library AnnoText64;

{ Wichtiger Hinweis zur DLL-Speicherverwaltung: ShareMem muss die erste
  Unit in der USES-Klausel Ihrer Bibliothek UND in der USES-Klausel Ihres Projekts
  (whlen Sie 'Projekt-Quelltext anzeigen') sein, wenn Ihre DLL Prozeduren oder Funktionen
  exportiert, die Strings als Parameter oder Funktionsergebnisse bergeben. Dies
  gilt fr alle Strings, die an oder von Ihrer DLL bergeben werden, auch fr solche,
  die in Records und Klassen verschachtelt sind. ShareMem ist die Interface-Unit zur
  gemeinsamen BORLNDMM.DLL-Speicherverwaltung, die zusammen mit Ihrer DLL
  weitergegeben werden muss. bergeben Sie String-Informationen mit PChar- oder ShortString-Parametern, um die Verwendung von BORLNDMM.DLL zu vermeiden.
 }

 { f.schneider: AnnoText64.dll (oder vergleichbare DLLs, die ImageEN >= 11.4 nutzen) bentigen auf jeden Fall
                ielib64.dll im Ausfhrungsverzeichnis)
 }


uses
//  ShareMem;
  SysUtils, Classes, bfaCommonMethods, bitfarm_enterprise, Uni, MySQLUniProvider, ievect, hyieutils;
//  Classes, Uni, MySQLUniProvider, DBAccess, DB,
//  bfaCommonMethods{, ievect};

{$R *.res}

var
  LastErrorId, index : Integer;

function GetLastError: Integer; stdcall;
begin
  Result := LastErrorId;
end;

function GetAnnoText(server: PChar; port: Integer; db, user, pass: PChar; gdocid: Int64): PChar; stdcall;
var
  con : TUniConnection;
  myq : TUniQuery;
  annostream : TMemoryStream;
  annotext: WideString;
  img : TImageEnVect;
  blob : TBytesStream;
  i, hobj : Integer;
begin
  Result := PChar('');
  LastErrorId := 0;
  try
    con := TUniConnection.Create(nil);
    con.ProviderName := 'mysql';
    con.Server := server;
    con.Port := port;
    con.Database := db;
    {$IFDEF GPL}
    con.Username := Decrypt(user, 'b17fa300900b421333de672c41a00d');
    con.Password := Decrypt(pass, 'b17fa300900b421333de672c41a00d');
    {$ELSE}
    con.Username := Decrypt(user, GlobalKey);
    con.Password := Decrypt(pass, GlobalKey);
    {$ENDIF}
    con.SpecificOptions.Values['UseUnicode'] := 'True';
    con.SpecificOptions.Values['Protocol'] := 'mpSSL';
    try
      con.Connect;
    except
      LastErrorId := 1;
      Exit;
    end;

    myq := TUniQuery.Create(nil);
    myq.Connection := con;
    myq.SQL.Text := 'select iev from sys_annotations where layer = 0 and gdocid = ' + IntToStr(gdocid);
    try
      myq.Execute;
    except
      LastErrorId := 2;
      Exit;
    end;

    if myq.RecordCount > 0 then
    begin
      annostream := TMemoryStream.Create;
      try
        img := TImageEnVect.Create(nil);
      except
        LastErrorId := 4;
        Exit;
      end;
      img.Visible := False;
      myq.First;
      try
        while not myq.Eof do
        begin
          annostream.Clear;
          img.Clear;
          blob := TBytesStream.Create(myq.FieldByName('iev').AsBytes);
          blob.SaveToStream(annostream);

          annostream.Position := 0;
          try
           img.LoadFromStreamIEV(annostream);
          except
            annotext := '';
            LastErrorId := 5;
            Exit;
          end;
          for i := 0 to img.ObjectsCount -1 do
          begin
            hobj := img.GetObjFromIndex(i);
            if Trim(img.ObjText[hobj]) = '' then
              Continue;
            if annotext = '' then
              annotext := Trim(img.ObjText[hobj])
            else
              annotext := annotext + #10 + Trim(img.ObjText[hobj]);
          end;
          blob.Clear;
          FreeAndNil(blob);
          myq.Next;
        end;
        annotext := StringReplace(annotext, #10#10, #10, [rfReplaceAll]);
        annotext := ParseSQLString(annotext);
      finally
        if Assigned(blob) then
        begin
          blob.Clear;
          FreeAndNil(blob);
        end;
        img.Clear;
        img.Free;
        annostream.Clear;
        FreeAndNil(annostream);
        Result := PChar(annotext);
      end;
    end
    else
      Result := PChar('');
  finally
    if Assigned(myq) then
    begin
      myq.Close;
      FreeAndNil(myq);
    end;
    if Assigned(con) then
    begin
      con.Disconnect();
      con.Close;
      FreeAndNil(con);
    end;
  end;
end;

function GetAnnoSVG(server: PChar; port: Integer; db, user, pass: PChar; gdocid: Int64): PChar; stdcall;
var
  con : TUniConnection;
  myq : TUniQuery;
  annostream : TMemoryStream;
  annotext: WideString;
  svgstream: TBytesStream;
  svg: string;
  tsvg: TBytes;
  psvg: PChar;
  img : TImageEnVect;
  blob : TBytesStream;
  i, hobj, size : Integer;
begin
  Result := PChar('');
  LastErrorId := 0;
  inc(index);
  try
    con := TUniConnection.Create(nil);
    con.ProviderName := 'mysql';
    con.Server := server;
    con.Port := port;
    con.Database := db;
    con.Username := Decrypt(user, GlobalKey);
    con.Password := Decrypt(pass, GlobalKey);
    con.SpecificOptions.Values['UseUnicode'] := 'True';
    con.SpecificOptions.Values['Protocol'] := 'mpSSL';
    try
      con.Connect;
    except
      LastErrorId := 1;
      Exit;
    end;

    myq := TUniQuery.Create(nil);
    myq.Connection := con;
    myq.SQL.Text := 'select iev from sys_annotations where layer = 0 and gdocid = ' + IntToStr(gdocid);
    try
      myq.Execute;
    except
      LastErrorId := 2;
      Exit;
    end;

    if myq.RecordCount > 0 then
    begin
      annostream := TMemoryStream.Create;
      try
        img := TImageEnVect.Create(nil);
      except
        LastErrorId := 4;
        Exit;
      end;
      img.Visible := False;
      myq.First;

      annostream.Clear;
      blob := TBytesStream.Create(myq.FieldByName('iev').AsBytes);

      blob.SaveToStream(annostream);
      annostream.Position := 0;
      try
       img.LoadFromStreamIEV(annostream);
      except
        annotext := '';
        LastErrorId := 5;
        Exit;
      end;

      //while FileExists(Format('c:\Test\annosvg_%d.svg', [index])) do
        //inc(index);

      svgstream := TBytesStream.Create;

      img.IO.Params.SVG_ImageCompression := ioJPEG;
      img.IO.Params.JPEG_Quality := 80;
//      img.IO.SaveToFileSVG(Format('c:\Test\annosvg_%d.svg', [index]));
      img.IO.SaveToStreamSVG(svgstream);

//      myq.Next;

      img.Clear;
      img.Free;

//      SetString(svg, PChar(svgstream.Memory), svgstream.Size);
      size := svgstream.Size;
      svgstream.Position := 0;
      SetLength(tsvg, size);
      svgstream.SetSize(size);
      tsvg := svgstream.Bytes;
      Result := PChar(tsvg);
      svgstream.Clear;
      FreeAndNil(svgstream);
      annostream.Clear;
      FreeAndNil(annostream);
    end
    else
      Result := PChar('');
  finally
    if Assigned(myq) then
    begin
      myq.Close;
      FreeAndNil(myq);
    end;
    if Assigned(con) then
    begin
      con.Disconnect();
      con.Close;
      FreeAndNil(con);
    end;
  end;
end;

exports
  GetAnnoText,
  GetLastError,
  GetAnnoSVG;

begin
end.

