program AnnoTextCMD;

{$APPTYPE CONSOLE}

{$R *.res}

uses
  System.SysUtils, System.Classes, System.IniFiles, Windows,
  Uni, MySQLUniProvider, ievect,
  bitfarm_enterprise, bfaCommonUtils,
  bfaCommonMethods;

var
  con : TUniConnection;
  myq : TUniQuery;
  annostream : TMemoryStream;
  annotext: WideString;
  img : TImageEnVect;
  blob : TBytesStream;
  i, hobj : Integer;
  bquiet : Boolean;
  strparam, sProfil, gdocid, sUser, sPass, Result: string;
  ini: TIniFile;
begin
  try
    { TODO -oUser -cConsole Main : Code hier einfgen }
    SetConsoleOutputCP(CP_UTF8);

    bquiet := (ParamCount > 2) and (Paramstr(3) = '-q');

    if not bquiet then
    begin
      WriteCMD('bitfarm Archiv V3  -  AnnoTextCMD Tool');
      WriteCMD('(c) 2004-'+ cCurYear + ' bitfarm Informationssysteme GmbH');

      for i := 1 to paramcount do
      strparam:= strparam + Paramstr(i) + ' ';

      WriteCmd('bergebene Parameter:' + strparam);
    end;
    if (ParamCount < 2) OR (paramstr(1) = '-h') then
    begin
      ExitCode := 1;
      if paramstr(1) <> '-h' then
      begin
         WriteCMD('Fehler: Nicht gengend Parameter angegeben! Aufrufen mit:');
         WriteCMD('AnnoTextCMD <Profil><Gdocid>{-q}');
         WriteLN('');
      end;

      WriteCMD('bfaquery: Tool um die Annotexte einer Public Annotation abzufragen');
      WriteCMD('Parameter:');
      WriteCMD('AnnoTextCMD <Profil><Gdocid>{-q}');
      WriteCMD('-h          Diese Hilfe');
      WriteCMD('-q          Quiet, keine Ausgabe auer das Ergebnis');
      WriteCMD('<Profil>    Name des Profils');
      WriteCMD('<Gdocid>    Gdocid des Dokuments');

      exit;
    end;

    sProfil := ExtractFilePath(Paramstr(0))+Paramstr(1)+'.con';
    gdocid := Paramstr(2);

    try
      ini := TInifile.Create(sProfil);
      sUser := ini.ReadString('Connection', 'User', '');
      sPass := ini.ReadString('Connection', 'Pass', '');

      con := TUniConnection.Create(nil);
      con.ProviderName := 'MySQL';
      con.Server := ini.ReadString('Connection', 'Server', '');
      con.Port := ini.ReadInteger('Connection', 'Port', 3306);
      con.Database := ini.ReadString('Connection', 'DB', '');
      con.Username := Decrypt(sUser, GlobalKey);
      con.Password := Decrypt(sPass, GlobalKey);
      con.Options.KeepDesignConnected := False;
      con.SpecificOptions.Add('Protocol=mpSSL');
      try
        con.Connect;
      except
        on E: Exception do
        begin
          if not bquiet then
          begin
            WriteCMD('error while connecting to database');
            Writeln(E.ClassName, ': ', E.Message);
          end;
          ExitCode := 1;
          Exit;
        end;
      end;

      myq := TUniQuery.Create(nil);
      myq.Connection := con;
      myq.SQL.Text := 'select iev from sys_annotations where layer = 0 and  gdocid = ' + gdocid;
      try
        myq.Execute;
      except
        ExitCode := 2;
        Exit;
      end;

      if myq.RecordCount > 0 then
      begin
        annostream := TMemoryStream.Create;
        try
          img := TImageEnVect.Create(nil);
        except
          ExitCode := 4;
          Exit;
        end;
        img.Visible := False;
        myq.First;
        while not myq.Eof do
        begin
          annostream.Clear;
          blob := TBytesStream.Create(myq.FieldByName('iev').AsBytes);

          blob.SaveToStream(annostream);
          annostream.Position := 0;
          try
           img.LoadFromStreamIEV(annostream);
          except
            annotext := '';
            ExitCode := 5;
            Exit;
          end;
          for i := 0 to img.ObjectsCount -1 do
          begin
            hobj := img.GetObjFromIndex(i);
            if Trim(img.ObjText[hobj]) = '' then
              Continue;
            if annotext = '' then
              annotext := Trim(img.ObjText[hobj])
            else
              annotext := annotext + #10 + Trim(img.ObjText[hobj]);
          end;
          myq.Next;
        end;
        annotext := StringReplace(annotext, #10#10, #10, [rfReplaceAll]);
        annotext := ParseSQLString(annotext);
        img.Clear;
        img.Free;
        annostream.Clear;
        FreeAndNil(annostream);
        Result := annotext;
      end
      else
        Result := '';
    finally
      if Assigned(myq) then
      begin
        myq.Close;
        FreeAndNil(myq);
      end;
      if Assigned(con) then
      begin
        con.Disconnect();
        con.Close;
        FreeAndNil(con);
      end;
      SetConsoleOutputCP(CP_UTF8);
      WriteLN(Result);
    end;
  except
    on E: Exception do
      Writeln(E.ClassName, ': ', E.Message);
  end;
end.
