program AutoScanV3;

//{$APPTYPE CONSOLE}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Aufruf mit Parameter
//  S:\bitfarm-archiv\autoscan.vbs archiv_1 -G:GP_i1220_SW300
//
uses
  SysUtils,
  IniFiles,
  ieview,
  iemview,
  ievect,
  ImageEnIO,
  Printers,
  Registry,
  Controls,
  Messages,
  Dialogs,
  ShellAPI,
  windows,
  classes,
  imageenview,
  bfaLog,
  bfaCommonUtils,
  bfaOptions,
  u_dm_Main in 'u_dm_Main.pas' {dm_Main: TDataModule},
  SynZip in '..\..\Delphi-Lib\SynPDF\SynZip.pas';

{$R *.res}

Function  AnsiToConCP(Const AString: String): String;
Var
  lResult: String;
Begin
  SetLength(lResult, Length(AString));
  {$IFDEF WIN32}
  CharToOEM(PWideChar(AString), PAnsiChar(lResult)); {32Bit}
  {$ELSE}
  AnsiToOEM(PChar(@AString[1]), PChar(@lResult[1])); {16Bit}
  {$ENDIF}
  Result := lResult;
End;

Function WriteCmd(strtext: String):STring ;
begin
  strtext:= AnsiToConCP(strtext);
  WriteLN(strtext);
End;




function GetSystemVariable(const Name: String): String;
   /////////////////////////////////////////////////////////////
   ///   Erstellt 06.06.2005 by SV                           ///
   ///                                                       ///
   ///   Liest eine Systemvariable aus                       ///
   ///                                                       ///
   ///   Parameter:  Name          Name der Systemvariable   ///
   ///                                                       ///
   ///   Rckgabe:   String mit Wert der Systemvariable      ///
   ///                                                       ///
   /////////////////////////////////////////////////////////////
begin
   Result := GetEnvironmentVariable(Name);
end;

function GenNewName: String;
   /////////////////////////////////////////////////////////////
   ///   Erstellt 07.06.2005 by SV                           ///
   ///                                                       ///
   ///   Erzeugt einen String mit dem aktuellen Datum und    ///
   ///   der aktuellen Uhrzeit                               ///
   ///                                                       ///
   ///   Parameter:  keine                                   ///
   ///                                                       ///
   ///   Rckgabe:   String mit Datum + Uhrzeit              ///
   ///                                                       ///
   /////////////////////////////////////////////////////////////
begin
   DateTimeToString(result, 'ddmmyyyyhhnnss', now);
end;


procedure ShowLogo;
begin
   AllocConsole;
   WriteLn('bitfarm Archiv V3 - AutoScan V3');
   WriteLn('(c) 2004 - ' + cCurYear +
    ' bitfarm Informationssysteme GmbH [http://www.bitfarm-archiv.de]');
   WriteLn(' ');

end;

procedure WaitForKey;
begin
   Exit;
   WriteLn(' ');
   WriteCMD('Bitte die Enter Taste drcken...');
   ReadLn;
end;


var
   img: TImageEnMView;
   scan: TIETWainParams;
   //tiff: TIOParamsVals;
   io: TImageEnIO;
   reg: TRegistry;
   sParamType, sProfileName, sTempPath, sTemplate, sFileName, Druckername: String;
   bStacked, useInvers, FiltLeer, bReady, bPageInfo, gbIgnoreTWAINError : Boolean;
   iComp, iCount, liimagecount, liscannedpages, li, button: Integer;
   JobFile: TIniFile;
   lftmp, GFkbleer: double;
   liev: TImageEnView;
   ms: TMemoryStream;
   Global : Boolean;
   iniFileName : string;
   ScannerProfiles : TbfaScannerProfiles;
   ScanObj : TbfaScanner;
   found : Boolean;


    fMLeft,
    fMRight,
    fMTop,
    fMBottom,
    fSHeight,
    fSWidth,
    fGamma: double;
    ieVPos: TIEVerticalPos;
    ieHPos: TIEHorizontalPos;
    ieSize: TIESize;
    xDocView: TImageEnVect;
    xUseStdPrn, xIdx, iFromPage, iToPage, iPage, status_req, status :Integer;
    i     :Integer;
    bPrintDoc, lbres     :Boolean;
    gIsDocPrinting :Boolean;


function PrintDoc():Boolean;
begin
    Result        := True;
    bPrintDoc     := False;

    try
      if Printer.Printers.Count = 0 then
      begin
        Exit;
      end;

      Printer.PrinterIndex := -1;    // default
      if LowerCase(Druckername) = 'standard' then
         Printer.PrinterIndex := -1
      else
      begin
         for i:= 0 to  Printer.Printers.Count -1  do
         begin
            if LowerCase(Printer.Printers.Strings[i]) = LowerCase(Druckername) then
               Printer.PrinterIndex := i;
         end;
      end;

      // Liefert der Druckertreiber gltige Parameter ?
      if (Printer.PageWidth < 1) or (Printer.PageHeight < 1) then
      begin
         ShowMessage('Der aktuelle Drucker ist nicht mit dem Viewer kompatibel.' +
            #13 + 'Bitte whlen Sie einen anderen Drucker aus oder benutzen' +
            #13 + 'Sie einen anderen Druckertreiber.');

         Exit;
      end;

       try
          ieSize := iesFITTOPAGE;
          ieVPos := ieVPCenter;
          ieHPos := ieHPCenter;

          if (img.ImageCount > 0) then
          begin
             (*
             if (  xDocView.ieBitmap.Height
                 < xDocView.ieBitmap.Width )

             then
                Printer.Orientation := poLandscape
             else
                Printer.Orientation := poPortrait;
               *)
             Printer.BeginDoc;

             try
                for iPage := 0 to img.ImageCount - 1 do
                begin
                   img.MIO.PrintImage(iPage, Printer.Canvas, fMLeft, fMTop,
                      fMRight, fMBottom, ieVPos, ieHPos, ieSize,
                      fSWidth, fSHeight, fGamma);

                   if iPage < (img.ImageCount - 1) then
                      Printer.NewPage;
                end;
             except
					on e: exception do
               begin
                  ShowLogo;
                  WriteCmd('Fehler bei m Drucken:' + e.Message);
               end;
             end;

             Printer.Enddoc;
          end;
       except
          on e: Exception do
          begin
             Printer.Abort;
             Result := False;
          end;
       end; {Try - Except}

    finally


    end;

end; 



begin
   { TODO -oUser -cConsole Main : Hier Code einfgen }
   //  FreeConsole;
   BD.LogPath := BD.EnvTemp;
   BD.LogName := 'AutoScanV3.log';
   bitfarmLog := TbfaLog.Create;
   bitfarmLog.Init(BD.LogPath, '', llNormal, 'AutoScanV3');
   bitfarmLog.Write(llNormal, ltInfo, 'Autoscan-Log', 'AutoScanV3');
   dm_Main := Tdm_Main.Create(nil);
   dm_Main.tico_Main.Icons := dm_Main.il_Std;
   dm_Main.tico_Main.Hint := 'bitfarm Archiv V3 - AutoScan (initalisiere)';
   dm_Main.tico_Main.Active := True;
   try
      bitfarmLog.Write(llNormal, ltInfo, 'Trap 1', 'AutoScanV3');
      img := TImageEnMView.Create(nil);
      img.GridWidth := -1;
      img.DisplayMode := mdGrid;
      img.StoreType := ietNormal;
      img.Style := iemsACD;

      io := TImageEnIO.Create(nil);
      reg := TRegistry.Create(KEY_READ);
      scan := img.MIO.TWainParams;
      //tiff := TIOParamsVals.Create(nil);
      if ParamCount < 2 then
      begin
         ShowLogo;
         WriteCMD('Fehler: Nicht gengend Parameter angegeben!');
         WriteLn('Aufrufen mit: AutoScanV3.exe <Template> -G:<Globales Scanprofil>{-P:Druckername}');
         WriteLn('                  oder       <Template> -U:<Benutzer Scanprofil>{-P:Druckername}');
         WriteCmd('Optional kann ein lokal installierter Drucker angegeben werden');
         WriteCmd('bei Druckername mit Leerzeichen bitte den gesamten Ausdruck in ');
         WriteCmd('Anfhrungszeichen setzen ("-P:Drucker 1")');
         WaitForKey;
         ExitCode := 1;  // Zuviele Parameter
         Exit;
      end;
      sTemplate := ParamStr(1);
      sParamType := UpperCase(Copy(ParamStr(2), 1, 3));
      sProfileName := Copy(ParamStr(2), 4, Length(ParamStr(2)) - 3);
      if sParamType = '-G:' then
      begin
         // Load Global Profile
         reg.RootKey := $80000002;  //HKEY_LOCAL_MACHINE;
         Global := True;
         iniFileName := BD.EnvProgramDataPd + 'bitfarm-archiv\ScannerProfiles.ini';
      end
      else
      if sParamType = '-U:' then
      begin
         // Load User Profile
         reg.RootKey := $80000001;  //HKEY_CURRENT_USER;
         Global := False;
         iniFileName := BD.EnvAppdataPd + 'bitfarm-archiv\ScannerProfiles.ini';
      end
      else
      begin
         ShowLogo;
         WriteLn('Fehler: Unbekannter Parameter (' + sParamType + ') angegeben!');
         WriteLn('Aufrufen mit: AutoScanV3.exe -G:<Globales Scanprofil>{-P:Druckername} -D:<Scan Ordner Pfad>');
         WriteLn('                  oder       -U:<Benutzer Scanprofil>{-P:Druckername} -D:<Scan Ordner Pfad>');
         WaitForKey;
         ExitCode := 2;  // Unbekannter Parameter abgegeben
         Exit;
      end;

		sTempPath := GetEnvironmentVariable('Temp');
      bPageInfo := False;
      if ParamCount >= 3 then
      begin
         for iCount := 3 to ParamCount do
         begin
            if UpperCase(Copy(ParamStr(iCount), 1, 3)) = '-P:' then
            begin
               bPrintDoc := True;
               Druckername := Copy(ParamStr(iCount), 4, Length(ParamStr(iCount)) - 3);
            end;

            if UpperCase(Copy(ParamStr(iCount), 1, 3)) = '-D:' then
            begin
                sTempPath:= Copy(ParamStr(iCount), 4, Length(ParamStr(iCount)) - 3);
            end;
            if LowerCase(Paramstr(iCount)) = 'pageinfo' then
            	bPageInfo := True;
            if LowerCase(Paramstr(iCount)) = '-debug' then
            	BD.LogOn := True;
         end;
      end;

      if sTempPath[Length(sTempPath)] <> '\' then
        sTempPath := sTempPath + '\';
      if not DirectoryExists(sTempPath) then
        CreateDir(sTempPath);

      BD.LogPath := sTempPath;

      if bitfarmLog.LogDir <> bd.LogPath then
      begin
        bitfarmLog.Init(BD.LogPath, '', llNormal, 'AutoScanV3');
        bitfarmLog.Write(llNormal, ltInfo, 'Autoscan-Log', 'AutoScanV3');
      end;

      bitfarmLog.Write(llNormal, ltInfo, 'Trap 2', 'AutoScanV3');
      ////////////////////////////////////////////////////////////////////////////////////////////////
      //  Scanner Parameter ueberpruefen und fehler ausgeben dessen Exception beim Scannen ausgelst wurde

      try
        if FileExists(iniFileName) then
        begin
          bitfarmLog.Write(llNormal, ltInfo, 'Ini: ' + iniFileName, 'AutoScanV3');

          ScannerProfiles := TbfaScannerProfiles.Create(sSysScannerProfilesINI);
          i := 0;
          found := False;
          while ((not found) and (i <= ScannerProfiles.Container.Count - 1)) do
          begin
            if ((ScannerProfiles.Container[i].ProfileName = sProfileName) and
                (ScannerProfiles.Container[i].GlobalProfile = Global)) then
            begin
              found := True;
              ScanObj := ScannerProfiles.Container[i];
            end
            else
            inc(i);
          end;

          if not found then
          begin
             ShowLogo;
             WriteLn('Fehler: Angegebenes Profil (' + sProfileName + ') existiert nicht!');
             bitfarmLog.Write(llNormal, ltInfo, 'Fehler: Angegebenes Profil (' +
              sProfileName + ') existiert nicht!', 'AutoScanV3');
             WaitForKey;
             ExitCode := 3;  // Profil wurde nicht gefunden
             Exit;
          end
          else
            bitfarmLog.Write(llNormal, ltInfo, 'Profil =' + sProfileName, 'AutoScanV3');


           if not scan.SelectSourceByName(ScanObj.ScannerName) then
           begin
              ShowLogo;
              WriteLn('Fehler: Angegebener Scanner (' + ScanObj.ScannerName +
                ') wurde nicht gefunden!');
               bitfarmLog.Write(llNormal, ltInfo, 'Fehler: Angegebener Scanner (' +
                ScanObj.ScannerName + ')wurde nicht gefunden!', 'AutoScanV3');
              WaitForKey;
              ExitCode := 4; // Scannername wurde nicht gefunden
              exit;
           end
           else
            bitfarmLog.Write(llNormal, ltInfo, 'Scanner =' + ScanObj.ScannerName, 'AutoScanV3');


        end
        else
        begin
          ScanObj := TbfaScanner.Create;
          try
             with reg do
             begin
                if not KeyExists('\Software\bitfarm\Archiv_V3\Scan\Profiles\' + sProfileName) then
                begin
                   ShowLogo;
                   WriteLn('Fehler: Angegebenes Profil (' + sProfileName + ') existiert nicht!');
                   WaitForKey;
                   ExitCode := 3;  // Profil wurde nicht gefunden
                   Exit;
                end
                else OpenKey('\Software\bitfarm\Archiv_V3\Scan\Profiles\' + sProfileName, False);
                bitfarmLog.Write(llNormal, ltInfo, 'Trap 3', 'AutoScanV3');
                if ReadBool('ScanByID') then
                  if not scan.SelectSourceByName(Scan.SourceName[ReadInteger('ScanID')]) then
                   begin
                      ShowLogo;
                      WriteLn('Fehler: Angegebener Scanner (' + ReadString('ScanName') + ') wurde nicht gefunden!');
                      WaitForKey;
                      ExitCode := 4; // Scannername wurde nicht gefunden
                      exit;

                   end;
                   //scan.SelectedSource := ReadInteger('ScanID');   //alte Methode
                if ReadBool('ScanByName') then
                   if not scan.SelectSourceByName(ReadString('ScanName')) then
                   begin
                      ShowLogo;
                      WriteLn('Fehler: Angegebener Scanner (' + ReadString('ScanName') + ') wurde nicht gefunden!');
                      WaitForKey;
                      ExitCode := 4; // Scannername wurde nicht gefunden
                      exit;

                   end;

                bitfarmLog.Write(llNormal, ltInfo, 'Profil =' + sProfileName, 'AutoScanV3');
                bitfarmLog.Write(llNormal, ltInfo, 'Scanner =' +
                  ReadString('ScanName'), 'AutoScanV3');

                ScanObj.Format := ReadInteger('PaperType');
                scanObj.Transfer := ReadInteger('Transfer');
                if ValueExists('Filter') then
                  ScanObj.Filter := ReadInteger('Filter');
                ScanObj.Brightness := ReadFloat('BrightCur');
                ScanObj.Contrast := ReadFloat('ContrastCur');
                ScanObj.Threshold := ReadFloat('ThresholdCur');
                Scanobj.Orientation := ReadInteger('PaperFormat');
                ScanObj.UseFrame := ReadBool('Cutted');
                ScanObj.FrameTop := ReadFloat('Cut_Top');
                ScanObj.FrameLeft := ReadFloat('Cut_Left');
                ScanObj.FrameRight := ReadFloat('Cut_Right');
                ScanObj.FrameBottom := ReadFloat('Cut_Bottom');
                scanObj.ADF := ReadBool('Opt_ADF');
                ScanObj.Duplex := ReadBool('Opt_Duplex');
                bStacked := ReadBool('Opt_Stacked');
                ScanObj.Stapel := bStacked;

                if valueExists('opt_UseInvers') then
                begin
                   UseInvers := Readbool('Opt_UseInvers');
                end
                else
                  UseInvers := false;
                ScanObj.Inverse := UseInvers;

                if ValueExists('Opt_FiltLeer') then
                begin
                   FiltLeer := ReadBool('Opt_FiltLeer');
                end
                else
                   FiltLeer := false;
                ScanObj.DeletePage := FiltLeer;

                if ValueExists('Opt_Leerkb') then
                begin
                   GFkbleer := ReadFloat('Opt_Leerkb');
                end
                else
                   GFkbleer := 0;
                ScanObj.DeletePageKB := Round(GFkbleer);

                if ValueExists('IgnoreTWAINError') then
                begin
                   gbIgnoreTWAINError := ReadBool('IgnoreTWAINError');
                end
                else
                   gbIgnoreTWAINError := True;
                ScanObj.IgnoreTWAINError := gbIgnoreTWAINError;

                ScanObj.ColorMode := ReadInteger('ColorMode');
                ScanObj.BitDepth := ReadInteger('BitDepth');
                ScanObj.DPI := ReadInteger('DPIX');

                iComp := ReadInteger('Compression');
                ScanObj.Compression := iComp;

                CloseKey;
             end;
          finally
            if Assigned(reg) then
               FreeAndNil(reg);
          end;
        end;

        case ScanObj.Format of
           00:
              Scan.StandardSize.CurrentValue := IETW_NONE;
           01:
              Scan.StandardSize.CurrentValue := IETW_A4LETTER;
           02:
              Scan.StandardSize.CurrentValue := IETW_B5LETTER;
           03:
              Scan.StandardSize.CurrentValue := IETW_USLETTER;
           04:
              Scan.StandardSize.CurrentValue := IETW_USLEGAL;
           05:
              Scan.StandardSize.CurrentValue := IETW_A5;
           06:
              Scan.StandardSize.CurrentValue := IETW_B4;
           07:
              Scan.StandardSize.CurrentValue := IETW_B6;
           08:
              Scan.StandardSize.CurrentValue := IETW_USLEDGER;
           09:
              Scan.StandardSize.CurrentValue := IETW_USEXECUTIVE;
           10:
              Scan.StandardSize.CurrentValue := IETW_A3;
           11:
              Scan.StandardSize.CurrentValue := IETW_B3;
           12:
              Scan.StandardSize.CurrentValue := IETW_A6;
           13:
              Scan.StandardSize.CurrentValue := IETW_C4;
           14:
              Scan.StandardSize.CurrentValue := IETW_C5;
           15:
              Scan.StandardSize.CurrentValue := IETW_C6;
           16:
              Scan.StandardSize.CurrentValue := IETW_4A0;
           17:
              Scan.StandardSize.CurrentValue := IETW_2A0;
           18:
              Scan.StandardSize.CurrentValue := IETW_A0;
           19:
              Scan.StandardSize.CurrentValue := IETW_A1;
           20:
              Scan.StandardSize.CurrentValue := IETW_A2;
           21:
              Scan.StandardSize.CurrentValue := IETW_A7;
           22:
              Scan.StandardSize.CurrentValue := IETW_A8;
           23:
              Scan.StandardSize.CurrentValue := IETW_A9;
           24:
              Scan.StandardSize.CurrentValue := IETW_A10;
           25:
              Scan.StandardSize.CurrentValue := IETW_ISOB0;
           26:
              Scan.StandardSize.CurrentValue := IETW_ISOB1;
           27:
              Scan.StandardSize.CurrentValue := IETW_ISOB2;
           28:
              Scan.StandardSize.CurrentValue := IETW_ISOB5;
           29:
              Scan.StandardSize.CurrentValue := IETW_ISOB7;
           30:
              Scan.StandardSize.CurrentValue := IETW_ISOB8;
           31:
              Scan.StandardSize.CurrentValue := IETW_ISOB9;
           32:
              Scan.StandardSize.CurrentValue := IETW_ISOB10;
           33:
              Scan.StandardSize.CurrentValue := IETW_JISB0;
           34:
              Scan.StandardSize.CurrentValue := IETW_JISB1;
           35:
              Scan.StandardSize.CurrentValue := IETW_JISB2;
           36:
              Scan.StandardSize.CurrentValue := IETW_JISB3;
           37:
              Scan.StandardSize.CurrentValue := IETW_JISB4;
           38:
              Scan.StandardSize.CurrentValue := IETW_JISB6;
           39:
              Scan.StandardSize.CurrentValue := IETW_JISB7;
           40:
              Scan.StandardSize.CurrentValue := IETW_JISB8;
           41:
              Scan.StandardSize.CurrentValue := IETW_JISB9;
           42:
              Scan.StandardSize.CurrentValue := IETW_JISB10;
           43:
              Scan.StandardSize.CurrentValue := IETW_C0;
           44:
              Scan.StandardSize.CurrentValue := IETW_C1;
           45:
              Scan.StandardSize.CurrentValue := IETW_C2;
           46:
              Scan.StandardSize.CurrentValue := IETW_C3;
           47:
              Scan.StandardSize.CurrentValue := IETW_C7;
           48:
              Scan.StandardSize.CurrentValue := IETW_C8;
           49:
              Scan.StandardSize.CurrentValue := IETW_C9;
           50:
              Scan.StandardSize.CurrentValue := IETW_C10;
           51:
              Scan.StandardSize.CurrentValue := IETW_USSTATEMENT;
           52:
              Scan.StandardSize.CurrentValue := IETW_BUSINESSCARD;
        else
           Scan.StandardSize.CurrentValue := IETW_A4LETTER;
        end;
        bitfarmLog.Write(llNormal, ltInfo, 'Trap 4', 'AutoScanV3');
        Scan.BufferedTransfer := True;    // das muss True sein, verdammte Hacke
        case ScanObj.Transfer of
           0:
           begin
              Scan.FileTransfer := True;
              Scan.CompatibilityMode := False;
           end;
           1:
           begin
              Scan.FileTransfer := True;
              Scan.CompatibilityMode := True;
           end;
           2:
           begin
              Scan.FileTransfer := False;
              Scan.CompatibilityMode := False;
           end;
           3:
           begin
              Scan.FileTransfer := False;
              Scan.CompatibilityMode := True;
           end;
           4:
           begin
              Scan.FileTransfer := False;
              Scan.BufferedTransfer := False;
              Scan.CompatibilityMode := False;
           end;
           5:
           begin
              Scan.FileTransfer := False;
              Scan.BufferedTransfer := False;
              Scan.CompatibilityMode := True;
           end;
        else
        begin
           Scan.FileTransfer := False;
           Scan.BufferedTransfer := True;
           Scan.CompatibilityMode := False;
        end;
        end;

        bitfarmLog.Write(llNormal, ltInfo, 'Trap 5', 'AutoScanV3');
         Case ScanObj.Filter of
            1:
               Scan.Filter := ietwRed;
            2:
               Scan.Filter := ietwGreen;
            3:
               Scan.Filter := ietwBlue;
            4:
               Scan.Filter := ietwWhite;
            5:
               Scan.Filter := ietwCyan;
            6:
               Scan.Filter := ietwMagenta;
            7:
               Scan.Filter := ietwYellow;
            8:
               Scan.Filter := ietwBlack;
         end;

        bitfarmLog.Write(llNormal, ltInfo, 'Trap 6', 'AutoScanV3');
        lftmp := ScanObj.Brightness;
        if lftmp <> 0 then
           scan.Brightness.CurrentValue := lftmp;
        lftmp := ScanObj.Contrast;
        if lftmp <> 0 then
           scan.Contrast.CurrentValue := lftmp;

        bitfarmLog.Write(llNormal, ltInfo, 'Trap 7', 'AutoScanV3');
        lftmp := ScanObj.Threshold;
        if lftmp <> 0 then
           scan.Threshold.CurrentValue := lftmp;
        Scan.Orientation.CurrentValue := ScanObj.Orientation;
        scan.AcquireFrameEnabled := False;
        Scan.AcquireFrameEnabled := ScanObj.UseFrame;
        Scan.AcquireFrameTop := ScanObj.FrameTop;
        Scan.AcquireFrameLeft := ScanObj.FrameLeft;
        Scan.AcquireFrameRight := ScanObj.FrameRight;
        Scan.AcquireFrameBottom := ScanObj.FrameBottom;
        Scan.FeederEnabled := ScanObj.ADF;
        Scan.DuplexEnabled := ScanObj.Duplex;
        bStacked := ScanObj.Stapel;
        UseInvers := ScanObj.Inverse;
        FiltLeer := ScanObj.DeletePage;
        GFkbleer := ScanObj.DeletePageKB;
        gbIgnoreTWAINError := ScanObj.IgnoreTWAINError;

        case ScanObj.ColorMode of
           0:
              Scan.PixelType.CurrentValue := 0;
           1:
              Scan.PixelType.CurrentValue := 1;
           2:
              Scan.PixelType.CurrentValue := 2;
        else
           Scan.PixelType.CurrentValue := 0;
        end;

        case ScanObj.BitDepth of
           0:
              Scan.BitDepth.CurrentValue := 1;
           1:
              Scan.BitDepth.CurrentValue := 4;
           2:
              Scan.BitDepth.CurrentValue := 8;
        else
           Scan.BitDepth.CurrentValue := 1;
        end;

        case ScanObj.DPI of
           0:
              Scan.XResolution.CurrentValue := 50;
           1:
              Scan.XResolution.CurrentValue := 75;
           2:
              Scan.XResolution.CurrentValue := 100;
           3:
              Scan.XResolution.CurrentValue := 150;
           4:
              Scan.XResolution.CurrentValue := 200;
           5:
              Scan.XResolution.CurrentValue := 300;
           6:
              Scan.XResolution.CurrentValue := 400;
           7:
              Scan.XResolution.CurrentValue := 600;
           8:
              Scan.XResolution.CurrentValue := 1200;
        else
           Scan.XResolution.CurrentValue := 200;
        end;

        case ScanObj.DPI of
           0:
              Scan.YResolution.CurrentValue := 50;
           1:
              Scan.YResolution.CurrentValue := 75;
           2:
              Scan.YResolution.CurrentValue := 100;
           3:
              Scan.YResolution.CurrentValue := 150;
           4:
              Scan.YResolution.CurrentValue := 200;
           5:
              Scan.YResolution.CurrentValue := 300;
           6:
              Scan.YResolution.CurrentValue := 400;
           7:
              Scan.YResolution.CurrentValue := 600;
           8:
              Scan.YResolution.CurrentValue := 1200;
        else
           Scan.YResolution.CurrentValue := 200;
        end;

        iComp := ScanObj.Compression;



         bitfarmLog.Write(llNormal, ltInfo, 'Trap 9', 'AutoScanV3');
         dm_Main.tico_Main.Icons := dm_Main.il_Ani;
         dm_Main.tico_Main.Hint := 'bitfarm Archiv V3 - AutoScan (scannen)' + #13 + scan.SourceName[scan.SelectedSource];
         dm_Main.tico_Main.Delay := 100;
         dm_Main.tico_Main.Animated := True;
         Scan.VisibleDialog := false;
         bitfarmLog.Write(llNormal, ltInfo, 'Trap 10', 'AutoScanV3');
         img.MIO.TWainParams.VisibleDialog := false;
         img.MIO.TWainParams.ProgressIndicators := false;

         bReady := False;

         while not bReady do
         begin
           	liimagecount := img.ImageCount;
            img.MIO.TWainParams.LastError := 0;
            img.MIO.TWainParams.LastErrorStr := '';
            bitfarmLog.Write(llNormal, ltInfo, 'vor Acquire', 'AutoScanV3');
          	lbres := img.MIO.Acquire(ieaTwain);  // daten vom Scannner Anfordern
            bitfarmLog.Write(llNormal, ltInfo, 'nach Acquire result: ' +
              BoolToStr(lbres), 'AutoScanV3');
            bitfarmLog.Write(llNormal, ltInfo, 'LastError: ' +
              Inttostr(img.MIO.TWainParams.LastError), 'AutoScanV3');

            if img.MIO.TWainParams.LastError <> 0 then
            begin
               if not gbIgnoreTWAINError then
               begin
                 bitfarmLog.Write(llNormal, ltInfo, 'nach not gbIgnoreTWAINError', 'AutoScanV3');

                  ShowLogo;
                 bitfarmLog.Write(llNormal, ltInfo, 'nach ShowLogo', 'AutoScanV3');

                  WriteLN('Fehler beim Scannen! TWAIN-Errorcode:' +
                    IntToStr(img.MIO.TWainParams.LastError));
                 bitfarmLog.Write(llNormal, ltInfo, 'Fehler beim Scannen! TWAIN-Errorcode:' +
                   IntToStr(img.MIO.TWainParams.LastError), 'AutoScanV3');
                     // bei einem Fehler lschen wir die letzte Seite
                  if (img.MIO.TWainParams.LastError <> 5) and (img.MIO.TWainParams.LastError <> 4) then
                  begin
                     if img.ImageCount > liimagecount then
                        img.DeleteImage(img.ImageCount - 1);
                     bitfarmLog.Write(llNormal, ltInfo, 'vor MessageDlg', 'AutoScanV3');

                     button := MessageDlg('Es hat einen Fehler beim Scannen gegeben (' +IntToStr(img.MIO.TWainParams.LastError) +').' +#13#10+
                                 'Es wurden bisher ' + inttostr(img.ImageCount)+' Seiten gescannt.' +#13#10+
                                 'Wollen sie den Scan fortsetzen und weitere Seiten hinzufgen oder Abbrechen?', mtWarning, [mbYes, mbCancel],0);
                     bitfarmLog.Write(llNormal, ltInfo, 'nach MessageDlg', 'AutoScanV3');

                     if button = mrYes then
                        bReady := False;
                     if button = mrCancel then
                     begin
                        bReady := True;
                        lbres := False;
                     end;
                  end
                  else
                    bReady := True;
               end
               else
                 bReady := True;
            end
            else
            	bReady := True;
         end;

         bitfarmLog.Write(llNormal, ltInfo, 'vor AcquireClose', 'AutoScanV3');

         try
            img.MIO.AcquireClose;
         except
           bitfarmLog.Write(llNormal, ltInfo, 'Fehler bei AcquireClose', 'AutoScanV3');

         end;

         bitfarmLog.Write(llNormal, ltInfo, 'nach AcquireClose', 'AutoScanV3');
         if lbres then
			   begin
           dm_Main.tico_Main.Animated := False;
           bitfarmLog.Write(llNormal, ltInfo, 'nach tico_Main.Animated', 'AutoScanV3');
         end
         else
         begin
            liscannedpages := img.ImageCount - liimagecount;
            if liscannedpages > 0 then
            begin
               for li := liimagecount to img.ImageCount -1 do
               begin
                 img.DeleteImage(liimagecount);
                 bitfarmLog.Write(llNormal, ltInfo, 'nach DeleteImage: ' +
                  inttostr(liimagecount), 'AutoScanV3');
               end;
            end;
         end;
      except
         on e: exception do
         begin
           bitfarmLog.Write(llNormal, ltInfo, 'vor ShowLogo (2)', 'AutoScanV3');

            ShowLogo;
            WriteLn('Fehler: Es ist ein Fehler beim Scannen aufgetreten(' + e.Message + ')');
            bitfarmLog.Write(llNormal, ltInfo,
              'Fehler: Es ist ein Fehler beim Scannen aufgetreten(' + e.Message + ')', 'AutoScanV3');

            WaitForKey;
            Exitcode := 5;  // Unerwarteter Fehler beim Scannen
            Exit;
         end;
      end;
      ///////////////////////////////////////////////////////////////////////////////////
      //
      // Datei speichern und auf Fehler beim Speichern prfen
      //
      try
         bitfarmLog.Write(llNormal, ltInfo, 'Trap 12 imagecount: ' +
           IntToStr(img.imagecount), 'AutoScanV3');

         if img.imagecount = 0 then
         begin
           bitfarmLog.Write(llNormal, ltInfo, 'vor ShowLogo (3)', 'AutoScanV3');
           ShowLogo;
            WriteLn('Keine Seite gescannt');
            WaitForKey;
            Exitcode := 7;  // Unerwarteter Fehler beim Speichern
            Exit;

         end;

         bitfarmLog.Write(llNormal, ltInfo, 'vor bPageInfo', 'AutoScanV3');
         if bPageInfo then
         begin
            button := MessageDlg('Es wurden ' + inttostr(img.ImageCount)+' Seiten gescannt.' +#13#10+
               'Seiten archivieren oder Abbrechen?', mtInformation, [mbYes, mbCancel],0);
            if button = mrCancel then
            begin
					ExitCode := 9;		//Abbruch durch den Benutzer
               Exit;
            end;
         end;

         bitfarmLog.Write(llNormal, ltInfo, 'vor tico_Main.Icons', 'AutoScanV3');

         dm_Main.tico_Main.Icons := dm_Main.il_Std;
         dm_Main.tico_Main.IconIndex := 0;
         dm_Main.tico_Main.Delay := 800;
         dm_Main.tico_Main.Hint := 'bitfarm Archiv V3 - AutoScan (speichern)' + #13 +
          scan.SourceName[scan.SelectedSource];
         dm_Main.tico_Main.Animated := True;
         //      if UseInvers then
         bitfarmLog.Write(llNormal, ltInfo, 'Trap 13', 'AutoScanV3');

         for iCount := 0 to img.ImageCount - 1 do
         begin
            case iComp of
               0:
                  img.MIO.Params[iCount].TIFF_Compression := ioTIFF_UNCOMPRESSED;
               1:
                  img.MIO.Params[iCount].TIFF_Compression := ioTIFF_G3FAX2D;
               2:
                  img.MIO.Params[iCount].TIFF_Compression := ioTIFF_G4FAX;
               3:
                  img.MIO.Params[iCount].TIFF_Compression := ioTIFF_JPEG;
               4:
                  img.MIO.Params[iCount].TIFF_Compression := ioTIFF_PACKBITS;
               5:
                  img.MIO.Params[iCount].TIFF_Compression := ioTIFF_LZW;
            else
               img.MIO.Params[iCount].TIFF_Compression :=
                  ioTIFF_UNCOMPRESSED;
            end;

            if img.MIO.TWainParams.PixelType.CurrentValue = 0 then
            begin
               img.MIO.Params[iCount].BitsPerSample := 1;
               img.MIO.Params[iCount].SamplesPerPixel := 1;
            end
            else
            if img.MIO.TWainParams.PixelType.CurrentValue = 1 then
            begin
               img.MIO.Params[iCount].BitsPerSample := img.MIO.TWainParams.BitDepth.CurrentValue;
               img.MIO.Params[iCount].SamplesPerPixel := 1;
            end
            else
            if img.MIO.TWainParams.PixelType.CurrentValue = 2 then
            begin
               img.MIO.Params[iCount].BitsPerSample := 8;
               img.MIO.Params[iCount].SamplesPerPixel := 3;
            end;
         end;

         img.MIO.DuplicateCompressionInfo;
         sleep(200);
         bitfarmLog.Write(llNormal, ltInfo, 'Trap 14', 'AutoScanV3');

         if useInvers then
         begin

            for iCount := 0 to img.ImageCount - 1 do
            begin
               img.SelectedImage := icount;
               img.Proc.Negative;
            end;
         end;
         bitfarmLog.Write(llNormal, ltInfo, 'Trap 15', 'AutoScanV3');

         if Filtleer then
         begin
            img.EnableMultiSelect := true;
            icount := 0;
            while iCount < img.ImageCount do
            begin
               ms := TMemoryStream.Create;

               img.SelectedImage := icount;
               liev := TImageEnView.Create(nil);
               liev.IO.Params.tiff_Compression := img.MIO.Params[iCount].tiff_Compression;
               liev.IEBitmap.AssignImage(img.GetTIEBitmap(img.SelectedImage));

               liev.io.Params.BitsPerSample := img.MIO.Params[iCount].BitsPerSample;
               liev.io.Params.SamplesPerPixel := img.MIO.Params[iCount].SamplesPerPixel;
               case liev.io.Params.BitsPerSample * liev.io.Params.SamplesPerPixel of
                  1:
                     liev.Proc.ConvertToBWOrdered;
                  4:
                     liev.Proc.ConvertToGray;
                  8:
                     liev.Proc.ConvertToGray;
                  24:
                     liev.Proc.ConvertTo24Bit;
               end;

               try
                  liev.IO.SaveToStreamTIFF(ms);
                  //tiffWriteStream(ms,true ,lbit,lioparam , Progress);

               except on e: exception do
                  begin
                  end;
               end;
               if ms.Size < trunc(GFkbleer * 1024) then
               begin
                  //  showmessage('delete page '+inttostr(icount));
                  img.deleteSelectedimages;
               end
               else
               begin
                  icount := icount + 1;
               end;
               if assigned(ms) then
                  freeandnil(ms);
               if assigned(liev) then
                  liev.Destroy;
               //            if assigned(lbit) then freeandnil (lbit);
            end;
         end;

         bitfarmLog.Write(llNormal, ltInfo, 'Trap 16', 'AutoScanV3');
         if not bStacked then
         begin
            if img.imagecount = 0 then
            begin
               ShowLogo;
               WriteLn('Keine Seite gescannt, bzw. nur leere Seiten.');
               WaitForKey;
               Exitcode := 8;  // Unerwarteter Fehler beim Speichern
               Exit;

            end;
            sFileName := GenNewName;

            img.MIO.SaveToFile(sTempPath + sFileName + '.TIF');
            // img.MIO.SaveToFile('c:\'+ sFileName + '.TIF');
            bitfarmLog.Write(llNormal, ltInfo, 'Copy jobfile: ' + sTempPath + sFileName + '.JOB', 'AutoScanV3');
            CopyFile(PChar(sTemplate), PChar(sTempPath + sFileName + '.JOB'), False);           //  Deaktiviert fr Geschwindigkeitsmessung
            if FileExists(sTempPath + sFileName + '.JOB') then
              bitfarmLog.Write(llNormal, ltInfo, 'jobfile: ' + sTempPath + sFileName + '.JOB - Existiert', 'AutoScanV3')
            else
              bitfarmLog.Write(llNormal, ltInfo, 'jobfile: ' + sTempPath + sFileName + '.JOB - NICHT Existiert!', 'AutoScanV3');


            try
               JobFile := TIniFile.Create(sTempPath + sFileName + '.JOB');
               // Ini.WriteString('Section','Schlssel1','Wert');
               Jobfile.WriteString('Document', 'NumPages', inttostr(img.ImageCount));

            finally
               JobFile.Free;
            end;
            bitfarmLog.Write(llNormal, ltInfo, 'Trap 17', 'AutoScanV3');

         end
         else
         begin
            for iCount := 0 to (img.ImageCount - 1) do
            begin
               sFileName := GenNewName;
               io.AttachedIEBitmap := img.GetTIEBitmap(iCount);
               io.AssignParams(img.MIO.Params[iCount]);
               io.SaveToFile(sTempPath + sFileName + IntToStr(iCount) + '.TIF');

               bitfarmLog.Write(llNormal, ltInfo, 'Copy jobfile: ' + sTempPath + sFileName + IntToStr(iCount) + '.JOB', 'AutoScanV3');
               CopyFile(PChar(sTemplate), PChar(sTempPath + sFileName + IntToStr(iCount) + '.JOB'), False);   // deaktiviert fr Geschwindigkeitsmessung
              if FileExists(sTempPath + sFileName + '.JOB') then
                bitfarmLog.Write(llNormal, ltInfo, 'jobfile: ' + sTempPath + sFileName + IntToStr(iCount) + '.JOB - Existiert', 'AutoScanV3')
              else
                bitfarmLog.Write(llNormal, ltInfo, 'jobfile: ' + sTempPath + sFileName + IntToStr(iCount) + '.JOB - NICHT Existiert!', 'AutoScanV3');

               try
//30.01.2020 ich denke das ist hier false, weil iCount wird nicht mitgegeben                  JobFile := TIniFile.Create(sTempPath + sFileName + '.JOB');
                 JobFile := TIniFile.Create(sTempPath + sFileName + IntToStr(iCount) + '.JOB');
                  // Ini.WriteString('Section','Schlssel1','Wert');
                  Jobfile.WriteString('Document', 'NumPages', '1');

               finally
                  JobFile.Free;
               end;

            end;
            bitfarmLog.Write(llNormal, ltInfo, 'Trap 18', 'AutoScanV3');

         end;

         if bPrintDoc then
         begin
            PrintDoc();
         end;
      except
         on e: exception do
         begin
            ShowLogo;
            WriteLn('Fehler: Unerwarteter Fehler beim Speichern (' + e.Message + ')');
            bitfarmLog.Write(llNormal, ltInfo, 'Fehler: Unerwarteter Fehler beim Speichern (' +
              e.Message + ')', 'AutoScanV3');

            WaitForKey;
            Exitcode := 6;  // Unerwarteter Fehler beim Speichern
            Exit;
         end;
      end;
   finally
      img := nil;
      if Assigned(img) then
         FreeAndNil(img);
      if Assigned(io) then
         FreeAndNil(io);
      (*if Assigned(tiff) then
         FreeAndNil(tiff);*)
      if Assigned(dm_Main) then
         dm_Main.Free;
      reg.free;
   end;

end.



