unit u_bfaMessage;

interface

uses
	gnugettext, Windows, SysUtils, Graphics, Forms,
   StdCtrls, ExtCtrls, Vcl.Imaging.GIFImg, Vcl.Controls, System.Classes;


type
   Tfrm_ShowBfaMessage = class (TForm)
      Label1: TLabel;
      Image1: TImage;
      Label2: TLabel;
      Shape1: TShape;
      Shape2: TShape;
      Shape3: TShape;
      Shape4: TShape;
    imgProgress: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure Label1Click(Sender: TObject);
   private
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
   end;

var
   frm_ShowBfaMessage: Tfrm_ShowBfaMessage;

implementation

uses bfaCommonUtils;

{$R *.dfm}


procedure Tfrm_ShowBfaMessage.FormCreate(Sender: TObject);
var
   iCount, iPos: integer;
   slBind, lsPar, lsParL, lsParCom, lsParVal, lsLanguage, lsLangPath: string;
   RS: TResourceStream;
begin
  BD.LogPath := BD.EnvTemp;
  BD.LogName := 'BfaMessage<%d>.log';

  if not (directoryexists(BD.AppdataBitfarm)) then
    try
       mkDir(BD.AppdataBitfarm);
    except on e: exception do

    end;
  // Auswertung der Parameter
  BD.LogOn := false;

  lsLanguage := '';
  lsLangPath := BD.ExeDir + 'locale\';
  for iCount := 1 to ParamCount do
  begin
    lsPar := ParamStr(icount);
    lsParL := lowercase(lsPar);
    iPos := Pos(':',lsParL);
    if iPos = 0 then
       iPos := maxint-1;
    lsParCom := Copy(lsParL,1,iPos-1); // das vor dem Doppelpunkt (oder alles wenn keiner)
    lsParVal := Copy(lsParL,iPos+1,maxint); // das vor nach Doppelpunkt (oder nix wenn keiner)
    if lsParL = '-debug' then
    begin
       BD.LogOn := true;
       Continue;
    end;
    if lsParCom = '-lang' then   //z.B. "-lang:en"
    begin lsLanguage := lsParVal; Continue; end;
    if lsParCom = '-langpath' then   //z.B. "-lang:en"
       begin lsLangPath := lsParVal; Continue; end;
  end;
  if lsLanguage = '' then
  begin
    if SysLocale.DefaultLCID = 1031 then
      lsLanguage := 'de'
    else
      lsLanguage := 'en';
  end;

  bindtextdomain('BfaMessage', lsLangPath);
  gnugettext.DefaultInstance.textdomain('BfaMessage');
  gnugettext.UseLanguage(lsLanguage);
  gnugettext.TranslateComponent(self);

  Application.Title := _('Datenbertragung zum bitfarm Archiv Server');
  Label1.Caption := _('...bitte warten Sie bis die bertragung beendet ist.');
  Label2.Caption := _('Dokumente werden zum Server bertragen');

  RS := TResourceStream.Create(hInstance, 'GifImage_1', RT_RCDATA);
  imgProgress.Picture.LoadFromStream(RS);
  (imgProgress.Picture.Graphic as TGIFImage).AnimationSpeed := 300;
  (imgProgress.Picture.Graphic as TGIFImage).Animate := True;
  Self.DoubleBuffered := True;
end;

procedure Tfrm_ShowBfaMessage.FormClick(Sender: TObject);
begin
   Application.Minimize;
end;

procedure Tfrm_ShowBfaMessage.Image1Click(Sender: TObject);
begin
   Application.Minimize;
end;

procedure Tfrm_ShowBfaMessage.Label2Click(Sender: TObject);
begin
   Application.Minimize;
end;

procedure Tfrm_ShowBfaMessage.Label1Click(Sender: TObject);
begin
   Application.Minimize;
end;

end.
