unit u_Main;

interface

uses
  Windows, Graphics, Messages, SysUtils, Classes, Forms,
  cxLookAndFeelPainters, cxGraphics, DASQLMonitor, UniSQLMonitor, ExtCtrls,
  cxClasses, dxAlertWindow, DB, DBAccess, Uni, UniProvider, MySQLUniProvider,
  MemDS, ImgList, Controls, JvBalloonHint, Menus, JvComponentBase,
  JvTrayIcon,
  bfaObjects36, JvAppHotKey, u_ttwvl, bfaLog, System.ImageList,
  System.Notification, Vcl.BaseImageCollection, Vcl.ImageCollection,
  Vcl.VirtualImageList, IniFiles;


const
  WM_HOTKEY_WVL_MESSAGE = WM_APP + 0;
  WM_HOTKEY_RECONNECT = WM_APP + 1;
  WM_HOTKEY_ENABLE_DISABLE = WM_APP + 2; // WParam 1 = enable, WParam 0 = disable
  WM_HOTKEY_RELOAD_CONFIG = WM_APP + 3;

  DOMAIN_HOTSEARCH36 = 'Hotsearch36';

type
  Tfrm_Main = class(TForm)
    pum_Main: TPopupMenu;
    mnu_Exit: TMenuItem;
    Strgs1: TMenuItem;
    Timer1: TTimer;
    Viewer1: TMenuItem;
    tim_connect: TTimer;
    tim_5min: TTimer;
    cntMain: TUniConnection;
    qry_old: TUniQuery;
    MySQLUniProvider1: TMySQLUniProvider;
    dsc_old: TUniDataSource;
    dxAlertWindowManager1: TdxAlertWindowManager;
    jtico_Main: TTrayIcon;
    UniSQLMonitor1: TUniSQLMonitor;
    mniLanguage: TMenuItem;
    mniGerman: TMenuItem;
    mniEnglish: TMenuItem;
    ImageCollection1: TImageCollection;
    VirtualImageList1: TVirtualImageList;
    procedure japp_HKHotKey(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure mnu_ExitClick(Sender: TObject);
    procedure Est1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure pum_MainPopup(Sender: TObject);
    procedure Viewer1Click(Sender: TObject);
    procedure MyConnection1Error(Sender: TObject; E: EDAError; var Fail: Boolean);
    procedure tim_connectTimer(Sender: TObject);
    procedure _jtico_MainDblClick(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure tim_5minTimer(Sender: TObject);
    procedure jtico_MainDblClick(Sender: TObject);
    procedure mniGermanClick(Sender: TObject);
    procedure mniEnglishClick(Sender: TObject);
  private
    FSearchObj: TbfaSearch;
    FSearchProc: TbfaSearchProcessing;
    currentCW: Word;
    dateCWFirstDay: TDateTime;
    dateCWLastDay: TDateTime;
  protected
    fbconnecting: Boolean;
    iGTaskCount, iGUsrID, iGNewResub: Integer;
    fHotKeyArray: array of TJvApplicationHotKey;
    fStorageArray: array of string;
    fArchiveArray: array of string;
    fbscreenshot: array of Boolean;
    fbsearchlinks: array of Boolean;
    fbsearchGDocID: array of Boolean;
    shotkey: tshortcut;
    igRegTimIds: array of Integer;
    gbshowpupup: Boolean;
    twvlckeck: TTwvlcheck;
    fsdomain: string;
//    fbbaloonactive: Boolean;
    fiBaloonCounter: Integer;
    fiBaloonCounterMax: Integer;
    fUsername, fProfil: string;
    fPushedResubsList: TStringList;
    procedure OnMyMessage(var Msg: TMessage); message WM_HOTKEY_WVL_MESSAGE;
    procedure OnReconnect(var Msg: TMessage); message WM_HOTKEY_RECONNECT; //3.5.0.3 [2393]
    procedure OnChangeHotKeyState(var Msg: TMessage); message WM_HOTKEY_ENABLE_DISABLE; // SJ 18.10.2021 - 3.6.2
    procedure OnReloadConfig(var Msg: TMessage); message WM_HOTKEY_RELOAD_CONFIG; // SJ 19.10.2021 - 3.6.2
    procedure readtimidsfromregistry;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure MYExit;
    procedure SetHint;
    function IsOptionWindowVisible: Boolean;
    function TakeScreenshot(var bmp: TBitmap; MonitorNumber: Integer): Boolean;
    procedure FullScreen(var bmp: TBitmap; MonitorNumber: Integer);
    procedure WndProc(var Msg: TMessage); override;

    function GetLanguageLocaleId: Integer;
    function IsLanguageGerman: Boolean;
    function GetLanguage: string;
    procedure SetLanguage(sLanguage: string);
    procedure InitLanguage;
    procedure CheckMenuItemLanguage(sLanguage: string);
    procedure Translate(sLanguage: string; ForTheFirstTime: Boolean = False);
    procedure LoadHotKeys(inifile: TIniFile);
  public
    // die werden von TTwvlcheck gebraucht
    bitfarmLog: TbfaLog;
    gbhasreg, FormIsFullScreen, fbingetocrtext, fbtakescreenshot, bShowalert: Boolean;
    fsOCR: string;
    bfaNotificationCenter: TNotificationCenter;
    procedure SetCW(day: TDate);
    procedure connnecttoserver;
    procedure getocrtext(bild: TBitmap);
    function ShellExecute_AndWait(Operation, FileName, Parameter, Directory: string; Show: word; bWait: boolean): longint;
    procedure ShowAlertWindow(Text: WideString);
  end;

procedure StartViewerWithParameters(bitfarmLog: TbfaLog; Classname: WideString; lsparam: string);

var
  frm_Main: Tfrm_Main;

implementation

uses
  u_dm_Main, u_Record, PNGImage, USingleInst,
  dateutils, u_screenshot, bfaCommonUtils, ShellApi, bfaCommonMethods, Registry,
  {$IFDEF ENTERPRISE}
  bitfarm_enterprise,
  {$ELSE}
  bitfarm_core,
  {$ENDIF}
  gnugettext, bfaCommonDB, ievect, Dialogs, hyiedefs, StrUtils,
  Clipbrd, RegularExpressions;

{$R *.dfm}

procedure StartViewerWithParameters(bitfarmLog: TbfaLog; Classname: WideString; lsparam: string);
var
  HWND: THandle;
  copydata: TCopyDataStruct;
  Data, PData: PWideChar;
  DataSize, i: Integer;
  sl: TStringList;
  lsCmd: string;
begin
  try
    if bitfarmLog <> nil  then
    begin
      bitfarmLog.Write(llNormal, ltInfo, 'Viewer Path: "' + PChar(ExtractFilePath(ParamStr(0)) +
        'ViewerV3.exe') + '"', ClassName);
      bitfarmLog.Write(llNormal, ltInfo, 'lsparam: "' + lsparam, ClassName);
    end;
    HWND := FindWindow(PChar('bitfarm.Viewer.V36'), nil);
    if HWND = 0 then
    begin
      if bitfarmLog <> nil  then
        bitfarmLog.Write(llNormal, ltInfo, 'ShellExecute', ClassName);
      //16.10.2024 -->
      lsCmd := ExtractFilePath(ParamStr(0)) + 'ViewerV3.exe';
      if Pos(' ', lsCmd) > 0 then
        lsCmd := '"' + lsCmd + '"';

//16.10.2024      ShellExecute(Application.Handle, PChar(''), PChar(ExtractFilePath(ParamStr(0)) +
//        'ViewerV3.exe'), PChar(lsparam), nil, SW_Hide);
      ShellExecute(Application.Handle, PChar(''), PChar(lsCmd), PChar(lsparam), nil, SW_Hide);
      //16.10.2024 <--
    end
    else
    begin
      if bitfarmLog <> nil  then
        bitfarmLog.Write(llNormal, ltInfo, 'SendMessage', ClassName);
      sl := TStringList.Create;
      try
        sl.Delimiter := ' ';
        sl.QuoteChar := #0;
        var start: Integer;
        start := 1;
        for i := 0 to Length(lsparam) - 1 do
        begin
          if (lsparam[i] = ' ') and (lsparam[i - 1] <> '\') then
          begin
            sl.Add(Copy(lsparam, start, i - start));
            start := i + 1;
          end else if i = Length(lsparam) - 1 then
            sl.Add(Copy(lsparam, start, Length(lsparam)));
        end;

        for i := 0 to sl.Count - 1 do
        begin
          sl[i] := StringReplace(sl[i], '\ ', ' ', [rfReplaceAll]);
        end;

        DataSize := 0;
        for i := 0 to sl.Count - 1 do
          Inc(DataSize, Length(sl[i]) + 1);
        Inc(DataSize);
        Data := StrAlloc(DataSize);
        try
          PData := Data;
          for i := 0 to sl.Count - 1 do
          begin
            StrPCopy(PData, sl[i]);
            Inc(PData, Length(sl[i]) + 1);
          end;
          PData^ := #0;
          CopyData.lpData:= Data;
          CopyData.cbData := DataSize * SizeOf(Char);
          CopyData.dwData:= $DDED;
          SendMessage(HWND, WM_COPYDATA, 0, LPARAM(@CopyData));
        finally
          StrDispose(Data);
        end;
      finally
        FreeAndNil(sl);
      end;
    end;
  except
    if bitfarmLog <> nil  then
      bitfarmLog.Write(llNormal, ltException, 'StartViewerWithParameters', ClassName);
  end;
end;

procedure Tfrm_Main.MYExit;
begin
  try
    Timer1.Enabled := False;
    tim_connect.Enabled := False;
    tim_5min.Enabled := False;

    Application.Terminate;
  except
    if bitfarmLog <> nil  then
      bitfarmLog.Write(llNormal, ltException, 'MyExit', ClassName);
  end;
end;

// 15.09.2010 b.takacs
// If a window with caption: Optionen und Einstellungen is visible returns true else false
function Tfrm_Main.IsOptionWindowVisible: Boolean;
var
  i: Integer;
  found: Boolean;
  WndText: PWideChar;
  {$IFDEF NEWTRANSLATIONFEATURE}
  MainFormPID, OptionsFormPID: DWORD;
  WndHDL, MainFormHDL: Cardinal;
  {$ELSE}
  WndHDL: Cardinal;
  {$ENDIF}
begin
  found := False;
  try
    WndHDL := GetWindow(handle, GW_HWNDFIRST);
    while (WndHDL <> GetWindow(handle, GW_HWNDLAST)) do
    begin
      if (IsWindowEnabled(WndHDL) and (IsWindowVisible(WndHDL))) then
      begin
        i := GetWindowTextLength(WndHDL);
        GetMem(WndText, (i + 1) * SizeOf(WideChar));
        try
          GetWindowText(WndHDL, WndText, i + 1);
          {$IFDEF NEWTRANSLATIONFEATURE}
          // Funktioniert aktuell nur, wenn Viewer und HotSearch die selbe Sprache haben
          //
          // TODO:
          //   WM_HOTKEY_GET_LANGUAGE - Message, welche den Viewer fragt welche Sprache er hat.
          //     -> Luft kein Viewer, zu letzt genutzer Sprache verwenden.
          //       lparam = 0, wparam HotSearch Handle = Anfrage von HotSearch an Viewer
          //       lparam = 1, wparam liefert Sprache = Antwort von Viewer mit Sprache
          //   WM_HOTKEY_CHANGE_LANGUAGE
          //       Wird die Sprache im Viewer gendert, Message an HotSearch dass er die Sprache ndern soll
          if (StrPos(WndText, pWideChar(_('Optionen und Einstellungen'))) <> nil) then
          begin
            MainFormHDL := FindWindow(PChar('bitfarm.Viewer.V36'), nil);
            GetWindowThreadProcessId(MainFormHDL, MainFormPID);
            GetWindowThreadProcessId(WndHDL, OptionsFormPID);
            if MainFormPID = OptionsFormPID then
            begin
              found := True;
              Break;
            end;
          end;
          {$ELSE}
          if (StrPos(WndText, 'Optionen und Einstellungen') <> nil) then
          begin
            found := True;
          end;
          {$ENDIF}
        finally
          FreeMem(WndText);
        end;
      end;
      WndHDL := GetWindow(WndHDL, GW_HWNDNEXT);
    end;
    Result := found;
  except
    Result := False;
  end;
end;

procedure Tfrm_Main.japp_HKHotKey(Sender: TObject);
var
  hWindow: HWND;
  Pid1, Pid2, lPrm: cardinal;
  ksNew, ksOld: TKeyboardState;
  clip: TClipboard;
  lsparam, lsparam1, lsparam2, lssearch, FileName: string;
  Bmp: TBitmap;
  Png: TPngImage;
begin
  if fbtakescreenshot then
    exit;

  if not IsOptionWindowVisible then
  begin
    try
      Pid1 := GetWindowThreadProcessId(Application.Handle);
      Pid2 := GetWindowThreadProcessID(GetForeGroundWindow);
      clip := TClipboard.Create;
      try
        if AttachThreadInput(Pid1, Pid2, True) then
        begin
          Bmp := TBitmap.Create;
          jtico_Main.IconIndex := 1;
          hWindow := GetFocus;
          lPrm := MakeLong(0, MapVirtualKey($42, 0));
          ksNew[VK_CONTROL] := $80;
          GetKeyboardState(ksOld);
          SetKeyboardState(ksNew);
          PostMessage(hWindow, WM_KEYDOWN, integer($42), integer(lPrm));
          PostMessage(hWindow, WM_KEYUP, integer($42), integer(lPrm or $C0000000));

          Sleep(80);
          lsparam1 := '';
          lsparam2 := '';

          if TJvApplicationHotKey(sender).Tag = 1 then
          begin
            if TakeScreenshot(Bmp, 0) then
            begin
              Png := TPngImage.Create;
              try
                Png.Assign(Bmp);
                FileName := CalcNonExistingFilename(Bd.EnvTempPd + 'Viewer\',
                  'Screenshot', '.png') + '.png';
                Png.SaveToFile(Bd.EnvTempPd + 'Viewer\' + FileName);

                lsparam := '-F:' + Bd.EnvTempPd + 'Viewer\' + FileName;
                StartViewerWithParameters(bitfarmLog, Classname, lsparam);
              finally
                Png.Free;
              end;
            end;
          end
          else
          begin
            if fbscreenshot[TJvApplicationHotKey(sender).Tag] then
            begin
              fbtakescreenshot := True;
              if TakeScreenshot(Bmp, 0) then
                FullScreen(Bmp, 0);
              lssearch := fsOCR;
            end
            else
            begin
              Application.ProcessMessages;
              Sleep(800);
              lssearch := Clip.AsText;
            end;
            if fStorageArray[TJvApplicationHotKey(sender).Tag] <> '' then
            begin
              if Pos(' ', fStorageArray[TJvApplicationHotKey(sender).Tag]) > 0 then
                lsparam1 := ' "-L:' + fStorageArray[TJvApplicationHotKey(sender).Tag] + '"'
              else
                lsparam1 := ' -L:' + fStorageArray[TJvApplicationHotKey(sender).Tag];
            end;
            if fArchiveArray[(sender as TJvApplicationHotKey).Tag] <> '' then
            begin
              if Pos(' ', fArchiveArray[TJvApplicationHotKey(sender).Tag]) > 0 then
                lsparam2 := ' "-A:' + #39 + fArchiveArray[TJvApplicationHotKey(sender).Tag] + '"'
              else
                lsparam2 := ' -A:' + fArchiveArray[TJvApplicationHotKey(sender).Tag];
            end;

            if bitfarmLog <> nil then
              bitfarmLog.Write(llNormal, ltInfo, 'lssearch: "' + lssearch + '"', ClassName);
            if lssearch <> '' then
            begin
              var MatchCollection: TMatchCollection;
              var Match: TMatch;
              var gdocid: string;
              var cancelStart: Boolean;
              cancelStart := False;
              MatchCollection := TRegEx.Matches(Lowercase(lssearch), '\bgdocid:(\d+)');
              for Match in MatchCollection do
              begin
                try
                  gdocid := Match.Groups[1].Value;
                except

                end;

                bitfarmLog.Write(llNormal, ltInfo, 'gdocid Match: "' + gdocid + '"', ClassName);
              end;
              if MatchCollection.Count = 1 then
              begin
                lsparam := ' ' + Trim('gdocid:') + gdocid;
                StartViewerWithParameters(bitfarmLog, Classname, Trim(lsparam));
                SetKeyboardState(ksOld);
                Exit;
              end else if fbsearchGDocID[TJvApplicationHotKey(sender).Tag] then
              begin
              // wurde ID-Suche konfiguriert?
                try
                  if Trim(lssearch).ToInteger.ToString = Trim(lssearch) then
                    lsparam := ' ' + Trim('gdocid:') + Trim(lssearch)
                  else
                    Exit;
                except
                  Exit;
                end;
              end else if fbsearchlinks[TJvApplicationHotKey(sender).Tag] then
              // wurde Verknpfungs-Suche konfiguriert?
                lsparam := '-R:' + lssearch + ' -GO'
              else
              begin
                lssearch := StringReplace(lssearch, ' ', '\ ', [rfReplaceAll]); // SJ 18.10.2021
                lssearch := StringReplace(lssearch, '"', #39, [rfReplaceAll]); // SJ 18.10.2021
//09.10.2017 Die reinfolge muss -L -A -V sein! weil im 3.6 wird nach und nach im Thread gemacht                lsparam := '-V:' + lssearch + ' ' + lsparam1 + lsparam2 + ' -GO';
                lsparam := lsparam1 + lsparam2;
                if lsparam <> '' then
                  lsparam := lsparam + ' ';
                lsparam := lsparam + '-V:"' + lssearch + '"' + ' -GO';
              end;
              StartViewerWithParameters(bitfarmLog, Classname, Trim(lsparam));
            end;
          end;

          SetKeyboardState(ksOld);
        end;

      finally
        fbtakescreenshot := False;
        AttachThreadInput(Pid1, Pid2, False);
        if Assigned(clip) then
          FreeAndNil(clip);
        if Assigned(Bmp) then
          Bmp.Free;
        jtico_Main.IconIndex := 0;
        jtico_Main.Animate := False;
      end;
    except
      on e:Exception do
      begin
        if bitfarmLog <> nil then
          bitfarmLog.Write(llNormal, ltException, 'Fehler bei japp_HKHotKey: ' + e.Message, ClassName);
      end;
    end;
  end;
end;

procedure Tfrm_Main.FormShow(Sender: TObject);
var
  litime, licounter: Integer;
begin
  if bitfarmLog <> nil then
    bitfarmLog.DebugBegin(llDebug, 'FormShow', ClassName);
  try
    try
      fbtakescreenshot := False;
      fbconnecting := False;
      licounter := 1;
      BD.LogOn := False;
      while licounter <= paramcount do
      begin
        if pos('-time', paramstr(licounter)) > 0 then
        begin
          inc(licounter);
          trystrtoint(paramstr(licounter), litime);
          Timer1.interval := litime * 1000;
        end;
        if pos('-debug', paramstr(licounter)) > 0 then
          BD.LogOn := True;

        inc(licounter);
      end;
      gbshowpupup := True;
      ShowWindow(GetWindow(Handle, GW_OWNER), SW_HIDE);
      Left := 10000;
      while (not gbhasreg) do
      begin
        if twvlckeck = nil then
        begin
          // create thread
          twvlckeck := TTwvlcheck.Create(False);
        end
        else
        begin
          // demand terminate
          twvlckeck.Terminate;
          // wait for terminate, it should just take the moment of a
          twvlckeck.WaitFor;
          FreeAndNil(twvlckeck);
          twvlckeck := TTwvlcheck.Create(False);
        end;
        Application.ProcessMessages;
        sleep(200);
      end;
    except
      if bitfarmLog <> nil then
        bitfarmLog.Write(llNormal, ltException, 'FormShow', ClassName);
    end;
  finally
    if bitfarmLog <> nil then
      bitfarmLog.DebugEnd(llDebug, 'FormShow', ClassName);
  end;
end;

procedure Tfrm_Main.mnu_ExitClick(Sender: TObject);
begin
  MYExit;
end;

procedure Tfrm_Main.Est1Click(Sender: TObject);
begin
  frm_Record.ShowModal;
end;

procedure Tfrm_Main.connnecttoserver;
var
  reg: TRegistry;
  lsmycon, lsConnection, lsPassDb, lsPassIni, lsPassIniE, lsUsername, lsProfil: string;
  ini, con: TIniFile;
  icount: Integer;
  lbLoginOk, BoolProfile: Boolean; // alles fr Anmeldung in Ordnung (Passwort und so ...)
  qry: TUniQuery;
  sUserName, sSectionUserEncrypted, sIdentPwdEncrypted, sProfile, sPassword: string;
begin
  Application.ProcessMessages;
  reg := TRegistry.Create;
  qry := TUniQuery.Create(nil);
  try
    qry.Connection := cntMain;
    if FileExists(GetSystemVariable('APPDATA') + '\bitfarm-archiv' + '\mylogin.ini') then  //Version 3.6
    begin
      if bitfarmLog <> nil then
        bitfarmLog.Write(llNormal, ltInfo, 'Version36', ClassName);
      ini := TIniFile.Create(PChar(GetSystemVariable('APPDATA') + '\bitfarm-archiv' + '\mylogin.ini'));
      if bitfarmLog <> nil then
        bitfarmLog.Write(llNormal, ltInfo, 'ini: ' + ini.FileName, ClassName);
//08.02.2019 Ticket 18014 -->
      sUsername := bd.EnvUsername;
      if bitfarmLog <> nil then
        bitfarmLog.Write(llNormal, ltInfo, 'sUsername: ' + sUsername, ClassName);
      sSectionUserEncrypted := Encrypt(lowercase(sUsername), GlobalKey);
//      if bitfarmLog <> nil then
//        bitfarmLog.Write(llNormal, ltInfo, 'sSectionUserEncrypted: ' + sSectionUserEncrypted, ClassName);
      sProfile := ini.ReadString(sSectionUserEncrypted, sSysProfile, '');
      if bitfarmLog <> nil then
      begin
        bitfarmLog.Write(llNormal, ltInfo, 'sProfile: ' + sProfile, ClassName);
        bitfarmLog.Write(llNormal, ltInfo, '(ini.ValueExists(sSectionUserEncrypted, sSysProfil): ' + BoolToStr((ini.ValueExists(sSectionUserEncrypted, sSysProfil)), True), ClassName);
      end;

//08.02.2019 Ticket 18014 <--
      if (ini.ValueExists('User', 'Profil') and (ini.ValueExists('User', 'UserName')))
          or
         (ini.ValueExists(sSectionUserEncrypted, sSysProfil))
          then
      begin
//08.02.2019 Ticket 18014 -->

        if bitfarmLog <> nil then
          bitfarmLog.Write(llNormal, ltInfo, '(ini.ValueExists(User, Profil) and (ini.ValueExists(User, UserName))): ' +
        BoolToStr((ini.ValueExists('User', 'Profil') and (ini.ValueExists('User', 'UserName'))), True), ClassName);

        if bitfarmLog <> nil then
          bitfarmLog.Write(llNormal, ltInfo, '(ini.ValueExists(sSectionUserEncrypted, sSysProfil)): ' +
        BoolToStr((ini.ValueExists(sSectionUserEncrypted, sSysProfil)), True), ClassName);

        BoolProfile := (ini.ValueExists('User', 'Profil') and (ini.ValueExists('User', 'UserName')));
        if bitfarmLog <> nil then
          bitfarmLog.Write(llNormal, ltInfo, 'BoolProfile: ' + BoolToStr(BoolProfile, True), ClassName);

        try
          if BoolProfile then
          begin
            if bitfarmLog <> nil then
              bitfarmLog.Write(llDebug, ltInfo, '(ini.ValueExists(User, Profil) and (ini.ValueExists(User, UserName)))', ClassName);
            lsUsername := ini.ReadString('User', 'UserName', '');
            if bitfarmLog <> nil then
              bitfarmLog.Write(llDebug, ltInfo, 'lsUsername: ' + lsUsername, ClassName);
            lsProfil := ini.ReadString('User', 'Profil', '');
            fUsername := lsUsername;
          end

          else
          // if (ini.ValueExists(sSectionUserEncrypted, sSysProfil)) then
          begin
            if bitfarmLog <> nil then
              bitfarmLog.Write(llDebug, ltInfo, '(ini.ValueExists(sSectionUserEncrypted, sSysProfil))', ClassName);
            lsUsername := sUserName;
            if bitfarmLog <> nil then
              bitfarmLog.Write(llDebug, ltInfo, 'lsUsername: ' + lsUsername, ClassName);
            lsProfil := ini.ReadString(sSectionUserEncrypted, sSysProfile, '');
            if sProfile = '' then  // Falls Sid noch nicht in Ini voerhanden, nehmen wir das Profil aus Section [Users]
              sProfile := ini.ReadString(sSysUser, sSysProfile, '');
            fUsername := sUsername;
            if bitfarmLog <> nil then
              bitfarmLog.Write(llDebug, ltInfo, 'fUsername: ' + fUsername, ClassName);
          end;
        except
          if bitfarmLog <> nil then
            bitfarmLog.Write(llNormal, ltException, 'fUserName', ClassName);
        end;

//08.02.2019 Ticket 18014 <--


        if bitfarmLog <> nil then
        begin
          bitfarmLog.Write(llNormal, ltInfo, 'lsProfil: ' + lsProfil, ClassName);
          bitfarmLog.Write(llNormal, ltInfo, 'ini.Destroy;', ClassName);
        end;

        ini.Destroy;

        if (fProfil <> '') or (lsProfil <> '') then
        begin
          if fProfil <> '' then
            lsmycon := fProfil
          else
            lsmycon := lsProfil;

          lsConnection := ExtractFilePath(ParamStr(0)) + lsmycon + '.con';

          con := TIniFile.Create(lsConnection);
          if (not (con.ValueExists('Connection', 'Server') and
            con.ValueExists('Connection', 'Port') and con.ValueExists('Connection', 'User') and
            con.ValueExists('Connection', 'DB') and con.ValueExists('Connection', 'Pass'))) then
          begin
            reg.CloseKey;
            gbhasreg := False;
            jtico_Main.Hint := _('Es konnte keine Verbindung zum Server hergestellt werden.');
            if bitfarmLog <> nil then
              bitfarmLog.Write(llNormal, ltInfo, 'Es konnte keine Verbindung zum Server hergestellt werden.', ClassName);
            Exit;
          end;
          jtico_Main.Hint := _('Verbindung zum Server wird hergestellt.');
          gbhasreg := True;
          if bitfarmLog <> nil then
            bitfarmLog.Write(llNormal, ltInfo, 'Verbindung zum Server wird hergestellt.', ClassName);
          try
            cntMain.Disconnect;
          except
            on e: Exception do
            begin
              cntMain.Connected := False;
              Exit;
            end;
          end;
          fsdomain := con.ReadString('Connection', 'Domain', '');
          cntMain.Server := con.ReadString('Connection', 'Server', '');
          cntMain.Port := con.ReadInteger('Connection', 'Port', 3306);
          cntMain.Database := con.ReadString('Connection', 'DB', '');
          cntMain.Username := Decrypt(con.ReadString('Connection', 'suuser', ' '), GlobalKey);
          cntMain.Password := Decrypt(con.ReadString('Connection', 'supass', ' '), GlobalKey);

          if bitfarmLog <> nil then
            bitfarmLog.Write(llNormal, ltInfo, 'Server:' + cntMain.Server + ';Db:' + cntMain.Database, ClassName);

          try
            cntMain.Connect;
          except
            on e: Exception do
            begin
              jtico_Main.IconIndex := 1;
              jtico_Main.Hint := _('Es konnte keine Verbindung zum Server hergestellt werden.');
              if not bShowalert then
              begin
                ShowAlertWindow(_('Es konnte keine Verbindung zum Server hergestellt werden.'));
                bShowalert := True;
              end;
              // could not connect to server
              for icount := 0 to 9 do
              begin
                Application.ProcessMessages;
                sleep(50);
              end;
              if bitfarmLog <> nil then
                bitfarmLog.Write(llNormal, ltException, 'Error:' + e.message, ClassName);

              reg.CloseKey;
              Exit;
            end;
          end;
          con.Destroy;
          if (not cntMain.Connected) then
          begin
            gbhasreg := False;
            reg.CloseKey;
            Exit;
          end;

          qry.SQL.Text := 'select * from sys_user where username = ' + #39 + lsUsername + #39 + ';';
          qry.Execute;
          if bitfarmLog <> nil then
            bitfarmLog.Write(llNormal, ltInfo, 'qry.SQL.Text:' + qry.SQL.Text, ClassName);

          if qry.RecordCount = 0 then
          begin
            gbhasreg := False;
            reg.CloseKey;
            Exit;

          end;
          iGUsrID := qry.FieldByName('userid').AsInteger;
          reg.CloseKey;
          readtimidsfromregistry;

        end
        else
        begin
          gbhasreg := False;
        end;
      end
      else
      begin
        if bitfarmLog <> nil then
          bitfarmLog.Write(llNormal, ltInfo, 'ini nicht vorhanden!', ClassName);
        gbhasreg := False;
        Exit;
      end;

    end
    else
    begin
      reg.RootKey := HKEY_CURRENT_USER;
      reg.OpenKey('\Software\bitfarm\Archiv_V3\Viewer\Login', True);
      if (fProfil <> '') or (reg.ValueExists('Conn')) then
      begin
        if fProfil <> '' then
          lsmycon := fProfil
        else
          lsmycon := reg.ReadString('Conn');

        lsConnection := ExtractFilePath(ParamStr(0)) + lsmycon + '.con';

        ini := TIniFile.Create(lsConnection);
        if (not (ini.ValueExists('Connection', 'Server') and ini.ValueExists('Connection', 'Port') and ini.ValueExists('Connection', 'User') and ini.ValueExists('Connection', 'DB') and ini.ValueExists('Connection', 'Pass'))) then
        begin
          reg.CloseKey;
          gbhasreg := False;
          jtico_Main.Hint := _('Es konnte keine Verbindung zum Server hergestellt werden.');
          Exit;
        end;
        jtico_Main.Hint := _('Verbindung zum Server wird hergestellt.');
        gbhasreg := True;
        try
          cntMain.Disconnect;
        except
          on e: Exception do
          begin
            cntMain.Connected := False;
            exit;
          end;
        end;
        fsdomain := ini.ReadString('Connection', 'Domain', '');
        cntMain.Server := ini.ReadString('Connection', 'Server', '');
        cntMain.Port := ini.ReadInteger('Connection', 'Port', 3306);
        cntMain.Database := ini.ReadString('Connection', 'DB', '');
        cntMain.Username := Decrypt(ini.ReadString('Connection', 'User', ' '), GlobalKey);
        cntMain.Password := Decrypt(ini.ReadString('Connection', 'Pass', ' '), GlobalKey);

        if bitfarmLog <> nil then
          bitfarmLog.Write(llNormal, ltInfo, 'Server:' + cntMain.Server + ';Db:' + cntMain.Database, ClassName);

        try
          cntMain.Connect;
        except
          on e: Exception do
          begin
            jtico_Main.IconIndex := 1;
            jtico_Main.Hint := _('Es konnte keine Verbindung zum Server hergestellt werden.');
            if not bShowalert then
            begin
              ShowAlertWindow(_('Es konnte keine Verbindung zum Server hergestellt werden.'));
              bShowalert := True;
            end;
            // could not connect to server
            for icount := 0 to 9 do
            begin
              Application.ProcessMessages;
              Sleep(50);
            end;
            if bitfarmLog <> nil then
              bitfarmLog.Write(llNormal, ltException, 'Error:' + e.message, ClassName);

            reg.CloseKey;
            Exit;
          end;
        end;
        ini.Destroy;
        if (not cntMain.Connected) then
        begin
          gbhasreg := False;
          reg.CloseKey;
          Exit;
        end;
        ini := TIniFile.Create(PChar(GetSystemVariable('APPDATA') + '\bitfarm-archiv' + '\mylogin.ini'));

        if (ini.ValueExists('User', 'UserName')) then
        begin
          lsUsername := ini.ReadString('User', 'UserName', '');
          fUsername := lsUsername;
          qry.SQL.Text := 'select * from sys_user where username = ' + #39 + lsUsername + #39 + ';';
          if bitfarmLog <> nil then
            bitfarmLog.Write(llDebug, ltInfo, 'qry.SQL.Text: ' + qry.SQL.Text, ClassName);
          qry.Execute;
          if bitfarmLog <> nil then
            bitfarmLog.Write(llNormal, ltInfo, 'User:' + qry.FieldByName('username').AsString, ClassName);

          if qry.RecordCount = 0 then
          begin
            gbhasreg := False;
            reg.CloseKey;
            exit;

          end;
          iGUsrID := qry.FieldByName('userid').asinteger;
          reg.CloseKey;
          readtimidsfromregistry;
        end;
      end
      else
      begin
        gbhasreg := False;
      end;
    end;
  finally
    FreeAndNil(qry);
    reg.CloseKey;
    SetHint;
  end;
end;

procedure Tfrm_Main.readtimidsfromregistry;
var
  icount: Integer;
  ini: TIniFile;
  lst: TStringList;
begin
  try
    if FileExists(GetSystemVariable('APPDATA') + '\bitfarm-archiv' + '\Viewer.ini') then //Version 36
    begin
      ini := TIniFile.Create(GetSystemVariable('APPDATA') + '\bitfarm-archiv' + '\Viewer.ini');
      if ini.ValueExists('Resub', 'TimidList') then
      begin
        lst := TStringList.Create;
        lst.Delimiter := ';';
        lst.DelimitedText := ini.ReadString('Resub', 'TimidList', '');
        iGNewResub := ini.ReadInteger('Resub', 'NewResubs', 0);  //02.08.2018 Ticket 15430

        iGTaskCount := lst.Count;

        SetLength(igRegTimIds, iGTaskCount);
        for icount := 0 to lst.Count - 1 do
        begin
          igRegTimIds[icount] := StrToInt(lst[icount]);
        end;
      end;
    end;

  finally
    if Assigned(ini) then
      FreeAndNil(ini);
  end;
end;

procedure Tfrm_Main.SetCW(day: TDate);
var
  currentday, firstday, lastday: Integer;
begin
  currentCW := DateUtils.WeekOfTheYear(day);
  currentday := DateUtils.DayOfTheWeek(day);
  dateCWFirstDay := DateUtils.IncDay(day, (currentday -1)* -1);
  dateCWLastDay := DateUtils.IncDay(dateCWFirstDay, 6);
end;

procedure Tfrm_Main.Timer1Timer(Sender: TObject);
var
  i, icount, iCount1, iDiff, iGYear, iGKW, liTimId: Integer;
  bEmpty, bFound, lbDo: Bool;
  iPos: TPoint;
  irect: TRect;
  dtFirstDayOfKW, dtStart, dtEnd, dtDate: TDateTime;
  sStart, sEnd, sLogReg, sLogSql, lsLog, holiday: string;
  dsc: TUniDataSource;
begin
  if (not gbhasreg) or fbconnecting then
    Exit;

  if (not cntMain.Connected) then
  begin
    Timer1.Enabled := False;
    tim_connect.Enabled := True;
    Exit;
  end;
  if bitfarmLog <> nil then
    bitfarmLog.Write(llNormal, ltInfo, 'Timer1Timer', ClassName);

  dsc := TUniDataSource.Create(nil);
  try
    try

      dtDate := date;

      try
        SetCW(Date);
      except
        if bitfarmLog <> nil then
          bitfarmLog.Write(llNormal, ltException, 'SetCW(Date);', ClassName);
      end;
      if bitfarmLog <> nil then
        bitfarmLog.Write(llNormal, ltInfo, 'SetCW(Date);', ClassName);
      try

        FSearchObj.Reset;
        FSearchObj.ID := 1;
        FSearchObj.Name := _('eigene Wiedervorlage');
        FSearchObj.ResubDateHigh := FormatDateTime('yyyy-mm-dd', dateCWLastDay);
        FSearchObj.UserContext := iGUsrID;
        FSearchObj.SearchType := 4; // Wiedervorlage
        FSearchObj.SelectedCols := 'gdocid,editmode,arcid,timid,tmr.timref,date,alarm,' +
          'tmr.modified,tmr.groupid,userid_shed,userid_work, ' +
          'IF (tmr.groupid <> 0, grwork.groupname, suwork.username) AS user_work, ' +
          'sushed.username as user_shed, status, tmr.options';
        FSearchObj.ResubState := 4; // nicht fertig
        FSearchObj.ResubStateNegated := True;
        holiday := GetHolidayList(iGUsrID, Date, Date);
        FSearchObj.ResubUserIDList := holiday;
        FsearchObj.GdocIDWithSymLink := False;

//13.01.2023        dsc.DataSet := FSearchProc.Search(cntMain, FSearchObj);

      except
        on e: Exception do
        begin
          cntMain.Connected := False;
          if bitfarmLog <> nil then
            bitfarmLog.Write(llNormal, ltException, 'Search', ClassName);
          exit;
        end;
      end;
      iDiff := 0;

      if bitfarmLog <> nil then
        bitfarmLog.Write(llNormal, ltInfo, 'Suche ausgefhrt', ClassName);

      // should check for changes also!!!
      // maybe the viewer should save directly to registry any changes...
      if ((dsc <> nil) and (dsc.DataSet <> nil) and (dsc.DataSet.RecordCount = 0)) and (iGTaskCount <> 0) then
      begin
        // The list is empty so no blink!!!
        bFound := False;
        bEmpty := True;
      end
      else
      begin
        bEmpty := True;
        bFound := False;
        if iGTaskCount <> dsc.DataSet.RecordCount then
        begin
          bEmpty := False;
          bFound := False;
        end
        else
        begin
          if bitfarmLog <> nil then
            bitfarmLog.Write(llNormal, ltInfo, 'for icount := 0 to dsc.DataSet.RecordCount - 1 do', ClassName);
          for icount := 0 to dsc.DataSet.RecordCount - 1 do
          begin
            bFound := False;
            liTimId := dsc.DataSet.FieldByName('timid').AsInteger;

            for iCount1 := 0 to iGTaskCount - 1 do
            begin
              bEmpty := False;
              if igRegTimIds[icount1] = liTimId then
              begin
                bFound := True;
                Break;
              end;
            end;

            // SJ 04.02.2022
//            if not bFound then
//            begin
//              iDiff := iDiff + 1;
//            end
//            else
//            begin
//              bFound := True;
//            end;
            if not bFound then
            begin
              iDiff := iDiff + 1;
            end;
            // SJ 04.02.2022

            dsc.DataSet.Next;
          end;
        end;
      end;

      if BD.LogOn then
      begin
        if bitfarmLog <> nil then
          bitfarmLog.Write(llNormal, ltInfo, 'if BD.LogOn then', ClassName);
      
        sLogReg := '';
        for i := 0 to iGTaskCount - 1 do
        begin
          sLogReg := sLogReg + IntToStr(igRegTimIds[i]) + ',';
        end;

        sLogSql := '';
        dsc.DataSet.First;
        for icount := 0 to dsc.DataSet.RecordCount - 1 do
        begin
          sLogSql := sLogSql + dsc.DataSet.FieldByName('timid').AsString + ',';
          dsc.DataSet.Next;
        end;

        if sLogReg = sLogSql then
          lsLog := ' Reg=SQL'
        else
          lsLog := '';

        if bitfarmLog <> nil then
          bitfarmLog.Write(llNormal, ltInfo, 'rc:' + inttostr(dsc.DataSet.RecordCount) +
                  ';tc:' + inttostr(iGTaskCount) +
                  ';f:' + booltostr(bFound) + ';dif:' + inttostr(iDiff) +
                  ';em:' + booltostr(bEmpty) + lsLog, ClassName);

      end;

      if bitfarmLog <> nil then
      begin
        bitfarmLog.Write(llNormal, ltInfo, 'bFound: ' + BoolToStr(bFound, True), ClassName);
        bitfarmLog.Write(llNormal, ltInfo, 'iDiff: ' + IntToStr(idiff), ClassName);
        bitfarmLog.Write(llNormal, ltInfo, 'bEmpty: ' + BoolToStr(bEmpty, True), ClassName);
        bitfarmLog.Write(llNormal, ltInfo, 'iGNewResub: ' + IntToStr(iGNewResub), ClassName);
      end;

      lbDo := (((not bFound) or (iDiff <> 0)) and (not bEmpty)) or (iGNewResub <> 0);

      if bitfarmLog <> nil then
        bitfarmLog.Write(llNormal, ltInfo, 'lbDo: ' + BoolToStr(lbDo, True), ClassName);
      
      if lbDo then
      begin
        if bitfarmLog <> nil then
          bitfarmLog.Write(llNormal, ltInfo, 'if lbDo then', ClassName);

        if BD.LogOn then
        begin
          if sLogReg <> sLogSql then
          begin
            if bitfarmLog <> nil then
              bitfarmLog.Write(llNormal, ltWarning, 'Reg: ' + sLogReg +
                ';'+ ' SQL: '+ sLogSql, ClassName);
          end
        end;

        SetLength(igRegTimIds, 0);
        SetLength(igRegTimIds, dsc.DataSet.RecordCount);

        dsc.DataSet.First;
        for icount := 0 to dsc.DataSet.RecordCount - 1 do
        begin
          igRegTimIds[icount] := dsc.DataSet.FieldByName('timid').AsInteger;
          dsc.DataSet.Next;
        end;

        iGTaskCount := dsc.DataSet.RecordCount;
        if bitfarmLog <> nil then
          bitfarmLog.Write(llNormal, ltInfo, 'hotsearch start blinkt', ClassName);

        jtico_Main.Animate := True;
        ipos := IRect.TopLeft;
        if bitfarmLog <> nil then
          bitfarmLog.Write(llNormal, ltInfo, _('Ihre Wiedervorlageliste hat sich gendert.'), ClassName);
        ShowAlertWindow(_('Ihre Wiedervorlageliste hat sich gendert.'));
        fiBaloonCounter := 0;
//        tim_5min.enabled := fbbaloonactive;
      end;
    except
      if bitfarmLog <> nil then
        bitfarmLog.Write(llNormal, ltException, 'Timer1Timer', ClassName);
    end;
  finally
    FreeAndNil(dsc);
  end;
end;

procedure Tfrm_Main.pum_MainPopup(Sender: TObject);
begin
  jtico_Main.Animate := False;
  jtico_Main.IconIndex := 0;
end;

procedure Tfrm_Main.Viewer1Click(Sender: TObject);
var
  lsParam, lsCmd: string;
  h: THandle;
  aparameter, lsprogname, lstmp, lsCaption, lsRepos, lsLog: string;
  lirueck, licounter, lireturncode: Integer;
  lirev: Int64;
  si: TStartupInfo;
  pi: TProcessInformation;
begin
  jtico_Main.Animate := False;
  Application.ProcessMessages;

  lsParam := '';
  if ((GetKeyState(vk_Control) < 0) //GetShiftState
    and (GetKeyState(vk_Shift) < 0) //GetShiftState
    ) or BD.LogOn then
    lsParam := '-debug';

  lsCmd := ExtractFilePath(ParamStr(0)) + 'ViewerV3.exe';
  //16.10.2024 -->
  if Pos(' ', lsCmd) > 0 then
    lsCmd := '"' + lsCmd + '"';
  //16.10.2024 <--
  if bitfarmLog <> nil then
    bitfarmLog.Write(llNormal, ltInfo, 'Tfrm_Main.Viewer1Click lsCmd="' + lsCmd +
      '" lsParam="' + lsParam + '"', ClassName);

  h := GetDesktopWindow;

   (**********************)
  FillChar(si, SizeOf(si), 0);
  si.cb := SizeOf(si);
  si.dwFlags := STARTF_USESHOWWINDOW;
  si.wShowWindow := SW_hide;
  FillChar(pi, SizeOf(pi), 0);
  AParameter := Format('cmd /c %s', [TrimRight(lsCmd)]);
   {errb := }  CreateProcess(nil, PChar(Aparameter), nil, nil, longbool(False),
   CREATE_NEW_CONSOLE or NORMAL_PRIORITY_CLASS, nil, PChar(BD.ExeDir), si, pi);

  Sleep(3000);
  TerminateProcess(pi.hProcess, 0);
  CloseHandle(pi.hProcess);
  CloseHandle(pi.hThread);
end;

procedure Tfrm_Main.MyConnection1Error(Sender: TObject; E: EDAError; var Fail: Boolean);
begin
  try
    jtico_Main.IconIndex := 1;
    jtico_Main.Hint := _('Es konnte keine Verbindung zum Server hergestellt werden.');

    for var icount := 0 to 9 do
    begin
      Application.ProcessMessages;
      sleep(50);
    end;
  except

  end;
end;

procedure Tfrm_Main.tim_connectTimer(Sender: TObject);
begin
  if fbconnecting then
    Exit;
  try  
    fbconnecting := True;
    try
      connnecttoserver;
    except
      on e: Exception do
      begin
      end;
    end;
    fbconnecting := False;
    if cntMain.Connected then
    begin
      jtico_Main.IconIndex := 0;
      SetHint;
      tim_connect.Enabled := False;
      Timer1.Enabled := True;
    end;
  except
    if bitfarmLog <> nil  then
      bitfarmLog.Write(llNormal, ltException, 'connectTimer', ClassName);
  end;
end;

procedure Tfrm_Main._jtico_MainDblClick(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  try
    jtico_Main.Animate := False;
    jtico_Main.IconIndex := 0;
    Application.ProcessMessages;

    StartViewerWithParameters(bitfarmLog, Classname, pchar(' -W:'));
  except
    if bitfarmLog <> nil  then
      bitfarmLog.Write(llNormal, ltException, '_jtico_MainDblClick', ClassName);
  end;
end;

procedure Tfrm_Main.OnChangeHotKeyState(var Msg: TMessage);
var
  I: Integer;
begin
  try
    for I := Low(fHotKeyArray) to High(fHotKeyArray) do
      fHotKeyArray[I].Active := (Msg.WParam = 1);
  except
    if bitfarmLog <> nil  then
      bitfarmLog.Write(llNormal, ltException, 'OnChangeHotKeyState', ClassName);
  end;
end;

procedure Tfrm_Main.OnMyMessage(var Msg: TMessage);
begin
  try
    if msg.WParam = 1 then
    begin
      jtico_Main.Animate := False;
      jtico_Main.IconIndex := 0;

      tim_5min.Enabled := False;
      readtimidsfromregistry;
    end;
  except
    if bitfarmLog <> nil  then
      bitfarmLog.Write(llNormal, ltException, 'OnMyMessage', ClassName);
  end;
end;

//3.5.0.3 [2393]
procedure Tfrm_Main.OnReconnect(var Msg: TMessage);
begin
  try
    if bitfarmLog <> nil then
      bitfarmLog.Write(llNormal, ltInfo, 'Tfrm_Main.OnReconnect', ClassName);

    cntMain.Disconnect;
    connnecttoserver;
  except
    if bitfarmLog <> nil  then
      bitfarmLog.Write(llNormal, ltException, 'OnReconnect', ClassName);
  end;
end;


procedure Tfrm_Main.OnReloadConfig(var Msg: TMessage);
var
  inifile: TIniFile;
begin
  try
    if bitfarmLog <> nil then
      bitfarmLog.Write(llNormal, ltDebug, 'OnReloadConfig', ClassName);
    try
      inifile := TIniFile.Create(BD.AppdataBitfarmPd + 'HotSearchOptions.ini');
      LoadHotKeys(inifile);
    finally
      if Assigned(inifile) then
        inifile.Free;
    end;
  except
    if bitfarmLog <> nil then
      bitfarmLog.Write(llNormal, ltException, 'OnReloadConfig', ClassName);
  end;
end;

function Tfrm_Main.GetLanguageLocaleId: Integer;
Var
  index: Integer;
begin
  index := Languages.indexOf(SysLocale.DefaultLCID);
  Result := Languages.LocaleID[index];
end;


function Tfrm_Main.IsLanguageGerman: Boolean;
const
  LOCALE_ID_GERMANY = 1031;
begin
  Result := (GetLanguageLocaleId = LOCALE_ID_GERMANY);
end;

function Tfrm_Main.GetLanguage: string;
Var
  inifile: TIniFile;
begin
  Result := 'de';
  try
  
    if FileExists(BD.AppdataBitfarmPd + 'HotSearchOptions.ini') then
    begin
      inifile := TIniFile.Create(BD.AppdataBitfarmPd + 'HotSearchOptions.ini');
      Result := inifile.ReadString('HotSearchOptions', 'Language', '');
      if Assigned(inifile) then
        inifile.Free;
    end;

    // Fall: HotSearchOptions.ini existiert nicht oder kein Language-Eintrag vorhanden
    if Result = '' then
    begin
      Result := 'de';
      if not IsLanguageGerman then
        Result := 'en';
    end;
  except
    Result := 'de';
  end;
end;

procedure Tfrm_Main.SetLanguage(sLanguage: string);
Var
  inifile: TIniFile;
begin
  if FileExists(BD.AppdataBitfarmPd + 'HotSearchOptions.ini') then
  begin
    inifile := TIniFile.Create(BD.AppdataBitfarmPd + 'HotSearchOptions.ini');
    try
      inifile.WriteString('HotSearchOptions', 'Language', sLanguage);
    finally
      inifile.Free;
    end;
  end;
end;

procedure Tfrm_Main.mniGermanClick(Sender: TObject);
begin
  Translate('de');
  SetHint;
end;

procedure Tfrm_Main.mniEnglishClick(Sender: TObject);
begin
  Translate('en');
  SetHint;
end;

procedure Tfrm_Main.Translate(sLanguage: string; ForTheFirstTime: Boolean = False);
var
  sPath: string;
begin
  try
    UseLanguage(sLanguage);
    if ForTheFirstTime then
      TranslateComponent(Self, DOMAIN_HOTSEARCH36)
    else
      ReTranslateComponent(Self, DOMAIN_HOTSEARCH36);
    CheckMenuItemLanguage(sLanguage);
    SetLanguage(sLanguage);
  except
    if bitfarmLog <> nil  then
      bitfarmLog.Write(llNormal, ltException, 'Translate', ClassName);
  end;
end;

procedure Tfrm_Main.CheckMenuItemLanguage(sLanguage: string);
begin
  mniGerman.Checked := (sLanguage = 'de');
  mniEnglish.Checked := not(sLanguage = 'de');
end;

procedure Tfrm_Main.InitLanguage;
Var
  sPath, sLanguage: string;
begin
  try
    // Ausnahmen (empfohlen aus der Doku "GNU gettext"
    TP_GlobalIgnoreClassProperty(TControl,'HelpKeyword');
    TP_GlobalIgnoreClassProperty(TControl,'ImeName');
    TP_GlobalIgnoreClassProperty(TStringField,'FieldName');
    TP_GlobalIgnoreClassProperty(TNotebook,'Pages');
    TP_GlobalIgnoreClassProperty(TField, 'DefaultExpression');
    TP_GlobalIgnoreClassProperty(TField, 'FieldName');
    TP_GlobalIgnoreClassProperty(TField, 'KeyFields');
    TP_GlobalIgnoreClassProperty(TField, 'DisplayName');
    TP_GlobalIgnoreClassProperty(TField, 'LookupKeyFields');
    TP_GlobalIgnoreClassProperty(TField, 'LookupResultField');
    TP_GlobalIgnoreClassProperty(TField, 'Origin');
    TP_GlobalIgnoreClassProperty(TFieldDef, 'Name');

    TP_GlobalIgnoreClass(Graphics.TFont);
    TP_GlobalIgnoreClass(TParam);
    TP_GlobalIgnoreClass(TUniConnection);
    TP_GlobalIgnoreClass(TMySQLUniProvider);
    TP_GlobalIgnoreClass(TUniDataSource);
    TP_GlobalIgnoreClass(TUniQuery);
    TP_GlobalIgnoreClass(TUniSQLMonitor);
    //gnugettext.TP_GlobalIgnoreClassProperty(TCRColumn,'FieldName');
    //gnugettext.TP_GlobalIgnoreClassProperty(TComboBoxEx, 'ItemsEx');
    //gnugettext.TP_GlobalIgnoreClassProperty(TSaveTextFileDialog,'PicturePanel');
    //gnugettext.TP_GlobalIgnoreClass(TSaveTextFileDialog);
    //gnugettext.TP_GlobalIgnoreClass(TOpenTextFileDialog);
    //gnugettext.TP_GlobalIgnoreClass(TSpTBXTabSheet);
    //gnugettext.TP_GlobalIgnoreClass(TClientDataSet);

    // Domain einbinden
    sPath := ExtractFilePath(Application.ExeName) + 'locale';
    bindtextdomain(DOMAIN_HOTSEARCH36, sPath);
    AddDomainForResourceString(DOMAIN_HOTSEARCH36);
    gnugettext.DefaultInstance.textdomain(DOMAIN_HOTSEARCH36);

    // bersetze
    Translate(GetLanguage, True);
  except
    if bitfarmLog <> nil  then
      bitfarmLog.Write(llNormal, ltException, 'InitLanguage', ClassName);
  end;
end;

procedure Tfrm_Main.FormCreate(Sender: TObject);
var
//  reg: Tregistry;
//  li, cnt, i: integer;
//  ls: string;
  HotSearchIni, VierwerIni: TIniFile;
begin
  try
    InitLanguage;

    bfaCommonDB.my_Con := cntMain;
    BD.LogPath := BD.EnvTemp;
    bShowalert := False; //02.08.2018 Ticket 14677
    BD.LogName := 'HotSearch36.log';
    bitfarmLog := TbfaLog.Create;
    bitfarmLog.Init(BD.LogPath, '', llNormal, 'HotSearch36');

//13.01.2023    bitfarmLog.Write(llNormal, ltInfo, 'HotSearch gestartet version:' + appversion, ClassName);

    jtico_Main.Animate := False;
    jtico_Main.IconIndex := 0;
    tim_5min.Enabled := False;

    bfaNotificationCenter := TNotificationCenter.Create(Self); //21.04.2020

    SetLength(fHotKeyArray, 0);
    SetLength(fStorageArray, 0);
    SetLength(fArchiveArray, 0);
    SetLength(fbscreenshot, 0);
    SetLength(fbsearchlinks, 0);
    SetLength(fbsearchGDocID, 0);

    if (FileExists(BD.AppdataBitfarmPd + 'HotSearchOptions.ini')) then
    begin
      HotSearchIni := TIniFile.Create(BD.AppdataBitfarmPd + 'HotSearchOptions.ini');
      LoadHotKeys(HotSearchIni);
      // <!-- SJ 19.10.2021 - moved to LoadHotKeys
//      fProfil := inifile.ReadString('HotSearchOptions', 'Conn', '');
//      cnt := inifile.ReadInteger('HotSearchOptions', 'Count', 0);
//      for i := 0 to cnt - 1 do
//      begin
//        SetLength(fHotKeyArray, i + 1);
//        SetLength(fStorageArray, i + 1);
//        SetLength(fArchiveArray, i + 1);
//        SetLength(fbscreenshot, i + 1);
//        SetLength(fbsearchlinks, i + 1);
//
//        fHotKeyArray[i] := TJvApplicationHotKey.Create(self);
//        if i = 0 then
//          fHotKeyArray[i].hotkey := inifile.ReadInteger('HotSearchOptions', 'HotKey' + IntToStr(i), 16450)
//        else if i = 1 then
//          fHotKeyArray[i].hotkey := inifile.ReadInteger('HotSearchOptions', 'HotKey' + IntToStr(i), 49229)
//        else
//          fHotKeyArray[i].hotkey := inifile.ReadInteger('HotSearchOptions', 'HotKey' + IntToStr(i), 0);
//
//  //      if fHotKeyArray[i].HotKey = fHotKeyArray[0].HotKey then  //wenn STRG + B im Viewer umkonfiguriert wird
//  //         fHotKeyArray[0].Active := False;
//
//        fHotKeyArray[i].Active := true;
//        fHotKeyArray[i].OnHotKey := japp_HKHotKey;
//        fHotKeyArray[i].Tag := i;
//
//        fStorageArray[i] := inifile.ReadString('HotSearchOptions', 'StoreName' + IntToStr(i), '');
//        fArchiveArray[i] := inifile.ReadString('HotSearchOptions', 'ArchiveName' + IntToStr(i), '');
//        fbscreenshot[i] := inifile.ReadBool('HotSearchOptions', 'ScreenShot' +
//          IntToStr(i), False);
//        fbsearchlinks[i] := inifile.ReadBool('HotSearchOptions', 'DocLink' +
//          IntToStr(i), False);
//
//      end;
//
//      fiBaloonCounterMax := -1;
//      fbbaloonactive := true;
      // SJ 19.10.2021 - moved to LoadHotKeys -->
    end;
    // SJ 19.10.2021 - Registry raus

    FSearchProc := TbfaSearchProcessing.Create;
    FSearchObj := TbfaSearch.Create;

    // <!-- TODO: SJ 07.02.2022 - habs nur drin gelassen, damit die Arbeit nicht umsonst war...
//    try
//      try
//        fPushedResubsList := TStringList.Create;
//        fPushedResubsList.Duplicates := dupIgnore;
//        fPushedResubsList.StrictDelimiter := True;
//        fPushedResubsList.Delimiter := ';';
//        if FileExists(BD.AppdataBitfarmPd + 'Viewer.ini') then
//        begin
//          VierwerIni := TIniFile.Create(BD.AppdataBitfarmPd + 'Viewer.ini');
//          fPushedResubsList.DelimitedText := VierwerIni.ReadString('Resub', 'PushedResubs', '');
//        end;
//      except
//        if bitfarmLog <> nil then
//          bitfarmLog.Write(llNormal, ltException, 'PushedResubsList', ClassName);
//      end;
//    finally
//      if Assigned(VierwerIni) then
//        VierwerIni.Free;
//    end;
    // SJ 07.02.2022 -->
  finally
    if Assigned(HotSearchIni) then
      HotSearchIni.Free;
  end;
end;

procedure Tfrm_Main.tim_5minTimer(Sender: TObject);
begin
  try
    if fiBaloonCounterMax > 0 then
    begin
      if fiBaloonCounter > fiBaloonCounterMax then
      begin
        tim_5min.Enabled := False;
      end;
    end;

    ShowAlertWindow(_('Ihre Wiedervorlageliste hat sich gendert.'));

    inc(fiBaloonCounter);
  except
    if bitfarmLog <> nil then
      bitfarmLog.Write(llNormal, ltException, 'tim_5minTimer', ClassName);
  end;
end;

//-----------------------------------------------------------------------------
procedure Tfrm_Main.SetHint;
begin
  if fUsername = '' then
    Exit;
  try
    if High(fHotKeyArray) > 0 then //04.10.2018 wenn keine Einstellung geladen kann, dann schreibt immer Exception ins Log.
    begin
      jtico_Main.Hint := _('bitfarm HotSearch36 Tool (STRG+C) + (') +
        shortcuttotext(fHotKeyArray[0].hotkey) + ')' + ' ' + _('Benutzer:') + fUsername;           // m.frey: funzt iwie nicht
      Strgs1.Caption := _('[STRG+C] + [') +
        shortcuttotext(fHotKeyArray[0].hotkey) + ']';
    end;
  except
    if bitfarmLog <> nil then
      bitfarmLog.Write(llNormal, ltException, 'SetHint', ClassName);
  end;
end;

procedure Tfrm_Main.FullScreen(var bmp: TBitmap; MonitorNumber: Integer);
begin
  try
    Form2 := TForm2.Create(frm_Main);
    Form2.BorderStyle := bsNone;
    Form2.WindowState := wsNormal;
    Form2.Scaled := False;
    Form2.BorderIcons := [];
    Form2.DefaultMonitor := dmDesktop;

    if (MonitorNumber = 0) then
    begin
      Form2.BoundsRect := Screen.DesktopRect;
      Form2.Image1.Picture.Bitmap.Width := Screen.DesktopWidth;
      Form2.Image1.Picture.Bitmap.Height := Screen.DesktopHeight;
      Form2.Image1.Width := Screen.DesktopWidth;
      Form2.Image1.Height := Screen.DesktopHeight;
    end
    else
    begin
      Form2.BoundsRect := Screen.Monitors[MonitorNumber - 1].BoundsRect;
      Form2.Image1.Picture.Bitmap.Width := Screen.Monitors[MonitorNumber - 1].Width;
      Form2.Image1.Picture.Bitmap.Height := Screen.Monitors[MonitorNumber - 1].Height;
      Form2.Image1.Width := Screen.Monitors[MonitorNumber - 1].Width;
      Form2.Image1.Height := Screen.Monitors[MonitorNumber - 1].Height;
    end;
    Form2.Image1.Picture.Assign(bmp);
    Form2.BringToFront;
    Form2.ShowModal;
  except
    if bitfarmLog <> nil then
      bitfarmLog.Write(llNormal, ltException, 'FullScreen', ClassName);
  end;
end;

function Tfrm_Main.TakeScreenshot(var bmp: TBitmap; MonitorNumber: Integer): Boolean;
const
  CAPTUREBLT = $40000000;
var
  DesktopCanvas: TCanvas;
  DC: HDC;
  Left, Top: Integer;
begin
  Result := False;
  if (MonitorNumber > Screen.MonitorCount) then
    Exit;
  DC := GetDC(0);
  try
    if (DC = 0) then
      Exit;
    try
      if (MonitorNumber = 0) then
      begin
        Bmp.Width := Screen.DesktopWidth;
        Bmp.Height := Screen.DesktopHeight;
        Left := Screen.DesktopLeft;
        Top := Screen.DesktopTop;
      end
      else
      begin
        Bmp.Width := Screen.Monitors[MonitorNumber - 1].Width;
        Bmp.Height := Screen.Monitors[MonitorNumber - 1].Height;
        Left := Screen.Monitors[MonitorNumber - 1].Left;
        Top := Screen.Monitors[MonitorNumber - 1].Top;
      end;
    except
    	on e:Exception do
        if bitfarmLog <> nil then
          bitfarmLog.Write(llNormal, ltException,
            'Fehler bei TakeScreenshot: Zuweisung der Bildschirmgre ' + e.Message, ClassName);
    end;

    try
      DesktopCanvas := TCanvas.Create;
      try
        DesktopCanvas.Handle := DC;
        Result := BitBlt(Bmp.Canvas.Handle, 0, 0, Bmp.Width, Bmp.Height, DesktopCanvas.Handle, Left, Top, SRCCOPY or CAPTUREBLT);
        Result := True;
      finally
        DesktopCanvas.Free;
      end;
    except
    	on e:Exception do
        if bitfarmLog <> nil then
          bitfarmLog.Write(llNormal, ltException,
            'Fehler bei TakeScreenshot: Screenshot erstellen' + e.Message, ClassName);

    end;
  finally
    if (DC <> 0) then
      ReleaseDC(0, DC);
  end;
end;


procedure Tfrm_Main.getocrtext(bild: TBitmap);
var
  im: TImageEnVect;
  lsdocname, lsoutput, lsErgebnis: string;
  lst1: TstringList;
  li, lipos1, lipos2, lipos3: Integer;
  vResult: Cardinal;
  lbnocr: Boolean;
  lsCmd1, lsCmd2: string;
begin
  if fbingetocrtext then
  begin
    ShowMessage(_('OCR ist bereits in Benutzung, bitte warten Sie einige Sekunden ') + #13 + _('und versuchen Sie erneut.'));
    Exit;
  end;
  try
    try
      fbingetocrtext := True;
      try
        im := TImageEnVect.Create(nil);
        im.Bitmap.PixelFormat := pf24bit;
        im.Width := bild.Width;
        im.Height := bild.Height;
        im.Bitmap.Canvas.Brush.Style := bsSolid;
        im.Bitmap.Canvas.FillRect(Rect(0, 0, bild.Width, bild.Height));
        im.BitmapResampleFilter := rfLinear;
        im.Bitmap.Assign(bild);
        im.Proc.Resample(im.Width * 3, im.Height * 3, rfLinear);
        lsdocname := BD.EnvTemp + '\hotsearch.ppm';
        im.IO.SaveToFile(lsdocname);
      finally
        if Assigned(im) then
          FreeAndNil(im);
      end;

      lsoutput := changefileext(lsdocname, '.html');

      lsCmd1 := BD.ExeDir + 'Viewer-Files\ocroscript\ocroscript.exe';
      if bitfarmLog <> nil then
        bitfarmLog.Write(llNormal, ltInfo, PChar('getocrtext lsCmd1=' + lsCmd1), ClassName);
      if fileexists(lsCmd1) then
      begin
        lsCmd2 := BD.ExeDir + 'Viewer-Files\bats\ocroscript.bat';
        if bitfarmLog <> nil then
          bitfarmLog.Write(llNormal, ltInfo, PChar('getocrtext lsCmd2=' + lsCmd2), ClassName);
        ShellExecute_AndWait('', lsCmd2, '"' + BD.ExeDir + 'Viewer-Files\ocroscript\ocroscript.exe" recognize "' + lsdocname + '"  "' + lsoutput + '"', BD.EnvTemp, SW_show, True);
        lbnocr := True;
      end
      else
      begin
        lsCmd2 := BD.ExeDir + 'Viewer-Files\bats\ocroexec.bat';
        if bitfarmLog <> nil then
          bitfarmLog.Write(llNormal, ltInfo, PChar('getocrtext lsCmd2=' + lsCmd2), ClassName);
        if FileExists(lsCmd2) then
        begin
          if bitfarmLog <> nil then
            bitfarmLog.Write(llNormal, ltInfo, 'Exists:' + ' "' + BD.ExeDir + 'Viewer-Files\ocrocmd\ocrocmd.exe" "' + lsdocname + '"  "' + lsoutput + '"', ClassName);
          ShellExecute_AndWait('', lsCmd2, '"' + BD.ExeDir +
            'Viewer-Files\ocrocmd\ocrocmd.exe" "'
            + lsdocname + '"  "' + lsoutput + '"', BD.ExeDir, SW_hide, True);
          lbnocr := False;
        end
        else
        begin
          if bitfarmLog <> nil then
            bitfarmLog.Write(llNormal, ltException, 'ocroscript.exe oder ocroexec.bat nicht vorhanden', ClassName);
          Exit;
        end;
      end;

      lst1 := TStringList.create;
      lst1.LoadFromFile(lsoutput);
      for li := 0 to lst1.Count - 1 do
      begin
        if lbnocr then
        begin
          lipos1 := pos('class="ocr_line" title="bbox', lst1.Strings[li]);
        end
        else
        begin
          lipos1 := pos('title=' + #39 + 'bbox', lst1.Strings[li]);
        end;

        if lipos1 > 0 then
        begin
          lipos2 := posex('>', lst1.Strings[li], lipos1);
          lipos3 := posex('</span>', lst1.Strings[li], lipos2);
          if lipos3 = 0 then
          begin
            lipos3 := length(lst1.Strings[li]);
          end;
          lsErgebnis := lsErgebnis + copy(lst1.Strings[li], lipos2 + 1, lipos3 - lipos2 - 1);
        end;
      end;
      fsOCR := '';
      if Pos('&#', lsErgebnis) > 0 then
        lsErgebnis := LeftStr(lsErgebnis, Pos('&#', lsErgebnis) - 1);
      lsErgebnis := StringReplace(lsErgebnis, 'O', '0', [rfReplaceAll]);
      if Length(lsErgebnis) > 0 then
      begin
        for li := 1 to Length(lsErgebnis) do
          if (lsErgebnis[li] in ['0'..'9', '.']) then
            fsOCR := fsOCR + lsErgebnis[li];
      end;

    except
      on e: exception do
      begin
        if bitfarmLog <> nil then
          bitfarmLog.Write(llNormal, ltException, 'Fehler bei getocrtext', ClassName);
      end;
    end;
  finally
    fbingetocrtext := False;
    if Assigned(lst1) then
      FreeAndNil(lst1);

    Form2.Close;
  end;
end;

function Tfrm_Main.ShellExecute_AndWait(Operation, FileName, Parameter, Directory: string; Show: word; bWait: boolean): longint;
var
  bOK: Boolean;
  Info: TShellExecuteInfo;
{
  ****** Parameters ******
  Operation:

  edit  Launches an editor and opens the document for editing.
  explore Explores the folder specified by lpFile.
  find Initiates a search starting from the specified directory.
  open Opens the file, folder specified by the lpFile parameter.
  print Prints the document file specified by lpFile.
  properties Displays the file or folder's properties.

  FileName:

  Specifies the name of the file or object on which
  ShellExecuteEx will perform the action specified by the lpVerb parameter.

  Parameter:

  String that contains the application parameters.
  The parameters must be separated by spaces.

  Directory:

  specifies the name of the working directory.
  If this member is not specified, the current directory is used as the working directory.

  Show:

  Flags that specify how an application is to be shown when it is opened.
  It can be one of the SW_ values

  bWait:

  If true, the function waits for the process to terminate
}
begin
  FillChar(Info, SizeOf(Info), Chr(0));
  Info.cbSize := SizeOf(Info);
  Info.fMask := SEE_MASK_NOCLOSEPROCESS;
  Info.lpVerb := PChar(Operation);
  Info.lpFile := PChar(FileName);
  Info.lpParameters := PChar(Parameter);
  Info.lpDirectory := PChar(Directory);
  Info.nShow := Show;
  bOK := Boolean(ShellExecuteEx(@Info));
  if bOK then
  begin
    if bWait then
    begin
      while WaitForSingleObject(Info.hProcess, 100) = WAIT_TIMEOUT do
        Application.ProcessMessages;
      bOK := GetExitCodeProcess(Info.hProcess, DWORD(Result));
    end
    else
      Result := 0;
  end;
  if not bOK then
    Result := -1;
end;

procedure Tfrm_Main.jtico_MainDblClick(Sender: TObject);
begin
  try
    jtico_Main.Animate := False;
    jtico_Main.IconIndex := 0;
    Application.ProcessMessages;
    StartViewerWithParameters(bitfarmLog, Classname, pchar(' -W:'));
  except
    if bitfarmLog <> nil then
      bitfarmLog.Write(llDebug, ltException, 'tim_5minTimer', ClassName);
  end;
end;

procedure Tfrm_Main.LoadHotKeys(inifile: TIniFile);
var
  cnt, i: Integer;
begin
  try
    if bitfarmLog <> nil then
      bitfarmLog.Write(llDebug, ltDebug, 'LoadHotKeys', ClassName);

    if inifile = nil then
    begin
      if bitfarmLog <> nil then
        bitfarmLog.Write(llDebug, ltException, 'LoadHotKeys - inifile nil', ClassName);
      Exit;
    end;

    SetLength(fHotKeyArray, 0);
    SetLength(fStorageArray, 0);
    SetLength(fArchiveArray, 0);
    SetLength(fbscreenshot, 0);
    SetLength(fbsearchlinks, 0);
    SetLength(fbsearchGDocID, 0);

    fProfil := inifile.ReadString('HotSearchOptions', 'Conn', '');
    cnt := inifile.ReadInteger('HotSearchOptions', 'Count', 0);
    for i := 0 to cnt - 1 do
    begin
      SetLength(fHotKeyArray, i + 1);
      SetLength(fStorageArray, i + 1);
      SetLength(fArchiveArray, i + 1);
      SetLength(fbscreenshot, i + 1);
      SetLength(fbsearchlinks, i + 1);
      SetLength(fbsearchGDocID, i + 1);

      fHotKeyArray[i] := TJvApplicationHotKey.Create(Self);
      if i = 0 then
        fHotKeyArray[i].hotkey := inifile.ReadInteger('HotSearchOptions', 'HotKey' + IntToStr(i), 16450)
      else if i = 1 then
        fHotKeyArray[i].hotkey := inifile.ReadInteger('HotSearchOptions', 'HotKey' + IntToStr(i), 49229)
      else
        fHotKeyArray[i].hotkey := inifile.ReadInteger('HotSearchOptions', 'HotKey' + IntToStr(i), 0);

      fHotKeyArray[i].Active := (not IsOptionWindowVisible);
      fHotKeyArray[i].OnHotKey := japp_HKHotKey;
      fHotKeyArray[i].Tag := i;

      fStorageArray[i] := inifile.ReadString('HotSearchOptions', 'StoreName' + IntToStr(i), '');
      fArchiveArray[i] := inifile.ReadString('HotSearchOptions', 'ArchiveName' + IntToStr(i), '');
      fbscreenshot[i] := inifile.ReadBool('HotSearchOptions', 'ScreenShot' + IntToStr(i), False);
      fbsearchlinks[i] := inifile.ReadBool('HotSearchOptions', 'DocLink' + IntToStr(i), False);
      fbsearchGDocID[i] := inifile.ReadBool('HotSearchOptions', 'GDocIDSearch' + IntToStr(i), False);
    end;

    fiBaloonCounterMax := -1;
//    fbbaloonactive := True;
  except
    if bitfarmLog <> nil then
      bitfarmLog.Write(llDebug, ltException, 'LoadHotKeys', ClassName);
  end;
end;

procedure Tfrm_Main.ShowAlertWindow(Text: WideString);

  procedure ShowNewMessage(const ACaption: WideString; AMessageText: WideString);
  var
    AAlertWindow: TdxAlertWindow;
    bfaNotification: TNotification;   //21.04.2020
  begin
    if TOSVersion.Check(6, 2) then //21.04.2020 Windows 8 oder grer
    begin
      bfaNotification := frm_Main.bfaNotificationCenter.CreateNotification;
      try
        bfaNotification.Name := 'bitfarm HotSearch 362 Notification';
        bfaNotification.Title := ACaption;
        bfaNotification.AlertBody := AMessageText;

        frm_Main.bfaNotificationCenter.PresentNotification(bfaNotification);
      finally
        bfaNotification.Free;
      end;
    end
    else
    begin
      AAlertWindow := dxAlertWindowManager1.Show(ACaption, AMessageText);
      AAlertWindow.RestartDisplayTimer;
    end;

  end;

var
  Cptn: WideString;
begin
  try
    Cptn := _('Wiedervorlageliste-nderung - HotSearch36');
    ShowNewMessage(Cptn, Text);
  except
    if bitfarmLog <> nil then
      bitfarmLog.Write(llDebug, ltException, 'ShowAlertWindow', ClassName);
  end;
end;

procedure Tfrm_Main.CreateParams(var Params: TCreateParams);
begin
  inherited;
  StrCopy(Params.WinClassName, 'bitfarm.HotSearch.V36');
  SingleInst.CreateParams(Params);
end;

procedure Tfrm_Main.WndProc(var Msg: TMessage);
begin
  if not SingleInst.HandleMessages(Msg) then
    inherited;
end;


end.

