unit bfaBaseImageEN;

interface

uses
    Classes, Controls, Forms, StdCtrls,  bfaCommonUtils, ievect,
    hyiedefs, imageenproc,
    imageenio, imageenview, ieview, hyieutils, bfaImageEnMView;

//04.10.2023
//var
//  bitfarmApp: TObject = nil;

procedure CreateThumbnailView(var imgThumbnailView: TbfaImageEnMView; AOwner: TComponent;
  Prnt: TWinControl; Page: Integer = 0; ShowComponent: Boolean = True);
function CreateInvisibleScanPoolMView(AOwner: TComponent): TbfaImageEnMView;

implementation

uses
  iemview
  {$IFDEF IMAGEEN1140}
  , iexTransitions
  {$ENDIF}
  ;

procedure CreateThumbnailView(var imgThumbnailView: TbfaImageEnMView; AOwner: TComponent;
  Prnt: TWinControl; Page: Integer = 0; ShowComponent: Boolean = True);
begin
  try

    if imgThumbnailView = nil then
    begin
//      imgThumbnailView := TbfaImageEnMView.Create(AOwner);
//      with imgThumbnailView do
//      begin
//        if Prnt <> nil then
//          Parent := Prnt;
//        Align := alClient;
//        BorderStyle := bsNone;
//        BottomGap := 2;
//        DisplayMode := mdGrid;
//        EnableMultiSelect := True;
//        ScrollBars := ssVertical;
//
//        {$IFDEF IMAGEEN1140}
//        //22.05.2023 FlatScrollBars
//        {$ELSE}
//        if Prnt <> nil then
//          FlatScrollBars := True;
//        {$ENDIF}
//
//        GridWidth := 1;
//        ImageCacheSize := 10;
//        KeyInteract := [mkiMoveSelected];
//        MouseInteract := [];
//        ParentCtl3D := False;
//        SelectionColor := gclLime; //$00FFA0A0;
//        SelectionWidth := 4;
//        SelectionWidthNoFocus := 2;
//        StoreType := ietThumb;
//        Style := iemsACD;
//        ThumbnailsBackgroundStyle := iebsCropShadow;
//        ThumbnailDisplayFilter := rfFastLinear;
//        TransitionEffect := iettPushAndSqueezeDown;
//        VisibleSelection := True;
//        ThumbWidth := 66;
//        ThumbHeight := 89;
//        Tag := tagThumbnailMView;
//        ControlStyle := ControlStyle + [csDisplayDragImage];
//      end;

      imgThumbnailView := TbfaImageEnMView.Create(AOwner);

      with imgThumbnailView do
      begin
        if Prnt <> nil then
          Parent := Prnt;
        Align := alClient;
        BorderStyle := bsNone;
        DisplayMode := mdGrid;
        EnableMultiSelect := True;
        ScrollBars := ssVertical;

        GridWidth := 1;
        ImageCacheSize := 10;
        KeyInteract := [mkiMoveSelected];
        {$IFDEF ImageEn1140}
//22.05.2023        if Prnt <> nil then
//          FlatScrollBars := True;
        BottomGap := 4;
        MouseInteract := [mmiSelect];
        CheckThumbBoundsOnSelect := True;
        MultiSelectionOptions := MultiSelectionOptions + [iemoHideSelectionRect];
        Style := iemsFlat;
        FillThumbnail := False;
        // FillThumbnail := False macht die beiden berflssig...
//        ThumbnailsBackgroundStyle := iebsSolid;
//        ThumbnailsBackgroundSelected := clNone;
        // Farben siehe auch bitfarmApp.ChangePreviewSkin und bitfarmApp.DoChangeSkin
        {$ELSE}
        if Prnt <> nil then
          FlatScrollBars := True;
        BottomGap := 2;
        MouseInteract := [];
        Style := iemsACD;
        ThumbnailsBackgroundStyle := iebsDiagCross;
        SelectionWidthNoFocus := 2;
        {$ENDIF}
        ParentCtl3D := False;
        SelectionColor := gclLime;
        SelectionWidth := 4;
        StoreType := ietThumb;
        ThumbnailDisplayFilter := rfFastLinear;
        TransitionEffect := iettPushAndSqueezeDown;
        VisibleSelection := True;
        ThumbWidth := 66;
        ThumbHeight := 89;

        Tag := tagThumbnailMView;
        ControlStyle := ControlStyle + [csDisplayDragImage];
      end;
    end;
  except
    imgThumbnailView := nil;
  end;
end;

function CreateInvisibleScanPoolMView(AOwner: TComponent): TbfaImageEnMView;
var
  img: TbfaImageEnMView;
begin
  Result := nil;
  try
    img := TbfaImageEnMView.Create(AOwner);
    with img do
    begin
      Visible := False;
      Align := alClient;
//30.04.2020      BorderStyle := bsSingle;
      BorderStyle := bsNone;
      BottomGap := 2;
      DisplayMode := mdGrid;
      EnableMultiSelect := True;
      GridWidth := 1;
      ImageCacheSize := 10;
      KeyInteract := [mkiMoveSelected];
      MouseInteract := [];
      ParentCtl3D := False;
      SelectionColor := gclLime; //$00FFA0A0;
      SelectionWidth := 4;
      {$IFNDEF IMAGEEN1140}
      SelectionWidthNoFocus := 2;
      {$ENDIF}
      StoreType := ietNormal;
      Style := iemsACD;
      ThumbnailsBackgroundStyle := iebsCropShadow;
      ThumbnailDisplayFilter := rfFastLinear;
      TransitionEffect := iettPushAndSqueezeDown;
      VisibleSelection := True;

      ThumbWidth := 66;
      ThumbHeight := 89;

      Tag := tagThumbnailMView;
      ControlStyle := ControlStyle + [csDisplayDragImage];

    end;

    Result := img;
  except
    Result := nil;
  end;
end;

end.
