//-----------------------------------------------------------------------------
// Projekt:    Bitfarm-Archiv
// Entwickler: MF
// Erstellt:   2009-09-16
// Name:       u_ShDbUtils
// Typ:        Unit
// Zweck:      Utils fr einfacheren DB-Zugriff
//-----------------------------------------------------------------------------
//----------------------------------------------------------------------------}

unit bfaCommonDB;

{###############################} INTERFACE {###############################}

{$WRITEABLECONST ON}

uses
  Windows, SysUtils, Classes, Dialogs,
  Uni, gnugettext, Math, bfaCommonUtils, bfaCommonMethods;

const
   my_Con : TUniConnection = nil;  // muss vom Hauptprogramm gesetzt werden
   LastSQL : string = ''; // letzter benutzter SQL-Befehl
   LastInsertId : int64 = 0;

   // Grundfunktionen
   function DbCreateQuery:TUniQuery;
   function DbCreateCommand:TUniSQL;
//   function DbDoSql(const MyQuery:TUniQuery; Sql:string):Boolean;
//   function DbDoSkySQL(const MyQuery:TUniQuery; Sql: string): boolean;
   function DbExecSql(const MyQuery:TUniQuery; Sql:string):Boolean;
//   function DbX(Sql:string):Boolean;
//   function DbXParam(Sql,Param,Value:string):Boolean;
//   function DbXMsg(Sql,ErrMod,ErrMsg:string):Boolean;
//   function DbXLog(Sql,Msg:string):Boolean;

   function AddQuote(Par:string):string;
   function AddDblQuote(Par:string):string;

   // Etwas hherer Level
   function DbCountSql(Sql:string):integer;
   function DbTableExist(Name:string):Boolean;
   function DbTableColumnExist(Table,Column:string):Boolean;
   function DbTableColumnType(Table,Column:string):string;
   function DbTableColumnValue(Sql:string):string;
   function DbTableColumnGetString(Sql:string):string;
   function DbTableColumnGetInteger(Sql:string):integer;
   function DbGetFirstColumns(Sql:string):string;

   // noch hher  :-)
   function DBGetUserName(UserID : Integer; displayname: Boolean = False): string;
   function DBGetUsernameByIDInObjectList: TStringList;
//12.09.2024   function DBGetGroupnameByIDInObjectList: TStringList;
   function DBGetGroupName(Groupid : Integer): string;
   function DBGetUserID(UserName : string): Integer;
   function DBGetGroupID(GroupName : string): Integer;

   function DBGetDocRights(gdocid: Int64; userid : Integer): Integer;
   function DBGetUserlist(groupid : Integer = 0; ownuserid: Integer = 0; order: Boolean = False; enabled : Boolean = False; realname : Boolean = False; deleted: Boolean = False): TStringList;
   function DBGetGrouplist(userid: Integer = 0; owngroupid: Integer = 0; order: Boolean = False; enabled : Boolean = False; deleted: Boolean = False): TStringList;
   function DBGetGroupMembers(groupid: Integer): TStringList;
   function GetHolidayList(UsrId:int64; dStart, dEnde: TDateTime):string;
   {############################} IMPLEMENTATION {#############################}

//-----------------------------------------------------------------------------
function DbCreateQuery:TUniQuery;
begin
   Result := TUniQuery.Create(nil);
   Result.Connection := my_Con;
end;

function DbCreateCommand:TUniSQL;
begin
   Result := TUniSQL.Create(nil);
   Result.Connection := my_Con;
end;

function DbExecSql(const MyQuery:TUniQuery; Sql:string):Boolean;
begin
   Result:=false;
   MyQuery.SQL.Text := Sql;
   MyQuery.Execute;
end;

//-----------------------------------------------------------------------------
//function DbDoSql(const MyQuery:TUniQuery; Sql:string):Boolean;
//begin
//   result := True;
//   LastSQL:=Sql;
//   try
//      MyQuery.Active := False;
//      MyQuery.SQL.Text := Sql;
//      MyQuery.Active := True;
//      MyQuery.First;
//   except
//      on e: Exception do
//      begin
////         LogEvnt('1000    Fehler in function DbDoSql mit Query '+MyQuery.Name+ ' ' + e.message);
//         result := False;
//      end;
//   end;
//end;

//-----------------------------------------------------------------------------
//function DbDoSkySQL(const MyQuery:TUniQuery; Sql: string): boolean;
//begin
////   GgfLogevnt('DbDoSkySQL:'+MyQuery.Name+' '+Sql);
//   LastSQL:=Sql;
//   try
//      // skywalker new procedure
//      // now check if the query is active, if so just execute
//      // else close and open the query
//      MyQuery.SQL.Text := Sql;
//      // not was added cause open should be done with
//      // a query which returns only one value accord to the
//      // error message
//      if not MyQuery.Active then
//         begin
//            // Just do an execute!
//            //Execute;
//             MyQuery.Open;
//         end
//      else
//         begin
//            MyQuery.Close;
//            MyQuery.Open;
//         end;
//      MyQuery.First;
//      Result := True;
//   except
//      on e: Exception do
//      begin
////         LogEvnt('1000    ' + _('Fehler') + ' in Modul: DbDoSkySQL    ' + e.message + #13 +' '+ LastSQL);
//         Result := False;
//      end;
//   end;
//end;

//-----------------------------------------------------------------------------
//function DbX(Sql:string):Boolean;
//var lmc: TUniSQL;
//begin
//
//   result := True;
//   lmc := DbCreateCommand;
//   try
//      LastSQL:=Sql;
//      lmc.Name := 'DbX';
//      lmc.SQL.Text := Sql;
//      lmc.Execute;
//      LastInsertId := lmc.LastInsertId;
//   finally
//      lmc.Free;
//   end;
//end;

//function DbXParam(Sql,Param,Value:string):Boolean;
//var lmc: TUniSQL;
//begin
//   result := True;
//   lmc := DbCreateCommand;
//   try
//      LastSQL:=Sql;
//      lmc.Name := 'DbX';
//      lmc.SQL.Text := Sql;
//      lmc.ParamByName(Param).AsString := Value;
//      lmc.Execute;
//      LastInsertId := lmc.LastInsertId;
//   finally
//      lmc.Free;
//   end;
//end;

//-----------------------------------------------------------------------------
//function DbXMsg(Sql,ErrMod,ErrMsg:string):Boolean;
//begin
//   Result := True;
//   try
//      DbX(SQL);
//   except
//      on e: Exception do
//      begin
//         ErrorMsg(ErrMod, ErrMsg + ' ' + e.Message, 1003, True);
//         Result := False;
//      end;
//   end;
//end;

//-----------------------------------------------------------------------------
//function DbXLog(Sql,Msg:string):Boolean;
//var lsE:string;
//begin
//   Result := True;
//   try
//      DbX(SQL);
//   except
//      on e: Exception do
//      begin
//         lsE := StringReplace(Msg, '%e%', e.Message, [rfReplaceAll]);
////         Logevnt(lsE);
//         Result := False;
//      end;
//   end;
//end;

//-----------------------------------------------------------------------------
function AddQuote(Par:string):string;
begin
   Result := #39 + Par + #39;
end;

function AddDblQuote(Par:string):string;
begin
   Result := #34 + Par + #34;
end;


//-----------------------------------------------------------------------------
// Routinen etwas hherer Level
//-----------------------------------------------------------------------------

// Zhlt Reihen einer Abfrage - Parameter ist Abfrage ab incl 'from'
function DbCountSql(Sql:string):integer;
var lmq: TUniQuery;
begin
   Result:=0;
   lmq := DbCreateQuery;
   try
      LastSQL:=Sql;
      try
         lmq.SQL.Text := 'select count(*) '+Sql;
         lmq.Execute;
         Result:=lmq.fields[0].asinteger;
      except
         on e: Exception do
         begin
//            LogEvnt('1000    Fehler in function DbCountSql mit Abfrage '+Sql+ ' ' + e.message);
         end;
      end;
   finally
      lmq.Free;
   end;
end;

//-----------------------------------------------------------------------------
function DbTableExist(Name:string):Boolean;
var lmq: TUniQuery;
begin
   lmq := DbCreateQuery;
   try
      // Prfen ob die Tabelle da ist.
      LastSQL:='show tables like ' +#39+ Name +#39;
      DbExecSql(lmq,LastSQL);
      Result:=lmq.recordcount > 0;
   finally
      lmq.Free;
   end;
end;

//-----------------------------------------------------------------------------
// Prft ob eine Spalte in einer Tabelle da ist
// es wird nicht geprft ob die Tabelle berhaupt da ist. Was passiert wenn nicht ist undefiniert.
function DbTableColumnExist(Table,Column:string):Boolean;
var lmq: TUniQuery;
begin
   lmq := DbCreateQuery;
   try
      LastSQL := 'select * from '+Table+' where 1=2'; // Leere Menge holen
      DbExecSql(lmq,LastSQL);
      Result := lmq.FieldDefList.Find(Column) <> nil;
   finally
      lmq.Free;
   end;
end;

//-----------------------------------------------------------------------------
// Holt den Typ einer Spalte
// es wird nicht geprft ob die Tabelle berhaupt da ist. Was passiert wenn nicht ist undefiniert.
function DbTableColumnType(Table,Column:string):string;
var lmq: TUniQuery;
begin
   Result := '';
   lmq := DbCreateQuery;
   try
      LastSQL := 'SHOW COLUMNS from '+Table+' like '+#39+Column+#39;
      DbExecSql(lmq,LastSQL);
      Result := lmq.FieldByName('type').AsString;
   finally
      lmq.Free;
   end;
end;

//-----------------------------------------------------------------------------
// Holt das erste Feld der ersten Spalte in einer Tabelle
// es wird nicht geprft ob die Tabelle berhaupt da ist. Was passiert wenn nicht ist undefiniert.
// Im gegensatz zu den zwei vorigen wird hier ein kompletter SQL Query angegeben.
// Beispiel "select Options from sys_arc where
// todo: umbenennen
function DbTableColumnValue(Sql:string):string;
var lmq: TUniQuery;
begin
   lmq := DbCreateQuery;
   try
      LastSQL := Sql;
      DbExecSql(lmq,LastSQL);
      Result := lmq.fields[0].AsString;
   finally
      lmq.Free;
   end;
end;

// das gleiche mit Fehlerbehandlung, dann Leerstring
function DbTableColumnGetString(Sql:string):string;
begin
   try
      result := DbTableColumnValue(Sql);
   except
      on e: Exception do
      begin
         result := '';
      end;
   end;
end;

// das gleiche mit integer, dann -1
function DbTableColumnGetInteger(Sql:string):integer;
var lmq: TUniQuery;
begin
   try
      lmq := DbCreateQuery;
      try
         LastSQL := Sql;
         DbExecSql(lmq,LastSQL);
         Result:=lmq.fields[0].AsInteger;
      finally
         lmq.Free;
      end;
   except
      on e: Exception do
      begin
         result := -1;
      end;
   end;
end;


//-----------------------------------------------------------------------------
// Holt das alle Werte vom ersten Spalte einer Abfrage
// es wird nicht geprft ob die Tabelle berhaupt da ist. Was passiert wenn nicht ist undefiniert.
// Alle Werte werden kommagetrennt zurckgegeben
// Beispiel:
function DbGetFirstColumns(Sql:string):string;
var lmq: TUniQuery; ls:string;
begin
   lmq := DbCreateQuery;
   try
      LastSQL := Sql;
      DbExecSql(lmq,LastSQL);
      while not lmq.Eof do
      begin
         ls:=lmq.fields[0].AsString;
         if length(Result) > 0 then
            Result := Result + ',' + ls
         else
            Result := ls;
         lmq.Next;
      end;
   finally
      lmq.Free;
   end;
end;

function DBGetUserName(UserID : Integer; displayname: Boolean = False): string;
begin
  if displayname then
  begin
	  Result := DbTableColumnGetString('select displayname from sys_user where userid = ' + inttostr(UserID));
    if Trim(Result) = '' then
	    Result := DbTableColumnGetString('select username from sys_user where userid = ' + inttostr(UserID));
  end else
	  Result := DbTableColumnGetString('select username from sys_user where userid = ' + inttostr(UserID));
end;


function DBGetUsernameByIDInObjectList: TStringList;
var
  qry: TUniQuery;
begin
  try
    try
      Result := TStringList.Create;
      qry := TUniQuery.Create(nil);
      qry.Connection := my_Con;
      qry.SQL.Text := 'select username, userid from sys_user';
      qry.Open;
      qry.First;
      while not qry.Eof do
      begin
        Result.AddObject(qry.FieldByName('username').AsString, TObject(qry.FieldByName('userid').AsInteger));
        qry.Next;
      end;
    except
      Result := nil;
    end;
  finally
    FreeAndNil(qry);
  end;
end;

//12.09.2024
//function DBGetGroupnameByIDInObjectList: TStringList;
//var
//  qry: TUniQuery;
//begin
//  try
//    try
//      Result := TStringList.Create;
//      qry := TUniQuery.Create(nil);
//      qry.Connection := my_Con;
//      qry.SQL.Text := 'select groupname, groupid from sys_group';
//      qry.Open;
//      qry.First;
//      while not qry.Eof do
//      begin
//        Result.AddObject(qry.FieldByName('groupname').AsString, TObject(qry.FieldByName('groupid').AsInteger));
////16.09.2024        Result.AddObject(TranslateGroupName(qry.FieldByName('groupname').AsString), TObject(qry.FieldByName('groupid').AsInteger));
//        qry.Next;
//      end;
//    except
//      Result := nil;
//    end;
//  finally
//    FreeAndNil(qry);
//  end;
//end;

function DBGetGroupName(Groupid : Integer): string;
begin
	Result := DbTableColumnGetString('select groupname from sys_group where groupid = ' + inttostr(Groupid));
end;

function DBGetUserID(UserName : string): Integer;
begin
	Result := DbTableColumnGetInteger('select userid from sys_user where username = ' +#39+ UserName +#39);
end;

function DBGetGroupID(GroupName : string): Integer;
begin
  //16.09.2024 --> wegen All (Built-In)
  if GroupName = sCaptionAllBuiltIn then
    GroupName := 'Alle (Builtin)';
  //16.09.2024 <--
	Result := DbTableColumnGetInteger('select groupid from sys_group where groupname = ' +#39+ GroupName +#39);
end;

function DBGetDocRights(gdocid: Int64; userid : Integer): Integer;
begin
	Result := DbTableColumnGetInteger('Select Sql_No_cache bit_or(rights) as rechte from sys_docxs where userid = ' + IntToStr(userid) +
         ' and gdocid = ' + IntToStr(gdocid) + ' Group by gdocid, rights, userid');
end;

function DBGetUserlist(groupid: Integer = 0; ownuserid: Integer = 0; order: Boolean = False;
  enabled: Boolean = False; realname: Boolean = False; deleted: Boolean = False): TStringList;
var
  lmq: TUniQuery;
  ls: string;
begin
   Result := TStringList.Create;
   lmq := DbCreateQuery;
   try
      if groupid = 0 then
      begin
        LastSQL := 'select username, displayname, userid, flags +0 from sys_user';
        if ownuserid <> 0 then
          LastSQL := LastSQL +  ' where userid <> ' + IntToStr(ownuserid);
      end else
      begin
        LastSQL := 'select username, displayname, u.userid, flags +0 from sys_user as u left join sys_groupuser as g on u.userid = g.userid where g.groupid = ' + IntToStr(groupid);
        if ownuserid <> 0 then
          LastSQL := LastSQL +  ' and userid <> ' + IntToStr(ownuserid);
      end;
      DbExecSql(lmq,LastSQL);
      while not lmq.Eof do
      begin
        if enabled and (lmq.Fields[3].AsInteger and 1 = 0) then
        begin
          lmq.Next;
          Continue;
        end;

        if deleted and (lmq.Fields[3].AsInteger and 2 = 2) then
        begin
          lmq.Next;
          Continue;
        end;

        if realname then
          ls := lmq.fields[0].AsString
        else begin
           if lmq.Fields[1].AsString <> '' then
             ls := lmq.Fields[1].AsString
           else
             ls := lmq.fields[0].AsString;
        end;

        if (ls <> 'System') {and (ls <> 'DMSAdmin')} then
         Result.AddObject(ls,TObject(lmq.Fields[2].AsInteger));

        lmq.Next;
      end;

      if order then
        Result.Sort;

   finally
      lmq.Free;
   end;
end;
//-----------------------------------------------------------------------------
function DBGetGrouplist(userid: Integer = 0; owngroupid: Integer = 0; order: Boolean = False; enabled : Boolean = False; deleted: Boolean = False): TStringList;
var lmq: TUniQuery; ls:string;
begin
   Result := TStringList.Create;
   lmq := DbCreateQuery;
   try
      if userid = 0 then
      begin
        LastSQL := 'select groupname, groupid, flags +0 from sys_group';
        if owngroupid <> 0 then
          LastSQL := LastSQL +  ' where userid <> ' + IntToStr(owngroupid);
      end else
      begin
        LastSQL := 'select groupname, userid from sys_group as u left join sys_groupuser as g on u.groupid = g.groupid where g.userid = ' + IntToStr(userid);
        if owngroupid <> 0 then
          LastSQL := LastSQL +  ' and groupid <> ' + IntToStr(owngroupid);
      end;
      DbExecSql(lmq, LastSQL);
      while not lmq.Eof do
      begin
        if enabled and (lmq.Fields[2].AsInteger and 1 = 0) then
        begin
          lmq.Next;
          Continue;
        end;

        if deleted and (lmq.Fields[2].AsInteger and 2 = 2) then
        begin
          lmq.Next;
          Continue;
        end;

         ls := lmq.fields[0].AsString;
         Result.AddObject(ls,TObject(lmq.Fields[1].AsInteger));
         lmq.Next;
      end;

      if order then
        Result.Sort;

   finally
      lmq.Free;
   end;
end;

function DBGetGroupMembers(groupid: Integer): TStringList;
var lmq: TUniQuery;
ls, sql: string;
begin
   Result := TStringList.Create;
   lmq := DbCreateQuery;
   try
      sql := 'select * from sys_groupuser as g left join sys_user as u on g.userid = u.userid where flags & 2 = 0 and groupid = ' + IntToStr(groupid);
      DbExecSql(lmq, sql);
      while not lmq.Eof do
      begin
        Result.Add(lmq.FieldByName('userid').AsString);
        lmq.Next;
      end;
   finally
      lmq.Free;
   end;
end;


function  GetHolidayList(UsrId:int64; dStart, dEnde: TDateTime):string;
   // Rekursive procedure
   procedure AddHolidayList(const UsrId:string; dStart, dEnde: TDateTime; var List:string);
   var lmq: TUniQuery; ls, lsSql:string;  p:integer; lbNoDate: Boolean;
   begin
      lbNoDate  := isNaN(dStart); // = cDateTimeUndefined;
      lmq := DbCreateQuery;
      try
         lsSql := 'SELECT * FROM sys_holiday ' +
                  'where (userid_dst = '+UsrId+')';
         if not lbNoDate then
            begin
               lsSql := lsSql + ' and ((start <= :dEnde) and (end >= :dStart)) and (end >= :dEnde)';
            end;
         lmq.SQL.Text := lsSql;
         if not lbNoDate then
            begin
               lmq.ParamByName('dStart').AsDateTime := dStart;
               lmq.ParamByName('dEnde').AsDateTime := dEnde;
            end;
         try
	         lmq.Execute;
         except
            begin
//	         	LogEvnt(_('Fehler bei GetHolydayList'));
               Exit;
            end;
         end;
         while not lmq.Eof do
         begin
            //ls := lmq.fields[0].AsString; // eine UstId holen
            ls := lmq.FieldByName('userid_src').AsString; // eine UstId holen
            p := Pos(','+ls+',', List); // Id in Liste suchen
            if p = 0 then
            begin
               // Vertreter zur Liste hinzu
               List := List + ls + ',';
               // Vertreter der Vertreter hinzu
               if lbNoDate then
                  begin
                     dStart := cDateTimeUndefined;
                     dEnde := cDateTimeUndefined;
                  end
               else
                  begin
                     dStart := lmq.ParamByName('dStart').AsDateTime;
                     dEnde := lmq.ParamByName('dEnde').AsDateTime;
                  end;
               AddHolidayList(ls, dStart, dEnde, List);
            end;
            lmq.Next;
         end;
      finally
         lmq.Free;
      end;
   end;

var lsGUsrID: string;
begin
   lsGUsrID := IntToStr(UsrId);
   Result := ','+lsGUsrID+','; // fr einfache Suche vorne auch ein Komma hin, wird am Schlu entfernt
   AddHolidayList(lsGUsrID, dStart, dEnde, Result);
   Result := copy(Result,2,length(Result)-2); // Komma vorne und hinten (wieder) weg
end;

end.

