unit bfaCommonDevExpress;

interface

uses
  cxGraphics, cxImage, cxButtons, ComCtrls;//cxTL;

  procedure AddResourceImageToImageList(imgList: TcxImageList; ImageName, Typ: String);
  procedure AddResourceImageToImage(img: TcxImage; ImageName, Typ: String);
  procedure AddResourceImageToButton(btn: TcxButton; ImageName, Typ: String);
//  procedure DrawTreeImages(tn: TcxTreeListNode);
  procedure DrawTreeImages(tn: TTreeNode);

var
  ctlGeneral: TcxEditStyleController = nil;
  ctlGeneralTextHighlighted: TcxEditStyleController = nil;
  ctlModified: TcxEditStyleController = nil;
  ctlModifiedTextHighlighted: TcxEditStyleController = nil;
  ctlRequired: TcxEditStyleController = nil;
  ctlRequiredTextHighlighted: TcxEditStyleController = nil;
  ctlDisabled: TcxEditStyleController = nil;
  ctlDisabledTextHighlighted: TcxEditStyleController = nil;
  ctlRedBackground: TcxEditStyleController = nil;
  ctlGeneralSearch: TcxEditStyleController = nil;
  ctlWhite: TcxEditStyleController = nil;
  stlControl: TcxStyle = nil;
  stlControlNoRight: TcxStyle = nil;
  stlControlRequired: TcxStyle = nil;
  stlControlModified: TcxStyle = nil;
  stlColumn: TcxStyle = nil;
  stlUrgent: TcxStyle = nil;
  stlUrgentSelected: TcxStyle = nil;
  stlWork: TcxStyle = nil;
  stlWorkSelected: TcxStyle = nil;
  stlDone: TcxStyle = nil;
  stlDoneSelected: TcxStyle = nil;
  stlFree: TcxStyle = nil;
  stlSelected: TcxStyle = nil;
  stlProgress: TcxStyle = nil;
  stlProgressSelected: TcxStyle = nil;
  stlGroupByBoxStyle: TcxStyle = nil;
  stlBackgroundStyle: TcxStyle = nil;
  stlTreeview: TcxStyle = nil;
  stlTreeViewSelected: TcxStyle = nil;
  stlImageEn: TcxStyle = nil;
  stlImageEnSelected: TcxStyle = nil;

implementation

{$R '..\..\IMAGE\RES\bfaGUI\bfaGUIIcons.RES'}

uses 
  Graphics, PNGImage, bfaCommonUtils, SysUtils, bfaBaseObjects;

//
procedure AddResourceImageToImageList(imgList: TcxImageList; ImageName, Typ: String);  
var
  BMPImg: TBitmap;
  PNGImg: TPngImage;
begin
  try
    BMPImg:= TBitmap.Create;

    if Typ = sSysBMP then
    begin
      BMPImg.LoadFromResourceName(hInstance, ImageName);
      imgList.AddMasked(BMPImg, BMPImg.TransparentColor);
    end
    else if Typ = sSysPNG then
    begin
      try
        PNGImg:= TPngImage.Create;
        PNGImg.LoadFromResourceName(hInstance, ImageName);
        BMPImg.Assign(PNGImg);
        imgList.AddMasked(BMPImg, BMPImg.TransparentColor);
      finally
        FreeAndNil(PNGImg);
      end;
    end;
  finally
    FreeAndNil(BMPImg);
  end;
end;
//
procedure AddResourceImageToImage(img: TcxImage; ImageName, Typ: String);  
var
  BMPImg: TBitmap;
  PNGImg: TPngImage;
begin
  img.Clear;
  if Typ = sSysBMP then
  begin
    try
      BMPImg:= TBitmap.Create;
      img.Picture.Bitmap.LoadFromResourceName(hInstance, ImageName);
    finally
      FreeAndNil(BMPImg);
    end;
  end
  else if Typ = sSysPNG then
  begin
    try
      PNGImg:= TPngImage.Create;
      PNGImg.LoadFromResourceName(hInstance, ImageName);
      img.Picture.Assign(PNGImg);
    finally
      FreeAndNil(PNGImg);
    end;
  end;
end;
//
procedure AddResourceImageToButton(btn: TcxButton; ImageName, Typ: String); 
var
  BMPImg: TBitmap;
  PNGImg: TPngImage;
begin
  btn.Glyph:= nil;
  try
    if Typ = sSysBMP then
    begin
      try
        BMPImg:= TBitmap.Create;
        btn.Glyph.LoadFromResourceName(hInstance, ImageName);
      finally
        FreeAndNil(BMPImg);
      end;
    end
    else if Typ = sSysPNG then
    begin
      try
        PNGImg:= TPngImage.Create;
        PNGImg.LoadFromResourceName(hInstance, ImageName);
        btn.Glyph.Assign(PNGImg);
      finally
        FreeAndNil(PNGImg);
      end;
    end;
  except

  end;
end;
//
//procedure DrawTreeImages(tn: TcxTreeListNode);
procedure DrawTreeImages(tn: TTreeNode);
var
  bfaTreeNodeData: PbfaTreeNodeData;
  ico: Integer;
begin
  bfaTreeNodeData:= PbfaTreeNodeData(tn.Data) ;
  if (bfaTreeNodeData.Obj.ObjType = otRoot) then
  begin
    ico:= icoRoot;
  end
  else if (bfaTreeNodeData.Obj.ObjType = otMandant) then
  begin
    ico:= icoMandant;
  end
  else if (bfaTreeNodeData.Obj.ObjType = otStore) then
  begin
    if (bfaTreeNodeData.IconIndex = 0) or (bfaTreeNodeData.IconIndex = -1) then
      ico:= icoStore
    else if (bfaTreeNodeData.IconIndex = 1) then
      ico:= icoStore_red
    else if (bfaTreeNodeData.IconIndex = 2) then
      ico:= icoStore_blue
    else if (bfaTreeNodeData.IconIndex = 3) then
      ico:= icoStore_green
    else if (bfaTreeNodeData.IconIndex = 4) then
      ico:= icoStore_grey
    else if (bfaTreeNodeData.IconIndex = 5) then
      ico:= icoStore_yellow
    else if (bfaTreeNodeData.IconIndex = 6) then
      ico:= icoStore_violet
    else if (bfaTreeNodeData.IconIndex = 7) then
      ico:= icoStore_orange;  
  end
  else if (bfaTreeNodeData.Obj.ObjType = otArchive) then
  begin
    if (bfaTreeNodeData.IconIndex = 0) or (bfaTreeNodeData.IconIndex = -1) then
      ico:= icoArchive
    else if (bfaTreeNodeData.IconIndex = 1) then
      ico:= icoArchive_red
    else if (bfaTreeNodeData.IconIndex = 2) then
      ico:= icoArchive_blue
    else if (bfaTreeNodeData.IconIndex = 3) then
      ico:= icoArchive_green
    else if (bfaTreeNodeData.IconIndex = 4) then
      ico:= icoArchive_grey
    else if (bfaTreeNodeData.IconIndex = 5) then
      ico:= icoArchive_yellow
    else if (bfaTreeNodeData.IconIndex = 6) then
      ico:= icoArchive_violet
    else if (bfaTreeNodeData.IconIndex = 7) then
      ico:= icoArchive_orange;  
  end
  else if (bfaTreeNodeData.Obj.ObjType = otRecordArchive) then
  begin
    if (bfaTreeNodeData.IconIndex = 0) or (bfaTreeNodeData.IconIndex = -1) then
      ico:= icoRecordArchive
    else if (bfaTreeNodeData.IconIndex = 1) then
      ico:= icoRecordArchive_red
    else if (bfaTreeNodeData.IconIndex = 2) then
      ico:= icoRecordArchive_blue
    else if (bfaTreeNodeData.IconIndex = 3) then
      ico:= icoRecordArchive_green
    else if (bfaTreeNodeData.IconIndex = 4) then
      ico:= icoRecordArchive_grey
    else if (bfaTreeNodeData.IconIndex = 5) then
      ico:= icoRecordArchive_yellow
    else if (bfaTreeNodeData.IconIndex = 6) then
      ico:= icoRecordArchive_violet
    else if (bfaTreeNodeData.IconIndex = 7) then
      ico:= icoRecordArchive_orange;
  end
  else if (bfaTreeNodeData.Obj.ObjType = otGroup) then
  begin
    ico:= icoGroup;
  end
  else if (bfaTreeNodeData.Obj.ObjType = otUser) then
  begin
    ico:= icoUser;
  end
  else if (bfaTreeNodeData.Obj.ObjType = otAdditionalField) then
  begin
    ico:= icoAdditionalField;
  end
  else if (bfaTreeNodeData.Obj.ObjType = otStatusField) then
  begin
    ico:= icoStatusField;
  end
  else if (bfaTreeNodeData.Obj.ObjType = otUserContainer) then
  begin
    ico:= icoUserContainer;
  end
  else if (bfaTreeNodeData.Obj.ObjType = otAddFieldContainer) then
  begin
    ico:= icoAddStsContainer;
  end;
  
  tn.ImageIndex:= ico;
  tn.SelectedIndex:= ico;  
end;
//


end.
