unit bfaCommonImageEN;

interface

uses
  Graphics, Classes, Controls, Types, Generics.Collections, ievect,
  hyiedefs, imageenproc, SpTBXControls, bfaBaseObjects, bfaPreview36,
  bfaThreadedThumbnail, bfaBasePreview, bfaObjects36, //09.11.2018 bfaApplication,
  bfaBaseImageEN, gnugettext, SplashForm, bfaImageEnVect, bfaImageEnMView
  ;

const
  MINTHUMBWIDTH = 120;
  MINTHUMBHEIGHT = 120;
  MAXTHUMBWIDTH = 500;
  MAXTHUMBHEIGHT = 500;

function PrvKindToStr(Value: TbfaPreviewKind): string;

function IsImageFile(Filename: WideString): Boolean;

procedure CreateThumbnailWithAnno(img_DocView: TbfaImageEnVect; prev: TbfaPreview; Doc: TbfaDocument; WithAnno: Boolean = True);

function CreateEmptyImage(img: TbfaImageEnVect; Ext: WideString; TranspColor: TColor) : Boolean;

procedure CreateHourglassImage(img: TbfaImageEnVect; TranspColor: TColor);

procedure IETextOut(Canvas: TCanvas; x, y: integer; angle: integer; const Text: string; FontSize: Integer; BColor, Color: TColor; FontName: TFontName; FontStyle: TFontStyles);

procedure CreateTransparentBitmap(var Bmp: Graphics.TBitmap; Left, Top, Width, Height: Integer; TranspColor: TColor);

procedure ResizeBitmap(Bitmap: Graphics.TBitmap; Width, Height: Integer; TranspColor: TColor);

procedure DrawOneImage(AThread: TThread; Doc: TbfaDocument; imgpos: Integer; prev: TbfaPreview; RefreshOnly: Boolean = False);

function CompareDocumentsByID(Doc1, Doc2: TbfaDocument): Boolean;

function CompareDocuments(Doc1, Doc2: TbfaDocument): Boolean;

procedure RefreshPageInThumbnails(AThread: TThread; Doc: TbfaDocument; ActPrev: TbfaPreview; Page: Integer; Bmp: Graphics.TBitmap);

procedure RefreshDocumentInPreviews(AThread: TThread; Doc: TbfaDocument;
  ActPrev1, ActPrev2: TbfaPreview; OnlyObjects: Boolean = False;
  SetInProcess: Boolean = False; ReloadThumbnails: Boolean = False);

procedure RefreshMainMultiView(AThread: TThread; prev: TbfaPreview; Lst: TList<TbfaDocument>; Add: Boolean; splForm : TfrmSplash; maxcnt : Integer = -1);

procedure CreateThumbnailView(var imgThumbnailView: TbfaImageEnMView; AOwner: TComponent; Prnt: TWinControl; Page: Integer = 0; ShowComponent: Boolean = True);

procedure CreateMultiView(var imgMultiView: TbfaImageEnMView; AOwner: TComponent; Prnt: TWinControl; Width: Integer = MINTHUMBWIDTH; Height: Integer = MINTHUMBHEIGHT);

function CreateInvisibleMView(AOwner: TComponent): TbfaImageEnMView;

function CreateInvisibleScanPoolMView(AOwner: TComponent): TbfaImageEnMView;

function CreateInvisibleVect(AOwner: TComponent): TbfaImageEnVect;

procedure MViewDragDrop(AThread: TThread; Sender, Source: TObject; X, Y: Integer; Move: Boolean;
  imgpos: Integer = -1; Add: Boolean = False; splForm : TfrmSplash = nil);

//09.11.2018 function AddPagesToDocument(AThread: TThread; srcDragObj: TbfaDragObject;
function AddPagesToDocument(AThread: TThread; srcDragObj: TObject;
  Move: Boolean; sen, src: TbfaImageEnMView; imgpos: Integer = -1; targetDoc: TbfaDocument = nil; Add: Boolean = False): TbfaDocument;

function DeletePagesFromDocument(AThread: TThread; sen: TbfaImageEnMView; SelectedPages: TStringList; ActDoc: TbfaDocument): TbfaDocument;

procedure CompressImage(var iColors: Integer; imgTmp: TbfaImageEnVect; imgM: TbfaImageEnMView = nil; idx: Integer = -1; DoCompress: Boolean = False);

function MergeDocuments(AThread: TThread;  //srcDragObj : TbfaDragObject;
  srcDragObj: TList<TbfaDocument>; targetDoc: TbfaDocument; splForm : TfrmSplash): TbfaDocument;

//03.07.2023function CreateEmptyDocument(prev: TbfaPreview; idx: Integer = -1): TbfaDocument;

procedure MoveDocsBetweenCollections(sen: TbfaImageEnMView; imgpos: Integer; SList: TStringList; prev: TbfaPreview);

function CheckSource(Source: TObject): Boolean;

function CheckSameDocument(Sender, Source: TObject): Boolean;

function DeleteDocumentFromList(AThread: TThread; List: TList<TbfaDocument>; idx: Integer): Boolean;

function CheckIfImageAtMousePos(MView: TbfaImageEnMView): Integer;

function CheckIfAllDocumentsPreviewChanged(List: TList<TbfaDocument>; image: Boolean): Boolean;

function DropZoneDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState): Boolean;

function DrawOneThumbWithAnnos(Fimg: TbfaImageEnVect): Boolean;

function DrawOneThumbWithFtxPos(Fimg: TbfaImageEnVect): Boolean;

function RefreshOneThumbWithAnnos(DocView: Tfrm_Voransicht; ActiveDoc: TbfaDocument; Page: Integer; Layer: Int64; ThumbnailView: TbfaImageEnMView; Grad: Integer = -1): Boolean;

//23.05.2017 procedure ChangeDocName(AThread: TThread; Doc: TbfaDocument; prev: TbfaPreview);
procedure ChangeDocName(AThread: TThread; Docs: TList<TbfaDocument>; prev: TbfaPreview);

procedure SaveNewDocName(AThread: TThread; Doc: TbfaDocument; Save: Boolean; prev: TbfaPreview);

procedure InsertOneImage(imgSen, imgSrc: TbfaImageEnMView; BitmapIdx: Integer; var imgp: Integer);

procedure AutoCrop(Proc: TImageEnProc; CutCol: TRGB; ColRange, MaxCutPer, CutPer: byte);

function IsDocumentInOtherPreview(prev: TbfaPreview; Doc: TbfaDocument): Boolean;

procedure CreateBitmapOnePage(OldBmp: Graphics.TBitmap; var NewBmp: Graphics.TBitmap; W, H: Integer);

procedure CreateBitmapMorePages(OldBmp: Graphics.TBitmap; var NewBmp: Graphics.TBitmap; W, H: Integer);

procedure CloneThumbnailViewFromScanPoolview(var ThumbnailView: TbfaImageEnMView; ScanPoolView: TbfaImageEnMView; Doc: Tbfadocument);

implementation

uses
  SysUtils, Windows, Dialogs, Forms, StdCtrls, ShellAPI, imageenio,
  imageenview, ieview, hyieutils, bfaCommonUtils, bfaProcessing,
  MainDataModule, bfaIconsDM, SpTBXDkPanels, bfaCommonMethods, bfaCommonDialogs, bfaCommonStyles,
  DateUtils, bfaApplication, bfaLog, iemview
  {$IFDEF IMAGEEN1140}
  , iexBitmaps, iexTransitions
  {$ENDIF}
  ;

var
  CommonImg_CS: TRTLCriticalSection;

(*10.06.2015 *)
function PrvKindToStr(Value: TbfaPreviewKind): string;
begin
  if Value = pvkSingle then
    Result := 'pvkSingle'
  else if Value = pvkMulti then
    Result := 'pvkMulti'
  else if Value = pvkMultiSingle then
    Result := 'pvkMultiSingle';
end;
//

function IsImageFile(Filename: WideString): Boolean;
var
  Ext: string;
begin
  try
    Ext := ExtractFileExt(Filename);

    if ((LowerCase(Ext) = '.gif') or (LowerCase(Ext) = '.tif') or
        (LowerCase(Ext) = '.tiff') or (LowerCase(Ext) = '.bmp') or
        (LowerCase(Ext) = '.jpg') or (LowerCase(Ext) = '.jpeg') or
        (LowerCase(Ext) = '.png') or (LowerCase(Ext) = '.ico') ) then
    begin
      Result := True;
    end
    else
      Result := False;

  except
    Result := False;
  end;
end;

procedure CloneThumbnailViewFromScanPoolview(var ThumbnailView: TbfaImageEnMView; ScanPoolView: TbfaImageEnMView; Doc: TbfaDocument);
var
  iebmp, iebmp2: TIEBitmap;
  bmp: Graphics.TBitmap;
  k, idx, i: Integer;
  Anno: TbfaAnnotation;
  Fimg: TbfaImageEnVect;
begin
  try
    if ThumbnailView = nil then
      CreateThumbnailView(ThumbnailView, nil, nil)
    else
      ThumbnailView.Clear;

    if ScanPoolView.ImageCount > 0 then
    begin
      ThumbnailView.LockPaint;
      try
        for k := 0 to ScanPoolView.ImageCount - 1 do
        begin
          iebmp := TIEBitmap.Create;
          bmp := Graphics.TBitmap.Create;
          try
            Anno := Doc.GetAnnotation(k, 0, idx);
            if (Anno <> nil) and (idx > -1) then
            begin
              Fimg := CreateInvisibleVect(nil);
              try
                Fimg.IO.Params.ImageIndex := 0;
                iebmp2 := TIEBitmap.Create;
                try
                  Doc.ScanPoolView.CopyToIEBitmap(k, iebmp2);
                  {$IFDEF ImageEN1140}
                  Fimg.Bitmap.Assign(iebmp2.VclBitmap);
                  {$ELSE}
                  Fimg.IO.Bitmap.Assign(iebmp2.VclBitmap);
                  {$ENDIF}
                finally
                  FreeandNil(iebmp2);
                end;
                if DrawOneThumbWithAnnos(Fimg) then
                  iebmp.Assign(Fimg.Bitmap)
                else
                  ScanPoolView.CopyToIEBitmap(k, iebmp);
              finally
                Fimg.RemoveAllObjects;
                Fimg.Clear;
//29.08.2023 -->
//                //10.05.2023 -->
////                try
////                  for i := Fimg.LayersCount - 1 downto 0 do
////                    Fimg.Layers[i].Free;
////                  Fimg.SelectionMask.Free;
////                except
////                end;
//                Fimg.Free;
//                //10.05.2023 <--
                {$IFDEF IMAGEEN_SYNCHRONIZED}
                Fimg.Free;
                {$ELSE}
                try
                  for i := Fimg.LayersCount - 1 downto 0 do
                    Fimg.Layers[i].Free;
                  Fimg.SelectionMask.Free;
                except
                end;
                {$ENDIF}
//29.08.2023 <--

                Fimg := nil;
              end;
            end
            else
              ScanPoolView.CopyToIEBitmap(k, iebmp);

            ThumbnailView.InsertImageEx(k);
            ThumbnailView.SetIEBitmap(k, iebmp);

            ThumbnailView.Mio.Params[k].TIFF_Compression := ScanPoolView.MIO.Params[k].TIFF_Compression;
            ThumbnailView.Mio.Params[k].BitsPerSample := ScanPoolView.MIO.Params[k].BitsPerSample;
            ThumbnailView.Mio.Params[k].SamplesPerPixel := ScanPoolView.MIO.Params[k].SamplesPerPixel;
          finally
            FreeAndNil(iebmp);
            FreeAndNil(bmp);
          end;

        end;
      finally
        ThumbnailView.UnLockPaint;
        ThumbnailView.Update;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, '', 'bfaCommonImageEN');
  end;
end;

procedure CreateThumbnailWithAnno(img_DocView: TbfaImageEnVect; prev: TbfaPreview;
  Doc: TbfaDocument; WithAnno: Boolean = True);
var
  idx, idx2, i, k, l, j: integer;
  AnnoObj: TbfaAnnotation;
  Fimg: TbfaImageEnVect;
  foundFtx, found: Boolean;
  iebmp2 : TIEBitmap;
begin
  try
    Fimg := CreateInvisibleVect(nil);
    try
      if (Doc.ScanPoolView <> nil) and (Doc.ScanPoolViewLoaded) then
      begin
        Fimg.IO.Params.ImageIndex := prev.ActivePage;
        iebmp2 := TIEBitmap.Create;
        try
          Doc.ScanPoolView.CopyToIEBitmap(prev.ActivePage, iebmp2);
          {$IFDEF ImageEN1140}
          Fimg.Bitmap.Assign(iebmp2.VclBitmap);
          {$ELSE}
          Fimg.IO.Bitmap.Assign(iebmp2.VclBitmap);
          {$ENDIF}
        finally
          FreeandNil(iebmp2);
        end;
      end else
      begin
        Fimg.IO.Params.ImageIndex := img_DocView.IO.Params.ImageIndex;
        Doc.DocStream.Position := 0;
        Fimg.IO.LoadFromStream(Doc.DocStream);
      end;

      if WithAnno then
      begin
        AnnoObj := Doc.GetAnnotation(Fimg.IO.Params.ImageIndex, 0, idx);
        if idx <> -1 then
        begin
          found := False;
          for i := Low(AnnoObj.ObjList) to High(AnnoObj.ObjList) do
          begin
            if (AnnoObj.ObjList[i].ModifiedType <> 2) and (AnnoObj.Layer = 0) then // nicht gelschte Anno
            begin
              found := True;
              Break;
            end;
          end;
          if found then
            DrawOneThumbWithAnnos(Fimg);
          end;
      end;

      foundFtx := False;
      if ((bitfarmApp.ViewerOptions.SearchOptions.FtxPos) and (prev.FtxPos <> nil) and (prev.FtxPos.Count > 0)) then
      begin
        k := 0;
        while ((not foundFtx) and (k <= prev.FtxPos.Count - 1)) do
        begin
          l := 0;
          if ((prev.FtxPos[k].WordList <> nil) and (prev.FtxPos[k].WordList.Count > 0)) then
          begin
            while ((not foundFtx) and (l <= prev.FtxPos[k].WordList.Count - 1)) do
            begin
              if prev.FtxPos[k].WordList[l].Page = (Fimg.IO.Params.ImageIndex + 1) then
                foundFtx := True
              else
                inc(l);
            end;
          end;

          inc(k);
        end;
      end;

      if foundFtx then
        DrawOneThumbWithFtxPos(Fimg);

      prev.ThumbnailView.SetImage(prev.ActivePage, Fimg.Bitmap);
      bitfarmApp.CreateRefreshPageInThumbnailsAction(Doc, prev, prev.ActivePage, Fimg.Bitmap);

    finally
      FreeAndNil(Fimg);
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'CreateThumbnailWithAnno', 'bfaCommonImageEN');
  end;
end;

function CreateEmptyImage(img: TbfaImageEnVect; Ext: WideString; TranspColor: TColor) : Boolean;
var
  myBMP, tmpBMP: Graphics.TBitmap;
  Icon: TIcon;
  FileInfo: SHFILEINFO;
  X, Y: Integer;
begin
  Result := False; //16.12.2020 kein Datetyp auf Bitmap
  try
    myBMP := Graphics.TBitmap.Create;
    CreateTransparentBitmap(myBMP, 0, 0, 2100, 2794, TranspColor);
    Icon := TIcon.Create;
    tmpBMP := Graphics.TBitmap.Create;
    if Ext <> '' then
    begin
      tmpBMP.Canvas.Brush.Color := TranspColor;
      if Length(Ext) > 5 then
        bfaIcons.ilPreview32.GetBitmap(Integer(icoidx_filetype_STAR), tmpBMP)
      else
      begin
        bfaIcons.ilPreview32.GetBitmap(Integer(icoidx_filetype_ANY), tmpBMP);
        Result := True;
      end;
      myBMP.Canvas.StretchDraw(Rect(0, 400, 2100, 2594), tmpBMP);
    end;
    img.Assign(myBMP);

    img.IO.Params.Width := 2100;
    img.IO.Params.Height := 2794;
    img.IO.Params.TIFF_Compression := ioTIFF_JPEG;
    img.IO.Params.BitsPerSample := 1;
    img.IO.Params.SamplesPerPixel := 1;
    img.Fit;
    img.Update;

  finally
    Icon.Free;
    tmpBMP.Free;
    myBMP.Free;
  end;
end;

procedure CreateHourglassImage(img: TbfaImageEnVect; TranspColor: TColor);
var
  BMPmy, tmpBMP: Graphics.TBitmap;
  X, Y: Integer;
begin
  try
    BMPmy := Graphics.TBitmap.Create;
    CreateTransparentBitmap(BMPmy, 0, 0, 2100, 2794, TranspColor);
    tmpBMP := Graphics.TBitmap.Create;
    bfaIcons.ilMainMenu32.GetBitmap(Integer(icoidx_hourglass), tmpBMP);

    X := round((2100 - 1400) / 2) + 180;
    Y := round((2794 - 1400) / 2) + 250;
    BMPmy.Canvas.StretchDraw(Rect(X, Y, X + 1000, Y + 1000), tmpBMP);

    img.Bitmap.Assign(BMPmy);

  finally
    tmpBMP.Free;
    BMPmy.Free;
  end;

end;

procedure IETextOut(Canvas: TCanvas; x, y: integer; angle: integer; const Text: string; FontSize: Integer; BColor, Color: TColor; FontName: TFontName; FontStyle: TFontStyles);
var
  LogFont: TLogFont;
begin
  with Canvas do
  begin
    GetObject(Font.Handle, SizeOf(TLogFont), @LogFont);
    Brush.Color := BColor;
    LogFont.lfEscapement := angle * 10;
    LogFont.lfQuality := 3;
    Font.Handle := CreateFontIndirect(LogFont);
    Font.Name := FontName;
    Font.Size := FontSize;
    Font.Style := FontStyle;
    Font.Color := Color;
    TextOut(x, y, Text);
  end;
end;

procedure CreateTransparentBitmap(var Bmp: Graphics.TBitmap; Left, Top, Width, Height: Integer; TranspColor: TColor);
begin
  if Assigned(Bmp) then
  begin
    Bmp.Width := Width;
    Bmp.Height := Height;
    Bmp.Transparent := True;
    Bmp.TransparentColor := TranspColor;
    Bmp.Canvas.Brush.Color := TranspColor;
    Bmp.Canvas.FillRect(Rect(Left, Top, Bmp.Width, Bmp.Height));
  end;
end;

procedure ResizeBitmap(Bitmap: Graphics.TBitmap; Width, Height: Integer; TranspColor: TColor);
var
  R: TRect;
  B: Graphics.TBitmap;
  X, Y: Integer;
begin
  if assigned(Bitmap) then
  begin
    B := Graphics.TBitmap.Create;

    try
      if (Bitmap.Width > Bitmap.Height) and (Bitmap.Width > 0) then
      begin
        R.Right := Width;
        R.Bottom := ((Width * Bitmap.Height) div Bitmap.Width);
        X := 0;
        Y := (Height div 2) - (R.Bottom div 2);
      end
      else if (Bitmap.Height > Bitmap.Width) and (Bitmap.Height > 0) then
      begin
        R.Right := ((Height * Bitmap.Width) div Bitmap.Height);
        R.Bottom := Height;
        X := (Width div 2) - (R.Right div 2);
        Y := 0;
      end;
      try
        R.Left := 0;
        R.Top := 0;
        B.PixelFormat := Bitmap.PixelFormat;
        B.Width := Width;
        B.Height := Height;
        B.Canvas.recTangle(0, 0, Width, Height);

        B.Canvas.Brush.Color := TranspColor;
        B.Canvas.FillRect(B.Canvas.ClipRect);
        B.Canvas.StretchDraw(R, Bitmap);
        Bitmap.Width := Width;
        Bitmap.Height := Height;
        Bitmap.Canvas.Brush.Color := TranspColor;
        Bitmap.Canvas.FillRect(Bitmap.Canvas.ClipRect);
        Bitmap.Canvas.Draw(X, Y, B);
      except
        bitfarmLog.Write(llNormal, ltException, 'ResizeBitmap', 'bfaCommonImageEN');
      end;
    finally
      B.Free;
    end;
  end;
end;

procedure DrawTheBitmap(prev: TbfaPreview; img: TbfaImageEnVect;
  myBmp: Graphics.TBitmap; Doc: TbfaBaseDocument; imgpos: Integer;
  RefreshOnly: Boolean);
begin
  try
    prev.MultiView.LockPaint;
    try
      prev.MultiView.ThumbWidth := MAXTHUMBWIDTH;
      prev.MultiView.ThumbHeight := MAXTHUMBHEIGHT;

      img.Assign(myBmp);

      if (not RefreshOnly) then
        prev.MultiView.InsertImageEx(imgpos);
      prev.MultiView.SetImage(imgpos, img.Bitmap);

      prev.MultiView.Mio.Params[imgpos].TIFF_Compression := img.IO.Params.TIFF_Compression;
      prev.MultiView.Mio.Params[imgpos].BitsPerSample := img.IO.Params.BitsPerSample;
      prev.MultiView.Mio.Params[imgpos].SamplesPerPixel := img.IO.Params.SamplesPerPixel;

      {$IFDEF IMAGEEN1140}
      prev.MultiView.TextTruncSide := iemtsLeft;
      {$ELSE}
      prev.MultiView.ImageBottomText[imgpos].TruncSide := iemtsLeft;
      {$ENDIF}
      if Doc.DocName <> '' then
      begin
        if (Length(Doc.DocName) > 15) then
          {$IFDEF IMAGEEN1140}
          prev.MultiView.ImageBottomText[imgpos] := Copy(Doc.DocName, 1, 15) + '...'
          {$ELSE}
          prev.MultiView.ImageBottomText[imgpos].Caption := Copy(Doc.DocName, 1, 15) + '...'
          {$ENDIF}
        else
          {$IFDEF IMAGEEN1140}
          prev.MultiView.ImageBottomText[imgpos] := Doc.DocName;
          {$ELSE}
          prev.MultiView.ImageBottomText[imgpos].Caption := Doc.DocName;
          {$ENDIF}
      end
      else
        {$IFDEF IMAGEEN1140}
        prev.MultiView.ImageBottomText[imgpos] := ' ';
        {$ELSE}
        prev.MultiView.ImageBottomText[imgpos].Caption := ' ';
        {$ENDIF}
  //08.11.2017 Im Importer wegen Documenttitel eingebaut -->
      if (prev = bitfarmApp.PreviewContainer.ImporterItem.Preview) and (not (Doc.ImporterDocNameModified or bitfarmApp.ViewerOptions.GeneralOptions.UseFileNameAsDocName)) then
        {$IFDEF IMAGEEN1140}
        prev.MultiView.SelectedFontColor := stlControlNoRight.TextColor
        {$ELSE}
        prev.MultiView.ImageBottomText[imgpos].Font.Color := stlControlNoRight.TextColor //14.09.2022 clGrayText
        {$ENDIF}
      else
        {$IFDEF IMAGEEN1140}
        begin
          prev.MultiView.BottomTextFont.Color := stlControl.TextColor;
          prev.MultiView.SelectedFontColor := stlControl.TextColor;
        end;
        {$ELSE}
        prev.MultiView.ImageBottomText[imgpos].Font.Color := stlControl.TextColor; //14.09.2022 clBlack;
        {$ENDIF}
  //08.11.2017 Im Importer wegen Documenttitel eingebaut <--
      if (Doc.ID = -1) or (Doc.InEditMode) then
        {$IFDEF IMAGEEN1140}
        prev.MultiView.ImageBottomText[imgpos] := prev.MultiView.ImageBottomText[imgpos] + ' *';
        {$ELSE}
        prev.MultiView.ImageBottomText[imgpos].Caption := prev.MultiView.ImageBottomText[imgpos].Caption + ' *';
        {$ENDIF}
    finally
      try
        prev.MultiView.ThumbWidth := prev.FActThumbnailWidth;
        prev.MultiView.ThumbHeight := prev.FActThumbnailHeight;
      except
        //
      end;
      prev.MultiView.UnLockPaint;
    end;

    prev.MultiView.UpdateImage(imgpos);

    try
      if (prev.ThumbnailView <> nil) and (prev.ThumbnailView.Visible) then
        if not prev.GetThumbnailInProcess then
          if (prev.ThumbnailView <> nil) then
            prev.ThumbnailView.Update;
    except
      bitfarmLog.Write(llNormal, ltException, 'DrawTheBitmap - ThumbnailView', 'bfaCommonImageEN');
    end;

    prev.Update;
  except
    bitfarmLog.Write(llNormal, ltException, 'DrawTheBitmap', 'bfaCommonImageEN');
  end;
end;

procedure DrawOneImage(AThread: TThread; Doc: TbfaDocument; imgpos: Integer; prev: TbfaPreview; RefreshOnly: Boolean = False);
var
  img: TbfaimageEnVect;
  myBmp, SymBMP: Graphics.TBitmap;
  X, Y: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'DrawOneImage', 'bfaCommonImageEN');
  try
    try
//29.08.2023 -->
  ////19.01.2023 Verursacht leider absturz im Importer/Arbeitsplatz darf nicht im Synchronize
  ////10.05.2023 noch ein versuch zurck...
  //      AThread.Synchronize(nil,
  //        procedure
  //        begin
  //          bitfarmLog.Write(llNormal, ltInfo, 'DrawOneImage - Doc.TempID: ' + GUIDToString(Doc.TempID), 'bfaCommonImageEN');
  //          img := TbfaImageEnVect.Create(nil);
  //          img.Visible := False; //10.05.2023
  //          myBmp := Graphics.TBitmap.create;
  //          SymBMP := Graphics.TBitmap.create;
  //        end);
      {$IFDEF IMAGEEN_SYNCHRONIZED}
      AThread.Synchronize(nil,
        procedure
        begin
          bitfarmLog.Write(llNormal, ltInfo, 'DrawOneImage - Doc.TempID: ' + GUIDToString(Doc.TempID), 'bfaCommonImageEN');
          img := TbfaImageEnVect.Create(nil);
          img.Visible := False; //10.05.2023
          myBmp := Graphics.TBitmap.create;
          SymBMP := Graphics.TBitmap.create;
        end);
      {$ELSE}
      bitfarmLog.Write(llNormal, ltInfo, 'DrawOneImage - Doc.TempID: ' + GUIDToString(Doc.TempID), 'bfaCommonImageEN');
      img := TbfaImageEnVect.Create(nil);
      img.Visible := False; //10.05.2023
      myBmp := Graphics.TBitmap.create;
      SymBMP := Graphics.TBitmap.create;
      {$ENDIF}
//29.08.2023 <--
      try
        try
//29.08.2023 -->
//10.05.2023          img.Visible := False;
          {$IFDEF IMAGEEN_SYNCHRONIZED}
          //10.05.2023          img.Visible := False;
          {$ELSE}
          img.Visible := False;
          {$ENDIF}
//29.08.2023 <--
          img.IO.AutoAdjustDPI := True;
          img.IO.Params.OriginalWidth := 0;
          img.IO.Params.OriginalHeight := 0;
          if ((Doc.GetInProcesses) and (not Doc.InRefreshProcess) and (not Doc.InSaveProcess)) then
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                try
                  CreateHourglassImage(img, clWhite);
                  myBmp.Assign(img.Bitmap);
                except
                  bitfarmLog.Write(llNormal, ltException, 'DrawOneImageInProcess - CreateEmptyImageFromResource - ThreadID:' + IntToStr(AThread.ThreadID), 'bfaCommonImageEN');
                end;
              end);
          end
          else
          begin
            if ((Doc.DocStream.Size > 0) and (Doc.HasPreview)) or (Doc.ScanPoolViewLoaded) then
            begin
              AThread.Synchronize(nil,
                procedure

                  procedure PortraitBMP;
                  begin
                    myBmp.Canvas.Rectangle(700, 350, 2410, 2770);
                    myBmp.Canvas.Rectangle(550, 200, 2330, 2650);
                    myBmp.Canvas.Pen.Color := clBlack;
                    myBmp.Canvas.Rectangle(410, 60, 2230, 2510);
                    myBmp.Canvas.Pen.Color := clDkGray;
                    myBmp.Canvas.StretchDraw(Rect(420, 70, 2220, 2500), img.Bitmap);
                  end;

                  procedure LandscapeBMP;
                  begin
                    myBmp.Canvas.Rectangle(350, 720, 2770, 2520);
                    myBmp.Canvas.Rectangle(200, 570, 2650, 2440);
                    myBmp.Canvas.Pen.Color := clBlack;
                    myBmp.Canvas.Rectangle(60, 430, 2510, 2340);
                    myBmp.Canvas.Pen.Color := clDkGray;
                    myBmp.Canvas.StretchDraw(Rect(70, 440, 2500, 2330), img.Bitmap);
                  end;

                var
                  iebmp: TIEBitmap;

                begin
                  try
                    img.IO.Params.ImageIndex := 0;
                    if (Doc.ScanPoolViewLoaded)  and (Doc.ScanPoolView <> nil) then
                    begin
                      img.IO.Params.ImageIndex := 0;
                      iebmp := TIEBitmap.Create;
                      try
                        Doc.ScanPoolView.CopyToIEBitmap(0, iebmp);
                        {$IFDEF ImageEN1140}
                        img.Bitmap.Assign(iebmp.VclBitmap);
                        {$ELSE}
                        img.IO.Bitmap.Assign(iebmp.VclBitmap);
                        {$ENDIF}
                        Doc.PageCount := Doc.ScanPoolView.ImageCount;
                      finally
                        FreeandNil(iebmp);
                      end;
                    end
                    else
                    begin
                      Doc.DocStream.Position := 0;
                      img.IO.LoadFromStream(Doc.DocStream);
                      Doc.PageCount := img.IO.Params.ImageCount;
                    end;

                    if Doc.Annotations.Count > 0 then
                      DrawOneThumbWithAnnos(img);

                    CreateTransparentBitmap(myBmp, 0, 0, 2794, 2794, prev.MultiView.Background);
                    myBmp.Canvas.Pen.Style := psSolid;
                    myBmp.Canvas.Pen.Width := 20;
                    myBmp.Canvas.Pen.Color := clDkGray;
                    myBmp.Canvas.Brush.Color := clWhite;

                    if ((Doc.ScanPoolView <> nil) and (Doc.ScanPoolViewLoaded) and
                        (Doc.ScanPoolView.ImageCount > 1)) or (img.io.params.TIFF_ImageCount > 1) then
                    begin
                      if ((((Doc.ScanPoolViewLoaded) and (Doc.ScanPoolView <> nil) and (img.IO.Bitmap.Height >= img.IO.Bitmap.width)) or
                           ((not Doc.ScanPoolViewLoaded) and (img.io.Params.Height >= img.io.Params.width)))) or
                            (img.io.Params.Height >= img.io.Params.width) then
                        PortraitBMP
                      else
                        LandscapeBMP;
                    end
                    else
                    begin
                      if (
                           (
                             (
                               (Doc.ScanPoolViewLoaded) and (Doc.ScanPoolView <> nil) and
                               (img.IO.Bitmap.Height > img.IO.Bitmap.width)
                             )
                             or
                             (
                               (not Doc.ScanPoolViewLoaded) and
                               (img.io.Params.Height > img.io.Params.width)
                             )
                           )
                         )
                         or
                         (img.io.Params.Height > img.io.Params.width) then
                      begin
                        myBmp.Canvas.StretchDraw(Rect(350, 70, 2500, 2770), img.Bitmap);
                      end else
                      begin
                        myBmp.Canvas.StretchDraw(Rect(0, 440, 2830, 2520), img.Bitmap);
                      end;
                    end;

                    if Doc.SymbolicArcID >= 0 then
                    begin
                      bfaIcons.ilMainMenu32.GetBitmap(9, SymBMP);
                      myBmp.Canvas.StretchDraw(Rect(10, 2410, 400, 2760), SymBMP);
                    end;

                    if (Doc.ScanPoolViewLoaded) and (Doc.ScanPoolView <> nil) then
                    begin
                      IETextOut(myBmp.Canvas, 420, 80, 0, ' ' + IntToStr(Doc.ScanPoolView.ImageCount) + ' ', 280, clWhite, clBlack, 'Arial', []);
                    end
                    else
                      IETextOut(myBmp.Canvas, 420, 80, 0, ' ' + IntToStr(img.io.params.TIFF_ImageCount) + ' ', 280, clWhite, clBlack, 'Arial', []);

                  except
                    bitfarmLog.Write(llNormal, ltException, 'DrawOneImage - Pagecount - ThreadID:' + IntToStr(AThread.ThreadID), 'bfaCommonImageEN');
                  end;
                end);

            end
            else
            begin
              AThread.Synchronize(nil,
                procedure
                var
                  FType : Boolean;
                  r:TRect;
                  s:String;
                begin
                  try
                    FType := CreateEmptyImage(img, ExtractFileExt(Doc.DocLoc),
                      bitfarmApp.BgColor);
                    myBmp.Assign(img.Bitmap);
                    if (Doc.DocType <> dtEmpty) and (Doc.FileType <> '') then
                    begin
                      if FType then
                      begin
                        if Length(Doc.FileType) < 6 then //Maximal 4 Buchstaben kann dargestellt werden, aberFileType enthlt '.' auch
                        begin
                          with myBmp.Canvas do
                          begin
                            Font.Color := $00D3D0CD;
                            Brush.Style := bsClear;
                            Font.Size := 500;
                            Font.Name := 'Calibri';
                            Font.Style := [fsBold];

                            r.Left := 0;
                            r.Top := 3400;
                            r.Right := 2100;
                            r.Bottom := 200;
                            s := UpperCase(StringReplace(Doc.FileType, '.', '', [rfReplaceAll]));
                            myBmp.Canvas.TextRect(r,s,[tfVerticalCenter,tfCenter,tfSingleLine]);
                          end;
                        end;
                      end;
                    end
                    else
                    begin
                      IETextOut(myBmp.Canvas, 80, 80, 0, ' ' +
                        IntToStr(img.io.params.TIFF_ImageCount) + ' ', 280,
                        clWhite, clBlack, 'Arial', []);
                    end;
                  except
                    bitfarmLog.Write(llNormal, ltException, 'DrawOneImage - CreateEmptyImage - ThreadID:' + IntToStr(AThread.ThreadID), 'bfaCommonImageEN');
                  end;
                end);
            end;
          end;

          AThread.Synchronize(nil,
            procedure
            begin
              try
                DrawTheBitmap(prev, img, myBmp, Doc, imgpos, RefreshOnly);
                prev.MultiView.Update;
              except
                bitfarmLog.Write(llNormal, ltException, 'DrawOneImage - Synchronize Image - ThreadID:' + IntToStr(AThread.ThreadID), 'bfaCommonImageEN');
              end;
            end);

        except
          bitfarmLog.Write(llNormal, ltException, 'DrawOneImage', 'bfaCommonImageEN');
        end;
      finally
//29.08.2023 -->
//  //10.05.2023 -->
//  //        img.Clear;
//  //        img.Free;
//  //        myBmp.Free;
//  //        SymBMP.Free;
//          AThread.Synchronize(nil,
//            procedure
//            begin
//              img.Clear;
//              img.Free;
//              myBmp.Free;
//              SymBMP.Free;
//            end);
//  //10.05.2023 <--
        {$IFDEF IMAGEEN_SYNCHRONIZED}
        AThread.Synchronize(nil,
          procedure
          begin
            img.Clear;
            img.Free;
            myBmp.Free;
            SymBMP.Free;
          end);
        {$ELSE}
        img.Clear;
        img.Free;
        myBmp.Free;
        SymBMP.Free;
        {$ENDIF}
//29.08.2023 <--
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'DrawOneImage - Create', 'bfaCommonImageEN');
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'DrawOneImage', 'bfaCommonImageEN');
  end;
end;

function CompareDocumentsByID(Doc1, Doc2: TbfaDocument): Boolean;
begin
  Result := False;
  try
    if (Doc1 <> nil) and (Doc2 <> nil) then
    begin
      if ((Doc1.ID <> -1) and (Doc2.ID <> -1)) then
        Result := (Doc1.ID = Doc2.ID)
      else
        Result := IsEqualGUID(Doc1.TempID, Doc2.TempID);
    end;
  except
    Result := False;
  end;
end;

function CompareDocuments(Doc1, Doc2: TbfaDocument): Boolean;
begin
  try
    Result := (Doc1 = Doc2);
  except
    Result := False;
  end;
end;

function IsIdenticalStreams(Source, Destination: TStream): boolean;
const
  Block_Size = 4096;
var
  Buffer_1: array[0..Block_Size - 1] of byte;
  Buffer_2: array[0..Block_Size - 1] of byte;
  Buffer_Length: integer;
begin
  Result := False;
  try
  //12.10.2018 Ticket 15208  if Source.Size <> Destination.Size then
    if
      ((Source = nil) and (Destination <> nil)) or
      ((Source <> nil) and (Destination = nil)) or
      ((Source <> nil) and (Destination <> nil) and (Source.Size <> Destination.Size)) then
      Exit;

    if (Source = Destination) then
    begin
      Result := True;
      Exit;
    end;

    Source.Position := 0;
    Destination.Position := 0;

    while Source.Position < Source.Size do
    begin
      Buffer_Length := Source.Read(Buffer_1, Block_Size);
      Destination.Read(Buffer_2, Block_Size);

      if not CompareMem(@Buffer_1, @Buffer_2, Buffer_Length) then
        Exit;
    end;
    Result := True;
  except
    bitfarmLog.Write(llNormal, ltException, 'IsIdenticalStreams', 'bfaCommonImageEN');
  end;
end;

procedure RefreshPageInThumbnails(AThread: TThread; Doc: TbfaDocument; ActPrev: TbfaPreview; Page: Integer; Bmp: Graphics.TBitmap);
begin
  bitfarmLog.DebugBegin(llDebug, 'RefreshPageInThumbnails', 'bfaCommonImageEN');
  try
    try
      AThread.Synchronize(nil,
        procedure
        var
          i: Integer;
        begin
          try
            for i := 0 to bitfarmApp.PreviewContainer.Containers.Count - 1 do
            begin
              if ActPrev = nil then
              begin
                if bitfarmApp.PreviewContainer.Containers[i].Preview.previewToolWindow.Visible then
                  bitfarmApp.PreviewContainer.Containers[i].Preview.ThumbnailView.SetImage(Page, Bmp);
              end
              else if (((ActPrev <> nil) and (ActPrev <> bitfarmApp.PreviewContainer.Containers[i].Preview))) and
                  (bitfarmApp.PreviewContainer.Containers[i].Preview.ActiveDoc <> nil) and
                  (CompareDocumentsByID(ActPrev.ActiveDoc, bitfarmApp.PreviewContainer.Containers[i].Preview.ActiveDoc)) then
              begin
                if bitfarmApp.PreviewContainer.Containers[i].Preview.previewToolWindow.Visible then
                  bitfarmApp.PreviewContainer.Containers[i].Preview.ThumbnailView.SetImage(Page, Bmp);
              end;
            end;
          finally
            FreeAndNil(Bmp);
          end;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'RefreshPageInThumbnails', 'bfaCommonImageEN');
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'RefreshPageInThumbnails', 'bfaCommonImageEN');
  end;
end;

procedure RefreshDocumentInPreviews(AThread: TThread; Doc: TbfaDocument;
  ActPrev1, ActPrev2: TbfaPreview; OnlyObjects: Boolean = False;
  SetInProcess: Boolean = False; ReloadThumbnails: Boolean = False);
var
  i, j, k, l: Integer;
  found, founddoc, CanClose, compDoc, ReloadThumb, ReloadDocStream, ReloadAnnoStream: Boolean;
  Lst: TList;
begin
  bitfarmLog.DebugBegin(llDebug, 'RefreshDocumentInPreViews', 'bfaCommonImageEN');
  try
    try
      for i := 0 to bitfarmApp.PreviewContainer.Containers.Count - 1 do
      begin
        found := False;
        j := 0;
        if bitfarmApp.PreviewContainer.Containers[i].Preview.List <> nil then
        begin
          while ((not found) and (j <= bitfarmApp.PreviewContainer.Containers[i].Preview.List.Count - 1)) do
          begin
            if CompareDocumentsByID(bitfarmApp.PreviewContainer.Containers[i].Preview.List[j], Doc) then
            begin
              found := True;
              if (bitfarmApp.PreviewContainer.Containers[i].Preview.PreviewKind = pvkSingle) then
              begin
                if not SetInProcess then
                begin
                  bitfarmApp.PreviewContainer.Containers[i].Preview.Enabled := True;
                  bitfarmApp.PreviewContainer.Containers[i].Preview.List[j].StartRefreshProcess;
                  try
                    if (ActPrev1 = nil) or (ActPrev1 <> bitfarmApp.PreviewContainer.Containers[i].Preview) then
                    begin
                      compDoc := CompareDocuments(bitfarmApp.PreviewContainer.Containers[i].Preview.List[j], Doc);
                      if not compDoc then
                        bitfarmApp.PreviewContainer.Containers[i].Preview.List[j].Clone(Doc);

                      if not OnlyObjects then
                      begin
                        ReloadDocStream := IsIdenticalStreams(Doc.DocStream, bitfarmApp.PreviewContainer.Containers[i].Preview.List[j].DocStream);
                        ReloadAnnoStream := IsIdenticalStreams(Doc.AnnoStream, bitfarmApp.PreviewContainer.Containers[i].Preview.List[j].AnnoStream);

                        ReloadThumb := ReloadThumbnails or (not reloadDocStream) or (not reloadAnnoStream) or (not compDoc);

                        if ((Assigned(bitfarmApp.PreviewContainer.Containers[i].Preview.List[j].DocStream)) and
                            (bitfarmApp.PreviewContainer.Containers[i].Preview.List[j].DocStream.Size > 0)) or
                            ((bitfarmApp.PreviewContainer.Containers[i].Preview.List[j].ScanPoolView <> nil) and
                            (bitfarmApp.PreviewContainer.Containers[i].Preview.List[j].ScanPoolViewLoaded)) then
                        begin
                          bitfarmApp.PreviewContainer.Containers[i].Preview.RefreshPreview(AThread, bitfarmApp.
                            PreviewContainer.Containers[i].Preview.List[j], ReloadThumb);
                        end else
                        begin
                          if (bitfarmApp.PreviewContainer.Containers[i].Panel <> bitfarmApp.PreviewContainer.PageSortingsItem.Panel) and
                             (bitfarmApp.PreviewContainer.Containers[i].Panel <> bitfarmApp.PreviewContainer.ViewerItem.Panel) and
                             (bitfarmApp.PreviewContainer.Containers[i].Panel <> bitfarmApp.PreviewContainer.ImporterItem.Panel) then //29.06.2017 Der drfte nicht geschlossen werden!
                          begin
                            if bitfarmApp.PreviewContainer.Containers[i].Panel.Parent.Name <> 'dckFloating' then
                              bitfarmApp.PreviewContainer.PanelCloseQuery(bitfarmApp.PreviewContainer.Containers[i].Panel, CanClose)
                            else
                              bitfarmApp.PreviewContainer.PanelCloseQuery(bitfarmApp.PreviewContainer.Containers[i].Panel.Parent.Parent,
                                CanClose);
                          end;
                        end;
                      end;
                    end;
                  finally
                    bitfarmApp.PreviewContainer.Containers[i].Preview.List[j].EndRefreshProcess;
                  end;
                end else
                  bitfarmApp.PreviewContainer.Containers[i].Preview.Enabled := False;
              end else
              begin
                DrawOneImage(AThread, Doc, j, bitfarmApp.PreviewContainer.Containers[i].Preview, True);
                founddoc := False;
                k := 0;
                while ((not founddoc) and (k <= bitfarmApp.PreviewContainer.Containers[i].Preview.List.Count - 1)) do
                begin
                  if CompareDocumentsByID(Doc, (bitfarmApp.PreviewContainer.Containers[i].Preview.List[k])) then
                  begin
                    founddoc := True;
                    if not SetInProcess then
                    begin
                      compDoc := CompareDocuments(bitfarmApp.PreviewContainer.Containers[i].Preview.List[k], Doc);
                      if not compDoc then
                        bitfarmApp.PreviewContainer.Containers[i].Preview.List[k].Clone(Doc);

                      if not OnlyObjects then
                      begin
                        // bfacrm:ticket__show__21615
                        ReloadThumb := ReloadThumbnails
                          or not IsIdenticalStreams(Doc.DocStream, bitfarmApp.PreviewContainer.Containers[i].Preview.List[k].DocStream)
                          or not IsIdenticalStreams(Doc.AnnoStream, bitfarmApp.PreviewContainer.Containers[i].Preview.List[k].AnnoStream) //12.10.2018 Ticket 15208
                          or (not compDoc);   //15.03.2017
                        //20.08.2024 SD -->bfacrm:ticket__show__39651
//                        if ((ActPrev1 = nil) or (ActPrev1 <> bitfarmApp.PreviewContainer.Containers[i].Preview)) then
                        if ((ActPrev1 <> nil) and (ActPrev1 = bitfarmApp.PreviewContainer.Containers[i].Preview)) then
                        //20.08.2024 SD <--bfacrm:ticket__show__39651
                        begin
                          if bitfarmApp.PreviewContainer.Containers[i].Preview.PreviewKind <> pvkMulti then
                          begin
                            bitfarmApp.PreviewContainer.Containers[i].Preview.RefreshPreview(AThread, bitfarmApp.
                              PreviewContainer.Containers[i].Preview.List[bitfarmApp.PreviewContainer.Containers[i].
                              Preview.MultiView.SelectedImage], ReloadThumb)
                          end else
                          begin
                            if bitfarmApp.PreviewContainer.Containers[i].Preview.MultiView.MultiSelectedImagesCount > 0 then
                              bitfarmApp.PreviewContainer.Containers[i].Preview.RefreshPreview(AThread, bitfarmApp.PreviewContainer.
                                Containers[i].Preview.List[bitfarmApp.PreviewContainer.Containers[i].Preview.MultiView.MultiSelectedImages[0]],
                                ReloadThumb);
                          end;
                        end;
                      end;
                    end;
                  end;
                  inc(k);
                end;
              end;
            end;
            inc(j);
          end;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'RefreshDocumentInPreViews', 'bfaCommonImageEN');
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'RefreshDocumentInPreViews', 'bfaCommonImageEN');
  end;
end;

procedure SetProgressBarVisible(prev: TbfaPreview; FList: TList<TbfaDocument>; Add: Boolean);
begin
  try
    if prev.prgPreview <> nil then
    begin
      prev.prgPreview.Min := 0;
      if Add then
      begin
        prev.prgPreview.Max := (FList.Count - 1) - prev.MultiView.ImageCount;
      end
      else
        prev.prgPreview.Max := FList.Count - 1;
      prev.prgPreview.Position := prev.prgPreview.Min;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetProgresBarVisible', 'bfaCommonImageEN');
  end;
end;

procedure SetProgressBarInVisible(prev: TbfaPreview);
begin
  try
    if prev.prgPreview <> nil then
    begin
      prev.prgPreview.Position := 0;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetProgresBarInVisible', 'bfaCommonImageEN');
  end;
end;

procedure RefreshMainMultiView(AThread: TThread; prev: TbfaPreview;
  Lst: TList<TbfaDocument>; Add: Boolean; splForm : TfrmSplash; maxcnt : Integer = -1);
var
  i, cnt, imgpos, listcnt : Integer;
  msg : string;
begin
  if (not Add) then
  begin
    if prev.MultiView <> nil then
      prev.MultiView.Clear;
    if prev.ThumbnailView <> nil then
      prev.ThumbnailView.Clear;
  end;
  try
    try
      bitfarmLog.DebugBegin(llDebug, 'RefreshMainMultiView', 'bfaCommonImageEN');
      if bitfarmApp.PreviewContainer.ImporterItem.Preview = prev then
        msg := _('Dokumente im Importer werden aktualisiert...')
      else if bitfarmApp.PreviewContainer.WorkplaceItem.Preview = prev then
        msg :=  _('Dokumente im Arbeitsplatz werden aktualisiert...');

      if prev.MultiView <> nil then
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            try
              SetProgressBarVisible(prev, Lst, Add);
            except
              bitfarmLog.Write(llNormal, ltException, 'RefreshMainMultiView - Synchronize Progressbar begin - ThreadID:' + IntToStr(AThread.ThreadID), 'bfaCommonImageEN');
            end;
          end);

        imgpos := 0;
        cnt := prev.MultiView.ImageCount;
        if maxcnt = -1 then
          listcnt := Lst.Count
        else
          listcnt := maxcnt;
        for i := cnt to Lst.Count - 1 do
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              splForm.lblLoading.Caption := dgettext('Shared36', msg);
              splForm.lblInfo.Caption :=
                ' (' + IntToStr(i + 1) + '/' + IntToStr(listcnt) + ')';
              if (i = 0) and (splForm.pgbDocuments.Position <> 0) then
              begin
                splForm.pgbDocuments.Properties.Min := 0;
                splForm.pgbDocuments.Position := 0;
                splForm.pgbDocuments.Properties.Max := Lst.Count;
              end;
              splForm.Update;
              if not splForm.Showing or ((i = cnt) and not splForm.UseTimer) then
              begin
                if bitfarmApp.PreviewContainer.ImporterItem.Preview = prev then
                  splForm.FormType := sftImporter
                else if bitfarmApp.PreviewContainer.WorkplaceItem.Preview = prev then
                  splForm.FormType := sftWorkplace;
                splForm.UseTimer := True;
                splForm.Show;
              end;
            end);

          DrawOneImage(AThread, Lst[i], cnt + imgpos, prev);
//16.11.2023 Im Update wird auch aufgerufen
//          AThread.Synchronize(nil,
//            procedure
//            begin
//              splForm.IncProgressBar;
//            end);
            inc(imgpos);
        end;

        AThread.Synchronize(nil,
          procedure
          begin
            try
              SetProgressBarInVisible(prev);
            except
              bitfarmLog.Write(llNormal, ltException, 'RefreshMainMultiView - Synchronize Progressbar end - ThreadID:' + IntToStr(AThread.ThreadID), 'bfaCommonImageEN');
            end;
          end);

      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'RefreshMainMultiView', 'bfaCommonImageEN');
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'RefreshMainMultiView', 'bfaCommonImageEN');
  end;
end;

//04.10.2023 im bfaBaseImageEn auch vorhanden
procedure CreateThumbnailView(var imgThumbnailView: TbfaImageEnMView; AOwner: TComponent; Prnt: TWinControl; Page: Integer = 0; ShowComponent: Boolean = True);
begin
  try
    if imgThumbnailView = nil then
    begin
//      imgThumbnailView := TbfaImageEnMView.Create(AOwner);
//
      bfaBaseImageEN.CreateThumbnailView(imgThumbnailView, AOwner, Prnt);
      with imgThumbnailView do
      begin
//        if Prnt <> nil then
//          Parent := Prnt;
//        Align := alClient;
//        BorderStyle := bsNone;
//        DisplayMode := mdGrid;
//        EnableMultiSelect := True;
//        ScrollBars := ssVertical;
//
//        GridWidth := 1;
//        ImageCacheSize := 10;
//        KeyInteract := [mkiMoveSelected];
//        {$IFDEF ImageEn1140}
////22.05.2023        if Prnt <> nil then
////          FlatScrollBars := True;
//        BottomGap := 4;
//        MouseInteract := [mmiSelect];
//        CheckThumbBoundsOnSelect := True;
//        MultiSelectionOptions := MultiSelectionOptions + [iemoHideSelectionRect];
//        Style := iemsFlat;
//        FillThumbnail := False;
//        // FillThumbnail := False macht die beiden berflssig...
////        ThumbnailsBackgroundStyle := iebsSolid;
////        ThumbnailsBackgroundSelected := clNone;
//        // Farben siehe auch bitfarmApp.ChangePreviewSkin und bitfarmApp.DoChangeSkin
//        {$ELSE}
//        if Prnt <> nil then
//          FlatScrollBars := True;
//        BottomGap := 2;
//        MouseInteract := [];
//        Style := iemsACD;
//        ThumbnailsBackgroundStyle := iebsDiagCross;
//        {$ENDIF}
//        ParentCtl3D := False;
//        SelectionColor := gclLime;
//        SelectionWidth := 4;
//        SelectionWidthNoFocus := 2;
//        StoreType := ietThumb;
//        ThumbnailDisplayFilter := rfFastLinear;
//        TransitionEffect := iettPushAndSqueezeDown;
//        VisibleSelection := True;
//        ThumbWidth := 66;
//        ThumbHeight := 89;
//
//        Tag := tagThumbnailMView;
//        ControlStyle := ControlStyle + [csDisplayDragImage];

        if bitfarmApp <> nil then
        begin
          Background := bitfarmApp.BgColor;
          ThumbnailsBackground := bitfarmApp.BgColor;
          ThumbnailsBorderColor := bitfarmApp.BgColor;
          ThumbnailsInternalBorderColor := bitfarmApp.BgColor;
          SelectionColor := bitfarmApp.slColor;
        end;
      end;
    end;
  except
    imgThumbnailView := nil;
  end;
end;

procedure CreateMultiView(var imgMultiView: TbfaImageEnMView; AOwner: TComponent; Prnt: TWinControl; Width: Integer = MINTHUMBWIDTH; Height: Integer = MINTHUMBHEIGHT);
begin
  try
    if imgMultiView = nil then
    begin
      imgMultiView := TbfaImageEnMView.Create(AOwner);
      with imgMultiView do
      begin
        if Prnt <> nil then
          Parent := Prnt;
        Align := alClient;
        BorderStyle := bsNone;
        BottomGap := 0;
        UpperGap := 10;
        DisplayMode := mdGrid;
        EnableMultiSelect := True;
        GridWidth := -1;
        KeyInteract := [mkiMoveSelected];
        {$IFDEF ImageEn1140}
//22.05.2023        FlatScrollBars := True;
        MouseInteract := [mmiSelect];
        CheckThumbBoundsOnSelect := True;

        MultiSelectionOptions := MultiSelectionOptions
          + [iemoHideSelectionRect,iemoRegion,iemoDontSortMultiSelection];

        ThumbnailOptionsEx := ThumbnailOptionsEx - [ietxAutoPadThumbnailColumns]; //29.09.2023
        {$ELSE}
        FlatScrollBars := True;
        MouseInteract := [];
        SelectionWidthNoFocus := 2;
        {$ENDIF}
        ParentCtl3D := False;
        SelectionColor := clLime;
        SelectionWidth := 4;
        StoreType := ietThumb;
        Style := iemsFlat;
        ThumbnailDisplayFilter := rfFastLinear;
        VisibleSelection := True;
        ThumbWidth := Width;
        ThumbHeight := Height;
        Tag := tagCollectionMView;
        ControlStyle := ControlStyle + [csDisplayDragImage];
      end;
    end;
  except
    imgMultiView := nil;
  end;
end;

function CreateInvisibleMView(AOwner: TComponent): TbfaImageEnMView;
var
  img: TbfaImageEnMView;
begin
  Result := nil;
  try
    img := TbfaImageEnMView.Create(AOwner);
    with img do
    begin
      Visible := False;
      Align := alClient;
      Anchors := [akLeft, akTop, akRight, akBottom];
      BackgroundStyle := iebsCropShadow;
      BorderStyle := bsNone;
      BottomGap := 0;
      DisplayMode := mdGrid;
      {$IFDEF IMAGEEN1140}
//22.05.2023      DrawImageBackground := false;
      {$ELSE}
      DrawImageBackground := false;
      {$ENDIF}
      EnableAlphaChannel := True;
      EnableMultiSelect := True;
      EnableImageCaching := False;
      GridWidth := -1;
      ImageCacheSize := 10;
      KeyInteract := [mkiMoveSelected];
      MouseInteract := [];
      ParentCtl3D := False;
      SelectionColor := $00FFA0A0;
      StoreType := ietNormal;
      Style := iemsACD;
      ThumbWidth := 70;
      ThumbHeight := 70;
    end;

    Result := img;
  except
    Result := nil;
  end;
end;

function CreateInvisibleScanPoolMView(AOwner: TComponent): TbfaImageEnMView;
var
  img: TbfaImageEnMView;
begin
  Result := nil;
  try
    img := TbfaImageEnMView.Create(AOwner);
    with img do
    begin
      Visible := False;
      Align := alClient;
      BorderStyle := bsNone;
      BottomGap := 2;
      DisplayMode := mdGrid;
      EnableMultiSelect := True;
      GridWidth := 1;
      ImageCacheSize := 10;
      KeyInteract := [mkiMoveSelected];
      MouseInteract := [];
      ParentCtl3D := False;
      Ctl3D := False;
      SelectionColor := gclLime;
      SelectionWidth := 4;
      {$IFNDEF IMAGEEN1140}
      SelectionWidthNoFocus := 2;
      {$ENDIF}
      StoreType := ietNormal;
      Style := iemsACD;
      ThumbnailsBackgroundStyle := iebsCropShadow;
      ThumbnailDisplayFilter := rfFastLinear;
      TransitionEffect := iettPushAndSqueezeDown;
      VisibleSelection := True;

      ThumbWidth := 66;
      ThumbHeight := 89;

      Tag := tagThumbnailMView;
      ControlStyle := ControlStyle + [csDisplayDragImage];
    end;

    Result := img;
  except
    Result := nil;
  end;
end;

function CreateInvisibleVect(AOwner: TComponent): TbfaImageEnVect;
var
  img: TbfaImageEnVect;
begin
  Result := nil;
  try
    img := TbfaImageEnVect.Create(AOwner);
    with img do
    begin
      Visible := False;
      IO.AutoAdjustDPI := True;
      BorderStyle := bsNone;
      BackgroundStyle := iebsCropShadow;
      img.ScrollBars := ssBoth;
      img.MouseInteract := [miScroll];
      img.ZoomFilter := rfFastLinear;
//07.12.2017 wegen CrashLog eingebaut -->
      try
        {$IFDEF IMAGEEN1140}
        //04.11.2022 Todo
        {$ELSE}
        img.MouseStableTimer.Free;
        img.MouseStableTimer := nil;
        {$ENDIF}
      except
      end;
//07.12.2017 wegen CrashLog eingebaut <--
    end;
    Result := img;
  except
    Result := nil;
  end;
end;

procedure MViewDragDrop(AThread: TThread; Sender, Source: TObject; X, Y: Integer;
  Move: Boolean; imgpos: Integer = -1; Add: Boolean = False; splForm : TfrmSplash = nil);
var
  sen, src: TbfaImageEnMView;
  TargetDoc: TbfaDocument;
  i, im, ipos: Integer;
  CanMerge: Boolean;
  P: TPoint;
  sOwner: TComponent;

  procedure DeleteSourceSelectedDocs;
  var
    k, i: Integer;
    Arr: TArray<Integer>;
    str: string;
    SList : TStringList;
  begin
    SList := TStringList.Create;
    try
      try
        SetLength(Arr, TbfaDragObject(Source).SelectedList.Count);

        for k := 0 to TbfaDragObject(Source).SelectedList.Count - 1 do
          Arr[k] := StrToInt(TbfaDragObject(Source).SelectedList[k]);

        TArray.Sort<Integer>(Arr);

        for k := High(Arr) downto Low(Arr) do
        begin
          DeleteDocumentFromList(AThread, TbfaPreview(TbfaDragObject(Source).DragSource.Owner).List, Arr[k]);
          SList.Add(IntToStr(Arr[k]));
        end;

        if (TbfaPreview(src.Owner) = bitfarmApp.PreviewContainer.ImporterItem.Preview) or
           (TbfaPreview(src.Owner) = bitfarmApp.PreviewContainer.WorkplaceItem.Preview)
        then
        begin
          for i := 0 to Slist.count - 1  do
          begin
            try
              Str := BD.EnvAppdataImporterPd + SysUtils.Format('%.*d',
                [4, StrToInt(Slist[i])]) + '.xml';
              if FileExists(Str) then
                SysUtils.DeleteFile(Str);
            except
              bitfarmLog.Write(llNormal, ltException, 'Konnte nicht gelscht werden: ' +
                Str, 'DeleteSourceSelectedDocs');
            end;
          end;
        end;

        AThread.Synchronize(nil,
          procedure
          var
            l: integer;
          begin
            for l := High(Arr) downto Low(Arr) do
              src.DeleteImage(Arr[l]);
            if TbfaPreview(src.Owner).ThumbnailView <> nil then
              TbfaPreview(src.Owner).ThumbnailView.Clear;
          end);
      except
        bitfarmLog.Write(llNormal, ltException, 'MViewDragDrop - DeleteSourceSelectedDocs',
          'bfaCommonImageEN');
      end;
    finally
      FreeAndNil(SList);
    end;
  end;

  procedure DeleteEmptyDocs(Doc : TbfaDocument = nil);
  var
    k, l: Integer;
    imgM: TbfaImageEnMView;
    DoDelete: Boolean;
  begin
    try
      imgM := CreateInvisibleMView(nil);
      try
        for k := TbfaPreview(sOwner).List.Count - 1 downto 0 do
        begin
          if (TbfaPreview(sOwner).List[k].HasPreview) then
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                DoDelete := False;
                if (TbfaPreview(sOwner).List[k].ScanPoolView <> nil) and
                   (TbfaPreview(sOwner).List[k].ScanPoolViewLoaded) then
                begin
                  DoDelete := (TbfaPreview(sOwner).List[k].ScanPoolView.ImageCount = 0);
                end else
                begin
                  imgM.Clear;
                  TbfaPreview(sOwner).List[k].DocStream.Position := 0;
                  imgM.MIO.LoadFromStream(TbfaPreview(sOwner).List[k].DocStream);
                  DoDelete := (imgM.ImageCount = 0);
                end;
              end);

            if DoDelete then
            begin
              for l := bitfarmApp.CurrentContainer.Count - 1 downto 0 do
              begin
                if bitfarmApp.CurrentContainer[l] = TbfaPreview(sOwner).List[k] then
                begin
                  bitfarmApp.CurrentContainer.Delete(l);
                  Break;
                end;
              end;

              DeleteDocumentFromList(AThread, TbfaPreview(sOwner).List, k);

              if TbfaPreview(sOwner).ActiveDoc <> nil then
                TbfaPreview(sOwner).ActiveDoc := nil;

              AThread.Synchronize(nil,
                procedure
                var
                  l: integer;
                begin
                  sen.DeleteImage(k);
                  sen.Update;
                  if TbfaPreview(sOwner).ThumbnailView <> nil then
                    TbfaPreview(sOwner).ThumbnailView.Clear;
                  sen.Deselect;
                  TbfaPreview(sOwner).SetActions;

                  if (TbfaPreview(sOwner) = bitfarmApp.PreviewContainer.ImporterItem.Preview) and
                     (bitfarmApp.PreviewContainer.PageSortingsItem.Panel.Showing)
                  then
                    bitfarmApp.CreateHidePageSortingsFrameAction;
                end);
            end;
          end;
        end;
      finally
        imgM.Free;
      end;

      if TbfaPreview(sOwner) = bitfarmApp.PreviewContainer.ImporterItem.Preview then
        bitfarmApp.SetImporterObjectCount(AThread)
      else if TbfaPreview(sOwner) = bitfarmApp.PreviewContainer.WorkplaceItem.Preview then
        bitfarmApp.SetWorkplaceObjectCount(AThread);
    except
      bitfarmLog.Write(llNormal, ltException, 'MViewDragDrop - DeleteSourceSelectedDocs', 'bfaCommonImageEN');
    end;
  end;

begin
  bitfarmLog.DebugBegin(llDebug, 'MViewDragDrop', 'bfaCommonImageEN');
  try
    try
      if (Source is TbfaDragObject) then
        src := TbfaImageEnMView(TbfaDragObject(Source).DragSource)
      else
      begin
        if (Source is TbfaImageEnMView) then
          src := (Source as TbfaImageEnMView)
        else
          src := nil;
      end;

/////////////////////////////////////// Ziel ist ein TbfaImageEnMView Komponent -->
      if ((Sender is TbfaImageEnMView) and (Source is TbfaDragObject)) then
      begin
        sen := TbfaImageEnMView(Sender);
        sOwner := sOwner;
        if sOwner = nil then
          sOwner := sen.Parent.Owner;

        bitfarmLog.Write(llDebug, ltInfo, 'Sender: ' + sen.Name + 'Source: ' +
          src.Name, 'bfaCommonImageEN');

        Move := (((Move) and (TbfaDragObject(Source).DocumentList[0].ID = -1)));
        if (not Move) then
          if ((TbfaDragObject(Source).DragSource = TbfaDragObject(Source).DragSender) and
             (TbfaDragObject(Source).DragInsertMode <> dimMerge) and
             (TbfaDragObject(Source).DragKind = dkDocuments))
          then
            Move := True;

        if imgpos = -1 then
        begin
          im := sen.InsertingPoint(X, Y);

          if ((TbfaDragObject(Source).DragInsertMode = dimAfter) and (im < sen.ImageCount)) then
            Inc(im);
        end
        else
          im := imgpos;

        if (sen.Tag = tagCollectionMView) then
        begin // --> // Ziel ist ein MultiView //
          if (TbfaDragObject(Source).DragKind = dkPages) then
          begin // --> // Wenn Einzelseiten werden verschiebt //
            if ((TbfaDragObject(Source).DragInsertMode = dimBefore) or (TbfaDragObject(Source).DragInsertMode = dimAfter)) then
            begin
              // --> // von Seiten muss ein neu Dokument erstellt werden und MultiView aktualisieren //
              TbfaPreview(sOwner).List.Insert(im, AddPagesToDocument(AThread, TbfaDragObject(Source), Move, sen, src, -1, nil, True));
              DrawOneImage(AThread, TbfaPreview(sOwner).List[im], im, TbfaPreview(sOwner), False);
              if src.ImageCount = 0 then
                DeleteEmptyDocs;
              bitfarmApp.RefreshPreviewCounter(AThread, TbfaPreview(sOwner));
              if (TbfaPreview(sOwner) = bitfarmApp.PreviewContainer.ImporterItem.Preview) and
                 (bitfarmApp.PreviewContainer.PageSortingsItem.Panel.Showing)
              then
                bitfarmApp.CreateShowPageSortingsFrameAction;
              // <-- // von Seiten muss ein neu Dokument erstellt werden und MultiView aktualisieren //
            end
            else if (TbfaDragObject(Source).DragInsertMode = dimMerge) then
            begin
              // --> // Seiten werden hinzugefgt und in alle Preview aktualisiert //
              TargetDoc := TbfaPreview(sOwner).List[im];
              AddPagesToDocument(AThread, TbfaDragObject(Source), Move, sen, src, -1, TargetDoc);
// wir haben das gesamte Dokumente aus der Miniaturansicht auf ein anderes Dokument gezogen -> Quelle lschen
              if (TbfaDragObject(Source).SelectedList.Count >= src.ImageCount) and
                 (src.ImageCount = 0)
              then
                DeleteEmptyDocs;

              RefreshDocumentInPreViews(AThread, TargetDoc, TbfaPreview(sOwner), nil,
                False, False, True);
              // <-- // Seiten werden hinzugefgt und in alle Preview aktualisiert //
            end;
          end // <-- // Wenn Einzelseiten werden verschiebt //
          else if (TbfaDragObject(Source).DragKind = dkDocuments) then
          begin // --> // Wenn Dokumente werden verschiebt //
            if ((TbfaDragObject(Source).DragInsertMode = dimBefore) or (TbfaDragObject(Source).DragInsertMode = dimAfter)) then
            begin
              if ((Sender = TbfaDragObject(Source).DragSource) and (sen.Tag = tagCollectionMView)) then
              begin
                if Move then
                begin
                  if ((im > 0) and (TbfaDragObject(Source).DragInsertMode = dimAfter)) then
                    Dec(im);

                  AThread.Synchronize(nil,
                    procedure
                    begin
                      MoveDocsBetweenCollections(sen, im, TbfaDragObject(Source).SelectedList, TbfaPreview(sOwner));
                    end);
                end
                else
                begin
                  for i := 0 to TbfaDragObject(Source).DocumentList.Count - 1 do
                  begin
//29.08.2023 -->
//                    AThread.Synchronize(nil,
//                      procedure
//                      begin
//                        TargetDoc := bitfarmApp.CreatePDocument;
//                      end);
                    {$IFDEF IMAGEEN_SYNCHRONIZED}
                    AThread.Synchronize(nil,
                      procedure
                      begin
                        TargetDoc := bitfarmApp.CreatePDocument;
                      end);
                    {$ELSE}
                    TargetDoc := bitfarmApp.CreatePDocument;
                    {$ENDIF}
//29.08.2023 <--
                    try
                      TargetDoc.Clone(TbfaDragObject(Source).DocumentList[i]);
                      TbfaPreview(sOwner).List.Insert(im, TargetDoc);
                      DrawOneImage(AThread, TargetDoc, im, TbfaPreview(sOwner), False);
                      bitfarmApp.RefreshPreviewCounter(AThread, TbfaPreview(sOwner));
                      inc(im);
                    finally
                      TargetDoc.EndMoveProcess;
                      TbfaDragObject(Source).DocumentList[i].EndMoveProcess;
                      if TbfaPreview(sOwner) = bitfarmApp.PreviewContainer.ImporterItem.Preview then
                        bitfarmApp.SaveDocumentsToXML(bitfarmApp.ImportContainer, BD.EnvAppdataImporterPd);
                      RefreshDocumentInPreviews(AThread, TargetDoc, TbfaPreview(sOwner), nil, False, False, True);
                      AThread.Synchronize(nil,
                        procedure
                        begin
                          sen.Update;
                        end);
                    end;
                  end;
                end;
              end
              else if ((src.Tag = tagCollectionMView) and (sen.Tag = tagCollectionMView)) then
              begin
                // verschiben auf ein anderen Komponent und ein neu Dokument muss erstellt werden -->
                for i := 0 to TbfaDragObject(Source).DocumentList.Count - 1 do
                begin
//29.08.2023 -->
//                    AThread.Synchronize(nil,
//                      procedure
//                      begin
//                        TargetDoc := bitfarmApp.CreatePDocument;
//                      end);
                  {$IFDEF IMAGEEN_SYNCHRONIZED}
                  AThread.Synchronize(nil,
                    procedure
                    begin
                      TargetDoc := bitfarmApp.CreatePDocument;
                    end);
                  {$ELSE}
                  TargetDoc := bitfarmApp.CreatePDocument;
                  {$ENDIF}
//29.08.2023 <--
                  try
                    TargetDoc.Clone(TbfaDragObject(Source).DocumentList[i]);
                    TbfaPreview(sOwner).List.Insert(im, TargetDoc);
                    DrawOneImage(AThread, TargetDoc, im, TbfaPreview(sOwner), False);
                    inc(im);
                  finally
                    TargetDoc.EndMoveProcess;
                    TbfaDragObject(Source).DocumentList[i].EndMoveProcess;
                  end;
                end;
                if Move then
                  DeleteSourceSelectedDocs;
                bitfarmApp.RefreshPreviewCounter(AThread, TbfaPreview(sOwner));
                // verschiben auf ein anderen Komponent und ein neu Dokument muss erstellt werden <--
              end;

            end
            else if (TbfaDragObject(Source).DragInsertMode = dimMerge) then
            begin
              // --> // Seiten werden hinzugefgt und in alle Preview aktualisiert //
              AThread.Synchronize(AThread,
                procedure
                begin
                  TbfaPreview(sOwner).MultiView.Deselect;
                  bitfarmApp.SetCurrentDocs(nil, nil, TbfaPreview(sOwner));
                  bitfarmApp.ShowDocumentProperties(nil, TbfaPreview(sOwner));
                  TargetDoc := TbfaPreview(sOwner).List[im];
                end);

              if MergeDocuments(AThread, TbfaDragObject(Source).DocumentList, TargetDoc, splForm) = nil then
                Exit;

              if Move then
                DeleteSourceSelectedDocs;
              RefreshDocumentInPreViews(AThread, TargetDoc, TbfaPreview(sOwner), nil, False, False, True);
              bitfarmApp.RefreshPreviewCounter(AThread, TbfaPreview(sOwner));
              AThread.Synchronize(AThread,
                procedure
                var
                  idx: Integer;
                begin
                  if bitfarmApp.PreviewContainer.ImporterItem.Preview = TbfaPreview(sOwner) then
                  begin
                    bitfarmApp.PreviewContainer.ImporterItem.Preview.dctPreviewTarget.Unregister(bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView);
                    bitfarmApp.PreviewContainer.ImporterItem.Preview.dctPreviewTarget.Register(bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView);
                  end;

                  for idx := 0 to TbfaPreview(sOwner).List.Count - 1 do
                    if TbfaPreview(sOwner).List[idx] = TargetDoc then
                    begin
                      TbfaPreview(sOwner).MViewImageSelect(sen, idx);
                      TbfaPreview(sOwner).MultiView.SelectedImage := idx;   // 11.11.2016
                      bitfarmApp.SetCurrentDocs(TargetDoc, nil, TbfaPreview(sOwner));     // 11.11.2016
                      bitfarmApp.ShowDocumentProperties(TargetDoc, TbfaPreview(sOwner));  // 11.11.2016
                    end;
                end);
              // <-- // Seiten werden hinzugefgt und in alle Preview aktualisiert //
            end;
          end; // <-- Dokumente werden verschoben //
        end // <-- //  Ziel ist eine MultiView //
        else if (sen.Tag = tagThumbnailMView) then
        begin // --> // Ziel ist eine Miniaturansicht //
          if (TbfaDragObject(Source).DragKind = dkPages) then
          begin // --> // Wenn Einzelseiten werden verschoben //
            if TbfaPreview(sOwner).PreviewKind = pvkSingle then
              TargetDoc := TbfaPreview(sOwner).List[0]
            else
              TargetDoc := TbfaPreview(sOwner).List[TbfaPreview(sOwner).MultiView.SelectedImage];
            AddPagesToDocument(AThread, TbfaDragObject(Source), Move, sen, src, im, TargetDoc);
            RefreshDocumentInPreViews(AThread, TargetDoc, TbfaPreview(sOwner), nil, False, False, True);
            if sen = src then
            begin
              AThread.Synchronize(nil,
                procedure
                begin
                  bitfarmApp.MViewImageSelect(sen, TbfaPreview(sOwner), TbfaPreview(sOwner).ThumbnailView.SelectedImage);  //06.12.2017 ins Syncronize reingekommen ist
                  TbfaPreview(sOwner).ShowPage(TbfaPreview(sOwner).ActiveDoc, TbfaPreview(sOwner).SingleView.img_DocView.IO.Params.ImageIndex);
                end);
            end;
          end // <-- // Wenn Einzelseiten werden verschoben //
          else if (TbfaDragObject(Source).DragKind = dkDocuments) then
          begin // --> // Wenn Dokumente werden verschoben //
              // --> // Seiten werden hinzugefgt und in alle Preview aktualisiert //
            if TbfaPreview(sOwner).PreviewKind = pvkSingle then
              TargetDoc := TbfaPreview(sOwner).List[0]
            else
              TargetDoc := TbfaPreview(sOwner).List[TbfaPreview(sOwner).MultiView.SelectedImage];
            if MergeDocuments(AThread, TbfaDragObject(Source).DocumentList, TargetDoc, splForm) = nil then
              Exit;
            if Move then
              DeleteSourceSelectedDocs;
            RefreshDocumentInPreViews(AThread, TargetDoc, nil, nil, False, False, True);
            AThread.Synchronize(nil,
              procedure
              begin
                if bitfarmApp.PreviewContainer.ImporterItem.Preview = TbfaPreview(sOwner) then
                begin
                  bitfarmApp.PreviewContainer.ImporterItem.Preview.dctPreviewTarget.Unregister(bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView);
                  bitfarmApp.PreviewContainer.ImporterItem.Preview.dctPreviewTarget.Register(bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView);
                end;
              end);
              // <-- // Seiten werden hinzugefgt und in alle Previews aktualisiert //
          end; // <-- Dokumente werden verschoben //
        end; // <-- // Ziel ist eine Miniaturansicht //

        if Move then
        begin // --> // Wenn die Seiten verschoben werden, muss auch berall aktualisiert werden//
          if (TbfaDragObject(Source).DragKind = dkPages) then
          begin
            for i := 0 to TbfaDragObject(Source).DocumentList.Count - 1 do
            begin
              if ((TargetDoc = nil) or ((TargetDoc <> nil) and (TargetDoc <> TbfaDragObject(Source).DocumentList[i]))) then
              begin
                RefreshDocumentInPreViews(AThread, TbfaDragObject(Source).DocumentList[i], TbfaPreview(sOwner), nil, False, False, True);
              end;
            end;
            bitfarmApp.RefreshPreviewCounter(AThread, TbfaPreview(src.Owner));
          end;
        end; // <-- // Wenn die Seiten verschoben werden, muss auch berall aktualisiert werden //

      end
/////////////////////////////////////// Ziel ist ein TbfaImageEnMView Komponent <--
/////////////////////////////////////// Ziel ist ein Dropzone                -->
      else if (((Sender is TSpTBXPanel) or (Sender is TSpTBXDockablePanel)) and (Source is TbfaDragObject)) then
      begin
        if (((Sender is TSpTBXPanel) and (((Sender as TSpTBXPanel).Name = 'dropImporter') or ((Sender as TSpTBXPanel).Name = 'dropWorkplace'))) or ((Sender is TSpTBXDockablePanel) and (((Sender as TSpTBXDockablePanel).Name = 'pnlImporter') or ((Sender as TSpTBXDockablePanel).Name = 'pnlWorkspace')))) then
        begin
          src := (TbfaDragObject(Source).DragSource as TbfaImageEnMView);

          if src.Tag = tagCollectionMView then
          begin
            /// wenn neue Dokumente muss erzeugt werden aus der Collection
            for i := 0 to TbfaDragObject(Source).DocumentList.Count - 1 do
            begin
              if ((Sender as TSpTBXPanel).Name = 'dropImporter') then
              begin
                if TbfaDragObject(Source).DragSource <> bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView then
                begin
                  AThread.Synchronize(nil,
                    procedure
                    begin
                      TargetDoc := bitfarmApp.CreatePDocument;
                      TargetDoc.Clone(TbfaDragObject(Source).DocumentList[i]);
                      TargetDoc.ID := -1;
                      bitfarmApp.PreviewContainer.ImporterItem.Preview.List.Add(TargetDoc);
                    end);

                  DrawOneImage(AThread, TargetDoc, bitfarmApp.PreviewContainer.ImporterItem.Preview.List.Count - 1, bitfarmApp.PreviewContainer.ImporterItem.Preview, False);

                  bitfarmApp.RefreshPreviewCounter(AThread, bitfarmApp.PreviewContainer.ImporterItem.Preview);

                  if Move then
                  begin
                    DeleteSourceSelectedDocs;
                    bitfarmApp.RefreshPreviewCounter(AThread, TbfaPreview(src.Owner));
                  end;

                end;
              end
              else if ((Sender as TSpTBXPanel).Name = 'dropWorkplace') then
              begin
                if (TbfaDragObject(Source).DragSource <> bitfarmApp.PreviewContainer.WorkplaceItem.Preview.MultiView) and (TbfaDragObject(Source).DragSource <> bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView) then
                begin
                  AThread.Synchronize(nil,
                    procedure
                    begin
                      TargetDoc := bitfarmApp.CreatePDocument;
                      TargetDoc.Clone(TbfaDragObject(Source).DocumentList[i], True);
                      bitfarmApp.PreviewContainer.WorkplaceItem.Preview.List.Add(TargetDoc);
                    end);

                  DrawOneImage(AThread, TargetDoc, bitfarmApp.PreviewContainer.WorkplaceItem.Preview.List.Count - 1, bitfarmApp.PreviewContainer.WorkplaceItem.Preview, False);
                  bitfarmApp.RefreshPreviewCounter(AThread, bitfarmApp.PreviewContainer.WorkplaceItem.Preview);

                  if Move then
                  begin
                    DeleteSourceSelectedDocs;
                    bitfarmApp.RefreshPreviewCounter(AThread, TbfaPreview(src.Owner));
                  end;

                end;
              end;
            end;
          end
          else if src.Tag = tagThumbnailMView then
          begin
          /// wenn neu Dokument muss erzeugt werden aus Miniaturansicht (Sender muss einfach Importer
          /// MultiView austauschen)

            if (Sender is TSpTBXPanel) then
            begin
              if bitfarmApp.DragObject <> nil then
              begin
                if bitfarmApp.DragObject.DragInsertMode = dimNone then
                  bitfarmApp.DragObject.DragInsertMode := dimAfter;
              end;

              if ((Sender as TSpTBXPanel).Name = 'dropImporter') then
              begin
                MViewDragDrop(AThread, bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView, Source, X, Y, Move, bitfarmApp.PreviewContainer.ImporterItem.Preview.List.Count, True);
              end
              else if ((Sender as TSpTBXPanel).Name = 'dropWorkplace') then
              begin
                MViewDragDrop(AThread, bitfarmApp.PreviewContainer.WorkplaceItem.Preview.MultiView, Source, X, Y, Move, bitfarmApp.PreviewContainer.WorkplaceItem.Preview.List.Count, True);
              end;
            end;
          end;

        end;
      end;
/////////////////////////////////////// Ziel ist ein Dropzone                <--

    except
      bitfarmLog.Write(llNormal, ltException, 'MViewDragDrop', 'bfaCommonImageEN');
    end;
  finally
    AThread.Synchronize(nil,
      procedure
      begin
        if (sen is TIEView) then
        begin
          TbfaPreview(sOwner).prgPreview.Visible := False;
        end;
      end);
    bitfarmLog.DebugEnd(llDebug, 'MViewDragDrop', 'bfaCommonImageEN');
  end;
end;

procedure InsertOneImage(imgSen, imgSrc: TbfaImageEnMView; BitmapIdx: Integer; var imgp: Integer);
var
  imgBMP: Graphics.TBitmap;
  iebmp2 : TIEBitmap;
  comp : TIOTIFFCompression;
  bps, spp : Integer;
begin
  try
    iebmp2 := TIEBitmap.Create;
    try
//22.11.2018 Ticket 16877 -->
      comp := imgSrc.MIO.Params[BitmapIdx].TIFF_Compression;
      bps := imgSrc.MIO.Params[BitmapIdx].BitsPerSample;
      spp := imgSrc.MIO.Params[BitmapIdx].SamplesPerPixel;
//22.11.2018 Ticket 16877 <--

      imgSrc.CopyToIEBitmap(BitmapIdx, iebmp2);
      imgSen.InsertImageEx(imgp);

      imgSen.MIO.Params[imgp].TIFF_Compression := comp;
      imgSen.MIO.Params[imgp].BitsPerSample := bps;
      imgSen.MIO.Params[imgp].SamplesPerPixel := spp;

      imgSen.SetImage(imgp, iebmp2.VclBitmap);
    finally
      FreeandNil(iebmp2);
    end;

//22.11.2018 Ticket 16877
//    imgSen.MIO.Params[imgp].TIFF_Compression :=
//      imgSrc.MIO.Params[BitmapIdx].TIFF_Compression;
//    imgSen.MIO.Params[imgp].BitsPerSample :=
//      imgSrc.MIO.Params[BitmapIdx].BitsPerSample;
//    imgSen.MIO.Params[imgp].SamplesPerPixel :=
//      imgSrc.MIO.Params[BitmapIdx].SamplesPerPixel;

    inc(imgp);
  except
  end;
end;

procedure MoveDocsBetweenCollections(sen: TbfaImageEnMView; imgpos: Integer; SList: TStringList; prev: TbfaPreview);
var
  i, insertpos: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'MoveDocsBetweenCollections', 'bfaCommonImageEN');
  try
    try
      insertpos := imgpos;

      if insertpos >= prev.List.Count - 1 then
        insertpos := prev.List.Count - 1;

      sen.Deselect;
      sen.MultiSelecting := True;
      for i := 0 to SList.Count - 1 do
        sen.SelectedImage := StrToInt(SList[i]);
      sen.MultiSelecting := False;

      sen.MultiSelectSortList;
      for i := sen.MultiSelectedImagesCount - 1 downto 0 do
      begin
        prev.List.Move(sen.MultiSelectedImages[i], insertpos);
        prev.List[insertpos].EndMoveProcess;
        sen.MoveImage(sen.MultiSelectedImages[i], insertpos);
      end;

    except
      prev.RefreshMultiView(False);
      bitfarmLog.Write(llNormal, ltException, 'MoveDocsBetweenCollections', 'bfaCommonImageEN');
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'MoveDocsBetweenCollections', 'bfaCommonImageEN');
  end;
end;

procedure SetAnnotationsPageIdx(imgSen: TbfaImageEnMView; Doc: TbfaDocument; ipos: Integer; DeleteSelected: Boolean);
var
  TmpLstSelected, TmpLstNotSelected: TList;
  AnnoObj: TbfaAnnotation;
  Before, After, idx, newpos, SelectedIdx, NotSelectedIdx, k: Integer;
begin
  Before := 0;
  After := 0;
  TmpLstSelected := TList.Create;
  TmpLstNotSelected := TList.Create;
  try
    for k := 0 to imgSen.ImageCount - 1 do
    begin
      AnnoObj := Doc.GetAnnotation(k, 0, idx);
      if AnnoObj <> nil then
      begin
        if imgSen.IsSelected(k) then
          TmpLstSelected.Add(AnnoObj)
        else
          TmpLstNotSelected.Add(AnnoObj);
      end;
    end;

    if ((TmpLstSelected.Count > 0) or (TmpLstNotSelected.Count > 0)) then
    begin
      k := 0;
      newpos := 0;
      SelectedIdx := 0;
      NotSelectedIdx := 0;
      while ((k <= imgSen.ImageCount - 1) and ((SelectedIdx <= TmpLstSelected.Count - 1) or (NotSelectedIdx <= TmpLstNotSelected.Count - 1))) do
      begin
        if (((ipos > 0) and (k = ipos) and (imgSen.SelectedImage > ipos)) or ((ipos > 0) and (k = ipos - 1) and (imgSen.SelectedImage < ipos)) or ((ipos = 0) and (k = ipos))) then
        begin
          while ((SelectedIdx <= TmpLstSelected.Count - 1) and (k <= imgSen.ImageCount - 1)) do
          begin
            if not DeleteSelected then
            begin
              TbfaAnnotation(TmpLstSelected[SelectedIdx]).Page := newpos;
              inc(newpos);
            end
            else
            begin
              TbfaAnnotation(TmpLstSelected[SelectedIdx]).AnnoStream.Clear;
              TbfaAnnotation(TmpLstSelected[SelectedIdx]).AnnoStream.Free;
              TbfaAnnotation(TmpLstSelected[SelectedIdx]).AnnoStream := nil;
              TbfaAnnotation(TmpLstSelected[SelectedIdx]).Free;
              TmpLstSelected[SelectedIdx] := nil;
            end;
            inc(SelectedIdx);
            inc(k);
          end;
        end
        else
        begin
          if ((TmpLstNotSelected.Count > 0) and (NotSelectedIdx <= TmpLstNotSelected.Count - 1)) then
          begin
            while ((NotSelectedIdx <= TmpLstNotSelected.Count - 1) and (k <= imgSen.ImageCount - 1) and (((k <> ipos - 1) and (imgSen.SelectedImage < ipos)) or ((k <> ipos) and (imgSen.SelectedImage > ipos)))) do
            begin
              if TmpLstNotSelected[NotSelectedIdx] <> nil then
                TbfaAnnotation(TmpLstNotSelected[NotSelectedIdx]).Page := newpos;
              inc(NotSelectedIdx);
              inc(newpos);
              inc(k);
            end;
          end
          else
          begin
            inc(newpos);
            inc(k);
          end;
        end;
      end;

      if DeleteSelected then
      begin
        for k := Doc.Annotations.Count - 1 downto 0 do
        begin
          if (Doc.Annotations[k].AnnoStream = nil) then
            Doc.Annotations.Delete(k);
        end;
      end;
    end;

  finally
    TmpLstSelected.Free;
    TmpLstNotSelected.Free;
  end;
end;

function AddPagesToDocument(AThread: TThread; srcDragObj: TObject;
  Move: Boolean; sen, src: TbfaImageEnMView; imgpos: Integer = -1; targetDoc: TbfaDocument = nil; Add: Boolean = False): TbfaDocument;
var
  imgSen, imgSrc: TbfaImageEnMView;
  i, j, ipos: Integer;
  Doc: TbfaDocument;
  AnnoObj, SrcAnno: TbfaAnnotation;
  Arr: TArray<Integer>;
  CanDestroy : Boolean;
begin
  Result := nil;
  bitfarmLog.DebugBegin(llDebug, 'AddPagesToDocument', 'bfaCommonImageEN');

  imgSen := nil;
  imgSrc := nil;
  CanDestroy := False;

//29.08.2023 -->
//  AThread.Synchronize(nil,
//    procedure
//    begin
//      if targetDoc = nil then
//        Doc := bitfarmApp.CreatePDocument
//      else
//        Doc := targetDoc;
//    end);
  {$IFDEF IMAGEEN_SYNCHRONIZED}
  AThread.Synchronize(nil,
    procedure
    begin
      if targetDoc = nil then
        Doc := bitfarmApp.CreatePDocument
      else
        Doc := targetDoc;
    end);
  {$ELSE}
  if targetDoc = nil then
    Doc := bitfarmApp.CreatePDocument
  else
    Doc := targetDoc;
  {$ENDIF}
//29.08.2023 <--

  imgSen := Doc.ScanPoolView;
  if not Doc.ScanPoolViewLoaded then
  begin
    if Doc.ScanPoolView <> nil then
      Doc.ScanPoolView.Clear;
  end;

  if imgSen = nil then
  begin
    imgSen := CreateInvisibleMView(nil);
    CanDestroy := True;
  end;

  try
    try
      EnterCriticalSection(CommonImg_CS);
      try
        Doc.StartProcess;
        Doc.PreviewChanging := True;

        AThread.Synchronize(nil,
          procedure
          begin
            RefreshDocumentInPreviews(AThread, Doc, nil, nil, True, True);

              if (not Doc.ScanPoolViewLoaded) then
              begin
                if Doc.DocStream.Size > 0 then
                begin
                  Doc.DocStream.Position := 0;
                  imgSen.MIO.LoadFromStream(Doc.DocStream);
                end;
                Doc.ScanPoolViewLoaded := True;
              end;

          end);

        for j := 0 to TbfaDragObject(srcDragObj).DocumentList.Count - 1 do
        begin
          Move := Move and (TbfaDragObject(srcDragObj).DocumentList[j].ID = -1);

          try
            AThread.Synchronize(nil,
              procedure
              begin
                imgSrc := TbfaDragObject(srcDragObj).DocumentList[j].ScanPoolView;

                if imgSrc = nil then
                begin
                  imgSrc := CreateInvisibleMView(nil);
                  imgSrc.Clear;
                  TbfaDragObject(srcDragObj).DocumentList[j].DocStream.Position := 0;  //ScanPool?
                  imgSrc.MIO.LoadFromStream(TbfaDragObject(srcDragObj).DocumentList[j].DocStream);
                end;

                if (TbfaDragObject(srcDragObj).DocumentList[j].ScanPoolView <> nil) and (not TbfaDragObject(srcDragObj).DocumentList[j].ScanPoolViewLoaded) then
                begin
                  imgSrc.Clear;
                  TbfaDragObject(srcDragObj).DocumentList[j].DocStream.Position := 0;  //ScanPool?
                  imgSrc.MIO.LoadFromStream(TbfaDragObject(srcDragObj).DocumentList[j].DocStream);
                  TbfaDragObject(srcDragObj).DocumentList[j].ScanPoolViewLoaded := True;
                end;
              end);

            if (imgpos = -1) then
              ipos := imgSen.ImageCount
            else
              ipos := imgpos;

            if Doc <> TbfaDragObject(srcDragObj).DocumentList[j] then
            begin
              bitfarmLog.Write(llDebug, ltInfo, 'Doc <> TbfaDragObject(srcDragObj).DocumentList[j]', 'bfaCommonImageEN');

              TbfaDragObject(srcDragObj).DocumentList[j].PreviewChanging := Move;

              if TbfaDragObject(srcDragObj).PageList.Count > 0 then
              begin
                AThread.Synchronize(nil,
                  procedure
                  var
                    k, idx, l: Integer;
                  begin
                    try
                      for k := 0 to TbfaDragObject(srcDragObj).PageList.Count - 1 do
                      begin
                        if sen.Tag <> tagCollectionMView then
                        begin
                          for l := Doc.Annotations.Count - 1 downto 0 do
                          begin
                            if Doc.Annotations[l].Page >= ipos then
                              Doc.Annotations[l].Page := Doc.Annotations[l].Page + 1;
                          end;
                        end;

                        InsertOneImage(imgSen, imgSrc, StrToInt(TbfaDragObject(srcDragObj).PageList[k]), ipos);
                        if sen.Tag <> tagCollectionMView then
                        begin
                          Dec(ipos);
                          InsertOneImage(sen, src, StrToInt(TbfaDragObject(srcDragObj).PageList[k]), ipos);
                        end;

                        SrcAnno := TbfaDragObject(srcDragObj).DocumentList[j].GetAnnotation(StrToInt(TbfaDragObject(srcDragObj).PageList[k]), 0, idx);
                        if SrcAnno <> nil then
                        begin
                          AnnoObj := TbfaAnnotation.Create;
                          AnnoObj.Clone(SrcAnno);
                          AnnoObj.Page := ipos - 1; //weil im InsertOneImage ist ein Inc()
                          Doc.Annotations.Add(AnnoObj);
                        end;
                      end;
                      if ((Move) and (TbfaDragObject(srcDragObj).DocumentList[j].ID = -1)) then
                      begin
                        TbfaDragObject(srcDragObj).PageList.CustomSort(SortSListAsInt);
                        for k := TbfaDragObject(srcDragObj).PageList.Count - 1 downto 0 do
                        begin
                          imgSrc.DeleteImage(StrToInt(TbfaDragObject(srcDragObj).PageList[k]));
                          src.DeleteImage(StrToInt(TbfaDragObject(srcDragObj).PageList[k]));

                          TbfaDragObject(srcDragObj).DocumentList[j].DeleteAnno(StrToInt(TbfaDragObject(srcDragObj).PageList[k]), True);
                        end;
                      end;
                    except
                      bitfarmLog.Write(llNormal, ltException, 'AddPagesToDocument - Synchronize - Insert - ThreadID:' + IntToStr(AThread.ThreadID), 'bfaCommonImageEN');
                    end;
                  end);
              end
              else
              begin
                AThread.Synchronize(nil,
                  procedure
                  var
                    k, idx, l: Integer;
                  begin
                    try
                      for k := 0 to imgSrc.ImageCount - 1 do
                      begin
                        if sen.Tag <> tagCollectionMView then
                        begin
                          for l := Doc.Annotations.Count - 1 downto 0 do
                          begin
                            if Doc.Annotations[l].Page >= ipos then
                              Doc.Annotations[l].Page := Doc.Annotations[l].Page + 1;
                          end;
                        end;

                        InsertOneImage(imgSen, imgSrc, k, ipos);
                        if sen.Tag <> tagCollectionMView then
                        begin
                          Dec(ipos);
                          InsertOneImage(sen, src, k, ipos);
                        end;

                        SrcAnno := TbfaDragObject(srcDragObj).DocumentList[j].GetAnnotation(StrToInt(TbfaDragObject(srcDragObj).PageList[k]), 0, idx);
                        if SrcAnno <> nil then
                        begin
                          AnnoObj := TbfaAnnotation.Create;
                          AnnoObj.Clone(SrcAnno);
                          AnnoObj.Page := ipos - 1; //weil im InsertOneImage ist ein Inc()
                          Doc.Annotations.Add(AnnoObj);
                        end;
                      end;
                      if ((Move) and (TbfaDragObject(srcDragObj).DocumentList[j].ID = -1)) then
                      begin
                        for k := imgSrc.ImageCount - 1 downto 0 do
                        begin
                          imgSrc.DeleteImage(k);
                          src.DeleteImage(k);

                          TbfaDragObject(srcDragObj).DocumentList[j].DeleteAnno(k, True);
                        end;
                      end;
                    except
                      bitfarmLog.Write(llNormal, ltException, 'AddPagesToDocument - Synchronize - Insert - ThreadID:' + IntToStr(AThread.ThreadID), 'bfaCommonImageEN');
                    end;
                  end);
              end;
            end
            else
            begin
              bitfarmLog.Write(llDebug, ltInfo, 'TargetDoc = TbfaDragObject(srcDragObj).DocumentList[j]', 'bfaCommonImageEN');
              AThread.Synchronize(nil,
                procedure
                var
                  k, l, idx, newpos: Integer;
                begin
                  try
                    if TbfaDragObject(srcDragObj).PageList.Count > 0 then
                    begin
                      try
                        for k := 0 to TbfaDragObject(srcDragObj).PageList.Count - 1 do
                        begin
                          if (sen.Tag <> tagCollectionMView) then
                          begin
                            for l := Doc.Annotations.Count - 1 downto 0 do
                            begin
                              if Doc.Annotations[l].Page >= ipos then
                                Doc.Annotations[l].Page := Doc.Annotations[l].Page + 1;
                            end;
                          end;

                          InsertOneImage(imgSen, imgSrc, StrToInt(TbfaDragObject(srcDragObj).PageList[k]), ipos);

                          if sen.Tag <> tagCollectionMView then
                          begin
                            Dec(ipos);
                            if ((ipos - 1) < StrToInt(TbfaDragObject(srcDragObj).PageList[k])) then
                              newpos := StrToInt(TbfaDragObject(srcDragObj).PageList[k]) + k
                            else
                              newpos := StrToInt(TbfaDragObject(srcDragObj).PageList[k]);
                            InsertOneImage(sen, src, newpos, ipos);
                          end;

                          if ((ipos - 1) < StrToInt(TbfaDragObject(srcDragObj).PageList[k])) then
                            newpos := StrToInt(TbfaDragObject(srcDragObj).PageList[k]) + k + 1
                          else
                            newpos := StrToInt(TbfaDragObject(srcDragObj).PageList[k]);

                          SrcAnno := Doc.GetAnnotation(newpos, 0, idx);
                          if SrcAnno <> nil then
                          begin
                            AnnoObj := TbfaAnnotation.Create;
                            AnnoObj.Clone(SrcAnno);
                            AnnoObj.Page := ipos - 1; //weil im InsertOneImage ist ein Inc()
                            Doc.Annotations.Add(AnnoObj);
                          end;
                        end;

                        SetLength(Arr, TbfaDragObject(srcDragObj).PageList.Count);

                        for k := 0 to TbfaDragObject(srcDragObj).PageList.Count - 1 do
                          Arr[k] := StrToInt(TbfaDragObject(srcDragObj).PageList[k]);

                        TArray.Sort<Integer>(Arr);

                        for k := High(Arr) downto Low(Arr) do
                        begin
                          if ((ipos - 1) < Arr[k]) then
                            newpos := Arr[k] + TbfaDragObject(srcDragObj).PageList.Count
                          else
                            newpos := Arr[k];

                          imgSen.DeleteImage(newpos);
                          sen.DeleteImage(newpos);

                          Doc.DeleteAnno(newpos, True);
                        end;
                      except
                        bitfarmLog.Write(llNormal, ltException, 'AddPagesToDocument - Synchronize - Insert - ThreadID:' + IntToStr(AThread.ThreadID), 'bfaCommonImageEN');
                      end;
                    end;
                  except
                    bitfarmLog.Write(llNormal, ltException, 'AddPagesToDocument - Synchronize - Move position - ThreadID:' + IntToStr(AThread.ThreadID), 'bfaCommonImageEN');
                  end;
                end);
            end;

            if (Doc <> TbfaDragObject(srcDragObj).DocumentList[j]) then
            begin
              if ((Move) and (TbfaDragObject(srcDragObj).DocumentList[j].ID = -1)) then
              begin
                TbfaDragObject(srcDragObj).DocumentList[j].StartSaveProcess;
                try
                  if (TbfaDragObject(srcDragObj).DocumentList[j].ScanPoolView <> nil) and
                     (TbfaDragObject(srcDragObj).DocumentList[j].ScanPoolViewLoaded) then
                  begin
                    TbfaDragObject(srcDragObj).DocumentList[j].ScanPoolViewchanged := True;
                  end else
                  begin
                    TbfaDragObject(srcDragObj).DocumentList[j].DocStream.Clear;
                    TbfaDragObject(srcDragObj).DocumentList[j].DocStream.Position := 0;
                    if imgSrc.ImageCount > 0 then
                    begin
                      AThread.Synchronize(nil,
                        procedure
                        begin
                          imgSrc.MIO.SaveToStreamTIFF(TbfaDragObject(srcDragObj).DocumentList[j].DocStream, False);
                          TbfaDragObject(srcDragObj).DocumentList[j].DocStream.Position := 0;
                        end);
                    end;
                  end;
                  if imgSrc.ImageCount = 0 then
                  begin
                    TbfaDragObject(srcDragObj).DocumentList[j].DocType := dtEmpty;
                    TbfaDragObject(srcDragObj).DocumentList[j].FileType := '';
                  end;
                  TbfaDragObject(srcDragObj).DocumentList[j].PreviewChanging := False;
                finally
                  TbfaDragObject(srcDragObj).DocumentList[j].EndSaveProcess;
                end;
              end;
            end;
          finally
            TbfaDragObject(srcDragObj).DocumentList[j].EndMoveProcess;
          end;
        end;

        AThread.Synchronize(nil,
          procedure
          var
            imgM: TbfaImageEnMView;
          begin
            Doc.StartSaveProcess;
            Doc.DocStream.Clear;
            Doc.DocStream.Position := 0;
            if (imgSen.ImageCount > 10) then //21.09.2018 Trennen zB ein Dokument ber 1000 Seiten macht Probleme
            begin
              Doc.ScanPoolViewchanged := True;
              Doc.ScanPoolViewLoaded := True;
              if (Doc.ScanPoolView <> imgSen) or (Doc.ThumbnailView = nil) then
              begin
                Doc.ScanPoolView := imgSen;
                imgM := Doc.ThumbnailView;
                CloneThumbnailViewFromScanPoolView(imgM, Doc.ScanPoolView, Doc);
                Doc.ThumbnailView := imgM;
              end;
            end else
            begin
              Doc.ScanPoolViewLoaded := False; //21.09.2018 Trennen zB ein Dokument ber 1000 Seiten macht Probleme
              imgSen.MIO.SaveToStreamTIFF(Doc.DocStream, False);
              if Doc.ScanPoolView <> nil then
              begin
                try
                  Doc.ScanPoolView.Clear;
//29.08.2023 -->
//                  Doc.ScanPoolView.Free; //10.05.2023
                  {$IFDEF IMAGEEN_SYNCHRONIZED}
                  Doc.ScanPoolView.Free; //10.05.2023
                  {$ENDIF}
//29.08.2023 <--
                finally
                  Doc.ScanPoolView := nil;
                end;
              end;
              if Doc.ThumbnailView <> nil then
              begin
                try
                  Doc.ThumbnailView.Clear;
                except
                end;
              end;
            end;
            Doc.DocType := dtScannedPage; //Wenn das Dokument gendert wird, dann kann nicht Datei bleiben!
            Doc.FileType := '.tif';
            Doc.HasPreview := True;
            Doc.PreviewChanging := False;
            Doc.Modified_Preview := True;
            bitfarmLog.Write(llDebug, ltInfo, 'Saved sen modifications', 'bfaCommonImageEN');
          end);

        Result := Doc;

      finally
        LeaveCriticalSection(CommonImg_CS);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'AddPagesToDocument', 'bfaCommonImageEN');
    end;
  finally
    Doc.EndSaveProcess;
    Doc.EndMoveProcess;
    Doc.EndProcess;
    bitfarmLog.DebugEnd(llDebug, 'AddPagesToDocument', 'bfaCommonImageEN');
  end;
end;

function DeletePagesFromDocument(AThread: TThread; sen: TbfaImageEnMView; SelectedPages: TStringList; ActDoc: TbfaDocument): TbfaDocument;
var
  imgSen: TbfaImageEnMView;
begin
  Result := nil;
  bitfarmLog.DebugBegin(llDebug, 'DeletePagesFromDocument', 'bfaCommonImageEN');
  try
      if ActDoc.ScanPoolView <> nil then
        imgSen := ActDoc.ScanPoolView
      else
      begin                                              // --> s.TIWARI bfacrm:ticket__show__21718 7/7/2020
        imgSen := CreateInvisibleScanPoolMView(nil);
        ActDoc.ScanPoolViewchanged := True;
      end;                                              // <-- s.TIWARI bfacrm:ticket__show__21718 7/7/2020

    try
      EnterCriticalSection(CommonImg_CS);
      try
        ActDoc.StartProcess;
        ActDoc.PreviewChanging := True;
        RefreshDocumentInPreViews(AThread, ActDoc, TbfaPreview(sen.Owner), nil, True);

        if (ActDoc.ScanPoolView = nil) then  // -- s.TIWARI bfacrm:ticket__show__21718 7/7/2020
        begin
          if (ActDoc.DocStream.Size > 0) then
          begin
            ActDoc.DocStream.Position := 0;
            imgSen.MIO.LoadFromStream(ActDoc.DocStream);
          end;
        end;

        AThread.Synchronize(nil,
          procedure
          var
            k: Integer;
          begin
            try
              if SelectedPages.Count > 0 then
              begin
                try
                  sen.Deselect;
                  imgSen.Deselect;
                  imgSen.MultiSelecting := True;
                  sen.MultiSelecting := True;
                  for k := 0 to SelectedPages.Count - 1 do
                  begin
                    imgSen.SelectedImage := StrToInt(SelectedPages[k]);
                    sen.SelectedImage := StrToInt(SelectedPages[k]);
                  end;
                  imgSen.MultiSelecting := False;
                  imgSen.MultiSelectSortList;
                  sen.MultiSelecting := False;
                  sen.MultiSelectSortList;

                  for k := 0 to imgSen.ImageCount - 1 do
                  begin
                    if imgSen.IsSelected(k) then
                      ActDoc.DeleteAnno(k, True);
                  end;

                  imgSen.DeleteSelectedImages;
                  sen.DeleteSelectedImages;

                except
                  bitfarmLog.Write(llNormal, ltException, 'DeletePagesFromDocument - Synchronize - Insert - ThreadID:' + IntToStr(AThread.ThreadID), 'bfaCommonImageEN');
                end;
              end;
            except
              bitfarmLog.Write(llNormal, ltException, 'DeletePagesFromDocument - Synchronize - Move position - ThreadID:' + IntToStr(AThread.ThreadID), 'bfaCommonImageEN');
            end;
          end);

        ActDoc.StartSaveProcess;
//23.05.2018 Ticket 14576 -->
//        if not bitfarmApp.WithScanPool then             // -- s.TIWARI bfacrm:ticket__show__21718 7/7/2020
//        begin
          ActDoc.ScanPoolViewchanged := True;
//        end
//        else
//        begin

          ActDoc.DocStream.Clear;
          ActDoc.DocStream.Position := 0;
          imgSen.MIO.SaveToStreamTIFF(ActDoc.DocStream, False);
//        end;
//23.05.2018 Ticket 14576 <--
        ActDoc.HasPreview := True;
        ActDoc.PreviewChanging := False;
        ActDoc.Modified_Preview := True;

        AThread.Synchronize(nil,
          procedure
          begin
            if ((sen.ImageCount > 0) and (sen.SelectedImage <> -1)) then
            begin
              TbfaPreview(sen.Owner).ShowPage(ActDoc, sen.SelectedImage);
            end
            else
            begin
              TbfaPreview(sen.Owner).SingleView.img_DocView.RemoveAllObjects;
              TbfaPreview(sen.Owner).SingleView.img_DocView.Clear;
              TbfaPreview(sen.Owner).SetActions; //(True);
            end;
          end);

        Result := ActDoc;

      finally
        ActDoc.EndSaveProcess;
        ActDoc.EndProcess;
        RefreshDocumentInPreViews(AThread, ActDoc, TbfaPreview(sen.Owner), nil, False, False, True);
        LeaveCriticalSection(CommonImg_CS);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'DeletePagesFromDocument', 'bfaCommonImageEN');
    end;
  finally
//      15.02.2021 Ticket 26026
//      try
//        imgSen.Free;
//      finally
//        imgSen := nil;
//      end;
    bitfarmLog.DebugEnd(llDebug, 'DeletePagesFromDocument', 'bfaCommonImageEN');
  end;
end;

procedure CompressImage(var iColors: Integer; imgTmp: TbfaImageEnVect;
  imgM: TbfaImageEnMView = nil; idx: Integer = -1; DoCompress: Boolean = False);
begin
  bitfarmLog.DebugBegin(llDebug, 'CompressImage', 'bfaCommonImageEN');
  try
    try
      if (DoCompress) or
         (imgtmp.IO.Params.TIFF_Compression = ioTIFF_G3FAX1D) or
         (imgtmp.IO.Params.TIFF_Compression = ioTIFF_G3FAX2D) or
         (imgtmp.IO.Params.TIFF_Compression = ioTIFF_UNCOMPRESSED) or
         (imgtmp.IO.Params.TIFF_Compression = ioTIFF_UNKNOWN) or
         (imgtmp.IO.Params.TIFF_Compression = ioTIFF_OLDJPEG)

      then
      begin
        iColors := imgTmp.Proc.CalcImageNumColors;
        with imgTmp.IO.Params do
        begin
          if iColors < 3 then  //SW
          begin
            BitsPerSample := 1;
            SamplesPerPixel := 1;
          end
          else if iColors < 256 then
          begin
            BitsPerSample := 4;
            SamplesPerPixel := 1;
          end
          else
          begin
            BitsPerSample := 8;
            SamplesPerPixel := 3;
          end;
          case imgTmp.IO.Params.BitsPerSample * imgTmp.IO.Params.SamplesPerPixel of
            1:
              TIFF_Compression := ioTIFF_G4FAX;
            4, 8:
              TIFF_Compression := ioTIFF_LZW;
            24:
              TIFF_Compression := ioTIFF_JPEG;
          else
            TIFF_Compression := ioTIFF_LZW;
          end;

          if (imgM <> nil) and (idx > -1) and (imgM.ImageCount > idx) then
          begin
            imgM.MIO.Params[idx].TIFF_Compression := imgTmp.IO.Params.TIFF_Compression;
            imgM.MIO.Params[idx].BitsPerSample := imgTmp.IO.Params.BitsPerSample;
            imgM.MIO.Params[idx].SamplesPerPixel := imgTmp.IO.Params.SamplesPerPixel;
          end;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'CompressImage', 'bfaCommonImageEN');
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CompressImage', 'bfaCommonImageEN');
  end;
end;

function MergeDocuments(AThread: TThread; // srcDragObj : TbfaDragObject;
  srcDragObj: TList<TbfaDocument>; targetDoc: TbfaDocument; splForm : TfrmSplash): TbfaDocument;
var
  imgSen: TbfaImageEnMView;
  Doc, NewDoc: TbfaDocument;
  AnnoObj: TbfaAnnotation;
  PCount, iColors, j, k, l, ActPage: Integer;
  img: TbfaImageEnVect;
  CanMerge, found, CanDestroy : Boolean;
  msg : string;
//23.08.2019 Ticket 20264 -->
  imgtmp : TbfaImageEnVect;
  TiffComp : TIOTIFFCompression;
  BPS, SPP : Integer;
  iebmptmp : TIEBitmap;
//23.08.2019 Ticket 20264 <--
begin
  Result := nil;
  bitfarmLog.DebugBegin(llDebug, 'MergeDocuments', 'bfaCommonImageEN');
//06.06.2018 Ticket 14576  imgSen := CreateInvisibleMView(nil);
  imgSen := nil;
  try
    try
      EnterCriticalSection(CommonImg_CS);
      CanDestroy := False;
      try
//        msg := dgettext('Shared36', 'Die Dokumente werden zusammengefhrt...');
        msg := dgettext('Shared36', 'Die Dokumente werden zusammengefhrt...');
        found := False;
        for j := 1 to srcDragObj.Count - 1 do
        begin
          if srcDragObj[j].ID <> -1 then
          begin
            found := True;
            Break;
          end;
        end;

        if (targetDoc.ID <> -1) or (found) then
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              CanMerge := (BfMessageDlg (dgettext('Shared36', 'Hierdurch wird ein neues Dokument erzeugt.') + #13#10 + dgettext('Shared36', 'Mchten Sie trotzdem fortfahren?'), mtWarning, [mbYes, mbNo], True, dgettext('Shared36',  'Hinweis')) = mrYes);
            end);
        end
        else
          CanMerge := True;

        if not CanMerge then
          Exit;

        AThread.Synchronize(nil,
          procedure
          begin
            splForm.lblLoading.Caption := msg;
            splForm.lblInfo.Caption := '';
            splForm.Update;
            if not splForm.Showing then
              splForm.Show;
          end);

//28.03.2017 Ticket 10252 -->
//        if TargetDoc.ID <> -1 then
//          TargetDoc.ID := -1;
        if targetDoc.ID <> -1 then
        begin
          NewDoc := TbfaDocument.Create;
          NewDoc.DocStream.Position := 0;
          targetDoc.DocStream.Position := 0;
          NewDoc.DocStream.CopyFrom(targetDoc.DocStream, targetDoc.DocStream.Size);
          for k := 0 to targetDoc.Annotations.Count - 1 do
          begin
            AnnoObj := TbfaAnnotation.Create;
            AnnoObj.Clone(targetDoc.Annotations[k]);
            NewDoc.Annotations.Add(AnnoObj);
          end;
          NewDoc.HasPreview := targetDoc.HasPreview;

          targetDoc.Reset;
          targetDoc.Clone(NewDoc);
        end;
//28.03.2017 Ticket 10252 <--

//29.08.2023 -->
//        AThread.Synchronize(nil,
//          procedure
//          begin
//            if (targetDoc = nil) or (targetDoc.ID <> -1) then
//              Doc := bitfarmApp.CreatePDocument
//            else
//              Doc := targetDoc;
//          end);
        {$IFDEF IMAGEEN_SYNCHRONIZED}
        AThread.Synchronize(nil,
          procedure
          begin
            if (targetDoc = nil) or (targetDoc.ID <> -1) then
              Doc := bitfarmApp.CreatePDocument
            else
              Doc := targetDoc;
          end);
        {$ELSE}
        if (targetDoc = nil) or (targetDoc.ID <> -1) then
          Doc := bitfarmApp.CreatePDocument
        else
          Doc := targetDoc;
        {$ENDIF}
//29.08.2023 <--

          if Doc.ScanPoolView <> nil then
          begin
            imgSen := Doc.ScanPoolView;
            if not Doc.ScanPoolViewLoaded then
              Doc.ScanPoolView.Clear
//23.08.2019 Ticket 20264 -->
            else
            begin
              for k := 0 to Doc.ScanPoolView.ImageCount - 1 do
              begin
                if (Doc.ScanPoolView.MIO.Params[k].TIFF_Compression = ioTIFF_UNKNOWN) or
                   (Doc.ScanPoolView.MIO.Params[k].TIFF_Compression = ioTIFF_UNCOMPRESSED) then
                begin
                  imgtmp := CreateInvisibleVect(nil);
                  try
                    iebmptmp := TIEBitmap.Create;
                    try
                      Doc.ScanPoolView.CopyToIEBitmap(l, iebmptmp);
                      {$IFDEF ImageEN1140}
                      imgtmp.Bitmap.Assign(iebmptmp.VclBitmap);
                      {$ELSE}
                      imgtmp.IO.Bitmap.Assign(iebmptmp.VclBitmap);
                      {$ENDIF}
                      CompressImage(iColors, imgtmp, Doc.ScanPoolView, k, True);
                    finally
                      FreeandNil(iebmptmp);
                    end;
                  finally
                    imgtmp.Free;
                    imgTmp := nil;
                  end;
                end;
              end;
            end;
//23.08.2019 Ticket 20264 <--
          end
          else
            imgSen := CreateInvisibleMView(nil);


        Doc.StartProcess;
        Doc.PreviewChanging := True;

        RefreshDocumentInPreviews(AThread, Doc, nil, nil, True, True);

        if (Doc.ScanPoolView <> nil) and (Doc.ScanPoolViewLoaded) then
          PCount := imgSen.ImageCount
        else
        if Doc.DocStream.Size > 0 then
        begin
          Doc.DocStream.Position := 0;
          imgSen.MIO.LoadFromStream(Doc.DocStream);
          PCount := imgSen.ImageCount;

//14.03.2018 Ticket 13607 -->
          img := bfaCommonImageEn.CreateInvisibleVect(nil);
          try
            for k := 0 to imgSen.ImageCount - 1 do
            begin
              img.Clear;
              img.IO.Params.ImageIndex := k;
              Doc.DocStream.Position := 0;
              img.IO.LoadFromStream(Doc.DocStream);

              CompressImage(iColors, img, imgSen, k, (img.IO.Params.SamplesPerPixel = 4));
            end;
          finally
            img.Free;
            img := nil;
          end;
//14.03.2018 Ticket 13607 <--
        end
        else
          PCount := 0;

        for j := 0 to srcDragObj.Count - 1 do
        begin
          if Doc <> srcDragObj[j] then
          begin
            try
              bitfarmLog.Write(llDebug, ltInfo, 'Doc <> srcDragObj.DocumentList[j]', 'bfaCommonImageEN');
              try
                AThread.Synchronize(nil,
                  procedure
                  var
                    l: Integer;
                    iebmp2 : TIEBitmap;
                  begin
                    if (srcDragObj[j].ScanPoolView <> nil) and srcDragObj[j].ScanPoolViewLoaded then
                    begin
                      ActPage := imgSen.ImageCount;

                      if (Doc.ScanPoolView <> nil) and (Doc.ScanPoolViewLoaded) then
                        if Doc.ThumbnailView <> nil then
                           Doc.ThumbnailView.LockPaint;
                      try
                        for l := 0 to srcDragObj[j].ScanPoolView.ImageCount - 1 do
                        begin
                          if srcDragObj.Count > 1 then
                          begin
                            splForm.lblLoading.Caption := msg;
                            splForm.lblInfo.Caption :=
                              ' (Dokument: ' + IntToStr(j + 1) + '/' + IntToStr(srcDragObj.Count) + ')'
                              + ' (Seite: ' + IntToStr(l + 1) + '/' + IntToStr(srcDragObj[j].ScanPoolView.ImageCount) + ')';
                          end
                          else
                          begin
                            splForm.lblLoading.Caption := msg;
                            splForm.lblInfo.Caption :=
                              ' (' + IntToStr(l + 1) + '/' + IntToStr(srcDragObj[j].ScanPoolView.ImageCount) + ')';
                          end;

                          splForm.Update;

                          imgSen.LockPaint;
                          try
                            iebmp2 := TIEBitmap.Create;
                            try
                              srcDragObj[j].ScanPoolView.CopyToIEBitmap(l, iebmp2);
                              imgSen.InsertImageEx(ActPage);
                              imgSen.SetImage(ActPage, iebmp2.VclBitmap);

                              if (Doc.ScanPoolView <> nil) and (Doc.ScanPoolViewLoaded) then
                                if Doc.ThumbnailView <> nil then
                                begin
                                  if ActPage <= Doc.ThumbnailView.ImageCount -1 then
                                  begin
                                    Doc.ThumbnailView.InsertImageEx(ActPage);
                                    Doc.ThumbnailView.SetImage(ActPage, iebmp2.VclBitmap);
                                  end;
                                end;

//23.08.2019 Ticket 20264 -->
                              TiffComp := srcDragObj[j].ScanPoolView.MIO.Params[l].TIFF_Compression;
                              BPS := srcDragObj[j].ScanPoolView.MIO.Params[l].BitsPerSample;
                              SPP := srcDragObj[j].ScanPoolView.MIO.Params[l].SamplesPerPixel;

                              if (TiffComp = ioTIFF_UNCOMPRESSED) or (TiffComp = ioTIFF_UNKNOWN) then
                              begin
                                imgtmp := CreateInvisibleVect(nil);
                                try
                                  {$IFDEF ImageEN1140}
                                  imgtmp.Bitmap.Assign(iebmp2.VclBitmap);
                                  {$ELSE}
                                  imgtmp.IO.Bitmap.Assign(iebmp2.VclBitmap);
                                  {$ENDIF}
                                  CompressImage(iColors, imgtmp, imgSen, ActPage, True);

                                  TiffComp := imgSen.Mio.Params[ActPage].TIFF_Compression;
                                  BPS := imgSen.Mio.Params[ActPage].BitsPerSample;
                                  SPP := imgSen.Mio.Params[ActPage].SamplesPerPixel;
                                finally
                                  imgtmp.Free;
                                  imgTmp := nil;
                                end;
                              end
                              else
                              begin
                                imgSen.Mio.Params[ActPage].TIFF_Compression := TiffComp;
                                imgSen.Mio.Params[ActPage].BitsPerSample := BPS;
                                imgSen.Mio.Params[ActPage].SamplesPerPixel := SPP;
                              end;
                            finally
                              FreeandNil(iebmp2);
                            end;

                            imgSen.Mio.Params[ActPage].DpiX :=
                              srcDragObj[j].ScanPoolView.MIO.Params[l].DpiX;
                            imgSen.Mio.Params[ActPage].DpiY :=
                              srcDragObj[j].ScanPoolView.MIO.Params[l].DpiY;

                            try
                              if (Doc.ScanPoolView <> nil) and (Doc.ScanPoolViewLoaded) then
                                if Doc.ThumbnailView <> nil then
                                begin
                                  if ActPage <= Doc.ThumbnailView.ImageCount -1 then
                                  begin
                                    Doc.ThumbnailView.Mio.Params[ActPage].TIFF_Compression := TiffComp;
                                    Doc.ThumbnailView.Mio.Params[ActPage].BitsPerSample := BPS;
                                    Doc.ThumbnailView.Mio.Params[ActPage].SamplesPerPixel := SPP;
                                  end;
                                end;
                            except
                            end;

                            inc(ActPage);
                          finally
                            imgSen.UnLockPaint;
                            imgSen.Update;
                          end;
                        end;
                      finally
                        if (Doc.ScanPoolView <> nil) and (Doc.ScanPoolViewLoaded) then
                          if Doc.ThumbnailView <> nil then
                          begin
                            Doc.ThumbnailView.UnLockPaint;
                            Doc.ThumbnailView.Update;
                          end;
                      end;
                    end
                    else begin
                      splForm.lblLoading.Caption := msg;
                      splForm.lblInfo.Caption :=
                          ' (' + IntToStr(j + 1) + '/' + IntToStr(srcDragObj.Count) + ')';
                      splForm.Update;

                      srcDragObj[j].DocStream.Position := 0;
                      imgSen.MIO.LoadFromStream(srcDragObj[j].DocStream);
                    end;

                    for l := 0 to srcDragObj[j].Annotations.Count - 1 do
                    begin
                      AnnoObj := TbfaAnnotation.Create;
                      AnnoObj.Clone(srcDragObj[j].Annotations[l]);
                      AnnoObj.Page := AnnoObj.Page + PCount;
                      Doc.Annotations.Add(AnnoObj);
                    end;

                    if not ((srcDragObj[j].ScanPoolView <> nil) and srcDragObj[j].ScanPoolViewLoaded) then
                    begin
                      img := bfaCommonImageEn.CreateInvisibleVect(nil);
                      try
                        for l := PCount to imgSen.ImageCount - 1 do
                        begin
                          img.Clear;
                          img.IO.Params.ImageIndex := l - PCount;
                          srcDragObj[j].DocStream.Position := 0;
                          img.IO.LoadFromStream(srcDragObj[j].DocStream);

                          CompressImage(iColors, img, imgSen, l, (img.IO.Params.SamplesPerPixel = 4));
                        end;
                      finally
                        img.Free;
                        img := nil;
                      end;
                    end;
//10.10.2023                    Inc(PCount); //30.06.2017 Ticket 10981
                    PCount := imgSen.ImageCount;
                  end);
              except
                bitfarmLog.Write(llNormal, ltException, 'MergeDocuments - Synchronize - ThreadID:' + IntToStr(AThread.ThreadID), 'bfaCommonImageEN');
              end;
            finally
              srcDragObj[j].EndMoveProcess;
            end;
          end;
        end;

        AThread.Synchronize(nil,
          procedure
          var
            imgM: TbfaImageEnMView;
          begin
            Doc.StartSaveProcess;
            Doc.DocStream.Clear;
            Doc.DocStream.Position := 0;
            if (imgSen.ImageCount > 10) then //21.09.2018 Trennen zB ein Dokument ber 1000 Seiten macht Probleme  (Fabian)
            begin
              Doc.ScanPoolView := imgSen;
              imgM := Doc.ThumbnailView;

              if (Doc.ScanPoolView <> nil) and (not Doc.ScanPoolViewLoaded) then
                if Doc.ThumbnailView <> nil then
                begin
                  CloneThumbnailViewFromScanPoolView(imgM, Doc.ScanPoolView, Doc);
                  Doc.ThumbnailView := imgM;
                end;

              Doc.ScanPoolViewLoaded := True;
              Doc.ScanPoolViewchanged := True;
            end
            else
            begin
              Doc.ScanPoolViewLoaded := False; //21.09.2018 Trennen zB ein Dokument ber 1000 Seiten macht Probleme
              imgSen.MIO.SaveToStreamTIFF(Doc.DocStream, False);

              if Doc.ScanPoolView <> nil then
              begin
                try
                  Doc.ScanPoolView.Clear;
//29.08.2023 -->
//                  Doc.ScanPoolView.Free; //10.05.2023
                  {$IFDEF IMAGEEN_SYNCHRONIZED}
                  Doc.ScanPoolView.Free; //10.05.2023
                  {$ENDIF}
//29.08.2023 <--
                finally
                  Doc.ScanPoolView := nil;
                end;
              end;
              if Doc.ThumbnailView <> nil then
              begin
                try
                  Doc.ThumbnailView.Clear;
                  //10.05.2023 Free???
                except
                end;
              end;
            end;

            Doc.DocType := dtScannedPage;
            Doc.FileType := '.tif';
            Doc.HasPreview := True;
            Doc.PreviewChanging := False;
            Doc.Modified_Preview := True;
            bitfarmLog.Write(llDebug, ltInfo, 'Saved sen modifications', 'bfaCommonImageEN');
          end);

        Result := Doc;

      finally
        Doc.EndSaveProcess;
        Doc.EndMoveProcess;
        Doc.EndProcess;

        AThread.Synchronize(nil,
          procedure
          begin
            splForm.lblInfo.Caption := '';
            splForm.Hide;
          end);

        LeaveCriticalSection(CommonImg_CS);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'MergeDocuments', 'bfaCommonImageEN');
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'MergeDocuments', 'bfaCommonImageEN');
  end;
end;

//03.07.2023 niergendwo benutzt...
//function CreateEmptyDocument(prev: TbfaPreview; idx: Integer = -1): TbfaDocument;
//var
//  pDoc: TbfaDocument;
//begin
//  bitfarmLog.DebugBegin(llDebug, 'CreateEmptyDocument', 'bfaCommonImageEN');
//  try
//    try
//      if (idx = -1) then
//      begin
//        if (prev.List.Count >= 1) then
//          idx := prev.List.Count - 1
//        else
//          idx := 0;
//      end;
//
//      pDoc := bitfarmApp.CreatePDocument;
//      pDoc.DocType := dtEmpty;
//      prev.List.Insert(idx, pDoc);
//
//      Result := pDoc;
//
//    except
//      Result := nil;
//      bitfarmLog.Write(llNormal, ltException, 'CreateEmptyDocument', 'bfaCommonImageEN');
//    end;
//  finally
//    bitfarmLog.DebugEnd(llDebug, 'CreateEmptyDocument', 'bfaCommonImageEN');
//  end;
//end;

function IsDocumentInOtherPreview(prev: TbfaPreview; Doc: TbfaDocument): Boolean;
var
  i, j, k: Integer;
  found: Boolean;
begin
  Result := False;

  if (prev = nil) or (Doc = nil) then
    Exit;

  bitfarmLog.DebugBegin(llDebug, 'IsDocumentInOtherPreview', 'bfaCommonImageEN');
  try
    try
      i := 0;
      found := False;
      while (not found) and (i <= bitfarmApp.PreviewContainer.Containers.Count - 1) do
      begin
        if bitfarmApp.PreviewContainer.Containers[i].Preview <> prev then
        begin
          if bitfarmApp.PreviewContainer.Containers[i].Preview.List <> nil then
          begin
            j := 0;
            while ((not found) and (j <= bitfarmApp.PreviewContainer.Containers[i].Preview.List.Count - 1)) do
            begin
              if bitfarmApp.PreviewContainer.Containers[i].Preview.List[j] = Doc then
                found := True;
              inc(j);
            end;
          end;
        end;
        inc(i);
      end;
      Result := found;
    except
      bitfarmLog.Write(llNormal, ltException, 'IsDocumentInOtherPreview', 'bfaCommonImageEN');
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'IsDocumentInOtherPreview', 'bfaCommonImageEN');
  end;
end;

function DeleteDocumentFromList(AThread: TThread; List: TList<TbfaDocument>; idx: Integer): Boolean;
var
  i, j, k: Integer;
  found, founddoc, docinprocess, CanClose: Boolean;
  MView : TbfaImageEnMView;
begin
  bitfarmLog.DebugBegin(llDebug, 'DeleteDocumentFromList', 'bfaCommonImageEN');
  Result := False;
  try
    try
      docinprocess := False;
      for i := 0 to bitfarmApp.PreviewContainer.Containers.Count - 1 do
      begin
        found := False;
        if bitfarmApp.PreviewContainer.Containers[i].Preview.List <> nil then
        begin
          j := bitfarmApp.PreviewContainer.Containers[i].Preview.List.Count - 1;
          while ((not found) and (j >= 0)) do
          begin
            if bitfarmApp.PreviewContainer.Containers[i].Preview.List[j] = List[idx] then
            begin
              found := True;
              if ((List[idx].GetInProcesses) and (not List[idx].InDeleteProcess)) then
                docinprocess := True
              else
              begin
                if (List = bitfarmApp.PreviewContainer.Containers[i].Preview.List) then
                begin
                  founddoc := False;
                  k := 0;
                  while ((not founddoc) and (k <= bitfarmApp.PreviewContainer.Containers[i].Preview.List.Count - 1)) do
                  begin
                    if (List[idx] = (bitfarmApp.PreviewContainer.Containers[i].Preview.List[k])) then
                    begin
                      founddoc := True;
                      if bitfarmApp.PreviewContainer.Containers[i].Preview.GetThumbnailInProcess then
                      begin
//29.08.2023 -->
//                        AThread.Synchronize(nil, //11.05.2023
//                          procedure
//                          begin
//                            bitfarmApp.PreviewContainer.Containers[i].Preview.KillThumbnailThread;
//                          end);
                        {$IFDEF IMAGEEN_SYNCHRONIZED}
                        AThread.Synchronize(nil, //11.05.2023
                          procedure
                          begin
                            bitfarmApp.PreviewContainer.Containers[i].Preview.KillThumbnailThread;
                          end);
                        {$ELSE}
                        bitfarmApp.PreviewContainer.Containers[i].Preview.KillThumbnailThread;
                        {$ENDIF}
//29.08.2023 <--
                      end;

                      try
                        if bitfarmApp.PreviewContainer.Containers[i].Preview.ThumbnailView <> nil then
                        begin
//29.08.2023 -->
//                          AThread.Synchronize(nil, //11.05.2023
//                            procedure
//                            begin
//                              bitfarmApp.PreviewContainer.Containers[i].Preview.ThumbnailView.Clear;
//                            end);
                        {$IFDEF IMAGEEN_SYNCHRONIZED}
                        AThread.Synchronize(nil, //11.05.2023
                          procedure
                          begin
                            bitfarmApp.PreviewContainer.Containers[i].Preview.ThumbnailView.Clear;
                          end);
                        {$ELSE}
                            bitfarmApp.PreviewContainer.Containers[i].Preview.ThumbnailView.Clear;
                        {$ENDIF}
//29.08.2023 <--
                        end;
                      except
                       //
                      end;
                      bitfarmApp.PreviewContainer.Containers[i].Preview.SingleView.gbAnnoNotSaved := False;  // wenn das Dokument/die Preview entfernt wird, dann mssen wir auch keine Annos mehr speichern
                      if (List[idx] = (bitfarmApp.PreviewContainer.Containers[i].Preview.ActiveDoc)) then
                        bitfarmApp.PreviewContainer.Containers[i].Preview.ActiveDoc := nil;
                    end;
                    inc(k);
                  end;
                end
                else
                begin
                  if ((bitfarmApp.PreviewContainer.Containers[i] <> bitfarmApp.PreviewContainer.ImporterItem) and (bitfarmApp.PreviewContainer.Containers[i] <> bitfarmApp.PreviewContainer.WorkplaceItem)) then
                  begin
                    AThread.Synchronize(nil,
                      procedure
                      begin
                        bitfarmApp.PreviewContainer.Containers[i].Preview.List.Clear;
                        if bitfarmApp.PreviewContainer.Containers[i].Panel <> bitfarmApp.PreviewContainer.PageSortingsItem.Panel then
                        begin
                          if bitfarmApp.PreviewContainer.Containers[i].Panel.Parent.Name <> 'dckFloating' then
                            bitfarmApp.PreviewContainer.PanelCloseQuery(bitfarmApp.PreviewContainer.Containers[i].Panel, CanClose)
                          else
                            bitfarmApp.PreviewContainer.PanelCloseQuery(bitfarmApp.PreviewContainer.Containers[i].Panel.Parent.Parent, CanClose);
                        end;
                      end);
                  end;
                end;
              end;
            end;
            dec(j);
          end;
        end;
      end;

      List[idx].EndDeleteProcess;
      if Assigned(List[idx].ThumbnailView) then  // Drag&Drop Problem
      begin
//29.08.2023 -->
//        AThread.Synchronize(nil,//11.05.2023
//          procedure
//          begin
//            bitfarmApp.PreviewContainer.ImporterItem.Preview.dctPreviewTarget.Unregister(List[idx].ThumbnailView);
//          end);
        {$IFDEF IMAGEEN_SYNCHRONIZED}
        AThread.Synchronize(nil,//11.05.2023
          procedure
          begin
            bitfarmApp.PreviewContainer.ImporterItem.Preview.dctPreviewTarget.Unregister(List[idx].ThumbnailView);
          end);
        {$ELSE}
        bitfarmApp.PreviewContainer.ImporterItem.Preview.dctPreviewTarget.Unregister(List[idx].ThumbnailView);
        {$ENDIF}
//29.08.2023 <--

      end;
//29.08.2023 -->
////10.05.2023 -->
////      if List[idx].ThumbnailView = bitfarmApp.PreviewContainer.ImporterItem.Preview.ThumbnailView then
////        bitfarmApp.PreviewContainer.ImporterItem.Preview.ThumbnailView := nil;
////      try
////        TbfaDocument(List[idx]).Free;
////      finally
////        List[idx] := nil;
////      end;
//      var NilThumbnail := List[idx].ThumbnailView = bitfarmApp.PreviewContainer.ImporterItem.Preview.ThumbnailView;
//      try
//        AThread.Synchronize(nil,
//          procedure
//          begin
//            TbfaDocument(List[idx]).Free;
//            if NilThumbnail then
//              bitfarmApp.PreviewContainer.ImporterItem.Preview.ThumbnailView := nil;
//          end);
//      finally
//        List[idx] := nil;
//      end;
//10.05.2023 <--
      {$IFDEF IMAGEEN_SYNCHRONIZED}
      var NilThumbnail := List[idx].ThumbnailView = bitfarmApp.PreviewContainer.ImporterItem.Preview.ThumbnailView;
      try
        AThread.Synchronize(nil,
          procedure
          begin
            if NilThumbnail then
              bitfarmApp.PreviewContainer.ImporterItem.Preview.ThumbnailView := nil;
            TbfaDocument(List[idx]).Free;
          end);
      finally
        List[idx] := nil;
      end;
      {$ELSE}
      var NilThumbnail := List[idx].ThumbnailView = bitfarmApp.PreviewContainer.ImporterItem.Preview.ThumbnailView;
      try
        if NilThumbnail then
          bitfarmApp.PreviewContainer.ImporterItem.Preview.ThumbnailView := nil;
        TbfaDocument(List[idx]).Free;
      finally
        List[idx] := nil;
      end;
      {$ENDIF}
//29.08.2023 <--

      List.Delete(idx);
      Result := docinprocess;
    except
      bitfarmLog.Write(llNormal, ltException, 'DeleteDocumentFromList', 'bfaCommonImageEN');
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'DeleteDocumentFromList', 'bfaCommonImageEN');
  end;
end;

function CheckSource(Source: TObject): Boolean;
begin
  try
    if (Source is TbfaDragObject) then
    begin
      Result := (not (((TbfaDragObject(Source).DragSource as TbfaImageEnMView).Tag = tagThumbnailMView) and
        (TbfaPreview((TbfaDragObject(Source).DragSource as TbfaImageEnMView).Owner).PreviewKind <> pvkMultiSingle) and
        (TbfaPreview((TbfaDragObject(Source).DragSource as TbfaImageEnMView).Owner).MultiView.MultiSelectedImagesCount > 1)));
    end
    else
    begin
      Result := (not (((Source as TbfaImageEnMView).Tag = tagThumbnailMView) and
        (TbfaPreview((Source as TbfaImageEnMView).Owner).PreviewKind <> pvkMultiSingle) and
        (TbfaPreview((Source as TbfaImageEnMView).Owner).MultiView.MultiSelectedImagesCount > 1)));
    end;
  except
    Result := False;
  end;
end;

function CheckSameDocument(Sender, Source: TObject): Boolean;
var
  docIdx: Integer;
begin
  try
    if (Source is TbfaDragObject) then
    begin
      Result := ((((Sender as TbfaImageEnMView).Tag = tagThumbnailMView) and
        ((TbfaDragObject(Source).DragSource as TbfaImageEnMView).Tag = tagThumbnailMView)) and
        ((TbfaPreview((Sender as TbfaImageEnMView).Owner).PreviewKind = pvkSingle) and
        (TbfaPreview((TbfaDragObject(Source).DragSource as TbfaImageEnMView).Owner).PreviewKind = pvkSingle)) and
        ((TbfaPreview((Sender as TbfaImageEnMView).Owner).List[0] <> (TbfaPreview((TbfaDragObject(Source).DragSource as TbfaImageEnMView).Owner).List[0]))));
    end
    else
    begin
      Result := ((((Sender as TbfaImageEnMView).Tag = tagThumbnailMView) and
        ((Source as TbfaImageEnMView).Tag = tagThumbnailMView)) and
        ((TbfaPreview((Sender as TbfaImageEnMView).Owner).PreviewKind = pvkSingle) and
        (TbfaPreview((Source as TbfaImageEnMView).Owner).PreviewKind = pvkSingle)) and
        ((TbfaPreview((Sender as TbfaImageEnMView).Owner).List[0] <> (TbfaPreview((Source as TbfaImageEnMView).Owner).List[0]))));
    end;
  except
    Result := False;
  end;
end;

function CheckIfImageAtMousePos(MView: TbfaImageEnMView): Integer;
var
  P: TPoint;
begin
  try
    P := MView.ScreenToClient(Mouse.CursorPos);
    Result := MView.ImageAtPos(P.X, P.Y);
  except
    Result := -1;
  end;
end;

function CheckIfAllDocumentsPreviewChanged(List: TList<TbfaDocument>; image: Boolean): Boolean;
var
  i: Integer;
  notchanged: Boolean;
begin
  try
    notchanged := True;
    i := 0;
    while ((notchanged) and (i <= List.Count - 1)) do
    begin
      if image then
        notchanged := ((List[i].HasPreview) and (not List[i].PreviewChanging))
      else
        notchanged := (not List[i].PreviewChanging);
      inc(i);
    end;
    Result := notchanged;
  except
    result := False;
  end;
end;

function DropZoneDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState): Boolean;
begin
  try
//    if (TbfaDragObject(Source).DragSource is TbfaImageEnMView) then
//    begin
//      if(
//          (TbfaDragObject(Source).DragKind <> dkNone)
//          and
//          (
//            (
//               (TbfaDragObject(Source).DragKind = dkPages) // Seiten werden verschoben
//               and
//               (TbfaDragObject(Source).DocumentList[0].HasPreview) // Das Dokument wovon die Seiten verschoben werden ist ein Image
//               and
//               (not TbfaDragObject(Source).DocumentList[0].PreviewChanging)
//             )
//             or
//             (
//               (TbfaDragObject(Source).DragKind = dkDocuments)
//               and
//               (bfaCommonImageEN.CheckIfAllDocumentsPreviewChanged(TbfaDragObject(Source).DocumentList, false))
//             )
//           )
//         )
//      then
//        Result := bfaCommonImageEN.CheckSource(Source)
//      else
//        Result := False;
//    end
//    else
//      Result := False;
  except
    Result := False;
  end;
end;

function DrawOneThumbWithAnnos(Fimg: TbfaImageEnVect): Boolean;
var
  iwidth, iheight, ipos: Integer;
begin
  Result := True;
  try
    Fimg.proc.convertTo24bit;

    iwidth := Round(Fimg.Bitmap.Width / 5);
    iheight := Round(Fimg.Bitmap.Height / 9);
    ipos := Round(Fimg.Bitmap.Width / 2);

    Fimg.ObjKind[-1] := iekMEMO;
//07.09.2021 ???
//    if ((iwidth <100 )or (iheight <100)) then     //-->bfacrm:ticket__show__26085
//    begin
//      iwidth:=496;
//      iheight:=390;
//      ipos:=1240;
//    end;                                          //<--bfacrm:ticket__show__26085
    Fimg.SetObjRect(-1, Bounds(ipos, 300, iwidth, iheight));
    Fimg.ObjBrushColor[-1] := gclYellow;
    Fimg.ObjBrushStyle[-1] := bsSolid;
    Fimg.ObjMemoBorderColor[-1] := clBlack;
    Fimg.ObjMemoBorderStyle[-1] := psSolid;
    Fimg.AddNewObject;
    Fimg.ObjKind[-1] := iekMEMO;
    Fimg.SetObjRect(-1, Bounds(ipos + iwidth + 100, 300 + iheight + 100, iwidth, iheight));
    Fimg.ObjBrushColor[-1] := gclBlue; //15.04.2021 clBlue;
    Fimg.ObjBrushStyle[-1] := bsSolid;
    Fimg.AddNewObject;
    Fimg.CopyObjectsToBack(False);
  except
    Result := False;
  end;
end;

function DrawOneThumbWithFtxPos(Fimg: TbfaImageEnVect): Boolean;
var
  iwidth, iheight, ipos, hObj: Integer;
begin
  Result := True;
  try
    with Fimg do
    begin
      proc.convertTo24bit;
      iwidth := Round(Fimg.IO.Params.Width / 5);
      iheight := Round(Fimg.IO.Params.Height / 9);
      ipos := Round(Fimg.IO.Params.Width / 2);

      hObj := AddNewObject; // hobj is an integer
      ObjKind[hObj] := iekBox;
      SetObjRect(hObj, Bounds(200, 1000, iwidth, iheight));
      ObjPenWidth[hObj] := 50;
      ObjPenColor[hObj] := gclRed;
      ObjPenStyle[hObj] := psDash;
      ObjBrushColor[hObj] := gclRed;
      ObjBrushStyle[hObj] := bsClear;
      ObjMemoBorderColor[hObj] := clBlack;
      ObjMemoBorderStyle[hObj] := psSolid;

      CopyObjectsToBack(False);

      Update;
    end;
  except
    Result := False;
  end;
end;

function RefreshOneThumbWithAnnos(DocView: Tfrm_Voransicht; ActiveDoc: TbfaDocument;
  Page: Integer; Layer: Int64; ThumbnailView: TbfaImageEnMView; Grad: Integer = -1): Boolean;
var
  img: TbfaImageEnVect;
  idx, i: Integer;
  AnnoObj: TbfaAnnotation;
  found: Boolean;
  iebmp2 : TIEBitmap;
begin
  Result := True;
  try
    img := TbfaImageEnVect.Create(nil);
    img.Visible := False;
    img.IO.AutoAdjustDPI := True;
    try

      if (ActiveDoc.ScanPoolView <> nil) and (ActiveDoc.ScanPoolViewLoaded) then
      begin
        img.IO.Params.ImageIndex := Page;
        iebmp2 := TIEBitmap.Create;
        try
          ActiveDoc.ScanPoolView.CopyToIEBitmap(Page, iebmp2);
          {$IFDEF ImageEN1140}
          img.Bitmap.Assign(iebmp2.VclBitmap);
          {$ELSE}
          img.IO.Bitmap.Assign(iebmp2.VclBitmap);
          {$ENDIF}
        finally
          FreeandNil(iebmp2);
        end;
      end else
      begin
        img.IO.Params.ImageIndex := DocView.img_DocView.IO.Params.ImageIndex;
        ActiveDoc.DocStream.Position := 0;
        img.IO.LoadFromStream(ActiveDoc.DocStream);
        if Grad <> -1 then
          img.Proc.Rotate(Grad);

      end;

      ActiveDoc.GetAnnotation(Page, Layer, idx);
      if idx <> -1 then
        bfaCommonImageEN.DrawOneThumbWithAnnos(img);

      ThumbnailView.SetIEBitmap(Page, img.IEBitmap);
    finally
      img.Free;
      img := nil;
    end;
  except
    Result := False;
  end;
end;

procedure RefreshTabAndFormCaption(AThread: TThread; FormName: WideString;
   TmpID : TGUID; iDocId : int64 = -1);
var
  iPreviewDocId: Int64;
begin
  try
    AThread.Synchronize(nil,
      procedure
      var
        j : Integer;
        PreviewTmpID : TGUID;
      begin
        for j := 0 to bitfarmApp.PreviewContainer.Containers.Count - 1 do
        begin
          if bitfarmApp.PreviewContainer.Containers[j].Preview.PreviewKind = pvkSingle then
          begin
            iPreviewDocId := -1;
            PreviewTmpID := GUID_NULL;
            if bitfarmApp.PreviewContainer.Containers[j].Preview.ActiveDoc <> nil then
            begin
              iPreviewDocId := bitfarmApp.PreviewContainer.Containers[j].Preview.ActiveDoc.Id;
              PreviewTmpID := bitfarmApp.PreviewContainer.Containers[j].Preview.ActiveDoc.TempID;
            end;

            if ((iDocId = -1) and (TmpID = PreviewTmpID)) or ((iDocId <> -1) and (iDocId = iPreviewDocId)) then
            begin
              if bitfarmApp.PreviewContainer.Containers[j].Preview.Floating then
              begin
                TForm(bitfarmApp.PreviewContainer.Containers[j].Panel.Parent.Owner).Caption := FormName;
              end;
              // SJ 16.09.2020 bfacrm:ticket__show__24351
              if (bitfarmApp.PreviewContainer.Containers[j] <> bitfarmApp.PreviewContainer.ViewerItem) then
                bitfarmApp.PreviewContainer.Containers[j].Tab.Caption := FormName;
            end;
          end;
        end;
      end);
  except
    bitfarmLog.Write(llNormal, ltException, 'RefreshTabAndFormCaption', 'bfaCommonImageEN');
  end;
end;

//23.05.2017 procedure ChangeDocName(AThread: TThread; Doc: TbfaDocument; prev: TbfaPreview);
procedure ChangeDocName(AThread: TThread; Docs: TList<TbfaDocument>; prev: TbfaPreview);
var
  i: Integer;
  found, rslt: Boolean;
  liSelectedCount: integer;
  lsTxt, lsDocName: string;
  req: TbfaRequest;
  docids: TStringList;
  docid: Int64;
  UserAction : PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'ChangeDocName', 'bfaCommonImageEN');
  try
    try
      if (prev <> nil) and (Docs <> nil) and (Docs.Count > 0) then
      begin
        if (Docs.Count = 1) and (Docs[0].ID = -1) and (prev.PreviewKind = pvkMulti) then
        begin
          i := 0;
          found := False;
          while ((not found) and (i <= prev.List.Count - 1)) do
          begin
            if CompareDocumentsByID(Docs[0], prev.List[i]) then
              found := true
            else
              inc(i);
          end;

          if found then
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                try
                  if (not prev.Edit.Focused) then
                  begin
                    prev.MultiView.Deselect;
                    prev.MultiView.MultiSelecting := True;
                    prev.MultiView.SelectedImage := i;
                    prev.MultiView.MultiSelecting := False;
                    prev.ChangeEditDocIdx := i;
                    prev.SetEdit;
                    prev.Edit.Text := Docs[0].DocName;
                    prev.Edit.Visible := True;
                    prev.Edit.SetFocus;
                  end else
                  begin
                    Docs[0].DocName := prev.Edit.Text;
                    prev.Edit.Visible := False;
                    prev.MultiView.SetFocus;
                    prev.MultiView.SelectedImage := i;
                    SaveNewDocName(AThread, TbfaDocument(Docs[0]), True, prev);
                  end;
                except
                  bitfarmLog.Write(llNormal, ltException, 'ChangeDocName - Synchronize', 'bfaCommonImageEN');
                end;
              end);

          end;
        end
        else
        begin

          lsDocName := Docs[0].DocName;
          docId := Docs[0].ID;
          // Macht bersetzung schwierig. Der alte Titel wird auerdem schon im Input angegeben.
          //if lsDocName <> '' then
          //  lsTxt := Format(dgettext('Shared36', 'Dokumententitel "%s" ndern ...'), [lsDocName])
          //else
//12.01.2023          lsTxt := dgettext('Shared36', 'Dokumententitel ndern ...');
          lsTxt := sCaptionChangeDocName;

          AThread.Synchronize(nil,
            procedure
            begin
//12.01.2023              rslt := bfaInputQuery(lsTxt, dgettext('Shared36', 'Bitte geben Sie einen neuen Titel ein:'), lsDocName);
              rslt := bfaInputQuery(lsTxt, sCaptionNewDocName, lsDocName);
            end);

          if rslt then
          begin
            lsDocName := trim(ParseSemicolonWithoutBackslash(lsDocName));
            if (Docs.Count = 1) and (lsDocName = Docs[0].DocName) then
            begin
//          SJ 06.12.2019 - message-box hat keinen mehrwert
//              BfShowmessage(dgettext('Shared36', 'Eingegebener Dokumententitel entspricht dem bisherigen Dokumententitel.'), AThread);
              Exit;
            end;

            docids := TStringList.Create;
            docids.Delimiter := ';';
            docids.StrictDelimiter := True;
            try
              for i := 0 to Docs.Count - 1 do
              begin
                if Docs[i].ID = -1 then
                begin
                  Docs[i].DocName := lsDocName;

                  bitfarmLog.Write(llNormal, ltInfo, 'RefreshDocumentInPreviews - Docs[i].TempID: ' + GUIDToString(Docs[i].TempID) , 'bfaCommonImageEN');
                  //10.07.2024 SD -->bfacrm:ticket__show__31605
//                  RefreshDocumentInPreviews(AThread, Docs[i], nil, nil);
                  RefreshDocumentInPreviews(AThread, Docs[i], nil, nil, True);
                  //10.07.2024 SD <--bfacrm:ticket__show__31605
                  bitfarmLog.Write(llNormal, ltInfo, 'RefreshTabAndFormCaption - Docs[i].TempID: ' + GUIDToString(Docs[i].TempID) , 'bfaCommonImageEN');
                  RefreshTabAndFormCaption(AThread, lsDocName + ' *', Docs[i].TempID);
                end
                else
                begin
                  docids.Add(IntToStr(Docs[i].ID));
                end;
              end;

              //10.07.2024 SD -->bfacrm:ticket__show__31605
//              AThread.Synchronize(nil,  // SJ 17.01.2020
//              procedure
//              var i: integer;
//              begin
//                bitfarmApp.ShowDocumentProperties(bitfarmApp.CurrentContainer[0], bitfarmApp.GetActivePreview);
//              end);
              //10.07.2024 SD <--bfacrm:ticket__show__31605

              if docids.Count > 0 then
              begin
                req := TbfaRequest.Create;
                try
                  req.ReqType := 'reqSaveDocName';
                  req.UserID := bitfarmApp.User.ID;
                  req.Profile := bitfarmApp.Profile;
                  req.Gdocid := Docs[0].ID;
                  req.DataString := lsDocName;
                  req.Parameter := docids.DelimitedText;
                  req.Lang := bitfarmApp.Lang;
                  bitfarmApp.MainSocket.SendRequestToServer(req);

                  req := bitfarmApp.MainSocket.ReceiveResponse(AThread);
                  if req = nil then
                    Exit;

//27.11.2018 Ticket 16957 -->
                  if req.ReqType = 'respAuthError' then
                  begin
                    BfShowMessage(dgettext('Shared36',  'Sie sind fr diesen Vorgang nicht berechtigt. Bitte melden Sie sich erneut an.'), AThread);
                    UserAction := bitfarmApp.CreateUserAction;
                    UserAction^.ActionName := 'actRelogin';
                    bitfarmApp.MainThread.Add(UserAction);
                    Exit;
                  end
                  else
//27.11.2018 Ticket 16957 <--
                  if req.ReqType = 'respError' then
                    BfShowMessage(dgettext('Shared36',  'Der Dokumententitel konnte nicht gendert werden.') + #13#10 + req.DataString, AThread)
                  else
                  begin
                    bitfarmApp.RefreshDoc(AThread);
//                SJ 16.09.2020 - RefreshDocumentInPreviews wird in RefreshDoc aufgerufen
//                              - Thumbnail aktualisieren nicht ntig ?!
//                    RefreshDocumentInPreviews(AThread, Docs[0], prev, nil, False, False, True);
                    if Docs[0].InEditMode then
                      RefreshTabAndFormCaption(AThread, lsDocName + ' *', Docs[0].TempID, Docs[0].ID)
                    else
                      RefreshTabAndFormCaption(AThread, lsDocName, Docs[0].TempID, Docs[0].ID);
                  end;
                finally
                  FreeAndNil(req);
                end;
              end;

              //11.07.2024 SD -->bfacrm:ticket__show__31605
              AThread.Synchronize(nil,
              procedure
              var i: integer;
              begin
                for i := 0 to bitfarmApp.PreviewContainer.Containers.Count - 1 do
                begin
                    if bitfarmApp.PreviewContainer.Containers[i].Preview.ActiveDoc = bitfarmApp.GetActivePreview.ActiveDoc then
                    begin
                      bitfarmApp.ShowDocumentProperties(bitfarmApp.CurrentContainer[0], bitfarmApp.PreviewContainer.Containers[i].Preview);
                    end;
                end;
              end);
              //11.07.2024 SD <--bfacrm:ticket__show__31605

            finally
              FreeAndNil(docids);
            end;

          end;

        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'ChangeDocName', 'bfaCommonImageEN');
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ChangeDocName', 'bfaCommonImageEN');
  end;
end;

procedure SaveNewDocName(AThread: TThread; Doc: TbfaDocument; Save: Boolean; prev: TbfaPreview);
var
  i: Integer;
  found: Boolean;
begin
  bitfarmLog.DebugBegin(llDebug, 'SaveNewDocName', 'bfaCommonImageEN');
  try
    try
      if prev <> nil then
      begin
        if prev.PreviewKind = pvkMulti then
        begin
          if (prev.ChangeEditDocIdx <> -1) then
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                try
                  if Save then
                  begin
                    Doc.DocName := prev.Edit.Text;

                    if Doc.DocName <> '' then
                    begin
                      if (Length(Doc.DocName) > 15) then
                        {$IFDEF IMAGEEN1140}
                        prev.MultiView.ImageBottomText[prev.ChangeEditDocIdx] := Copy(Doc.DocName, 1, 15) + '...'
                        {$ELSE}
                        prev.MultiView.ImageBottomText[prev.ChangeEditDocIdx].Caption := Copy(Doc.DocName, 1, 15) + '...'
                        {$ENDIF}
                      else
                        {$IFDEF IMAGEEN1140}
                        prev.MultiView.ImageBottomText[prev.ChangeEditDocIdx] := Doc.DocName;
                        {$ELSE}
                        prev.MultiView.ImageBottomText[prev.ChangeEditDocIdx].Caption := Doc.DocName;
                        {$ENDIF}
                    end
                    else
                      {$IFDEF IMAGEEN1140}
                      prev.MultiView.ImageBottomText[prev.ChangeEditDocIdx] := ' ';
                      {$ELSE}
                      prev.MultiView.ImageBottomText[prev.ChangeEditDocIdx].Caption := ' ';
                      {$ENDIF}

                    if (Doc.ID = -1) or (Doc.InEditMode) then
                      {$IFDEF IMAGEEN1140}
                      prev.MultiView.ImageBottomText[prev.ChangeEditDocIdx] := prev.MultiView.ImageBottomText[prev.ChangeEditDocIdx] + ' *';
                      {$ELSE}
                      prev.MultiView.ImageBottomText[prev.ChangeEditDocIdx].Caption := prev.MultiView.ImageBottomText[prev.ChangeEditDocIdx].Caption + ' *';
                      {$ENDIF}

                    if prev = bitfarmApp.PreviewContainer.ImporterItem.Preview then
                      bitfarmApp.SetImporterDocName(Doc.DocName);

                    Doc.ImporterDocNameModified := True;
                    {$IFDEF IMAGEEN1140}
                    prev.MultiView.BottomTextFont.Color := stlControl.TextColor;
                    prev.MultiView.SelectedFontColor := stlControl.TextColor; //14.09.2022 clBlack;
                    {$ELSE}
                    prev.MultiView.ImageBottomText[prev.ChangeEditDocIdx].Font.Color := stlControl.TextColor; //14.09.2022 clBlack;
                    {$ENDIF}

                  end;
                  prev.Edit.Visible := False;
                finally
                  prev.ChangeEditDocIdx := -1;
                  prev.ChangeDocNameInProcess := False;
                  { SJ 24.11.2022 - TODO : eigentlich so:
                  // bitfarmApp.ShowDocumentProperties(Doc, prev); // SJ 17.01.2020
                  // ABER: dann kann das falsche Dokument selektiert sein.
                  // Dann mssen wir also auch das Doc setzen...
                  }
                  bitfarmApp.ShowDocumentProperties(bitfarmApp.CurrentContainer[0], bitfarmApp.GetActivePreview); // SJ 17.01.2020
                end;
              end);
            RefreshTabAndFormCaption(AThread, Doc.DocName, Doc.TempID, Doc.ID);

          end
          else
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                BfMessageDlg(dgettext('Shared36', 'Der Dokumententitel konnte nicht gendert werden.'), mtError, [mbOK]);
              end);
          end;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'SaveNewDocName', 'bfaCommonImageEN');
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SaveNewDocName', 'bfaCommonImageEN');
  end;
end;

procedure AutoCrop(Proc: TImageEnProc; CutCol: TRGB; ColRange, MaxCutPer, CutPer: byte);
var
  iPx, iPy, iX1, iX2, iY1, iY2, iMaxX, iMaxY, iCutCount, iValue: Integer;
  MinCol, MaxCol: TRGB;
  Image: TIEBitmap;
begin
   // Variablen initalisieren
  Image := Proc.AttachedIEBitmap;
  iMaxX := Round(Image.Width * (MaxCutPer / 100));
  iMaxY := Round(Image.Height * (MaxCutPer / 100));
  iValue := Round(CutCol.r - (ColRange / 2));
  if iValue < 0 then
    MinCol.r := 0
  else
    MinCol.r := iValue;
  iValue := Round(CutCol.g - (ColRange / 2));
  if iValue < 0 then
    MinCol.g := 0
  else
    MinCol.g := iValue;
  iValue := Round(CutCol.b - (ColRange / 2));
  if iValue < 0 then
    MinCol.b := 0
  else
    MinCol.b := iValue;
  iValue := Round(CutCol.r + (ColRange / 2));
  if iValue > 255 then
    MaxCol.r := 255
  else
    MaxCol.r := iValue;
  iValue := Round(CutCol.g + (ColRange / 2));
  if iValue > 255 then
    MaxCol.g := 255
  else
    MaxCol.g := iValue;
  iValue := Round(CutCol.b + (ColRange / 2));
  if iValue > 255 then
    MaxCol.b := 255
  else
    MaxCol.b := iValue;
  iX1 := 0;
  iX2 := Image.Width;
  iY1 := 0;
  iY2 := Image.Height;

   // Analyse des oberen Randes
  for iPy := 0 to iMaxY do
  begin
    iCutCount := 0;
    for iPx := 0 to (Image.Width - 1) do
    begin
      if ((Image.Pixels[iPx, iPy].B >= MinCol.b) and (Image.Pixels[iPx, iPy].B <= MaxCol.b)) and ((Image.Pixels[iPx, iPy].g >= MinCol.g) and (Image.Pixels[iPx, iPy].g <= MaxCol.g)) and ((Image.Pixels[iPx, iPy].R >= MinCol.r) and (Image.Pixels[iPx, iPy].R <= MaxCol.r)) then
        inc(iCutCount, 1);
    end;
    if iCutCount < Round(Image.Width * (CutPer / 100)) then
    begin
      iY1 := iPy;
      break;
    end
    else
      iY1 := iMaxY;
  end;

   // Analyse des unteren Randes
  for iPy := (Image.Height - 1) downto (Image.Height - iMaxY) do
  begin
    iCutCount := 0;
    for iPx := 0 to (Image.Width - 1) do
    begin
      if ((Image.Pixels[iPx, iPy].B >= MinCol.b) and (Image.Pixels[iPx, iPy].B <= MaxCol.b)) and ((Image.Pixels[iPx, iPy].g >= MinCol.g) and (Image.Pixels[iPx, iPy].g <= MaxCol.g)) and ((Image.Pixels[iPx, iPy].R >= MinCol.r) and (Image.Pixels[iPx, iPy].R <= MaxCol.r)) then
        inc(iCutCount, 1);
    end;
    if iCutCount < Round(Image.Width * (CutPer / 100)) then
    begin
      iY2 := iPy;
      break;
    end
    else
      iY2 := Image.Height - iMaxY;
  end;

   // Analyse des linken Randes
  for iPx := 0 to iMaxX do
  begin
    iCutCount := 0;
    for iPy := 0 to (Image.Height - 1) do
    begin
      if ((Image.Pixels[iPx, iPy].B >= MinCol.b) and (Image.Pixels[iPx, iPy].B <= MaxCol.b)) and ((Image.Pixels[iPx, iPy].g >= MinCol.g) and (Image.Pixels[iPx, iPy].g <= MaxCol.g)) and ((Image.Pixels[iPx, iPy].R >= MinCol.r) and (Image.Pixels[iPx, iPy].R <= MaxCol.r)) then
        inc(iCutCount, 1);
    end;
    if iCutCount < Round(Image.Width * (CutPer / 100)) then
    begin
      iX1 := iPx;
      break;
    end
    else
      iX1 := iMaxX;
  end;

   // Analyse des rechten Randes
  for iPx := (Image.Width - 1) downto (Image.Width - iMaxX) do
  begin
    iCutCount := 0;
    for iPy := 0 to (Image.Height - 1) do
    begin
      if ((Image.Pixels[iPx, iPy].B >= MinCol.b) and (Image.Pixels[iPx, iPy].B <= MaxCol.b)) and ((Image.Pixels[iPx, iPy].g >= MinCol.g) and (Image.Pixels[iPx, iPy].g <= MaxCol.g)) and ((Image.Pixels[iPx, iPy].R >= MinCol.r) and (Image.Pixels[iPx, iPy].R <= MaxCol.r)) then
        inc(iCutCount, 1);
    end;
    if iCutCount < Round(Image.Width * (CutPer / 100)) then
    begin
      iX2 := iPx;
      break;
    end
    else
      iX2 := Image.Width - iMaxX;
  end;
  Proc.Crop(iX1, iY1, iX2, iY2);
end;

procedure CreateBitmapOnePage(OldBmp: Graphics.TBitmap; var NewBmp: Graphics.TBitmap; W, H: Integer);
begin
  try
    ResizeBitmap(OldBmp, W, H, clWhite);
    with NewBmp do
    begin
      Width := W;
      Height := H;
      Canvas.Pen.Style := psSolid;
      Canvas.Pen.Width := 1;
      Canvas.Pen.Color := clDkGray;
      Canvas.Brush.Color := clBlack; //clLtGray;//clWhite;
      Canvas.Pen.Color := clBlack;
      Canvas.Rectangle(5, 5, W - 5, H - 5);
      Canvas.StretchDraw(Rect(7, 7, W - 7, H - 7), OldBmp);
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'CreateBitmapOnePage', 'bfaCommonImageEn');
  end;
end;

procedure CreateBitmapMorePages(OldBmp: Graphics.TBitmap; var NewBmp: Graphics.TBitmap; W, H: Integer);
begin
  try
    ResizeBitmap(OldBmp, W, H, clWhite);
    with NewBmp do
    begin
      Width := W;
      Height := H;
      Canvas.Pen.Style := psSolid;
      Canvas.Pen.Width := 1;
      Canvas.Pen.Color := clDkGray;
      Canvas.Brush.Color := clWhite;
      Canvas.Rectangle(15, 15, W - 5, H - 5);
      Canvas.Rectangle(10, 10, W - 10, H - 10);
      Canvas.Pen.Color := clBlack;
      Canvas.Rectangle(5, 5, W - 15, H - 15);
      Canvas.Pen.Color := clDkGray;
      Canvas.StretchDraw(Rect(7, 7, W - 17, H - 17), OldBmp);
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'CreateBitmapMorePages', 'bfaCommonImageEn');
  end;
end;

(*05.09.2018
procedure Tfrm_Main.Compress(CompMode: Integer);
/////////////////////////////////////////////////////////////////////////
///                                                                   ///
/// Komprimiert alle selektierten Bilder nach dem eingestellten       ///
/// Kompressions Mode                                                 ///
///                                                                   ///
/// CompMode            Funktion                                      ///
///  0                  Automatische auswahl passender Kompression    ///
///  1                  Packbits Kompression                          ///
///  2                  FAX G4   Kompression                          ///
///  3                  LZW      Kompression                          ///
///  4                  JPEG     Kompression                          ///
///  5                  keine    Kompression                          ///
///                                                                   ///
/////////////////////////////////////////////////////////////////////////
var
   iCount, iIdx, iMode, iCol: Integer;
   dPer: Double;
   rgb: TRGB;
begin
   GgfLogEvnt('Tfrm_Main.Compress');

   for iCount := 0 to (img_Pages.MultiSelectedImagesCount - 1) do
   begin
      sGProcText := 'Bild analysieren';
      iIdx := img_Pages.MultiSelectedImages[iCount];
      img_Pages.Proc.AttachedIEBitmap := img_Pages.GetTIEBitmap(iIdx);
      if CompMode <> 0 then
         iMode := CompMode
      else
      begin
         iCol := img_Pages.Proc.CalcImageNumColors;
         case iCol of
            0..2:
               iMode := 2;
            3..256:
               iMode := 3;
         else
         begin
            dPer := img_Pages.Proc.GetDominantColor(rgb);
            if dPer < 20 then
               iMode := 4
            else
               iMode := 3;
         end;
         end;
      end;
      sGProcText := 'Bild filtern';
      case iMode of
         1:
         begin
            img_Pages.Proc.ConvertToBWThreshold(-2);
            img_Pages.MIO.Params[iIdx].TIFF_Compression := ioTIFF_PACKBITS;
         end;
         2:
         begin
            img_Pages.Proc.ConvertToBWThreshold(-2);
            img_Pages.MIO.Params[iIdx].TIFF_Compression := ioTIFF_G4FAX;
         end;
         3:
            img_Pages.MIO.Params[iIdx].TIFF_Compression := ioTIFF_LZW;
         4:
            img_Pages.MIO.Params[iIdx].TIFF_Compression := ioTIFF_JPEG;
         5:
            img_Pages.MIO.Params[iIdx].TIFF_Compression := ioTIFF_UNCOMPRESSED;
      else
         img_Pages.MIO.Params[iIdx].TIFF_Compression := ioTIFF_UNCOMPRESSED;
      end;
   end;
   img_Pages.UpdateEx(True);
   preview(true, true);
end;

procedure Tfrm_Main.ChangeColor(ColMode: Integer);
var
   iCount, iIdx: Integer;
begin
   GgfLogEvnt('Tfrm_Main.ChangeColor');

   for iCount := 0 to (img_Pages.MultiSelectedImagesCount - 1) do
   begin
      sGProcText := 'Bild filtern';
      iIdx := img_Pages.MultiSelectedImages[iCount];
      img_Pages.Proc.AttachedIEBitmap := img_Pages.GetTIEBitmap(iIdx);
      case ColMode of
         0:
         begin
            img_Pages.Proc.ConvertToBWThreshold(-2);
            img_Pages.MIO.Params[iIdx].SamplesPerPixel := 1;
            img_Pages.MIO.Params[iIdx].BitsPerSample := 1;
         end;
         1:
         begin
            img_Pages.Proc.ConvertToGray;
            img_Pages.MIO.Params[iIdx].SamplesPerPixel := 1;
            img_Pages.MIO.Params[iIdx].BitsPerSample := 4;
         end;
         2:
         begin
            img_Pages.Proc.ConvertTo(16, ieOrdered);
            img_Pages.MIO.Params[iIdx].SamplesPerPixel := 1;
            img_Pages.MIO.Params[iIdx].BitsPerSample := 4;
         end;
         3:
         begin
            img_Pages.Proc.ConvertToGray;
            img_Pages.MIO.Params[iIdx].SamplesPerPixel := 1;
            img_Pages.MIO.Params[iIdx].BitsPerSample := 8;
         end;
         4:
         begin
            img_Pages.Proc.ConvertTo(256, ieOrdered);
            img_Pages.MIO.Params[iIdx].SamplesPerPixel := 1;
            img_Pages.MIO.Params[iIdx].BitsPerSample := 8;
         end;
         5:
         begin
            img_Pages.Proc.ConvertTo24Bit;
            img_Pages.MIO.Params[iIdx].SamplesPerPixel := 3;
            img_Pages.MIO.Params[iIdx].BitsPerSample := 8;
         end;
      end;
   end;
   img_Pages.UpdateEx(True);
   preview(true, true);
end;
*)

initialization
  InitializeCriticalSection(CommonImg_CS);

finalization
  DeleteCriticalSection(CommonImg_CS);

end.




