unit bfaCommonUtils;
//
//  bitfarm-Archiv Base Objects Common Utils v36
//
//
//
//
//------------------------------------------------------------------------------

interface

uses
  VCL.Graphics, Messages, Math, Windows, SysUtils{, gnugettext, cxEdit, cxStyles}
  ;

resourcestring

//////////// Messages //////////////////////////////////////////////////////////
///
  sMsgLoginErrorUserLocked = 'Login failure! The User is locked!';
  //sMsgNotAllowedCharachters               = 'Not allowed charachters: ';
  sMsgNotAllowedCharachters = 'Nicht erlaubte Zeichen: ';
  sMsgAllowedCharachters = 'Erlaubte Zeichen: ';
  sNotAllowedChar = '!\*?`{|}' + #39 + #160;
//  sRefreshImport                          = 'Dokumente im Importer werden aktualisiert...';
//////////// Captions //////////////////////////////////////////////////////////
///
  sCaptionNegatedSearch = 'bei Suche negieren';
  sCaptionChangeDocName = 'Dokumententitel ndern ...';
  sCaptionNewDocName = 'Bitte geben Sie einen neuen Titel ein:';
  sDay = 'Tag';
  sSysBitfarm = 'bitfarm-Archiv V3.6';
  sCaptionUserDefined = 'User defined';
  sCaptionUserContainer = 'Users and groups container';
  sCaptionAddStsFieldContainer = 'Additional- and statusfield container';
  sCaptionEdit = 'Edit';
  sCaptionReload = 'Reload';
  sCaptionDefault = 'Default';
  sCaptionChange = 'Change';
  sCaptionCancel = 'Cancel';
  sCaptionSave = 'Save';
  sCaptionNone = 'None';
  sCaptionEditBox = 'Textfield';
  sCaptionDateTime = 'Datefield';
  sCaptionComboBox = 'Dropdown box';
  sCaptionCheckComboBox = 'Check-Dropdown box';
  sCaptionInterval = 'Intervalfield';
  sCaptionInteger = 'Integer';
  sCaptionFloat = 'Float';
  sCaptionCurrency = 'Currency';
  sCaptionStatusField = 'Status field';
  sCaptionRequired = 'Required';
  sCaptionStrictMode = 'Strict - mode';
  sCaptionFileName = 'Filename at send or save';
  sCaptionRedAtMinusValue = 'Red text at minus value';
  sCaptionUseModificationsOnBaseFieldToo = 'Use modifications on basefield too';
  sCaptionBlackAndWhite = 'Black & White';
  sCaptionGrayscale4bit = 'Grayscale (4bit)';
  sCaptionGrayscale8bit = 'Grayscale (8bit)';
  sCaptionColor = 'Color';
  sCaptionJPG = 'JPG';
  sCaptionPackBits = 'PackBits';
  sCaptionLZW = 'LZW';
  sCaptionNoComprerssion = 'No compression';
  sCaptionCCITT4 = 'CCITT 4';
  sCaptionAll = 'Alle';
  sCaptionAllBuiltIn = 'Alle (Builtin)';
  // SJ 06.01.2020 sCaptionAutoZoom
  sCaptionAutoZoomOrig = 'Originalauflsung (100%)';
  sCaptionAutoZoomAuto = 'Automatisch anpassen ';
  sCaptionAutoZoomWidth = 'Seitenbreite anpassen';
  sCaptionAutoZoomHeight = 'Seitenhhe anpassen';
  sCaptionAutoZoomSelection = 'Selektion';
  sCaptionAutoZoomOff = 'Autozoom aus';
  sCaptionAutoZoomLastSetting = 'letzte Benutzereinstellung';
  strReqAnmeldung = 'reqAnmeldung';
  strReqDoc = 'reqDoc';
  strReqVoransicht = 'reqVoransicht';
  strReqIEV = 'reqIev';
  strReqIevCheck = 'reqIevCheck';
  strReqSendIev = 'reqSendIev';
  strReqSendVoransicht = 'reqSendVoransicht';
  strReqSendOri = 'reqSendOri';
  strRespAuth = 'respAuth';
  strReqOri = 'reqOri';
  strIEVPublic = 'public';
  strIEVPrivate = 'private';
  strReqIevDelete = 'reqIevDelete';
  strReqQueuecount = 'reqQueueCount';
  strReqDuplicateDoc = 'reqDuplicateDoc';
  strReqResetOriginal = 'reqResetOriginal';
  strReqMoveDoc = 'reqMoveDoc';
  strRespSendReady = 'respSendReady';
  strRespSendComplete = 'respSendComplete';
  strRespOK = 'respOK';
  strRespError = 'respError';
  strReqFinished = 'finished';
  strXMLEndTag = '</bfreq>';

const
  BFAFONT = 10;
  BFAFONTSETTINGS = 110;


//
  vctpNormal = 0;		// ViewerConnectionType Normal (Default 3.5)
  vctpSocket = 1;   // ViewerConnectionType Socket (Client Server Connection)
  sctpSSL = 0;      // SocketType SSL (only at vctpSocket)
  sctpNoSSL = 1;    // SocketType NoSSL (only at vctpSocket)
  annoPub = 0;      // Public Annotation
  annoPriv = 1;     // Private Annotation
  respOk = 0;       // Socket response OK
  respError = 1;    // Socket response Error
  respConflict = 2; // Socket response Conflicted Document or IEV

  UM_ENSURERESTORED = WM_USER + 1;

//
//////// Log Types//  ////////////////////////////////////////////////////////
//  ltInfo = 'INFO:';
//  ltDebug = 'DEBUG:';
//  ltError = 'ERROR:';
//  ltWarning = 'WARNING:';
//  ltException = 'EXCEPTION - ERROR:';

//
////////// Registry Key Strings  ///////////////////////////////////////////////
  sSysBaseRegKey = 'SOFTWARE\bitfarm\Archiv_V4';
  sSysGUIMainForm = 'GUI\MainForm';
  sSysGUIMainFormTreeViewAdmin = 'GUI\MainForm\TreeView\Admin';
  sSysGUIMainFormTreeViewScanImport = 'GUI\MainForm\TreeView\ScanImport';
  sSysGUIMainFormTreeViewView = 'GUI\MainForm\TreeView\View';
  sSysGUIClientFrame = 'GUI\ClientFrame';
  sSysGUIGlobal = 'GUI\Global';
  sSysGUIViewer = 'Viewer';
  sSysGUIDocEditor = 'DocEditor';
  sSysLastFrameKind = 'LastFrameKind';
  sSysLastTreeViewKind = 'LastTreeViewKind';
  sSysLastArcID = 'LastArcID';
  sSysLastRecordArcID = 'LastRecordArcID';
  sSysDocEditorZoom = 'DocEditorZoom';
  sSysDocEditorScrollStep = 'DocEditorScrollStep';
  sSysDocEditorZoomStep = 'DocEditorZoomStep';
  sSysDocEditorMultiZoomStep = 'DocEditorMultiZoomStep';
  sSysClientLogPath = 'ClientLogPath';
  sSysClientPath = 'ClientPath';
  sSysRoundedPopup = 'UseRoundedPopup';
  sSysShowTreeViewUserContainers = 'ShowTreeViewUserContainers';
  sSysShowTreeViewAddfieldContainers = 'ShowTreeViewAddFieldContainers';
  sSysSkinFile = 'SkinFile';
  sSysSkinName = 'SkinName';
//
////////// INI Strings  ////////////////////////////////////////////////////////
  sSysOptionsSection = 'Options';
  sSysConnectionSection = 'Connection';
  sSysServerSection = 'Server';
  sSysScriptsSection = 'Scripts';
  sSysPass = 'Pass';
  sSysSUPass = 'supass';
  sSysDB = 'DB';
  sSysDBProvider = 'db_provider';
  sSysAutoreconnect = 'auto_reconnect';
  sSysUsertimeout = 'user_timeout';
  sSysServerPath = 'ServerPath';
  sSysBfaServer = 'Server';
  sSysBfaServerPort = 'Port';
  sSysBfaServerVersion = 'version';
  sSysSystem = 'System';
  sSysCount = 'Count';
  sSysProfile = 'Profil';
  sSysProfil_ = 'Profil_';
  sSysProfilName = 'ProfilName';
  sSysScannerID = 'ScannerID';
  sSysScannerName = 'ScannerName';
  sSysScannerApiType = 'ScannerApiType';
  sSysScanByID = 'ScanByID';
  sSysScanByName = 'ScanByName';
  sSysColorMode = 'ColorMode';
  sSysBitDepth = 'BitDepth';
  sSysDPI = 'DPI';
  sSysCompression = 'Compression';
  sSysOrientation = 'Orientation';
  sSysFormat = 'Format';
  sSysADF = 'ADF';
  sSysDuplex = 'Duplex';
  sSysProportional = 'Proportional';
  sSysTransfer = 'Transfer';
  sSysCompatibleMode = 'CompatibleMode';
  sSysFilter = 'Filter';
  sSysFilterThreshold = 'FilterThreshold';
  sSysBrightness = 'Brightness';
  sSysBrightnessMin = 'BrightnessMin';
  sSysBrightnessMax = 'BrightnessMax';
  sSysContrast = 'Contrast';
  sSysContrastMin = 'ContrastMin';
  sSysContrastMax = 'ContrastMax';
  sSysThreshold = 'Threshold';
  sSysThresholdMin = 'ThresholdMin';
  sSysThresholdMax = 'ThresholdMax';
  sSysInverse = 'Inverse';
  sSysUseFrame = 'UseFrame';
  sSysStapel = 'Stapel';
  sSysDeletePage = 'DeletePage';
  sSysDeletePageKB = 'DeletePageKB';
  sSysDefault = 'Default';
  sSysGlobal = 'Global';
  sSysFrameLeft = 'FrameLeft';
  sSysFrameRight = 'FrameRight';
  sSysFrameTop = 'FrameTop';
  sSysFrameBottom = 'FrameBottom';
  sSysIgnoreTWAINError = 'IgnoreTWAINError';
  sSysNormalButton = 'Normal';
  sSysRecordButton = 'Record';
  sSysTreeView = 'Treeview';
  sSysAdminExpanded = 'AdminExpanded';
  sSysAdminLastID = 'AdminLastID';
  sSysImportExpanded = 'ImportExpanded';
  sSysImportLastID = 'ImportLastID';
  sSysViewExpanded = 'ViewExpanded';
  sSysViewLastID = 'ViewLastID';
  sSysAdmin = 'Admin';
  sSysContainer = 'Container';
  sSysResult = 'Result';
  sSysEditorOptions = 'EditorOptions';
  sSysResubOptions = 'ResubOptions';
  sSysHotSearchOptions = 'HotSearchOptions';
  sSysColumnTitle = 'ColumnTitle';
  sSysColumnInfo = 'ColumnInfo';
  sSysColumnComment = 'ColumnComment';
  sSysColumnAlarm = 'ColumnAlarm';
  sSysColumnModified = 'ColumnModified';
  sSysColumnArchive = 'ColumnArchive';
  sSysColumnDocDate = 'ColumnDocDate';
  sSysResubOnStartup = 'ResubOnStartup';
  sSysResubTimer = 'ResubTimer';
  sSysResubTimerInterval = 'ResubTimerInterval';
  sSysReturnToSender = 'ReturnToSender';
  sSysEmailreminder = 'Emailreminder';
  sSysNotifyByMail = 'NotifyByMail';
  sSysShowAllAddfields = 'ShowAllAddfields';
  sSysDefaultArchiveGroup = 'DefaultArchiveGroup';
  sSysDefaultAddfieldGroup = 'DefaultAddfieldGroup';
  sSysDefaultStatefieldGroup = 'DefaultStatefieldGroup';
  sSysDefaultResubStatefield = 'DefaultResubStatefield';
  sSysAdminFullscreen = 'AdminFullscreen';
  sSysResubFavsInPreview = 'ResubFavsInPreview';
  sSysDefaultArchiveGroupRights = 'DefaultArchiveGroupRights';
  sSysDefaultAddfieldGroupRights = 'DefaultAddfieldGroupRights';
  sSysDefaultStatefieldGroupRights = 'DefaultStatefieldGroupRights';
  sSysShowViewerThumbnail = 'ShowViewerThumbnail';
  sSysShowImporterThumbnail = 'ShowImporterThumbnail';
  sSysShowWorkplaceThumbnail = 'ShowWorkplaceThumbnail';
  sSysInvertDirection = 'InvertDirection';
  sSysOCRAutoClipbrd = 'OCRAutoClipbrd';
  sSysOCRAdd = 'OCRAdd';
  sSysOCRKey = 'OCRKey';
  sSysAutoZoom = 'AutoZoom';
  sSysInUnDockedPanel = 'InUnDockedPanel';
  sSysImporterInUnDockedPanel = 'ImporterInUnDockedPanel';
  sSysImporterOpenDocInImporter = 'ImporterOpenDocInImporter';
  sSysWorkplaceAutoEditMode = 'WorkplaceAutoEditMode';
  sSysWorkplaceInUnDockedPanel = 'WorkplaceInUnDockedPanel';
  sSysWorkplaceOpenDocInWorkplace = 'WorkplaceOpenDocInWorkplace';
  sSysWorkplaceOpenDoc = 'WorkplaceOpenDoc';
  sSysAutoEditMode = 'AutoEditMode';
  sSysDocNoAction = 'DocNoAction';
  sSysGeneralOptions = 'GeneralOptions';
  sSysDefaultSaveDirectory = 'DefaultSaveDirectory';
  sSysOverwriteLocalSave = 'OverwriteLocalSave';
  sSysRowColorEvenOdd = 'RowColorEvenOdd';
  sSysDefaultPrinter = 'DefaultPrinter';
  sSysDefaultPrinterName = 'DefaultPrinterName';
  sSysPluginButtons = 'PluginButtons';
  sSysUseDefaultPrinter = 'UseDefaultPrinter';
  sSysNoAutoHintByAnnos = 'NoAutoHintByAnnos';
  sSysHintBallons = 'HintBallons';
  sSysShowLinkCount = 'ShowLinkCount';
  sSysShowRoot = 'ShowRoot';
  sSysAutoPreview = 'AutoPreview';
  sSysAutoViewerAtArchiveChange = 'AutoViewerAtArchiveChange';
  sSysChangePageByEnter = 'ChangePageByEnter';
  sSysAutoCheckout = 'AutoCheckout';
  sSysCheckoutNewDocuments = 'CheckoutNewDocuments';
  sSysAutoCheckin = 'AutoCheckin';
  sSysDisplayCheckoutAtShutdown = 'DisplayCheckoutAtShutdown';
  sSysNoLoginWindow = 'NoLoginWindow';
  sSysMsLogon = 'MsLogon';
  sSysDefaultEmail = 'DefaultEmail';
  sSysDefaultCleanup = 'DefaultCleanup';
  sSysTimeSyncServer = 'TimeSyncServer';
  sSysTimeSync = 'TimeSync';
  sSysExportPDF = 'ExportPDF';
  sSysOleOutlook = 'OleOutlook';
  sSysMailTo = 'MailTo';
  sSysComboAutoDown = 'ComboAutoDown';
  sSysAlternativeScanMode = 'AlternativeScanMode';
  sSysAlertWindow = 'AlertWindow';
  sSysPluginTimeOut = 'PluginTimeOut';
  sSysShowDocList = 'ShowDocList';
  sSysSearchOptions = 'SearchOptions';
  sSysGUIOptions = 'GUIOptions';
  sSysSystemOptions = 'SystemOptions';
  sSysPreviewDlgOptions = 'PreviewDlgOptions';
  sSysAdminOptions = 'AdminOptions';
  sSysLimit = 'Limit';
  sSysHistoryBookmarkLimit = 'HistoryBookmarkLimit';
  sSysNewDocumentsFirst = 'NewDocumentsFirst';
  sSysAutoDisplay = 'AutoDisplay';
  sSysSearchLastYear = 'SearchLastYear';
  sSysSQLFullText = 'SQLFulltext';
  sSysDocModified = 'DocModified';
  sSysFtxPos = 'FtxPos';
  sSysShowDocLinks = 'ShowDocLinks';
  sSysShowDocLinksInTab = 'ShowDocLinksInTab';
  sSysDragDropAsWindows = 'DragDropAsWindows';
  sSysSetAnnoDPI = 'SetAnnoDPI';
  sSysUseFileNameAsDocName = 'UseFileNameAsDocName';
  sSysDontResetOnArcSet = 'DontResetOnArcSet';
  sSysFulltextSearch = 'FulltextSearch';
  sSysDocTagsSearch = 'DocTagsSearch';
  sSysAnnoTxtSearch = 'AnnoTxtSearch';
  sSysFieldSearch = 'FieldSearch';
  sSysResetFieldsAfterArchiving = 'ResetFieldsAfterArchiving';
  sSysPrintAfterArchiving = 'PrintAfterArchiving';
  sSysNoOCR = 'NoOCR';
  sSysLateOCR = 'LateOCR';
  sSysCopyGdocidLink = 'CopyGdocidLink';
  sSysImportFilter = 'ImportFilter';
  sSysImportColor = 'ImportColor';
  sSysImportHighRes = 'ImportHighRes';
  sSysImportBarcode = 'ImportBarcode';
  sSysCalculateOnSelectedRecordsOnly = 'CalculateOnSelectedRecordsOnly';
  sSysEnableSymlinks = 'EnableSymlinks';
  sSysSymlinkAddfields = 'SymlinkAddfields';
  sSysUseOnlyGeneralSearchField = 'UseOnlyGeneralSearchField';
  sSysStoredFloatingPosX = 'StoredFloatingPosX';
  sSysStoredFloatingPosY = 'StoredFloatingPosY';
  sSysStoredFloatingOldPosX = 'StoredFloatingOldPosX';
  sSysStoredFloatingOldPosY = 'StoredFloatingOldPosY';
  sSysSearchPanelFloatingPosX = 'SearchPanelFloatingPosX';
  sSysSearchPanelFloatingPosY = 'SearchPanelFloatingPosY';
  sSysSearchPanelFloatingWidth = 'SearchPanelFloatingWidth';
  sSysSearchPanelFloatingHeight = 'SearchPanelFloatingHeight';
  sSysSearchPanelWidth = 'SearchPanelWidth';
  sSysStoredFloatingWidth = 'StoredFloatingWidth';
  sSysStoredFloatingHeight = 'StoredFloatingHeight';
  sSysStoredFloatingOldWidth = 'StoredFloatingOldWidth';
  sSysStoredFloatingOldHeight = 'StoredFloatingOldHeight';
  sSysStoredFloatingFullScreen = 'StoredFloatingFullScreen';
  sSysSearchPanelFloating = 'SearchPanelFloating';
  sSysMarkedDocs = 'MarkedDocs';
  sSysCheckboxDialogs = 'CheckboxDialogs';
  sSysPageSize = 'PageSize';
  sSysPageHeight = 'PageHeight';
  sSysPageWidth = 'PageWidth';
  sSysBorderLeft = 'BorderLeft';
  sSysBorderRight = 'BorderRight';
  sSysBorderTop = 'BorderTop';
  sSysBorderBottom = 'BorderBottom';
  sSysAnnos = 'Annos';
  sSysPubAnnos = 'PubAnnos';
  sSysPrivAnnos = 'PrivAnnos';
  sSysStationery = 'Stationery';
  sSysCenter = 'Center';
  sSysRotate = 'Rotate';
  sSysCopies = 'Copies';
  sSysSort = 'Sort';
  sSysMerge = 'Merge';
  sSysFileType = 'FileType';
  sSysEmailType = 'EmailType';
  sSysLogDir = 'LogDir';
  sSysLogLevel = 'LogLevel';
  sSysAdminGUIType = 'AdminGUIType';
  sSysAdminLayoutInTheFrame = 'AdminLayoutInTheFrame';
  sSysGlobalGUIType = 'GlobalGUIType';
  sSysUserName = 'Username';
  sSysProvider = 'Provider';
  sSysPassword = 'Password';
  sSysServer = 'Server';
  sSysDatabase = 'Database';
  sSysPort = 'Port';
  sSysClientVersion = 'ClientVersion';
  sSysOffline = 'OFFLINE';
  sSysArchive = 'Archive';
  sSysVersions = 'Versions';
  sSysVersion = 'Version';
  sSysClean = 'Clean';
  sSysRibbonView = 'RibbonView';
  sSysEmpty = '<Empty>';
  sSysURL = 'https://www.bitfarm-archiv.de/';
  sSysBfaApplication = 'bfaApplication';
  sSysViewerFiles = 'Viewer-Files';
  sSysBPLS = 'BPLS';
  sSysLocale = 'Locale';
  sSysLayouts = 'Layouts';
  sSysInis = 'Inis';
  sSysDefaultSkin = 'Office2010Black';
  sSysRibbonColorSchemeName = 'UserSkin';
  sSysLogin = 'Login';
  sSysProfil = 'Profil';
  sSysUserKind = 'UserKind';
  sSysOptions = 'Options';
  sSysGroupName = 'Groupname';
  sSysTdxScreenTipStyle = 'TdxScreenTipStyle';
  sSysGlobalFontName = 'GlobalFontName';
  sSysTreeViewFontName = 'TreeViewFontName';
  sSysPixels = 'Pixels';
  sSysGlobalFontSize = 'GlobalFontSize';
  sSysTreeViewFontSize = 'TreeViewFontSize';
  sSysDefaultGlobalFontName = 'Segoe UI';
  sSysDefaultTreeViewFontName = 'Tahoma';
  sSysUsrID = 'usrid';
  sSysGrpID = 'groupid';
  sSysFormKind = 'FormKind';
  sSysContainerForm = 'ContainerForm';
  sSysTreeNodeAlwaysFromDB = 'TreeNodeAlwaysFromDB';
  sSysError = 'Error';
  sSysErrorCode = 'Errorcode';
  sSysUser = 'User';
  sSysSUUser = 'suuser';
  sSysGroup = 'Group';
  sSysArchiveRole = 'ArchiveRole';
  sSysApplicationRole = 'ApplicationRole';
  sSysSavePass = 'SavePass';
  sSysDomain = 'Domain';
  sSysOfflineDB = 'OfflineDB';
  sSysRightViewer = 'read';
  sSysRightImporter = 'import';
  sSysLanguage = 'Language';
  sSysDeutsch = 'Deutsch';
  sSysDE = 'de';
  sSysEnglish = 'English';
  sSysEN = 'en';
  sSysRead_ = 'read_';
  sSysWrite_ = 'write_';
  sSysModify_ = 'modify_';
  sSysGRead_ = 'gread_';
  sSysGWrite_ = 'gwrite_';
  sSysGModify_ = 'gmodify_';
  sSysVersion36 = 36;
  sSysVersion40 = 40;
  sSysUpdate = 'Update';
  sSysUpdateFailed = 'UpdateFailed';
  sSysStartingArea = 'StartingArea';
  sSysNegativeCurrency = 'NegativeCurrency';
  sSysCloseBookmarkDialog = 'CloseBookmarkDialog';
  sSysRememberLastTool = 'RememberLastTool';
  sSysDefaultSkinRes = 'bfaDefault.skinres';
  sSysBaseSkinRes = 'bfaBase.skinres'; // GPL Skins
  sSysWinClassName = 'bitfarm.Viewer.V4';
  sSysMainFormPropertiesINI = 'MainFormProperties.ini';
  sSysOptionsDialogPropertiesINI = 'OptionsDialogProperties.ini';
  sSysViewerConfigINI = 'ViewerConfig.ini';
  sSysAdminFramePropertiesINI = 'AdminFrameProperties.ini';
  sSysAdminFrameUserPropertiesINI = 'AdminFrameUserProperties.ini';
  sSysAdminFrameGroupPropertiesINI = 'AdminFrameGroupProperties.ini';
  sSysAdminFrameAddFieldPropertiesINI = 'AdminFrameAddFieldProperties.ini';
  sSysAdminFrameStsFieldPropertiesINI = 'AdminFrameStsFieldProperties.ini';
  sSysBitfarmApplicationFileName = 'bitfarmApplication.exe';
  sSysCreateUserForm = 'CreateUserForm';
  sSysUserPropertiesForm = 'UserPropertiesForm';
  sSysScannerProfilesINI = 'ScannerProfiles.ini';
  sSysUseDBMonitor = 'UseDBMonitor';
  sSysTreeViewINI = 'TreeView.ini';
  sSysGlobalOptionsINI = 'GlobalOptions.ini';
  sSysEditorOptionsINI = 'EditorOptions.ini';
  sSysAdminFrame = 'AdminFrame';
  sSysEditor = 'Editor.ini';
  sSysUserFrameComponentsINI = 'UserFrameComponents.ini';
  sSysGroupFrameComponentsINI = 'GroupFrameComponents.ini';
  sSysAdditionalFieldFrameComponentsINI = 'AdditionalFieldFrameComponents.ini';
  sSysStatusFieldFrameComponentsINI = 'StatusFieldFrameComponents.ini';
  sSysMainFormDockingIni = 'MainFormDocking.ini';
  sSysImportDockingIni = 'ImportDocking.ini';
  sSysViewerDockingIni = 'ViewerDocking.ini';
  sSysAdminFrameDockingIni = 'AdminFrameDocking.ini';
  sSysClientFrameDockingIni = 'ClientFrameDocking.ini';
  sSysLytDefault = 'Default view';
  sSysLytNotebook = 'Notebook view';
  sSysLytGroup = 'Group view';
  sSysLytTab = 'Tab view';
  sSysLytEmbeddedMini = 'Embedded Mini view';
  sSysLytEmbeddedNormal = 'Embedded Normal view';
  sSysTab = 'Tab';
  sSysNotebook = 'Notebook';
  sSysMini = 'Mini';
  sSysNormal = 'Normal';
  sSysNoSSL = 'NoSSL';
  sSysEdition = 'edition';
  sSysGnuViewerDomain = 'ViewerV36';

/////////// Columns ////////////////////////////////////////////////////////////
  sColGrpName = 'grpname';
  sColUserName = 'username';
  sColUserEmail = 'email';
  sColFirstName = 'firstname';
  sColLastName = 'lastname';
  sColMiddleName = 'middlename';
  sColDescription = 'description';
  sColEmail = 'email';
  sColUserDescription = 'userdescription';
  sColGroupDescription = 'groupdescription';
  sColFieldDescription = 'fielddescription';
  sColState = 'status';
  sColGrpID = 'groupid';
  sColUserID = 'userid';
  sColFieldID = 'fieldid';
  sColName = 'name';
  sColID = 'id';
  sColType = 'type';
  sColObjType = 'objtype';
  sColArcName = 'arcname';
  sColColumType = 'column_type';
  sColProfilName = 'profilname';
  sColProfilID = 'profilid';
  sColClientID = 'clientid';
  sColObjID = 'objid';
  sColIdxL = 'idxl';
  sColIdxR = 'idxr';
  sColRights = 'rights';
  sColParentID = 'parentid';
  sColLevel = 'level';
  sColArcID = 'arcid';
  sColObjName = 'objname';
  sColObjValue = 'objvalue';
  sColPassword = 'password';
  sColBgrPicture = 'bgrpicture';
  sColDocName = 'docname';
  sColDocTXT = 'doctxt';
  sColInheritPermission = 'inherit_permission';
  sColInheritAdditionalFields = 'inherit_addfield';
  sColAddFieldID = 'fieldid';
  sColDisplayname = 'displayname';
  sColFieldType = 'fieldtype';
  sColValueType = 'valuetype';
  sColControlType = 'controltype';
  sColMode = 'mode';
  sColOptions = 'options';
  sColChkPrg = 'chkprg';
  sColFunction = 'function';
  sColDefaultValue = 'defaultvalue';
  sColIndexTableID = 'indextableid';
  sColStateFunction = 'statefunction';
  sColEnabled = 'enabled';
  sColControlItems = 'controlitems';
  sColSize = 'size';
  sColPosition = 'position';
  sColColor = 'color';
  sColTab = 'tab';
  sColLayout = 'layout';
  sColDocLoc = 'docloc';
  sColExtLoc = 'extloc';
  sColOriLoc = 'oriloc';
  sColPageCount = 'pagecount';
  sColFileType = 'filetype';
  sColGDocID = 'gdocid';
  sColTimeStamp = 'timestamp';
  sColDocDate = 'docdate';
  sColKind = 'kind';
  sColIcon = 'icon';
  sColMandant = 'mandant';
  sColUserMandant = 'userMandant';
  sColGroupMandant = 'groupmandant';
  sColCfgID = 'cfgid';
  sColRoleID = 'roleid';
  sColIdx = 'idx';
  sColCheckBox = 'checkbox';
  sPrmLgrID = 'prm_lgrid';
  sPrmGroupList = 'prm_grouplist';
  sPrmClientID = 'prm_clientid';
  sPrmProfilID = 'prm_profilid';
  sPrmHasChildren = 'prm_haschildren';
  sPrmParam = 'prm_param';
  sPrmUserName = 'prm_username';
  sPrmResult = 'prm_result';
  sPrmKind = 'prm_kind';
  sPrmRecordStore = 'prm_recordstore';
  sPrmRecordArchive = 'prm_recordarchive';
  sPrmIcon = 'prm_icon';
  sPrmStatus = 'prm_status';
  sPrmState = 'prm_status';
  sPrmPassword = 'prm_password';
  sPrmUserID = 'prm_userid';
  sPrmParentID = 'prm_parentid';
  sPrmObjID = 'prm_objid';
  sPrmType = 'prm_type';
  sPrmTableName = 'prm_tablename';
  sPrmRoot = 'prm_root';
  sPrmRootType = 'prm_roottype';
  sPrmUserType = 'prm_usertype';
  sPrmGroupType = 'prm_grouptype';
  sPrmLeft = 'prm_left';
  sPrmRight = 'prm_right';
  sPrmRights = 'prm_rights';
  sPrmIdxL = 'prm_idxl';
  sPrmIdxR = 'prm_idxr';
  sPrmIdx = 'prm_idx';
  sPrmID = 'prm_id';
  sPrmObjType = 'prm_objtype';
  sPrmLevel = 'prm_level';
  sPrmLayoutID = 'prm_layoutid';
  sPrmMandant = 'prm_mandant';
  sPrmStore = 'prm_store';
  sPrmArchive = 'prm_archive';
  sPrmFirstName = 'prm_firstname';
  sPrmLastName = 'prm_lastname';
  sPrmUserPass = 'prm_userpass';
  sPrmUserEmail = 'prm_useremail';
  sPrmDescription = 'prm_description';
  sPrmEmail = 'prm_email';
  sPrmUserStatus = 'prm_userstatus';
  sPrmGroupName = 'prm_groupname';
  sPrmArcName = 'prm_arcname';
  sPrmArcBackPic = 'prm_arcbackpic';
  sPrmBgrPicture = 'prm_bgrpicture';
  sPrmDocName = 'prm_docname';
  sPrmArcType = 'prm_arctype';
  sPrmArcStatus = 'prm_arcstatus';
  sPrmCurUserID = 'prm_curuserid';
  sPrmDMSAdmin = 'prm_dmsadmin';
  sPrmInheritPermission = 'prm_inheritpermission';
  sPrmInheritAdditionalFields = 'prm_inheritaddfield';
  sPrmGroupID = 'prm_groupid';
  sPrmObjName = 'prm_objname';
  sPrmIDs = 'prm_ids';
  sPrmOnlyName = 'prm_onlyname';
  sPrmDeleted = 'prm_deleted';
  sPrmLocked = 'prm_locked';
  sPrmArchiveID = 'prm_arcid';
  sPrmDMSRoot = 'prm_dmsroot';
  sPrmDisplayName = 'prm_displayname';
  sPrmFieldType = 'prm_fieldtype';
  sPrmValueType = 'prm_valuetype';
  sPrmControlType = 'prm_controltype';
  sPrmMode = 'prm_mode';
  sPrmOptions = 'prm_options';
  sPrmChkPrg = 'prm_chkprg';
  sPrmFunction = 'prm_function';
  sPrmDefaultValue = 'prm_defaultvalue';
  sPrmIndexTableID = 'prm_indextableid';
  sPrmStateFunction = 'prm_statefunction';
  sPrmEnabled = 'prm_enabled';
  sPrmControlItems = 'prm_controlitems';
  sPrmDatabaseName = 'prm_databasename';
  sPrmColumnName = 'prm_columnname';
  sPrmColumn = 'prm_column';
  sPrmAddFieldID = 'prm_fieldid';
  sPrmSize = 'prm_size';
  sPrmColor = 'prm_color';
  sPrmSysGrpUsrID = 'prm_sysgrpusrid';
  sPrmPosition = 'prm_position';
  sPrmTab = 'prm_tab';
  sPrmRead = 'prm_read';
  sPrmWrite = 'prm_write';
  sPrmModify = 'prm_modify';
  sPrmUnsetRights = 'prm_unsetrights';
  sPrmInherit = 'prm_inherit';
  sPrmArchiveLayout = 'prm_layout';
  sPrmGDocID = 'prm_gdocid';
  sPrmDocTxt = 'prm_doctxt';
  sPrmDocTags = 'prm_doctags';
  sPrmAddFieldType = 'prm_addfieldtype';
  sPrmStsFieldType = 'prm_stsfieldtype';
  sPrmUserContainerType = 'prm_usercontainertype';
  sPrmAddStsContainerType = 'prm_addstscontainertype';
  sPrmArchiveLayoutID = 'prm_archivelayoutid';
  sPrmContainerType = 'prm_containertype';
  sPrmListType = 'prm_listtype';
  sPrmLayoutIDs = 'prm_layoutids';
  sPrmSQLType = 'prm_sqltype';
  sPrmDeleteMitcontainer = 'prm_deletemitcontainer';
  sPrmRoleID = 'prm_roleid';
  sPrmUserManagement = 'prm_usermanagement';
  sPrmNewParentID = 'prm_newparentid';
  sPrmNewObjID = 'prm_newobjid';
  sPrmMandantID = 'prm_mandantid';
  sPrmMiddleName = 'prm_middlename';
  sPrmContainerID = 'prm_containerid';
  sPrmUsrIdx = 'prm_useridx';
  sPrmGrpIdx = 'prm_groupidx';
  sPrmDBName = 'prm_dbname';
  sPrmSaveImmediately = 'prm_saveimmediately';
  sPrmDocLoc = 'prm_docloc';
  sPrmOriLoc = 'prm_oriloc';
  sPrmExtLoc = 'prm_extloc';
  sPrmSrcLoc = 'prm_srcloc';
  sPrmCheckout = 'prm_checkout';
  sPrmRevSave = 'prm_revsave';
  sPrmModifiedUserID = 'prm_modifyuserid';
  sPrmArcID = 'prm_arcid';
  sPrmPagecount = 'prm_pagecount';
  sPrmDocType = 'prm_doctype';
  sPrmFileType = 'prm_filetype';
  sPrmObjLayoutID = 'prm_objlayoutid';
  sPrmGrpList = 'prm_grplist';
  sColumnUserUserName = 'colUserName';
  sColumnUserFirstName = 'colUserFirstName';
  sColumnUserLastName = 'colUserLastName';
  sColumnUserDescription = 'colUserDescription';
  sColumnUserEmail = 'colUserEmail';
  sColumnUserState = 'colUserState';
  sColumnUserID = 'colUserID';
  sColumnGroupName = 'colGroupName';
  sColumnGroupDescription = 'colGroupDescription';
  sColumnGroupID = 'colGroupID';
  sColumnLevel = 'colLevel';
  sColumnName = 'colName';
  sColumnID = 'colID';
  sColumnType = 'colType';
  sColumnObjType = 'colObjType';
  sColumnDescription = 'colDescription';
  sColumnArchiveName = 'colArchiveName';
  sColumnArchiveDescription = 'colArchiveDescription';
  sColumnArchiveID = 'colArchiveID';
  sColumnArchiveLayoutID = 'colArchiveLayoutID';
  sColumnAddFieldID = 'colAddFieldID';
  sColumnDisplayName = 'colDisplayName';
  sColumnAddStsFieldDescription = 'colAddStsFldDescription';
  sColumnDefaultValue = 'colDefaultValue';
  sColumnControlItems = 'colControlItems';
  sColumnFieldType = 'colFieldType';
  sColumnValueType = 'colValueType';
  sColumnControlType = 'colControlType';
  sColumnMode = 'colMode';
  sColumnOptions = 'colOptions';
  sColumnChkPrg = 'colChkPrg';
  sColumnIndexTableID = 'colIndexTableID';
  sColumnStateFunction = 'colStateFunction';
  sColumnFunction = 'colFunction';
  sColumnEnabled = 'colEnabled';
  sColumnSize = 'colSize';
  sColumnGDocID = 'colGDocID';
  sColumnDocLoc = 'colDocLoc';
  sColumnTimeStamp = 'colTimeStamp';
  sColumnDocDate = 'colDocDate';
  sColumnPageCount = 'colPageCount';
  sColumnFileType = 'colFileType';
  sColumnKind = 'colKind';
  sColumnIcon = 'colIcon';
  sColumnIdx = 'colIdx';
  sColumnDocName = 'colDocName';
  sColumnDocTXT = 'colDocTXT';
  sTvwUsers = 'tvwUsers';
  sLvlUsers = 'lvlUsers';
  sGrdUsers = 'grdUsers';
  sTblSysLayout = 'sys_layout';
  sTblSysGrpUsr = 'sys_grpusr';
  sTblSysUsr = 'sys_usr';
  sTblSysGrp = 'sys_grp';
  sTblSysDocIdx = 'sys_docidx_';
  sTblSysArc = 'sys_arc';
  sTblSysAddField = 'sys_field';
  sSysBIGINT = 'BIGINT';
  sSysTINYINT = 'TINYINT';
  sSysINT = 'INT';
  sSysVARCHAR = 'VARCHAR';
  sSysDATETIME = 'DATETIME';
  sSysDOUBLE = 'DOUBLE';
  sSysFLOAT = 'FLOAT';
  sSysDECIMAL = 'DECIMAL';
  sSysNUMERIC = 'NUMERIC';
  sSysVARCHAR255 = 'VARCHAR (255)';
  sSpSelectTreenodeByLgrID = 'sp_select_treenode_by_lgrid';
  sSpSelectDocumentByGDocID = 'sp_select_document_by_gdocid';
  sSpNodeHasChildren = 'sp_select_node_has_children';
  sSpSelectUserByID = 'sp_select_user_by_id';
  sSpLogin = 'sp_login';
  sSpSelectDMSRoot = 'sp_select_dms_root';
  sSpSelectLayoutRights = 'sp_select_layout_rights';
  sSpSelectCfgByParams = 'sp_select_cfg_by_params';
  sSpCheckIfObjectExistsOnLevel = 'sp_check_if_object_exists_on_level';
  sSpSelectObjectDetailsByID = 'sp_select_object_details_by_id';
  sSpSelectLayoutIDbyObjectIDs = 'sp_select_layout_id_by_object_ids';
  sSpSelectArchiveApplicationRightsByUser = 'sp_select_archive_application_rights_by_user';
  sSpSelectLayoutRoots = 'sp_select_layout_roots';
  sSpSelectUserContainers = 'sp_select_user_containers';
  sSpCheckIfExistsAndHasRight = 'sp_check_if_exists_and_has_right';
  sSpSelectLayoutArchivesWithIdxParams = 'sp_select_layout_archives_with_idx_params';
  sSpUpdateUserPwd = 'sp_update_pwd';
  sSpInsertObjectToLayout = 'sp_insert_object_to_layout';
  sSpCreateUser = 'sp_insert_user';
  sSpCheckIfUserAdminInOtherContainer = 'sp_checkif_user_admin_in_other_container';
  sSpSelectObjectsMandant = 'sp_select_objects_mandant';
  sSpCheckUser = 'sp_check_user';
  sSpCheckGroup = 'sp_check_group';
  sSpUpdateUser = 'sp_update_user';
  sSpCreateGroup = 'sp_insert_group';
  sSpUpdateGroup = 'sp_update_group';
  sSpInsertNewGroupToSysGrpUsr = 'sp_insert_new_group_to_sys_grpusr';
  sspSelectGroupSysGrpUsrParentID = 'sp_select_sys_grpusr_parentid';
  sSpSelectGroupSysGrpUsrID = 'sp_select_group_sys_grpusr_id';
  sSpSelectGroupByID = 'sp_select_group_by_id';
  sSpCreateArchive = 'sp_create_archive';
  sSpSelectArchiveNameByID = 'sf_select_archivename_by_id';
  sSpSelectProfiles = 'sp_select_profiles';
  sSpSelectCfgByID = 'sp_select_cfg_by_id';
  sSpSelectContainerObjects = 'sp_select_container_objects';
  sSpSelectArchivesByUserID = 'sp_select_archives_by_userid';
  sSpSelectWhereObjMember = 'sp_select_where_obj_member';
  sSpSelectLayoutUsersAndGroups = 'sp_select_layout_users_and_groups';
  sSpSelectLayoutWhereObjMember = 'sp_select_layout_where_obj_member';
  sSpSelectFields = 'sp_select_fields';
  sSpSelectApplicationRightsByUser = 'sp_select_application_rights_by_user';
  sSpUpdateLayoutRights = 'sp_update_layout_rights';
  sSpUpdateContainerDescription = 'sp_update_container_description';
  sSpSelectContainerDescription = 'sp_select_container_description';
  sSpSelectArchiveAncestorObjects = 'sp_select_archive_ancestor_objects';
  sSpCopyNode = 'sp_copy_node';
  sSpSelectFieldPermissions = 'sp_select_field_permissions';
  sSpUpdateInheritedFieldRights = 'sp_update_inherited_field_rights';
  sSpSelectMaxUsrGrpIdx = 'sp_select_max_usergroup_idx';
  sSpSelectGroupMembers = 'sp_select_group_members';
  sSpSelectDMSRootArchiveID = 'sp_select_dmsroot_archive_id';
  sSpUpdateFieldinMapping = 'sp_update_field_in_mapping';
  sSpUpdateFieldInheritedMapping = 'sp_update_inherited_field_mapping';
  sSpSelectAllFields = 'sp_select_all_fields';
  sSpFieldByArchiveID = 'sp_select_field_by_archiveid';
  sSpInsertDocument = 'sp_insert_document';
  sSpInsertDocTxt = 'sp_insert_doctxt';
  sSpSelectArchiveByArcID = 'sp_select_archive_by_arcid';
  sColTypWideString = 'WideString';
  sColTypInteger = 'Integer';
  sColTypLargeInt = 'LargeInt';
  sColTypDateTime = 'DateTime';
  sSysBMP = 'BMP';
  sSysPNG = 'PNG';
  sSys_red = '_red';
  sSys_blue = '_blue';
  sSys_green = '_green';
  sSys_grey = '_grey';
  sSys_yellow = '_yellow';
  sSys_violet = '_violet';
  sSys_orange = '_orange';
  sSysDMSRoot = 'DMSRoot';
  sSysDMSAdmin = 'DMSAdmin';
  sSysTemp = 'Temp';
  sSysAppData = 'AppData';
  sSysBfaLOG = 'BfaLOG';
  sSysBitfarmApplication = 'bitfarmApplication';
  sSysDEBUG = 'DEBUG';
  sSysLOG = 'LOG';
  sSysScanPoolTMP = 'ScanPool.TMP';
  sSysBitfarmDirectory = 'bitfarmv4';
  sSysMySQL = 'MySQL';
  sSysSQLServer = 'SQL Server';
  sSysPostgreSQL = 'PostgreSQL';
  sSysOracle = 'Oracle';
  sSysSELECT = 'SELECT';
  sSysFROM = 'FROM';
  sSysWHERE = 'WHERE';
  sSysAddFieldColumnPrefix = 'add_';
  sSysEnableCheckBox = 'EnableCheckBox';
  sSysAndOrComboBox = 'AndOrComboBox';
  sSysOperatorComboBox = 'OperatorComboBox';
  sSysTextEdit = 'TextEdit';
  sSysComboBox = 'ComboBox';
  sSysDateEdit = 'DateEdit';
  sSysCurrencyEdit = 'CurrencyEdit';
  sSysCalcEdit = 'CalcEdit';
  sSysCheckComboBox = 'CheckComboBox';
  sSysCheckBox = 'CheckBox';
  sSysIntegerEdit = 'IntegerEdit';
  sSysButton = 'Button';
  sSysNotCheckbox = 'NOTCheckBox';
  sSysAddButton = 'AddButton';
  sSysLookupButton = 'LookupButton';
  sSysTopPanel = 'TopPanel';
  sSysBottomPanel = 'BottomPanel';
  sSysSearchButton = 'SearchButton';
  sSysResetButton = 'ResetButton';
  sSysLayoutControl = 'LayoutControl';
  sSysEditButton = 'EditButton';
  sSysLookupComboBox = 'LookupComboBox';
  sSysSaveButton = 'SaveButton';
  sSysReloadButton = 'ReloadButton';
  sSysDefaultButton = 'DefaultButton';
  sSysCancelButton = 'CancelButton';
  sSysEditArchiveName = 'edtFavArchives';
  sSysEditArchiveIDS = 'edtFavArchivIDs';
  sSysLow = 'Low';
  sSysHigh = 'High';
  MySQLMaxRowSize = 65535;

//
////////// Rights bit //////////////////////////////////////////////////////////
///  sys_layout
///
///  Bei Berechtigung nderung MUSS AUCH die folgenede sps auch gendert werden !!!!!!!
///      - sp_select_archivesbyuserid
///      - sp_insert_objecttolayout
///      - ...

/// sys_layout
//  rAppArchiveManagement = 1;
//  rAppUserManagement = 2;
//  rAppGroupManagement = 4;
//  rAppFieldManagement = 8;
//  rAppCreateWorkflow = 16;
//  rAppModifyWorkflow = 32;
//  rAppDeleteWorkflow = 64;
//  rAppCancelWorkflow = 128;
//  rAppLockUser = 256;
//  rAppModifyuserPwd = 512;
//  rAppResetUserPwd = 1024;
//  rAppImport = 2048;
//  rAppView = 4096;

/// Version36
  rightList = 1;
  rightRead = 2;
  rightModify = 4;
  rightWrite = 8;
  rightEmail = 16;
  rightPrint = 32;
  rightLink = 64;
  rightImport = 128;
  rightHistory = 256;
  rightMove = 512;
  rightAWrite = 1024;
  rightARead = 2048;
  rightAModify = 4096;
  rightAPWrite = 8192;  // private Annorechte sind NUR fr die Freigabe (Eintrag in sys_docxs) niemals Rolle oder Archivberechtigung!
  rightAPRead = 16384;  // private Annorechte sind NUR fr die Freigabe (Eintrag in sys_docxs) Grund: fr den eigenen privaten Layer bentigt man kein Recht
  rightWFBreak = 32768;
  rightListProtokoll = 65536;
  rightAdmin = 131072;
  rightDelete = 262144;
  rightExport = 524288;
  rightRevSave = 1048576;
  rightAPModify = 2097152;  // private Annorechte sind NUR fr die Freigabe (Eintrag in sys_docxs)
  rRoleSearch = rightList or rightRead or rightARead;
  rRoleImport = rRoleSearch or rightModify or rightImport or rightLink or rightAWrite;
  rRoleStandard = rRoleImport or rightWrite or rightEmail or rightPrint or rightHistory;
  rRolePower = rRoleStandard or rightMove or rightRevSave or rightWFBreak or rightDelete or rightExport;
  rRoleAdmin = rRolePower or rightAdmin or rightAModify;

  (* // da wir die Provate Annorechte wohl erstmal nicht bentigen, werden die auch in der Rollen nicht gesetzt
  rRoleSearch = rightSearch or rightShow or rightARead or rightAPRead;

  rRoleImport = rightSearch or rightShow or rightModify or rightImport or rightLink
                  or rightMove or rightARead or rightAWrite or rightAPRead or rightAPWrite;

  rRoleStandard = rightSearch or rightShow or rightModify or rightImport
                  or rightWrite or rightEmail or rightPrint or rightLink or rightHistory or rightRevSave
                  or rightMove or rightARead or rightAWrite or rightAPRead or rightAPWrite;

  rRolePower = rightSearch or rightShow or rightModify or rightImport
                  or rightWrite or rightEmail or rightPrint or rightLink or rightHistory or rightRevSave
                  or rightMove or rightARead or rightAWrite or rightAPRead or rightAPWrite
                  or rightWFBreak or rightDelete or rightExport;

  rRoleAdmin = rRolePower or rightAdmin or rightAModify or rightAPModify;
  *)

/// Zusatzfeld und Statusfeld Berechtigung
  rFieldRead = 1;
  rFieldWrite = 2;
  rFieldModify = 4;

//
////////// UniDac Providers ////////////////////////////////////////////////////
  providerMySQL = 0; //UniDac MySQL Provider
  providerMsSQL = 1; //UniDac Microsoft SQL Server Provider
  providerPostgreSQL = 2; //UniDac Postgre SQL Provider
  providerOracleSQL = 3; //UniDac Oracle Provider
//
////////// Application Class Error Codes ///////////////////////////////////////
  ecApplicationConnectionNotInitialized = 1001;
  ecApplicationCreateNewUserFailure = 1002;
  ecApplicationConnectionInitializationFailure = 1003;
  ecApplicationLogNotInitialized = 1004;
  ecApplicationFailureinInit = 1005;
  ecApplicationINIFileNotFound = 1006;
  ecApplicationLoginFailure = 1007;
  ecApplicationSetConnectionFailure = 1008;
  ecApplicationSetApplicationRightsFailure = 1009;
  ecApplicationSetApplicationRightsUserKindFailure = 1010;
  ecApplicationBadConVersion = 1011;
//
////////// User Class Error Codes //////////////////////////////////////////////
  ecUserNotInitialized = 2001;
  ecUserConnectionIsNotAvailable = 2002;
  ecUserFailureInSetApplicationRights = 2003;
  ecUserFailureInInit = 2004;
  ecUserConnectionOrLogIsNotInitialized = 2005;
  ecUserFailureInLoadUser = 2006;
  ecUserFailureInSetUser = 2007;
  ecUserFailureInSave = 2008;
//
///////// Archive Class Error Codes ////////////////////////////////////////////
  ecArchiveConnectionIsNotAvailable = 3001;
  ecArchiveFailureInLoadArchive = 3002;
  ecArchiveFailureInChangeStoreID = 3003;
  ecArchiveFailureInSetConnection = 3004;
  ecArchiveFailureInCreateNewAdditionalField = 3005;
  ecArchiveFailureArcNotLoaded = 3006;
  ecArchiveConnectionOrLogNotInitialized = 3007;
  ecArchiveFailureInInit = 3008;
  ecArchiveFailureInSave = 3009;
  ecArchiveIsNotLoaded = 3010;
  ecArchiveFailureInAddObject = 3011;
  ecArchiveFailureInRemoveObject = 3012;
  ecArchiveFailureInAddAdditionalField = 3013;
  ecArchiveFailureInSelectAdditionalFields = 3014;
  ecArchiveFailureInRemoveAdditionalField = 3015;
  ecArchiveFailureInLoadAdditionalFields = 3016;
  ecArchiveFailureInLoadStatusFields = 3017;
  ecArchiveFailureInSelectStatusFields = 3018;
  ecArchiveFailureInSaveGUILayout = 3019;
  ecArchiveFailureInUpdateObject = 3020;
  ecArchiveFailureInLoadUsersAndGroups = 3021;
  ecArchiveFailureInSaveUsersAndGroupsContainer = 3022;
  ecArchiveFailureInSaveAdditionalFields = 3023;
  ecArchiveFailureInLoadContainerPermissions = 3024;
  ecArchiveFailureInLoadContainerFields = 3025;
  ecArchiveFailureInSaveContainerPermissionsList = 3026;
  ecArchiveFailureInSaveContainerFieldsList = 3027;
  ecArchiveFailureInRefreshObject = 3028;
//
///////// Connection Class Error Codes /////////////////////////////////////////
  ecConnectionDatabaseFailure = 4001;
  ecConnectionGetUserIDByNameFailure = 4002;
  ecConnectionCreateNewDocumentFailure = 4003;
  ecConnectionCreateNewArchiveFailure = 4004;
  ecConnectionSaveDocTXTFailure = 4005;
  ecConnectionCreateNewUserFailure = 4006;
  ecConnectionLoadArchiveFailure = 4007;
  ecConnectionChangeStoreIDFailure = 4008;
  ecConnectionLoadDocumentFailure = 4009;
  ecConnectionCreateNewGDocIDFailure = 4010;
  ecConnectionCreateNewAdditionalFieldFailure = 4011;
  ecConnectionFailureInCreateDocIdxTable = 4012;
  ecConnectionAddFldInvalidFieldType = 4013;
  ecConnectionExceptionInCreateNewFieldInDocumentIndex = 4014;
  ecConnectionAddFldCannotAlterOrUpDateTable = 4015;
  ecConnectionAddFldCannotCreateNewDocIdxTable = 4016;
  ecConnectionAddFldFieldNameOrTypeIsEmpty = 4017;
  ecConnectionCreateNewFieldInDocumentIndexFailure = 4018;
  ecConnectionFailureInInit = 4019;
  ecConnectionLogIsNotInitialized = 4020;
  ecConnectionCreateNewAdditionalFieldInsertMappingFailure = 4021;
  ecConnectionAddFldCannotAlterTable = 4022;
  ecConnectionAddFldCannotUpDateTable = 4023;
  ecConnectionSaveVocabularyFailure = 4024;
  ecConnectionStartWorkflowFailure = 4025;
  ecConnectionSelectArchivesFailure = 4026;
  ecConnectionLoginFailure = 4027;
  ecConnectionLoadUserFailure = 4028;
  ecConnectionSelectClientsFailure = 4029;
  ecConnectionGetLayoutObjectsFailure = 4030;
  ecConnectionGetLayoutRootObjectsFailure = 4031;
  ecConnectionGetLayoutRootUserRightsFailure = 4032;
  ecConnectionGetLayoutWithIdxParamsFailure = 4033;
  ecConnectionCheckUserMembershipFailure = 4034;
  ecConnectionGetArchivesByUserIDFailure = 4035;
  ecConnectionSelectUsersFailure = 4036;
  ecConnectionSelectGroupsFailure = 4037;
  ecConnectionCreateArchiveFailure = 4038;
  ecConnectionArchiveNameAlreadyExsits = 4039;
  ecConnectionCreateArchiveFailureCannotInsertUser = 4040;
  ecConnectionCreateArchiveFailureCannotInsertNewMandantIntoSysLayout = 4041;
  ecConnectionCreateArchiveFailureCannotInsertNewRootIntoSysArc = 4042;
  ecConnectionAddObjectToLayoutFailure = 4043;
  ecConnectionObjectAlreadyExsits = 4044;
  ecConnectionGetDmsRootFailure = 4045;
  ecConnectionCheckIfObjectExsitsOnLevelFailure = 4046;
  ecConnectionSelectObjectDetailsByIDFailure = 4047;
  ecConnectionCreateArchiveFailureInsertNewObject = 4048;
  ecConnectionSelectObjectsGroupsandUsersFailure = 4049;
  ecConnectionGetLayoutUsersAndGroupsFailure = 4050;
  ecConnectionCreateUserFailure = 4051;
  ecConnectionUserNameAlreadyExsits = 4052;
  ecConnectionUserLocked = 4053;
  ecConnectionCreateGroupFailure = 4054;
  ecConnectionGroupNameAlreadyExsits = 4055;
  ecConnectionInsertGroupToSysGrpUsrFailure = 4056;
  ecConnectionSelectGroupMembersFailure = 4057;
  ecConnectionInsertObjectToSysGrpUsrFailure = 4058;
  ecConnectionSelectAddUsersFailure = 4059;
  ecConnectionSelectAddGroupsFailure = 4060;
  ecConnectionSelectGroupSysGrpUsrIDFailure = 4061;
  ecConnectionSelectObjectRightsFailure = 4062;
  ecConnectionUpdateRightsToObjectFailure = 4063;
  ecConnectionSelectArchivenamesByIDsFailure = 4064;
  ecConnectionSelectObjectsWithMemberIDsFailure = 4065;
  ecConnectionUpdateGroupFailure = 4066;
  ecConnectionUpdateUserFailure = 4067;
  ecConnectionSelectWhereObjMemberFailure = 4068;
  ecConnectionDeleteArchiveFailure = 4069;
  ecConnectionRootCannotBeDeleted = 4070;
  ecConnectionObjectHasChildNodes = 4071;
  ecConnectionDocumentsBelongsToArchive = 4072;
  ecConnectionUpdateArchiveFailure = 4073;
  ecConnectionDeleteUserOrGroupFromSysLayoutFailure = 4074;
  ecConnectionDeleteUserOrGroupFailure = 4075;
  ecConnectionSelectLayoutWhereObjMemberFailure = 4076;
  ecConnectionSelectUserByIDFailure = 4077;
  ecConnectionSelectAdditionalAndStatusFieldsFailure = 4078;
  ecConnectionInsertAdditionalFieldFailure = 4079;
  ecConnectionCreateAdditionalFieldFailure = 4080;
  ecConnectionCheckIfDisplaynameExistsFailure = 4081;
  ecConnectionGetSysDocIdxCounterFailure = 4082;
  ecConnectionCheckIfColumnExistsFailure = 4083;
  ecConnectionspSelectTableColumnsFailure = 4084;
  ecConnectionGetTableRowSizeFailure = 4085;
  ecConnectionCreateIndexTableFailure = 4086;
  ecConnectionAlterIndexTableFailure = 4087;
  ecConnectionUpdateAdditionalFieldIndexTableIDFailure = 4088;
  ecConnectionSelectAdditionalFieldByIDFailure = 4089;
  ecConnectionUpdateAdditionalFieldFailure = 4090;
  ecConnectionLoadGroupFailure = 4091;
  ecConnectionDeleteUserOrGroupFromGroupFailure = 4092;
  ecConnectionSelectGroupSysGrpUsrParentIDFailure = 4093;
  ecConnectionInsertAdditionalFieldToMappingFailure = 4094;
  ecConnectionSelectAdditionalFieldsFailure = 4095;
  ecConnectionInheritAdditionalFieldFailure = 4096;
  ecConnectionDeleteAdditionalFieldFromMappingFailure = 4097;
  ecConnectionSelectAdditionalFieldByArchiveIDFailure = 4098;
  ecConnectionUpdateBaseAdditionalFieldFailure = 4099;
  ecConnectionAdditionalFieldAlreadyExsits = 4100;
  ecConnectionCheckIfDMSAdminFailure = 4101;
  ecConnectionGetLayoutArchivesWithIdxParamsFailure = 4102;
  ecConnectionGetContainerOjectsFailure = 4103;
  ecConnectionInsertUserMappingFailure = 4104;
  ecConnectionSelectAvailableObjectsFailure = 4105;
  ecConnectionSelectLayoutIDByObjectIDsFailure = 4106;
  ecConnectionSelectArchiveAncestoreObjectsFailure = 4107;
  ecConnectionSelectObjectsMandantFailure = 4108;
  ecConnectionDeleteObjectFromSysUserMappingFailure = 4109;
  ecConnectionCheckIfGrpUsrObjectExsitsOnLevelFailure = 4110;
  ecConnectionUpdateUserMappingFailure = 4111;
  ecConnectionDeleteContainerFailure = 4112;
  ecConnectionUpdateUserPwdFailure = 4113;
  ecConnectionSelectRolesFailure = 4114;
  ecConnectionLoadProfileFailure = 4115;
  ecConnectionUpdateLayoutRights = 4116;
  ecConnectionUpdateContainerDescription = 4117;
  ecConnectionSelectUserContainers = 4118;
  ecConnectionCheckIfExistsAndHasRight = 4119;
  ecConnectionSelectContainerDescription = 4120;
  ecConnectionCheckIfUserAdminInOtherContainer = 4121;
  ecConnectionCopyNode = 4122;
  ecConnectionSelectFieldPermissionsFailure = 4123;
  ecConnectionUpdateInheritedFieldRightsFailure = 4124;
  ecConnectionSelectMaxUsrGrpIdxFailure = 4125;
  ecConnectionSelectAllFieldsFailure = 4126;
  ecConnectionCreateDocument = 4127;
  ecConnectionCheckUserFailure = 4128;
  ecConnectionCheckGroupFailure = 4129;
  ecConnectionSelectArchiveNameByIDFailure = 4130;
  ecConnectionInsertDocTxt = 4131;
  ecConnectionSelectTreenodeByLgrIDFailure = 4132;
  ecConnectionNodeHasChildrenFailure = 4133;
//
///////// Document Class Error Codes ///////////////////////////////////////////
  ecDocumentConnectionIsNotAvailable = 5001;
  ecDocumentFailureInSaveDocTXT = 5002;
  ecDocumentFailureInSetConnection = 5003;
  ecDocumentFailureDocNotLoaded = 5004;
  ecDocumentFailureInDocLoad = 5005;
  ecDocumentConnectionOrLogIsNotInitialized = 5006;
  ecDocumentFailureInInit = 5007;
  ecDocumentFailureInSaveVocabulary = 5008;
  ecDocumentFailureInStartWorkflow = 5009;
  ecDocumentPageCountCannotbeSetbyArchivedDocument = 5010;
  ecDocumentFailureinSetPageCount = 5011;
  ecDocumentFailureInLoadArchive = 5012;
  ecDocumentFailureInClone = 5013;
//
///////// Log Error Codes //////////////////////////////////////////////////////
  ecLogNotInitialized = 6001;
  ecLogLogDirIsEmpty = 6002;
  ecLogFileNotExists = 6003;
  ecLogFileNotExistsButException = 6004;
//
///////// AdditionalField Class Error Codes ////////////////////////////////////
  ecAdditionalFieldConnectionOrLogIsNotInitialized = 7001;
  ecAdditionalFieldFailureInInit = 7002;
  ecAdditionalFieldFailureInLoad = 7003;
  ecAdditionalFieldFailureInSave = 7004;
//
///////// Viewer Class Error Codes /////////////////////////////////////////////
  ecViewerConnectionOrLogIsNotInitialized = 8001;
  ecViewerFailureInSelectAllArchives = 8002;
//
///////// AdditionalFieldCollection Class Error Codes //////////////////////////
  ecAdditionalFieldCollectionFailureinInit = 9001;
//
///////// Global Error Codes ///////////////////////////////////////////////////
  ecNoRecord = 10001;
  ecConnectionIsNULL = 10002;
  ecLogIsNULL = 10003;
  ecFailureInInitConnectionAndLog = 10004;
  ecConnectionIsNotInitialized = 10005;
  ecLogIsNotInitialized = 10006;
  ecFailureInInitLog = 10007;
  ecFailureInInitApplication = 10008;
  ecApplicationIsNotInitialized = 10009;
//
///////// Application Rights Class Error Codes //////////////////////////
  ecApplicationRightsFailureInSetAppRights = 12001;
//
////////// Group Class Error Codes /////////////////////////////////////////////
  ecGroupFailureInLoadGroup = 13001;
  ecGroupFailureInSave = 13002;
  ecGroupConnectionOrLogIsNotInitialized = 13003;
  ecGroupFailureInAddObject = 13004;
  ecGroupFailureInRemoveObject = 13005;
//
////////// Group Class Error Codes /////////////////////////////////////////////
  ecFillTreeListFailure = 14001;

//
////////// States /////////////////////////////////////////////////////////
  stActive = 0;
  stLocked = 1;
  stModified = 2;
  stDeleted = 99;
//
////////// Document Workflow States ////////////////////////////////////////////
  dwsNotInWorkflow = 0;
  dwsInWorkflow = 1;
//
////////// Document CheckOut States ////////////////////////////////////////////
  dcsCheckedIn = 0;
  dcsCheckedOut = 1;
//
/////// Log Levels ///////////////////////////////////////////////////////////
//  llNormal = 0;  // Fehlercodes
//  llLow = 1;  // Low
//  llLowGUI = 2;  // GUI Sachen
//  llMedium = 3;  // BaseObj Initialization Sachen
//  llHigh = 4;  // BaseObjects
//  llDebug = 5;  // DEBUG

//
////////// AdditionalField Types ///////////////////////////////////////////////
  aftRequired = 1;
  aftLink = 2;
  aftFileNameAtSendAndSave = 4;
  aftStrictMode = 8;
  aftRedMinusValue = 16;

//
////////// Field Valuetypes ////////////////////////////////////////////////////
  vtBigInt = 0;
  vtTinyInt = 1;
  vtInteger = 2;
  vtString = 3;
  vtDateTime = 4;
  vtDouble = 5;
  vtFloat = 6;
  vtDecimal = 7;
  vtNumeric = 8;

//
////////// Field Controltypes //////////////////////////////////////////////////
  ctEditBox = 0;   // Universalfeld
  ctDateTime = 1;   // Datumsfeld
  ctComboBox = 2;   // Auswahlfeld
  ctCheckComboBox = 3;   // Mehrfach-Auswahlfeld
  ctInterval = 4;   // Intervalfeld
  ctInteger = 5;   // Ganzzahl
  ctFloat = 6;   // Fliekomma
  ctCurrency = 7;   // Whrung

//
////////// Application Kind ////////////////////////////////////////////////////
  akImporter = 0;
  akViewer = 1;
  akAdministrator = 2;
  akAllInOne = 3;
//
////////// Frame Kind //////////////////////////////////////////////////////////
  fkNone = -1;
  fkAdministrator = 0;
  fkScanImport = 1;
  fkViewer = 2;
  fkStartFrame = 3;

//
////////// AdminFrame Type /////////////////////////////////////////////////////
  ftArchive = 0;
  ftUserContainer = 1;
  ftFieldContainer = 2;
  ftUser = 3;
  ftGroup = 4;
  ftAddField = 5;
  ftStsField = 6;
  ftImport = 7;
  ftViewer = 8;
  ftWorkflow = 9;
  ftWorkplace = 10;

//
////////// sys_layout Object Type //////////////////////////////////////////////
  otRoot = -1;   // DMS - default Root
  otMandant = 0;
  otStore = 1;
  otArchive = 2;
  otGroup = 3;
  otUser = 4;
  otRecordArchive = 5;
  otUserContainer = 6;
  otAddFieldContainer = 7;
  otAdditionalField = 8;
  otStatusField = 9;

//
////////// Viewer Tags   ///////////////////////////////////////////////////////
  tagInActiveViewer = 0;
  tagActiveViewer = 1;
  tagCanDeleted = 999;
  tagThumbnailMView = 99;
  tagCollectionMView = 98;
  tagThumbnailPoolView = 97;

//
///// Contexts
  ctxViewerTools = 0;
  ctxCollectionTools = 1;

//
///// Color Mode
  cmBlackAndWhite = 0;
  cmGrayscale4bit = 1;
  cmGrayscale8bit = 2;
  cmColor = 3;

//
///// Compression Mode
  cmpJPG = 0;
  cmpPackBits = 1;
  cmpLZW = 2;
  cmpNoCompression = 3;
  cmpCCITT4 = 4;

//
///// DPI
  dpi50 = 0;
  dpi75 = 1;
  dpi100 = 2;
  dpi150 = 3;
  dpi200 = 4;
  dpi300 = 5;
  dpi400 = 6;
  dpi600 = 7;
  dpi1200 = 8;
  dpiDefault = 300;

//
///// Scroll step
  scr10 = 0;
  scr20 = 1;
  scr30 = 2;
  scr40 = 3;
  scr50 = 4;
  scr60 = 5;
  scr70 = 6;
  scr80 = 7;
  scr90 = 8;
  scr100 = 9;
  scr110 = 10;
  scr120 = 11;
  scr130 = 12;
  scr140 = 13;
  scr150 = 14;
  scrDefault = 60;

//
///// Zoom step
  zms1 = 0;
  zms2 = 1;
  zms3 = 2;
  zms4 = 3;
  zms5 = 4;
  zms10 = 5;
  zms15 = 6;
  zms20 = 7;
  zms25 = 8;
  zms30 = 9;
  zms35 = 10;
  zms40 = 11;
  zms50 = 12;
  zms100 = 13;
  zmsDefault = 10;

//
////// document Types
  dtEmpty = 0;
  dtFile = 1;
  dtBatch = 2;
  dtScannedPage = 3;
  dtArchived = 4;
  dtRecord = 5;

//
////// default Font Sizes
  fsRibbonManager = 8;
  fsTreeView = 9;


//
//////
  idxStatusServer = 0;
  idxStatusUser = 1;
  idxStatusProfil = 2;
  idxStatusArchive = 3;
  idxStatusText = 4;

//
////// sys_cfg ClientID-s
  ciServer = 0;

//
////// Layouts
  lytDefault = 0;
  lytNotebook = 1;
  lytGroup = 2;
  lytTab = 3;
  lytEmbeddedMini = 4;
  lytEmbeddedNormal = 5;

//
////// Search Object Search Types
  stypNormal = 0; // normale Suche,
  stypLocalBookmarks = 1; // lokales Lesezeichen
  stypGlobalBookmarks = 2; // globales Lesezeichen
  stypProcessBookmarks = 3; // Verlaufs-Lesezeichen
  stypResubmissionList = 4; // WVL
  stypAddFieldSearch = 5; // Zusatzfeldsuche (Verschlagwortungshilfe)

  cUnassignedDate = -693594;

  // Cursors
  crSymLinkCursor = 5;
  crMoveCursor = 6;
  crCopyCursor = 7;
  mwlFiletypes = 'mwl Dateien|*.mwl';
  cEmptyGUID = '{00000000-0000-0000-0000-000000000000}';

type

  TbfaResubKind = (rkMyTasks, rkController, rkInferior, rkNone);
  TbfaControlKind = (ckDefault, ckDisabled, ckReadOnly, ckRequired);
  TbfaControlType = (ctCreate, ctProperties);
  TbfaPanelKind = (pkCreate, pkProperties, pkShowOnly);
  TbfaFieldControlKind = (ackTextBox, ackComboBox, ackDateEdit, ackCurrencyEdit,
    ackCalcEdit, ackCheckComboBox, ackInterval, ackIntegerEdit);
  TbfaLayoutControlKind = (lckDesign, lckScanImport, lckViewer);
  TbfaViewerKind = (vkWorkPlace, vkImporter, vkViewer);
   TbfaDriveType = (DRIVE_UNKNOWN, DRIVE_NO_ROOT_DIR, DRIVE_REMOVABLE, DRIVE_FIXED, DRIVE_REMOTE, DRIVE_CDROM, DRIVE_RAMDISK);
  TbfaAddObjectFormKind = (aofkUserMapping, aofkUserContainer, aofkAddUserToGroup,
    aofkAddGroupToGroup, aofkAddObjectToGroup, aofkFieldMapping, aofkFieldContainer,
    aofkDMSAdmin, aofkFieldPermission, aofkAddUserGroupToField);
  TbfaIconIndexes = (
    icoidx_abort,
    icoidx_admin_clock,
    icoidx_admin_clock_selected,
    icoidx_annotation_delete,
    icoidx_annotation_no,
    icoidx_annotation_private,
    icoidx_annotation_public,
    icoidx_archive_document,
    icoidx_arrow_down,
    icoidx_arrow_left,
    icoidx_arrow_right,
    icoidx_arrow_up,
    icoidx_autoreference,
    icoidx_away,
    icoidx_away_remove,
    icoidx_bell,
    icoidx_bell_remove,
    icoidx_bell_view,
    icoidx_book,
    icoidx_bookmark,
    icoidx_bookmark_check,
    icoidx_bookmark_check_selected,
    icoidx_bookmark_create,
    icoidx_bookmark_dialog,
    icoidx_bookmark_edit,
    icoidx_bookmark_folder,
    icoidx_bookmark_folder_expanded,
    icoidx_bookmark_global,
    icoidx_bookmark_global_check,
    icoidx_bookmark_global_selected,
    icoidx_bookmark_global_selected_check,
    icoidx_bookmark_selected,
    icoidx_checkout_disabled,
    icoidx_checkout_unselected,
    icoidx_clipboard,
    icoidx_clipboard_file,
    icoidx_clipboard_link,
    icoidx_clipboard_page,
    icoidx_clipboard_stamp,
    icoidx_clock,
    icoidx_clock_abort,
    icoidx_clock_check,
    icoidx_clock_create,
    icoidx_clock_disabled,
    icoidx_clock_enabled,
    icoidx_clock_forward,
    icoidx_clock_unselected,
    icoidx_cut_border,
    icoidx_database_close,
    icoidx_database_create,
    icoidx_database_export,
    icoidx_database_start,
    icoidx_date,
    icoidx_date_deleteDate_recalculate,
    icoidx_delete_nrs,
    icoidx_document,
    icoidx_document_bookmark,
    icoidx_document_checkout,
    icoidx_document_checkout_all,
    icoidx_document_copy,
    icoidx_document_create_empty,
    icoidx_document_delete,
    icoidx_document_info,
    icoidx_document_invert_color,
    icoidx_document_last,
    icoidx_document_link_add,
    icoidx_document_link_remove,
    icoidx_document_merge,
    icoidx_document_reload,
    icoidx_document_split,
    icoidx_edit,
    icoidx_edit_enabled,
    icoidx_edit_graphics,
    icoidx_edit_password,
    icoidx_edit_unselected,
    icoidx_export_csv,
    icoidx_export_meta,
    icoidx_export_odt,
    icoidx_export_xls,
    icoidx_fields,
    icoidx_fields_save,
    icoidx_files_download,
    icoidx_files_load,
    icoidx_flag_britain,
    icoidx_flag_germany,
    icoidx_folder_closed,
    icoidx_folder_closed_importer,
    icoidx_folder_open,
    icoidx_folder_open_importer,
    icoidx_forwarded,
    icoidx_group,
    icoidx_help,
    icoidx_hourglass,
    icoidx_importer_document_pages,
    icoidx_importer_pages,
    icoidx_importer_reset,
    icoidx_importer_send,
    icoidx_importer_send_view,
    icoidx_info,
    icoidx_jump_to_original_archive,
    icoidx_language_select,
    icoidx_layouts,
    icoidx_layout_delete,
    icoidx_layout_save,
    icoidx_letter,
    icoidx_link_create,
    icoidx_link_delete,
    icoidx_link_enabled,
    icoidx_link_unselected,
    icoidx_lock,
    icoidx_lock_no,
    icoidx_mail_file,
    icoidx_mail_link,
    icoidx_mail_pdf,
    icoidx_mail_tif,
    icoidx_mail_view,
    icoidx_move,
    icoidx_ok,
    icoidx_original_file_enabled,
    icoidx_original_file_unselected,
    icoidx_original_restore,
    icoidx_original_view,
    icoidx_page_delete,
    icoidx_paint_settings,
    icoidx_plugin,
    icoidx_pointer,
    icoidx_preview_auto,
    icoidx_preview_height,
    icoidx_preview_no_autozoom,
    icoidx_preview_original,
    icoidx_preview_width,
    icoidx_print,
    icoidx_print_view,
    icoidx_profile_change,
    icoidx_relog,
    icoidx_remove_dots,
    icoidx_rename_document,
    icoidx_reset,
    icoidx_resubmission_everybody,
    icoidx_resubmission_everybody_forward,
    icoidx_resubmission_group,
    icoidx_resubmission_group_forward,
    icoidx_resubmission_own,
    icoidx_resubmission_own_forward,
    icoidx_rotate_180,
    icoidx_rotate_left,
    icoidx_rotate_right,
    icoidx_save_file,
    icoidx_save_link,
    icoidx_save_pdf,
    icoidx_save_tif,
    icoidx_save_view,
    icoidx_scan_dialog,
    icoidx_scan_page,
    icoidx_scan_profile_create,
    icoidx_scan_profile_export,
    icoidx_scan_profile_global,
    icoidx_scan_profile_import,
    icoidx_scan_profile_local,
    icoidx_scan_profile_remove,
    icoidx_scan_settings,
    icoidx_search,
    icoidx_search_left,
    icoidx_search_result_highlighting,
    icoidx_search_result_highlighting_no,
    icoidx_search_right,
    icoidx_select,
    icoidx_send_to,
    icoidx_settings,
    icoidx_sorting_abort,
    icoidx_start,
    icoidx_status_check_out,
    icoidx_status_field_disabled,
    icoidx_status_field_enabled,
    icoidx_status_field_unselected,
    icoidx_straighten,
    icoidx_surface,
    icoidx_switch,
    icoidx_symbolic_link,
    icoidx_symbolic_link_remove,
    icoidx_symbolic_link_view,
    icoidx_tag_edit,
    icoidx_team_viewer,
    icoidx_thumbnail,
    icoidx_toolbar,
    icoidx_tree,
    icoidx_tree_expand,
    icoidx_tree_reduce,
    icoidx_tree_reload,
    icoidx_tree_tools,
    icoidx_update,
    icoidx_user,
    icoidx_video,
    icoidx_warehouse_closed,
    icoidx_warehouse_closed_importer,
    icoidx_warehouse_open,
    icoidx_warehouse_open_importer,
    icoidx_workspace_copy,
    icoidx_workspace_document,
    icoidx_workspace_document_pages,
    icoidx_workspace_pages

    );

  TbfaIconIndexes2 = (
    icoidx_arrow,
    icoidx_change_color,
    icoidx_change_format,
    clipboard_fields,
    clipboard_objects,
    clipboard_rights,
    clipboard_status_field,
    copy_objects,
    icoidx_dialog_stamp,
    icoidx_document_reserve_mail_file,
    icoidx_document_reserve_mail_pdf,
    icoidx_document_reserve_mail_tif,
    icoidx_document_reserve_remove,
    icoidx_document_reserve_save_file,
    icoidx_document_reserve_save_pdf,
    icoidx_document_reserve_save_tif,
    icoidx_document_reserve,
    icoidx_document_reserved_view_1,
    icoidx_document_reserved_view_2,
    icoidx_document_reserved_view_3,
    icoidx_document_reserved_view_4,
    icoidx_document_reserved_view_5,
    icoidx_document_reserve_1,
    icoidx_document_reserve_2,
    icoidx_document_reserve_3,
    icoidx_document_reserve_4,
    icoidx_document_reserve_5,
    icoidx_filetype_ANY,
    icoidx_filetype_STAR,
    icoidx_info_dialog,
    icoidx_legal_dialog,
    icoidx_line,
    icoidx_marker_blue,
    icoidx_marker_green,
    icoidx_marker_orange,
    icoidx_marker_red,
    icoidx_marker_yellow,
    icoidx_note_blue,
    icoidx_note_green,
    icoidx_note_orange,
    icoidx_note_red,
    icoidx_note_yellow,
    icoidx_ocr,
    icoidx_open_new_tab,
    icoidx_open_new_window,
    icoidx_pencil_blue,
    icoidx_pencil_green,
    icoidx_pencil_orange,
    icoidx_pencil_red,
    icoidx_pencil_yellow,
    icoidx_resubmission_user_01,
    icoidx_resubmission_user_02,
    icoidx_resubmission_user_03,
    icoidx_resubmission_user_04,
    icoidx_resubmission_user_05,
    icoidx_resubmission_user_06,
    icoidx_resubmission_user_07,
    icoidx_resubmission_user_08,
    icoidx_resubmission_user_09,
    icoidx_resubmission_user_10,
    icoidx_resubmission_view,
    icoidx_stamp_aqua,
    icoidx_stamp_black,
    icoidx_stamp_blue,
    icoidx_stamp_green,
    icoidx_stamp_grey,
    icoidx_stamp_image,
    icoidx_stamp_no,
    icoidx_stamp_orange,
    icoidx_stamp_pink,
    icoidx_stamp_purple,
    icoidx_stamp_red,
    icoidx_stamp_text,
    icoidx_stamp_yellow,
    icoidx_tag_assistant_enabled,
    icoidx_tag_assistant_unselected,
    icoidx_text,
    icoidx_text_1,
    icoidx_text_2,
    icoidx_text_3,
    icoidx_text_4,
    icoidx_text_5
    );

  TbfaIconIndexes3 = (
    icoidx_flag_ar,
    icoidx_flag_bg,
    icoidx_flag_da,
    icoidx_flag_el,
    icoidx_flag_es,
    icoidx_flag_fi,
    icoidx_flag_fr,
    icoidx_flag_hi,
    icoidx_flag_hu,
    icoidx_flag_it,
    icoidx_flag_ja,
    icoidx_flag_nb,
    icoidx_flag_nl,
    icoidx_flag_pl,
    icoidx_flag_pt,
    icoidx_flag_ro,
    icoidx_flag_sk,
    icoidx_flag_sv,
    icoidx_flag_tr,
    icoidx_flag_uk,
    icoidx_flag_zh
    );


type
  TArcDocId = record
    ArcId: int64;
    DocId: int64;
  end;

  TUsrId = int64;

  Tversion = record
    Major: integer;
    Minor: integer;
    compile: integer;
    revision: integer;
  end;

  eAddFieldType = (zfld00_Universal, zfld01_Datum, zfld02_Auswahl,
    zfld03_MehrfachAuswahl, zfld04_NichtDefiniert, zfld05_Intervall, zfld06_GanzZahl,
    zfld07_FliessKomma, zfld08_Waehrung, zfld09_Status, zfld10_Document, zfld11_DLM,
    zfld12_DLMDate, zfld13_Grid, zfld14_GridColumn);
  sAddFieldType = set of eAddFieldType;
  eDateFormat = (dtfDay, dtfWeek, dtfMonth, dtfYear, dtfDate, dtfNone);
  TStrictItemsAction = (siaAddToList, siaNoChanges, siaDelete, siaNone);

  //annotationsdata
  TAnnoData = record
    version: string[50];
    Ersteller: string[100];
    Datum: string[255];
    Veraenderer: string[255];
    // GUID wurde hinzugenommen, damit wir bei Stempeln mit Plugin-Ausfhrung
    // wissen welche Anno am Ende (bei Plugin-Error) gelscht werden muss, da
    // die ID durch die IEVs nicht eindeutig ist.
    // Auf GUID darf erst ab Version 0.2 zugegriffen werden
    GUID: TGUID;
  end;

  PAnnoData = ^TAnnoData;

  // ein Typ zur Speicherung von Anzeigezustnden
  TDocViewSave = record
    Doc: TArcDocId; // Das Dokument
    Page: integer; // Die Seite
  end;

  TDocViewSaves = array[0..5] of TDocViewSave;

	// Callback-Funktionen fr frm_Voransicht
  TOnObjectOver = procedure(annodata: PAnnoData) of object;
  TOnDblClick = procedure(Sender: TObject) of object;

 // Record mit Rechtevariablen fr Archiv- und Dokumentenrechte
  TRData = record
    list, print, read, link, modify, import, write, history, mail, move, aread,
    awrite, amodify, apwrite, apread, hstprotoread, suanno, docdel,
    docexport, revsave: boolean;
  end;

  TPID = record
    id: int64;
  end;

  PPID = ^TPID;

  TStringArray = array of string;

  TBfData = class
  public
    EnvTemp,   // %temp%
    EnvTempPd, // %temp% mit Pathdelimiter
    EnvTempUpdatePd, // Verzeichnis in %temp% fr Updater-Downloads
    EnvSystemRoot, EnvSystemRootPd, EnvAppdata, EnvAppdataPd,
    EnvAppdataImporter, EnvAppdataImporterPd, EnvAppdataWorkplace,
    EnvAppdataWorkplacePd, EnvUsername, EnvProgramData, EnvProgramFiles,
    EnvProgramFilesX86, EnvProgramFilesPd, EnvProgramFilesX86Pd, EnvProgramDataPd,
    AppdataBitfarm, AppdataBitfarmPd, ProgramDataBitfarm, ProgramDataBitfarmPd,
    ProgramFilesBitfarm, ProgramFilesBitfarmPd, ProgramFilesBitfarmClient,
    ProgramFilesBitfarmClientPd, ProgramFilesX86Bitfarm, ProgramFilesX86BitfarmPd,
    ProgramFilesX86BitfarmClient, ProgramFilesX86BitfarmClientPd,
    MyLoginIniName, ExeFile, ExeDir, GtDomain, // Domain fr gnugettext
    LogPath, // Verzeichnis fr das Logs
    LogName, // Dateiname (ohne Pfad) fr das Log. "<%d>" steht fr das Datum
    LogUser, // User fr den geloggt wird
    LogPre, dummy: string;
    LogOn, DevDebug, SetDuplex, RunsLocal: Boolean;
    DriveType : TbfaDriveType;
    constructor Create;
  end;

  ERedirectorError = Exception;

var
  bfaFontSize : Integer = BFAFONT;
  bfaFontSettingsSize : Integer = BFAFONTSETTINGS;
//  bfaButtonHeight : Integer = 30;

  cColorRequiredField: TColor = $00CAE4FF;
  cColorLightGreen: TColor = $00E1FFE6; // Hellgrn - fr genderte Felder
  cColorLightBlue: TColor = $00F1FFC6; // fr genderte und gesuchte Felder
  cColorNoRightInit: TColor = $00E0E0E0;
  cColorNoRight: TColor = $00E0E0E1; //c0e1ff  //00a3d4ff   //adb4de  //hellrotbraun //No right 1
  cColorNoRightChg: TColor = $00adb4ff; //c0e1ff  //00a3d4ff   //adb4de  //hellrotbraun //No right 2
  cColorNoRightStat: TColor = $008489a9; //c0e1ff  //00a3d4ff   //8489a9  //rotbraun  //No right fr Status
  cColorWhite: TColor = $00FFFFFF;
  cColorRed: TColor = $000000FF;
  cColorBlack: TColor = $00000000;
  cColorGray: TColor = $00808080;
  cColorOrange: TColor = $001FA2F5; //15.04.2021 $000080ff;

 	//Standardfarben
  gclBlack: TColor = clBlack;
  gclLime: TColor = $0076D6BC; //15.04.2021 clLime;
  gclRed: TColor = $001C44C7; //15.04.2021 $003442E3;
  gclBlue: Tcolor = $00D8A275; //15.04.2021 $00825305;
  gclGreen: TColor = $0076D6BC; //15.04.2021
  gclDarkRed: TColor = $002828FF; 	// ~ rot
  gclBrown: TColor = $003A3A70; 	// ~ braun
  gclYellow: TColor = $0048D3EF; //15.04.2021 $00FFFF;	// ~ gelb
  gclOlive: TColor = clOlive;
  gclTeal: TColor = clTeal;
  gclFree: TColor = clwhite;
  gclFreeText: TColor = clBlack;
  gclSelected: TColor = $00bdbdbd;
  gclSelectedText: TColor = clBlack;
  gclWork: TColor = $0065ffff; //clyellow;
  gclWorkText: TColor = clBlack;
  gclWorkSelected: TColor = $0000a3e1;
  gclWorkSelectedText: TColor = clBlack;
  gclDone: TColor = $0005EF11;
  gclDoneText: TColor = clBlack;
  gclDoneSelected: TColor = $00009100;
  gclDoneSelectedText: TColor = clBlack;
  gclUrgent: TColor = $003442E3;
  gclUrgentText: TColor = $00EFEFEF;
  gclUrgentSelected: TColor = $00121B85;
  gclUrgentSelectedText: TColor = $00EFEFEF;
  gclProgress: TColor = $00E1FFE6;
  gclProgressText: TColor = clBlack;
  gclProgressSelected: TColor = $0092bf9a;
  gclProgressSelectedText: TColor = clBlack;
  gclNone: TColor = clNone;
  sCaptionOnlySearch: WideString;
  sColorBlack, sColorBrown, sColorGreen, sColorOlive, sColorDarkblue, sColorPurple,
  sColorGreenblue, sColorGray, sColorSilver, sColorRed, sColorLime, sColorYellow,
  sColorBlue, sColorFuchsia, sColorAquamarine, sColorWhite, sColorDollargreen,
  sColorLightblue, sColorCream, sColorMediumgray, sCaptionNewPolyline, sCaptionNewEllipse,
  sCaptionNewRectangle, sCaptionNewMeasureline: WideString;
  sLastDir: WideString;

  BD: TBfData = nil;

const
  cCurYear = '2024';
  cDateTimeUndefined = NaN; // Um bei Parametern angeben zu knnen, dass undefiniert

  globalDelimiter = ';';
  Zoll = 0.03937007874015748031496062992126;

  //Optionen fr Zusatzfeld
  cAddfieldOptMandatory = 1;
  cAddfieldOptLink = 2;
  cAddfieldOptNaming = 4;
  cAddfieldOptStrict = 8;
  cAddfieldRead = 1;    // Feld ist nur Lesbar
  cAddfieldWrite = 2;   // Feld kann einmal beschrieben werden
  cAddfieldModify = 4;  // Feld ist Les-, Schreib und nderbar

  cBackSlash = char(92);

  //Optionen fr Archiv
  cArchivOptNamePflicht = 1;  // "Titelpflicht"
  cArchivOptNameArchiv = 2;  // "Dokname aus Archiv"
  cArchivOptPlugin = 4;  // "Plugin aktiv"
  //
  cDocNameDefault = 'Dokument';

  //3.5.0.92
  cEmptyDateString = '  .  .    ';

  //3.5.0.121 f.schneider  Konstanten und Typen aus u_ViewBase integriert, um diese auch den
  //anderen Anwendungen zur Verfgung zu stellen
  sfVoransicht = 1;
  sfVolltext = 2;
  sfDocLink = 3;
  sfHistory = 4;
  sfRechte = 5;
  sfNix = 6;
  sfCommentary = 7;

  // Angemeldet als: = 0
  cStatusPanelUser = 1;
  // Server:         = 2
  cStatusPanelServer = 3;
  cStatusPanelDoc = 5;
  cStatusPanelInfo = 7;
  cStatusPanelDocIdTrennzeichen = '/';
  FILE_READ_DATA = $0001;
  FILE_WRITE_DATA = $0002;
  FILE_APPEND_DATA = $0004;
  FILE_READ_EA = $0008;
  FILE_WRITE_EA = $0010;
  FILE_EXECUTE = $0020;
  FILE_READ_ATTRIBUTES = $0080;
  FILE_WRITE_ATTRIBUTES = $0100;
  FILE_GENERIC_READ = (STANDARD_RIGHTS_READ or FILE_READ_DATA or FILE_READ_ATTRIBUTES or FILE_READ_EA or SYNCHRONIZE);
  FILE_GENERIC_WRITE = (STANDARD_RIGHTS_WRITE or FILE_WRITE_DATA or FILE_WRITE_ATTRIBUTES or FILE_WRITE_EA or FILE_APPEND_DATA or SYNCHRONIZE);
  FILE_GENERIC_EXECUTE = (STANDARD_RIGHTS_EXECUTE or FILE_READ_ATTRIBUTES or FILE_EXECUTE or SYNCHRONIZE);
  FILE_ALL_ACCESS = STANDARD_RIGHTS_REQUIRED or SYNCHRONIZE or $1FF;


{############################} implementation {#############################}

uses
  bfaCommonMethods;

constructor TBfData.Create;
var
  lsappdata, lsuser, lsdomain: string;
begin
///19.10.2017 gendert wegen ArchivDrucker fehler wo in System Context gelaufen war -->
  lsappdata := GetSystemVariable('APPDATA');
  lsuser := WindowsUserName;
  if (Pos('system32', lsappdata) > 0) and (lsuser <> '') then
  begin
//     lsdomain:= GetSystemVariable('USERDOMAIN');
//     ShowMessage('USERDOMAIN: ' + lsdomain);
//     if lsdomain <> '' then
//       lsuser := lsuser + '.' + lsdomain;
    EnvTemp := LowerCase('c:\users\' + lsuser + '\AppData\Local\Temp');
    EnvSystemRoot := LowerCase(GetSystemVariable('systemroot'));
    EnvAppdata := LowerCase('c:\users\' + lsuser + '\AppData\Roaming\');
    EnvUsername := LowerCase(lsuser);
    EnvProgramData := LowerCase(GetSystemVariable('ProgramData'));
  end
  else
  begin
    EnvTemp := LowerCase(GetSystemVariable('TEMP'));
    EnvSystemRoot := LowerCase(GetSystemVariable('systemroot'));
    EnvAppdata := LowerCase(GetSystemVariable('appdata'));
    EnvUsername := LowerCase(GetSystemVariable('username'));
    EnvProgramData := LowerCase(GetSystemVariable('ProgramData'));
  end;
  // <!-- SJ Abschlussprojekt
  if Windows64Bit then
    EnvProgramFiles := LowerCase(GetSystemVariable('ProgramFiles'))
  else
    EnvProgramFiles := LowerCase(GetSystemVariable('ProgramFiles(x86)'));
  EnvProgramFilesX86 := LowerCase(GetSystemVariable('ProgramFiles(x86)'));
  // SJ Abschlussprojekt -->
  EnvTempPd := IncludeTrailingPathDelimiter(EnvTemp);
  EnvSystemRootPd := IncludeTrailingPathDelimiter(EnvSystemRoot);
  EnvAppdataPd := IncludeTrailingPathDelimiter(EnvAppdata);
  EnvProgramDataPd := IncludeTrailingPathDelimiter(EnvProgramData);
  // <!-- SJ Abschlussprojekt
  EnvTempUpdatePd := IncludeTrailingPathDelimiter(EnvTempPd + 'bitfarm-Archiv-update-user');
  EnvProgramFilesPd := IncludeTrailingPathDelimiter(EnvProgramFiles);
  EnvProgramFilesX86Pd := IncludeTrailingPathDelimiter(EnvProgramFilesX86);
  // SJ Abschlussprojekt -->
  EnvAppdataImporter := LowerCase(EnvAppdataPd + 'bitfarm-archiv\Importer');
  EnvAppdataImporterPd := IncludeTrailingPathDelimiter(EnvAppdataImporter);
  EnvAppdataWorkplace := LowerCase(EnvAppdataPd + 'bitfarm-archiv\Workplace');
  EnvAppdataWorkplacePd := IncludeTrailingPathDelimiter(EnvAppdataWorkplace);
  // <!-- SJ Abschlussprojekt
//  ProgramFilesBitfarm := EnvProgramFilesPd + 'bitfarm-Archiv'; // SJ 08.04.2020
  ProgramFilesBitfarm := LowerCase(EnvProgramFilesPd + 'Bitfarm-Archiv');
  ProgramFilesBitfarmPd := IncludeTrailingPathDelimiter(ProgramFilesBitfarm);
  ProgramFilesBitfarmClient := LowerCase(ProgramFilesBitfarmPd + 'Client');
  ProgramFilesBitfarmClientPd := IncludeTrailingPathDelimiter(ProgramFilesBitfarmClient);
//  ProgramFilesX86Bitfarm := EnvProgramFilesX86Pd + 'bitfarm-Archiv'; // SJ 08.04.2020
  ProgramFilesX86Bitfarm := LowerCase(EnvProgramFilesX86Pd + 'Bitfarm-Archiv');
  ProgramFilesX86BitfarmPd := IncludeTrailingPathDelimiter(ProgramFilesX86Bitfarm);
  ProgramFilesX86BitfarmClient := LowerCase(ProgramFilesX86BitfarmPd + 'Client');
  ProgramFilesX86BitfarmClientPd := IncludeTrailingPathDelimiter(ProgramFilesX86BitfarmClient);
  // SJ Abschlussprojekt -->

///19.10.2017 gendert wegen ArchivDrucker fehler wo in System Context gelaufen war <--


  AppdataBitfarm := LowerCase(EnvAppdata + '\bitfarm-archiv');
  AppdataBitfarmPd := IncludeTrailingPathDelimiter(AppdataBitfarm);
  ProgramDataBitfarm := LowerCase(EnvProgramData + '\bitfarm-archiv');
  ProgramDataBitfarmPd := IncludeTrailingPathDelimiter(ProgramDataBitfarm);

  MyLoginIniName := AppdataBitfarm + '\mylogin.ini';
  ExeFile := LowerCase(ParamStr(0));
  ExeDir := ExtractFilePath(ExeFile); // mit Delimiter hinten

  LogPath := EnvTemp; // vorbelegen
  LogName := ChangeFileExt(ExtractFileName(ExeFile), '.log');
  SetDuplex := False;

  DriveType := TbfaDriveType(GetDriveType(PWideChar(ExeDir)));
  RunsLocal := DriveType = DRIVE_FIXED;
end;

initialization
  BD := TBfData.Create;

finalization
  FreeAndNil(BD);

end.
