unit bfaDPAPI;

interface

uses
  System.SysUtils,
  Winapi.Windows,
  System.NetEncoding;

const
  CRYPTPROTECT_UI_FORBIDDEN = 1;
  CRYPTPROTECT_LOCAL_MACHINE = 4;
  EXTRA_ENTROPY = 'klsrgnweac,84z59;)/fea_#mujhadsfe';

type
  _CRYPTOAPI_BLOB = record
    cbData: DWORD;
    pbData: PByte;
  end;

  DATA_BLOB = _CRYPTOAPI_BLOB;
  PDATA_BLOB = ^DATA_BLOB;

  _CRYPTPROTECT_PROMPTSTRUCT = record
    cbSize: DWORD;
    dwPromptFlags: DWORD;
    hwndApp: HWND;
    szPrompt: PWideChar;
  end;

  CRYPTPROTECT_PROMPTSTRUCT = _CRYPTPROTECT_PROMPTSTRUCT;
  PCRYPTPROTECT_PROMPTSTRUCT = ^CRYPTPROTECT_PROMPTSTRUCT;

function CryptProtectData(pDataIn: PDATA_BLOB;
  szDataDescr: PWideChar; pOptionalEntropy: PDATA_BLOB;
  pReserved: Pointer; pPromptStruct: PCRYPTPROTECT_PROMPTSTRUCT; dwFlags: DWORD;
  pDataOut: PDATA_BLOB): BOOL; stdcall; external 'Crypt32.dll';

function CryptUnprotectData(pDataIn: PDATA_BLOB; ppszDataDescr: PPWideChar;
  pOptionalEntropy: PDATA_BLOB; pReserved: Pointer;
  pPromptStruct: PCRYPTPROTECT_PROMPTSTRUCT; dwFlags: DWORD;
  pDataOut: PDATA_BLOB): BOOL; stdcall; external 'Crypt32.dll';
procedure FreeDataBlob(var Data: DATA_BLOB);
function cryptData(text: string): TBytes;
function decryptData(cipher_text: TBytes): string;
function cryptDataBase64(text: string):string;
function decryptDataBase64(base64string: string): string;

implementation



procedure FreeDataBlob(var Data: DATA_BLOB);
begin
  if Assigned(Data.pbData) then
    LocalFree(HLOCAL(Data.pbData));
  FillChar(Data, SizeOf(DATA_BLOB), 0);
end;


function cryptDataBase64(text: string):string;
var
  base64: TBase64Encoding;
  cipher_text: TBytes;
begin
  result := '';
  cipher_text := cryptData(text);
  if length(cipher_text) > 0 then
  begin
    base64 := TBase64Encoding.Create(0);
    result := base64.EncodeBytesToString(cipher_text);
  end;
end;

function decryptDataBase64(base64string: string): string;
var
  base64: TBase64Encoding;
  cipher_text: TBytes;
begin
  Result := '';

  if base64string = '' then
    Exit;

  base64 := TBase64Encoding.Create(0);
  cipher_text := base64.DecodeStringToBytes(base64string);

  result := decryptData(cipher_text);
end;



function cryptData(text: string): TBytes;
var
  Bytes, BytesEnt, BytesOut: TBytes;
  dataIn: DATA_BLOB;
  dataOut: DATA_BLOB;
  dataEnt: DATA_BLOB;
begin
  dataOut.cbData := 0;
  dataOut.pbData := nil;
  dataEnt.cbData := 0;
  dataEnt.pbData := nil;

  bytes := TEncoding.UTF8.GetBytes(text);
  dataIn.cbData := length(Bytes); // How much data (in bytes) we want to encrypt
  dataIn.pbData := @bytes[0];     // Pointer to the data itself - the address of the first element of the input byte array

  BytesEnt := TEncoding.UTF8.GetBytes(EXTRA_ENTROPY);
  dataEnt.cbData := length(BytesEnt);
  dataEnt.pbData := @BytesEnt[0];

  if not CryptProtectData(@dataIn, PChar('python_data'), @dataEnt, nil, nil, CRYPTPROTECT_UI_FORBIDDEN, @dataOut) then
    RaiseLastOSError; // Bad things happen sometimes

  // Copy the encrypted bytes to RESULT variable
  setLength(result, dataOut.cbData);
  //setLength(BytesOut, dataOut.cbData);
  move(dataOut.pbData^, result[0], dataOut.cbData);
  //move(dataOut.pbData^, BytesOut[0], dataOut.cbData);

  FreeDataBlob(dataOut);
//  FreeDataBlob(dataEnt);
  //LocalFree(HLOCAL(dataOut.pbData));

end;

function decryptData(cipher_text: TBytes): string;
var
  Bytes, BytesEnt, BytesOut: TBytes;
  dataIn: DATA_BLOB;
  dataOut: DATA_BLOB;
  dataEnt: DATA_BLOB;
begin
  result := '';
  dataIn.cbData := length(cipher_text);
  dataIn.pbData := @cipher_text[0];

  BytesEnt := TEncoding.UTF8.GetBytes(EXTRA_ENTROPY);
  dataEnt.cbData := length(BytesEnt);
  dataEnt.pbData := @BytesEnt[0];

  if CryptUnprotectData(@dataIn, nil, @dataEnt, nil, nil, CRYPTPROTECT_UI_FORBIDDEN, @dataOut) then
  begin
    try
      SetLength(BytesOut, dataOut.cbData);
      move(dataOut.pbData^, BytesOut[0], dataOut.cbData);
      result := TEncoding.UTF8.GetString(BytesOut);
    finally
      FreeDataBlob(dataOut);
//      FreeDataBlob(dataEnt);
      FillChar(BytesOut, SizeOf(BytesOut), 0);
    end;
  end;
end;

end.
