{ bitfarm Standard-Objekte @italic((nur Auzug)) }
unit bfaObjects36;

interface

uses
  Classes, Generics.Collections, Uni, DB, XMLIntf, bfaLog, {bfaSP,}
  bfaCommonUtils, bfaBaseObjects, u_bfaAddfield, Graphics,  HTTPApp,
  gnugettext, ievect, bfaImageEnVect, bfaImageEnMView
  ;

type

//   TBfData = class
//   public
//      EnvTemp,   // %temp%
//      EnvTempPd, // %temp% mit Pathdelimiter
//      EnvSystemRoot,
//      EnvSystemRootPd,
//      EnvAppdata,
//      EnvAppdataPd,
//      EnvAppdataImporter,
//      EnvAppdataImporterPd,
//      EnvAppdataWorkplace,
//      EnvAppdataWorkplacePd,
//      EnvUsername,
//      EnvProgramData,
//      EnvProgramDataPd,
//
//      AppdataBitfarm,
//      AppdataBitfarmPd,
//      ProgramDataBitfarm,
//      ProgramDataBitfarmPd,
//      MyLoginIniName,
//
//      ExeFile,
//      ExeDir,
//      GtDomain, // Domain fr gnugettext
//
//      LogPath, // Verzeichnis fr das Logs
//      LogName, // Dateiname (ohne Pfad) fr das Log. "<%d>" steht fr das Datum
//      LogUser, // User fr den geloggt wird
//      LogPre,
//      dummy: string;
//      LogOn, DevDebug, SetDuplex : Boolean;
//      constructor Create;
//   end;

  TArchive = record
    Name: string;
    Arcid: Int64;
    Lgrid: Int64;
    Typ: Integer;
    Flags: Integer;
    Backpic: string;
    Options: Integer;
    DefDocname: string;
    Storageid: Integer;
    Rights: Int64;
  end;

  TbfaAnnoObj = record
    ID: Integer;
    ObjKind: TIEVObjectKind;
    ObjText: WideString;
    Modified: Boolean;
    NewText: WideString;
    Name: WideString;
    ModifiedType: Integer;
  end;

  TbfaAnnotation = class(TbfaBaseObject)
  private
    FAnnoStream: TMemoryStream;
    FPage: Integer;
    FLayer: Integer;
    FPriv: Boolean;
    FFilePath: WideString;
    FText: WideString;
    FRights: Integer;
    FHistory: TList <TbfaHistory>;
    FDeleted: Boolean;
    procedure SetDeleted(Value: Boolean);
    function GetDeleted: Boolean;
  public
    ObjList: array of TbfaAnnoObj;

    constructor Create; override;
    destructor Destroy; override;

    /// <summary>
    ///   Erzeugt neues Objekt und setzt Werte von Source
    /// </summary>
    procedure Clone(Source: TbfaAnnotation);

    procedure ClearHistoryList;

    property AnnoStream: TMemoryStream read FAnnoStream write FAnnoStream;
    property Page: Integer read FPage write FPage;
    property Priv: Boolean read FPriv write FPriv;
    property Layer: Integer read FLayer write FLayer;
    property FilePath: WideString read FFilePath write FFilePath;
    property Text: WideString read FText write FText;
    property Rights: Integer read FRights write FRights;
    property History: TList<TbfaHistory> read FHistory write FHistory;
    property Deleted: Boolean read GetDeleted write SetDeleted;
  end;


  TbfaStationery = class(TObject)
  private
    FStationeryStream: TMemoryStream;
    FPages: Integer;
  public
    Layers: array of Integer;

    constructor Create;
    destructor Destroy; override;
    procedure Clone(Source: TbfaStationery);
    procedure Load(var img: TbfaImageEnVect;
      DocPageCount: Integer; FilePath: WideString = ''; Str: TMemoryStream = nil);

    property StationeryStream: TMemoryStream read FStationeryStream;
    property Pages: Integer read FPages;
  end;

  TBfaADObject = class(TObject)
  public
    Name: WideString;
    Typ: WideString;
    Ldap: WideString;
    Modified: Boolean;
    DisplayName: WideString;
    Flags: Integer;
    Highlight: Boolean;

    constructor Create;
    procedure Clone(Source: TbfaADObject);

  end;

  TbfaBracket = class(TObject)
  private
    Fkind: TbfaBracketKind;
    procedure SetBracketKind(const Value: TbfaBracketKind);
  public

    display: string;
    constructor Create;
    procedure Clone(Source: TbfaBracket);
    property Kind: TbfaBracketKind read FKind write SetBracketKind;
  end;

  TbfaJunction = class(TObject)
  private
    Fkind: TbfaJunctionKind;
    procedure SetJunctionKind(const Value: TbfaJunctionKind);
  public

    display: string;
    OnChange: procedure of object;
    constructor Create;
    procedure Clone(Source: TbfaJunction);

    property Kind: TbfaJunctionKind read FKind write SetJunctionKind;
  end;

  TbfaExpression = class(TObject)
  private
    FFieldtype: eAddFieldType;
    FDateFormat: eDateFormat;
    Ffield: string;
    Ffieldname: WideString;
    FDisplay: WideString;
    Fvalue: WideString;
    FID: Integer;
    FStatus: Boolean;
    FIndexID: Integer;
    procedure SetFieldtype(const Value: eAddFieldType);
    procedure SetField(const Value: string);
    procedure SetFieldname(const Value: WideString);
    procedure SetValue(const Value: WideString);
    procedure SetDisplay;
    procedure SetDateFormat(const Value: eDateFormat);
  public
    junction: TbfaJunction;
    oplist: TStringList;
    op: string;

    constructor Create;
    destructor Destroy; override;

    procedure Update;
    procedure Clone(Source: TbfaExpression);
    property Fieldtype: eAddFieldType read FFieldtype write SetFieldtype ;
    property DateFormat: eDateFormat read FDateFormat write SetDateFormat;
    property Field: string read FField write SetField;
    property Fieldname: WideString read Ffieldname write SetFieldname;
    property Value: WideString read FValue write SetValue;
    property Display: WideString read FDisplay;
    property ID: Integer read FID write FID;
    property Status: Boolean read FStatus write FStatus;
    property IndexID: Integer read FIndexID write FIndexID;
  end;



//  TbfaFieldRight = class(TObject)  // ein Feldberechtigungssatz fr entweder ein Addfield ODER ein Statefield
//  public                            // es kann entweder eine Userid ODER eine GroupID hinterlegt werden
//    ArcID : Integer;                // die Rechte werden als Bitmaske gespeichert
//    FieldID : Integer;           //  rFieldRead      = 1;
//    Userid : Integer;               //  rFieldModify    = 4;
//    Groupid : Integer;
//    Rights : Integer;
//    Fieldpos : Integer;
//    Modified : Boolean;
//    Deleted: Boolean;
//    constructor Create; overload;
//    Procedure Clone(Source: TbfaFieldRight);
//
//  end;

  TbfaArcRight = class(TObject)     // ein Archivberechtigungssatz
  public                            // es kann entweder eine Userid ODER eine GroupID hinterlegt werden
    ArcID: Integer;                // die Rechte werden als Bitmaske gespeichert
    ArcTempID: TGUID; //24.01.2022 Ticket 29625
    Userid: Integer;
    Groupid: Integer;
    Rights: Integer;
    Modified: Boolean;
    Deleted: Boolean;
    constructor Create; overload;
    Procedure Clone(Source: TbfaArcRight);

  end;


  TbfaAddField = class(TbfaBaseField)
  private
    FModifiedHigh: Boolean;
  published
  public
    Items: TStringList;
    Rights: Int64;
    Component: TBfaAddfieldComp;
    ValuesQuery: WideString;
    Checkprogram: WideString;
    constructor Create; overload; override;
    constructor Create(value: Int64); overload;
    destructor Destroy; override;

    procedure Clone(Source: TbfaAddField); overload;
    procedure SetValue(value, valuehigh: Variant; modified, modifiedhigh: Boolean);
    property ModifiedHigh: Boolean read FModifiedHigh write FModifiedHigh;
  end;

  TbfaStateField = class(TbfaBaseField)
    private
      FBitmask: Int64;
      FIndexColumnID: Integer;
      FAddfieldID: Integer;
      FFunc: Integer;
      FRights: Int64;
      FFlags: Integer;

    public
      //IndexColumnID : Integer;
//      Rights : Int64;
//          AddfieldID : Integer;
//      Func : Integer;
//      Component : TbfaStatefieldComp;
      Component: TBfaStatefieldComp;
      constructor Create; override;
      destructor Destroy; override;

      procedure Clone(Source: TbfaStateField); overload;
      procedure SetValue(value: TFieldState; modified : Boolean);
      property Bitmask: Int64 read FBitmask write FBitmask;
      property IndexColumnID: Integer read FIndexColumnID write FIndexColumnID;
      property AddfieldID: Integer read FAddfieldID write FAddfieldID;
      property Func: Integer read FFunc write FFunc;
      property Rights: Int64 read FRights write FRights;
      property Flags: Integer read FFlags write FFlags;
  end;

  TbfaSvnField = class(TbfaBaseObject)
    public
      Gdocid: Int64;
      Date: TDateTime;
      Info: WideString;
      Version: Integer;
      Revision: Integer;
      Userid: Integer;

      constructor Create; override;
      procedure Clone(Source: TbfaSvnField); overload;
    end;

  TbfaWorkflow = class(TbfaBaseObject)
    public
      TimID: Int64;
      TimRef: Int64;
      Gdocid: Int64;
      Profile: WideString;
      Date: TDateTime;
      AlarmDate: TDateTime;
      UseridWork: Integer;
      UseridShed: Integer;
      Users: string;
      Groups: string;
      GroupID: Integer;
      Status: Integer;
      Options: Integer;
      Info: WideString;
      Comment: WideString;
      Required: Integer;
      WfID: Integer;
      HistID: Integer;
      ModifiedDate: TDateTime;

      constructor Create; override;
      procedure Clone(Source: TbfaWorkflow); overload;
  end;

  TbfaDLM = class(TbfaBaseObject)
  public
    Typ: Integer;
    Fieldid: Integer;
    Item: WideString;
    Items: TStringList;
    Duration: Integer;
    Interval: string;
    Date: TDateTime;
    Prio: Integer;
    Mode: Integer;
    CurrentItem: Boolean;

    constructor Create; override;
    procedure Clone(Source: TbfaDLM); overload;

  end;

    TbfaADEntry = class(TbfaBaseObject)
  public
    ADClass: string;
    ADPath: string;
    DisplayName: string;
    SamAccountname: string;
    Mail: string;
    UserAccountControl: Integer;
    HasUser: Boolean;

    constructor Create; override;
    procedure Clone(Source: TbfaADEntry); overload;

  end;

  TbfaArchive = class(TbfaBaseObject)
  public
    Tblname: string;
    Lgrid: Int64;
    Flags: Integer;
    Backpic: WideString;
    Options: Integer;
    DefDocname: WideString;
    Storageid: Integer;
    Rights: Int64;
    Users: TStringList;    // die zugeordneten User als Liste mit: str(Userid), Object = TbfaArcRight
    Groups: TStringList;    // die zugeordneten User als Liste str(Groupid), Object = TbfaArcRight
    Addfields: TStringList; // die Zusatzfelder als Liste mit: str(Addfieldid), Object = TList<TbfaFieldRights>
    Statefields: TStringList;  // die Statusfelder als Liste mit: str(Statefieldid), Object = TList<TbfaFieldRights>
    Modified_User: Boolean;
    Modified_Addfields: Boolean;
    Modified_Statefields: Boolean;
    Modified_Expired: Boolean;
    Duration: Integer;
    Interval: string;

    constructor Create; override;
    destructor Destroy; override;
    procedure Clone(Source: TbfaArchive); overload;

    property Typ: Integer read FObjType write FObjType;


  end;

  /// <Beschreibung>bitfarm Document Klasse</Beschreibung>
  /// <Description>bitfarm Document class</Description>
  TbfaDocument = class(TbfaBaseDocument)
		private
      FAddfields: TList<TbfaAddfield>;
      FStatefields: TList<TbfaStateField>;
      FSvnHistory: TList<TbfaSvnField>;
      FWorkflows: TList<TbfaWorkflow>;
      FHistory: TList <TbfaHistory>;
      FAnnotations: TList<TbfaAnnotation>;
      FScanPoolView: TbfaImageEnMView;
      FThumbnailView: TbfaImageEnMView;
      FScanPoolViewChanged: Boolean;
      FScanPoolViewLoaded: Boolean;
		public
 			constructor Create; override;
      destructor Destroy; override;
      procedure Clone(Source: TbfaDocument; WithTempID: Boolean = False;
        WithOriStream: Boolean = True; WithProcesses: boolean = True;
        WithThumbnailView: Boolean = True;
        OnlyDoc: Boolean = False;
        WithDocStream: Boolean = True;
        WithProperties: Boolean = True); overload;
      procedure Reset; override;
      /// <Beschreibung></Beschreibung>
      /// <Description></Description>
      function GetAnnotation(PageIdx: Integer; LayerIdx: Int64;
        var ContainerIdx: Integer): TbfaAnnotation;

      /// <summary>
      ///   True wenn Annos vorliegen
      /// </summary>
      function HasAnnotation: Boolean;
      procedure SetAnnoPageCount(OldPage, NewPage: Integer);
      procedure DeleteAnno(Page: Integer; MovePage: Boolean = False);

      property AddFields: TList<TbfaAddfield> read FAddfields write FAddfields;
      property StateFields: TList<TbfaStateField> read FStatefields write FStatefields;
      property SvnHistory: TList<TbfaSvnField> read FSvnHistory write FSvnHistory;
      property Workflows: TList<TbfaWorkflow> read FWorkflows write FWorkflows;
      property History: TList<TbfaHistory> read FHistory write FHistory;
      property Annotations: TList<TbfaAnnotation> read FAnnotations write FAnnotations;
      property ScanPoolView: TbfaImageEnMView read FScanPoolView write FScanPoolView;
      property ScanPoolViewchanged: Boolean read FScanPoolViewChanged write FScanPoolViewChanged;
      property ScanPoolViewLoaded: Boolean read FScanPoolViewLoaded write FScanPoolViewLoaded;
      property ThumbnailView: TbfaImageEnMView read FThumbnailView write FThumbnailView;
  end;

  PbfaDocument = ^TbfaDocument;


  TbfaSearch = class(TbfaBaseSearch)
  private
    /// <Beschreibung>Liste mit BitfarmAddfield Objekten</Beschreibung>
    /// <Description></Description>
    FAddFields: TList<TbfaAddField>;
    /// <Beschreibung>Liste mit BitfarmStatefield Objekten</Beschreibung>
    /// <Description></Description>
    FStsFields: TList<TbfaStateField>;

    function GetAddFieldXML: Variant;
    function GetStsFieldXML: Variant;

  public
    constructor Create; override;
    destructor Destroy; override;

    procedure Reset; override;
    procedure Clone(Source: TbfaSearch; WithGUID: Boolean = False); overload;

//    function DoXMLFromAddFields : Variant;
//    function DoXMlFromStateFields : Variant;

    property AddFields: TList<TbfaAddField> read FAddFields write FAddFields;
    property StsFields: TList<TbfaStateField> read FStsFields write FStsFields;
    property AddFieldXML: Variant read GetAddFieldXML write FAddFieldXML;
    property StsFieldXML: Variant read GetStsFieldXML write FStsFieldXML;
  end;

  TbfaSearchProcessing = class(TbfaBaseSearchProcessing)
  private
//    Fqry : TUniStoredProc;

    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    procedure AddSearchFields(SObj: TbfaSearch; ChildNode: IXMLNode);
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
//10.09.2015    procedure WriteFieldsToXML(SObj : TbfaSearch; var ChildNode : IXMLNode);
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    function FillSearchObjectWithNode(SObj: TbfaSearch; Fav: IXMLNode): TbfaSearch;

  public
    Fqry: TUniStoredProc;
    OnCheckHistoryNodes: procedure (HistoryObj: TbfaSearch) of object;

    constructor Create;
    destructor Destroy; override;

    /// <Beschreibung>Funktion um eine Lesezeichendatei einzulesen. Gibt eine Liste an SearchObjekten zurck. Optional kann man den Namen oder die ID eines bestimmten Lesezeichen angeben, welches dann zurckgegeben wird. Wird eine UserId/GroupID bzw eine Liste von IDs angegeben, so werden nur die Lesezeichen zurckgegeben, auf die mindestens eine (oder mehrere) ID berechtigt ist. Die Eingrenzung auf UserId hat Vorrang vor GroupID</Beschreibung>
    /// <Description></Description>
    function ReadXMLFile(Path: WideString; Name: WideString = ''; ID: Int64 = -1;
      UserID: Integer = -1; GroupID:  Integer = -1): TList<TbfaSearch>; overload;
    /// <Beschreibung>Funktion um ein SearchObject direkt mit einem XML-Knoten (fav-Node) zu fllen, bei Erfolg wird ein SearchObject zurckgegeben, andernfalls None. Der Knoten muss ein ElementTree.Element Objekt sein</Beschreibung>
    /// <Description></Description>
    function FillSearchWithNode(Fav: IXMLNode): TbfaSearch;
    /// <Beschreibung>Funktion um SearchObjekte als XML-File zu schreiben. Das Format der XML entspricht der Version 3.6. Es kann ein Objekte oder eine Liste an Objekten bergeben werden. Funktion liefert True bei Erfolg</Beschreibung>
    /// <Description></Description>
//10.09.2015    function WriteXMLFile(Path : WideString; Items : TList<TbfaSearch>) : Boolean;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    procedure Reset;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
//30.04.2024    function Search(Cnt: TUniConnection; SearchObj: TbfaSearch; HistoryObj: TbfaSearch; out ErrorStr: string; SList: TStringList = nil): TDataSet;
    function Search(Cnt: TUniConnection; SearchObj: TbfaSearch; HistoryObj: TbfaSearch;
      out ErrorStr: string; SList: TStringList = nil; DevLog: TbfaLog = nil): TDataSet;

  end;

//  TbfaUserRec = record
//    ID : Int64;
//    Name : WideString;
//    DisplayName : WideString;
//    Email : WideString;
//    Flags : Integer;
//    Password : WideString;
//    GroupList : TStringList;
//  end;

  TbfaGroupRec = record
    GroupID: Int64;
    SysGrpID: Int64;
    GroupName: WideString;
    Description: WideString;
    ParentID: Int64;
  end;

  TbfaCoordinates = record
    Top,
    Left,
    Bottom,
    Right: Integer;
  end;

    TbfaNodeInfo = class(TObject)
    public
      Typ: Integer;
      // <Typ>
      //    -1 = User/Group Folders in GlobalListNode and RootNodes {not moveable}
      //    0 = Global Folders {moveable for administrators}
      //    1 = Local Folders  {moveable}
      //    2 = History Folders {do not exist currently}
      // </Typ>
      Userid: Int64;
      Groupid: Int64;
      GUID: string;
      constructor Create; overload;
      constructor Create(AGUID: string); overload;
      constructor Create(AType: Integer; AGUID: string); overload;
    end;

    TbfaWordPos = class(TbfaBaseObject)
    public
      Page: Integer;
      Coordinates: array of TbfaCoordinates;
      constructor Create; override;
      destructor Destroy; override;
//      procedure Clone(Source : TbfaHistory); overload;
    end;

    TbfaFtxPos = class(TbfaBaseObject)
    public
      Word: WideString;
      Color: TColor;
      WordList: TList<TbfaWordPos>;

      constructor Create; override;
      destructor Destroy; override;
//      procedure Clone(Source : TbfaHistory); overload;
    end;

    { Record um Updatestatus zu definieren }
    TbfaUpdateStatus = (eUpdateError, eNoUpdate, eUpdateAvailable, eUpdateOK);

    function IndexOfTbfaInt(list: TStrings; value: Integer): Integer; overload;
//    function IndexOfTbfaInt(list : TStringList; value : Integer): Integer; overload;
    function IndexOfTbfaInt(list: TStrings; value: Int64): Integer; overload;

//const
//    BD: TBfData = nil;


implementation

uses SysUtils, Variants, ActiveX, XMLDoc, SpTBXEditors,
  cxCalendar, bfaParser, RegularExpressions, {u_ShDbUtils, bfaCommonImageEN,}
  bfaBaseImageEN, hyieutils, imageenio
  {$IFDEF IMAGEEN1140}
  , iexBitmaps
  {$ENDIF}
  ;

//
//  Name: Create
//  Parameters: -
//  Beschreibung: Setzt die Standardwerte und erstellt die Objekte
//  Description: Sets the default values and creates the objects
//  Return value: -
// [] 17.04.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
procedure TbfaDocument.Clone(Source: TbfaDocument; WithTempID: Boolean = False;
  WithOriStream: Boolean = True; WithProcesses: boolean = True;
  WithThumbnailView: Boolean = True;
  OnlyDoc: Boolean = False; //13.03.2019 Ticket 18518 wenn nur gespeichert wird und bleibt stehen, dann muss nicht alles neugeladen werden
  WithDocStream: Boolean = True;
  WithProperties: Boolean = True
  );
var
  i: Integer;
  iebmp: TIEBitmap;
  bmp: Graphics.TBitmap;
begin
  FInCloneProcess := True;
  try
    try
      FAddfields.Clear;
      FStatefields.Clear;

      for i := 0 to FSvnHistory.Count-1 do
      begin
        FSvnHistory[i].Free;
        FSvnHistory[i] := nil;
      end;
      FSvnHistory.Clear;

      for i := 0 to FWorkflows.Count-1 do
      begin
        FWorkflows[i].Free;
        FWorkflows[i] := nil;
      end;
      FWorkflows.Clear;

      for i := 0 to FAnnotations.Count-1 do
      begin
        FAnnotations[i].Free;
        FAnnotations[i] := nil;
      end;
      FAnnotations.Clear;

      if WithProperties then //15.11.2023 bei SendTo nicht ntig
      begin
        for i := 0 to Source.FAddfields.Count -1 do
        begin
          FAddfields.Add(TbfaAddField.Create);
          FAddfields[i].Clone(Source.FAddfields[i]);
        end;

        for i := 0 to Source.FStatefields.Count -1 do
        begin
          FStatefields.Add(TbfaStateField.Create);
          FStatefields[i].Clone(Source.FStatefields[i]);
        end;

        for i := 0 to Source.FSvnHistory.Count -1 do
        begin
          FSvnHistory.Add(TbfaSvnField.Create);
          FSvnHistory[i].Clone(Source.FSvnHistory[i]);
        end;

        for i := 0 to Source.FWorkflows.Count -1 do
        begin
          FWorkflows.Add(TbfaWorkflow.Create);
          FWorkflows[i].Clone(Source.FWorkflows[i]);
        end;

        for i := 0 to Source.FHistory.Count -1 do
        begin
          FHistory.Add(TbfaHistory.Create);
          FHistory[i].Clone(Source.FHistory[i]);
        end;
      end;

      for i := 0 to Source.Annotations.Count - 1 do
      begin
        FAnnotations.Add(TbfaAnnotation.Create);
        FAnnotations[i].Clone(Source.Annotations[i]);
      end;

    except
      FErrorCode := ecDocumentFailureInClone;
    end;

    inherited Clone(Source, WithTempID, WithOriStream, WithProcesses,
      WithThumbnailView, OnlyDoc, WithDocStream);

    FScanPoolViewLoaded := Source.ScanPoolViewLoaded;
    FScanPoolViewChanged := Source.ScanPoolViewchanged;

    if not OnlyDoc then //13.03.2019 Ticket 18518
    begin
      //22.05.2018 Ticket 14756 -->
      if (FThumbnailView <> nil) or (Source.ThumbnailView <> nil) then
      begin
        try
          if (FThumbnailView = nil) and (WithThumbnailView) then
            CreateThumbnailView(FThumbnailView, Source.ThumbnailView.Owner, nil)
          else if (FThumbnailView <> nil) then
            FThumbnailView.Clear;

          if (FThumbnailView <> nil) and (Source.ThumbnailView <> nil) and
             (Source.FThumbnailView.ImageCount > 0) then
          begin
            FThumbnailView.LockPaint;
            try
              for i := 0 to Source.FThumbnailView.ImageCount - 1  do
              begin
                iebmp := TIEBitmap.Create;
                bmp := Graphics.TBitmap.Create;
                try
                  Source.FThumbnailView.CopyToIEBitmap(i, iebmp);
                  FThumbnailView.InsertImageEx(i);
                  FThumbnailView.SetIEBitmap(i, iebmp);

                  FThumbnailView.Mio.Params[i].BMP_Version := ioBMP_BMOS2V2;
                  FThumbnailView.Mio.Params[i].BMP_Compression := ioBMP_RLE;

                  FThumbnailView.Mio.Params[i].TIFF_Compression :=
                    Source.ThumbnailView.MIO.Params[i].TIFF_Compression;
                  FThumbnailView.Mio.Params[i].BitsPerSample :=
                    Source.ThumbnailView.MIO.Params[i].BitsPerSample;
                  FThumbnailView.Mio.Params[i].SamplesPerPixel :=
                    Source.ThumbnailView.MIO.Params[i].SamplesPerPixel;
                finally
                  FreeAndNil(iebmp);
                  FreeAndNil(bmp);
                end;
              end;
            finally
              FThumbnailView.UnLockPaint;
              FThumbnailView.Update;
            end;
          end;
        except
          FErrorCode := ecDocumentFailureInClone;
        end;
      end;

      if (FScanPoolView <> nil) or (Source.ScanPoolView <> nil) then
      begin
        try
          FScanPoolViewChanged := Source.ScanPoolViewchanged;
          FScanPoolViewLoaded := Source.ScanPoolViewLoaded;
          if (FScanPoolViewLoaded) then
          begin
            if (FScanPoolView = nil) and (WithThumbnailView) then
              FScanPoolView := CreateInvisibleScanPoolMView(nil)
            else if (FScanPoolView <> nil) then
              FScanPoolView.Clear;

            if (FScanPoolView <> nil) and (Source.ScanPoolView <> nil) and
               (Source.ScanPoolView.ImageCount > 0) then
            begin
              FScanPoolView.LockPaint;
              try
                for i := 0 to Source.ScanPoolView.ImageCount - 1  do
                begin
                  iebmp := TIEBitmap.Create;
                  bmp := Graphics.TBitmap.Create;
                  try
                    Source.ScanPoolView.CopyToIEBitmap(i, iebmp);
                    FScanPoolView.InsertImageEx(i);
                    FScanPoolView.SetIEBitmap(i, iebmp);

                    FScanPoolView.Mio.Params[i].BMP_Version := ioBMP_BMOS2V2;
                    FScanPoolView.Mio.Params[i].BMP_Compression := ioBMP_RLE;

                    FScanPoolView.Mio.Params[i].TIFF_Compression :=
                      Source.ScanPoolView.MIO.Params[i].TIFF_Compression;
                    FScanPoolView.Mio.Params[i].BitsPerSample :=
                      Source.ScanPoolView.MIO.Params[i].BitsPerSample;
                    FScanPoolView.Mio.Params[i].SamplesPerPixel :=
                      Source.ScanPoolView.MIO.Params[i].SamplesPerPixel;
                    FScanPoolView.Mio.Params[i].DpiX :=
                      Source.ScanPoolView.MIO.Params[i].DPIX;
                    FScanPoolView.Mio.Params[i].DpiY :=
                      Source.ScanPoolView.MIO.Params[i].DPIY;
                  finally
                    FreeAndNil(iebmp);
                    FreeAndNil(bmp);
                  end;
                end;
              finally
                FScanPoolView.UnLockPaint;
                FScanPoolView.Update;
              end;
            end;
          end;
        except
          FErrorCode := ecDocumentFailureInClone;
        end;
      end;
//22.05.2018 Ticket 14756 <--
    end;

  finally
    FInCloneProcess := False;
  end;
end;

constructor TbfaDocument.Create;
begin
  try
		inherited Create;

    FAddfields := TList<TbfaAddfield>.Create;
    FStatefields := TList<TbfaStateField>.Create;
    FSvnHistory := TList<TbfaSvnField>.Create;
    FWorkflows := TList<TbfaWorkflow>.Create;
    FHistory := TList<TbfaHistory>.Create;
    FAnnotations := TList<TbfaAnnotation>.Create;
    FScanPoolView := nil;
    FThumbnailView := nil;
  except

  end;
end;

procedure TbfaDocument.SetAnnoPageCount(OldPage, NewPage: Integer);
var
  i: Integer;
  found: Boolean;
begin
  FErrorCode := 0;
  try
    if ((FID = -1)) then// and ((FDocType = dtEmpty) or (FDocType = dtScannedPage))) then
    begin
      i := 0;
      found := False;
      while ((not found) and (i <= FAnnotations.Count - 1)) do
      begin
        if FAnnotations[i].Page = OldPage then
        begin
          found := True;
          FAnnotations[i].Page := NewPage;
        end;

        inc(i);
      end;
    end
    else
      FErrorCode := ecDocumentPageCountCannotbeSetbyArchivedDocument;

  except
    FErrorCode := ecDocumentFailureinSetPageCount;
  end;
end;

procedure TbfaDocument.DeleteAnno(Page: Integer; MovePage: Boolean = False);
var
  i: Integer;
  found: Boolean;
begin
  try
    if (FID = -1)  then //or ((FID <> -1) and (FInEditMode)) then // and ((FDocType = dtEmpty) or (FDocType = dtScannedPage))) then
    begin
      i := 0;
      found := False;
      while ((not found) and (i <= FAnnotations.Count - 1)) do
      begin
        if FAnnotations[i].Page = Page then
          found := True
        else
          inc(i);
      end;

      if found then
      begin
        try
          FAnnotations[i].AnnoStream.Clear;
          FAnnotations[i].AnnoStream.Free;
          FAnnotations[i].AnnoStream := nil;
          FAnnotations[i].Free;
          FAnnotations[i] := nil;
        finally                   //17.01.2019
          FAnnotations.Delete(i);
        end;
      end;

      if MovePage then
      begin
        for i := 0 to FAnnotations.Count - 1 do
        begin
          if FAnnotations[i].Page > Page then
            FAnnotations[i].Page := FAnnotations[i].Page - 1;
        end;
      end;
    end;
  except
    FErrorCode := ecDocumentFailureinSetPageCount;
  end;
end;

destructor TbfaDocument.Destroy;
var
  i : Integer;
  tmp : Integer;
begin
  try
    try
      tmp := 0;
      while FInCloneProcess do
        inc(tmp);        

      try
        if FAddfields <> nil then
        begin
          for i := 0 to FAddfields.Count-1 do
          begin
            try
              FAddfields[i].Free;
            finally
              FAddfields[i] := nil;
            end;
          end;
          FAddfields.Clear;
          FreeAndNil(FAddfields);
        end;
      finally
        FAddfields := nil;
      end;

      try
        if FStatefields <> nil then
        begin
          for i := 0 to FStatefields.Count-1 do
          begin
            try
              FStatefields[i].Free;
            finally
              FStatefields[i] := nil;
            end;
          end;
          FStatefields.Clear;
          FreeAndNil(FStatefields);
        end;
      finally
        FStatefields := nil;
      end;

      try
        if FSvnHistory <> nil then
        begin
          for i := 0 to FSvnHistory.Count-1 do
          begin
            FSvnHistory[i].Free;
            FSvnHistory[i] := nil;
          end;
          FSvnHistory.Clear;
          FreeAndNil(FSvnHistory);
        end;
      finally
        FSvnHistory := nil;
      end;

      try
        if FHistory <> nil then
        begin
          for i := 0 to FHistory.Count-1 do
          begin
            FHistory[i].Free;
            FHistory[i] := nil;
          end;
          FHistory.Clear;
          FreeAndNil(FHistory);
        end;
      finally 
        FHistory := nil;   
      end;

      if FAnnotations <> nil then
      begin
        try
          for i := FAnnotations.Count - 1 downto 0 do
          begin
            try
              FAnnotations[i].Free;
            finally
              FAnnotations[i] := nil;
            end;
          end;
          FAnnotations.Clear;
          FreeAndNil(FAnnotations);
        except
          //17.01.2019
          FAnnotations := nil;
        end;
      end;

      try
        if FScanPoolView <> nil then
        begin
          try
            FScanPoolView.Clear;
//29.08.2023 -->
//            FScanPoolView.Free; //10.05.2023
            {$IFDEF IMAGEEN_SYNCHRONIZED}
            FScanPoolView.Free; //10.05.2023
            {$ENDIF}
//29.08.2023 <--
          finally
            FScanPoolView := nil;
          end;
        end;

        if FThumbnailView <> nil then
        begin
          try
            FThumbnailView.Clear;
//29.08.2023 -->
//            FThumbnailView.Free; //10.05.2023
            {$IFDEF IMAGEEN_SYNCHRONIZED}
            //28.09.2023 Verursacht ein Fehler im Multiview Bereichen FThumbnailView.Free; //10.05.2023
            {$ENDIF}
//29.08.2023 <--
          finally
            FThumbnailView := nil;
          end;
        end;
      except
        //09.01.2019
      end;
    except
      //09.01.2019
    end;     
  finally
    inherited Destroy;
  end;
end;


function TbfaDocument.HasAnnotation: Boolean;
begin
  try
    Result := FAnnotations.Count > 0;
  except
    Result := False;
  end;
end;

function TbfaDocument.GetAnnotation(PageIdx: Integer; LayerIdx: Int64;
  var ContainerIdx: Integer): TbfaAnnotation;
var
  found: Boolean;
  i: Integer;
begin
  Result := nil;
  try
    if FAnnotations = nil then
      Exit;

    try
      ContainerIdx := -1;
      if FAnnotations.Count > 0 then
      begin
        i := 0;
        found := False;
        while ((not found) and (i <= FAnnotations.Count - 1)) do
        begin
          if (FAnnotations[i].Page = PageIdx) and (LayerIdx = -1) then
            found := True
          else if (FAnnotations[i].Page = PageIdx) and (FAnnotations[i].Layer = LayerIdx) then
            found := True
          else
            inc(i);
        end;
        if found then
        begin
          ContainerIdx := i;
          Result := FAnnotations[i];
        end;
      end;
    except
      ContainerIdx := -1;
      Result := nil;
    end;
  except
    Result := nil;
  end;
end;

procedure TbfaDocument.Reset;
begin
  inherited;
  if FAnnotations <> nil then
  begin
    for var i := FAnnotations.Count - 1 downto 0 do
      FAnnotations[i].Free;
    FAnnotations.Clear;
  end;
  FScanPoolViewChanged := False;
  FScanPoolViewLoaded := False;
end;


{ TbfaAddField }

constructor TbfaAddField.Create;
begin
  inherited Create;
  Items := TStringList.Create;
  Items.Delimiter := ';';
  Items.StrictDelimiter := True;
  Rights := -1;
  Component := nil;
  ValuesQuery := '';
  Checkprogram := '';
  Description := '';
  ModifiedHigh := False;
end;

constructor TbfaAddField.Create(value: Int64);
begin
  inherited Create;
  Items := TStringList.Create;
  Items.Delimiter := ';';
  Items.StrictDelimiter := True;
  Rights := -1;
  Component := nil;
  ValuesQuery := '';
  Checkprogram := '';
  Description := '';
  ModifiedHigh := False;
  ID := value;
end;

destructor TbfaAddField.Destroy;
var
  i: Integer;
begin
  FreeAndNil(Items);

  inherited Destroy;
end;

procedure TbfaAddField.SetValue(value, valuehigh: Variant; modified, modifiedhigh : Boolean);
begin
  Self.Value := value;
  Self.ValueHigh := valuehigh;
  Self.Modified := modified;
  Self.ModifiedHigh := modifiedhigh;
end;

procedure TbfaAddField.Clone(Source : TbfaAddField);
var
  i: Integer;
begin
  inherited Clone(Source);
  Items := TStringList.Create;
  Items.Delimiter := ';';
  Items.StrictDelimiter := True;
  if (Source.Items <> nil) and (Source.Items.Count > 0) then
    Items.CommaText := Source.Items.CommaText;
  Rights := Source.Rights;
//  if Source.Component <> nil then
//    Component := TBfaAddfieldComp.Create(Source.Component.Parent, Source.Component.AddfieldType,Source.Component.Dispname, Source.Component.Indexing);
//  Component := Source.Component;
  ValuesQuery := Source.ValuesQuery;
  Checkprogram := Source.Checkprogram;
  ModifiedHigh := Source.ModifiedHigh;
  Description := Source.Description;
end;

{ TbfaStateField }

constructor TbfaStateField.Create;
begin
  inherited Create;
  FIndexColumnID := 0;
  FBitmask := 0;
  FRights := 0;
  FAddfieldID := 0;
  FFlags := 0;
end;

destructor TbfaStateField.Destroy;
var
  i: Integer;
begin

  inherited Destroy;
end;

procedure TbfaStateField.Clone(Source : TbfaStateField);
var
  i: Boolean;
begin
  inherited Clone(Source);

  FBitmask := Source.Bitmask;
  FIndexColumnID := Source.IndexColumnID;
  FRights := Source.Rights;
  FAddfieldID := Source.AddfieldID;
  FFunc := Source.Func;
  FFlags := Source.Flags;
//      Component : TbfaStatefieldComp;
end;

procedure TbfaStateField.SetValue(value: TFieldState; modified : Boolean);
begin
  Self.Value := value = fsSet;
  Self.Modified := modified;
end;

constructor TbfaSearch.Create;
begin
  inherited Create;
  FAddFields := TList<TbfaAddField>.Create;
  FAddFields.Clear;
  FStsFields := TList<TbfaStateField>.Create;
  FStsFields.Clear;
end;

procedure TbfaSearch.Reset;
begin
  inherited Reset;
  if FAddFields <> nil then
    FAddFields.Clear;
  if FStsFields <> nil then
    FStsFields.Clear;
end;

destructor TbfaSearch.Destroy;
var
  i : Integer;
begin
  if FAddFields <> nil then
  begin
    for i := FAddFields.Count - 1 downto 0 do
    begin
      FAddFields[i].Free;
      FAddFields[i] := nil;
    end;
    FAddFields.Clear;
    FreeAndNil(FAddFields);
  end;

  if FStsFields <> nil then
  begin
    for i := FStsFields.Count - 1 downto 0 do
    begin
      FStsFields[i].Free;
      FStsFields[i] := nil;
    end;
    FStsFields.Clear;
    FreeAndNil(FStsFields);
  end;

  inherited Destroy;
end;

procedure TbfaSearch.Clone(Source : TbfaSearch; WithGUID: Boolean = False);
var
  i : Integer;
  Fld : TbfaAddField;
  Sts : TbfaStateField;
  TempGUID: TGUID;
begin
  inherited Clone(Source);
  FAddFields := TList<TbfaAddField>.Create;
  FAddFields.Clear;
  for i := 0 to Source.AddFields.Count - 1 do
  begin
    Fld := TbfaAddField.Create;
    Fld.Clone(Source.AddFields[i]);
    FAddFields.Add(Fld);
  end;

  FStsFields := TList<TbfaStateField>.Create;
  FStsFields.Clear;
  for i := 0 to Source.StsFields.Count - 1 do
  begin
    Sts := TbfaStateField.Create;
    Sts.Clone(Source.StsFields[i]);
    FStsFields.Add(Sts);
  end;
  if WithGUID then
  begin
    if Source.GUID <> cEmptyGUID then
      Self.GUID := Source.GUID
    else
    begin
      CreateGUID(TempGUID);
      Self.GUID := GUIDToString(TempGUID);
    end;
  end;

end;

function TbfaSearch.GetAddFieldXML : Variant;
begin
  if (not VarIsNull(FAddFieldXML)) and (FAddFieldXML <> '') then
    Result := FAddFieldXML
  else if FAddFields.Count > 0 then
  begin
//25.07.2018    Result := UTF8ToWideString(ObjectToXML(TList<TbfaBaseObject>(FAddFields), True, 'utf-8')); //25.07.2018 Fehler bei der Suche mit mehreren 100 eintrgen bei Auswahlfeldern
    Result := UTF8ToWideString(ObjectToXML(TList<TbfaBaseObject>(FAddFields), True,
      'utf-8', '', '', nil, nil, False));    
    Result := HTTPApp.HTMLDecode(Result);
  end
  else
    Result := '';
end;

function TbfaSearch.GetStsFieldXML : Variant;
begin
  if (not VarIsNull(FStsFieldXML)) and (FStsFieldXML <> '') then
    Result := FStsFieldXML
  else if FStsFields.Count > 0 then
    Result := UTF8ToWideString(ObjectToXML(TList<TbfaBaseObject>(FStsFields), True, 'utf-8'))
  else
    Result := '';
end;

constructor TbfaSearchProcessing.Create;
begin
  Fqry := TUniStoredProc.Create(nil);
  Fqry.Name := 'spSearch36';
  Reset;
end;

destructor TbfaSearchProcessing.Destroy;
begin
  FreeAndNil(Fqry);
  inherited Destroy;
end;

procedure TbfaSearchProcessing.Reset;
begin
  FVersion := 36;
end;

function TbfaSearchProcessing.Search(Cnt: TUniConnection; SearchObj: TbfaSearch;
//30.04.2024  HistoryObj: TbfaSearch; out ErrorStr: string; SList: TStringList = nil): TDataSet;
  HistoryObj: TbfaSearch; out ErrorStr: string; SList: TStringList = nil; DevLog: TbfaLog = nil): TDataSet;
var
  i, idx: Integer;
  ArcIDs, GDocIDs, GroupList: WideString;
  UseRights, found: Boolean;
  qry, lmq: TUniQuery;
  TmpSList: TStringList;
  sqlwhere: WideString;
begin
  ErrorStr := '';
  if ((Cnt <> nil) and (Cnt.Connected) and (SearchObj <> nil)) then
  begin
    ArcIDs := '';
    GDocIDs := '';
    try
      UseRights := False;
      found := False;
      if (SearchObj.UserID > 0) then
      begin
        UseRights := True;
        found := SearchObj.UserID = SearchObj.UserContext;
      end;

      if ((SearchObj.GroupID > -1) and (not found)) then
      begin
        UseRights := True;

        if SearchObj.UserContext = -1 then  // kein User-Kontext aber eine Gruppensuche? Hier wird ein Gruppenlesezeichen getestet
          found := SearchObj.GroupList.Count > 0
        else begin
          qry := TUniQuery.Create(nil);
          qry.Connection := Cnt;
          TmpSList := TStringList.Create;
          try
            qry.SQL.Text := 'SELECT GROUP_CONCAT(groupid) as ids FROM sys_groupuser WHERE userid=' +
              IntToStr(SearchObj.UserContext) + ';';

            qry.Open;
            TmpSList.CommaText := qry.FieldByName('ids').AsString;
            qry.Close;
            if (TmpSList.Count > 0) then
            begin
              i := 0;
              while ((i <= TmpSList.Count - 1) and (not found)) do
              begin
                found := SearchObj.GroupID = StrToInt(TmpSList[i]);
                inc(i);
              end;
            end;
          finally
            FreeAndNil(qry);
            FreeAndNil(TmpSList);
          end;
        end;
      end;

      if ((not UseRights) or (UseRights and found)) then
      begin
        if SearchObj.SelectedArcID > 0 then
        begin
          if SearchObj.ArcID.IndexOf(IntToStr(SearchObj.SelectedArcID)) = -1 then
            SearchObj.ArcID.Add(IntToStr(SearchObj.SelectedArcID));
        end;

        if SearchObj.ArcID.Count > 0 then
        begin
          ArcIDs := SearchObj.ArcID.CommaText;
        end else
          ArcIDs := '';

        Fqry := TUniStoredProc.Create(nil);

        Fqry.Connection := Cnt;
        Fqry.Debug := Cnt.Debug;

        Fqry.StoredProcName := 'sp_search';
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'SearchProc.Search - sp_search', ClassName);
        Fqry.PrepareSQL;

        Fqry.ParamByName('prm_searchtype').AsInteger := SearchObj.SearchType;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_searchtype: ' + SearchObj.SearchType.ToString, ClassName);

        Fqry.ParamByName('prm_version').AsInteger := sSysVersion36;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_version: ' + sSysVersion36.ToString, ClassName);

        if ArcIDs <> '' then
        begin
          Fqry.ParamByName('prm_arcid').AsString := ArcIDs;
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_arcid: ' + ArcIDs, ClassName);
        end;

        if not VarIsNull(SearchObj.Order) and (SearchObj.Order <> '') then
        begin
          Fqry.ParamByName('prm_order').AsWideString := SearchObj.Order;
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_order: ' + SearchObj.Order, ClassName);
        end;

        Fqry.Params.ParamValues['prm_direction'] := SearchObj.Direction;
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_direction: ' + SearchObj.Direction, ClassName);

        Fqry.ParamByName('prm_limit').AsInteger := SearchObj.MaxValues;
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_limit: ' + SearchObj.MaxValues.ToString, ClassName);

        Fqry.ParamByName('prm_userid').AsLargeInt := SearchObj.UserContext;
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_userid: ' + SearchObj.UserContext.ToString, ClassName);

        Fqry.ParamByName('prm_searchuserid').AsLargeInt := SearchObj.SearchUserID;
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_searchuserid: ' + SearchObj.SearchUserID.ToString, ClassName);

        if SearchObj.SearchUserNegated then
          Fqry.ParamByName('prm_searchuser_negated').AsSmallInt := 1
        else
          Fqry.ParamByName('prm_searchuser_negated').AsSmallInt := 0;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_searchuser_negated: ' + BoolToStr(SearchObj.SearchUserNegated, True), ClassName);

        Fqry.ParamByName('prm_searchgroupid').AsLargeInt := SearchObj.SearchGroupID;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_searchgroupid: ' + SearchObj.SearchGroupID.ToString, ClassName);

        if SearchObj.SearchGroupNegated then
          Fqry.ParamByName('prm_searchgroup_negated').AsSmallInt := 1
        else
          Fqry.ParamByName('prm_searchgroup_negated').AsSmallInt := 0;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_searchgroup_negated: ' + BoolToStr(SearchObj.SearchGroupNegated, True), ClassName);

        if not VarIsNull(SearchObj.SearchDate) then
        begin
          if VarIsType(SearchObj.SearchDate, varDate) then
          begin
            Fqry.ParamByName('prm_searchdate').AsWideString := FormatDateTime('yyyy-mm-dd',SearchObj.SearchDate);
            if (DevLog <> nil) and BD.DevDebug then
              DevLog.Write(llDebug, ltInfo, 'prm_searchdate: ' + FormatDateTime('yyyy-mm-dd',SearchObj.SearchDate), ClassName);
          end
          else
          begin
            Fqry.ParamByName('prm_searchdate').AsWideString := SearchObj.SearchDate;
//23.05.2024            if (DevLog <> nil) and BD.DevDebug then
//              DevLog.Write(llDebug, ltInfo, 'prm_searchdate: ' + SearchObj.SearchDate.ToString, ClassName);
          end;
        end;

        if not VarIsNull(SearchObj.SearchDateHigh) then
        begin
          if VarIsType(SearchObj.SearchDateHigh, varDate) then
          begin
            Fqry.ParamByName('prm_searchdate_high').AsWideString := FormatDateTime('yyyy-mm-dd',SearchObj.SearchDateHigh);
            if (DevLog <> nil) and BD.DevDebug then
              DevLog.Write(llDebug, ltInfo, 'prm_searchdate_high: ' + FormatDateTime('yyyy-mm-dd',SearchObj.SearchDateHigh), ClassName);
          end
          else
          begin
            Fqry.ParamByName('prm_searchdate_high').AsWideString := SearchObj.SearchDateHigh;
//23.05.2024            if (DevLog <> nil) and BD.DevDebug then
//              DevLog.Write(llDebug, ltInfo, 'prm_searchdate_high: ' + SearchObj.SearchDateHigh.ToString, ClassName);
          end;
        end;

        if SearchObj.SearchDateNegated then
          Fqry.ParamByName('prm_searchdate_negated').AsSmallInt := 1
        else
          Fqry.ParamByName('prm_searchdate_negated').AsSmallInt := 0;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_searchdate_negated: ' + BoolToStr(SearchObj.SearchDateNegated, True), ClassName);

        if SearchObj.SQLWhereOnly then
          Fqry.ParamByName('prm_sqlwhere_only').AsSmallInt := 1
        else
         Fqry.ParamByName('prm_sqlwhere_only').AsSmallInt := 0;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_sqlwhere_only: ' + BoolToStr(SearchObj.SQLWhereOnly, True), ClassName);

        if not VarIsNull(SearchObj.SQLWhere) then
        begin
          Fqry.ParamByName('prm_sqlwhere').AsWideString := SearchObj.SQLWhere;
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_sqlwhere: ' + SearchObj.SQLWhere, ClassName);
        end
        else
        begin
          Fqry.ParamByName('prm_sqlwhere').AsWideString := '';
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_sqlwhere: ', ClassName);
        end;

        Fqry.Params.ParamValues['prm_sqlwhere_operator'] := SearchObj.SQLWhereOperator;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_sqlwhere_operator: ' + SearchObj.SQLWhereOperator, ClassName);

        Fqry.ParamByName('prm_ftx_fields').AsInteger := SearchObj.FtxFields;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_ftx_fields: ' + SearchObj.FtxFields.ToString, ClassName);

        Fqry.Params.ParamValues['prm_ftx'] := SearchObj.SearchString;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_ftx: ' + SearchObj.SearchString, ClassName);

        if SearchObj.SearchStringNegated then
          Fqry.ParamByName('prm_ftx_negated').AsSmallInt := 1
        else
          Fqry.ParamByName('prm_ftx_negated').AsSmallInt := 0;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_ftx_negated: ' + BoolToStr(SearchObj.SearchStringNegated, True), ClassName);

        if SearchObj.FtxMatchAgainst then
          Fqry.ParamByName('prm_matchagainst').AsSmallInt := 1
        else
          Fqry.ParamByName('prm_matchagainst').AsSmallInt := 0;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_matchagainst: ' + BoolToStr(SearchObj.FtxMatchAgainst, True), ClassName);

        if (SearchObj.FtxMatchAgainst) and (SearchObj.FtxNaturalMode) then
          Fqry.ParamByName('prm_natural_mode').AsSmallInt := 1
        else
          Fqry.ParamByName('prm_natural_mode').AsSmallInt := 0;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_natural_mode: ' + BoolToStr(SearchObj.FtxNaturalMode, True), ClassName);

        if (SearchObj.FtxMatchAgainst) and (SearchObj.FtxBooleanMode) and (not SearchObj.FtxNaturalMode) then
          Fqry.ParamByName('prm_boolean_mode').AsSmallInt := 1
        else
          Fqry.ParamByName('prm_boolean_mode').AsSmallInt := 0;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_boolean_mode: ' + BoolToStr(SearchObj.FtxBooleanMode, True), ClassName);

        if (SearchObj.FtxMatchAgainst) and (SearchObj.FtxWithQueryExpansion) then
          Fqry.ParamByName('prm_with_query_expansion').AsSmallInt := 1
        else
          Fqry.ParamByName('prm_with_query_expansion').AsSmallInt := 0;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_with_query_expansion: ' + BoolToStr(SearchObj.FtxWithQueryExpansion, True), ClassName);

        Fqry.Params.ParamValues['prm_result_type'] := SearchObj.ResultType;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_result_type: ' + SearchObj.ResultType, ClassName);

        Fqry.ParamByName('prm_selected_cols').AsWideString := SearchObj.SelectedCols;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_selected_cols: ' + SearchObj.SelectedCols, ClassName);

        Fqry.ParamByName('prm_addfield_xml').AsWideString := SearchObj.AddFieldXML;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_addfield_xml: ' + SearchObj.AddFieldXML, ClassName);

        Fqry.ParamByName('prm_stsfield_xml').AsWideString := SearchObj.StsFieldXML;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_stsfield_xml: ' + SearchObj.StsFieldXML, ClassName);

        Fqry.Params.ParamValues['prm_xmlpath'] := NULL;

        if SearchObj.Count then
          Fqry.ParamByName('prm_count').AsSmallInt := 1
        else
          Fqry.ParamByName('prm_count').AsSmallInt := 0;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_count: ' + BoolToStr(SearchObj.Count, True), ClassName);

        if not VarIsNull(SearchObj.CheckOut) then
        begin
          if SearchObj.CheckOut > -1 then
          begin
            Fqry.ParamByName('prm_checkout').AsInteger := SearchObj.CheckOut;
            if (DevLog <> nil) and BD.DevDebug then
              DevLog.Write(llDebug, ltInfo, 'prm_checkout: ' + SearchObj.CheckOut.ToString, ClassName);
          end;
        end else
          Fqry.Params.ParamValues['prm_checkout'] := NULL;

        if not VarIsNull(SearchObj.InResub) then
        begin
          if SearchObj.InResub then
            Fqry.ParamByName('prm_resub').AsSmallInt := 1
          else
            Fqry.ParamByName('prm_resub').AsSmallInt := 0;
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_resub: ' + BoolToStr(SearchObj.InResub, True), ClassName);


          if SearchObj.InResubNegated then
            Fqry.ParamByName('prm_resub_negated').AsSmallInt := 1
          else
            Fqry.ParamByName('prm_resub_negated').AsSmallInt := 0;
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_resub_negated: ' + BoolToStr(SearchObj.InResubNegated, True), ClassName);
        end else
        begin
          Fqry.Params.ParamValues['prm_resub'] := NULL;
          Fqry.ParamByName('prm_resub_negated').AsSmallInt := 0;
        end;

        Fqry.ParamByName('prm_state').AsInteger := SearchObj.State;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_state: ' + SearchObj.State.ToString, ClassName);

        Fqry.ParamByName('prm_notstate').AsInteger := SearchObj.NotState;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_notstate: ' + SearchObj.NotState.ToString, ClassName);

        if (SearchObj.GdocID.Count > 1) then
          GDocIDs := Stringreplace(SearchObj.GDocID.Text, Char(13) + Char(10), ',', [rfReplaceAll])
        else
          GDocIDs := Stringreplace(SearchObj.GDocID.Text ,Char(13) + Char(10), '', [rfReplaceAll]);

        if ((GDocIDs <> '') and (GDocIDs[Length(GDocIDs)] = ',')) then
          Delete(GDocIDs, length(GDocIDs), 1);

        Fqry.ParamByName('prm_gdocid').AsString := GDocIDs;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_gdocid: ' + GDocIDs, ClassName);

        if not VarIsNull(SearchObj.GdocIDWithSymLink) then
        begin
          if SearchObj.GdocIDWithSymLink then
            Fqry.ParamByName('prm_gdocid_with_symlink').AsSmallInt := 1
          else
            Fqry.ParamByName('prm_gdocid_with_symlink').AsSmallInt := 0;
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_gdocid_with_symlink: ' + BoolToStr(SearchObj.GdocIDWithSymLink, True), ClassName);
        end else
          Fqry.Params.ParamValues['prm_gdocid_with_symlink'] := NULL;

        Fqry.Params.ParamValues['prm_refsearch'] := SearchObj.RefSearch;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_refsearch: ' + SearchObj.RefSearch, ClassName);

        if SearchObj.RefSearchNegated then
          Fqry.ParamByName('prm_refsearch_negated').AsSmallInt := 1
        else
          Fqry.ParamByName('prm_refsearch_negated').AsSmallInt := 0;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_refsearch_negated: ' + BoolToStr(SearchObj.RefSearchNegated, True), ClassName);

        Fqry.Params.ParamValues['prm_timref'] := SearchObj.TimRef.CommaText;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_timref: ' + SearchObj.TimRef.CommaText, ClassName);

        if VarIsNull(SearchObj.ResubDate) then
        begin
          Fqry.ParamByName('prm_resubdate').AsWideString := '';
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_resubdate: ', ClassName);
        end
        else
        begin
          Fqry.ParamByName('prm_resubdate').AsWideString := SearchObj.ResubDate;
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_resubdate: ' + SearchObj.ResubDate, ClassName);
        end;

        if VarIsNull(SearchObj.ResubDateHigh) then
        begin
          Fqry.ParamByName('prm_resubdate_high').AsWideString := '';
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_resubdate_high: ', ClassName);
        end
        else
        begin
          Fqry.ParamByName('prm_resubdate_high').AsWideString := SearchObj.ResubDateHigh;
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_resubdate_high: ' + SearchObj.ResubDateHigh, ClassName);
        end;

        if SearchObj.ResubDateNegated then
          Fqry.ParamByName('prm_resubdate_negated').AsSmallInt := 1
        else
          Fqry.ParamByName('prm_resubdate_negated').AsSmallInt := 0;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_resubdate_negated: ' + BoolToStr(SearchObj.ResubDateNegated, True), ClassName);

        if VarIsNull(SearchObj.ResubAlarm) then
        begin
          Fqry.ParamByName('prm_resubalarm').AsWideString := '';
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_resubalarm: ', ClassName);
        end
        else
        begin
          Fqry.ParamByName('prm_resubalarm').AsWideString := SearchObj.ResubAlarm;
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_resubalarm: ' + SearchObj.ResubAlarm, ClassName);
        end;

        if VarIsNull(SearchObj.ResubAlarmHigh) then
        begin
          Fqry.ParamByName('prm_resubalarm_high').AsWideString := '';
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_resubalarm_high: ', ClassName);
        end
        else
        begin
          Fqry.ParamByName('prm_resubalarm_high').AsWideString := SearchObj.ResubAlarmHigh;
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_resubalarm_high: ' + SearchObj.ResubAlarmHigh, ClassName);
        end;

        if SearchObj.ResubAlarmNegated then
          Fqry.ParamByName('prm_resubalarm_negated').AsSmallInt := 1
        else
          Fqry.ParamByName('prm_resubalarm_negated').AsSmallInt := 0;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_resubalarm_negated: ' + BoolToStr(SearchObj.ResubAlarmNegated, True), ClassName);

        Fqry.ParamByName('prm_resubstate').AsInteger := SearchObj.ResubState;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_resubstate: ' + SearchObj.ResubState.ToString, ClassName);

        Fqry.ParamByName('prm_resubnotstate').AsInteger := SearchObj.ResubNotState;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_resubnotstate: ' + SearchObj.ResubNotState.ToString, ClassName);

        if SearchObj.ResubStateNegated then
          Fqry.ParamByName('prm_resubstate_negated').AsSmallInt := 1
        else
          Fqry.ParamByName('prm_resubstate_negated').AsSmallInt := 0;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_resubstate_negated: ' + BoolToStr(SearchObj.ResubStateNegated, True), ClassName);

        Fqry.ParamByName('prm_resubuserid').AsLargeInt := SearchObj.ResubUserID;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_resubuserid: ' + SearchObj.ResubUserID.ToString, ClassName);

        Fqry.ParamByName('prm_resubuserid_list').AsWideString := SearchObj.ResubUserIDList;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_resubuserid_list: ' + SearchObj.ResubUserIDList, ClassName);

        if SearchObj.ResubUserIDNegated then
          Fqry.ParamByName('prm_resubuserid_negated').AsSmallInt := 1
        else
          Fqry.ParamByName('prm_resubuserid_negated').AsSmallInt := 0;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_resubuserid_negated: ' + SearchObj.ResubUserIDNegated.ToString, ClassName);

        Fqry.ParamByName('prm_resubcontrollerid').AsLargeInt := SearchObj.ResubControllerID;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_resubcontrollerid: ' + SearchObj.ResubControllerID.ToString, ClassName);

        if SearchObj.ResubControllerIDNegated then
          Fqry.ParamByName('prm_resubcontrollerid_negated').AsSmallInt := 1
        else
          Fqry.ParamByName('prm_resubcontrollerid_negated').AsSmallInt := 0;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_resubcontrollerid_negated: ' + BoolToStr(SearchObj.ResubControllerIDNegated, True), ClassName);

        Fqry.Params.ParamValues['prm_docname'] := SearchObj.DocName;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_docname: ' + SearchObj.DocName, ClassName);

        if SearchObj.DocNameNegated then
          Fqry.ParamByName('prm_docname_negated').AsSmallInt := 1
        else
          Fqry.ParamByName('prm_docname_negated').AsSmallInt := 0;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_docname_negated: ' + BoolToStr(SearchObj.DocNameNegated, True), ClassName);

        if (SearchObj.GroupList.Count > 0) then
        begin
          Fqry.Params.ParamValues['prm_grouplist'] := SearchObj.GroupList.CommaText;
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_grouplist: ' + SearchObj.GroupList.CommaText, ClassName);
        end;

        Fqry.Params.ParamValues['prm_searchdatetype'] := SearchObj.SearchDateType;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_searchdatetype: ' + SearchObj.SearchDateType.ToString, ClassName);

        Fqry.Params.ParamValues['prm_filetype'] := SearchObj.FileType;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_filetype: ' + SearchObj.FileType, ClassName);

        if SearchObj.FileTypeNegated then
          Fqry.ParamByName('prm_filetype_negated').AsSmallInt := 1
        else
          Fqry.ParamByName('prm_filetype_negated').AsSmallInt := 0;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_filetype_negated: ' + BoolToStr(SearchObj.FileTypeNegated, True), ClassName);

        SearchObj.Debug := True;
        if SearchObj.Debug then
          Fqry.ParamByName('prm_debug').AsSmallInt := 1
        else
          Fqry.ParamByName('prm_debug').AsSmallInt := 0;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_debug: ' + BoolToStr(SearchObj.Debug, True), ClassName);

        if SearchObj.AboUserid > -1 then
        begin
          Fqry.ParamByName('prm_abo_userid').AsInteger := SearchObj.AboUserid;
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_abo_userid: ' + SearchObj.AboUserid.ToString, ClassName);
        end;

        if SearchObj.UseSearch35 then
          Fqry.ParamByName('prm_usesearch35').AsSmallInt := 1
        else
          Fqry.ParamByName('prm_usesearch35').AsSmallInt := 0;
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.Write(llDebug, ltInfo, 'prm_usesearch35: ' + BoolToStr(SearchObj.UseSearch35, True), ClassName);

        if (SearchObj.UserList.Count > 0) then
        begin
          Fqry.ParamByName('prm_userlist').AsString := SearchObj.UserList.CommaText;
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_userlist: ' + SearchObj.UserList.CommaText, ClassName);
        end
        else
        begin
          Fqry.ParamByName('prm_userlist').AsString := IntToStr(SearchObj.UserID);
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_userlist: ' + IntToStr(SearchObj.UserID), ClassName);
        end;

        if SearchObj.RightsMask > -1 then
        begin
          Fqry.ParamByName('prm_rightsmask').AsLargeInt := SearchObj.RightsMask;
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.Write(llDebug, ltInfo, 'prm_rightsmask: ' + SearchObj.RightsMask.ToString, ClassName);
        end;

        if SList <> nil then //21.01.2019 die mehr als 255 Charachter sein knnen sonst wird (WideMEMO) in der Trefferliste
        begin
          Fqry.DataTypeMap.Clear;
          for i := 0 to SList.Count - 1 do
            Fqry.DataTypeMap.AddFieldNameRule(slist[i], ftWideString, 1024);
        end;

        Fqry.Execute;

        Result := Fqry;

        {$IFNDEF DISABLE_HISTORY_FUTURE_DELETE}
        if (DevLog <> nil) and BD.DevDebug then
          DevLog.DebugBegin(llDebug, 'OnCheckHistoryNodes', ClassName);
        try
          if Assigned(OnCheckHistoryNodes) then
            OnCheckHistoryNodes(HistoryObj);
        finally
          if (DevLog <> nil) and BD.DevDebug then
            DevLog.DebugEnd(llDebug, 'OnCheckHistoryNodes', ClassName);
        end;
        {$ENDIF}

      end
      else begin
        Result := nil;
        ErrorStr := _('Keine Berechtigung diese Suche durchzufhren');
      end;

    except
      Result := nil;
      SearchObj.Verify := True;   // die Suche war wohl fehlerhaft und sollte geprft werden (zB lesezeichen)
      ErrorStr := _('Es hat einen Fehler bei der Suche gegeben');
    end;

  end
  else
    Result := nil;
end;

procedure TbfaSearchProcessing.AddSearchFields(SObj: TbfaSearch; ChildNode: IXMLNode);
var
  Fld: TbfaAddField;
  Sts: TbfaStateField;
  FieldsNode, FieldNode: IXMLNode;
  j, i: Integer;
begin
  try
    for j := 0 to ChildNode.ChildNodes.Count - 1 do
    begin
      FieldsNode := ChildNode.ChildNodes[j];
      if FieldsNode.NodeName = 'BitfarmAddfield' then
      begin
        Fld := XMLToAddField(FieldsNode);
        Fld.ModifiedSearch := True;
        TbfaSearch(SObj).AddFields.Add(Fld);
      end
      else if FieldsNode.NodeName = 'BitfarmStatefield' then
      begin
        Sts := XMLToStsField(FieldsNode);
        Sts.ModifiedSearch := True;
        TbfaSearch(SObj).StsFields.Add(Sts);
      end;

    end;
  except
  end;
end;

function TbfaSearchProcessing.ReadXMLFile(Path : WideString; Name: WideString = '';
  ID : Int64 = -1; UserID : Integer = -1; GroupID :  Integer = -1) : TList<TbfaSearch>;
var
  RootNode, Node : IXMLNode;
  XMLDoc : IXMLDocument;
  Attr : OleVariant;
  i : Integer;
  List : TList<TbfaSearch>;
  SObj : TbfaSearch;

    function CompareStringLists(List1, List2 : TStringList) : Boolean;
    var
      i : Integer;
      j : Integer;
      found : Boolean;
    begin
      Result := False;
      found := False;
      try
        i := 0;
        while ((not found) and (i <= List1.Count - 1))do
        begin
          j := 0;
          while ((not found) and (j <= List2.Count - 1))do
          begin
            if List1[i] = List2[j] then
              found := True;
            inc(j);
          end;
          inc(i);
        end;
        Result := found;
      except
        Result := False;
      end;
    end;

begin
  try
    if ((Path = '') or not FileExists(Path)) then
    begin
      Result := nil;
      Exit;
    end;

    XMLDoc := TXMLDocument.Create(nil);
    try
      XMLDoc.LoadFromFile(Path);

      RootNode := XMLDoc.DocumentElement; // ChildNodes.FindNode('Lesezeichen');

      if RootNode <> nil then
      begin
        List := TList<TbfaSearch>.Create;
        for i := 0 to RootNode.ChildNodes.Count - 1 do
        begin
          Node := RootNode.ChildNodes[i];

          if ((Name <> '') or (ID > -1)) then
          begin
            if (ID > -1) then
            begin
              Attr := Node.Attributes['id'];
              if (VarIsNull(Attr) or (Attr <> ID)) then
                Continue;
            end;
            if (Name <> '') then
            begin
              Attr := Node.Attributes['name_fav'];
              if (VarIsNull(Attr) or (Attr <> Name)) then
                Continue;
            end;
          end;

          SObj := FillSearchWithNode(Node);

          if SObj = nil then
            Continue;

          if SObj.searchtype = -1 then
          begin
            if Pos('Lokale', RootNode.Attributes['name']) > 0 then
              SObj.SearchType := 1
            else if Pos('Globale', RootNode.Attributes['name']) > 0 then
              SObj.SearchType := 2
            else if Pos('Verlaufs-', RootNode.Attributes['name']) > 0 then
              SObj.SearchType := 3;
          end;

          // userids haben Vorrang vor groupids
          if UserID > -1 then
          begin
            if UserID <> SObj.UserID then
              Continue;
          end;

          if GroupID > -1 then
          begin
            if GroupID <> SObj.GroupID then
              Continue;
          end;

          List.Add(SObj);

        end;

        Result := List;

      end
      else
        Result := nil;

    finally
      XMLDoc := nil;
    end;

  except
    result := nil;
  end;
end;


function TbfaSearchProcessing.FillSearchWithNode(Fav : IXMLNode) : TbfaSearch;
var
  SObj : TbfaSearch;
begin
  try
    SObj := TbfaSearch.Create;

    Result := FillSearchObjectWithNode(SObj, Fav);

  except
    Result := nil;
  end;
end;

function TbfaSearchProcessing.FillSearchObjectWithNode(SObj : TbfaSearch; Fav : IXMLNode) : TbfaSearch;
var
  Attr : OleVariant;
  i, j : Integer;
//  Tmp : TStringList;
//  qry : TUniQuery;
  ChildNode : IXMLNode;
begin
  try
    if Fav = nil then
    begin
      Result := nil;
      Exit;
    end;
//    Tmp := TStringList.Create;

    Attr := Fav.Attributes['name_fav'];
    if not VarIsNULL(Attr) then
      SObj.Name := Attr;
    Attr := Fav.Attributes['id'];
    if not VarIsNULL(Attr) then
      SObj.ID := Attr;
    Attr := Fav.Attributes['Suchdatum'];
    if not VarIsNULL(Attr) then
      SObj.Date := Attr;
    if VarIsNull(SObj.Date) then
    begin
      Attr := Fav.Attributes['date'];
      if not VarIsNULL(Attr) then
        SObj.Date := Attr;
    end;
    Attr := Fav.Attributes['userid'];
    if not VarIsNULL(Attr) then
      SObj.UserID := Attr;
    Attr := Fav.Attributes['groupid'];
    if not VarIsNULL(Attr) then
      SObj.GroupID := Attr;

 //   qry := TUniQuery.Create(nil);
    try
//      Attr := Fav.Attributes['urights'];
//      SObj.URights := Attr;
//      if not VarIsNull(Attr) then
//        SObj.UserID.CommaText := Attr;
      (*
      if not VarIsNULL(Attr) then
      begin
        SObj.URights := Attr;
        SObj.UserID.CommaText := '';
        Tmp.Clear;
        Tmp.CommaText := Attr;
        for i := 0 to Tmp.Count - 1 do
        begin
          qry.SQL.Text := 'CALL sp_select_userid_by_name(:prm_version, :prm_username)';
          if ((Version = 35) or (Version = 36)) then
            qry.Params.ParamByName('prm_version').AsLargeInt := sSysVersion36
          else if (Version = 40) then
            qry.Params.ParamByName('prm_version').AsLargeInt := sSysVersion40;
          qry.Params.ParamByName('prm_username').AsWideString := Tmp.Strings[i];
          qry.Execute;
          if qry.RecordCount > 0 then
          begin
            if ((Version = 35) or (Version = 36)) then
              SObj.UserID.Add(qry.FieldByName('USR_ID').AsString)
            else if (Version = 40) then
              SObj.UserID.Add(qry.FieldByName('userid').AsString);
          end;

        end;
      end;
      *)

//      Attr := Fav.Attributes['grights'];
//      SObj.GRights := Attr;
//      if not VarIsNull(Attr) then
//        SObj.GroupID.CommaText := '';
      (*
      if not VarIsNULL(Attr) then
      begin
        SObj.GRights := Attr;
        SObj.GroupID.CommaText := '';
        Tmp.Clear;
        Tmp.CommaText := Attr;
        for i := 0 to Tmp.Count - 1 do
        begin
          qry.SQL.Text := 'CALL sp_select_groupid_by_name(:prm_version, :prm_groupname)';
          if ((Version = 35) or (Version = 36)) then
            qry.Params.ParamByName('prm_version').AsLargeInt := sSysVersion36
          else if (Version = 40) then
            qry.Params.ParamByName('prm_version').AsLargeInt := sSysVersion40;
          qry.Params.ParamByName('prm_groupname').AsWideString := Tmp.Strings[i];
          qry.Execute;
          if qry.RecordCount > 0 then
          begin
            if ((Version = 35) or (Version = 36)) then
              SObj.GroupID.Add(qry.FieldByName('GRP_ID').AsString)
            else if (Version = 40) then
              SObj.GroupID.Add(qry.FieldByName('grpid').AsString);
          end;
        end;
      end;
      *)

      for i := 0 to Fav.ChildNodes.Count - 1 do
      begin
        ChildNode := Fav.ChildNodes[i];
        if ChildNode.NodeName = 'arcid' then
        begin
          SObj.ArcID.CommaText := ChildNode.NodeValue;
        end
        else if ChildNode.NodeName = 'gdocid' then
        begin
          SObj.GdocID.CommaText := ChildNode.NodeValue;
        end
        else if ChildNode.NodeName = 'searchtype' then
        begin
          SObj.SearchType := StrToInt(ChildNode.NodeValue);
        end
        else if ChildNode.NodeName = 'Gbadvusrsrc' then
        begin
          SObj.SQLWhereOnly := ChildNode.NodeValue = '-1';
        end
        else if ChildNode.NodeName = 'sqlwhereonly' then
        begin
          SObj.SQLWhereOnly := ChildNode.NodeValue = 'true';
        end
        else if ChildNode.NodeName = 'sqlwhere' then
        begin
          SObj.SQLWhere := ChildNode.NodeValue;
        end
        else if ChildNode.NodeName = 'maxvalues' then
        begin
          if ((ChildNode.NodeValue <> 'alle') and (ChildNode.NodeValue <> 'all')) then
            SObj.MaxValues := ChildNode.NodeValue
          else
            SObj.MaxValues := 0;
        end
        else if ((ChildNode.NodeName = 'iStat') or (ChildNode.NodeName = 'state')) then
        begin
          SObj.State := ChildNode.NodeValue;
        end
        else if ((ChildNode.NodeName = 'niStat') or (ChildNode.NodeName = 'notstate')) then
        begin
          SObj.NotState := ChildNode.NodeValue;
        end
        else if ((ChildNode.NodeName = 'notslw') or (ChildNode.NodeName = 'ftx_negated')) then
        begin
          SObj.SearchStringNegated := ChildNode.NodeValue;
        end
        else if ChildNode.NodeName = 'iCheckout' then
        begin
          SObj.CheckOut := StrToInt(ChildNode.NodeValue);
        end
        else if ChildNode.NodeName = 'checkout' then
        begin
          SObj.CheckOut := StrToInt(ChildNode.NodeValue);
        end
        else if ChildNode.NodeName = 'inresub' then
        begin
          SObj.InResub := ChildNode.NodeValue = 'true';
        end
        else if ChildNode.NodeName = 'inresub_negated' then
        begin
          SObj.InResubNegated := ChildNode.NodeValue = 'true';
        end
        else if ChildNode.NodeName = 'count' then
        begin
          SObj.Count := ChildNode.NodeValue;
        end
        else if ((ChildNode.NodeName = 'vtx') or (ChildNode.NodeName = 'ftx') or (ChildNode.NodeName = 'slw')) then
        begin
          if ((ChildNode.NodeName = 'vtx') or (ChildNode.NodeName = 'ftx')) then
            SObj.FtxFields := SObj.FtxFields or 1
          else
            SObj.FtxFields := SObj.FtxFields or 2;

          if SObj.SearchString = '' then
            SObj.SearchString := ChildNode.NodeValue
          else
            SObj.SearchString := SObj.SearchString + ' ' + ChildNode.NodeValue;
        end
        else if (ChildNode.NodeName = 'ftx_fields') then
        begin
          SObj.FtxFields := ChildNode.NodeValue;
        end
        else if (ChildNode.NodeName = 'sqlwhere_operator') then
        begin
          SObj.SQLWhereOperator := ChildNode.NodeValue;
        end
        else if ChildNode.NodeName = 'ftx_matchagainst' then
        begin
          SObj.FtxMatchAgainst := ChildNode.NodeValue = 'true';
        end
        else if ChildNode.NodeName = 'ftx_booleanmode' then
        begin
          SObj.FtxBooleanMode := ChildNode.NodeValue = 'true';
        end
        else if ChildNode.NodeName = 'ftx_naturalmode' then
        begin
          SObj.FtxNaturalMode := ChildNode.NodeValue = 'true';
        end
        else if ChildNode.NodeName = 'ftx_withqueryexpansion' then
        begin
          SObj.FtxWithQueryExpansion := ChildNode.NodeValue = 'true';
        end
        else if ChildNode.NodeName = 'refsearch' then
        begin
          SObj.RefSearch := ChildNode.NodeValue;
        end
        else if ChildNode.NodeName = 'timref' then
        begin
          SObj.TimRef.CommaText := ChildNode.NodeValue;
        end
        else if (ChildNode.NodeName = 'searchuserid') then
        begin
          SObj.SearchUserID := StrToInt(ChildNode.NodeValue);
        end
        else if ((ChildNode.NodeName = 'Benutzer') or (ChildNode.NodeName = 'searchuser')) then
        begin
          SObj.SearchUser := ChildNode.NodeValue;
        end
        else if (ChildNode.NodeName = 'notBenutzer') then
        begin
          SObj.SearchUser := ChildNode.NodeValue;
          SObj.SearchUserNegated := True;
        end
        else if (ChildNode.NodeName = 'searchuser_negated') then
        begin
          SObj.SearchUserNegated := ChildNode.NodeValue = 'true';
        end
        else if (ChildNode.NodeName = 'searchgroupid') then
        begin
          SObj.SearchGroupID := StrToInt(ChildNode.NodeValue);
        end
        else if (ChildNode.NodeName = 'searchgroup') then
        begin
          SObj.SearchGroup := ChildNode.NodeValue;
        end
        else if (ChildNode.NodeName = 'searchgroup_negated') then
        begin
          SObj.SearchGroupNegated := ChildNode.NodeValue = 'true';
        end
        else if (ChildNode.NodeName = 'constructive') then
        begin
          SObj.Constructive := ChildNode.NodeValue = 'true';
        end
        else if (ChildNode.NodeName = 'selected_cols') then
        begin
          SObj.SelectedCols := ChildNode.NodeValue;
        end
        else if (ChildNode.NodeName = 'datevom') then
        begin
          SObj.SearchDate := FloatToStr(ChildNode.NodeValue);
        end
        else if (ChildNode.NodeName = 'datebis') then
        begin
          SObj.SearchDateHigh := FloatToStr(ChildNode.NodeValue);
        end
        else if (ChildNode.NodeName = 'notdatevom') then
        begin
          SObj.SearchDate := FloatToStr(ChildNode.NodeValue);
          Sobj.SearchDateNegated := True;
        end
        else if (ChildNode.NodeName = 'searchdate') then
        begin
          try
            SObj.SearchDate := FormatDateTime('yyyy-mm-dd  hh:nn:ss', StrToDate(ChildNode.NodeValue));
          except
            SObj.SearchDate := NULL;
          end;
        end
        else if (ChildNode.NodeName = 'searchdatehigh') then
        begin
          try
            SObj.SearchDateHigh := FormatDateTime('yyyy-mm-dd  hh:nn:ss', StrToDate(ChildNode.NodeValue));
          except
            SObj.SearchDateHigh := NULL;
          end;
        end
        else if (ChildNode.NodeName = 'searchdate_negated') then
        begin
          SObj.SearchDateNegated := ChildNode.NodeValue = 'true';
        end
        else if ChildNode.NodeName = 'searchdatetype' then
        begin
          SObj.SearchDateType := StrToInt(ChildNode.NodeValue);
        end
        else if ChildNode.NodeName = 'groupby' then
          SObj.GroupBy := ChildNode.NodeValue
        else if (ChildNode.NodeName = 'direction') then
        begin
          SObj.Direction := ChildNode.NodeValue;
        end
        else if (ChildNode.NodeName = 'order') then
        begin
          SObj.Order := ChildNode.NodeValue;
        end
        else if (ChildNode.NodeName = 'docname') then
        begin
          SObj.DocName := ChildNode.NodeValue;
        end
        else if (ChildNode.NodeName = 'docname_negated') then
        begin
          SObj.DocNameNegated := ChildNode.NodeValue = 'true';
        end
        else if ChildNode.NodeName = 'grouplist' then
        begin
          SObj.GroupList.CommaText := ChildNode.NodeValue;
        end
        else if (ChildNode.NodeName = 'resubalarm') then
        begin
          try
            SObj.ResubAlarm := FormatDateTime('yyyy-mm-dd  hh:nn:ss', StrToDate(ChildNode.NodeValue));
          except
            SObj.ResubAlarm := NULL;
          end;
        end
        else if (ChildNode.NodeName = 'resubalarmhigh') then
        begin
          try
            SObj.ResubAlarmHigh := FormatDateTime('yyyy-mm-dd  hh:nn:ss', StrToDate(ChildNode.NodeValue));
          except
            SObj.ResubAlarmHigh := NULL;
          end;
        end
        else if (ChildNode.NodeName = 'resubalarm_negated') then
        begin
          SObj.ResubAlarmNegated := ChildNode.NodeValue = 'true';
        end
        else if (ChildNode.NodeName = 'resubdate') then
        begin
          try
            SObj.ResubDate := FormatDateTime('yyyy-mm-dd  hh:nn:ss', StrToDate(ChildNode.NodeValue));
          except
            SObj.ResubDate := NULL;
          end;
        end
        else if (ChildNode.NodeName = 'resubdatehigh') then
        begin
          try
            SObj.ResubDateHigh := FormatDateTime('yyyy-mm-dd  hh:nn:ss', StrToDate(ChildNode.NodeValue));
          except
            SObj.ResubDateHigh := NULL;
          end;
        end
        else if (ChildNode.NodeName = 'resubdate_negated') then
        begin
          SObj.ResubDateNegated := ChildNode.NodeValue = 'true';
        end
        else if (ChildNode.NodeName = 'resubcontrollerid') then
        begin
          SObj.ResubControllerID := StrToInt(ChildNode.NodeValue);
        end
        else if (ChildNode.NodeName = 'resubcontrollerid_negated') then
        begin
          SObj.ResubControllerIDNegated := ChildNode.NodeValue = 'true';
        end
        else if (ChildNode.NodeName = 'resubuserid') then
        begin
          SObj.ResubUserID := StrToInt(ChildNode.NodeValue);
        end
        else if (ChildNode.NodeName = 'resubuserid_negated') then
        begin
          SObj.ResubUserIDNegated := ChildNode.NodeValue = 'true';
        end
        else if (ChildNode.NodeName = 'resubstate') then
        begin
          SObj.ResubState := StrToInt(ChildNode.NodeValue);
        end
        else if (ChildNode.NodeName = 'resulttype') then
        begin
          SObj.ResultType := ChildNode.NodeValue;
        end
        else if ((ChildNode.NodeName = 'zusatzname') or (ChildNode.NodeName = 'searchfields')) then
        begin
          AddSearchFields(SObj, ChildNode);
        end;
      end;

      Result := SObj;
    finally
    //  FreeAndNil(qry);
    //  FreeAndNil(Tmp);
    end;
  except
    Result := nil;
  end;
end;


{ TbfaNodeInfo }

constructor TbfaNodeInfo.Create;
begin
  Typ := -1; // details in declaration
  Userid := 0;
  Groupid := 0;
  GUID := '';
end;

constructor TbfaNodeInfo.Create(AGUID: string);
begin
  inherited Create;

  GUID := AGUID;
end;

constructor TbfaNodeInfo.Create(AType: Integer; AGUID: string);
begin
  inherited Create;

  Typ := AType; // details in declaration
  GUID := AGUID;
end;

{ TbfaFtxPos }

constructor TbfaFtxPos.Create;
begin
  inherited Create;
  Word := '';
  Color := gclRed;
  WordList := Tlist<TbfaWordPos>.Create;
end;

destructor TbfaFtxPos.Destroy;
var
  i : Integer;
begin
  for i := WordList.Count - 1 downto 0 do
  begin
    WordList[i].Free;
    WordList[i] := nil;
    WordList.Delete(i);
  end;
  FreeAndNil(WordList);

  inherited Destroy;
end;

{ TbfaWordPos }

constructor TbfaWordPos.Create;
begin
  inherited Create;
  Page := 0;
  SetLength(Coordinates, 0);
end;

destructor TbfaWordPos.Destroy;
begin
  Page := 0;
  SetLength(Coordinates, 0);
  inherited Destroy;
end;

{ TbfaSvnField }

procedure TbfaSvnField.Clone(Source: TbfaSvnField);
begin
  inherited Clone(Source);
  Gdocid := Source.Gdocid;
  ID := Source.ID;
  Version := Source.Version;
  Revision := Source.Revision;
  Userid := Source.Userid;
  Info := Source.Info;
  Date := Source.Date;
end;

constructor TbfaSvnField.Create;
begin
  Gdocid := -1;
  ID := -1;
  Version := -1;
  Revision := -1;
  Userid := -1;
  Info := '';

end;

{ TbfaWorkflow }

procedure TbfaWorkflow.Clone(Source: TbfaWorkflow);
begin
  inherited Clone(Source);
  TimID := Source.TimID;
  TimRef := Source.TimRef;
  Gdocid  := Source.Gdocid;
  Profile := Source.Profile;
  UseridWork := Source.UseridWork;
  UseridShed := Source.UseridShed;
  GroupID := Source.GroupID;
  Users := Source.Users;
  Groups := Source.Groups;
  Status := Source.Status;
  Options := Source.Options;
  Info := Source.Info;
  Comment := Source.Comment;
  Required := Source.Required;
  WfID := Source.WfID;
  HistID := Source.HistID;
  Date := Source.Date;
  AlarmDate := Source.AlarmDate;
//  Modified := Source.Modified;
  ModifiedDate := Source.ModifiedDate;
end;

constructor TbfaWorkflow.Create;
begin
  inherited;
  TimID := -1;
  TimRef := -1;
  Gdocid  := -1;
  UseridWork := -1;
  UseridShed := -1;
  GroupID := 0;
  Profile := '';
  Users := '';
  Groups := '';
  Status := 0;
  Options := 0;
  Info := '';
  Comment := '';
  Required := 0;
  WfID:= -1;
  HistID := -1;
  Modified := False;
end;

{ TbfaArchive }

procedure TbfaArchive.Clone(Source: TbfaArchive);
begin
  inherited Clone(Source);
  Tblname := Source.Tblname;
  Lgrid := Source.Lgrid;
  Typ := Source.Typ;
  Flags := Source.Flags;
  Backpic := Source.Backpic;
  Options := Source.Options;
  DefDocname := Source.DefDocname;
  Storageid := Source.Storageid;
  Rights := Source.Rights;
  Users.Assign(Source.Users);
  Groups.Assign(Source.Groups);
  Addfields.Assign(Source.Addfields);
  Statefields.Assign(Source.Statefields);
  Duration := Source.Duration;
  Interval := Source.Interval;
end;

constructor TbfaArchive.Create;
begin
  inherited Create;
//  Name := '';
  Tblname := '';
//  Arcid := -1;
  Lgrid := -1;
  Typ := 0;
  Flags := 0;
  Backpic := '';
  Options := 0;
  DefDocname := '';
  Storageid := 0;
  Rights := 0;
  Users:= TStringList.Create;
  Groups:= TStringList.Create;
  Addfields:= TStringList.Create;
  Statefields:= TStringList.Create;
  Duration := 0;
  Interval := '';
end;

destructor TbfaArchive.Destroy;
var
  i: Integer;
begin
  Users.Clear;
  FreeAndNil(Users);
  Groups.Clear;
  FreeAndNil(Groups);


//  for i := Addfields.Count -1 downto 0  do
      Addfields.Clear;

  FreeAndNil(Addfields);

//  for i := 0  to Statefields.Count -1 do
//    Statefields.Objects[i].Free;
      Statefields.Clear;

  FreeAndNil(Statefields);

  inherited;
end;

function IndexOfTbfaInt(list : TStrings; value : Integer): Integer; overload;
var
  idx : Integer;
begin
  Result := -1;
  for idx := 0  to list.Count -1 do
  begin
    if (list.Objects[idx] is TbfaInt) then
      if TbfaInt(list.Objects[idx]).Value = value then
      begin
        Result := idx;
        Break;
      end;
  end;
end;

//function IndexOfTbfaInt(list : TStringList; value : Integer): Integer; overload;
//var
//  idx : Integer;
//begin
//  Result := -1;
//  for idx := 0  to list.Count -1 do
//  begin
//    if (list.Objects[idx] is TbfaInt) then
//      if TbfaInt(list.Objects[idx]).Value = value then
//      begin
//        Result := idx;
//        Break;
//      end;
//  end;
//end;

function IndexOfTbfaInt(list : TStrings; value : Int64): Integer; overload;
var
  idx : Integer;
begin
  Result := -1;
  for idx := 0  to list.Count -1 do
  begin
    if (list.Objects[idx] is TbfaInt64) then
      if TbfaInt64(list.Objects[idx]).Value = value then
      begin
        Result := idx;
        Break;
      end;
  end;
end;
//
//{ TbfaFieldRight }
//
//procedure TbfaFieldRight.Clone(Source: TbfaFieldRight);
//begin
//    ArcID := Source.Arcid;
//    FieldID := Source.FieldID;
//    Userid := Source.Userid;
//    Groupid := Source.Groupid;
//    Rights := Source.Rights;
//    Fieldpos := Source.Fieldpos;
//    Modified := Source.Modified;
//    Deleted := Source.Deleted;
//end;
//
//constructor TbfaFieldRight.Create;
//begin
//    Arcid := -1;
//    FieldID := -1;
//    Userid := -1;
//    Groupid := -1;
//    Rights := -1;
//    Fieldpos := -1;
//    Modified := False;
//    Deleted := False;
//
//end;

{ TbfaArcRight }

procedure TbfaArcRight.Clone(Source: TbfaArcRight);
begin
  ArcID := Source.ArcID;
  ArcTempID := Source.ArcTempID;
  Userid := Source.Userid;
  Groupid := Source.Groupid;
  Rights := Source.Rights;
  Modified := Source.Modified;
  Deleted := Source.Deleted;
end;

constructor TbfaArcRight.Create;
begin
  ArcID := -1;
  ArcTempID := TGUID.Empty;
  Userid := -1;
  Groupid := -1;
  Rights := -1;
  Modified := False;
  Deleted := False;
end;

{ TBfaADObject }

procedure TBfaADObject.Clone(Source: TbfaADObject);
begin
  Name := Source.Name;
  Typ := Source.Typ;
  Ldap := Source.Ldap;
  Modified := Source.Modified;
  DisplayName := Source.DisplayName;
  Flags := Source.Flags;
end;

constructor TBfaADObject.Create;
begin
  Name := '';
  Typ := '';
  Ldap := '';
  Modified := False;
  DisplayName := '';
  Flags := 0;
  Highlight := False;
end;

{ TbfaBracket }

procedure TbfaBracket.Clone(Source: TbfaBracket);
begin
  Fkind := Source.Kind;
end;

constructor TbfaBracket.Create;
begin
  Fkind := brOpen;
end;

procedure TbfaBracket.SetBracketKind(const Value: TbfaBracketKind);
begin
  FKind := Value;
  if FKind = brOpen then
    display := '('
  else
    display := ')';
end;

{ TbfaJunktion }

procedure TbfaJunction.Clone(Source: TbfaJunction);
begin
  Fkind := Source.Kind;
end;

constructor TbfaJunction.Create;
begin
  Fkind := jnEmpty;
end;

procedure TbfaJunction.SetJunctionKind(const Value: TbfaJunctionKind);
begin
  FKind := Value;
  if FKind = jnAND then
    display := 'AND';

  if FKind = jnOR then
    display := 'OR';

  if FKind = jnNOT then
    display := 'NOT';

  if FKind = jnEmpty then
    display := '';

  if Assigned(OnChange) then
    OnChange();

end;

{ TbfaExpression }

procedure TbfaExpression.Clone(Source: TbfaExpression);
begin
  oplist.CommaText := Source.oplist.CommaText;
  FValue := Source.Fvalue;
  FFieldtype := Source.Fieldtype;
  Ffield := Source.Field;
  Ffieldname := Source.Fieldname;
  FID := Source.ID;
  op := Source.op;
  junction.Kind := Source.junction.Kind;
  junction.OnChange := Self.SetDisplay;
  SetDisplay;
end;

constructor TbfaExpression.Create;
begin
  oplist := TStringList.Create;
  oplist.StrictDelimiter := True;
  oplist.CommaText := '=,<>,>,<,>=,<=,like,rlike,is,between';
  op := '=';
  ID := -1;
  junction := TbfaJunction.Create;
  junction.OnChange := Self.SetDisplay;
  FDateFormat := dtfNone;
end;

destructor TbfaExpression.Destroy;
begin
  inherited;
  oplist.Clear;
  FreeAndNil(oplist);
end;

procedure TbfaExpression.SetDateFormat(const Value: eDateFormat);
begin
  FDateFormat := Value;
  SetDisplay;
end;

procedure TbfaExpression.SetDisplay;
var
  junc: string;
  dispname: WideString;
begin
  if junction.Kind = jnNOT then
    junc := 'NOT'
  else
    junc := '';
  if Ffieldname <> '' then
    dispname := Ffieldname
  else
    dispname := Ffield;

  if FDateFormat = dtfDay then
    dispname := 'day(' + dispname + ')'
  else if FDateFormat = dtfWeek then
    dispname := 'week(' + dispname + ')'
  else if FDateFormat = dtfMonth then
    dispname := 'month(' + dispname + ')'
  else  if FDateFormat = dtfYear then
    dispname := 'year(' + dispname + ')'
  else  if FDateFormat = dtfDate then
    dispname := 'date(' + dispname + ')';

  FDisplay := junc + ' ' + dispname + ' ' + op + ' ' + Fvalue;
  FDisplay := Trim(FDisplay);
end;

procedure TbfaExpression.SetField(const Value: string);
begin
  FField := Value;
  SetDisplay;
end;

procedure TbfaExpression.SetFieldname(const Value: WideString);
begin
  Ffieldname := Value;
  SetDisplay;
end;

procedure TbfaExpression.SetFieldtype(const Value: eAddFieldType);
begin
  FFieldtype := Value;
  if Fieldtype in [zfld00_Universal,zfld02_Auswahl, zfld03_MehrfachAuswahl, zfld05_Intervall, zfld09_Status, zfld11_DLM, zfld13_Grid, zfld14_GridColumn] then
//11.10.2017 Ticket 12163    oplist.CommaText := '=,<>,like,is';
    oplist.CommaText := '=,<>,like,rlike,is,between';
  if Fieldtype in [zfld01_Datum, zfld06_GanzZahl, zfld07_FliessKomma, zfld08_Waehrung, zfld12_DLMDate] then
    oplist.CommaText := '=,<>,>,<,>=,<=,is,between';
  if Fieldtype in [zfld10_Document] then
    oplist.CommaText := '=,<>,>,<,>=,<=,like,rlike,is,between';
  if oplist.IndexOf(op) = -1 then
    op := '=';
  SetDisplay;
end;

procedure TbfaExpression.SetValue(const Value: WideString);
begin
  FValue := Value;
  SetDisplay;
end;

procedure TbfaExpression.Update;
begin
  SetDisplay;
end;

{ TbfaDLM }

procedure TbfaDLM.Clone(Source: TbfaDLM);
begin
  inherited Clone(Source);
  Typ := Source.Typ;
  Fieldid := Source.Fieldid;
  Item := Source.Item;
  Duration := Source.Duration;
  Interval := Source.Interval;
  Date := Source.Date;
  Prio := Source.Prio;
  Mode := Source.Mode;
  Items.DelimitedText := Source.Items.DelimitedText;
  CurrentItem := Source.CurrentItem;
end;

constructor TbfaDLM.Create;
begin
  inherited Create;

  ID := -1;
  Typ := -1;
  Fieldid := -1;
  Item := '';
  Items := TStringList.Create;
  Items.Delimiter := ';';
  Items.StrictDelimiter := True;
  Duration := -1;
  Interval := '';
  Prio := -1;
  Mode := -1;
  CurrentItem := False;
  Date := cUnassignedDate;
end;

//constructor TBfData.Create;
//var
//  lsappdata, lsuser, lsdomain : string;
//begin
/////19.10.2017 gendert wegen ArchivDrucker fehler wo in System Context gelaufen war -->
//   lsappdata:= GetSystemVariable('APPDATA');
//   lsuser:= WUserName;
//   if (Pos('system32',lsappdata) > 0) And (lsuser <> '') then
//   begin
////     lsdomain:= GetSystemVariable('USERDOMAIN');
////     ShowMessage('USERDOMAIN: ' + lsdomain);
////     if lsdomain <> '' then
////       lsuser := lsuser + '.' + lsdomain;
//     EnvTemp        := 'c:\users\' + lsuser + '\AppData\Local\Temp';
//     EnvSystemRoot  := GetSystemVariable('systemroot');
//     EnvAppdata     := 'c:\users\' + lsuser + '\AppData\Roaming\';
//     EnvUsername    := lsuser;
//     EnvProgramData := GetSystemVariable('ProgramData');
//   end
//   else
//   begin
//     EnvTemp        := GetSystemVariable('TEMP');
//     EnvSystemRoot  := GetSystemVariable('systemroot');
//     EnvAppdata     := GetSystemVariable('appdata');
//     EnvUsername    := GetSystemVariable('username');
//     EnvProgramData := GetSystemVariable('ProgramData');
//   end;
//   EnvTempPd      := IncludeTrailingPathDelimiter(EnvTemp);
//   EnvSystemRootPd:= IncludeTrailingPathDelimiter(EnvSystemRoot);
//   EnvAppdataPd   := IncludeTrailingPathDelimiter(EnvAppdata);
//   EnvProgramDataPd := IncludeTrailingPathDelimiter(EnvProgramData);
//   EnvAppdataImporter := EnvAppdataPd + 'bitfarm-archiv\Importer';
//   EnvAppdataImporterPd := IncludeTrailingPathDelimiter(EnvAppdataImporter);
//   EnvAppdataWorkplace := EnvAppdataPd + 'bitfarm-archiv\Workplace';
//   EnvAppdataWorkplacePd := IncludeTrailingPathDelimiter(EnvAppdataWorkplace);
//
/////19.10.2017 gendert wegen ArchivDrucker fehler wo in System Context gelaufen war <--
//
//
//   AppdataBitfarm := EnvAppdata + '\bitfarm-archiv';
//   AppdataBitfarmPd := IncludeTrailingPathDelimiter(AppdataBitfarm);
//   ProgramDataBitfarm := EnvProgramData + '\bitfarm-archiv';
//   ProgramDataBitfarmPd := IncludeTrailingPathDelimiter(ProgramDataBitfarm);
//
//   MyLoginIniName := AppdataBitfarm + '\mylogin.ini';
//   ExeFile := ParamStr(0);
//   ExeDir := ExtractFilePath(ExeFile); // mit Delimiter hinten
//
//   LogPath := EnvTemp; // vorbelegen
//   LogName := ChangeFileExt(ExtractFileName(ExeFile), '.log');
//
//   SetDuplex := False;
//end;


//initialization
//   BD := TBfData.Create;
//
//finalization
//   FreeAndNil(BD);

constructor TbfaAnnotation.Create;
begin
  inherited Create;
  FAnnoStream := TMemoryStream.Create;
  FPage := 0;
  FPriv := False;
  FLayer := 0;
  SetLength(ObjList, 0);
  FHistory := TList<TbfaHistory>.Create;
  Deleted := False;
end;

procedure TbfaAnnotation.ClearHistoryList;
var
  i: Integer;
begin
  try
    for i := FHistory.Count - 1 downto 0 do
    begin
      FHistory[i].Free;
      FHistory[i] := nil;
    end;
    FHistory.Clear;
  except

  end;
end;

procedure TbfaAnnotation.Clone(Source: TbfaAnnotation);
var
  i: Integer;
  hst: TbfaHistory;
begin
  try
    FPage := Source.Page;
    FPriv := Source.Priv;
    FLayer := Source.Layer;
    FRights := Source.Rights;
    FModified := Source.Modified;
    FAnnoStream.Position := 0;
    Source.AnnoStream.Position := 0;
    FAnnoStream.CopyFrom(Source.AnnoStream, Source.AnnoStream.Size);
    FAnnoStream.Position := 0;
    SetLength(ObjList, Length(Source.ObjList));
    for i := Low(Source.ObjList) to High(Source.ObjList) do
      ObjList[i] := Source.ObjList[i];
    ClearHistoryList;
    for i := 0 to Source.History.Count - 1 do
    begin
      hst := TbfaHistory.Create;
      hst.Clone(Source.History[i]);
      FHistory.Add(hst);
    end;
  except

  end;
end;

destructor TbfaAnnotation.Destroy;
begin
  FreeAndNil(FAnnoStream);

  SetLength(ObjList, 0);

  inherited Destroy;
end;

function TbfaAnnotation.GetDeleted: Boolean;
begin
  // aktuell nur als Haltepunkt da...
  Result := FDeleted;
end;

procedure TbfaAnnotation.SetDeleted(Value: Boolean);
begin
  // aktuell nur als Haltepunkt da...
  FDeleted := Value;
end;


procedure TbfaStationery.Clone(Source: TbfaStationery);
begin
  FPages := Source.Pages;

  if Length(Source.Layers) > 0 then
    Layers[0] := Source.Layers[0];
  if Length(Source.Layers) > 1 then
    Layers[1] := Source.Layers[1];
  if Length(Source.Layers) > 2 then
    Layers[2] := Source.Layers[2];
  SetLength(Layers, length(Source.Layers));
  FStationeryStream.Clear;
  Source.FStationeryStream.Position := 0;
  FStationeryStream.CopyFrom(Source.FStationeryStream, Source.FStationeryStream.Size);

end;

constructor TbfaStationery.Create;
begin
  FStationeryStream := TMemoryStream.Create;
  FPages := -1;
  SetLength(Layers, 3);
  Layers[0] := 0;
  Layers[1] := 0;
  Layers[2] := 0;
end;

destructor TbfaStationery.Destroy;
begin
  FStationeryStream.Clear;
  FreeAndNil(FStationeryStream);

  SetLength(Layers, 0);
  Layers := nil;

  inherited Destroy;
end;

procedure TbfaStationery.Load(var img: TbfaImageEnVect;
  DocPageCount: Integer; FilePath: WideString = ''; Str: TMemoryStream = nil);

var
  Lyr: Integer;

  procedure SetLayer;
  begin
    img.Layers[lyr].PosX := 0;
    img.Layers[lyr].Posy := 0;
    img.Layers[lyr].Width := img.Layers[0].Bitmap.Width;
    img.Layers[lyr].Height := img.Layers[0].Bitmap.Height;
    img.Layers[lyr].Operation := ielAND;
  end;

begin
  try
    FStationeryStream.Clear;
    if (FilePath <> '') then
      FStationeryStream.LoadFromFile(FilePath)
    else if (Str <> nil) then
    begin
      Str.Position := 0;
      FStationeryStream.CopyFrom(Str, Str.Size);
    end;
    FStationeryStream.Position := 0;

    if ((img <> nil) and (FStationeryStream.Size > 0)) then
    begin

      img.CancelInteracts;

      Lyr := img.LayersAdd;
      img.IO.Params.TIFF_ImageIndex := 0;
      img.LayersCurrent := Lyr;
      FStationeryStream.Position := 0;
      img.IO.LoadFromStream(FStationeryStream);

      SetLength(Layers, img.IO.Params.ImageCount);
      Layers[0] := Lyr;

      FPages := img.IO.Params.ImageCount;

      SetLayer;

      if DocPageCount > 1 then
      begin
        if (FPages > 1) then
        begin
          Lyr := img.LayersAdd;
          img.IO.Params.TIFF_ImageIndex := 1;
          FStationeryStream.Position := 0;
          img.IO.LoadFromStream(FStationeryStream);

          Layers[1] := Lyr;

          img.Layers[lyr].Visible := False;
          SetLayer;

          if (FPages > 2) then
          begin
            Lyr := img.LayersAdd;
            img.IO.Params.TIFF_ImageIndex := 2;
            FStationeryStream.Position := 0;
            img.IO.LoadFromStream(FStationeryStream);

            Layers[2] := Lyr;

            img.Layers[lyr].Visible := False;
            SetLayer;
          end;
        end;
      end;
      img.Update;
      img.LayersCurrent := 0;
    end;
  except

  end;
end;






{ TbfaADEntry }

procedure TbfaADEntry.Clone(Source: TbfaADEntry);
begin
  Self.ADClass := Source.ADClass;
  Self.ADPath := Source.ADPath;
  Self.DisplayName := Source.DisplayName;
  Self.SamAccountname := Source.SamAccountname;
  Self.Mail := Source.Mail;
  Self.UserAccountControl := Source.UserAccountControl;
  Self.HasUser := Source.HasUser;
end;

constructor TbfaADEntry.Create;
begin
  inherited;

end;

end.




