unit bfaSP;

interface

uses 
  uni;

type
  TbfaSP = class(TObject)
  protected                    
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FErrorCode: Integer;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FStoredProcedure: TUniStoredProc;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FDataSource: TUniDataSource;

  public
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    constructor Create(Connection: TUniConnection; SPName: WideString); overload;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    destructor Destroy; override;
    procedure Open;
    procedure Close;
    procedure Execute;
    function Eof: Boolean;
    procedure First;
    procedure Next;
    procedure Prior;
    procedure Last;
    function RecordCount: Integer;
    function FieldValues(const FieldName: string): Variant;
    function FieldByNameAsString(const FieldName: string): String;
    function FieldByNameAsUInt64(const FieldName: string): UInt64;
    function FieldByNameAsWideString(const FieldName: string): WideString;
    function FieldByNameAsInteger(const FieldName: string): Integer;
    function FieldByNameAsLargeInt(const FieldName: string): Int64;
    function FieldByNameAsBoolean(const FieldName: string): Boolean;    
    function FieldByNameAsVariant(const FieldName: string): Variant;    
    function ParamByNameAsString(const Value: string): String;
    function ParamByNameAsWideString(const Value: string): WideString;
    function ParamByNameAsInteger(const Value: string): Integer;
    function ParamByNameAsLargeInt(const Value: string): Int64;
    function ParamByNameAsBoolean(const Value: string): Boolean;    
    function ParamByNameAsVariant(const Value: string): Variant;    
    function ParamByNameAsUInt64(const Value: string): UInt64;    
    procedure SetParamByNameAsString(const Prm: string; Value: String);
    procedure SetParamByNameAsWideString(const Prm: string; Value: WideString);
    procedure SetParamByNameAsInteger(const Prm: string; Value: Integer);
    procedure SetParamByNameAsLargeInt(const Prm: string; Value: Int64);
    procedure SetParamByNameAsSmallInt(const Prm: string; Value: SmallInt);
    procedure SetParamByNameAsBoolean(const Prm: string; Value: Boolean);    
    procedure SetParamByNameAsVariant(const Prm: string; Value: Variant);
    procedure SetParamByNameAsUInt64(const Prm: string; Value: UInt64);
    procedure PrepareSQL;
    function DataSource: TUniDataSource;
    
  end;

implementation

uses 
  SysUtils;

//
constructor TbfaSP.Create(Connection: TUniConnection; SPName: WideString);
begin
  FErrorCode:= -1;
  FStoredProcedure:= TUniStoredProc.Create(nil);
  FStoredProcedure.Connection:= Connection;
  FStoredProcedure.StoredProcName:= SPName;
  FDataSource:= TUniDataSource.Create(nil);
  FDataSource.DataSet:= FStoredProcedure;
end;

destructor TbfaSp.Destroy;
begin
//  if FStoredProcedure <> nil then
    FreeAndNil(FStoredProcedure);
//  if FDataSource <> nil then
    FreeAndNil(FDataSource);
  inherited Destroy;
end;
//
procedure TbfaSp.Open;
begin
  FDataSource.DataSet.Open;
end;
//
procedure TbfaSp.Close;
begin
  FDataSource.DataSet.Close;
  Free;
end;
//
procedure TbfaSp.Execute;
begin
  FStoredProcedure.Execute;
end;
//
function TbfaSp.Eof: Boolean;
begin
  result:= FStoredProcedure.Eof;
end;
//
procedure TbfaSp.First;
begin
  FStoredProcedure.First;
end;
//
procedure TbfaSp.Next;
begin
  FStoredProcedure.Next;
end;
//
procedure TbfaSp.Prior;
begin
  FStoredProcedure.Prior;
end;
//
procedure TbfaSp.Last;
begin
  FStoredProcedure.Last;
end;
//
function TbfaSp.RecordCount: Integer;
begin
  Result:= FStoredProcedure.RecordCount;
end;
//
function TbfaSp.FieldValues(const FieldName: string): Variant;
begin
  Result:= FStoredProcedure.FieldValues[FieldName];
end;
//
function TbfaSp.FieldByNameAsString(const FieldName: string): String;
begin
  Result:= FStoredProcedure.FieldByName(FieldName).AsString;
end;
//
function TbfaSp.FieldByNameAsUInt64(const FieldName: string): UInt64;
begin
//  Result:= FStoredProcedure.FieldByName(FieldName).AsLargeInt;
  Result:= FStoredProcedure.FieldValues[FieldName];
end;
//
function TbfaSp.FieldByNameAsWideString(const FieldName: string): WideString;
begin
  Result:= FStoredProcedure.FieldByName(FieldName).AsWideString;
end;
//
function TbfaSp.FieldByNameAsInteger(const FieldName: string): Integer;
begin
  Result:= FStoredProcedure.FieldByName(FieldName).AsInteger;
end;
//
function TbfaSp.FieldByNameAsLargeInt(const FieldName: string): Int64;
begin
  Result:= FStoredProcedure.FieldByName(FieldName).AsLargeInt;
end;
//
function TbfaSp.FieldByNameAsBoolean(const FieldName: string): Boolean;
begin
  Result:= FStoredProcedure.FieldByName(FieldName).AsBoolean;
end;
//
function TbfaSp.FieldByNameAsVariant(const FieldName: string): Variant;
begin
  Result:= FStoredProcedure.FieldByName(FieldName).AsVariant;
end;
//
function TbfaSp.ParamByNameAsString(const Value: string): String;
begin
  Result:= FStoredProcedure.ParamByName(Value).AsString;
end;
//
function TbfaSp.ParamByNameAsWideString(const Value: string): WideString;
begin
  Result:= FStoredProcedure.ParamByName(Value).AsWideString;
end;
//
function TbfaSp.ParamByNameAsInteger(const Value: string): Integer;
begin
  Result:= FStoredProcedure.ParamByName(Value).AsInteger;
end;
//
function TbfaSp.ParamByNameAsLargeInt(const Value: string): Int64;
begin
  Result:= FStoredProcedure.ParamByName(Value).AsLargeInt;
end;
//
function TbfaSp.ParamByNameAsBoolean(const Value: string): Boolean;
begin
  Result:= FStoredProcedure.ParamByName(Value).AsBoolean;
end;
//
function TbfaSp.ParamByNameAsVariant(const Value: string): Variant;
begin
  Result:= FStoredProcedure.ParamByName(Value).Value;
end;
//
function TbfaSp.ParamByNameAsUInt64(const Value: string): UInt64;
begin
//  Result:= FStoredProcedure.ParamByName(Value).AsLargeInt;
  Result:= FStoredProcedure.Params.ParamValues[Value];
end;
//
procedure TbfaSp.SetParamByNameAsString(const Prm: string; Value: String);
begin
  FStoredProcedure.ParamByName(Prm).AsString:= Value;
end;
//
procedure TbfaSp.SetParamByNameAsWideString(const Prm: string; Value: WideString);
begin
  FStoredProcedure.ParamByName(Prm).AsWideString:= Value;
end;
//
procedure TbfaSp.SetParamByNameAsInteger(const Prm: string; Value: Integer);
begin
  FStoredProcedure.ParamByName(Prm).AsInteger:= Value;
end;
//
procedure TbfaSp.SetParamByNameAsLargeInt(const Prm: string; Value: Int64);
begin
  FStoredProcedure.ParamByName(Prm).AsLargeInt:= Value;
end;
//
procedure TbfaSp.SetParamByNameAsSmallInt(const Prm: string; Value: SmallInt);
begin
  FStoredProcedure.ParamByName(Prm).AsSmallInt:= Value;
end;
//
procedure TbfaSp.SetParamByNameAsBoolean(const Prm: string; Value: Boolean);
begin
  FStoredProcedure.ParamByName(Prm).AsBoolean:= Value;
end;
//
procedure TbfaSp.SetParamByNameAsVariant(const Prm: string; Value: Variant);
begin
  FStoredProcedure.ParamByName(Prm).Value:= Value;
end;
//
procedure TbfaSp.SetParamByNameAsUInt64(const Prm: string; Value: UInt64);
begin
//  FStoredProcedure.ParamByName(Prm).AsLargeInt:= Value;
  FStoredProcedure.Params.ParamValues[Prm]:= Value;
end;
//
procedure TbfaSp.PrepareSQL;
begin
  FStoredProcedure.PrepareSQL;
end;
//
function TbfaSp.DataSource: TUniDataSource;
begin
  Result:= FDataSource;
end;
//

end.
