unit u_Info;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, jpeg, ExtCtrls, ShellAPI, gnugettext, bfaCommonUtils, SpTBXItem, SpTBXControls;

function GetVersionInfo: string; //#3.5
function GetVersionInfoW: string; //#3.5
function appversion(): STring;

type
  Tfrm_Info = class (TForm)
    img_Logo: TImage;
    lbl_Info1: TLabel;
    lbl_Info2: TLabel;
    lbl_Info3: TLabel;
    lbl_Info4: TLabel;
    lbl_Info5: TLabel;
    lbl_Info6: TLabel;
    lbl_Info8: TLabel;
    lbl_Info7: TLabel;
    btnLegal: TButton;
    lbl_URL: TLabel;
    SpTBXPanel1: TSpTBXPanel;
    procedure FormShow(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: word; Shift: TShiftState);
    procedure lbl_URLClick(Sender: TObject);
    procedure lbl_URLMouseEnter(Sender: TObject);
    procedure lbl_URLMouseLeave(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnLegalClick(Sender: TObject);
    procedure lbl_Info6Click(Sender: TObject);
    procedure lbl_Info6MouseEnter(Sender: TObject);
    procedure lbl_Info6MouseLeave(Sender: TObject);
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  frm_Info: Tfrm_Info;

implementation

uses
  u_Rights, MainForm;


{$R *.dfm}

{3.6<}
function GetVersionInfo: string;
var
  VerInfoSize: DWord;
  VerInfo: Pointer;
  VerValueSize: DWord;
  VerValue: PVSFixedFileInfo;
  Dummy: DWord;
begin
  try
    VerInfoSize := GetFileVersionInfoSize(PChar(BD.ExeFile), Dummy);
    GetMem(VerInfo, VerInfoSize);
    GetFileVersionInfo(PChar(BD.ExeFile), 0, VerInfoSize, VerInfo);
    VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
    with VerValue^ do
    begin
      Result := IntToStr(dwFileVersionMS shr 16);
      Result := Result + '.' + IntToStr(dwFileVersionMS and $FFFF);
      Result := Result + '.' + IntToStr(dwFileVersionLS shr 16);
      Result := Result + '.' + IntToStr(dwFileVersionLS and $FFFF);
    end;
  except
//      logevnt('Fehler bei GetVersionInfo (u_Info):' + BD.ExeFile);
  end;
  FreeMem(VerInfo, VerInfoSize);
end;
{>3.6}


{3.6<}
function GetVersionInfoW: string;
var
  VerInfoSize: DWord;
  VerInfo: Pointer;
  VerValueSize: DWord;
  VerValue: PVSFixedFileInfo;
  Dummy: DWord;
begin
  VerInfoSize := GetFileVersionInfoSize(PChar(ParamStr(0)), Dummy);
  GetMem(VerInfo, VerInfoSize);
  GetFileVersionInfo(PChar(ParamStr( 0)), 0, VerInfoSize, VerInfo);
  VerQueryValue(VerInfo, '\StringFileVersion', Pointer(VerValue), VerValueSize);
  with VerValue^ do
  begin
    Result := IntToStr(dwFileVersionMS shr 16);
    Result := Result + '.' + IntToStr(dwFileVersionMS and $FFFF);
    Result := Result + '.' + IntToStr(dwFileVersionLS shr 16);
    Result := Result + '.' + IntToStr(dwFileVersionLS and $FFFF);
  end;
  FreeMem(VerInfo, VerInfoSize);
end;

{>3.6}

function appversion(): String;
var
  verblock: PVSFIXEDFILEINFO;
  versionMS, versionLS, verlen, s: cardinal;
  rs: TResourceStream;
  m: TMemoryStream;
  p: pointer;
  AppVersionString: string;
begin
  m := TMemoryStream.Create;
  try
    rs := TResourceStream.CreateFromID(HInstance, 1, RT_VERSION);
    try
      m.CopyFrom(rs, rs.Size);
    finally
      rs.Free;
    end;
    m.Position := 0;
    if VerQueryValue(m.Memory, '\', pointer(verblock), verlen) then
      begin
        VersionMS := verblock.dwFileVersionMS;
        VersionLS := verblock.dwFileVersionLS;
        AppVersionString := //Application.Title+' '+
          IntToStr(versionMS shr 16)+'.'+
          IntToStr(versionMS and $FFFF)+'.'+
          IntToStr(VersionLS shr 16)+'.'+
          IntToStr(VersionLS and $FFFF);
      end;

  finally
    m.Free;
  end;
  Result := AppVersionString;
end;

procedure Tfrm_Info.FormShow(Sender: TObject);
begin
  {$IFNDEF ENTERPRISE}
  lbl_Info1.Caption := 'bitfarm-Archiv V36 Viewer - GPL Version ' + appversion;
  lbl_Info7.Visible := False;
  lbl_Info6.Caption := 'Sourceforge.net';
  lbl_Info6.Font.Style := [TFontStyle.fsUnderline];
  lbl_Info6.Font.Color := clBlue;
  {$ELSE}
  lbl_Info1.Caption := 'bitfarm-Archiv V36 Viewer - Version ' + appversion;
  {$ENDIF}
  lbl_Info8.Caption := 'Copyright (c) 2004 - '+cCurYear+' bitfarm Informationssysteme GmbH';
end;

procedure Tfrm_Info.FormKeyUp(Sender: TObject; var Key: word; Shift: TShiftState);
begin
  try
    if Screen.ActiveForm = Self then
    begin
     if Key = VK_ESCAPE then
       Self.Close;
    end;
  except
    //
  end;
end;

procedure Tfrm_Info.lbl_Info6Click(Sender: TObject);
begin
  {$IFNDEF ENTERPRISE}
  ShellExecute(0, nil, PChar('https://www.bitfarm-archiv.de/downloads-support/gpl-support.html'), PChar(''),
    PChar(''), SW_NORMAL);
  {$ENDIF}
end;

procedure Tfrm_Info.lbl_Info6MouseEnter(Sender: TObject);
begin
  {$IFNDEF ENTERPRISE}
    lbl_Info6.Font.Color := clSkyBlue;
  {$ENDIF}
end;

procedure Tfrm_Info.lbl_Info6MouseLeave(Sender: TObject);
begin
  {$IFNDEF ENTERPRISE}
    lbl_Info6.Font.Color := clBlue;
  {$ENDIF}
end;

procedure Tfrm_Info.lbl_URLClick(Sender: TObject);
begin
  ShellExecute(0, nil, PChar('https://www.bitfarm-archiv.de/'), PChar(''),
    PChar(''), SW_NORMAL);
end;

procedure Tfrm_Info.lbl_URLMouseEnter(Sender: TObject);
begin
  lbl_URL.Font.Color := clSkyBlue;
end;

procedure Tfrm_Info.lbl_URLMouseLeave(Sender: TObject);
begin
  lbl_URL.Font.Color := clBlue;
end;

procedure Tfrm_Info.CreateParams(var Params: TCreateParams);
begin
  inherited;
  (*
  Params.ExStyle := Params.ExStyle; // or WS_EX_APPWINDOW;
  Params.WndParent := GetDesktopWindow;
  *)
end;

procedure Tfrm_Info.FormCreate(Sender: TObject);
begin
  TranslateComponent(Self, 'CommonUtils');
end;

procedure Tfrm_Info.btnLegalClick(Sender: TObject);
begin
  Application.CreateForm(Tfrm_Rights, frmMainForm.frm_Rights);
  frmMainForm.frm_Rights.ShowModal;
  frmMainForm.frm_Rights.Release;
end;

end.
