unit ComponentsRegistrationUnit;

interface

procedure Register;

implementation

uses
  Classes,
  Forms,
  TreeIntf,
  u_bfaMainMenuGPL,
  u_bfaMainMenuEnterprise,
  u_bfaStandardToolbar,
  u_bfaTlbStandard,
  u_bfaTlbPreview,
  u_bfaAddfield,
  u_bfaScrollBox,
  u_bfaGrid,
  u_bfaSplitter,
  u_bfaInputCombo,
  u_bfaInputEdit,
  u_bfaSelector,
  u_bfaTlbImport,
  bfaTabSheet;

type
  TFrameClass = class of TFrame;


procedure RegisterFramesAsComponents(const Page: string; const FrameClasses: array of TFrameClass);
var
  FrameClass: TFrameClass;
begin
  for FrameClass in FrameClasses do
  begin
    RegisterComponents(Page, [FrameClass]);
    RegisterSprigType(FrameClass, TComponentSprig);
  end;
end;

procedure Register;
begin
  RegisterFramesAsComponents('bfaComponents', [TbfaMainMenu, TbfaMainMenuEnterprise,
    TbfaStandardToolbar, TbfaInputEdit, TbfaInputCombo, TbfaSelector]);
  RegisterComponents('bfaComponents', [TbfaTlbStandard, TbfaTlbPreview, TbfaTlbImport,
    TBfaAddfieldComp, TbfaStatefieldComp, TbfaScrollBox, TbfaDBGrid, TbfaSplitter, TbfaJvCheckedComboBox
    {// SJ 16.12.2020}
    , TbfaLabel, TbfaTextEdit, TbfaComboBox, TbfaCheckedListBox, TbfaCheckedCombo, TbfaTabSheet]);
end;

end.
