unit bfaGridDBTableView;

interface

uses
  Classes, ExtCtrls, Vcl.Controls, VCL.Graphics, cxGrid, cxGridDBTableView,
  cxGridCustomTableView, cxGraphics, dxCore, cxGridCustomView, cxcustomData,
  cxGridTableView, cxGridRows
  ;

type
  TGridKind = (gkNone, gkSearch, gkResub, gkResubDelegate);
  TcxGridColumnHeaderViewInfoAccess = class(TcxGridColumnHeaderViewInfo);
  TcxGridColumnHeaderFilterButtonViewInfoAccess = class (TcxGridColumnHeaderFilterButtonViewInfo);
  TcxGridColumnHeaderPainterAccess = class(TcxGridColumnHeaderPainter);
  TcxViewInfoAcess = class(TcxGridTableDataCellViewInfo);
  TcxPainterAccess = class(TcxGridTableDataCellPainter);

  TbfaGridIndicatorAccess = class(TcxCustomGridCellViewInfo)
  public
    procedure Dropdown; override;
  end;

  TbfaGridSite = class(TcxGridSite)
  protected
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  end;

  TbfaGridTableViewInfo = class(TcxGridTableViewInfo)
  protected
    function GetSiteClass: TcxGridSiteClass; override;
  end;

  TOnDeselect  = procedure of object;

  TbfaGridDBTableView = class(TcxGridDBTableView)
  private
    FChangeDelay, ARecIndex, FActRec, FUserid : Integer;
    FDelayTimer : TTimer;
    FIsSelectionChanged : Boolean;
    FOnDeselect: TOnDeselect;

    FKind : TGridKind;
    FSkipTimer : Boolean;
    FColGDocID, FColArcID, FColSymArcID, FColAlarm : TcxGridDBColumn;

    procedure DoChangedTimer(Sender : TObject);
    procedure SetChangeDelay(Value : Integer);
    procedure DoSelectionChanged; override;
    procedure DoCustomDrawCell(ACanvas: TcxCanvas;
      AViewInfo: TcxGridTableDataCellViewInfo; var ADone: Boolean); override;
    procedure DoCustomDrawGroupCell(//Sender : TcxCustomGridTableView;
     ACanvas: TcxCanvas;
      AViewInfo: TcxGridTableCellViewInfo; var ADone: Boolean); override;


//    procedure DoCustomDrawGroupSummaryCell(Sender: TObject; ACanvas: TcxCanvas; ARow: TcxGridGroupRow; AColumn: TcxGridColumn;
//      ASummaryItem: TcxDataSummaryItem; AViewInfo: TcxCustomGridViewCellViewInfo; var ADone: Boolean); override;
//    procedure DoCustomDrawGroupSummaryCell(ACanvas: TcxCanvas;
//      AViewInfo: TcxCustomGridViewCellViewInfo; var ADone: Boolean); override;

    procedure DoKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DoCustomDrawColumnHeader(Sender: TcxGridTableView; ACanvas: TcxCanvas;
      AViewInfo: TcxGridColumnHeaderViewInfo; var ADone: Boolean);
    procedure DataChanged(Sender: TObject);
    procedure DoGroupRowExpanded(AGroup: TcxGridGroupRow); override;
    function GetFirstSelectedRecord: Integer;
//    procedure DoFocusedRecordChanged(
//      APrevFocusedRecordIndex, AFocusedRecordIndex,
//      APrevFocusedDataRecordIndex, AFocusedDataRecordIndex: Integer;
//      ANewItemRecordFocusingChanged: Boolean); override;
  protected
    function GetViewInfoClass: TcxCustomGridViewInfoClass; override;
    function GetViewDataClass: TcxCustomGridViewDataClass; override;
    function GetSummaryItemClass: TcxDataSummaryItemClass; override;

  public
    clEnabledText, clDisabledText, clFree, clFreeText, clSelected, clSelectedText,
    clWork, clWorkText, clWorkSelected, clWorkSelectedText, clDone, clDoneText,
    clDoneSelected, clDoneSelectedText, clUrgent, clUrgentText, clUrgentSelected,
    clUrgentSelectedText, clProgress, clProgressText, clProgressSelected,
    clProgressSelectedText : TColor;

    ImageList : TImageList;
    FInEditMode: TStringList;
    RowColorEvenOdd : Boolean;
    Grd : TcxGrid;

    constructor Create(AOwner: TComponent); override;

    procedure SetBookmark;
    function CreateDBColumn(ColumnName, ColumnCaption, ColumnFieldName,
      ColumnValueType : WideString; ColumnWidth: Integer;
      Visiblity : Boolean = True; ColumnsortOrder : TdxSortOrder = soNone;
      GrpIndex : Integer = -1; SIndex : Integer = -1;
      Customization : Boolean = True; EditForm : TdxDefaultBoolean = bTrue;
      ColTyp : Integer = -1; FooterKind : Integer = 0): TcxGridDBColumn;
    procedure DoMouseUp(
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Changed(AChangeKind: TcxGridViewChangeKind); overload;
      {$IFDEF BCBCOMPATIBLE}virtual;{$ENDIF}
    procedure SetGridDBTableViewDefaultSettings; //15.09.2023 Muss nicht im MainForm sein


  published
    property ChangeDelay : Integer read FChangeDelay write SetChangeDelay;
    property Kind: TGridKind read FKind write FKind;
    property Userid: Integer read FUserid write FUserid;
    property ActRec: Integer read FActRec write FActRec;
//    property ColGDocID : TcxGridDBColumn read FColGDocID;
//    property ColArcID : TcxGridDBColumn read FColArcID;
    property ColAlarm : TcxGridDBColumn read FColAlarm write FColAlarm;
    property ColSymArcID : TcxGridDBColumn read FColSymArcID;
    property InEditMode : TStringList read FInEditMode;
    property OnDeselect : TOnDeselect read FOnDeselect write FOnDeselect;
    property IsSelectionChanged : Boolean read FIsSelectionChanged write FIsSelectionChanged;

  end;

  TbfaGridViewData = class(TcxGridViewData)
  protected
    function GetRecordClass(const ARecordInfo: TcxRowInfo): TcxCustomGridRecordClass; override;
  end;

  TbfaGridDataRow = class(TcxGridDataRow)
  protected
    function GetViewInfoClass: TcxCustomGridRecordViewInfoClass; override;
  end;

  TbfaGridMasterDataRow = class(TcxGridMasterDataRow)
    function GetViewInfoClass: TcxCustomGridRecordViewInfoClass; override;
  end;

  TbfaGridDataRowViewInfo = class(TcxGridDataRowViewInfo)
  public
    function Click(AHitTest: TcxCustomGridHitTest; AButton: TMouseButton;
                   AShift: TShiftState): Boolean; override;
  end;

  TbfaGridMasterDataRowViewInfo = class(TcxGridMasterDataRowViewInfo)
    function Click(AHitTest: TcxCustomGridHitTest; AButton: TMouseButton;
                   AShift: TShiftState): Boolean; override;
  end;

  TbfaGridDBTableSummaryItem = class (TcxGridDBTableSummaryItem)
  protected
    function GetValueFormat(AValueType: TcxSummaryValueType; const AValue: Variant;
      AIsFooter: Boolean): string; override;
  end;

implementation

uses
  Winapi.Windows, System.SysUtils, Vcl.GraphUtil, bfaCommonUtils, cxTextEdit,
  Vcl.ImgList, cxCurrencyEdit, cxDataStorage, cxGridCommon, cxLookAndFeelPainters,
  System.Variants, cxGeometry, bfaCommonStyles
  ;


procedure TbfaGridDBTableView.SetGridDBTableViewDefaultSettings;
begin
//  with grdDBTableView do
//  begin
    FilterRow.Visible := False;
    OptionsView.GroupByBox := False;

    OptionsCustomize.ColumnsQuickCustomization := False;
    OptionsCustomize.ColumnsQuickCustomizationShowCommands := False;

    OptionsCustomize.GroupBySorting := False;
    OptionsView.FooterMultiSummaries := True;
    OptionsData.Appending := False;
    OptionsData.CancelOnExit := False;
    OptionsData.Deleting := False;
    OptionsData.DeletingConfirmation := False;
    OptionsData.Editing := False;
    OptionsData.Inserting := False;
    OptionsSelection.MultiSelect:= True;
    OptionsSelection.CellSelect := False;
    OptionsSelection.InvertSelect := True;
    OptionsSelection.UnselectFocusedRecordOnExit := False;
    OptionsView.FocusRect := False;
    OptionsView.NoDataToDisplayInfoText := '';
    OptionsView.GroupFooters := gfInvisible;
    Navigator.Visible := True;
    Navigator.InfoPanel.DisplayMask := '[RecordIndex] / [RecordCount]';
    Navigator.InfoPanel.Visible := True;
    Navigator.Buttons.First.Visible := False;
    Navigator.Buttons.PriorPage.Visible := False;
    Navigator.Buttons.Prior.Visible := False;
    Navigator.Buttons.Next.Visible := False;
    Navigator.Buttons.NextPage.Visible := False;
    Navigator.Buttons.Last.Visible := False;
    Navigator.Buttons.Insert.Visible := False;
    Navigator.Buttons.Append.Visible := False;
    Navigator.Buttons.Delete.Visible := False;
    Navigator.Buttons.Edit.Visible := False;
    Navigator.Buttons.Post.Visible := False;
    Navigator.Buttons.Cancel.Visible := False;
    Navigator.Buttons.Refresh.Visible := False;
    Navigator.Buttons.SaveBookmark.Visible := False;
    Navigator.Buttons.GotoBookmark.Visible := False;
    Navigator.Buttons.Filter.Visible := False;
//  end;
end;

function TbfaGridDBTableView.CreateDBColumn(ColumnName, ColumnCaption,
  ColumnFieldName, ColumnValueType : WideString; ColumnWidth: Integer;
  Visiblity : Boolean = True; ColumnsortOrder : TdxSortOrder = soNone;
  GrpIndex : Integer = -1; SIndex : Integer = -1;
  Customization : Boolean = True; EditForm : TdxDefaultBoolean = bTrue;
  ColTyp : Integer = -1; FooterKind : Integer = 0): TcxGridDBColumn;
var
  col : TcxGridDBColumn;
  i, visibleidx : Integer;
  found : Boolean;
begin
  try
    found := False;
    visibleidx := 0;
    for i := 0 to Self.ColumnCount - 1 do
    begin
      if Self.Columns[i].Visible then
        inc(visibleidx);
      if Self.Columns[i].Name = ColumnName then
      begin
        found := True;
        col := Self.Columns[i];
        Break;
      end;
    end;

    if not found then
    begin
      col:= Self.CreateColumn as TcxGridDBColumn;
      with col do
      begin
        Name := ColumnName;
        Caption := ColumnCaption;
        DataBinding.FieldName := ColumnFieldName;
        DataBinding.ValueType := ColumnValueType;

        if ColTyp <> -1  then
        begin
          if eAddFieldType(ColTyp) = zfld01_Datum then
          begin
            DataBinding.ValueTypeClass := TcxDateTimeValueType;
            Properties.ValidateOnEnter := False;
          end
          else if  (eAddFieldType(ColTyp) = zfld05_Intervall) then
          begin
            DataBinding.ValueTypeClass := TcxStringValueType;
            PropertiesClass := TcxTextEditProperties;
          end
          else if (eAddFieldType(ColTyp) = zfld07_FliessKomma) then
          begin
            DataBinding.ValueTypeClass := TcxFloatValueType;
            PropertiesClass := TcxTextEditProperties;
            TcxTextEditProperties(Properties).DisplayFormat := ',0.0000000000;-,0.0000000000';
          end
          else if eAddFieldType(ColTyp) = zfld08_Waehrung then
          begin
            DataBinding.ValueTypeClass := TcxCurrencyValueType;
            PropertiesClass := TcxCurrencyEditProperties;
            TcxCurrencyEditProperties(Properties).DisplayFormat := ',0.00;-,0.00';
          end;
        end;
      end;

      if ColumnName = 'gdocid' then
        FColGDocID := col
      else if ColumnName = 'arcid' then
        FColArcID := col
      else if ColumnName = 'alarm' then
        FColAlarm := col
      else if ColumnName = 'symarcid' then
        FColSymArcID := col;
    end;

    with col do
    begin
      if Visiblity then
        SortOrder := ColumnSortOrder
      else
        SortOrder := soNone;
      SortIndex := SIndex;
      Width := ColumnWidth;
      Visible := Visiblity;
      GroupIndex := GrpIndex;

      if (not Visiblity) then
      begin
        VisibleForCustomization := Customization;
        VisibleForEditForm := bFalse;
      end
      else
      begin
        VisibleForCustomization := Customization;
        VisibleForEditForm := EditForm;
      end;

      if (ColumnName = 'docname') or (ColumnName = 'docdate') then
      begin
        VisibleForCustomization := False;
        VisibleForEditForm := bFalse;
      end;

      Summary.FooterKind := TcxSummaryKind(FooterKind); //23.09.2021 Ticket 24736
      Summary.GroupFooterKind := TcxSummaryKind(FooterKind); //23.09.2021 Ticket 24736
    end;
    col.Styles.Header := Self.Styles.Header;

    Result:= col;
  except
    Result:= nil;
  end;
end;

procedure TbfaGridDBTableView.Changed(AChangeKind: TcxGridViewChangeKind);
begin
  inherited;
end;

constructor TbfaGridDBTableView.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  FChangeDelay := 250;

  FDelayTimer := TTimer.Create(Self);
  FDelayTimer.OnTimer := DoChangedTimer;
  FDelayTimer.Enabled := False;

  Self.RowColorEvenOdd := True;
  Self.clEnabledText := clBlack;
  Self.clDisabledText := clGrayText;
  Self.clFree := gclFree;
  Self.clFreeText := gclFreeText;
  Self.clSelected := gclSelected;
  Self.clSelectedText := gclSelectedText;
  Self.clWork := gclWork;
  Self.clWorkText := gclWorkText;
  Self.clWorkSelected := gclWorkSelected;
  Self.clWorkSelectedText := gclWorkSelectedText;
  Self.clDone := gclDone;
  Self.clDoneText := gclDoneText;
  Self.clDoneSelected := gclDoneSelected;
  Self.clDoneSelectedText := gclDoneSelectedText;
  Self.clUrgent := gclUrgent;
  Self.clUrgentText := gclUrgentText;
  Self.clUrgentSelected := gclUrgentSelected;
  Self.clUrgentSelectedText := gclUrgentSelectedText;
  Self.clProgress := gclProgress;
  Self.clProgressText := gclProgressText;
  Self.clProgressSelected := gclProgressSelected;
  Self.clProgressSelectedText := gclProgressSelectedText;

  Self.OnKeyUp := DoKeyUp;
  Self.OnCustomDrawColumnHeader := DoCustomDrawColumnHeader;
  Self.DataController.OnDataChanged := DataChanged;
  Self.DataController.Options := [dcoAssignGroupingValues, dcoAssignMasterDetailKeys, dcoCaseInsensitive,
    dcoSaveExpanding, dcoMultiSelectionSyncGroupWithChildren];

  FActRec := -1;
  FSkipTimer := False;
  FInEditMode := TStringList.Create;

  FIsSelectionChanged := False;
end;

procedure TbfaGridDBTableView.SetChangeDelay(Value: Integer);
begin
  if not Assigned(FDelayTimer) then
    Exit;

  FChangeDelay := Value;
  if Value < 0 then Value := 0;
  FDelayTimer.Interval := Value;
  FDelayTimer.Enabled := False;
end;

procedure TbfaGridDBTableView.DoChangedTimer(Sender: TObject);
begin
  try
    FDelayTimer.Enabled:= False;
    if (Self.DataController.DataSource <> nil) and
       (Self.DataController.DataSource.DataSet <> nil) then
      FActRec := DataController.DataSource.DataSet.RecNo - 1
    else
      FActRec := -1;
    inherited DoSelectionChanged;
  except
    //
  end;
end;

procedure TbfaGridDBTableView.DoSelectionChanged;
begin
  try
    if not FSkipTimer then
    begin
      if (FChangeDelay = 0) then
      begin
        inherited DoSelectionChanged;
      end
      else begin
        FDelayTimer.Enabled := False;
        FDelayTimer.Enabled := True;
      end;
    end;
  finally
    FIsSelectionChanged := True;
    FSkipTimer := True;
  end;
end;

procedure TbfaGridDBTableView.DoCustomDrawGroupCell(//Sender : TcxCustomGridTableView;
  ACanvas: TcxCanvas;
  AViewInfo: TcxGridTableCellViewInfo; var ADone: Boolean);
var
  AValue: Variant;
  IsSelected, GroupContainsSelected : Boolean;
begin
  inherited;
  try
    if (AViewInfo is TcxGridGroupCellViewInfo) then
    begin
      IsSelected := AViewInfo.GridRecord.Selected;

      GroupContainsSelected :=
        Self.DataController.GroupContainsSelectedRows(AViewInfo.GridRecord.Index) and not AViewInfo.GridRecord.Expanded;

      if IsSelected or GroupContainsSelected then
        ACanvas.brush.color := clSelected
      else
        ACanvas.brush.color := clFree;

      if ((AViewInfo.GridRecord as TcxGridGroupRow).GroupedColumn.Properties is TcxCurrencyEditProperties) then
      begin
        AValue := (AViewInfo.GridRecord as TcxGridGroupRow).Value;
        if (not VarIsNull(AValue)) and (AValue < 0) then
          ACanvas.Font.Color := gclRed
        else
          ACanvas.Font.Color := clFreeText;
      end
      else
        ACanvas.Font.Color := clFreeText;

  //    if AViewInfo.GridRecord.Focused then
  //      ACanvas.Font.Style := [fsBold]
  //    else
  //      ACanvas.Font.Style := [];

    end;
  except

  end;
end;

procedure TbfaGridDBTableView.DoCustomDrawCell(ACanvas: TcxCanvas;
      AViewInfo: TcxGridTableDataCellViewInfo; var ADone: Boolean);
var
  CurrentSelected, IsSelected, inWork : Boolean;
  APainter : TcxPainterAccess;
  strGdocID : string;
  intStatus, intGrpID, intOption, intWork, idx : Integer;
  dtAlarm : TDateTime;
begin
  if AViewInfo.GridRecord.RecordIndex = -1 then
    Exit;

  try
    ACanvas.Font.Size := Styles.Header.Font.Size;
    CurrentSelected := AViewInfo.GridRecord.Selected and
//19.04.2022      (AViewInfo.GridRecord.RecordIndex = FActRec - 1);
      (AViewInfo.GridRecord.RecordIndex = FActRec);
    IsSelected := AViewInfo.GridRecord.Selected;

    inWork := False; //29.09.2022 Ticket 31446

    if ACanvas.brush.color = clHighlight then
      ACanvas.brush.color := clFree;

    if FKind = gkNone then
    begin
      if IsSelected then
        ACanvas.brush.color := clSelected
      else
        ACanvas.brush.color := clFree;
    end;

    if (Self.DataController.DataSource <> nil) and
      (Self.DataController.DataSource.DataSet <> nil) and
      (Self.DataController.DataSource.DataSet.RecordCount > 0) then
    begin
      if (FKind = gkSearch) then
      begin
        strGdocID := Self.DataController.GetValue(AViewInfo.GridRecord.RecordIndex,
          Self.DataController.GetItemByFieldName('gdocid').Index);
        if FInEditMode.IndexOf(strGdocID) > -1 then
        begin
          if IsSelected then
            ACanvas.brush.color := clProgressSelected
          else
            ACanvas.brush.color := clProgress;
        end
        else begin
          if IsSelected then
            ACanvas.brush.color := clSelected
          else
            ACanvas.brush.color := clFree;
        end;
      end else if (FKind in [gkResub, gkResubDelegate]) then
      begin
        if Self.DataController.DataSource.DataSet.FieldDefList.Find('status') <> nil then
        begin
          try
            idx := Self.GetColumnByFieldName('status').Index;
          except
            idx := -1;
          end;
          if idx > -1 then
            intStatus := Self.DataController.GetValue(AViewInfo.GridRecord.RecordIndex, idx)
          else
            intStatus := 0;

          if intStatus = 0 then
          begin
            if IsSelected then
              ACanvas.brush.color := clSelected
            else
              ACanvas.brush.color := clFree;
          end;
          if (intStatus and 1) = 1 then
          begin
            if IsSelected then
              ACanvas.brush.color := clSelected
            else
              ACanvas.brush.color := clFree;
          end;
          if (intStatus and 2) = 2 then
          begin
            inWork := True; //29.09.2022 Ticket 31446
            if IsSelected then
              ACanvas.brush.color := clWorkSelected
            else
              ACanvas.brush.color := clWork;
          end;
          if (intStatus and 4) = 4 then
          begin
            if IsSelected then
              ACanvas.brush.color := clDoneSelected
            else
              ACanvas.brush.color := clDone;
          end;
        end;

        if (Self.DataController.DataSource.DataSet.FieldDefList.Find('alarm') <> nil) then
        begin
          try
            idx := Self.DataController.GetItemByFieldName('alarm').Index;
          except
            idx := -1;
          end;
//29.09.2022          if idx > -1 then
          if (idx > -1) and not inWork then //29.09.2022 Ticket 31446
          begin
            dtAlarm := Self.DataController.Values[AViewInfo.GridRecord.RecordIndex,
              idx];
            if (dtAlarm <= Now()) and ((intStatus and 4) = 0) then
            begin
              if IsSelected then
                ACanvas.brush.color := clUrgentSelected
              else
                ACanvas.brush.color := clUrgent;
            end;
          end;
        end;

        if (Self.DataController.DataSource.DataSet.FieldDefList.Find('groupid') <> nil)
          and (Self.DataController.DataSource.DataSet.FieldDefList.Find('options') <> nil)
          and Assigned(ImageList)
          and (TcxGridDBColumn(AViewInfo.Item).DataBinding.FieldName = 'typ') then
        begin
          APainter := TcxPainterAccess(TcxViewInfoAcess(AViewInfo).GetPainterClass.
            Create(ACanvas, AViewInfo));
          with APainter do
          begin
            try
              with TcxCustomTextEditViewInfo(AViewInfo.EditViewInfo).TextRect do
                Left := Left + ImageList.Width + 1;

              ACanvas.FillRect(AViewInfo.Bounds, ACanvas.Brush.Color);
              DrawBorders;

              try
                intWork := Self.DataController.Values[AViewInfo.GridRecord.RecordIndex,
                  Self.DataController.GetItemByFieldName('userid_work').Index];
              except
                intWork := 0;
              end;
              try
                intGrpID := Self.DataController.Values[AViewInfo.GridRecord.RecordIndex,
                  Self.DataController.GetItemByFieldName('groupid').Index];
              except
                intGrpID := 0;
              end;
              try
                intOption := Self.DataController.Values[AViewInfo.GridRecord.RecordIndex,
                  Self.DataController.GetItemByFieldName('options').Index];
              except
                intOption := 0;
              end;

              if FKind = gkResub then
              begin
                if intWork = FUserID then
                begin
                  if intGrpID <> 0 then
                  begin
                    if (intOption and 1) = 1 then
                      ImageList.Draw(ACanvas.Canvas, AViewInfo.ClientBounds.Left,
                        AViewInfo.ClientBounds.Top, Integer(icoidx_resubmission_everybody), True)
                    else
                      ImageList.Draw(ACanvas.Canvas, AViewInfo.ClientBounds.Left,
                        AViewInfo.ClientBounds.Top, Integer(icoidx_user), True)
                  end else
                    ImageList.Draw(ACanvas.Canvas, AViewInfo.ClientBounds.Left,
                      AViewInfo.ClientBounds.Top, Integer(icoidx_group), dsTransparent,
                      itImage, True);
                end else
                begin
                  if  (intGrpID <> 0) then
                  begin
                    if  (intOption and 1) = 1 then
                      ImageList.Draw(ACanvas.Canvas, AViewInfo.ClientBounds.Left,
                        AViewInfo.ClientBounds.Top, Integer(icoidx_resubmission_everybody_forward),
                        True )
                    else
                      ImageList.Draw(ACanvas.Canvas, AViewInfo.ClientBounds.Left,
                        AViewInfo.ClientBounds.Top, Integer(icoidx_resubmission_group_forward),
                        True )
                  end else
                    ImageList.Draw(ACanvas.Canvas, AViewInfo.ClientBounds.Left,
                      AViewInfo.ClientBounds.Top, Integer(icoidx_resubmission_own_forward),
                      dsTransparent, itImage, True );
                end;
              end else
              begin
                if intGrpID <> 0 then
                begin
                  if  (intOption and 1) = 1 then
                    ImageList.Draw(ACanvas.Canvas, AViewInfo.ClientBounds.Left,
                      AViewInfo.ClientBounds.Top, Integer(icoidx_resubmission_everybody), True )
                  else
                    ImageList.Draw(ACanvas.Canvas, AViewInfo.ClientBounds.Left,
                      AViewInfo.ClientBounds.Top, Integer(icoidx_user), True )
                end else
                  ImageList.Draw(ACanvas.Canvas, AViewInfo.ClientBounds.Left,
                    AViewInfo.ClientBounds.Top, Integer(icoidx_group), True );
              end;
            finally
              Free;
            end;
          end;
          ADone := true;
          Exit;
        end;
      end;
    end;

    if (Self.DataController.DataSource <> nil) and
       (Self.DataController.DataSource.DataSet <> nil) and
       (Self.Controller.SelectedRecordCount > 0) and
       IsSelected and CurrentSelected
    then
      ACanvas.Font.Style := [fsBold]
    else
      ACanvas.Font.Style := [];

    if Grd.Enabled then
    begin
      if ACanvas.brush.color = clFree then
        ACanvas.Font.Color := clFreeText
      else if ACanvas.brush.color = clSelected then
        ACanvas.Font.Color := clSelectedText
      else if ACanvas.brush.color = clUrgent then
        ACanvas.Font.Color := clUrgentText
      else if ACanvas.brush.color = clUrgentSelected then
        ACanvas.Font.Color := clUrgentSelectedText
      else if ACanvas.brush.color = clWork then
        ACanvas.Font.Color := clWorkText
      else if ACanvas.brush.color = clWorkSelected then
        ACanvas.Font.Color := clWorkSelectedText
      else if ACanvas.brush.color = clDone then
        ACanvas.Font.Color := clDoneText
      else if ACanvas.brush.color = clDoneSelected then
        ACanvas.Font.Color := clDoneSelectedText
      else if ACanvas.brush.color = clProgress then
        ACanvas.Font.Color := clProgressText
      else if ACanvas.brush.color = clProgressSelected then
        ACanvas.Font.Color := clProgressSelectedText
      else
        ACanvas.Font.Color := clEnabledText;
    end
    else
      ACanvas.Font.Color := clDisabledText;

//15.03.2021 Ticket 25701 -->
    if (AViewInfo.Properties is TcxCurrencyEditProperties) and
      (AViewInfo.Value < 0)
    then
      ACanvas.Font.Color := gclRed; //15.04.2021 clRed;
//15.03.2021 Ticket 25701 <--

    if Self.RowColorEvenOdd and
        Odd(AViewInfo.GridRecord.Index) then
    begin
      if (ACanvas.brush.Color = clUrgent) then
        ACanvas.brush.color := ColorAdjustLuma(colortorgb(ACanvas.brush.color), -30, false)
      else if (ACanvas.brush.Color = clWork) then
        ACanvas.brush.color := ColorAdjustLuma(colortorgb(ACanvas.brush.color), -55, false)
      else
        ACanvas.brush.color := ColorAdjustLuma(colortorgb(ACanvas.brush.color), -15, false);
    end;
  except
    //
  end;
end;

procedure TbfaGridDBTableView.DoKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Self.DataController.DataSource = nil) or
     (Self.DataController.DataSource.DataSet = nil) or
     (not Self.DataController.DataSource.DataSet.Active)
  then
    Exit;

  if (Shift = []) then
  begin
    case Key of
      vk_up, vk_down, vk_left, vk_right, vk_prior, vk_next, vk_home, vk_end:
      begin
//05.04.2022        Self.Controller.FocusedRow.Selected := True;
        Self.Controller.FocusedRecord.Selected := True;
        Self.Invalidate;
        FDelayTimer.Enabled := False;
        FDelayTimer.Enabled := True;
        if Assigned(FOnDeselect) then
          FOnDeselect;
      end;
      27:
      begin
        Self.Controller.ClearSelection;
        if FActRec > -1 then
        begin
          try
            Self.DataController.DataSource.DataSet.RecNo := FActRec + 1;
//05.04.2022            Self.Controller.FocusedRow.Selected := True;
            Self.Controller.FocusedRecord.Selected := True;
          except
            //09.11.2017 Crashlog
          end;
        end
        else begin
          Self.DataController.DataSource.DataSet.First;
          FDelayTimer.Enabled := False;
          FDelayTimer.Enabled := True;
        end;
        if Assigned(FOnDeselect) then
          FOnDeselect;
      end;
    end;
  end;
end;

function TbfaGridDBTableView.GetFirstSelectedRecord : Integer;
var
  i: Integer;
  found : Boolean;
begin
  try
    Found := False;
    for i := 0 to Self.Controller.SelectedRecordCount - 1 do
    begin
      if Self.Controller.SelectedRecords[i] <> nil then
      begin
        found := True;
        Break;
      end;
    end;
    if found then
      Result := i
    else
      Result := -1;
  except
    Result := -1;
  end;
end;

procedure TbfaGridDBTableView.DoMouseUp(
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  LastRec, LastActRec, i, idx : Integer;
  bUp, found, colsized : Boolean;
begin
  if (Button = mbRight) or
     (Self.DataController.DataSource = nil) or
     (Self.DataController.DataSource.DataSet = nil) or
     (not Self.DataController.DataSource.DataSet.Active)
  then
    Exit;

  FDelayTimer.Enabled:= False;
  LastRec := Self.DataController.DataSource.DataSet.RecNo - 1;
//  if ssShift in Shift then
//  begin
//    LastActRec := FActRec;
//    Self.DataController.DataSource.DataSet.DisableControls;
////19.04.2022    Self.DataController.DataSource.DataSet.RecNo := FActRec + 1;
//    if FActRec <> LastRec then
//    begin
//      bUp := FActRec > LastRec;
////19.04.2022      if bUp then
////      begin
////        FActRec := Self.Controller.SelectedRecords[0].RecordIndex ;
////        Self.DataController.DataSource.DataSet.RecNo := LastActRec + 1;
////      end
////      else begin
////        FActRec := Self.Controller.FocusedRecord.RecordIndex;
////        Self.DataController.DataSource.DataSet.RecNo := LastActRec + 1;
////      end;
//      FDelayTimer.Enabled:= True;
//    end;
////19.04.2022    Self.Controller.FocusedRecord.Selected := True;
//    Self.DataController.DataSource.DataSet.EnableControls;
//  end
//  else if ssCtrl in Shift then begin
  if (ssCtrl in Shift) or (ssShift in Shift) then
  begin
    Self.DataController.DataSource.DataSet.DisableControls;
    if Self.Controller.FocusedRecord.Selected then begin
     Self.DataController.DataSource.DataSet.RecNo := LastRec + 1;
     Self.Controller.FocusedRecord.Selected := True;
     if (ssShift in Shift) then
     begin
       for i := 0 to Self.Controller.SelectedRecordCount - 1 do
       begin
         if (TcxGridGroupRow(Self.Controller.SelectedRecords[i]) = nil) or
            (not TcxGridGroupRow(Self.Controller.SelectedRecords[i]).isData) then
           Continue;
         found := FActRec = Self.Controller.SelectedRecords[i].RecordIndex;
         if found then
           Break;
       end;
       if not found then
       begin
         FActRec := Self.DataController.DataSource.DataSet.RecNo - 1;
         FDelayTimer.Enabled:= True;
       end;
     end;
    end
    else begin
      if LastRec = FActRec then begin
        if Self.Controller.SelectedRecordCount < 1 then
          Self.Controller.FocusedRecord.Selected := True
        else begin
          idx := GetFirstSelectedRecord;
          Self.DataController.DataSource.DataSet.RecNo :=
            Self.Controller.SelectedRecords[idx].RecordIndex + 1;
          FActRec := Self.Controller.SelectedRecords[idx].RecordIndex;
          FDelayTimer.Enabled:= True;
        end;
      end else
        Self.DataController.DataSource.DataSet.RecNo := FActRec + 1;
    end;
    Self.DataController.DataSource.DataSet.EnableControls;
  end
  else if Shift = [] then begin
//13.07.2022 Ticket 31271   if Self.DataController.IsGridMode or Self.Controller.FocusedRecord.Selected then
    if Self.OptionsView.GroupByBox
      or ((Self.Controller.FocusedRecord <> nil) and Self.Controller.FocusedRecord.Selected) then
    begin
      if (LastRec <> FActRec) or FIsSelectionChanged then
        FDelayTimer.Enabled:= True;
      FActRec := Self.DataController.DataSource.DataSet.RecNo - 1;
    end;
  end;
end;

procedure TbfaGridDBTableView.DoGroupRowExpanded(//Sender: TcxGridTableView;
  AGroup: TcxGridGroupRow);
begin
//08.04.2022  if Self.Controller.SelectedRecordCount = 0 then
//    Self.Controller.FocusNextRecordWithSelection(AGroup.Index, True, False, True);
end;

//procedure TbfaGridDBTableView.DoFocusedRecordChanged(
//  APrevFocusedRecordIndex, AFocusedRecordIndex,
//  APrevFocusedDataRecordIndex, AFocusedDataRecordIndex: Integer;
//  ANewItemRecordFocusingChanged: Boolean);
//begin
////  if AFocusedRecord.IsData then
////  begin
////  end
////  else
////  begin
////  end;
//end;

procedure TbfaGridDBTableView.SetBookmark;
begin
  if (Self.DataController.DataSource = nil) or
     (Self.DataController.DataSource.DataSet = nil) or
     (not Self.DataController.DataSource.DataSet.Active)
  then
    Exit;
  FActRec := Self.DataController.DataSource.DataSet.RecNo - 1;
end;

procedure TbfaGridDBTableView.DataChanged(Sender: TObject);
begin
  if (Self.DataController = nil) or (Self.DataController.DataSource = nil) or
     (Self.DataController.DataSource.DataSet = nil) or
     (not Self.DataController.DataSource.DataSet.Active) or
     (Self.DataController.DataSource.DataSet.RecordCount < 1)
  then
    Self.TabStop := False
  else
    Self.TabStop := True;
end;

procedure TbfaGridDBTableView.DoCustomDrawColumnHeader(
  Sender: TcxGridTableView; ACanvas: TcxCanvas;
  AViewInfo: TcxGridColumnHeaderViewInfo; var ADone: Boolean);
const
  States: array[TcxGridCellState] of TcxButtonState = (cxbsNormal, cxbsHot, cxbsPressed);
var
  AFilterRect, ASortRect, ASortOrderRect, ATextRect, ARect: TRect;
  I: Integer;
  AFilterButtonState: TcxButtonState;
  DC: HDC;
  lf: LOGFONT;
  hf: HFONT;
  AText: string;
  AHeaderPainter: TcxGridColumnHeaderPainterAccess;
begin
  ADone := True;

  with TcxGridColumnHeaderViewInfoAccess(AviewInfo) do
  begin
    ATextRect := TextAreaBounds;
    for I := 0 to AreaViewInfoCount - 1 do
    begin
      if AreaViewInfos[I] is TcxGridColumnHeaderSortingMarkViewInfo then
      begin
        AText := IntToStr(Column.SortIndex + 1);
        ASortRect := AreaViewInfos[I].Bounds;
        ASortOrderRect := ASortRect;
        ASortOrderRect.Top := ASortOrderRect.Top + Ord(IsPressed) - 3;
        ASortOrderRect.Right := ASortRect.Left - 1;
        ASortOrderRect.Left := ASortOrderRect.Right - ACanvas.TextWidth(AText);
        ASortRect.Bottom := ASortRect.Bottom + Ord(IsPressed);
      end;
    end;
    ATextRect.Right := ASortOrderRect.Left - 2;
    ACanvas.Font.Color := Self.Styles.Header.Font.Color;

    //11.11.2021 --> wegen NativeStyle True! wenn alles auf Devexpress umgesetzt wird muss hier berprfen!!!
    Params.Color := Self.Styles.Header.Color;
    ACanvas.Brush.Color := Params.Color;

    cxLookAndFeelPaintersManager.GetPainter(lfsUltraFlat).DrawHeader(ACanvas, Bounds, ATextRect,
        Neighbors, [], States[State], Column.HeaderAlignmentHorz, Column.HeaderGlyphAlignmentVert, False, True,
        AViewInfo.Text, ACanvas.Font, ACanvas.Font.Color, Params.Color);

    ACanvas.DrawComplexFrame(Bounds, ctlGeneral.Style.BorderColor, ctlGeneral.Style.BorderColor,
      [bRight], 1); //31.08.2022 Column Borders, sonst bleibt immer schwarz
    ACanvas.DrawComplexFrame(Bounds, ctlGeneral.Style.BorderColor, ctlGeneral.Style.BorderColor,
      [bBottom], 2); //31.08.2022 Column Borders, unten 2 Pixel damit man besser unterscheiden kann vom ColumnHeader

    cxLookAndFeelPaintersManager.GetPainter(lfsUltraFlat).DrawSortingMark(ACanvas, ASortRect, Column.SortOrder = soAscending);

    //11.11.2021 Column Header -->
    AHeaderPainter := TcxGridColumnHeaderPainterAccess.Create(ACanvas, AViewInfo);
    try
      AHeaderPainter.DrawAreas;
    finally
      AHeaderPainter.Free;
    end;
    //11.11.2021 Column Header <--

    //11.11.2021    if (Self.SortedItemCount > 1) then //wenn mehr als 1 Spalter sortiert ist muss das index auch angezeigt werden
    if (Self.SortedItemCount > 1) and (Column.Sortindex > -1) then
    begin
      ACanvas.Brush.Color := Params.Color;
      DC := ACanvas.Handle;
      GetObject(ACanvas.Font.Handle, SizeOf(lf), @lf);
      StrPCopy(LF.lfFaceName, ACanvas.Font.Name);
      lf.lfHeight := -MulDiv(ACanvas.Font.Size, GetDeviceCaps(DC, LOGPIXELSY), 72);
      hf := SelectObject(DC, CreateFontIndirect(lf));
      try
        ExtTextOut(DC, ASortOrderRect.Left, ASortOrderRect.Top, ETO_CLIPPED, @Bounds, PChar(AText), Length(AText), nil);
      finally
        DeleteObject(SelectObject(DC, hf));
      end;
    end;
    ADone := True;
  end;
end;

procedure TbfaGridSite.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  try
    if (Button = mbRight) then
    begin
      FocusOnClick := False;
      try
        inherited MouseDown(Button, Shift, X, Y);
      finally
        FocusOnClick := True;
      end;
    end
    else
      inherited MouseDown(Button, Shift, X, Y);
  except
    //
  end;
end;

function TbfaGridTableViewInfo.GetSiteClass: TcxGridSiteClass;
begin
  Result := TbfaGridSite;
end;

function TbfaGridDBTableView.GetViewInfoClass: TcxCustomGridViewInfoClass;
begin
  Result := TbfaGridTableViewInfo;
end;

function TbfaGridDBTableView.GetViewDataClass: TcxCustomGridViewDataClass;
begin
  result := TbfaGridViewData;
end;

function TbfaGridViewData.GetRecordClass(const ARecordInfo: TcxRowInfo): TcxCustomGridRecordClass;
begin
  if ARecordInfo.Level < DataController.Groups.GroupingItemCount then
    Result := TcxGridGroupRow
  else
    if GridView.IsMaster then
      Result := TbfaGridMasterDataRow
    else
      Result := TbfaGridDataRow;
end;

function TbfaGridDataRow.GetViewInfoClass: TcxCustomGridRecordViewInfoClass;
begin
  Result := TbfaGridDataRowViewInfo;
end;

function TbfaGridDataRowViewInfo.Click(AHitTest: TcxCustomGridHitTest; AButton: TMouseButton;
  AShift: TShiftState): boolean;
begin
  Result := AButton = mbRight;
  if not Result then
    Result := inherited Click(AHitTest, AButton, AShift);
end;

function TbfaGridMasterDataRow.GetViewInfoClass: TcxCustomGridRecordViewInfoClass;
begin
  Result := TbfaGridMasterDataRowViewInfo;
end;

function TbfaGridMasterDataRowViewInfo.Click(
  AHitTest: TcxCustomGridHitTest; AButton: TMouseButton;
  AShift: TShiftState): Boolean;
begin
  Result := AButton = mbRight;
  if not Result then
    Result := inherited Click(AHitTest, AButton, AShift)
end;

function TbfaGridDBTableSummaryItem.GetValueFormat(
  AValueType: TcxSummaryValueType; const AValue: Variant;
  AIsFooter: Boolean): string;
begin
  if (Self.Column.Properties <> nil) then
    Result := TcxCustomTextEditProperties(Self.Column.Properties).DisplayFormat
  else
    Result := inherited GetValueFormat(AValueType, AValue, AIsFooter);
end;

function TbfaGridDBTableView.GetSummaryItemClass: TcxDataSummaryItemClass;
begin
  Result := TbfaGridDBTableSummaryItem;
end;

procedure TbfaGridIndicatorAccess.DropDown;
begin
  inherited;
end;

end.

