unit u_bfaTlbPreview;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes,
  SpTBXEditors, SpTBXItem, TB2Item, TB2Dock, TB2Toolbar;

type
  TbfaTlbPreview = class(TSpTBXToolbar)
    mnuPreviousPage: TSpTBXItem;
    bfaTlbPreviewLabelPage: TSpTBXLabelItem;
    tlbPreviewControlItem1: TTBControlItem;
//30.08.2022    edtPageNumber: TSpTBXEditItem;
    edtPageNumber: TSpTBXEdit;
    mnuNextPage: TSpTBXItem;
    bfaTlbPreviewSeparatorItem1: TTBSeparatorItem;
    bfaTlbPreviewLabelPageCount: TSpTBXLabelItem;
    tlbPreviewControlItem2: TTBControlItem;
    sbmAutozoom: TSpTBXSubmenuItem;
    mnuZoom100: TSpTBXItem;
    mnuZoomPage: TSpTBXItem;
    mnuZoomWidth: TSpTBXItem;
    mnuZoomHeight: TSpTBXItem;
    mnuZoomSelect: TSpTBXItem;
    mnuZoomOff: TSpTBXItem;
    mnuPublicAnno: TSpTBXItem;
    mnuPrivateAnno: TSpTBXSubmenuItem;
    mnuStationery: TSpTBXItem;
    sbmStationery: TSpTBXSubmenuItem;
    mnuFtxPos: TSpTBXItem;
    cbxZoom: TSpTBXComboBox;

  private
    { Private-Deklarationen }
  procedure OnAutozoomClick(Sender: TObject);
  procedure NoDblClickOnPageChange(Sender: Tobject);

  public
     constructor Create(AOwner: TComponent); override;
     procedure CreateComponents;
    { Public-Deklarationen }
  end;

implementation

uses
  gnugettext, bfaCommonUtils;

{ TbfaTlbPreview }

constructor TbfaTlbPreview.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
end;

procedure TbfaTlbPreview.OnAutozoomClick(Sender: TObject);
var
  sbmi: TSpTBXSubmenuItem;

begin
  sbmi := TSpTBXSubmenuItem(Sender);

  case sbmi.ImageIndex of
    Integer(icoidx_preview_original):
    begin
      if mnuZoom100.Enabled then
        mnuZoom100.Click;
    end;

    Integer(icoidx_preview_auto):
    begin
      if mnuZoomPage.Enabled then
        mnuZoomPage.Click;
    end;

    Integer(icoidx_preview_width):
    begin
      if mnuZoomWidth.Enabled then
        mnuZoomWidth.Click;
    end;

    Integer(icoidx_select):
    begin
      if mnuZoomSelect.Enabled then
        mnuZoomSelect.Click;
    end;

    Integer(icoidx_preview_no_autozoom):
    begin
      if mnuZoomOff.Enabled then
        mnuZoomOff.Click;
    end;

    Integer(icoidx_preview_height):
    begin
      if mnuZoomHeight.Enabled then
        mnuZoomHeight.Click;
    end;
  end;
end;

procedure TbfaTlbPreview.CreateComponents;
begin
  Self.ShrinkMode := tbsmNone;
  mnuPreviousPage := TSpTBXItem.Create(Self);
  mnuPreviousPage.OnDblClick := NoDblClickOnPageChange;
  mnuPreviousPage.Alignment := taLeftJustify;
  bfaTlbPreviewLabelPage := TSpTBXLabelItem.Create(Self);
  bfaTlbPreviewLabelPage.FontSettings.Size := bfaFontSettingsSize; //10.09.2020
  bfaTlbPreviewLabelPage.Options := [tboNoAutoHint];
//30.08.2022  edtPageNumber := TSpTBXEditItem.Create(Self);
  tlbPreviewControlItem1 := TTBControlItem.Create(Self);
//30.08.2022  edtPageNumber.FontSettings.Size := bfaFontSettingsSize; //10.09.2020
  mnuNextPage := TSpTBXItem.Create(Self);
  mnuNextPage.OnDblClick := NoDblClickOnPageChange;
  bfaTlbPreviewSeparatorItem1 := TTBSeparatorItem.Create(Self);
  bfaTlbPreviewLabelPageCount := TSpTBXLabelItem.Create(Self);
  bfaTlbPreviewLabelPageCount.FontSettings.Size := bfaFontSettingsSize; //10.09.2020
//  bfaTlbPreviewLabelPageCount.Caption := _('von') + ' ' + IntToStr(0) + ' ';
  bfaTlbPreviewLabelPageCount.Caption := Format(_('von %s '), [IntToStr(0)]);
  bfaTlbPreviewLabelPageCount.Options := [tboNoAutoHint];
  tlbPreviewControlItem2 := TTBControlItem.Create(Self);
  sbmAutozoom := TSpTBXSubmenuItem.Create(Self);
  sbmAutozoom.DropdownCombo := True;
  mnuZoom100 := TSpTBXItem.Create(Self);
  mnuZoomPage := TSpTBXItem.Create(Self);
  mnuZoomWidth := TSpTBXItem.Create(Self);
  mnuZoomHeight := TSpTBXItem.Create(Self);
  mnuZoomSelect := TSpTBXItem.Create(Self);
  mnuZoomOff := TSpTBXItem.Create(Self);
  mnuPublicAnno := TSpTBXItem.Create(Self);
  mnuPrivateAnno := TSpTBXSubmenuItem.Create(Self);
  mnuPrivateAnno.DropdownCombo := True;
  mnuPrivateAnno.HideEmptyPopup := True;
  mnuStationery := TSpTBXItem.Create(Self);
  sbmStationery := TSpTBXSubmenuItem.Create(Self);
  sbmStationery.Visible := False;
  sbmStationery.DropdownCombo := True;
  sbmStationery.HideEmptyPopup := True;
  mnuFtxPos := TSpTBXItem.Create(Self);


  Self.Items.Add(mnuPreviousPage);
  Self.Items.Add(bfaTlbPreviewLabelPage);
  edtPageNumber := TSpTBXEdit.Create(tlbPreviewControlItem1);
  edtPageNumber.TabStop := False;
  edtPageNumber.Parent := Self;

//30.08.2022  edtPageNumber.CustomWidth := 35;
  edtPageNumber.Width := 35;
//30.08.2022  Self.Items.Add(edtPageNumber);
  Self.Items.Add(bfaTlbPreviewLabelPageCount);
  Self.Items.Add(mnuNextPage);
  Self.Items.Add(bfaTlbPreviewSeparatorItem1);
  cbxZoom := TSpTBXComboBox.Create(tlbPreviewControlItem2);
  cbxZoom.TabStop := False;
  cbxZoom.Parent := Self;
//  cbxZoom.Width := 100; // 29.07.2021 - bfacrm:ticket__show__28089
  cbxZoom.Width := 85;
  cbxZoom.Items.Add('1,00 %');    //13.06.2024 SD <--bfacrm:ticket__show__39017
  cbxZoom.Items.Add('10,00 %');
  cbxZoom.Items.Add('12,50 %');
  cbxZoom.Items.Add('15,00 %');
  cbxZoom.Items.Add('20,00 %');
  cbxZoom.Items.Add('25,00 %');
  cbxZoom.Items.Add('50,00 %');
  cbxZoom.Items.Add('75,00 %');
  cbxZoom.Items.Add('100,00 %');
  cbxZoom.Items.Add('125,00 %');
  cbxZoom.Items.Add('150,00 %');
  cbxZoom.Items.Add('200,00 %');
  cbxZoom.Items.Add('300,00 %');
  cbxZoom.Items.Add('400,00 %');
  cbxZoom.Items.Add('600,00 %');
  cbxZoom.Hint := _('Zoomfaktor');

  Self.Items.Add(sbmAutozoom);
  sbmAutozoom.Add(mnuZoom100);
  sbmAutozoom.Add(mnuZoomPage);
  sbmAutozoom.Add(mnuZoomWidth);
  sbmAutozoom.Add(mnuZoomHeight);
  sbmAutozoom.Add(mnuZoomSelect);
  sbmAutozoom.Add(mnuZoomOff);
  Self.Items.Add(mnuPublicAnno);
  Self.Items.Add(mnuPrivateAnno);
  Self.Items.Add(mnuStationery);
  Self.Items.Add(sbmStationery);
  Self.Items.Add(mnuFtxPos);

  bfaTlbPreviewLabelPage.Caption := _('Seite:');

  sbmAutozoom.ImageIndex := -1; // 24.09.2020 Integer(icoidx_preview_width);
  sbmAutozoom.Options := [tboDropdownArrow];
  sbmAutozoom.OnClick := OnAutozoomClick;

  tlbPreviewControlItem1.Control := edtPageNumber;
  tlbPreviewControlItem2.Control := cbxZoom;
//16.09.2024  TranslateComponent(Self, sSysGnuViewerDomain);
  TranslateComponent(Self, 'Shared36');
end;

procedure TbfaTlbPreview.NoDblClickOnPageChange(Sender: Tobject);
begin
  // verhindert den falschen Seitenwechsel bei Doppelklick auf die Seiten-Pfeile.
  // absichtlich leer - Event muss nur zugewiesen sein...
end;

end.
