unit u_bfaTlbStandard;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes,
  TB2Item, SpTBXItem, TB2Dock, TB2Toolbar;

type
  TbfaTlbStandard = class(TSpTBXToolbar)
    tlbStandardSubmenuItemSave,
    tlbStandardSubmenuItemEmail,
    tlbStandardSubmenuItemPrint,
    tlbStandardSubmenuItemClipboard
    : TSpTBXSubmenuItem;
    tlbStandardSubmenuItemSaveTIF,
    tlbStandardSubmenuItemSavePDF,
    tlbStandardSubmenuItemSaveOriginal,
    tlbStandardSubmenuItemSaveLink,
    tlbStandardSubmenuItemSavePreview,
    tlbStandardSubmenuItemEmailPDF,
    tlbStandardSubmenuItemEmailTIF,
    tlbStandardSubmenuItemEmailOriginal,
    tlbStandardSubmenuItemEmailLink,
    tlbStandardSubmenuItemEmailPreview,
    tlbStandardSubmenuItemPrintStandard,
    tlbStandardSubmenuItemPrintPreview,
    tlbStandardSubmenuItemClipboardDoc,
    tlbStandardSubmenuItemClipboardOriginalDoc,
    tlbStandardSubmenuItemClipboardPage,
    tlbStandardSubmenuItemClipboardLink
    : TSpTBXItem;
    tlbStandardSeparatorItem1: TTBSeparatorItem;
    tlbStandardRotateLeft: TSpTBXItem;
    tlbStandardFlip: TSpTBXItem;
    tlbStandardRotateRight: TSpTBXItem;
    tlbStandardSeparatorItem2: TTBSeparatorItem;
    tlbStandardEditTags: TSpTBXItem;
    tlbStandardAutoRef: TSpTBXItem;
    tlbStandardNewLink: TSpTBXItem;
    tlbStandardAddLink: TSpTBXItem;
    tlbStandardSeparatorItem3: TTBSeparatorItem;
    tlbStandardSeparatorItem4: TTBSeparatorItem;
    tlbStandardDeletePage: TSpTBXItem;
    tlbStandardSeparatorItem6: TTBSeparatorItem;
    tlbStandardSave: TSpTBXItem;
    tlbStandardCancel: TSpTBXItem;
    tlbStandardTreeView: TSpTBXItem;
    tlbStandardSearchOptions: TSpTBXItem;
    tlbStandardThumbnail: TSpTBXItem;
    tlbStandardFloatingWVL: TSpTBXItem;
    tlbStandardSeparatorItem5: TTBSeparatorItem;
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
     constructor Create(AOwner: TComponent); override;
     procedure CreateComponents;
     procedure ShowSaveButtons;
     procedure HideSaveButtons;
  end;


implementation

uses gnugettext, bfaCommonUtils;

{ TbfaStandardToolbar }

constructor TbfaTlbStandard.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
end;

procedure TbfaTlbStandard.CreateComponents;
begin
  tlbStandardSave := TSpTBXItem.Create(Self);
  tlbStandardCancel := TSpTBXItem.Create(Self);
  tlbStandardSeparatorItem4 := TTBSeparatorItem.Create(Self);

  tlbStandardTreeView := TSpTBXItem.Create(Self);
  tlbStandardSearchOptions := TSpTBXItem.Create(Self);
  tlbStandardThumbnail := TSpTBXItem.Create(Self);
  tlbStandardFloatingWVL := TSpTBXItem.Create(Self);
  tlbStandardSeparatorItem5 := TTBSeparatorItem.Create(Self);
  tlbStandardSubmenuItemSave := TSpTBXSubmenuItem.Create(Self);
  tlbStandardSubmenuItemSave.DropdownCombo := True;
  tlbStandardSubmenuItemEmail := TSpTBXSubmenuItem.Create(Self);
  tlbStandardSubmenuItemEmail.DropdownCombo := True;
  tlbStandardSubmenuItemPrint := TSpTBXSubmenuItem.Create(Self);
  tlbStandardSubmenuItemPrint.DropdownCombo := True;
  tlbStandardSubmenuItemClipboard := TSpTBXSubmenuItem.Create(Self);
  tlbStandardSubmenuItemClipboard.DropdownCombo := True;
  tlbStandardSeparatorItem1 := TTBSeparatorItem.Create(Self);
  tlbStandardRotateLeft := TSpTBXItem.Create(Self);
  tlbStandardFlip := TSpTBXItem.Create(Self);
  tlbStandardRotateRight := TSpTBXItem.Create(Self);
  tlbStandardSeparatorItem2 := TTBSeparatorItem.Create(Self);
  tlbStandardEditTags := TSpTBXItem.Create(Self);
  tlbStandardAutoRef := TSpTBXItem.Create(Self);
  tlbStandardNewLink := TSpTBXItem.Create(Self);
  tlbStandardAddLink := TSpTBXItem.Create(Self);
  tlbStandardSeparatorItem3 := TTBSeparatorItem.Create(Self);

  tlbStandardDeletePage := TSpTBXItem.Create(Self);
  tlbStandardSeparatorItem6 := TTBSeparatorItem.Create(Self);
  tlbStandardSubmenuItemSaveTIF := TSpTBXItem.Create(Self);
  tlbStandardSubmenuItemSavePDF := TSpTBXItem.Create(Self);
  tlbStandardSubmenuItemSaveOriginal := TSpTBXItem.Create(Self);
  tlbStandardSubmenuItemSaveLink := TSpTBXItem.Create(Self);
  tlbStandardSubmenuItemSavePreview := TSpTBXItem.Create(Self);
  tlbStandardSubmenuItemEmailPDF := TSpTBXItem.Create(Self);
  tlbStandardSubmenuItemEmailTIF := TSpTBXItem.Create(Self);
  tlbStandardSubmenuItemEmailOriginal := TSpTBXItem.Create(Self);
  tlbStandardSubmenuItemEmailLink := TSpTBXItem.Create(Self);
  tlbStandardSubmenuItemEmailPreview := TSpTBXItem.Create(Self);
  tlbStandardSubmenuItemPrintStandard := TSpTBXItem.Create(Self);
  tlbStandardSubmenuItemPrintPreview := TSpTBXItem.Create(Self);
  tlbStandardSubmenuItemClipboardDoc := TSpTBXItem.Create(Self);
  tlbStandardSubmenuItemClipboardOriginalDoc := TSpTBXItem.Create(Self);
  tlbStandardSubmenuItemClipboardPage := TSpTBXItem.Create(Self);
  tlbStandardSubmenuItemClipboardLink := TSpTBXItem.Create(Self);
  Self.Items.Add(tlbStandardSave);
  Self.Items.Add(tlbStandardCancel);
  Self.Items.Add(tlbStandardSeparatorItem4);
  Self.Items.Add(tlbStandardTreeView);
  Self.Items.Add(tlbStandardSearchOptions);
  Self.Items.Add(tlbStandardThumbnail);
  Self.Items.Add(tlbStandardFloatingWVL);
  Self.Items.Add(tlbStandardSeparatorItem5);
  Self.Items.Add(tlbStandardSubmenuItemSave);
  Self.Items.Add(tlbStandardSubmenuItemEmail);
  Self.Items.Add(tlbStandardSubmenuItemPrint);
  Self.Items.Add(tlbStandardSubmenuItemClipboard);
  Self.Items.Add(tlbStandardSeparatorItem1);
  Self.Items.Add(tlbStandardRotateLeft);
  Self.Items.Add(tlbStandardFlip);
  Self.Items.Add(tlbStandardRotateRight);
  Self.Items.Add(tlbStandardSeparatorItem2);
  Self.Items.Add(tlbStandardEditTags);
  Self.Items.Add(tlbStandardAutoRef);
  Self.Items.Add(tlbStandardNewLink);
  Self.Items.Add(tlbStandardAddLink);
  Self.Items.Add(tlbStandardSeparatorItem3);
  Self.Items.Add(tlbStandardDeletePage);
  Self.Items.Add(tlbStandardSeparatorItem6);
  tlbStandardSubmenuItemSave.LinkSubitems := TTBCustomItem.Create(nil);
  tlbStandardSubmenuItemSave.LinkSubitems.Add(tlbStandardSubmenuItemSaveTIF);
  tlbStandardSubmenuItemSave.LinkSubitems.Add(tlbStandardSubmenuItemSavePDF);
  tlbStandardSubmenuItemSave.LinkSubitems.Add(tlbStandardSubmenuItemSaveOriginal);
  tlbStandardSubmenuItemSave.LinkSubitems.Add(tlbStandardSubmenuItemSaveLink);
  tlbStandardSubmenuItemSave.LinkSubitems.Add(tlbStandardSubmenuItemSavePreview);
  tlbStandardSubmenuItemEmail.LinkSubitems := TTBCustomItem.Create(nil);
  tlbStandardSubmenuItemEmail.LinkSubitems.Add(tlbStandardSubmenuItemEmailTIF); //13.09.2024 SD -->bfacrm:ticket__show__39948 Der Menpunkt TIF muss der erste sein
  tlbStandardSubmenuItemEmail.LinkSubitems.Add(tlbStandardSubmenuItemEmailPDF);
  tlbStandardSubmenuItemEmail.LinkSubitems.Add(tlbStandardSubmenuItemEmailOriginal);
  tlbStandardSubmenuItemEmail.LinkSubitems.Add(tlbStandardSubmenuItemEmailLink);
  tlbStandardSubmenuItemEmail.LinkSubitems.Add(tlbStandardSubmenuItemEmailPreview);
  tlbStandardSubmenuItemPrint.LinkSubitems := TTBCustomItem.Create(nil);
  tlbStandardSubmenuItemPrint.LinkSubitems.Add(tlbStandardSubmenuItemPrintStandard);
  tlbStandardSubmenuItemPrint.LinkSubitems.Add(tlbStandardSubmenuItemPrintPreview);
  tlbStandardSubmenuItemClipboard.LinkSubitems := TTBCustomItem.Create(nil);
  tlbStandardSubmenuItemClipboard.LinkSubitems.Add(tlbStandardSubmenuItemClipboardDoc);
  tlbStandardSubmenuItemClipboard.LinkSubitems.Add(tlbStandardSubmenuItemClipboardOriginalDoc);
  tlbStandardSubmenuItemClipboard.LinkSubitems.Add(tlbStandardSubmenuItemClipboardPage);
  tlbStandardSubmenuItemClipboard.LinkSubitems.Add(tlbStandardSubmenuItemClipboardLink);
  
  TranslateComponent(Self, sSysGnuViewerDomain);

  tlbStandardSave.Visible := False;
  tlbStandardCancel.Visible := False;
  tlbStandardSeparatorItem4.Visible := False;
  tlbStandardSave.Enabled := False;
  tlbStandardCancel.Enabled := False;
end;

procedure TbfaTlbStandard.HideSaveButtons;
begin
  if tlbStandardSave.Visible then
  begin
    if not tlbStandardSave.Enabled then
    begin
      tlbStandardSave.Visible := False;
      tlbStandardCancel.Visible := False;
      tlbStandardSeparatorItem4.Visible := False;
      tlbStandardSave.Enabled := False;
      tlbStandardCancel.Enabled := False;
    end;
  end;
end;

procedure TbfaTlbStandard.ShowSaveButtons;
begin
  if not tlbStandardSave.Visible then
  begin
    tlbStandardSave.Visible := True;
    tlbStandardCancel.Visible := True;
    tlbStandardSeparatorItem4.Visible := True;
    tlbStandardSave.Enabled := False;
    tlbStandardCancel.Enabled := False;
  end;
end;

end.
