unit AddGlobalBookmarkFolder;

interface

uses
  gnugettext, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SpTBXItem, SpTBXControls, bfaIconsDM, StdCtrls, SpTBXEditors, ComCtrls;

type
  TfrmAddGlobalBookmarkFolder = class(TForm)
    btnOk: TSpTBXSpeedButton;
    btnCancel: TSpTBXSpeedButton;
    SpTBXRadioGroup1: TSpTBXRadioGroup;
    edtName: TSpTBXEdit;
    SpTBXLabel2: TSpTBXLabel;
    SpTBXLabel1: TSpTBXLabel;
    cbbUser: TSpTBXComboBox;
    procedure SpTBXRadioGroup1Click(Sender: TObject);
    constructor Create(Sender: TObject; Node: TTreeNode); overload;
    procedure btnOkClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure cbbUserChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
    listuser, listgroup: TStringList;
  public
    { Public-Deklarationen }

  end;

var
  frmAddGlobalBookmarkFolder: TfrmAddGlobalBookmarkFolder;

implementation

uses
  {u_ShDbUtils,} BfaCommonDB, bfaObjects36;

{$R *.dfm}

procedure TfrmAddGlobalBookmarkFolder.btnCancelClick(Sender: TObject);
begin
  Self.ModalResult := mrCancel;
end;

procedure TfrmAddGlobalBookmarkFolder.btnOkClick(Sender: TObject);
begin
  Self.ModalResult := mrOk;
end;

procedure TfrmAddGlobalBookmarkFolder.cbbUserChange(Sender: TObject);
begin
  if SpTBXRadioGroup1.ItemIndex = 1 then
    edtName.Text := _('Lesezeichen fr Benutzer ') + cbbUser.Text
  else if SpTBXRadioGroup1.ItemIndex = 2 then
    edtName.Text := _('Lesezeichen fr Gruppe ') + cbbUser.Text;
end;

constructor TfrmAddGlobalBookmarkFolder.Create(Sender: TObject; Node: TTreeNode);
var
  i, idx : Integer;
  userid, groupid : Int64;
begin
  inherited Create(nil);
  SpTBXRadioGroup1.ItemIndex := 0;
  listuser := DBGetUserList(0,0, True, True, False, True);
  listuser.Sort;
  listgroup := DBGetGrouplist(0,0, True, True, True);
  listgroup.Sort;

  for i := 0 to Node.Count -1 do
  begin
    userid :=  TbfaNodeInfo(Node[i].Data).Userid;
    groupid :=  TbfaNodeInfo(Node[i].Data).groupid;

    if (userid = 0) and (groupid = 0) then
    begin
      SpTBXRadioGroup1.ItemIndex := 1;
      SpTBXRadioGroup1.Buttons[0].Enabled := False;
    end;
    if userid <> 0  then
    begin
      idx := listuser.IndexOfObject(TObject(userid));
      if (idx >= 0) and (idx <= listuser.Count - 1 )then //28.09.2017 kann -1 auch sein
        listuser.Delete(idx);
    end;
    if groupid <> 0  then
    begin
      idx := listgroup.IndexOfObject(TObject(groupid));
      if (idx >= 0) and (idx <= listgroup.Count - 1 )then //28.09.2017 kann -1 auch sein
        listgroup.Delete(idx);
    end;
  end;
end;

procedure TfrmAddGlobalBookmarkFolder.FormCreate(Sender: TObject);
begin
  TranslateComponent(Self, 'ViewerV36');
end;

procedure TfrmAddGlobalBookmarkFolder.SpTBXRadioGroup1Click(Sender: TObject);
var
  i: Integer;
begin
  //OutputDebugString('SpTBXRadioGroup1Click');

  if SpTBXRadioGroup1.ItemIndex = 0 then
  begin
    cbbUser.Enabled := False;
    edtName.Text := _('Lesezeichen fr alle Benutzer');
  end else if SpTBXRadioGroup1.ItemIndex = 1 then
  begin
    cbbUser.Items.Clear;
    for i := 0 to listuser.Count -1 do
      cbbUser.AddItem(listuser[i],listuser.Objects[i]);

    cbbUser.Enabled := True;
    cbbUser.ItemIndex := -1;
    edtName.Text := '';
    cbbUser.Text := '';
  end else if SpTBXRadioGroup1.ItemIndex = 2 then
  begin
    cbbUser.Items.Clear;
    for i := 0 to listgroup.Count -1 do
      cbbUser.AddItem(listgroup[i],listgroup.Objects[i]);

    cbbUser.Enabled := True;
    cbbUser.ItemIndex := -1;
    edtName.Text := '';
    cbbUser.Text := '';
  end;

end;

end.

