unit ContractMgmt;

interface

uses
  gnugettext, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SpTBXControls, SpTBXEditors, StdCtrls, SpTBXItem;


type
  TfrmContractMgmt = class(TForm)
    SpTBXPanel1: TSpTBXPanel;
    SpTBXLabel1: TSpTBXLabel;
    SpTBXLabel2: TSpTBXLabel;
    SpTBXLabel3: TSpTBXLabel;
    SpTBXLabel4: TSpTBXLabel;
    SpTBXLabel5: TSpTBXLabel;
    SpTBXLabel6: TSpTBXLabel;
    SpTBXLabel7: TSpTBXLabel;
    edt_name: TSpTBXButtonEdit;
    cbx_start: TSpTBXComboBox;
    cbx_interval: TSpTBXComboBox;
    cbx_end: TSpTBXComboBox;
    cbx_lastactivated: TSpTBXComboBox;
    cbx_notice: TSpTBXComboBox;
    edt_offset: TSpTBXSpinEdit;
    btnOK: TSpTBXButton;
    btnCancel: TSpTBXButton;
    SpTBXLabel8: TSpTBXLabel;
    cbx_archive: TSpTBXComboBox;
    procedure edt_nameSubEditButton0Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    fname, fdir : String;

    procedure ClearFields;
  end;


implementation

{$R *.dfm}

uses
  IniFiles, MainDataModule, bfaObjects36, bfaCommonUtils, bfaCommonDialogs;

procedure TfrmContractMgmt.ClearFields;
begin
  edt_name.Text := '';
  cbx_archive.ItemIndex := -1;
  cbx_start.ItemIndex := -1;
  cbx_end.ItemIndex := -1;
  cbx_lastactivated.ItemIndex := -1;
  cbx_interval.ItemIndex := -1;
  cbx_notice.ItemIndex := -1;
  edt_offset.Text := '0';
  edt_offset.Value := 0;
end;

procedure TfrmContractMgmt.edt_nameSubEditButton0Click(Sender: TObject);
var
  startfield, endfield, intervalfield, lastactivatedfield, noticefield: String;
  startdate, enddate, interval, lastactivated, kuendigung: String;
  ini : TIniFile;
  i, arcid, offset : Integer;
begin
  if PromptForFileName(fname, mwlFiletypes, fdir, _('Datei ffnen'), '', False) then
  begin
    ini := TIniFile.Create(fname);

    if not ini.SectionExists('Info') then
    begin
      BfShowMessage('Keine Konfiguration gefunden, Info Section fehlt');
      Exit;
    end;

    ClearFields;
    edt_name.Text := fname;


    if ini.ValueExists('Info','archivID') then
      arcid := ini.ReadInteger('Info','archivID', -1)
    else
      arcid := ini.ReadInteger('Info','archiveid', -1);
    if ini.ValueExists('Info','start') then
      startdate := ini.ReadString('Info','start', '')
    else
      startfield := ini.ReadString('Info','startfield', '');
    if ini.ValueExists('Info','end') then
      enddate := ini.ReadString('Info','end', '')
    else
      endfield := ini.ReadString('Info','endfield', '');
    if ini.ValueExists('Info','interval') then
      interval := ini.ReadString('Info','interval', '')
    else
      intervalfield := ini.ReadString('Info','intervalfield', '');
    if ini.ValueExists('Info','lasttimeactivated') then
      lastactivated := ini.ReadString('Info','lasttimeactivated', '')
    else
      lastactivatedfield := ini.ReadString('Info','lastactivatedfield', '');
    if ini.ValueExists('Info','kuendingung') then
      kuendigung := ini.ReadString('Info','kuendingung', '')
    else
      noticefield := ini.ReadString('Info','noticefield', '');
    if ini.ValueExists('Info','versatz') then
      offset := ini.ReadInteger('Info','versatz', 7)
    else
      offset := ini.ReadInteger('Info','offset', 7);

    for i := 0 to cbx_archive.Items.Count -1 do
    begin
      if TbfaArchive(cbx_archive.Items.Objects[i]).ID  = arcid then
      begin
        cbx_archive.ItemIndex := i;
        Break;
      end;
    end;
    for i := 0 to cbx_start.Items.Count -1 do
    begin
      if ((TbfaAddfield(cbx_start.Items.Objects[i]).Name  = startfield) and (startfield <> '')) or
         ((TbfaAddfield(cbx_start.Items.Objects[i]).DisplayName  = startdate) and (startdate <> ''))  then
      begin
        cbx_start.ItemIndex := i;
        Break;
      end;
    end;
    for i := 0 to cbx_interval.Items.Count -1 do
    begin
      if ((TbfaAddfield(cbx_interval.Items.Objects[i]).Name  = intervalfield) and (intervalfield <> '')) or
         ((TbfaAddfield(cbx_interval.Items.Objects[i]).DisplayName  = interval) and (interval <> ''))  then
      begin
        cbx_interval.ItemIndex := i;
        Break;
      end;
    end;
    for i := 0 to cbx_end.Items.Count -1 do
    begin
      if ((TbfaAddfield(cbx_end.Items.Objects[i]).Name = endfield) and (endfield <> '')) or
         ((TbfaAddfield(cbx_end.Items.Objects[i]).DisplayName  = enddate) and (enddate <> '')) then
      begin
        cbx_end.ItemIndex := i;
        Break;
      end;
    end;
    for i := 0 to cbx_lastactivated.Items.Count -1 do
    begin
      if ((TbfaAddfield(cbx_lastactivated.Items.Objects[i]).Name  = lastactivatedfield) and (lastactivatedfield <> '')) or
         ((TbfaAddfield(cbx_lastactivated.Items.Objects[i]).DisplayName  = lastactivated) and (lastactivated <> ''))  then
      begin
        cbx_lastactivated.ItemIndex := i;
        Break;
      end;
    end;
    for i := 0 to cbx_notice.Items.Count -1 do
    begin
      if ((TbfaAddfield(cbx_notice.Items.Objects[i]).Name  = noticefield) and (noticefield <> '')) or
         ((TbfaAddfield(cbx_notice.Items.Objects[i]).DisplayName  = kuendigung) and (kuendigung <> '')) then
      begin
        cbx_notice.ItemIndex := i;
        Break;
      end;
    end;
    edt_offset.Value := offset;
    edt_offset.Text := IntToStr(offset);

  end;

end;

end.
