unit CreateGlobalBookmark;

interface

uses
  gnugettext, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TB2Item, SpTBXItem, Menus, SpTBXControls, StdCtrls, SpTBXEditors,
  StrUtils, WideStrUtils, bfaBaseObjects, bfaObjects36, RegularExpressions,
  bfaCommonDB, MainDataModule, bfaApplication, bfaIconsDM, cxGraphics, ComCtrls,
  cxControls, cxLookAndFeels, cxLookAndFeelPainters, cxContainer, cxEdit,
  cxTextEdit, cxMaskEdit, cxDropDownEdit, dxBevel, System.Generics.Collections;

type
  TfrmCreateGlobalBookmark = class(TForm)
    popField: TSpTBXPopupMenu;
    tbiAddfield: TSpTBXItem;
    tbiStatefield: TSpTBXItem;
    tbiDocumentfields: TSpTBXItem;
    popNot: TSpTBXPopupMenu;
    tbiNOT: TSpTBXItem;
    tbiEmpty: TSpTBXItem;
    popOperator: TSpTBXPopupMenu;
    SpTBXItem2: TSpTBXItem;
    edtValue: TSpTBXEdit;
    popArchive: TSpTBXPopupMenu;
    tbiRepos: TSpTBXItem;
    tbiArchive: TSpTBXItem;
    popUser: TSpTBXPopupMenu;
    tbiUser: TSpTBXItem;
    tbiGroup: TSpTBXItem;
    popLimit: TSpTBXPopupMenu;
    tbiLimit1: TSpTBXItem;
    tbiLimit10: TSpTBXItem;
    tbiLimit50: TSpTBXItem;
    tbiLimit100: TSpTBXItem;
    tbiLimit500: TSpTBXItem;
    tbiLimit1000: TSpTBXItem;
    tbiLimit5000: TSpTBXItem;
    tbiLimitAll: TSpTBXItem;
    popDateFormat: TSpTBXPopupMenu;
    tbiDay: TSpTBXItem;
    tbiWeek: TSpTBXItem;
    tbiMonth: TSpTBXItem;
    tbiYear: TSpTBXItem;
    tbiDateNone: TSpTBXItem;
    tbiDate: TSpTBXItem;
    lblArcid: TSpTBXLabel;
    lblUserid: TSpTBXLabel;
    pnl1: TSpTBXPanel;
    SpTBXLabel2: TSpTBXLabel;
    cbxBookmark: TcxComboBox;
    dxBevel1: TdxBevel;
    SpTBXLabel1: TSpTBXLabel;
    edtName: TSpTBXEdit;
    btnArchive: TSpTBXButton;
    btnUser: TSpTBXButton;
    cbxArchive: TcxComboBox;
    cbxUser: TcxComboBox;
    chkMappedFieldsOnly: TSpTBXCheckBox;
    btnLimit: TSpTBXButton;
    lblMaxValues: TSpTBXLabel;
    btnBracketOpen: TSpTBXButton;
    btnBracketClose: TSpTBXButton;
    btnAnd: TSpTBXButton;
    btnOr: TSpTBXButton;
    btnField: TSpTBXButton;
    btnAdd: TSpTBXButton;
    btnModify: TSpTBXButton;
    btnDelete: TSpTBXButton;
    btnOperator: TSpTBXButton;
    btnNot: TSpTBXButton;
    btnDateFormat: TSpTBXButton;
    lblFieldID: TSpTBXLabel;
    btnInfo: TSpTBXButton;
    lstSQLWhere: TSpTBXListBox;
    chkConstructive: TSpTBXCheckBox;
    chkDontRefreshDataSet: TSpTBXCheckBox;
    chkDontInheritate: TSpTBXCheckBox;
    chkVerify: TSpTBXCheckBox;
    chkCloseOnSave: TSpTBXCheckBox;
    btnTest: TSpTBXButton;
    btnOK: TSpTBXButton;
    btnCancel: TSpTBXButton;
    cbxField: TcxComboBox;
    cbxStateValue: TcxComboBox;

    procedure btnJunctionClick(Sender: TObject);
    procedure btnFieldClick(Sender: TObject);
    procedure btnBracketCloseClick(Sender: TObject);
    procedure btnBracketOpenClick(Sender: TObject);
    procedure tbiArchiveClick(Sender: TObject);
    procedure tbiUserClick(Sender: TObject);
    procedure tbiAddfieldClick(Sender: TObject);
    procedure tbiDateFormatClick(Sender: TObject);
    procedure tbiNOTClick(Sender: TObject);
    procedure tbiOPClick(Sender: TObject);
    procedure EnableExpression;
    procedure FormCreate(Sender: TObject);
    procedure lstSQLWhereMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lstSQLWhereDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure lstSQLWhereDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure lstSQLWhereClick(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure btnModifyClick(Sender: TObject);

    procedure popOPItemClick(Sender: TObject);

    procedure cbxFieldChange(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure btnTestClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure chkMappedFieldsOnlyClick(Sender: TObject);
    procedure tbiLimitClick(Sender: TObject);
    procedure btnAndClick(Sender: TObject);
    procedure btnOrClick(Sender: TObject);
    procedure SetbtnAnd;
    procedure SetbtnOr;
    procedure SetbtnBracketOpen;
    procedure SetbtnBracketClose;

    procedure SelectLastLine;
    procedure SelectNextLine;
    procedure btnInfoClick(Sender: TObject);
    procedure cbxArchiveChange(Sender: TObject);
    procedure cbxUserChange(Sender: TObject);
    procedure ShowArcidLabel;
    procedure ShowUseridLabel;
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure cbxFieldDropDown(Sender: TObject);
    procedure cbxFieldCloseUp(Sender: TObject);
    procedure edtNameChange(Sender: TObject);
    procedure chkConstructiveClick(Sender: TObject);
    procedure chkVerifyClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cbxArchiveClick(Sender: TObject);
    procedure cbxBookmarkClick(Sender: TObject);
    procedure chkDontRefreshDataSetClick(Sender: TObject);
    procedure chkDontInheritateClick(Sender: TObject);
  private
    { Private-Deklarationen }
    fIndent, fLastBookmarkIndex: Integer;
    FRefreshFields, FDropDownOpen, FLoadBookmark, FSkipCreate, FSkipOnChange: Boolean;
    AUserList, AGroupList: TStringList;

    procedure reAlign;
    function HasChild(arcid: Int64): Boolean;
    function DBGetGroupnameByIDInObjectList: TStringList;

  public
    { Public-Deklarationen }
    sobj: TbfaSearch;
    ATreeNode: TTreeNode;
    FieldTypes : TStringList;
    DocumentFields: TStringList;
    OnSave: procedure of object;

//    procedure LoadBookmark(obj: TbfaSearch);
    procedure LoadBookmark(TreeNode: TTreeNode; obj: TbfaSearch = nil);
    procedure AddToList(modify: Boolean);
    procedure CreatePoPOpItems;
    procedure CreateBookmark;
    procedure FillCbxBookmarkItems(CurrentView: TbfaViewKind);
    procedure LoadUserArchives;
    procedure RefreshCaptionOfCurrentBookmark;
    function GetBookmarkCaption(Node: TTreeNode): String;
    function VerifyBookmark: Boolean;
    constructor Create(AOwner: TComponent;
      WithoutCbxBookmark: Boolean = False;
      CurrentView: TbfaViewKind = tvkNone); overload;
  end;

var
  frmCreateGlobalBookmark: TfrmCreateGlobalBookmark;
  MousePos : TPoint;

implementation

uses
  bfaCommonUtils, bfaCommonMethods, bfaCommonDialogs, ShowBookmark, MainForm, XMLIntf, XMLDoc,
  ActiveX, TypInfo, Uni, DateUtils, bfaParser, bfaLog, bfaCommonStyles;
{$R *.dfm}

procedure TfrmCreateGlobalBookmark.AddToList(modify: Boolean);
var
  bracket: TbfaBracket;
  junc: TbfaJunction;
  expr: TbfaExpression;
  idx : Integer;
  addfield: TbfaAddField;
  statefield : TbfaStateField;

begin
  idx := lstSQLWhere.ItemIndex;
  if not modify and (idx > -1) then
    inc(idx);

  if modify and (idx = -1) then
    Exit;

  if btnField.Checked then
  begin
    if cbxField.ItemIndex = -1 then
      Exit;
    expr := TbfaExpression.Create;

    if tbiAddfield.Checked then
    begin
      edtValue.Text := ParseSQLString(edtValue.Text);
      addfield := bitfarmApp.GetAddfieldByID(Integer(cbxField.Properties.Items.Objects[cbxField.ItemIndex]));
      if addfield <> nil then
      begin
        expr.Fieldname := addfield.DisplayName;
        expr.Field := addfield.Name;
        expr.ID := addfield.ID;
        expr.Fieldtype := eAddfieldType(addfield.Typ);
        expr.op := btnOperator.Caption;
        expr.IndexID := addfield.IndexTableID;
        if tbiEmpty.Checked then
          expr.junction.Kind := jnEmpty
        else
          expr.junction.Kind := jnNOT;

        if addfield.Typ in [1,12] then
        begin
          if tbiDay.Checked then
          begin
            expr.Field := 'day('+expr.Field+')';
            expr.DateFormat := dtfDay;
          end else if tbiWeek.Checked then
          begin
            expr.Field := 'week('+expr.Field+')';
            expr.DateFormat := dtfWeek;
          end else if tbiMonth.Checked then
          begin
            expr.Field := 'month('+expr.Field+')';
            expr.DateFormat := dtfMonth;
          end else if tbiYear.Checked then
          begin
            expr.Field := 'year('+expr.Field+')';
            expr.DateFormat := dtfYear;
          end else if tbiDate.Checked then
          begin
            expr.Field := 'date('+expr.Field+')';
            expr.DateFormat := dtfDate;
          end else if tbiDateNone.Checked then
          begin
            expr.DateFormat := dtfNone;
          end;
        end;

        if (addfield.Typ in [0,2,3,5,11]) and ((Trim(edtValue.Text) = '') or (Trim(edtValue.Text) = '""') ) then
        begin
          edtValue.Text := 'NULL';
          expr.op := 'is';
        end;

        if not (addfield.Typ in [0,2,3,5,11]) and (Trim(edtValue.Text) = '')  then
          edtValue.Text := '0';

        if (addfield.Typ in [0,2,3,5,11]) and (LeftStr(edtValue.Text,1) <> '"') and
            (edtValue.Text <> 'NULL') and (edtValue.Text <> '""')
            and (LowerCase(expr.op) <> 'between')
        then
          edtValue.Text := '"' + edtValue.Text;

         if (addfield.Typ in [0,2,3,5,11]) and (RightStr(edtValue.Text,1) <> '"') and
            (edtValue.Text <> 'NULL') and (edtValue.Text <> '""')
            and (LowerCase(expr.op) <> 'between')
         then
          edtValue.Text := edtValue.Text +  '"' ;

        expr.Value := edtValue.Text;
      end;
    end;

    if tbiStatefield.Checked then
    begin
      if cbxField.ItemIndex = -1 then
        Exit;
      statefield := bitfarmApp.GetStatefieldByID(Integer(cbxField.Properties.Items.Objects[cbxField.ItemIndex]));
      if statefield <> nil then
      begin
        expr.Fieldname := statefield.DisplayName;
        expr.Field := IntToStr(statefield.ID);
        expr.ID := statefield.ID;
        expr.Fieldtype := zfld09_Status;
        expr.op := btnOperator.Caption;
        expr.IndexID := statefield.IndexColumnID;
        if tbiEmpty.Checked then
          expr.junction.Kind := jnEmpty
        else
          expr.junction.Kind := jnNOT;
        expr.Status := cbxStateValue.ItemIndex = 0;  //gesetzt
        if expr.Status then
          expr.Value := 'gesetzt'
        else
          expr.Value := 'nicht gesetzt';
      end;
    end;

    if tbiDocumentfields.Checked then
    begin
      if cbxField.ItemIndex = -1 then
        Exit;
      expr.Fieldtype := zfld10_Document;
      edtValue.Text := ParseSQLString(edtValue.Text);
      case Integer(cbxField.Properties.Items.Objects[cbxField.ItemIndex]) of
        1:
          begin
            expr.Fieldname := _('Benutzer');
            expr.Field := 'su.username';
            expr.ID := 1;
          end;
        2:
          begin
            expr.Fieldname := _('Titel');
            expr.Field := 'docname';
            expr.ID := 2;
          end;
        3:
          begin
            expr.Fieldname := _('Datum');
            expr.ID := 3;

            if tbiDay.Checked then
            begin
              expr.Field := 'day(docdate)';
              expr.DateFormat := dtfDay;
            end else if tbiWeek.Checked then
            begin
              expr.Field := 'week(docdate)';
              expr.DateFormat := dtfWeek;
            end else if tbiMonth.Checked then
            begin
              expr.Field := 'month(docdate)';
              expr.DateFormat := dtfMonth;
            end else if tbiYear.Checked then
            begin
              expr.Field := 'year(docdate)';
              expr.DateFormat := dtfYear;
            end else if tbiDate.Checked then
            begin
              expr.Field := 'date(docdate)';
              expr.DateFormat := dtfDate;
            end else if tbiDateNone.Checked then
            begin
              expr.Field := 'docdate';
              expr.DateFormat := dtfNone;
            end else
            begin   // FallBack
              expr.Field := 'docdate';
              expr.DateFormat := dtfNone;
            end;
          end;
        4:
          begin
            expr.Fieldname := _('Bearbeitet');
            expr.ID := 4;

            if tbiDay.Checked then
            begin
              expr.Field := 'day(sd.modified)';
              expr.DateFormat := dtfDay;
            end else if tbiWeek.Checked then
            begin
              expr.Field := 'week(sd.modified)';
              expr.DateFormat := dtfWeek;
            end else if tbiMonth.Checked then
            begin
              expr.Field := 'month(sd.modified)';
              expr.DateFormat := dtfMonth;
            end else if tbiYear.Checked then
            begin
              expr.Field := 'year(sd.modified)';
              expr.DateFormat := dtfYear;
            end else if tbiDate.Checked then
            begin
              expr.Field := 'date(sd.modified)';
              expr.DateFormat := dtfDate;
            end else if tbiDateNone.Checked then
            begin
              expr.Field := 'sd.modified';
              expr.DateFormat := dtfNone;
            end else
            begin
              expr.Field := 'sd.modified';
              expr.DateFormat := dtfNone;
            end;
          end;
        5:
          begin
            expr.Fieldname := _('Gdocid');
            expr.Field := 'sd.gdocid';
            expr.ID := 5;
          end;
        6:
          begin
            expr.Fieldname := _('Volltext');
            expr.Field := 'doctxt';
            expr.ID := 6;
          end;
        7:
          begin
            expr.Fieldname := _('Schlagwort');
            expr.Field := 'doctags';
            expr.ID := 7;
          end;
        8:
          begin
            expr.Fieldname := _('Dokumentpfad');
            expr.Field := 'docloc';
            expr.ID := 8;
          end;
        9:
          begin
            expr.Fieldname := _('Originalpfad');
            expr.Field := 'oriloc';
            expr.ID := 9;
          end;
        10:
          begin
            expr.Fieldname := _('Ausgecheckt');
            expr.Field := 'checkout';
            expr.ID := 10;
          end;
        11:
          begin
            expr.Fieldname := _('Datum (Tag)');
            expr.Field := 'day(docdate)';
            expr.ID := 11;
          end;
        12:
          begin
            expr.Fieldname := _('Datum (Woche)');
            expr.Field := 'week(docdate)';
            expr.ID := 12;
          end;
        13:
          begin
            expr.Fieldname := _('Datum (Monat)');
            expr.Field := 'month(docdate)';
            expr.ID := 13;
          end;
        14:
          begin
            expr.Fieldname := _('Datum (Jahr)');
            expr.Field := 'year(docdate)';
            expr.ID := 14;
          end;
        15:
          begin
            expr.Fieldname := _('Annotation');
            expr.Field := 'annotxt';
            expr.ID := 15;
          end;
        16:
          begin
            expr.Fieldname := _('Datum-Uhrzeit');
            expr.Field := 'docdate';
            expr.ID := 16;
          end;
        17:
          begin
            expr.Fieldname := _('Lschdatum');
            expr.ID := 17;

            if tbiDay.Checked then
            begin
              expr.Field := 'day(expired)';
              expr.DateFormat := dtfDay;
            end else if tbiWeek.Checked then
            begin
              expr.Field := 'week(expired)';
              expr.DateFormat := dtfWeek;
            end else if tbiMonth.Checked then
            begin
              expr.Field := 'month(expired)';
              expr.DateFormat := dtfMonth;
            end else if tbiYear.Checked then
            begin
              expr.Field := 'year(expired)';
              expr.DateFormat := dtfYear;
            end else if tbiDate.Checked then
            begin
              expr.Field := 'date(expired)';
              expr.DateFormat := dtfDate;
            end else if tbiDateNone.Checked then
            begin
              expr.Field := 'expired';
              expr.DateFormat := dtfNone;
            end else
            begin
              expr.Field := 'expired';
              expr.DateFormat := dtfNone;
            end;
          end;
        18:
          begin
            expr.Fieldname := _('Zusatzfelder');
            expr.Field := 'fieldtxt';
            expr.ID := 18;
          end;
        19:
          begin
            expr.Fieldname := _('Verknpfung');
            expr.Field := 'refname';
            expr.ID := 19;
          end;
        20:
          begin
            expr.Fieldname := _('Typ');
            expr.Field := 'filetype';
            expr.ID := 20;
          end;
        21:
          begin
            expr.Fieldname := _('BenutzerID');
            expr.Field := 'sd.userid';
            expr.ID := 21;
          end;
        22:
          begin
            expr.Fieldname := _('GruppenID');
            expr.Field := 'sg.groupid';
            expr.ID := 22;
          end;
      end;
      if tbiEmpty.Checked then
        expr.junction.Kind := jnEmpty
      else
        expr.junction.Kind := jnNOT;
      expr.op := btnOperator.Caption;

      if expr.op = 'is' then
      begin
        expr.Value := 'NULL';
        edtValue.Text := 'NULL';
      end else if expr.op = 'in' then    //gdocid
      begin
        if (edtValue.Text = '') or (edtValue.Text = '""') then  // wir knnen keine 'leeren' gdocids suchen
          Exit;
        if (LeftStr(edtValue.Text,1) <> '(')  then
          edtValue.Text := '(' + edtValue.Text;

        if  (RightStr(edtValue.Text,1) <> ')')  then
          edtValue.Text := edtValue.Text +  ')' ;
        expr.Value := edtValue.Text;
      end else begin
        if (Integer(cbxField.Properties.Items.Objects[cbxField.ItemIndex]) in [6,7,8,9]) and (Trim(edtValue.Text) = '')  then
          edtValue.Text := '""';

        if not (Integer(cbxField.Properties.Items.Objects[cbxField.ItemIndex]) in [1,2,6,7,8,9]) and (Trim(edtValue.Text) = '')  then
          edtValue.Text := '0';

        if (Integer(cbxField.Properties.Items.Objects[cbxField.ItemIndex]) in [1,2,8,9]) and (LeftStr(edtValue.Text,1) <> '"')  then
          edtValue.Text := '"' + edtValue.Text;

        if (Integer(cbxField.Properties.Items.Objects[cbxField.ItemIndex]) in [1,2,8,9]) and (RightStr(edtValue.Text,1) <> '"')  then
          edtValue.Text := edtValue.Text +  '"' ;

        if (Integer(cbxField.Properties.Items.Objects[cbxField.ItemIndex]) in [1,2,6,7,15,18,19,20]) then  //12.10.2017 Ticket 12163
        begin
          // erste Eingabefeld bereinigen und dann Quotes und Wildcards aufbauen
          if (LeftStr(edtValue.Text,2) = '"%')  and (RightStr(edtValue.Text,2) = '%"')  then
          begin
            edtValue.Text := Copy(edtValue.Text, 3, length(edtValue.Text) -4);
          end;

          if (LeftStr(edtValue.Text,1) = '"')  and (RightStr(edtValue.Text,1) = '"')  then
          begin
            edtValue.Text := Copy(edtValue.Text, 2, length(edtValue.Text) -2);
          end;

          if expr.op = 'match' then
          begin
            if (edtValue.Text = '') or (edtValue.Text = '""') then
              edtValue.Text := '""'
            else begin
              if (LeftStr(edtValue.Text,1) <> '"')  then
                edtValue.Text := '"' + edtValue.Text;

              if  (RightStr(edtValue.Text,1) <> '"')  then
                edtValue.Text :=edtValue.Text +  '"' ;
            end;
          end else if expr.op = 'like' then
          begin
            if (edtValue.Text = '') or (edtValue.Text = '""') then
              edtValue.Text := '""'
            else if (edtValue.Text = '%%') or (edtValue.Text = '"%%"') or
                    (edtValue.Text = '%') or (edtValue.Text = '"%"')
            then
              edtValue.Text := '"%"'
            else begin
              if (LeftStr(edtValue.Text,1) <> '%')  then
                edtValue.Text := '%' + edtValue.Text;

              if (RightStr(edtValue.Text,1) <> '%')  then
                edtValue.Text := edtValue.Text +  '%' ;

              if (LeftStr(edtValue.Text,1) <> '"')  then
                edtValue.Text := '"' + edtValue.Text;

              if  (RightStr(edtValue.Text,1) <> '"')  then
                edtValue.Text := edtValue.Text +  '"' ;

              if (LeftStr(edtValue.Text,2) <> '"%')  then
                edtValue.Text := '"%' + edtValue.Text;

              if  (RightStr(edtValue.Text,2) <> '%"')  then
                edtValue.Text := edtValue.Text +  '%"' ;
            end;
          end else begin
            if (edtValue.Text = '') or (edtValue.Text = '""') then
              edtValue.Text := '""';

            if (LeftStr(edtValue.Text,1) <> '"')  then
              edtValue.Text := '"' + edtValue.Text;

            if  (RightStr(edtValue.Text,1) <> '"')  then
              edtValue.Text := edtValue.Text +  '"' ;
          end;
        end;

        expr.Value := edtValue.Text;
      end;
    end;

    if modify then
    begin
      lstSQLWhere.Items[idx] := expr.display;
      lstSQLWhere.Items.Objects[idx] := expr;
    end else begin
      lstSQLWhere.Items.InsertObject(idx, DupeString(' ', fIndent) + expr.display, expr);
    end;
    if sobj = nil then
      Exit;

    sobj.Modified := True;
    btnOk.Enabled := True;
  end;
  reAlign;
  if not modify then
    SelectNextLine;
  //  SelectLastLine;
end;

procedure TfrmCreateGlobalBookmark.btnAndClick(Sender: TObject);
var
  bracket: TbfaBracket;
  junc: TbfaJunction;
  idx: Integer;
begin
//  SetbtnAnd;
//  AddToList(False);

  idx := lstSQLWhere.ItemIndex;
  if idx > -1 then
    inc(idx);

  junc := TbfaJunction.Create;
  junc.Kind := jnAND;
  lstSQLWhere.Items.InsertObject(idx, DupeString(' ', fIndent) + junc.display, junc);
  reAlign;
  SelectNextLine;
  if sobj = nil then
    Exit;

  sobj.Modified := True;
  btnOk.Enabled := True;
end;

procedure TfrmCreateGlobalBookmark.btnOrClick(Sender: TObject);
var
  bracket: TbfaBracket;
  junc: TbfaJunction;
  idx: Integer;
begin
//  SetbtnOr;
//  AddToList(False);

  idx := lstSQLWhere.ItemIndex;
  if idx > -1 then
    inc(idx);

  junc := TbfaJunction.Create;
  junc.Kind := jnOR;
  lstSQLWhere.Items.InsertObject(idx, DupeString(' ', fIndent) + junc.display, junc);
  reAlign;
  SelectNextLine;
  if sobj = nil then
    Exit;

  sobj.Modified := True;
  btnOk.Enabled := True;
end;

procedure TfrmCreateGlobalBookmark.btnBracketCloseClick(Sender: TObject);
var
  bracket: TbfaBracket;
  junc: TbfaJunction;
  idx: Integer;
begin
//  SetbtnBracketClose;
//  AddToList(False);

  idx := lstSQLWhere.ItemIndex;
  if idx > -1 then
    inc(idx);

  bracket := TbfaBracket.Create;
  bracket.Kind := brClose;
  lstSQLWhere.Items.InsertObject(idx, ')', bracket);
  reAlign;
  SelectNextLine;
  if sobj = nil then
    Exit;

  sobj.Modified := True;
  btnOk.Enabled := True;
end;

procedure TfrmCreateGlobalBookmark.btnBracketOpenClick(Sender: TObject);
var
  bracket: TbfaBracket;
  junc: TbfaJunction;
  idx: Integer;
begin
//  SetbtnBracketOpen;
//  AddToList(False);

  idx := lstSQLWhere.ItemIndex;
  if idx > -1 then
    inc(idx);

  bracket := TbfaBracket.Create;
  bracket.Kind := brOpen;
  lstSQLWhere.Items.InsertObject(idx, '(', bracket);
  reAlign;
  SelectNextLine;
  if sobj = nil then
    Exit;

  sobj.Modified := True;
  btnOk.Enabled := True;
end;

procedure TfrmCreateGlobalBookmark.btnFieldClick(Sender: TObject);
begin
  btnField.Checked := True;
  btnAnd.Checked := False;
  btnOr.Checked := False;
  btnBracketClose.Checked := False;
  btnBracketOpen.Checked := False;
  btnDateFormat.Enabled := False;
  EnableExpression;
end;

procedure TfrmCreateGlobalBookmark.btnInfoClick(Sender: TObject);
var
  frmShowBookmark: TfrmShowBookmark;
  XML: IXMLDocument;
  RootNode: IXMLNode;
begin
  CoInitialize(nil);
  XML := NewXMLDocument;
  try
    XML.Encoding := 'UTF-8';
    XML.Options := [doNodeAutoIndent, doNamespaceDecl];
    RootNode := XML.AddChild('bookmark');
    cbxArchive.ItemIndex := cbxArchive.Properties.Items.IndexOfObject(TObject(sobj.SelectedArcID));

    if tbiUser.Checked then
      cbxUser.ItemIndex := cbxUser.Properties.Items.IndexOfObject(Tobject(sobj.UserID))
    else
      cbxUser.ItemIndex := cbxUser.Properties.Items.IndexOfObject(Tobject(sobj.GroupID));

    CreateBookmark;

    SearchObjToXML(XML, RootNode, sobj);

    frmShowBookmark := TfrmShowBookmark.Create(Self);
    frmShowBookmark.mmoXML.Lines.Text := XML.XML.Text;
    frmShowBookmark.XML := XML;
    frmShowBookmark.ShowModal;
  finally
    frmShowBookmark.Release;
    XML := nil;
    CoUninitialize;
  end;
end;

procedure TfrmCreateGlobalBookmark.btnJunctionClick(Sender: TObject);
begin
  btnField.Checked := False;
  btnAnd.Checked := False;
  btnOr.Checked := False;
  btnBracketClose.Checked := False;
  btnBracketOpen.Checked := False;
  EnableExpression;
end;

procedure TfrmCreateGlobalBookmark.btnOKClick(Sender: TObject);
begin
  try
    try
      Screen.Cursor := crHourGlass;
      edtName.Text := ParseSQLString(edtName.Text);
      if VerifyBookmark then
      begin
        cbxArchive.ItemIndex := cbxArchive.Properties.Items.IndexOfObject(TObject(sobj.SelectedArcID));

        if tbiUser.Checked then
          cbxUser.ItemIndex := cbxUser.Properties.Items.IndexOfObject(TObject(sobj.UserID))
        else
          cbxUser.ItemIndex := cbxUser.Properties.Items.IndexOfObject(TObject(sobj.GroupID));

        CreateBookmark;

        if Assigned(OnSave) then
        begin
          OnSave;
          sobj.Modified := False;
          btnOk.Enabled := False;
        end;

        if chkCloseOnSave.Checked or not Assigned(OnSave) then
          ModalResult := mrOk
        else
          RefreshCaptionOfCurrentBookmark;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'btnOKClick', ClassName);
    end;
  finally
    Screen.Cursor := crDefault;
  end;
end;


procedure TfrmCreateGlobalBookmark.btnTestClick(Sender: TObject);
var
  params: TStringList;
  Node: TTreeNode;
  Objects: TList;
  tempobj: TbfaSearch;
  members: TStringList;
begin
  // Suche ausfhren
  cbxArchive.ItemIndex := cbxArchive.Properties.Items.IndexOfObject(TObject(sobj.SelectedArcID));

  if tbiUser.Checked then
    cbxUser.ItemIndex := cbxUser.Properties.Items.IndexOfObject(Tobject(sobj.UserID))
  else
    cbxUser.ItemIndex := cbxUser.Properties.Items.IndexOfObject(Tobject(sobj.GroupID));

  CreateBookmark;

  tempobj := TbfaSearch.Create;
  tempobj.Clone(sobj);

  if tempobj.SearchType = 2 then  // globales Lesezeichen wird im Kontext des eingestellten Nutzers ausgefhrt beim Test
  begin
    if tempobj.UserID <= 0 then   // Gruppen lesezeichen? einen user aus der Gruppe in den Kontext holen
    begin
      members := DBGetGroupMembers(tempobj.GroupID);
      if members.Count = 0 then
      begin
        BfShowMessage('Die ausgewhlte Gruppe hat keine Mitglieder');
        Exit;
      end else begin
//        tempobj.UserList.CommaText := members.CommaText ;   // wir nehmen den ersten Benutzer
        tempobj.UserContext := StrToInt(members[0]);
//          tempobj.UserContext := -1;
          tempobj.GroupList.Add(IntToStr(tempobj.GroupID));
      end;
    end else
      tempobj.UserContext := tempobj.UserID;
    // wie ich mhsam herausgefunden habe, muss bei globalen Lesezeichen der(die) User in Userlist stehen
    // weil die SearchEngine bei Searchtype 2 die Userlist benutzt statt den User Context
    tempobj.UserList.Assign(bitfarmApp.User.HolidayList);   // in der Holidaylist stehen wenigstens der User selbst drin
  end else  // lokale immer im user-Kontext
    tempobj.UserContext := bitfarmApp.User.ID;

  tempobj.SelectedCols := bitfarmApp.SetSelectedColumns(False, False, tempobj.SelectedCols);

  if tempobj.SelectedArcID > 0 then
    bitfarmApp.SelectNodeByID(frmMainForm.FViewerTreeview, tempobj.SelectedArcID)
  else
    bitfarmApp.SelectNodeByID(frmMainForm.FViewerTreeview, 1);

  if (tempobj.SelectedArcID > 0) and (tempobj.SelectedArcID <= High(aSysArc)) then
  begin
    if aSysArc[tempobj.SelectedArcID].Typ = 0 then  //lager
    begin
      tempobj.ArcID := bitfarmApp.GetArcids(tempobj.SelectedArcID, bitfarmApp.User.ID);
//            if ArcID.Count = 0 then
//              ArcID.Add(IntToStr(aSysArc[0].Arcid));
      if tempobj.ArcID.IndexOf(IntToStr(tempobj.SelectedArcID)) = -1 then
        tempobj.ArcID.Add(IntToStr(tempobj.SelectedArcID));
    end else
      tempobj.ArcID.CommaText := IntToStr(tempobj.SelectedArcID);
  end;

  if tbiLimit1.Checked then
    tempobj.MaxValues := 1
  else if tbiLimit10.Checked then
    tempobj.MaxValues := 10
  else if tbiLimit50.Checked then
    tempobj.MaxValues := 50
  else if tbiLimit100.Checked then
    tempobj.MaxValues := 100
  else if tbiLimit500.Checked then
    tempobj.MaxValues := 500
  else if tbiLimit1000.Checked then
    tempobj.MaxValues := 1000
  else if tbiLimit5000.Checked then
    tempobj.MaxValues := 5000
  else if tbiLimitAll.Checked then
    tempobj.MaxValues := 0;

  Params := TStringList.Create();
  Node := frmMainForm.FViewerTreeview.Selected;
  Objects := TList.Create;

  Params.Add(GetEnumName(TypeInfo(TbfaViewKind),integer(bitfarmApp.CurrentView)));
  //Params.Add(GetEnumName(TypeInfo(TbfaViewKind),integer(frmMainForm.FViewerTreeview.ViewKind)));

  Params.Add(IntToStr(frmMainForm.FViewerTreeview.LastSelected));
  Params.Add(GetEnumName(TypeInfo(TbfaViewKind),integer(bitfarmApp.CurrentView)));

  Objects.Add(Node);
  bitfarmLog.Write(llNormal, ltDebug, 'btnTestClick vor ChangeArchive', ClassName);
  bitfarmApp.ChangeArchive(Params, Objects, nil);

  if not VarIsNull(tempobj.SQLWhere) then
    bitfarmApp.ParseSQLWhereSObj(tempobj);

  bitfarmApp.StartSearchThread(tempobj);

  if Assigned(tempobj) then
    FreeAndNil(tempobj);
  if Assigned(members) then
    FreeAndNil(members);

end;

procedure TfrmCreateGlobalBookmark.cbxArchiveChange(Sender: TObject);
begin
//  // SJ 15.09.2021
//  //  TSpTBXComboBox hat das Problem, dass es bei gleichnamigen Items immer das erste selektiert
//  //  (beim DropDown), auch wenn eigentlich das zweite ausgewhlt wurde.
//  //  Deswegen wechsel auf DevEx. Diese arbeitet anders und selektiert bei Paste direkt das Item.
//  //  Ticket 24163 kann also raus. Hat ohnehin zu Problem bfacrm:ticket__show__28321 gefhrt.
//  //
//  //  Bei DevEx ist aber die OnChange anders. Die wird bei gleichem .Text (aber anderem Object)
//  //  nicht ausgefhrt. OnClick hingegen schon. Deswegen wechsel auf OnClick.

//  try
//  // bfacrm:ticket__show__24163 4/19/2021
//    if cbxArchive.Properties.Items.IndexOf(cbxArchive.Text) <> -1 then
//      cbxArchive.ItemIndex := cbxArchive.Properties.Items.IndexOf(cbxArchive.Text);

//  // TODO SJ: s.o.
//    if (Sender is TcxComboBox) and Assigned(TcxComboBox(Sender).OnClick) then
//      TcxComboBox(Sender).OnClick(Sender);
//  except
//    bitfarmLog.Write(llNormal, ltException, 'cbxArchiveChange', ClassName);
//  end;
end;

procedure TfrmCreateGlobalBookmark.cbxArchiveClick(Sender: TObject);
begin
  // SJ 13.09.2021 - OnChange wird bei gleichem Text nicht ausgefhrt
  //               - OnClick hingegen schon
//  24163
//
// SJ 13.09.2021
// Sagars Lsung fhrt zu Problem: bfacrm:ticket__show__28321
  try
    try
      if FLoadBookmark then
        Exit;

      if cbxArchive.ItemIndex >= 0 then
        sobj.SelectedArcID := Integer(cbxArchive.Properties.Items.Objects[cbxArchive.ItemIndex])
      else if cbxArchive.Properties.Items.IndexOf(cbxArchive.Text) <> -1 then
        sobj.SelectedArcID := Integer(cbxArchive.Properties.Items.IndexOf(cbxArchive.Text))
      else
        sobj.SelectedArcID := -1;

    except
      bitfarmLog.Write(llNormal, ltException, 'cbxArchiveChange', ClassName);
    end;

    ShowArcidLabel;

    FRefreshFields := True;
    try
      tbiAddfield.Click
    finally
      FRefreshFields := False;
    end;

    sobj.Modified := True;
    btnOk.Enabled := True;
  except
    bitfarmLog.Write(llNormal, ltException, 'cbxArchiveClick', ClassName);
  end;
end;

procedure TfrmCreateGlobalBookmark.cbxBookmarkClick(Sender: TObject);
var
  DialogResult: Integer;
begin
// bewusst OnClick. Arbeitet wie OnChange, lst aber auch aus wenn sich der Text nicht ndern, sondern nur das Item
  try
    // because ItemIndex will be set initial (before ShowModal) - avoid second LoadBookmark
    if Self.Visible then
    begin
      if (sobj <> nil) and (cbxBookmark.ItemIndex <> fLastBookmarkIndex) then
      begin
        if sobj.Modified then
        begin
          DialogResult := BfMessageDlg('nderungen speichern?', mtConfirmation, [mbYes, mbNo, mbCancel]);
          if DialogResult = mrCancel then
          begin
            cbxBookmark.ItemIndex := fLastBookmarkIndex;
            Exit;
          end else if DialogResult = mrYes then
          begin
            fLastBookmarkIndex := cbxBookmark.ItemIndex;
            if Assigned(OnSave) then
              OnSave;
          end
        end;

        if cbxBookmark.ItemIndex <> -1 then
        begin
          Self.LoadBookmark(TTreeNode(cbxBookmark.Properties.Items.Objects[cbxBookmark.ItemIndex]));
          fLastBookmarkIndex := cbxBookmark.ItemIndex;
        end;
      end;
    end;
  except
    on E: Exception do
    begin
      bitfarmLog.Write(llNormal, ltException, 'cbxBookmarkClick: ' + E.Message, ClassName);
      BfShowMessage(_('Fehler beim Laden des Lesezeichens'));
    end;
  end;
end;

procedure TfrmCreateGlobalBookmark.cbxFieldChange(Sender: TObject);
var
  i, idx: Integer;
//  item: TTBRootItem;
  item: TSpTBXItem;
  expr: TbfaExpression;
  addfield: TbfaAddfield;
  statefield: TbfaStateField;
begin
  if FSkipCreate then
    Exit;

  idx := cbxField.ItemIndex;
  if idx = -1 then
    Exit;

  btnBracketOpen.Checked := False;
  btnBracketClose.Checked := False;
  btnAnd.Checked := False;
  btnOr.Checked := False;

  expr := TbfaExpression.Create;
  if tbiAddfield.Checked then
  begin
    addfield := bitfarmApp.GetAddfieldByID(Integer(cbxField.Properties.Items.Objects[idx]));
    expr.Fieldtype := eAddfieldType(addfield.Typ);
    btnDateFormat.Enabled := (expr.Fieldtype = zfld01_Datum) or (expr.Fieldtype = zfld12_DLMDate);
    lblFieldID.Caption := Format('ID: %d Typ: %s',[addfield.ID,Fieldtypes[addfield.Typ]]);
  end
  else if tbiStatefield.Checked then
  begin
    statefield := bitfarmApp.GetStatefieldByID(Integer(cbxField.Properties.Items.Objects[idx]));
    expr.Fieldtype := zfld09_Status;
    lblFieldID.Caption := Format('ID: %d',[statefield.ID]);
  end
  else begin
    expr.Fieldtype := zfld10_Document;
    lblFieldID.Caption := '';
    // Datum und Bearbeitet
    btnDateFormat.Enabled := Integer(cbxField.Properties.Items.Objects[idx]) in [3,4,17];
  end;

  expr.ID := Integer(cbxField.Properties.Items.Objects[idx]);

  cbxStateValue.Visible := expr.Fieldtype = zfld09_Status;
  edtValue.Visible := not (expr.Fieldtype = zfld09_Status);

  if not btnDateFormat.Enabled then
    btnDateFormat.Caption := _('Datumsformat');

  popOperator.Items.Clear;
  if (expr.FieldType = zfld10_Document) and (expr.ID = 5) then  // bei gdocid nur in Operator
  begin
      item := TSpTBXItem.Create(popOperator);
      item.Caption := 'in';
      item.OnClick := popOPItemClick;
      item.FontSettings.Color := stlControl.Font.Color;
      popOperator.Items.Add(item);
  end else begin
  for i := 0 to expr.oplist.Count -1 do
  begin
    item := TSpTBXItem.Create(popOperator);
    item.Caption := expr.oplist[i];
    item.OnClick := popOPItemClick;
    item.FontSettings.Color := stlControl.Font.Color;
    popOperator.Items.Add(item);
  end;
    if (expr.FieldType = zfld10_Document) and (expr.ID in [6,7,15,18]) then
    begin
      item := TSpTBXItem.Create(popOperator);
      item.Caption := 'match';
      item.OnClick := popOPItemClick;
      item.FontSettings.Color := stlControl.Font.Color;
      popOperator.Items.Add(item);
    end;
  end;
  //btnOperator.Caption := expr.op;
  btnOperator.Caption := popOperator.Items[0].Caption;
end;

procedure TfrmCreateGlobalBookmark.cbxFieldCloseUp(Sender: TObject);
begin
  FDropDownOpen := False;
end;

procedure TfrmCreateGlobalBookmark.cbxFieldDropDown(Sender: TObject);
begin
  FDropDownOpen := True;
end;

procedure TfrmCreateGlobalBookmark.cbxUserChange(Sender: TObject);
begin
  try
    if FSkipOnChange then
      Exit;
    try
      if cbxUser.ItemIndex >= 0 then
      begin
        if tbiUser.Checked then
        begin
          sobj.UserID := Integer(cbxUser.Properties.Items.Objects[cbxUser.ItemIndex]);
          sobj.GroupID := 0;
        end else begin
          sobj.UserID := 0;
          sobj.GroupID := Integer(cbxUser.Properties.Items.Objects[cbxUser.ItemIndex]);
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'cbxUserChange', ClassName);
    end;

    ShowUseridLabel;

  finally
    FSkipOnChange := False;
  end;
end;

procedure TfrmCreateGlobalBookmark.chkConstructiveClick(Sender: TObject);
begin
  if sobj <> nil then
  begin
    sobj.Modified := True;
    btnOK.Enabled := True;
  end;
end;

procedure TfrmCreateGlobalBookmark.chkDontInheritateClick(Sender: TObject);
begin
  if sobj <> nil then
  begin
    sobj.Modified := True;
    btnOK.Enabled := True;
  end;
end;

procedure TfrmCreateGlobalBookmark.chkDontRefreshDataSetClick(Sender: TObject);
begin
  if sobj <> nil then
  begin
    sobj.Modified := True;
    btnOK.Enabled := True;
  end;
end;

procedure TfrmCreateGlobalBookmark.chkMappedFieldsOnlyClick(Sender: TObject);
begin
  FRefreshFields := True;
  try
    //if btnField.Caption = tbiAddfield.Caption then
    //  tbiAddfield.Click
    //else if btnField.Caption = tbiStatefield.Caption then
    //  tbiStatefield.Click;
      tbiAddfield.Click
  finally
    FRefreshFields := False;
  end;
end;

procedure TfrmCreateGlobalBookmark.chkVerifyClick(Sender: TObject);
begin
  if sobj <> nil then
  begin
    sobj.Modified := True;
    btnOK.Enabled := True;
  end;
end;

function TfrmCreateGlobalBookmark.DBGetGroupnameByIDInObjectList: TStringList;
var
  qry: TUniQuery;
begin
  try
    try
      Result := TStringList.Create;
      qry := TUniQuery.Create(nil);
      qry.Connection := my_Con;
      qry.SQL.Text := 'select groupname, groupid from sys_group';
      qry.Open;
      qry.First;
      while not qry.Eof do
      begin
//12.09.2024        Result.AddObject(qry.FieldByName('groupname').AsString, TObject(qry.FieldByName('groupid').AsInteger));
        Result.AddObject(bitfarmApp.TranslateGroupName(qry.FieldByName('groupname').AsString), TObject(qry.FieldByName('groupid').AsInteger));
        qry.Next;
      end;
    except
      Result := nil;
    end;
  finally
    FreeAndNil(qry);
  end;
end;

constructor TfrmCreateGlobalBookmark.Create(AOwner: TComponent;
  WithoutCbxBookmark: Boolean = False;
  CurrentView: TbfaViewKind = tvkNone);
begin
  inherited Create(AOwner);
  FDropDownOpen := False;
  fLastBookmarkIndex := -1;
  if ctlGeneral <> nil then
  begin
    cbxBookmark.Style.StyleController := ctlGeneral;
    cbxArchive.Style.StyleController := ctlGeneral;
    cbxUser.Style.StyleController := ctlGeneral;
    cbxField.Style.StyleController := ctlGeneral;
    cbxStateValue.Style.StyleController := ctlGeneral;
  end;

  AUserList := DBGetUsernameByIDInObjectList;
  AGroupList := DBGetGroupnameByIDInObjectList;

  if not WithoutCbxBookmark then
    FillCbxBookmarkItems(CurrentView)
  else
    cbxBookmark.Enabled := False;
end;

procedure TfrmCreateGlobalBookmark.CreateBookmark;
var
  i, j, k : Integer;
  sql : WideString;
  expr : TbfaExpression;
  datestr, dateformat, sStrToDateString : string;
  value : WideString;
  statefield : TbfaStateField;
  add, state, field: string;
  tmplst: TStringList;
begin
  sobj.SelectedCols := 'gdocid,arcid,username';

  if tbiUser.Checked then
  begin
    if cbxUser.ItemIndex > -1 then
    sobj.UserID := Integer(cbxUser.Properties.Items.Objects[cbxUser.ItemIndex]);
    sobj.GroupID := 0;
  end else begin
    sobj.UserID := 0;
    if cbxUser.ItemIndex > -1 then
    sobj.GroupID := Integer(cbxUser.Properties.Items.Objects[cbxUser.ItemIndex]);
  end;

  if cbxArchive.Enabled then   // nur wenn wir das Archiv/Lager auch auswhlen drfen, lesen wir aus der DropDown die ArchivID
  begin
    if cbxArchive.ItemIndex <> -1 then
    begin
      try
        sobj.SelectedArcID := Integer(cbxArchive.Properties.Items.Objects[cbxArchive.ItemIndex]);
      except
        //07.02.2019 wegen CrashLog...                  
      end;
    end;
  end;

  if (sobj.SelectedArcID > 0) and (sobj.SelectedArcID <= High(aSysArc)) and
    (aSysArc[sobj.SelectedArcID].Typ = 0) then   // wenn wir auf einem Lager stehen, brauchen wir die einzelnen Arcids nicht
    sobj.ArcID.Clear;

  if (sobj.SelectedArcID > 0) and (sobj.Arcid.Count = 1) and (sobj.SelectedArcid <> StrToInt(sobj.Arcid[0])) then
    sobj.Arcid[0] := IntToStr(sobj.SelectedArcID);

  if tbiLimit1.Checked then
    sobj.MaxValues := 1
  else if tbiLimit10.Checked then
    sobj.MaxValues := 10
  else if tbiLimit50.Checked then
    sobj.MaxValues := 50
  else if tbiLimit100.Checked then
    sobj.MaxValues := 100
  else if tbiLimit500.Checked then
    sobj.MaxValues := 500
  else if tbiLimit1000.Checked then
    sobj.MaxValues := 1000
  else if tbiLimit5000.Checked then
    sobj.MaxValues := 5000
  else if tbiLimitAll.Checked then
    sobj.MaxValues := 0;

  sobj.Constructive := chkConstructive.Checked;
  sobj.Verify := chkVerify.Checked;
  sobj.DontRefreshDataSet := chkDontRefreshDataSet.Checked;
  sobj.DontInheritate := chkDontInheritate.Checked;
  sobj.Name := edtName.Text;

  tmplst := TStringList.Create;
  tmplst.Assign(lstSQLWhere.Items);
  bitfarmApp.CreateBookmarkSobj(sobj, tmplst);
end;

procedure TfrmCreateGlobalBookmark.CreatePoPOpItems;
var
  //item: TTBRootItem;
  item: TSpTBXItem;
begin
  popOperator.Items.Clear;
  //item := TTBRootItem.Create(popOperator);
  item := TSpTBXItem.Create(popOperator);
  item.Caption := '=';
  item.OnClick := popOPItemClick;
//  item.FontSettings.Color := clWhite;
  popOperator.Items.Add(item);
  //item := TTBRootItem.Create(popOperator);
  item := TSpTBXItem.Create(popOperator);
  item.Caption := '<>';
  item.OnClick := popOPItemClick;
  popOperator.Items.Add(item);
  //item := TTBRootItem.Create(popOperator);
  item := TSpTBXItem.Create(popOperator);
  item.Caption := 'is';
  item.OnClick := popOPItemClick;
  popOperator.Items.Add(item);
end;

procedure TfrmCreateGlobalBookmark.edtNameChange(Sender: TObject);
begin
  if sobj <> nil then
  begin
    sobj.Modified := True;
    btnOk.Enabled := True;
  end;
end;

procedure TfrmCreateGlobalBookmark.EnableExpression;
var
  enable : Boolean;
begin
  enable := btnField.Checked;
  btnNot.Enabled := enable;
  cbxField.Enabled := enable;
  btnOperator.Enabled := enable;
  edtValue.Enabled := enable;
end;

procedure TfrmCreateGlobalBookmark.FillCbxBookmarkItems(CurrentView: TbfaViewKind);
  procedure AddItems(ATreeNode: TTreeNode; isGlobal: Boolean);
  var
    j: Integer;
  begin
    if ATreeNode.Count > 0 then
    begin
      for j := 0 to ATreeNode.Count - 1 do
      begin
        if ATreeNode.Item[j].Data <> nil then
        begin
          if (TObject(ATreeNode.Item[j].Data) is TbfaSearch) then
          begin
            if frmMainForm.checkBookmark(frmMainForm.FViewerTreeview.Selected, TbfaSearch(ATreeNode.Item[j].Data), isGlobal) then
              cbxBookmark.Properties.Items.AddObject(GetBookmarkCaption(ATreeNode.Item[j]), ATreeNode.Item[j]);
          end else if (TObject(ATreeNode.Item[j].Data) is TbfaNodeInfo) then
            AddItems(ATreeNode.Item[j], isGlobal);
        end;
      end;
    end;
  end;
var
  I: Integer;
  ANode: TTreeNode;
  editable: Boolean;
begin
  if not cbxBookmark.Enabled then
    Exit;

  try
    try
      // Bei Lesezeichen bieten wir alle lokalen Lesezeichen zum bearbeiten an
      // (und global wenn Admin)
      if (CurrentView = tvkFavorites) then
      begin
        cbxBookmark.Properties.Items.BeginUpdate;
        cbxBookmark.Properties.Items.Clear;

        for I := 0 to frmMainForm.trvBookmarks.Items.Count - 1 do
        begin
          ANode := frmMainForm.trvBookmarks.Items[I];
          if (TObject(ANode.Data) is TbfaSearch) and (
              (GetRootNode(ANode) = bitfarmApp.LocalListNode) or
              ((GetRootNode(ANode) = bitfarmApp.GlobalListNode) and bitfarmApp.User.isAdmin))
          then
            cbxBookmark.Properties.Items.AddObject(GetBookmarkCaption(ANode), TTreeNode(ANode));
        end;

        if (fLastBookmarkIndex <> -1) then
          cbxBookmark.ItemIndex := fLastBookmarkIndex;

      // Im Viewer prfen wir welche Lesezeichen im aktuellen Lager/Archiv angezeigt wird
      end else if (CurrentView = tvkViewer) then
      begin
        for I := 0 to frmMainForm.trvBookmarks.Items.Count - 1 do
        begin
          editable := ((frmMainForm.trvBookmarks.Items[I] = bitfarmApp.GlobalListNode) and bitfarmApp.User.isAdmin) or
                      (frmMainForm.trvBookmarks.Items[I] = bitfarmApp.LocalListNode);
          if editable then
            AddItems(frmMainForm.trvBookmarks.Items[I], (frmMainForm.trvBookmarks.Items[I] = bitfarmApp.GlobalListNode));
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'FillCbxBookmarkItems', ClassName);
    end;
  finally
    cbxBookmark.Properties.Items.EndUpdate;
  end;
end;

procedure TfrmCreateGlobalBookmark.FormCreate(Sender: TObject);
begin
  FRefreshFields := False;
  FSkipCreate := True;
  sobj := TbfaSearch.Create;

  Font.Size := bfaFontSize; //19.10.2021 Ticket 28299

  FieldTypes := TStringList.Create;
  FieldTypes.Add(_('Universal'));
  FieldTypes.Add(_('Datum'));
  FieldTypes.Add(_('Auswahl'));
  FieldTypes.Add(_('Mehrfach'));
  FieldTypes.Add(_('Invisible'));
  FieldTypes.Add(_('Interval'));
  FieldTypes.Add(_('Ganzzahl'));
  FieldTypes.Add(_('Fliekomma'));
  FieldTypes.Add(_('Whrung'));
  FieldTypes.Add(_('9'));
  FieldTypes.Add(_('10'));
  FieldTypes.Add(_('DLM Auswahlfeld'));
  FieldTypes.Add(_('DLM Datumsfeld'));
  FieldTypes.Add(_('Grid Feld'));
  FieldTypes.Add(_('Grid Spalte'));

  tbiAddfieldClick(tbiAddfield);
  tbiArchiveClick(tbiArchive);
  tbiUserClick(tbiUser);
  btnAnd.Checked := True;
  tbiArchive.Checked := True;
  tbiUser.Checked := True;
  tbiAddfield.Checked := True;
  tbiEmpty.Checked := True;
  edtValue.Visible := True;
  cbxStateValue.Visible := False;
  chkMappedFieldsOnly.Checked := False;

//  regs := TStringList.Create;
//  regs.Add('^(not )*(docstate_)(\d+)\s*&\s*(\d+)\s*([<=>]+)\s*(\d+)');
//  regs.Add('^(not )*(\S+)\s*([<=>]+|like|is)\s*(.+)');
//  regs.Add('^(not )*(\S+)\s*([<=>]+|like|is)\s*str_to_date\("(\d{2}.\d{2}.\d{4}|\d{4}.\d{2}.\d{2}).*?"\)');
//  regs.Add('^(not )*(\S+)\s*([<=>]+|like|is)\s*(\d+)');
//  regs.Add('^(not )*(\S+)\s*(between)\s*(.+\s*and\s*.+)');
//  regs.Add('^(not )*MATCH \((\S+)\) (AGAINST) \((.+) IN BOOLEAN MODE\)');

  DocumentFields := TStringList.Create;
  DocumentFields.Sorted := False;
  DocumentFields.AddObject(_('Benutzer'), TObject(1));
  DocumentFields.AddObject(_('Titel'), TObject(2));
  DocumentFields.AddObject(_('Datum'), TObject(3));
  DocumentFields.AddObject(_('Bearbeitet'), TObject(4));
  DocumentFields.AddObject(_('Gdocid'), TObject(5));
  DocumentFields.AddObject(_('Volltext'), TObject(6));
  DocumentFields.AddObject(_('Schlagwort'), TObject(7));
  DocumentFields.AddObject(_('Dokumentpfad'), TObject(8));
  DocumentFields.AddObject(_('Originalpfad'), TObject(9));
  DocumentFields.AddObject(_('Ausgecheckt'), TObject(10));
  DocumentFields.AddObject(_('Annotation'), TObject(15));
  DocumentFields.AddObject(_('Lschdatum'), TObject(17));
  DocumentFields.AddObject(_('Zusatzfelder'), TObject(18));
  DocumentFields.AddObject(_('Verknpfung'), TObject(19));
  DocumentFields.AddObject(_('Typ'), TObject(20));
  DocumentFields.AddObject(_('BenutzerID'), TObject(21));
  DocumentFields.AddObject(_('GruppenID'), TObject(22));
  fIndent := 0;
  tbiLimitClick(popLimit.Items[2]);
  btnInfo.Images := bfaIcons.ilMainMenu;
  btnInfo.ImageIndex := Integer(icoidx_info);
  sobj := TbfaSearch.Create;
  CreatePoPOpItems;

  TranslateComponent(Self, 'ViewerV36');

  FSkipCreate := False;

  if cbxField.Properties.Items.Count > 0 then
  begin
    cbxField.ItemIndex := 0;
    cbxFieldChange(Sender);
  end;
end;

procedure TfrmCreateGlobalBookmark.FormDestroy(Sender: TObject);
begin
  try
    if Assigned(AUserList) then
      FreeAndNil(AUserList);
    if Assigned(AGroupList) then
      FreeAndNil(AGroupList);
  except

  end;
end;

procedure TfrmCreateGlobalBookmark.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  Msg: TMsg;
begin
  if ((Key = VK_ESCAPE) and btnCancel.Visible and btnCancel.Enabled and (not FDropDownOpen)) then
    btnCancel.Click
  else if (ssCtrl in Shift) and (Key = Ord('S')) and btnOK.Enabled then
  begin
    btnOK.Click;
    PeekMessage(Msg, 0, WM_CHAR, WM_CHAR, PM_REMOVE); // gegen PLING-Ton
  end;
end;

procedure TfrmCreateGlobalBookmark.FormShow(Sender: TObject);
begin
  btnFieldClick(Sender);
  cbxFieldChange(Sender);
end;

function TfrmCreateGlobalBookmark.GetBookmarkCaption(Node: TTreeNode): String;
begin
  try
    Result := Node.Text + ' | ' + frmMainForm.NodeHint(Node);

    if TbfaSearch(Node.Data).UserID > 0 then
    begin
      if (AUserList.IndexOfObject(TObject(TbfaSearch(Node.Data).UserID)) <> -1) and
         (AUserList[Integer(AUserList.IndexOfObject(TObject(TbfaSearch(Node.Data).UserID)))] <> '')
      then
        Result := Result + ' | ' + _('Benutzer:') + ' ' + AUserList[Integer(AUserList.IndexOfObject(TObject(TbfaSearch(Node.Data).UserID)))];
    end else if (TbfaSearch(Node.Data).UserID = 0) then
    begin
      if (AGroupList.IndexOfObject(TObject(TbfaSearch(Node.Data).GroupID)) <> -1) and
         (AGroupList[Integer(AGroupList.IndexOfObject(TObject(TbfaSearch(Node.Data).GroupID)))] <> '')
      then
        Result := Result + ' | ' + _('Gruppe:') + ' ' + AGroupList[Integer(AGroupList.IndexOfObject(TObject(TbfaSearch(Node.Data).GroupID)))];
    end;
  except
    Result := _('Hier ist ein Fehler passiert...');
  end;
end;

function TfrmCreateGlobalBookmark.HasChild(arcid: Int64): Boolean;
var
  i : Integer;
begin
  Result := False;
  for i := Low(aSysArc) to High(aSysArc) do
  begin
    if aSysArc[i].Lgrid = arcid then    // uns interessieren nur Eintrge unterhalb der arcid
    begin
      if aSysArc[i].Typ = 0 then  // wieder ein Lager -> Rekursion
      begin
        if HasChild(aSysArc[i].Arcid) then
        begin
          Result := True;
          Break;
        end;
      end else if (aSysArc[i].Rights and rightRead) = rightRead then
      begin
        Result := True;
        Break;
      end;
    end;
  end;
end;

procedure TfrmCreateGlobalBookmark.LoadBookmark(TreeNode: TTreeNode; obj: TbfaSearch = nil);
var
  sqltmp : TStringList;
  SelectedArcidRights: Int64;
begin
  try
    try
      bitfarmLog.DebugBegin(llDebug, 'LoadBookmark', ClassName);
      FLoadBookmark := True;
      // obj will only be set if we create a new bookmark
      // otherwise we will take the SearchObject of the TreeNode
      if (obj <> nil) then
      begin
        bitfarmLog.Write(llDebug, ltDebug, 'LoadBookmark - before clone - obj <> nil', ClassName);
        ATreeNode := TreeNode;
        sobj.Clone(TbfaSearch(obj), True);
      end else if (obj = nil) and (TObject(TreeNode.Data) is TbfaSearch) then
      begin
        bitfarmLog.Write(llDebug, ltDebug, 'LoadBookmark - before clone - obj = nil', ClassName);
        ATreeNode := TreeNode;
        sobj.Clone(TbfaSearch(TreeNode.Data), True);
      end;

      if sobj = nil then
      begin
        bitfarmLog.Write(llDebug, ltDebug, 'LoadBookmark - sobj is nil - Exit', ClassName);
        Exit;
      end;

      if obj = nil then
      begin
        bitfarmLog.Write(llDebug, ltDebug, 'LoadBookmark - after clone - obj = nil', ClassName);
        if (GetRootNode(TreeNode) = bitfarmApp.GlobalListNode) then
        begin
          bitfarmLog.Write(llDebug, ltDebug, 'LoadBookmark - after clone - = GlobalListNode', ClassName);
          Self.Caption := _('Globales Lesezeichen ndern');
          Self.cbxUser.Enabled := False;
          Self.btnUser.Enabled := False;
        end else
        begin
          bitfarmLog.Write(llDebug, ltDebug, 'LoadBookmark - after clone - <> GlobalListNode', ClassName);
          Self.Caption := _('Lokales Lesezeichen ndern');
          Self.cbxArchive.Enabled := True;   // Ticket 20864
          Self.btnArchive.Enabled := True;   // Ticket 20864
        end;
      end else
      begin
        bitfarmLog.Write(llDebug, ltDebug, 'LoadBookmark - after clone - obj <> nil', ClassName);
        if (GetRootNode(TreeNode) = bitfarmApp.GlobalListNode) then
        begin
          bitfarmLog.Write(llDebug, ltDebug, 'LoadBookmark - after clone - = GlobalListNode', ClassName);
          Self.Caption := _('Globales Lesezeichen erstellen');
        end else
        begin
          bitfarmLog.Write(llDebug, ltDebug, 'LoadBookmark - after clone - <> GlobalListNode', ClassName);
          Self.Caption := _('Lokales Lesezeichen erstellen');
          Self.cbxUser.Enabled := False;
          Self.btnUser.Enabled := False;
        end;
      end;

      edtName.Text := sobj.Name;
      chkVerify.Checked := sobj.Verify;
      chkConstructive.Checked := sobj.Constructive;
      chkDontRefreshDataSet.Checked := sobj.DontRefreshDataSet;
      chkDontInheritate.Checked := sobj.DontInheritate;
      bitfarmLog.Write(llDebug, ltDebug, 'LoadBookmark - {C8332610-584A-4BF7-AB3A-A9EFE8EFF72C}', ClassName);

      if (sobj.GroupID > -1) and (sobj.UserID <= 0) then   // GruppenID >= 0 und keine UserID
      begin
        //tbiGroup.Click;
        tbiUser.Checked := False;
        tbiGroup.Checked := True;
        cbxUser.Properties.Items.BeginUpdate;
        cbxUser.Properties.Items.Clear;
        cbxUser.Properties.Items.Assign(DBGetGroupList(0, 0, True, True));
        cbxUser.Properties.Items.EndUpdate;
        FSkipOnChange := True;
        cbxUser.ItemIndex := cbxUser.Properties.Items.IndexOfObject(TObject(sobj.GroupID));
      end;

      if sobj.UserID > 0 then
      begin
//        tbiUser.Click;
        tbiUser.Checked := True;
        tbiGroup.Checked := False;
        cbxUser.Properties.Items.BeginUpdate;
        cbxUser.Properties.Items.Clear;
        cbxUser.Properties.Items.Assign(DBGetUserList(0, 0, True, True));
        cbxUser.Properties.Items.EndUpdate;
        FSkipOnChange := True;
        cbxUser.ItemIndex := cbxUser.Properties.Items.IndexOfObject(TObject(sobj.UserID));
      end;

      if tbiUser.Checked then
        btnUser.Caption := _('Benutzer')
      else
        btnUser.Caption := _('Gruppe');

      bitfarmLog.Write(llDebug, ltDebug, 'LoadBookmark - {9D9AD137-D762-4311-9353-62F570136DE0}', ClassName);
      ShowUseridLabel;
      SelectedArcidRights := 0;

      if sobj.SelectedArcID = 0 then     // aktuelles Archiv
      begin
        bitfarmLog.Write(llDebug, ltDebug, 'LoadBookmark - SelectedArcID = 0', ClassName);
        tbiArchive.Click;
        cbxArchive.ItemIndex := cbxArchive.Properties.Items.IndexOfObject(TObject(sobj.SelectedArcID));
      end else if sobj.SelectedArcID > 0 then
      begin
        bitfarmLog.Write(llDebug, ltDebug, 'LoadBookmark - SelectedArcID > 0', ClassName);
        if sobj.SelectedArcID <= High(aSysArc) then
        begin
          SelectedArcidRights := aSysArc[sobj.SelectedArcID].Rights;
          if aSysArc[sobj.SelectedArcID].Typ = 0 then
            tbiRepos.Click
          else
            tbiArchive.Click;
        end;
        cbxArchive.ItemIndex := cbxArchive.Properties.Items.IndexOfObject(TObject(sobj.SelectedArcID));
      end else
      begin
        bitfarmLog.Write(llDebug, ltDebug, 'LoadBookmark - SelectedArcID <= 0', ClassName);
        tbiRepos.Click;
        cbxArchive.ItemIndex := cbxArchive.Properties.Items.IndexOfObject(TObject(sobj.SelectedArcID));
      end;

      tbiLimitAll.Visible := (((SelectedArcidRights and rightAdmin) = rightAdmin) or bitfarmApp.User.DMSAdmin)
                              or (SObj.MaxValues <= 0);  // sollte das Lesezeichen Alle als MaxTreffer haben, dann anzeigen

      ShowArcidLabel;

      if SObj.MaxValues > 0 then
      begin
        bitfarmLog.Write(llDebug, ltDebug, 'LoadBookmark - SObj.MaxValues > 0', ClassName);
        if StrToInt(tbiLimit1.Caption) = SObj.MaxValues then
          tbiLimit1.Click
        else if StrToInt(tbiLimit10.Caption) = SObj.MaxValues then
          tbiLimit10.Click
        else if StrToInt(tbiLimit100.Caption) = SObj.MaxValues then
          tbiLimit100.Click
        else if StrToInt(tbiLimit500.Caption) = SObj.MaxValues then
          tbiLimit500.Click
        else if StrToInt(tbiLimit1000.Caption) = SObj.MaxValues then
          tbiLimit1000.Click
        else if StrToInt(tbiLimit5000.Caption) = SObj.MaxValues then
          tbiLimit5000.Click
        else if StrToInt(tbiLimit50.Caption) = SObj.MaxValues then
          tbiLimit50.Click;
      end
      else if tbiLimitAll.Visible then
        tbiLimitAll.Click
      else
        tbiLimit50.Click;

      sqltmp := TStringList.Create;
      bitfarmApp.ParseSobjToSQLWhere(sobj, sqltmp);
      lstSQLWhere.Items.Assign(sqltmp);
      bitfarmLog.Write(llNormal, ltInfo, 'LoadBookmark - after lstSQLWhere Assign', ClassName);

      btnOk.Enabled := False;

      reAlign;

      SelectLastLine;
      if (cbxBookmark.ItemIndex = -1) or (cbxBookmark.Properties.Items.Objects[cbxBookmark.ItemIndex] <> TTreeNode(TreeNode)) then
        cbxBookmark.ItemIndex := cbxBookmark.Properties.Items.IndexOfObject(TTreeNode(TreeNode));
      fLastBookmarkIndex := cbxBookmark.ItemIndex;
      sobj.Modified := False;
      btnOk.Enabled := False;
    except
      bitfarmLog.Write(llNormal, ltException, 'LoadBookmark', ClassName);
    end;
  finally
    FLoadBookmark := False;
    bitfarmLog.DebugEnd(llDebug, 'LoadBookmark', ClassName);
  end;
end;

procedure TfrmCreateGlobalBookmark.LoadUserArchives;
var
  i: Integer;
begin
  try
    for i := 0 to popArchive.Items.Count - 1 do
      popArchive.Items[i].Checked := False;
    popArchive.Items[0].Checked := True;
    btnArchive.Caption := popArchive.Items[0].Caption;

    cbxArchive.Properties.Items.BeginUpdate;
    cbxArchive.Properties.Sorted := False;
//    cbxArchive.Clear;
    cbxArchive.Properties.Items.Clear;
    for i := 0 to High(aSysArc) do
    begin
      // Archive
      if (aSysArc[i].Typ = 1) and (aSysArc[i].Name <> '') and
         (((aSysArc[i].Rights and rightRead) = rightRead) or bitfarmApp.User.isAdmin) // Ticket 20864
      then
        cbxArchive.Properties.Items.AddObject(aSysArc[i].Name, TObject(aSysArc[i].Arcid));
    end;
  finally
    cbxArchive.Properties.Items.EndUpdate;
    cbxArchive.Properties.Sorted := True;

    if cbxArchive.Properties.Items.Count > 0 then
      cbxArchive.ItemIndex := 0;
  end;
end;

procedure TfrmCreateGlobalBookmark.lstSQLWhereClick(Sender: TObject);
var
  i, idx: Integer;
  //item: TTBRootItem;
  item : TSpTBXItem;
begin
  idx := lstSQLWhere.ItemIndex;
  if idx = -1 then
    Exit;
  if TObject(lstSQLWhere.Items.Objects[idx]) is TbfaBracket then
  begin
    if TbfaBracket(lstSQLWhere.Items.Objects[idx]).Kind = brOpen then
      SetbtnBracketOpen
    else
      SetbtnBracketClose;
    btnDateFormat.Enabled := False;
    lblFieldID.Caption := '';
  end;
  if TObject(lstSQLWhere.Items.Objects[idx]) is TbfaJunction then
  begin
    if TbfaJunction(lstSQLWhere.Items.Objects[idx]).Kind = jnAND then
//      tbiAND.Click
      SetbtnAnd
    else if TbfaJunction(lstSQLWhere.Items.Objects[idx]).Kind = jnOr then
//      tbiOR.Click;
      SetbtnOr;
    btnDateFormat.Enabled := False;
    lblFieldID.Caption := '';
  end;

  if TObject(lstSQLWhere.Items.Objects[idx]) is TbfaExpression then
  begin
    if Integer(TbfaExpression(lstSQLWhere.Items.Objects[idx]).Fieldtype) < 9  then
      tbiAddfield.Click;
    if Integer(TbfaExpression(lstSQLWhere.Items.Objects[idx]).Fieldtype) = 9  then
      tbiStatefield.Click;
    if Integer(TbfaExpression(lstSQLWhere.Items.Objects[idx]).Fieldtype) = 10  then
      tbiDocumentfields.Click;
    cbxField.ItemIndex := cbxField.Properties.Items.IndexOfObject(TObject(TbfaExpression(lstSQLWhere.Items.Objects[idx]).ID));
    cbxFieldChange(Self);

    if TbfaExpression(lstSQLWhere.Items.Objects[idx]).junction.Kind = jnAND then
      tbiEmpty.Click;
    if TbfaExpression(lstSQLWhere.Items.Objects[idx]).junction.Kind = jnEmpty then
      tbiEmpty.Click;
    if TbfaExpression(lstSQLWhere.Items.Objects[idx]).junction.Kind = jnNOT then
      tbiNOT.Click;

    if Integer(TbfaExpression(lstSQLWhere.Items.Objects[idx]).Fieldtype) = 9  then
    begin
      if TbfaExpression(lstSQLWhere.Items.Objects[idx]).Status then
        cbxStateValue.ItemIndex := 0
      else
        cbxStateValue.ItemIndex := 1;
    end
    else
      edtValue.Text := TbfaExpression(lstSQLWhere.Items.Objects[idx]).Value;

    if Integer(TbfaExpression(lstSQLWhere.Items.Objects[idx]).Fieldtype) in [1,10]  then
    begin
      btnDateFormat.Enabled := ((TbfaExpression(lstSQLWhere.Items.Objects[idx]).ID in [3,4,17]) and
                                (Integer(TbfaExpression(lstSQLWhere.Items.Objects[idx]).Fieldtype) = 10)) or
                                (Integer(TbfaExpression(lstSQLWhere.Items.Objects[idx]).Fieldtype) = 1);

      if TbfaExpression(lstSQLWhere.Items.Objects[idx]).DateFormat = dtfDay then
        tbiDay.Click
      else if TbfaExpression(lstSQLWhere.Items.Objects[idx]).DateFormat = dtfWeek then
        tbiWeek.Click
      else if TbfaExpression(lstSQLWhere.Items.Objects[idx]).DateFormat = dtfMonth then
        tbiMonth.Click
      else if TbfaExpression(lstSQLWhere.Items.Objects[idx]).DateFormat = dtfYear then
        tbiYear.Click
      else if TbfaExpression(lstSQLWhere.Items.Objects[idx]).DateFormat = dtfDate then
        tbiDate.Click
      else
        tbiDateNone.Click;
    end;

    popOperator.Items.Clear;
    for i := 0 to TbfaExpression(lstSQLWhere.Items.Objects[idx]).oplist.Count -1 do
    begin
      item := TSpTBXItem.Create(popOperator);
      item.Caption := TbfaExpression(lstSQLWhere.Items.Objects[idx]).oplist[i];
      item.OnClick := popOPItemClick;
      item.FontSettings.Color := stlControl.Font.Color;
      popOperator.Items.Add(item);
    end;

    if (TbfaExpression(lstSQLWhere.Items.Objects[idx]).FieldType = zfld10_Document) and
        (TbfaExpression(lstSQLWhere.Items.Objects[idx]).ID in [6,7,15,18]) then
    begin
      item := TSpTBXItem.Create(popOperator);
      item.Caption := 'match';
      item.OnClick := popOPItemClick;
      item.FontSettings.Color := stlControl.Font.Color;
      popOperator.Items.Add(item);
    end;

    btnOperator.Caption := TbfaExpression(lstSQLWhere.Items.Objects[idx]).op;
  end;

  if not btnDateFormat.Enabled then
    btnDateFormat.Caption := _('Datumsformat');

end;

procedure TfrmCreateGlobalBookmark.lstSQLWhereDragDrop(Sender, Source: TObject;
  X, Y: Integer);
var
  Num1, Num2: Integer;
  Point1, Point2: TPoint;
begin
  Point2.X:=X;
  Point2.Y:=Y;
  with Source as TSpTBXListBox do
  begin
    Num2:=lstSQLWhere.ItemAtPos(MousePos,True);
    if Num2 = -1 then
      Exit;
    Num1:=lstSQLWhere.ItemAtPos(Point2,True);

    if not((Num1 = -1) and (lstSQLWhere.Items.Count -1 = Num2)) and not(Num1 = Num2) then
    begin
      sobj.Modified := True;
      btnOK.Enabled := True;
    end;

    if Num1 = -1 then
      Num1 := lstSQLWhere.Items.Count -1;
    lstSQLWhere.Items.Move(Num2, Num1);
    lstSQLWhere.Selected[Num1] := True;
  end;
  reAlign;
end;

procedure TfrmCreateGlobalBookmark.lstSQLWhereDragOver(Sender, Source: TObject;
  X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := Source = lstSQLWhere;
end;

procedure TfrmCreateGlobalBookmark.lstSQLWhereMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  MousePos.X := X;
  MousePos.Y := Y;
end;


procedure TfrmCreateGlobalBookmark.SelectLastLine;
begin
  if (lstSQLWhere.ItemIndex < lstSQLWhere.Count) and (lstSQLWhere.Count > 0) then
  begin
     lstSQLWhere.ItemIndex := lstSQLWhere.Items.Count -1;
     lstSQLWhere.Selected[lstSQLWhere.ItemIndex] := True;
  end;
  lstSQLWhereClick(nil);

end;

procedure TfrmCreateGlobalBookmark.SelectNextLine;
begin
  if (lstSQLWhere.ItemIndex < lstSQLWhere.Count) and (lstSQLWhere.Count > 0) then
  begin
     lstSQLWhere.ItemIndex := lstSQLWhere.ItemIndex +1;
     lstSQLWhere.Selected[lstSQLWhere.ItemIndex] := True;
  end;
  lstSQLWhereClick(nil);
end;

procedure TfrmCreateGlobalBookmark.SetbtnAnd;
begin
//  btnField.Checked := False;
  btnAnd.Checked := True;
  btnOr.Checked := False;
  btnBracketClose.Checked := False;
  btnBracketOpen.Checked := False;
//  btnDateFormat.Enabled := False;
  EnableExpression;
end;

procedure TfrmCreateGlobalBookmark.SetbtnBracketClose;
begin
//  btnField.Checked := False;
  btnAnd.Checked := False;
  btnOr.Checked := False;
  btnBracketClose.Checked := True;
  btnBracketOpen.Checked := False;
//  btnDateFormat.Enabled := False;
  EnableExpression;
end;

procedure TfrmCreateGlobalBookmark.SetbtnBracketOpen;
begin
//  btnField.Checked := False;
  btnAnd.Checked := False;
  btnOr.Checked := False;
  btnBracketClose.Checked := False;
  btnBracketOpen.Checked := True;
//  btnDateFormat.Enabled := False;
  EnableExpression;
end;

procedure TfrmCreateGlobalBookmark.SetbtnOr;
begin
//  btnField.Checked := False;
  btnAnd.Checked := False;
  btnOr.Checked := True;
  btnBracketClose.Checked := False;
  btnBracketOpen.Checked := False;
//  btnDateFormat.Enabled := False;
  EnableExpression;
end;

procedure TfrmCreateGlobalBookmark.ShowArcidLabel;
begin
  if cbxArchive.ItemIndex = -1 then
  begin
    lblArcid.Caption := '';
    Exit;
  end;

  if popArchive.Items[0].Checked then
  begin
    lblArcid.Caption := _('Archiv ID:') + ' ' + IntToStr(Integer(cbxArchive.Properties.Items.Objects[cbxArchive.ItemIndex]));
  end else if popArchive.Items[1].Checked then
  begin
    lblArcid.Caption := _('Lager ID:') + ' ' + IntToStr(Integer(cbxArchive.Properties.Items.Objects[cbxArchive.ItemIndex]));
  end;
end;

procedure TfrmCreateGlobalBookmark.ShowUseridLabel;
begin
  if cbxUser.ItemIndex = -1 then
  begin
    lblUserid.Caption := '';
    Exit;
  end;

  if popUser.Items[0].Checked then
  begin
    lblUserid.Caption := _('Benutzer ID:') + ' ' + IntToStr(Integer(cbxUser.Properties.Items.Objects[cbxUser.ItemIndex]));
  end else if popUser.Items[1].Checked then
  begin
    lblUserid.Caption := _('Gruppe ID:') + ' ' + IntToStr(Integer(cbxUser.Properties.Items.Objects[cbxUser.ItemIndex]));
  end;
end;

procedure TfrmCreateGlobalBookmark.btnAddClick(Sender: TObject);
begin
  AddToList(False);
end;

procedure TfrmCreateGlobalBookmark.btnModifyClick(Sender: TObject);
begin
  AddToList(True);
end;

procedure TfrmCreateGlobalBookmark.btnDeleteClick(Sender: TObject);
var
  idx : Integer;
begin
  idx := lstSQLWhere.ItemIndex;
  if idx > -1 then
  begin
    lstSQLWhere.Items.Delete(idx);
    reAlign;
    if idx = lstSQLWhere.Count then
      idx := lstSQLWhere.Count -1;

    if idx > -1 then
      lstSQLWhere.Selected[idx] := True;
//    SelectLastLine;
    if sobj = nil then
      Exit;

    sobj.Modified := True;
    btnOk.Enabled := True;
  end;
end;

procedure TfrmCreateGlobalBookmark.popOPItemClick(Sender: TObject);
begin
  btnOperator.Caption := TTBCustomItem(Sender).Caption;

  if btnOperator.Caption = 'is' then
    edtValue.Text := 'NULL';
end;

procedure TfrmCreateGlobalBookmark.reAlign;
var
  i : Integer;
begin
  fIndent := 0;
  for i := 0 to lstSQLWhere.Items.Count -1 do
  begin
    if TObject(lstSQLWhere.Items.Objects[i]) is TbfaBracket then
      if TbfaBracket(lstSQLWhere.Items.Objects[i]).Kind = brClose then
        if fIndent >= 2 then
          fIndent := fIndent -2;

    lstSQLWhere.Items[i] := DupeString(' ', fIndent) + Trim(lstSQLWhere.Items[i]);

    if TObject(lstSQLWhere.Items.Objects[i]) is TbfaBracket then
      if TbfaBracket(lstSQLWhere.Items.Objects[i]).Kind = brOpen then
        fIndent := fIndent + 2;
  end;
end;

procedure TfrmCreateGlobalBookmark.RefreshCaptionOfCurrentBookmark;
var
  ActiveIndex: Integer;
begin
  if not cbxBookmark.Enabled then
    Exit;

  ActiveIndex := cbxBookmark.ItemIndex;

  if ActiveIndex <> -1 then
  begin
    cbxBookmark.Properties.Items[ActiveIndex] := GetBookmarkCaption(Self.ATreeNode);
    cbxBookmark.Properties.Items.Objects[ActiveIndex] := Self.sobj;
    cbxBookmark.ItemIndex := ActiveIndex;
  end;
end;

procedure TfrmCreateGlobalBookmark.tbiAddfieldClick(Sender: TObject);
var
  i, j, k, l: Integer;
  lmq: TUniQuery;
  sDisplayName: string;
begin
  try
    btnField.Checked := True;
    btnBracketClose.Checked := False;
    btnBracketOpen.Checked := False;
    btnAnd.Checked := False;
    btnOr.Checked := False;
    EnableExpression;
//    CreatePoPOpItems;
    btnField.Checked := True;
    if (btnField.Caption = TTBCustomItem(Sender).Caption) and (not FRefreshFields) then
      Exit;

    for i := 0 to popField.Items.Count - 1 do
        popField.Items[i].Checked := False;
    btnField.Caption := TTBCustomItem(Sender).Caption;
    TTBCustomItem(Sender).Checked := True;

    cbxField.Properties.Items.BeginUpdate;
    cbxField.Properties.Items.Clear;
    cbxField.Properties.Sorted := True;   //Zusatz und Statusfelder sind sorted, Dokumentfelder nicht

    if popField.Items[0].Checked then       // Zusatzfelder
    begin
      if (not chkMappedFieldsOnly.Checked) then
      begin
        for i := 0 to High(aAddfields) do
        begin
          if (aAddfields[i] <> nil) and (aAddfields[i].DisplayName <> '')
            and ((aAddfields[i].Flags and 2) <> 2) //11.06.2024 BT bfacrm:ticket__show__38924
          then
            cbxField.Properties.Items.AddObject(aAddfields[i].DisplayName, TObject(aAddfields[i].ID));
        end;
      end else
      begin
        lmq := TUniQuery.Create(nil);
        try
          lmq.Connection := dmMain.cntMain;
          lmq.SQL.Text := Format('SELECT sa.fieldid FROM sys_addfieldxs sa '+
           'WHERE sa.arcid = %d GROUP BY sa.fieldid', [Integer(cbxArchive.Properties.Items.Objects[cbxArchive.ItemIndex])]);
          lmq.Open;
          if lmq.RecordCount > 0 then
          begin
            for i := 0 to High(aAddfields) do
            begin
              if (aAddfields[i] <> nil) and (aAddfields[i].DisplayName <> '')
                and ((aAddfields[i].Flags and 2) <> 2) //11.06.2024 BT bfacrm:ticket__show__38924
              then
              begin
                lmq.First;
                for j := 0 to lmq.RecordCount - 1 do
                begin
                  if lmq.FieldByName('fieldid').AsInteger = aAddfields[i].ID then
                  begin
                    cbxField.Properties.Items.AddObject(aAddfields[i].DisplayName, TObject(aAddfields[i].ID));

                    // bei Gridfeldern fgen wir auch die darunter liegenden Felder hinzu
                    if (aAddfields[i].Typ = 13) and (aAddfields[i].ValuesQuery <> '') then
                    begin
                      try
                        var AConfig: TbfaGridConfig;
                        var xmlnode: IXMLDocument;
                        CoInitialize(nil);
                        xmlnode := TXMLDocument.Create(nil);
                        try
                          xmlnode.LoadFromXML(aAddfields[i].ValuesQuery);
                          AConfig := XMLToGridConfig(xmlnode.DocumentElement);

                          for k := 0 to AConfig.Columns.Count - 1 do
                          begin
                            for l := 0 to High(aAddfields) do
                            begin
                              if (aAddfields[l] <> nil) and (aAddfields[l].Name = AConfig.Columns[k].FieldName) then
                              begin
                                cbxField.Properties.Items.AddObject(aAddfields[l].DisplayName, TObject(aAddfields[l].ID));
                                Break;
                              end;
                            end;
                          end;
                        finally
                          CoUninitialize;
                        end;
                      except
                        bitfarmLog.Write(llNormal, ltException, 'tbiAddfieldClick - GridConfig failed', ClassName);
                      end;
                    end;
                    Break;
                  end;
                  lmq.Next;
                end;
              end;
            end;
          end;
          lmq.Close;
        finally
          FreeAndNil(lmq);
        end;
      end;
    end
    else if popField.Items[1].Checked then       // Statusfelder
    begin
      if (not chkMappedFieldsOnly.Checked) then
      begin
        for i := 0 to High(aStatefields) do
        begin
          if (aStatefields[i] <> nil) and (aStatefields[i].DisplayName <> '')
            and ((aStatefields[i].Flags and 2) <> 2) //11.06.2024 BT bfacrm:ticket__show__38924
          then
          begin
            sDisplayName := aStatefields[i].DisplayName;
            if sDisplayName = 'auf Wiedervorlage' then
              sDisplayName := _('auf Wiedervorlage');
            cbxField.Properties.Items.AddObject(sDisplayName, TObject(aStatefields[i].ID));
          end;
        end;
      end else
      begin
        lmq := TUniQuery.Create(nil);
        try
          lmq.Connection := dmMain.cntMain;
          lmq.SQL.Text := Format('SELECT sa.fieldid FROM sys_statefieldxs sa '+
           'WHERE sa.arcid = %d GROUP BY sa.fieldid', [Integer(cbxArchive.Properties.Items.Objects[cbxArchive.ItemIndex])]);
          lmq.Open;
          if lmq.RecordCount > 0 then
          begin
            for i := 0 to High(aStatefields) do
            begin
              if (aStatefields[i] <> nil) and (aStatefields[i].DisplayName <> '') then
              begin
                lmq.First;
                for j := 0 to lmq.RecordCount - 1 do
                begin
                  if lmq.FieldByName('fieldid').AsInteger = aStatefields[i].ID then
                  begin
                    cbxField.Properties.Items.AddObject(aStatefields[i].DisplayName, TObject(aStatefields[i].ID));
                    Break;
                  end;
                  lmq.Next;
                end;
              end;
            end;
          end;

          cbxField.Properties.Items.AddObject(_('auf Wiedervorlage'), TObject(0));

          lmq.Close;
        finally
          FreeAndNil(lmq);
        end;
      end;
    end else begin       // Dokumentfelder
      cbxField.Properties.Items.Assign(DocumentFields);   // durch Assign einer nicht sortierten Liste setzt sich sorted zurck
    end;

    cbxField.Properties.Items.EndUpdate;
    if cbxField.Properties.Items.Count > 0 then
    begin
      cbxField.ItemIndex := 0;
      cbxFieldChange(Sender);
    end;

    edtValue.Visible := tbiAddfield.Checked or tbiDocumentfields.Checked;
    cbxStateValue.Visible := tbiStatefield.Checked;
    lblFieldID.Caption := '';
  except
    bitfarmLog.Write(llNormal, ltException, 'tbiAddfieldClick', ClassName);
  end;
end;


procedure TfrmCreateGlobalBookmark.tbiArchiveClick(Sender: TObject);
var
  i: Integer;
begin
  if btnArchive.Caption = TTBCustomItem(Sender).Caption then
    Exit
  else if sobj <> nil then
  begin
    sobj.Modified := True;
    btnOk.Enabled := True;
  end;

  for i := 0 to popArchive.Items.Count - 1 do
    popArchive.Items[i].Checked := False;

  btnArchive.Caption := TTBCustomItem(Sender).Caption;
  TTBCustomItem(Sender).Checked := True;

  try
    cbxArchive.Properties.Items.BeginUpdate;
    cbxArchive.Properties.Sorted := False;
//    cbxArchive.Clear;
    cbxArchive.Properties.Items.Clear;

    if popArchive.Items[1].Checked then
     cbxArchive.Properties.Items.AddObject(_('alle Archive'), TObject(-1))
    else if popArchive.Items[0].Checked then
      cbxArchive.Properties.Items.AddObject(_('aktuelles Archiv'), TObject(0));

    for i := 0 to High(aSysArc) do
    begin
      if (aSysArc[i].Typ = 0) and popArchive.Items[1].Checked and   // Lager
         (aSysArc[i].Name <> '') and
         ((HasChild(aSysArc[i].Arcid) or bitfarmApp.User.isAdmin))
      then
        cbxArchive.Properties.Items.AddObject(aSysArc[i].Name, TObject(aSysArc[i].Arcid));

      if (aSysArc[i].Typ = 1) and popArchive.Items[0].Checked and   // Archive
         (aSysArc[i].Name <> '') and
         (((aSysArc[i].Rights and rightRead) = rightRead) or bitfarmApp.User.isAdmin)
      then
        cbxArchive.Properties.Items.AddObject(aSysArc[i].Name, TObject(aSysArc[i].Arcid));
    end;
  finally
    cbxArchive.Properties.Items.EndUpdate;
    cbxArchive.Properties.Sorted := True;
    if cbxArchive.Properties.Items.Count > 0 then
      cbxArchive.ItemIndex := 0;
  end;

  ShowArcidLabel;
  if sobj = nil then
    Exit;
end;

procedure TfrmCreateGlobalBookmark.tbiDateFormatClick(Sender: TObject);
var
  i: Integer;
begin
  try
    for i := 0 to popDateFormat.Items.Count - 1 do
      popDateFormat.Items[i].Checked := False;
    btnDateFormat.Caption := TTBCustomItem(Sender).Caption;
    TTBCustomItem(Sender).Checked := True;
  except
    bitfarmLog.Write(llNormal, ltException, 'TfrmCreateGlobalBookmark.tbiDateFormatClick', ClassName);
  end;
end;

procedure TfrmCreateGlobalBookmark.tbiLimitClick(Sender: TObject);
var
  i: Integer;
begin
  try
    for i := 0 to popLimit.Items.Count - 1 do
      popLimit.Items[i].Checked := False;
    btnLimit.Caption := TTBCustomItem(Sender).Caption;
    TTBCustomItem(Sender).Checked := True;

    if sobj <> nil then
    begin
      sobj.Modified := True;
      btnOk.Enabled := sobj.Modified;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'TfrmCreateGlobalBookmark.tbiLimitClick', ClassName);
  end;
end;

procedure TfrmCreateGlobalBookmark.tbiNOTClick(Sender: TObject);
var
  i: Integer;
begin
  if btnNot.Caption = TTBCustomItem(Sender).Caption then
    Exit;

  for i := 0 to popNot.Items.Count - 1 do
      popNot.Items[i].Checked := False;
  btnNot.Caption := TTBCustomItem(Sender).Caption;
  TTBCustomItem(Sender).Checked := True;
end;

procedure TfrmCreateGlobalBookmark.tbiOPClick(Sender: TObject);
var
  i: Integer;
begin
  if btnOperator.Caption = TTBCustomItem(Sender).Caption then
    Exit;

  for i := 0 to popOperator.Items.Count - 1 do
      popOperator.Items[i].Checked := False;
  btnOperator.Caption := TTBCustomItem(Sender).Caption;
  TTBCustomItem(Sender).Checked := True;
end;

procedure TfrmCreateGlobalBookmark.tbiUserClick(Sender: TObject);
var
  i: Integer;
begin
  if btnUser.Caption = TTBCustomItem(Sender).Caption then
    Exit;

  for i := 0 to popUser.Items.Count - 1 do
      popUser.Items[i].Checked := False;
  btnUser.Caption := TTBCustomItem(Sender).Caption;
  TTBCustomItem(Sender).Checked := True;

  cbxUser.Properties.Items.BeginUpdate;
  cbxUser.Properties.Items.Clear;

  if popUser.Items[0].Checked then
    cbxUser.Properties.Items.Assign(DBGetUserList(0, 0, True, True));

  if popUser.Items[1].Checked then
    cbxUser.Properties.Items.Assign(DBGetGroupList(0, 0, True, True));
  cbxUser.Properties.Items.EndUpdate;

  if cbxUser.Properties.Items.Count > 0 then
    cbxUser.ItemIndex := 0;

  ShowUseridLabel;

end;

function TfrmCreateGlobalBookmark.VerifyBookmark: Boolean;
var
  i, cntbrackets: Integer;
begin
  Result := True;
  cntbrackets := 0;
  for i := lstSQLWhere.Items.Count -1 downto 0 do
  begin
    if lstSQLWhere.Items.Objects[i] = nil then
      lstSQLWhere.Items.Delete(i);
  end;

  i := 0;
  while i <  lstSQLWhere.Items.Count - 1 do
  begin
    if (TObject(lstSQLWhere.Items.Objects[i]) is TbfaBracket) and
        (TbfaBracket(lstSQLWhere.Items.Objects[i]).Kind = brClose)  then    // beginnt mit Klammerzu? lschen
    begin
      lstSQLWhere.Items.Delete(i)
    end else
      Break;
  end;

  i := 0;
  while i <  lstSQLWhere.Items.Count - 1 do
  begin
    if TObject(lstSQLWhere.Items.Objects[i]) is TbfaJunction then    // beginnt mit Junction? lschen
    begin
      lstSQLWhere.Items.Delete(i);
    end else
      Break;
  end;

  for i := 0 to lstSQLWhere.Items.Count -1 do
  begin
    if TObject(lstSQLWhere.Items.Objects[i]) is TbfaBracket then
    begin
      if TbfaBracket(lstSQLWhere.Items.Objects[i]).Kind = brOpen then
        Inc(cntbrackets)
      else
        Dec(cntbrackets);
    end;
  end;

  if cntbrackets <> 0 then
  begin
    if cntbrackets > 0 then
    begin
      BfShowMessage(_('Es wurden mehr Klammern geffnet als geschlossen.'));
      Result := False;
      Exit;
    end;

    if cntbrackets < 0 then
    begin
      BfShowMessage(_('Es wurden mehr Klammern geschlossen als geffnet'));
      Result := False;
      Exit;
    end;
  end;

  // Klammerpaare ohne Inhalt ? lschen
  i := 0;
  while i < lstSQLWhere.Items.Count - 2 do
  begin
    if (TObject(lstSQLWhere.Items.Objects[i]) is TbfaBracket) and
        (TObject(lstSQLWhere.Items.Objects[i +1]) is TbfaBracket) then
    begin
      if (TbfaBracket(lstSQLWhere.Items.Objects[i]).Kind = brOpen) and
          (TbfaBracket(lstSQLWhere.Items.Objects[i +1]).Kind = brClose)  then
      begin
        lstSQLWhere.Items.Delete(i);
        lstSQLWhere.Items.Delete(i +1);
      end else
        Inc(i);
    end else
      Inc(i);
  end;

  // Junction direkt nach Klammer auf ? lschen
  i := 0;
  while i < lstSQLWhere.Items.Count - 2 do
  begin
    if (TObject(lstSQLWhere.Items.Objects[i]) is TbfaBracket) and
        (TObject(lstSQLWhere.Items.Objects[i +1]) is TbfaJunction) then
    begin
      if (TbfaBracket(lstSQLWhere.Items.Objects[i]).Kind = brOpen) then
      begin
        lstSQLWhere.Items.Delete(i +1);
      end else
        Inc(i);
    end else
      Inc(i);
  end;

  // Junction direkt nach Klammer zu ? lschen
  i := 0;
  while i < lstSQLWhere.Items.Count - 2 do
  begin
    if (TObject(lstSQLWhere.Items.Objects[i]) is TbfaJunction) and
        (TObject(lstSQLWhere.Items.Objects[i +1]) is TbfaBracket) then
    begin
      if (TbfaBracket(lstSQLWhere.Items.Objects[i +1]).Kind = brClose) then
      begin
        lstSQLWhere.Items.Delete(i +1);
      end else
        Inc(i);
    end else
      Inc(i);
  end;

  // zwei Junction hintereinander? Fail
  for i := 0 to lstSQLWhere.Items.Count - 2 do
  begin
    if (TObject(lstSQLWhere.Items.Objects[i]) is TbfaJunction) and
        (TObject(lstSQLWhere.Items.Objects[i +1]) is TbfaJunction) then
    begin
      BfShowMessage(_('Zwei aufeinanderfolgende logische Verknpfungen.'));
      Result := False;
      lstSQLWhere.ItemIndex := i;
      Exit;
    end;
  end;

  // zwei Expression hintereinander? Fail
  for i := 0 to lstSQLWhere.Items.Count - 2 do
  begin
    if (TObject(lstSQLWhere.Items.Objects[i]) is TbfaExpression) and
        (TObject(lstSQLWhere.Items.Objects[i +1]) is TbfaExpression) then
    begin
      BfShowMessage(_('Zwei aufeinanderfolgende Ausdrcke ohne Verknpfung.'));
      Result := False;
      lstSQLWhere.ItemIndex := i;
      Exit;
    end;
  end;

  // Expression direkt vor Klammer?? Fail
  for i := 0 to lstSQLWhere.Items.Count - 2 do
  begin
    if (TObject(lstSQLWhere.Items.Objects[i]) is TbfaExpression) and
        (TObject(lstSQLWhere.Items.Objects[i +1]) is TbfaBracket) then
    begin
      if (TbfaBracket(lstSQLWhere.Items.Objects[i +1]).Kind = brOpen) then
      begin
        BfShowMessage(_('Ausdruck vor Klammer ohne Verknpfung.'));
        Result := False;
        lstSQLWhere.ItemIndex := i;
        Exit;
      end;
    end;
  end;
end;

end.

