unit DLMForm;

interface

uses
  gnugettext, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxGraphics, cxControls, cxLookAndFeels, cxLookAndFeelPainters,
  cxStyles, cxCustomData, cxFilter, cxData, cxDataStorage, cxEdit, cxNavigator,
  DB, DBClient, cxDBData, cxGridLevel, cxClasses, cxGridCustomView, cxGridCustomTableView,
  cxGridTableView, cxGridDBTableView, cxGrid, cxTextEdit, SpTBXControls, ImgList,
  dxmdaset, cxDropDownEdit, cxSpinEdit, cxCalendar, Math, SpTBXItem, Uni, Generics.Collections, bfaObjects36,
  TB2Item, Menus, dxDateRanges, System.ImageList, cxImageList,
  dxScrollbarAnnotations;

type
  TcxViewInfoAcess = class(TcxGridTableDataCellViewInfo);
  TcxPainterAccess = class(TcxGridTableDataCellPainter);

type
  TfrmDLM = class(TForm)
    pnlDLM: TSpTBXPanel;
    grdDLMTable: TcxGridDBTableView;
    grdDLMLevel: TcxGridLevel;
    grdDLM: TcxGrid;
    btnOK: TSpTBXButton;
    mdtMemData: TdxMemData;
    clmnRecID: TcxGridDBColumn;
    clmnTyp: TcxGridDBColumn;
    clmnName: TcxGridDBColumn;
    clmnItem: TcxGridDBColumn;
    clmnDuration: TcxGridDBColumn;
    clmnInterval: TcxGridDBColumn;
    clmnDate: TcxGridDBColumn;
    clmnMode: TcxGridDBColumn;
    clmnOrder: TcxGridDBColumn;
    clmnModified: TcxGridDBColumn;
    clmnID: TcxGridDBColumn;
    mdtMemDataName: TStringField;
    mdtMemDataAuswahl: TStringField;
    mdtMemDataDauer: TStringField;
    mdtMemDataInterval: TStringField;
    mdtMemDataDatum: TStringField;
    mdtMemDataTyp: TIntegerField;
    mdtMemDataOrder: TFloatField;
    popInfo: TSpTBXPopupMenu;
    imgFields: TcxImageList;
    procedure grdDLMTableCustomDrawCell(Sender: TcxCustomGridTableView;
      ACanvas: TcxCanvas; AViewInfo: TcxGridTableDataCellViewInfo;
      var ADone: Boolean);
    procedure grdDLMTableDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure grdDLMTableDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure grdDLMTableStartDrag(Sender: TObject;
      var DragObject: TDragObject);
    procedure ReorderRows(AView: TcxGridTableView; ADestRow: TcxCustomGridRecord);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure DLMDataChange(Sender: TObject; Field: TField);
    procedure clmnItemPropertiesCloseUp(Sender: TObject);
    procedure clmnIntervalPropertiesCloseUp(Sender: TObject);
    procedure clmnDatePropertiesEditValueChanged(Sender: TObject);
    procedure clmnDurationPropertiesEditValueChanged(Sender: TObject);
    procedure SetOrderValue(DS: TDataSet; AValue: Variant);
    procedure popInfoInitPopup(Sender: TObject; PopupView: TTBView);
    procedure clmnDatePropertiesInitPopup(Sender: TObject);
    procedure clmnDatePropertiesValidate(Sender: TObject;
      var DisplayValue: Variant; var ErrorText: TCaption; var Error: Boolean);
  private
    { Private-Deklarationen }
    AKeys: Variant;

    Intervals: TStringList;
    function GetEntryByFieldid(fieldid, ftype: Integer): TbfaDLM;
    function GetEntryByID(id: Integer): TbfaDLM;
    procedure SetModified;
    procedure DBGridDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ResequenceCDS(cds: TClientDataSet; FromRow: Integer);
    procedure MoveRecord(cds: TClientDataSet; OldPos, NewPos: Integer);
    procedure SetCurrentItem(entry: TbfaDLM);
  public
    { Public-Deklarationen }
    Entries: TList<TbfaDLM>;
    DLMDataSet: TClientDataSet;
    DLMDataSource : TDataSource;
    procedure Retranslate;
  end;

//01.02.2019 wegen Crashlog 
//var
//  frmDLM: TfrmDLM;

implementation

uses
  bfaCommonDB, bfaCommonMethods, DateUtils, StdCtrls, bfaCommonUtils;


{$R *.dfm}
procedure TfrmDLM.SetOrderValue(DS: TDataSet; AValue: Variant);
var
  idx, id : Integer;
  entry : TbfaDLM;
  value: Variant;
begin
//  DS.Edit;
//  DS.FieldByName('Order').Value := AValue;
//  DS.FieldByName('Modified').Value := 1;
//  DS.Post;

  entry := GetEntryByID(DS.FieldByName('ID').Value);

  if entry <> nil then
  begin
    entry.Prio := AValue;
    entry.Modified := True;
  end;
end;

procedure TfrmDLM.clmnDatePropertiesEditValueChanged(Sender: TObject);
var
  idx, id : Integer;
  entry : TbfaDLM;
  value: Variant;
begin

// das macht nicht wirklich Sinn! das Datum von morgen ist morgen schon heute
//  if (Trunc(TcxDateEdit(Sender).Date) <= Trunc(Now()))
//       and not (IsEmptyDate(TcxDateEdit(Sender).Date))  then
//  begin
//    BfShowMessage(_('Das Lschdatum muss mindestens auf morgen gesetzt sein.'));
//    TcxDateEdit(Sender).Date := Tomorrow();
//  end;

  if VarIsNull(TcxDateEdit(Sender).EditValue) then
    value := null
  else
    value := TcxDateEdit(Sender).Date;

  if DLMDataSet.Fields[2].Value = 0 then   // Statusfeld? Combo leer
  begin
    entry := GetEntryByFieldid(DLMDataSet.Fields[3].Value, DLMDataSet.Fields[2].Value);

  end else begin
//    idx :=  TcxComboBoxProperties(clmnItem.Properties).Items.IndexOf(DLMDataSet.Fields[5].Value);
    idx := IndexOfCaseSensitive(TcxComboBoxProperties(clmnItem.Properties).Items, DLMDataSet.Fields[5].Value);
    if idx > -1 then
    begin
      id := Integer(TcxComboBoxProperties(clmnItem.Properties).Items.Objects[idx]);
      entry := GetEntryByID(id);
    end;
  end;

  if entry <> nil then
  begin
    entry.Duration := 0;
    entry.Interval := '';
    if VarIsNull(value) then
      entry.Date := cUnassignedDate
    else
      entry.Date := value;
    entry.Modified := True;
    DLMDataSet.Edit;
    DLMDataSet.FieldByName('Duration').Value := 0;
    DLMDataSet.FieldByName('Interval').Value := '';
    DLMDataSet.FieldByName('Date').Value := value;
    DLMDataSet.FieldByName('Modified').Value := 1;
    DLMDataSet.Post;
  end;


end;

procedure TfrmDLM.clmnDatePropertiesInitPopup(Sender: TObject);
var
  entry : TbfaDLM;
begin
  entry := GetEntryByID(DLMDataSet.FieldByName('ID').Value);

  if entry <> nil then
  begin
    if entry.Typ = 2 then
      Abort;
  end;
end;

procedure TfrmDLM.clmnDatePropertiesValidate(Sender: TObject;
  var DisplayValue: Variant; var ErrorText: TCaption; var Error: Boolean);
begin
  // bfacrm:ticket__show__16812
  if Error then
  begin
    DisplayValue := '';
    Error := False;
  end;
end;

procedure TfrmDLM.clmnDurationPropertiesEditValueChanged(Sender: TObject);
var
  idx, id : Integer;
  entry : TbfaDLM;
  value: Variant;
begin
  value := TcxSpinEdit(Sender).Value;

  if (DLMDataSet.Fields[2].Value = 0) or (DLMDataSet.Fields[2].Value = 2) then   // Statusfeld oder DLM Datum? Combo leer
  begin
    entry := GetEntryByFieldid(DLMDataSet.Fields[3].Value, DLMDataSet.Fields[2].Value);
  end
  else begin
//    idx :=  TcxComboBoxProperties(clmnItem.Properties).Items.IndexOf(DLMDataSet.Fields[5].Value);
    idx := IndexOfCaseSensitive(TcxComboBoxProperties(clmnItem.Properties).Items, DLMDataSet.Fields[5].Value);
    if idx > -1 then
    begin
      id := Integer(TcxComboBoxProperties(clmnItem.Properties).Items.Objects[idx]);
      entry := GetEntryByID(id);
    end;
  end;

  if entry <> nil then
  begin
    if VarIsNull(value) then
      entry.Duration := 0
    else
      entry.Duration := value;
    entry.Date := cUnassignedDate;
    if entry.Duration = 0 then
      entry.Interval := '';
    entry.Modified := True;
    DLMDataSet.Edit;
    DLMDataSet.FieldByName('Duration').Value := value;
    if entry.Duration = 0 then
      DLMDataSet.FieldByName('Interval').Value := entry.Interval;
    DLMDataSet.FieldByName('Date').Value := null;
    DLMDataSet.FieldByName('Modified').Value := 1;
    DLMDataSet.Post;
  end;

end;

procedure TfrmDLM.clmnIntervalPropertiesCloseUp(Sender: TObject);
var
  idx, id, valindex : Integer;
  entry : TbfaDLM;
  value: Variant;
begin
  value := TcxComboBox(Sender).Text;
  valindex := TcxComboBox(Sender).ItemIndex;

  if valindex = -1 then
    Exit;

  if (DLMDataSet.Fields[2].Value = 0) or (DLMDataSet.Fields[2].Value = 2) then   // Statusfeld oder DLM Datum? Combo leer
  begin
    entry := GetEntryByFieldid(DLMDataSet.Fields[3].Value, DLMDataSet.Fields[2].Value);

  end else begin
//    idx :=  TcxComboBoxProperties(clmnItem.Properties).Items.IndexOf(DLMDataSet.Fields[5].Value);
    idx := IndexOfCaseSensitive(TcxComboBoxProperties(clmnItem.Properties).Items, DLMDataSet.Fields[5].Value);
    if idx > -1 then
    begin
      id := Integer(TcxComboBoxProperties(clmnItem.Properties).Items.Objects[idx]);
      entry := GetEntryByID(id);
    end;
  end;

  if entry <> nil then
  begin
    entry.Interval := Intervals[valindex];
    entry.Date := cUnassignedDate;
    entry.Modified := True;
    if entry.Interval = 'c' then
      entry.Duration := 0;

    DLMDataSet.Edit;
    DLMDataSet.FieldByName('Interval').Value := value;
    DLMDataSet.FieldByName('Date').Value := null;
    DLMDataSet.FieldByName('Duration').Value := entry.Duration;
    DLMDataSet.FieldByName('Modified').Value := 1;
    DLMDataSet.Post;
  end;
end;

procedure TfrmDLM.clmnItemPropertiesCloseUp(Sender: TObject);
var
  idx, id : Integer;
  entry : TbfaDLM;
  value : WideString;
begin
//  idx := TcxComboBoxProperties(clmnItem.Properties).Items.IndexOf(DLMDataSet.Fields[5].Value);
  idx := TcxComboBox(Sender).ItemIndex;
  value := TcxComboBox(Sender).Text;
  if idx > -1 then
  begin
    id := Integer(TcxComboBoxProperties(clmnItem.Properties).Items.Objects[idx]);
    entry := GetEntryByID(id);
    if entry = nil then
      Exit;
    entry.Modified := True;
    SetCurrentItem(entry);
    DLMDataSet.Edit;
    DLMDataSet.Fields[1].Value := id;
    DLMDataSet.Fields[5].Value := value;
    DLMDataSet.Fields[6].Value := entry.Duration;
    DLMDataSet.Fields[7].Value := TcxComboBoxProperties(clmnInterval.Properties).Items[Intervals.IndexOf(entry.Interval)];
    if VarIsNullDate(entry.Date) or IsEmptyDate(entry.Date) then
      DLMDataSet.Fields[8].Value := null
    else
      DLMDataSet.Fields[8].Value := entry.Date;
    DLMDataSet.Post;
  end;
end;

procedure TfrmDLM.DLMDataChange(Sender: TObject; Field: TField);
var
  entry : TbfaDLM;
  j, k : Integer;
begin
  if DLMDataSource.DataSet = nil then
    Exit;

  if DLMDataSet.RecNo <= 0 then
    Exit;

  if Field <> nil then  // wir reduzieren die anzahl der aufrufe nach einen oncloseup der comboboxfelder
    Exit;

  TcxComboBoxProperties(clmnItem.Properties).Items.BeginUpdate;
  if (DLMDataSet.Fields[2].Value = 0) or (DLMDataSet.Fields[2].Value = 2) then   // Statusfeld, DLM Datum? Combo leer
  begin
    TcxComboBoxProperties(clmnItem.Properties).Items.Clear;

  end else begin
    entry := GetEntryByFieldid(DLMDataSet.Fields[3].Value, DLMDataSet.Fields[2].Value);
    TcxComboBoxProperties(clmnItem.Properties).Items.Clear;
    TcxComboBoxProperties(clmnItem.Properties).Items.AddStrings(entry.Items);

    for j := 0 to TcxComboBoxProperties(clmnItem.Properties).Items.Count -1 do
    begin
      for k := 0 to Entries.Count -1 do
      begin
        if (TcxComboBoxProperties(clmnItem.Properties).Items[j] = Entries[k].Item) and
            (entry.Fieldid = Entries[k].Fieldid) and (entry.Typ = Entries[k].Typ)
        then   // wir haben das Item in den Entries gefunden
        begin
          TcxComboBoxProperties(clmnItem.Properties).Items.Objects[j] := TObject(Entries[k].ID);  // wir weisen dem EIntrag in clmnItem die ID des DLM EIntrages zu
          Break;
        end;
      end;
    end;

  end;
  TcxComboBoxProperties(clmnItem.Properties).Items.EndUpdate;

end;

procedure TfrmDLM.FormCreate(Sender: TObject);
begin
  DLMDataSet := TClientDataSet.Create(nil);
  DLMDataSource := TDataSource.Create(nil);

  DLMDataSet.FieldDefs.Add('RecId', ftInteger, 0);         // [0] RecordID
  DLMDataSet.FieldDefs.Add('ID', ftInteger, 0);            // [1] ID
  DLMDataSet.FieldDefs.Add('Typ', ftInteger, 0);           // [2] DLM Typ
  DLMDataSet.FieldDefs.Add('Fieldid', ftInteger, 0);       // [3] Fieldid
  DLMDataSet.FieldDefs.Add('Name', ftWideString, 20);          // [4] Name des Feldes
  DLMDataSet.FieldDefs.Add('Item', ftWideString, 20);          // [5] Auswahlitem
  DLMDataSet.FieldDefs.Add('Duration', ftInteger, 0);
  DLMDataSet.FieldDefs.Add('Interval', ftString, 20);
  DLMDataSet.FieldDefs.Add('Date', ftDateTime, 0);
  DLMDataSet.FieldDefs.Add('Mode', ftString, 20);
  DLMDataSet.FieldDefs.Add('Order', ftFloat, 0);
  DLMDataSet.FieldDefs.Add('Modified', ftInteger, 0);
  DLMDataSet.IndexFieldNames := 'Order';
  DLMDataSet.CreateDataSet;
  DLMDataSource.DataSet := DLMDataSet;
  grdDLMTable.DataController.DataSource := DLMDataSource;
  grdDLMTable.DataController.KeyFieldNames := 'RecId';

  DLMDataSource.OnDataChange := DLMDataChange;

  Entries := TList<TbfaDLM>.Create;
  Intervals := TStringList.Create;
  Intervals.CommaText := ',d,w,m,y,c';

  TranslateComponent(Self, 'ViewerV36');
end;

procedure TfrmDLM.Retranslate;
begin
  ReTranslateComponent(Self, 'ViewerV36');
end;

procedure TfrmDLM.FormShow(Sender: TObject);
var
  lmq: TUniQuery;
  tempDLM: TbfaDLM;
  i, j, k, RecID, fieldid, prio : Integer;
  Inserted : TStringList;
  found : Boolean;
  vdate: Variant;
begin
//  Entries.Clear;
  prio := 0;
  fieldid := -1;
  lmq := DbCreateQuery;
  try
    if Entries.Count = 0 then
    begin
      lmq.SQL.Text := 'select d.id, d.type, d.fieldid, d.item, d.prio, d.mode, d.duration, d.interval, d.date, a.displayname as aname, a.items, s.displayname as sname ' +
                        'from sys_doclifecycle as d left join sys_addfields as a on d.fieldid = a.addfieldid left join sys_statefields as s on d.fieldid = s.stateid order by prio asc';
      lmq.Execute;
      if lmq.RecordCount > 0 then
      begin
        lmq.First;
        while not lmq.Eof do
        begin
          tempDLM := TbfaDLM.Create;
          tempDLM.ID := lmq.FieldByName('id').AsInteger;
          tempDLM.Typ := lmq.FieldByName('type').AsInteger;
          tempDLM.Fieldid := lmq.FieldByName('fieldid').AsInteger;
          if tempDLM.Fieldid <> fieldid then
          begin
            fieldid := tempDLM.Fieldid;
            inc(prio);
          end;

          tempDLM.Item := lmq.FieldByName('item').AsWideString;
          tempDLM.Prio := prio;
          tempDLM.Mode := lmq.FieldByName('mode').AsInteger;
          tempDLM.Duration := lmq.FieldByName('duration').AsInteger;
          tempDLM.Interval := lmq.FieldByName('interval').AsString;
          vdate := lmq.FieldByName('date').AsVariant;   // erst checken ob das Feld in der Datenbank nicht NULL ist
          if not (VarIsNull(vdate) or IsEmptyDate(vdate)) then
            tempDLM.Date := lmq.FieldByName('date').AsDateTime;

          if tempDLM.Typ = 0 then  //Statusfeld
          begin
            tempDLM.Name := lmq.FieldByName('sname').AsString;
          end else begin
            tempDLM.Name := lmq.FieldByName('aname').AsString;
            tempDLM.Items.DelimitedText := lmq.FieldByName('items').AsString;
          end;

          Entries.Add(tempDLM);

          lmq.Next;

          // der jeweils erste Eintrag erhlt das CurrentItem Flag (wird bentigt fr auswahllisten
          found := False;
          for i := 0 to Entries.Count -1 do
          begin
            if (Entries.Items[i].Fieldid = tempDLM.FieldID) and (Entries.Items[i].Typ = tempDLM.Typ) and
                (Entries.Items[i].ID <> tempDLM.ID) then  // wir haben schon ein Item von diesem Feld? dann berspringen wir
            begin
              found := True;
              Break;
            end;
          end;
          if not found then
            tempDLM.CurrentItem := True;

        end;
      end;
    end;

    DLMDataSet.DisableControls;
    DLMDataSet.Open;
    DLMDataSet.First;
    DLMDataSet.EmptyDataSet;

    RecID := 0;
    Inserted := TStringList.Create;
    TcxComboBoxProperties(clmnInterval.Properties).Items.StrictDelimiter := True;
    TcxComboBoxProperties(clmnInterval.Properties).Items.CommaText := ',' + _('Tag(e)') + ',' + _('Woche(n)') + ',' + _('Monat(e)') + ',' + _('Jahr(e)') + ',' + _('Nie (leeren)');
    for i := 0 to Entries.Count -1 do
    begin
      if not Entries.Items[i].CurrentItem then  // nur das CurrentItem anzeigen (Status und Datumsfelder sind immer currentitem
        Continue;                               // bei auswahlfeld ist es beim start das erste, danach das zuletzt angezeigte item

      // Statusfelder
      if Entries.Items[i].Typ = 0 then
      begin
        DLMDataSet.Append;
        DLMDataSet.Fields[0].Value := RecID;
        DLMDataSet.Fields[1].Value := Entries.Items[i].ID;
        DLMDataSet.Fields[2].Value := Entries.Items[i].Typ;
        DLMDataSet.Fields[3].Value := Entries.Items[i].Fieldid;
        DLMDataSet.Fields[4].Value := Entries.Items[i].Name;
        //TcxComboBoxProperties(clmnInterval.Properties).Items.CommaText := ',Tag,Woche,Monat,Jahr';
        if Entries.Items[i].Duration <> 0 then
          DLMDataSet.Fields[6].Value := Entries.Items[i].Duration;
        DLMDataSet.Fields[7].Value := TcxComboBoxProperties(clmnInterval.Properties).Items[Intervals.IndexOf(Entries.Items[i].Interval)];
        if not (VarIsNullDate(Entries.Items[i].Date) or IsEmptyDate(Entries.Items[i].Date)) then
          DLMDataSet.Fields[8].Value := Entries.Items[i].Date
        else
          DLMDataSet.Fields[8].Value := null;
//        TcxDateEditProperties(clmnDate.Properties).MinDate := Tomorrow();
        DLMDataSet.Fields[9].Value := Entries.Items[i].Mode;
        DLMDataSet.Fields[10].Value := Entries.Items[i].Prio;
        DLMDataSet.Fields[11].Value := 0;
        DLMDataSet.Post;
        Inc(RecID);
        Continue;
      end else begin  //DLM Auswahl oder Datumsfelder
        if Inserted.IndexOf(IntToStr(Entries.Items[i].Fieldid)) > -1 then   // schon vorhanden? berspringen
          Continue;

        DLMDataSet.Append;
        DLMDataSet.Fields[0].Value := RecID;
        DLMDataSet.Fields[1].Value := Entries.Items[i].ID;
        DLMDataSet.Fields[2].Value := Entries.Items[i].Typ;
        DLMDataSet.Fields[3].Value := Entries.Items[i].Fieldid;
        DLMDataSet.Fields[4].Value := Entries.Items[i].Name;
        if Entries.Items[i].Items.Count > 0 then
          // DLMDataSet.Fields[5].Value := Entries.Items[i].Items[0]
          DLMDataSet.Fields[5].Value := Entries.Items[i].Item
        else
          DLMDataSet.Fields[5].Value := '';

        TcxComboBoxProperties(clmnItem.Properties).Items.AddStrings(Entries.Items[i].Items);
        //TcxComboBoxProperties(clmnInterval.Properties).Items.CommaText := ',Tag,Woche,Monat,Jahr';
        if Entries.Items[i].Duration <> 0 then
          DLMDataSet.Fields[6].Value := Entries.Items[i].Duration;
        DLMDataSet.Fields[7].Value := TcxComboBoxProperties(clmnInterval.Properties).Items[Intervals.IndexOf(Entries.Items[i].Interval)];
        if not (VarIsNullDate(Entries.Items[i].Date) or IsEmptyDate(Entries.Items[i].Date)) then
          DLMDataSet.Fields[8].Value := Entries.Items[i].Date
        else
          DLMDataSet.Fields[8].Value := null;
//        TcxDateEditProperties(clmnDate.Properties).MinDate := Tomorrow();
        DLMDataSet.Fields[9].Value := Entries.Items[i].Mode;
        DLMDataSet.Fields[10].Value := Entries.Items[i].Prio;
        DLMDataSet.Fields[11].Value := 0;
        DLMDataSet.Post;
        Inserted.Add(IntToStr(Entries.Items[i].Fieldid));

        // nun in der Combobox die eintrge durchlaufen und die id des passenden entries hinzufgen

        for j := 0 to TcxComboBoxProperties(clmnItem.Properties).Items.Count -1 do
        begin
          for k := 0 to Entries.Count -1 do
          begin
            if (TcxComboBoxProperties(clmnItem.Properties).Items[j] = Entries[k].Item) and
               (Entries.Items[i].Fieldid = Entries[k].Fieldid) and (Entries.Items[i].Typ = Entries[k].Typ) then   // wir haben das Item in den Entreis gefunden
            begin
              TcxComboBoxProperties(clmnItem.Properties).Items.Objects[j] := TObject(Entries[k].ID);
              Break;
            end;
          end;
        end;

        Inc(RecID);
        Continue;
      end;
    end;
  finally
    lmq.Free;

    DLMDataSet.First;
    DLMDataSet.Active := True;
    DLMDataSet.EnableControls;
    Paint;
  end;

end;

function TfrmDLM.GetEntryByFieldid(fieldid, ftype: Integer): TbfaDLM;
var
  i : Integer;
begin
  Result := nil;
  for i := 0 to Entries.Count -1 do
  begin
    if (Entries[i].Fieldid = fieldid) and (Entries[i].Typ = ftype) then
    begin
      Result := Entries[i];
      Break;
    end;
  end;
end;

function TfrmDLM.GetEntryByID(id: Integer): TbfaDLM;
var
  i : Integer;
begin
  Result := nil;
  for i := 0 to Entries.Count -1 do
  begin
    if Entries[i].ID = id then
    begin
      Result := Entries[i];
      Break;
    end;
  end;
end;

procedure TfrmDLM.grdDLMTableCustomDrawCell(Sender: TcxCustomGridTableView;
  ACanvas: TcxCanvas; AViewInfo: TcxGridTableDataCellViewInfo;
  var ADone: Boolean);
var
  APainter: TcxPainterAccess;
  idx : Integer;
begin
  if not (AViewInfo.EditViewInfo is TcxCustomTextEditViewInfo) then
      Exit;
  if AViewInfo.Item.Index <> clmnName.Index then
    Exit;

  APainter := TcxPainterAccess(TcxViewInfoAcess(AViewInfo).GetPainterClass.Create(ACanvas, AViewInfo));
  with APainter do
  begin
    try
      with TcxCustomTextEditViewInfo(AViewInfo.EditViewInfo).TextRect do
        Left := Left + imgFields.Width + 2;

      DrawContent;
      DrawBorders;

      if Not VarIsNull(AViewInfo.GridRecord.Values[clmnTyp.Index]) then
      begin
        idx := AViewInfo.GridRecord.Values[clmnTyp.Index];
        with AViewInfo.ClientBounds do
//19.10.2021          imgFields.Draw(ACanvas.Canvas, Left + 1, Top + 1, idx);
          imgFields.Draw(ACanvas.Canvas, Left + 1, Top, idx);
      end;
    finally
      Free;
    end;
  end;
  ADone := True;

end;

procedure TfrmDLM.grdDLMTableDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  HT: TcxCustomGridHitTest;
begin
  with TcxGridSite(Sender) do
  begin
    HT := ViewInfo.GetHitTest(X, Y);
    //ReorderRows(TcxGridTableView(GridView), TcxGridRecordCellHitTest(HT).GridRecord);
    DBGridDragDrop(Sender, Source, X, Y);
  end;
end;

procedure TfrmDLM.grdDLMTableDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
var
  HT: TcxCustomGridHitTest;
begin
  with TcxGridSite(Sender) do
  begin
    HT := ViewInfo.GetHitTest(X, Y);
    Accept := (HT is TcxGridRecordCellHitTest) and (TcxGridRecordCellHitTest(HT).GridRecord.RecordIndex <> GridView.DataController.FocusedRecordIndex)
  end;
end;

procedure TfrmDLM.grdDLMTableStartDrag(Sender: TObject;
  var DragObject: TDragObject);
begin
  with TcxGridDBTableView(TcxGridSite(Sender).GridView) do
    AKeys := DataController.DataSet.FieldValues['RecId'];
end;

procedure TfrmDLM.popInfoInitPopup(Sender: TObject; PopupView: TTBView);
var
  fieldid : Integer;
  lmq: TUniQuery;
  i : Integer;
  item : TTBRootItem;
begin
  popInfo.Items.Clear;
  if not VarIsNull(grdDLMTable.DataController.DataSet.FieldValues['Fieldid']) then //22.10.2018 Ticket 16383
  begin
    fieldid := grdDLMTable.DataController.DataSet.FieldValues['Fieldid'];
    item :=  TTBRootItem.Create(nil);
    item.Caption := 'ID: ' + IntToStr(fieldid);
    popInfo.Items.Add(item);
    lmq := DbCreateQuery;
    try
      if grdDLMTable.DataController.DataSet.FieldValues['Typ']  = 0 then
        lmq.SQL.Text := 'select a.arcname from sys_arc as a left join sys_statefieldxs as x on a.arcid = x.arcid where fieldid = ' + IntToStr(fieldid) + ' group by a.arcid order by a.arcname'
      else
        lmq.SQL.Text := 'select a.arcname from sys_arc as a left join sys_addfieldxs as x on a.arcid = x.arcid where fieldid = ' + IntToStr(fieldid) + ' group by a.arcid order by a.arcname';
      lmq.Execute;
      if lmq.RecordCount > 0 then
      begin
        i := 0;
        lmq.First;
        while not lmq.Eof do
        begin
          item :=  TTBRootItem.Create(nil);
          item.Caption := lmq.FieldByName('arcname').AsWideString;
          popInfo.Items.Add(item);
          Inc(i);
          if i > 10 then
          begin
            item :=  TTBRootItem.Create(nil);
            item.Caption := '...';
            popInfo.Items.Add(item);
            Break;
          end;
          lmq.Next;
        end;
      end;
    finally
      lmq.Free;
    end;
  end;
end;

procedure TfrmDLM.ReorderRows(AView: TcxGridTableView;
  ADestRow: TcxCustomGridRecord);
var
  I: Integer;
  ADC: TcxDBDataController;
  AOrderValue: Variant;
  AOrderColumnIndex: Integer;
  IsUpper: Boolean;
begin
  with AView do
  begin
    ADC := TcxDBDataController(DataController);
    AOrderColumnIndex := TcxGridColumn(ADC.GetItemByFieldName('Order')).Index;
    AOrderValue := ADestRow.Values[AOrderColumnIndex];
    IsUpper := ADestRow .Index < ADC.GetRowIndexByRecordIndex(ADC.FindRecordIndexByKey(AKeys), False);
  end;
  ADestRow.Focused := True;
  SetOrderValue(ADC.DataSet, Round(AOrderValue - Ord(not IsUpper) + 0.5));  // move dragged record 1 record lower
  ADC.LocateByKey(AKeys); // focus the dragged record in the DataSet
  SetOrderValue(ADC.DataSet, AOrderValue);
  if isUpper then
    ADC.GotoLast
  else
    ADC.GotoFirst;
  I := 0;
  while ADC.Values[ADC.FocusedRecordIndex, AOrderColumnIndex] <> AOrderValue do
  begin
    SetOrderValue(ADC.DataSet, Ord(IsUpper) * ADC.RowCount - Sign(Ord(IsUpper) - 0.1) * (I + Ord(not IsUpper)));
    Inc(I);
    if IsUpper then
      ADC.GotoPrev
    else
      ADC.GotoNext;

    if I > ADC.RowCount then
      Break;
  end;
end;

procedure TfrmDLM.SetCurrentItem(entry: TbfaDLM);
var
  i : Integer;
begin
  // erst alle Entries dieses Feldes und Typs suchen und CurrentItem zurcksetzen

  for i := 0 to Entries.Count -1 do
  begin
    if (Entries.Items[i].Fieldid = entry.FieldID) and (Entries.Items[i].Typ = entry.Typ) then
      Entries.Items[i].CurrentItem := False;
  end;
  entry.CurrentItem := True;
end;

procedure TfrmDLM.SetModified;
begin
  DLMDataSet.Edit;
  DLMDataSet.FieldByName('Modified').Value := 1;
  DLMDataSet.Post;
end;



procedure TfrmDLM.DBGridDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  GridRow: Integer;
  OriginalRow: Integer;
  HT: TcxCustomGridHitTest;
  ADC: TcxDBDataController;
begin
    with TcxGridSite(Sender) do
  begin
    HT := ViewInfo.GetHitTest(X, Y);

  end;

  GridRow := TcxGridRecordCellHitTest(HT).GridRecord.Index +1;
  //GridRow := grdDLM.MouseCoord(X,Y).Y;

  if GridRow = 0 then
    GridRow := 1;
//  if (Source is TListBox) then
//  begin
//    //An item is being dropped into the DBGrid
//    if DLMDataSet.IsEmpty then
//    begin
//    //The grid is empty. Add the item in the first position
//      DLMDataSet.AppendRecord([1, TListBox(Source).Items[TListBox(Source).ItemIndex], RandomRange(1, 101)]);
//    end
//    else
//    begin
//      //Insert the item at the position of the drop
//      if GridRow = -1 then //the drop is at the end of the DBGrid
//        GridRow := DLMDataSet.RecordCount + 1
//      else //the drop needs to be inserted into the DBGrid. Make room
//        ResequenceCDS(DLMDataSet, GridRow);
//      //Insert the new item at the drop position
//      DLMDataSet.InsertRecord([GridRow, TListBox(Source).Items[TListBox(Source).ItemIndex], RandomRange(1, 101)]);
//    end;
//    //Remove the dropped item from the source (optional)
//    TListBox(Source).Items.Delete(TListBox(Source).ItemIndex);
//  end
//  else
//  if Source = Sender then
  if Source is TcxDragControlObject then
  begin
    //We are dragging within the DBGrid
    if DLMDataSet.IsEmpty then exit;

    ADC := TcxDBDataController(grdDLMTable.DataController);
    OriginalRow :=  ADC.GetRowIndexByRecordIndex(ADC.FindRecordIndexByKey(AKeys), False) +1;
    if (OriginalRow = GridRow) or (GridRow = -1) then
      Exit
    else
      MoveRecord(DLMDataSet, OriginalRow, GridRow);
  end;
end;

procedure TfrmDLM.ResequenceCDS(cds: TClientDataSet; FromRow: Integer);
var
  clone: TClientDataSet;
  SequenceFld: TField;
begin
  clone := TClientDataSet.Create(nil);
  try
    clone.CloneCursor(cds, True);
    SequenceFld := clone.FieldByName('Order');
    begin
      //Shift all records down to make room in the sequence
      //for the record being inserted
      clone.Last;
      while (SequenceFld.AsInteger >= FromRow) and not clone.bof do
      begin
        clone.Edit;
        SequenceFld.AsInteger := SequenceFld.AsInteger + 1;
        clone.Post;
        clone.Prior;
      end;
    end
  finally
    clone.Free;
  end;
end;

procedure TfrmDLM.MoveRecord(cds: TClientDataSet; OldPos, NewPos: Integer);
var
  clone: TClientDataSet;
  SequenceFld: TField;
  recno : Integer;
begin
  clone := TClientDataSet.Create(nil);
  try
    clone.CloneCursor(cds, True);
    clone.IndexFieldNames := 'Order';
    SequenceFld := clone.FieldByName('Order');
    clone.RecNo := OldPos;
    clone.Edit;
    //Move the record being moved to the end of the sequence
    SequenceFld.AsInteger := cds.RecordCount + 1;
    SetOrderValue(clone, SequenceFld.AsInteger);
    clone.Post;

    if OldPos < NewPos then
    begin
      //Shift the records after the original old position up one position
      clone.RecNo := OldPos;
      while (clone.RecNo < NewPos) do
      begin
        clone.Edit;
        SequenceFld.AsInteger := SequenceFld.AsInteger - 1;
        SetOrderValue(clone, SequenceFld.AsInteger);
        clone.Post;

        clone.Next;
      end;
    end
    else
    begin
      //Shift the record before the original position down one position
      //clone.IndexFieldNames := 'Order';
      clone.RecNo := OldPos - 1;
      while (clone.RecNo >= NewPos) and (not clone.bof) do
      begin
        recno := clone.RecNo;
        clone.Edit;
        SequenceFld.AsInteger := SequenceFld.AsInteger + 1;
        SetOrderValue(clone, SequenceFld.AsInteger);
        clone.Post;

        clone.Prior;
        //clone.RecNo := recno -1;
      end;
    end;
    //Move the record being moved to its new position
    clone.RecNo := cds.RecordCount;
    clone.Edit;
    SequenceFld.AsInteger := NewPos;
    SetOrderValue(clone, SequenceFld.AsInteger);
    clone.Post;

  finally
    clone.Free;
  end;
  cds.RecNo := NewPos;
end;


end.
