unit ELManagerFrm;

interface

uses
  EException,
  EEvents,
  SysUtils, Classes;

type
  TfrmElManager = class(TDataModule)
    procedure DataModuleCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ELAttachZippedLogs(AExceptionInfo : TEurekaExceptionInfo;
      const ATempFolder : string; AAttachedFiles : TStrings; var ACallNextHandler : Boolean);
  end;

var
  frmElManager: TfrmElManager;

implementation

uses
  bfaLog, bfaCommonUtils, Windows;

{$R *.dfm}

// Lets add some other log files to the usual EL file and screen shot...
procedure TfrmElManager.ELAttachZippedLogs(AExceptionInfo : TEurekaExceptionInfo;
  const ATempFolder : string; AAttachedFiles : TStrings; var ACallNextHandler : Boolean);
var
  ClonedLogName, OldFileName, NewFileName: string;
begin
  try
    if Assigned(bitfarmLog) then
    begin
      ClonedLogName := bitfarmLog.FlushAndClone; // copy the current log to a temp clone file and return the fully-qualified path and name of new file
      if Length(ClonedLogName) > 0 then // it is possible that there were no lines in the log file. Skip the log file send if it is empty
        AAttachedFiles.Add(ClonedLogName); // add the cloned log file to the ELP file that will be sent to MantisBT

      //04.07.2023 Bei CrashLogs knnte zustzlich helfen... -->
      try
        OldFileName := BD.EnvAppdataPd + '\bitfarm-archiv\Viewer.ini';
        NewFileName := BD.EnvAppdataPd + '\bitfarm-archiv\Bug Reports\Viewer.ini';
        CopyFile(PWideChar(OldFileName), PWideChar(NewFileName), False);
        if Length(NewFileName) > 0 then
          AAttachedFiles.Add(NewFileName);
      except
      end;

      try
        OldFileName := BD.EnvAppdataPd + '\bitfarm-archiv\ViewerLayout.ini';
        NewFileName := BD.EnvAppdataPd + '\bitfarm-archiv\Bug Reports\ViewerLayout.ini';
        CopyFile(PWideChar(OldFileName), PWideChar(NewFileName), False);
        if Length(NewFileName) > 0 then
          AAttachedFiles.Add(NewFileName);
      except
      end;

      try
        OldFileName := BD.EnvAppdataPd + '\bitfarm-archiv\ViewerOptions.ini';
        NewFileName := BD.EnvAppdataPd + '\bitfarm-archiv\Bug Reports\ViewerOptions.ini';
        CopyFile(PWideChar(OldFileName), PWideChar(NewFileName), False);
        if Length(NewFileName) > 0 then
          AAttachedFiles.Add(NewFileName);
      except
      end;

      try
        OldFileName := BD.EnvAppdataPd + '\bitfarm-archiv\sortings.ini';
        NewFileName := BD.EnvAppdataPd + '\bitfarm-archiv\Bug Reports\sortings.ini';
        CopyFile(PWideChar(OldFileName), PWideChar(NewFileName), False);
        if Length(NewFileName) > 0 then
          AAttachedFiles.Add(NewFileName);
      except
      end;
      //04.07.2023 <--

    end;
  finally
    ACallNextHandler := false;
  end;
end;

procedure TfrmELManager.DataModuleCreate(Sender : TObject);
begin
  inherited;
  RegisterEventZippedFilesRequest(ELAttachZippedLogs); // Attach extra files to the report and zip them
end;

initialization
  frmELManager := TfrmELManager.Create(nil); // self initialize!
finalization
  FreeAndNil(frmELManager); // free on shutdown

end.
