unit ExportForm;

interface

uses
  gnugettext, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, u_bfaSelector, SpTBXControls, SpTBXItem, SpTBXEditors, StdCtrls;

type
  TfrmExport = class(TForm)
    edtName: TSpTBXEdit;
    edtPath: TSpTBXButtonEdit;
    SpTBXLabel1: TSpTBXLabel;
    SpTBXLabel2: TSpTBXLabel;
    btnOK: TSpTBXButton;
    btnCancel: TSpTBXButton;
    lblGroupsUser: TSpTBXLabel;
    pnl1: TSpTBXPanel;
    bfsExportUser: TbfaSelector;
    procedure edtPathSubEditButton0Click(Sender: TObject);
    procedure edtNameChange(Sender: TObject);
    procedure edtPathChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    IgnoreNonEmptyDir: Boolean;
  end;


implementation

{$R *.dfm}
uses
  MainDataModule, bfaCommonFiles, bfaCommonDialogs, bfaCommonUtils, bfaCommonStyles;

procedure TfrmExport.edtNameChange(Sender: TObject);
begin
  btnOK.Enabled := (Trim(edtName.Text) <> '') and (Trim(edtPath.Text) <> '');
end;

procedure TfrmExport.edtPathChange(Sender: TObject);
begin
  btnOK.Enabled := (Trim(edtName.Text) <> '') and (Trim(edtPath.Text) <> '');
end;

procedure TfrmExport.edtPathSubEditButton0Click(Sender: TObject);
begin
  with TFileOpenDialog.Create(nil) do
  begin
    Title:= _('Speicherort auswhlen');
    Options:= [fdoPickFolders];
    if Execute then
    begin
      edtPath.Text := FileName;
      if not IsDirectoryEmpty(FileName) then
        if BfMessageDialogWithCheckBox(_('Hinweis'), _('Sie haben ein nicht leeres Verzeichnis fr den Export gewhlt.') +
          #13#10 + _('Wollen Sie trotzdem dorthin exportieren?'), mtWarning, [mbOk, mbCancel], [_('Ok')],
          True, bitfarmApp.ViewerOptions, 'ExportNonEmptyDir', mrOk) <> mrOK then
        begin
          FileName := '';
          edtPath.Text := '';
        end else
          IgnoreNonEmptyDir := True;
    end;
  end;
end;

procedure TfrmExport.FormCreate(Sender: TObject);
begin
  TranslateComponent(Self, 'ViewerV36');
  IgnoreNonEmptyDir := False;

  edtName.Color := ctlGeneral.Style.Color;
  edtName.Font.Color := ctlGeneral.Style.TextColor;
  edtPath.Color := ctlGeneral.Style.Color;
  edtPath.Font.Color := ctlGeneral.Style.TextColor;
  SpTBXLabel1.Color := ctlGeneral.Style.Color;
  SpTBXLabel1.Font.Color := ctlGeneral.Style.TextColor;
  SpTBXLabel2.Color := ctlGeneral.Style.Color;
  SpTBXLabel2.Font.Color := ctlGeneral.Style.TextColor;
  btnOK.Color := ctlGeneral.Style.Color;
  btnOK.Font.Color := ctlGeneral.Style.TextColor;
  btnCancel.Color := ctlGeneral.Style.Color;
  btnCancel.Font.Color := ctlGeneral.Style.TextColor;
  bfsExportUser.Color := ctlGeneral.Style.Color;
  bfsExportUser.Font.Color := ctlGeneral.Style.TextColor;
  bfsExportUser.Color := stlControl.color;
  bfsExportUser.edtFilter1.Color := stlControl.color;
  bfsExportUser.edtFilter1.Font.Color := stlControl.Textcolor;
  bfsExportUser.edtFilter2.Color := stlControl.color;
  bfsExportUser.edtFilter2.Font.Color := stlControl.Textcolor;
  bfsExportUser.lvList1.Color := stlControl.color;
  bfsExportUser.lvList1.Font.Color := stlControl.TextColor;
  bfsExportUser.lvList2.Color := stlControl.color;
  bfsExportUser.lvList2.Font.Color := stlControl.TextColor;
  lblGroupsUser.Color := ctlGeneral.Style.Color;
  lblGroupsUser.Font.Color := ctlGeneral.Style.TextColor;
  pnl1.Color := ctlGeneral.Style.Color;
  pnl1.Font.Color := ctlGeneral.Style.TextColor;
end;

end.
