unit FloatingResubFrame;

interface

uses
  Forms, StdCtrls, ExtCtrls, Classes, Controls,
  SpTBXItem, SpTBXControls,
  cxGrid, cxGridLevel, bfaGridDBTableView, cxGraphics,
  cxGridCustomTableView, cxStyles, cxGridCustomPopupMenu, cxGridPopupMenu,
  cxGridCustomView, cxGridTableView, uni, bfaObjects36, TB2Item, Vcl.Menus,
  ResubFrameGPL, u_bfaScrollBox, cxClasses
  ;

type
  TfraFloatingResub = class (TFrame)
    Panel2: TPanel;
    Splitter1: TSplitter;
    Panel3: TPanel;
    cxGridPopupMenu1: TcxGridPopupMenu;
    popFilterBar: TSpTBXPopupMenu;
    tbiSearchBar: TSpTBXItem;
    popResubGrid: TSpTBXPopupMenu;
    SpTBXItem1: TSpTBXItem;
    SpTBXItem2: TSpTBXItem;
    SpTBXItem3: TSpTBXItem;
    procedure btnMyTasksClick(Sender: TObject);
    procedure btnDelegateTasksClick(Sender: TObject);
    procedure tbi1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnResubDoneClick(Sender: TObject);
    procedure btnResubForwardClick(Sender: TObject);
    procedure btnResubCancelClick(Sender: TObject);
    procedure Panel2Resize(Sender: TObject);
    procedure cxGridPopupMenu1Popup(ASenderMenu: TComponent; AHitTest: TcxCustomGridHitTest; X, Y: Integer;
      var AllowPopup: Boolean);
    procedure popFilterBarPopup(Sender: TObject);
    procedure SpTBXItem3Click(Sender: TObject);
    procedure SpTBXItem2Click(Sender: TObject);
    procedure SpTBXItem1Click(Sender: TObject);
    procedure popResubGridPopup(Sender: TObject);
    procedure Panel2CanResize(Sender: TObject; var NewWidth, NewHeight: Integer; var Resize: Boolean);
  private
    { Private-Deklarationen }
    grdResultlistDevExLevel: TcxGridLevel;
    tbiGroupByBox, tbiFooterBox, tbiColumnCustomization, tbiDeleteColumnOrder
    : TSpTBXItem;

    dsc: TUniDataSource;
    FSearchObj: TbfaSearch;
    searchproc: TbfaSearchProcessing;
    DelView: Integer;

    FShowDocument: Boolean;

    procedure DoSaveResub(Param : string);
    procedure tvwResultCustomDrawCell(Sender: TcxCustomGridTableView;
          ACanvas: TcxCanvas; AViewInfo: TcxGridTableDataCellViewInfo;
          var ADone: Boolean);
    procedure grdResubResultlistMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
    procedure grdResultListSelectionChanged(Sender: TcxCustomGridTableView);
    procedure btnResubSaveClick(Sender: TObject);
    procedure OnColumnCustomizationClick(Sender: TObject);
    procedure OnClickGroupping(Sender: TObject);
    procedure OnClickFooter(Sender: TObject);
    function CreateFloatingResubGrid(OnlyStd: Boolean): Boolean;
    procedure OnClickDeleteColumnOrder(Sender: TObject);
    procedure ShowResubResult;
  public
    { Public-Deklarationen }
    fraResub: TfraResub;
    grdResultlistDevEx: TcxGrid;
    grdResubResultlistDevExView: TbfaGridDBTableView;

    constructor Create(AOwner: TComponent); override;

    procedure ShowResubGrid;
    procedure grdResultlistDblClick(Sender: TObject);
    procedure Retranslate;
  end;

implementation

{$R *.dfm}

uses
  bfaIconsDM, MainDataModule, MainForm, cxLookAndFeels, DB, bfaLog,
  gnugettext, System.SysUtils, bfaCommonUtils, System.Types, bfaApplication, bfaCommonStyles,
  cxDateNavigator, cxCalendar, Dialogs, DateUtils, dxCore, cxGridStdPopupMenu, System.IniFiles, System.StrUtils,
  cxCustomData, Winapi.Windows, cxGridDBTableView, CommonGUIUtils;

procedure TfraFloatingResub.btnDelegateTasksClick(Sender: TObject);
var
  ErrorStr: string;
begin
  try
    grdResubResultlistDevExView.DataController.DataSource := nil;

    fraResub.ResubKind := rkController;

    bitfarmApp.SetDelegateTaskControls(fraResub);
    bitfarmApp.FillDelegateTasksSearch(fraResub, grdResubResultlistDevExView, FSearchObj);

    dsc.DataSet := searchproc.Search(dmMain.cntResubSearch, FsearchObj, nil, ErrorStr);
    if ErrorStr <> '' then
      frmMainForm.SetNotificationBar(ErrorStr);

    grdResubResultlistDevExView.Kind := gkResubDelegate;
//29.02.2024 -->
//    grdResubResultlistDevExView.DataController.DataSource := dsc;
//    if grdResubResultlistDevExView.DataController.DataSource.DataSet.RecordCount > 0 then
//    begin
//      grdResubResultlistDevExView.SetBookmark;
//      //29.02.2024 -->
//      //grdResubResultlistDevExView.Controller.FocusedRecord.Selected := True;
//      //grdResultListSelectionChanged(grdResubResultlistDevExView);
//      if (grdResubResultlistDevExView.Controller.FocusedRecord <> nil) and not grdResubResultlistDevExView.Controller.FocusedRecord.IsData then
//      begin
//        try
//          if grdResubResultlistDevExView.DataController.RecordCount >= grdResubResultlistDevExView.ActRec then
//            idx := grdResubResultlistDevExView.ActRec
//          else
//            idx := 0;
//          grdResubResultlistDevExView.DataController.MakeRecordVisible(idx);
//          grdResubResultlistDevExView.DataController.FocusedRecordIndex := idx;
//          grdResubResultlistDevExView.Invalidate;
//        except
//          //
//        end;
//      end;
//      grdResubResultlistDevExView.Controller.FocusedRecord.Selected := True;
//      grdResubResultlistDevExView.OnSelectionChanged(grdResubResultlistDevExView);
//      //29.02.2024 <--
//    end;
    ShowResubResult;
//29.02.2024 <--
    frmMainForm.actShowCW.Enabled := False;
    frmMainForm.actCWPrevious.Enabled := False;
    frmMainForm.actCWNext.Enabled := False;

  except

  end;
end;

procedure TfraFloatingResub.btnMyTasksClick(Sender: TObject);
var
  ErrorStr: string;
begin
  try
    grdResubResultlistDevExView.DataController.DataSource := nil;

    fraResub.ResubKind := rkMyTasks;

    bitfarmApp.SetMyTaskControls(fraResub);
    bitfarmApp.FillMyTasksSearch(fraResub, grdResubResultlistDevExView, FSearchObj);
//29.06.2023 bfacrm:ticket__show__35480 -->
    if pos('docname', FSearchObj.SelectedCols) = 0 then
      FSearchObj.SelectedCols := FSearchObj.SelectedCols + ',docname ';
    if pos('info', FSearchObj.SelectedCols) = 0 then
      FSearchObj.SelectedCols := FSearchObj.SelectedCols + ',info ';
    if pos('comment', FSearchObj.SelectedCols) = 0 then
      FSearchObj.SelectedCols := FSearchObj.SelectedCols + ',comment ';
    if pos('arcname', FSearchObj.SelectedCols) = 0 then
      FSearchObj.SelectedCols := FSearchObj.SelectedCols + ',arcname ';
//29.06.2023 bfacrm:ticket__show__35480 <--

    dsc.DataSet := searchproc.Search(dmMain.cntResubSearch, FsearchObj, nil, ErrorStr);
    if ErrorStr <> '' then
      frmMainForm.SetNotificationBar(ErrorStr);

    grdResubResultlistDevExView.Kind := gkResub;
//29.02.2024 -->
//    grdResubResultlistDevExView.DataController.DataSource := dsc;
//    if grdResubResultlistDevExView.DataController.DataSource.DataSet.RecordCount > 0 then
//    begin
//      grdResubResultlistDevExView.SetBookmark;
//      //29.02.2024 -->
//      //grdResubResultlistDevExView.Controller.FocusedRecord.Selected := True;
//      //grdResultListSelectionChanged(grdResubResultlistDevExView);
//      if (grdResubResultlistDevExView.Controller.FocusedRecord <> nil) and not grdResubResultlistDevExView.Controller.FocusedRecord.IsData then
//      begin
//        try
//          if grdResubResultlistDevExView.DataController.RecordCount >= grdResubResultlistDevExView.ActRec then
//            idx := grdResubResultlistDevExView.ActRec
//          else
//            idx := 0;
//          grdResubResultlistDevExView.DataController.MakeRecordVisible(idx);
//          grdResubResultlistDevExView.DataController.FocusedRecordIndex := idx;
//          grdResubResultlistDevExView.Invalidate;
//        except
//          //
//        end;
//      end;
//      grdResubResultlistDevExView.Controller.FocusedRecord.Selected := True;
//      grdResubResultlistDevExView.OnSelectionChanged(grdResubResultlistDevExView);
//      //29.02.2024 <--
//    end;
    ShowResubResult;
//29.02.2024 <--
    frmMainForm.actShowCW.Enabled := True;
    frmMainForm.actCWPrevious.Enabled := True;
    frmMainForm.actCWNext.Enabled := True;

  except

  end;
end;

procedure TfraFloatingResub.ShowResubResult;
var
  idx: Integer;
begin
  try
    grdResubResultlistDevExView.DataController.DataSource := dsc;
    if (grdResubResultlistDevExView.DataController.DataSource.DataSet.RecordCount > 0) then
    begin
      grdResubResultlistDevExView.SetBookmark;
      //29.02.2024 -->
      //grdResubResultlistDevExView.Controller.FocusedRecord.Selected := True;
      //grdResultListSelectionChanged(grdResubResultlistDevExView);
      if (grdResubResultlistDevExView.Controller.FocusedRecord <> nil) and not grdResubResultlistDevExView.Controller.FocusedRecord.IsData then
      begin
        try
          if grdResubResultlistDevExView.DataController.RecordCount >= grdResubResultlistDevExView.ActRec then
            idx := grdResubResultlistDevExView.ActRec
          else
            idx := 0;
          grdResubResultlistDevExView.DataController.MakeRecordVisible(idx);
          grdResubResultlistDevExView.DataController.FocusedRecordIndex := idx;
          grdResubResultlistDevExView.Invalidate;
        except
          //
        end;
      end;
      grdResubResultlistDevExView.Controller.FocusedRecord.Selected := True;
      grdResubResultlistDevExView.OnSelectionChanged(grdResubResultlistDevExView);
      //29.02.2024 <--
    end;
  except

  end;
end;

procedure TfraFloatingResub.btnResubCancelClick(Sender: TObject);
begin
  DoSaveResub('cancel');
end;

procedure TfraFloatingResub.btnResubSaveClick(Sender: TObject);
begin
  DoSaveResub('change');
end;

procedure TfraFloatingResub.btnResubDoneClick(Sender: TObject);
begin
  if ((fraResub.ResubKind = rkController) and (fraResub.DelegateView = 3)) or
     ((fraResub.ResubKind = rkMyTasks) and (fraResub.MyTasksView = 3)) then
    DoSaveResub('delete')
  else
    DoSaveResub('set_done');
end;

procedure TfraFloatingResub.btnResubForwardClick(Sender: TObject);
begin
  DoSaveResub('forward');
end;

procedure TfraFloatingResub.DoSaveResub(Param : string);
var
  UserAction: PUserAction;
  i: Integer;
  Doc : TbfaDocument;
  resub: PResub;
  userid, groupid: Integer;
begin
  try
    if (bitfarmapp.CurrentContainer.Count > 0) and (bitfarmapp.CurrentContainer[0].InEditMode) then
    begin
      ShowMessage(_('Da sind Dokumente im Edit-Modus. Bitte speichern Sie die zuerst!'));
      Exit;
    end;

    if (grdResubResultlistDevExView.Controller.SelectedRowCount > 0) then
    begin
      New(resub);
      FillChar(resub^, SizeOf(resub^), 0);
      resub^.Info := fraResub.edtResubInfo.Text;
      resub^.Comment := fraResub.edtResubComment.Text;
      userid := -1;
      groupid := -1;

      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actSaveResub';
      for i := 0 to grdResubResultlistDevExView.Controller.SelectedRowCount - 1 do
      begin
        Doc := TbfaDocument.Create;
        Doc.ID := grdResubResultlistDevExView.DataController.GetValue(
            grdResubResultlistDevExView.Controller.SelectedRows[i].Index,
            grdResubResultlistDevExView.DataController.GetItemByFieldName('gdocid').Index);
        Doc.TimID := grdResubResultlistDevExView.DataController.GetValue(
            grdResubResultlistDevExView.Controller.SelectedRows[i].Index,
            grdResubResultlistDevExView.DataController.GetItemByFieldName('timid').Index);
        if i = 0 then
        begin
          if param = 'forward' then
          begin
            frmMainForm.frmResubDialog.fraCreateResub.LoadResub := True;
            try
              frmMainForm.frmResubDialog.Caption := _('Wiedervorlage weiterleiten');
              with frmMainForm.frmResubDialog.fraCreateResub do
              begin
                btnOk.Caption := _('Weiterleiten');
                Clear;
                edtAlarm1.Text := '7';
                edtAlarm1.Value := 7; // bfacrm:ticket__show__30688
                cbbFavorites.ItemIndex := -1;

                InitialOptions := grdResubResultlistDevExView.DataController.GetValue(
                      grdResubResultlistDevExView.Controller.SelectedRows[0].Index,
                      grdResubResultlistDevExView.DataController.GetItemByFieldName('options').Index);
                edtInfoCreate.Text := grdResubResultlistDevExView.DataController.GetValue(
                      grdResubResultlistDevExView.Controller.SelectedRows[0].Index,
                      grdResubResultlistDevExView.DataController.GetItemByFieldName('info').Index);
                edtInfoFoward.Text := grdResubResultlistDevExView.DataController.GetValue(
                      grdResubResultlistDevExView.Controller.SelectedRows[0].Index,
                      grdResubResultlistDevExView.DataController.GetItemByFieldName('comment').Index);
                dtDate1.Date := grdResubResultlistDevExView.DataController.GetValue(
                      grdResubResultlistDevExView.Controller.SelectedRows[0].Index,
                      grdResubResultlistDevExView.DataController.GetItemByFieldName('date').Index);;

                chkReturnToSender.Checked := (InitialOptions and 2) = 2;
                chkReturnToSender.Enabled := not chkReturnToSender.Checked;   // leiten wir mit rts weiter, dann bleibt return to sender stehen, man kann es nicht wieder entfernen
                chkEmailreminder.Checked := (InitialOptions and 4) = 4;
                chkNotifyByMail.Checked := (InitialOptions and 64) = 64;
                chkEveryone.Checked := (InitialOptions and 1) = 1;
                chkOnlyOne.Checked := not chkEveryone.Checked;

                cbbGroup.SetUnCheckedAll;
                cbbUser.SetUnCheckedAll;

              end;
            finally
              frmMainForm.frmResubDialog.fraCreateResub.LoadResub := False
            end;

            frmMainForm.frmResubDialog.ShowModal;

            if frmMainForm.frmResubDialog.ModalResult <> mrOK then
              Break;

            resub := frmMainForm.frmResubDialog.fraCreateResub.GetResub;
            resub^.TimID := grdResubResultlistDevExView.DataController.GetValue(
                  grdResubResultlistDevExView.Controller.SelectedRows[0].Index,
                  grdResubResultlistDevExView.DataController.GetItemByFieldName('timid').Index);
          end
          else
          begin
            resub^.TimID := grdResubResultlistDevExView.DataController.GetValue(
                  grdResubResultlistDevExView.Controller.SelectedRows[i].Index,
                  grdResubResultlistDevExView.DataController.GetItemByFieldName('timid').Index);
            resub^.TimRef := grdResubResultlistDevExView.DataController.GetValue(
                  grdResubResultlistDevExView.Controller.SelectedRows[i].Index,
                  grdResubResultlistDevExView.DataController.GetItemByFieldName('timref').Index);
            resub^.options := grdResubResultlistDevExView.DataController.GetValue(
                  grdResubResultlistDevExView.Controller.SelectedRows[i].Index,
                  grdResubResultlistDevExView.DataController.GetItemByFieldName('options').Index);
            resub^.Status := grdResubResultlistDevExView.DataController.GetValue(
                  grdResubResultlistDevExView.Controller.SelectedRows[i].Index,
                  grdResubResultlistDevExView.DataController.GetItemByFieldName('status').Index);
            resub^.UseridShed := grdResubResultlistDevExView.DataController.GetValue(
                  grdResubResultlistDevExView.Controller.SelectedRows[i].Index,
                  grdResubResultlistDevExView.DataController.GetItemByFieldName('userid_shed').Index);
            if fraResub.ResubKind = rkMyTasks then
            begin
              resub^.Date := fraResub.cxDateEdit1.Date;
              resub^.AlarmDate := DateUtils.IncDay(resub^.Date, 7);
              resub^.Users := grdResubResultlistDevExView.DataController.GetValue(
                  grdResubResultlistDevExView.Controller.SelectedRows[i].Index,
                  grdResubResultlistDevExView.DataController.GetItemByFieldName('userid_work').Index);
              resub^.Groups := grdResubResultlistDevExView.DataController.GetValue(
                  grdResubResultlistDevExView.Controller.SelectedRows[i].Index,
                  grdResubResultlistDevExView.DataController.GetItemByFieldName('groupid').Index);
              if fraResub.tbiResubWork.Color = gclYellow then
                resub^.Status := 2
              else
                resub^.Status := 0;
            end
            else if fraResub.ResubKind = rkController then
            begin
              if fraResub.cbbUserGroups.ItemIndex < fraResub.IndexUserPos then
                groupid := Integer(fraResub.cbbUserGroups.Items.Objects[fraResub.cbbUserGroups.ItemIndex])
              else
                userid := Integer(fraResub.cbbUserGroups.Items.Objects[fraResub.cbbUserGroups.ItemIndex]);
              resub^.Users := IntToStr(userid);
              resub^.Groups := IntToStr(groupid);
              resub^.AlarmDate := grdResubResultlistDevExView.DataController.GetValue(
                  grdResubResultlistDevExView.Controller.SelectedRows[i].Index,
                  grdResubResultlistDevExView.DataController.GetItemByFieldName('alarm').Index);
              resub^.Date := grdResubResultlistDevExView.DataController.GetValue(
                  grdResubResultlistDevExView.Controller.SelectedRows[i].Index,
                  grdResubResultlistDevExView.DataController.GetItemByFieldName('date').Index);
            end;
          end;
          if (param <> 'set_done') and (param <> 'delete') then
            UserAction^.objects.Add(TObject(resub));
        end;
        UserAction^.Documents.Add(Doc);
      end;

      if (param = 'forward') and (frmMainForm.frmResubDialog.ModalResult <> mrOK) then
        Exit;

      UserAction^.params.Add(param);
      bitfarmApp.MainThread.Add(UserAction);
    end;
  except
  end;
end;

procedure TfraFloatingResub.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  frmMainForm.ShowFloatingResub := False;
end;

procedure TfraFloatingResub.tvwResultCustomDrawCell(Sender: TcxCustomGridTableView;
      ACanvas: TcxCanvas; AViewInfo: TcxGridTableDataCellViewInfo;
      var ADone: Boolean);
begin
//14.10.2020 Muss hier sein, sonst TbfaDBGridTableView.DoCustomDrawCell wird nicht gettigt!
end;

constructor TfraFloatingResub.Create(AOwner: TComponent);
var
//  i, j, k, icol, ColTyp, GrpIdx, SIdx, FKind : Integer;
//  sort: TSorting;
//  sord : TdxSortOrder;
//  vsbl,
  DoGrouping : Boolean;
//  arcid : Int64;
//  inifile: TMemIniFile;
//  cols, sortings, items: TStringList;
//  str: string;
begin
  inherited Create(AOwner);

  try
    Font.Size := bfaFontSize; //10.09.2020
    FShowDocument := False;

    fraResub := TfraResub.Create(Self);
    fraResub.Parent := Panel2;
    fraResub.Align := alClient;
    fraResub.FloatingFrame := True;

    fraResub.cxDateNavigator1 := TcxDateNavigator.Create(Self);
    with fraResub.cxDateNavigator1 do
    begin
      Parent := fraResub.ResubScrollBox;
      Left := 3;
      Top := fraResub.btnShowCW.Top + fraResub.btnShowCW.Height + 6;
      Width := 228;
      Height := 160;
      Anchors := [akLeft, akTop, akRight];
      TabStop := False;
      OnClick := fraResub.cxDateNavigator1Click;
      OnCustomDrawDayNumber := fraResub.cxDateNavigator1CustomDrawDayNumber;
      OnPeriodChanged := fraResub.cxDateNavigator1PeriodChanged;
    end;
    fraResub.lblCW.Top:= fraResub.cxDateNavigator1.Top +
      fraResub.cxDateNavigator1.Height + 20;
//27.02.2024    fraResub.cxDateNavigator1.Styles.Background := stlBackgroundStyle;
    fraResub.cxDateNavigator1.Styles.Background := stlControl;
    fraResub.cxDateNavigator1.Styles.Content := stlFree;
    fraResub.cxDateNavigator1.Styles.Header := stlColumn;
    fraResub.cxDateNavigator1.Styles.Selection := stlSelected;

    fraResub.popDelegate.Items[0].Checked := True;
    fraResub.popMyTasks.Items[0].Checked := True;
    fraResub.btnMyTasks.Images := bfaIcons.ilMainMenu;
    fraResub.btnMyTasks.ImageIndex := Integer(icoidx_resubmission_own);
    fraResub.btnMyTasks.OnClick := btnMyTasksClick;
    fraResub.btnDelegateTasks.Images := bfaIcons.ilMainMenu;
    fraResub.btnDelegateTasks.ImageIndex := Integer(icoidx_forwarded);//14.02.2023 Integer(icoidx_resubmission_group);
    fraResub.btnDelegateTasks.OnClick := btnDelegateTasksClick;
    fraResub.btnShowCW.Action := frmMainForm.actShowCW;
    fraResub.btnShowCW.Images := bfaIcons.ilMainMenu;
    fraResub.btnCWNext.Action := frmMainForm.actCWNext;
    fraResub.btnCWNext.Images := bfaIcons.ilMainMenu;
    fraResub.btnCWPrevious.Action := frmMainForm.actCWPrevious;
    fraResub.btnCWPrevious.Images := bfaIcons.ilMainMenu;

    fraResub.btnSaveResub.OnClick := btnResubSaveClick;
    fraResub.btnResubForward.OnClick := btnResubForwardClick;
    fraResub.btnResubDone.OnClick := btnResubDoneClick;
    fraResub.btnResubCancel.OnClick := btnResubCancelClick;
    fraResub.cxDateEdit1.Style.StyleController := ctlGeneral;
    fraResub.cxDateEdit1.Properties.InputKind := ikRegExpr;
    fraResub.cxDateEdit1.Properties.EditFormat := FormatSettings.ShortDateFormat;

    FsearchObj := TbfaSearch.Create;
    searchproc := TbfaSearchProcessing.Create;
    dsc := TUniDataSource.Create(nil);
    grdResultlistDevEx := TcxGrid.Create(Self);
    grdResultlistDevEx.Parent := Panel3;
    grdResultlistDevEx.Align := alClient;
    grdResultlistDevEx.Name := 'Grid';
    grdResultlistDevEx.LookAndFeel.ScrollbarMode := sbmClassic;
    grdResultlistDevEx.LookAndFeel.NativeStyle := False;
    grdResultlistDevExLevel := grdResultlistDevEx.Levels.Add;
    grdResultlistDevExLevel.Name := 'Grid_LevelName';
    grdResubResultlistDevExView := grdResultlistDevEx.CreateView(TbfaGridDBTableView) as TbfaGridDBTableView;
    grdResubResultlistDevExView.Name := 'Grid_ViewName';
    grdResubResultlistDevExView.Grd := grdResultlistDevEx;
    grdResultlistDevExLevel.GridView := grdResubResultlistDevExView;
    grdResultlistDevEx.Width := 500;
    grdResubResultlistDevExView.Styles.Header := stlColumn;
    grdResubResultlistDevExView.Styles.GroupByBox := stlGroupByBoxStyle;
    grdResubResultlistDevExView.Styles.Navigator := stlGroupByBoxStyle;
    grdResubResultlistDevExView.Styles.NavigatorInfoPanel := stlGroupByBoxStyle;
    grdResubResultlistDevExView.Styles.Background := stlBackgroundStyle;
    grdResubResultlistDevExView.Styles.Group := stlColumn;
    grdResubResultlistDevExView.Styles.Footer := stlColumn;
    grdResubResultlistDevExView.RowColorEvenOdd := bitfarmApp.ViewerOptions.GeneralOptions.RowColorEvenOdd;
    grdResubResultlistDevExView.ImageList := TImageList(bfaIcons.ilMainMenu);
    frmMainForm.SetGridDBTableViewSettings(grdResubResultlistDevExView);
    grdResubResultlistDevExView.OnCustomDrawCell := tvwResultCustomDrawCell;
    grdResubResultlistDevExView.OnDblClick := grdResultlistDblClick;
    grdResubResultlistDevExView.OnMouseUp := grdResubResultlistMouseUp;
    grdResubResultlistDevExView.OnSelectionChanged := grdResultListSelectionChanged;
    grdResubResultlistDevExView.ChangeDelay := 150;

    DoGrouping := CreateFloatingResubGrid(False); //30.06.2023 bfacrm:ticket__show__35480

    cxGridPopupMenu1.Grid := grdResultlistDevEx;

    tbiColumnCustomization := TSpTBXItem.Create(popFilterBar);
    tbiColumnCustomization.FontSettings.Size := bfaFontSettingsSize;
    tbiColumnCustomization.Caption := _('Spalten ein/ausblenden');
    tbiColumnCustomization.Enabled := True;
    tbiColumnCustomization.Visible := True;
    tbiColumnCustomization.OnClick := OnColumnCustomizationClick;
    popFilterBar.Items.Add(tbiColumnCustomization);

    tbiGroupByBox := TSpTBXItem.Create(popFilterBar);
    tbiGroupByBox.FontSettings.Size := bfaFontSettingsSize;
    tbiGroupByBox.Caption := _('Gruppierleiste');
    tbiGroupByBox.Enabled := True;
    tbiGroupByBox.Visible := True;
    tbiGroupByBox.OnClick := OnClickGroupping;
    popFilterBar.Items.Add(tbiGroupByBox);

    tbiFooterBox := TSpTBXItem.Create(popFilterBar);
    tbiFooterBox.FontSettings.Size := bfaFontSettingsSize;
    tbiFooterBox.Caption := _('Fuzeile');
    tbiFooterBox.Enabled := True;
    tbiFooterBox.Visible := True;
    tbiFooterBox.OnClick := OnClickFooter;
    popFilterBar.Items.Add(tbiFooterBox);

    tbiDeleteColumnOrder := TSpTBXItem.Create(popFilterBar);
    tbiDeleteColumnOrder.FontSettings.Size := bfaFontSettingsSize;
    tbiDeleteColumnOrder.Caption := _(sCaptionActDeleteColumnOrder);
    tbiDeleteColumnOrder.Enabled := True;
    tbiDeleteColumnOrder.Visible := True;
    tbiDeleteColumnOrder.OnClick := OnClickDeleteColumnOrder;
    popFilterBar.Items.Add(tbiDeleteColumnOrder);

    if DoGrouping then
      OnClickGroupping(nil);

    bitfarmApp.ReadResubUserGroups(fraResub);

    bitfarmApp.ChangeResubFrameColor(fraResub);

    grdResultlistDevEx.PopupMenu := popResubGrid;

    SpTBXItem1.Images := bfaIconsDM.bfaIcons.ilMainMenu;
    SpTBXItem2.Images := bfaIconsDM.bfaIcons.ilMainMenu;
    SpTBXItem3.Images := bfaIconsDM.bfaIcons.ilMainMenu;
    SpTBXItem1.ImageIndex := Integer(icoidx_clock_check);
    SpTBXItem2.ImageIndex := Integer(icoidx_clock_forward);
    SpTBXItem3.ImageIndex := Integer(icoidx_clock_abort);

    TranslateComponent(Self, 'ViewerV36');
  except
    on E: Exception do
      bitfarmApp.Log.Write(llNormal, ltException, 'TfraFloatingResub Create ' + E.Message, ClassName);
  end;
end;

function TfraFloatingResub.CreateFloatingResubGrid(OnlyStd: Boolean): Boolean;
var
  i, j, k, icol, ColTyp, GrpIdx, SIdx, FKind : Integer;
  sort: TSorting;
  sord : TdxSortOrder;
  vsbl, DoGrouping : Boolean;
  arcid : Int64;
  inifile: TMemIniFile;
  cols, sortings, items: TStringList;
  str: string;
begin
  Result := False;
  try
    grdResubResultlistDevExView.CreateDBColumn(
      'gdocid', 'gdocid', 'gdocid', '', 90, False, soNone, -1, -1, False);
    grdResubResultlistDevExView.CreateDBColumn(
      'arcid', 'arcid', 'arcid', '', 90, False, soNone, -1, -1, False);
    grdResubResultlistDevExView.CreateDBColumn(
      'symarcid', 'symarcid', 'symarcid', '', 90, False, soNone, -1, -1, False);
    grdResubResultlistDevExView.CreateDBColumn(
      'editmode', 'editmode', 'editmode', '', 90, False, soNone, -1, -1, False);
    grdResubResultlistDevExView.CreateDBColumn(
      'status', 'status', 'status', '', 90, False, soNone, -1, -1, False);
    grdResubResultlistDevExView.CreateDBColumn(
      'groupid', 'groupid', 'groupid', '', 90, False, soNone, -1, -1, False);
    grdResubResultlistDevExView.CreateDBColumn(
      'options', 'options', 'options', '', 90, False, soNone, -1, -1, False);
    grdResubResultlistDevExView.CreateDBColumn(
      'timid', 'timid', 'timid', '', 90, False, soNone, -1, -1, False);
    grdResubResultlistDevExView.CreateDBColumn(
      'timref', 'timref', 'timref', '', 90, False, soNone, -1, -1, False);
    grdResubResultlistDevExView.CreateDBColumn(
      'userid_work', 'userid_work', 'userid_work', '', 90, False, soNone, -1, -1, False);
    grdResubResultlistDevExView.CreateDBColumn(
      'userid_shed', 'userid_shed', 'userid_shed', '', 90, False, soNone, -1, -1, False);
    grdResubResultlistDevExView.CreateDBColumn(
      'typ',  _('Typ'), 'typ', '', 35, True);
    grdResubResultlistDevExView.CreateDBColumn(
      'date', _('Datum'), 'date', '', 140, False);
    grdResubResultlistDevExView.CreateDBColumn(
      'alarm',  _('Alarm'), 'alarm', '', 140,
      bitfarmApp.ViewerOptions.ResubOptions.ColumnAlarm);
    grdResubResultlistDevExView.CreateDBColumn(
      'doc_modified',  _('nderungsdatum'), 'doc_modified', '', 140,
      bitfarmApp.ViewerOptions.ResubOptions.ColumnModified);
    grdResubResultlistDevExView.CreateDBColumn(
      'docname',  _('Titel'), 'docname', '', 140,
      bitfarmApp.ViewerOptions.ResubOptions.ColumnTitle);
    grdResubResultlistDevExView.CreateDBColumn(
      'info',  _('Info'), 'info', '', 140,
      bitfarmApp.ViewerOptions.ResubOptions.ColumnInfo);
    grdResubResultlistDevExView.CreateDBColumn(
      'comment',  _('Kommentar'), 'comment', '', 140,
      bitfarmApp.ViewerOptions.ResubOptions.ColumnComment);
    grdResubResultlistDevExView.CreateDBColumn(
      'arcname',  _('Archiv'), 'arcname', '', 140,
      bitfarmApp.ViewerOptions.ResubOptions.ColumnArchive);

    arcid := bitfarmApp.CurrentResubArchive.Arcid;
    for i := Low(aColSortings[arcid]) to High(aColSortings[arcid]) do
    begin
      try
        case aColSortings[arcid, i].SortOrder of
          0:
            sord := soNone;
          1:
            sord := soAscending;
          2:
            sord := soDescending;
        end;
        ColTyp := -1;
        if Pos('add_', aColSortings[arcid, i].Field) > 0 then
        begin
          try
            for k := Low(aAddfields) to High(aAddfields) do
            begin
              if aAddfields[k] = nil then
                Continue;
              if (aAddfields[k].Name = aColSortings[arcid, i].Field) and
                 (aAddfields[k].Typ = 8) then
              begin
                ColTyp := aAddfields[k].Typ;
                Break;
              end;
            end;
          except
            on E: Exception do
              bitfarmApp.Log.Write(llNormal, ltException, 'TfraFloatingResub CreateGrid Currency: ' + E.Message, ClassName);
          end;
        end;

        if not DoGrouping then
          DoGrouping := (aColSortings[arcid, i].GroupingIndex <> -1);

        grdResubResultlistDevExView.CreateDBColumn(
          aColSortings[arcid, i].Field, aColSortings[arcid, i].Title,
          aColSortings[arcid, i].Field, '', aColSortings[arcid, i].Width,
          aColSortings[arcid, i].Visible, sord,
          aColSortings[arcid, i].GroupingIndex, aColSortings[arcid, i].SortIndex,
          True, bTrue, ColTyp, aColSortings[arcid, i].FooterKind);

      except
        on E: Exception do
          bitfarmApp.Log.Write(llNormal, ltException, 'TfraFloatingResub Add columns: ' + E.Message, ClassName);
      end;
    end;

    if not OnlyStd and FileExists(BD.AppdataBitfarmPd + 'Sortings.ini') then //28.04.2022 aus der ini nochmal anpassen wenn vorhanden
    begin
      inifile := TMemIniFile.Create(BD.AppdataBitfarmPd + 'Sortings.ini');
      try
        if inifile.SectionExists(bitfarmApp.SortingsFloatingResubProfile) then
        begin
          cols := TStringList.Create;
          cols.Delimiter := ';';
          cols.StrictDelimiter := True;
          sortings := TStringList.Create;
          sortings.Delimiter := ',';
          sortings.StrictDelimiter := True;
          items := TStringList.Create;
          try
            inifile.ReadSection(bitfarmApp.SortingsFloatingResubProfile, items);

            for i := 0 to items.Count - 1 do
            begin
              try
                try
                  str := inifile.ReadString(bitfarmApp.SortingsFloatingResubProfile, items[i], '');
                except
                  str := '';
                end;
                cols.DelimitedText := ReplaceStr(str, '"', '');

                if cols.Count > 0 then
                begin
                  for j := 0 to cols.Count - 1 do
                  begin
                    if cols[j] <> '' then
                    begin
                      try
                        sortings.DelimitedText := cols[j];
                        if j = 0 then
                        begin
                          if (sortings[0] = 'ArcOptions') then
                          begin
                            grdResubResultlistDevExView.OptionsView.GroupByBox := StrToBool(sortings[1]);
                            grdResubResultlistDevExView.OptionsView.Footer := StrToBool(sortings[2]);
                            Continue;
                          end
                          else
                          begin
                            grdResubResultlistDevExView.OptionsView.GroupByBox := False;
                            grdResubResultlistDevExView.OptionsView.Footer := False;
                          end;
                        end;

                        for k := 0 to grdResubResultlistDevExView.ColumnCount - 1 do
                        begin
                          if grdResubResultlistDevExView.Columns[k].DataBinding.FieldName = sortings[1] then
                          begin
                            sort := bitfarmApp.GetSortRec(sortings);
                            with grdResubResultlistDevExView.Columns[k] do
                            begin
                              SortOrder := TdxSortOrder(sort.SortOrder);
                              SortIndex := sort.SortIndex;
                              Width := sort.Width;
                              Visible := sort.Visible;
                              GroupIndex := sort.GroupingIndex;
                              Summary.FooterKind := TcxSummaryKind(sort.FooterKind);
                              Summary.GroupFooterKind := TcxSummaryKind(sort.FooterKind);
                            end;
                            Break;
                          end;
                        end;
                      except
                      //
                      end;
                    end;
                  end;
                end;
              except
                //
              end;
            end;
          finally
            FreeAndNil(cols);
            FreeAndNil(sortings);
            FreeAndNil(items);
          end;
        end;
      finally
        FreeAndNil(inifile);
      end;
    end;
  except
    on E: Exception do
      bitfarmApp.Log.Write(llNormal, ltException, 'TfraFloatingResub.CreateFloatingResubGrid: ' + E.Message, ClassName);
  end;
end;

procedure TfraFloatingResub.Retranslate;
begin
  ReTranslateComponent(Self, 'ViewerV36');
end;

procedure TfraFloatingResub.OnColumnCustomizationClick(Sender: TObject);
begin
  try
    if grdResubResultlistDevExView.FilterRow.Visible  then
      TbfaGridIndicatorAccess(grdResubResultlistDevExView.ViewInfo.IndicatorViewInfo.Items[1]).DropDown
    else
      TbfaGridIndicatorAccess(grdResubResultlistDevExView.ViewInfo.IndicatorViewInfo.Items[0]).DropDown;
  except
  end;
end;

procedure TfraFloatingResub.OnClickGroupping(Sender: TObject);
begin
  grdResubResultlistDevExView.OptionsView.GroupByBox := not grdResubResultlistDevExView.OptionsView.GroupByBox;
  tbiGroupByBox.Checked := grdResubResultlistDevExView.OptionsView.GroupByBox;

  if not grdResubResultlistDevExView.OptionsView.GroupByBox then
  begin
    for var i := 0 to grdResubResultlistDevExView.ColumnCount - 1 do
    begin
      if grdResubResultlistDevExView.Columns[i].GroupIndex <> -1 then
      begin
        grdResubResultlistDevExView.Columns[i].GroupIndex := -1;
        grdResubResultlistDevExView.Columns[i].Visible := True;
      end;
    end;
  end;
end;

procedure TfraFloatingResub.OnClickFooter(Sender: TObject);
begin
  grdResubResultlistDevExView.OptionsView.Footer := not grdResubResultlistDevExView.OptionsView.Footer;
  grdResubResultlistDevExView.OptionsView.FooterMultiSummaries := True;
  if grdResubResultlistDevExView.OptionsView.Footer then
    grdResubResultlistDevExView.OptionsView.GroupFooters := gfAlwaysVisible
  else
    grdResubResultlistDevExView.OptionsView.GroupFooters := gfInvisible;
  tbiFooterBox.Checked := grdResubResultlistDevExView.OptionsView.Footer;
end;

procedure TfraFloatingResub.OnClickDeleteColumnOrder(Sender: TObject);
begin
  try
    grdResubResultlistDevExView.ClearItems;
    CreateFloatingResubGrid(True);
  finally

  end;
end;

procedure TfraFloatingResub.cxGridPopupMenu1Popup(ASenderMenu: TComponent; AHitTest: TcxCustomGridHitTest; X,
  Y: Integer; var AllowPopup: Boolean);

  function IsItemsExists(AMenu: TcxGridStdHeaderMenu): Boolean;
  var
    I: Integer;
  begin
    Result := False;
    with AMenu.Items do
      for I := 0 to Count - 1 do
        if (Items[I].Name = 'itmCopyToClbrd') (*or (Items[I].Name = 'CollapseItem')*) then
        begin
          Result := True;
          System.Break;
        end;
  end;


var
  s, selpos2 : TPoint;
  selrect : TRect;
  AItem : TMenuItem;
begin
  try
    if (ASenderMenu is TcxGridStdHeaderMenu) or
       (ASenderMenu is TcxGridStdGroupByBoxMenu) or
       (ASenderMenu is TcxGridStdGroupRowMenu)
    then
    begin
      S.X := X;
      S.Y := Y;
      selpos2 := grdResultlistDevEx.ScreenToClient(s);

      popFilterBar.Popup(X, Y);
      AllowPopup := False;
    end;
  except

  end;

end;

procedure TfraFloatingResub.ShowResubGrid;
var
  col: TcxGridDBColumn;
begin
  try
    try
      col := grdResubResultlistDevExView.GetColumnByFieldName('alarm');
      if col <> nil then
        col.Visible := bitfarmApp.ViewerOptions.ResubOptions.ColumnAlarm;
      col := grdResubResultlistDevExView.GetColumnByFieldName('docname');
      if col <> nil then
        col.Visible := bitfarmApp.ViewerOptions.ResubOptions.ColumnTitle;
      col := grdResubResultlistDevExView.GetColumnByFieldName('info');
      if col <> nil  then
        col.Visible := bitfarmApp.ViewerOptions.ResubOptions.ColumnInfo;
      col := grdResubResultlistDevExView.GetColumnByFieldName('comment');
      if col <> nil then
        col.Visible := bitfarmApp.ViewerOptions.ResubOptions.ColumnComment;
      col := grdResubResultlistDevExView.GetColumnByFieldName('doc_modified');
      if col <> nil then
        col.Visible := bitfarmApp.ViewerOptions.ResubOptions.ColumnModified;
      col := grdResubResultlistDevExView.GetColumnByFieldName('arcname');
      if col <> nil then
        col.Visible := bitfarmApp.ViewerOptions.ResubOptions.ColumnArchive;
      col := grdResubResultlistDevExView.GetColumnByFieldName('docdate');
      if col <> nil then
        col.Visible := bitfarmApp.ViewerOptions.ResubOptions.ColumnDocDate;
    except

    end;

    Self.Caption := _('Wiedervorlage');

    btnMyTasksClick(Self);
  except

  end;
end;

procedure TfraFloatingResub.SpTBXItem1Click(Sender: TObject);
begin
  btnResubCancelClick(Sender);
end;

procedure TfraFloatingResub.SpTBXItem2Click(Sender: TObject);
begin
  btnResubForwardClick(Sender);
end;

procedure TfraFloatingResub.SpTBXItem3Click(Sender: TObject);
begin
  btnResubDoneClick(Sender);
end;

procedure TfraFloatingResub.tbi1Click(Sender: TObject);
var
  i : Integer;
begin
  try
    DelView := TSpTBXItem(Sender).Tag;

    for i := 0 to fraResub.popDelegate.Items.Count -1 do
      fraResub.popDelegate.Items[i].Checked := False;

    TSpTBXItem(Sender).Checked := True;

    btnDelegateTasksClick(Self);
  except

  end;
end;

procedure TfraFloatingResub.grdResultlistDblClick(Sender: TObject);
var
  gdocid : Integer;
  AHitTest: TcxCustomGridHitTest;
  AColumnCaption: String;
  MouseDownPos : TPoint;
  FGridColumnMouseDown : Boolean;
  UserAction : PUserAction;
begin
  if (grdResubResultlistDevExView.DataController.DataSource = nil) or
     (grdResubResultlistDevExView.DataController.DataSource.DataSet = nil) or
     (grdResubResultlistDevExView.DataController.RecordCount = 0) then
    Exit;

  MouseDownPos := grdResultlistDevEx.ScreenToClient(mouse.cursorpos);
  AHitTest := TcxGridSite(Sender).ViewInfo.GetHitTest(MouseDownPos.X, MouseDownPos.Y);
  FGridColumnMouseDown := (AHitTest.HitTestCode = htColumnHeader) or
    (AHitTest.HitTestCode = htColumnHeaderHorzSizingEdge) or
    (AHitTest.HitTestCode = htColumnHeaderFilterButton);

  if FGridColumnMouseDown then
    Exit;

  if (grdResubResultlistDevExView.Controller.SelectedRowCount > 0) then
  begin
    try
      gdocid :=
        grdResubResultlistDevExView.DataController.GetValue(
        grdResubResultlistDevExView.ActRec,
        grdResubResultlistDevExView.DataController.GetItemByFieldName('gdocid').Index);
    except
      gdocid := 0;
    end;
  end
  else
    gdocid := 0;

  if (gdocid > 0) then
  begin
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actLoadDoc';
      UserAction^.params.Add(IntToStr(-1));
      UserAction^.params.Add(IntToStr(gdocid));

      bitfarmApp.MainThread.Add(UserAction);
    except
    end;
  end;
end;

procedure TfraFloatingResub.Panel2CanResize(Sender: TObject; var NewWidth, NewHeight: Integer; var Resize: Boolean);
begin
//20.05.2022  bitfarmApp.DoResubPanelResize(fraResub);
//  if fraResub.ResubScrollBox.VertScrollBar.IsScrollBarVisible then
//    Panel2.Constraints.MinWidth := 265 + 15
//  else
//    Panel2.Constraints.MinWidth := 265;
end;

procedure TfraFloatingResub.Panel2Resize(Sender: TObject);
begin
  bitfarmApp.DoResubPanelResize(fraResub);
  if fraResub.ResubScrollBox.VertScrollBar.IsScrollBarVisible then
  begin
    Panel2.Constraints.MinWidth := 280;
  end
  else
    Panel2.Constraints.MinWidth := 265;
end;

procedure TfraFloatingResub.popFilterBarPopup(Sender: TObject);
begin
  tbiGroupByBox.Checked := grdResubResultlistDevExView.OptionsView.GroupByBox;
  tbiFooterBox.Checked := grdResubResultlistDevExView.OptionsView.Footer;
end;

procedure TfraFloatingResub.popResubGridPopup(Sender: TObject);
begin
  SpTBXItem3.Caption := fraResub.btnResubCancel.Caption;
  SpTBXItem3.Enabled := fraResub.btnResubCancel.Enabled;
  SpTBXItem2.Caption := fraResub.btnResubForward.Caption;
  SpTBXItem2.Enabled := fraResub.btnResubForward.Enabled;
  SpTBXItem1.Caption := fraResub.btnResubDone.Caption;
  SpTBXItem1.Enabled := fraResub.btnResubDone.Enabled;
end;

procedure TfraFloatingResub.grdResubResultlistMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
var
  UserAction: PUserAction;
  i : Integer;
  doc: TbfaDocument;
  found: Boolean;
  MouseDownPos: TPoint;
  TitleRect: TRect;
  Pt1, Pt2: TPoint;
  src, dest: TList;
  dsc2 : TDataSource;
begin
  try
//    FMouseDown := False;
//    FIsDragging := False;

    MouseDownPos := grdResultlistDevEx.ScreenToClient(mouse.cursorpos);
    Pt1.X := 0;
    Pt1.Y := 0;
    Pt2.X := grdResultlistDevEx.ClientWidth;
    Pt2.Y := 18;

    TitleRect := Classes.rect(Pt1, Pt2);
//    if (Shift = []) and (PtInRect(TitleRect, MouseDownPos)) then
//      if not ((grdResubResultlistDevExView.DataController.DataSource = nil) or
//              (grdResubResultlistDevExView.DataController.DataSet = nil))
//      then
//        frmMainForm.grdResultlistOnColSizing;

    dsc2 := grdResubResultlistDevExView.DataController.DataSource;
    if (Button = mbRight) or (dsc2 = nil) or (dsc2.DataSet = nil) or
       (grdResubResultlistDevExView.ActRec = -1)
    then
      Exit;

    grdResubResultlistDevExView.DoMouseUp(Button, Shift, X, Y);

    src := TList.Create;

//    for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
//      if bitfarmApp.CurrentContainer[i].InEditMode then
//        src.Add(Pointer(bitfarmApp.CurrentContainer[i].ID));

    if (Shift = [ssShift]) or (Shift = [ssCtrl])
      //14.04.2022  or ((Shift = []) and grdResubResultlistDevExView.IsSelectionChanged)
    then
    begin
      dsc.DataSet.DisableControls;
      try
        if (Shift = [ssCtrl])
        //14.04.2022 or ((Shift = []) and grdResubResultlistDevExView.IsSelectionChanged)
        then
        begin
//          if grdResubResultlistDevExView.Controller.FocusedRow <> nil then
//            grdResubResultlistDevExView.Controller.FocusedRow.Selected := True;
//          bitfarmApp.SelectedRowsToCurrentContainer(grdResubResultlistDevExView);
//          if ((Shift = []) and grdResubResultlistDevExView.IsSelectionChanged) then
//            grdResubResultlistDevExView.IsSelectionChanged := False;
        end
        else if (Shift = [ssShift]) then
        begin
//          bitfarmApp.ClearCurrentContainer;   //entfernt Document-Objekte, wenn nicht in Tabs geffnet
//          bitfarmApp.SelectedRowsToCurrentContainer(grdResubResultlistDevExView, False, src);
        end;
      finally
        dsc.DataSet.EnableControls;
      end;

      if src.Count > 0 then
      begin
//        try
//          try
//            UserAction := bitfarmApp.CreateUserAction;
//            UserAction^.ActionName := 'actBackgroundCancel';
//            for i := 0 to src.Count - 1 do
//              UserAction^.Params.Add(IntToStr(Integer(src[i])));
//            bitfarmApp.BackThread.Add(UserAction);
//          except
//            bitfarmLog.Write(llNormal, ltException, 'grdResultlistMouseUp - ', ClassName);
//          end;
//        finally
//        end;
      end;
    end
    else
      grdResultlistDblClick(Sender);
  except
    bitfarmApp.Log.Write(llNormal, ltException, 'grdResubResultlistMouseUp', ClassName);
  end;
end;

procedure TfraFloatingResub.grdResultListSelectionChanged(Sender: TcxCustomGridTableView);
var
  name: string;
  id, Idx: Integer;
  itm: TcxCustomGridTableItem;
begin
  if grdResubResultlistDevExView.DataController.RowCount = 0  then
    Exit;

  bitfarmApp.Log.DebugBegin(llDebug, 'grdResultListSelectionChanged', ClassName);
  fraResub.LoadResub := True;
  try
    try
      try
        itm := grdResubResultlistDevExView.DataController.GetItemByFieldName('info');
        if itm <> nil then
        begin
          Idx := itm.Index;
          fraResub.edtResubInfo.Text := grdResubResultlistDevExView.DataController.GetValue(
              grdResubResultlistDevExView.ActRec, Idx);
        end;
      except
        //29.06.2023
      end;

      try
        itm := grdResubResultlistDevExView.DataController.GetItemByFieldName('comment');
        if itm <> nil then
        begin
          Idx := itm.Index;
          fraResub.edtResubComment.Text := grdResubResultlistDevExView.DataController.GetValue(
              grdResubResultlistDevExView.ActRec, Idx);
        end;
      except
        //29.06.2023
      end;

      if fraResub.ResubKind = rkMyTasks then
      begin
        try
          itm := grdResubResultlistDevExView.DataController.GetItemByFieldName('date');
          if itm <> nil then
          begin
            Idx := itm.Index;
            fraResub.cxDateEdit1.Date := grdResubResultlistDevExView.DataController.GetValue(
                grdResubResultlistDevExView.ActRec, Idx);
          end;
        except
          //29.06.2023
        end;
      end
      else if fraResub.ResubKind = rkController then
      begin
        name := '';
        try
          id := grdResubResultlistDevExView.DataController.GetValue(
            grdResubResultlistDevExView.ActRec,
            grdResubResultlistDevExView.DataController.GetItemByFieldName('groupid').Index);
          if id > 0 then
            name := bitfarmApp.grouplist[bitfarmApp.grouplist.IndexOfObject(TObject(id))]
          else
          begin
            id := grdResubResultlistDevExView.DataController.GetValue(
              grdResubResultlistDevExView.ActRec,
              grdResubResultlistDevExView.DataController.GetItemByFieldName('userid_work').Index);
            name := bitfarmApp.userlist[bitfarmApp.userlist.IndexOfObject(TObject(id))];
          end;
        except
          //29.06.2023
          name := '';
        end;
        fraResub.cbbUserGroups.ItemIndex := fraResub.cbbUserGroups.Items.IndexOf(name);
      end;
      try
        if (grdResubResultlistDevExView.DataController.GetValue(
            grdResubResultlistDevExView.ActRec,
            grdResubResultlistDevExView.DataController.GetItemByFieldName('status').Index) and 2) = 2
        then
          fraResub.tbiResubWork.Color := gclYellow
        else
          fraResub.tbiResubWork.Color := cColorWhite;
      except
        //29.06.2023
      end;

      if Self.Parent.Visible and Self.Parent.Enabled and grdResultlistDevEx.Enabled then
        grdResultlistDevEx.SetFocus;
    except
      bitfarmApp.Log.Write(llNormal, ltException, 'grdResultListSelectionChanged', ClassName);
    end;
  finally
    fraResub.LoadResub := False;
    bitfarmApp.Log.DebugEnd(llDebug, 'grdResultListSelectionChanged', ClassName);
  end
end;

end.
