unit FulltextFrame;

interface

uses
  gnugettext, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, ExtCtrls,
  Dialogs, SpTBXControls, StdCtrls, SpTBXEditors, SpTBXItem, ComCtrls,
  JvComponentBase, JvFormPlacement, TB2Item, Menus;

type
  TfraFulltext = class(TFrame)
    SpTBXPanel1: TSpTBXPanel;
    edtSearchFulltext: TSpTBXEdit;
    btnDown: TSpTBXButton;
    btnUp: TSpTBXButton;
    chkWholeWords: TSpTBXCheckBox;
    mmoFulltext: TRichEdit;
    chkCircle: TSpTBXCheckBox;
    popFulltext: TSpTBXPopupMenu;
    mniSelectedInArchive: TSpTBXItem;
    mniSelectedToToolbar: TSpTBXItem;
    mniSelectedInTree: TSpTBXItem;
    sptbxsprtrtm1: TTBSeparatorItem;
    mniSelectedToLinks: TSpTBXItem;
    mniSelectedToKeywords: TSpTBXItem;
    mniSelectedToClipboard: TSpTBXItem;
    procedure tmrMarkFulltext(Sender: TObject);
    procedure edtSearchFulltextChange(Sender: TObject);
    procedure edtSearchFulltextKeyPress(Sender: TObject; var Key: Char);
    procedure SearchPrevious;
    procedure btnDownClick(Sender: TObject);
    procedure btnUpClick(Sender: TObject);
    procedure chkWholeWordsClick(Sender: TObject);
    procedure mmoFulltextKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edtSearchFulltextKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mmoFulltextKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mmoFulltextMouseEnter(Sender: TObject);
    procedure mniSelectedToClipboardClick(Sender: TObject);
    procedure mniSelectedToKeywordsClick(Sender: TObject);
    procedure popFulltextPopup(Sender: TObject);
    procedure mniSelectedToLinksClick(Sender: TObject);
    procedure mniSelectedToToolbarClick(Sender: TObject);
    procedure mniSelectedInArchiveClick(Sender: TObject);
    procedure mniSelectedInTreeClick(Sender: TObject);
    procedure mmoFulltextResizeRequest(Sender: TObject; Rect: TRect);
    procedure mmoFulltextDblClick(Sender: TObject);
  private
    { Private-Deklarationen }
    inputtimer : TTimer;

  protected
    procedure CopySelectedTextToField(Sender: TObject);

  public
    { Public-Deklarationen }
    searchpos : Integer;
    found : Boolean;
    lastedit : WideString;
    OnResizeZoom: procedure (Sender: TObject) of object;

    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    procedure SearchNext(WithDialog : Boolean = True);
    procedure Clear;
    function GetSelectedText: string;
    function IsCurrentDocInEditMode: Boolean;
    function MarkText(RichEdit : TRichEdit; const AWord: string; AOptions: TSearchTypes): Boolean;
    function SelectNextRichText(RichEdit : TRichEdit; const AWord: string; StartPos: Integer; AOptions: TSearchTypes): Integer;
    function SelectPreviousRichText(RichEdit : TRichEdit; const AWord: string; EndPos: Integer; AOptions: TSearchTypes): Integer;

  end;

implementation

{$R *.dfm}

uses MainDataModule, bfaIconsDM, bfaCommonUtils, bfaPreview36,
  bfaLog, bfaApplication, MainForm, SpTBXDkPanels, StrUtils, bfaCommonMethods, bfaCommonDialogs, bfaObjects36, u_bfaAddfield;



{ TfrmFulltext }

procedure TfraFulltext.btnDownClick(Sender: TObject);
begin
//  try
//    SearchNext;
//  except
//    bitfarmLog.Write(llNormal, ltException, 'btnDownClick', ClassName);
//  end
end;
//
procedure TfraFulltext.btnUpClick(Sender: TObject);
begin
//  try
//    SearchPrevious;
//  except
//    bitfarmLog.Write(llNormal, ltException, 'btnUpClick', ClassName);
//  end;
end;

procedure TfraFulltext.chkWholeWordsClick(Sender: TObject);
begin
//  try
//    if chkWholeWords.Checked then
//    begin
//      lastedit := '';
//      tmrMarkFulltext(Sender);
//    end;
//  except
//    bitfarmLog.Write(llNormal, ltException, 'chkWholeWordsClick', ClassName);
//  end;
end;

procedure TfraFulltext.Clear;
begin
  try
    mmoFulltext.Clear;
//  edtSearchFulltext.Clear;
  except
    bitfarmLog.Write(llNormal, ltException, 'TfraFulltext.Clear', ClassName);
  end;
end;

constructor TfraFulltext.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  btnUp.Images := bfaIcons.ilMainMenu;
  btnDown.Images := bfaIcons.ilMainMenu;
//07.09.2020  btnUp.ImageIndex := 213;
//  btnDown.ImageIndex := 214;
  btnUp.Height := 30;
  btnUp.Width := 30;
  btnUp.ImageIndex := Integer(icoidx_arrow_up);
  btnDown.Height := 30;
  btnDown.Width := 30;
  btnDown.ImageIndex := Integer(icoidx_arrow_down);
  inputtimer := TTimer.Create(Aowner);
  inputtimer.Enabled := False;
  inputtimer.Interval := 200;
  inputtimer.OnTimer := tmrMarkFulltext;
  searchpos := -1;
  found := False;
  mmoFulltext.Font.Size := bfaFontSize; //10.09.2020
  chkWholeWords.Caption := _('Ganzes Wort');
  chkCircle.Caption := _('Suche am Anfang/Ende fortsetzen');
end;

destructor TfraFulltext.Destroy;
begin
  try
    inputtimer.Enabled := False;
    FreeAndNil(inputtimer);
  finally
    inherited Destroy;
  end;
end;

procedure TfraFulltext.edtSearchFulltextChange(Sender: TObject);
begin
//  try
//    inputtimer.Enabled := False;
//    inputtimer.Enabled := True;
//  except
//    bitfarmLog.Write(llNormal, ltException, 'edtSearchFulltextChange', ClassName);
//  end;
end;


procedure TfraFulltext.edtSearchFulltextKeyPress(Sender: TObject;
  var Key: Char);
var
  State: TKeyboardState;
begin
//  try
//    GetKeyboardState(State);
//
//    if Key = #13 then
//    begin
//      if ((State[vk_Shift] and 128)<>0) then
//        SearchPrevious
//      else
//        SearchNext;
//      Key := #0;
//    end;
//  except
//    bitfarmLog.Write(llNormal, ltException, 'edtSearchFulltextKeyPress', ClassName);
//  end;
end;

procedure TfraFulltext.edtSearchFulltextKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
//  try
//    if Key = VK_F3 then
//    begin
//      mmoFulltext.SetFocus;
//      if ssShift in Shift then
//        SearchPrevious
//      else
//        SearchNext;
//    end;
//  except
//    bitfarmLog.Write(llNormal, ltException, 'edtSearchFulltextKeyUp', ClassName);
//  end;
end;

//12.09.2024 SD -->bfacrm:ticket__show__39890
procedure TfraFulltext.mmoFulltextDblClick(Sender: TObject);
var
  EndPos: Integer;
begin
  if Length(mmoFulltext.SelText) = 0 then
    Exit;
  EndPos := 1;
  while not (EndPos > Length(mmoFulltext.SelText)) do
  begin
    Inc(EndPos);
    if mmoFulltext.SelText[EndPos] in [',', '.', ' ', #13, #10, #0] then
    begin
      if EndPos > 1 then
        Dec(EndPos);
      Break;
    end;
  end;
  mmoFulltext.SelLength := EndPos;
end;
//12.09.2024 SD <--bfacrm:ticket__show__39890

procedure TfraFulltext.mmoFulltextKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
//  try
//    if (Key = 70) and (ssCtrl in Shift) then   // STRG + f
//      TbfaPreview(Owner).SearchbarTextEdit.SetFocus;
//  //    edtSearchFulltext.SetFocus;
//  except
//    bitfarmLog.Write(llNormal, ltException, 'mmoFulltextKeyDown', ClassName);
//  end;
end;

procedure TfraFulltext.mmoFulltextKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
//  try
//    if Key = VK_F3 then
//      if ssShift in Shift then
//        SearchPrevious
//      else
//        SearchNext;
//  except
//    bitfarmLog.Write(llNormal, ltException, 'mmoFulltextKeyUp', ClassName);
//  end;
end;

procedure TfraFulltext.mmoFulltextMouseEnter(Sender: TObject);
begin
// SJ 08.06.2022 - bfacrm:ticket__show__31210
// nicht ersichtlich warum das hier notwendig ist. Scrollen funktioniert auch so.
//  try
//    if TbfaPreview(Owner).DontUseMouseEnter or (bitfarmApp.ShowDocumentInProcess) then {or (not bitfarmApp.CanFocus)} // SJ 23.09.2021
//      Exit;
//
//    if (
//         (TSpTBXDockablePanel(Owner.Owner).Parent.Name = 'dckFloating')
//         and
//         (not TForm(TSpTBXDockablePanel(Owner.Owner).Parent.Parent).Active)
//       )
//       or
//       (
//         (TSpTBXDockablePanel(Owner.Owner).Parent = frmMainForm.dckDocumentEditors)
//         and
//         (not frmMainForm.Active)
//        )
//        then
//      Exit;
//
//    mmoFulltext.SetFocus;
//  except
//    bitfarmLog.Write(llNormal, ltException, 'mmoFulltextMouseEnter', ClassName);
//  end;
end;

// occures when the zoom level of the Fulltext changes
// OnResizeZoom assigned at Application (preview.create)
procedure TfraFulltext.mmoFulltextResizeRequest(Sender: TObject; Rect: TRect);
begin
  try
    if Assigned(OnResizeZoom) then
      OnResizeZoom(Sender);
  except
    bitfarmLog.Write(llNormal, ltException, 'mmoFulltextResizeRequest', ClassName);
  end;
end;

procedure TfraFulltext.SearchNext(WithDialog : Boolean = True);
var
  newpos: Integer;
  stype : TSearchTypes;
  txt : string;
begin
//  stype := [];
//  if chkWholeWords.Checked then
//    stype := [stWholeWord];
//
////18.06.2018 Hotfix bei Version 3.6.0.1045 -->
//  if (LeftStr(edtSearchFulltext.Text,1) = '"') and (RightStr(edtSearchFulltext.Text,1) = '"') then
//    txt := Copy(edtSearchFulltext.Text, 2, Length(edtSearchFulltext.Text) -2)
//  else
//    txt := edtSearchFulltext.Text;
////18.06.2018 Hotfix bei Version 3.6.0.1045 <--
//
//  newpos := SelectNextRichText(mmoFulltext, txt, searchpos +1, stype);
//  if newpos = -1 then
//  begin
//    if found then
//    begin
//      if chkCircle.Checked then
//        searchpos := SelectNextRichText(mmoFulltext, txt, 0, stype)
//      else if ((WithDialog) and
//          (BfMessageDlg(_('Kein weiteres Vorkommen gefunden.\nMchten Sie vom Dokumentenanfang weitersuchen?'),
//          mtConfirmation, [mbYes,mbNo]) = mrYes)) then
//      begin
////        Key := #0;
////          searchpos := -1;
//        searchpos := SelectNextRichText(mmoFulltext, txt, 0, stype);
//        Abort;
//      end;
//    end
//    else begin
//      if WithDialog then
//        BfShowMessage(_('Wort nicht gefunden'));
//      searchpos := -1;
//      found := False;
//    end;
//  end else
//  begin
//    found := True;
//    searchpos := newpos;
//  end;
end;

procedure TfraFulltext.SearchPrevious;
var
  newpos: Integer;
  stype : TSearchTypes;
  txt : string;
begin
//  stype := [];
//  if chkWholeWords.Checked then
//    stype := [stWholeWord];
//
////18.06.2018 Hotfix bei Version 3.6.0.1045 -->
//  if (LeftStr(edtSearchFulltext.Text,1) = '"') and (RightStr(edtSearchFulltext.Text,1) = '"') then
//    txt := Copy(edtSearchFulltext.Text, 2, Length(edtSearchFulltext.Text) -2)
//  else
//    txt := edtSearchFulltext.Text;
////18.06.2018 Hotfix bei Version 3.6.0.1045 <--
//
//  newpos := SelectPreviousRichText(mmoFulltext, txt, searchpos -1, stype);
//  if newpos = -1 then
//  begin
//    if found then
//    begin
//      if chkCircle.Checked then
//        searchpos := SelectPreviousRichText(mmoFulltext, txt, Length(mmoFulltext.Text), stype)
//
//      else if BfMessageDlg(_('Kein weiteres Vorkommen gefunden.\nMchten Sie vom Dokumentenende weitersuchen?'),
//          mtConfirmation, [mbYes,mbNo]) = mrYes then
//      begin
////        Key := #0;
////          searchpos := -1;
//        searchpos := SelectPreviousRichText(mmoFulltext, txt, Length(mmoFulltext.Text), stype);
//        Abort;
//      end;
//    end
//    else begin
//      BfShowMessage(_('Wort nicht gefunden'));
//      searchpos := -1;
//      found := False;
//    end;
//  end else
//  begin
//    found := True;
//    searchpos := newpos;
//  end;
end;

procedure TfraFulltext.mniSelectedInArchiveClick(Sender: TObject);
begin
  try
    bitfarmLog.Write(llDebug, ltDebug, 'mniSelectedInArchiveClick', Classname);
    frmMainForm.edtGeneralSearch.Text := ParseNotAllowedChars(GetSelectedText);
    frmMainForm.actSearch.Execute;
  except
    on e:exception do
      bitfarmLog.Write(llNormal, ltException, 'TfraFulltext.mniSelectedInArchiveClick' + e.Message, ClassName);
  end;
end;

procedure TfraFulltext.mniSelectedInTreeClick(Sender: TObject);
var
  UserAction: PUserAction;
begin
  try
    bitfarmLog.Write(llDebug, ltDebug, 'mniSelectedInTreeClick', Classname);

    frmMainForm.edtGeneralSearch.Text := ParseNotAllowedChars(GetSelectedText);
    UserAction := bitfarmApp.CreateUserAction;
    UserAction^.ActionName := 'actCtrlAltF';
    UserAction^.params.Add('1');
    bitfarmApp.MainThread.Add(UserAction);

    if frmMainForm.actSearch.Enabled then
      frmMainForm.actSearch.Execute;
  except
    on e:exception do
      bitfarmLog.Write(llNormal, ltException, 'TfraFulltext.mniSelectedInTreeClick' + e.Message, ClassName);
  end;
end;

procedure TfraFulltext.mniSelectedToClipboardClick(Sender: TObject);
begin
  try
    bitfarmLog.Write(llDebug, ltDebug, 'mniSelectedToClipboardClick', Classname);
    SendMessage(TWinControl(mmoFulltext).Handle, WM_COPY, 0, 0);
  except
    bitfarmLog.Write(llNormal, ltException, 'TfraFulltext.mniItemCopyClick', ClassName);
  end;
end;

procedure TfraFulltext.mniSelectedToKeywordsClick(Sender: TObject);
begin
  try
    bitfarmLog.Write(llDebug, ltDebug, 'mniSelectedToKeywordsClick', Classname);
    frmMainform.AddTag(GetSelectedText, true);
  except
    on e:exception do
      bitfarmLog.Write(llNormal, ltException, 'TfraFulltext.mniKeywordsClick' + e.Message, ClassName);
  end;
end;

procedure TfraFulltext.mniSelectedToLinksClick(Sender: TObject);
var
  sText: string;
begin
  try
    bitfarmLog.Write(llDebug, ltDebug, 'mniSelectedToLinksClick', Classname);
    sText := GetSelectedText;
    bitfarmApp.CreateNewLinkAction(true, false, false, sText);
  except
    on e:exception do
      bitfarmLog.Write(llNormal, ltException, 'TfraFulltext.mniLinksClick' + e.Message, ClassName);
  end;
end;

procedure TfraFulltext.mniSelectedToToolbarClick(Sender: TObject);
begin
  try
    bitfarmLog.Write(llDebug, ltDebug, 'mniSelectedToToolbarClick', Classname);
    if not(bitfarmApp.GetActivePreview.tbi_SearchBar.Checked) then
      bitfarmApp.GetActivePreview.tbi_SearchBarClick(Sender);

    bitfarmApp.GetActivePreview.SearchbarTextEdit.Text := GetSelectedText;
    bitfarmApp.GetActivePreview.FulltextView.mmoFulltext.SelStart := bitfarmApp.GetActivePreview.FulltextView.mmoFulltext.SelStart - 1;
    bitfarmApp.GetActivePreview.SearchbarButtonDownClick(Sender);
  except
    on e:exception do
      bitfarmLog.Write(llNormal, ltException, 'TfraFulltext.mniSelectedToToolbarClick' + e.Message, ClassName);
  end;
end;

procedure TfraFulltext.popFulltextPopup(Sender: TObject);
Var
  bSelectedTextNotEmpty: Boolean;
  i: integer;
  SubItem: TSpTBXItem;
  info : tagMENUINFO;
begin
  bSelectedTextNotEmpty := GetSelectedText <> '';

  mniSelectedToClipboard.Enabled := bSelectedTextNotEmpty;
  mniSelectedToKeywords.Enabled := bSelectedTextNotEmpty and IsCurrentDocInEditMode;
  mniSelectedToLinks.Enabled := bSelectedTextNotEmpty;
  mniSelectedToToolbar.Enabled := bSelectedTextNotEmpty;
  mniSelectedInArchive.Enabled := bSelectedTextNotEmpty;
  mniSelectedInTree.Enabled := bSelectedTextNotEmpty;

  for i := popFulltext.Items.Count - 1 downto 0 do
  begin
     if popFulltext.Items[i].Tag = -1 then
        popFulltext.Items.Delete(i);
  end;

  if bSelectedTextNotEmpty and IsCurrentDocInEditMode then
  begin
    for i := 0 to frmMainform.scrbxViewerAddfields.ComponentCount - 1 do
    begin
      if frmMainform.scrbxViewerAddfields.Components[i] is TBfaAddfieldComp then
      begin
        SubItem:= TSpTBXItem.Create(popFulltext);
        SubItem.Caption := TBfaAddfieldComp(frmMainform.scrbxViewerAddfields.Components[i]).Dispname;
        SubItem.OnClick := CopySelectedTextToField;
        SubItem.Tag := -1;
        popFulltext.Items.Add(SubItem);
      end;
    end;
  end;
end;

procedure TfraFulltext.CopySelectedTextToField(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'CopySelectedTextToField', Classname);
  try
    if GetSelectedText = '' then
      exit;

    bitfarmApp.CopyResultToAddfieldAction(Sender, GetSelectedText);
  finally
    bitfarmLog.DebugEnd(llDebug, 'CopySelectedTextToField', Classname);
  end;
end;

function TfraFulltext.GetSelectedText: string;
begin
  Result := trim(mmoFulltext.SelText);
end;

function TfraFulltext.IsCurrentDocInEditMode: Boolean;
begin
  result :=      (bitfarmApp.CurrentContainer.Count > 0)
             and (bitfarmApp.CurrentContainer[0] <> nil)
             and bitfarmApp.CurrentContainer[0].InEditMode;
end;

procedure TfraFulltext.tmrMarkFulltext(Sender: TObject);
var
  stype : TSearchTypes;
begin
//  stype := [];
//  if chkWholeWords.Checked then
//    stype := [stWholeWord];
//  if edtSearchFulltext.Text = '' then
//  begin
//    mmoFulltext.SelStart := 0;
//    mmoFulltext.SelLength := Length(mmoFulltext.Text);
//    mmoFulltext.SelAttributes.Color := 0;
//    mmoFulltext.SelAttributes.Style := [];
//    mmoFulltext.SelLength := 0;
//  end
//  else if (edtSearchFulltext.Text <> lastEdit) and (Length(edtSearchFulltext.Text) > 2) then
//    MarkText(mmoFulltext, edtSearchFulltext.Text, stype);
//  lastedit := edtSearchFulltext.Text;
//  inputtimer.Enabled := False;
end;

function TfraFulltext.MarkText(RichEdit : TRichEdit; const AWord: string; AOptions: TSearchTypes): Boolean;
var
  OrigSelStart, OrigSelLen : integer;
  Start, Found, lenText, i : integer;
  AColor : array[0..9] of TColor;
  StrList : TStrings;
  InputStr : string;
begin
//  if AWord = '' then
//    exit;
//
//  OrigSelStart := RichEdit.SelStart;
//  OrigSelLen := RichEdit.SelLength;
//  lenText := Length(RichEdit.Text);
//  RichEdit.Perform(WM_SETREDRAW, 0, 0);
//
//
//  RichEdit.SelStart := 0;
//  RichEdit.SelLength := lenText;
//  RichEdit.SelAttributes.Color := 0;
//  RichEdit.SelAttributes.Style := [];
//
//
//   InputStr := Trim(ParseSemicolonUseBackslash(AWord));
//   StrList := StrToWords4(InputStr);
//   if StrList.count = 0 then
//      exit;
//
////20.11.2017 Ticket 12680 -->
//  for i := 0 to StrList.Count - 1 do
//  begin
//    if (LeftStr(StrList[i],1) = '"') and (RightStr(StrList[i],1) = '"') then
//      StrList[i] := Copy(StrList[i], 2, Length(StrList[i]) -2);
//
//    if length(StrList[i]) > 1 then
//    begin
//      case Ord(StrList[i][1]) of
//        $2B, $2D, $2F:
//        begin
//          StrList[i] := copy(StrList[i], 2, length(StrList[i]));
//        end;
//      end;
//    end;
//  end;
////20.11.2017 Ticket 12680 <--
//
//   AColor[0] := gclRed;
//   AColor[1] := gclLime;
//   AColor[2] := clBlue;
//   AColor[3] := clFuchsia;
//   AColor[4] := clMaroon;
//   AColor[5] := clGreen;
//   AColor[6] := clNavy;
//   AColor[7] := clPurple;
//   AColor[8] := gclTeal;
//   AColor[9] := gclOlive;
//
//    for i := 0 to StrList.Count - 1 do
//    begin
//      try
//        Start := 0;
//        Found := RichEdit.FindText(StrList[i], Start, lenText, AOptions);
//        while Found <> -1 do begin
//          RichEdit.SelStart := Found;
//          RichEdit.SelLength := Length(StrList[i]);
//          // TODO: save start of search match and original font colour
//          RichEdit.SelAttributes.Color := AColor[i mod 10];
//          RichEdit.SelAttributes.Style := [fsBold];
//          Start := Found + Length(StrList[i]);
//          Found := RichEdit.FindText(StrList[i], Start, lenText, AOptions);
//        end;
//      finally
//        RichEdit.SelStart := OrigSelStart;
//        RichEdit.SelLength := OrigSelLen;
//        RichEdit.Perform(WM_SETREDRAW, 1, 0);
//        RichEdit.Repaint;
//      end;
//    end;
end;

function TfraFulltext.SelectNextRichText(RichEdit : TRichEdit; const AWord: string; StartPos: Integer; AOptions: TSearchTypes): Integer;
var
  OrigSelStart, OrigSelLen: integer;
  Found, lenText: integer;
begin
//  if AWord = '' then
//    exit;
//
//  lenText := Length(RichEdit.Text);
//  RichEdit.Perform(WM_SETREDRAW, 0, 0);
//  try
//    Result := RichEdit.FindText(AWord, StartPos, lenText, AOptions);
//    if Result <> -1 then
//    begin
//      RichEdit.SelStart := Result;
//      RichEdit.SelLength := Length(AWord);
//    end;
//  finally
//
//    RichEdit.Perform(WM_SETREDRAW, 1, 0);
//    RichEdit.Repaint;
//  end;
end;

function TfraFulltext.SelectPreviousRichText(RichEdit : TRichEdit; const AWord: string; EndPos: Integer; AOptions: TSearchTypes): Integer;
var
  OrigSelStart, OrigSelLen: integer;
  Found, lenText: integer;
begin
//  if AWord = '' then
//    exit;
//
//  Result := -1;
//  lenText := Length(RichEdit.Text) - EndPos;
//  RichEdit.Perform(WM_SETREDRAW, 0, 0);
//  try
//    Found := RichEdit.FindText(AWord, 0, EndPos, AOptions);
//
//    while Found <> -1 do
//    begin
//      Result := Found;
//      Found := RichEdit.FindText(AWord,  Found +1 , EndPos -Result, AOptions);
//    end;
//
//    if Result <> -1 then
//    begin
//      RichEdit.SelStart := Result;
//      RichEdit.SelLength := Length(AWord);
//    end;
//  finally
//    RichEdit.Perform(WM_SETREDRAW, 1, 0);
//    RichEdit.Repaint;
//  end;
end;

end.
