unit GridConfigForm;

interface

uses
  gnugettext, Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, SpTBXControls, u_bfaScrollBox, Vcl.StdCtrls, SpTBXEditors, SpTBXItem,
  bfaBaseObjects, bfaObjects36, u_bfaAddfield, System.Generics.Collections, cxGridTableView,
  cxGrid, Vcl.Menus, SpTBXFormPopupMenu, SpTBXExtEditors, SVNInfoForm;

type
  TfrmGridConfig = class(TForm)
    SpTBXPanel1: TSpTBXPanel;
    cbxName: TSpTBXComboBox;
    cbxType: TSpTBXComboBox;
    btnAdd: TSpTBXButton;
    btnModify: TSpTBXButton;
    btnDelete: TSpTBXButton;
    scrbxGrid: TbfaScrollBox;
    SpTBXPanel2: TSpTBXPanel;
    chkShowTitle: TSpTBXCheckBox;
    chkShowSums: TSpTBXCheckBox;
    chkGroupbyBox: TSpTBXCheckBox;
    chkShowIndicator: TSpTBXCheckBox;
    chkUsePopups: TSpTBXCheckBox;
    chkManualSorting: TSpTBXCheckBox;
    chkAlternateRows: TSpTBXCheckBox;
    chkMultiSelect: TSpTBXCheckBox;
    btnOk: TSpTBXButton;
    btnCancel: TSpTBXButton;
    chkUseColumnsNames: TSpTBXCheckBox;
    lb1: TSpTBXLabel;
    btnedExpression: TSpTBXButtonEdit;
    lb2: TSpTBXLabel;
    cbxFormat: TSpTBXComboBox;
    chkReadOnly: TSpTBXCheckBox;
    cbxDBType: TSpTBXComboBox;
    cbxDBField: TSpTBXComboBox;
    btnList: TSpTBXButton;
    lb3: TSpTBXLabel;
    cbxSummary: TSpTBXComboBox;
    chkShowTab: TSpTBXCheckBox;
    edtTabName: TSpTBXEdit;
    lb4: TSpTBXLabel;
    edtDefaultValue: TSpTBXEdit;
    frmpopExpression: TSpTBXFormPopupMenu;
    chkStampTransparent: TSpTBXCheckBox;
    cbxStampSize: TSpTBXComboBox;
    cedtStampColor: TSpTBXColorEdit;
    lb5: TSpTBXLabel;
    lb6: TSpTBXLabel;
    chkExportAddfields: TSpTBXCheckBox;
    chkExportUnicode: TSpTBXCheckBox;
    procedure FormShow(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure cbxNameChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbxNameKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure chkClick(Sender: TObject);
    procedure btnedExpressionChange(Sender: TObject);
    procedure cbxTypeChange(Sender: TObject);
    procedure cbxFormatChange(Sender: TObject);
    procedure chkReadOnlyClick(Sender: TObject);
    procedure cbxDBTypeChange(Sender: TObject);
    procedure cbxDBFieldChange(Sender: TObject);
    procedure btnListClick(Sender: TObject);
    procedure cbxSummaryChange(Sender: TObject);
    procedure chkShowTabClick(Sender: TObject);
    procedure edtTabNameChange(Sender: TObject);
    procedure edtTabNameKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure btnAddClick(Sender: TObject);
    procedure btnModifyClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure edtDefaultValueChange(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure GridColumnPosChanged(Sender: TcxGridTableView; AColumn: TcxGridColumn);
    procedure GridColumnSizeChanged(Sender: TcxGridTableView; AColumn: TcxGridColumn);
    procedure GridColumnHeaderClick(Sender: TcxGridTableView; AColumn: TcxGridColumn);
    procedure btnedExpressionSubEditButton0Click(Sender: TObject);
    procedure cbxStampSizeChange(Sender: TObject);
    procedure cedtStampColorChange(Sender: TObject);
    procedure  GridSearchOnChange(Sender: TObject);
  private
    { Private-Deklarationen }
    SkipOnChange: Boolean;
    new_addid: Integer;
    procedure LoadAddfieldlist;
    function GetExpressionsCaption: string;
  public
    { Public-Deklarationen }
    Modified: Boolean;
    Gridfield: TbfaAddfield;
    AddfieldComp : TbfaAddfieldComp;
    InitialConfig: TbfaGridConfig;
    Addfields: TList<TbfaAddfield>;   // Referenz auf die Addfields des Administrators
    InitOptions: Integer;
    TempColumn: TbfaColumnConfig;
    procedure SetModified;
    procedure Retranslate;
  end;

var
  frmGridConfig: TfrmGridConfig;
  frmPopInfo: TfrmSVNInfo;

implementation

uses
  System.StrUtils, cxSpinEdit, cxCurrencyEdit, MainForm, TagsForm, bfaCommonUtils, bfaCommonDialogs, dxCore,
  cxGridDBTableView, cxCustomData, MainDataModule;
{$R *.dfm}

procedure TfrmGridConfig.btnAddClick(Sender: TObject);
var
  newcolumn: TbfaColumnConfig;
  newconfig: TbfaGridConfig;
  i, idx: Integer;
begin
  // erst etwas bereinigen, Typabhngig
  if not (Integer(cbxType.Items.Objects[cbxType.ItemIndex]) in [2, 3, 6, 7]) then
  begin
    TempColumn.DisplayFormat := '';
    TempColumn.SummaryType := smtNone;
    cbxFormat.ItemIndex := -1;
    cbxSummary.ItemIndex := -1;
  end;

  if Integer(cbxType.Items.Objects[cbxType.ItemIndex]) <> 4 then
    TempColumn.ListItems.Clear;

  newconfig := TbfaGridConfig.Create;
  newconfig.Clone(AddfieldComp.compGrid.Config);

  newcolumn := TbfaColumnConfig.Create;
  newcolumn.Clone(TempColumn);
  newcolumn.Fieldname := 'new_' + IntToStr(new_addid);
  newcolumn.ColWidth := 100;
  inc(new_addid);
  newconfig.Columns.Add(newcolumn);
  FreeAndNil(TempColumn);
  TempColumn := TbfaColumnConfig.Create;
  Gridfield.Modified := True;

  Addfieldcomp.compGrid.ResetColumns;
  newconfig.AlternateRows := bitfarmApp.ViewerOptions.GeneralOptions.RowColorEvenOdd;
  AddfieldComp.compGrid.LoadConfig(newconfig);
  Addfieldcomp.LoadGridSearchField;
  //cbxName.AddItem(newcolumn.Name, newcolumn);
  //    zwei grundlegende Probnleme wurden hier gelst
  // 1. nach einem AddItem oder AddObject aktualisiert sich NICHT der ItemIndex, daher muss der zugewiesen werden.
  //    da per ItemIndex die aktuelle Feldkonfiguration aus dem DropDown cbxName geholt wird, sind nderungen an
  //    neu angelegt Feldern, wenn NICHT die ComboBox nochmal geffnet wurde, bei ItemIndex = -1
  //    in die TempColumn geschrieben worden
  // 2. da hier newcolumn der Combobox zugewiesen wurde und nicht compGrid.Config.Columns wurden nderungen
  //    an neuen Feldern (auch wenn diesmal der ItemIndex stimmte) trotzdem nicht gespeichert, weil es sich um
  //    unterschiedliche Instanzen handelte.
  //    Zwar wurde die newcolumn der newconfig hinzugefgt und diese per LoadConfig in compGrid.Config.Columns geladen,
  //    allerdings wird das Object in LoadConfig selbst nochmal geclont.
  //    Somit war newcolumn[x] <> compGrid.Config.Columns[x]
  idx := -1;
  for i := 0 to AddfieldComp.compGrid.Config.Columns.Count -1 do
  begin
    if AddfieldComp.compGrid.Config.Columns[i].Name = newcolumn.Name then
    begin
      idx := cbxName.Items.AddObject(AddfieldComp.compGrid.Config.Columns[i].Name, AddfieldComp.compGrid.Config.Columns[i]);
      Break;
    end;
  end;

  cbxName.ItemIndex := idx;
  btnAdd.Enabled := False;
  cbxType.Enabled := False;
  FreeAndNil(newconfig);
  SetModified;
end;

procedure TfrmGridConfig.btnCancelClick(Sender: TObject);
begin
  Modified := False;   // bei Cancel Modified zurcksetzen
end;

procedure TfrmGridConfig.btnDeleteClick(Sender: TObject);
var
  value, oldvalue: string;
  idx, i: Integer;
  newconfig: TbfaGridConfig;
begin
  if cbxName.ItemIndex > -1 then
  begin
    value := cbxName.Text;
    oldvalue := cbxName.Text;

    if BfMessageDlg(Format(_('Mchten Sie die Spalte %s wirklich lschen?'),[oldvalue]), mtConfirmation, [mbYes, mbNo], True) = mrYes then
    begin
      idx := cbxName.ItemIndex;
      cbxName.Items.Delete(idx);

      for i := 0 to AddfieldComp.compGrid.Config.Columns.Count -1 do
        if AddfieldComp.compGrid.Config.Columns[i].Name = oldvalue then
        begin
          if LeftStr(AddfieldComp.compGrid.Config.Columns[i].Fieldname,4) = 'new_' then
            AddfieldComp.compGrid.Config.Columns.Delete(i)
          else
            AddfieldComp.compGrid.Config.Columns[i].Fieldname := 'del_' + AddfieldComp.compGrid.Config.Columns[i].Fieldname;
          Break;
        end;

      newconfig := TbfaGridConfig.Create;
      newconfig.Clone(AddfieldComp.compGrid.Config);

      Gridfield.Modified := True;

      Addfieldcomp.compGrid.ResetColumns;
      newconfig.AlternateRows := bitfarmApp.ViewerOptions.GeneralOptions.RowColorEvenOdd;
      AddfieldComp.compGrid.LoadConfig(newconfig);
      Addfieldcomp.LoadGridSearchField;
      if cbxName.GetCount > 0 then
        cbxName.ItemIndex := 0
      else begin
        cbxName.ItemIndex := -1;
        cbxName.Text := '';
      end;
      btnAdd.Enabled := False;
      cbxType.Enabled := False;
      FreeAndNil(newconfig);
      cbxNameChange(Sender);
      SetModified;
    end;
  end;
end;

procedure TfrmGridConfig.btnedExpressionChange(Sender: TObject);
var
  columnconfig : TbfaColumnConfig;
begin
  if SkipOnChange then
    Exit;

  chkReadOnly.Checked := Trim(btnedExpression.Text) <> '';
  chkReadOnly.Enabled := not (Trim(btnedExpression.Text) <> '');

  if cbxName.ItemIndex > -1 then
  begin
    columnconfig := TbfaColumnConfig(cbxName.Items.Objects[cbxName.ItemIndex]);
    columnconfig.ReadOnly := chkReadOnly.Checked;
    columnconfig.Expression := Trim(btnedExpression.Text);
  end else
  begin
    TempColumn.ReadOnly := chkReadOnly.Checked;
    TempColumn.Expression := Trim(btnedExpression.Text);
  end;

  SetModified;
end;

procedure TfrmGridConfig.btnedExpressionSubEditButton0Click(Sender: TObject);
begin
  frmpopExpression.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
end;

procedure TfrmGridConfig.btnListClick(Sender: TObject);
var
  columnconfig : TbfaColumnConfig;
  i: Integer;
begin
  frmMainForm.frmTags := TfrmTags.Create(nil);
  frmMainForm.frmTags.MaxLineLength := 48;
  try
    if cbxName.ItemIndex > -1 then
    begin
      columnconfig := TbfaColumnConfig(cbxName.Items.Objects[cbxName.ItemIndex]);
      frmMainForm.frmTags.mmoTags.Lines := columnconfig.ListItems;
    end else
    begin
      frmMainForm.frmTags.mmoTags.Lines :=  TempColumn.ListItems;
    end;
    frmMainForm.frmTags.Caption := _('Liste bearbeiten');
    frmMainForm.frmTags.ShowModal;

    if frmMainForm.frmTags.ModalResult = mrOk then
    begin
      if cbxName.ItemIndex > -1 then
      begin
        columnconfig.ListItems.Clear;
        for i := 0 to frmMainForm.frmTags.mmoTags.Lines.Count -1 do
        begin
          if Trim(frmMainForm.frmTags.mmoTags.Lines[i]) <> '' then
            columnconfig.ListItems.Add(frmMainForm.frmTags.mmoTags.Lines[i]);
        end;
      end else
      begin
        TempColumn.ListItems.Clear;
        for i := 0 to frmMainForm.frmTags.mmoTags.Lines.Count -1 do
        begin
          if Trim(frmMainForm.frmTags.mmoTags.Lines[i]) <> '' then
            TempColumn.ListItems.Add(frmMainForm.frmTags.mmoTags.Lines[i]);
        end;
      end;
      SetModified;
    end;
  finally
    FreeAndNil(frmMainForm.frmTags);
  end;
end;

procedure TfrmGridConfig.btnModifyClick(Sender: TObject);
var
  value, oldvalue: string;
  idx, i: Integer;
  newconfig: TbfaGridConfig;
begin
  if cbxName.ItemIndex > -1 then
  begin
    value := cbxName.Text;
    oldvalue := cbxName.Text;

    if bfaInputQuery('Spaltentitel ndern', '', value) then
    begin
      idx := cbxName.ItemIndex;
      cbxName.Items[idx] := value;
      TbfaColumnConfig(cbxName.Items.Objects[idx]).Name := value;

      for i := 0 to AddfieldComp.compGrid.Config.Columns.Count -1 do
        if AddfieldComp.compGrid.Config.Columns[i].Name = oldvalue then
          AddfieldComp.compGrid.Config.Columns[i].Name := value;

      newconfig := TbfaGridConfig.Create;
      newconfig.Clone(AddfieldComp.compGrid.Config);

      Gridfield.Modified := True;

      Addfieldcomp.compGrid.ResetColumns;
      newconfig.AlternateRows := bitfarmApp.ViewerOptions.GeneralOptions.RowColorEvenOdd;
      AddfieldComp.compGrid.LoadConfig(newconfig);
      Addfieldcomp.LoadGridSearchField;
      cbxName.ItemIndex := cbxName.Items.IndexOf(value);
      btnAdd.Enabled := False;
      cbxType.Enabled := False;
      FreeAndNil(newconfig);
      SetModified;
    end;
  end;
end;

procedure TfrmGridConfig.btnOkClick(Sender: TObject);
var
  tempcolumns: TList<TbfaColumnConfig>;
  i, j: Integer;
  colname: string;
begin
  AddfieldComp.compGrid.Config.ShowHeader := chkShowTitle.Checked;
  AddfieldComp.compGrid.Config.ShowSummary := chkShowSums.Checked;
  AddfieldComp.compGrid.Config.ShowGroupbybox := chkGroupbyBox.Checked;
  AddfieldComp.compGrid.Config.ShowIndicator := chkShowIndicator.Checked;
  AddfieldComp.compGrid.Config.UsePopups := chkUsePopups.Checked;
  AddfieldComp.compGrid.Config.ManualSorting := chkManualSorting.Checked;
//  AddfieldComp.compGrid.Config.AlternateRows := chkAlternateRows.Checked;
  AddfieldComp.compGrid.Config.MultiSelect := chkMultiSelect.Checked;
  AddfieldComp.compGrid.Config.UseColumnNames := chkUseColumnsNames.Checked;
  AddfieldComp.compGrid.Config.ExportAddfields := chkExportAddfields.Checked;
  AddfieldComp.compGrid.Config.ExportUnicode := chkExportUnicode.Checked;
  if chkShowTab.Checked then
    Gridfield.Options := Gridfield.Options or 16
  else begin
    Gridfield.Options := Gridfield.Options and not 16;
    edtTabName.Text := '';
  end;
  AddfieldComp.compGrid.Config.Displayname := Trim(edtTabName.Text);
  AddfieldComp.compGrid.Config.Stamp_Transparent :=  chkStampTransparent.Checked;
  AddfieldComp.compGrid.Config.Stamp_Size := Integer(cbxStampSize.Items.Objects[cbxStampSize.ItemIndex]);
  AddfieldComp.compGrid.Config.Stamp_Color := cedtStampColor.Text;
  if AddfieldComp.cbxGridSearchField.ItemIndex > -1 then
    AddfieldComp.compGrid.Config.SearchField := TbfaString(AddfieldComp.cbxGridSearchField.Items.Objects[AddfieldComp.cbxGridSearchField.ItemIndex]).Value
  else
    AddfieldComp.compGrid.Config.SearchField := '';

  tempcolumns := TList<TbfaColumnConfig>.Create;

  for i := 1 to AddfieldComp.compGrid.View.ColumnCount -1 do
  begin
    colname := AddfieldComp.compGrid.View.Columns[i].Caption;
    for j := 0 to AddfieldComp.compGrid.Config.Columns.Count -1 do
    begin
      if AddfieldComp.compGrid.Config.Columns[j].Name = colname then
      begin
        if j <> i -1 then
        begin
          AddfieldComp.compGrid.Config.Columns.Move(j, i -1);
          Break;
        end;
      end;
    end;
  end;

end;

procedure TfrmGridConfig.cbxDBFieldChange(Sender: TObject);
var
  columnconfig : TbfaColumnConfig;
begin
  if SkipOnChange then
    Exit;

  if cbxName.ItemIndex > -1 then
  begin
    columnconfig := TbfaColumnConfig(cbxName.Items.Objects[cbxName.ItemIndex]);
    columnconfig.ListAddfield := Integer(TObject(cbxDBField.Items.Objects[cbxDBField.ItemIndex]));
  end else
  begin
    TempColumn.ListAddfield := Integer(TObject(cbxDBField.Items.Objects[cbxDBField.ItemIndex]));
  end;

  SetModified;
end;

procedure TfrmGridConfig.cbxDBTypeChange(Sender: TObject);
var
  columnconfig : TbfaColumnConfig;
begin
  LoadAddfieldlist;

  if SkipOnChange then
    Exit;

  if cbxName.ItemIndex > -1 then
  begin
    columnconfig := TbfaColumnConfig(cbxName.Items.Objects[cbxName.ItemIndex]);
    if cbxDBType.ItemIndex = 0 then
      columnconfig.ListType := lstAddfieldItems
    else
      columnconfig.ListType := lstAddfieldValues;
    if columnconfig.ColumnType = cltDBList then
    begin
      cbxDBField.ItemIndex := cbxDBField.Items.IndexOfObject(TObject(columnconfig.ListAddfield));
    end;
  end else
  begin
    if cbxDBType.ItemIndex = 0 then
      TempColumn.ListType := lstAddfieldItems
    else
      TempColumn.ListType := lstAddfieldValues;
    if TempColumn.ColumnType = cltDBList then
    begin
      cbxDBField.ItemIndex := cbxDBField.Items.IndexOfObject(TObject(TempColumn.ListAddfield));
    end;
  end;

  SetModified;
end;

procedure TfrmGridConfig.cbxFormatChange(Sender: TObject);
var
  columnconfig : TbfaColumnConfig;
begin
  if SkipOnChange then
    Exit;

  if cbxName.ItemIndex > -1 then
  begin
    columnconfig := TbfaColumnConfig(cbxName.Items.Objects[cbxName.ItemIndex]);
    columnconfig.DisplayFormat := Trim(cbxFormat.Text);
  end else
  begin
    TempColumn.DisplayFormat := Trim(cbxFormat.Text);
  end;

  SetModified;
end;

procedure TfrmGridConfig.cbxNameChange(Sender: TObject);
var
  columnconfig: TbfaColumnConfig;
begin
  SkipOnChange := True;
  try
    if cbxName.Text <> '' then
      cbxName.ItemIndex := cbxName.Items.IndexOf(cbxName.Text);
    if cbxName.ItemIndex = -1 then
    begin
      cbxType.ItemIndex := 0;
      btnAdd.Enabled := True;
      btnModify.Enabled := False;
      btnDelete.Enabled := False;
      cbxType.Enabled := True;
      chkReadOnly.Checked := False;
      cbxFormat.ItemIndex := -1;
      btnedExpression.Text := '';
      edtDefaultValue.Text := '';
      cbxFormat.Enabled := False;
      cbxSummary.ItemIndex := -1;
      TempColumn.Name := Trim(cbxName.Text);
      btnAdd.Enabled := Trim(cbxName.Text) <> '';
    end else
    begin
      columnconfig := TbfaColumnConfig(cbxName.Items.Objects[cbxName.ItemIndex]);
      cbxType.ItemIndex := cbxType.Items.IndexOfObject(TObject(columnconfig.ColumnType));
      btnAdd.Enabled := False;
      btnModify.Enabled := True;
      btnDelete.Enabled := True;
      cbxType.Enabled := False;
      chkReadOnly.Checked := columnconfig.ReadOnly;
      cbxFormat.Text := columnconfig.DisplayFormat;
      cbxFormat.Enabled := columnconfig.ColumnType in [cltNumber, cltCurrency];
      btnedExpression.Text := columnconfig.Expression;
      edtDefaultValue.Text := columnconfig.DefaultValue;
      btnList.Enabled := columnconfig.ColumnType = cltList;
      cbxDBType.Enabled := columnconfig.ColumnType = cltDBList;
      cbxDBField.Enabled := columnconfig.ColumnType = cltDBList;
      if columnconfig.ListType = lstAddfieldItems then
        cbxDBType.ItemIndex := 0
      else if columnconfig.ListType = lstAddfieldValues then
        cbxDBType.ItemIndex := 1;
      if columnconfig.ColumnType = cltDBList then
      begin
        LoadAddfieldlist;
        cbxDBField.ItemIndex := cbxDBField.Items.IndexOfObject(TObject(columnconfig.ListAddfield));
      end;
      cbxSummary.ItemIndex := cbxSummary.Items.IndexOfObject(TObject(columnconfig.SummaryType));

      cbxSummary.Enabled := Integer(columnconfig.ColumnType) in [2,3,6,7];

      edtTabName.Text := AddfieldComp.compGrid.Config.Displayname;
    end;
    chkReadOnly.Enabled := not (Trim(btnedExpression.Text) <> '');
  finally
    SkipOnChange := False;
  end;
end;

procedure TfrmGridConfig.cbxNameKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if SkipOnChange then
    Exit;

  cbxNameChange(Sender);
end;

procedure TfrmGridConfig.cbxStampSizeChange(Sender: TObject);
begin
  if SkipOnChange then
    Exit;

  SetModified;
end;

procedure TfrmGridConfig.cbxSummaryChange(Sender: TObject);
var
  columnconfig : TbfaColumnConfig;
  i: Integer;
  gridcolumn: TcxGridColumn;
  footeritems: TcxDataFooterSummaryItems;
  groupitems: TcxDataGroupSummaryItems;
begin
  if SkipOnChange then
    Exit;

  if cbxName.ItemIndex > -1 then
  begin
    columnconfig := TbfaColumnConfig(cbxName.Items.Objects[cbxName.ItemIndex]);
    if columnconfig.SummaryType = TbfaSummaryKind(cbxSummary.Items.Objects[cbxSummary.ItemIndex]) then   // es wurde nichts neu/anderes ausgewhlt?
      Exit;

    columnconfig.SummaryType := TbfaSummaryKind(cbxSummary.Items.Objects[cbxSummary.ItemIndex]);

    if chkShowSums.Checked then
    begin
      gridcolumn := AddfieldComp.compGrid.View.GetColumnByFieldName(columnconfig.Fieldname);
      if columnconfig.SummaryType <> smtNone then
      begin
        with TcxGridTableSummaryItem(AddfieldComp.compGrid.FooterSummaryItems.Add) do
        try
          try
            BeginUpdate;
            Column := TcxGridDBColumn(gridcolumn);
            Kind := TcxSummaryKind(columnconfig.SummaryType);
          finally
            EndUpdate;
          end;
        except
          AddfieldComp.compGrid.FooterSummaryItems.Items[AddfieldComp.compGrid.FooterSummaryItems.Count-1].Free;
        end;
        with TcxGridTableSummaryItem(AddfieldComp.compGrid.GroupSummaryItems.Add) do
        try
          try
            BeginUpdate;
            Column := TcxGridDBColumn(gridcolumn);
            Kind := TcxSummaryKind(columnconfig.SummaryType);
          finally
            EndUpdate;
          end;
        except
          AddfieldComp.compGrid.GroupSummaryItems.Items[AddfieldComp.compGrid.GroupSummaryItems.Count-1].Free;
        end;
      end else
      begin
         footeritems := AddfieldComp.compGrid.FooterSummaryItems;

         for i := footeritems.Count -1 downto 0 do
         begin
          if TcxGridDBColumn(footeritems[i].Field.Item) = gridcolumn then
            footeritems[i].Free
         end;

         groupitems := AddfieldComp.compGrid.GroupSummaryItems;
         for i := groupitems.Count -1 downto 0 do
         begin
          if TcxGridDBColumn(groupitems[i].Field.Item) = gridcolumn then
            groupitems[i].Free
         end;
//         AddfieldComp.compGrid.FooterSummaryItems.Items[gridcolumn.Index].Free;
//         AddfieldComp.compGrid.GroupSummaryItems.Items[gridcolumn.Index].Free;
      end;
    end;

  end else
  begin
    TempColumn.SummaryType := TbfaSummaryKind(cbxSummary.Items.Objects[cbxSummary.ItemIndex]);
  end;

  SetModified;
end;

procedure TfrmGridConfig.cbxTypeChange(Sender: TObject);
begin
  cbxFormat.Enabled := Integer(cbxType.Items.Objects[cbxType.ItemIndex]) in [2, 3, 7];
  cbxSummary.Enabled := Integer(cbxType.Items.Objects[cbxType.ItemIndex]) in [2, 3, 6, 7];
  btnList.Enabled := Integer(cbxType.Items.Objects[cbxType.ItemIndex]) = 4;
  cbxDBType.Enabled := Integer(cbxType.Items.Objects[cbxType.ItemIndex]) = 5;
  cbxDBField.Enabled := Integer(cbxType.Items.Objects[cbxType.ItemIndex]) = 5;

  if cbxName.ItemIndex =  -1 then   // der ColumnType kann nur bei neuen Feldern gendert/definiert werden
  begin                             // bestehende Felder knnen nicht im Type gendert werden
    TempColumn.ColumnType := TbfaColumnType(cbxType.Items.Objects[cbxType.ItemIndex]);
    case TempColumn.ColumnType of
      cltEdit, cltList, cltDBList:
        TempColumn.ValueType := vltString;
      cltDate:
        TempColumn.ValueType := vltDate;
      cltNumber, cltAutoIncrement:
        TempColumn.ValueType := vltInteger;
      cltCurrency:
        TempColumn.ValueType := vltCurrency;
      cltFloat:
        TempColumn.ValueType := vltFloat;
    end;

    // fr ein neues Whrungsfeld bieten wir direkt die Standard  Formatierung an
    // diese wird, wenn keine Formatierung gewhlt ist sowieso eingestellt
    if TempColumn.ColumnType = cltCurrency then
      cbxFormat.ItemIndex := 3;

    if TempColumn.ColumnType = cltDBList then
    begin
      if cbxDBType.ItemIndex = 0 then
        TempColumn.ListType := lstAddfieldItems
      else
        TempColumn.ListType := lstAddfieldValues;
    end;
  end;
end;

procedure TfrmGridConfig.cedtStampColorChange(Sender: TObject);
begin
  if SkipOnChange then
    Exit;

  SetModified;
end;

procedure TfrmGridConfig.chkClick(Sender: TObject);
begin
  if SkipOnChange then
    Exit;
  with AddfieldComp.compGrid do
  begin
    View.OptionsView.Header := chkShowTitle.Checked;
    View.OptionsView.Footer := chkShowSums.Checked;
    View.OptionsView.GroupByBox := chkGroupbyBox.Checked;
    View.OptionsView.Indicator := chkShowIndicator.Checked;
//    PopupStandard.UseBuiltInPopupMenus := chkUsePopups.Checked;
    View.OptionsCustomize.ColumnSorting := chkManualSorting.Checked;
    // wenn wir sortieren wollen, dann mssen wir auch die mglichkeit haben, wieder in die ursprungsreihenfolge zu sortieren.
    // dafr brauchen wir die RecID Spalte
//    if chkAlternateRows.Checked then
//      View.Styles.UseOddEvenStyles := bDefault
//    else
//      View.Styles.UseOddEvenStyles := bFalse;
    View.GetColumnByFieldName('RecID').Visible := chkManualSorting.Checked;

  end;

  SetModified;
end;

procedure TfrmGridConfig.chkReadOnlyClick(Sender: TObject);
var
  columnconfig : TbfaColumnConfig;
begin
  if SkipOnChange then
    Exit;

  if cbxName.ItemIndex > -1 then
  begin
    columnconfig := TbfaColumnConfig(cbxName.Items.Objects[cbxName.ItemIndex]);
    columnconfig.ReadOnly := chkReadOnly.Checked;
  end else
  begin
    TempColumn.ReadOnly := chkReadOnly.Checked;
  end;
  SetModified;
end;

procedure TfrmGridConfig.chkShowTabClick(Sender: TObject);
begin
  if chkShowTab.Checked then
    Gridfield.Options := Gridfield.Options or 16
  else
    Gridfield.Options := Gridfield.Options and not 16;
  edtTabName.Enabled := chkShowTab.Checked;
  SetModified;
end;

procedure TfrmGridConfig.edtDefaultValueChange(Sender: TObject);
var
  columnconfig : TbfaColumnConfig;
begin
  if SkipOnChange then
    Exit;

  if cbxName.ItemIndex > -1 then
  begin
    columnconfig := TbfaColumnConfig(cbxName.Items.Objects[cbxName.ItemIndex]);
    columnconfig.DefaultValue := edtDefaultValue.Text;
  end else
  begin
    TempColumn.DefaultValue := edtDefaultValue.Text;;
  end;

  SetModified;
end;

procedure TfrmGridConfig.edtTabNameChange(Sender: TObject);
begin
  if SkipOnChange then
    Exit;

  SetModified;
end;

procedure TfrmGridConfig.edtTabNameKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  edtTabNameChange(Sender);
end;

procedure TfrmGridConfig.FormCreate(Sender: TObject);
begin
  SkipOnChange := True;
  try
    cbxType.Items.AddObject(_('Eingabe'), TObject(0));
    cbxType.Items.AddObject(_('Datum'), TObject(1));
    cbxType.Items.AddObject(_('Zahl'), TObject(2));
    cbxType.Items.AddObject(_('Whrung'), TObject(3));
    cbxType.Items.AddObject(_('Liste'), TObject(4));
    cbxType.Items.AddObject(_('DB-Liste'), TObject(5));
    cbxType.Items.AddObject(_('AutoInc'), TObject(6));
    cbxType.Items.AddObject(_('Fliekomma'), TObject(7));

    cbxSummary.Items.AddObject(_('Keine'), TObject(0));
    cbxSummary.Items.AddObject(_('Summe'), TObject(1));
    cbxSummary.Items.AddObject(_('Minimum'), TObject(2));
    cbxSummary.Items.AddObject(_('Maximum'), TObject(3));
    cbxSummary.Items.AddObject(_('Anzahl'), TObject(4));
    cbxSummary.Items.AddObject(_('Durchschnitt'), TObject(5));

    cbxStampSize.Items.AddObject('20 %', TObject(20));
    cbxStampSize.Items.AddObject('30 %', TObject(30));
    cbxStampSize.Items.AddObject('40 %', TObject(40));
    cbxStampSize.Items.AddObject('50 %', TObject(50));
    cbxStampSize.Items.AddObject('75 %', TObject(75));
    cbxStampSize.Items.AddObject('100 %', TObject(100));
    cbxStampSize.Items.AddObject('125 %', TObject(125));
    cbxStampSize.Items.AddObject('150 %', TObject(150));
    cbxStampSize.ItemIndex := 2;

    InitialConfig := TbfaGridConfig.Create;
    TempColumn := TbfaColumnConfig.Create;
    frmPopInfo := TfrmSVNInfo.Create(Self);

    frmPopInfo.lstSVN.Clear;
    frmPopInfo.Width := 350;
    frmPopInfo.Height := 320;
    frmPopInfo.lstSVN.WordWrap := True;
    //02.09.2024 -->
    (*
    frmPopInfo.lstSVN.Text := ParseMsgCRLF(_('Unter Expression knnen Funktionen hinterlegt werden,\n' +
      'um in dieser Spalte Ergebnisse anzeigen zu lassen,\ndie sich aus anderen Spalten berechnen lassen.\n' +
      'Neben den grundlegenden arithmetischen Funktionen stehen auch Funktionen zur Verfgung, die hnlich der Excel-Funktionen sind.\n' +
      'Ein andere Spalte wird referenziert in dem man den Spaltetitel in eckige Klammern setzt.\n' +
      'Beispiele:\n' +
      '[Preis] * [Anzahl]\n' +
      '[Einnahmen] - [Ausgaben]\n' +
      '[Betrag] * 0.19\n' +
      'Es sind auch Bedingungen mglich, zB. die Berechnung eines Prozentsatzes abhngig von einem Prozentwert ' +
      'aus einem Listenfeld Mwst mit den Werten "19 %" und "7 %":\n' +
      '[Preis] * [Anzahl] * IF([Mwst] = "19 %"; 0,19; 0,07)\n' +
      'Bedingungen schachtelt man in dem im ELSE Zweig des IF Ausdrucks ein weiterer IF Ausdruck eingefgt wird:\n' +
      'IF([Auswahl] = "Eins"; 1; IF([Auswahl] = "Zwei"; 2; 3))\n' +
      '(wenn die Auswahl Eins ist dann gebe 1 zurck, ansonsten wenn die Auswahl Zwei ist gebe 2 zurck, ansonsten 3)'));*)
    frmPopInfo.lstSVN.Text := GetExpressionsCaption;
    //02.09.2024 <--

    frmpopExpression.PopupForm := frmPopInfo;
    TranslateComponent(Self, 'ViewerV36');
    TranslateComponent(frmPopInfo, 'ViewerV36');
  finally
    SkipOnChange := False;
  end;
end;

function TfrmGridConfig.GetExpressionsCaption: string;
begin
  Result := ParseMsgCRLF(_('Unter Expression knnen Funktionen hinterlegt werden,\n' +
      'um in dieser Spalte Ergebnisse anzeigen zu lassen,\ndie sich aus anderen Spalten berechnen lassen.\n' +
      'Neben den grundlegenden arithmetischen Funktionen stehen auch Funktionen zur Verfgung, die hnlich der Excel-Funktionen sind.\n' +
      'Ein andere Spalte wird referenziert in dem man den Spaltetitel in eckige Klammern setzt.\n' +
      'Beispiele:\n' +
      '[Preis] * [Anzahl]\n' +
      '[Einnahmen] - [Ausgaben]\n' +
      '[Betrag] * 0.19\n' +
      'Es sind auch Bedingungen mglich, zB. die Berechnung eines Prozentsatzes abhngig von einem Prozentwert ' +
      'aus einem Listenfeld Mwst mit den Werten "19 %" und "7 %":\n' +
      '[Preis] * [Anzahl] * IF([Mwst] = "19 %"; 0,19; 0,07)\n' +
      'Bedingungen schachtelt man in dem im ELSE Zweig des IF Ausdrucks ein weiterer IF Ausdruck eingefgt wird:\n' +
      'IF([Auswahl] = "Eins"; 1; IF([Auswahl] = "Zwei"; 2; 3))\n' +
      '(wenn die Auswahl Eins ist dann gebe 1 zurck, ansonsten wenn die Auswahl Zwei ist gebe 2 zurck, ansonsten 3)'));
end;

procedure TfrmGridConfig.FormShow(Sender: TObject);
var
  i, tempid : Integer;
  color, tempname: string;
begin
  Modified := False;   // beim ffnen Modified zurcksetzen
  cbxName.Clear;
  new_addid := 0;
  tempid := 0;
  FreeAndNil(InitialConfig);
  InitialConfig := TbfaGridConfig.Create;
  InitialConfig.Clone(AddfieldComp.compGrid.Config);
  InitOptions := Gridfield.Options;

  FreeAndNil(TempColumn);
  TempColumn := TbfaColumnConfig.Create;
//
//  AddfieldComp.btnGridAdd.Visible := False;
//  AddfieldComp.btnGridDelete.Visible := False;
//  AddfieldComp.btnGridStamp.Visible := False;
//  AddfieldComp.btnGridExport.Visible := False;
//  AddfieldComp.btnGridConfig.Visible := False;

  AddfieldComp.btnGridAdd.Enabled := False;
  AddfieldComp.btnGridDelete.Enabled := False;
  AddfieldComp.btnGridStamp.Enabled := False;
  AddfieldComp.btnGridExport.Enabled := False;
  AddfieldComp.btnGridConfig.Enabled := False;

  for i := 0 to AddfieldComp.compGrid.Config.Columns.Count -1 do
  begin
    cbxName.AddItem(AddfieldComp.compGrid.Config.Columns[i].Name, AddfieldComp.compGrid.Config.Columns[i]);
    tempname := AddfieldComp.compGrid.Config.Columns[i].Fieldname;
    if LeftStr(tempname, 4) = 'new_' then
    begin
      tempid := StrToInt(Rightstr(tempname, length(tempname) -4));
      if tempid >= new_addid then
        new_addid := tempid +1;
    end;
  end;
  if cbxName.Items.Count > 0 then
    cbxName.ItemIndex := 0;
  cbxNameChange(Sender);
  chkShowTitle.Checked := AddfieldComp.compGrid.Config.ShowHeader;
  chkShowSums.Checked := AddfieldComp.compGrid.Config.ShowSummary;
  chkGroupbyBox.Checked := AddfieldComp.compGrid.Config.ShowGroupbybox;
  chkShowIndicator.Checked := AddfieldComp.compGrid.Config.ShowIndicator;
  chkUsePopups.Checked := AddfieldComp.compGrid.Config.UsePopups;
  chkManualSorting.Checked := AddfieldComp.compGrid.Config.ManualSorting;
//  chkAlternateRows.Checked := AddfieldComp.compGrid.Config.AlternateRows;
  chkMultiSelect.Checked := AddfieldComp.compGrid.Config.MultiSelect;
  chkUseColumnsNames.Checked := AddfieldComp.compGrid.Config.UseColumnNames;
  chkExportAddfields.Checked := AddfieldComp.compGrid.Config.ExportAddfields;
  chkExportUnicode.Checked := AddfieldComp.compGrid.Config.ExportUnicode;
  chkShowTab.Checked := (Gridfield.Options and 16) = 16;
  edtTabName.Enabled := (Gridfield.Options and 16) = 16;

  chkStampTransparent.Checked := AddfieldComp.compGrid.Config.Stamp_Transparent;
  cbxStampSize.ItemIndex := cbxStampSize.Items.IndexOfObject(TObject(AddfieldComp.compGrid.Config.Stamp_Size));

  cedtStampColor.Text := AddfieldComp.compGrid.Config.Stamp_Color;
  color := StringReplace(AddfieldComp.compGrid.Config.Stamp_Color, '#','', [rfReplaceAll]);
  color := '$00' + copy(color,5,2) + copy(color,3,2) + copy(color,1,2);
  cedtStampColor.SelectedColor := StrToInt(color);
  cedtStampColor.OnChange := cedtStampColorChange;
  AddfieldComp.cbxGridSearchField.Properties.OnChange := GridSearchOnChange;

  LoadAddfieldlist;
  SetModified;
  AddfieldComp.compGrid.Grid.Enabled := True;
  AddfieldComp.compGrid.View.OnColumnPosChanged := GridColumnPosChanged;
  AddfieldComp.compGrid.View.OnColumnSizeChanged := GridColumnSizeChanged;
  AddfieldComp.compGrid.View.OnColumnHeaderClick := GridColumnHeaderClick;
end;

procedure TfrmGridConfig.GridColumnHeaderClick(Sender: TcxGridTableView; AColumn: TcxGridColumn);
begin
  if SkipOnChange then
    Exit;

  cbxName.ItemIndex := cbxName.Items.IndexOf(AColumn.Caption);
  cbxNameChange(Sender);
end;

procedure TfrmGridConfig.GridColumnPosChanged(Sender: TcxGridTableView; AColumn: TcxGridColumn);
begin
  SetModified;
end;

procedure TfrmGridConfig.GridColumnSizeChanged(Sender: TcxGridTableView; AColumn: TcxGridColumn);
var
  i: Integer;
  columnconfig: TbfaColumnConfig;
begin
  for i := 0 to cbxName.Items.Count -1 do     // hier sind die aktuellen Configs hinterlegt
  begin
    columnconfig := TbfaColumnConfig(cbxName.Items.Objects[i]);
    if columnconfig.Name = AColumn.Caption then  // Feld gefunden? vergleichen
    begin
      columnconfig.ColWidth := AColumn.Width;
    end;
  end;
  SetModified;
end;

procedure TfrmGridConfig.GridSearchOnChange(Sender: TObject);
begin
  SetModified;
end;

procedure TfrmGridConfig.LoadAddfieldlist;
var
  i: Integer;
begin
  cbxDBField.Items.Clear;
  if cbxDBType.ItemIndex = 0 then
  begin
    for i := 0 to Addfields.Count -1 do
    begin
      if Addfields[i].Typ in [2, 3, 11] then    // Auswahlfelder, Mehrfach, DLM Auswahl
        cbxDBField.Items.AddObject(Addfields[i].DisplayName + '   ['+Addfields[i].Name+']', TObject(Addfields[i].ID));
    end;
  end else
  begin
    for i := 0 to Addfields.Count -1 do
    begin
      cbxDBField.Items.AddObject(Addfields[i].DisplayName + '   ['+Addfields[i].Name+']', TObject(Addfields[i].ID));
    end;
  end;
end;

procedure TfrmGridConfig.Retranslate;
begin
  ReTranslateComponent(Self, 'ViewerV36');
  if Assigned(frmPopInfo) then
    frmPopInfo.lstSVN.Text := GetExpressionsCaption;
end;

procedure TfrmGridConfig.SetModified;
var
  changes : Boolean;
  i, j : Integer;
  columnconfig, initialcolumn : TbfaColumnConfig;
  currentconfig: TbfaGridConfig;
begin
  changes := False;

  changes := chkShowTitle.Checked <> InitialConfig.ShowHeader;
  changes := (chkShowSums.Checked <> InitialConfig.ShowSummary) or changes;
  changes := (chkGroupbyBox.Checked <> InitialConfig.ShowGroupbybox) or changes;
  changes := (chkShowIndicator.Checked <> InitialConfig.ShowIndicator) or changes;
  changes := (chkUsePopups.Checked <> InitialConfig.UsePopups) or changes;
  changes := (chkManualSorting.Checked <> InitialConfig.ManualSorting) or changes;
//  changes := (chkAlternateRows.Checked <> InitialConfig.AlternateRows) or changes;
  changes := (chkMultiSelect.Checked <> InitialConfig.MultiSelect) or changes;
  changes := (chkUseColumnsNames.Checked <> InitialConfig.UseColumnNames) or changes;
  changes := (chkExportAddfields.Checked <> InitialConfig.ExportAddfields) or changes;
  changes := (chkExportUnicode.Checked <> InitialConfig.ExportUnicode) or changes;
  changes := (chkStampTransparent.Checked <> InitialConfig.Stamp_Transparent) or changes;
  changes := (edtTabName.Text <> InitialConfig.Displayname) or changes;
  if cbxStampSize.ItemIndex > -1 then
    changes := (Integer(cbxStampSize.Items.Objects[cbxStampSize.ItemIndex]) <> InitialConfig.Stamp_Size) or changes;
  changes := (cedtStampColor.Text <> InitialConfig.Stamp_Color) or changes;
  changes := (Gridfield.Options <> InitOptions) or changes;
  if AddfieldComp.cbxGridSearchField.ItemIndex > -1 then
    changes := (TbfaString(AddfieldComp.cbxGridSearchField.Items.Objects[AddfieldComp.cbxGridSearchField.ItemIndex]).Value <> InitialConfig.Searchfield) or changes;

  // Columns.Count mssen wir um eins erhhen, da ein Grid immer die generische RecID Spalte hat (die nicht in der Config ist)
  changes := (InitialConfig.Columns.Count +1 <> AddfieldComp.compGrid.View.ColumnCount) or changes;

  // wir prfen, ob sich die Reihenfolge gendert hat
  j := 0;
  for i := 0 to InitialConfig.Columns.Count -1 do
  begin
    if j = AddfieldComp.compGrid.View.ColumnCount then
      Break;
    if changes then
      Break;

    if (AddfieldComp.compGrid.View.Columns[j].Name = 'RecID') or
       (LeftStr(AddfieldComp.compGrid.View.Columns[j].Name, 4) = 'del_') then
      inc(j);   // RecID Spalte oder gelschte SPlaten berspringen

    if i < AddfieldComp.compGrid.View.ColumnCount then
    begin
      changes := (InitialConfig.Columns[i].Name <> AddfieldComp.compGrid.View.Columns[j].Caption) or changes;
//      changes := (InitialConfig.Columns[i].Expression <> AddfieldComp.compGrid.View.Columns[j].DataBinding.Expression) or changes;
    end;
    inc(j);

  end;

  // wir prfen, ob die Felder selbst sich gendert haben
  for i := 0 to InitialConfig.Columns.Count -1 do
  begin
    if changes then
      break;
    for j := 0 to cbxName.Items.Count -1 do     // hier sind die aktuellen Configs hinterlegt
    begin
      columnconfig := TbfaColumnConfig(cbxName.Items.Objects[j]);
      if columnconfig.Name = InitialConfig.Columns[i].Name then  // Feld gefunden? vergleichen
      begin
        initialcolumn := InitialConfig.Columns[i];
        changes := (columnconfig.ReadOnly <> initialcolumn.ReadOnly) or changes;
        changes := (columnconfig.DisplayFormat <> initialcolumn.DisplayFormat) or changes;
        changes := (columnconfig.Expression <> initialcolumn.Expression) or changes;
        changes := (columnconfig.ListType <> initialcolumn.ListType) or changes;
        changes := (columnconfig.ListAddfield <> initialcolumn.ListAddfield) or changes;
        changes := (columnconfig.ListItems.DelimitedText <> initialcolumn.ListItems.DelimitedText) or changes;
        changes := (columnconfig.SummaryType <> initialcolumn.SummaryType) or changes;
        changes := (columnconfig.DefaultValue <> initialcolumn.DefaultValue) or changes;
        changes := (columnconfig.ColWidth <> initialcolumn.ColWidth) or changes;
        Break;
      end;
    end;
  end;

  Modified := changes;
  btnOk.Enabled := changes;
end;

end.
