unit OptionsForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SpTBXTabs, TB2Item, SpTBXItem, SpTBXControls, TB2Dock, TB2Toolbar,
  ActnList, StdCtrls, bfaApplication, ComCtrls, ieview, imageenview, ievect,
  hyieutils, iemview, ExtDlgs, JvExComCtrls, JvHotKey, cxGraphics, cxControls,
  cxLookAndFeels, cxLookAndFeelPainters, cxContainer, cxEdit, cxTextEdit,
  cxMaskEdit, cxDropDownEdit, cxImageComboBox, cxClasses, Buttons,
  CreateResubFrame, SpTBXEditors, System.Actions, bfaImageEnVect{, bfaImageEnMView}
  ;

type
  TfrmOptions = class(TForm)
    SpTBXPanel1: TSpTBXPanel;
    tcOptions: TSpTBXTabControl;
    tabItemGeneral: TSpTBXTabItem;
    tabGeneral: TSpTBXTabSheet;
    tabItemSearch: TSpTBXTabItem;
    tabSearch: TSpTBXTabSheet;
    tabItemScanProfile: TSpTBXTabItem;
    tabScanProfile: TSpTBXTabSheet;
    btnCancel: TSpTBXButton;
    btnApply: TSpTBXButton;
    btnOK: TSpTBXButton;
    tbScanProfiles: TSpTBXToolbar;
    tbiSeparatorItem1: TTBSeparatorItem;
    tbiSeparatorItem2: TTBSeparatorItem;
    tbiNewScanProfile: TSpTBXItem;
    tbiDeleteScanProfile: TSpTBXItem;
    tbiImportScanProfile: TSpTBXItem;
    tbiExportScanProfile: TSpTBXItem;
    actNewProfile: TAction;
    actDeleteProfile: TAction;
    actExportProfiles: TAction;
    actImportProfiles: TAction;
    lblScanProfile: TSpTBXLabel;
    gbxScanProperties: TSpTBXGroupBox;
    cbxScannerName: TSpTBXComboBox;
    lblScanner: TSpTBXLabel;
    cbxColorMode: TSpTBXComboBox;
    cbxCompression: TSpTBXComboBox;
    cbxDPI: TSpTBXComboBox;
    lblDetection: TSpTBXLabel;
    lblCompression: TSpTBXLabel;
    lblDPI: TSpTBXLabel;
    rgpScanBy: TSpTBXRadioGroup;
    grbBrightness: TSpTBXGroupBox;
    lblBrightness: TSpTBXLabel;
    edtBrightness: TSpTBXSpinEdit;
    trbBrightness: TSpTBXTrackBar;
    grbContrast: TSpTBXGroupBox;
    grbThreshold: TSpTBXGroupBox;
    lblContrast: TSpTBXLabel;
    trbContrast: TSpTBXTrackBar;
    edtContrast: TSpTBXSpinEdit;
    lblThreshold: TSpTBXLabel;
    edtThreshold: TSpTBXSpinEdit;
    trbThreshold: TSpTBXTrackBar;
    grbDefaultScanOptions: TSpTBXGroupBox;
    chkADF: TSpTBXCheckBox;
    chkDuplex: TSpTBXCheckBox;
    chkStacked: TSpTBXCheckBox;
    chkInvers: TSpTBXCheckBox;
    chkDeletePage: TSpTBXCheckBox;
    edtDeletePages: TSpTBXSpinEdit;
    lblDeletePages: TSpTBXLabel;
    chkIgnoreTWAINError: TSpTBXCheckBox;
    lblPaperForm: TSpTBXLabel;
    cbxFormat: TSpTBXComboBox;
    lblPaperOrientation: TSpTBXLabel;
    cbxOrientation: TSpTBXComboBox;
    lblTransfer: TSpTBXLabel;
    cbxTransfer: TSpTBXComboBox;
    actModifyOptions: TAction;
    actEnableModifyOptions: TAction;
    aclOptionsForm: TActionList;
    rgpProfilType: TSpTBXRadioGroup;
    chkDefaultProfile: TSpTBXCheckBox;
    grbFrame: TSpTBXGroupBox;
    chkSetFrame: TSpTBXCheckBox;
    lblFrameBegin: TSpTBXLabel;
    lblFrameBeginX: TSpTBXLabel;
    lblFrameBeginXmm: TSpTBXLabel;
    edtFrameLeft: TSpTBXEdit;
    lblFrameBeginY: TSpTBXLabel;
    edtFrameTop: TSpTBXEdit;
    lblFrameBeginYmm: TSpTBXLabel;
    lblFrameEnd: TSpTBXLabel;
    lblFrameEndX: TSpTBXLabel;
    lblFrameEndXmm: TSpTBXLabel;
    edtFrameRight: TSpTBXEdit;
    lblFrameEndY: TSpTBXLabel;
    edtFrameBottom: TSpTBXEdit;
    lblFrameEndYmm: TSpTBXLabel;
    grbFilter: TSpTBXGroupBox;
    lblFilter: TSpTBXLabel;
    cbxFilter: TSpTBXComboBox;
    dlgSaveFile: TSaveTextFileDialog;
    tabItemEditor: TSpTBXTabItem;
    tabEditor: TSpTBXTabSheet;
    grpThumbnails: TSpTBXGroupBox;
    chkViewerThumnail: TSpTBXCheckBox;
    chkImporterThumbnail: TSpTBXCheckBox;
    chkWorkplaceThumbnail: TSpTBXCheckBox;
    grbSave: TSpTBXGroupBox;
    lblDefaultSavePath: TSpTBXLabel;
    edtDefaultSaveDirectory: TSpTBXButtonEdit;
    grbPrint: TSpTBXGroupBox;
    lblDefaultPrinter: TSpTBXLabel;
    cbxDocumentPrinter: TSpTBXComboBox;
    chkUseWindowsDefaultPrinter: TSpTBXCheckBox;
    grbView: TSpTBXGroupBox;
    chkShowLinkCount: TSpTBXCheckBox;
    grbLogin: TSpTBXGroupBox;
    chkMsLogon: TSpTBXCheckBox;
    chkNoLoginWindow: TSpTBXCheckBox;
    chkAutoPreview: TSpTBXCheckBox;
    grpOCR: TSpTBXGroupBox;
    chkOCRClip: TSpTBXCheckBox;
    chkOCRAdd: TSpTBXCheckBox;
    lblOcrHotkey: TSpTBXLabel;
    edtHotKeyOcr: TJvHotKey;
    grpZoom: TSpTBXGroupBox;
    lblAutoZoom: TSpTBXLabel;
    cbxAutoZoom: TSpTBXComboBox;
    chkInvertDirection: TSpTBXCheckBox;
    grbGeneralSettings: TSpTBXGroupBox;
    chkSyncTimeBitfarm: TSpTBXCheckBox;
    cbxTimeServer: TSpTBXComboBox;
    chkShowDocLinkList: TSpTBXCheckBox;
    grbSearch: TSpTBXGroupBox;
    lblMaxSearchResults: TSpTBXLabel;
    cbxLimit: TSpTBXComboBox;
    chkAutoDisplay: TSpTBXCheckBox;
    chkDocLinkList: TSpTBXCheckBox;
    chkDontResetOnArcSet: TSpTBXCheckBox;
    grbGeneralSearch: TSpTBXGroupBox;
    grbGeneralSearchOptions: TSpTBXGroupBox;
    chkFieldSearch: TSpTBXCheckBox;
    chkAnnoTxtSearch: TSpTBXCheckBox;
    chkDoctagsSearch: TSpTBXCheckBox;
    chkFulltextSearch: TSpTBXCheckBox;
    chkUseOnlyGeneralSearch: TSpTBXCheckBox;
    lblMaxHistoryBookmarks: TSpTBXLabel;
    cbxHistoryBookmarksLimit: TSpTBXComboBox;
    grpDblClickDocument: TSpTBXGroupBox;
    chkDblClickFloating: TSpTBXCheckBox;
    cbxScanProfile: TcxImageComboBox;
    chkCompatibleMode: TSpTBXCheckBox;
    chkDocEditorZoom: TSpTBXCheckBox;
    chkAlertWindow: TSpTBXCheckBox;
    grbEmail: TSpTBXGroupBox;
    chkOLEOutlook: TSpTBXCheckBox;
    chkMailTo: TSpTBXCheckBox;
    chkDocLinkListInTab: TSpTBXCheckBox;
    chkAutoViewerAtArchiveChange: TSpTBXCheckBox;
    rbnOpenDoc: TSpTBXRadioButton;
    rbnAutoEditMode: TSpTBXRadioButton;
    grpDblClickImporter: TSpTBXGroupBox;
    chkImporterDblClickFloating: TSpTBXCheckBox;
    rbnImporterOpenDoc: TSpTBXRadioButton;
    rbnImporterOpenDocInImporter: TSpTBXRadioButton;
    grpDblClickWorkplace: TSpTBXGroupBox;
    chkWorkplaceDblClickFloating: TSpTBXCheckBox;
    rbnWorkplaceOpenDoc: TSpTBXRadioButton;
    rbnWorkplaceOpenDocInWorkplace: TSpTBXRadioButton;
    tabItemResub: TSpTBXTabItem;
    tabResub: TSpTBXTabSheet;
    grbResubOptions: TSpTBXGroupBox;
    chkResubOnStartup: TSpTBXCheckBox;
    chkResubTimer: TSpTBXCheckBox;
    cbbTimerInterval: TSpTBXComboBox;
    lblMinutesRefresh: TSpTBXLabel;
    chkReturnToSender: TSpTBXCheckBox;
    chkEmailReminder: TSpTBXCheckBox;
    grbDefaultResubCols: TSpTBXGroupBox;
    chkColumnTitle: TSpTBXCheckBox;
    chkColumnInfo: TSpTBXCheckBox;
    chkColumnComment: TSpTBXCheckBox;
    chkColumnAlarm: TSpTBXCheckBox;
    chkColumnModified: TSpTBXCheckBox;
    grbResubFavorites: TSpTBXGroupBox;
    cbbName: TSpTBXComboBox;
    btnNewResub: TSpTBXButton;
    btnDeleteResub: TSpTBXButton;
    SpTBXPanel2: TSpTBXPanel;
    chkShowAllAddfieldsResub: TSpTBXCheckBox;
    tabItemAdmin: TSpTBXTabItem;
    tabAdmin: TSpTBXTabSheet;
    grpbxAdminOptions: TSpTBXGroupBox;
    chkDefaultArchiveGroup: TSpTBXCheckBox;
    chkDefaultAddfieldGroup: TSpTBXCheckBox;
    chkDefaultStatefieldGroup: TSpTBXCheckBox;
    cbxDefaultArchiveGroupRights: TSpTBXComboBox;
    cbxDefaultAddfieldGroupRights: TSpTBXComboBox;
    cbxDefaultStatefieldGroupRights: TSpTBXComboBox;
    tabItemHotSearch: TSpTBXTabItem;
    tabHotSearch: TSpTBXTabSheet;
    grbHotkeys: TSpTBXGroupBox;
    btnHotSearchNew: TSpTBXButton;
    btnHotSearchDelete: TSpTBXButton;
    lblStore: TSpTBXLabel;
    lblArchive: TSpTBXLabel;
    lblHotkey: TSpTBXLabel;
    chkScreenshot: TSpTBXCheckBox;
    chkDocLink: TSpTBXCheckBox;
    cbbHotkeyStore: TSpTBXComboBox;
    cbbHotkeyArchive: TSpTBXComboBox;
    edtHotKey: TJvHotKey;
    lblHotsearchProfile: TSpTBXLabel;
    cbbProfil: TSpTBXComboBox;
    chkSetAnnoDPI: TSpTBXCheckBox;
    tabItemImporter: TSpTBXTabItem;
    tabImporter: TSpTBXTabSheet;
    grbImporterSettings: TSpTBXGroupBox;
    chkResetAfterArchive: TSpTBXCheckBox;
    chkPrintAfterArchive: TSpTBXCheckBox;
    chkNoOCR: TSpTBXCheckBox;
    chkQuickArchive: TSpTBXCheckBox;
    edtFilter: TSpTBXEdit;
    lblImporterFilter: TSpTBXLabel;
    chkNegativeCurrencyRed: TSpTBXCheckBox;
    chkDragDropAsWindows: TSpTBXCheckBox;
    chkShowAllAddfields: TSpTBXCheckBox;
    chkAdminFullscreen: TSpTBXCheckBox;
    chkSearchLastYear: TSpTBXCheckBox;
    dlgOpenFile: TOpenTextFileDialog;
    chkSQLFullText: TSpTBXCheckBox;
    chkNotifyByMail: TSpTBXCheckBox;
    chkUseFileNameAsDocName: TSpTBXCheckBox;
    lblContrastMin: TSpTBXLabel;
    lblContrastMax: TSpTBXLabel;
    lblBrightnessMin: TSpTBXLabel;
    lblBrightnessMax: TSpTBXLabel;
    lblThresholdMin: TSpTBXLabel;
    lblThresholdMax: TSpTBXLabel;
    chkComboAutoDown: TSpTBXCheckBox;
    chkImportColor: TSpTBXCheckBox;
    chkImportHighRes: TSpTBXCheckBox;
    chkImportBarcode: TSpTBXCheckBox;
    chkResubFavsInPreview: TSpTBXCheckBox;
    chkExportPDF: TSpTBXCheckBox;
    chkOverwriteLocalSave: TSpTBXCheckBox;
    chkRowColorEvenOdd: TSpTBXCheckBox;
    chkCalculateonSelectedRecords: TSpTBXCheckBox;
    rbnDblClickNoAction: TSpTBXRadioButton;
    chkWorkplaceAutoEdit: TSpTBXCheckBox;
    lblStartingArea: TSpTBXLabel;
    cbxStartingArea: TSpTBXComboBox;
    chkHintBallons: TSpTBXCheckBox;
    SpTBXGroupBox1: TSpTBXGroupBox;
    chkRememberLastTool: TSpTBXCheckBox;
    lblName: TSpTBXLabel;
    edtName: TSpTBXEdit;
    cbbHotkey: TcxComboBox;
    chkGDocIDSearch: TSpTBXCheckBox;
    chkColumnDocDate: TSpTBXCheckBox;
    chkDocModified: TSpTBXCheckBox;
    lblApiType: TSpTBXLabel;
    grpbxLogging: TSpTBXGroupBox;
    SpTBXLabel1: TSpTBXLabel;
    cbxLogLevel: TSpTBXComboBox;
    chkFtxPos: TSpTBXCheckBox;
    chkAutoCheckOut: TSpTBXCheckBox;
    chkAutoCheckin: TSpTBXCheckBox;
    chkCheckoutNewDocuments: TSpTBXCheckBox;
    chkDisplayCheckoutAtShutdown: TSpTBXCheckBox;

    procedure actNewProfileExecute(Sender: TObject);
    procedure actDeleteProfileExecute(Sender: TObject);
    procedure actSaveProfileExecute(Sender: TObject);
    procedure actExportProfilesExecute(Sender: TObject);
    procedure actImportProfilesExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure actApplyExecute(Sender: TObject);
    procedure cbxScanProfile_2Change(Sender: TObject);
    procedure edtScannerNameChange(Sender: TObject);
    procedure cbxColorModeChange(Sender: TObject);
    procedure edtBrightnessChange(Sender: TObject);
    procedure edtContrastChange(Sender: TObject);
    procedure edtThresholdChange(Sender: TObject);
    procedure trbBrightnessChange(Sender: TObject);
    procedure trbContrastChange(Sender: TObject);
    procedure trbThresholdChange(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure actModifyOptionsExecute(Sender: TObject);
    procedure cbxScannerNameChange(Sender: TObject);
    procedure actEnableModifyOptionsExecute(Sender: TObject);
    procedure cbxCompressionChange(Sender: TObject);
    procedure cbxDPIChange(Sender: TObject);
    procedure cbxFormatChange(Sender: TObject);
    procedure cbxOrientationChange(Sender: TObject);
    procedure cbxPixelFlavorChange(Sender: TObject);
    procedure cbxTransferChange(Sender: TObject);
    procedure chkADFClick(Sender: TObject);
    procedure chkDuplexClick(Sender: TObject);
    procedure chkStackedClick(Sender: TObject);
    procedure chkInversClick(Sender: TObject);
    procedure chkDeletePageClick(Sender: TObject);
    procedure edtDeletePagesClick(Sender: TObject);
    procedure chkIgnoreTWAINErrorClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure chkDefaultProfileClick(Sender: TObject);
    procedure rgpProfilTypeClick(Sender: TObject);
    procedure rgpScanByClick(Sender: TObject);
    procedure cbxFilterChange(Sender: TObject);
    procedure chkSetFrameClick(Sender: TObject);
    procedure edtFrameLeftChange(Sender: TObject);
    procedure edtFrameTopChange(Sender: TObject);
    procedure edtFrameRightChange(Sender: TObject);
    procedure edtFrameBottomChange(Sender: TObject);
    procedure edtDefaultSaveDirectorySubEditButton0Click(Sender: TObject);
    procedure chkViewerThumnailClick(Sender: TObject);
    procedure chkImporterThumbnailClick(Sender: TObject);
    procedure chkWorkplaceThumbnailClick(Sender: TObject);
    procedure chkInvertDirectionClick(Sender: TObject);
    procedure edtDefaultSaveDirectoryChange(Sender: TObject);
    procedure cbxDocumentPrinterChange(Sender: TObject);
    procedure chkUseWindowsDefaultPrinterClick(Sender: TObject);
    procedure chkShowLinkCountClick(Sender: TObject);
    procedure chkAutoPreviewClick(Sender: TObject);
    procedure chkNoLoginWindowClick(Sender: TObject);
    procedure chkMsLogonClick(Sender: TObject);
    procedure chkSyncTimeBitfarmClick(Sender: TObject);
    procedure cbxTimeServerChange(Sender: TObject);
    procedure cbxTimeServerSelect(Sender: TObject);
    procedure chkAutoDisplayClick(Sender: TObject);
    procedure chkDocLinkListClick(Sender: TObject);
    procedure cbxLimitChange(Sender: TObject);
    procedure chkDontResetOnArcSetClick(Sender: TObject);
    procedure chkFulltextSearchClick(Sender: TObject);
    procedure chkDocTagsSearchClick(Sender: TObject);
    procedure chkDoctagSearchClick(Sender: TObject);
    procedure chkFileTypeSearchClick(Sender: TObject);
    procedure chkAnnoTxtSearchClick(Sender: TObject);
    procedure chkGroupSearchClick(Sender: TObject);
    procedure chkFieldSearchClick(Sender: TObject);
    procedure chkRefnameSearchClick(Sender: TObject);
    procedure chkUseOnlyGeneralSearchClick(Sender: TObject);
    procedure cbxHistoryBookmarksLimitChange(Sender: TObject);
    procedure chkDblClickFloatingClick(Sender: TObject);
    procedure cbxScanProfilePropertiesChange(Sender: TObject);
    procedure chkCompatibleModeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure chkAutoEditModeClick(Sender: TObject);
    procedure chkDocEditorZoomClick(Sender: TObject);
    procedure chkAlertWindowClick(Sender: TObject);
    procedure chkExportPDFClick(Sender: TObject);
    procedure chkOLEOutlookClick(Sender: TObject);
    procedure chkMailToClick(Sender: TObject);
    procedure chkShowDocLinkListClick(Sender: TObject);
    procedure chkDocLinkListInTabClick(Sender: TObject);
    procedure chkAutoViewerAtArchiveChangeClick(Sender: TObject);
    procedure btnResetAllOptionsClick(Sender: TObject);
    procedure rbnImporterOpenDocClick(Sender: TObject);
    procedure rbnWorkplaceOpenDocClick(Sender: TObject);
    procedure chkImporterDblClickFloatingClick(Sender: TObject);
    procedure chkWorkplaceDblClickFloatingClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure chkResubOnStartupClick(Sender: TObject);
    procedure chkResubTimerClick(Sender: TObject);
    procedure chkReturnToSenderClick(Sender: TObject);
    procedure chkEmailReminderClick(Sender: TObject);
    procedure chkShowAllAddfieldsResubClick(Sender: TObject);
    procedure chkShowAllAddfieldsClick(Sender: TObject);

    procedure chkColumnTitleClick(Sender: TObject);
    procedure chkColumnInfoClick(Sender: TObject);
    procedure chkColumnCommentClick(Sender: TObject);
    procedure chkColumnAlarmClick(Sender: TObject);
    procedure chkColumnModifiedClick(Sender: TObject);
    procedure cbbTimerIntervalChange(Sender: TObject);
    procedure cbbNameChange(Sender: TObject);
    procedure OnResubModified;
    procedure btnNewResubClick(Sender: TObject);
    procedure btnDeleteResubClick(Sender: TObject);
    procedure chkDefaultArchiveGroupClick(Sender: TObject);
    procedure chkDefaultAddfieldGroupClick(Sender: TObject);
    procedure chkDefaultStatefieldGroupClick(Sender: TObject);
    procedure chkDefaultResubStatefieldClick(Sender: TObject);
    procedure cbxDefaultArchiveGroupRightsChange(Sender: TObject);
    procedure cbxDefaultAddfieldGroupRightsChange(Sender: TObject);
    procedure cbxDefaultStatefieldGroupRightsChange(Sender: TObject);
    procedure btnHotSearchNewClick(Sender: TObject);
    procedure cbbHotKeyChange(Sender: TObject);
    procedure cbbHotkeyStoreChange(Sender: TObject);
    procedure cbbHotkeyArchiveChange(Sender: TObject);
    procedure edtHotKeyChange(Sender: TObject);
    procedure chkScreenshotClick(Sender: TObject);
    procedure chkDocLinkClick(Sender: TObject);
    procedure btnHotSearchDeleteClick(Sender: TObject);
    procedure cbbProfilChange(Sender: TObject);
    procedure chkSetAnnoDPIClick(Sender: TObject);
    procedure chkPrintAfterArchiveClick(Sender: TObject);
    procedure chkResetAfterArchiveClick(Sender: TObject);
    procedure chkNoOCRClick(Sender: TObject);
    procedure chkQuickArchiveClick(Sender: TObject);
    procedure edtFilterChange(Sender: TObject);
// SJ 24.11.2020 - ChangePageByEnter entfernt
//    procedure chkChangePageClick(Sender: TObject);
    procedure cbxAutoZoomChange(Sender: TObject);
    procedure chkOCRClipClick(Sender: TObject);
    procedure chkOCRAddClick(Sender: TObject);
    procedure edtHotKeyOcrChange(Sender: TObject);
    procedure chkDragDropAsWindowsClick(Sender: TObject);
    procedure chkAdminFullscreenClick(Sender: TObject);
    procedure chkSearchLastYearClick(Sender: TObject);
    procedure chkSQLFullTextClick(Sender: TObject);
    procedure chkNotifyByMailClick(Sender: TObject);
    procedure chkUseFileNameAsDocNameClick(Sender: TObject);
    procedure chkComboAutoDownClick(Sender: TObject);
    procedure chkImportColorClick(Sender: TObject);
    procedure chkImportHighResClick(Sender: TObject);
    procedure chkImportBarcodeClick(Sender: TObject);
    procedure chkResubFavsInPreviewClick(Sender: TObject);
    procedure chkOverwriteLocalSaveClick(Sender: TObject);
    procedure chkRowColorEvenOddClick(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure chkCalculateonSelectedRecordsClick(Sender: TObject);
    procedure chkWorkplaceAutoEditClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure OptionsFormDropDown(Sender: TObject);
    procedure OptionsFormCloseUp(Sender: TObject);
    procedure cbxStartingAreaChange(Sender: TObject);
    procedure chkNegativeCurrencyRedClick(Sender: TObject);
    procedure chkHintBallonsClick(Sender: TObject);
    procedure chkRememberLastToolClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure edtNameChange(Sender: TObject);
    procedure chkGDocIDSearchClick(Sender: TObject);
    procedure chkColumnDocDateClick(Sender: TObject);
    procedure chkDocModifiedClick(Sender: TObject);
    procedure edtDefaultSaveDirectoryKeyPress(Sender: TObject; var Key: Char);
    procedure cbxHistoryBookmarksLimitKeyPress(Sender: TObject; var Key: Char);
    procedure edtFilterKeyPress(Sender: TObject; var Key: Char);
    procedure cbxFilterKeyPress(Sender: TObject; var Key: Char);
    procedure cbxDefaultArchiveGroupRightsKeyPress(Sender: TObject;
      var Key: Char);
    procedure cbbHotkeyKeyPress(Sender: TObject; var Key: Char);
    procedure cbxScannerNameKeyPress(Sender: TObject; var Key: Char);
    procedure cbxLogLevelChange(Sender: TObject);
    procedure chkFtxPosClick(Sender: TObject);
    procedure chkAutoCheckOutClick(Sender: TObject);
    procedure chkAutoCheckinClick(Sender: TObject);
    procedure chkCheckoutNewDocumentsClick(Sender: TObject);
    procedure chkDisplayCheckoutAtShutdownClick(Sender: TObject);

  private
    { Private declarations }
    FScanProfileChange, FHotKeyChange, FDropDownOpen, FRunningTimeSync: Boolean;
    FMStream: TMemoryStream;
    RoleList, FieldRights: TStringList;
    procedure FillScannerCombo;
    procedure FillCompressionCombo;
    procedure SetEditorTab;
    procedure ResetEditorTab;
    procedure SetScanTab;
    procedure ResetScanTab;
    procedure ResetHotkeyTab;
    procedure SetImporterTab;
    procedure ResetImporterTab;
    procedure SetOneGeneralSearchOption(Active: TSpTBXCheckBox);
    procedure SetHotSearchCheckboxes;
    {$IFDEF ImageEN1140}
    procedure SetMouseWheelSettings;
    function SetScannerApiLabel: Integer;
    {$ENDIF}
  protected
    FModifyOptionsResult: Integer;
    FShow: Boolean;
    procedure SetHotkeyTab; virtual;
    procedure SetSearchTab; virtual;
    procedure ResetSearchTab; virtual;
    procedure SetGeneralTab; virtual;
    procedure ResetGeneralTab; virtual;
    procedure SetResubTab; virtual;
    procedure ResetResubTab; virtual;
    procedure SetAdminTab; virtual;
    procedure ResetAdminTab; virtual;

  public
    { Public declarations }
    fraCreateResub: TfraCreateResub;
    imgPreView : TbfaImageEnVect;
    DefaultProfilChanged: Boolean;
    procedure FillCombosWithObjects;
    procedure InitRoleList; //17.09.2024
    procedure InitFieldRights; //17.09.2024
  end;

implementation

{$R *.dfm}

uses
  bfaLog, bfaCommonUtils, bfaCommonFiles, bfaCommonDialogs, bfaOptions, imageenio, gnugettext, bfaCommonImageEN, IniFiles,
  ProfileForm, VCL.Printers, strUtils, ShellAPI, MainDataModule,
  SpTBXSkins, Generics.Collections, bfaCommonDB, bfaBaseObjects, bfaObjects36, bfaCommonStyles,
  Menus, MainForm, bfaImageENMView
  {$IFDEF IMAGEEN1140}
  , hyiedefs, iexAcquire, ietwain
  {$ENDIF}
  , bfaCommonMethods;

procedure TfrmOptions.edtBrightnessChange(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].Brightness := StrToFloat(edtBrightness.Text);
      actEnableModifyOptions.Execute;
    end;
    trbBrightness.Position := StrToInt(edtBrightness.Text);
  except
    trbBrightness.Position := 0;
  end;
end;

procedure TfrmOptions.edtContrastChange(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].Contrast := StrToFloat(edtContrast.Text);
      actEnableModifyOptions.Execute;
    end;
    trbContrast.Position := StrToInt(edtContrast.Text);
  except
    trbContrast.Position := 0;
  end;
end;

procedure TfrmOptions.edtDefaultSaveDirectoryChange(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.DefaultSaveDirectory := edtDefaultSaveDirectory.Text;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'edtDefaultSaveDirectoryChange', ClassName);
  end;
end;

procedure TfrmOptions.edtDefaultSaveDirectoryKeyPress(Sender: TObject;
  var Key: Char);
begin
  DisableBeep(Key); //11.03.2024 bfacrm:ticket__show__38134
end;

procedure TfrmOptions.edtDefaultSaveDirectorySubEditButton0Click(Sender: TObject);
begin
  try
    Self.FDropDownOpen := True;
    with TFileOpenDialog.Create(nil) do
    try
      Title := _('Bitte whlen Sie ein Verzeichnis');
      Options := [fdoPickFolders];
      if Execute then
        edtDefaultSaveDirectory.Text := FileName;
    finally
      Self.FDropDownOpen := False;
      Free;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'edtDefaultSaveDirectorySubEditButton0Click', ClassName);
  end;
end;

procedure TfrmOptions.edtDeletePagesClick(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].DeletePageKB := StrToInt(edtDeletePages.Text);
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'edtDeletePageClick', ClassName);
  end;
end;

procedure TfrmOptions.edtFilterChange(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.ImportFilter :=  edtFilter.Text;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'edtFilterChange', ClassName);
  end;
end;

procedure TfrmOptions.edtFilterKeyPress(Sender: TObject; var Key: Char);
begin
  DisableBeep(Key); //11.03.2024 bfacrm:ticket__show__38134
end;

procedure TfrmOptions.edtFrameBottomChange(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].FrameBottom := StrToFloat(edtFrameBottom.Text);
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'edtFrameBottomChange', ClassName);
  end;
end;

procedure TfrmOptions.edtFrameLeftChange(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].FrameLeft := StrToFloat(edtFrameLeft.Text);
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'edtFrameLeftChange', ClassName);
  end;
end;

procedure TfrmOptions.edtFrameRightChange(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].FrameRight := StrToFloat(edtFrameRight.Text);
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'edtFrameRightChange', ClassName);
  end;
end;

procedure TfrmOptions.edtFrameTopChange(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].FrameTop := StrToFloat(edtFrameTop.Text);
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'edtFrameTopChange', ClassName);
  end;
end;

procedure TfrmOptions.edtHotKeyChange(Sender: TObject);
var
  i : Integer;
  found : Boolean;
begin
  try
    bitfarmLog.Write(llNormal, ltDebug, 'edtHotKeyChange', ClassName);
    if not FHotKeyChange then
    begin
      bitfarmLog.Write(llNormal, ltDebug, 'edtHotKeyChange - not FHotKeyChange', ClassName);
      if not FShow then
      begin
        bitfarmLog.Write(llNormal, ltDebug, 'edtHotKeyChange - not FShow', ClassName);
        i := Low(aHotKeys);
        found := false;
        while ((not found) and (i <= High(aHotKeys))) do
        begin
          bitfarmLog.Write(llNormal, ltDebug, 'edtHotKeyChange - aHotKeys['+i.ToString+'].HotKey = ' + aHotKeys[i].HotKey.ToString, ClassName);
          if (i <> cbbHotkey.ItemIndex) and (aHotKeys[i].HotKey = edtHotKey.HotKey) then
            found := True;
          inc(i);
        end;
        if (not found) or (edtHotKey.HotKey = 0) then
        begin
          aHotKeys[cbbHotkey.ItemIndex].HotKey := edtHotKey.HotKey;
          bitfarmLog.Write(llNormal, ltDebug, 'edtHotKeyChange - aHotKeys['+i.ToString+'].HotKey = ' + aHotKeys[i].HotKey.ToString, ClassName);
        end else
        begin
          BfMessageDlg(_('Dieser Hotkey wird bereits verwendet.') +
                 #13 + _('Bitte whlen Sie einen anderen.'), mtError, [mbOK]);
          aHotKeys[cbbHotkey.ItemIndex].HotKey := 0;
          edtHotKey.HotKey := 0;
        end;
        aHotKeys[cbbHotkey.ItemIndex].Modified := True;
        actEnableModifyOptions.Execute;
      end;
    end;
  except

  end;
end;

procedure TfrmOptions.edtHotKeyOcrChange(Sender: TObject);
var
  i: Integer;
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.EditorOptions.OCRKey := edtHotKeyOcr.HotKey;

//03.05.2017
//      for i := 0 to bitfarmApp.PreviewContainer.Containers.Count - 1 do
//      begin
//        bitfarmApp.PreviewContainer.Containers[i].Preview.tbi_rangeocr.ShortCut :=
//          bitfarmApp.ViewerOptions.EditorOptions.OCRKey;
//      end;

      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'edtHotKeyOcrChange', ClassName);
  end;
end;

procedure TfrmOptions.edtNameChange(Sender: TObject);
begin
  try
    bitfarmLog.Write(llNormal, ltDebug, 'edtNameChange', ClassName);
    if (not FShow) and (not FHotKeyChange) then
    begin
      if cbbHotkey.ItemIndex <> -1 then
        aHotKeys[cbbHotkey.ItemIndex].Name := Trim(TSpTBXEdit(Sender).Text);

      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'edtNameChange', ClassName);
  end;
end;

procedure TfrmOptions.edtScannerNameChange(Sender: TObject);
begin
  actEnableModifyOptions.Execute;
end;

procedure TfrmOptions.edtThresholdChange(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].Threshold := StrToFloat(edtThreshold.Text);
      actEnableModifyOptions.Execute;
    end;
    trbThreshold.Position := StrToInt(edtThreshold.Text);
  except
    trbThreshold.Position := 0;
  end;
end;

procedure TfrmOptions.FormClose(Sender: TObject; var Action: TCloseAction);
var
  hd: HWND;
begin
  try
    hd := FindWindow('bitfarm.hotsearch.V36', nil);
    if hd <> 0 then
      PostMessage(hd, WM_HOTKEY_ENABLE_DISABLE, 1, 0);
  except
    bitfarmLog.Write(llNormal, ltException, 'FormClose - WM_HOTKEY_ENABLE_DISABLE', ClassName);
  end;
end;

procedure TfrmOptions.FormCreate(Sender: TObject);
begin
  FMStream := TMemoryStream.Create;
  fraCreateResub := TfraCreateResub.Create(Self);
  fraCreateResub.Parent := SpTBXPanel2;
//26.10.2020 Ticket 24863  fraCreateResub.Align := alClient;
  fraCreateResub.dtDate1.Date := Date();
  fraCreateResub.dtDate1.Enabled := False;
  fraCreateResub.btnOk.Enabled := False;
  fraCreateResub.btnCancel.Enabled := False;
  fraCreateResub.btnOk.Visible := False;
  fraCreateResub.btnCancel.Visible := False;
  fraCreateResub.cbbFavIcon.Visible := True;
  fraCreateResub.OnModified := OnResubModified;
  fraCreateResub.Color := Self.Color;
  fraCreateResub.SpTBXPanel1.Color := Self.Color;

  fraCreateResub.dtDate1.Visible := False;
  fraCreateResub.Bezeichnung4.Visible := False;
  fraCreateResub.lblDateInDays.Visible := True;
  fraCreateResub.edtAdditionalDays.Visible := True;
  fraCreateResub.edtAdditionalDays.Text := '0';
  fraCreateResub.edtAdditionalDays.Enabled := True;

  imgPreView := TbfaImageEnVect.Create(Self);
  imgPreView.Parent := gbxScanProperties;
  imgPreView.Top := 50;
  imgPreView.Left := 507;
  imgPreView.Height := 150;
  imgPreView.Width := 300;
  imgPreView.BackgroundStyle := iebsCropShadow;
  imgPreView.Background := Self.Color;
  imgPreView.Visible:= False;

  RoleList := TStringlist.Create;
  InitRoleList;

  FieldRights := TStringlist.Create;
  InitFieldRights;

  // Reihenfolge in der Combobox enspricht nicht dem Itemindex -> Rckwrtskompatiblitt
  FillCombosWithObjects;

  Font.Size := bfaFontSize; //10.09.2020
  tbiNewScanProfile.ImageIndex := Integer(icoidx_scan_profile_create);
  tbiDeleteScanProfile.ImageIndex := Integer(icoidx_scan_profile_remove);
  tbiExportScanProfile.ImageIndex := Integer(icoidx_scan_profile_export);
  tbiImportScanProfile.ImageIndex := Integer(icoidx_scan_profile_import);

  chkScreenshot.Caption := _('Bereichs OCR') + ' / ' + _('Screenshot-Tool'); // dann muss nicht extra ein neuer Eintrag in die bersetzung

  if bitfarmApp.User.IsAdmin then
    cbxStartingArea.Items.Add(_('Administration'));

  cbbHotkey.Style.StyleController := ctlGeneral;
  TranslateComponent(Self, sSysGnuViewerDomain);
  TranslateComponent(actNewProfile, sSysGnuViewerDomain);
  TranslateComponent(actDeleteProfile, sSysGnuViewerDomain);
  TranslateComponent(actExportProfiles, sSysGnuViewerDomain);
  TranslateComponent(actImportProfiles, sSysGnuViewerDomain);
  TranslateComponent(actModifyOptions, sSysGnuViewerDomain);
  TranslateComponent(actEnableModifyOptions, sSysGnuViewerDomain);

  TranslateComponent(tbiNewScanProfile, sSysGnuViewerDomain);
  TranslateComponent(tbiDeleteScanProfile, sSysGnuViewerDomain);
  TranslateComponent(tbiImportScanProfile, sSysGnuViewerDomain);
  TranslateComponent(tbiExportScanProfile, sSysGnuViewerDomain);
  TranslateComponent(tbiDeleteScanProfile, sSysGnuViewerDomain);
  TranslateComponent(tbiDeleteScanProfile, sSysGnuViewerDomain);
end;

//17.09.2024 -->
procedure TfrmOptions.InitRoleList;
var
  i: integer;
begin
  for i:=0 to RoleList.Count -1 do
    TbfaInt(RoleList.Objects[i]).Free;

  RoleList.Clear;  // Wichtig!
  RoleList.AddObject(_('Recherche'), TbfaInt64.Create(rRoleSearch));
  RoleList.AddObject(_('Importer'), TbfaInt64.Create(rRoleImport));
  RoleList.AddObject(_('Standard'), TbfaInt64.Create(rRoleStandard));
  RoleList.AddObject(_('Erweitert'), TbfaInt64.Create(rRolePower));
  RoleList.AddObject(_('Admin'), TbfaInt64.Create(rRoleAdmin));
end;

procedure TfrmOptions.InitFieldRights;
var
  i: integer;
begin
  for i:=0 to FieldRights.Count -1 do
    TbfaInt(FieldRights.Objects[i]).Free;

  FieldRights.Clear;  // Wichtig!
  FieldRights.AddObject(_('Lesen'), TbfaInt.Create(1));
  FieldRights.AddObject(_('Schreiben'), TbfaInt.Create(2));
  FieldRights.AddObject(_('ndern'), TbfaInt.Create(4));
end;
//17.09.2024 <--

procedure TfrmOptions.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FMStream);
  FreeAndNil(RoleList);
  FreeAndNil(FieldRights);
end;

procedure TfrmOptions.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  Msg: TMsg;
begin
  if (Key = VK_ESCAPE) and (not FDropDownOpen) and (not fraCreateResub.OpenPopup) then
  begin
    btnCancel.Click;
    PeekMessage(Msg, 0, WM_CHAR, WM_CHAR, PM_REMOVE); // SJ 24.01.2020 - gegen PLING-Ton
  end;
end;

procedure TfrmOptions.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  NewTabIndex, i: Integer;
begin
  if ((ssCtrl in Shift) and (Key = Ord('S'))) and (btnApply.Enabled) then
    btnApply.Click;
  if (Key = VK_TAB) and (ssCtrl in Shift) then
  begin
    tcOptions.Toolbar.BeginUpdate;
    i := 0;
    if (tcOptions.ActiveTabIndex = tcOptions.Items.Count-1) then  
      NewTabIndex := 0
    else
      NewTabIndex := tcOptions.ActiveTabIndex + 1;
      
    while (not tcOptions.Items[NewTabIndex].Visible) and (i < tcOptions.Items.Count - 1) do
    begin
      NewTabIndex := NewTabIndex + 1;
      i := i + 1;
    end;
    
    if (i = tcOptions.Items.Count) then           
      NewTabIndex := 0;
      
    tcOptions.ActiveTabIndex := NewTabIndex;
    tcOptions.Toolbar.EndUpdate;
  end;

end;

procedure TfrmOptions.FormResize(Sender: TObject);
begin
  try
    if (imgPreView <> nil) and (imgPreView.IO.Params.ImageIndex <> -1) then
      imgPreView.Fit;
  except

  end;
end;

procedure TfrmOptions.SetGeneralTab;
begin
  try
    ResetGeneralTab;

    cbxDocumentPrinter.Items := Printer.Printers;

    edtDefaultSaveDirectory.Text := bitfarmApp.ViewerOptions.GeneralOptions.DefaultSaveDirectory;
    cbxDocumentPrinter.ItemIndex := bitfarmApp.ViewerOptions.GeneralOptions.DefaultPrinter;
    chkUseWindowsDefaultPrinter.Checked := bitfarmApp.ViewerOptions.GeneralOptions.UseDefaultPrinter;
    chkOverwriteLocalSave.Checked := bitfarmApp.ViewerOptions.GeneralOptions.OverwriteLocalSave;
    chkRowColorEvenOdd.Checked := bitfarmApp.ViewerOptions.GeneralOptions.RowColorEvenOdd;
    chkShowLinkCount.Checked := bitfarmApp.ViewerOptions.GeneralOptions.ShowLinkCount;
    chkAutoPreview.Checked := bitfarmApp.ViewerOptions.GeneralOptions.AutoPreview;
    chkNoLoginWindow.Checked := bitfarmApp.ViewerOptions.GeneralOptions.NoLoginWindow;
    chkMsLogon.Checked := bitfarmApp.ViewerOptions.GeneralOptions.MsLogon;
    chkSyncTimeBitfarm.Checked := bitfarmApp.ViewerOptions.GeneralOptions.TimeSync;
    cbxTimeServer.Text := bitfarmApp.ViewerOptions.GeneralOptions.TimeSyncServer;
    chkAlertWindow.Checked := bitfarmApp.ViewerOptions.GeneralOptions.AlertWindow;
    chkExportPDF.Checked := bitfarmApp.ViewerOptions.GeneralOptions.ExportPDF;
    chkOLEOutlook.Checked := bitfarmApp.ViewerOptions.GeneralOptions.OleOutlook;
    chkMailTo.Checked := bitfarmApp.ViewerOptions.GeneralOptions.MailTo;
    chkShowDocLinkList.Checked := bitfarmApp.ViewerOptions.GeneralOptions.ShowDocLinks;
    chkComboAutoDown.Checked := bitfarmApp.ViewerOptions.GeneralOptions.ComboAutoDown;

    chkDocLinkListInTab.Enabled := bitfarmApp.ViewerOptions.GeneralOptions.ShowDocLinks;
    chkDocLinkListInTab.Checked := bitfarmApp.ViewerOptions.GeneralOptions.ShowDocLinksInTab;
    chkDragDropAsWindows.Checked := bitfarmApp.ViewerOptions.GeneralOptions.DragDropAsWindows;
    chkSetAnnoDPI.Checked := bitfarmApp.ViewerOptions.GeneralOptions.SetAnnoDPI;
    chkSetAnnoDPI.Enabled := not bitfarmApp.SetAnnoDPIFromCon; //06.11.2017 Ticket 12362
    chkUseFileNameAsDocName.Checked := bitfarmApp.ViewerOptions.GeneralOptions.UseFileNameAsDocName;
    chkUseFileNameAsDocName.Enabled := not bitfarmApp.UseFileNameAsDocNameFromCon; //20.11.2017 Ticket 12450

    chkAutoViewerAtArchiveChange.Checked := bitfarmApp.ViewerOptions.GeneralOptions.AutoViewerAtArchiveChange;
// SJ 24.11.2020 - ChangePageByEnter entfernt
//    chkChangePage.Checked := bitfarmApp.ViewerOptions.GeneralOptions.ChangePageByEnter;
    chkCalculateonSelectedRecords.Checked := bitfarmApp.ViewerOptions.GeneralOptions.CalculateOnSelectedRecordsOnly;
    cbxStartingArea.ItemIndex := bitfarmApp.ViewerOptions.GeneralOptions.StartingArea;
    chkNegativeCurrencyRed.Checked := bitfarmApp.ViewerOptions.GeneralOptions.NegativeCurrency;
    chkHintBallons.Checked := bitfarmApp.ViewerOptions.GeneralOptions.HintBallons;
    chkFtxPos.Checked := bitfarmApp.ViewerOptions.SearchOptions.FtxPos;

  except
    bitfarmLog.Write(llNormal, ltException, 'SetGeneralTab', ClassName);
  end;
end;

procedure TfrmOptions.SetAdminTab;
begin
  ResetAdminTab;

  chkDefaultArchiveGroup.Checked := bitfarmApp.ViewerOptions.AdminOptions.DefaultArchiveGroup;
  chkDefaultAddfieldGroup.Checked := bitfarmApp.ViewerOptions.AdminOptions.DefaultAddfieldGroup;
  chkDefaultStatefieldGroup.Checked := bitfarmApp.ViewerOptions.AdminOptions.DefaultStatefieldGroup;
  chkAdminFullscreen.Checked := bitfarmApp.ViewerOptions.AdminOptions.AdminFullscreen;
  cbxLogLevel.ItemIndex := bitfarmApp.ViewerOptions.AdminOptions.LogLevel; //22.03.2024

  cbxDefaultArchiveGroupRights.ItemIndex := IndexOfTbfaInt(RoleList, bitfarmApp.ViewerOptions.AdminOptions.DefaultArchiveGroupRights);
  cbxDefaultAddfieldGroupRights.ItemIndex := IndexOfTbfaInt(FieldRights, bitfarmApp.ViewerOptions.AdminOptions.DefaultAddfieldGroupRights);
  cbxDefaultStatefieldGroupRights.ItemIndex := IndexOfTbfaInt(FieldRights, bitfarmApp.ViewerOptions.AdminOptions.DefaultStatefieldGroupRights);

end;

procedure TfrmOptions.SetEditorTab;
begin
  try
    ResetEditorTab;

    chkViewerThumnail.Checked := bitfarmApp.ViewerOptions.EditorOptions.ShowViewerThumbnail;
    chkImporterThumbnail.Checked := bitfarmApp.ViewerOptions.EditorOptions.ShowImporterThumbnail;
    chkWorkplaceThumbnail.Checked := bitfarmApp.ViewerOptions.EditorOptions.ShowWorkplaceThumbnail;
    chkInvertDirection.Checked := bitfarmApp.ViewerOptions.EditorOptions.InvertDirection;
    chkDocEditorZoom.Checked := bitfarmApp.ViewerOptions.EditorOptions.DocEditorZoom;
    chkDblClickFloating.Checked := bitfarmApp.ViewerOptions.EditorOptions.InUnDockedPanel;
    rbnDblClickNoAction.Checked := bitfarmApp.ViewerOptions.EditorOptions.DocNoAction;
    rbnAutoEditMode.Checked := bitfarmApp.ViewerOptions.EditorOptions.AutoEditMode;
    rbnOpenDoc.Checked := (not rbnAutoEditMode.Checked) and (not rbnDblClickNoAction.Checked);
    chkImporterDblClickFloating.Checked :=
      bitfarmApp.ViewerOptions.EditorOptions.ImporterInUnDockedPanel;
    rbnImporterOpenDoc.Checked :=
      not bitfarmApp.ViewerOptions.EditorOptions.ImporterOpenDocInImporter;
    rbnImporterOpenDocInImporter.Checked := not rbnImporterOpenDoc.Checked;
    chkWorkplaceDblClickFloating.Checked :=
      bitfarmApp.ViewerOptions.EditorOptions.WorkplaceInUnDockedPanel;

    // 11.10.2019  Ticket 20763
    rbnWorkplaceOpenDoc.Checked := bitfarmApp.ViewerOptions.EditorOptions.WorkplaceOpenDoc;
    rbnWorkplaceOpenDocInWorkplace.Checked := bitfarmApp.ViewerOptions.EditorOptions.WorkplaceOpenDocInWorkplace;
    chkWorkplaceAutoEdit.Checked := bitfarmApp.ViewerOptions.EditorOptions.WorkplaceAutoEditMode;

//    chkDblClickFloating.Enabled := not bitfarmApp.ViewerOptions.EditorOptions.AutoEditMode;
//    chkImporterDblClickFloating.Enabled := not bitfarmApp.ViewerOptions.EditorOptions.ImporterOpenDocInImporter;
//    chkWorkplaceDblClickFloating.Enabled := bitfarmApp.ViewerOptions.EditorOptions.WorkplaceOpenDoc;

//    rbnWorkplaceOpenDoc.Checked :=
//      not bitfarmApp.ViewerOptions.EditorOptions.WorkplaceOpenDocInWorkplace;
//    rbnWorkplaceAutoEdit.Checked := bitfarmApp.ViewerOptions.EditorOptions.WorkplaceAutoEditMode;
//    rbnWorkplaceOpenDocInWorkplace.Checked :=
//      (not rbnWorkplaceOpenDoc.Checked) and (not rbnWorkplaceAutoEdit.Checked);

    //cbxAutoZoom.ItemIndex := bitfarmApp.ViewerOptions.EditorOptions.AutoZoom;
    cbxAutoZoom.ItemIndex := cbxAutoZoom.Items.IndexOfObject(TObject(bitfarmApp.ViewerOptions.EditorOptions.AutoZoom));
    chkOCRClip.Checked := bitfarmApp.ViewerOptions.EditorOptions.OCRAutoClipbrd;
    chkOCRAdd.Checked := bitfarmApp.ViewerOptions.EditorOptions.OCRAdd;
    edtHotKeyOcr.HotKey := bitfarmApp.ViewerOptions.EditorOptions.OCRKey;
    chkRememberLastTool.Checked := bitfarmApp.ViewerOptions.EditorOptions.RememberLastTool;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetEditorTab', ClassName);
  end;
end;

procedure TfrmOptions.SetSearchTab;
begin
  try
    ResetSearchTab;

    if bitfarmApp.ViewerOptions.SearchOptions.Limit = -1 then
      cbxLimit.ItemIndex := cbxLimit.Items.IndexOf(_('Alle'))
    else
      cbxLimit.ItemIndex := cbxLimit.Items.IndexOf(IntToStr(bitfarmApp.ViewerOptions.SearchOptions.Limit));

    cbxHistoryBookmarksLimit.Text := IntToStr(bitfarmApp.ViewerOptions.SearchOptions.HistoryBookmarkLimit);
    chkAutoDisplay.Checked := bitfarmApp.ViewerOptions.SearchOptions.AutoDisplay;
    chkSearchLastYear.Checked := bitfarmApp.ViewerOptions.SearchOptions.SearchLastYear;
    chkSQLFullText.Checked := bitfarmApp.ViewerOptions.SearchOptions.SQLFullText;
    chkDocLinkList.Checked := bitfarmApp.ViewerOptions.SearchOptions.ShowDocLinks;
    chkDontResetOnArcSet.Checked := bitfarmApp.ViewerOptions.SearchOptions.DontResetOnArcSet;
    chkDocModified.Checked := bitfarmApp.ViewerOptions.SearchOptions.DocModified;

    chkFulltextSearch.Checked := bitfarmApp.ViewerOptions.SearchOptions.FulltextSearch;
    chkDocTagsSearch.Checked := bitfarmApp.ViewerOptions.SearchOptions.DoctagsSearch;
    chkAnnoTxtSearch.Checked := bitfarmApp.ViewerOptions.SearchOptions.AnnoTxtSearch;
    chkFieldSearch.Checked := bitfarmApp.ViewerOptions.SearchOptions.FieldTxtSearch;
//    chkFileTypeSearch.Checked := bitfarmApp.ViewerOptions.SearchOptions.FileTypeSearch;
//    chkUserSearch.Checked := bitfarmApp.ViewerOptions.SearchOptions.UserSearch;
//    chkGroupSearch.Checked := bitfarmApp.ViewerOptions.SearchOptions.GroupSearch;
//    chkDocnameSearch.Checked := bitfarmApp.ViewerOptions.SearchOptions.DocNameSearch;
//    chkRefnameSearch.Checked := bitfarmApp.ViewerOptions.SearchOptions.RefnameSearch;
    chkUseOnlyGeneralSearch.Checked := bitfarmApp.ViewerOptions.SearchOptions.UseOnlyGeneralSearchField;
    chkShowAllAddfields.Checked := bitfarmApp.ViewerOptions.SearchOptions.ShowAllAddfields;
    chkFtxPos.Checked := bitfarmApp.ViewerOptions.SearchOptions.FtxPos;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetSearchTab', ClassName);
  end;
end;

procedure TfrmOptions.chkColumnDocDateClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.ResubOptions.ColumnDocDate := chkColumnDocDate.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkColumnDocDateClick', ClassName);
  end;
end;

procedure TfrmOptions.chkGDocIDSearchClick(Sender: TObject);
begin
  if not FHotKeyChange then
  begin
    if not FShow then
    begin
      if (cbbHotkey.ItemIndex <> -1) and (Length(aHotKeys) > 0) then
      begin
        aHotKeys[cbbHotkey.ItemIndex].GDocIDSearch := chkGDocIDSearch.Checked;
        aHotKeys[cbbHotkey.ItemIndex].Modified := True;
        SetHotSearchCheckboxes;
        actEnableModifyOptions.Execute;
      end;
    end;
  end;
end;

procedure TfrmOptions.SetHotkeyTab;
var
  i: Integer;
  sFiles: TStrings;
  sFileName: WideString;
begin
  try
    ResetHotkeyTab;
// bitfarmLog.Write(llDebug, ltDebug, '00', ClassName);

    for i := Low(aHotKeys) to High(aHotKeys) do
    begin
      if aHotKeys[i].State = 0 then
        cbbHotkey.Properties.Items.Add(aHotKeys[i].Name);
    end;
// bitfarmLog.Write(llDebug, ltDebug, '01', ClassName);
// bitfarmLog.Write(llDebug, ltDebug, '01 - Low(aSysArc)' + Low(aSysArc).ToString, ClassName);
// bitfarmLog.Write(llDebug, ltDebug, '01 - High(aSysArc)' + High(aSysArc).ToString, ClassName);

    for i := Low(aSysArc) to High(aSysArc) do
    begin
    // entweder haben wir Rechte, oder wir haben Childs mit Rechten
    // Archive knnen wir hier ignorieren, da diese durch cbbHotkeyStoreChange gesetzt werden
// bitfarmLog.Write(llDebug, ltDebug, '01 - ' + i.ToString, ClassName);
// bitfarmLog.Write(llDebug, ltDebug, 'aSysArc[i].Name:' + aSysArc[i].Name, ClassName);
// bitfarmLog.Write(llDebug, ltDebug, 'aSysArc[i].Typ:' + aSysArc[i].Typ.ToString, ClassName);
// bitfarmLog.Write(llDebug, ltDebug, 'aSysArc[i].Rights:' + aSysArc[i].Rights.ToString, ClassName);
// bitfarmLog.Write(llDebug, ltDebug, 'rRoleSearch:' + rRoleSearch.ToString, ClassName);
//
      if (aSysArc[i].Name <> '') and (aSysArc[i].Typ = 0) and (
          ((aSysArc[i].Rights and rightList) = rightList) or
          frmMainForm.FViewerTreeview.HasChildren(i, rRoleSearch)
         )
      then
        cbbHotkeyStore.Items.AddObject(aSysArc[i].Name, TObject(i));
// bitfarmLog.Write(llDebug, ltDebug, '01_1 - ' + i.ToString, ClassName);
    end;
// bitfarmLog.Write(llDebug, ltDebug, '02', ClassName);

    sFiles := TStringList.Create;
    try
      FindAllFiles(sFiles, BD.ExeDir, '*.con', False);
      for i := 0 to (sFiles.Count - 1) do
      begin
        sFileName := ExtractFileName(sFiles[i]);
        sFiles[i] := copy(sFileName, 1, (Length(sFileName) - 4));
      end;
      if sFiles.Count > 0 then
        cbbProfil.Items := sFiles;
    finally
      FreeAndNil(sFiles);
    end;
// bitfarmLog.Write(llDebug, ltDebug, '03', ClassName);

    cbbProfil.ItemIndex := cbbProfil.Items.IndexOf(aHotKeyProfil);
    // HS will lieber den Standard-HotKey, anstelle von -1
    cbbHotkey.ItemIndex := 0;
// bitfarmLog.Write(llDebug, ltDebug, '04', ClassName);
  except
    bitfarmLog.Write(llNormal, ltException, 'SetHotkeyTab', ClassName);
  end;
end;

procedure TfrmOptions.SetHotSearchCheckboxes;
begin
  chkGDocIDSearch.Enabled := (not chkDocLink.Checked);
  chkDocLink.Enabled := (not chkGDocIDSearch.Checked);

  cbbHotkeyStore.Enabled := (not chkGDocIDSearch.Checked) and (not chkDocLink.Checked);
  if not cbbHotkeyStore.Enabled then
    cbbHotkeyStore.ItemIndex := -1;

  cbbHotkeyArchive.Enabled := (not chkGDocIDSearch.Checked) and (not chkDocLink.Checked);
  if not cbbHotkeyArchive.Enabled then
    cbbHotkeyArchive.ItemIndex := -1;
end;

procedure TfrmOptions.SetImporterTab;
begin
  bitfarmLog.DebugBegin(llDebug, 'SetImporterTab', ClassName);
   try
      try
        ResetImporterTab;

        chkPrintAfterArchive.Checked := bitfarmApp.ViewerOptions.GeneralOptions.PrintAfterArchiving;
        chkResetAfterArchive.Checked := bitfarmApp.ViewerOptions.GeneralOptions.ResetFieldsAfterArchiving;
        chkNoOCR.Checked := bitfarmApp.ViewerOptions.GeneralOptions.NoOCR;
        chkQuickArchive.Checked := bitfarmApp.ViewerOptions.GeneralOptions.LateOCR;
        edtFilter.Text := bitfarmApp.ViewerOptions.GeneralOptions.ImportFilter;
        chkImportColor.Checked := bitfarmApp.ViewerOptions.GeneralOptions.ImportColor;
        chkImportHighRes.Checked := bitfarmApp.ViewerOptions.GeneralOptions.ImportHighRes;
        chkImportBarcode.Checked := bitfarmApp.ViewerOptions.GeneralOptions.ImportBarcode;
      except
          on e: exception do
            bitfarmLog.Write(llNormal, ltException, 'SetImporterTab' + e.Message, ClassName);
      end;
   finally
      bitfarmLog.DebugEnd(llDebug, 'SetImporterTab', ClassName);
   end;
end;

{$IFDEF ImageEN1140}
procedure TfrmOptions.SetMouseWheelSettings;
var
  i: Integer;
begin
  try
    for I := 0 to bitfarmApp.PreviewContainer.Containers.Count - 1 do
    begin
      if bitfarmApp.ViewerOptions.EditorOptions.DocEditorZoom then
      begin
        bitfarmApp.PreviewContainer.Containers[i].Preview.SingleView.img_DocView.MouseWheelParams.Action := iemwVScroll;
        bitfarmApp.PreviewContainer.Containers[i].Preview.SingleView.img_DocView.MouseWheelParams.InvertDirection := False;
        bitfarmApp.PreviewContainer.Containers[i].Preview.SingleView.img_DocView.MouseWheelParamsAlt.Action := iemwZoom;
        bitfarmApp.PreviewContainer.Containers[i].Preview.SingleView.img_DocView.MouseWheelParamsAlt.InvertDirection := not bitfarmApp.ViewerOptions.EditorOptions.InvertDirection;
      end else
      begin
        bitfarmApp.PreviewContainer.Containers[i].Preview.SingleView.img_DocView.MouseWheelParams.Action := iemwZoom;
        bitfarmApp.PreviewContainer.Containers[i].Preview.SingleView.img_DocView.MouseWheelParams.InvertDirection := not bitfarmApp.ViewerOptions.EditorOptions.InvertDirection;
        bitfarmApp.PreviewContainer.Containers[i].Preview.SingleView.img_DocView.MouseWheelParamsAlt.InvertDirection := False;
        bitfarmApp.PreviewContainer.Containers[i].Preview.SingleView.img_DocView.MouseWheelParamsAlt.Action := iemwVScroll;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetMouseWheelSettings', ClassName);
  end;
end;
{$ENDIF}

procedure TfrmOptions.btnHotSearchNewClick(Sender: TObject);
begin
  SetLength(aHotKeys, High(aHotKeys) + 2);
  aHotKeys[High(aHotKeys)].ID := High(aHotKeys) ;
//  aHotKeys[High(aHotKeys)].Name := _('HotKey') + ' ' + IntToStr(High(aHotKeys));
  aHotKeys[High(aHotKeys)].Name := _('neuer Hotkey');
  aHotKeys[High(aHotKeys)].State := 0;
  cbbHotkeyStore.ItemIndex := -1;
  cbbHotkeyArchive.ItemIndex := -1;
  cbbHotkey.Properties.Items.Add(aHotKeys[High(aHotKeys)].Name);
  cbbHotkey.ItemIndex := High(aHotKeys);
end;

procedure TfrmOptions.btnResetAllOptionsClick(Sender: TObject);
begin
  try
    DeleteFile(BD.AppdataBitfarmPd + 'ViewerOptions.ini');

    bitfarmApp.ViewerOptions.Reload;
    bitfarmApp.ReadResubFavs;
    FormShow(Self);
  except

  end;
end;

{$IFDEF ImageEn1140}
function TfrmOptions.SetScannerApiLabel: Integer;
var
  Device: TIEAcquireSource;
  Api: TIEAcquireApi;
  MIO: TbfaImageEnMView;
  ScanObj: TbfaScanner;
begin
  try
    Result := -1;
    MIO := TbfaImageEnMView.Create(Self);
    try
      ScanObj := bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex];
      Device := MIO.MIO.AcquireParams.FindSourceByName(ScanObj.ScannerName);

      // wenn das Gert nicht gefunden werden kann, wird die Form inital dargestellt, das Gert ist aber nicht verbunden
      // dann zeigen wir den Ursprnglichen Api-Typ an.
      if (Device.Api = ieaNone) and (Device.DeviceType = ieadUnknown) and
         (Device.Location = -1) and (cbxScannerName.Text <> '') then
      begin
        if ScanObj.ApiType = 0 then
          Api := ieaTwain
        else if ScanObj.ApiType = 1 then
          Api := ieaWIA
        else
          Api := ieaNone;
      end else
      begin
        if (Device.Api = ieaTwain) and (cbxScannerName.Text <> '') then
          Api := ieaTwain
        else if (Device.Api = ieaWIA) and (cbxScannerName.Text <> '') then
          Api := ieaWIA
        else if (Device.Api = ieaNone) and (cbxScannerName.Text <> '') then
          Api := ieaNone
        else if (cbxScannerName.Text = '') then
        begin
          Result := -1;
          lblApiType.Visible := False;
          Exit;
        end;
      end;

      case Api of
        ieaTwain:
        begin
          lblApiType.Caption := _('Typ:') + ' ' + _('TWAIN');
          Result := 0;
        end;
        ieaWIA:
        begin
          lblApiType.Caption := _('Typ:') + ' ' + _('WIA');
          Result := 1;
        end;
        else
        begin
          lblApiType.Caption := _('Typ:') + ' ' + _('unbekannt');
          Result := -1;
        end;
      end;

      lblApiType.Visible := True;
    finally
      MIO.MIO.TwainParams.FreeResources;
      FreeAndNil(MIO);
    end;
  except
    lblApiType.Caption := _('Typ:') + ' ' + _('unbekannt');
    lblApiType.Visible := True;
    Result := -1;
  end;
end;
{$ENDIF}

procedure TfrmOptions.SetScanTab;
begin
  try
    cbxScanProfile.ItemIndex := -1;
    cbxScanProfile.Text := '';

    ResetScanTab;

    bitfarmApp.FillScanProfiles(cbxScanProfile, False);
    if imgPreview <> nil then //12.12.2022
      imgPreView.MouseWheelParams.ZoomPosition := iemwMouse;

    if (bitfarmApp.ScannerProfiles.Container.Count > 0) then
    begin
      if Assigned(frmMainForm.fraScanFunctions) and Assigned(frmMainForm.fraScanFunctions.cbxScanProfile) and 
        (frmMainForm.fraScanFunctions.cbxScanProfile.ItemIndex <> -1) and 
        (frmMainForm.fraScanFunctions.cbxScanProfile.Properties.Items.count = cbxScanProfile.Properties.Items.Count) then
      begin
        cbxScanProfile.ItemIndex := frmMainForm.fraScanFunctions.cbxScanProfile.ItemIndex;
      end
      else
      begin
        if (bitfarmApp.ScannerProfiles.DefaultScanner <> -1) then
          cbxScanProfile.ItemIndex := bitfarmApp.ScannerProfiles.DefaultScanner
        else
          cbxScanProfile.ItemIndex := 0;
      end;
    end;


    actExportProfiles.Enabled := (cbxScanProfile.Properties.Items.Count > 0);
    actImportProfiles.Enabled := True;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetScanTab', ClassName);
  end;
end;

procedure TfrmOptions.FormShow(Sender: TObject);
var
  i: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'FormShow', ClassName);
  FShow := True;
  actModifyOptions.Enabled := False;
  try
    try
      DefaultProfilChanged := False;
      SetGeneralTab;
      SetEditorTab;
      SetScanTab;
      SetSearchTab;
      SetResubTab;
      SetAdminTab;
      SetImporterTab;
      tabAdmin.TabVisible := bitfarmApp.User.isAdmin;
      bitfarmLog.Write(llDebug, ltDebug, '0', ClassName);
      SetHotkeyTab;
      bitfarmLog.Write(llDebug, ltDebug, '1', ClassName);

      // Lager werden jetzt in SetHotkeyTab gesetzt. Archive beim cbbHotkeyArchiveChange
//      for i := Low(aSysArc) to High(aSysArc) do
//      begin
//        if (aSysArc[i].Name <> '') then
//        begin
//          if aSysArc[i].Typ = 0 then
//            cbbHotkeyStore.Items.AddObject(aSysArc[i].Name, TObject(i));
//          else if aSysArc[i].Typ = 1 then
//            cbbHotkeyArchive.Items.AddObject(aSysArc[i].Name, TObject(i));
//        end;
//      end;

      WindowState := wsNormal;
      bitfarmLog.Write(llDebug, ltDebug, '2', ClassName);

      FMStream.Clear;
      imgPreView.Clear;
    except
      bitfarmLog.Write(llNormal, ltException, 'FormShow', ClassName);
    end;
    try
      var hd: HWND;
      hd := FindWindow('bitfarm.hotsearch.V36', nil);
      if hd <> 0 then
        PostMessage(hd, WM_HOTKEY_ENABLE_DISABLE, 0, 0);
    except
      bitfarmLog.Write(llNormal, ltException, 'FormShow - WM_HOTKEY_ENABLE_DISABLE', ClassName);
    end;
  finally
    FHotKeyChange := False;
    FScanProfileChange := False;
    FShow := False;
    bitfarmLog.DebugEnd(llDebug, 'FormShow', ClassName);
  end;
end;

procedure TfrmOptions.OnResubModified;
var
  i, j, k, options: Integer;
  inifile: TIniFile;
  task: string;
  resub: TResub;
  lst: TStringList;
begin
  if cbbName.ItemIndex = -1 then
    Exit;

  actEnableModifyOptions.Execute;

  lst := TStringList.Create;
  lst.Delimiter := ';';
  lst.StrictDelimiter := True;
  try
    i := cbbName.ItemIndex;
    task := 'Task' + Inttostr(i);
    resub.ID := i;
    resub.Name := fraCreateResub.edtName.Text;
    resub.Info := fraCreateResub.edtInfoCreate.Text;
    resub.FwdInfo := fraCreateResub.edtInfoFoward.Text;
    resub.Alarm := Round(fraCreateResub.edtAlarm1.Value);
    resub.AdditionalDays := Round(fraCreateResub.edtAdditionalDays.Value);
    for j := 0 to fraCreateResub.cbbUser.Items.Count - 1 do
      if fraCreateResub.cbbUser.IsChecked(j) then
        lst.Add(IntToStr(integer(fraCreateResub.cbbUser.Items.Objects[j])));

    resub.Users := lst.DelimitedText;
    lst.Clear;
    for j := 0 to fraCreateResub.cbbGroup.Items.Count - 1 do
      if fraCreateResub.cbbGroup.IsChecked(j) then
        lst.Add(IntToStr(integer(fraCreateResub.cbbGroup.Items.Objects[j])));

    resub.Groups := lst.DelimitedText;
    options := 0;
    if fraCreateResub.chkEveryone.Checked then
      options := (options or 1);
    if fraCreateResub.chkReturnToSender.Checked then
      options := (options or 2);
    if fraCreateResub.chkEmailreminder.Checked then
      options := (options or 4);
    if fraCreateResub.chkNotifyByMail.Checked then
      options := (options or 64);
    resub.Options := options;
    resub.FavIcon := fraCreateResub.cbbFavIcon.ItemIndex;
    resub.AdditionalDays := Round(fraCreateResub.edtAdditionalDays.Value);

    // war das FavIcon schon vergeben, so mssen wir den ursprnglichen Eintrag leersetzen
    for j := Low(aResubFavs) to High(aResubFavs) do
    begin
      if (aResubFavs[j].FavIcon = resub.FavIcon) and
         (aResubFavs[j].ID <> resub.ID) and
         (resub.FavIcon <> 0) then
      begin
        // vorher fragen wir aber, ob wir das wirklich machen sollen...
        if (BfMessageDlg(_('Dieses Favoriten-Bild wird bereits verwendet. Mchten Sie den alten Entrag ersetzen?'), mtConfirmation, [mbYes,mbNo]) = mrYes) then
        begin
          aResubFavs[j].FavIcon := 0;
          Break;
        end else
        begin
          resub.FavIcon := aResubFavs[i].FavIcon;
          fraCreateResub.cbbFavIcon.ItemIndex := aResubFavs[i].FavIcon;
        end;
      end;
    end;
    resub.Modified := True;
    aResubFavs[i] := resub;

    if cbbName.Items[i] <> fraCreateResub.edtName.Text then  // Ticket 14817, aktualisieren der Combobox
    begin
      cbbName.Items[i] := fraCreateResub.edtName.Text;
      cbbName.ItemIndex := i;  //  Index muss nochmal gesetzt werden, da beim ndern des Items, geht der Itemindex verloren. Das Onchange wird dabei nicht erneut aufgerufen!
    end;

  finally
    FreeAndNil(lst);
  end;

end;

procedure TfrmOptions.OptionsFormCloseUp(Sender: TObject);
begin
  // used in several Elements to avoid the Form to close on ESC
  FDropDownOpen := False;
end;

procedure TfrmOptions.OptionsFormDropDown(Sender: TObject);
begin
  // used in several Elements to avoid the Form to close on ESC
  FDropDownOpen := True;
end;

procedure TfrmOptions.rbnImporterOpenDocClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.EditorOptions.ImporterOpenDocInImporter := rbnImporterOpenDocInImporter.Checked;

//      chkImporterDblClickFloating.Enabled := not bitfarmApp.ViewerOptions.EditorOptions.ImporterOpenDocInImporter;

      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'ImporterOpenDocImImporterClick', ClassName);
  end;
end;

procedure TfrmOptions.rbnWorkplaceOpenDocClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.EditorOptions.WorkplaceOpenDoc :=  Sender = rbnWorkplaceOpenDoc;
      bitfarmApp.ViewerOptions.EditorOptions.WorkplaceOpenDocInWorkplace := Sender = rbnWorkplaceOpenDocInWorkplace;
//      bitfarmApp.ViewerOptions.EditorOptions.WorkplaceAutoEditMode := Sender = rbnWorkplaceAutoEdit;

//      chkWorkplaceDblClickFloating.Enabled := bitfarmApp.ViewerOptions.EditorOptions.WorkplaceOpenDoc;

      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'rbnWorkplaceOpenDocClick', ClassName);
  end;
end;

procedure TfrmOptions.actApplyExecute(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'actApplyExecute', ClassName);
  try
    try
      bitfarmApp.ScannerProfiles.Save;
    except
      bitfarmLog.Write(llNormal, ltException, 'actApplyExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actApplyExecute', ClassName);
  end;
end;

procedure TfrmOptions.actDeleteProfileExecute(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'actDeleteProfileExecute', ClassName);
  try
    try
      if BfMessageDlg(_('Mchten Sie das ausgewhlte Profil wirklich lschen?'), mtConfirmation, [mbYes, mbNo], True) = mrYes then
      begin
        bitfarmApp.ScannerProfiles.Container.Delete(cbxScanProfile.ItemIndex);
        bitfarmApp.ScannerProfiles.Save;
        bitfarmApp.FillScanProfiles(cbxScanProfile);
        bitfarmApp.RefreshScanCombos(True);
        cbxScanProfile.Text := '';
        cbxScanProfile.ItemIndex := -1;
        cbxScanProfile.Properties.OnChange(cbxScanProfile);

        actExportProfiles.Enabled := (cbxScanProfile.Properties.Items.Count > 0);

      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'actDeleteProfileExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actDeleteProfileExecute', ClassName);
  end;
end;

procedure TfrmOptions.actEnableModifyOptionsExecute(Sender: TObject);
begin
  actModifyOptions.Enabled := True;
end;

procedure TfrmOptions.actExportProfilesExecute(Sender: TObject);
begin
  try
    dlgSaveFile.Filter := 'Profile files (*.pro)|*.PRO|Any file (*.*)|*.*';
    if dlgSaveFile.Execute then
    begin
      Screen.Cursor := crHourGlass;
      try
        bitfarmApp.ScannerProfiles.ExportProfiles(dlgSaveFile.FileName);
        BfMessageDlg(_('Die Exportdatei ist fertig.'), mtInformation, [mbOK]);
      finally
        Screen.Cursor := crDefault;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'actExportProfilesExecute', ClassName);
  end;
end;

procedure TfrmOptions.actImportProfilesExecute(Sender: TObject);
var
  ImportScannerOptions : TbfaScannerOptions;
  Scanner : TbfaScanner;
  i, counter : Integer;
  ini : TInifile;
begin
  try
    try
      dlgOpenFile.Filter := 'Profile files (*.pro)|*.PRO|Any file (*.*)|*.*';
      FDropDownOpen := True;
      if dlgOpenFile.Execute then
      begin
        ImportScannerOptions := TbfaScannerOptions.Create(ostIniFile, dlgOpenFile.FileName);
        ini := TIniFile.Create(dlgOpenFile.FileName);
        try
          bitfarmApp.ScannerProfiles.ReadScannerOptions(dlgOpenFile.FileName, HKEY_LOCAL_MACHINE, '', '',
            ImportScannerOptions, False);

          counter := ini.ReadInteger(sSysVersion, 'Count', 0);

          for i := 0 to Counter - 1 do
          begin
            Scanner := TbfaScanner.Create;
            Scanner.GlobalProfile := True;
            bitfarmApp.Log.Write(llDebug, ltInfo, 'ReadFromIni: ' + dlgOpenFile.FileName, ClassName);
            bitfarmApp.ScannerProfiles.ReadFromIni(Scanner, ImportScannerOptions, i);

            bitfarmApp.ScannerProfiles.Container.Add(Scanner);
          end;
          SetScanTab;
          bitfarmApp.RefreshScanCombos(True); //28.03.2017 Ticket 10177
          actEnableModifyOptions.Execute;
        finally
          FreeAndNil(ImportScannerOptions);
          FreeAndNil(ini);
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'actImportProfilesExecute', ClassName);
    end;
  finally
    FDropDownOpen := False;
  end;
end;

procedure TfrmOptions.actModifyOptionsExecute(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'actModifyOptionsExecute', ClassName);
  try
    try
      bitfarmLog.DebugBegin(llDebug, 'SaveScanProfiles', ClassName);
      try
        if cbxScanProfile.ItemIndex > -1 then
        begin
          if cbxColorMode.ItemIndex = 0 then
          begin
            bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].ColorMode := 0;
            bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].BitDepth := 0;
          end
          else if cbxColorMode.ItemIndex = 1 then
          begin
            bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].ColorMode := 1;
            bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].BitDepth := 1;
          end
          else if cbxColorMode.ItemIndex = 2 then
          begin
            bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].ColorMode := 1;
            bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].BitDepth := 2;
          end
          else
          if cbxColorMode.ItemIndex = 3 then
          begin
            bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].ColorMode := 2;
            bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].BitDepth := 2;
          end;

          if cbxColorMode.ItemIndex > 0 then
          begin
            if cbxCompression.text = 'JPG' then
              bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].Compression := 3
            else
            if cbxCompression.text = 'PackBits' then
              bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].Compression := 4
            else
            if cbxCompression.text = 'LZW' then
              bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].Compression := 5
            else
              bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].Compression := 0;
          end
          else
          begin
             case cbxCompression.ItemIndex of
               0:  //CCTIT 4
                 bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].Compression := 2;
               1: //Keine Kompression
                 bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].Compression := 0;
               else
                 bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].Compression := 0;
             end;

          end;
        end;

        FModifyOptionsResult := bitfarmApp.ScannerProfiles.Save;
        if FModifyOptionsResult <> 0 then
          BfMessageDlg(_('Fehler beim Speichern des Scan-Profiles!'), mtError, [mbOK]);
      finally
        bitfarmLog.DebugEnd(llDebug, 'SaveScanProfiles', ClassName);
      end;

      bitfarmLog.DebugEnd(llDebug, 'bitfarmApp.ViewerOptions.Save', ClassName);
      try
        FModifyOptionsResult := bitfarmApp.ViewerOptions.Save;
        if FModifyOptionsResult <> 0 then
          BfMessageDlg(_('Fehler beim Speichern der Editor Optionen!'), mtError, [mbOK]);
      finally
        bitfarmLog.DebugEnd(llDebug, 'bitfarmApp.ViewerOptions.Save', ClassName);
      end;

      //10.07.2024 SD -->bfacrm:ticket__show__36177
      //Wird der erste WV-Favorit gespeichert, so soll die Toolbar automatisch aktiviert werden.
      if (Length(aResubFavs) > 0) and (frmMainForm.tlbResubFavs.Items.Count = 0) then
        frmMainForm.tlbResubFavs.Visible := True;
      //10.07.2024 SD <--bfacrm:ticket__show__36177

      bitfarmApp.WriteResubFavs;
      bitfarmApp.CreateResubPopup;
      bitfarmApp.CreateResubFavsInPreviews;
      bitfarmApp.WriteHotSearchOptions;
      SetHotkeyTab; // beim bernehmen knnen sich die Bezeichner fr die Hotkeys ndern
      bitfarmApp.RefreshGUIByOption;

      actModifyOptions.Enabled := False;
    except
      bitfarmLog.Write(llNormal, ltException, 'actModifyOptionsExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actModifyOptionsExecute', ClassName);
  end;
end;

procedure TfrmOptions.actNewProfileExecute(Sender: TObject);
begin
  try
    frmProfileForm := TfrmProfileForm.Create(Application);
    frmProfileForm.cbx := cbxScanProfile;
    frmProfileForm.pnl1.Color := stlControl.Color;
    frmProfileForm.edtProfileName.Color := stlControl.Color;
    frmProfileForm.edtProfileName.Font.Color := stlControl.TextColor;
    frmProfileForm.ShowModal;
    if frmProfileForm.ModalResult <> mrCancel then
    begin
      cbxColorMode.ItemIndex := 0;
      cbxColorMode.OnChange(Self);
      cbxCompression.OnChange(Self);
      cbxDPI.ItemIndex := 5;
      cbxDPI.OnChange(Self);
      cbxFormat.ItemIndex := 1;
      cbxFormat.OnChange(Self);
      cbxOrientation.ItemIndex := 0;
      cbxOrientation.OnChange(Self);
      cbxTransfer.ItemIndex := 2;
      cbxTransfer.OnChange(Self);
      chkIgnoreTWAINError.Checked := True;
      chkIgnoreTWAINError.OnClick(Self);
      actExportProfiles.Enabled := (cbxScanProfile.Properties.Items.Count > 0);
    end;
  finally
    frmProfileForm.Release;
  end;
end;

procedure TfrmOptions.actSaveProfileExecute(Sender: TObject);
begin
//
end;

procedure TfrmOptions.btnDeleteResubClick(Sender: TObject);
var
  index: Integer;
begin
  index := cbbName.ItemIndex;

  if index = -1 then
    Exit;

  if BfMessageDlg(Format(_('Soll der Favorit %s wirklich gelscht werden'),[cbbName.Items[cbbName.ItemIndex]]),mtConfirmation, mbOKCancel, True) = mrOk then
  begin
    bitfarmApp.DeleteResubFavs(index);
    cbbName.Items.Delete(index);

    if (index > cbbName.Items.Count - 1) then
      index := index - 1;
    cbbName.ItemIndex := index;
    cbbName.OnChange(nil);
    cbbName.Invalidate; // ansonsten wird beim letzten Item der Text nicht zurck gesetzt
    actEnableModifyOptions.Execute;
    btnDeleteResub.Enabled := cbbName.ItemIndex <> -1;
    if cbbName.ItemIndex = -1 then
      fraCreateResub.edtName.Text := '';
  end;
end;

procedure TfrmOptions.btnHotSearchDeleteClick(Sender: TObject);
var
  i, idx: Integer;
  hotkey: TbfaHotKey;
begin
  try
    idx := cbbHotkey.ItemIndex;
    if idx > 1 then
    begin
      for i := idx + 1 to High(aHotKeys) do
      begin
        if i <= High(aHotKeys) then
        begin
          hotkey := aHotKeys[i];
          hotkey.ID := i - 1;
//          hotkey.Name := _('Hotkey ') + IntToStr(i - 1);
          hotkey.Modified := True;
          aHotKeys[i - 1] := hotKey;
        end;
      end;
      SetLength(aHotKeys, Length(aHotKeys) - 1);
      cbbHotkey.Properties.Items.Clear;
      for i := Low(aHotKeys) to High(aHotKeys) do
      begin
        if aHotKeys[i].State = 0 then
          cbbHotkey.Properties.Items.Add(aHotKeys[i].Name);
      end;
      if idx < cbbHotkey.Properties.Items.Count then
        cbbHotkey.ItemIndex := idx
      else
        cbbHotkey.ItemIndex := 0;
      cbbHotKeyChange(Sender);
      actEnableModifyOptions.Execute;
    end;
  except

  end;
end;

procedure TfrmOptions.btnNewResubClick(Sender: TObject);
var
  i,j, idx : Integer;
  found : Boolean;
begin
  SetLength(aResubFavs, High(aResubFavs) + 2);
  aResubFavs[High(aResubFavs)].ID := High(aResubFavs) + 1;
  idx := High(aResubFavs) + 1;
  found := True;
  while found do
  begin
    found := False;
    for i := 0 to High(aResubFavs) do
    begin
      if aResubFavs[i].Name = _('Favorit') + ' ' + IntToStr(idx) then
      begin
        found := True;
        inc(idx);
      end;
    end;
  end;

  aResubFavs[High(aResubFavs)].Name := _('Favorit') + ' ' + IntToStr(idx);
  aResubFavs[High(aResubFavs)].Alarm := 7;
  aResubFavs[High(aResubFavs)].Modified := True;
  aResubFavs[High(aResubFavs)].AdditionalDays := 0;
  cbbName.Items.Add(aResubFavs[High(aResubFavs)].Name);
  cbbName.ItemIndex := High(aResubFavs);
  cbbName.OnChange(nil);
  //10.07.2024 SD -->bfacrm:ticket__show__36177
  //Dem neuen Element ein Icon zuweisen, das noch nicht im Toolbar vorhanden ist.
  for j := 1 to fraCreateResub.cbbFavIcon.Items.Count do
  begin
    found := False;
    for i := 0 to High(aResubFavs) do
    begin
      if aResubFavs[i].FavIcon = j then
      begin
        found := True;
        Break;
      end;
    end;
    if not found then
      Break
  end;
  if not found then
     fraCreateResub.cbbFavIcon.ItemIndex := j;
  //10.07.2024 SD <--bfacrm:ticket__show__36177
  fraCreateResub.edtName.SetFocus;
  btnDeleteResub.Enabled := cbbName.ItemIndex <> -1;
end;

procedure TfrmOptions.btnOKClick(Sender: TObject);
begin
  if actModifyOptions.Enabled then
  begin
    actModifyOptions.Execute;
    if FModifyOptionsResult <> 0 then
      Self.ModalResult := mrNone
    else
      Self.ModalResult := mrOK;
  end
  else
    Self.ModalResult := mrOK;
end;

procedure TfrmOptions.cbbHotkeyArchiveChange(Sender: TObject);
begin
  try
    if not FHotKeyChange then
    begin
      if not FShow then
      begin
        aHotKeys[cbbHotkey.ItemIndex].ArchiveName := cbbHotkeyArchive.Text;
        if cbbHotkeyArchive.ItemIndex = -1 then
          aHotKeys[cbbHotkey.ItemIndex].ArchiveID := -1
        else
          aHotKeys[cbbHotkey.ItemIndex].ArchiveID := Integer(cbbHotkeyArchive.Items.Objects[cbbHotkeyArchive.ItemIndex]);
        aHotKeys[cbbHotkey.ItemIndex].Modified := True;
        actEnableModifyOptions.Execute;
      end;
    end;
  except

  end;
end;

procedure TfrmOptions.cbbHotKeyChange(Sender: TObject);
begin
  FHotKeyChange := True;
  try
    try
      lblName.Enabled := True;
      edtName.Enabled := True;
      lblStore.Enabled := True;
      lblArchive.Enabled := True;
      lblHotkey.Enabled := True;
      cbbHotkeyStore.Enabled := True;
      cbbHotkeyArchive.Enabled := True;
      chkScreenshot.Enabled := True;
      chkDocLink.Enabled := True;
      chkGDocIDSearch.Enabled := True;
      edtHotKey.Enabled := True;

      if cbbHotkey.ItemIndex <> -1 then
      begin
        edtName.Text := aHotKeys[cbbHotkey.ItemIndex].Name;
        if (cbbHotkey.ItemIndex = 0) or (cbbHotkey.ItemIndex = 1) then
        begin
          lblName.Enabled := False;
          edtName.Enabled := False;
          lblStore.Enabled := False;
          lblArchive.Enabled := False;
          lblHotkey.Enabled := False;
          chkScreenshot.Enabled := False;
          chkDocLink.Enabled := False;
          chkGDocIDSearch.Enabled := False;
          cbbHotkeyStore.Enabled := False;
          cbbHotkeyArchive.Enabled := False;
          cbbHotkeyStore.ItemIndex := -1;
          cbbHotkeyArchive.ItemIndex := -1;
          chkScreenshot.Checked := False;
          chkGDocIDSearch.Checked := False;
          edtHotKey.HotKey := aHotKeys[cbbHotkey.ItemIndex].HotKey;
          btnHotSearchDelete.Enabled := False;
        end
        else
        begin
          try
            cbbHotkeyStore.ItemIndex := cbbHotKeyStore.Items.IndexOf(aHotKeys[cbbHotkey.ItemIndex].StoreName);
            cbbHotkeyStore.OnChange(cbbHotkeyStore);
          except
            cbbHotkeyStore.Text := aHotKeys[cbbHotkey.ItemIndex].StoreName;
          end;
          try
            cbbHotkeyArchive.ItemIndex := cbbHotkeyArchive.Items.IndexOf(aHotKeys[cbbHotkey.ItemIndex].ArchiveName);
            cbbHotkeyArchive.OnChange(cbbHotkeyArchive);
          except
            cbbHotkeyArchive.Text := aHotKeys[cbbHotkey.ItemIndex].ArchiveName;
          end;
          chkScreenshot.Checked := aHotKeys[cbbHotkey.ItemIndex].Screenshot;
          chkDocLink.Checked := aHotKeys[cbbHotkey.ItemIndex].DocLink;
          chkDocLink.Enabled := aHotKeys[cbbHotkey.ItemIndex].DocLink or ((not aHotKeys[cbbHotkey.ItemIndex].DocLink) and (not aHotKeys[cbbHotkey.ItemIndex].GDocIDSearch));
          chkGDocIDSearch.Enabled := (not aHotKeys[cbbHotkey.ItemIndex].DocLink);
          // DocLink war zuerst da. Falls also jemand in der ini rumspielen sollte (und beide setzt), gewinnt DocLink.
          chkGDocIDSearch.Checked := (chkGDocIDSearch.Enabled and aHotKeys[cbbHotkey.ItemIndex].GDocIDSearch);
          edtHotKey.HotKey := aHotKeys[cbbHotkey.ItemIndex].HotKey;
          btnHotSearchDelete.Enabled := True;
        end;
      end
      else
        // HS will lieber den Standard-HotKey, anstelle von -1
        cbbHotkey.ItemIndex := 0;
//      begin
//        cbbHotkeyStore.Text := '';
//        cbbHotkeyArchive.Text := '';
//        chkScreenshot.Checked := False;
//        chkGDocIDSearch.Checked := False;
//        chkDocLink.Checked := False;
//        edtHotKey.HotKey := 0;
//        lblName.Enabled := False;
//        edtName.Text := '';
//        edtName.Enabled := False;
//        lblStore.Enabled := False;
//        lblArchive.Enabled := False;
//        lblHotkey.Enabled := False;
//        chkScreenshot.Enabled := False;
//        chkGDocIDSearch.Enabled := False;
//        chkDocLink.Enabled := False;
//        cbbHotkeyStore.Enabled := False;
//        cbbHotkeyArchive.Enabled := False;
//        edtHotKey.Enabled := False;
//        btnHotSearchDelete.Enabled := False;
//      end;
    except

    end;
  finally
    FHotKeyChange := False;
  end;
end;

procedure TfrmOptions.cbbHotkeyKeyPress(Sender: TObject; var Key: Char);
begin
  DisableBeep(Key); //11.03.2024 bfacrm:ticket__show__38134
end;

procedure TfrmOptions.cbbHotkeyStoreChange(Sender: TObject);
var
  i: Integer;
begin
  try
    cbbHotkeyArchive.ItemIndex := -1;
    cbbHotkeyArchive.Items.Clear;
    if cbbHotkeyStore.ItemIndex > -1 then
      for i := Low(aSysArc) to High(aSysArc) do
        if (aSysArc[i].Typ = 1) and ((aSysArc[i].Rights and rightList) = rightList) then
          if aSysArc[i].Lgrid = Integer(cbbHotkeyStore.Items.Objects[cbbHotkeyStore.ItemIndex]) then
            cbbHotkeyArchive.Items.AddObject(aSysArc[i].Name, TObject(i));

    if not FHotKeyChange then
    begin
      if not FShow then
      begin
        aHotKeys[cbbHotkey.ItemIndex].StoreName := cbbHotkeyStore.Text;
        if cbbHotkeyStore.ItemIndex > -1 then
          aHotKeys[cbbHotkey.ItemIndex].StoreID := Integer(cbbHotkeyStore.Items.Objects[cbbHotkeyStore.ItemIndex])
        else
          aHotKeys[cbbHotkey.ItemIndex].StoreID := -1;
        aHotKeys[cbbHotkey.ItemIndex].Modified := True;
        actEnableModifyOptions.Execute;
      end;
    end;
  except

  end;
end;

procedure TfrmOptions.cbbNameChange(Sender: TObject);
var
  ind//, i
  : Integer;
//  lst: TStringList;
begin
  fraCreateResub.LoadResub := True;
  try
    ind := cbbName.ItemIndex;

    if ind = -1 then
    begin
      cbbName.Text := '';
      Exit;
    end;

    bitfarmApp.LoadWVLFavorite(fraCreateResub, ind);
  finally
    fraCreateResub.LoadResub := False;
  end;

end;

procedure TfrmOptions.cbbProfilChange(Sender: TObject);
var
  i: Integer;
begin
  try
    if not FShow then
    begin
      aHotKeyProfil := cbbProfil.Text;
      actEnableModifyOptions.Execute;
    end;
  except

  end;
end;

procedure TfrmOptions.cbbTimerIntervalChange(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.ResubOptions.ResubTimerInterval := StrToInt(cbbTimerInterval.Text);
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'cbbTimerIntervalChange', ClassName);
  end;
end;

procedure TfrmOptions.cbxAutoZoomChange(Sender: TObject);
var
  i: Integer;
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.EditorOptions.AutoZoom := Integer(cbxAutoZoom.Items.Objects[cbxAutozoom.ItemIndex]);

      for i := 0 to bitfarmApp.PreviewContainer.Containers.Count - 1 do
      begin
        case bitfarmApp.ViewerOptions.EditorOptions.AutoZoom of
          0 : bitfarmApp.Zoom100(bitfarmApp.PreviewContainer.Containers[i].Preview);
          1 : bitfarmApp.ZoomPage(bitfarmApp.PreviewContainer.Containers[i].Preview);
          2 : bitfarmApp.ZoomWidth(bitfarmApp.PreviewContainer.Containers[i].Preview);
          3 : bitfarmApp.ZoomSelect(bitfarmApp.PreviewContainer.Containers[i].Preview);
          4 : bitfarmApp.ZoomOff(bitfarmApp.PreviewContainer.Containers[i].Preview);
          5 : bitfarmApp.ZoomHeight(bitfarmApp.PreviewContainer.Containers[i].Preview);  // Task 14649
//          6 : letzte Benutzereinstellung. Keine nderung ntig
        end;
      end;

      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkInvertDirectionClick', ClassName);
  end;
end;

procedure TfrmOptions.cbxColorModeChange(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      actEnableModifyOptions.Execute;
    end;
    FillCompressionCombo;
  except
    bitfarmLog.Write(llNormal, ltException, 'cbxColorModeChange', ClassName);
  end;
end;

procedure TfrmOptions.cbxCompressionChange(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].Compression := Integer(cbxCompression.Items.Objects[cbxCompression.ItemIndex]);
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'cbxCompressionChange', ClassName);
  end;
end;

procedure TfrmOptions.cbxDefaultAddfieldGroupRightsChange(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.AdminOptions.DefaultAddfieldGroupRights := TbfaInt(cbxDefaultAddfieldGroupRights.Items.Objects[cbxDefaultAddfieldGroupRights.ItemIndex]).Value;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'cbxDefaultArchiveGroupRightsChange', ClassName);
  end;
end;

procedure TfrmOptions.cbxDefaultArchiveGroupRightsChange(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.AdminOptions.DefaultArchiveGroupRights := TbfaInt64(cbxDefaultArchiveGroupRights.Items.Objects[cbxDefaultArchiveGroupRights.ItemIndex]).Value;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'cbxDefaultArchiveGroupRightsChange', ClassName);
  end;
end;

procedure TfrmOptions.cbxDefaultArchiveGroupRightsKeyPress(Sender: TObject;
  var Key: Char);
begin
  DisableBeep(Key); //11.03.2024 bfacrm:ticket__show__38134
end;

procedure TfrmOptions.cbxDefaultStatefieldGroupRightsChange(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.AdminOptions.DefaultStatefieldGroupRights := TbfaInt(cbxDefaultStatefieldGroupRights.Items.Objects[cbxDefaultStatefieldGroupRights.ItemIndex]).Value;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'cbxDefaultArchiveGroupRightsChange', ClassName);
  end;
end;

procedure TfrmOptions.cbxDocumentPrinterChange(Sender: TObject);
begin
  try
    if cbxDocumentPrinter.ItemIndex = -1 then
    begin
      chkUseWindowsDefaultPrinter.Checked := True;
      cbxDocumentPrinter.Text := _('Windows-Standarddrucker');
      cbxDocumentPrinter.Enabled := False;
    end
    else
    begin
      chkUseWindowsDefaultPrinter.Checked := False;
      cbxDocumentPrinter.Enabled := True;
    end;

    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.DefaultPrinter := cbxDocumentPrinter.ItemIndex;
      bitfarmApp.ViewerOptions.GeneralOptions.DefaultPrinterName := cbxDocumentPrinter.Text;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'cbxDocumentPrinterChange', ClassName);
  end;
end;

procedure TfrmOptions.cbxDPIChange(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].DPI := cbxDPI.ItemIndex;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'cbxDPIChange', ClassName);
  end;
end;

procedure TfrmOptions.cbxFilterChange(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].Filter := cbxFilter.ItemIndex;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'cbxFilterChange', ClassName);
  end;
end;

procedure TfrmOptions.cbxFilterKeyPress(Sender: TObject; var Key: Char);
begin
  DisableBeep(Key); //11.03.2024 bfacrm:ticket__show__38134
end;

procedure TfrmOptions.cbxFormatChange(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].Format := cbxFormat.ItemIndex;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'cbxFormatChange', ClassName);
  end;
end;

procedure TfrmOptions.cbxHistoryBookmarksLimitChange(Sender: TObject);
var
  Value, Code: Integer;
begin
  try
    if (not FShow) then
    begin
      val(cbxHistoryBookmarksLimit.Text, Value, Code);
      if Code <> 0 then
        bitfarmApp.ViewerOptions.SearchOptions.HistoryBookmarkLimit := 20
      else
        bitfarmApp.ViewerOptions.SearchOptions.HistoryBookmarkLimit := Value;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'cbxHistoryBookmarksLimitChange', ClassName);
  end;
end;

procedure TfrmOptions.cbxHistoryBookmarksLimitKeyPress(Sender: TObject;
  var Key: Char);
begin
  DisableBeep(Key); //11.03.2024 bfacrm:ticket__show__38134
end;

procedure TfrmOptions.cbxLimitChange(Sender: TObject);
var
  Value, Code: Integer;
begin
  try
    if (not FShow) then
    begin
      val(cbxLimit.Text, Value, Code);
      if Code <> 0 then
        bitfarmApp.ViewerOptions.SearchOptions.Limit := -1
      else
        bitfarmApp.ViewerOptions.SearchOptions.Limit := Value;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'cbxLimitChange', ClassName);
  end;
end;

procedure TfrmOptions.cbxLogLevelChange(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.AdminOptions.LogLevel := cbxLogLevel.ItemIndex;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkDefaultAddfieldGroupClick', ClassName);
  end;
end;

procedure TfrmOptions.cbxOrientationChange(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].Orientation := cbxOrientation.ItemIndex;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'cbxOrientationChange', ClassName);
  end;
end;

procedure TfrmOptions.cbxPixelFlavorChange(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
//      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].
//        Compression := cbxCompression.ItemIndex;
//      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'cbxCompressionChange', ClassName);
  end;
end;

procedure TfrmOptions.cbxScannerNameChange(Sender: TObject);
{$IFDEF ImageEn1140}
var
  Api: Integer;
{$ENDIF}
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].ScannerName := cbxScannerName.Text;
      actEnableModifyOptions.Execute;

      {$IFDEF ImageEn1140}
      Api := SetScannerApiLabel;
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].ApiType := Api;
      {$ENDIF}
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'cbxScannerNameChange', ClassName);
  end;
end;

procedure TfrmOptions.cbxScannerNameKeyPress(Sender: TObject; var Key: Char);
begin
  DisableBeep(Key); //11.03.2024 bfacrm:ticket__show__38134
end;

procedure TfrmOptions.cbxScanProfilePropertiesChange(Sender: TObject);
var
  ScanObj: TbfaScanner;
  i, j: Integer;
  MIO: TbfaImageEnMView;
begin
  bitfarmLog.DebugBegin(llDebug, 'cbxScanProfileChange', ClassName);
  FScanProfileChange := True;
  try
    try
      if cbxScanProfile.ItemIndex <> -1 then
      begin
        ScanObj := bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex];

        gbxScanProperties.Enabled := True;

        for i := 0 to gbxScanProperties.ControlCount - 1 do
        begin
          if ((gbxScanProperties.Controls[i].Name <> 'grbFilter') and
              (gbxScanProperties.Controls[i].Name <> 'grbFrame') and
              (gbxScanProperties.Controls[i].Name <> 'btnPrev') and
              (gbxScanProperties.Controls[i].Name <> 'btnNext')) then
          begin
            gbxScanProperties.Controls[i].Enabled := True;
            if (gbxScanProperties.Controls[i] is TSpTBXGroupBox) then
            begin
              for j := 0 to TSpTBXGroupBox(gbxScanProperties.Controls[i]).ControlCount - 1 do
                if TSpTBXGroupBox(gbxScanProperties.Controls[i]).Controls[j].Name <> edtDeletePages.Name then
                  TSpTBXGroupBox(gbxScanProperties.Controls[i]).Controls[j].Enabled := True;
            end;
          end;
        end;

        if ScanObj.GlobalProfile then
          rgpProfilType.ItemIndex := 0
        else
          rgpProfilType.ItemIndex := 1;

        chkDefaultProfile.Checked := ScanObj.DefaultProfile;

        cbxScannerName.Text := ScanObj.ScannerName;
        {$IFDEF ImageEn1140}
        SetScannerApiLabel;
        {$ENDIF}

        if ScanObj.ColorMode = 0 then                       // Schwarz-weiss
          cbxColorMode.ItemIndex :=  0;

        if ScanObj.ColorMode = 1 then                       // Graustufen
        begin
          if ScanObj.BitDepth = 0 then   // das kann eigentlich nicht sein, es muss 1 (4bit) oder 2 (8bit) sein
          begin                                 // das ist in versionen vor v3.5.1.13 so und wird hier korrigiert
            cbxColorMode.ItemIndex := 2;     // wir stellen auf 8bit Graustufe
            ScanObj.BitDepth := 2;
          end;

          if ScanObj.BitDepth = 1 then   // 4bit
            cbxColorMode.ItemIndex := 1;

          if ScanObj.BitDepth = 2 then   // 8bit
            cbxColorMode.ItemIndex := 2;
        end;

        if ScanObj.ColorMode = 2 then  // Farbe
          cbxColorMode.ItemIndex := 3;

        if cbxColorMode.ItemIndex <> 3 then
        begin
          grbFilter.Enabled := True;
          lblFilter.Enabled := True;
          cbxFilter.Enabled := True;
        end
        else
        begin
          grbFilter.Enabled := False;
          lblFilter.Enabled := False;
          cbxFilter.Enabled := False;
        end;

        FillCompressionCombo;

        cbxFilter.ItemIndex := ScanObj.Filter;

        if cbxColorMode.ItemIndex = 1 then
        begin
          case ScanObj.Compression of
            0: // keine Kompression
              cbxCompression.ItemIndex := 2;
            4: // PackBits
              cbxCompression.ItemIndex := 0;
            5: // LZW
              cbxCompression.ItemIndex := 1;
          else // keine Kompression
            cbxCompression.ItemIndex := 2;
          end;
        end
        else
        begin
          case ScanObj.Compression of
            0: // keine Kompression
             cbxCompression.ItemIndex := 3;
            3: // JPG
              cbxCompression.ItemIndex := 0;
            4: // PackBits
              cbxCompression.ItemIndex := 1;
            5: // LZW
              cbxCompression.ItemIndex := 2;
          else // keine Kompression
            cbxCompression.ItemIndex := 3;
          end;
        end;



        cbxDPI.ItemIndex := ScanObj.DPI;
        if ScanObj.ScanByID then
          rgpScanBy.ItemIndex := 0
        else
          rgpScanBy.ItemIndex := 1;

        edtBrightness.SpinOptions.MinValue := ScanObj.BrightnessMin;
        edtBrightness.SpinOptions.MaxValue := ScanObj.BrightnessMax;
        trbBrightness.Min := Round(ScanObj.BrightnessMin);
        trbBrightness.Max := Round(ScanObj.BrightnessMax);
        edtBrightness.Text := FloatToStr(ScanObj.Brightness);
        lblBrightnessMin.Caption := FloatToStr(ScanObj.BrightnessMin);
        lblBrightnessMax.Caption := FloatToStr(ScanObj.BrightnessMax);

        edtContrast.SpinOptions.MinValue := ScanObj.ContrastMin;
        edtContrast.SpinOptions.MaxValue := ScanObj.ContrastMax;
        trbContrast.Min := Round(ScanObj.ContrastMin);
        trbContrast.Max := Round(ScanObj.ContrastMax);
        edtContrast.Text := FloatToStr(ScanObj.Contrast);
        lblContrastMin.Caption := FloatToStr(ScanObj.ContrastMin);
        lblContrastMax.Caption := FloatToStr(ScanObj.ContrastMax);

        edtThreshold.SpinOptions.MinValue := ScanObj.ThresholdMin;
        edtThreshold.SpinOptions.MaxValue := ScanObj.ThresholdMax;
        trbThreshold.Min := Round(ScanObj.ThresholdMin);
        trbThreshold.Max := Round(ScanObj.ThresholdMax);
        edtThreshold.Text := FloatToStr(ScanObj.Threshold);
        lblThresholdMin.Caption := FloatToStr(ScanObj.ThresholdMin);
        lblThresholdMax.Caption := FloatToStr(ScanObj.ThresholdMax);

        chkADF.Checked := ScanObj.ADF;
        chkDuplex.Checked := ScanObj.Duplex;
        chkStacked.Checked := ScanObj.Stapel;
        chkInvers.Checked := ScanObj.Inverse;
        chkDeletePage.Checked := ScanObj.DeletePage;
        edtDeletePages.Text := IntToStr(ScanObj.DeletePageKB);
        edtDeletePages.Enabled := chkDeletePage.Checked;
        chkIgnoreTWAINError.Checked := ScanObj.IgnoreTWAINError;

        cbxFormat.ItemIndex := ScanObj.Format;
        cbxOrientation.ItemIndex := ScanObj.Orientation;
        cbxTransfer.ItemIndex := ScanObj.Transfer;
        chkCompatibleMode.Checked := ScanObj.CompatibleMode;

        chkSetFrame.Checked := ScanObj.UseFrame;
        for i := 0 to grbFrame.ControlCount - 1 do
          grbFrame.Controls[i].Enabled := chkSetFrame.Checked;

        edtFrameLeft.Text := FloatToStr(ScanObj.FrameLeft);
        edtFrameTop.Text := FloatToStr(ScanObj.FrameTop);
        edtFrameRight.Text := FloatToStr(ScanObj.FrameRight);
        edtFrameBottom.Text := FloatToStr(ScanObj.FrameBottom);

        actDeleteProfile.Enabled := True;
      end
      else
      begin
        ResetScanTab;
        lblApiType.Visible := False;
      end;
      {$IFNDEF ImageEn1140}
      lblApiType.Visible := False;
      {$ENDIF}

    except
      bitfarmLog.Write(llNormal, ltException, 'cbxScanProfileChange', ClassName);
    end;
  finally
    FScanProfileChange := False;
    bitfarmLog.DebugEnd(llDebug, 'cbxScanProfileChange', ClassName);
  end;
end;

procedure TfrmOptions.cbxScanProfile_2Change(Sender: TObject);
var
  ScanObj: TbfaScanner;
  i, j: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'cbxScanProfileChange', ClassName);
  FScanProfileChange := True;
  try
    try
      if cbxScanProfile.ItemIndex <> -1 then
      begin
        ScanObj := bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex];

        gbxScanProperties.Enabled := True;

        for i := 0 to gbxScanProperties.ControlCount - 1 do
        begin
          if ((gbxScanProperties.Controls[i].Name <> 'grbFilter') and (gbxScanProperties.Controls[i].Name <> 'grbFrame')) then
          begin
            gbxScanProperties.Controls[i].Enabled := True;
            if (gbxScanProperties.Controls[i] is TSpTBXGroupBox) then
            begin
              for j := 0 to TSpTBXGroupBox(gbxScanProperties.Controls[i]).ControlCount - 1 do
                if TSpTBXGroupBox(gbxScanProperties.Controls[i]).Controls[j].Name <> edtDeletePages.Name then
                  TSpTBXGroupBox(gbxScanProperties.Controls[i]).Controls[j].Enabled := True;
            end;
          end;
        end;

//        rgpScanBy.Caption := _('Auswahl nach:');
//        rgpProfilType.Caption := _('Profiltyp:');

        if ScanObj.GlobalProfile then
          rgpProfilType.ItemIndex := 0
        else
          rgpProfilType.ItemIndex := 1;

        chkDefaultProfile.Checked := ScanObj.DefaultProfile;

        cbxScannerName.Text := ScanObj.ScannerName;
        cbxColorMode.ItemIndex := ScanObj.ColorMode;
        FillCompressionCombo;

        if ScanObj.ColorMode = 1 then                       // Graustufen
        begin
          if ScanObj.BitDepth = 0 then   // das kann eigentlich nicht sein, es muss 1 (4bit) oder 2 (8bit) sein
          begin                                 // das ist in versionen vor v3.5.1.13 so und wird hier korrigiert
            ScanObj.ColorMode := 2;     // wir stellen auf 8bit Graustufe
            ScanObj.BitDepth := 2;
          end
          else if ScanObj.BitDepth = 1 then   // 4bit
          begin
            ScanObj.ColorMode := 1;
          end
          else if ScanObj.BitDepth = 2 then   // 8bit
          begin
            ScanObj.ColorMode := 2;
          end;
        end;
        if ScanObj.ColorMode <> 3 then
        begin
          grbFilter.Enabled := true;
          lblFilter.enabled := true;
          cbxFilter.enabled := true;
        end
        else
        begin
          grbFilter.Enabled := false;
          lblFilter.enabled := false;
          cbxFilter.enabled := false;
        end;

        cbxCompression.ItemIndex := ScanObj.Compression;
        cbxDPI.ItemIndex := ScanObj.DPI;
//        if ScanObj.ScannerID >= 0 then
//          rgpScanBy.ItemIndex := 0
//        else
//          rgpScanBy.ItemIndex := 1;

        edtBrightness.SpinOptions.MinValue := ScanObj.BrightnessMin;
        edtBrightness.SpinOptions.MaxValue := ScanObj.BrightnessMax;
        trbBrightness.Min := Round(ScanObj.BrightnessMin);
        trbBrightness.Max := Round(ScanObj.BrightnessMax);
        lblBrightnessMin.Caption := FloatToStr(ScanObj.BrightnessMin);
        lblBrightnessMax.Caption := FloatToStr(ScanObj.BrightnessMax);
        edtBrightness.Text := FloatToStr(ScanObj.Brightness);

        edtContrast.SpinOptions.MinValue := ScanObj.ContrastMin;
        edtContrast.SpinOptions.MaxValue := ScanObj.ContrastMax;
        trbContrast.Min := Round(ScanObj.ContrastMin);
        trbContrast.Max := Round(ScanObj.ContrastMax);
        lblContrastMin.Caption := FloatToStr(ScanObj.ContrastMin);
        lblContrastMax.Caption := FloatToStr(ScanObj.ContrastMax);
        edtContrast.Text := FloatToStr(ScanObj.Contrast);

        edtThreshold.SpinOptions.MinValue := ScanObj.ThresholdMin;
        edtThreshold.SpinOptions.MaxValue := ScanObj.ThresholdMax;
        trbThreshold.Min := Round(ScanObj.ThresholdMin);
        trbThreshold.Max := Round(ScanObj.ThresholdMax);
        lblThresholdMin.Caption := FloatToStr(ScanObj.ThresholdMin);
        lblThresholdMax.Caption := FloatToStr(ScanObj.ThresholdMax);
        edtThreshold.Text := FloatToStr(ScanObj.Threshold);

        chkADF.Checked := ScanObj.ADF;
        chkDuplex.Checked := ScanObj.Duplex;
        chkStacked.Checked := ScanObj.Stapel;
        chkInvers.Checked := ScanObj.Inverse;
        chkDeletePage.Checked := ScanObj.DeletePage;
        edtDeletePages.Text := IntToStr(ScanObj.DeletePageKB);

        cbxFormat.ItemIndex := ScanObj.Format;
        cbxOrientation.ItemIndex := ScanObj.Orientation;
//        cbxPixelFlavor.ItemIndex := ScanObj.
        cbxTransfer.ItemIndex := ScanObj.Transfer;
        chkCompatibleMode.Checked := ScanObj.CompatibleMode;

        chkSetFrame.Checked := ScanObj.UseFrame;
        for i := 0 to grbFrame.ControlCount - 1 do
          grbFrame.Controls[i].Enabled := chkSetFrame.Checked;

        edtFrameLeft.Text := FloatToStr(ScanObj.FrameLeft);
        edtFrameTop.Text := FloatToStr(ScanObj.FrameTop);
        edtFrameRight.Text := FloatToStr(ScanObj.FrameRight);
        edtFrameBottom.Text := FloatToStr(ScanObj.FrameBottom);

        actDeleteProfile.Enabled := True;

      end
      else
      begin
        ResetScanTab;
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'cbxScanProfileChange', ClassName);
    end;
  finally
    FScanProfileChange := False;
    bitfarmLog.DebugEnd(llDebug, 'cbxScanProfileChange', ClassName);
  end;
end;

procedure TfrmOptions.cbxStartingAreaChange(Sender: TObject);
begin
  try
    bitfarmApp.ViewerOptions.GeneralOptions.StartingArea :=
      cbxStartingArea.ItemIndex;
      actEnableModifyOptions.Execute;
  except
    bitfarmLog.Write(llNormal, ltException, 'cbxStartingAreaChange', ClassName);
  end;
end;

procedure TfrmOptions.cbxTimeServerChange(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.TimeSyncServer := cbxTimeServer.Text;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'cbxTimeServerChange', ClassName);
  end;
end;

procedure TfrmOptions.cbxTimeServerSelect(Sender: TObject);
var
  parameter, param1: string;
   //err: integer;
begin
  if (not FShow) then
  begin
    if cbxTimeServer.ItemIndex > -1 then
    begin
      param1 := cbxTimeServer.Items.Strings[cbxTimeServer.ItemIndex];
      if param1 <> '' then
      begin
        parameter := '/c net time ' + param1 + '/set /yes';
        {err := }
        ShellExecute(0, 'open', PChar(BD.EnvSystemRoot + '\system32\cmd.exe'), PChar(parameter), nil, SW_hide);
      end;
      //   sgTimeserver := param1;
    end;
    cbxTimeServerChange(Sender);
  end;
end;

procedure TfrmOptions.cbxTransferChange(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].Transfer := cbxTransfer.ItemIndex;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'cbxTransferChange', ClassName);
  end;
end;

procedure TfrmOptions.chkADFClick(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].ADF := chkADF.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkADFClick', ClassName);
  end;
end;

procedure TfrmOptions.chkAdminFullscreenClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.AdminOptions.AdminFullscreen := chkAdminFullscreen.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkDefaultAddfieldGroupClick', ClassName);
  end;
end;

procedure TfrmOptions.chkAlertWindowClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.AlertWindow := chkAlertWindow.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkAlertWindowClick', ClassName);
  end;
end;

procedure TfrmOptions.chkAutoCheckinClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.AutoCheckin := chkAutoCheckin.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkAutoCheckinClick', ClassName);
  end;
end;

procedure TfrmOptions.chkAutoCheckOutClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.AutoCheckout := chkAutoCheckOut.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkAutoCheckOutClick', ClassName);
  end;
end;

procedure TfrmOptions.chkAutoDisplayClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.SearchOptions.AutoDisplay := chkAutoDisplay.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkAutoDisplayClick', ClassName);
  end;
end;

procedure TfrmOptions.chkAutoEditModeClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.EditorOptions.AutoEditMode := rbnAutoEditMode.Checked;
      bitfarmApp.ViewerOptions.EditorOptions.DocNoAction := rbnDblClickNoAction.Checked;

//      chkDblClickFloating.Enabled := not bitfarmApp.ViewerOptions.EditorOptions.AutoEditMode;

      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkAutoEditModeClick', ClassName);
  end;
end;

procedure TfrmOptions.chkAutoPreviewClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.AutoPreview := chkAutoPreview.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkAutoPreviewClick', ClassName);
  end;
end;

procedure TfrmOptions.chkAutoViewerAtArchiveChangeClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.AutoViewerAtArchiveChange := chkAutoViewerAtArchiveChange.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkAutoViewerAtArchiveChangeClick', ClassName);
  end;
end;

procedure TfrmOptions.chkHintBallonsClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.HintBallons :=
        chkHintBallons.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkBallonHintClick', ClassName);
  end;
end;

procedure TfrmOptions.chkCalculateonSelectedRecordsClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.CalculateOnSelectedRecordsOnly :=
        chkCalculateonSelectedRecords.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkCalculateonSelectedRecordsClick', ClassName);
  end;
end;

procedure TfrmOptions.chkCheckoutNewDocumentsClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.CheckoutNewDocuments := chkCheckoutNewDocuments.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkCheckoutNewDocumentsClick', ClassName);
  end;
end;

procedure TfrmOptions.chkColumnAlarmClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.ResubOptions.ColumnAlarm := chkColumnAlarm.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkColumnAlarmClick', ClassName);
  end;
end;

procedure TfrmOptions.chkColumnModifiedClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.ResubOptions.ColumnModified := chkColumnModified.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkColumnModifiedClick', ClassName);
  end;
end;

procedure TfrmOptions.chkColumnCommentClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.ResubOptions.ColumnComment := chkColumnComment.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkColumnCommentClick', ClassName);
  end;
end;

procedure TfrmOptions.chkColumnInfoClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.ResubOptions.ColumnInfo := chkColumnInfo.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkColumnInfoClick', ClassName);
  end;
end;

procedure TfrmOptions.chkColumnTitleClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.ResubOptions.ColumnTitle := chkColumnTitle.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkColumnTitleClick', ClassName);
  end;
end;

procedure TfrmOptions.chkComboAutoDownClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.ComboAutoDown := chkComboAutoDown.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkComboAutoDownClick', ClassName);
  end;
end;

procedure TfrmOptions.chkCompatibleModeClick(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].CompatibleMode := chkCompatibleMode.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkCompatibleModeClick', ClassName);
  end;
end;

procedure TfrmOptions.chkDblClickFloatingClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.EditorOptions.InUnDockedPanel := chkDblClickFloating.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkDblClickFloatingClick', ClassName);
  end;
end;

procedure TfrmOptions.chkDefaultAddfieldGroupClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.AdminOptions.DefaultAddfieldGroup := chkDefaultAddfieldGroup.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkDefaultAddfieldGroupClick', ClassName);
  end;
end;

procedure TfrmOptions.chkDefaultArchiveGroupClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.AdminOptions.DefaultArchiveGroup := chkDefaultArchiveGroup.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkDefaultArchiveGroupClick', ClassName);
  end;
end;

procedure TfrmOptions.chkDefaultProfileClick(Sender: TObject);
var
  i: Integer;
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      for i := 0 to bitfarmApp.ScannerProfiles.Container.Count - 1 do
      begin
        if ((chkDefaultProfile.Checked) and (i = cbxScanProfile.ItemIndex)) or (not chkDefaultProfile.Checked) then
          bitfarmApp.ScannerProfiles.Container[i].DefaultProfile := chkDefaultProfile.Checked
        else if (chkDefaultProfile.Checked) and (i <> cbxScanProfile.ItemIndex) then
          bitfarmApp.ScannerProfiles.Container[i].DefaultProfile := not chkDefaultProfile.Checked;

        if chkDefaultProfile.Checked then
          bitfarmApp.ScannerProfiles.DefaultScanner := cbxScanProfile.ItemIndex
        else
          bitfarmApp.ScannerProfiles.DefaultScanner := -1;

        DefaultProfilChanged := True;
      end;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkDefaultProfileClick', ClassName);
  end;
end;

procedure TfrmOptions.chkDefaultResubStatefieldClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin

      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkDefaultResubStatefieldClick', ClassName);
  end;
end;

procedure TfrmOptions.chkDefaultStatefieldGroupClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.AdminOptions.DefaultStatefieldGroup := chkDefaultStatefieldGroup.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkDefaultStatefieldGroupClick', ClassName);
  end;
end;

procedure TfrmOptions.chkDeletePageClick(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].DeletePage := chkDeletePage.Checked;
      edtDeletePages.Enabled := chkDeletePage.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkDeletePageClick', ClassName);
  end;
end;

procedure TfrmOptions.chkDisplayCheckoutAtShutdownClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.DisplayCheckoutAtShutdown := chkDisplayCheckoutAtShutdown.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkDisplayCheckoutAtShutdownClick', ClassName);
  end;
end;

procedure TfrmOptions.chkDocEditorZoomClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.EditorOptions.DocEditorZoom := chkDocEditorZoom.Checked;

      {$IFDEF ImageEn1140}
        SetMouseWheelSettings;
      {$ENDIF}

      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkDocEditorZoomClick', ClassName);
  end;
end;

procedure TfrmOptions.chkDocLinkClick(Sender: TObject);
begin
  if not FHotKeyChange then
  begin
    if not FShow then
    begin
      if (cbbHotkey.ItemIndex <> -1) and (Length(aHotKeys) > 0) then
      begin
        aHotKeys[cbbHotkey.ItemIndex].DocLink := chkDocLink.Checked;
        aHotKeys[cbbHotkey.ItemIndex].Modified := True;
        SetHotSearchCheckboxes;
        actEnableModifyOptions.Execute;
      end;
    end;
  end;
end;

procedure TfrmOptions.chkDocLinkListClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.SearchOptions.ShowDocLinks := chkDocLinkList.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkDocLinkListClick', ClassName);
  end;
end;

procedure TfrmOptions.chkDocLinkListInTabClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.ShowDocLinksInTab := chkDocLinkListInTab.Checked;
      bitfarmApp.ShowDocLinkList;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkDocLinkListInTabClick', ClassName);
  end;
end;

procedure TfrmOptions.chkDocModifiedClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.SearchOptions.DocModified := chkDocModified.Checked;
      actEnableModifyOptions.Execute;
      if (frmMainForm.grdResultlistDevExView <> nil) and (frmMainForm.grdResultlistDevExView.ColumnCount > 0) then
      begin
        try
          for var j := 0 to frmMainForm.grdResultlistDevExView.ColumnCount - 1 do
          begin
            if frmMainForm.grdResultlistDevExView.Columns[j].DataBinding.FieldName = 'doc_modified' then
            begin
              frmMainForm.grdResultlistDevExView.Columns[j].Visible := bitfarmApp.ViewerOptions.SearchOptions.DocModified;
              Break;
            end;
          end;
        except
          on E: Exception do
            bitfarmLog.Write(llNormal, ltException, 'set doc_modified visibility: ' + E.Message, ClassName);
        end;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkDocModifiedClick', ClassName);
  end;
end;

procedure TfrmOptions.chkFieldSearchClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.SearchOptions.FieldTxtSearch := chkFieldSearch.Checked;
      SetOneGeneralSearchOption(chkFieldSearch);
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkFieldSearchClick', ClassName);
  end;
end;

procedure TfrmOptions.chkDocTagsSearchClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.SearchOptions.DocTagsSearch := chkDocTagsSearch.Checked;
      SetOneGeneralSearchOption(chkDocTagsSearch);
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkDocTagsSearchClick', ClassName);
  end;
end;

procedure TfrmOptions.chkDontResetOnArcSetClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.SearchOptions.DontResetOnArcSet := chkDontResetOnArcSet.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkDontResetOnArcSetClick', ClassName);
  end;
end;

procedure TfrmOptions.chkDragDropAsWindowsClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.DragDropAsWindows := chkDragDropAsWindows.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkDragDropAsWindowsClick', ClassName);
  end;
end;

procedure TfrmOptions.chkDuplexClick(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].Duplex := chkDuplex.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkDuplexClick', ClassName);
  end;
end;

procedure TfrmOptions.chkEmailReminderClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.ResubOptions.Emailreminder := chkEmailReminder.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkReturnToSenderClick', ClassName);
  end;
end;

procedure TfrmOptions.chkShowAllAddfieldsClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.SearchOptions.ShowAllAddfields := chkShowAllAddfields.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkShowAllAddfieldsClick', ClassName);
  end;
end;

procedure TfrmOptions.chkShowAllAddfieldsResubClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.ResubOptions.ShowAllAddfields := chkShowAllAddfieldsResub.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkShowAllAddfieldsResubClick', ClassName);
  end;
end;

procedure TfrmOptions.chkExportPDFClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.ExportPDF := chkExportPDF.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkExportPDFClick', ClassName);
  end;
end;

procedure TfrmOptions.chkFileTypeSearchClick(Sender: TObject);
begin
//  try
//    if (not FShow) then
//    begin
//      bitfarmApp.ViewerOptions.SearchOptions.FileTypeSearch :=
//        chkFileTypeSearch.Checked;
//      SetOneGeneralSearchOption(chkFileTypeSearch);
//      actEnableModifyOptions.Execute;
//    end;
//  except
//    bitfarmLog.Write(llNormal, ltException, 'chkFileTypeSearchClick', ClassName);
//  end;
end;

procedure TfrmOptions.chkFtxPosClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.SearchOptions.FtxPos := chkFtxPos.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkFtxPosClick', ClassName);
  end;
end;

procedure TfrmOptions.chkDoctagSearchClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      with bitfarmApp.ViewerOptions.SearchOptions do
      begin
        DoctagsSearch := chkDoctagsSearch.Checked;
        SetOneGeneralSearchOption(chkDoctagsSearch);
        actEnableModifyOptions.Execute;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkDoctagsSearchClick', ClassName);
  end;
end;

procedure TfrmOptions.chkFulltextSearchClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.SearchOptions.FulltextSearch := chkFulltextSearch.Checked;
      SetOneGeneralSearchOption(chkFulltextSearch);
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkFulltextSearchClick', ClassName);
  end;
end;

procedure TfrmOptions.chkGroupSearchClick(Sender: TObject);
begin
//  try
//    if (not FShow) then
//    begin
//      bitfarmApp.ViewerOptions.SearchOptions.GroupSearch :=
//        chkGroupSearch.Checked;
//      SetOneGeneralSearchOption(chkGroupSearch);
//      actEnableModifyOptions.Execute;
//    end;
//  except
//    bitfarmLog.Write(llNormal, ltException, 'chkGroupSearchClick', ClassName);
//  end;
end;


procedure TfrmOptions.chkIgnoreTWAINErrorClick(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].IgnoreTWAINError := chkIgnoreTWAINError.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkIgnoreTWAINErrorClick', ClassName);
  end;
end;

procedure TfrmOptions.chkImportBarcodeClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.ImportBarcode := chkImportBarcode.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkImportBarcodeClick', ClassName);
  end;
end;

procedure TfrmOptions.chkImportColorClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.ImportColor := chkImportColor.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkImportColorClick', ClassName);
  end;
end;

procedure TfrmOptions.chkImporterDblClickFloatingClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.EditorOptions.ImporterInUnDockedPanel := chkImporterDblClickFloating.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkImporterDblClickFloatingClick', ClassName);
  end;
end;

procedure TfrmOptions.chkImporterThumbnailClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.EditorOptions.ShowImporterThumbnail := chkImporterThumbnail.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkImporterThumbnailClick', ClassName);
  end;
end;

procedure TfrmOptions.chkImportHighResClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.ImportHighRes := chkImportHighRes.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkImportHighResClick', ClassName);
  end;
end;

procedure TfrmOptions.chkInversClick(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].Inverse := chkInvers.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkInversClick', ClassName);
  end;
end;

procedure TfrmOptions.chkInvertDirectionClick(Sender: TObject);
var
  i: Integer;
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.EditorOptions.InvertDirection := chkInvertDirection.Checked;

      {$IFDEF ImageEN1140}
        SetMouseWheelSettings;
      {$ELSE}
      for i := 0 to bitfarmApp.PreviewContainer.Containers.Count - 1 do
      begin
        bitfarmApp.PreviewContainer.Containers[i].Preview.SingleView.img_DocView.MouseWheelParams.InvertDirection := chkInvertDirection.Checked;
      end;
      {$ENDIF}

      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkInvertDirectionClick', ClassName);
  end;
end;

procedure TfrmOptions.chkMsLogonClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.MsLogon := chkMsLogon.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkMsLogonClick', ClassName);
  end;
end;


procedure TfrmOptions.chkNegativeCurrencyRedClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.NegativeCurrency := chkNegativeCurrencyRed.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkNegativeCurrencyRedClick', ClassName);
  end;
end;

procedure TfrmOptions.chkNoLoginWindowClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.NoLoginWindow := chkNoLoginWindow.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkNoLoginWindowClick', ClassName);
  end;
end;

procedure TfrmOptions.chkNoOCRClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.NoOCR := chkNoOCR.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkNoOCRClick', ClassName);
  end;
end;

procedure TfrmOptions.chkNotifyByMailClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.ResubOptions.NotifyByMail := chkNotifyByMail.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkReturnToSenderClick', ClassName);
  end;
end;

procedure TfrmOptions.chkOCRAddClick(Sender: TObject);
var
  i: Integer;
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.EditorOptions.OCRAdd := chkOCRAdd.Checked;

      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkOCRAddClick', ClassName);
  end;
end;

procedure TfrmOptions.chkOCRClipClick(Sender: TObject);
var
  i: Integer;
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.EditorOptions.OCRAutoClipbrd := chkOCRClip.Checked;

      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkOCRClipClick', ClassName);
  end;
end;

procedure TfrmOptions.chkOLEOutlookClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.OleOutlook := chkOLEOutlook.Checked;
      actEnableModifyOptions.Execute;
      if ((chkMailTo.Checked) and (chkOLEOutlook.Checked)) then   //24.06.2019 Ticket 18257
        chkMailTo.Checked := False;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkOLEOutlookClick', ClassName);
  end;
end;


procedure TfrmOptions.chkOverwriteLocalSaveClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.OverwriteLocalSave := chkOverwriteLocalSave.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkOverwriteLocalSaveClick', ClassName);
  end;
end;

procedure TfrmOptions.chkMailToClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.MailTo := chkMailTo.Checked;
      actEnableModifyOptions.Execute;
      if ((chkOLEOutlook.Checked) and (chkMailTo.Checked)) then   //24.06.2019 Ticket 18257
        chkOLEOutlook.Checked := False;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkMailToClick', ClassName);
  end;
end;
procedure TfrmOptions.chkPrintAfterArchiveClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.PrintAfterArchiving := chkPrintAfterArchive.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkPrintAfterArchiveClick', ClassName);
  end;
end;

procedure TfrmOptions.chkQuickArchiveClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.LateOCR := chkQuickArchive.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkQuickArchiveClick', ClassName);
  end;
end;

procedure TfrmOptions.chkRefnameSearchClick(Sender: TObject);
begin
//  try
//    if (not FShow) then
//    begin
//      bitfarmApp.ViewerOptions.SearchOptions.RefnameSearch :=
//        chkRefnameSearch.Checked;
//      SetOneGeneralSearchOption(chkRefnameSearch);
//      actEnableModifyOptions.Execute;
//    end;
//  except
//    bitfarmLog.Write(llNormal, ltException, 'chkRefnameSearchClick', ClassName);
//  end;
end;

procedure TfrmOptions.chkRememberLastToolClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.EditorOptions.RememberLastTool := chkRememberLastTool.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkRememberLastToolClick', ClassName);
  end;
end;

procedure TfrmOptions.chkResetAfterArchiveClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.ResetFieldsAfterArchiving := chkResetAfterArchive.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkResetAfterArchiveClick', ClassName);
  end;
end;

procedure TfrmOptions.chkResubFavsInPreviewClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.ResubOptions.ResubFavsInPreview := chkResubFavsInPreview.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkResubFavsInPreviewClick', ClassName);
  end;
end;

procedure TfrmOptions.chkResubOnStartupClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.ResubOptions.ResubOnStartup := chkResubOnStartup.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkResubOnStartupClick', ClassName);
  end;
end;

procedure TfrmOptions.chkResubTimerClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.ResubOptions.ResubTimer := chkResubTimer.Checked;
      cbbTimerInterval.Enabled := chkResubTimer.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkResubOnStartupClick', ClassName);
  end;
end;

procedure TfrmOptions.chkReturnToSenderClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.ResubOptions.ReturnToSender := chkReturnToSender.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkReturnToSenderClick', ClassName);
  end;
end;

procedure TfrmOptions.chkRowColorEvenOddClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.RowColorEvenOdd := chkRowColorEvenOdd.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkRowColorEvenOddClick', ClassName);
  end;
end;

procedure TfrmOptions.chkScreenshotClick(Sender: TObject);
begin
  try
    if not FHotKeyChange then
    begin
      if not FShow then
      begin
        if (cbbHotkey.ItemIndex <> -1) and (Length(aHotKeys) > 0) then
        begin
          aHotKeys[cbbHotkey.ItemIndex].Screenshot := chkScreenshot.Checked;
          aHotKeys[cbbHotkey.ItemIndex].Modified := True;
          actEnableModifyOptions.Execute;
        end;
      end;
    end;
  except

  end;
end;

procedure TfrmOptions.chkSearchLastYearClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.SearchOptions.SearchLastYear := chkSearchLastYear.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkSearchLastYearClick', ClassName);
  end;
end;

procedure TfrmOptions.chkSetFrameClick(Sender: TObject);
var
  i: Integer;
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].UseFrame := chkSetFrame.Checked;
      grbFrame.Enabled := chkSetFrame.Checked;
      for i := 0 to grbFrame.ControlCount - 1 do
        grbFrame.Controls[i].Enabled := chkSetFrame.Checked;

      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'cbxFormatChange', ClassName);
  end;
end;

procedure TfrmOptions.chkShowDocLinkListClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.ShowDocLinks := chkShowDocLinkList.Checked;
      chkDocLinkListInTab.Enabled := chkShowDocLinkList.Checked;
      bitfarmApp.ShowDocLinkList;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkShowDocLinkListClick', ClassName);
  end;
end;

procedure TfrmOptions.chkShowLinkCountClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.ShowLinkCount := chkShowLinkCount.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkShowLinkCountClick', ClassName);
  end;
end;

procedure TfrmOptions.chkSetAnnoDPIClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.SetAnnoDPI :=
        chkSetAnnoDPI.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkSetAnnoDPIClick', ClassName);
  end;
end;

procedure TfrmOptions.chkSQLFullTextClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.SearchOptions.SQLFullText := chkSQLFullText.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkSQLFullTextClick', ClassName);
  end;
end;

procedure TfrmOptions.chkStackedClick(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].Stapel := chkStacked.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkStackedClick', ClassName);
  end;
end;

procedure TfrmOptions.chkSyncTimeBitfarmClick(Sender: TObject);
var
  icount: integer;
  cmd, parameter, aparameter: string;
  tempstringList: TStrings;
  si: TStartupInfo;
  pi: TProcessInformation;
   //errb: longbool;
begin
  try
    try
      // FRunningTimeSync = bfacrm:ticket__show__21089
      if chkSyncTimeBitfarm.Checked and (not FRunningTimeSync) then
        // Zeit Sychronisieren mit   net time \\servername /set /yes

      begin
        FRunningTimeSync := chkSyncTimeBitfarm.Checked;
        tempStringList := TStringList.Create;

        FillChar(si, SizeOf(si), 0);
        si.cb := SizeOf(si);
        si.dwFlags := STARTF_USESHOWWINDOW;
        si.wShowWindow := SW_hide;

        // set pi properly
        FillChar(pi, SizeOf(pi), 0);
        //err:= ShellExecute(0,nil,PChar(%systemroot%+'\system32\cmd.exe /c net time \\sv02 /set /yes'), Nil, Nil, SW_NORMAL);
        //parameter:= '/c  dir > c:\nogtest.txt';
        // parameter:= '/c /q net time \\sv02 /set /yes'; // Zur entwicklungszeit mit dem Produktiv Server synken
        //parameter:= '/c net view > '+BD.EnvTemp+'\netview.lst';
        //err:=ShellExecute(0,'open',PChar(BD.EnvSystemRoot+'\system32\cmd.exe'),PChar(parameter),nil, SW_hide);
        // showmessage (inttostr(err));
        //sleep(120);

        //iskywalker20070613 exchanged shellexecute with createprocess (from   http://www.dsdt.info/tipps/?id=456 )
        // set cmd and parameter!
        cmd := BD.EnvSystemRoot + '\system32\\cmd.exe';
        parameter := '/c net view > ' + BD.EnvTemp + '\netview.lst';
        // fill Aparameter: this string should have the cmd and parameter arguments
        AParameter := Format('"%s" %s', [cmd, TrimRight(parameter)]);
        //start create Process: no process name, cmd with parameter, ,,,,,where it should be started, si, pi
        {errb := }      CreateProcess(nil, PChar(AParameter), nil, nil, longbool(False), CREATE_DEFAULT_ERROR_MODE or CREATE_NEW_CONSOLE or NORMAL_PRIORITY_CLASS, nil, PChar(BD.EnvSystemRoot + '\system32\'), si, pi);
        // wait till process is finished
        while (WaitForSingleObject(pi.hProcess, 1) <> Wait_Object_0) do
        begin
          Application.ProcessMessages;
          if not FRunningTimeSync then
            Exit;
        end;
        try
          if fileexists(BD.EnvTemp + '\netview.lst') then
          begin
            tempStringList.LoadFromFile(BD.EnvTemp + '\netview.lst');
              //Datei laden
            if tempStringList.Count > 0 then
              tempStringList.Delete(0); // Zeile' Servername und beschreibung leschen
            if tempStringList.Count > 0 then
              tempStringList.Delete(0);
              // Zeile' ----------------------------------------------------------------------------------------' lschen !
            for icount := 0 to tempstringList.Count - 1 do
            begin
              if leftstr(tempStringList[icount], 2) = '\\' then
                cbxTimeServer.Items.Add(copy(tempStringList[icount], 1, pos(' ', tempStringList[icount])));
            end;
          end;
        except
        end;
      end;

      cbxTimeServer.Enabled := chkSyncTimeBitfarm.Checked;

      if (not FShow) then
      begin
        bitfarmApp.ViewerOptions.GeneralOptions.TimeSync := chkSyncTimeBitfarm.Checked;
        actEnableModifyOptions.Execute;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'chkSyncTimeBitfarmClick', ClassName);
    end;
  finally
    FRunningTimeSync := False;
  end;
end;

procedure TfrmOptions.chkUseFileNameAsDocNameClick(Sender: TObject);
var
  i : Integer;
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.UseFileNameAsDocName :=
        chkUseFileNameAsDocName.Checked;
      actEnableModifyOptions.Execute;

      for i := 0 to bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView.ImageCount - 1 do
      begin
        if (not (TbfaDocument(bitfarmApp.PreviewContainer.ImporterItem.Preview.List[i]).ImporterDocNameModified or
                 bitfarmApp.ViewerOptions.GeneralOptions.UseFileNameAsDocName)) then
          {$IFDEF IMAGEEN1140}
          bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView.SelectedFontColor := stlControlNoRight.TextColor
          {$ELSE}
          bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView.ImageBottomText[i].Font.Color := stlControlNoRight.TextColor
          {$ENDIF}
        else
          {$IFDEF IMAGEEN1140}
          bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView.SelectedFontColor := stlControl.TextColor;
          {$ELSE}
          bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView.ImageBottomText[i].Font.Color := stlControl.TextColor;
          {$ENDIF}
      end;
      bitfarmApp.PreviewContainer.ImporterItem.Preview.multiview.Update;

    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkUseFileNameAsDocNameClick', ClassName);
  end;
end;

procedure TfrmOptions.chkUseOnlyGeneralSearchClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.SearchOptions.UseOnlyGeneralSearchField := chkUseOnlyGeneralSearch.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkUseOnlyGeneralSearchClick', ClassName);
  end;
end;

procedure TfrmOptions.chkAnnoTxtSearchClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.SearchOptions.AnnoTxtSearch := chkAnnoTxtSearch.Checked;
      SetOneGeneralSearchOption(chkAnnoTxtSearch);
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkAnnoTxtSearchClick', ClassName);
  end;
end;

procedure TfrmOptions.chkUseWindowsDefaultPrinterClick(Sender: TObject);
begin
  try
    if chkUseWindowsDefaultPrinter.Checked then
    begin
      cbxDocumentPrinter.Enabled := False;
      cbxDocumentPrinter.Text := _('Windows-Standarddrucker');
    end
    else
    begin
      cbxDocumentPrinter.Enabled := True;
      cbxDocumentPrinter.ItemIndex := 0;
    end;
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.GeneralOptions.UseDefaultPrinter := chkUseWindowsDefaultPrinter.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkUseWindowsDefaultPrinterClick', ClassName);
  end;
end;

procedure TfrmOptions.chkViewerThumnailClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.EditorOptions.ShowViewerThumbnail := chkViewerThumnail.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkViewerThumnailClick', ClassName);
  end;
end;

procedure TfrmOptions.chkWorkplaceAutoEditClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.EditorOptions.WorkplaceAutoEditMode := chkWorkplaceAutoEdit.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkWorkplaceAutoEditClick', ClassName);
  end;
end;

procedure TfrmOptions.chkWorkplaceDblClickFloatingClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.EditorOptions.WorkplaceInUnDockedPanel := chkWorkplaceDblClickFloating.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkWorkplaceDblClickFloatingClick', ClassName);
  end;
end;

procedure TfrmOptions.chkWorkplaceThumbnailClick(Sender: TObject);
begin
  try
    if (not FShow) then
    begin
      bitfarmApp.ViewerOptions.EditorOptions.ShowWorkplaceThumbnail := chkWorkplaceThumbnail.Checked;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkWorkplaceThumbnailClick', ClassName);
  end;
end;

{$IFDEF ImageEn1140}
procedure TfrmOptions.FillScannerCombo;
var
  iCount: Integer;
  Scanner: TIEAcquireParams;
  img: TbfaImageEnMView;
begin
  bitfarmLog.DebugBegin(llDebug, 'FillScannerCombo', ClassName);
  try
    try
      img := TbfaImageEnMView.Create(nil);
      try
        if BD.DevDebug then
           img.MIO.AcquireParams.AttachedTwainParams.LogFile := bitfarmLog.LogDir + '\ViewerV36' + '_' + FormatDateTime('YYYY-MM-DD', Now) + '_TWainParams.' + sSysLOG;

        cbxScannerName.Items.Clear;
        Scanner := img.MIO.AcquireParams;
        Scanner.AttachedTwainParams.FreeResources;
//        Scanner.FillListWithSources(cbxScannerName.Items, [ieaTwain, ieaWIA], True);

        if Scanner.AttachedTwainParams.SourceCount > 0 then
          for iCount := 0 to (Scanner.AttachedTwainParams.SourceCount - 1) do
            cbxScannerName.Items.AddObject(Scanner.AttachedTwainParams.SourceName[iCount], TObject(0));

        if Scanner.AttachedWIAParams.DevicesInfoCount > 0 then
          for iCount := 0 to (Scanner.AttachedWIAParams.DevicesInfoCount - 1) do
            cbxScannerName.Items.AddObject(Scanner.AttachedWIAParams.DevicesInfo[iCount].Name, TObject(1));
      finally
        img.Free;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'FillScannerCombo', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'FillScannerCombo', ClassName);
  end;
end;
{$ELSE}
procedure TfrmOptions.FillScannerCombo;
var
  iCount: Integer;
  Scanner: TIETwainParams;
  img: TbfaImageEnMView;
begin
  bitfarmLog.DebugBegin(llDebug, 'FillScannerCombo', ClassName);
  try
    try
      img := TbfaImageEnMView.Create(nil);
      try
        if BD.DevDebug then
           img.MIO.TWainParams.LogFile := bitfarmLog.LogDir + '\ViewerV36' + '_' + FormatDateTime('YYYY-MM-DD', Now) + '_TWainParams.' + sSysLOG;

        cbxScannerName.Items.Clear;
        Scanner := img.MIO.TwainParams;
        Scanner.FreeResources;
        for iCount := 0 to (Scanner.SourceCount - 1) do
          cbxScannerName.Items.Add(Scanner.SourceName[iCount]);

      finally
        img.Free;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'FillScannerCombo', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'FillScannerCombo', ClassName);
  end;
end;
{$ENDIF}

procedure TfrmOptions.ResetGeneralTab;
begin
  bitfarmLog.DebugBegin(llDebug, 'ResetGeneralTab', ClassName);
  try
    try
      cbxDocumentPrinter.Clear;
      edtDefaultSaveDirectory.Text := '';
      cbxDocumentPrinter.Text := '';
      chkUseWindowsDefaultPrinter.Checked := False;
      chkShowLinkCount.Checked := False;
      chkAutoPreview.Checked := False;
      chkNoLoginWindow.Checked := False;
      chkMsLogon.Checked := False;
      chkSyncTimeBitfarm.Checked := False;
      cbxTimeServer.Text := '';
      cbxTimeServer.Enabled := False;
      chkAlertWindow.Checked := False;
      chkAutoViewerAtArchiveChange.Checked := False;
      chkDocLinkList.Checked := False;
      chkDocLinkListInTab.Checked := False;
      chkComboAutoDown.Checked := False;
      chkExportPDF.Checked := False;
      chkOLEOutlook.Checked := False;
      chkMailTo.Checked := False;
//      chkChangePage.Checked := False;
      chkResubFavsInPreview.Checked := False;
      chkCalculateonSelectedRecords.Checked := False;
      chkNegativeCurrencyRed.Checked := False;
    except
      bitfarmLog.Write(llNormal, ltException, 'ResetGeneralTab', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ResetGeneralTab', ClassName);
  end;
end;

procedure TfrmOptions.ResetResubTab;
begin
  chkResubOnStartup.Checked := False;
  chkResubTimer.Checked := True;
  cbbTimerInterval.ItemIndex := 2;
  chkReturnToSender.Checked := False;
  chkEmailReminder.Checked := False;
  chkNotifyByMail.Checked := False;

  chkShowAllAddfieldsResub.Checked := False;

  chkColumnTitle.Checked := False;
  chkColumnInfo.Checked := False;
  chkColumnComment.Checked := False;
  chkColumnAlarm.Checked := False;
  chkColumnModified.Checked := False;
  chkColumnDocDate.Checked := False;

  cbbName.ItemIndex := -1;
  cbbName.OnChange(nil);
end;

procedure TfrmOptions.ResetAdminTab;
begin
  chkDefaultArchiveGroup.Checked := False;
  chkDefaultAddfieldGroup.Checked := False;
  chkDefaultStatefieldGroup.Checked := False;
//  chkDefaultResubStatefield.Checked := False;

  cbxDefaultArchiveGroupRights.ItemIndex := 0;
  cbxDefaultAddfieldGroupRights.ItemIndex := 0;
  cbxDefaultStatefieldGroupRights.ItemIndex := 0;

end;

procedure TfrmOptions.ResetEditorTab;
begin
  bitfarmLog.DebugBegin(llDebug, 'ResetEditorTab', ClassName);
  try
    try
      chkViewerThumnail.Checked := False;
      chkImporterThumbnail.Checked := False;
      chkWorkplaceThumbnail.Checked := False;
      chkInvertDirection.Checked := False;
      chkDocEditorZoom.Checked := False;
      chkDblClickFloating.Checked := False;
      rbnAutoEditMode.Checked := False;
      rbnOpenDoc.Checked := not rbnAutoEditMode.Checked;
      cbxAutoZoom.ItemIndex := 0;
      chkOCRClip.Checked := False;
      chkOCRAdd.Checked := False;
      edtHotKeyOcr.HotKey := 16473;

    except
      bitfarmLog.Write(llNormal, ltException, 'ResetEditorTab', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ResetEditorTab', ClassName);
  end;
end;

procedure TfrmOptions.ResetSearchTab;
begin
  bitfarmLog.DebugBegin(llDebug, 'ResetSearchTab', ClassName);
  try
    try
      cbxLimit.ItemIndex := -1;
      cbxLimit.Text := '';
      cbxHistoryBookmarksLimit.Text := '';
      chkAutoDisplay.Checked := False;
      chkDocLinkList.Checked := False;
      chkDontResetOnArcSet.Checked := False;
      chkShowAllAddfields.Checked := False;
      chkSearchLastYear.Checked := False;
      chkSQLFullText.Checked := False;
      chkDocModified.Checked := False;
      chkFtxPos.Checked := False;
    except
      bitfarmLog.Write(llNormal, ltException, 'ResetSearchTab', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ResetSearchTab', ClassName);
  end;
end;

procedure TfrmOptions.ResetHotkeyTab;
begin
  bitfarmLog.DebugBegin(llDebug, 'ResetHotkeyTab', ClassName);
  try
    try
      cbbHotkey.Properties.Items.Clear;
      cbbHotkey.Text := '';
      lblName.Enabled := False;
      edtName.Enabled := False;
      edtName.Text := '';
      lblStore.Enabled := False;
      lblArchive.Enabled := False;
      lblHotkey.Enabled := False;
      chkGDocIDSearch.Enabled := False;
      cbbHotkeyStore.Enabled := False;
      cbbHotkeyStore.ItemIndex := -1;
      cbbHotkeyStore.Text := '';
      cbbHotkeyStore.Items.Clear;
      cbbHotkeyArchive.Enabled := False;
      cbbHotkeyArchive.ItemIndex := -1;
      cbbHotkeyArchive.Text := '';
      cbbHotkeyArchive.Items.Clear;
      chkScreenshot.Enabled := False;
      chkDocLink.Enabled := False;
      edtHotKey.Enabled := False;
      edtHotKey.HotKey := 0;
      btnHotSearchDelete.Enabled := False;
      cbbProfil.Items.Clear;
      cbbProfil.Text := '';
      chkGDocIDSearch.Checked := False;
      chkScreenshot.Checked := False;
      chkDocLink.Checked := False;
    except
      bitfarmLog.Write(llNormal, ltException, 'ResetHotkeyTab', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ResetHotkeyTab', ClassName);
  end;
end;

procedure TfrmOptions.ResetImporterTab;
begin
  bitfarmLog.DebugBegin(llDebug, 'ResetImporterTab', ClassName);
  try
    try
      chkPrintAfterArchive.Checked := False;
      chkResetAfterArchive.Checked := False;
      chkNoOCR.Checked := False;
      chkQuickArchive.Checked := False;
      edtFilter.Text := '';
      chkImportColor.Checked := False;
      chkImportHighRes.Checked := False;
      chkImportBarcode.Checked  := False;
    except
      bitfarmLog.Write(llNormal, ltException, 'ResetImporterTab', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ResetImporterTab', ClassName);
  end;
end;

procedure TfrmOptions.ResetScanTab;
var
  i, j: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'ResetScanTab', ClassName);
  try
    try
      if gbxScanProperties.Enabled then
      begin
        cbxScannerName.ItemIndex := -1;
//        cbxScannerName.Text := '';
        cbxColorMode.ItemIndex := -1;
        cbxColorMode.Text := '';
        cbxCompression.ItemIndex := -1;
        cbxCompression.Text := '';
        cbxDPI.ItemIndex := -1;
        cbxDPI.Text := '';
        trbBrightness.Position := 0;
        edtBrightness.Text := '0';
        trbContrast.Position := 0;
        edtContrast.Text := '0';
        trbThreshold.Position := 0;
        edtThreshold.Text := '0';
        chkADF.Checked := False;
        chkDuplex.Checked := False;
        chkStacked.Checked := False;
        chkInvers.Checked := False;
        chkIgnoreTWAINError.Checked := False;
        chkDeletePage.Checked := False;
        edtDeletePages.Text := '0';
        edtDeletePages.Enabled := False;
        lblDeletePages.Enabled := False;
        rgpProfilType.ItemIndex := -1;
        chkDefaultProfile.Checked := False;
        cbxFilter.ItemIndex := -1;
        edtFrameLeft.Text := '0';
        edtFrameTop.Text := '0';
        edtFrameRight.Text := '0';
        edtFrameBottom.Text := '0';

        cbxFormat.ItemIndex := -1;
        cbxOrientation.ItemIndex := -1;
        cbxTransfer.ItemIndex := -1;
        chkCompatibleMode.Checked := False;

        FillScannerCombo;

        actDeleteProfile.Enabled := False;

        for i := 0 to gbxScanProperties.ControlCount - 1 do
        begin
          if (gbxScanProperties.Controls[i] is TSpTBXGroupBox) then
          begin
            for j := 0 to TSpTBXGroupBox(gbxScanProperties.Controls[i]).ControlCount - 1 do
              TSpTBXGroupBox(gbxScanProperties.Controls[i]).Controls[j].Enabled := False;
          end;
          gbxScanProperties.Controls[i].Enabled := False;
        end;
//        rgpScanBy.Caption := '';
//        rgpProfilType.Caption := '';
        gbxScanProperties.Enabled := False;
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'ResetScanTab', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ResetScanTab', ClassName);
  end;
end;

procedure TfrmOptions.rgpProfilTypeClick(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].GlobalProfile := (rgpProfilType.ItemIndex = 0);
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'rgpProfilTypeClick', ClassName);
  end;
end;

procedure TfrmOptions.rgpScanByClick(Sender: TObject);
begin
  try
    if (not FShow) and (not FScanProfileChange) then
    begin
      bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex].
        ScannerID := rgpScanBy.ItemIndex;
      actEnableModifyOptions.Execute;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'rgpScanByClick', ClassName);
  end;
end;

(*
  if ((Key = 9) and (ssCtrl in Shift) and (ssShift in Shift)) then
  begin
    if tcOptions.ActiveTabIndex > 0 then
      tcOptions.ActiveTabIndex := tcOptions.ActiveTabIndex - 1
    else if tcOptions.ActiveTabIndex = 0 then
      tcOptions.ActiveTabIndex := tcOptions.Items.Count - 1;
  end
  else if ((Key = 9) and (ssCtrl in Shift)) then
  begin
    if tcOptions.ActiveTabIndex < tcOptions.Items.Count - 1 then
      tcOptions.ActiveTabIndex := tcOptions.ActiveTabIndex + 1
    else if tcOptions.ActiveTabIndex = tcOptions.Items.Count - 1 then
      tcOptions.ActiveTabIndex := 0;
  end;*)

procedure TfrmOptions.trbBrightnessChange(Sender: TObject);
begin
  try
    edtBrightness.Text := IntToStr(trbBrightness.Position);
  except
    edtBrightness.Text := '0';
  end;
end;

procedure TfrmOptions.trbContrastChange(Sender: TObject);
begin
  try
    edtContrast.Text := IntToStr(trbContrast.Position);
  except
    edtContrast.Text := '0';
  end;
end;

procedure TfrmOptions.trbThresholdChange(Sender: TObject);
begin
  try
    edtThreshold.Text := IntToStr(trbThreshold.Position);
  except
    edtThreshold.Text := '0';
  end;
end;

procedure TfrmOptions.FillCombosWithObjects;
begin
  // bentigt weil gnugettext zwar die Items neu setzt, aber die Objects dabei lscht.
  // sonst funktionieren die ganzen IndexOfObject nicht mehr

  cbxDefaultArchiveGroupRights.Clear;
  cbxDefaultArchiveGroupRights.Items := RoleList;

  cbxDefaultAddfieldGroupRights.Clear;
  cbxDefaultAddfieldGroupRights.Items := FieldRights;

  cbxDefaultStatefieldGroupRights.Clear;
  cbxDefaultStatefieldGroupRights.Items := FieldRights;

  cbxAutoZoom.Items.Clear;
  cbxAutoZoom.Items.AddObject(_(sCaptionAutoZoomOrig), TObject(0));
  cbxAutoZoom.Items.AddObject(_(sCaptionAutoZoomAuto),TObject(1));
  cbxAutoZoom.Items.AddObject(_(sCaptionAutoZoomWidth), TObject(2));
  cbxAutoZoom.Items.AddObject(_(sCaptionAutoZoomHeight), TObject(5));
  cbxAutoZoom.Items.AddObject(_(sCaptionAutoZoomSelection), TObject(3));
  cbxAutoZoom.Items.AddObject(_(sCaptionAutoZoomOff), TObject(4));
  cbxAutoZoom.Items.AddObject(_(sCaptionAutoZoomLastSetting), TObject(6));

end;

procedure TfrmOptions.FillCompressionCombo;
begin
  try
    cbxCompression.Items.Clear;

    if cbxColorMode.ItemIndex = 0 then    // Schwarz-Weiss
    begin
      cbxCompression.Items.AddObject(sCaptionCCITT4, TObject(cmpCCITT4));
      cbxCompression.Items.AddObject(sCaptionLZW, TObject(cmpLZW));
    end
    else if cbxColorMode.ItemIndex = 1 then     // Grau 4bit
    begin
      cbxCompression.Items.AddObject(sCaptionPackBits, TObject(cmpPackBits));
      cbxCompression.Items.AddObject(sCaptionLZW, TObject(cmpLZW));
    end
    else if ((cbxColorMode.ItemIndex = 2) or      // Grau 8bit
      (cbxColorMode.ItemIndex = 3)) then   // Farbe
    begin
      cbxCompression.Items.AddObject(sCaptionJPG, TObject(cmpJPG));
      cbxCompression.Items.AddObject(sCaptionPackBits, TObject(cmpPackBits));
      cbxCompression.Items.AddObject(sCaptionLZW, TObject(cmpLZW));
    end;

    cbxCompression.ItemIndex := 0;

    if cbxColorMode.ItemIndex <> 3 then
    begin
      lblFilter.Enabled := True;
      grbFilter.Enabled := True;
      cbxFilter.Enabled := True;
    end
    else
    begin
      lblFilter.Enabled := False;
      grbFilter.Enabled := False;
      cbxFilter.Enabled := False;
    end;

    cbxCompression.Text := '';
  except
    bitfarmLog.Write(llNormal, ltException, 'FillCompressionCombo', ClassName);
  end;
end;

procedure TfrmOptions.SetOneGeneralSearchOption(Active: TSpTBXCheckBox);
var
  i: Integer;
begin
  try
    with bitfarmApp.ViewerOptions.SearchOptions do
    begin
      if ((not FulltextSearch) and (not DocTagsSearch) and (not AnnoTxtSearch) and (not FieldTxtSearch)) then
      begin
        chkFulltextSearch.Checked := True;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetOneGeneralSearchOption', ClassName);
  end;
end;

procedure TfrmOptions.SetResubTab;
var
  i: Integer;
  lst: TStringList;
begin
  try
    ResetResubTab;

    chkResubOnStartup.Checked := bitfarmApp.ViewerOptions.ResubOptions.ResubOnStartup;
    chkResubTimer.Checked := bitfarmApp.ViewerOptions.ResubOptions.ResubTimer;
    cbbTimerInterval.ItemIndex := cbbTimerInterval.Items.IndexOf(IntToStr(bitfarmApp.ViewerOptions.ResubOptions.ResubTimerInterval));
    cbbTimerInterval.Enabled := chkResubTimer.Checked;
    chkReturnToSender.Checked := bitfarmApp.ViewerOptions.ResubOptions.ReturnToSender;
    chkEmailReminder.Checked := bitfarmApp.ViewerOptions.ResubOptions.Emailreminder;
    chkNotifyByMail.Checked := bitfarmApp.ViewerOptions.ResubOptions.NotifyByMail;
    chkShowAllAddfieldsResub.Checked := bitfarmApp.ViewerOptions.ResubOptions.ShowAllAddfields;
    chkResubFavsInPreview.Checked := bitfarmApp.ViewerOptions.ResubOptions.ResubFavsInPreview;

    chkColumnTitle.Checked := bitfarmApp.ViewerOptions.ResubOptions.ColumnTitle;
    chkColumnInfo.Checked := bitfarmApp.ViewerOptions.ResubOptions.ColumnInfo;
    chkColumnComment.Checked := bitfarmApp.ViewerOptions.ResubOptions.ColumnComment;
    chkColumnAlarm.Checked := bitfarmApp.ViewerOptions.ResubOptions.ColumnAlarm;
    chkColumnModified.Checked := bitfarmApp.ViewerOptions.ResubOptions.ColumnModified;
    chkColumnDocDate.Checked := bitfarmApp.ViewerOptions.ResubOptions.ColumnDocDate;

    fraCreateResub.cbbUser.Items := DBGetUserlist(0, 0, True, True);
    fraCreateResub.cbbGroup.Items := DBGetGrouplist(0, 0, True, True);
    bitfarmApp.FillResubFavCombo(cbbName);
    if cbbName.Items.Count > 0 then
    begin
      cbbName.ItemIndex := 0;
      btnDeleteResub.Enabled := True;
      cbbname.OnChange(nil);
    end;
  except

    bitfarmLog.Write(llNormal, ltException, 'SetResubTab', ClassName);
  end;
end;

end.

