unit PasswordForm;

interface

uses
  gnugettext, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SpTBXControls, StdCtrls, SpTBXEditors, SpTBXItem;

type
  TfrmPassword = class(TForm)
    SpTBXLabel1: TSpTBXLabel;
    SpTBXLabel2: TSpTBXLabel;
    SpTBXLabel3: TSpTBXLabel;
    edtOldPassword: TSpTBXEdit;
    edtConfirm: TSpTBXEdit;
    btnOK: TSpTBXButton;
    btnCancel: TSpTBXButton;
    edtnewPassword: TSpTBXEdit;
    SpTBXPanel1: TSpTBXPanel;
    procedure btnOKClick(Sender: TObject);
    procedure edtPasswordKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edtPasswordKeyPress(Sender: TObject; var Key: Char);
    function CheckPassword: Boolean;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    OldPassword : WideString;
    MustChange : Boolean;
  end;

implementation

uses
  {$IFDEF ENTERPRISE}
    bitfarm_enterprise,
  {$ELSE}
    bitfarm_core,
  {$ENDIF}
  bfaCommonMethods, bfaCommonDialogs
  ;
{$R *.dfm}

procedure TfrmPassword.btnOKClick(Sender: TObject);
begin
  if CheckPassword then
    ModalResult := mrOk
  else
    Abort;
end;

procedure TfrmPassword.edtPasswordKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key = ';') then
  begin
    BfShowMessage(_('Ein Semikolon kann nicht im Passwort verwendet werden!'));
    Key := #0;
    Abort;
  end;
end;

procedure TfrmPassword.FormCreate(Sender: TObject);
begin
  TranslateComponent(Self, 'ViewerV36');
  MustChange := False;
end;

procedure TfrmPassword.FormShow(Sender: TObject);
begin
  if OldPassword = '' then
  begin
    SpTBXLabel1.Enabled := False;
    edtOldPassword.Enabled := False;
    edtnewPassword.SetFocus;
  end else
    edtOldPassword.SetFocus;
  if MustChange then
    btnCancel.Enabled := False;
end;

function TfrmPassword.CheckPassword: Boolean;
begin
  Result := False;
  try
    if Pos(';', edtOldPassword.Text) > 0 then
    begin
      BfShowMessage(_('Ein Semikolon kann nicht im Passwort verwendet werden!'));
      edtOldPassword.Text := '';
      Exit;
    end;

    if Pos(';', edtNewPassword.Text) > 0 then
    begin
      BfShowMessage(_('Ein Semikolon kann nicht im Passwort verwendet werden!'));
      edtNewPassword.Text := '';
      Exit;
    end;

    if Pos(';', edtConfirm.Text) > 0 then
    begin
      BfShowMessage(_('Ein Semikolon kann nicht im Passwort verwendet werden!'));
      edtConfirm.Text := '';
      Exit;
    end;

    edtOldPassword.Text := ParseSQLString(edtOldPassword.Text);
    edtNewPassword.Text := ParseSQLString(edtNewPassword.Text);
    edtConfirm.Text := ParseSQLString(edtConfirm.Text);

    if EnCrypt(edtOldPassword.Text, GlobalKey) <> OldPassword then
    begin
      BfShowMessage(_('Das alte Passwort stimmt nicht'));
      edtOldPassword.SetFocus;
      Exit;
    end;

    if edtNewPassword.Text <> edtConfirm.Text then
    begin
      BfShowMessage(_('Das neue Passwort stimmt nicht berein'));
      edtConfirm.SetFocus;
      Exit;
    end;
    Result := True;

  finally

  end;
end;

procedure TfrmPassword.edtPasswordKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then
    btnOKClick(Sender);
end;


end.
