unit PreviewDlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, SpTBXEditors, SpTBXControls, SpTBXItem, ImgList, ieview,
  imageenview, ievect, ComCtrls, Generics.Collections, Printers, Vcl.Menus,
  TB2Item,
  {$IFDEF IMAGEEN1140}
  hyiedefs, hyieutils, iexBitmaps, iesettings, iexLayers, iexRulers,
  iexToolbars, iexUserInteractions, imageenio, imageenproc, iexProcEffects,
  {$ENDIF}
  bfaImageEnVect, bfaImageEnMView;

type
  TPreviewDlgType = (dlgPrint, dlgSave, dlgEmail);

  TfrmPreviewDlg = class(TForm)
    SpTBXPanel1: TSpTBXPanel;
    grpBorders: TSpTBXGroupBox;
    lblTop: TSpTBXLabel;
    edtTop: TSpTBXSpinEdit;
    lblBottom: TSpTBXLabel;
    edtBottom: TSpTBXSpinEdit;
    lblLeft: TSpTBXLabel;
    edtLeft: TSpTBXSpinEdit;
    lblRight: TSpTBXLabel;
    edtRight: TSpTBXSpinEdit;
    grpSize: TSpTBXGroupBox;
    cbx_Size: TSpTBXComboBox;
    lbl_SHeight: TSpTBXLabel;
    lbl_SWidth: TSpTBXLabel;
    nedt_SWidth: TSpTBXSpinEdit;
    nedt_SHeight: TSpTBXSpinEdit;
    grpOptions: TSpTBXGroupBox;
    chkAnnos: TSpTBXCheckBox;
    chkStationery: TSpTBXCheckBox;
    chkCenter: TSpTBXCheckBox;
    chkRotate: TSpTBXCheckBox;
    btnAddStationery: TSpTBXButton;
    btnRemoveStationery: TSpTBXButton;
    chkMergeDocuments: TSpTBXCheckBox;
    rbnPublic: TSpTBXRadioButton;
    rbnPrivate: TSpTBXRadioButton;
    grpPages: TSpTBXGroupBox;
    rbnAll: TSpTBXRadioButton;
    rbnFromTo: TSpTBXRadioButton;
    lblCopies: TSpTBXLabel;
    edtCopies: TSpTBXSpinEdit;
    chkSort: TSpTBXCheckBox;
    lblFrom: TSpTBXLabel;
    edtFrom: TSpTBXSpinEdit;
    lblTo: TSpTBXLabel;
    edtTo: TSpTBXSpinEdit;
    rbnSeiten: TSpTBXRadioButton;
    edtPages: TSpTBXEdit;
    rbnSelected: TSpTBXRadioButton;
    grpPreview: TSpTBXGroupBox;
    img_PreView: TbfaImageEnVect;
    btnPrevious: TSpTBXButton;
    btnNext: TSpTBXButton;
    lblPage: TSpTBXLabel;
    lblMergedPage: TSpTBXLabel;
    grpFileType: TSpTBXGroupBox;
    rbnTIF: TSpTBXRadioButton;
    rbnPDF: TSpTBXRadioButton;
    rbnSaveOriginal: TSpTBXRadioButton;
    grpEmailType: TSpTBXGroupBox;
    rbnAttachment: TSpTBXRadioButton;
    rbnLink: TSpTBXRadioButton;
    dlgOpenFile: TOpenDialog;
    SpTBXPanel2: TSpTBXPanel;
    btnProperties: TSpTBXButton;
    btnPrint: TSpTBXButton;
    btnCancel: TSpTBXButton;
    btnReset: TSpTBXButton;
    popSharedLayer: TSpTBXPopupMenu;
    procedure cbx_SizeChange(Sender: TObject);
    procedure btnPropertiesClick(Sender: TObject);
    procedure rbnAllClick(Sender: TObject);
    procedure edtFromChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure nedt_SWidthValueChanged(Sender: TObject);
    procedure nedt_SHeightValueChanged(Sender: TObject);
    procedure edtTopValueChanged(Sender: TObject);
    procedure edtBottomValueChanged(Sender: TObject);
    procedure edtLeftValueChanged(Sender: TObject);
    procedure edtRightValueChanged(Sender: TObject);
    procedure chkAnnosClick(Sender: TObject);
    procedure chkStationeryClick(Sender: TObject);
    procedure chkCenterClick(Sender: TObject);
    procedure chkRotateClick(Sender: TObject);
    procedure edtCopiesValueChanged(Sender: TObject);
    procedure chkSortClick(Sender: TObject);
    procedure btnAddStationeryClick(Sender: TObject);
    procedure btnRemoveStationeryClick(Sender: TObject);
    procedure edtToChange(Sender: TObject);
    procedure edtPagesChange(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure btnPreviousClick(Sender: TObject);
    procedure chkMergeDocumentsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure edtPagesKeyPress(Sender: TObject; var Key: Char);
    procedure rbnSaveOriginalClick(Sender: TObject);
    procedure btnResetClick(Sender: TObject);
    procedure rbnAttachmentClick(Sender: TObject);
    procedure rbnPublicClick(Sender: TObject);
    procedure edtFromExit(Sender: TObject);
    procedure edtToExit(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure popSharedLayerPopup(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    { Private declarations }
    FShow, FClick : Boolean;
    FDocCount, FPageCount, FMaxPage, FActPage : Integer;
    FStationeryPath : WideString;
    FDlgType : TPreviewDlgType;
    FDocPages : TStringList;

    procedure DrawPreview;
    procedure SetSelectedPages;
    procedure SetPageLabel;
    procedure SetMaxPage;
    procedure SetDlgType(Value : TPreviewDlgType);
    function IsPageValid(iDoc, iPage: integer): Boolean;
    function DoSelectedPagesExist: Boolean;
    procedure DrawCornerResizeGrabHandle;
    procedure OnPopupSharedLayerClick(Sender: TObject);
  public
    { Public declarations }
    Documents : TList;
    PrnName : string; //13.12.2017 Ticket 12890
    Prn : TPrinter;
    PrivateLayer : Int64;
    procedure SetGroup(Grp : TspTbxGroupBox; Enable : Boolean);

    property DlgType : TPreviewDlgType read FDlgType write SetDlgType;
    property StationeryPath : WideString read FStationeryPath;
  end;

var
  frmPreviewDlg: TfrmPreviewDlg;

implementation

uses
  MainForm, bfaProcessing, bfaObjects36, bfaCommonImageEN, bfaLog,
  MainDataModule, bfaCommonUtils, bfaCommonDialogs, bfaCommonStyles,
  bfaApplication, gnugettext
  {$IFDEF IMAGEEN1140}
  , iexClasses
  {$ELSE}
  , hyieutils, imageenio
  {$ENDIF}
  ;

{$R *.dfm}

procedure TfrmPreviewDlg.SetGroup(Grp : TspTbxGroupBox; Enable : Boolean);
var
  i : Integer;
begin
  try
    for i := 0 to Grp.ComponentCount - 1 do
      TWinControl(Grp.Components[i]).Enabled := Enable;
    Grp.Enabled := Enable;
    if grp = grpSize then
    begin
      cbx_Size.Enabled := Enable;
    end
    else if grp = grpOptions then
    begin
      chkCenter.Checked := False;
      chkCenter.Enabled := Enable;
      chkRotate.Checked := False;
      chkRotate.Enabled := Enable;
      chkAnnos.Checked := False;
//      chkannos.Enabled := Enable;
//       SetGroup(grpAnnos, False);
      rbnPublic.Enabled := False;
      rbnPrivate.Enabled := False;
      chkStationery.Checked := False;
      chkStationery.Enabled := Enable;
      chkMergeDocuments.Checked := False;
      chkMergeDocuments.Enabled := Enable;
    end
    else if grp = grpPages then
    begin
      rbnAll.Enabled := Enable;
      rbnSelected.Enabled := Enable;
      rbnSeiten.Enabled := Enable;
      rbnFromTo.Enabled := Enable;
      lblCopies.Enabled := Enable and (FDlgType = dlgPrint);
      edtCopies.Enabled := Enable and (FDlgType = dlgPrint);
      chkSort.Enabled := Enable and (FDlgType = dlgPrint);
      lblFrom.Enabled := rbnFromTo.Checked;
      LblTo.Enabled := rbnFromTo.Checked;
      edtFrom.Enabled := rbnFromTo.Checked;
      edtTo.Enabled := rbnFromTo.Checked;
    end
    else if grp = grpPreview then
    begin
      lblPage.Enabled := Enable;
      lblMergedPage.Enabled := Enable;
      img_PreView.Visible := Enable;
//    end
//    else if grp = grpAnnos then
//    begin
//      rbnPublic.Enabled := Enable;
//      rbnPrivate.Enabled := Enable;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetGroup', ClassName);
  end;
end;

procedure TfrmPreviewDlg.SetDlgType(Value : TPreviewDlgType);
begin
  FShow := True;
  try
    FDlgType := Value;
    if (FDlgType <> dlgPrint) and (rbnSaveOriginal.Checked) then
    begin
      SetGroup(grpOptions, False);
      SetGroup(grpPages, False);
      SetGroup(grpPreview, False);
    end
    else
    begin
      if FDlgType = dlgPrint then
      begin
        rbnTIF.Enabled := False;
        rbnPDF.Enabled := False;
        SetGroup(grpBorders, True);
        SetGroup(grpSize, True);
        SetGroup(grpFileType, False);
        SetGroup(grpEmailType, False);
        SetGroup(grpOptions, True);
        SetGroup(grpPages, True);
        SetGroup(grpPreview, True);
        btnProperties.Visible := True;
        chkCenter.Enabled := True;
        chkRotate.Enabled := True;
  //      lblTop.Enabled := True;
  //      edtTop.Enabled := True;
  //      lblBottom.Enabled := True;
  //      edtBottom.Enabled := True;
  //      lblLeft.Enabled := True;
  //      edtLeft.Enabled := True;
  //      lblRight.Enabled := True;
  //      edtRight.Enabled := True;
        rbnSaveOriginal.Enabled := False;
        rbnAttachment.Enabled := False;
        rbnLink.Enabled := False;

        edtCopies.Text := '1';

      end
      else if FDlgType = dlgSave then
      begin
  //      grpSize.Enabled := False;
        cbx_Size.Enabled := False;
        SetGroup(grpBorders, False);
        SetGroup(grpSize, False);
        SetGroup(grpFileType, True);
        SetGroup(grpEmailType, True);
        SetGroup(grpOptions, True);
        SetGroup(grpPages, True);
        SetGroup(grpPreview, True);

        btnProperties.Visible := False;
        chkCenter.Checked := False;
        chkCenter.Enabled := False;
        chkRotate.Checked := False;
        chkRotate.Enabled := False;
  //      lblTop.Enabled := False;
  //      edtTop.Enabled := False;
  //      lblBottom.Enabled := False;
  //      edtBottom.Enabled := False;
  //      lblLeft.Enabled := False;
  //      edtLeft.Enabled := False;
  //      lblRight.Enabled := False;
  //      edtRight.Enabled := False;

        rbnTIF.Enabled := True;
        rbnPDF.Enabled := True;
        rbnSaveOriginal.Enabled := (Documents <> nil) and (Documents.Count > 0) and
          (TbfaDocument(Documents[0]).OriLoc <> '') and (TbfaDocument(Documents[0]).OriStream <> nil) and
          (TbfaDocument(Documents[0]).OriStream.Size > 0);
        rbnAttachment.Enabled := False;
        rbnLink.Enabled := False;

        edtCopies.Text := '1';

      end
      else if FDlgType = dlgEmail then
      begin
  ///      grpSize.Enabled := False;
        cbx_Size.Enabled := False;
        SetGroup(grpBorders, False);
        SetGroup(grpSize, False);
        SetGroup(grpFileType, True);
        SetGroup(grpEmailType, True);
        SetGroup(grpOptions, True);
        SetGroup(grpPages, True);
        SetGroup(grpPreview, True);

        btnProperties.Visible := False;
        chkCenter.Checked := False;
        chkCenter.Enabled := False;
        chkRotate.Checked := False;
        chkRotate.Enabled := False;
  //      lblTop.Enabled := False;
  //      edtTop.Enabled := False;
  //      lblBottom.Enabled := False;
  //      edtBottom.Enabled := False;
  //      lblLeft.Enabled := False;
  //      edtLeft.Enabled := False;
  //      lblRight.Enabled := False;
  //      edtRight.Enabled := False;

        rbnTIF.Enabled := True;
        rbnPDF.Enabled := True;
  //      grbFileType.Enabled := True;
        rbnSaveOriginal.Enabled := (Documents <> nil) and (Documents.Count > 0) and
          (TbfaDocument(Documents[0]).OriLoc <> '') and (TbfaDocument(Documents[0]).OriStream <> nil) and
          (TbfaDocument(Documents[0]).OriStream.Size > 0);
        rbnAttachment.Enabled := True;
        rbnLink.Enabled := False;
  //      grbEmailTyp.Enabled := True;
        edtCopies.Text := '1';
      end;
    end;

    with bitfarmApp.ViewerOptions.PreviewDlgOptions do
    begin
      if grpSize.Enabled then
      begin
        cbx_Size.ItemIndex := PageSize;
        cbx_SizeChange(Self);
      end;
      if grpBorders.Enabled then
      begin
        nedt_SWidth.Value := PageWidth;
        nedt_SWidth.Text := FloatToStr(PageWidth);
        nedt_SHeight.Value := PageHeight;
        nedt_SHeight.Text := FloatToStr(PageHeight);
        edtTop.Value := BorderTop;
        edtTop.Text := FloatToStr(BorderTop);
        edtBottom.Value := BorderBottom;
        edtBottom.Text := FloatToStr(BorderBottom);
        edtLeft.Value := BorderLeft;
        edtLeft.Text := FloatToStr(BorderLeft);
        edtRight.Value := BorderRight;
        edtRight.Text := FloatToStr(BorderRight);
      end;
      chkAnnos.Checked := chkannos.Enabled and Annos;
      rbnPublic.Checked := PubAnnos;
      rbnPrivate.Checked := PrivAnnos;
      chkStationery.Checked := chkStationery.Enabled and Stationery;
      chkCenter.Checked := chkCenter.Enabled and Center;
      chkRotate.Checked := chkRotate.Enabled and Rotate;
      if edtCopies.Enabled then
      begin
//06.02.2018 Ticket 13416        edtCopies.Value := 1;
//28.05.2018 Ticket         edtCopies.Text := IntToStr(bitfarmApp.ViewerOptions.PreviewDlgOptions.Copies);
//        edtCopies.Value := bitfarmApp.ViewerOptions.PreviewDlgOptions.Copies;
        edtCopies.Text := '1';
        edtCopies.Value := 1;
      end;
      chkSort.Checked := chksort.Enabled and False;
      chkMergeDocuments.Checked := chkMergeDocuments.Enabled and Merge;
      rbnTIF.Checked := (FileType = 0);
      rbnPDF.Checked := (FileType = 1);
      rbnSaveOriginal.Checked := rbnSaveOriginal.Checked and (FileType = 2);
//      if (not rbnTIF.checked) and (not rbnPDF) and (not r)

      rbnAttachment.Checked := (EmailType = 0);
      rbnLink.Checked := (EmailType = 1);

    end;

    if ((FDlgType = dlgEmail) or (FDlgType = dlgSave)) and (not FClick) then
      if bitfarmApp.ViewerOptions.GeneralOptions.ExportPDF then
        rbnPDF.Checked := True;

    SetMaxPage;

//04.08.2017    if (FDlgType = dlgEmail) or (FDlgType = dlgSave) then
      cbx_Size.ItemIndex := 1;

  finally
    FShow := False;
  end;
end;

procedure TfrmPreviewDlg.btnAddStationeryClick(Sender: TObject);
begin
//  dlgOpenFile.InitialDir := ;
  if dlgOpenFile.Execute then
  begin
    FStationeryPath := dlgOpenFile.FileName;
    btnAddStationery.Hint := FStationeryPath;
    btnRemoveStationery.Enabled := True;
    DrawPreview;
  end;
end;


function TfrmPreviewDlg.DoSelectedPagesExist: Boolean;
Var
  i: integer;
  s: string;
  sl: TStringList;
begin
  Result := false;

  for i := 0 to Documents.Count - 1 do
  begin
    if TbfaDocument(Documents[i]).SelectedPages.Count > 0 then
    begin
      Result := true;
      break;
    end;
  end;
end;

function TfrmPreviewDlg.IsPageValid(iDoc, iPage: integer): Boolean;
Var
  i: integer;
  s: string;
  sl: TStringList;
  bFound: Boolean;
begin
  Result := true;

  if rbnAll.Checked then
    exit;

  if iDoc < Documents.Count then
  begin
    bFound := false;
    sl := TbfaDocument(Documents[iDoc]).SelectedPages; // Performance
    for i := 0 to sl.Count - 1 do
    begin
      if StrToIntDef(sl[i], 0) = iPage then
      begin
        bFound := true;
        break;
      end;
    end;
    Result := bFound;
  end;
end;

procedure TfrmPreviewDlg.btnNextClick(Sender: TObject);
var
  iSavePageCount: integer;
  iSaveDocCount: integer;
  iSaveActPage: integer;

  procedure GoToNextPageIndices;
  begin
    //15.01.2016  if FPageCount < TbfaDocument(Documents[FDocCount]).PageCount then
    if FPageCount < StrToInt(FDocPages[FDocCount]) then   // Page < PageMax
    begin
      Inc(FPageCount);
      Inc(FActPage);
    end
    //15.01.2016  else if (FPageCount = TbfaDocument(Documents[FDocCount]).PageCount) then
    else if (FPageCount = StrToInt(FDocPages[FDocCount])) then   // Page = PageMax
    begin
      if FDocCount < Documents.Count - 1 then
      begin
        Inc(FDocCount);
        Inc(FActPage);
      end
      else
      begin
        FDocCount := 0;
        FActPage := 1;
      end;
      FPageCount := 1;
    end
    else
      begin                                                       // Page > PageMax
      FDocCount := 0;
      FPageCount := 1;
      FActPage := 1;
    end;
  end;

begin
  iSavePageCount := FPageCount;
  iSaveDocCount := FDocCount;
  iSaveActPage := FActPage;

  GoToNextPageIndices; // Eine Seite Vor

  while  not IsPageValid(FDocCount, FPageCount) do
  begin
    GoToNextPageIndices; // Eine Seite Vor

    if    (iSavePageCount = FPageCount)       // Abbruch, damit wir nicht in eine Endlosschleife kommen.
      and (iSaveDocCount = FDocCount)
      and (iSaveActPage = FActPage) then
      break;
  end;

  DrawPreview;
end;

procedure TfrmPreviewDlg.btnPreviousClick(Sender: TObject);
var
  iSavePageCount: integer;
  iSaveDocCount: integer;
  iSaveActPage: integer;

  procedure GoToPreviousPageIndices;
  begin
  if FPageCount > 1 then
  begin
    Dec(FPageCount);
    Dec(FActPage);
  end
  else if (FPageCount = 1) then
  begin
    if FDocCount > 0 then
    begin
      Dec(FDocCount);
      Dec(FActPage);
    end
    else
    begin
      FDocCount := Documents.Count - 1;
      FActPage := FMaxPage;
    end;
  //    FPageCount := TbfaDocument(Documents[FDocCount]).PageCount;
    FPageCount := StrToInt(FDocPages[FDocCount]);
  end
  else
  begin
    FDocCount := Documents.Count - 1;
    FPageCount := FMaxPage;
    FActPage := FMaxPage;
  end;
  end;


begin
  iSavePageCount := FPageCount;  // Speichere Indizes
  iSaveDocCount := FDocCount;
  iSaveActPage := FActPage;

  GoToPreviousPageIndices; // Eine Seite Zurck

  while not IsPageValid(FDocCount, FPageCount)  do
  begin
    GoToPreviousPageIndices;

    if    (iSavePageCount = FPageCount)       // Abbruch, damit wir nicht in eine Endlosschleife kommen.
      and (iSaveDocCount = FDocCount)
      and (iSaveActPage = FActPage) then
      break;

  end;
  DrawPreview; //
end;

procedure TfrmPreviewDlg.btnPropertiesClick(Sender: TObject);
var
  ADevice, ADriver, APort : string;
  iDummy  : THandle;
  xPrnDlg : TPrintDialog;
  str : string;
begin
  xPrnDlg := TPrintDialog.Create(nil);
  try
    if xPrnDlg.Execute then
    begin
      try
        DrawPreView;

        {$IF CompilerVersion >= 26}
        PrnName := TbfaPrinter(Prn).Clone(Printer);
        {$ELSE}
        SetLength(ADevice, 200);
        SetLength(ADriver, 200);
        SetLength(APort, 200);
        Printer.GetPrinter(PChar(ADevice), PChar(ADriver), PChar(APort), idummy);
        PrnName := ADevice;
        Prn.SetPrinter(PChar(ADevice), PChar(ADriver), PChar(APort), idummy);
        Prn := TPrinter.Create;
        Prn.Clone(Printer);
        {$IFEND}

        Caption := 'Druck-Vorschau - ' + PrnName;
        edtCopies.Text := IntToStr(xPrnDlg.Copies);
        edtCopies.Value := xPrnDlg.Copies;
        chkSort.Checked := xPrnDlg.Collate;
      except
        bitfarmLog.Write(llNormal, ltException, 'btnPropertiesClick', ClassName);
      end;
    end;
  finally
    FreeAndNil(xPrnDlg);
  end;
end;

procedure TfrmPreviewDlg.btnRemoveStationeryClick(Sender: TObject);
begin
  FStationeryPath := '';
  btnRemoveStationery.Enabled := False;
  btnAddStationery.Hint := FStationeryPath;
  DrawPreview;
end;

procedure TfrmPreviewDlg.btnResetClick(Sender: TObject);
begin
  DlgType := FDlgType;
  FShow := True;
  try

    rbnTIF.Checked := True;
    bitfarmApp.ViewerOptions.PreviewDlgOptions.FileType := 0;

    rbnAttachment.Checked := True;
    bitfarmApp.ViewerOptions.PreviewDlgOptions.EmailType := 0;

    rbnAll.Checked := True;

    chkAnnos.Checked := False;
    bitfarmApp.ViewerOptions.PreviewDlgOptions.Annos := chkAnnos.Checked;

    chkStationery.Checked := False;
    bitfarmApp.ViewerOptions.PreviewDlgOptions.Stationery := chkStationery.Checked;

    chkCenter.Checked := False;
    bitfarmApp.ViewerOptions.PreviewDlgOptions.Center := chkCenter.Checked;

    chkRotate.Checked := False;
    bitfarmApp.ViewerOptions.PreviewDlgOptions.Rotate := chkRotate.Checked;

    chkSort.Checked := False;
    bitfarmApp.ViewerOptions.PreviewDlgOptions.Sort := chkSort.Checked;

    chkMergeDocuments.Checked := False;
    bitfarmApp.ViewerOptions.PreviewDlgOptions.Merge := chkMergeDocuments.Checked;

    rbnAllClick(Self);
    DrawPreview;
  finally
    FShow := False;
  end;
end;

procedure TfrmPreviewDlg.cbx_SizeChange(Sender: TObject);
begin
  if not FShow then
  begin
    bitfarmApp.ViewerOptions.PreviewDlgOptions.PageSize := cbx_Size.ItemIndex;
  end;

  if cbx_Size.ItemIndex = 3 then
  begin
    lbl_SWidth.Enabled := True;
    lbl_SHeight.Enabled := True;
    nedt_SWidth.Enabled := True;
    nedt_SHeight.Enabled := True;
  end
  else
  begin
    lbl_SWidth.Enabled := False;
    lbl_SHeight.Enabled := False;
    nedt_SWidth.Enabled := False;
    nedt_SHeight.Enabled := False;
  end;
  if not FShow then
  begin
    DrawPreView;
  end;
end;

procedure TfrmPreviewDlg.chkAnnosClick(Sender: TObject);
begin
  if not FShow then
  begin
    bitfarmApp.ViewerOptions.PreviewDlgOptions.Annos := chkAnnos.Checked;
    DrawPreview;
  end;
//  SetGroup(grpAnnos, chkAnnos.Checked);
  rbnPublic.Enabled := chkAnnos.Checked;
  rbnPrivate.Enabled := chkAnnos.Checked;
end;

procedure TfrmPreviewDlg.chkCenterClick(Sender: TObject);
begin
  if not FShow then
  begin
    bitfarmApp.ViewerOptions.PreviewDlgOptions.Center := chkCenter.Checked;
    DrawPreview;
  end;
end;

procedure TfrmPreviewDlg.chkMergeDocumentsClick(Sender: TObject);
begin
  if not FShow then
  begin
    bitfarmApp.ViewerOptions.PreviewDlgOptions.Merge := chkMergeDocuments.Checked;
    DrawPreview;
  end;
end;

procedure TfrmPreviewDlg.chkRotateClick(Sender: TObject);
begin
  if not FShow then
  begin
    bitfarmApp.ViewerOptions.PreviewDlgOptions.Rotate := chkRotate.Checked;
    DrawPreview;
  end;
end;

procedure TfrmPreviewDlg.chkSortClick(Sender: TObject);
begin
  if not FShow then
  begin
    bitfarmApp.ViewerOptions.PreviewDlgOptions.Sort := chkSort.Checked;
  end;
end;

procedure TfrmPreviewDlg.chkStationeryClick(Sender: TObject);
begin
  if not FShow then
  begin
    bitfarmApp.ViewerOptions.PreviewDlgOptions.Stationery := chkStationery.Checked;
    DrawPreview;
  end;
  if chkStationery.Checked then
    btnAddStationery.Enabled := True;
end;

procedure TfrmPreviewDlg.DrawPreview;
var
  MStream : TMemoryStream;
  img : TbfaImageEnVect;
  VPos: TIEVerticalPos;
  HPos: TIEHorizontalPos;
  SSize: TIESize;
  fBLeft, fBTop, fBRight, fBBottom, fWidth, fHeight : Double;
  priv, pub : Boolean;
  FPreviewDoc : TbfaDocument;
  Lst : TList<TbfaDocument>;
  Layer : Int64;
begin
  Layer := -1;
  Screen.Cursor := crHourGlass;
  try
    try
      img_Preview.Clear;

      VPos := ievpTOP;
      HPos := iehpLEFT;

      case cbx_Size.ItemIndex of
        0:
           SSize := iesNORMAL;
        1:
           SSize := iesFITTOPAGE;
        2:
           SSize := iesFITTOPAGESTRETCH;
        3:
           SSize := iesSPECIFIEDSIZE;
      else
        SSize := iesFITTOPAGE;
      end;

      if chkCenter.Checked then
      begin
        VPos := ievpCENTER;
        HPos := iehpCENTER;
      end;

      MStream := TMemoryStream.Create;
      img := CreateInvisibleVect(nil);
      Lst := TList<TbfaDocument>.Create;
      FPreviewDoc := TbfaDocument.Create;
      try
        FPreviewDoc.Clone(TbfaDocument(Documents[FDocCount]));
        FPreviewDoc.SelectedPages.Clear;
        FPreviewDoc.SelectedPages.Add(IntToStr(FPageCount));
        Lst.Add(FPreviewDoc);
        with bitfarmApp.ViewerOptions.PreviewDlgOptions do
        begin
          if Annos then
          begin
            if rbnPublic.Checked then
            begin
              Layer := 0;
              pub := True;
              priv := False;
            end
            else
            begin
//              Layer := bitfarmApp.User.ID;
              Layer := PrivateLayer;
              pub := False;
              priv := True;
            end;
          end
          else
          begin
            pub := False;
            priv := False;
            Layer := 0;
          end;
          MStream := bfaImageRendering(nil, Lst,
            Stationery, priv, Pub, Layer, Copies, Sort, nil, FStationeryPath);

          MStream.Position := 0;
          img.IO.LoadFromStream(MStream);

          if edtLeft.Value <> 0.00 then
            fBLeft := (edtLeft.Value * Zoll) else fBLeft := 0;
          if edtTop.Value <> 0.00 then
            fBTop := (edtTop.Value * Zoll) else fBTop := 0;
          if edtRight.Value <> 0.00 then
            fBRight := (edtRight.Value * Zoll) else fBRight := 0;
          if edtBottom.Value <> 0.00 then
            fBBottom := (edtBottom.Value * Zoll) else fBBottom := 0;
          if nedt_SWidth.Value <> 0.00 then
            fWidth := (nedt_SWidth.Value * Zoll) else fWidth := 0;
          if nedt_SHeight.Value <> 0.00 then
            fHeight := (nedt_SHeight.Value * Zoll) else fHeight := 0;

          if chkRotate.Checked then
          begin
            if (img.IO.Params.Height < img.IO.Params.Width) then
            begin
              if Printers.Printer.Orientation <> poLandscape then
                img.Proc.Rotate(90);
            end
            else
            begin
              if Printers.Printer.Orientation <> poPortrait then
                img.Proc.Rotate(-90);
            end;
          end;

          img.IO.PreviewPrintImage(
            img_Preview.Bitmap, 400, 544,
//            {$IF CompilerVersion >= 26}
//13.06.2019            bfaPrinters.Printer,
            nil,
//            {$ELSE}
//            Printers.Printer,
//            {$IFEND}
            fBLeft, fBTop, fBRight, fBBottom, VPos, HPos, SSize, fWidth,
            fHeight, 1);

        end;
        img_Preview.Update;

        SetPageLabel;
      finally
        MStream.Free;
        img.Free;
        FPreviewDoc.Free;
        FPreviewDoc := nil;
        Lst.Clear;
        Lst.Free;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'DrawPreview', ClassName);
    end;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TfrmPreviewDlg.edtBottomValueChanged(Sender: TObject);
begin
  if not FShow then
  begin
    bitfarmApp.ViewerOptions.PreviewDlgOptions.BorderBottom := edtBottom.Value;
    DrawPreview;
  end;
end;

procedure TfrmPreviewDlg.edtCopiesValueChanged(Sender: TObject);
var
  s: String;
  iValue, iCode: Integer;
begin
  if not FShow then
  begin
    bitfarmApp.ViewerOptions.PreviewDlgOptions.Copies := Round(edtCopies.Value);
  end;

  if Assigned(chkSort) then
  begin
    // 19.03.2018 Ticket 13987 -->
    s := edtCopies.Text;
    val(s, iValue, iCode);
    if (iCode = 0) and (iValue > 1) then // Integer und > 1
      chkSort.Enabled := True
    else
    begin
      chkSort.Checked := False;
      chkSort.Enabled := False;
    end;
    // 19.03.2018 Ticket 13987 <--
  end;
end;

procedure TfrmPreviewDlg.edtFromChange(Sender: TObject);
begin
  if (Assigned(edtFrom) and Assigned(edtTo)) then
  begin
    edtTo.SpinOptions.MinValue := edtFrom.SpinOptions.Value;

    if edtTo.SpinOptions.Value < edtTo.SpinOptions.MaxValue then
      edtTo.SpinOptions.Value := edtTo.SpinOptions.MaxValue;

    SetSelectedPages;
  end;
end;

procedure TfrmPreviewDlg.edtLeftValueChanged(Sender: TObject);
begin
  if not FShow then
  begin
    bitfarmApp.ViewerOptions.PreviewDlgOptions.BorderLeft := edtLeft.Value;
    DrawPreview;
  end;
end;

procedure TfrmPreviewDlg.edtPagesChange(Sender: TObject);
begin
  if Assigned(edtPages) then
  begin
    SetSelectedPages;
  end;
end;

procedure TfrmPreviewDlg.edtPagesKeyPress(Sender: TObject; var Key: Char);
var
  input, lastCharacter, pageNumber: string;
  number, i, count: Integer;
  success: Boolean;
  sl: TStringList;

begin
  // 28.03.2019 Ticket 18703  -->
  if not(Key in [#8, #13, '0' .. '9', ',', '-']) then
    Key := #0
  else
  begin
    // Abfrage auf ungltige Zeichenkombinationen
    pageNumber := '';
    input := edtPages.Text;
    // x-y-z verhindern nur x-y erlauben
    if (Key = '-') then
    begin
      sl := TStringList.Create;
      sl.StrictDelimiter := True;
      sl.Delimiter := ',';
      sl.DelimitedText := edtPages.Text;
      input := sl.DelimitedText;
      count := 0;
      // wenn zwischen zwei Kommata mehr als ein Minus dann Key = #0
      if (Length(input) > 0) then
      begin
        for i := 1 to Length(input) do
        begin
          if input[i] = ',' then
            // neuer Teil durch Komma getrennt
            count := 0;
          if input[i] = '-' then
            Inc(count);
        end;
        // zweites '-' wird verworfen
        if (count > 0) then
          Key := #0;
      end;
    end;
    // ',,' und '--' und ',-' und '-,' und '-0' und fhrende '0' werden verworfen
    if ((((Key = ',') or (Key = '-') or (Key = '0')) and
      ((AnsiLastChar(input) = ',') or (AnsiLastChar(input) = '-'))) or
      ((Length(edtPages.Text) = 0) and ((Key = ',') or (Key = '-') or
      (Key = '0')))) then
      Key := #0;
    // leere Eingabe fhrt nicht zum Click
    // if ((Key = #13) and (edtPages.Text <> '')) then
    if (Key = #13) then
    // vermeiden das letztes Zeichen Komma zu leerer Ausgabe fhrt
    // Komma wird verworfen
    begin
      if (AnsiLastChar(input) = ',') then
      begin
        input := edtPages.Text;
        Delete(input, Length(input), 1);
        edtPages.Text := input;
      end;
      btnPrint.Click;
    end;
    // Prfe ob Zahl kleiner Seitenzahl des Dokumentes ist
    if (Key in ['0' .. '9']) then
    begin
      // wenn schon eine Eingabe erfolg ist, berprfen ob Zahl am Ende
      // d.h. ob wir eine Zahl eventuell vergrssern
      if (Length(input) > 0) then
      begin
        pageNumber := Key;
        lastCharacter := Copy(input, Length(input), 1);
        // wenn letztes Zeichen vor Eingabe auch Zahl
        success := TryStrToInt(lastCharacter, number);
        if (success) then
        // Eingabe zurck auf Zahl durchsuchen und zu einer Zahl zusammensetzen
        // solange bis anderes Zeichen auftritt
        begin
          repeat
            pageNumber := lastCharacter + pageNumber;
            SetLength(input, Length(input) - 1);
            lastCharacter := Copy(input, Length(input), 1);
            success := TryStrToInt(lastCharacter, number);
          until not(success);
        end;
      end;
      // wenn keine Zahl vorhanden war wird direkt zugewiesen
      if (pageNumber = '') then
        pageNumber := Key;
      // wenn Zahl grsser als max. Seitenzahl dann Eingabe verwerfen
      if (StrToInt(pageNumber) > FMaxPage) then
        Key := #0;
    end;
  end;
  // 28.03.2019 Ticket 18703  <--
end;

procedure TfrmPreviewDlg.edtRightValueChanged(Sender: TObject);
begin
  if not FShow then
  begin
    bitfarmApp.ViewerOptions.PreviewDlgOptions.BorderRight := edtRight.Value;
    DrawPreview;
  end;
end;

procedure TfrmPreviewDlg.edtToChange(Sender: TObject);
begin
  if (Assigned(edtFrom) and Assigned(edtTo)) then
  begin
    SetSelectedPages;
  end;
end;


procedure TfrmPreviewDlg.edtFromExit(Sender: TObject);
begin
  if (edtFrom.Value > edtTo.Value) then
     edtFrom.Value := edtTo.Value;

  if edtFrom.Value > edtFrom.SpinOptions.MaxValue then
    edtFrom.Value := edtFrom.SpinOptions.MaxValue;
end;

procedure TfrmPreviewDlg.edtToExit(Sender: TObject);
begin
   if (edtTo.Value < edtFrom.Value) then
     edtTo.Value := edtFrom.Value;

  if edtTo.Value > edtTo.SpinOptions.MaxValue then
    edtTo.Value := edtTo.SpinOptions.MaxValue;
end;

procedure TfrmPreviewDlg.edtTopValueChanged(Sender: TObject);
begin
  if not FShow then
  begin
    bitfarmApp.ViewerOptions.PreviewDlgOptions.BorderTop := edtTop.Value;
    DrawPreview;
  end;
end;

procedure TfrmPreviewDlg.FormClose(Sender: TObject; var Action: TCloseAction);
// 01.04.2019 Ticket 18703  -->
var
  input: string;

begin
  try
    if ModalResult = mrOk then
      if edtPages.Text <> '' then
      begin
        //wenn das letzte Zeichen ein Komma ist, wird es gelscht
        input := edtPages.Text;
        if (AnsiLastChar(input) = ',') then
        begin
          input := edtPages.Text;
          Delete(input, Length(input), 1);
          edtPages.Text := input;
        end;
       // 01.04.2019 Ticket 18703 <--
      end;
       bitfarmApp.ViewerOptions.SavePreviewDlgOptions(True)
  except

  end;
end;

procedure TfrmPreviewDlg.FormCreate(Sender: TObject);
begin
  TranslateComponent(Self, 'ViewerV36');
  Prn := TPrinter.Create;
  PrnName := '';
  SetDlgType(dlgPrint);
  PrivateLayer := bitfarmApp.User.ID;
end;

procedure TfrmPreviewDlg.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if ((Key = VK_ESCAPE) and btnCancel.Visible and btnCancel.Enabled) then
    btnCancel.Click;
end;

procedure TfrmPreviewDlg.FormPaint(Sender: TObject);
begin
  DrawCornerResizeGrabHandle;
end;

procedure TfrmPreviewDlg.DrawCornerResizeGrabHandle;
var
  DC: HDC;
  rect: TRect;
begin
  DC:=GetDC(Handle);
  rect := self.ClientRect;
  rect.Top := rect.Bottom-15;
  rect.left := rect.Right-15;

  DrawFrameControl ( DC, Rect , DFC_SCROLL, DFCS_SCROLLSIZEGRIP );
end;

procedure TfrmPreviewDlg.FormShow(Sender: TObject);
var
  i, PCount: Integer;
  img : TbfaImageEnMView;
  Tiff : TIETIFFHandler;
  nottif : Boolean;
begin
  try
    FShow := True;
    FClick := False;
    FDocCount := 0;
    FPageCount := 1;
    FActPage := 1;
    FStationeryPath := '';
    FDocPages := TStringList.Create;
    DlgType := FDlgType;
    rbnAllClick(Self);
    Tiff := TIETIFFHandler.Create;
    img := TbfaImageEnMView.Create(nil);
    try
      for i := 0 to Documents.Count - 1 do
      begin
        if (TbfaDocument(Documents[i]) <> nil) and
           (TbfaDocument(Documents[i]).ScanPoolView <> nil) and
           (TbfaDocument(Documents[i]).ScanPoolViewLoaded) then
        begin
          FDocPages.Add(IntToStr(TbfaDocument(Documents[i]).ScanPoolView.ImageCount));
        end
        else
        begin
//05.10.2023 ich glaube, dass das hier falsch ist          if (TbfaDocument(Documents[i]).FileType = '.tif') or (TbfaDocument(Documents[i]).FileType = '.tiff') then
          if not ((TbfaDocument(Documents[i]).FileType = '.tif') or (TbfaDocument(Documents[i]).FileType = '.tiff')) then
            nottif := True;
          if (TbfaDocument(Documents[i]).FileType = '.tif') or
           (TbfaDocument(Documents[i]).FileType = '.tiff') then
          begin
            TbfaDocument(Documents[i]).DocStream.Position := 0;
            Tiff.ReadStream(TbfaDocument(Documents[i]).DocStream);
            PCount := Tiff.GetPagesCount;
            if PCount = 0 then
              nottif := True
            else
            begin
              nottif := False;
              FDocPages.Add(IntToStr(Tiff.GetPagesCount));
            end;
          end;

          if nottif then
          begin
            img.Clear;
            TbfaDocument(Documents[i]).DocStream.Position := 0;
            img.MIO.LoadFromStream(TbfaDocument(Documents[i]).DocStream);
            FDocPages.Add(IntToStr(img.ImageCount));
          end;
        end;
      end;
    finally
      tiff.Free;
      tiff := nil;
      img.Free;
      img := nil;
    end;

    // sollten wir ein PrivateLayer Popup haben, dann suchen wir den Namen des angezeigten Layers
    if popSharedLayer.Items.Count > 0 then
    begin
      for i := 0 to popSharedLayer.Items.Count -1 do
      begin
        popSharedLayer.Items[i].OnClick := OnPopupSharedLayerClick;
        if popSharedLayer.Items[i].Tag = PrivateLayer then
          rbnPrivate.Caption := popSharedLayer.Items[i].Caption;
      end;
    end;

    DrawPreview;
    edtCopiesValueChanged(Sender);

    // Briefpapier nur enablen, wenn auch im Mainform enabled ist.
    chkStationery.Enabled := frmMainForm.actStationery.Enabled;
    if not chkStationery.Enabled then
      chkStationery.Checked := false;

    Self.Color := stlControl.Color;
    Self.Font.Color := stlControl.TextColor;
    cbx_Size.Color := stlControl.Color;
    cbx_Size.Font.Color := stlControl.TextColor;
    nedt_SWidth.Color := stlControl.Color;
    nedt_SWidth.Font.Color := stlControl.TextColor;
    nedt_SHeight.Color := stlControl.Color;
    nedt_SHeight.Font.Color := stlControl.TextColor;
    edtTop.Color := stlControl.Color;
    edtTop.Font.Color := stlControl.TextColor;
    edtBottom.Color := stlControl.Color;
    edtBottom.Font.Color := stlControl.TextColor;
    edtLeft.Color := stlControl.Color;
    edtLeft.Font.Color := stlControl.TextColor;
    edtRight.Color := stlControl.Color;
    edtRight.Font.Color := stlControl.TextColor;
    edtFrom.Color := stlControl.Color;
    edtFrom.Font.Color := stlControl.TextColor;
    edtCopies.Color := stlControl.Color;
    edtCopies.Font.Color := stlControl.TextColor;
    edtTo.Color := stlControl.Color;
    edtTo.Font.Color := stlControl.TextColor;
    edtPages.Color := stlControl.Color;
    edtPages.Font.Color := stlControl.TextColor;

  finally
    FShow := False;
  end;
end;

procedure TfrmPreviewDlg.SetPageLabel;
var
  PageCount: Integer;
begin
  if (FDocPages.Count > 0) and (FDocPages.Count >= FDocCount) then
    PageCount := FDocPages[FDocCount].ToInteger
  else
    PageCount := 1;

  lblPage.Caption := 'Doc: ' + IntToStr(FDocCount + 1) + '/' + IntToStr(Documents.Count) + '  Page: ' +
//  IntToStr(FPageCount) + '/' + IntToStr(TbfaDocument(Documents[FDocCount]).PageCount);
  IntToStr(FPageCount) + '/' + PageCount.ToString;
  lblMergedPage.Caption := 'ActPage: ' + IntToStr(FActPage) + '/' + IntToStr(FMaxPage);
end;

procedure TfrmPreviewDlg.SetMaxPage;
var
  i, PCount : Integer;
  tiff : TIETIFFHandler;
  im : TbfaImageEnMView;
begin
  tiff := TIETIFFHandler.Create;
  try
    FMaxPage := 0;
    if Documents <> nil then
    begin
      for i := 0 to Documents.Count - 1 do
      begin
//26.07.2018 Ticket 14576 -->
        if (TbfaDocument(Documents[i]).ScanPoolView <> nil) and (TbfaDocument(Documents[i]).ScanPoolViewLoaded) then
        begin
          FMaxPage := FMaxPage + TbfaDocument(Documents[i]).ScanPoolView.ImageCount;
        end
        else
        begin
//26.07.2018 Ticket 14576 <--
          TbfaDocument(Documents[i]).DocStream.Position := 0;
          tiff.ReadStream(TbfaDocument(Documents[i]).DocStream);
        PCount := tiff.GetPagesCount;
        if PCount = 0 then // 15.08.2018 kein tif Datei ist
        begin
          im := TbfaImageEnMView.Create(nil);
          im.EnableMultiSelect := True;
          try
            TbfaDocument(Documents[i]).DocStream.Position := 0;
            im.MIO.LoadFromStream(TbfaDocument(Documents[i]).DocStream);
            PCount := im.ImageCount;
          finally
            im.Free;
            im := nil;
          end;
        end;
        FMaxPage := FMaxPage + PCount;

        end;
      end;
    end;

    edtFrom.SpinOptions.MaxValue := FMaxPage;
    edtTo.SpinOptions.MaxValue := FMaxPage;

    if FMaxPage > 1 then
    begin
      btnPrevious.Enabled := True;
      btnNext.Enabled := True;
    end;
  finally
    tiff.Free;
  end;
end;

procedure TfrmPreviewDlg.nedt_SHeightValueChanged(Sender: TObject);
begin
  if not FShow then
  begin
    bitfarmApp.ViewerOptions.PreviewDlgOptions.PageHeight := nedt_SHeight.Value;
    DrawPreview;
  end;
end;

procedure TfrmPreviewDlg.nedt_SWidthValueChanged(Sender: TObject);
begin
  if not FShow then
  begin
    bitfarmApp.ViewerOptions.PreviewDlgOptions.PageWidth := nedt_SWidth.Value;
    DrawPreView;
  end;
end;

procedure TfrmPreviewDlg.OnPopupSharedLayerClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'OnPopupSharedLayerClick', ClassName);

  PrivateLayer := TSpTBXItem(Sender).Tag;
  rbnPrivate.Caption := TSpTBXItem(Sender).Caption;
  DrawPreview;

end;

procedure TfrmPreviewDlg.popSharedLayerPopup(Sender: TObject);
begin
  if popSharedLayer.Items.Count = 0 then
    Abort;
end;

procedure TfrmPreviewDlg.rbnAllClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'rbnAllClick', ClassName);
  try
    try
      if rbnAll.Checked then
      begin
        edtFrom.Enabled := False;
        edtTo.Enabled := False;
        lblFrom.Enabled := False;
        lblTo.Enabled := False;
        edtPages.Enabled := False;
        chkMergeDocuments.Enabled := True;
//        if FDlgType = dlgPrint then
//        begin
//          lblCopies.Enabled := True;
//          edtCopies.Enabled := True;
//        end
//        else
//        begin
//          lblCopies.Enabled := False;
//          edtCopies.Enabled := False;
//        end;
      end
      else if rbnSelected.Checked then
      begin
        edtFrom.Enabled := False;
        edtTo.Enabled := False;
        lblFrom.Enabled := False;
        lblTo.Enabled := False;
        edtPages.Enabled := False;
        chkMergeDocuments.Enabled := True;
//        if FDlgType = dlgPrint then
//        begin
//          lblCopies.Enabled := True;
//          edtCopies.Enabled := True;
//        end
//        else
//        begin
//          lblCopies.Enabled := False;
//          edtCopies.Enabled := False;
//        end;
      end
      else if rbnFromTo.Checked then
      begin
        edtFrom.Enabled := True;
        edtTo.Enabled := True;
        lblFrom.Enabled := True;
        lblTo.Enabled := True;
        edtPages.Enabled := False;
        chkMergeDocuments.Checked := True;
        chkMergeDocuments.Enabled := False;
        edtCopies.Text := '1';
//        lblCopies.Enabled := False;
//        edtCopies.Enabled := False;
      end
      else if rbnSeiten.Checked then
      begin
        edtFrom.Enabled := False;
        edtTo.Enabled := False;
        lblFrom.Enabled := False;
        lblTo.Enabled := False;
        edtPages.Enabled := True;
        chkMergeDocuments.Checked := True;
        chkMergeDocuments.Enabled := False;
        edtCopies.Text := '1';
//        lblCopies.Enabled := False;
//        edtCopies.Enabled := False;
      end;
      SetSelectedPages;
    except
      bitfarmLog.Write(llNormal, ltException, 'rbnAllClick', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'rbnAllClick', ClassName);
  end;
end;

procedure TfrmPreviewDlg.rbnAttachmentClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'rbnAttachmentClick', ClassName);
  try
    try
      if not FShow then
      begin
        if  rbnAttachment.Checked then
          bitfarmApp.ViewerOptions.PreviewDlgOptions.EmailType := 0
        else if  rbnLink.Checked then
          bitfarmApp.ViewerOptions.PreviewDlgOptions.EmailType := 1;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'rbnAttachmentClick', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'rbnAttachmentClick', ClassName);
  end;
end;

procedure TfrmPreviewDlg.rbnPublicClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'rbnPublicClick', ClassName);
  try
    try
      if not FShow then
      begin
        bitfarmApp.ViewerOptions.PreviewDlgOptions.PubAnnos := rbnPublic.Checked;
        bitfarmApp.ViewerOptions.PreviewDlgOptions.PrivAnnos := rbnPrivate.Checked;

        DrawPreview;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'rbnPublicClick', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'rbnPublicClick', ClassName);
  end;
end;

procedure TfrmPreviewDlg.rbnSaveOriginalClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'rbnSaveOriginalClick', ClassName);
  try
    try
      if not FShow then
      begin
        FClick := True;
        try
          grpOptions.Enabled := not rbnSaveOriginal.Checked;
          grpPages.Enabled := not rbnSaveOriginal.Checked;
          grpPreview.Enabled := not rbnSaveOriginal.Checked;

          if  rbnTIF.Checked then
            bitfarmApp.ViewerOptions.PreviewDlgOptions.FileType := 0
          else if  rbnPDF.Checked then
            bitfarmApp.ViewerOptions.PreviewDlgOptions.FileType := 1
          else if  rbnSaveOriginal.Checked then
            bitfarmApp.ViewerOptions.PreviewDlgOptions.FileType := 2;

          DlgType := FDlgType;
        finally
          FClick := False;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'rbnSaveOriginalClick', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'rbnSaveOriginalClick', ClassName);
  end;
end;

procedure TfrmPreviewDlg.SetSelectedPages;
var
  i, j, code1, code2, Val1, val2 : Integer;
  str : string;
  Tmp, Tmp2 : TStringList;
begin
  bitfarmLog.DebugBegin(llDebug, 'SetSelectedPages', ClassName);
  try
    try
      if Documents <> nil then
      begin
        if rbnAll.Checked then
        begin
          for i := 0 to Documents.Count - 1 do
          begin
            TbfaDocument(Documents[i]).SelectedPages.Clear;
          end;
        end
        else if rbnSelected.Checked then
        begin
          TbfaDocument(Documents[0]).SelectedPages.Clear;
          if bitfarmapp.GetActivePreview.ThumbnailView.Visible then
          begin
            for i := 0 to bitfarmapp.GetActivePreview.ThumbnailView.MultiSelectedImagesCount - 1 do
              TbfaDocument(Documents[0]).SelectedPages.Add(IntToStr(bitfarmapp.
                GetActivePreview.ThumbnailView.MultiSelectedImages[i] + 1));
          end
          else
          begin
            TbfaDocument(Documents[0]).SelectedPages.Add(
                IntToStr(bitfarmapp.GetActivePreview.SingleView.img_DocView.
                IO.Params.ImageIndex + 1));
          end;

          if     DoSelectedPagesExist
             and not IsPageValid(FDocCount,FPageCount) then
          begin
            btnNext.Click;
          end;
        end
        else if rbnFromTo.Checked then
        begin
          str := '';
//24.03.2017 Ticket 10065          for i := Round(edtFrom.Value) to Round(edtTo.Value) do
          for i := StrToInt(edtFrom.Text) to StrToInt(edtTo.Text) do
          begin
//24.03.2017 Ticket 10065            if i < edtTo.Value then
            if i < StrToInt(edtTo.Text) then
              str := str + IntToStr(i) + ','
            else
              str := str + IntToStr(i);
          end;

          for i := 0 to Documents.Count - 1 do
          begin
            TbfaDocument(Documents[i]).SelectedPages.Clear;
            TbfaDocument(Documents[i]).SelectedPages.CommaText := str;
          end;
        end
        else if rbnSeiten.Checked then
        begin
          Tmp := TStringList.Create;
          try
            str := '';
            if edtPages.Text <> '' then
            begin
              Tmp.CommaText := edtPages.Text;
              for i := 0 to Tmp.Count - 1 do
              begin
                if Pos('-', Tmp[i]) > 0 then
                begin
                  Tmp2 := TStringList.Create;
                  try
                    Tmp2.Delimiter := '-';
                    Tmp2.DelimitedText := Tmp[i];
                    val(Tmp2[0], Val1, code1);
                    val(Tmp2[Tmp2.Count - 1], val2, code2);
                    if ((code1 = 0) and (code2 = 0)) then
                    begin
                      for j := Val1 to val2 do
                      begin
                        if ((j < val2) or (i < Tmp.Count - 1)) then
                          str := str + IntToStr(j) + ','
                        else
                          str := str + IntToStr(j);

                      end;
                    end;
                  finally
                    Tmp2.Free;
                  end;
                end
                else
                begin
                  if (Tmp[i] <> '') then
                  begin
                    val(Tmp[i], Val1, code1);
                    if code1 = 0 then
                    begin
                      if (i < Tmp.Count - 1) then
                        str := str + Tmp[i] + ','
                      else
                        str := str + Tmp[i];
                    end;
                  end;
                end;
              end;
            end;
            for i := 0 to Documents.Count - 1 do
            begin
              TbfaDocument(Documents[i]).SelectedPages.Clear;
              TbfaDocument(Documents[i]).SelectedPages.CommaText := str;
            end;
          finally
            Tmp.Free;
          end;
        end;

        rbnSelected.Hint := TbfaDocument(Documents[0]).SelectedPages.CommaText;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'SetSelectedPages', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetSelectedPages', ClassName);
  end;
end;

end.
