unit PrintDlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, SpTBXEditors, SpTBXControls, SpTBXItem, ImgList, ieview,
  imageenview, ievect, ComCtrls;

type
  TfrmPrintDlg = class(TForm)
    SpTBXGroupBox1: TSpTBXGroupBox;
    SpTBXLabel1: TSpTBXLabel;
    edtTop: TSpTBXSpinEdit;
    SpTBXLabel2: TSpTBXLabel;
    edtBottom: TSpTBXSpinEdit;
    SpTBXLabel3: TSpTBXLabel;
    edtLeft: TSpTBXSpinEdit;
    SpTBXLabel4: TSpTBXLabel;
    edtRight: TSpTBXSpinEdit;
    SpTBXGroupBox2: TSpTBXGroupBox;
    cbx_Size: TSpTBXComboBox;
    lbl_SHeight: TSpTBXLabel;
    lbl_SWidth: TSpTBXLabel;
    nedt_SWidth: TSpTBXSpinEdit;
    nedt_SHeight: TSpTBXSpinEdit;
    SpTBXGroupBox3: TSpTBXGroupBox;
    chkAnnos: TSpTBXCheckBox;
    chkStationery: TSpTBXCheckBox;
    chkCenter: TSpTBXCheckBox;
    chkRotate: TSpTBXCheckBox;
    SpTBXGroupBox4: TSpTBXGroupBox;
    SpTBXGroupBox5: TSpTBXGroupBox;
    img_PreView: TImageEnVect;
    rbnAll: TSpTBXRadioButton;
    rbnFromTo: TSpTBXRadioButton;
    SpTBXLabel5: TSpTBXLabel;
    edtCopies: TSpTBXSpinEdit;
    chkSort: TSpTBXCheckBox;
    chkAll: TSpTBXCheckBox;
    SpTBXButton1: TSpTBXButton;
    SpTBXButton2: TSpTBXButton;
    SpTBXTrackBar1: TSpTBXTrackBar;
    lblFrom: TSpTBXLabel;
    edtFrom: TSpTBXSpinEdit;
    lblTo: TSpTBXLabel;
    edtTo: TSpTBXSpinEdit;
    rbnSeiten: TSpTBXRadioButton;
    edtPages: TSpTBXEdit;
    btnProperties: TSpTBXButton;
    btnPrint: TSpTBXButton;
    btnCancel: TSpTBXButton;
    procedure cbx_SizeChange(Sender: TObject);
    procedure btnPropertiesClick(Sender: TObject);
    procedure rbnAllClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    procedure DrawPreview;
  public
    { Public declarations }
  end;

var
  frmPrintDlg: TfrmPrintDlg;

implementation

uses
  Printers;

{$R *.dfm}

procedure TfrmPrintDlg.btnPropertiesClick(Sender: TObject);
var
  PrnName,
  dummy   : Array[0..255] of char;
  iDummy  : Cardinal;
  xPrnDlg : TPrintDialog;
begin
  xPrnDlg := TPrintDialog.Create (nil);
  try

    if xPrnDlg.Execute then
    begin
      DrawPreView;
      Printer.GetPrinter(PrnName, dummy, dummy, idummy);
      Caption := 'Druck-Vorschau - ' + PrnName;
      edtCopies.Text := IntToStr(Printer.Copies);
      chkSort.Checked := xPrnDlg.Collate;
    end;
  finally
    xPrnDlg.Free;
  end;
end;

procedure TfrmPrintDlg.cbx_SizeChange(Sender: TObject);
begin
   if cbx_Size.ItemIndex = 3 then
   begin
      lbl_SWidth.Enabled := True;
      lbl_SHeight.Enabled := True;
      nedt_SWidth.Enabled := True;
      nedt_SHeight.Enabled := True;
   end
   else
   begin
      lbl_SWidth.Enabled := False;
      lbl_SHeight.Enabled := False;
      nedt_SWidth.Enabled := False;
      nedt_SHeight.Enabled := False;
   end;
   DrawPreView;
end;

procedure TfrmPrintDlg.DrawPreview;
//var
//  VPos: TIEVerticalPos;
//  HPos: TIEHorizontalPos;
//  SSize: TIESize;
//  fBLeft, fBTop, fBRight, fBBottom, fWidth, fHeight : Double;
//begin
//  try
//    VPos := ievpTOP;
//    HPos := iehpLEFT;
//
//    //  fXCoef := frm_Main.fra_Voransicht.img_Voransicht.MeasureCoefX;
//    //  fYCoef := frm_Main.fra_Voransicht.img_Voransicht.MeasureCoefY;
//    case cbx_Size.ItemIndex of
//      0:
//         SSize := iesNORMAL;
//      1:
//         SSize := iesFITTOPAGE;
//      2:
//         SSize := iesFITTOPAGESTRETCH;
//      3:
//         SSize := iesSPECIFIEDSIZE;
//    else
//      SSize := iesFITTOPAGE;
//    end;
//    if tbtn_PTL.Checked then
//    begin
//      VPos := ievpTOP;
//      HPos := iehpLEFT;
//    end
//    else
//    if tbtn_PTM.Checked then
//    begin
//      VPos := ievpTOP;
//      HPos := iehpCENTER;
//    end
//    else
//    if tbtn_PTR.Checked then
//    begin
//      VPos := ievpTOP;
//      HPos := iehpRIGHT;
//    end
//    else
//    if tbtn_PML.Checked then
//    begin
//      VPos := ievpCENTER;
//      HPos := iehpLEFT;
//    end
//    else
//    if tbtn_PMM.Checked then
//    begin
//      VPos := ievpCENTER;
//      HPos := iehpCENTER;
//    end
//    else
//    if tbtn_PMR.Checked then
//    begin
//      VPos := ievpCENTER;
//      HPos := iehpRIGHT;
//    end
//    else
//    if tbtn_PBL.Checked then
//    begin
//      VPos := ievpBOTTOM;
//      HPos := iehpLEFT;
//    end
//    else
//    if tbtn_PBM.Checked then
//    begin
//      VPos := ievpBOTTOM;
//      HPos := iehpCENTER;
//    end
//    else
//    if tbtn_PBR.Checked then
//    begin
//      VPos := ievpBOTTOM;
//      HPos := iehpRIGHT;
//    end;
//
//    if nedt_BLeft.Value <> 0.00 then
//      fBLeft := (nedt_BLeft.Value * Zoll) else fBLeft := 0;
//    if nedt_BTop.Value <> 0.00 then
//      fBTop := (nedt_BTop.Value * Zoll) else fBTop := 0;
//    if nedt_BRight.Value <> 0.00 then
//      fBRight := (nedt_BRight.Value * Zoll) else fBRight := 0;
//    if nedt_BBottom.Value <> 0.00 then
//      fBBottom := (nedt_BBottom.Value * Zoll) else fBBottom := 0;
//    if nedt_SWidth.Value <> 0.00 then
//      fWidth := (nedt_SWidth.Value * Zoll) else fWidth := 0;
//    if nedt_SHeight.Value <> 0.00 then
//      fHeight := (nedt_SHeight.Value * Zoll) else fHeight := 0;
//
//    mDocView.IO. (
//      img_Preview.Bitmap, 260, 360, Printer,
//      fBLeft, fBTop, fBRight, fBBottom, VPos, HPos, SSize,
//      fWidth, fHeight, nedt_OGamma.Value);
//    img_Preview.Update;
//  except
//
//  end;
begin

end;

procedure TfrmPrintDlg.FormShow(Sender: TObject);
begin
  edtFrom.Text := '1';
  edtTo.Text := '1';
  edtPages.Text := '';
  edtCopies.Text := '1';
end;

procedure TfrmPrintDlg.rbnAllClick(Sender: TObject);
begin
  if rbnAll.Checked then
  begin
    edtFrom.Enabled := False;
    edtTo.Enabled := False;
    lblFrom.Enabled := False;
    lblTo.Enabled := False;
    edtPages.Enabled := False;
  end
  else if rbnFromTo.Checked then
  begin
    edtFrom.Enabled := True;
    edtTo.Enabled := True;
    lblFrom.Enabled := True;
    lblTo.Enabled := True;
    edtPages.Enabled := False;
  end
  else if rbnSeiten.Checked then
  begin
    edtFrom.Enabled := False;
    edtTo.Enabled := False;
    lblFrom.Enabled := False;
    lblTo.Enabled := False;
    edtPages.Enabled := True;
  end;
end;

end.
