unit PrivateLayer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CheckLst, SpTBXEditors, SpTBXItem,
  SpTBXControls;


type
  TfrmPrivateLayer = class(TForm)
    lstUser: TSpTBXCheckListBox;
    btnShare: TSpTBXButton;
    btnCancel: TSpTBXButton;
    sptbxgrpbx1: TSpTBXGroupBox;
    chkRead: TSpTBXCheckBox;
    chkWrite: TSpTBXCheckBox;
    chkModify: TSpTBXCheckBox;

    procedure chkModifyClick(Sender: TObject);
    procedure chkWriteClick(Sender: TObject);
    procedure chkReadClick(Sender: TObject);
    procedure btnShareClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure lstUserClickCheck(Sender: TObject);
    procedure lstUserClick(Sender: TObject);
    function GetRight: Integer;
    procedure SetRight(right: Integer);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
     formloaded, settingright : Boolean;
  public
    { Public-Deklarationen }
    selectedUser : Integer;   // 11/11/2020 bfacrm:ticket__show__24052
    lstObjects : TStringList;
    constructor Create(AOwner: TComponent; ownuserid, gdocid: Int64); overload;
  end;

implementation

{$R *.dfm}

uses
  bfaLog, bfaBaseObjects, bfaCommonUtils, bfaCommonDB, Uni, bfaIconsDM, MainDataModule, gnugettext;

procedure TfrmPrivateLayer.btnCancelClick(Sender: TObject);
begin
  Self.ModalResult := mrCancel;
end;

procedure TfrmPrivateLayer.btnShareClick(Sender: TObject);
begin
  Self.ModalResult := mrOk;
end;

procedure TfrmPrivateLayer.chkModifyClick(Sender: TObject);
begin
  if not formloaded then
    Exit;
  if settingright then
    Exit;
  try
    settingright := True;
    if chkModify.Checked then
    begin
      chkRead.Checked := False;
      chkWrite.Checked := False;
    end else
      chkModify.Checked := True;
    settingright := False;
     if lstUser.ItemIndex = -1 then    // bfacrm:ticket__show__24052 11/11/2020
        lstUser.ItemIndex := selectedUser;   // bfacrm:ticket__show__24052 11/11/2020
    TbfaUser(lstObjects.Objects[lstUser.ItemIndex]).Rights := GetRight;
    TbfaUser(lstObjects.Objects[lstUser.ItemIndex]).Modified := True;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkModifyClick', ClassName);
  end;
end;

procedure TfrmPrivateLayer.chkReadClick(Sender: TObject);
begin
  if not formloaded then
    Exit;
  if settingright then
    Exit;
  try
    settingright := True;
    if chkRead.Checked then
    begin
      chkWrite.Checked := False;
      chkModify.Checked := False;
    end else
      chkRead.Checked := True;
    settingright := False;
    if lstUser.ItemIndex = -1 then    // bfacrm:ticket__show__24052 11/11/2020
        lstUser.ItemIndex := selectedUser;   // bfacrm:ticket__show__24052 11/11/2020
    TbfaUser(lstObjects.Objects[lstUser.ItemIndex]).Rights := GetRight;
    TbfaUser(lstObjects.Objects[lstUser.ItemIndex]).Modified := True;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkReadClick', ClassName);
  end;
end;

procedure TfrmPrivateLayer.chkWriteClick(Sender: TObject);
begin
  if not formloaded then
    Exit;
  if settingright then
    Exit;
  try
    settingright := True;
    if chkWrite.Checked then
    begin
      settingright := True;
      chkRead.Checked := False;
      chkModify.Checked := False;

    end else
      chkWrite.Checked  := True;
    settingright := False;
      if lstUser.ItemIndex = -1 then    // bfacrm:ticket__show__24052 11/11/2020
        lstUser.ItemIndex := selectedUser;   // bfacrm:ticket__show__24052 11/11/2020
    TbfaUser(lstObjects.Objects[lstUser.ItemIndex]).Rights := GetRight;
    TbfaUser(lstObjects.Objects[lstUser.ItemIndex]).Modified := True;
  except
    bitfarmLog.Write(llNormal, ltException, 'chkWriteClick', ClassName);
  end;
end;

constructor TfrmPrivateLayer.Create(AOwner: TComponent; ownuserid, gdocid: Int64);
var
  list : TStringList;
  i : Integer;
  userrec : TbfaUser;
  lmq : TUniQuery;
begin
  formloaded := False;
  inherited Create(Owner);
  TranslateComponent(Self, 'ViewerV36');
  btnShare.Images := bfaIcons.ilMainMenu;
//07.09.2020  btnShare.ImageIndex := 195;
  btnShare.ImageIndex := Integer(icoidx_ok);

  btnCancel.Images := bfaIcons.ilMainMenu;
//07.09.2020  btnCancel.ImageIndex := 194;
  btnCancel.ImageIndex := Integer(icoidx_abort);
  lstObjects := TStringList.Create;
//  lstObjects.Sorted := True;
//  lstUser.Sorted := True;
  list := DBGetUserlist(0, ownuserid, True, True);
  list.Sort;
  for i := 0 to list.Count -1 do
  begin
    userrec := TbfaUser.Create;
    userrec.Name := list[i];
    userrec.ID := Integer(list.Objects[i]);
    userrec.Rights := 0;
    userrec.Modified := False;

    lstUser.Items.Add(list[i]);
    lstObjects.AddObject(list[i], userrec)

  end;

  lstUser.Items := list;

  lmq := DbCreateQuery;
  lmq.SQL.Text := Format('select userid, rights+0 from sys_docxs where gdocid = %d and src_userid = %d', [gdocid, ownuserid]);
  try
     lmq.Execute;

     if lmq.RecordCount > 0 then
     begin
        while not lmq.Eof do
        begin
          for i := 0 to lstObjects.Count -1 do
          begin
            if TbfaUser(lstObjects.Objects[i]).ID = lmq.FieldByName('userid').AsInteger then
            begin
                if (lmq.FieldByName('rights+0').AsInteger and 2121728) > 0 then
                begin
                  TbfaUser(lstObjects.Objects[i]).Rights := lmq.FieldByName('rights+0').AsInteger;
                  lstUser.Checked[i] := True;
                  selectedUser := i ; // bfacrm:ticket__show__24052 11/11/2020
                end;
                Break;
            end;
          end;

          lmq.Next;
        end;
     end;

  finally
    lmq.Free;
  end;
  formloaded := True;
end;


procedure TfrmPrivateLayer.FormCreate(Sender: TObject);
begin
// Ticket 24621   Dies fhrte zu dem Fehler: Die Liste und die Vorauswahl luft in der Create(),
// danach erst luft die FormCreate, durch das TranslateComponent wurde die Liste wieder zurckgesetzt
//  TranslateComponent(Self, 'ViewerV36');
end;

function TfrmPrivateLayer.GetRight: Integer;
begin
  Result := 0;
  if chkRead.Checked then
    Result := Result or rightAPRead;
  if chkWrite.Checked then
    Result := Result or rightAPWrite;
  if chkModify.Checked then
    Result := Result or rightAPModify;
end;

procedure TfrmPrivateLayer.lstUserClick(Sender: TObject);
var
  userrec : TbfaUser;
  id :Integer;
begin
  try
    SetRight(TbfaUser(lstObjects.Objects[lstUser.ItemIndex]).Rights);
  except
    bitfarmLog.Write(llNormal, ltException, 'lstUserClick', ClassName);
  end;
end;

procedure TfrmPrivateLayer.lstUserClickCheck(Sender: TObject);
begin
  //OutputDebugString('lstUserClickCheck');
  TbfaUser(lstObjects.Objects[lstUser.ItemIndex]).Modified := True;
  if lstUser.Checked[lstUser.ItemIndex] then
  begin
     TbfaUser(lstObjects.Objects[lstUser.ItemIndex]).Rights := GetRight;
     if TbfaUser(lstObjects.Objects[lstUser.ItemIndex]).Rights = 0 then
        chkRead.Checked := True;

  end else
     TbfaUser(lstObjects.Objects[lstUser.ItemIndex]).Rights := 0;
  SetRight(TbfaUser(lstObjects.Objects[lstUser.ItemIndex]).Rights);
end;

procedure TfrmPrivateLayer.SetRight(right: Integer);
begin
  settingright := True;
  try
    chkRead.Checked := (right and rightAPRead) = rightAPRead;
    chkWrite.Checked := (right and rightAPWrite) = rightAPWrite;
    chkModify.Checked := (right and rightAPModify) = rightAPModify;
  finally
    settingright := False;
  end;
end;

end.

