unit ProfileForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SpTBXControls, StdCtrls, SpTBXEditors, SpTBXItem,
  bfaApplication, cxImageComboBox;

type
  TfrmProfileForm = class(TForm)
    pnl1: TSpTBXPanel;
    lblProfilename: TSpTBXLabel;
    rgpProfilType: TSpTBXRadioGroup;
    edtProfileName: TSpTBXEdit;
    btnCreate: TSpTBXButton;
    btnCancel: TSpTBXButton;
    procedure edtProfileNameKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure btnCreateClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    FcbxScanProfile : TcxImageComboBox;
  public
    { Public declarations }

    property cbx : TcxImageComboBox read FcbxScanProfile write FcbxScanProfile;
  end;

var
  frmProfileForm: TfrmProfileForm;

implementation

uses
  bfaOptions, gnugettext, MainDataModule, bfaCommonDialogs;

{$R *.dfm}

procedure TfrmProfileForm.FormCreate(Sender: TObject);
begin
  TranslateComponent(Self, 'ViewerV36');
end;

procedure TfrmProfileForm.btnCreateClick(Sender: TObject);
var
  Scanner : TbfaScanner;
  i : Integer;
  found : Boolean;
begin
  try
    Scanner := TbfaScanner.Create;
    Scanner.GlobalProfile := (rgpProfilType.ItemIndex = 0);
    Scanner.ProfileName := edtProfileName.Text;

    i := 0;
    found := False;
    while ((not found) and ( i <= bitfarmApp.ScannerProfiles.Container.Count - 1)) do
    begin
      if bitfarmApp.ScannerProfiles.Container[i].ProfileName = edtProfileName.Text then
        found := True;
      Inc(i);
    end;

    if (not found) then
    begin

      bitfarmApp.ScannerProfiles.Container.Add(Scanner);

      bitfarmApp.FillScanProfiles(FcbxScanProfile);
  //    FcbxScanProfile.ItemIndex := FcbxScanProfile.Items.Count - 1;
      FcbxScanProfile.ItemIndex := FcbxScanProfile.Properties.Items.Count - 1;
//      FcbxScanProfile.OnChange(FcbxScanProfile);
      FcbxScanProfile.Properties.OnChange(FcbxScanProfile);
      bitfarmApp.RefreshScanCombos(True);

      ModalResult := mrOk;
    end
    else
    begin
      BfMessageDlg(_('Bitte geben Sie ein andere Profilname ein!'), mtError, [mbOK]);
      ModalResult := mrNone;
    end;
  except
    ShowMessage(_('Fehler'));
    ModalResult := mrNone;
  end;
end;

procedure TfrmProfileForm.edtProfileNameKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  Msg: TMsg;
begin
  if (Key = VK_RETURN) then
  begin
    btnCreate.Click;
    PeekMessage(Msg, 0, WM_CHAR, WM_CHAR, PM_REMOVE); // SJ 07.10.2020 - gegen PLING-Ton
  end
  else if (Key = VK_ESCAPE) then
  begin
    btnCancel.Click;
    PeekMessage(Msg, 0, WM_CHAR, WM_CHAR, PM_REMOVE); // SJ 07.10.2020 - gegen PLING-Ton
  end;
end;

procedure TfrmProfileForm.FormShow(Sender: TObject);
begin
  rgpProfilType.ItemIndex := 1;
  edtProfileName.Text := '';
  edtProfileName.SetFocus;
end;

end.
