unit ResubFrameGPL;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SpTBXControls, SpTBXItem, cxGraphics, cxControls, cxLookAndFeels,
  cxLookAndFeelPainters, cxContainer, cxEdit, ComCtrls, dxCore, cxDateUtils,
  cxTextEdit, cxMaskEdit, cxDropDownEdit, cxCalendar, TB2Item, TB2Dock,
  TB2Toolbar, StdCtrls, SpTBXEditors, ImgList, JvImageList, cxStyles,
  TB2ExtItems, Menus, gnugettext, cxSchedulerDateNavigator, cxDateNavigator,
  u_bfaScrollBox, bfaCommonUtils,
  bfaCommonStyles //11.09.2024 SD <--bfacrm:ticket__show__39894
  ;

type
  TfraResub = class(TFrame)
    dropResub: TSpTBXPanel;
    SpTBXLabel1: TSpTBXLabel;
    SpTBXLabel2: TSpTBXLabel;
    ResubScrollBox: TbfaScrollBox;
    btnMyTasks: TSpTBXButton;
    btnDelegateTasks: TSpTBXButton;
    edtResubInfo: TSpTBXEdit;
    edtResubComment: TSpTBXEdit;
    SpTBXLabel3: TSpTBXLabel;
    SpTBXLabel4: TSpTBXLabel;
    SpTBXToolbar1: TSpTBXToolbar;
    tbiResubWork: TSpTBXColorItem;
    cxDateEdit1: TcxDateEdit;
    btnCWNext: TSpTBXButton;
    btnCWPrevious: TSpTBXButton;
    btnShowCW: TSpTBXButton;
    btnResubDone: TSpTBXButton;
    btnResubCancel: TSpTBXButton;
    btnResubForward: TSpTBXButton;
    lblDateOrUser: TSpTBXLabel;
    btnSaveResub: TSpTBXButton;
    popDelegate: TSpTBXPopupMenu;
    tbi1: TSpTBXItem;
    tbi2: TSpTBXItem;
    tbi3: TSpTBXItem;
    tbi4: TSpTBXItem;
    cbbUserGroups: TSpTBXComboBox;
    lblCW: TSpTBXLabel;
    tbiMitarbeiter: TSpTBXItem;
    btnDropDown: TSpTBXButton;
    popMyTasks: TSpTBXPopupMenu;
    tbiMyTasks: TSpTBXItem;
    SpTBXItem2: TSpTBXItem;
    SpTBXItem3: TSpTBXItem;
    SpTBXItem4: TSpTBXItem;
    SpTBXItem5: TSpTBXItem;
    btnDropDownMyTasks: TSpTBXButton;
    procedure dropResubClick(Sender: TObject);
    procedure cxDateNavigator1CustomDrawDayNumber(Sender: TObject;
      ACanvas: TcxCanvas; AViewInfo: TcxSchedulerDateNavigatorDayNumberViewInfo;
      var ADone: Boolean);
    procedure cxDateEdit1PropertiesChange(Sender: TObject);
    procedure edtResubInfoChange(Sender: TObject);
    procedure edtResubCommentChange(Sender: TObject);
    procedure tbiDelegateClick(Sender: TObject);
    procedure tbiResubWorkClick(Sender: TObject);
    procedure cbbUserGroupsDrawBackground(Sender: TObject; ACanvas: TCanvas;
      ARect: TRect; const PaintStage: TSpTBXPaintStage;
      var PaintDefault: Boolean);
    procedure cbbUserGroupsDrawItem(Sender: TObject; ACanvas: TCanvas;
      var ARect: TRect; Index: Integer; const State: TOwnerDrawState;
      const PaintStage: TSpTBXPaintStage; var PaintDefault: Boolean);
    procedure cbbUserGroupsDrawItemBackground(Sender: TObject; ACanvas: TCanvas;
      var ARect: TRect; Index: Integer; const State: TOwnerDrawState;
      const PaintStage: TSpTBXPaintStage; var PaintDefault: Boolean);
    procedure cbbUserGroupsChange(Sender: TObject);
    procedure cxDateNavigator1Click(Sender: TObject);
    procedure cxDateNavigator1PeriodChanged(Sender: TObject; const AStart,
      AFinish: TDateTime);
    procedure edtResubInfoDblClick(Sender: TObject);
    procedure tbiMyTasksClick(Sender: TObject);
    procedure cbbUserGroupsKeyPress(Sender: TObject; var Key: Char);
    procedure edtResubInfoKeyPress(Sender: TObject; var Key: Char);
    procedure edtResubCommentKeyPress(Sender: TObject; var Key: Char);

  private
    { Private-Deklarationen }
    FLoadResub : Boolean;
    FDelegateView: Integer;  // 0 = gesamt, 1= offen, 2= in Arbeit, 3= fertig
    FMyTasksView: Integer;  // 0 = gesamt, 1= offen, 2= in Arbeit, 3= fertig
    procedure SetLoadResub(const Value: Boolean);
    procedure SetDelegateView(const Value: Integer);
    procedure SetMyTasksView(const Value: Integer);

  public
    { Public-Deklarationen }
    cxDateNavigator1 : TcxDateNavigator;
//22.02.2022    Modified: Boolean;
    ResubKind: TbfaResubKind; //22.02.2022 von bfaApplication hier eingebaut
    FloatingFrame : Boolean;
    IndexUserPos: Integer;  // ab diese Position stehen in der ccbUserGroups die User;
    procedure EnableControls(enable: Boolean);

    constructor Create(AOwner : TComponent);

    property DelegateView: Integer read FDelegateView write SetDelegateView;
    property MyTasksView: Integer read FMyTasksView write SetMyTasksView;
    property LoadResub: Boolean read FLoadResub write SetLoadResub;

  end;

implementation

{$R *.dfm}

uses
  MainForm, MainDataModule, bfaIconsDM, u_EditInfo, DateUtils, bfaCommonMethods,
  bfaBaseObjects; //26.06.2024 SD <--bfacrm:ticket__show__39118

procedure TfraResub.cbbUserGroupsChange(Sender: TObject);
begin
  if not FloatingFrame then
  begin
    if bitfarmApp.CurrentContainer.Count = 0 then
      Exit;
    if FLoadResub then
      Exit;
  end else
  begin
    if frmMainForm.fraFloatingResub.grdResubResultlistDevExView.Controller.SelectedRowCount = 0 then
      Exit;

  end;
  //22.02.2022Modified := True;
  btnSaveResub.Enabled := True;
end;

procedure TfraResub.cbbUserGroupsDrawBackground(Sender: TObject;
  ACanvas: TCanvas; ARect: TRect; const PaintStage: TSpTBXPaintStage;
  var PaintDefault: Boolean);
begin
  //OutputDebugString('cbbUserGroupsDrawBackground');
end;

procedure TfraResub.cbbUserGroupsDrawItem(Sender: TObject; ACanvas: TCanvas;
  var ARect: TRect; Index: Integer; const State: TOwnerDrawState;
  const PaintStage: TSpTBXPaintStage; var PaintDefault: Boolean);
begin
  if PaintStage = pstPrePaint then
    Inc(ARect.Left, 16);
end;

procedure TfraResub.cbbUserGroupsDrawItemBackground(Sender: TObject;
  ACanvas: TCanvas; var ARect: TRect; Index: Integer;
  const State: TOwnerDrawState; const PaintStage: TSpTBXPaintStage;
  var PaintDefault: Boolean);
begin
  if Index >= IndexUserPos then
    bfaIcons.ilMainMenu.Draw(ACanvas, ARect.Left, ARect.Top, Integer(icoidx_user), True )
  else
    bfaIcons.ilMainMenu.Draw(ACanvas, ARect.Left, ARect.Top, Integer(icoidx_group), True );

end;

procedure TfraResub.cbbUserGroupsKeyPress(Sender: TObject; var Key: Char);
begin
  DisableBeep(Key); //11.03.2024 bfacrm:ticket__show__38134
end;

constructor TfraResub.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FloatingFrame := False;
  ResubKind := rkNone; //22.02.2022
end;

procedure TfraResub.cxDateEdit1PropertiesChange(Sender: TObject);
begin
  try
    if not FloatingFrame then
    begin
      if bitfarmApp.CurrentContainer.Count = 0 then
        Exit;
      if FLoadResub then
        Exit;
    end else
    begin
      if frmMainForm.fraFloatingResub.grdResubResultlistDevExView.Controller.SelectedRowCount = 0 then
        Exit;
    end;
    //22.02.2022 := True;
    btnSaveResub.Enabled := True;
  except

  end;
end;

procedure TfraResub.cxDateNavigator1Click(Sender: TObject);
begin
  if (frmMainform = nil) or (not frmMainform.fAppStarted) then
    Exit;

  bitfarmApp.SetCW(cxDateNavigator1.Date);
  bitfarmApp.RefreshCWLabel(nil, cxDateNavigator1.Date);
//22.02.2022  if bitfarmApp.ResubKind = rkMyTasks then
  if Self.ResubKind = rkMyTasks then
  begin
    if not FloatingFrame then
      bitfarmApp.MyTasksQuery(nil);
//23.02.2022    else
//      frmMainForm.fraFloatingResub.btnMyTasksClick(nil);
  end;
end;

procedure TfraResub.cxDateNavigator1CustomDrawDayNumber(Sender: TObject;
  ACanvas: TcxCanvas; AViewInfo: TcxSchedulerDateNavigatorDayNumberViewInfo;
  var ADone: Boolean);
var
  MyDate : TDateTime;
  rect : TRect;
begin
  if (frmMainform = nil) or (not frmMainform.fAppStarted) then
    Exit;

  if AviewInfo.Date = Date  then
  begin
    rect := AViewInfo.Bounds;
    ACanvas.FillRect(rect, gclRed);
  end;
end;

procedure TfraResub.cxDateNavigator1PeriodChanged(Sender: TObject; const AStart,
  AFinish: TDateTime);
begin
  if (frmMainform = nil) or (not frmMainform.fAppStarted) then
    Exit;
  //26.06.2024 SD -->bfacrm:ticket__show__39118
  if (bitfarmApp.CurrentView <> tvkResub) then
    Exit;
  //26.06.2024 SD <--bfacrm:ticket__show__39118
  try
    bitfarmApp.SetCW(cxDateNavigator1.Date);
    bitfarmApp.RefreshCWLabel(nil, cxDateNavigator1.Date);
    if not FloatingFrame then
    begin
//22.02.2022      if bitfarmApp.ResubKind = rkMyTasks then
      if Self.ResubKind = rkMyTasks then
        bitfarmApp.MyTasksQuery(nil);
    end
    else if frmMainForm.IsFloatingResubShowing then
    begin
      if Self.ResubKind = rkMyTasks then
        frmMainForm.fraFloatingResub.btnMyTasksClick(nil);
    end;
  except

  end;
end;

procedure TfraResub.dropResubClick(Sender: TObject);
begin
  ShowMessage('Drop Resub');
end;

procedure TfraResub.edtResubCommentChange(Sender: TObject);
begin
  if not FloatingFrame then
  begin
    if bitfarmApp.CurrentContainer.Count = 0 then
      Exit;
    if FLoadResub then
      Exit;
  end
  else
  begin
    if frmMainForm.fraFloatingResub.grdResubResultlistDevExView.Controller.SelectedRowCount = 0 then
      Exit;
  end;
  //22.02.2022 := True;
  btnSaveResub.Enabled := True;
end;

procedure TfraResub.edtResubCommentKeyPress(Sender: TObject; var Key: Char);
begin
  DisableBeep(Key); //11.03.2024 bfacrm:ticket__show__38134
end;

procedure TfraResub.edtResubInfoChange(Sender: TObject);
begin
  if not FloatingFrame then
  begin
    if bitfarmApp.CurrentContainer.Count = 0 then
      Exit;
    if FLoadResub then
      Exit;
  end
  else
  begin
    if frmMainForm.fraFloatingResub.grdResubResultlistDevExView.Controller.SelectedRowCount = 0 then
      Exit;

  end;
  //22.02.2022 := True;
  btnSaveResub.Enabled := True;
end;

procedure TfraResub.edtResubInfoDblClick(Sender: TObject);
var
  frmEditInfo: Tfrm_EditInfo;
begin
//  frmEditInfo := Tfrm_EditInfo.Create(nil);
  frmEditInfo := Tfrm_EditInfo.Create(Self.Owner); // bfacrm:ticket__show__35603
  try
    frmEditInfo.FormTyp := 0;
    //11.09.2024 SD -->bfacrm:ticket__show__39894
    frmEditInfo.btn_speichern.ModalResult := mrOk;
    frmEditInfo.Color := stlControl.Color;
    frmEditInfo.Font.Color := stlControl.TextColor;
    frmEditInfo.memo_Info.Color := stlControl.Color;
    frmEditInfo.memo_Info.Font.Color := stlControl.TextColor;
    //11.09.2024 SD <--bfacrm:ticket__show__39894
    frmEditInfo.ShowModal;
  finally
    frmEditInfo.Release;
  end;

end;

procedure TfraResub.edtResubInfoKeyPress(Sender: TObject; var Key: Char);
begin
  DisableBeep(Key); //11.03.2024 bfacrm:ticket__show__38134
end;

procedure TfraResub.EnableControls(enable: Boolean);
begin
  btnMyTasks.Enabled := enable;
  btnDelegateTasks.Enabled := enable;
  edtResubInfo.Enabled := enable;
  edtResubComment.Enabled := enable;
  SpTBXLabel3.Enabled := enable;
  SpTBXLabel4.Enabled := enable;
  SpTBXToolbar1.Enabled := enable;
  tbiResubWork.Enabled := enable;
  cxDateEdit1.Enabled := enable;
  btnCWNext.Enabled := enable;
  btnCWPrevious.Enabled := enable;
  btnShowCW.Enabled := enable;
  btnResubDone.Enabled := enable;
  btnResubCancel.Enabled := enable;
  btnResubForward.Enabled := enable;
  cxDateNavigator1.Enabled := enable;
  lblDateOrUser.Enabled := enable;
  btnSaveResub.Enabled := enable;
end;

procedure TfraResub.SetDelegateView(const Value: Integer);
begin
  FDelegateView := Value;
  case FDelegateView of
    0:
      btnDelegateTasks.Caption := _('del. WVL (offen)');
    1:
      btnDelegateTasks.Caption := _('del. WVL (berfllig)');
    2:
      btnDelegateTasks.Caption := _('del. WVL (in Arbeit)');
    3:
      btnDelegateTasks.Caption := _('del. WVL (fertig)');
    4:
      btnDelegateTasks.Caption := _('del. WVL (Mitarbeiter)');
  end;

end;

procedure TfraResub.SetMyTasksView(const Value: Integer);
begin
  FMyTasksView := Value;
  case FMyTasksView of
    0:
      btnMyTasks.Caption := _('eigene WVL (offen)');
    1:
      btnMyTasks.Caption := _('eigene WVL (berfllig)');
    2:
      btnMyTasks.Caption := _('eigene WVL (in Arbeit)');
    3:
      btnMyTasks.Caption := _('eigene WVL (fertig)');
    4:
      btnMyTasks.Caption := _('eigene WVL (Mitarbeiter)');
  end;

end;

procedure TfraResub.SetLoadResub(const Value: Boolean);
begin
  FLoadResub := Value;
  btnSaveResub.Enabled := False;
end;

procedure TfraResub.tbiMyTasksClick(Sender: TObject);
var
  i : Integer;
begin
  MyTasksView := TSpTBXItem(Sender).Tag;

  for i := 0 to popMyTasks.Items.Count -1 do
    popMyTasks.Items[i].Checked := False;
   TSpTBXItem(Sender).Checked := True;
  if not FloatingFrame then
    frmMainForm.actMyTasks.Execute
  else if frmMainForm.IsFloatingResubShowing then
    frmMainForm.fraFloatingResub.btnMyTasksClick(Sender);
end;

procedure TfraResub.tbiDelegateClick(Sender: TObject);
var
  i : Integer;
begin
  DelegateView := TSpTBXItem(Sender).Tag;

  for i := 0 to popDelegate.Items.Count -1 do
    popDelegate.Items[i].Checked := False;
   TSpTBXItem(Sender).Checked := True;
  if not FloatingFrame then
    frmMainForm.actDelegateTasks.Execute
  else if frmMainForm.IsFloatingResubShowing then
    frmMainForm.fraFloatingResub.btnDelegateTasksClick(Sender);
end;

procedure TfraResub.tbiResubWorkClick(Sender: TObject);
begin
  if not FloatingFrame then
  begin

    if bitfarmApp.CurrentContainer.Count = 0 then
      Exit;

    if FLoadResub then
      Exit;
  end
  else if frmMainForm.IsFloatingResubShowing then
  begin
    if frmMainForm.fraFloatingResub.grdResubResultlistDevExView.Controller.SelectedRowCount = 0 then
      Exit;
  end;

  //22.02.2022 := True;
  btnSaveResub.Enabled := True;

  if tbiResubWork.Color = cColorWhite then
    tbiResubWork.Color := gclYellow
  else
    tbiResubWork.Color := cColorWhite;
end;

end.
