unit ScanFunctions;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, 
  Dialogs, StdCtrls, SpTBXEditors, SpTBXControls,
  SpTBXItem, cxGraphics, cxControls, cxLookAndFeels, cxLookAndFeelPainters,
  cxContainer, cxEdit, cxTextEdit, cxMaskEdit, cxDropDownEdit, cxImageComboBox, ExtCtrls;

type
  TfraScanFunctions = class(TFrame)
    Panel1: TPanel;
    SpTBXGroupBox1: TSpTBXGroupBox;
    btnScan: TSpTBXButton;
    btnScanDialog: TSpTBXButton;
    btnLoadFile: TSpTBXButton;
    btnSaveFile: TSpTBXButton;
    btnDeleteSelected: TSpTBXButton;
    chkStackScan: TSpTBXCheckBox;
    chkScanDuplex: TSpTBXCheckBox;
    btnArchive: TSpTBXButton;
    cbxScanProfile: TcxImageComboBox;
    btnScanProfilOptions: TSpTBXButton;
    chkImportOCR: TSpTBXCheckBox;
    chkColor: TSpTBXCheckBox;
    chkHiRes: TSpTBXCheckBox;
    btnReset: TSpTBXButton;
    chkPrintAfterArchive: TSpTBXCheckBox;       // Ticket 14649
    procedure cbxScanProfilePropertiesChange(Sender: TObject);
    procedure cbxScanProfileClick(Sender: TObject);
  private
    { Private-Deklarationen }

  public
    { Public-Deklarationen }

  end;

implementation

{$R *.dfm}

uses
  bfaCommonUtils, bfaLog, MainDataModule, MainForm, bfaOptions, bfaApplication;
  //bfaLog, MainForm, MainDataModule, bfaCommonUtils, bfaoptions, Registry, ietwain,
 //imageenio, gnugettext, bfaCommonImageEN;

procedure TfraScanFunctions.cbxScanProfileClick(Sender: TObject);
begin
  cbxScanProfilePropertiesChange(Sender);
end;

procedure TfraScanFunctions.cbxScanProfilePropertiesChange(Sender: TObject);
var
  ScanObj : TbfaScanner;
begin
  try
    if (cbxScanProfile.ItemIndex <> -1) and (not frmMainForm.actScan.Enabled) then
    begin
      frmMainForm.actScan.Enabled := True;
      frmMainForm.actScanDialog.Enabled := True;
    end;

    if (cbxScanProfile.ItemIndex <> -1) then
    begin
      ScanObj := bitfarmApp.ScannerProfiles.Container[cbxScanProfile.ItemIndex];

      chkStackScan.Checked := ScanObj.Stapel;
      chkScanDuplex.Checked := ScanObj.Duplex;
    end;

  except
    bitfarmLog.Write(llNormal, ltException, 'MultiViewDblClick - ' + Self.Name, ClassName);
  end;
end;

end.
