unit ShowBookmark;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SpTBXControls, SpTBXItem, StdCtrls, SpTBXEditors, ExtDlgs, Xml.XMLDoc, Xml.XMLIntf;

type
  TfrmShowBookmark = class(TForm)
    pnl1: TSpTBXPanel;
    btnSave: TSpTBXButton;
    btnClose: TSpTBXButton;
    mmoXML: TMemo;
    dlgSaveFile: TSaveTextFileDialog;
    procedure btnSaveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    XML : IXMLDocument;
  end;

var
  frmShowBookmark: TfrmShowBookmark;

implementation

uses
  bfaCommonUtils, bfaCommonStyles;

{$R *.dfm}

procedure TfrmShowBookmark.btnSaveClick(Sender: TObject);
begin
  dlgSaveFile.Filter := 'XML files (*.xml)|*.XML|Any file (*.*)|*.*';
  dlgSaveFile.FilterIndex := 1;
  dlgSaveFile.DefaultExt := 'xml';
  dlgSaveFile.Options := [ofOverwritePrompt];
  if dlgSaveFile.Execute then
  begin
    if dlgSaveFile.FileName <> '' then
    begin
      if ExtractFileExt(dlgSaveFile.FileName) = '' then
        dlgSaveFile.FileName := dlgSaveFile.FileName + 'xml';

      if Assigned(XML) then
        XML.SaveToFile(dlgSaveFile.FileName)
      else
        mmoXML.Lines.SaveToFile(dlgSaveFile.FileName);

    end;
  end;
end;

procedure TfrmShowBookmark.FormCreate(Sender: TObject);
begin
  pnl1.Color := ctlGeneral.Style.Color;
  btnSave.Color := ctlGeneral.Style.Color;
  btnClose.Color := ctlGeneral.Style.Color;
  mmoXML.Color:= ctlGeneral.Style.Color;
  mmoXML.Font.Color := ctlGeneral.Style.Font.Color;
end;

end.
