unit TagsForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SpTBXItem, SpTBXControls, StdCtrls;

type
  TfrmTags = class(TForm)
    mmoTags: TMemo;
    SpTBXPanel1: TSpTBXPanel;
    btnOK: TSpTBXButton;
    btnCancel: TSpTBXButton;
    btnSortUp: TSpTBXSpeedButton;
    btnSortDown: TSpTBXSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure mmoTagsKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure btnSortDownClick(Sender: TObject);
    procedure btnSortUpClick(Sender: TObject);
    procedure mmoTagsKeyPress(Sender: TObject; var Key: Char);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    MaxLineLength: Integer;
    procedure Retranslate;
  end;

var
  frmTags: TfrmTags;

implementation

uses gnugettext, bfaIconsDM, bfaCommonUtils, bfaCommonMethods, bfaLog, bfaCommonStyles;

{$R *.dfm}

procedure TfrmTags.btnSortDownClick(Sender: TObject);
var
  sl : TStringList;
begin
  try
    try
      sl := TStringList.Create;
      sl.Assign(mmoTags.Lines);
      sl.CustomSort(SortCompareDesc);
      mmoTags.Lines.Assign(sl);
    finally
      sl.Free
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'btnSortDownClick', ClassName);
  end;
end;

procedure TfrmTags.btnSortUpClick(Sender: TObject);
var
  sl : TStringList;
begin
  try
    try
      sl := TStringList.Create;
      sl.Assign(mmoTags.Lines);
      sl.CustomSort(SortCompareAsc);
      mmoTags.Lines.Assign(sl);
    finally
      sl.Free
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'btnSortUpClick', ClassName);
  end;
end;

procedure TfrmTags.FormCreate(Sender: TObject);
begin
  TranslateComponent(Self, 'ViewerV36');
  btnSortUp.Images := bfaIcons.ilMainMenu;
  btnSortUp.ImageIndex := Integer(icoidx_arrow_up);
  btnSortDown.Images := bfaIcons.ilMainMenu;
  btnSortDown.ImageIndex := Integer(icoidx_arrow_down);
  MaxLineLength := 0;

  SpTBXPanel1.Color := ctlGeneral.Style.Color;
  mmoTags.Color := ctlGeneral.Style.Color;
  mmoTags.Font.Color := ctlGeneral.Style.Font.Color;

end;

procedure TfrmTags.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    Self.btnCancel.Click;
end;

procedure TfrmTags.mmoTagsKeyPress(Sender: TObject; var Key: Char);
begin
  if MaxLineLength = 0 then
     Exit;

  if (Key = #13) or (Key = #8) then // Return und Backspace mssen immer gehen
    Exit;

  if (length(mmoTags.Lines[mmoTags.CaretPos.Y]) >= MaxLineLength) then
  begin
    Key := #0;
  end;
end;

procedure TfrmTags.mmoTagsKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  line, line2: string;
begin
  if ssCtrl in Shift then
  begin
    if Key = VK_UP then
    begin
      if mmoTags.CaretPos.Y > 0 then
      begin
        mmoTags.Lines.BeginUpdate;
        line := mmoTags.Lines[mmoTags.CaretPos.Y -1];
        line2 := mmoTags.Lines[mmoTags.CaretPos.Y];
        mmoTags.Lines[mmoTags.CaretPos.Y] := line;
        mmoTags.Lines[mmoTags.CaretPos.Y -1] := line2;
        mmoTags.Lines.EndUpdate;
      end;
    end;
    if Key = VK_DOWN then
    begin
      if mmoTags.CaretPos.Y < mmoTags.Lines.Count -1 then
      begin
        mmoTags.Lines.BeginUpdate;
        line := mmoTags.Lines[mmoTags.CaretPos.Y];
        line2 := mmoTags.Lines[mmoTags.CaretPos.Y +1];
        mmoTags.Lines[mmoTags.CaretPos.Y] := line2;
        mmoTags.Lines[mmoTags.CaretPos.Y +1] := line;
        mmoTags.Lines.EndUpdate;
      end;
    end;
  end;
end;

procedure TfrmTags.Retranslate;
begin
  ReTranslateComponent(Self, 'ViewerV36');
end;

end.
