unit Unit2;

interface

uses
//  ShareMem,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, dxCore, Vcl.StdCtrls,
  Dialogs, System.IniFiles, Uni, UniProvider, MySQLUniProvider, bitfarm_enterprise, bfaCommonMethods;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Label1: TLabel;
    Button2: TButton;
    Label2: TLabel;
    Button3: TButton;
    Label3: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Button4: TButton;
    Edit4: TEdit;
    btn1: TButton;
    btn2: TButton;
    btn3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btn1Click(Sender: TObject);
    procedure btn2Click(Sender: TObject);
    procedure btn3Click(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

//  TGetAnnoText = function(server: PChar; port: Integer; db, user,pass: PChar; gdocid: Int64): PChar; stdcall;
//  TGetLastError = function: Integer; stdcall;
//  TGetAnnoSVG = function(server: PChar; port: Integer; db, user,pass: PChar; gdocid: Int64): PChar; stdcall;
  TConnectDB = function(profil: PChar): Integer; stdcall;
  TDisconnectDB = function: Integer; stdcall;
  TGetExport = function(profile: PChar; gdocid: Integer; gridvalue: PChar): Pchar; stdcall;
  TGetValue = function(profile: PChar; gdocid: Integer; gridvalue: PChar): Pchar; stdcall;
  TRoutine = procedure(); stdcall;
var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  MyHandle: THandle;
  AInitializeProc, AFinalizeProc: TRoutine;
//function GetAnno(server,port,user,pass: PChar; gdocid: Int64): PChar; stdcall; external 'AnnoText.dll';


procedure TForm1.btn1Click(Sender: TObject);
var
 getvalue : TGetValue;
 success: PChar;
begin
  if MyHandle = 0 then
    MyHandle := LoadLibrary('bfaGridfield64.DLL');
  if MyHandle <> 0 then
  begin
    @getvalue := GetProcAddress(MyHandle, 'GetValue');

    if @getvalue <> nil then
    begin
       try
         success :=  getvalue(PChar(Edit4.Text), StrToInt(Edit1.Text), PChar(Edit2.Text));
         Label1.Caption := success;
       except
         Label1.Caption := 'Exception';
       end;
    end;

    getvalue := nil;
  end;
end;
procedure TForm1.btn2Click(Sender: TObject);
begin
  Edit2.Clear;
  Label1.Caption := '';
  Label2.Caption := '';
  Label3.Caption := '';
end;

procedure TForm1.btn3Click(Sender: TObject);
var
  sProfil, sUser, sPass, bfaServer: string;
  con: TIniFile;
  bfaServerNoSSL, bfaServerPort: Integer;
  mycon: TUniConnection;

begin
      sProfil := GetEnvironmentVariable('bitfarm-archiv') +'\' + Edit4.Text + '.con';

      con := TIniFile.Create(sProfil);

      bfaServerNoSSL := 0;

      try
        with con do
        begin
          sUser := ReadString('Connection', 'User', '');
          sPass := ReadString('Connection', 'Pass', '');
          bfaServer := ReadString('Server', 'server', 'localhost');
          bfaServerPort := ReadInteger('Server', 'port', 50001);
          bfaServerNoSSL := ((LowerCase(ReadString('Server', 'nossl', 'false')) = 'true') or (ReadString('Server', 'nossl', 'false') = '1')).ToInteger;
  //        archive_rs := ReadString('Scripts', 'archive_rs','');
  //        archive_nrs := ReadString('Scripts', 'archive_nrs','');

          mycon := TUniConnection.Create(nil);
          mycon.ProviderName := 'MySQL';

          with mycon do
          begin
            Username := Decrypt(sUser, GlobalKey);
            Password := Decrypt(sPass, GlobalKey);
            Server := ReadString('Connection', 'Server', '');
            Port := ReadInteger('Connection', 'Port', 3306);
            Database := ReadString('Connection', 'DB', '');
            SpecificOptions.Values['UseUnicode'] := 'True';
            SpecificOptions.Values['Protocol'] := 'mpSSL';
            try
              Connect; // Anmelden an der Datenbank
            except
              on e: Exception do
              begin
                ExitCode := 2;
                Label1.Caption := e.Message;    // Fehler beim Auslesen der .CON Datei
                exit;
              end;
            end;
            if not Connected then // Wenn keine Verbindung dann Tool verlassen
            begin
              ExitCode := 3;  //keine Connection zur Datenbank mglich
              Label1.Caption := 'not connected';
              exit;
            end else
               Label1.Caption := 'connected';
          end;
        end;
      finally

      end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
 connect : TConnectDB;
 success: Integer;
begin
  Label1.Caption := 'connect';
  MyHandle := LoadLibrary('bfaGridfield64.DLL');
  if MyHandle <> 0 then
  begin
    // The InitializeDXLibrary method calls the dxInitialize procedure within the my.dll library
    AInitializeProc := GetProcAddress(MyHandle, 'InitializeDXLibrary');
    if not Assigned(AInitializeProc) then
      raise Exception.Create('Improper library version');
    // The FinalizeDXLibrary method calls the dxFinalize procedure within the my.dll library
    AFinalizeProc := GetProcAddress(MyHandle, 'FinalizeDXLibrary');
    if not Assigned(AFinalizeProc) then
      raise Exception.Create('Improper library version');

    AInitializeProc;

    @connect := GetProcAddress(MyHandle, 'ConnectDB');

    if @connect <> nil then
    begin
       try
         success :=  connect(PChar(Edit3.Text));
         Label1.Caption := IntToStr(success);
       except
         Label1.Caption := 'Exception';
       end;
    end;

    connect := nil;
  end;


end;

procedure TForm1.Button2Click(Sender: TObject);
var
  disconnect : TDisconnectDB;
  success: Integer;
begin
  Label2.Caption := 'disconnect';
  if MyHandle = 0 then
     MyHandle := LoadLibrary('bfaGridfield64.DLL');

  if MyHandle <> 0 then
  begin
     @disconnect := GetProcAddress(MyHandle, 'DisconnectDB');

      if @disconnect <> nil then
      begin
         try
           success := disconnect;
           Label2.Caption := IntToStr(success);
         except
           Label2.Caption := 'Exception';
         end;
      end;
      if Assigned(AFinalizeProc) then
        AFinalizeProc;
      disconnect := nil;
      FreeLibrary(MyHandle);
      MyHandle := 0;
  end;

end;

procedure TForm1.Button3Click(Sender: TObject);
var
 getexport : TGetExport;
 success: PChar;
begin
  if MyHandle = 0 then
    MyHandle := LoadLibrary('bfaGridfield64.DLL');
  if MyHandle <> 0 then
  begin
    @getexport := GetProcAddress(MyHandle, 'GetExport');

    if @getexport <> nil then
    begin
       try
         success :=  getexport(PChar(Edit4.Text), StrToInt(Edit1.Text), PChar(Edit2.Text));
         Label1.Caption := success;
       except
         Label1.Caption := 'Exception';
       end;
    end;

    getexport := nil;
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  loadgridfields : TRoutine;
begin
  if MyHandle = 0 then
    MyHandle := LoadLibrary('bfaGridfield64.DLL');
  if MyHandle <> 0 then
  begin
    @loadgridfields := GetProcAddress(MyHandle, 'LoadGridfields');

    if @loadgridfields <> nil then
    begin
       try
         loadgridfields;
         Label1.Caption := 'loaded gridfields';
       except
         on e: Exception do
          Label1.Caption := 'Exception:' + e.Message;
       end;
    end;

    loadgridfields := nil;
  end;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if (Key = #13) and (Edit1.Text <> '') then
    Button1Click(Sender);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Button2.Click;
end;

end.


