library bfaGridField64;

{ Wichtiger Hinweis zur DLL-Speicherverwaltung: ShareMem muss die erste
  Unit in der USES-Klausel Ihrer Bibliothek UND in der USES-Klausel Ihres Projekts
  sein (whlen Sie "Projekt, Quelltext anzeigen"), wenn Ihre DLL Prozeduren oder Funktionen
  exportiert, die Strings als Parameter oder Funktionsergebnisse bergeben. Dies
  gilt fr alle Strings, die an oder von Ihrer DLL bergeben werden, auch fr solche,
  die in Records und Klassen verschachtelt sind. ShareMem ist die Interface-Unit fr
  den gemeinsamen BORLNDMM.DLL-Speichermanager, der zusammen mit Ihrer DLL
  weitergegeben werden muss. bergeben Sie String-Informationen mit PChar- oder ShortString-
  Parametern, um die Verwendung von BORLNDMM.DLL zu vermeiden.

  Wichtiger Hinweis zur Verwendung der VCL: Wenn diese DLL implizit geladen wird
  und die in einem Unit-Initialisierungsabschnitt erstellte TWicImage/TImageCollection-Komponente
  verwendet, dann muss Vcl.WicImageInit in die USES-Klausel
  der Bibliothek aufgenommen werden. }

uses
//  ShareMem,
  System.SysUtils,
  System.Classes, dxCore,
  System.Generics.Collections, MidasLib,
  Uni, MySQLUniProvider, IniFiles, cxStyles, cxEdit,
  XMLDoc, XMLIntf, ActiveX,
  bfaBaseObjects, bfaCommonUtils, bfaCommonStyles, bitfarm_enterprise, bfaCommonMethods,
  bfaBaseParser,
  u_bfaAddfield in '..\..\Delphi-Shared_362\bfaComponents36\Source\u_bfaAddfield.pas';

{$R *.res}
{$R Icons.res}
type

TGridfields = TDictionary<integer, TBfaAddfieldComp>;

var
  addfieldcomp: TBfaAddfieldComp;
  mycon : TUniConnection;
  myq: TUniQuery;
  sUser, sPass, sProfil, gridvalue, header, csv: string;
  AConfig: TbfaGridConfig;
  xmlnode : IXMLDocument;
//  gridfields: TDictionary<integer, TBfaAddfieldComp>;
  gridfields: TDictionary<string, TGridfields>;
  mycons: TDictionary<string, TUniConnection>;
  profiles: TStringList;

function DisconnectDB: Integer;
var
  addfields: TGridfields;
begin
  Result := 0;

  try
    if gridfields <> nil then
    begin
      for var Enum in gridfields do
      begin
        addfields := Enum.Value;
        for var field in addfields do
          FreeAndNil(field.Value);
        FreeAndNil(Enum.Value);
      end;
      gridfields.Clear;
    end;

    FreeAndNil(addfieldcomp);
    FreeAndNil(ctlGeneral);
    FreeAndNil(stlFree);
    if Assigned(mycons) then
    begin
      for var Enum in mycons do
      begin
        Enum.Value.Disconnect;
        Enum.Value.Close;
        FreeAndNil(Enum.Value);
      end;
      mycons.Clear;
    end;
    if Assigned(myq) then
      FreeAndNIl(myq);
  except
    Result := 1;
  end;

end;

function ConnectDB(AProfile: PChar): Integer;
var
  bfaServer: string;
  bfaServerPort: Integer;
  bfaServerNoSSL: Integer;
  con: TIniFile;
  gkey: string;
  gpl: Boolean;
begin
   // Auslesen der Connection
//  gridfields := TDictionary<string, TGridfields>.Create;
  profiles := TStringList.Create;
  profiles.Delimiter := ';';
  profiles.StrictDelimiter := True;
  profiles.DelimitedText := AProfile;

  if Assigned(mycons) and (mycons <> nil) then
    DisconnectDB;

  mycons := TDictionary<string, TUniConnection>.Create;

  try
    for var i := 0 to profiles.Count -1 do
    begin
      sProfil := GetEnvironmentVariable('bitfarm-archiv') +'\' + profiles[i] + '.con';

      con := TIniFile.Create(sProfil);
      Result := 0;
      bfaServerNoSSL := 0;
      gpl := False;

      try
        with con do
        begin
          sUser := ReadString('Connection', 'User', '');
          sPass := ReadString('Connection', 'Pass', '');
          bfaServer := ReadString('Server', 'server', 'localhost');
          bfaServerPort := ReadInteger('Server', 'port', 50001);
          bfaServerNoSSL := ((LowerCase(ReadString(sSysServerSection, sSysNoSSL, 'false')) = 'true') or (ReadString(sSysServerSection, sSysNoSSL, 'false') = '1')).ToInteger;
          gpl := LowerCase(ReadString(sSysServerSection, sSysEdition, '')) = 'gpl';
          if gpl then
            gkey := 'b17fa300900b421333de672c41a0d'
          else
            gkey := GlobalKey;
  //        archive_rs := ReadString('Scripts', 'archive_rs','');
  //        archive_nrs := ReadString('Scripts', 'archive_nrs','');

          mycon := TUniConnection.Create(nil);
          mycon.ProviderName := 'MySQL';

          with mycon do
          begin
            Username := Decrypt(sUser, gkey);
            Password := Decrypt(sPass, gkey);
            Server := ReadString('Connection', 'Server', '');
            Port := ReadInteger('Connection', 'Port', 3306);
            Database := ReadString('Connection', 'DB', '');
            SpecificOptions.Values['UseUnicode'] := 'True';
            SpecificOptions.Values['Protocol'] := 'mpSSL';
            try
              Connect; // Anmelden an der Datenbank
            except
              on e: Exception do
              begin
                ExitCode := 2;
                Result := 2;    // Fehler beim Auslesen der .CON Datei
                exit;
              end;
            end;
            if not Connected then // Wenn keine Verbindung dann Tool verlassen
            begin
              ExitCode := 3;  //keine Connection zur Datenbank mglich
              Result := 3;
              exit;
            end;
//            myq := TUniQuery.Create(nil);
//            myq.Connection := mycon;

            mycons.Add(profiles[i], mycon);

          end;
        end;
      except
        on e: Exception do
        begin
          ExitCode := 4;   // Fehler beim Auslesen der .CON Datei
          Result := 4;
          exit;
        end;
      end;
    end;
  finally
    if Assigned(con) then
      FreeAndNil(con);
  end;
end;


function GetExport(profile: PChar; addfieldid: Integer; gridvalue: PChar): Pchar;
var
  addfieldcomp: TBfaAddfieldComp;
  values_query: string;
  MyConfig: TbfaGridConfig;
  xmlnode : IXMLDocument;
begin
  Result := gridvalue;
  addfieldcomp := nil;

  if (gridfields <> nil) and gridfields.ContainsKey(profile) and
     (gridfields[profile].ContainsKey(addfieldid)) then
    addfieldcomp := gridfields[profile][addfieldid]
  else begin
    if (mycons <> nil) and (mycons.ContainsKey(profile)) then
    begin

      if myq = nil then
        myq := TUniQuery.Create(nil);
      myq.Connection := mycons[profile];

      myq.SQL.Text := 'select * from sys_addfields where addfieldid = ' + IntToStr(addfieldid);

      myq.Execute;
      myq.First;
      values_query := myq.FieldByName('values_query').AsString;

      if values_query <> '' then
      begin
        if ctlGeneral = nil then
          ctlGeneral := TcxEditStyleController.Create(nil);
        if stlFree = nil then
        begin
          stlFree := TcxStyle.Create(nil);
          stlFree.Color := gclFree;
          stlFree.TextColor := gclFreeText;
        end;

        addfieldcomp := TBfaAddfieldComp.Create(nil, zfld13_Grid, '', False, nil);

        MyConfig := TbfaGridConfig.Create;
        CoInitialize(nil);
        xmlnode := TXMLDocument.Create(nil);
        try
          xmlnode.LoadFromXML(values_query);
          MyConfig := XMLToGridConfig(xmlnode.DocumentElement);
        finally
          CoUninitialize;
        end;
        if MyConfig <> nil then
        begin
          MyConfig.UseColumnNames := False;
          addfieldcomp.compGrid.LoadConfig(MyConfig, True);
        end;
      end;
    end;
  end;

  if addfieldcomp <> nil then
  begin
    addfieldcomp.Value := string(gridvalue);
    addfieldcomp.compGrid.GetExport(header, csv);

    Result := PChar(header + '|' + csv);
  end;

end;

function GetValue(profile: PChar; addfieldid: Integer; gridvalue: PChar): Pchar;
var
  addfieldcomp: TBfaAddfieldComp;
  values_query: string;
  MyConfig: TbfaGridConfig;
  xmlnode : IXMLDocument;
begin
  Result := gridvalue;
  addfieldcomp := nil;

  if (gridfields <> nil) and gridfields.ContainsKey(profile) and
     (gridfields[profile].ContainsKey(addfieldid)) then
    addfieldcomp := gridfields[profile][addfieldid]
  else begin
    if (mycons <> nil) and (mycons.ContainsKey(profile)) then
    begin

      if myq = nil then
        myq := TUniQuery.Create(nil);
      myq.Connection := mycons[profile];

      myq.SQL.Text := 'select * from sys_addfields where addfieldid = ' + IntToStr(addfieldid);

      myq.Execute;
      myq.First;
      values_query := myq.FieldByName('values_query').AsString;

      if values_query <> '' then
      begin
        if ctlGeneral = nil then
          ctlGeneral := TcxEditStyleController.Create(nil);
        if stlFree = nil then
        begin
          stlFree := TcxStyle.Create(nil);
          stlFree.Color := gclFree;
          stlFree.TextColor := gclFreeText;
        end;

        addfieldcomp := TBfaAddfieldComp.Create(nil, zfld13_Grid, '', False, nil);

        MyConfig := TbfaGridConfig.Create;
        CoInitialize(nil);
        xmlnode := TXMLDocument.Create(nil);
        try
          xmlnode.LoadFromXML(values_query);
          MyConfig := XMLToGridConfig(xmlnode.DocumentElement);
        finally
          CoUninitialize;
        end;
        if MyConfig <> nil then
        begin
          MyConfig.UseColumnNames := False;
          addfieldcomp.compGrid.LoadConfig(MyConfig, True);
        end;
      end;
    end;
  end;

  if addfieldcomp <> nil then
  begin
    addfieldcomp.Value := string(gridvalue);
    csv := addfieldcomp.compGrid.GetValue();

    Result := PChar(csv);
  end;

end;

procedure LoadGridfields;
var
  addfieldcomp: TBfaAddfieldComp;
  i: integer;
  addfields: TGridfields;
  addfieldid: Integer;
  values_query: string;
  MyConfig: TbfaGridConfig;
  xmlnode : IXMLDocument;
begin

  for i := 0 to profiles.Count -1 do
  begin
    if (mycons <> nil) and (mycons.ContainsKey(profiles[i])) and mycons[profiles[i]].Connected then
    begin
      if (gridfields <> nil) then
      begin
        if (gridfields.ContainsKey(profiles[i])) {and (gridfields[profiles[i]] <> nil)} then
        begin
          for var Enum in gridfields[profiles[i]] do
            FreeAndNil(Enum.Value);
          gridfields[profiles[i]].Clear;
        end else
          gridfields.Add(profiles[i], TGridfields.Create);
      end else
      begin
//        gridfields[profiles[i]] := TDictionary<Integer, TGridfields.Create>.Create;
         gridfields := TDictionary<string, TGridfields>.Create;
         gridfields.Add(profiles[i], TGridfields.Create);
      end;

//      addfields := TGridfields.Create;

      if myq = nil then
        myq := TUniQuery.Create(nil);
      myq.Connection := mycons[profiles[i]];

      myq.SQL.Text := 'select * from sys_addfields where type = 13';
      myq.Execute;
      myq.First;
      while not myq.Eof do
      begin
        values_query := myq.FieldByName('values_query').AsString;
        addfieldid := myq.FieldByName('addfieldid').AsInteger;

        if values_query <> '' then
        begin
          if ctlGeneral = nil then
            ctlGeneral := TcxEditStyleController.Create(nil);
          if stlFree = nil then
          begin
            stlFree := TcxStyle.Create(nil);
            stlFree.Color := gclFree;
            stlFree.TextColor := gclFreeText;
          end;

          addfieldcomp := TBfaAddfieldComp.Create(nil, zfld13_Grid, '', False, nil);

          MyConfig := TbfaGridConfig.Create;
          CoInitialize(nil);
          xmlnode := TXMLDocument.Create(nil);
          try
            xmlnode.LoadFromXML(values_query);
            MyConfig := XMLToGridConfig(xmlnode.DocumentElement);
          finally
            CoUninitialize;
          end;
          if MyConfig <> nil then
          begin
            MyConfig.UseColumnNames := False;
            addfieldcomp.compGrid.LoadConfig(MyConfig, True);
//            gridfields.Add(profiles[i], TGridFields.Create);
            gridfields[profiles[i]].Add(addfieldid, addfieldcomp);
          end;
        end;
        myq.Next;
      end;
    end;
  end;
end;

procedure FinalizeDXLibrary;
begin
  dxCore.dxFinalize;
end;

procedure InitializeDXLibrary;
begin
  dxCore.dxInitialize;
end;

exports
ConnectDB,
DisconnectDB,
GetExport,
GetValue,
LoadGridfields,
InitializeDXLibrary,
FinalizeDXLibrary;


begin

end.

initialization

finalization
  DisconnectDB;



