program bfaGridfieldCMD;

{$APPTYPE CONSOLE}

{$R *.res}
{$R Icons.res}

uses
  System.SysUtils, Uni, MySQLUniProvider, IniFiles, cxEdit, XMLDoc, XMLIntf, ActiveX,
  bfaBaseObjects, bfaCommonUtils, bfaCommonStyles, bitfarm_enterprise, bfaCommonMethods,
  bfaBaseParser,
  u_bfaAddfield in '..\..\Delphi-Shared_362\bfaComponents36\Source\u_bfaAddfield.pas';

var
  addfieldcomp: TBfaAddfieldComp;
  mycon : TUniConnection;
  myq: TUniQuery;
  sUser, sPass, sProfil, values_query, gridvalue, header, csv: string;
  con: TIniFile;
  AConfig: TbfaGridConfig;
  xmlnode : IXMLDocument;


function ConnectDB: boolean;
var
  bfaServer: string;
  bfaServerPort: Integer;
  bfaServerNoSSL: Integer;
begin
   // Auslesen der Connection
  con := TIniFile.Create(sProfil);
  Result := True;
  bfaServerNoSSL := 0;
  try
    try
      with con do
      begin
        sUser := ReadString('Connection', 'User', '');
        sPass := ReadString('Connection', 'Pass', '');
        bfaServer := ReadString('Server', 'server', 'localhost');
        bfaServerPort := ReadInteger('Server', 'port', 50001);
        bfaServerNoSSL := ((LowerCase(ReadString(sSysServerSection, sSysNoSSL, 'false')) = 'true') or (ReadString(sSysServerSection, sSysNoSSL, 'false') = '1')).ToInteger;
//        archive_rs := ReadString('Scripts', 'archive_rs','');
//        archive_nrs := ReadString('Scripts', 'archive_nrs','');

        with mycon do
        begin
          Username := Decrypt(sUser, GlobalKey);
          Password := Decrypt(sPass, GlobalKey);
          Server := ReadString('Connection', 'Server', '');
          Port := ReadInteger('Connection', 'Port', 3306);
          Database := ReadString('Connection', 'DB', '');
          WriteCMD('Connection to Server ' + Server + ' with DB ' + Database);
          Connect; // Anmelden an der Datenbank
          if not Connected then // Wenn keine Verbindung dann Tool verlassen
          begin
            ExitCode := 2;  //keine Connection zur Datenbank mglich
            WriteCMD('Fehler: Keine Verbindung zur Datenbank!');
            Result := False;
            exit;
          end;
        end;

//        MainSocket := TBaseSocketConnection.Create(bfaServerNoSSL, bfaServer, bfaServerPort, '');
//
//        MainSocket.CreateComponents;
//        MainSocket.ServerReadTimeout := 10000; //10 Sekunden bei der Anmeldung

      end;
    except
      on e: Exception do
      begin
        ExitCode := 4;   // Fehler beim Auslesen der .CON Datei
        WriteCMD('Fehler: Beim Auslesen der .CON Datei! ' + e.Message);
        Result := False;
        exit;
      end;
    end;
  finally
    if Assigned(con) then
      FreeAndNil(con);
  end;
end;

begin
  try
    { TODO -oUser -cConsole Main : Code hier einfgen }
    ctlGeneral := TcxEditStyleController.Create(nil);
    addfieldcomp := TBfaAddfieldComp.Create(nil, zfld13_Grid, '', False, nil);

    mycon := TUniConnection.Create(nil);
    mycon.ProviderName := 'MySQL';

    sProfil := ExtractFilePath(ParamStr(0)) + ParamStr(1) + '.con';
    ConnectDB;

    gridvalue := ParamStr(2);

    myq := TUniQuery.Create(nil);
    myq.Connection := mycon;

    myq.SQL.Text := 'select * from sys_addfields where addfieldid = 73';

    myq.Execute;
    myq.First;
    values_query := myq.FieldByName('values_query').AsString;

    AConfig := TbfaGridConfig.Create;

    if values_query <> '' then
    begin
      CoInitialize(nil);
      xmlnode := TXMLDocument.Create(nil);
      try
        xmlnode.LoadFromXML(values_query);
        AConfig := XMLToGridConfig(xmlnode.DocumentElement);
      finally
        CoUninitialize;
      end;
      if AConfig <> nil then
      begin
        addfieldcomp.compGrid.LoadConfig(AConfig);
      end;
    end;

    addfieldcomp.Value := gridvalue;
    addfieldcomp.compGrid.GetExport(header, csv);

    WriteLN(header + '|' + csv);


    mycon.Disconnect;
    FreeAndNil(addfieldcomp);
    FreeAndNil(ctlGeneral);
    WriteLN('Done...');
  except
    on E: Exception do
      Writeln(E.ClassName, ': ', E.Message);
  end;
end.
