unit bfaDocumentsCollection;

interface

uses 
  bfaDocument,
  Generics.Collections;

type 
  TVisibleDocs = record
    VisibleDoc: PbfaDocument;
    VisiblePage: Integer;
  end;

  TbfaDocumentsCollection = class(TList<PbfaDocument>)
  private
    FActiveIndex: Integer;
    FActiveDocument: PbfaDocument;
    FVisiblePages: TList<TVisibleDocs>;
      
  public
    constructor Create;

    procedure Activate(Index: Integer);

    property ActiveIndex: Integer read FActiveIndex;
    property ActiveDoc: PbfaDocument read FActiveDocument;
    property VisibleDocuments: TList<TVisibleDocs> read FVisiblePages write FVisiblePages;
  
  end;

  PbfaDocumentsCollection = ^TbfaDocumentsCollection;

implementation

//
constructor TbfaDocumentsCollection.Create;
begin
  inherited Create;
  FVisiblePages:= TList<TVisibleDocs>.Create;

  FActiveIndex:= -1;
  FActiveDocument:= nil;
  
end;
//
procedure TbfaDocumentsCollection.Activate(Index: Integer);
begin
  try
    FActiveIndex:= Index;
    FActiveDocument:= Pointer(Self.Items[Index]);  
  except
    FActiveIndex:= -1;
    FActiveDocument:= nil;
  end;
end;
//

end.
