unit bfaField;

interface

uses
  Generics.Collections,
  Classes, bfaApplication, bfaBaseObjects;

type

  /// <Beschreibung></Beschreibung>
  /// <Description></Description>
  TbfaFunction = class (TObject)
  private
    FFunctionID: Int64;
    FFunctionName: WideString;
    FDescription: WideString;
    FFunction: WideString;
    FFieldID: Int64;
    FFunctionType: Integer;
  public
    constructor Create;
    
    property FunctionID: Int64 read FFunctionID;
    property FunctionName: WideString read FFunctionName;
    property Description: WideString read FDescription;
    property bfaFunction: WideString read FFunction;
    property FieldID: Int64 read FFieldID;
    property FunctionType: Integer read FFunctionType;
  end;

  /// <Beschreibung>bitfarm AdditionalField Klasse</Beschreibung>
  /// <Description>bitfarm AdditionalField class</Description>
  TbfaField = class(TbfaBaseField)
  private
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FbfaApplication: PbfaApplication;
    

  public
    /// <Beschreibung>Setzt die Standardwerte und erstellt die Objekte</Beschreibung>
    /// <Description>Sets the default values and creates the objects</Description>
    constructor Create(bfaApp: PbfaApplication); overload;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    function Load(FldID: Int64): Integer; virtual;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    function Save: Integer; virtual;
     
  end;

  PbfaField = ^TbfaField;


  /// <Beschreibung></Beschreibung>
  /// <Description></Description>
  TbfaClientField = class(TbfaField)
  private
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FArchiveID: Int64;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FArchiveLayoutID: Int64;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FFunctions: WideString;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FEvents: WideString;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FUserRead: Boolean;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FUserWrite: Boolean;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FUserModify: Boolean;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FHasRights: Boolean;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FMaxUserIdx: Integer;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FMaxGroupIdx: Integer;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FMaxUsrColumn: Integer;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FMaxGrpColumn: Integer;

  public
    /// <Beschreibung>Setzt die Standardwerte und erstellt die Objekte</Beschreibung>
    /// <Description>Sets the default values and creates the objects</Description>
    constructor Create(bfaApp: PbfaApplication; MaxUserColumn, MaxGroupColumn : Integer); overload;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
(*    constructor Create(UserID: Int64); overload;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    constructor Create(Connection: TbfaConnection; Log: TbfaLog); overload;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>    
    constructor Create(Connection: TbfaConnection; Log: TbfaLog; UserID: Int64); overload;   *)
    
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    function Load(FldID: Int64): Integer; overload;
    
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property UserRead: Boolean read FUserRead write FUserRead;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property UserWrite: Boolean read FUserWrite write FUserWrite;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property UserModify: Boolean read FUserModify write FUserModify;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property HasRights: Boolean read FHasRights write FHasRights;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property ArchiveID: Int64 read FArchiveID write FArchiveID;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property ArchiveLayoutID: Int64 read FArchiveLayoutID write FArchiveLayoutID;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property Functions: WideString read FFunctions write FFunctions;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property Events: WideString read FEvents write FEvents;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property MaxUserIdx: Integer read FMaxUserIdx write FMaxUserIdx;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property MaxGroupIdx: Integer read FMaxGroupIdx write FMaxGroupIdx;
    
  
  end;

  PbfaClientField = ^TbfaClientField;

  /// <Beschreibung></Beschreibung>
  /// <Description></Description>
  TbfaAdminField = class(TbfaClientField)
  private
    FFieldPermissions : TList<TbfaPermission>;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FFieldPermissionsModified : Boolean;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
//    FUserRights: array of Integer;
//    /// <Beschreibung></Beschreibung>
//    /// <Description></Description>
//    FUserRightsUnSetter: array of Integer;
//    /// <Beschreibung></Beschreibung>
//    /// <Description></Description>
//    FGroupRights: array of Integer;
//    /// <Beschreibung></Beschreibung>
//    /// <Description></Description>
//    FGroupRightsUnSetter: array of Integer;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FModificationOnBaseField : Boolean;

//    /// <Beschreibung></Beschreibung>
//    /// <Description></Description>
//    function GetUserRights(Idx: Integer): Integer;
//    /// <Beschreibung></Beschreibung>
//    /// <Description></Description>
//    procedure SetUserRights(Idx: Integer; Value: Integer);  
//    /// <Beschreibung></Beschreibung>
//    /// <Description></Description>
//    function GetUserRightsUnSetter(Idx: Integer): Integer;
//    /// <Beschreibung></Beschreibung>
//    /// <Description></Description>
//    procedure SetUserRightsUnSetter(Idx: Integer; Value: Integer);  
//    /// <Beschreibung></Beschreibung>
//    /// <Description></Description>
//    function GetGroupRights(Idx: Integer): Integer;
//    /// <Beschreibung></Beschreibung>
//    /// <Description></Description>
//    procedure SetGroupRights(Idx: Integer; Value: Integer);  
//    /// <Beschreibung></Beschreibung>
//    /// <Description></Description>
//    function GetGroupRightsUnSetter(Idx: Integer): Integer;
//    /// <Beschreibung></Beschreibung>
//    /// <Description></Description>
//    procedure SetGroupRightsUnSetter(Idx: Integer; Value: Integer);      
//    /// <Beschreibung></Beschreibung>
//    /// <Description></Description>
//    function GetMaxUserRights: Integer;
//    /// <Beschreibung></Beschreibung>
//    /// <Description></Description>
//    function GetMaxGroupRights: Integer;

  public
    /// <Beschreibung>Setzt die Standardwerte und erstellt die Objekte</Beschreibung>
    /// <Description>Sets the default values and creates the objects</Description>
    constructor Create(bfaApp: PbfaApplication; MaxUserColumn, MaxGroupColumn : Integer); overload;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
//    constructor Create(Connection: TbfaConnection; Log: TbfaLog); overload;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
//    constructor Create(bfaApp: PbfaApplication; UsrIdx, GrpIdx: Integer); overload;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    function Save: Integer; override;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    function Load(FldID: Int64): Integer; overload;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    function CopyToBaseField(Fld: TbfaBaseField): Integer;
//    
//    /// <Beschreibung></Beschreibung>
//    /// <Description></Description>
//    property UserRights[Idx: Integer]: Integer read GetUserRights write SetUserRights;
//    /// <Beschreibung></Beschreibung>
//    /// <Description></Description>
//    property UserRightsUnSetter[Idx: Integer]: Integer read GetUserRightsUnSetter write SetUserRightsUnSetter;
//    /// <Beschreibung></Beschreibung>
//    /// <Description></Description>
//    property GroupRights[Idx: Integer]: Integer read GetGroupRights write SetGroupRights;
//    /// <Beschreibung></Beschreibung>
//    /// <Description></Description>
//    property GroupRightsUnSetter[Idx: Integer]: Integer read GetGroupRightsUnSetter write SetGroupRightsUnSetter;
//    /// <Beschreibung></Beschreibung>
//    /// <Description></Description>
//    property MaxUserRights: Integer read GetMaxUserRights;
//    /// <Beschreibung></Beschreibung>
//    /// <Description></Description>
//    property MaxGroupRights: Integer read GetMaxGroupRights;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property ModificationOnBaseField : Boolean read FModificationOnBaseField write FModificationOnBaseField;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property FieldPermissionsModified : Boolean read FFieldPermissionsModified write FFieldPermissionsModified;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property FieldPermissions : TList<TbfaPermission> read FFieldPermissions write FFieldPermissions;
    
  
  end;  

  PbfaAdminField = ^TbfaAdminField;
  

implementation

uses
  bfaCommonUtils, SysUtils, bfaMethods;

//
//  Name: Create
//  Parameters: -
//  Beschreibung: Setzt die Standardwerte und erstellt die Objekte
//  Description: Sets the default values and creates the objects
//  Return value: -
// [] 17.04.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
constructor TbfaFunction.Create;
begin
  inherited Create;
  FFunctionID:= -1;
  FFunctionName:= '';
  FDescription:= '';
  FFunction:= '';
  FFieldID:= -1;
  FFunctionType:= -1;
end;
//
//  Name: Create
//  Parameters: -
//  Beschreibung: Setzt die Standardwerte und erstellt die Objekte
//  Description: Sets the default values and creates the objects
//  Return value: -
// [] 17.04.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
constructor TbfaField.Create(bfaApp: PbfaApplication);
begin
  try
    New(FbfaApplication);
    FbfaApplication:= bfaApp;

    inherited Create;

  except
    FbfaApplication:= nil;
  end;
end;
//
//  Name: Create
//  Parameters: -
//  Beschreibung: Setzt die Standardwerte und erstellt die Objekte
//  Description: Sets the default values and creates the objects
//  Return value: -
// [] 17.04.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
constructor TbfaClientField.Create(bfaApp: PbfaApplication; MaxUserColumn, MaxGroupColumn : Integer);
begin
  try
    inherited Create(bfaApp);

    FFunctions:= '';
    FEvents:= '';
    FArchiveID:= -1;
    FArchiveLayoutID:= -1;
    FUserRead:= False;
    FUserWrite:= False;
    FUserModify:= False;
    FHasRights:= False;
    FMaxUserIdx:= -1;
    FMaxGroupIdx:= -1;
    FMaxUsrColumn := MaxUserColumn;
    FMaxGrpColumn := MaxGroupColumn;
  except
    FbfaApplication:= nil;
  end;
end;
//
//  Name: Create
//  Parameters: -
//  Beschreibung: Setzt die Standardwerte und erstellt die Objekte
//  Description: Sets the default values and creates the objects
//  Return value: -
// [] 17.04.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
constructor TbfaAdminField.Create(bfaApp: PbfaApplication; MaxUserColumn, MaxGroupColumn : Integer);
var
  i, UsrIdx, GrpIdx: Integer;
begin
  inherited Create(bfaApp, MaxUserColumn, MaxGroupColumn);
  FFieldPermissions := TList<TbfaPermission>.Create;
  FModificationOnBaseField := False;
  FFieldPermissionsModified := False;
//  FUserRights:= nil;
//  FUserRightsUnSetter:= nil;
//  FGroupRights:= nil;
//  FGroupRightsUnSetter:= nil;

(*
  FbfaApplication^.Connection.SelectMaxUsrGrpIdx(UsrIdx, GrpIdx);
  
  if UsrIdx > 0 then
    FMaxUserIdx := (1 + UsrIdx) * 64
  else
    FMaxUserIdx := 64;
  SetLength(FUserRights, FMaxUserIdx);
  for i:= 0 to FMaxUserIdx do
    FUserRights[i]:= 0;  

  SetLength(FUserRightsUnSetter, FMaxUserIdx);
  for i:= 0 to FMaxUserIdx do
    FUserRightsUnSetter[i]:= 0;  

  if GrpIdx > 0 then
    FMaxGroupIdx := (1+ GrpIdx) * 64
  else
    FMaxGroupIdx := 64;
  SetLength(FGroupRights, FMaxGroupIdx);
  for i:= 0 to FMaxGroupIdx do
    FGroupRights[i]:= 0; 

  SetLength(FGroupRightsUnSetter, FMaxGroupIdx);
  for i:= 0 to FMaxGroupIdx do
    FGroupRightsUnSetter[i]:= 0; 
*)
end;
//
//  Name: Load
//  Parameters: AddFldID
//  Beschreibung: Ldt ein AdditionalField mit der bergebenen AddFldID 
//  Description: Load the Additional Field By ID
//  Return value: ErrorCode
// [] 17.04.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TbfaField.Load(FldID: Int64): Integer;
var
  FldRec: TBaseFldRec;
begin
  FErrorCode:= 0;
  if FInitialized then
  begin
    FbfaApplication^.WriteLog(llHigh, ltInfo, 'Load(FldID: ' + IntToStr(FldID) + ')', ClassName);
    try
      FErrorCode:= FbfaApplication^.Connection.SelectBaseFieldByID(FldID, FldRec);
      if FErrorCode = 0 then
      begin
        FModified:= False;
        FID:= FldRec.FldID;
        FName:= FldRec.DisplayName;
        FDefaultValue:= FldRec.DefaultValue;
        FObjType:= FldRec.FieldType;
        FIndexTableID:= FldRec.IndexTableID;
        FValueType:= FldRec.ValueType;
        FControlType:= FldRec.ControlType;
        FMode:= FldRec.Mode;
        FOptions:= FldRec.Options;
        FDescription:= FldRec.Description;
        FEnabled:= FldRec.Enabled;  
        FControlItems:= FldRec.ControlItems; 
        FSize:= FldRec.Size;
        FStatus:= FldRec.Status;       
      end;
      FLoaded := True;
      
      Result:= FErrorCode;
    except
      FErrorCode:= ecAdditionalFieldFailureInLoad;
      FbfaApplication^.WriteLog(llNormal, ltException, sSysErrorCode + ': ' + IntToStr(FErrorCode), ClassName);
      Result:= FErrorCode;
    end;
  end
  else
  begin
    FErrorCode:= ecAdditionalFieldConnectionOrLogIsNotInitialized;
    Result:= FErrorCode;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TbfaField.Save: Integer;
var
  FldRec: TBaseFldRec;
begin
  FErrorCode:= 0;
  if FInitialized then
  begin
    FbfaApplication^.WriteLog(llHigh, ltInfo, 'SaveBase(AddFldID: ' + IntToStr(FID) + ')', ClassName);
    try
      FldRec.FldID:= FID;
      FldRec.DisplayName:= FName;
      FldRec.DefaultValue:= FDefaultValue;
      FldRec.FieldType:= FObjType;
      FldRec.IndexTableID:= FIndexTableID;
      FldRec.ValueType:= FValueType;
      FldRec.ControlType:= FControlType;
      FldRec.Mode:= FMode;
      FldRec.Options:= FOptions;
      FldRec.Description:= FDescription;
      FldRec.Enabled:= FEnabled;  
      FldRec.ControlItems:= FControlItems; 
      FldRec.Size:= FSize;       
      FldRec.Status:= FStatus;       

    
      FErrorCode:= FbfaApplication^.Connection.UpdateBaseField(FldRec, False);

      Result:= FErrorCode;
    except
      FErrorCode:= ecAdditionalFieldFailureInSave;
      FbfaApplication^.WriteLog(llNormal, ltException, sSysErrorCode + ': ' + IntToStr(FErrorCode), ClassName);
      Result:= FErrorCode;
    end;
  end
  else
  begin
    FErrorCode:= ecAdditionalFieldConnectionOrLogIsNotInitialized;
    Result:= FErrorCode;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TbfaAdminField.Save: Integer;
var
  FldRec: TFldRec;
begin
  FErrorCode:= 0;
  if FInitialized then
  begin
    FbfaApplication^.WriteLog(llHigh, ltInfo, 'Save(FldID: ' + IntToStr(FID) + ')', ClassName);
    try
      FldRec.ArchiveID:= FArchiveID;
      FldRec.FldID:= FID;
      FldRec.DisplayName:= FName;
      FldRec.DefaultValue:= FDefaultValue;
      FldRec.FieldType:= FObjType;
      FldRec.IndexTableID:= FIndexTableID;
      FldRec.ValueType:= FValueType;
      FldRec.ControlType:= FControlType;
      FldRec.Mode:= FMode;
      FldRec.Options:= FOptions;
      FldRec.Description:= FDescription;
      FldRec.Enabled:= FEnabled;  
      FldRec.ControlItems:= FControlItems; 
      FldRec.Size:= FSize;       
      FldRec.Status:= FStatus;
    
//      FErrorCode:= FbfaApplication^.Connection.UpdateField(FldRec);
      FErrorCode:= FbfaApplication^.Connection.UpdateFieldInheritedMapping(FArchiveLayoutID, FldRec);

      FFieldPermissionsModified := False;
      
      Result:= FErrorCode;
    except
      FErrorCode:= ecAdditionalFieldFailureInSave;
      FbfaApplication^.WriteLog(llNormal, ltException, sSysErrorCode + ': ' + IntToStr(FErrorCode), ClassName);
      Result:= FErrorCode;
    end;
  end
  else
  begin
    FErrorCode:= ecAdditionalFieldConnectionOrLogIsNotInitialized;
    Result:= FErrorCode;
  end;
end;
//
//  Name: Load
//  Parameters: AddFldID
//  Beschreibung: Ldt ein AdditionalField mit der bergebenen AddFldID 
//  Description: Load the Additional Field By ID
//  Return value: ErrorCode
// [] 17.04.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TbfaClientField.Load(FldID: Int64): Integer;
var  
  BaseFieldRec: TBaseFldRec;
  FldRec: TFldRec;
begin
  FErrorCode:= 0;
  if FInitialized then
  begin
    FbfaApplication^.WriteLog(llHigh, ltInfo, 'Load(FldID: ' + IntToStr(FldID) + ')', ClassName);
    try
      FErrorCode:= FbfaApplication^.Connection.SelectBaseFieldByID(FldID, BaseFieldRec);
      if FErrorCode = 0 then
      begin
        FID:= BaseFieldRec.FldID;
        FName:= BaseFieldRec.DisplayName;
        FDefaultValue:= BaseFieldRec.DefaultValue;
        FObjType:= BaseFieldRec.FieldType;
        FIndexTableID:= BaseFieldRec.IndexTableID;
        FValueType:= BaseFieldRec.ValueType;
        FControlType:= BaseFieldRec.ControlType;
        FMode:= BaseFieldRec.Mode;
        FOptions:= BaseFieldRec.Options;
        FDescription:= BaseFieldRec.Description;
        FEnabled:= BaseFieldRec.Enabled;  
        FControlItems:= BaseFieldRec.ControlItems; 
        FSize:= BaseFieldRec.Size;    
        FStatus:= BaseFieldRec.Status;
        FUserRead:= False;
        FUserWrite:= False;
        FUserModify:= False;
        FHasRights:= False;

        Result:= FErrorCode;
        if FArchiveID > 0 then
        begin   
        
          if (FbfaApplication^.Connection.SelectFieldByArchiveID(FID, FArchiveID, FbfaApplication^.User.ID, FMaxUsrColumn, FMaxGrpColumn, FldRec) <> nil) then // kann sein das es ist hier noch 10001 weil noch nicht gespeichert ist im Arcvhiv, aber will schon die Werte ndern
          begin
            FDefaultValue:= FldRec.DefaultValue;
            FMode:= FldRec.Mode;
            FOptions:= FldRec.Options;
            FDescription:= FldRec.Description;
            FControlItems:= FldRec.ControlItems; 
            FUserRead:= FldRec.UserRead;
            FUserWrite:= FldRec.UserWrite;
            FUserModify:= FldRec.UserModify;
            FHasRights:= FldRec.HasRights;

            FArchiveLayoutID:= FArchiveLayoutID; 
          end;
          
        end;
        FLoaded := True;
      end;

    except
      FErrorCode:= ecAdditionalFieldFailureInLoad;
      FbfaApplication^.WriteLog(llNormal, ltException, sSysErrorCode + ': ' + IntToStr(FErrorCode), ClassName);
      Result:= FErrorCode;
    end;
  end
  else
  begin
    FErrorCode:= ecAdditionalFieldConnectionOrLogIsNotInitialized;
    Result:= FErrorCode;
  end;
end;
//
function TbfaAdminField.Load(FldID: Int64): Integer;
var  
  FldRec : TFldRec;
  i : Integer;
begin
  FErrorCode:= 0;
  if FInitialized then
  begin
    FbfaApplication^.WriteLog(llHigh, ltInfo, 'Load(FldID: ' + IntToStr(FldID) + ')', ClassName);
    try
      FErrorCode:= inherited Load(FldID);
      if FErrorCode = 0 then
      begin
        FLoaded := False;

        if FArchiveID > 0 then
        begin   
          for i := 0 to FFieldPermissions.Count - 1 do
            FFieldPermissions.Items[i].Free;

          FFieldPermissions.Clear;
//
//          if FMaxUsrColumn > 0 then
//            FMaxUserIdx := (1 + FMaxUsrColumn) * 64
//          else
//            FMaxUserIdx := 64;
//          SetLength(FUserRights, FMaxUserIdx);
//          for i:= 0 to FMaxUserIdx do
//            FUserRights[i]:= 0;  
//
//          SetLength(FUserRightsUnSetter, FMaxUserIdx);
//          for i:= 0 to FMaxUserIdx do
//            FUserRightsUnSetter[i]:= 0;  
//
//          if FMaxGrpColumn > 0 then
//            FMaxGroupIdx := (1+ FMaxGrpColumn) * 64
//          else
//            FMaxGroupIdx := 64;
//          SetLength(FGroupRights, FMaxGroupIdx);
//          for i:= 0 to FMaxGroupIdx do
//            FGroupRights[i]:= 0; 
//
//          SetLength(FGroupRightsUnSetter, FMaxGroupIdx);
//          for i:= 0 to FMaxGroupIdx do
//            FGroupRightsUnSetter[i]:= 0;
        
        
          FErrorCode:= FbfaApplication^.Connection.SelectAdminFieldByArchiveID(FID, FArchiveID, -1, FMaxUsrColumn, FMaxGrpColumn, FldRec, FFieldPermissions);
        
          if FErrorCode = 0 then // kann sein das es ist hier noch 10001 weil noch nicht gespeichert ist im Arcvhiv, aber will schon die Werte ndern
          begin
            FDefaultValue:= FldRec.DefaultValue;
            FMode:= FldRec.Mode;
            FOptions:= FldRec.Options;
            FDescription:= FldRec.Description;
            FControlItems:= FldRec.ControlItems; 

            FArchiveLayoutID:= FArchiveLayoutID; 
          end;

        end;
        FFieldPermissionsModified := False;
        
        FLoaded := True;
        Result:= FErrorCode;
      end;

    except
      FErrorCode:= ecAdditionalFieldFailureInLoad;
      FbfaApplication^.WriteLog(llNormal, ltException, sSysErrorCode + ': ' + IntToStr(FErrorCode), ClassName);
      Result:= FErrorCode;
    end;
  end
  else
  begin
    FErrorCode:= ecAdditionalFieldConnectionOrLogIsNotInitialized;
    Result:= FErrorCode;
  end;
end;
////
//function TbfaAdminField.GetUserRights(Idx: Integer): Integer;
//begin
//  Result:= FUserRights[Idx];
//end;
////
//procedure TbfaAdminField.SetUserRights(Idx: Integer; Value: Integer);  
//begin
//  FUserRights[Idx]:= Value;
//end;
////
//function TbfaAdminField.GetUserRightsUnSetter(Idx: Integer): Integer;
//begin
//  Result:= FUserRightsUnSetter[Idx];
//end;
////
//procedure TbfaAdminField.SetUserRightsUnSetter(Idx: Integer; Value: Integer);  
//begin
//  FUserRightsUnSetter[Idx]:= Value;
//end;
////
//function TbfaAdminField.GetGroupRights(Idx: Integer): Integer;
//begin
//  Result:= FGroupRights[Idx];
//end;
////
//procedure TbfaAdminField.SetGroupRights(Idx: Integer; Value: Integer);
//begin
//  FGroupRights[Idx]:= Value;
//end;
////
//function TbfaAdminField.GetGroupRightsUnSetter(Idx: Integer): Integer;
//begin
//  Result:= FGroupRightsUnSetter[Idx];
//end;
////
//procedure TbfaAdminField.SetGroupRightsUnSetter(Idx: Integer; Value: Integer);
//begin
//  FGroupRightsUnSetter[Idx]:= Value;
//end;
////
//function TbfaAdminField.GetMaxUserRights: Integer;
//begin
//  Result:= High(FUserRights);
//end;
////
//function TbfaAdminField.GetMaxGroupRights: Integer;
//begin
//  Result:= High(FGroupRights);                            
//end;
//
function TbfaAdminField.CopyToBaseField(Fld: TbfaBaseField): Integer;
begin
  Fld.ID:= FID;
  Fld.DefaultValue:= FDefaultValue;
  Fld.DisplayName:= FName;
  Fld.ObjType:= FObjType;
  Fld.ValueType:= FValueType;
  Fld.ControlType:= FControlType;
  Fld.Description:= FDescription;
  Fld.Enabled:= FEnabled;
  Fld.ControlItems:= FControlItems;
  Fld.Size:= FSize;
  Fld.Status:= FStatus;
  Fld.Mode:= FMode;
  Fld.Options:= FOptions;
  Fld.Modified:= FModified;
  Fld.IndexTableID:= FIndexTableID;
end;
//

end.
