unit bfaMethods;

interface

uses 
  bfaLog, bfaConnection;

//
function CommonInit(var ActLog: TbfaLog; var ActConnection: TbfaConnection;
                      Log: TbfaLog; Connection: TbfaConnection; var Initialized: boolean): Integer; 
function CommonLogInit(var ActLog: TbfaLog; Log: TbfaLog; var Initialized: boolean): Integer; 
//

implementation

uses
  bfaCommonUtils;

//
//  Name: CommonInit
//  Parameters:
//  Description: Set the Log and connection objects
//  Return value: ErrorCode
// [] 17.04.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function CommonInit(var ActLog: TbfaLog; var ActConnection: TbfaConnection;
                      Log: TbfaLog; Connection: TbfaConnection; var Initialized: boolean): Integer; 
var
  ECode: Integer;
begin
  ECode:= 0;
  Initialized:= false;
  if (Log <> nil) then
  begin
    if (Connection <> nil) then
    begin
      try
        ActLog:= Log as TbfaLog;
        Result:= ECode;
        if ECode = 0 then
        begin
          try
            ActConnection:= Connection as TbfaConnection;
            Initialized:= true;
            Result:= ECode;
          except
            ECode:= ecFailureInInitConnectionAndLog;
            Result:= ECode;
          end;
        end
        else
        begin
          ECode:= ecFailureInInitConnectionAndLog;
          Result:= ECode;
        end;
      except
        ECode:= ecFailureInInitConnectionAndLog;
        Result:= ECode;
      end;
    end
    else
    begin
      ECode:= ecConnectionIsNotInitialized;
      Result:= ECode;
    end;
    end
  else
  begin
    ECode:= ecLogIsNotInitialized;
    Result:= ECode;
  end;
end;
//
//  Name: CommonLogInit
//  Parameters:
//  Description: Set the Log object
//  Return value: ErrorCode
// [] 17.04.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function CommonLogInit(var ActLog: TbfaLog; Log: TbfaLog; var Initialized: boolean): Integer; 
var
  ECode: Integer;
begin
  ECode:= 0;
  Initialized:= false;
  if (Log <> nil) then
  begin
    try
      ActLog:= Log as TbfaLog;
      Result:= ECode;
    except
      ECode:= ecFailureInInitLog;
      Result:= ECode;
    end;
  end
  else
  begin
    ECode:= ecLogIsNotInitialized;
    Result:= ECode;
  end;
end;
//

end.
