unit bfaMySQLDatabaseScripts;

interface

uses    
  Generics.Collections,
  bfaBaseObjects, Uni, ADODB, bfaLog, bfaConnection,
  bfaMySQLDataAccessDM, bfaSP, 
  DB,
  bfaUser, Classes;

type
  TMySQL = class(TObject)
    function LoadUser(Cnt : PbfaConnection; UserObj : PbfaUserGroupBase) : Integer;
    function SelectArchiveNameByID(Cnt : Pbfaconnection; ArcID : Int64) : WideString;
    function LoadGroup(Cnt : PbfaConnection; GroupObj : PbfaUserGroupBase): Integer;
    function Login(Cnt : PbfaConnection; UserObj : PbfaUserGroupBase) : Integer;
    function GetDMSRoot(Cnt : Pbfaconnection; DmsRoot : WideString) : Int64;
    function CheckIfDMSAdmin(Cnt : Pbfaconnection; ParentID, ObjID : Int64; ObjType : Integer) : Boolean;
    function SelectRoles(Cnt : PbfaConnection; Role: WideString): TBfaSP;
    function CheckIfObjectExsitsOnLevel(Cnt : Pbfaconnection; ParentID, ObjID : Int64; ObjType : Integer; TblName : string) : Boolean;
    function GetObjectDetailsByID(Cnt : PbfaConnection; ID : Int64; var LayoutRec : TLayoutRec; TblName : string) : Integer;
    function SelectLayoutIDByObjectIDs(Cnt : PbfaConnection; ObjID, ParentID : Int64; OType : Integer) : Int64;
    function GetUserArchiveApplicationRights(Cnt : PbfaConnection; UserID, ParentID : Int64) : TbfaSP;
    function GetLayoutRootObjects(Cnt : PbfaConnection; Typ : Integer) : TbfaSP;
    function SelectUserContainers(Cnt : PbfaConnection) : TbfaSP;
    function CheckIfExistsAndHasRight(Cnt : PbfaConnection; ParentID, ObjID : Int64; ObjType, Rights : Integer) : Boolean;
    function GetLayoutArchivesWithIdxParams(Cnt: PbfaConnection; LeftIdx, RightIdx: Int64; Level, ObjType: Integer): TbfaSP;
    function UpdateUserPwd(Cnt : PbfaConnection; UserID, MandantID : Int64; UserName, Password : WideString) : Integer;
    function AddObjectToLayout(Cnt : PbfaConnection; ParentID, ObjID: Int64; ObjType: Integer; ObjName: WideString; InheritPermission, InheritAdditionalField: Boolean): Int64;
    function CreateUser(Cnt : PbfaConnection; FirstName, MiddleName, LastName, UserName, Password, EMail, Description: WideString; iState: Integer; MandantID, LayoutID: Int64; SaveImmediately: Boolean; var UserLayoutID, ContainerID : Int64): Int64;
    function CheckIfUserAdminInOtherContainer(Cnt : PbfaConnection; ObjID, ParentID: Int64; ObjType: Integer): Boolean;
    function SelectObjectsMandant(Cnt : PbfaConnection; ObjID: Int64; ObjType : Integer; var MandantName: WideString): Int64;
    function CheckUser(Cnt : PbfaConnection; UserID : Int64; UserName, Password : WideString; MandantID : Int64): Integer;
    function CheckGroup(Cnt : PbfaConnection; GroupName : WideString; GroupID, MandantID : Int64): Integer;
    function UpdateUser(Cnt : PbfaConnection; UserID, MandantID : Int64; UserName, Email, Description, FirstName, LastName, MiddleName, Password: WideString; Status: Integer; OnlyUserName: Boolean = False): Int64;
    function CreateGroup(Cnt : PbfaConnection; GroupName, Description, Email : WideString; MandantID, LayoutID: Int64; SaveImmediately: Boolean; var GroupLayoutID, ContainerID : Int64): Int64;
    function UpdateGroup(Cnt : PbfaConnection; GroupID, MandantID : Int64; GroupName, Description, Email : WideString; OnlyGroupName : Boolean) : Int64;
    function SelectGroupSysGrpUsrID(Cnt : PbfaConnection; GroupID: Int64): Int64;
    function SelectGroupSysGrpUsrParentID(Cnt : PbfaConnection; SysGrpID: Int64): Int64;
    function CreateArchive(Cnt : PbfaConnection; ArcName, BgrPicture, DefDocName, Description: WideString; ParentID, UserID: Int64; ArchiveType, Icon: Integer; DMSAdmin, InheritPermission, InheritAdditionalField: Boolean; Kind: TbfaTreeViewKind; var ArcID, LayoutID : Int64): Integer;

    

    
    function SelectProfiles(Cn: TUniConnection; Log: TbfaLog): TbfaSp;
    function SelectProfileCfgByID(Cn: TUniConnection; ClientID: Int64; Conn: TbfaConnection; Log: TbfaLog): Integer;
    function GetUserApplicationRights(Cn: TUniConnection; Log: TbfaLog; UserID: Int64): TbfaSP;
    function GetArchivesByUserID(Cn: TUniConnection; Log: TbfaLog; UserID: Int64; LeftIdx, RightIdx: Int64; UserRight: Integer) : TbfaSP;
    function GetArchivesByUserIDReturnWithList(Cn: TUniConnection; Log: TbfaLog; UserID: Int64; LeftIdx, RightIdx: Int64; UserRight: Integer; GrpList : Boolean = False; ArcIDs : WideString = '') : WideString;    function SelectContainerDescription(Cn: TUniConnection; Log: TbfaLog; ID: Int64): WideString;
    function LoadArchive(DM: TbfaMySQLDataAccess; Cn: TUniConnection; LayoutID: Int64; var ArcRec: TArchiveRec; Log: TbfaLog): Integer;
    function LoadDocument(DM: TbfaMySQLDataAccess; Cn: TUniConnection; GDocID: Int64; var DocRec: TDocumentRec; Log: TbfaLog): Integer;
    function GetLayoutUsersAndGroups(Cn: TUniConnection; Log: TbfaLog; ParentID: Int64): TbfaSP;
    function SelectUsers(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog): TDataSet;
    function SelectGroups(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog): TDataSet;
    function SelectAllFields(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog): TbfaSP;
    function SelectAddUsers(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog): TDataSet;
    function SelectAddGroups(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog): TDataSet;
    function SelectGroupMembers(Cn: TUniConnection; Log: TbfaLog; ObjID, MandantID: Int64): TbfaSp;
    function InsertObjectToSysGrpUsr(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; ParentID, ObjID, MandantID: Int64; ObjType: Integer): Integer;
    function SelectObjectRights(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; ParentID, ObjID: Int64; ObjType: Integer): Int64;
    function UpdateRightsToObject(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; ArchiveID, ObjID, Rights: Int64; ObjType: Integer): Int64;
//    function SelectArchivenamesByIDs(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; IDs: string): WideString;
//    function SelectObjectsWithMemberIDs(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; IDs, TableName: string): TDataSet;
    function SelectWhereObjMember(Cn: TUniConnection; Log: TbfaLog; ObjID: Int64; ObjType: Integer): TbfaSP;
    function DeleteArchive(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; LayoutID: Int64): Integer;
    function UpdateArchive(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; LayoutID, ArcID: Int64; ArcName, BgrPicture, DocName, Description: WideString; InheritPermission, InheritAdditionalField, OnlyArcName: Boolean; Icon: Integer; Kind: TbfaTreeViewKind): Int64;
    function UpdateArchiveGUILayout(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; ArcID: Int64; ArchiveLayout: TMemoryStream): Integer;
//    function DeleteUserOrGroupFromSysLayout(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; ParentID, ObjID: Int64; ObjType: Integer): Integer;
//    function DeleteUserOrGroup(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; ObjID: Int64; ObjType: Integer): Integer;
    function SelectLayoutWhereObjMember(Cn: TUniConnection; Log: TbfaLog; ObjID: Int64; ObjType: Integer): TbfaSP;
//    function SelectAdditionalAndStatusFields(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog): TDataSet;
    function InsertField(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; DisplayName, Description, DefaultValue, ControlItems: WideString; 
      FieldType, ControlType, ValueType, Mode, FieldOptions, IndexTableID, Size: Integer; ControlEnabled: Boolean; LayoutID: Int64; 
      SaveImmediately : Boolean; var ContainerID : Int64): Int64;
    function CreateBaseField(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; 
      DisplayName, Description, DefaultValue, ControlItems: WideString; 
      FieldType, ControlType, ValueType, Mode, FieldOptions, IndexTableID, Size: Integer; 
      ControlEnabled: Boolean; LayoutID : Int64; SaveImmediately: Boolean; var ContainerID: Int64): Int64;
    function GetSysDocIdxCounter(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog): Integer;
    function CheckIfColumnExists(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; DBName, TableName, ColumnName: string): Boolean;
    function GetFieldSize(FieldType: Integer; Size: Integer = 255): Integer;
    function GetTableFieldSize(FieldType: String): Integer;
    function SelectTableColumns(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; DBName, TableName: String): TDataSet;
    function GetTableRowSize(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; Tablename: String): Integer;
    function CreateIndexTable(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; TableName, ColumnName: String): Integer;
    function ValueTypeToString(ValueType: Integer; Size: Integer = 255): String;
    function AlterIndexTable(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; TableName, ColumnName: String): Integer;
    function UpdateFieldIndexTableID(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; AddFieldID: Int64; IndexTableID: Integer): Integer;
    function SelectBaseFieldByID(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; AddFldID: Int64; var FldRec: TBaseFldRec): Integer;
    function UpdateBaseField(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; Field: TBaseFldRec; OnlyName : Boolean): Integer;
    function UpdateField(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; Field: TFldRec): Integer;
    function UpdateFieldInheritedMapping(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; LayoutID: Int64; Field: TFldRec): Integer;
    function DeleteUserOrGroupFromGroup(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; ObjID, ParentID: Int64; ObjType: Integer): Integer;
    function DeleteObjectFromFieldMapping(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; LayoutID, ObjID: Int64): Integer;
    function SelectFields(Cn: TUniConnection; Log: TbfaLog; ArchiveID: Int64): TBfaSp;
    function CheckIfFieldExists(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; DisplayName: WideString): Integer;
    function GetFieldValue(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; typ: Integer; id: Int64; coltyp: Integer = 0): WideString;
    function GetContainerObjects(Cn: TUniConnection; Log: TbfaLog; ArchiveLayoutID: Int64; ContainerType, ListType, SQLType: Integer; LayoutIDs: string): TbfaSP;
    function AddObjectToUserMapping(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; LayoutID, ObjID, Rights, RoleID: Int64; ObjType: Integer): Int64;
    function UpdateObjectInUserMapping(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; LayoutID, ObjID, Rights: Int64; ObjType: Integer): Int64;
    function SelectAvailableUsers(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; ArchiveLayoutID: Int64; FullList: Integer): TDataSet;
    function SelectAvailableGroups(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; ArchiveLayoutID: Int64; FullList: Integer): TDataSet;
    function SelectArchiveAncestorObjects(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; LayoutID: Int64): TbfaSP;
    function DeleteObjectFromUserMapping(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; LayoutID, ObjID: Int64; ObjType: Integer): Integer;
    function CheckIfGrpUsrObjectExsitsOnLevel(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; ParentID, ObjID, MandantID: Int64; ObjType: Integer): Boolean;
    function DeleteContainer(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; LayoutID: Int64): Integer;
    function DeleteObject(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; LayoutID: Int64): Integer;
    function AddObjectToFieldMapping(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; LayoutID, FieldID, ArchiveID: Int64; ObjType: Integer; DefaultValue, Description, ControlItems: WideString; Mode, PrmOptions: Integer): Int64;
    function SelectFieldByArchiveID(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; FldID, ArchiveID, UserID: Int64; UserIdx, GroupIdx: Integer; var FldRec: TFldRec): TbfaSP;
    function SelectAdminFieldByArchiveID(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; FldID, ArchiveID, UserID: Int64; UserColumn, GroupColumn: Integer; var FldRec: TFldRec; List : TList<TbfaPermission>): Integer;
    function UpdateLayoutRights(Cn: TUniConnection; Log: TbfaLog; LayoutID, Rights, RoleID: Int64): Integer;
    function UpdateContainerDescription(Cn: TUniConnection; Log: TbfaLog; LayoutID: Int64; Description: WideString): Integer;
    function CopyNode(Cn: TUniConnection; Log: TbfaLog; ParentID: Int64; ObjType: Integer; NewParentID, NewObjID: Int64): Int64;
    function SelectFieldPermissions(Cn: TUniConnection; Log: TbfaLog; ArcID, AddFieldID: Int64; var UsrIdx, GrpIdx: Integer): TBfaSP;
    function UpdateInheritedFieldRights(Cn: TUniConnection; Log: TbfaLog; LayoutID, ArcID, AddfieldID: Int64; Idx, ObjType: Integer; Read, Write, Modify, UnsetRights: UInt64): Integer;
    function SelectMaxUsrGrpIdx(Cn: TUniConnection; Log: TbfaLog; var UsrIdx, GrpIdx: Integer): Integer;
    function SelectDMSRootArchiveID(Cn: TUniConnection; Log: TbfaLog): Int64;
    function CreateDocument(Cn: TUniConnection; Log: TbfaLog; DocLoc, OriLoc, ExtLoc, Srcloc, DocName: WideString; 
                            UserID: Int64; CheckOut, RevSave: Boolean; ArcID: Int64; PageCount, docType: Integer;
                            FileType: string; DocTxt, DocTags: WideString): Int64;
    function InsertDocTxt(Cn: TUniConnection; Log: TbfaLog; GDocID : Int64; DocTxt, DocTags: WideString): Int64;
                            


  end;

var
  MySQL : TMySQL;

implementation

uses 
  bfaCommonUtils, SysUtils, bfaMethods, bfaCommonMethods;

//
function TMySQL.LoadUser(Cnt : Pbfaconnection; UserObj : PbfaUserGroupBase) : Integer;
var
  FErrorCode : Integer;
  FbfaSP : TbfaSP;
begin
  FErrorCode := 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.LoadUser', 'bfaMySQLDatabaseScriptsU');
  FbfaSP := TbfaSP.Create(Cnt^.MySQLConnection, sSpSelectUserByID);
  try
    FbfaSP.PrepareSQL;
    FbfaSP.SetParamByNameAsLargeInt(sPrmUserID, UserObj^.ID); 
    FbfaSP.Execute;
    if FbfaSP.RecordCount > 0 then
    begin
      with PbfaUser(UserObj)^ do
      begin
        Name := FbfaSP.FieldByNameAsWideString(sColUserName);
        FirstName := FbfaSP.FieldByNameAsWideString(sColFirstName);
        LastName := FbfaSP.FieldByNameAsWideString(sColLastName);
        MiddleName := FbfaSP.FieldByNameAsWideString(sColMiddleName);
        Description := FbfaSP.FieldByNameAsWideString(sColDescription);
        Password := FbfaSP.FieldByNameAsWideString(sColPassword);
        Email := FbfaSP.FieldByNameAsWideString(sColUserEmail);
        Status := FbfaSP.FieldByNameAsInteger(sColState);   
        MandantID := FbfaSP.FieldByNameAsLargeInt(sColMandant); 
        ContainerID := -1;
      end;


      Cnt^.Log.Write(llDebug, ltDebug, 'userid: ' + IntToStr(PbfaUser(UserObj)^.ID) + ', ' +
                  'username: ' + PbfaUser(UserObj)^.Name ,  'bfaMySQLDatabaseScriptsU');    
    end
    else
    begin
      FErrorCode := ecNoRecord;
      Cnt^.Log.Write(llNormal, ltError, 'spSelectUserByID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    end;

    Result := FErrorCode;
  except
    FErrorCode := ecConnectionLoadUserFailure;
    Cnt^.Log.Write(llNormal, ltException, 'spSelectUserByID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result := FErrorCode;
  end;
end;
//
function TMySQL.SelectArchiveNameByID(Cnt : Pbfaconnection; ArcID : Int64) : WideString;
var
  FErrorCode : Integer;
  FbfaSP : TbfaSP;
begin
  FErrorCode := 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.SelectArchiveNameByID', 'bfaMySQLDatabaseScriptsU');
  FbfaSP := TbfaSP.Create(Cnt^.MySQLConnection, sSpSelectArchiveNameByID);
  try
    FbfaSP.PrepareSQL;
    FbfaSP.SetParamByNameAsLargeInt(sPrmArcID, ArcID); 
    FbfaSP.Execute;

    Result := FbfaSP.ParamByNameAsWideString(sSysResult);
  except
    FErrorCode := ecConnectionSelectArchiveNameByIDFailure;
    Cnt^.Log.Write(llNormal, ltException, 'spSelectArchiveNameByID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result := '';
  end;
end;
//
function TMySQL.LoadGroup(Cnt : Pbfaconnection; GroupObj : PbfaUserGroupBase): Integer;
var
  FErrorCode : Integer;
  FbfaSP : TbfaSP;
begin
  FErrorCode := 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.LoadGroup', 'bfaMySQLDatabaseScriptsU');
  FbfaSP := TbfaSP.Create(Cnt^.MySQLConnection, sSpSelectGroupByID);
  try
    FbfaSP.PrepareSQL;
    FbfaSP.SetParamByNameAsLargeInt(sPrmGroupID, GroupObj^.ID); 
    FbfaSP.Execute;
    if FbfaSP.RecordCount > 0 then
    begin
      with PbfaGroup(GroupObj)^ do
      begin
        Name := FbfaSP.FieldByNameAsWideString(sColGrpName);
        Description := FbfaSP.FieldByNameAsWideString(sColDescription);
        Email := FbfaSP.FieldByNameAsWideString(sColEmail);
        SysGrpID := MySQL.SelectGroupSysGrpUsrID(Cnt, ID);
        ParentID := MySQL.SelectGroupSysGrpUsrParentID(Cnt, SysGrpID);
        MandantID := FbfaSP.FieldByNameAsLargeInt(sColMandant); 
        ContainerID := -1;
      end;
    end;


      Cnt^.Log.Write(llDebug, ltDebug, 'groupid: ' + IntToStr(PbfaGroup(GroupObj)^.ID) + ', ' +
                  'groupname: ' + PbfaGroup(GroupObj)^.Name ,  'bfaMySQLDatabaseScriptsU');    

    Result := FErrorCode;
  except
    FErrorCode := ecConnectionLoadGroupFailure;
    Cnt^.Log.Write(llNormal, ltException, 'SpSelectGroupByID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result := FErrorCode;
  end;
end;
//
function TMySQL.Login(Cnt : Pbfaconnection; UserObj : PbfaUserGroupBase) : Integer;
var
  FErrorCode : Integer;
  FbfaSP : TbfaSP;
begin
  FErrorCode:= 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.Login', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cnt^.MySQLConnection, sSpLogin);
  try
    try
      FbfaSP.PrepareSQL;
      
      FbfaSP.SetParamByNameAsWideString(sPrmUserName, UserObj^.Name);
      FbfaSP.SetParamByNameAsWideString(sPrmPassword, PbfaUser(UserObj)^.Password);

      FbfaSP.Execute;
        if FbfaSP.ParamByNameAsLargeInt(sPrmResult) > 0 then
        begin
          UserObj.ID:= FbfaSP.ParamByNameAsLargeInt(sPrmResult)
        end
        else if FbfaSP.ParamByNameAsInteger(sPrmStatus) = stLocked then
          FErrorCode := ecConnectionUserLocked
        else
        begin
          FErrorCode := ecNoRecord;
          Cnt^.Log.Write(llNormal, ltError, 'spLogin - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
        end;
      
        Result := FErrorCode;
    except
      FErrorCode := ecConnectionLoginFailure;
      Cnt^.Log.Write(llNormal, ltException, 'spLogin - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result := FErrorCode;
    end;
  finally
    FbfaSP.Free;
  end;
end;
//
function TMySQL.GetDMSRoot(Cnt : Pbfaconnection; DmsRoot : WideString) : Int64;
var
  FErrorCode : Integer;
  FbfaSP : TbfaSP;
begin
  FErrorCode := 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.GetDMSRoot', 'bfaMySQLDatabaseScriptsU');
  FbfaSP := TbfaSP.Create(Cnt^.MySQLConnection, sSpSelectDMSRoot);
  try
    try
      FbfaSP.PrepareSQL;
      
      FbfaSP.SetParamByNameAsWideString(sPrmRoot, DMSRoot);
      FbfaSP.SetParamByNameAsInteger(sPrmRootType, otRoot);

      FbfaSP.Execute;
      
      Result := FbfaSP.FieldByNameAsLargeInt(sColID)
    except
      FErrorCode := ecConnectionLoginFailure;
      Cnt^.Log.Write(llNormal, ltException, 'SpSelectDMSRoot - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result := FErrorCode;
    end;
  finally
    FbfaSP.Free;
  end;
end;
//
function TMySQL.CheckIfDMSAdmin(Cnt : PbfaConnection; ParentID, ObjID : Int64; ObjType : Integer) : Boolean;
var
  FErrorCode : Integer;
  FbfaSP : TbfaSP;
begin
  FErrorCode := 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.CheckIfDMSAdmin', 'bfaMySQLDatabaseScriptsU');
  FbfaSP := TbfaSP.Create(Cnt^.MySQLConnection, sSpSelectLayoutRights);
  try
    try
      FbfaSP.PrepareSQL;
      
      FbfaSP.SetParamByNameAsLargeInt(sPrmParentID, ParentID);
      FbfaSP.SetParamByNameAsLargeInt(sPrmObjID, ObjID);
      FbfaSP.SetParamByNameAsInteger(sPrmType, ObjType);
      FbfaSP.SetParamByNameAsInteger(sPrmUserType, otUser);
      FbfaSP.SetParamByNameAsInteger(sPrmGroupType, otGroup);

      FbfaSP.Execute;
      
      if  FbfaSp.ParamByNameAsInteger(sPrmResult) = 1 then
        Result := True
      else
        Result := False;
    except
      FErrorCode := ecConnectionCheckIfDMSAdminFailure;
      Cnt^.Log.Write(llNormal, ltException, 'CheckIfDMSAdmin - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result := False;
    end;
  finally
    FbfaSP.Free;
  end;
end;
//
function TMySQL.SelectRoles(Cnt : PbfaConnection; Role: WideString): TBfaSP;
var
  FErrorCode : Integer;
  FbfaSP : TbfaSP;
begin
  FErrorCode := 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.SelectRoles', 'bfaMySQLDatabaseScriptsU');
  FbfaSP := TbfaSP.Create(Cnt^.MySQLConnection, sSpSelectCfgByParams);
  try
    FbfaSP.PrepareSQL;
    FbfaSP.SetParamByNameAsLargeInt(sPrmClientID, ciServer); 
    FbfaSP.SetParamByNameAsString(sPrmParam, Role);  
    FbfaSP.Open;
    Result := FbfaSP;
  except
    FErrorCode:= ecConnectionSelectRolesFailure;
    Cnt^.Log.Write(llNormal, ltException, 'SelectRoles - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result := nil;
  end;
end;
//
function TMySQL.CheckIfObjectExsitsOnLevel(Cnt : Pbfaconnection; ParentID, ObjID : Int64; ObjType : Integer; TblName : string) : Boolean;
var
  FErrorCode : Integer;
  FbfaSP : TbfaSP;
begin
  FErrorCode := 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.CheckIfObjectExsitsOnLevel', 'bfaMySQLDatabaseScriptsU');
  FbfaSP := TbfaSP.Create(Cnt^.MySQLConnection, sSpCheckIfObjectExistsOnLevel);
  try
    FbfaSP.PrepareSQL;
                  
    FbfaSP.SetParamByNameAsLargeInt(sPrmParentID, ParentID);
    FbfaSP.SetParamByNameAsLargeInt(sPrmObjID, ObjID);
    FbfaSP.SetParamByNameAsInteger(sPrmType, ObjType);
    FbfaSP.SetParamByNameAsString(sPrmTableName, TblName);
    FbfaSP.SetParamByNameAsInteger(sPrmUserType, otUser);
    FbfaSP.SetParamByNameAsInteger(sPrmGroupType, otGroup);
    FbfaSP.SetParamByNameAsInteger(sPrmAddFieldType, otAdditionalField);
    FbfaSP.SetParamByNameAsInteger(sPrmStsFieldType, otStatusField);
    FbfaSP.SetParamByNameAsInteger(sPrmUserContainerType, otUserContainer);
    FbfaSP.SetParamByNameAsInteger(sPrmAddStsContainerType, otAddFieldContainer);


    FbfaSP.Execute;

    if FbfaSP.ParamByNameAsInteger(sPrmResult) = 1 then
      Result := True
    else
      Result := False;

    FbfaSP.Free;
  except
    FErrorCode := ecConnectionCheckIfObjectExsitsOnLevelFailure;
    Cnt^.Log.Write(llNormal, ltException, 'spCheckIfObjectExistsOnLevel - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result := False;
  end;
end;
//
function TMySQL.GetObjectDetailsByID(Cnt : PbfaConnection; ID : Int64; var LayoutRec : TLayoutRec; TblName : string) : Integer;
var
  FErrorCode : Integer;
  FbfaSP : TbfaSP;
begin
  FErrorCode := 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.GetObjectDetailsByID', 'bfaMySQLDatabaseScriptsU');
  FbfaSP := TbfaSP.Create(Cnt^.MySQLConnection, sSpSelectObjectDetailsByID);
  try
    FbfaSP.PrepareSQL;
    FbfaSP.SetParamByNameAsLargeInt(sPrmID, ID);
    FbfaSP.SetParamByNameAsString(sPrmTableName, TblName);
    FbfaSP.Execute;

    LayoutRec.LayoutID := ID;
    LayoutRec.ParentID := FbfaSP.ParamByNameAsLargeInt(sPrmParentID);
    LayoutRec.ObjID := FbfaSP.ParamByNameAsLargeInt(sPrmObjID);
    LayoutRec.ObjType := FbfaSP.ParamByNameAsInteger(sPrmObjType);
    LayoutRec.IdxL := FbfaSP.ParamByNameAsLargeInt(sPrmIdxL);
    LayoutRec.IdxR := FbfaSP.ParamByNameAsLargeInt(sPrmIdxR);
    LayoutRec.Level := FbfaSP.ParamByNameAsInteger(sPrmLevel);
//    LayoutRec.Rights := FbfaSP.FieldByNameAsLargeInt(sColRights);
//    LayoutRec.RoleID := FbfaSP.FieldByNameAsLargeInt(sColRoleID);
      
    Result := FErrorCode;
  except
    FErrorCode := ecConnectionSelectObjectDetailsByIDFailure;
    Cnt^.Log.Write(llNormal, ltException, 'spSelectObjectDetailsByID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result := -1;
  end;
end;
//
function TMySQL.SelectLayoutIDByObjectIDs(Cnt : PbfaConnection; ObjID, ParentID : Int64; OType : Integer) : Int64;
var
  FErrorCode : Integer;
  FbfaSP : TbfaSP;
begin
  FErrorCode := 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.SelectLayoutIDByObjectIDs', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cnt^.MySQLConnection, sSpSelectLayoutIDbyObjectIDs);
  try
    FbfaSP.PrepareSQL;

    FbfaSP.SetParamByNameAsLargeInt(sPrmObjID, ObjID);
    FbfaSP.SetParamByNameAsInteger(sPrmObjType, OType);
    FbfaSP.SetParamByNameAsLargeInt(sPrmParentID, ParentID);

    FbfaSP.Open;
    Result:= FbfaSP.ParamByNameAsLargeInt(sPrmResult);
  except
    FErrorCode:= ecConnectionSelectLayoutIDByObjectIDsFailure;
    Cnt^.Log.Write(llNormal, ltException, 'spSelectLayoutIDbyObjectIDs - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= -1;
  end;
end;
//
function TMySQL.GetUserArchiveApplicationRights(Cnt : PbfaConnection; UserID, ParentID : Int64) : TbfaSP;
var
  FErrorCode : Integer;
  FbfaSP : TbfaSP;
begin
  FErrorCode := 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.GetUserArchiveApplicationRights', 'bfaMySQLDatabaseScriptsU');
  FbfaSP := TbfaSP.Create(Cnt.MySQLConnection, sSpSelectArchiveApplicationRightsByUser);
  try
    FbfaSP.PrepareSQL;
  
    FbfaSP.SetParamByNameAsLargeInt(sPrmParentID, ParentID);
    FbfaSP.SetParamByNameAsLargeInt(sPrmUserID, UserID);
    FbfaSP.SetParamByNameAsLargeInt(sPrmUserType, otUser);
    FbfaSP.SetParamByNameAsLargeInt(sPrmGroupType, otGroup);
    FbfaSP.SetParamByNameAsLargeInt(sPrmUserContainerType, otUserContainer);

    FbfaSP.Open;
    Result := FbfaSP;
  except
    FErrorCode := -1;
    Cnt^.Log.Write(llNormal, ltException, 'spSelectArchiveApplicationRightsByUser - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result := nil;
  end;
end;
//
function TMySQL.GetLayoutRootObjects(Cnt : PbfaConnection; Typ : Integer) : TbfaSP;
var
  FErrorCode : Integer;
  FbfaSP : TbfaSP;
begin
  FErrorCode := 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.GetLayoutRootObjects', 'bfaMySQLDatabaseScriptsU');
  FbfaSP := TbfaSP.Create(Cnt^.MySQLConnection, sSpSelectLayoutRoots);
  try
    FbfaSP.PrepareSQL;
    FbfaSp.SetParamByNameAsInteger(sPrmType, Typ);
    FbfaSP.Open;
    
    Result := FbfaSP;
  except
    FErrorCode := ecConnectionGetLayoutRootObjectsFailure;
    Cnt^.Log.Write(llNormal, ltException, 'spSelectLayoutRoots - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result := nil;
  end;
end;
//
function TMySQL.SelectUserContainers(Cnt : PbfaConnection) : TbfaSP;
var
  FErrorCode : Integer;
  FbfaSP : TbfaSP;
begin
  FErrorCode := 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.SelectUserContainers', 'bfaMySQLDatabaseScriptsU');
  FbfaSP := TbfaSP.Create(Cnt^.MySQLConnection, sSpSelectUserContainers);
  try
    FbfaSP.PrepareSQL;
    FbfaSP.SetParamByNameAsInteger(sPrmContainerType, otUserContainer);

    FbfaSP.Open;
    Result := FbfaSP;
  except
    FErrorCode := ecConnectionSelectUserContainers;
    Cnt^.Log.Write(llNormal, ltException, 'SelectUserContainers - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result := nil;
  end;
end;
//
function TMySQL.CheckIfExistsAndHasRight(Cnt : PbfaConnection; ParentID, ObjID : Int64; ObjType, Rights : Integer) : Boolean;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.CheckIfExistsAndHasRight', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cnt^.MySQLConnection, sSpCheckIfExistsAndHasRight);
  try
    FbfaSP.PrepareSQL;
    
    FbfaSP.SetParamByNameAsLargeInt(sPrmParentID, ParentID);
    FbfaSP.SetParamByNameAsLargeInt(sPrmObjID, ObjID);
    FbfaSP.SetParamByNameAsInteger(sPrmType, ObjType);
    FbfaSP.SetParamByNameAsInteger(sPrmRight, Rights);
    FbfaSP.SetParamByNameAsInteger(sPrmUserType, otUser);
    FbfaSP.SetParamByNameAsInteger(sPrmGroupType, otGroup);
    FbfaSP.SetParamByNameAsInteger(sPrmAddFieldType, otAdditionalField);
    FbfaSP.SetParamByNameAsInteger(sPrmStsFieldType, otStatusField);
    FbfaSP.SetParamByNameAsInteger(sPrmUserContainerType, otUserContainer);
    FbfaSP.SetParamByNameAsInteger(sPrmAddStsContainerType, otAddFieldContainer);

    FbfaSP.Execute;
    
    if FbfaSP.ParamByNameAsInteger(sPrmResult) = 1 then
      Result:= True
    else
      Result:= False;
      
  except
    FErrorCode:= ecConnectionCheckIfExistsAndHasRight;
    Cnt^.Log.Write(llNormal, ltException, 'CheckIfExistsAndHasRight - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= False;
  end;
end;
//
function TMySQL.GetLayoutArchivesWithIdxParams(Cnt : PbfaConnection; LeftIdx, RightIdx: Int64; Level, ObjType: Integer): TbfaSP;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.GetLayoutArchivesWithIdxParams', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cnt^.MySQLConnection, sSpSelectLayoutArchivesWithIdxParams);
  try
    FbfaSP.PrepareSQL;

    FbfaSP.SetParamByNameAsLargeInt(sPrmLeft, LeftIdx);
    FbfaSP.SetParamByNameAsLargeInt(sPrmRight, RightIdx);
    FbfaSP.SetParamByNameAsInteger(sPrmLevel, Level);
    FbfaSP.SetParamByNameAsInteger(sPrmType, ObjType);
    FbfaSP.SetParamByNameAsInteger(sPrmRoot, otRoot);
    FbfaSP.SetParamByNameAsInteger(sPrmMandant, otMandant);
    FbfaSP.SetParamByNameAsInteger(sPrmStore, otStore);
    FbfaSP.SetParamByNameAsInteger(sPrmArchive, otArchive);
    FbfaSP.SetParamByNameAsInteger(sPrmRecordArchive, otRecordArchive);
    FbfaSP.SetParamByNameAsInteger(sPrmUserContainerType, otUserContainer);
    FbfaSP.SetParamByNameAsInteger(sPrmAddStsContainerType, otAddFieldContainer);
    FbfaSP.SetParamByNameAsInteger(sPrmUserType, otUser);
    

    FbfaSP.Open;
    Result:= FbfaSP;
  except
    FErrorCode:= ecConnectionGetLayoutArchivesWithIdxParamsFailure;
    Cnt^.Log.Write(llNormal, ltException, 'spSelectLayoutArchivesWithIdxParams - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= nil;
  end;
end;
//
function TMySQL.AddObjectToLayout(Cnt : PbfaConnection; ParentID, ObjID: Int64; ObjType: Integer; ObjName: WideString; InheritPermission, InheritAdditionalField: Boolean): Int64;
var
  FErrorCode : Integer;
  FbfaSP : TbfaSP;
begin
  FErrorCode := 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.CreateUser', 'bfaMySQLDatabaseScriptsU');
  FbfaSP := TbfaSP.Create(Cnt^.MySQLConnection, sSpInsertObjectToLayout);
  try  
    FbfaSP.PrepareSQL;

    FbfaSP.SetParamByNameAsLargeInt(sPrmParentID, ParentID);
    FbfaSP.SetParamByNameAsLargeInt(sPrmObjID, ObjID);
    FbfaSP.SetParamByNameAsInteger(sPrmType, ObjType);
    FbfaSP.SetParamByNameAsWideString(sPrmObjName, ObjName);
    FbfaSP.SetParamByNameAsInteger(sPrmUserType, otUser);
    FbfaSP.SetParamByNameAsInteger(sPrmGroupType, otGroup);
    FbfaSP.SetParamByNameAsInteger(sPrmRoot, otRoot);
    FbfaSP.SetParamByNameAsInteger(sPrmMandant, otMandant);
    FbfaSP.SetParamByNameAsInteger(sPrmArchive, otArchive);
    FbfaSP.SetParamByNameAsInteger(sPrmStore, otStore);
    if InheritPermission then
      FbfaSP.SetParamByNameAsInteger(sPrmInheritPermission, 1)
    else
      FbfaSP.SetParamByNameAsInteger(sPrmInheritPermission, 0);        
    if InheritAdditionalField then
      FbfaSP.SetParamByNameAsInteger(sPrmInheritAdditionalFields, 1)
    else
      FbfaSP.SetParamByNameAsInteger(sPrmInheritAdditionalFields, 0);        
      
    FbfaSP.Execute;       
      
    Result:= FbfaSP.ParamByNameAsLargeInt(sPrmResult);

  except
    FErrorCode := ecConnectionAddObjectToLayoutFailure;
    Cnt^.Log.Write(llNormal, ltException, 'SpInsertObjectToLayout - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result := -1;
  end;
end;
//
function TMySQL.CreateUser(Cnt : PbfaConnection; FirstName, MiddleName, LastName, UserName, Password, EMail, Description: WideString; iState: Integer; MandantID, LayoutID: Int64; SaveImmediately: Boolean; var UserLayoutID, ContainerID : Int64): Int64;
var
  FErrorCode : Integer;
  FbfaSP : TbfaSP;
begin
  FErrorCode := 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.CreateUser', 'bfaMySQLDatabaseScriptsU');
  FbfaSP := TbfaSP.Create(Cnt^.MySQLConnection, sSpCreateUser);
  try
    Cnt^.MySQLTransaction.StartTransaction;
    FbfaSP.PrepareSQL;


    FbfaSP.SetParamByNameAsWideString(sPrmDBName, Cnt^.MySQLConnection.Database);
    FbfaSP.SetParamByNameAsWideString(sPrmFirstName, FirstName);
    FbfaSP.SetParamByNameAsWideString(sPrmMiddleName, MiddleName);
    FbfaSP.SetParamByNameAsWideString(sPrmLastName, LastName);
    FbfaSP.SetParamByNameAsWideString(sPrmUserName, UserName);
    FbfaSP.SetParamByNameAsWideString(sPrmUserPass, Password);
    FbfaSP.SetParamByNameAsWideString(sPrmUserEmail, EMail);
    FbfaSP.SetParamByNameAsWideString(sPrmDescription, Description);
    FbfaSP.SetParamByNameAsInteger(sPrmUserStatus, iState);
    FbfaSP.SetParamByNameAsLargeInt(sPrmMandantID, MandantID);
    FbfaSP.SetParamByNameAsInteger(sPrmDeleted, stDeleted);
    FbfaSP.SetParamByNameAsInteger(sPrmLocked, stLocked);
    FbfaSP.SetParamByNameAsLargeInt(sPrmLayoutID, LayoutID);
    FbfaSP.SetParamByNameAsLargeInt(sPrmContainerID, ContainerID);
    FbfaSP.SetParamByNameAsInteger(sPrmUserType, otUser);
    FbfaSP.SetParamByNameAsInteger(sPrmGroupType, otGroup);
    FbfaSP.SetParamByNameAsInteger(sPrmRoot, otRoot);
    FbfaSP.SetParamByNameAsInteger(sPrmMandant, otMandant);
    FbfaSP.SetParamByNameAsInteger(sPrmArchive, otArchive);
    FbfaSP.SetParamByNameAsInteger(sPrmStore, otStore);
    FbfaSP.SetParamByNameAsInteger(sPrmAddFieldType, otAdditionalField);
    FbfaSP.SetParamByNameAsInteger(sPrmStsFieldType, otStatusField);
    FbfaSP.SetParamByNameAsInteger(sPrmUserContainerType, otUserContainer);
    FbfaSP.SetParamByNameAsInteger(sPrmAddStsContainerType, otAddFieldContainer);
    if SaveImmediately then
      FbfaSP.SetParamByNameAsSmallInt(sPrmSaveImmediately, 1)
    else
      FbfaSP.SetParamByNameAsSmallInt(sPrmSaveImmediately, 0);
      
      
    FbfaSP.Execute;       
      
    UserLayoutID:= FbfaSP.ParamByNameAsLargeInt(sPrmObjLayoutID);
    Result:= FbfaSP.ParamByNameAsLargeInt(sPrmResult);
    if ContainerID = -1 then
      ContainerID := FbfaSP.ParamByNameAsLargeInt(sPrmContainerID);
    
    Cnt^.MySQLTransaction.Commit;

  except
    Cnt^.MySQLTransaction.RollBack;
    FErrorCode := ecConnectionCreateUserFailure;
    Cnt^.Log.Write(llNormal, ltException, 'spInsertUser - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result := -1;
  end;
end;
//
function TMySQL.CheckUser(Cnt : PbfaConnection; UserID : Int64; UserName, Password : WideString; MandantID : Int64): Integer;
var
  FErrorCode : Integer;
  FbfaSP : TbfaSP;
begin
  FErrorCode := 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.CheckUser', 'bfaMySQLDatabaseScriptsU');
  FbfaSP := TbfaSP.Create(Cnt^.MySQLConnection, sSpCheckUser);
  try
    FbfaSP.PrepareSQL;
      
    FbfaSP.SetParamByNameAsLargeInt(sPrmUserID, UserID);
    FbfaSP.SetParamByNameAsWideString(sPrmUserName, UserName);
    FbfaSP.SetParamByNameAsWideString(sPrmUserPass, Password);
    FbfaSP.SetParamByNameAsLargeInt(sPrmMandantID, MandantID);
    FbfaSP.SetParamByNameAsInteger(sPrmDeleted, stDeleted);
    FbfaSP.SetParamByNameAsInteger(sPrmLocked, stLocked);
      
      
    FbfaSP.Execute;       
      
    Result:= FbfaSP.ParamByNameAsInteger(sPrmResult);

  except
    FErrorCode := ecConnectionCheckUserFailure;
    Cnt^.Log.Write(llNormal, ltException, 'spCheckUser - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result := -1;
  end;
end;
//
function TMySQL.UpdateUserPwd(Cnt : PbfaConnection; UserID, MandantID : Int64; UserName, Password : WideString) : Integer;
var
  FErrorCode : Integer;
  FbfaSP : TbfaSP;
begin
  FErrorCode := 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.UpdateUserPwd', 'bfaMySQLDatabaseScriptsU');
  FbfaSP := TbfaSP.Create(Cnt^.MySQLConnection, sSpUpdateUserPwd);
  try
    Cnt^.MySQLTransaction.StartTransaction;

    FbfaSP.PrepareSQL;
    
    FbfaSP.SetParamByNameAsLargeInt(sPrmUserID, UserID);
    FbfaSP.SetParamByNameAsWideString(sPrmUserName, UserName);
    FbfaSP.SetParamByNameAsWideString(sPrmPassword, Password);
    FbfaSP.SetParamByNameAsLargeInt(sPrmMandantID, MandantID);
    FbfaSP.SetParamByNameAsInteger(sPrmDeleted, stDeleted);
    FbfaSP.SetParamByNameAsInteger(sPrmLocked, stLocked);

    FbfaSP.Execute;       
      
    Result:= FErrorCode;   
    Cnt^.MySQLTransaction.Commit;
  except
    Cnt^.MySQLTransaction.Rollback;
    FErrorCode := ecConnectionUpdateUserPwdFailure;
    Cnt^.Log.Write(llNormal, ltException, 'spUpdateUserPwd - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result := -1;
  end;
end;
//
function TMySQL.CheckGroup(Cnt : PbfaConnection; GroupName : WideString; GroupID, MandantID : Int64): Integer;
var
  FErrorCode : Integer;
  FbfaSP : TbfaSP;
begin
  FErrorCode := 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.CheckGroup', 'bfaMySQLDatabaseScriptsU');
  FbfaSP := TbfaSP.Create(Cnt^.MySQLConnection, sSpCheckGroup);
  try
    FbfaSP.PrepareSQL;
      
    FbfaSP.SetParamByNameAsLargeInt(sPrmGroupID, GroupID);
    FbfaSP.SetParamByNameAsWideString(sPrmGroupName, GroupName);
    FbfaSP.SetParamByNameAsLargeInt(sPrmMandantID, MandantID);
      
    FbfaSP.Execute;       
      
    Result:= FbfaSP.ParamByNameAsInteger(sPrmResult);

  except
    FErrorCode := ecConnectionCheckGroupFailure;
    Cnt^.Log.Write(llNormal, ltException, 'spCheckGroup - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result := -1;
  end;
end;
//
function TMySQL.UpdateUser(Cnt : PbfaConnection; UserID, MandantID: Int64; UserName, Email, Description, FirstName, LastName, MiddleName, Password: WideString; Status: Integer; OnlyUserName: Boolean = False): Int64;
var
  FErrorCode : Integer;
  FbfaSP : TbfaSP;
  CanStartTransaction : Boolean;
begin
  FErrorCode := 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.UpdateUser', 'bfaMySQLDatabaseScriptsU');
  FbfaSP := TbfaSP.Create(Cnt^.MySQLConnection, sSpUpdateUser);
  try
    CanStartTransaction := not Cnt^.MySQLTransaction.Active;
    if CanStartTransaction then
      Cnt^.MySQLTransaction.StartTransaction;
  
    FbfaSP.PrepareSQL;
      
    FbfaSP.SetParamByNameAsLargeInt(sPrmUserID, UserID);
    FbfaSP.SetParamByNameAsWideString(sPrmUserName, UserName);
    FbfaSP.SetParamByNameAsWideString(sPrmUserEmail, Email);
    FbfaSP.SetParamByNameAsInteger(sPrmUserStatus, Status);
    FbfaSP.SetParamByNameAsWideString(sPrmDescription, Description);
    FbfaSP.SetParamByNameAsWideString(sPrmFirstName, FirstName);
    FbfaSP.SetParamByNameAsWideString(sPrmLastName, LastName);
    FbfaSP.SetParamByNameAsWideString(sPrmUserPass, Password);
    FbfaSP.SetParamByNameAsLargeInt(sPrmMandantID, MandantID);
    FbfaSP.SetParamByNameAsInteger(sPrmDeleted, stDeleted);
    FbfaSP.SetParamByNameAsInteger(sPrmLocked, stLocked);
    
    FbfaSP.SetParamByNameAsWideString(sPrmMiddleName, MiddleName);
    FbfaSP.SetParamByNameAsWideString(sPrmDMSAdmin, sSysDMSAdmin);
    if OnlyUserName then
      FbfaSP.SetParamByNameAsSmallInt(sPrmOnlyName, 1)
    else
      FbfaSP.SetParamByNameAsSmallInt(sPrmOnlyName, 0);
      
    FbfaSP.Execute;       
      
    Result:= FbfaSP.ParamByNameAsInteger(sPrmResult);

    if CanStartTransaction then
      Cnt^.MySQLTransaction.Commit;
    

  except
    if CanStartTransaction then
      Cnt^.MySQLTransaction.Rollback;
  
    FErrorCode := ecConnectionUpdateUserFailure;
    Cnt^.Log.Write(llNormal, ltException, 'sSpUpdateUser - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result := -1;
  end;
end;
//
function TMySQL.CreateGroup(Cnt : PbfaConnection; GroupName, Description, Email : WideString; MandantID, LayoutID: Int64; SaveImmediately: Boolean; var GroupLayoutID, ContainerID : Int64): Int64;
var
  FErrorCode : Integer;
  FbfaSP, FbfaSPNewGrp : TbfaSP;
begin
  FErrorCode := 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.CreateGroup', 'bfaMySQLDatabaseScriptsU');
  FbfaSP := TbfaSP.Create(Cnt^.MySQLConnection, sSpCreateGroup);
  Cnt^.MySQLTransaction.StartTransaction;
  try
    
    FbfaSP.PrepareSQL;
      
    FbfaSP.SetParamByNameAsWideString(sPrmDBName, Cnt^.MySQLConnection.Database);
    FbfaSP.SetParamByNameAsWideString(sPrmGroupName, GroupName);
    FbfaSP.SetParamByNameAsWideString(sPrmDescription, Description);
    FbfaSP.SetParamByNameAsWideString(sPrmEmail, Email);
    FbfaSP.SetParamByNameAsLargeInt(sPrmMandantID, MandantID);
    FbfaSP.SetParamByNameAsLargeInt(sPrmLayoutID, LayoutID);
    FbfaSP.SetParamByNameAsLargeInt(sPrmContainerID, ContainerID);
    FbfaSP.SetParamByNameAsInteger(sPrmUserType, otUser);      
    FbfaSP.SetParamByNameAsInteger(sPrmGroupType, otGroup);      
    FbfaSP.SetParamByNameAsInteger(sPrmRoot, otRoot);      
    FbfaSP.SetParamByNameAsInteger(sPrmMandant, otMandant);      
    FbfaSP.SetParamByNameAsInteger(sPrmStore, otStore);      
    FbfaSP.SetParamByNameAsInteger(sPrmArchive, otArchive);      
    FbfaSP.SetParamByNameAsInteger(sPrmAddFieldType, otAdditionalField);
    FbfaSP.SetParamByNameAsInteger(sPrmStsFieldType, otStatusField);
    FbfaSP.SetParamByNameAsInteger(sPrmUserContainerType, otUserContainer);
    FbfaSP.SetParamByNameAsInteger(sPrmAddStsContainerType, otAddFieldContainer);
    if SaveImmediately then
      FbfaSP.SetParamByNameAsSmallInt(sPrmSaveImmediately, 1)
    else
      FbfaSP.SetParamByNameAsSmallInt(sPrmSaveImmediately, 0);
      
            
    FbfaSP.Execute;       
      
    GroupLayoutID:= FbfaSP.ParamByNameAsLargeInt(sPrmObjLayoutID);
    Result:= FbfaSp.ParamByNameAsLargeInt(sPrmResult);
    if ContainerID = -1 then
      ContainerID:= FbfaSP.ParamByNameAsLargeInt(sPrmContainerID);

    if Result > 0 then
    begin
      FbfaSPNewGrp := TbfaSP.Create(Cnt^.MySQLConnection, sSpInsertNewGroupToSysGrpUsr);
      try
        FbfaSPNewGrp.PrepareSQL;    
        FbfaSPNewGrp.SetParamByNameAsLargeInt(sPrmObjID, Result);
        FbfaSPNewGrp.SetParamByNameAsInteger(sPrmObjType, otGroup);
        FbfaSPNewGrp.SetParamByNameAsLargeInt(sPrmMandant, MandantID);
        
        FbfaSPNewGrp.Execute;

        if FbfaSPNewGrp.ParamByNameAsLargeInt(sPrmResult) < 0 then
        begin
          Cnt^.MySQLTransaction.Rollback;
          Result:= -3;
          FErrorCode:= ecConnectionInsertGroupToSysGrpUsrFailure;
        end
        else
        begin
          Cnt^.MySQLTransaction.Commit;
        end;
      except
        Cnt^.MySQLTransaction.Rollback;      
        FErrorCode:= ecConnectionCreateGroupFailure;
        Cnt^.Log.Write(llNormal, ltException, 'sSpInsertNewGroupToSysGrpUsr - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
        Result:= -1;
      end;
    end
    else
    begin
      Cnt^.MySQLTransaction.Rollback;      
    end;

  except
    Cnt^.MySQLTransaction.Rollback;      
    FErrorCode:= ecConnectionCreateGroupFailure;
    Cnt^.Log.Write(llNormal, ltException, 'spInsertGroup - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= -1;
  end;
end;
//
function TMySQL.UpdateGroup(Cnt : PbfaConnection; GroupID, MandantID : Int64; GroupName, Description, Email : WideString; OnlyGroupName : Boolean) : Int64;
var
  FErrorCode : Integer;
  FbfaSP : TbfaSP;
  CanStartTransaction : Boolean;
begin
  FErrorCode := 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.UpdateGroup', 'bfaMySQLDatabaseScriptsU');
  FbfaSP := TbfaSP.Create(Cnt^.MySQLConnection, sSpUpdateGroup);
  try
    CanStartTransaction := not Cnt^.MySQLTransaction.Active;
    if CanStartTransaction then
      Cnt^.MySQLTransaction.StartTransaction;
        
    FbfaSP.PrepareSQL;
      
    FbfaSP.SetParamByNameAsLargeInt(sPrmGroupID, GroupID);
    FbfaSP.SetParamByNameAsWideString(sPrmDescription, Description);
    FbfaSP.SetParamByNameAsWideString(sPrmGroupName, GroupName);
    FbfaSP.SetParamByNameAsWideString(sPrmEmail, Email);
    FbfaSP.SetParamByNameAsLargeInt(sPrmMandantID, MandantID);
    if OnlyGroupName then
      FbfaSP.SetParamByNameAsSmallInt(sPrmOnlyName, 1)
    else
      FbfaSP.SetParamByNameAsSmallInt(sPrmOnlyName, 0);
        
    FbfaSP.Execute;       
      
    Result:= FbfaSP.ParamByNameAsInteger(sPrmResult);

    if CanStartTransaction then
      Cnt^.MySQLTransaction.Commit;
    
  except
    if CanStartTransaction then
      Cnt^.MySQLTransaction.RollBack;
  
    FErrorCode:= ecConnectionUpdateGroupFailure;
    Cnt^.Log.Write(llNormal, ltException, 'spUpdateGroup - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= -1;
  end;
end;
//
function TMySQL.SelectGroupSysGrpUsrID(Cnt : PbfaConnection; GroupID: Int64): Int64;
var
  FErrorCode: Integer;
  FbfaSP : TbfaSP;
begin
  FErrorCode:= 0;
  Result:= -1;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.SelectGroupSysGrpUsrID', 'bfaMySQLDatabaseScriptsU');
  FbfaSP := TbfaSP.Create(Cnt^.MySQLConnection, sSpSelectGroupSysGrpUsrID);
  try
    FbfaSP.PrepareSQL;
      
    FbfaSP.SetParamByNameAsLargeInt(sPrmGroupID, GroupID);
    FbfaSP.SetParamByNameAsInteger(sPrmGroupType, otGroup);
    
    FbfaSP.Execute;       
      
    Result:= FbfaSP.ParamByNameAsLargeInt(sPrmResult);
  except
    FErrorCode:= ecConnectionSelectGroupSysGrpUsrIDFailure;
    Cnt^.Log.Write(llNormal, ltException, 'spSelectGroupSysGrpUsrID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= -1;
  end;
end;
//
function TMySQL.SelectGroupSysGrpUsrParentID(Cnt : PbfaConnection; SysGrpID: Int64): Int64;
var
  FErrorCode: Integer;
  FbfaSP : TbfaSP;
begin
  FErrorCode:= 0;
  Result:= -1;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.SelectGroupSysGrpUsrID', 'bfaMySQLDatabaseScriptsU');
  FbfaSP := TbfaSP.Create(Cnt^.MySQLConnection, sSpSelectGroupSysGrpUsrParentID);
  try
    FbfaSP.PrepareSQL;
      
    FbfaSP.SetParamByNameAsLargeInt(sPrmSysGrpUsrID, SysGrpID);
    
    FbfaSP.Execute;       
      
    Result:= FbfaSp.ParamByNameAsLargeInt(sPrmResult);
  except
    FErrorCode:= ecConnectionSelectGroupSysGrpUsrParentIDFailure;
    Cnt^.Log.Write(llNormal, ltException, 'spSelectGroupSysGrpUsrParentID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= -1;
  end;
end;
//
function TMySQL.CreateArchive(Cnt : PbfaConnection; ArcName, BgrPicture, DefDocName, Description: WideString; ParentID, UserID: Int64; ArchiveType, Icon: Integer; DMSAdmin, InheritPermission, InheritAdditionalField: Boolean; Kind: TbfaTreeViewKind; var ArcID, LayoutID : Int64): Integer;
var
  FErrorCode: Integer;
  FbfaSP : TbfaSP;
begin
  FErrorCode:= 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.CreateArchive', 'bfaMySQLDatabaseScriptsU');
  FbfaSP := TbfaSP.Create(Cnt^.MySQLConnection, sSpCreateArchive);
  Cnt^.MySQLTransaction.StartTransaction;
  try  
    FbfaSP.PrepareSQL;
      
    FbfaSP.SetParamByNameAsLargeInt(sPrmParentID, ParentID);
    FbfaSP.SetParamByNameAsWideString(sPrmArcName, ArcName);
    FbfaSP.SetParamByNameAsWideString(sPrmArcBackPic, BgrPicture);
    FbfaSP.SetParamByNameAsWideString(sPrmDocName, DefDocName);
    FbfaSP.SetParamByNameAsInteger(sPrmArcType, ArchiveType);
    FbfaSP.SetParamByNameAsInteger(sPrmArcStatus, stActive);
    FbfaSP.SetParamByNameAsInteger(sPrmRoot, otRoot);
    FbfaSP.SetParamByNameAsInteger(sPrmMandant, otMandant);
    FbfaSP.SetParamByNameAsInteger(sPrmStore, otStore);
    FbfaSP.SetParamByNameAsInteger(sPrmArchive, otArchive);
    FbfaSP.SetParamByNameAsInteger(sPrmGroupType, otGroup);
    FbfaSP.SetParamByNameAsInteger(sPrmUserType, otUser);
    FbfaSP.SetParamByNameAsLargeInt(sPrmCurUserID, UserID);
    if DMSAdmin then
      FbfaSP.SetParamByNameAsInteger(sPrmDMSAdmin, 1)
    else 
      FbfaSP.SetParamByNameAsInteger(sPrmDMSAdmin, 0);
    if InheritPermission then
      FbfaSP.SetParamByNameAsInteger(sPrmInheritPermission, 1)
    else 
      FbfaSP.SetParamByNameAsInteger(sPrmInheritPermission, 0);      
    if InheritAdditionalField then
      FbfaSP.SetParamByNameAsInteger(sPrmInheritAdditionalFields, 1)
    else 
      FbfaSP.SetParamByNameAsInteger(sPrmInheritAdditionalFields, 0);      
    FbfaSP.SetParamByNameAsInteger(sPrmIcon, Icon);
    FbfaSP.SetParamByNameAsWideString(sPrmDescription, Description);
    if Kind = tvNormal then
      FbfaSP.SetParamByNameAsInteger(sPrmKind, 0)
    else
      FbfaSP.SetParamByNameAsInteger(sPrmKind, 1);
    FbfaSP.SetParamByNameAsInteger(sPrmRecordArchive, otRecordArchive);
    FbfaSP.SetParamByNameAsInteger(sPrmAddFieldType, otAdditionalField);
    FbfaSP.SetParamByNameAsInteger(sPrmStsFieldType, otStatusField);
    FbfaSP.SetParamByNameAsInteger(sPrmUserContainerType, otUserContainer);
    FbfaSP.SetParamByNameAsInteger(sPrmAddStsContainerType, otAddFieldContainer);

    FbfaSP.Execute;  
      
    Result:= FbfaSP.ParamByNameAsLargeInt(sPrmResult);    

    if Result >= 0 then
    begin
      ArcID := FbfaSP.ParamByNameAsLargeInt(sPrmArcID);
      LayoutID := FbfaSP.ParamByNameAsLargeInt(sPrmLayoutID);
    
      Cnt^.MySQLTransaction.Commit;
    end
    else 
    begin
      ArcID := -1;
      LayoutID := -1;
    
      Cnt^.MySQLTransaction.Rollback;  
      if Result = -1 then
        FErrorCode:= ecConnectionCreateArchiveFailure
      else if Result = -2 then
        FErrorCode:= ecConnectionSelectObjectDetailsByIDFailure
      else if Result = -3 then
        FErrorCode:= ecConnectionCreateArchiveFailureInsertNewObject
      else if Result = -4 then
        FErrorCode:= ecConnectionCreateArchiveFailure
      else if Result = -5 then
        FErrorCode:= ecConnectionCreateArchiveFailureInsertNewObject
      else if Result = -6 then
        FErrorCode:= ecConnectionCreateArchiveFailureCannotInsertUser
      else if Result = -7 then
        FErrorCode:= ecConnectionCreateArchiveFailureCannotInsertUser;
    end;   
  except
    Cnt^.MySQLTransaction.RollBack;
    FErrorCode:= ecConnectionCreateArchiveFailure;
    Cnt^.Log.Write(llNormal, ltException, 'MySQL.CreateArchive - ErrorCode: ' + IntToStr(FErrorCode) + ' SQL Result: ' + IntToStr(Result) + ' - RollBack Transaction', 'bfaMySQLDatabaseScriptsU');
    Result:= -1;
  end;
end;
//




















function TMySQL.CheckIfUserAdminInOtherContainer(Cnt : PbfaConnection; ObjID, ParentID: Int64; ObjType: Integer): Boolean;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.CheckIfUserAdminInOtherContainer', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cnt^.MySQLConnection, sSpCheckIfUserAdminInOtherContainer);
  try
    FbfaSP.PrepareSQL;
    
    FbfaSP.SetParamByNameAsLargeInt(sPrmObjID, ObjID);
    FbfaSP.SetParamByNameAsLargeInt(sPrmParentID, ParentID);
    FbfaSP.SetParamByNameAsInteger(sPrmObjType, ObjType);
    FbfaSP.SetParamByNameAsInteger(sPrmUserManagement, rAppUserManagement);

    FbfaSP.Execute;
    
    if FbfaSP.ParamByNameAsInteger(sPrmResult) = 1 then
      Result:= True
    else
      Result:= False;
      
  except
    FErrorCode:= ecConnectionCheckIfUserAdminInOtherContainer;
    Cnt^.Log.Write(llNormal, ltException, 'CheckIfUserAdminInOtherContainer - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= False;
  end;
end;
//
function TMySQL.SelectObjectsMandant(Cnt : PbfaConnection; ObjID: Int64; ObjType : Integer; var MandantName: WideString): Int64;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Cnt^.Log.Write(llDebug, ltInfo, 'MySQL.SelectObjectsMandant', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cnt^.MySQLConnection, sSpSelectObjectsMandant);
  try
    FbfaSP.PrepareSQL;
    
    FbfaSP.SetParamByNameAsLargeInt(sPrmObjID, ObjID);
    FbfaSP.SetParamByNameAsInteger(sPrmObjType, ObjType);
    FbfaSP.SetParamByNameAsInteger(sPrmMandant, otMandant);

    FbfaSP.Execute;
    
    if FbfaSP.RecordCount > 0 then
    begin
      MandantName:= FbfaSP.FieldByNameAsString(sColArcName);
      Result:= FbfaSP.FieldByNameAsLargeInt(sColArcID);
    end
    else
    begin
      MandantName:= sSysDMSRoot;
      Result:= 1;
    end;
      
  except
    FErrorCode:= ecConnectionSelectObjectsMandantFailure;
    Cnt^.Log.Write(llNormal, ltException, 'spSelectObjectsMandant - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= -1;
  end;
end;

  
//
function TMySQL.SelectProfiles(Cn: TUniConnection; Log: TbfaLog): TBfaSP;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectProfiles', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpSelectCfgByParams);
  try
    FbfaSP.PrepareSQL;
    FbfaSP.SetParamByNameAsLargeInt(sPrmClientID, ciServer);  //0 = Server
    FbfaSP.SetParamByNameAsString(sPrmParam, sSysProfilName);  
    FbfaSP.Open;
    Result:= FbfaSP;
  except
    FErrorCode:= ecConnectionSelectClientsFailure;
    Log.Write(llNormal, ltException, 'SelectProfiles - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= nil;
  end;
end;
//
function TMySQL.SelectProfileCfgByID(Cn: TUniConnection; ClientID: Int64; Conn: TbfaConnection; Log: TbfaLog): Integer;
var
  FErrorCode, Port, Provider: Integer;
  UName, Pwd, Database, Server: String;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectProfileCfgByID', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpSelectCfgByID);
  try
    with FbfaSp do      
    begin
      PrepareSQL;
      SetParamByNameAsLargeInt(sPrmClientID, ClientID);  //0 = Server
      Execute;
      if RecordCount > 0 then
      begin
        Port:= -1;
        Provider:= -1;
        UName:= '';
        Pwd:= '';
        Database:= '';
        Server:= '';
        
        First;
        while not Eof do
        begin
          if Lowercase(FieldByNameAsString(sColObjName)) = Lowercase(sSysPort) then
            Port:= FieldByNameAsInteger(sColObjValue)
          else if Lowercase(FieldByNameAsString(sColObjName)) = Lowercase(sSysProvider) then
            Provider:= FieldByNameAsInteger(sColObjValue)
          else if Lowercase(FieldByNameAsString(sColObjName)) = Lowercase(sSysServer) then
            Server:= FieldByNameAsString(sColObjValue)
          else if Lowercase(FieldByNameAsString(sColObjName)) = Lowercase(sSysUserName) then
            UName:= FieldByNameAsString(sColObjValue)
          else if Lowercase(FieldByNameAsString(sColObjName)) = Lowercase(sSysPassword) then
            Pwd:= FieldByNameAsString(sColObjValue)
          else if Lowercase(FieldByNameAsString(sColObjName)) = Lowercase(sSysDatabase) then
            Database:= FieldByNameAsString(sColObjValue);
          Next;
        end;
        FErrorCode:= Conn.SetConnection(UName, Pwd, Database, Server, Port, Provider);
      end
      else
      begin
        FErrorCode:= ecNoRecord;
        Log.Write(llNormal, ltError, 'SelectProfileCfgByID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      end;
    end;
    Result:= FErrorCode;
  except
    FErrorCode:= ecConnectionLoadProfileFailure;
    Log.Write(llNormal, ltException, 'SelectProfileCfgByID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= FErrorCode;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 17.04.2013 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.CheckIfGrpUsrObjectExsitsOnLevel(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; ParentID, ObjID, MandantID: Int64; ObjType: Integer): Boolean;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.CheckIfGrpUsrObjectExsitsOnLevel', 'bfaMySQLDatabaseScriptsU');
  with DM.spCheckIfGrpUsrObjectExistsOnLevel do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;
                  
      ParamByName(sPrmParentID).AsLargeInt:= ParentID;
      ParamByName(sPrmObjID).AsLargeInt:= ObjID;
      ParamByName(sPrmType).AsInteger:= ObjType;
      ParamByName(sPrmMandant).AsLargeInt:= MandantID;

      Execute;       
      
      if  ParamByName(sPrmResult).AsInteger = 1 then
        Result:= True
      else
        Result:= False;
      
    except
      FErrorCode:= ecConnectionCheckIfGrpUsrObjectExsitsOnLevelFailure;
      Log.Write(llNormal, ltException, 'CheckIfGrpUsrObjectExsitsOnLevel - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= False;
    end;
  end;
end;


//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.GetUserApplicationRights(Cn: TUniConnection; Log: TbfaLog; UserID: Int64): TbfaSP;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.GetUserApplicationRights', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpSelectApplicationRightsByUser);
  try
    FbfaSP.PrepareSQL;

    FbfaSP.SetParamByNameAsLargeInt(sPrmUserID, UserID);
    FbfaSP.SetParamByNameAsInteger(sPrmUserType, otUser);
    FbfaSP.SetParamByNameAsInteger(sPrmGroupType, otGroup);
  
    FbfaSP.Open;
    Result:= FbfaSP;
  except
    FErrorCode:= ecConnectionLoginFailure;
    Log.Write(llNormal, ltException, 'spSelectApplicationRightsByUser - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= nil;
  end;
end;

//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.GetArchivesByUserID(Cn: TUniConnection; Log: TbfaLog; UserID: Int64; LeftIdx, RightIdx: Int64; 
    UserRight: Integer): TbfaSP;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.GetArchivesByUserID', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpSelectArchivesByUserID);
  try
    FbfaSP.PrepareSQL;
    FbfaSP.SetParamByNameAsLargeInt(sPrmUserID, UserID);
    FbfaSP.SetParamByNameAsLargeInt(sPrmIdxL, LeftIdx);
    FbfaSP.SetParamByNameAsLargeInt(sPrmIdxR, RightIdx);
    FbfaSP.SetParamByNameAsInteger(sPrmRight, UserRight);
    FbfaSP.SetParamByNameAsInteger(sPrmUserType, otUser);
    FbfaSP.SetParamByNameAsInteger(sPrmGroupType, otGroup);
    FbfaSP.SetParamByNameAsInteger(sPrmRoot, otRoot);
    FbfaSP.SetParamByNameAsInteger(sPrmMandant, otMandant);
    FbfaSP.SetParamByNameAsInteger(sPrmStore, otStore);
    FbfaSP.SetParamByNameAsInteger(sPrmArchive, otArchive);
    FbfaSP.SetParamByNameAsInteger(sPrmRecordArchive, otRecordArchive);
    FbfaSP.SetParamByNameAsSmallInt(sPrmGrpList, 0);
    FbfaSP.SetParamByNameAsWideString(sPrmArcID, '');

    FbfaSP.Open;
    Result:= FbfaSP;
  except
    FErrorCode:= ecConnectionGetArchivesByUserIDFailure;
    Log.Write(llNormal, ltException, 'spSelectArchivesByUserID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= nil;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.GetArchivesByUserIDReturnWithList(Cn: TUniConnection; Log: TbfaLog; UserID: Int64; LeftIdx, RightIdx: Int64; 
    UserRight: Integer; GrpList : Boolean = False; ArcIDs : WideString = '') : WideString;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode := 0;
  Result := '';
  Log.Write(llDebug, ltInfo, 'MySQL.GetArchivesByUserID', 'bfaMySQLDatabaseScriptsU');
  FbfaSP := TbfaSP.Create(Cn, sSpSelectArchivesByUserID);
  try
    FbfaSP.PrepareSQL;
    FbfaSP.SetParamByNameAsLargeInt(sPrmUserID, UserID);
    FbfaSP.SetParamByNameAsLargeInt(sPrmIdxL, LeftIdx);
    FbfaSP.SetParamByNameAsLargeInt(sPrmIdxR, RightIdx);
    FbfaSP.SetParamByNameAsInteger(sPrmRight, UserRight);
    FbfaSP.SetParamByNameAsInteger(sPrmUserType, otUser);
    FbfaSP.SetParamByNameAsInteger(sPrmGroupType, otGroup);
    FbfaSP.SetParamByNameAsInteger(sPrmRoot, otRoot);
    FbfaSP.SetParamByNameAsInteger(sPrmMandant, otMandant);
    FbfaSP.SetParamByNameAsInteger(sPrmStore, otStore);
    FbfaSP.SetParamByNameAsInteger(sPrmArchive, otArchive);
    FbfaSP.SetParamByNameAsInteger(sPrmRecordArchive, otRecordArchive);
    if GrpList then
      FbfaSP.SetParamByNameAsSmallInt(sPrmGrpList, 1)
    else
      FbfaSP.SetParamByNameAsSmallInt(sPrmGrpList, 0);
    FbfaSP.SetParamByNameAsWideString(sPrmArcID, ArcIDs);

    FbfaSP.Execute;

    Result := FbfaSP.ParamByNameAsWideString(sPrmResult);
  except
    FErrorCode := ecConnectionGetArchivesByUserIDFailure;
    Log.Write(llNormal, ltException, 'spSelectArchivesByUserID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result := '';
  end;
end;
//
function TMySQL.SelectContainerDescription(Cn: TUniConnection; Log: TbfaLog; ID: Int64): WideString;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectContainerDescription', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpSelectContainerDescription);
  try
    FbfaSP.PrepareSQL;
    FbfaSP.SetParamByNameAsInteger(sPrmID, ID);

    FbfaSP.Execute;
    Result:= FbfaSP.FieldByNameAsWideString(sColDescription);
  except
    FErrorCode:= ecConnectionSelectContainerDescription;
    Log.Write(llNormal, ltException, 'sSpSelectContainerDescription - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= '';
  end;
end;


//
//  Name: MySQL.LoadArchiv
//  Parameters: ArcID
//              ArcRec
//              Log
//  Beschreibung:
//  Description:
//  Return value: ErrorCode
// [] 17.04.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.LoadArchive(DM: TbfaMySQLDataAccess; Cn: TUniConnection; LayoutID: Int64; var ArcRec: TArchiveRec; Log: TbfaLog): Integer;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.LoadArchive', 'bfaMySQLDatabaseScriptsU');
  with DM.spSelectArchiveByArcID do
  begin
    try
      Connection:= Cn;
      PrepareSQL;
      
      ParamByName(sPrmLayoutID).AsLargeInt:= LayoutID;
      ParamByName(sPrmRoot).AsInteger:= otRoot;
      ParamByName(sPrmMandant).AsInteger:= otMandant;
      ParamByName(sPrmStore).AsInteger:= otStore;
      ParamByName(sPrmArchive).AsInteger:= otArchive;
      ParamByName(sPrmRecordArchive).AsInteger:= otRecordArchive;
      Execute;
      if RecordCount > 0 then
      begin
        ArcRec.LayoutID:= FieldByName(sColID).AsLargeInt;
        ArcRec.ArchiveID:= FieldByName(sColArcID).AsLargeInt;
        ArcRec.ParentID:= FieldByName(sColParentID).AsLargeInt;
        ArcRec.ArcName:= FieldByName(sColArcName).AsWideString;
        ArcRec.BgrPicture:= FieldByName(sColBgrPicture).AsWideString;
        ArcRec.DocName:= FieldByName(sColDocName).AsWideString;
        ArcRec.InheritPermissions:= FieldByName(sColInheritPermission).AsBoolean;
        ArcRec.InheritFields:= FieldByName(sColInheritAdditionalFields).AsBoolean;
        ArcRec.ArcType:= FieldByName(sColType).AsInteger;
        ArcRec.Icon:= FieldByName(sColIcon).AsInteger;
        Arcrec.Description:= FieldByName(sColDescription).AsWidestring;
        if FieldByName(sColKind).AsInteger = 0 then
          ArcRec.Kind:= tvNormal
        else
          ArcRec.Kind:= tvRecord;
        ArcRec.ArchiveLayout:= nil;
        if TBlobField(FieldByName(sColLayout)).Value <> nil  then
        begin
          ArcRec.ArchiveLayout:= TMemoryStream(CreateBlobStream(FieldByName(sColLayout), bmRead));
        end;
          
      end
      else
      begin
        FErrorCode:= ecNoRecord;
        Log.Write(llNormal, ltError, 'spSelectArchiveByArcID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      end;
      Result:= FErrorCode;
    except
      FErrorCode:= ecConnectionLoadArchiveFailure;
      Log.Write(llNormal, ltException, 'spSelectArchiveByArcID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= FErrorCode;
    end;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 17.04.2013 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.LoadDocument(DM: TbfaMySQLDataAccess; Cn: TUniConnection; GDocID: Int64; var DocRec: TDocumentRec; Log: TbfaLog): Integer;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.LoadDocument', 'bfaMySQLDatabaseScriptsU');
  with DM.spSelectDocumentByGdocID do
  begin
    try
      Connection:= Cn;
      PrepareSQL;
      
      ParamByName(sPrmGDocID).AsLargeInt:= GDocID;
      Execute;
      if RecordCount > 0 then
      begin
        DocRec.ArcID:= FieldByName(sColArcID).AsLargeInt;
        DocRec.DocLoc:= FieldByName(sColDocLoc).AsWideString;
        DocRec.ExtLoc:= '';//FieldByName(sColExtLoc).AsWideString;
        DocRec.OriLoc:= '';//FieldByName(sColOriLoc).AsWideString;
        DocRec.DocTXT:= '';//FieldByName(sColDocTXT).AsWideString;
        DocRec.Vocabulary:= '';//FieldByName(sColVocabulary).AsWideString;
        DocRec.CheckedOut:= False;//FieldByName(sColCheckedout).AsBoolean;
//        DocRec.DocStream.LoadFromFile(DocRec.DocLoc);
//        DocRec.ORIStream:= nil;//FieldByName(sColDocLoc).AsWideString;
//        DocRec.IEVStream:= nil;//FieldByName(sColDocLoc).AsWideString;
//        DocRec.LetterStream:= nil;//FieldByName(sColDocLoc).AsWideString;
        DocRec.PageCount:= FieldByName(sColPageCount).AsInteger;
        DocRec.DocType:= dtArchived;//FieldByName(sColDocLoc).AsWideString;
        DocRec.FileType:= FieldByName(sColFileType).AsWideString;
        DocRec.FilePath:= DocRec.DocLoc;//FieldByName(sColDocLoc).AsWideString;
        DocRec.Image:= True;
        
//        ArcRec.ArchiveLayout:= TMemoryStream(CreateBlobStream(FieldByName(sColLayout), bmRead));
          
      end
      else
      begin
        FErrorCode:= ecNoRecord;
        Log.Write(llNormal, ltError, 'spSelectArchiveByArcID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      end;
      Result:= FErrorCode;
    except
      FErrorCode:= ecConnectionLoadArchiveFailure;
      Log.Write(llNormal, ltException, 'spSelectArchiveByArcID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= FErrorCode;
    end;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.GetLayoutUsersAndGroups(Cn: TUniConnection; Log: TbfaLog; ParentID: Int64): TbfaSP;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.GetLayoutUsersAndGroups', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpSelectLayoutUsersAndGroups);
  try
    FbfaSP.PrepareSQL;

    FbfaSP.SetParamByNameAsLargeInt(sPrmParentID, ParentID);
    FbfaSP.SetParamByNameAsInteger(sPrmUserType, otUser);
    FbfaSP.SetParamByNameAsInteger(sPrmGroupType, otGroup);
  
    FbfaSP.Open;
    Result:= FbfaSP;
  except
    FErrorCode:= ecConnectionGetLayoutUsersAndGroupsFailure;
    Log.Write(llNormal, ltException, 'spSelectLayoutUsersAndGroups - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= nil;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.SelectUsers(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog): TDataSet;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectUsers', 'bfaMySQLDatabaseScriptsU');
  with DM.spSelectUsers do
  begin
    try
      Connection:= Cn;
      PrepareSQL;
      Execute;

      Result:= DM.dscSelectUsers.DataSet;
      
    except
      FErrorCode:= ecConnectionSelectUsersFailure;
      Log.Write(llNormal, ltException, 'spSelectUsers - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= nil;
    end;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.SelectGroups(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog): TDataSet;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectGroups', 'bfaMySQLDatabaseScriptsU');
  with DM.spSelectGroups do
  begin
    try
      Connection:= Cn;
      PrepareSQL;
      Execute;
      
      Result:= DM.dscSelectGroups.DataSet;
      
    except
      FErrorCode:= ecConnectionSelectGroupsFailure;
      Log.Write(llNormal, ltException, 'spSelectGroups - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= nil;
    end;
  end;
end;
//
function TMySQL.SelectAllFields(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog): TbfaSP;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectAllFields', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpSelectAllFields);
  try
    FbfaSP.PrepareSQL;
  
    FbfaSP.Open;
    Result:= FbfaSP;
  except
    FErrorCode:= ecConnectionSelectAllFieldsFailure;
    Log.Write(llNormal, ltException, 'spSelectAllFields - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= nil;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.SelectAddUsers(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog): TDataSet;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectAddUsers', 'bfaMySQLDatabaseScriptsU');
  with DM.spSelectAddUsers do
  begin
    try
      Connection:= Cn;
      PrepareSQL;
      Execute;

      Result:= DM.dscSelectAddUsers.DataSet;
      
    except
      FErrorCode:= ecConnectionSelectAddUsersFailure;
      Log.Write(llNormal, ltException, 'spSelectAddUsers - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= nil;
    end;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.SelectAddGroups(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog): TDataSet;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectAddGroups', 'bfaMySQLDatabaseScriptsU');
  with DM.spSelectAddGroups do
  begin
    try
      Connection:= Cn;
      PrepareSQL;
      Execute;
      
      Result:= DM.dscSelectAddGroups.DataSet;
      
    except
      FErrorCode:= ecConnectionSelectAddGroupsFailure;
      Log.Write(llNormal, ltException, 'spSelectAddGroups - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= nil;
    end;
  end;
end;

//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.AddObjectToUserMapping(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; LayoutID, ObjID, Rights, RoleID: Int64; ObjType: Integer): Int64;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.AddObjectToUserMapping', 'bfaMySQLDatabaseScriptsU');
  with DM.spAddObjectToUserMapping do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;

      ParamByName(sPrmLayoutID).AsLargeInt:= LayoutID;
      ParamByName(sPrmObjID).AsLargeInt:= ObjID;
      ParamByName(sPrmObjType).AsInteger:= ObjType;
      ParamByName(sPrmRights).AsLargeInt:= Rights;
      ParamByName(sPrmRoleID).AsLargeInt:= RoleID;
      ParamByName(sPrmRoot).AsInteger:= otRoot;
      ParamByName(sPrmMandant).AsInteger:= otMandant;
      ParamByName(sPrmStore).AsInteger:= otStore;
      ParamByName(sPrmArchive).AsInteger:= otArchive;      
      ParamByName(sPrmRecordArchive).AsInteger:= otRecordArchive;      
      Execute;       
      
      Result:= ParamByName(sPrmResult).AsLargeInt;
      
    except
      FErrorCode:= ecConnectionInsertUserMappingFailure;
      Log.Write(llNormal, ltException, 'spAddObjectToUserMapping - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= -1;
    end;
  end;
end;
//
function TMySQL.AddObjectToFieldMapping(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; LayoutID, FieldID, ArchiveID: Int64; ObjType: Integer; DefaultValue, Description, ControlItems: WideString; Mode, PrmOptions: Integer): Int64;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.AddObjectToFieldMapping', 'bfaMySQLDatabaseScriptsU');
  with DM.spAddObjectToFieldMapping do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;

      ParamByName(sPrmLayoutID).AsLargeInt:= LayoutID;
      ParamByName(sPrmObjID).AsLargeInt:= FieldID;
      ParamByName(sPrmObjType).AsLargeInt:= ObjType;
      ParamByName(sPrmArchiveID).AsLargeInt:= ArchiveID;
      ParamByName(sPrmMode).AsInteger:= Mode;  
      ParamByName(sPrmOptions).AsInteger:= PrmOptions;  
      ParamByName(sPrmDefaultValue).AsWideString:= DefaultValue;  
      ParamByName(sPrmDescription).AsWideString:= Description;  
      ParamByName(sPrmControlItems).AsWideString:= ControlItems; 
      ParamByName(sPrmRoot).AsInteger:= otRoot;      
      ParamByName(sPrmMandant).AsInteger:= otMandant;      
      ParamByName(sPrmStore).AsInteger:= otStore;      
      ParamByName(sPrmArchive).AsInteger:= otArchive;      
      ParamByName(sPrmRecordArchive).AsInteger:= otRecordArchive;      
      
      Execute;       
      
      Result:= ParamByName(sPrmResult).AsLargeInt;
      
    except
      FErrorCode:= ecConnectionInsertUserMappingFailure;
      Log.Write(llNormal, ltException, 'spAddObjectToUserMapping - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= -1;
    end;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.UpdateObjectInUserMapping(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; LayoutID, ObjID, Rights: Int64; ObjType: Integer): Int64;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.UpdateObjectInUserMapping', 'bfaMySQLDatabaseScriptsU');
  with DM.spUpdateObjectInUserMapping do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;

      ParamByName(sPrmLayoutID).AsLargeInt:= LayoutID;
      ParamByName(sPrmObjID).AsLargeInt:= ObjID;
      ParamByName(sPrmObjType).AsInteger:= ObjType;
      ParamByName(sPrmRights).AsLargeInt:= Rights;
      ParamByName(sPrmRoot).AsInteger:= otRoot;
      ParamByName(sPrmMandant).AsInteger:= otMandant;
      ParamByName(sPrmStore).AsInteger:= otStore;
      ParamByName(sPrmArchive).AsInteger:= otArchive;      
      ParamByName(sPrmRecordArchive).AsInteger:= otRecordArchive;      
      Execute;       
      
      Result:= FErrorCode;
      
    except
      FErrorCode:= ecConnectionUpdateUserMappingFailure;
      Log.Write(llNormal, ltException, 'spUpdateObjectInUserMapping - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= -1;
    end;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.SelectGroupMembers(Cn: TUniConnection; Log: TbfaLog; ObjID, MandantID: Int64): TbfaSP;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectGroupMembers', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpSelectGroupMembers);
  try
    FbfaSP.PrepareSQL;
    FbfaSP.SetParamByNameAsLargeInt(sPrmObjID, ObjID);  
    FbfaSP.SetParamByNameAsInteger(sPrmGroupType, otGroup);  
    FbfaSP.SetParamByNameAsLargeInt(sPrmMandant, MandantID);  
    FbfaSP.Open;
    Result := FbfaSP
  except
    FErrorCode:= ecConnectionSelectGroupMembersFailure;
    Log.Write(llNormal, ltException, 'SelectGroupMembers - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= nil;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.InsertObjectToSysGrpUsr(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; ParentID, ObjID, MandantID: Int64; ObjType: Integer): Integer;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Result:= -1;
  Log.Write(llDebug, ltInfo, 'MySQL.InsertObjectToSysGrpUsr', 'bfaMySQLDatabaseScriptsU');
  with DM.spInsertObjectToGrpUsr do
  begin
//    DM.trnBfaServer.DefaultConnection:= Cn;
//    DM.trnBfaServer.StartTransaction;
    try
      Connection:= Cn;  
      PrepareSQL;
      
      ParamByName(sPrmParentID).AsLargeInt:= ParentID;
      ParamByName(sPrmObjID).AsLargeInt:= ObjID;
      ParamByName(sPrmType).AsInteger:= ObjType;
      ParamByName(sPrmUserType).AsInteger:= otUser;
      ParamByName(sPrmGroupType).AsInteger:= otGroup;
      ParamByName(sPrmMandant).AsLargeInt:= MandantID;
      Execute;       
      
      Result:= ParamByName(sPrmResult).AsInteger;

//      DM.trnBfaServer.Commit;
    except
//      DM.trnBfaServer.Rollback;
      FErrorCode:= ecConnectionInsertObjectToSysGrpUsrFailure;
      Log.Write(llNormal, ltException, 'spInsertObjectToGrpUsr - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= -1;
    end;
  end;
end;

//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.SelectObjectRights(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; ParentID, ObjID: Int64; ObjType: Integer): Int64;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Result:= -1;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectObjectRights', 'bfaMySQLDatabaseScriptsU');
  with DM.spLayoutRights do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;

      ParamByName(sPrmParentID).AsLargeInt:= ParentID;
      ParamByName(sPrmObjID).AsLargeInt:= ObjID;
      ParamByName(sPrmType).AsInteger:= ObjType;
      Execute;       
      
      Result:= ParamByName(sPrmRights).AsLargeInt;
    except
      FErrorCode:= ecConnectionSelectObjectRightsFailure;
      Log.Write(llNormal, ltException, 'spLayoutRights - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= -1;
    end;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.UpdateRightsToObject(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; ArchiveID, ObjID, Rights: Int64; ObjType: Integer): Int64;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Result:= -1;
  Log.Write(llDebug, ltInfo, 'MySQL.UpdateRightsToObject', 'bfaMySQLDatabaseScriptsU');
  with DM.spUpdateRightsToObject do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;
      
      ParamByName(sPrmParentID).AsLargeInt:= ArchiveID;
      ParamByName(sPrmObjID).AsLargeInt:= ObjID;
      ParamByName(sPrmObjType).AsInteger:= ObjType;
      ParamByName(sPrmRights).AsLargeInt:= Rights;
      Execute;       
      
      Result:= FErrorCode;      
    except
      FErrorCode:= ecConnectionUpdateRightsToObjectFailure;
      Log.Write(llNormal, ltException, 'spUpdateRightsToObject - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= FErrorCode;
    end;
  end;
end;
(*
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.SelectArchivenamesByIDs(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; IDs: string): WideString;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectArchivenamesByIDs', 'bfaMySQLDatabaseScriptsU');
  with DM.spSelectArchiveNamesByIDs do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;
      
      ParamByName(sPrmIDs).AsString:= IDs;
      Execute;       
      
      Result:= ParamByName(sPrmResult).AsWideString;
      
    except
      FErrorCode:= ecConnectionSelectArchivenamesByIDsFailure;
      Log.Write(llNormal, ltException, 'spSelectArchiveNamesByIDs - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= '';
    end;
  end;
end;

//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.SelectObjectsWithMemberIDs(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; IDs, TableName: string): TDataSet;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectObjectsWithMemberIDs', 'bfaMySQLDatabaseScriptsU');
  with DM.spSelectObjectsWithMemberIDs do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;

      ParamByName(sPrmIDs).AsString:= IDs;
      ParamByName(sPrmTableName).AsString:= TableName;
      Execute;       
      
      Result:= DM.dscSelectObjectsWithMemberIDs.DataSet;
    except
      FErrorCode:= ecConnectionSelectObjectsWithMemberIDsFailure;
      Log.Write(llNormal, ltException, 'spSelectObjectsWithMemberIDs - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= nil;
    end;
  end;
end;
 *)
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.DeleteContainer(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; LayoutID: Int64): Integer;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Result:= -1;
  Log.Write(llDebug, ltInfo, 'MySQL.DeleteContainer', 'bfaMySQLDatabaseScriptsU');
  with DM.spDeleteContainer do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;

      ParamByName(sPrmLayoutID).AsLargeInt:= LayoutID;
      ParamByName(sPrmUserContainerType).AsInteger:= otUserContainer;
      ParamByName(sPrmAddStsContainerType).AsInteger:= otAdditionalField;
      ParamByName(sPrmUserType).AsInteger:= otUser;
      ParamByName(sPrmGroupType).AsInteger:= otGroup;
      ParamByName(sPrmAddFieldType).AsInteger:= otAdditionalField;
      ParamByName(sPrmStsFieldType).AsInteger:= otStatusField;
      ParamByName(sPrmDeleted).AsInteger:= stDeleted;
        
      Execute;       
      
      Result:= ParamByName(sPrmResult).AsInteger;
    except
      FErrorCode:= ecConnectionDeleteContainerFailure;
      Log.Write(llNormal, ltException, 'spDeleteContainer - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= -1;
    end;
  end;
end;
//
function TMySQL.DeleteObject(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; LayoutID: Int64): Integer;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Result:= -1;
  Log.Write(llDebug, ltInfo, 'MySQL.DeleteObject', 'bfaMySQLDatabaseScriptsU');
  with DM.spDeleteObject do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;

      ParamByName(sPrmLayoutID).AsLargeInt:= LayoutID;
      ParamByName(sPrmUserType).AsInteger:= otUser;
      ParamByName(sPrmGroupType).AsInteger:= otGroup;
      ParamByName(sPrmAddFieldType).AsInteger:= otAdditionalField;
      ParamByName(sPrmStsFieldType).AsInteger:= otStatusField;
      ParamByName(sPrmDeleted).AsInteger:= stDeleted;
      ParamByName(sPrmDeleteMitContainer).AsInteger:= 0; 
      ParamByName(sPrmUserContainerType).AsInteger:= otUserContainer;
      ParamByName(sPrmAddStsContainerType).AsInteger:= otAdditionalField;
        
      Execute;       
      
      Result:= ParamByName(sPrmResult).AsInteger;
    except
      FErrorCode:= ecConnectionDeleteContainerFailure;
      Log.Write(llNormal, ltException, 'spDeleteObject - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= -1;
    end;
  end;
end;

//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.SelectWhereObjMember(Cn: TUniConnection; Log: TbfaLog; ObjID: Int64; ObjType: Integer): TbfaSP;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectWhereObjMember', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpSelectWhereObjMember);
  try
    FbfaSP.PrepareSQL;
    FbfaSP.SetParamByNameAsLargeInt(sPrmObjID, ObjID);
    FbfaSP.SetParamByNameAsInteger(sPrmObjType, ObjType);

    FbfaSP.Open;
    Result:= FbfaSP;
  except
    FErrorCode:= ecConnectionSelectWhereObjMemberFailure;
    Log.Write(llNormal, ltException, 'spSelectWhereObjMember - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= nil;
  end;
(*


var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectWhereObjMember', 'bfaMySQLDatabaseScriptsU');
  with DM.spSelectWhereObjMember do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;

      ParamByName(sPrmObjID).AsLargeInt:= ObjID;
      ParamByName(sPrmObjType).AsInteger:= ObjType;
      Execute;       
      
      Result:= DM.dscSelectWhereObjMember.DataSet;
    except
      FErrorCode:= ecConnectionSelectWhereObjMemberFailure;
      Log.Write(llNormal, ltException, 'spSelectWhereObjMember - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= nil;
    end;
  end; *)
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.DeleteArchive(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; LayoutID: Int64): Integer;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Result:= -1;
  Log.Write(llDebug, ltInfo, 'MySQL.DeleteArchive', 'bfaMySQLDatabaseScriptsU');
  with DM.spDeleteArchive do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;
            
      ParamByName(sPrmLayoutID).AsLargeInt:= LayoutID;
      ParamByName(sPrmRoot).AsInteger:= otRoot;
      ParamByName(sPrmMandant).AsInteger:= otMandant;
      ParamByName(sPrmStore).AsInteger:= otStore;
      ParamByName(sPrmArchive).AsInteger:= otArchive;
      ParamByName(sPrmRecordArchive).AsInteger:= otRecordArchive;
      ParamByName(sPrmUserContainerType).AsInteger:= otUserContainer;
      ParamByName(sPrmAddStsContainerType).AsInteger:= otAddFieldContainer;
      ParamByName(sPrmDeleted).AsInteger:= stDeleted;

      Execute;       
      
      Result:= ParamByName(sPrmResult).AsInteger;      
      
    except
      FErrorCode:= ecConnectionDeleteArchiveFailure;
      Log.Write(llNormal, ltException, 'spDeleteArchive - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= FErrorCode;
    end;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.UpdateArchive(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; LayoutID, ArcID: Int64; ArcName, BgrPicture, DocName, Description: WideString; InheritPermission, InheritAdditionalField, OnlyArcName: Boolean; Icon: Integer; Kind: TbfaTreeViewKind): Int64;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.UpdateArchive', 'bfaMySQLDatabaseScriptsU');
  with DM.spUpdateArchive do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;

      ParamByName(sPrmLayoutID).AsLargeInt:= LayoutID;
      ParamByName(sPrmArchiveID).AsLargeInt:= ArcID;
      ParamByName(sPrmArcName).AsWideString:= ArcName;
      ParamByName(sPrmBgrPicture).AsWideString:= BgrPicture;
      ParamByName(sPrmDocName).AsWideString:= DocName;
      if InheritPermission then
        ParamByName(sPrmInheritPermission).AsInteger:= 1
      else
        ParamByName(sPrmInheritPermission).AsInteger:= 0;
      if InheritAdditionalField then
        ParamByName(sPrmInheritAdditionalFields).AsInteger:= 1
      else
        ParamByName(sPrmInheritAdditionalFields).AsInteger:= 0;
      ParamByName(sPrmDMSRoot).AsWideString:= sSysDMSRoot;
      if OnlyArcName then
        ParamByName(sPrmOnlyName).AsInteger:= 1
      else
        ParamByName(sPrmOnlyName).AsInteger:= 0;
        
      ParamByName(sPrmDescription).AsWideString:= Description;
      if Kind = tvNormal then
        ParamByName(sPrmKind).AsInteger:= 0
      else
        ParamByName(sPrmKind).AsInteger:= 1;      
      ParamByName(sPrmIcon).AsInteger:= Icon;
      Execute;       
      
      Result:= ParamByName(sPrmResult).AsLargeInt;      
    except
      FErrorCode:= ecConnectionUpdateArchiveFailure;
      Log.Write(llNormal, ltException, 'spUpdateArchive - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= -1;
    end;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.UpdateArchiveGUILayout(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; ArcID: Int64; ArchiveLayout: TMemoryStream): Integer;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.UpdateArchiveGUILayout', 'bfaMySQLDatabaseScriptsU');
  with DM.spUpdateArchiveLayout do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;

      ParamByName(sPrmArchiveID).AsLargeInt:= ArcID;
      ArchiveLayout.Position:= 0;
      ParamByName(sPrmArchiveLayout).LoadFromStream(ArchiveLayout, ftBlob);
      Execute;       
      
      Result:= FErrorCode;      
    except
      FErrorCode:= ecConnectionUpdateArchiveFailure;
      Log.Write(llNormal, ltException, 'spUpdateArchiveGUILayout - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= -1;
    end;
  end;
end;
(*
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.DeleteUserOrGroupFromSysLayout(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; ParentID, ObjID: Int64; ObjType: Integer): Integer;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Result:= -1;
  Log.Write(llDebug, ltInfo, 'MySQL.DeleteUserOrGroupFromSysLayout', 'bfaMySQLDatabaseScriptsU');
  with DM.spDeleteUserOrGroupFromSysLayout do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;

      ParamByName(sPrmParentID).AsLargeInt:= ParentID;
      ParamByName(sPrmObjID).AsLargeInt:= ObjID;
      ParamByName(sPrmObjType).AsInteger:= ObjType;
      ParamByName(sPrmMandant).AsInteger:= otMandant;
      ParamByName(sPrmStore).AsInteger:= otStore;
      ParamByName(sPrmArchive).AsInteger:= otArchive;

      Execute;       
      
      Result:= FErrorCode;      
      
    except
      FErrorCode:= ecConnectionDeleteUserOrGroupFromSysLayoutFailure;
      Log.Write(llNormal, ltException, 'spDeleteUserOrGroupFromSysLayout - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= FErrorCode;
    end;
  end;
end;

//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.DeleteUserOrGroup(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; ObjID: Int64; ObjType: Integer): Integer;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Result:= -1;
  Log.Write(llDebug, ltInfo, 'MySQL.DeleteUserOrGroup', 'bfaMySQLDatabaseScriptsU');
  with DM.spDeleteUserOrGroup do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;
      
      ParamByName(sPrmObjID).AsLargeInt:= ObjID;
      ParamByName(sPrmObjType).AsInteger:= ObjType;
      ParamByName(sPrmGroupType).AsInteger:= otGroup;
      ParamByName(sPrmUserType).AsInteger:= otUser;
      ParamByName(sPrmDeleted).AsInteger:= stDeleted;

      Execute;       
      
      Result:= FErrorCode;      
      
    except
      FErrorCode:= ecConnectionDeleteUserOrGroupFailure;
      Log.Write(llNormal, ltException, 'spDeleteUserOrGroup - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= FErrorCode;
    end;
  end;
end;
*)
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.SelectLayoutWhereObjMember(Cn: TUniConnection; Log: TbfaLog; ObjID: Int64; ObjType: Integer): TbfaSP;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectLayoutWhereObjMember', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpSelectLayoutWhereObjMember);
  try
    FbfaSP.PrepareSQL;

    FbfaSP.SetParamByNameAsLargeInt(sPrmObjID, ObjID);
    FbfaSP.SetParamByNameAsInteger(sPrmObjType, ObjType);
    FbfaSP.SetParamByNameAsInteger(sPrmState, stActive);
    FbfaSP.SetParamByNameAsInteger(sPrmRoot, otRoot);      
    FbfaSP.SetParamByNameAsInteger(sPrmMandant, otMandant);      
    FbfaSP.SetParamByNameAsInteger(sPrmStore, otStore);      
    FbfaSP.SetParamByNameAsInteger(sPrmArchive, otArchive);      
    FbfaSP.SetParamByNameAsInteger(sPrmRecordArchive, otRecordArchive);    

    FbfaSP.Open;
    Result:= FbfaSP;
  except
    FErrorCode:= ecConnectionSelectLayoutWhereObjMemberFailure;
    Log.Write(llNormal, ltException, 'spSelectLayoutWhereObjMember - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= nil;
  end;
end;

//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
(*
function TMySQL.SelectAdditionalAndStatusFields(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog): TDataSet;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectAdditionalAndStatusFields', 'bfaMySQLDatabaseScriptsU');
  with DM.spSelectAddAndStsFields do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;
      Execute;       
      
      Result:= DM.dscSelectAddAndStsFields.DataSet;
    except
      FErrorCode:= ecConnectionSelectAdditionalAndStatusFieldsFailure;
      Log.Write(llNormal, ltException, 'spSelectAddAndStsFields - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= nil;
    end;
  end;
end;  *)
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.InsertField(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; DisplayName, Description, DefaultValue, ControlItems: WideString; 
  FieldType, ControlType, ValueType, Mode, FieldOptions, IndexTableID, Size: Integer; ControlEnabled: Boolean; LayoutID: Int64; SaveImmediately: Boolean; var ContainerID : Int64): Int64;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Result:= -1;
  Log.Write(llDebug, ltInfo, 'MySQL.InsertField', 'bfaMySQLDatabaseScriptsU');
  with DM.spInsertField do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;

      ParamByName(sPrmDisplayName).AsWideString:= DisplayName;
      ParamByName(sPrmFieldType).AsInteger:= FieldType;
      ParamByName(sPrmValueType).AsInteger:= ValueType;
      ParamByName(sPrmControlType).AsInteger:= ControlType;
      ParamByName(sPrmDefaultValue).AsWideString:= DefaultValue;
      ParamByName(sPrmMode).AsInteger:= Mode;
      ParamByName(sPrmOptions).AsInteger:= FieldOptions;
      ParamByName(sPrmIndexTableID).AsInteger:= IndexTableID;
      ParamByName(sPrmDescription).AsWideString:= Description;
      if ControlEnabled then
        ParamByName(sPrmEnabled).AsSmallInt:= 1
      else
        ParamByName(sPrmEnabled).AsSmallInt:= 0;
      ParamByName(sPrmControlItems).AsWideString:= ControlItems;
      ParamByName(sPrmSize).AsInteger:= Size;
      ParamByName(sPrmState).AsInteger:= stActive;

      ParamByName(sPrmLayoutID).AsLargeInt:= LayoutID;
      ParamByName(sPrmContainerID).AsLargeInt:= ContainerID;
      ParamByName(sPrmUserType).AsInteger:= otUser;      
      ParamByName(sPrmGroupType).AsInteger:= otGroup;      
      ParamByName(sPrmRoot).AsInteger:= otRoot;      
      ParamByName(sPrmMandant).AsInteger:= otMandant;      
      ParamByName(sPrmStore).AsInteger:= otStore;      
      ParamByName(sPrmArchive).AsInteger:= otArchive;      
//      ParamByName(sPrmRecordArchive).AsInteger:= otRecordArchive;  
      ParamByName(sPrmAddFieldType).AsInteger:= otAdditionalField;
      ParamByName(sPrmStsFieldType).AsInteger:= otStatusField;
      ParamByName(sPrmUserContainerType).AsInteger:= otUserContainer;
      ParamByName(sPrmAddStsContainerType).AsInteger:= otAddFieldContainer;
      if SaveImmediately then
        ParamByName(sPrmSaveImmediately).AsSmallInt:= 1
      else
        ParamByName(sPrmSaveImmediately).AsSmallInt:= 0;
      
      Execute;       
      
      Result:= ParamByName(sPrmResult).AsLargeInt;
      if ContainerID = -1 then
        ContainerID := ParamByName(sPrmContainerID).AsLargeInt;        

    except
      FErrorCode:= ecConnectionInsertAdditionalFieldFailure;
      Log.Write(llNormal, ltException, 'spInsertField - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= -1;
    end;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.CheckIfFieldExists(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; DisplayName: WideString): Integer;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Result:= -1;
  Log.Write(llDebug, ltInfo, 'MySQL.CheckIfFieldExists', 'bfaMySQLDatabaseScriptsU');
  with DM.spCheckIfDisplaynameExists do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;

      ParamByName(sPrmDisplayName).AsWideString:= DisplayName;

      Execute;       
      
      Result:= ParamByName(sPrmResult).AsLargeInt;

    except
      FErrorCode:= ecConnectionCheckIfDisplaynameExistsFailure;
      Log.Write(llNormal, ltException, 'spCheckIfDisplaynameExists - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= -1;
    end;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.GetSysDocIdxCounter(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog): Integer;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Result:= -1;
  Log.Write(llDebug, ltInfo, 'MySQL.GetSysDocIdxCounter', 'bfaMySQLDatabaseScriptsU');
  with DM.spSelectSysDocIdxTableCounter do
  begin
    try
      Connection:= Cn;
      PrepareSQL;

      ParamByName(sPrmDatabaseName).AsWideString:= Cn.Database;

      Execute;       
      
      Result:= (ParamByName(sPrmResult).AsInteger - 1);

    except
      FErrorCode:= ecConnectionGetSysDocIdxCounterFailure;
      Log.Write(llNormal, ltException, 'spSelectSysDocIdxTableCounter - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= -1;
    end;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.CreateBaseField(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; 
  DisplayName, Description, DefaultValue, ControlItems: WideString; 
  FieldType, ControlType, ValueType, Mode, FieldOptions, IndexTableID, Size: Integer; 
  ControlEnabled: Boolean; LayoutID : Int64; SaveImmediately: Boolean; var ContainerID: Int64): Int64;
var
  FErrorCode, rslt, tblcounter, TableRowSize, FieldSize: Integer;
  AddFldID: Int64;
begin
  FErrorCode:= 0;
  Result:= -1;
  Log.Write(llDebug, ltInfo, 'MySQL.CreateField', 'bfaMySQLDatabaseScriptsU');
//  rslt:= MySQL.CheckIfFieldExists(DM, Cn, Log, DisplayName);
//  if rslt = 0 then
//  begin
    tblcounter:= MySQL.GetSysDocIdxCounter(DM, Cn, Log);
    if tblcounter >= 0 then
    begin
      with DM do
      begin
        trnBfaServer.DefaultConnection:= Cn;
        trnBfaServer.StartTransaction;      
        try

        AddFldID:= MySQL.InsertField(DM, Cn, Log, DisplayName, Description, DefaultValue, ControlItems, FieldType, ControlType, ValueType, Mode, FieldOptions, 
                            IndexTableID, Size, ControlEnabled, LayoutID, SaveImmediately, ContainerID);

        if not MySQL.CheckIfColumnExists(DM, Cn, Log, Cn.Database, sTblSysDocIdx + IntToStr(tblcounter), sSysAddFieldColumnPrefix + IntToStr(AddFldID)) then
        begin
          FieldSize:= MySQL.GetFieldSize(ValueType, Size);
          if FieldSize <> -1 then
          begin
            TableRowSize:= MySQL.GetTableRowSize(DM, Cn, log, sTblSysDocIdx + IntToStr(tblcounter));

            if (( TableRowSize + FieldSize ) < MySQLMaxRowSize) then
            begin
              FErrorCode:= MySQL.AlterIndexTable(DM, Cn, Log, sTblSysDocIdx + IntToStr(tblcounter), sSysAddFieldColumnPrefix + IntToStr(AddFldID) + ' ' + MySQL.ValueTypeToString(ValueType, Size));
              if FErrorCode <> 0 then
              begin
                tblcounter:= tblcounter + 1;
                FErrorCode:= MySQL.CreateIndexTable(DM, Cn, Log, sTblSysDocIdx + IntToStr(tblcounter), sSysAddFieldColumnPrefix + IntToStr(AddFldID) + ' ' + MySQL.ValueTypeToString(ValueType, Size));
              end;
            end
            else
            begin
              tblcounter:= tblcounter + 1;
              FErrorCode:= MySQL.CreateIndexTable(DM, Cn, Log, sTblSysDocIdx + IntToStr(tblcounter), sSysAddFieldColumnPrefix + IntToStr(AddFldID) + ' ' + MySQL.ValueTypeToString(ValueType, Size));
            end;

            if FErrorCode = 0 then
            begin
              FErrorCode:= MySQL.UpdateFieldIndexTableID(DM, Cn, Log, AddFldID, tblcounter);
              if FErrorCode = 0 then
              begin
                Result:= AddFldID;
                trnBfaServer.Commit;
              end
              else
              begin
              trnBfaServer.Rollback;
              Result:= -7; // Update IndexTableID error
              end;
            end
            else
            begin
              trnBfaServer.Rollback;
              Result:= -6; // Cannot Create/Alter table
            end;
          end
          else
          begin
            trnBfaServer.Rollback;
            Result:= -5; // FieldType error
          end;
        end
        else
        begin
          trnBfaServer.Rollback;
          Result:= -4; // Column Already exists in table
        end;
        

        except
          trnBfaServer.Rollback;
          FErrorCode:= ecConnectionCreateAdditionalFieldFailure;
          Log.Write(llNormal, ltException, 'MySQL.CreateField - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
          Result:= -1;
        end;  
      end;
    end
    else
      Result:= -3; // sys_docidx_% Fehler
//  end
//  else
//  begin
//    if rslt > 0 then
//      Result:= -2 // -2 DisplayName exsitst, -1 error
//    else
//      Result:= rslt;
//  end;  
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.CheckIfColumnExists(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; DBName, TableName, ColumnName: string): Boolean;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.CheckIfColumnExists', 'bfaMySQLDatabaseScriptsU');
  with DM.spCheckIfColumnExists do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;
                  
      ParamByName(sPrmDBName).AsString:= DBName;
      ParamByName(sPrmTableName).AsString:= TableName;
      ParamByName(sPrmColumnName).AsString:= ColumnName;

      Execute;       
      
      if  ParamByName(sPrmResult).AsInteger > 0 then
        Result:= True
      else
        Result:= False;
      
    except
      FErrorCode:= ecConnectionCheckIfColumnExistsFailure;
      Log.Write(llNormal, ltException, 'spCheckIfColumnExists - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= False;
    end;
  end;
end; 
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.GetFieldSize(FieldType: Integer; Size: Integer = 255): Integer;
begin
  if FieldType = vtBigInt then
    Result:= 8
  else if FieldType = vtTinyInt then
    Result:= 1
  else if FieldType = vtInteger then
    Result:= 4
  else if FieldType = vtString then
    Result:= (Size * 3)   // *3 Because of the Unicode
  else if FieldType = vtDateTime then
    Result:= 8
  else if FieldType = vtDouble then
    Result:= 8
  else if FieldType = vtFloat then
    Result:= 4
  else if FieldType = vtDecimal then
    Result:= 8
  else if FieldType = vtNumeric then
    Result:= 8
  else
    Result:= -1;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.GetTableFieldSize(FieldType: String): Integer;
var
  i: Integer;
  cnt: String;
begin
  FieldType:= UpperCase(FieldType);
  if Pos(sSysBIGINT,FieldType) > 0 then
    Result:= MySQL.GetFieldSize(vtBigInt)
  else if Pos(sSysTINYINT,FieldType) > 0 then
    Result:= MySQL.GetFieldSize(vtTinyInt)
  else if Pos(sSysINT,FieldType) > 0 then
    Result:= MySQL.GetFieldSize(vtInteger)
  else if Pos(sSysVARCHAR,FieldType) > 0 then
  begin
    cnt:= '';
    for i:= Pos('(', FieldType)+1 to Pos(')', FieldType)-1 do
      cnt:= cnt + FieldType[i];
    Result:= MySQL.GetFieldSize(vtString, StrToInt(cnt));
  end
  else if Pos(sSysDATETIME,FieldType) > 0 then
    Result:= MySQL.GetFieldSize(vtDateTime)
  else if Pos(sSysDOUBLE,FieldType) > 0 then
    Result:= MySQL.GetFieldSize(vtDouble)
  else if Pos(sSysFLOAT,FieldType) > 0 then
    Result:= MySQL.GetFieldSize(vtFloat)
  else if Pos(sSysDECIMAL,FieldType) > 0 then
    Result:= MySQL.GetFieldSize(vtDecimal)
  else if Pos(sSysNUMERIC,FieldType) > 0 then
    Result:= MySQL.GetFieldSize(vtNumeric)
  else
    Result:= -1;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.ValueTypeToString(ValueType: Integer; Size: Integer = 255): String;
begin
  try
    if ValueType = vtBigInt then
      Result:= sSysBIGINT
    else if ValueType = vtTinyInt then
      Result:= sSysTINYINT
    else if ValueType = vtInteger then
      Result:= sSysINT
    else if ValueType = vtString then
      Result:= sSysVARCHAR + ' (' + IntToStr(Size) + ')'
    else if ValueType = vtDateTime then
      Result:= sSysDATETIME
    else if ValueType = vtDouble then
      Result:= sSysDOUBLE
    else if ValueType = vtFloat then
      Result:= sSysFLOAT
    else if ValueType = vtDecimal then
      Result:= sSysDECIMAL
    else if ValueType = vtNumeric then
      Result:= sSysNUMERIC
    else
      Result:= sSysVARCHAR255;
  except
    Result:= sSysVARCHAR255;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.SelectTableColumns(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; DBName, TableName: String): TDataSet;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectTableColumns', 'bfaMySQLDatabaseScriptsU');
  with DM.spSelectTableColumns do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;
                  
      ParamByName(sPrmDBName).AsString:= DBName;
      ParamByName(sPrmTableName).AsString:= TableName;
      
      Execute;       
      
      Result:= DM.dscSelectTableColumns.DataSet;
    except
      FErrorCode:= ecConnectionspSelectTableColumnsFailure;
      Log.Write(llNormal, ltException, 'spSelectTableColumns - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= nil;
    end;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.GetTableRowSize(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; Tablename: String): Integer;
var
  FErrorCode, ColSize, ActRowSize: Integer;
  dsc: TUniDataSource;
begin
  FErrorCode:= 0;
  Result:= -1;
  Log.Write(llDebug, ltInfo, 'MySQL.GetTableRowSize', 'bfaMySQLDatabaseScriptsU');
  dsc:= TUniDataSource.Create(DM);
  try
    try
      dsc.DataSet:= MySQL.SelectTableColumns(DM, Cn, Log, Cn.Database, TableName);
      if dsc.DataSet.RecordCount > 0 then
      begin 
        ActRowSize:= 0;
        with dsc.DataSet do
        begin        
          First;
          while not Eof do
          begin
            ColSize:= MySQL.GetTableFieldSize(FieldByName(sColColumType).AsString);
            if ColSize <> -1 then
            begin
              ActRowSize:= ActRowSize + ColSize;
            end;
            
            Next;
          end;
          Close;
          Result:= ActRowsize;
        end;
      end
      else
        Result:= -1;
  
    except
      FErrorCode:= ecConnectionGetTableRowSizeFailure;
      Log.Write(llNormal, ltException, 'MySQL.GetTableRowSize - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= -1;
    end;
  finally
    FreeAndNil(dsc);
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.CreateIndexTable(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; TableName, ColumnName: String): Integer;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Result:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.CreateIndexTable', 'bfaMySQLDatabaseScriptsU');
  with DM.spCreateSysDocIdxTable do
  begin
    try
      Connection:= Cn;
      PrepareSQL;

      ParamByName(sPrmTableName).AsWideString:= TableName;
      ParamByName(sPrmColumn).AsWideString:= ColumnName;

      Execute;       
      
    except
      FErrorCode:= ecConnectionCreateIndexTableFailure;
      Log.Write(llNormal, ltException, 'spCreateSysDocIdxTable - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= -1;
    end;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.AlterIndexTable(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; TableName, ColumnName: String): Integer;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Result:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.AlterIndexTable', 'bfaMySQLDatabaseScriptsU');
  with DM.spAlterSysDocIdxTable do
  begin
    try
      Connection:= Cn;
      PrepareSQL;

      ParamByName(sPrmTableName).AsWideString:= TableName;
      ParamByName(sPrmColumn).AsWideString:= ColumnName;

      Execute;       
      
    except
      FErrorCode:= ecConnectionAlterIndexTableFailure;
      Log.Write(llNormal, ltException, 'spAlterSysDocIdxTable - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= -1;
    end;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.UpdateFieldIndexTableID(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; AddFieldID: Int64; IndexTableID: Integer): Integer;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Result:= -1;
  Log.Write(llDebug, ltInfo, 'MySQL.UpdateFieldIndexTableID', 'bfaMySQLDatabaseScriptsU');
  with DM.spUpdateFieldIndexTableID do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;
      
      ParamByName(sPrmAddFieldID).AsLargeInt:= AddFieldID;
      ParamByName(sPrmIndexTableID).AsInteger:= IndexTableID;
      Execute;       
      
      Result:= FErrorCode;      
    except
      FErrorCode:= ecConnectionUpdateAdditionalFieldIndexTableIDFailure;
      Log.Write(llNormal, ltException, 'spUpdateFieldIndexTableID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= FErrorCode;
    end;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.SelectBaseFieldByID(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; AddFldID: Int64; var FldRec: TBaseFldRec): Integer;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectFieldByID', 'bfaMySQLDatabaseScriptsU');
  with DM.spSelectFieldByID do
  begin
    try
      Connection:= Cn;
      PrepareSQL;
      
      ParamByName(sPrmAddFieldID).AsLargeInt:= AddFldID;
      Execute;
      if RecordCount > 0 then
      begin
        FldRec.FldID:= FieldByName(sColAddFieldID).AsLargeInt;
        FldRec.DisplayName:= FieldByName(sColDisplayname).AsWideString;
        FldRec.FieldType:= FieldByName(sColFieldType).AsInteger;
        FldRec.ValueType:= FieldByName(sColValueType).AsInteger;
        FldRec.ControlType:= FieldByName(sColControlType).AsInteger;
        FldRec.Mode:= FieldByName(sColMode).AsInteger;
        FldRec.Options:= FieldByName(sColOptions).AsInteger;
        FldRec.DefaultValue:= FieldByName(sColDefaultValue).AsWideString;
        FldRec.IndexTableID:= FieldByName(sColIndexTableID).AsInteger;
        FldRec.Description:= FieldByName(sColDescription).AsWideString;
        if FieldByName(sColEnabled).AsInteger = 0 then
          FldRec.Enabled:= False
        else if FieldByName(sColEnabled).AsInteger = 1 then
          FldRec.Enabled:= True;
        FldRec.Size:= FieldByName(sColSize).AsInteger;
        FldRec.ControlItems:= FieldByName(sColControlItems).AsWideString;
        FldRec.Status:= FieldByName(sColState).AsInteger;
      end
      else
      begin
        FErrorCode:= ecNoRecord;
        Log.Write(llNormal, ltError, 'spSelectFieldByID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      end;

      Result:= FErrorCode;
    except
      FErrorCode:= ecConnectionSelectAdditionalFieldByIDFailure;
      Log.Write(llNormal, ltException, 'spSelectFieldByID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= FErrorCode;
    end;
  end;
end;
//
function TMySQL.SelectFieldByArchiveID(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; FldID, ArchiveID, UserID: Int64; UserIdx, GroupIdx: Integer; var FldRec: TFldRec): TbfaSP;
var
  FbfaSP, FbfaMember: TbfaSP;
  FErrorCode: Integer;
  Rights, UserRight: UInt64;
  i, idx: Integer;
  found: Boolean;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectFieldByArchiveID', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpFieldByArchiveID);
  try
    FbfaSP.PrepareSQL;

    FbfaSP.SetParamByNameAsLargeInt(sPrmArchiveID, ArchiveID);
    FbfaSP.SetParamByNameAsInteger(sPrmAddFieldID, FldID);

    FbfaSP.Execute;

    if FbfaSP.RecordCount > 0 then
    begin
      FldRec.FldID:= FbfaSp.FieldByNameAsLargeInt(sColAddFieldID);
      FldRec.DisplayName:= FbfaSp.FieldByNameAsWideString(sColDisplayname);
      FldRec.FieldType:= FbfaSp.FieldByNameAsInteger(sColFieldType);
      FldRec.ValueType:= FbfaSp.FieldByNameAsInteger(sColValueType);
      FldRec.ControlType:= FbfaSp.FieldByNameAsInteger(sColControlType);
      FldRec.Mode:= FbfaSp.FieldByNameAsInteger(sColMode);
      FldRec.Options:= FbfaSp.FieldByNameAsInteger(sColOptions);
      FldRec.DefaultValue:= FbfaSp.FieldByNameAsWideString(sColDefaultValue);
      FldRec.IndexTableID:= FbfaSp.FieldByNameAsInteger(sColIndexTableID);
      FldRec.Description:= FbfaSp.FieldByNameAsWideString(sColDescription);
      if FbfaSp.FieldByNameAsInteger(sColEnabled) = 0 then
        FldRec.Enabled:= False
      else if FbfaSp.FieldByNameAsInteger(sColEnabled) = 1 then
        FldRec.Enabled:= True;
      FldRec.Size:= FbfaSp.FieldByNameAsInteger(sColSize);
      FldRec.ControlItems:= FbfaSp.FieldByNameAsWideString(sColControlItems);
      FldRec.Status:= FbfaSp.FieldByNameAsInteger(sColState);
      FldRec.UserRead:= False;
      FldRec.UserWrite:= False;
      FldRec.UserModify:= False;
      FldRec.HasRights:= False;

      if UserIdx <> -1 then
      begin
        i:= 0;
        while (i<=UserIdx) and (not FldRec.HasRights) do
        begin
          if (not FldRec.HasRights) then  
          begin
            if (FbfaSp.FieldByNameAsLargeInt(sSysRead_ + IntToStr(i)) > 0 ) then
              FldRec.HasRights:= True;
          end;
          if (not FldRec.HasRights) then  
          begin
            if (FbfaSp.FieldByNameAsLargeInt(sSysWrite_ + IntToStr(i)) > 0 ) then
              FldRec.HasRights:= True;
          end;
          if (not FldRec.HasRights) then  
          begin
            if (FbfaSp.FieldByNameAsLargeInt(sSysModify_ + IntToStr(i)) > 0 ) then
              FldRec.HasRights:= True;
          end;
          inc(i);
        end;
      end;

      if GroupIdx <> -1 then
      begin
        i:= 0;
        while (i<=GroupIdx) and (not FldRec.HasRights) do
        begin
          if (not FldRec.HasRights) then  
          begin
            if (FbfaSp.FieldByNameAsLargeInt(sSysGRead_ + IntToStr(i)) > 0 ) then
              FldRec.HasRights:= True;
          end;
          if (not FldRec.HasRights) then  
          begin
            if (FbfaSp.FieldByNameAsLargeInt(sSysGWrite_ + IntToStr(i)) > 0 ) then
              FldRec.HasRights:= True;
          end;
          if (not FldRec.HasRights) then  
          begin
            if (FbfaSp.FieldByNameAsLargeInt(sSysGModify_ + IntToStr(i)) > 0 ) then
              FldRec.HasRights:= True;
          end;
          inc(i);
        end;
      end;
      
      if (UserID > 0) and (FldRec.HasRights) then // angemeldete UserID
      begin
        idx:= (UserID div 64);
        Rights:= FbfaSp.FieldByNameAsLargeInt(sSysRead_ + IntToStr(idx));
        UserRight:= bfaPower(UserID - 1);
        if ((Rights and UserRight) = UserRight) then
          FldRec.UserRead:= True;
        Rights:= FbfaSp.FieldByNameAsLargeInt(sSysWrite_ + IntToStr(idx));
        if ((Rights and UserRight) = UserRight) then
          FldRec.UserWrite:= True;
        Rights:= FbfaSp.FieldByNameAsLargeInt(sSysModify_ + IntToStr(idx));
        if ((Rights and UserRight) = UserRight) then
          FldRec.UserModify:= True;


        if ((not FldRec.UserRead) and (not FldRec.UserWrite) and (not FldRec.UserModify)) then
        begin
          FbfaMember:= SelectWhereObjMember(Cn, Log, UserID, otUser);
          try
            if FbfaMember.RecordCount > 0 then
            begin
              FbfaMember.First;
              while ((not FbfaMember.Eof) and ((not FldRec.UserRead) and (not FldRec.UserWrite) and (not FldRec.UserModify)) )do
              begin
                idx:= (FbfaMember.FieldByNameAsLargeInt(sColGrpID) div 64);
                Rights:= FbfaSp.FieldByNameAsLargeInt(sSysGRead_ + IntToStr(idx));
                UserRight:= bfaPower(FbfaMember.FieldByNameAsLargeInt(sColGrpID) - 1);
                if ((Rights and UserRight) = UserRight) then
                  FldRec.UserRead:= True;
                Rights:= FbfaSp.FieldByNameAsLargeInt(sSysGWrite_ + IntToStr(idx));
                if ((Rights and UserRight) = UserRight) then
                  FldRec.UserWrite:= True;
                Rights:= FbfaSp.FieldByNameAsLargeInt(sSysGModify_ + IntToStr(idx));
                if ((Rights and UserRight) = UserRight) then
                  FldRec.UserModify:= True;
              
            
                FbfaMember.Next;
              end;
            end;          
          finally
            FbfaMember.Close;
          end;
        end;
      end;

      Result:= FbfaSP;
  
    end
    else
    begin
      FErrorCode:= ecNoRecord;
      Log.Write(llNormal, ltError, 'spSelectFieldByArchiveID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= nil;
    end;
  
  except
    FErrorCode:= ecConnectionSelectAdditionalFieldByIDFailure;
    Log.Write(llNormal, ltException, 'spSelectFieldByArchiveID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= nil;
  end;
end;
//
function TMySQL.SelectAdminFieldByArchiveID(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; FldID, ArchiveID, UserID: Int64; UserColumn, GroupColumn: Integer; var FldRec: TFldRec; List : TList<TbfaPermission>): Integer;
var
  FbfaSp: TbfaSP;
  FErrorCode, i, Items : Integer;
  RightsRead, RightsWrite, RightsModify : UInt64;

  procedure SetOneRight(dsc: TbfaSP; Typ, idx: Integer; List : TList<TbfaPermission>);
  var 
    j,k: Integer;
    Obj : TbfaBaseObject;
    Perm : TbfaPermission;
    found : Boolean;
  begin  
    if Typ = otUser then
    begin
      RightsRead := dsc.FieldByNameAsLargeInt(sSysRead_ + IntToStr(Idx));
      RightsWrite := dsc.FieldByNameAsLargeInt(sSysWrite_ + IntToStr(Idx));
      RightsModify := dsc.FieldByNameAsLargeInt(sSysModify_ + IntToStr(Idx));
    end
    else if Typ = otGroup then
    begin
      RightsRead := dsc.FieldByNameAsLargeInt(sSysGRead_ + IntToStr(Idx));
      RightsWrite := dsc.FieldByNameAsLargeInt(sSysGWrite_ + IntToStr(Idx));
      RightsModify := dsc.FieldByNameAsLargeInt(sSysGModify_ + IntToStr(Idx));
    end;

    for j:= 0 to 63 do
    begin
      Obj := TbfaBaseObject.Create;
      Obj.ID := Items + j + 1;
      Obj.ObjType := Typ;
      Obj.Status := stActive;
      
      Perm := TbfaPermission.Create(Obj, '', False, False, False);
      
      found := False;
    
      if ((RightsRead and bfaPower(j)) = bfaPower(j)) then
      begin
        found := True;
        Perm.ReadRight := True;
      end;

      if ((RightsWrite and bfaPower(j)) = bfaPower(j)) then
      begin
        found := True;
        Perm.WriteRight := True;
      end;

      if ((RightsModify and bfaPower(j)) = bfaPower(j)) then
      begin
        found := True;
        Perm.ModifyRight := True;
      end;

      if (not found) then
      begin
        FreeandNil(Obj);
        FreeAndNil(Perm);
      end
      else
        List.Add(Perm);
      
    end;  
  end;
  
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectAdminFieldByArchiveID', 'bfaMySQLDatabaseScriptsU');
    try
      FbfaSp:= SelectFieldByArchiveID(Dm, CN, Log, FldId, ArchiveID, UserID, -1, -1, FldRec);
      if FbfaSp.RecordCount > 0 then
      begin

        //////// Hier muss Berechtigung gelesen werden 
        Items:= 0;
        for i:= 0 to (UserColumn div 64) do
        begin
          SetOneRight(FbfaSp, otUser, i, List);
          Items:= Items + 64;
        end;

        Items:= 0;
        for i:= 0 to (GroupColumn div 64) do
        begin
          SetOneRight(FbfaSp, otGroup, i, List);
          Items:= Items + 64;        
        end;

        
      end
      else
      begin
        FErrorCode:= ecNoRecord;
        Log.Write(llNormal, ltError, 'spSelectFieldByArchiveID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      end;

      Result:= FErrorCode;
    except
      FErrorCode:= ecConnectionSelectAdditionalFieldByIDFailure;
      Log.Write(llNormal, ltException, 'spSelectFieldByArchiveID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= FErrorCode;
    end;
end;
//function TMySQL.SelectAdminFieldByArchiveID(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; FldID, ArchiveID, UserID: Int64; var FldRec: TFldRec; var UsrArray, GrpArray: array of Integer): Integer;
//var
//  FbfaSp: TbfaSP;
//  FErrorCode, i, Items: Integer;
//  Rights: UInt64;
//
//  procedure SetOneRight(dsc: TbfaSP; FieldName: WideString; Rght: Integer; var DynArray: array of Integer);
//  var 
//    j: Integer;
//  begin  
//    Rights:= dsc.FieldByNameAsLargeInt(FieldName);
//    for j:= 0 to 63 do
//    begin
//      if ((Rights and bfaPower(j)) = bfaPower(j)) then
//        DynArray[Items + j]:= DynArray[Items + j] + Rght;
//    end;  
//  end;
//  
//begin
//  FErrorCode:= 0;
//  Log.Write(llDebug, ltInfo, 'MySQL.SelectAdminFieldByArchiveID', 'bfaMySQLDatabaseScriptsU');
//    try
//      FbfaSp:= SelectFieldByArchiveID(Dm, CN, Log, FldId, ArchiveID, UserID, -1, -1, FldRec);
//      if FbfaSp.RecordCount > 0 then
//      begin
//
//        //////// Hier muss Berechtigung gelesen werden 
//        Items:= 0;
//        for i:= 0 to (High(UsrArray) div 64) do
//        begin
//          SetOneRight(FbfaSp, sSysRead_ + IntToStr(i), rFieldRead, UsrArray);
//          SetOneRight(FbfaSp, sSysWrite_ + IntToStr(i), rFieldWrite, UsrArray);
//          SetOneRight(FbfaSp, sSysModify_ + IntToStr(i), rFieldModify, UsrArray);
//          Items:= Items + 64;
//        end;
//
//        Items:= 0;
//        for i:= 0 to (High(GrpArray) div 64) do
//        begin
//          SetOneRight(FbfaSp, sSysGRead_ + IntToStr(i), rFieldRead, GrpArray);
//          SetOneRight(FbfaSp, sSysGWrite_ + IntToStr(i), rFieldWrite, GrpArray);
//          SetOneRight(FbfaSp, sSysGModify_ + IntToStr(i), rFieldModify, GrpArray);
//          Items:= Items + 64;        
//        end;
//
//        
//      end
//      else
//      begin
//        FErrorCode:= ecNoRecord;
//        Log.Write(llNormal, ltError, 'spSelectFieldByArchiveID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
//      end;
//
//      Result:= FErrorCode;
//    except
//      FErrorCode:= ecConnectionSelectAdditionalFieldByIDFailure;
//      Log.Write(llNormal, ltException, 'spSelectFieldByArchiveID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
//      Result:= FErrorCode;
//    end;
//end;
//
function TMySQL.UpdateBaseField(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; Field: TBaseFldRec; OnlyName : Boolean): Integer;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Result:= -1;
  Log.Write(llDebug, ltInfo, 'MySQL.UpdateField', 'bfaMySQLDatabaseScriptsU');
  with DM.spUpdateField do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;

      ParamByName(sPrmAddFieldID).AsLargeInt:= Field.FldID;
      ParamByName(sPrmDisplayName).AsWideString:= Field.DisplayName;
      ParamByName(sPrmFieldType).AsInteger:= Field.FieldType;  
      ParamByName(sPrmDefaultValue).AsWideString:= Field.DefaultValue;  
      ParamByName(sPrmIndexTableID).AsInteger:= Field.IndexTableID;  
      ParamByName(sPrmValueType).AsInteger:= Field.ValueType;  
      ParamByName(sPrmControlType).AsInteger:= Field.ControlType;  
      ParamByName(sPrmMode).AsInteger:= Field.Mode;  
      ParamByName(sPrmOptions).AsInteger:= Field.Options;  
      ParamByName(sPrmDescription).AsWideString:= Field.Description;  
      if Field.Enabled then
        ParamByName(sPrmEnabled).AsInteger:= 1
      else
        ParamByName(sPrmEnabled).AsInteger:= 0;
      ParamByName(sPrmControlItems).AsWideString:= Field.ControlItems;  
      ParamByName(sPrmSize).AsInteger:= Field.Size;  
      ParamByName(sPrmState).AsInteger:= Field.Status;  
      if OnlyName then
        ParamByName(sPrmOnlyName).AsInteger:= 1
      else
        ParamByName(sPrmOnlyName).AsInteger:= 0;
      Execute;       
      
      Result:= FErrorCode;      
    except
      FErrorCode:= ecConnectionUpdateBaseAdditionalFieldFailure;
      Log.Write(llNormal, ltException, 'spUpdateField - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= FErrorCode;
    end;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.UpdateField(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; Field: TFldRec): Integer;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Result:= -1;
  Log.Write(llDebug, ltInfo, 'MySQL.UpdateField', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpUpdateFieldinMapping);
  try
    FbfaSp.PrepareSQL;

    FbfaSP.SetParamByNameAsLargeInt(sPrmAddFieldID, Field.FldID);  
    FbfaSP.SetParamByNameAsLargeInt(sPrmArchiveID, Field.ArchiveID);  
    FbfaSP.SetParamByNameAsInteger(sPrmMode, Field.Mode);  
    FbfaSP.SetParamByNameAsInteger(sPrmOptions, Field.Options);  
    FbfaSP.SetParamByNameAsWideString(sPrmDefaultValue, Field.DefaultValue);  
    FbfaSP.SetParamByNameAsWideString(sPrmDescription, Field.Description);  
    FbfaSP.SetParamByNameAsWideString(sPrmControlItems, Field.ControlItems);  

    FbfaSP.Execute;       

    Result:= FErrorCode;      
  except
    FErrorCode:= ecConnectionUpdateAdditionalFieldFailure;
    Log.Write(llNormal, ltException, 'spUpdateField - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= -1;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 17.04.2013 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.UpdateFieldInheritedMapping(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; LayoutID: Int64; Field: TFldRec): Integer;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Result:= -1;
  Log.Write(llDebug, ltInfo, 'MySQL.UpdateFieldInheritedMapping', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpUpdateFieldInheritedMapping);
  try
    FbfaSp.PrepareSQL;

    FbfaSP.SetParamByNameAsLargeInt(sPrmLayoutID, LayoutID);  
    FbfaSP.SetParamByNameAsLargeInt(sPrmAddFieldID, Field.FldID);  
    FbfaSP.SetParamByNameAsLargeInt(sPrmArchiveID, Field.ArchiveID);  
    FbfaSP.SetParamByNameAsInteger(sPrmMode, Field.Mode);  
    FbfaSP.SetParamByNameAsInteger(sPrmOptions, Field.Options);  
    FbfaSP.SetParamByNameAsWideString(sPrmDefaultValue, Field.DefaultValue);  
    FbfaSP.SetParamByNameAsWideString(sPrmDescription, Field.Description);  
    FbfaSP.SetParamByNameAsWideString(sPrmControlItems, Field.ControlItems);  
    FbfaSP.SetParamByNameAsInteger(sPrmRoot, otRoot);
    FbfaSP.SetParamByNameAsInteger(sPrmMandant, otMandant);
    FbfaSP.SetParamByNameAsInteger(sPrmStore, otStore);
    FbfaSP.SetParamByNameAsInteger(sPrmArchive, otArchive);
    FbfaSP.SetParamByNameAsInteger(sPrmRecordArchive, otRecordArchive);

    FbfaSP.Execute;       

    Result:= FErrorCode;      
  except
    FErrorCode:= ecConnectionUpdateAdditionalFieldFailure;
    Log.Write(llNormal, ltException, 'UpdateFieldInheritedMapping - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= -1;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.DeleteUserOrGroupFromGroup(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; ObjID, ParentID: Int64; ObjType: Integer): Integer;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Result:= -1;
  Log.Write(llDebug, ltInfo, 'MySQL.DeleteUserOrGroupFromGroup', 'bfaMySQLDatabaseScriptsU');
  with DM.spDeleteUserGroupFromGroup do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;
      
      ParamByName(sPrmObjID).AsLargeInt:= ObjID;
      ParamByName(sPrmParentID).AsLargeInt:= ParentID;
      ParamByName(sPrmObjType).AsInteger:= ObjType;
      ParamByName(sPrmGroupType).AsInteger:= otGroup;

      Execute;       
      
      Result:= FErrorCode;      
      
    except
      FErrorCode:= ecConnectionDeleteUserOrGroupFromGroupFailure;
      Log.Write(llNormal, ltException, 'spDeleteUserGroupFromGroup - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= FErrorCode;
    end;
  end;
end;
//
function TMySQL.SelectFields(Cn: TUniConnection; Log: TbfaLog; ArchiveID: Int64): TBfaSp;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectFields', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpSelectFields);
  try
    FbfaSP.PrepareSQL;
    FbfaSP.SetParamByNameAsLargeInt(sPrmArchiveID, ArchiveID);
    FbfaSP.SetParamByNameAsSmallInt(sPrmEnabled, 1);  
    FbfaSP.Open;
    Result:= FbfaSP;
  except
    FErrorCode:= ecConnectionSelectAdditionalFieldsFailure;
    Log.Write(llNormal, ltException, 'SelectFields - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= nil;
  end;
end;
//
function TMySQL.GetFieldValue(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; typ: Integer; id: Int64; coltyp: Integer = 0): WideString;
var
  col, tbl, colid: string;
begin
  try
  
    with DM.qryGetFieldValues do
    begin
      Connection:= Cn;
  
      if ((typ = otRoot) or (typ = otMandant) or (typ = otStore) or (typ = otArchive) or (typ = otRecordArchive)) then
      begin
        colid:= sColArcID;
        col:= sColArcName;
        tbl:= sTblSysArc;
      end
      else if (typ = otGroup) then
      begin
        colid:= sColGrpID;
        col:= sColGrpName;
        tbl:= sTblSysGrp;
      end
      else if (typ = otUser) then
      begin
        colid:= sColUserID;
        col:= sColUserName;
        tbl:= sTblSysUsr;
      end
      else if ((typ = otAdditionalField) or (typ = otStatusField))then
      begin
        colid:= sColAddFieldID;
        col:= sColDisplayname;
        tbl:= sTblSysAddField;
      end;

      if coltyp = 1 then
        col:= sColDescription
      else if coltyp = 2 then
        col:= sColColor
      else if coltyp = 3 then
        col:= sColIcon;
            
      SQL.Text:= sSysSELECT + ' ' + col +  
        ' ' + sSysFROM + ' ' + tbl + ' ' + sSysWHERE + ' ' + colid + ' = ' + IntToStr(id) + ';';
      Open;
      if RecordCount > 0 then
        Result:= FieldByName(col).AsWideString
      else
        Result:= '';
    
      Close;  
    end;
  except
    Result:= '';
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.GetContainerObjects(Cn: TUniConnection; Log: TbfaLog; ArchiveLayoutID: Int64; ContainerType, ListType, SQLType: Integer; LayoutIDs: string): TbfaSP;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.GetContainerOjects', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpSelectContainerObjects);
  try
    FbfaSP.PrepareSQL;
    FbfaSP.SetParamByNameAsString(sPrmLayoutIDs, LayoutIDs);
    FbfaSP.SetParamByNameAsInteger(sPrmContainerType, ContainerType);
    FbfaSP.SetParamByNameAsInteger(sPrmGroupType, otGroup);
    FbfaSP.SetParamByNameAsInteger(sPrmUserType, otUser);
    FbfaSP.SetParamByNameAsInteger(sPrmUserContainerType, otUserContainer);
    FbfaSP.SetParamByNameAsInteger(sPrmAddStsContainerType, otAddFieldContainer);
    FbfaSP.SetParamByNameAsInteger(sPrmAddFieldType, otAdditionalField);
    FbfaSP.SetParamByNameAsInteger(sPrmStsFieldType, otStatusField);
    FbfaSP.SetParamByNameAsInteger(sPrmListType, ListType);
    FbfaSP.SetParamByNameAsInteger(sPrmArchive, otArchive);
    FbfaSP.SetParamByNameAsInteger(sPrmRecordArchive, otRecordArchive);
    FbfaSP.SetParamByNameAsInteger(sPrmSQLType, SQLType); 
    FbfaSP.SetParamByNameAsLargeInt(sPrmArchiveLayoutID, ArchiveLayoutID);  

    FbfaSP.Execute;
    Result:= FbfaSP;
  except
    FErrorCode:= ecConnectionGetContainerOjectsFailure;
    Log.Write(llNormal, ltException, 'spSelectContainerObjectss - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= nil;
  end;
(*
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.GetContainerOjects', 'bfaMySQLDatabaseScriptsU');
  with DM.spSelectContainerObjects do
  begin
    try
      Connection:= Cn;
      PrepareSQL;
      
      ParamByName(sPrmLayoutIDs).AsString:= LayoutIDs;
      ParamByName(sPrmContainerType).AsInteger:= ContainerType;
      ParamByName(sPrmGroupType).AsInteger:= otGroup;
      ParamByName(sPrmUserType).AsInteger:= otUser;
      ParamByName(sPrmUserContainerType).AsInteger:= otUserContainer;
      ParamByName(sPrmAddStsContainerType).AsInteger:= otAddFieldContainer;
      ParamByName(sPrmAddFieldType).AsInteger:= otAdditionalField;
      ParamByName(sPrmStsFieldType).AsInteger:= otStatusField;
      ParamByName(sPrmListType).AsInteger:= ListType;
      ParamByName(sPrmArchive).AsInteger:= otArchive;
      ParamByName(sPrmRecordArchive).AsInteger:= otRecordArchive;
      ParamByName(sPrmSQLType).AsInteger:= SQLType;


      ParamByName(sPrmArchiveLayoutID).AsLargeInt:= ArchiveLayoutID;
      
      Execute;
      
      Result:= DM.dscSelectContainerOjects.DataSet;
      
    except
      FErrorCode:= ecConnectionGetContainerOjectsFailure;
      Log.Write(llNormal, ltException, 'spSelectContainerObjectss - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= nil;
    end;
  end;  *)
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.SelectAvailableUsers(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; ArchiveLayoutID: Int64; FullList: Integer): TDataSet;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectAvailableUsers', 'bfaMySQLDatabaseScriptsU');
  with DM.spSelectAvailableUsers do
  begin
    try
      Connection:= Cn;
      PrepareSQL;
      
      ParamByName(sPrmArchiveLayoutID).AsLargeInt:= ArchiveLayoutID;
      ParamByName(sPrmInherit).AsInteger:= FullList;
      ParamByName(sPrmContainerType).AsInteger:= otUserContainer;
      ParamByName(sPrmGroupType).AsInteger:= otGroup;
      ParamByName(sPrmUserType).AsInteger:= otUser;
      ParamByName(sPrmUserContainerType).AsInteger:= otUserContainer;
      ParamByName(sPrmAddStsContainerType).AsInteger:= otAddFieldContainer;
      ParamByName(sPrmAddFieldType).AsInteger:= otAdditionalField;
      ParamByName(sPrmStsFieldType).AsInteger:= otStatusField;
      ParamByName(sPrmListType).AsInteger:= 1;
      Execute;
      
      Result:= DM.dscSelectAvailableUsers.DataSet;
      
    except
      FErrorCode:= ecConnectionSelectAvailableObjectsFailure;
      Log.Write(llNormal, ltException, 'spSelectAvailableObjects - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= nil;
    end;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.SelectAvailableGroups(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; ArchiveLayoutID: Int64; FullList: Integer): TDataSet;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectAvailableGroups', 'bfaMySQLDatabaseScriptsU');
  with DM.spSelectAvailableGroups do
  begin
    try
      Connection:= Cn;
      PrepareSQL;
      
      ParamByName(sPrmArchiveLayoutID).AsLargeInt:= ArchiveLayoutID;
      ParamByName(sPrmInherit).AsInteger:= FullList;
      ParamByName(sPrmContainerType).AsInteger:= otUserContainer;
      ParamByName(sPrmGroupType).AsInteger:= otGroup;
      ParamByName(sPrmUserType).AsInteger:= otUser;
      ParamByName(sPrmUserContainerType).AsInteger:= otUserContainer;
      ParamByName(sPrmAddStsContainerType).AsInteger:= otAddFieldContainer;
      ParamByName(sPrmAddFieldType).AsInteger:= otAdditionalField;
      ParamByName(sPrmStsFieldType).AsInteger:= otStatusField;
      ParamByName(sPrmListType).AsInteger:= 2;
      Execute;
      
      Result:= DM.dscSelectAvailableGroups.DataSet;
      
    except
      FErrorCode:= ecConnectionSelectAvailableObjectsFailure;
      Log.Write(llNormal, ltException, 'spSelectAvailableObjects - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= nil;
    end;
  end;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TMySQL.SelectArchiveAncestorObjects(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; LayoutID: Int64): TbfaSP;
var
  FbfaSP: TbfaSP;
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectArchiveAncestorObjects', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpSelectArchiveAncestorObjects);
  try
    FbfaSP.PrepareSQL;
      
    FbfaSP.SetParamByNameAsLargeInt(sPrmLayoutID, LayoutID);
    FbfaSP.SetParamByNameAsInteger(sPrmRoot, otRoot);
    FbfaSP.SetParamByNameAsInteger(sPrmMandant, otMandant);
    FbfaSP.SetParamByNameAsInteger(sPrmStore, otStore);
    FbfaSP.SetParamByNameAsInteger(sPrmArchive, otArchive);
    FbfaSP.SetParamByNameAsInteger(sPrmRecordArchive, otRecordArchive);

    FbfaSP.Execute;
    Result:= FbfaSP;
  except
      FErrorCode:= ecConnectionSelectArchiveAncestoreObjectsFailure;
      Log.Write(llNormal, ltException, 'spSelectArchiveAncestorObjects - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= nil;

  end;
end;

//
function TMySQL.DeleteObjectFromUserMapping(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; LayoutID, ObjID: Int64; ObjType: Integer): Integer;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Result:= -1;
  Log.Write(llDebug, ltInfo, 'MySQL.DeleteObjectFromSysUserMapping', 'bfaMySQLDatabaseScriptsU');
  with DM.spDeleteObjectFromUserMapping do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;
      
      ParamByName(sPrmLayoutID).AsLargeInt:= LayoutID;
      ParamByName(sPrmObjType).AsInteger:= ObjType;
      ParamByName(sPrmObjID).AsLargeInt:= ObjID;
      ParamByName(sPrmRoot).AsInteger:= otRoot;
      ParamByName(sPrmMandant).AsInteger:= otMandant;
      ParamByName(sPrmStore).AsInteger:= otStore;
      ParamByName(sPrmArchive).AsInteger:= otArchive;
      ParamByName(sPrmRecordArchive).AsInteger:= otRecordArchive;

      Execute;       
      
      Result:= FErrorCode;      
      
    except
      FErrorCode:= ecConnectionDeleteObjectFromSysUserMappingFailure;
      Log.Write(llNormal, ltException, 'spDeleteObjectFromUserMapping - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= FErrorCode;
    end;
  end;
end;
//
function TMySQL.DeleteObjectFromFieldMapping(DM: TbfaMySQLDataAccess; Cn: TUniConnection; Log: TbfaLog; LayoutID, ObjID: Int64): Integer;
var
  FErrorCode: Integer;
begin
  FErrorCode:= 0;
  Result:= -1;
  Log.Write(llDebug, ltInfo, 'MySQL.DeleteObjectFromFieldMapping', 'bfaMySQLDatabaseScriptsU');
  with DM.spDeleteObjectFromFieldMapping do
  begin
    try
      Connection:= Cn;  
      PrepareSQL;
      
      ParamByName(sPrmLayoutID).AsLargeInt:= LayoutID;
      ParamByName(sPrmObjID).AsLargeInt:= ObjID;
      ParamByName(sPrmRoot).AsInteger:= otRoot;
      ParamByName(sPrmMandant).AsInteger:= otMandant;
      ParamByName(sPrmStore).AsInteger:= otStore;
      ParamByName(sPrmArchive).AsInteger:= otArchive;
      ParamByName(sPrmRecordArchive).AsInteger:= otRecordArchive;

      Execute;       
      
      Result:= FErrorCode;      
      
    except
      FErrorCode:= ecConnectionDeleteAdditionalFieldFromMappingFailure;
      Log.Write(llNormal, ltException, 'DeleteObjectFromFieldMapping - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
      Result:= FErrorCode;
    end;
  end;
end;
//
function TMySQL.UpdateLayoutRights(Cn: TUniConnection; Log: TbfaLog; LayoutID, Rights, RoleID: Int64): Integer;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.UpdateLayoutRights', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpUpdateLayoutRights);
  try
    FbfaSP.PrepareSQL;
    FbfaSP.SetParamByNameAsLargeInt(sPrmLayoutID, LayoutID);  
    FbfaSP.SetParamByNameAsLargeInt(sPrmRights, Rights); 
    FbfaSP.SetParamByNameAsLargeINt(sPrmRoleID, RoleID);  
    FbfaSP.Execute;
    Result:= FErrorCode;
  except
    FErrorCode:= ecConnectionUpdateLayoutRights;
    Log.Write(llNormal, ltException, 'sSpUpdateLayoutRights - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= FErrorCode;
  end;
end;
//
function TMySQL.UpdateContainerDescription(Cn: TUniConnection; Log: TbfaLog; LayoutID: Int64; Description: WideString): Integer;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.UpdateContainerDescription', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpUpdateContainerDescription);
  try
    FbfaSP.PrepareSQL;
    FbfaSP.SetParamByNameAsLargeInt(sPrmLayoutID, LayoutID);  
    FbfaSP.SetParamByNameAsWideString(sPrmDescription, Description); 
    FbfaSP.Execute;
    Result:= FErrorCode;
  except
    FErrorCode:= ecConnectionUpdateContainerDescription;
    Log.Write(llNormal, ltException, 'sSpUpdateContainerDescription - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= FErrorCode;
  end;
end;
//
function TMySQL.CopyNode(Cn: TUniConnection; Log: TbfaLog; ParentID: Int64; ObjType: Integer; NewParentID, NewObjID: Int64): Int64;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.CopyNode', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpCopyNode);
  try
    FbfaSP.PrepareSQL;

    FbfaSP.SetParamByNameAsLargeInt(sPrmParentID, ParentID);  
    FbfaSP.SetParamByNameAsInteger(sPrmObjType, ObjType);  
    FbfaSP.SetParamByNameAsLargeInt(sPrmNewParentID, NewParentID);  
    FbfaSP.SetParamByNameAsLargeInt(sPrmNewObjID, NewObjID);  
    
    FbfaSP.Execute;
    Result:= FErrorCode;
  except
    FErrorCode:= ecConnectionCopyNode;
    Log.Write(llNormal, ltException, 'sSpCopyNode - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= FErrorCode;
  end;
end;
//
function TMySQL.SelectFieldPermissions(Cn: TUniConnection; Log: TbfaLog; ArcID, AddFieldID: Int64; var UsrIdx, GrpIdx: Integer): TBfaSP;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectFieldPermissions', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpSelectFieldPermissions);
  try
    FbfaSP.PrepareSQL;
    FbfaSP.SetParamByNameAsLargeInt(sPrmArchiveID, ArcID);  
    FbfaSP.SetParamByNameAsLargeInt(sPrmAddFieldID, AddFieldID);  

    FbfaSP.Execute;

    UsrIdx:= FbfaSp.ParamByNameAsInteger(sPrmUsrIdx);
    GrpIdx:= FbfaSp.ParamByNameAsInteger(sPrmGrpIdx);

    Result:= FbfaSP;
  except
    FErrorCode:= ecConnectionSelectFieldPermissionsFailure;
    Log.Write(llNormal, ltException, 'SelectFieldPermissions - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= nil;
  end;
end;
//
function TMySQL.UpdateInheritedFieldRights(Cn: TUniConnection; Log: TbfaLog; LayoutID, ArcID, AddfieldID: Int64; Idx, ObjType: Integer; Read, Write, Modify, UnsetRights: UInt64): Integer;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.UpdateInheritedFieldRights', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpUpdateInheritedFieldRights);
  try
    FbfaSP.PrepareSQL;

    FbfaSP.SetParamByNameAsLargeInt(sPrmLayoutID, LayoutID);
    FbfaSP.SetParamByNameAsLargeInt(sPrmArchiveID, ArcID);  
    FbfaSP.SetParamByNameAsLargeInt(sPrmAddFieldID, AddFieldID);  
    FbfaSP.SetParamByNameAsInteger(sPrmIdx, Idx);  
    FbfaSP.SetParamByNameAsUInt64(sPrmRead, Read);  
    FbfaSP.SetParamByNameAsUInt64(sPrmWrite, Write);  
    FbfaSP.SetParamByNameAsUInt64(sPrmModify, Modify);  
    FbfaSP.SetParamByNameAsUInt64(sPrmUnsetRights, UnsetRights);  
    FbfaSP.SetParamByNameAsInteger(sPrmType, ObjType);  
    FbfaSP.SetParamByNameAsInteger(sPrmUserType, otUser);  
    FbfaSP.SetParamByNameAsInteger(sPrmGroupType, otGroup);  
    FbfaSP.SetParamByNameAsInteger(sPrmRoot, otRoot);      
    FbfaSP.SetParamByNameAsInteger(sPrmMandant, otMandant);      
    FbfaSP.SetParamByNameAsInteger(sPrmStore, otStore);      
    FbfaSP.SetParamByNameAsInteger(sPrmArchive, otArchive);      
    FbfaSP.SetParamByNameAsInteger(sPrmRecordArchive, otRecordArchive);      

    FbfaSP.Execute;
    Result:= FErrorCode;
  except
    FErrorCode:= ecConnectionUpdateInheritedFieldRightsFailure;
    Log.Write(llNormal, ltException, 'UpdateInheritedFieldRights - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= FErrorCode;
  end;
end;
//
function TMySQL.SelectMaxUsrGrpIdx(Cn: TUniConnection; Log: TbfaLog; var UsrIdx, GrpIdx: Integer): Integer;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectMaxUsrGrpIdx', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpSelectMaxUsrGrpIdx);
  try
    FbfaSP.PrepareSQL;

    FbfaSP.Execute;

    UsrIdx:= FbfaSp.ParamByNameAsInteger(sPrmUsrIdx);
    GrpIdx:= FbfaSp.ParamByNameAsInteger(sPrmGrpIdx);

    Result:= FErrorCode;
  except
    FErrorCode:= ecConnectionSelectMaxUsrGrpIdxFailure;
    Log.Write(llNormal, ltException, 'SelectMaxUsrGrpIdx - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= FErrorCode;
  end;
end;
//
function TMySQL.SelectDMSRootArchiveID(Cn: TUniConnection; Log: TbfaLog): Int64;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Result:= -1;
  Log.Write(llDebug, ltInfo, 'MySQL.SelectDMSRootArchiveID', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpSelectDMSRootArchiveID);
  try
    FbfaSP.PrepareSQL;

    FbfaSp.SetParamByNameAsInteger(sPrmRoot, otRoot);

    FbfaSP.Execute;
    
    Result:= FbfaSp.ParamByNameAsLargeInt(sPrmResult);

  except
    FErrorCode:= ecConnectionSelectMaxUsrGrpIdxFailure;
    Log.Write(llNormal, ltException, 'SelectDMSRootArchiveID - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= -1;
  end;
end;
//
function TMySQL.CreateDocument(Cn: TUniConnection; Log: TbfaLog; DocLoc, OriLoc, ExtLoc, Srcloc, DocName: WideString; 
                               UserID: Int64; CheckOut, RevSave: Boolean; ArcID: Int64; PageCount, docType: Integer;
                               FileType: string; DocTxt, DocTags: WideString): Int64;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Result:= -1;
  Log.Write(llDebug, ltInfo, 'MySQL.CreateDocument', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpInsertDocument);
  try
    FbfaSP.PrepareSQL;

    FbfaSp.SetParamByNameAsWideString(sPrmDocLoc, DocLoc);
    FbfaSp.SetParamByNameAsWideString(sPrmOriLoc, OriLoc);
    FbfaSp.SetParamByNameAsWideString(sPrmExtLoc, ExtLoc);
    FbfaSp.SetParamByNameAsWideString(sPrmSrcLoc, SrcLoc);
    FbfaSp.SetParamByNameAsWideString(sPrmDocName, DocName);
    FbfaSp.SetParamByNameAsLargeInt(sPrmUserID, UserID);
    FbfaSp.SetParamByNameAsBoolean(sPrmCheckout, False);
    FbfaSp.SetParamByNameAsBoolean(sPrmRevSave, False);
    FbfaSp.SetParamByNameAsLargeInt(sPrmModifiedUserID, UserID);
    FbfaSp.SetParamByNameAsLargeInt(sPrmArcID, ArcID);
    FbfaSp.SetParamByNameAsInteger(sPrmPagecount, PageCount);
    FbfaSp.SetParamByNameAsInteger(sPrmDocType, DocType);
    FbfaSp.SetParamByNameAsWideString(sPrmFileType, FileType);

    FbfaSP.Execute;
    
    Result:= FbfaSp.ParamByNameAsLargeInt(sPrmResult);

    if ((Result > -1) and ((DocTxt <> '') or (DocTags <> ''))) then
    begin
      InsertDocTxt(Cn, Log, Result, DocTxt, DocTags);
    end;

  except
    FErrorCode:= ecConnectionCreateDocument;
    Log.Write(llNormal, ltException, 'CreateDocument - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= -1;
  end;
end;
//
function TMySQL.InsertDocTxt(Cn: TUniConnection; Log: TbfaLog; GDocID : Int64; DocTxt, DocTags: WideString): Int64;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
begin
  FErrorCode:= 0;
  Result:= -1;
  Log.Write(llDebug, ltInfo, 'MySQL.InsertDocTxt', 'bfaMySQLDatabaseScriptsU');
  FbfaSP:= TbfaSP.Create(Cn, sSpInsertDocTxt);
  try
    FbfaSP.PrepareSQL;

    FbfaSp.SetParamByNameAsLargeInt(sPrmGDocID, GDocID);
    FbfaSp.SetParamByNameAsWideString(sPrmDocTxt, DocTxt);
    FbfaSp.SetParamByNameAsWideString(sPrmDocTags, DocTags);

    FbfaSP.Execute;
    
    Result:= FbfaSp.ParamByNameAsLargeInt(sPrmResult);

  except
    FErrorCode:= ecConnectionInsertDocTxt;
    Log.Write(llNormal, ltException, 'InsertDocTxt - ErrorCode: ' + IntToStr(FErrorCode), 'bfaMySQLDatabaseScriptsU');
    Result:= -1;
  end;
end;//


end.
