unit bfaRequestHandler;

{$M+}

interface

uses
  Classes,  XMLDoc, XMLIntf, ActiveX, bfaBaseObjects;


type
  /// <Beschreibung>bitfarm RequestHandler Klasse</Beschreibung>
  /// <Description>bitfarm RequestHandler class</Description>
  TRequestHandler = class(TbfaBaseObject)
  private
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FReqType: string;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FUserID: Int64;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FParameter: string;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FFileName: string;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FDataLen: Integer;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FDataType: string;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FGDocID: Int64;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FPage: Integer;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FRevision: Integer;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FIEVType: string;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FIEVUserID: Int64;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FPubAnno: TStringList;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FPrivAnno: TStringList;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FData: string;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FXmlStr: string;
    FPrio : Integer;

  published
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property ReqType: string read FReqType write FReqType;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property UserID: Int64 read FUserID write FUserID;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property Parameter: string read FParameter write FParameter;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property FileName: string read FFileName write FFileName;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property DataLen: Integer read FDataLen write FDataLen;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property DataType: string read FDataType write FDataType;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property GDocID: Int64 read FGDocID write FGDocID;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property Page: Integer read FPage write FPage;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property Revision: Integer read FRevision write FRevision;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property IEVType: string read FIEVType write FIEVType;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property IEVUserID: Int64 read FIEVUserID write FIEVUserID;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property PubAnno: TStringList read FPubAnno write FPubAnno;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property PrivAnno: TStringList read FPrivAnno write FPrivAnno;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property Data: string read FData write FData;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property XmlStr: string read FXmlStr write FXmlStr;
    property Prio: Integer read FPrio write FPrio;

  public
    user: Int64;
    arcid: Int64;
    ievUser: Int64;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    function createXMLString: string;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    procedure readXMLString(xml: String);
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    procedure Clear;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    constructor Create;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
//    procedure Free;

    function createXMLDoc: string;


  end;

implementation
uses
  SysUtils;

//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 17.04.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
constructor TRequestHandler.Create;
begin
	inherited Create;

end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 17.04.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
procedure TRequestHandler.Clear;
begin

end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 17.04.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
function TRequestHandler.createXMLString : string;
begin
   try
//      GgfLogEvntBeg('RequestHandler - CreateXMLString');
      CoInitialize(nil);
      Result := createXMLDoc;
       CoUninitialize;
//      GgfLogEvntEnd('RequestHandler - CreateXMLString');
   except
//   	LogEvnt('Fehler bei CreateXMLString');
   end;
end;

function TRequestHandler.createXMLDoc: string;
var
      xmlDoc: TXMLDocument;
      Parent, FirstLevel, SecondLevel: IXMLNode;
      XMLStream : TStringStream;
begin
  xmlDoc:= TXMLDocument.Create(nil);
  try //07.08.2017

    xmlDoc.Active := true;
    xmlDoc.Encoding := 'ASCII';

    Parent := xmlDoc.AddChild('bfaReq') ;
     FirstLevel := Parent.AddChild('header') ;
        Secondlevel := FirstLevel.AddChild('reqType') ;
          SecondLevel.Text := Self.reqType;
        SecondLevel := FirstLevel.AddChild('dataLen') ;
           SecondLevel.Text := IntToStr(Self.dataLen);
        SecondLevel := FirstLevel.AddChild('user') ;
          SecondLevel.Text := IntToStr(Self.user);
        SecondLevel := FirstLevel.AddChild('fileName');
           SecondLevel.Text := Self.fileName;
        SecondLevel := FirstLevel.AddChild('dataType');
          SecondLevel.Text := Self.dataType;
        SecondLevel := FirstLevel.AddChild('gdocId');
          SecondLevel.Text := IntToStr(Self.gdocId);
        SecondLevel := FirstLevel.AddChild('page');
          SecondLevel.Text := IntToStr(Self.page);
        SecondLevel := FirstLevel.AddChild('revision');
          SecondLevel.Text := IntToStr(Self.revision);
        SecondLevel := FirstLevel.AddChild('arcid');
          SecondLevel.Text := IntToStr(Self.arcid);
        SecondLevel := FirstLevel.AddChild('ievType');
          SecondLevel.Text := Self.ievType;
        SecondLevel := FirstLevel.AddChild('ievUser') ;
           SecondLevel.Text := IntToStr(Self.ievUser);
        SecondLevel := FirstLevel.AddChild('privAnno');
          SecondLevel.Text := Self.privAnno.Text;
        SecondLevel := FirstLevel.AddChild('pubAnno');
          SecondLevel.Text := Self.pubAnno.Text;
     FirstLevel := Parent.AddChild('data') ;
        FirstLevel.Text := Self.data;

    XMLStream := TStringStream.Create;
    try
      xmlDoc.SaveToStream(XMLStream);
      Result := XmlStream.DataString;
    finally
      XMLStream.Free;
    end;
  finally
    xmlDoc.Free;
  end;
end;




//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 17.04.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
procedure TRequestHandler.readXMLString(xml :String);
begin

end;
//
end.
