unit bfaUser;

interface

uses
  Generics.Collections, Classes, bfaBaseObjects;
//  , bfaConnection, bfaLog;

type
  TbfaRights = class;  

  TbfaUserGroupBase = class(TbfaBaseObject)
  protected
    FbfaApplication : Pointer;
    /// <Beschreibung>E-mail Adresse</Beschreibung>
    /// <Description>E-mail address</Description>
    FEmail : WideString;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FRights : TbfaRights;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FMandantID : Int64;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FContainerID : Int64; // ContainerID wo des Objekt ModifyUser Rechte hat

    procedure SetEmail(Value : WideString);

  public  
    /// <Beschreibung>Setzt die Standardwerte und erstellt die Objekte</Beschreibung>
    /// <Description>Sets the default values and creates the objects</Description>
    constructor Create(bfaApp : Pointer); overload;  
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    function Rights : TbfaRights;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    procedure Reset; override;
    
    /// <Beschreibung>E-mail Adresse</Beschreibung>
    /// <Description>E-mail address</Description>
    property Email : WideString read FEmail write SetEmail;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property MandantID : Int64 read FMandantID write FMandantID;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property ContainerID : Int64 read FContainerID write FContainerID;    

  end;

  PbfaUserGroupBase = ^TbfaUserGroupBase;
  

  TbfaGroupMember = class(TObject)
  private
    FName, 
    FDescription 
    : WideString;
    
    FType, 
    FLevel, 
    FStatus 
    : Integer;
    
    FObjID, 
    FParentID, 
    FID 
    : Int64;

    FModified 
    : Boolean;
  public
    constructor Create(Name, Desc: WideString; Typ, Lvl, Stat: Integer; OID, PID, LID: Int64; Modified: Boolean);

    property ObjName: WideString read FName write FName;
    property Description: WideString read FDescription write FDescription;
    property ObjType: Integer read FType write FType;
    property Level: Integer read FLevel write FLevel;
    property Status: Integer read FStatus write FStatus;
    property ObjID: Int64 read FObjID write FObjID;
    property ParentID: Int64 read FParentID write FParentID;
    property ID: Int64 read FID write FID;
    property Modified: Boolean read FModified write FModified;
    
  end;    
  
  /// <Beschreibung>bitfarm User Klasse</Beschreibung>
  /// <Description>bitfarm User class</Description>
  TbfaUser = class(TbfaUserGroupBase)
  private
    /// <Beschreibung>Passwort</Beschreibung>
    /// <Description>Password</Description>
    FPassword : WideString;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FDMSAdmin : Boolean;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FFirstName : WideString;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FLastName : WideString;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FMiddleName : WideString;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>    
    FMemberOf : TList<TbfaGroupMember>;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>    
    FPermissions : TList<TbfaBaseObject>;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FMemberOfListModified : Boolean;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FPermissionsListModified : Boolean; 
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FListLoaded : Boolean; 


    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    function SetApplicationRights(bfaApp : Pointer) : Integer;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    function CheckIfDMSAdmin : Boolean;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    procedure FillMembersList;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    procedure FillPermissionsList;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    procedure Reset; override;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    procedure SetPassword(Value : WideString);
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    procedure SetFirstName(Value : WideString);
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    procedure SetMiddleName(Value : WideString);
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    procedure SetLastName(Value : WideString);
    
  public
    /// <Beschreibung>Setzt die Standardwerte und erstellt die Objekte</Beschreibung>
    /// <Description>Sets the default values and creates the objects</Description>
    constructor Create(bfaApp : Pointer); overload;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    function Load(UserID : Int64; Lists : Boolean) : Integer; 
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    function Save : Integer;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    procedure Clone(Source : TbfaUser);


    /// <Beschreibung>Benutzer ID</Beschreibung>
    /// <Description>User ID</Description>
    property ID : Int64 read FID;
    /// <Beschreibung>Passwort</Beschreibung>
    /// <Description>Password</Description>
    property Password : WideString read FPassword write SetPassword;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property DMSAdmin : Boolean read FDMSAdmin;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property FirstName : WideString read FFirstName write SetFirstName;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property LastName : WideString read FLastName write SetLastName;    
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property MiddleName : WideString read FMiddleName write SetMiddleName; 
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property MemberOf: TList<TbfaGroupMember> read FMemberOf;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property Permissions: TList<TbfaBaseObject> read FPermissions;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property MemberOfListModified : Boolean read FMemberOfListModified write FMemberOfListModified;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property PermissionsListModified : Boolean read FPermissionsListModified write FPermissionsListModified;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property ListLoaded : Boolean read FListLoaded write FListLoaded;
   
    
  end;

  PbfaUser = ^TbfaUser;

  /// <Beschreibung>bitfarm Gruppe Klasse</Beschreibung>
  /// <Description>bitfarm group class</Description>
  TbfaGroup = class(TbfaUserGroupBase)
  private
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FSysGrpID : Int64;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FParentID : Int64;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>    
    FMembers : TList<TbfaGroupMember>;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>    
    FMemberOf : TList<TbfaGroupMember>;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>    
    FPermissions : TList<TbfaBaseObject>;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FMemberOfListModified : Boolean;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FMembersListModified : Boolean;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FPermissionsListModified : Boolean; 
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FListLoaded : Boolean;
    
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    procedure FillMembersList;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    procedure FillMemberOfList;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    procedure FillPermissionsList;
    
  public
    /// <Beschreibung>Setzt die Standardwerte und erstellt die Objekte</Beschreibung>
    /// <Description>Sets the default values and creates the objects</Description>
    constructor Create(bfaApp : Pointer); overload;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    procedure Reset; override;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    function Load(GroupID : Int64; Lists : Boolean): Integer; 
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    function Save : Integer;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    procedure Clone(Source : TbfaGroup);
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    function AddObject(ObjID : Int64; ObjType : Integer) : Integer;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    function RemoveObject(ObjID, ParentID : Int64; ObjType : Integer) : Integer;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property Members: TList<TbfaGroupMember> read FMembers;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property MemberOf: TList<TbfaGroupMember> read FMemberOf;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property Permissions: TList<TbfaBaseObject> read FPermissions;

    
    /// <Beschreibung>Benutzer ID</Beschreibung>
    /// <Description>User ID</Description>
    property ID : Int64 read FID;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property SysGrpID : Int64 read FSysGrpID write FSysGrpID;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property ParentID : Int64 read FParentID write FParentID;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property MembersListModified : Boolean read FMembersListModified write FMembersListModified;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property MemberOfListModified : Boolean read FMemberOfListModified write FMemberOfListModified;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property PermissionsListModified : Boolean read FPermissionsListModified write FPermissionsListModified;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property ListLoaded : Boolean read FListLoaded write FListLoaded;
    
  end;

  PbfaGroup = ^TbfaGroup;

  
  /// <Beschreibung>bitfarm Applikationsrechte Klasse</Beschreibung>
  /// <Description>bitfarm Application rights class</Description>
  TbfaApplicationRights = class(TbfaBaseApplicationRights)
  private
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    function SetAppRights(bfaApp : Pointer; Usr : TbfaUser) : Integer;      

  public
    property AppAdmin : Boolean read FAppAdmin;
    property AppImport : Boolean read FAppImport;
    property AppView : Boolean read FAppView;
    property ArchiveManagement : Boolean read FArchiveManagement;
    property UserManagement : Boolean read FUserManagement;
    property GroupManagement : Boolean read FGroupManagement;
    property FieldManagement : Boolean read FFieldManagement;
    property ModifyUserPwd : Boolean read FModifyUserPwd;
    property ResetUserPwd : Boolean read FResetUserPwd;
    property LockUser : Boolean read FLockUser;
    property CreateWorkflow : Boolean read FCreateWorkflow;
    property ModifyWorkflow : Boolean read FModifyWorkflow;
    property DeleteWorkflow : Boolean read FDeleteWorkflow;
    property CancelWorkflow : Boolean read FCancelWorkflow; 
    
  end;
  
  /// <Beschreibung>bitfarm Archivrechte Klasse</Beschreibung>
  /// <Description>bitfarm Archive rights class</Description>
  TbfaArchiveRights = class(TbfaBaseArchiveRights)
  private
    FErrorCode : Integer;

    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    function SetArcRights(bfaApp : Pointer; Usr : TbfaUser; ParentID : Int64; var AppRights : TbfaApplicationRights) : Integer;     
         
  public
    property ASearch : Boolean read FArchiveSearch;
    property AShow : Boolean read FArchiveShow;
    property AModify : Boolean read FArchiveModify;
    property AWrite : Boolean read FArchiveWrite;
    property AEmail : Boolean read FArchiveEmail;
    property AMove : Boolean read FArchiveMove;
    property ADelete : Boolean read FArchiveDelete;
    property AExport : Boolean read FArchiveExport;
    property APrint : Boolean read FArchivePrint;
    property ALink : Boolean read FArchiveLink;
    property AImport : Boolean read FArchiveImport;
    property AHistory : Boolean read FArchiveHistory;
    property AListProtokoll : Boolean read FArchiveListProtokoll;
    property ARevSave : Boolean read FArchiveRevSave;
      
        
 
  end;
 
  /// <Beschreibung>bitfarm Benutzersrechte Klasse</Beschreibung>
  /// <Description>bitfarm User rights class</Description>
  TbfaRights = class(TObject)
  private
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FErrorCode : Integer;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FApplicationRights : TbfaApplicationRights;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    FArchiveRights : TbfaArchiveRights;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
//    FDocumentRights: TbfaDocumentRights;
  public
    property ApplicationRights : TbfaApplicationRights read FApplicationRights;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    property ArchiveRights : TbfaArchiveRights read FArchiveRights;
//    property DocumentRights: TbfaDocumentRights read FDocumentRights;

    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    constructor Create; 
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    function SetApplicationRights(bfaApp : Pointer; Usr : TbfaUser) : Integer;
    /// <Beschreibung></Beschreibung>
    /// <Description></Description>
    function SetArchiveRights(bfaApp : Pointer; Usr : TbfaUser; ParentID : Int64) : Integer;
    
  end;

implementation

uses 
  bfaCommonUtils, SysUtils, uni, bfaSP, bfaApplication, bfaArchive;


//
function TbfaUser.SetApplicationRights(bfaApp : Pointer) : Integer;
begin
  FErrorCode := FRights.SetApplicationRights(bfaApp, Self);
end;
//
function TbfaRights.SetApplicationRights(bfaApp : Pointer; Usr : TbfaUser) : Integer;
begin
  FErrorCode := FApplicationRights.SetAppRights(bfaApp, Usr);
end;
//
function TbfaUser.CheckIfDMSAdmin : Boolean;
var
  RootID : Int64;
begin
  FErrorCode := 0;
  Result := False;
  if FInitialized then
  begin
    PbfaApplication(FbfaApplication)^.WriteLog(llHigh, ltInfo, 'CheckIfDMSAdmin', ClassName);  
    try
      RootID := PbfaApplication(FbfaApplication)^.Connection.SelectDMSRoot;        

      if RootID > 0 then
      begin
        Result := PbfaApplication(FbfaApplication)^.Connection.CheckIfDMSAdmin(RootID, FID, FObjType);
      end
      else
        Result := False;
    except
      FErrorCode := ecUserFailureInSetApplicationRights;
      Result := False;
      PbfaApplication(FbfaApplication)^.WriteLog(llNormal, ltException, 'Exception in CheckIfDMSAdmin', ClassName);  
    end;
  end
  else
  begin
    FErrorCode := ecUserConnectionOrLogIsNotInitialized;
  end;
end;
//
constructor TbfaUserGroupBase.Create(bfaApp : Pointer);
begin
  New(FbfaApplication);
  FbfaApplication := bfaApp;
  
  inherited Create;
  FEmail := '';
  FRights := TbfaRights.Create;
  FMandantID := -1;
  FContainerID := -1;
end;
//
procedure TbfaUserGroupBase.Reset;
begin
  inherited Reset;
  FEmail := '';
  FreeAndNil(FRights);
  FRights := nil;
  FRights:= TbfaRights.Create;
  FMandantID := -1;
  FContainerID := -1;  
end;
//
procedure TbfaUserGroupBase.SetEmail(Value : WideString);                                     
begin
  FEmail := Value;
  FGeneralPropertiesModified := True;
  FModified := True;
end;
//
constructor TbfaUser.Create(bfaApp : Pointer);
begin
  inherited Create(bfaApp);
  FDMSAdmin := False;
  FPassword := '';
  FFirstName := '';
  FLastName := '';
  FMiddleName := '';
  FObjType := otUser;
  FMemberOf := TList<TbfaGroupMember>.Create;
  FPermissions := TList<TbfaBaseObject>.Create;
  FMemberOfListModified := False;
  FPermissionsListModified := False;
  FListLoaded := False;
  Finitialized := True;
end;
//
procedure TbfaUser.Reset;
begin
  inherited Reset;
  FDMSAdmin := False;
  FPassword := '';
  FFirstName := '';
  FLastName := '';
  FMiddleName := '';
  FObjType := otUser;
  FreeAndNil(FmemberOf);
  FMemberOf := nil;
  FMemberOf := TList<TbfaGroupMember>.Create;
  FreeAndNil(FPermissions);
  FPermissions := nil;
  FPermissions := TList<TbfaBaseObject>.Create;
  FMemberOfListModified := False;
  FPermissionsListModified := False;
  FListLoaded := False;
  Finitialized := True;
end;
//
procedure TbfaUser.SetPassword(Value : WideString);                                     
begin
  FPassword := Value;
  FGeneralPropertiesModified := True;
  FModified := True;
end;
//
procedure TbfaUser.SetFirstName(Value : WideString);                                     
begin
  FFirstName := Value;
  FGeneralPropertiesModified := True;
  FModified := True;
end;
//
procedure TbfaUser.SetMiddleName(Value : WideString);                                     
begin
  FMiddleName := Value;
  FGeneralPropertiesModified := True;
  FModified := True;
end;
//
procedure TbfaUser.SetLastName(Value : WideString);                                     
begin
  FLastName := Value;
  FGeneralPropertiesModified := True;
  FModified := True;
end;
//
procedure TbfaUser.FillMembersList;
var
  dsc: TbfaSP;
begin
  try
    if (FMemberOf <> nil) then
    begin
      dsc:= PbfaApplication(FbfaApplication)^.Connection.SelectWhereObjMember(FID, otUser);
      FMemberOf.Clear;
      if dsc <> nil then
      begin
        if dsc.RecordCount > 0 then
        begin
          dsc.First;
          while not dsc.Eof do
          begin
            FMemberOf.Add(TbfaGroupMember.Create(
            PbfaApplication(FbfaApplication)^.Connection.GetFieldValue(otGroup,dsc.FieldByNameAsLargeInt(sColGrpID),0),
            PbfaApplication(FbfaApplication)^.Connection.GetFieldValue(otGroup,dsc.FieldByNameAsLargeInt(sColGrpID),1),
            otGroup,
            dsc.FieldByNameAsInteger(sColLevel),
            stActive,
            dsc.FieldByNameAsLargeInt(sColGrpID),
            -1,
            dsc.FieldByNameAsLargeInt(sColID),
            False));

            dsc.Next;
          end;   
          
        end;
        dsc.Close;
      end;
    end;
  except
    PbfaApplication(FbfaApplication)^.WriteLog(llNormal, ltException, 'FillMembersList', ClassName);
  end;
end;
//
procedure TbfaUser.FillPermissionsList;
var
  dsc : TbfaSP;
  baseObj : TbfaAdminArchive;
begin
  try
    if FPermissions <> nil then
    begin
      dsc:= PbfaApplication(FbfaApplication)^.Connection.SelectLayoutWhereObjMember(FID, otUser);
      if dsc <> nil then
      begin
        if dsc.RecordCount > 0 then
        begin
          dsc.First;
          while not dsc.Eof do
          begin
            baseObj := TbfaAdminArchive.Create(FbfaApplication);
            with baseObj do
            begin
              ID := dsc.FieldByNameAsLargeInt(sColArcID);
              ArchiveName := dsc.FieldByNameAsWideString(sColArcName);
              Description := dsc.FieldByNameAsWideString(sColDescription);
              ArcType := dsc.FieldByNameAsInteger(sColType);
              ArchiveIcon := dsc.FieldByNameAsInteger(sColIcon);
              if dsc.FieldByNameAsInteger(sColKind) = 0 then
                Kind := tvNormal
              else if dsc.FieldByNameAsInteger(sColKind) = 1 then
                Kind := tvRecord;
              Loaded := False;
              Modified := False;
            end;

            FPermissions.Add(baseObj);
            
            dsc.Next;
          end;   
          
        end;
        dsc.Close;
      end;    
    end;
  except
    PbfaApplication(FbfaApplication)^.WriteLog(llNormal, ltException, 'FillPermissionsList', ClassName);
  end;  
end;
//
function TbfaUser.Load(UserID : Int64; Lists : Boolean) : Integer;
begin
  FErrorCode := 0;
  if FInitialized then
  begin
    PbfaApplication(FbfaApplication)^.WriteLog(llHigh, ltInfo, 'Load(UserID: ' + IntToStr(UserID) + ')', ClassName);
    try
      Reset;
      FID := UserID;
      FErrorCode := PbfaApplication(FbfaApplication)^.Connection.LoadUser(@Self);
      if FErrorCode = 0 then
      begin
        FLoaded := True;      
        FDMSAdmin := CheckIfDmsAdmin;
        SetApplicationRights(FbfaApplication);                    
        if (Floaded and Lists) then
        begin
          FillMembersList;
          FillPermissionsList;
          FListLoaded := True;
        end
        else
        begin
          FMemberOf := nil;
          FPermissions := nil;
          FListLoaded := False;
        end;

        FGeneralPropertiesModified := False;
        FMemberOfListModified := False;
        FPermissionsListModified := False;
        FModified := False;
        FErrorCode := 0;
      end;

    except
      FErrorCode := ecUserFailureInLoadUser;
      FLoaded := False;
      PbfaApplication(FbfaApplication)^.WriteLog(llNormal, ltException, sSysErrorCode + ': ' + IntToStr(FErrorCode), ClassName);
      Result := FErrorCode;
    end;
  end
  else
  begin
    FErrorCode := ecUserConnectionOrLogIsNotInitialized;
    FLoaded := False;
  end;
  Result := FErrorCode;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------cm
function TbfaUserGroupBase.Rights: TbfaRights;
begin
  Result:= FRights;
end;
//
//  Name:
//  Parameters:
//  Beschreibung:
//  Description:
//  Return value:
// [] 23.05.2012 b.takacs 4.0.0.0
//------------------------------------------------------------------------------
procedure TbfaUser.Clone(Source: TbfaUser);
begin
  try
    FID:= Source.ID;
    FName:= Source.Name;
    FPassword:= Source.Password;
    FEmail:= Source.Email;
    FStatus:= Source.Status;
    FRights:= Source.Rights;
    FDMSAdmin:= Source.DMSAdmin;          
    FDescription:= Source.Description;
    FErrorCode:= Source.ErrorCode;
    FInitialized:= Source.Initialized;
    FMandantID:= Source.MandantID;
    FFirstName:= Source.FirstName;
    FLastName:= Source.LastName;
    FMiddleName:= Source.MiddleName;
    FContainerID:= Source.ContainerID;
    FMemberOfListModified := Source.MemberOfListModified;
    FPermissionsListModified := Source.PermissionsListModified;
    FListLoaded := Source.ListLoaded;
    
  except
    PbfaApplication(FbfaApplication)^.WriteLog(llNormal, ltException, 'Clone', ClassName);  
  end;
end;
//
constructor TbfaRights.Create;
begin
  FErrorCode:= 0;
  FApplicationRights:= TbfaApplicationRights.Create;
  FArchiveRights:= TbfaArchiveRights.Create;
//  FDocumentRights:= TbfaDocumentRights.Create;
end;
//
function TbfaApplicationRights.SetAppRights(bfaApp : Pointer; Usr: TbfaUser): Integer;
var
  dsc: TbfaSP;
  Rights: Int64;
begin
  FErrorCode:= 0;
  FAppAdmin:= False;
  FAppImport:= False;
  FAppView:= False;

  if Usr.Initialized then
  begin
    PbfaApplication(bfaApp)^.WriteLog(llHigh, ltInfo, 'TbfaApplicationRights.SetAppRights', ClassName);  
    if Usr.DMSAdmin then
    begin
      FAppAdmin:= True;
      FAppImport:= True;
      FAppView:= True;
    end
    else
    begin
      try
        try
          Rights:= 0;
          dsc:= PbfaApplication(bfaApp)^.Connection.GetUserApplicationRights(Usr.ID);
          if dsc <> nil then
          begin
            with dsc do
            begin
              First;
              while ( (not Eof) and ((not FAppAdmin) and (not FAppImport) and (not FAppView)) ) do
              begin
                Rights:= dsc.FieldByNameAsLargeInt(sColRights);
                if not FAppAdmin then
                begin
                  if ((Rights and rAppArchiveManagement) = rAppArchiveManagement) or
                     ((Rights and rAppUserManagement) = rAppUserManagement) or
                     ((Rights and rAppGroupManagement) = rAppGroupManagement) or
                     ((Rights and rAppFieldManagement) = rAppFieldManagement) or
                     ((Rights and rAppCreateWorkflow) = rAppCreateWorkflow) or
                     ((Rights and rAppModifyWorkflow) = rAppModifyWorkflow) or
                     ((Rights and rAppDeleteWorkflow) = rAppDeleteWorkflow) or
                     ((Rights and rAppCancelWorkflow) = rAppCancelWorkflow) or
                     ((Rights and rAppLockUser) = rAppLockUser) or
                     ((Rights and rAppModifyuserPwd) = rAppModifyuserPwd) or
                     ((Rights and rAppResetUserPwd) = rAppResetUserPwd) then
                  begin
                     FAppAdmin:= True;
                  end;

                  if not FAppImport then
                  begin
                    if ((Rights and rAppImport) = rAppImport) then
                    begin
                      FAppImport:= True;
                    end;
                  end;
                  if not FAppView then
                  begin
                    if ((Rights and rAppView) = rAppView) then
                    begin
                      FAppView:= True;
                    end;
                  end;                  

                  
                end;
                Next;
              end;
            end;
          end;
          dsc.Close;
        except
          FErrorCode:= ecApplicationRightsFailureInSetAppRights;
          Result:= FErrorCode;
          PbfaApplication(bfaApp)^.WriteLog(llNormal, ltException, 'SetApplicationRights', ClassName);  
        end;
      finally
        FreeAndNil(dsc);
      end;
    end;
  end
  else
  begin
    FErrorCode:= ecUserConnectionOrLogIsNotInitialized;
  end;                 
  Result:= FErrorCode;
end;
//
function TbfaArchiveRights.SetArcRights(bfaApp : Pointer; Usr: TbfaUser; ParentID: Int64; var AppRights: TbfaApplicationRights): Integer;
var
  dsc: TbfaSP;
  Rights: Int64;
begin
  FErrorCode:= 0;
  try
    if usr.DMSAdmin then
    begin
      AppRights.SetRights(True);
      SetRights(True);
    end
    else
    begin
      AppRights.ClearRights;
      ClearRights;
      try
        try        
          Rights:= 0;
          dsc:= PbfaApplication(bfaApp)^.Connection.GetUserArchiveApplicationRights(Usr.ID, ParentID);
          if dsc <> nil then
          begin
              if dsc.RecordCount > 0 then
              begin
                Rights:= dsc.FieldByNameAsLargeInt(sColRights);
                if ((Rights and rAppArchiveManagement) = rAppArchiveManagement) then
                  AppRights.FArchiveManagement:= True
                else
                  AppRights.FArchiveManagement:= False;
                if ((Rights and rAppUserManagement) = rAppUserManagement) then
                begin
                  AppRights.FUserManagement:= True;
                  Usr.ContainerID:= ParentID;
                end
                else
                begin
                  AppRights.FUserManagement:= False;
                  Usr.ContainerID:= -1;
                end;
                if ((Rights and rAppGroupManagement) = rAppGroupManagement) then
                  AppRights.FGroupManagement:= True
                else
                  AppRights.FGroupManagement:= False;
                if ((Rights and rAppFieldManagement) = rAppFieldManagement) then
                  AppRights.FFieldManagement:= True
                else
                  AppRights.FFieldManagement:= False;
                if ((Rights and rAppCreateWorkflow) = rAppCreateWorkflow) then
                  AppRights.FCreateWorkflow:= True
                else
                  AppRights.FCreateWorkflow:= False;
                if ((Rights and rAppModifyWorkflow) = rAppModifyWorkflow) then
                  AppRights.FModifyWorkflow:= True
                else
                  AppRights.FModifyWorkflow:= False;
                if ((Rights and rAppDeleteWorkflow) = rAppDeleteWorkflow) then
                  AppRights.FDeleteWorkflow:= True
                else
                  AppRights.FDeleteWorkflow:= False;
                if ((Rights and rAppCancelWorkflow) = rAppCancelWorkflow) then
                  AppRights.FCancelWorkflow:= True
                else
                  AppRights.FCancelWorkflow:= False;
                if ((Rights and rAppLockUser) = rAppLockUser) then
                  AppRights.FLockUser:= True
                else
                  AppRights.FLockUser:= False;
                if ((Rights and rAppModifyuserPwd) = rAppModifyuserPwd) then
                  AppRights.FModifyUserPwd:= True
                else
                  AppRights.FModifyUserPwd:= False;
                if ((Rights and rAppResetUserPwd) = rAppResetUserPwd) then
                  AppRights.FResetUserPwd:= True
                else
                  AppRights.FResetUserPwd:= False;


(*
                  
                if ((Rights and rArchiveSearch) = rArchiveSearch)  then
                  FArchiveSearch:= True
                else
                  FArchiveSearch:= False;
                if ((Rights and rArchiveShow) = rArchiveShow)  then
                  FArchiveShow:= True
                else
                  FArchiveShow:= False;
                if ((Rights and rArchiveModify) = rArchiveModify)  then
                  FArchiveModify:= True
                else
                  FArchiveModify:= False;
                if ((Rights and rArchiveWrite) = rArchiveWrite)  then
                  FArchiveWrite:= True
                else
                  FArchiveWrite:= False;
                if ((Rights and rArchiveEmail) = rArchiveEmail)  then
                  FArchiveEmail:= True
                else
                  FArchiveEmail:= False;
                if ((Rights and rArchiveMove) = rArchiveMove)  then
                  FArchiveMove:= True
                else
                  FArchiveMove:= False;
                if ((Rights and rArchiveDelete) = rArchiveDelete)  then
                  FArchiveDelete:= True
                else
                  FArchiveDelete:= False;
                if ((Rights and rArchiveExport) = rArchiveExport)  then
                  FArchiveExport:= True
                else
                  FArchiveExport:= False;
                if ((Rights and rArchivePrint) = rArchivePrint)  then
                  FArchivePrint:= True
                else
                  FArchivePrint:= False;
                if ((Rights and rArchiveLink) = rArchiveLink)  then
                  FArchiveLink:= True
                else
                  FArchiveLink:= False;
                if ((Rights and rArchiveImport) = rArchiveImport)  then
                  FArchiveImport:= True
                else
                  FArchiveImport:= False;
                if ((Rights and rArchiveHistory) = rArchiveHistory)  then
                  FArchiveHistory:= True
                else
                  FArchiveHistory:= False;
                if ((Rights and rArchiveListProtokoll) = rArchiveListProtokoll)  then
                  FArchiveListProtokoll:= True
                else
                  FArchiveListProtokoll:= False;
                if ((Rights and rArchiveRevSave) = rArchiveRevSave)  then
                  FArchiveRevSave:= True
                else
                  FArchiveRevSave:= False;

                  *)
            end; 
          end; 
        except
          FErrorCode:= ecApplicationRightsFailureInSetAppRights;
          Result:= FErrorCode;
          PbfaApplication(bfaApp)^.WriteLog(llNormal, ltException, 'Exception in SetApplicationRights', ClassName);  
        end;
      finally
        dsc.Free;
      end;
    
    end;
  except

  end;
end;
//
function TbfaRights.SetArchiveRights(bfaApp : Pointer; Usr: TbfaUser; ParentID: Int64): Integer;
begin

  FErrorCode:= FArchiveRights.SetArcRights(bfaApp, Usr, ParentID, FApplicationRights);
end;
//
constructor TbfaGroup.Create(bfaApp : Pointer);
begin
  inherited Create(bfaApp);
  FSysGrpID := -1;
  FParentID := -1;
  FobjType := otGroup;  
  FMembersListModified := False;
  FMemberOfListModified := False;
  FPermissionsListModified := False;
  FListLoaded := False;
  FInitialized := True;
end;
//
procedure TbfaGroup.Reset;
begin
  inherited Reset;
  FSysGrpID := -1;
  FParentID := -1;
  FObjType := otGroup;
  FreeAndNil(FMembers);
  FMembers := nil;
  FMembers := TList<TbfaGroupMember>.Create;
  FreeAndNil(FMemberOf);
  FMemberOf := nil;
  FMemberOf := TList<TbfaGroupMember>.Create;
  FreeAndNil(FPermissions);
  FPermissions := nil;
  FPermissions := TList<TbfaBaseObject>.Create;
  FMembersListModified := False;
  FMemberOfListModified := False;
  FPermissionsListModified := False;
  FListLoaded := False;
  Finitialized := True;
end;
//
function TbfaGroup.Load(GroupID : Int64; Lists : Boolean): Integer;
begin
  FErrorCode:= 0;
  if FInitialized then
  begin
    PbfaApplication(FbfaApplication)^.WriteLog(llHigh, ltInfo, 'Load(GroupID: ' + IntToStr(GroupID) + ')', ClassName);
    try
      Reset;
      FID := GroupID;
      FErrorCode := PbfaApplication(FbfaApplication)^.Connection.LoadGroup(@Self);
      if FErrorCode = 0 then
      begin
        FLoaded := True;
        if (Floaded and Lists) then
        begin
          FillMembersList;
          FillMemberOfList;
          FillPermissionsList;
          FListLoaded := True;
        end
        else
        begin
          FMembers := nil;
          FMemberOf := nil;
          FPermissions := nil;
          FListLoaded := False;
        end;   

        FGeneralPropertiesModified := False;
        FMembersListModified := False;
        FMemberOfListModified := False;
        FPermissionsListModified := False;
        FModified := False;
      end
      else
      begin
        Result:= FErrorCode;
      end;

    except
      FErrorCode:= ecGroupFailureInLoadGroup;
      FLoaded:= False;
      PbfaApplication(FbfaApplication)^.WriteLog(llNormal, ltException, sSysErrorCode + ': ' + IntToStr(FErrorCode), ClassName);
      Result:= FErrorCode;
    end;
  end
  else
  begin
    FErrorCode:= ecUserConnectionOrLogIsNotInitialized;
    FLoaded:= False;
  end;
  Result:= FErrorCode;
end;
//
function TbfaGroup.Save: Integer;
var
  Grp : TbfaGroup;
  i : Integer;
begin
  FErrorCode:= 0;
  if FInitialized then
  begin
    PbfaApplication(FbfaApplication)^.WriteLog(llHigh, ltInfo, 'Save(GroupID: ' + IntToStr(FID) + ')', ClassName);
    try
      if FGeneralPropertiesModified then
        FErrorCode:= PbfaApplication(FbfaApplication)^.Connection.UpdateGroup(FID, FMandantID, FName, FDescription, FEmail, False);

      if FMembersListModified then
      begin        
        for i:= 0 to FMembers.Count -1 do
        begin
          if FMembers.Items[i].Modified then
          begin
            if FMembers.Items[i].Status = stDeleted then
            begin
              if FMembers.Items[i].ParentID <> -1 then
                RemoveObject(FMembers.Items[i].ObjID, FMembers.Items[i].ParentID, FMembers.Items[i].ObjType);
            end
            else if FMembers.Items[i].Status = stActive then
            begin
              AddObject(FMembers.Items[i].ObjID, FMembers.Items[i].ObjType);        
            end;
          end;
        end;
      end;

      if FMemberOfListModified then
      begin
        Grp:= TbfaGroup.Create(FbfaApplication);
        try 
          for i:= 0 to FMemberOf.Count -1 do
          begin
            if FMemberOf.Items[i].Modified then
            begin
              if (Grp.Load(FMemberOf.Items[i].ObjID, False) = 0) then
              begin
                if FMemberOf.Items[i].Status = stDeleted then
                begin
                  Grp.RemoveObject(FID, Grp.SysGrpID, otGroup);
                end
                else if FMemberOf.Items[i].Status = stActive then
                begin
                  Grp.AddObject(FID, otGroup);        
                end;
              end;
            end;
          end;
        finally
          FreeAndNil(Grp);
        end;
      end;
        

      Result:= FErrorCode;
    except
      FErrorCode:= ecGroupFailureInSave;
      PbfaApplication(FbfaApplication)^.WriteLog(llNormal, ltException, sSysErrorCode + ': ' + IntToStr(FErrorCode), ClassName);
      Result:= FErrorCode;
    end;
  end
  else
  begin
    FErrorCode:= ecGroupConnectionOrLogIsNotInitialized;
    Result:= FErrorCode;
  end;
end;
//
function TbfaUser.Save : Integer;
var
  i : Integer;
  Grp : TbfaGroup;
begin
  FErrorCode := 0;
  if FInitialized then
  begin
    PbfaApplication(FbfaApplication)^.WriteLog(llHigh, ltInfo, 'Save(UserID: ' + IntToStr(FID) + ')', ClassName);
    try
    
      if FGeneralPropertiesModified then
        FErrorCode := PbfaApplication(FbfaApplication)^.Connection.UpdateUser(FID, FMandantID, FName, FEmail, FDescription, FFirstName, FLastName, FMiddleName, FPassword, FStatus, False);

      if FMemberOfListModified then
      begin
        Grp := TbfaGroup.Create(FbfaApplication);
        try
          for i:= 0 to MemberOf.Count -1 do
          begin
            if MemberOf.Items[i].Modified then
            begin
              if MemberOf.Items[i].Status = stDeleted then
              begin
                if (Grp.Load(MemberOf.Items[i].ObjID, False) = 0) then
                begin
                  Grp.RemoveObject(FID, Grp.SysGrpID, otUser);
                end;
              end
              else if MemberOf.Items[i].Status = stActive then
              begin
                  if (Grp.Load(MemberOf.Items[i].ObjID, False) = 0) then
                  begin
                    Grp.AddObject(FID, otUser);
                  end;
              end;
            end;
          end;
        finally
          FreeAndNil(Grp);
        end;      
      end;

      Result:= FErrorCode;
    except
      FErrorCode:= ecUserFailureInSave;
      PbfaApplication(FbfaApplication)^.WriteLog(llNormal, ltException, sSysErrorCode + ': ' + IntToStr(FErrorCode), ClassName);
      Result:= FErrorCode;
    end;
  end
  else
  begin
    FErrorCode:= ecUserConnectionOrLogIsNotInitialized;
    Result:= FErrorCode;
  end;
end;
//
procedure TbfaGroup.Clone(Source: TbfaGroup);
begin
  try
    FID := Source.ID;
    FSysGrpID := Source.SysGrpID;
    FName := Source.Name;
    FDescription := Source.Description;
    FErrorCode := Source.ErrorCode;
    FInitialized := Source.Initialized;
    FLoaded := Source.Loaded;
    FMandantID := Source.MandantID;
    FEmail := Source.Email;
    FMembersListModified := Source.MembersListModified;
    FMemberOfListModified := Source.MemberOfListModified;
    FPermissionsListModified := Source.PermissionsListModified;
    FMembers := Source.Members;
    FMemberOf := Source.MemberOf;
    FPermissions := Source.Permissions;
    FListLoaded := Source.ListLoaded;

  except
    PbfaApplication(FbfaApplication)^.WriteLog(llNormal, ltException, 'Clone', ClassName);
  end;
end;
//
function TbfaGroup.AddObject(ObjID: Int64; ObjType: Integer): Integer;
begin
  FErrorCode:= 0;
  if FInitialized then
  begin
    if FLoaded then
    begin
      PbfaApplication(FbfaApplication)^.WriteLog(llHigh, ltInfo, 'AddObject()', ClassName);
      try

        FErrorCode:= PbfaApplication(FbfaApplication)^.Connection.InsertObjectToSysGrpUsr(FSysGrpID, ObjID, FMandantID, ObjType);

        Result:= FErrorCode;
      except
        FErrorCode:= ecGroupFailureInAddObject;
        PbfaApplication(FbfaApplication)^.WriteLog(llNormal, ltException, sSysErrorCode + ': ' + IntToStr(FErrorCode), ClassName);
        Result:= FErrorCode;
      end;
    end
    else
    begin
      FErrorCode:= ecGroupFailureInAddObject;
      Result:= FErrorCode;
    end;
  end
  else
  begin
    FErrorCode:= ecGroupConnectionOrLogIsNotInitialized;
    Result:= FErrorCode;
  end;
end;
//
function TbfaGroup.RemoveObject(ObjID, ParentID: Int64; ObjType: Integer): Integer;
begin
  FErrorCode:= 0;
  if FInitialized then
  begin
    if FLoaded then
    begin
      PbfaApplication(FbfaApplication)^.WriteLog(llHigh, ltInfo, 'RemoveObject()', ClassName);
      try

        FErrorCode:= PbfaApplication(FbfaApplication)^.Connection.DeleteUserOrGroupFromGroup(ObjID, ParentID, ObjType);

        Result:= FErrorCode;
      except
        FErrorCode:= ecGroupFailureInRemoveObject;
        PbfaApplication(FbfaApplication)^.Writelog(llNormal, ltException, sSysErrorCode + ': ' + IntToStr(FErrorCode), ClassName);
        Result:= FErrorCode;
      end;
    end
    else
    begin
      FErrorCode:= ecGroupFailureInRemoveObject;
      Result:= FErrorCode;
    end;
  end
  else
  begin
    FErrorCode:= ecGroupConnectionOrLogIsNotInitialized;
    Result:= FErrorCode;
  end;
end;
//
procedure TbfaGroup.FillMemberOfList;
var
  dsc: TbfaSP;
begin
  try
    if (FMemberOf <> nil) then
    begin
      dsc:= PbfaApplication(FbfaApplication)^.Connection.SelectWhereObjMember(FID, otGroup);
      FMemberOf.Clear;
      if dsc <> nil then
      begin
        if dsc.RecordCount > 0 then
        begin
          dsc.First;
          while not dsc.Eof do
          begin

            if (not ((dsc.FieldByNameAsLargeInt(sColGrpID) = FID) and ((dsc.FieldByNameAsInteger(sColType) = otGroup))))  then
            begin
          
              FMemberOf.Add(TbfaGroupMember.Create(
              PbfaApplication(FbfaApplication)^.Connection.GetFieldValue(otGroup,dsc.FieldByNameAsLargeInt(sColGrpID),0),
              PbfaApplication(FbfaApplication)^.Connection.GetFieldValue(otGroup,dsc.FieldByNameAsLargeInt(sColGrpID),1),
              otGroup,
              dsc.FieldByNameAsInteger(sColLevel),
              stActive,
              dsc.FieldByNameAsLargeInt(sColGrpID),
              -1,
              dsc.FieldByNameAsLargeInt(sColID),
              False));

                
            end;            

            dsc.Next;
          end;   
          
        end;
        dsc.Close;
      end;
    end;
  except
    PbfaApplication(FbfaApplication)^.WriteLog(llNormal, ltException, 'FillMemberOfList', ClassName);
  end;
end;
//
procedure TbfaGroup.FillMembersList;
var
  dsc: TbfaSP;
begin
  try
    if (FMembers <> nil) then
    begin
      dsc:= PbfaApplication(FbfaApplication)^.Connection.SelectGroupMembers(FID, FMandantID);
      FMembers.Clear;
      if dsc <> nil then
      begin
        if dsc.RecordCount > 0 then
        begin
          dsc.First;
          while not dsc.Eof do
          begin

            if (not ((dsc.FieldByNameAsLargeInt(sColObjID) = FID) and ((dsc.FieldByNameAsInteger(sColType) = otGroup))))  then
            begin
          
              FMembers.Add(TbfaGroupMember.Create(
              PbfaApplication(FbfaApplication)^.Connection.GetFieldValue(dsc.FieldByNameAsInteger(sColType),dsc.FieldByNameAsLargeInt(sColObjID),0),
              PbfaApplication(FbfaApplication)^.Connection.GetFieldValue(dsc.FieldByNameAsInteger(sColType),dsc.FieldByNameAsLargeInt(sColObjID),1),
              dsc.FieldByNameAsInteger(sColType),
              dsc.FieldByNameAsInteger(sColLevel),
              stActive,
              dsc.FieldByNameAsLargeInt(sColObjID),
              dsc.FieldByNameAsLargeInt(sColParentID),
              dsc.FieldByNameAsLargeInt(sColID),
              False));

            end;            

            dsc.Next;
          end;   
          
        end;
        dsc.Close;
      end;
    end;
  except
    PbfaApplication(FbfaApplication)^.WriteLog(llNormal, ltException, 'FillMembersList', ClassName);
  end;
end;
//
procedure TbfaGroup.FillPermissionsList;
var
  dsc : TbfaSP;
  baseObj : TbfaAdminArchive;
begin
  try
    if FPermissions <> nil then
    begin
      dsc:= PbfaApplication(FbfaApplication)^.Connection.SelectLayoutWhereObjMember(FID, otGroup);
      if dsc <> nil then
      begin
        if dsc.RecordCount > 0 then
        begin
          dsc.First;
          while not dsc.Eof do
          begin
            baseObj := TbfaAdminArchive.Create(FbfaApplication);
            with baseObj do
            begin
              ID := dsc.FieldByNameAsLargeInt(sColArcID);
              ArchiveName := dsc.FieldByNameAsWideString(sColArcName);
              Description := dsc.FieldByNameAsWideString(sColDescription);
              ArcType := dsc.FieldByNameAsInteger(sColType);
              ArchiveIcon := dsc.FieldByNameAsInteger(sColIcon);
              if dsc.FieldByNameAsInteger(sColKind) = 0 then
                Kind := tvNormal
              else if dsc.FieldByNameAsInteger(sColKind) = 1 then
                Kind := tvRecord;
              Loaded := False;
              Modified := False;
            end;

            FPermissions.Add(baseObj);
            
            dsc.Next;
          end;   
          
        end;
        dsc.Close;
      end;    
    end;
  except
    PbfaApplication(FbfaApplication)^.WriteLog(llNormal, ltException, 'FillPermissionsList', ClassName);
  end; 
end;
//
constructor TbfaGroupMember.Create(Name, Desc : WideString; Typ, Lvl, Stat : Integer; OID, PID, LID : Int64; Modified : Boolean);
begin
  FName := Name;
  FDescription := Desc;
  FType := Typ;
  FLevel := Lvl;
  FStatus := Stat;
  FObjID := OID;
  FParentID := PID;
  FID := LID;
  FModified := Modified;
end;
//


end.
