{ Dialog-Fenster mit Profilauswahl }
unit ChooseProfile;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, bfaCommonUtils, bfaCommonFiles, bfaLog;

type
{ Profilauswahl - bitte via ShowModal anzeigen }
  TProfileForm = class(TForm)
    lblChooseProfile: TLabel;
    cbbProfile: TComboBox;
    btnOk: TButton;
    btnCancel: TButton;
    { Constructor }
    procedure FormCreate(Sender: TObject);
    { setzt public Profile Property und gib Modalresult zurueck }
    procedure btnOkClick(Sender: TObject);
    { Enter simuliert klick auf btnOk }
    procedure cbbProfileKeyPress(Sender: TObject; var Key: Char);
  protected
    { Damit die Form auch in der Taskleiste angezeigt wird, obwohl das erzeugen in der FormCreate laeuft }
    procedure CreateParams(var Params: TCreateParams); override;
  private
    { Private-Deklarationen }

  public
    { public Property des ausgewaelten Profils }
    Profile: Widestring;
    { Public-Deklarationen }
  end;

var
  { @exclude }
  ProfileForm: TProfileForm;

implementation

{$R *.dfm}

procedure TProfileForm.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.ExStyle := Params.ExStyle or WS_EX_APPWINDOW;
  Params.WndParent := 0;
end;

procedure TProfileForm.btnOkClick(Sender: TObject);
begin
  Profile := cbbProfile.Text;
end;

procedure TProfileForm.cbbProfileKeyPress(Sender: TObject; var Key: Char);
begin
inherited;
  if Key = #13 then
  begin
    btnOk.Click;
    Key := #0;
  end;
end;

procedure TProfileForm.FormCreate(Sender: TObject);
var
  ConList: TStrings;
  I : Integer;
begin
  try
    inherited;
    ConList := TStringList.Create;
    if (BD.ExeDir = BD.ProgramFilesBitfarmClient) then
    begin
      bitfarmLog.Write(llDebug, ltDebug, 'ExeDir = ProgramFilesBitfarmClient', ClassName);
      FindAllFiles(ConList, BD.ProgramFilesBitfarmClient, '*.con', False)
    end else
    begin
      bitfarmLog.Write(llDebug, ltDebug, 'ExeDir <> ProgramFilesBitfarmClient', ClassName);
      FindAllFiles(ConList, BD.ExeDir, '*.con', False);
    end;

    for I := 0 to ConList.Count-1 do
      ConList[I] := copy(ExtractFileName(ConList[I]), 1, (Length(ExtractFileName(ConList[I])) - 4));
    cbbProfile.Items := ConList;
    if (ConList.Count > 0) then
      cbbProfile.ItemIndex := 0;
  finally
    ConList.Free;
  end;
end;

end.
