 program bfaquery;

{$APPTYPE CONSOLE}


uses
  SysUtils,
  IniFiles,
  Classes,
  Windows,
  strUtils,
  bitfarm_enterprise,
  bfaCommonMethods,
  RegularExpressions,
  u_dm_sep in 'u_dm_sep.pas' {dm_sep: TDataModule};

{$R *.res}

Var
 con: TIniFile;
 sProfil, sUser, sPass: WideString;
 tblname, strlimit: WideString;
 modus, strparam, Ausgabe, queue, select, arcidin, joinindex: WideString;
 strQuery,arcname, arcid, StrArcid, StrDocid, strvolltext, strdatum: WideString;
 i, j, l, gesamt: Integer;
 gslmy:Tstringlist;

 zusfeld_name: Tstringlist;
 zusdisp_name: Tstringlist;
 indextableid: TStringList;
 arcidlist, arcnames: Tstringlist;
 tblnamelist: Tstringlist;
// zusfeld_wert:Tstringlist;
 strLink: TStringlist;
 n1,n2,n3,nZeit  : int64;
 bout: Boolean;
 mydatum: TDateTime;



Function makemysqldate(datum:String):String;
begin
  makemysqldate:= RightStr(datum,4) + '-' + MidStr(datum,4,2) +'-' + LeftStr(datum,2);

end;

// ----------------------------------------
procedure StartTimer;
begin
  QueryPerformanceFrequency(n1);
  QueryPerformanceCounter(n2);
end;

// ----------------------------------------
function Stoptimer:int64;
begin
  QueryPerformanceCounter(n3);
  result := (n3-n2) * 1000 div n1;
end;



function ConnectDB: boolean;
  begin
    // Auslesen der Connection
    con    := TIniFile.Create(sProfil);
    Result := True;
    try
      try
        with con do
        begin
          sUser := ReadString('Connection', 'User', '');
          sPass := ReadString('Connection', 'Pass', '');
          with dm_sep.my_Con do
          begin
            Username := Decrypt(sUser, GlobalKey);
            Password := Decrypt(sPass, GlobalKey);
            Server   := ReadString('Connection', 'Server', '');
            Port     := ReadInteger('Connection', 'Port', 3306);
            Database := ReadString('Connection', 'DB', '');
            WriteCMD('Connection to Server ' + Server + ' with DB ' + Database);
            Connect; // Anmelden an der Datenbank
            if not Connected then // Wenn keine Verbindung dann Tool verlassen
            begin
              ExitCode := 2;
              WriteCMD('Fehler: Keine Verbindung zur Datenbank!');
              Result := False;
              exit;
            end;
          end;
        end;
      except
        on e: Exception do
        begin
          ExitCode := 4;
          WriteCMD('Fehler: Beim Auslesen der .CON Datei! ' + e.Message);
          Result := False;
          exit;
        end;
      end;
    finally
      if Assigned(con) then
        FreeAndNil(con);
    end;
  end;


function WriteJobFile(strPfad:String): Boolean;
var ini: TIniFile;
    iCount: Integer;
    sWert: String;
    idx : Integer;
    state : string;
    //comp: TComponent;
begin
  Result:=True;
  ini := TIniFile.Create(strPfad + '.job');
  // ini := TIniFile.Create('c:\' + sGDocName + '.JOB');
  try
    try
      with ini do
      begin
        WriteString('Version', 'Version', '36');
        WriteString('Archiv', 'Profil', Paramstr(2));
        WriteString('Archiv', 'Name', arcname);
        WriteString('Archiv', 'Tabelle', tblname);
        WriteString('Document', 'DOCID', strArcid + '.' + strDocid);
        if dm_sep.my_q.FieldDefList.Find('gdocid')<> NIL then
        begin
           WriteString('Document', 'gdoc_id', dm_sep.my_q.fieldbyname('gdocid').asstring);
        end ;
        WriteString('Document', 'Titel', dm_sep.my_q.fieldbyname('docname').asstring);
        WriteString('Document', 'Orginal', dm_sep.my_q.fieldbyname('docloc').asstring);
        WriteString('Document', 'Kopie', dm_sep.my_q.fieldbyname('extloc').asstring);
        WriteString('Document', 'Quelle', dm_sep.my_q.fieldbyname('oriloc').asstring);
        if dm_sep.my_q.fieldbyname('userid').AsInteger <> 0 then
        begin
          dm_sep.my_q3.SQL.Text := 'select username from sys_user where userid = ' + dm_sep.my_q.fieldbyname('userid').asstring;
          dm_sep.my_q3.Execute;
          if dm_sep.my_q3.RecordCount > 0 then
            WriteString('Document', 'Benutzer', dm_sep.my_q3.fieldbyname('username').asstring)
          else
            WriteString('Document', 'Benutzer', 'System');
        end else
        begin
          WriteString('Document', 'Benutzer', 'System');
        end;

        WriteString('Document', 'userid', dm_sep.my_q.fieldbyname('userid').asstring);
//
//        WriteString('Document', 'Volltext', strvolltext);

        state := '0:'+ dm_sep.my_q.fieldbyname('docstate_0').asstring;

        idx := 1;
        while dm_sep.my_q.FieldDefList.Find('docstate_' + IntToStr(idx)) <> NIL do
        begin
          state := state + ';' + IntToStr(idx) + ':' +  dm_sep.my_q.fieldbyname('docstate_' + IntToStr(idx)).asstring;
          inc(idx);
        end;

        WriteString('Document', 'Status', state);

        WriteString('Document', 'StatStr', '');
//        WriteString('Document', 'OCR_QF', dm_sep.my_q.fieldbyname('OCR_QF').asstring);
        WriteString('Document', 'OCR_Typ', 'OMP');
        WriteString('Document', 'Schlagworte', '');
        //strdatum:=  dm_sep.my_q.fieldbyname('TStamp').asstring;
        mydatum:= dm_sep.my_q.fieldbyname('docdate').asDateTime;
        strdatum:=FormatDateTime('yyyy-mm-dd hh:mm:ss',mydatum);
        WriteString('Document', 'Datum',strdatum );
        sWert := '';

        WriteString('Document', 'Filter', '');
        WriteString('Referenz', 'Anzahl', IntToStr(strLink.Count));

         for iCount := 0  to strLink.Count -1 do
         begin
           WriteString('Referenz', 'Referenz' + IntToStr(iCount + 1), strLink[iCount]);
         end;

         WriteString('SVN', 'SVN_Link', '');
         WriteString('SVN', 'SVN_Version', '');
         WriteString('SVN', 'SVN_Revision', '');
         WriteString('SVN', 'SVN_Datum', '');

         WriteString('Tasks', 'Termin', '');
         WriteString('Tasks', 'Alarm', '');
         WriteString('Tasks', 'Bearbeiter', '');

         WriteString('Tasks', 'Notiz', '');
         WriteString('Zusatzfelder', 'Felder' , IntToStr(zusfeld_name.Count));

         for iCount := 0  to zusfeld_name.Count -1 do
         begin
           WriteString('Zusatzfelder', 'ZusTitel' + IntToStr(iCount + 1), zusdisp_name[iCount]);
           WriteString('Zusatzfelder', 'ZusFeld' + IntToStr(iCount + 1), zusfeld_name[iCount]);
           WriteString('Zusatzfelder', 'ZusWert' + IntToStr(iCount + 1), dm_sep.my_q.fieldbyname(zusfeld_name[iCount]).asstring);
         end;

      end;
    except
      Result:=False;
    end;
  finally


    if Assigned(ini) then
    begin
         ini.UpdateFile;
         FreeAndNil(ini);
    end;
  end;
end;


function TranslateAddfields(input : WideString): WideString;
var
  reg: TRegEx;
  match : TMatch;
  matches : TMatchCollection;
  i : Integer;
  add : string;
begin
  Result := input;
  if input = '' then
    Exit;

  reg := TregEx.Create('(add_\d+)', [roIgnoreCase, roMultiline]);
  match := reg.Match(input);
  matches := TRegEx.Matches(input,'(add_\d+)');
  if matches.Count > 0 then
  begin
    for match in matches do
    begin
      add := match.Groups[1].Value;
      dm_sep.my_q2.SQL.Text := 'select value from sys_config where name like ' + #39 + add + ',%' + #39;
      dm_sep.my_q2.Execute;
      if dm_sep.my_q2.RecordCount > 0 then
      begin
        input := StringReplace(input, match.Groups[1].Value, dm_sep.my_q2.FieldByName('value').AsString, [rfReplaceAll, rfIgnoreCase]);
      end;
    end;
  end;

  Result := input;
end;


begin
  { TODO -oUser -cConsole Main : Hier Code einfgen }

  WriteCMD('bitfarm Archiv V3  -  Datenbank bfaquery Tool');
  WriteCMD('(c) 2004-2022 bitfarm Informationssysteme GmbH');

  for i := 1 to paramcount do
  strparam:= strparam + Paramstr(i) + ' ';

  WriteCmd('bergebene Parameter:' + strparam);

  if (ParamCount < 4) OR (paramstr(1)='-h') then
  begin
    ExitCode := 1;
    if paramstr(1)<>'-h' then
    begin
       WriteCMD('Fehler: Nicht gengend Parameter angegeben! Aufrufen mit:');
       WriteCMD('bfaquery <-h|-l|-r|-j|><Profil><arc_id><Query>{-out:Pfad}{-select:Spalten}{limit}');
       WriteLN('');
    end;

    WriteCMD('bfaquery: Tool um eine SQL-Query direkt an der Datenbank abzufragen');
    WriteCMD('Parameter:');
    WriteCMD('bfaquery <-h|-l|-r|-j|><Profil><arc_id><Query>{-out:Pfad}{-select:Spalten}{limit}');

    WriteCMD('Modus: -h    diese Hilfe');
    WriteCMD('       -l    list: eine Liste der Dokumente ohne Aktion');
    WriteCMD('       -t    timer: es wird die Abfragedauer und die Trefferzahl zurckgegeben');

    WriteCMD('       -r    reload: Wiedereinstellen in die Queue');
    WriteCMD('       -j    job: erstellt JobFiles, bentigt die Angabe eines Outputverzeichnisses');
    WriteCMD('Profil:      Name des Profils');
    WriteCMD('Arc_ID:      Eindeutige ArchivID oder arc_Tablename oder all fr alle Archive');
    WriteCMD('Query:       Where-Anweisung ');
    WriteCMD('-out:Pfad    (optional) alternativer Pfad fr Job-Dateien (bei -r oder -j)');
    WriteCMD('-select:Spalten die Spalten, die die Abfrage zurckliefern soll (optional)');
    WriteCMD('Limit:       maximale Anzahl der Treffer (optional)');
    WriteCMD('Hinweis:     eine Query mit Leerzeichen mu mit');
    WriteCMD('             Anfhrungszeichen bergeben werden.');
    WriteCMD('             Semikolon und MySQL-Befehle (drop,truncate, alter, insert, update etc.)');
    WriteCMD('             sind nicht erlaubt.');

    exit;
  end;

  sProfil:=ExtractFilePath(Paramstr(0))+Paramstr(2)+'.con';
  queue:=  ExtractFilePath(Paramstr(0))+'queue\';
  bout:=False;

  if paramstr(1) = '-l' then
  begin
    modus:='list';
  end;

  if paramstr(1) = '-r' then
  begin
    modus:='reload';
  end;

  if paramstr(1) = '-j' then
  begin
    modus:='job';
  end;

  if paramstr(1) = '-t' then
  begin
    modus:='timer';
  end;

  strQuery:= Paramstr(4);

  if Pos(';',strQuery) <> 0 then
  begin
    WriteCMD('Abfrage nicht erlaubt');
    Exitcode:=255;
    Exit;
  end;
  if Pos('truncate ',LowerCase(strQuery)) <> 0 then
  begin
    WriteCMD('Abfrage nicht erlaubt');
    Exitcode:=255;
    Exit;
  end;
  if Pos('drop ',LowerCase(strQuery)) <> 0 then
  begin
    WriteCMD('Abfrage nicht erlaubt');
    Exitcode:=255;
    Exit;
  end;
  if Pos('insert ',LowerCase(strQuery)) <> 0 then
  begin
    WriteCMD('Abfrage nicht erlaubt');
    Exitcode:=255;
    Exit;
  end;
  if Pos('update ',LowerCase(strQuery)) <> 0 then
  begin
    WriteCMD('Abfrage nicht erlaubt');
    Exitcode:=255;
    Exit;
  end;

  if Pos('alter ',LowerCase(strQuery)) <> 0 then
  begin
    WriteCMD('Abfrage nicht erlaubt');
    Exitcode:=255;
    Exit;
  end;

  if strQuery <> '' then
   strQuery:= ' where ' + strQuery;

  select:='';

  if paramcount >= 5 then
  begin
    for i:= 5 to paramcount do
    begin
      if LeftStr(paramstr(i),5) = '-out:' then
      begin
        bout:=True;
        queue:=Rightstr(paramstr(i),Length(paramstr(i)) - 5);
      end else if LeftStr(paramstr(i),8) = '-select:' then
      begin
        select:= Rightstr(paramstr(i),Length(paramstr(i)) - 8);
      end else
        strlimit:= ' Limit ' + paramstr(i);
    end;
  end;

  if (modus = 'job') and (bout = False) then
  begin
    WriteCMD('Bei der Option -j muss ein -out Verzeichnis angegeben werden');
    ExitCode := 6;
    Exit;
  end;

  if rightstr(queue,1) <> '\' then
   queue:= queue + '\';

  tblnamelist := tstringlist.create();
  tblnamelist.Clear;
  arcidlist := tstringlist.create();
  arcidlist.Clear;
  arcnames:= tstringlist.create();
  arcnames.Clear;

  if leftstr(Paramstr(3),4) = 'arc_' then
  begin
   tblname:=rightstr(Paramstr(3),14);
  end
  else if lowercase(Paramstr(3)) = 'all' then
  begin
    tblname:='all';
  end;

  // Initalisieren der Objekte
  if not FileExists(sProfil) then
  begin
    ExitCode := 5;
    WriteCmd('Fehler: Kann condatei <' + ParamStr(2) + '> nicht finden.');
    exit;
  end;

  dm_sep:=tdm_sep.Create(nil);
  connectDB;

  strQuery := TranslateAddfields(strQuery);
  select := TranslateAddfields(select);

  if tblname = '' then
  begin
    dm_sep.my_q.SQL.text:='select * from sys_arc where arcid ='+Paramstr(3);
  end
  else if tblname = 'all' then
  begin
    dm_sep.my_q.SQL.text:='select * from sys_arc where type= 1 and flags & 1 = 1' ;
  end
  else begin
    dm_sep.my_q.SQL.text:='select * from sys_arc where tblname like ' + #39 +'%' + tblname + '%' + #39 ;
  end;

  dm_sep.my_q.Execute;
  while not dm_sep.my_q.Eof do
  begin
    tblname:= dm_sep.my_q.fieldbyname('tblname').asstring;
    tblnamelist.Add(tblname);
    arcid:= dm_sep.my_q.fieldbyname('arcid').asstring;
    arcidlist.add(arcid);
    arcname := dm_sep.my_q.fieldbyname('arcname').asstring;
    arcnames.Add(arcname);
    writeCmd('arcid:' + arcid +' tbl :' + tblname);
    dm_sep.my_q.Next;
  end;

  zusfeld_name := Tstringlist.Create;
  zusdisp_name := Tstringlist.Create;
  indextableid := Tstringlist.Create;

  //zusfeld_wert:=Tstringlist.Create;
  strLink:=TStringlist.Create;

  arcidin := ' arcid in (' + arcidlist.CommaText + ')';

//    for j := 0 to arcidlist.Count -1 Do
//    begin
  zusfeld_name.Clear;
  zusdisp_name.Clear;
  indextableid.Clear;
  strLink.Clear;
  try
    dm_sep.my_q.SQL.text:='select * from sys_addfields as a left join sys_addfieldxs as x ' +
    ' on a.addfieldid = x.fieldid where (' + arcidin + ' or a.type = 14) and flags & 1 = 1 group by fieldname order by addfieldid';

    dm_sep.my_q.Execute;
    while not dm_sep.my_q.Eof do
    begin
      zusfeld_name.Add(dm_sep.my_q.fieldbyname('fieldname').asstring);
      writeCmd(' Feld_Name: '+dm_sep.my_q.fieldbyname('fieldname').asstring);
      zusdisp_name.Add(dm_sep.my_q.fieldbyname('displayname').asstring);
      writeCmd(' Disp_Name: '+dm_sep.my_q.fieldbyname('displayname').asstring);
      if indextableid.IndexOf(dm_sep.my_q.fieldbyname('indextableid').asstring) = -1 then
       indextableid.Add(dm_sep.my_q.fieldbyname('indextableid').asstring);
      dm_sep.my_q.Next;
    end;
  except
     WriteCmd('Fehler bei der Datenbankabfrage (Zusatzfelder)');
  end;
  joinindex := '';
  for i := 0 to indextableid.Count -1 do
  begin
    joinindex := joinindex + ' left join sys_docidx_' + indextableid[i] + ' on d.gdocid = sys_docidx_' + indextableid[i] +'.gdocid';
  end;
//    end;


  if modus = 'timer' then
  begin
    gesamt:=0;
    WriteCmd('Start:' + TimeToStr(time));
    StartTimer;

    dm_sep.my_q.SQL.text:='select * from sys_doc as d ' + joinindex + strQuery + ' and ' + arcidin + strlimit;
    dm_sep.my_q.Execute;

    gesamt := dm_sep.my_q.recordcount;

    nZeit := StopTimer;
    WriteCmd('Dauer:' + inttoStr(nZeit) + ' msek.');
    WriteCmd('Treffer:' + IntToStr(gesamt));
  end else
  begin
  //      for j := 0 to arcidlist.Count -1 Do
  //      begin
    strLink.Clear;

    try
      dm_sep.my_q.SQL.text := 'select * from sys_doc as d left join sys_user as u on d.userid = u.userid ' + joinindex + strQuery + ' and ' + arcidin + strlimit;
      dm_sep.my_q.Execute;

      if  dm_sep.my_q.recordcount > 0 then
          WriteCMD(' gefunden:'+ inttostr(dm_sep.my_q.recordcount))
      else
          WriteCMD('Hinweis:  konnte nicht gefunden werden');

      gslmy:=tstringlist.Create;
      i:=0;

      while not dm_sep.my_q.Eof do
      begin
        StrArcid := dm_sep.my_q.fieldbyname('arcid').asstring;
        strDocid := dm_sep.my_q.fieldbyname('gdocid').asstring;
        writeCmd(StrArcid + '.' + strDocid +': '+dm_sep.my_q.fieldbyname('docloc').asstring);

        if modus='reload' then
        begin
          gslmy.Clear;
          gslmy.Add(dm_sep.my_q.fieldbyname('docloc').asstring);
          gslmy.Add(dm_sep.my_q.fieldbyname('username').asstring);
          gslmy.Add(StrArcid + '.' + strDocid);
          gslmy.Add(ParamStr(2));
          i:=i+1;
          Ausgabe := FormatFloat('00000.#####',i);
          while fileexists(queue + 'change'+Ausgabe+'.cng') do
          begin
            i:=i+1;
            Ausgabe := FormatFloat('00000.#####',i);
          end;

          gslmy.SaveToFile(queue + 'change'+Ausgabe+'.cng');
        end;

        if select <> '' then
        begin
          try
            dm_sep.my_q2.SQL.text:='select ' + select + ' from  sys_doc as d ' + joinindex +' where d.gdocid = '+strDocid;
            dm_sep.my_q2.Execute;
            for l:= 0 to dm_sep.my_q2.fields.count -1 do
            begin
              WriteCMD(dm_sep.my_q2.fields[l].asstring);
            end;
          except
            on e:Exception do
              WriteCmd('Fehler bei der Datenbankabfrage: ' + e.Message);
          end;
        end;

        if modus = 'job' then
        begin
          try
            dm_sep.my_q2.SQL.text:='select DISTINCT(refname) from sys_doclink where gdocid = ' + strDocid;
            dm_sep.my_q2.Execute;
            strLink.Clear;
            while not dm_sep.my_q2.Eof do
            begin
               strLink.Add( dm_sep.my_q2.fieldbyname('refname').asstring);
               //Cmd(' Referenz :'+dm_sep.my_q2.fieldbyname('REF_NAME').asstring);
               dm_sep.my_q2.Next;
            end;
          except
            on e:Exception do
               WriteCmd('Fehler bei der Datenbankabfrage: ' + e.Message);
          end;

          tblname := tblnamelist[j];
          arcname := arcnames[j];

          if Not WriteJobFile(queue + StrArcid +'.'+strDocid) then
             WriteCMD(queue + strarcid +'.'+strDocid+'.job konnte nicht erstellt werden');
        end;
        dm_sep.my_q.Next;
      end;
    except
       on e:Exception do
          WriteCmd('Fehler bei der Datenbankabfrage: ' + e.Message);
    end;
  end;
//    end;


end.



