program searchdocsbyfields;

{$APPTYPE CONSOLE}


uses
  //u_Functions,
  SysUtils,
  IniFiles,
  Classes,
  Windows,
  strUtils,
  DateUtils,
  bfaCommonUtils,
  bfaCommonMethods,
  bitfarm_enterprise,
  u_dm_sep in 'u_dm_sep.pas' {dm_sep: TDataModule};

{$R *.res}

Var
 con: TIniFile;
 sProfil, sUser, sPass: String;
 tblname, zusname, zustyp, strlimit, filename, docpath: String;
 modus, strparam, Ausgabe, queue, query, Zeile: string;
 strVon, strBis, strbetween, strStatus, strNot, strWhere, lsnegate: string;
 i, j, iParamPos: Integer;
 gslmy,querylist: Tstringlist;
 DateiFile : TextFile;
 listfound, listnotfound, bwildcard, bnegate, bOrg, bGdocid: Boolean;
 arcid, indextableid, bitmask, leftjoin, db : string;

//Function  AnsiToConCP(Const AString: String): String;
//Var
//  lResult: String;
//Begin
//  SetLength(lResult, Length(AString));
//  {$IFDEF WIN32}
//  CharToOEM(PChar(AString), PChar(lResult)); {32Bit}
//  {$ELSE}
//  AnsiToOEM(PChar(@AString[1]), PChar(@lResult[1])); {16Bit}
//  {$ENDIF}
//  Result := lResult;
//End;

//Function WriteCmd(strtext: String):STring ;
//  begin
//    strtext:= AnsiToConCP(strtext);
//    WriteLN(strtext);
//  End;

Function makemysqldate(datum:String):String;
  begin
      if datum = '' then
      	Result := ' is NULL '
      else
      	Result:= RightStr(datum,4) + '-' + MidStr(datum,4,2) +'-' + LeftStr(datum,2);
  end;

function ConnectDB: boolean;
  begin
    // Auslesen der Connection
    con    := TIniFile.Create(sProfil);
    Result := True;
    try
      try
        with con do
        begin
          sUser := ReadString('Connection', 'User', '');
          sPass := ReadString('Connection', 'Pass', '');
          with dm_sep.my_con do
          begin
            Username := Decrypt(sUser, GlobalKey);
            Password := Decrypt(sPass, GlobalKey);
            Server   := ReadString('Connection', 'Server', '');
            Port     := ReadInteger('Connection', 'Port', 3306);
            Database := ReadString('Connection', 'DB', '');
            WriteCMD('Connection to Server ' + Server + ' with DB ' + Database);
            db := Database;
            Connect; // Anmelden an der Datenbank
            if not Connected then // Wenn keine Verbindung dann Tool verlassen
            begin
              ExitCode := 2;
              WriteCMD('Fehler: Keine Verbindung zur Datenbank!');
              Result := False;
              exit;
            end;
          end;
        end;
      except
        on e: Exception do
        begin
          ExitCode := 4;
          WriteCMD('Fehler: Beim Auslesen der .CON Datei! ' + e.Message);
          Result := False;
          exit;
        end;
      end;
    finally
      if Assigned(con) then
        FreeAndNil(con);
    end;
  end;


begin
  { TODO -oUser -cConsole Main : Hier Code einfgen }

  WriteCMD('bitfarm Archiv V3  -  Datenbank SearchDocsByFields Tool');
  WriteCMD('(c) 2004-2020 bitfarm Informationssysteme GmbH');

  for I := 1 to paramcount do
     strparam := strparam + Paramstr(i) + ' ';

  WriteCmd('bergebene Parameter:' + strparam);

  if (ParamCount < 5) OR (paramstr(1)='-h') then
  begin
    ExitCode := 1;
    if paramstr(1) <> '-h' then
    begin
      WriteCMD('Fehler: Nicht genuegend Parameter angegeben! Aufrufen mit:');
      WriteCMD('SearchDocsByFields <Modus><Profil><Arc_ID><Zusatzfeld><Query|Filename><-von:Datum><-bis:Datum><-s:Status><-snot:Maske><-org><Limit>');
      WriteLN('');
    end;

    WriteCMD('SearchDocsByFields: Tool zur Ausgabe bzw Wiedereinstellen von');
    WriteCmd('Dokumenten bei denen ein bestimmtes Zusatzfeld einen gesuchten Wert enthlt');
    WriteCMD('Parameter:');
    WriteCMD('SearchDocsByFields <Modus><Profil><Arc_ID><Zusatzfeld><Query|Filename><-von:Datum><-bis:Datum><-s:Status><-snot:Maske><-org><-gdocid><Limit>');

    WriteCMD('Modus: -h    diese Hilfe');
    WriteCMD('       -l    list: eine Liste der Dokumente ohne Aktion');
    WriteCMD('       -l0   list: eine Liste der Dokumente ohne Aktion (Wildcards erlaubt)');
    WriteCMD('       -l1   list: eine Liste der Dokumente ohne Aktion (mit Negation )');
    WriteCMD('       -l2   list: eine Liste der Dokumente ohne Aktion (mit Negation und Wildcards erlaubt)');
    WriteCMD('       -r    reload: Wiedereinstellen in die Queue');
    WriteCMD('       -r0   reload: Wiedereinstellen in die Queue (Wildcards erlaubt)');
    WriteCMD('       -r1   reload: Wiedereinstellen in die Queue (mit Negation)');
    WriteCMD('       -r2   reload: Wiedereinstellen in die Queue (mit Negation und Wildcards erlaubt)');
    WriteCMD('       (bei der Suche mit Wildcards wird eine vergleichende Suche (SQL like) ausgefhrt');
    WriteCMD('       (es kann z.B. das % benutzt werden, um auf Wortbestandteile zu prfen');
    WriteCMD('       -f    file: Suchen nach Werten aus einer Textdatei');
    WriteCMD('       -ff   file(found): Zeigt nur die gefundenen Treffer an');
    WriteCMD('       -fn   file(notfound): Zeigt nur Suchbegriffe ohne Treffer an');
    WriteCMD('Profil:      Name des Profils');
    WriteCMD('Arc_ID:      Eindeutige ArchivID oder arc_Tablename');
    WriteCMD('Zusatzfeld:  Feldname oder xxx wenn nicht nach einem Zusatzfeld gesucht ');
    WriteCMD('             werden soll (also nur Datums und/oder Statussuche)');
    WriteCmd('             Eine Query braucht dann nicht angegeben werden');
    WriteCMD('Query:       Inhalt des Zusatzfeldes,  Leerstring = ' +#39 +#39 );
    WriteCMD('             Je nach Modus sind hier Wildcards oder Negativsuchen mglich');
    WriteCMD('Filename:    einfache Text-Datei mit Suchbegriff pro Zeile');
    WriteCMD('-von:Datum:  Startdatum DD.MM.YYYY einschlielich ');
    WriteCMD('-bis:Datum:  Enddatum ausschlielich, wird das Enddatum nicht angegeben');
    WriteCMD('             wird bis einschlielich heute gesucht');
    WriteCMD('-s:Status:   es wird nach gesetzten Statusbutton gesucht');
    WriteCMD('             Bitmaske der Statusbutton (integer) =');
    WriteCMD('             in Bearbeitung=1 + Button1=2 + Button2=4 + Button3=8 etc.');
    WriteCmd('-snot:Maske: Bitmaske, welche Buttons nicht gesetzt sind');
    WriteCMD('             Buttons die nicht in den beiden Bitmasken enthalten sind,');
    WriteCMD('             werden bei der Suche nicht bercksichtigt');
    WriteCMD('-org:        Falls vorhanden werden Originaldateien wiedereingestellt');
    WriteCMD('-gdocid:     Gibt die gdocid statt arcid.docid des Dokuments zurck');
    WriteCMD('Limit:       maximale Anzahl der Treffer (optional)');
    WriteCMD('Hinweis:     Feldnamen und Suchstrings mit Leerzeichen mssen mit');
    WriteCMD('             Anfhrungszeichen bergeben werden.');

    exit;
  end;

  bwildcard := false;
  bnegate := false;
  bOrg := False;
  bGdocid := False;

  try
    if paramstr(1) = '-l' then
      modus := 'list';

    if paramstr(1) = '-r' then
      modus := 'reload';

    if paramstr(1) = '-l0' then
    begin
      modus := 'list';
      bwildcard := true;
    end;

    if paramstr(1) = '-r0' then
    begin
      modus := 'reload';
      bwildcard := true;
    end;
    if paramstr(1) = '-l1' then
    begin
      modus := 'list';
      bnegate := true;
    end;

    if paramstr(1) = '-r1' then
    begin
      modus := 'reload';
      bnegate := true;
    end;            
    if paramstr(1) = '-l2' then
    begin
      modus := 'list';
      bwildcard := true;
      bnegate := true;
    end;

    if paramstr(1) = '-r2' then
    begin
      modus := 'reload';
      bwildcard := true;
      bnegate := true;
    end;

    listfound := True;
    listnotfound := True;
    if paramstr(1) = '-f' then
      modus := 'file';

    if paramstr(1) = '-ff' then
    begin
      modus := 'file';
      listfound := True;
      listnotfound := False;
    end;

    if paramstr(1) = '-fn' then
    begin
      modus := 'file';
      listfound := False;
      listnotfound := True
    end;

    zusname := paramstr(4);
    if paramstr(4) = #39 + #39 then
      zusname:= '';

    iParamPos := 5;

    if modus = 'file' then
    begin
       filename := paramstr(5)
    end else
    begin
      if zusname <> 'xxx' then
      begin
         query := paramstr(5);
         if paramstr(5) = #39 + #39 then
           query := '';
         inc(iParamPos);
      end;
    end;

    if paramcount >= iParamPos then
    begin
       for i:= iParamPos to paramcount do
       begin
         if LeftStr(paramstr(i),4) = '-von' then
         begin
            strvon := Rightstr(paramstr(i),10);
         end
         else
         if LeftStr(paramstr(i),4) = '-bis' then
         begin
            strbis := Rightstr(paramstr(i),10);
         end
         else
         if LeftStr(paramstr(i),3) = '-s:' then
         begin
            strStatus := Rightstr(paramstr(i),Length(paramstr(i)) -3);
         end
         else
         if LeftStr(paramstr(i),5) = '-snot' then
         begin
            strNot := Rightstr(paramstr(i),Length(paramstr(i)) -6);
         end
         else
         if LeftStr(paramstr(i),4) = '-org' then
         begin
            bOrg := True;
         end
         else
         if LeftStr(paramstr(i),7) = '-gdocid' then
         begin
            bGdocid := True;
         end
         else if ParamStr(i) <> ParamStr(5) then
            strlimit := ' Limit ' + paramstr(i);
       end;
    end;

    if strStatus <> '' then
    begin
      if Pos(':', strStatus) > 0 then
      begin
        indextableid := LeftStr(strStatus, Pos(':', strStatus) -1);
        bitmask := RightStr(strStatus, Length(strStatus) - Pos(':', strStatus));
      end else begin
        indextableid := '0';
        bitmask := strStatus;
      end;

      strStatus:= '(docstate_' + indextableid + ' & '  + bitmask + ') = ' + bitmask ;
    end;
    if strNot <> '' then
    begin
        if Pos(':', strNot) > 0 then
        begin
          indextableid := LeftStr(strNot, Pos(':', strNot) -1);
          bitmask := RightStr(strNot, Length(strNot) - Pos(':', strNot));
        end else begin
          indextableid := '0';
          bitmask := strNot;
        end;
       strStatus := strStatus + ' and (docstate_' + indextableid+ ' & ' + bitmask +') = 0';
    end;

    if strStatus <> '' then
      strStatus := ' and (' + strStatus + ')';

    if strbis = '' then
      strbis:= DateToStr(Tomorrow);

    if strvon <> '' then
    begin
      strvon := makemysqldate(strvon);
      strbis := makemysqldate(strbis);
      strbetween := ' and docdate between ' + #39+ strvon + #39+' and ' + #39+ strbis+ #39;
    end;

    if leftstr(Paramstr(3),4) = 'arc_' then
      tblname := rightstr(Paramstr(3),14);

  except
    on e: Exception do
    begin
        WriteLn('Fehler: Beim Parameter parsen ! ' + e.Message);
        ExitCode := 1;
        exit;
    end;
  end;
  // Initalisieren der Objekte

  sProfil:=ExtractFilePath(Paramstr(0))+Paramstr(2)+'.con';
  queue:=  ExtractFilePath(Paramstr(0))+'queue\';
  if not FileExists(sProfil) then
  begin
    ExitCode := 5;
    WriteCmd('Fehler: Kann condatei <' + ParamStr(2) + '> nicht finden.');
    exit;
  end;
  try
    dm_sep:=tdm_sep.Create(nil);
    connectDB;
  except
    on e: Exception do
    begin
        Writecmd('Fehler: Konnte nicht zur Datenbank verbinden');
        ExitCode := 1;
        exit;
    end;
  end;

  if tblname = '' then
  begin
    arcid := Paramstr(3);
    try
      dm_sep.my_q.SQL.text:='select * from sys_arc where arcid =' + Paramstr(3);
      dm_sep.my_q.Execute;
      while not dm_sep.my_q.Eof do
      begin
         tblname:= dm_sep.my_q.fieldbyname('tblname').asstring;
         WriteCmd(' tbl :'+dm_sep.my_q.fieldbyname('tblname').asstring);
         dm_sep.my_q.Next;
      end;
    except
      on e: Exception do
      begin
        WriteLn('Fehler: Beim Auslesen der Sys_Arc Tabelle ! ' + e.Message);
        ExitCode := 1;
        exit;
      end;
    end;
  end else begin
    try
      dm_sep.my_q.SQL.text:='select * from sys_arc where tblname =' + tblname;
      dm_sep.my_q.Execute;
      while not dm_sep.my_q.Eof do
      begin
         arcid:= dm_sep.my_q.fieldbyname('arcid').asstring;
         WriteCmd(' tbl :'+dm_sep.my_q.fieldbyname('tblname').asstring);
         dm_sep.my_q.Next;
      end;
    except
      on e: Exception do
      begin
        WriteLn('Fehler: Beim Auslesen der Sys_Arc Tabelle ! ' + e.Message);
        ExitCode := 1;
        exit;
      end;
    end;
  end;

  if paramstr(4) = 'xxx' then
  begin
      zusname := 'xxx';
  end else
  begin
    try
      if LowerCase(LeftStr(ParamStr(4),4)) = 'add_' then
        dm_sep.my_q.SQL.text:='select * from sys_addfields where fieldname =' + #39 +Paramstr(4)+ #39
      else
        dm_sep.my_q.SQL.text:='select * from sys_addfields where displayname =' + #39 +Paramstr(4)+ #39;
      dm_sep.my_q.Execute;
      while not dm_sep.my_q.Eof do
      begin
         zusname := dm_sep.my_q.fieldbyname('fieldname').asstring;
         zustyp := dm_sep.my_q.fieldbyname('type').asstring;
         WriteCmd(' Feld_Name :'+zusname + ' Typ:' + zustyp);
         dm_sep.my_q.Next;
      end;

      if zusname = '' then
      begin
        WriteCmd(' Zusatzfeld ' + Paramstr(4) + ' wurde in dem Archiv nicht gefunden');
        exitcode:=1;
        exit;

      end;
    except
      on e: Exception do
      begin
        WriteLn('Fehler: Beim Auslesen der Sys_Addfields Tabelle ! ' + e.Message);
        ExitCode := 1;
        exit;
      end;

    end;
  end;
   // bei -file werden die suchbegriffe in eine liste gelesen, ber diese wird iteriert
   // bei  -l oder -r wird der suchbegriff query einziger inhalt der liste

   querylist:=TStringList.Create;

   if modus = 'file' then
   begin
      try
        if FileExists(filename) then
        begin
          AssignFile(DateiFile,filename);
          Reset(DateiFile);
          while not eof(DateiFile) do
          begin
              Readln(DateiFile,Zeile);
              querylist.Add(zeile);
          end;
          CloseFile(DateiFile);
        end
        else
        begin
            WriteCMD('Fehler: Die Datei ' + filename +' konnte nicht gefunden werden');
            ExitCode:=1;
            Exit;
        end;
      except
        on e: Exception do
        begin
          WriteLn('Fehler: Beim Auslesen der Datei ' + filename+' ! ' + e.Message);
          ExitCode := 1;
          exit;
        end;
      end;
   end
   else
   begin
      querylist.Add(query);
   end;

   gslmy:=tstringlist.Create;
   i:=1;

  for j:=0 to querylist.Count -1 do
  begin
    leftjoin := '';
    if zusname <> 'xxx' then
    begin
      if bnegate then
        lsnegate:='not ';
      if zustyp = '1' then
      begin
          if querylist[j] = '' then
            strWhere := lsnegate +  zusname + ' is NULL AND'
          else
          begin
            querylist[j] := makemysqldate(querylist[j]);
             strWhere :=  lsnegate + zusname + '='+ #39 + querylist[j] + #39 + ' AND';
          end;
      end
      else
      begin
         if bwildcard then
           strWhere :=  lsnegate +  zusname + ' like '+ #39 + querylist[j] + #39 + ' and'
         else
            strWhere :=  lsnegate + zusname + '='+ #39 + querylist[j] + #39 + ' and';
      end;

      dm_sep.my_q.SQL.text := 'SELECT DISTINCT TABLE_NAME, COLUMN_NAME FROM INFORMATION_SCHEMA.COLUMNS ' +
                              'WHERE COLUMN_NAME LIKE ' + #39 + zusname + #39 +
                              ' AND TABLE_SCHEMA=' +#39 +db+ #39;
      dm_sep.my_q.Execute;
      if  dm_sep.my_q.recordcount = 0 then
      begin
          WriteCmd(' Zusatzfeld ' + Paramstr(4) + ' wurde in dem Archiv nicht gefunden (2)');
          exitcode := 1;
          exit;
      end;

      leftjoin := dm_sep.my_q.FieldByName('TABLE_NAME').AsString;
    end;

    try
      if leftjoin <> '' then
        dm_sep.my_q.SQL.text := 'select * from sys_doc left join ' + leftjoin+ ' on ' + leftjoin +'.gdocid = sys_doc.gdocid ' +
                                ' left join sys_user on sys_doc.userid = sys_user.userid ' +
                                ' where arcid = ' + arcid + ' and ' + strWhere + ' docloc <>' + #39+ #39 + strStatus + strbetween +  strlimit
      else
        dm_sep.my_q.SQL.text := 'select * from sys_doc ' +
                                ' left join sys_user on sys_doc.userid = sys_user.userid ' +
                                ' where arcid = ' + arcid + ' and ' + strWhere + ' docloc <>' + #39+ #39 + strStatus + strbetween +  strlimit;

      dm_sep.my_q.Execute;

      if  dm_sep.my_q.recordcount > 0 then
      begin
         if listfound then
           WriteCMD(querylist[j] + ' gefunden:' + inttostr(dm_sep.my_q.recordcount));
      end
      else
      begin
         if listnotfound then
           WriteCMD('Fehler: ' + querylist[j] + ' konnte nicht gefunden werden');
      end;

      while not dm_sep.my_q.Eof do
      begin
        if modus = 'reload' then
        begin
          try
             gslmy.Clear;
             if bOrg AND (dm_sep.my_q.fieldbyname('oriloc').asstring <> '') then
               gslmy.Add(dm_sep.my_q.fieldbyname('oriloc').asstring)
             else
               gslmy.Add(dm_sep.my_q.fieldbyname('docloc').asstring);

             gslmy.Add(dm_sep.my_q.fieldbyname('username').asstring);
             gslmy.Add(arcid + '.' + dm_sep.my_q.fieldbyname('gdocid').asstring);
             gslmy.Add(paramstr(2));
             Ausgabe := FormatFloat('00000.#####',i);
             gslmy.SaveToFile(queue + 'change'+Ausgabe+'.cng');
             i := i + 1;
          except
             on e: Exception do
             begin
                WriteLn('Fehler: Beim speichern der .cng Datei ' + queue + 'change'+Ausgabe+'.cng ! ' + e.Message);
                ExitCode := 1;
                exit;
             end;
          end;
        end;
        if listfound then
          if bOrg AND (dm_sep.my_q.fieldbyname('oriloc').asstring<>'') then
               docpath := dm_sep.my_q.fieldbyname('oriloc').asstring
          else
              docpath := dm_sep.my_q.fieldbyname('docloc').asstring;
          if bGdocid then
            WriteCmd(dm_sep.my_q.fieldbyname('gdocid').asstring +' :'+docpath)
          else
            WriteCmd(arcid + '.' + dm_sep.my_q.fieldbyname('gdocid').asstring +' :'+docpath);

        dm_sep.my_q.Next;
      end;
    except
       on e: Exception do
       begin
          WriteLn('Fehler: Bei der SQL-Abfrage ! ' + e.Message);
          ExitCode := 1;
          exit;
       end;
    end;
  end;

end.



