program searchemptydoctxt;

{$APPTYPE CONSOLE}


uses
  SysUtils,
  IniFiles,
  Classes,
  Windows,
  StrUtils,
  bfaCommonUtils,
  bfaCommonMethods,
  bitfarm_enterprise,
  u_dm_sep in 'u_dm_sep.pas' {dm_sep: TDataModule};

{$R *.res}


Var
 con: TIniFile;
 sProfil, sUser, sPass: String;
 strlimit: String;
 modus, strparam, Ausgabe,queue, strDatum: string;
 i , j, k, gesamt, robin : Integer;
 gslmy:Tstringlist;
 all, oriloc, uebergabe: Boolean;
 tblname, arcid, paths :Tstringlist;


Function makemysqldate(datum:String):String;
begin
    makemysqldate:= RightStr(datum,4) + '-' + MidStr(datum,4,2) +'-' + LeftStr(datum,2);
end;


function ConnectDB: boolean;
  begin
    // Auslesen der Connection
    con    := TIniFile.Create(sProfil);
    Result := True;
    try
      try
        with con do
        begin
          sUser := ReadString('Connection', 'User', '');
          sPass := ReadString('Connection', 'Pass', '');
          with dm_sep.my_Con do
          begin
            Username := Decrypt(sUser, GlobalKey);
            Password := Decrypt(sPass, GlobalKey);
            Server   := ReadString('Connection', 'Server', '');
            Port     := ReadInteger('Connection', 'Port', 3306);
            Database := ReadString('Connection', 'DB', '');
            WriteLn('Connection to Server ' + Server + ' with DB ' + Database);
            Connect; // Anmelden an der Datenbank
            if not Connected then // Wenn keine Verbindung dann Tool verlassen
            begin
              ExitCode := 2;
              WriteLn('Fehler: Keine Verbindung zur Datenbank!');
              Result := False;
              exit;
            end;
          end;
        end;
      except
        on e: Exception do
        begin
          ExitCode := 4;
          WriteLn('Fehler: Beim Auslesen der .CON Datei! ' + e.Message);
          Result := False;
          exit;
        end;
      end;
    finally
      if Assigned(con) then
        FreeAndNil(con);
    end;
  end;



begin
  { TODO -oUser -cConsole Main : Hier Code einfgen }

  WriteLn('bitfarm Archiv V3  -  Datenbank SearchEmptyDocTxt Tool');
  WriteLn('(c) 2004-2017 bitfarm Informationssysteme GmbH');

  for I := 1 to paramcount do
     strparam:= strparam + Paramstr(i) + ' ';

  WriteCmd('bergebene Parameter:'+strparam);

  if (ParamCount < 3) OR (paramstr(1)='-h') then
  begin
    ExitCode := 1;
    WriteLN('SearchEmptyDocTxt: Tool zur Ausgabe bzw Wiedereinstellen von');
    WriteCmd('Dokumenten, die keinen Volltext erhalten haben');
    WriteLN('Parameter: searchemptydoctxt <-h|-l|-ltif|-r|-rtif|-lorg|-rorg><Profil><arc_id|all>{-D:Datum}{-P:Pfad}{limit}');
    WriteLN('Modus: -h  diese Hilfe');
    WriteLN('       -l  list: eine Liste der Dokumente ohne Aktion');
    WriteLN('       -r  reload: Wiedereinstellen in die Queue');
    WriteLN('       -ltif  eine Liste der Tif-Dokumente ohne Aktion');
    WriteLN('       -rtif  Wiedereinstellen von Tif-Dokumenten in die Queue');
    WriteLN('       -lorg  eine Liste von Original-Dateien (zB. PDF) ohne Aktion');
    WriteLN('       -rorg  Wiedereinstellen von Original-Dateien in die Queue');
    WriteLN('Profil: Name des Profils');
    WriteCMD('Arc_ID: Eindeutige ArchivID oder  all  fr alle Archive');
    WriteCMD('-D:Datum  Alle Dokumente ab diesem Datum (tt.mm.yyyy)');
    WriteCMD('-P:Pfad   Ein oder mehrere kommagetrennte Zielpfade');
    WriteLN('Limit: maximale Anzahl der Treffer (optional, gilt jeweils pro Archiv)');
    
    if paramstr(1)<>'-h' then
    begin
        WriteLN('');
        WriteCmd('Fehler: Nicht gengend Parameter angegeben!');
        WriteLn('Aufrufen mit: searchemptydoctxt <-h|-l|-ltif|-r|-rtif|-lorg|-rorg><Profil><arc_id|all>{-D:Datum}{limit}');
    end;
    exit;
  end;

  if paramstr(1) = '-l' then
  begin
    modus:='list';
  end;
  if paramstr(1) = '-ltif' then
  begin
    modus:='list';
    strLimit:= ' and docloc Like ' +#39 + '%.tif%' + #39;
  end;
  if paramstr(1) = '-r' then
  begin
    modus:='reload';
  end;
  if paramstr(1) = '-rtif' then
  begin
    modus:='reload';
    strLimit:= ' and docloc Like ' +#39 + '%.tif%' + #39;
  end;
  if paramstr(1) = '-lorg' then
  begin
    modus:='list';
    oriloc:=True;
    strLimit:= ' and oriloc <> ' +#39 + #39;
  end;
  if paramstr(1) = '-rorg' then
  begin
    modus:='reload';
    oriloc:=True;
    strLimit:= ' and oriloc <> ' +#39 + #39;
  end;


  if paramstr(3) = 'all' then
    all:=True;

  paths := TStringList.Create;

  if paramcount >= 4 then
  begin
    for i := 4 to ParamCount do
    begin
      if Leftstr(paramstr(i),3) = '-D:' then
      begin
        strDatum := Copy(ParamStr(i),4,Length(ParamStr(i))-3);
        strDatum := makemysqldate(strDatum);
        strlimit := strlimit + ' and docdate > ' +#39+ strDatum +#39;
      end else if Leftstr(paramstr(i),3) = '-P:' then
      begin
        paths.CommaText := Copy(ParamStr(i),4,Length(ParamStr(i))-3);
      end
      else
      begin
         strlimit:= strLimit + ' limit ' + paramstr(i);
      end;
    end;
  end;

  // Initalisieren der Objekte

  sProfil:=ExtractFilePath(Paramstr(0))+Paramstr(2)+'.con';
  if paths.Count = 0 then
      paths.Add(ExtractFilePath(Paramstr(0))+'queue\');
  for i := 0 to paths.Count -1 do
  begin

    if RightStr(paths[i],1) <> '\' then
      paths[i] := paths[i] + '\';

    if (not DirectoryExists(paths[i])) and (modus = 'reload') then
    begin
      ExitCode := 6;
      WriteCmd(Format('Fehler: Kann das Verzeichnis %s nicht finden.',[paths[i]]));
      exit;
    end;

  end;

  if not FileExists(sProfil) then
  begin
    ExitCode := 5;
    WriteCmd('Fehler: Kann condatei <' + ParamStr(2) + '> nicht finden.');
    exit;
  end;

  dm_sep:=tdm_sep.Create(nil);
  connectDB;

  if all = False then
  begin
    dm_sep.my_q.SQL.text:='select * from sys_arc where arcid ='+Paramstr(3);
    dm_sep.my_q.Execute;
  end else
  begin
    dm_sep.my_q.SQL.text:='select * from sys_arc where type = 1 and flags & 2 = 0';
    dm_sep.my_q.Execute;
  end;

  tblname:=tstringlist.Create;
  arcid:=tstringlist.Create;

  while not dm_sep.my_q.Eof do
  begin
    tblname.Add(dm_sep.my_q.fieldbyname('tblname').asstring);
    arcid.add(dm_sep.my_q.fieldbyname('arcid').asstring);
    writeCmd(' tbl :'+dm_sep.my_q.fieldbyname('tblname').asstring);
    dm_sep.my_q.Next;
  end;

{     dm_sep.my_q.SQL.text:='select * from cfg_'+ tblname +' where Disp_Name =' + #39 +Paramstr(4)+ #39;
     dm_sep.my_q.Execute;
     while not dm_sep.my_q.Eof do
     begin
             zusname:= dm_sep.my_q.fieldbyname('Feld_Name').asstring;
             writeCmd(' Feld_Name :'+dm_sep.my_q.fieldbyname('Feld_name').asstring);
             dm_sep.my_q.Next;
     end;                           }

//     dm_sep.my_q.SQL.text:='select * from arc_'+ tblname +' where  (doc_txt not '+
//     'REGEXP '+#39+'[:alpha:].'+#39+') AND (DOC_LOC<>' + #39+ #39 +') And (doc_txt not regexp ' + #39 +'[:space:].' + #39 +') and (doc_txt not regexp ' + #39 +'[:blank:].' + #39 + ') ' +  strlimit;

   i:=1;
   robin := 0;
   for k := 0 to arcid.count -1 do
   begin
      try
//        dm_sep.my_q.SQL.text:='select * from sys_doc as d left join sys_doctxt as t on d.gdocid = t.gdocid ' +
//                              ' left join sys_user as u on d.userid = u.userid where ((doctxt  ' +
//                              'REGEXP '+#39+'^[[:space:]]*$'+#39+') or (doctxt is null)) AND (docloc <>' + #39+ #39 +') and arcid =  ' + arcid[k] +  strlimit;

        dm_sep.my_q.SQL.text:='select * from sys_doc as d ' +
                              ' left join sys_user as u on d.userid = u.userid where ((doctxt  ' +
                              'REGEXP '+#39+'^[[:space:]]*$'+#39+') or (doctxt is null)) AND (docloc <>' + #39+ #39 +') and arcid =  ' + arcid[k] +  strlimit;
        dm_sep.my_q.Execute;
        gslmy:=tstringlist.Create;

        Ausgabe := FormatFloat('00000.#####',i);
        while not dm_sep.my_q.Eof do
        begin
          if modus='reload' then
            begin
               gslmy.Clear;
               if oriloc then
                  gslmy.Add(dm_sep.my_q.fieldbyname('oriloc').asstring)
               else
                  gslmy.Add(dm_sep.my_q.fieldbyname('docloc').asstring);

               gslmy.Add(dm_sep.my_q.fieldbyname('username').asstring);
               gslmy.Add(arcid[k] + '.' + dm_sep.my_q.fieldbyname('gdocid').asstring);
               gslmy.Add(ParamStr(2));

               while fileexists(paths[robin] + 'change'+Ausgabe+'.cng') do
               begin
                 i:=i+1;
                 Ausgabe := FormatFloat('00000.#####',i);
               end;

               WriteLN(ausgabe);
               gslmy.SaveToFile(paths[robin] + 'change'+Ausgabe+'.cng');
               inc(robin);
               if robin = paths.Count then
                  robin := 0;
            end;

            if oriloc then
              writeCmd(arcid[k] + '.' + dm_sep.my_q.fieldbyname('gdocid').asstring
              +' :'+dm_sep.my_q.fieldbyname('oriloc').asstring)

            else
              writeCmd(arcid[k] + '.' + dm_sep.my_q.fieldbyname('gdocid').asstring
              +' :'+dm_sep.my_q.fieldbyname('docloc').asstring);

            dm_sep.my_q.Next;
        end;

        WriteLN('Treffer: '+ inttostr(dm_sep.my_q.recordcount));
        gesamt:=gesamt +  dm_sep.my_q.recordcount;
      except
        on e: Exception do
          WriteCmd('Es hat ein Fehler bei der Datenbankabfrage gegeben:' + e.Message);
      end;
   end;
   if all = True then
      WriteLN('Treffer gesamt:' + inttostr(gesamt));

   WriteLN('Fertig.');

end.



