program tiff2pdf;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  IniFiles,
  Windows,
  hyiedefs,
  imageenio,
  imageenview,
  imageenproc,
  ievect,
  IEMView,
  IEMIO;

{$R *.res}
  
const
  GlobalKey = '7F1E324C67945C0CF98DBE4EDD87C4DA17DB4A2163B33804950FA52FC8E66CA0' +
    '6B9D523178403F505E53222D7122760CE4D297889BB84CF4639E2A235E0BD940' +
    'AAB3468D929F402ED1B52C42BCAEB10F57AB98F69DE73C609C4A3DFC0FC36DEC' +
    'A5CD0AB22D68C60A326B48FDDB1BFCDC214383DF8C4808B029F6421260100761';
var
  GsProfil, GSsendername,strparam: string;
   sPath, sDatei: String;
   keepsize: Boolean;
   I:Integer;



Function AnsiToConCP(Const AString: String): String;
Var
  lResult: String;
Begin
  SetLength(lResult, Length(AString));
  {$IFDEF WIN32}
//12.01.2024  CharToOEM(PChar(AString), PChar(lResult)); {32Bit}
  CharToOEM(PChar(AString), PAnsiChar(lResult)); {32Bit}
  {$ELSE}
  AnsiToOEM(PChar(@AString[1]), PChar(@lResult[1])); {16Bit}
  {$ENDIF}
  Result := lResult;
End;


Function WriteCmd(strtext: String):STring ;
begin
//12.01.2024  strtext:= AnsiToConCP(strtext);
  WriteLN(strtext);
End;


function ConvertToPDF(InputFile, OutputPath: string): boolean;
var
  imgConv: TImageEnMView;
  imgProc: TImageEnProc;
  imgMrg:  TImageEnView;
  Vec: TImageEnVect;
  iCount, iL, iLW, iLH, iLX, iLY, iColors, iSPP, iBPS,iDpiX, iDpiY,o: integer;
  fPer:    double;
  rgb:     TRGB;
begin
  Result  := True;
  imgConv := TImageEnMView.Create(nil);
  imgProc := TImageEnProc.Create(nil);
  imgMrg  := TImageEnView.Create(nil);

  imgConv.ThreadPoolSize := 20;
  imgConv.MIO.AutoAdjustDPI := True;
  try
    try

      WriteLN('Lade Bilddatei: ' + InputFile);
      imgConv.MIO.LoadFromFile(InputFile);
      WriteLN('Anzahl Seiten:' + inttostr( imgConv.MIO.ParamsCount));
      WriteLN('Starte Verarbeitung....');
     Vec := TImageEnVect.Create(nil);
     vec.IO.AutoAdjustDPI := True;

     vec.IO.CreatePDFFile(OutputPath + ExtractFileName(ChangeFileExt(InputFile, '.pdf')));
     vec.IO.Params.PDF_Creator :=
        'bitfarm Archiv V3 (c) 2004 - 2024 bitfarm Informationssysteme GmbH';
     vec.IO.Params.PDF_Title := ChangeFileExt(InputFile, '');

     vec.IO.Params.PDF_Producer :=
        'bitfarm Archiv Viewer V3.5 (c) 2004 - 2024 bitfarm Informationssysteme GmbH';
     vec.IO.Params.JPEG_Quality := 80;
//     vec.IO.Params.TIFF_Orientation:= frm_MainForm.fra_Voransicht.img_DocView.IO.Params.TIFF_Orientation; //22.07.2011 b.takacs 3.5.1.33 [3065]
//     vec.IO.Params.PDF_PaperWidth:= fra_Voransicht.img_DocView.IO.Params.Width; //07.07.2011 b.takacs 3.5.1.27 [3065]
//     vec.IO.Params.PDF_PaperHeight:= fra_Voransicht.img_DocView.IO.Params.Height; //07.07.2011 b.takacs 3.5.1.27 [3065]




      for iCount := 0 to (imgConv.MIO.ParamsCount - 1) do
      begin
          imgMrg.IEBitmap.AssignImage(imgConv.GetTIEBitmap(iCount));

          iLW := imgMrg.IEBitmap.Width;
          iLH := imgMrg.IEBitmap.Height;
          iDpiX :=imgConv.MIO.Params[iCount].DpiX ;
          iDpiY :=imgConv.MIO.Params[iCount].DpiY ;
          vec.IO.Params.TIFF_Orientation := imgMrg.IO.Params.TIFF_Orientation;
          vec.io.params.imageindex := iCount;
//          vec.IO.LoadFromFile(InputFile);
          Vec.IEBitmap.Assign(imgMrg.IEBitmap);
          icolors := 0;
          WriteCMD('Seite:' + inttostr(iCount + 1) + ' Gre:' + inttostr(iLW) +'x'+inttostr(iLH) + ' DPI:' + inttostr(iDpix)+'x'+ inttostr(iDpiY));
        if keepsize = True then
        begin
            vec.IO.Params.PDF_PaperWidth :=  Round((iLW /iDpiX) * 72);
            vec.IO.Params.PDF_PaperHeight := Round((iLH /iDpiY) * 72);
        end
        else
        begin
         // save pdf as DIN-A4
          if iLH > iLW then
          begin
              vec.IO.Params.PDF_PaperWidth := 595;
              vec.IO.Params.PDF_PaperHeight := 842;

          end
          else
          begin
              vec.IO.Params.PDF_PaperWidth := 842;
              vec.IO.Params.PDF_PaperHeight := 595;
          end;
        end;


         if icolors = 0 then
         begin
            iColors := vec.Proc.CalcImageNumColors;
         end;
         if icolors < 128 then
         begin
            vec.IO.Params.PDF_Compression := ioPDF_LZW;
         end
         else
         begin
            vec.IO.Params.PDF_Compression := ioPDF_jpeg;
            vec.io.Params.BitsPerSample := 8;
            vec.io.Params.SamplesPerPixel := 3;
         end;
         vec.IO.SaveToPDF;

      end;
      vec.IO.ClosePDFFile;
    except
      on e: Exception do
      begin
        Result := False;
        // ErrorMsg('ConvertToPDF', 'Fehler beim konvertieren der TIFF Datei: ' + e.Message, 2000, True);
      end;
    end;
  finally
    if Assigned(imgConv) then
    begin
      FreeAndNil(imgConv);
    end;
    if Assigned(imgProc) then
    begin
      FreeAndNil(imgProc);
    end;
    if Assigned(imgMrg) then
    begin
      FreeAndNil(imgMrg);
    end;
  end;
end;


begin
  WriteLn('bitfarm Archiv V3  -   Tiff2Pdf-Converter');
  WriteLn('(c) 2004-2024 bitfarm Informationssysteme GmbH');

  if ParamCount < 1 then
  begin
    ExitCode := 1;
    WriteCMD('Fehler: Nicht gengend Parameter angegeben!');
    WriteLn('        Aufrufen mit: Tiff2Pdf <tif-datei>{keepsize}');
    WriteCMD('keepsize: (optional) Es wird die Bildgre des Tifdokuments beibehalten');
    WriteCMD('ansonsten wird ein DIN A4 groes PDF erstellt');
    exit;
  end;


 for I := 1 to paramcount do
     strparam:= strparam + Paramstr(i) + ' ';

  WriteCmd('bergebene Parameter:'+strparam);

  if Lowercase(paramstr(2)) ='keepsize' then
    keepsize:=True;


  if not FileExists(ParamStr(1)) then
  begin
    ExitCode := 5;
    WriteLn('Fehler: Kann Tif-Datei <' + ParamStr(1) + '> nicht finden.');
    exit;
  end;
 { if not FileAccessable(ParamStr(1)) then
  begin
    exit;
  end;}
  sDatei := ParamStr(1);
  sPath:= ExtractFilePath(sDatei);

  ConvertToPDF(sDatei,sPath);

  WriteLN('Done...');
  { TODO -oUser -cConsole Main : Hier Code einfgen }
end.
