program userinfo;

{$APPTYPE CONSOLE}


uses
  u_Functions in 'u_Functions.pas',
  SysUtils,
  IniFiles,
  Classes,
  Windows,
  strUtils,
  u_dm_sep in 'u_dm_sep.pas',
  bfaCommonUtils,
  bfaCommonMethods;

{$R *.res}

const
  GlobalKey = '7F1E324C67945C0CF98DBE4EDD87C4DA17DB4A2163B33804950FA52FC8E66CA0' +
    '6B9D523178403F505E53222D7122760CE4D297889BB84CF4639E2A235E0BD940' +
    'AAB3468D929F402ED1B52C42BCAEB10F57AB98F69DE73C609C4A3DFC0FC36DEC' +
    'A5CD0AB22D68C60A326B48FDDB1BFCDC214383DF8C4808B029F6421260100761';

Var
 con: TIniFile;
 sProfil, sUser, sPass: String;
 tblname, zusname, strlimit, arcid, grp_id: String;
 modus, strparam, Ausgabe,queue: string;
 usr_ids: TStringList;
 i,j: Integer;
 pw, found, all: Boolean;

//Function  AnsiToConCP(Const AString: String): String;
//Var
//  lResult: String;
//Begin
//  SetLength(lResult, Length(AString));
//  {$IFDEF WIN32}
//  CharToOEM(PChar(AString), PChar(lResult)); {32Bit}
//  {$ELSE}
//  AnsiToOEM(PChar(@AString[1]), PChar(@lResult[1])); {16Bit}
//  {$ENDIF}
//  Result := lResult;
//End;
//
//Function WriteCmd(strtext: String):STring ;
//  begin
//  strtext:= AnsiToConCP(strtext);
//  WriteLN(strtext);
//End;


function ConnectDB: boolean;
  begin
    // Auslesen der Connection
    con    := TIniFile.Create(sProfil);
    Result := True;
    try
      try
        with con do
        begin
          sUser := ReadString('Connection', 'User', '');
          sPass := ReadString('Connection', 'Pass', '');
          with dm_sep.my_Con do
          begin
            Username := Decrypt(sUser, GlobalKey);
            Password := Decrypt(sPass, GlobalKey);
            Server   := ReadString('Connection', 'Server', '');
            Port     := ReadInteger('Connection', 'Port', 3306);
            Database := ReadString('Connection', 'DB', '');
            WriteLn('Connection to Server ' + Server + ' with DB ' + Database);
            Connect; // Anmelden an der Datenbank
            if not Connected then // Wenn keine Verbindung dann Tool verlassen
            begin
              ExitCode := 2;
              WriteLn('Fehler: Keine Verbindung zur Datenbank!');
              Result := False;
              exit;
            end;
          end;
        end;
      except
        on e: Exception do
        begin
          ExitCode := 4;
          WriteLn('Fehler: Beim Auslesen der .CON Datei! ' + e.Message);
          Result := False;
          exit;
        end;
      end;
    finally
      if Assigned(con) then
        FreeAndNil(con);
    end;
  end;

begin
  { TODO -oUser -cConsole Main : Hier Code einfgen }

  WriteLn('bitfarm Archiv V3  -  Datenbank UserInfo Tool');
  WriteLn('(c) 2004-2017 bitfarm Informationssysteme GmbH');

  for I := 1 to paramcount do
     strparam:= strparam + Paramstr(i) + ' ';

  WriteCmd('bergebene Parameter:'+strparam);

  if (ParamCount < 2) OR (paramstr(1)='-h') then
  begin
    ExitCode := 1;

    if   paramstr(1)<>'-h' then
    begin

      WriteLn('Fehler: Nicht genuegend Parameter angegeben!');
      WriteLn('Aufrufen mit: userinfo <-h|-u|-i><Profil><Username oder ID>{-pw|-all}');
    end;

    WriteLN('userinfo: Tool zur Ausgabe von Benutzerinformationen');
    WriteLN('Parameter: userinfo <Modus><Profil><Username oder ID>{-pw|-all}');
    WriteLN('Modus: -h  diese Hilfe');
    WriteLN('Modus: -u  sucht nach dem Usernamen');
    WriteLN('Modus: -i  sucht nach der UserID');
    WriteLN('Modus: -gn  sucht nach dem Gruppennamen');
    WriteLN('Modus: -gi  sucht nach der GruppenID');
    WriteLN('pw: optionale Passwortausgabe');
    WriteLN('Profil: Name des Profils');

    exit;
  end;

   if paramstr(1) = '-u' then
    	modus:='user';

   if paramstr(1) = '-i' then
    	modus:='id';

   if paramstr(1) = '-gn' then
    	modus:='group';

   if paramstr(1) = '-gi' then
    	modus:='groupid';

  	if paramcount = 4 then
  	begin
      if paramstr(4) = '-pw' then
      begin
       pw:=true;
      end;
      if paramstr(4) = '-all' then
      begin
       all:=true;
      end;
  	end;

  // Initalisieren der Objekte
   found := False;
   sProfil:=ExtractFilePath(Paramstr(0))+Paramstr(2)+'.con';
   queue:=  ExtractFilePath(Paramstr(0))+'queue\';
   if not FileExists(sProfil) then
   begin
      ExitCode := 5;
      WriteCmd('Fehler: Kann condatei <' + ParamStr(2) + '> nicht finden.');
      exit;
   end;

   dm_sep:=tdm_sep.Create(nil);
   connectDB;

   usr_ids:= TStringList.Create;

   if modus = 'id' then
   begin
     usr_ids.Add(Paramstr(3));
   end ;

   grp_id:=  Paramstr(3);

   if modus = 'group' then
   begin
      dm_sep.my_q.SQL.text:='select * from sys_group where groupname ='+#39+Paramstr(3)+#39;

       dm_sep.my_q.Execute;
       if dm_sep.my_q.RecordCount = 0 then
         grp_id := '-1'
       else
       begin
          while not dm_sep.my_q.Eof do
          begin
             //found:=True;
             grp_id := dm_sep.my_q.fieldbyname('groupid').asstring;
             dm_sep.my_q.Next;
          end;

       end;
   end;

   if ((modus = 'groupid') or (modus = 'group')) and (grp_id <> '-1') then
   begin
      dm_sep.my_q.SQL.text:='select * from sys_groupuser where groupid ='+#39+grp_id+#39;

      dm_sep.my_q.Execute;
      while not dm_sep.my_q.Eof do
      begin
          //found:=True;
          usr_ids.Add(dm_sep.my_q.fieldbyname('userid').asstring);
          dm_sep.my_q.Next;
      end;
   end;


   if modus = 'user' then
   begin
      dm_sep.my_q.SQL.text:='select * from sys_user where username ='+#39+Paramstr(3)+#39;
      dm_sep.my_q.Execute;
      while not dm_sep.my_q.Eof do
      begin
          //found:=True;
          usr_ids.Add(dm_sep.my_q.fieldbyname('userid').asstring);
          dm_sep.my_q.Next;
      end;
   end;


   for i:=0 to usr_ids.Count -1 do
   begin
   	dm_sep.my_q.SQL.text:='select * from sys_user where userid ='+#39+usr_ids[i]+#39;

      dm_sep.my_q.Execute;
      while not dm_sep.my_q.Eof do
      begin
         if ((pos('enabled',dm_sep.my_q.fieldbyname('flags').asstring) > 0) And (all = False)) or (all = True) then
         begin
            found:=True;
            writeCmd('usr_id:' + dm_sep.my_q.fieldbyname('userid').asstring);
            writeCmd('usr_name:'+ dm_sep.my_q.fieldbyname('username').asstring);
            writeCmd('usr_mail:' + dm_sep.my_q.fieldbyname('usermail').asstring);
            if pw then
               writeCmd('usr_pass:' + dm_sep.my_q.fieldbyname('userpass').asstring);
            writeCmd(dm_sep.my_q.fieldbyname('flags').asstring);
         end;
         dm_sep.my_q.Next;
      end;

   end;
   if not found then
     writeCmd('Keinen Eintrag gefunden...');


end.



