program TimChecker; {$APPTYPE CONSOLE}

uses
  SysUtils,
  StrUtils,
  dm_timcheck in 'dm_timcheck.pas' {dm_tim: TDataModule},
  inifiles,
  IdMessage,
  IdSMTP,
  IdMessageBuilder,
//  HTTPApp,
  Classes,
  Windows,
  DateUtils,
  DB,
  {$IFNDEF GPL}
  bitfarm_enterprise,
  {$ELSE}
  bitfarm_core,
  {$ENDIF }
  bfaCommonUtils,
  bfaCommonMethods,
  bfaDPAPI in '..\..\Delphi-Shared_362\bfaCommonUtils\Source\bfaDPAPI.pas',
  bfaBaseObjects in '..\..\Delphi-Shared_362\bfaCommonUtils\Source\bfaBaseObjects.pas',
  bfaBaseSocketConnection in '..\..\Delphi-Shared_362\bfaCommonUtils\Source\bfaBaseSocketConnection.pas';

{$R *.res}

type

  TbfaWorkflow = class
    timid: string;
    userid_work: string;
    userid_shed: string;
    docname: widestring;
    info: widestring;
    gdocid: string;
  end;

var
  GsProfil, GSsendername, Clientprogramm, ClientSpooler,
    smtp_server_host, smtp_user, smtp_pass, bfauser, bfapass, bfaServer, Profile: string;
    smtp_port, bfaServerNoSSL, bfaServerPort : Integer;
  breport, bfaServerSMTP: Boolean;

function DeCrypt(HexInputStr, HexKeyStr: string): string;
/// ///////////////////////////////////////////////////////////////
/// 10.04.2005 Erstellt DeCrypt by SV.                        ///
/// ///
/// Diese Funktion erzeugt aus dem HexInputStr einen mit      ///
/// HexKeyStr entschlsselten String (einfaches XOR)          ///
/// ///
/// Format: Entschlsselter String                            ///
/// ///
/// ///////////////////////////////////////////////////////////////
var
  iCntIStr, iCntKStr: integer;
begin
  iCntIStr := 1;
  iCntKStr := 1;
  Result := '';
  while iCntIStr < (Length(HexInputStr) + 1) do
  begin
    try
      Result := Result + chr((StrToInt('$' + copy(HexInputStr, iCntIStr, 2))
        xor StrToInt('$' + copy(HexKeyStr, iCntKStr mod (Length(HexKeyStr) +
        1), 2))));
    except
      on e: Exception do
      begin
        // LogEvnt('9002    Fehler in Modul: DeCrypt    ' + e.Message);
        Result := '';
        exit;
      end;
    end;
    Inc(iCntIStr, 2);
    Inc(iCntKStr, 2);
  end;
end;

Function GetFileVersion(const FileName: String): String;
var
  VersionInfoSize, VersionInfoValueSize, Zero: DWord;
  VersionInfo, VersionInfoValue: Pointer;
begin
  { Ist Datei nicht vorhanden, dann Hinweis und raus aus Funktion ... }
  if not FileExists(FileName) then
  begin
    Result := '-1'; { alternativ auch 'File not found' oder sonstwas }
    exit;
  end;

  { sonnst weiter. }
  Result := '';
  VersionInfoSize := GetFileVersionInfoSize(PChar(FileName), Zero);
  if VersionInfoSize = 0 then
    exit;
  { Bei nicht genug Speicher wird EOutOfMemory-Exception ausgelst }
  GetMem(VersionInfo, VersionInfoSize);
  try
    if GetFileVersionInfo(PChar(FileName), 0, VersionInfoSize, VersionInfo) and
      VerQueryValue(VersionInfo, '\' { root block } , VersionInfoValue,
      VersionInfoValueSize) and (0 <> LongInt(VersionInfoValueSize)) then
    begin
      with TVSFixedFileInfo(VersionInfoValue^) do
      begin
        Result := IntToStr(HiWord(dwFileVersionMS));
        Result := Result + '.' + IntToStr(LoWord(dwFileVersionMS));
        Result := Result + '.' + IntToStr(HiWord(dwFileVersionLS));
        Result := Result + '.' + IntToStr(LoWord(dwFileVersionLS));
      end; { with }
    end; { then }
  finally
    FreeMem(VersionInfo);
  end; { try }
end; { GetFileVersion }

procedure checkalarm;
var
  sMsg, sMsgHeader: string;
  ShedUser: TStringList;
  UserName: TStringList;
  UserEmail: TStringList;
  UserID: TStringList;
  AllUser: TStringList;
  WorkerEmail: TStringList;
  aWorkUser: array of TStringList;
  aTimID: array of array of TStringList;
  aInfo: array of array of TStringList;
  aDocname: array of array of TStringList;
  aGdocid: array of array of TStringList;
  shed_idx, work_idx, idx, tim_idx, email_idx: integer;
  builder, builderplain: TIdCustomMessageBuilder;
  smtp: TIdSMTP;
  msg: Tidmessage;
  bfaWorkflow: TbfaWorkflow;
  Docname : WideString;
  doc_cnt : Integer;
  req : TbfaRequest;
  sock: TBaseSocketConnection;
  reqUserID : integer;
begin
  // todo document this function
  // user names
  UserName := TStringList.Create;
  // user emails
  UserEmail := TStringList.Create;
  // user ids
  UserID := TStringList.Create;
  // all user ids
  AllUser := TStringList.Create;
  // shed users
  ShedUser := TStringList.Create;

  WorkerEmail := TStringList.Create;

  sock := nil;

  // DateTimeToString(sLogDate, 'dd.mm.yyyy hh:nn:ss', now);
  // select the wvl which erinnerung is older than today and they are unfinished and
  // optionen has 4 in it (send mail)
  dm_tim.m_q.sql.Text :=
    ' select * from sys_timer as st left join sys_doc as sd on (st.gdocid = sd.gdocid)'
    + 'where  alarm < now() and ' +
    ' ((status & 4) = 0) and ((st.options & 4)= 4) order by userid_shed';
  try
    dm_tim.m_q.Execute;
  except
    on e: Exception do
      WriteCmd('Fehler bei der Datenbankabfrage der berflligen Wiedervorlagen: ' + e.Message);
  end;

  if dm_tim.m_q.RecordCount > 0 then
    writeln('Es sind noch Wvl offen und veraltet!');

  try
    dm_tim.m_q.First;
    while (not dm_tim.m_q.EOF) do
    begin
      // check if usr is already in  ShedUser
      shed_idx := ShedUser.indexof(dm_tim.m_q.FieldByName('userid_shed').AsString);
      if shed_idx = -1 then
      begin
        // add user to  AllUser (shed)
        if AllUser.indexof(dm_tim.m_q.FieldByName('userid_shed').AsString) = -1 then
          AllUser.add(dm_tim.m_q.FieldByName('userid_shed').AsString);

        // add user to ShedUser
        ShedUser.add(dm_tim.m_q.FieldByName('userid_shed').AsString);
        shed_idx := ShedUser.indexof(dm_tim.m_q.FieldByName('userid_shed').AsString);

        // add informations about this user
        if Length(aWorkUser) <= shed_idx then
        begin
          setlength(aWorkUser, shed_idx + 1);
          aWorkUser[shed_idx] := TStringList.Create;
          setlength(aTimID, shed_idx + 1);
          setlength(aInfo, shed_idx + 1);
          setlength(aDocname, shed_idx + 1);
          setlength(aGdocid, shed_idx + 1);
        end;
      end;

      // add information about tim_id
      work_idx := aWorkUser[shed_idx].indexof(dm_tim.m_q.FieldByName('userid_work').AsString);
      if work_idx = -1 then
      begin
        if AllUser.indexof(dm_tim.m_q.FieldByName('userid_work').AsString) = -1 then
          AllUser.add(dm_tim.m_q.FieldByName('userid_work').AsString);

        aWorkUser[shed_idx].add(dm_tim.m_q.FieldByName('userid_work').AsString);

        work_idx := aWorkUser[shed_idx].indexof(dm_tim.m_q.FieldByName('userid_work').AsString);

        setlength(aTimID[shed_idx], work_idx + 1);
        aTimID[shed_idx][work_idx] := TStringList.Create;
        setlength(aInfo[shed_idx], work_idx + 1);
        aInfo[shed_idx][work_idx] := TStringList.Create;
        setlength(aDocname[shed_idx], work_idx + 1);
        aDocname[shed_idx][work_idx] := TStringList.Create;
        setlength(aGdocid[shed_idx], work_idx + 1);
        aGdocid[shed_idx][work_idx] := TStringList.Create;
      end;
      // tim_id doesnt exist , so add (should happen always...)
      if aTimID[shed_idx][work_idx].indexof(dm_tim.m_q.FieldByName('timid').AsString) = -1 then
      begin
        aTimID[shed_idx][work_idx].add(dm_tim.m_q.FieldByName('timid').AsString);
        aInfo[shed_idx][work_idx].add(dm_tim.m_q.FieldByName('info').AsString);
        aDocname[shed_idx][work_idx].add(dm_tim.m_q.FieldByName('docname').AsString);
        aGdocid[shed_idx][work_idx].add(dm_tim.m_q.FieldByName('gdocid').AsString);

        if WorkerEmail.indexof(dm_tim.m_q.FieldByName('userid_work').AsString) = -1
        then
          email_idx := WorkerEmail.AddObject(dm_tim.m_q.FieldByName('userid_work').AsString, TStringList.Create)
        else
          email_idx := WorkerEmail.indexof(dm_tim.m_q.FieldByName('userid_work').AsString);

        bfaWorkflow := TbfaWorkflow.Create;
        bfaWorkflow.timid := dm_tim.m_q.FieldByName('timid').AsString;
        bfaWorkflow.info := dm_tim.m_q.FieldByName('info').AsString;
        bfaWorkflow.docname := dm_tim.m_q.FieldByName('docname').AsString;
        bfaWorkflow.gdocid := dm_tim.m_q.FieldByName('gdocid').AsString;
        bfaWorkflow.userid_shed := dm_tim.m_q.FieldByName('userid_shed').AsString;
        TStringList(WorkerEmail.Objects[email_idx]).AddObject(dm_tim.m_q.FieldByName('timid').AsString, bfaWorkflow);
      end;

      dm_tim.m_q.Next;
    end;
  except
    on e: Exception do
      WriteCmd('Fehler beim Aufbau der Wiedervorlagenliste: ' + e.Message);
  end;

  // build the list with users information
  try
    dm_tim.m_q2.sql.Text := 'select * from sys_user where (flags & 2) = 0';
    dm_tim.m_q2.Execute;
    dm_tim.m_q2.First;
    while (not dm_tim.m_q2.EOF) do
    begin
      if (AllUser.indexof(dm_tim.m_q2.FieldByName('userid').AsString) > -1) then
      begin
        UserName.add(dm_tim.m_q2.FieldByName('username').AsString);
        UserEmail.add(dm_tim.m_q2.FieldByName('usermail').AsString);
        UserID.add(dm_tim.m_q2.FieldByName('userid').AsString);
      end;
      dm_tim.m_q2.Next;
    end;
  except
    on e: Exception do
      WriteCmd('Fehler beim Aufbau der Benutzerliste: ' + e.Message);
  end;


  // connect to smtp
  if not bfaServerSMTP then
  begin
    smtp := TIdSMTP.Create(nil);
    smtp.Host := smtp_server_host;
    smtp.Port := smtp_port;

    try
      smtp.Connect;
    except
      WriteCMD('Konnte mit SMTP Server ' + smtp_server_host +  ' nicht verbinden.');
      Exit;
    end;
    if breport then
      WriteCMD('Server Response:' + #10 + #13 + smtp.LastCmdResult.Text.Text);

    if smtp_user <> '' then
    begin
      smtp.Username := smtp_user;
      smtp.Password := smtp_pass;

      try
        if not smtp.Authenticate then
        begin
          WriteCMD('Konnte nicht am SMTP Server ' + smtp_server_host + ' authentifizieren.');
          Exit;
        end;
      except
        WriteCMD('Fehler: Konnte nicht am SMTP Server ' + smtp_server_host +  ' authentifizieren.');
        Exit;
      end;
    end;
  end;

  // go throught the shedulers
  doc_cnt := 0;
  for shed_idx := 0 to Length(aWorkUser) - 1 do
  begin
    idx := UserID.indexof(ShedUser.Strings[shed_idx]);
    if idx = -1 then
      Continue;

    if (UserEmail.Count = 0) or (UserEmail.Strings[idx] = '') then
      Continue;

    msg := Tidmessage.Create(nil);

    // build message
    msg.Recipients.Clear;

    builder := TIdMessageBuilderHtml.Create;
//    builderplain := TIdMessageBuilderPlain.Create;
    builder.Attachments.Clear;
    msg.From.Name := 'Bitfarm Archiv';
    msg.From.Address := GSsendername;

    with msg.Recipients.add do
    begin
      Name := UserName.Strings[idx];
      Address := UserEmail.Strings[idx];
    end;
    sMsg := '';
    sMsgHeader := '';
    sMsgHeader := '<META HTTP-EQUIV="Content-Type" CONTENT="text/html;charset=iso-8859-1">'
      + '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">' +
      '<HTML><HEAD>' +
      '<META http-equiv=Content-Type content="text/html; charset=iso-8859-1">' +
      '<META content="bitfarm Archiv V3" name=GENERATOR>' + '<STYLE></STYLE>' +
      '</HEAD>' + '<BODY bgColor=#ffffff>';

    try
      // go through the workers
      for work_idx := 0 to aWorkUser[shed_idx].Count - 1 do
      begin
        idx := UserID.indexof(aWorkUser[shed_idx].Strings[work_idx]);
        if idx = -1 then
          Continue;

        sMsg := sMsg + '<br/>Bearbeiter: ' + UserName.Strings[idx];
        // go through the tim_ids
        for tim_idx := 0 to aTimID[shed_idx][work_idx].Count - 1 do
        begin
          inc(doc_cnt);
          Docname := 'Dokument';
          if aDocname[shed_idx][work_idx].Strings[tim_idx] <> '' then
            Docname := aDocname[shed_idx][work_idx].Strings[tim_idx];

          sMsg := sMsg + '<div>Timid: ' + aTimID[shed_idx][work_idx].Strings
            [tim_idx] + ', Info: ' + aInfo[shed_idx][work_idx].Strings[tim_idx];
          sMsg := sMsg + '<br>Link zum Dokument: <A href="gdocid:' +
            aGdocid[shed_idx][work_idx].Strings[tim_idx] + '">' + Docname + '</a><br/></div>';
        end;
      end;
    except
      on e: Exception do
        WriteCmd('Fehler beim Aufbau der Controller Email. ' + e.Message);
    end;
    // send message

    if doc_cnt = 1 then
      sMsgHeader := sMsgHeader + '<DIV><span style="color:red">Achtung! Bei diesem Dokument' +
      ' wurde die eingestellte Bearbeitungszeit &uuml;berschritten:</span>&nbsp;<BR></DIV><Div>'
    else
      sMsgHeader := sMsgHeader + '<DIV><span style="color:red">Achtung! Bei diesen Dokumenten' +
      ' wurde die eingestellte Bearbeitungszeit &uuml;berschritten:</span>&nbsp;<BR></DIV><Div>';


    sMsg := sMsgHeader + sMsg +
      '</div><br/><br/><DIV><STRONG><FONT face=Arial><EM>bitfarm-<FONT color=#ff6600>Archiv</FONT></STRONG> Dokumentenmanagement</EM></FONT><BR>'
      + '</BODY></HTML>';

    TIdMessageBuilderHtml(builder).Html.Text := sMsg;

//    TIdMessageBuilderPlain(builderplain).PlainText.Text :=
//      'Sie bentigen ein eMail-Programm, das HTML EMails untersttzt' + #13 +
//      'um die <Als Dokumentenlink versenden> Funktion sinnvoll einzusetzen.' +
//      #13 + #13 + 'Bitte wenden Sie sich an Ihren Administrator.';

    msg.Subject := 'bitfarm-Archiv: Erinnerung an Wiedervorlage';

    try
      builder.FillMessage(msg);
      // builderplain.FillMessage(msg);
    finally
      builder.Free;
//      builderplain.Free;
    end;

    if bfaServerSMTP then
    begin
      try
        sock := TBaseSocketConnection.Create(Byte(bfaServerNoSSL), bfaServer, bfaServerPort, '');
        sock.CreateComponents;
        if sock.Connect then
        begin
          req := TbfaRequest.Create;
          req.ReqType := 'reqAuthenticate';
          req.Parameter := bfauser;
          req.Profile := Profile;
          req.DataString := EnCrypt(bfapass, GlobalKey);
          sock.SendRequestToServer(req);

          req := sock.ReceiveResponse;
          if req.ReqType = 'respAuthError' then
          begin
            WriteLN('Anmeldung am Bitfarm-Server nicht mglich.' + #13#10 + req.DataString);
            Exit;
          end else
          begin
            sock.SetSid(DeCrypt(req.Sessionid, GlobalKey));
            reqUserID := req.UserID;
            req.DataString := '';
            req.ReqType := 'reqSMTPMail';
            req.ParameterList := TStringList.Create;
            req.ParameterList.Add('recp:'+ msg.Recipients.EMailAddresses);
            req.ParameterList.Add('subject:'+ msg.Subject);
            req.ParameterList.Add('html:'+sMsg);

            sock.SendRequestToServer(req);
            req := sock.ReceiveResponse();
            if req.ReqType <> 'respOK' then
            begin
              WriteLN('Server meldet Fehler bei reqSMTPMail: ' + req.DataString);
            end;
          end;
        end;
      except
        on e: Exception do
          WriteCmd('Fehler beim Senden des reqSMPTMail: ' + e.Message);
      end;
    end else
    begin
      try
        try
          smtp.Send(msg)
        except
          WriteCMD(Format('Message konnte nicht an "%s" gesendet werden!',
            [UserEmail.Strings[idx]]));
        end;
      finally
        FreeAndNil(msg);
      end;
    end;
  end;

    // go throught the worker
  for work_idx := 0 to WorkerEmail.Count - 1 do
  begin
    idx := UserID.indexof(WorkerEmail[work_idx]);

    if idx = -1 then
      Continue;

    if (UserEmail.Count = 0) or (UserEmail.Strings[idx] = '') then
      Continue;

    if TStringList(WorkerEmail.Objects[work_idx]).Count = 0 then
      Continue;

    msg := Tidmessage.Create(nil);

    // build message
    msg.Recipients.Clear;

    builder := TIdMessageBuilderHtml.Create;
//    builderplain := TIdMessageBuilderPlain.Create;
    builder.Attachments.Clear;
    msg.From.Name := 'Bitfarm Archiv';
    msg.From.Address := GSsendername;

    with msg.Recipients.add do
    begin
      Name := UserName.Strings[idx];
      Address := UserEmail.Strings[idx];
    end;
    sMsg := '';
    sMsg := '<META HTTP-EQUIV="Content-Type" CONTENT="text/html;charset=iso-8859-1">'
      + '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">' +
      '<HTML><HEAD>' +
      '<META http-equiv=Content-Type content="text/html; charset=iso-8859-1">' +
      '<META content="bitfarm Archiv V3" name=GENERATOR>' + '<STYLE></STYLE>' +
      '</HEAD>' + '<BODY bgColor=#ffffff>';

    if TStringList(WorkerEmail.Objects[work_idx]).Count = 1 then
      sMsg := sMsg + '<DIV><span style="color:red">Achtung! Bei diesem Dokument' +
      ' wurde die eingestellte Bearbeitungszeit &uuml;berschritten:</span>&nbsp;<BR></DIV><Div>'
    else
      sMsg := sMsg + '<DIV><span style="color:red">Achtung! Bei diesen Dokumenten' +
      ' wurde die eingestellte Bearbeitungszeit &uuml;berschritten:</span>&nbsp;<BR></DIV><Div>';

    // go through the workflows

    try
      for tim_idx := 0 to TStringList(WorkerEmail.Objects[work_idx]).Count - 1 do
      begin
        Docname := 'Dokument';
        if TbfaWorkflow(TStringList(WorkerEmail.Objects[work_idx]).Objects[tim_idx]).docname <> '' then
          Docname := TbfaWorkflow(TStringList(WorkerEmail.Objects[work_idx]).Objects[tim_idx]).docname;
        sMsg := sMsg + '<div>Timid: ' + TStringList(WorkerEmail.Objects[work_idx]).Strings[tim_idx]
                     + ', Info: ' + TbfaWorkflow(TStringList(WorkerEmail.Objects[work_idx]).Objects[tim_idx]).info;
        sMsg := sMsg + '<br>Link zum Dokument: <A href="gdocid:' +  TbfaWorkflow(TStringList(WorkerEmail.Objects[work_idx]).Objects[tim_idx]).gdocid + '">'
                     + Docname + '</a><br/></div>';

      end;
    except
      on e: Exception do
        WriteCmd('Fehler beim Aufbau der Benutzer Email. ' + e.Message);

    end;

    // send message
    sMsg := sMsg +
      '</div><br/><br/><DIV><STRONG><FONT face=Arial><EM>bitfarm-<FONT color=#ff6600>Archiv</FONT></STRONG> Dokumentenmanagement</EM></FONT><BR>'
      + '</BODY></HTML>';

    TIdMessageBuilderHtml(builder).Html.Text := sMsg;

//    TIdMessageBuilderPlain(builderplain).PlainText.Text :=
//      'Sie bentigen ein eMail-Programm, das HTML EMails untersttzt' + #13 +
//      'um die <Als Dokumentenlink versenden> Funktion sinnvoll einzusetzen.' +
//      #13 + #13 + 'Bitte wenden Sie sich an Ihren Administrator.';

    msg.Subject := 'bitfarm-Archiv: Erinnerung an Wiedervorlage';

    try
      builder.FillMessage(msg);
      // builderplain.FillMessage(msg);
    finally
      builder.Free;
//      builderplain.Free;
    end;

    if bfaServerSMTP then
    begin
      try
        if not Assigned(sock) then
        begin
          sock := TBaseSocketConnection.Create(Byte(bfaServerNoSSL), bfaServer, bfaServerPort, '');
          sock.CreateComponents;
          if sock.Connect then
          begin
            req := TbfaRequest.Create;
            req.ReqType := 'reqAuthenticate';
            req.Parameter := bfauser;
            req.Profile := Profile;
            req.DataString := EnCrypt(bfapass, GlobalKey);
    //        req.Lang := Lang;
            sock.SendRequestToServer(req);

            req := sock.ReceiveResponse;
            if req.ReqType = 'respAuthError' then
            begin
              WriteLN('Anmeldung am Bitfarm-Server nicht mglich.' + #13#10 + req.DataString);
              Exit;
            end else
            begin
              sock.SetSid(DeCrypt(req.Sessionid, GlobalKey));
              reqUserID := req.UserID;
            end;
          end;
        end;

        req.DataString := '';
        req.ReqType := 'reqSMTPMail';
        req.UserID := reqUserID;
        req.ParameterList := TStringList.Create;
        req.ParameterList.Add('recp:'+ msg.Recipients.EMailAddresses);
        req.ParameterList.Add('subject:'+ msg.Subject);
        req.ParameterList.Add('html:'+sMsg);

        sock.SendRequestToServer(req);
        req := sock.ReceiveResponse();
        if req.ReqType <> 'respOK' then
        begin
          WriteLN('Server meldet Fehler bei reqSMTPMail: ' + req.DataString);
        end;
      except
        on e: Exception do
          WriteCmd('Fehler beim Senden des reqSMPTMail: ' + e.Message);
      end;
    end else
    begin
      try
        try
          smtp.Send(msg)
        except
          WriteCMD(Format('Message konnte nicht an "%s" gesendet werden!', [UserEmail.Strings[idx]]));
        end;
      finally
        FreeAndNil(msg);
      end;
    end;
  end;

  // smtp disconnect
  if not bfaServerSMTP then
  begin
    try
      smtp.Disconnect;
    except
      WriteCmd('Fehler bei SMTP Disconnect');
    end;
  end;

  for work_idx := 0 to WorkerEmail.Count - 1 do
  begin
    if TStringList(WorkerEmail.Objects[work_idx]).Count > 0 then
      TStringList(WorkerEmail.Objects[work_idx]).Clear;
    WorkerEmail.Objects[work_idx].Free;
  end;
end;

function ConnectDB(sProfil: string): Boolean;
var
  con: Tinifile;
  sUser, sPass, auth_cred: string;
begin
  // Auslesen der Connection
  con := Tinifile.Create(sProfil);
  Result := True;
  try
    try
      with con do
      begin
        sUser := ReadString('Connection', 'User', '');
        sPass := ReadString('Connection', 'Pass', '');

        Clientprogramm := ReadString('Scripts', 'clientprogram', '');
        ClientSpooler := ReadString('Scripts', 'uncclientspooler', '');
        dm_tim.m_C.UserName := DeCrypt(sUser, GlobalKey);
        dm_tim.m_C.Password := DeCrypt(sPass, GlobalKey);
        dm_tim.m_C.Server := ReadString('Connection', 'Server', '');
        dm_tim.m_C.Port := ReadInteger('Connection', 'Port', 3306);
        dm_tim.m_C.Database := ReadString('Connection', 'DB', '');
        WriteCMD('Connection to Server ' + dm_tim.m_C.Server + ' with DB ' +
          dm_tim.m_C.Database);
        dm_tim.m_C.Connect; // Anmelden an der Datenbank
        if not dm_tim.m_C.Connected then
        // Wenn keine Verbindung dann Tool verlassen
        begin
          ExitCode := 2;
          writeln('Fehler: Keine Verbindung zur Datenbank!');
          Result := False;
          exit;
        end;

        bfaServer := ReadString(sSysServerSection, sSysBfaServer, 'localhost');
        bfaServerPort := ReadInteger(sSysServerSection, sSysBfaServerPort, 50001);
        bfaServerNoSSL := ((LowerCase(ReadString(sSysServerSection, sSysNoSSL, 'false')) = 'true') or (ReadString(sSysServerSection, sSysNoSSL, 'false') = '1')).ToInteger;
        bfaServerSMTP :=  LowerCase(ReadString('scripts', 'bfa_server_smtp', 'false')) = 'true';
        smtp_server_host := ReadString('scripts', 'smtpserver', '');
        smtp_port := ReadInteger('scripts', 'smtpport', 25);
        GSsendername := ReadString('scripts', 'sendername', '');
        smtp_user := ReadString('scripts', 'authuser', '');
        smtp_pass := ReadString('scripts', 'authpass', '');
        auth_cred := ReadString('scripts', 'auth_cred', '');
        if auth_cred <> '' then
          smtp_pass := decryptDataBase64(auth_cred);

        bfauser := ReadString('client', 'bfauser', '');
        bfapass := ReadString('client', 'bfapass', '');

        if bfaServerSMTP then
        begin
          bfauser := decryptDataBase64(bfauser);
          bfapass := decryptDataBase64(bfapass);
        end;

        if ((smtp_server_host = '') or (GSsendername = '')) then
        begin
          ExitCode := 6;
          writeln('Fehler in der .CON Datei: Keinen Smtp Server oder keinen Sendername angegeben!');
          exit;
        end;

        if (bfaServerSMTP and ((bfauser = '') or (bfapass = ''))) then
        begin
          ExitCode := 6;
          writeln('Fehler in der .CON Datei: Kein SMTP User oder Passwort angegeben!');
          exit;
        end;
      end;
    except
      on e: Exception do
      begin
        ExitCode := 4;
        writeln('Fehler: Beim Auslesen der .CON Datei! ' + e.Message);
        Result := False;
        exit;
      end;
    end;
  finally
    if Assigned(con) then
      FreeAndNil(con);
  end;
end;

function GetIndexTableID(fieldname: string): integer;
begin
  try
    dm_tim.m_qidx.sql.Text :=
      'SELECT indextableid FROM sys_addfields WHERE fieldname = ' + #39 +
      fieldname + #39 + ';';
    dm_tim.m_qidx.Execute;
    Result := dm_tim.m_qidx.FieldByName('indextableid').AsInteger;
  except
    on e: Exception do
    begin
      Result := -1;
      writeln('Fehler: GetIndexTableID(' + fieldname + ')! ' + e.Message);
    end;
  end;
end;

procedure check4timermngroutine;
var
  lnow, lsinterv, lsinterv1, likuendigung, likuendigung1: Tdatetime;
  licounter, licounter1, licounter2, liinc, liversatz, shiftamount, ifile, i,
    iidx: integer;
  lsstartfeld, lsendfeld, lsintervalfeld, lsusersfeld, lslasttimeactivatedfeld,
    lstmp, lstmp1, sFileName, smwfilename, lskuendigungfeld, colid: string;
  liarcid, bitmask: int64;
  linilist, linifiles: Tinifile;
  lbismonat, lbisjahr, lbistag, lkbisTag, lkbismonat, lkbisjahr: Boolean;
  slWFEnd, IDList, FieldList: TStringList;
  sql_idx, idx, gdocid: string;
begin
  // todo mach mal schlankeren code!!!
  try
    ifile := 0;
    dm_tim.m_q.sql.Text := 'select now() as ldate';
    dm_tim.m_q.Execute;
    lnow := dm_tim.m_q.FieldByName('ldate').AsDateTime;

    linilist := Tinifile.Create(extractfilepath(Clientprogramm) +
      '\Vertragsmanagement\List.ini');
    licounter := linilist.ReadInteger('Files', 'Counter', 0);
    if licounter = 0 then
    begin
      writeln('Keinen Eintrag in ' + extractfilepath(Clientprogramm) +
        '\Vertragsmanagement\List.ini gefunden.');
      exit;
    end;

    for licounter1 := 0 to licounter - 1 do
    begin
      try
        smwfilename := linilist.ReadString('Files',
          'Datei' + IntToStr(licounter1), '');
        if not FileExists(smwfilename) then
        begin
          writeln('Keine Datei gefunden:' + smwfilename);
          Continue;
        end;

        WriteCMD('Lese MWL-Datei: ' + smwfilename);

        linifiles := Tinifile.Create(smwfilename);
        lsstartfeld := linifiles.ReadString('Info', 'startfield', '');
        lsintervalfeld := linifiles.ReadString('Info', 'intervalfield', '');
        lsendfeld := linifiles.ReadString('Info', 'endfield', '');
        lslasttimeactivatedfeld := linifiles.ReadString('Info',
          'lastactivatedfield', '');
        lskuendigungfeld := linifiles.ReadString('Info', 'noticefield', '');
        liversatz := linifiles.ReadInteger('Info', 'offset', 0);
        liarcid := linifiles.ReadInteger('Info', 'archiveid', 0);

        if (liarcid = 0) or (lsstartfeld = '') or (lsendfeld = '') then
        begin
          WriteCMD('notwendige Angaben nicht vollstndig, berspringe...');
          Continue;
        end;

        dm_tim.m_q.sql.Text := 'select * from sys_arc where arcid = ' +
          IntToStr(liarcid);
        dm_tim.m_q.Execute;

        if breport then
        begin
          writeln('');
          WriteCMD('********************************************************');
          WriteCMD('Vertragsmanagement fr Archiv: ' + dm_tim.m_q.FieldByName
            ('arcname').AsString + ' (' + IntToStr(liarcid) + ')');
          dm_tim.m_q.sql.Text :=
            'select * from sys_addfields where fieldname = ' + #39 +
            linifiles.ReadString('Info', 'startfield', '') + #39;
          dm_tim.m_q.Execute;
          WriteCMD('Vertragsbeginn: ' + dm_tim.m_q.FieldByName('displayname')
            .AsString);

          dm_tim.m_q.sql.Text :=
            'select * from sys_addfields where fieldname = ' + #39 +
            linifiles.ReadString('Info', 'intervalfield', '') + #39;
          dm_tim.m_q.Execute;
          WriteCMD('Laufzeit      : ' + dm_tim.m_q.FieldByName('displayname')
            .AsString);

          dm_tim.m_q.sql.Text :=
            'select * from sys_addfields where fieldname = ' + #39 +
            linifiles.ReadString('Info', 'endfield', '') + #39;
          dm_tim.m_q.Execute;
          WriteCMD('Vertragsende  : ' + dm_tim.m_q.FieldByName('displayname')
            .AsString);

          dm_tim.m_q.sql.Text :=
            'select * from sys_addfields where fieldname = ' + #39 +
            linifiles.ReadString('Info', 'lastactivatedfield', '') + #39;
          dm_tim.m_q.Execute;
          WriteCMD('letzte Aktivierung: ' + dm_tim.m_q.FieldByName
            ('displayname').AsString);

          dm_tim.m_q.sql.Text :=
            'select * from sys_addfields where fieldname = ' + #39 +
            linifiles.ReadString('Info', 'noticefield', '') + #39;
          dm_tim.m_q.Execute;
          WriteCMD('Kndigungsfrist   : ' + dm_tim.m_q.FieldByName
            ('displayname').AsString);

          WriteCMD('Versatz       : ' + linifiles.ReadString('Info',
            'offset', ''));
          writeln('');
        end;

        // 05.11.2018            sql_idx := 'select * from sys_docidx_0 as idx0';
        FieldList := TStringList.Create;
        try
          sql_idx := 'select sd.gdocid, ';

          FieldList.Duplicates := dupIgnore;
          FieldList.Sorted := True;
          FieldList.add(lsstartfeld);
          FieldList.add(lsintervalfeld);
          FieldList.add(lsendfeld);
          FieldList.add(lslasttimeactivatedfeld);
          FieldList.add(lskuendigungfeld);

          dm_tim.m_q2.sql.Text := 'SELECT fieldname FROM sys_addfields as ad ' +
            'left join sys_addfieldxs as adx on (ad.addfieldid = adx.fieldid) '
            + 'where type <> 4 and arcid =' + IntToStr(liarcid) +
            ' group by ad.addfieldid, pos order by pos';
          dm_tim.m_q2.Open;

          if dm_tim.m_q2.RecordCount > 0 then
          begin
            dm_tim.m_q2.First;
            while not dm_tim.m_q2.EOF do
            begin
              FieldList.add(dm_tim.m_q2.FieldByName('fieldname').AsString);
              dm_tim.m_q2.Next;
            end;
          end;
          dm_tim.m_q2.Close;

          for i := 0 to FieldList.Count - 1 do
          begin
            sql_idx := sql_idx + FieldList[i];
            if i < FieldList.Count - 1 then
              sql_idx := sql_idx + ',';
          end;

          sql_idx := sql_idx + ' from sys_doc as sd';

          IDList := TStringList.Create;
          try
            IDList.Duplicates := dupIgnore;
            IDList.Sorted := True;

            for i := 0 to FieldList.Count - 1 do
              IDList.add(IntToStr(GetIndexTableID(FieldList[i])));

            for i := 0 to IDList.Count - 1 do
            begin
              if IDList[i] <> '-1' then
                sql_idx := sql_idx +
                  Format(' left join sys_docidx_%s as idx%s on (sd.gdocid = idx%s.gdocid)',
                  [IDList[i], IDList[i], IDList[i]]);
            end;
          finally
            FreeAndNil(IDList);
          end;
        finally
          FreeAndNil(FieldList);
        end;

        // 05.11.2018
        // dm_tim.m_q1.sql.text := 'show tables like ' + #39 + 'sys_docidx_%' + #39;
        // dm_tim.m_q1.execute;
        // for i := 1 to dm_tim.m_q1.RecordCount -1 do
        // begin
        // idx := IntToStr(i);
        // sql_idx := sql_idx + Format(' left join sys_docidx_%s as idx%s on (idx0.gdocid = idx%s.gdocid)',[idx,idx,idx]);
        // end;
        // todo: natrlich falls der server down war oder timchecker nicht
        // ausgefhrt wrde sein versatz+vertragskndigung dann gibt es ein problem...
        dm_tim.m_q1.sql.Text := sql_idx +
        // 05.11.2018 ' left join sys_doc as sd on (idx0.gdocid = sd.gdocid)' +
        // 06.11.2018 mit Heino geeinigt das Vertrge die schon EndDatum haben sollten nicht mehr gemeldet werden              ' where  ((' + lsendfeld + ' > now()) or (' + lsendfeld + ' is null)) and (not (' + lsstartfeld + ' is null))' +
          ' where (' + lsendfeld + ' is null) and (not (' + lsstartfeld +
          ' is null))' + ' and sd.arcid = ' + IntToStr(liarcid);

        dm_tim.m_q1.Execute;
        // alles was nicht abgelaufen oder ohne vertragsende ist und einen vertragsbeginn hat
        while not dm_tim.m_q1.EOF do
        begin
          try
            // Abfrage Interval
            lstmp := dm_tim.m_q1.FieldByName(lsintervalfeld).AsString;
            gdocid := dm_tim.m_q1.FieldByName('gdocid').AsString;
            if lstmp = '' then
            begin
              if breport then
                WriteCMD('Fr Dokument ' + IntToStr(liarcid) + '.' + gdocid + ' wurde keine Laufzeit angegeben');
              dm_tim.m_q1.Next;
              Continue;
            end;
            lbismonat := False;
            lbisjahr := False;
            lbistag := False;

            // todo for day add dm_tim.m_q1.fieldbyname(lsstartfeld).asdatetime or lasttimeactivated
            if pos('T', lstmp) > 0 then
            begin
              lstmp := copy(lstmp, 1, Length(lstmp) - 1);
              lsinterv := strtofloat(lstmp);
              lsinterv1 := lsinterv + now;
              lbistag := True;
            end
            else if pos('W', lstmp) > 0 then
            begin
              lstmp := copy(lstmp, 1, Length(lstmp) - 1);
              lsinterv := strtofloat(lstmp) * 7;
              lsinterv1 := lsinterv + now;
              lbistag := True;
            end
            else if pos('M', lstmp) > 0 then
            begin
              lstmp := copy(lstmp, 1, Length(lstmp) - 1);
              lsinterv := strtofloat(lstmp);
              lbismonat := True;
            end else
            begin
              lstmp := copy(lstmp, 1, Length(lstmp) - 1);
              lsinterv := strtofloat(lstmp);
              lbisjahr := True;
            end;

            // um Endlosschleifen zu verhindern wird hier auf Interval 0 geprft
            if lstmp = '0' then
            begin
              if breport then
                WriteCMD('Fehler bei Dokument ' + IntToStr(liarcid) + '.' +
                  gdocid + '. Laufzeit kann nicht 0 sein');
              lstmp := '';
              dm_tim.m_q1.Next;
              Continue;
            end;

            // Abfrage Kndigungsfrist
            lkbismonat := False;
            lkbisjahr := False;
            lkbisTag := False;
            lstmp1 := dm_tim.m_q1.FieldByName(lskuendigungfeld).AsString;
            // todo for day add dm_tim.m_q1.fieldbyname(lsstartfeld).asdatetime or lasttimeactivated

            if pos('T', lstmp1) > 0 then
            begin
              lstmp1 := copy(lstmp1, 1, Length(lstmp1) - 1);
              likuendigung := strtofloat(lstmp1);
              lkbisTag := True;
            end
            else if pos('W', lstmp1) > 0 then
            begin
              lstmp1 := copy(lstmp1, 1, Length(lstmp1) - 1);
              likuendigung := strtofloat(lstmp1) * 7;
              lkbisTag := True;
            end
            else if pos('M', lstmp1) > 0 then
            begin
              lstmp1 := copy(lstmp1, 1, Length(lstmp1) - 1);
              likuendigung := strtofloat(lstmp1);
              lkbismonat := True;
            end
            else if pos('J', lstmp1) > 0 then
            begin
              lstmp1 := copy(lstmp1, 1, Length(lstmp1) - 1);
              try
                likuendigung := strtofloat(lstmp1);
              except
                on e: Exception do
                begin
                  likuendigung := 1;
                end;
              end;
              lkbisjahr := True;
            end;

            if breport then
            begin
              if not(lkbisTag or lkbismonat or lkbisjahr) then
                WriteCMD('Fr Dokument ' + IntToStr(liarcid) + '.' + gdocid + ' wurde keine Kndigungsfrist gesetzt');
            end;

            // wenn die letzte Aktivierung  leer ist

            // zuerst einmal die Laufzeit auf das Startdatum rechnen
            if lbistag then
            begin
              licounter2 := 0;
              lsinterv1 := 0;
              liinc := trunc(lsinterv);
              lsinterv1 := IncDay(dm_tim.m_q1.FieldByName(lsstartfeld)
                .AsDateTime, liinc);
            end;
            if lbismonat then
            begin
              licounter2 := 0;
              lsinterv1 := 0;
              liinc := trunc(lsinterv);
              lsinterv1 := IncMonth(dm_tim.m_q1.FieldByName(lsstartfeld)
                .AsDateTime, liinc);
            end;
            if lbisjahr then
            begin
              licounter2 := 0;
              lsinterv1 := 0;
              liinc := trunc(lsinterv);
              lsinterv1 := IncYear(dm_tim.m_q1.FieldByName(lsstartfeld)
                .AsDateTime, liinc);
            end;

            // dann die Kndigungsfrist abziehen
            if lkbisTag then
            begin
              likuendigung1 := lsinterv1 - likuendigung;
              lsinterv1 := likuendigung1;
            end;
            if lkbismonat then
            begin
              licounter2 := 0;
              liinc := trunc(likuendigung);
              likuendigung1 := IncMonth(lsinterv1, -liinc);
              lsinterv1 := likuendigung1;
            end;
            if lkbisjahr then
            begin
              licounter2 := 0;
              liinc := trunc(likuendigung);
              likuendigung1 := IncYear(lsinterv1, -liinc);
              lsinterv1 := likuendigung1;
            end;

            // zuletzt noch den Versatz abziehen
            lsinterv1 := lsinterv1 - liversatz;

            // it is not practically to add one month to
            // a date that are 10 years old, so we add so much that it makes sense

            if (lnow > lsinterv1) and (lbistag OR lbismonat OR lbisjahr) then
            begin
              while lnow > lsinterv1 do
              begin
                if lbistag then
                begin
                  liinc := trunc(lsinterv);
                  lsinterv1 := IncDay(lsinterv1, liinc);
                end;
                if lbismonat then
                begin
                  liinc := trunc(lsinterv);
                  lsinterv1 := IncMonth(lsinterv1, liinc);
                end;
                if lbisjahr then
                begin
                  liinc := trunc(lsinterv);
                  lsinterv1 := IncYear(lsinterv1, liinc);
                end;
              end;

              if breport then
              begin
                WriteCMD('Dokument ' + IntToStr(liarcid) + '.' + gdocid +
                  ' wird am ' + DateTimeToStr(lsinterv1) +
                  ' das nchste mal fllig');
              end;

              if lnow < lsinterv1 then
              begin
                if lbistag then
                begin
                  liinc := trunc(lsinterv);
                  lsinterv1 := IncDay(lsinterv1, -liinc);
                end;
                if lbismonat then
                begin
                  liinc := trunc(lsinterv);
                  lsinterv1 := IncMonth(lsinterv1, -liinc);
                end;
                if lbisjahr then
                begin
                  liinc := trunc(lsinterv);
                  lsinterv1 := IncYear(lsinterv1, -liinc);
                end;
              end;
            end;

            // befindet sich heute (lnow) zwischen dem aktivierungsdatum
            // (lsinterv1) und dem kndigungsdatum (lsinterv1+versatz)
            // dann workflow anstossen
            if (lsinterv1 < lnow) and (lsinterv1 + liversatz > lnow) then
            begin
              if not dm_tim.m_q1.FieldByName(lslasttimeactivatedfeld).IsNull
              then
              begin
                if (lsinterv1 < dm_tim.m_q1.FieldByName(lslasttimeactivatedfeld)
                  .AsDateTime) and
                  (lsinterv1 + liversatz > dm_tim.m_q1.FieldByName
                  (lslasttimeactivatedfeld).AsDateTime) then
                begin
                  if breport then
                  begin
                    WriteCMD('Dokument ' + IntToStr(liarcid) + '.' + gdocid +
                      ' wurde schon am ' + dm_tim.m_q1.FieldByName
                      (lslasttimeactivatedfeld).AsString + ' vorgelegt');
                  end;
                  dm_tim.m_q1.Next;
                  // wurde innerhalb des Versatzes vor Kndigungsfrist schon vorgelegt
                  Continue;
                end;
              end;

              if breport then
              begin
                WriteCMD('Dokument ' + IntToStr(liarcid) + '.' + gdocid + ' ist fllig');
              end else
              begin
                dm_tim.m_q4.sql.Text := 'select * from sys_doc where gdocid = ' + gdocid;

                dm_tim.m_q4.Execute;

                if dm_tim.m_q4.RecordCount = 0 then
                begin
                  WriteCMD('Dokument ' + IntToStr(liarcid) + '.' + gdocid + ' konnte nicht gefunden werden');
                  dm_tim.m_q1.Next;
                  Continue;
                end;

                Inc(ifile);
                dm_tim.m_q2.sql.Text := 'select date_format(now(),' + #39 +
                                        '%d%m%Y%H%i%s' + #39 + ') as date';
                dm_tim.m_q2.Execute;
                sFileName := dm_tim.m_q2.FieldByName('date').AsString;
                sFileName := Format(sFileName + '%.6d', [ifile]);
                slWFEnd := TStringList.Create;
                dm_tim.m_q2.sql.Text := 'SELECT displayname, fieldname FROM sys_addfields as ad ' +
                                        'left join sys_addfieldxs as adx on (ad.addfieldid = adx.fieldid) ' +
                                        'where type <> 4 and arcid =' + IntToStr(liarcid) +
                                        ' group by ad.addfieldid, pos order by pos';
                dm_tim.m_q2.Execute;

                slWFEnd.add(IntToStr(liarcid) + '.' + gdocid);
                slWFEnd.add('-2');
                slWFEnd.add('Archivname=' + dm_tim.m_q.FieldByName('arcname').AsString);
                slWFEnd.add('Dokumenttitel=' + dm_tim.m_q4.FieldByName ('docname').AsString);
                slWFEnd.add('DocLoc=' + dm_tim.m_q4.FieldByName('docloc').AsString);
                slWFEnd.add('userid=1');
                slWFEnd.add('Zusatzfelder=' + IntToStr(dm_tim.m_q2.RecordCount));

                dm_tim.m_q2.First;
                while not dm_tim.m_q2.EOF do
                begin

                  slWFEnd.add(dm_tim.m_q2.FieldByName('displayname').AsString + ':=' +
                  dm_tim.m_q1.FieldByName(dm_tim.m_q2.FieldByName('fieldname').AsString).AsString);
                  dm_tim.m_q2.Next;

                end;
                try
                  dm_tim.m_q3.sql.Text := 'SELECT displayname, indexcolumnid, bitmask FROM sys_statefields as ad '
                    + 'left join sys_statefieldxs as adx on (ad.stateid = adx.fieldid) '
                    + 'where arcid =' + IntToStr(liarcid) +
                    ' and ad.stateid <> 1 group by stateid, pos order by pos';
                  dm_tim.m_q3.Execute;
                  // slWFEnd.Add('Zusatzstatus='+ dm_tim.m_q1.FieldByName('DOC_STATE').asstring);
                  slWFEnd.add('Zusatzstatus=' +  IntToStr(dm_tim.m_q3.RecordCount + 1));
                  slWFEnd.add('In Bearbeitung=' + IntToStr(dm_tim.m_q4.FieldByName('docstate_0').AsInteger and 1));

                  shiftamount := 0;
                  while not dm_tim.m_q3.EOF do
                  begin
                    shiftamount := dm_tim.m_q3.recno;
                    colid := dm_tim.m_q3.FieldByName('indexcolumnid').AsString;
                    bitmask := trunc(dm_tim.m_q3.FieldByName('bitmask')
                      .AsFloat);
                    if dm_tim.m_q4.FieldByName('docstate_' + colid).AsInteger and bitmask > 0 then
                      slWFEnd.add(dm_tim.m_q3.FieldByName('displayname').AsString + '=' + IntToStr(1 shl shiftamount))
                    else
                      slWFEnd.add(dm_tim.m_q3.FieldByName('displayname').AsString + '=0');
                    dm_tim.m_q3.Next;
                  end;
                except
                  writeln('Keine Zusatzfelder vorhanden.');
                end;

                slWFEnd.SaveToFile(ClientSpooler + sFileName + '.WFEND');
                WriteCMD('1:' + ClientSpooler + sFileName + '.WFEND');

                slWFEnd.Free;

                // 06.11.2018                          dm_tim.m_q1.FieldByName(lslasttimeactivatedfeld).AsDateTime := Today;  //heute ist das aktivierungsdatum!

                iidx := GetIndexTableID(lslasttimeactivatedfeld);
                if iidx <> -1 then
                begin
                  try
                    dm_tim.m_qupdate.sql.Text := 'UPDATE sys_docidx_' +
                      IntToStr(iidx) + ' SET ' + lslasttimeactivatedfeld + ' = now() WHERE gdocid = ' +
                      dm_tim.m_q1.FieldByName('gdocid').AsString + ';';
                    dm_tim.m_qupdate.Execute;
                  except
                    WriteCMD('Error beim Verarbeiten einzelner Datenstze (iidx <> -1); ' +
                      'dm_tim.m_qupdate.SQL.Text: ' + dm_tim.m_qupdate.sql.Text);
                  end;
                end
                else
                  WriteCMD('Error beim Verarbeiten einzelner Datenstze (iidx = -1) ');
              end;
            end;
          except
            on e: Exception do
            begin
              WriteCMD('Error beim Verarbeiten einzelner Datenstze ' +
                e.Message);
            end;
          end;
          dm_tim.m_q1.Next;
        end;
      except
        on e: Exception do
        begin
          WriteCMD('Error beim Verarbeiten einzelner MWL ' + smwfilename + ' ' + e.Message);
        end;
      end;
    end;
  except
    on e: Exception do
    begin
      writeln('Error: ' + e.Message);
      ExitCode := 1;
    end;
  end;
end;

begin

  writeln('bitfarm Archiv V3  -  Datenbank Check Timer Tool ' + GetFileVersion(ParamStr(0)));
  writeln('(c) 2004-' + cCurYear + ' bitfarm Informationssysteme GmbH');
  if ParamCount < 1 then
  begin
    ExitCode := 1;
    WriteCMD('Fehler: Nicht gengend Parameter angegeben!');
    writeln('         Aufrufen mit: timchecker <con-datei> {report}');
    exit;
  end;

  // check for profil
  if not FileExists(ParamStr(1)) then
  begin
    ExitCode := 5;
    WriteCMD('Fehler: Kann Condatei <' + ParamStr(1) + '> nicht finden.');
    exit;
  end;
  { if not FileAccessable(ParamStr(1)) then
    begin
    exit;
    end; }
  GsProfil := ParamStr(1);
  if ParamCount = 2 then
  begin
    if (ParamStr(2) = 'report') or (ParamStr(2) = '-report') then
    begin
      breport := True;
    end;
  end;

  dm_tim := tdm_tim.Create(nil);
  ExitCode := 0;
  ConnectDB(GsProfil);
  if (ExitCode > 0) then
  begin
    exit;
  end;

  Profile := ExtractFileName(GsProfil);
  Profile := LeftStr(Profile, length(Profile) -4);

  if breport then
    WriteCMD('TimChecker: Report-Modus:');

  checkalarm;
  check4timermngroutine;

  if breport then
  begin
    writeln('');
    WriteCMD('Done...');
  end;

end.
