#!/usr/bin/env python
# -*- coding: latin-1 -*-

import os, sys
import re
import subprocess
import argparse

from bfa_version import *


def commandline_arg(bytestring):
    unicode_string = bytestring
    return unicode_string


svnpath = None
pyfile = None
exefile = None
revision = None
path = os.environ['path']
if not path:
    print(u"Konnte %Path% Variable nicht auflsen")
else:
    paths = path.split(";")
    for path in paths:
        if os.path.exists(os.path.join(path, 'svn.exe')):
            svnpath = os.path.join(path, 'svn.exe')
            print(u"SVN gefunden: %s" % svnpath)
            break

mypath = os.path.split(os.path.abspath(sys.argv[0]))[0]

parser = argparse.ArgumentParser(description=u"bitfarm Archiv Build-Tool, zur Erstellung der Python Executeables", \
                                 epilog=u"Werden keine Parameter bergeben wird nur die bfa_version.py und bfa_version.txt aktualisiert.\n" +
                                        u"Dazu wird per SVN die aktuelle Revision aus dem SVN geholt.\n" +
                                        u"Nach dem Pfad auf die Datei knnen noch beliebige Parameter bergeben werden.\n" +
                                        u"die an PyInstaller weitergereicht werden.")
parser.add_argument("fpath", help=u"Pfad auf die .spec Datei, oder Pfad auf eine .py Datei", nargs='?', type=commandline_arg)

# parser.add_argument("kwargs", help="Optionale Parameter, die an PyInstaller weitergegeben werden", nargs='*', type=commandline_arg)
args, kwargs = parser.parse_known_args()

if args.fpath and os.path.splitext(args.fpath)[1].lower() == '.spec':
    with open(args.fpath, 'r') as f:
        for line in f:
            reg = re.search('Analysis\(\[\'(.+)\'', line)
            if reg and reg.group(1):
                pyfile = reg.group(1)
                print(u"Pythonfile %s" % pyfile)

            reg = re.search('name=\'(.+)\'', line)
            if reg and reg.group(1):
                exefile = reg.group(1)
                print(u"Exefile %s" % exefile)
                break
if args.fpath and os.path.splitext(args.fpath)[1].lower() == '.py':
    pyfile = args.fpath
if not pyfile:
    pyfile = mypath

if not pyfile:
    print(u"Konnte aus der .spec-Datei kein Python-File auslesen")
    sys.exit(1)

print(u"Aktuelle Version %s" % version)

# jetzt der svnaufruf
pyfile = os.path.abspath(pyfile)
print(u"Pythonfile Pfad %s" % pyfile)
subargs = [svnpath, 'info', pyfile]
# p = subprocess.Popen(args)
svn = subprocess.check_output(subargs).decode('ansi')
print(svn)
reg = re.search(r'Revision: (\d+)', svn)
if reg and reg.group(1):
    revision = reg.group(1)
    print(u"Revision vom Repository gelesen %s" % revision)

if not revision:
    print(u"Revision konnte nicht ausgelesen werden")
else:
    version = version[:version.rfind('.')] + '.%s'
    version = version % revision
    version_ext = version.replace('.',', ')
    print(u"Neuen Versionsstring erstellt: %s" % version)
    with open('bfa_version.py', 'w') as f:
        f.write("version = '%s'" % version)

    info = """VSVersionInfo(
              ffi=FixedFileInfo(
                filevers=(%s),
                prodvers=(3, 6, 1, 0),
                mask=0x3f,
                flags=0x0,
                OS=0x40004,
                fileType=0x1,
                subtype=0x0,
                date=(0, 0)
                ),
              kids=[
                StringFileInfo(
                  [
                  StringTable(                    u'040904B0',
                    [StringStruct(u'CompanyName', u'bitfarm GmbH'),
                    StringStruct(u'FileVersion', u'%s'),
                    StringStruct(u'LegalCopyright', u'\\xa9 bitfarm GmbH. All rights reserved.'),
                    StringStruct(u'OriginalFilename', u'%s'),
                    StringStruct(u'ProductName', u'bitfarm Archiv v36'),
                    StringStruct(u'ProductVersion', u'%s')])
                  ]),
                VarFileInfo([VarStruct(u'Translation', [1031, 1200])])
              ]
            )""" % (version_ext, version, exefile, version)

    with open('bfa_version.txt', 'wb') as f:
        f.write(info.encode())

if not args.fpath:
    print(u"Keine Datei bergeben.Beende...")
    sys.exit(1)

if not os.path.exists(args.fpath):
    print(u"Datei %s nicht vorhanden" % args.fpath)
    sys.exit(1)

subargs = ['PyInstaller', '-y', '--clean', args.fpath]
if kwargs:
    subargs.extend(kwargs)
p = subprocess.Popen(subargs)
p.wait()


