#!/usr/bin/env python
# -*- coding: utf-8 -*-

import socket
import gettext
import bitfarm_doc
import bitfarm_xml as bfaxml
import bitfarm_workflow
from bitfarm_utils import get_fileowner
from bitfarm_files import inilesen

import ConfigParser, codecs
import datetime, time
import os, Queue, shutil, sys, threading
import random
import hashlib, logging

import gc
from collections import defaultdict


# TODO: Das muss aus der Config ausgelesen werden (unvollständig!)

THREADED=False # Jeden Ordner in eigenem Thread überwachen?

DOCTYPES = (".jpg",".pdf", ".ps", ".tif", ".tiff", ".doc", ".docx", ".xls", ".xlsx", ".ppt", ".pptx", ".xls", ".txt", ".bmp", ".xml")
CMDTYPES = ('.kom', '.wfend', '.move',  '.bra', ".fend", ".bfa", ".movx")
EXTRATYPES = (".ftx", ".vtx", ".slw", ".swd", ".iev")
JOBTYPES = ('.job', '.bfaxml')

# benötigte Variablen instanzieren
paths_to_watch=[]
profile_names = []
profiles={}
path_profiles = {}

# Liste für Dateien in Arbeit
inprogress = []

try:
    trans = gettext.translation("bfaCollector", "locale", ['en'],  fallback = True)
    trans.install()
except:
    print(u'Keine Übersetzung gefunden/no translation found')
    _ = lambda x: x
else:
    _ = trans.ugettext


class MyFormatter(logging.Formatter):
  def __init__(self, fmt=None, datefmt=None, encoding='windows-1250'):
    logging.Formatter.__init__(self, fmt, datefmt)
    self.encoding = encoding
    # 'windows-1250'
  def formatException(self, ei):
    r = logging.Formatter.formatException(self, ei)
    if type(r) in [str]:
      r = r.decode(self.encoding, 'replace') # Convert to unicode
    return r

  def format(self, record):
    t = record
    try:
        t = logging.Formatter.format(self, record)
    except:
        return t
    if type(t) in [unicode]:
      t = t.encode(self.encoding, 'replace')
    if type(t) in [str]:
        t = t.decode(self.encoding)
#        t = t.decode('utf8')
    return t


def shasum(filepath, blocksize = 1024*1024):
    h = hashlib.sha1()
    f = open(os.path.expandvars(filepath), "rb")
    try:
        while True:
            block = f.read(blocksize)
            if not block:
                break
            h.update(block)
    finally:
        f.close()
    return h.hexdigest()


def schnittmenge(definition):
    liste = definition[0]
    result = []
    for i in liste:
        for i2 in definition:
            if i not in i2:
                if i in result: result.remove(i)
                break
            if i in i2 and i in result: continue
            if i not in result: result.append(i)
    return result

def runcmd(filepath):
    #TODO: Aktion für Kommandodateien implementieren
    if os.path.splitext(filepath)[1].lower()==".bra":
        log.debug(_(u"bra File verarbeiten!"))
        os.remove(filepath)
    elif os.path.splitext(filepath)[1].lower()==".move":
        log.debug(_(u"move File verarbeiten!"))
        os.remove(filepath)
    elif os.path.splitext(filepath)[1].lower()==".wfend":
        log.debug(_(u"wfend File verarbeiten!"))
        os.remove(filepath)

def do_import_from_file(result,  sock):
#    xmlfile = result['filepath']+".xml"
#    xmlfile = open(xmlfile, 'w')
#    xmlfile.write(bitfarm_xml.object_to_xml(result['doc']))
#    xmlfile.close()
    global inprogress
    doc = result['doc']
    log.info(_(u'starte Import von Datei %s') %(doc.srcloc))
    if bfaProc.create_tempname(doc):
        try:
            shutil.move(doc.srcloc, os.path.expandvars(doc.tempname) + os.path.splitext(doc.srcloc)[1])
            log.info(_(u'Datei %s nach %s verschoben') %(doc.srcloc, doc.tempname + os.path.splitext(doc.srcloc)[1]))
        except:
            log.exception(_(u'Fehler beim Verschieben in die Archivablage'))
        else:
            inprogress.remove(result['filepath'])
            doc.srcloc = doc.tempname + os.path.splitext(doc.srcloc)[1]
            bfaProc.write(doc)

            if len(result['iev']) > 0:
                for iev in result['iev']:
                    ievfile = os.path.expandvars(doc.tempname) + iev[len(os.path.splitext(result['filepath'])[0]):] 
                    try:
                        shutil.move(iev, ievfile)
                        log.info(_(u'IEV-Datei %s nach %s verschoben') %(iev, ievfile))
                    except:
                        log.exception(_(u'Fehler beim Verschieben einer IEV-Datei in die Archivablage'))

            wflows = bfaWflow.get_workflow(profile = result['profile'], wf_type = 0, wf_trigger = 0, arcid = doc.arcid, use_default = True)

            if wflows is None or len(wflows) == 0:
                wflows = bfaWflow.get_workflow(profile = result['profile'],  wf_type = 0,  wf_trigger = 0)

            if wflows is None:
                log.error(_(u'Kein Default-Workflow vorhanden. Datenbank kaputt?'))

            if len(wflows) == 0:
                log.error(_(u'Kein Default-Workflow vorhanden. Datenbank kaputt?'))
            
            for wflow in wflows:
                if wflow.tasks is not None:
                    log.debug(_(u'Dokument wird mit Workflow [%s] %s übergeben') %(wflow.wf_id, wflow.wf_name))
                    doc.tasks = wflow.tasks
                    req = bitfarm_doc.bfaReq()
                    req.data = doc
                    xmlstr = bfaxml.object_to_xml(req)
                    if xmlstr:
                        success = False
                        tried = 1
                        while not success:
                            try:
                                log.debug(con.main.profile)
                                log.debug(sock)
                                sock.sendall(xmlstr)

                                nachricht =''
                                while nachricht[-9:] != '</bfaReq>':
                                    nachricht += sock.recv(1024)

                                log.debug(nachricht)
                            except:
                                log.debug(_(u"Verbindung weg, versuche reconnect"))
                                if tried > 3:
                                    log.error(_(u'Mehr als 3 Versuche benötigt. Alarm!!'))
                                    break
                                else:
                                    tried += 1

                                    sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
                                    sock.connect((con.main.archiveserver, con.main.archiveport))
                                    log.debug(sock)
                            else:
                                success = True

                    doc = None
                    req = None
                    #time.sleep(float(delay))
                    xmlstr = ''
                    break   # wir übergeben das Dokument mit dem ersten gefundenen Workflow, dann verlassen wir die schleife


class Pop3Watcher(threading.Thread):

    def __init__(self, popconfig, result_queue):
        self.config = popconfig
        self.queue = result_queue
        threading.Thread.__init__(self)
        self.start()

    def run(self):
        while 1:
            time.sleep(60)


class SafeWatcher(threading.Thread):
    global inprogress
    def __init__(self, paths, result_queue, con):
        self.paths_to_watch = paths
        self.queue = result_queue
        self.bfaProc = bitfarm_doc.BitfarmDocProcessing(con)
        threading.Thread.__init__(self)
        self.start()

    def run(self):
        running = 1
        while running:
            for pth in self.paths_to_watch:
                for dirpath, dirnames, filenames in os.walk(unicode(pth)):
                    #before=defaultdict(int)

                    for f in filenames:
                        tmppath=os.path.join(dirpath,f)
                        if tmppath in inprogress:
                            continue
                        templatename = ''
                        if os.path.isfile(tmppath):
                            log.debug("neue Datei %s gefunden" %tmppath)
                            #config = path_profiles[pth]['config']
                            # globalblacklistextensions prüfen
                            #if os.path.splitext(f)[1].lower() <> "" and os.path.splitext(f)[1].lower() in config.get('Scripts', 'globalblacklistextensions'):
                            if os.path.splitext(f)[1].lower() <> "" and os.path.splitext(f)[1].lower() in path_profiles[pth]['config']['scripts'].globalblacklistextensions:
                                log.debug("Datei %s wird verworfen (blacklist)" %tmppath)
                                # TODO: Hier besser Garbage als einfach löschen
                                os.remove(tmppath)
                                for root, dirs, files in os.walk(dirpath):
                                    for fn in files:
                                        tmpfile = os.path.join(dirpath, fn)
                                        # gleichnamige Dateien finden und entfernen
                                        # TODO: glob.glob benutzen
                                        if os.path.splitext(fn)[0][0:len(os.path.splitext(os.path.basename(tmppath))[0])] == os.path.splitext(os.path.basename(tmppath))[0]:
                                            os.remove(tmpfile)

                            # acceptnoextension prüfen
                            elif os.path.splitext(f)[1].lower() == "" and not path_profiles[pth]['config']['scripts'].globalacceptnoextension:
                                log.debug("Datei %s wird verworfen (leere extension nicht gestattet)" %tmppath)
                                # TODO: Hier besser Garbage als einfach löschen
                                os.remove(tmppath)
                                for root, dirs, files in os.walk(dirpath):
                                    for fn in files:
                                        tmpfile = os.path.join(dirpath, fn)
                                        # gleichnamige Dateien finden und entfernen
                                        if os.path.splitext(fn)[0][0:len(os.path.splitext(os.path.basename(tmppath))[0])] == os.path.splitext(os.path.basename(tmppath))[0]:
                                            os.remove(tmpfile)
                            else:
                                if os.path.splitext(f)[1].lower() in CMDTYPES:
                                    #TODO: Task für das Kommando erzeugen
                                    runcmd(tmppath)
                                    pass
                                elif os.path.splitext(f)[1].lower() in JOBTYPES:
                                    pass
                                elif os.path.splitext(f)[1].lower() in EXTRATYPES:
                                    pass
                                else: # DOCTPYE oder unbekannt
                                    go = None
                                    profil = path_profiles[pth]['profil']
                                    iev = []
                                    
                                    try:
                                        # TODO: delayedscannerimport abbilden
                                        #if config.get('Import', 'delayedscannerimport').lower()=='true':
                                            #print "warte 1 Sekunde wg. delayedscannerimport"
                                            #time.sleep(1)
                                        testopen = open(tmppath, 'rb')
                                        testopen.close()
                                        testopen = None
                                        go = True
                                    except:
                                        go = None

                                    if go:
                                        stats = os.stat(tmppath)
                                        sha = shasum(tmppath)

#                                        randname = str(random.randint(1, 999999))+os.path.splitext(tmppath)[1]
#                                        while os.path.isfile(os.path.join(sammelverzeichnis, randname)):
#                                            randname = str(random.randint(1, 999999))+os.path.splitext(tmppath)[1]
#                                        try:
#                                            log.debug("importiere Datei nach %s" % os.path.join(sammelverzeichnis, randname))
#                                            shutil.move(tmppath, os.path.join(sammelverzeichnis, randname))
#                                        except:
#                                            log.error("Datei %s konnte nicht verschoben werden!" % tmppath)
#                                            break
#                                        randbase = os.path.splitext(randname)[0]

                                        doc = bitfarm_doc.BitfarmDocument()
                                        self.bfaProc.create(doc)
                                        doc.origin = dirpath
                                        doc.filename = f
                                        doc.srcloc = tmppath
                                        doc.sha = sha
                                        doc.profile = profil

                                        # Nach zum Dokument gehörenden gleichnamigen Dateien suchen
                                        log.debug('Suche gleichnamige Dateien (Metadaten)')
                                        for root, dirs, files in os.walk(dirpath):
                                            for fn in files:
                                                tmpfile = os.path.join(dirpath, fn)

                                                # gleichnamige Dateien finden
                                                if os.path.splitext(fn)[0][0:len(os.path.splitext(os.path.basename(tmppath))[0])] == os.path.splitext(os.path.basename(tmppath))[0]:

                                                    # Schlagworte importieren
                                                    if os.path.splitext(os.path.basename(fn))[1].lower() in (".slw", ".swd"):
                                                        log.debug('Schlagwortdatei zum Dokument gefunden')
                                                        try:
                                                            slwd = codecs.open(tmpfile, 'r', encoding="windows-1252")
                                                            doc.tags = slwd.read().split('\n')
                                                            log.debug('Schlagworte hinzugefügt')
                                                            slwd.close()
                                                            os.remove(tmpfile)
                                                        except:
                                                            log.error('Schlagwort lesen fehlgeschlagen')

                                                    # Volltext übernehmen
                                                    elif os.path.splitext(os.path.basename(fn))[1].lower() in (".vtx", ".ftx"):
                                                        log.debug('Volltextdatei zum Dokument gefunden')
                                                        try:
                                                            vtxd = codecs.open(tmpfile, 'r', encoding="windows-1252")
                                                            doc.ftx.text = vtxd.read()
                                                            log.debug('Volltext hinzugefügt')
                                                            vtxd.close()
                                                            os.remove(tmpfile)
                                                        except:
                                                            log.error('Volltext lesen fehlgeschlagen')

                                                    # vorhandenen Job importieren
                                                    elif os.path.splitext(os.path.basename(fn))[1].lower() == ".job":
                                                        log.debug('Jobdatei zum Dokument gefunden')
                                                        try:
                                                            self.bfaProc.read_from_file(doc, tmpfile)
                                                            log.debug('Job gelesen, doc-Objekt aktualisiert')
                                                            os.remove(tmpfile)
                                                        except:
                                                            log.error('Job lesen fehlgeschlagen')

                                                    # mitgelieferte Annos importieren
                                                    elif os.path.splitext(os.path.basename(fn))[1].lower() == ".iev":
                                                        log.debug('Annotation zum Dokument gefunden')
                                                        iev.append(tmpfile)
                                                        #TODO: iev-Stream mitgeben
                                                        # erstmal übergeben wir aber die Dateien, da v36 anfangs Dateibasiert bleibt
                                                    else:
                                                        log.warning("unbekannte Datei %s gefunden" %tmppath)
                                        # Archiv ermitteln, falls nicht per job bekannt

#                                        if doc.archive is None:
                                        if path_profiles[pth]['typ'] == 'IMPORT':
#                                            log.debug('ermittle Archiv')
                                            #if config.get('Import','readarchivfromfolder')=="true":
                                            if path_profiles[pth]['config']['import'].readarchivfromfolder:
                                                templatename = os.path.basename(os.path.split(tmppath)[0]).lower()
                                                #TODO: templates müssen zur Laufzeit ermittelt werden,
                                                # sonst müsste nach jeder Änderung an Templates der Collector neu gestartet werden
    #                                                if profiles[profil]['templates'].has_key(templatename):
    #                                                    doc.archive=profiles[profil]['templates'][templatename].get('Archiv', 'Name')
    #                                                    log.debug("doc.archiv ermittelt: %s (fromfolder)"%doc.archive)
                                            elif path_profiles[pth]['config']['import'].readarchivfromfilename:
                                                templatename = os.path.splitext(os.path.split(tmppath)[1])[0].lower()
                                                #TODO: templates müssen zur Laufzeit ermittelt werden,
                                                # sonst müsste nach jeder Änderung an Templates der Collector neu gestartet werden
    #                                                if profiles[profil]['templates'].has_key(templatename):
    #                                                    doc.archive=profiles[profil]['templates'][templatename].get('Archiv', 'Name')
    #                                                    log.debug("doc.archiv ermittelt: %s (fromfilename)"%doc.archive)
                                        if templatename:
                                            self.bfaProc.sortto(doc, templatename)


                                        if doc.archive == None:
                                            #unverteilt des Profils nehmen
                                            doc.archive = con[profil].undistributed
                                        #doc.archive = "Entwicklung"
                                        #self.bfaProc.sortto(doc, "Entwicklung")
                                        # User ermitteln, falls nicht per job bekannt
                                        if doc.user is None or doc.user == "" or doc.user == 'System':
                                            log.debug('ermittle Benutzer')
                                            if path_profiles[pth]['config']['import'].readuserfromfileowner:
                                                doc.user = get_fileowner(tmppath)
                                                log.debug("doc.user from fileowner: %s" %doc.user)
                                            elif path_profiles[pth]['config']['import'].readuserfromfilename:
                                                doc.user = os.path.splitext(os.path.split(tmppath)[1])[0].lower()
                                                log.debug("doc.user from fromfilename: %s" %doc.user)
                                            elif path_profiles[pth]['config']['import'].readuserfromfolder:
                                                doc.user = os.path.basename(os.path.split(tmppath)[0]).lower()
                                                log.debug("doc.user from fromfolder: %s" %doc.user)
#                                        if doc.user == None or doc.user == "":
#                                            doc.user = "System"

#                                        doc.date = datetime.datetime.now().replace(microsecond = 0)
                                        result = {'doc':doc, 'profile':profil, 'filepath':tmppath, 'stats':stats, 'importpath':pth, 'oripath':tmppath, 'iev':iev}
                                        if result:
                                            inprogress.append(tmppath)
                                            log.debug(result)
                                            self.queue.put(result)


            time.sleep(1)


if __name__ == '__main__':

    # ermitteln der Umgebung
    scriptname = os.path.basename(sys.argv[0])
    if sys.platform== 'win32':
        mypath = os.path.split(os.path.abspath(sys.argv[0]))[0]
        try:
            bfapath = os.environ['bitfarm-archiv']
        except:
            bfapath = mypath
    else:
        mypath = os.getcwd()
    fullpath = os.path.join( mypath , scriptname)

    # Logging starten
    logging.config.fileConfig(os.path.join(mypath, "bfaCollector.ini"))

    #log = logging.getLogger("Main.collector")
    log = logging.getLogger("Main")
    log.setLevel(log.handlers[0].level)
    if mypath.lower() == os.getcwd().lower():
        # create console handler and set level to debug
        ch = logging.StreamHandler(sys.stdout)
        level = 'debug'
        levels = {'debug' : logging.DEBUG,
                        'info' : logging.INFO,
                        'warning' : logging.WARNING,
                        'error' : logging.ERROR,
                        'critical' : logging.CRITICAL}
        if len(sys.argv) > 1:
            for arg in sys.argv:
                if '-log:' in arg:
                    level = arg[5:].lower()
                    break

        ch.setLevel(levels[level])
        formatter = MyFormatter('%(name)s-%(levelname)s:  %(message)s')
    #            formatter = MyFormatter('%(name)s -- %(levelname)s -- %(message)s', encoding='cp852')
    #            formatter = logging.Formatter('%(name)s -- %(levelname)s -- %(message)s')

        ch.setFormatter(formatter)
        ch.args = sys.stdout
        log.addHandler(ch)

    log.debug('starte bfaCollector')

    # Die Import-Pfade + Clientspooler-Pfade der in sys.argv[2] angegebenen Profile werden zusätzlich überwacht
    try:
        profile_names.extend(sys.argv[1].split(','))
    except:
        pass

    # Übergebenes Profil (Main) ermitteln
    try:
        con = bitfarm_doc.BitfarmConnections(profile_names)
        con.create_db_engine()
        con.read_ini()
        sammelverzeichnis = os.path.join(con.main.serverprogram, 'collected')
        if not os.path.isdir(sammelverzeichnis):
            os.mkdir(sammelverzeichnis)
    except:
        log.exception(_(u"Hauptprofil konnte nicht gelesen werden, beende"))
        sys.exit(1)


    bfaProc = bitfarm_doc.BitfarmDocProcessing(con)
    bfaWflow = bitfarm_workflow.BitfarmWorkflowProcessing(con)

    log.info(_(u"Verbinde mit Archivierungsserver auf %s:%s" %(con.main.archiveserver, con.main.archiveport)))
    try:
        sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        sock.connect((con.main.archiveserver, con.main.archiveport))
    except:
        log.exception(_(u"Konnte keine Verbindung aufbauen"))
        sys.exit(2)
    else:
        log.debug(sock)


    # Ermitteln aller zu überwachenden Verzeichnisse
    for profil in profile_names:
        profiles[profil]={}

        # Übergabepfad des Profils hinzufügen
        if os.path.ismount(con[profil].uncclientspooler):
            if con[profil].uncclientspooler not in paths_to_watch:
                paths_to_watch.append(con[profil].uncclientspooler)
        else:
            if con[profil].uncclientspooler not in paths_to_watch:
                paths_to_watch.append(con[profil].uncclientspooler)

        path_profiles[con[profil].uncclientspooler]={}
        path_profiles[con[profil].uncclientspooler]['profil'] = profil
        path_profiles[con[profil].uncclientspooler]['typ'] = 'UEBERGABE'
        path_profiles[con[profil].uncclientspooler]['config'] = con[profil].ini

        #TODO: templates müssen zur Laufzeit ermittelt werden,
        # sonst müsste nach jeder Änderung an Templates der Collector neu gestartet werden
#        profiles[profil]['templates']={}
#        for dirpath, dirnames, filenames in os.walk(con[profil].templates):
#            for f in filenames:
#                if os.path.splitext(f)[1].lower()==".tpl":
#                    config = ConfigParser.SafeConfigParser(allow_no_value=False)
#                    config.read(os.path.join(con[profil].templates, f))
#                    profiles[profil]['templates'][os.path.splitext(f)[0].lower()]=config

        # Import-Pfade aus Config
    #    config = ConfigParser.SafeConfigParser(allow_no_value=False)
    #    config.read(os.path.join(con[profil].serverprogram, 'scripts.ini'))
    #    import_config=config.options('Import')
    for profile in con:
        for d in profile.ini['import'].__dict__.values():
            if type(d) is str:
                if os.path.isdir(d) and d not in paths_to_watch:
                    paths_to_watch.append(d)
                    if not path_profiles.has_key(d):
                        path_profiles[d]={}
                    #path_profiles[d]['config']= config
                    path_profiles[d]['config']= con[profil].ini
                    path_profiles[d]['profil']= profile.profile
                    path_profiles[d]['typ']= 'IMPORT'





    # Hier alle Watcher-Threads starten.
    # Verhalten der Watcher:
    # Abholen des Dokuments (mit allen Metadateien)
    # Verschieben des Dokuments ins Sammelverzeichnis
    # Erzeugen eines BitfarmDocument-Objekts
    # Doc-Objekt an die Queue (self.queue der Collector Instanz) übergeben

    stopsignal=None
    queue = Queue.Queue()

    # Thread zur Überwachung eines Pop3-Kontos starten
    popconfig=None
#        if os.path.isfile('bfapop3.ini'):
#            popconfig = ConfigParser.SafeConfigParser(allow_no_value=False)
#            popconfig.read('bfapop3.ini')
#            Pop3Watcher(popconfig, self.queue)

    # Thread(s) zur Überwachung der Uebergabe- und der Import-Ordner starten
    if THREADED:
        for path in paths_to_watch:
            SafeWatcher([path], queue, con)
    else:
        SafeWatcher(paths_to_watch, queue, con)

    if popconfig:
        log.debug(_(u"\nÜberwachtes E-Mail-Konto:\n%s") %(popconfig.get('Main', 'POP3 Server')))

    log.debug(_(u"Überwachte Verzeichnisse:\n%s\n")%str(paths_to_watch))


    # Endlosschleife zum Abarbeiten der Queue
    while not stopsignal:
        try:
            #gc.collect()
            ret = do_import_from_file(queue.get(True, 10), sock)
        except Queue.Empty:
            pass

    log.info(_(u"bfaCollector beendet"))
    sys.exit(0)




