# -*- encoding: utf-8 -*-
from ctypes import windll, c_char_p, c_uint32, c_void_p, byref, \
    create_string_buffer, Structure, sizeof, POINTER
from ctypes import *
import array
import cherrypy
import sys
import time
from bfaHttpAuth import AuthController, require
import io
# from email import *
import base64
# from email.mime import message, image, text, audio, base, multipart
import json
import codecs
import inspect
# import numpy as np
import numpy
import cv2
import pprint
# import magic
import logging
import logging.config
import os
import subprocess
import traceback
import win32service
import win32serviceutil
import win32api
import win32file
import win32con
import win32event
import win32evtlogutil
import win32timezone
import winerror
import os
import sys
import string
import time
import servicemanager
import socket
import psutil
import glob
import datetime
import tempfile
import shutil
from cherrypy.lib import sessions
import decimal
from cherrypy._cpcompat import ntou
from cherrypy._json import decode as json_decode


__version__ = "3.6.2.11"


SERVERINFO = {"version": __version__}


class MyJsonEncoder(json.JSONEncoder):
    def default(self, o):
        if isinstance(o, decimal.Decimal):
            return str(float(o))
        elif isinstance(o, set):
            return list(o)
        elif isinstance(o, datetime.datetime):
            return o.strftime('%Y-%m-%d %H:%M:%S')
        return super(MyJsonEncoder, self).default(o)

    def iterencode(self, value):
        # Adapted from cherrypy/_cpcompat.py
        for chunk in super().iterencode(value):
            yield chunk.encode("utf-8")


json_encoder = MyJsonEncoder()


def json_handler(*args, **kwargs):
    # Adapted from cherrypy/lib/jsontools.py
    value = cherrypy.serving.request._json_inner_handler(*args, **kwargs)
    return json_encoder.iterencode(value)


def json_in_processor(entity):
    """Read application/json data into request.json."""
    if not entity.headers.get(ntou('Content-Length'), ntou('')):
        raise cherrypy.HTTPError(411)

    body = entity.fp.read()
    try:
        cherrypy.serving.request.json = json_decode(body.decode('utf-8'))
        cherrypy.serving.request.json_error = False
        cherrypy.serving.request.json_errormsg = None

    except Exception as e:
        cherrypy.serving.request.json_error = True
        cherrypy.serving.request.json_errormsg = str(e)
        serverlogger.error("json-decode error. raw data:\n%s" % body)
        serverlogger.error(str(e))

    # with cherrypy.HTTPError.handle(ValueError, 400, 'Invalid JSON document'):


# try:
#     import Image
# except:
#     from PIL import Image


class IpLogger(logging.LoggerAdapter):
    def process(self, msg, kwargs):
        return '(%d),%s' % (self.extra['name1'](1, 1000), msg), kwargs


MAXINPUTFILESIZE = 200 * 1024 * 1024  # 200MB


logging_conf_string = r"""[loggers]
keys=root, bfaserver, mycherrypy.access, mycherrypy.error, realclientlogger

[logger_realclientlogger]
level=NOTSET
handlers=realclientlogger_rotfilehandler
qualname=realclientlogger

[logger_root]
level=NOTSET
handlers=server_streamhandler, server_rotfilehandler


[logger_bfaserver]
handlers=server_streamhandler,server_rotfilehandler
qualname=serverlogger

[logger_mycherrypy.access]
level=NOTSET
handlers=cherrypy_access_rotfilehandler
qualname=cherrypy.access

[logger_mycherrypy.error]
level=NOTSET
handlers=cherrypy_error_rotfilehandler
qualname=cherrypy.error

[handlers]
keys=server_streamhandler, server_rotfilehandler, cherrypy_error_rotfilehandler, cherrypy_access_rotfilehandler, realclientlogger_rotfilehandler

[formatters]
keys=server_formatter, cherrypy_formatter, realclientlogger_formatter

[formatter_realclientlogger_formatter]
format=%(asctime)s - %(remoteip)s - %(message)s
datefmt=
class=logging.Formatter

[formatter_cherrypy_formatter]
format=%(asctime)s - %(levelname)s - %(message)s
datefmt=
class=logging.Formatter

[formatter_server_formatter]
format=%(asctime)s - %(remoteip)s - %(levelname)s - %(message)s
datefmt=
class=logging.Formatter

[handler_client_streamhandler]
class=StreamHandler
level=NOTSET
formatter=client_formatter
args=(sys.stdout,)

[handler_server_streamhandler]
class=StreamHandler
level=NOTSET
formatter=server_formatter
args=(sys.stdout,)


[handler_server_rotfilehandler]
class=handlers.TimedRotatingFileHandler
level=NOTSET
formatter=server_formatter
args=(r"logs\bfa_http.log", "midnight", 1, 14)

[handler_cherrypy_error_rotfilehandler]
class=handlers.TimedRotatingFileHandler
level=NOTSET
formatter=cherrypy_formatter
args=(r"logs\bfa_http_cherrypy.log", "midnight", 1, 14)

[handler_cherrypy_access_rotfilehandler]
class=handlers.TimedRotatingFileHandler
level=NOTSET
formatter=cherrypy_formatter
args=(r"logs\bfa_http_cherrypy_access.log", "midnight", 1, 14)

[handler_realclientlogger_rotfilehandler]
class=handlers.TimedRotatingFileHandler
level=NOTSET
formatter=realclientlogger_formatter
args=(r"logs\bfa_http_client.log", "midnight", 1, 14)
"""


class IpFilter(logging.Filter):
    def filter(self, record):
        record.remoteip = cherrypy.request.headers.get(
            "X-REAL-IP", cherrypy.request.remote.ip)
        return True


class TimingTool(cherrypy.Tool):
    def __init__(self):
        cherrypy.Tool.__init__(self, 'before_handler',
                               self.start_timer,
                               priority=95)

    def _setup(self):
        cherrypy.Tool._setup(self)
        cherrypy.request.hooks.attach('before_finalize',
                                      self.end_timer,
                                      priority=5)

    def start_timer(self):
        cherrypy.request._time = time.time()

    def end_timer(self):
        # print cherrypy.request
        try:
            duration = time.time() - cherrypy.request._time
            #serverlogger.error("%s" % str(cherrypy.request.args))
            #serverlogger.error("%s" % dir(cherrypy.request))
            serverlogger.info("Page handler took %.4f (%s)" %
                              (duration, str(cherrypy.request.args[0])))
        except:
            pass


cherrypy.tools.timeit = TimingTool()


class ApiController():

    exposed = True

    def __init__(self):
        pass

    # @profile
    @require()
    @cherrypy.tools.json_out(handler=json_handler)
    @cherrypy.tools.timeit()
    def GET(self, *args, **kwargs):
        headers = cherrypy.response.headers
        headers['X-Frame-Options'] = 'DENY'
        headers['X-XSS-Protection'] = '1; mode=block'
        headers['Content-Security-Policy'] = "default-src 'self';"
        try:
            uuid = cherrypy.session['bfaserverclient'].uuid
        except:
            uuid = "nouuid"
        serverlogger.info("%s - incoming GET request on url %s" %
                          (uuid, args[0]))
        serverlogger.info("%s - GET args: %s" % (uuid, str(args)))
        serverlogger.info("%s - GET kwargs: %s" % (uuid, str(kwargs)))
        if len(args) > 0:
            url = args[0]
        if url.lower() in ("preview", "getpng"):
            url = "preview"
            func = "getImg"
        elif url.lower() == "getori":
            func = "getOri"
        elif url.lower() == "gettif":
            func = "getPreview"
        elif url.lower() in ("gdocidstore", "getdoc"):
            func = "getDoc"
        elif url.lower() == "gettext":
            func = "getTxt"
        elif url.lower() == "getusers":
            func = "getReadUsers"
        elif url.lower() == "getgroups":
            func = "getReadGroups"
        elif url.lower() == "getarctree":
            func = "getReadArchives"
        elif url.lower() == "getaddfields":
            func = "getReadAddfields"
        elif url.lower() == "getlastmodified":
            func = "getLastModified"
        elif url.lower() in ("getwvl", "getresub"):
            func = "getWvl"
        elif url.lower() == "gethistory":
            func = "getHistory"
        elif url.lower() in ("getdocedit", "editdoc"):
            func = "getEdit"
        elif url.lower() in ("getdoccancel", "canceldoc"):
            func = "getCancel"
        elif url.lower() in ("saveholiday", "getsaveholiday"):
            func = "getSaveHoliday"
        elif url.lower() == "getholiday":
            func = "getHoliday"
        elif url.lower() in ("deleteholiday", "getdeleteholiday"):
            func = "getDeleteHoliday"
        elif url.lower() in ("modifyholiday", "getmodifyholiday"):
            func = "getModifyHoliday"
        elif url.lower() == "getbookmarks":
            func = "getBookmarks"
        elif url.lower() == "executebookmark":
            func = "getExecuteBookmarks"
        else:
            serverlogger.error("%s - unknown url %s" % (uuid, url))
            cherrypy.response.status = 404
            return {'data': {}, 'errorcode': 404, 'message': 'unknown url', 'result': False}

        # lookup client functions
        clientmethodd = cherrypy.session['bfaserverclient'].clientmethodd
        # clientmethods = cherrypy.session['bfaserverclient'].clientmethods
        if func in list(clientmethodd.keys()):
            callfunc = clientmethodd[func]
            serverlogger.info(
                "%s - client-method for url %s: %s" % (uuid, url, func))
        else:
            callfunc = None
            serverlogger.error(
                "%s - no client-method found for url %s: %s" % (uuid, str(args[0])))
            cherrypy.response.status = 404
            return {'data': {}, 'errorcode': 500, 'message': 'no client-method found', 'result': False}
            return
            # return [False, 404, "not client methodfound"]

        if callfunc:
            cargs, varargs, keywords, defaults, _, _, _ = inspect.getfullargspec(
                clientmethodd[func])
            cargs.remove("self")
            ccargs = [x for x in cargs]

            # mix with delivered kwargs and defaults:
            myargs = {}
            optargs = {}
            if defaults is None:
                defaults = ()
            gap = len(cargs)-len(defaults)
            for index, value in enumerate(defaults):
                cargs[index+gap] = (cargs[index+gap], value)
            for element in cargs:
                if type(element) != tuple:
                    key = element
                    value = ""
                else:
                    key = element[0]
                    value = element[1]
                if key in kwargs:
                    value = kwargs[key]
                myargs[key] = value

            # check for missing args
            if sorted(myargs.keys()) != sorted(ccargs):
                cherrypy.response.status = 400
                serverlogger.error("%s - argument error" % (uuid))
                return {'data': {}, 'errorcode': 500, 'message': 'no client-method found', 'result': False}
                # return
                # return [False, 400, "argument error"]
            optargs = {}
            for key in kwargs:
                if key not in myargs:
                    optargs[key] = kwargs[key]
            # handle value casting
            if func in cherrypy.session["bfaserverclient"].args:
                castdict = cherrypy.session["bfaserverclient"].args[func]
                for key, value in list(myargs.items()):
                    if value is not None:
                        try:
                            myargs[key] = castdict[key](value)
                        except Exception as e:
                            if type(value) in (str, str):
                                logval = value[:100]
                            else:
                                logval = value
                            serverlogger.error(
                                "%s - %s casting error (value %s,type %s) %s" % (uuid, key, logval, type(value), str(e)))

                            cherrypy.response.status = 422
                            return {'data': {}, 'errorcode': 422, 'message': 'casting error on key %s' % key, 'result': False}
                            # return "False"
                            # return [False, 400, "argument casting error"]

            # asjson=True wird vom http-Server grundsätzlich mitgeschickt, egal, ob der Client den Parameter geliefert hat oder nicht
            if "asjson" in ccargs:
                myargs["asjson"] = True
            serverlogger.info("%s - calling %s with args %s" %
                              (uuid, str(callfunc), str(myargs)))

            try:
                callresult = callfunc(**myargs)
            except socket.error as e:
                serverlogger.error("%s - socket exception %s" % (uuid, str(e)))
                cherrypy.response.status = 503
                # cherrypy.session["bfaserverclient"].logout()

                sess = cherrypy.session
                username = sess.get(SESSION_KEY, None)

                if username:
                    sess[SESSION_KEY] = None
                    cherrypy.session['usr_id'] = None
                    cherrypy.session['_cp_username'] = None
                    cherrypy.session["bfaserverclient"].logout()
                    cherrypy.session["bfaserverclient"] = None
                    if username:
                        cherrypy.request.login = None
                        serverlogger.info("%s logged out" % username)

                return {'data': {}, 'errorcode': 503, 'message': 'backend has gone', 'result': False}
                # return "backend has gone (dead socket)"
            except Exception as e:
                serverlogger.error("%s - exception %s" % (uuid, str(e)))
                serverlogger.error("%s - traceback %s" %
                                   (uuid, traceback.format_exc()))

                cherrypy.response.status = 503
                return {'data': {}, 'errorcode': 504, 'message': 'unknown backend error', 'result': False}
                # return "unknown backend error"

            if callresult is None:
                cherrypy.response.headers['Content-Type'] = "text/plain"
                serverlogger.error(
                    "%s - clientfunction returned None" % (uuid))
                cherrypy.response.status = 500
                return {'data': {}, 'errorcode': 505, 'message': 'clientfunction returned None', 'result': False}
                # return "False"
                # return [False, 500, "no result"]

            if callresult[0] is False:
                serverlogger.error(
                    "%s - clientfunction returned False" % (uuid))
                success, statuscode, result, errorcode, message = callresult
                cherrypy.response.status = statuscode
                cherrypy.response.headers['Content-Type'] = "application/json"
                return {'data': result, 'errorcode': errorcode, 'message': message, 'result': False}
                # return "False"

                # return [False, callresult[1], "clientfunction returned False"]
            else:
                try:
                    success, statuscode, result, errorcode, message = callresult
                except:
                    serverlogger.error(
                        "%s - result-tuple wrong length: %s" % (uuid, str(callresult)))
                    cherrypy.response.headers['Content-Type'] = "application/json"
                    cherrypy.response.status = 500
                    return {'data': {}, 'errorcode': 507, 'message': 'result-tuple wrong length', 'result': False}
                    # return "False"
                    # return [False, 500, "result-tuple wrong length"]
            try:
                l = len(result)
            except TypeError:
                l = 0
            serverlogger.info("%s - got result [success: %s, statuscode: %s, len(response-data): %d]" % (uuid, success,  statuscode, l))
            # preview color-resampling and resizing
            # try:
            if url == "preview" and cherrypy.response.headers['Content-Type'].startswith("image"):
                color = "color"
                size = None
                scale = None
                coloroption = cv2.IMREAD_COLOR

                # color
                if "color" in optargs:
                    color = optargs["color"]
                    color = color.lower()
                if color not in ("grey", "gray", "bw", "color"):
                    cherrypy.response.status = 400
                    serverlogger.debug("%s - unknown color %s" % (uuid, color))
                    cherrypy.response.headers['Content-Type'] = "application/json"
                    return {'data': {}, 'errorcode': 508, 'message': 'unknown color', 'result': False}
                    # return "False"
                    # return [False, 400, "unknown color"]

                if color in ("grey", "gray", "bw"):
                    coloroption = cv2.IMREAD_GRAYSCALE
                else:
                    coloroption = cv2.IMREAD_COLOR

                # size
                if "size" in optargs:
                    size = optargs["size"]
                    try:
                        maxx, maxy = size.split("x")
                        maxx = int(maxx)
                        maxy = int(maxy)
                    except Exception as e:
                        #cherrypy.response.status = 400
                        serverlogger.debug(
                            "%s - exception '%s' in size calculation on arg %s" % (uuid, str(size), str(e)))
                        # return "False"
                        # return [False, 400, "size error"]
                # rotation
                if "rotation" in optargs:
                    try:
                        rotation = -int(optargs["rotation"])
                    except Exception as e:
                        cherrypy.response.status = 400
                        serverlogger.debug(
                            "%s - exception in rotation calculation %s" % (uuid, str(e)))
                        cherrypy.response.headers['Content-Type'] = "application/json"
                        return {'data': {}, 'errorcode': 509, 'message': 'exception in rotation calculation', 'result': False}
                        # return "False"
                        # return [False, 400, "rotation error"]
                else:
                    rotation = None

                # scale
                if "scale" in optargs:
                    try:
                        scale = float(optargs["scale"])
                    except:
                        cherrypy.response.status = 400
                        serverlogger.debug(
                            "%s - exception in scale calculation %s" % (uuid, str(e)))
                        cherrypy.response.headers['Content-Type'] = "application/json"
                        return {'data': {}, 'errorcode': 510, 'message': 'exception in scale calculation', 'result': False}
                        # return "False"
                        # return [False, 400, "scale error"]
                    if scale < 0.1 or scale > 1.0:
                        cherrypy.response.status = 400
                        serverlogger.debug(
                            "%s - bad scale factor %s" % (uuid, str(scale)))
                        cherrypy.response.headers['Content-Type'] = "application/json"
                        return {'data': {}, 'errorcode': 511, 'message': 'bad scale factor', 'result': False}
                        # return "False"
                        # return [False, 400, "bad scale factor"]
                serverlogger.info("%s - color: %s" % (uuid,  str(color)))
                img_array = numpy.asarray(bytearray(result), dtype=numpy.uint8)
                if color is not None:
                    if color in ("gray", "grey"):
                        im = cv2.imdecode(img_array, cv2.IMREAD_GRAYSCALE)
                    elif color in ("bw"):
                        serverlogger.info("%s - change color to bw" % (uuid))
                        im_gray = cv2.imdecode(img_array, cv2.IMREAD_GRAYSCALE)
                        (thresh, im) = cv2.threshold(im_gray, 128,
                                                     255, cv2.THRESH_BINARY | cv2.THRESH_OTSU)
                    else:
                        im = cv2.imdecode(img_array, coloroption)
                else:
                    im = cv2.imdecode(img_array, coloroption)
                reshaped = im

                if rotation is not None:
                    im = rotateAndScale(im, scaleFactor=1, degreesCCW=rotation)
                if size is not None:
                    y, x = im.shape[:2]
                    scale = min(float(int(maxx))/float(x),
                                float(int(maxy))/float(y))
                if scale is not None:
                    newshape = (int(im.shape[:2][1]*scale),
                                int(im.shape[:2][0]*scale))
                    reshaped = cv2.resize(
                        im, newshape, interpolation=cv2.INTER_AREA)
                    im = reshaped

                result = base64.b64encode(cv2.imencode(
                    ".png", reshaped, [cv2.IMWRITE_PNG_COMPRESSION, 9])[1].tobytes()).decode()
            if url in ("getori", "gettif"):
                result = base64.b64encode(result).decode()
            serverlogger.info("%s - returning result, leaving GET" % (uuid))
            cherrypy.response.headers['Content-Type'] = "application/json"
            if errorcode is None:
                errorcode = 0
            return {'data': result, 'errorcode': errorcode, 'message': message, 'result': True}

        cherrypy.response.status = 400
        serverlogger.error("%s - unknown error in GET" % (uuid))
        cherrypy.response.headers['Content-Type'] = "application/json"
        return {'data': result, 'errorcode': 600, 'message': 'unknown error', 'result': False}
        # return result
        # return "False"
        # return [False, 400, "unknown error"]

    # @cherrypy.tools.timeit()
    @require()
    @cherrypy.tools.json_out(handler=json_handler)
    @cherrypy.tools.json_in(processor=json_in_processor)
    @cherrypy.tools.timeit()
    def POST(self, *args):
        # if hasattr(cherrypy.serving.request, "json_error"):
        if cherrypy.serving.request.json_error is True:
            msg = cherrypy.serving.request.json_errormsg
            return {'data': msg, 'errorcode': 415, 'message': 'json decode error', 'result': False}
        headers = cherrypy.response.headers
        headers['X-Frame-Options'] = 'DENY'
        headers['X-XSS-Protection'] = '1; mode=block'
        headers['Content-Security-Policy'] = "default-src 'self';"
        try:
            uuid = cherrypy.session['bfaserverclient'].uuid
        except:
            uuid = "nouuid"
        serverlogger.info(
            "%s - incoming POST request on url %s" % (uuid, args[0]))
        serverlogger.info("%s - POST args: %s" % (uuid, str(args)))
        try:
            kwargs = cherrypy.request.json
        except:
            cherrypy.response.status = 500
            serverlogger.debug("%s - json decode error in POST" % (uuid))
            return {'data': {}, 'errorcode': 512, 'message': 'json decode error', 'result': False}
            # return [False, 500, "json decode error in POST"]
        log_kwargs = kwargs.copy()
        if "docstream" in log_kwargs:
            log_kwargs["docstream"] = log_kwargs["docstream"][:100]+"..."

        serverlogger.info("%s - POST kwargs: %s" % (uuid, str(log_kwargs)))
        func = None
        if len(args) > 0:
            url = args[0]
        else:
            cherrypy.response.status = 400
            serverlogger.error("%s - unknown url" % (uuid))
            return {'data': {}, 'errorcode': 513, 'message': 'missing parameter', 'result': False}
            # return [False, 404, "unknown url"]

        if url.lower() == "search":
            func = "getSearch"
        elif url.lower() == "saveresub":
            func = "getSaveResub"
        elif url.lower() == "savedoc":
            func = "getSave"
        elif url.lower() == "settitle":
            func = "getSaveTitle"
        elif url.lower() == "newdoc":
            func = "getNewDoc"
        elif url.lower() == "archive":
            func = "getNewDoc"

        else:
            cherrypy.response.status = 404
            serverlogger.error("%s - unknown url %s" % (uuid, url))
            return {'data': {}, 'errorcode': 404, 'message': 'unknown url', 'result': False}

        clientmethodd = cherrypy.session['bfaserverclient'].clientmethodd
        # clientmethods = cherrypy.session['bfaserverclient'].clientmethods
        if func in list(clientmethodd.keys()):
            callfunc = clientmethodd[func]
            serverlogger.info(
                "%s - client-method for url %s: %s" % (uuid, url, func))
        else:
            callfunc = None
            serverlogger.error(
                "%s - no client-method found for url %s" % (uuid, url))
            cherrypy.response.status = 404
            return {'data': {}, 'errorcode': 500, 'message': 'no client-method found', 'result': False}

        # get args for client function

        if callfunc:
            serverlogger.debug("callfunc %s" % (func))
            cargs, varargs, keywords, defaults, _, _, _ = inspect.getfullargspec(
                clientmethodd[func])
            cargs.remove("self")
            ccargs = [x for x in cargs]

            # mix with delivered kwargs and defaults:
            myargs = {}
            optargs = {}
            if defaults is None:
                defaults = ()
            gap = len(cargs)-len(defaults)
            for index, value in enumerate(defaults):
                cargs[index+gap] = (cargs[index+gap], value)
            for element in cargs:
                if type(element) != tuple:
                    key = element
                    value = ""
                else:
                    key = element[0]
                    value = element[1]
                if key in kwargs:
                    value = kwargs[key]
                myargs[key] = value
            serverlogger.debug("missing arg check")
            # check for missing args
            if sorted(myargs.keys()) != sorted(ccargs):
                serverlogger.debug("sorted(myargs.keys()) != sorted(ccargs)")
                cherrypy.response.status = 400
                serverlogger.error("%s - argument error" % (uuid))
                return {'data': {}, 'errorcode': 500, 'message': 'argument error', 'result': False}
            optargs = {}
            for key in kwargs:
                if key not in myargs:
                    optargs[key] = kwargs[key]
            # handle value casting
            serverlogger.debug("before casting")
            if func in cherrypy.session["bfaserverclient"].args:
                serverlogger.debug("func found")
                castdict = cherrypy.session["bfaserverclient"].args[func]
                #serverlogger.debug("myargs: %s" %str(myargs))
                for key, value in list(myargs.items()):
                    if value is not None:
                        try:
                            # eingeführt, um bei den casting-Funktionen weitere args mitgeben zu können (datetime formatstrings z.B., siehe z.B. bfaserverclient self.caster.strtodate)
                            if type(castdict[key]) == tuple:
                                myargs[key] = castdict[key][0](
                                    value, castdict[key][1])
                            else:
                                myargs[key] = castdict[key](value)
                            #serverlogger.debug("casting %s successfull to %s" %(key, str(myargs[key])))
                        except Exception as e:
                            serverlogger.error(
                                "%s - %s casting error: %s" % (uuid, key, str(e)))
                            serverlogger.debug(traceback.format_exc())
                            cherrypy.response.status = 400
                            return {'data': str(e), 'errorcode': 500, 'message': 'argument casting failed', 'result': False}
                            return

            if "asjson" in ccargs:
                myargs["asjson"] = True
            serverlogger.info("%s - calling %s with args %s" %
                              (uuid,  str(callfunc), str(myargs)))

            try:
                callresult = callfunc(**myargs)
            except socket.error as e:
                serverlogger.error("%s - socket exception %s" % (uuid, str(e)))
                cherrypy.response.status = 503
                # cherrypy.session["bfaserverclient"].logout()
                sess = cherrypy.session
                username = sess.get(SESSION_KEY, None)
                if username:
                    sess[SESSION_KEY] = None
                    cherrypy.session['usr_id'] = None
                    cherrypy.session['_cp_username'] = None
                    cherrypy.session["bfaserverclient"].logout()
                    cherrypy.session["bfaserverclient"] = None
                    if username:
                        cherrypy.request.login = None
                        serverlogger.info("%s logged out" % username)
                return {'data': {}, 'errorcode': 503, 'message': 'backend has gone', 'result': False}
                # return "backend has gone (dead socket)"
            except Exception as e:
                serverlogger.error("%s - exception %s" % (uuid, str(e)))
                serverlogger.error("%s - traceback %s" %
                                   (uuid, traceback.format_exc()))
                cherrypy.response.status = 503
                return {'data': {}, 'errorcode': 504, 'message': 'unknown backend error', 'result': False}
                # return "unknown backend error"

            if callresult is None:
                serverlogger.error(
                    "%s - clientfunction returned None" % (uuid))
                cherrypy.response.status = 500
                return {'data': {}, 'errorcode': 505, 'message': 'clientfunction returned None', 'result': False}
                # return "False"
                # return [False, 500, "no result"]
            if callresult[0] is False:
                serverlogger.error(
                    "%s - clientfunction returned False" % (uuid))
                if len(callresult) == 5:
                    success, statuscode, result, errorcode, message = callresult
                    cherrypy.response.status = statuscode
                    return {'data': result, 'errorcode': errorcode, 'message': message, 'result': False}
                else:
                    cherrypy.response.status = callresult[1]
                    return {'data': {}, 'errorcode': 506, 'message': 'clientfunction returned False', 'result': False}
                # return "False"
                # return [False, callresult[1], "clientfunction returned False"]
            else:
                try:
                    success, statuscode, result, errorcode, message = callresult
                except:
                    serverlogger.error(
                        "%s - result-tuple wrong length: %s" % (uuid, str(callresult)))
                    cherrypy.response.status = 500
                    return {'data': str(callresult), 'errorcode': 507, 'message': 'backend error, result-tuple wrong length', 'result': False}
                try:
                    l = len(result)
                except TypeError:
                    l = 0
                serverlogger.info(
                    "%s - got result [success: %s, statuscode: %s, len(response-data): %d]" % (uuid, success,  statuscode,  l))
                cherrypy.response.status = 200
                return {'data': result, 'errorcode': errorcode, 'message': message, 'result': True}
                return result

    def PUT(self, *args, **kwargs):
        cherrypy.response.status = 405
        return

    def DELETE(self, *args, **kwargs):
        cherrypy.response.status = 405
        return


class BfaService(object):

    @require()
    @cherrypy.tools.json_out()
    @cherrypy.expose
    def photo_to_doc(self, ufile, extension=None):
        photo_to_doc_exe = cherrypy.config.get("photo_to_doc")
        serverlogger.debug("photo_to_doc_exe, " + str(photo_to_doc_exe))
        upload_basedir = cherrypy.config.get("photo_to_doc_upload")
        serverlogger.debug("photo_to_doc_upload, " + str(upload_basedir))
        if upload_basedir is None or photo_to_doc_exe is None:
            return {'data': {}, 'errorcode': 100, 'message': 'server config-error', 'result': False}
            # return "error, photo_to_doc is not configured"
        if extension.lower() not in ("png", "bmp", "jpg", "jpeg"):
            return {'data': {}, 'errorcode': 245, 'message': 'unknown extension, only "png", "bmp", "jpg", "jpeg" allowed', 'result': False}
        if not os.path.isdir(upload_basedir):
            os.makedirs(upload_basedir)
        tempdir = tempfile.mkdtemp(dir=upload_basedir)
        serverlogger.info("tempdir " + tempdir)
        # filetype = magic.from_buffer(base64.b64decode(ufile))

        upload_file = os.path.join(tempdir, "temp."+extension)
        size = 0
        try:
            with open(upload_file, 'wb') as out:
                out.write(base64.b64decode(ufile))
                # size = len(data)
        except:
            return {'data': {}, 'errorcode': 101, 'message': 'error reading upload-file', 'result': False}
            # return "error reading upload-file"

        streamdata = None
        try:
            cmd_args = [photo_to_doc_exe, "-binarize", upload_file,
                        os.path.splitext(upload_file)[0] + "_doc."+extension]
            serverlogger.debug(
                "subprocess photo_to_doc_exe cmd: " + " ".join(cmd_args))
            proc = subprocess.Popen(
                cmd_args, stdout=subprocess.PIPE, stderr=subprocess.PIPE, text=True)
            streamdata = proc.communicate()[0]
        except Exception as e:
            serverlogger.debug(
                "subprocess photo_to_doc_exe exception: " + str(e))
            return {'data': {}, 'errorcode': 102, 'message': 'error processing photo', 'result': False}
            # return "error processing photo"
        rc = proc.returncode
        serverlogger.debug(
            "subprocess photo_to_doc_exe returnvalue: " + str(rc))
        if streamdata is not None:
            for line in streamdata.split("\n"):
                line = line.strip()
                if len(line) > 0:
                    serverlogger.debug(
                        "subprocess photo_to_doc_exe stdout: " + str(line))
        if rc == 0:
            with open(os.path.splitext(upload_file)[0] + "_doc."+extension, "rb") as f:
                imgstr = f.read()
            imgstr = base64.b64encode(imgstr).decode()
            # base64 kodieren und Header setzen
            #cherrypy.response.headers['Content-Type'] = "image/jpg"
            # html = '<html><body><img src="data:image/png;base64,'+imgstr+'"></img></body></html>'
            if "deltemp" in list(cherrypy.config.keys()):
                if cherrypy.config["deltemp"] != False:
                    shutil.rmtree(tempdir)
            else:
                shutil.rmtree(tempdir)
            cherrypy.response.status = 200
            return {'data': {"b64_imagedata": imgstr, "imagetype": extension}, 'errorcode': 0, 'message': 'success', 'result': True}
            # return html
        else:
            if "deltemp" in list(cherrypy.config.keys()):
                if cherrypy.config["deltemp"] != False:
                    shutil.rmtree(tempdir)

            #cherrypy.response.headers['Content-Type'] = "application/json"
            if rc == 240:
                cherrypy.response.status = 400
                errorstr = "unable to load image (image not found)"
            elif rc == 241:
                cherrypy.response.status = 400
                errorstr = "unable to load image (not an image?)"
            elif rc == 242:
                cherrypy.response.status = 200
                errorstr = "no document contour found"
            elif rc == 243:
                cherrypy.response.status = 200
                errorstr = "document contour found, but too small"
            else:
                cherrypy.response.status = 500
                errorstr = "unknown error"
            return {'data': {}, 'errorcode': rc, 'message': errorstr, 'result': False}
            # return "{\"error\":%d, \"errorstr\":\"%s\"}" %(rc, errorstr)


class AppServer():

    auth = AuthController()
    api = ApiController()
    tools = BfaService()

    @cherrypy.expose
    @require()
    @cherrypy.tools.json_in()
    @cherrypy.tools.json_out()
    def logging(self, *args, **kwargs):
        try:
            loglist = cherrypy.request.json
            for log in loglist:
                realclientlog.info(log)
            return {"result": True, "errorcode": 0, "message": "client-log message saved", "data": True}
        except Exception as e:
            serverlogger.error("error logging clientlog: %s" % e)
            return {"result": False, "errorcode": 111, "message": "error saving client-log message", "data": str(e)}

    @require()
    @cherrypy.expose
    @cherrypy.tools.json_out()
    def set_loglevel(self, level=""):
        username = cherrypy.session.get("_cp_username")
        if username.lower() != "dmsadmin":
            serverlogger.warning(
                "set_loglevel called by user %s, but only dmsadmin is allowed to change loglevel" % username)
            cherrypy.response.status = 401
            return {"result": False, "errorcode": 112401, "message": "only dmsadmin may change the loglevel", "data": False}

        loglevels = {"debug": logging.DEBUG, "info": logging.INFO,
                     "warning": logging.WARNING, "error": logging.ERROR, "critical": logging.CRITICAL}
        level = level.lower()
        if level not in list(loglevels.keys()):
            serverlogger.info(
                "unknown loglevel, set_loglevel not set to %s" % level)
            cherrypy.response.status = 400
            return {"result": False, "errorcode": 112, "message": "unknown loglevel", "data": False}
        else:
            serverlogger.info("set_loglevel set to %s" % level)
            serverlogger.setLevel(loglevels[level])
            return {"result": True, "errorcode": 0, "message": "", "data": True}

    @cherrypy.expose
    @cherrypy.tools.json_out()
    def pwsave(self):
        try:
            pwsave = cherrypy.config.get("pwsave")
            if type(pwsave) != bool:
                pwsave = False
        except:
            pwsave = False
        return {"result": pwsave, "errorcode": 0, "message": "", "data": pwsave}

    @cherrypy.expose
    @cherrypy.tools.json_out()
    def serverinfo(self):
        return {"result": True, "errorcode": 0, "message": "", "data": SERVERINFO}
        # return SERVERINFO

    @cherrypy.expose
    def index(self, mobile=True, **kwargs):
        # cherrypy.request.cookie["sameSite"] = None
        if mobile in ("true", "True"):
            mobile = True
        if mobile == True:
            htmlfile = cherrypy.config.get("indexfile")
        else:
            htmlfile = cherrypy.config.get("indexfile").replace(
                "index.html", "desktop.html")
        with open(htmlfile, "rb") as f:
            html = f.read()
        return html

    @cherrypy.expose
    def ping(self):
        return
    
    @cherrypy.expose
    def anybodyOutThere(self, *args, **kwargs):
        return "please upgrade to version 2!"


class bfahttpservice(win32serviceutil.ServiceFramework):

    _svc_name_ = "bfaHttpServer36"
    _svc_display_name_ = "bitfarm http-Server36"
    _svc_description_ = "bitfarm http-Server für die Version 36"
    #_svc_deps_ = ["EventLog"]

    def __init__(self, args):
        win32serviceutil.ServiceFramework.__init__(self, args)
        self.hWaitStop = win32event.CreateEvent(None, 0, 0, None)
        # servicemanager.LogInfoMsg("INIT!")
        self.timeout = 1000  # 1 second
        self.bfasrv = None
        self.nginx = None

    def SvcStop(self):
        # import servicemanager
        # servicemanager.LogInfoMsg("STOP!")
        self.ReportServiceStatus(win32service.SERVICE_STOP_PENDING)
        if self.nginx:
            stopnginx(self.nginx)
        win32event.SetEvent(self.hWaitStop)
        #self.bfasrv.stopsignal = True

    def SvcDoRun(self):
        import servicemanager
        servicemanager.LogInfoMsg("bfaHttpServer36 Service starting...")
        # servicemanager.LogMsg(servicemanager.EVENTLOG_INFORMATION_TYPE,servicemanager.PYS_SERVICE_STARTED,(self._svc_name_, ''))
        win32evtlogutil.ReportEvent(self._svc_name_, servicemanager.PYS_SERVICE_STARTED,
                                    0, servicemanager.EVENTLOG_INFORMATION_TYPE, (self._svc_name_, ''))

        self.ReportServiceStatus(win32service.SERVICE_START_PENDING)

        # This is how long the service will wait to run / refresh itself (see script below)

        app = AppServer()

        mypath = os.path.split(os.path.abspath(sys.argv[0]))[0]
        mypath = str(win32file.GetLongPathName(mypath))

        try:
            bfapath = os.getenv("bitfarm-archiv")
        except:
            bfapath = mypath
        binpath = os.path.join(bfapath, "bin")
        servicemanager.LogInfoMsg("bfaHttpServer36 bfapath %s" % bfapath)
        servicemanager.LogInfoMsg("bfaHttpServer36 mypath %s" % mypath)

        cfgfile = os.path.join(bfapath, 'bin', "bfaHttpServer.cfg")
        if not os.path.exists(cfgfile):
            cfgfile = os.path.join(mypath, "bfaHttpServer.cfg")

        cherrypy.tree.mount(app, '/', cfgfile)
        # cherrypy.config.update(os.path.join(mypath, "bfaHttpServer.cfg"))
        cherrypy.config.update(cfgfile)

        if "nginx" in cherrypy.config:
            self.nginx = cherrypy.config.get("nginx")
            if not os.path.isfile(self.nginx):
                self.nginx = None
        if self.nginx:
            nginxdir = os.path.dirname(self.nginx)
            nginxconf = os.path.join(nginxdir, "conf", "nginx.conf")
            with codecs.open(nginxconf, "r", encoding="utf8") as tmpf:
                content = tmpf.read()
            lines = content.split("\n")
            for line in lines:
                if line.strip().startswith("client_max_body_size"):
                    val = line.strip().split(" ")[1][:-1]
                    SERVERINFO["client_max_body_size"] = val
        #nginx = cherrypy.config.get("nginx")
        loglevels = {"debug": logging.DEBUG, "info": logging.INFO,
                     "warning": logging.WARNING, "error": logging.ERROR, "critical": logging.CRITICAL}
        if "loglevel" in cherrypy.config:
            level = cherrypy.config.get("loglevel")
            try:
                level = level.lower()
                serverlogger.setLevel(loglevels[level])
            except:
                level = "info"
                serverlogger.setLevel(loglevels[level])
                serverlogger.error(
                    "bfaHttpServer.cfg invalid value for option 'loglevel'. Using loglevel 'info'")
        else:
            serverlogger.error(
                "bfaHttpServer.cfg missing option 'loglevel'. Using loglevel 'info' now.")
            serverlogger.setLevel(loglevels["info"])
        if self.nginx:
            servicemanager.LogInfoMsg("bfaHttpServer36 nginx %s" % self.nginx)
            try:
                stopnginx(self.nginx)
            except Exception as e:
                servicemanager.LogInfoMsg(
                    "bfaHttpServer36 exception SvcDoRun %s" % str(e))
                servicemanager.LogInfoMsg(
                    "bfaHttpServer36 traceback %s" % traceback.format_exc())
            try:
                killAllNginx()
            except Exception as e:
                servicemanager.LogInfoMsg(
                    "bfaHttpServer36 exception SvcDoRun %s" % str(e))
                servicemanager.LogInfoMsg(
                    "bfaHttpServer36 traceback %s" % traceback.format_exc())

            try:
                startnginx(self.nginx)
            except Exception as e:
                servicemanager.LogInfoMsg(
                    "bfaHttpServer36 exception SvcDoRun %s" % str(e))
                servicemanager.LogInfoMsg(
                    "bfaHttpServer36 traceback %s" % traceback.format_exc())
            try:
                rotateLogs(self.nginx)
            except Exception as e:
                servicemanager.LogInfoMsg(
                    "bfaHttpServer36 exception SvcDoRun %s" % str(e))
                servicemanager.LogInfoMsg(
                    "bfaHttpServer36 traceback %s" % traceback.format_exc())
            try:
                rltask = cherrypy.process.plugins.BackgroundTask(
                    interval=3600, function=rotateLogs, args=[self.nginx])
                rltask.start()
            except Exception as e:
                servicemanager.LogInfoMsg(
                    "bfaHttpServer36 exception SvcDoRun %s" % str(e))
                servicemanager.LogInfoMsg(
                    "bfaHttpServer36 traceback %s" % traceback.format_exc())

        serverlogger.info("using config-file '%s'" % cfgfile)
        cherrypy.engine.start()
        self.ReportServiceStatus(win32service.SERVICE_RUNNING)
        servicemanager.LogInfoMsg("Running")
        while True:
            # Wait for service stop signal, if I timeout, loop again
            rc = win32event.WaitForSingleObject(self.hWaitStop, self.timeout)
            # Check to see if self.hWaitStop happened
            if rc == win32event.WAIT_OBJECT_0:
                # Stop signal encountered
                break


class BfaSession(sessions.RamSession):
    def __init__(self, id=None, **kwargs):
        super(BfaSession, self).__init__(id, **kwargs)

    def clean_up(self):
        serverlogger.debug("starting session cleanup")
        now = self.now()
        for _id, (data, expiration_time) in copyitems(self.cache):
            serverlogger.debug(data)
            serverlogger.debug(expiration_time)
            if expiration_time <= now:
                serverlogger.debug("session cleanup _id: %s" % (str(_id)))
                try:
                    sess = cherrypy.session
                except:
                    pass
                try:
                    username = data.get(SESSION_KEY, None)
                except Exception as e:
                    serverlogger.debug(
                        "error session cleanup 2. error %s " % str(e))
                try:
                    if "bfaserverclient" in data:
                        if data["bfaserverclient"] is not None:
                            data["bfaserverclient"].logout()
                            serverlogger.info(
                                "session cleanup -> %s wurde abgemeldet" % username)
                    #sess['_cp_username'] = None
                except Exception as e:
                    serverlogger.warning(
                        "warning session cleanup 2 failed. Error %s " % str(e))

        super(BfaSession, self).clean_up()


def rotateAndScale(img, scaleFactor=0.5, degreesCCW=30):
    (oldY, oldX) = img.shape[:2]
    M = cv2.getRotationMatrix2D(
        center=(oldX/2, oldY/2), angle=degreesCCW, scale=scaleFactor)
    newX, newY = oldX*scaleFactor, oldY*scaleFactor
    r = numpy.deg2rad(degreesCCW)
    newX, newY = (abs(numpy.sin(r)*newY) + abs(numpy.cos(r)*newX),
                  abs(numpy.sin(r)*newX) + abs(numpy.cos(r)*newY))
    (tx, ty) = ((newX-oldX)/2, (newY-oldY)/2)
    M[0, 2] += tx
    M[1, 2] += ty
    rotatedImg = cv2.warpAffine(img, M, dsize=(int(newX), int(newY)))
    return rotatedImg


def startnginx(nginx):
    if nginx:
        subprocess.Popen([nginx], cwd=os.path.dirname(
            nginx), close_fds=True, creationflags=subprocess.CREATE_NEW_CONSOLE)


def stopnginx(nginx):
    if nginx:
        stopcmd = [nginx, "-s", "stop"]
        p = subprocess.Popen(stopcmd, cwd=os.path.dirname(nginx))
        p.communicate()


def reopennginx(nginx):
    reopencmd = [nginx, "-s", "reopen"]
    p = subprocess.Popen(reopencmd, cwd=os.path.dirname(nginx))
    p.communicate()


def rotateLogs(nginx):
    maxsize = 1024 * 1000 * 10  # 10 MB
    backupcount = 5
    dirname = os.path.join(os.path.split(nginx)[0],  "logs")
    myfile = ""
    logfiles = glob.glob(os.path.join(dirname, "*.log"))
    today = datetime.date.today()
    oldlogs = []

    for filename in logfiles:
        info = os.stat(filename)
        myfile = os.path.split(filename)[1]
        base = os.path.splitext(myfile)[0]
        if filename.endswith(".log") and info.st_size > maxsize and myfile in ("access.log",  "error.log",  "host.access.log"):
            newname = os.path.join(dirname, base) + "_" + str(today) + ".log"
            os.rename(filename,  newname)
            reopennginx(nginx)
            #tf = open(filename,  'w')
            # tf.close()
            # jetzt die alte datei loeschen (falls vorhanden)
            for root,  dirs,  files in os.walk(dirname,  topdown=False):
                for name in files:
                    if name.startswith(base) and (len(name) > len(myfile)) and (name != os.path.split(newname)[1]):
                        oldlogs.append(os.path.join(dirname,  name))
    for oldfile in oldlogs:
        os.remove(oldfile)


def killAllNginx():
    for proc in psutil.process_iter():
        try:
            procname = proc.name()
        except:
            continue
        if procname == "nginx.exe":
            # time.sleep(0.25)
            try:
                children = proc.children()
            except:
                continue
            for child in children:
                try:
                    if child.is_running():
                        pid = child.pid
                        child.kill()
                        serverlogger.debug("killed nginx-child %d" % pid)
                except:
                    continue
            try:
                pid = proc.pid
                proc.kill()
                serverlogger.debug("killed nginx-process %d" % pid)
            except:
                continue


if __name__ == '__main__':

    @cherrypy.tools.register('before_finalize', priority=60)
    def secureheaders():
        headers = cherrypy.response.headers
        headers['X-Frame-Options'] = 'DENY'
        headers['X-XSS-Protection'] = '1; mode=block'
        headers['Content-Security-Policy'] = "default-src 'self';"

    mypath = os.path.split(os.path.abspath(sys.argv[0]))[0]
    mypath = win32file.GetLongPathName(mypath)
    try:
        bfapath = os.environ["bitfarm-archiv"]
    except:
        bfapath = mypath

    httplogfile = os.path.join(bfapath, 'bin', "bfahttp_logging.conf")
    servicemanager.LogInfoMsg(
            f'httplogfile1 {httplogfile}')
    if not os.path.exists(httplogfile):
        httplogfile = os.path.join(mypath, "bfahttp_logging.conf")
    servicemanager.LogInfoMsg(
            f'httplogfile2 {httplogfile}')
    if not os.path.isfile(httplogfile):
        with open(httplogfile, "w") as f:
            f.write(logging_conf_string)
    try:
        logging.config.fileConfig(httplogfile)
    except Exception as e:
        import servicemanager
        servicemanager.LogInfoMsg(
            'Fehler beim Einlesen der Konfigurationsdatei %s: %s' % (httplogfile, str(e)))
        sys.exit()
    print(f"using {httplogfile}")
    serverlogger = logging.getLogger("serverlogger")
    serverlogger.addFilter(IpFilter())
    serverlogger.propagate = True
    cherrypy.log.error_file = ""
    cherrypy.log.access_file = ""
    cherrypy.log.error_log = logging.getLogger("cherrypy.error")
    cherrypy.log.access_log = logging.getLogger("cherrypy.access")
    cherrypy.log.error_log.propagate = False
    cherrypy.log.access_log.propagate = False
    realclientlog = logging.getLogger('realclientlogger')
    realclientlog.addFilter(IpFilter())

    def copyitems(d): return list(d.items())
    SESSION_KEY = '_cp_username'
    sessions.BfaSession = BfaSession
    if len(sys.argv) == 1:

        try:
            evtsrc_dll = os.path.abspath(servicemanager.__file__)
            servicemanager.PrepareToHostSingle(bfahttpservice)
            servicemanager.Initialize('bfaHttpServer36', evtsrc_dll)
            servicemanager.StartServiceCtrlDispatcher()
        except win32service.error as details:
            if details[0] == winerror.ERROR_FAILED_SERVICE_CONTROLLER_CONNECT:
                win32serviceutil.usage()
    else:
        if sys.argv[1] in ['install', 'stop', 'start', 'remove']:
            servicemanager.LogInfoMsg(
                'Parameter für Dienststeuerung: %s' % sys.argv[1])
            win32serviceutil.HandleCommandLine(bfahttpservice)
        else:
            app = AppServer()
            mypath = os.path.split(os.path.abspath(sys.argv[0]))[0]
            mypath = str(win32file.GetLongPathName(mypath))
            try:
                bfapath = os.getenv("bitfarm-archiv")
            except:
                bfapath = mypath
            binpath = os.path.join(bfapath, "bin")
            cfgfile = os.path.join(bfapath, 'bin', "bfaHttpServer.cfg")

            if not os.path.exists(cfgfile):
                cfgfile = os.path.join(mypath, "bfaHttpServer.cfg")
            serverlogger.info("using config-file '%s'" % cfgfile)
            cherrypy.tree.mount(app, '/', cfgfile)
            # cherrypy.config.update(os.path.join(mypath, "bfaHttpServer.cfg"))
            cherrypy.config.update(cfgfile)

            nginx = None
            if "nginx" in cherrypy.config:

                nginx = cherrypy.config.get("nginx")

                if not os.path.isfile(nginx):
                    nginx = None

            if nginx:
                nginxdir = os.path.dirname(nginx)
                nginxconf = os.path.join(nginxdir, "conf", "nginx.conf")
                with codecs.open(nginxconf, "r", encoding="utf8") as tmpf:
                    content = tmpf.read()
                lines = content.split("\n")
                for line in lines:
                    if "client_max_body_size" in line:
                        val = line.strip().split(" ")[1][:-1]
                        SERVERINFO["client_max_body_size"] = val
                stopnginx(nginx)
                killAllNginx()
            loglevels = {"debug": logging.DEBUG, "info": logging.INFO,
                         "warning": logging.WARNING, "error": logging.ERROR, "critical": logging.CRITICAL}
            if "loglevel" in cherrypy.config:
                level = cherrypy.config.get("loglevel")
                try:
                    level = level.lower()
                    serverlogger.setLevel(loglevels[level])
                except:
                    level = "info"
                    serverlogger.setLevel(loglevels[level])
                    serverlogger.error(
                        "bfaHttpServer.cfg invalid value for option 'loglevel'. Using loglevel 'info'")
            else:
                serverlogger.error(
                    "bfaHttpServer.cfg missing option 'loglevel'. Using loglevel 'info' now.")
                serverlogger.setLevel(loglevels["info"])
            serverlogger.setLevel(logging.DEBUG)
            if nginx:
                startnginx(nginx)
                rotateLogs(nginx)
                rltask = cherrypy.process.plugins.BackgroundTask(
                    interval=10, function=rotateLogs, args=[nginx])
                rltask.start()
            cherrypy.engine.console_control_handler.subscribe()

            cherrypy.engine.start()
  

            try:
                cherrypy.engine.block()
            except:
                print("kb exception")
                pass
            if nginx:
                print("stopping nginx")
                stopnginx(nginx)
