#!/usr/bin/env python
# -*- coding: latin-1 -*-

import os
import sys
import threading
import select
import shutil
import threading
import Queue
import logging
import logging.config
import datetime,  time
import cStringIO
import warnings
import subprocess
#import PyPDF2
import pyPdf
import socket
import gettext
from collections import deque

import bitfarm_doc
#import bitfarm_files
import bitfarm_xml
#import bitfarm_workflow
import OcrClient
import glob


try:
    trans = gettext.translation("bfaArchiving", "locale", ['en'],  fallback = True)
    trans.install()
except:
    print(u'Keine bersetzung gefunden/no translation found')
    _ = lambda x: x
else:
    _ = trans.ugettext

def enqueue_output(out, queue):
    for line in iter(out.readline, b''):
        queue.put(line)
    out.close()


class bfaOCR(threading.Thread):
    result = []
    resultlock = threading.Lock()
    ocrlock = threading.Lock()
    omplock = threading.Lock()
    queue_cnt = 3
    #queue = Queue.Queue(BitfarmArchivierung.cnt_ocr_threads)
    queue = Queue.Queue(0)
    log = logging.getLogger("Main.bfaOCR")


    def __init__(self,  con):
        threading.Thread.__init__(self)
        self._job = None
        self.con = con
        self.bufsize = 4096
        self.stream = cStringIO.StringIO()
        self.result = None
        self.serverIP = 'localhost'
        self.serverPort = 57076
        self.buffsize = 4096
        self.timeout = 0
        self.bfaProc = bitfarm_doc.BitfarmDocProcessing(self.con)
        self.log.info(_(u'%s: OCR-Thread initialisiert') % self.name)

    def run(self):

        while self.is_alive():
            self._job = bfaOCR.queue.get()
            self.log.debug(_(u"%s: ocr [%s] (%i aktive tasks)") % (self.name, self._job.gdocid, bfaOCR.queue.unfinished_tasks))
#
#            start = time.time()
#            self.timeout = start +2
#            for i in range(100):
#                time.sleep(0.20)

            try:
                txt = u""
                tries = 1
                ext = os.path.splitext(self._job.path)[1]


                #self._job.ftx.text = u"Dies ist ein schner Volltexttest\x0cMit zwei Seiten"

                if hasattr(self,  self._job.tasks[0].task):
                    getattr(self,  self._job.tasks[0].task)()
                else:
                    self.result = False
                    self._job.error = True
                    self._job.errortext = _("Die Funktion %s konnte nicht gefunden werden") % self._job.tasks[0].task
                    self.log.error(self._job.errortext)

                self.log.debug(_('%s: verarbeitet: %s') % (self.name, self._job))
            except:
                self.log.exception(_('%s: Fehler in der Verarbeitung') % self.name)


            if self._job is not None:
                bfaOCR.resultlock.acquire()
                try:
                    if self._Thread__stopped:
                        break
                    if type(self._job) is list:
                        self.__class__.result.extend(self._job)
                    else:
                        self.__class__.result.append(self._job)
                    if bfaOCR.queue.unfinished_tasks > 0:
                        bfaOCR.queue.task_done()
                    self._job = None
                    self.timeout = 0
                finally:
                    bfaOCR.resultlock.release()
                    self.log.debug(_(u"%s: ocr fertig : %s") % (self.name, str(self._job)))
            else:
                self.log.error(_(u'%s: kein Job fr die Rckgabe mehr vorhanden.') % self.name)

        self.log.warning(_(u'%s: Thread wurde gestoppt') % self.name)


    def run_ooffice2txt(self):
        return u''

    def pdf_to_txt(self):
        self.log.debug(_('pdf_to_txt'))
        if os.path.splitext(self._job.path)[1] != '.pdf':
            self.log.warning(_(u'%s Die bergebene Datei ist kein PDF: %s') %(self.name, self._job.path))
            self._job.result = False
            return None

        if not os.path.exists(os.path.join(self.con.main.bfapath, 'pdftotext.exe')):
            self.log.warning(_(u'%s pdftotext.exe konnte nicht gefunden werden') %self.name)
            self._job.result = False
            return None

        outputpath = self._job.tempname+'.tmp.txt'
        #args = ['pdftotext.exe', '-nopgbrk', pdffile]
        args = [os.path.join(self.con.main.bfapath, 'pdftotext.exe'), self._job.path, os.path.expandvars(outputpath)]
        try:
            timeout = 3000    #5min.
            cnt = 0
            is_timeout = False

            pipe = subprocess.Popen(args, stdout=subprocess.PIPE, stderr=subprocess.PIPE)

            while pipe.returncode is None:
                time.sleep(0.1)
                cnt += 1
                if cnt > timeout:
                    self.log.error(_(u'%s: timeout bei pdftotext') %self.name)
                    is_timeout = True
                    break
                pipe.poll()
            if is_timeout:
                self.log.warning(_(u'%s: beende pdftotext Prozess') %self.name)
                pipe.terminate()
                self._job.result = False
                return None
        except:
            self.log.exception(_(u'%s pdftotext.exe konnte nicht ausgefhrt werden') %self.name)

        if not os.path.exists(os.path.expandvars(outputpath)):
            self.log.warning(_(u'%s Fehler beim Schreiben der temporren Textdatei') %self.name)
            self._job.result = False
            return None
        else:
            try:
                f = open(os.path.expandvars(outputpath), 'r')
                txt = f.read()
            except:
                self.log.exception(_(u'%s Fehler beim Lesen der temporren Textdatei') %self.name)
                txt = u""
            finally:
                f.close()
            try:
                os.remove(os.path.expandvars(outputpath))
            except:
                self.log.error(_(u'%s: Konnte %s nicht lschen') %(self.name, outputpath))

            self._job.ftx.text = txt.decode('latin-1')

            if not self._job.ftx.is_empty:
                self._job.result = True
            else:
                self._job.result = False

    def pdf_to_txt2(self):
        self.log.debug(_(u'pdf_to_txt2'))
        if os.path.splitext(self._job.path)[1] != '.pdf':
            self.log.warning(_(u'%s Die bergebene Datei ist kein PDF: %s') %(self.name, self._job.path))
            self._job.result = False
            return None

        content = u""
        try:
            #pdf = PyPDF2.PdfFileReader(file(self._job.path, "rb"))
            pdf = pyPdf.PdfFileReader(file(self._job.path, "rb"))
            for i in range(0, pdf.getNumPages()):
                #content = pdf.getPage(i).extractText() + "\n"
                content = pdf.getPage(i).extractText()
                self._job.ftx.append(content)
                self.log.info(_(u'pdf_to_txt2 Seite %s') % i)
            self._job.result = True
        except:
            self.log.exception(_(u'%s Fehler bei pdf_to_txt2') % self.name)
            self._job.result = False

    def cre(self):
        self.log.debug(_(u'cre'))
        if not self._job.ftx.is_empty:
            self.log.warning(_(u'%s: Achtung, das Dokument hat schon Volltext. Funktion wird verlassen') %self.name)
            self._job.result = False
            return None
        docpath = self._job.path
        if os.path.splitext(docpath)[1] != '.tif':
            self.log.warning(_(u'%s Die bergebene Datei ist kein TIF, suche in docloc: %s') %(self.name, docpath))
            if self._job.docloc:
                docpath = self._job.docloc
                if os.path.splitext(docpath)[1] != '.tif':
                    self.log.warning(_(u'%s Die Datei in docloc ist kein TIF: %s') %(self.name, docpath))
                    self._job.result = False
                    return None
            else:
                self.log.warning(_(u'%s: docloc nicht vorhanden') % self.name)
                self._job.result = False
                return None

        if not os.path.exists(os.path.expandvars(docpath)):
            self.log.warning(_(u'%s: Datei konnte nicht gefunden werden %s') %(self.name, docpath))
            self._job.result = False
            return None


        tstamp = datetime.datetime.now().strftime('CRE%H%M%S%f')[:-3]
        credir = os.path.join(self.con.main.tempdir, tstamp)
        if not os.path.isdir(credir):
            os.mkdir(credir)
        crefile = os.path.join(credir, os.path.basename(docpath))
        shutil.copy(docpath, credir)

        args = [os.path.join(self.con.main.mypath,'SplitterV4.exe'), '-s', crefile]
        try:
            pipe = subprocess.Popen(args, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
            timeout = 0
            splittertimeout = False
            while pipe.returncode is None:
                time.sleep(0.1)
                timeout += 1
                if timeout >= 200:    # lnger als 20 sec pro Dokument sollte es nicht dauern
                    self.log.error(u'%s: timeout bei SplitterV4' % self.name)
                    splittertimeout = True
                    break
                pipe.poll()
            if splittertimeout:
                pipe.terminate()
        except:
            self.log.exception(_(u'%s SplitterV4.exe konnte nicht ausgefhrt werden'))
            self._job.result = False
            return None

        pattern = os.path.splitext(crefile)[0]+'_page*.tif'
        tiffiles = glob.glob(pattern)

        try:
            for tiffile in tiffiles:

                _buf = self._do_cre(self.con, tiffile, self.name)

                if type(self._job.ftx) is bitfarm_doc.BitfarmFulltext:
                    self._job.ftx.append(_buf)
                else:
                    self._job.ftx += _buf + '\0xc'

        finally:
            pass

        try:
            shutil.rmtree(credir,  True)
        except:
            self.log.exception(_(u'%s: Fehler beim Lschen des temporren Verzeichnis %s') %(self.name, credir))

        if self._job.ftx.is_empty:
            self._job.result = False
        else:
            self._job.result = True

        return True

    @staticmethod
    def _do_cre(con, fname, logname):
        _buf = u''
        args = [os.path.join(con.main.bfapath,'bfaOCR','bfaOCR.exe'), r'-i:%s' % str(fname), '-console']
        bfaOCR.log.debug("%s: %s" %(logname, args))

        try:
            #pipe = subprocess.Popen(args, stdout=subprocess.PIPE, stderr=subprocess.PIPE, shell = False)
            pipe = subprocess.Popen(args, stdin = subprocess.PIPE,  stdout=subprocess.PIPE, stderr = subprocess.PIPE)
            queue = Queue.Queue()
            thr = threading.Thread(target=enqueue_output, args=(pipe.stdout, queue))
            thr.daemon = True # thread dies with the program
            thr.start()
            out = ''
            timeout = 0
            ocrtimeout = False
            line = None
            while pipe.returncode is None:
                try:
                    line = queue.get(timeout=.1)
                except Queue.Empty:
                    timeout += 1
                    if timeout >= 600:    # lnger als 60 sec pro Dokument sollte es nicht dauern
                        bfaOCR.log.error(_(u'%s: timeout bei qs_bc_cmd') % logname)
                        ocrtimeout = True
                        break
                else:
                    out += line
                pipe.poll()
            if ocrtimeout:
                bfaOCR.log.warning(_(u'%s: beende bfaOCR Prozess') % logname)
                pipe.terminate()
            else:
                while line:
                    try:
                        line = queue.get(timeout=.1)
                    except Queue.Empty:
                        line = None
                    else:
                        out += line
        except:
            bfaOCR.log.exception(_(u'%s bfaOCR.exe konnte nicht ausgefhrt werden'%logname))
            return _buf
        bfaOCR.log.debug(_(u'%s: nach bfaOCR') % logname)

        out = out.strip()
        pipe = None
        thr = None
        queue = None

        time.sleep(0.5)

        bfaOCR.ocrlock.acquire()
        try:
            if out is not None:
                bfaOCR.log.debug(_(u'%s: Volltext gelesen %s') % (logname, fname))
                try:
                    _buf = out.decode('cp1252')
                except:
                    bfaOCR.log.exception(_(u'Fehler bei der decodierung (cp1252)'))
                bfaOCR.log.debug(u'%s: nach decode'% logname)
            else:
                bfaOCR.log.warning(_(u'%s: Seite konnte nicht gelesen werden') % logname)
        finally:
            bfaOCR.ocrlock.release()

        return _buf


    def raise_ocr_error(self):
        self.log.debug(u'%s: raise_ocr_error(self)' % self.name)
        self._job.error = True




