# -*- encoding: UTF-8 -*-
import urllib.request, urllib.parse, urllib.error
import json, codecs,time
import email.generator, mimetypes
import os, stat,  sys
import io
import argparse
import base64
import shutil
import pprint 


OFFICEEXT = [".doc", ".docx", ".odt", ".xls", ".xlsx", ".ppt", ".pptx", ".odt", ".ods", ".odp", ".rtf", ".txt", ".wps"]
OFFICEEXT = [".doc", ".docx", ".dotx", ".odt", ".xls", ".xlsx", ".ppt", ".pptx", ".odt", ".ods", ".odp", ".rtf", ".txt", ".wps", ".asc", ".xml"]

class Callable:
    def __init__(self, anycallable):
        self.__call__ = anycallable

# Controls how sequences are uncoded. If true, elements may be given multiple values by
#  assigning a sequence.
doseq = 1

class MultipartPostHandler(urllib.request.BaseHandler):
    handler_order = urllib.request.HTTPHandler.handler_order - 10 # needs to run first

    def http_request(self, request):
        data = request.get_data()
        if data is not None and type(data) != str:
            v_files = []
            v_vars = []
            try:
                 for (key, value) in list(data.items()):
                     if type(value) is bytes or isinstance(value, io.BytesIO):
                         v_files.append((key, value))
                     else:
                         v_vars.append((key, value))
            except TypeError:
                systype, value, traceback = sys.exc_info()
                raise TypeError("not a valid non-string sequence or mapping object\n%s" % traceback)

            if len(v_files) == 0:
                data = urllib.parse.urlencode(v_vars, doseq)
            else:
                boundary, data = self.multipart_encode(v_vars, v_files)

                contenttype = 'multipart/form-data; boundary=%s' % boundary
                if(request.has_header('Content-Type') and request.get_header('Content-Type').find('multipart/form-data') != 0):
                    print(("Replacing %s with %s" % (request.get_header('content-type'), 'multipart/form-data')))
                request.add_unredirected_header('Content-Type', contenttype)

            request.add_data(data)

        return request

    def multipart_encode(vars, files, boundary=None, buf=None):
        if boundary is None:
            boundary = email.generator._make_boundary()
        if buf is None:
            buf = io.BytesIO()
        for(key, value) in vars:
            buf.write('--%s\r\n' % boundary)
            buf.write('Content-Disposition: form-data; name="%s"' % key)
            if value is None:
                value = ""
            buf.write('\r\n\r\n' + value + '\r\n')
        for(key, fd) in files:
            if isinstance(fd, cStringIO.OutputType):
                fd.seek(0, 2)
                file_size = fd.tell()
                fd.seek(0, 2)
                filename = "stream.dat"
                contenttype = mimetypes.guess_type(filename)[0] or 'application/octet-stream'
            else:
                file_size = os.fstat(fd.fileno())[stat.ST_SIZE]
                filename = fd.name.split('/')[-1]
                contenttype = mimetypes.guess_type(filename)[0] or 'application/octet-stream'
            buf.write('--%s\r\n' % boundary)
            buf.write('Content-Disposition: form-data; name="%s"; filename="%s"\r\n' % (key, filename.encode("utf8")))
            buf.write('Content-Type: %s\r\n' % contenttype)
            # buffer += 'Content-Length: %s\r\n' % file_size
            fd.seek(0)
            buf.write('\r\n' + fd.read() + '\r\n')
        buf.write('--' + boundary + '--\r\n\r\n')
        buf = buf.getvalue()
        return boundary, buf
    multipart_encode = Callable(multipart_encode)

    https_request = http_request


class BfaRenderClient():
    def __init__(self, server):
        self.server = server
    
    def convert(self, **kwargs):
        args = {}
        # Dokument wird als Dateipfad geliefert
        if "inputfile" in kwargs:
            inputfile = kwargs["inputfile"].encode("utf8")
            args["inputfile"] = inputfile
        # Dokument wird als Stream geliefert
        elif "inputstream" in kwargs:
            kwargs["inputstream"].seek(0)
            args["myFile"] = kwargs["inputstream"]
        # Dokument kommt mit dem Request
        elif "myFile" in kwargs:
            args["myFile"] = kwargs["myFile"]
            inputfile = kwargs["myFile"].name
            
        if "iev" in kwargs:
            args["iev"] = open(ievfile, "rb")
        elif "ievstream" in kwargs:
            args["iev"] = kwargs["ievstream"]
        elif "ievdict" in kwargs:
            for pageno, stream in list(kwargs["ievdict"].items()):
                args["iev_%d" %pageno] = stream
        if "inputfile" in kwargs:
            ext = os.path.splitext(inputfile)[1].lower()
            if ext == ".tif":
                if "outtype" in kwargs:
                    if kwargs["outtype"] == "png":
                        args["outtypes"] = "png"
                        if "pngoptions" in kwargs:
                            args["pngoptions"] = kwargs["pngoptions"]
                    if kwargs["outtype"] == "tif":
                        args["outtypes"] = "tif"
                

        args["outtypes"] = kwargs["outtype"]
        if "tifoptions" in kwargs:
            args["tifoptions"] = kwargs["tifoptions"]
        args["outtypes"] = kwargs["outtype"]
        if "emloptions" in kwargs:
            args["emloptions"] = kwargs["emloptions"]
        validatorURL = "http://"+self.server+"/renderservice/multiconvert"
        opener = urllib.request.build_opener(MultipartPostHandler)
        openerres = opener.open(validatorURL, args)
        result = openerres.read()
        obj = json.loads(result)
        
        return obj
                        
                    
                    
if __name__ == "__main__":
    c = BfaRenderClient("th_migrate354_1:57076")
    result = c.convert(inputfile="test.tif", outtype="png", pngoptions='color=color')
    pass
        
