#!/usr/bin/env python
# -*- coding: latin-1 -*-

import os
import sys
import threading
#import select
import shutil
import Queue
import logging
import codecs
#import logging.config
import datetime,  time
import cStringIO
import warnings
import subprocess
#import win32com
#import win32com.client
#from win32com.client import Dispatch, GetActiveObject
import pythoncom
import socket
import gettext
from collections import deque
#from requestHandler import *
import glob
import zipfile
import bitfarm_proc
import bitfarm_doc
#import bitfarm_doc_shared
import bitfarm_xml
import bitfarm_workflow

import ghostscript
import pyPdf
#from ghostscript import _gsprint as gs

import atlas_opt as atlas
from bfaRenderClient import BfaRenderClient

try:
    import thtiflib
    thtiflibimported = True
except:
    thtiflibimported = False

OOFFICEEXT = ['.odt', '.ods', '.odg', '.odp', '.odf', '.ott', '.otp', '.ots', '.otg', '.sdw', '.stw', '.sdc', '.stc', '.sxc', '.sdd', '.sti', '.sxi', '.sxd', '.std', '.sda', '.sxm', '.smf', '.vor']
MSWORDEXT = ['.doc', '.docx', '.dot', '.dotm']
MSEXCELEXT = ['.xls', '.xlsx', '.xlt', '.xlm', '.xlst', '.xslm']
MSPOWERPOINTEXT = ['.ppt', '.pptx']
HTMLEXT = [".html", ".htm"]
MSOFFICEEXT = MSWORDEXT[:]
MSOFFICEEXT.extend(MSEXCELEXT)
MSOFFICEEXT.extend(MSPOWERPOINTEXT)
PS2TIFEXT = ['.ps' ]
PDF2TIFEXT = ['.pdf']
PDFTYPES = {None:'"-dPDFX"', 'pdfx':'"-dPDFX"', 'pdfa':"-dPDFA=1", 'pdfa1':"-dPDFA=1", 'pdfa2':"-dPDFA=2"}
GSORIENTATION ={'portrait': '"<< /Orientation 0>> setpagedevice"', 'seascape': '"<< /Orientation 1>> setpagedevice"',  'upsidedown': '"<< /Orientation 2>> setpagedevice"', 'landscape': '<< /Orientation 3>> setpagedevice'}

try:
    trans = gettext.translation("bfaArchiving", "locale", ['en'],  fallback = True)
    trans.install()
except:
    print(u'Keine bersetzung gefunden/no translation found')
    _ = lambda x: x
else:
    _ = trans.ugettext



class ServicePrinter(object):
    """ServicePrinter-Klasse
    Stellt TCP-Serviceprinter zur Verfgung, beginnend mit TCP-ServicePrinter01 auf Port 9100
    Etabliert den Socket fr den jeweiligen Printer
    """
    log = logging.getLogger('Main.Serviceprinter')
    count = 0

    def __init__(self, con):
            conn = None
            self.con = con
            ServicePrinter.count +=1
            self.name = "TCP-Serviceprinter%02i" %ServicePrinter.count
            self.host = '127.0.0.1'
            self.port = 9099 + ServicePrinter.count
            self.timeout = 10
            #self.sock = None
            self.sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            self.sock.bind((self.host, self.port))
            self.sock.setblocking(1)
            self.sock.settimeout(self.timeout)
            self.sock.listen(1)

            self.log.info("%s up  port=%s  host=%s" %(self.name, self.port, self.host))

    def delete(self):
        ServicePrinter.count -= 1
        self.sock.close()
        self.log.info(u'Serviceprinter %s geschlossen' %self.name)


class bfaRendering(threading.Thread):
    result = []
    resultlock = threading.Lock()
    gslock = threading.Lock()
    wordlock = threading.Lock()
    excellock = threading.Lock()
    powerpointlock = threading.Lock()
    oolock = threading.Lock()
    rtc_list = []
    rtc_list_lock = threading.Lock()
    queue_cnt = 1
    queue = Queue.Queue(0)
    split_size = 1024*1024/2
    count = 0
    log = logging.getLogger("Main.bfaRendering")
    #GS = ghostscript.Ghostscript()
    GS = None


    def __init__(self, con, service_printer):
        threading.Thread.__init__(self)
        self._job = None
        self.con = con
        self.timeout = 0
        self.ps_stream_sum = deque([524288], 5)
        self.ps_stream_time = deque([1], 5)
        self.wordapp = None
        self.excelapp = None
        self.powerpointapp = None
        self.printer = service_printer
        self.log.info('%s: Serviceprinter erstellt %s' %(self.name,  self.printer.name))
        self.serviceprinter_timeout = 10
        self.officeprint_timeout = 10
        self.RECBUF = 1024 * 1024 / 10
        self.ps_stream = None
        self.bfaProc = bitfarm_proc.BitfarmDocProcessing(self.con)
        bfaRendering.count +=1
        self.log.info(_(u'%s: Render-Thread initialisiert') %self.name)


    def run(self):

#        pythoncom.CoInitialize()
#        self.wordapp = Dispatch("Word.Application")
#        self.wordapp.Visible = 0
#
#        self.excelapp = Dispatch('Excel.Application')
#        self.excelapp.Visible = 0
#        self.excelapp.AskToUpdateLinks = 0
#
#        self.powerpointapp =  Dispatch('PowerPoint.Application')
#        self.powerpointapp.DisplayAlerts= 0
#        try:
#            self.powerpointapp.Visible = 0
#        except:
#            pass    #schmeisst wohl immer eine exception

        while self.is_alive():
            self.ps_stream = cStringIO.StringIO()
#            self.ps_stream.truncate()
#            self.ps_stream.seek(0)

            self._job = bfaRendering.queue.get()
            self.log.debug(_(u"%s: rendere [%s] (%i aktive tasks)") %(self.name, self._job.gdocid, bfaRendering.queue.unfinished_tasks))
#            qtime = int(self.name[7:]) * 3
#
#            start = time.time()
#            self.timeout = start + 1
#            time.sleep(10)
#            for i in range(qtime):
#                self.log.debug(u"verarbeite rendern %i" %i)
#                time.sleep(0.3)

            if  self._job.path is None:
                self._job.error = True
                self._job.errortext = _(u'Es wurde keine Datei bergeben [%s]') %str(self._job.gdocid)
                self.log.error(self._job.errortext )
            elif not os.path.exists(os.path.expandvars(self._job.path)):
                self._job.error = True
                self._job.errortext = _(u'123 Die Datei %s konnte nicht gefunden werden') %os.path.expandvars(str(self._job.path))
                self.log.error(self._job.errortext )
            else:
                try:
                    # TODO: aus config lesen
                    if hasattr(self,  self._job.tasks[0].task):
                        getattr(self,  self._job.tasks[0].task)()
                    else:
                        self._job.result = False
                        self._job.error = True
                        self._job.errortext = _("Die Funktion %s konnte nicht gefunden werden") %self._job.tasks[0].task
                        self.log.error(self._job.errortext)
                        #print dir(self)

                    self.log.debug(_('%s: verarbeitet: %s') %(self.name, self._job))
                except:
                    self.log.exception(_('%s: Fehler in der Verarbeitung') %self.name)

            if self._job is not None:
                bfaRendering.resultlock.acquire()
                try:
                    if self._Thread__stopped:
                        break
                    if type(self._job) is list:
                        self.__class__.result.extend(self._job)
                        if bfaRendering.queue.unfinished_tasks > 0:
                            bfaRendering.queue.task_done()
                        self.timeout = 0
                        self._job = None
                    elif self._job is not None:
                        self.__class__.result.append(self._job)
                        if bfaRendering.queue.unfinished_tasks > 0:
                            bfaRendering.queue.task_done()
                        self.timeout = 0
                        self._job = None
                    else:
                        self.log.error(_(u'%s: kein Job fr die Rckgabe mehr vorhanden.') %self.name)

                finally:
                    bfaRendering.resultlock.release()
                    self.log.debug(_(u"%s: rendern fertig: %s") %(self.name, str(self._job)))
                    if self.ps_stream is not None:
                        self.ps_stream.close()
                    self.ps_stream = None
                    #del self._job
            else:
                self.log.error(_(u'%s: kein Job fr die Rckgabe mehr vorhanden.') %self.name)


        self.log.warning(_(u'%s: Thread wurde gestoppt') %self.name)
        if self.ps_stream is not None:
            self.ps_stream.close()
        self.ps_stream = None
#        pythoncom.CoUninitialize()


    def render_to_cache(self):

        self.log.debug(u'%s: render_to_cache' %self.name)

        params = self._job.tasks[0].params

        # Wird der Job schon verarbeitet?
        relevant_params = str(self._job.gdocid)+str(params.img_createatlas)+str(params.img_outpath)
        bfaRendering.rtc_list_lock.acquire()
        if relevant_params in bfaRendering.rtc_list:
            self.log.warning(_(u'%s: render_to_cache: Job wird bereits verarbeitet') %(self.name))
            self._job.result = False
            bfaRendering.rtc_list_lock.release()
            return None
        else:
            bfaRendering.rtc_list.append(relevant_params)
        bfaRendering.rtc_list_lock.release()

        if not os.path.exists(os.path.join(self.con.main.bfapath, 'FilterV4.exe')):
            self.log.warning(_(u'%s: konnte FilterV4.exe nicht finden') %(self.name))
            self._job.result = False
            bfaRendering.rtc_list_lock.acquire()
            bfaRendering.rtc_list.remove(relevant_params)
            bfaRendering.rtc_list_lock.release()
            return None

        filterargs =[os.path.join(self.con.main.bfapath, 'FilterV4.exe'), '-in=' + os.path.expandvars(self._job.docloc)]
        if params.img_createatlas is True:
            if not os.path.isdir(params.img_outpath):
                os.makedirs(params.img_outpath)
            else:
                # thumbnailverzeichnis aufrumen
                for f in os.listdir(params.img_outpath):
                    os.remove(os.path.join(params.img_outpath, f))
            # atlas -> splitten
            params.img_split = True
            # Anpassen des outpaths fr Filterv4
            outdir = params.img_outpath
            params.img_outpath = os.path.join(params.img_outpath, str(self._job.gdocid)+"."+params.img_format)
            filterargs.append("-color")
        else:
            filterargs.append("-color")
        filterargs.append("-format="+params.img_format)

        if params.img_width is not None:
            filterargs.append("-width="+str(params.img_width))
        if params.img_height is not None:
            filterargs.append("-height="+str(params.img_height))
        if params.page is not None:
            filterargs.append("-page="+str(params.page))
        if params.img_split is True:
            filterargs.append("-split")
        if params.img_merge_anno is not None:
            filterargs.append("-anno="+params.img_merge_anno)
            if "-split" in filterargs:
                filterargs.remove("-split")

        filterargs.append("-out="+params.img_outpath)
        res = self._do_filter(filterargs)
        if res is True and params.img_createatlas is True:
            #time.sleep(1)
            filenames = [os.path.join(outdir, f) for f in os.listdir(outdir)]
            if params.img_createatlas is True:
                ret = atlas.create(os.path.join(outdir, "thumbnail"), filenames, None)
                if not ret:
                    res = False
                else:
                    # atlas-file und atlas-png sind erzeugt, thumbnails knnen gelscht werden
                    for f in os.listdir(outdir):
                        if not f.startswith("thumbnail"):
                            os.remove(os.path.join(outdir, f))

        # Job wieder freigeben
        bfaRendering.rtc_list_lock.acquire()
        bfaRendering.rtc_list.remove(relevant_params)
        bfaRendering.rtc_list_lock.release()

        #TODO: result prfen, auch im Dateisystem -> Log-Warning
        self._job.result = res

    def render_by_type(self):
        self.log.debug(u'%s: render_by_type' %self.name)
        ext = 'unknown'
        self._job.result = False
        ext =  os.path.splitext(self._job.path)[1].lower()
        # now establish a connection to the next converterserver
        server = None
        isolated = None
        
        if ext in MSWORDEXT:
            try:
                s = time.perf_counter()
                if self.con.main.ini['office'].mswordinstalled and self.wordapp is not None:
                    self.doc_to_tif()
                else:
                    self.odt_to_tif()
                self._job.result = True
                self.log.debug(_(u'%s Funktion durchgefhrt %s') %(self.name, str(time.perf_counter()-s)))
            except:
                self.log.exception(_(u'%s: Fehler in der Verarbeitung von doc_to_tif') % self.name)
                self._job.result = False
                self._job.error = True
                self._job.errortext = _(u'render_by_type: Fehler bei doc_to_tif')
                while len(self.ps_stream_sum) > len(self.ps_stream_time):
                    self.ps_stream_sum.pop()
        elif ext in MSEXCELEXT:
            try:
                if self.con.main.ini['office'].msexcelinstalled and self.excelapp is not None:
                    self.excel_to_tif()
                else:
                    self.odt_to_tif()
                self._job.result = True
            except:
                self._job.result = False
                self._job.error = True
                self._job.errortext = _(u'render_by_type: Fehler bei excel_to_tif')
        elif ext in MSPOWERPOINTEXT:
            try:
                if self.con.main.ini['office'].mspowerpointinstalled and self.powerpointapp is not None:
                    self.powerpoint_to_tif()
                else:
                    self.odt_to_tif()
                self._job.result = True
            except:
                self._job.result = False
                self._job.error = True
                self._job.errortext = _(u'render_by_type: Fehler bei powerpoint_to_tif')
        elif ext in OOFFICEEXT:
            try:
                self.odt_to_tif()
                self._job.result = True
            except:
                self._job.result = False
                self._job.error = True
                self._job.errortext = _(u'render_by_type: Fehler bei odt_to_tif')
        elif ext in PDF2TIFEXT:
            try:
                self.pdf_to_tif()
                self._job.result = True
            except:
                self._job.result = False
                self._job.error = True
                self._job.errortext = _(u'render_by_type: Fehler bei pdf_to_tif')
        elif ext in PS2TIFEXT:
            try:
                self.ps_to_tif()
                self._job.result = True
            except:
                self._job.result = False
                self._job.error = True
                self._job.errortext = _(u'render_by_type: Fehler bei ps_to_tif')
        elif ext == ".eml":
            try:
                self.eml_to_tif()
                self._job.result = True
            except:
                self._job.result = False
                self._job.error = True
                self._job.errortext = _(u'render_by_type: Fehler bei eml_to_tif')
        elif ext == ".msg":
            try:
                self.msg_to_tif()
                self._job.result = True
            except:
                self._job.result = False
                self._job.error = True
                self._job.errortext = _(u'render_by_type: Fehler bei msg_to_tif')
        elif ext == '.tif':     # nach docloc kopieren falls nicht vorhanden
            if not self._job.docloc:
                self._job.docloc = self._job.path
            else:
                if self._job.docloc != self._job.path:   #nur Eintragen, wenn nicht schon als docloc vorhanden
                    self._job.extloc = self._job.path
            if self._job.srcloc == self._job.path:
                self._job.srcloc = u''
        elif ext in HTMLEXT:
            try:
                self.html_to_tif()
                self._job.result = True
            except:
                self._job.result = False
                self._job.error = True
                self._job.errortext = _(u'render_by_type: Fehler bei html_to_pdf')


        else:   #Dummy-Tif erzeugen

            if ext == '.zip':
                if not zipfile.is_zipfile(self._job.path):
                    self.log.warning(_(u'%s: bergebene Datei kein Zip-File') %self.name)
                    lines = ['', '', '', '', u'  Es konnte keine Voransicht erzeugt werden', '  %s' %os.path.basename(self._job.path), '', '']
                else:
                    zf = zipfile.ZipFile(self._job.path, 'r')
                    lines = ['', '', '  Zip-Datei %s' %self._job.filename, '  Inhalt:']
                    lines.extend(self._list_zip_content(zf, zf.namelist(), '    '))
                    zf.close()
            else:
                lines = ['', '', '', '', u'  Es konnte keine Voransicht erzeugt werden', '  %s' %os.path.basename(self._job.path), '', '']


            self.bfaProc.create_tmploc(self._job, '.tff')
            with open(os.path.expandvars(self._job.tmploc), 'w') as f:
                f.writelines('\n'.join(lines))

            if not os.path.exists(os.path.join(self.con.main.bfapath, 'Text2tif.exe')):
                self.log.warning(_(u'%s: konnte Text2tif.exe nicht finden') %(self.name))
                self._job.result = False
            else:
                timeout = 3000    #5min.
                cnt = 0
                is_timeout = False

                args =[os.path.join(self.con.main.bfapath, 'Text2tif.exe'), os.path.expandvars(self._job.tmploc)]
                try:
                    pipe = subprocess.Popen(args, stdout=subprocess.PIPE, stderr=subprocess.PIPE)

                    while pipe.returncode is None:
                        time.sleep(0.1)
                        cnt += 1
                        if cnt > timeout:
                            self.log.error(_(u'%s: timeout bei Text2tif.exe') %self.name)
                            is_timeout = True
                            break
                        pipe.poll()
                    if is_timeout:
                        self.log.warning(_('%s: beende Text2tif.exe Prozess') %self.name)
                        pipe.terminate()
                        self._job.result = False
                        return None
                except:
                    self.log.exception(_(u'%s Text2tif.exe konnte nicht ausgefhrt werden'))
                else:
                    if os.path.exists(os.path.splitext(os.path.expandvars(self._job.tmploc))[0] + '.tif'):
                        self._job.outfile = os.path.splitext(self._job.tmploc)[0] + '.tif'
                    else:

                        self._job.result = False
                        self._job.error = True
                        self._job.errortext = _(u'render_by_type: Keine Verarbeitungsroutine fr Typ %s gefunden') %ext


    def _list_zip_content(self, zf, filenames,  prefix):
        _ret = []
        for file in filenames:
            if os.path.splitext(file)[1] == '.zip':
                _ret.append(prefix + file)
                newprefix = prefix *2
                new_zf = zf.open(file)
                zf_stream = cStringIO.StringIO()
                zf_stream.write(new_zf.read())
                new_zf.close()
                zf_stream.seek(0)
                new_zf = zipfile.ZipFile(zf_stream, 'r')
                _ret.extend(self._list_zip_content(new_zf, new_zf.namelist(), newprefix))
                new_zf.close()
                zf_stream.truncate()
                del zf_stream
            else:
                _ret.append(prefix + file)
        return _ret

    def _ps_stream_to_tif(self):
        self.log.debug(u'%s _ps_stream_to_tif %s' %(self.name, str(self._job.outfile)))
        if not self._job.outfile:
            return None

        self.ps_stream.seek(0, 2)
        if self.ps_stream.tell() == 0:
            self.log.error(u'%s ps_stream enthlt keine Daten' %self.name)
            return None

        self.ps_stream.seek(0)

        args = self._set_ps_args()
        args.append("-sOutputFile=" +str(self._job.outfile))
        if self._job.tasks[0].params.orientation is not None:
            if self._job.tasks[0].params.orientation in GSORIENTATION:
                args.append('-c')
                args.append(GSORIENTATION[self._job.tasks[0].params.orientation])
                args.append('-f')


        self._run_ghostscript_file(args,  self.ps_stream)

        return True

    def _ps_stream_to_pdf(self):
        self.log.debug(u'%s _ps_stream_to_pdf %s' %(self.name, str(self._job.outfile)))
        if not self._job.outfile:
            return None

        self.ps_stream.seek(0, 2)
        if self.ps_stream.tell() == 0:
            self.log.error(u'%s ps_stream enthlt keine Daten' %self.name)
            return None

        self.ps_stream.seek(0)
        if self._job.tasks[0].params.pdftype in PDFTYPES:
            pdftype = PDFTYPES[self._job.tasks[0].params.pdftype]
        else:
            pdftype = PDFTYPES[None]

#        args = self._set_ps_args()
        args = [
        pdftype,
        "-dBATCH",
        "-dNOPAUSE",
        "-dNOPROMPT",
        "-dNOOUTERSAVE ",
        "-dUseCIEColor",
        "-sProcessColorModel=DeviceCMYK",
        "-sDEVICE=pdfwrite",
        "-sOutputFile=" +str(os.path.expandvars(self._job.outfile))
        ]

        self._run_ghostscript_file(args,  self.ps_stream)

        return True

    def _ps_stream_to_text(self, _txtfile):
        self.log.debug(u'%s ps_stream_to_text %s' %(self.name, str(_txtfile)))

        if not _txtfile:
            return None

        self.ps_stream.seek(0, 2)
        if self.ps_stream.tell() == 0:
            self.log.error(u'%s ps_stream enthlt keine Daten' %self.name)
            return None

        self.ps_stream.seek(0)

        args = [
        "-dBATCH",
        "-dNOPAUSE",
        "-dNOPROMPT",
        "-dSTRICT",
        "-sDEVICE=txtwrite",
        "-dTextFormat=3",
        "-sOutputFile=" +str(os.path.expandvars(self._job.tempname) + '_%04d.txt'),
        "-c quit"
        ]

        self._run_ghostscript_file(args,  self.ps_stream)

        txtfiles = glob.glob(os.path.expandvars(self._job.tempname) + '_????.txt')
        for txtfile in txtfiles:
            try:
                f = open(txtfile, 'r')
                _buf = f.read()
            except:
                self.log.exception(_(u'%s Fehler beim Laden der Txt-datei %s') %(self.name, self._job.tmploc))
            else:
                f.close()

            _buf = _buf.replace('\xc0','\xc3')
            if _buf != '':
                if type(self._job.ftx) is bitfarm_doc.BitfarmFulltext:
                    self._job.ftx.append(_buf.decode('utf8', 'replace'))
                else:
                    self._job.ftx += _buf.decode('utf8', 'replace') + '\0xc'

        for txtfile in txtfiles:
            try:
                os.remove(txtfile)
            except:
                self.log.warning(_(u'%s konnte temporre Tetxtdatei nicht lschen %s') %(self.name,  txtfile))

        self.log.debug(_(u"%s: [%s] Volltext wurde erzeugt") %(self.name, self._job.gdocid))
        return True

    def _ps_stream_to_file(self):
        self.log.debug(u'%s: _ps_stream_to_file' %self.name)
        self.ps_stream.seek(0, 2)
        datalen = self.ps_stream.tell()
        self.ps_stream.seek(0)

        if datalen == 0:
            self.log.warning(_(u'%s _ps_stream_to_file Stream ist leer') %self.name)
            return None

        try:
            f = open(os.path.expandvars(self._job.outfile), "wb")
            while self.ps_stream.tell() < datalen:
                f.write(self.ps_stream.read(self.split_size))
            f.close()
        except:
            self.log.exception(_(u'%s: Fehler bei _ps_stream_to_file') %self.name)

    def receive_ps_stream(self):
        self.log.debug(u'%s receive_ps_stream' %self.name)
        try:
            self.log.debug(u'%s trying to connect to printer on port %d' %(self.name, self.printer.port))
            conn, addr = self.printer.sock.accept()
        except:
            self.log.exception(_(u'%s Timeout beim ffnen des Serviceprinter-Sockets %s') %(self.name, self.printer.name))
            return None
        self.log.debug(u"%s: neuer Druckjob" %self.name)

        try:
            conn.settimeout(self.printer.timeout)
            data = conn.recv(self.RECBUF)
        except:
            self.log.exception(_(u'%s Es konnten keine Daten vom Drucker %s empfangen werden (Timeout)') %(self.name, self.printer.name))
            return None
        while data:
            self.ps_stream.write(data)
            try:
                data = conn.recv(self.RECBUF)
            except:
                self.log.exception(_(u'%s Abbruch beim Datenempfang vom Drucker %s') %(self.name, self.printer.name))
                conn.close()
                return None
        conn.close()
        data = None

        if self.ps_stream.tell() == 0:
            self.log.error(_(u'%s Es wurde kein PS-Stream empfangen') %self.name)
            return None
        else:
            self.log.debug(_(u"%s: Empfangen abgeschlossen, Bytes=%i") %(self.name, self.ps_stream.tell()))
        return True


    def pdf_to_tif(self):
        self.log.debug(u'%s: pdf_to_tif [%s]' %(self.name, self._job))
        if os.path.splitext(self._job.path)[1] != '.pdf':
            self.log.warning(_(u'%s: pdf_to_tif kein untersttztes Dateiformat %s') %(self.name, self._job.path))
            self._job.result = False
            return None

        self.bfaProc.create_outfile(self._job, '.tif')

        args = self._set_ps_args()
#        args.pop(args.index('ps2pdf'))
        args.extend(["-sOutputFile=" +str(os.path.expandvars(self._job.outfile)), "-f", str(os.path.expandvars(self._job.path)), "-c quit"])

        bfaRendering.gslock.acquire()
        try:
            GS = ghostscript.Ghostscript(*args)
            ghostscript.gs.exit(GS._instance)
        except:
            self.log.exception(_(u'%s: Ghostscript-Fehler bei pdf_to_tif [%s]') %(self.name, self._job))
        finally:
            ghostscript.cleanup()
            bfaRendering.gslock.release()
            if GS is not None:
                del GS

        if self._job.tasks[0].params.extract_text:
            self._job.tasks.insert(1, bitfarm_workflow.BitfarmTask('pdf_to_txt'))

        self.log.debug(_(u"%s: [%s] Tif wurde erzeugt %s") %(self.name, self._job.gdocid, self._job.outfile))
        time.sleep(0.5)
        return True


    def ps_to_tif(self):
        self.log.debug(u'%s: ps_to_tif' %self.name)
        if os.path.splitext(os.path.expandvars(self._job.path))[1] != '.ps':
            self.log.warning(_(u'%s: ps_to_tif kein untersttztes Dateiformat %s') %(self.name, self._job.path))
            self._job.result = False
            return None

        self.bfaProc.create_outfile(self._job, '.tif')

        # timeout aufgrund des durchschnitts ermitteln
        start = time.time()
        av = float(sum(self.ps_stream_sum) / sum(self.ps_stream_time))
        self.log.debug(_(u'%s: Performanceermittlung %.2f bps') %(self.name,  av))


        self.ps_stream.seek(0)
        self.ps_stream.truncate()
        datalen = os.path.getsize(os.path.expandvars(self._job.path))

        # wir haben einen durchschnitt? dann setzen wir einen tineout fr die nchste verarbeitung
#        self.timeout = start + ((datalen / av) * 5)
#        self.timeout = start + 100
#        self.log.debug(u'%s: Timeout gesetzt %.2f' %(self.name, (datalen / av) * 5))

        self.ps_stream_sum.append(datalen)

        f = open(os.path.expandvars(self._job.path),  "rb")
        while f.tell() < datalen:
            self.ps_stream.write(f.read(self.split_size))
        f.close()
        self.ps_stream.seek(0)

        self._ps_stream_to_tif()

        if self._job.tasks[0].params.extract_text:
            self._ps_stream_to_text(self._job.tempname + '.txt')

        self.ps_stream_time.append(time.time() - start)
        #self.log.debug(u'%s: neue Performancewerte genommen %s %s' %(self.name, str(self.ps_stream_sum), str(self.ps_stream_time)))

        if not os.path.exists(os.path.expandvars(self._job.outfile)):
            self.log.error(_(u'%s Fehler bei ps_to_tif: Kein tif-file erstellt %s') %(self.name, self._job.outfile))
            return None

        self.log.debug(_(u"%s: [%s] Tif wurde erzeugt %s") %(self.name, self._job.gdocid, self._job.outfile))

    def ps_to_pdf(self):
        self.log.debug(u'%s: ps_to_pdf' %self.name)
        if os.path.splitext(self._job.path)[1] != '.ps':
            self.log.warning(_(u'%s: ps_to_pdf kein untersttztes Dateiformat %s') %(self.name, self._job.path))
            self._job.result = False
            return None

        self.bfaProc.create_outfile(self._job, '.pdf')

        # timeout aufgrund des durchschnitts ermitteln
        start = time.time()
        av = float(sum(self.ps_stream_sum) / sum(self.ps_stream_time))
        self.log.debug(_(u'%s: Performanceermittlung %.2f bps') %(self.name,  av))


        self.ps_stream.seek(0)
        self.ps_stream.truncate()
        datalen = os.path.getsize(os.path.expandvars(self._job.path))

        # wir haben einen durchschnitt? dann setzen wir einen tineout fr die nchste verarbeitung
#        self.timeout = start + ((datalen / av) * 5)
#        self.timeout = start + 100
#        self.log.debug(u'%s: Timeout gesetzt %.2f' %(self.name, (datalen / av) * 5))

        self.ps_stream_sum.append(datalen)

        f = open(os.path.expandvars(self._job.path), "rb")
        while f.tell() < datalen:
            self.ps_stream.write(f.read(self.split_size))
        f.close()
        self.ps_stream.seek(0)

        self._ps_stream_to_pdf()

        if self._job.tasks[0].params.extract_text:
            self._ps_stream_to_text(self._job.tempname + '.txt')

        self.ps_stream_time.append(time.time() - start)
        #self.log.debug(u'%s: neue Performancewerte genommen %s %s' %(self.name, str(self.ps_stream_sum), str(self.ps_stream_time)))

        if not os.path.exists(self._job.outfile):
            self.log.error(_(u'%s Fehler bei ps_to_tif: Kein tif-file erstellt %s') %(self.name, self._job.outfile))
            return None


        self.log.debug(_(u"%s: [%s] Tif wurde erzeugt %s") %(self.name, self._job.gdocid, self._job.outfile))

    def ps_to_text(self):
        self.log.debug(u'%s: ps_to_text' %self.name)
        if os.path.splitext(self._job.path)[1] != '.ps':
            self.log.warning(_(u'%s: ps_to_pdf kein untersttztes Dateiformat %s') %(self.name, self._job.path))
            self._job.result = False
            return None

        self.ps_stream.seek(0)
        self.ps_stream.truncate()
        datalen = os.path.getsize(self._job.path)

        # wir haben einen durchschnitt? dann setzen wir einen tineout fr die nchste verarbeitung
#        self.timeout = start + ((datalen / av) * 5)
#        self.timeout = start + 100
#        self.log.debug(u'%s: Timeout gesetzt %.2f' %(self.name, (datalen / av) * 5))

        self.ps_stream_sum.append(datalen)

        with open(os.path.expandvars(self._job.path), "rb") as f:
            while f.tell() < datalen:
                self.ps_stream.write(f.read(self.split_size))

        self.ps_stream.seek(0)

        self._ps_stream_to_text()


    def _html_to_pdf(self, outfile):
        starttime = time.time()
        self.log.debug(_(u'%s: _html_to_pdf')%(self.name))
        wkhtmlpath =  os.path.join(self.con.main.bfapath, 'wkhtmltopdf\\wkhtmltopdf.exe')
        args=[wkhtmlpath, "--dpi", "300", "--no-pdf-compression", "--disable-javascript", "--output-format", "pdf", os.path.expandvars(self._job.path), os.path.expandvars(outfile)]
        try:
            timeout = 3000    #5min.
            cnt = 0
            is_timeout = False

            pipe = subprocess.Popen(args, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
            while pipe.returncode is None:
                time.sleep(0.1)
                cnt += 1
                if cnt > timeout:
                    self.log.error(_(u'%s: timeout bei wkhtmltopdf.exe') %self.name)
                    is_timeout = True
                    break
                pipe.poll()
            if is_timeout:
                self.log.warning(_('%s: beende wkhtmltopdf.exe Prozess') %self.name)
                pipe.terminate()
                self._job.result = False
                return None
        except:
            self.log.exception(_(u'%s wkhtmltopdf.exe konnte nicht ausgefhrt werden'))
        self.log.debug(_(u'_html_to_pdf runtime: %s' % str(time.time()-starttime)))


    def _rtf_to_html(self):
        self.log.debug(_(u'%s: _rtf_to_html')%(self.name))

        if self.con.main.openofficepath is None:
            oopath = os.path.join(self.con.main.bfapath, 'OpenOfficePortable\\App\\openoffice\\program')
        else:
            oopath = self.con.main.openofficepath
        if not os.path.exists(oopath):
            self.log.warning(_(u'%s: Konnte OpenOfficePfad nicht finden %s') %(self.name, oopath))
            self._job.result = False
            return None
        try:
            args = [os.path.join(oopath, 'soffice.exe'),
                    '-nofirststartwizard',
                    '-headless',
                    '-nocrashreport',
                    '-norestore']

            args.append('macro:///bitfarm.bitfarm.ConvertWordToHTML("%s")' %(os.path.expandvars(self._job.path)))
            bfaRendering.oolock.acquire()
            try:
                timeout = 3000    #5min.
                cnt = 0
                is_timeout = False

                self.log.debug(_(str(args)))
                pipe = subprocess.Popen(args, stdout=subprocess.PIPE, stderr=subprocess.PIPE)

                while pipe.returncode is None:
                    time.sleep(0.1)
                    cnt += 1
                    if cnt > timeout:
                        self.log.error(_(u'%s: timeout bei soffice.exe ConvertWordToHTML') %self.name)
                        is_timeout = True
                        break
                    pipe.poll()
                if is_timeout:
                    self.log.warning(_('%s: beende soffice.exe Prozess') %self.name)
                    pipe.terminate()
                    self._job.result = False
                    return None
            except:
                self.log.exception(_(u'%s soffice.exe konnte nicht ausgefhrt werden'))

        finally:
            bfaRendering.oolock.release()

    def _odt_to_ps(self):
        self.log.debug(_(u'%s: _odt_to_ps auf %s')%(self.name, self.printer.name))

        if self.con.main.openofficepath is None:
            oopath = os.path.join(self.con.main.bfapath, 'OpenOfficePortable\\App\\openoffice\\program')
        else:
            oopath = self.con.main.openofficepath
        if not os.path.exists(oopath):
            self.log.warning(_(u'%s: Konnte OpenOfficePfad nicht finden %s') %(self.name, oopath))
            self._job.result = False
            return None

        self.ps_stream.seek(0)
        self.ps_stream.truncate()
        bfaRendering.oolock.acquire()
        try:
            args = [os.path.join(oopath, 'soffice.exe'),
                    '-nofirststartwizard',
                    '-headless',
                    '-nocrashreport',
                    '-norestore']
#            if os.path.splitext(self._job.outfile)[1] == '.tif': # or os.path.splitext(self._job.path)[1] == '.ppt' or os.path.splitext(self._job.path)[1] == '.pps':
#                args.append('macro:///bitfarm.bitfarm.SpeichernAlsTIF("%s","%s")' %(self._job.path, str(self._job.outfile)))
#            else:
#                args.append('macro:///bitfarm.bitfarm.drucken("%s","%s")' %(self._job.path, self.printer.name))
            args.append('macro:///bitfarm.bitfarm.drucken("%s","%s")' %(os.path.expandvars(self._job.path), self.printer.name))
            #self.receive_ps_stream()
            try:
                timeout = 3000    #5min.
                cnt = 0
                is_timeout = False

                self.log.debug(_(str(args)))
                pipe = subprocess.Popen(args, stdout=subprocess.PIPE, stderr=subprocess.PIPE)

                while pipe.returncode is None:
                    time.sleep(0.1)
                    cnt += 1
                    if cnt > timeout:
                        self.log.error(_(u'%s: timeout bei soffice.exe drucken') %self.name)
                        is_timeout = True
                        break
                    pipe.poll()
                if is_timeout:
                    self.log.warning(_('%s: beende soffice.exe Prozess') %self.name)
                    pipe.terminate()
                    self._job.result = False
                    return None
            except:
                self.log.exception(_(u'%s soffice.exe konnte nicht ausgefhrt werden'))
            else:

                self.receive_ps_stream()

            if self._job.tasks[0].params.extract_text:
                timeout = 3000    #5min.
                cnt = 0
                is_timeout = False

                del args[-1]
                args.append('macro:///bitfarm.bitfarm.SpeichernAlsTXT("%s,%s")' %(os.path.expandvars(self._job.path), os.path.expandvars(self._job.outfile) + '.txt'))
                try:
                    pipe = subprocess.Popen(args, stdout=subprocess.PIPE, stderr=subprocess.PIPE)

                    while pipe.returncode is None:
                        time.sleep(0.1)
                        cnt += 1
                        if cnt > timeout:
                            self.log.error(_(u'%s: timeout bei soffice.exe SpeichernAlsTXT') %self.name)
                            is_timeout = True
                            break
                        pipe.poll()
                    if is_timeout:
                        self.log.warning(_('%s: beende soffice.exe Prozess') %self.name)
                        pipe.terminate()
                        self._job.result = False
                        return None
                except:
                    self.log.exception(_(u'%s soffice.exe konnte nicht ausgefhrt werden'))
                else:
                    if os.path.exists(os.path.expandvars(self._job.outfile) + '.txt'):
                        try:
                            f = codecs.open(os.path.expandvars(self._job.outfile) + '.txt', encoding='latin1')
                            self._job.ftx.text = f.read()
                            f.close()
                        except:
                            self._job.ftx.text = u""

                        try:
                            os.remove(os.path.expandvars(self._job.outfile) + '.txt')
                        except:
                            self.log.warning(_(u'%s: konnte temporre Volltextdatei nicht lschen %s') %(self.name, self._job.outfile + '.txt'))
                    else:
                        self._job.ftx.text = u""
            time.sleep(0.1)

        finally:
            bfaRendering.oolock.release()


    def odt_to_ps(self):
        self.log.debug(u'%s: odt_to_ps auf %s' %(self.name, self.printer.name))
        if os.path.splitext(self._job.path)[1] not in OOFFICEEXT:
            self.log.warning(_(u'%s: odt_to_ps kein untersttztes Dateiformat %s') %(self.name, self._job.path))
            self._job.result = False
            return None

        self.bfaProc.create_outfile(self._job, '.ps')

        self._odt_to_ps()

        self._ps_stream_to_file()

        if not os.path.exists(os.path.expandvars(self._job.outfile)):
            self._job.result = False
            self._job.errortext = _(u'Fehler bei odt_to_ps: Kein ps-file erstellt %s') %self._job.outfile
            self._job.error = True
            self.log.exception(self.name + ' '+ self._job.errortext)
            return None

        return True

    def html_to_pdf(self):
        self.log.debug(u'%s: html_to_pdf' %(self.name))
        if os.path.splitext(self._job.path)[1] not in HTMLEXT:
            self.log.warning(_(u'%s: html_to_pdf kein untersttztes Dateiformat %s') %(self.name, self._job.path))
            self._job.result = False
            return None

        self.bfaProc.create_outfile(self._job, '.pdf')

        self._html_to_pdf(self._job.outfile)


        if not os.path.exists(os.path.expandvars(self._job.outfile)):
            self._job.result = False
            self._job.errortext = _(u'Fehler bei html_to_pdf: Kein pfd-file erstellt %s') %self._job.outfile
            self._job.error = True
            self.log.error(self.name + ' '+ self._job.errortext)
            return None

        return True

    def html_to_tif(self):
        self.log.debug(u'%s: html_to_tif' %(self.name))
        if os.path.splitext(self._job.path)[1] not in HTMLEXT:
            self.log.warning(_(u'%s: html_to_pdf kein untersttztes Dateiformat %s') %(self.name, self._job.path))
            self._job.result = False
            return None

        self.bfaProc.create_tmploc(self._job, '.pdf')

        self._html_to_pdf(self._job.tmploc)

        if not os.path.exists(os.path.expandvars(self._job.tmploc)):
            self._job.result = False
            self._job.errortext = _(u'Fehler bei html_to_tif: Kein pfd-file erstellt %s') %self._job.outfile
            self._job.error = True
            self.log.exception(self.name + ' '+ self._job.errortext)
            return None

        self._job.path = self._job.tmploc
        self.bfaProc.create_outfile(self._job, '.tif')

        self.pdf_to_tif()
        self._job.path = os.path.splitext(self._job.path)[0]+".html"

        if not os.path.exists(os.path.expandvars(self._job.outfile)):
            self._job.result = False
            self._job.errortext = _(u'Fehler bei html_to_pdf: Kein tif-file erstellt %s') %self._job.outfile
            self._job.error = True
            self.log.error(self.name + ' '+ self._job.errortext)
            return None

        return True

    def odt_to_tif(self):
        self.log.debug(u'%s: odt_to_tif auf %s' %(self.name, self.printer.name))
        if os.path.splitext(self._job.path)[1] not in OOFFICEEXT and os.path.splitext(self._job.path)[1] not in MSOFFICEEXT:
            self.log.warning(_(u'%s: odt_to_tif kein untersttztes Dateiformat %s') %(self.name, self._job.path))
            self._job.result = False
            return None

        self.bfaProc.create_outfile(self._job, '.tif')

        self._odt_to_ps()

        self._ps_stream_to_tif()

        if not os.path.exists(os.path.expandvars(self._job.outfile)):
            self._job.result = False
            self._job.errortext = _(u'Fehler bei odt_to_tif: Kein tif-file erstellt %s') %self._job.outfile
            self._job.error = True
            self.log.error(self.name + ' '+ self._job.errortext)
            return None

        return True

    def odt_to_pdf(self):
        self.log.debug(u'%s: odt_to_pdf auf %s' %(self.name, self.printer.name))
        if os.path.splitext(self._job.path)[1] not in OOFFICEEXT:
            self.log.warning(_(u'%s: odt_to_pdf kein untersttztes Dateiformat %s') %(self.name, self._job.path))
            self._job.result = False
            return None

        self.bfaProc.create_outfile(self._job, '.pdf')

        self._odt_to_ps()

        self._ps_stream_to_pdf()

        if not os.path.exists(os.path.expandvars(self._job.outfile)):
            self._job.result = False
            self._job.errortext = _(u'Fehler bei odt_to_pdf: Kein pdf-file erstellt %s') %self._job.outfile
            self._job.error = True
            self.log.exception(self.name + ' '+ self._job.errortext)
            return None

        return True


    def _set_ps_args(self):
        _ret = [
        "ps2pdf",
        "-dNOPAUSE",
        "-dNOPROMPT",
        "-dBATCH",
        "-dSAFER",
        "-dSTRICT",
        "-dNOOUTERSAVE",
        "-dQUIET",
        "-dNUMRENDERINGTHREADS=2",
        "-dMAXBITMAP=30000000",
        "-dMAXPATTERNBITMAP=200000",
        "-dDITHERPPI=600"
        ]

        if self._job.tasks[0].params.img_resolution is not None:
            _ret.append("-r%s" %self._job.tasks[0].params.img_resolution)
        else:
            _ret.append("-r300")

        if self._job.tasks[0].params.img_colordepth is not None:
            if self._job.tasks[0].params.img_colordepth == "bw":
                _ret.append("-sDEVICE=tiffg4")
            elif self._job.tasks[0].params.img_colordepth == "gray":
                _ret.append("-sDEVICE=tiffgray")
                _ret.append("-sCompression=lzw")
            elif self._job.tasks[0].params.img_colordepth == "color":
                _ret.append("-sDEVICE=tiff24nc")
                _ret.append("-sCompression=lzw")
        else:
            _ret.append("-sDEVICE=tiffg4")

        return _ret

    def _run_ghostscript_file(self,  args,  fileobj):
        self.log.debug(u'%s: _run_ghostscript_file' %self.name)
        bfaRendering.gslock.acquire()
        try:
            GS = ghostscript.Ghostscript()
            ghostscript.gs.init_with_args(GS._instance, args)
            try:
                GS.run_file(fileobj)
            except:
                self.log.exception(_(u'Ghostscript-Fehler'))

            ghostscript.gs.exit(GS._instance)
        except:
            self.log.exception(_(u'Ghostscript-Fehler'))
        finally:
            ghostscript.cleanup()
            bfaRendering.gslock.release()
            del GS

    def custom_converter(self):
        self.log.debug(u'%s: custom_converter' %self.name)

        if self._job.tasks[0].params.cc_converter is None:
            self.log.warning(_(u'%s: Kein Converter angegeben') %self.name)
            self._job.result = False
            return None

        if os.path.isfile(self._job.tasks[0].params.cc_converter):
            tool = self._job.tasks[0].params.cc_converter
        else:
            tool = os.path.join(self.con.main.bfapath, self._job.tasks[0].params.cc_converter)

        if not os.path.exists(tool):
            self.log.warning(_(u'%s: Kein Converter gefunden %s') %(self.name, tool))
            self._job.result = False
            return None

        if self._job.tasks[0].params.cc_ext is None:
            self.log.warning(_(u'%s: Kein Extension angegeben, es wird .tif erwartet') %self.name)
            ext = '.tif'
        else:
            ext = self._job.tasks[0].params.cc_ext

        if self._job.tasks[0].params.cc_args is None:
            self.log.warning(_(u'%s: Kein Argumente angegeben, es wird das Dokument bergeben') %self.name)
            args = [self._job.path]
        else:
            args = self._job.tasks[0].params.cc_args.split(';')

        for ind in range(len(args)):
            if args[ind].find('%outfile%') > -1:
                self.bfaProc.create_outfile(self._job, ext)
                args[ind] = args[ind].replace('%outfile%', os.path.expandvars(self._job.outfile))
            if args[ind].find('%tmploc%') > -1:
                self.bfaProc.create_tmploc(self._job, ext)
                args[ind] = args[ind].replace('%tmploc%', os.path.expandvars(self._job.tmploc))
            if args[ind].find('%docloc%') > -1:
                if self._job.docloc is not None:
                    args[ind] = args[ind].replace('%docloc%', os.path.expandvars(self._job.docloc))
            if args[ind].find('%extloc%') > -1:
                if self._job.extloc is not None:
                    args[ind] = args[ind].replace('%extloc%', os.path.expandvars(self._job.extloc))
            if args[ind].find('%oriloc%') > -1:
                if self._job.oriloc is not None:
                    args[ind] = args[ind].replace('%oriloc%', os.path.expandvars(self._job.oriloc))
            if args[ind].find('%srcloc%') > -1:
                if self._job.srcloc is not None:
                    args[ind] = args[ind].replace('%srcloc%', os.path.expandvars(self._job.srcloc))
            if args[ind].find('%infile%') > -1:
                args[ind] = args[ind].replace('%infile%', os.path.expandvars(self._job.path))

        if self._job.tasks[0].params.timeout is not None:
            timeout = self._job.tasks[0].params.timeout
        else:
            timeout = 300

        if self._job.tasks[0].params.timeout_per_page is not None:
            if self._job.pages is None:
                bitfarm_doc_shared.get_fileinfo(self._job)
            if self._job.pages is not None:
                timeout = int(self._job.tasks[0].params.timeout_per_page  * self._job.pages)

        timeout *= 10
        cnt = 0
        is_timeout = False

        args.insert(0,  tool)
        try:
            self.log.debug(_(u'%s: starte custom_converter %s') %(self.name, " ".join(args)))
            pipe = subprocess.Popen(args, stdout=subprocess.PIPE, stderr=subprocess.PIPE)

            while pipe.returncode is None:
                time.sleep(0.1)
                cnt += 1
                if cnt > timeout:
                    self.log.error(_(u'%s: timeout bei custom_converter') %self.name)
                    is_timeout = True
                    break
                pipe.poll()
            if is_timeout:
                self.log.warning(_('%s: beende custom_converter Prozess') %self.name)
                pipe.terminate()
                self._job.result = False
                return None
        except:
            self.log.exception(_(u'%s custom_converter konnte nicht ausgefhrt werden'))


        if pipe.returncode != 0:
            self.log.error(_(u'%s: custom_converter meldet einen Fehler rc= %i') %(self.name, pipe.returncode))
            self._job.result = False
            return None


        if self._job.outfile:
            if not os.path.exists(os.path.expandvars(self._job.outfile)):
                self.log.error(_(u'%s: custom_converter nicht erfolgreich, keine Datei erzeugt') %self.name)
                self.result = False
                self.error = True
                self._job.outfile = None
        elif self._job.tmploc:
            if not os.path.exists(os.path.expandvars(self._job.tmploc)):
                self.log.error(_(u'%s: custom_converter nicht erfolgreich, keine Datei erzeugt') %self.name)
                self.result = False
                self.error = True
        else:
            if ext != os.path.splitext(self._job.path)[1]:  #Datei mit neuer Endung erzeugt
                if not os.path.exists(os.path.expandvars(os.path.splitext(self._job.path))[0] + ext):
                    self.log.error(_(u'%s: custom_converter nicht erfolgreich, keine Datei erzeugt') %self.name)
                    self.result = False
                    self.error = True
                else:
                    self._job.outfile = os.path.splitext(self._job.path)[0] + ext
            else:
                if not os.path.exists(os.path.expandvars(self._job.path)):
                    self.log.error(_(u'%s: custom_converter nicht erfolgreich, keine Datei erzeugt') %self.name)
                    self.result = False
                    self.error = True


    def filter(self):
        self.log.debug(u'%s: filter' %self.name)

        if not os.path.exists(os.path.join(self.con.main.bfapath, 'FilterV4.exe')):
            self.log.warning(_(u'%s: konnte FilterV4.exe nicht finden') %(self.name))
            self._job.result = False
            return None

        args =[os.path.join(self.con.main.bfapath, 'FilterV4.exe'), '-in=' + os.path.expandvars(self._job.path)]


        if self._job.tasks[0].params.img_format is not None:    # wir haben ein Zielformat? Neue Datei erzeugen...
            self.bfaProc.create_outfile(self._job, self._job.tasks[0].params.img_format)
            args.append('-out='+ os.path.expandvars(self._job.outfile))
        else:
            if self._job.tasks[0].params.destination is not None:  # wir haben ein Zielort? Neue Datei erzeugen...
                self.bfaProc.create_outfile(self._job, os.path.splitext(self._job.path)[1])
                args.append('-out='+ os.path.expandvars(self._job.outfile))
            else:
                args.append('-out=' + os.path.expandvars(self._job.path))   # wir filtern die Eingangsdatei


        if self._job.tasks[0].params.img_resolution is not None:
            args.append('-res=' + str(self._job.tasks[0].params.img_resolution))

        if self._job.tasks[0].params.img_rotate is not None:
            args.append('-rotate=' + str(self._job.tasks[0].params.img_rotate))

        if self._job.tasks[0].params.img_turn is not None:
            args.append('-turn=' + str(self._job.tasks[0].params.img_turn))

        if self._job.tasks[0].params.img_setfilter is not None:
            args.append('-setfilter=' + str(self._job.tasks[0].params.img_setfilter))

        if self._job.tasks[0].params.img_removepix is not None:
            args.append('-rempix=' + str(self._job.tasks[0].params.img_removepix))

        if self._job.tasks[0].params.img_negative == True:
            args.append('-negative')

        if self._job.tasks[0].params.img_dither == True:
            args.append('-dither')

        if self._job.tasks[0].params.img_noise == True:
            args.append('-noise')

        if self._job.tasks[0].params.img_sharpen == True:
            args.append('-sharpen')

        if self._job.tasks[0].params.img_white == True:
            args.append('-white')

        if self._job.tasks[0].params.img_autocrop == True:
            args.append('-autocrop')

        if self._job.tasks[0].params.img_nonproportional == True:
            args.append('-nonprop')

        if self._job.tasks[0].params.img_split == True:
            args.append('-split')

        if self._job.tasks[0].params.img_skew is not None:
            args.append('-skew=' + str(self._job.tasks[0].params.img_skew))

        if self._job.tasks[0].params.img_size is not None:
            args.append('-size=' + str(self._job.tasks[0].params.img_size))

        if self._job.tasks[0].params.img_width is not None:
            args.append('-width=' + str(self._job.tasks[0].params.img_width))

        if self._job.tasks[0].params.img_height is not None:
            args.append('-height=' + str(self._job.tasks[0].params.img_height))

        if self._job.tasks[0].params.img_removered is not None:
            args.append('-remred=' + str(self._job.tasks[0].params.img_removered))

        if self._job.tasks[0].params.img_removegreen is not None:
            args.append('-remgreen=' + str(self._job.tasks[0].params.img_removegreen))

        if self._job.tasks[0].params.img_removeblue is not None:
            args.append('-remblue=' + str(self._job.tasks[0].params.img_removeblue))

        if self._job.tasks[0].params.img_cutleft is not None:
            args.append('-cutleft=' + str(self._job.tasks[0].params.img_cutleft))

        if self._job.tasks[0].params.img_cutright is not None:
            args.append('-cutright=' + str(self._job.tasks[0].params.img_cutright))

        if self._job.tasks[0].params.img_cuttop is not None:
            args.append('-cuttop=' + str(self._job.tasks[0].params.img_cuttop))

        if self._job.tasks[0].params.img_cutbottom is not None:
            args.append('-cutbottom=' + str(self._job.tasks[0].params.img_cutbottom))

        if self._job.tasks[0].params.img_cropleft is not None:
            args.append('-cropleft=' + str(self._job.tasks[0].params.img_cropleft))

        if self._job.tasks[0].params.img_cropright is not None:
            args.append('-cropright=' + str(self._job.tasks[0].params.img_cropright))

        if self._job.tasks[0].params.img_croptop is not None:
            args.append('-croptop=' + str(self._job.tasks[0].params.img_croptop))

        if self._job.tasks[0].params.img_cropbottom is not None:
            args.append('-cropbottom=' + str(self._job.tasks[0].params.img_cropbottom))

        if self._job.tasks[0].params.img_colordepth is not None:
            if self._job.tasks[0].params.img_colordepth == 'bw':
                if self._job.tasks[0].params.img_bw_threshold is not None:
                    args.append('-bw=' + str(self._job.tasks[0].params.img_bw_threshold))
                else:
                    args.append('-bw=-2')
            elif self._job.tasks[0].params.img_colordepth == 'gray':
                args.append('-gray')
            elif self._job.tasks[0].params.img_colordepth == 'color':
                args.append('-color')

        if self._job.tasks[0].params.img_merge_anno is not None:
            if os.path.isfile(self._job.tasks[0].params.img_merge_anno) and os.path.exists(os.path.expandvars(self._job.tasks[0].params.img_merge_anno)):
                if os.path.splitext(self._job.tasks[0].params.img_merge_anno)[1] == '.iev':
                    args.append('-anno=' + str(os.path.expandvars(self._job.tasks[0].params.img_merge_anno)))

        if self._job.tasks[0].params.img_merge_layer is not None:
            if os.path.isfile(self._job.tasks[0].params.img_merge_layer) and os.path.exists(os.path.expandvars(self._job.tasks[0].params.img_merge_layer)):
                args.append('-layer=' + str(os.path.expandvars(self._job.tasks[0].params.img_merge_layer)))


        if self._job.tasks[0].params.img_compression is not None:
            if self._job.tasks[0].params.img_compression.lower() == 'lzw':
                args.append('-complzw')
            elif self._job.tasks[0].params.img_compression.lower() == 'faxg4':
                args.append('-compg4')
            elif self._job.tasks[0].params.img_compression.lower() == 'jpg':
                if self._job.tasks[0].params.img_comprate is not None:
                    args.append('-compjpg=' + str(self._job.tasks[0].params.img_comprate))
                else:
                    args.append('-compjpg')
            elif self._job.tasks[0].params.img_compression.lower() == 'auto':
                if self._job.tasks[0].params.img_comprate is not None:
                    args.append('-compauto=' + str(self._job.tasks[0].params.img_comprate))
                else:
                    args.append('-compauto')

        if self._job.tasks[0].params.page is not None:
            args.append('-page=' + str(self._job.tasks[0].params.page))
        elif self._job.tasks[0].params.pages is not None:
            args.append('-page=' + str(self._job.tasks[0].params.pages))

        if self._job.tasks[0].params.timeout is not None:
            timeout = self._job.tasks[0].params.timeout
        else:
            timeout = 300

        if self._job.tasks[0].params.timeout_per_page is not None:
            if self._job.pages is None:
                bitfarm_doc_shared.get_fileinfo(self._job)
            if self._job.pages is not None:
                timeout = int(self._job.tasks[0].params.timeout_per_page  * self._job.pages)

        if len(args) > 2:
            self._job.result = bfaRendering._do_filter(args, timeout, self.name)

            if self._job.outfile is not None:
                if not os.path.exists(os.path.expandvars(self._job.outfile)):
                    self.log.error(_(u'%s: Filtern nicht erfolgreich, keine Datei erzeugt') %self.name)
                    self.result = False
                    self.error = True
                    self._job.outfile = None
            else:
                if not os.path.exists(os.path.expandvars(self._job.path)):
                    self.log.error(_(u'%s: Filtern nicht erfolgreich, keine Datei erzeugt') %self.name)
                    self.result = False
                    self.error = True
        else:
            self.result = False

    @staticmethod
    def _do_filter(args,  timeout = 300, selfname = '_do_filter'):
        if len(args) < 3:
            return False

        try:
            timeout *= 10
            cnt = 0
            is_timeout = False
            bfaRendering.log.debug(_('%s: starte FilterV4 args = %s') %(selfname, " ".join(args)))
            #startupinfo = subprocess.STARTUPINFO()
            #startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW
            #pipe = subprocess.Popen(args, stdout=subprocess.PIPE, stderr=subprocess.PIPE, startupinfo=startupinfo)
            pipe = subprocess.Popen(args, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
            while pipe.returncode is None:
                time.sleep(0.1)
                cnt += 1
                if cnt > timeout:
                    bfaRendering.log.error(_(u'%s: timeout bei Filter') %selfname)
                    is_timeout = True
                    break
                pipe.communicate()
                pipe.poll()
            if is_timeout:
                bfaRendering.log.warning(_('%s: beende Filter Prozess') %selfname)
                pipe.terminate()
                return False
        except:
            bfaRendering.log.exception(_(u'%s Filterv4.exe konnte nicht ausgefhrt werden') %selfname)
            return False
        return True


    def raise_render_error(self):
        self.log.debug(u'%s: raise_render_error' %self.name)
        self._job.error = True

