#!/usr/bin/python
# -*- coding: utf-8 -*-
import gobject
import gtk
import sys

import codecs

import bitfarm_doc
import bitfarm_proc
#import bitfarm_workflow

class Classifier():
    
    def __init__(self, mainwin, db, wfproc, bfaproc):
        
        self.db = db
        self.wfproc = wfproc
        self.bfaProc = bfaproc
        self.wfproc.read_docclasses()
        #self.wfproc.create_classrules(profile = None,  classname = u"Serviceaufträge")
        
        self.mainwin = mainwin
        # Hbox für Menue, Hauptfenster und Statusbar
        self.main = gtk.VBox()
        self.main.set_visible(True)
        
        # Statusbar
        self.statusbar = gtk.Statusbar()
        self.statusbar.push(0, "classifier started...")
        self.main.pack_end(self.statusbar, expand=False, fill=False, padding=1)

        # Menue
        self.menu = gtk.MenuBar()
        
#        file_menu = gtk.Menu()
#        file_item = gtk.MenuItem("Datei")
#        file_item.set_submenu(file_menu)
#        self.menu.append(file_item)
#        quit_item = gtk.MenuItem("Quit")
#        quit_item.connect_object ("activate", self.file_menu_action, "file.quit")
#        file_menu.append(quit_item)
        self.main.pack_start(self.menu, expand=False, fill=False, padding=1)
        
        # Hauptfenster
        paned = gtk.HPaned()
        # Hauptfenster left
        lvbox = gtk.VBox()
        # Klassenliste
        self.classview = gtk.TreeView()
        self.class_store = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_PYOBJECT)
        self.classview_selection = self.classview.get_selection()
        self.classview.set_grid_lines(gtk.TREE_VIEW_GRID_LINES_BOTH)
        
        self.classview.set_model(self.class_store)

        textrenderer = gtk.CellRendererText()
        column= gtk.TreeViewColumn("ID")
        column.pack_start(textrenderer)
        column.add_attribute(textrenderer, 'text', 0)
        column.set_resizable(True)
        column.set_sizing(gtk.TREE_VIEW_COLUMN_AUTOSIZE)
        self.classview.append_column(column)
        
        textrenderer = gtk.CellRendererText()
        column= gtk.TreeViewColumn("Klassenbezeichnung")
        column.pack_start(textrenderer)
        column.add_attribute(textrenderer, 'text', 1)
        column.set_resizable(True)
        column.set_sizing(gtk.TREE_VIEW_COLUMN_AUTOSIZE)
        self.classview.append_column(column)
        
        sw = gtk.ScrolledWindow()
        sw.set_border_width(1)
        sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        sw.add(self.classview)
        
        lvbox.pack_start(sw)
        self.test_btn = gtk.Button("test")
        self.test_btn.connect("clicked", self.on_test_clicked)
        self.test_btn.connect('drag_drop', self.on_drop_test)
        lvbox.pack_end(self.test_btn, expand=False, fill=False, padding=1)
        
        btnhb = gtk.HBox()
        self.add_classbtn = gtk.Button("hinzufügen")
        self.add_classbtn.connect("clicked", self.on_add_classbtn)
        self.rem_classbtn = gtk.Button("löschen")
        self.rem_classbtn.set_sensitive(False)
        self.rem_classbtn.connect("clicked", self.on_rem_classbtn)
        
        btnhb.pack_start(self.add_classbtn, expand=False, fill=False, padding=1)
        btnhb.pack_start(self.rem_classbtn, expand=False, fill=False, padding=1)
        lvbox.pack_start(btnhb, expand=False, fill=False, padding=1)
        
        
        # Hauptfenster right
        rvbox = gtk.VBox()
        self.nb_main = gtk.Notebook()
        self.nb_main.set_size_request(400,300)
        
        # Liste der Dokumente
        self.doc_hp = gtk.HPaned()
        self.doc_treeview = gtk.TreeView()
        self.doc_store = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_PYOBJECT)
        self.doc_treeview_selection = self.doc_treeview.get_selection()
        self.doc_treeview.set_grid_lines(gtk.TREE_VIEW_GRID_LINES_BOTH)
        self.doc_treeview_selection.connect('changed', self.on_doc_selected)
        self.doc_treeview.set_model(self.doc_store)
        
        textrenderer = gtk.CellRendererText()
        column= gtk.TreeViewColumn("ID")
        column.pack_start(textrenderer)
        column.add_attribute(textrenderer, 'text', 0)
        column.set_resizable(True)
        column.set_sizing(gtk.TREE_VIEW_COLUMN_AUTOSIZE)
        self.doc_treeview.append_column(column)
        
        textrenderer = gtk.CellRendererText()
        column= gtk.TreeViewColumn("Klasse")
        column.pack_start(textrenderer)
        column.add_attribute(textrenderer, 'text', 1)
        column.set_resizable(True)
        column.set_sizing(gtk.TREE_VIEW_COLUMN_AUTOSIZE)
        self.doc_treeview.append_column(column)
        
        textrenderer = gtk.CellRendererText()
        column= gtk.TreeViewColumn("gdocid")
        column.pack_start(textrenderer)
        column.add_attribute(textrenderer, 'text', 2)
        column.set_resizable(True)
        column.set_sizing(gtk.TREE_VIEW_COLUMN_AUTOSIZE)
        self.doc_treeview.append_column(column)
        
        sw = gtk.ScrolledWindow()
        sw.set_border_width(1)
        sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        
        sw.add(self.doc_treeview)
        vb = gtk.VBox()
        vb.pack_start(sw)
        btnhb = gtk.HBox()
        
        
        # Button öffnet ein Untermenü
        self.add_docbtn = gtk.Button("hinzufügen")
        self.add_docbtn.set_sensitive(False)
        
        add_docbtn_menu = gtk.Menu()
        menu_add_from_file = gtk.MenuItem("aus Datei")
        menu_add_from_bitfarm = gtk.MenuItem("aus Bitfarm")
        menu_add_from_entry = gtk.MenuItem("Text eingeben")
        
        menu_add_from_file.connect("activate", self.on_add_doc_from_file)
        menu_add_from_bitfarm.connect("activate", self.on_add_doc_from_bitfarm)
        
        add_docbtn_menu.append(menu_add_from_file)
        menu_add_from_file.show()
        add_docbtn_menu.append(menu_add_from_bitfarm)
        menu_add_from_bitfarm.show()
        add_docbtn_menu.append(menu_add_from_entry)
        menu_add_from_entry.show()
        
        self.add_docbtn.connect("event", self.on_add_docbtn, add_docbtn_menu)
        
        
        btnhb.pack_start(self.add_docbtn, expand=False, fill=False, padding=1)

        self.rem_docbtn = gtk.Button("löschen")
        self.rem_docbtn.set_sensitive(False)
        self.rem_docbtn.connect("clicked", self.on_rem_docbtn)
        btnhb.pack_start(self.rem_docbtn, expand=False, fill=False, padding=1)
        
        self.calc_docsbtn = gtk.Button("Regeln berechnen")
        self.calc_docsbtn.connect("clicked", self.on_calc_docsbtn)
        vb.pack_end(self.calc_docsbtn, expand=False, fill=False, padding=1)
        vb.pack_end(btnhb, expand=False, fill=False, padding=1)
        
        self.doc_hp.pack1(vb)
        
        # Dokumenten-Text
        sw = gtk.ScrolledWindow()
        sw.set_border_width(1)
        sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.doc_textview = gtk.TextView()
        self.doc_textview.set_wrap_mode(gtk.WRAP_NONE)
        sw.add(self.doc_textview)
        self.classview_selection.connect('changed', self.on_class_selected)
        self.doc_hp.pack2(sw)
        
        self.nb_main.append_page(self.doc_hp, gtk.Label("Texte"))
        
        # Regeln
        self.rules_hb = gtk.HBox()
        # links alle n´s (Tupel-Länge)
        
        self.n_view = gtk.TreeView()
        self.n_store = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_STRING)
        self.n_view_selection = self.n_view.get_selection()
        self.n_view.set_grid_lines(gtk.TREE_VIEW_GRID_LINES_BOTH)
        
        self.n_view.set_model(self.n_store)
        
        textrenderer = gtk.CellRendererText()
        column= gtk.TreeViewColumn("Tupel-Länge")
        column.pack_start(textrenderer)
        column.add_attribute(textrenderer, 'text', 0)
        column.set_resizable(True)
        column.set_sizing(gtk.TREE_VIEW_COLUMN_AUTOSIZE)
        self.n_view.append_column(column)
        self.rules_hb.pack_start(self.n_view)
        
        textrenderer = gtk.CellRendererText()
        column= gtk.TreeViewColumn("Anzahl")
        column.pack_start(textrenderer)
        column.add_attribute(textrenderer, 'text', 1)
        column.set_resizable(True)
        column.set_sizing(gtk.TREE_VIEW_COLUMN_AUTOSIZE)
        self.n_view.append_column(column)
        self.rules_hb.pack_start(self.n_view)
        
        # rechts alle Tupel der Länge n der gewählten Klasse
        self.ngram_view = gtk.TreeView()
        self.ngram_store = gtk.ListStore(gobject.TYPE_STRING)
        self.ngram_view_selection = self.ngram_view.get_selection()
        self.ngram_view.set_grid_lines(gtk.TREE_VIEW_GRID_LINES_BOTH)
        #self.ngram_view_selection.connect('changed', self.on_n_selected)
        self.ngram_view.set_model(self.ngram_store)
        
        textrenderer = gtk.CellRendererText()
        column= gtk.TreeViewColumn("Tupel")
        column.pack_start(textrenderer)
        column.add_attribute(textrenderer, 'text', 0)
        column.set_resizable(True)
        column.set_sizing(gtk.TREE_VIEW_COLUMN_AUTOSIZE)
        self.ngram_view.append_column(column)
        #self.rules_hb.pack_start(self.ngram_view)
        
        sw = gtk.ScrolledWindow()
        sw.set_border_width(1)
        sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        sw.add(self.ngram_view)
        self.rules_hb.pack_start(sw)
        self.nb_main.append_page(self.rules_hb, gtk.Label("Klassenregeln"))
        
        self.n_view_selection.connect('changed', self.on_n_selected)
        
        rvbox.pack_start(self.nb_main)
        
        
        paned.pack1(lvbox)
        paned.pack2(rvbox)
        self.main.pack_start(paned)
        self.show_classes()

    def on_drop_test(self, *args):
        print args

    def on_test_clicked(self, btn):
        dialog = gtk.FileChooserDialog("Open..",
                               None,
                               gtk.FILE_CHOOSER_ACTION_OPEN,
                               (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                                gtk.STOCK_OPEN, gtk.RESPONSE_OK))
        dialog.set_default_response(gtk.RESPONSE_OK)
        dialog.set_select_multiple(True)
        filter = gtk.FileFilter()
        filter.set_name("Text-Dateien")
        filter.add_pattern("*.txt")
        dialog.add_filter(filter)
        response = dialog.run()
        # Text aus Datei lesen, und in DB eintragen
        if response == gtk.RESPONSE_OK:
            fname = dialog.get_filename().decode("utf-8")
            try:
                f = codecs.open(fname, encoding='utf-8')
                txt = f.read()
                f.close()
            except:
                f = codecs.open(fname, encoding="latin1")
                txt = f.read()
                f.close()
            result = self.wfproc.classify(profile = None, txt = txt)
        dialog.destroy()
    
    def on_rem_classbtn(self, btn):
        classid = None
        (model, pathlist) = self.classview_selection.get_selected_rows()
        for path in pathlist :
            tree_iter = model.get_iter(path)
            classid = int(model.get_value(tree_iter, 0))
            classname = unicode(model.get_value(tree_iter, 1))
        if classid is not None:
            resp = self.ask_yes_no("Klasse %s und alle zugehörigen Dokumente entfernen?" %classname)
            if resp == -8:
                result = self.wfproc._remove_class(profile = None, classname = classname)
                if result is True:
                    self.class_store.remove(tree_iter)
                    self.doc_store.clear()
                else:
                    self.errormsg("Fehler beim Entfernen der Klasse")
                
                
    
    def on_n_selected(self, *args):
        classid = None
        classname = None
        n = None
        (model, pathlist) = self.classview_selection.get_selected_rows()
        for path in pathlist :
            tree_iter = model.get_iter(path)
            classid = int(model.get_value(tree_iter, 0))
            classname = unicode(model.get_value(tree_iter, 1))  
        (model, pathlist) = self.n_view_selection.get_selected_rows()
        if len(pathlist)>0:
            for path in pathlist :
                tree_iter = model.get_iter(path)
                n = int(model.get_value(tree_iter, 0))
        
        self.ngram_store.clear()
        if n in self.wfproc.doc_classes[classname].ngrams:
            for ngram in self.wfproc.doc_classes[classname].ngrams[n]:
                self.ngram_store.append([" ".join(ngram)])
    
    def on_calc_docsbtn(self, btn, *args):            
        print btn, args
        classid = None
        (model, pathlist) = self.classview_selection.get_selected_rows()
        for path in pathlist :
            tree_iter = model.get_iter(path)
            classid = int(model.get_value(tree_iter, 0))
            classname = unicode(model.get_value(tree_iter, 1))    
        self.wfproc.create_classrules(classname=classname)    
    
    def on_add_classbtn(self, btn, *args):
        def savebtn_clicked(btn, entry, win):
            classname = unicode(entry.get_text())
            newclassid = self.wfproc._add_class(profile = None, classname = classname)
            if newclassid is None:
                self.errormsg("Klassenbezeichnung gibt es schon, bitte wählen Sie eine andere Bezeichnung!")
            else:
                self.class_store.append([newclassid, classname, None])
                self.doc_textview.get_buffer().set_text("")
            win.destroy()

        classnamewin = gtk.Window()
        vbox = gtk.VBox()
        classnameentry = gtk.Entry()
        vbox.pack_start(classnameentry)
        savebtn = gtk.Button("Klasse anlegen")
        savebtn.connect("clicked", savebtn_clicked, classnameentry, classnamewin)
        vbox.pack_start(savebtn)
        classnamewin.add(vbox)
        classnamewin.show_all()
            

    def on_add_docbtn(self, btn, event, menu):
        if event.type == gtk.gdk.BUTTON_PRESS:
            menu.popup(None, None, None, event.button, event.time)
            return True
        return False
        
    
    def on_add_doc_from_file(self, *args):
        # ausgewälte Klasse ermitteln
        txt = None
        classname = None
        (model, pathlist) = self.classview_selection.get_selected_rows()
        for path in pathlist :
            tree_iter = model.get_iter(path)
            classname = unicode(model.get_value(tree_iter,1))
        if classname is None:
            self.errormsg("Bitte zuerst eine Klasse auswählen")
            return None
            

        dialog = gtk.FileChooserDialog("Open..",
                               None,
                               gtk.FILE_CHOOSER_ACTION_OPEN,
                               (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                                gtk.STOCK_OPEN, gtk.RESPONSE_OK))
        dialog.set_default_response(gtk.RESPONSE_OK)
        dialog.set_select_multiple(True)
        filter = gtk.FileFilter()
        filter.set_name("Text-Dateien")
        filter.add_pattern("*.txt")
        dialog.add_filter(filter)
        response = dialog.run()

        # Text aus Datei lesen, und in DB eintragen
        if response == gtk.RESPONSE_OK:
            fnames = dialog.get_filenames()
            for fname in fnames:
                fname = fname.decode('utf-8')
                try:
                    f = codecs.open(fname, encoding='utf-8')
                    txt = f.read()
                    f.close()
                except:
                    f = codecs.open(fname, encoding="latin1")
                    txt = f.read()
                    f.close()
                result = self.wfproc._add_classdoc(profile = None, classname = classname, txt = txt)
                if result is None:
                    self.errormsg("Das Dokument konnte nicht hinzugefügt werden")
                    dialog.destroy()
                    return None
                
            self.show_docs(classname)
        elif response == gtk.RESPONSE_CANCEL:
            print 'Closed, no files selected'
        dialog.destroy()
        
    def on_add_doc_from_bitfarm(self, *args):
        
        def addbtn_clicked(btn, entry, win):
            gdocid = unicode(entry.get_text())
            try:
                gdocid = int(gdocid)
            except:
                self.errormsg("Bitte geben Sie eine gültige gdocid ein!")
                return None
            doc = bitfarm_doc.BitfarmDocument()  
            
            doc.version=3
            doc.gdocid = gdocid
            self.bfaProc.load(doc)
            txt = doc.ftx.text
            
            
            result = self.wfproc._add_classdoc(profile = None, gdocid = gdocid, classname = classname, txt = txt)
            if result is None:
                self.errormsg("Das Dokument konnte nicht hinzugefügt werden")
                dialog.destroy()
                return None
            win.destroy()
        
        txt = None
        classname = None
        (model, pathlist) = self.classview_selection.get_selected_rows()
        for path in pathlist :
            tree_iter = model.get_iter(path)
            classname = unicode(model.get_value(tree_iter,1))
        if classname is None:
            self.errormsg("Bitte zuerst eine Klasse auswählen")
            return None
            
        
        gdocidwin = gtk.Window()
        vbox = gtk.VBox()
        gdocidentry = gtk.Entry()
        vbox.pack_start(gdocidentry)
        savebtn = gtk.Button("OK")
        savebtn.connect("clicked", addbtn_clicked, gdocidentry, gdocidwin)
        vbox.pack_start(savebtn)
        gdocidwin.add(vbox)
        gdocidwin.show_all()
        
    def on_rem_docbtn(self, *args):    
        (model, pathlist) = self.doc_treeview_selection.get_selected_rows()
        for path in pathlist :
            tree_iter = model.get_iter(path)
            id = int(model.get_value(tree_iter,0))
            response = self.ask_yes_no("Dokument wirklich entfernen")
            
            if response == -8:
                if self.wfproc._remove_classdoc(profile = None, id = id) is True:
                    self.doc_store.remove(tree_iter)
                    self.doc_textview.get_buffer().set_text("")
                    self.rem_docbtn.set_sensitive(False)
                else:
                    self.errormsg("Fehler beim Entfernen des Referenzdokuments")
        
    def on_doc_selected(self, tree_selection):
        (model, pathlist) = tree_selection.get_selected_rows()
        for path in pathlist :
            tree_iter = model.get_iter(path)
            doctxt = model.get_value(tree_iter,3)
            self.rem_docbtn.set_sensitive(True)
            self.doc_textview.get_buffer().set_text(doctxt)
            
            
    
    def on_class_selected(self, tree_selection):
        (model, pathlist) = tree_selection.get_selected_rows()
        self.doc_textview.get_buffer().set_text("")
        self.n_store.clear()
        if len(pathlist)>0:
            for path in pathlist :
                tree_iter = model.get_iter(path)
                classname = unicode(model.get_value(tree_iter,1))
                classid = int(model.get_value(tree_iter, 0))
                self.show_docs(classname)
                self.add_docbtn.set_sensitive(True)
                self.rem_docbtn.set_sensitive(False)
                self.rem_classbtn.set_sensitive(True)
            
            try:
                for n in self.wfproc.doc_classes[classname].ngrams.keys():
                    self.n_store.append([str(n), str(len(self.wfproc.doc_classes[classname].ngrams[n]))])
                
            except:
                # noch keine Regeln da
                pass
            try:
                self.n_view.set_cursor(0)
                self.doc_treeview.set_cursor(0)
            except:
                print "error in on_class_selected"
            self.on_n_selected()
    
    def show_docs(self, classname):
        self.doc_store.clear()
        self.wfproc.read_docclasses()
        for doc in self.wfproc.doc_classes[classname].classdocs:
            self.doc_store.append([doc[0], classname, doc[1], doc[2]])

    def show_classes(self):
        self.class_store.clear()
        for cl in self.wfproc.doc_classes:
            self.class_store.append( [self.wfproc.doc_classes[cl].classid, self.wfproc.doc_classes[cl].classname, self.wfproc.doc_classes[cl]] )
            

    def doc_menu_action(self, arg):
        if arg == "doc.add":
            print "doc.add"
        else:
            print arg
            
            
    def class_menu_action(self, arg):

        def savebtn_clicked(btn, entry, win):
            #print btn, entry
            classname = entry.get_text()
            #print classname
            classname = classname.encode("latin1")
            #print type(classname)
            sql = "SELECT * from sys_classes WHERE classname='%s'" % classname
            result = self.db.execute(sql).fetchall()
            #result = self.cursor.fetchall()
            #print result
            if len(result)>0:
                self.errormsg("Klassenbezeichnung gibt es schon, bitte wählen Sie eine andere Bezeichnung!")
            else:
                sql = "INSERT INTO sys_classes(classname) VALUES ('%s')" %(classname)
                self.db.execute(sql)
                win.destroy()
                self.class_store.append([self.db.lastrowid, classname.decode("latin1"), None])
            
            
        if arg == "class.add":
            #print "class.add"
            
            classnamewin = gtk.Window()
            vbox = gtk.VBox()
            
            classnameentry = gtk.Entry()
            vbox.pack_start(classnameentry)
            
            savebtn = gtk.Button("Klasse anlegen")
            savebtn.connect("clicked", savebtn_clicked, classnameentry, classnamewin)
            vbox.pack_start(savebtn)
            
            
            classnamewin.add(vbox)
            classnamewin.show_all()
            
        else:
            print arg
            
    def file_menu_action(self, arg):
        if arg == "file.dbadd":
            dialog = gtk.FileChooserDialog("Open..",
                               None,
                               gtk.FILE_CHOOSER_ACTION_SAVE,
                               (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                                gtk.STOCK_OPEN, gtk.RESPONSE_OK))
            dialog.set_default_response(gtk.RESPONSE_OK)

            filter = gtk.FileFilter()
            filter.set_name("sqlite-database-file")
            filter.add_pattern("*.db")
            dialog.add_filter(filter)
            response = dialog.run()
            if response == gtk.RESPONSE_OK:
                self.create_db(dialog.get_filename())
            elif response == gtk.RESPONSE_CANCEL:
                print 'Closed, no files selected'
            dialog.destroy()
            

            
        elif arg == "file.dbopen":
            #print "file.open"
            dialog = gtk.FileChooserDialog("Open..",
                               None,
                               gtk.FILE_CHOOSER_ACTION_OPEN,
                               (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                                gtk.STOCK_OPEN, gtk.RESPONSE_OK))
            dialog.set_default_response(gtk.RESPONSE_OK)

            filter = gtk.FileFilter()
            filter.set_name("sqlite-database-file")
            filter.add_pattern("*.db")
            dialog.add_filter(filter)
            response = dialog.run()
            if response == gtk.RESPONSE_OK:
                self.load_db(dialog.get_filename())
            elif response == gtk.RESPONSE_CANCEL:
                print 'Closed, no files selected'
            dialog.destroy()
    

                
    
    def usermessage(self, msg):
        md = gtk.MessageDialog(self.mainwin,
            gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_INFO,
            gtk.BUTTONS_OK, msg)
        md.run()
        md.destroy()
        
    def errormsg(self, errmsg):
        md = gtk.MessageDialog(self.mainwin,
            gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_ERROR,
            gtk.BUTTONS_CLOSE, errmsg)
        md.run()
        md.destroy()

    def ask_yes_no(self, msg):
        md = gtk.MessageDialog(self.mainwin,
            gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_QUESTION,
            gtk.BUTTONS_YES_NO, msg)
        response = md.run()
        md.destroy()
        return response

    def doc_menu_action(self, arg):
        if arg == "doc.addfromfile":
            print "doc.addfromfile"
            dialog = gtk.FileChooserDialog("Open..",
                               None,
                               gtk.FILE_CHOOSER_ACTION_SAVE,
                               (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                                gtk.STOCK_OPEN, gtk.RESPONSE_OK))
            dialog.set_default_response(gtk.RESPONSE_OK)

            filter = gtk.FileFilter()
            filter.set_name("txt-files")
            filter.add_pattern("*.txt")
            dialog.add_filter(filter)
            response = dialog.run()
            if response == gtk.RESPONSE_OK:
                self.add_docfile(dialog.get_filename())
            elif response == gtk.RESPONSE_CANCEL:
                print 'Closed, no files selected'
            dialog.destroy()
            
            
            
        elif arg == "doc.addfrombitfarm":
            print "doc.addfrombitfarm"
        elif arg == "doc.addfromtext":
            print "doc.addfromtext"
        else:
            print arg
        

        

        


class ServerAdmin():
    
    def __init__(self,  profile):
        self.con = bitfarm_proc.BitfarmConnections(profile)
        self.con.create_db_engine()
        self.db = self.con.main.engine.connect()
        self.wfProc = bitfarm_proc.BitfarmWorkflowProcessing(self.con)
        self.bfaProc = bitfarm_doc.BitfarmDocProcessing(self.con)
        # Mainwindow
        self.mainwin = gtk.Window()
        self.mainwin.connect("delete-event", self.quitnow)
        
        # Notebook mit den einzelnen Anwendungen
        self.nb_main = gtk.Notebook()
        self.nb_main.set_size_request(400,300)
        
        # Classifier Anwendung
        classifier = Classifier(self.mainwin, self.db, self.wfProc, self.bfaProc)
        
        self.nb_main.append_page(gtk.Label("Administration"), gtk.Label("Administration"))
        self.nb_main.append_page(gtk.Label("Workflows"), gtk.Label("Workflows"))
        self.nb_main.append_page(classifier.main, gtk.Label("Classifier"))
        self.nb_main.append_page(gtk.Label("Reporting"), gtk.Label("Reporting"))
        self.nb_main.append_page(gtk.Label("Logging"), gtk.Label("Logging"))
        
        self.mainwin.add(self.nb_main)
        self.mainwin.show_all()
    
    def quitnow(self, *args):

        gtk.main_quit()
            
        

def main():
    gtk.main()
    return

if __name__ == "__main__":
    profile = sys.argv[1]
    admin = ServerAdmin(profile)
    main()
