#!/usr/bin/env python
# -*- coding: latin-1 -*-

import os
import sys
import logging
from bitfarm_doc import *
from bitfarm_workflow import *
import re
import datetime
import bitfarm_xml as bfaxml

def assign_pattern():
    if steps > 0:   # wir gehen soviel Schritte bis zu unserem Treffer
        if get == 0:
            exp = '(\.+)'
        elif get == 1:
            exp = '(\S+)'
        else:
            exp = '(\S+' + ('\s+\S+' * (get -1)) + ')'
        if steps == 1:
            stepexp = '\s+'
        else:
            stepexp = ('\s.+\s' * (steps -1))
        if direction == 1:
            getfields[0].searchpattern = exp + stepexp + searchword
        else:
            getfields[0].searchpattern = searchword + stepexp + exp
    else:   #wir sind der Treffer selbst
        getfields[0].searchpattern = '(' + searchword + ')'

SHORTXML = True

scriptname = os.path.basename(sys.argv[0])
if sys.platform== 'win32':
    mypath = os.path.split(os.path.abspath(sys.argv[0]))[0]
    try:
        bfapath = os.environ['bitfarm-archiv']
    except:
        bfapath = mypath
else:
    mypath = os.getcwd()
fullpath = os.path.join( mypath , scriptname)

log = logging.getLogger("Main")
if mypath.lower() == os.getcwd().lower():
    # create console handler and set level to debug
    ch = logging.StreamHandler()
    level = 'debug'
    levels = {'debug' : logging.DEBUG,
                'info' : logging.INFO,
                'warning' : logging.WARNING,
                'error' : logging.ERROR,
                'citical' : logging.CRITICAL}
    if len(sys.argv) > 1:
        for arg in sys.argv:
            if '-log:' in arg:
                level = arg[5:].lower()
                break

    ch.setLevel(levels[level])
#        formatter = MyFormatter('%(name)s-%(levelname)s:  %(message)s')
    formatter = logging.Formatter('%(name)s-%(levelname)s:  %(message)s')
#            formatter = MyFormatter('%(name)s -- %(levelname)s -- %(message)s', encoding='cp852')
#            formatter = logging.Formatter('%(name)s -- %(levelname)s -- %(message)s')

    ch.setFormatter(formatter)
    ch.args = sys.stdout
    log.addHandler(ch)

#if mypath.lower() != os.getcwd().lower():
#    logging.config.fileConfig(os.path.join(mypath, "bfaArchivierung_fl.conf"))
#else:
#    logging.config.fileConfig(os.path.join(mypath, "bfaArchivierung_cl.conf"))

if not os.path.exists(os.path.join(mypath, "wfd")):
    os.mkdir(os.path.join(mypath, "wfd"))

con = []
profile = sys.argv[1]
con = bitfarm_doc.BitfarmConnections(profile)
con.create_db_engine()
db = con.main.engine.connect()
#    con = bitfarm_doc.BitfarmCon(profile)
#    con.connect()

wfProc = BitfarmWorkflowProcessing(con)
bfaProc = BitfarmDocProcessing(con)

# lese sys_arc ein

sys_arc = []
result = db.execute('select * from sys_arc').fetchall()
for row in result:
    print row
    sys_arc.append([x for x in row])
for arc in sys_arc:
    arc[2] = arc[2].decode('latin-1')


# Tabelle leer machen
#db.execute('Truncate sys_wfd')
#db.execute('Truncate sys_naming')

t = BitfarmTask()
print t.show_tasks()


# zuerst den default Workflow
w = BitfarmWorkflow()
w.wf_trigger = 0   # workflow fr collector
w.typ = 0       # dokumentenworkflow
w.tasks.append(BitfarmTask('render_by_type'))
w.tasks.append(BitfarmTask('omp'))
w.tasks.append(BitfarmTask('check_workflows'))
w.tasks.append(BitfarmTask('archive'))
w.wf_name = 'default'

wfProc.save_workflow_by_id(wf = w, wf_id = 1)
bfaxml.object_to_xmlfile(w, 'wfd\\default.xml', shortxml = SHORTXML)
del w

try:
    wfd_file = sys.argv[2]
except:
    wfd_file = os.path.join(bfapath, profile + '.wfd')
if not os.path.exists(wfd_file):
    print "WFD-Datei %s konnte nicht gefunden werden" %wfd_file
    sys.exit(1)

namings = []    #sammelt die naming sections
sortings = []   #sammelt die sorting sections
workflows = []  #sammelt die workflow sections
settings = []   #sammelt die setting sections
nosortings = []  # sammelt nosorting Anweisungen als Liste von Conditon-Objekten
nosortings_condition = None
usings =[]      # Liste mit Getfieldanweisungen fr Using Anweisung in den Setting Sections
usings_getfield = None

with open(wfd_file) as wfd:
    while True:
        line = wfd.readline()
        if not line:
            break
        found_naming = None
        found_sorting = None
        found_workflow = None
        found_setting = None
        naming = []
        sorting = []
        workflow = []
        setting = []
        #print line[:-1]
        found_naming = re.match('naming section', line.lower())
        if found_naming:
            while line.lower()[0:11] != 'end section':
                print line[:-1]
                if line != '\n':
                    naming.append(line.decode('latin-1'))
                line = wfd.readline()
                if not line:
                    break
            namings.append(naming)
        found_sorting = re.match('sorting section', line.lower())
        if found_sorting:
            while line.lower()[0:11] != 'end section':
                print line[:-1]
                if line != '\n':
                    sorting.append(line.decode('latin-1'))
                line = wfd.readline()
                if not line:
                    break
            sortings.append(sorting)
        found_workflow = re.match('workflow section', line.lower())
        if found_workflow:
            while line.lower()[0:11] != 'end section':
                print line[:-1]
                if line != '\n':
                    workflow.append(line.decode('latin-1'))
                line = wfd.readline()
                if not line:
                    break
            workflows.append(workflow)
        found_workflow = re.match('late-workflow section', line.lower())
        if found_workflow:
            while line.lower()[0:11] != 'end section':
                print line[:-1]
                if line != '\n':
                    workflow.append(line.decode('latin-1'))
                line = wfd.readline()
                if not line:
                    break
            workflows.append(workflow)
        found_workflow = re.match('interval-workflow section', line.lower())
        if found_workflow:
            while line.lower()[0:11] != 'end section':
                print line[:-1]
                if line != '\n':
                    workflow.append(line.decode('latin-1'))
                line = wfd.readline()
                if not line:
                    break
            workflows.append(workflow)
        found_workflow = re.match('continue section', line.lower())
        if found_workflow:
            while line.lower()[0:11] != 'end section':
                print line[:-1]
                if line != '\n':
                    workflow.append(line.decode('latin-1'))
                line = wfd.readline()
                if not line:
                    break
            workflows.append(workflow)            
        found_setting = re.match('settings section', line.lower())
        if found_setting:
            while line.lower()[0:11] != 'end section':
                print line[:-1]
                if line != '\n':
                    setting.append(line.decode('latin-1'))
                line = wfd.readline()
                if not line:
                    break
            settings.append(setting)

print namings
print sortings
print workflows
print settings

#Auswertung


if len(settings) > 0:
    task = None
    print "%s Setting Regeln gefunden" %len(settings)
    for setting in settings:
        print setting
        for line in setting:
            found = False
            print line
            nosort = re.search('nosorting=(\S+)', line)
            if nosort:
                nosort = nosort.groups(0)[0]
                if nosort.isdigit():
                    nosort = int(nosort)
                    for arc in sys_arc:
                        if nosort == arc[0]:
                            arcid = arc[0]
                            found = True
                            break
                elif type(nosort) is str:
                    for arc in sys_arc:
                        if nosort.lower() == arc[2].lower():
                            arcid = arc[0]
                            found = True
                            break
                if found:
                    nosortings.append(arcid)
            
            using = re.search('USE \[(\S+)\] FOR (\S+)', line)
            if using:
                print using.group(1)
                print using.group(2)
                
                use = using.group(1) 
                use_addfield = (using.group(2)[1:-1] if using.group(2)[0] == '%' and using.group(2)[-1] == '%' else using.group(2)) 
                
                if use and use_addfield:
                    gf = BitfarmGetField() 
                    gf.addfield = use_addfield
                    gf.using = use
                    usings.append(gf)
                    
                
        if len(nosortings) >0:
            cset = BitfarmConditionSet('arcid', 'document', 'containsnot', nosortings)
            nosortings_condition = BitfarmConditionObject('and', cset)            

        if len(usings) >0:
            id = wfProc.save_naming(name = 'using', getfield = usings)
            bfaxml.object_to_xmlfile(usings, 'wfd\\using.xml', shortxml = SHORTXML)
            if id:
                usings_getfield = BitfarmGetField()
                usings_getfield.id = id
                    

if len(namings) > 0:
    task = None
    print "%s Naming Regeln gefunden" %len(namings)
    for naming in namings:
        getfields = []
        getfields.append(BitfarmGetField())
        direction = 2
        steps = 1
        get = 1
        searchsteps = None
        searchdirection = None
        getstrings = None
        field = None
        displayname = None
        linkstring = None
        makedate = None
        date_us = None
        cutleft =  None
        cutright = None
        numeric = None
        nodeletespaces = None
        nodeletedashes = None
        nodeletedots = None
        searchword = ""
        set_displayname = None
        andindocument = None
        orindocument = None
        notindocument = None
        section = "".join(naming)
        conditions = []
        condition = None
        cset = None
        cobj = None
        name = re.search('naming section (.+)', section)
        archiv = re.search('archivtabelle=(\S+)', section)
        #wir gehen zeilenwiese eine naminganweisung durch
        for line in naming:
            line = line.lstrip()
            if len(line) == 0:
                continue
            if line[0] == ';':  #auskommentiert, berspringen
                continue
            print line[:-1]
            searchstring = None
            searchpattern = None
            searchbarcode = None
               
            if not searchstring:
                searchstring = re.search('searchstring\s?=\s?(\S+)', line)
            if not searchpattern:
                searchpattern = re.search('searchpattern\s?=\s?(\S+)', line)
            if not searchbarcode:
                searchbarcode = re.search('searchbarcode\s?=\s?(\S+)', line)
            if not field:
                field = re.search('zusatzfeld\s?=\s?(\S.+)', line)
            if not searchsteps:
                searchsteps = re.search('searchsteps\s?=\s?(\S+)', line)
            if not searchdirection:
                searchdirection = re.search('searchdirection\s?=\s?(\S+)', line)
            if not getstrings:
                getstrings = re.search('getstrings\s?=\s?(\S+)', line)
            if not displayname:
                displayname =  re.search('displayname\s?=\s?(\S+)', line)
            if not linkstring:
                linkstring =  re.search('linkstring', line)
            if not makedate:
                makedate =  re.search('date', line)
            if not date_us:
                date_us = re.search('date-us', line)
            if not numeric:
                numeric =  re.search('numeric', line)
            if not cutleft:
                cutleft = re.search('cutawayleft\s?=\s?(\S+)', line)
            if not cutright:
                cutright = re.search('cutawayright\s?=\s?(\S+)', line)
            if not nodeletespaces:
                nodeletespaces =  re.search('nodeletespaces', line)
            if not nodeletedashes:
                nodeletedashes =  re.search('nodeletedashes', line)
            if not nodeletedots:
                nodeletedots =  re.search('nodeletedots', line)
            if not andindocument:
                andindocument = re.search('andindocument\s?=\s?(\S+)', line)
            if not orindocument:
                orindocument = re.search('orindocument\s?=\s?(\S+)', line)
            if not notindocument:
                notindocument = re.search('notindocument\s?=\s?(\S+)', line)


            # wenn wir einen serachstring gefunden haben erstellen wir eine neue Getfieldanweisung an erster Position
            if searchstring or searchpattern or searchbarcode:

                # hat unsere aktuelle getfieldanweisung schon ein searchpattern/barcode erstellen wir jetzt eine neue
                if getfields[0].searchpattern is not None or getfields[0].searchbarcode is not None:
                    getfields.insert(0, BitfarmGetField())
                    direction = 2     # pro Anweisung zurcksetzen
                    steps = 1
                    get = 1
                    field = None
                    displayname = None
                    linkstring = None
                    makedate = None
                    date_us = None
                    numeric = None
                    cutleft =  None
                    cutright = None
                    nodeletespaces = None
                    nodeletedashes = None
                    nodeletedots = None
                    andindocument = None
                    orindocument = None
                    notindocument = None
                if searchbarcode:
                    getfields[0].searchbarcode = searchbarcode.groups(0)[0]
                else:
                    if searchstring:
                        searchword = searchstring.groups(0)[0]
                    if searchpattern:
                        searchword = searchpattern.groups(0)[0]
                        steps = 0
                    assign_pattern()

            if field:
                getfields[0].addfield = field.groups(0)[0]
            if displayname:
                set_displayname = displayname.groups(0)[0]
            if linkstring:
                getfields[0].linkstring = True
            if makedate:
                getfields[0].makedate = True
            if date_us:
                 getfields[0].makedate = True
                 getfields[0].formatstring = '%m.%d.%Y'
            if numeric:
                getfields[0].numeric = True
            if cutleft:
                getfields[0].cutleft = int(cutleft.groups(0)[0])
            if cutright:
                getfields[0].cutright = int(cutright.groups(0)[0])
            if nodeletespaces:
                getfields[0].nodeletespaces = True
            if nodeletedashes:
                getfields[0].nodeletedashes = True
            if nodeletedots:
                getfields[0].nodeletedots = True
            if searchsteps:
                steps = int(searchsteps.groups(0)[0])
                assign_pattern()

            if searchdirection:
                word = searchdirection.groups(0)[0]
                if word.isdigit():
                    direction = int(word)
                else:
                    if word == 'left' or word == 'links':
                        direction = 1
                    if word == 'right' or word == 'rechts':
                        direction = 2
                assign_pattern()

            if getstrings:
                if getstrings.groups(0)[0] == u'all':
                    get = 0
                else:
                    get = int(getstrings.groups(0)[0])
                assign_pattern()

            if andindocument:
                cset = BitfarmConditionSet('', 'ftx', 'contains', andindocument.groups(0)[0])
                cobj = BitfarmConditionObject('and', cset)
                conditions.append(cobj)
                andindocument = None
            if orindocument:
                cset = BitfarmConditionSet('', 'ftx', 'contains', orindocument.groups(0)[0])
                cobj = BitfarmConditionObject('or', cset)
                conditions.append(cobj)
                orindocument = None
            if notindocument:
                cset = BitfarmConditionSet('', 'ftx', 'containsnot', notindocument.groups(0)[0])
                cobj = BitfarmConditionObject('and', cset)
                conditions.append(cobj)
                notindocument = None

        if usings_getfield:     # wenn wir auch using-anweisungen gespeichert haben, dann nehmen wir
            getfields.append(usings_getfield)   # die usings_getfield hinzu, darber werden spter 
                                                # die using-anweisungen nachgeladen
                                                
        # jetzt haben wir hoffentlich die getfield(s) anweisungen zusammen, erstellen den Workflow,
        # schreiben den in die sys_wfd, und die getfield-anweisungen in die sys_naming
        arcid = None
        if archiv is None:
            arcid = 0
        else:
            archiv = archiv.groups(0)[0]
        if name is None:
            name = archiv
        else:
            name = name.groups(0)[0]

        print u"Verarbeite naming section %s fr Archiv %s" %(name, archiv)

        if arcid is None:
            for arc in sys_arc:
                if arc[2].lower() == archiv.lower():
                    arcid = arc[0]
                    break

        if arcid is None:       # der Workflow war keinem Archiv zuzuordnen, dann mit der nchsten namimngregel weitermachen
            print u"Keine Arcid fr %s gefunden, verarbeite nchste Regel..." %archiv
            continue

        # wir prfen ob wir getfieldanweisungen mit searchpattern /barcode haben
        found = False
        task = None
        task2 = None
        for item in getfields:
            if item.searchpattern or item.searchbarcode:
                found = True
                break

        if len(conditions) > 0:
            condition = BitfarmConditionObject('and', conditions)

        if found:
            task = BitfarmTask('naming')
            task.params.getfield = BitfarmGetField()
            task.params.getfield.name = name
            if condition:
                task.condition = condition
        if set_displayname:
            task2 = BitfarmTask('set_displayname')
            task2.params.set_displayname = set_displayname
            if condition:
                task2.condition = condition

        w = BitfarmWorkflow()
        w.wf_trigger = 0   # workflow fr collector
        w.typ = 0       # dokumenten workflow
        w.tasks.append(BitfarmTask('render_by_type'))
        w.tasks[0].params.extract_text = True
        w.tasks.append(BitfarmTask('omp'))
        if task:
            w.tasks.append(task)
        if task2:
            w.tasks.append(task2)
        w.tasks.append(BitfarmTask('check_workflows'))
        w.tasks.append(BitfarmTask('archive'))
        w.wf_name = name

        wfProc.save_workflow(wf = w, wf_type = 0,  wf_trigger = 0, arcid = arcid,  wf_name = name)
        if found:
            wfProc.save_naming(name = name,  getfield = getfields,  ref_docs = None)

        bfaxml.object_to_xmlfile(w, 'wfd\\workflow_%s.xml' %name, shortxml = SHORTXML)
        bfaxml.object_to_xmlfile(getfields, 'wfd\\naming_%s.xml' %name, shortxml = SHORTXML)

        # wir speichern den naming und displayname Task nochmal extra als Workflow fr die Archivierung
        # dann kann eine sorting-Regel ber check_workflows diese finden
        if task or task2:
            w2 = BitfarmWorkflow()
            w2.wf_trigger = 1   # workflow fr archivierung
            w2.typ = 0       # dokumenten workflow
            if task:
                w2.tasks.append(task)
            if task2:
                w.tasks.append(task2)
            wfProc.save_workflow(wf = w2, wf_type = 0,  wf_trigger = 1, arcid = arcid,  wf_name = 'naming:' + name)
            bfaxml.object_to_xmlfile(w2, 'wfd\\naming_%s.xml' %name, shortxml = SHORTXML)

if len(workflows) > 0:
    continues = []      #globale Liste aller nextworkflows, beziehungsweise continues
    nextworkflows = []  # wird bentigt um den zusammenhang der sektionen herzustellen
    for workflow in workflows:
        print workflow
        section = "".join(workflow)
        conditions = []
        condition = None
        else_task = None
        cset = None
        cobj = None
        user_work = None
        user_shed = None
        termin = None
        alarm = None
        exportpath = None
        sendmsg = None
        sendfile = None
        sendheadr = None
        sendmailto = None
        sendmailrecp = []
        sendmailtask = None
        next = None
        cont = None
        lateworkflow = False
        intervalworkflow = False
        continueworkflow = False
        options = 0
        
        name = re.search('late-workflow section (.+)', section)
        if name is not None:
            lateworkflow = True        
        if name is None:
            name = re.search('interval-workflow section (.+)', section)
            if name is not None:
                intervalworkflow = True  
        if name is None:
            name = re.search('\s?workflow section (.+)', section)
        if name is None:
            name = re.search('continue section (.+)', section)
            if name is not None:
               continueworkflow = True 
        if name is not None:
            name = name.groups()[0]
        else:
           name = 'workflow:unbenannt'
           
        name = name.strip()
        arcid = 0
        archiv = re.search('archivtabelle\s?=\s?(\S+)', section)
        if archiv is not None:
            archiv = archiv.groups()[0].strip()
            for arc in sys_arc:
                if archiv.lower() == arc[2].lower():
                    arcid = int(arc[0])
                    break
            
        for line in workflow:
            line = line.strip()
            if len(line) == 0:
                continue
            if line[0] == ';':  #auskommentiert, berspringen
                continue
            print line
            case = None
            case = re.search('CASE\s?(\S+)\s?=\s?(\S+)', line)
            if case:
                if case.groups()[0][:7] == 'Status_':
                    cset = BitfarmConditionSet(case.groups()[0][7:], 'status', '=', True if case.groups()[1].lower() == 'true' else False)
                    cobj = BitfarmConditionObject('and', cset)
                    conditions.append(cobj)    
                else:
                    cset = BitfarmConditionSet(case.groups()[0], 'field', '=', case.groups()[1])
                    cobj = BitfarmConditionObject('and', cset)
                    conditions.append(cobj)    
            
            if user_work is None:
                user_work = re.search('bearbeiter\s?=\s?(\S+)', line)
                if user_work:
                    user_work = user_work.groups()[0].split(";")
                    for ind in range(len(user_work)):
                        if user_work[ind][:1] == u'#':
                            user_work[ind] = con.main.read_group(db = db, name = user_work[ind][1:])
                            options = 0
                        elif user_work[ind][:1] == u'':
                            user_work[ind] = con.main.read_group(db = db, name = user_work[ind][1:])
                            options = 1
                        elif user_work[ind][:1] != u'%' and user_work[ind][-1] != u'%':
                            user_work[ind] = con.main.read_user(db = db, name = user_work[ind])
                            options = 0
            if user_shed is None:
                user_shed = re.search('controller\s?=\s?(\S+)', line)
                if user_shed:
                    #TODO: mehrere Controller behalten wir uns mal fr eine sptere Version vor, v4
#                    user_shed = user_shed.groups()[0].split(";")
#                    for ind in range(len(user_shed)):
                    user_shed = user_shed.groups()[0]
                    if user_shed[:1] != u'%' and user_shed[-1] != u'%':
                        user_shed = con.main.read_user(db = db, name = user_shed)
            if termin is None:
                termin = re.search('termin\s?=\s?(\S+)', line)
                if termin:
                    termin = termin.groups()[0]
                    if termin.isdigit():
                        termin = datetime.datetime.now() + datetime.timedelta(int(termin))
                    else:
                        termin = datetime.datetime.now()
                    termin = termin.replace(microsecond = 0)
            if alarm is None:
                alarm = re.search('alarm\s?=\s?(\S+)', line)
                if alarm:
                    alarm = alarm.groups()[0]
                    if alarm.isdigit():
                        alarm = datetime.datetime.now() + datetime.timedelta(int(alarm))
                    else:
                        alarm = datetime.datetime.now() + datetime.timedelta(7)
                    alarm = alarm.replace(microsecond = 0)            
            if exportpath is None:
                exportpath = re.search('exportpath\s?=\s?(.+)', line)
                if exportpath:
                    exportpath = exportpath.groups()[0]
            if sendmsg is None:
                sendmsg = re.search('sendmsg\s?=\s?(.+)', line)
                if sendmsg:
                    sendmsg = sendmsg.groups()[0]
            if sendfile is None:
               sendfile = re.search('sendfile', line)
               if sendfile:
                    sendfile = True
            #TODO: sendheadr und sendmailto noch implementieren
            if sendheadr is None:
               sendheadr = re.search('sendheadr\s?=\s?(.+)', line)
               if sendheadr:
                    sendheadr = sendheadr.groups()[0]
            if sendmailto is None:
               sendmailto = re.search('sendmailto\s?=\s?(.+)', line)
               if sendmailto:
                    sendmailto = sendmailto.groups()[0]   
                    sendmailrecp.append(sendmailto)
            if next is None:
                next  = re.search('nextworkflow\s?=\s?(.+)', line)
                if next:
                    if next.groups()[0].lower() != 'nil':
                        nextworkflows.append(next.groups()[0])
                        next = next.groups()[0]
                    else:
                        next = None
            if cont is None:
                cont = re.search('continue\s?=\s?(.+)', line)
                if cont:
                    continues.append(cont.groups()[0])
                    cont = cont.groups()[0]
        # section gelesen, anlegen
        
        if len(conditions) > 0:     # wenn wir eine condition haben, dann brauchen wir einen 'end_workflow' else_task
            condition = BitfarmConditionObject('and', conditions)
            else_task = BitfarmTask('end_workflow')
        
        if continueworkflow and next is None:    # wenn wir eine continue section haben und next ist nicht gesetzt 
            next = 'nil'                         # dann ist das gleichbedeutend mit nil

        if len(sendmailrecp) > 0:
            for i in range(len(sendmailrecp)):
                if sendmailrecp[i][:1] == u'#' or sendmailrecp[i][:1] == u'':
                    sendmailrecp[i] = con.main.read_group(db = db, name = sendmailrecp[i][1:])
            sendmailtask = BitfarmTask('send_mail')
            sendmailtask.message = BitfarmNotification()
            sendmailtask.message.recipient = sendmailrecp
            sendmailtask.message.subject = sendheadr if sendheadr is not None else u"Archiv: neues Dokument"
            sendmailtask.message.text = sendmsg
            sendmailtask.message.attach_document = sendfile is not None
            sendmailtask.message.attach_link = True
            sendmailtask.message.send_mail = True

        if next:
            #wenn wir keine continue section sind, dann wird ein start-eintrag erzeugt
            if not continueworkflow:  
                wf = BitfarmWorkflow()
                if lateworkflow:
                    wf.wf_name = u'late:%s' %name
                elif intervalworkflow:
                    wf.wf_name = u'interval:%s' %name 
                else:
                    wf.wf_name = u'start:%s' %name
                wf.tasks.append(BitfarmTask('create_workflow_step'))
                wf.tasks[0].name = wf.wf_name
                wf.tasks[0].params.wf_name = u'workflow:%s' %name 
                wf.tasks[0].params.options = options
                wf.tasks[0].params.wf_recipient = user_work
                wf.tasks[0].params.wf_controller = user_shed
                wf.tasks[0].params.wf_info = sendmsg
                wf.tasks[0].params.wf_date = termin
                wf.tasks[0].params.wf_alarm = alarm
                wf.tasks[0].params.wf_type = 1  
                wf.condition = condition
                wf.else_tasks = else_task
                wf.wf_type = 0     # der Start-Workflow ist ein Dokumenten-Workflow. Es soll verarbeitet werden, wenn ein Dokument verarbeitet wird.
                wf.wf_trigger = 2 if lateworkflow or intervalworkflow else 0    # 0= Collector findet, 2= bfaArchiving/bfaServer findet Workflow
                wf.arcid = arcid
                wf.options = options
                
                wfProc.save_workflow(wf = wf, wf_type = wf.wf_type,  wf_trigger = wf.wf_trigger)
                bfaxml.object_to_xmlfile(wf, 'wfd\\%s.xml' % wf.wf_name.replace(':', '_'), shortxml = SHORTXML)
            
            if next.lower() == 'nil':
                wf = BitfarmWorkflow()
                if cont is not None:
                    wf.wf_name = u'workflow:%s' %cont
                else:
                    wf.wf_name = u'workflow:%s' %name
                wf.tasks.append(BitfarmTask('end_workflow_step'))
                wf.tasks[0].name = wf.wf_name
                wf.condition = condition
                wf.else_tasks = else_task
                wf.wf_type = 1    
                wf.wf_trigger = 2 if lateworkflow or intervalworkflow else 0    # 0= Collector findet, 2= bfaArchiving/bfaServer findet Workflow
                wf.arcid = arcid
                
                if sendmailtask:
                    wf.tasks.append(sendmailtask)
                
                wfProc.save_workflow(wf = wf, wf_type = wf.wf_type,  wf_trigger = wf.wf_trigger)
                bfaxml.object_to_xmlfile(wf, 'wfd\\%s.xml' % wf.wf_name.replace(':', '_'), shortxml = SHORTXML)  
            else:
                wf = BitfarmWorkflow()
                if cont is not None:
                    wf.wf_name = u'workflow:%s' %cont
                else:
                    wf.wf_name = u'workflow:%s' %name
                wf.tasks.append(BitfarmTask('create_workflow_step'))
                wf.tasks[0].name = wf.wf_name
                wf.tasks[0].params.wf_name = u'workflow:%s' %next 
                wf.tasks[0].params.options = options
                wf.tasks[0].params.wf_recipient = user_work
                wf.tasks[0].params.wf_controller = user_shed
                wf.tasks[0].params.wf_info = sendmsg
                wf.tasks[0].params.wf_date = termin
                wf.tasks[0].params.wf_alarm = alarm
                wf.tasks[0].params.wf_type = 1
                wf.condition = condition  
                wf.else_tasks = else_task
                wf.wf_type = 1 
                wf.wf_trigger = 2 if lateworkflow or intervalworkflow else 0    # 0= Collector findet, 2= bfaArchiving/bfaServer findet Workflow
                wf.arcid = arcid
                
                if sendmailtask:
                    wf.tasks.append(sendmailtask)
                
                wfProc.save_workflow(wf = wf, wf_type = wf.wf_type,  wf_trigger = wf.wf_trigger)
                bfaxml.object_to_xmlfile(wf, 'wfd\\%s.xml' % wf.wf_name.replace(':', '_'), shortxml = SHORTXML)
        else:   #kein mehrstufiger workflow, dann einfache wiedervorlage
            wf = BitfarmWorkflow()
            if lateworkflow:
                wf.wf_name = u'late:%s' %name
            elif intervalworkflow:
                wf.wf_name = u'interval:%s' %name 
            else:
                wf.wf_name = u'workflow:%s' %name
            wf.tasks.append(BitfarmTask('create_resub'))
            wf.tasks[0].name = wf.wf_name
            #wf.tasks[0].params.wf_name = u'workflow:%s' %next 
            wf.tasks[0].params.options = options
            wf.tasks[0].params.wf_recipient = user_work
            wf.tasks[0].params.wf_controller = user_shed
            wf.tasks[0].params.wf_info = sendmsg
            wf.tasks[0].params.wf_date = termin
            wf.tasks[0].params.wf_alarm = alarm
            wf.tasks[0].params.wf_type = 1  
            wf.condition = condition
            wf.else_tasks = else_task
            wf.wf_type = 1    
            wf.wf_trigger = 2 if lateworkflow or intervalworkflow else 0    # 0= Collector findet, 2= bfaArchiving/bfaServer findet Workflow
            wf.arcid = arcid

            if sendmailtask:
                wf.tasks.append(sendmailtask)            
            
            wfProc.save_workflow(wf = wf, wf_type = wf.wf_type,  wf_trigger = wf.wf_trigger)
            bfaxml.object_to_xmlfile(wf, 'wfd\\%s.xml' % wf.wf_name.replace(':', '_'), shortxml = SHORTXML)

                
        print conditions
    
    for wf in nextworkflows:
        if wf in continues:
            print u"nextworkflow %s findet continue-section" %wf
        else:
            print u"nextworkflow %s ohne continue-section" %wf
    
        
    

if len(sortings) > 0:
    task = None
    print "%s Sorting Regeln gefunden" %len(sortings)
    general_sortings = []       #allgemeine sortierregeln die an keinem Archiv gebunden sind
    for sorting in sortings:
        andindocument = None
        orindocument = None
        notindocument = None
        docbarcode = None
        sortto = None
        destination = None
        section = "".join(sorting)
        conditions = []
        condition = None
        cset = None
        cobj = None
        name = re.search('sorting section (.+)', section)
        archiv = re.search('archivtabelle=(\S+)', section)
        #wir gehen zeilenwiese eine sortingnweisung durch
        for line in sorting:
            line = line.lstrip()
            if len(line) == 0:
                continue
            if line[0] == ';':  #auskommentiert, berspringen
                continue
            #print line[:-1]
            sortto = re.search('sortto=(\S+)', line)
            andindocument = re.search('andindocument=(\S+)', line)
            orindocument = re.search('orindocument=(\S+)', line)
            notindocument = re.search('notindocument=(\S+)', line)
            docbarcode = re.search('docbarcode=(\S+)', line)
            
            if andindocument:
                cset = BitfarmConditionSet('', 'ftx', 'contains', andindocument.groups(0)[0])
                cobj = BitfarmConditionObject('and', cset)
                conditions.append(cobj)

            if orindocument:
                cset = BitfarmConditionSet('', 'ftx', 'contains', orindocument.groups(0)[0])
                cobj = BitfarmConditionObject('or', cset)
                conditions.append(cobj)

            if notindocument:
                cset = BitfarmConditionSet('', 'ftx', 'containsnot', notindocument.groups(0)[0])
                cobj = BitfarmConditionObject('and', cset)
                conditions.append(cobj)
            
            if docbarcode:
                cset = BitfarmConditionSet('barcodes', 'document', 'contains', docbarcode.groups(0)[0])
                cobj = BitfarmConditionObject('and', cset)
                conditions.append(cobj)
            
            if sortto:
                destination = sortto.groups(0)[0]

        # jetzt haben wir hoffentlich die sortto anweisungen zusammen, erstellen den Workflow,
        # schreiben den in die sys_wfd.
        # ber den check_workflows Task sollen weitere naming -Regeln gefunden werden, die bei namings zustzlich gespeichert wurden

        if destination is None:
            continue

        if nosortings_condition:    # wenn wir eine nosorting condition haben, dann der sortinganweisung hinzufgen
            conditions.append(nosortings_condition)

        if archiv is None:
            print u"allgemeine Sortierregel %s" %name.groups(0)[0]
            arcid = 0
#            if len(conditions) > 0:
#                condition = BitfarmConditionObject('and', conditions)

            task = BitfarmTask('move_doc')
            task.params.sortto = destination
            if len(conditions) > 0:
                condition = BitfarmConditionObject('and', conditions)
            if condition:
                task.condition = condition
            else:
                continue        # keine Default-Sortierregel ohne Condition! Sonst wird im Zweifelsfall immer sortiert
            general_sortings.append(task)
            continue        #   erstmal sammeln und am ende anlegen
        else:
            archiv = archiv.groups(0)[0]
        if name is None:
            name = archiv
        else:
            name = name.groups(0)[0]

        print u"Verarbeite sorting section %s fr Archiv %s" %(name, archiv)
        arcid = None
        for arc in sys_arc:
            if arc[2].lower() == archiv.lower():
                arcid = arc[0]
                break

        if arcid is None:       # der Workflow war keinem Archiv zuzuordnen, dann mit der nchsten sortingregel weitermachen
            print u"Keine Arcid fr %s gefunden, verarbeite nchste Regel..." %archiv
            continue
        #TODO: sortings mit falschen Zielarchiv aussortieren
        task = None

        if len(conditions) > 0:
            condition = BitfarmConditionObject('and', conditions)

        task = BitfarmTask('move_doc')
        task.params.sortto = destination
        if condition:
            task.condition = condition

        w = BitfarmWorkflow()
        w.wf_trigger = 1   # workflow fr Archivierung
        w.typ = 0       # dokumenten workflow
        if task:
            w.tasks.append(task)
        tcheck = BitfarmTask('check_workflows')
        tcheck.condition = BitfarmConditionSet('result', 'document', '=', True) # nur ausfhren wenn sorting erfolgreich
        w.tasks.append(tcheck)
        w.wf_name = name

        wfProc.save_workflow(wf = w, wf_type = 0,  wf_trigger = 1, wf_prio =1, arcid = arcid,  wf_name = 'sorting:' + name)
        bfaxml.object_to_xmlfile(w, 'wfd\\sorting_%s.xml' %name, shortxml = SHORTXML)

    if len(general_sortings) > 0:
        w = BitfarmWorkflow()
        w.wf_trigger = 1   # workflow fr bfaArchiving
        w.typ = 0       # dokumenten workflow
        i = 1

        for i in range(len(general_sortings) -1, 0 , -1):
            general_sortings[i -1].else_tasks = general_sortings[i]

        w.tasks.append(general_sortings[0])

        tcheck = BitfarmTask('check_workflows')
        tcheck.condition = BitfarmConditionSet('result', 'document', '=', True) # nur ausfhren wenn sorting erfolgreich
        w.tasks.append(tcheck)
        w.wf_name = 'default'

        wfProc.save_workflow(wf = w, wf_type = 0,  wf_trigger = 1, wf_prio =1, arcid = 0,  wf_name =  w.wf_name)
        bfaxml.object_to_xmlfile(w, 'wfd\\default_sorting.xml', shortxml = SHORTXML)

    print "Done..."
