﻿"""
********************************************************************************
**************************   bitfarm-Archiv 2009  ******************************
********************************************************************************
**************************   bitfarm_files.py     ******************************
**************************   Version  3.4.1.1     ******************************
********************************************************************************
****                                                                        ****
****        Modul für die häufigsten Datei-Operation                        ****
****        GetFirstFile,GetLastFIle,CountFiles,readconfig,inilesen         ****
****        GetFiFo                                                         ****
****                                                                        ****
********************************************************************************
********************************************************************************
"""


import sys
if sys.platform == 'win32':
    import win32file
    import win32com.client
    from logging.handlers import NTEventLogHandler
#from vb2py.vbfunctions import *
#from bitfarm_utils import *
import bitfarm_utils
import subprocess
import shutil
import os
import datetime
import time
import logging
import re


scriptname = os.path.basename(sys.argv[0])
if sys.platform== 'win32':
    mypath =os.path.split(os.path.abspath(sys.argv[0]))[0]
else:
    mypath = os.getcwd()
programm = mypath
fullpath = os.path.join( programm , scriptname)

modul = os.path.basename(os.path.splitext(sys.argv[0])[0])
logger = logging.getLogger(modul)

if sys.platform == 'win32':
    try:
        evhandler = NTEventLogHandler(modul)
        logger.addHandler(evhandler)
    except:
        logger = None
else:
    logging.basicConfig()


def GetFirstFile(folder, *extension):
    _ret = None
    if os.path.exists(folder):

        list = ListFiles(folder, *extension)
        if len(list) > 0:
            _ret = list[0]

    return _ret

def GetLastFile(folder, *extension):
    _ret = None
    if os.path.exists(folder):

        list = ListFiles(folder, *extension)
        if len(list) > 0:
            _ret = list[len(list)-1]

    return _ret



def GetFirstFile_extern(folder, mask):
    _ret = None
    strinput = ''
    lswine = ''

    if os.path.exists(os.path.join(programm , 'countfiles.exe')):
        try:
            if sys.platform == 'win32':
                pipe = subprocess.Popen([os.path.join(programm , 'countfiles.exe ') , folder ,mask , '-lf'], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
            else:
                pipe = subprocess.Popen([lswine,'"'+os.path.join(programm , 'countfiles.exe')+'" "'+\
                folder + '" ' + mask + '-lf'], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
            schleife= 0

            while (pipe.returncode == None) and (schleife<5000):
                pipe.poll()
                time.sleep(0.001)
                schleife=schleife+1

            if sys.platform == 'win32':
                subprocess.Popen("taskkill /PID %i" % pipe.pid, shell=True)
            else:
                subprocess.Popen("kill %i" % pipe.pid, shell=True)

            if pipe.returncode <> None:
                strinput=str(pipe.stdout.read())

        except:
            print "error "+str(sys.exc_info()[0])+' '+str(sys.exc_info()[1])

        strinput = strinput.strip()
        lianzahl =strinput.find('Anzahl:')
        lieanzahl= strinput.find(chr(10),lianzahl)
        Anzahl = 0
        if lieanzahl == -1:
            Anzahl =  strinput[lianzahl+7:len(strinput)]
        else:
            Anzahl =strinput[lianzahl+7:strinput.find(chr(10),lianzahl)]
        if int(Anzahl) <> 0:
            strname = Right(strinput, len(strinput) - strinput.rfind(chr(10))-1)
        pipe = None

    return _ret


def GetLastFile_extern(folder, mask):
    _ret = None
    strinput = ''
    lswine = ''

    if os.path.exists(os.path.join(programm , 'countfiles.exe')):
        try:
            if sys.platform == 'win32':
                pipe = subprocess.Popen([os.path.join(programm , 'countfiles.exe ') , folder ,mask , '-ll'], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
            else:
                pipe = subprocess.Popen([lswine,os.path.join(programm , 'countfiles.exe'),  folder, mask, '-ll'], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
#                print [lswine,os.path.join(programm , 'countfiles.exe'),   folder, mask, '-ll']
            schleife= 0

            pipe.poll()
            while (pipe.returncode == None) and (schleife<5000):
                pipe.poll()
                time.sleep(0.001)
                schleife=schleife+1

            if sys.platform == 'win32':
                subprocess.Popen("taskkill /PID %i" % pipe.pid, shell=True)
            else:
                subprocess.Popen("kill %i" % pipe.pid, shell=True)

            if pipe.returncode <> None:
                strinput=str(pipe.stdout.read())

        except:
            print "error "+str(sys.exc_info()[0])+' '+str(sys.exc_info()[1])

        strinput = strinput.strip()
        lianzahl =strinput.find('Anzahl:')
        lieanzahl= strinput.find(chr(10),lianzahl)
        Anzahl = 0
        if lieanzahl == -1:
            Anzahl =  strinput[lianzahl+7:len(strinput)]
        else:
            Anzahl =strinput[lianzahl+7:strinput.find(chr(10),lianzahl)]

        if int(Anzahl) <> 0:
            strname = Right(strinput, len(strinput) - strinput.rfind(chr(10))-1)
        _ret = strname
        pipe = None

    return _ret

def GetFiFo_extern(fifopath, basename):
    _ret = None

    """
    scriptname = os.path.basename(sys.argv[0])
    if sys.platform== 'win32':
        mypath =os.path.split( sys.argv[0])[0]
    else:
        mypath = os.getcwd()
    programm = mypath
    fullpath = os.path.join( programm , scriptname)
   """

    basename = basename.lower()
    highest = 0
    fifofile = GetLastFile_extern(fifopath,'*.*')
    strfifo = os.path.splitext(os.path.basename(fifofile))[0]
    if '_0' in strfifo:
        strfifo = strfifo.replace( '_0', '')
    if '-archiv' in strfifo:
        strfifo = strfifo.replace( '-archiv', '')
    if '-temp' in strfifo:
        strfifo = strfifo.replace( '-temp', '')
    strnumber = Right(strfifo, 5)
    highest = StrConvert(strnumber)
    if highest == 99999:
        if basename == 'prio':
            logger.setLevel(Loggingmodul.ERROR)
            logger.warning( 'bitfarm-Archiv: Achtung Totaler Overflow - Queue vollgelaufen !' + '\r\n' + 'Es werden keine Dokumente mehr gespoolt')
            fifofolder = None
            sys.exit(2)
        else:
            basename = 'prio'
            _ret = GetFiFo(fifopath, basename)
            return
    tempnumber = str(highest + 1)
    tempnumber = tempnumber.zfill(5)
    time.sleep(0.1000)
    fifofolder = os.path.abspath(fifopath)
    for fifofile in os.listdir( fifofolder):
        strfifo = os.path.abspath(fifofile)
        if strfifo == basename + tempnumber:
            if scriptdebug == True:
                logger.setLevel(Loggingmodul.WARNING)
                logger.warning('Archivierung.vbs' + '\r\n' + 'Slot schon besetzt, Routine wird nochmals aufgerufen' + '\r\n' + tempnumber)
            _ret = GetFiFo(fifopath, basename)
            fifofolder = None
            fifofile = None
            return _ret
    fifofolder = None
    fifofile = None
    _ret = os.path.join(fifopath, basename + tempnumber)
    return _ret



def GetFiFo(fifopath, basename, *len_index):
    _ret = None
    basename = basename.lower()
    highest = 0
    biggest = 0
    i = 1
    tempnumber = ''
    list =[]
    if len(len_index) == 0:
        len_index = 5
    else:
        len_index = len_index[0]


    biggest = int(10 ** len_index) -1

    fifofile = GetLastFile(fifopath)
    if not fifofile:
        tempnumber='1'
        tempnumber= tempnumber.zfill(len_index)
    else:
        strfifo = os.path.splitext(os.path.basename(fifofile))[0]

        while highest == 0:
            if strfifo.find('_0') != 0:
                strfifo = strfifo.replace('_0','')
            if strfifo.find('-archiv') != 0:
                strfifo = strfifo.replace('-archiv','')
            if strfifo.find('-temp') != 0:
                strfifo = strfifo.replace('-temp','')

            if len(strfifo)>len_index-1:
                strnumber = strfifo[len(strfifo)-len_index:]
                if strnumber.isdigit():
                    highest=int(strnumber)

                    if highest >= biggest:
                        if basename == 'prio':
                            logger.setLevel(Loggingmodul.ERROR)
                            logger.warning( 'bitfarm-Archiv: Achtung Totaler Overflow - Queue vollgelaufen !' + '\r\n' + 'Es werden keine Dokumente mehr gespoolt')
                            fifofolder = None
                            sys.exit(2)
                        else:
                            basename = 'prio'
                            _ret = GetFiFo(fifopath, basename)
                            return _ret

                    highest = highest +1
                    tempnumber = str(highest)
                    tempnumber = tempnumber.zfill(len_index)
                    time.sleep(0.1000)

                    # jetzt gegenprüfen, ob der name immer noch frei ist
                    list = ListFiles(fifopath)
                    if list:
                        suchedatei= re.compile(basename + tempnumber, re.IGNORECASE)
                        listfiltered=filter(suchedatei.search,list)
#                        print listfiltered
                        if len(listfiltered):
                            print('Slot besetzt')
                            _ret = GetFiFo(fifopath, basename, *len_index)
                            return _ret
                        else:
                            break

            if not list:
                list = ListFiles(fifopath)
            i = i +1
            if i <= len(list):
                strfifo = os.path.splitext(os.path.basename(list[-i]))[0]
            else:
                strfifo ='0'
                strfifo = strfifo.zfill(len_index)


    _ret = os.path.join(fifopath, basename + tempnumber)
    return _ret



def Countpages(tifdatei):
    _ret = None
    if os.path.exists(tifdatei) and LCase(os.path.splitext(tifdatei)[1]) == '.tif' and os.path.exists(programm + 'CountPages.exe'):
        strinput = ''
        schleife = 0
        oExec = objWSHShell.Exec(programm + 'CountPages.exe ' + tifdatei)
        while not oExec.StdOut.AtEndOfStream:
            strinput = strinput + oExec.StdOut.Read(1)
        durch = False
        schleife = 0
        while schleife < 50:
            if oExec.Status == 1:
                durch = True
                break
            time.sleep(0.100)
            schleife = schleife + 1
        if durch == False:
            logger.setLevel(Loggingmodul.WARNING)
            logger.warning('Archivierung.vbs Function countpages: Schwerwiegender Fehler' + '\r\n' + 'Countpages.exe antwortet nicht oder wird nicht beendet' + '\r\n' + 'Status: ' + oExec.Status + '\r\n' + 'Exitcode ' + oExec.ExitCode + '\r\n' + 'Schleife: ' + schleife)
            countpages = 0
            oExec.Terminate()
        else:
            if Instr(1, strinput, 'Seiten:') <> 0:
                strinput = Trim(Right(strinput, len(strinput) - Instr(1, strinput, 'Seiten:') - 6))
                strinput = Left(strinput, Instr(1, strinput, chr(13)) - 1)
                countpages = StrConvert(strinput)
    else:
        countpages = 0
    return countpages


def CountFiles_extern(folder, mask):
    _ret = None
    _ret = 0
    if os.path.exists(os.path.join(programm , 'countfiles.exe')):
        try:
            if sys.platform == 'win32':
                pipe = subprocess.Popen([os.path.join(programm , 'countfiles.exe ') , folder ,mask , '-ll'], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
            else:
                pipe = subprocess.Popen([lswine,os.path.join(programm , 'countfiles.exe'),  folder, mask, '-ll'], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
#                print [lswine,os.path.join(programm , 'countfiles.exe'),   folder, mask, '-ll']
            schleife= 0

            pipe.poll()
            while (pipe.returncode == None) and (schleife<5000):

                pipe.poll()

                time.sleep(0.001)
                schleife=schleife+1
            #print str(subprocess.mswindows)
            if sys.platform == 'win32':
                subprocess.Popen("taskkill /PID %i" % pipe.pid, shell=True)
            else:
                subprocess.Popen("kill %i" % pipe.pid, shell=True)
            #print str(pipe.returncode)
            if pipe.returncode <> None:
                strinput=str(pipe.stdout.read())

                #print str(pipe.stderr.read())
        except:
            print "error "+str(sys.exc_info()[0])+' '+str(sys.exc_info()[1])

        strinput = strinput.strip()
#        print strinput
        lianzahl =strinput.find('Anzahl:')
        lieanzahl= strinput.find(chr(10),lianzahl)
        Anzahl = 0
        if lieanzahl == -1:
            Anzahl =  strinput[lianzahl+7:len(strinput)]
        else:
            Anzahl =strinput[lianzahl+7:strinput.find(chr(10),lianzahl)]

        _ret = int(Anzahl)
        #_ret = StrConvert(strname)

    return _ret


def CountFiles(folder, *extension):
    _ret = None

    if os.path.exists(folder):

        list = os.listdir(folder)
        if extension == '' or len(extension) == 0:
            _ret = len(list)
        else:
            pythonfiles= re.compile("\w*"+extension[0]+"$", re.IGNORECASE)
            listfiltered=filter(pythonfiles.search,list)
            _ret = len(listfiltered)


    return _ret


def ListFiles(folder, *extension):
    _ret = None

    if os.path.exists(folder):

        list = os.walk(folder).next()
        if extension == '' or len(extension) == 0:
            _ret = list[2]
        else:

            pythonfiles= re.compile("\w*"+extension[0]+"$", re.IGNORECASE)
            listfiltered=filter(pythonfiles.search,list[2])
            _ret = listfiltered
        if sys.platform <> "win32":
            _ret.sort()
    return _ret

def ListBasefiles(folder, *basename):
    _ret = None

    if os.path.exists(folder):

        list = os.walk(folder).next()
        if basename == '' or len(basename) == 0:
            _ret = list[2]
        else:

            pythonfiles= re.compile(basename[0]+".", re.IGNORECASE)
            listfiltered=filter(pythonfiles.search,list[2])

            if not listfiltered:
                _ret = None
            else:
                _ret = listfiltered
        if sys.platform <> "win32":
            _ret.sort()
    return _ret

def inilesen(inipfad):
    _ret=None

    if os.path.isfile(inipfad):
        try:
            f = open(inipfad,"r")
            inp = f.read()
            f.close
        except:
            print "Die Datei %s konnte nicht gelesen werden" % (inipfad)
            return _ret
    else:
        print "Die Datei %s konnte nicht gefunden werden" % (inipfad)
        return _ret
    inhalt = inp.decode('iso-8859-1')

    it = re.finditer(r"(.*) *=( *.*)",inhalt , re.I)

    ini={}
    for m in it:
        try:
            if m.group(1)[0] != ';':
                ini.update({m.group(1).strip():m.group(2).strip() if m.group(2).strip() != '' else False})
        except:
            print "Fehler: %s=%s" % (m.group(1),m.group(2))
#    print ini
#    counter = 0
    for items in ini:
#        try:
#            print "first "+str(len(ini))
#            print ini[items]
#            print type(items)
#            print items.encode("utf-8")
#            print type(ini[items])
#            print counter
#        except:
#            print str(sys.exc_info()[0])+' '+str(sys.exc_info()[1])
#        counter = counter +1

        if type(ini[items]) == unicode:
#            print "fer "+items.encode("utf-8")
            if ini[items].lower() == 'true':
                ini[items]= True
            elif ini[items].lower() == 'false':
                ini[items]= False
            elif ini[items].isdigit():
#                 print  "my digit "+str(ini[items])
                 ini[items]= int(ini[items])
            elif '"' in ini[items]:
                ini[items]= ini[items].replace('"','')
            elif '\\' in ini[items] or ':\\' in ini[items]:
                if sys.platform == 'win32':
                    if not (os.path.isdir(ini[items]) or os.path.isfile(ini[items])):
                        print "Der Pfad %s (%s) konnte nicht gefunden werden" % (items,ini[items])
                        ini[items]= False

#        print "der "+str(counter)
#    print "exiting"
#    print ini
    return ini



def create_arcfolder(con,  svnpath):
    # erstellt abhängig vom Datum die entsprechenden Archivverzeichnisse

    if not os.path.exists(con.archivverzeichnis):
        errortext = 'Das Archivverzeichnis ' + con.archivverzeichnis + ' existiert nicht - Programmabruch'
        print errortext
        logger.setLevel(Logging.WARNING)
        logger.warning(errortext)
        sys.exit(2)


    if not os.path.exists(con.archivkopie):
        errortext = 'Das Archivverzeichnis ' + con.archivkopie + ' existiert nicht - Programmabruch'
        print errortext
        logger.setLevel(Logging.WARNING)
        logger.warning(errortext)
        sys.exit(2)

    sub1 = time.strftime("%m%Y")
    sPath = os.path.join(con.archivverzeichnis, sub1)
    makedir(sPath)
    sPath = os.path.join(con.archivkopie, sub1)
    makedir(sPath)
    bitfarm_utils.svn_add(sPath,  svnpath)

    sub2 = time.strftime("%d")
    sPath = os.path.join(con.archivverzeichnis, sub1, sub2)
    makedir(sPath)
    sPath = os.path.join(con.archivkopie, sub1, sub2)
    makedir(sPath)
    bitfarm_utils.svn_add(sPath,  svnpath)

    _ret = os.path.join(sub1,sub2)
    return _ret

def makedir(lsPath):
    _ret = True
    if not os.path.exists(lsPath):
        errortext = '(0): kann Archivverzeichnis '+lsPath+'  nicht erstellen - Berechtigung?'
        try:
            tes1 = os.mkdir(lsPath)
            tes1 = None
            time.sleep(0.200)
        except:
            logger.setLevel(Logging.WARNING)
            logger.warning(modul + errortext)
            print errortext
            sys.exit(2)
        if not os.path.exists(lsPath):
            logger.setLevel(Logging.WARNING)
            logger.warning(modul + errortext)
            print errortext
            sys.exit(2)

    return _ret

def svn_diradd(lsPAth):
    _ret = True

    return _ret

def create_arcfilename(con, larcFolder):
    _ret = None
    lsFilename = time.strftime("%Y%m%d%H%M%S")
    lsPath = os.path.join(con.archivverzeichnis, larcFolder)
    lsPath2 = os.path.join(con.archivkopie, larcFolder)

    while ListBasefiles(lsPath, lsFilename) or ListBasefiles(lsPath2, lsFilename):
        lsFileName = time.strftime("%Y%m%d%H%M%S")

    _ret = lsFilename
    return _ret

def test():
    list = inilesen('D:\\bitfarm-archiv\\scripts.ini')
    print list


def test_countfiles():

    start = time.time()
    list = CountFiles('C:\\Python_Test\\bitfarm\\count', '*.*')
    ende = time.time()
    print list
    print ende - start


    print 'countfilespy'
    start = time.time()
    list = CountFiles_py('C:\\Python_Test\\bitfarm\\count')
    ende = time.time()
    print list
    print ende - start

    print 'countfilespy2'
    start = time.time()
    list = countfiles_py('C:\\Python_Test\\bitfarm\\count')
    ende = time.time()
    print list
    print ende - start

def test_countfiles2():

    print 'countfilespy2'
    start = time.time()
    list = CountFiles_py2('C:\\Python_Test\\bitfarm\\count','.txt')
    ende = time.time()
    print list
    print ende - start

def test_ListFiles():
    list = ListFiles('D:\\bitfarm-archiv\\queue\\')

    print list

def test_ListBasefiles():
    list = ListBasefiles('D:\\bitfarm-archiv\\queue\\','temp00002')

    print list

def test_ListBasefiles():
    list = ListBasefiles('D:\\bitfarm-archiv\\queue\\','temp00002')

    print list

def test_GetFirstFile():
    list = GetFirstFile('C:\\Python_Test\\bitfarm\\count','e')
    print list
    if list == None:
        print 'leer'
    if not list:
        print 'not!'

def test_GetLastFile():
    list = GetLastFile('D:\\bitfarm-archiv\\queue','.py')
    print list

def test_GetFiFo():
    list = GetFiFo('C:\\Python_Test\\bitfarm\\queue','temp')
    print list


if __name__ == "__main__":
    test_ListFiles()
    test_ListBasefiles()
    #test_GetFiFo()
    test_GetLastFile()
