# This Python file uses the following encoding: utf-8
"""
********************************************************************************
**************************   bitfarm-Archiv 2009  ******************************
********************************************************************************
**************************   bitfarm_imaging.py     ******************************
**************************   Version  3.4.1.0     ******************************
********************************************************************************
****                                                                        ****
****        Modul fuer die Datei Ausdruck in PS                              ****
****                                                                        ****
********************************************************************************
********************************************************************************
"""


import sys, pickle

#from vb2py.vbfunctions import *
from bitfarm_utils import *
from bitfarm_files import *
import subprocess
import shutil
import sys
import datetime
import time
import logging as Logging
import re
import os

scriptdebug = True



if sys.platform == 'win32':
    import win32file
    from win32com.client import *
    from logging.handlers import NTEventLogHandler
#    evhandler = NTEventLogHandler(modul)
#    logger.addHandler(evhandler)
else:
    from logging.handlers import SysLogHandler
    Logging.basicConfig()

if sys.platform == 'win32':
    batext = ".bat"
else:
    batext = ".sh"   



#scriptname = os.path.basename(sys.argv[0])
#if sys.platform== 'win32':
#    mypath =os.path.split(os.path.abspath(sys.argv[0]))[0]
#else:
#    mypath = os.getcwd()
#programm = mypath

if sys.platform == 'win32':
    mypath = os.environ['bitfarm-archiv']
    programmbin = os.path.join(mypath, "bin")
#    mypath =os.path.split(os.path.abspath(sys.argv[0]))[0]
else:
    programmbin = os.getcwd()
    mypath = os.path.abspath(os.path.join(programmbin, ".."))
programm = mypath

fullpath = os.path.join(programm , scriptname)

modul = os.path.basename(os.path.splitext(sys.argv[0])[0])
#logger = logging.getLogger(modul)

#if sys.platform == 'win32':
#    evhandler = NTEventLogHandler(modul)
#    logger.addHandler(evhandler)
#else:
#    logging.basicConfig()

# kapselt ODTtoPS und PStoTIF
def ODTtoTIF(paramsdict, job, con, logger):
    paramsdict = ODTtoPS(paramsdict, job, con, logger)
    if paramsdict['erfolg'] == True:
        paramsdict = PStoTIF(paramsdict, job, con, logger)
    return paramsdict

# kapselt DOCtoPS und PStoTIF    
def DOCtoTIF(paramsdict, job, con, logger):
    paramsdict = DOCtoPS(paramsdict, job, con, logger)
    if paramsdict['erfolg'] == True:
        paramsdict = PStoTIF(paramsdict, job, con, logger)
    return paramsdict

# kapselt XLStoPS und PStoTIF
def XLStoTIF(paramsdict, job, con, logger):
    paramsdict = XLStoPS(paramsdict, job, con, logger)
    if paramsdict['erfolg'] == True:
        paramsdict = PStoTIF(paramsdict, job, con, logger)
    return paramsdict

# kapselt XLStoPS und PStoTIF
def PPTtoTIF(paramsdict, job, con, logger):
    paramsdict = PPTtoPS(paramsdict, job, con, logger)
    if paramsdict['erfolg'] == True:
        paramsdict = PStoTIF(paramsdict, job, con, logger)
    return paramsdict    
# kapselt PDFtoPS und PStoTIF
def PDFtoTIF(paramsdict, job, con, logger):
    paramsdict = PDFtoPS(paramsdict, job, con, logger)
    if paramsdict['erfolg'] == True:
        paramsdict = PStoTIF(paramsdict, job, con, logger)
    return paramsdict

def PStoTIF(paramsdict, job, con, logger):
    dateiname   = paramsdict["dateiname"]
    extension   = paramsdict["extension"]
    color       = paramsdict["color"]
    OCRHandle   = paramsdict["OCRHandle"]
    hires       = paramsdict["hires"]
    _ret = None
    erfolg = True
    rc = 0
    print "bitfarm_imaging: PStoTIF Start ----------------------------------------------"

    try:
        lngReturnCode = os.system('"' + os.path.join(programmbin , 'processmonitor.bat') + '" ghostscript')
    except:
        pass
    time.sleep(0.200)
    if sys.platform == "win32":
    
        if job.ocrtyp == 'TXT':
            lsparam = '"' + os.path.join(programmbin , 'ghostscript' + batext) + '" @' + os.path.join(programm , 'tiff-OCR.rsp') + ' ' + dateiname + '-temp.tif ' + dateiname + '.ps'
        else:
            lsparam = '"' + os.path.join(programmbin , 'ghostscript' + batext) + '" @' + os.path.join(programm , 'tiff-300.rsp') + ' ' + dateiname + '-temp.tif ' + dateiname + '.ps'
    else:
        if hires:
            lsparam = os.path.join(programm , 'ghostscript.sh') + ' @' + programm + '\\filter\\tiff-300.rsp ' + dateiname + '-temp.tif ' + dateiname + '.ps'
        else:
            lsparam = os.path.join(programm , 'ghostscript.sh') + ' @' + programm + '\\filter\\tiff-200.rsp ' + dateiname + '-temp.tif ' + dateiname + '.ps'
        
    #print lsparam
    strinput = ""
    try:
        schleife = 0
        pipe = subprocess.Popen(lsparam, stdout=subprocess.PIPE)
#        print lsparam
        pipe.poll()
        while (pipe.returncode == None) and (schleife < 5000):
            pipe.poll()
            time.sleep(0.001)
            schleife = schleife + 1

        rc = pipe.returncode
        strinput = pipe.stdout.read()
    except:
        print str(sys.exc_info()[0])

    #print strinput

    if rc <> 0:
        errortxt = 'bitfarm_imaging: PStoTIF: Fehler bei Ghostscript(Color).'
        ##logger.setLevel(Logging.WARNING)
        logger.warning(errortxt)
        erfolg = False
        
    if not os.path.exists(dateiname + '-temp.tif'):
        errortxt = 'bitfarm_imaging: PStoTIF: Fehler bei Ghostscript: keine TIF-Datei erzeugt. Moelicherweise zu wenig freier Festplattenspeicher.'
        ##logger.setLevel(Logging.WARNING)
        logger.warning(errortxt)
        erfolg = False
   
    if erfolg:
        lngReturnCode = RunFilter(dateiname + '-temp.tif', os.path.join(programm , 'tiff-300.txt'), dateiname + '.tif')
        if lngReturnCode <> 0:
            errortxt = 'bitfarm_imaging: PStoTIF: Fehler bei Filtern nach Ghostscript.'
            ##logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            GetGarbage(dateiname)
            Unlock(lockdatei)
            print errortxt
            sys.exit(2)
        time.sleep(0.200)
        
        if not os.path.exists(dateiname + '.tif'):
            errortxt = 'bitfarm_imaging: PStoTIF: Fehler beim Filtern: keine TIF-Datei erzeugt. Moeglicherweise zu wenig freier Festplattenspeicher.'
            ##logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print "\t" + errortxt
            
            if not os.path.exists(dateiname + '-temp.tif'):
                errortxt = 'bitfarm_imaging: PStoTIF: Fehler beim Filtern: keine temp.TIF-Datei erzeugt. Moeglicherweise zu wenig freier Festplattenspeicher.'
                ##logger.setLevel(Logging.WARNING)
                logger.warning(errortxt)
                print "\t" + errortxt
                GetGarbage(dateiname)
                Unlock(lockdatei)
                sys.exit(2)
            else:
                try:
                    os.rename(dateiname + '-temp.tif', dateiname + '.tif')
                except:
                    errortxt = 'bitfarm_imaging: PStoTIF: Fehler beim Filtern: konnte temp.tif nicht in tif umbennen'
                    ##logger.setLevel(Logging.WARNING)
                    logger.warning(errortxt)
                    print "\t" + errortxt
                    GetGarbage(dateiname)
                    Unlock(lockdatei)
                    sys.exit(2)
                    
        os.remove(dateiname + '-temp.tif')
        lngReturnCode = os.system('"' + os.path.join(programmbin , 'processmonitor.bat') + '" ghostscript')
        time.sleep(0.200)
        
        
        
        if sys.platform == "win32":
            if color:
                if not hires:
                    lsparam = '"' + os.path.join(programmbin , 'ghostscript' + batext) + '" "@' + os.path.join(programm , 'tiff-200-color.rsp') + '" ' + dateiname + '-archiv.tif ' + dateiname + '.ps'
                else:
                    lsparam = '"' + os.path.join(programmbin , 'ghostscript' + batext) + '" "@' + os.path.join(programm , 'tiff-300-color.rsp') + '" ' + dateiname + '-archiv.tif ' + dateiname + '.ps'
            else:
                if hires == False:
                    lsparam = '"' + os.path.join(programmbin , 'ghostscript' + batext) + '" @' + os.path.join(programm , 'tiff-200.rsp') + ' ' + dateiname + '-archiv.tif ' + dateiname + '.ps'
                else:
                    lsparam = '"' + os.path.join(programmbin , 'ghostscript' + batext) + '" @' + os.path.join(programm , 'tiff-300.rsp') + ' ' + dateiname + '-archiv.tif ' + dateiname + '.ps'
        else:
            if color:
                if not hires:
                    lsparam = os.path.join(programm , 'ghostscript.sh') + ' @' + programm + '\\filter\\tiff-200-color.rsp ' + dateiname + '-archiv.tif ' + dateiname + '.ps'
                else:
                    lsparam = os.path.join(programm , 'ghostscript.sh') + ' @' + programm + '\\filter\\tiff-300-color.rsp ' + dateiname + '-archiv.tif ' + dateiname + '.ps'
            else:
                if hires == False:
                    lsparam = os.path.join(programm , 'ghostscript.sh') + ' @' + programm + '\\filter\\tiff-200.rsp ' + dateiname + '-archiv.tif ' + dateiname + '.ps'
                else:
                    lsparam = os.path.join(programm , 'ghostscript.sh') + ' @' + programm + '\\filter\\tiff-300.rsp ' + dateiname + '-archiv.tif ' + dateiname + '.ps'

        
        #print lsparam
        try:
            schleife = 0
            pipe = subprocess.Popen(lsparam, stdout=subprocess.PIPE)
            pipe.poll()
            while (pipe.returncode == None) and (schleife < 5000):
                pipe.poll()
                time.sleep(0.001)
                schleife = schleife + 1
    
            rc = pipe.returncode
            strinput = pipe.stdout.read()
    
    
        except:
            print str(sys.exc_info()[0])
    
       # print strinput
    
        if rc <> 0:
            errortxt = 'bitfarm_imaging: PStoTif: Fehler bei Ghostscript (Archiv-tif konnte nicht erstellt werden).'
            ##logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            erfolg = False
            GetGarbage(dateiname)
            Unlock(lockdatei)
            print "\t" + errortxt
            sys.exit(2)
            
        archivtif = dateiname + '-archiv'
        if not os.path.exists(dateiname + '-archiv.tif'):
            errortxt = 'bitfarm_imaging: PStoTIF: Fehler bei Ghostscript: keine Archiv-TIF-Datei erzeugt. Moeglicherweise zu wenig freier Festplattenspeicher.'
            ##logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            GetGarbage(dateiname)
            Unlock(lockdatei)
            print "\t" + errortxt
            sys.exit(2)
        
            #TODO: Powerpoint rotate ausgelagert
        
   
    if erfolg == False:
        paramsdict["erfolg"] = True
        paramsdict["OCRHandle"] = '.tif'
        paramsdict["erfolg"] = False
        paramsdict["handle"] = 'unbekannt'
        job.ocrtyp = 'TXT'

    else:
        paramsdict["OCRHandle"] = '.tif'
        paramsdict["erfolg"] = True
        paramsdict["handle"] = 'tif'
    paramsdict['archivtif'] = archivtif
    paramsdict["con"] = con
    paramsdict["job"] = job 
    print "bitfarm_imaging: PStoTIF Ende -----------------------------------------------"   
    return paramsdict

def PDFtoPS(paramsdict, job, con, logger):
    print "bitfarm_imaging: PDFtoPS Start ----------------------------------------------"
    color = paramsdict["color"]
    extension = paramsdict["extension"]
    dateiname = paramsdict["dateiname"]
    hires = paramsdict["hires"]
    checkexistingdocpreview = paramsdict["checkexistingdocpreview"]
    CustomPDFtoTIFFConverter = paramsdict["CustomPDFtoTIFFConverter"]
    Filtermakro = paramsdict["Filtermakro"]

    if (color==False):
        Filter1="tiff-200.rsp"
        Filter2="tiff-300.rsp"
    else:
        Filter1="tiff-200-color.rsp"
        Filter2="tiff-300-color.rsp"
    
    erfolg = False
    
    # entferne Postscript falls vorhanden
    if os.path.exists(dateiname + '.ps'):
        os.remove(dateiname + '.ps')
   
    # Auf schon vorhandene, mitgelieferte Voaransichten pruefen
    if checkexistingdocpreview:
        if os.path.exists(dateiname + '.tif'):
            return paramsdict
    # tiff direkt erzeugen per pdftotiff
    if LCase(CustomPDFtoTIFFConverter) == 'pdftotiff':
        if hires:
            lngReturnCode = os.system('"' + os.path.join(programm , 'pdftotiff') + '" -i ' + dateiname + '.pdf -o ' + queue + ' -b 1 -m -x 300 -y 300')
        else:
            lngReturnCode = os.system('"' + os.path.join(programm , 'pdftotiff') + '" -i ' + dateiname + '.pdf -o ' + queue + ' -b 1 -m -x 200 -y 200')
        if not os.path.exists(dateiname + '.tif'):

            errortxt = 'bitfarm_imaging: PDFtoPS: Fehler bei pdftotiff: keine TIF-Datei erzeugt. PDF-Datei moeglicherweise fehlerhaft.'
            ##logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print errortxt
            erfolg = False
        if erfolg:
            shutil.copyfile(dateiname + '.tif', dateiname + '-archiv.tif')
            archivtif = dateiname + '-archiv'
        if erfolg:
            if hires == False:
                lngReturnCode = os.system('"' + os.path.join(programm , 'pdftotiff') + '" -i ' + dateiname + '.pdf -o ' + queue + ' -b 1 -m -x 300 -y 300')
    # ansonsten pdftops, dann pstotiff
    else:
        if scriptdebug:
            turn = 0
            while not (os.path.exists(dateiname + '.pdf') or turn == 200):
                time.sleep(0.100)
                turn = turn + 1
            ##logger.setLevel(Logging.WARNING)
            logger.warning('Turns: ' + str(turn))
        lngReturnCode = os.system('"' + os.path.join(programm , 'processmonitor.bat') + '" PDFtoPS')
        time.sleep(0.200)
        lngReturnCode = os.system('"' + os.path.join(programm , 'PDFtoPS.bat') + '" ' + dateiname + '.pdf')
        if lngReturnCode <> 0:
            errortxt = 'bitfarm_imaging: PDFtoPS: Fehler bei PDFtoPS.bat ' + dateiname + '.pdf'
            ##logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print "\t" + errortxt
            erfolg = False
        else:
            erfolg = True
        time.sleep(0.200)
        if not os.path.exists(dateiname + '.ps'):

            errortxt = 'bitfarm_imaging: PDFtoPS: Fehler bei PDFtoPS.bat: keine Postscript-Datei erzeugt. PDF-Datei moeglicherweise fehlerhaft.' + dateiname + '.ps'
            ##logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print "\t" + errortxt
            erfolg = False


    if erfolg:
        if InStr(1, Filtermakro, 'dropscanpdf') <> 0:
            if os.path.exists(dateiname + '.pdf'):
                try:
                    os.remove(dateiname + '.pdf')
                except:
                    errortxt = 'bitfarm_imaging: PDFtoPS: Fehler bei dropscanpdf der pdf-Datei.' + dateiname + '.pdf'
                    ##logger.setLevel(Logging.WARNING)
                    logger.warning(errortxt)
                    print "\t" + errortxt
                    erfolg = False
                else:
                    Filtermakro = Filtermakro.replace('dropscanpdf', '')
                    OCRhandle = '.tif'
                    extension = '.pdf'
                    filterjob(dateiname)
    if erfolg == True:
        extension = '.tif'
        paramsdict["OCRHandle"] = '.tif'
        paramsdict["Filtermakro"] = Filtermakro

    paramsdict['erfolg'] = erfolg
    paramsdict["extension"] = extension
    paramsdict["color"] = color
    paramsdict["hires"] = hires
    paramsdict["job"] = job
    paramsdict["con"] = con
    print "bitfarm_imaging: PDFtoPS Ende -----------------------------------------------"
    return paramsdict

# wird nicht mehr benötigt, in pdftotiff integrier

def DOCtoPS(paramsdict, job, con, logger):
    print "bitfarm_imaging: DOCtoPS Start ----------------------------------------------"
    dateiname = paramsdict["dateiname"]
    extension = paramsdict["extension"]
    lngReturnCode = ""
    officeOCR = paramsdict["officeOCR"]
    handle = paramsdict["handle"]
    
    erfolg = True
    tempextension = extension
    if sys.platform == "win32":
        temp = os.path.join(mypath, 'temp')
    else:
        temp = '/tmp/'

    if setServicePrinter():
        erfolg = True

    # WordObjekt erzeugen
    if erfolg:
        try:
            objWord = win32com.client.Dispatch("Word.Application")
        except:
            errortxt = 'bitfarm_imaging: DOCtoPS: Kein Word installiert oder Fehler beim Zugriff.'
            ##logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print errortxt
            erfolg = False
            
    # vorhandene Serviceprinter.ps löschen
    if erfolg:
        if os.path.exists(temp + 'Serviceprinter.ps'):
            try:
                os.remove(temp + 'Serviceprinter.ps')
            except:
                errortxt = 'bitfarm_imaging.py: DOCtoPS: kann Serviceprinter.ps nicht loeschen.'
                ##logger.setLevel(Logging.WARNING)
                logger.warning(errortxt)
                print errortxt
                erfolg = False
                objWord = None

    if extension == '.vcf':
        extension = '.txt'

    if erfolg:
        attribbits = win32file.GetFileAttributes(dateiname + extension)
        attribbits = (attribbits) & (~1) & (~(8 + 16 + 64 + 128))
        win32file.SetFileAttributes(dateiname + extension, attribbits)
        time.sleep(0.200)
        #******************** Registrierungsschl?ssel "Deaktivierte Elemente" loeschen falls vorhanden *******

        #objWSHShell.regdelete('HKEY_CURRENT_USER\\Software\\Microsoft\\Office\\10.0\\Word\\Resiliency\\DisabledItems\\')
        #objWSHShell.regdelete('HKEY_CURRENT_USER\\Software\\Microsoft\\Office\\11.0\\Word\\Resiliency\\DisabledItems\\')
        #objWSHShell.regdelete('HKEY_CURRENT_USER\\Software\\Microsoft\\Office\\12.0\\Word\\Resiliency\\DisabledItems\\')

        #*****************************************************************************************
    # Dokument laden    
    if erfolg:
        # TODO: Processmonitor ueberarbeiten/auslagern
        #lngReturnCode = os.system('"' + os.path.join(programm , 'processmonitor.bat') + '" WORD')
        time.sleep(0.200)

        erfolg = False
        versuche = 0
        while erfolg == False and versuche < 3:
            try:
                wordDoc = objWord.Documents.Add(dateiname + extension)
            except:
                wordDoc = None
                versuche = versuche + 1
                errortxt = 'bitfarm_imaging.py: DOCtoPS: Fehler bei MS-Office zu TIF Wandlung. Bitte prüfen, ob das Dokument in Office ohne weitere Meldungen gedruckt werden kann, ggf. Änderungen vornehmen und erneut archivieren.'
                ##logger.setLevel(Logging.WARNING)
                logger.warning(errortxt + '\r\n' + '\t' + str(sys.exc_info()[1]) + '\r\n' + 'Versuche:' + str(versuche))
                erfolg = False
                print "\t" + errortxt
                time.sleep(0.2000)
            else:
                erfolg = True
    if erfolg:
        try:
            objWord.visible = False
            objWord.DisplayAlerts = False
            objWord.Options.PrintBackground = False
            objWord.Options.PrintHiddenText = False
            objWord.DisplayAlerts = False
        except:
            if scriptdebug:
                ##logger.setLevel(Logging.WARNING)
                logger.warning('bitfarm_imaging.py: DOCtoPS: Fehler bei Abfrage der ProtectionType-Eigenschaft' + '\r\n' + '\r\n' + str(sys.exc_info()[1]))
                print '\tbitfarm_imaging.py: DOCtoPS: Fehler bei Abfrage der ProtectionType-Eigenschaft' + '\r\n' + '\r\n' + str(sys.exc_info()[1])   
        # Unprotect
        if objWord.ActiveDocument.ProtectionType == -1:
            wordprotect = False
        else:
            try:
                objWord.ActiveDocument.Unprotect('')
            except:
                wordprotect = True
            else:
                wordprotect = False
        if scriptdebug:
            ##logger.setLevel(Logging.WARNING)
            logger.warning('bitfarm_imaging.py: DOCtoPS: Status nach Kennwortprüfung' + '\n' + 'wordprotect=' + str(wordprotect) + '\n' + str(sys.exc_info()[1]))
            #print '\tbitfarm_imaging.py: DOCtoPS: Status nach Kennwortprüfung' + '\r\n' + 'wordprotect=' + str(wordprotect) + '\r\n' + '\r\n\t' + str(sys.exc_info()[1])
        #   Printdate und Createdate Behandlung
        if not wordprotect:
            #todo: objWord.ActiveDocument.Sections(1).Headers(1).Range.Fields ungültig!
            try:
                for f1 in objWord.ActiveDocument.Sections(1).Headers(1).Range.Fields:
                    if InStr(1, f1.Code, 'PRINTDATE') <> 0 or InStr(1, f1.Code, 'CREATEDATE') <> 0 or InStr(1, f1.Code, 'DATE') <> 0:
                        f1.Unlink()
            except:
                if scriptdebug:
                    ##logger.setLevel(Logging.WARNING)
                    logger.warning('bitfarm_imaging.py: DOCtoPS: Fehler beim Unlink der Header' + '\n' + str(sys.exc_info()[1]))
                    #print '\tbitfarm_imaging.py: DOCtoPS: Fehler beim Unlink der Header' + '\r\n' + '\r\n' + str(sys.exc_info()[1])
            f1 = None
            try:
                for f2 in objWord.ActiveDocument.Sections(1).Footers(1).Range.Fields:
                    if InStr(1, f2.Code, 'PRINTDATE') <> 0 or InStr(1, f2.Code, 'CREATEDATE') <> 0 or InStr(1, f1.Code, 'DATE') <> 0:
                        f2.Unlink()
            except:
                if scriptdebug:
                    ##logger.setLevel(Logging.WARNING)
                    logger.warning('bitfarm_imaging.py: DOCtoPS: Fehler beim Unlink der Footer' + '\n' + str(sys.exc_info()[1]))
                    #print '\tbitfarm_imaging.py: DOCtoPS: Fehler beim Unlink der Footer' + '\r\n' + '\r\n' + str(sys.exc_info()[1])
            f2 = None
            try:
                for f3 in objWord.ActiveDocument.Fields:
                    if InStr(1, f3.Code, 'PRINTDATE') <> 0 or InStr(1, f3.Code, 'CREATEDATE') <> 0 or InStr(1, f1.Code, 'DATE') <> 0:
                        f3.Unlink()
            except:
                if scriptdebug:
                    ##logger.setLevel(Logging.WARNING)
                    logger.warning('bitfarm_imaging.py: DOCtoPS: Fehler beim Unlink des Dokumenteninhaltes' + '\n' + str(sys.exc_info()[1]))
                    #print '\tbitfarm_imaging.py: DOCtoPS: Fehler beim Unlink des Dokumenteninhaltes' + '\r\n' + '\r\n' + str(sys.exc_info()[1])
            f3 = None

            #############################################################################################
            #if handle == 'ASCII':
            #objWord.ActiveDocument.PageSetup.Orientation = 0
            #objWord.ActiveDocument.PageSetup.LeftMargin = 28.4
            #objWord.ActiveDocument.PageSetup.RightMargin = 18.4
            #objWord.ActiveDocument.PageSetup.BottomMargin = 18.4

        #objWord.ActiveDocument.PrintOut
        try:
            wordDoc.PrintOut(False, 0)
        except:
            errortxt = 'bitfarm_imaging.py: DOCtoPS: Fehler bei MS - Office zu TIF Wandlung. Bitte prüfen, ob das Dokument in Office ohne weitere Meldungen gedruckt werden kann, ggf. Änderungen vornehmen und erneut archivieren.' + '\r\n' + '\r\n' + str(sys.exc_info()[1])
            ##logger.setLevel(Logging.WARNING)
            logger.warning(errortxt + '\r\n' + '\t' + str(sys.exc_info()[1]))
            print '\t' + errortxt
            erfolg = False
            wordDoc = None
            objWord = None


    if erfolg:
        time.sleep(0.500)
        if not officeOCR:
            if not os.path.exists(dateiname + '.txt'):
                try:
                    objWord.ActiveDocument.SaveAs(dateiname + '.txt', 2)
                except:
                    errortxt = 'bitfarm_imaging.py: DOCtoPS: Fehler bei MS - Office zu TIF Wandlung. Bitte prüfen, ob das Dokument in Office ohne weitere Meldungen als .txt gespeichert werden kann, ggf. Änderungen vornehmen und erneut archivieren.'
                    ##logger.setLevel(Logging.WARNING)
                    logger.warning(errortxt + '\r\n' + '\t' + str(sys.exc_info()[1]))
                    erfolg = False
                    objWord = None
                    print '\t' + errortxt
            if os.path.exists(dateiname + '.txt'):
                job.ocrtyp = 'TXT'
    if erfolg:
        time.sleep(0.200)
        #objWord.ActiveDocument.Saved = True
        try:
            wordDoc.Saved = True
            time.sleep(0.300)
            #objWord.ActiveDocument.close
            wordDoc.Close()
        except:
            errortxt = 'bitfarm_imaging.py: DOCtoPS: Fehler bei MS - Office zu TIF Wandlung. Bitte prüfen, ob das Dokument in Office ohne weitere Meldungen gedruckt werden kann, ggf. Änderungen vornehmen und erneut archivieren.'
            ##logger.setLevel(Logging.WARNING)
            logger.warning(errortxt + '\r\n' + '\t' + str(sys.exc_info()[1]))
            print '\t' + errortxt
            erfolg = False
            wordDoc = None
            objWord = None

    if erfolg:
        try:
            objWord.Quit()
            wordDoc = None
            objWord = None
        except:
            errortxt = 'bitfarm_imaging.py: DOCtoPS: Fehler bei MS - Office zu TIF Wandlung. Bitte pr?fen, ob das Dokument in Office ohne weitere Meldungen gedruckt werden kann, ggf. ?nderungen vornehmen und erneut archivieren.'
            ##logger.setLevel(Logging.WARNING)
            logger.warning(errortxt + '\r\n' + '\t' + str(sys.exc_info()[1]))
            erfolg = False

    if erfolg:
        if os.path.exists(dateiname + '.ps'):
            os.remove(dateiname + '.ps')
    time.sleep(0.200)
    if erfolg:
        abbruch = False
        k = 0
        while not abbruch:
            if os.path.exists(temp + '\Serviceprinter.ps'):
                time.sleep(0.400)
                try:
                    shutil.copyfile(temp + '\Serviceprinter.ps', dateiname + '.ps')
                except:
                    errortxt = 'bitfarm_imaging.py: DOCtoPS: konnte aus Postscript - Datei nicht kopieren.'
                    ##logger.setLevel(Logging.WARNING)
                    logger.warning(errortxt + '\r\n' + '\t' + str(sys.exc_info()[1]))
                    print '\t' + errortxt
                    erfolg = False
                    abbruch = True
                abbruch = True
            else:
                time.sleep(0.200)
                k = k + 1
                if k > 280:
                    abbruch = True
    if erfolg:
        if os.path.exists(temp + 'Serviceprinter.ps'):
            try:
                os.remove(temp + 'Serviceprinter.ps')
            except:
                #logger.setLevel(Logging.WARNING)
                logger.warning('bitfarm_imaging.py: error removing' + temp + 'Serviceprinter.ps')
        if not os.path.exists(dateiname + '.ps'):
            errortxt = 'bitfarm_imaging.py: DOCtoPS: konnte aus DOC - Datei keine PS - Datei erzeugen.'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt + '\r\n' + " " + str(sys.exc_info()[1]))
            print '\t' + errortxt
            erfolg = False
    if not erfolg:
        handle = 'unbekannt'
        job.ocrtyp = 'TXT'
        OCRHandle = '.tif'
        color = False
    paramsdict["extension"] = tempextension
    paramsdict["erfolg"] = erfolg
    paramsdict["officeOCR"] = officeOCR
    paramsdict["handle"] = handle
    paramsdict["con"] = con
    paramsdict["job"] = job
    print "bitfarm_imaging: DOCtoPS Ende -----------------------------------------------"
    
    return paramsdict

def PPTtoPS(paramsdict, job, con, logger):    
#    if  (isBusy())  and  (rundirect == False) :
        #errortxt = 'bitfarm-Archiv Serverdienst: Kollission mit einer weiteren Instanz entdeckt.'
        ##logger.setLevel(Logging.WARNING)
        #logger.warning(errortxt)
        #print errortxt
        #sys.exit(2)
    print "bitfarm_imaging: PPTtoPS Start ---------------------------------------------"
    dateiname = paramsdict["dateiname"]
    extension = paramsdict["extension"]
    lngReturnCode = ""
    officeOCR = paramsdict["officeOCR"]
    handle = paramsdict["handle"]
    SavePPasList = paramsdict["SavePPasList"]
    
    erfolg = True
    tempextension = extension
    if sys.platform == "win32":
        temp = os.path.join(mypath, 'temp\\')
    else:
        temp = '/tmp/'

    if setServicePrinter():
        erfolg = True
    
    # Excel-Objekt erzeugen
    if erfolg:
        try:
            objPPT = win32com.client.Dispatch("PowerPoint.Application")
        except:
            errortxt = 'bitfarm_imaging.py: PPTtoPS: Kein Powerpoint installiert oder Fehler beim Zugriff.'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print '\t' + errortxt
            erfolg = False
       
    if erfolg:
        if os.path.exists(temp + 'Serviceprinter.ps'):
            try:
                os.remove(temp + 'Serviceprinter.ps')
            except:
                errortxt = 'bitfarm_imaging.py: PPTtoPS: kann Serviceprinter.ps nicht loeschen.'
                #logger.setLevel(Logging.WARNING)
                logger.warning(errortxt)
                print '\t' + errortxt
                erfolg = False
                objPPT = None



    if erfolg:
        attribbits = win32file.GetFileAttributes(dateiname + extension)
        attribbits = (attribbits) & (~1) & (~(8 + 16 + 64 + 128))
        win32file.SetFileAttributes(dateiname + extension, attribbits)
        time.sleep(0.200)
        #lngReturnCode = os.system('"' + os.path.join(programm , 'processmonitor.bat') + '" POWERPOINT')
        time.sleep(0.200)

    if erfolg:
        try:
            oPPTDoc = objPPT.Presentations.Open(dateiname + extension, False, False, False)
        except:
            errortxt = 'bitfarm_imaging.py: PPTtoPS: Fehler bei MS-Office zu TIF Wandlung. Konnte ' + dateiname + extension + 'nicht oeffnen!'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print '\t' + errortxt
            erfolg = False
            objPPT = None

    if erfolg:
        try:
            oPPTDoc.PrintOptions.RangeType = 1
            oPPTDoc.PrintOptions.NumberOfCopies = 1
            if SavePPasList:
                oPPTDoc.PrintOptions.OutputType = 6
            else:
                oPPTDoc.PrintOptions.OutputType = 1
            oPPTDoc.PrintOptions.PrintHiddenSlides = False
            oPPTDoc.PrintOptions.FitToPage = True
            oPPTDoc.PrintOptions.PrintInBackground = True
            oPPTDoc.PrintOptions.ActivePrinter = 'Serviceprinter'
        except:
            errortxt = 'bitfarm_imaging.py: PPTtoPS: Fehler bei MS-Office zu TIF Wandlung. Konnte das Druckoptionen für das Dokument nicht setzen!'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print '\t' + errortxt
            erfolg = False
            objPPT = None

            oPPTDoc = None

    if erfolg:
        try:
            oPPTDoc.PrintOut()
        except:
            errortxt = 'bitfarm_imaging.py: PPTtoPS: Fehler bei MS-Office zu TIF Wandlung. Das Dokument konnte nicht auf Serviceprinter ausgedruckt werden!'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print '\t' + errortxt
            erfolg = False
            objPPT = None

            oPPTDoc = None

        time.sleep(1.1000)
    if erfolg:
        try:
            oPPTDoc.Close()
            oPPTDoc = None
        except:
            errortxt = 'bitfarm_imaging.py: PPTtoPS: Fehler bei MS-Office zu TIF Wandlung. Fehler beim Schliessen des Dokuments!'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print '\t' + errortxt
            erfolg = False
            objPPT = None

    if erfolg:
        try:
            objPPT.Quit()
            objPPT = None
        except:
            errortxt = 'bitfarm_imaging.py: PPTtoPS: Konnte Powerpoint nicht beenden!'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print '\t' + errortxt
            erfolg = False
    if erfolg:
        if os.path.exists(dateiname + '.ps'):
            os.remove(dateiname + '.ps')
    time.sleep(0.200)
    if erfolg:
        abbruch = False
        k = 0
        while abbruch == False:
            if os.path.exists(temp + 'Serviceprinter.ps'):
                #time.sleep(0.400)
                try:
                    shutil.copyfile(temp + 'Serviceprinter.ps', dateiname + '.ps')
                except:
                    errortxt = 'bitfarm_imaging.py: PPTtoPS: konnte Postscript-Datei nicht kopieren.'
                    #logger.setLevel(Logging.WARNING)
                    logger.warning(errortxt)
                    print '\t' + errortxt
                    erfolg = False
                    abbruch = True
                abbruch = True
            else:
                time.sleep(0.200)
                k = k + 1
                if k > 200:
                    abbruch = True
    if erfolg:
        if os.path.exists(temp + 'Serviceprinter.ps'):
            try:
                os.remove(temp + 'Serviceprinter.ps')
            except:
                #logger.setLevel(Logging.WARNING)
                logger.warning('error deleting ' + temp + 'Serviceprinter.ps')

    if erfolg:
        extension = ".tif"
        if not os.path.exists(dateiname + '.ps'):
            errortxt = 'bitfarm_imaging.py: PPTtoPS: konnte aus PPT-Datei keine PS-Datei erzeugen.'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print '\t' + errortxt
            erfolg = False
    if not erfolg:
        handle = 'unbekannt'
        job.ocrtyp = 'TXT'
        OCRHandle = '.tif'
        color = False
    paramsdict["extension"] = extension
    paramsdict["erfolg"] = erfolg
    paramsdict["officeOCR"] = officeOCR
    paramsdict["handle"] = handle
    paramsdict["job"] = job
    paramsdict["con"] = con
    
    print "bitfarm_imaging: PPTtoPS Ende ----------------------------------------------"
    return paramsdict

def XLStoPS(paramsdict, job, con, logger):
    print "bitfarm_imaging: XLStoPS Start ---------------------------------------------"
    
    isBusy          = paramsdict["isBusy"]
    rundirect       = paramsdict["rundirect"]
    dateiname       = paramsdict["dateiname"]
    extension       = paramsdict["extension"]
    color           = paramsdict["color"]
    hires           = paramsdict["hires"]
    officeOCR       = paramsdict["officeOCR"]
    dateiname       = paramsdict["dateiname"]
    
    erfolg          = True    
    
    if sys.platform == "win32":
        temp = os.path.join(mypath, 'temp')
    else:
        temp = ' / tmp / '
    _ret = None

    erfolg = True
    if sys.platform == "win32":
        if setServicePrinter():
            erfolg = True
    
    
    
        # todo: prüfen, ob noch gebraucht wird:
        #if  not rundirect:
        #    if  ( isBusy() )  and  ( rundirect == False ) :
        #    #logger.setLevel(Logging.WARNING)
        #    logger.warning( 'bitfarm - Archiv Serverdienst: Kollission mit einer weiteren Instanz entdeckt.')
        #    print 'bitfarm - Archiv Serverdienst: Kollission mit einer weiteren Instanz entdeckt.'
        #    sys.exit(2)
    if erfolg:
        try:
            objXL = objWord = win32com.client.Dispatch('Excel.Application')
        except:
            errortxt = 'bitfarm_imaging.py: XLStoPS: Kein Excel installiert oder Fehler beim Zugriff.'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print '\t' + errortxt
            erfolg = False
            objXL = None

    if erfolg:
        if os.path.exists(temp + 'Serviceprinter.ps'):
            try:
                os.remove(temp + 'Serviceprinter.ps')
            except:
                errortxt = 'bitfarm_imaging.py: DOCtoPS: kann Serviceprinter.ps nicht loeschen.'
                #logger.setLevel(Logging.WARNING)
                logger.warning(errortxt)
                print '\t' + errortxt
                erfolg = False
                objXL = None

#    if erfolg:
#        lngReturnCode = os.system('"' + os.path.join(programm , 'processmonitor.bat') + '" EXCEL')
#        time.sleep(0.200)

    if erfolg:
        objXL.EnableEvents = False
        #objWb = objXL.WorkBooks.Open(dateiname + extension, UpdateLinks == 0)
        objWb = objXL.WorkBooks.Open(dateiname + extension)
    if erfolg:
        objWb.PrintOut()
    if erfolg:
        time.sleep(0.500)
        try:
            objWb.Saved = True
            time.sleep(0.500)
            objWb.Close()
            objWb = None
        except:
            errortxt = 'bitfarm_imaging.py: XLStoPS: Fehler beim Schliessen der Workbooks.'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print '\t' + errortxt
            erfolg = False
            objXL = None
    if erfolg:
        try:
            objXL.Quit()
            objXL = None
        except:
            errortxt = 'bitfarm_imaging.py: XLStoPS: Fehler beim Schliessen von Excel.'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print '\t' + errortxt
            erfolg = False
    if erfolg:
        if os.path.exists(dateiname + '.ps'):
            os.remove(dateiname + '.ps')
    time.sleep(0.200)
    if erfolg:
        abbruch = False
        k = 0
        while not abbruch:
            spPath = os.path.join(temp , 'Serviceprinter.ps')
            if os.path.exists(spPath):
                time.sleep(0.400)
                try:
                    shutil.copyfile(spPath, dateiname + '.ps')
                except:
                    errortxt = 'bitfarm_imaging.py: XLStoPS: Konnte Postscript-Datei nicht kopieren!'
                    #logger.setLevel(Logging.WARNING)
                    logger.warning(errortxt)
                    GetGarbage(Dateiname)
                    Unlock(lockdatei)
                    print '\t' + errortxt
                    sys.exit(2)
                abbruch = True
            else:
                time.sleep(0.200)
                k = k + 1
                if k > 20:
                    abbruch = True
    if os.path.exists(spPath):
        try:
            os.remove(spPath)
        except:
            #logger.setLevel(Logging.WARNING)
            logger.warning('error removing ' + temp + 'Serviceprinter.ps')
    if erfolg:
        if not os.path.exists(dateiname + '.ps'):
            errortxt = 'bitfarm_imaging.py: XLStoPS: Postscript-Datei nicht vorhanden!'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print '\t' + errortxt
            erfolg = False
    paramsdict["job"] = job
    paramsdict["con"] = con
    paramsdict["erfolg"] = erfolg
    paramsdict["handle"] = 'unbekannt'
    paramsdict["OCRHandle"] = '.tif'
    paramsdict["color"] = False
    #paramsdict["job"] = job
    #paramsdict["con"] = con
    
    print "bitfarm_imaging: XLStoPS Ende ----------------------------------------------"
    return paramsdict

def ODTtoPS(paramsdict, job, con, logger):
    print "bitfarm_imaging: ODTtoPS Start ---------------------------------------------"
    
    erfolg          = True
    dateiname       = paramsdict["dateiname"]
    extension       = paramsdict["extension"]
    color           = paramsdict["color"]
    hires           = paramsdict["hires"]
    officeOCR       = paramsdict["officeOCR"]
    openofficepath  = con.openofficepath

    if sys.platform == "win32":
        temp = os.path.join(mypath, 'temp')
    else:
        temp = ' / tmp / '
    if sys.platform == "win32":
        if not os.path.exists(openofficepath + 'soffice.exe'):
            erfolg = False
            #logger.setLevel(Logging.WARNING)
            logger.warning('bitfarm_imaging: ODTtoPS: OpenOffice nicht korrekt installiert oder Pfad falsch ! ' + '\r\n' + openofficepath)
            print '\tbitfarm_imaging: ODTtoPS: OpenOffice nicht korrekt installiert oder Pfad falsch ! ' + '\r\n' + openofficepath
        if setServicePrinter():
            erfolg = True
        
        # todo: prüfen, ob noch gebraucht wird:
        #if  not rundirect:
        #    if  ( isBusy() )  and  ( rundirect == False ) :
        #    #logger.setLevel(Logging.WARNING)
        #    logger.warning( 'bitfarm - Archiv Serverdienst: Kollission mit einer weiteren Instanz entdeckt.')
        #    print 'bitfarm - Archiv Serverdienst: Kollission mit einer weiteren Instanz entdeckt.'
        #    sys.exit(2)

    pfilename = os.path.join(temp, 'Serviceprinter.ps')
    if os.path.exists(pfilename):
        try:
            os.remove(pfilename)
        except:
            errortxt = 'bitfarm_imaging: ODTtoPS: kann Serviceprinter.ps nicht löschen.'
            print '\t' + errortxt
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            erfolg = False
            rcArr["returnCode"]= 1
            return rcArr
            objWord = None
    Beginn = time.time()

    if sys.platform == 'win32':
        if extension == '.htm' or extension == '.dbf':
            rcArr = runOoMacro(openofficepath, dateiname, extension, "Bitfarm.bitfarm.drucken", logger)
        elif extension == '.ppt' or extension == '.pps' or extension == '.pptx':
            rcArr = runOoMacro(openofficepath, dateiname, extension, "Bitfarm.bitfarm.SpeichernAlsTIF", logger)
        else:
            rcArr = runOoMacro(openofficepath, dateiname, extension, "Bitfarm.bitfarm.drucken", logger)

    if (rcArr["returnCode"] == 0):
        durch = True
    else:
        durch = False
    if durch:
        erfolg = True

        if extension == '.ppt' or extension == '.pps':
            if os.path.exists(dateiname + '.tif'):
                erfolg = True
                if hires:
                    if color:
                        lngReturnCode = RunFilter(dateiname + '.tif', programm + 'TIFF - 300.txt', dateiname + ' - archiv.tif')
                    else:
                        lngReturnCode = RunFilter(dateiname + '.tif', programm + 'TIFF - 300 - bw.txt', dateiname + ' - archiv.tif')
                else:
                    if color:
                        lngReturnCode = RunFilter(dateiname + '.tif', programm + 'TIFF - 200.txt', dateiname + ' - archiv.tif')
                    else:
                        lngReturnCode = RunFilter(dateiname + '.tif', programm + 'TIFF - 200 - bw.txt', dateiname + ' - archiv.tif')
                if lngReturnCode <> 0:
                    errortxt = 'bitfarm_imaging: ODTtoPS: Fehler beim Filtern des Archivtifs. Bitte Filterdateien überprüfen'
                    print '\t' + errortxt
                    #logger.setLevel(Logging.WARNING)
                    logger.warning(errortxt)
                    archivtif = dateiname
                else:
                    archivtif = dateiname + ' - archiv'
            else:
                #logger.setLevel(Logging.WARNING)
                logger.warning('bitfarm_imaging: ODTtoPS: Fehler bei .ppt zu Tif - Wandlung, Datei nicht erstellt')
                print '\tbitfarm_imaging: ODTtoPS: Fehler bei .ppt zu Tif - Wandlung, Datei nicht erstellt'
                erfolg = False
                rcArr["returnCode"] = 1
            
            # todo: prüfen, warum pdf gelöscht werden muss
            if os.path.exists(dateiname + '.pdf'):
                try:
                    os.remove(dateiname + '.pdf')
                except:
                    #logger.setLevel(Logging.WARNING)
                    logger.warning('error deleting ' + dateiname + '.pdf')
    else:
        print '\tbitfarm_imaging: ODTtoPS: Konnte OpenOfficeDokument nicht auf PS - Drucker ausgeben' + '\r\n' + 'evtl Timeout oder nicht vorhanden' + '\r\n' + 'Versuche:' + str(rcArr["Versuche"])
        erfolg = False
        #logger.setLevel(Logging.WARNING)
        logger.warning('bitfarm_imaging: ODTtoPS: Konnte OpenOfficeDokument nicht auf PS - Drucker ausgeben' + '\r\n' + 'evtl Timeout oder nicht vorhanden' + '\r\n' + 'Versuche:' + str(rcArr["Versuche"]))
        rcArr["returnCode"] = 1
        
    if (sys.platform == "win32"):
        pfilename = os.path.join(temp , 'Serviceprinter.ps')
    else:
        llastfile = GetLastFile(temp, 'Serviceprinter.ps - ' + os.path.split(dateiname)[1] + '. * ' + os.environ['USER'])
        if llastfile <> None:
            pfilename = os.path.join(temp, llastfile)
        else:
             pfilename = os.path.join(temp, 'Serviceprinter.ps - ' + os.path.split(dateiname)[1] + '. * ' + os.environ['USER'])
   
    #todo: prüfen, warum hier text extrahiert wird. Auslagern? hier nur imaging
    if officeOCR == False:
        # todo: prüfen: Office 2010 Formate auch?
        if  (extension == '.ods')  or  (extension == '.odt')  or  (extension == '.htm')  or  (extension == '.rtf')  or  (extension == '.doc')  or  (extension == '.xls')  or  (extension == '.dbf') :
            if not os.path.exists(dateiname + '.txt'):
                if extension == '.odt' or extension == '.htm' or extension == '.rtf' or extension == '.doc':
                    rc = runOoMacro(openofficepath, dateiname, extension, "Bitfarm.bitfarm.SpeichernAlsTXT", logger)
                if  (extension == '.ods')   or  (extension == '.xls')  or  (extension == '.dbf'):
                    if sys.platform == "win32":
                        rc = runOoMacro(openofficepath, dateiname, extension, "Bitfarm.bitfarm.SpeichernAlsCSV", logger)
                    else:
                        os.system(os.path.join(openofficepath , 'soffice') + ' - norestore - invisible macro: /// Bitfarm.bitfarm.SpeichernAlsCSV\(' + dateiname + extension + '\)')
                    if os.path.exists(dateiname + '.txt'):
                        rcArr["Typ"] = 'TXT'
    # todo: warum Ausnahme für ppt? Weil kein ps, sonder tif per OO-Makro?
    # warum tif per Makro nur bei ppt?
    if extension <> '.ppt' and extension <> '.pps':
        if erfolg:
            abbruch = False
            k = 0
            while abbruch == False:
                if os.path.exists(pfilename):

                    schleife = 0
                    lcpsuc = False
                    while (not lcpsuc)  and (schleife < 5000):
                        schleife = schleife + 1
                        time.sleep(0.01)
                        try:
                            shutil.copyfile(pfilename, dateiname + '.ps')
                            lcpsuc = True
                        except:
                            errortxt = 'bitfarm_imaging: ODTtoPS: konnte aus Postscript - Datei nicht kopieren. ' + str(sys.exc_info()[0]) + ' ' + str(sys.exc_info()[1]) + ' ' + pfilename + ' ' + dateiname + '.ps'
                            lcpsuc = False
                    if schleife == 50:
                            #logger.setLevel(Logging.WARNING)
                            logger.warning(errortxt + ' Schleife ' + str(schleife))
                            print '\t' + errortxt
                            erfolg = False
                            abbruch = True
                    abbruch = True
                else:
                    k = k + 1
                    if k > 280:
                        abbruch = True
        if os.path.exists(pfilename):
            try:
                os.remove(pfilename)
            except:
                    #logger.setLevel(Logging.WARNING)
                    logger.warning('error deleting ' + pfilename)
        if not os.path.exists(dateiname + '.ps'):
            errortxt = 'bitfarm_imaging: ODTtoPS: konnte aus OpenOffice - Datei keine PS - Datei erzeugen.'
            print '\t' + errortxt
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            erfolg = False
            rcArr["returnCode"]=1
            
    paramsdict["erfolg"] = erfolg
    paramsdict["extension"] = extension
    paramsdict["color"] = color
    paramsdict["hires"] = hires
    paramsdict["officeOCR"] = officeOCR
    paramsdict["job"] = job
    paramsdict["con"] = con

    
    print "bitfarm_imaging: ODTtoPS Ende ----------------------------------------------"
    return paramsdict


#------------------ bis hier 
def PStoPDF(dateiname):
    print "bitfarm_imaging: PStoPDF Start ---------------------------------------------"
    global lngReturnCode, errortxt, handle, batext, programm, programmbin, lockdatei, OCRHandle, color, extension
     
    _ret = None
          
    if  (isBusy())  and  (rundirect == False) :
        errortxt = 'bitfarm_imaging: PStoPDF: Kollission mit einer weiteren Instanz entdeckt.'
        #logger.setLevel(Logging.WARNING)
        logger.warning(errortxt)
        print '\t' + errortxt
        sys.exit(2)

    lngReturnCode = os.system('"' + os.path.join(programm , 'makepdf.bat') + '" @' + os.path.join(programm , 'pdf.rsp') + ' ' + dateiname + '.pdf ' + dateiname + '.ps')
    if lngReturnCode <> 0:
        errortxt = 'bitfarm_imaging: PStoPDF: Fehler bei makepdf.'
        #logger.setLevel(Logging.WARNING)
        logger.warning(errortxt)
        print '\t' + errortxt
        GetGarbage(dateiname)
        Unlock(lockdatei)
        sys.exit(2)
    extension = '.pdf'
    handle = 'pdf'
    print "bitfarm_imaging: PStoPDF Ende ----------------------------------------------"
    return _ret



def ASCtoTIF(dateiname, ini, job):
    print "bitfarm_imaging: ASCtoTIF Start ---------------------------------------------"
    #print ini
    javapath = str(ini["javapath"])
    foppath = str(ini["foppath"])
    global lngReturnCode, errortxt
    _ret = None
    asc = os.stat(dateiname + '.asc')
    ascsize = asc.st_size 
    #ascsize = fs.getfile(dateiname + '.asc')
    if ascsize == 0:
        errortxt = 'bitfarm_imaging: ASCtoTIF: Datei 0 Byte -> Garbage'
        #logger.setLevel(Logging.WARNING)
        logger.warning(errortxt)
        print '\t' + errortxt
        GetGarbage(dateiname)
        Unlock(lockdatei)
        sys.exit(2)
    ascsize = None
    if scriptdebug:
        #logger.setLevel(Logging.ERROR)
        logger.warning('bitfarm_imaging: ASCtoTIF: ' + javapath + '\r\n' + 'Foppath: ' + foppath)

    erfolg = True
    job.ocrtyp = 'TXT'
    if not os.path.exists(dateiname + '.txt'):
        shutil.copyfile(dateiname + '.asc', dateiname + '.txt')
    fopexists = False
    if javapath == '':
        #logger.setLevel(Logging.WARNING)
        logger.warning('bitfarm_imaging: ASCtoTIF: Es wurde kein Pfad fuer das JRE in der Scripts.ini uebergeben')
        if foppath == '':
            #logger.setLevel(Logging.WARNING)
            logger.warning('bitfarm_imaging: ASCtoTIF: Es wurde kein Pfad fuer das fop-Modul in der Scripts.ini uebergeben')
    else:
        if foppath == '':
            #logger.setLevel(Logging.WARNING)
            logger.warning('bitfarm_imaging: ASCtoTIF: Es wurde kein Pfad fuer das fop-Modul in der Scripts.ini uebergeben')
        else:
            if os.path.exists(javapath):
                if os.path.exists(foppath):
                    fopexists = True
                else:
                    #logger.setLevel(Logging.WARNING)
                    logger.warning('bitfarm_imaging: ASCtoTIF: fop-Modul nicht im angegebenen Pfad gefunden:' + '\r\n' + foppath)
            else:
                    #logger.setLevel(Logging.WARNING)
                    logger.warning('bitfarm_imaging: ASCtoTIF: Java-Runtime nicht im angegebenen Pfad gefunden:' + '\r\n' + javapath)
    if fopexists:
        lngReturnCode = os.system('"' + os.path.join(programmbin , 'ASC2FO.py') + '" ' + foppath + ' ' + dateiname + '.asc')
        ascmodul = 'ASC2FO'
    else:
        lngReturnCode = os.system('python "' + os.path.join(programmbin , 'ASC2HTML.py') + '" ' + dateiname + '.asc')
        ascmodul = 'ASC2HTML'
    if lngReturnCode <> 0:
        errortxt = 'bitfarm_imaging: ASCtoTIF: Fehler bei ASC2TIF. Verwendetes Modul: ' + ascmodul
        #logger.setLevel(Logging.WARNING)
        logger.warning(errortxt)
        print '\t' + errortxt
        erfolg = False
    time.sleep(0.20)
    if fopexists :
        durchlauf = 0
        abbruch = False
        while abbruch == False:
            if not os.path.exists(dateiname + '.pdf'):
                time.sleep(0.100)
                durchlauf = durchlauf + 1
            else:
                abbruch = True
            if durchlauf == 30:
                abbruch = True
        if scriptdebug:
            #logger.setLevel(Logging.WARNING)
            logger.warning(dateiname + '.pdf vorhanden. Durchlauf: ' + str(durchlauf))
        
        #muss nicht nach color / nicht color unterschieden werden, wird innerhalb von pdftotiff erledigt (über paramsdict["color"])
        #if color == False:
        paramsdict = {"dateiname": dateiname, "checkexistingdocpreview":checkexistingdocpreview, "CustomPDFtoTIFFConverter":CustomPDFtoTIFFConverter, "officeOCR":officeOCR, "color":color, "hires":hires}
        paramsdict = PDFtoTIF(paramsdict, job, con, logger)
        extension= paramsdict["extension"]
        OCRHandle = paramsdict["OCRHandle"]
        Filtermakro = paramsdict["Filtermakro"] 
        #else:
        #    PDFtoColorTIF(dateiname)
        if os.path.exists(dateiname + '.fo'):
            os.remove(dateiname + '.fo')
    else:
        einer = 8
        zehner = 9
        hunderter = 9
        abbruch = False
        oldzaehler = '999'
        newzaehler = '998'
        while abbruch == False:
            if os.path.exists(dateiname + '_' + str(hunderter) + str(zehner) + str(einer) + '.html'):
                print ("\tbitfarm_imaging: ASCtoTIF: Hurra:" + str(hunderter) + str(zehner) + str(einer) + ".html")
                extension = '.html'
                DOCtoPS(dateiname + '_' + str(hunderter) + str(zehner) + str(einer))
                os.remove(dateiname + '_' + str(hunderter) + str(zehner) + str(einer) + '.html')
                os.remove(dateiname + '_' + str(hunderter) + str(zehner) + str(einer) + '.txt')
                print ("bitfarm_imaging: ASCtoTIF: zwischenbericht")
                PStoNonOCRTIF(dateiname + '_' + str(hunderter) + str(zehner) + str(einer))
                os.remove(dateiname + '_' + str(hunderter) + str(zehner) + str(einer) + '.ps')
                if  (os.path.exists(dateiname + '_' + oldzaehler + '.tif'))  and  (os.path.exists(dateiname + '_' + newzaehler + '.tif')) :
                    lngReturnCode = os.system('"' + os.path.join(programm , 'splitterv3.exe') + '" -m ' + dateiname + '_' + oldzaehler + '.tif ' + dateiname + '_' + newzaehler + '.tif')
                    time.sleep(0.30)
                    if lngreturncode == 0:
                        os.remove(dateiname + '_' + newzaehler + '.tif')
                        shutil.copyfile(dateiname + '_' + oldzaehler + '.tif', dateiname + '_' + newzaehler + '.tif')
                        os.remove(dateiname + '_' + oldzaehler + '.tif')
                    else:
                        errortxt = 'bitfarm_imaging: ASCtoTIF: Fehler beim mergen der Seiten bei ASCtoTIF'
                        #logger.setLevel(Logging.WARNING)
                        logger.warning(errortxt)
                        print '\t' + errortxt
                        GetGarbage(dateiname)
                        Unlock(lockdatei)
                        sys.exit(2)
            if  (hunderter == 0)  and  (zehner == 0)  and  (einer == 1) :
                abbruch = True
            if abbruch == False:
                oldzaehler = newzaehler
                if einer > 0:
                    einer = einer - 1
                else:
                    if zehner > 0:
                        zehner = zehner - 1
                        einer = 9
                    else:
                        if hunderter > 0:
                            hunderter = hunderter - 1
                            zehner = 9
                            einer = 9
                        else:
                            hunderter = 0
                            zehner = 0
                            einer = 0
                newzaehler = hunderter + zehner + einer
        if os.path.exists(dateiname + '_001.tif'):
            shutil.copyfile(dateiname + '_001.tif', dateiname + '.tif')
            os.remove(dateiname + '_001.tif')
    if scriptdebug:
        #logger.setLevel(Logging.WARNING)
        logger.warning('bitfarm_imaging: ASCtoTIF: die Asc2Tif- Wandlung erfolgte mit :' + '\r\n' + ascmodul)
    extension = '.asc'
    print "bitfarm_imaging: ASCtoTIF Ende ----------------------------------------------"
    return _ret

def PLTtoTIF(dateiname):
    print "bitfarm_imaging: PLTtoTIF Start ---------------------------------------------"
    global lngReturnCode, errortxt
    _ret = None
    erfolg = True
    job.ocrtyp = 'TXT'
    lngReturnCode = os.system('"' + os.path.join(programm , 'PLTtoTIF.bat') + '" ' + dateiname + '.plt ' + dateiname + '-temp.tif')
    if lngReturnCode <> 0:
        errortxt = 'bitfarm_imaging: ASCtoTIF: Fehler bei PLTCONVERT.'
        #logger.setLevel(Logging.WARNING)
        logger.warning(errortxt)
        print '\t' + errortxt
        erfolg = False
    time.sleep(0.100)
    if not os.path.exists(dateiname + '-temp.tif'):
        errortxt = 'bitfarm_imaging: ASCtoTIF: Fehler bei PLTtoTIF: keine TIF-Datei erzeugt. M?glicherweise zu wenig freier Festplattenspeicher.'
        #logger.setLevel(Logging.WARNING)
        logger.warning(errortxt)
        print '\t' + errortxt
        erfolg = False
    if erfolg:
        lngReturnCode = RunFilter(dateiname + '-temp.tif', os.path.join(programm , 'tiff-SW.txt'), dateiname + '.tif')
        if lngReturnCode <> 0:
            errortxt = 'bitfarm_imaging: ASCtoTIF: Fehler bei Filtern nach Ghostscript(Color).'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print '\t' + errortxt
            GetGarbage(dateiname)
            Unlock(lockdatei)
            sys.exit(2)
        time.sleep(0.200)
        os.remove(dateiname + '-temp.tif')
        if not os.path.exists(dateiname + '.tif'):
            errortxt = 'bitfarm_imaging: ASCtoTIF: Fehler beim Filtern: keine TIF-Datei erzeugt. M?glicherweise zu wenig freier Festplattenspeicher oder Datei defekt.'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print '\t' + errortxt
            GetGarbage(dateiname)
            Unlock(lockdatei)
            sys.exit(2)
    if erfolg == False:
        handle = 'unbekannt'
        job.ocrtyp = 'TXT'
        OCRHandle = '.tif'
        color = False
    print "bitfarm_imaging: PLTtoTIF Ende ----------------------------------------------"
    return _ret

def DWGtoTIF(paramsdict, job, con, logger):
    print "bitfarm_imaging: DWGtoTIF Start ---------------------------------------------"
    erfolg          = True
    dateiname       = paramsdict["dateiname"]
    extension       = paramsdict["extension"]
    color           = paramsdict["color"]
    hires           = paramsdict["hires"]
    officeOCR       = paramsdict["officeOCR"]
    openofficepath  = con.openofficepath
    
    if (color==False):
        Filter1="\\tiff-300.rsp "
        Filter2="\\tiff-400.rsp "
        bat = "DWGtoPDF.bat"
    else:
        Filter1="\\tiff-300-color.rsp "
        Filter2="\\tiff-400-color.rsp "
        bat = "DWGtoColorPDF.bat"

#    if  (isBusy())  and  (rundirect == False) :

#        #logger.setLevel(Logging.WARNING)
#        logger.warning('bitfarm-Archiv Serverdienst: Kollission mit einer weiteren Instanz entdeckt.')
#        print errortxt
#        sys.exit(2)
    if os.path.exists(dateiname + '.pdf'):
        os.remove(dateiname + '.pdf')
        time.sleep(0.300)
    lngReturnCode = os.system('"' + os.path.join(programm , bat) + '" ' + dateiname + '.pdf ' + dateiname + extension)
    if lngReturnCode <> 0:
        errortxt = 'bitfarm_imaging: DWGtoTIF: Fehler bei AutoCAD-Konvertierung mit ' + bat
        #logger.setLevel(Logging.WARNING)
        logger.warning(errortxt)
        print '\t' + errortxt
        erfolg = False
    if erfolg:
        a = 0
        while (os.path.exists(dateiname + '.pdf') == False)  and  (a < 120):
            time.sleep(0.1000)
            a = a + 1
        if a > 119:
            errortxt = 'bitfarm_imaging: DWGtoTIF: Fehler bei AutoCAD-Konvertierung - Timeout.'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print '\t' + errortxt
            erfolg = False

            objWMIService = GetObject('winmgmts:\\\\.\\root\\cimv2')
            strQuery = "Select * from Win32_Process where Name='AcmeCADConverter.exe'"
            colItems = objWMIService.ExecQuery(strQuery)
            for objItem in colItems:
                objItem.Terminate
            objItem = None
            colItems = None
            objWMIService = None
        time.sleep(0.1000)
    if erfolg:
        lngReturnCode = os.system('"' + os.path.join(programm , 'ghostscript.bat') + '" @' + programm + '\\tiff-600.rsp ' + dateiname + '.tif ' + dateiname + '.pdf')
        if lngReturnCode <> 0:

            errortxt = 'bitfarm_imaging: DWGtoTIF: Fehler bei Ghostscript.'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print '\t' + errortxt
            GetGarbage(dateiname)
            Unlock(lockdatei)
            sys.exit(2)
        if not os.path.exists(dateiname + '.tif'):

            errortxt = 'bitfarm_imaging: DWGtoTIF: Fehler bei Ghostscript: keine TIF-Datei erzeugt. M?glicherweise zu wenig freier Festplattenspeicher.'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print '\t' + errortxt
            GetGarbage(dateiname)
            Unlock(lockdatei)
            sys.exit(2)
        if hires == False:
            lngReturnCode = os.system('"' + os.path.join(programm , 'ghostscript.bat') + '" @' + programm + Filter1 + dateiname + '-archiv.tif ' + dateiname + '.pdf')
        else:
            lngReturnCode = os.system('"' + os.path.join(programm , 'ghostscript.bat') + '" @' + programm + Filter2 + dateiname + '-archiv.tif ' + dateiname + '.pdf')
        if lngReturnCode <> 0:

            errortxt = 'bitfarm_imaging: DWGtoTIF: Fehler bei Ghostscript.'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print '\t' + errortxt
            GetGarbage(dateiname)
            Unlock(lockdatei)
            sys.exit(2)
        archivtif = dateiname + '-archiv'
        if not os.path.exists(dateiname + '-archiv.tif'):

            errortxt = 'bitfarm_imaging: DWGtoTIF: Fehler bei Filter: keine Archiv-TIF-Datei erzeugt. M?glicherweise zu wenig freier Festplattenspeicher.' + '\r\n' + 'Setze auf Standard-tif zur?ck' + '\r\n' + dateiname + '.tif'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print '\t' + errortxt
            archivtif = dateiname
            if not os.path.exists(dateiname + '.tif'):

                errortxt = 'bitfarm_imaging: DWGtoTIF: Fehler bei Filter: keine TIF-Datei erzeugt. M?glicherweise zu wenig freier Festplattenspeicher.' + '\r\n' + dateiname + '.tif'
                #logger.setLevel(Logging.WARNING)
                logger.warning(errortxt)
                print '\t' + errortxt
                GetGarbage(dateiname)
                Unlock(lockdatei)
                sys.exit(2)
    if erfolg == False:
        handle = 'unbekannt'
        job.ocrtyp = 'TXT'
        OCRHandle = '.tif'
        color = False
    paramsdict["erfolg"] = erfolg
    paramsdict["extension"] = extension
    paramsdict["color"] = color
    paramsdict["hires"] = hires
    paramsdict["officeOCR"] = officeOCR
    paramsdict["job"] = job
    paramsdict["con"] = con
    print "bitfarm_imaging: DWGtoTIF Ende ----------------------------------------------"
    return paramsdict

def AKTtoPS(dateiname):
    print "bitfarm_imaging: AKTtoPS Start ----------------------------------------------"
    global lngReturnCode, errortxt
    _ret = None

    erfolg = True
    tempextension = extension
    try:
        wshnet = CreateObject('WScript.Network')
    except:
        errortxt = 'bitfarm_imaging: AKTtoPS: Entweder Serviceprinter nicht installiert oder Scripting Host Version zu alt.'
        #logger.setLevel(Logging.WARNING)
        logger.warning(errortxt)
        print '\t' + errortxt
        erfolg = False
    if erfolg:
        try:
            wshnet.SetDefaultPrinter('Serviceprinter')
        except:
            errortxt = 'bitfarm_imaging: AKTtoPS: Kann keinen Standarddrucker festlegen. Entweder Serviceprinter nicht installiert oder Scripting Host Version zu alt.'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print '\t' + errortxt
            erfolg = False
        wshnet = None
    if  (isBusy())  and  (rundirect == False) :
        #logger.setLevel(Logging.WARNING)
        logger.warning('bitfarm_imaging: AKTtoPS: Kollission mit einer weiteren Instanz entdeckt.')
        sys.exit(2)
    if erfolg:
        if os.path.exists(os.path.join(temp , 'Serviceprinter.ps')):
            try:
                os.remove(os.path.join(temp , 'Serviceprinter.ps'))
            except:
                errortxt = 'bitfarm_imaging: AKTtoPS: kann Serviceprinter.ps nicht loeschen.'
                #logger.setLevel(Logging.WARNING)
                logger.warning(errortxt)
                print '\t' + errortxt
                erfolg = False
    if not os.path.exists(os.path.join(programm , 'ISBconvert.bat')):
        erfolg = False
        errortxt = 'bitfarm_imaging: AKTtoPS: Fehler: isbconvert.bat nicht vorhanden.'
        #logger.setLevel(Logging.WARNING)
        logger.warning(errortxt)
        print '\t' + errortxt
    if erfolg:
        time.sleep(0.20)
        lngReturnCode = os.system('"' + os.path.join(programm , 'isbconvert.bat') + '" ' + dateiname + '.akt')
        time.sleep(0.200)
        if lngReturnCode <> 0:
            errortxt = 'bitfarm_imaging: AKTtoPS: Fehler bei AKT-CAD-Konvertierungmit isbconvert.bat.'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print '\t' + errortxt
            erfolg = False
    if erfolg:
        if os.path.exists(dateiname + '.ps'):
            os.remove(dateiname + '.ps')
    time.sleep(0.200)
    if erfolg:
        abbruch = False
        k = 0
        while abbruch == False:
            if os.path.exists(os.path.join(temp , 'Serviceprinter.ps')):
                time.sleep(0.400)
                try:
                    shutil.copyfile(os.path.join(temp , 'Serviceprinter.ps'), dateiname + '.ps')
                except:
                    errortxt = 'bitfarm_imaging: AKTtoPS: konnte aus Postscript-Datei nicht kopieren.'
                    #logger.setLevel(Logging.WARNING)
                    logger.warning(errortxt)
                    print '\t' + errortxt
                    erfolg = False
                    abbruch = True
                abbruch = True
            else:
                time.sleep(0.200)
                k = k + 1
                if k > 280:
                    abbruch = True
    if erfolg:
        if os.path.exists(os.path.join(temp , 'Serviceprinter.ps')):
            try:
                os.remove(os.path.join(temp , 'Serviceprinter.ps'))
            except:
                #logger.setLevel(Logging.WARNING)
                logger.warning('error deleting ' + temp + 'Serviceprinter.ps')
        if not os.path.exists(dateiname + '.ps'):
            errortxt = 'bitfarm_imaging: AKTtoPS: konnte aus AKT-Datei keine PS-Datei erzeugen.'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print '\t' + errortxt
            erfolg = False
    if erfolg == False:
        handle = 'unbekannt'
        job.ocrtyp = 'TXT'
        OCRHandle = '.tif'
        #todo: why that?
        #color = True
    extension = tempextension
    print "bitfarm_imaging: AKTtoPS Start ----------------------------------------------"
    return _ret





def runOoMacro(openofficepath, dateiname, extension, macro, logger):
    print "bitfarm_imaging: runOoMacro Start -------------------------------------------"
    rcArr = {}
    if sys.platform == "win32":
        lsparam = os.path.join(openofficepath , 'soffice.exe') + ' -invisible -nocrashreport -norestore macro:///'+macro+'(' + dateiname + extension + ')'     
        #print 'runOoMacro: ' + lsparam
        pipe = subprocess.Popen(lsparam, stdout=subprocess.PIPE)
        pipe.poll()
        schleife = 0
        while (pipe.returncode == None) and (schleife < 5000):
            pipe.poll()
            time.sleep(0.001)
            schleife = schleife + 1
            
        if pipe.returncode <> 0:
            #logger.setLevel(Logging.WARNING)
            logger.warning(u'bitfarm_imaging: runOoMacro: Fehler beim Ausführen des Makros (' + macro + ') - Timeout')
       
        if scriptdebug:
            #logger.setLevel(Logging.WARNING)
            logger.warning('Versuche:' + str(schleife))
        
        rcArr["Versuche"] = schleife
        rcArr["returnCode"] = pipe.returncode
        
        objWMIService = GetObject('winmgmts:\\\\.\\root\\cimv2')
        strQuery = "Select * from Win32_Process where Name='soffice.bin'"
        colItems = objWMIService.ExecQuery(strQuery)
        z = 0
        for objItem in colItems:
            objItem.Terminate
            z = z + 1
        if z > 0:
            #logger.setLevel(Logging.ERROR)
            logger.warning('bitfarm_imaging: runOoMacro: Terminierte soffice.bin - Instanzen: ' + str(z))
        
        
        objItem = None
        colItems = None
        objWMIService = None
        objWMIService = GetObject('winmgmts:\\\\.\\root\\cimv2')
        strQuery = "Select * from Win32_Process where Name='soffice.exe'"
        colItems = objWMIService.ExecQuery(strQuery)
       
        z = 0
        for objItem in colItems:
            objItem.Terminate
            z = z + 1
        if z > 0:
            #logger.setLevel(Logging.ERROR)
            logger.warning('bitfarm_imaging: runOoMacro: Terminierte soffice.exe - Instanzen: ' + str(z))
        objItem = None
        colItems = None
        objWMIService = None
    else:
        os.system(os.path.join(openofficepath , 'soffice') + ' - norestore - invisible "macro:///'+macro+'(' + dateiname + extension + ')"')
    print "bitfarm_imaging: runOoMacro Ende --------------------------------------------"
    return rcArr

def RunFilter(param1, param2, param3):
    print "bitfarm_imaging: RunFilter Start --------------------------------------------"
    global programm, lockdatei, tempname
    _ret = None
    beginn = time.time()
    tempname = os.path.splitext(param3)[0]

    if not os.path.exists(param2):
        #Filterdatei nicht vorhanden
        #logger.setLevel(Logging.WARNING)
        logger.warning('bitfarm_imaging: RunFilter: Filterdatei nicht vorhanden:' + param2)
        _ret = 4
        abbruch = True
    else:
        _ret = 0
        if sys.platform == 'win32':
            Filterrun = os.system('"' + os.path.join(programm , 'filterv3.bat') + '" ' + param1 + ' ' + param2 + ' ' + param3)
        else:
            Filterrun = os.system('wine "' + os.path.join(programm , 'FilterV3.exe') + '" ' + param1 + ' ' + param2 + ' ' + param3)

        ende1 = time.time()
        if scriptdebug:
            print  "\tZeit1 = " + str(ende1 - beginn)
        #******************************** auf Ergebnis warten ****************************
        time.sleep(0.3000)
        abbruch = False
        #    If testfilter = False Then                ' FilterV3 schon terminiert
        #        abbruch = True
        #    End If
        #
    a = 0
    wartezeit = 100
    while abbruch == False:
        if checkfilter(tempname) == 0:
            abbruch = True
        if abbruch == False:
            zaehler3 = 0
            zaehler2 = 0
            abbruch2 = False
            time.sleep(1.000)
            while abbruch2 == False:
                mycheck = 0
                mycheck = checkfilter(tempname)
                if mycheck == 3:
                    zaehler3 = zaehler3 + 1
                if mycheck == 2:
                    zaehler2 = zaehler2 + 1
                    if zaehler3 > 0:
                        zaehler2 = zaehler2 + zaehler3
                        zaehler3 = 0
                if mycheck == 1:
                    abbruch2 = True
                if mycheck == 0:
                    abbruch = True
                    abbruch2 = True
                if zaehler3 > 10:
                    abbruch2 = True
                    abbruch = True
                    a = wartezeit
                    _ret = 3
                if zaehler2 > 35:
                    abbruch2 = True
                    abbruch = True
                    a = wartezeit
                    _ret = 2
                if abbruch2 == False:
                    time.sleep(0.1500)
        if abbruch == False:
            time.sleep(0.1000)
        a = a + 1
        if a >= wartezeit:
            abbruch = True
    time.sleep(0.50)
    #if not os.path.exists(lockdatei):
    #   #logger.setLevel(Logging.ERROR)
    #   logger.warning( 'archivierung: Filter-Prozess von Dienstkontrolle terminiert.')
    #   sys.exit(2)

    if sys.platform == 'win32':
        objWMIService = GetObject('winmgmts:\\\\.\\root\\cimv2')
        strQuery = "Select * from Win32_Process where Name='filterV3'"
        colItems = objWMIService.ExecQuery(strQuery)
        dir(colItems)
        z = 0
        for objItem in colItems:
            print objItem
            objItem.Terminate
            z = z + 1
        if z > 0:
                #logger.setLevel(Logging.ERROR)
                logger.warning('bitfarm-Archiv: Archivierung: Filter-Prozess terminiert bei ' + tempname)
        colItems = None
        objWMIService = None
    else:
        os.system("killall -9 FilterV3.exe")
    ende2 = time.time()
    print "bitfarm_imaging: RunFilter Ende ---------------------------------------------"
    return _ret

def checkfilter(tempname):
    print "bitfarm_imaging: checkfilter Start ------------------------------------------"
    global scriptdebug
    _ret = None
    _ret = 0
    if scriptdebug:
        mydebugfile = open(tempname + '.log', 'w')
    time.sleep(0.50)
    oldtestcounter1 = 0
    oldtestcounter2 = 0
    oldtestcounter3 = 0
    oldtestcounter4 = 0
    oldtestcounter5 = 0
    oldtestcounter6 = 0
    oldtestcounter7 = 0
    newtestcounter1 = 0
    newtestcounter2 = 0
    newtestcounter3 = 0
    newtestcounter4 = 0
    newtestcounter5 = 0
    newtestcounter6 = 0
    newtestcounter7 = 0
    if sys.platform == 'win32':
        strComputer = '.'
        objWMIService = None
        strQuery = "SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name ='FilterV3'"
        objWMIService = GetObject('winmgmts:\\\\.\\root\\cimv2')
        
        #strQuery = "SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'filterV3'"
        time.sleep(0.50)
        colProcesses = objWMIService.ExecQuery(strQuery)
        #print dir(colProcesses)
        time.sleep(0.50)
        kette = ''
        for strProcess in colProcesses:
            #print strProcess.olerepr.__dict__
            
            oldtestcounter1 = int(strProcess.IOReadBytesPerSec)          
            oldtestcounter2 = int(strProcess.IOReadOperationsPerSec)
            oldtestcounter3 = int(strProcess.IOWriteBytesPerSec)
            oldtestcounter4 = int(strProcess.IOWriteOperationsPerSec)
            oldtestcounter5 = int(strProcess.IOOtherBytesPerSec)
            oldtestcounter6 = int(strProcess.IOOtherOperationsPerSec)
            oldtestcounter7 = int(strProcess.PercentProcessorTime)
        colProcess = None
        objWMIService = None
        time.sleep(0.2000)
        strComputer = '.'

        objWMIService = None
        strQuery = "SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name ='FilterV3'"
        objWMIService = GetObject('winmgmts:\\\\.\\root\\cimv2')
        #strQuery = "SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'filterV3'"
        colProcesses = objWMIService.ExecQuery(strQuery)
        time.sleep(0.50)
        kette = ''
        mycounter1 = 0
        for strProcess in colProcesses:
            #print strProcess.__dict__
            newtestcounter1 = int(strProcess.IOReadBytesPerSec)          
            newtestcounter2 = int(strProcess.IOReadOperationsPerSec)
            newtestcounter3 = int(strProcess.IOWriteBytesPerSec)
            newtestcounter4 = int(strProcess.IOWriteOperationsPerSec)
            newtestcounter5 = int(strProcess.IOOtherBytesPerSec)
            newtestcounter6 = int(strProcess.IOOtherOperationsPerSec)
            newtestcounter7 = int(strProcess.PercentProcessorTime)
            mycounter1 = mycounter1 + 1
        colProcess = None
        objWMIService = None
    else:
        #todo complete it
        _ret = ProcessRunning('filterV3')

    test1diff = 0
    test2diff = 0
    test3diff = 0
    test4diff = 0
    test5diff = 0
    test6diff = 0
    test7diff = 0
    test1diff = newtestcounter1 - oldtestcounter1
    test2diff = newtestcounter2 - oldtestcounter2
    test3diff = newtestcounter3 - oldtestcounter3
    test4diff = newtestcounter4 - oldtestcounter4
    test5diff = newtestcounter5 - oldtestcounter5
    test6diff = newtestcounter6 - oldtestcounter6
    test7diff = newtestcounter7 - oldtestcounter7

    if scriptdebug == True:
        mydebugfile.write('Checkfilter: ' + str(test1diff) + '    :' + str(test2diff) + '    :' + str(test3diff) + '    :' + str(test4diff) + '    :' + str(test5diff) + '    :' + str(test6diff) + '    :' + str(test7diff) + '\n')
    if test7diff > 0:
        _ret = 2
    zaehler1 = 0
    if test1diff > 0:
        zaehler1 = zaehler1 + 1
    if test2diff > 0:
        zaehler1 = zaehler1 + 1
    if test3diff > 0:
        zaehler1 = zaehler1 + 1
    if test4diff > 0:
        zaehler1 = zaehler1 + 1
    if test5diff > 0:
        zaehler1 = zaehler1 + 1
    if test6diff > 0:
        zaehler1 = zaehler1 + 1
    if test7diff > 0:
        zaehler1 = zaehler1 + 1
    if zaehler1 > 2:
        _ret = 1
    if zaehler1 == 0:
        _ret = 3
    if  (test1diff > 0)  and  (test2diff > 0)  and  (test3diff == 0)  and  (test4diff == 0)  and  (test5diff > 0)  and  (test6diff == 0)  and  (test7diff > 0) :
        _ret = 3
    if _ret == 2:
        if  (test1diff == 0)  and  (test2diff == 0)  and  (test3diff == 0)  and  (test4diff == 0)  and  (test5diff == 0)  and  (test6diff == 0) :
            _ret = 3
    if  (test1diff == 0)  and  (test2diff == 0)  and  (test3diff == 0)  and  (test4diff == 0)  and  (test5diff == 0)  and  (test6diff == 0)  and  (test7diff == 0) :
        _ret = 0
    if scriptdebug:
        mydebugfile.write('Checkfilter: ' + str(_ret) + '\n')
        mydebugfile.close()
        mydebugfile = None
    print "Rueckgabewert: " + str(_ret)
    print "bitfarm_imaging: checkfilter Ende -------------------------------------------"
    return _ret

def setServicePrinter():
    _ret = False
    objWMIService = None
    objWMIService = GetObject('winmgmts:\\\\.\\root\\cimv2')
    strQuery = "Select * from Win32_Printer"
    colItems = objWMIService.ExecQuery(strQuery)
    z = 0
    for objItem in colItems:
        
        #print objItem.Name
        
        if objItem.Name == 'Serviceprinter':
            try:
                objItem.SetDefaultPrinter
                _ret = True
                break
            except:
                errortxt = 'Serviceprinter konnte nicht als Standard definiert werden'
                #logger.setLevel(Logging.WARNING)
                logger.warning(errortxt)
                print errortxt
         
            
    objItem = None
    colItems = None
    objWMIService = None
    if not _ret:
        errortxt = 'Serviceprinter nicht installiert'
        #logger.setLevel(Logging.WARNING)
        logger.warning(errortxt)
        print errortxt
    return _ret   
        
def rotate_powerpoint(dateiname):
    if  ((handle == 'Powerpoint')   and  (SavePPasList == False))  or  (handle == 'AKT') :
            lngReturnCode = RunFilter(dateiname + '-archiv.tif', os.path.join(programm , 'PProtate.txt'), dateiname + '-archiv1.tif')
            if lngReturnCode <> 0:
                errortxt = 'archivierung(10-12): Fehler bei Filtern nach Ghostscript(Color).'
                #logger.setLevel(Logging.WARNING)
                logger.warning(errortxt)
                GetGarbage(dateiname)
                Unlock(lockdatei)
                sys.exit(2)
            time.sleep(0.50)
            os.remove(dateiname + '-archiv.tif')
            time.sleep(0.50)
            shutil.copyfile(dateiname + '-archiv1.tif', dateiname + '-archiv.tif')
            time.sleep(0.50)
            os.remove(dateiname + '-archiv1.tif')

def shrinkjpg(paramsdict, job, con, logger):
    #paramsdict={"OCRHandle": OCRHandle, "SavePPasList": SavePPasList, "handle": handle, "isBusy": isBusy, "extension": extension, "rundirect":rundirect, "Filtermakro": Filtermakro, "dateiname": tempname, "checkexistingdocpreview":checkexistingdocpreview, "CustomPDFtoTIFFConverter":CustomPDFtoTIFFConverter, "officeOCR":officeOCR, "color":color, "hires":hires}
    tempname = paramsdict["dateiname"]
    extension = paramsdict["extension"] 
    autoshrinkjpg = paramsdict["autoshrinkjpg"]
    #jpgfaktor = paramsdict["jpgfaktor"]

    global lngReturnCode, errortxt
    _ret = None
    mysize = 0
    #lattributes = win32file.GetFileAttributes(datei)
    #win32file.SetFileAttributes(datei, lattributes or 1)
    mysize =os.path.getsize(tempname + extension)
    print mysize
    #mysize = dateiinfo.size
    mysize = int(mysize / 1000)
    time.sleep(0.20)
    dateiinfo = None
    if mysize > autoshrinkjpg:
        autoshrinkjpg = autoshrinkjpg * 2.6
        jpgfaktor = int((autoshrinkjpg / mysize) * 100)
        if jpgfaktor > 99:
            jpgfaktor = 99
        jpgfaktor = int(100 - (100 - jpgfaktor) / 2)
        if jpgfaktor < 12:
            jpgfaktor = 12
        if jpgfaktor < 40:
            jpgfaktor = int(40 - (40 - jpgfaktor) / 2)
        if os.path.exists(os.path.join(programm , 'temp', 'jpgfilter.txt')):
            try:
                os.remove(os.path.join(programm , 'temp', 'jpgfilter.txt'))
            except:
                errortxt = 'bitfarm-Archiv: Archivierung: Fehler beim L?schversuch alter JPG-Filterdatei.'
                #logger.setLevel(Logging.WARNING)
                logger.warning(errortxt)
                print errortxt
                GetGarbage(tempname)
                Unlock(lockdatei)
                sys.exit(2)
            time.sleep(0.50)
        try:
            jpgfilter = open(os.path.join(programm , 'temp', 'jpgfilter.txt'), 'w')
            jpgfilter.write('COMPJPEG=' + str(jpgfaktor))
            jpgfilter.close()
            jpgfilter = None
        except:
            errortxt = 'bitfarm-Archiv: Archivierung: Fehler beim erstellen neuer JPG-Filterdatei.'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print errortxt
            GetGarbage(tempname)
            Unlock(lockdatei)
            sys.exit(2)
        try:
            shutil.copyfile(tempname + extension, tempname + '-OCR' + extension)
        except:
            errortxt = 'bitfarm-Archiv: Archivierung: Fehler beim kopieren JPG-Datei.'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print errortxt
            GetGarbage(tempname)
            Unlock(lockdatei)
            sys.exit(2)
        try:
            os.remove(tempname + extension)
        except:
            errortxt = 'bitfarm-Archiv: Archivierung: Fehler beim umkopieren JPG-Datei.'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print errortxt
            GetGarbage(tempname)
            Unlock(lockdatei)
            sys.exit(2)
        ocrname = tempname + '-OCR'
        lngReturnCode = RunFilter(tempname + '-OCR' + extension, os.path.join(programm , 'temp', 'jpgfilter.txt'), tempname + extension)
        if lngReturnCode <> 0:
            errortxt = 'bitfarm-Archiv: Archivierung: Fehler beim Filtern der JPG-datei:' + lngReturnCode
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print errortxt
            GetGarbage(tempname)
            Unlock(lockdatei)
            sys.exit(2)
        time.sleep(0.300)
        if os.path.exists(tempname + extension) == False:
            shutil.copyfile(tempname + '-OCR' + extension, tempname + extension)
            errortxt = 'bitfarm-Archiv: Archivierung: Fehler bei JPG-Shrinking - Originaldatei wurde wiederhergestellt.'
            #logger.setLevel(Logging.WARNING)
            logger.warning(errortxt)
            print errortxt
        if os.path.exists(os.path.join(programm , 'temp', 'jpgfilter.txt')):
            os.remove(os.path.join(programm , 'temp', 'jpgfilter.txt'))
        time.sleep(0.20)
    
        
        mysize2 =os.path.getsize(tempname + extension)
        print mysize2
        #mysize = dateiinfo.size
        mysize2 = int(mysize2 / 1000)
        
        time.sleep(0.20)
        time.sleep(0.20)

        if mysize2 > mysize:
            try:
                os.remove(tempname + extension)
            except:
                errortxt = 'bitfarm-Archiv: Archivierung: Fehler beim loeschen JPG-Datei(2).'
                #logger.setLevel(Logging.WARNING)
                logger.warning(errortxt)
                print errortxt
                GetGarbage(tempname)
                Unlock(lockdatei)
                sys.exit(2)
            try:
                shutil.copyfile(tempname + '-OCR' + extension, tempname + extension)
            except:
                errortxt = 'bitfarm-Archiv: Archivierung: Fehler beim loeschen JPG-Datei(3).'
                #logger.setLevel(Logging.WARNING)
                logger.warning(errortxt)
                print errortxt
                GetGarbage(tempname)
                Unlock(lockdatei)
                sys.exit(2)
    return _ret

if __name__ == "__main__":
     test_ODTtoPS()
