#!/usr/bin/env python
# -*- coding: utf-8 -*-

# version fuer 35 und 36
import sys
import bitfarm_doc
from bitfarm_proc import BitfarmConnections
import warnings
warnings.filterwarnings(action='ignore', module='sqlalchemy')
try:
    con = BitfarmConnections(sys.argv[1])
    con.create_db_engine()
    con.connect_db() 
    shasum = sys.argv[2]
except Exception as e:
    print("-----------------------")
    print(e)
    print("-----------------------")
    msg = "Fehler! Keine DB-Verbindung oder Aufrufparameter falsch.\n"
    msg += "Aufruf:\nget_doc_by_sha.exe <Pfad auf con-Datei> <sha-Summe>"
    sys.exit(msg)

if con.version in (35, 3.5, 3.0, "35", "3.5", "3", "3.0"):
    try:
        arctblnames = []
        relevantarcs = set()
        sql = "SELECT arc_tblname, arc_id from sys_arc where type=1"
        res = con.main.db.execute(sql)
        for row in res:
            arctblnames.append((row[0], row[1]))

        docs = {}
        for tblname,arcid in arctblnames:

            sql = "SELECT doc_id from arc_"+ tblname + " where sha1=%s"
            #print sql
            res = con.main.db.execute(sql, (shasum, ))
            for row in res:
                if row[0] is not None:
                    if arcid not in docs:
                        docs[arcid]=[]
                    docs[arcid].append(row[0])

        for arcid in docs:
            for docid in docs[arcid]:
                sql = "SELECT gdoc_id from sys_gdocid where arc_id=%d and doc_id=%d" % (arcid, docid)
                res = con.main.db.execute(sql)
                for row in res:
                    print(row[0], arcid, docid)
    except:
        msg = "Fehler bei der Verarbeitung"
        sys.exit(msg)
else:
    sql = "SELECT arcid, gdocid from sys_doc where sha1=%s"
    res = con.main.db.execute(sql, (shasum))
    for row in res:
        print(row[1], row[0], row[1])
