#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""Dieses Modul enthält alle Bitfarm Historymeldungen, die der Server schreiben kann. Clients müssen eine BitfarmHistory Objekt
 übergeben, der wenigstens die HistoryID und die Userid trägt. Die Historyeinträge können 3 optionale Parameter über Formatstring
 aufnehmen (%s). Sie sind in dieser Unit mit _() markiert, damit pygettext diese für eine Übersetzung extrahieren können"""

_ = lambda x: x

HISTORY_MAP = {

                # 0 - 199 Servereinträge
                0:   _(u'%s'),
                1:   _(u'Testeintrag, 1 Value %s'),
                2:   _(u'Testeintrag, 2 Values %s %s'),
                3:   _(u'Testeintrag, 3 Values %s %s %s'),
                4:   _(u'%s'),
                5:   _(u'%s %s'),
                6:   _(u'%s %s %s'),
                7:   _(u'Dokument archiviert'),
                8:   _(u'Dokument archiviert (%s)'),
                9:   _(u'Dokument indiziert und archiviert'),
                10:  _(u'Dokument indiziert und archiviert (%s)'),
                11:  _(u'Das Dokument wurde aktualisert (%s)'),
                12:  _(u'Das Dokument wurde überarbeitet (%s)'),
                13:  _(u'Verknüpfung %s automatisch angelegt'),
                14:  _(u'Wiedervorlage für abonniertes Dokument für %s angelegt'),
                15:  _(u'Dokument wurde revisionssicher abgelegt'),
                16:  _(u'Dokument wurde in Bearbeitung gesetzt'),
                17:  _(u"Wiedervorlage angelegt: %s Termin: %s, Status: offen"),
                18:  _(u"Dokument automatisch mit [%s] verknüpft"),
                19:  _(u"Das Dokument wurde in die SAP-Tabelle eingetragen"),
                20:  _(u'Das Dokument wurde überarbeitet'),
                21:  _(u"Das Dokument wurde in die SAP-Tabelle aktualisiert"),
                22:  _(u"Neuer Benutzer [%s] angelegt, Name = %s"),
                23:  _(u"Benutzer [%s] geändert, Name = %s"),
                24:  _(u"Benutzer [%s] geändert, Name %s nach %s"),
                25:  _(u"Benutzer [%s] geändert, Anzeigename %s nach %s"),
                26:  _(u"Benutzer [%s] geändert, Email %s nach %s"),
                27:  _(u"Benutzer [%s] geändert, Rolle %s nach %s"),
                28:  _(u"Benutzer [%s] geändert, Passwort geändert"),
                29:  _(u"Benutzer [%s] geändert, Eigenschaften %s nach %s"),
                30:  _(u"Neuer Benutzer [%s] angelegt, Name = %s, Anzeigename = %s"),
                31:  _(u"Neuer Benutzer [%s] angelegt, Email = %s"),
                32:  _(u"Neuer Benutzer [%s] angelegt, Eigenschaften = %s"),
                33:  _(u"Neuer Benutzer [%s] angelegt, Rolle = %s"),
                34:  _(u"Neuer Benutzer [%s] angelegt, Passwort gesetzt"),

                35:  _(u"Neue Gruppe [%s] angelegt, Name = %s"),
                36:  _(u"Neue Gruppe [%s] angelegt, Rolle %s"),
                37:  _(u"Neue Gruppe [%s] angelegt, Eigenschaften %s"),
                38:  _(u"Neue Gruppe [%s] angelegt, Adpath %s"),
                39:  _(u"Gruppe [%s] geändert, Name %s nach %s"),
                40:  _(u"Gruppe [%s] geändert, Rolle %s nach %s"),
                41:  _(u"Gruppe [%s] geändert, Eigenschaften %s nach %s"),
                42:  _(u"Gruppe [%s] geändert, Adpath %s nach %s"),

                43:  _(u"Neues Zusatzfeld [%s] angelegt, Name = %s"),
                44:  _(u"Neues Zusatzfeld [%s] angelegt, Feldtyp %s"),
                45:  _(u"Neues Zusatzfeld [%s] angelegt, Eigenschaften %s"),
                46:  _(u"Neues Zusatzfeld [%s] angelegt, Optionen %s"),
                47:  _(u"Neues Zusatzfeld [%s] angelegt, Suchmethode %s"),
                48:  _(u"Neues Zusatzfeld [%s] angelegt, Checkprogramm %s"),
                49:  _(u"Neues Zusatzfeld [%s] angelegt, Auswahlwerte gesetzt, Anzahl = %s"),
                50:  _(u"Zusatzfeld [%s] geändert, Name %s nach %s"),
                51:  _(u"Zusatzfeld [%s] geändert, Feldtyp %s nach %s"),
                52:  _(u"Zusatzfeld [%s] geändert, Eigenschaften %s nach %s"),
                53:  _(u"Zusatzfeld [%s] geändert, Optionen %s nach %s"),
                54:  _(u"Zusatzfeld [%s] geändert, Suchmethode %s nach %s"),
                55:  _(u"Zusatzfeld [%s] geändert, Checkprogramm %s nach %s"),
                56:  _(u"Zusatzfeld [%s] geändert, Auswahlwerte geändert, Anzahl = %s"),

                57:  _(u"Neues Statusfeld [%s] angelegt, Name = %s"),
                58:  _(u"Neues Statusfeld [%s] angelegt, Bitmask %s IndexColumnID %s"),
                59:  _(u"Neues Statusfeld [%s] angelegt, verlinktes Zusatzfeld %s, Funktion %s"),
                60:  _(u"Neues Statusfeld [%s] angelegt, Eigenschaften %s"),
                61:  _(u"Statusfeld [%s] geändert, Name %s nach %s"),
                62:  _(u"Statusfeld [%s] geändert, verlinktes Zusatzfeld %s nach %s"),
                63:  _(u"Statusfeld [%s] geändert, Funktion %s nach %s"),
                64:  _(u"Statusfeld [%s] geändert, Eigenschaften %s nach %s"),

                65:  _(u"Archiv [%s] geändert, Name %s nach %s"),
                66:  _(u"Lager [%s] geändert, Name %s nach %s"),
                67:  _(u"Archiv [%s] verschoben, von Lager %s nach %s"),
                68:  _(u"Lager [%s] verschoben, von Lager %s nach %s"),
                69:  _(u"Archiv [%s] geändert, Eigenschaften %s nach %s"),
                70:  _(u"Lager [%s] geändert, Eigenschaften %s nach %s"),
                71:  _(u"Archiv [%s] geändert, Briefpapier %s nach %s"),
                72:  _(u"Lager [%s] geändert, Briefpapier %s nach %s"),
                73:  _(u"Archiv [%s] geändert, Optionen %s nach %s"),
                74:  _(u"Lager [%s] geändert, Optionen %s nach %s"),
                75:  _(u"Archiv [%s] geändert, Standard Dokumentennamen %s nach %s"),
                76:  _(u"Lager [%s] geändert, Standard Dokumentennamen %s nach %s"),
                77:  _(u"Neues Archiv [%s] angelegt, Name = %s, Lager = %s"),
                78:  _(u"Neues Lager [%s] angelegt, Name %s, Lager = %s"),
                79:  _(u"Neues Archiv [%s] angelegt, Eigenschaften %s"),
                80:  _(u"Neues Lager [%s] angelegt, Eigenschaften %s"),
                81:  _(u"Neues Archiv [%s] angelegt, Briefpapier %s"),
                82:  _(u"Neues Lager [%s] angelegt, Briefpapier %s"),
                83:  _(u"Neues Archiv [%s] angelegt, Optionen %s"),
                84:  _(u"Neues Lager [%s] angelegt, Optionen %s"),
                85:  _(u"Neues Archiv [%s] angelegt, Standard Dokumentennamen %s"),
                86:  _(u"Neues Lager [%s] angelegt, Standard Dokumentennamenn %s"),

                87: _(u"Berechtigung für Archiv [%s] geändert, Benutzer [%s], Rechte = %s"),
                88: _(u"Berechtigung für Archiv [%s] geändert, Gruppe [%s], Rechte = %s"),
                89: _(u"Berechtigung für Zusatzfeld [%s] geändert, Benutzer [%s], Rechte = %s"),
                90: _(u"Berechtigung für Zusatzfeld [%s] geändert, Gruppe [%s], Rechte = %s"),
                91: _(u"Berechtigung für Statusfeld [%s] geändert, Benutzer [%s], Rechte = %s"),
                92: _(u"Berechtigung für Statusfeld [%s] geändert, Gruppe [%s], Rechte = %s"),

                93: _(u"Berechtigung für Archiv [%s] entfernt, Benutzer [%s]"),
                94: _(u"Berechtigung für Archiv [%s] entfernt, Gruppe [%s]"),
                95: _(u"Berechtigung für Zusatzfeld [%s] entfernt, Benutzer [%s]"),
                96: _(u"Berechtigung für Zusatzfeld [%s] entfernt, Gruppe [%s]"),
                97: _(u"Berechtigung für Statusfeld [%s] entfernt, Benutzer [%s]"),
                98: _(u"Berechtigung für Statusfeld [%s] entfernt, Gruppe [%s]"),

                99: _(u"Es wurden Benutzer der Gruppe %s hinzugefügt [%s]"),
                100: _(u"Es wurden Benutzer aus der Gruppe %s entfernt [%s]"),
                101: _(u"Es wurden Mitarbeiter dem Benutzer %s hinzugefügt [%s]"),
                102: _(u"Es wurden Mitarbeiter des Benutzers %s entfernt [%s]"),

                103: _(u"Wiedervorlagen wurden vom Admin gelöscht, Refid [%s], Benutzer [%s], Gruppen [%s]"),

                104:  _(u"Neue Gruppe [%s] angelegt, Email %s"),
                105:  _(u"Gruppe [%s] geändert, Email %s nach %s"),

                106:  _(u"Neues Zusatzfeld [%s] angelegt, Beschreibung %s"),
                107:  _(u"Zusatzfeld [%s] geändert, Beschreibung %s nach %s"),

                108:  _(u"Starte AD-Abgleich..."),
                109:  _(u"AD-Abgleich durchgeführt."),
                110:  _(u"SAP-Dokument wurde von SAP überschrieben"),
                111:  _(u"SAP-Dokument wurde von SAP als gelöscht markiert"),
                112:  _(u"SAP-Dokument wurde angelegt"),

                113:  _(u"Dokumentenlebensdauer für das Archiv [%s] wurde auf %s gesetzt"),
                114:  _(u"Dokumentenlebensdauer für das Archiv [%s] wurde von %s auf %s gesetzt"),
                115:  _(u"Das Löschdatum für das Dokument wurde auf %s gesetzt"),
                116:  _(u"Das Löschdatum für das Dokument wurde nicht geändert"),
                117:  _(u"Das Löschdatum für das Dokument wurde nicht geändert, es bleibt auf %s gesetzt"),
                118:  _(u"Das Löschdatum für das Dokument %s vom %s für das Archiv [%s] wurde erreicht. Das Dokument wurde gelöscht"),
                119:  _(u"Das Löschdatum für das Dokument wurde erneut berechnet und auf %s gesetzt"),
                120:  _(u"Dokumentenlebensdauer für das Archiv wurde geändert, das Löschdatum wird daher auf %s gesetzt"),

                121:  _(u"DLM-Konfiguration: Zusatzfeld %s Auswahl %s auf %s gesetzt"),
                122:  _(u"DLM-Konfiguration: Datumsfeld auf %s gesetzt"),
                123:  _(u"DLM-Konfiguration: Statusfeld %s auf %s gesetzt"),
                124:  _(u"DLM-Konfiguration: Zusatzfeld %s auf Prio %s gesetzt"),
                125:  _(u"DLM-Konfiguration: Datumsfeld %s auf Prio %s gesetzt"),
                126:  _(u"DLM-Konfiguration: Statusfeld %s auf Prio %s gesetzt"),

                127:  _(u"Die Dokumentenlebensdauer für das gesamte Archiv %s [%s] wurde neu berechnet"),
                128:  _(u"Die Dokumentenlebensdauer für %s Archiv(e) wird neu berechnet"),
                129:  _(u"Neuberechnung der Dokumentenlebensdauer für das Archive %s [%s] abgeschlossen"),
                130:  _(u"Neuberechnung: keine Dokumente in Archiv [%s]"),
                131:  _(u"Die Dokumentenlebensdauer für das Archive %s [%s] wird neu berechnet"),

                132:  _(u"Das Dokument wurde vom DMS %s importiert. (Ursprungs-ID %s)"),
                133:  _(u"Es wurden alle Benutzer aus der Gruppe %s entfernt"),
                134:  _(u"Das Dokument wurde vom DMS %s synchronisert. (Ursprungs-ID %s)"),
                135:  _(u"Die Konfiguration des Servers wurde neu eingelesen."),
                136:  _(u"Der Wert des Zusatzfeldes %s wurde vom Administrator von %s auf %s gesetzt"),


                # 200 - 399 Clienteinträge Dokument
                200: _(u'Änderung am Dokument gespeichert'),
                201: _(u'Das Dokument wurde von %s nach %s verschoben'),
                202: _(u'Das Dokument wurde ausgecheckt'),
                203: _(u'Das Dokument wurde eingecheckt'),
                204: _(u'Das Dokument wurde abonniert, Kommentar = "%s"'),
                205: _(u'Das Abonnement wurde aufgehoben'),
                206: _(u'Das Dokument wurde im lokalen Verzeichnis %s gespeichert'),
                207: _(u'Das Dokument wurde auf Drucker %s ausgedruckt'),
                208: _(u'Das Dokument (Voransicht) wurde einer Email übergeben'),
                209: _(u'Das Dokument (Original) wurde einer Email übergeben'),
                210: _(u'Plugin %s gestartet, Parameter %s'),
                211: _(u'Verknüpfung %s angelegt'),
                212: _(u'Verknüpfung %s gelöscht'),
                213: _(u'Dokument der Verknüpfung %s hinzugefügt'),
                214: _(u'Dokument aus der Verknüpfung %s entfernt'),
                215: _(u'Zusatzfeld %s von "%s" nach "%s" geändert'),
                216: _(u'Statusfeld %s von "%s" nach "%s" geändert'),
                217: _(u'Dokumententitel geändert von "%s" in "%s"'),
                218: _(u'Schlagworter auf "%s" geändert'),
                219: _(u'Schlagwort "%s" entfernt'),
                220: _(u'Das Dokument wurde von %s gelesen'),
                221: _(u'Der Symbolic Link wurde von %s nach %s verschoben'),
                222: _(u'Leeres %s Dokument in Archiv %s angelegt'),
                223: _(u'Änderung an der Voransicht gespeichert'),
                224: _(u'Dokument wurde synchronisiert'),
                225: _(u'Zusatzfeld %s automatisch nach "%s" geändert'),
                226: _(u'Zusatzfeld %s automatisch geleert'),
                227: _(u'Zusatzfeld %s nach "%s" geändert'),
                228: _(u'Symbolic Link wurde im Archiv %s angelegt'),
                229: _(u'Dokument erneut zur Verarbeitung gegeben'),
                230: _(u'Dokument revisionssicher abgelegt.'),
                231: _(u"NRS-Dokument [%s] gelöscht von Benutzer [%s]"),
                232: _(u"Originaldokument (Voransicht) wiederhergestellt."),
                233: _(u"Das Dokument wurde per Email als Link an %s versendet."),
                234: _(u'Zusatzfeld %s geleert'),
                235: _(u'Das Löschdatum für das Dokument wurde manuell auf %s gesetzt (Adminberechtigung)'),
                236: _(u'Verknüpfungsfeld geändert, Dokument der Verknüpfung %s hinzugefügt'),
                237: _(u'Verknüpfungsfeld geändert, Dokument aus der Verknüpfung %s entfernt'),
                238: _(u'Das Dokument wurde nach %s exportiert'),
                239: _(u'Das Dokument wurde dupliziert, ID des Quelldokuments [%s]'),
                240: _(u'Das Dokument wurde dupliziert, ID des neuen Dokuments [%s]'),
                241: _(u'Das Dokument wurde per Drag & Drop lokal gespeichert'),
                242: _(u'Die Seiten %s des Dokuments wurden per Drag & Drop lokal gespeichert'),
                243: _(u'Ein Dokumenten-Link wurde in die Zwischenablage kopiert.'),
                244: _(u'Die Voransicht wurde in die Zwischenablage kopiert.'),
                245: _(u'Die Originaldatei wurde in die Zwischenablage kopiert.'),
                246: _(u'Die Seite %s wurde in die Zwischenablage kopiert.'),
                247: _(u'Eine Verknüpfung wurde auf den Desktop erstellt.'),

                300: _(u'%s-Annotation auf Seite %s angelegt'),
                301: _(u'%s-Annotation auf Seite %s entfernt'),
                302: _(u'Alle Annotation auf Seite %s entfernt'),
                303: _(u'%s-Annotation mit Text %s auf Seite %s angelegt'),
                304: _(u'%s-Annotation mit Text %s auf Seite %s entfernt'),
                305: _(u'Annotation auf Seite %s wurde von %s nach %s geändert'),
                306: _(u'Annotation auf Seite %s geändert'),
                307: _(u'Annotation auf Seite %s angelegt'),
                308: _(u'Annotation auf Seite %s entfernt'),
                309: _(u'Ein Kommentar wurde angelegt'),
                310: _(u'Ein Kommentar wurde geändert'),
                311: _(u'Ein Kommentar wurde entfernt'),


                # 400 - 599 Clienteinträge Workflow
                400: _(u'eigene Wiedervorlage angelegt'),
                401: _(u'Wiedervorlage %s für Benutzer %s angelegt'),   # Wiedervorlage werden mit ihrem Namen angezeigt
                402: _(u'Wiedervorlage %s für Gruppe %s angelegt'),
                403: _(u'Wiedervorlage %s weitergeleitet an Benutzer %s'),
                404: _(u'Wiedervorlage %s weitergeleitet an Gruppe %s'),
                405: _(u'Wiedervorlage %s beendet'),
                406: _(u'Wiedervorlage %s fortgesetzt'),
                407: _(u'fertige Wiedervorlage %s entfernt'),
                408: _(u'Wiedervorlage %s geändert, Info = %s'),
                409: _(u'Wiedervorlage %s geändert, Kommentar = %s'),
                410: _(u'Wiedervorlage %s geändert, Status = %s'),
                411: _(u'Wiedervorlage %s geändert, Datum = %s'),
                412: _(u'Wiedervorlage %s geändert, Alarm = %s'),
                413: _(u'Wiedervorlage %s angelegt, Kommentar = %s'),
                414: _(u'Wiedervorlage %s angelegt, Datum = %s, Alarm = %s'),
                415: _(u'Wiedervorlage %s angelegt, Optionen = %s'),
                416: _(u'Gruppenwiedervorlage %s mit Jeder einzeln fertiggesetzt, Optionen = %s'),
                417: _(u'Gruppenwiedervorlage %s mit Einer für Alle fertiggesetzt, Optionen = %s'),


                899: _(u'Letzter vordefinierter Eintrag')
                }

