def toint(strvalue):
    try:
        return str(int(float(strvalue)))
    except:
        return strvalue


def percent(strvalue):
    return f"{strvalue}%"


def to_two_digits(strvalue):
    if len(strvalue) > 0:
        strvalue = strvalue.replace(",", ".")
        formatted_value = f"{float(strvalue):,.2f}".replace(",", "X").replace(".", ",").replace("X", ".")
        return formatted_value
    else:
        return "0,00"

def get_currency_symbol(currency_str):
    currency_symbols = {
        "EUR": "€",  # Euro
        "USD": "$",  # US Dollar
        "GBP": "£",  # British Pound
        "JPY": "¥",  # Japanese Yen
        "CHF": "CHF",  # Swiss Franc
        "AUD": "A$",  # Australian Dollar
        "CAD": "C$",  # Canadian Dollar
        "CNY": "¥",  # Chinese Yuan Renminbi
        "INR": "₹",  # Indian Rupee
        "RUB": "₽",  # Russian Ruble
        "BRL": "R$",  # Brazilian Real
        "ZAR": "R",  # South African Rand
        "MXN": "$",  # Mexican Peso
        "KRW": "₩",  # South Korean Won
        "TRY": "₺",  # Turkish Lira
        "SEK": "kr",  # Swedish Krona
        "NOK": "kr",  # Norwegian Krone
        "DKK": "kr",  # Danish Krone
        "PLN": "zł",  # Polish Zloty
        "HUF": "Ft",  # Hungarian Forint
        "CZK": "Kč",  # Czech Koruna
        "RON": "lei",  # Romanian Leu
        "BGN": "лв",  # Bulgarian Lev
        "HRK": "kn",  # Croatian Kuna
        "ISK": "kr",  # Icelandic Krona
        "SGD": "S$",  # Singapore Dollar
        "HKD": "HK$",  # Hong Kong Dollar
        "NZD": "NZ$",  # New Zealand Dollar
        "MYR": "RM",  # Malaysian Ringgit
        "THB": "฿",  # Thai Baht
        "IDR": "Rp",  # Indonesian Rupiah
        "PHP": "₱",  # Philippine Peso
        "VND": "₫",  # Vietnamese Dong
        "ILS": "₪",  # Israeli Shekel
        "AED": "د.إ",  # UAE Dirham
        "SAR": "﷼",  # Saudi Riyal
        "KWD": "د.ك",  # Kuwaiti Dinar
        "QAR": "﷼",  # Qatari Riyal
        "EGP": "£",  # Egyptian Pound
        "NGN": "₦",  # Nigerian Naira
        "KES": "KSh",  # Kenyan Shilling
        "GHS": "₵",  # Ghanaian Cedi
        "TZS": "TSh",  # Tanzanian Shilling
        "UGX": "USh",  # Ugandan Shilling
        "MAD": "د.م.",  # Moroccan Dirham
        "DZD": "د.ج",  # Algerian Dinar
        "TND": "د.ت",  # Tunisian Dinar
        "XOF": "CFA",  # West African CFA Franc
        "XAF": "FCFA",  # Central African CFA Franc
        "BWP": "P",  # Botswana Pula
        "ZMW": "ZK",  # Zambian Kwacha
        "MWK": "MK",  # Malawian Kwacha
        "MUR": "₨",  # Mauritian Rupee
        "LKR": "₨",  # Sri Lankan Rupee
        "PKR": "₨",  # Pakistani Rupee
        "BDT": "৳",  # Bangladeshi Taka
        "NPR": "₨",  # Nepalese Rupee
        "MMK": "K",  # Myanmar Kyat
        "KHR": "៛",  # Cambodian Riel
        "LAK": "₭",  # Lao Kip
        "MNT": "₮",  # Mongolian Tugrik
        "KZT": "₸",  # Kazakhstani Tenge
        "UZS": "лв",  # Uzbekistani Som
        "AZN": "₼",  # Azerbaijani Manat
        "GEL": "₾",  # Georgian Lari
        "AMD": "֏",  # Armenian Dram
        "BYN": "Br",  # Belarusian Ruble
        "MDL": "L",  # Moldovan Leu
        "MKD": "ден",  # Macedonian Denar
        "RSD": "дин",  # Serbian Dinar
        "BAM": "KM",  # Bosnian Convertible Marka
        "ALL": "L",  # Albanian Lek
        "UAH": "₴",  # Ukrainian Hryvnia
        "KGS": "лв",  # Kyrgyzstani Som
        "TJS": "ЅМ",  # Tajikistani Somoni
        "AFN": "؋",  # Afghan Afghani
        "IRR": "﷼",  # Iranian Rial
        "IQD": "ع.د",  # Iraqi Dinar
        "LBP": "ل.ل",  # Lebanese Pound
        "SYP": "£",  # Syrian Pound
        "YER": "﷼",  # Yemeni Rial
        "OMR": "ر.ع.",  # Omani Rial
        "BHD": "ب.د",  # Bahraini Dinar
        "JOD": "د.ا",  # Jordanian Dinar
        "LYD": "ل.د",  # Libyan Dinar
        "SDG": "ج.س",  # Sudanese Pound
        "SOS": "Sh",  # Somali Shilling
        "ETB": "Br",  # Ethiopian Birr
        "DJF": "Fdj",  # Djiboutian Franc
        "ERN": "Nfk",  # Eritrean Nakfa
        "SZL": "E",  # Swazi Lilangeni
        "LSL": "L",  # Lesotho Loti
        "MZN": "MT",  # Mozambican Metical
        "AOA": "Kz",  # Angolan Kwanza
        "ZWL": "Z$",  # Zimbabwean Dollar
        "BBD": "Bds$",  # Barbadian Dollar
        "BMD": "BD$",  # Bermudian Dollar
        "BSD": "B$",  # Bahamian Dollar
        "BZD": "BZ$",  # Belize Dollar
        "BND": "B$",  # Brunei Dollar
        "FJD": "FJ$",  # Fijian Dollar
        "GYD": "G$",  # Guyanese Dollar
        "JMD": "J$",  # Jamaican Dollar
        "KYD": "CI$",  # Cayman Islands Dollar
        "LRD": "L$",  # Liberian Dollar
        "NAD": "N$",  # Namibian Dollar
        "SBD": "SI$",  # Solomon Islands Dollar
        "SRD": "$",  # Surinamese Dollar
        "TTD": "TT$",  # Trinidad and Tobago Dollar
        "TWD": "NT$",  # New Taiwan Dollar
        "VUV": "VT",  # Vanuatu Vatu
        "WST": "WS$",  # Samoan Tala
        "XCD": "$",  # East Caribbean Dollar
        "PGK": "K",  # Papua New Guinean Kina
        "TOP": "T$",  # Tongan Paʻanga
        "FOK": "kr",  # Faroese Króna
        "GGP": "£",  # Guernsey Pound
        "IMP": "£",  # Isle of Man Pound
        "JEP": "£",  # Jersey Pound
        "SHP": "£",  # Saint Helena Pound
        "KPW": "₩",  # North Korean Won
        "MOP": "MOP$",  # Macanese Pataca
        "MVR": "Rf",  # Maldivian Rufiyaa
        "BTN": "Nu.",  # Bhutanese Ngultrum
        "KID": "$",  # Kiribati Dollar
        "TVD": "$",  # Tuvaluan Dollar
        "ZMW": "ZK",  # Zambian Kwacha
        "MWK": "MK",  # Malawian Kwacha
        "MUR": "₨",  # Mauritian Rupee
        "LKR": "₨",  # Sri Lankan Rupee
        "PKR": "₨",  # Pakistani Rupee
        "BDT": "৳",  # Bangladeshi Taka
        "NPR": "₨",  # Nepalese Rupee
        "MMK": "K",  # Myanmar Kyat
        "KHR": "៛",  # Cambodian Riel
        "LAK": "₭",  # Lao Kip
        "MNT": "₮",  # Mongolian Tugrik
        "KZT": "₸",  # Kazakhstani Tenge
        "UZS": "лв",  # Uzbekistani Som
        "AZN": "₼",  # Azerbaijani Manat
        "GEL": "₾",  # Georgian Lari
        "AMD": "֏",  # Armenian Dram
        "BYN": "Br",  # Belarusian Ruble
        "MDL": "L",  # Moldovan Leu
        "MKD": "ден",  # Macedonian Denar
        "RSD": "дин",  # Serbian Dinar
        "BAM": "KM",  # Bosnian Convertible Marka
        "ALL": "L",  # Albanian Lek
        "UAH": "₴",  # Ukrainian Hryvnia
        "KGS": "лв",  # Kyrgyzstani Som
        "TJS": "ЅМ",  # Tajikistani Somoni
        "AFN": "؋",  # Afghan Afghani
        "IRR": "﷼",  # Iranian Rial
        "IQD": "ع.د",  # Iraqi Dinar
        "LBP": "ل.ل",  # Lebanese Pound
        "SYP": "£",  # Syrian Pound
        "YER": "﷼",  # Yemeni Rial
        "OMR": "ر.ع.",  # Omani Rial
        "BHD": "ب.د",  # Bahraini Dinar
        "JOD": "د.ا",  # Jordanian Dinar
        "LYD": "ل.د",  # Libyan Dinar
        "SDG": "ج.س",  # Sudanese Pound
        "SOS": "Sh",  # Somali Shilling
        "ETB": "Br",  # Ethiopian Birr
        "DJF": "Fdj",  # Djiboutian Franc
        "ERN": "Nfk",  # Eritrean Nakfa
        "SZL": "E",  # Swazi Lilangeni
        "LSL": "L",  # Lesotho Loti
        "MZN": "MT",  # Mozambican Metical
        "AOA": "Kz",  # Angolan Kwanza
        "ZWL": "Z$",  # Zimbabwean Dollar
        "BBD": "Bds$",  # Barbadian Dollar
        "BMD": "BD$",  # Bermudian Dollar
        "BSD": "B$",  # Bahamian Dollar
        "BZD": "BZ$",  # Belize Dollar
        "BND": "B$",  # Brunei Dollar
        "FJD": "FJ$",  # Fijian Dollar
        "GYD": "G$",  # Guyanese Dollar
        "JMD": "J$",  # Jamaican Dollar
        "KYD": "CI$",  # Cayman Islands Dollar
        "LRD": "L$",  # Liberian Dollar
        "NAD": "N$",  # Namibian Dollar
        "SBD": "SI$",  # Solomon Islands Dollar
        "SRD": "$",  # Surinamese Dollar
        "TTD": "TT$",  # Trinidad and Tobago Dollar
        "TWD": "NT$",  # New Taiwan Dollar
        "VUV": "VT",  # Vanuatu Vatu
        "WST": "WS$",  # Samoan Tala
        "XCD": "$",  # East Caribbean Dollar
        "PGK": "K",  # Papua New Guinean Kina
        "TOP": "T$",  # Tongan Paʻanga
        "FOK": "kr",  # Faroese Króna
        "GGP": "£",  # Guernsey Pound
        "IMP": "£",  # Isle of Man Pound
        "JEP": "£",  # Jersey Pound
        "SHP": "£",  # Saint Helena Pound
        "KPW": "₩",  # North Korean Won
        "MOP": "MOP$",  # Macanese Pataca
        "MVR": "Rf",  # Maldivian Rufiyaa
        "BTN": "Nu.",  # Bhutanese Ngultrum
        "KID": "$",  # Kiribati Dollar
        "TVD": "$",  # Tuvaluan Dollar
    }
    
    if currency_str in currency_symbols:
        return currency_symbols[currency_str]
    else:
        return currency_str