#!/usr/bin/env python
# -*- coding: utf-8 -*-

import setuptools
from distutils.core import setup
from distutils.extension import Extension
from Cython.Distutils import build_ext
import bitfarm_core
import bitfarm_enterprise

ext_modules = [
    Extension("bitfarm_core",  ["bitfarm_core.py"]),
    Extension("bitfarm_enterprise",  ["bitfarm_enterprise.py"]),
    Extension("bitfarm_baseobj",  ["bitfarm_baseobj.py"]),
    Extension("bitfarm_doc",  ["bitfarm_doc.py"]),
    Extension("bitfarm_proc",  ["bitfarm_proc.py"]),
    Extension("bitfarm_con",  ["bitfarm_con.py"]),
    Extension("bitfarm_history",  ["bitfarm_history.py"]),
    Extension("bitfarm_errors",  ["bitfarm_errors.py"]),
    Extension("bitfarm_xml",  ["bitfarm_xml.py"]),
    Extension("bitfarm_oauth",  ["bitfarm_oauth.py"]),
    Extension("bitfarm_translate",  ["bitfarm_translate.py"]),
    Extension("bfaServerCore",  ["bfaServerCore.py"]),
    Extension("bfaServerEnterprise",  ["bfaServerEnterprise.py"])
]

setup(
    name = 'bitfarm_c_api',
    cmdclass = {'build_ext': build_ext},
    include_dirs = [],
    ext_modules = ext_modules
)