'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'***************  Archivierungsdient.vbs  GPL **********************************************
'*******************************************************************************************
'***************  Version 3.6.2.0             **********************************************
'*******************************************************************************************
'***************  Programm zum Starten der Archivierung als Dienst           ***************
'***************  auch ohne Benutzerkontext.                                 ***************
'***************                                                             ***************
'***************  wird ber Serviceany (Resoucekit) installiert              ***************
'***************  verbleibt im Speicher und startet die Archivierung alle    ***************
'***************  paar Minten                                                ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************





wartesekunden = 2
Profil=""
adminmail=""
checkmysql=False
ocrserver=""
renderserver=""
lastlog = 0
lastmail = 0
loginterval = 300
mailinterval = 3600
'*******************************************************************************************
'*******************************************************************************************
On Error Resume Next


Set osh = WScript.CreateObject("WScript.Shell") 
Set fs      = WScript.CreateObject("Scripting.FileSystemObject") 


fullpath = WScript.ScriptFullName
scriptname = WScript.ScriptName
mypath = Left(fullpath,Len(fullpath)-Len(scriptname))


inilesen()
readconfig(Profil)

If mypath = "" Then
    osh.LogEvent 1, "bitfarm-Archiv: Fehler(Archivierungsdienst): kann Scriptpfad nicht bestimmen."
    WScript.Quit
End If
Err.clear


If fs.FileExists(mypath&"temp\directlock") Then
    fs.deletefile(mypath&"temp\directlock")
End If
If fs.FileExists(mypath&"temp\lock") Then
    fs.deletefile(mypath&"temp\lock")
End If
If fs.FileExists(mypath&"temp\superlock") Then
    fs.deletefile(mypath&"temp\superlock")
End If


' Luft die MySQL?
' Etwas warten (max 20 Sek.), da nach Neustart des Servers die MySQL evtl. noch nicht da ist.
abbruch = False
i = 0
mysqlrunning = False
While abbruch = False
    mysqlrunning = check_mysql()
    If mysqlrunning = False Then
        WScript.Sleep 1000
    Else
        abbruch = True	
    End If
    If i = 20 Then
        abbruch = True
    End If
    i = i +1
Wend


' Converter-Dienst starten, falls konfiguriert
If ocrserver<>"" And renderserver <> "" Then
	cmd = "net start bfaConvSrv"
	osh.Run cmd, 0, False
End If

a=0
i=0
Do While i=0
    a=a+1
    If a>5 Then
        
        a=0
        If checkoverflow=True Then
            osh.LogEvent 2, "bitfarm-Archiv Dienstkontrolle: Programmberlauf -> Neustart ausgelst."&z
            osh.run Chr(34)& mypath&"\RESTART.bat" &Chr(34),0, False
            WScript.sleep 500
            WScript.quit
        End If
    End If
    If checkmysql = True Then
    	mysqlrunning = check_mysql()

    	If mysqlrunning = False Then
    		
    		' Eventlog-Meldung erzeugen
    		If lastlog = 0 Then
    			osh.LogEvent 2, "bitfarm-Archiv Dienstkontrolle: MySQL ist nicht erreichbar."
    			lastlog = Timer()
    		Else
    			' Nur einmal pro 5 Minuten loggen
    			If Timer() - lastlog > loginterval Then
    				osh.LogEvent 2, "bitfarm-Archiv Dienstkontrolle: MySQL ist nicht erreichbar."
    				lastlog = Timer()
    			End If
    		End If
    		
    		' Mail an admin
    		If adminmail <> "" Then
	    		If lastmail=0 Then
	    			sendmail = True
	    		ElseIf Timer()-lastmail > mailinterval Then    ' Nur einmal pro Stunde
	    			sendmail = True
	    		Else
	    			sendmail = False
	    		End If
	    		If sendmail = True Then
		        	errortxt = "</br>Der MySQL Dienst ist zur Zeit nicht erreichbar, die Archivierung wurde ausgesetzt.</br>Bitte prfen Sie die MySQL.</br>"
		        	cmd = Chr(34)&mypath & "sendlinkmail.vbs"&Chr(34)&" " & adminmail & " " &  "0.0" & " " & Chr(34) & errortxt & Chr(34)
		        	lngReturnCode = osh.Run(Chr(34)&mypath & "sendlinkmail.vbs"&Chr(34)&" " & adminmail & " " &  "0.0" & " " & Chr(34) & errortxt & Chr(34),0,True)
		        	lastmail = Timer()
			    End If
	    	End If
	    	WScript.Sleep 1000
	    	
    	Else
    		osh.Run Chr(34)& mypath&"\archivierung.bat" &Chr(34),0, False 
    	End If
    Else
    	osh.Run Chr(34)& mypath&"\archivierung.bat" &Chr(34),0, False 
    End If
    If Err.number Then
        Err.clear
        On Error Resume Next
    End If
    WScript.Sleep wartesekunden*1000
    
Loop
Set fs=Nothing
WScript.Quit


Function check_mysql()


    check_mysql=False
    If fs.fileexists(mypath & "bfa_mysqlcheck.exe") Then
    	cmd = Chr(34) & mypath & "bfa_mysqlcheck.exe" & Chr(34) & " " & Chr(34) & mypath&profil&".con" & Chr(34)
    	Set oExec    = osh.Exec(cmd)	
    	Do While Not oExec.StdOut.AtEndOfStream
	        strinput = strinput & oExec.StdOut.Read(1)	
	    Loop
	    If InStr(1, LCase(strinput), "true")<>0 Then
        	check_mysql=True
    	End If
    Else
    	osh.LogEvent 1, "archivierungsdienst.vbs: bfa_mysqlcheck.exe nicht gefunden. Fahre ohne MySQL-Check fort"
    	check_mysql = True
    End If
End Function


Function checkoverflow()
    On Error Resume Next
    checkoverflow=False
    If ocrserver="" Then
	    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
	    strQuery = "Select * from Win32_Process where Name='omnipage.exe'"
	    Set colItems = objWMIService.ExecQuery(strQuery,,48)
	    z=0
	    For Each objItem In colItems
	        
	        z=z+1
	    Next
	    If z>1 Then
	        checkoverflow=True
	        osh.LogEvent 2, "bitfarm-Archiv Dienstkontrolle: Exception bei Omnipage.exe Prozessanzahl "&z
	    End If
	End If
	
	If renderserver="" Then
		Set colItems = Nothing
	    Set objWMIService = Nothing
	    
	    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
	    strQuery = "Select * from Win32_Process where Name='gswin32.exe'"
	    Set colItems = objWMIService.ExecQuery(strQuery,,48)
	    z=0
	    For Each objItem In colItems
	        
	        z=z+1
	    Next
	    If z>3 Then
	        checkoverflow=True
	        osh.LogEvent 2, "bitfarm-Archiv Dienstkontrolle: Exception bei gswin32.exe Prozessanzahl "&z
	    End If
	    
	    Set colItems = Nothing
	    Set objWMIService = Nothing
	    
	    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
	    strQuery = "Select * from Win32_Process where Name='gswin32c.exe'"
	    Set colItems = objWMIService.ExecQuery(strQuery,,48)
	    z=0
	    For Each objItem In colItems
	        
	        z=z+1
	    Next
	    If z>3 Then
	        checkoverflow=True
	        osh.LogEvent 2, "bitfarm-Archiv Dienstkontrolle: Exception bei gswin32c.exe Prozessanzahl "&z
	    End If
	    
	    Set colItems = Nothing
	    Set objWMIService = Nothing
	    
	    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
	    strQuery = "Select * from Win32_Process where Name='gsview32.exe'"
	    Set colItems = objWMIService.ExecQuery(strQuery,,48)
	    z=0
	    For Each objItem In colItems
	        
	        z=z+1
	    Next
	    If z>8 Then
	        checkoverflow=True
	        osh.LogEvent 2, "bitfarm-Archiv Dienstkontrolle: Exception bei gsview32.exe Prozessanzahl "&z
	    End If
	    
	    Set colItems = Nothing
	    Set objWMIService = Nothing
	    
	    Set colItems = Nothing
	    Set objWMIService = Nothing
	    
	    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
	    strQuery = "Select * from Win32_Process where Name='soffice.exe'"
	    Set colItems = objWMIService.ExecQuery(strQuery,,48)
	    z=0
	    For Each objItem In colItems
	        
	        z=z+1
	    Next
	    If z>2 Then
	        checkoverflow=True
	        osh.LogEvent 2, "bitfarm-Archiv Dienstkontrolle: Exception bei soffice.exe Prozessanzahl "&z
	    End If
	    
	    Set colItems = Nothing
	    Set objWMIService = Nothing
	    
	    Set colItems = Nothing
	    Set objWMIService = Nothing
	    
	    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
	    strQuery = "Select * from Win32_Process where Name='soffice.bin'"
	    Set colItems = objWMIService.ExecQuery(strQuery,,48)
	    z=0
	    For Each objItem In colItems
	        
	        z=z+1
	    Next
	    If z>2 Then
	        checkoverflow=True
	        osh.LogEvent 2, "bitfarm-Archiv Dienstkontrolle: Exception bei soffice.bin Prozessanzahl "&z
	    End If
	    
	End If
    
    
    
    Set colItems = Nothing
    Set objWMIService = Nothing
    
    
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='rdtifbar.exe'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    z=0
    For Each objItem In colItems
        
        z=z+1
    Next
    If z>2 Then
        checkoverflow=True
        osh.LogEvent 2, "bitfarm-Archiv Dienstkontrolle: Exception bei rdtifbar.exe Prozessanzahl "&z
    End If
    
    Set colItems = Nothing
    Set objWMIService = Nothing
    
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='FilterV3.exe'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    z=0
    For Each objItem In colItems
        
        z=z+1
    Next
    If z>3 Then
        checkoverflow=True
        osh.LogEvent 2, "bitfarm-Archiv Dienstkontrolle: Exception bei FilterV3.exe Prozessanzahl "&z		
    End If
    
    Set colItems = Nothing
    Set objWMIService = Nothing
    
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='WinWord.exe'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    z=0
    For Each objItem In colItems
        
        z=z+1
    Next
    If z>3 Then
        checkoverflow=True
        osh.LogEvent 2, "bitfarm-Archiv Dienstkontrolle: Exception bei Winword.exe Prozessanzahl "&z
    End If
    
    Set colItems = Nothing
    Set objWMIService = Nothing
    
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='Excel.exe'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    z=0
    For Each objItem In colItems
        
        z=z+1
    Next
    If z>3 Then
        checkoverflow=True
        osh.LogEvent 2, "bitfarm-Archiv Dienstkontrolle: Exception bei Excel.exe Prozessanzahl "&z
    End If
    
    Set colItems = Nothing
    Set objWMIService = Nothing
    
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='PowerPoint.exe'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    z=0
    For Each objItem In colItems
        
        z=z+1
    Next
    If z>3 Then
        checkoverflow=True
        osh.LogEvent 2, "bitfarm-Archiv Dienstkontrolle: Exception bei PowerPoint.exe Prozessanzahl "&z
    End If
    
    Set colItems = Nothing
    Set objWMIService = Nothing
    
    
    

    
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='dbimpv3.exe'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    z=0
    For Each objItem In colItems
        
        z=z+1
    Next
    If z>5 Then
        checkoverflow=True
        osh.LogEvent 2, "bitfarm-Archiv Dienstkontrolle: Exception bei dbimpv3.exe Prozessanzahl "&z
    End If
    
    Set colItems = Nothing
    Set objWMIService = Nothing
    
    
    
    
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='cmd.exe'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    z=0
    For Each objItem In colItems
        
        z=z+1
    Next
    If z>22 Then
        checkoverflow=True
        osh.LogEvent 2, "bitfarm-Archiv Dienstkontrolle: Exception bei cmd.exe Prozessanzahl "&z
    End If
    
    Set colItems = Nothing
    Set objWMIService = Nothing
    
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='wscript.exe'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    z=0
    For Each objItem In colItems
        
        z=z+1
    Next
    If z>22 Then
        checkoverflow=True
        If fs.FileExists(mypath&"getrunningvbs.exe") = False Then
            objWSHShell.LogEvent 1, "bitfarm-Archiv: Dienstkontrolle: getrunningvbs.exe nicht im Programmpfad gefunden."
        Else
            strname=getrunningvbs()
            
            
        End If
        
        osh.LogEvent 2, "bitfarm-Archiv Dienstkontrolle: Exception bei wscript.exe Prozessanzahl "&z & vbCrLf & strname
    End If
    
    Set colItems = Nothing
    Set objWMIService = Nothing
    
    
    
    
    Set colItems = Nothing
    Set objWMIService = Nothing
    
    
End Function


Function getrunningvbs
    On Error Resume Next
    
    Set oExec    = osh.Exec(mypath&"getrunningvbs.exe")
    strinput = oExec.StdOut.ReadAll
    durch = False
    schleife = 0
    Do While schleife < 5000
        If oExec.Status = 1 Then 
            durch = True
            Exit Do
        End If
        
        WScript.Sleep 1
        schleife = schleife +1
    Loop
    
    getrunningvbs = LCase(strinput)
    Set oExec = Nothing
    
End Function


Function inilesen()
    On Error Resume Next
    Err.clear
    Set inifile = fs.OpenTextFile(mypath&"scripts.ini",1)
    If Err.number Then
        osh.LogEvent 1, "scripts.ini nicht im Scriptpfad vorhanden oder nicht lesbar."
        Err.clear
        WScript.Quit
    End If 
    
    kette=inifile.readline
    Scriptsflag=InStr(1,kette,"[Scripts]")
    Do While Scriptsflag = 0
        kette=inifile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        If inifile.AtEndOfStream = True Then
            inifile.close
            osh.LogEvent 1, "Fehler beim Lesen der scripts.ini - falsche Formatierung."
            WScript.Quit
        End If
    Loop
    
    
    Do While inifile.AtEndOfStream <> True
        kette=inifile.readline
        If Left(kette,1)<>";" Then
            
            
            
            If InStr(1,kette,"Profil",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"Profil",1)+7)
                Profil=wert
            End If
            
            If InStr(1,kette,"renderserver",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"renderserver",1)+13)
                renderserver=wert
            End If
            
            If InStr(1,kette,"ocrserver",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"ocrserver",1)+9)
                ocrserver=wert
            End If
            
        End If
        
    Loop
    inifile.close
    Set inifile = Nothing
    If Profil="" Then
        osh.LogEvent 1, "Fehler beim Lesen der scripts.ini - kein Profil."
        WScript.Quit
    End If
    
    
End Function

Private Function GetString(kette,pos)
    On Error Resume Next
    zeichen=""
    ergebnis=""
    index=0
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (zeichen<>"	") And (index<80)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,pos+index,1)
        index=index+1
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=")) And (ergebnis="") Then
            zeichen=""
        End If
    Loop
    Trim(ergebnis)
    GetString=ergebnis
End Function

Function readconfig(profil)
    On Error Resume Next
    readconfig=True
    Err.clear
    
    If Not fs.FileExists(mypath&profil&".con") Then
        Err.clear
        errortxt=profil&".con Datei nicht im Scriptpfad vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        readconfig=False
        Err.clear
    End If
    
    If readconfig=True Then	
        Set confile = fs.OpenTextFile(mypath&profil&".con",1)
        If Err.number Then
            Err.clear
            errortxt="Profilfdatei nicht im Scriptpfad vorhanden oder nicht lesbar."
            objWshShell.LogEvent 1, errortxt
            Err.clear
            readconfig=False
            
        End If 
    End If
    
    If readconfig=True Then	
        kette=confile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        Do While Scriptsflag = 0
            kette=confile.readline
            Scriptsflag=InStr(1,kette,"[Scripts]")
            If confile.AtEndOfStream = True Then
                confile.close
                Set confile=Nothing
                scriptsflag=1
                errortxt="Fehler beim Lesen der CON-Datei - falsche Formatierung."
                objWshShell.LogEvent 1, errortxt
                readconfig = False
                
            End If
        Loop
        
    End If
    
    
    If readconfig = True Then
        
        Do While confile.AtEndOfStream <> True
            
            kette=Trim(confile.readline)
            kette = Replace(kette,vbTab,"")
            
            If Left(kette,1)<>";" Then
                
                
                
                If InStr(1,kette,"adminmail",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"adminmail",1)+9)
                    adminmail = wert
                End If
                
                If InStr(1,kette,"checkmysql",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"checkmysql",1)+10)
                    If LCase(wert)="true" Then
                        checkmysql=True
                    Else
                        checkmysql=False
                    End If
                End If
                
                
                
                
            End If
            
        Loop
        confile.close
        Set confile = Nothing
        
    End If
    
    
End Function
'**************************************  ENDE  *********************************************
'*******************************************************************************************
