'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'***************  Archivspooler.vbs  GPL  **************************************************
'*******************************************************************************************
'***************  Version 3.6.2.0         **************************************************
'*******************************************************************************************
'***************  Programm zur Entgegennahme von Dateien durch               ***************
'***************  den verteiler.vbs Dienst.                                  ***************
'***************                                                             ***************
'***************  druckt ber GSVIEW bei Bedarf aus und erstellt .ps und     ***************
'***************  .job Datei fr die Archivierung. Entschlsselt Parameter   ***************
'***************  aus bergebenem Dateinamen.                                ***************
'***************                                                             ***************
'***************                                                             ***************
'***************  Syntax: <programmpfad>Archivspooler.bat <datei><Profil>    ***************
'***************  gltig sind Postscript oder tif Dateien                    ***************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************

jetzt = Timer
scriptdebug= False
logging = False
cleanup = True

trennzeichen = ""
druckserver=""
standardfilter=""



'*******************************************************************************************
'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

On Error Resume Next

Dim objWSHShell, fso, FileIn, FileOut
Dim Datei, Text, Txt, i, arrSort, arrTest(), oArgs, Druckername
Dim lngReturnCode
ReDim ext(60)

Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set fs      = WScript.CreateObject("Scripting.FileSystemObject") 
Set oArgs    = WScript.Arguments 
Err.Clear

filtermakro="" 
druckserver1=""
druckserver2=""
druckserver3=""
druckserver4=""
programm=""
clientID=""
archivverzeichnis="" 
queue=""
direct=""
unverteilt=""
directpath=False
For i=0 To 59
	ext(i)="...."
Next

readuserfromfilename=False
readuserfromfolder=False
readuserfromfileowner=False
readarchivfromfilename=False
readarchivfromfolder=False
extcounter=0
prio=False
acceptdoc=False
acceptxls=False
acceptdwg=False
acceptppt=False
acceptallfiletypes=False
MSOffice2007installed=False
uncclientspooler=""
globalblacklist=""
globalacceptnoextension=False
checkexistingdocpreview=False
dateiname=""
removepscopies=False
pcltotif=""
color = ""
Typ = "OMP"

'**************************************************************************************
'**************************************************************************************

'*******************************************************************************************
'**************************  Startparameter initialisieren  ********************************
Err.clear
fullpath = WScript.ScriptFullName
If Err.number Then
	Err.clear
	errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
	objWshShell.LogEvent 1, errortxt
	WScript.Quit
End If 
scriptname = WScript.ScriptName
If Err.number Then
	Err.clear
	errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
	objWshShell.LogEvent 1, errortxt
	WScript.Quit
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))
If Err.number Then
	Err.clear
	errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
	objWshShell.LogEvent 1, errortxt
	WScript.Quit
End If 
If Len(programm)=0 Then
	errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
	objWshShell.LogEvent 1, errortxt
	WScript.Quit
End If
queue=programm&"queue\"
direct=programm&"direct\"
garbagepath=programm&"garbage\"
temp=programm&"temp\"
templates=programm&"templates\"


'*******************************************************************************************
'*******************************************************************************************

inilesen

ext(0)=".tif"
ext(1)=".ps"
ext(2)=".pdf"
ext(3)=".bmp"
ext(4)=".jpg"
ext(5)=".gif"
ext(6)=".pcl"
extcounter=7

If acceptdoc=True Then
	ext(extcounter)=".doc"
	ext(extcounter+1)=".rtf"
	ext(extcounter+2)=".htm"
	ext(extcounter+3)=".txt"
	extcounter=extcounter+4
End If

If acceptxls=True Then
	ext(extcounter)=".xls"
	ext(extcounter+1)=".dbf"
	ext(extcounter+2)=".tab"
	extcounter=extcounter+3
End If

If acceptppt=True Then
	ext(extcounter)=".ppt"
	ext(extcounter+1)=".pps"
	extcounter=extcounter+2
End If

If acceptdwg=True Then
	ext(extcounter)=".dwg"
	ext(extcounter+1)=".dxf"
	extcounter=extcounter+2
End If

If MSOffice2007installed=True Then
	ext(extcounter)=".docx"
	ext(extcounter+1)=".docm"
	ext(extcounter+2)=".dotx"
	ext(extcounter+3)=".dotm"
	ext(extcounter+4)=".xlsx"
	ext(extcounter+5)=".xlsm"
	ext(extcounter+6)=".xltx"
	ext(extcounter+7)=".xltm"
	extcounter=extcounter+8
	
End If

'**************************************************************************************
'**************************************************************************************



Jahr = DatePart("yyyy",Date)
Monat = DatePart("m",Date)
Tag = DatePart("d",Date)
Stunde = DatePart("h",Time)
Minuten = DatePart("n",Time)
Sekunde = DatePart("s", Time)

datum = Jahr&"-" & Monat & "-" & Tag & "--" & Stunde & "-" & Minuten & "-" & Sekunde

Err.clear
Datei = oArgs.item(0) 

If Err.number<>0 Then
	objWshShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: kein Parameter bergeben (Datei)."
	Err.clear
	WScript.Quit
End If 

If logging=True Then
	objWshShell.LogEvent 4, "bitfarm-Archiv logging: Archivspooler: startet bearbeitung von folgender Datei: "&Datei & vbCrLf & jetzt
End If

isfile=False

If LCase(left(fs.GetFileName(Datei),4))="fast" Then
	directpath=True
	isfile=True
End If

If LCase(Right(datei,4))=".var" Then
	WScript.sleep 500
	If fs.fileexists(datei) Then
		Err.clear
		On Error Resume Next
		fs.deletefile datei, True
		Err.clear
	End If
	WScript.quit
End If



w=0
abbruch=False
extension=""

If fs.GetExtensionName(datei)<>"" Then
	extension = "." & fs.GetExtensionName(datei)
	extension=LCase(extension)
End If




If globalblacklist<>"" Then
	erlaubt = False
	
	If Not(globalacceptnoextension = True And extension = "") Then
		
		'<PDB 03.11.2014 Anpassung um Extensionprfung zu verschrfen
		blacklistmatch = False
		extensionarray = Split(globalblacklist, ".")
		For Each ext2 In extensionarray
			If "." & LCase(ext2) = LCase(extension) Then
				blacklistmatch = True
			End If
		Next
			
		'If InStr(1,globalblacklist,extension) <> 0  Then
		If blacklistmatch Then
		'/PDB>
			
			If scriptdebug Then
				objWshShell.LogEvent 4, "Archivspooler-debug: globalblacklist lsche Datei: "&Datei & vbCrLf & jetzt
			End If 
			
			
			fs.DeleteFile Datei, True
			
			Err.clear
			On Error Resume Next
			
			basisdatei = Left(Datei,Len(datei)-Len(extension))
			
			Err.clear
			On Error Resume Next
			
			If fs.FileExists(basisdatei&".ftx") Then
				fs.Deletefile basisdatei&".ftx", True
				Err.clear
				On Error Resume Next
			End If
			
			If fs.FileExists(basisdatei&".iev") Then
				fs.Deletefile basisdatei&".iev", True
				Err.clear
				On Error Resume Next
			End If
			
			If fs.FileExists(basisdatei&".slw") Then
				fs.Deletefile basisdatei&".slw", True
				Err.clear
				On Error Resume Next
			End If
			
			If fs.FileExists(basisdatei&".swd") Then
				fs.Deletefile basisdatei&".swd", True
				Err.clear
				On Error Resume Next
			End If
			
			If fs.FileExists(basisdatei&".vtx") Then
				fs.Deletefile basisdatei&".vtx", True
				Err.clear
				On Error Resume Next
			End If
			
			If fs.FileExists(basisdatei&".job") Then
				fs.Deletefile basisdatei&".job", True
				Err.clear
				On Error Resume Next
			End If
			
			If fs.FileExists(basisdatei&".tpl") Then
				fs.Deletefile basisdatei&".tpl", True
				Err.clear
				On Error Resume Next
			End If
			
			If fs.FileExists(basisdatei&".pdf") Then
				fs.Deletefile basisdatei&".pdf", True
				Err.clear
				On Error Resume Next
			End If
			
			If fs.FileExists(basisdatei&".tif") Then
				fs.Deletefile basisdatei&".tif", True
				Err.clear
				On Error Resume Next
			End If
			
			If fs.FileExists(basisdatei&".ps") Then
				fs.Deletefile basisdatei&".ps", True
				Err.clear
				On Error Resume Next
			End If
			
			If fs.FileExists(basisdatei&".pcl") Then
				fs.Deletefile basisdatei&".pcl", True
				Err.clear
				On Error Resume Next
			End If
			
			WScript.quit	
			
		End If
	End If
End If


If ((standardfilter<>"") And (extension=".ps")) Or ((standardfilter<>"") And (extension=".pdf")) Or ((standardfilter<>"") And (extension=".pcl")) Then
	filtermakro=standardfilter
End If


Err.clear
Profil = oArgs.item(1) 
'objWSHShell.LogEvent 1, "Archivspooler-Debug: Parameter:" & vbCrLf & oArgs.Item(0) & " " & oArgs.item(1) 
If Err.number<>0 Then
	objWshShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: kein Parameter bergeben (Profil)."
	Err.clear
	WScript.Quit
End If 


zahl = Zufallszahl(0,999)
laenge=Len(Datei)
If laenge<1 Then
	objWshShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Fehler in Parameter (laenge=0)."
	Err.clear
	WScript.Quit
End If

myname = fs.GetBaseName(Datei)
filename = fs.GetFileName(Datei)
extension="." & LCase(fs.getextensionname(datei))
Ausgabename =  Programm&"temp\"&filename

If Not fs.FolderExists(Programm&"temp\") Then
	Err.clear
	Set test = fs.CreateFolder(Programm&"temp\")
	Set test = Nothing
	If Err.number<>0 Then
		objWshShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Fehler beim Anlegen des Temp-Ordners: "&programm&"temp\"
		Err.clear
		WScript.quit
	End If
End If


Do While fs.FileExists(Ausgabename) 
	zahl2 = Zufallszahl(0,999)
	Ausgabename = Programm&"temp\"&myname&zahl2&extension
	
	'objWshShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Datei existiert leider schon. ("&Ausgabename&")" &vbcrlf& jetzt
	'  	err.clear
	'WScript.Quit
Loop

If Not fs.FileExists(Datei) Then
	'objWshShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: bergebene Datei nicht (mehr) vorhanden:"&Datei &vbcrlf& jetzt
	Err.clear
	WScript.Quit
End If



'************ Username muss vor dem Kopieren ermittelt werden *****************
username=""
If readuserfromfileowner=True Then
	
	Username= GetOwner(Datei)
	If scriptdebug=True Then
		objWshShell.LogEvent 4, "Archivspooler-debug: using fileowner " & Username &vbCrLf& jetzt
	End If
End If
'*******************************************************************************

'++++++++ dies bitte unbedingt drin lassen, falls function getowner in einen error luft (z.B. wg. Unix-Host)
Err.clear
On Error Resume Next


fs.CopyFile Datei, Ausgabename, True
If Err.number<>0 Then
	If scriptdebug = True Then
		objWshShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Kopieren gescheitert." & Datei &vbCrLf& Ausgabename  & vbCrLf &  Err.Number & "-" & Err.Description &vbCrLf& jetzt
		
	End If
	Err.clear
	WScript.Quit
End If



'******************** Wichtig: Freigeben der temporren Datei *********************
'MsgBox "fs.DeleteFile Datei:"& Datei 
Err.clear
fs.DeleteFile Datei, True

If Err.number<>0 Then
	objWshShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Client-Verzeichnis konnte nicht aufgerumt werden." & vbCrLf  & Datei &vbCrLf&  Err.Number & "-" & Err.Description &vbCrLf& jetzt
	
	Err.clear
	On Error Resume Next
	'MsgBox "fs.deletefile Ausgabename:"& Ausgabename
	fs.deletefile Ausgabename, True
	If Err.number<>0 Then
		objWshShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Temp-Verzeichnis konnte nicht aufgerumt werden." & vbCrLf  & Ausgabename &vbCrLf&   Err.Number & "-" & Err.Description &vbCrLf& jetzt
		
		Err.clear
		On Error Resume Next
	End If
	WScript.Quit
End If

If logging=True Then
	objWshShell.LogEvent 4, "bitfarm-Archiv logging: Archivspooler:  temp-Bearbeitung von folgender Datei: "&Datei & vbCrLf & Ausgabename &vbCrLf& jetzt
End If


'***********************************    Verarbeitung    **************************************
'**************************** 1. Variablen auslesen aus Dateinamen ******************


If InStr(1,myname,trennzeichen,1)<>0 Then
	
	laenge=Len(myname)
	x=1
	Do While (x<laenge) And (Mid(myname,x,1)<>trennzeichen)
		x=x+1
	Loop
	
	Username=Mid(myname,1,x-1)
	If Err.number<>0 Then
		objWshShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Fehler bei Variablen aus Dateinamen lesen."
		Err.clear
		WScript.Quit
	End If
	myname=Mid(myname,x+1,laenge-x)
	If Err.number<>0 Then
		objWshShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Fehler bei Variablen aus Dateinamen lesen."
		Err.clear
		WScript.Quit
	End If
	laenge=laenge-x
	
	x=1
	Do While (x<laenge) And (Mid(myname,x,1)<>trennzeichen)
		x=x+1
	Loop
	
	Druckername=Mid(myname,1,x-1)
	
	myname=Mid(myname,x+1,laenge-x)
	If Err.number<>0 Then
		objWshShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Fehler bei Variablen aus Dateinamen lesen."
		Err.clear
		WScript.Quit
	End If
	laenge=laenge-x
	
	x=1
	Do While (x<laenge) And (Mid(myname,x,1)<>trennzeichen)
		x=x+1
	Loop
	
	Typ=Mid(myname,1,x-1)
	
	myname=Mid(myname,x+1,laenge-x)
	laenge=laenge-x
	If Err.number<>0 Then
		objWshShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Fehler bei Variablen aus Dateinamen lesen."
		Err.clear
		WScript.Quit
	End If
	x=1
	Do While (x<laenge) And (Mid(myname,x,1)<>trennzeichen)
		x=x+1
	Loop
	
	Tabelle=Mid(myname,1,x-1)
	If Err.number<>0 Then
		objWshShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Fehler bei Variablen aus Dateinamen lesen."
		Err.clear
		WScript.Quit
	End If
	
	myname=Mid(myname,x+1,laenge-x)
	laenge=laenge-x
	If Err.number<>0 Then
		objWshShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Fehler bei Variablen aus Dateinamen lesen."
		Err.clear
		WScript.Quit
	End If
	x=1
	Do While (x<laenge) And (Mid(myname,x,1)<>trennzeichen)
		x=x+1
	Loop
	
	Profil=Mid(myname,1,x-1)
	If Err.number<>0 Then
		objWshShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Fehler bei Variablen aus Dateinamen lesen."
		Err.clear
		WScript.Quit
	End If
	
	dateiname="Dokument"
	
Else
	
	If username="" Then
		Username="System"
	End If
	Tabelle=""
	If readarchivfromfolder=True Then
		laenge=Len(datei)
		x=0
		pos1=0
		pos2=0
		Do While (x<laenge) And (Mid(Datei,laenge-x,1)<>"\")
			x=x+1
		Loop
		pos1=laenge-x
		x=x+1
		Do While (x<laenge-1) And (Mid(Datei,laenge-x,1)<>"\")
			x=x+1
		Loop
		pos2=laenge-x+1
		If pos2>2 Then
			Tabelle=Mid(datei,pos2,pos1-pos2)
			If (Len(uncclientspooler)>Len(tabelle)) Then
				If LCase(tabelle)=LCase(Right(uncclientspooler,Len(tabelle))) Then
					tabelle=""
				End If
			End If
		Else
			Tabelle=""
		End If
	End If
	If readarchivfromfilename=True Then
		Tabelle=readinfo(Datei)
	End If
	If readuserfromfolder=True Then
		laenge=Len(datei)
		x=0
		pos1=0
		pos2=0
		Do While (x<laenge) And (Mid(Datei,laenge-x,1)<>"\")
			x=x+1
		Loop
		pos1=laenge-x
		x=x+1
		Do While (x<laenge-1) And (Mid(Datei,laenge-x,1)<>"\")
			x=x+1
		Loop
		pos2=laenge-x+1
		If pos2>2 Then
			Username=Mid(datei,pos2,pos1-pos2)
			If (Len(uncclientspooler)>Len(Username)) Then
				If LCase(Username)=LCase(Right(uncclientspooler,Len(Username))) Then
					Username="System"
				End If
			End If
		Else
			Username="System"
		End If
	End If
	If readuserfromfilename=True Then
		Username=readinfo(Datei)
	End If
	
	Druckername="noprint"
	
End If



If scriptdebug=True Then
	objWshShell.LogEvent 4, "Archivspooler-debug: Username:"&Username&vbCrLf&"Tabelle:"&Tabelle&vbCrLf&"Druckername:"&Druckername&vbCrLf&"Typ:"&Typ&vbCrLf&"Profil:"&Profil&vbCrLf&jetzt
End If

' Profil lesen

erfolg=readconfig(Profil)

If erfolg=False Then
	objWshShell.LogEvent 2, "bitfarm-Archiv: Archivspooler: Kann Konfiguration nicht lesen"
	
End If



'frhes lesen der Job oder Tpl um Prio ber den OCR_Typ zu ermitteln
If extension = "." Then
	basisdatei = Left(Datei,Len(datei))
Else
	basisdatei = Left(Datei,Len(datei)-Len(extension))
End If


If dateiname<>"Dokument" Then
	dateiname = fs.Getbasename(datei)
End If
Err.clear

If Len(dateiname)=18 Then
	If Left(dateiname,4)="file" Then
		Dateiname="Dokument"
	End If
End If


If fs.FileExists(basisdatei & ".job") Then
	
	erfolg=readjob(basisdatei & ".job")
	If erfolg = False And scriptdebug Then
		objWshShell.LogEvent 4, "Archivspooler-debug: frhes lesen der Jobdatei nicht erfolgreich "&vbCrLf&basisdatei&".job" &vbCrLf& jetzt
	End If 
	
Else
	If fs.fileexists(templates&Tabelle&".TPL") Then
		erfolg=readjob(templates&Tabelle&".TPL")
		If erfolg = False And scriptdebug Then
			objWshShell.LogEvent 4, "Archivspooler-debug: frhes lesen des Templates nicht erfolgreich "&vbCrLf&templates&Tabelle&".TPL" &vbCrLf& jetzt
		End If 
	End If 
End If 



'********************* priopath ***************************

If Typ="OMZ" Then
	prio=True
	Typ="OMP"
End If

If Typ="OCZ" Then
	prio=True
	Typ="OCR"
End If

If Typ="TXZ" Then
	prio=True
	Typ="TXT"
End If

If Typ="CCZ" Then
	prio=True
	Typ="CCR"
End If

If Typ="CMZ" Then
	prio=True
	Typ="CMP"
End If

If Typ="CXZ" Then
	prio=True
	Typ="CXT"
End If

If Typ="CRZ" Then
	prio=True
	Typ="CRE"
End If


'********************* Directpath fr Dateien ***************************
If directpath=True Then
	If Typ="OMP" Then
		typ="OMX"
	End If
	If Typ="OCR" Then
		typ="OCX"
	End If
	If Typ="TXT" Then
		typ="TXX"
	End If
	If Typ="CMP" Then
		typ="CMX"
	End If
	If Typ="CCR" Then
		typ="CCX"
	End If
	If Typ="CXT" Then
		typ="CXX"
	End If
	If Typ="CRE" Then
		typ="CRX"
	End If
End If


'************************ COLOR-Pfad *********************************

If Typ="CMP" Then
	typ="OMP"
	Filtermakro="color"
End If
If Typ="CCR" Then
	typ="OCR"
	Filtermakro="color"
End If
If Typ="CXT" Then
	typ="TXT"
	Filtermakro="color"
End If
If Typ="CMX" Then
	typ="OMX"
	Filtermakro="color"
End If
If Typ="CCX" Then
	typ="OCX"
	Filtermakro="color"
End If
If Typ="CXX" Then
	typ="TXX"
	Filtermakro="color"
End If


If scriptdebug=True Then
	objWshShell.LogEvent 4, "Archivspooler-debug: ClientID: "&clientID &vbCrLf& jetzt
End If

' falls ein unbekannter OCR_TYP gesetzt ist auf OMP ndern
If ((typ<>"OMP") And (typ<>"OCR") And (typ<>"TXT") And (typ<>"CRE") And (typ<>"EMP") And (typ<>"OMX") And (typ<>"OCX") And (typ<>"TXX") And (typ<>"CRX")) Then
	typ = "OMP"
End If


'********************* 1b. festlegen Werte fr weitere Verarbeitung *******************
'MsgBox "tempname:"&tempname
If (Typ="OMP") Or (Typ="OCR") Or (Typ="TXT") Or (Typ="CRE") Or (Typ="EMP") Then
	If prio = True Then
		Do While fs.FileExists(tempname&extension) Or tempname=""
			tempname=getfifo(queue,"prio")
		Loop
	Else
		Do While fs.FileExists(tempname&extension) Or tempname=""
			tempname=getfifo(queue,"temp")
			'objWSHShell.LogEvent 1,"getfifo Tempname: " & tempname
		Loop
	End If
End If


If (Typ="OMX") Or (Typ="OCX") Or (Typ="TXX") Or (Typ="CRX") Then
	directpath=True
	
	If Typ="OMX" Then
		Typ="OMP"
	End If
	If Typ="OCX" Then
		Typ="OCR"
	End If
	If Typ="TXX" Then
		Typ="TXT"
	End If
	If Typ="CRX" Then
		Typ="CRE"
	End If
	If isfile=False Then
		clientID=fs.GetBaseName(datei)
		'clientID=Right(datei,9)
		clientID=Right(clientID,6)
	Else
		clientID=fs.GetBaseName(datei)
		'clientID=Right(datei,10)
		clientID=Right(clientID,6)
	End If
	Do While fs.FileExists(tempname&extension) Or tempname=""
		tempname=getfifo(queue,"temp-direct")
	Loop
	
End If




Err.clear
If fs.FileExists(ausgabename) Then
	If scriptdebug Then
		objWshShell.LogEvent 1, "Archivspooler-debug: Kopiere Datei in die Queue" &vbCrLf&Ausgabename&vbCrLf&tempname&extension&vbCrLf&jetzt
	End If 
	
	fs.CopyFile Ausgabename, tempname&extension, True
	
	If Err.number<>0 Then
		objWshShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: kann temporre datei nicht zwischenkopieren. "&Err.number & vbTab & Err.Description &vbCrLf& ausgabename &vbCrLf& tempname&extension &vbCrLf& jetzt
		WScript.Quit
	End If
Else
	objWshShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: keine datei mehr vorhanden (zwischenkopie)."  &vbCrLf& ausgabename &vbCrLf& tempname &vbCrLf& jetzt
	WScript.Quit
End If



fs.DeleteFile Ausgabename, True
If Err.number<>0 Then
	objWshShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: kann temporre Datei nicht lschen. "&Err.number & vbTab & Err.Description &vbCrLf& ausgabename &vbCrLf& jetzt
	Err.clear
	
End If

'Ausgabename =  Archivverzeichnis&datum &"-"& zahl


'*****************************  bernehmen von Volltext- und Schlagwortdatei *****


If extension = "." Then
	basisdatei = Left(Datei,Len(datei))
Else
	basisdatei = Left(Datei,Len(datei)-Len(extension))
End If

If dateiname<>"Dokument" Then
	dateiname = fs.Getbasename(datei)
End If
Err.clear
If Len(dateiname)=18 Then
	If Left(dateiname,4)="file" Then
		Dateiname="Dokument"
	End If
End If




If fs.FileExists(basisdatei&".ftx") Then
	bfaCopyFile basisdatei&".ftx", tempname&".ftx"
	
End If
If fs.FileExists(basisdatei&".slw") Then
	bfaCopyFile basisdatei&".slw", tempname&".slw"
Else
	Set myhandle = fs.OpenTextFile(tempname&".slw",2,True)
	If ((LCase(Left(Dateiname,4))<>"file") Or Not fs.FileExists(basisdatei&".slw")) And (LCase(Left(Dateiname,4))<>"fast") And (LCase(Left(Dateiname,7))<>"msgfast") And (LCase(Left(Dateiname,7))<>"msgfile") Then
		myhandle.writeline "Dateiname=" & dateiname
	End If	
	myhandle.close
	Set myhandle=Nothing
	WScript.sleep 50
	
End If

If fs.FileExists(basisdatei&".ocr") Then
	bfaCopyFile basisdatei&".ocr", tempname&".ocr"
	
End If

For s=0 To 50
	If fs.FileExists(basisdatei&s&".iev") Then
		bfaCopyFile basisdatei&s&".iev", tempname&"_"&s&".iev"
	End If
Next

If fs.FileExists(basisdatei&".msg") Then
	bfaCopyFile basisdatei&".msg", tempname&".msg"
End If

If extension=".msg" Then
	If fs.FileExists(basisdatei&".doc") Then
		bfaCopyFile basisdatei&".doc", tempname&".doc"
	End If
	
	If fs.FileExists(basisdatei&".docx") Then
		bfaCopyFile basisdatei&".docx", tempname&".docx"
	End If

	If fs.FileExists(basisdatei&".htm") Then
		bfaCopyFile basisdatei&".htm", tempname&".htm"
	End If
End If
'+++++++++++++++++  Bei bergabe zB einer PDF Datei soll ggf. eine mitgefhrte Ansicht bernommen werden
'+++++++++++++++++  zB Import vom ERP-System
If extension <> ".tif" And fs.FileExists(basisdatei&".tif") And checkexistingdocpreview=True Then
	bfaCopyFile basisdatei&".tif", tempname&".tif"
End If

'+++++++++++++++++  ggfs. hat der Verteiler auch zuerst das tif gefunden
 '+++++++++++++++++ dann muss geprft werden, ob es ein zugehriges Dokument gibt
If extension = ".tif" And checkexistingdocpreview=True Then
	docfile = finddoc(basisdatei)
	If fs.FileExists(docfile) Then
		dst = tempname&"." & fs.GetExtensionName(docfile)
		bfaCopyFile docfile, tempname&"." & fs.GetExtensionName(docfile)
	End If
End If


If fs.FileExists(basisdatei&".job") Then
	erfolg = bfaCopyFile(basisdatei&".job", tempname&".tpl")
	
	If Not erfolg Then
		objWSHShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Fehler bei Kopieren Jobdatei" &vbCrLf& basisdatei&".job" &vbCrLf& tempname&".tpl" &vbCrLf& jetzt
		If fs.fileexists(tempname&".tpl")=True Then
			fs.deletefile tempname&".tpl", True
		End If
		
		WScript.Quit
		
	End If 	
	
End If


'**************************** 2. Drucken ******************************
lngReturnCode=0

If LCase(druckername) <>"noprint" Then
	
	If extension=".ps" Or extension=".pdf" Or extension=".pcl" Then
		tempprint = getfifo(temp,"print")
		
		fs.CopyFile tempname & extension, tempprint & extension, True
		If Err.Number Then
			objWSHShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Fehler beim Ausdruck" & vbCrLf & "Druckdatei konnte nicht umkopiert werden" & vbCrLf & tempname & extension & vbCrLf & tempprint & extension & vbCrLf & Err.Number& vbTab & Err.Description
		Else
			WScript.Sleep 100
			If extension=".ps" Or extension=".pdf" Then
				Set psprint = objWSHShell.exec ("wscript "&Chr(34)&  programm&"psprint.vbs"&Chr(34)&" """&druckername&""" "&Chr(34)&tempprint&extension &Chr(34)& " " & profil)
			End If
		End If
	End If
	
	If (extension=".pcl") And (LCase(druckername) <>"noprint") Then
		If fs.fileexists(programm&druckername&".bat") Then
			Set pclprint = objWSHShell.exec (Chr(34)&programm&druckername&".bat"&Chr(34)&" "&Chr(34)&tempprint&extension&Chr(34))
		Else
			objWSHShell.LogEvent 1, "bitfarm-Archiv: archivspooler: Fehler beim Ausdruck: BAT-Datei nicht vorhanden ("&programm&druckername&".bat)"
		End If 
		
	End If 
	
	If LCase(extension)=".tif" Then
		lngReturnCode = objWSHShell.Run(Chr(34)&programm&"obcopier.exe"&Chr(34)&" "&druckserver&druckername&" "&Chr(34)&tempname&".tif"&Chr(34),0,True)
		WScript.Sleep 5000
		If lngReturnCode <> 0 Then
			objWSHShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Fehler beim Ausdruck (tif-datei)"
			If fs.fileexists(tempname&".tpl")=True Then
				fs.deletefile tempname&".tpl", True
			End If
			WScript.Quit
		End If
	End If
End If


'*******************************  Mehrfachdruck auf ein Exemplar beschrnken   ***********************

If (removepscopies = True) And (extension=".ps") Then
	
	ps2Name=fs.getparentfoldername(tempname)&"\" & fs.getbasename(tempname) & ".ps2"
	
	If fs.FileExists(ps2Name) Then
		fs.DeleteFile ps2Name, True
	End If
	
	Set ps = fs.opentextfile(tempname& extension,1)
	Set ps2 = fs.createtextfile(ps2Name,2)
	Do While ps.atendofstream <> True
		
		kette = ps.readline
		If InStr(1,kette,"NumCopies") Then
			If scriptdebug = True Then
				objWSHShell.LogEvent 4, "Archivspooler: removepscopies:"&kette & vbCrLf & tempname
			End If
			pos1 = InStr(1,kette,"NumCopies")
			kette = Left(kette,pos1 + 8) & " 1"
			
			ps2.WriteLine kette
			kette = ps.ReadLine
			pos1 = InStr(1,kette,"/languagelevel")
			kette = "1  " & Right(kette,Len(kette)-pos1 +1)
			ps2.WriteLine kette
			kette = ps.ReadLine
			
		End If
		ps2.WriteLine kette
	Loop
	ps.Close
	ps2.Close
	Set ps = Nothing
	Set ps2 = Nothing
	
	If Err.Number <> 0 Then
		objWshShell.LogEvent 1, "Archivspooler: removepscopies: Fehler bei Parsen der PS-Datei"&tempname& extension&vbCrLf & Err.Number & vbTab & Err.Description
		If fs.FileExists(ps2Name) Then
			fs.DeleteFile ps2Name, True
		End If
		Err.Clear
	Else
		If fs.FileExists(tempname& extension) Then
			fs.DeleteFile tempname& extension, True
			WScript.Sleep 100
		End If
		
		If Err.Number Then
			objWSHShell.LogEvent 1, "Archivspooler: removepscopies: Fehler beim lschen der PS-Datei"&tempname& extension&vbCrLf & Err.Number & vbTab & Err.Description
		Else
			fs.MoveFile ps2Name,tempname& extension
			If Err.Number Then
				objWSHShell.LogEvent 1, "Archivspooler: removepscopies: Fehler beim Umkopieren der PS-Datei"&ps2Name & vbCrLf &tempname& extension&vbCrLf & Err.Number & vbTab & Err.Description
				
			End If
			'Datei = tempname& extension
		End If
	End If	
End If

'***********************************************************************************************


If LCase(tabelle)="noarch" Then
	If fs.fileexists(basisdatei&".job") Then
		fs.DeleteFile basisdatei&".job", True
	End If
	If fs.fileexists(tempname&".pdf") Then
		fs.DeleteFile tempname&".pdf", True
	End If
	If fs.fileexists(tempname&".ps") Then
		fs.DeleteFile tempname&".ps", True
	End If
	If fs.fileexists(tempname&".tif") Then
		fs.DeleteFile tempname&".tif", True
	End If
	If fs.fileexists(tempname&".slw") Then
		fs.DeleteFile tempname&".slw", True
	End If
	If fs.fileexists(tempname&".ftx") Then
		fs.DeleteFile tempname&".ftx", True
	End If
	If fs.fileexists(tempname&".tpl") Then
		fs.DeleteFile tempname&".tpl", True
	End If
	If fs.fileexists(tempname&".iev") Then
		fs.DeleteFile tempname&".iev", True
	End If
	If fs.fileexists(tempname&".job") Then
		fs.DeleteFile tempname&".job", True
	End If
	
	WScript.quit	
End If	



'************************* Zur Weiterverarbeitung *******************************
erfolg=readconfig(profil)

If erfolg=False Then
	objWshShell.LogEvent 2, "bitfarm-Archiv: Archivspooler: Kann Konfiguration nicht lesen, benutze Archivname unverteilt."
	unverteilt="unverteilt"
End If

If Tabelle="" Then
	If unverteilt<>"" Then
		Tabelle=unverteilt
	Else
		Tabelle="unverteilt"
	End If
End If


If fs.FileExists(tempname&".job") Then
	objWshShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: jobdatei bereits vorhanden!! ("&tempname&")." &vbCrLf& jetzt
	If fs.fileexists(tempname&".tpl")=True Then
		fs.deletefile tempname&".tpl", True
	End If
	WScript.Quit
End If

If fs.fileexists(tempname&".tpl") Then
	Username=""
	Datum=setdokdate()
	Typ=""
	
Else
	Err.clear
	If Tabelle="workflow" Then
		If fs.fileexists(programm&"workflow-return.tpl") Then
			fs.CopyFile programm&"workflow-return.tpl", tempname&".tpl", True
			If Err.number Then
				Err.clear
				objWSHShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Fehler bei Kopieren einer Vorlagendatei ("&Tabelle&")" &vbCrLf& jetzt
				WScript.Quit
			End If 
		Else
			objWSHShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Fehler bei Kopieren einer Vorlagendatei ("&Tabelle&")" &vbCrLf& jetzt

			WScript.Quit
			
		End If
	Else
		If Not fs.FolderExists(templates) Then
			objWSHShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Kann nicht auf das Templatesverzeichnis zugreifen" & vbCrLf & templates &vbCrLf& jetzt
			rollback("bitfarm-Archiv: Archivspooler: Kann nicht auf das Templatesverzeichnis zugreifen" & vbCrLf & templates &vbCrLf& jetzt)
			WScript.Quit
		End If
		
		If fs.fileexists(templates&Tabelle&".TPL") Then
			fs.CopyFile templates&Tabelle&".TPL", tempname&".tpl", True
			If Err.number Then
				Err.clear
				objWSHShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Fehler bei Kopieren einer Vorlagendatei ("&Tabelle&")" &vbCrLf& jetzt
				WScript.Quit
			End If 
		Else
			If unverteilt<>"" Then
				Tabelle=unverteilt
			Else
				Tabelle="unverteilt"
			End If
			If fs.fileexists(templates&Tabelle&".TPL") Then
				fs.CopyFile templates&Tabelle&".TPL", tempname&".tpl", True
				If Err.number Then
					Err.clear
					objWSHShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Fehler bei Kopieren einer Vorlagendatei ("&Tabelle&")" &vbCrLf& jetzt
					WScript.Quit
				End If
			Else 
				objWSHShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Fehler bei Kopieren einer Vorlagendatei unverteilt" & vbCrLf & Tabelle &vbCrLf& jetzt
				WScript.Quit
			End If
		End If
	End If
	Datum=setdokdate()
End If

erfolg=readjob(tempname&".tpl")

If erfolg=False Then
	objWSHShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Fehler beim lesen einer neuen TPLdatei." &vbCrLf& tempname &vbCrLf& jetzt
End If



If Typ="OMZ" Then
	Typ="OMP"
End If
If Typ="OCZ" Then
	Typ="OCR"
End If
If Typ="TXZ" Then
	Typ="TXT"
End If
If Typ="CCZ" Then
	Typ="OCR"
End If
If Typ="CMZ" Then
	Typ="OMP"
End If
If Typ="CXZ" Then
	Typ="TXT"
End If
If Typ="OMX" Then
	Typ="OMP"
End If
If Typ="OCX" Then
	Typ="OCR"
End If
If Typ="TXX" Then
	Typ="TXT"
End If
If Typ="CRX" Then
	Typ="CRE"
End If


erfolg=writejob(tempname)

If erfolg=False Then
	objWSHShell.LogEvent 1, "bitfarm-Archiv: Archivspooler: Fehler beim schreiben einer neuen Jobdatei." &vbCrLf& tempname &vbCrLf& jetzt
	If fs.fileexists(tempname&".tpl")=True Then
		fs.deletefile tempname&".tpl", True
	End If
	WScript.Quit
End If

If erfolg=True Then
	Err.clear
	On Error Resume Next
	If fs.fileexists(basisdatei&".job") Then
		fs.DeleteFile basisdatei&".job", True
		If Err.number<>0 Then
			Err.clear
			On Error Resume Next
			objWshShell.LogEvent 2, "bitfarm-Archiv: Archivspooler6: kann temporre Datei nicht lschen. "&basisdatei&".job" &vbCrLf& tempname &vbCrLf& jetzt
			Err.clear
		End If 
	End If
End If

If logging=True Then
	objWshShell.LogEvent 4, "bitfarm-Archiv logging: Archivspooler: beende bearbeitung von folgender Datei: "&Datei&vbCrLf&"Job wurde abgelegt als "&tempname&".job" & vbCrLf & jetzt
End If

If directpath=True  Then
	
	'lngReturnCode = objWSHShell.Run(chr(34)&programm&"archivierung.bat"&chr(34),0,true)
End If


WScript.Quit



'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************Ende Hauptprogramm******************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************

Function appendBackslash(thepath)
	If Right(thepath,1)<>"\" Then
		thepath=thepath&"\"
	End If
	appendBackslash=thepath
End Function

Function readconfig(profil)
	On Error Resume Next
	readconfig=True
	Err.clear
	
	If Not fs.FileExists(programm&profil&".con") Then
		Err.clear
		errortxt=profil&".con Datei nicht im Scriptpfad vorhanden oder nicht lesbar."
		objWshShell.LogEvent 1, errortxt
		readconfig=False
		Err.clear
	End If
	
	If readconfig=True Then	
		Set confile = fs.OpenTextFile( programm&profil&".con" ,1)
		If Err.number Then
			Err.clear
			errortxt="Profildatei nicht im Scriptpfad vorhanden oder nicht lesbar.(2)"
			objWshShell.LogEvent 1, errortxt
			Err.clear
			readconfig=False
			
		End If 
	End If
	
	If readconfig=True Then	
		kette=confile.readline
		Scriptsflag=InStr(1,kette,"[Scripts]")
		Do While Scriptsflag = 0
			kette=confile.readline
			Scriptsflag=InStr(1,kette,"[Scripts]")
			If confile.AtEndOfStream = True Then
				confile.close
				Set confile=Nothing
				scriptsflag=1
				errortxt="Fehler beim Lesen der CON-Datei - falsche Formatierung."
				objWshShell.LogEvent 1, errortxt
				readconfig = False
				
			End If
		Loop
		
	End If
	
	
	If readconfig = True Then
		Do While confile.AtEndOfStream <> True
			kette=confile.readline
			If Left(kette,1)<>";" Then
				
				If InStr(1,kette,"unverteilt",1)<>0 Then
					wert=GetString(kette,InStr(1,kette,"unverteilt",1)+11)
					unverteilt = wert
				End If
				
				If InStr(1,kette,"uncclientspooler",1)<>0 Then
					wert = Right(kette,Len(kette) -17)
					uncclientspooler = Trim(wert)
					If Len(uncclientspooler)>2 Then
						uncclientspooler=Left(uncclientspooler,Len(uncclientspooler)-1)
					End If
				End If
				
				If InStr(1,kette,"templates",1)<>0 Then
					wert = Right(kette,Len(kette) -10)
					If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
						templates=Trim(wert)
						templates=appendBackslash(templates)
					End If
				End If	
			End If
		Loop
		confile.close
		Set confile = Nothing
	End If
	
	
End Function




'***************************************************************************************
'***************************************************************************************
'***************************************************************************************



Function writejob(tempname)
	On Error Resume Next
	writejob=True
	Err.clear
	
	If Not fs.FileExists(tempname&".tpl") Then
		Err.clear
		errortxt=tempname&".tpl Datei nicht vorhanden oder nicht lesbar. (writejob)"
		objWshShell.LogEvent 1, errortxt
		writejob=False
		Err.clear
	End If
	
	If writejob=True Then	
		Set quelljobfile = fs.OpenTextFile(tempname&".tpl",1)
		If Err.number Then
			Err.clear
			errortxt="Kann Jobdatei nicht zum schreiben ffnen."
			objWshShell.LogEvent 1, errortxt
			writejob=False
		End If 
	End If
	
	If writejob=True Then
		If fs.FileExists(tempname&".jmp") Then
			fs.DeleteFile(tempname& ".jmp")
			If Err.number Then
				Err.clear
				errortxt="Zwischendatei fr Jobdatei existierte noch, kann diese aber nicht lschen."
				objWshShell.LogEvent 1, errortxt
				writejob=False
				quelljobfile.close
				Set quelljobfile=Nothing
			End If 
		End If	
	End If
	
	If writejob=True Then
		Set zieljobfile = fs.OpenTextFile(tempname&".jmp",8,True)
		If Err.number Then
			Err.clear
			errortxt="Kann Jobdatei nicht zum schreiben ffnen."
			objWshShell.LogEvent 1, errortxt
			writejob=False
			quelljobfile.close
			Set quelljobfile=Nothing
		End If 
	End If
	
	If writejob = True Then
		ersatzstring=""	
		Do While quelljobfile.AtEndOfStream <> True
			kette=quelljobfile.readline
			
			ersatzstring=""
			
			If InStr(1,kette,"DOCID=",1)<>0 Then
				ersatzstring="DOCID="
			End If	
			
			If (Typ<>"") And (InStr(1,kette,"OCR_Typ=",1)<>0) Then
				ersatzstring="OCR_Typ="&Typ
			End If	
			
			If (Username<>"") And (InStr(1,kette,"Benutzer=",1)<>0) Then
				ersatzstring="Benutzer="&Username
			End If	
			
			If (InStr(1,kette,"Volltext=",1)<>0) Then
				If fs.fileExists(tempname&".txt") Then
					ersatzstring="Volltext="&tempname&".txt"
				End If
			End If
			
			If InStr(1,kette,"Schlagworte=",1)<>0 Then
				If fs.fileExists(tempname&".slw") Then
					ersatzstring="Schlagworte="&tempname&".swd"
				End If
			End If
			
			If (Datum<>"") And (InStr(1,kette,"Datum=",1)<>0) Then
				ersatzstring="Datum="&Datum
			End If
			
			If (autolink<>"") And (InStr(1,kette,"Referenz=",1)<>0) Then
				ersatzstring="Referenz="&autolink
			End If
			
			If (Filtermakro<>"") And (InStr(1,kette,"Filter=",1)<>0) Then
				filterstrings = Split(Filtermakro, ";")
				newfilterstring = ""
				For fi = 0 To UBound(filterstrings)
					If filterstrings(fi) <> "" Then
						newfilterstring = newfilterstring & filterstrings(fi) & ";"
					End If
				Next
				If color = True Then
					newfilterstring = newfilterstring & "color"
				End If
				
				ersatzstring="Filter="&newfilterstring
				'If color = True Then
					'ersatzstring = ersatzstring&"color"
				'End If
				
			End If	
			
			If ersatzstring<>"" Then
				zieljobfile.writeline(ersatzstring)
			Else
				zieljobfile.writeline(kette)
			End If
			
		Loop
		
		If clientID<>"" Then
			zieljobfile.writeline("clientID="&clientID)
		End If
		
		quelljobfile.close
		Set quelljobfile = Nothing
		zieljobfile.close
		Set zieljobfile=Nothing
		WScript.sleep 70
		
		Err.clear
		fs.DeleteFile(tempname& ".tpl")
		If Err.number Then
			Err.clear
			errortxt="Fehler beim lschen der alten jobdatei."
			objWshShell.LogEvent 1, errortxt
			writejob=False
		End If 
		
		WScript.sleep 70
		
		If writejob=True Then
			Err.clear
			On Error Resume Next
			fs.CopyFile tempname&".jmp", tempname&".job", True
			If Err.number Then
				errortxt="Fehler beim umkopieren Jobdatei." & vbCrLf & Err.number & vbTab & Err.Description
				objWshShell.LogEvent 1, errortxt
				writejob=False
				Err.clear
			End If 
		End If
		
		WScript.sleep 70
		If writejob=True Then
			fs.DeleteFile(tempname& ".jmp")
			If Err.number Then
				errortxt="Fehler beim lschen der zwischen-jobdatei." & vbCrLf & Err.number & vbTab & Err.Description
				objWshShell.LogEvent 1, errortxt
				writejob=False
				Err.clear
			End If 
		End If
		WScript.sleep 70
	End If
	
End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function readjob(tempname)
	On Error Resume Next
	readjob=True
	Err.clear
	
	
	
	If Not fs.FileExists(tempname) Then
		Err.clear
		errortxt=tempname&"bitfarm-Archiv: Archivspooler: .job Datei nicht vorhanden oder nicht lesbar. (readjob)"
		objWshShell.LogEvent 1, errortxt
		readjob=False
		Err.clear
	End If
	
	If readjob=True Then	
		Set jobfile = fs.OpenTextFile(tempname,1)
		If Err.number Then
			Err.clear
			errortxt="bitfarm-Archiv: Archivspooler: Jobdatei nicht vorhanden oder nicht lesbar."
			objWshShell.LogEvent 1, errortxt
			readjob=False
		End If 
	End If
	
	
	If readjob = True Then
		Do While jobfile.AtEndOfStream <> True
			kette=jobfile.readline
			If Left(kette,1)<>";" Then
				
				If InStr(1,kette,"OCR_Typ=",1)<>0 Then
					wert=GetString(kette,InStr(1,kette,"OCR_Typ=",1)+8)
					If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
						Typ = wert
					End If
				End If
				
				If InStr(1,kette,"Filter=",1)<>0 Then
					wert=GetString(kette,InStr(1,kette,"Filter=",1)+7)
					If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
						Filtermakro = LCase(wert)
						If InStr(1,LCase(wert),"color",1)<>0 Then
							'Filtermakro=""
							Filtermakro=Replace(Filtermakro,"color","")			
							color=True
						End If
						If InStr(1,LCase(wert),"highres",1)<>0 Then
							Filtermakro=Replace(Filtermakro,"highres","")				
							'Filtermakro=""
							hires=True
						End If
					End If
				End If				
			End If
			
		Loop
		jobfile.close
		Set jobfile = Nothing
	End If
	
	
End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function inilesen()
	On Error Resume Next
	Err.clear
	Set inifile = fs.OpenTextFile(programm&"scripts.ini",1)
	If Err.number Then
		objWshShell.LogEvent 1, "scripts.ini nicht im Scriptpfad vorhanden oder nicht lesbar."
		Err.clear
		WScript.Quit
	End If 
	
	kette=inifile.readline
	Scriptsflag=InStr(1,kette,"[Scripts]")
	Do While Scriptsflag = 0
		kette=inifile.readline
		Scriptsflag=InStr(1,kette,"[Scripts]")
		If inifile.AtEndOfStream = True Then
			inifile.close
			objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - falsche Formatierung."
			WScript.Quit
		End If
	Loop
	
	
	Do While inifile.AtEndOfStream <> True
		kette=inifile.readline
		If Left(kette,1)<>";" Then
			
			If InStr(1,kette,"MSWordinstalled",1)<>0 Then
				wert=GetString(kette,InStr(1,kette,"MSWordinstalled",1)+16)
				If LCase(wert)="true" Then
					acceptdoc = True
				End If	
			End If
			
			If InStr(1,kette,"MSExcelinstalled",1)<>0 Then
				wert=GetString(kette,InStr(1,kette,"MSExcelinstalled",1)+17)
				If LCase(wert)="true" Then
					acceptxls = True
				End If	
			End If
			
			If InStr(1,kette,"MSPowerPointinstalled",1)<>0 Then
				wert=GetString(kette,InStr(1,kette,"MSPowerPointinstalled",1)+22)
				If LCase(wert)="true" Then
					acceptppt = True
				End If	
			End If
			
			If InStr(1,kette,"DWGViewerinstalled",1)<>0 Then
				wert=GetString(kette,InStr(1,kette,"DWGViewerinstalled",1)+19)
				If LCase(wert)="true" Then
					acceptdwg = True
				End If	
			End If
			
			If InStr(1,kette,"MSOffice2007installed",1)<>0 Then
				wert=GetString(kette,InStr(1,kette,"MSOffice2007installed",1)+22)
				If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
					If LCase(wert)="true" Then
						MSOffice2007installed=True
					End If
				End If
			End If
			
			If InStr(1,kette,"readuserfromfileowner",1)<>0 Then
				wert=GetString(kette,InStr(1,kette,"readuserfromfileowner",1)+21)
				If LCase(wert)="true" Then
					readuserfromfileowner = True
				End If	
			End If
			
			If InStr(1,kette,"readuserfromfilename",1)<>0 Then
				wert=GetString(kette,InStr(1,kette,"readuserfromfilename",1)+21)
				If LCase(wert)="true" Then
					readuserfromfilename = True
				End If	
			End If
			
			If InStr(1,kette,"readuserfromfolder",1)<>0 Then
				wert=GetString(kette,InStr(1,kette,"readuserfromfolder",1)+19)
				If LCase(wert)="true" Then
					readuserfromfolder = True
				End If	
			End If
			
			If InStr(1,kette,"readarchivfromfilename",1)<>0 Then
				wert=GetString(kette,InStr(1,kette,"readarchivfromfilename",1)+23)
				If LCase(wert)="true" Then
					readarchivfromfilename = True
				End If	
			End If
			
			If InStr(1,kette,"readarchivfromfolder",1)<>0 Then
				wert=GetString(kette,InStr(1,kette,"readarchivfromfolder",1)+21)
				If LCase(wert)="true" Then
					readarchivfromfolder = True
				End If	
			End If
			
			If InStr(1,kette,"acceptallfiletypes",1)<>0 Then
				wert=GetString(kette,InStr(1,kette,"acceptallfiletypes",1)+19)
				If LCase(wert)="true" Then
					acceptallfiletypes = True
				End If	
			End If
			
			
			If InStr(1,kette,"globalblacklistextensions",1)<>0 Then
				wert=LCase(GetString(kette,InStr(1,kette,"globalblacklistextensions",1)+26))
				If (wert<>"") And (Len(wert)>2) Then
					globalblacklist=wert
				End If
			End If
			
			If InStr(1,kette,"globalacceptnoextension",1)<>0 Then
				wert=LCase(GetString(kette,InStr(1,kette,"globalacceptnoextension",1)+24))
				If LCase(wert)="true" Then
					globalacceptnoextension = True
				End If
			End If
			
			If InStr(1,kette,"checkexistingdocpreview",1)<>0 Then
				wert=GetString(kette,InStr(1,kette,"checkexistingdocpreview",1)+24)
				If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
					If LCase(wert)="true" Then
						checkexistingdocpreview=True
					End If
				End If
			End If
			
			If InStr(1,kette,"removepscopies",1)<>0 Then
				wert=GetString(kette,InStr(1,kette,"removepscopies",1)+15)
				If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
					If LCase(wert)="true" Then
						removepscopies=True
					End If
				End If
			End If
			
			If InStr(1,kette,"pcltotif",1)<>0 Then
				wert=LCase(GetString(kette,InStr(1,kette,"pcltotif",1)+9))
				If (wert<>"") And (Len(wert)>2) Then
					pcltotif=wert
				End If
			End If
			
			If InStr(1,kette,"Typ=",1)<>0 Then
				wert=GetString(kette,InStr(1,kette,"Typ",1)+4)
				Typ = wert
			End If
		End If
		
	Loop
	inifile.close
	Set inifile = Nothing
	If programm="" Then
		objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - kein Programmpfad."
		WScript.Quit
	End If
	
	
End Function

'***************************************************************************************
'***************************************************************************************

Function readinfo(datei)
	On Error Resume Next
	laenge=Len(datei)
	x=0
	pos1=0
	
	Do While (x<laenge) And (Mid(Datei,laenge-x,1)<>"\")
		x=x+1
	Loop
	pos1=laenge-x
	dateiname=Right(datei,laenge-pos1)
	laenge=Len(dateiname)
	x=0
	pos1=0
	Do While (x<laenge) And (Mid(Dateiname,laenge-x,1)<>".")
		x=x+1
	Loop
	pos1=laenge-x-1
	zwischenname=Left(dateiname,pos1)
	laenge=Len(zwischenname)
	x=1
	namex=""
	wert=""
	Do While x <= laenge
		zeichen=Mid(zwischenname,x,1)
		wert=Asc(zeichen)
		If (wert=45) Or (wert=46) Or (wert=95) Or (wert=32) Or (wert=246) Or (wert=214) Or (wert=228) Or (wert=196) Or (wert=252) Or (wert=220) Or (wert=223) Or ((wert>47) And (wert<58)) Or ((wert>64) And (wert<91)) Or ((wert>96) And (wert<123)) Then
			namex=namex&zeichen
		End If
		x=x+1
	Loop
	name=LCase(Namex)
	readinfo=Namex
End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function setdokdate()
	On Error Resume Next
	Jahr = DatePart("yyyy",Date)
	Monat = DatePart("m",Date)
	Tag = DatePart("d",Date)
	Stunde = DatePart("h",Time)
	Minuten = DatePart("n",Time)
	Sekunde = DatePart("s", Time)
	If Len(Monat)=1 Then 
		monat="0"&monat
	End If
	If Len(tag)=1 Then 
		tag="0"&tag
	End If
	If Len(stunde)=1 Then 
		stunde="0"&stunde
	End If
	If Len(minuten)=1 Then 
		minuten="0"&minuten
	End If
	If Len(sekunde)=1 Then 
		sekunde="0"&sekunde
	End If
	setdokdate = Jahr&"-" & Monat & "-" & Tag & " " & Stunde & ":" & Minuten & ":" & Sekunde
End Function

'***************************************************************************************
'***************************************************************************************
'***************************************************************************************
'**************************************************************************************
'**************************************************************************************


Function Zufallszahl(von, bis)
	On Error Resume Next
	anzahl = bis-von+1
	Randomize
	Zufallszahl = Fix(Rnd*(anzahl))+von
End Function


Private Function StrConvert(String)
	On Error Resume Next
	wert1=0
	l = Len(String)
	
	For x = 1 To l
		wert1=wert1+((Asc(Mid(String,x,1))-48)*(10^(l-x)))
	Next
	StrConvert=wert1
End Function

Private Function GetString(kette,pos)
	On Error Resume Next
	zeichen=""
	ergebnis=""
	index=0
	Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (zeichen<>"	") And (index<80)
		ergebnis=ergebnis+zeichen
		zeichen=Mid(kette,pos+index,1)
		index=index+1
		If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=")) And (ergebnis="") Then
			zeichen=""
		End If
	Loop
	Trim(ergebnis)
	GetString=ergebnis
End Function


Function RegRead(tempkey)
	On Error Resume Next
	privkey = tempkey
	
	RegRead = objWSHShell.RegRead(privkey)
	If Not Err.number=0 Then
		objWshShell.LogEvent 1, "Fehler: Registrierungsschlssel nicht gesetzt."
		RegRead=""
		Err.clear
		WScript.Quit
	End If
End Function

Function getfifo(fifopath,fifoname)
	On Error Resume Next
	If fs.fileexists(Chr(34) & programm  & "queue\Thumbs.db" & Chr(34)) Then
		fs.deletefile Chr(34) & programm  & "queue\Thumbs.db" & Chr(34), True
		If Err.number<>0 Then
			objWshShell.LogEvent 2, "Archivspooler: konnte Thums.db nicht lschen"
			
		End If 
		
	End If
	
	Dim fifofile
	Dim fifofolder
	Beginn = Timer
	tempnumber=""
	fifoname=LCase(fifoname)
	
	highest = 0
	
	'objWSHShell.LogEvent 1, "getfifo Debug: Parameter: " & vbCrLf & fifopath & " " & fifoname
	fifofile = GetLastFile(programm & "queue", fifoname&"*.*")
	'objWSHShell.LogEvent 1, "getfifo Debug: programm: " & vbCrLf & programm
	'objWSHShell.LogEvent 1, "getfifo Debug: getlastfile: " & vbCrLf & fifofile
	If fifofile<>"" Then
		strfifo = fs.GetBaseName(fifofile)
		If InStr(1,strfifo,"_0") <> 0 Then
			strfifo = Replace(strfifo,"_0","")
		End If
		If InStr(1,strfifio,"-archiv") <> 0 Then
			strfifo = Replace(strfifo,"-archiv","")
		End If
		If InStr(1,strfifio,"-temp") <> 0 Then
			strfifo = Replace(strfifo,"-temp","")
		End If
		strnumber = Right(strfifo,5)
		If IsNumeric(strnumber) Then
			highest= strConvert(strnumber)
		Else
			'Achtung ermittelter Dateiname hat keinen 5 stelligen Index. So eine datei hat hier nichts verloren.
			'wir suchen den letzten job
			fifofile = GetLastFile(Chr(34) & programm & "queue" &Chr(34), fifoname&"*.job")
			If fifofile<>"" Then
				strfifo = fs.GetBaseName(fifofile)
				strnumber = Right(strfifo,5)
				If IsNumeric(strnumber) Then
					highest= strConvert(strnumber)
				End If		
			Else
				'es gibt keinen job
			End If
		End If
		
		If highest = 99999 Then       ' zahlenbereich fr diesen dateinamen voll, umbenennen
			If fifoname = "prio" Then
				objWshShell.LogEvent 1,"bitfarm-Archiv: Achtung Totaler Overflow - Queue vollgelaufen !"&vbCrLf&"Es werden keine Dokumente mehr gespoolt"
				Set fifofolder = Nothing
				WScript.Quit
			Else
				fifoname = "prio"
				getfifo = getfifo(fifopath,fifoname)
				Exit Function
			End If
		End If
		
	End If
	
	tempnumber = MakeFifoString(highest +1)
	
	WScript.Sleep 200
	fifofile = GetLastFile(programm & "queue" ,fifoname&"*.*")
	strfifo = fs.GetBaseName(fifofile)
	
	If strfifo = fifoname& tempnumber Then
		If scriptdebug = True Then
			objWshShell.LogEvent 4, "Archivierung.vbs" &vbCrLf& "Slot schon besetzt, Routine wird nochmals aufgerufen" &vbCrLf& tempnumber &vbCrLf& jetzt
		End If
		
		getfifo = getfifo(fifopath,fifoname)
		
		Exit Function
	End If
	
	'vielleicht wurde aus unbekannten grnden doch ein schon vergebener name ermittelt
	
	If fs.FileExists(fifopath & fifoname& tempnumber & extension) Then
		highest = highest + 1
		tempnumber = MakeFifoString(highest +1)
		Do While fs.FileExists(fifopath & fifoname& tempnumber & extension) And highest <99999
			highest = highest + 1
			tempnumber = MakeFifoString(highest +1)
		Loop
	End If
	
	
	If tempnumber<>"" Then
		getfifo = fifopath & fifoname & tempnumber
	Else
		'alternativ alte routine
		highest = 0
		
		Set fifofolder = fs.GetFolder(fifopath)
		For Each fifofile In fifofolder.Files
			
			strfifo = fs.GetBaseName(fifofile)
			If InStr(1,strfifo,"_0") <> 0 Then
				strfifo = Replace(strfifo,"_0","")
			End If
			If InStr(1,strfifio,"-archiv") <> 0 Then
				strfifo = Replace(strfifo,"-archiv","")
			End If
			If InStr(1,strfifio,"-temp") <> 0 Then
				strfifo = Replace(strfifo,"-temp","")
			End If
			' Bedingung Basename = fifoname+ 5 stellige Zahl
			
			If Len(strfifo) = Len(fifoname)+5 Then
				If LCase(Left(strfifo,Len(strfifo)-5)) = fifoname Then
					
					strnumber = Right(strfifo,5)
					If IsNumeric(strnumber) Then
						strnumber= strConvert(strnumber)
					End If
					If strnumber> highest Then
						highest =  strnumber
					End If
				End If
			End If
			
			If highest = 99999 Then       ' zahlenbereich fr diesen dateinamen voll, umbenennen
				If fifoname = "prio" Then
					
					objWshShell.LogEvent 1,"bitfarm-Archiv: Achtung Totaler Overflow - Queue vollgelaufen !"&vbCrLf&"Es werden keine Dokumente mehr gespoolt"
					
					Set fifofolder = Nothing
					WScript.Quit
				Else
					fifoname = "prio"
					
					getfifo = getfifo(fifopath,fifoname)
					'Set fifofolder = Nothing
					'Set fifofile = Nothing
					Exit Function
				End If
			End If
		Next 
		Set fifofolder = Nothing
		Set fifofile = Nothing
		
		
		tempnumber = MakeFifoString(highest +1)
		
		WScript.Sleep 1000
		
		Set fifofolder = fs.GetFolder(fifopath)
		For Each fifofile In fifofolder.Files
			strfifo = fs.GetBaseName(fifofile)
			
			If strfifo = fifoname& tempnumber Then
				'MsgBox "doch gefunden, die routine nochmals aufrufen"
				If scriptdebug = True Then
					objWshShell.LogEvent 4, "Archivierung.vbs" &vbCrLf& "Slot schon besetzt, Routine wird nochmals aufgerufen" &vbCrLf& tempnumber &vbCrLf& jetzt
				End If
				
				getfifo = getfifo(fifopath,fifoname)
				Set fifofolder = Nothing
				Set fifofile = Nothing
				Exit Function
			End If
		Next 
		Set fifofolder = Nothing
		Set fifofile = Nothing
		
		getfifo = fifopath & fifoname & tempnumber
		
	End If
	Ende = Timer
	If scriptdebug = True Then
		objWshShell.LogEvent 4, "Archivspooler: ermittelter tempname=" & getfifo
	End If 
	
End Function


Function MakeFiFoString(nummer) 
	On Error Resume Next
	
	If Len(nummer) = 1 Then MakeFiFoString = "0000" & nummer
	If Len(nummer) = 2 Then MakeFiFoString = "000" & nummer
	If Len(nummer) = 3 Then MakeFiFoString = "00" & nummer
	If Len(nummer) = 4 Then MakeFiFoString = "0" & nummer
	If Len(nummer) = 5 Then MakeFiFoString = "" & nummer
	
End Function


Function GetFirstFile(folder,mask)
	On Error Resume Next
	
	GetFirstFile=""
	If fs.FileExists(Chr(34)&programm&"countfiles.exe"&Chr(34)) Then
		Set oExec    = objWSHShell.Exec(Chr(34)&programm&"countfiles.exe"&Chr(34)&" "& folder & " " & mask & " -lf")
		
		strinput = oExec.StdOut.ReadAll
		
		durch = False
		schleife = 0
		Do While schleife < 5000
			If oExec.Status = 1 Then 
				durch = True
				Exit Do
			End If
			
			WScript.Sleep 1
			schleife = schleife +1
		Loop
		timer4 = Timer
		
		strname = strinput
		strname=Right(strinput,Len(strinput)-InStrRev(strinput,Chr(13),Len(strinput)-2)-1)
		strname = Left(strname,InStr(strname,Chr(13))-1)
		
		GetFirstFile=strname
		
		Set oExec = Nothing
	Else
		objWSHShell.LogEvent 1, "Archivierung.vbs: " & programm&"countfiles.exe nicht gefunden"
	End If
	
End Function


Function GetLastFile(folder,mask)
	On Error Resume Next
	'objWSHShell.LogEvent 1, "GetLastFile Debug Parameter: " & folder&" " & mask
	GetLastFile=""
	
	If fs.FileExists(programm&"countfiles.exe") Then
		'objWSHShell.LogEvent 1, "GetLastFile Debug countfiles-Aufruf: " & Chr(34)&programm&"countfiles.exe"&Chr(34)&" "& folder & " " & mask & " -ll"
		Set oExec    = objWSHShell.Exec(Chr(34)&programm&"countfiles.exe"&Chr(34)&" "& Chr(34) & folder & Chr(34) & " " & mask & " -ll")
		
		strinput = oExec.StdOut.ReadAll
		
		durch = False
		schleife = 0
		Do While schleife < 5000
			If oExec.Status = 1 Then 
				durch = True
				Exit Do
			End If
			
			WScript.Sleep 1
			schleife = schleife +1
		Loop
		timer4 = Timer
		
		strname = strinput
		strname=Right(strinput,Len(strinput)-InStrRev(strinput,Chr(13),Len(strinput)-2)-1)
		strname = Left(strname,InStr(strname,Chr(13))-1)
		
		GetLastFile=strname
		
		Set oExec = Nothing
	Else
		objWSHShell.LogEvent 1, "Archivierung.vbs: " & programm&"countfiles.exe nicht gefunden"
	End If
	
End Function



Function CountFiles(folder,mask)
	On Error Resume Next
	
	CountFiles=0
	If fs.FileExists(Chr(34)&programm&"countfiles.exe"&Chr(34)) Then
		Set oExec    = objWSHShell.Exec(Chr(34)&programm&"countfiles.exe"&Chr(34)&" "& folder & " " & mask)
		
		strinput = oExec.StdOut.ReadAll
		
		durch = False
		schleife = 0
		Do While schleife < 5000
			If oExec.Status = 1 Then 
				durch = True
				Exit Do
			End If
			
			WScript.Sleep 1
			schleife = schleife +1
		Loop
		timer4 = Timer
		
		strname = strinput
		strname = Right(strinput,Len(strinput)-InStrRev(strinput,Chr(13),Len(strinput)-2)-1)
		strname = Left(strname,InStr(strname,Chr(13))-1)
		
		If InStr(strname,"Anzahl:") Then
			strname = Right(strname,Len(strname)-7)
			
			'MsgBox oExec.ExitCode & vbtab & timer4-timer3 & vbTab & schleife & vbCrLf  & ">>" & strname
			CountFiles = Strconvert(strname)
		End If
		
		Set oExec = Nothing
	Else
		objWSHShell.LogEvent 1, "Archivierung.vbs: " & programm&"countfiles.exe nicht gefunden"
	End If
	
End Function


Function GetOwner(sFile)
	On Error Resume Next
	Err.clear
	sComputer = "."
	Set oWMI = GetObject("winmgmts:" _
	& "{impersonationLevel=impersonate}!\\" & sComputer & "\root\cimv2")
	
	Set oCollection = oWMI.ExecQuery _
	("ASSOCIATORS OF {Win32_LogicalFileSecuritySetting='" & sFile _
	& "'} WHERE AssocClass=Win32_LogicalFileOwner ResultRole=Owner")
	
	If scriptdebug=True Then
		objWshShell.LogEvent 4, "Archivspooler-debug: GetOwner(sFile) "&sFile &vbCrLf& jetzt
	End If
	
	For Each oSID In oCollection
		GetOwner = oSID.AccountName
		If scriptdebug=True Then
			objWshShell.LogEvent 4, "Archivspooler-debug: GetOwner() ."&GetOwner &vbCrLf& jetzt
		End If
	Next
	
	
	If VarType(GetOwner) = 0 Then
		GetOwner = "System"
	End If
End Function


Function bfaCopyFile(scrfile,destfile)
	On Error Resume Next
	If scriptdebug Then
		objWshShell.LogEvent 4, "Archivspooler-debug: bfaCopyFile(" &scrfile&","&destfile&")"
	End If 
	copied = False
	Err.Clear
	
	fs.MoveFile scrfile, destfile 
	
	If Err.Number<> 0 Then
		objWshShell.LogEvent 1, "Archivspooler: Die Datei " &scrfile& vbCrLf &" konnte nicht nach "&destfile&" verschoben werden" & vbCrLf & Err.Number & vbTab & Err.Description
		
		For try = 1 To 10
			Err.Clear
			WScript.Sleep 500
			fs.MoveFile scrfile, destfile 
			If Err.Number Then
				objWSHShell.LogEvent 2, "Archivspooler: Kopierversuch " & try &"/10 fehlgeschlagen"
			Else
				copied = True
				Exit For
			End If 
		Next 
		
		If copied Then
			objWSHShell.LogEvent 0, "Archivspooler: Kopieren der Datei " &scrfile&" erfolgreich bei Versuch " & try 
		Else
			objWSHShell.LogEvent 1, "Archivspooler: Kopieren der Datei  " &scrfile&" fehlgeschlagen" & vbCrLf & Err.Number & vbTab & Err.Description
		End If 
	Else
		copied = True
	End If 
	
	bfaCopyFile = copied
	
End Function


Function rollback(errormsg)

	' kopiert alle tempname-Dateien aus der queue nach garbagepath mit Original-Dateiname aus Datei
	' und erstellt eine error-Datei im Garbage mit der bergebenen errormsg
	
	basename = Left(filename,Len(filename)-Len(extension))
	cnt = 0
	While fs.FileExists(garbagepath&"\"&basename & extension)=True 
		basename = basename+"_"&cnt
	Wend
	
	If fs.FileExists(tempname & extension) Then
		fs.MoveFile tempname & extension, garbagepath&"\"&basename & extension
	End If
	
	If fs.FileExists(tempname & ".slw") Then
		fs.MoveFile tempname & ".slw", garbagepath&"\"&basename & ".slw"
	End If
	
	If fs.FileExists(tempname & ".job") Then
		fs.MoveFile tempname & ".job", garbagepath&"\"&basename & ".job"
	End If
	
	If fs.FileExists(tempname & ".iev") Then
		fs.MoveFile tempname & ".iev", garbagepath&"\"&basename & ".iev"
	End If
	
	Set errorfile = fs.CreateTextFile(garbagepath&"\"&basename & ".err", True, False)
	errorfile.WriteLine(errormsg)
	errorfile.Close()
	WScript.Quit()
	
End Function


Function finddoc(basisdatei)
	' findet im gleiche Verzeichnis wie basisdatei die erste gleichnamige Datei, 
	' deren Endung nicht job oder tif ist
	basedir = fs.GetParentFolderName(basisdatei)
	basefilename = fs.GetBaseName(basisdatei)
	finddoc = ""
    Set folder = fs.GetFolder(basedir)
    For Each otherfile In folder.Files
    	If LCase(fs.GetExtensionName(otherfile)) <> "job" And LCase(fs.GetExtensionName(otherfile)) <> "tif" Then
	    	If LCase(basefilename) = LCase(fs.GetBaseName(otherfile)) Then
	    		finddoc = otherfile.path
	    		Exit for
	    	End If
	    End If
    Next
End Function
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'************************************   Ende    ***************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
