'*******************************************************************************************
'*******************************************************************************************
'***************************      bitfarm Archiv 2024      *********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'***************  GarbageReload.vbs   GPL  *************************************************
'*******************************************************************************************
'***************  Version 3.6.2.0          *************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Serviceroutine zum nachtrglichen Einstellen               ***************
'***************  von Dokumenten aus den Garbage Ordner                      ***************
'***************                                                             ***************
'***************  Syntax: <programmpfad>GarbageReload.vbs                    ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************

On Error Resume Next

Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set fs      = WScript.CreateObject("Scripting.FileSystemObject") 
Set oArgs    = WScript.Arguments 

limit=30

ReDim zusatzfeldname(limit)
ReDim zusatzfeld(limit)
ReDim zusatzspalte(limit)
Zusatzfelder = 0
typ = ""
myname=""


'*******************************************************************************************
'******************************* Initialisierung der globalen Variablen ********************



Err.clear
fullpath = WScript.ScriptFullName
If Err.number Then
    Err.clear
    errortxt="bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehler beim Drucken/Archivieren: Kann Startparameter nicht initialisieren - aktueller Scripting Host? Wenden Sie sich an den Administrator."
    MsgBox(errortxt)
    WScript.Quit
End If 
scriptname = WScript.ScriptName
If Err.number Then
    Err.clear
    errortxt="bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehler beim Drucken/Archivieren: Kann Startparameter nicht initialisieren - aktueller Scripting Host? Wenden Sie sich an den Administrator."
    MsgBox(errortxt)
    WScript.Quit
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))


If Err.number Then
    Err.clear
    errortxt="bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehler beim Drucken/Archivieren: Kann Startparameter nicht initialisieren - aktueller Scripting Host? Wenden Sie sich an den Administrator."
    MsgBox(errortxt)
    WScript.Quit
End If 
If Len(programm)=0 Then
    errortxt="bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehler beim Drucken/Archivieren: Kann Startparameter nicht initialisieren - aktueller Scripting Host? Wenden Sie sich an den Administrator."
    MsgBox(errortxt)
    WScript.Quit
End If
queue=programm&"queue\"
garbage = programm & "garbage\"


'*******************************************************************************************
'*******************************************************************************************


Set gfolder = fs.GetFolder(garbage)

For Each gfile In gfolder.Files
    erfolg = False
    If LCase(fs.GetExtensionName(gfile)) = "job" Then
        myname = ""
        ReDim zusatzfeldname(limit)
        ReDim zusatzfeld(limit)
        ReDim zusatzspalte(limit)
        
        
        qbase = getfifo(queue,"temp")
        
        gbase = fs.getBaseName(gfile)
        
        erfolg = readjob(garbage & gbase)
        
        If erfolg = False Then
            MsgBox " Konnte Job-Datei nicht lesen " & gbase
        End If
        If fs.FileExists(garbage&gbase&".txt") Then
            
            typ = "TXT"
        End If
        
        erfolg = writejob(garbage & gbase)
        
        If erfolg = False Then
            MsgBox " Konnte Job-Datei nicht schreiben" & gbase
        End If
        
        
        ' ermitteln, ob es sich um ein Dokument handelt, das
	    ' mit ODTtoPS_neu archiviert wurde, damit ggfs. das
	    ' temporre PDF entfernt werden kann
        Dim basefiles(30)
        Dim officeext
        officeext = Array("eml", "msg", "odt", "ods", "odg", "odp", "odf", "ott", "otp", "ots", "otg", "sdw", "sxw", "stw", "sdc", "stc","sdd","sti","sxi","std","sda","sxm","smf", "vor","csv", "xls", "xlt", "xlsx", "xlsm", "xltx", "xltm", "dbf", "vcf", "doc", "dot", "docx", "docm", "dotx", "dotm", "pptx", "ppt", "pps", "htm", "html")
        counter = 0
        isoffice = False
        ' alle Dateien die zum Job gehren ermitteln        
        For Each basefile In gfolder.Files                
	        If fs.GetBaseName(basefile)= gbase Or fs.GetBaseName(basefile)= gbase&"-archiv" Then
		        ext = LCase(fs.GetExtensionName(basefile))
		        If IsInArray(ext, officeext) Then
		        	isoffice = True
		        End If
	        	basefiles(counter)=basefile
	        	counter = counter + 1
	        End If
	    Next
	            
        If erfolg = True Then
            fs.copyfile gfile, qbase&".job"
            fs.DeleteFile gfile, True
            For Each basefile In basefiles
                ext = LCase(fs.GetExtensionName(basefile))
                If (ext <>"err" And ext <> "log") And ((ext = "pdf" And isoffice=True)=False) Then
                    fs.copyfile basefile, qbase& "." &  ext
                End If
                fs.DeleteFile basefile, True
            Next 
        End If
    End If
    
Next 


WScript.Quit



'***************************************************************************************
'***************************************************************************************
'***************************************************************************************




Function writejob(tempname)
    On Error Resume Next
    writejob=True
    Err.clear
    
    If Not fs.FileExists(tempname&".job") Then
        Err.clear
        errortxt=tempname&".job Datei nicht vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        writejob=False
        Err.clear
    End If
    
    If writejob=True Then	
        Set quelljobfile = fs.OpenTextFile(tempname&".job",1)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writejob=False
            
        End If 
    End If
    
    If writejob=True Then
        If fs.FileExists(tempname&".tmp") Then
            fs.DeleteFile(tempname& ".tmp")
            If Err.number Then
                Err.clear
                errortxt="Zwischendatei fr Jobdatei existierte noch, kann diese aber nicht lschen."
                objWshShell.LogEvent 1, errortxt
                writejob=False
                quelljobfile.close
                Set quelljobfile=Nothing
            End If 
            
        End If	
    End If
    
    If writejob=True Then
        Set zieljobfile = fs.OpenTextFile(tempname&".tmp",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writejob=False
            quelljobfile.close
            Set quelljobfile=Nothing
        End If 
    End If
    
    
    
    If writejob = True Then
        
        
        ersatzstring=""	
        Do While quelljobfile.AtEndOfStream <> True
            kette=quelljobfile.readline
            skip = False
            ersatzstring=""
            
            If  (InStr(1,kette,"DOCID=",1)<>0) Then
                ersatzstring="DOCID="
            End If	
            
            If  (InStr(1,kette,"gdoc_id=",1)<>0) Then
                ersatzstring="gdoc_id="
            End If	
            
            If (myname<>"") And (InStr(1,kette,"Titel=",1)<>0) Then
                ersatzstring="Titel="&myname
            End If
            
            If (InStr(1,kette,"Orginal=",1)<>0) Then
                ersatzstring="Orginal="
            End If	
            
            
            If (InStr(1,kette,"Kopie=",1)<>0) Then
                ersatzstring="Kopie="
            End If
            
            If (InStr(1,kette,"Quelle=",1)<>0) Then
                ersatzstring="Quelle="
            End If
            
            
            If (InStr(1,kette,"Status=",1)<>0) Then
                ersatzstring="Status="
            End If	
            
            
            If (InStr(1,kette,"StatStr=",1)<>0) Then
                ersatzstring="StatStr="
            End If
            
            If (InStr(1,kette,"OCR_QF=",1)<>0) Then
                ersatzstring="OCR_QF="
            End If
            
            
            
            If  (InStr(1,kette,"Schlagworte=",1)<>0) Then
                If fs.FileExists(garbage&gbase&".swd") Or fs.FileExists(garbage&gbase&".slw") Then
                    ersatzstring="Schlagworte="&qbase&".swd"
                End If
                
            End If	
            
            If  (InStr(1,kette,"Volltext=",1)<>0) Then
                ersatzstring="Volltext="
                
            End If	
            
            
            If (Typ<>"") And (InStr(1,kette,"OCR_Typ=",1)<>0) Then
                ersatzstring="OCR_Typ="&Typ
            End If
            
            
            
            If Left(kette,14)="[Zusatzfelder]" Then
                zieljobfile.writeline "[Zusatzfelder]"
                zieljobfile.writeline "Felder=" & Zusatzfelder
                quelljobfile.SkipLine
                skip = True
                For x=0 To strconvert(zusatzfelder) -1
                    
                    
                    zieljobfile.writeline "ZusTitel"&x+1&"="&zusatzfeldname(x)
                    zieljobfile.writeline "ZusFeld"&x+1&"="&zusatzspalte(x)
                    zieljobfile.writeline "ZusWert"&x+1&"="&zusatzfeld(x)
                    quelljobfile.SkipLine
                    quelljobfile.SkipLine
                    quelljobfile.SkipLine
                Next
            End If
            
            
            
            If skip = False Then
                If ersatzstring<>"" Then
                    zieljobfile.writeline(ersatzstring)
                Else
                    zieljobfile.writeline(kette)
                End If
            End If
            
        Loop
        
        If clientID<>"" Then
            zieljobfile.writeline("clientID="&clientID)
        End If
        
        quelljobfile.close
        Set quelljobfile = Nothing
        zieljobfile.close
        Set zieljobfile=Nothing
        WScript.sleep 50
        
        Err.clear
        fs.DeleteFile(tempname& ".job")
        If Err.number Then
            Err.clear
            errortxt="Fehler beim lschen der alten jobdatei."
            objWshShell.LogEvent 1, errortxt
            writejob=False
        End If 
        
        
        WScript.sleep 50
        
        
        If writejob=True Then
            
            fs.CopyFile tempname&".tmp", tempname&".job", True
            If Err.number Then
                Err.clear
                errortxt="Fehler beim umkopieren Jobdatei."
                objWshShell.LogEvent 1, errortxt
                writejob=False
            End If 
        End If
        
        WScript.sleep 50
        If writejob=True Then
            fs.DeleteFile(tempname& ".tmp")
            If Err.number Then
                Err.clear
                errortxt="Fehler beim lschen der zwischen-jobdatei."
                objWshShell.LogEvent 1, errortxt
                writejob=False
            End If 
        End If
        WScript.sleep 50
        
    End If
    
    
End Function




Function readjob(tempname)
    On Error Resume Next
    readjob=True
    Err.clear
    
    If Not fs.FileExists(tempname&".job") Then
        Err.clear
        errortxt=tempname&".job Datei nicht vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        readjob=False
        Err.clear
    End If
    
    If readjob=True Then	
        Set jobfile = fs.OpenTextFile(tempname&".job",1)
        If Err.number Then
            Err.clear
            errortxt="Jobdatei nicht vorhanden oder nicht lesbar."
            objWshShell.LogEvent 1, errortxt
            
            readjob=False
            
        End If 
    End If
    
    
    If readjob = True Then
        Do While jobfile.AtEndOfStream <> True
            kette=jobfile.readline
            If Left(kette,1)<>";" Then
                If InStr(1,kette,"OCR_Typ=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"OCR_Typ=",1)+8)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        
                        Typ = wert
                    Else
                        Typ = "MAN"	
                    End If
                End If
                
                If InStr(1,kette,"Name=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Name=",1)+5)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        laenge=Len(kette)+1
                        pos1=InStr(1,kette,"Name=",1)+5
                        wert=Mid(kette,pos1,laenge-pos1)
                        Tabelle = wert
                    End If
                    
                End If 
                
                If InStr(1,kette,"DOCID=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"DOCID=",1)+5)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        dokID = wert
                    End If
                End If
                
                If InStr(1,kette,"Titel=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Titel=",1)+5))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        myname = normstring(wert)
                    End If
                End If
                
                If InStr(1,kette,"Benutzer=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Benutzer=",1)+8))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        'leerzeichen raus wegen parameterbergabe
                        username = Replace(wert," ", "")
                    End If
                End If
                
                If InStr(1,kette,"Tabelle=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Tabelle=",1)+7))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        folderID = wert
                    End If
                End If
                
                If InStr(1,kette,"Quelle=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Quelle=",1)+6))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        quelle = wert
                    End If
                End If
                
                If InStr(1,kette,"Orginal=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Orginal=",1)+7))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Orginal = wert
                    End If
                End If
                
                
                If InStr(1,kette,"Status=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Status=",1)+7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        oldstatus = wert
                    End If
                End If
                
                If InStr(1,kette,"clientID=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"clientID=",1)+8)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        clientID = wert
                    End If
                End If
                
                If InStr(1,kette,"Felder=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Felder=",1)+7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Zusatzfelder = strconvert(wert)
                        If Zusatzfelder > 29 Then
                            errortxt="Jobdatei: mehr als "&limit&" Zusatzfelder werden nicht untersttzt."
                            objWshShell.LogEvent 1, errortxt
                            readjob=False
                        End If
                        'If Zusatzfelder > 0 Then
                        '	checkOCR=false
                        'End If
                    End If
                End If
                
                If InStr(1,kette,"ZusTitel",1)<>0 Then
                    wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"ZusTitel",1)+9)))
                    If Len(wert)>0 Then
                        If Left(wert,1)="=" Then
                            wert=Right(wert,Len(wert)-1)
                        End If
                    End If
                    
                    aussortieren=True
                    For a=1 To Len(wert)
                        If (Mid(wert,a,1)<>" ") And (Mid(wert,a,1)<>".") Then
                            aussortieren=False
                        End If
                    Next
                    If aussortieren=True Then
                        wert=""
                    End If
                    
                    gefunden=False
                    x=0
                    Do While gefunden=False
                        If Zusatzfeldname(x)="" Then
                            gefunden=True
                            Zusatzfeldname(x)=wert
                            
                        End If
                        If gefunden=False Then
                            x=x+1
                        End If
                    Loop
                End If
                
                If InStr(1,kette,"ZusWert",1)<>0 Then
                    wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"ZusWert",1)+8)))
                    If Len(wert)>0 Then
                        If Left(wert,1)="=" Then
                            wert=Right(wert,Len(wert)-1)
                        End If
                    End If
                    
                    aussortieren=True
                    For a=1 To Len(wert)
                        If (Mid(wert,a,1)<>" ") And (Mid(wert,a,1)<>".") Then
                            
                            aussortieren=False
                        End If
                    Next
                    If aussortieren=True Then
                        wert=""
                    End If
                    
                    pos1=InStr(1,kette,wert,1)
                    If wert="" Then
                        pos1=0
                    End If
                    If pos1>3 Then
                        wert=Right(kette,Len(kette)-pos1+1)
                    Else
                        wert=""
                    End If
                    
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Zusatzfeld(x)=normstring(wert)
                        
                        checkOCR=False
                    End If
                End If
                
                
                If InStr(1,kette,"ZusFeld",1)<>0 Then
                    wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"ZusFeld",1)+8)))
                    If Len(wert)>0 Then
                        If Left(wert,1)="=" Then
                            wert=Right(wert,Len(wert)-1)
                        End If
                    End If
                    
                    aussortieren=True
                    For a=1 To Len(wert)
                        If (Mid(wert,a,1)<>" ") And (Mid(wert,a,1)<>".") Then
                            
                            aussortieren=False
                        End If
                    Next
                    If aussortieren=True Then
                        wert=""
                    End If
                
                    pos1=InStr(1,kette,wert,1)
                    If wert="" Then
                        pos1=0
                    End If
                    If pos1>3 Then
                        wert=Right(kette,Len(kette)-pos1+1)
                    Else
                        wert=""
                    End If
                    
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Zusatzspalte(x)=wert
                        
                        checkOCR=False
                    End If
                End If
            End If
            
        Loop
        jobfile.close
        Set jobfile = Nothing
        
    End If
    
End Function




Private Function NormString(String)
    On Error Resume Next
    tempkette=""
    wert1=0
    l = Len(String)
    
    For x = 1 To l
        wert1=Asc(Mid(String,x,1))
        If (wert1>=0) And (wert1<=32) Then
            tempkette=tempkette&" "
        Else
            
            If wert1=151 Then
                wert1=45
            End If
            If wert1=150 Then
                wert1=45
            End If
            If wert1=95 Then
                wert1=45
            End If
            If wert1=173 Then
                wert1=45
            End If
            If wert1=175 Then
                wert1=45
            End If
            If wert1=170 Then
                wert1=97
            End If	
            If wert1=161 Then
                wert1=105
            End If
            If wert1=181 Then
                wert1=117
            End If
            If wert1=213 Then
                wert1=214
            End If
            If wert1=195 Then
                wert1=196
            End If
            If wert1=229 Then
                wert1=97
            End If
            If wert1=230 Then
                tempkette=tempkette&"a"
                wert1=101
            End If
            If wert1=209 Then
                wert1=78
            End If
            If wert1=199 Then
                wert1=67
            End If
            If wert1=231 Then
                wert1=99
            End If
            If wert1=241 Then
                wert1=110
            End If
            If wert1=245 Then
                wert1=246
            End If
            If wert1=251 Then
                wert1=252
            End If
            If wert1=253 Then
                wert1=121
            End If
            If wert1=197 Then
                wert1=65
            End If
            
            If wert1=44 Then
                wert1=46
            End If
            
            If (wert1>=204) And (wert1<=207) Then
                wert1=73
            End If
            If (wert1>=200) And (wert1<=203) Then
                wert1=69
            End If
            If (wert1>=192) And (wert1<=194) Then
                wert1=65
            End If
            If (wert1>=210) And (wert1<=211) Then
                wert1=79
            End If	
            If (wert1>=212) And (wert1<=213) Then
                wert1=214
            End If
            If (wert1>=217) And (wert1<=218) Then
                wert1=85
            End If
            If wert1=219 Then
                wert1=220
            End If			
            If (wert1>=224) And (wert1<=225) Then
                wert1=97
            End If
            If (wert1>=226) And (wert1<=227) Then
                wert1=228
            End If
            If (wert1>=224) And (wert1<=225) Then
                wert1=97
            End If
            If (wert1>=232) And (wert1<=235) Then
                wert1=101
            End If
            If (wert1>=236) And (wert1<=239) Then
                wert1=105
            End If	
            If (wert1>=242) And (wert1<=243) Then
                wert1=111
            End If
            If (wert1>=249) And (wert1<=250) Then
                wert1=117
            End If
            
            
            If ((wert1>=44) And (wert1<=46)) Or ((wert1>=47) And (wert1<=57)) Or ((wert1>=63) And (wert1<=90)) Or ((wert1>=97) And (wert1<=122)) Or (wert1=196) Or (wert1=214) Or (wert1=220) Or (wert1=223) Or (wert1=228) Or (wert1=246) Or (wert1=252) Or (wert1=40) Or (wert1=41) Or (wert1=42) Or (wert1=37) Or (wert1=61) Or (wert1=92) Or (wert1=35) Or (wert1=33) Then		
                tempkette=tempkette+Chr(wert1)
            Else
                tempkette=tempkette&""
            End If
        End If
        
        
        
        
    Next
    tempkette2=""
    
    l = Len(tempkette)
    'If l>3 Then
    u=1
    Do While u<=l
        c1=Mid(tempkette,u,1)
        If c1<>" " Then
            o=0
            wort=c1
            Do While ((o+u)<l) And (c1<>" ")
                o=o+1
                c1=Mid(tempkette,u+o,1)
                If c1<>" " Then
                    wort=wort&c1
                End If
            Loop
            u=u+o
            If dropshortstrings=True Then
                If Len(wort)>2 Then
                    tempkette2=tempkette2&" "&wort
                End If
            Else
                tempkette2=tempkette2&" "&wort
            End If
        End If
        u=u+1
        
    Loop
    
    
    NormString=Trim(tempkette2)
    
    
End Function



Private Function GetString(kette,pos)
    On Error Resume Next
    zeichen=""
    ergebnis=""
    index=0
    charwert=0
    If Len(zeichen)=1 Then
        charwert=Asc(zeichen)
    End If
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (charwert<>13) And (charwert<>10) And (zeichen<>"	") And (index<80)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,pos+index,1)
        index=index+1
        If Len(zeichen)=1 Then
            charwert=Asc(zeichen)
        End If
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=") Or (charwert=10) Or (charwert=13)) And (ergebnis="") Then
            zeichen=""
        End If
        
    Loop
    
    GetString=Trim(ergebnis)
End Function




Private Function StrConvert(String)
    On Error Resume Next
    wert1=0
    l = Len(String)
    
    For x = 1 To l
        wert1=wert1+((Asc(Mid(String,x,1))-48)*(10^(l-x)))
    Next
    StrConvert=wert1
End Function



Function getfifo(fifopath,fifoname)
    On Error Resume Next
    If fs.fileexists(programm & "queue\Thumbs.db") Then
        fs.deletefile programm & "queue\Thumbs.db", True
        If Err.number<>0 Then
            objWshShell.LogEvent 2, "Archivspooler: konnte Thums.db nicht lschen"
            
        End If 
        
    End If
    
    Dim fifofile
    Dim fifofolder
    Beginn = Timer
    tempnumber=""
    fifoname=LCase(fifoname)
    
    highest = 0
    
    
    fifofile = GetLastFile(programm & "queue", fifoname&"*.*")
    If fifofile<>"" Then
        strfifo = fs.GetBaseName(fifofile)
        If InStr(1,strfifo,"_0") <> 0 Then
            strfifo = Replace(strfifo,"_0","")
        End If
        If InStr(1,strfifio,"-archiv") <> 0 Then
            strfifo = Replace(strfifo,"-archiv","")
        End If
        If InStr(1,strfifio,"-temp") <> 0 Then
            strfifo = Replace(strfifo,"-temp","")
        End If
        strnumber = Right(strfifo,5)
        If IsNumeric(strnumber) Then
            highest= strConvert(strnumber)
        Else
            'Achtung ermittelter Dateiname hat keinen 5 stelligen Index. So eine datei hat hier nichts verloren.
            'wir suchen den letzten job
            fifofile = GetLastFile(programm & "queue", fifoname&"*.job")
            If fifofile<>"" Then
                strfifo = fs.GetBaseName(fifofile)
                strnumber = Right(strfifo,5)
                If IsNumeric(strnumber) Then
                    highest= strConvert(strnumber)
                End If		
                
                
            Else
                'es gibt keinen job
                
            End If
            
        End If
        
        
        If highest = 99999 Then       ' zahlenbereich fr diesen dateinamen voll, umbenennen
            If fifoname = "prio" Then
                
                objWshShell.LogEvent 1,"bitfarm-Archiv: Achtung Totaler Overflow - Queue vollgelaufen !"&vbCrLf&"Es werden keine Dokumente mehr gespoolt"
                
                Set fifofolder = Nothing
                WScript.Quit
            Else
                fifoname = "prio"
                
                getfifo = getfifo(fifopath,fifoname)
                
                Exit Function
            End If
        End If
        
    End If
    
    
    tempnumber = MakeFifoString(highest +1)
    
    WScript.Sleep 200
    
    
    fifofile = GetLastFile(programm & "queue",fifoname&"*.*")
    strfifo = fs.GetBaseName(fifofile)
    
    
    If strfifo = fifoname& tempnumber Then
        If scriptdebug = True Then
            objWshShell.LogEvent 2, "Archivierung.vbs" &vbCrLf& "Slot schon besetzt, Routine wird nochmals aufgerufen" &vbCrLf& tempnumber &vbCrLf& jetzt
        End If
        
        getfifo = getfifo(fifopath,fifoname)
        
        Exit Function
    End If
    
    'vielleicht wurde aus unbekannten grnden doch ein schon vergebener name ermittelt
    
    If fs.FileExists(fifopath & fifoname& tempnumber & extension) Then
        highest = highest + 1
        tempnumber = MakeFifoString(highest +1)
        
        Do While fs.FileExists(fifopath & fifoname& tempnumber & extension) And highest <99999
            highest = highest + 1
            tempnumber = MakeFifoString(highest +1)
        Loop
        
    End If
    
    
    If tempnumber<>"" Then
        getfifo = fifopath & fifoname & tempnumber
    Else
        'alternativ alte routine
        highest = 0
        
        Set fifofolder = fs.GetFolder(fifopath)
        
        For Each fifofile In fifofolder.Files
            
            strfifo = fs.GetBaseName(fifofile)
            If InStr(1,strfifo,"_0") <> 0 Then
                strfifo = Replace(strfifo,"_0","")
            End If
            If InStr(1,strfifio,"-archiv") <> 0 Then
                strfifo = Replace(strfifo,"-archiv","")
            End If
            If InStr(1,strfifio,"-temp") <> 0 Then
                strfifo = Replace(strfifo,"-temp","")
            End If
            'msgbox "strfifo="& strfifo
            ' Bedingung Basename = fifoname+ 5 stellige Zahl
            
            If Len(strfifo) = Len(fifoname)+5 Then
                If LCase(Left(strfifo,Len(strfifo)-5)) = fifoname Then
                    
                    strnumber = Right(strfifo,5)
                    If IsNumeric(strnumber) Then
                        strnumber= strConvert(strnumber)
                        'MsgBox "strnumber=" & strnumber		
                    End If
                    If strnumber> highest Then
                        highest =  strnumber
                    End If
                End If
            End If
            
            'msgbox "highest=" & highest
            
            If highest = 99999 Then       ' zahlenbereich fr diesen dateinamen voll, umbenennen
                If fifoname = "prio" Then
                    
                    objWshShell.LogEvent 1,"bitfarm-Archiv: Achtung Totaler Overflow - Queue vollgelaufen !"&vbCrLf&"Es werden keine Dokumente mehr gespoolt"
                    
                    Set fifofolder = Nothing
                    WScript.Quit
                Else
                    fifoname = "prio"
                    
                    getfifo = getfifo(fifopath,fifoname)
                    'msgbox "overflow-getfifo=" & getfifo	
                    'Set fifofolder = Nothing
                    'Set fifofile = Nothing
                    Exit Function
                End If
            End If
            
            
        Next 
        Set fifofolder = Nothing
        Set fifofile = Nothing
        
        
        tempnumber = MakeFifoString(highest +1)
        
        WScript.Sleep 1000
        'MsgBox "checkfifo - nochmals nachsehen ob in der zwischenzeit der name von woanders her besetzt wurde"
        
        Set fifofolder = fs.GetFolder(fifopath)
        
        For Each fifofile In fifofolder.Files
            
            
            
            strfifo = fs.GetBaseName(fifofile)
            
            If strfifo = fifoname& tempnumber Then
                'MsgBox "doch gefunden, die routine nochmals aufrufen"
                If scriptdebug = True Then
                    objWshShell.LogEvent 2, "Archivierung.vbs" &vbCrLf& "Slot schon besetzt, Routine wird nochmals aufgerufen" &vbCrLf& tempnumber &vbCrLf& jetzt
                End If
                
                getfifo = getfifo(fifopath,fifoname)
                Set fifofolder = Nothing
                Set fifofile = Nothing
                Exit Function
            End If
            
        Next 
        Set fifofolder = Nothing
        Set fifofile = Nothing
        
        getfifo = fifopath & fifoname & tempnumber
        
        
    End If
    Ende = Timer
    'MsgBox "Getfifo in : " & ende - beginn
    If scriptdebug = True Then
        objWshShell.LogEvent 4, "Archivspooler: ermittelter tempname=" & getfifo
    End If 
    
End Function


Function MakeFiFoString(nummer) 
    On Error Resume Next
    
    If Len(nummer) = 1 Then MakeFiFoString = "0000" & nummer
    If Len(nummer) = 2 Then MakeFiFoString = "000" & nummer
    If Len(nummer) = 3 Then MakeFiFoString = "00" & nummer
    If Len(nummer) = 4 Then MakeFiFoString = "0" & nummer
    If Len(nummer) = 5 Then MakeFiFoString = "" & nummer
    
End Function


Function GetFirstFile(folder,mask)
    On Error Resume Next
    
    GetFirstFile=""
    If fs.FileExists(programm&"countfiles.exe") Then
        Set oExec    = objWSHShell.Exec(programm&"countfiles.exe "& folder & " " & mask & " -lf")
        
        'Do While Not oExec.StdOut.AtEndOfStream
        ' strinput = strinput & oExec.StdOut.Read(1)	
        'Loop
        
        
        strinput = oExec.StdOut.ReadAll
        
        
        durch = False
        schleife = 0
        Do While schleife < 5000
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 1
            schleife = schleife +1
        Loop
        timer4 = Timer
        
        strname = strinput
        strname=Right(strinput,Len(strinput)-InStrRev(strinput,Chr(13),Len(strinput)-2)-1)
        strname = Left(strname,InStr(strname,Chr(13))-1)
        
        'MsgBox oExec.ExitCode & vbtab & timer4-timer3 & vbTab & schleife & vbCrLf  & ">>" & strname
        GetFirstFile=strname
        
        Set oExec = Nothing
    Else
        objWSHShell.LogEvent 1, "Archivierung.vbs: " & programm&"countfiles.exe nicht gefunden"
    End If
    
End Function


Function GetLastFile(folder,mask)
    On Error Resume Next
    
    GetLastFile=""
    
    If fs.FileExists(programm&"countfiles.exe") Then
        Set oExec    = objWSHShell.Exec(programm&"countfiles.exe "& folder & " " & mask & " -ll")
        
        'Do While Not oExec.StdOut.AtEndOfStream
        ' strinput = strinput & oExec.StdOut.Read(1)	
        'Loop
        
        
        strinput = oExec.StdOut.ReadAll
        
        
        durch = False
        schleife = 0
        Do While schleife < 5000
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 1
            schleife = schleife +1
        Loop
        timer4 = Timer
        
        strname = strinput
        strname=Right(strinput,Len(strinput)-InStrRev(strinput,Chr(13),Len(strinput)-2)-1)
        strname = Left(strname,InStr(strname,Chr(13))-1)
        
        
        'MsgBox oExec.ExitCode & vbtab & timer4-timer3 & vbTab & schleife & vbCrLf  & ">>" & strname
        GetLastFile=strname
        
        Set oExec = Nothing
    Else
        objWSHShell.LogEvent 1, "Archivierung.vbs: " & programm&"countfiles.exe nicht gefunden"
    End If
    
End Function



Function CountFiles(folder,mask)
    On Error Resume Next
    
    CountFiles=0
    If fs.FileExists(programm&"countfiles.exe") Then
        Set oExec    = objWSHShell.Exec(programm&"countfiles.exe "& folder & " " & mask)
        
        'Do While Not oExec.StdOut.AtEndOfStream
        ' strinput = strinput & oExec.StdOut.Read(1)	
        'Loop
        
        
        strinput = oExec.StdOut.ReadAll
        
        
        durch = False
        schleife = 0
        Do While schleife < 5000
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 1
            schleife = schleife +1
        Loop
        timer4 = Timer
        
        strname = strinput
        strname = Right(strinput,Len(strinput)-InStrRev(strinput,Chr(13),Len(strinput)-2)-1)
        strname = Left(strname,InStr(strname,Chr(13))-1)
        
        If InStr(strname,"Anzahl:") Then
            strname = Right(strname,Len(strname)-7)
            
            'MsgBox oExec.ExitCode & vbtab & timer4-timer3 & vbTab & schleife & vbCrLf  & ">>" & strname
            CountFiles = Strconvert(strname)
        End If
        
        Set oExec = Nothing
    Else
        objWSHShell.LogEvent 1, "Archivierung.vbs: " & programm&"countfiles.exe nicht gefunden"
    End If
    
End Function


Function IsInArray(strIn, arrCheck)
    bFlag = False
    If IsArray(arrCheck) And Not IsNull(strIn) Then
        Dim i
        For i = 0 To UBound(arrCheck)
            If LCase(arrcheck(i)) = LCase(strIn) Then
                bFlag = True
                Exit For
            End If
        Next
    End If
    IsInArray = bFlag
End Function  
