'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'***************  spooldienst.vbs   GPL  ***************************************************
'*******************************************************************************************
'***************  Version 3.6.2.0        ***************************************************
'*******************************************************************************************
'***************  Programm zum Starten der Druck- und Scanaufgaben           ***************
'***************  auch ohne Benutzerkontext.                                 ***************
'***************                                                             ***************
'***************  wird ber Serviceany (Resoucekit) installiert              ***************
'***************  verbleibt im Speicher und startet das Controllerscript     ***************
'***************  alle paar Minuten                                          ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************


On Error Resume Next


wartesekunden = 53
logging = False

'*******************************************************************************************
'*******************************************************************************************


Set fs  = WScript.CreateObject("Scripting.FileSystemObject") 
Set osh = WScript.CreateObject("WScript.Shell") 
'mypath = osh.ExpandEnvironmentStrings("%bitfarm-archiv%")  
'mypath=regread("HKLM\SOFTWARE\bitfarm\bitfarm-archiv") 
fullpath = WScript.ScriptFullName
scriptname = WScript.ScriptName
mypath = Left(fullpath,Len(fullpath)-Len(scriptname))

'*******************************************************************************************
'**************************  eventlog auf 'Ereignisse berschreiben setzen' ****************
'

strComputer = "."
Set objWMIService = GetObject("winmgmts:" _
& "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")

Set objInstalledLogFiles = objWMIService.ExecQuery _
("Select * from Win32_NTEventLogFile Where LogFilename = 'Application'")

For Each objLogfile In objInstalledLogFiles
    
    If objLogfile.OverWriteOutdated <> 0 Then
        objLogfile.OverWriteOutdated = 0 
        objLogFile.Put_
    End If
    If Err.Number <> 0 Then
        osh.LogEvent 1, "bitfarm-Archiv: Spooldienst: Das Eventlog des Servers ist ungnstig konfiguriert." & vbCrLf& "Bitte die Option 'Eintrge bei Bedarf berschreiben' in den Eigenschaften des Anwendungs-Logs setzen"
        
        Err.Clear
        
    End If
    
Next

Set objLogfile = Nothing
Set objInstalledLogFiles = Nothing
Set objWMIService = Nothing


'*******************************************************************************************



If mypath = "" Then
    osh.LogEvent 1, "Controller: Kein Pfad aufgelst"
    WScript.Quit
End If 



On Error Resume Next

Profil=""
inilesen()


If (Profil="") Or (Profil=" ") Or (Profil="	") Then
    osh.LogEvent 1, "bitfarm-Archiv: Spooldienst: Fehlender Parameter: Profil."
    WScript.Quit
End If

'Set WshEnv = osh.Environment("System")
'WshEnv("bitfarm-archiv") = Mid(mypath,1,Len(mypath)-1)
'WshEnv("dbimp") = 0
'If err.number<>0 Then
'    err.clear
'    osh.LogEvent 1, "bitfarm-Archiv: Spooldienst: Kann Umgebungsvariable nicht setzen."

'    Set WshEnv=nothing
'    WScript.Quit
'End If 
'Set WshEnv=nothing

'WScript.Sleep 500


i=0
Do While i=0
    If logging = True Then
        '	 osh.LogEvent 0, "Spooldienst.vbs: Loop"
    End If
    osh.Run Chr(34)&mypath&"\controler.bat"&Chr(34)&" "&Profil,0, False 
    If Err.number Then
        If logging = True Then
            osh.LogEvent 2, "Spooldienst.vbs: Error1:"&Err.number
        End If
        Err.clear
        On Error Resume Next
        Err.clear
    End If
    
    
    WScript.Sleep wartesekunden*1000
Loop
WScript.Quit

'***************************************************************************************
'***************************************************************************************

Function inilesen()
    On Error Resume Next
    Err.clear
    Set inifile = fs.OpenTextFile(mypath&"scripts.ini",1)
    If Err.number Then
        osh.LogEvent 1, "scripts.ini nicht im Scriptpfad vorhanden oder nicht lesbar."
        Err.clear
        WScript.Quit
    End If 
    
    kette=inifile.readline
    Scriptsflag=InStr(1,kette,"[Scripts]")
    Do While Scriptsflag = 0
        kette=inifile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        If inifile.AtEndOfStream = True Then
            inifile.close
            osh.LogEvent 1, "Fehler beim Lesen der scripts.ini - falsche Formatierung."
            WScript.Quit
        End If
    Loop
    
    
    Do While inifile.AtEndOfStream <> True
        kette=inifile.readline
        If Left(kette,1)<>";" Then
            
            
            
            If InStr(1,kette,"Profil",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"Profil",1)+7)
                Profil=wert
            End If
            
            
        End If
        
    Loop
    inifile.close
    Set inifile = Nothing
    If Profil="" Then
        osh.LogEvent 2, "Fehler beim Lesen der scripts.ini - kein Profil."
        WScript.Quit
    End If
    
    
End Function



'***************************************************************************************
'***************************************************************************************
Private Function GetString(kette,pos)
    On Error Resume Next
    zeichen=""
    ergebnis=""
    index=0
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (zeichen<>"	") And (index<80)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,pos+index,1)
        index=index+1
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=")) And (ergebnis="") Then
            zeichen=""
        End If
    Loop
    Trim(ergebnis)
    GetString=ergebnis
End Function

'**************************************  ENDE  *********************************************
'*******************************************************************************************
