'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'***************  autoscan.vbs     GPL  ****************************************************
'*******************************************************************************************
'***************  Version 3.6.2.0       ****************************************************
'*******************************************************************************************
'***************  Steuerprogramm fr das Einscannen mit autoscanV3.exe       ***************
'***************  bergabe der Parameter als Profilbezeichner                ***************
'***************                                                             ***************
'***************  wird gestartet auf dem Client bei Tastendruck am Scanner   ***************
'***************  oder direkt                                                ***************
'***************                                                             ***************
'***************  Syntax: wscript <server-programmpfad>autoscan.vbs          ***************
'***************  <ArchivTemplate> <Scanprofil> <Filter> <-t:(timeout)>      ***************
'***************  <-j:(Papierstauthreshold)>                                 ***************
'***************  Filter: sind Filter bergeben, werden die Filter           ***************
'***************  des Templates                                              ***************
'***************  berschrieben [barcodemerge, dropscanpdf, Grafikfilter     ***************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************

scriptdebug = False					'schreibt ins %temp%-Verzeichnis ein bfa-scanner.log
autoscandebug = True
cleanup = True
quickimport=False
popupviewer=False
trennzeichen=""



Typ = "OMP"
Druckername = "noprint"
ioreaddeltalimit = 0					' bei diesem Limit wird ein Papierstau erkannt , ggf anpassen  [-j:]
noinputlimit = 0							' timeout wenn vom Scanner keine Daten kommen (Scanner nicht angeschlossen oder Reset notwendig) [-t:] 
' die Werte werden per Parameter bergeben, so knnen pro Arbeitsplatz verschiedene Scanner
' angesteuert werden
' zB i1220		-j:170 , -t:60
' zB i30/i40  -j:1000, -t:40

'*******************************************************************************************
'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

On Error Resume Next

Dim objWSHShell, fso, FileIn, FileOut 
Dim Datei, Text, Txt, i, arrSort, arrTest(), oArgs, Druckername
Dim lngReturnCode

ReDim page(60)
ReDim keybarcode(10)
ReDim barcode(10)

lngReturnCode = 0

Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set fs      = WScript.CreateObject("Scripting.FileSystemObject") 
Set oArgs    = WScript.Arguments 



clientprogramm=""
uncclientspooler="" 
ueberschrift = "bitfarm-Archiv Autoscan"

scannerpagecountinfo=False
dateianzahl=0

For x=0 To 9
    keybarcode(x)=""
    barcode(x)=""
Next

check1=0
check2=0
check3=0
check4=0
counter2=0
oldcheck1=0
oldcheck2=0
noinput = 0

'*******************************************************************************************
'**************************  eventlog auf 'Ereignisse berschreiben setzen' ****************
'

strComputer = "."
Set objWMIService = GetObject("winmgmts:" _
& "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")

Set objInstalledLogFiles = objWMIService.ExecQuery _
("Select * from Win32_NTEventLogFile Where LogFilename = 'Application'")

For Each objLogfile In objInstalledLogFiles
    
    If objLogfile.OverWriteOutdated <> 0 Then
        objLogfile.OverWriteOutdated = 0 
        objLogFile.Put_
    End If
    If Err.Number <> 0 Then
        objWSHShell.LogEvent 1, "Achtung ! Im Eventlog des Clients ist nicht die Option 'Eintrge bei Bedarf berschreiben' gesetzt. Logging und Scriptdebug werden daher ausgeschaltet." 
        scriptdebug = False
        logging = False
        Err.Clear
        On Error Resume Next
    End If
    
Next

Set objLogfile = Nothing
Set objInstalledLogFiles = Nothing
Set objWMIService = Nothing



'*******************************************************************************************
'**************************  Startparameter initialisieren  ********************************
Err.clear
fullpath = WScript.ScriptFullName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
scriptname = WScript.ScriptName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
If Len(programm)=0 Then
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If

templates = programm & "templates\"




'*******************************************************************************************
'*******************************************************************************************
'*************************************************************************************
'**************************   Parameterbergabe **************************************
'************************************************************************************* 
Template = ""
Template = oArgs.item(0) 
If Err.number<>0 Then
    MsgBox("bitfarm-Archiv: Fehlende Parameter beim Aufruf. Syntax: autoscan.vbs <Archiv> <Scanprofil>")
    Err.clear
    WScript.Quit
End If 

If Template="" Then
    MsgBox("bitfarm-Archiv: Fehlende Parameter beim Aufruf. Syntax: autoscan.vbs <Archiv> <Scanprofil>")
    Err.clear
    WScript.Quit
End If 

ScanProfil = oArgs.item(1) 
If Err.number<>0 Then
    ScanProfil=Archiv
    Err.clear
End If 

If ScanProfil="" Then
    ScanProfil=Archiv
    Err.clear
End If 

mask=""
barcodetype=""
noinputlimit = 0
ioreaddeltalimit = 0
useowntemp = False

If oArgs.Count =>2 Then
    
    For i = 2 To oArgs.count-1
        
        If InStr(1,LCase(oArgs.Item(i)),"-t:") <> 0  Or InStr(1,LCase(oArgs.Item(i)),"-j:") <> 0 Or oArgs.Item(i) = "barcodemerge" Or oArgs.Item(i)= "mergebarcodes"  Or oArgs.Item(i)= "useowntemp" Then
            If oArgs.Item(i)= "barcodemerge" Or oArgs.Item(i)= "mergebarcodes" Then
                'mask="mergebarcodes"
                'barcodetype=oArgs.Item(i)		
                filtermakro = oArgs.Item(i)
            End If
            
            If InStr(1,LCase(oArgs.Item(i)),"-t:") <> 0 Then
                noinputlimit = Round(Right(oArgs.Item(i),Len(oArgs.Item(i))-3))
            End If
             
            If InStr(1,LCase(oArgs.Item(i)),"-j:") <> 0 Then
                ioreaddeltalimit = Round(Right(oArgs.Item(i),Len(oArgs.Item(i))-3))			
            End If
            
            If InStr(1,LCase(oArgs.Item(i)),"useowntemp") <> 0 Then
                useowntemp=True			
            End If
        Else
            filtermakro = oArgs.Item(i)
        End If
    Next 
    
End If

'If mask="mergebarcodes" Then
'	filtermakro="barcodemerge"
'End If

If InStr(1,filtermakro,"mergebarcodes") <> 0 Then
    filtermakro = Replace(filtermakro,"mergebarcodes","barcodemerge")
End If


'MsgBox "Autoscan.vbs: Parameter " & vbcrlf & "template=" & template & vbCrlf& "Scanprofil=" & scanprofil & vbcrlf & "Filtermakro=" & Filtermakro & vbcrlf & "barcodetype=" & barcodetype&vbcrlf&"noinputlimit="&noinputlimit&vbCrlF&"ioreaddeltlimit=" & ioreaddeltalimit&vbcrlf&"username="& username&vbcrlf&"temppath=" &temppath &vbcrlf&"systemroot=" & systemroot


Tabelle = Archiv



'*******************************************************************************************
'*******************************************************************************************

inilesen()

'*******************************************************************************************
'******************************************************************************************* 


Err.clear
'On Error Resume Next 


'*******************************************************************************************
'******************************************************************************************* 



username = objWSHShell.ExpandEnvironmentStrings("%username%")    

If Err.number<>0 Then
    MsgBox("Fehler: Kann Benutzername nicht auswerten.")
    Err.clear
    WScript.Quit
End If 

If (Len(username)<1) Or (username="%username%") Or (username="") Then
    username="unbekannt"
End If

vistaflag=False
publicpath=""
publicpath = objWSHShell.ExpandEnvironmentStrings("%localappdata%")    
If Err.number<>0 Then
    Err.clear
    On Error Resume Next
End If
If (publicpath<>"") And (publicpath<>"%localappdata%") Then
    vistaflag=True
End If
'MsgBox(publicpath)

temppath = objWSHShell.ExpandEnvironmentStrings("%temp%")    
If Err.number<>0 Then
    MsgBox("Fehler: Kann Tempverzeichnis nicht auswerten.")
    Err.clear
    WScript.Quit
End If 

If vistaflag=True  Then
    temppath=publicpath&"\temp"
End If  

systemroot = objWSHShell.ExpandEnvironmentStrings("%systemroot%")    
If Err.number<>0 Then
    MsgBox("Fehler: Kann Systemrootverzeichnis nicht auswerten.")
    Err.clear
    WScript.Quit
End If 
systemtemp=systemroot&"\TEMP"
testspace

Profil=""

erfolg=readtemplate(template)
If erfolg=False Then
    MsgBox("bitfarm-Archiv: Kann zum angegebenen Archiv kein Template finden ("&template&")")
    WScript.Quit
End If

erfolg=readconfig(Profil)
If erfolg=False Then
    MsgBox("bitfarm-Archiv: Kann Konfigurationsdatei nicht lesen ("&Profil&")")
    WScript.Quit
End If

druckpfad = uncclientspooler 


dokdate=setdokdate()

If scriptdebug = True Then
    objWshShell.LogEvent 4,"Autoscan.vbs: Parameter " & vbCrLf & "template=" & template & vbCrLf& "Scanprofil=" & scanprofil & vbCrLf & "Filtermakro=" & Filtermakro & vbCrLf & "barcodetype=" & barcodetype&vbCrLf&"noinputlimit="&noinputlimit&vbCrLf&"ioreaddeltlimit=" & ioreaddeltalimit&vbCrLf&"username="& username&vbCrLf&"temppath=" &temppath &vbCrLf&"systemroot=" & systemroot
End If



'**************************************************************************************************
'******************************************   auf hngenen Job prfen   ***************************
'**************************************************************************************************

hangjob=False
lockdatei=temppath&"\scanlock"


msgtrigger=False

If fs.fileexists(lockdatei) Then
    hangjob=True
End If




Err.clear
Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
If Err.number<>0 Then
    MsgBox("bitfarm-Archiv Scan: Fehler: kein WMI installiert. Bitte nachinstallieren.")
    WScript.quit
End If			
strQuery = "Select * from Win32_Process where Name='AutoScanV3.exe'"
Set colItems = objWMIService.ExecQuery(strQuery,,48)
z=0
For Each objItem In colItems
    
    z=z+1	
Next
If z=>1 Then
    hangjob=True
End If
Set colItems = Nothing
Set objWMIService = Nothing

If scriptdebug = True Then
    objWshShell.LogEvent 4,"Autoscan.vbs: Hangjob =" & hangjob
End If

If hangjob=True Then
    frage = "Ein vorheriger Scanvorgang ist noch aktiv oder er wurde nicht korrekt ausgefhrt (z.B. wegen Papierstau)."&vbCrLf&vbCrLf&"Soll der vorherige Scan jetzt abgebrochen und ein neuer Vorgang gestartet werden?" & vbCrLf & vbTab &"(der vorherige Scan wird komplett verworfen !)"
    ueberschrift = "bitfarm-Archiv AutoScan"
    antwort = objWSHShell.Popup(frage,, ueberschrift, vbExclamation + vbYesNo)
    abgebrochen=False
    If antwort = vbNo Then
        WScript.Quit
    End If
    
    killscanjob
    
    
End If




'*************************************************************************************************
'************************************** Lock setzen **********************************************
'*************************************************************************************************
Err.clear
If Not fs.FileExists(lockdatei) Then
    Set lockfile = fs.CreateTextFile(lockdatei,True)
    lockfile.Writeline("lock")
    lockfile.close
    
    Set lockfile = Nothing
    
    If Err.number<>0 Then
        MsgBox("bitfarm-Archiv Scan: Fehler: Kann kein lockfile erstellen.")
        Err.clear
        Unlock(programm&lockdatei)
        WScript.Quit
    End If 
End If

transfermode="Server"
Err.clear
zahl = Zufallszahl(100000,999999)


'*********************************************************************************************
'************************************* prfen auf alten Job **********************************
'*********************************************************************************************

If (Transfermode="Server") And (vistaflag=False) Then
    
    flag=False
    i=0
    Set folder = fs.GetFolder(systemtemp)
    For Each unterordner In folder.subfolders
        If Err.number = 0 Then
            If Right(unterordner.name,16)="Zwischenspeicher" Then
                flag=True
            End If
        End If
    Next
    
    If flag=True Then
        frage = "Es sind noch Scandaten im Zwischenspeicher und der Archivserver ist jetzt zur Archivierung bereit. Sollen diese Daten jetzt zum Server gesendet werden?"&vbCrLf&vbCrLf&"Wenn Sie JA drcken, werden die Daten an den Server gesendet. Bitte warten Sie in diesem Falle auf eine Meldung zur Fertigstellung, bevor Sie weitere Scanjobs starten."&vbCrLf&"Wenn Sie NEIN whlen, wird das Einscannen gestartet. Sie erhalten beim nchsten mal wieder die Mglichkeit, die Daten aus dem Zwischenspeicher an den Server zu senden."
        ueberschrift = "bitfarm-Archiv Scanmodul"
        antwort = objWSHShell.Popup(frage,, ueberschrift, vbQuestion + vbYesNo)
        abgebrochen=False
    End If
    
    If (antwort=VByes) And (flag=True) Then
        quickimport=False	
        For Each unterordner In folder.subfolders
            If Right(unterordner.name,16)="Zwischenspeicher" Then	
                mypath=unterordner
                sendtoserver(mypath)
                
            End If
        Next
        frage = "Alle Scandaten wurden aus dem Zwischenspeicher an den Server zur Archivierung gesendet. Ggf. kontrollieren Sie nach einigen Minuten nach, ob die Dokumente im Archiv angekommen sind. Sie knnen jetzt wie gewohnt weiterarbeiten und neue Dokumente einscannen."
        ueberschrift = "bitfarm-Archiv Scanmodul"
        antwort = objWSHShell.Popup(frage,, ueberschrift, vbInformation + vbOKOnly)
        abgebrochen=False
        WScript.Quit
    End If
End If




'**************************************************************************************************
'******************************************   Verzeichnis setzen   *******************************
'**************************************************************************************************

mypath=""
setpath


'**************************************************************************************************
'******************************************   Scannen   *******************************************
'**************************************************************************************************



'Beginn = Timer


msgtrigger=True

timeout = 6000						'mu grtmglichen Scanvolumen angepasst werden

params = Chr(34) &templates&template&".TPL"&Chr(34)&" "&Chr(34)&scanprofil& Chr(34) 
If useowntemp=True Then
	params = params & " -D:" &mypath
End If 

If scannerpagecountinfo Then
	params = params & " pageinfo"
	scannerpagecountinfo = False
End If 
If autoscandebug Then
	params = params & " -debug"
End If


If scriptdebug = True Then
    objWshShell.LogEvent 4, "Autoscan.vbs: Autoscan-Aufruf" & vbCrLf & programm&"autoscanv3.exe "& params
End If

Set oExec = objWSHShell.Exec(Chr(34) & programm&"autoscanv3.exe"&Chr(34)&" "& params)

scanpid = oExec.ProcessID
'MsgBox scanpid
'On Error Resume Next

'hierber lt sich eine timeout routine fr diesen konkreten autoscanv3.exe aufruf realisieren
erfolg = False
durch = False
If scriptdebug = True Then
    Set mydebugfile = fs.OpenTextFile(temppath & "\bfa-scanner.log",8,True)
End If

Do While erfolg = False
    schleife = 0
    Do While schleife < timeout		
        If oExec.Status = 1 Then 
            durch = True
            Exit Do
        End If
        
        If ioreaddeltalimit <> 0 Or noinputlimit <> 0 Then 
            checkscanner
        Else
            WScript.Sleep 100
        End If
        
        'WScript.Sleep 100  
        schleife = schleife +1
    Loop
    'Ende = Timer
    'objWshShell.LogEvent 1, "Versuche:" & schleife
    
    
    If durch = True Then
        objWshShell.LogEvent 4," Autoscan erfolgreich durchgefhrt" & vbCrLf & "oExec.Status = " & oExec.Status & " schleife = " & schleife & vbCrLf & "PorzessID = " & scanpid
        erfolg = True
    Else
        objWshShell.LogEvent 1, "Timeout bei AutoscanV3.exe ("& timeout/600 & "min. Scanjob abgebrochen ? " & vbCrLf & " oExec.Status = " & oExec.Status & " schleife = " & schleife & vbCrLf & "PorzessID = " & scanpid
        frage = "Timeout beim Scanvorgang ("& timeout/600 & "min). Soll der aktuelle Scanvorgang abgebrochen werden ? " & vbCrLf & "(bei laufendem Scanvorgang zum Fortsetzen bitte 'Nein' drcken)."
        ueberschrift = "bitfarm-Archiv AutoScan"
        removemsg
        antwort = objWSHShell.Popup(frage,, ueberschrift, vbExclamation + vbYesNo)
        If antwort = vbYes Then
            killscanjob
            erfolg = False
            WScript.Quit
        End If
        showmsg
        timeout = 3000
    End If
    
Loop

If scriptdebug = True Then
    mydebugfile.close
    Set mydebugfile=Nothing
End If

'If not fs.fileexists(lockdatei) Then
'	
'	wscript.quit
'End If


'Fehlerbehandlung
If oExec.ExitCode <> 0 Then
	removemsg
	Select Case oExec.ExitCode
		Case 1 ret = MsgBox ("Fehler: Nicht gengend Parameter angegeben!", 16, "Autoscan")
		Case 2 ret = MsgBox ("Fehler: Unbekannter Parameter", 16, "Autoscan")
		Case 3 ret = MsgBox ("Fehler: Angegebenes Profil nicht gefunden", 16, "Autoscan")
		Case 4 ret = MsgBox ("Fehler: Angegebener Scanner nicht gefunden", 16, "Autoscan")
		Case 5 ret = MsgBox ("Fehler: Es ist ein Fehler beim Scannen aufgetreten", 16, "Autoscan")
		Case 6 ret = MsgBox ("Fehler: Unerwarteter Fehler beim Speichern", 16, "Autoscan")
		Case 7 ret = MsgBox ("Fehler: Keine Seite gescannt", 16, "Autoscan")
		Case 8 ret = MsgBox ("Fehler: Keine Seite gescannt, bzw. nur leere Seiten.", 16, "Autoscan")
		Case 9 ret = 9
		Case Else ret = MsgBox ("Fehler: Unbekannetr Fehler", 16, "Autoscan")
	End Select
	
	Unlock(lockdatei)
	WScript.Quit
End If




'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************

'MsgBox("scannen beendet:"&mypath)

showmsg

WScript.Sleep 500
gatherfiles(mypath)
WScript.Sleep 500

If Transfermode="Server" Then
    
    sendtoserver(mypath)
    removemsg
    If (dateianzahl=1) And (popupviewer=True) Then
        
        'checkfeedback
        lngReturnCode = objWSHShell.Run(programm&"checkfeedback.vbs "& zahl,1,False)
    End If
End If


Set folder = fs.GetFolder(temppath)
For Each tempfile In folder.files
    If LCase(fs.GetExtensionName(tempfile)) = "job" Then
        fs.deletefile tempfile, True
    End If
    
Next


If scriptdebug = True Then
    objWshShell.LogEvent 4, "Autoscan.vbs: Regulrer Programmausstieg.  PID=" & scanpid
End If

removemsg

WScript.Quit


'******************************************  Funktionen  *************************************

'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function setpath
    On Error Resume Next
    If Transfermode="Server" Then
        dokdate=setdokdate()
        zahl = Zufallszahl(10000,99999)
        If Err.number<>0 Then
            'MsgBox("error gesetzt")
            Err.clear
            On Error Resume Next
        End If
        mypath=temppath&"\bfa-scan"&zahl
        'MsgBox(mypath)
        If Not fs.folderexists(mypath) Then
            fs.createfolder(mypath)
            If Err.number <>0 Then
                frage = "Kann im TEMP-Ordner des Benutzers keinen Unterordner erstellen -> Abbruch."
                antwort = objWSHShell.Popup(frage,, ueberschrift, vbQuestion + vbOKOnly)
                objWshShell.LogEvent 1,"Kann im TEMP-Ordner des Benutzers keinen Unterordner erstellen -> Abbruch."
                Err.clear
                WScript.Quit
            End If
        Else
            zahl = Zufallszahl(10000,99999)
            
            mypath=temppath&"\bfa-scan"&zahl
            If Not fs.folderexists(mypath) Then
                fs.createfolder(mypath)
                If Err.number <>0 Then
                    frage = "Kann im TEMP-Ordner des Benutzers keinen Unterordner erstellen -> Abbruch."
                    antwort = objWSHShell.Popup(frage,, ueberschrift, vbQuestion + vbOKOnly)
                    objWshShell.LogEvent 1,"Kann im TEMP-Ordner des Benutzers keinen Unterordner erstellen -> Abbruch."
                    Err.clear
                    WScript.Quit
                End If
            Else
                frage = "Fehler: Verzeichnis existiert schon!"
                antwort = objWSHShell.Popup(frage,, ueberschrift, vbQuestion + vbOKOnly)
                objWshShell.LogEvent 2,"Fehler: Verzeichnis existiert schon!"
                
            End If
        End If
    End If
    
    If Transfermode="Local" Then
        dokdate=setdokdate()
        zahl = Zufallszahl(10000,99999)
        
        mypath=systemtemp&"\bfa-scan"&zahl&"Zwischenspeicher"
        If Not fs.folderexists(mypath) Then
            fs.createfolder(mypath)
            If Err.number <>0 Then
                frage="Kann im System-TEMP-Ordner keinen Unterordner erstellen 2-> Abbruch."
                antwort = objWSHShell.Popup(frage,, ueberschrift, vbQuestion + vbOKOnly)
                objWshShell.LogEvent 1,"Kann im System-TEMP-Ordner keinen Unterordner erstellen 2-> Abbruch."
                Err.clear
                WScript.Quit
            End If
        Else
            zahl = Zufallszahl(10000,99999)
            
            mypath=systemtemp&"\bfa-scan"&zahl&"Zwischenspeicher"
            If Not fs.folderexists(mypath) Then
                fs.createfolder(mypath)
                If Err.number <>0 Then
                    frage = "Kann im System-TEMP-Ordner keinen Unterordner erstellen 3-> Abbruch."
                    antwort = objWSHShell.Popup(frage,, ueberschrift, vbQuestion + vbOKOnly)
                    objWshShell.LogEvent 1,"Kann im System-TEMP-Ordner keinen Unterordner erstellen 3-> Abbruch."
                    Err.clear
                    WScript.Quit
                End If
            Else
                frage = "Fehler: Verzeichniss existiert schon! 2"
                antwort = objWSHShell.Popup(frage,, ueberschrift, vbQuestion + vbOKOnly)
                objWshShell.LogEvent 2,"Fehler: Verzeichniss existiert schon! 2"
            End If
        End If
    End If
    
End Function




Function gatherfiles(mypath)
    On Error Resume Next
    mergemode=False
    If mask<>"" Then
        mergemode=True
    End If
    
    '********************************** hier ggf. auskommentieren **************************
    '***************************************************************************************
    mergemode=False
    '***************************************************************************************
    '***************************************************************************************
    'MsgBox("mypath:"&mypath)    
    If scriptdebug=True Then
    	objWSHShell.LogEvent 1, "Autoscan.vbs: mypath bei beginn von gatherfiles:" & vbCrLf & mypath &vbCrLf & "temppath: " & temppath
    End If
    If useowntemp=True Then
    	temppath = mypath
    End If
    
    If scriptdebug=True Then
    	objWSHShell.LogEvent 1, "Autoscan.vbs: temppath neu bei useowntemp:" & vbCrLf & temppath
    End If
    
    If mergemode=False Then
        
        i=0
        Set folder = fs.GetFolder(temppath)
        'objWshShell.LogEvent 1, temppath
        'MsgBox("temppath:"&temppath)
        For Each file In folder.files
            
            If LCase(Right(file,3)) = "tif" Then
                'MsgBox("gefunden!"&file)
                mydocnumber=file.name
                mydocnumber=Left(mydocnumber,Len(mydocnumber)-4)
                
                If useowntemp=False Then
                	fs.copyfile file, mypath&"\"&file.name, True
                	If cleanup = True Then
	                    fs.deletefile file, True
                	End If
                End If
                
                'MsgBox(temppath&"\"&mydocnumber&".job")
                
                If fs.fileexists(temppath&"\"&mydocnumber&".job") Then
                	If scriptdebug=True Then
				    	objWSHShell.LogEvent 1, "Autoscan.vbs: Jobfile gefunden:" & vbCrLf & temppath&"\"&mydocnumber&".job"
				    End If
                    
                    erfolg=readjob(temppath&"\"&mydocnumber)
                    If erfolg=False Then
                        frage = "bitfarm-Archiv: kann Jobfile nicht lesen. Kann nicht archivieren. Bitte wenden Sie sich an den Administrator."
                        antwort = objWSHShell.Popup(frage,, ueberschrift, vbQuestion + vbOKOnly)
                        objWshShell.LogEvent 1,"Autoscan.vbs: kann Jobfile nicht lesen. Kann nicht archivieren. Bitte wenden Sie sich an den Administrator."
                        WScript.Quit
                    End If
                    erfolg=writejob(temppath&"\"&mydocnumber, temppath&"\"&mydocnumber)
                    If erfolg=False Then
                        frage = "bitfarm-Archiv: kann Jobfile nicht schreiben. Kann nicht archivieren. Bitte wenden Sie sich an den Administrator."
                        antwort = objWSHShell.Popup(frage,, ueberschrift, vbQuestion + vbOKOnly)
                        objWshShell.LogEvent 1,"Autoscan.vbs: kann Jobfile nicht schreiben. Kann nicht archivieren. Bitte wenden Sie sich an den Administrator."
                        WScript.Quit
                    End If
                    
                    
                    If useowntemp=False Then
                    	fs.copyfile temppath&"\"&mydocnumber&".job", mypath&"\"&mydocnumber&".job"
                    	
                    	If scriptdebug=True Then
                    		objWSHShell.LogEvent 1, "Autoscan: Quelljob: " & temppath&"\"&mydocnumber&".job" &vbCrLf & "Zieljob: " & mypath&"\"&mydocnumber&".job"
                    	End If
                    	
                    	If cleanup = True Then
	                        fs.deletefile temppath&"\"&mydocnumber&".job"
                    	End If
                    End If
                Else
                	objWSHShell.LogEvent 1, "Autoscan.vbs: Jobfile nicht gefunden:" & vbCrLf & temppath&"\"&mydocnumber&".job"    
                End If
                If useowntemp=False Then
	                If fs.fileexists(temppath&"\"&mydocnumber&".ocr") Then
	                    fs.copyfile temppath&"\"&mydocnumber&".ocr", mypath&"\"&mydocnumber&".ocr"
	                    fs.deletefile temppath&"\"&mydocnumber&".ocr"
	                End If
	                If fs.fileexists(temppath&"\"&mydocnumber&".vtx") Then
	                    fs.copyfile temppath&"\"&mydocnumber&".vtx", mypath&"\"&mydocnumber&".ftx"
	                    fs.deletefile temppath&"\"&mydocnumber&".vtx"
	                End If
	                
	                If fs.fileexists(temppath&"\"&mydocnumber&".slw") Then
	                    fs.copyfile temppath&"\"&mydocnumber&".slw", mypath&"\"&mydocnumber&".slw"
	                    fs.deletefile temppath&"\"&mydocnumber&".slw"
	                End If
				End If	
				If Not fs.fileexists(mypath&"\"&mydocnumber&".slw") Then
	               	Set slwfile = fs.CreateTextFile(mypath&"\"&mydocnumber&".slw")
	               	slwfile.Close
					Set slwfile = Nothing
	            End If           
            End If
        Next
    Else
        i=0
        kette=""
        keyfile=""
        'barcode=""
        x=0
        For x=0 To 60
            page(x)=""
        Next
        
        Set folder = fs.GetFolder(temppath)
        
        For Each file In folder.files
            gefunden=False
            If LCase(Right(file,3)) = "tif" Then
                mydocnumber=file.name
                mydocnumber=Left(mydocnumber,Len(mydocnumber)-4)
                If mydocnumber<>"TRENNCODE" Then
                    kette=kette&mydocnumber&vbCrLf
                    'lngReturnCode = objWSHShell.Run(programm&"cutterv3.exe "&temppath&"\"&mydocnumber&".tif "&mask,0,true)
                    'If lngReturnCode <> 0 Then
                    '	MsgBox("bitfarm-Archiv Scan: Fehler bei der Barcodeextraktion, bitte scannen Sie erneut oder benachrichtigen Sie den Administrator.")
                    'End If
                    'wscript.sleep 20
                    'If fs.fileexists(temppath&"\TRENNCODE.TIF") Then
                    
                    lngReturnCode = objWSHShell.Run(programm&"rdtifbar.exe "&temppath&"\"&file.name,0,True)
                    WScript.sleep 50
                    'fs.deletefile temppath&"\TRENNCODE.TIF", true
                End If
                WScript.sleep 20
                
                If fs.fileexists(temppath&"\"&mydocnumber&".bar") Then
                    i=0
                    Set barcodedatei = fs.OpenTextFile(temppath&"\"&mydocnumber&".bar",1)
                    If barcodedatei.AtEndOfStream <> True Then
                        barcode(i)=barcodedatei.readline
                        i=i+1
                    End If
                    barcodedatei.close
                    Set barcodedatei=Nothing
                    WScript.sleep 20
                    fs.deletefile temppath&"\"&mydocnumber&".bar", True
                    gefunden=False
                    For y=0 To 9
                        For z=0 To 9
                            If keybarcode(z)<>"" Then
                                If barcode(y)<>"" Then
                                    If Len(barcode(y))>=Len(keybarcode(z)) Then
                                        If LCase(Left(barcode(y),Len(keybarcode(z))))=LCase(keybarcode(z)) Then
                                            gefunden=True	
                                            'MsgBox("gefunden!")		
                                        End If
                                    End If
                                End If
                            End If
                        Next
                    Next
                End If
                
                If gefunden=True Then
                    '####################### neue Keypage gefunden - zuerst die alten Dateien RCKWRTS (splitter-problem) zusammenfassen #############
                    t=59
                    Do While t<>0
                        If (page(t)<>"") And (page(t+1)<>"") Then
                            lngReturnCode = objWSHShell.Run(programm&"splitterv3.exe -m "&temppath&"\"&page(t+1)&".TIF "&temppath&"\"&page(t)&".TIF",0,True)
                            WScript.sleep 30				
                            If lngreturncode=0 Then
                                fs.deletefile temppath&"\"&page(t)&".TIF", True
                                fs.copyfile temppath&"\"&page(t+1)&".TIF", temppath&"\"&page(t)&".TIF", True
                                fs.deletefile temppath&"\"&page(t+1)&".TIF", True
                                If fs.fileexists(temppath&"\"&page(t+1)&".job") Then
                                    fs.deletefile temppath&"\"&page(t+1)&".job", True
                                End If
                            End If
                            'MsgBox("gepackt: "&t)
                        End If
                        t=t-1
                    Loop
                    
                    '####################### jetzt die neue Sektion anfangen ###################
                    keyfile=mydocnumber
                    For x=0 To 60
                        page(x)=""
                    Next
                    x=2
                    page(1)=mydocnumber
                    
                    keyfile=mydocnumber
                    erfolg=writejob(temppath&"\"&mydocnumber, temppath&"\"&mydocnumber)	
                End If
                
                If keyfile<>"" Then
                    If keyfile<>mydocnumber Then
                        page(x)=mydocnumber
                        x=x+1
                        'lngReturnCode = objWSHShell.Run(programm&"splitterv3.exe -m "&temppath&"\"&keyfile&".TIF "&temppath&"\"&mydocnumber&".TIF",0,true)
                    End If
                End If
            End If
        Next
        Set folder=Nothing
        
        '####################### Endlauf fr die letzten Dokumentenseiten #############
        t=59
        Do While t<>0
            If (page(t)<>"") And (page(t+1)<>"") Then
                lngReturnCode = objWSHShell.Run(programm&"splitterv3.exe -m "&temppath&"\"&page(t+1)&".TIF "&temppath&"\"&page(t)&".TIF",0,True)
                
                If lngreturncode=0 Then
                    fs.deletefile temppath&"\"&page(t)&".TIF", True
                    fs.copyfile temppath&"\"&page(t+1)&".TIF", temppath&"\"&page(t)&".TIF", True
                    fs.deletefile temppath&"\"&page(t+1)&".TIF", True
                    If fs.fileexists(temppath&"\"&page(t+1)&".job") Then
                        fs.deletefile temppath&"\"&page(t+1)&".job", True
                    End If
                End If
                'MsgBox("gepackt: "&t)
            End If
            t=t-1
        Loop
        
        i=0
        Set folder = fs.GetFolder(temppath)
        For Each file In folder.files
            If LCase(Right(file,3)) = "tif"Then
                mydocnumber=file.name
                mydocnumber=Left(mydocnumber,Len(mydocnumber)-4)
                If useowntemp=True Then
                	fs.copyfile file, mypath&"\"&file.name, True
                	fs.deletefile file, True
                End If
                
                'MsgBox(temppath&"\"&mydocnumber&".job")
                
                If fs.fileexists(temppath&"\"&mydocnumber&".job") Then
                    erfolg=readjob(temppath&"\"&mydocnumber)
                    If erfolg=False Then
                        MsgBox("bitfarm-Archiv: kann Jobfile nicht lesen. Kann nicht archivieren. Bitte wenden Sie sich an den Administrator.")
                        objWshShell.LogEvent 1,"Autoscan.vbs: kann Jobfile nicht lesen. Kann nicht archivieren. Bitte wenden Sie sich an den Administrator."
                        WScript.Quit
                    End If
                    erfolg=writejob(temppath&"\"&mydocnumber, temppath&"\"&mydocnumber)
                    If erfolg=False Then
                        MsgBox("bitfarm-Archiv: kann Jobfile nicht schreiben. Kann nicht archivieren. Bitte wenden Sie sich an den Administrator.")
                        objWshShell.LogEvent 1,"Autoscan.vbs: kann Jobfile nicht schreiben. Kann nicht archivieren. Bitte wenden Sie sich an den Administrator."
                        WScript.Quit
                    End If
                    If useowntemp=True Then
                    	fs.copyfile temppath&"\"&mydocnumber&".job", mypath&"\"&mydocnumber&".job"
                    	fs.deletefile temppath&"\"&mydocnumber&".job"
                    End If
                End If
                If useowntemp=True Then
                	If fs.fileexists(temppath&"\"&mydocnumber&".ocr") Then
	                    fs.copyfile temppath&"\"&mydocnumber&".ocr", mypath&"\"&mydocnumber&".ocr"
                    	fs.deletefile temppath&"\"&mydocnumber&".ocr"
                	End If
                	If fs.fileexists(temppath&"\"&mydocnumber&".vtx") Then
	                    fs.copyfile temppath&"\"&mydocnumber&".vtx", mypath&"\"&mydocnumber&".ftx"
                    	fs.deletefile temppath&"\"&mydocnumber&".vtx"
                	End If
                	If fs.fileexists(temppath&"\"&mydocnumber&".slw") Then
	                    fs.copyfile temppath&"\"&mydocnumber&".slw", mypath&"\"&mydocnumber&".slw"
                    	fs.deletefile temppath&"\"&mydocnumber&".slw"
                	End If
                End If
            End If
        Next
    End If
    
End Function



Function sendtoserver(mypath)
    On Error Resume Next
    If scriptdebug = True Then
        objWshShell.LogEvent 0,"Autoscan.vbs: sendtoserver(" & mypath & ")"
    End If
    
    i=0
    Set folder = fs.GetFolder(mypath)
    For Each file In folder.files
        
        If LCase(Right(file,3)) = "tif" Then
            If msgtrigger=False Then
                msgtrigger=True
                showmsg
            End If
            
            'i=i+1
            seiten=0
            If scannerpagecountinfo=True Then
            	seiten = countpages(file)
            End If
            i=i+seiten
            
            zahl = Zufallszahl(100000,999999)
            docfile=file.name
            docfile=Left(docfile,Len(docfile)-4)
            If quickimport=True Then
                docfile2="fast"&docfile
            Else
                docfile2="file"&docfile
            End If
            
            Profil=""
            uncclientspooler=""
            Typ="OMP"
            WScript.Sleep 50
            If fs.fileexists(mypath&"\"&docfile&".job") Then
                erfolg=readjob(mypath&"\"&docfile)
                If erfolg=False Then
                    removemsg
                    frage="bitfarm-Archiv: kann Jobfile nicht lesen. Kann nicht archivieren. Bitte wenden Sie sich an den Administrator."
                    antwort = objWSHShell.Popup(frage,, ueberschrift, vbQuestion + vbOKOnly)
                    objWshShell.LogEvent 1,"Autoscan.vbs: kann Jobfile nicht lesen. Kann nicht archivieren. Bitte wenden Sie sich an den Administrator. 2"
                    killscanjob
                    WScript.Quit
                End If
                
            Else
                WScript.sleep 200
                If fs.fileexists(mypath&"\"&docfile&".job") Then
                    erfolg=readjob(mypath&"\"&docfile)
                    If erfolg=False Then
                        removemsg
                        frage = "bitfarm-Archiv: kann Jobfile nicht lesen. Kann nicht archivieren. Bitte wenden Sie sich an den Administrator."
                        antwort = objWSHShell.Popup(frage,, ueberschrift, vbQuestion + vbOKOnly)
                        objWshShell.LogEvent 1,"Autoscan.vbs: kann Jobfile nicht lesen. Kann nicht archivieren. Bitte wenden Sie sich an den Administrator. 3"
                        killscanjob
                        WScript.Quit
                    End If
                Else 	
                    removemsg
                    frage = "bitfarm-Archiv: keine Anweisungen zum Archivieren gefunden. Dokument(e) wurde nicht archiviert. Wenden Sie sich an den Administrator."
                    antwort = objWSHShell.Popup(frage,, ueberschrift, vbQuestion + vbOKOnly)
                    objWshShell.LogEvent 1,"Autoscan.vbs: keine Anweisungen zum Archivieren gefunden. Dokument(e) wurde nicht archiviert. Wenden Sie sich an den Administrator."&vbCrLf&mypath&"\"&docfile&".job"
                    killscanjob
                    WScript.Quit
                End If
            End If
            druckpfad=""
            erfolg=readconfig(Profil)
            druckpfad=uncclientspooler
            If erfolg=False Then
                removemsg
                frage = "bitfarm-Archiv: kann Profildatei nicht lesen ("&Profil&"). Bitte wenden Sie sich an den Administrator."
                antwort = objWSHShell.Popup(frage,, ueberschrift, vbQuestion + vbOKOnly)
                objWshShell.LogEvent 1,"Autoscan.vbs: kann Profildatei nicht lesen ("&Profil&"). Bitte wenden Sie sich an den Administrator."
                killscanjob
                WScript.Quit
            End If
            
            zahl = Zufallszahl(100000,999999)
            Ausgabename =  druckpfad&docfile2&".tif"
            
            '	If fs.FileExists(Ausgabename) Then
            '		WScript.sleep 1500
            '	End If
            '	If fs.FileExists(Ausgabename) Then
            '		WScript.sleep 1500
            '	End If
            '	If fs.FileExists(Ausgabename) Then
            '		WScript.sleep 1500
            '	End If
            '	If fs.FileExists(Ausgabename) Then
            '		WScript.sleep 1500
            '	End If
            '	If fs.FileExists(Ausgabename) Then
            '		WScript.sleep 1500
            '	End If
            '	If fs.FileExists(Ausgabename) Then
            '		WScript.sleep 1500
            '	End If
            '	If fs.FileExists(Ausgabename) Then
            '		MsgBox("bitfarm-Archiv: Fehler: Serverdienst reagiert nicht. Die Dokumente konnten nicht archiviert werden. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
            '		WScript.Quit
            '	End If
            '	
            
            Err.clear
            
            If fs.fileexists(mypath&"\"&docfile&".job") Then
                fs.CopyFile mypath&"\"&docfile&".job", druckpfad&docfile2&".job", True
                If Err.number<>0 Then
                    Err.clear
                    frage = "bitfarm-Archiv: Fehler bei bergabe der Scandaten an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support."
                    antwort = objWSHShell.Popup(frage,, ueberschrift, vbQuestion + vbOKOnly)
                    objWshShell.LogEvent 1,"Autoscan.vbs: Fehler bei bergabe der Scandaten an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support."
                    removemsg
                    killscanjob
                    WScript.Quit
                End If
            Else
                
                frage = "bitfarm-Archiv Hinweis: Zu dem Scanjob wurden keine weiteren Informationen gefunden. Das Dokument wird dennoch archiviert. Es wird in das Standard-unsortiert Archiv eingelagert und kann von dort an seinen richtigen Ort verschoben werden. Sollte dies hufiger vorkommen, unterrichten Sie bitte den Administrator."
                antwort = objWSHShell.Popup(frage,, ueberschrift, vbQuestion + vbOKOnly)
                objWshShell.LogEvent 2,"Autoscan.vbs Hinweis: Zu dem Scanjob wurden keine weiteren Informationen gefunden. Das Dokument wird dennoch archiviert. Es wird in das Standard-unsortiert Archiv eingelagert und kann von dort an seinen richtigen Ort verschoben werden. Sollte dies hufiger vorkommen, unterrichten Sie bitte den Administrator."
                removemsg
                killscanjob
                WScript.Quit
            End If
            
            
            If fs.fileexists(mypath&"\"&docfile&".OCR") Then
                fs.CopyFile mypath&"\"&docfile&".OCR", druckpfad&docfile2&".ocr", True
                If Err.number<>0 Then
                    Err.clear
                    frage = "bitfarm-Archiv: Fehler bei bergabe der Scandaten an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support."
                    antwort = objWSHShell.Popup(frage,, ueberschrift, vbQuestion + vbOKOnly)
                    objWshShell.LogEvent 1,"Autoscan.vbs: Fehler bei bergabe der Scandaten an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support."
                    removemsg
                    killscanjob
                    WScript.Quit
                End If
                
            End If
            
            
            If fs.fileexists(mypath&"\"&docfile&".ftx") Then
                fs.CopyFile mypath&"\"&docfile&".ftx", druckpfad&docfile2&".ftx", True
                If Err.number<>0 Then
                    Err.clear
                    removemsg
                    frage = "bitfarm-Archiv: Fehler bei bergabe der Scandaten an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support."
                    antwort = objWSHShell.Popup(frage,, ueberschrift, vbQuestion + vbOKOnly)
                    objWshShell.LogEvent 1,"Autoscan.vbs: Fehler bei bergabe der Scandaten an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support."
                    killscanjob
                    WScript.Quit
                End If
                
            End If
            
            
            If fs.fileexists(mypath&"\"&docfile&".SLW") Then
                fs.CopyFile mypath&"\"&docfile&".SLW", druckpfad&docfile2&".slw", True
                If Err.number<>0 Then
                    Err.clear
                    removemsg
                    frage = "bitfarm-Archiv: Fehler bei bergabe der Scandaten an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support."
                    antwort = objWSHShell.Popup(frage,, ueberschrift, vbQuestion + vbOKOnly)
                    objWshShell.LogEvent 1,"Autoscan.vbs: Fehler bei bergabe der Scandaten an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support."
                    killscanjob
                    WScript.Quit
                End If
                
            End If
            
            
            fs.CopyFile file, Ausgabename, True
            If Err.number<>0 Then
                Err.clear
                removemsg
                frage = "bitfarm-Archiv: Fehler bei bergabe der Scandaten an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support."
                antwort = objWSHShell.Popup(frage,, ueberschrift, vbQuestion + vbOKOnly)
                objWshShell.LogEvent 1,"Autoscan.vbs: Fehler bei bergabe der Scandaten an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support."
                killscanjob
                WScript.Quit
            End If
            Err.clear
            WScript.Sleep 200
            
            If scriptdebug = True Then
                objWshShell.LogEvent 4,"Autoscan.vbs: gescannte Datei kopiert" & vbCrLf & "von= " & file.path & vbCrLf & "nach=" & Ausgabename
            End If
            
            
            
            If cleanup =True Then	
                fs.DeleteFile file, True
                If Err.number<>0 Then
                    removemsg
                    frage = "bitfarm-Archiv: Fehler: Kann temporre Dateien nicht lschen. Sollte dieses Problem hufiger vorkommen bitte Nachricht an 0271 / 31 396 - 0 oder per E-Mail an service@bitfarm-gmbh.de"
                    antwort = objWSHShell.Popup(frage,, ueberschrift, vbQuestion + vbOKOnly)
                    objWshShell.LogEvent 2,"Autoscan.vbs: Fehler: Kann temporre Dateien nicht lschen. Sollte dieses Problem hufiger vorkommen bitte Nachricht an 0271 / 31 396 - 0 oder per E-Mail an service@bitfarm-gmbh.de"
                    Err.clear
                    WScript.Quit
                End If
                
                If fs.fileexists(mypath&"\"&docfile&".job") Then
                    fs.DeleteFile mypath&"\"&docfile&".job", True
                    If Err.number<>0 Then
                        Err.clear
                        removemsg
                        frage = "bitfarm-Archiv: Fehler: Kann temporre Dateien nicht lschen. Sollte dieses Problem hufiger vorkommen bitte Nachricht an 0271 / 31 396 - 0 oder per E-Mail an service@bitfarm-gmbh.de"
                        antwort = objWSHShell.Popup(frage,, ueberschrift, vbQuestion + vbOKOnly)
                        objWshShell.LogEvent 2,"Autoscan.vbs: Fehler: Kann temporre Dateien nicht lschen. Sollte dieses Problem hufiger vorkommen bitte Nachricht an 0271 / 31 396 - 0 oder per E-Mail an service@bitfarm-gmbh.de"
                        WScript.Quit
                    End If
                End If
                If fs.fileexists(mypath&"\"&docfile&".OCR") Then
                    fs.DeleteFile mypath&"\"&docfile&".OCR", True
                    If Err.number<>0 Then
                        Err.clear
                        removemsg
                        MsgBox("bitfarm-Archiv: Fehler bei Scan: Kann temporre Dateien nicht lschen. Sollte dieses Problem hufiger vorkommen bitte Nachricht an 0271 / 31 396 - 0 oder per E-Mail an service@bitfarm-gmbh.de")
                        objWshShell.LogEvent 2,"Autoscan.vbs: Fehler bei Scan: Kann temporre Dateien nicht lschen. Sollte dieses Problem hufiger vorkommen bitte Nachricht an 0271 / 31 396 - 0 oder per E-Mail an service@bitfarm-gmbh.de"
                        WScript.Quit
                    End If
                End If
                
                If fs.fileexists(mypath&"\"&docfile&".ftx") Then
                    fs.DeleteFile mypath&"\"&docfile&".ftx", True
                    If Err.number<>0 Then
                        Err.clear
                        removemsg
                        MsgBox("bitfarm-Archiv: Fehler bei Scan: Kann temporre Dateien nicht lschen. Sollte dieses Problem hufiger vorkommen bitte Nachricht an 0271 / 31 396 - 0 oder per E-Mail an service@bitfarm-gmbh.de")
                        objWshShell.LogEvent 2,"Autoscan.vbs: Fehler bei Scan: Kann temporre Dateien nicht lschen. Sollte dieses Problem hufiger vorkommen bitte Nachricht an 0271 / 31 396 - 0 oder per E-Mail an service@bitfarm-gmbh.de"
                        WScript.Quit
                    End If
                End If
                
                If fs.fileexists(mypath&"\"&docfile&".SLW") Then
                    fs.DeleteFile mypath&"\"&docfile&".SLW", True
                    If Err.number<>0 Then
                        Err.clear
                        removemsg
                        MsgBox("bitfarm-Archiv: Fehler bei Scan: Kann temporre Dateien nicht lschen. Sollte dieses Problem hufiger vorkommen bitte Nachricht an 0271 / 31 396 - 0 oder per E-Mail an service@bitfarm-gmbh.de")
                        objWshShell.LogEvent 2,"Autoscan.vbs: Fehler bei Scan: Kann temporre Dateien nicht lschen. Sollte dieses Problem hufiger vorkommen bitte Nachricht an 0271 / 31 396 - 0 oder per E-Mail an service@bitfarm-gmbh.de"
                        WScript.Quit
                    End If
                End If
            End If
            
        End If
        
    Next
    
    Set folder = Nothing
    WScript.Sleep 100
    If cleanup = True Then
        delfolder(mypath)
    End If
    If fs.fileexists(lockdatei) Then
        fs.deletefile lockdatei, True
    End If
    
    If scriptdebug = True Then
        objWshShell.LogEvent 4,"Autoscan.vbs: Es wurden " & i & " Dokument(e) an den Server bertragen"
    End If
    
    
    If scannerpagecountinfo=True Then
        removemsg
        WScript.sleep 500
        If i>0 Then
            If i>1 Then
                frage = i&" Seiten an den Server bertragen."
            Else
                frage = i&" Seite an den Server bertragen."
            End If
            ueberschrift = "bitfarm-Archiv Dokumentenscan"
            
            antwort = objWSHShell.Popup(frage,, ueberschrift, vbInformation + vbOKOnly)
            
        End If
    End If
    
End Function

Function readjob(tempname)
    On Error Resume Next
    readjob=True
    Err.clear
    
    If Not fs.FileExists(tempname&".job") Then
        Err.clear
        
        readjob=False
        Err.clear
    End If
    
    If readjob=True Then	
        Set jobfile = fs.OpenTextFile(tempname&".job",1)
        If Err.number Then
            Err.clear
            readjob=False
        End If 
    End If
    
    If readjob = True Then
        Do While jobfile.AtEndOfStream <> True
            kette=jobfile.readline
            If Left(kette,1)<>";" Then
                
                If InStr(1,kette,"Profil=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Profil=",1)+7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Profil = wert
                    End If
                End If
                
                If InStr(1,kette,"OCR_Typ=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"OCR_Typ=",1)+8)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Typ = wert
                    End If
                End If
            End If
        Loop
        jobfile.close
        Set jobfile = Nothing
    End If
    
End Function

Function readtemplate(tempname)
    On Error Resume Next
    readtemplate=True
    Err.clear
    
    If Not fs.FileExists(templates&tempname&".tpl") Then
        Err.clear
        
        readtemplate=False
        Err.clear
    End If
    
    If readtemplate=True Then	
        Set jobfile = fs.OpenTextFile(templates&tempname&".tpl",1)
        If Err.number Then
            Err.clear
            readtemplate=False
        End If 
    End If
    
    If readtemplate = True Then
        Do While jobfile.AtEndOfStream <> True
            kette=jobfile.readline
            If Left(kette,1)<>";" Then
                
                If InStr(1,kette,"Profil=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Profil=",1)+7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Profil = wert
                    End If
                End If
            End If
        Loop
        jobfile.close
        Set jobfile = Nothing
    End If
    
End Function


Function writejob(tempname1,tempname2)
    On Error Resume Next
    writejob=True
    Err.clear
    
    If Not fs.FileExists(tempname1&".job") Then
        Err.clear
        errortxt=tempname1&".job Datei nicht vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        writejob=False
        Err.clear
    End If
    
    If writejob=True Then	
        Set quelljobfile = fs.OpenTextFile(tempname1&".job",1)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum Schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writejob=False
            
        End If 
    End If
    
    If writejob=True Then
        If fs.FileExists(tempname2&".tmp") Then
            fs.DeleteFile(tempname2& ".tmp")
            If Err.number Then
                Err.clear
                errortxt="Zwischendatei fr Jobdatei existierte noch, kann diese aber nicht lschen."
                objWshShell.LogEvent 1, errortxt
                writejob=False
                quelljobfile.close
                Set quelljobfile=Nothing
            End If 
            
        End If	
    End If
    
    If writejob=True Then
        Set zieljobfile = fs.OpenTextFile(tempname2&".tmp",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writejob=False
            quelljobfile.close
            Set quelljobfile=Nothing
        End If 
    End If
        
    If writejob = True Then
        stopflag=False
        ersatzstring=""	
        Do While quelljobfile.AtEndOfStream <> True
            kette=quelljobfile.readline
            ersatzstring=""
            
            'If (myname<>"") and (InStr(1,kette,"Titel=",1)<>0) Then
            '	ersatzstring="Titel="&myname
            'End If
            
            If (Username<>"") And (InStr(1,kette,"Benutzer=",1)<>0) Then
                ersatzstring="Benutzer="&Username
                'objWshShell.LogEvent 1, ersatzstring
            End If	
            
            If (Typ<>"") And (InStr(1,kette,"OCR_Typ=",1)<>0) Then
                ersatzstring="OCR_Typ="&Typ
                'objWshShell.LogEvent 1, ersatzstring
            End If	
            
            If (Filtermakro<>"") And (InStr(1,kette,"Filter=",1)<>0) Then
                ersatzstring="Filter="&Filtermakro
            End If	
            
            'If (dokDate<>"") and (InStr(1,kette,"Datum=",1)<>0) Then
            '	ersatzstring="Datum="&DokDate
            'End If
            
            
            'If Left(kette,3)="Zus" Then
            '	For x=1 to Zusatzfelder
            '		
            '		If (Zusatzfeld(x)<>"") AND (InStr(1,kette,"ZusWert"&x&"=",1)<>0) Then
            '			ersatzstring="ZusWert"&x&"="&Zusatzfeld(x)
            '		End If
            '	Next
            'End If
            'If barcode<>"" Then
            If Left(kette,8)="ZusTitel" Then
                For x=1 To limit
                    If InStr(1,kette,"ZusTitel"&x&"=",1)<>0 Then
                        If x<10 Then
                            wert=GetString(kette,InStr(1,kette,"ZusTitel"&x,1)+9)
                        Else
                            wert=GetString(kette,InStr(1,kette,"ZusTitel"&x,1)+10)
                        End If
                        
                        For w=0 To limit
                            If LCase(wert)="barcode" Then
                                ersatzstring="ZusWert"&x&"="&barcode(1)
                            End If
                        Next
                        
                        zieljobfile.writeline(kette)
                        kette=quelljobfile.readline
                        
                        zieljobfile.writeline(kette)
                        kette=quelljobfile.readline
                    End If
                Next
                'End If
            End If
            
            If ersatzstring<>"" Then
                zieljobfile.writeline(ersatzstring)
            Else
                zieljobfile.writeline(kette)
            End If
        Loop
        quelljobfile.close
        Set quelljobfile = Nothing
        zieljobfile.close
        Set zieljobfile=Nothing
        WScript.sleep 300
        
        Err.clear
        fs.DeleteFile(tempname1& ".job")
        If Err.number Then
            Err.clear
            errortxt="Fehler beim lschen der alten jobdatei."
            objWshShell.LogEvent 1, errortxt
            writejob=False
        End If 
        
        
        WScript.sleep 200
        If writejob=True Then
            fs.CopyFile tempname2&".tmp", tempname2&".job", True
            If Err.number Then
                Err.clear
                errortxt="Fehler beim umkopieren Jobdatei."
                objWshShell.LogEvent 1, errortxt
                writejob=False
            End If 
        End If
        
        WScript.sleep 300
        If writejob=True Then
            fs.DeleteFile(tempname2& ".tmp")
            If Err.number Then
                Err.clear
                errortxt="Fehler beim lschen der zwischen-jobdatei."
                objWshShell.LogEvent 1, errortxt
                writejob=False
            End If 
        End If
        WScript.sleep 200
    End If
    
End Function


'*******************************************************************************
Function appendBackslash(thepath)
    If Right(thepath,1)<>"\" Then
        thepath=thepath&"\"
    End If
    appendBackslash=thepath
End Function
'*******************************************************************************


Function readconfig(profil)
    On Error Resume Next
    readconfig=True
    Err.clear
    
    If Not fs.FileExists(programm&profil&".con") Then
        Err.clear
        errortxt=profil&".con Datei nicht im Scriptpfad vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        readconfig=False
        Err.clear
    End If
    
    If readconfig=True Then	
        Set confile = fs.OpenTextFile(programm&profil&".con",1)
        If Err.number Then
            Err.clear
            errortxt="Profilfdatei nicht im Scriptpfad vorhanden oder nicht lesbar."
            objWshShell.LogEvent 1, errortxt
            Err.clear
            readconfig=False
            
        End If 
    End If
    
    If readconfig=True Then	
        kette=confile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        Do While Scriptsflag = 0
            kette=confile.readline
            Scriptsflag=InStr(1,kette,"[Scripts]")
            If confile.AtEndOfStream = True Then
                confile.close
                Set confile=Nothing
                scriptsflag=1
                errortxt="Fehler beim Lesen der CON-Datei - falsche Formatierung."
                objWshShell.LogEvent 1, errortxt
                readconfig = False
                
            End If
        Loop
        
    End If
    
    
    If readconfig = True Then
        Do While confile.AtEndOfStream <> True
            kette=confile.readline
            If Left(kette,1)<>";" Then
                If InStr(1,kette,"uncclientspooler",1)<>0 Then
                    wert = Right(kette,Len(kette) -17)
                    uncclientspooler = Trim(wert)
                End If
                
                If InStr(1,kette,"templates",1)<>0 Then
                    wert = Right(kette,Len(kette) -10)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        templates=Trim(wert)
                        templates=appendBackslash(templates)
                        If fs.FolderExists(templates)<>True Then
	                        errortxt="templates-Verzeichnis '" &templates&"' nicht gefunden."
      				            objWshShell.LogEvent 1, errortxt
      				            Err.clear
      				            readconfig=False
                        End If
                    End If
                End If	
            End If
        Loop
        confile.close
        Set confile = Nothing
    End If
End Function



Function checkfeedback()
    On Error Resume Next
    'If Right(Typ,1)<>"X" Then
    '	WScript.Quit
    'End If
    
    mymsg=druckpfad&"msg"&zahl&".bfa"
    
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    WScript.Sleep 300
    If fs.fileexists(mymsg) Then
        starteviewer
    End If
    
    
    frage = "Direktes Anzeigen des gerade importierten Dokuments im bitfarm-Archiv Viewer nicht mglich. Sollte dies hufiger vorkommen, wenden Sie sich an den Netzwerkadministrator."
    ueberschrift = "bitfarm-Archiv Autoscan"
    antwort = objWSHShell.Popup(frage,, ueberschrift, vbExclamation)
    
    Unlock(lockdatei)
    WScript.Quit
    
End Function


Function starteviewer()
    On Error Resume Next
    mymsg=druckpfad&"msg"&zahl&".bfa"
    Set msgdatei = fs.OpenTextFile(mymsg,1)
    dokID=msgdatei.readline
    msgdatei.close
    Set msgdatei = Nothing
    On Error Resume Next
    Err.clear
    fs.deletefile mymsg, True
    If Err.number <> 0 Then
        Err.clear
        On Error Resume Next
    End If
    lngReturnCode = objWSHShell.exec(programm&"\ViewerV3.exe "&dokID)
    If Err.number<>0 Then
        Err.clear
        objWshShell.LogEvent 1,"Fehler beim starten des Viewers. Aktueller Windows Scripting Host?" & vbCrLf & "DokID:" & dokID
    End If
    Unlock(lockdatei)
    WScript.Quit
End Function




'***************************************************************************************
'***************************************************************************************
'***************************************************************************************


Function inilesen()
    On Error Resume Next
    Err.clear
    Set inifile = fs.OpenTextFile(programm&"scripts.ini",1)
    If Err.number Then
        frage="Fehler: scripts.ini nicht im Scriptpfad vorhanden oder nicht lesbar."
        antwort = objWSHShell.Popup(frage,, ueberschrift, vbInformation + vbOKOnly)
        objWshShell.LogEvent 1,"Autoscan.vbs: Fehler: scripts.ini nicht im Scriptpfad vorhanden oder nicht lesbar."
        Err.clear
        WScript.Quit
    End If 
    
    kette=inifile.readline
    Scriptsflag=InStr(1,kette,"[Scripts]")
    Do While Scriptsflag = 0
        kette=inifile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        If inifile.AtEndOfStream = True Then
            inifile.close
            frage = "Fehler beim Lesen der scripts.ini - falsche Formatierung."
            antwort = objWSHShell.Popup(frage,, ueberschrift, vbInformation + vbOKOnly)
            objWshShell.LogEvent 1,"Fehler beim Lesen der scripts.ini - falsche Formatierung."
            WScript.Quit
        End If
    Loop
    
    
    Do While inifile.AtEndOfStream <> True
        kette=inifile.readline
        If Left(kette,1)<>";" Then
            If InStr(1,kette,"scannerpagecountinfo",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"scannerpagecountinfo",1)+21)
                If LCase(wert)="true" Then
                    scannerpagecountinfo = True
                End If	
            End If
            
            If InStr(1,kette,"keybarcode1",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode1",1)+12)
                keybarcode(1)=wert
            End If
            
            If InStr(1,kette,"keybarcode2",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode2",1)+12)
                keybarcode(2)=wert
            End If
            
            If InStr(1,kette,"keybarcode3",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode3",1)+12)
                keybarcode(3)=wert
            End If
            
            If InStr(1,kette,"keybarcode4",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode4",1)+12)
                keybarcode(4)=wert
            End If
            
            If InStr(1,kette,"keybarcode5",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode5",1)+12)
                keybarcode(5)=wert
            End If
            
            If InStr(1,kette,"keybarcode6",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode6",1)+12)
                keybarcode(6)=wert
            End If
        End If
    Loop
    inifile.close
    Set inifile = Nothing
    If programm="" Then
        objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - kein Programmpfad."
        WScript.Quit
    End If
   
End Function

'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function Countpages(tifdatei)
    On Error Resume Next
    
    If fs.Fileexists(tifdatei) And LCase(fs.GetextensionName(tifdatei)) = "tif" And fs.FileExists(programm & "CountPages.exe") Then
        
        On Error Resume Next
        strinput = ""
        schleife = 0
        
        Set oExec    = objWSHShell.Exec(Chr(34)&programm&"CountPages.exe"&Chr(34)&" "&Chr(34)&tifdatei&Chr(34))
        
        Do While Not oExec.StdOut.AtEndOfStream
            strinput = strinput & oExec.StdOut.Read(1)	
        Loop
        
        durch = False
        schleife = 0
        Do While schleife < 50
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 100  
            schleife = schleife +1
        Loop
        
        If durch = False Then
            objWshShell.LogEvent 1, "Archivierung.vbs Function countpages: Schwerwiegender Fehler" & vbCrLf & "Countpages.exe antwortet nicht oder wird nicht beendet" & vbCrLf & "Status: " & oExec.Status & vbCrLf & "Exitcode " & oExec.ExitCode & vbCrLf & "Schleife: " & schleife
            countpages = 0 
            oExec.Terminate
        Else
            If InStr(1,strinput,"Seiten:") <> 0 Then
                strinput = Trim(Right(strinput,Len(strinput)-InStr(1,strinput,"Seiten:")-6))
                strinput = Left(strinput,InStr(1,strinput,Chr(13))-1)
                countpages = strconvert(strinput)
            End If  
        End If
    Else
        'keine tif-datei oder nicht vorhanden
        countpages = 0 
    End If
    
End Function

'***************************************************************************************
'***************************************************************************************
'***************************************************************************************


Function setdokdate()
    On Error Resume Next
    Jahr = DatePart("yyyy",Date)
    Monat = DatePart("m",Date)
    Tag = DatePart("d",Date)
    Stunde = DatePart("h",Time)
    Minuten = DatePart("n",Time)
    Sekunde = DatePart("s", Time)
    If Len(Monat)=1 Then 
        monat="0"&monat
    End If
    If Len(tag)=1 Then 
        tag="0"&tag
    End If
    If Len(stunde)=1 Then 
        stunde="0"&stunde
    End If
    If Len(minuten)=1 Then 
        minuten="0"&minuten
    End If
    If Len(sekunde)=1 Then 
        sekunde="0"&sekunde
    End If
    setdokdate = Jahr&"-" & Monat & "-" & Tag & " " & Stunde & ":" & Minuten & ":" & Sekunde
End Function

'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function testspace
    On Error Resume Next
    freespace=100000
    
    For Each Drive In fs.Drives
        If Drive.DriveLetter=UCase(Left(temppath,1)) Then
            freespace=Drive.FreeSpace
            
        End If
    Next
    
    If freespace < 50000 Then
        MsgBox("Es ist nicht mehr genug Platz auf der Festplatte, um einen Scan durchzufhren! Bitte Informieren Sie Ihren Netzwerkadministrator.")
        objWshShell.LogEvent 1,"Autoscan.vbs: Es ist nicht mehr genug Platz auf der Festplatte, um einen Scan durchzufhren! Bitte Informieren Sie Ihren Netzwerkadministrator."
        WScript.Quit
    End If
    freespace=100000
    For Each Drive In fs.Drives
        If Drive.DriveLetter=UCase(Left(systemroot,1)) Then
            freespace=Drive.FreeSpace
        End If
    Next
    If freespace < 50000 Then
        MsgBox("Es ist nicht mehr genug Platz auf der Festplatte, um einen Scan durchzufhren! Bitte Informieren Sie Ihren Netzwerkadministrator.")
        objWshShell.LogEvent 1,"Autoscan.vbs: Es ist nicht mehr genug Platz auf der Festplatte, um einen Scan durchzufhren! Bitte Informieren Sie Ihren Netzwerkadministrator."
        WScript.Quit
    End If
    
End Function

Function delfolder(folder)
    On Error Resume Next
    Set ordner=fs.getfolder(folder)
    For Each file In ordner.files
        fs.deletefile(file)
        Err.clear
        
    Next
    For Each unterordner In ordner.subfolders
        delfolder(unterordner)
        
        fs.deletefolder(unterordner)
    Next
    fs.deletefolder(folder)
    Set ordner=Nothing
End Function


Function Zufallszahl(von, bis)
    On Error Resume Next
    anzahl = bis-von+1
    Randomize
    Zufallszahl = Fix(Rnd*(anzahl))+von
End Function

Private Function strConvert(str)	
    On Error Resume Next 
    
    If Not IsNumeric(str) Then
        strConvert = 0
        
    ElseIf (InStr(1,str,".") And InStr(1,str,",")) Then
        strConvert = 0
    Else
        str1=""
        str2=""
        neg = False
        
        If InStr(1,str,",") Then
            str1 = Left(str,InStr(1,str,",")-1)
            str2 = Right(str,Len(str)-InStr(1,str,","))
        ElseIf InStr(1,str,".") Then
            str1 = Left(str,InStr(1,str,".")-1)
            str2 = Right(str,Len(str)-InStr(1,str,"."))
        Else
            str1 =str
            str2="0"
        End If
        
        If Left(str1,1) = "-" Then
            neg = True
            str1 = Replace(str1,"-","")
        End If 
        
        wert1=0
        l = Len(str1)
        For x = 1 To l
            wert1=wert1+((Asc(Mid(str1,x,1))-48)*(10^(l-x)))
        Next
        
        wert2=0
        l = Len(str2)
        For x = 1 To l
            wert2=wert2+((Asc(Mid(str2,x,1))-48)*(10^(l-x)))
        Next
        
        wert2 = wert2/(10^Len(str2))
        
        StrConvert=wert1+wert2
        
        If neg = True  Then
            strConvert = 0 - strConvert
        End If
    End If
    
End Function

Private Function GetString(kette,pos)
    On Error Resume Next
    zeichen=""
    ergebnis=""
    index=0
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (zeichen<>"	") And (index<80)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,pos+index,1)
        index=index+1
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=")) And (ergebnis="") Then
            zeichen=""
        End If
    Loop
    Trim(ergebnis)
    GetString=ergebnis
End Function


Function RegRead(tempkey)
    On Error Resume Next
    privkey = tempkey
    
    RegRead = objWSHShell.RegRead(privkey)
    If Not Err.number=0 Then
        MsgBox("Fehler: Registrierungsschlssel nicht gesetzt.")
        objWshShell.LogEvent 1,"Autoscan.vbs Fehler: Registrierungsschlssel nicht gesetzt." & vbCrLf & privkey
        RegRead=""
        Err.clear
        WScript.Quit
    End If
End Function


'************************************ lock lschen ***********************************
Function Unlock(lockfileandpath)
    On Error Resume Next
    Err.clear
    On Error Resume Next
    If fs.fileexists(lockfileandpath) Then
        fs.DeleteFile lockfileandpath, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            WScript.Sleep 430
            fs.DeleteFile lockfileandpath, True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                WScript.Sleep 530
                fs.DeleteFile lockfileandpath, True
                If Err.number<>0 Then
                    Err.clear
                    On Error Resume Next
                    'objWshShell.LogEvent 2, "archivierung(F1): Hinweis: konnte lockdatei nicht lschen:"&lockfileandpath
                    
                End If
            End If    		
            
        End If
    End If
End Function

Function killscanjob()
    On Error Resume Next
    
    If fs.fileexists(lockdatei) Then
        fs.deletefile lockdatei,True
    End If
    
    Set colItems = Nothing
    Set objWMIService = Nothing
    
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='AutoScanV3.exe'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    z=0
    For Each objItem In colItems
        objItem.Terminate()
        z=z+1
        WScript.Sleep 100
    Next
    
    objWshShell.LogEvent 2,"Autoscan.vbs: Teminierte AutoscanV3-Instanzen:" & z
    
    
    Set colItems = Nothing
    Set objWMIService = Nothing
    WScript.Sleep 500
    
    
    ' zweiter Terminierungslauf
    
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='AutoScanV3.exe'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    'z=0
    For Each objItem In colItems
        objItem.Terminate()
        z=z+1
        WScript.Sleep 100
    Next
    
    objWshShell.LogEvent 2,"Autoscan.vbs: Teminierte AutoscanV3-Instanzen:" & z
    
    Set colItems = Nothing
    Set objWMIService = Nothing
    WScript.Sleep 500
    
    allegeloescht = True
    Set folder = fs.GetFolder(temppath)
    For Each file In folder.files
        
        extfile = LCase(fs.GetExtensionName(file)) 
        If  extfile = "tmp" Or extfile = "job" Or extfile = "tif"  Then
            'Msgbox "lsche jetzt: " & file.name
            If Left(file.name,1) <> "~" Then
                WScript.Sleep 100
                fs.deletefile file, True
                j = j +1
            End If
            
            If Err.number<>0 Then
                allegeloescht = False
                Err.clear
                j = j -1
                On Error Resume Next
            End If
        End If
    Next
    
    Set folder = fs.GetFolder(temppath)
    For Each ordner In folder.subfolders
        'msgbox ordner.name
        If Left(ordner.name,8) = "bfa-scan" Then
            delfolder(ordner)
        End If
    Next
    
    If allegeloescht = True Then
        objWshShell.LogEvent 4,"Autoscan.vbs: Es wurden "& j & " Dateien gelscht"
    Else
        objWshShell.LogEvent 2,"Autoscan.vbs: Es wurden "& j & " Dateien gelscht" & vbCrLf & "Es konnte aber nicht alle Dateien gelscht werden"	
    End If
    
End Function



Function checkscanner
    On Error Resume Next
    Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    WScript.Sleep 50
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'AutoScanV3'")
    WScript.Sleep 50
    
    For Each strProcess In colProcesses
        'counter1=strProcess.IOReadBytesPerSec
        counter2=strProcess.IOReadOperationsPerSec
        'counter3=strProcess.IOWriteBytesPerSec
        'counter4=strProcess.IOWriteOperationsPerSec
        'counter5=strProcess.IOOtherBytesPerSec
        'counter6=strProcess.IOOtherOperationsPerSec
        'counter7=strProcess.PercentProcessorTime
        
    Next
    
    check4 = check3 
    check3 = check2 
    check2 = check1 
    check1 = (Round(counter2) - oldcheck1)
    
    'check5 = (Round(counter5) - oldcheck2) 
    
    
    checkstau = check1 + check2 + check3 + check4
    If checkstau <> 0 Then
        checkstau = (check1 + check2 + check3 + check4) / 4	
        noinput = 0
    Else
        'If check5 = 0 Then
        noinput = noinput +1
        'Else
        '	noinput = 0
        'End If
    End If
    
    If noinputlimit <> 0 Then
        If noinput > noinputlimit Then
            noinput = 0
            frage = "Vom Scanner werden keine Daten empfangen !" & vbCrLf & "Bitte starten Sie den Scanner neu"
            antwort = objWSHShell.Popup(frage,, ueberschrift, vbInformation + vbOKOnly)
            objWshShell.LogEvent 1,"Autoscan.vbs - Vom Scanner werden keine Daten empfangen - Abbruch"
            killscanjob
            
            If scriptdebug = True Then
                mydebugfile.close
                Set mydebugfile=Nothing
            End If
            
            Set fs = Nothing
            Set objWSHShell = Nothing
            
            WScript.Quit
        End If
    End If
    
    If scriptdebug = True Then
        mydebugfile.writeline(Now() & vbTab & counter2 &vbTab & check1 &vbTab & check2 &vbTab & check3 &vbTab & check4 & vbTab & checkstau & vbTab & noinput)   ' & vbTab & "Counter5" & vbTab & counter5 & vbTab & check5)
    End If
    
    If ioreaddeltalimit <> 0 Then
        If checkstau >ioreaddeltalimit Then
            frage = "PAPIERSTAU !!!  Der Scanjob wird abgebrochen, es werden keine Dokumente zum Server bertragen !" & vbCrLf & "Bitte beseitigen Sie den Papierstau und starten den Scanvorgang neu."
            antwort = objWSHShell.Popup(frage,, ueberschrift, vbInformation + vbOKOnly)
            objWshShell.LogEvent 1,"Autoscan.vbs - Papierstau ! Der Vorgang wird abgebrochen"
            killscanjob
            
            If scriptdebug = True Then
                mydebugfile.close
                Set mydebugfile=Nothing
            End If
            
            Set fs = Nothing
            Set objWSHShell = Nothing
            WScript.Quit
        End If
    End If
    checkstau = 0
    'oldcheck4 = check4
    'oldcheck3 = check3
    'oldcheck2 = check2
    oldcheck1 = Round(counter2)
    'oldcheck2 = Round(counter5)
    
End Function

Function showmsg()
    On Error Resume Next
    showmsg=True
    Err.clear
    On Error Resume Next
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        showmsg=False
    Else
        Set objWMIService = Nothing
    End If
    If showmsg=True Then
        Set oExec = objWSHShell.exec(programm&"bfamessage.exe")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            showmsg=False
        Else
            Set oexec=Nothing
        End If
    End If
End Function

Function removemsg()
    Err.clear
    On Error Resume Next
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    If Err.number=0 Then
        strQuery = "Select * from Win32_Process where Name='bfamessage.exe'"
        Set colItems = objWMIService.ExecQuery(strQuery,,48)
        For Each objItem In colItems
            objItem.Terminate()
        Next
        WScript.sleep 100
        Set colItems = Nothing
        Set objWMIService = Nothing
    End If
    Err.clear
    On Error Resume Next
End Function




'*******************************************************************************************
'*******************************************************************************************
'********************************          Ende             ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
