'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'***************  barcodemerger.vbs   GPL  *************************************************
'*******************************************************************************************
'***************  Version 3.6.2.0          *************************************************
'*******************************************************************************************
'***************  Programm zum Trennen eines Stapelscans mittels             ***************
'***************  Barcodes                                                   ***************
'***************                                                             ***************
'***************  die erstellten Dateien werden automatisch verknpft        ***************
'***************  und in die queue eingestellt.                              ***************
'***************                                                             ***************
'***************  Syntax: <programmpfad>barcodemerger.vbs {tif-Datei}        ***************
'***************                                                             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************

'*** fr den Service:
scriptdebug = False
cleanup = True
limit=60

'*******************************************************************************************
'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

On Error Resume Next



Dim datei, arg1, Progr, Zeit, i, oArgs
Dim objFolder, objcleanfolder, objTextFile, objFile
Dim fs, filedecode, folder, allfiles, file, strPfadQueue, strAnhang
Dim strLine, strLen, decode
Dim strHtmlDatei, strHtml, filehtml


Dim strFrom, strSubject, strTo, strCC, strDate, StrContent, strPfadTemp
ReDim Zusatzfeld(limit)
ReDim Zusatzfeldname(limit)
ReDim linkspeicher(limit)
ReDim barcode(50)
ReDim keybarcode(50)
ReDim stapelbarcode(50)
ReDim filenames(5000)'5000
ReDim droppage(50)
ReDim aktbarcode(50)
ReDim dropaktpage(50)
ReDim dropstapelpage(50)
ReDim linkcounter(30)
ReDim doclinks(30)


Set fs = CreateObject("Scripting.FileSystemObject")
Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set oArgs    = WScript.Arguments 


For i = 0 To limit 
    Zusatzfeld(i)=""
    Zusatzfeldname(i)=""
    linkspeicher(i)="" 
Next

For x=0 To 49
    droppage(x)=0
    dropaktpage(x)=0
    dropstapelpage(x)=0
Next


For x=0 To 49
    keybarcode(x)=""
    aktbarcode(x)=""
    stapelbarcode(x)=""
    barcode(x)=""
Next

erfolg = True
dropfirstpage=False
dropaktpage=False
maxpage=0
barcodemask=""
barcodemode=""
barcodesecondthreshold=""
eymbcrdcmdpath=""
bcsecondrun=""
bcpluspath=""
strcontent=""
strinput=""
strbarcode=""
linkzaehler=0
an=""
absender=""
absenderadresse=""
cc=""
bcc=""
empfangsdatum=""
docnumber=1
username=""
dokdate=""
bcfilter="barcodefilter1.txt"
extension=".tif"
myaktbarcode=""
stapelmode=False
master_uebergabe=""


Err.clear
fullpath = WScript.ScriptFullName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    'objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
scriptname = WScript.ScriptName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    'objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    'objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
If Len(programm)=0 Then
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    'objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If

inilesen()

queue=programm&"queue\"

If master_uebergabe <> "" Then 
	If fs.FolderExists(master_uebergabe) Then
		uebergabe = master_uebergabe	
	Else
		uebergabe=Programm&"uebergabe\"
	End If
Else
	uebergabe=Programm&"uebergabe\"
End If

If scriptdebug=True Then
	objWshShell.LogEvent 1, "Barcodemerger.vbs uebergabe: " & uebergabe
End If

zahl = Zufallszahl(0,99999)
strPfadQueue = ""
strPfadTemp = programm&"BCTemp\"



If Not fs.FolderExists(strPfadTemp) Then
    Set test = fs.CreateFolder(strPfadTemp)
    Set test = Nothing
    WScript.sleep 200
    If Err.number<>0 Then
        objWshShell.LogEvent 1, "Barcodemerger.vbs(0): kann verzeichnis nicht erstellen - Berechtigung?" & strPfadTemp
        Err.clear
        WScript.Quit
    End If 
    
    If Not fs.FolderExists(strPfadTemp) Then
        objWshShell.LogEvent 1, "Barcodemerger.vbs(0b): kann verzeichnis nicht erstellen (2) - Berechtigung?"& strPfadTemp
        WScript.Quit
    End If
End If

strPfadTemp=strPfadTemp&zahl&"\"

If Not fs.FolderExists(strPfadTemp) Then
    Set test = fs.CreateFolder(strPfadTemp)
    Set test = Nothing
    WScript.sleep 200
    If Err.number<>0 Then
        objWshShell.LogEvent 1, "Barcodemerger.vbs(1): kann verzeichnis nicht erstellen - Berechtigung?" & strPfadTemp
        Err.clear
        WScript.Quit
    End If 
    
    If Not fs.FolderExists(strPfadTemp) Then
        objWshShell.LogEvent 1, "Barcodemerger.vbs(1b): kann verzeichnis nicht erstellen (2) - Berechtigung?" & strPfadTemp
        WScript.Quit
    End If
End If



partcounter=0
Set oArgs    = WScript.Arguments                 

'hole alle Argumente 
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

If oArgs.Count= 1 Then
    datei  =   oArgs.item(0)  
Else
    objWshShell.LogEvent 1, "bitfarm-Archiv barcodemerger: Kein Argument bergeben. (Basisname Tif-Datei)"
    WScript.Quit
End If


datei1=datei&".tmp"

If fs.FileExists(datei&".tmp") Then
    Set objFolder = fs.GetFile(datei&".tmp")
    
Else
    Set fs = Nothing
    objWshShell.LogEvent 1, "bitfarm-Archiv barcodemerger(2): keine tmp-Datei vorhanden." & datei&".tmp"
    WScript.Quit
End If


myfilename=objfolder.name
myfoldername=Left(datei1,Len(datei1)-Len(myfilename))

myfilename=Left(myfilename,Len(myfilename)-4)

If fs.fileexists(queue&myfilename&".tif")=False Then
    objWshShell.LogEvent 1, "bitfarm-Archiv barcodemerger(3): Zur Job-Datei keine TIF-Datei vorhanden."
    WScript.quit
End If

mytempname=myfilename



'################################### Verarbeitung #####################################
'##############1. splitten ##################

fs.copyfile queue&myfilename&".tif", strPfadTemp&myfilename&".tif", True

If Err.number<>0 Then
    objWshShell.LogEvent 1, "Barcodemerger.vbs: kann Tif-Datei nicht kopieren" & vbCrLf & queue&myfilename&".tif" & vbCrLf & strPfadTemp&myfilename&".tif"  & vbCrLf & Err.Description
    Err.clear
    erfolg = False
End If 

If erfolg = True Then
    lngReturnCode = objWSHShell.Run(programm&"split.bat "&strPfadTemp&myfilename&".tif",0,True)
    
    If lngReturnCode <> 0 Then
        objWshShell.LogEvent 1, "bitfarm-Archiv barcodemerger: Fehler beim Splitten" & vbCrLf & strPfadTemp&myfilename&".tif"
        erfolg = False
    End If
End If

WScript.sleep 100

If erfolg = True Then
    fs.deletefile strPfadTemp&myfilename&".tif", True
    
    If Err.number<>0 Then
        objWshShell.LogEvent 1, "Barcodemerger.vbs: kann Tif-Datei nicht lschen" & vbCrLf & strPfadTemp&myfilename&".tif" & vbCrLf & Err.Description
        Err.clear
        erfolg = False
    End If 
End If


'##############2. nach barcodes suchen und mergen ##################

If erfolg = True Then
    i=0
    kette=""
    keypages=False
    
    temppath=strPfadTemp
    
    
    For o=0 To 5000
        filenames(o) = ""
    Next
    
    
    Set folder = fs.GetFolder(temppath)
    
    For Each file In folder.files
        
        If LCase(Right(file,3)) = "tif" Then
            
            index = Mid(file.name,InStr(1,file.name,"page")+4,Len(file.name) - 	InStr(1,file.name,"page") - 7)
            'MsgBox file.name & " - " & index
            filenames(strconvert(index)) = file.name
            anzahlfiles = anzahlfiles +1
            If anzahlfiles >4999 Then
                objWshShell.LogEvent 2,"barcodemerger.vbs: Es werden keine Dokumente mit mehr als 5000 Einzel- Seiten verarbeitet"
                erfolg = False
                Exit For		
            End If
            
        End If
    Next 
    
End If


If erfolg = True Then
    
    ReDim pagebarcode(anzahlfiles,49)
    ReDim docbarcode(anzahlfiles,49)
    ReDim doclinks(anzahlfiles)
    ReDim pageoperation(anzahlfiles)
    ReDim page(anzahlfiles)
    
    
    For i = 0 To anzahlfiles -1
        page(i)=""
        pageoperation(i)=0    'alles einzelseiten
        If filenames(i) <> "" Then
            page(i) = filenames(i)
        Else
            page(i) = ""
        End If
        doclinks(i)=""
    Next 
    
    
    For t=0 To anzahlfiles
        For i=0 To 49
            pagebarcode(t,i)=""
            docbarcode(t,i)=""
        Next
    Next
    
    
    
    mystapelbarcode=""
    For xy = 0 To anzahlfiles - 1
        For i = 0 To 49
            barcode(i) = ""
        Next
        
        dropfirstpage=False	
        gefunden=False
        If stapelmode = True Then
            stapelmode
        End If
        If eymbcrdcmdpath<>"" Then
            gefunden=useeymbcrdcmd(filenames(xy))	
            If scriptdebug = True Then
                objWshShell.LogEvent 4,"barcodemerger.vbs: useeymbcrdcmd: " & filenames(xy) & vbCrLf & "gefunden=" & gefunden
            End If
            
        ElseIf bcpluspath<>"" Then	
            gefunden=usebcplus(filenames(xy))
            If scriptdebug = True Then
                objWshShell.LogEvent 4,"barcodemerger.vbs: usebcplus: " & filenames(xy) & vbCrLf & "gefunden=" & gefunden
            End If
        Else
            
            gefunden=userdtifbar(filenames(xy))
            
            If scriptdebug = True Then
                objWshShell.LogEvent 4,"barcodemerger.vbs: userdtifbar: " & filenames(xy) & vbCrLf & "gefunden=" & gefunden
            End If
        End If
        
        
        ' alle Barcodes bernehmen die gefunden wurden	
        For r=0 To 49
            pagebarcode(xy,r)=barcode(r)
        Next
        
        
        If gefunden=True Then     ' Keybarcode gefunden
            keypages = True
            If dropfirstpage = True Then     ' Droppage ?
                pageoperation(xy) = 2
            End If
        Else
            ' nicht gefunden dann mergen		
            pageoperation(xy) = 1	
            
        End If
        
        
    Next
    
    
    
    ' Starte jetzt Verarbeitung   (keydocs, mergen und droppages)
    myaktbarcode=""
    keypage = 0 	' erste seite ist erstmal keypage 
    If pageoperation(0) = 1 Then   ' muss auch sein, damit diese wenigstens die gelesen barcodes erhlt, auch wenn keine trennung etc durchgefhrt wird
        pageoperation(0) = 0 
    End If
    
    
    
    'haben wir berhaupt eine trennung ?
    
    If keypages = True Then
        linkstring=""
        
        For xy = 0 To anzahlfiles -1
            
            '#######################
            'Suche in den Barcode nach einem neuen myaktbarcode
            For y=0 To 49
                For z=0 To 49
                    If aktbarcode(z)<>"" Then
                        If pagebarcode(xy,y)<>"" Then
                            If Len(pagebarcode(xy,y))>=Len(aktbarcode(z)) Then
                                If LCase(Left(pagebarcode(xy,y),Len(aktbarcode(z))))=LCase(aktbarcode(z)) Then
                                    
                                    myaktbarcode=pagebarcode(xy,y)
                                    mystapelcode=""
                                    'Neuer Aktenbarcode -> neuer linkstring zum Verknpfen erzeugen
                                    linkstring = createaktlink(xy, aktbarcode(z))
                                    
                                End If
                            End If
                        End If 
                    End If
                Next
            Next
            '#######################		
            
            
            For y=0 To 49
                For z=0 To 49
                    If stapelbarcode(z)<>"" Then
                        If pagebarcode(xy,y)<>"" Then
                            If Len(pagebarcode(xy,y))>=Len(stapelbarcode(z)) Then
                                If LCase(Left(pagebarcode(xy,y),Len(stapelbarcode(z))))=LCase(stapelbarcode(z)) Then
                                    mystapelcode=pagebarcode(xy,y)
                                    mystapelbarcode=pagebarcode(xy,y)
                                End If
                            End If
                        End If 
                    End If
                Next
            Next
            
            
            
            'aktuellen linkstring in doclinks schreiben
            'doclinks-index stimmt mit docbarcode-index berein
            If linkstring <> "" Then
                doclinks(xy) = linkstring
            End If
            op = pageoperation(xy)
            If pageoperation(xy) = 0 Then	
                
                ergebnis = mergebcarrays(xy,xy)	'in das docbarcodearrray die werte von pagebarcode bernehmen
                'aktuelle docbarcode erhlt akteulle pagebarcodes
                keypage = xy					' keypage ist jetzt die aktuelle seite
                
            ElseIf pageoperation(xy) = 1 Then		'mergen
                
                path1 = temppath&page(keypage)	
                path2 = temppath&page(xy)
                ergebnis = mergebcarrays(keypage,xy)
                
                
                lngReturnCode = objWSHShell.Run(programm&"splitterv3.exe -a " & path1 & " " & path2,0,True)
                WScript.sleep 30				
                If lngreturncode=0 Then
                    fs.deletefile path2, True
                    
                    
                    
                    
                    
                Else
                    objWshShell.LogEvent 1, "barcodemerger.vbs: Fehler beim Mergen" & vbCrLf & path1 & " + " & vbCrLf & path2	
                    
                    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
                    strQuery = "Select * from Win32_Process where Name='SplitterV3.exe'"
                    Set colItems = objWMIService.ExecQuery(strQuery,,48)
                    z=0
                    For Each objItem In colItems
                        objItem.Terminate()
                        z=z+1
                    Next
                    If z>0 Then
                        objWshShell.LogEvent 2, "barcodemerger.vbs:: SplitterV3-Prozess terminiert bei "&path1
                        
                    End If
                    
                    Set colItems = Nothing
                    Set objWMIService = Nothing
                    
                    
                End If
                page(xy) = ""
                
                
                
                
            ElseIf pageoperation(xy) = 2 Then   'droppage
                
                For x = 0 To 49 
                    docbarcode(xy+1,x) = docbarcode(xy,x)
                    
                Next 		
                ergebnis = mergebcarrays(xy +1,xy)	' seite wird gedroppt, dh nchste seite wird keypage und erhlt barcodes
                keypage = xy +1
                
                If pageoperation(xy+1) <> 2 Then			'nchste seite wird keypage, aber nur wenn es keine droppage ist
                    pageoperation(xy+1) = 0								' 2 droppages hintereinander ? wer machte denn sowas ? - Wer wei !!!	
                End If
                
                path2 = temppath&page(xy)
                If fs.fileexists(path2) Then
                    fs.deletefile path2, True
                End If
                
                page(xy) = ""	
                
                
                
            End If 
            
            
            
            
            'jetzt noch aktbarcode einfgen, falls noch nicht vorhanden
            aktflag=False
            If myaktbarcode<>"" Then
                For x=0 To 49
                    If docbarcode(xy,x)=myaktbarcode Then
                        aktflag=True
                    End If
                Next
                If aktflag=False Then
                    x=0
                    Do While aktflag=False
                        If docbarcode(xy,x)="" Then
                            aktflag=True
                            docbarcode(xy,x)=myaktbarcode
                        End If
                        x=x+1
                        If x>28 Then
                            aktflag=True
                            objWshShell.LogEvent 1,"bitfarm-Archiv: barcodemerger(72): berlauf im barcodearay Aktenbarcodes"
                        End If
                        
                    Loop	
                End If
            End If
            
            '####################
            stapelflag = False
            If mystapelcode<>"" Then
                For x=0 To 49
                    If docbarcode(xy,x)=mystapelcode Then
                        stapelflag=True
                    End If
                Next
                If stapelflag=False Then
                    x=0
                    Do While stapelflag=False
                        If docbarcode(xy,x)="" Then
                            stapelflag=True
                            docbarcode(xy,x)=mystapelcode
                        End If
                        x=x+1
                        If x>48 Then
                            stapelflag=True
                            objWshShell.LogEvent 1,"bitfarm-Archiv: barcodemerger(72): berlauf im barcodearay stapelbarcodes"
                        End If
                        
                    Loop	
                End If
            End If            
        Next 
        
    End If
    
    
    Set folder=Nothing
    
End If		

Err.clear

bcmergejob(datei)



If keypages = True Then
    
    If scriptdebug = True Then
        For x=0 To anzahlfiles-1
            kette=kette & "DocNumber:"&x&vbCrLf
            For y=0 To 49
                If docbarcode(x,y)<>"" Then
                    kette=kette&docbarcode(x,y)&vbCrLf
                End If
            Next
        Next
        objWshShell.LogEvent 4, "barcodemerger.vbs: Docbarcodes Ergebnis" &vbCrLf & "Keypages=" & keypages & vbCrLf & kette
    End If
    
    
    
    '#####################################  Einstellen in queue ###########################
    
    
    
    For xy= 0 To anzahlfiles -1
        
        If page(xy)<> "" Then
            
            newtempname=""
            myname=page(xy)
            
            
            '######################## freien Slot suchen #####################
            
            
            'newtempname = getfifo(queue,"temp-bar")
            Jahr = DatePart("yyyy",Date)
			Monat = DatePart("m",Date)
			Tag = DatePart("d",Date)
			Stunde = DatePart("h",Time)
			Minuten = DatePart("n",Time)
			Sekunde = DatePart("s", Time)
			
			datum = Jahr & Monat & Tag & Stunde & Minuten & Sekunde
			
			
			zahl = Zufallszahl(10000000,99999999)

			uebergabename = "temp-bar-" & datum & "-" & zahl
            newtempname = getfifo(uebergabe,uebergabename)
            
            
            
            
            If fs.fileexists(datei&".slw") Then '#########################  Barcodes in Schlagwortdatei an Archivierung bergeben ################
                err.clear
                fs.copyfile datei&".slw", newtempname&".slw", True
                If err.number <> 0 Then
                	objwshshell.LogEvent 1, "barcodemerger.vbs Fehler beim Kopieren von '" & datei &".slw' nach '" & newtempname&".slw'" & vbCrLf & err.number & vbCrLf & err.Description
                	err.clear
                End If
                '			Set swfile=fs.OpenTextFile(newtempname&".slw",1)
                '			kette=""
                '			If swfile.atendofstream=False Then
                '			kette=swfile.readall
                '			End If
                '			swfile.close
                Set swfile=Nothing
                WScript.sleep 50
                Set swfile=fs.OpenTextFile(newtempname&".slw",8,1)
                swfile.writeline "Message:BarcodeRead=Complete"
                For x=0 To 49
                    If docbarcode(xy,x)<>"" Then
                        'isKeyBarCode = False
                        'For kb=0 To 29
                        '	If keybarcode(kb) = docbarcode(xy,x) Then
                        '		isKeyBarCode = True
                        '	End If
                        'Next
                        'If isKeyBarCode = False Then
                        swfile.writeline "Barcode:"&docbarcode(xy,x)
                        'End If
                    End If
                Next
                '				If myaktbarcode<>"" Then
                '					swfile.writeline "Barcode:"&myaktbarcode
                '				End If
                
                'swfile.write(kette)               
                swfile.close
                Set swfile=Nothing
            Else
            	objwshshell.LogEvent 1, "barcodemerger.vbs original-slw '" & datei &".slw' wurde nicht gefunden!"
            End If
            If Not fs.fileexists(newtempname&".slw") Then
            	objwshshell.LogEvent 1, "barcodemerger.vbs '" & newtempname &".slw' wurde nicht erzeugt!"
            End If
            If fs.fileexists(datei&".swd") Then '#########################  Barcodes in Schlagwortdatei an Archivierung bergeben ################
                fs.copyfile datei&".swd", newtempname&".swd", True
                '			Set swfile=fs.OpenTextFile(newtempname&".swd",1)
                '			kette=""
                '			If swfile.atendofstream=False Then
                '			kette=swfile.readall
                '			End If
                '			swfile.close
                '			Set swfile=Nothing
                '			wscript.sleep 50
                Set swfile=fs.OpenTextFile(newtempname&".swd",8,1)
                swfile.writeline "Message:BarcodeRead=Complete"
                For x=0 To 49
                    If docbarcode(xy,x)<>"" Then
                        swfile.writeline "Barcode:"&docbarcode(xy,x)
                    End If
                Next
                '				If myaktbarcode<>"" Then
                '					swfile.writeline "Barcode:"&myaktbarcode
                '				End If
                'swfile.write(kette)
                swfile.close
                Set swfile=Nothing
                
            End If
            If fs.fileexists(datei&".ftx") Then
                fs.copyfile datei&".ftx", newtempname&".ftx", True
            End If
            If fs.fileexists(datei&".vtx") Then
                fs.copyfile datei&".vtx", newtempname&".vtx", True
            End If
            
            update_datum(datei&".bctmp")
            fs.copyfile datei&".bctmp", newtempname&".job", True
            
            
            'Hier wird ggf. Referenz eingefgt
            If doclinks(xy) <> "" Then
                addlink doclinks(xy), newtempname&".job"
            End If
            
            fs.copyfile temppath & myname, newtempname&".tif", True
            
            If cleanup = True Then
                fs.deletefile  temppath & myname, True
            End If
            
            '******************   Anzahl der Jobs in der Queue zhlen und queuecnt.txt aktualisieren *******************
            
            If fs.fileexists(programm & "countfiles.exe") Then
                
                i = countfiles(programm & "queue" , "*.job")	
                
                If fs.Fileexists(programm& "queuecnt.txt") Then
                    
                    fs.DeleteFile programm& "queuecnt.txt", True
                    On Error Resume Next
                End If  
                Set cntfile = fs.CreateTextFile(programm& "queuecnt.txt",True)
                cntfile.Writeline i
                cntfile.close
                
                Set folder = Nothing
                
            Else
                lngReturnCode = objWSHShell.Run(Chr(34)&programm & "countfiles.bat"&Chr(34)&" " &Chr(34)& programm&Chr(34))
            End If
            
            
            
            
        End If
        
    Next
    Set folder =Nothing
    WScript.sleep 20
    
    If cleanup=True Then
        
        strbase = fs.getbasename(datei)
        strfolder = fs.getparentfoldername(datei)
        
        Set objcleanfolder = fs.getfolder(strfolder)
        
        For Each objfile In objcleanfolder.files
            
            strname = fs.getbasename(objfile)
            If strname = strbase Then
                
                fs.deletefile (objfile), True
            End If
            If strname = strbase&"-archiv" Then
                
                fs.deletefile (objfile), True
            End If
            If strname = strbase&"-temp" Then
                
                fs.deletefile (objfile), True
            End If
            
        Next 
        
        If fs.fileexists(datei&"-archiv.tif") Then
            fs.deletefile datei&"-archiv.tif", True
        End If
        If fs.fileexists(datei&"-temp.tif") Then
            fs.deletefile datei&"-temp.tif", True
        End If
        
    End If
    
Else
    
    If scriptdebug = True Then
        objWshShell.LogEvent 4, "barcodemerger.vbs: tmp-Datei umbenennen, keine Trennung erfolgt" & vbCrLf & datei&".job"
    End If
    ' hier alle pagebarcodes in slw schreiben
    
    
    If fs.fileexists(datei&".slw") Then '#########################  Barcodes in Schlagwortdatei an Archivierung bergeben ################
        Set swfile=Nothing
        WScript.sleep 50
        Set swfile=fs.OpenTextFile(datei&".slw",8,1)
        swfile.writeline "Message:BarcodeRead=Complete"
        
        For p=0 To UBound(pagebarcode)
            For x=0 To 49
                If pagebarcode(p,x)<>"" Then
                    swfile.writeline "Barcode:"&pagebarcode(p,x)
                End If
            Next 
        Next  
        
        swfile.close
        Set swfile=Nothing
        
    End If
    If fs.fileexists(datei&".swd") Then '#########################  Barcodes in Schlagwortdatei an Archivierung bergeben ################
        Set swfile=fs.OpenTextFile(datei&".swd",8,1)
        swfile.writeline "Message:BarcodeRead=Complete"
        
        For p=0 To UBound(pagebarcode)
            For x=0 To 49
                If pagebarcode(p,x)<>"" Then
                    swfile.writeline "Barcode:"&pagebarcode(p,x)
                End If
            Next 
        Next  
        
        swfile.close
        Set swfile=Nothing
        
    End If    
    
    
    Err.clear
    fs.movefile datei&".bctmp", datei&".job"
    
    If Err.number<>0 Then
        objWshShell.LogEvent 1,"bitfarm-Archiv barcodemerger.vbs: kann datei bctmp-Datei nicht umkopieren."&datei&".bctmp"	
    End If
    
    WScript.Sleep 100
    Err.clear
    fs.deletefile datei&".tmp", True
    If Err.number<>0 Then
        objWshShell.LogEvent 1,"bitfarm-Archiv barcodemerger.vbs: kann datei tmp-Datei nicht lschen."&datei&".tmp"
        
    End If
    
End If


If cleanup = True Then
    
    Set folder = fs.GetFolder(strPfadTemp)
    For Each file In folder.files
        fs.deletefile file, True
        If Err.number<>0 Then
            objWshShell.LogEvent 1,"bitfarm-Archiv barcodemerger.vbs: kann datei nicht lschen."&file
            WScript.quit
        End If
    Next
    Set folder=Nothing
    WScript.sleep 500
    strPfadTemp=Left(strPfadTemp,Len(strPfadTemp)-1)
    
    fs.deletefolder strPfadTemp, True
    If Err.number<>0 Then
        objWshShell.LogEvent 1,"bitfarm-Archiv barcodemerger.vbs: kann Ordner nicht lschen."&strPfadTemp
        WScript.quit
    End If
End If



Set fs=Nothing


WScript.Quit



'################################################################################
'################################################################################
'################################################################################
'################################################################################
'################################################################################
'################################################################################
'##############################      Ende        ################################
'################################################################################
'################################################################################
'################################################################################
'################################################################################
'################################################################################
'################################################################################


Function mergebcarrays(idocbc,ipagebc)
    On Error Resume Next
    
    
    ' erstmal letzten eintag finden
    For ifrei = 0 To 49
        If docbarcode(idocbc,ifrei) = "" Then
            Exit For
        End If
        
    Next 
    
    
    If ifrei < 50 Then
        ' array bernehmen, dabei doppelte verwerfen
        For q = 0 To 49    ' alle pagebarcodes durchgehen
            found = False
            If pagebarcode(ipagebc,q) <> "" Then   'ist berhaupt was da ?
                For r = 0 To ifrei ' und gegen vorhandene eintrge des docbarcodes testen
                    
                    If pagebarcode(ipagebc,q) = docbarcode(idocbc,r) Then
                        ' doppelter eintrag gefunden
                        found = True
                        Exit For			
                    End If
                Next 
                If found = False And r <=49 Then    'wenn er nichts doppeltes gefunden hat und die schleife auch nicht durchgelaufen ist (r = 50) theoretisch nicht mglich aber zur sicherheit
                    docbarcode(idocbc,ifrei) = pagebarcode(ipagebc,q)
                    ifrei =ifrei +1
                    If ifrei = 30 Then
                        ' berlauf
                        Exit For
                    End If
                End If	
            End If
        Next 
    End If
    If scriptdebug = True Then
        msgstr = "Docbarcode(" & idocbc & "): " & vbCrLf
        For ii = 0 To 49
            msgstr = msgstr & ii & "= " & docbarcode(idocbc,ii) & vbCrLf 
        Next 
        objWshShell.LogEvent 4, msgstr
    End If
    
    
End Function


Function useeymbcrdcmd(mydocnumber)
    On Error Resume Next
    
    'MsgBox mydocnumber
    myfilename = mydocnumber
    strmask = ""
    bcsecondrun = ""
    gefunden = False
    turn=0
    'For i = 0 To 29
    '	barcode(i) = ""
    'Next
    If barcodemask <> "" Or barcodemask <> "" Then
        strmask = "-bctypes " & barcodemask & " "
    End If
    
    
    If barcodemode = 1 Then
        'myfilename = myfilename & "-bc"
        If fs.fileexists(programm&bcfilter) Then
            myfilename = Left(mydocnumber,Len(mydocnumber) - 4) & "-bc.tif"		
            lngReturnCode = objWSHShell.Run(programm&"bcfilterv3.bat "&strPfadTemp&mydocnumber&" "&programm&bcfilter&" "&strPfadTemp&myfilename ,0,True)
            
            If lngReturnCode<>0 Then
                Err.clear
                errortxt="bitfarm-Archiv: barcodemerger(1): Fehler beim Filtern der Tifdatei:"&lngReturnCode	
                objWshShell.LogEvent 1, errortxt
                'getgarbage(tempname)
                'Unlock(programm&lockdatei)
                'WScript.Quit
                myfilename = mydocnumber
                
            End If
            WScript.Sleep 300
            If Not fs.fileexists(strPfadTemp&myfilename) Then
                errortxt="bitfarm-Archiv:  barcodemerger(2): Fehler beim Filtern der Tifdatei"
                objWshShell.LogEvent 1, errortxt
                
                myfilename = mydocnumber
                'getgarbage(tempname)
                'Unlock(programm&lockdatei)
                'WScript.Quit
                Err.clear
            End If
            
            'fs.deletefile strPfadTemp&myfilename&".tif" , True
            'fs.copyfile strPfadTemp&myfilename & "-filter.tif" , strPfadTemp&myfilename&".tif" , True
            'fs.deletefile strPfadTemp&myfilename&"-filter.tif" , True
            'mydocnumber = strPfadTemp&myfilename & "-bc.tif"
        Else
            objWshShell.LogEvent 1, "Barcodemerger.vbs: Barcodefilter nicht vorhanden:" & bcfilter
        End If
    End If
    
    Do Until turn = 2 Or gefunden = True
        'MsgBox strmask & bcsecondrun
        Set oExec    = objWSHShell.Exec(eymbcrdcmdpath & " "& bcsecondrun & strmask  & temppath & myfilename )	
        
        Do While Not oExec.StdOut.AtEndOfStream
            strinput = strinput & oExec.StdOut.Read(1)	
        Loop
        
        'MsgBox strinput
        
        
        If InStr(1, strinput,"<NbCodes>") <> 0 Then
            nbcodes = strconvert(Mid(strinput,InStr(1, strinput,"<NbCodes>")+9, InStr(1, strinput,"</NbCodes>")- InStr(1, strinput,"<NbCodes>")-9))
        End If
        
        
        If nbcodes > 49 Then 
            nbcodes = 49
        End If
        
        For i = 0 To nbcodes
            If InStr(1, strinput,"<Data>") <> 0 Then
                'MsgBox oExec.Status
                mybarcode = Mid(strinput,InStr(1, strinput,"<Data>")+6, InStr(1, strinput,"</Data>")- InStr(1, strinput,"<Data>")-6)
                '############## mybarcode in barcode-array einsortieren ####################
                schonvorhanden=False
                For r=0 To 49
                    If barcode(r)=mybarcode Then
                        schonvorhanden=True
                    End If
                Next
                If schonvorhanden=False Then
                    r=0
                    gefunden=False
                    Do While gefunden=False
                        If barcode(r)="" Then
                            barcode(r)=mybarcode
                            gefunden=True
                        End If
                        If gefunden=False Then
                            r=r+1
                        End If
                        If r=50 Then
                            r=49
                            gefunden=True
                        End If
                    Loop
                End If
                '#################################################################
                
                
                strinput = Right(strinput,Len(strinput) - InStr(1, strinput,"</Data>") -6)
                'MsgBox strinput	
                'MsgBox barcode(i)		
            End If	
        Next 
        '			For i = 0 To nbcodes
        '			strbarcodes = strbarcodes & barcode(i) & vbcrlf
        '			Next 
        '		
        '			MsgBox strbarcodes
        
        '	For v= 0 To 9
        '				MsgBox "keybarcode("& v & ")=" & keybarcode(v) & vbCrlf & "Barcode(" & v&")=" & barcode(v)
        '			Next
        '	
        gefunden=False
        For y=0 To 49
            For z=0 To 49
                If keybarcode(z)<>"" Then
                    If barcode(y)<>"" Then
                        If Left(keybarcode(z), 9)="||regex||" Then
                            kb_re = Right(keybarcode(z), Len(keybarcode(z)) - 9)
                            Set objRE = New RegExp
                            objRE.Global     = False    ' Nur eine bereinstimmung  (die erste)
                            objRE.IgnoreCase = False
                            objRE.Pattern    = kb_re
                            Set colMatches = objRE.Execute(barcode(y))
                            hits = colMatches.Count
                            If hits > 0 Then
                                gefunden=True
                                stapelmode = False
                                mystapelbarcode=""	
                                If droppage(z)=1 Then
                                    dropfirstpage=True
                                End If		                    
                            End If
                        Else
                            If Len(barcode(y))>=Len(keybarcode(z)) Then
                                If LCase(Left(barcode(y),Len(keybarcode(z))))=LCase(keybarcode(z)) Then
                                    gefunden=True
                                    stapelmode = False
                                    mystapelbarcode=""	
                                    If droppage(z)=1 Then
                                        dropfirstpage=True
                                    End If
                                    
                                End If
                            End If
                        End If
                    End If
                End If 
            Next
        Next
        
        'Aktenbarcodes suchen
        For y=0 To 49
            For z=0 To 49
                If aktbarcode(z)<>"" Then
                    If barcode(y)<>"" Then
                        If Len(barcode(y))>=Len(aktbarcode(z)) Then
                            If LCase(Left(barcode(y),Len(aktbarcode(z))))=LCase(aktbarcode(z)) Then
                                gefunden=True
                                stapelmode = False
                                mystapelbarcode=""		
                                'myaktbarcode=barcode(y)
                                If dropaktpage(z)=1 Then
                                    
                                    dropfirstpage=True
                                End If
                                'MsgBox "Gefunden"
                                
                            End If
                        End If
                    End If
                End If
            Next
        Next
        
        ' Stapelbarcode suchen
        For y=0 To 49
            For z=0 To 49
                If stapelbarcode(z)<>"" Then
                    If barcode(y)<>"" Then
                        If Len(barcode(y))>=Len(aktbarcode(z)) Then
                            If LCase(Left(barcode(y),Len(stapelbarcode(z))))=LCase(stapelbarcode(z)) Then
                                stapelmode=True	 
                                'mystapelbarcode=stapelbarcode(z)	
                                mystapelbarcode=barcode(y)	
                                If dropstapelpage(z)=1 Then  
                                    dropfirstpage=True
                                End If	                             
                            End If
                        End If
                    End If
                End If
            Next
        Next    
        
        Set oExec = Nothing
        
        If gefunden = False Then
            If barcodesecondthreshold <> "" Then
                bcsecondrun = "-minconf 0," & barcodesecondthreshold & " "
                turn=turn+1
            Else
                turn = 2 
            End If
        End If
        
        strinput = ""
    Loop
    
    If Right(myfilename,7) = "-bc.tif" Then
        fs.deletefile temppath & myfilename,True
    End If
    
    'MsgBox gefunden & turn
    If stapelmode = True Then
        gefunden=True
    End If
    useeymbcrdcmd = gefunden
    
End Function






Function userdtifbar(mydocnumber)
    On Error Resume Next
    
    'MsgBox mydocnumber
    mydocnumber=Left(mydocnumber,Len(mydocnumber)-4)
    If mydocnumber<>"TRENNCODE" Then
        
        kette=kette&mydocnumber&vbCrLf
        
        runbarcode(temppath&mydocnumber)			
        
        
        'fs.deletefile temppath&"\TRENNCODE.TIF", true
    End If
    WScript.sleep 20
    
    
    If fs.fileexists(temppath&mydocnumber&".bar") Then
        Set barcodedatei = fs.OpenTextFile(temppath&mydocnumber&".bar",1)
        
        Do While barcodedatei.AtEndOfStream <> True 
            mybarcode=normstring(barcodedatei.readline)
            If mybarcode<>"" Then
                '############## mybarcode in barcode-array einsortieren ####################
                schonvorhanden=False
                For r=0 To 49
                    If barcode(r)=mybarcode Then
                        schonvorhanden=True
                    End If
                Next
                If schonvorhanden=False Then
                    r=0
                    gefunden=False
                    Do While gefunden=False
                        If barcode(r)="" Then
                            barcode(r)=mybarcode
                            gefunden=True
                        End If
                        If gefunden=False Then
                            r=r+1
                        End If
                        If r=50 Then
                            r=49
                            gefunden=True
                        End If
                    Loop
                    
                End If
                '#################################################################
            End If
            
        Loop
        barcodedatei.close
        Set barcodedatei=Nothing
        WScript.sleep 20
        fs.deletefile temppath&mydocnumber&".bar", True
        '			
        '			For v= 0 To 9
        '				MsgBox "keybarcode("& v & ")=" & keybarcode(v) & vbCrlf & "Barcode(" & v&")=" & barcode(v)
        '			Next
        '			
        
        
        
        
        gefunden=False
        For y=0 To 49
            For z=0 To 49
                If keybarcode(z)<>"" Then
                    If barcode(y)<>"" Then
                        If Left(keybarcode(z), 9)="||regex||" Then
                            kb_re = Right(keybarcode(z), Len(keybarcode(z)) - 9)
                            Set objRE = New RegExp
                            objRE.Global     = False    ' Nur eine bereinstimmung  (die erste)
                            objRE.IgnoreCase = False
                            objRE.Pattern    = kb_re
                            Set colMatches = objRE.Execute(barcode(y))
                            hits = colMatches.Count
                            If hits > 0 Then
                                gefunden=True
                                stapelmode = False
                                mystapelbarcode=""	
                                If droppage(z)=1 Then
                                    dropfirstpage=True
                                End If	
                            End If	                    
                        Else
                            If Len(barcode(y))>=Len(keybarcode(z)) Then
                                If LCase(Left(barcode(y),Len(keybarcode(z))))=LCase(keybarcode(z)) Then
                                    gefunden=True
                                    stapelmode = False
                                    mystapelbarcode=""	
                                    If droppage(z)=1 Then
                                        dropfirstpage=True
                                    End If
                                    
                                End If
                            End If
                        End If
                    End If
                End If   
            Next
        Next
        
        'Aktenbarcodes suchen
        For y=0 To 49
            For z=0 To 49
                If aktbarcode(z)<>"" Then
                    If barcode(y)<>"" Then
                        If Len(barcode(y))>=Len(aktbarcode(z)) Then
                            If LCase(Left(barcode(y),Len(aktbarcode(z))))=LCase(aktbarcode(z)) Then
                                gefunden=True
                                stapelmode = False
                                mystapelbarcode=""		
                                'myaktbarcode=barcode(y)
                                If dropaktpage(z)=1 Then
                                    
                                    dropfirstpage=True
                                End If
                                'MsgBox "Gefunden"
                                
                            End If
                        End If
                    End If
                End If
            Next
        Next
        
        ' Stapelbarcode suchen
        For y=0 To 49
            For z=0 To 49
                If stapelbarcode(z)<>"" Then
                    If barcode(y)<>"" Then
                        If Len(barcode(y))>=Len(aktbarcode(z)) Then
                            If LCase(Left(barcode(y),Len(stapelbarcode(z))))=LCase(stapelbarcode(z)) Then
                                stapelmode=True	 
                                'mystapelbarcode=stapelbarcode(z)	
                                mystapelbarcode=barcode(y)	
                                If dropstapelpage(z)=1 Then  
                                    dropfirstpage=True
                                End If	                             
                            End If
                        End If
                    End If
                End If
            Next
        Next       
        
        
    Else
        If mystapelbarcode<>"" Then
            barcode(0)=mystapelbarcode
        End If    
    End If
    
    '  Hier den Aufruf fr die zweite Barcodesuche
    '  nach dem zweiten Aufruf wird nochmal die .bar Datei nach inhalt durchsucht
    
    If gefunden = False And barcodesecondthreshold<>"" Then
        bcsecondrun = " -t:" & barcodesecondthreshold
        
        runbarcode(temppath&mydocnumber)
        
        bcsecondrun = ""
        WScript.sleep 20
        
        If fs.fileexists(temppath&mydocnumber&".bar") Then
            Set barcodedatei = fs.OpenTextFile(temppath&mydocnumber&".bar",1)
            
            Do While barcodedatei.AtEndOfStream <> True 
                mybarcode=normstring(barcodedatei.readline)
                
                '############## mybarcode in barcode-array einsortieren ####################
                schonvorhanden=False
                For r=0 To 49
                    If barcode(r)=mybarcode Then
                        schonvorhanden=True
                    End If
                Next
                If schonvorhanden=False Then
                    r=0
                    gefunden=False
                    Do While gefunden=False
                        If barcode(r)="" Then
                            barcode(r)=mybarcode
                            gefunden=True
                        End If
                        If gefunden=False Then
                            r=r+1
                        End If
                        If r=50 Then
                            r=49
                            gefunden=True
                        End If
                    Loop
                End If
                '#################################################################
            Loop
            barcodedatei.close
            Set barcodedatei=Nothing
            WScript.sleep 20
            fs.deletefile temppath&mydocnumber&".bar", True
            '			For v= 0 To 9
            '			MsgBox "2:keybarcode("& v & ")=" & keybarcode(v) & vbCrlf & "Barcode(" & v&")=" & barcode(v)
            '			Next
            '			
            
            gefunden=False
            For y=0 To 49
                For z=0 To 49
                    If keybarcode(z)<>"" Then
                        If barcode(y)<>"" Then
                            If Len(barcode(y))>=Len(keybarcode(z)) Then
                                If LCase(Left(barcode(y),Len(keybarcode(z))))=LCase(keybarcode(z)) Then
                                    gefunden=True	
                                    stapelmode = False
                                    mystapelbarcode=""	
                                    If droppage(z)=1 Then
                                        dropfirstpage=True
                                        
                                    End If
                                    'MsgBox "Secondrun:Gefunden"
                                    
                                End If
                            End If
                        End If
                    End If
                Next
            Next
            
            
            
            'Aktenbarcodes suchen
            For y=0 To 49
                For z=0 To 49
                    If aktbarcode(z)<>"" Then
                        If barcode(y)<>"" Then
                            If Len(barcode(y))>=Len(aktbarcode(z)) Then
                                If LCase(Left(barcode(y),Len(aktbarcode(z))))=LCase(aktbarcode(z)) Then
                                    gefunden=True
                                    stapelmode = False
                                    mystapelbarcode=""		
                                    'myaktbarcode=barcode(y)
                                    If dropaktpage(z)=1 Then
                                        
                                        dropfirstpage=True
                                    End If
                                    'MsgBox "Gefunden"
                                    
                                End If
                            End If
                        End If
                    End If
                Next
            Next
            
            ' Stapelbarcode suchen
            For y=0 To 49
                For z=0 To 49
                    If stapelbarcode(z)<>"" Then
                        If barcode(y)<>"" Then
                            If Len(barcode(y))>=Len(aktbarcode(z)) Then
                                If LCase(Left(barcode(y),Len(stapelbarcode(z))))=LCase(stapelbarcode(z)) Then
                                    stapelmode=True	 
                                    'mystapelbarcode=stapelbarcode(z)	
                                    mystapelbarcode=barcode(y)	
                                    If dropstapelpage(z)=1 Then  
                                        dropfirstpage=True
                                    End If	                             
                                End If
                            End If
                        End If
                    End If
                Next
            Next       
            
        End If
        
    End If
    
    If stapelmode = True Then
        gefunden=True
    End If
    userdtifbar = gefunden
End Function



Function usebcplus(mydocnumber)
    On Error Resume Next
    Set bcpexec = fs.getfile(bcpluspath)
    bcpdir = bcpexec.Parentfolder
    inidir = fs.getfolder(bcpdir&"\inis") 
    
    If inidir = Empty Then
        fs.createfolder(bcpdir&"\inis")
        fs.copyfile bcpdir&"\bcplus.ini", bcpdir&"\inis\bcplus.ini",True 
    End If
    
    inifiles = getfilenames(bcpdir&"\inis\","bcplus\d*.ini$")
    
    
    gotbarcode = False
    mydocnumber=Left(mydocnumber,Len(mydocnumber)-4)
    For Each inifile In inifiles
        fs.copyfile inifile, bcpdir&"\bcplus.ini",True 
        'MsgBox "bcplus:" & mydocnumber
        
        If mydocnumber<>"TRENNCODE" Then
            kette=kette&mydocnumber&vbCrLf
            runbcplus(temppath&mydocnumber)			
            
            'fs.deletefile temppath&"\TRENNCODE.TIF", true
        End If
        WScript.sleep 20
        
        newbarcodes = 0
        If fs.fileexists(temppath&mydocnumber&".bar") Then
            gotbarcode = True
            Set barcodedatei = fs.OpenTextFile(temppath&mydocnumber&".bar",1)
            
            Do While barcodedatei.AtEndOfStream <> True 
                mybarcode=barcodedatei.readline
                '############## mybarcode in barcode-array einsortieren ####################
                schonvorhanden=False
                For r=0 To 49
                    If barcode(r)=mybarcode Then
                        schonvorhanden=True
                    End If
                Next
                If schonvorhanden=False Then
                    newbarcodes = newbarcodes + 1
                    r=0
                    gefunden=False
                    Do While gefunden=False
                        If barcode(r)="" Then
                            barcode(r)=mybarcode
                            gefunden=True
                        End If
                        If gefunden=False Then
                            r=r+1
                        End If
                        If r=50 Then
                            r=49
                            gefunden=True
                        End If
                    Loop
                End If
                '#################################################################
            Loop
            barcodedatei.close
            Set barcodedatei=Nothing
            WScript.sleep 20
            fs.deletefile temppath&mydocnumber&".bar", True
            If scriptdebug=True Then
                objwshshell.LogEvent 0, "barcodemerger.vbs debug: mit " & inifile & " " & newbarcodes & " gefunden!"
            End If
        End If
    Next
    
    If gotbarcode=True Then
        
        gefunden=False
        
        For y=0 To 49
            For z=0 To 49
                If keybarcode(z)<>"" Then
                    If barcode(y)<>"" Then
                        If Left(keybarcode(z), 9)="||regex||" Then
                            kb_re = Right(keybarcode(z), Len(keybarcode(z)) - 9)
                            Set objRE = New RegExp
                            objRE.Global     = False    ' Nur eine bereinstimmung  (die erste)
                            objRE.IgnoreCase = False
                            objRE.Pattern    = kb_re
                            Set colMatches = objRE.Execute(barcode(y))
                            hits = colMatches.Count
                            If hits > 0 Then
                                gefunden=True
                                stapelmode = False
                                mystapelbarcode=""	
                                If droppage(z)=1 Then
                                    dropfirstpage=True
                                End If		                    
                            End If
                        Else
                            If Len(barcode(y))>=Len(keybarcode(z)) Then
                                If LCase(Left(barcode(y),Len(keybarcode(z))))=LCase(keybarcode(z)) Then
                                    gefunden=True
                                    stapelmode = False
                                    mystapelbarcode=""	
                                    If droppage(z)=1 Then
                                        dropfirstpage=True
                                    End If
                                    
                                End If
                            End If
                        End If
                    End If
                End If
            Next
        Next
        
        'Aktenbarcodes suchen
        For y=0 To 49
            For z=0 To 49
                If aktbarcode(z)<>"" Then
                    If barcode(y)<>"" Then
                        If Len(barcode(y))>=Len(aktbarcode(z)) Then
                            If LCase(Left(barcode(y),Len(aktbarcode(z))))=LCase(aktbarcode(z)) Then
                                gefunden=True
                                stapelmode = False
                                mystapelbarcode=""		
                                'myaktbarcode=barcode(y)
                                If dropaktpage(z)=1 Then
                                    dropfirstpage=True
                                End If
                                'MsgBox "Gefunden"
                                
                            End If
                        End If
                    End If
                End If
            Next
        Next
        
        ' Stapelbarcode suchen
        For y=0 To 49
            For z=0 To 49
                If stapelbarcode(z)<>"" Then
                    If barcode(y)<>"" Then
                        If Len(barcode(y))>=Len(aktbarcode(z)) Then
                            If LCase(Left(barcode(y),Len(stapelbarcode(z))))=LCase(stapelbarcode(z)) Then
                                stapelmode=True	 
                                'mystapelbarcode=stapelbarcode(z)	
                                mystapelbarcode=barcode(y)
                                If dropstapelpage(z)=1 Then  
                                    dropfirstpage=True
                                End If	                             
                            End If
                        End If
                    End If
                End If
            Next
        Next
    Else
        If mystapelbarcode<>"" Then
            barcode(0)=mystapelbarcode
        End If        
    End If
    
    If stapelmode = True Then
        gefunden=True
    End If
    usebcplus = gefunden
    
End Function


Function usebcplus_old(mydocnumber)
    On Error Resume Next
    
    'MsgBox "bcplus:" & mydocnumber
    mydocnumber=Left(mydocnumber,Len(mydocnumber)-4)
    If mydocnumber<>"TRENNCODE" Then
        kette=kette&mydocnumber&vbCrLf
        runbcplus(temppath&mydocnumber)			
        
        'fs.deletefile temppath&"\TRENNCODE.TIF", true
    End If
    WScript.sleep 20
    
    
    If fs.fileexists(temppath&mydocnumber&".bar") Then
        Set barcodedatei = fs.OpenTextFile(temppath&mydocnumber&".bar",1)
        
        Do While barcodedatei.AtEndOfStream <> True 
            mybarcode=barcodedatei.readline
            '############## mybarcode in barcode-array einsortieren ####################
            schonvorhanden=False
            For r=0 To 49
                If barcode(r)=mybarcode Then
                    schonvorhanden=True
                End If
            Next
            If schonvorhanden=False Then
                r=0
                gefunden=False
                Do While gefunden=False
                    If barcode(r)="" Then
                        barcode(r)=mybarcode
                        gefunden=True
                    End If
                    If gefunden=False Then
                        r=r+1
                    End If
                    If r=50 Then
                        r=49
                        gefunden=True
                    End If
                Loop
            End If
            '#################################################################
        Loop
        barcodedatei.close
        Set barcodedatei=Nothing
        WScript.sleep 20
        fs.deletefile temppath&mydocnumber&".bar", True
        
        
        gefunden=False
        
        For y=0 To 49
            For z=0 To 49
                If keybarcode(z)<>"" Then
                    If barcode(y)<>"" Then
                        If Left(keybarcode(z), 9)="||regex||" Then
                            kb_re = Right(keybarcode(z), Len(keybarcode(z)) - 9)
                            Set objRE = New RegExp
                            objRE.Global     = False    ' Nur eine bereinstimmung  (die erste)
                            objRE.IgnoreCase = False
                            objRE.Pattern    = kb_re
                            Set colMatches = objRE.Execute(barcode(y))
                            hits = colMatches.Count
                            If hits > 0 Then
                                gefunden=True
                                stapelmode = False
                                mystapelbarcode=""	
                                If droppage(z)=1 Then
                                    dropfirstpage=True
                                End If		                    
                            End If
                        Else
                            If Len(barcode(y))>=Len(keybarcode(z)) Then
                                If LCase(Left(barcode(y),Len(keybarcode(z))))=LCase(keybarcode(z)) Then
                                    gefunden=True
                                    stapelmode = False
                                    mystapelbarcode=""	
                                    If droppage(z)=1 Then
                                        dropfirstpage=True
                                    End If
                                    
                                End If
                            End If
                        End If
                    End If
                End If
            Next
        Next
        
        'Aktenbarcodes suchen
        For y=0 To 49
            For z=0 To 49
                If aktbarcode(z)<>"" Then
                    If barcode(y)<>"" Then
                        If Len(barcode(y))>=Len(aktbarcode(z)) Then
                            If LCase(Left(barcode(y),Len(aktbarcode(z))))=LCase(aktbarcode(z)) Then
                                gefunden=True
                                stapelmode = False
                                mystapelbarcode=""		
                                'myaktbarcode=barcode(y)
                                If dropaktpage(z)=1 Then
                                    dropfirstpage=True
                                End If
                                'MsgBox "Gefunden"
                                
                            End If
                        End If
                    End If
                End If
            Next
        Next
        
        ' Stapelbarcode suchen
        For y=0 To 49
            For z=0 To 49
                If stapelbarcode(z)<>"" Then
                    If barcode(y)<>"" Then
                        If Len(barcode(y))>=Len(aktbarcode(z)) Then
                            If LCase(Left(barcode(y),Len(stapelbarcode(z))))=LCase(stapelbarcode(z)) Then
                                stapelmode=True	 
                                'mystapelbarcode=stapelbarcode(z)	
                                mystapelbarcode=barcode(y)	
                                If dropstapelpage(z)=1 Then  
                                    dropfirstpage=True
                                End If	                             
                            End If
                        End If
                    End If
                End If
            Next
        Next       
        
        
        
        
    Else
        If mystapelbarcode<>"" Then
            barcode(0)=mystapelbarcode
        End If    
    End If
    
    '  Hier den Aufruf fr die zweite Barcodesuche, mit bergabe eines anderen Parameters
    '  nach dem zweiten Aufruf wird nochmal die .bar Datei nach inhalt durchsucht
    
    '	If gefunden = False And barcodesecondthreshold<>"" Then
    '		
    '		bcsecondrun = " -t:" & barcodesecondthreshold
    '		
    '		runbcplus(temppath&mydocnumber)
    '		
    '		bcsecondrun = ""
    '		wscript.sleep 20
    '
    '		If fs.fileexists(temppath&mydocnumber&".bar") Then
    '			
    '		
    '		  i=0
    '			Set barcodedatei = fs.OpenTextFile(temppath&mydocnumber&".bar",1)
    '			
    '			Do While barcodedatei.AtEndOfStream <> True 
    '				barcode(i)=barcodedatei.readline
    '				'MsgBox barcode(i)
    '				i=i+1
    '			Loop
    '			barcodedatei.close
    '			Set barcodedatei=nothing
    '			wscript.sleep 20
    '			'fs.deletefile temppath&mydocnumber&".bar", true
    '			For v= 0 To 9
    '			MsgBox "2:keybarcode("& v & ")=" & keybarcode(v) & vbCrlf & "Barcode(" & v&")=" & barcode(v)
    '			Next
    '			
    '			
    '			gefunden=false
    '			For y=0 to 9
    '					For z=0 to 9
    '							If keybarcode(z)<>"" Then
    '								If barcode(y)<>"" Then
    '									If Len(barcode(y))>=Len(keybarcode(z)) Then
    '									If LCase(Left(barcode(y),Len(keybarcode(z))))=LCase(keybarcode(z)) Then
    '											gefunden=true	
    '											MsgBox "BCPLUS: Secondrun:Gefunden"
    '													
    '									End If
    '									End If
    '								End If
    '							End If
    '					Next
    '			Next
    '		End If
    '
    '
    '	End If
    If stapelmode = True Then
        gefunden=True
    End If
    usebcplus = gefunden
End Function











Function Zufallszahl(von, bis)
    On Error Resume Next
    anzahl = bis-von+1
    Randomize
    Zufallszahl = Fix(Rnd*(anzahl))+von
End Function



'################################################################################
'################################################################################
'################################################################################




Function inilesen()
    On Error Resume Next
    
    Err.clear
    Set inifile = fs.OpenTextFile(programm&"scripts.ini",1)
    If Err.number Then
        'MsgBox("Fehler: scripts.ini nicht im Scriptpfad vorhanden oder nicht lesbar.")
        Err.clear
        WScript.Quit
    End If 
    
    kette=inifile.readline
    Scriptsflag=InStr(1,kette,"[Scripts]")
    Do While Scriptsflag = 0
        kette=inifile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        If inifile.AtEndOfStream = True Then
            inifile.close
            'MsgBox("Fehler beim Lesen der scripts.ini - falsche Formatierung.")
            WScript.Quit
        End If
    Loop
    
    barcodenow=0 'Index, welcher Barcode gerade in der ini-Datei gemeint ist, zur Zuordnung der Anweisung dropkeybarcodepage=true
    stapelbarcodeindex = 0 
    Do While inifile.AtEndOfStream <> True
        kette=inifile.readline
        If Left(kette,1)<>";" Then
            
            
            
            If InStr(1,kette,"scannerpagecountinfo",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"scannerpagecountinfo",1)+21)
                If LCase(wert)="true" Then
                    scannerpagecountinfo = True
                End If	
            End If
            
            If InStr(1,kette,"stapelbarcode01",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode01=",1)+16)
                stapelbarcode(0)=wert
                stapelbarcodeindex = 0
            End If
            If InStr(1,kette,"stapelbarcode02",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode02=",1)+16)
                stapelbarcode(1)=wert
                stapelbarcodeindex = 1
            End If
            If InStr(1,kette,"stapelbarcode03",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode03=",1)+16)
                stapelbarcode(2)=wert
                stapelbarcodeindex = 2
            End If
            If InStr(1,kette,"stapelbarcode04",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode04=",1)+16)
                stapelbarcode(3)=wert
                stapelbarcodeindex = 3
            End If
            If InStr(1,kette,"stapelbarcode05",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode05=",1)+16)
                stapelbarcode(4)=wert
                stapelbarcodeindex = 4
            End If
            If InStr(1,kette,"stapelbarcode06",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode06=",1)+16)
                stapelbarcode(5)=wert
                stapelbarcodeindex = 5
            End If
            If InStr(1,kette,"stapelbarcode07",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode07=",1)+16)
                stapelbarcode(6)=wert
                stapelbarcodeindex = 6
            End If
            If InStr(1,kette,"stapelbarcode08",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode08=",1)+16)
                stapelbarcode(7)=wert
                stapelbarcodeindex = 7
            End If
            If InStr(1,kette,"stapelbarcode09",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode09=",1)+16)
                stapelbarcode(8)=wert
                stapelbarcodeindex = 8
            End If
            If InStr(1,kette,"stapelbarcode10",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode10=",1)+16)
                stapelbarcode(9)=wert
                stapelbarcodeindex = 9
            End If
            If InStr(1,kette,"stapelbarcode11",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode11=",1)+16)
                stapelbarcode(10)=wert
                stapelbarcodeindex = 10
            End If
            If InStr(1,kette,"stapelbarcode12",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode12=",1)+16)
                stapelbarcode(11)=wert
                stapelbarcodeindex = 11
            End If
            If InStr(1,kette,"stapelbarcode13",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode13=",1)+16)
                stapelbarcode(12)=wert
                stapelbarcodeindex = 12
            End If
            If InStr(1,kette,"stapelbarcode14",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode14=",1)+16)
                stapelbarcode(13)=wert
                stapelbarcodeindex = 13
            End If
            If InStr(1,kette,"stapelbarcode15",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode15=",1)+16)
                stapelbarcode(14)=wert
                stapelbarcodeindex = 14
            End If
            If InStr(1,kette,"stapelbarcode16",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode16=",1)+16)
                stapelbarcode(15)=wert
                stapelbarcodeindex = 15
            End If
            
            If InStr(1,kette,"stapelbarcode17",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode17=",1)+16)
                stapelbarcode(16)=wert
                stapelbarcodeindex = 16
            End If
            If InStr(1,kette,"stapelbarcode18",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode18=",1)+16)
                stapelbarcode(17)=wert
                stapelbarcodeindex = 17
            End If
            If InStr(1,kette,"stapelbarcode19",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode19=",1)+16)
                stapelbarcode(18)=wert
                stapelbarcodeindex = 18
            End If
            If InStr(1,kette,"stapelbarcode20",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode20=",1)+16)
                stapelbarcode(19)=wert
                stapelbarcodeindex = 19
            End If
            If InStr(1,kette,"stapelbarcode21",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode21=",1)+16)
                stapelbarcode(20)=wert
                stapelbarcodeindex = 20
            End If
            If InStr(1,kette,"stapelbarcode22",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode22=",1)+16)
                stapelbarcode(21)=wert
                stapelbarcodeindex = 21
            End If
            If InStr(1,kette,"stapelbarcode23",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode23=",1)+16)
                stapelbarcode(22)=wert
                stapelbarcodeindex = 22
            End If
            If InStr(1,kette,"stapelbarcode24",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode24=",1)+16)
                stapelbarcode(23)=wert
                stapelbarcodeindex = 23
            End If
            If InStr(1,kette,"stapelbarcode25",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode25=",1)+16)
                stapelbarcode(24)=wert
                stapelbarcodeindex = 24
            End If
            If InStr(1,kette,"stapelbarcode26",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode26=",1)+16)
                stapelbarcode(25)=wert
                stapelbarcodeindex = 25
            End If
            If InStr(1,kette,"stapelbarcode27",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode27=",1)+16)
                stapelbarcode(26)=wert
                stapelbarcodeindex = 26
            End If
            If InStr(1,kette,"stapelbarcode28",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode28=",1)+16)
                stapelbarcode(27)=wert
                stapelbarcodeindex = 27
            End If
            If InStr(1,kette,"stapelbarcode14",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode14=",1)+16)
                stapelbarcode(13)=wert
                stapelbarcodeindex = 13
            End If
            If InStr(1,kette,"stapelbarcode29",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode29=",1)+16)
                stapelbarcode(28)=wert
                stapelbarcodeindex = 28
            End If            
            If InStr(1,kette,"stapelbarcode30",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode30=",1)+16)
                stapelbarcode(29)=wert
                stapelbarcodeindex = 29
            End If
            If InStr(1,kette,"stapelbarcode31",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode31=",1)+16)
                stapelbarcode(30)=wert
                stapelbarcodeindex = 30
            End If                 
            If InStr(1,kette,"stapelbarcode32",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode32=",1)+16)
                stapelbarcode(31)=wert
                stapelbarcodeindex = 31
            End If                 
            If InStr(1,kette,"stapelbarcode33",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode33=",1)+16)
                stapelbarcode(32)=wert
                stapelbarcodeindex = 32
            End If                 
            If InStr(1,kette,"stapelbarcode34",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode34=",1)+16)
                stapelbarcode(33)=wert
                stapelbarcodeindex = 33
            End If                 
            If InStr(1,kette,"stapelbarcode35",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode35=",1)+16)
                stapelbarcode(34)=wert
                stapelbarcodeindex = 34
            End If                 
            If InStr(1,kette,"stapelbarcode36",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode36=",1)+16)
                stapelbarcode(35)=wert
                stapelbarcodeindex = 35
            End If                 
            If InStr(1,kette,"stapelbarcode37",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode37=",1)+16)
                stapelbarcode(36)=wert
                stapelbarcodeindex = 36
            End If                 
            If InStr(1,kette,"stapelbarcode38",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode38=",1)+16)
                stapelbarcode(37)=wert
                stapelbarcodeindex = 37
            End If                 
            If InStr(1,kette,"stapelbarcode39",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode39=",1)+16)
                stapelbarcode(38)=wert
                stapelbarcodeindex = 38
            End If                 
            If InStr(1,kette,"stapelbarcode40",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode40=",1)+16)
                stapelbarcode(39)=wert
                stapelbarcodeindex = 39
            End If                 
            If InStr(1,kette,"stapelbarcode41",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode41=",1)+16)
                stapelbarcode(40)=wert
                stapelbarcodeindex = 40
            End If                 
            If InStr(1,kette,"stapelbarcode42",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode42=",1)+16)
                stapelbarcode(41)=wert
                stapelbarcodeindex = 41
            End If                 
            If InStr(1,kette,"stapelbarcode43",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode43=",1)+16)
                stapelbarcode(42)=wert
                stapelbarcodeindex = 42
            End If                 
            If InStr(1,kette,"stapelbarcode44",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode44=",1)+16)
                stapelbarcode(43)=wert
                stapelbarcodeindex = 43
            End If                 
            If InStr(1,kette,"stapelbarcode45",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode45=",1)+16)
                stapelbarcode(44)=wert
                stapelbarcodeindex = 44
            End If                 
            If InStr(1,kette,"stapelbarcode46",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode46=",1)+16)
                stapelbarcode(45)=wert
                stapelbarcodeindex = 45
            End If                 
            If InStr(1,kette,"stapelbarcode47",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode47=",1)+16)
                stapelbarcode(46)=wert
                stapelbarcodeindex = 46
            End If                 
            If InStr(1,kette,"stapelbarcode48",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode48=",1)+16)
                stapelbarcode(47)=wert
                stapelbarcodeindex = 47
            End If                 
            If InStr(1,kette,"stapelbarcode49",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode49=",1)+16)
                stapelbarcode(48)=wert
                stapelbarcodeindex = 48
            End If                 
            If InStr(1,kette,"stapelbarcode50",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stapelbarcode50=",1)+16)
                stapelbarcode(49)=wert
                stapelbarcodeindex = 49
            End If                 
            
            
            
            
            
            
            
            
            If InStr(1,kette,"keybarcode01",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode01",1)+13)
                keybarcode(0)=wert
                barcodenow=0
            End If
            If InStr(1,kette,"keybarcode02",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode02",1)+13)
                keybarcode(1)=wert
                barcodenow=1
            End If
            If InStr(1,kette,"keybarcode03",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode03",1)+13)
                keybarcode(2)=wert
                barcodenow=2
            End If
            If InStr(1,kette,"keybarcode04",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode04",1)+13)
                keybarcode(3)=wert
                barcodenow=3
            End If
            If InStr(1,kette,"keybarcode05",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode05",1)+13)
                keybarcode(4)=wert
                barcodenow=4
            End If
            If InStr(1,kette,"keybarcode06",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode06",1)+13)
                keybarcode(5)=wert
                barcodenow=5
            End If
            If InStr(1,kette,"keybarcode07",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode07",1)+13)
                keybarcode(6)=wert
                barcodenow=6
            End If
            If InStr(1,kette,"keybarcode08",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode08",1)+13)
                keybarcode(7)=wert
                barcodenow=7
            End If
            If InStr(1,kette,"keybarcode09",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode09",1)+13)
                keybarcode(8)=wert
                barcodenow=8
            End If
            If InStr(1,kette,"keybarcode10",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode10",1)+13)
                keybarcode(9)=wert
                barcodenow=9
            End If
            If InStr(1,kette,"keybarcode11",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode11",1)+13)
                keybarcode(10)=wert
                barcodenow=10
            End If
            If InStr(1,kette,"keybarcode12",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode12",1)+13)
                keybarcode(11)=wert
                barcodenow=11
            End If
            If InStr(1,kette,"keybarcode13",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode13",1)+13)
                keybarcode(12)=wert
                barcodenow=12
            End If
            If InStr(1,kette,"keybarcode14",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode14",1)+13)
                keybarcode(13)=wert
                barcodenow=13
            End If
            If InStr(1,kette,"keybarcode15",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode15",1)+13)
                keybarcode(14)=wert
                barcodenow=14
            End If
            If InStr(1,kette,"keybarcode16",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode16",1)+13)
                keybarcode(15)=wert
                barcodenow=15
            End If
            If InStr(1,kette,"keybarcode17",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode17",1)+13)
                keybarcode(16)=wert
                barcodenow=16
            End If
            If InStr(1,kette,"keybarcode18",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode18",1)+13)
                keybarcode(17)=wert
                barcodenow=17
            End If
            If InStr(1,kette,"keybarcode19",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode19",1)+13)
                keybarcode(18)=wert
                barcodenow=18
            End If
            If InStr(1,kette,"keybarcode20",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode20",1)+13)
                keybarcode(19)=wert
                barcodenow=19
            End If
            If InStr(1,kette,"keybarcode21",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode21",1)+13)
                keybarcode(20)=wert
                barcodenow=20
            End If
            If InStr(1,kette,"keybarcode22",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode22",1)+13)
                keybarcode(21)=wert
                barcodenow=21
            End If
            If InStr(1,kette,"keybarcode23",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode23",1)+13)
                keybarcode(22)=wert
                barcodenow=22
            End If
            If InStr(1,kette,"keybarcode24",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode24",1)+13)
                keybarcode(23)=wert
                barcodenow=23
            End If
            If InStr(1,kette,"keybarcode25",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode25",1)+13)
                keybarcode(24)=wert
                barcodenow=24
            End If
            If InStr(1,kette,"keybarcode26",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode26",1)+13)
                keybarcode(25)=wert
                barcodenow=25
            End If
            If InStr(1,kette,"keybarcode27",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode27",1)+13)
                keybarcode(26)=wert
                barcodenow=26
            End If
            If InStr(1,kette,"keybarcode28",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode28",1)+13)
                keybarcode(27)=wert
                barcodenow=27
            End If
            If InStr(1,kette,"keybarcode29",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode29",1)+13)
                keybarcode(28)=wert
                barcodenow=28
            End If
            If InStr(1,kette,"keybarcode30",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode30",1)+13)
                keybarcode(29)=wert
                barcodenow=29
            End If
            If InStr(1,kette,"keybarcode31",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode31",1)+13)
                keybarcode(30)=wert
                barcodenow=30
            End If
            If InStr(1,kette,"keybarcode32",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode32",1)+13)
                keybarcode(31)=wert
                barcodenow=31
            End If
            If InStr(1,kette,"keybarcode33",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode33",1)+13)
                keybarcode(32)=wert
                barcodenow=32
            End If
            If InStr(1,kette,"keybarcode34",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode34",1)+13)
                keybarcode(33)=wert
                barcodenow=33
            End If
            If InStr(1,kette,"keybarcode35",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode35",1)+13)
                keybarcode(34)=wert
                barcodenow=34
            End If
            If InStr(1,kette,"keybarcode36",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode36",1)+13)
                keybarcode(35)=wert
                barcodenow=35
            End If
            If InStr(1,kette,"keybarcode37",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode37",1)+13)
                keybarcode(36)=wert
                barcodenow=36
            End If
            If InStr(1,kette,"keybarcode38",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode38",1)+13)
                keybarcode(37)=wert
                barcodenow=37
            End If
            If InStr(1,kette,"keybarcode39",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode39",1)+13)
                keybarcode(38)=wert
                barcodenow=38
            End If
            If InStr(1,kette,"keybarcode40",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode40",1)+13)
                keybarcode(39)=wert
                barcodenow=39
            End If
            If InStr(1,kette,"keybarcode41",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode41",1)+13)
                keybarcode(40)=wert
                barcodenow=40
            End If
            If InStr(1,kette,"keybarcode42",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode42",1)+13)
                keybarcode(41)=wert
                barcodenow=41
            End If
            If InStr(1,kette,"keybarcode43",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode43",1)+13)
                keybarcode(42)=wert
                barcodenow=42
            End If
            If InStr(1,kette,"keybarcode44",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode44",1)+13)
                keybarcode(43)=wert
                barcodenow=43
            End If
            If InStr(1,kette,"keybarcode45",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode45",1)+13)
                keybarcode(44)=wert
                barcodenow=44
            End If
            If InStr(1,kette,"keybarcode46",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode46",1)+13)
                keybarcode(45)=wert
                barcodenow=45
            End If
            If InStr(1,kette,"keybarcode47",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode47",1)+13)
                keybarcode(46)=wert
                barcodenow=46
            End If
            If InStr(1,kette,"keybarcode48",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode48",1)+13)
                keybarcode(47)=wert
                barcodenow=47
            End If
            If InStr(1,kette,"keybarcode49",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode49",1)+13)
                keybarcode(48)=wert
                barcodenow=48
            End If
            If InStr(1,kette,"keybarcode50",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"keybarcode50",1)+13)
                keybarcode(49)=wert
                barcodenow=49
            End If
            
            
            
            
            
            
            
            
            
            
            
            If InStr(1,kette,"aktbarcode01",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode01",1)+13)
                aktbarcode(0)=wert
                barcodenow=0
            End If
            If InStr(1,kette,"aktbarcode02",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode02",1)+13)
                aktbarcode(1)=wert
                barcodenow=1
            End If
            If InStr(1,kette,"aktbarcode03",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode03",1)+13)
                aktbarcode(2)=wert
                barcodenow=2
            End If
            If InStr(1,kette,"aktbarcode04",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode04",1)+13)
                aktbarcode(3)=wert
                barcodenow=3
            End If
            If InStr(1,kette,"aktbarcode05",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode05",1)+13)
                aktbarcode(4)=wert
                barcodenow=4
            End If
            If InStr(1,kette,"aktbarcode06",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode06",1)+13)
                aktbarcode(5)=wert
                barcodenow=5
            End If
            If InStr(1,kette,"aktbarcode07",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode07",1)+13)
                aktbarcode(6)=wert
                barcodenow=6
            End If
            If InStr(1,kette,"aktbarcode08",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode08",1)+13)
                aktbarcode(7)=wert
                barcodenow=7
            End If
            If InStr(1,kette,"aktbarcode09",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode09",1)+13)
                aktbarcode(8)=wert
                barcodenow=8
            End If
            If InStr(1,kette,"aktbarcode10",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode10",1)+13)
                aktbarcode(9)=wert
                barcodenow=9
            End If
            If InStr(1,kette,"aktbarcode11",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode11",1)+13)
                aktbarcode(10)=wert
                barcodenow=10
            End If
            If InStr(1,kette,"aktbarcode12",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode12",1)+13)
                aktbarcode(11)=wert
                barcodenow=11
            End If
            If InStr(1,kette,"aktbarcode13",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode13",1)+13)
                aktbarcode(12)=wert
                barcodenow=12
            End If
            If InStr(1,kette,"aktbarcode14",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode14",1)+13)
                aktbarcode(13)=wert
                barcodenow=13
            End If
            If InStr(1,kette,"aktbarcode15",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode15",1)+13)
                aktbarcode(14)=wert
                barcodenow=14
            End If
            If InStr(1,kette,"aktbarcode16",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode16",1)+13)
                aktbarcode(15)=wert
                barcodenow=15
            End If
            If InStr(1,kette,"aktbarcode17",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode17",1)+13)
                aktbarcode(16)=wert
                barcodenow=16
            End If
            If InStr(1,kette,"aktbarcode18",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode18",1)+13)
                aktbarcode(17)=wert
                barcodenow=17
            End If
            If InStr(1,kette,"aktbarcode19",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode19",1)+13)
                aktbarcode(18)=wert
                barcodenow=18
            End If
            If InStr(1,kette,"aktbarcode20",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode20",1)+13)
                aktbarcode(19)=wert
                barcodenow=19
            End If
            If InStr(1,kette,"aktbarcode21",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode21",1)+13)
                aktbarcode(20)=wert
                barcodenow=20
            End If
            If InStr(1,kette,"aktbarcode22",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode22",1)+13)
                aktbarcode(21)=wert
                barcodenow=21
            End If
            If InStr(1,kette,"aktbarcode23",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode23",1)+13)
                aktbarcode(22)=wert
                barcodenow=22
            End If
            If InStr(1,kette,"aktbarcode24",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode24",1)+13)
                aktbarcode(23)=wert
                barcodenow=23
            End If
            If InStr(1,kette,"aktbarcode25",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode25",1)+13)
                aktbarcode(24)=wert
                barcodenow=24
            End If
            If InStr(1,kette,"aktbarcode26",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode26",1)+13)
                aktbarcode(25)=wert
                barcodenow=25
            End If
            If InStr(1,kette,"aktbarcode27",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode27",1)+13)
                aktbarcode(26)=wert
                barcodenow=26
            End If
            If InStr(1,kette,"aktbarcode28",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode28",1)+13)
                aktbarcode(27)=wert
                barcodenow=27
            End If
            If InStr(1,kette,"aktbarcode29",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode29",1)+13)
                aktbarcode(28)=wert
                barcodenow=28
            End If
            If InStr(1,kette,"aktbarcode30",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"aktbarcode30",1)+13)
                aktbarcode(29)=wert
                barcodenow=29
            End If
            
            
            If InStr(1,kette,"dropkeybarcodepage=true",1)<>0 Then
                droppage(barcodenow)=1
            End If
            
            If InStr(1,kette,"dropaktbarcodepage=true",1)<>0 Then
                dropaktpage(barcodenow)=1
            End If
            
            If InStr(1,kette,"dropstapelbarcodepage=true",1)<>0 Then
                dropstapelpage(stapelbarcodeindex)=1
            End If
            
            If InStr(1,kette,"linkcounter",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"linkcounter",1)+12)
                linkcounter(barcodenow)=wert
            End If            
            
            If InStr(1,kette,"barcodemask",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"barcodemask",1)+12)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    barcodemask=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"barcodemode",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"barcodemode",1)+12)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    barcodemode=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"barcodesecondthreshold",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"barcodesecondthreshold",1)+23)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    barcodesecondthreshold=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"eymbcrdcmdpath",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"eymbcrdcmdpath",1)+15)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    eymbcrdcmdpath=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"bcpluspath",1)<>0 Then
                wert = Right(kette,Len(kette) -11)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    bcpluspath=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"master_uebergabe",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"master_uebergabe=",1)+17)
                master_uebergabe=wert
            End If
            
            
        End If
        
    Loop
    inifile.close
    Set inifile = Nothing
    If programm="" Then
        objWshShell.LogEvent 2, "Fehler beim Lesen der scripts.ini - kein Programmpfad."
        WScript.Quit
    End If
    
    
End Function







'***************************************************************************************
'***************************************************************************************
'***************************************************************************************




Function runbarcode(tempname)
    On Error Resume Next
    'MsgBox "bcsecondrun=" & bcsecondrun
    
    
    runbarcode=True
    If (fs.fileexists(tempname&".tif")) And (Not fs.fileexists(tempname&".bar")) Then
        If (barcodemode="") Or (barcodemode="0") Then
            Err.clear
            If barcodemask="" Then
                
                lngReturnCode = objWSHShell.Run(programm&"rdtifbar.exe "&tempname&".tif"& bcsecondrun,0,True)
                
                
            Else
                
                lngReturnCode = objWSHShell.Run(programm&"rdtifbar.exe "&tempname&".tif -p:"&barcodemask & bcsecondrun,0,True)
            End If
            
            If Err.number<>0 Then
                errortxt="archivierung(18eg): Fehler beim starten von rdtifbar ("&tempname&".tif). Errornummer: "&Err.number
                objWshShell.LogEvent 1, errortxt
                runbarcode=False
            End If
        ElseIf barcodemode="1" Then
            If fs.fileexists(tempname&".ttd") Then
                fs.deletefile tempname&".ttd", True
            End If
            If fs.fileexists(programm&bcfilter) Then
                'MsgBox bcfilter
                lngReturnCode = objWSHShell.Run(programm&"bcfilterv3.bat "&tempname&".tif "&programm&bcfilter&" "&tempname&"-bc.tif",0,True)
                
                If lngReturnCode<>0 Then
                    Err.clear
                    errortxt="bitfarm-Archiv: Archivierung(jo): Fehler beim Filtern der Tifdatei:"&lngReturnCode	
                    objWshShell.LogEvent 1, errortxt
                    getgarbage(tempname)
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If
                WScript.Sleep 300
                If Not fs.fileexists(tempname&"-bc.tif") Then
                    errortxt="bitfarm-Archiv: Archivierung(jx): Fehler beim Filtern der Tifdatei"
                    objWshShell.LogEvent 1, errortxt
                    getgarbage(tempname)
                    Unlock(programm&lockdatei)
                    WScript.Quit
                    Err.clear
                End If
            Else
                objWshShell.LogEvent 1, "Barcodemerger.vbs: Barcodefilter nicht vorhanden:" & bcfilter
                runbarcode=False
            End If	
            If runbarcode=True Then
                If barcodemask="" Then
                    lngReturnCode = objWSHShell.Run(programm&"rdtifbar.exe "&tempname&"-bc.tif"& bcsecondrun,0,True)
                Else
                    'MsgBox "barcodemask=" & barcodemask
                    lngReturnCode = objWSHShell.Run(programm&"rdtifbar.exe "&tempname&"-bc.tif -p:"&barcodemask & bcsecondrun,0,True)
                End If
                
                If Err.number<>0 Then
                    errortxt="archivierung(18eg): Fehler beim starten von rdtifbar ("&tempname&"-bc.tif). Errornummer: "&Err.number
                    objWshShell.LogEvent 1, errortxt
                    runbarcode=False
                End If
            End If
            
            
            
            
        Else
            errortxt="archivierung(18ek): Fehler: barcodemode= in scripts.ini: Wert wird nicht untersttzt."
            objWshShell.LogEvent 1, errortxt
            runbarcode=False
        End If
        
        If runbarcode=True Then
            WScript.sleep 1000
            waitbarcode
            WScript.sleep 200
        End If
    Else
        runbarcode=False
    End If
    
    If fs.fileexists(tempname&"-bc.bar") Then
        fs.copyfile tempname&"-bc.bar", tempname&".bar", True
        fs.deletefile tempname&"-bc.bar", True
        Err.clear
    End If
    
    
    If fs.fileexists(tempname&"-bc.tibar") Then
        fs.copyfile tempname&"-bc.tibar", tempname&".bar", True
        fs.deletefile tempname&"-bc.tibar", True
        Err.clear
    End If
    
    If fs.fileexists(tempname&".tibar") Then
        fs.copyfile tempname&".tibar", tempname&".bar", True
        fs.deletefile tempname&".tibar", True
        Err.clear
    End If
    
    
    If (fs.fileexists(tempname&"-bc.tif")) And (cleanup=True) Then
        fs.deletefile tempname&"-bc.tif", True
    End If
    
    
End Function



Function runbcplus(tempname)      ' Paramter zur bergabe an bcplus mssen noch angepasst werden
    On Error Resume Next
    'MsgBox "bcsecondrun=" & bcsecondrun
    
    
    runbcplus=True
    If (fs.fileexists(tempname&".tif")) And (Not fs.fileexists(tempname&".bar")) Then
        If (barcodemode="") Or (barcodemode="0") Then
            Err.clear
            If barcodemask="" Then
                
                lngReturnCode = objWSHShell.Run(programm&"bcplus.bat " & bcpluspath &" "&tempname&".tif",0,True)
            Else
                
                lngReturnCode = objWSHShell.Run(programm&"bcplus.bat " & bcpluspath &" "&tempname&".tif",0,True)
            End If
            
            If Err.number<>0 Then
                errortxt="archivierung(18eg): Fehler beim starten von bcplus ("&tempname&".tif). Errornummer: "&Err.number
                objWshShell.LogEvent 1, errortxt
                runbcplus=False
            End If
        ElseIf barcodemode="1" Then
            If fs.fileexists(tempname&".ttd") Then
                fs.deletefile tempname&".ttd", True
            End If
            If fs.fileexists(programm&bcfilter) Then
                'MsgBox bcfilter
                lngReturnCode = objWSHShell.Run(programm&"bcfilterv3.bat "&tempname&".tif "&programm&bcfilter&" "&tempname&"-bc.tif",0,True)
                
                If lngReturnCode<>0 Then
                    Err.clear
                    errortxt="bitfarm-Archiv: Archivierung(jo): Fehler beim Filtern der Tifdatei:"&lngReturnCode	
                    objWshShell.LogEvent 1, errortxt
                    getgarbage(tempname)
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If
                WScript.Sleep 300
                If Not fs.fileexists(tempname&"-bc.tif") Then
                    errortxt="bitfarm-Archiv: Archivierung(jx): Fehler beim Filtern der Tifdatei"
                    objWshShell.LogEvent 1, errortxt
                    getgarbage(tempname)
                    Unlock(programm&lockdatei)
                    WScript.Quit
                    Err.clear
                End If
            Else
                objWshShell.LogEvent 1, "Barcodemerger.vbs: Barcodefilter nicht vorhanden:" & bcfilter
                runbcplus=False
            End If	
            If runbcplus=True Then
                If barcodemask="" Then
                    lngReturnCode = objWSHShell.Run(programm&"bcplus.bat " & bcpluspath &" "&tempname&".tif",0,True)
                Else
                    'MsgBox "barcodemask=" & barcodemask
                    lngReturnCode = objWSHShell.Run(programm&"bcplus.bat " & bcpluspath &" "&tempname&".tif",0,True)
                End If
                
                If Err.number<>0 Then
                    errortxt="archivierung(18eg): Fehler beim starten von bcplus ("&tempname&"-bc.tif). Errornummer: "&Err.number
                    objWshShell.LogEvent 1, errortxt
                    runbcplus=False
                End If
            End If
            
            
            
            
        Else
            errortxt="archivierung(18ek): Fehler: barcodemode= in scripts.ini: Wert wird nicht untersttzt."
            objWshShell.LogEvent 1, errortxt
            runbcplus=False
        End If
        
        If runbcplus=True Then
            WScript.sleep 1000
            
            'waitbcplus
            WScript.sleep 200
        End If
    Else
        runbcplus=False
    End If
    
    If fs.fileexists(tempname&"-bc.bar") Then
        fs.copyfile tempname&"-bc.bar", tempname&".bar", True
        fs.deletefile tempname&"-bc.bar", True
        Err.clear
    End If
    
    
    If fs.fileexists(tempname&"-bc.tibar") Then
        fs.copyfile tempname&"-bc.tibar", tempname&".bar", True
        fs.deletefile tempname&"-bc.tibar", True
        Err.clear
    End If
    
    If fs.fileexists(tempname&".tibar") Then
        fs.copyfile tempname&".tibar", tempname&".bar", True
        fs.deletefile tempname&".tibar", True
        Err.clear
    End If
    
    
    If (fs.fileexists(tempname&"-bc.tif")) And (cleanup=True) Then
        fs.deletefile tempname&"-bc.tif", True
    End If
    
    
End Function







'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function waitbarcode()
    On Error Resume Next
    abbruch1=False
    Do While abbruch1=False
        Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
        'strQuery = "Select * from Win32_Process where Name='barcode.exe'"
        strQuery = "Select * from Win32_Process where Name='rdtifbar.exe'"
        Set colItems = objWMIService.ExecQuery(strQuery,,48)
        z=0
        For Each objItem In colItems
            
            z=z+1
            
        Next
        If z=0 Then
            abbruch1=True
        End If
        
        Set colItems = Nothing
        Set objWMIService = Nothing
        If abbruch1=False Then
            If checkbarcode()=0 Then
                
                
                
                Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
                'strQuery = "Select * from Win32_Process where Name='barcode.exe'"
                strQuery = "Select * from Win32_Process where Name='rdtifbar.exe'"
                Set colItems = objWMIService.ExecQuery(strQuery,,48)
                z=0
                For Each objItem In colItems
                    
                    z=z+1
                    objItem.Terminate()
                    
                Next
                
                Set colItems = Nothing
                Set objWMIService = Nothing
                abbruch1=True
            End If
            WScript.sleep 200
        End If
    Loop
    
End Function





Function checkbarcode
    On Error Resume Next
    checkbarcode=0
    
    If scriptdebug=True Then
        
        Set mydebugfile = fs.OpenTextFile(tempname&".log",8,True)
        'Set mydebugfile = fs.OpenTextFile(datei&".bclog",8,true)
    End If	
    
    WScript.Sleep 50
    Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    WScript.Sleep 50
    'Set colProcesses = objWMIService.ExecQuery _
    ' ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'barcode'")
    
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'rdtifbar'") 
    
    WScript.Sleep 50
    
    oldtestcounter1=0
    oldtestcounter2=0
    oldtestcounter3=0
    oldtestcounter4=0
    oldtestcounter5=0
    oldtestcounter6=0
    oldtestcounter7=0
    newtestcounter1=0
    newtestcounter2=0
    newtestcounter3=0
    newtestcounter4=0
    newtestcounter5=0
    newtestcounter6=0
    newtestcounter7=0
    
    kette=""
    
    For Each strProcess In colProcesses
        oldtestcounter1=strProcess.IOReadBytesPerSec
        oldtestcounter2=strProcess.IOReadOperationsPerSec
        oldtestcounter3=strProcess.IOWriteBytesPerSec
        oldtestcounter4=strProcess.IOWriteOperationsPerSec
        oldtestcounter5=strProcess.IOOtherBytesPerSec
        oldtestcounter6=strProcess.IOOtherOperationsPerSec
        oldtestcounter7=strProcess.PercentProcessorTime
        
    Next
    Set colProcess=Nothing
    Set objWMIService=Nothing
    WScript.Sleep 2000
    Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    WScript.Sleep 50
    'Set colProcesses = objWMIService.ExecQuery _
    ' ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'barcode'")
    
    
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'rdtifbar'") 
    
    WScript.Sleep 50
    
    kette=""
    mycounter1=0
    For Each strProcess In colProcesses
        newtestcounter1=strProcess.IOReadBytesPerSec
        newtestcounter2=strProcess.IOReadOperationsPerSec
        newtestcounter3=strProcess.IOWriteBytesPerSec
        newtestcounter4=strProcess.IOWriteOperationsPerSec
        newtestcounter5=strProcess.IOOtherBytesPerSec
        newtestcounter6=strProcess.IOOtherOperationsPerSec
        newtestcounter7=strProcess.PercentProcessorTime
        mycounter1=mycounter1+1
    Next
    Set colProcess=Nothing
    Set objWMIService=Nothing
    
    
    
    test1diff=0
    test2diff=0
    test3diff=0
    test4diff=0
    test5diff=0
    test6diff=0
    test7diff=0
    
    test1diff=strconvert(Trim(newtestcounter1))-strconvert(Trim(oldtestcounter1))
    test2diff=strconvert(Trim(newtestcounter2))-strconvert(Trim(oldtestcounter2))
    test3diff=strconvert(Trim(newtestcounter3))-strconvert(Trim(oldtestcounter3))
    test4diff=strconvert(Trim(newtestcounter4))-strconvert(Trim(oldtestcounter4))
    test5diff=strconvert(Trim(newtestcounter5))-strconvert(Trim(oldtestcounter5))
    test6diff=strconvert(Trim(newtestcounter6))-strconvert(Trim(oldtestcounter6))
    test7diff=strconvert(Trim(newtestcounter7))-strconvert(Trim(oldtestcounter7))
    
    If scriptdebug=True Then
        mydebugfile.writeline("rdtifbar: "&test1diff&"	:"&test2diff&"	:"&test3diff&"	:"&test4diff&"	:"&test5diff&"	:"&test6diff&"	:"&test7diff)
        
    End If
    
    If test7diff>0 Then
        checkbarcode=2
    End If
    
    If scriptdebug=True Then
        mydebugfile.writeline(checkbarcode)
        mydebugfile.close
        Set mydebugfile=Nothing
    End If
    
    
End Function





'################################################################################
'################################################################################
'################################################################################


Private Function NormString(String)
    
    On Error Resume Next
    
    tempkette=""
    wert1=0
    l = Len(String)
    
    For x = 1 To l
        wert1=Asc(Mid(String,x,1))
        If (wert1>=0) And (wert1<=32) Then
            tempkette=tempkette&" "
        Else
            
            If wert1=151 Then
                wert1=45
            End If
            If wert1=150 Then
                wert1=45
            End If
            If wert1=95 Then
                wert1=45
            End If
            If wert1=173 Then
                wert1=45
            End If
            If wert1=175 Then
                wert1=45
            End If
            If wert1=170 Then
                wert1=97
            End If	
            If wert1=161 Then
                wert1=105
            End If
            If wert1=181 Then
                wert1=117
            End If
            If wert1=213 Then
                wert1=214
            End If
            If wert1=195 Then
                wert1=196
            End If
            If wert1=229 Then
                wert1=97
            End If
            If wert1=230 Then
                tempkette=tempkette&"a"
                wert1=101
            End If
            If wert1=209 Then
                wert1=78
            End If
            If wert1=199 Then
                wert1=67
            End If
            If wert1=231 Then
                wert1=99
            End If
            If wert1=241 Then
                wert1=110
            End If
            If wert1=245 Then
                wert1=246
            End If
            If wert1=251 Then
                wert1=252
            End If
            If wert1=253 Then
                wert1=121
            End If
            If wert1=197 Then
                wert1=65
            End If
            
            
            
            If (wert1>=204) And (wert1<=207) Then
                wert1=73
            End If
            If (wert1>=200) And (wert1<=203) Then
                wert1=69
            End If
            If (wert1>=192) And (wert1<=194) Then
                wert1=65
            End If
            If (wert1>=210) And (wert1<=211) Then
                wert1=79
            End If	
            If (wert1>=212) And (wert1<=213) Then
                wert1=214
            End If
            If (wert1>=217) And (wert1<=218) Then
                wert1=85
            End If
            If wert1=219 Then
                wert1=220
            End If			
            If (wert1>=224) And (wert1<=225) Then
                wert1=97
            End If
            If (wert1>=226) And (wert1<=227) Then
                wert1=228
            End If
            If (wert1>=224) And (wert1<=225) Then
                wert1=97
            End If
            If (wert1>=232) And (wert1<=235) Then
                wert1=101
            End If
            If (wert1>=236) And (wert1<=239) Then
                wert1=105
            End If	
            If (wert1>=242) And (wert1<=243) Then
                wert1=111
            End If
            If (wert1>=249) And (wert1<=250) Then
                wert1=117
            End If
            
            If ((wert1>=40) And (wert1<=42)) Or ((wert1>=44) And (wert1<=58)) Or ((wert1>=63) And (wert1<=90)) Or ((wert1>=97) And (wert1<=122)) Or (wert1=196) Or (wert1=95) Or (wert1=214) Or (wert1=220) Or (wert1=223) Or (wert1=228) Or (wert1=246) Or (wert1=252) Or (wert1=37) Or (wert1=61) Or (wert1=92) Or (wert1=35) Or (wert1=33) Then		
                tempkette=tempkette+Chr(wert1)
            Else
                tempkette=tempkette&""
            End If
        End If
        
        
        
        
    Next
    tempkette2=""
    
    l = Len(tempkette)
    'If l>3 Then
    u=1
    Do While u<=l
        c1=Mid(tempkette,u,1)
        If c1<>" " Then
            o=0
            wort=c1
            Do While ((o+u)<l) And (c1<>" ")
                o=o+1
                c1=Mid(tempkette,u+o,1)
                If c1<>" " Then
                    wort=wort&c1
                End If
            Loop
            u=u+o
            If dropshortstrings=True Then
                If Len(wort)>2 Then
                    tempkette2=tempkette2&" "&wort
                End If
            Else
                tempkette2=tempkette2&" "&wort
            End If
        End If
        u=u+1
        
    Loop
    
    
    NormString=Trim(tempkette2)
    
    
End Function



Private Function GetString(kette,pos)
    On Error Resume Next
    zeichen=""
    ergebnis=""
    index=0
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (zeichen<>"	") And (index<80)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,pos+index,1)
        index=index+1
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=")) And (ergebnis="") Then
            zeichen=""
        End If
    Loop
    Trim(ergebnis)
    GetString=ergebnis
End Function


Private Function StrConvert(String)
    On Error Resume Next
    wert1=0
    l = Len(String)
    
    For x = 1 To l
        wert1=wert1+((Asc(Mid(String,x,1))-48)*(10^(l-x)))
    Next
    StrConvert=wert1
End Function

Function setdokdate()
    On Error Resume Next
    
    Jahr = DatePart("yyyy",Date)
    Monat = DatePart("m",Date)
    Tag = DatePart("d",Date)
    Stunde = DatePart("h",Time)
    Minuten = DatePart("n",Time)
    Sekunde = DatePart("s", Time)
    If Len(Monat)=1 Then 
        monat="0"&monat
    End If
    If Len(tag)=1 Then 
        tag="0"&tag
    End If
    If Len(stunde)=1 Then 
        stunde="0"&stunde
    End If
    If Len(minuten)=1 Then 
        minuten="0"&minuten
    End If
    If Len(sekunde)=1 Then 
        sekunde="0"&sekunde
    End If
    setdokdate = Jahr&"-" & Monat & "-" & Tag & " " & Stunde & ":" & Minuten & ":" & Sekunde
End Function

'################################################################################################################




Function getfifo(fifopath,fifoname)
    On Error Resume Next
    If fs.fileexists(programm & "queue\Thumbs.db") Then
        fs.deletefile programm & "queue\Thumbs.db", True
        If Err.number<>0 Then
            objWshShell.LogEvent 2, "barcodemerger.vbs: konnte Thums.db nicht lschen"
            
        End If 
        
    End If
    
    Dim fifofile
    Dim fifofolder
    Beginn = Timer
    tempnumber=""
    fifoname=LCase(fifoname)
    
    highest = 0
    
    
    fifofile = GetLastFile(programm & "queue", fifoname&"*.*")
    If fifofile<>"" Then
        strfifo = fs.GetBaseName(fifofile)
        If InStr(1,strfifo,"_0") <> 0 Then
            strfifo = Replace(strfifo,"_0","")
        End If
        If InStr(1,strfifio,"-archiv") <> 0 Then
            strfifo = Replace(strfifo,"-archiv","")
        End If
        If InStr(1,strfifio,"-temp") <> 0 Then
            strfifo = Replace(strfifo,"-temp","")
        End If
        strnumber = Right(strfifo,5)
        If IsNumeric(strnumber) Then
            highest= strConvert(strnumber)
        Else
            'Achtung ermittelter Dateiname hat keinen 5 stelligen Index. So eine datei hat hier nichts verloren.
            'wir suchen den letzten job
            fifofile = GetLastFile(programm & "queue", fifoname&"*.job")
            If fifofile<>"" Then
                strfifo = fs.GetBaseName(fifofile)
                strnumber = Right(strfifo,5)
                If IsNumeric(strnumber) Then
                    highest= strConvert(strnumber)
                End If		
                
                
            Else
                'es gibt keinen job
                
            End If
            
        End If
        
        
        If highest = 99999 Then       ' zahlenbereich fr diesen dateinamen voll, umbenennen
            If fifoname = "prio" Then
                
                objWshShell.LogEvent 1,"bitfarm-Archiv: Achtung Totaler Overflow - Queue vollgelaufen !"&vbCrLf&"Es werden keine Dokumente mehr gespoolt"
                
                Set fifofolder = Nothing
                WScript.Quit
            Else
                fifoname = "prio"
                
                getfifo = getfifo(fifopath,fifoname)
                
                Exit Function
            End If
        End If
        
    End If
    
    
    tempnumber = MakeFifoString(highest +1)
    
    WScript.Sleep 200
    
    
    fifofile = GetLastFile(programm & "queue",fifoname&"*.*")
    strfifo = fs.GetBaseName(fifofile)
    
    
    If strfifo = fifoname& tempnumber Then
        If scriptdebug = True Then
            objWshShell.LogEvent 4, "Archivierung.vbs" &vbCrLf& "Slot schon besetzt, Routine wird nochmals aufgerufen" &vbCrLf& tempnumber &vbCrLf& jetzt
        End If
        
        getfifo = getfifo(fifopath,fifoname)
        
        Exit Function
    End If
    
    'vielleicht wurde aus unbekannten grnden doch ein schon vergebener name ermittelt
    
    If fs.FileExists(fifopath & fifoname& tempnumber & extension) Then
        highest = highest + 1
        tempnumber = MakeFifoString(highest +1)
        
        Do While fs.FileExists(fifopath & fifoname& tempnumber & extension) And highest <99999
            highest = highest + 1
            tempnumber = MakeFifoString(highest +1)
        Loop
        
    End If
    
    
    If tempnumber<>"" Then
        getfifo = fifopath & fifoname & tempnumber
    Else
        'alternativ alte routine
        highest = 0
        
        Set fifofolder = fs.GetFolder(fifopath)
        
        For Each fifofile In fifofolder.Files
            
            strfifo = fs.GetBaseName(fifofile)
            If InStr(1,strfifo,"_0") <> 0 Then
                strfifo = Replace(strfifo,"_0","")
            End If
            If InStr(1,strfifio,"-archiv") <> 0 Then
                strfifo = Replace(strfifo,"-archiv","")
            End If
            If InStr(1,strfifio,"-temp") <> 0 Then
                strfifo = Replace(strfifo,"-temp","")
            End If
            'msgbox "strfifo="& strfifo
            ' Bedingung Basename = fifoname+ 5 stellige Zahl
            
            If Len(strfifo) = Len(fifoname)+5 Then
                If LCase(Left(strfifo,Len(strfifo)-5)) = fifoname Then
                    
                    strnumber = Right(strfifo,5)
                    If IsNumeric(strnumber) Then
                        strnumber= strConvert(strnumber)
                        'MsgBox "strnumber=" & strnumber		
                    End If
                    If strnumber> highest Then
                        highest =  strnumber
                    End If
                End If
            End If
            
            'msgbox "highest=" & highest
            
            If highest = 99999 Then       ' zahlenbereich fr diesen dateinamen voll, umbenennen
                If fifoname = "prio" Then
                    
                    objWshShell.LogEvent 1,"bitfarm-Archiv: Achtung Totaler Overflow - Queue vollgelaufen !"&vbCrLf&"Es werden keine Dokumente mehr gespoolt"
                    
                    Set fifofolder = Nothing
                    WScript.Quit
                Else
                    fifoname = "prio"
                    
                    getfifo = getfifo(fifopath,fifoname)
                    'msgbox "overflow-getfifo=" & getfifo	
                    'Set fifofolder = Nothing
                    'Set fifofile = Nothing
                    Exit Function
                End If
            End If
            
            
        Next 
        Set fifofolder = Nothing
        Set fifofile = Nothing
        
        
        tempnumber = MakeFifoString(highest +1)
        
        WScript.Sleep 1000
        'MsgBox "checkfifo - nochmals nachsehen ob in der zwischenzeit der name von woanders her besetzt wurde"
        
        Set fifofolder = fs.GetFolder(fifopath)
        
        For Each fifofile In fifofolder.Files
            
            
            
            strfifo = fs.GetBaseName(fifofile)
            
            If strfifo = fifoname& tempnumber Then
                'MsgBox "doch gefunden, die routine nochmals aufrufen"
                If scriptdebug = True Then
                    objWshShell.LogEvent 4, "Archivierung.vbs" &vbCrLf& "Slot schon besetzt, Routine wird nochmals aufgerufen" &vbCrLf& tempnumber &vbCrLf& jetzt
                End If
                
                getfifo = getfifo(fifopath,fifoname)
                Set fifofolder = Nothing
                Set fifofile = Nothing
                Exit Function
            End If
            
        Next 
        Set fifofolder = Nothing
        Set fifofile = Nothing
        
        getfifo = fifopath & fifoname & tempnumber
        
        
    End If
    Ende = Timer
    'MsgBox "Getfifo in : " & ende - beginn
    If scriptdebug = True Then
        objWshShell.LogEvent 4, "Archivspooler: ermittelter tempname=" & getfifo
    End If 
    
End Function


Function MakeFiFoString(nummer) 
    On Error Resume Next
    
    If Len(nummer) = 1 Then MakeFiFoString = "0000" & nummer
    If Len(nummer) = 2 Then MakeFiFoString = "000" & nummer
    If Len(nummer) = 3 Then MakeFiFoString = "00" & nummer
    If Len(nummer) = 4 Then MakeFiFoString = "0" & nummer
    If Len(nummer) = 5 Then MakeFiFoString = "" & nummer
    
End Function


Function GetFirstFile(folder,mask)
    On Error Resume Next
    
    GetFirstFile=""
    If fs.FileExists(programm&"countfiles.exe") Then
        Set oExec    = objWSHShell.Exec(programm&"countfiles.exe "& folder & " " & mask & " -lf")
        
        'Do While Not oExec.StdOut.AtEndOfStream
        ' strinput = strinput & oExec.StdOut.Read(1)	
        'Loop
        
        
        strinput = oExec.StdOut.ReadAll
        
        
        durch = False
        schleife = 0
        Do While schleife < 5000
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 1
            schleife = schleife +1
        Loop
        timer4 = Timer
        
        strname = strinput
        strname=Right(strinput,Len(strinput)-InStrRev(strinput,Chr(13),Len(strinput)-2)-1)
        strname = Left(strname,InStr(strname,Chr(13))-1)
        
        'MsgBox oExec.ExitCode & vbtab & timer4-timer3 & vbTab & schleife & vbCrLf  & ">>" & strname
        GetFirstFile=strname
        
        Set oExec = Nothing
    Else
        objWSHShell.LogEvent 1, "Archivierung.vbs: " & programm&"countfiles.exe nicht gefunden"
    End If
    
End Function


Function GetLastFile(folder,mask)
    On Error Resume Next
    
    GetLastFile=""
    
    If fs.FileExists(programm&"countfiles.exe") Then
        Set oExec    = objWSHShell.Exec(programm&"countfiles.exe "& folder & " " & mask & " -ll")
        
        'Do While Not oExec.StdOut.AtEndOfStream
        ' strinput = strinput & oExec.StdOut.Read(1)	
        'Loop
        
        
        strinput = oExec.StdOut.ReadAll
        
        
        durch = False
        schleife = 0
        Do While schleife < 5000
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 1
            schleife = schleife +1
        Loop
        timer4 = Timer
        
        strname = strinput
        strname=Right(strinput,Len(strinput)-InStrRev(strinput,Chr(13),Len(strinput)-2)-1)
        strname = Left(strname,InStr(strname,Chr(13))-1)
        
        
        'MsgBox oExec.ExitCode & vbtab & timer4-timer3 & vbTab & schleife & vbCrLf  & ">>" & strname
        GetLastFile=strname
        
        Set oExec = Nothing
    Else
        objWSHShell.LogEvent 1, "Archivierung.vbs: " & programm&"countfiles.exe nicht gefunden"
    End If
    
End Function



Function CountFiles(folder,mask)
    On Error Resume Next
    
    CountFiles=0
    If fs.FileExists(programm&"countfiles.exe") Then
        Set oExec    = objWSHShell.Exec(programm&"countfiles.exe "& folder & " " & mask)
        
        'Do While Not oExec.StdOut.AtEndOfStream
        ' strinput = strinput & oExec.StdOut.Read(1)	
        'Loop
        
        
        strinput = oExec.StdOut.ReadAll
        
        
        durch = False
        schleife = 0
        Do While schleife < 5000
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 1
            schleife = schleife +1
        Loop
        timer4 = Timer
        
        strname = strinput
        strname = Right(strinput,Len(strinput)-InStrRev(strinput,Chr(13),Len(strinput)-2)-1)
        strname = Left(strname,InStr(strname,Chr(13))-1)
        
        If InStr(strname,"Anzahl:") Then
            strname = Right(strname,Len(strname)-7)
            
            'MsgBox oExec.ExitCode & vbtab & timer4-timer3 & vbTab & schleife & vbCrLf  & ">>" & strname
            CountFiles = Strconvert(strname)
        End If
        
        Set oExec = Nothing
    Else
        objWSHShell.LogEvent 1, "Archivierung.vbs: " & programm&"countfiles.exe nicht gefunden"
    End If
    
End Function




Function bcmergejob(tempname)
    On Error Resume Next
    
    
    bcmergejob=True
    Err.clear
    
    If Not fs.FileExists(tempname&".tmp") Then
        Err.clear
        errortxt=tempname&".tmp	Datei nicht vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        bcmergejob=False
        Err.clear
    End If
    
    If bcmergejob=True Then	
        Set quelljobfile = fs.OpenTextFile(tempname&".tmp",1)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            bcmergejob=False
            
        End If 
    End If
    
    'If bcmergejob=true Then
    'If fs.FileExists(tempname&".tmp") Then
    '	fs.DeleteFile tempname& ".tmp", true
    '	If err.number Then
    '		err.clear
    '		errortxt="Zwischendatei fr Jobdatei existierte noch, kann diese aber nicht lschen."
    '		objWshShell.LogEvent 1, errortxt
    '		bcmergejob=false
    '		quelljobfile.close
    '		Set quelljobfile=nothing
    '	End If 
    '	
    'End If	
    'End If
    
    If bcmergejob=True Then
        Set zieljobfile = fs.OpenTextFile(tempname&".bctmp",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann bctmp-datei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            bcmergejob=False
            quelljobfile.close
            Set quelljobfile=Nothing
        End If 
    End If
    
    
    
    If bcmergejob = True Then
        
        stopflag=False
        ersatzstring=""	
        Do While quelljobfile.AtEndOfStream <> True
            kette=quelljobfile.readline
            
            ersatzstring=""
            
            
            If (InStr(1,kette,"Filter=",1)<>0) Then
                ersatzstring=Replace(kette,"barcodemerge","")
            End If
            
            
            If Left(kette,8) = "gdoc_id=" Then
                ersatzstring="gdoc_id="
            End If 
            
            
            If ersatzstring<>"" Then
                zieljobfile.writeline(ersatzstring)
            Else
                zieljobfile.writeline(kette)
            End If
            
        Loop
        quelljobfile.close
        Set quelljobfile = Nothing
        zieljobfile.close
        Set zieljobfile=Nothing
        WScript.sleep 50
        
        'err.clear
        'fs.DeleteFile(tempname& ".job")
        'If err.number Then
        '	err.clear
        '	errortxt="Fehler beim lschen der alten jobdatei."
        '	objWshShell.LogEvent 1, errortxt
        '	bcmergejob=false
        'End If 
        '
    End If
    
    
End Function


Function createaktlink(position, barcode)
    Err.Clear
    
    linkcounterfile = ""
    
    'Erstmal nachschauen, ob fr diesen Barcode verknpft werden soll
    For ind = 0 To limit
        If aktbarcode(ind) = barcode Then
            linkcounterfile = linkcounter(ind)
            Exit For
        End If
    Next
    
    'Linkcounter um 1 erhhen + linkstring erzeugen
    If fs.FileExists(linkcounterfile) Then
        abbruch = False
        Set linkfile = fs.OpenTextFile(linkcounterfile,1)
        
        If Err.Number <> 0 Then
            errortext = "barcodemerger.vbs: linkcounter Datei " & linkcounterfile & " konnte nicht geffnet werden, es wird keine Verknpfung fr die Akte angelegt."
            errortext = errortext & vbCrLf & Err.Number & vbCrLf & Err.description
            objwshshell.LogEvent 1, errortext
            Err.Clear
            abbruch = True
        End If
        If abbruch = False Then
            prefix = linkfile.readline
            counter = Int(linkfile.readline)
            counter = counter + 1
            linkfile.close
            fs.deletefile(linkcounterfile)
            Set linkfile = Nothing
            Set linkfile = fs.OpenTextFile(linkcounterfile,2, True)
            If Err.Number <> 0 Then
                errortext = "barcodemerger.vbs: linkcounter Datei " & linkcounterfile & " konnte nicht geffnet werden, es wird keine Verknpfung fr die Akte angelegt."
                errortext = errortext & vbCrLf & Err.Number & vbCrLf & Err.description
                objwshshell.LogEvent 1, errortext
                Err.Clear
                abbruch = True
            End If
            If abbruch = False Then
                linkfile.writeline(prefix)
                linkfile.writeline(counter)
                linkfile.close
                Set linkfile = Nothing
                createaktlink = prefix & "_" & counter
            End If
        End If
        
        If abbruch = True Then
            createaktlink = ""
        End If
    Else
        createaktlink = ""
        errortext = "barcodemerger.vbs: linkcounter Datei " & linkcounterfile & " existiert nicht, es wird keine Verknpfung fr die Akte angelegt."
        objwshshell.LogEvent 1, errortext
    End If
    
End Function 



Function addlink(linkstring, jobfile)
    Err.Clear
    
    Set thejobfile = fs.OpenTextFile(jobfile,1)
    If Err.Number <> 0 Then
        errortext = "barcodemerger.vbs: jobfile " & jobfile & " konnte nicht geffnet werden, es wird keine Verknpfung fr die Akte angelegt."
        errortext = errortext & vbCrLf & Err.Number & vbCrLf & Err.description
        objwshshell.LogEvent 1, errortext
        Err.Clear
        abbruch = True
    End If
    
    If abbruch = False Then
        Set newjobfile = fs.OpenTextFile(jobfile&".t2",8,True)
        
        If Err.Number <> 0 Then
            errortext = "barcodemerger.vbs: jobfile " & jobfile & ".t2 konnte nicht angelegt werden, es wird keine Verknpfung fr die Akte angelegt."
            errortext = errortext & vbCrLf & Err.Number & vbCrLf & Err.description
            objwshshell.LogEvent 1, errortext
            Err.Clear
            abbruch = True
        End If
    End If
    
    If abbruch = False Then
        
        refsfound = False
        
        'Bis Referenz alles kopieren
        Do Until ((refsfound = True) Or (thejobfile.atendofstream=True))
            line = thejobfile.readline
            If InStr("[Referenz]", line)<> 0 Then
                refsfound=True
            End If
            newjobfile.writeline(line)
        Loop
        
        'Kein "[Referenz]" im Jobfile: dann einfgen mit neuer Referenz
        If refsfound = False Then
            newjobfile.writeline("[Referenz]")
            newjobfile.writeline("Anzahl=1")
            newjobfile.writeline("Referenz1="&linkstring)
        End If
        
        'Anzahl Referenzen ermitteln und +1 setzen
        If refsfound = True Then
            line = thejobfile.readline
            If LCase(Left(line, 7)) = "anzahl=" Then
                linelen = Len(line)
                anzahl = Right(line, Len(line)-7)
                anzahl = anzahl + 1
                newjobfile.writeline("Anzahl="&anzahl)
            End If
            
            'bestehende und neue Referenz einfgen
            Do Until ((refsfound = False) Or (thejobfile.atendofstream=True))
                line = thejobfile.readline
                If LCase(Left(line, 8)) <> "referenz" Then
                    refsfound = False
                    newjobfile.writeline("Referenz"&anzahl&"="&linkstring)
                End If
                newjobfile.writeline(line)
            Loop	
        End If
        
        'Rest des Jobfiles einfgen
        If thejobfile.atendofstream<>True Then
            line = thejobfile.readline
            While (thejobfile.atendofstream <> True)
                newjobfile.writeline(line)
                line = thejobfile.readline
            Wend
        End If
        
        'Schliessen und Umbenennen
        thejobfile.close
        newjobfile.close
        Set thejobfile = Nothing	
        Set newjobfile = Nothing
        
        fs.deletefile jobfile, True
        
        Err.Clear
        
        fs.movefile jobfile&".t2", jobfile
        If Err.Number <> 0 Then
            WScript.Sleep 1000
            fs.movefile jobfile&".t2", jobfile
            Err.Clear
        End If
    End If
    
End Function

Function update_datum(myjobfile)
    update_datum = True
    If Not fs.FileExists(myjobfile) Then
        Err.clear
        errortxt=myjobfile&" Datei nicht vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        update_datum=False
        Err.clear
    End If
    
    If update_datum=True Then	
        Set quelljobfile = fs.OpenTextFile(myjobfile,1)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum lesen ffnen."
            objWshShell.LogEvent 1, errortxt
            update_datum=False
            
        End If 
    End If
    
    If update_datum=True Then
        Set zieljobfile = fs.OpenTextFile(myjobfile&".t1",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann bctmp-datei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            update_datum=False
            quelljobfile.close
            Set quelljobfile=Nothing
        End If 
    End If
    
    If update_datum = True Then
        
        stopflag=False
        ersatzstring=""	
        Do While quelljobfile.AtEndOfStream <> True
            kette=quelljobfile.readline
            
            ersatzstring=""
            
            If LCase(Left(kette,6)) = "datum=" Then
                jetzt = setdokdate()
                WScript.Sleep 1001
                ersatzstring="Datum="&jetzt
                'objwshshell.LogEvent 1, "barcodemerge-debug jetzt: " & ersatzstring
            End If 
            
            If ersatzstring<>"" Then
                zieljobfile.writeline(ersatzstring)
            Else
                zieljobfile.writeline(kette)
            End If
            
        Loop
        quelljobfile.close
        Set quelljobfile = Nothing
        zieljobfile.close
        Set zieljobfile=Nothing
        WScript.sleep 50
    End If  
    
    
    On Error Resume Next
    Err.Clear
    fs.deletefile myjobfile, True
    
    If Err.Number<>0 Then
        objwshshell.LogEvent 1, "barcodemerger.vbs Fehler: Konnte Datei " & myjobfile & " nicht lschen! " & Err.Description
    Else
        WScript.Sleep 500
        fs.movefile myjobfile&".t1", myjobfile
        If Err.Number<>0 Then
            objwshshell.LogEvent 1, "barcodemerger.vbs Fehler: Konnte Datei " & myjobfile&".t1 nicht nach " & myjobfile & " kopieren! " & Err.Description
            Err.Clear
        End If
    End If
    
End Function


Function GetFileNames(Directory, Pattern)
    Dim FileNames(), AfterPattern()
    Dim FolderObject, fso, f
    Dim i
    i = 0
    
    
    Set FolderObject = fs.GetFolder(Directory)
    ReDim FileNames(FolderObject.Files.Count)
    ReDim AfterPattern(FolderObject.Files.Count)
    For Each f In FolderObject.Files
        FileNames(i) = f.Path
        i = i + 1
    Next
    'Pattern Portion
    Dim RegExp
    Set RegExp = CreateObject("VBScript.RegExp")
    RegExp.Pattern = Pattern
    RegExp.Global = False
    Dim x
    x = -1
    For i = LBound(FileNames) To UBound(FileNames)
        If RegExp.Test(FileNames(i)) = True Then
            x = x + 1
            AfterPattern(x) = FileNames(i)
            
        End If
    Next
    ReDim Preserve AfterPattern(x)
    GetFileNames = AfterPattern
    
    
    
    Set FolderObject = Nothing
    Set RegExp = Nothing
    
End Function


Function IsInArray(strIn, arrCheck)
    bFlag = False
    If IsArray(arrCheck) And Not IsNull(strIn) Then
        Dim i
        For i = 0 To UBound(arrCheck)
            If LCase(arrcheck(i)) = LCase(strIn) Then
                bFlag = True
                Exit For
            End If
        Next
    End If
    IsInArray = bFlag
End Function  
