'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'***************  bfa-backup.vbs    GPL  ***************************************************
'*******************************************************************************************
'***************  Version 3.6.2.0        ***************************************************
'*******************************************************************************************
'***************  Programm zum Packen und Bereitstellen des Archives         ***************
'***************  Wird ber den Taskplaner oder ber Backupdienst gestartet. ***************
'***************                                                             ***************
'***************  Syntax: <programmpfad>bfa-backup.vbs     	                 ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************

backuparchiv = False
backupversion = False
backupnrsarchiv = False
backupworkflows = False
backupsvnrepository = False
backupmysqllog  = False
mysqlservice = ""
backupzeitraum = 5
filesize = 20000
zippath = ""
use7zip = False
scriptdebug = False

'*******************************************************************************************
'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

On Error Resume Next

Dim objWSHShell, fso, FileIn, FileOut 
Dim Datei, Text, Txt, i, arrSort, arrTest(), oArgs, Druckername
Dim lngReturnCode


Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set fs      = WScript.CreateObject("Scripting.FileSystemObject") 
Set oArgs    = WScript.Arguments 

SQLcount=0
backuppath=""
programm=""
archivverzeichnis = ""
adminmail = ""
storages = ""
archivkopie=""
archive_rs=""
archive_nrs=""

sqlbackup=False
Profil=""

errflag=False

uncclientspooler=""

sqldatapath=""
zwischenspeicher=""
programm=""
svn_repository=""
workflows=""
strinput=""
stoponfail=True
remotemysqlserver=""


objWshShell.LogEvent 4, "bitfarm-Archiv: Archivservice startet..."

'nummer = DatePart("d",Date)&DatePart("m",Date)&DatePart("h",Date)&DatePart("n",Date)
nummer = DatePart("yyyy",Date) & Right("00" & DatePart("m",Date),2) & Right("00" &DatePart("d",Date),2) & "-" & Right("00" & DatePart("h",Time),2) & Right("00" &DatePart("n",Time),2)

'*******************************************************************************************
'**************************  Startparameter initialisieren  ********************************
Err.clear
fullpath = WScript.ScriptFullName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
scriptname = WScript.ScriptName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
If Len(programm)=0 Then
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If


'**************************************************************************************
'**************************    Profil per Argument     ********************************

If oArgs.Count >= 1 Then
    Profil = oArgs.Item(0)
End If 



'**************************************************************************************
'**************************************************************************************

'If Profil = "" Then 
    inilesen
'End If 

'**************************************************************************************
'**************************************************************************************

erfolg=readconfig(Profil)
If erfolg=False Then
    errortxt="Archivbackup: Fehler beim lesen der Profildatei?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If

If mysqlservice="" Then
	errortxt="Archivbackup: Fehler beim lesen der Profildatei, mysqlservice nicht gesetzt!"
    objWshShell.LogEvent 1, errortxt
    
    If stoponfail=True Then
        errortxt = errortxt & vbCrLf & "Die Dienste (inkl. MySQL) werden gestoppt und mssen von Hand neu gestartet werden."
    End If
    objWshShell.LogEvent 1, errortxt
    If stoponfail=True Then
        ' Bitfarm-Dienste anhalten
        ret  = objWSHShell.Run(chr(34) & programm&"BackupStopService.bat" & chr(34),0,True)
        ' MySQL anhalten
        cmd = "sc " & remotemysqlserver & " stop "&Chr(34)&mysqlservice&Chr(34)
		Set oExec = objWSHShell.Exec(cmd)
		Do While Not oExec.StdOut.AtEndOfStream
		    strinput = strinput & oExec.StdOut.Read(1)	
		Loop
        ' Mail an Admin
        If adminmail <> "" Then
            errortxt = "</br>Beim Erstellen des letzten Backups ist ein Fehler aufgetreten. Die Dienste (inkl. MySQL) wurden daher angehalten.</br>"
            errortxt = errortxt &  "</br>"  & "Im Profil " &Profil& " fehlt im Abschnitt Backup der Eintrag 'mysqlservice'!"
    		errortxt = errortxt &  "</br>"  & "Bitte prfen/korrigieren Sie die Konfiguration!"
    		lngReturnCode = objWSHShell.Run(Chr(34)&programm & "sendlinkmail.vbs"&Chr(34)&" " & adminmail & " " &  "0.0" & " " & Chr(34) & errortxt & Chr(34),0,True)
        End If
    Else
        errortxt = "</br>Beim Erstellen des letzten Backups ist ein Fehler aufgetreten.</br>"
        errortxt = errortxt &  "</br>"  & "Im Profil " &Profil& " fehlt im Abschnitt Backup der Eintrag 'mysqlservice'!"
    	errortxt = errortxt &  "</br>"  & "Bitte prfen/korrigieren Sie die Konfiguration!"
  		lngReturnCode = objWSHShell.Run(Chr(34)&programm & "sendlinkmail.vbs"&Chr(34)&" " & adminmail & " " &  "0.0" & " " & Chr(34) & errortxt & Chr(34),0,True)	
    End If
    
    
	errortxt = "</br>Beim Erstellen des letzten Backups ist ein Fehler aufgetreten.</br>"
    
    WScript.Quit
End If


archivbasedir = objWSHShell.ExpandEnvironmentStrings(storages)    
archivverzeichnis = archivbasedir & "\" & archive_rs & "\"
archivkopie = archivbasedir & "\" & archive_nrs & "\"
zwischenspeicher=backuppath

'**************************************************************************************


If Not fs.FolderExists(backuppath) Then
    errortxt="Archivbackup: Verzeichnis nicht vorhanden oder erreichbar (backuppath)" &  vbCrLf & backuppath
    If stoponfail=True Then
        errortxt = errortxt & vbCrLf & "Die Dienste (inkl. MySQL) werden gestoppt und mssen von Hand neu gestartet werden."
    End If
    objWshShell.LogEvent 1, errortxt
    If stoponfail=True Then
        ' Bitfarm-Dienste anhalten
        ret  = objWSHShell.Run(chr(34) & programm&"BackupStopService.bat" & chr(34),0,True)
        ' MySQL anhalten
        cmd = "sc " & remotemysqlserver & " stop "&Chr(34)&mysqlservice&Chr(34)
        objWshShell.LogEvent 1, cmd
		Set oExec = objWSHShell.Exec(cmd)
		Do While Not oExec.StdOut.AtEndOfStream
		    strinput = strinput & oExec.StdOut.Read(1)	
		Loop
        ' Mail an Admin
        If adminmail <> "" Then
            errortxt = "</br>Beim Erstellen des letzten Backups ist ein Fehler aufgetreten. Die Dienste (inkl. MySQL) wurden daher angehalten.</br>"
            errortxt = errortxt &  "</br>"  & "Das Backup-Verzeichnis " & backuppath & " ist nicht vorhanden!"
            errortxt = errortxt &  "</br>"  & "Bitte prfen/korrigieren Sie die Konfiguration und starten die Dienste im Anschluss von Hand."
            lngReturnCode = objWSHShell.Run(Chr(34)&programm & "sendlinkmail.vbs"&Chr(34)&" " & adminmail & " " &  "0.0" & " " & Chr(34) & errortxt & Chr(34),0,True)
        End If
    Else
        errortxt = "</br>Beim Erstellen des letzten Backups ist ein Fehler aufgetreten.</br>"
        errortxt = errortxt &  "</br>"  & "Das Backup-Verzeichnis " & backuppath & " ist nicht vorhanden!"
        errortxt = errortxt &  "</br>"  & "Bitte prfen/korrigieren Sie die Konfiguration!"
        lngReturnCode = objWSHShell.Run(Chr(34)&programm & "sendlinkmail.vbs"&Chr(34)&" " & adminmail & " " &  "0.0" & " " & Chr(34) & errortxt & Chr(34),0,True)		
    End If
    WScript.Quit
End If

If Not fs.FolderExists(sqldatapath) Then
    errortxt="Archivbackup: Verzeichnis nicht vorhanden oder erreichbar (sqldatapath)" & vbCrLf & sqldatapath
    If stoponfail=True Then
        errortxt = errortxt & vbCrLf & "Die Dienste (inkl. MySQL) werden gestoppt und mssen von Hand neu gestartet werden."
    End If
    
    objWshShell.LogEvent 1, errortxt
    
    ' Bitfarm-Dienste anhalten
    If stoponfail=True Then
        ' Bitfarm-Dienste anhalten
        ret  = objWSHShell.Run(chr(34) & programm&"BackupStopService.bat" & chr(34),0,True)
        ' MySQL anhalten
        cmd = "sc " & remotemysqlserver & " stop "&Chr(34)&mysqlservice&Chr(34)
		Set oExec = objWSHShell.Exec(cmd)
		Do While Not oExec.StdOut.AtEndOfStream
		    strinput = strinput & oExec.StdOut.Read(1)	
		Loop
        
        ' Mail an Admin
        If adminmail <> "" Then
            errortxt = "</br>Beim Erstellen des letzten Backups ist ein Fehler aufgetreten. Die Dienste (inkl. MySQL) wurden daher angehalten.</br>"
            errortxt = errortxt & "</br>" & "Das SQL-Daten-Verzeichnis " & sqldatapath & " ist nicht vorhanden"
            errortxt = errortxt & "</br>" & "Bitte prfen/korrigieren Sie die Konfiguration und starten die Dienste im Anschluss von Hand."
            lngReturnCode = objWSHShell.Run(Chr(34)&programm & "sendlinkmail.vbs"&Chr(34)&" " & adminmail & " " &  "0.0" & " " & Chr(34) & errortxt & Chr(34),0,True)
        End If
    Else
        errortxt = "</br>Beim Erstellen des letzten Backups ist ein Fehler aufgetreten.</br>"
        errortxt = errortxt & "</br>" & "Das SQL-Daten-Verzeichnis " & sqldatapath & " ist nicht vorhanden"
        errortxt = errortxt & "</br>" & "Bitte prfen/korrigieren Sie die Konfiguration!"
        lngReturnCode = objWSHShell.Run(Chr(34)&programm & "sendlinkmail.vbs"&Chr(34)&" " & adminmail & " " &  "0.0" & " " & Chr(34) & errortxt & Chr(34),0,True)
    End If 
    WScript.Quit
End If

'If backupsvnrepository Then
    'If Left(svn_repository,2) <>"\\" Then
        'svn_repository = "\\" & svn_repository
    'End If 
'End If 


'**************************************************************************************
'****************************   Arbeitsdienst stoppen und warten  *********************

Err.clear
ret  = objWSHShell.Run(chr(34) & programm & "BackupStopService.bat" & chr(34),0,True)
If Err.Number Or ret <> 0 Then
    Err.clear
    objWshShell.LogEvent 1, "archivbackup: kann Archivierungsdienst nicht stoppen."
    WScript.Quit
End If

lockdatei="temp\lock"

warten=True
i=0

Do While warten = True
    WScript.Sleep 1000'0
    If fs.FileExists(programm&lockdatei) Then
        i=i+1
    Else
        warten = False
    End If
    If i>1000 Then
        objWSHShell.LogEvent 1, "archivbackup: Wartezeit fr Dienstende berschritten. Vielleicht nicht aufgerumtes Lock?"
        If stoponfail = True Then
            ' Mail an Admin
            If adminmail <> "" Then
                errortxt = "</br>Beim Erstellen des letzten Backups ist ein Fehler aufgetreten. Die Dienste (inkl. MySQL) wurden daher angehalten.</br>"
                errortxt = errortxt & "</br>" & "Der Archivierungsdienst konnte nicht beendet werden (lock-Datei vorhanden)."
                errortxt = errortxt & "</br>" & "Bitte prfen/korrigieren Sie die Konfiguration und starten die Dienste im Anschluss von Hand."
                lngReturnCode = objWSHShell.Run(Chr(34)&programm & "sendlinkmail.vbs"&Chr(34)&" " & adminmail & " " &  "0.0" & " " & Chr(34) & errortxt & Chr(34),0,True)
            End If
        Else
            ' Bitfarm-Dienste stehen, neu starten wenn stoponfail=False
            errortxt = "</br>Beim Erstellen des letzten Backups ist ein Fehler aufgetreten.</br>"
            errortxt = errortxt & "</br>" & "Der Archivierungsdienst konnte nicht beendet werden (lock-Datei vorhanden)."
            lngReturnCode = objWSHShell.Run(Chr(34)&programm & "sendlinkmail.vbs"&Chr(34)&" " & adminmail & " " &  "0.0" & " " & Chr(34) & errortxt & Chr(34),0,True)
            ret  = objWSHShell.Run(Chr(34) & programm & "BackupStartService.bat" & Chr(34),0,True)
        End If       
        WScript.Quit
    End If
Loop

'**************************************************************************************
'********************************   zwischenspeicher leeren  **************************

msg = ""

Set objRE = New RegExp
objRE.Global     = False
objRE.IgnoreCase = True
objRE.Pattern = "(.zip.\d\d\d$)|(.rar$)"
Set folder = fs.GetFolder(zwischenspeicher)
For Each datei In folder.files
    Set colMatches = objRE.Execute(Datei.Name)
    If colMatches.Count> 0 Then
        unterschied = DateDiff("d" , datei.DateLastModified, Date)
        If unterschied>CInt(backupzeitraum) Then
            SQLcount=SQLcount+1
            msg = msg &"gelscht: " & Datei.Name & vbCrLf
            fs.DeleteFile datei, True
            Err.clear
            
        End If
    End If
Next
Set folder = Nothing

If SQLCount > 0 Then
    objWshShell.LogEvent 4,"bfa-backup: Es wurden " & CStr(SQLCount) & " Datei/en gelscht, da sie lter als " & backupzeitraum & " Tag/e waren " & vbCrLf & msg	
End If 

'**************************************************************************************
'******************************  Packen und Kopieren  *********************************

objWshShell.LogEvent 4, "bitfarm-Archiv: Packvorgang gestartet. Profil = " & Profil



'************************************  Archiv  ****************************************
If backuparchiv=True And archivverzeichnis <> "" Then
    If checkpath(archivverzeichnis) Then
        Call checkrunningrar
        If use7zip = True Then
        	zcmd = Chr(34) & zippath & Chr(34) & " a " & Chr(34) &backuppath&"archiv"&nummer & ".zip" & Chr(34) & " " & Chr(34) &makeunc(archivverzeichnis)& Chr(34) & " -r -v" & CStr(CInt(filesize/1000)) & "m"
        	objWSHShell.LogEvent 4,zcmd
			Set oExec = objWSHShell.Exec(zcmd)
		    strinput = ""
		    strerr = ""
		    
		    Do While Not oExec.StdOut.AtEndOfStream
		        strinput = strinput & oExec.StdOut.ReadAll	
		    Loop
		    
		    Do While Not oExec.StdErr.AtEndOfStream
		        strerr = strerr & oExec.Stderr.ReadAll
		    Loop
		    
		    objWSHShell.LogEvent 4, "bfa-backup.vbs 7z.exe returncode: " & oExec.ExitCode
			
			If scriptdebug=True Then
				mys = Left(strinput,30000)
				i = 1
				While mys <> ""
					objWSHShell.LogEvent 4, "bfa-backup.vbs 7z.exe stdout " & i & vbCrLf & Chr(34) & mys & Chr(34)
					mys = Mid(strinput,i*30000,30000)
					i = i + 1
				Wend
				mys = Left(strerr,30000)
				i = 1
				While mys <> ""
					objWSHShell.LogEvent 4, "bfa-backup.vbs 7z.exe stderr " & i & vbCrLf & Chr(34) & mys & Chr(34)
					mys = Mid(strerr,i*30000,30000)
					i = i + 1
				Wend
			End If
		    ret = oExec.ExitCode
        	
			'ret = objWSHShell.Run(zcmd,0,True)
        Else
        	ret = objWSHShell.Run(Chr(34) & programm&"rar.exe" & Chr(34) & " a -s -r -v"&filesize&" -ri1 -inul "& Chr(34) &backuppath&"archiv"&nummer& Chr(34) &" "& Chr(34) &makeunc(archivverzeichnis)& Chr(34),0,True)
        End If
        If Err.Number Or ret <> 0 Then
            Err.Clear
            nr = Err.Number
            desc = Err.Description
            objWshShell.LogEvent 1, "archivbackup: Fehler beim Packen." & vbCrLf & archivverzeichnis 
            errflag=True
            
        End If
        
        WScript.Sleep 1000
    End If
End If 
'************************************  NRS-Archiv  ****************************************
If backupnrsarchiv=True And archivkopie<> "" Then
    If checkpath(archivkopie) Then
        Call checkrunningrar
        
        If use7zip = True Then
        	zcmd = Chr(34) & zippath & Chr(34) & " a " & Chr(34) &backuppath&"nrsarchiv"&nummer & ".zip" & Chr(34) & " " & Chr(34) &makeunc(archivkopie)& Chr(34) & " -r -v" & CStr(CInt(filesize/1000)) & "m"
        	objWSHShell.LogEvent 4,zcmd
        	Set oExec = objWSHShell.Exec(zcmd)
		    strinput = ""
		    strerr = ""
		    Do While Not oExec.StdOut.AtEndOfStream
		        strinput = strinput & oExec.StdOut.ReadAll	
		    Loop
		    
		    Do While Not oExec.StdErr.AtEndOfStream
		        strerr = strerr & oExec.Stderr.ReadAll
		    Loop
		
			objWSHShell.LogEvent 4, "bfa-backup.vbs 7z.exe returncode: " & oExec.ExitCode
			
			If scriptdebug=True Then
				mys = Left(strinput,30000)
				i = 1
				While mys <> ""
					objWSHShell.LogEvent 4, "bfa-backup.vbs 7z.exe stdout " & i & vbCrLf & Chr(34) & mys & Chr(34)
					mys = Mid(strinput,i*30000,30000)
					i = i + 1
				Wend
				
				mys = Left(strerr,30000)
				i = 1
				While mys <> ""
					objWSHShell.LogEvent 4, "bfa-backup.vbs 7z.exe stderr " & i & vbCrLf & Chr(34) & mys & Chr(34)
					mys = Mid(strerr,i*30000,30000)
					i = i + 1
				Wend
			End If
			
		    ret = oExec.ExitCode

        Else
        	ret = objWSHShell.Run(Chr(34) & programm&"rar.exe" & Chr(34) & " a -s -r -v"&filesize&" -ri1 -inul "& Chr(34) &backuppath&"nrsarchiv"&nummer& Chr(34) &" "& Chr(34) &makeunc(archivkopie)& Chr(34),0,True)
        End If
        
        'ret = objWSHShell.Run(programm&"rar.exe a -s -r -v"&filesize&" -ri1 -inul "& Chr(34) &backuppath&"nrsarchiv"&nummer& Chr(34) &" "& Chr(34) &makeunc(archivkopie)& Chr(34),0,True)
        If Err.Number Or ret <> 0 Then
            Err.clear
            objWshShell.LogEvent 1, "archivbackup: Fehler beim Packen." & vbCrLf & archivkopie
            errflag=True
        End If
        
        WScript.Sleep 1000
    End If
End If 

'************************************  programm  ****************************************
If backupversion=True And programm <> "" Then
    If checkpath(programm) Then
        Call checkrunningrar
        
        If use7zip = True Then
        	zcmd = Chr(34) & zippath & Chr(34) & " a " & Chr(34) &backuppath&"programm"&nummer & ".zip" & Chr(34) & " " & Chr(34) &makeunc(programm)& Chr(34) & " -r -v" & CStr(CInt(filesize/1000)) & "m"
        	objWSHShell.LogEvent 4,zcmd
        	Set oExec = objWSHShell.Exec(zcmd)
		    strinput = ""
		    strerr = ""
		    Do While Not oExec.StdOut.AtEndOfStream
		        strinput = strinput & oExec.StdOut.ReadAll	
		    Loop
		    
		    Do While Not oExec.StdErr.AtEndOfStream
		        strerr = strerr & oExec.Stderr.ReadAll
		    Loop
		
			objWSHShell.LogEvent 4, "bfa-backup.vbs 7z.exe returncode: " & oExec.ExitCode
			
			If scriptdebug=True Then
				mys = Left(strinput,30000)
				i = 1
				While mys <> ""
					objWSHShell.LogEvent 4, "bfa-backup.vbs 7z.exe stdout " & i & vbCrLf & Chr(34) & mys & Chr(34)
					mys = Mid(strinput,i*30000,30000)
					i = i + 1
				Wend
				
				mys = Left(strerr,30000)
				i = 1
				While mys <> ""
					objWSHShell.LogEvent 4, "bfa-backup.vbs 7z.exe stderr " & i & vbCrLf & Chr(34) & mys & Chr(34)
					mys = Mid(strerr,i*30000,30000)
					i = i + 1
				Wend
			End If
			
		    ret = oExec.ExitCode
        Else
        	ret = objWSHShell.Run(Chr(34) & programm&"rar.exe" & Chr(34) & " a -s -r -v"&filesize&" -ri1 -inul "& Chr(34) &backuppath&"programm"&nummer& Chr(34) &" "& Chr(34) &makeunc(programm)& Chr(34),0,True)
        End If
        
        'ret = objWSHShell.Run(programm&"rar.exe a -s -r -v"&filesize&" -ri1 -inul "& Chr(34) &backuppath&"programm"&nummer& Chr(34) &" "& Chr(34) &makeunc(programm)& Chr(34),0,True)
        If Err.Number Or (ret <> 0 And ret <> 1) Then
            Err.clear
            objWshShell.LogEvent 1, "archivbackup: Fehler beim Packen." & vbCrLf & programm
            errflag=True
        End If
        
        WScript.Sleep 1000
    End If 
End If


'************************************  svn-repository  ****************************************
If backupsvnrepository=True And svn_repository<> "" Then
    
    If checkpath(svn_repository) Then
        Call checkrunningrar
        
        If use7zip = True Then
        	zcmd = Chr(34) & zippath & Chr(34) & " a " & Chr(34) &backuppath&"svnrepository"&nummer & ".zip" & Chr(34) & " " & Chr(34) &makeunc(svn_repository)& Chr(34) & " -r -v" & CStr(CInt(filesize/1000)) & "m"
        	objWSHShell.LogEvent 4,zcmd
        	Set oExec = objWSHShell.Exec(zcmd)
		    strinput = ""
		    strerr = ""
		    Do While Not oExec.StdOut.AtEndOfStream
		        strinput = strinput & oExec.StdOut.ReadAll	
		    Loop
		    
		    Do While Not oExec.StdErr.AtEndOfStream
		        strerr = strerr & oExec.Stderr.ReadAll
		    Loop
		
			objWSHShell.LogEvent 4, "bfa-backup.vbs 7z.exe returncode: " & oExec.ExitCode
			
			If scriptdebug=True Then
				mys = Left(strinput,30000)
				i = 1
				While mys <> ""
					objWSHShell.LogEvent 4, "bfa-backup.vbs 7z.exe stdout " & i & vbCrLf & Chr(34) & mys & Chr(34)
					mys = Mid(strinput,i*30000,30000)
					i = i + 1
				Wend
				
				mys = Left(strerr,30000)
				i = 1
				While mys <> ""
					objWSHShell.LogEvent 4, "bfa-backup.vbs 7z.exe stderr " & i & vbCrLf & Chr(34) & mys & Chr(34)
					mys = Mid(strerr,i*30000,30000)
					i = i + 1
				Wend
			End If
			
		    ret = oExec.ExitCode
        Else
        	ret = objWSHShell.Run(Chr(34) & programm&"rar.exe" & Chr(34) & " a -s -r -v"&filesize&" -ri1 -inul "& Chr(34) &backuppath&"svnrepository"&nummer& Chr(34) &" "& Chr(34) &makeunc(svn_repository)& Chr(34),0,True)
        End If
        
        'ret = objWSHShell.Run(programm&"rar.exe a -s -r -v"&filesize&" -ri1 -inul "& Chr(34) &backuppath&"svnrepository"&nummer& Chr(34) &" "& Chr(34) &makeunc(svn_repository)& Chr(34),0,True)
        If Err.Number Or ret <> 0 Then
            errflag=True
            objWshShell.LogEvent 1, "archivbackup: Fehler beim Packen." & vbCrLf & svn_repository & vbCrLf & Err.Number & ":" & Err.Description & vbCrLf & "ret:" & ret
            Err.clear
        End If
        
        WScript.Sleep 1000
    End If 
End If

'************************************  workflows  ****************************************
If backupworkflows=True And workflows<> "" Then
    Call checkrunningrar
    If checkpath(workflows) Then
    
    	If use7zip = True Then
        	zcmd = Chr(34) & zippath & Chr(34) & " a " & Chr(34) &backuppath&"workflows"&nummer & ".zip" & Chr(34) & " " & Chr(34) &makeunc(workflows)& Chr(34) & " -r -v" & CStr(CInt(filesize/1000)) & "m"
        	objWSHShell.LogEvent 4,zcmd
        	Set oExec = objWSHShell.Exec(zcmd)
		    strinput = ""
		    strerr = ""
		    Do While Not oExec.StdOut.AtEndOfStream
		        strinput = strinput & oExec.StdOut.ReadAll	
		    Loop
		    
		    Do While Not oExec.StdErr.AtEndOfStream
		        strerr = strerr & oExec.Stderr.ReadAll
		    Loop
		
			objWSHShell.LogEvent 4, "bfa-backup.vbs 7z.exe returncode: " & oExec.ExitCode
			
			If scriptdebug=True Then
				mys = Left(strinput,30000)
				i = 1
				While mys <> ""
					objWSHShell.LogEvent 4, "bfa-backup.vbs 7z.exe stdout " & i & vbCrLf & Chr(34) & mys & Chr(34)
					mys = Mid(strinput,i*30000,30000)
					i = i + 1
				Wend
				
				mys = Left(strerr,30000)
				i = 1
				While mys <> ""
					objWSHShell.LogEvent 4, "bfa-backup.vbs 7z.exe stderr " & i & vbCrLf & Chr(34) & mys & Chr(34)
					mys = Mid(strerr,i*30000,30000)
					i = i + 1
				Wend
			End If
		    ret = oExec.ExitCode
        Else
        	ret = objWSHShell.Run(Chr(34) & programm&"rar.exe" & Chr(34) & " a -s -r -v"&filesize&" -ri1 -inul "& Chr(34) &backuppath&"workflows"&nummer& Chr(34) &" "& Chr(34) &makeunc(workflows)& Chr(34),0,True)
        End If
    
        'ret = objWSHShell.Run(programm&"rar.exe a -s -r -v"&filesize&" -ri1 -inul "& Chr(34) &backuppath&"workflows"&nummer& Chr(34) &" "& Chr(34) &makeunc(workflows)& Chr(34),0,True)
        If Err.Number Or ret <> 0 Then
            errflag=True
            objWshShell.LogEvent 1, "archivbackup: Fehler beim Packen." & vbCrLf & workflows & vbCrLf & Err.Number & ":" & Err.Description & vbCrLf & "ret:" & ret
            Err.clear
        End If
        
        WScript.Sleep 1000
    End If 
End If
'**************************************************************************************
'****************************   SQLServer stoppen und warten   ************************



Err.Clear


stoppedpattern = "state\s+:\s*\d\s+stopped"
runningpattern = "state\s+:\s*\d\s+running"
Set objRE = New RegExp
objRE.Global     = False
objRE.IgnoreCase = True

strinput = ""

cmd = "sc " & remotemysqlserver & " stop "&Chr(34)&mysqlservice&Chr(34)
starttime = Timer()
Set oExec = objWSHShell.Exec(cmd)
Do While Not oExec.StdOut.AtEndOfStream
    strinput = strinput & oExec.StdOut.ReadAll	
Loop

If Err.Number Or oExec.ExitCode <> 0 Then  
    objWshShell.LogEvent 1, "sqlbackup: kann SQL-Dienst nicht stoppen." & vbCrLf &  strinput & vbCrLf & oExec.ExitCode & vbCrLf & Err.number & vbTab & Err.description
    Err.clear
    WScript.Quit		
End If

If oExec.ExitCode = 0 And strinput ="" Then
    objWshShell.LogEvent 2, "sqlbackup: der SQL-Dienst war schon gestoppt." 
End If 

starttime = Timer()
cmd = "sc " & remotemysqlserver & " query "&Chr(34)&mysqlservice&Chr(34)
objRE.Pattern = stoppedpattern
stopped = False
Do While stopped=False
	strinput = ""
	Set oExec = objWSHShell.Exec(cmd)
	Do While Not oExec.StdOut.AtEndOfStream
	    strinput = strinput & oExec.StdOut.ReadAll	
	Loop
	Set colMatches = objRE.Execute(strinput)
	If colMatches.Count> 0 Then
		stopped = True
		endtime = Timer()
		If scriptdebug=True Then
			objWSHShell.LogEvent 4, "bfa-backup.vbs: shutdown MySQL took " & endtime-starttime & " seconds"
		End If
	Else
		WScript.Sleep 1000
	End If
Loop





'**************************************************************************************
'******************************  Packen und Kopieren  *********************************
objWshShell.LogEvent 4, "bitfarm-Archiv: SQL-Packvorgang gestartet."
Err.Clear
Call checkrunningrar
Err.Clear
If use7zip = True Then
	zcmd = Chr(34) & zippath & Chr(34) & " a " & Chr(34) &backuppath&"SQLBackup"&nummer& ".zip" & Chr(34) & " " & Chr(34) &makeunc(sqldatapath)& Chr(34) & " -r -v" & CStr(CInt(filesize/1000)) & "m"
	objWSHShell.LogEvent 4,zcmd
	Set oExec = objWSHShell.Exec(zcmd)
    strinput = ""
    strerr = ""
    Do While Not oExec.StdOut.AtEndOfStream
        strinput = strinput & oExec.StdOut.ReadAll	
    Loop
    
    Do While Not oExec.StdErr.AtEndOfStream
        strerr = strerr & oExec.Stderr.ReadAll
    Loop

	objWSHShell.LogEvent 4, "bfa-backup.vbs 7z.exe returncode: " & oExec.ExitCode
	
	If scriptdebug=True Then
		mys = Left(strinput,30000)
		i = 1
		While mys <> ""
			objWSHShell.LogEvent 4, "bfa-backup.vbs 7z.exe stdout " & i & vbCrLf & Chr(34) & mys & Chr(34)
			mys = Mid(strinput,i*30000,30000)
			i = i + 1
		Wend
		
		mys = Left(strerr,30000)
		i = 1
		While mys <> ""
			objWSHShell.LogEvent 4, "bfa-backup.vbs 7z.exe stderr " & i & vbCrLf & Chr(34) & mys & Chr(34)
			mys = Mid(strerr,i*30000,30000)
			i = i + 1
		Wend
	End If
    ret = oExec.ExitCode
Else
	ret = objWSHShell.Run(Chr(34) & programm&"rar.exe" & Chr(34) & " a -r -v"&filesize&" -s -ri1 -ierr -inul "& Chr(34) & backuppath&"SQLBackup"&nummer& Chr(34) & " "& Chr(34) & sqldatapath & Chr(34),0,True)
End If


If Err.Number Or ret <> 0 Then
    
    
    objWshShell.LogEvent 1, "archivbackup: Fehler beim Packen. (MySQL)" & vbcrlf & err.number & vbcrlf & err.Description & vbCrLf & ret
    Err.clear
    errflag=True
End If

WScript.Sleep 1000
If fs.FileExists(sqldatapath&"\..\mysql.log") And backupmysqllog  Then
    
    Jahr1 = DatePart("yyyy",Date)
    Monat1 = Right("00" & DatePart("m",Date),2)
    Tag1 = Right("00" & DatePart("d",Date),2)
    'ret = objWSHShell.Run(programm&"rar.exe a  -s -ri1 -ierr -inul "&backuppath&"SQLLOGBackup"&Jahr1 &"_"& Monat1 &"_"& Tag1&" "&sqldatapath&"\..\mysql.log",0,true)
    Call checkrunningrar
    
    If use7zip = True Then
		zcmd = Chr(34) & zippath & Chr(34) & " a " & Chr(34) &backuppath&"SQLLOGBackup"&nummer & ".zip" & Chr(34) & " " & Chr(34) & sqldatapath&"\..\mysql.log" & Chr(34) & " -r -v" & CStr(CInt(filesize/1000)) & "m"
		objWSHShell.LogEvent 4,zcmd
		Set oExec = objWSHShell.Exec(zcmd)
	    strinput = ""
	    strerr = ""
	    Do While Not oExec.StdOut.AtEndOfStream
	        strinput = strinput & oExec.StdOut.ReadAll	
	    Loop
	    
	    Do While Not oExec.StdErr.AtEndOfStream
	        strerr = strerr & oExec.Stderr.ReadAll
	    Loop
	
		objWSHShell.LogEvent 4, "bfa-backup.vbs 7z.exe returncode: " & oExec.ExitCode
		
		If scriptdebug=True Then
			mys = Left(strinput,30000)
			i = 1
			While mys <> ""
				objWSHShell.LogEvent 4, "bfa-backup.vbs 7z.exe stdout " & i & vbCrLf & Chr(34) & mys & Chr(34)
				mys = Mid(strinput,i*30000,30000)
				i = i + 1
			Wend
			
			mys = Left(strerr,30000)
			i = 1
			While mys <> ""
				objWSHShell.LogEvent 4, "bfa-backup.vbs 7z.exe stderr " & i & vbCrLf & Chr(34) & mys & Chr(34)
				mys = Mid(strerr,i*30000,30000)
				i = i + 1
			Wend
		End If
	    ret = oExec.ExitCode
	Else
		ret = objWSHShell.Run(Chr(34) & programm&"rar.exe" & Chr(34) & " a  -s -ri1 -ierr -inul "& Chr(34) & backuppath&"SQLLOGBackup"&nummer& Chr(34) &" "& Chr(34) &sqldatapath&"\..\mysql.log"& Chr(34),0,True)
	End If
    
    
    
    If Err.Number Or ret <> 0 Then
        Err.clear
        objWshShell.LogEvent 1, "archivbackup: Fehler beim Packen.(mysql.log)"
        errflag=True
        
    End If
    
    WScript.Sleep 1000
End If
WScript.Sleep 10000


'**************************************************************************************
'******************************  Lschen alter SQL-Logs *******************************
' th 02.03.2018:
' Lschen der Logs ausgebaut, muss von der MySQL selbst gemacht werden
' Dazu in der my.ini die Variable "expire_logs_days" setzen, z.B. "expire_logs_days=10" 
' -> fhrt dazu, dass Logs entfernt werden, die lter als 10 Tage sind. Wird von der MySQL
' 	 beim Start erledigt.
'If errflag=False Then
'    objWshShell.LogEvent 4, "bitfarm-Archiv: Suche und Lsche alte SQL-Binrlogs..."
    
'    logcount=0
    
'    Set logfolder=fs.getfolder(sqldatapath)
'    For Each logfile In logfolder.files
        
'        extension=""
'        unterschied=""
        
'        If Len(logfile)>7 Then
'            extension=Right(logfile,7)
'            If Left(extension,1)="." Then
'                If IsNumeric(Right(extension,6))=True Then
                    
'                    unterschied = DateDiff("d" , logfile.DateLastModified, Date)
'                    If unterschied>CInt(backupzeitraum) Then
'                        logcount=logcount+1
'                        msg = msg &"gelscht: " & logfile.Name & vbCrLf
'                        fs.DeleteFile logfile, True
'                        If Err.number<>0 Then
'                            Err.clear
'                            On Error Resume Next
'                            objWshShell.LogEvent 1, "bfa-backup: Fehler beim Lschen eines Binrlogs"
'                        End If
'                    End If
'                End If
'            End If
'        End If
'    Next
'    Set logfolder = Nothing
    
'    If logCount > 0 Then
'        objWshShell.LogEvent 4,"bfa-backup: Es wurden " & CStr(logcount) & " Binrlogdatei/en gelscht, da sie lter als " & backupzeitraum & " Tag/e waren " & vbCrLf & msg	
'    End If 
'End If



If errflag=True Then
    '*************** Fehler beim Backup, Email an admin, Dienste-Neustart nicht durchfhren wenn stoponfail=True
    If adminmail <> "" Then
        If stoponfail = True Then
            errortxt = "Beim Erstellen des letzten Backups ist ein Fehler aufgetreten. Die Dienste (inkl. MySQL) wurden daher angehalten."
            errortxt = errortxt & vbCrLf & "Bitte prfen Sie das Backup und starten die Dienste im Anschluss von Hand."
        Else
            errortxt = "Beim Erstellen des letzten Backups ist ein Fehler aufgetreten."
            errortxt = errortxt & vbCrLf & "Bitte prfen Sie die Konfiguration!."
        End If
        lngReturnCode = objWSHShell.Run(Chr(34)&programm & "sendlinkmail.vbs"&Chr(34)&" " & adminmail & " " &  "0.0" & " " & Chr(34) & errortxt & Chr(34),0,True)
    End If   
    If stoponfail=True Then
        WScript.Quit
    End If 
    
    '**************************************************************************************
End If


'**************************************************************************************
'******************************  Dienst wieder starten  *******************************

Err.Clear
cmd = "sc " & remotemysqlserver & " start "&Chr(34)&mysqlservice&Chr(34)
starttime = Timer()
Set oExec = objWSHShell.Exec(cmd)
Do While Not oExec.StdOut.AtEndOfStream
    strinput = strinput & oExec.StdOut.Read(1)	
Loop

If Err.Number Or oExec.ExitCode <> 0 Then  
    objWshShell.LogEvent 1, "bitfarm-Archiv SQL-Backup: kann SQLServer nicht starten." & vbCrLf &  strinput & vbCrLf & oExec.ExitCode & vbCrLf & Err.number & vbTab & Err.description
    Err.clear
    WScript.Quit		
End If

' wait for MySQL
cmd = "sc " & remotemysqlserver & " query "&Chr(34)&mysqlservice&Chr(34)
objRE.Pattern = runningpattern
started = False
Do While started=False
	strinput = ""
	Set oExec = objWSHShell.Exec(cmd)
	Do While Not oExec.StdOut.AtEndOfStream
	    strinput = strinput & oExec.StdOut.ReadAll	
	Loop
	Set colMatches = objRE.Execute(strinput)
	If colMatches.Count> 0 Then
		started = True
		endtime = Timer()
		If scriptdebug=True Then
			objWSHShell.LogEvent 4, "bfa-backup.vbs: starting MySQL took " & endtime-starttime & " seconds"
		End If
	Else
		WScript.Sleep 1000
	End If
Loop


'**************************************************************************************
'******************************  Dienst wieder starten  *******************************

ret = objWSHShell.Run(chr(34) & programm&"BackupStartService.bat" & chr(34),0,True)
If Err.Number Or ret <> 0 Then
    Err.clear
    objWshShell.LogEvent 1, "archivbackup: kann Arbeitsdienst nicht starten."
    WScript.Quit
End If




'**************************************************************************************
'***********************************  Protokoll   *************************************

objWshShell.LogEvent 4, "bitfarm-Archiv: Packvorgang beendet."

WScript.Quit


'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************Ende Hauptprogramm******************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************

Function checkpath(strPath)
    
    
    If Not fs.FolderExists(strPath) Then
        errortxt="Archivbackup: Verzeichnis nicht vorhanden oder erreichbar ("&strPath&")" & vbCrLf & strPath
        objWshShell.LogEvent 1, errortxt
        checkpath=False
    Else
        checkpath= True
    End If
    
End Function

Function makeunc(strPath)
    
    If Left(strPath,2) = "\\" Then
        If Right(strPath,1) <> "\" Then
            strPath = strPath & "\"
        End If
        
        makeunc= strPath & "*"
    Else
        makeunc= strPath
    End If 
    
End Function


Function readconfig(profil)
    On Error Resume Next
    readconfig=True
    Err.clear
    
    If Not fs.FileExists(programm&profil&".con") Then
        Err.clear
        errortxt=profil&".con Datei nicht im Scriptpfad vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        readconfig=False
        Err.clear
    End If
    
    If readconfig=True Then	
        Set confile = fs.OpenTextFile(programm&profil&".con",1)
        If Err.number Then
            Err.clear
            errortxt="Profilfdatei nicht im Scriptpfad vorhanden oder nicht lesbar."
            objWshShell.LogEvent 1, errortxt
            Err.clear
            readconfig=False
            
        End If 
    End If
    
    If readconfig=True Then	
        kette=confile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        Do While Scriptsflag = 0
            kette=confile.readline
            Scriptsflag=InStr(1,kette,"[Scripts]")
            If confile.AtEndOfStream = True Then
                confile.close
                Set confile=Nothing
                scriptsflag=1
                errortxt="Fehler beim Lesen der CON-Datei - falsche Formatierung."
                objWshShell.LogEvent 1, errortxt
                readconfig = False
                
            End If
        Loop
        
    End If
    
    
    If readconfig = True Then
        
        Do While confile.AtEndOfStream <> True
            
            kette=Trim(confile.readline)
            kette = Replace(kette,vbTab,"")
            
            If Left(kette,1)<>";" Then
                
                
                If InStr(1,kette,"serverprogramm",1)<>0 Then
                    wert=Right(kette,Len(kette)-15)
                    programm = Trim(wert)
                    queue=programm&"queue\"
                    garbagepath=programm&"garbage\"
                    workflows=programm&"workflows\"
                    masks=programm&"masks\"
                    forms=programm&"forms\"
                    
                End If
                
                
                
                
                If Left(kette,13) = "clientspooler" Then
                    wert = Right(kette,Len(kette) -14)
                    clientspooler = Trim(wert)
                End If
                
                If Left(kette,16) = "uncclientspooler" Then
                    wert = Right(kette,Len(kette) -17)
                    uncclientspooler = Trim(wert)
                End If
                
                If InStr(1,kette,"uncclientspooler",1)<>0 Then
                    wert=Right(kette,Len(kette)-17)
                    uncclientspooler = Trim(wert)
                End If
                
                If InStr(1,kette,"use7zip",1)<>0 Then
                    wert=Right(kette,Len(kette)-8)
                    If LCase(wert)="true" Then
                    	use7zip = True
                    Else
                    	use7zip = False
                    End If
                End If
                
                If InStr(1,kette,"archivverzeichnis",1)<>0 Then
                    wert=Right(kette,Len(kette)-18)
                    archivverzeichnis = Trim(wert)
                End If
                
                If InStr(1,kette,"archivkopie",1)<>0 Then
                    wert=Right(kette,Len(kette)-12)
                    archivkopie = Trim(wert)
                End If
                
                If InStr(1,kette,"storages",1)<>0 Then
                    wert = Right(kette,Len(kette) -9)
                    storages = Trim(wert)
                End If
                
                If InStr(1,kette,"archive_rs",1)<>0 Then
                	wert = Right(kette,Len(kette) -11)
                    archive_rs = Trim(wert)
                End If
                
                If InStr(1,kette,"archive_nrs",1)<>0 Then
                	wert = Right(kette,Len(kette) -12)
                    archive_nrs = Trim(wert)
                End If
                
                
                If InStr(1,kette,"backuppath",1)<>0 Then
                    wert=Right(kette,Len(kette)-11)
                    backuppath = Trim(wert)
                End If
                
                If InStr(1,kette,"backupstart",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"backupstart",1)+11)
                    backupstart = wert
                End If
                
                If InStr(1,kette,"remotemysqlserver",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"remotemysqlserver",1)+17)
                    remotemysqlserver = wert
                End If
                
                If InStr(1,kette,"mysqlservice",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"mysqlservice",1)+13)
                    mysqlservice = wert
                End If
                
                
                
                If InStr(1,kette,"sqldatapath",1)<>0 Then
                    wert=Right(kette,Len(kette)-12)
                    'if len(wert)>4 then
                    sqldatapath = Trim(wert)
                    'end if
                End If
                
                If InStr(1,kette,"stoponfail",1)<>0 Then
                    wert=Right(kette,Len(kette)-11)
                    stoponfail = Trim(wert)
                    If LCase(stoponfail)="true" Then
                        stoponfail=True
                    Else
                        stoponfail=False
                    End If
                End If
                
                If InStr(1,kette,"sendername",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"sendername",1)+10)
                    sendername = wert
                End If
                
                If InStr(1,kette,"schattenarchiv",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"schattenarchiv",1)+14)
                    If LCase(wert)="true" Then
                        schattenarchiv=True
                    Else
                        schattenarchiv=False
                    End If
                End If
                
                If InStr(1,kette,"dublettenpruefung",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"dublettenpruefung",1)+17)
                    
                    If (wert="true") Or (wert="TRUE") Then
                        dublettenpruefung=True
                    Else
                        dublettenpruefung=False
                    End If
                    
                End If
                
                If InStr(1,kette,"adminmail",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"adminmail",1)+9)
                    adminmail = wert
                End If
                
                If InStr(1,kette,"unverteilt",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"unverteilt",1)+10)
                    unverteilt = wert
                End If
                
                If InStr(1,kette,"svn_repository",1)<>0 Then
                    wert=Right(kette,Len(kette)-15)
                    svn_repository = Trim(wert)
                End If
                
                
                If Left(Trim(LCase(Replace(kette,vbTab,""))),9)="workflows" Then
                    wert = Right(kette,Len(kette) -10)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        workflows=Trim(wert)
                    End If
                End If	
                
                If InStr(1,kette,"backuparchiv",1)<>0 Then
                    wert=Trim(Right(kette,Len(kette)-13))
                    
                    If LCase(wert)="true" Then
                        backuparchiv=True
                    Else
                        backuparchiv=False
                    End If
                    
                End If
                
                If InStr(1,kette,"backupversion",1)<>0 Then
                    wert=Trim(Right(kette,Len(kette)-14))
                    
                    If LCase(wert)="true" Then
                        backupversion=True
                    Else
                        backupversion=False
                    End If
                    
                End If
                
                If InStr(1,kette,"backupnrsarchiv",1)<>0 Then
                    wert=Trim(Right(kette,Len(kette)-16))
                    
                    If LCase(wert)="true" Then
                        backupnrsarchiv=True
                    Else
                        backupnrsarchiv=False
                    End If
                    
                End If
                
                If InStr(1,kette,"backupworkflows",1)<>0 Then
                    wert=Trim(Right(kette,Len(kette)-16))
                    
                    If LCase(wert)="true" Then
                        backupworkflows=True
                    Else
                        backupworkflows=False
                    End If
                    
                End If
                
                If InStr(1,kette,"backupsvnrepository",1)<>0 Then
                    wert=Trim(Right(kette,Len(kette)-20))
                    
                    If LCase(wert)="true" Then
                        backupsvnrepository=True
                    Else
                        backupsvnrepository=False
                    End If
                    
                End If
                
                If InStr(1,kette,"backupmysqllog",1)<>0 Then
                    wert=Trim(Right(kette,Len(kette)-15))
                    
                    If LCase(wert)="true" Then
                        backupmysqllog=True
                    Else
                        backupmysqllog=False
                    End If
                    
                End If
                
                If InStr(1,kette,"filesize",1)<>0 Then
                    wert=Trim(Right(kette,Len(kette)-9))
                    
                    If IsNumeric(wert) Then
                        filesize=wert 
                        
                    End If
                    
                End If
                
                If InStr(1,kette,"backupzeitraum",1)<>0 Then
                    wert=Trim(Right(kette,Len(kette)-15))
                    
                    If IsNumeric(wert) Then
                        backupzeitraum=wert 
                        
                    End If
                    
                End If
                
            End If
            
        Loop
        confile.close
        Set confile = Nothing
        
    End If
    
    
End Function





'***************************************************************************************
'***************************************************************************************

Function inilesen()
    On Error Resume Next
    Err.clear
    Set inifile = fs.OpenTextFile(programm&"scripts.ini",1)
    If Err.number Then
        objWshShell.LogEvent 1, "scripts.ini nicht im Scriptpfad vorhanden oder nicht lesbar."
        Err.clear
        WScript.Quit
    End If 
    
    kette=inifile.readline
    Scriptsflag=InStr(1,kette,"[Scripts]")
    Do While Scriptsflag = 0
        kette=inifile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        If inifile.AtEndOfStream = True Then
            inifile.close
            objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - falsche Formatierung."
            WScript.Quit
        End If
    Loop
    
    
    Do While inifile.AtEndOfStream <> True
        kette=inifile.readline
        If Left(kette,1)<>";" Then
            
            
            
            If InStr(1,LCase(kette),"zippath",1)<>0 Then
                'wert=GetString(kette,InStr(1,kette,"zippath",1)+8)
				wert=Trim(Right(kette,Len(kette)-8))
                zippath=wert
				'msgbox(zippath)
            End If
            
            If InStr(1,kette,"Profil",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"Profil",1)+7)
                Profil=wert
            End If
            
            
        End If
        
    Loop
    inifile.close
    Set inifile = Nothing
    If Profil="" Then
        objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - kein Profil."
        WScript.Quit
    End If
    
    
End Function



'***************************************************************************************
'***************************************************************************************

Function checkrunningrar
    
    
    z = 0
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='rar.exe'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    z=0
    For Each objItem In colItems
        objItem.Terminate()
        z=z+1
    Next
    If z>0 Then
        objWshShell.LogEvent 4, "bitfarm-Archiv Exception-Handling: Terminierte rar-Instanzen: "&z
        WScript.Sleep 2000
    End If
    
    Set colItems = Nothing
    Set objWMIService = Nothing
    
    
    
    
    
End Function



'**************************************************************************************
'**************************************************************************************



Function Zufallszahl(von, bis)
    On Error Resume Next
    anzahl = bis-von+1
    Randomize
    Zufallszahl = Fix(Rnd*(anzahl))+von
End Function

Private Function StrConvert(String)
    On Error Resume Next
    wert1=0
    l = Len(String)
    
    For x = 1 To l
        wert1=wert1+((Asc(Mid(String,x,1))-48)*(10^(l-x)))
    Next
    StrConvert=wert1
End Function


Private Function GetString(kette,pos)
    On Error Resume Next
    zeichen=""
    ergebnis=""
    index=0
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (zeichen<>"	") And (index<80)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,pos+index,1)
        index=index+1
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=")) And (ergebnis="") Then
            zeichen=""
        End If
    Loop
    Trim(ergebnis)
    GetString=ergebnis
End Function


Function RegRead(tempkey)
    On Error Resume Next
    privkey = tempkey
    
    RegRead = objWSHShell.RegRead(privkey)
    If Not Err.number=0 Then
        objWshShell.LogEvent 1, "Fehler: Registrierungsschlssel nicht gesetzt."
        RegRead=""
        Err.clear
        WScript.Quit
    End If
End Function

'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'************************************   Ende    ***************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
