'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'***************  changelog.vbs     GPL  ***************************************************
'*******************************************************************************************
'***************  Version 3.6.2.0        ***************************************************
'*******************************************************************************************
'***************  Dienstscript zur berwachung des nicht revisionsicheren    ***************
'***************  Dokumentenbereiches zur Meldung von nderungen.            ***************
'***************                                                             ***************
'***************                                                             ***************
'***************  Wird vom Spooldienst gestartet                             ***************
'***************                                                             ***************
'***************  Syntax: <programmpfad>changelog.vbs                        ***************
'***************                                                             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************

'*** fr den Service:
scriptdebug=False
ignoreuser=False
maxopenhandles=200
' default latenz = 10
latenz=20
' default zeitfenster=180
zeitfenster=120
slots=200
strComputer="."   'auch anderer Server mglich
z = 0 

'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************

On Error Resume Next
Set objWshShell = WScript.CreateObject("WScript.Shell")
Set fs = CreateObject("Scripting.FileSystemObject")

fullpath = WScript.ScriptFullName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Sleep 3000
    WScript.Quit
End If 
scriptname = WScript.ScriptName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Sleep 3000
    WScript.Quit
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Sleep 3000
    WScript.Quit
End If 
If Len(programm)=0 Then
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Sleep 3000
    WScript.Quit
End If

ReDim HandleNR(maxopenhandles), HandleName(maxopenhandles), HandleProz(maxopenhandles), HandleUser(maxopenhandles)
ReDim ext(20)
ReDim slotdatei(slots)
ReDim slottimestamp(slots)
ReDim slotusername(slots)
ReDim slotfree(slots)

ReDim oldslotdatei(slots)
ReDim oldslottimestamp(slots)
ReDim oldslotusername(slots)



For x=0 To slots-1
    slotdatei(x)=""
    slottimestamp(x)=Now
    slotusername(x)=""
    slotfree(x) = True
    oldslotdatei(x)=""
    oldslottimestamp(x)=Now
    oldslotusername(x)=""
    
Next

'**********************  von der berwachung ausgeschlossene Extensions  *****************	
'ext(1)="tif"
'ext(2)="ps"
'ext(3)="txt"
'ext(4)="job"
'ext(5)="ftx"
'ext(6)="swd"
'ext(7)="jpg"
'ext(8)="vtx"
'ext(9)="pcx"
'ext(10)="gif"
'ext(11)="bmp"
'ext(12)="iev"
'ext(13)="eml"
'ext(14)="msg"
'ignoreext= ".tif.ps.txt.job.ftx.swd.jpg.vtx.pcx.gif.bmp.iev.eml.msg"
ignoreext= ".tif.ps.job.ftx.swd.jpg.vtx.pcx.gif.bmp.iev.eml.msg"

targetfolder=""
remotetargetfolder""
hostlanguage=""
hostversion=""
svnfiletypes=""	
svnpath=""
svncreatenewrecord=""
iSCSIPath=""
dokid=""
profil=""

inilesen()


If targetfolder="" Then
    objWshShell.LogEvent 1, "bitfarm-Archiv nderungsdienst: kein berwachtes Verzeichnis. Inaktiv..."
    o=0
    Do While o=0
        WScript.Sleep 60000
    Loop
    WScript.Quit
End If

username = LCase(objWSHShell.ExpandEnvironmentStrings("%username%"))

If Err.number<>0 Then
    Err.clear
    On Error Resume Next
    username="administrator"
End If

queue=programm&"queue\"

For i = 0 To maxerinnern 
    HandleNR(i)=""
    HandleName(i)=""
    HandleProz(i)=""
    HandleUser(i)=""
Next

'Handling fr iSCSI


If (iSCSIPath<>"") And (Len(targetfolder)>3) Then
    myfolder=Right(targetfolder,Len(targetfolder)-3)
    myfolder=iSCSIPath&myfolder
    
Else
    myfolder=targetfolder
    
End If


Err.clear
'Set objEvents = GetObject("winmgmts:{(Security)}\\.\root\cimV2")
Set objEvents = GetObject("winmgmts:" _
& "{impersonationLevel=impersonate,(Security)}!\\" & _
strComputer & "\root\cimv2")


If Err.Number Then
    objWshShell.LogEvent 1, "bitfarm-Archiv nderungsdienst: kann keine Verbindung zum Eventlog herstellen, WMI nicht gestartet?." & vbCrLf & Err.number
    Err.clear
    WScript.Sleep 3000
    WScript.Quit
End If

If (hostlanguage="englisch") And (hostversion="w2k") Then 
    Set Events = objEvents.ExecNotificationQuery ("select * from __InstanceCreationEvent WHERE TargetInstance ISA 'Win32_NTLogEvent' AND TargetInstance.Eventcode ='562' AND TargetInstance.Logfile = 'Security'") 
End If

If (hostlanguage="deutsch") And (hostversion="w2k") Then 
    Set Events = objEvents.ExecNotificationQuery ("select * from __InstanceCreationEvent WHERE TargetInstance ISA 'Win32_NTLogEvent' AND TargetInstance.Eventcode ='560' AND TargetInstance.Logfile = 'Security'") 
End If

If ((hostversion="2k3") Or (hostversion="xp")) Then 
    Set Events = objEvents.ExecNotificationQuery ("select * from __InstanceCreationEvent WHERE TargetInstance ISA 'Win32_NTLogEvent' AND TargetInstance.Eventcode ='560' AND TargetInstance.Logfile = 'Security'") 
End If

If hostversion="2k8" Then 
    Set Events = objEvents.ExecNotificationQuery ("select * from __InstanceCreationEvent WHERE TargetInstance ISA 'Win32_NTLogEvent' AND TargetInstance.Eventcode ='4656' AND TargetInstance.Logfile = 'Security'") 
End If




If scriptdebug=True Then
    objWshShell.LogEvent 4, "bitfarm-Archiv nderungsdienst (Debug-Modus): starte...." & vbCrLf & "myfolder:" & myfolder
End If

'************************************** Hauptschleife ********************************************

If (hostlanguage="englisch") And (hostversion="w2k") Then
    
    Do
        checkage()
        Set NTEvent = Events.nextevent 
        sender = NTEvent.TargetInstance.ComputerName
        typ = NTEvent.TargetInstance.Type
        Code = NTEvent.TargetInstance.Eventcode
        Category = NTEvent.TargetInstance.Category
        Dienst = NTEvent.TargetInstance.SourceName
        User = NTEvent.TargetInstance.User
        
        
        If (Code="560") And (Dienst="Security") And (Category="3") Then
            kette=NTEvent.TargetInstance.Message
            dateiname=Trim(Getstring(kette,InStr(1,kette,"Object Name:",1)+13))
            laenge=Len(dateiname)
            dateiname=Left(dateiname,laenge-4)
            
            If Dateiname<>"" Then
                zwischenhandle=Trim(GetString(kette,InStr(1,kette,"New Handle ID:",1)+15))
                zwischenhandle=Left(zwischenhandle,Len(zwischenhandle)-4)
                zwischenprozess=Trim(GetString(kette,InStr(1,kette,"Process ID:",1)+12))
                zwischenprozess=Left(zwischenprozess,Len(zwischenprozess)-4)
                
                i=0
                Do While HandleName(i)<>""
                    i=i+1
                Loop
                HandleName(i)=dateiname
                HandleNR(i)=zwischenhandle
                HandleProz(i)=zwischenprozess
                HandleUser(i)=User
                If scriptdebug=True Then
                    objWshShell.LogEvent 4, "bitfarm-Archiv nderungsdienst (Debug-Modus): Trap1: "&dateiname
                End If
                
            End If
            
        End If
        
        
        If (Code="562") And (Dienst="Security") And (Category="3") Then
            kette=NTEvent.TargetInstance.Message
            zwischenhandle=Trim(GetString(kette,InStr(1,kette,"Handle ID:",1)+11))
            zwischenhandle=Left(zwischenhandle,Len(zwischenhandle)-4)
            zwischenprozess=Trim(GetString(kette,InStr(1,kette,"Process ID:",1)+12))
            zwischenprozess=Left(zwischenprozess,Len(zwischenprozess)-4)
            'objWshShell.LogEvent 2,"NeuerHandle2:"&dateiname&":"&zwischenhandle&":"&zwischenprozess&":"&User
            i=0
            
            Do While ((HandleNR(i)<>zwischenhandle) Or (HandleProz(i)<>zwischenprozess)) And (i<maxopenhandles)
                i=i+1
            Loop
            If (HandleProz(i)=zwischenprozess) And (HandleNR(i)=zwischenhandle) Then
                fname=HandleName(i)	
                WScript.Sleep 100
                
                '*****************************   Aktion    ****************************
                tellinfo(i)
                '**********************************************************************
                
                HandleProz(i)=""
                HandleNR(i)=""
                HandleName(i)=""
                HandleUser(i)=""
                
            End If
        End If
        Set ntevents=Nothing
        WScript.Sleep 200   
    Loop
    
End If



If (LCase(hostlanguage="deutsch")) And (LCase(hostversion="w2k")) Then
    
    Do
        checkage()
        Set NTEvent = Events.nextevent 
        sender = NTEvent.TargetInstance.ComputerName
        typ = NTEvent.TargetInstance.Type
        Code = NTEvent.TargetInstance.Eventcode
        Category = NTEvent.TargetInstance.Category
        Dienst = NTEvent.TargetInstance.SourceName
        User = NTEvent.TargetInstance.User
        
        
        If (Code="560") And (Dienst="Security") And (Category="3") Then
            kette=NTEvent.TargetInstance.Message
            dateiname=Trim(Getstring(kette,InStr(1,kette,"Objektname:",1)+12))
            laenge=Len(dateiname)
            dateiname=Left(dateiname,laenge-4)
            
            If Dateiname<>"" Then
                zwischenhandle="0"
                zwischenprozess="0"
                i=0
                Do While HandleName(i)<>""
                    i=i+1
                Loop
                HandleName(i)=dateiname
                HandleNR(i)=zwischenhandle
                HandleProz(i)=zwischenprozess
                HandleUser(i)=User
                '*************************************** Aktion ***********************
                tellinfo(i)
                '**********************************************************************
                
                HandleProz(i)=""
                HandleNR(i)=""
                HandleName(i)=""
                HandleUser(i)=""
                
            End If
        End If
        
        Set ntevents=Nothing
        WScript.Sleep 200   
    Loop
    
    
End If


'If (hostlanguage="deutsch") and ((hostversion="2k3") or (hostversion="xp")) Then

If ((hostversion="2k3") Or (hostversion="xp")) Then
    
    Do
        checkage()
        Set NTEvent = Events.nextevent 
        sender = NTEvent.TargetInstance.ComputerName
        typ = NTEvent.TargetInstance.Type
        Code = NTEvent.TargetInstance.Eventcode
        Category = NTEvent.TargetInstance.Category
        Dienst = NTEvent.TargetInstance.SourceName
        User = NTEvent.TargetInstance.User
        
        If (Code="560") And (Dienst="Security") And (Category="3") Then
            kette=NTEvent.TargetInstance.Message
            dateiname = ""
            
            If InStr(1, kette,"Objektname:") Then	
                pos1 = InStr(1,kette,"Objektname:")+11
                pos2 = InStr(pos1,kette, vbCrLf)
                If pos1 <> 0 And pos2<>0 Then
                    dateiname =Mid(kette, pos1, pos2-pos1)
                    dateiname = Trim(Replace(dateiname,vbTab,""))
                End If 
            End If 
            
            If InStr(1,kette,"Object Name:",1) Then
                pos1 = InStr(1,kette,"Object Name:")+12
                pos2 = InStr(pos1,kette, vbCrLf)
                If pos1 <> 0 And pos2<>0 Then
                    dateiname =Mid(kette, pos1, pos2-pos1)
                    dateiname = Trim(Replace(dateiname,vbTab,""))
                End If 
            End If 
            
            
            If Dateiname<>"" Then
                zwischenhandle="0"
                zwischenprozess="0"
                i=0
                Do While HandleName(i)<>""
                    i=i+1
                Loop
                
                HandleName(i)=dateiname
                HandleNR(i)=zwischenhandle
                HandleProz(i)=zwischenprozess
                HandleUser(i)=User
                '*************************************** Aktion ***********************
                tellinfo(i)
                '**********************************************************************
                
                HandleProz(i)=""
                HandleNR(i)=""
                HandleName(i)=""
                HandleUser(i)=""
            End If
            
        End If  
        
        Set ntevents=Nothing
        WScript.Sleep 200   
    Loop
    
End If



'If (hostlanguage="deutsch") and (hostversion="2k8") Then
If hostversion="2k8" Then
    
    Do
        checkage()
        Set NTEvent = Events.nextevent 
        sender = NTEvent.TargetInstance.ComputerName
        typ = NTEvent.TargetInstance.Type
        Code = NTEvent.TargetInstance.Eventcode
        Category = NTEvent.TargetInstance.Category
        Dienst = NTEvent.TargetInstance.SourceName
        User = NTEvent.TargetInstance.User
        kette=NTEvent.TargetInstance.Message
        
        If scriptdebug = True Then
            objWshShell.LogEvent 4, "nderungsdienst: Code=" & Code & vbCrLf & "Category=" & Category & vbCrLf & "Dienst=" & Dienst& vbCrLf & kette & vbCrLf & Timer()
        End If 
        
        
        If (Code="4656" ) And (Dienst="Microsoft-Windows-Security-Auditing") And (Category="12800") Then
            If scriptdebug = True Then
                objWshShell.LogEvent 4, "nderungsdienst: Code=" & Code & vbCrLf & "Category=" & Category & vbCrLf & "Dienst=" & Dienst& vbCrLf & kette & vbCrLf & Timer()
            End If 
            
            If InStr(1, kette,"Objektname:") Then	
                pos1 = InStr(1,kette,"Objektname:")+11
                pos2 = InStr(pos1,kette, vbCrLf)
                If pos1 <> 0 And pos2<>0 Then
                    dateiname =Mid(kette, pos1, pos2-pos1)
                    dateiname = Trim(Replace(dateiname,vbTab,""))
                End If 
            End If 	
            
            If InStr(1,kette,"Object Name:",1) Then
                pos1 = InStr(1,kette,"Object Name:")+12
                pos2 = InStr(pos1,kette, vbCrLf)
                If pos1 <> 0 And pos2<>0 Then
                    dateiname =Mid(kette, pos1, pos2-pos1)
                    dateiname = Trim(Replace(dateiname,vbTab,""))
                End If 
            End If 
            
            
            User=Trim(Getstring(kette,InStr(1,kette,"Kontoname:",1)+10))
            
            If Dateiname<>"" Then
                
                zwischenhandle="0"
                zwischenprozess="0"
                i=0
                Do While HandleName(i)<>""
                    i=i+1
                Loop
                HandleName(i)=dateiname
                HandleNR(i)=zwischenhandle
                HandleProz(i)=zwischenprozess
                HandleUser(i)=User
                '*************************************** Aktion ***********************
                tellinfo(i)
                '**********************************************************************
                
                HandleProz(i)=""
                HandleNR(i)=""
                HandleName(i)=""
                HandleUser(i)=""
            End If
        End If
        
        Set NTEvent = Nothing
        WScript.Sleep 20   
    Loop
    
End If



objWshShell.LogEvent 1, "bitfarm-Archiv nderungsdienst: Unerwartet terminiert. Bitte Konfiguration prfen und ggf. Support anfordern."
WScript.Sleep 1000
WScript.Quit


'**********************************  Ende ***********************************



Function tellinfo(i)
    On Error Resume Next
    fname=LCase(Handlename(i))
    user=LCase(HandleUser(i))
    laenge=Len(myfolder)
    If Len(fname)>laenge Then
        If Left(fname,laenge)=myfolder Then
            'umformatieren fname, wenn iSCSI-Host
            If myfolder<>targetfolder Then
                'fname=Left(targetfolder,3)&Right(fname,Len(fname)-Len(myfolder))
                fname=targetfolder&Right(fname,Len(fname)-Len(myfolder))
            ElseIf remotetargetfolder<>"" Then
            	fname=Replace(fname,targetfolder,remotetargetfolder)
            End If
            
            If (InStr(1,User,username,1)=0) And (InStr(1,User,"system",1)=0) Or (ignoreuser=True) Then
                If InStr(1,fname,"~$",1)=0 And InStr(1,fname,".~lock",1)=0 And InStr(1,fname,".svn\",1)=0 Then 
                    If (InStr(1,fname,"~wrl",1)=0) And (InStr(1,fname,"~wrd",1)=0) Then
                        If fs.FileExists(fname) Then	
                            getroffen=True
                            
                            
                            
                            If InStr(1,ignoreext,LCase(fs.GetExtensionName(fname))) Then
                                getroffen = False
                                Exit Function
                            End If 
                            
                            If scriptdebug=True Then
                                mytesthandle=Handlename(i)
                                objWshShell.LogEvent 4, "nderungsdienst (Debug-Modus): Trap4 (getroffen): "&mytesthandle & vbCrLf  _
                                &	"Abfrage FileExists("&fname&")="&fs.fileexists(fname)
                            End If	
                            
                            
                            
                            If getroffen=True Then
                                
                                WScript.Sleep 200
                                
                                Set filehandle=fs.getfile(fname)
                                myfiledate=filehandle.dateLastModified
                                myfileaccessed=filehandle.dateLastAccessed
                                Set filehandle=Nothing
                                mydate=Now
                                
                                If myfiledate = myfileaccessed Then
                                    differenz=DateDiff("s",myfiledate,mydate)
                                Else
                                    If myfiledate >= myfileaccessed Then
                                        differenz=DateDiff("s",myfiledate,mydate)
                                    Else
                                        differenz=DateDiff("s",myfileaccessed,mydate)
                                    End If 
                                End If 
                                
                                If scriptdebug=True Then
                                    objWshShell.LogEvent 4, "nderungsdienst (Debug-Modus): Trap5 Differenz: "&differenz & " <180"
                                End If
                                
                                If differenz < zeitfenster Then    'nur events der letzten drei minuten bercksichtigen
                                    gefunden=False
                                    abbruch=False
                                    x=0
                                    Do While abbruch=False
                                        If slotdatei(x)=fname Then
                                            slottimestamp(x)=mydate
                                            slotusername(x)=user
                                            gefunden=True
                                            abbruch=True
                                        End If
                                        x=x+1
                                        If x>slots-1 Then
                                            abbruch=True
                                        End If
                                    Loop
                                    If gefunden=False Then
                                        abbruch=False
                                        x=0
                                        Do While abbruch=False
                                            If slotdatei(x)="" Then
                                                slotdatei(x)=fname
                                                slottimestamp(x)=mydate
                                                slotusername(x)=user
                                                Exit Do
                                                'abbruch=true
                                            End If
                                            x=x+1
                                            If x>slots-1 Then
                                                abbruch=True
                                                objWshShell.LogEvent 1, "bitfarm-Archiv nderungsdienst: Schwerer Fehler: Arrayberlauf"
                                            End If
                                        Loop
                                    End If
                                    
                                    If scriptdebug=True Then
                                        objWshShell.LogEvent 4, "nderungsdienst (Debug-Modus): Gendert:"&fname&" User:"&User&" Targetfolder:"&targetfolder&" jetzt:"&mydate&" Dateimodified:"&myfiledate & vbCrLf &"Slot=" & x
                                    End If
                                End If
                                
                            End If
                        End If
                    End If
                End If
            End If 
        End If
    End If
    
End Function



Function checkage()
    On Error Resume Next
    mydate=Now
    
    
    If scriptdebug Then
        msg=""
        For x = 0 To slots-1
            If slotdatei(x) <> "" Then
                msg = msg & x & ": " & slottimestamp(x) & "= " & slotdatei(x)& vbCrLf
            End If 
        Next 
        objWshShell.LogEvent 4, "nderungsdienst(Debug-Modus):" & mydate & vbCrLf &"Aktive Slots:" & vbCrLf & msg
    End If
    
    
    
    
    For x=0 To slots-1
        If slotdatei(x)<>"" Then
            change = True
            'If DateDiff("s",slottimestamp(x),mydate)>latenz Or scriptdebug Then
            'probieren wir hier mal einen anderen mechanismus um zu verhindern das dokumente alle 10 sec aktualisiert werden
            'allerdings soll die erste nderung (adhoc nderung) bercksichtigt werden
            ' und nderungen die lnger als drei minuten her sind
            
            
            For y = 0 To slots-1
                If slotdatei(x)=oldslotdatei(y) Then   'diese datei wurde schon aktualisiert nur wann?
                    diff = DateDiff("s",oldslottimestamp(y),slottimestamp(x))
                    If diff <= latenz  Then   'nicht grer 10 sec ?
                        change = False
                        Exit For
                    End If 
                End If 
            Next
            
            
            
            If change = True Then
                If scriptdebug=True Then
                    objWshShell.LogEvent 4, "nderungsdienst (Debug-Modus): trifft zu: Latenz>"&latenz&vbCrLf&slotdatei(x) & vbCrLf & "SlotTimeStamp:"& slottimestamp(x)& vbCrLf&"mydate:" & mydate
                End If
                
                extension = fs.GetExtensionName(slotdatei(x))
                
                i=10000
                tempname=queue&"change"&i&".cng"
                flag10=True
                If fs.FileExists(tempname) Then
                    flag10=False
                End If
                Do While flag10=False
                    i = i + 1
                    tempname=queue&"change"&i&".cng"
                    flag10=True
                    If fs.FileExists(tempname) Then
                        flag10=False
                    End If
                Loop
                myusername=slotusername(x)
                Err.clear
                On Error Resume Next
                If InStr(1,myusername,"\",1)<>0 Then
                    myusername=Right(myusername,Len(myusername)-InStr(1,myusername,"\",1))
                    
                End If
                If InStr(1,myusername,vbCrLf) Then
                    myusername=Replace(myusername,vbCrLf,"")
                End If
                
                myusername=Trim(myusername)
                Err.clear
                On Error Resume Next
                dokid=""
                
                searchdocsbyfilename(slotdatei(x))
                
                If profil="" Or dokid="" Then
                    erfolg = readjob(slotdatei(x))
                End If
                
                If profil <>"" And dokid<>"" Then
                    Set changefile = fs.OpenTextFile(tempname,8,True)
                    If Err.number=0 Then
                        changefile.writeline(slotdatei(x))
                        changefile.writeline(myusername)
                        If dokid<>"" Then
                            dokid=Trim(dokid)
                            changefile.writeline dokid
                        End If
                        
                        If profil<>"" Then
                            profil=Trim(profil)
                            changefile.writeline profil
                        End If
                        
                        If svn_add<>"" Then
                            changefile.writeline("Revision:" & svn_add)
                        End If
                        changefile.close
                    Else
                        Err.clear
                        On Error Resume Next
                        objWshShell.LogEvent 1, "bitfarm-Archiv nderungsdienst: Fehler beim Schreiben der Change-Datei. " & tempname
                    End If
                    
                    Set changefile=Nothing
                    WScript.Sleep 50
                End If 
                
                If scriptdebug Then
                    strdebug = ""
                    If fs.fileexists(tempname) Then
                        Set tfile = fs.Opentextfile(tempname)
                        Do Until tfile.atendofstream
                            strdebug = strdebug & tfile.ReadLine &vbCrLf
                        Loop
                        tfile.close
                        Set tfile = Nothing
                        objWshShell.LogEvent 4, "nderungsdienst (Debug-Modus):" & tempname & vbCrLf & "Inhalt:" & vbCrLf& strdebug				
                    Else
                        objWshShell.LogEvent 1, "nderungsdienst (Debug-Modus):" & tempname & " nicht vorhanden!"
                    End If 
                End If 
                
                found = False
                For y =0 To slots-1
                    If oldslotdatei(y)=slotdatei(x) Then  'alten slot aktualisieren oder anlegen
                        oldslottimestamp(y)=slottimestamp(x)
                        oldslotusername(y) = slotusername(x)
                        found = True
                        Exit For
                    End If
                Next
                
                If found = False Then
                    For y =0 To slots-1
                        
                        If oldslotdatei(y)="" Then  'leeren alten slot anlegen
                            oldslotdatei(y)=slotdatei(x)
                            oldslottimestamp(y)=slottimestamp(x)
                            oldslotusername(y) = slotusername(x)
                            Exit For
                        End If
                    Next
                End If 
                
                'bei erfolgreicher erstellung der changedatei wird der aktuelle slot zurckgesetzt		
                slotdatei(x)=""
                slottimestamp(x)=mydate
                slotusername(x)=""
                
                If z => 10 Then
                    z = 0  'Breakpoint zum Debuggen
                End If 
                
            End If
        End If
    Next
    WScript.Sleep 100
    
    
    ' alte Slots  die lnger als 3min in der Liste sind, zurcksetzen  
    For y = 0 To slots-1
        If oldslotdatei(y) <>"" Then
            diff = DateDiff("s",oldslottimestamp(y),Now())
            If diff > zeitfenster Then
                oldslotdatei(y)=""
                oldslottimestamp(y)=Now()
                oldslotusername(y)=""
            End If 
        End If 
    Next 
    
    
    
    z = z +1
End Function





Function inilesen()
    On Error Resume Next
    Err.clear
    Set inifile = fs.OpenTextFile(programm&"scripts.ini",1)
    If Err.number Then
        objWshShell.LogEvent 1, "scripts.ini nicht im Scriptpfad vorhanden oder nicht lesbar."
        Err.clear
        WScript.Quit
    End If 
    
    kette=inifile.readline
    Scriptsflag=InStr(1,kette,"[Scripts]")
    Do While Scriptsflag = 0
        kette=inifile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        If inifile.AtEndOfStream = True Then
            inifile.close
            objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - falsche Formatierung."
            WScript.Quit
        End If
    Loop
    
    
    Do While inifile.AtEndOfStream <> True
        kette=inifile.readline
        If Left(kette,1)<>";" Then
            
            If InStr(1,kette,"Profil",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"Profil",1)+7)
                If Profil="" Then
                    profil = wert
                End If
            End If
            
            If InStr(1,kette,"nderungsdienst=",1)<>0 Then
                wert=Right(kette,Len(kette)-(InStr(1,kette,"nderungsdienst=",1)+15))
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    targetfolder = LCase(wert)
                End If
            End If
            
            If InStr(1,LCase(kette),"remotenderung=",1)<>0 Then
                wert=Right(kette,Len(kette)-(InStr(1,LCase(kette),"remotenderung=",1)+14))
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    remotetargetfolder = LCase(wert)
                End If
            End If
            
            If InStr(1,kette,"Hostsystem=",1)<>0 Then
                wert=Right(kette,Len(kette)-(InStr(1,kette,"Hostsystem=",1)+10))
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    hostversion = LCase(wert)
                End If
            End If
            
            If InStr(1,kette,"Hostsprache=",1)<>0 Then
                wert=Right(kette,Len(kette)-(InStr(1,kette,"Hostsprache=",1)+11))
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    hostlanguage = LCase(wert)
                End If
            End If
            
            If InStr(1,kette,"iSCSIPath=",1)<>0 Then
                wert=Right(kette,Len(kette)-(InStr(1,kette,"iSCSIPath=",1)+9))
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    iSCSIPath = LCase(wert)
                End If
            End If
            
            
            If InStr(1,kette,"svnfiletypes",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"svnfiletypes",1)+13)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    svnfiletypes=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"svnpath",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"svnpath",1)+8)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    svnpath=Trim(wert)
                End If
            End If
            
            
        End If
    Loop
    inifile.close
    Set inifile = Nothing
    If programm="" Then
        objWshShell.LogEvent 2, "Fehler beim Lesen der scripts.ini - kein Programmpfad."
        WScript.Quit
    End If
    
    
End Function




Private Function StrConvert(String)
    On Error Resume Next
    wert1=0
    For x = 1 To Len(String)
        wert1=wert1+((Asc(Mid(String,x,1))-48)*(10^(Len(String)-x)))
    Next
    StrConvert=wert1
End Function

Private Function GetString(kette,pos)
    On Error Resume Next
    zeichen=""
    ergebnis=""
    index=0
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (zeichen<>"	") And (index<120)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,pos+index,1)
        index=index+1
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=")) And (ergebnis="") Then
            zeichen=""
        End If
    Loop
    Trim(ergebnis)
    GetString=ergebnis
End Function




Function readjob(jobfilename)
    On Error Resume Next
    readjob=True
    Err.clear
    
    jobfile = fs.getparentfoldername(jobfilename) & "\" & fs.getBasename(jobfilename) 
    
    If Not fs.FileExists(jobfile&".job") Then
        Err.clear
        errortxt="Changelog.vbs: " & jobfile&".job Datei nicht vorhanden oder nicht lesbar(1)."
        objWshShell.LogEvent 1, errortxt
        readjob=False
        Err.clear
    End If
    
    If readjob=True Then	
        Set jobfile = fs.OpenTextFile(jobfile&".job",1)
        If Err.number Then
            Err.clear
            errortxt="Changelog.vbs: " & jobfile&".job datei nicht vorhanden oder nicht lesbar.(1)"
            objWshShell.LogEvent 1, errortxt
            
            readjob=False
            
        End If 
    End If
    
    
    If readjob = True Then
        
        Do While jobfile.AtEndOfStream <> True
            kette=jobfile.readline
            If Left(kette,1)<>";" Then
                
                If InStr(1,kette,"Profil=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Profil=",1)+7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Profil = wert
                    End If
                End If
                
                If InStr(1,kette,"DOCID=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"DOCID=",1)+5)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        dokID = wert
                    End If
                End If
                
            End If
            
            
        Loop
        jobfile.close
        Set jobfile = Nothing
    End If
    
End Function

Function searchdocsbyfilename(strfile)
    On Error Resume Next
    searchdocsbyfilename=False
    'sollte keine Job-Datei vorhanden sein, die Tabelle aus dem Pfad ermitteln, nach der Datei suchen
    'und doc_id ausgeben lassen. als profil muss das aus der scripts ini reichen (problem bei mehreren getrennten mandanten)
    If scriptdebug Then
        objWshSHell.LogEvent 4,"changelog.vbs: searchdocsbyfilename gestartet:" & vbCrLf & strfile
    End If 
    If Not fs.FileExists(programm&"searchdocsbyfilename.exe") Then
        objWshSHell.LogEvent 1,"changelog.vbs: searchdocsbyfilename.exe nicht im Programmpfad"
        Exit Function
    End If 
    
    searchdocsbyfilename=False
    If profil<>"" Then
        
        strfilename= fs.getBaseName(strfile) & "." & fs.getExtensionName(strfile)
        
        If InStr(1,strfile,targetfolder)<>0 Then
            
            Set oExec    = objWSHShell.Exec(Chr(34) & programm&"searchdocsbyfilename.exe" & Chr(34) & " -l "& profil & " all ori_loc " & strfilename )
            strinput = oExec.StdOut.ReadAll
            
            durch = False
            schleife = 0
            Do While schleife < 1000
                If oExec.Status = 1 Then 
                    durch = True
                    Exit Do
                End If
                
                WScript.Sleep 10
                schleife = schleife +1
            Loop
            
            rc = oExec.ExitCode
            
            
            If durch = False Or rc <> 0 Then
                objWshSHell.LogEvent 1,"changelog.vbs: Fehler beisearchdocsbyfilename.exe"
                Exit Function
            End If 
            
            
            If InStr(1,strinput,"Treffer: 0")<>0 Then
                objWshSHell.LogEvebt 1,"changelog.vbs: searchdocsbyfilename: fr das bergebene Dokument wurde kein Datenbankeintrag gefunden" & vbCrLf & strfile
            Else
                If InStr(1,strinput,"DOCID=")<>0 Then
                    
                    strinput =Right(strinput,Len(strinput)-InStr(1,strinput,"DOCID=")-5) 
                    dokid = Left(strinput,InStr(1,strinput,Chr(13))-1)
                    searchdocsbyfilename=True
                    
                End If
            End If
            
        Else
            objWshSHell.LogEvebt 1,"changelog.vbs: searchdocsbyfilename: bergebener Pfad scheint nicht im berwachtem Verzeichnis zu liegen" & vbCrLf & strfile
        End If
    End If
    
End Function
