'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'***************  cleanup.vbs      GPL  ****************************************************
'*******************************************************************************************
'***************  Version 3.6.2.1       ****************************************************
'*******************************************************************************************
'***************  Hilfsscript zur Behandlung eines Ausnahmefehlers           ***************
'***************                                                             ***************
'***************  beendet bitfarm-Archiv Prozesse                            ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************


On Error Resume Next
Set fs      = WScript.CreateObject("Scripting.FileSystemObject") 
Set objWSHShell = WScript.CreateObject("WScript.Shell") 
fullpath = WScript.ScriptFullName
If err.number Then
	err.clear
	errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
	objWshShell.LogEvent 1, errortxt
	WScript.Quit
End If 
scriptname = WScript.ScriptName
If err.number Then
	err.clear
	errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
	objWshShell.LogEvent 1, errortxt
	WScript.Quit
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))
If err.number Then
	err.clear
	errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
	objWshShell.LogEvent 1, errortxt
	WScript.Quit
End If 

	
		Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
		strQuery = "Select * from Win32_Process where Name='gswin32.exe'"
		Set colItems = objWMIService.ExecQuery(strQuery,,48)
		z=0
		For Each objItem in colItems
   			 objItem.Terminate()
   			 z=z+1
		Next
		If z>0 Then
			objWshShell.LogEvent 0, "bitfarm-Archiv Exception-Handling: Terminierte Ghostscript-Instanzen: "&z
		End If

		Set colItems = NOTHING
		Set objWMIService = NOTHING
		
		
		Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
		strQuery = "Select * from Win32_Process where Name='gswin32c.exe'"
		Set colItems = objWMIService.ExecQuery(strQuery,,48)
		z=0
		For Each objItem in colItems
   			 objItem.Terminate()
   			 z=z+1
		Next
		If z>0 Then
			objWshShell.LogEvent 0, "bitfarm-Archiv Exception-Handling: Terminierte Ghostscript-Instanzen: "&z
		End If

		
		Set colItems = NOTHING
		Set objWMIService = NOTHING
		
		Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
		strQuery = "Select * from Win32_Process where Name='dbimpv3.exe'"
		Set colItems = objWMIService.ExecQuery(strQuery,,48)
		z=0
		For Each objItem in colItems
   			 objItem.Terminate()
   			 z=z+1
		Next
		If z>0 Then
			objWshShell.LogEvent 0, "bitfarm-Archiv Exception-Handling: Terminierte dbimpv3-Instanzen: "&z
		End If

		Set colItems = NOTHING
		Set objWMIService = NOTHING
		
		
		Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
		strQuery = "Select * from Win32_Process where Name='FilterV3.exe'"
		Set colItems = objWMIService.ExecQuery(strQuery,,48)
		z=0
		For Each objItem in colItems
   			 objItem.Terminate()
   			 z=z+1
		Next
		If z>0 Then
			objWshShell.LogEvent 0, "bitfarm-Archiv Exception-Handling: Terminierte Filter-Instanzen: "&z
		End If

		Set colItems = NOTHING
		Set objWMIService = NOTHING
		

		
		Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
		strQuery = "Select * from Win32_Process where Name='gsview32.exe'"
		Set colItems = objWMIService.ExecQuery(strQuery,,48)
		z=0
		For Each objItem in colItems
   			 objItem.Terminate()
   			 z=z+1
		Next
		If z>0 Then
			objWshShell.LogEvent 0, "bitfarm-Archiv Exception-Handling: Terminierte gsview-Instanzen: "&z
		End If

		Set colItems = NOTHING
		Set objWMIService = Nothing
		
		Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
		strQuery = "Select * from Win32_Process where Name='soffice.bin'"
		Set colItems = objWMIService.ExecQuery(strQuery,,48)
		z=0
		For Each objItem in colItems
   			 objItem.Terminate()
   			 z=z+1
		Next
		If z>0 Then
			objWshShell.LogEvent 0, "bitfarm-Archiv Exception-Handling: Terminierte soffice.bin-Instanzen: "&z
		End If

		Set colItems = Nothing
		Set objWMIService = Nothing
		
		Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
		strQuery = "Select * from Win32_Process where Name='soffice.exe'"
		Set colItems = objWMIService.ExecQuery(strQuery,,48)
		z=0
		For Each objItem in colItems
   			 objItem.Terminate()
   			 z=z+1
		Next
		If z>0 Then
			objWshShell.LogEvent 0, "bitfarm-Archiv Exception-Handling: Terminierte soffice.exe-Instanzen: "&z
		End If

		Set colItems = Nothing
		Set objWMIService = Nothing
		
	
'		Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
'		strQuery = "Select * from Win32_Process where Name='OpAgent.exe'"
'		Set colItems = objWMIService.ExecQuery(strQuery,,48)
'		z=0
'		For Each objItem in colItems
'   		objItem.Terminate()
'   		 z=z+1
'   	Next
'		If z>0 Then
'			objWshShell.LogEvent 0, "bitfarm-Archiv Exception-Handling: Terminierte OpAgent.exe-Instanzen: "&z
'		End If
'
'		Set colItems = Nothing
'		Set objWMIService = Nothing
'		
'		Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
'		strQuery = "Select * from Win32_Process where Name='JobRunner.exe'"
'		Set colItems = objWMIService.ExecQuery(strQuery,,48)
'		z=0
'		For Each objItem in colItems
'   		objItem.Terminate()
'   		 z=z+1
'   	Next
'		If z>0 Then
'			objWshShell.LogEvent 0, "bitfarm-Archiv Exception-Handling: Terminierte JobRunner.exe-Instanzen: "&z
'		End If
'
'		Set colItems = Nothing
'		Set objWMIService = Nothing
'	

		Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
		strQuery = "Select * from Win32_Process where Name='SplitterV3.exe'"
		Set colItems = objWMIService.ExecQuery(strQuery,,48)
		z=0
		For Each objItem in colItems
   			 objItem.Terminate()
   			 z=z+1
		Next
		If z>0 Then
			objWshShell.LogEvent 2, "bitfarm-Archiv Exception-Handling: Terminierte SplitterV3-Instanzen: "&z
			
		End If

		Set colItems = NOTHING
		Set objWMIService = Nothing
		
				
		If fs.fileexists(programm&"temp\lock") Then
			fs.deletefile programm&"temp\lock", true
			If err.number Then
				err.clear
				On Error Resume Next
			End If
		End If
		
		If fs.fileexists(programm&"temp\directlock") Then
			fs.deletefile programm&"temp\directlock", true
			If err.number Then
				err.clear
				On Error Resume Next
			End If
		End If
		
		If fs.fileexists(programm&"temp\superlock") Then
			fs.deletefile programm&"temp\superlock", true
			If err.number Then
				err.clear
				On Error Resume Next
			End If
		End If

		If fs.fileexists(programm&"temp\barcodelock") Then
			fs.deletefile programm&"temp\barcodelock", true
			If err.number Then
				err.clear
				On Error Resume Next
			End If
		End If
				
		If fs.fileexists(programm&"temp\movelock") Then
			fs.deletefile programm&"temp\movelock", true
			If err.number Then
				err.clear
				On Error Resume Next
			End If
		End If
		
			
		
	
	wscript.sleep 200
	
	wscript.quit
	
	
	
