'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'***************  clientspooler.vbs   GPL  *************************************************
'*******************************************************************************************
'***************  Version 3.6.2.0    *******************************************************
'*******************************************************************************************
'***************  Programm zur bergabe der vom Druckertreiber erzeugten     ***************
'***************  Postscript-Datei auf die berwachte Serverfreigabe         ***************
'***************                                                             ***************
'***************  wird gestartet auf dem Client bei einem Druckjob           ***************
'***************  ber die redrun parameter                                  ***************
'***************                                                             ***************
'***************  Syntax: wscript <server-programmpfad>clientspooler.vbs     ***************
'***************  %1 <druckername> <OCR-Typ> <Template> <Profil>             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************


trennzeichen=""


'*******************************************************************************************
'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

On Error Resume Next
 
Dim objWSHShell, fso, FileIn, FileOut 
Dim Datei, Text, Txt, i, arrSort, arrTest(), oArgs, Druckername
Dim lngReturnCode
 
Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set fs      = WScript.CreateObject("Scripting.FileSystemObject") 
set oArgs    = Wscript.Arguments 



'*******************************************************************************************
'*******************************************************************************************
'******************************* Initialisierung der globalen Variablen ********************


uncclientspooler=""
err.clear
fullpath = WScript.ScriptFullName
If err.number Then
	err.clear
	errortxt="bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehler beim Drucken/Archivieren: Kann Startparameter nicht initialisieren - aktueller Scripting Host? Wenden Sie sich an den Administrator."
	MsgBox(errortxt)
	WScript.Quit
End If 
scriptname = WScript.ScriptName
If err.number Then
	err.clear
	errortxt="bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehler beim Drucken/Archivieren: Kann Startparameter nicht initialisieren - aktueller Scripting Host? Wenden Sie sich an den Administrator."
	MsgBox(errortxt)
	WScript.Quit
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))


If err.number Then
	err.clear
	errortxt="bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehler beim Drucken/Archivieren: Kann Startparameter nicht initialisieren - aktueller Scripting Host? Wenden Sie sich an den Administrator."
	MsgBox(errortxt)
	WScript.Quit
End If 
If Len(programm)=0 Then
	errortxt="bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehler beim Drucken/Archivieren: Kann Startparameter nicht initialisieren - aktueller Scripting Host? Wenden Sie sich an den Administrator."
	MsgBox(errortxt)
	WScript.Quit
End If
queue=programm&"queue\"

'*******************************************************************************************
'*******************************************************************************************


 
Redmon = objWSHShell.ExpandEnvironmentStrings("%REDMON_USER%")    
If err.number<>0 Then
    MsgBox("bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehler: Kann Benutzername nicht auswerten.")
    err.clear
    WScript.Quit
  End If 

If (Len(Redmon)<1) or (Redmon="%REDMON_USER%") or (Redmon="") Then
	Redmon="unbekannt"
End If

'*************************************************************************************
'**************************   Parameterbergabe **************************************
'************************************************************************************* 


Typ = oArgs.item(1) 
  If err.number<>0 Then
    MsgBox("bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehlende Parameter. Benutzung: clientspooler.vbs <pfad zur ps-Datei> <Name des Serverdruckers> <Typ: OMP|OCR|TXT> <Tabelle> <Profil>")
    err.clear
    WScript.Quit
  End If 

  Profil = oArgs.item(3) 
  If err.number<>0 Then
    MsgBox("bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehlende Parameter. Benutzung: clientspooler.vbs <pfad zur ps-Datei> <Name des Serverdruckers> <Typ: OMP|OCR|TXT> <Tabelle> <Profil>")
    err.clear
    WScript.Quit
  End If 
Druckername = oArgs.item(0)
If err.number<>0 Then
    MsgBox("bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehlende Parameter. Benutzung: clientspooler.vbs <pfad zur ps-Datei> <Name des Serverdruckers> <Typ: OMP|OCR|TXT> <Tabelle> <Profil>")
    err.clear
    WScript.Quit
End If 

Tabelle = oArgs.item(2) 
  If err.number<>0 Then
    MsgBox("bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehlende Parameter. Benutzung: clientspooler.vbs <pfad zur ps-Datei> <Name des Serverdruckers> <Typ: OMP|OCR|TXT> <Tabelle> <Profil>")
    err.clear
    WScript.Quit
  End If 

Datei = oArgs.item(4) 
  If err.number<>0 Then
    MsgBox("bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehlende Parameter. Benutzung: clientspooler.vbs <pfad zur ps-Datei> <Name des Serverdruckers> <Typ: OMP|OCR|TXT> <Tabelle> <Profil>")
    err.clear
    WScript.Quit
  End If 



If Left(Druckername,3) = "-l:" Then
	' lokal ausdrucken'
	Druckername = Right(Druckername,Len(Druckername) -3)
	fs.CopyFile Datei, Datei & ".ps"
	objWSHShell.LogEvent 1, "wscript "&chr(34)&  programm&"psprint.vbs"&chr(34)&" """&druckername&""" "&chr(34)&Datei&".ps" &chr(34)& " " & profil
	Set psprint = objWSHShell.exec ("wscript "&chr(34)&  programm&"psprint.vbs"&chr(34)&" """&druckername&""" "&chr(34)&Datei&".ps" &chr(34)& " " & profil)
	
	
	Druckername = "noprint"
End If 



If InStr(1,Druckername,"\") Then
	Druckername = Replace(Druckername,"\","~")
End If
If InStr(1,Druckername," ") Then
		Druckername = Replace(Druckername," ","#")
	End If




	

zahl = Zufallszahl(100000,999999)



erfolg=readconfig(Profil)

If erfolg=false Then
	MsgBox("bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehler: Kann nicht archivieren, da das angegebene Profil nicht lesbar/vorhanden ist (Profilname: "&Profil&"). Sollte das Problem wiederholt auftreten, wenden Sie sich an Ihren Administrator.")
	WScript.Quit
End If

druckpfad = uncclientspooler



'If (Typ <> "TXT") AND (Typ <> "OCR") AND (Typ <> "OMP") AND (Typ <> "OCX") AND (Typ <> "OMX") AND (Typ <> "TXX") Then
'	MsgBox("bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Dokumententyp als Parameter nicht bergeben. Bitte die redrun-Befehlszeile in den Druckereinstellungen prfen. Dokumententypen OMP, OCR oder TXT.")
'	WScript.Quit
'End If

If Druckername = "" Then
	MsgBox("bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Druckername als Parameter nicht bergeben. Bitte die redrun-Befehlszeile in den Druckereinstellungen prfen.")
	WScript.Quit
End If

Ausgabename =  druckpfad&Redmon&trennzeichen&Druckername&trennzeichen&Typ&trennzeichen&Tabelle&trennzeichen&Profil&trennzeichen&zahl&".ps"

If fs.FileExists(Ausgabename) Then
	MsgBox("bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehler bei bergabe des Ausdrucks an den Server(1). Sollte dieses Problem hufiger vorkommen bitte Nachricht an 0271 / 31 396 - 0 oder per E-Mail an service@bitfarm-gmbh.de")
	WScript.Quit
End If

If not fs.FileExists(Datei) Then
	MsgBox("bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehler bei bergabe des Ausdrucks an den Server(2). Sollte dieses Problem hufiger vorkommen bitte Nachricht an 0271 / 31 396 - 0 oder per E-Mail an service@bitfarm-gmbh.de")
	WScript.Quit
End If

If err.number<>0 Then
	err.clear
	On Error Resume Next
End If

'objWshShell.LogEvent 1, "logging clientspooler: "&Datei&":"&Ausgabename
'MsgBox(Datei&":"&Ausgabename)
showmsg
fs.CopyFile Datei, Ausgabename, True
wscript.sleep 1000 '** Eingefgt, damit User die bertragungsnachricht auch sehen
removemsg
  If err.number<>0 Then
    MsgBox("bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehler bei bergabe des Ausdrucks an den Server(3 - fehlende Schreibrechte, kein Zugriff auf "&druckpfad&" ). Sollte dieses Problem hufiger vorkommen informieren Sie bitte Ihren Administrator"&VBCRLF&VBCRLF&"Windows Vista: Sie mssen Mitglied der lokalen Administratoren dieses Rechners sein, oder zumindest Schreibrechte auf %systemroot%\temp haben, damit die Funktion nutzbar ist.")
    err.clear
    WScript.Quit
  End If
  
'WScript.Quit

If Right(Typ,1)= "X" Then
For ii = 1 To 10 
WScript.sleep 2000  
If not fs.FileExists(Ausgabename) Then
	'checkfeedback
		lngReturnCode = objWSHShell.Run(programm&"checkfeedback.vbs "& zahl,1,False)
		Exit For 
End If
Next 
End If 


WScript.Quit


'******************************************  Funktionen  *************************************

'***************************************************************************************
'***************************************************************************************
'***************************************************************************************




Function starteviewer()
On Error Resume Next
mymsg=druckpfad&"msg"&zahl&".bfa"
Set msgdatei = fs.OpenTextFile(mymsg,1)
dokID=msgdatei.readline
msgdatei.close
Set msgdatei = nothing
On Error Resume Next
fs.deletefile mymsg, true
If err.number <> 0 Then
	err.clear
	On Error Resume Next
End If

lngReturnCode = objWSHShell.exec(programm&"\ViewerV3.exe "&dokID)
If err.number<>0 Then
	err.clear
	'MsgBox("Fehler beim starten des Viewers. Aktueller Windows Scripting Host?")
End If
WScript.Quit
End Function





'***************************************************************************************
'***************************************************************************************
'***************************************************************************************



Function readconfig(profil)
On Error Resume Next
readconfig=true
err.clear

If not fs.FileExists(programm&profil&".con") Then
	
	readconfig=false
	err.clear
End If
		
If readconfig=true Then	
Set confile = fs.OpenTextFile(programm&profil&".con",1)
If err.number Then
	
	err.clear
	readconfig=false
	
End If 
End If

If readconfig=true Then	
kette=confile.readline
Scriptsflag=InStr(1,kette,"[Scripts]")
Do While Scriptsflag = 0
kette=confile.readline
Scriptsflag=InStr(1,kette,"[Scripts]")
If confile.AtEndOfStream = True Then
	confile.close
	Set confile=nothing
	scriptsflag=1
	
	readconfig = false
    	
End If
loop

End If


If readconfig = true Then
	
Do While confile.AtEndOfStream <> True

kette=Trim(confile.readline)
kette = Replace(kette,vbTab,"")


If Left(kette,1)<>";" Then
	
	
	If Left(kette,13) = "clientspooler" Then
		wert = Right(kette,Len(kette) -14)
		clientspooler = Trim(wert)
	End If
	
	If Left(kette,16) = "uncclientspooler" Then
		wert = Right(kette,Len(kette) -17)
		uncclientspooler = Trim(wert)
	End If
	
	
End If

loop
confile.close
Set confile = nothing

End If


End Function




'***************************************************************************************
'***************************************************************************************
'***************************************************************************************


Function Zufallszahl(von, bis)
On Error Resume Next
anzahl = bis-von+1
randomize
Zufallszahl = Fix(rnd*(anzahl))+von
End Function


Private Function StrConvert(string)
On Error Resume Next
  wert1=0
  l = Len(string)
  
  For x = 1 to l
    wert1=wert1+((Asc(Mid(String,x,1))-48)*(10^(l-x)))
  Next
  StrConvert=wert1
End Function


Private Function GetString(kette,pos)
On Error Resume Next
zeichen=""
ergebnis=""
index=0
Do While (zeichen<>" ") and (zeichen<>Vbcrlf) and (zeichen<>"	") and (index<80)
        ergebnis=ergebnis+zeichen
	zeichen=Mid(kette,pos+index,1)
	index=index+1
	If ((zeichen=" ") or (zeichen="	") or (zeichen="=")) and (ergebnis="") Then
		zeichen=""
	End If
loop
Trim(ergebnis)
GetString=ergebnis
End Function


Function RegRead(tempkey)
On Error Resume Next
	privkey = tempkey

	RegRead = objWSHShell.RegRead(privkey)
	if not err.number=0 Then
	MsgBox( "Fehler: Registrierungsschlssel nicht gesetzt.")
	RegRead=""
	err.clear
	WScript.Quit
	end if
End Function




Function showmsg()
On Error Resume Next
showmsg=True
err.clear
On Error Resume Next
Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
If err.number<>0 Then
	err.clear
	On Error Resume Next
	showmsg=False
Else
	Set objWMIService = Nothing
End If
If showmsg=True Then
Set oExec = objWSHShell.exec(programm&"bfamessage.exe")
If err.number<>0 Then
	err.clear
	On Error Resume Next
	showmsg=False
Else
	Set oexec=Nothing
End If
End If
End Function



Function removemsg()
err.clear
On Error Resume Next
Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
If err.number=0 Then
strQuery = "Select * from Win32_Process where Name='bfamessage.exe'"
Set colItems = objWMIService.ExecQuery(strQuery,,48)
For Each objItem in colItems
	 objItem.Terminate()
Next
wscript.sleep 100
Set colItems = NOTHING
Set objWMIService = Nothing
End If
err.clear
On Error Resume Next
End Function






'*******************************************************************************************
'*******************************************************************************************
'********************************          Ende             ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
