'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'***************  controler.vbs   GPL  *****************************************************
'*******************************************************************************************
'***************  Version 3.6.2.2      *****************************************************
'*******************************************************************************************
'***************  Programm zum Start und Kontrolle des verteiler-Dienstes    ***************
'***************  fr Client-Druckauftrge an die Archivdrucker       	     ***************
'***************                                                             ***************
'***************  wird auf dem Server ber den Druckdienst und die Datei     ***************
'***************  controler.bat einmal pro Minute gestartet.                 ***************
'***************                                                             ***************
'***************  Syntax: controler.bat                                      ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************


looptime = 500


'*******************************************************************************************
'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
On Error Resume Next

Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set fs      = WScript.CreateObject("Scripting.FileSystemObject") 
Set oArgs    = Wscript.Arguments 


pid = ""
Profil=""
strname=""
strinput=""
pfadvbs=""

fullpath = WScript.ScriptFullName
scriptname = WScript.ScriptName
mypath = Left(fullpath,Len(fullpath)-Len(scriptname))


If mypath = "" Then
	objWshShell.LogEvent 1, "bitfarm-Archiv: Controller: Kein Pfad aufgelst gefunden."
    	WScript.Quit
End If 

Profil = oArgs.item(0) 
  If err.number<>0 Then
    err.clear
    objWSHShell.LogEvent 1, "bitfarm-Archiv: Controller: Fehlender Parameter: Profil."
    err.clear
    WScript.Quit
  End If 

If (Profil="") or (Profil=" ") or (Profil="	") Then
	objWSHShell.LogEvent 1, "bitfarm-Archiv: Controller: Fehlender Parameter: Profil."
 	WScript.Quit
End If

WScript.Sleep 200


If fs.FileExists(mypath&"getrunningvbs.exe") = False Then
	objWSHShell.LogEvent 1, "bitfarm-Archiv: Controller: getrunningvbs.exe nicht im Programmpfad gefunden." & vbCrLf & mypath&"getrunningvbs.exe"
 	WScript.Quit
End If

start = chr(34)&mypath&"verteiler.bat"&chr(34)&" "&Profil

strname=getrunningvbs()
If strname = "" Then
  objWSHShell.LogEvent 0, "controler.vbs: getrunningvbs.exe = " & strname
End If

If InStr(strname,"verteiler.vbs") <> 0 Then
	'gestartet, aber wie oft ?

	'erste string berspringen
	'strname = Right(strname,Len(strname)-InStr(1,strname,Chr(13))-1)
	
	Do While Instr(strname,"verteiler.vbs")<> 0 
		pid = Trim(Left(strname,InStr(strname,"-->")-1))
		strname = Right(strname,Len(strname)-InStr(1,strname,"-->")-3)
		pfadvbs = Left(strname,InStr(1,strname,Chr(13))-1)
		strname = Right(strname,Len(strname)-InStr(1,strname,Chr(13))-1)
		
		
		' alles ber einen laufenden prozess terminieren
		If InStr(pfadvbs,"verteiler.vbs") then
		
			If passfirst = True then
			Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
			strQuery = "Select * from Win32_Process where Handle='" & pid &"'"
			Set colItems = objWMIService.ExecQuery(strQuery,,48)
	
			For Each objItem in colItems
			 objItem.Terminate()
			 objWSHShell.LogEvent 2,"Controler.vbs: doppelte Verteiler.vbs terminiert" & vbCrLf & "PID=" & pid
			
			Next
			Set objWMIService = Nothing
			End If
			passfirst=True		
			
		End If
		pfadvbs=""
	Loop		
Else	' nicht gestartet	
	Set ergebnis = objWSHShell.exec(start)
	WScript.Sleep looptime
	
	strname = getrunningvbs()
	
	Do While Instr(strname,"verteiler.vbs")<> 0 

	pid = Trim(Left(strname,InStr(strname,"-->")-1))
	strname = Right(strname,Len(strname)-InStr(1,strname,"-->")-3)
	pfadvbs = Left(strname,InStr(1,strname,Chr(13))-1)
	strname = Right(strname,Len(strname)-InStr(1,strname,Chr(13))-1)
	Loop

	objWSHShell.LogEvent 4,"Controler.vbs: Verteiler.vbs gestartet" & vbCrLf & "PID=" & pid	
End If

WScript.Quit

Function getrunningvbs
On Error Resume Next
	Set oExec    = objWSHShell.Exec(chr(34)&mypath&"getrunningvbs.exe"&chr(34))
	strinput = oExec.StdOut.ReadAll
	durch = False
	schleife = 0
	Do While schleife < 5000
		If oExec.Status = 1 Then 
	    	durch = True
	     	Exit Do
	     End if
	     	
	     WScript.Sleep 1
	     schleife = schleife +1
	Loop

	getrunningvbs = LCase(strinput)
	Set oExec = Nothing

End Function

'*******************************************************************************************
'*******************************************************************************************
'********************************          Ende             ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************


