'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'***************  direktimport.vbs   GPL  **************************************************
'*******************************************************************************************
'***************  Version 3.6.2.0         **************************************************
'*******************************************************************************************
'***************  Nimmt Postscript, PDF oder TIF-Dateien entgegen            ***************
'***************  (Drag & Drop) und bergibt diese zur Archivierung an den   ***************
'***************  Server. Neu: auch .DOC und .DWG Dateien.                   ***************
'***************  				                                             ***************
'***************  wird gestartet auf dem Client bei Drag & Drop              ***************
'***************                                                             ***************
'***************                                                             ***************
'***************  Syntax: wscript <server-programmpfad>direktimport.vbs      ***************
'***************  <Profil> <Datei(en)>                                       ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************


Profil=""

quickimport=false


'*******************************************************************************************
'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

On Error Resume Next
 
Dim objWSHShell, fso, FileIn, FileOut 
Dim Datei, Text, Txt, i, arrSort, arrTest(), oArgs, Druckername
Dim lngReturnCode

ReDim ext(60)

lngReturnCode = 0
 
Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set fs      = WScript.CreateObject("Scripting.FileSystemObject") 
set oArgs    = Wscript.Arguments 

'*******************************************************************************************
'**************************  eventlog auf 'Ereignisse berschreiben setzen' ****************
'

strComputer = "."
Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")

Set objInstalledLogFiles = objWMIService.ExecQuery _
    ("Select * from Win32_NTEventLogFile Where LogFilename = 'Application'")

For each objLogfile in objInstalledLogFiles
   
    If objLogfile.OverWriteOutdated <> 0 Then
    	objLogfile.OverWriteOutdated = 0 
    	objLogFile.Put_
    End If
   If Err.Number <> 0 Then
    	 objWSHShell.LogEvent 1, "Achtung ! Im Eventlog des Clients ist nicht die Option 'Eintrge bei Bedarf berschreiben' gesetzt. Logging und Scriptdebug werden daher ausgeschaltet." 
    	scriptdebug = False
			logging = False
    	Err.Clear
    	On Error Resume Next
    End If
    
Next

Set objLogfile = Nothing
Set objInstalledLogFiles = Nothing
Set objWMIService = Nothing


'*******************************************************************************************



 
clientprogramm=""
uncclientspooler="" 

Typ=""
lockdatei=""

For i=0 to 59
ext(i)="...."
Next

extcounter=0

acceptdoc=false
acceptxls=false
acceptdwg=false
acceptppt=false
deletesourcefiles=false
acceptallfiletypes=false

'*******************************************************************************************
'**************************  Startparameter initialisieren  ********************************
err.clear
fullpath = WScript.ScriptFullName
If err.number Then
	err.clear
	errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
	objWshShell.LogEvent 1, errortxt
	WScript.Quit
End If 
scriptname = WScript.ScriptName
If err.number Then
	err.clear
	errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
	objWshShell.LogEvent 1, errortxt
	WScript.Quit
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))
If err.number Then
	err.clear
	errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
	objWshShell.LogEvent 1, errortxt
	WScript.Quit
End If 
If Len(programm)=0 Then
	errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
	objWshShell.LogEvent 1, errortxt
	WScript.Quit
End If


' *************************************  inilesen ***********************************

inilesen

' ***********************************************************************************



ext(0)=".tif"
ext(1)=".ps"
ext(2)=".pdf"
ext(3)=".bmp"
ext(4)=".jpg"
ext(5)=".gif"
extcounter=6

If acceptdoc=true Then
	ext(extcounter)=".doc"
	ext(extcounter+1)=".rtf"
	ext(extcounter+2)=".htm"
	ext(extcounter+3)=".txt"
	extcounter=extcounter+4
End If

If acceptxls=true Then
	ext(extcounter)=".xls"
	ext(extcounter+1)=".dbf"
	ext(extcounter+2)=".tab"
	extcounter=extcounter+3
End If

If acceptppt=true Then
	ext(extcounter)=".ppt"
	ext(extcounter+1)=".pps"
	extcounter=extcounter+2
End If

If acceptdwg=true Then
	ext(extcounter)=".dwg"
	ext(extcounter+1)=".dxf"
	extcounter=extcounter+2
	
End If


temppath = objWSHShell.ExpandEnvironmentStrings("%temp%")    
If err.number<>0 Then
    MsgBox("bitfarm-Archiv: Fehler: Kann TEMP-Variable nicht auswerten.")
    err.clear
    WScript.Quit
  End If 
username = objWSHShell.ExpandEnvironmentStrings("%username%")    
If err.number<>0 Then
    MsgBox("bitfarm-Archiv: Fehler: Kann USERNAME-Variable nicht auswerten.")
    err.clear
    WScript.Quit
  End If 

If (Len(username)<1) or (username="%username%") or (username="") Then
	username="unbekannt"
End If


tempfile=temppath&"\temp.tif"
dokdate=""


'*******************************  Testen auf Kollission   ***************************************



If fs.fileexists(temppath&"\Lock") Then
	a=0
	Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
	If err.number<>0 Then
		err.clear
		MsgBox("Fehler: kein Microsoft WMI installiert. Bitte nachinstallieren.")
		WScript.Quit
	End If
	strQuery = "Select * from Win32_Process where Name='wscript.exe'"
	Set colItems = objWMIService.ExecQuery(strQuery,,48)
	For Each objItem in colItems
   	 	a=a+1
	Next
	Set colItems=nothing
	Set objWMIService=nothing
	If a>1 Then
		
		
		frage = "Es luft zur Zeit bereits eine Datenbertragung an den Archivserver. Bitte versuchen Sie es in einigen Minuten noch einmal. Sollte diese Meldung stets wiederkommen, informieren Sie den Netzwerkadministrator."
		ueberschrift = "bitfarm-Archiv Import"
		antwort = objWSHShell.Popup(frage,, ueberschrift, vbExclamation)
		WScript.Quit
		
		'abbruch=false
		'Do While abbruch=false
		'WScript.Sleep 1000
		'If not fs.fileexists(temppath&"\Lock") Then
		'	abbruch=true
		'End If
		'If abbruch=true Then
		'	zahl=Zufallszahl(1000,5000)
		'	WScript.Sleep zahl
		'	If fs.fileexists(temppath&"\Lock") Then
		'		abbruch=false
		'	End If
		'End If
		'loop
		
	Else
		fs.deletefile temppath&"\Lock", true
	End If
	
End If
	
lockdatei=temppath&"\Lock"
Set lockfile = fs.OpenTextFile(temppath&"\Lock",8,true)
If err.number<>0 Then
	WScript.Quit
End If
lockfile.writeline("lock")
lockfile.close
Set lockfile=nothing



'*******************************************************************************************
'**************************  Prfen, ob Server bereit  *************************************


erfolg=readconfig(Profil)
If erfolg=false Then
	MsgBox("bitfarm-Archiv: Kann Konfigurationsdatei nicht lesen ("&Profil&")")
	Unlock(lockdatei)
	WScript.Quit
End If

druckpfad = uncclientspooler 

zahl = Zufallszahl(1000,9999)




'*******************************************************************************************
'**************************  Alle Jobdateien lschen, die evtl. noch vorhanden sind  *******

i=0
Set folder = fs.GetFolder(temppath)
For each file in folder.files

If (Right(file,3) = "job") or (Right(file,3) = "JOB") Then
	err.clear
  	fs.DeleteFile file, True
  	If err.number<>0 Then
    		MsgBox("bitfarm-Archiv: Kein Schreibzugriff auf das TEMP-Verzeichnis. Bitte informieren Sie Ihren Administrator.")
    		err.clear
    		Unlock(lockdatei)
    		WScript.Quit
  	End If
End If
Next


'**************************************************************************************************
'******************************************   Zielabfrage   ***************************************
'**************************************************************************************************




lngReturnCode = objWSHShell.Run(programm&"ImporterV3.exe "&programm&profil&".con ",1,true)
wscript.Sleep 200
If lngReturnCode <> 0 Then
	'MsgBox("bitfarm-Archiv: Allgemeiner Fehler bei Parameterbergabe.")
	Unlock(lockdatei)
	WScript.Quit
End If


'**************************************************************************************************
'*******************************    Jobdatei suchen   *********************************************
'**************************************************************************************************
template=""
Set folder = fs.GetFolder(temppath)
For each file in folder.files

If (Right(file,3) = "job") or (Right(file,3) = "JOB") Then
	template=file
End If
Next
Set folder = nothing

If template<>"" Then
Set tempobject=fs.getfile(template)
templatename=tempobject.name
Set tempobject=nothing
templatename=Left(templatename,Len(templatename)-4)
Else
Unlock(lockdatei)
wscript.quit
End If

'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************

Profil=""

erfolg=readjob(template)
If erfolg=false Then
	MsgBox("bitfarm-Archiv: Kann zum angegebenen Archiv kein Template finden ("&template&")")
	Unlock(lockdatei)
	WScript.Quit
End If

erfolg=readconfig(Profil)
If erfolg=false Then
	MsgBox("bitfarm-Archiv: Kann Konfigurationsdatei nicht lesen ("&Profil&")")
	Unlock(lockdatei)
	WScript.Quit
End If

druckpfad = uncclientspooler 

If druckpfad="" Then
	MsgBox("bitfarm-Archiv: Fehler: Konnte keinen bergabepfad zum Server bestimmen.")
	Unlock(lockdatei)
	WScript.Quit
End If


'If (Typ <> "TXT") AND (Typ <> "OCR") AND (Typ <> "OMP") Then
'	MsgBox("Falscher Texterkennungstyp. Bitte Script autoscan.vbs prfen.")
'	Unlock(lockdatei)
'	WScript.Quit
'End If

'*******************************************************************************************
'************************************ Parameter in Jobdatei  *******************************
dokdate=setdokdate()
erfolg = writejob(Left(template,Len(template)-4))
If erfolg=false Then
	MsgBox("bitfarm-Archiv: kann Parameter nicht in Jobdatei schreiben - kann nicht archivieren. Bitte informieren Sie den Administrator.")
	Unlock(lockdatei)
	WScript.Quit
End If




'*******************************************************************************************
'*******************************************************************************************
'*************************************************************************************
'**************************   Parameterbergabe und Hauptschleife ********************
'************************************************************************************* 

'MsgBox("bitfarm-Archiv: Die gewhlten Dateien / Ordner werden nun archiviert. Bitte warten Sie, bis die Besttigung angezeigt wird.")
showmsg
err.clear
i=0
dateianzahl=0
datei=""
abbruch1=false
On Error Resume Next

Do While abbruch1=False And i <= oArgs.Count-1
	
	On Error Resume Next
	err.clear
	datei=oArgs.item(i)
	If err.number<>0 Then
		err.clear
		abbruch1=true
	Else
		
	
		i=i+1
	
		
		
'*******************************************************************************************
'**********************************  Hier die Aktion  **************************************

If fs.folderexists(Datei) Then
	archfolder(Datei)
Else
	archfile(Datei)
	
End If




'*******************************************************************************************
'*******************************************************************************************

End If		
		
	

loop
err.clear

If dateianzahl > 0 Then
	'MsgBox("bitfarm-Archiv: "&dateianzahl&" Datei(en) wurden an den Server bergeben.")
Else
	i=0
	kette=""
	Do While ext(i)<>"...."
		kette=kette&" "&ext(i)
		i=i+1
	loop
	frage = "Keine Dateien zum archivieren gefunden."&VBCRLF&"Untersttzte Dateitypen:"&VBCRLF&VBCRLF&kette
	If acceptallfiletypes=true Then
		frage="Keine Dateien zum archivieren gefunden."
	End If
	ueberschrift = "bitfarm-Archiv Dateiimport"
	antwort = objWSHShell.Popup(frage,, ueberschrift, vbSystemModal + vbExclamation)
	
	
End If


'**************************************************************************************************
'*************************************  aufrumen und Ende  ***************************************
'**************************************************************************************************


Set folder = fs.GetFolder(temppath)
For each file in folder.files



If (LCase(Right(file,3)) = "job") or (LCase(Right(file,3)) = "slx") or (LCase(Right(file,3)) = "slw") or (LCase(Right(file,3)) = "vtx") Then
	err.clear
	fs.deletefile file, True
	err.clear
End If


Next
Set folder = Nothing
wscript.sleep 1000 '** Eingefgt, damit User die bertragungsnachricht auch sehen
removemsg
Unlock(lockdatei)

WScript.Quit


'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************

Function archfolder(datei)
On Error Resume Next
Set ordner=fs.getfolder(datei)
For each file in ordner.files
archfile(file)
Next
For each unterordner in ordner.subfolders
archfolder(unterordner)
Next
Set ordner=nothing
End Function

Function archfile(Datei)
On Error Resume Next
w=0
abbruch=false
extension=""

Do While abbruch=false
If w>5 Then
	abbruch=true
End If
If (abbruch=false) and (Mid(datei,(Len(datei)-w),1)=".") Then
	extension=LCase(Right(datei,w+1))
	abbruch=true
End If
If abbruch=false Then
	w=w+1
End If
loop




u=0
Do While u<=extcounter

If (extension=ext(u)) or (acceptallfiletypes=true) Then
	If (extension<>".rar") and (extension<>".wfend") and (extension<>".bfa") and (extension<>".ftx") and (extension<>".vtx") and (extension<>".job") and (extension<>".slw") and (extension<>".slx") and (extension<>".swd") and (extension<>".tff") Then
	
	if lcase(right(datei,9))<>"thumbs.db" then
	writeslwdatei(datei)
	sendtoserver(Datei)
	dateianzahl=dateianzahl+1
	u=10000
	end if
	End If
End If
u=u+1
loop


End Function


Function sendtoserver(datei)
On Error Resume Next
sendtoserver=false
zahl = Zufallszahl(100000,999999)
If quickimport=false Then
Ausgabename=druckpfad&"file"&zahl
Else
Ausgabename=druckpfad&"fast"&zahl
End If


If fs.FileExists(Ausgabename&".job") Then
	zahl = Zufallszahl(100000,999999)
	If quickimport=false Then
	Ausgabename=druckpfad&"file"&zahl
	Else
	Ausgabename=druckpfad&"fast"&zahl
	End If
	If fs.FileExists(Ausgabename&".job") Then
		zahl = Zufallszahl(100000,999999)
		If quickimport=false Then
		Ausgabename=druckpfad&"file"&zahl
		Else
		Ausgabename=druckpfad&"fast"&zahl
		End If
	
	
		Wscript.Sleep 1500
		If fs.FileExists(Ausgabename&".job") Then
			removemsg
			MsgBox("bitfarm-Archiv: Fehler: Serverdienst reagiert nicht.")
			Unlock(lockdatei)
			WScript.Quit
		End If
	End If
		
End If



err.clear
fs.CopyFile template, Ausgabename&".job", True
If err.number<>0 Then
		err.clear
		    removemsg
    		MsgBox("bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
    		Unlock(lockdatei)
    		WScript.Quit
End If

'If fs.FileExists(Ausgabename&".slw") Then
'	Wscript.Sleep 1500
'	If fs.FileExists(Ausgabename&".slw") Then
'		MsgBox("bitfarm-Archiv: Fehler: Server leert nicht den bergabepfad. Kann nicht archivieren.")
'		Unlock(lockdatei)
'		WScript.Quit
'		
'	End If
'End If
'If fs.FileExists(Ausgabename&".ftx") Then
'	Wscript.Sleep 1500
'	If fs.FileExists(Ausgabename&".ftx") Then
'		MsgBox("bitfarm-Archiv: Fehler: Server leert nicht den bergabepfad. Kann nicht archivieren.")
'		Unlock(lockdatei)
'		WScript.Quit
'		
'	End If
'End If

err.clear
If fs.FileExists(temppath&"\slx"&templatename&".slx") Then
fs.CopyFile temppath&"\slx"&templatename&".slx", Ausgabename&".slw", True
If err.number<>0 Then
		err.clear
		    removemsg
    		MsgBox("bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
    		Unlock(lockdatei)
    		WScript.Quit
End If
End If
'If fs.FileExists(template&".slw") Then
'fs.deletefile template&".slw", True
'If err.number<>0 Then
'		err.clear
'    		MsgBox("bitfarm-Archiv: Fehler bei Datenbergabe an den Server. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
'    		WScript.Quit
'    		
'End If
'End If
If fs.FileExists(temppath&"\vtx"&templatename&".vtx") Then
fs.CopyFile temppath&"\vtx"&templatename&".vtx", Ausgabename&".ftx", True
If err.number<>0 Then
		err.clear
		    removemsg
    		MsgBox("bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
    		Unlock(lockdatei)
    		WScript.Quit
End If
End If


If fs.GetExtensionName(datei)<>"" Then
	extension = "." & fs.GetExtensionName(datei)
End If


If (LCase(Right(datei,4))="html") Then
		extension=".htm"
End If

fs.CopyFile Datei, Ausgabename&extension, True
  	If err.number<>0 Then
    		err.clear
    		removemsg
    		MsgBox("bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
    		Unlock(lockdatei)
    		WScript.Quit
  	End If

't=0
'Do While t<120
'If fs.FileExists(Ausgabename&extension) Then
'	WScript.sleep 100
'	t=t+1
'Else
'	t=200
'End If
'loop
'If t<>200 Then
'	If fs.FileExists(Ausgabename&extension) Then
'	fs.DeleteFile Ausgabename&extension, True
'	If err.number<>0 Then
'    		MsgBox("bitfarm-Archiv: Schwerer Fehler - konnte nicht archivieren. Informieren Sie den Administrator.")
'    		err.clear
'    		Unlock(lockdatei)
'    		WScript.Quit
'  	End If
'	End If
'	If fs.FileExists(Ausgabename&".job") Then
'	fs.DeleteFile Ausgabename&".job", True
'	If err.number<>0 Then
'    		MsgBox("bitfarm-Archiv: Schwerer Fehler - konnte nicht archivieren. Informieren Sie den Administrator.")
'    		err.clear
'    		Unlock(lockdatei)
'    		WScript.Quit
'  	End If
'  	End If
'	If fs.FileExists(Ausgabename&".slw") Then
'	fs.DeleteFile Ausgabename&".slw", True
'	If err.number<>0 Then
'    		MsgBox("bitfarm-Archiv: Schwerer Fehler - konnte nicht archivieren. Informieren Sie den Administrator.")
'    		err.clear
'    		Unlock(lockdatei)
'    		WScript.Quit
'  	End If
'	End If
'	If fs.FileExists(Ausgabename&".ftx") Then
'	fs.DeleteFile Ausgabename&".ftx", True
'	If err.number<>0 Then
'    		MsgBox("bitfarm-Archiv: Schwerer Fehler - konnte nicht archivieren. Informieren Sie den Administrator.")
'    		err.clear
'    		Unlock(lockdatei)
'    		WScript.Quit
'  	End If
'	End If
'	frage = "Fehler: Der Archivserver reagiert nicht - es wurden ggf. nicht alle Dateien archiviert. Versuchen Sie es in einigen Minuten erneut. Sollte dieser Fehler wiederholt vorkommen, informieren Sie den Netzwerkadministrator."
'	ueberschrift = "bitfarm-Archiv Dateiimport"
'	antwort = objWSHShell.Popup(frage,, ueberschrift, vbSystemModal + vbCritical)
'	'MsgBox("bitfarm-Archiv: Fehler: Der Archivserver reagiert nicht - es wurden ggf. nicht alle Dateien archiviert. Sollte dies hufiger Vorkommen informieren Sie den Netzwerkadministrator.")
'	Unlock(lockdatei)
'	WScript.Quit
'End If
'WScript.Sleep 50
sendtoserver=true
If deletesourcefiles=true Then
	err.clear
	On Error Resume Next
	fs.DeleteFile datei, True
	If err.number<>0 Then
		err.clear
		On Error Resume Next
	End If
End If



End Function



'******************************************  Funktionen  *************************************

'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function writeslwdatei(Datei)
On Error Resume Next



err.clear
If fs.FileExists(temppath&"\slx"&templatename&".slx") Then
	fs.deletefile temppath&"\slx"&templatename&".slx", True
	If err.number Then
	err.clear
	removemsg
	MsgBox("bitfarm-Archiv: Fehler beim Dateiimport: Kann Dateinamen nicht als Schlagwort speichern. Kann so nicht archivieren. Bitte informieren Sie den Administrator.")
	Unlock(lockdatei)
	WScript.Quit	
	End If
End If 


'pos1=Len(datei)
'gefunden=false
'Do While (pos1>0) and (gefunden=false)
'	pos1=pos1-1
'	If Mid(datei,pos1,1)="\" Then 
'		gefunden = true
'	End If
'loop
'pos2=Len(datei)
'gefunden=false
'Do While (pos2>0) and (gefunden=false)
'	pos2=pos2-1
'	If Mid(datei,pos2,1)="." Then 
'		gefunden = true
'	End If
'loop
'If gefunden=false Then
'	MsgBox("bitfarm-Archiv: Fehler: Falsches Dateiformat.")
'	Unlock(lockdatei)
'	WScript.Quit
'End If
'namestring=""
'namestring=Mid(datei,pos1+1,(Len(datei)-pos1)-(Len(datei)-pos2+1))

namestring = fs.GetBaseName(datei)



err.clear
Set zielslwfile = fs.OpenTextFile(temppath&"\slx"&templatename&".slx",8,true)
zielslwfile.writeline("Dateiname="&namestring)
l=1
laenge=Len(namestring)
mystring1=""
Do While l<laenge
mystring2=getword(namestring,l)
If mystring2<>mystring1 Then
	zielslwfile.writeline(mystring2)
	mystring1=mystring2
End If
l=l+1
loop

If fs.FileExists(temppath&"\slw"&templatename&".slw") Then
Set quellslwfile = fs.OpenTextFile(temppath&"\slw"&templatename&".slw",1)
Do While quellslwfile.AtEndOfStream <> True
	zielslwfile.writeline(quellslwfile.readline)
loop
Set quellslwfile = nothing
End If

zielslwfile.close
Set zielslwfile=nothing
If err.number Then
	err.clear
	removemsg
	MsgBox("bitfarm-Archiv: Fehler beim Dateiimport: Kann Dateinamen nicht als Schlagwort speichern. Kann so nicht archivieren. Bitte informieren Sie den Administrator.")
	Unlock(lockdatei)
	WScript.Quit	
End If



End Function

'***************************************************************************************
'***************************************************************************************



Function readjob(tempname)
On Error Resume Next
readjob=true
err.clear




If not fs.FileExists(tempname) Then
	err.clear
	
	readjob=false
	err.clear
End If
		
If readjob=true Then	
Set jobfile = fs.OpenTextFile(tempname,1)
If err.number Then
	err.clear
		
	readjob=false
	
End If 
End If


If readjob = true Then
	
Do While jobfile.AtEndOfStream <> True
kette=jobfile.readline
If Left(kette,1)<>";" Then
	
	
	If InStr(1,kette,"Profil=",1)<>0 Then
		wert=GetString(kette,InStr(1,kette,"Profil=",1)+7)
		If (Len(wert)>0) and (wert<>" ") and (wert<>"	") Then
			Profil = wert
		End If
	End If
	
	If InStr(1,kette,"Typ",1)<>0 Then
		wert=GetString(kette,InStr(1,kette,"Typ",1)+4)
		typ = wert
	End If
	
		
End If


loop
jobfile.close
Set jobfile = nothing

End If


End Function

Function writejob(tempname)
On Error Resume Next
writejob=true
err.clear




If not fs.FileExists(tempname&".job") Then
	err.clear
	errortxt=tempname&".job Datei nicht vorhanden oder nicht lesbar."
	objWshShell.LogEvent 1, errortxt
	writejob=false
	err.clear
End If
		
If writejob=true Then	
Set quelljobfile = fs.OpenTextFile(tempname&".job",1)
If err.number Then
	err.clear
	errortxt="Kann Jobdatei nicht zum schreiben ffnen."
	objWshShell.LogEvent 1, errortxt
	writejob=false
	
End If 
End If

If writejob=true Then
If fs.FileExists(tempname&".tmp") Then
	fs.DeleteFile(tempname& ".tmp")
	If err.number Then
		err.clear
		errortxt="Zwischendatei fr Jobdatei existierte noch, kann diese aber nicht lschen."
		objWshShell.LogEvent 1, errortxt
		writejob=false
		quelljobfile.close
		Set quelljobfile=nothing
	End If 
	
End If	
End If

If writejob=true Then
Set zieljobfile = fs.OpenTextFile(tempname&".tmp",8,true)
If err.number Then
	err.clear
	errortxt="Kann Jobdatei nicht zum schreiben ffnen."
	objWshShell.LogEvent 1, errortxt
	writejob=false
	quelljobfile.close
	Set quelljobfile=nothing
End If 
End If



If writejob = true Then

stopflag=false
ersatzstring=""	
Do While quelljobfile.AtEndOfStream <> True
kette=quelljobfile.readline




ersatzstring=""

If (myname<>"") and (InStr(1,kette,"Titel=",1)<>0) Then
	ersatzstring="Titel="&myname
End If



If (Username<>"") and (InStr(1,kette,"Benutzer=",1)<>0) Then
	ersatzstring="Benutzer="&Username
End If	

If (dokDate<>"") and (InStr(1,kette,"Datum=",1)<>0) Then
	ersatzstring="Datum="&DokDate
End If

If (Typ<>"") and (InStr(1,kette,"OCR_Typ=",1)<>0) Then
	ersatzstring="OCR_Typ="&Typ
End If



'If Left(kette,3)="Zus" Then
'	For x=1 to Zusatzfelder
'		
'		If (Zusatzfeld(x)<>"") AND (InStr(1,kette,"ZusWert"&x&"=",1)<>0) Then
'			ersatzstring="ZusWert"&x&"="&Zusatzfeld(x)
'		End If
'	Next
'End If

If ersatzstring<>"" Then
	zieljobfile.writeline(ersatzstring)
Else
	zieljobfile.writeline(kette)
End If

loop
quelljobfile.close
Set quelljobfile = nothing
zieljobfile.close
Set zieljobfile=nothing
wscript.sleep 50

err.clear
fs.DeleteFile(tempname& ".job")
If err.number Then
	err.clear
	errortxt="Fehler beim lschen der alten jobdatei."
	objWshShell.LogEvent 1, errortxt
	writejob=false
End If 


'wscript.sleep 200

If writejob=true Then
	
fs.CopyFile tempname&".tmp", tempname&".job", True
If err.number Then
	err.clear
	errortxt="Fehler beim umkopieren Jobdatei."
	objWshShell.LogEvent 1, errortxt
	writejob=false
End If 
End If

wscript.sleep 50
If writejob=true Then
fs.DeleteFile(tempname& ".tmp")
If err.number Then
	err.clear
	errortxt="Fehler beim lschen der zwischen-jobdatei."
	objWshShell.LogEvent 1, errortxt
	writejob=false
End If 
End If
wscript.sleep 50

End If




End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************
'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function readconfig(profil)
On Error Resume Next
readconfig=true
err.clear

If not fs.FileExists(programm&profil&".con") Then
	err.clear
	errortxt=profil&".con Datei nicht im Scriptpfad vorhanden oder nicht lesbar."
	objWshShell.LogEvent 1, errortxt
	readconfig=false
	err.clear
End If
		
If readconfig=true Then	
Set confile = fs.OpenTextFile(programm&profil&".con",1)
If err.number Then
	err.clear
	errortxt="Profilfdatei nicht im Scriptpfad vorhanden oder nicht lesbar."
	objWshShell.LogEvent 1, errortxt
	err.clear
	readconfig=false
	
End If 
End If

If readconfig=true Then	
kette=confile.readline
Scriptsflag=InStr(1,kette,"[Scripts]")
Do While Scriptsflag = 0
kette=confile.readline
Scriptsflag=InStr(1,kette,"[Scripts]")
If confile.AtEndOfStream = True Then
	confile.close
	Set confile=nothing
	scriptsflag=1
	errortxt="Fehler beim Lesen der CON-Datei - falsche Formatierung."
	objWshShell.LogEvent 1, errortxt
	readconfig = false
    	
End If
loop

End If


If readconfig = true Then
	
Do While confile.AtEndOfStream <> True
kette=confile.readline
If Left(kette,1)<>";" Then
	
	
	
		
		
	If InStr(1,kette,"uncclientspooler",1)<>0 Then
		wert=GetString(kette,InStr(1,kette,"uncclientspooler",1)+16)
		uncclientspooler = wert
	End If
	
		
End If

loop
confile.close
Set confile = nothing

End If


End Function




'***************************************************************************************
'***************************************************************************************
'***************************************************************************************
Function setdokdate()
On Error Resume Next
Jahr = DatePart("yyyy",Date)
Monat = DatePart("m",Date)
Tag = DatePart("d",Date)
Stunde = DatePart("h",Time)
Minuten = DatePart("n",Time)
Sekunde = DatePart("s", Time)
If Len(Monat)=1 Then 
	monat="0"&monat
End If
If Len(tag)=1 Then 
	tag="0"&tag
End If
If Len(stunde)=1 Then 
	stunde="0"&stunde
End If
If Len(minuten)=1 Then 
	minuten="0"&minuten
End If
If Len(sekunde)=1 Then 
	sekunde="0"&sekunde
End If
setdokdate = Jahr&"-" & Monat & "-" & Tag & " " & Stunde & ":" & Minuten & ":" & Sekunde
End Function

'***************************************************************************************
'***************************************************************************************
'***************************************************************************************


Function inilesen()
On Error Resume Next

err.clear
Set inifile = fs.OpenTextFile(programm&"scripts.ini",1)
If err.number Then
	objWshShell.LogEvent 1, "scripts.ini nicht im Scriptpfad vorhanden oder nicht lesbar."
	err.clear
	Unlock(lockdatei)
	WScript.Quit
End If 
	
kette=inifile.readline
Scriptsflag=InStr(1,kette,"[Scripts]")
Do While Scriptsflag = 0
kette=inifile.readline
Scriptsflag=InStr(1,kette,"[Scripts]")
If inifile.AtEndOfStream = True Then
	inifile.close
	objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - falsche Formatierung."
	Unlock(lockdatei)
    	WScript.Quit
End If
loop


Do While inifile.AtEndOfStream <> True
kette=inifile.readline
If Left(kette,1)<>";" Then
	
		
	If InStr(1,kette,"Profil",1)<>0 Then
		wert=GetString(kette,InStr(1,kette,"Profil",1)+7)
		If Profil="" Then
			profil = wert
		End If
	End If
	
	If InStr(1,kette,"Typ",1)<>0 Then
		wert=GetString(kette,InStr(1,kette,"Typ",1)+4)
		typ = wert
	End If
	
	If InStr(1,kette,"MSWordinstalled",1)<>0 Then
		wert=GetString(kette,InStr(1,kette,"MSWordinstalled",1)+16)
		If LCase(wert)="true" Then
			acceptdoc = true
		End If	
	End If
	
	If InStr(1,kette,"MSExcelinstalled",1)<>0 Then
		wert=GetString(kette,InStr(1,kette,"MSExcelinstalled",1)+17)
		If LCase(wert)="true" Then
			acceptxls = true
		End If	
	End If
	
	If InStr(1,kette,"MSPowerPointinstalled",1)<>0 Then
		wert=GetString(kette,InStr(1,kette,"MSPowerPointinstalled",1)+22)
		If LCase(wert)="true" Then
			acceptppt = true
		End If	
	End If
	
	If InStr(1,kette,"DWGViewerinstalled",1)<>0 Then
		wert=GetString(kette,InStr(1,kette,"DWGViewerinstalled",1)+19)
		If LCase(wert)="true" Then
			acceptdwg = true
		End If	
	End If
	
	If InStr(1,kette,"deletesourcefiles",1)<>0 Then
		wert=GetString(kette,InStr(1,kette,"deletesourcefiles",1)+18)
		If LCase(wert)="true" Then
			deletesourcefiles = true
		End If	
	End If
	
	If InStr(1,kette,"acceptallfiletypes",1)<>0 Then
		wert=GetString(kette,InStr(1,kette,"acceptallfiletypes",1)+19)
		If LCase(wert)="true" Then
			acceptallfiletypes = true
		End If	
	End If
			
	
End If

loop
inifile.close
Set inifile = nothing
If programm="" Then
	objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - kein Programmpfad."
	WScript.Quit
End If


End Function



Private Function GetWord(kette,pos)
On Error Resume Next
zeichen=""
ergebnis=""
index1=pos
'MsgBox(Len(kette)&":"&pos)
Do While (zeichen<>" ") and (zeichen<>"	") and (index1>1)
	index1=index1-1
	zeichen=Mid(kette,index1,1)
	
loop
'MsgBox(index1)
zeichen=""
index2=0
maxindex2=Len(kette)-index1+2
Do While (zeichen<>" ") and (zeichen<>Vbcrlf) and (zeichen<>"	") and (index2<maxindex2)
        ergebnis=ergebnis+zeichen
	zeichen=Mid(kette,index1+index2,1)
	index2=index2+1
	If ((zeichen=" ") or (zeichen="	") or (zeichen="=")) and (ergebnis="") Then
		zeichen=""
	End If
loop
'MsgBox(index)
Trim(ergebnis)
GetWord=ergebnis
End Function

Function Unlock(lockfileandpath)
On Error Resume Next
err.clear
If lockfileandpath<>"" Then
If fs.fileexists(lockfileandpath) Then
 	fs.DeleteFile lockfileandpath
	If err.number<>0 Then
    		objWshShell.LogEvent 1, "archivierung(F1): Fehler: kann lockdatei nicht lschen:"&lockfileandpath
    		WScript.Quit
  	End If
End If
End If
End Function

Function Zufallszahl(von, bis)
On Error Resume Next
anzahl = bis-von+1
randomize
Zufallszahl = Fix(rnd*(anzahl))+von
end Function


Private Function StrConvert(string)
On Error Resume Next
  wert1=0
  l = Len(string)
  
  For x = 1 to l
    wert1=wert1+((Asc(Mid(String,x,1))-48)*(10^(l-x)))
  Next
  StrConvert=wert1
End Function


Private Function GetString(kette,pos)
On Error Resume Next
zeichen=""
ergebnis=""
index=0
Do While (zeichen<>" ") and (zeichen<>Vbcrlf) and (zeichen<>"	") and (index<80)
        ergebnis=ergebnis+zeichen
	zeichen=Mid(kette,pos+index,1)
	index=index+1
	If ((zeichen=" ") or (zeichen="	") or (zeichen="=")) and (ergebnis="") Then
		zeichen=""
	End If
loop
Trim(ergebnis)
GetString=ergebnis
End Function


Function RegRead(tempkey)
	On Error Resume Next
	privkey = tempkey

	RegRead = objWSHShell.RegRead(privkey)
	if not err.number=0 Then
	MsgBox("Fehler: Registrierungsschlssel nicht gesetzt.")
	RegRead=""
	err.clear
	WScript.Quit
	end if
end Function


Function showmsg()
On Error Resume Next
showmsg=True
err.clear
On Error Resume Next
Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
If err.number<>0 Then
	err.clear
	On Error Resume Next
	showmsg=False
Else
	Set objWMIService = Nothing
End If
If showmsg=True Then
Set oExec = objWSHShell.exec(programm&"bfamessage.exe")
If err.number<>0 Then
	err.clear
	On Error Resume Next
	showmsg=False
Else
	Set oexec=Nothing
End If
End If
End Function



Function removemsg()
err.clear
On Error Resume Next
Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
If err.number=0 Then
strQuery = "Select * from Win32_Process where Name='bfamessage.exe'"
Set colItems = objWMIService.ExecQuery(strQuery,,48)
For Each objItem in colItems
	 objItem.Terminate()
Next
wscript.sleep 100
Set colItems = NOTHING
Set objWMIService = Nothing
End If
err.clear
On Error Resume Next
End Function



'*******************************************************************************************
'*******************************************************************************************
'********************************          Ende             ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
