'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'***************  druckimport.vbs   GPL  ***************************************************
'*******************************************************************************************
'***************  Version 3.6.2.0        ***************************************************
'*******************************************************************************************
'***************  Nimmt Postscript-Dateien aus Redmon entgegen               ***************
'***************  und bergibt diese zur Archivierung an den                 ***************
'***************  Server. Dabei kann der Benutzer das Archiv auswhlen.      ***************
'***************                                                             ***************
'***************                                                             ***************
'***************  Syntax: wscript <server-programmpfad>druckimport.vbs       ***************
'***************  <Datei(en)> <Profil> {Drucker}              	             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************

scriptdebug = False
logging = False 

'MsgBox "Druckimport.vbs ist gestartet"
'*******************************************************************************************
'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

On Error Resume Next

Dim objWSHShell, fso, FileIn, FileOut 
Dim Datei, Text, Txt, i, arrSort, arrTest(), oArgs, Druckername
Dim lngReturnCode
'Dim net

'*******************************************************************************************
'**************************  eventlog auf 'Ereignisse berschreiben setzen' ****************
'

strComputer = "."
Set objWMIService = GetObject("winmgmts:" _
& "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")

Set objInstalledLogFiles = objWMIService.ExecQuery _
("Select * from Win32_NTEventLogFile Where LogFilename = 'Application'")

For Each objLogfile In objInstalledLogFiles
    
    If objLogfile.OverWriteOutdated <> 0 Then
        objLogfile.OverWriteOutdated = 0 
        objLogFile.Put_
    End If
    If Err.Number <> 0 Then
        objWSHShell.LogEvent 1, "Achtung ! Im Eventlog des Clients ist nicht die Option 'Eintrge bei Bedarf berschreiben' gesetzt. Logging und Scriptdebug werden daher ausgeschaltet." 
        scriptdebug = False
        logging = False
        Err.Clear
        On Error Resume Next
    End If
    
Next

Set objLogfile = Nothing
Set objInstalledLogFiles = Nothing
Set objWMIService = Nothing



ReDim ext(60)

lngReturnCode = 0

Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set fs      = WScript.CreateObject("Scripting.FileSystemObject") 
Set oArgs    = WScript.Arguments 
'Set net = WScript.CreateObject("WScript.Network") 

clientprogramm=""
uncclientspooler="" 
Profil=""
Typ=""
Filtermakro=""
Ausgabename=""
Druckername=""

For i=0 To 59
    ext(i)="...."
Next

extcounter=0

acceptdoc=False
acceptxls=False
acceptdwg=False



If scriptdebug = True Then
    For i = 0 To oArgs.Count -1
        arg = arg & oArgs.Item(i) & vbCrLf
    Next 
    objWSHShell.LogEvent 4, "druckimport.vbs gestartet (1) - " & Now() & vbCrLf & arg
End If





Redmon = objWSHShell.ExpandEnvironmentStrings("%REDMON_USER%")    
If Err.number<>0 Then
    MsgBox("bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehler: Kann Benutzername nicht auswerten.")
    objWSHShell.LogEvent 1, "bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehler: Kann Benutzername nicht auswerten."
    Err.clear
    WScript.Quit
End If 

If (Len(Redmon)<1) Or (Redmon="%REDMON_USER%") Or (Redmon="") Then
    Redmon="unbekannt"
End If

'*******************************************************************************************
'**************************  Startparameter initialisieren  ********************************
Err.clear
fullpath = WScript.ScriptFullName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWSHShell.LogEvent 1, errortxt
    WScript.Quit
End If 
scriptname = WScript.ScriptName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWSHShell.LogEvent 1, errortxt
    WScript.Quit
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWSHShell.LogEvent 1, errortxt
    WScript.Quit
End If 
If Len(programm)=0 Then
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWSHShell.LogEvent 1, errortxt
    WScript.Quit
End If




inilesen


ext(0)=".tif"
ext(1)=".ps"
ext(2)=".pdf"
ext(3)=".bmp"
ext(4)=".jpg"
ext(5)=".gif"
extcounter=6

If acceptdoc=True Then
    ext(extcounter)=".doc"
    ext(extcounter+1)=".rtf"
    ext(extcounter+2)=".htm"
    ext(extcounter+3)=".txt"
    extcounter=extcounter+4
End If

If acceptxls=True Then
    ext(extcounter)=".xls"
    ext(extcounter+1)=".dbf"
    ext(extcounter+2)=".tab"
    extcounter=extcounter+3
End If

If acceptppt=True Then
    ext(extcounter)=".ppt"
    ext(extcounter+1)=".pps"
    extcounter=extcounter+2
End If

If acceptdwg=True Then
    ext(extcounter)=".dwg"
    ext(extcounter+1)=".dxf"
    extcounter=extcounter+2
    
End If


temppath = objWSHShell.ExpandEnvironmentStrings("%temp%")    
If Err.number<>0 Then
    MsgBox("bitfarm-Archiv: Fehler: Kann TEMP-Variable nicht auswerten.")
    objWshShell.LogEvent 1, "bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehlende Parameter. Benutzung: clientspooler.vbs <pfad zur ps-Datei> <Name des Serverdruckers> <Typ: OMP|OCR|TXT> <Tabelle> <Profil>"
    Err.clear
    WScript.Quit
End If 

appdatapath = objWSHShell.ExpandEnvironmentStrings("%appdata%")    
If Err.number<>0 Then
    MsgBox("bitfarm-Archiv: Fehler: Kann TEMP-Variable nicht auswerten.")
    objWshShell.LogEvent 1, "bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehlende Parameter. Benutzung: clientspooler.vbs <pfad zur ps-Datei> <Name des Serverdruckers> <Typ: OMP|OCR|TXT> <Tabelle> <Profil>"
    Err.clear
    WScript.Quit
End If 

If oArgs.Count = 1 Then
    
    
    If fs.fileexists(appdatapath&"\bitfarm-archiv\mylogin.ini") Then
        Set inifile = fs.OpenTextfile(appdatapath&"\bitfarm-archiv\mylogin.ini")
        Do While Not inifile.AtEndOfStream
            strinput = LCase(inifile.readline)
            If InStr(1,strinput,"Profil",1)<>0 Then
                wert=GetString(strinput,InStr(1,strinput,"Profil",1)+7)
                profil = wert
                Exit Do
            End If
            
        Loop
        inifile.close
        
    End If
    If profil ="" Then
        
        MsgBox("bitfarm-Archiv 1: Achtung, es konnte nicht archiviert werden! mylogin.ini konnte nicht ausgelesen werden, kein Profil. Benutzung: clientspooler.vbs <pfad zur ps-Datei> <Name des Serverdruckers> <Typ: OMP|OCR|TXT> <Tabelle> <Profil>")
        objWshShell.LogEvent 1, "bitfarm-Archiv (1): Achtung, es konnte nicht archiviert werden!mylogin.ini konnte nicht ausgelesen werden, kein Profil. Benutzung: clientspooler.vbs <pfad zur ps-Datei> <Name des Serverdruckers> <Typ: OMP|OCR|TXT> <Tabelle> <Profil>"
        Err.clear
        WScript.Quit
    End If 
    
    
    Datei = oArgs.item(0) 
    If Err.number<>0 Then
        
        MsgBox("bitfarm-Archiv 2: Achtung, es konnte nicht archiviert werden! Fehlende Parameter. Benutzung: clientspooler.vbs <pfad zur ps-Datei> <Name des Serverdruckers> <Typ: OMP|OCR|TXT> <Tabelle> <Profil>")
        objWshShell.LogEvent 1, "bitfarm-Archiv (2): Achtung, es konnte nicht archiviert werden! Fehlende Parameter. Benutzung: clientspooler.vbs <pfad zur ps-Datei> <Name des Serverdruckers> <Typ: OMP|OCR|TXT> <Tabelle> <Profil>"
        Err.clear
        WScript.Quit
    End If 
    
ElseIf oArgs.Count = 2 Then
    
    
    profil = oArgs.item(0) 
    If Err.number<>0 Then
        
        MsgBox("bitfarm-Archiv 3: Achtung, es konnte nicht archiviert werden! Fehlende Parameter. Benutzung: clientspooler.vbs <pfad zur ps-Datei> <Name des Serverdruckers> <Typ: OMP|OCR|TXT> <Tabelle> <Profil>")
        objWshShell.LogEvent 1, "bitfarm-Archiv (3): Achtung, es konnte nicht archiviert werden! Fehlende Parameter. Benutzung: clientspooler.vbs <pfad zur ps-Datei> <Name des Serverdruckers> <Typ: OMP|OCR|TXT> <Tabelle> <Profil>"
        Err.clear
        WScript.Quit
    End If 
    
    
    
    Datei = oArgs.item(1) 
    If Err.number<>0 Then
        
        MsgBox("bitfarm-Archiv 4: Achtung, es konnte nicht archiviert werden! Fehlende Parameter. Benutzung: clientspooler.vbs <pfad zur ps-Datei> <Name des Serverdruckers> <Typ: OMP|OCR|TXT> <Tabelle> <Profil>")
        objWshShell.LogEvent 1, "bitfarm-Archiv (4): Achtung, es konnte nicht archiviert werden! Fehlende Parameter. Benutzung: clientspooler.vbs <pfad zur ps-Datei> <Name des Serverdruckers> <Typ: OMP|OCR|TXT> <Tabelle> <Profil>"
        Err.clear
        WScript.Quit
    End If 
    
ElseIf oArgs.Count = 3 Then
    
    profil = oArgs.item(0) 
    If Err.number<>0 Then
        
        MsgBox("bitfarm-Archiv 3: Achtung, es konnte nicht archiviert werden! Fehlende Parameter. Benutzung: clientspooler.vbs <pfad zur ps-Datei> <Name des Serverdruckers> <Typ: OMP|OCR|TXT> <Tabelle> <Profil>")
        objWshShell.LogEvent 1, "bitfarm-Archiv (3): Achtung, es konnte nicht archiviert werden! Fehlende Parameter. Benutzung: clientspooler.vbs <pfad zur ps-Datei> <Name des Serverdruckers> <Typ: OMP|OCR|TXT> <Tabelle> <Profil>"
        Err.clear
        WScript.Quit
    End If 
    
    
    
    
    Druckername = oArgs.Item(1)
    If Err.number<>0 Then
        
        MsgBox("bitfarm-Archiv 5: Fehler beim Auslesen des Druckernamens")
        objWshShell.LogEvent 1, "bitfarm-Archiv 5: Fehler beim Auslesen des Druckernamens"
        Err.clear
        
    End If 
    
    
    Datei = oArgs.item(2) 
    If Err.number<>0 Then
        
        MsgBox("bitfarm-Archiv 4: Achtung, es konnte nicht archiviert werden! Fehlende Parameter. Benutzung: clientspooler.vbs <pfad zur ps-Datei> <Name des Serverdruckers> <Typ: OMP|OCR|TXT> <Tabelle> <Profil>")
        objWshShell.LogEvent 1, "bitfarm-Archiv (4): Achtung, es konnte nicht archiviert werden! Fehlende Parameter. Benutzung: clientspooler.vbs <pfad zur ps-Datei> <Name des Serverdruckers> <Typ: OMP|OCR|TXT> <Tabelle> <Profil>"
        Err.clear
        WScript.Quit
    End If 
    
    
End If



If Err.number<>0 Then
    Err.clear
    'On Error Resume next
End If

'host = net.ComputerName


username=Redmon
If Err.number<>0 Then
    MsgBox("bitfarm-Archiv: Fehler: Kann USERNAME-Variable nicht auswerten.")
    objWshShell.LogEvent 1, "bitfarm-Archiv: Fehler: Kann USERNAME-Variable nicht auswerten."
    Err.clear
    WScript.Quit
End If 

If (Len(username)<1) Or (username="%username%") Or (username="") Then
    username="unbekannt"
End If

If scriptdebug = True Then
    objWSHShell.LogEvent 4, "Druckimport.vbs: bergebene Parameter " & vbCrLf & "Profil=" & Profil & vbCrLf & "Datei=" & Datei & vbCrLf & "username=" & username & vbCrLf & "temppath=" & temppath
End If


If logging = True Then
    
    jetzt = getlogtime
    
    logpath = temppath&"\druckimport_log\"
    
    If Not fs.FolderExists(logpath) Then
        Set test = fs.CreateFolder(logpath)
        Set test = Nothing
        WScript.sleep 200
        If Err.number<>0 Then
            objWshShell.LogEvent 1, "druckimport: kann log-verzeichnis nicht erstellen - Berechtigung?"
            Err.clear
            WScript.Quitt
        End If 
        
        If Not fs.FolderExists(logpath) Then
            objWshShell.LogEvent 1, "druckimport: kann log--verzeichnis nicht erstellen (2) - Berechtigung?"
            WScript.Quit
        End If
    End If
    logpath = temppath&"\druckimport_log\" & jetzt &"_"
    
    
    fs.CopyFile Datei, logpath&fs.GetFilename(datei) & ".org", True
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
    End If
    
    
End If

tempfile=temppath&"\temp.tif"
dokdate=""

'*******************************  Testen auf Kollission   ***************************************


Unlock(temppath&"\Lock")

If fs.fileexists(temppath&"\Lock") Then
    a=0
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    If Err.number<>0 Then
        Err.clear
        MsgBox("Fehler: kein Microsoft WMI installiert. Bitte nachinstallieren.")
        objWshShell.LogEvent 1, "Fehler: kein Microsoft WMI installiert. Bitte nachinstallieren."
        WScript.Quit
    End If
    strQuery = "Select * from Win32_Process where Name='wscript.exe'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    For Each objItem In colItems
        a=a+1
    Next
    Set colItems=Nothing
    Set objWMIService=Nothing
    If a>1 Then
        
        
        frage = "Es luft zur Zeit bereits eine Datenbertragung an den Archivserver. Bitte versuchen Sie es in einigen Minuten noch einmal. Sollte diese Meldung stets wiederkommen, informieren Sie den Netzwerkadministrator."
        ueberschrift = "bitfarm-Archiv Import"
        antwort = objWSHShell.Popup(frage,, ueberschrift, vbExclamation)
        objWshShell.LogEvent 2, frage
        WScript.Quit
        
        'abbruch=false
        'Do While abbruch=false
        'WScript.Sleep 1000
        'If not fs.fileexists(temppath&"\Lock") Then
        '	abbruch=true
        'End If
        'If abbruch=true Then
        '	zahl=Zufallszahl(1000,5000)
        '	WScript.Sleep zahl
        '	If fs.fileexists(temppath&"\Lock") Then
        '		abbruch=false
        '	End If
        'End If
        'loop
        
    Else
        fs.deletefile temppath&"\Lock", True
    End If
    
End If

lockdatei=temppath&"\Lock"
Set lockfile = fs.OpenTextFile(temppath&"\Lock",8,True)
If Err.number<>0 Then
    WScript.Quit
End If
lockfile.writeline("lock")
lockfile.close
Set lockfile=Nothing



'*******************************************************************************************
'**************************  Prfen, ob Server bereit  *************************************




'erfolg=readconfig(Profil)
'If erfolg=false Then
'	MsgBox("bitfarm-Archiv: Kann Konfigurationsdatei nicht lesen ("&Profil&")")
'	objWshShell.LogEvent 1, "bitfarm-Archiv: Kann Konfigurationsdatei nicht lesen ("&Profil&")"
'	Unlock(lockdatei)
'	WScript.Quit
'End If
'
'druckpfad = uncclientspooler 

zahl = Zufallszahl(100000,999999)
'Set dummy = fs.OpenTextFile(temppath&"\"&zahl&"dummy.txt",8,true)
'dummy.close
'Set dummy=nothing
'dummytest=druckpfad&zahl&"dummy.txt"
'fs.copyfile temppath&"\"&zahl&"dummy.txt", druckpfad&zahl&"dummy.txt"
'fs.deletefile temppath&"\"&zahl&"dummy.txt", True
'If err.number<>0 Then
'	err.clear
'	MsgBox("bitfarm-Archiv: Fehler beim Testen des Serverdienstes. Informieren Sie den Netzwerkadministrator.")
'	Unlock(lockdatei)
'	WScript.Quit
'	
'End If
'fs.deletefile temppath&"\"&zahl&"dummy.txt", True
'
'WScript.Sleep 800

'If fs.fileexists(druckpfad&zahl&"dummy.txt") Then
'	fs.deletefile druckpfad&zahl&"dummy.txt", true
'	frage = "Der Archivserver ist z.Z. nicht bereit fr den Empfang von Dateien. Bitte versuchen Sie es spter noch einmal. Sollte das Problem anhalten, informieren Sie den Netzwerkadministrator."
'	ueberschrift = "bitfarm-Archiv Import"
'	antwort = objWSHShell.Popup(frage,, ueberschrift, vbExclamation)
'	abgebrochen=false
'	Unlock(lockdatei)
'	WScript.Quit
'	
'	
'End If
'


'*******************************************************************************************
'**************************  Alle Jobdateien lschen, die evtl. noch vorhanden sind  *******

i=0
Set folder = fs.GetFolder(temppath)
For Each file In folder.files
    
    If (Right(file,3) = "job") Or (Right(file,3) = "JOB") Then
        Err.clear
        fs.DeleteFile file, True
        If Err.number<>0 Then
            MsgBox("bitfarm-Archiv: Kein Schreibzugriff auf das TEMP-Verzeichnis. Bitte informieren Sie Ihren Administrator.")
            objWshShell.LogEvent 1,"bitfarm-Archiv: Kein Schreibzugriff auf das TEMP-Verzeichnis. Bitte informieren Sie Ihren Administrator."
            Err.clear
            WScript.Quit
        End If
    End If
Next


'**************************************************************************************************
'******************************************   Zielabfrage   ***************************************
'**************************************************************************************************
'MsgBox(programm&"QimpV3.exe "&programm&profil&".con "&tempfile)
Err.Clear

' neuen Ordner in temp erzeugen (random name)
' ps als "Dokument.ps" reinkopieren und Verzeichnisimport mit Viewer starten.

tempfolder = temppath & "\bfa_print_" & Zufallszahl(1000000, 9999999)
While fs.FolderExists(tempfolder)
	tempfolder = temppath & "\bfa_print_" & Zufallszahl(1000000, 9999999)
Wend

fs.CreateFolder(tempfolder)

fs.MoveFile Datei, tempfolder & "\" & "Dokument.ps"



If Err.number<>0 Then
    MsgBox("bitfarm-Archiv druckimport.vbs: Postscript konnte nicht umbenannt werden (Fehler " & Err.Number & ", " & Err.Description & "), bitte informieren Sie Ihren Administrator.")
    objWshShell.LogEvent 1,"bitfarm-Archiv druckimport.vbs: Postscript konnte nicht umbenannt werden."
    Err.Clear
    Unlock(lockdatei)
    WScript.Quit
End If
        


arg = Chr(34)& programm&"ViewerV3.exe" &Chr(34) & " -DD:" & Chr(34) & tempfolder & Chr(34)

If scriptdebug=True Then
	objWSHShell.LogEvent 1, "druckimport.vbs Starting ViewerV3.exe:" & vbCrLf & arg
End If
lngReturnCode = objWSHShell.Run(arg, 1, False)
Unlock(lockdatei)
WScript.Quit


If lngReturnCode <> 0 Then
    'MsgBox("bitfarm-Archiv: Allgemeiner Fehler bei Parameterbergabe.")
    
    'objWSHShell.LogEvent 1, "Druckimport.vbs: Allgemeiner Fehler bei der Parameterbergabe an ImporterV3:" &programm&profil&".con "
    
    Unlock(lockdatei)
    WScript.Quit
End If





'**************************************************************************************************
'*******************************    Jobdatei suchen   *********************************************
'**************************************************************************************************
template=""
Set folder = fs.GetFolder(temppath)
For Each file In folder.files
    
    If (Right(file,3) = "job") Or (Right(file,3) = "JOB") Then
        template=file
    End If
Next
Set folder = Nothing

If template<>"" Then
    Set tempobject=fs.getfile(template)
    templatename=tempobject.name
    Set tempobject=Nothing
    templatename=Left(templatename,Len(templatename)-4)
Else
    frage = "bitfarm-Archiv Druckimport: Der Importer konnte keine Job-Datei erstellen oder wurde abgebrochen"
    ueberschrift = "bitfarm-Archiv Druckimport"
    'antwort = objWSHShell.Popup(frage,, ueberschrift, vbSystemModal + vbExclamation)
    'MsgBox "bitfarm-Archiv Druckimport: Der Importer konnte keine Job-Datei erstellen oder wurde abgebrochen"
    objWshShell.LogEvent 1, "bitfarm-Archiv Druckimport: Der Importer konnte keine Job-Datei erstellen oder wurde abgebrochen"
    
    Unlock(lockdatei)
    WScript.quit
End If


'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************

Profil=""




erfolg=readjob(template)
If erfolg=False Then
    MsgBox("bitfarm-Archiv: Kann zum angegebenen Archiv kein Template finden ("&template&")")
    objWshShell.LogEvent 1, "bitfarm-Archiv: Kann zum angegebenen Archiv kein Template finden ("&template&")"
    Unlock(lockdatei)
    WScript.Quit
End If



erfolg=readconfig(Profil)
If erfolg=False Then
    MsgBox("bitfarm-Archiv: Kann Konfigurationsdatei nicht lesen ("&Profil&")")
    objWshShell.LogEvent 1, "bitfarm-Archiv: Kann Konfigurationsdatei nicht lesen ("&Profil&")"
    Unlock(lockdatei)
    WScript.Quit
End If

druckpfad = uncclientspooler 

If scriptdebug = True Then
    objWSHShell.LogEvent 4,"druckimport.vbs - readconfig und readjob erfolgreich" & vbCrLf & "profil=" & profil & vbCrLf & "druckpfad=" & druckpfad & vbCrLf & "template=" & template
End If


If druckpfad="" Then
    MsgBox("bitfarm-Archiv: Fehler: Konnte keinen bergabepfad zum Server bestimmen.")
    objWshShell.LogEvent 1, "bitfarm-Archiv: Fehler: Konnte keinen bergabepfad zum Server bestimmen."
    Unlock(lockdatei)
    WScript.Quit
End If


'If (Typ <> "TXT") AND (Typ <> "OCR") AND (Typ <> "OMP") Then
'	MsgBox("Falscher Texterkennungstyp. Bitte Script autoscan.vbs prfen.")
'	Unlock(lockdatei)
'	WScript.Quit
'End If




'*******************************************************************************************
'************************************ Parameter in Jobdatei  *******************************
dokdate=setdokdate()
erfolg = writejob(Left(template,Len(template)-4))
If erfolg=False Then
    MsgBox("bitfarm-Archiv: kann Parameter nicht in Jobdatei schreiben - kann nicht archivieren. Bitte informieren Sie den Administrator.")
    objWshShell.LogEvent 1, "bitfarm-Archiv: kann Parameter nicht in Jobdatei schreiben - kann nicht archivieren. Bitte informieren Sie den Administrator."
    WScript.Quit
End If




'*******************************************************************************************
'*******************************************************************************************
'*************************************************************************************
'**************************   Parameterbergabe und Hauptschleife ********************
'************************************************************************************* 

'MsgBox("bitfarm-Archiv: Die gewhlten Dateien / Ordner werden nun archiviert. Bitte warten Sie, bis die Besttigung angezeigt wird.")
Err.clear
i=0
dateianzahl=1
erfolg = True


showmsg
erfolg = sendtoserver(Datei)

If erfolg = True Then
    
    
    
    
    If dateianzahl > 0 Then
        frage = "bitfarm-Archiv: Das Dokument wurden an den Server bergeben."
        ueberschrift = "bitfarm-Archiv Druckimport"
        'antwort = objWSHShell.Popup(frage,, ueberschrift, vbSystemModal + vbExclamation)
        objWshShell.LogEvent 4, "druckimport.vbs: "&dateianzahl&" Dokument(e) wurden an den Server bergeben." & vbCrLf & datei & vbCrLf & Ausgabename
    Else
        i=0
        kette=""
        Do While ext(i)<>"...."
            kette=kette&" "&ext(i)
            i=i+1
        Loop
        frage = "Keine Dateien zum archivieren gefunden."&vbCrLf&"Untersttzte Dateitypen:"&vbCrLf&vbCrLf&kette
        ueberschrift = "bitfarm-Archiv Druckimport"
        antwort = objWSHShell.Popup(frage,, ueberschrift, vbSystemModal + vbExclamation)
        objWshShell.LogEvent 2, frage	
        
    End If
    
Else
    frage ="bitfarm-Archiv: Achtung !!!  Das Drucken ins Archiv war nicht erfolgreich !" & vbCrLf & "Es wurde kein Dokument bergeben. Bitte wenden Sie sich an die Administration"
    ueberschrift = "bitfarm-Archiv Druckimport"
    antwort = objWSHShell.Popup(frage,, ueberschrift, vbSystemModal + vbExclamation)
    
    objWshShell.LogEvent 1, "bitfarm-Archiv: Achtung !!!  Das Drucken ins Archiv war nicht erfolgreich !" & vbCrLf & "Es wurde kein Dokument bergeben. Bitte wenden Sie sich an die Administration"
End If


'**************************************************************************************************
'*************************************  aufrumen und Ende  ***************************************
'**************************************************************************************************


Set folder = fs.GetFolder(temppath)
For Each file In folder.files
    
    
    
    If (LCase(Right(file,3)) = "job") Or (LCase(Right(file,3)) = "slx") Or (LCase(Right(file,3)) = "slw") Or (LCase(Right(file,3)) = "vtx") Then
        Err.clear
        fs.deletefile file, True
        Err.clear
    End If
    
    
Next
Set folder = Nothing
WScript.Sleep 1500
removemsg
Unlock(lockdatei)

If scriptdebug = True Then
    objWSHShell.LogEvent 4,"druckimport.vbs - Programmausstieg"
End If


WScript.Quit


'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************

Function archfolder(datei)
    On Error Resume Next
    Set ordner=fs.getfolder(datei)
    For Each file In ordner.files
        archfile(file)
    Next
    For Each unterordner In ordner.subfolders
        archfolder(unterordner)
    Next
    Set ordner=Nothing
End Function

Function archfile(Datei)
    On Error Resume Next
    If fs.GetExtensionName(datei)<>"" Then
        extension = "." & fs.GetExtensionName(datei)
        extension = LCase(extension)
    End If
    
    
    u=0
    
    Do While u<=extcounter
        
        If extension=ext(u) Then
            sendtoserver(Datei)
            dateianzahl=dateianzahl+1
            u=10000
        End If
        u=u+1
    Loop
    
    
End Function


Function sendtoserver(datei)
    sendtoserver=True
    On Error Resume Next
    
    If Druckername = "" Then
        sendtoserver=True
        zahl = Zufallszahl(100000,999999)
        If quickimport=False Then
            Ausgabename=druckpfad&"file"&zahl
        Else
            Ausgabename=druckpfad&"fast"&zahl
        End If
        
        
        If fs.FileExists(Ausgabename&".job") Then
            zahl = Zufallszahl(100000,999999)
            If quickimport=False Then
                Ausgabename=druckpfad&"file"&zahl
            Else
                Ausgabename=druckpfad&"fast"&zahl
            End If
            If fs.FileExists(Ausgabename&".job") Then
                zahl = Zufallszahl(100000,999999)
                If quickimport=False Then
                    Ausgabename=druckpfad&"file"&zahl
                Else
                    Ausgabename=druckpfad&"fast"&zahl
                End If
                
                
                WScript.Sleep 1500
                If fs.FileExists(Ausgabename&".job") Then
                    removemsg
                    MsgBox("bitfarm-Archiv: Fehler: Serverdienst reagiert nicht.")
                    objWshShell.LogEvent 1, "bitfarm-Archiv: Druckimport.vbs:"&vbCrLf&"Server leert nicht den bergabepfad. Kann nicht archivieren."&vbCrLf&Ausgabename & ".job"
                    Unlock(lockdatei)
                    WScript.Quit
                End If
            End If
            
        End If
    Else    'es wurde ein optionaler Drucker mit angegeben: Der Dateiname wird wie beim Clientspooler generiert, dadurch wird ein paraller Druck ausgelst
        psname = fs.GetBaseName(Datei)
        
        
        If InStr(1,Druckername,"\") Then
            Druckername = Replace(Druckername,"\","~")
        End If
        If InStr(1,Druckername," ") Then
            Druckername = Replace(Druckername," ","#")
        End If
        
        Ausgabename =druckpfad& Username & "" & Druckername & "" & typ & "unverteilt" & Profil & "" & psname
        
        
        
    End If
    
    '###########################
    'sendtoserver=true
    '
    'zahl = Zufallszahl(100000,999999)
    'If quickimport=false Then
    'Ausgabename=druckpfad&"file"&zahl
    'Else
    'Ausgabename=druckpfad&"fast"&zahl
    'End If
    'If fs.FileExists(Ausgabename&".job") Then
    '	Wscript.Sleep 1500
    '	If fs.FileExists(Ausgabename&".job") Then
    '		removemsg
    '		MsgBox("bitfarm-Archiv: Fehler: Server leert nicht den bergabepfad. Kann nicht archivieren.")
    '		objWshShell.LogEvent 1, "bitfarm-Archiv: Officeimport.vbs:"&vbcrlf&"Server leert nicht den bergabepfad. Kann nicht archivieren."&vbcrlf&Ausgabename & ".job"
    '		Unlock(lockdatei)
    '		sendtoserver=false
    '	End If
    'End If
    '
    
    
    
    
    
    If scriptdebug = True Then
        objWSHShell.LogEvent 4, "druckimport.vbs - sendtoserver() Datei=" & datei & vbCrLf & "Ausgabe=" & Ausgabename
    End If
    
    
    Err.clear
    
    If logging = True Then
        fs.CopyFile template, logpath&fs.GetFilename(template), True
        
        '	jetzt2 = getlogtime
        '		Set mydebugfile = fs.OpenTextFile(temppath&"\druckimport_log\"& "druckimport.log",8,true)
        '		mydebugfile.Writeline (jetzt2& vbTab& host & vbTab & "Druckimport bergabe begonnen...")
        '		mydebugfile.close
        '		Set mydebugfile = Nothing
        
        
    End If
    
    
    
    fs.CopyFile template, Ausgabename&".job", True
    
    
    If Err.number<>0 Then
        
        objWshShell.LogEvent 1, "bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support." & vbCrLf & template & "->" & vbCrLf & Ausgabename&".job" & vbCrLf & Err.number & vbTab & Err.description
        removemsg
        MsgBox "bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.",vbOK,"bitfarm-Archiv Druckimport"
        Unlock(lockdatei)
        sendtoserver=False
        Err.clear
    Else
        
        If logging = True Then
            'fs.CopyFile template, logpath&fs.GetFilename(template), True
            '		jetzt2 = getlogtime
            '		Set mydebugfile = fs.OpenTextFile(temppath&"\druckimport_log\" & "druckimport.log",8,true)
            '		mydebugfile.Writeline (jetzt2& vbTab& host & vbTab & template & "  -->  " & Ausgabename & ".job")
            '		mydebugfile.close
            '		Set mydebugfile = Nothing
            
        End If
        
        
        
    End If
    
    'If fs.FileExists(Ausgabename&".slw") Then
    '	Wscript.Sleep 1500
    '	If fs.FileExists(Ausgabename&".slw") Then
    '		MsgBox("bitfarm-Archiv: Fehler: Server leert nicht den bergabepfad. Kann nicht archivieren.")
    '		Unlock(lockdatei)
    '		WScript.Quit
    '		
    '	End If
    'End If
    'If fs.FileExists(Ausgabename&".ftx") Then
    '	Wscript.Sleep 1500
    '	If fs.FileExists(Ausgabename&".ftx") Then
    '		MsgBox("bitfarm-Archiv: Fehler: Server leert nicht den bergabepfad. Kann nicht archivieren.")
    '		Unlock(lockdatei)
    '		WScript.Quit
    '		
    '	End If
    'End If
    
    Err.clear
    If fs.FileExists(temppath&"\slw"&templatename&".slw") Then
        If logging = True Then
            fs.CopyFile temppath&"\slw"&templatename&".slw", logpath&fs.GetFilename(temppath&"\slw"&templatename&".slw"), True
        End If
        
        fs.CopyFile temppath&"\slw"&templatename&".slw", Ausgabename&".slw", True
        
        
        If Err.number<>0 Then
            
            objWshShell.LogEvent 1, "bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support." & vbCrLf & Ausgabename&".slw"& vbCrLf & Err.number & vbTab & Err.description
            removemsg
            MsgBox "bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.",vbOK,"bitfarm-Archiv Druckimport"
            Unlock(lockdatei)
            sendtoserver=False
            Err.clear
        Else
            
            '	If logging = True Then
            '		'fs.CopyFile template, logpath&fs.GetFilename(template), True
            '		jetzt2 = getlogtime
            '		Set mydebugfile = fs.OpenTextFile(temppath&"\druckimport_log\" & "druckimport.log",8,true)
            '		mydebugfile.Writeline (jetzt2& vbTab& host & vbTab & temppath&"\slw"&templatename&".slw" & "  -->  " & Ausgabename&".slw")
            '		mydebugfile.close
            '		Set mydebugfile = Nothing
            '	
            '	End If
        End If
    End If
    'If fs.FileExists(template&".slw") Then
    'fs.deletefile template&".slw", True
    'If err.number<>0 Then
    '		err.clear
    '    		MsgBox("bitfarm-Archiv: Fehler bei Datenbergabe an den Server. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
    '    		WScript.Quit
    '    		
    'End If
    'End If
    If fs.FileExists(temppath&"\vtx"&templatename&".vtx") Then
        
        If logging = True Then
            fs.CopyFile temppath&"\vtx"&templatename&".vtx", logpath&fs.GetFilename(temppath&"\vtx"&templatename&".vtx"), True
        End If
        
        
        fs.CopyFile temppath&"\vtx"&templatename&".vtx", Ausgabename&".ftx", True
        If Err.number<>0 Then
            
            objWshShell.LogEvent 1, "bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support." & vbCrLf & Ausgabename&".ftx"& vbCrLf & Err.number & vbTab & Err.description
            removemsg
            MsgBox "bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.",vbOK,"bitfarm-Archiv Druckimport"
            Unlock(lockdatei)
            sendtoserver=False
            Err.clear
        Else
            
            '	If logging = True Then
            '		'fs.CopyFile template, logpath&fs.GetFilename(template), True
            '		jetzt2 = getlogtime
            '		Set mydebugfile = fs.OpenTextFile(temppath&"\druckimport_log\" & "druckimport.log",8,true)
            '		mydebugfile.Writeline (jetzt2& vbTab& host & vbTab & temppath&"\vtx"&templatename&".vtx" & "  -->  " & Ausgabename&".ftx")
            '		mydebugfile.close
            '		Set mydebugfile = Nothing
            '	
            '	End If
            
            
        End If
    End If
    
    
    extension=".ps"
    If logging = True Then
        
        fs.CopyFile Datei, logpath&fs.GetFilename(datei), True
    End If
    
    fs.CopyFile datei, Ausgabename&extension, True
    If Err.number<>0 Then
        
        objWshShell.LogEvent 1, "bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support." & vbCrLf & Ausgabename&extension& vbCrLf & Err.number & vbTab & Err.description
        removemsg
        MsgBox "bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.",vbOK,"bitfarm-Archiv Druckimport"
        Unlock(lockdatei)
        sendtoserver=False
        Err.clear
    Else
        
        '	If logging = True Then
        '		'fs.CopyFile template, logpath&fs.GetFilename(template), True
        '		jetzt2 = getlogtime
        '		Set mydebugfile = fs.OpenTextFile(temppath&"\druckimport_log\" & "druckimport.log",8,true)
        '		mydebugfile.Writeline (jetzt2& vbTab& host & vbTab & datei & "  -->  " & Ausgabename&extension)
        '		mydebugfile.Writeline (jetzt2 & vbTab & "bertragung abgeschlossen")
        '		mydebugfile.Writeline (jetzt2)
        '		mydebugfile.close
        '		Set mydebugfile = Nothing
        '	
        '	End If
        '  	
        
        
        
        
    End If
    
    'MsgBox(Datei&":"&Ausgabename&":"&extension)
    
    't=0
    'Do While t<120
    'If fs.FileExists(Ausgabename&extension) Then
    '	WScript.sleep 100
    '	t=t+1
    'Else
    '	t=200
    'End If
    'loop
    'If t<>200 Then
    '	If fs.FileExists(Ausgabename&extension) Then
    '	fs.DeleteFile Ausgabename&extension, True
    '	If err.number<>0 Then
    '    		MsgBox("bitfarm-Archiv: Schwerer Fehler - konnte nicht archivieren. Informieren Sie den Administrator.")
    '    		err.clear
    '    		Unlock(lockdatei)
    '    		WScript.Quit
    '  	End If
    '	End If
    '	If fs.FileExists(Ausgabename&".job") Then
    '	fs.DeleteFile Ausgabename&".job", True
    '	If err.number<>0 Then
    '    		MsgBox("bitfarm-Archiv: Schwerer Fehler - konnte nicht archivieren. Informieren Sie den Administrator.")
    '    		err.clear
    '    		Unlock(lockdatei)
    '    		WScript.Quit
    '  	End If
    '  	End If
    '	If fs.FileExists(Ausgabename&".slw") Then
    '	fs.DeleteFile Ausgabename&".slw", True
    '	If err.number<>0 Then
    '    		MsgBox("bitfarm-Archiv: Schwerer Fehler - konnte nicht archivieren. Informieren Sie den Administrator.")
    '    		err.clear
    '    		Unlock(lockdatei)
    '    		WScript.Quit
    '  	End If
    '	End If
    '	If fs.FileExists(Ausgabename&".ftx") Then
    '	fs.DeleteFile Ausgabename&".ftx", True
    '	If err.number<>0 Then
    '    		MsgBox("bitfarm-Archiv: Schwerer Fehler - konnte nicht archivieren. Informieren Sie den Administrator.")
    '    		err.clear
    '    		Unlock(lockdatei)
    '    		WScript.Quit
    '  	End If
    '	End If
    '	frage = "Fehler: Der Archivserver reagiert nicht - es wurden ggf. nicht alle Dateien archiviert. Versuchen Sie es in einigen Minuten erneut. Sollte dieser Fehler wiederholt vorkommen, informieren Sie den Netzwerkadministrator."
    '	ueberschrift = "bitfarm-Archiv Druckimport"
    '	antwort = objWSHShell.Popup(frage,, ueberschrift, vbSystemModal + vbCritical)
    '	'MsgBox("bitfarm-Archiv: Fehler: Der Archivserver reagiert nicht - es wurden ggf. nicht alle Dateien archiviert. Sollte dies hufiger Vorkommen informieren Sie den Netzwerkadministrator.")
    '	Unlock(lockdatei)
    '	WScript.Quit
    'End If
    'WScript.Sleep 50
    
    
End Function



'******************************************  Funktionen  *************************************

'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function writeslwdatei(Datei)
    On Error Resume Next
    Err.clear
    If fs.FileExists(temppath&"\slx"&templatename&".slx") Then
        fs.deletefile temppath&"\slx"&templatename&".slx", True
        If Err.number Then
            Err.clear
            removemsg
            MsgBox("bitfarm-Archiv: Fehler beim Dateiimport: Kann Dateinamen nicht als Schlagwort speichern. Kann so nicht archivieren. Bitte informieren Sie den Administrator.")
            objWshShell.LogEvent 1, "bitfarm-Archiv: Fehler beim Dateiimport: Kann Dateinamen nicht als Schlagwort speichern. Kann so nicht archivieren. Bitte informieren Sie den Administrator."
            Unlock(lockdatei)
            WScript.Quit	
        End If
    End If 
    
    
    pos1=Len(datei)
    gefunden=False
    Do While (pos1>0) And (gefunden=False)
        pos1=pos1-1
        If Mid(datei,pos1,1)="\" Then 
            gefunden = True
        End If
    Loop
    pos2=Len(datei)
    gefunden=False
    Do While (pos2>0) And (gefunden=False)
        pos2=pos2-1
        If Mid(datei,pos2,1)="." Then 
            gefunden = True
        End If
    Loop
    If gefunden=False Then
        removemsg
        MsgBox("bitfarm-Archiv: Fehler: Falsches Dateiformat.")
        objWshShell.LogEvent 1, "bitfarm-Archiv: Fehler: Falsches Dateiformat." & datei
        Unlock(lockdatei)
        WScript.Quit
    End If
    
    namestring=""
    namestring=Mid(datei,pos1+1,(Len(datei)-pos1)-(Len(datei)-pos2+1))
    
    Err.clear
    Set zielslwfile = fs.OpenTextFile(temppath&"\slx"&templatename&".slx",8,True)
    l=1
    laenge=Len(namestring)
    mystring1=""
    Do While l<laenge
        mystring2=getword(namestring,l)
        If mystring2<>mystring1 Then
            zielslwfile.writeline(mystring2)
            mystring1=mystring2
        End If
        l=l+1
    Loop
    
    If fs.FileExists(temppath&"\slw"&templatename&".slw") Then
        Set quellslwfile = fs.OpenTextFile(temppath&"\slw"&templatename&".slw",1)
        Do While quellslwfile.AtEndOfStream <> True
            zielslwfile.writeline(quellslwfile.readline)
        Loop
        Set quellslwfile = Nothing
    End If
    
    zielslwfile.close
    Set zielslwfile=Nothing
    If Err.number Then
        Err.clear
        removemsg
        MsgBox("bitfarm-Archiv: Fehler beim Dateiimport: Kann Dateinamen nicht als Schlagwort speichern. Kann so nicht archivieren. Bitte informieren Sie den Administrator.")
        objWshShell.LogEvent 1, "bitfarm-Archiv: Fehler beim Dateiimport: Kann Dateinamen nicht als Schlagwort speichern. Kann so nicht archivieren. Bitte informieren Sie den Administrator."
        Unlock(lockdatei)
        WScript.Quit	
    End If
    
    
    
End Function

'***************************************************************************************
'***************************************************************************************



Function readjob(tempname)
    On Error Resume Next
    readjob=True
    Err.clear
    
    If Not fs.FileExists(tempname) Then
        Err.clear
        
        readjob=False
        Err.clear
    End If
    
    If readjob=True Then	
        Set jobfile = fs.OpenTextFile(tempname,1)
        If Err.number Then
            Err.clear
            
            readjob=False
            
        End If 
    End If
    
    
    If readjob = True Then
        
        Do While jobfile.AtEndOfStream <> True
            kette=jobfile.readline
            If Left(kette,1)<>";" Then
                
                
                If InStr(1,kette,"Profil=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Profil=",1)+7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Profil = wert
                    End If
                End If
                
                If InStr(1,kette,"OCR_Typ=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"OCR_Typ=",1)+8)
                    typ = wert
                End If
                
                If Left(kette,9) = "Benutzer=" Then
					username=Right(kette,Len(kette)-(InStr(1,kette,"Benutzer=",1)+8))
					If username = "" Then
						username = "unbekannt"
					End If 
				End If
                
            End If
            
            
        Loop
        jobfile.close
        Set jobfile = Nothing
        
    End If
    
    
End Function

Function writejob(tempname)
    On Error Resume Next
    writejob=True
    Err.clear
    
    If Not fs.FileExists(tempname&".job") Then
        Err.clear
        errortxt=tempname&".job Datei nicht vorhanden oder nicht lesbar."
        objWSHShell.LogEvent 1, errortxt
        writejob=False
        Err.clear
    End If
    
    If writejob=True Then	
        Set quelljobfile = fs.OpenTextFile(tempname&".job",1)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWSHShell.LogEvent 1, errortxt
            writejob=False
            
        End If 
    End If
    
    If writejob=True Then
        If fs.FileExists(tempname&".tmp") Then
            fs.DeleteFile(tempname& ".tmp")
            If Err.number Then
                Err.clear
                errortxt="Zwischendatei fr Jobdatei existierte noch, kann diese aber nicht lschen."
                objWSHShell.LogEvent 1, errortxt
                writejob=False
                quelljobfile.close
                Set quelljobfile=Nothing
            End If 
            
        End If	
    End If
    
    If writejob=True Then
        Set zieljobfile = fs.OpenTextFile(tempname&".tmp",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWSHShell.LogEvent 1, errortxt
            writejob=False
            quelljobfile.close
            Set quelljobfile=Nothing
        End If 
    End If
    
    
    
    If writejob = True Then
        
        stopflag=False
        ersatzstring=""	
        Do While quelljobfile.AtEndOfStream <> True
            kette=quelljobfile.readline
            
            
            
            
            ersatzstring=""
            
            If (myname<>"") And (InStr(1,kette,"Titel=",1)<>0) Then
                ersatzstring="Titel="&myname
            End If
            
            
            
            If (Username<>"") And (InStr(1,kette,"Benutzer=",1)<>0) Then
                ersatzstring="Benutzer="&Username
            End If	
            
            If (dokDate<>"") And (InStr(1,kette,"Datum=",1)<>0) Then
                ersatzstring="Datum="&DokDate
            End If
            
            If (Typ<>"") And (InStr(1,kette,"OCR_Typ=",1)<>0) Then
                ersatzstring="OCR_Typ="&Typ
            End If
            
            If (Filtermakro<>"") And (InStr(1,kette,"Filter=",1)<>0) Then
                ersatzstring="Filter="&Filtermakro
            End If	
            
            
            'If Left(kette,3)="Zus" Then
            '	For x=1 to Zusatzfelder
            '		
            '		If (Zusatzfeld(x)<>"") AND (InStr(1,kette,"ZusWert"&x&"=",1)<>0) Then
            '			ersatzstring="ZusWert"&x&"="&Zusatzfeld(x)
            '		End If
            '	Next
            'End If
            
            If ersatzstring<>"" Then
                zieljobfile.writeline(ersatzstring)
            Else
                zieljobfile.writeline(kette)
            End If
            
        Loop
        quelljobfile.close
        Set quelljobfile = Nothing
        zieljobfile.close
        Set zieljobfile=Nothing
        WScript.sleep 50
        
        Err.clear
        fs.DeleteFile(tempname& ".job")
        If Err.number Then
            Err.clear
            errortxt="Fehler beim lschen der alten jobdatei."
            objWSHShell.LogEvent 1, errortxt
            writejob=False
        End If 
        
        
        'wscript.sleep 200
        
        If writejob=True Then
            
            fs.CopyFile tempname&".tmp", tempname&".job", True
            If Err.number Then
                Err.clear
                errortxt="Fehler beim umkopieren Jobdatei."
                objWSHShell.LogEvent 1, errortxt
                writejob=False
            End If 
        End If
        
        WScript.sleep 50
        If writejob=True Then
            fs.DeleteFile(tempname& ".tmp")
            If Err.number Then
                Err.clear
                errortxt="Fehler beim lschen der zwischen-jobdatei."
                objWSHShell.LogEvent 1, errortxt
                writejob=False
            End If 
        End If
        WScript.sleep 50
        
    End If
    
    
End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************
'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function readconfig(profil)
    On Error Resume Next
    readconfig=True
    Err.clear
    
    If Not fs.FileExists(programm&profil&".con") Then
        Err.clear
        errortxt=profil&".con Datei nicht im Scriptpfad vorhanden oder nicht lesbar."
        objWSHShell.LogEvent 1, errortxt
        readconfig=False
        Err.clear
    End If
    
    If readconfig=True Then	
        Set confile = fs.OpenTextFile(programm&profil&".con",1)
        If Err.number Then
            Err.clear
            errortxt="Profilfdatei nicht im Scriptpfad vorhanden oder nicht lesbar."
            objWSHShell.LogEvent 1, errortxt
            Err.clear
            readconfig=False
            
        End If 
    End If
    
    If readconfig=True Then	
        kette=confile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        Do While Scriptsflag = 0
            kette=confile.readline
            Scriptsflag=InStr(1,kette,"[Scripts]")
            If confile.AtEndOfStream = True Then
                confile.close
                Set confile=Nothing
                scriptsflag=1
                errortxt="Fehler beim Lesen der CON-Datei - falsche Formatierung."
                objWSHShell.LogEvent 1, errortxt
                readconfig = False
                
            End If
        Loop
        
    End If
    
    
    If readconfig = True Then
        
        Do While confile.AtEndOfStream <> True
            kette=confile.readline
            If Left(kette,1)<>";" Then
                
                
                If InStr(1,kette,"uncclientspooler",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"uncclientspooler",1)+16)
                    uncclientspooler = wert
                End If
                
                '	If InStr(1,kette,"clientprogramm",1)<>0 Then
                '		wert=GetString(kette,InStr(1,kette,"uncclientspooler",1)+15)
                '		clientprogramm = wert
                '	End If
                
            End If
            
        Loop
        confile.close
        Set confile = Nothing
        
    End If
    
    
End Function




'***************************************************************************************
'***************************************************************************************
'***************************************************************************************
Function setdokdate()
    On Error Resume Next
    Jahr = DatePart("yyyy",Date)
    Monat = DatePart("m",Date)
    Tag = DatePart("d",Date)
    Stunde = DatePart("h",Time)
    Minuten = DatePart("n",Time)
    Sekunde = DatePart("s", Time)
    If Len(Monat)=1 Then 
        monat="0"&monat
    End If
    If Len(tag)=1 Then 
        tag="0"&tag
    End If
    If Len(stunde)=1 Then 
        stunde="0"&stunde
    End If
    If Len(minuten)=1 Then 
        minuten="0"&minuten
    End If
    If Len(sekunde)=1 Then 
        sekunde="0"&sekunde
    End If
    setdokdate = Jahr&"-" & Monat & "-" & Tag & " " & Stunde & ":" & Minuten & ":" & Sekunde
End Function

'***************************************************************************************
'***************************************************************************************
'***************************************************************************************


Function inilesen()
    On Error Resume Next
    Err.clear
    Set inifile = fs.OpenTextFile(programm&"scripts.ini",1)
    If Err.number Then
        objWSHShell.LogEvent 1, "scripts.ini nicht im Scriptpfad vorhanden oder nicht lesbar."
        Err.clear
        Unlock(lockdatei)
        WScript.Quit
    End If 
    
    kette=inifile.readline
    Scriptsflag=InStr(1,kette,"[Scripts]")
    Do While Scriptsflag = 0
        kette=inifile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        If inifile.AtEndOfStream = True Then
            inifile.close
            objWSHShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - falsche Formatierung."
            Unlock(lockdatei)
            WScript.Quit
        End If
    Loop
    
    
    Do While inifile.AtEndOfStream <> True
        kette=inifile.readline
        If Left(kette,1)<>";" Then
            
            
            If InStr(1,kette,"Profil",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"Profil",1)+7)
                profil = wert
            End If
            
            If InStr(1,kette,"Typ",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"Typ",1)+4)
                typ = wert
            End If
            
            If InStr(1,kette,"MSWordinstalled",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"MSWordinstalled",1)+16)
                If LCase(wert)="true" Then
                    acceptdoc = True
                End If	
            End If
            
            If InStr(1,kette,"MSExcelinstalled",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"MSExcelinstalled",1)+17)
                If LCase(wert)="true" Then
                    acceptxls = True
                End If	
            End If
            
            If InStr(1,kette,"MSPowerPointinstalled",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"MSPowerPointinstalled",1)+22)
                If LCase(wert)="true" Then
                    acceptppt = True
                End If	
            End If
            
            If InStr(1,kette,"DWGViewerinstalled",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"DWGViewerinstalled",1)+19)
                If LCase(wert)="true" Then
                    acceptdwg = True
                End If	
            End If
            
            
        End If
        
    Loop
    inifile.close
    Set inifile = Nothing
    If programm="" Then
        objWSHShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - kein Programmpfad."
        WScript.Quit
    End If
    
    
End Function



Private Function GetWord(kette,pos)
    On Error Resume Next
    zeichen=""
    ergebnis=""
    index1=pos
    'MsgBox(Len(kette)&":"&pos)
    Do While (zeichen<>" ") And (zeichen<>"	") And (index1>1)
        index1=index1-1
        zeichen=Mid(kette,index1,1)
        
    Loop
    'MsgBox(index1)
    zeichen=""
    index2=0
    maxindex2=Len(kette)-index1+2
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (zeichen<>"	") And (index2<maxindex2)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,index1+index2,1)
        index2=index2+1
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=")) And (ergebnis="") Then
            zeichen=""
        End If
    Loop
    'MsgBox(index)
    Trim(ergebnis)
    GetWord=ergebnis
End Function

Function Unlock(lockfileandpath)
    On Error Resume Next
    Err.clear
    If lockfileandpath<>"" Then
        If fs.fileexists(lockfileandpath) Then
            fs.DeleteFile lockfileandpath
            If Err.number<>0 Then
                objWSHShell.LogEvent 1, "archivierung(F1): Fehler: kann lockdatei nicht lschen:"&lockfileandpath
                WScript.Quit
            End If
        End If
    End If
End Function

Function Zufallszahl(von, bis)
    On Error Resume Next
    anzahl = bis-von+1
    Randomize
    Zufallszahl = Fix(Rnd*(anzahl))+von
End Function


Private Function StrConvert(String)
    On Error Resume Next
    wert1=0
    l = Len(String)
    
    For x = 1 To l
        wert1=wert1+((Asc(Mid(String,x,1))-48)*(10^(l-x)))
    Next
    StrConvert=wert1
End Function


Private Function GetString(kette,pos)
    On Error Resume Next
    zeichen=""
    ergebnis=""
    index=0
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (zeichen<>"	") And (index<80)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,pos+index,1)
        index=index+1
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=")) And (ergebnis="") Then
            zeichen=""
        End If
    Loop
    Trim(ergebnis)
    GetString=ergebnis
End Function


Function RegRead(tempkey)
    On Error Resume Next
    privkey = tempkey
    
    RegRead = objWSHShell.RegRead(privkey)
    If Not Err.number=0 Then
        MsgBox("Fehler: Registrierungsschlssel nicht gesetzt.")
        objWshShell.LogEvent 1, "Fehler: Registrierungsschlssel nicht gesetzt."
        RegRead=""
        Err.clear
        WScript.Quit
    End If
End Function


Function showmsg()
    showmsg=True
    Err.clear
    On Error Resume Next
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        showmsg=False
    Else
        Set objWMIService = Nothing
    End If
    If showmsg=True Then
        Set oExec = objWSHShell.exec(Chr(34)&programm&"bfamessage.exe"&Chr(34))
        If Err.number<>0 Then
            Err.clear
            'On Error Resume next
            showmsg=False
        Else
            Set oexec=Nothing
        End If
    End If
End Function



Function removemsg()
    Err.clear
    On Error Resume Next
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    If Err.number=0 Then
        strQuery = "Select * from Win32_Process where Name='bfamessage.exe'"
        Set colItems = objWMIService.ExecQuery(strQuery,,48)
        For Each objItem In colItems
            objItem.Terminate()
        Next
        WScript.sleep 100
        Set colItems = Nothing
        Set objWMIService = Nothing
    End If
    Err.clear
    'On Error Resume next
End Function

Function getlogtime
    On Error Resume Next
    
    
    
    Jahr = DatePart("yyyy",Date)
    Monat = DatePart("m",Date)
    If Len(monat) = 1 Then
        monat = "0" & monat
    End If
    Tag = DatePart("d",Date)
    If Len(tag) = 1 Then
        tag = "0" & tag
    End If
    
    Stunde = DatePart("h",Time)
    If Len(Stunde) = 1 Then
        Stunde = "0" & Stunde
    End If
    
    Minuten = DatePart("n",Time)
    If Len(Minuten) = 1 Then
        Minuten = "0" & Minuten
    End If
    
    Sekunde = DatePart("s", Time)
    If Len(Sekunde) = 1 Then
        Sekunde = "0" & Sekunde
    End If
    
    getlogtime = Jahr&"-" & Monat & "-" & Tag & "--" & Stunde & "-" & Minuten & "-" & Sekunde
    
End Function




'*******************************************************************************************
'*******************************************************************************************
'********************************          Ende             ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
