'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'***************  mover.vbs         GPL  ***************************************************
'*******************************************************************************************
'***************  Version 3.6.2.0        ***************************************************
'*******************************************************************************************
'***************  Programm zum Umsetzen der Verschiebeoperation von          ***************
'***************  Dokumenten durch den Viewer im Dateisystem                 ***************
'***************                                                             ***************
'***************  Wird vom Spooldienst gestartet, sobald eine entsprechende  ***************
'***************  Anweisungsdatei vom Client bergeben wird.                 ***************
'***************                                                             ***************
'***************                                                             ***************
'***************                                                             ***************
'***************  Syntax: <programmpfad>mover.vbs <MOVE-Datei>               ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************


scriptdebug = False
logging = False

'*******************************************************************************************
'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

On Error Resume Next


Dim objWSHShell, fso, FileIn, FileOut 
Dim Datei, Text, Txt, i, arrSort, arrTest(), oArgs, Druckername
Dim lngReturnCode
ReDim ext(60)

Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set fs      = WScript.CreateObject("Scripting.FileSystemObject") 
Set oArgs    = WScript.Arguments 

If scriptdebug=True Then
    For i = 0 To oArgs.Count -1	
        arg = arg & oArgs.Item(i) & vbCrLf
    Next 
    objWshShell.LogEvent 4, "mover.vbs (1) gestartet" & vbCrLf & arg
End If 

'*******************************************************************************************
'**************************  Startparameter initialisieren  ********************************
Err.clear
fullpath = WScript.ScriptFullName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
scriptname = WScript.ScriptName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
If Len(programm)=0 Then
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If


archivverzeichnis="" 
oldposition=""
Tabelle=""
oldkopieposition=""
archivkopie=""
profil=""
quelle=""
kopiename=""
folderID=""
basisname=""
newfolder=""
Typ="OMP"
commandtype=""
dokid=""
gdocid=""
arcid=""
strdocid=""
ursprung=""
wfID="0"
Benutzer=""
noworkflow=False
moveext=".MOVE"
svn_link=""
svn_version=""
svn_revision=""
svninfo=""
dontmovesvn=False
opensslpath=""

'movelock = getmovelockvar
'If scriptdebug=true Then
'		objWshShell.LogEvent 0, "mover.vbs (1) MovelockVariabel." & movelock
'
'	End If
'If movelock = 1 Then
'	If scriptdebug=true Then
'		objWshShell.LogEvent 0, "mover.vbs (1) MovelockVariabel vorhanden, Programmausstieg" & vbCrLf & "Datei:" & datei & vbCrlF & Now()
'
'	End If
'	
'	wscript.quit
'End If
'


lockdatei=programm&"temp\movelock"

If fs.fileexists(lockdatei) Then
    
    If scriptdebug=True Then
        objWshShell.LogEvent 4, "mover.vbs (1) Lockdatei vorhanden, Programmausstieg" & vbCrLf & "Datei:" & datei & vbCrLf & Now()
    End If
    WScript.quit
End If
WScript.Sleep 50
If fs.fileexists(lockdatei) Then
    If scriptdebug=True Then
        objWshShell.LogEvent 4, "mover.vbs (2) Lockdatei vorhanden, Programmausstieg" & vbCrLf & "Datei:" & datei & vbCrLf & Now()
    End If
    WScript.quit
Else
    '*************************************************************************************************
    '************************************** Lock setzen **********************************************
    '*************************************************************************************************
    'setmovelockvar
    Err.Clear
    
    Set lockfile = fs.CreateTextFile(lockdatei,True)
    If Err.number<>0 Then
        WScript.Quit
    End If
    
    lockfile.Writeline("lock")
    lockfile.close
    
    Set lockfile = Nothing
    
    If Err.number<>0 Then
        objWshShell.LogEvent 1, "bitfarm-Archiv: mover(1): Fehler bei lockfile erstellen"
        On Error Resume Next
        Err.clear
        Unlock(lockdatei)
        WScript.Quit
    End If 
    
    
End If
WScript.sleep 50

'**************************************************************************************
'**************************************************************************************

Jahr = DatePart("yyyy",Date)
Monat = DatePart("m",Date)
Tag = DatePart("d",Date)

mon=Monat
If Len(mon)=1 Then
    mon="0"&mon
End If
jhr=Jahr
If Len(Tag)=1 Then
    Tag="0"&Tag
End If
foldernumber=mon&jhr
subfoldernumber=Tag


'*******************************************************************************************
'**************************  Startparameter initialisieren  ********************************
Err.clear
fullpath = WScript.ScriptFullName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    Unlock(lockdatei)
    WScript.Quit
End If 
scriptname = WScript.ScriptName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    Unlock(lockdatei)
    WScript.Quit
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    Unlock(lockdatei)
    WScript.Quit
End If 
If Len(programm)=0 Then
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    Unlock(lockdatei)
    WScript.Quit
End If


'*******************************************************************************************
'*******************************************************************************************

inilesen

'**************************************************************************************
'**************************************************************************************


Err.clear
Datei = oArgs.item(0) 
If Err.number<>0 Then
    objWshShell.LogEvent 1, "bitfarm-Archiv: Mover: kein Parameter bergeben (Datei)."
    Err.clear
    Unlock(lockdatei)
    WScript.Quit
End If 


If Not fs.FileExists(Datei) Then
    objWshShell.LogEvent 1, "bitfarm-Archiv: mover: bergebene Datei nicht (mehr) vorhanden." & Datei
    Err.clear
    Unlock(lockdatei)
    WScript.Quit
End If

'****************************  Anweisungsdatei schon sichern, spoolerpfad leeren ******************
If InStr(1,datei,programm&"temp\",1)=0 Then
    
    If scriptdebug=True Then
        objWshShell.LogEvent 4, "mover.vbs (1) Anweisungsdatei sichern" & vbCrLf & "Datei: " & datei & vbCrLf & "Pfad:  " & programm & "temp\"
        
    End If
    
    tempdatei=sicher(datei)
    cleanup(datei)
    datei=tempdatei
End If

'**********************************************************************************

erfolg=False
erfolg=readjob(Datei)
If erfolg=False Then
    objWshShell.LogEvent 1, "bitfarm-Archiv: mover: Fehler beim lesen der Anweisungen."
    cleanup(Datei)
    Unlock(lockdatei)
    WScript.Quit
End If



If profil<>"" Then
    erfolg=readconfig(profil)
    If erfolg=False Then
        objWshShell.LogEvent 1, "bitfarm-Archiv: mover: kann Profil nicht lesen."
        cleanup(Datei)
        Unlock(lockdatei)
        WScript.Quit
    End If
Else
    objWshShell.LogEvent 1, "bitfarm-Archiv: mover: kein Profil erkannt."
    cleanup(Datei)
    Unlock(lockdatei)
    WScript.Quit
End If



If LCase(commandtype)="moveanweisung" Then
    
    ' kein Umlagern von Dokumente mehr, nie wieder!
    
    '	If Not dontmovesvn Then
    '*********************************** verzeichnisse anlegen ***************************
    '		If Not fs.FolderExists(archivverzeichnis) Then
    '			Set tes1 = fs.CreateFolder(archivverzeichnis)
    '			Set tes1 = Nothing
    '			WScript.sleep 50
    '			If Err.number<>0 Then
    '				objWshShell.LogEvent 1, "bitfarm-Archiv: Mover: Fehler beim Anlegen des Archivverzeichnisses."
    '				Err.clear
    '				Unlock(lockdatei)
    '				WScript.Quit
    '			End If 
    
    '			If Not fs.FolderExists(archivverzeichnis) Then
    '				objWshShell.LogEvent 1, "bitfarm-Archiv: Mover: (2) Fehler beim Anlegen des Archivverzeichnisses."
    '				Unlock(lockdatei)
    '				WScript.Quit
    '			End If
    '		End If
    
    '		Err.clear
    
    '		If Not fs.FolderExists(archivkopie) Then
    '			Set tes1 = fs.CreateFolder(archivkopie)
    '			Set tes1 = Nothing
    '			WScript.sleep 50
    '			If Err.number<>0 Then
    '				objWshShell.LogEvent 1, "bitfarm-Archiv (mover): Fehler beim Anlegen des Archivkopie-Verzeichnisses ("&archivkopie&")."
    '				Err.clear
    '				Unlock(lockdatei)
    '				WScript.Quit
    '			End If 
    
    '			If Not fs.FolderExists(archivkopie) Then
    '				objWshShell.LogEvent 1, "bitfarm-Archiv (mover): (2) Fehler beim Anlegen des Archivkopie-Verzeichnisses."
    '				Unlock(lockdatei)
    '				WScript.Quit
    '			End If
    '		End If
    
    '		Tabellex=Tabelle
    '		laenge=Len(Tabellex)
    
    '		If laenge>0 Then
    '			Tabelley=""
    '			For x=1 To laenge
    '				mychar=Mid(tabellex,x,1)
    '				If (mychar<>" ") And (mychar<>"\") And (mychar<>"/") And (mychar<>"+") And (mychar<>"*") And (mychar<>".") And (mychar<>":") And (mychar<>"<") And (mychar<>">")Then
    '					tabelley=tabelley&mychar
    '				Else
    '					objWshShell.LogEvent 2, "bitfarm-Archiv: Archivnamen sollten keine Leer- und Sonderzeichen enthalten! Bitte im Admin-Tool ndern: "&Tabelle
    '				End If
    '			Next
    '			tabellex=tabelley
    '		End If
    
    '		If Len(tabelley)<1 Then
    '			errortxt="bitfarm-archiv: mover(38): Fehlerhafter Archivnamen (Sonderzeichen, oder/und zu kurz). Bitte im Administrator ndern."
    '			objWshShell.LogEvent 1, errortxt
    '			Unlock(lockdatei)
    '			WScript.Quit
    '		End If
    
    
    '		Ausgabeverzeichnis = Archivverzeichnis&Tabellex&folderID&"\"
    '		schattenverzeichnis = archivkopie&Tabellex&folderID&"\"
    
    
    '		If Not fs.FolderExists(Ausgabeverzeichnis) Then
    '			Set tes1 = fs.CreateFolder(Ausgabeverzeichnis)
    '			Set tes1 = Nothing
    '			WScript.sleep 50
    '			If Err.number<>0 Then
    '				objWshShell.LogEvent 1, "bitfarm-Archiv: Mover: Fehler beim Anlegen eines Verzeichnisses (1)."
    '				Err.clear
    '				Unlock(lockdatei)
    '				WScript.Quit
    '			End If 
    
    '			If Not fs.FolderExists(Ausgabeverzeichnis) Then
    '				objWshShell.LogEvent 1, "bitfarm-Archiv: Mover: Fehler beim Anlegen eines Verzeichnisses (2)."
    '				Unlock(lockdatei)
    '				WScript.Quit
    '			End If
    '		End If
    
    
    '		If Not fs.FolderExists(schattenverzeichnis) Then
    '			Set tes1 = fs.CreateFolder(schattenverzeichnis)
    '			Set tes1 = Nothing
    '			WScript.sleep 50
    '			If Err.number<>0 Then
    '				objWshShell.LogEvent 1, "bitfarm-Archiv: Mover: Fehler beim Anlegen eines Verzeichnisses (3)."
    '				Err.clear
    '				Unlock(lockdatei)
    '				WScript.Quit
    '			End If 
    
    '			If Not fs.FolderExists(schattenverzeichnis) Then
    '				objWshShell.LogEvent 1, "bitfarm-Archiv: Mover: Fehler beim Anlegen eines Verzeichnisses (4)."
    '				Unlock(lockdatei)
    '				WScript.Quit
    '			End If
    '		End If
    
    
    '		Ausgabeverzeichnis = Archivverzeichnis&Tabellex&folderID&"\"&foldernumber&"\"
    '		schattenverzeichnis = archivkopie&Tabellex&folderID&"\"&foldernumber&"\"
    
    '		If Not fs.FolderExists(Ausgabeverzeichnis) Then
    '			Set tes1 = fs.CreateFolder(Ausgabeverzeichnis)
    '			Set tes1 = Nothing
    '			WScript.sleep 50
    '			If Err.number<>0 Then
    '				objWshShell.LogEvent 1, "bitfarm-Archiv: Mover: Fehler beim Anlegen eines Verzeichnisses (5)."
    '				Err.clear
    '				Unlock(lockdatei)
    '				WScript.Quit
    '			End If 
    
    '			If Not fs.FolderExists(Ausgabeverzeichnis) Then
    '				objWshShell.LogEvent 1, "bitfarm-Archiv: Mover: Fehler beim Anlegen eines Verzeichnisses (6)."
    '				Unlock(lockdatei)
    '				WScript.Quit
    '			End If
    '		End If
    
    
    '		If Not fs.FolderExists(schattenverzeichnis) Then
    '			Set tes1 = fs.CreateFolder(schattenverzeichnis)
    '			Set tes1 = Nothing
    '			WScript.sleep 50
    '			If Err.number<>0 Then
    '				objWshShell.LogEvent 1, "bitfarm-Archiv: Mover: Fehler beim Anlegen eines Verzeichnisses (7)."
    '				Err.clear
    '				Unlock(lockdatei)
    '				WScript.Quit
    '			End If 
    
    '			If Not fs.FolderExists(schattenverzeichnis) Then
    '				objWshShell.LogEvent 1, "bitfarm-Archiv: Mover: Fehler beim Anlegen eines Verzeichnisses (8)."
    '				Unlock(lockdatei)
    '				WScript.Quit
    '			End If
    '		End If
    
    '		Ausgabeverzeichnis = Archivverzeichnis&Tabellex&folderID&"\"&foldernumber&"\"&subfoldernumber&"\"
    '		schattenverzeichnis = archivkopie&Tabellex&folderID&"\"&foldernumber&"\"&subfoldernumber&"\"
    
    '		If Not fs.FolderExists(Ausgabeverzeichnis) Then
    '			Set tes1 = fs.CreateFolder(Ausgabeverzeichnis)
    '			Set tes1 = Nothing
    '			WScript.sleep 200
    '			If Err.number<>0 Then
    '				objWshShell.LogEvent 1, "bitfarm-Archiv: Mover(0): kann Ausgabeverzeichnis-verzeichnis nicht erstellen - Berechtigung?"
    '				Err.clear
    '				On Error Resume Next
    '				WScript.Quit
    '			End If 
    
    '			If Not fs.FolderExists(Ausgabeverzeichnis) Then
    '				objWshShell.LogEvent 1, "bitfarm-Archiv: Mover(0b): kann Ausgabeverzeichnis-verzeichnis nicht erstellen (2) - Berechtigung?"
    '				WScript.Quit
    '			End If
    '		End If
    
    
    '		If Not fs.FolderExists(schattenverzeichnis) Then
    '			Set tes1 = fs.CreateFolder(schattenverzeichnis)
    '			Set tes1 = Nothing
    '			WScript.sleep 200
    '			If Err.number<>0 Then
    '				objWshShell.LogEvent 1, "bitfarm-Archiv: Mover(1): kann schattenverzeichnis-verzeichnis nicht erstellen - Berechtigung?"
    '				Err.clear
    '				On Error Resume Next
    '				WScript.Quit
    '			End If 
    
    '			If Not fs.FolderExists(schattenverzeichnis) Then
    '				objWshShell.LogEvent 1, "bitfarm-Archiv: Mover(1b): kann schattenverzeichnis-verzeichnis nicht erstellen (2) - Berechtigung?"
    '				WScript.Quit
    '			End If
    '		End If
    
    '******************************************** verschieben **************************
    
    '		If scriptdebug=True Then
    '			objWshShell.LogEvent 4, "mover.vbs Beginn Verschiebeoperation."& vbCrLf & datei
    '		End If
    
    '		flag12=False
    '		If InStr(1,oldposition,archivkopie,1)<>0 Then
    '			ausgabeverzeichnis=schattenverzeichnis
    '			flag12=True
    '		End If
    
    '		flag66=False	
    '		kopiename=""
    '		ausgabename=""
    '		If fs.fileexists(oldposition) Then
    '			flag66=True
    
    '			Set tempfile=fs.getfile(oldposition)
    'ausgabename=ausgabeverzeichnis&Left(tempfile.name,Len(tempfile.name)-4)
    '			ausgabename=ausgabeverzeichnis&tempfile.Name
    '			If oldkopieposition <> "" Then
    '				kopiename = ausgabeverzeichnis&tempfile.Name
    '			End If 
    '			Set tempfile=Nothing
    'MsgBox("Verschiebe1:"&oldposition&" + "&ausgabeverzeichnis)
    
    '			erfolg=copygroup(oldposition,ausgabeverzeichnis)
    
    '			If erfolg=False Then
    '				objWshShell.LogEvent 1, "bitfarm-Archiv: Mover: Fehler beim verschieben."
    '				erfolg=Rollbackoperation(oldposition,ausgabeverzeichnis)
    '				Unlock(lockdatei)
    '				WScript.Quit
    '			End If
    
    '		End If
    
    
    '		If (oldkopieposition<>"") And (flag12=False) Then
    '			If fs.fileexists(oldkopieposition) Then
    '				flag66=True
    
    '				Set tempfile=fs.getfile(oldkopieposition)
    '				kopiename=schattenverzeichnis&tempfile.name
    '				Set tempfile=Nothing
    '				If ausgabename="" Then
    '					ausgabename=kopiename
    '				End If
    'MsgBox("Verschiebe2:"&oldkopieposition&" zu "&schattenverzeichnis)
    
    '				If scriptdebug=True Then
    '					objWshShell.LogEvent 4, "mover.vbs Verschiebe2:"&oldkopieposition&" zu "&schattenverzeichnis
    '				End If
    
    '				erfolg=copygroup(oldkopieposition,schattenverzeichnis)
    '				If erfolg=False Then
    '					objWshShell.LogEvent 1, "bitfarm-Archiv: Mover: Fehler beim verschieben der arbeitskopie."
    '					kopiename=""
    '					erfolg=Rollbackoperation(oldposition,ausgabeverzeichnis)
    '					erfolg=Rollbackoperation(oldkopieposition,schattenverzeichnis)
    '					Unlock(lockdatei)
    '					WScript.Quit
    '				End If
    
    '			End If
    '		End If
    
    
    '		If flag66=False Then
    '			objWshShell.LogEvent 1, "bitfarm-Archiv: Mover: Inkonsistente Anweisung (Dateien nicht vorhanden) in "&Datei
    '			Unlock(lockdatei)
    '			WScript.Quit
    '		End If
    
    
    '		If fs.fileexists(schattenverzeichnis&basisname&".job") Then
    '			readoldjob(schattenverzeichnis&basisname&".job")
    
    '		End If
    
    '		If fs.fileexists(ausgabeverzeichnis&basisname&".job") Then
    '			readoldjob(ausgabeverzeichnis&basisname&".job")
    
    '		End If
    
    '		If quelle <> "" Then
    '			quelle = ausgabeverzeichnis & fs.GetFileName(quelle)
    '		End If 
    
    
    'MsgBox("Schreibe neue Jobdatei...")
    '		erfolg=writejob(Left(datei,Len(datei)-5))
    
    '		If erfolg=False Then
    '			objWshShell.LogEvent 1, "bitfarm-Archiv: Mover: Fehler beim schreiben der Datenbankdatei."
    '			erfolg=Rollbackoperation(oldposition,ausgabeverzeichnis)
    '			erfolg=cleanup(Left(datei,Len(datei)-5)&".job")
    '			If kopiename<>"" Then
    '				erfolg=Rollbackoperation(oldkopieposition,schattenverzeichnis)
    '			End If
    '			Unlock(lockdatei)
    '			WScript.Quit
    '		End If
    
    'WScript.Sleep 50
    'If fs.fileexists(programm & "DocID.dbi") Then
    '	fs.deletefile programm&"DocID.dbi", true
    '
    '	If err.number<>0 Then
    '		errortxt="bitfarm-Archiv: Mover: kann .dbi - datei nicht lschen."
    '		objWSHShell.LogEvent 1, errortxt
    '		erfolg=Rollbackoperation(oldposition,ausgabeverzeichnis)
    '		erfolg=cleanup(Left(datei,Len(datei)-5)&".job")
    '		If kopiename<>"" Then
    '			erfolg=Rollbackoperation(oldkopieposition,schattenverzeichnis)
    '		End If
    '		Unlock(lockdatei)
    '		WScript.Quit
    '	End If
    'End If	
    '***********************************  bergabe an die Datenbank ****************************
    'MsgBox("bergebe an Datenbank...")
    'lngReturnCode = objWSHShell.Run(programm&"DBImpV3.exe "&Left(datei,Len(datei)-5)&".job",0,true)
    'MsgBox("Datenbankrckmeldung:"&lngreturncode)
    '		lngReturnCode=dbimp(Left(datei,Len(datei)-5))
    
    '		If scriptdebug=True Then
    '			objWshShell.LogEvent 4, "mover.vbs (2) bergabe an die Datenbank:" & Left(datei,Len(datei)-5)
    '		End If
    
    '		If (lngReturnCode <> 0) And (lngReturnCode<>6) Then
    '			errortxt="bitfarm-Archiv: Mover: Fehler bei bergabe an Datenbank ("&lngreturncode&")"
    '			objWSHShell.LogEvent 1, errortxt
    '			erfolg=Rollbackoperation(oldposition,ausgabeverzeichnis)
    '			If fs.fileexists(Left(datei,Len(datei)-5)&".job") Then
    '				zahl1=zufallszahl(0,99999)
    '				fs.copyfile Left(datei,Len(datei)-5)&".job", programm&"temp\"&zahl1&".job", True
    '			End If
    '			erfolg=cleanup(Left(datei,Len(datei)-5)&".job")
    '			If kopiename<>"" Then
    '				erfolg=Rollbackoperation(oldkopieposition,schattenverzeichnis)
    '			End If
    '			Unlock(lockdatei)
    '			WScript.Quit
    '		End If
    
    
    
    '		If fs.fileexists(schattenverzeichnis&basisname&".job") Then
    '			erfolg=refreshjob(schattenverzeichnis&basisname)
    '			fs.copyfile Left(datei,Len(datei)-5)&".job", schattenverzeichnis&basisname&".job", True
    
    '		End If
    
    '		If fs.fileexists(ausgabeverzeichnis&basisname&".job") Then
    '			erfolg=refreshjob(ausgabeverzeichnis&basisname)
    '			fs.copyfile Left(datei,Len(datei)-5)&".job", ausgabeverzeichnis&basisname&".job", True
    
    '		End If
    
    'erfolg=delfile(oldposition,ausgabeverzeichnis)
    'If kopiename<>"" Then
    '	erfolg=delfile(oldkopieposition,schattenverzeichnis)
    'End If
    
    '	Else
    '		If scriptdebug Then
    '			objWshShell.LogEvent 4,"Mover.vbs: Dateien unter SVN werden nicht verschoben" & vbCrLf & ausgabename
    '		End If 
    '	End If 
    
    ausgabename = Replace(Datei, "." & fs.GetExtensionName(Datei), ".txt")
    fs.MoveFile Datei, ausgabename
    If Err.Number Then
        objWSHShell.LogEvent 2,"Mover.vbs: Konnte Move-Datei nicht fr workflow.vbs umbenennen" & vbCrLf & Err.Description 
        Err.Clear
    End If 
    
    erfolg=cleanup(datei)
    erfolg=cleanup(Left(datei,Len(datei)-5)&".job")
    
    If Not noworkflow Then
        ausgabename = Replace(ausgabename,"." &fs.GetExtensionName(ausgabename),"")
        
        param = Chr(34) & ausgabename& Chr(34) &" "&wfID&" "&dokID&" "&profil&" 2 """&tabelle&""" "&schattenverzeichnis&basisname
        'msgbox(param)
        If scriptdebug = True Then
            objWshShell.LogEvent 4,"Mover.vbs: Verschiebeanweisung an Workflow. Parameter: Name:"&param
        End If
        
        If fs.fileexists(schattenverzeichnis&basisname&".tif") Then
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"workflow.bat"&Chr(34)&" "& Chr(34) & ausgabename& Chr(34) &" "&wfID&" "&dokID&" "&profil&" 2 """&tabelle&""" "&schattenverzeichnis&basisname,0,True)
        Else
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"workflow.bat"&Chr(34)&" "& Chr(34) & ausgabename& Chr(34) &" "&wfID&" "&dokID&" "&profil&" 2 """&tabelle&"",0,True)
        End If
        
    Else
        If scriptdebug = True Then
            objWshShell.LogEvent 4,"Mover.vbs: Verschiebeanweisung ohne Workflow. (.movx)"
        End If
    End If 
    
    Unlock(lockdatei)
    
    If scriptdebug = True Then
        objWshShell.LogEvent 4,"Mover.vbs: Programmausstieg (2)"
    End If
    
    WScript.Quit
End If

'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'***************************     Kommandodateien      *********************************
'**************************************************************************************
'***************************     MakeRevisionSave     *********************************
'**************************************************************************************

If (commandtype="makerevisionsave") Or (commandtype="makerevisonsave") Then
    If fs.fileexists(oldkopieposition) Then
        Set tempfile=fs.getfile(oldkopieposition)
        basis1name=schattenverzeichnis&tempfile.name
        basis2name=basis1Name
        Set tempfile=Nothing
    Else
        objWshShell.LogEvent 1, "Mover: Revisionssicher abzulegende Datei existiert nicht!"
        Unlock(lockdatei)
        WScript.Quit
    End If
    
    If ursprung <> "" Then
        extension = "." & fs.GetExtensionName(ursprung)
    Else
        extension = "." & fs.GetExtensionName(basis1name)
    End If 
    
    basis1name=Replace(basis1name,"." & fs.GetExtensionName(basis1name),"")
    
    If InStr(1,oldkopieposition,archivverzeichnis,1)<>0 Then
        objWshShell.LogEvent 1, "Mover: Dokument liegt bereits revisionssicher."
        Unlock(lockdatei)
        WScript.Quit
    End If
    
    'If fs.FileExists(Left(oldkopieposition,Len(oldkopieposition)-4) &  ".job") = False Then
    '	objWshShell.LogEvent 1, "bitfarm-Archiv: Mover: Es existiert keine Job-Datei am Ursprungsort." & vbCrLf & "Das Verschieben in den Revisionssicheren Bereich wird abgebrochen" & vbCrLf & Left(oldkopieposition,Len(oldkopieposition)-4) &  ".job"
    '	Unlock(lockdatei)
    '	WScript.Quit
    'End If
    
    'basis1pfad=Left(oldkopieposition,Len(oldkopieposition)-Len(basis1name)-4)
    basis1pfad=fs.GetParentFolderName(oldkopieposition) & "\"
    basis1pfad=Right(basis1pfad,Len(basis1pfad)-Len(archivkopie))
    
    erfolg=savegroup(oldkopieposition,archivverzeichnis&basis1pfad)
    If erfolg=False Then
        objWshShell.LogEvent 1, "bitfarm-Archiv: Mover: Fehler bei revisionssicher speichern."
        erfolg=Rollbackoperation(oldkopieposition,archivverzeichnis&basis1pfad)
        If erfolg=False Then
            objWshShell.LogEvent 1, "bitfarm-Archiv: Mover: schwerer Fehler -> konnte kein Rollback durchfhren:"&oldkopieposition
        End If
        Unlock(lockdatei)
        WScript.Quit
    End If
    
    ' nach dem umlagern die sha1 prfsumme aktualisieren
    'auskommentiert wegen darstellungsproblemen beim revisionsicheren speichern von dokumenten, wenn ein ext_loc vorhanden ist 
    'erfolg=delsavedfile(oldkopieposition,archivverzeichnis&basis1pfad)
    
    ausgabename=archivverzeichnis&basispfad&basis1pfad&basis2Name
    sha1 = Pruefsumme(archivverzeichnis&basispfad&basis1pfad&basis1Name & extension)
    
    erfolg=refreshjob(archivverzeichnis&basispfad&basis1pfad&basis1name)
    If erfolg=False Then
        objWshShell.LogEvent 1, "bitfarm-Archiv: Mover: Fehler bei revisionsicher speichern (Jobdatei)"
        erfolg=Rollbackoperation(oldkopieposition,archivverzeichnis&basis1pfad)
        If erfolg=False Then
            objWshShell.LogEvent 1, "bitfarm-Archiv: Mover: schwerer Fehler -> konnte kein Rollback durchfhren:"&oldkopieposition
        End If
        Unlock(lockdatei)
        WScript.Quit
    End If
    
    '***********************************  bergabe an die Datenbank ****************************
    
    lngReturnCode=dbimp(archivverzeichnis&basispfad&basis1pfad&basis1Name)
    
    If scriptdebug=True Then
        objWshShell.LogEvent 4, "mover.vbs (3) bergabe an die Datenbank:" & archivverzeichnis&basispfad&basis1pfad&basis1Name
    End If
    
    If (lngReturnCode <> 0) And (lngReturnCode<>6) Then
        errortxt="bitfarm-Archiv: Mover: Fehler bei bergabe an Datenbank ("&lngreturncode&")"
        objWSHShell.LogEvent 1, errortxt
        erfolg=Rollbackoperation(oldkopieposition,archivverzeichnis&basis1pfad)
        Unlock(lockdatei)
        WScript.Quit
    End If
    
    erfolg=cleanup(datei)
End If



'**************************************************************************************
'***************************          ReOCRFile       *********************************
'**************************************************************************************

If commandtype="reocrfile" Then
    myfile=oldkopieposition
    If ursprung<>"" Then
        myfile=ursprung
    End If
    queue=programm&"queue\"
    i=0
    tempname=queue&"change"&i&".cng"
    flag10=True
    If fs.FileExists(tempname) Then
        flag10=False
    End If
    Do While flag10=False
        i = i + 1
        tempname=queue&"change"&i&".cng"
        flag10=True
        If fs.FileExists(tempname) Then
            flag10=False
        End If
    Loop
    
    Err.clear
    
    Set changefile = fs.OpenTextFile(tempname,8,True)
    If Err.number=0 Then
        changefile.writeline(myfile)
        changefile.writeline(Benutzer)
        changefile.writeline(gdocid)
        changefile.writeline(profil)
        changefile.WriteLine("SvnInfo=" & SvnInfo)
        changefile.close
    Else
        Err.clear
        On Error Resume Next
        objWshShell.LogEvent 1, "bitfarm-Archiv nderungsdienst: Fehler beim Schreiben in die Warteschlange."
    End If
    
    Set changefile=Nothing
    
    erfolg=cleanup(datei)
    Unlock(lockdatei)
    WScript.Quit
End If

'**************************************************************************************
'***************************    CreateNewJobFiles        ******************************
'**************************************************************************************

If commandtype="createnewjobfiles" Then
    If fs.fileexists(programm&"createnewjobfile.exe") And fs.fileexists(programm&"createnewjobfile.bat") Then
        rc = objWSHShell.Run(Chr(34)&programm&"createnewjobfile.bat"&Chr(34)&" "&Chr(34)&Profil&Chr(34)&" "&Chr(34)&"-f:"&Datei&Chr(34),0,False)
    End If 
End If 

If scriptdebug=True Then
    objWshShell.LogEvent 4, "mover.vbs Programmende"
End If


Unlock(lockdatei)
WScript.Quit
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************Ende Hauptprogramm******************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************


Function refreshjob(tempname)
    On Error Resume Next
    refreshjob=True
    Err.clear
    
    If Not fs.FileExists(tempname&".job") Then
        Err.clear
        
        If fs.FileExists(programm & "createnewjobfile.exe") Then 
            Set oExec= objWSHShell.Exec(Chr(34)&programm & "createnewjobfile.exe"&Chr(34)&" "&Chr(34)&profil&Chr(34)& " " & arcid & " " & strdocid & " "&Chr(34)&tempname&Chr(34))	
            
            Do While Not oExec.StdOut.AtEndOfStream
                strinput = strinput & oExec.StdOut.Read(1)	
            Loop
            
            durch = False
            schleife = 0
            Do While schleife < 50
                If oExec.Status = 1 Then 
                    durch = True
                    Exit Do
                End If
                WScript.Sleep 100  
                schleife = schleife +1
            Loop
            
            If durch = False Then
                objWSHShell.LogEvent 2, "Mover.vbs: createnewjobfile TimeOut"
                refreshjob=False
            End If	
            rc = oExec.ExitCode
            Set oExec = Nothing
            
            If fs.FileExists(tempname & ".job") Then
                refreshjob=True
            Else
                refreshjob=False
            End If
        Else
            If fs.FileExists(programm & "createnewtemplate.exe") Then
                Set oExec= objWSHShell.Exec(Chr(34)&programm&"createnewtemplate.exe"&Chr(34)&" "&Chr(34)&profil&Chr(34)& " " &arcid& " " &Chr(34)&tempname&Chr(34))	
                durch = False
                schleife = 0
                Do While schleife < 50
                    If oExec.Status = 1 Then 
                        durch = True
                        Exit Do
                    End If
                    WScript.Sleep 100  
                    schleife = schleife +1
                Loop
                
                If durch = False Then
                    objWSHShell.LogEvent 1, "Mover.vbs: CreateNewTemplate TimeOut"
                    refreshjob=False
                End If	
                
                Set oExec = Nothing
                If fs.FileExists(tempname & ".tpl") Then
                    refreshjob=True
                Else
                    refreshjob=False
                End If
            Else
                errortxt="Mover.vbs: CreateNewTemplate.exe nicht vorhanden"
                objWSHShell.LogEvent 1, errortxt
                refreshjob=False
                Err.clear
            End If
        End If 
    End If
    
    If refreshjob=True Then	
        Set quelljobfile = fs.OpenTextFile(tempname&".job",1)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            refreshjob=False
        End If 
    End If
    
    If refreshjob=True Then
        If fs.FileExists(tempname&".tmp") Then
            fs.DeleteFile tempname& ".tmp", True
            If Err.number Then
                Err.clear
                errortxt="Zwischendatei fr Jobdatei existierte noch, kann diese aber nicht lschen."
                objWshShell.LogEvent 1, errortxt
                refreshjob=False
                quelljobfile.close
                Set quelljobfile=Nothing
            End If 
        End If	
    End If
    
    If refreshjob=True Then
        Set zieljobfile = fs.OpenTextFile(tempname&".tmp",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            refreshjob=False
            quelljobfile.close
            Set quelljobfile=Nothing
        End If 
    End If
    
    If refreshjob = True Then
        foundsha1=False
        stopflag=False
        ersatzstring=""	
        Do While quelljobfile.AtEndOfStream <> True
            kette=quelljobfile.readline
            ersatzstring=""
            
            If (Ausgabename<>"") And (InStr(1,kette,"Orginal=",1)<>0) Then
                ersatzstring="Orginal="&Ausgabename
            End If	
            
            If (Kopiename<>"") And (InStr(1,kette,"Kopie=",1)<>0) Then
                ersatzstring="Kopie="&kopiename
            End If	
            
            If (Quelle<>"") And (InStr(1,kette,"Quelle=",1)<>0) Then
                ersatzstring="Quelle="&Quelle
            End If
            
            If InStr(1,kette,"StatStr=",1)<>0 Then
                ersatzstring="StatStr=Dokumentendateien revisionssicher abgelegt."
            End If
            
            If (dokID<>"") And (InStr(1,kette,"DOCID=",1)<>0) Then
                ersatzstring="DOCID="&dokID
            End If
            
            If InStr(1,kette,"Benutzer=",1)<>0 Then
                ersatzstring="Benutzer="
            End If
            
            If InStr(1,kette,"Datum=",1)<>0 And InStr(1,kette,"SVN",1)=0 Then
                ersatzstring="Datum="
            End If		
            
            If InStr(1,kette,"Volltext=",1)<>0 Then
                ersatzstring="Volltext="
            End If	
            
            If InStr(1,kette,"Schlagworte=",1)<>0 Then
                ersatzstring="Schlagworte="
            End If
            
            If InStr(1,kette,"Status=",1)<>0 Then
                ersatzstring="Status="
            End If	
            
            If (InStr(1,kette,"Termin=",1)<>0) Then
                ersatzstring="Termin="
            End If
            
            If (InStr(1,kette,"Alarm=",1)<>0) Then
                ersatzstring="Alarm="
            End If
            
            If (InStr(1,kette,"Bearbeiter=",1)<>0) Then
                ersatzstring="Bearbeiter="
            End If
            
            If (InStr(1,kette,"Notiz=",1)<>0) Then
                ersatzstring="Notiz="
            End If	
            
            If (InStr(1,kette,"SVN_Link=",1)<>0) Then
                ersatzstring="SVN_Link="
            End If	
            
            If (InStr(1,kette,"SVN_Version=",1)<>0) Then
                ersatzstring="SVN_Version="
            End If	
            
            If (InStr(1,kette,"SVN_Revision=",1)<>0) Then
                ersatzstring="SVN_Revision="
            End If	
            
            If (InStr(1,kette,"SVN_Info=",1)<>0) Then
                ersatzstring="SVN_Info="
            End If	
            
            If (InStr(1,kette,"SVN_Datum=",1)<>0) Then
                ersatzstring="SVN_Datum="
            End If	
            
            If InStr(1,kette,"Sha1=",1)<>0 Then
                ersatzstring="Sha1="&sha1
                foundsha1= True
            End If
            
            If ersatzstring<>"" Then
                zieljobfile.writeline(ersatzstring)
            Else
                zieljobfile.writeline(kette)
            End If
        Loop
        
        If foundsha1 = False And opensslpath <> "" Then
            zieljobfile.WriteLine "[Hash]"
            zieljobfile.WriteLine "SHA1=" & sha1
        End If 
        
        quelljobfile.close
        Set quelljobfile = Nothing
        zieljobfile.close
        Set zieljobfile=Nothing
        WScript.sleep 20
        
        Err.clear
        fs.DeleteFile(tempname& ".job")
        If Err.number Then
            Err.clear
            errortxt="Fehler beim lschen der alten Jobdatei."
            objWshShell.LogEvent 1, errortxt
            refreshjob=False
        End If 
        
        WScript.sleep 20
        
        If refreshjob=True Then
            fs.CopyFile tempname&".tmp", tempname&".job", True
            If Err.number Then
                Err.clear
                errortxt="Fehler beim umkopieren Jobdatei."
                objWshShell.LogEvent 1, errortxt
                refreshjob=False
            End If 
        End If
        
        WScript.sleep 20
        If refreshjob=True Then
            fs.DeleteFile tempname& ".tmp", True
            If Err.number Then
                Err.clear
                errortxt="Fehler beim Lschen der Zwischen-Jobdatei."
                objWshShell.LogEvent 1, errortxt
                refreshjob=False
            End If 
        End If
    End If
    
End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function cleanup(Datei)
    On Error Resume Next
    Err.clear
    If fs.FileExists(datei) Then
        
        fs.DeleteFile Datei, True
        If Err.number<>0 Then
            objWshShell.LogEvent 1, "bitfarm-Archiv: Mover: Kann nicht aufrumen. "&Err.number
            Err.clear
            Unlock(lockdatei)
            WScript.Quit
        End If
    End If
End Function

Function sicher(Datei)
    On Error Resume Next
    sicher=""
    Err.clear
    If fs.FileExists(datei) Then
        Set movefile=fs.getfile(datei)	
        movefilename=movefile.name
        Set movefile=Nothing
        fs.copyfile datei, programm&"temp\"&movefilename, True
        
        If Err.number<>0 Then
            objWshShell.LogEvent 1, "bitfarm-Archiv: Mover: Kann nicht in temp-ordner verschieben. "&Err.number
            Err.clear
            Unlock(lockdatei)
            WScript.Quit
        End If
    End If
    
    If fs.FileExists(programm&"temp\"&movefilename) Then
        sicher=programm&"temp\"&movefilename
    End If
    
    
End Function

'***************************************************************************************

Function copygroup(oldposition,newfolder)
    On Error Resume Next
    Err.clear
    copygroup=True
    Set tempfile=fs.getfile(oldposition)
    basisname=Left(tempfile.name,Len(tempfile.name)-4)
    Set tempfile=Nothing
    oldfolder=Left(oldposition,Len(oldposition)-(Len(basisname)+4))
    Set folder=fs.getfolder(oldfolder)
    Err.clear
    
    '####################################### kopieren ##############################
    For Each file In folder.files
        'If Left(file.name,Len(file.name)-4)=basisname Then
        If InStr(1,file.name,basisname,1)<>0 Then
            
            'If fs.fileexists(newfolder&file.name) Then
            '	copygroup=false
            '	objWshShell.LogEvent 2, "bitfarm-Archiv: Mover: zu kopierende Datei existiert schon im Zielordner."
            'End If
            If copygroup=True Then
                fs.copyfile file, newfolder&file.name, True
                If Err.number Then 
                    objWshShell.LogEvent 1, "bitfarm-Archiv: Mover: Fehler beim Verschieben." & vbCrLf & file & vbCrLf & newfolder&file.Name & vbCrLf & Err.Description
                    Err.Clear
                    copygroup=False
                End If
                
            End If
            
        End If
    Next
    WScript.Sleep 20
    '###################################### verifizieren ################################
    If copygroup=True Then
        For Each file In folder.files
            If InStr(1,file.name,basisname,1)<>0 Then
                
                If Not fs.fileexists(newfolder&file.name) Then
                    copygroup=False
                    objWshShell.LogEvent 2, "bitfarm-Archiv: Mover: kopierte Dateien existieren nicht."
                End If
                
            End If
        Next
    End If
    
End Function


'***********************************Revisionssicher speichern*********************************
Function savegroup(oldposition,newfolder)
    On Error Resume Next
    Err.clear
    savegroup=True
    Set tempfile=fs.getfile(oldposition)
    basisname=Replace(tempfile.name,"." & fs.GetExtensionName(tempfile.name),"")
    
    Set tempfile=Nothing
    oldfolder=fs.GetParentFolderName(oldposition)&"\"
    Set folder=fs.getfolder(oldfolder)
    Err.clear
    
    '####################################### kopieren ##############################
    For Each file In folder.files
        'If Left(file.name,Len(file.name)-4)=basisname Then
        If (InStr(1,file.name,basisname,1)<>0) And LCase(Right(file.name,3)<>"iev") And (LCase(Right(file.name,3)<>"job")) Then
            
            'If fs.fileexists(newfolder&file.name) Then
            '	savegroup=false
            '	'objWshShell.LogEvent 2, "bitfarm-Archiv: Mover: zu kopierende Datei existiert schon im Zielordner."
            'End If
            If savegroup=True Then
                fs.copyfile file, newfolder&file.name, True
                If Err.number Then 
                    objWshShell.LogEvent 2, "bitfarm-Archiv: Mover: Fehler beim Speichern." & vbCrLf & file & vbCrLf & newfolder&file.Name & vbCrLf & Err.Description
                    Err.clear
                    savegroup=False
                End If
                
                
            End If
            
        End If
    Next
    WScript.Sleep 20
    
    '###################################### aktuelle job-Datei schreiben  ###############
    
    
    
    
    
    '###################################### verifizieren ################################
    If savegroup=True Then
        ftxt = ""
        If ursprung <> "" Then
            quelle = Replace(ursprung,oldfolder,newfolder)
        End If 
        
        For Each file In folder.files
            If InStr(1,file.name,basisname,1)<>0 Then
                testname=LCase(fs.GetExtensionName(file.Name))
                
                If testname <> "job" And testname <> "iev" Then
                    If Not fs.fileexists(newfolder&file.name) Then
                        savegroup=False
                        'objWshShell.LogEvent 2, "bitfarm-Archiv: Mover: kopierte Dateien existieren nicht."
                    End If
                End If 
            End If
        Next
    End If
    
End Function


'***************************************************************************************

Function Rollbackoperation(oldposition,newfolder)
    On Error Resume Next
    Err.clear
    Rollbackoperation=True
    'Set tempfile=fs.getfile(oldposition)
    'basisname=Left(tempfile.name,Len(tempfile.name)-4)
    'Set tempfile=nothing
    'oldfolder=Left(oldposition,Len(oldposition)-(Len(basisname)+4))
    'Set folder=fs.getfolder(oldfolder)
    'err.clear
    
    
    
    '####################################### lschen #################################
    
    'For each file in folder.files
    'If InStr(1,file.name,basisname,1)<>0 Then
    '	
    '	
    '	
    '	If fs.fileexists(newfolder&file.name) Then
    '		
    '		fs.deletefile newfolder&file.name, true
    '		If err.number Then 
    '			err.clear
    '			objWshShell.LogEvent 2, "bitfarm-Archiv: Mover: konnte kein Rollback durchfhren "&newfolder&file.name
    '		End If
    '	End If
    '
    '	
    '		
    '	
    '	
    'End If
    'Next
    
End Function


Function delfile(oldposition,newfolder)
    On Error Resume Next
    Err.clear
    delfile=True
    If fs.fileexists(oldposition) Then
        Set tempfile=fs.getfile(oldposition)
        basisname=Left(tempfile.name,Len(tempfile.name)-4)
        Set tempfile=Nothing
        oldfolder=Left(oldposition,Len(oldposition)-(Len(basisname)+4))
        Set folder=fs.getfolder(oldfolder)
        Err.clear
        '####################################### lschen #################################
        
        For Each file In folder.files
            If (InStr(1,file.name,basisname,1)<>0) And (LCase(Right(file.name,3)<>"iev")) Then
                If fs.fileexists(newfolder&file.name) Then
                    fs.deletefile file, True
                    If Err.number Then 
                        Err.clear
                        objWshShell.LogEvent 2, "bitfarm-Archiv: Mover: konnte in Dokumenten nicht aufrumen: "&file
                    End If
                End If
            End If
        Next
    End If
    
End Function


'***************************************************************************************
Function delsavedfile(oldposition,newfolder)
    On Error Resume Next
    Err.clear
    delsavedfile=True
    Set tempfile=fs.getfile(oldposition)
    basisname=Left(tempfile.name,Len(tempfile.name)-4)
    Set tempfile=Nothing
    oldfolder=Left(oldposition,Len(oldposition)-(Len(basisname)+4))
    Set folder=fs.getfolder(oldfolder)
    Err.clear
    '####################################### lschen #################################
    
    For Each file In folder.files
        If InStr(1,file.name,basisname,1)<>0 Then
            If fs.fileexists(newfolder&file.name) Then
                fs.deletefile file, True
                If Err.number Then 
                    Err.clear
                    objWshShell.LogEvent 2, "bitfarm-Archiv: Mover: konnte in Dokumenten nicht aufrumen: "&file
                End If
            End If
        End If
    Next
    
End Function

'***************************************************************************************

Function readconfig(profil)
    On Error Resume Next
    readconfig=True
    Err.clear
    
    If Not fs.FileExists(programm&profil&".con") Then
        Err.clear
        errortxt=profil&".con Datei nicht im Scriptpfad vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        readconfig=False
        Err.clear
    End If
    
    If readconfig=True Then	
        Set confile = fs.OpenTextFile(programm&profil&".con",1)
        If Err.number Then
            Err.clear
            errortxt="Profilfdatei nicht im Scriptpfad vorhanden oder nicht lesbar."
            objWshShell.LogEvent 1, errortxt
            Err.clear
            readconfig=False
            
        End If 
    End If
    
    If readconfig=True Then	
        kette=confile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        Do While Scriptsflag = 0
            kette=confile.readline
            Scriptsflag=InStr(1,kette,"[Scripts]")
            If confile.AtEndOfStream = True Then
                confile.close
                Set confile=Nothing
                scriptsflag=1
                errortxt="Fehler beim Lesen der CON-Datei - falsche Formatierung."
                objWshShell.LogEvent 1, errortxt
                readconfig = False
            End If
        Loop
    End If
    
    If readconfig = True Then
        Do While confile.AtEndOfStream <> True
            kette=confile.readline
            If Left(kette,1)<>";" Then
                
                If InStr(1,kette,"archivverzeichnis",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"archivverzeichnis",1)+17)
                    archivverzeichnis = wert
                End If
                
                If InStr(1,kette,"archivkopie",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"archivkopie",1)+11)
                    archivkopie = wert
                End If
            End If
        Loop
        confile.close
        Set confile = Nothing
    End If
    
End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function writejob(tempname)
    On Error Resume Next
    writejob=True
    Err.clear
    
    If Not (fs.FileExists(tempname&".MOVE") Or fs.FileExists(tempname&".MOVX")) Then
        Err.clear
        errortxt=tempname&".MOVE Datei nicht vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        writejob=False
        Err.clear
    End If
    
    If fs.FileExists(tempname&".MOVE") Then
        moveext=".MOVE"
    End If 
    
    If fs.FileExists(tempname&".MOVX") Then
        moveext=".MOVX"
    End If
    
    
    If writejob=True Then	
        Set quelljobfile = fs.OpenTextFile(tempname&moveext,1)
        If Err.number Then
            Err.clear
            errortxt="Kann Movedatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writejob=False
            
        End If 
    End If
    
    If writejob=True Then
        If fs.FileExists(tempname&".job") Then
            fs.DeleteFile(tempname& ".job")
            If Err.number Then
                Err.clear
                errortxt="Mover: Zwischendatei fr Jobdatei existierte noch, kann diese aber nicht lschen."
                objWshShell.LogEvent 1, errortxt
                writejob=False
                quelljobfile.close
                Set quelljobfile=Nothing
            End If 
            
        End If	
    End If
    
    If writejob=True Then
        Set zieljobfile = fs.OpenTextFile(tempname&".job",8,True)
        If Err.number Then
            Err.clear
            errortxt="Mover: Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writejob=False
            quelljobfile.close
            Set quelljobfile=Nothing
        End If 
    End If
    
    If writejob = True Then
        stopflag=False
        ersatzstring=""	
        Do While quelljobfile.AtEndOfStream <> True
            kette=quelljobfile.readline
            ersatzstring=""
            
            If (Ausgabename<>"") And (InStr(1,kette,"Orginal=",1)<>0) Then
                ersatzstring="Orginal="&Ausgabename
            End If	
            
            If (Kopiename<>"") And (InStr(1,kette,"Kopie=",1)<>0) Then
                ersatzstring="Kopie="&kopiename
            End If	
            
            If (Quelle<>"") And (InStr(1,kette,"Quelle=",1)<>0) Then
                ersatzstring="Quelle="&Quelle
            End If
            
            If InStr(1,kette,"StatStr=",1)<>0 Then
                ersatzstring="StatStr=Dokumentendateien umgelagert"
            End If
            
            If (Typ<>"") And (InStr(1,kette,"OCR_Typ=",1)<>0) Then
                ersatzstring="OCR_Typ="&Typ
            End If
            
            If ersatzstring<>"" Then
                zieljobfile.writeline(ersatzstring)
            Else
                zieljobfile.writeline(kette)
            End If
        Loop
        quelljobfile.close
        Set quelljobfile = Nothing
        zieljobfile.close
        Set zieljobfile=Nothing
        
    End If
    
End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function readjob(tempname)
    On Error Resume Next
    readjob=True
    Err.clear
    
    If Not fs.FileExists(tempname) Then
        Err.clear
        errortxt=tempname&"Anweisungsdatei nicht vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        readjob=False
        Err.clear
    End If
    
    If LCase(Right(tempname,4))="move" Then
        commandtype="moveanweisung"
    End If
    
    If LCase(Right(tempname,4))="movx" Then
        commandtype="moveanweisung"
        noworkflow = True
    End If
    
    If readjob=True Then	
        Set jobfile = fs.OpenTextFile(tempname,1)
        If Err.number Then
            Err.clear
            errortxt="Mover: Anweisungsdatei nicht vorhanden oder nicht lesbar."
            objWshShell.LogEvent 1, errortxt
            
            readjob=False
        End If 
    End If
    
    If readjob = True Then
        Do While jobfile.AtEndOfStream <> True
            kette=jobfile.readline
            kette = Replace(kette, " = ", "=")
            If Left(kette,1)<>";" Then
                If InStr(1,kette,"Profil=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Profil=",1)+7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Profil = wert
                        If LCase(Right(profil,4))=".con" Then
                            profil=Left(profil,Len(profil)-4)
                        End If
                    End If
                End If
                
                If InStr(1,kette,"OCR_Typ=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"OCR_Typ=",1)+8)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Typ = wert
                    Else
                        Typ = "OMP"	
                    End If
                End If
                
                If InStr(1,kette,"Name=",1)<>0 Then
                	wert = Right(kette, Len(kette)-5)
                    'wert=GetString(kette,InStr(1,kette,"Name=",1)+5)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Tabelle = wert
                    End If
                End If
                
                If InStr(1,kette,"Tabelle=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Tabelle=",1)+7))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        folderID = wert
                    End If
                End If
                
                If InStr(1,kette,"Kopie=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Kopie=",1)+6)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        oldkopieposition = wert
                    End If
                End If
                
                If InStr(1,kette,"Orginal=",1)<>0 Then
                    wert=Right(kette,Len(kette)-8)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        oldposition = wert
                    End If
                End If
                
                If InStr(1,kette,"Command=",1)<>0 Then
                    wert=Right(kette,Len(kette)-8)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        commandtype = LCase(wert)
                    End If
                End If
                
                If InStr(1,kette,"doc_loc=",1)<>0 Then
                    wert=Right(kette,Len(kette)-8)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        oldkopieposition = wert
                    End If
                End If
                
                If InStr(1,kette,"ori_loc=",1)<>0 Then
                    wert=Right(kette,Len(kette)-8)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        ursprung = wert
                    End If
                End If
                
                If Left(LCase(kette),6) = "docid=" Then
                    wert=Right(kette,Len(kette)-6)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        dokid = wert
                    End If
                End If
                
                If Left(LCase(kette),7) = "doc_id=" Then
                    wert=Right(kette,Len(kette)-7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        dokid = wert
                    End If
                End If
                
                If Left(LCase(kette),7) = "gdocid=" Then
                    wert=Right(kette,Len(kette)-7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        gdocid = wert
                    End If
                End If
                
                If InStr(1,kette,"Benutzer=",1)<>0 Then
                    wert=Right(kette,Len(kette)-9)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Benutzer = wert
                    End If
                End If
                
                If InStr(1,LCase(kette),"svn_link=",1)<>0 Then
                    wert=Right(kette,Len(kette)-9)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        svn_link = wert
                        dontmovesvn=True
                    End If
                End If
                If InStr(1,LCase(kette),"svn_version=",1)<>0 Then
                    wert=Right(kette,Len(kette)-12)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        svn_version = wert
                        dontmovesvn=True
                    End If
                End If
                If InStr(1,LCase(kette),"svn_revision=",1)<>0 Then
                    wert=Right(kette,Len(kette)-13)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        svn_revision = wert
                        dontmovesvn=True
                    End If
                End If
                If InStr(1,LCase(kette),"svninfo=",1)<>0 Then
                    wert=Right(kette,Len(kette)-8)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        svninfo = wert
                        dontmovesvn=True
                    End If
                End If
                If InStr(1,LCase(kette),"quelle=",1)<>0 Then
                    wert=Right(kette,Len(kette)-7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        quelle = wert
                    End If
                End If	
            End If
        Loop
        jobfile.close
        Set jobfile = Nothing
    End If
    
    If dokid <> "" Then
        arcid = Left(dokid, InStr(1,dokid,".")-1)
        strdocid = Right(dokid,Len(dokid)-InStr(1,dokid,"."))
    End If
    
End Function


'***************************************************************************************

Function readoldjob(tempname)
    On Error Resume Next
    readoldjob=True
    Err.clear
    
    If Not fs.FileExists(tempname) Then
        Err.clear
        errortxt=tempname&".alte Jobdatei nicht vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        readoldjob=False
        Err.clear
    End If
    
    If readoldjob=True Then	
        Set jobfile = fs.OpenTextFile(tempname,1)
        If Err.number Then
            Err.clear
            errortxt="Mover: alte Jobdatei nicht vorhanden oder nicht lesbar."
            objWshShell.LogEvent 1, errortxt
            
            readoldjob=False
            
        End If 
    End If
    
    
    If readoldjob = True Then
        Do While jobfile.AtEndOfStream <> True
            kette=jobfile.readline
            If Left(kette,1)<>";" Then
                
                If InStr(1,kette,"OCR_Typ=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"OCR_Typ=",1)+8)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        
                        Typ = wert
                    Else
                        Typ = "OMP"	
                    End If
                End If
            End If
            
        Loop
        jobfile.close
        Set jobfile = Nothing
    End If
    
End Function


'********************************************************************************
'********************************************************************************
'********************************************************************************


Function inilesen()
    On Error Resume Next
    Err.clear
    Set inifile = fs.OpenTextFile(programm&"scripts.ini",1)
    If Err.number Then
        objWshShell.LogEvent 1, "scripts.ini nicht im Scriptpfad vorhanden oder nicht lesbar."
        Err.clear
        Unlock(lockdatei)
        WScript.Quit
    End If 
    
    kette=inifile.readline
    Scriptsflag=InStr(1,kette,"[Scripts]")
    Do While Scriptsflag = 0
        kette=inifile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        If inifile.AtEndOfStream = True Then
            inifile.close
            objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - falsche Formatierung."
            Unlock(lockdatei)
            WScript.Quit
        End If
    Loop
    
    
    Do While inifile.AtEndOfStream <> True
        kette=inifile.readline
        If Left(kette,1)<>";" Then
            
            If InStr(1,kette,"Profil",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"Profil",1)+7)
                If profil="" Then
                    profil = wert
                End If
            End If		
            
            If InStr(1,kette,"MSWordinstalled",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"MSWordinstalled",1)+16)
                If LCase(wert)="true" Then
                    acceptdoc = True
                End If	
            End If
            
            If InStr(1,kette,"MSExcelinstalled",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"MSExcelinstalled",1)+17)
                If LCase(wert)="true" Then
                    acceptxls = True
                End If	
            End If
            
            If InStr(1,kette,"MSPowerPointinstalled",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"MSPowerPointinstalled",1)+22)
                If LCase(wert)="true" Then
                    acceptppt = True
                End If	
            End If
            
            
            If InStr(1,kette,"opensslpath",1)<>0 Then
                wert = Right(kette,Len(kette) -12)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    opensslpath=Trim(wert)
                End If
            End If
        End If
        
    Loop
    inifile.close
    Set inifile = Nothing
    If programm="" Then
        objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - kein Programmpfad."
        Unlock(lockdatei)
        WScript.Quit
    End If
    
    
End Function

'********************************************************************************
'********************************************************************************
'********************************************************************************

Function dbimp(Datei)
    On Error Resume Next
    
    If scriptdebug=True Then
        objWshShell.LogEvent 4, "Mover.vbs Function dbimp_neu: Datei " & Datei
    End If
    dokid = 0
    wfid=0
    Do While dokid = 0 And wfid = 0 
        
        strinput = ""
        schleife = 0
        
        Beginn = Timer
        ' > c:\bitfarm-archiv\garbage\dbimp.log
        Set oExec    = objWSHShell.Exec(Chr(34)&programm&"DBImpV3.exe"&Chr(34)&" "&Chr(34)&Datei&".job"&Chr(34))
        
        Do While Not oExec.StdOut.AtEndOfStream
            strinput = strinput & oExec.StdOut.Read(1)	
        Loop
        
        durch = False
        schleife = 0
        Do While schleife < 50
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 100  
            schleife = schleife +1
        Loop
        Ende = Timer
        
        If durch = False Then
            objWshShell.LogEvent 1, "Mover.vbs Function dbimp: Schwerwiegender Fehler" & vbCrLf & "dbimpV3.exe antwortet nicht oder wird nicht beendet" & vbCrLf & "Status: " & oExec.Status & vbCrLf & "Exitcode " & oExec.ExitCode & vbCrLf & "Schleife: " & schleife
            returnvalue=100
            oExec.Terminate
            Exit Do
        Else
            returnvalue = oExec.ExitCode
        End If
        
        If scriptdebug=True Then
            objWshShell.LogEvent 4, "Mover.vbs Function dbimp: dbimpV3.exe ausgefhrt" & vbCrLf & "Status: " & oExec.Status & vbCrLf & "Exitcode " & oExec.ExitCode & vbCrLf & "Schleife: " & schleife &vbCrLf& strinput
            
        End If
        
        'strinput = LCase(strinput)
        
        If (InStr(1,strinput,"DokID:") <> 0) Or (InStr(1,strinput,"DocID:") <> 0) Then
            If InStr(1,strinput,"DokID:") <> 0 Then
                strdokid = Right(strinput,Len(strinput)-InStr(1,strinput,"DokID:")-5)
            Else
                strdokid = Right(strinput,Len(strinput)-InStr(1,strinput,"DocID:")-5)
            End If
            
            strdokid = Left(strdokid,InStr(1,strdokid,Chr(13))-1)
            DokID = strdokid	
        End If
        
        If InStr(1,strinput,"WfID:") <> 0 Then
            strwfid = Right(strinput,Len(strinput)-InStr(1,strinput,"WfID:")-4)
            strwfid = Left(strwfid,InStr(1,strwfid,Chr(13))-1)
            wfID = strwfid
        End If
        
        If Not IsNumeric(strdokid) Then
            returnvalue = 101
        End If
        If returnvalue <>0 Then Exit Do
    Loop	
    
    If InStr(1,LCase(strinput),"erfolgreich" )<> 0 Then
        exec_dbimp = "DbImpV3 erfolgreich in " & Ende - Beginn
    Else
        If InStr(1,LCase(strinput),"fehler" )<> 0 Then
            exec_dbimp = "DbImpV3 Fehler in " & Ende - Beginn
            objWshShell.LogEvent 1, "Mover.vbs Function dbimp: dbimpV3.exe meldet einen Fehler:" & vbCrLf & strinput
            
        Else
            exec_dbimp = " DbImpV3 unbekannte Rckmeldung " & Ende - Beginn
        End If
    End If
    
    If logging = True Then
        
        If fs.FileExists(programm&"mover_dbimp.log") Then
            Set mydebugfile = fs.getFile(programm&"mover_dbimp.log")
            dlm = mydebugfile.DateCreated
            Set mydebugfile = Nothing
            If DateDiff("d", Now(),dlm) > 2 Then
                fs.deletefile programm&"mover_dbimp.log", True
                
                WScript.Sleep 200
            End If
        End If
        
        
        If Not (fs.fileexists(programm & "mover_dbimp.log")) Then
            Set outfile = fs.CreateTextFile(programm & "mover_dbimp.log")
            outfile.close
        End If
        Set outfile = fs.OpenTextFile(programm & "mover_dbimp.log",8)	
        outfile.Writeline "Mover.vbs --- " & Now()
        outfile.Writeline strinput 
        outfile.Writeline exec_dbimp
        outfile.WriteLine "Durchlauf:" & Schleife
        outfile.WriteLine "Datei:" & datei
        outfile.WriteLine 
        If fs.fileexists(Datei&".job") Then
            outfile.WriteLine "Inhalt der Jobdatei:"
            outfile.WriteLine "---------------------------------------------------"
            Set myjobfile = fs.OpenTextFile(Datei&".job",1)
            Do While myjobfile.atendofstream=False
                kette=myjobfile.readline
                outfile.writeline(kette)
            Loop
            myjobfile.close
            Set myjobfile=Nothing
            outfile.WriteLine "---------------------------------------------------"
            outfile.WriteLine 
        End If
        outfile.close		
        
        objWshShell.LogEvent 4, "Mover.vbs Function dbimp: retval " & returnvalue & vbCrLf & strinput
        Set outfile = Nothing
    Else
        If returnvalue <> 0 Then
            objWshShell.LogEvent 1, "Mover.vbs Function dbimp: retval " & returnvalue & vbCrLf & strinput
        End If
    End If
    
    Set oExec = Nothing
    dbimp=returnvalue
End Function

'********************************************************************************
'********************************************************************************
'************************************ lock lschen ***********************************

Function Unlock(lockfileandpath)
    On Error Resume Next
    'unsetmovelockvar
    
    Err.clear
    On Error Resume Next
    If fs.fileexists(lockfileandpath) Then
        fs.DeleteFile lockfileandpath, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            WScript.Sleep 430
            fs.DeleteFile lockfileandpath, True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                WScript.Sleep 530
                fs.DeleteFile lockfileandpath, True
                If Err.number<>0 Then
                    Err.clear
                    On Error Resume Next
                    objWshShell.LogEvent 2, "mover: Warnung: konnte lockdatei nicht lschen:"&lockfileandpath
                End If
            End If
        End If
    End If
    
    If scriptdebug = True Then
        objWshShell.LogEvent 4,"Mover.vbs: Unlock ausgefhrt fr Datei:" & datei
    End If
    
End Function



'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function setdokdate()
    On Error Resume Next
    Jahr = DatePart("yyyy",Date)
    Monat = DatePart("m",Date)
    Tag = DatePart("d",Date)
    Stunde = DatePart("h",Time)
    Minuten = DatePart("n",Time)
    Sekunde = DatePart("s", Time)
    If Len(Monat)=1 Then 
        monat="0"&monat
    End If
    If Len(tag)=1 Then 
        tag="0"&tag
    End If
    If Len(stunde)=1 Then 
        stunde="0"&stunde
    End If
    If Len(minuten)=1 Then 
        minuten="0"&minuten
    End If
    If Len(sekunde)=1 Then 
        sekunde="0"&sekunde
    End If
    setdokdate = Jahr&"-" & Monat & "-" & Tag & " " & Stunde & ":" & Minuten & ":" & Sekunde
End Function

'***************************************************************************************
'***************************************************************************************
'***************************************************************************************
'**************************************************************************************
'**************************************************************************************



Function Zufallszahl(von, bis)
    On Error Resume Next
    anzahl = bis-von+1
    Randomize
    Zufallszahl = Fix(Rnd*(anzahl))+von
End Function

Private Function StrConvert(String)
    On Error Resume Next
    wert1=0
    l = Len(String)
    
    For x = 1 To l
        wert1=wert1+((Asc(Mid(String,x,1))-48)*(10^(l-x)))
    Next
    StrConvert=wert1
End Function


Private Function GetString(kette,pos)
    On Error Resume Next
    zeichen=""
    ergebnis=""
    index=0
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (zeichen<>"	") And (index<80)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,pos+index,1)
        index=index+1
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=")) And (ergebnis="") Then
            zeichen=""
        End If
    Loop
    Trim(ergebnis)
    GetString=ergebnis
End Function


Function RegRead(tempkey)
    privkey = tempkey
    
    RegRead = objWSHShell.RegRead(privkey)
    If Not Err.number=0 Then
        objWshShell.LogEvent 1, "Fehler: Registrierungsschlssel nicht gesetzt."
        RegRead=""
        Err.clear
        Unlock(lockdatei)
        WScript.Quit
    End If
End Function


Private Function Pruefsumme(Datei)
    On Error Resume Next
    
    If opensslpath <> "" Then
        
        If fs.FileExists(opensslpath) Then
            strinput = ""
            Set oExec = objWSHShell.Exec(Chr(34)&opensslpath & Chr(34)&" dgst -sha1 " & Chr(34)&Datei&Chr(34) )
            Do While Not oExec.StdOut.AtEndOfStream
                strinput = strinput & oExec.StdOut.ReadAll
            Loop
            
            durch = False
            schleife = 0
            Do While schleife < 50
                If oExec.Status = 1 Then 
                    durch = True
                    Exit Do
                End If
                
                WScript.Sleep 100  
                schleife = schleife +1
            Loop
            
            If durch = False Or oExec.ExitCode <> 0 Then
                objWSHShell.LogEvent 1, "Mover.vbs: konnte sha1 Summe nicht erzeugen" & vbCrLf & Datei & vbCrLf & strinput
            Else
                If InStr(1,strinput,"=") Then
                    Pruefsumme = Trim(Right(strinput,Len(strinput) - InStr(1,strinput,"=")))
                    If InStr(1,Pruefsumme, Chr(10)) Then
                        Pruefsumme = Replace(Pruefsumme,Chr(10),"")
                    End If 
                End If 
            End If
            
        Else
            objWSHShell.LogEvent 1, "Mover.vbs: konnte openssl nicht finden" & vbCrLf & opensslpath 
            Pruefsumme=""
        End If 
    End If
    
End Function

'********************************************************************************
'********************************************************************************
'********************************************************************************
'********************************************************************************


Function getmovelockvar
    On Error Resume Next
    getmovelockvar=0
    
    Set WshEnv = objWSHShell.Environment("System")
    
    getmovelockvar = WshEnv("movelock")
    
    
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
    End If
    
    Set WshEnv=Nothing
    
End Function

Function setmovelockvar
    On Error Resume Next
    Set WshEnv = objWSHShell.Environment("System")
    WshEnv.Item("movelock") = 1
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
    End If
    Set WshEnv=Nothing
End Function

Function unsetmovelockvar
    On Error Resume Next
    Set WshEnv = objWSHShell.Environment("System")
    WshEnv.Item("movelock") = 0
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
    End If
    Set WshEnv=Nothing
End Function



'********************************************************************************
'********************************************************************************
'********************************************************************************

'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'************************************   Ende    ***************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
