'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'***************  movetobitfarm.vbs   GPL  *************************************************
'*******************************************************************************************
'***************  Version 3.6.2.0          *************************************************
'*******************************************************************************************
'***************  Nimmt Dateien entgegen (sendto, Drag&Drop)                 ***************
'***************  und bergibt diese zur Archivierung an den                 ***************
'***************  Server. Lscht danach die Quelldateien.                    ***************
'***************                                                             ***************
'***************  Syntax: wscript <server-programmpfad>movetobitfarm.vbs     ***************
'***************  <Datei(en)>                                                ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************

'*******************************************************************************************
'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************


scriptdebug = False

On Error Resume Next

Dim objWSHShell
Dim oArgs
Dim lngReturnCode
lngReturnCode = 0

Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set fs      = WScript.CreateObject("Scripting.FileSystemObject") 
Set oArgs    = WScript.Arguments 

'*******************************************************************************************
'**************************  eventlog auf 'Ereignisse berschreiben setzen' ****************
'
Err.clear
fullpath = WScript.ScriptFullName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
scriptname = WScript.ScriptName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
If Len(programm)=0 Then
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If

importobject = oArgs.item(0)

objcount = oArgs.Count
cmd = Chr(34) &programm&"ViewerV3.exe" &Chr(34)
arg = ""
For i = 0 To objcount-1 
	importobject = oArgs.Item(i)
	If fs.FileExists(importobject) Then
		If scriptdebug=True Then
			objWSHShell.LogEvent 1, "movetobitfarm.vbs import file " & importobject
		End If
		
		' Kommandozeilenbeschrnkung von 2047 Zeichen umgehen, in dem wir mehrmals an den Viewer senden
		If Len(cmd & arg) + Len(importobject) > 2000 Then
			If scriptdebug=True Then
				objWSHShell.LogEvent 1, "movetobitfarm.vbs Starting ViewerV3.exe:" & vbCrLf & cmd & arg
			End If
			
			lngReturnCode = objWSHShell.Run(cmd & arg, 1, True)
			
			If lngReturnCode <> 0 Then
				objWSHShell.LogEvent 1, "movetobitfarm.vbs starting ViewerV3.exe:" & vbCrLf & arg & vbCrLf & vbCrLf & "error while importing, ViewerV3.exe returncode " & lngReturnCode
				MsgBox("error while importing, ViewerV3.exe returncode " & lngReturnCode)
			End If
			arg = ""   ' zurcksetzen, Schleife fortfahren lassen
		End If
		
		If arg = "" Then
			arg = arg & " -FD:" & Chr(34) & importobject & Chr(34)
		Else
			arg = arg & "|" & Chr(34) & importobject & Chr(34)
		End If 
	ElseIf fs.FolderExists(importobject) Then
		If scriptdebug=True Then
			objWSHShell.LogEvent 1, "movetobitfarm.vbs import folder " & importobject
		End If
		
		' Kommandozeilenbeschrnkung von 2047 Zeichen umgehen, in dem wir mehrmals an den Viewer senden
		If Len(cmd & arg) + Len(importobject) > 2000 Then
			If scriptdebug=True Then
				objWSHShell.LogEvent 1, "movetobitfarm.vbs Starting ViewerV3.exe:" & vbCrLf & cmd & arg
			End If
			
			lngReturnCode = objWSHShell.Run(cmd & arg, 1, True)
			
			If lngReturnCode <> 0 Then
				objWSHShell.LogEvent 1, "movetobitfarm.vbs starting ViewerV3.exe:" & vbCrLf & arg & vbCrLf & vbCrLf & "error while importing, ViewerV3.exe returncode " & lngReturnCode
				MsgBox("error while importing, ViewerV3.exe returncode " & lngReturnCode)
			End If
			arg = ""   ' zurcksetzen, Schleife fortfahren lassen
		End If
		
		arg = arg & " -DD:" & Chr(34) & importobject & Chr(34)
	End If
Next

arg = cmd & arg
If scriptdebug=True Then
	objWSHShell.LogEvent 1, "movetobitfarm.vbs Starting ViewerV3.exe:" & vbCrLf & arg
End If

lngReturnCode = objWSHShell.Run(arg, 1, True)

If lngReturnCode <> 0 Then
	objWSHShell.LogEvent 1, "movetobitfarm.vbs starting ViewerV3.exe:" & vbCrLf & arg & vbCrLf & vbCrLf & "error while importing, ViewerV3.exe returncode " & lngReturnCode
	MsgBox("error while importing, ViewerV3.exe returncode " & lngReturnCode)
End If



