'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'***************  officeimport.vbs   GPL  **************************************************
'*******************************************************************************************
'***************  Version 3.6.2.1         **************************************************
'*******************************************************************************************
'***************  Nimmt Officedokumente entgegen                             ***************
'***************  und bergibt diese zur Archivierung an den                 ***************
'***************  Server.                                                    ***************
'***************                                                             ***************
'***************  wird direkt aus Office ber Makro gestartet.               ***************
'***************                                                             ***************
'***************                                                             ***************
'***************  Syntax: wscript <server-programmpfad>officeimport.vbs      ***************
'***************  <Datei(en)>                               	             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************

Profil=""
popupoffice=True

'*******************************************************************************************
'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

On Error Resume Next

Dim objWSHShell, fso, FileIn, FileOut 
Dim Datei, Text, Txt, i, arrSort, arrTest(), oArgs, Druckername
Dim lngReturnCode

ReDim ext(60)

lngReturnCode = 0

Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set fs      = WScript.CreateObject("Scripting.FileSystemObject") 
Set oArgs    = WScript.Arguments 


clientprogramm=""
uncclientspooler="" 
archivverzeichnis=""
archivkopie=""
zahl=0
officequickimport=False
Typ=""

For i=0 To 59
    ext(i)="...."
Next

extcounter=0

acceptdoc=True
acceptxls=True
acceptdwg=True
acceptppt=True
acceptallfiletypes=False
MSOffice2007installed=False
openofficepath=""

'*******************************************************************************************
'**************************  eventlog auf 'Ereignisse berschreiben setzen' ****************
'

strComputer = "."
Set objWMIService = GetObject("winmgmts:" _
& "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")

Set objInstalledLogFiles = objWMIService.ExecQuery _
("Select * from Win32_NTEventLogFile Where LogFilename = 'Application'")

For Each objLogfile In objInstalledLogFiles
    
    If objLogfile.OverWriteOutdated <> 0 Then
        objLogfile.OverWriteOutdated = 0 
        objLogFile.Put_
    End If
    If Err.Number <> 0 Then
        objWSHShell.LogEvent 1, "Achtung ! Im Eventlog des Clients ist nicht die Option 'Eintrge bei Bedarf berschreiben' gesetzt. Logging und Scriptdebug werden daher ausgeschaltet." 
        scriptdebug = False
        logging = False
        Err.Clear
        On Error Resume Next
    End If
    
Next

Set objLogfile = Nothing
Set objInstalledLogFiles = Nothing
Set objWMIService = Nothing




'*******************************************************************************************
'**************************  Startparameter initialisieren  ********************************
Err.clear
fullpath = WScript.ScriptFullName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
scriptname = WScript.ScriptName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
If Len(programm)=0 Then
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If

inilesen

If openofficepath <> "" Then
    acceptdoc=True
    acceptxls=True
    acceptppt=True
    
End If



If InStr(openofficepath,"3") <> 0 Or InStr(openofficepath,"4") <> 0 Then
    MSOffice2007installed = True
End If


ext(0)=".tif"
ext(1)=".ps"
ext(2)=".pdf"
ext(3)=".bmp"
ext(4)=".jpg"
ext(5)=".gif"

extcounter=6

If acceptdoc=True Then
    ext(extcounter)=".doc"
    ext(extcounter+1)=".rtf"
    ext(extcounter+2)=".htm"
    ext(extcounter+3)=".txt"
    extcounter=extcounter+4
End If

If acceptxls=True Then
    ext(extcounter)=".xls"
    ext(extcounter+1)=".dbf"
    ext(extcounter+2)=".tab"
    extcounter=extcounter+3
End If

If acceptppt=True Then
    ext(extcounter)=".ppt"
    ext(extcounter+1)=".pps"
    extcounter=extcounter+2
End If

If acceptdwg=True Then
    ext(extcounter)=".dwg"
    ext(extcounter+1)=".dxf"
    extcounter=extcounter+2
    
End If

If MSOffice2007installed=True Then
    ext(extcounter)=".docx"
    ext(extcounter+1)=".docm"
    ext(extcounter+2)=".dotx"
    ext(extcounter+3)=".dotm"
    ext(extcounter+4)=".xlsx"
    ext(extcounter+5)=".xlsm"
    ext(extcounter+6)=".xltx"
    ext(extcounter+7)=".xltm"
    extcounter=extcounter+8
    
End If

If openofficepath<>"" Then
    ext(extcounter)=".docx"
    ext(extcounter+1)=".docm"
    ext(extcounter+2)=".dotx"
    ext(extcounter+3)=".dotm"
    ext(extcounter+4)=".xlsx"
    ext(extcounter+5)=".xlsm"
    ext(extcounter+6)=".xltx"
    ext(extcounter+7)=".xltm"
    ext(extcounter+8)=".odt"
    ext(extcounter+9)=".ods"
    ext(extcounter+10)=".odp"
    ext(extcounter+11)=".odf"
    ext(extcounter+12)=".odg"
    ext(extcounter+13)=".odb"
    ext(extcounter+14)=".ott"
    ext(extcounter+15)=".ots"
    ext(extcounter+16)=".otp"
    ext(extcounter+17)=".otg"
    
    extcounter=extcounter+18
    
    
End If


temppath = objWSHShell.ExpandEnvironmentStrings("%temp%")    

If Err.number<>0 Then
    MsgBox("bitfarm-Archiv: Fehler: Kann TEMP-Variable nicht auswerten.")
    Err.clear
    WScript.Quit
End If 
username = objWSHShell.ExpandEnvironmentStrings("%username%")    
If Err.number<>0 Then
    MsgBox("bitfarm-Archiv: Fehler: Kann USERNAME-Variable nicht auswerten.")
    Err.clear
    WScript.Quit
End If 

If (Len(username)<1) Or (username="%username%") Or (username="") Then
    username="unbekannt"
End If


tempfile=temppath&"\temp.tif"
dokdate=""

If fs.fileexists(temppath&"\Lock") Then
    a=0
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    If Err.number<>0 Then
        Err.clear
        MsgBox("Fehler: kein Microsoft WMI installiert. Bitte nachinstallieren.")
        WScript.Quit
    End If
    strQuery = "Select * from Win32_Process where Name='wscript.exe'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    For Each objItem In colItems
        a=a+1
    Next
    Set colItems=Nothing
    Set objWMIService=Nothing
    If a>1 Then
        
        
        frage = "Es luft zur Zeit bereits eine Datenbertragung an den Archivserver. Bitte versuchen Sie es in einigen Minuten noch einmal. Sollte diese Meldung stets wiederkommen, informieren Sie den Netzwerkadministrator."
        ueberschrift = "bitfarm-Archiv Import"
        antwort = objWSHShell.Popup(frage,, ueberschrift, vbExclamation)
        WScript.Quit
        
        'abbruch=false
        'Do While abbruch=false
        'WScript.Sleep 1000
        'If not fs.fileexists(temppath&"\Lock") Then
        '	abbruch=true
        'End If
        'If abbruch=true Then
        '	zahl=Zufallszahl(1000,5000)
        '	WScript.Sleep zahl
        '	If fs.fileexists(temppath&"\Lock") Then
        '		abbruch=false
        '	End If
        'End If
        'loop
        
    Else
        fs.deletefile temppath&"\Lock", True
    End If
    
End If



'*******************************************************************************************
'**************************  Prfen, ob Server bereit  *************************************


erfolg=readconfig(Profil)
If erfolg=False Then
    MsgBox("bitfarm-Archiv: Kann Konfigurationsdatei nicht lesen ("&Profil&")")
    WScript.Quit
End If

druckpfad = uncclientspooler 

zahl = Zufallszahl(100000,999999)


'*******************************************************************************************
'**************************  Parameterbergabe  *******


datei=oArgs.item(0)
If Err.number<>0 Then
    Err.clear
    WScript.quit
End If

oldname=oArgs.item(1)
If Err.number<>0 Then
    Err.clear
    On Error Resume Next
End If

'*******************************************************************************************
'**************************  Alle Jobdateien lschen, die evtl. noch vorhanden sind  *******

i=0
Set folder = fs.GetFolder(temppath)
For Each file In folder.files
    
    If (Right(file,3) = "job") Or (Right(file,3) = "JOB") Then
        Err.clear
        fs.DeleteFile file, True
        If Err.number<>0 Then
            MsgBox("bitfarm-Archiv: Kein Schreibzugriff auf das TEMP-Verzeichnis. Bitte informieren Sie Ihren Administrator.")
            Err.clear
            WScript.Quit
        End If
    End If
Next


'**************************************************************************************************
'******************************************   Zielabfrage   ***************************************
'**************************************************************************************************


'lngReturnCode = objWSHShell.Run(programm&"QimpV3.exe "&programm&profil&".con "&tempfile,1,true)
'wscript.Sleep 300
'If lngReturnCode <> 0 Then
'	'MsgBox("bitfarm-Archiv: Allgemeiner Fehler bei Parameterbergabe.")
'	WScript.Quit
'End If

paramstr="" 
If oldname<>"" Then
    paramstr="-D:" & Chr(34) & oldname & Chr(34)
Else
	oldname = fs.GetBaseName(Datei)
End If


extension = "." & fs.GetExtensionName(datei)
basedir = fs.GetParentFolderName(Datei)

importfoldername = temppath & "\" & "bfa-import" 
importfoldername = importfoldername & Zufallszahl(100000,999999)

While fs.FolderExists(importfoldername)
	importfoldername = importfoldername & Zufallszahl(100000,999999)
Wend

Set importfolder = fs.CreateFolder(importfoldername)
realfilename = importfoldername &"\"&oldname&extension

fs.MoveFile Datei, realfilename
myname = fs.GetBaseName(realfilename)
createimportjob(fs.GetFile(realfilename))

arg = Chr(34) &programm& "ViewerV3.exe" &Chr(34)& " -DD:" &Chr(34)& importfolder &Chr(34)

If scriptdebug=True Then
	objWSHShell.LogEvent 1, "officeimport.vbs Starting ViewerV3.exe:" & vbCrLf & arg
End If

lngReturnCode = objWSHShell.Run(arg, 1, False)

'lngReturnCode = objWSHShell.Run(Chr(34)& programm&"ImporterV3.exe" &Chr(34)& " "&Chr(34)& programm&profil&".con" &Chr(34)& " " & paramstr,1,True)

WScript.Quit


WScript.Sleep 300
If lngReturnCode <> 0 Then
    'MsgBox("bitfarm-Archiv: Allgemeiner Fehler bei Parameterbergabe.")
    WScript.Quit
End If


'**************************************************************************************************
'*******************************    Jobdatei suchen   *********************************************
'**************************************************************************************************
template=""
Set folder = fs.GetFolder(temppath)
For Each file In folder.files
    
    If (Right(file,3) = "job") Or (Right(file,3) = "JOB") Then
        template=file
    End If
Next
Set folder = Nothing

If template<>"" Then
    Set tempobject=fs.getfile(template)
    templatename=tempobject.name
    Set tempobject=Nothing
    templatename=Left(templatename,Len(templatename)-4)
Else
    WScript.quit
End If

'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************

Profil=""

erfolg=readjob(template)
If erfolg=False Then
    MsgBox("bitfarm-Archiv: Kann zum angegebenen Archiv kein Template finden ("&template&")")
    WScript.Quit
End If

erfolg=readconfig(Profil)
If erfolg=False Then
    MsgBox("bitfarm-Archiv: Kann Konfigurationsdatei nicht lesen ("&Profil&")")
    WScript.Quit
End If

druckpfad = uncclientspooler 

If druckpfad="" Then
    MsgBox("bitfarm-Archiv: Fehler: Konnte keinen bergabepfad zum Server bestimmen.")
    WScript.Quit
End If


'If (Typ <> "TXT") AND (Typ <> "OCR") AND (Typ <> "OMP") Then
'	MsgBox("Falscher Texterkennungstyp. Bitte Script autoscan.vbs prfen.")
'	WScript.Quit
'End If

'*******************************************************************************************
'************************************ Parameter in Jobdatei  *******************************
dokdate=setdokdate()
erfolg = writejob(Left(template,Len(template)-4))
If erfolg=False Then
    MsgBox("bitfarm-Archiv: kann Parameter nicht in Jobdatei schreiben - kann nicht archivieren. Bitte informieren Sie den Administrator.")
    WScript.Quit
End If




'*******************************************************************************************
'*******************************************************************************************
'*************************************************************************************
'**************************   Parameterbergabe und Hauptschleife ********************
'************************************************************************************* 

On Error Resume Next
Err.clear


If fs.fileexists(Datei) Then
    showmsg
    archfile(Datei)
End If



'**************************************************************************************************
'*************************************  aufrumen und Ende  ***************************************
'**************************************************************************************************


Set folder = fs.GetFolder(temppath)
For Each file In folder.files
    
    
    
    If (LCase(Right(file,3)) = "job") Or (LCase(Right(file,3)) = "slx") Or (LCase(Right(file,3)) = "slw") Or (LCase(Right(file,3)) = "vtx") Then
        Err.clear
        fs.deletefile file, True
        Err.clear
    End If
    
    
Next
Set folder = Nothing

WScript.sleep 1000
removemsg()
If popupoffice=True Then
    
    'checkfeedback
    lngReturnCode = objWSHShell.Run(Chr(34) & programm&"checkfeedback.vbs" & Chr(34) & " "& zahl,1,False)
    WScript.Sleep 300
    If lngReturnCode <> 0 Then
        'MsgBox("bitfarm-Archiv: Allgemeiner Fehler bei Parameterbergabe.")
        WScript.Quit
    End If
    
    
    
    
    
End If




WScript.Quit


'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************

Function archfolder(datei)
    On Error Resume Next
    Set ordner=fs.getfolder(datei)
    For Each file In ordner.files
        archfile(file)
    Next
    For Each unterordner In ordner.subfolders
        archfolder(unterordner)
    Next
    Set ordner=Nothing
End Function

Function archfile(Datei)
    On Error Resume Next
    
    If fs.GetExtensionName(datei)<>"" Then
        extension = "." & fs.GetExtensionName(datei)
        extension = LCase(extension)
    End If
    
    u=0
    
    Do While u<=extcounter
        
        If extension=ext(u) Then
            writeslwdatei(datei)
            sendtoserver(Datei)
            dateianzahl=dateianzahl+1
            u=10000
        End If
        u=u+1
    Loop
    
    
End Function


Function sendtoserver(datei)
    On Error Resume Next
    
    sendtoserver=False
    zahl = Zufallszahl(100000,999999)
    If officequickimport=True Then
        Ausgabename=druckpfad&"fast"&zahl
    Else
        Ausgabename=druckpfad&"file"&zahl
    End If
    
    If fs.FileExists(Ausgabename&".job") Then
        zahl = Zufallszahl(100000,999999)
        If officequickimport=True Then
            Ausgabename=druckpfad&"fast"&zahl
        Else
            Ausgabename=druckpfad&"file"&zahl
        End If
        
        If fs.FileExists(Ausgabename&".job") Then
            zahl = Zufallszahl(100000,999999)
            If officequickimport=True Then
                Ausgabename=druckpfad&"fast"&zahl
            Else
                Ausgabename=druckpfad&"file"&zahl
            End If
            
            WScript.Sleep 1500
            If fs.FileExists(Ausgabename&".job") Then
                removemsg()
                MsgBox("bitfarm-Archiv: Fehler: Serverdienst reagiert nicht.")
                objWshShell.LogEvent 1, "bitfarm-Archiv: Officeimport.vbs:"&vbCrLf&"Server leert nicht den bergabepfad. Kann nicht archivieren."&vbCrLf&Ausgabename & ".job"
                WScript.Quit
            End If
        End If
        
    End If
    
    
    
    'sendtoserver=false
    'zahl = Zufallszahl(100000,999999)
    ''Ausgabename=druckpfad&"file"&zahl
    'Ausgabename=druckpfad&"fast"&zahl
    'If fs.FileExists(Ausgabename&".job") Then
    '	Wscript.Sleep 1500
    '	If fs.FileExists(Ausgabename&".job") Then
    '		MsgBox("bitfarm-Archiv: Fehler: Server leert nicht den bergabepfad. Kann nicht archivieren.")
    '	End If
    'End If
    
    
    
    Err.clear
    fs.CopyFile template, Ausgabename&".job", True
    If Err.number<>0 Then
        Err.clear
        removemsg()
        MsgBox("bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
        objWshShell.LogEvent 1, "bitfarm-Archiv: Officeimport.vbs:"&vbCrLf&"Fehler bei bergabe der Dateien an den Archivserver."&vbCrLf&Ausgabename & ".job"
        WScript.Quit
    End If
    
    If fs.FileExists(Ausgabename&".slw") Then
        WScript.Sleep 1500
        If fs.FileExists(Ausgabename&".slw") Then
            removemsg()
            MsgBox("bitfarm-Archiv: Fehler: Server leert nicht den bergabepfad. Kann nicht archivieren.")
            objWshShell.LogEvent 1, "bitfarm-Archiv: Officeimport.vbs:"&vbCrLf&"Fehler bei bergabe der Dateien an den Archivserver."&vbCrLf&Ausgabename & ".slw"
        End If
    End If
    If fs.FileExists(Ausgabename&".ftx") Then
        WScript.Sleep 1500
        If fs.FileExists(Ausgabename&".ftx") Then
            removemsg()
            MsgBox("bitfarm-Archiv: Fehler: Server leert nicht den bergabepfad. Kann nicht archivieren.")
            objWshShell.LogEvent 1, "bitfarm-Archiv: Officeimport.vbs:"&vbCrLf&"Fehler bei bergabe der Dateien an den Archivserver."&vbCrLf&Ausgabename & ".ftx"
        End If
    End If
    
    
    
    Err.clear
    If fs.FileExists(temppath&"\slx"&templatename&".slx") Then
        
        fs.CopyFile temppath&"\slx"&templatename&".slx", Ausgabename&".slw", True
        If Err.number<>0 Then
            Err.clear
            removemsg()
            MsgBox("bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
            objWshShell.LogEvent 1, "bitfarm-Archiv: Officeimport.vbs:"&vbCrLf&"Fehler bei bergabe der Dateien an den Archivserver."&vbCrLf&Ausgabename & ".slw"
            
            WScript.Quit
        End If
    End If
    'If fs.FileExists(template&".slw") Then
    'fs.deletefile template&".slw", True
    'If err.number<>0 Then
    '		err.clear
    '    		MsgBox("bitfarm-Archiv: Fehler bei Datenbergabe an den Server. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
    '    		WScript.Quit
    '    		
    'End If
    'End If
    If fs.FileExists(temppath&"\vtx"&templatename&".vtx") Then
        fs.CopyFile temppath&"\vtx"&templatename&".vtx", Ausgabename&".ftx", True
        If Err.number<>0 Then
            Err.clear
            removemsg()
            MsgBox("bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
            objWshShell.LogEvent 1, "bitfarm-Archiv: Officeimport.vbs:"&vbCrLf&"Fehler bei bergabe der Dateien an den Archivserver."&vbCrLf&Ausgabename & ".ftx"
            WScript.Quit
        End If
    End If
    
    
    If fs.GetExtensionName(datei)<>"" Then
        extension = "." & fs.GetExtensionName(datei)
        extension = LCase(extension)
    End If
    
    
    fs.CopyFile Datei, Ausgabename&extension, True
    If Err.number<>0 Then
        Err.clear
        removemsg()
        MsgBox("bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
        objWshShell.LogEvent 1, "bitfarm-Archiv: Officeimport.vbs:"&vbCrLf&"Fehler bei bergabe der Dateien an den Archivserver."&vbCrLf&Ausgabename & extension
        WScript.Quit
    End If
    
    fs.deletefile Datei, True
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
    End If
    
    't=0
    'Do While t<60
    'If fs.FileExists(Ausgabename&extension) Then
    '	WScript.sleep 200
    '	t=t+1
    'Else
    '	t=100
    'End If
    'loop
    'If t<>100 Then
    '	If fs.FileExists(Ausgabename&extension) Then
    '	fs.DeleteFile Ausgabename&extension, True
    '	If err.number<>0 Then
    '    		MsgBox("bitfarm-Archiv: Schwerer Fehler - konnte nicht archivieren. Informieren Sie den Administrator.")
    '    		err.clear
    '    		WScript.Quit
    '  	End If
    '	End If
    '	If fs.FileExists(Ausgabename&".job") Then
    '	fs.DeleteFile Ausgabename&".job", True
    '	If err.number<>0 Then
    '    		MsgBox("bitfarm-Archiv: Schwerer Fehler - konnte nicht archivieren. Informieren Sie den Administrator.")
    '    		err.clear
    '    		WScript.Quit
    '  	End If
    '  	End If
    '	If fs.FileExists(Ausgabename&".slw") Then
    '	fs.DeleteFile Ausgabename&".slw", True
    '	If err.number<>0 Then
    '    		MsgBox("bitfarm-Archiv: Schwerer Fehler - konnte nicht archivieren. Informieren Sie den Administrator.")
    '    		err.clear
    '    		WScript.Quit
    '  	End If
    '	End If
    '	If fs.FileExists(Ausgabename&".ftx") Then
    '	fs.DeleteFile Ausgabename&".ftx", True
    '	If err.number<>0 Then
    '    		MsgBox("bitfarm-Archiv: Schwerer Fehler - konnte nicht archivieren. Informieren Sie den Administrator.")
    '    		err.clear
    '    		WScript.Quit
    '  	End If
    '	End If
    '	frage = "Fehler: Der Archivserver reagiert nicht - es wurden ggf. nicht alle Dateien archiviert. Versuchen Sie es in einigen Minuten erneut. Sollte dieser Fehler wiederholt vorkommen, informieren Sie den Netzwerkadministrator."
    '	ueberschrift = "bitfarm-Archiv Dateiimport"
    '	antwort = objWSHShell.Popup(frage,, ueberschrift, vbSystemModal + vbCritical)
    '	'MsgBox("bitfarm-Archiv: Fehler: Der Archivserver reagiert nicht - es wurden ggf. nicht alle Dateien archiviert. Sollte dies hufiger Vorkommen informieren Sie den Netzwerkadministrator.")
    '	WScript.Quit
    'End If
    'WScript.Sleep 200
    sendtoserver=True
    
End Function



'******************************************  Funktionen  *************************************

'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function writeslwdatei(Datei)
    On Error Resume Next
    Err.clear
    If fs.FileExists(temppath&"\slx"&templatename&".slx") Then
        fs.deletefile temppath&"\slx"&templatename&".slx", True
        If Err.number Then
            Err.clear
            removemsg()
            MsgBox("bitfarm-Archiv: Fehler beim Dateiimport: Kann Dateinamen nicht als Schlagwort speichern. Kann so nicht archivieren. Bitte informieren Sie den Administrator.")
            WScript.Quit	
        End If
    End If 
    
    
    namestring=oldname
    If InStr(1,namestring,archivverzeichnis,1)<>0 Then
        namestring=""
    End If
    
    If InStr(1,namestring,archivkopie,1)<>0 Then
        namestring=""
    End If
    
    
    Set zielslwfile = fs.OpenTextFile(temppath&"\slx"&templatename&".slx",8,True)
    
    If namestring<>"" Then
        Err.clear
        
        'zielslwfile.writeline("Dateiname="&namestring) ################# Auskommentiert, da ohnehin bei Makroimport quatsch #######
        zielslwfile.writeline("Dateiname=")
        
        l=1
        laenge=Len(namestring)
        mystring1=""
        Do While l<laenge
            mystring2=getword(namestring,l)
            If mystring2<>mystring1 Then
                zielslwfile.writeline(mystring2)
                mystring1=mystring2
            End If
            l=l+1
        Loop
    End If
    
    If fs.FileExists(temppath&"\slw"&templatename&".slw") Then
        Set quellslwfile = fs.OpenTextFile(temppath&"\slw"&templatename&".slw",1)
        Do While quellslwfile.AtEndOfStream <> True
            zielslwfile.writeline(quellslwfile.readline)
            
        Loop
        Set quellslwfile = Nothing
    End If
    
    
    
    zielslwfile.close
    Set zielslwfile=Nothing
    If Err.number Then
        Err.clear
        removemsg()
        MsgBox("bitfarm-Archiv: Fehler beim Dateiimport: Kann Dateinamen nicht als Schlagwort speichern. Kann so nicht archivieren. Bitte informieren Sie den Administrator.")
        WScript.Quit	
    End If
    
    
    
End Function




'***************************************************************************************
'***************************************************************************************



Function checkfeedback()
    On Error Resume Next
    o=0
    mymsg=druckpfad&"msg"&zahl&".bfa"
    abbruch=False
    Do While abbruch=False
        If o<800 Then
            o=o+1
        Else
            
            
            frage = "Direktes Anzeigen des gerade archivierten Dokuments nicht mglich. Benutzen Sie den Viewer, um das Dokument erneut zu ffnen."
            ueberschrift = "bitfarm-Archiv Officeimport"
            antwort = objWSHShell.Popup(frage,, ueberschrift, vbExclamation)
            WScript.quit
        End If
        
        If fs.fileexists(mymsg) Then
            startdocument
        End If
        
        WScript.sleep 300
        
    Loop
    
    
End Function


'***************************************************************************************
'***************************************************************************************


Function startdocument
    On Error Resume Next
    mymsg=druckpfad&"msg"&zahl&".bfa"
    Set msgdatei = fs.OpenTextFile(mymsg,1)
    dokID=msgdatei.readline
    msgdatei.close
    Set msgdatei = Nothing
    On Error Resume Next
    Err.clear
    fs.deletefile mymsg, True
    If Err.number <> 0 Then
        Err.clear
        On Error Resume Next
    End If
    lngReturnCode = objWSHShell.exec(programm&"\ViewerV3.exe "&dokID)
    If Err.number<>0 Then
        Err.clear
        'MsgBox("Fehler beim starten des Viewers. Aktueller Windows Scripting Host?")
    End If
    
    WScript.Quit
    
End Function





'***************************************************************************************
'***************************************************************************************



Function readjob(tempname)
    On Error Resume Next
    readjob=True
    Err.clear
    
    If Not fs.FileExists(tempname) Then
        Err.clear
        
        readjob=False
        Err.clear
    End If
    
    If readjob=True Then	
        Set jobfile = fs.OpenTextFile(tempname,1)
        If Err.number Then
            Err.clear
            
            readjob=False
            
        End If 
    End If
    
    
    If readjob = True Then
        
        Do While jobfile.AtEndOfStream <> True
            kette=jobfile.readline
            If Left(kette,1)<>";" Then
                
                
                If InStr(1,kette,"Profil=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Profil=",1)+7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Profil = wert
                    End If
                End If
                
                If InStr(1,kette,"OCR_Typ",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"OCR_Typ",1)+8)
                    typ = wert
                End If
                
                
            End If
            
            
        Loop
        jobfile.close
        Set jobfile = Nothing
        
    End If
    
    
End Function

Function writejob(tempname)
    On Error Resume Next
    writejob=True
    Err.clear
    
    If Not fs.FileExists(tempname&".job") Then
        Err.clear
        errortxt=tempname&".job Datei nicht vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        writejob=False
        Err.clear
    End If
    
    If writejob=True Then	
        Set quelljobfile = fs.OpenTextFile(tempname&".job",1)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writejob=False
            
        End If 
    End If
    
    If writejob=True Then
        If fs.FileExists(tempname&".tmp") Then
            fs.DeleteFile(tempname& ".tmp")
            If Err.number Then
                Err.clear
                errortxt="Zwischendatei fr Jobdatei existierte noch, kann diese aber nicht lschen."
                objWshShell.LogEvent 1, errortxt
                writejob=False
                quelljobfile.close
                Set quelljobfile=Nothing
            End If 
            
        End If	
    End If
    
    If writejob=True Then
        Set zieljobfile = fs.OpenTextFile(tempname&".tmp",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writejob=False
            quelljobfile.close
            Set quelljobfile=Nothing
        End If 
    End If
    
    
    
    If writejob = True Then
        
        stopflag=False
        ersatzstring=""	
        
        'If popupoffice=true Then
        'If Typ="OMP" Then
        '	Typ="OMX"
        'End If
        '
        'If Typ="TXT" Then
        '	Typ="TXX"
        'End If
        'End If
        
        
        Do While quelljobfile.AtEndOfStream <> True
            kette=quelljobfile.readline
            
            
            
            
            ersatzstring=""
            
            If (myname<>"") And (InStr(1,kette,"Titel=",1)<>0) Then
                ersatzstring="Titel="&myname
            End If
            
            
            
            If (Username<>"") And (InStr(1,kette,"Benutzer=",1)<>0) Then
                ersatzstring="Benutzer="&Username
            End If	
            
            If (dokDate<>"") And (InStr(1,kette,"Datum=",1)<>0) Then
                ersatzstring="Datum="&DokDate
            End If
            
            If (Typ<>"") And (InStr(1,kette,"OCR_Typ=",1)<>0) Then
                ersatzstring="OCR_Typ="&Typ
            End If
            
            
            
            'If Left(kette,3)="Zus" Then
            '	For x=1 to Zusatzfelder
            '		
            '		If (Zusatzfeld(x)<>"") AND (InStr(1,kette,"ZusWert"&x&"=",1)<>0) Then
            '			ersatzstring="ZusWert"&x&"="&Zusatzfeld(x)
            '		End If
            '	Next
            'End If
            
            If ersatzstring<>"" Then
                zieljobfile.writeline(ersatzstring)
            Else
                zieljobfile.writeline(kette)
            End If
            
        Loop
        quelljobfile.close
        Set quelljobfile = Nothing
        zieljobfile.close
        Set zieljobfile=Nothing
        WScript.sleep 300
        
        Err.clear
        fs.DeleteFile(tempname& ".job")
        If Err.number Then
            Err.clear
            errortxt="Fehler beim lschen der alten jobdatei."
            objWshShell.LogEvent 1, errortxt
            writejob=False
        End If 
        
        
        WScript.sleep 200
        
        If writejob=True Then
            
            fs.CopyFile tempname&".tmp", tempname&".job", True
            If Err.number Then
                Err.clear
                errortxt="Fehler beim umkopieren Jobdatei."
                objWshShell.LogEvent 1, errortxt
                writejob=False
            End If 
        End If
        
        WScript.sleep 300
        If writejob=True Then
            fs.DeleteFile(tempname& ".tmp")
            If Err.number Then
                Err.clear
                errortxt="Fehler beim lschen der zwischen-jobdatei."
                objWshShell.LogEvent 1, errortxt
                writejob=False
            End If 
        End If
        WScript.sleep 200
        
    End If
    
    
End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************
'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function readconfig(profil)
    On Error Resume Next
    readconfig=True
    Err.clear
    
    If Not fs.FileExists(programm&profil&".con") Then
        Err.clear
        errortxt=profil&".con Datei nicht im Scriptpfad vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        readconfig=False
        Err.clear
    End If
    
    If readconfig=True Then	
        Set confile = fs.OpenTextFile(programm&profil&".con",1)
        If Err.number Then
            Err.clear
            errortxt="Profilfdatei nicht im Scriptpfad vorhanden oder nicht lesbar."
            objWshShell.LogEvent 1, errortxt
            Err.clear
            readconfig=False
            
        End If 
    End If
    
    If readconfig=True Then	
        kette=confile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        Do While Scriptsflag = 0
            kette=confile.readline
            Scriptsflag=InStr(1,kette,"[Scripts]")
            If confile.AtEndOfStream = True Then
                confile.close
                Set confile=Nothing
                scriptsflag=1
                errortxt="Fehler beim Lesen der CON-Datei - falsche Formatierung."
                objWshShell.LogEvent 1, errortxt
                readconfig = False
                
            End If
        Loop
        
    End If
    
    
    If readconfig = True Then
        
        Do While confile.AtEndOfStream <> True
            kette=confile.readline
            If Left(kette,1)<>";" Then
                
                
                
                
                
                If InStr(1,kette,"uncclientspooler",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"uncclientspooler",1)+16)
                    uncclientspooler = wert
                End If
                
                If InStr(1,kette,"archivverzeichnis",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"archivverzeichnis",1)+17)
                    archivverzeichnis = wert
                End If
                
                If InStr(1,kette,"archivkopie",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"archivkopie",1)+11)
                    archivkopie = wert
                End If
                
                
            End If
            
        Loop
        confile.close
        Set confile = Nothing
        
    End If
    
    
End Function




'***************************************************************************************
'***************************************************************************************
'***************************************************************************************
Function setdokdate()
    On Error Resume Next
    Jahr = DatePart("yyyy",Date)
    Monat = DatePart("m",Date)
    Tag = DatePart("d",Date)
    Stunde = DatePart("h",Time)
    Minuten = DatePart("n",Time)
    Sekunde = DatePart("s", Time)
    If Len(Monat)=1 Then 
        monat="0"&monat
    End If
    If Len(tag)=1 Then 
        tag="0"&tag
    End If
    If Len(stunde)=1 Then 
        stunde="0"&stunde
    End If
    If Len(minuten)=1 Then 
        minuten="0"&minuten
    End If
    If Len(sekunde)=1 Then 
        sekunde="0"&sekunde
    End If
    setdokdate = Jahr&"-" & Monat & "-" & Tag & " " & Stunde & ":" & Minuten & ":" & Sekunde
End Function

'***************************************************************************************
'***************************************************************************************
'***************************************************************************************


Function inilesen()
    On Error Resume Next
    
    Err.clear
    Set inifile = fs.OpenTextFile(programm&"scripts.ini",1)
    If Err.number Then
        objWshShell.LogEvent 1, "scripts.ini nicht im Scriptpfad vorhanden oder nicht lesbar."
        Err.clear
        WScript.Quit
    End If 
    
    kette=inifile.readline
    Scriptsflag=InStr(1,kette,"[Scripts]")
    Do While Scriptsflag = 0
        kette=inifile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        If inifile.AtEndOfStream = True Then
            inifile.close
            objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - falsche Formatierung."
            WScript.Quit
        End If
    Loop
    
    
    Do While inifile.AtEndOfStream <> True
        kette=inifile.readline
        If Left(kette,1)<>";" Then
            
            
            If InStr(1,kette,"Profil",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"Profil",1)+7)
                If profil="" Then
                    profil = wert
                End If
            End If
            
            If InStr(1,kette,"Typ",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"Typ",1)+4)
                typ = wert
            End If
            
            If InStr(1,kette,"MSWordinstalled",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"MSWordinstalled",1)+16)
                If LCase(wert)="true" Then
                    acceptdoc = True
                End If	
            End If
            
            If InStr(1,kette,"MSExcelinstalled",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"MSExcelinstalled",1)+17)
                If LCase(wert)="true" Then
                    acceptxls = True
                End If	
            End If
            
            If InStr(1,kette,"MSPowerPointinstalled",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"MSPowerPointinstalled",1)+22)
                If LCase(wert)="true" Then
                    acceptppt = True
                End If	
            End If
            
            If InStr(1,kette,"MSOffice2007installed",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"MSOffice2007installed",1)+22)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        MSOffice2007installed=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"DWGViewerinstalled",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"DWGViewerinstalled",1)+19)
                If LCase(wert)="true" Then
                    acceptdwg = True
                End If	
            End If
            
            If InStr(1,kette,"acceptallfiletypes",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"acceptallfiletypes",1)+19)
                If LCase(wert)="true" Then
                    acceptallfiletypes = True
                End If	
            End If
            
            If InStr(1,kette,"officequickimport",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"officequickimport",1)+18)
                If LCase(wert)="true" Then
                    officequickimport = True
                End If	
            End If
            
            If InStr(1,kette,"openofficepath",1)<>0 Then
                'wert=GetString(kette,InStr(1,kette,"openofficepath",1)+15)
                wert = Right(kette,Len(kette) -15)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    openofficepath=Trim(wert)
                End If
            End If	
            
        End If
        
    Loop
    inifile.close
    Set inifile = Nothing
    If programm="" Then
        objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - kein Programmpfad."
        WScript.Quit
    End If
    
    
    If officequickimport=False Then
        popupoffice=False
    End If
    
End Function



Private Function GetWord(kette,pos)
    On Error Resume Next
    zeichen=""
    ergebnis=""
    index1=pos
    'MsgBox(Len(kette)&":"&pos)
    Do While (zeichen<>" ") And (zeichen<>"	") And (index1>1)
        index1=index1-1
        zeichen=Mid(kette,index1,1)
        
    Loop
    'MsgBox(index1)
    zeichen=""
    index2=0
    maxindex2=Len(kette)-index1+2
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (zeichen<>"	") And (index2<maxindex2)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,index1+index2,1)
        index2=index2+1
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=")) And (ergebnis="") Then
            zeichen=""
        End If
    Loop
    'MsgBox(index)
    Trim(ergebnis)
    GetWord=ergebnis
End Function


Function Zufallszahl(von, bis)
    On Error Resume Next
    anzahl = bis-von+1
    Randomize
    Zufallszahl = Fix(Rnd*(anzahl))+von
End Function


Private Function StrConvert(String)
    On Error Resume Next
    wert1=0
    l = Len(String)
    
    For x = 1 To l
        wert1=wert1+((Asc(Mid(String,x,1))-48)*(10^(l-x)))
    Next
    StrConvert=wert1
End Function


Private Function GetString(kette,pos)
    zeichen=""
    ergebnis=""
    index=0
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (zeichen<>"	") And (index<80)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,pos+index,1)
        index=index+1
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=")) And (ergebnis="") Then
            zeichen=""
        End If
    Loop
    Trim(ergebnis)
    GetString=ergebnis
End Function


Function RegRead(tempkey)
    privkey = tempkey
    
    RegRead = objWSHShell.RegRead(privkey)
    If Not Err.number=0 Then
        MsgBox("Fehler: Registrierungsschlssel nicht gesetzt.")
        RegRead=""
        Err.clear
        WScript.Quit
    End If
End Function

Function showmsg()
    On Error Resume Next
    showmsg=True
    Err.clear
    On Error Resume Next
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        showmsg=False
    Else
        Set objWMIService = Nothing
    End If
    If showmsg=True Then
        Set oExec = objWSHShell.exec(programm&"bfamessage.exe")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            showmsg=False
        Else
            Set oexec=Nothing
        End If
    End If
End Function



Function removemsg()
    
    Err.clear
    On Error Resume Next
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    If Err.number=0 Then
        strQuery = "Select * from Win32_Process where Name='bfamessage.exe'"
        Set colItems = objWMIService.ExecQuery(strQuery,,48)
        For Each objItem In colItems
            objItem.Terminate()
        Next
        WScript.sleep 100
        Set colItems = Nothing
        Set objWMIService = Nothing
    End If
    Err.clear
    On Error Resume Next
End Function


Function createimportjob(importfile)
	'WScript.Echo importfile
	filefolder = importfile.ParentFolder
	filename = importfile.Name
	extension = fs.GetExtensionName(importfile)
	filebasename = fs.GetBaseName(importfile)
	
	'If usertitel = "" Then
		'If attachmentdontuseoriname = True Then
	    	'myname = normstring(betreff)
	    'Else
	        'myname = filebasename
	    'End If
	'Else
		'myname = usertitel
	'End If	
	
	' die Email selbst heisst immer bfa-Mail
	If filebasename = "bfa-Mail" Then
		myname = normstring(betreff)
	' alles andere sind attachments und heissen wir die Originaldatei
	Else
		myname = filebasename
	End If
	Set newjobfile = fs.CreateTextFile(filefolder & "\" & filebasename & ".job", True)
	newjobfile.WriteLine("[Version]")
	newjobfile.WriteLine("Version=36")
	newjobfile.WriteLine("[Archiv]")
	newjobfile.WriteLine("Profil=")
	
	newjobfile.WriteLine("Name=")
	newjobfile.WriteLine("Tabelle=")
	newjobfile.WriteLine("[Document]")
	newjobfile.WriteLine("DOCID=")
	newjobfile.WriteLine("Titel="&myname)
	newjobfile.WriteLine("Orginal=")
	newjobfile.WriteLine("Kopie=")
	newjobfile.WriteLine("Quelle=")
	newjobfile.WriteLine("Benutzer=")
	newjobfile.WriteLine("Volltext=")
	newjobfile.WriteLine("Status=")
	newjobfile.WriteLine("StatStr=")
	newjobfile.WriteLine("OCR_QF=")
	newjobfile.WriteLine("OCR_Typ=")
	newjobfile.WriteLine("Pages=")
	newjobfile.WriteLine("gdoc_id=")
	newjobfile.WriteLine("Schlagworte=")
	DokDate = setdokdate()
	newjobfile.WriteLine("Datum="&DokDate)
	newjobfile.WriteLine("Filter=fromoffice")
	newjobfile.WriteLine("[Referenz]")
	
	reftotal = 0
	For Each lnk In linkspeicher
		If lnk <> "" Then
			reftotal = reftotal + 1
		End If
	Next
	
	newjobfile.WriteLine("Anzahl="&reftotal)
	
	refcount = 0
	For i = 0 To limit
		If linkspeicher(i) <> "" Then
			refcount = refcount + 1
			newjobfile.WriteLine("Referenz"&refcount&"="&linkspeicher(i))
		End If
	Next
	
	newjobfile.WriteLine("[Tasks]")
	newjobfile.WriteLine("Termin=")
	newjobfile.WriteLine("Alarm=")
	newjobfile.WriteLine("Bearbeiter=")
	newjobfile.WriteLine("Notiz=")
	newjobfile.WriteLine("[Zusatzfelder]")
	newjobfile.WriteLine("Felder=0")

	newjobfile.Close

End Function
'*******************************************************************************************
'*******************************************************************************************
'********************************          Ende             ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

'' SIG '' Begin signature block
'' SIG '' MIIkyAYJKoZIhvcNAQcCoIIkuTCCJLUCAQExCzAJBgUr
'' SIG '' DgMCGgUAMGcGCisGAQQBgjcCAQSgWTBXMDIGCisGAQQB
'' SIG '' gjcCAR4wJAIBAQQQTvApFpkntU2P5azhDxfrqwIBAAIB
'' SIG '' AAIBAAIBAAIBADAhMAkGBSsOAwIaBQAEFMo1jDCVYDs0
'' SIG '' u/62v3AzPHv0XOR7oIIeujCCBU4wggQ2oAMCAQICEHun
'' SIG '' lQxDIiTZXVcM5VXbpQMwDQYJKoZIhvcNAQELBQAwfDEL
'' SIG '' MAkGA1UEBhMCR0IxGzAZBgNVBAgTEkdyZWF0ZXIgTWFu
'' SIG '' Y2hlc3RlcjEQMA4GA1UEBxMHU2FsZm9yZDEYMBYGA1UE
'' SIG '' ChMPU2VjdGlnbyBMaW1pdGVkMSQwIgYDVQQDExtTZWN0
'' SIG '' aWdvIFJTQSBDb2RlIFNpZ25pbmcgQ0EwHhcNMjEwNTMx
'' SIG '' MDAwMDAwWhcNMjQwNTMwMjM1OTU5WjCBkjELMAkGA1UE
'' SIG '' BhMCREUxHDAaBgNVBAgME05vcmRyaGVpbi1XZXN0ZmFs
'' SIG '' ZW4xDzANBgNVBAcMBlNpZWdlbjEpMCcGA1UECgwgYml0
'' SIG '' ZmFybSBJbmZvcm1hdGlvbnNzeXN0ZW1lIEdtYkgxKTAn
'' SIG '' BgNVBAMMIGJpdGZhcm0gSW5mb3JtYXRpb25zc3lzdGVt
'' SIG '' ZSBHbWJIMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIB
'' SIG '' CgKCAQEAoRJ0i87hei84JWio6ppr39qNUaIVkivyYmXk
'' SIG '' Kcc2biAsUT32n4M4vTPpwRG7Y0JkUPVQkq76hIU/WK2l
'' SIG '' LQO4AmgMnIz7X2KvZxytsUELaV0chUrM4Mp2aU/2msqr
'' SIG '' 4BnmojsncK+KBvls0GhWRPwmOcOJlM4kkUHqxaAeEMBK
'' SIG '' aaXmK4e9szmw1wxaOdsUx7SOd4dYFMhCZnyHbiWmTScm
'' SIG '' 8tXl29UJjeUx4MuR8ihzLSABSMQaLfc4Efs4APpgcvPp
'' SIG '' 7LOZjCCHL8cfu796tlHxie6a64rpdi/XfBTN1DuWdC65
'' SIG '' 8hwaBshTU+qrtADaBq8EBpt8VnkYIfMifgP6XHjITQID
'' SIG '' AQABo4IBszCCAa8wHwYDVR0jBBgwFoAUDuE6qFM6MdWK
'' SIG '' vsG7rWcaA4WtNA4wHQYDVR0OBBYEFOXIB9Ay7umZN/qG
'' SIG '' Oy9DE2bx+RbOMA4GA1UdDwEB/wQEAwIHgDAMBgNVHRMB
'' SIG '' Af8EAjAAMBMGA1UdJQQMMAoGCCsGAQUFBwMDMBEGCWCG
'' SIG '' SAGG+EIBAQQEAwIEEDBKBgNVHSAEQzBBMDUGDCsGAQQB
'' SIG '' sjEBAgEDAjAlMCMGCCsGAQUFBwIBFhdodHRwczovL3Nl
'' SIG '' Y3RpZ28uY29tL0NQUzAIBgZngQwBBAEwQwYDVR0fBDww
'' SIG '' OjA4oDagNIYyaHR0cDovL2NybC5zZWN0aWdvLmNvbS9T
'' SIG '' ZWN0aWdvUlNBQ29kZVNpZ25pbmdDQS5jcmwwcwYIKwYB
'' SIG '' BQUHAQEEZzBlMD4GCCsGAQUFBzAChjJodHRwOi8vY3J0
'' SIG '' LnNlY3RpZ28uY29tL1NlY3RpZ29SU0FDb2RlU2lnbmlu
'' SIG '' Z0NBLmNydDAjBggrBgEFBQcwAYYXaHR0cDovL29jc3Au
'' SIG '' c2VjdGlnby5jb20wIQYDVR0RBBowGIEWaW5mb0BiaXRm
'' SIG '' YXJtLWFyY2hpdi5kZTANBgkqhkiG9w0BAQsFAAOCAQEA
'' SIG '' RLt57msg2LAnUeKBkqSEMK0YCuO6Ww/ZCUowag88f0K9
'' SIG '' wFC+wwlIZOSQVoniG6jCLDYJ63n2JPRtN1Ubv3sVXwbZ
'' SIG '' czAx7EEeq7pzp9zwQ+ezNV/29XKX68HZF9vnstw3Sh30
'' SIG '' rwM0uQV/MBiVBwSPK9ZMgbI84SwS+vf3RNlRdtEv+ofr
'' SIG '' b8QVZIKWu6C+xQuFIMVf/uyqJo8aII0jdGG0KDmqD3Fi
'' SIG '' k5aY7Qt9+lgPCGkBeXNMDBadLNWF3618Zbn6gJkhRAYY
'' SIG '' EJ855Qsn1M8jGo6OweX8yfg/zO4cGv7g7L5LrjZKRirf
'' SIG '' J3A2Mditxflhw9llAu7YZcpjKxceXJhCgjCCBYEwggRp
'' SIG '' oAMCAQICEDlyRDr5IrdR19NsEN0xNZUwDQYJKoZIhvcN
'' SIG '' AQEMBQAwezELMAkGA1UEBhMCR0IxGzAZBgNVBAgMEkdy
'' SIG '' ZWF0ZXIgTWFuY2hlc3RlcjEQMA4GA1UEBwwHU2FsZm9y
'' SIG '' ZDEaMBgGA1UECgwRQ29tb2RvIENBIExpbWl0ZWQxITAf
'' SIG '' BgNVBAMMGEFBQSBDZXJ0aWZpY2F0ZSBTZXJ2aWNlczAe
'' SIG '' Fw0xOTAzMTIwMDAwMDBaFw0yODEyMzEyMzU5NTlaMIGI
'' SIG '' MQswCQYDVQQGEwJVUzETMBEGA1UECBMKTmV3IEplcnNl
'' SIG '' eTEUMBIGA1UEBxMLSmVyc2V5IENpdHkxHjAcBgNVBAoT
'' SIG '' FVRoZSBVU0VSVFJVU1QgTmV0d29yazEuMCwGA1UEAxMl
'' SIG '' VVNFUlRydXN0IFJTQSBDZXJ0aWZpY2F0aW9uIEF1dGhv
'' SIG '' cml0eTCCAiIwDQYJKoZIhvcNAQEBBQADggIPADCCAgoC
'' SIG '' ggIBAIASZRc2DsPbCLPQrFcNdu3NJ9NMrVCDYeKqIE0J
'' SIG '' LWQJ3M6Jn8w9qez2z8Hc8dOx1ns3KBErR9o5xrw6GbRf
'' SIG '' pr19naNjQrZ28qk7K5H44m/Q7BYgkAk+4uh0yRi0kdRi
'' SIG '' ZNt/owbxiBhqkCI8vP4T8IcUe/bkH47U5FHGEWdGCFHL
'' SIG '' hhRUP7wz/n5snP8WnRi9UY41pqdmyHJn2yFmsdSbeAPA
'' SIG '' UDrozPDcvJ5M/q8FljUfV1q3/875PbcstvZU3cjnEjpN
'' SIG '' rkyKt1yatLcgPcp/IjSufjtoZgFE5wFORlObM2D3lL5T
'' SIG '' N5BzQ/Myw1Pv26r+dE5px2uMYJPexMcM3+EyrsyTO1F4
'' SIG '' lWeL7j1W/gzQaQ8bD/MlJmszbfduR/pzQ+V+DqVmsSl8
'' SIG '' MoRjVYnEDcGTVDAZE6zTfTen6106bDVc20HXEtqpSQvf
'' SIG '' 2ICKCZNijrVmzyWIzYS4sT+kOQ/ZAp7rEkyVfPNrBale
'' SIG '' FoPMuGfi6BOdzFuC00yz7Vv/3uVzrCM7LQC/NVV0CUnY
'' SIG '' SVgaf5I25lGSDvMmfRxNF7zJ7EMm0L9BX0CpRET0medX
'' SIG '' h55QH1dUqD79dGMvsVBlCeZYQi5DGky08CVHWfoEHpPU
'' SIG '' JkZKUIGy3r54t/xnFeHJV4QeD2PW6WK61l9VLupcxigI
'' SIG '' BCU5uA4rqfJMlxwHPw1S9e3vL4IPAgMBAAGjgfIwge8w
'' SIG '' HwYDVR0jBBgwFoAUoBEKIz6W8Qfs4q8p74Klf9AwpLQw
'' SIG '' HQYDVR0OBBYEFFN5v1qqK0rPVIDh2JvAnfKyA2bLMA4G
'' SIG '' A1UdDwEB/wQEAwIBhjAPBgNVHRMBAf8EBTADAQH/MBEG
'' SIG '' A1UdIAQKMAgwBgYEVR0gADBDBgNVHR8EPDA6MDigNqA0
'' SIG '' hjJodHRwOi8vY3JsLmNvbW9kb2NhLmNvbS9BQUFDZXJ0
'' SIG '' aWZpY2F0ZVNlcnZpY2VzLmNybDA0BggrBgEFBQcBAQQo
'' SIG '' MCYwJAYIKwYBBQUHMAGGGGh0dHA6Ly9vY3NwLmNvbW9k
'' SIG '' b2NhLmNvbTANBgkqhkiG9w0BAQwFAAOCAQEAGIdR3HQh
'' SIG '' PZyK4Ce3M9AuzOzw5steEd4ib5t1jp5y/uTW/qofnJYt
'' SIG '' 7wNKfq70jW9yPEM7wD/ruN9cqqnGrvL82O6je0P2hjZ8
'' SIG '' FODN9Pc//t64tIrwkZb+/UNkfv3M0gGhfX34GRnJQisT
'' SIG '' v1iLuqSiZgR2iJFODIkUzqJNyTKzuugUGrxx8VvwQQuY
'' SIG '' AAoiAxDlDLH5zZI3Ge078eQ6tvlFEyZ1r7uq7z97dzvS
'' SIG '' xAKRPRkA0xdcOds/exgNRc2ThZYvXd9ZFk8/Ub3VRRg/
'' SIG '' 7UqO6AZhdCMWtQ1QcydER38QXYkqa4UxFMToqWpMgLxq
'' SIG '' eM+4f452cpkMnf7XkQgWoaNflTCCBfUwggPdoAMCAQIC
'' SIG '' EB2iSDBvmyYY0ILgln0z02owDQYJKoZIhvcNAQEMBQAw
'' SIG '' gYgxCzAJBgNVBAYTAlVTMRMwEQYDVQQIEwpOZXcgSmVy
'' SIG '' c2V5MRQwEgYDVQQHEwtKZXJzZXkgQ2l0eTEeMBwGA1UE
'' SIG '' ChMVVGhlIFVTRVJUUlVTVCBOZXR3b3JrMS4wLAYDVQQD
'' SIG '' EyVVU0VSVHJ1c3QgUlNBIENlcnRpZmljYXRpb24gQXV0
'' SIG '' aG9yaXR5MB4XDTE4MTEwMjAwMDAwMFoXDTMwMTIzMTIz
'' SIG '' NTk1OVowfDELMAkGA1UEBhMCR0IxGzAZBgNVBAgTEkdy
'' SIG '' ZWF0ZXIgTWFuY2hlc3RlcjEQMA4GA1UEBxMHU2FsZm9y
'' SIG '' ZDEYMBYGA1UEChMPU2VjdGlnbyBMaW1pdGVkMSQwIgYD
'' SIG '' VQQDExtTZWN0aWdvIFJTQSBDb2RlIFNpZ25pbmcgQ0Ew
'' SIG '' ggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEKAoIBAQCG
'' SIG '' Io0yhXoYn0nwli9jCB4t3HyfFM/jJrYlZilAhlRGdDFi
'' SIG '' xRDtsocnppnLlTDAVvWkdcapDlBipVGREGrgS2Ku/fD4
'' SIG '' GKyn/+4uMyD6DBmJqGx7rQDDYaHcaWVtH24nlteXUYam
'' SIG '' 9CflfGqLlR5bYNV+1xaSnAAvaPeX7Wpyvjg7Y96Pv25M
'' SIG '' QV0SIAhZ6DnNj9LWzwa0VwW2TqE+V2sfmLzEYtYbC43H
'' SIG '' ZhtKn52BxHJAteJf7wtF/6POF6YtVbC3sLxUap28jVZT
'' SIG '' xvC6eVBJLPcDuf4vZTXyIuosB69G2flGHNyMfHEo8/6n
'' SIG '' xhTdVZFuihEN3wYklX0Pp6F8OtqGNWHTAgMBAAGjggFk
'' SIG '' MIIBYDAfBgNVHSMEGDAWgBRTeb9aqitKz1SA4dibwJ3y
'' SIG '' sgNmyzAdBgNVHQ4EFgQUDuE6qFM6MdWKvsG7rWcaA4Wt
'' SIG '' NA4wDgYDVR0PAQH/BAQDAgGGMBIGA1UdEwEB/wQIMAYB
'' SIG '' Af8CAQAwHQYDVR0lBBYwFAYIKwYBBQUHAwMGCCsGAQUF
'' SIG '' BwMIMBEGA1UdIAQKMAgwBgYEVR0gADBQBgNVHR8ESTBH
'' SIG '' MEWgQ6BBhj9odHRwOi8vY3JsLnVzZXJ0cnVzdC5jb20v
'' SIG '' VVNFUlRydXN0UlNBQ2VydGlmaWNhdGlvbkF1dGhvcml0
'' SIG '' eS5jcmwwdgYIKwYBBQUHAQEEajBoMD8GCCsGAQUFBzAC
'' SIG '' hjNodHRwOi8vY3J0LnVzZXJ0cnVzdC5jb20vVVNFUlRy
'' SIG '' dXN0UlNBQWRkVHJ1c3RDQS5jcnQwJQYIKwYBBQUHMAGG
'' SIG '' GWh0dHA6Ly9vY3NwLnVzZXJ0cnVzdC5jb20wDQYJKoZI
'' SIG '' hvcNAQEMBQADggIBAE1jUO1HNEphpNveaiqMm/EAAB4d
'' SIG '' Yns61zLC9rPgY7P7YQCImhttEAcET7646ol4IusPRuzz
'' SIG '' Rl5ARokS9At3WpwqQTr81vTr5/cVlTPDoYMot94v5JT3
'' SIG '' hTODLUpASL+awk9KsY8k9LOBN9O3ZLCmI2pZaFJCX/8E
'' SIG '' 6+F0ZXkI9amT3mtxQJmWunjxucjiwwgWsatjWsgVgG10
'' SIG '' Xkp1fqW4w2y1z99KeYdcx0BNYzX2MNPPtQoOCwR/oEuu
'' SIG '' u6Ol0IQAkz5TXTSlADVpbL6fICUQDRn7UJBhvjmPeo5N
'' SIG '' 9p8OHv4HURJmgyYZSJXOSsnBf/M6BZv5b9+If8AjntIe
'' SIG '' Q3pFMcGcTanwWbJZGehqjSkEAnd8S0vNcL46slVaeD68
'' SIG '' u28DECV3FTSK+TbMQ5Lkuk/xYpMoJVcp+1EZx6ElQGqE
'' SIG '' V8aynbG8HArafGd+fS7pKEwYfsR7MUFxmksp7As9V1DS
'' SIG '' yt39ngVR5UR43QHesXWYDVQk/fBO4+L4g71yuss9Ou7w
'' SIG '' XheSaG3IYfmm8SoKC6W59J7umDIFhZ7r+YMp08Ysfb06
'' SIG '' dy6LN0KgaoLtO0qqlBCk4Q34F8W2WnkzGJLjtXX4oemO
'' SIG '' CiUe5B7xn1qHI/+fpFGe+zmAEc3btcSnqIBv5VPU4OOi
'' SIG '' wtJbGvoyJi1qV3AcPKRYLqPzW0sH3DJZ84enGm1YMIIG
'' SIG '' 7DCCBNSgAwIBAgIQMA9vrN1mmHR8qUY2p3gtuTANBgkq
'' SIG '' hkiG9w0BAQwFADCBiDELMAkGA1UEBhMCVVMxEzARBgNV
'' SIG '' BAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0plcnNleSBD
'' SIG '' aXR5MR4wHAYDVQQKExVUaGUgVVNFUlRSVVNUIE5ldHdv
'' SIG '' cmsxLjAsBgNVBAMTJVVTRVJUcnVzdCBSU0EgQ2VydGlm
'' SIG '' aWNhdGlvbiBBdXRob3JpdHkwHhcNMTkwNTAyMDAwMDAw
'' SIG '' WhcNMzgwMTE4MjM1OTU5WjB9MQswCQYDVQQGEwJHQjEb
'' SIG '' MBkGA1UECBMSR3JlYXRlciBNYW5jaGVzdGVyMRAwDgYD
'' SIG '' VQQHEwdTYWxmb3JkMRgwFgYDVQQKEw9TZWN0aWdvIExp
'' SIG '' bWl0ZWQxJTAjBgNVBAMTHFNlY3RpZ28gUlNBIFRpbWUg
'' SIG '' U3RhbXBpbmcgQ0EwggIiMA0GCSqGSIb3DQEBAQUAA4IC
'' SIG '' DwAwggIKAoICAQDIGwGv2Sx+iJl9AZg/IJC9nIAhVJO5
'' SIG '' z6A+U++zWsB21hoEpc5Hg7XrxMxJNMvzRWW5+adkFiYJ
'' SIG '' +9UyUnkuyWPCE5u2hj8BBZJmbyGr1XEQeYf0RirNxFrJ
'' SIG '' 29ddSU1yVg/cyeNTmDoqHvzOWEnTv/M5u7mkI0Ks0BXD
'' SIG '' f56iXNc48RaycNOjxN+zxXKsLgp3/A2UUrf8H5VzJD0B
'' SIG '' KLwPDU+zkQGObp0ndVXRFzs0IXuXAZSvf4DP0REKV4TJ
'' SIG '' f1bgvUacgr6Unb+0ILBgfrhN9Q0/29DqhYyKVnHRLZRM
'' SIG '' yIw80xSinL0m/9NTIMdgaZtYClT0Bef9Maz5yIUXx7gp
'' SIG '' GaQpL0bj3duRX58/Nj4OMGcrRrc1r5a+2kxgzKi7nw0U
'' SIG '' 1BjEMJh0giHPYla1IXMSHv2qyghYh3ekFesZVf/QOVQt
'' SIG '' Ju5FGjpvzdeE8NfwKMVPZIMC1Pvi3vG8Aij0bdonigbS
'' SIG '' lofe6GsO8Ft96XZpkyAcSpcsdxkrk5WYnJee647BeFbG
'' SIG '' RCXfBhKaBi2fA179g6JTZ8qx+o2hZMmIklnLqEbAyfKm
'' SIG '' /31X2xJ2+opBJNQb/HKlFKLUrUMcpEmLQTkUAx4p+hul
'' SIG '' Iq6lw02C0I3aa7fb9xhAV3PwcaP7Sn1FNsH3jYL6uckN
'' SIG '' U4B9+rY5WDLvbxhQiddPnTO9GrWdod6VQXqngwIDAQAB
'' SIG '' o4IBWjCCAVYwHwYDVR0jBBgwFoAUU3m/WqorSs9UgOHY
'' SIG '' m8Cd8rIDZsswHQYDVR0OBBYEFBqh+GEZIA/DQXdFKI7R
'' SIG '' NV8GEgRVMA4GA1UdDwEB/wQEAwIBhjASBgNVHRMBAf8E
'' SIG '' CDAGAQH/AgEAMBMGA1UdJQQMMAoGCCsGAQUFBwMIMBEG
'' SIG '' A1UdIAQKMAgwBgYEVR0gADBQBgNVHR8ESTBHMEWgQ6BB
'' SIG '' hj9odHRwOi8vY3JsLnVzZXJ0cnVzdC5jb20vVVNFUlRy
'' SIG '' dXN0UlNBQ2VydGlmaWNhdGlvbkF1dGhvcml0eS5jcmww
'' SIG '' dgYIKwYBBQUHAQEEajBoMD8GCCsGAQUFBzAChjNodHRw
'' SIG '' Oi8vY3J0LnVzZXJ0cnVzdC5jb20vVVNFUlRydXN0UlNB
'' SIG '' QWRkVHJ1c3RDQS5jcnQwJQYIKwYBBQUHMAGGGWh0dHA6
'' SIG '' Ly9vY3NwLnVzZXJ0cnVzdC5jb20wDQYJKoZIhvcNAQEM
'' SIG '' BQADggIBAG1UgaUzXRbhtVOBkXXfA3oyCy0lhBGysNsq
'' SIG '' fSoF9bw7J/RaoLlJWZApbGHLtVDb4n35nwDvQMOt0+Lk
'' SIG '' VvlYQc/xQuUQff+wdB+PxlwJ+TNe6qAcJlhc87QRD9XV
'' SIG '' w+K81Vh4v0h24URnbY+wQxAPjeT5OGK/EwHFhaNMxcyy
'' SIG '' UzCVpNb0llYIuM1cfwGWvnJSajtCN3wWeDmTk5Sbsdyy
'' SIG '' bUFtZ83Jb5A9f0VywRsj1sJVhGbks8VmBvbz1kteraMr
'' SIG '' Qoohkv6ob1olcGKBc2NeoLvY3NdK0z2vgwY4Eh0khy3k
'' SIG '' /ALWPncEvAQ2ted3y5wujSMYuaPCRx3wXdahc1cFaJqn
'' SIG '' yTdlHb7qvNhCg0MFpYumCf/RoZSmTqo9CfUFbLfSZFrY
'' SIG '' KiLCS53xOV5M3kg9mzSWmglfjv33sVKRzj+J9hyhtal1
'' SIG '' H3G/W0NdZT1QgW6r8NDT/LKzH7aZlib0PHmLXGTMze4n
'' SIG '' muWgwAxyh8FuTVrTHurwROYybxzrF06Uw3hlIDsPQaof
'' SIG '' 6aFBnf6xuKBlKjTg3qj5PObBMLvAoGMs/FwWAKjQxH/q
'' SIG '' EZ0eBsambTJdtDgJK0kHqv3sMNrxpy/Pt/360KOE2See
'' SIG '' +wFmd7lWEOEgbsausfm2usg1XTN2jvF8IAwqd661ogKG
'' SIG '' uinutFoAsYyr4/kKyVRd1LlqdJ69SK6YMIIG9jCCBN6g
'' SIG '' AwIBAgIRAJA5f5rSSjoT8r2RXwg4qUMwDQYJKoZIhvcN
'' SIG '' AQEMBQAwfTELMAkGA1UEBhMCR0IxGzAZBgNVBAgTEkdy
'' SIG '' ZWF0ZXIgTWFuY2hlc3RlcjEQMA4GA1UEBxMHU2FsZm9y
'' SIG '' ZDEYMBYGA1UEChMPU2VjdGlnbyBMaW1pdGVkMSUwIwYD
'' SIG '' VQQDExxTZWN0aWdvIFJTQSBUaW1lIFN0YW1waW5nIENB
'' SIG '' MB4XDTIyMDUxMTAwMDAwMFoXDTMzMDgxMDIzNTk1OVow
'' SIG '' ajELMAkGA1UEBhMCR0IxEzARBgNVBAgTCk1hbmNoZXN0
'' SIG '' ZXIxGDAWBgNVBAoTD1NlY3RpZ28gTGltaXRlZDEsMCoG
'' SIG '' A1UEAwwjU2VjdGlnbyBSU0EgVGltZSBTdGFtcGluZyBT
'' SIG '' aWduZXIgIzMwggIiMA0GCSqGSIb3DQEBAQUAA4ICDwAw
'' SIG '' ggIKAoICAQCQsnE/eeHUuYoXzMOXwpCUcu1aOm8BQ39z
'' SIG '' WiifJHygNUAG+pSvCqGDthPkSxUGXmqKIDRxe7slrT9b
'' SIG '' CqQfL2x9LmFR0IxZNz6mXfEeXYC22B9g480Saogfxv4Y
'' SIG '' y5NDVnrHzgPWAGQoViKxSxnS8JbJRB85XZywlu1aSY1+
'' SIG '' cuRDa3/JoD9sSq3VAE+9CriDxb2YLAd2AXBF3sPwQmnq
'' SIG '' /ybMA0QfFijhanS2nEX6tjrOlNEfvYxlqv38wzzoDZw4
'' SIG '' ZtX8fR6bWYyRWkJXVVAWDUt0cu6gKjH8JgI0+WQbWf3j
'' SIG '' OtTouEEpdAE/DeATdysRPPs9zdDn4ZdbVfcqA23VzWLa
'' SIG '' zpwe/OpwfeZ9S2jOWilh06BcJbOlJ2ijWP31LWvKX2TH
'' SIG '' aygM2qx4Qd6S7w/F7KvfLW8aVFFsM7ONWWDn3+gXIqN5
'' SIG '' QWLP/Hvzktqu4DxPD1rMbt8fvCKvtzgQmjSnC//+HV6k
'' SIG '' 8+4WOCs/rHaUQZ1kHfqA/QDh/vg61MNeu2lNcpnl8TIt
'' SIG '' UfphrU3qJo5t/KlImD7yRg1psbdu9AXbQQXGGMBQ5Pit
'' SIG '' /qxjYUeRvEa1RlNsxfThhieThDlsdeAdDHpZiy7L9GQs
'' SIG '' Qkf0VFiFN+XHaafSJYuWv8at4L2xN/cf30J7qusc6es9
'' SIG '' Wt340pDVSZo6HYMaV38cAcLOHH3M+5YVxQIDAQABo4IB
'' SIG '' gjCCAX4wHwYDVR0jBBgwFoAUGqH4YRkgD8NBd0UojtE1
'' SIG '' XwYSBFUwHQYDVR0OBBYEFCUuaDxrmiskFKkfot8mOs8U
'' SIG '' pvHgMA4GA1UdDwEB/wQEAwIGwDAMBgNVHRMBAf8EAjAA
'' SIG '' MBYGA1UdJQEB/wQMMAoGCCsGAQUFBwMIMEoGA1UdIARD
'' SIG '' MEEwNQYMKwYBBAGyMQECAQMIMCUwIwYIKwYBBQUHAgEW
'' SIG '' F2h0dHBzOi8vc2VjdGlnby5jb20vQ1BTMAgGBmeBDAEE
'' SIG '' AjBEBgNVHR8EPTA7MDmgN6A1hjNodHRwOi8vY3JsLnNl
'' SIG '' Y3RpZ28uY29tL1NlY3RpZ29SU0FUaW1lU3RhbXBpbmdD
'' SIG '' QS5jcmwwdAYIKwYBBQUHAQEEaDBmMD8GCCsGAQUFBzAC
'' SIG '' hjNodHRwOi8vY3J0LnNlY3RpZ28uY29tL1NlY3RpZ29S
'' SIG '' U0FUaW1lU3RhbXBpbmdDQS5jcnQwIwYIKwYBBQUHMAGG
'' SIG '' F2h0dHA6Ly9vY3NwLnNlY3RpZ28uY29tMA0GCSqGSIb3
'' SIG '' DQEBDAUAA4ICAQBz2u1ocsvCuUChMbu0A6MtFHsk57Rb
'' SIG '' FX2o6f2t0ZINfD02oGnZ85ow2qxp1nRXJD9+DzzZ9cN5
'' SIG '' JWwm6I1ok87xd4k5f6gEBdo0wxTqnwhUq//EfpZsK9OU
'' SIG '' 67Rs4EVNLLL3OztatcH714l1bZhycvb3Byjz07LQ6xm+
'' SIG '' FSx4781FoADk+AR2u1fFkL53VJB0ngtPTcSqE4+XrwE1
'' SIG '' K8ubEXjp8vmJBDxO44ISYuu0RAx1QcIPNLiIncgi8RNq
'' SIG '' 2xgvbnitxAW06IQIkwf5fYP+aJg05Hflsc6MlGzbA20o
'' SIG '' BUd+my7wZPvbpAMxEHwa+zwZgNELcLlVX0e+OWTOt9oj
'' SIG '' VDLjRrIy2NIphskVXYCVrwL7tNEunTh8NeAPHO0bR0ic
'' SIG '' ImpVgtnyughlA+XxKfNIigkBTKZ58qK2GpmU65co4b59
'' SIG '' G6F87VaApvQiM5DkhFP8KvrAp5eo6rWNes7k4EuhM6sL
'' SIG '' dqDVaRa3jma/X/ofxKh/p6FIFJENgvy9TZntyeZsNv53
'' SIG '' Q5m4aS18YS/to7BJ/lu+aSSR/5P8V2mSS9kFP22GctOi
'' SIG '' 0MBk0jpCwRoD+9DtmiG4P6+mslFU1UzFyh8SjVfGOe1c
'' SIG '' /+yfJnatZGZn6Kow4NKtt32xakEnbgOKo3TgigmCbr/j
'' SIG '' 9re8ngspGGiBoZw/bhZZSxQJCZrmrr9gFd2G9TGCBXow
'' SIG '' ggV2AgEBMIGQMHwxCzAJBgNVBAYTAkdCMRswGQYDVQQI
'' SIG '' ExJHcmVhdGVyIE1hbmNoZXN0ZXIxEDAOBgNVBAcTB1Nh
'' SIG '' bGZvcmQxGDAWBgNVBAoTD1NlY3RpZ28gTGltaXRlZDEk
'' SIG '' MCIGA1UEAxMbU2VjdGlnbyBSU0EgQ29kZSBTaWduaW5n
'' SIG '' IENBAhB7p5UMQyIk2V1XDOVV26UDMAkGBSsOAwIaBQCg
'' SIG '' cDAQBgorBgEEAYI3AgEMMQIwADAZBgkqhkiG9w0BCQMx
'' SIG '' DAYKKwYBBAGCNwIBBDAcBgorBgEEAYI3AgELMQ4wDAYK
'' SIG '' KwYBBAGCNwIBFTAjBgkqhkiG9w0BCQQxFgQUePYlwujR
'' SIG '' 2R89Fn/YHv7EYc0Blw0wDQYJKoZIhvcNAQEBBQAEggEA
'' SIG '' VavxKl6cTYhRIQ6XUvy8rSQvAnI8C97tjQrdLuKr74Zp
'' SIG '' 8/viT8WBpTE+Ja3HSxVU+nzaNysYruuOCCODPKt3yPej
'' SIG '' tFlcJrGW9Fv7dvTWvU45bLFsmUDnMRq0bxk7DOsE5ZRL
'' SIG '' +A5WkkPRHUhskZYP93wu37WJhZjvHbivQregu4+2DHod
'' SIG '' rCNwRWTNNiDCbTxSY06rO2+kYWw9SmYlDTYpV80wpPyr
'' SIG '' Dp8iq/R0hK4NsAlsEiOtVitlAKy1KjsCIHP/Du5lWNRy
'' SIG '' IiP6/ZvB91cmIXRhfGZYbLjhPoFrpvfXp8EqxzP+orty
'' SIG '' 8SEJTYfzW2SLoJKh1Oop93FJWt8+39VihaGCA0wwggNI
'' SIG '' BgkqhkiG9w0BCQYxggM5MIIDNQIBATCBkjB9MQswCQYD
'' SIG '' VQQGEwJHQjEbMBkGA1UECBMSR3JlYXRlciBNYW5jaGVz
'' SIG '' dGVyMRAwDgYDVQQHEwdTYWxmb3JkMRgwFgYDVQQKEw9T
'' SIG '' ZWN0aWdvIExpbWl0ZWQxJTAjBgNVBAMTHFNlY3RpZ28g
'' SIG '' UlNBIFRpbWUgU3RhbXBpbmcgQ0ECEQCQOX+a0ko6E/K9
'' SIG '' kV8IOKlDMA0GCWCGSAFlAwQCAgUAoHkwGAYJKoZIhvcN
'' SIG '' AQkDMQsGCSqGSIb3DQEHATAcBgkqhkiG9w0BCQUxDxcN
'' SIG '' MjMwMTE3MTAxNDU4WjA/BgkqhkiG9w0BCQQxMgQwWpwT
'' SIG '' RhygtVVfuCE1KOIHNP4RI9nWGOVy9VIJ6kN9M+e071/1
'' SIG '' Xg09ZxOGVhfrOaiBMA0GCSqGSIb3DQEBAQUABIICAI07
'' SIG '' PvA1BhlQ7L26t0iFIyG0rWFAbksFrgv7HH0bJwPk/CDF
'' SIG '' SMGDsxTbiiLMYiVce1l5loJXFWQjhWHX4zDW6MCCHK5U
'' SIG '' oBA4T6FnJCqyMQoQLDLUK0t0N2Tix2a6zMOCX+t27j1d
'' SIG '' aAKNvH5iY9BpkialMDgrrQIzTlhdoMVxcoIGysimHB3h
'' SIG '' GV7vg+DGgBnJQJkh3d4PBEdz+WkcDAL73bB6Ubmn4n4H
'' SIG '' IQkQwGC1QCFwzA4WIWHaldhbfE/C3NQd1unXLBUfYNNr
'' SIG '' PhVIAhZ7xHD2j6FlX2n0kbh5XtDb2rX/gk55YW9wFp/C
'' SIG '' rgtj1GobweYffRIdUAzdFxKkomXNsJ6mCD5IxW6TA8WQ
'' SIG '' yq5oQnXAv71Tm8weHRJHoNWc9AMvTyEEYzNiw2qTZnPu
'' SIG '' fVi43b4Vy97et73rVbTbOGlBxsk73lquJENSGRrkWQ7S
'' SIG '' gsqBXpgiTnnil/ZOZ+91XKW/OMga/X2JOQxWfD5SxirY
'' SIG '' OO1UO+PKSyZ9Vvk4nwo/IYU/o9LhTpq7Xpf+YMabC1Ru
'' SIG '' EwK/9RwfK7P/pxoVdWrECQMsVgrKtdwdcyThC91rXkAn
'' SIG '' 4WqMKJTVsfa6JWIJYcXHK72LpeY5wKg+Gb30+OQGBV0F
'' SIG '' ig/wEObrB54CRbNq7phyxBSnpYGsvk3plU7j/on/kpbe
'' SIG '' GqKP+N9y/faqHy+bNni9
'' SIG '' End signature block
