'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'***************  outlookimport.vbs   GPL  *************************************************
'*******************************************************************************************
'***************  Version 3.6.2.1          *************************************************
'*******************************************************************************************
'***************  Nimmt E-Mails aus Outlook entgegen und sendet diese        ***************
'***************  an den Archivserver.                                       ***************
'***************  wird gestartet vom Outlook-Addin                           ***************
'***************                                                             ***************
'***************  Syntax: wscript <server-programmpfad>outlookimport.vbs     ***************
'***************  <Pfad>                                                     ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************
Profil=""
quickimport=False
scriptdebug=False



'*******************************************************************************************
'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

On Error Resume Next

Dim objWSHShell, fso, FileIn, FileOut 
Dim Datei, Text, Txt, i, arrSort, arrTest(), oArgs, Druckername
Dim lngReturnCode
limit=60 
linklimit = 200
ReDim ext(limit)
ReDim zusatzfeld(limit)
ReDim zusatzfeldname(limit)
ReDim zwischenfeld(limit)
ReDim zwischenfeldname(limit)
ReDim linkspeicher(linklimit)
ReDim globallinks(linklimit)


lngReturnCode = 0

Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set fs      = WScript.CreateObject("Scripting.FileSystemObject") 
Set oArgs    = WScript.Arguments 

clientprogramm=""
uncclientspooler="" 
outlookimportpath=""

Typ=""
lockdatei=""
linkstring=""
linkzaehler=0
unverteilt=""
fax=False
faxnummer=""
faxzeit=""
maildomain=""
myname=""
titel=""
namestring=""
usertitel=""
gdocid=""

originaldatei = ""
richtung=""
empfaenger=""
absender=""
absenderadresse=""
empfangsuhrzeit=""
empfangsdatum=""
versanddatum=""
versanduhrzeit=""
kategorie=""
Betreff=""
cc=""
bcc=""

For i=0 To limit
    ext(i)="...."
    zusatzfeld(i)=""
    zusatzfeldname(i)=""
    zwischenfeld(i)=""
    zwischenfeldname(i)=""
Next

For i=0 To linklimit
    linkspeicher(i)=""
    globallinks(i)=""
Next
extcounter=0

acceptdoc=False
acceptxls=False
acceptdwg=False
acceptppt=False
acceptallfiletypes=False
emailacceptnoextension=False
archmsg=False
emailblack=""
emailwhite=""
attachmentdontuseoriname=False

'*******************************************************************************************
'**************************  eventlog auf 'Ereignisse berschreiben setzen' ****************
'

strComputer = "."
Set objWMIService = GetObject("winmgmts:" _
& "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")

Set objInstalledLogFiles = objWMIService.ExecQuery _
("Select * from Win32_NTEventLogFile Where LogFilename = 'Application'")

For Each objLogfile In objInstalledLogFiles
    
    If objLogfile.OverWriteOutdated <> 0 Then
        objLogfile.OverWriteOutdated = 0 
        objLogFile.Put_
    End If
    If Err.Number <> 0 Then
        objWSHShell.LogEvent 1, "Achtung ! Im Eventlog des Clients ist nicht die Option 'Eintrge bei Bedarf berschreiben' gesetzt. Logging und Scriptdebug werden daher ausgeschaltet." 
        scriptdebug = False
        logging = False
        Err.Clear
        On Error Resume Next
    End If
    
Next

Set objLogfile = Nothing
Set objInstalledLogFiles = Nothing
Set objWMIService = Nothing


'*******************************************************************************************
'*******************************************************************************************
'**************************  Startparameter initialisieren  ********************************
Err.clear
fullpath = WScript.ScriptFullName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
scriptname = WScript.ScriptName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
If Len(programm)=0 Then
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If

templates=programm&"templates\"



inilesen

ext(0)=".tif"
ext(1)=".ps"
ext(2)=".pdf"
ext(3)=".bmp"
ext(4)=".jpg"
ext(5)=".gif"
ext(6)=".jpeg"
extcounter=7

If acceptdoc=True Then
    ext(extcounter)=".doc"
    ext(extcounter+1)=".rtf"
    ext(extcounter+2)=".htm"
    ext(extcounter+3)=".txt"
    extcounter=extcounter+4
End If

If acceptxls=True Then
    ext(extcounter)=".xls"
    ext(extcounter+1)=".dbf"
    ext(extcounter+2)=".tab"
    extcounter=extcounter+3
End If

If acceptppt=True Then
    ext(extcounter)=".ppt"
    ext(extcounter+1)=".pps"
    extcounter=extcounter+2
End If

If acceptdwg=True Then
    ext(extcounter)=".dwg"
    ext(extcounter+1)=".dxf"
    extcounter=extcounter+2
    
End If


temppath = objWSHShell.ExpandEnvironmentStrings("%temp%")    
If outlookimportpath="" Then
    outlookimportpath = objWSHShell.ExpandEnvironmentStrings("%temp%")    
End If

If Err.number<>0 Then
    MsgBox("bitfarm-Archiv: Fehler: Kann TEMP-Variable nicht auswerten.")
    Err.clear
    WScript.Quit
End If 
username = objWSHShell.ExpandEnvironmentStrings("%username%")    
If Err.number<>0 Then
    MsgBox("bitfarm-Archiv: Fehler: Kann USERNAME-Variable nicht auswerten.")
    Err.clear
    WScript.Quit
End If 

If (Len(username)<1) Or (username="%username%") Or (username="") Then
    username="unbekannt"
End If


dokdate=""

'*******************************************************************************************
'**************************  Parameter  ****************************************************
modus="direct"

Err.clear
Typ = "OMP"


If oArgs.Count > 0 And oArgs.Count <3 Then
    
    Profil = oArgs.item(1) 
    If Err.number<>0 Then
        Err.clear
        modus="abfrage"
    End If 
    
    
    If modus = "direct" Then
        Tabelle = oArgs.item(0) 
        If Err.number<>0 Then
            Err.clear
            modus="abfrage"
        End If 
    End If
Else
    modus = "abfrage"
    
End If



'*******************************************************************************************
'**************************  Prfen, ob Server bereit  *************************************


erfolg=readconfig(Profil)
If erfolg=False Then
    removemsg()
    MsgBox("bitfarm-Archiv: Kann Konfigurationsdatei nicht lesen ("&Profil&")")
    Unlock(lockdatei)
    WScript.Quit
End If

druckpfad = uncclientspooler 

zahl = Zufallszahl(100000,999999)


'*******************************************************************************************
'**************************  Alle Jobdateien lschen, die evtl. noch vorhanden sind  *******

i=0
Set folder = fs.GetFolder(temppath)
For Each file In folder.files
    
    If (Right(file,3) = "job") Or (Right(file,3) = "JOB") Then
        Err.clear
        fs.DeleteFile file, True
        If Err.number<>0 Then
            removemsg()
            MsgBox("bitfarm-Archiv: Kein Schreibzugriff auf das TEMP-Verzeichnis. Bitte informieren Sie Ihren Administrator.")
            Err.clear
            Unlock(lockdatei)
            WScript.Quit
        End If
    End If
Next


'**************************************************************************************************
'******************************************   Zielabfrage   ***************************************
'**************************************************************************************************

If modus = "direct" Then
    
    If fs.fileexists(templates&Tabelle&".TPL") Then
        fs.CopyFile templates&Tabelle&".TPL", temppath&"\"&Tabelle&".job", True
        If Err.number Then
            Err.clear
            objWSHShell.LogEvent 1, "bitfarm-Archiv: archivspooler: Fehler bei Kopieren einer Vorlagendatei ("&Tabelle&")"
            WScript.Quit
        End If 
    Else
        If unverteilt<>"" Then
            Tabelle=unverteilt
        Else
            Tabelle="unverteilt"
        End If
        If fs.fileexists(templates&Tabelle&".TPL") Then
            fs.CopyFile templates&Tabelle&".TPL", temppath&"\"&Tabelle&".job", True
        Else
            modus="abfrage"
        End If
    End If
End If


If modus = "abfrage" Then
	' Meta auslesen, nackten Job erzeugen (ohne Archiv-Template), Metadaten reinpasten, Verzeichnis mit allen
	' attachments + Mail selbst erzeugen, gleichnamige Kopie des erzeugten Jobs dazulegen
	' dann ViewerV3.exe mit -DD:<Pfad auf Ordner> aufrufen, dann beenden.
	' outlookimport beenden
	myfoldername=outlookimportpath

	Set myfolder=fs.getfolder(myfoldername)
	For Each folder In myfolder.subfolders
    	If Left(folder.name,8)="bfa-mail" Then
			blacklist(folder) ' blacklist attachments entfernen
		    
		    ' die mssen auch leer gesetzt werden fr jede neue Mail
		    For i=0 To limit
			    zusatzfeld(i)=""
			    zusatzfeldname(i)=""
			Next
		    
		    readEMAILMetas(folder) ' metadaten in zusatzfeld-array einlesen
		    
		    'GP: linkspeicher (Verknpfungen) leeren, damit nicht die Verknpfungen vom Vorgnger mitbernommen werden
		    'FS: das hat ja nicht so wirklich geklappt, wenn man linkspeicher leersetzt und in checklink der wieder mit alten werten aus den zusatzfeldern gefllt wird
		    linkzaehler = 0
			For i = 0 To linklimit 
		      linkspeicher(i) = ""
		    Next
		    
		    checklink(folder)
		    If fax=True Then
		        readFAXMetas(folder)
		        linkstring=""
		    End If
	    
		    ' neues Temp Verzeichnis erstellen
    		' dort die Mail selbst und alle brigen attachments kopieren
    		importfoldername = temppath & "\" & "bfa-import" 
    		importfoldername = importfoldername & Zufallszahl(100000,999999)
    		
    		While fs.FolderExists(importfoldername)
    			importfoldername = importfoldername & Zufallszahl(100000,999999)
    		Wend
    		'MsgBox(folder)
    		Set importfolder = fs.CreateFolder(importfoldername)
    		For Each file In folder.Files
    			If Left(file.Name,4) <> "bfa-" Or LCase(file.Name) = "bfa-mail.msg" Then
    				originaldatei = file.Name
    				fs.CopyFile file, importfolder.Path & "\" & file.Name
    				basename = fs.GetBaseName(file)
    				writeEMAILslwdatei(importfolder.Path & "\" & basename&".slw")
    			End If
    		Next
		    
		    dokdate=setdokdate()
		    
		    If Typ="OMP" Then
		        Typ="EMP"
		    End If
		    If Typ="TXT" Then
		        Typ="EXT"
		    End If
		    
		    ' mit den ermittelten Werten aus Zusatzfeldern und Link Job-Template erstellen
    		' und pro Datei im importfolder eine Kopie des Jobs mit dem Namen der Datei erstellen
    		' Viewer Aufruf mit -DD:<temp-Ordner>
		    For Each importfile In importfolder.Files
		    	createimportjob(importfile)
		    Next
	
			' Kommandozeilenbeschrnkung von 2047 Zeichen umgehen, in dem wir mehrmals an den Viewer senden
			If Len(Chr(34) & programm & "ViewerV3.exe" & Chr(34) & arg) + Len(" -DD:" &Chr(34)& importfolder.path &Chr(34)) > 2000 Then
				If scriptdebug=True Then
					objWSHShell.LogEvent 1, "copytobitfarm.vbs Starting ViewerV3.exe:" & vbCrLf & arg
				End If
				
				lngReturnCode = objWSHShell.Run(Chr(34) & programm & "ViewerV3.exe" & Chr(34) & arg, 1, True)
				
				If lngReturnCode <> 0 Then
					objWSHShell.LogEvent 1, "copytobitfarm.vbs starting ViewerV3.exe:" & vbCrLf & arg & vbCrLf & vbCrLf & "error while importing, ViewerV3.exe returncode " & lngReturnCode

				End If
				arg = ""   ' zurcksetzen, Schleife fortfahren lassen
			End If

            'msgbox(importfolder.path)
			'arg = Chr(34) &programm& "ViewerV3.exe" &Chr(34)& " -DD:" &Chr(34)& importfolder.path &Chr(34)
                         arg = arg & " -DD:" &Chr(34)& importfolder.path &Chr(34)

'			If scriptdebug=True Then
'				objWSHShell.LogEvent 1, "outlookimport.vbs Starting ViewerV3.exe:" & vbCrLf & arg'
'			End If
			
'			lngReturnCode = objWSHShell.Run(arg, 1, False)
			
		    'MsgBox("viewer gestartet")
		  	' th 10.10.2017 -> bfa-mail Ordner muss gelscht sein, damit das Addin das Flag setzt
      		fs.deletefolder(folder)  
		End If
	Next
	
    If arg <> "" then		
      If scriptdebug=True Then
        objWSHShell.LogEvent 1, "outlookimport.vbs Starting ViewerV3.exe:" & vbCrLf & arg
      End If
 			
'     Hinweis: mit 500 Parametern konnte der Viewer unter WIN10 gestartet werden und der Viewer hat sogar alle Parameter empfangen!!!
	  
      lngReturnCode = objWSHShell.Run(Chr(34) & programm & "ViewerV3.exe" & Chr(34) & arg, 1, False)
    End if
     
	' bfa-mail Ordern entfernen
	Delete_bfamailfolder(outlookimportpath)
	' bfa-import Ordner wird vom Viewer entfernt
    Unlock(lockdatei)
    WScript.Quit
End If



showmsg()


'**************************************************************************************************
'*******************************    Jobdatei suchen   *********************************************
'**************************************************************************************************
template=""
Set folder = fs.GetFolder(temppath)
For Each file In folder.files
    
    If (Right(file,3) = "job") Or (Right(file,3) = "JOB") Then
        template=file
    End If
Next
Set folder = Nothing



If template<>"" Then
    Set tempobject=fs.getfile(template)
    templatename=tempobject.name
    Set tempobject=Nothing
    templatename=Left(templatename,Len(templatename)-4)
Else
    Unlock(lockdatei)
    removemsg()
    WScript.quit
End If
'MsgBox template

'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************

Profil=""
erfolg=readjob(template)

If erfolg=False Then
    removemsg()
    MsgBox("bitfarm-Archiv: Kann zum angegebenen Archiv kein Template finden ("&template&")")
    Unlock(lockdatei)
    
    WScript.Quit
End If

For i=0 To linklimit
    globallinks(i)=linkspeicher(i)
Next

For i=0 To limit
    zwischenfeld(i)=zusatzfeld(i)
    zwischenfeldname(i)=zusatzfeldname(i)
Next


erfolg=readconfig(Profil)
If erfolg=False Then
    removemsg()
    ret=MsgBox ("bitfarm-Archiv: Kann Profil des Templates nicht lesen" &vbCrLf&"Profil:"&Profil&vbCrLf&"Template:" & template,0,"Outlookimport.vbs")
    Unlock(lockdatei)
    
    WScript.Quit
End If

druckpfad = uncclientspooler 

If druckpfad="" Then
    removemsg()
    MsgBox("bitfarm-Archiv: Fehler: Konnte keinen bergabepfad zum Server bestimmen.")
    Unlock(lockdatei)
    
    WScript.Quit
End If


'If (Typ <> "TXT") AND (Typ <> "OCR") AND (Typ <> "OMP") Then
'	MsgBox("Falscher Texterkennungstyp. Bitte Script autoscan.vbs prfen.")
'	Unlock(lockdatei)
'	WScript.Quit
'End If

'*******************************************************************************************
'************************************ Parameter in Jobdatei  *******************************
dokdate=setdokdate()
'erfolg = writejob(Left(template,Len(template)-4))
'If erfolg=false Then
'	MsgBox("bitfarm-Archiv(3d): kann Parameter nicht in Jobdatei schreiben - kann nicht archivieren. Bitte informieren Sie den Administrator.")
'	Unlock(lockdatei)
'	WScript.Quit
'End If



'*************************************************************************************
'**************************   Parameterbergabe und Hauptschleife ********************
'************************************************************************************* 

'MsgBox("bitfarm-Archiv: Die gewhlten Dateien / Ordner werden nun archiviert. Bitte warten Sie, bis die Besttigung angezeigt wird.")
Err.clear
i=0
dateianzahl=0
datei=""
abbruch1=False

myfoldername=outlookimportpath

Set myfolder=fs.getfolder(myfoldername)
For Each folder In myfolder.subfolders
    
    
    If Left(folder.name,8)="bfa-mail" Then
        
        linkstring=""
        linkzaehler=0
        For i=0 To linklimit
            If globallinks(i)<>"" Then
                linkspeicher(linkzaehler)=globallinks(i)
                linkzaehler=linkzaehler+1
            End If
        Next
        
        
        For i=0 To limit
            zusatzfeld(i)=zwischenfeld(i)
            zusatzfeldname(i)=zwischenfeldname(i)
        Next
        'myname=""
        
        blacklist(folder)
        
        'checkunicodehtml(folder)
        'bernimmt mittlerweile die Archivierung ab 3.4.0.35
        
        'erfolg=readjob(template)
        '		If erfolg=false Then
        '			MsgBox("bitfarm-Archiv: Kann zum angegebenen Archiv kein Template finden ("&template&")")
        '			Unlock(lockdatei)
        '			WScript.Quit
        '		End If
        readEMAILMetas(folder)
        
        If fax=True Then
            readFAXMetas(folder)
            linkstring=""
        End If
        ' myname ist immer dann leer, wenn der Anwender keinen Doktitel eingetragen hat
        ' in diesem Fall fr alle Mails/Anhnge diesen Doktitel setzen
        If usertitel<>"" Then
            myname = usertitel
        End If
        
        If myname <> "" Then
            usertitel = myname
        End If
        
        If myname = "" Then
            If betreff <> "" Then
                myname = normstring(betreff)
            Else
                myname = "E-Mail Nachricht"
            End If
        End If
        
        
        dokdate=setdokdate()
        
        If Typ="OMP" Then
            Typ="EMP"
        End If
        If Typ="TXT" Then
            Typ="EXT"
        End If
        
        syncarrays '*************** User eingegebene Zusatzfelder berschreiben ausgelesene **********
        
        archmail(folder)
        If usertitel<>"" Then
            myname = usertitel
        Else
            myname = ""
        End If
        
    End If
Next




'**************************************************************************************************
'*************************************  aufrumen und Ende  ***************************************
'**************************************************************************************************

'MsgBox "Ende der archivierung"
WScript.sleep 1000 '++ Damit User auf jeden Fall die showmsg-meldung sehen
removemsg()

cleanup

Unlock(lockdatei)
WScript.Quit


'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************

Function createimportjob(importfile)
	'WScript.Echo importfile
	filefolder = importfile.ParentFolder
	filename = importfile.Name
	extension = fs.GetExtensionName(importfile)
	filebasename = fs.GetBaseName(importfile)
	
	'If usertitel = "" Then
		'If attachmentdontuseoriname = True Then
	    	'myname = normstring(betreff)
	    'Else
	        'myname = filebasename
	    'End If
	'Else
		'myname = usertitel
	'End If	
	
	' die Email selbst heisst immer bfa-Mail
	If filebasename = "bfa-Mail" Then
		myname = normstring(betreff)
	' alles andere sind attachments und heissen wir die Originaldatei
	Else
		myname = filebasename
	End If
	Set newjobfile = fs.CreateTextFile(filefolder & "\" & filebasename & ".job", True)
	newjobfile.WriteLine("[Version]")
	newjobfile.WriteLine("Version=36")
	newjobfile.WriteLine("[Archiv]")
	newjobfile.WriteLine("Profil=")
	
	newjobfile.WriteLine("Name=")
	newjobfile.WriteLine("Tabelle=")
	newjobfile.WriteLine("[Document]")
	newjobfile.WriteLine("DOCID=")
	newjobfile.WriteLine("Titel="&myname)
	newjobfile.WriteLine("Orginal=")
	newjobfile.WriteLine("Kopie=")
	newjobfile.WriteLine("Quelle=")
	newjobfile.WriteLine("Benutzer=")
	newjobfile.WriteLine("Volltext=")
	newjobfile.WriteLine("Status=")
	newjobfile.WriteLine("StatStr=")
	newjobfile.WriteLine("OCR_QF=")
	newjobfile.WriteLine("OCR_Typ=")
	newjobfile.WriteLine("Pages=")
	newjobfile.WriteLine("gdoc_id=")
	newjobfile.WriteLine("Schlagworte=")
	newjobfile.WriteLine("Datum=")
	newjobfile.WriteLine("Filter=fromoutlook")
	newjobfile.WriteLine("[Referenz]")
	
	reftotal = 0
	For Each lnk In linkspeicher
		If lnk <> "" Then
			reftotal = reftotal + 1
		End If
	Next
	
	newjobfile.WriteLine("Anzahl="&reftotal)
	
	refcount = 0
	For i = 0 To limit
		If linkspeicher(i) <> "" Then
			refcount = refcount + 1
			newjobfile.WriteLine("Referenz"&refcount&"="&linkspeicher(i))
		End If
	Next
	
	newjobfile.WriteLine("[Tasks]")
	newjobfile.WriteLine("Termin=")
	newjobfile.WriteLine("Alarm=")
	newjobfile.WriteLine("Bearbeiter=")
	newjobfile.WriteLine("Notiz=")
	newjobfile.WriteLine("[Zusatzfelder]")
	newjobfile.WriteLine("Felder=0")

	newjobfile.Close

End Function




Function archmail(folder)
    On Error Resume Next
    
    Set ordner=fs.getfolder(folder)
    
    Set anzfiles = ordner.files
    
    If anzfiles.count = 0 Then
        Set anzfiles = Nothing	
        Set ordner=Nothing
        fs.deletefolder folder, True
        Exit Function
        
    End If
    
    If fax=True Then
        If fs.fileexists(folder&"\bfa-mail.html") Then
            fs.DeleteFile folder&"\bfa-mail.html", True
        End If
        If fs.fileexists(folder&"\bfa-mail.txt") Then
            fs.DeleteFile folder&"\bfa-mail.txt", True
        End If
        If fs.fileexists(folder&"\bfa-Metadaten.txt") Then
            fs.DeleteFile folder&"\bfa-Metadaten.txt", True
        End If
        
    End If
    
    If fax=False Then
        
        
        ' wenn das dokument als dok vorhanden ist dann alle internen grafiken lschen
        rkv = RegRead("HKEY_CURRENT_USER\Software\bitfarm\Archiv_V3\Makros\selectattachments")
        If rkv <> "-1" Then
	        If fs.fileexists(folder&"\bfa-mail.doc") Then
	            Set maildateienfolder = fs.getfolder(folder&"\bfa-Mail-Dateien")
	            For Each maildateien In maildateienfolder.Files
	                If fs.fileexists(folder&"\" & fs.getfilename(maildateien)) Then
	                    fs.Deletefile (folder&"\" & fs.getfilename(maildateien)),True
	                    If Err.number<> 0 Then
	                        Err.clear
	                    End If
	                End If
	            Next
	        End If
	    End If
        
        checklink(folder)
        
        erfolg = writejob(Left(template,Len(template)-4))
        If erfolg=False Then
            removemsg()
            MsgBox("bitfarm-Archiv(3b): kann Parameter nicht in Jobdatei schreiben - kann nicht archivieren. Bitte informieren Sie den Administrator.")
            Unlock(lockdatei)
            
            WScript.Quit
        End If
        erfolg = writeEMAILjob(Left(template,Len(template)-4))
        If erfolg=False Then
            removemsg()
            MsgBox("bitfarm-Archiv(3c): kann Parameter nicht in Jobdatei schreiben - kann nicht archivieren. Bitte informieren Sie den Administrator.")
            Unlock(lockdatei)
            WScript.Quit
        End If
        
        
        
        If fs.fileexists(folder&"\bfa-mail.html") Or fs.fileexists(folder&"\bfa-mail.doc")Then
            writeEMAILslwdatei(Left(template,Len(template)-4)&".slx")
            archhtml(folder&"\bfa")
        ElseIf fs.fileexists(folder&"\bfa-mail.txt") Then
            writeEMAILslwdatei(Datei)
            
            archtxt(folder&"\bfa")
        Else
            ' wenn keine doc/html oder keine txt-mail dann den rest auch lschen
            Err.clear
            If fs.fileexists(folder&"\bfa-Mail.doc") Then
                fs.deletefile folder&"\bfa-Mail.doc", True
            End If
            
            If fs.fileexists(folder&"\bfa-Mail.msg") Then
                fs.deletefile folder&"\bfa-Mail.msg", True
            End If
            If fs.fileexists(folder&"\bfa-Mail.html") Then
                fs.DeleteFile folder&"\bfa-Mail.html", True
            End If
            If fs.fileexists(folder&"\bfa-Mail.txt") Then
                fs.DeleteFile folder&"\bfa-Mail.txt", True
            End If
            If fs.fileexists(folder&"\bfa-Metadaten.txt") Then
                fs.DeleteFile folder&"\bfa-Metadaten.txt", True
            End If
            If Err.number<>0 Then
                Err.clear
            End If	
            
            
        End If
    End If
    
    
    ' job jetzt neu schreiben ohne gdocid (Ticket 3635)
    gdocid=""
    erfolg = writeEMAILjob(Left(template,Len(template)-4))
    For Each file In ordner.files
        
        archfile(file)
        
    Next
    
    Set ordner=Nothing
    
    fs.deletefolder folder, True
    
End Function


'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************


Function blacklist(folder)
    On Error Resume Next
    i=0
    Set myfolder=fs.getfolder(folder)
    For Each file In folder.files
        
        
        If Left(file.Name,4) <> "bfa-" Then
            
            erlaubt = False		
            
            myextension = fs.GetExtensionName(file)
            myextension = LCase(myextension)
            
            
            If emailwhite="" And emailblack="" Then
                erlaubt = True
            Else
                If InStr(1,emailwhite,myextension) <> 0 Or emailwhite = "" Then
                    erlaubt = True
                End If
                If InStr(1,emailblack,myextension) <> 0  Then
                    erlaubt = False
                End If
            End If
            
            If myextension = "" And emailacceptnoextension = True Then
                erlaubt = True
            End If
            
            If myextension = "" And emailacceptnoextension = False Then
                erlaubt = False
            End If
            
            'MsgBox erlaubt
            
            If erlaubt = True Then
                i=i+1
            Else
                fs.deletefile file, True
                If Err.number<>0 Then
                    Err.clear
                    removemsg()
                    MsgBox("bitfarm-Archiv: outlook.vbs: kann ber Blacklist gesperrte Datei nicht lschen" & vbCrLf & file.Name)
                    Unlock(lockdatei)
                    WScript.Quit
                    
                End If
                
            End If
        End If
        
    Next
    Set myfolder=Nothing
    
End Function

Function checklink(folder)
    'MsgBox "anzahl links:" & i
    
    'If fs.fileexists(folder&"\bfa-mail.html") Then
    '	i=i-1
    'End If
    'If fs.fileexists(folder&"\bfa-Metadaten.txt") Then
    '	i=i-1
    'End If
    'If fs.fileexists(folder&"\bfa-mail.txt") Then
    '	i=i-1
    'End If
    i = 0
    Set linkfolder = fs.GetFolder(folder)
    For Each linkfile In linkfolder.Files
        
        If InStr(1,LCase(linkfile.Name),"bfa-mail") = 0 And InStr(1,LCase(linkfile.Name),"bfa-metadaten") = 0  Then
            i =i +1
        End If
        
    Next 
    
    Set linkfolder = Nothing
    
    If i>0 Then
        linkstring="EMail"
        
        
        linkabsender=""
        linkversanddatum=""
        linkversandzeit=""
        
        For x=0 To limit
            If zusatzfeldname(x)="Absenderadresse" Then
                linkabsender=zusatzfeld(x)
            End If
            If zusatzfeldname(x)="Absender" Then
                linkabsender=zusatzfeld(x)
            End If
            If zusatzfeldname(x)="Versanddatum" Then
                linkversanddatum=zusatzfeld(x)
            End If
            If zusatzfeldname(x)="Versandzeit" Then
                linkversandzeit=zusatzfeld(x)
            End If
            
        Next
        If linkabsender="" Then
            linkabsender=zufallszahl(100,999)
        End If
        If linkversanddatum="" Then
            linkversanddatum=zufallszahl(100,999)
        End If
        If linkversandzeit="" Then
            linkversandzeit=zufallszahl(100,999)
        End If
        
        linkspeicher(linkzaehler)=linkstring&":"&linkabsender&"_"&linkversanddatum&"_"&linkversandzeit
        linkzaehler=linkzaehler+1
        
    End If
    
    'MsgBox"linkstring;" & linkstring
    
    
End Function



'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************


Function archfile(Datei)
    On Error Resume Next
    'MsgBox(Datei)
    extension=""
    
    If fs.GetExtensionName(datei)<>"" Then
        extension = "." & LCase(fs.GetExtensionName(datei))
    End If
    
    u=0
    'MsgBox "extcounter:"&extcounter
    Do While u<=extcounter
        
        If (extension=ext(u)) Or (acceptallfiletypes=True) Then
            
            writeslwdatei(datei)
            sendtoserver(Datei)
            dateianzahl=dateianzahl+1
            Exit Do
            
        End If
        u=u+1
    Loop
    
    
End Function



Function archhtml(datei)
    
    On Error Resume Next
    archhtml=False
    zahl = Zufallszahl(100000,999999)
    If quickimport=False Then
        Ausgabename=druckpfad&"msgfile"&zahl
    Else
        Ausgabename=druckpfad&"msgfast"&zahl
    End If
    If fs.FileExists(Ausgabename&".job") Then
        
        
        zahl = Zufallszahl(100000,999999)
        If quickimport=False Then
            Ausgabename=druckpfad&"msgfile"&zahl
        Else
            Ausgabename=druckpfad&"msgfast"&zahl
        End If
        
        If fs.FileExists(Ausgabename&".job") Then
            
            
            zahl = Zufallszahl(100000,999999)
            If quickimport=False Then
                Ausgabename=druckpfad&"msgfile"&zahl
            Else
                Ausgabename=druckpfad&"msgfast"&zahl
            End If
            If fs.FileExists(Ausgabename&".job") Then
                removemsg()
                MsgBox("bitfarm-Archiv: Fehler: Doppelter Dateinamen bergabepfad. Kann nicht archivieren.")
                Unlock(lockdatei)
                WScript.Quit
            End If
        End If
    End If
    
    '***************************  Ausgabepfad prfen
    
    If fs.FileExists(Ausgabename&".slw") Then
        WScript.Sleep 1500
        If fs.FileExists(Ausgabename&".slw") Then
            removemsg()
            MsgBox("bitfarm-Archiv: Fehler[5]: Server leert nicht den bergabepfad. Kann nicht archivieren.")
            Unlock(lockdatei)
            WScript.Quit
            
        End If
    End If
    If fs.FileExists(Ausgabename&".ftx") Then
        WScript.Sleep 1500
        If fs.FileExists(Ausgabename&".ftx") Then
            removemsg()
            MsgBox("bitfarm-Archiv: Fehler[6]: Server leert nicht den bergabepfad. Kann nicht archivieren.")
            Unlock(lockdatei)
            WScript.Quit
            
        End If
    End If
    
    '******************************  Kopieren
    
    Err.clear
    fs.CopyFile template, Ausgabename&".job", True
    If Err.number<>0 Then
        Err.clear
        removemsg()
        MsgBox("bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
        Unlock(lockdatei)
        WScript.Quit
    End If
    
    
    Err.clear
    If fs.FileExists(temppath&"\"&templatename&".slx") Then
        fs.CopyFile temppath&"\"&templatename&".slx", Ausgabename&".slw", True
        If Err.number<>0 Then
            Err.clear
            removemsg()
            MsgBox("bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
            Unlock(lockdatei)
            WScript.Quit
        End If
    End If
    'If fs.FileExists(template&".slw") Then
    'fs.deletefile template&".slw", True
    'If err.number<>0 Then
    '		err.clear
    '    		MsgBox("bitfarm-Archiv: Fehler bei Datenbergabe an den Server. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
    '    		WScript.Quit
    '    		
    'End If
    'End If
    If fs.FileExists(datei&"-Mail.txt") Then
        'fs.CopyFile datei&"-Mail.txt", Ausgabename&".ftx", True
        If Err.number<>0 Then
            Err.clear
            removemsg()
            MsgBox("bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
            Unlock(lockdatei)
            WScript.Quit
        End If
        'Typ="EXT"
        
        
    End If
    
    If fs.FileExists(datei&"-Mail.msg") Then
        fs.CopyFile datei&"-Mail.msg", Ausgabename&".msg", True
        If Err.number<>0 Then
            Err.clear
            removemsg()
            MsgBox("bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
            Unlock(lockdatei)
            WScript.Quit
        End If
    End If
    
'    If archmsg=False Then
'        If fs.fileexists (datei&"-Mail.doc") Then
'            extension=".doc"
'            fs.CopyFile Datei&"-Mail.doc", Ausgabename&extension, True
'            If Err.number<>0 Then
'                Err.clear
'                removemsg()
'                MsgBox("bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
'                Unlock(lockdatei)
'                WScript.Quit
'            End If
            
'        Else
            
'            extension=".htm"
            
'            fs.CopyFile Datei&"-Mail.html", Ausgabename&extension, True
            
'            If Err.number<>0 Then
'                Err.clear
'                removemsg()
'                MsgBox("bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
'                Unlock(lockdatei)
'                WScript.Quit
'            End If
            
'        End If
'    End If
    
    archhtml=True
    
    Err.clear
    'On Error Resume next
    If fs.fileexists(datei&"-Mail.doc") Then
        fs.deletefile datei&"-Mail.doc", True
    End If
    
    If fs.fileexists(datei&"-Mail.msg") Then
        fs.deletefile datei&"-Mail.msg", True
    End If
    If fs.fileexists(datei&"-Mail.html") Then
        fs.DeleteFile datei&"-Mail.html", True
    End If
    If fs.fileexists(datei&"-Mail.txt") Then
        fs.DeleteFile datei&"-Mail.txt", True
    End If
    If fs.fileexists(datei&"-Metadaten.txt") Then
        fs.DeleteFile datei&"-Metadaten.txt", True
    End If
    If Err.number<>0 Then
        Err.clear
    End If
    
    
End Function




Function archtxt(datei)
    On Error Resume Next
    'archtxt=false
    'zahl = Zufallszahl(100000,999999)
    'If quickimport=false Then
    'Ausgabename=druckpfad&"file"&zahl
    'Else
    'Ausgabename=druckpfad&"fast"&zahl
    'End If
    'If fs.FileExists(Ausgabename&".job") Then
    '	Wscript.Sleep 1500
    '	If fs.FileExists(Ausgabename&".job") Then
    '		MsgBox("bitfarm-Archiv: Fehler: Server leert nicht den bergabepfad. Kann nicht archivieren.")
    '		Unlock(lockdatei)
    '		WScript.Quit
    '	End If
    'End If
    
    
    
    archtxt=False
    zahl = Zufallszahl(100000,999999)
    If quickimport=False Then
        Ausgabename=druckpfad&"msgfile"&zahl
    Else
        Ausgabename=druckpfad&"msgfast"&zahl
    End If
    
    
    If fs.FileExists(Ausgabename&".job") Then
        zahl = Zufallszahl(100000,999999)
        If quickimport=False Then
            Ausgabename=druckpfad&"msgfile"&zahl
        Else
            Ausgabename=druckpfad&"msgfast"&zahl
        End If
        If fs.FileExists(Ausgabename&".job") Then
            zahl = Zufallszahl(100000,999999)
            If quickimport=False Then
                Ausgabename=druckpfad&"msgfile"&zahl
            Else
                Ausgabename=druckpfad&"msgfast"&zahl
            End If
            
            
            WScript.Sleep 1500
            If fs.FileExists(Ausgabename&".job") Then
                removemsg()
                MsgBox("bitfarm-Archiv: Fehler: Serverdienst reagiert nicht.")
                objWshShell.LogEvent 1, "bitfarm-Archiv: Outlookimport.vbs[1]:"&vbCrLf&"Server leert nicht den bergabepfad. Kann nicht archivieren."&vbCrLf&Ausgabename & ".job"
                Unlock(lockdatei)
                WScript.Quit
            End If
        End If
        
    End If
    
    
    Err.clear
    fs.CopyFile template, Ausgabename&".job", True
    If Err.number<>0 Then
        Err.clear
        removemsg()
        MsgBox("bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
        Unlock(lockdatei)
        WScript.Quit
    End If
    
    If fs.FileExists(Ausgabename&".slw") Then
        WScript.Sleep 1500
        If fs.FileExists(Ausgabename&".slw") Then
            removemsg()
            MsgBox("bitfarm-Archiv: Fehler[2]: Server leert nicht den bergabepfad. Kann nicht archivieren.")
            Unlock(lockdatei)
            WScript.Quit
            
        End If
    End If
    If fs.FileExists(Ausgabename&".ftx") Then
        WScript.Sleep 1500
        If fs.FileExists(Ausgabename&".ftx") Then
            removemsg()
            MsgBox("bitfarm-Archiv: Fehler[3]: Server leert nicht den bergabepfad. Kann nicht archivieren.")
            Unlock(lockdatei)
            WScript.Quit
            
        End If
    End If
    
    Err.clear
    If fs.FileExists(temppath&"\slx"&templatename&".slx") Then
        fs.CopyFile temppath&"\slx"&templatename&".slx", Ausgabename&".slw", True
        If Err.number<>0 Then
            Err.clear
            MsgBox("bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
            Unlock(lockdatei)
            WScript.Quit
        End If
    End If
    If fs.FileExists(datei&"-Mail.msg") Then
        If archmsg=True Then
            If fs.FileExists(datei&"-Mail.txt") Then
                fs.deleteFile datei&"-Mail.txt", True 
            End If
        End If
        fs.CopyFile datei&"-Mail.msg", Ausgabename&".msg"
        If Err.number<>0 Then
            Err.clear
            removemsg()
            MsgBox("bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
            Unlock(lockdatei)
            WScript.Quit
        End If
    End If
    
    
    
    extension=".txt"
    'MsgBox "Ausgabename&extension:"&Ausgabename&extension
    'MsgBox "datei:"&fs.GetbaseName(datei)
    
    If fs.FileExists(datei&"-Mail.txt") Then
        fs.CopyFile datei&"-Mail.txt", Ausgabename&extension, True
        
        If Err.number<>0 Then
            Err.clear
            removemsg()
            MsgBox("bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
            Unlock(lockdatei)
            WScript.Quit
        End If
    End If
    
    
    archtxt=True
    
    Err.clear
    'On Error Resume next
    If fs.fileexists(datei&"-Mail.msg") Then
        fs.deletefile datei&"-Mail.msg", True
    End If
    
    If fs.fileexists(datei&"-Mail.txt") Then
        fs.DeleteFile datei&"-Mail.txt", True
    End If
    If fs.fileexists(datei&"-Metadaten.txt") Then
        fs.DeleteFile datei&"-Metadaten.txt", True
    End If
    
    
End Function



Function sendtoserver(datei)
    On Error Resume Next
    'MsgBox("sendtoserver " & Datei)
    sendtoserver=False
    zahl = Zufallszahl(100000,999999)
    If quickimport=False Then
        Ausgabename=druckpfad&"msgfile"&zahl
    Else
        Ausgabename=druckpfad&"msgfast"&zahl
    End If
    
    
    If fs.FileExists(Ausgabename&".job") Then
        zahl = Zufallszahl(100000,999999)
        If quickimport=False Then
            Ausgabename=druckpfad&"msgfile"&zahl
        Else
            Ausgabename=druckpfad&"msgfast"&zahl
        End If
        If fs.FileExists(Ausgabename&".job") Then
            zahl = Zufallszahl(100000,999999)
            If quickimport=False Then
                Ausgabename=druckpfad&"msgfile"&zahl
            Else
                Ausgabename=druckpfad&"msgfast"&zahl
            End If
            
            
            WScript.Sleep 1500
            If fs.FileExists(Ausgabename&".job") Then
                removemsg()
                MsgBox("bitfarm-Archiv: Fehler: Serverdienst reagiert nicht.")
                objWshShell.LogEvent 1, "bitfarm-Archiv: Outlookimport.vbs[0]:"&vbCrLf&"Server leert nicht den bergabepfad. Kann nicht archivieren."&vbCrLf&Ausgabename & ".job"
                Unlock(lockdatei)
                WScript.Quit
            End If
        End If
        
    End If
    
    
    
    
    '################################################
    'MsgBox "sendtoserver:" & datei
    'sendtoserver=false
    'zahl = Zufallszahl(100000,999999)
    'If quickimport=false Then
    'Ausgabename=druckpfad&"file"&zahl
    'Else
    'Ausgabename=druckpfad&"fast"&zahl
    'End If
    'If fs.FileExists(Ausgabename&".job") Then
    '	Wscript.Sleep 1500
    '	If fs.FileExists(Ausgabename&".job") Then
    '		MsgBox("bitfarm-Archiv: Fehler: Server leert nicht den bergabepfad. Kann nicht archivieren.")
    '		Unlock(lockdatei)
    '		WScript.Quit
    '	End If
    'End If
    '
    Err.clear

    If attachmentdontuseoriname = True Then
    	If usertitel = "" Then
    		myname = ""
    		writejob(Left(template, Len(template) -4))
    	End If
    ElseIf namestring <> "" And usertitel="" Then
        myname = namestring
        writejob(Left(template, Len(template) -4))
    End If
    
    If scriptdebug = True Then
        objWSHShell.LogEvent 4, "Outlookimport-server:"& template & " ->" & ausgabename&".job"
    End If 
    
    fs.CopyFile template, Ausgabename&".job", True
    If Err.Number<> 0 Then
        objWSHShell.LogEvent 1,"Outlookimport.vbs: kopieren fehlgeschlagen" & vbCrLf & template & "-->" & vbCrLf & Ausgabename&".job" & vbCrLf & Err.Number & vbTab & Err.Description
        Err.Clear
        MsgBox("bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
        Unlock(lockdatei)
        WScript.Quit
    End If
    
    
    
    If fs.FileExists(Ausgabename&".slw") Then
        WScript.Sleep 1500
        If fs.FileExists(Ausgabename&".slw") Then
            removemsg()
            MsgBox("bitfarm-Archiv: Fehler[3]: Server leert nicht den bergabepfad. Kann nicht archivieren.")
            Unlock(lockdatei)
            WScript.Quit
            
        End If
    End If
    If fs.FileExists(Ausgabename&".ftx") Then
        WScript.Sleep 1500
        If fs.FileExists(Ausgabename&".ftx") Then
            removemsg()
            MsgBox("bitfarm-Archiv: Fehler[4]: Server leert nicht den bergabepfad. Kann nicht archivieren.")
            Unlock(lockdatei)
            WScript.Quit
            
        End If
    End If
    
    Err.clear
    If fs.FileExists(temppath&"\slx"&templatename&".slx") Then
        fs.CopyFile temppath&"\slx"&templatename&".slx", Ausgabename&".slw", True
        If Err.number<>0 Then
            Err.clear
            removemsg()
            MsgBox("bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
            Unlock(lockdatei)
            WScript.Quit
        End If
    End If
    'If fs.FileExists(template&".slw") Then
    'fs.deletefile template&".slw", True
    'If err.number<>0 Then
    '		err.clear
    '    		MsgBox("bitfarm-Archiv: Fehler bei Datenbergabe an den Server. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
    '    		WScript.Quit
    '    		
    'End If
    'End If
    If fs.FileExists(temppath&"\vtx"&templatename&".vtx") Then
        fs.CopyFile temppath&"\vtx"&templatename&".vtx", Ausgabename&".ftx", True
        If Err.number<>0 Then
            Err.clear
            MsgBox("bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
            Unlock(lockdatei)
            WScript.Quit
        End If
    End If
    
    
    If fs.GetExtensionName(datei)<>"" Then
        extension = "." & fs.GetExtensionName(datei)
        extension=LCase(extension)
    End If
    
    If extension = ".jpeg" Then extension = ".jpg"
    
    'MsgBox "sendtoserver:" & Ausgabename&extension
    
    fs.CopyFile Datei, Ausgabename&extension, True
    If Err.number<>0 Then
        Err.clear
        removemsg()
        MsgBox("bitfarm-Archiv: Fehler bei bergabe der Dateien an den Archivserver. Bitte wenden Sie sich an den zustndigen Administrator oder kontakten Sie den bitfarm-Archiv Support.")
        Unlock(lockdatei)
        WScript.Quit
    End If
    
    't=0
    'Do While t<120
    'If fs.FileExists(Ausgabename&extension) Then
    '	WScript.sleep 100
    '	t=t+1
    'Else
    '	t=200
    'End If
    'loop
    'If t<>200 Then
    '	If fs.FileExists(Ausgabename&extension) Then
    '	fs.DeleteFile Ausgabename&extension, True
    '	If err.number<>0 Then
    '    		MsgBox("bitfarm-Archiv: Schwerer Fehler - konnte nicht archivieren. Informieren Sie den Administrator.")
    '    		err.clear
    '    		Unlock(lockdatei)
    '    		WScript.Quit
    '  	End If
    '	End If
    '	If fs.FileExists(Ausgabename&".job") Then
    '	fs.DeleteFile Ausgabename&".job", True
    '	If err.number<>0 Then
    '    		MsgBox("bitfarm-Archiv: Schwerer Fehler - konnte nicht archivieren. Informieren Sie den Administrator.")
    '    		err.clear
    '    		Unlock(lockdatei)
    '    		WScript.Quit
    '  	End If
    '  	End If
    '	If fs.FileExists(Ausgabename&".slw") Then
    '	fs.DeleteFile Ausgabename&".slw", True
    '	If err.number<>0 Then
    '    		MsgBox("bitfarm-Archiv: Schwerer Fehler - konnte nicht archivieren. Informieren Sie den Administrator.")
    '    		err.clear
    '    		Unlock(lockdatei)
    '    		WScript.Quit
    '  	End If
    '	End If
    '	If fs.FileExists(Ausgabename&".ftx") Then
    '	fs.DeleteFile Ausgabename&".ftx", True
    '	If err.number<>0 Then
    '    		MsgBox("bitfarm-Archiv: Schwerer Fehler - konnte nicht archivieren. Informieren Sie den Administrator.")
    '    		err.clear
    '    		Unlock(lockdatei)
    '    		WScript.Quit
    '  	End If
    '	End If
    '	frage = "Fehler: Der Archivserver reagiert nicht - es wurden ggf. nicht alle Dateien archiviert. Versuchen Sie es in einigen Minuten erneut. Sollte dieser Fehler wiederholt vorkommen, informieren Sie den Netzwerkadministrator."
    '	ueberschrift = "bitfarm-Archiv E-Mailimport"
    '	antwort = objWSHShell.Popup(frage,, ueberschrift, vbSystemModal + vbCritical)
    '	'MsgBox("bitfarm-Archiv: Fehler: Der Archivserver reagiert nicht - es wurden ggf. nicht alle Dateien archiviert. Sollte dies hufiger Vorkommen informieren Sie den Netzwerkadministrator.")
    '	Unlock(lockdatei)
    '	WScript.Quit
    'End If
    'WScript.Sleep 50
    sendtoserver=True
    
    Err.clear
    fs.DeleteFile datei, True
    If Err.number<>0 Then
        Err.clear
    End If
    
    
End Function



'******************************************  Funktionen  *************************************



Function cleanup()
    On Error Resume Next
    Err.clear
    If fs.FileExists(temppath&"\slx"&templatename&".slx") Then
        fs.deletefile temppath&"\slx"&templatename&".slx", True
        If Err.number Then
            Err.clear
            'On Error Resume next
        End If
    End If 
    If fs.FileExists(temppath&"\vtx"&templatename&".vtx") Then
        fs.deletefile temppath&"\vtx"&templatename&".vtx", True
        If Err.number Then
            Err.clear
        End If
    End If 
    
    If fs.FileExists(temppath&"\SLW"&templatename&".SLW") Then
        fs.deletefile temppath&"\SLW"&templatename&".SLW", True
        If Err.number Then
            Err.clear
        End If
    End If 
    
    If fs.FileExists(template) Then
        fs.deletefile template, True
        If Err.number Then
            Err.clear
        End If
    End If
End Function



Function delete_bfamailfolder(bfafolder)
    On Error Resume Next
    'sicherheitshalber leermachen, damit bei abbruch des makros diese verzeichnisse nicht nochmal abgearbeitet werden
    'das verzeichnis selbst bleibt stehen, damit das makro erkennnen kann, das die mail nicht bertragen wurde 
    Set myfolder=fs.getfolder(bfafolder)
    For Each folder In myfolder.subfolders
        If Left(folder.name,8)="bfa-mail" Then
            
            Set bfamail = fs.getfolder(folder)
            For Each mailfile In bfamail.Files
                fs.deletefile mailfile, True
                If Err.number Then
                    objWSHShell.LogEvebt 1,"Konnte Inhalt des Verzeichnis nicht lschen" & vbCrLf & mailfile & vbCrLf & Err.number & vbTab & Err.description
                    Err.clear
                End If
            Next 
            
            For Each subfolder In bfamail.subfolders
                fs.deletefolder(subfolder)
                If Err.number Then
                    objWSHShell.LogEvebt 1,"Konnte Inhalt des Verzeichnis nicht lschen" & vbCrLf & subfolder & vbCrLf & Err.number & vbTab & Err.description
                    Err.clear
                End If
            Next 
        End If
    Next 
    
    Set myfolder = Nothing
    
End Function	



'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function writeslwdatei(Datei)
    On Error Resume Next
    'MsgBox "writeslw:" & datei
    
    
    Err.clear
    If fs.FileExists(temppath&"\slx"&templatename&".slx") Then
        fs.deletefile temppath&"\slx"&templatename&".slx", True
        Err.clear
        If Err.number Then
            
            removemsg()
            MsgBox("bitfarm-Archiv: Fehler beim E-Mailimport: Kann Dateinamen nicht als Schlagwort speichern. Kann so nicht archivieren. Bitte informieren Sie den Administrator.")
            Unlock(lockdatei)
            WScript.Quit	
        End If
    End If 
    
    
    'namestring = fs.GetAbsolutePathName(datei)
    namestring = fs.GetBaseName(datei)
    
    
    If namestring <> "" Then
        gefunden = True
    End If
    
    
    If gefunden=False Then
        removemsg()
        MsgBox("bitfarm-Archiv: Fehler: Falsches Dateiformat.")
        Unlock(lockdatei)
        WScript.Quit
    End If
    
    'namestring=""
    'namestring=Mid(datei,pos1+1,(Len(datei)-pos1)-(Len(datei)-pos2+1))
    
    
    Err.clear
    Set zielslwfile = fs.OpenTextFile(temppath&"\slx"&templatename&".slx",8,True)
    zielslwfile.writeline("Dateiname="&namestring)
    l=1
    laenge=Len(namestring)
    mystring1=""
    Do While l<laenge
        mystring2=getword(namestring,l)
        If mystring2<>mystring1 Then
            zielslwfile.writeline(mystring2)
            mystring1=mystring2
        End If
        l=l+1
    Loop
    
    If fs.FileExists(temppath&"\slw"&templatename&".slw") Then
        Set quellslwfile = fs.OpenTextFile(temppath&"\slw"&templatename&".slw",1)
        Do While quellslwfile.AtEndOfStream <> True
            zielslwfile.writeline(quellslwfile.readline)
        Loop
        quellslwfile.close
        Set quellslwfile = Nothing
    End If
    
    zielslwfile.writeline("Richtung="&richtung)
    zielslwfile.writeline("Empfaenger="&empfaenger)
    zielslwfile.writeline("Absender="&absender)
    zielslwfile.writeline("Absenderadresse="&absenderadresse)
    zielslwfile.writeline("Betreff="&Betreff)
    zielslwfile.writeline("Versanddatum="&versanddatum)
    zielslwfile.writeline("Versanduhrzeit="&versanduhrzeit)
    zielslwfile.writeline("Empfangsdatum="&empfangsdatum)
    zielslwfile.writeline("Empfangsuhrzeit="&empfangsuhrzeit)
    zielslwfile.writeline("Kategorie="&kategorie)
    zielslwfile.writeline("Faxnummer="&Faxnummer)
    zielslwfile.writeline("Fax="&fax)
    zielslwfile.writeline("CC="&cc)
    zielslwfile.writeline("BCC="&bcc)
    
    
    
    'For i=0 to limit
    '	If zusatzfeld(i)<>"" Then
    '		zielslwfile.writeline(zusatzfeld(i))
    '	End If
    'Next
    
    zielslwfile.close
    Set zielslwfile=Nothing
    If Err.number Then
        Err.clear
        removemsg()
        MsgBox("bitfarm-Archiv: Fehler beim E-Mailimport: Kann Dateinamen nicht als Schlagwort speichern. Kann so nicht archivieren. Bitte informieren Sie den Administrator.")
        Unlock(lockdatei)
        WScript.Quit	
    End If
    
    
End Function

'***************************************************************************************
'***************************************************************************************

Function writeEMAILslwdatei(Datei)
    On Error Resume Next
    Err.clear

    
    Set zielslwfile = fs.OpenTextFile(Datei,8,True)

    
    
    zielslwfile.writeline("Richtung="&richtung)
    zielslwfile.writeline("Empfaenger="&empfaenger)
    zielslwfile.writeline("Absender="&absender)
    zielslwfile.writeline("Absenderadresse="&absenderadresse)
    zielslwfile.writeline("Betreff="&Betreff)
    zielslwfile.writeline("Versanddatum="&versanddatum)
    zielslwfile.writeline("Versanduhrzeit="&versanduhrzeit)
    zielslwfile.writeline("Empfangsdatum="&empfangsdatum)
    zielslwfile.writeline("Empfangsuhrzeit="&empfangsuhrzeit)
    zielslwfile.writeline("Kategorie="&kategorie)
    zielslwfile.writeline("Faxnummer="&Faxnummer)
    zielslwfile.writeline("Fax="&fax)
    zielslwfile.writeline("CC="&cc)
    zielslwfile.writeline("BCC="&bcc)
    Err.Clear
    If Originaldatei <> "bfa-Mail.msg"  and Originaldatei <> "" Then
    	zielslwfile.writeline("Dateiname="&fs.GetBaseName(Originaldatei))
    	If Err.number Then
	        Err.Clear
	        ori_ext = fs.GetExtensionName(Originaldatei)
	        zielslwfile.writeline("Dateiname=Dokument."&ori_ext)
	    End If
    End If
    
    
    zielslwfile.close
    Set zielslwfile=Nothing
    If Err.number Then
        Err.clear
        removemsg()
        MsgBox("bitfarm-Archiv: Fehler beim E-Mailimport: Kann Dateinamen nicht als Schlagwort speichern. Kann so nicht archivieren. Bitte informieren Sie den Administrator.")
        Unlock(lockdatei)
        WScript.Quit	
    End If

    
    
End Function

'***************************************************************************************
'***************************************************************************************


Function readjob(tempname)
    On Error Resume Next
    readjob=True
    Err.clear
    
    
    If Not fs.FileExists(tempname) Then
        Err.clear
        
        readjob=False
        Err.clear
    End If
    
    If readjob=True Then	
        Set jobfile = fs.OpenTextFile(tempname,1)
        If Err.number Then
            Err.clear
            
            readjob=False
            
        End If 
    End If
    
    
    If readjob = True Then
        
        Do While jobfile.AtEndOfStream <> True
            kette=jobfile.readline
            If Left(kette,1)<>";" Then
                
                
                If InStr(1,kette,"Profil=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Profil=",1)+7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Profil = wert
                    End If
                End If
                
                If InStr(1,kette,"OCR_Typ",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"OCR_Typ",1)+8)
                    typ = wert
                End If
                
                If InStr(1,kette,"Titel",1)<>0 And InStr(1,kette,"ZusTitel",1)=0 Then
                    'wert=GetString(kette,InStr(1,kette,"Titel",1)+6)
                    wert = Right(kette,Len(kette)-6)
                    myname = wert
                End If
                
                If InStr(1,kette,"gdoc_id=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"gdoc_id=",1)+7)
                    gdocid = wert
                End If
                
                
                If Left(kette,8) ="Referenz"  And linkzaehler < linklimit Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"=",1)))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                
                If InStr(1,kette,"ZusTitel",1)<>0 Then
                    
                    wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"ZusTitel",1)+9)))
                    If Len(wert)>0 Then
                        If Left(wert,1)="=" Then
                            wert=Right(wert,Len(wert)-1)
                        End If
                    End If
                    
                    aussortieren=True
                    For a=1 To Len(wert)
                        If (Mid(wert,a,1)<>" ") And (Mid(wert,a,1)<>".") Then
                            aussortieren=False
                        End If
                    Next
                    If aussortieren=True Then
                        wert=""
                    End If
                    
                    
                    gefunden=False
                    x=0
                    Do While gefunden=False
                        If Zusatzfeldname(x)="" Then
                            gefunden=True
                            Zusatzfeldname(x)=wert
                            
                        End If
                        If gefunden=False Then
                            x=x+1
                        End If
                    Loop		
                    
                End If
                
                If InStr(1,kette,"ZusWert",1)<>0 Then
                    'wert=getstring(kette,InStr(1,kette,"ZusWert",1)+9)
                    wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"ZusWert",1)+8)))
                    If Len(wert)>0 Then
                        If Left(wert,1)="=" Then
                            wert=Right(wert,Len(wert)-1)
                        End If
                    End If
                    
                    aussortieren=True
                    For a=1 To Len(wert)
                        If (Mid(wert,a,1)<>" ") And (Mid(wert,a,1)<>".") Then
                            
                            aussortieren=False
                        End If
                    Next
                    If aussortieren=True Then
                        wert=""
                    End If
                    
                    
                    pos1=InStr(1,kette,wert,1)
                    If wert="" Then
                        pos1=0
                    End If
                    If pos1>3 Then
                        wert=Right(kette,Len(kette)-pos1+1)
                    Else
                        wert=""
                    End If
                    
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Zusatzfeld(x)=wert
                    End If
                End If
                
            End If
            
            
        Loop
        jobfile.close
        Set jobfile = Nothing
        
    End If
    
    
End Function



'********************************************************************************
'********************************************************************************
'********************************************************************************
'********************************************************************************



Function readEMAILMetas(ordner)
    On Error Resume Next
    readEMAILMetas=True
    Err.clear
    
    If Not fs.FileExists(ordner&"\bfa-Metadaten.txt") Then
        Err.clear
        
        readEMAILMetas=False
        Err.clear
    End If
    
    If readEMAILMetas=True Then	
        Set jobfile = fs.OpenTextFile(ordner&"\bfa-Metadaten.txt",1)
        If Err.number Then
            Err.clear
            
            readEMAILMetas=False
            
        End If 
    End If
    absender=""
    absenderadresse=""
    empfaenger=""
    betreff=""
    versanddatum=""
    versanduhrzeit=""
    empfangsdatum=""
    empfangszeit=""
    kategorie=""
    cc=""
    bcc=""
    
    
    
    If readEMAILMetas = True Then
        
        Do While jobfile.AtEndOfStream <> True
            kette=jobfile.readline
            If Left(kette,1)<>";" Then
                
                If Left(kette,13) = "Versanddatum:" Then
                    'If InStr(1,kette,"Versanddatum:",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Versanddatum:",1)+14)
                    
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        versanddatum=wert
                        zusatzfeldname(i)="Versanddatum"
                        zusatzfeld(i)=wert
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        zusatzfeldname(i)="Datum"
                        zusatzfeld(i)=wert
                    End If
                End If
                
                If Left(kette,15) = "Versanduhrzeit:" Then
                    'If InStr(1,kette,"Versanduhrzeit:",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Versanduhrzeit:",1)+16)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        versanduhrzeit=wert
                        zusatzfeldname(i)="Versandzeit"
                        zusatzfeld(i)=wert
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        zusatzfeldname(i)="Uhrzeit"
                        zusatzfeld(i)=wert
                    End If
                End If
                
                If Left(kette,14) = "Empfangsdatum:" Then
                    'If InStr(1,kette,"Empfangsdatum:",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Empfangsdatum:",1)+15)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        empfangsdatum=wert
                        zusatzfeldname(i)="Empfangsdatum"
                        zusatzfeld(i)=wert
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        zusatzfeldname(i)="Datum"
                        zusatzfeld(i)=wert
                    End If
                End If
                
                If Left(kette,13) = "Empfangszeit:" Then
                    'If InStr(1,kette,"Empfangszeit:",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Empfangszeit:",1)+14)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        empfangszeit=wert
                        zusatzfeldname(i)="Empfangszeit"
                        zusatzfeld(i)=wert
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        zusatzfeldname(i)="Uhrzeit"
                        zusatzfeld(i)=wert
                    End If
                End If
                
                If Left(kette,9) = "Absender:" Then	
                    'If InStr(1,kette,"Absender:",1)<>0 Then
                    'wert=GetString(kette,InStr(1,kette,"Absender:",1)+10)
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Absender:",1)+9))
                    wert=Trim(wert)
                    
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        absender=wert
                        zusatzfeldname(i)="Absender"
                        zusatzfeld(i)=wert
                        absender=wert
                        If Left(wert,13)="SBSFaxService" Then
                            fax=True
                        End If
                    End If
                End If
                
                If Left(kette,16) = "Absenderadresse:" Then	
                    'If InStr(1,kette,"Absenderadresse:",1)<>0 Then
                    
                    wert=GetString(kette,InStr(1,kette,"Absenderadresse:",1)+17)
                    wert=normstring(wert)
                    
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        absenderadresse=wert
                        zusatzfeldname(i)="Absenderadresse"
                        zusatzfeld(i)=wert
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        If InStr(1,wert,"@",1)<>0 Then
                            zusatzfeldname(i)="Absender"
                            zusatzfeld(i)=wert
                            absender=wert
                        End If
                        absenderadresse=wert
                        If Left(wert,13)="SBSFaxService" Then
                            fax=True
                        End If
                    End If
                End If
                
                If Left(kette,3) = "An:" Then		
                    'If InStr(1,kette,"An:",1)<>0 Then
                    'wert=GetString(kette,InStr(1,kette,"An:",1)+4)
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"An:",1)+4))
                    wert=normstring(wert)
                    wert=Trim(wert)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        zusatzfeldname(i)="An"
                        zusatzfeld(i)=wert
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        empfaenger=wert
                        zusatzfeldname(i)="Empfnger"
                        zusatzfeld(i)=wert
                        empfaenger=wert
                    End If
                End If
                
                If Left(kette,3) = "CC:" Then			
                    'If InStr(1,kette,"CC:",1)<>0 Then
                    'wert=GetString(kette,InStr(1,kette,"CC:",1)+4)
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"CC:",1)+4))
                    wert=normstring(wert)
                    wert=Trim(wert)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        cc=wert
                        zusatzfeldname(i)="CC"
                        zusatzfeld(i)=wert
                    End If
                End If
                
                If Left(kette,4) = "BCC:" Then			
                    'If InStr(1,kette,"BCC:",1)<>0 Then
                    'wert=GetString(kette,InStr(1,kette,"BCC:",1)+5)
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"BCC:",1)+5))
                    wert=normstring(wert)
                    wert=Trim(wert)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        bcc=wert
                        zusatzfeldname(i)="BCC"
                        zusatzfeld(i)=wert
                    End If
                End If
                
                If Left(kette,11) = "Kategorien:" Then			
                    'If InStr(1,kette,"Kategorien:",1)<>0 Then
                    'wert=GetString(kette,InStr(1,kette,"Kategorien:",1)+12)
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Kategorien:",1)+12))
                    wert=Trim(wert)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        kategorie=wert
                        zusatzfeldname(i)="Kategorien"
                        zusatzfeld(i)=wert
                    End If
                End If
                
                If Left(kette,8) = "Betreff:" Then	
                    'If (InStr(1,kette,"Betreff:",1)<>0) And (fax=False) Then
                    'wert=GetString(kette,InStr(1,kette,"Betreff:",1)+9)
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Betreff:",1)+9))
                    wert=normstring(wert)
                    wert=Trim(wert)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        betreff=wert
                        zusatzfeldname(i)="Betreff"
                        zusatzfeld(i)=wert
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        zusatzfeldname(i)="Titel"
                        zusatzfeld(i)=wert
                    End If
                End If
                
                
                
            End If
            
            
        Loop
        jobfile.close
        Set jobfile = Nothing
        
        richtung=""
        If (InStr(1,absender,"@",1)=0) Then
            richtung="Ausgang"
        Else 
            richtung="Eingang"
        End If 
        If (richtung="Ausgang") And (InStr(1,empfaenger,"@",1)=0) Then
            richtung="Intern"
        End If 
        
        If maildomain<>"" Then
            
            If (InStr(1,absender,maildomain,1)<>0) And (InStr(1,empfaenger,maildomain,1)=0) And (InStr(1,empfaenger,"@",1)<>0) Then
                richtung="Ausgang"
            End If
            If (InStr(1,absender,"@",1)<>0) And (InStr(1,absender,maildomain,1)=0) Then
                richtung="Eingang"
            End If
            If (InStr(1,absender,maildomain,1)<>0) And (InStr(1,empfaenger,maildomain,1)<>0) Then
                richtung="Intern"
            End If
            
        End If
        
        
        gefunden=False
        i=0
        Do While gefunden=False
            If zusatzfeldname(i)="" Then
                gefunden=True
            End If
            If gefunden=False Then
                i=i+1
            End If
            If i=limit Then
                gefunden=True
            End If
        Loop
        zusatzfeldname(i)="Richtung"
        zusatzfeld(i)=richtung
        
        
    End If
    
    'MsgBox " Metas gelsen, richtung ermittelt= " & richtung
    
End Function



'********************************************************************************
'********************************************************************************
'********************************************************************************
'********************************************************************************
'********************************************************************************
'********************************************************************************


Function readFAXMetas(ordner)
    On Error Resume Next
    readFAXMetas=True
    Err.clear
    myname="Fax"
    
    
    For i=0 To limit
        If zusatzfeldname(i)="Absender" Then
            zusatzfeld(i)=""
            zusatzfeldname(i)=""
        End If
        If zusatzfeldname(i)="Absenderadresse" Then
            zusatzfeld(i)=""
            zusatzfeldname(i)=""
        End If
        If zusatzfeldname(i)="Empfnger" Then
            zusatzfeld(i)=""
            zusatzfeldname(i)=""
        End If
        If zusatzfeldname(i)="An" Then
            zusatzfeld(i)=""
            zusatzfeldname(i)=""
        End If
    Next
    
    
    If Not fs.FileExists(ordner&"\bfa-Mail.html") Then
        Err.clear
        
        readFAXMetas=False
        Err.clear
    End If
    
    If readFAXMetas=True Then	
        Set jobfile = fs.OpenTextFile(ordner&"\bfa-Mail.html",1)
        If Err.number Then
            Err.clear
            
            readFAXMetas=False
            
        End If 
    End If
    
    
    If readFAXMetas = True Then
        
        Do While jobfile.AtEndOfStream <> True
            kette=jobfile.readline
            If Left(kette,1)<>";" Then
                
                
                If InStr(1,kette,"Fax-Eingang",1)<>0 Then
                    gefunden=False
                    i=0
                    Do While gefunden=False
                        If zusatzfeldname(i)="" Then
                            gefunden=True
                        End If
                        If gefunden=False Then
                            i=i+1
                        End If
                        If i=limit Then
                            gefunden=True
                        End If
                    Loop
                    richtung="Eingang"
                    zusatzfeldname(i)="Richtung"
                    zusatzfeld(i)="Eingang"
                    gefunden=False
                    i=0
                    Do While gefunden=False
                        If zusatzfeldname(i)="" Then
                            gefunden=True
                        End If
                        If gefunden=False Then
                            i=i+1
                        End If
                        If i=limit Then
                            gefunden=True
                        End If
                    Loop
                    empfaenger=wert
                    zusatzfeldname(i)="Empfnger"
                    zusatzfeld(i)=Profil
                    gefunden=False
                    i=0
                    Do While gefunden=False
                        If zusatzfeldname(i)="" Then
                            gefunden=True
                        End If
                        If gefunden=False Then
                            i=i+1
                        End If
                        If i=limit Then
                            gefunden=True
                        End If
                    Loop
                    zusatzfeldname(i)="An"
                    zusatzfeld(i)=Profil
                    
                End If
                
                If InStr(1,kette,"Fax-Ausgang",1)<>0 Then
                    gefunden=False
                    i=0
                    Do While gefunden=False
                        If zusatzfeldname(i)="" Then
                            gefunden=True
                        End If
                        If gefunden=False Then
                            i=i+1
                        End If
                        If i=limit Then
                            gefunden=True
                        End If
                    Loop
                    richtung="Ausgang"
                    zusatzfeldname(i)="Richtung"
                    zusatzfeld(i)="Ausgang"
                    gefunden=False
                    i=0
                    Do While gefunden=False
                        If zusatzfeldname(i)="" Then
                            gefunden=True
                        End If
                        If gefunden=False Then
                            i=i+1
                        End If
                        If i=limit Then
                            gefunden=True
                        End If
                    Loop
                    absender=profil
                    zusatzfeldname(i)="Absender"
                    zusatzfeld(i)=Profil
                    gefunden=False
                    i=0
                    Do While gefunden=False
                        If zusatzfeldname(i)="" Then
                            gefunden=True
                        End If
                        If gefunden=False Then
                            i=i+1
                        End If
                        If i=limit Then
                            gefunden=True
                        End If
                    Loop
                    absenderadresse=profil
                    zusatzfeldname(i)="Absenderadresse"
                    zusatzfeld(i)=Profil
                    
                End If
                
                
                If InStr(1,kette,"erfolgreich unter der Nummer",1)<>0 Then
                    'wert=GetString(kette,InStr(1,kette,"erfolgreich unter der Nummer",1)+28)
                    
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"erfolgreich unter der Nummer",1)+28))
                    If InStr(1,kette,"</p>",1)=0 Then
                        kette=jobfile.readline
                        wert=wert&" "&kette
                    End If
                    
                    
                    wert=Trim(makefaxnumber(wert))
                    
                    faxnummer=wert
                    'myname=wert
                    
                    
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        adresse=wert
                        zusatzfeldname(i)="Adresse"
                        zusatzfeld(i)=wert
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        empfaenger=wert
                        zusatzfeldname(i)="Empfnger"
                        zusatzfeld(i)=wert
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        zusatzfeldname(i)="An"
                        zusatzfeld(i)=wert
                    End If
                End If
                
                If InStr(1,kette,"Absender:",1)<>0 Then
                    
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Absender:",1)+9))
                    
                    wert=Trim(makefaxnumber(wert))
                    
                    faxnummer=wert
                    'myname=wert
                    
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        absender=wert
                        zusatzfeldname(i)="Absender"
                        zusatzfeld(i)=wert
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        absenderadresse=wert
                        zusatzfeldname(i)="Absenderadresse"
                        zusatzfeld(i)=wert
                    End If
                End If
                
                If InStr(1,kette,"bertragung beendet:",1)<>0 Then
                    'wert=GetString(kette,InStr(1,kette,"bertragung beendet:",1)+21)
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"bertragung beendet:",1)+20))
                    If Len(wert)>7 Then
                        wert=Left(wert,Len(wert)-4)
                    Else
                        wert=""
                    End If
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        versanduhrzeit=wert
                        zusatzfeldname(i)="Versandzeit"
                        zusatzfeld(i)=wert
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        zusatzfeldname(i)="Uhrzeit"
                        zusatzfeld(i)=wert
                    End If
                End If
                
                
                
                If InStr(1,kette,"bertragungszeit:",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"bertragungszeit:",1)+18)
                    If Len(wert)>7 Then
                        wert=Left(wert,Len(wert)-4)
                    Else
                        wert=""
                    End If
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        empfangsuhrzeit=wert
                        zusatzfeldname(i)="Empfangszeit"
                        zusatzfeld(i)=wert
                        gefunden=False
                        i=0
                        Do While gefunden=False
                            If zusatzfeldname(i)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                i=i+1
                            End If
                            If i=limit Then
                                gefunden=True
                            End If
                        Loop
                        zusatzfeldname(i)="Uhrzeit"
                        zusatzfeld(i)=wert
                    End If
                End If
                
                
                
            End If
            
            
        Loop
        jobfile.close
        Set jobfile = Nothing
        
    End If
    
    
End Function



'********************************************************************************
'********************************************************************************
'********************************************************************************
'********************************************************************************
'********************************************************************************
'********************************************************************************




Function writejob(tempname)
    On Error Resume Next
    writejob=True
    Err.clear
    
    
    If Not fs.FileExists(tempname&".job") Then
        Err.clear
        errortxt=tempname&".job Datei nicht vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        writejob=False
        Err.clear
    End If
    
    If writejob=True Then	
        Set quelljobfile = fs.OpenTextFile(tempname&".job",1)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writejob=False
            
        End If 
    End If
    
    If writejob=True Then
        If fs.FileExists(tempname&".tmp") Then
            fs.DeleteFile(tempname& ".tmp")
            If Err.number Then
                Err.clear
                errortxt="Zwischendatei fr Jobdatei existierte noch, kann diese aber nicht lschen."
                objWshShell.LogEvent 1, errortxt
                writejob=False
                quelljobfile.close
                Set quelljobfile=Nothing
            End If 
            
        End If	
    End If
    
    If writejob=True Then
        Set zieljobfile = fs.OpenTextFile(tempname&".tmp",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writejob=False
            quelljobfile.close
            Set quelljobfile=Nothing
        End If 
    End If
    
    
    
    
    If writejob = True Then
        
        stopflag=False
        ersatzstring=""	
        Do While quelljobfile.AtEndOfStream <> True
            kette=quelljobfile.readline
            
            
            If (InStr(1,kette,"[Referenz]",1)<>0) And (quelljobfile.AtEndOfStream <> True) Then
                abbruch=False
                Do While abbruch=False 
                    kette=quelljobfile.readline
                    If quelljobfile.AtEndOfStream = True Then
                        abbruch=True
                    End If
                    If (InStr(1,kette,"Referenz",1)=0) And (InStr(1,kette,"Anzahl",1)=0) Then
                        abbruch = True
                    End If
                Loop
                zieljobfile.writeline("[Referenz]")
                zieljobfile.writeline("Anzahl="&linkzaehler)
                x=0
                Do While x < linkzaehler
                    zieljobfile.writeline("Referenz"&x+1&"="&linkspeicher(x))
                    x=x+1
                Loop
                kette = ""
            End If
            
            ersatzstring=""
            
            If InStr(1,kette,"Titel=",1)<>0 Then
                ersatzstring="Titel="&myname
            End If
            
            If (Username<>"") And (InStr(1,kette,"Benutzer=",1)<>0) Then
                ersatzstring="Benutzer="&Username
            End If	
            
            If (dokDate<>"") And (InStr(1,kette,"Datum=",1)<>0) Then
                ersatzstring="Datum="&DokDate
            End If
            
            If (Typ<>"") And (InStr(1,kette,"OCR_Typ=",1)<>0) Then
                ersatzstring="OCR_Typ="&Typ
            End If
            
            
            
            If Left(kette,8)="ZusTitel" Then
                For x=1 To limit
                    
                    If InStr(1,kette,"ZusTitel"&x&"=",1)<>0 Then
                        
                        wert=GetString(kette,InStr(1,kette,"ZusTitel"&x,1)+10)
                        For w=0 To limit
                            If LCase(Zusatzfeldname(w))=LCase(wert) Then
                                ersatzstring="ZusWert"&x&"="&Zusatzfeld(w)
                            End If
                        Next
                        
                        zieljobfile.writeline(kette)
                        kette=quelljobfile.readline
                        
                        zieljobfile.writeline(kette)
                        kette=quelljobfile.readline
                    End If
                Next
            End If
            
            If ersatzstring<>"" Then
                zieljobfile.writeline(ersatzstring)
            Else
                zieljobfile.writeline(kette)
            End If
            
        Loop
        quelljobfile.close
        Set quelljobfile = Nothing
        zieljobfile.close
        Set zieljobfile=Nothing
        WScript.sleep 50
        
        Err.clear
        fs.DeleteFile(tempname& ".job")
        If Err.number Then
            Err.clear
            errortxt="Fehler beim lschen der alten jobdatei."
            objWshShell.LogEvent 1, errortxt
            writejob=False
        End If 
        
        
        'wscript.sleep 200
        
        If writejob=True Then
            
            fs.CopyFile tempname&".tmp", tempname&".job", True
            If Err.number Then
                Err.clear
                errortxt="Fehler beim umkopieren Jobdatei."
                objWshShell.LogEvent 1, errortxt
                writejob=False
            End If 
        End If
        
        WScript.sleep 50
        If writejob=True Then
            fs.DeleteFile(tempname& ".tmp")
            If Err.number Then
                Err.clear
                errortxt="Fehler beim lschen der zwischen-jobdatei."
                objWshShell.LogEvent 1, errortxt
                writejob=False
            End If 
        End If
        WScript.sleep 50
        
    End If
    
End Function


'********************************************************************************
'********************************************************************************
'********************************************************************************
'********************************************************************************
'********************************************************************************
'********************************************************************************




Function writeEMAILjob(tempname)
    On Error Resume Next
    writeEMAILjob=True
    Err.clear
    
    If Not fs.FileExists(tempname&".job") Then
        Err.clear
        errortxt=tempname&".job Datei nicht vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        writeEMAILjob=False
        Err.clear
    End If
    
    If writeEMAILjob=True Then	
        Set quelljobfile = fs.OpenTextFile(tempname&".job",1)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writeEMAILjob=False
            
        End If 
    End If
    
    If writeEMAILjob=True Then
        If fs.FileExists(tempname&".tmp") Then
            fs.DeleteFile(tempname& ".tmp")
            If Err.number Then
                Err.clear
                errortxt="Zwischendatei fr Jobdatei existierte noch, kann diese aber nicht lschen."
                objWshShell.LogEvent 1, errortxt
                writeEMAILjob=False
                quelljobfile.close
                Set quelljobfile=Nothing
            End If 
            
        End If	
    End If
    
    If writeEMAILjob=True Then
        Set zieljobfile = fs.OpenTextFile(tempname&".tmp",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writeEMAILjob=False
            quelljobfile.close
            Set quelljobfile=Nothing
        End If 
    End If
    
    
    
    If writeEMAILjob = True Then
        
        stopflag=False
        ersatzstring=""	
        Do While quelljobfile.AtEndOfStream <> True
            kette=quelljobfile.readline
            
            
            If (InStr(1,kette,"[Referenz]",1)<>0) And (quelljobfile.AtEndOfStream <> True) Then
                abbruch=False
                Do While abbruch=False 
                    kette=quelljobfile.readline
                    If quelljobfile.AtEndOfStream = True Then
                        abbruch=True
                    End If
                    If (InStr(1,kette,"Referenz",1)=0) And (InStr(1,kette,"Anzahl",1)=0) Then
                        abbruch = True
                    End If
                Loop
                zieljobfile.writeline("[Referenz]")
                zieljobfile.writeline("Anzahl="&linkzaehler)
                x=0
                Do While x < linkzaehler
                    zieljobfile.writeline("Referenz"&x+1&"="&linkspeicher(x))
                    x=x+1
                Loop
                
            End If
            
            ersatzstring=""
            
            If InStr(1,kette,"Titel=",1)<>0 Then
                ersatzstring="Titel="&myname
            End If
            
            If InStr(1,kette,"Filter=",1)<>0 Then
                thisfilter = Right(kette,Len(kette)-7)
                If thisfilter="" Then
                    ersatzstring="Filter=fromoutlook"
                ElseIf InStr(LCase(thisfilter), "fromoutlook")=0 Then
                    ersatzstring="Filter=fromoutlook,"&thisfilter
                End If
            End If
            
            If (Username<>"") And (InStr(1,kette,"Benutzer=",1)<>0) Then
                ersatzstring="Benutzer="&Username
            End If	
            
            If (dokDate<>"") And (InStr(1,kette,"Datum=",1)<>0) Then
                ersatzstring="Datum="&DokDate
            End If
            
            If InStr(1,kette,"OCR_Typ=",1)<>0 Then
                ersatzstring="OCR_Typ=EMP"
            End If
            
            If InStr(1,kette,"gdoc_id=",1)<>0 Then
                If gdocid<>"" Then
                    ersatzstring="gdoc_id="&gdocid
                    gdocid=""
                Else
                    ersatzstring="gdoc_id="
                End If
            End If
            
            If Left(kette,8)="ZusTitel" Then
                For x=1 To limit
                    If InStr(1,kette,"ZusTitel"&x&"=",1)<>0 Then
                        wert=GetString(kette,InStr(1,kette,"ZusTitel"&x,1)+10)
                        
                        For w=0 To limit
                            If LCase(Zusatzfeldname(w))=LCase(wert) Then
                                ersatzstring="ZusWert"&x&"="&Zusatzfeld(w)
                            End If
                        Next
                        
                        zieljobfile.writeline(kette)
                        kette=quelljobfile.readline
                        
                        zieljobfile.writeline(kette)
                        kette=quelljobfile.readline
                        
                        
                    End If
                Next
                
                
                
                
            End If
            
            If ersatzstring<>"" Then
                zieljobfile.writeline(ersatzstring)
            Else
                zieljobfile.writeline(kette)
            End If
            
        Loop
        quelljobfile.close
        Set quelljobfile = Nothing
        zieljobfile.close
        Set zieljobfile=Nothing
        WScript.sleep 50
        
        Err.clear
        fs.DeleteFile(tempname& ".job")
        If Err.number Then
            Err.clear
            errortxt="Fehler beim lschen der alten jobdatei."
            objWshShell.LogEvent 1, errortxt
            writeEMAILjob=False
        End If 
        
        
        'wscript.sleep 200
        
        If writeEMAILjob=True Then
            
            fs.CopyFile tempname&".tmp", tempname&".job", True
            If Err.number Then
                Err.clear
                errortxt="Fehler beim umkopieren Jobdatei."
                objWshShell.LogEvent 1, errortxt
                writeEMAILjob=False
            End If 
        End If
        
        WScript.sleep 50
        If writeEMAILjob=True Then
            fs.DeleteFile(tempname& ".tmp")
            If Err.number Then
                Err.clear
                errortxt="Fehler beim lschen der zwischen-jobdatei."
                objWshShell.LogEvent 1, errortxt
                writeEMAILjob=False
            End If 
        End If
        WScript.sleep 50
        
    End If
    
    
End Function



Function syncarrays()
    On Error Resume Next
    For x=0 To limit
        If zwischenfeld(x)<>"" Then
            
            For a=0 To limit
                If LCase(zusatzfeldname(a))=LCase(zwischenfeldname(x)) Then
                    
                    zusatzfeld(a)=zwischenfeld(x)
                End If
            Next
        End If
    Next
End Function




'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function appendBackslash(thepath)
    If Right(thepath,1)<>"\" Then
        thepath=thepath&"\"
    End If
    appendBackslash=thepath
End Function

'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function readconfig(profil)
    On Error Resume Next
    readconfig=True
    Err.clear
    
    If Not fs.FileExists(programm&profil&".con") Then
        Err.clear
        errortxt=profil&".con Datei nicht im Scriptpfad vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        readconfig=False
        Err.clear
    End If
    
    If readconfig=True Then	
        Set confile = fs.OpenTextFile(programm&profil&".con",1)
        If Err.number Then
            Err.clear
            errortxt="Profilfdatei nicht im Scriptpfad vorhanden oder nicht lesbar."
            objWshShell.LogEvent 1, errortxt
            Err.clear
            readconfig=False
            
        End If 
    End If
    
    If readconfig=True Then	
        kette=confile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        Do While Scriptsflag = 0
            kette=confile.readline
            Scriptsflag=InStr(1,kette,"[Scripts]")
            If confile.AtEndOfStream = True Then
                confile.close
                Set confile=Nothing
                scriptsflag=1
                errortxt="Fehler beim Lesen der CON-Datei - falsche Formatierung."
                objWshShell.LogEvent 1, errortxt
                readconfig = False
                
            End If
        Loop
        
    End If
    
    
    If readconfig = True Then
        
        Do While confile.AtEndOfStream <> True
            kette=confile.readline
            If Left(kette,1)<>";" Then
                
                
                If InStr(1,kette,"uncclientspooler",1)<>0 Then
                    wert = Right(kette,Len(kette) -17)
                    uncclientspooler = Trim(wert)
                End If
                
                If InStr(1,kette,"unverteilt",1)<>0 Then
                    wert = Right(kette,Len(kette) -11)
                    unverteilt = Trim(wert)
                End If
                
                
                If InStr(1,kette,"templates",1)<>0 Then
                    wert = Right(kette,Len(kette) -10)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        templates=Trim(wert)
                        templates=appendBackslash(templates)
                    End If
                End If	
                
                
            End If
            
        Loop
        confile.close
        Set confile = Nothing
        
    End If
    
    
End Function

'***************************************************************************************
'***************************************************************************************
'***************************************************************************************


Function checkunicodehtml(pfad)
    On Error Resume Next
    If fs.FileExists(pfad&"\bfa-Mail.html") Then
        Set htmlfile = fs.OpenTextFile(pfad&"\bfa-Mail.html",1)
        test = htmlfile.Read(2)
        htmlfile.Close
        Set htmlfile = Nothing
        
        If Left(test,1)  = Chr(255) And Right(test,1)= Chr(254) Then
            'MsgBox "unicode!"
            If fs.FileExists(programm&"convertunicode.bat") Then
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"convertunicode.bat" & Chr(34) & " " & pfad&"\bfa-Mail.html " &  pfad&"\bfa-Mail2.html",0,True)
                If lngReturnCode<> 0 Then
                    objWSHShell.LogEvent 1, "Outlookimport.vbs: Fehler bei der Unicode nach UTF8-Konvertierung. convertunicode.bat konnte nicht durchgefhrt werden" & vbCrLf & pfad & "\bfa-Mail.html"
                    
                End If
                WScript.Sleep 200
                If fs.FileExists(pfad&"\bfa-Mail2.html") Then
                    fs.DeleteFile pfad&"\bfa-Mail.html" , True
                    If Err.Number<> 0 Then
                        objWSHShell.LogEvent 1, "Outlookimport.vbs: Fehler bei der Unicode nach UTF8-Konvertierung. bfa-Mail2.html konnte nicht gelscht werden" & vbCrLf & pfad&"\bfa-Mail2.html"
                        Err.Clear
                        On Error Resume Next
                    Else
                        fs.MoveFile pfad&"\bfa-Mail2.html", pfad&"\bfa-Mail.html"
                        
                    End If
                    
                End If
            Else
                objWSHShell.LogEvent 1, "Outlookimport.vbs: Fehler bei der Unicode nach UTF8-Konvertierung. convertunicode.bat nicht vorhanden" & vbCrLf & programm&"convertunicode.bat"
            End If
            
        End If
        
    End If
    
    
End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************



Private Function makefaxnumber(String)
    On Error Resume Next
    tempkette=""
    o=""
    For x=1 To Len(String)
        o=Mid(String,x,1)
        
        
        
        If (o<>" ") And (o<>"0") And (o<>"1") And (o<>"1") And (o<>"2") And (o<>"3") And (o<>"4") And (o<>"5") And (o<>"6") And (o<>"7") And (o<>"8") And (o<>"9") And (o<>"+") And (o<>"-") And (o<>"(") And (o<>")") Then
            o=""
        End If 
        
        
        tempkette=tempkette&o
        
    Next
    
    x=Len(tempkette)
    abbruch=False
    Do While abbruch=False
        o=Mid(tempkette,x,1)
        
        If (o<>"0") And (o<>"1") And (o<>"1") And (o<>"2") And (o<>"3") And (o<>"4") And (o<>"5") And (o<>"6") And (o<>"7") And (o<>"8") And (o<>"9") Then
            abbruch=False
        Else
            abbruch=True
            
        End If 
        x=x-1
        If x<1 Then
            abbruch=True
        End If
    Loop
    
    If x>1 Then
        tempkette=Left(tempkette,x+1)
    End If
    
    
    makefaxnumber=tempkette
End Function

'***************************************************************************************
'***************************************************************************************
'***************************************************************************************
Function setdokdate()
    On Error Resume Next
    Jahr = DatePart("yyyy",Date)
    Monat = DatePart("m",Date)
    Tag = DatePart("d",Date)
    Stunde = DatePart("h",Time)
    Minuten = DatePart("n",Time)
    Sekunde = DatePart("s", Time)
    If Len(Monat)=1 Then 
        monat="0"&monat
    End If
    If Len(tag)=1 Then 
        tag="0"&tag
    End If
    If Len(stunde)=1 Then 
        stunde="0"&stunde
    End If
    If Len(minuten)=1 Then 
        minuten="0"&minuten
    End If
    If Len(sekunde)=1 Then 
        sekunde="0"&sekunde
    End If
    setdokdate = Jahr&"-" & Monat & "-" & Tag & " " & Stunde & ":" & Minuten & ":" & Sekunde
End Function

'***************************************************************************************
'***************************************************************************************
'***************************************************************************************


Function inilesen()
    On Error Resume Next
    Err.clear
    Set inifile = fs.OpenTextFile(programm&"scripts.ini",1)
    If Err.number Then
        objWshShell.LogEvent 1, "scripts.ini nicht im Scriptpfad vorhanden oder nicht lesbar."
        Err.clear
        Unlock(lockdatei)
        WScript.Quit
    End If 
    
    kette=inifile.readline
    Scriptsflag=InStr(1,kette,"[Scripts]")
    Do While Scriptsflag = 0
        kette=inifile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        If inifile.AtEndOfStream = True Then
            inifile.close
            objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - falsche Formatierung."
            Unlock(lockdatei)
            WScript.Quit
        End If
    Loop
    
    
    Do While inifile.AtEndOfStream <> True
        kette=inifile.readline
        If Left(kette,1)<>";" Then
            If InStr(1,kette,"Profil",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"Profil",1)+7)
                If profil="" Then
                    profil = wert
                End If
            End If
            
            If InStr(1,kette,"Typ",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"Typ",1)+4)
                typ = wert
            End If
            
            If InStr(1,kette,"MSWordinstalled",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"MSWordinstalled",1)+16)
                If LCase(wert)="true" Then
                    acceptdoc = True
                End If	
            End If
            
            If InStr(1,kette,"MSExcelinstalled",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"MSExcelinstalled",1)+17)
                If LCase(wert)="true" Then
                    acceptxls = True
                End If	
            End If
            
            If InStr(1,kette,"MSPowerPointinstalled",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"MSPowerPointinstalled",1)+22)
                If LCase(wert)="true" Then
                    acceptppt = True
                End If	
            End If
            
            If InStr(1,kette,"DWGViewerinstalled",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"DWGViewerinstalled",1)+19)
                If LCase(wert)="true" Then
                    acceptdwg = True
                End If	
            End If
            
            
            If InStr(1,kette,"acceptallfiletypes",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"acceptallfiletypes",1)+19)
                If LCase(wert)="true" Then
                    acceptallfiletypes = True
                End If	
            End If
            
            If InStr(1,kette,"maildomain",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"maildomain",1)+11)
                maildomain = Trim(wert)
            End If
            
            If InStr(1,kette,"archmsg",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"archmsg",1)+7)
                If LCase(wert)="true" Then
                    archmsg=True
                End If
            End If
            
            If InStr(1,kette,"attachmentdontuseoriname",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"attachmentdontuseoriname",1)+24)
                If LCase(wert)="true" Then
                    attachmentdontuseoriname=True
                End If
            End If
            
            If InStr(1,kette,"emailacceptnoextension",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"emailacceptnoextension",1)+23)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        emailacceptnoextension=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"emailwhitelistextensions",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"emailwhitelistextensions",1)+25)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    emailwhite=Trim(LCase(wert))
                End If
            End If
            
            
            If InStr(1,kette,"emailblacklistextensions",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"emailblacklistextensions",1)+25)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    emailblack=Trim(LCase(wert))
                End If
            End If
            
            If InStr(1,kette,"outlookimportpath",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"outlookimportpath",1)+18)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    outlookimportpath=Trim(LCase(wert))
                End If
            End If
            
            
            
        End If
    Loop
    inifile.close
    Set inifile = Nothing
    If programm="" Then
        objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - kein Programmpfad."
        WScript.Quit
    End If
    
End Function





Private Function NormString(String)
    On Error Resume Next
    tempkette=""
    wert1=0
    l = Len(String)
    
    For x = 1 To l
        wert1=Asc(Mid(String,x,1))
        If (wert1>=0) And (wert1<=32) Then
            tempkette=tempkette&" "
        Else
            If ((wert1>=48) And (wert1<=57)) Or ((wert1>=64) And (wert1<=90)) Or ((wert1>=97) And (wert1<=122)) Or (Chr(wert1)="-") Or (Chr(wert1)="_") Or (Chr(wert1)=".") Or (Chr(wert1)="")Or (Chr(wert1)="")Or (Chr(wert1)="")Or (Chr(wert1)="")Or (Chr(wert1)="")Or (Chr(wert1)="")Or (Chr(wert1)="")Then			
                tempkette=tempkette+Chr(wert1)
            Else
                tempkette=tempkette&""
            End If
        End If
    Next
    
    NormString=Trim(tempkette)
End Function




Private Function GetWord(kette,pos)
    On Error Resume Next
    zeichen=""
    ergebnis=""
    index1=pos
    'MsgBox(Len(kette)&":"&pos)
    Do While (zeichen<>" ") And (zeichen<>"	") And (index1>1)
        index1=index1-1
        zeichen=Mid(kette,index1,1)
        
    Loop
    'MsgBox(index1)
    zeichen=""
    index2=0
    maxindex2=Len(kette)-index1+2
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (zeichen<>"	") And (index2<maxindex2)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,index1+index2,1)
        index2=index2+1
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=")) And (ergebnis="") Then
            zeichen=""
        End If
    Loop
    'MsgBox(index)
    Trim(ergebnis)
    GetWord=ergebnis
End Function

Function Unlock(lockfileandpath)
    On Error Resume Next
    Err.clear
    If lockfileandpath<>"" Then
        If fs.fileexists(lockfileandpath) Then
            fs.DeleteFile lockfileandpath
            If Err.number<>0 Then
                objWshShell.LogEvent 1, "archivierung(F1): Fehler: kann lockdatei nicht lschen:"&lockfileandpath
                WScript.Quit
            End If
        End If
    End If
End Function

Function Zufallszahl(von, bis)
    On Error Resume Next
    anzahl = bis-von+1
    Randomize
    Zufallszahl = Fix(Rnd*(anzahl))+von
End Function

Private Function StrConvert(String)
    On Error Resume Next
    wert1=0
    l = Len(String)
    
    For x = 1 To l
        wert1=wert1+((Asc(Mid(String,x,1))-48)*(10^(l-x)))
    Next
    StrConvert=wert1
End Function



Private Function GetString(kette,pos)
    On Error Resume Next
    
    
    zeichen=""
    ergebnis=""
    index=0
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (zeichen<>"	") And (index<80)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,pos+index,1)
        index=index+1
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=")) And (ergebnis="") Then
            zeichen=""
        End If
    Loop
    Trim(ergebnis)
    GetString=ergebnis
End Function


Function RegRead(tempkey)
    On Error Resume Next
    privkey = tempkey
    
    RegRead = objWSHShell.RegRead(privkey)
    If Not Err.number=0 Then
        MsgBox("Fehler: Registrierungsschlssel nicht gesetzt.")
        RegRead=""
        Err.clear
        WScript.Quit
    End If
End Function

Private Function conformfilename(strname)
    On Error Resume Next
    
    
    strname = Replace(strname,"\","")
    strname = Replace(strname,"/","")
    strname = Replace(strname,"+","")
    strname = Replace(strname,"*","")
    strname = Replace(strname,":","-")
    strname = Replace(strname,"<","(")
    strname = Replace(strname,">",")")
    strname = Replace(strname,"|","")
    strname = Replace(strname,"?","")
    strname = Replace(strname,Chr(34),"'")
    
    conformfilename = Trim(strname)
    
End Function



Function showmsg()
    On Error Resume Next
    showmsg=True
    Err.clear
    On Error Resume Next
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        showmsg=False
    Else
        Set objWMIService = Nothing
    End If
    If showmsg=True Then
        Set oExec = objWSHShell.exec(Chr(34)&programm&"bfamessage.exe"&Chr(34))
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            showmsg=False
        Else
            Set oexec=Nothing
        End If
    End If
End Function



Function removemsg()
    On Error Resume Next
    Err.clear
    On Error Resume Next
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    If Err.number=0 Then
        strQuery = "Select * from Win32_Process where Name='bfamessage.exe'"
        Set colItems = objWMIService.ExecQuery(strQuery,,48)
        For Each objItem In colItems
            objItem.Terminate()
        Next
        WScript.sleep 100
        Set colItems = Nothing
        Set objWMIService = Nothing
    End If
    Err.clear
    On Error Resume Next
End Function


function RegRead(tempkey)
    On Error Resume Next
	privkey = tempkey
	RegRead = objWSHShell.RegRead(privkey)
	if not err.number=0 Then
	objWshShell.LogEvent 1, "bitfarm-Archiv: Fehler: Registrierungsschlssel nicht gesetzt."
	RegRead=""
	err.clear
	WScript.Quit
	end if
end function
'*******************************************************************************************
'*******************************************************************************************
'********************************          Ende             ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
