'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'***************  processmonitor.vbs   GPL  ************************************************
'*******************************************************************************************
'***************  Version 3.6.2.0           ************************************************
'*******************************************************************************************
'***************  Programm zur berwachung einzelner Hilfsprozesse           ***************
'***************  fr die Dokumentenkonvertierung (Beispiel: WinWord)        ***************
'***************                                                             ***************
'***************  kontrolliert, ob ein Prozess noch aktiv ist und            ***************
'***************  schliet diesen kontrolliert, wenn ein Fehler auftritt     ***************
'***************  Verhindert so, dass durch ein fehlerhaftes Dokument        ***************
'***************  die gesamte Verarbeitung blockiert wird.                   ***************
'***************                                                             ***************
'***************  Syntax: <programmpfad>processmonitor.vbs (Prozess)         ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

On Error Resume Next


Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set oArgs    = WScript.Arguments 

myprocessname=""
myprocessexe=""

bit32 = False
bit64 = False

OSBitWidth()

myprocess = oArgs.item(0) 
If Err.number<>0 Then
    objWshShell.LogEvent 1, "bitfarm-Archiv: processmonitor: Parameter fehlt (Prozess)."
    Err.clear
    WScript.Quit
End If 



'****************************************************************************
'****************************************************************************
'******************************** Bekannte Prozesse *************************
'****************************************************************************
'****************************************************************************


If myprocess="WORD" Then
    myprocessname="winword"
    myprocessexe="WinWord.exe"
End If

If myprocess="EXCEL" Then
    myprocessname="excel"
    myprocessexe="Excel.exe"
End If

If myprocess="POWERPOINT" Then
    myprocessname="powerpoint"
    myprocessexe="PowerPoint.exe"
End If

If myprocess="PDFtoPS" Then
    myprocessname="pdftops"
    myprocessexe="pdftops.exe"
End If

If LCase(myprocess)="ghostscript" Then
	If bit32=True Then
    	myprocessname="gswin32c"
    	myprocessexe="gswin32c.exe"
    ElseIf bit64=True Then
    	myprocessname="gswin64c"
    	myprocessexe="gswin64c.exe"
    End If
End If


If LCase(myprocess)="isb" Then
    myprocessname="p109exe"
    myprocessexe="p109exe.exe"
End If


'****************************************************************************
'****************************************************************************
'****************************************************************************
'****************************************************************************
'****************************************************************************
'****************************************************************************



If myprocessname="" Then
    objWshShell.LogEvent 1, "bitfarm-Archiv: processmonitor: Nicht definierter Prozess: "&myprocess
    WScript.Quit
End If

i=0
abbruch=False
Do While abbruch=False
    WScript.sleep 300
    i=i+1
    If i>10 Then 
        abbruch=True
    End If
    If testprocess=True Then
        abbruch=True
        'objWshShell.LogEvent 1, "Prozess gefunden!! "&myprocess
    End If
Loop

WScript.sleep 1000	

abbruch=False
i=0
Do While abbruch=False
    WScript.sleep 1500
    i=i+1
    If i>1000 Then 
        abbruch=True
    End If
    If testprocess=False Then
        WScript.Quit
    End If
    If (testprocess=True) And (checkprocess=False) Then
        
        WScript.sleep 3000
        
        If (testprocess=True) And (checkprocess=False) Then
            
            WScript.sleep 3000
            
            If (testprocess=True) And (checkprocess=False) Then
                
                WScript.sleep 3000
                
                If (testprocess=True) And (checkprocess=False) Then
                    
                    WScript.sleep 3000
                    
                    If (testprocess=True) And (checkprocess=False) Then
                        
                        WScript.sleep 3000
                        
                        If (testprocess=True) And (checkprocess=False) Then
                            termprocess
                            
                            WScript.quit
                        End If
                    End If
                End If
            End If
        End If
    End If 
    
Loop


WScript.quit





Sub OSBitWidth
	Bits = GetObject("winmgmts:root\cimv2:Win32_Processor='cpu0'").AddressWidth
	If Bits = 32 then
		bit32 = True
		bit64 = False
	End If 
	If Bits = 64 then
		bit32 = False
		bit64 = True
	End If 
End sub



Function testprocess
    On Error Resume Next
    testprocess=False
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='"&myprocessexe&"'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    z=0
    For Each objItem In colItems
        
        z=z+1
    Next
    If z>0 Then
        testprocess=True
    End If
    
    Set colItems = Nothing
    Set objWMIService = Nothing
End Function





Function termprocess
    On Error Resume Next
    WScript.Sleep 1000
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='"&myprocessexe&"'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    z=0
    For Each objItem In colItems
        objItem.Terminate()
        z=z+1
    Next
    If z>0 Then
        objWshShell.LogEvent 2, "bitfarm-Archiv: Terminierte Prozess-Instanzen ("&myprocessname&"): "&z
    End If
    Set colItems = Nothing
    Set objWMIService = Nothing
End Function




Function checkprocess
    On Error Resume Next
    checkprocess=False
    WScript.Sleep 50
    Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    WScript.Sleep 50
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = '"&myprocessname&"'")
    WScript.Sleep 50
    oldcounter=0
    newcounter=0
    old1counter=0
    new1counter=0
    kette=""
    For Each strProcess In colProcesses
        kette=strProcess.IOReadBytesPerSec&vbCrLf
        oldcounter=strProcess.IOReadOperationsPerSec
        kette=kette&strProcess.IOWriteBytesPerSec&vbCrLf
        old1counter=strProcess.IOWriteOperationsPerSec
        kette=kette&IOOtherBytesPerSec&vbCrLf
        kette=kette&strProcess.IOOtherOperationsPerSec&vbCrLf
        kette=kette&"Prozessorzeit"&strProcess.PercentProcessorTime
    Next
    Set colProcess=Nothing
    Set objWMIService=Nothing
    WScript.Sleep 2000
    Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    WScript.Sleep 50
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = '"&myprocessname&"'")
    WScript.Sleep 50
    
    kette=""
    For Each strProcess In colProcesses
        kette=strProcess.IOReadBytesPerSec&vbCrLf
        newcounter=strProcess.IOReadOperationsPerSec
        kette=kette&strProcess.IOWriteBytesPerSec&vbCrLf
        new1counter=strProcess.IOWriteOperationsPerSec
        kette=kette&IOOtherBytesPerSec&vbCrLf
        kette=kette&strProcess.IOOtherOperationsPerSec&vbCrLf
        kette=kette&"Prozessorzeit"&strProcess.PercentProcessorTime
    Next
    Set colProcess=Nothing
    Set objWMIService=Nothing
    
    
    If (oldcounter <> newcounter) Then
        
        checkprocess=True
    End If
    
    If (old1counter <> new1counter) Then
        
        checkprocess=True
    End If
    
    
End Function
