'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2023    ******************************
'*******************************************************************************************
'*******************************************************************************************
'***************  psprint.vbs      GPL  ****************************************************
'*******************************************************************************************
'***************  Version 3.6.2.1       ****************************************************
'*******************************************************************************************
'***************  Programm zur Entgegennahme von Druck.Dateien durch         ***************
'***************  den Archivspooler                                          ***************
'***************  druckt ber bfa_pdf2tif                                    ***************
'***************                                                             ***************
'***************  Syntax:                                                    ***************
'***************   <programmpfad>psprint.vbs <druckername><datei><Profil>    ***************
'***************  gltig sind Postscript oder pdf Dateien                    ***************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************

On Error Resume Next

scriptdebug=False


Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set oArgs  = Wscript.Arguments           
Set fs = CreateObject("Scripting.FileSystemObject")

'*******************************************************************************************
'**************************  Startparameter initialisieren  ********************************
err.clear
fullpath = WScript.ScriptFullName
If err.number Then
    err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
scriptname = WScript.ScriptName
If err.number Then
    err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))
If err.number Then
    err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
If Len(programm)=0 Then
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If


'*******************************************************************************************
'*******************************************************************************************

gsview=""
bfa_pdf2tif = programm & "bfa_pdf2tif.exe"

If oArgs.Count < 3 Then
    objWshShell.LogEvent 1, "psprint.vbs Es wurden nicht genug Parameter bergeben <druckername><datei><profil>"
    WScript.Quit
    
End If

druckername=oArgs.Item(0)
tempname=oArgs.Item(1)
profil=oArgs.Item(2)



If scriptdebug = True Then
    objWshShell.LogEvent 0, "psprint.vbs Parameter" & vbCrLf & druckername & vbCrLf &  tempname & vbCrLf & profil
End If

If fs.FileExists(tempname) = False Then
    objWshShell.LogEvent 1, "psprint.vbs bergebene Datei nicht verfgbar" & vbCrLf & tempname 
    Wscript.quit
    
End If


erfolg = readconfig(profil)

If InStr(1,druckername,"~") Then
    druckername = Replace(druckername,"~","\")
End If
If InStr(1,druckername,"#") Then
    druckername = Replace(druckername,"#"," ")
End If


If erfolg = True Then    
    extension="." & LCase(fs.GetExtensionName(tempname))
    If (extension=".ps" Or extension=".pdf") And druckername <> "" Then
        
        cmd = Chr(34)&programm&"bfa_pdf2tif.exe" & Chr(34) & " -i " & Chr(34) & tempname & Chr(34) & " --printer " & Chr(34) & druckername & Chr(34)
	                        
	    If scriptdebug = True Then
	        objWSHShell.LogEvent 4, "psprint.vbs: bfa_pdf2tif Aufruf:" & vbCrLf & cmd
	    End If 
	    
	    Set oexec = objWSHShell.Exec(cmd)
	    durch = False
	    schleife = 0
	    Do While schleife < 1000
	        If oexec.Status = 1 Then 
	            durch = True
	            Exit Do
	        End If
	        
	        WScript.Sleep 200  
	        schleife = schleife +1
	    Loop
        
        If durch = True Then
            fs.deletefile tempname, True
            If err.number Then
                objWshShell.LogEvent 1, "psprint.vbs. Konnte temporre Datei nicht lschen" & vbCrLf & tempname & vbCrLf & err.number & vbTab & err.Description
            End If
        Else
        	objWshShell.LogEvent 1, "psprint.vbs bfa_pdf2tif konnte nicht ausgefhrt werden" & vbCrLf & "Status: " & oexec.Status & vbTab & "Exitcode " & oexec.ExitCode & vbTab & "Schleife: " & schleife
        	oexec.Terminate
        End If
        
        WScript.Sleep 500
    End If
    
Else
    objWSHShell.LogEvent 1, "bitfarm-Archiv: psprint.vbs: Konnte Profil nicht lesen"
    
End If



WScript.Quit



'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************Ende Hauptprogramm******************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************


Function readconfig(profil)
    On Error Resume Next
    readconfig=True
    err.clear
    
    If Not fs.FileExists(programm&profil&".con") Then
        err.clear
        errortxt=programm&profil&".con Datei nicht im Scriptpfad vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        readconfig=False
        err.clear
    End If
    
    If readconfig=True Then	
        Set confile = fs.OpenTextFile(programm&profil&".con",1)
        If err.number Then
            err.clear
            errortxt="Profilfdatei nicht im Scriptpfad vorhanden oder nicht lesbar."
            objWshShell.LogEvent 1, errortxt
            err.clear
            readconfig=False
            
        End If 
    End If
    
    If readconfig=True Then	
        kette=confile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        Do While Scriptsflag = 0
            kette=confile.readline
            Scriptsflag=InStr(1,kette,"[Scripts]")
            If confile.AtEndOfStream = True Then
                confile.close
                Set confile=Nothing
                scriptsflag=1
                errortxt="Fehler beim Lesen der CON-Datei - falsche Formatierung."
                objWshShell.LogEvent 1, errortxt
                readconfig = False
                
            End If
        Loop
        
    End If
    
    
    If readconfig = True Then
        
        Do While confile.AtEndOfStream <> True
            kette=confile.readline
            If Left(kette,1)<>";" Then
                
                
                If InStr(1,kette,"gsview",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"gsview",1)+6))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        gsview = wert
                    End If
                    
                End If		
                
                '	
                '	If InStr(1,kette,"unverteilt",1)<>0 Then
                '		wert=GetString(kette,InStr(1,kette,"unverteilt",1)+11)
                '		unverteilt = wert
                '	End If
                '	
                '	If InStr(1,kette,"uncclientspooler",1)<>0 Then
                '		wert=GetString(kette,InStr(1,kette,"uncclientspooler",1)+16)
                '		uncclientspooler = wert
                '		If Len(uncclientspooler)>2 Then
                '			uncclientspooler=Left(uncclientspooler,Len(uncclientspooler)-1)
                '		End If
                '	End If
                '	
            End If
            
        Loop
        confile.close
        Set confile = Nothing
        
    End If
    
    
End Function



Private Function GetString(kette,pos)
    On Error Resume Next
    
    zeichen=""
    ergebnis=""
    index=0
    charwert=0
    If Len(zeichen)=1 Then
        charwert=Asc(zeichen)
    End If
    Do While (zeichen<>" ") And (zeichen<>Vbcrlf) And (charwert<>13) And (charwert<>10) And (zeichen<>"	") And (index<80)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,pos+index,1)
        index=index+1
        If Len(zeichen)=1 Then
            charwert=Asc(zeichen)
        End If
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=") Or (charwert=10) Or (charwert=13)) And (ergebnis="") Then
            zeichen=""
        End If
        
    Loop
    
    GetString=Trim(ergebnis)
End Function



'***************************************************************************************
'***************************************************************************************
'***************************************************************************************
'*****************************************************************************************

'' SIG '' Begin signature block
'' SIG '' MIIkxgYJKoZIhvcNAQcCoIIktzCCJLMCAQExCzAJBgUr
'' SIG '' DgMCGgUAMGcGCisGAQQBgjcCAQSgWTBXMDIGCisGAQQB
'' SIG '' gjcCAR4wJAIBAQQQTvApFpkntU2P5azhDxfrqwIBAAIB
'' SIG '' AAIBAAIBAAIBADAhMAkGBSsOAwIaBQAEFJZU72X4tekR
'' SIG '' voZJuZfvcmKVdrZdoIIeuTCCBU4wggQ2oAMCAQICEHun
'' SIG '' lQxDIiTZXVcM5VXbpQMwDQYJKoZIhvcNAQELBQAwfDEL
'' SIG '' MAkGA1UEBhMCR0IxGzAZBgNVBAgTEkdyZWF0ZXIgTWFu
'' SIG '' Y2hlc3RlcjEQMA4GA1UEBxMHU2FsZm9yZDEYMBYGA1UE
'' SIG '' ChMPU2VjdGlnbyBMaW1pdGVkMSQwIgYDVQQDExtTZWN0
'' SIG '' aWdvIFJTQSBDb2RlIFNpZ25pbmcgQ0EwHhcNMjEwNTMx
'' SIG '' MDAwMDAwWhcNMjQwNTMwMjM1OTU5WjCBkjELMAkGA1UE
'' SIG '' BhMCREUxHDAaBgNVBAgME05vcmRyaGVpbi1XZXN0ZmFs
'' SIG '' ZW4xDzANBgNVBAcMBlNpZWdlbjEpMCcGA1UECgwgYml0
'' SIG '' ZmFybSBJbmZvcm1hdGlvbnNzeXN0ZW1lIEdtYkgxKTAn
'' SIG '' BgNVBAMMIGJpdGZhcm0gSW5mb3JtYXRpb25zc3lzdGVt
'' SIG '' ZSBHbWJIMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIB
'' SIG '' CgKCAQEAoRJ0i87hei84JWio6ppr39qNUaIVkivyYmXk
'' SIG '' Kcc2biAsUT32n4M4vTPpwRG7Y0JkUPVQkq76hIU/WK2l
'' SIG '' LQO4AmgMnIz7X2KvZxytsUELaV0chUrM4Mp2aU/2msqr
'' SIG '' 4BnmojsncK+KBvls0GhWRPwmOcOJlM4kkUHqxaAeEMBK
'' SIG '' aaXmK4e9szmw1wxaOdsUx7SOd4dYFMhCZnyHbiWmTScm
'' SIG '' 8tXl29UJjeUx4MuR8ihzLSABSMQaLfc4Efs4APpgcvPp
'' SIG '' 7LOZjCCHL8cfu796tlHxie6a64rpdi/XfBTN1DuWdC65
'' SIG '' 8hwaBshTU+qrtADaBq8EBpt8VnkYIfMifgP6XHjITQID
'' SIG '' AQABo4IBszCCAa8wHwYDVR0jBBgwFoAUDuE6qFM6MdWK
'' SIG '' vsG7rWcaA4WtNA4wHQYDVR0OBBYEFOXIB9Ay7umZN/qG
'' SIG '' Oy9DE2bx+RbOMA4GA1UdDwEB/wQEAwIHgDAMBgNVHRMB
'' SIG '' Af8EAjAAMBMGA1UdJQQMMAoGCCsGAQUFBwMDMBEGCWCG
'' SIG '' SAGG+EIBAQQEAwIEEDBKBgNVHSAEQzBBMDUGDCsGAQQB
'' SIG '' sjEBAgEDAjAlMCMGCCsGAQUFBwIBFhdodHRwczovL3Nl
'' SIG '' Y3RpZ28uY29tL0NQUzAIBgZngQwBBAEwQwYDVR0fBDww
'' SIG '' OjA4oDagNIYyaHR0cDovL2NybC5zZWN0aWdvLmNvbS9T
'' SIG '' ZWN0aWdvUlNBQ29kZVNpZ25pbmdDQS5jcmwwcwYIKwYB
'' SIG '' BQUHAQEEZzBlMD4GCCsGAQUFBzAChjJodHRwOi8vY3J0
'' SIG '' LnNlY3RpZ28uY29tL1NlY3RpZ29SU0FDb2RlU2lnbmlu
'' SIG '' Z0NBLmNydDAjBggrBgEFBQcwAYYXaHR0cDovL29jc3Au
'' SIG '' c2VjdGlnby5jb20wIQYDVR0RBBowGIEWaW5mb0BiaXRm
'' SIG '' YXJtLWFyY2hpdi5kZTANBgkqhkiG9w0BAQsFAAOCAQEA
'' SIG '' RLt57msg2LAnUeKBkqSEMK0YCuO6Ww/ZCUowag88f0K9
'' SIG '' wFC+wwlIZOSQVoniG6jCLDYJ63n2JPRtN1Ubv3sVXwbZ
'' SIG '' czAx7EEeq7pzp9zwQ+ezNV/29XKX68HZF9vnstw3Sh30
'' SIG '' rwM0uQV/MBiVBwSPK9ZMgbI84SwS+vf3RNlRdtEv+ofr
'' SIG '' b8QVZIKWu6C+xQuFIMVf/uyqJo8aII0jdGG0KDmqD3Fi
'' SIG '' k5aY7Qt9+lgPCGkBeXNMDBadLNWF3618Zbn6gJkhRAYY
'' SIG '' EJ855Qsn1M8jGo6OweX8yfg/zO4cGv7g7L5LrjZKRirf
'' SIG '' J3A2Mditxflhw9llAu7YZcpjKxceXJhCgjCCBYEwggRp
'' SIG '' oAMCAQICEDlyRDr5IrdR19NsEN0xNZUwDQYJKoZIhvcN
'' SIG '' AQEMBQAwezELMAkGA1UEBhMCR0IxGzAZBgNVBAgMEkdy
'' SIG '' ZWF0ZXIgTWFuY2hlc3RlcjEQMA4GA1UEBwwHU2FsZm9y
'' SIG '' ZDEaMBgGA1UECgwRQ29tb2RvIENBIExpbWl0ZWQxITAf
'' SIG '' BgNVBAMMGEFBQSBDZXJ0aWZpY2F0ZSBTZXJ2aWNlczAe
'' SIG '' Fw0xOTAzMTIwMDAwMDBaFw0yODEyMzEyMzU5NTlaMIGI
'' SIG '' MQswCQYDVQQGEwJVUzETMBEGA1UECBMKTmV3IEplcnNl
'' SIG '' eTEUMBIGA1UEBxMLSmVyc2V5IENpdHkxHjAcBgNVBAoT
'' SIG '' FVRoZSBVU0VSVFJVU1QgTmV0d29yazEuMCwGA1UEAxMl
'' SIG '' VVNFUlRydXN0IFJTQSBDZXJ0aWZpY2F0aW9uIEF1dGhv
'' SIG '' cml0eTCCAiIwDQYJKoZIhvcNAQEBBQADggIPADCCAgoC
'' SIG '' ggIBAIASZRc2DsPbCLPQrFcNdu3NJ9NMrVCDYeKqIE0J
'' SIG '' LWQJ3M6Jn8w9qez2z8Hc8dOx1ns3KBErR9o5xrw6GbRf
'' SIG '' pr19naNjQrZ28qk7K5H44m/Q7BYgkAk+4uh0yRi0kdRi
'' SIG '' ZNt/owbxiBhqkCI8vP4T8IcUe/bkH47U5FHGEWdGCFHL
'' SIG '' hhRUP7wz/n5snP8WnRi9UY41pqdmyHJn2yFmsdSbeAPA
'' SIG '' UDrozPDcvJ5M/q8FljUfV1q3/875PbcstvZU3cjnEjpN
'' SIG '' rkyKt1yatLcgPcp/IjSufjtoZgFE5wFORlObM2D3lL5T
'' SIG '' N5BzQ/Myw1Pv26r+dE5px2uMYJPexMcM3+EyrsyTO1F4
'' SIG '' lWeL7j1W/gzQaQ8bD/MlJmszbfduR/pzQ+V+DqVmsSl8
'' SIG '' MoRjVYnEDcGTVDAZE6zTfTen6106bDVc20HXEtqpSQvf
'' SIG '' 2ICKCZNijrVmzyWIzYS4sT+kOQ/ZAp7rEkyVfPNrBale
'' SIG '' FoPMuGfi6BOdzFuC00yz7Vv/3uVzrCM7LQC/NVV0CUnY
'' SIG '' SVgaf5I25lGSDvMmfRxNF7zJ7EMm0L9BX0CpRET0medX
'' SIG '' h55QH1dUqD79dGMvsVBlCeZYQi5DGky08CVHWfoEHpPU
'' SIG '' JkZKUIGy3r54t/xnFeHJV4QeD2PW6WK61l9VLupcxigI
'' SIG '' BCU5uA4rqfJMlxwHPw1S9e3vL4IPAgMBAAGjgfIwge8w
'' SIG '' HwYDVR0jBBgwFoAUoBEKIz6W8Qfs4q8p74Klf9AwpLQw
'' SIG '' HQYDVR0OBBYEFFN5v1qqK0rPVIDh2JvAnfKyA2bLMA4G
'' SIG '' A1UdDwEB/wQEAwIBhjAPBgNVHRMBAf8EBTADAQH/MBEG
'' SIG '' A1UdIAQKMAgwBgYEVR0gADBDBgNVHR8EPDA6MDigNqA0
'' SIG '' hjJodHRwOi8vY3JsLmNvbW9kb2NhLmNvbS9BQUFDZXJ0
'' SIG '' aWZpY2F0ZVNlcnZpY2VzLmNybDA0BggrBgEFBQcBAQQo
'' SIG '' MCYwJAYIKwYBBQUHMAGGGGh0dHA6Ly9vY3NwLmNvbW9k
'' SIG '' b2NhLmNvbTANBgkqhkiG9w0BAQwFAAOCAQEAGIdR3HQh
'' SIG '' PZyK4Ce3M9AuzOzw5steEd4ib5t1jp5y/uTW/qofnJYt
'' SIG '' 7wNKfq70jW9yPEM7wD/ruN9cqqnGrvL82O6je0P2hjZ8
'' SIG '' FODN9Pc//t64tIrwkZb+/UNkfv3M0gGhfX34GRnJQisT
'' SIG '' v1iLuqSiZgR2iJFODIkUzqJNyTKzuugUGrxx8VvwQQuY
'' SIG '' AAoiAxDlDLH5zZI3Ge078eQ6tvlFEyZ1r7uq7z97dzvS
'' SIG '' xAKRPRkA0xdcOds/exgNRc2ThZYvXd9ZFk8/Ub3VRRg/
'' SIG '' 7UqO6AZhdCMWtQ1QcydER38QXYkqa4UxFMToqWpMgLxq
'' SIG '' eM+4f452cpkMnf7XkQgWoaNflTCCBfUwggPdoAMCAQIC
'' SIG '' EB2iSDBvmyYY0ILgln0z02owDQYJKoZIhvcNAQEMBQAw
'' SIG '' gYgxCzAJBgNVBAYTAlVTMRMwEQYDVQQIEwpOZXcgSmVy
'' SIG '' c2V5MRQwEgYDVQQHEwtKZXJzZXkgQ2l0eTEeMBwGA1UE
'' SIG '' ChMVVGhlIFVTRVJUUlVTVCBOZXR3b3JrMS4wLAYDVQQD
'' SIG '' EyVVU0VSVHJ1c3QgUlNBIENlcnRpZmljYXRpb24gQXV0
'' SIG '' aG9yaXR5MB4XDTE4MTEwMjAwMDAwMFoXDTMwMTIzMTIz
'' SIG '' NTk1OVowfDELMAkGA1UEBhMCR0IxGzAZBgNVBAgTEkdy
'' SIG '' ZWF0ZXIgTWFuY2hlc3RlcjEQMA4GA1UEBxMHU2FsZm9y
'' SIG '' ZDEYMBYGA1UEChMPU2VjdGlnbyBMaW1pdGVkMSQwIgYD
'' SIG '' VQQDExtTZWN0aWdvIFJTQSBDb2RlIFNpZ25pbmcgQ0Ew
'' SIG '' ggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEKAoIBAQCG
'' SIG '' Io0yhXoYn0nwli9jCB4t3HyfFM/jJrYlZilAhlRGdDFi
'' SIG '' xRDtsocnppnLlTDAVvWkdcapDlBipVGREGrgS2Ku/fD4
'' SIG '' GKyn/+4uMyD6DBmJqGx7rQDDYaHcaWVtH24nlteXUYam
'' SIG '' 9CflfGqLlR5bYNV+1xaSnAAvaPeX7Wpyvjg7Y96Pv25M
'' SIG '' QV0SIAhZ6DnNj9LWzwa0VwW2TqE+V2sfmLzEYtYbC43H
'' SIG '' ZhtKn52BxHJAteJf7wtF/6POF6YtVbC3sLxUap28jVZT
'' SIG '' xvC6eVBJLPcDuf4vZTXyIuosB69G2flGHNyMfHEo8/6n
'' SIG '' xhTdVZFuihEN3wYklX0Pp6F8OtqGNWHTAgMBAAGjggFk
'' SIG '' MIIBYDAfBgNVHSMEGDAWgBRTeb9aqitKz1SA4dibwJ3y
'' SIG '' sgNmyzAdBgNVHQ4EFgQUDuE6qFM6MdWKvsG7rWcaA4Wt
'' SIG '' NA4wDgYDVR0PAQH/BAQDAgGGMBIGA1UdEwEB/wQIMAYB
'' SIG '' Af8CAQAwHQYDVR0lBBYwFAYIKwYBBQUHAwMGCCsGAQUF
'' SIG '' BwMIMBEGA1UdIAQKMAgwBgYEVR0gADBQBgNVHR8ESTBH
'' SIG '' MEWgQ6BBhj9odHRwOi8vY3JsLnVzZXJ0cnVzdC5jb20v
'' SIG '' VVNFUlRydXN0UlNBQ2VydGlmaWNhdGlvbkF1dGhvcml0
'' SIG '' eS5jcmwwdgYIKwYBBQUHAQEEajBoMD8GCCsGAQUFBzAC
'' SIG '' hjNodHRwOi8vY3J0LnVzZXJ0cnVzdC5jb20vVVNFUlRy
'' SIG '' dXN0UlNBQWRkVHJ1c3RDQS5jcnQwJQYIKwYBBQUHMAGG
'' SIG '' GWh0dHA6Ly9vY3NwLnVzZXJ0cnVzdC5jb20wDQYJKoZI
'' SIG '' hvcNAQEMBQADggIBAE1jUO1HNEphpNveaiqMm/EAAB4d
'' SIG '' Yns61zLC9rPgY7P7YQCImhttEAcET7646ol4IusPRuzz
'' SIG '' Rl5ARokS9At3WpwqQTr81vTr5/cVlTPDoYMot94v5JT3
'' SIG '' hTODLUpASL+awk9KsY8k9LOBN9O3ZLCmI2pZaFJCX/8E
'' SIG '' 6+F0ZXkI9amT3mtxQJmWunjxucjiwwgWsatjWsgVgG10
'' SIG '' Xkp1fqW4w2y1z99KeYdcx0BNYzX2MNPPtQoOCwR/oEuu
'' SIG '' u6Ol0IQAkz5TXTSlADVpbL6fICUQDRn7UJBhvjmPeo5N
'' SIG '' 9p8OHv4HURJmgyYZSJXOSsnBf/M6BZv5b9+If8AjntIe
'' SIG '' Q3pFMcGcTanwWbJZGehqjSkEAnd8S0vNcL46slVaeD68
'' SIG '' u28DECV3FTSK+TbMQ5Lkuk/xYpMoJVcp+1EZx6ElQGqE
'' SIG '' V8aynbG8HArafGd+fS7pKEwYfsR7MUFxmksp7As9V1DS
'' SIG '' yt39ngVR5UR43QHesXWYDVQk/fBO4+L4g71yuss9Ou7w
'' SIG '' XheSaG3IYfmm8SoKC6W59J7umDIFhZ7r+YMp08Ysfb06
'' SIG '' dy6LN0KgaoLtO0qqlBCk4Q34F8W2WnkzGJLjtXX4oemO
'' SIG '' CiUe5B7xn1qHI/+fpFGe+zmAEc3btcSnqIBv5VPU4OOi
'' SIG '' wtJbGvoyJi1qV3AcPKRYLqPzW0sH3DJZ84enGm1YMIIG
'' SIG '' 7DCCBNSgAwIBAgIQMA9vrN1mmHR8qUY2p3gtuTANBgkq
'' SIG '' hkiG9w0BAQwFADCBiDELMAkGA1UEBhMCVVMxEzARBgNV
'' SIG '' BAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0plcnNleSBD
'' SIG '' aXR5MR4wHAYDVQQKExVUaGUgVVNFUlRSVVNUIE5ldHdv
'' SIG '' cmsxLjAsBgNVBAMTJVVTRVJUcnVzdCBSU0EgQ2VydGlm
'' SIG '' aWNhdGlvbiBBdXRob3JpdHkwHhcNMTkwNTAyMDAwMDAw
'' SIG '' WhcNMzgwMTE4MjM1OTU5WjB9MQswCQYDVQQGEwJHQjEb
'' SIG '' MBkGA1UECBMSR3JlYXRlciBNYW5jaGVzdGVyMRAwDgYD
'' SIG '' VQQHEwdTYWxmb3JkMRgwFgYDVQQKEw9TZWN0aWdvIExp
'' SIG '' bWl0ZWQxJTAjBgNVBAMTHFNlY3RpZ28gUlNBIFRpbWUg
'' SIG '' U3RhbXBpbmcgQ0EwggIiMA0GCSqGSIb3DQEBAQUAA4IC
'' SIG '' DwAwggIKAoICAQDIGwGv2Sx+iJl9AZg/IJC9nIAhVJO5
'' SIG '' z6A+U++zWsB21hoEpc5Hg7XrxMxJNMvzRWW5+adkFiYJ
'' SIG '' +9UyUnkuyWPCE5u2hj8BBZJmbyGr1XEQeYf0RirNxFrJ
'' SIG '' 29ddSU1yVg/cyeNTmDoqHvzOWEnTv/M5u7mkI0Ks0BXD
'' SIG '' f56iXNc48RaycNOjxN+zxXKsLgp3/A2UUrf8H5VzJD0B
'' SIG '' KLwPDU+zkQGObp0ndVXRFzs0IXuXAZSvf4DP0REKV4TJ
'' SIG '' f1bgvUacgr6Unb+0ILBgfrhN9Q0/29DqhYyKVnHRLZRM
'' SIG '' yIw80xSinL0m/9NTIMdgaZtYClT0Bef9Maz5yIUXx7gp
'' SIG '' GaQpL0bj3duRX58/Nj4OMGcrRrc1r5a+2kxgzKi7nw0U
'' SIG '' 1BjEMJh0giHPYla1IXMSHv2qyghYh3ekFesZVf/QOVQt
'' SIG '' Ju5FGjpvzdeE8NfwKMVPZIMC1Pvi3vG8Aij0bdonigbS
'' SIG '' lofe6GsO8Ft96XZpkyAcSpcsdxkrk5WYnJee647BeFbG
'' SIG '' RCXfBhKaBi2fA179g6JTZ8qx+o2hZMmIklnLqEbAyfKm
'' SIG '' /31X2xJ2+opBJNQb/HKlFKLUrUMcpEmLQTkUAx4p+hul
'' SIG '' Iq6lw02C0I3aa7fb9xhAV3PwcaP7Sn1FNsH3jYL6uckN
'' SIG '' U4B9+rY5WDLvbxhQiddPnTO9GrWdod6VQXqngwIDAQAB
'' SIG '' o4IBWjCCAVYwHwYDVR0jBBgwFoAUU3m/WqorSs9UgOHY
'' SIG '' m8Cd8rIDZsswHQYDVR0OBBYEFBqh+GEZIA/DQXdFKI7R
'' SIG '' NV8GEgRVMA4GA1UdDwEB/wQEAwIBhjASBgNVHRMBAf8E
'' SIG '' CDAGAQH/AgEAMBMGA1UdJQQMMAoGCCsGAQUFBwMIMBEG
'' SIG '' A1UdIAQKMAgwBgYEVR0gADBQBgNVHR8ESTBHMEWgQ6BB
'' SIG '' hj9odHRwOi8vY3JsLnVzZXJ0cnVzdC5jb20vVVNFUlRy
'' SIG '' dXN0UlNBQ2VydGlmaWNhdGlvbkF1dGhvcml0eS5jcmww
'' SIG '' dgYIKwYBBQUHAQEEajBoMD8GCCsGAQUFBzAChjNodHRw
'' SIG '' Oi8vY3J0LnVzZXJ0cnVzdC5jb20vVVNFUlRydXN0UlNB
'' SIG '' QWRkVHJ1c3RDQS5jcnQwJQYIKwYBBQUHMAGGGWh0dHA6
'' SIG '' Ly9vY3NwLnVzZXJ0cnVzdC5jb20wDQYJKoZIhvcNAQEM
'' SIG '' BQADggIBAG1UgaUzXRbhtVOBkXXfA3oyCy0lhBGysNsq
'' SIG '' fSoF9bw7J/RaoLlJWZApbGHLtVDb4n35nwDvQMOt0+Lk
'' SIG '' VvlYQc/xQuUQff+wdB+PxlwJ+TNe6qAcJlhc87QRD9XV
'' SIG '' w+K81Vh4v0h24URnbY+wQxAPjeT5OGK/EwHFhaNMxcyy
'' SIG '' UzCVpNb0llYIuM1cfwGWvnJSajtCN3wWeDmTk5Sbsdyy
'' SIG '' bUFtZ83Jb5A9f0VywRsj1sJVhGbks8VmBvbz1kteraMr
'' SIG '' Qoohkv6ob1olcGKBc2NeoLvY3NdK0z2vgwY4Eh0khy3k
'' SIG '' /ALWPncEvAQ2ted3y5wujSMYuaPCRx3wXdahc1cFaJqn
'' SIG '' yTdlHb7qvNhCg0MFpYumCf/RoZSmTqo9CfUFbLfSZFrY
'' SIG '' KiLCS53xOV5M3kg9mzSWmglfjv33sVKRzj+J9hyhtal1
'' SIG '' H3G/W0NdZT1QgW6r8NDT/LKzH7aZlib0PHmLXGTMze4n
'' SIG '' muWgwAxyh8FuTVrTHurwROYybxzrF06Uw3hlIDsPQaof
'' SIG '' 6aFBnf6xuKBlKjTg3qj5PObBMLvAoGMs/FwWAKjQxH/q
'' SIG '' EZ0eBsambTJdtDgJK0kHqv3sMNrxpy/Pt/360KOE2See
'' SIG '' +wFmd7lWEOEgbsausfm2usg1XTN2jvF8IAwqd661ogKG
'' SIG '' uinutFoAsYyr4/kKyVRd1LlqdJ69SK6YMIIG9TCCBN2g
'' SIG '' AwIBAgIQOUwl4XygbSeoZeI72R0i1DANBgkqhkiG9w0B
'' SIG '' AQwFADB9MQswCQYDVQQGEwJHQjEbMBkGA1UECBMSR3Jl
'' SIG '' YXRlciBNYW5jaGVzdGVyMRAwDgYDVQQHEwdTYWxmb3Jk
'' SIG '' MRgwFgYDVQQKEw9TZWN0aWdvIExpbWl0ZWQxJTAjBgNV
'' SIG '' BAMTHFNlY3RpZ28gUlNBIFRpbWUgU3RhbXBpbmcgQ0Ew
'' SIG '' HhcNMjMwNTAzMDAwMDAwWhcNMzQwODAyMjM1OTU5WjBq
'' SIG '' MQswCQYDVQQGEwJHQjETMBEGA1UECBMKTWFuY2hlc3Rl
'' SIG '' cjEYMBYGA1UEChMPU2VjdGlnbyBMaW1pdGVkMSwwKgYD
'' SIG '' VQQDDCNTZWN0aWdvIFJTQSBUaW1lIFN0YW1waW5nIFNp
'' SIG '' Z25lciAjNDCCAiIwDQYJKoZIhvcNAQEBBQADggIPADCC
'' SIG '' AgoCggIBAKSTKFJLzyeHdqQpHJk4wOcO1NEc7GjLAWTk
'' SIG '' is13sHFlgryf/Iu7u5WY+yURjlqICWYRFFiyuiJb5vYy
'' SIG '' 8V0twHqiDuDgVmTtoeWBIHIgZEFsx8MI+vN9Xe8hmsJ+
'' SIG '' 1yzDuhGYHvzTIAhCs1+/f4hYMqsws9iMepZKGRNcrPzn
'' SIG '' q+kcFi6wsDiVSs+FUKtnAyWhuzjpD2+pWpqRKBM1uR/z
'' SIG '' PeEkyGuxmegN77tN5T2MVAOR0Pwtz1UzOHoJHAfRIuBj
'' SIG '' hqe+/dKDcxIUm5pMCUa9NLzhS1B7cuBb/Rm7HzxqGXtu
'' SIG '' uy1EKr48TMysigSTxleGoHM2K4GX+hubfoiH2FJ5if5u
'' SIG '' dzfXu1Cf+hglTxPyXnypsSBaKaujQod34PRMAkjdWKVT
'' SIG '' pqOg7RmWZRUpxe0zMCXmloOBmvZgZpBYB4DNQnWs+7SR
'' SIG '' 0MXdAUBqtqgQ7vaNereeda/TpUsYoQyfV7BeJUeRdM11
'' SIG '' EtGcb+ReDZvsdSbu/tP1ki9ShejaRFEqoswAyodmQ6Mb
'' SIG '' AO+itZadYq0nC/IbSsnDlEI3iCCEqIeuw7ojcnv4VO/4
'' SIG '' ayewhfWnQ4XYKzl021p3AtGk+vXNnD3MH65R0Hts2B0t
'' SIG '' EUJTcXTC5TWqLVIS2SXP8NPQkUMS1zJ9mGzjd0HI/x8k
'' SIG '' VO9urcY+VXvxXIc6ZPFgSwVP77kv7AkTAgMBAAGjggGC
'' SIG '' MIIBfjAfBgNVHSMEGDAWgBQaofhhGSAPw0F3RSiO0TVf
'' SIG '' BhIEVTAdBgNVHQ4EFgQUAw8xyJEqk71j89FdTaQ0D9KV
'' SIG '' ARgwDgYDVR0PAQH/BAQDAgbAMAwGA1UdEwEB/wQCMAAw
'' SIG '' FgYDVR0lAQH/BAwwCgYIKwYBBQUHAwgwSgYDVR0gBEMw
'' SIG '' QTA1BgwrBgEEAbIxAQIBAwgwJTAjBggrBgEFBQcCARYX
'' SIG '' aHR0cHM6Ly9zZWN0aWdvLmNvbS9DUFMwCAYGZ4EMAQQC
'' SIG '' MEQGA1UdHwQ9MDswOaA3oDWGM2h0dHA6Ly9jcmwuc2Vj
'' SIG '' dGlnby5jb20vU2VjdGlnb1JTQVRpbWVTdGFtcGluZ0NB
'' SIG '' LmNybDB0BggrBgEFBQcBAQRoMGYwPwYIKwYBBQUHMAKG
'' SIG '' M2h0dHA6Ly9jcnQuc2VjdGlnby5jb20vU2VjdGlnb1JT
'' SIG '' QVRpbWVTdGFtcGluZ0NBLmNydDAjBggrBgEFBQcwAYYX
'' SIG '' aHR0cDovL29jc3Auc2VjdGlnby5jb20wDQYJKoZIhvcN
'' SIG '' AQEMBQADggIBAEybZVj64HnP7xXDMm3eM5Hrd1ji673L
'' SIG '' Sjx13n6UbcMixwSV32VpYRMM9gye9YkgXsGHxwMkysel
'' SIG '' 8Cbf+PgxZQ3g621RV6aMhFIIRhwqwt7y2opF87739i7E
'' SIG '' fu347Wi/elZI6WHlmjl3vL66kWSIdf9dhRY0J9Ipy//t
'' SIG '' Ldr/vpMM7G2iDczD8W69IZEaIwBSrZfUYngqhHmo1z2s
'' SIG '' IY9wwyR5OpfxDaOjW1PYqwC6WPs1gE9fKHFsGV7Cg3KQ
'' SIG '' ruDG2PKZ++q0kmV8B3w1RB2tWBhrYvvebMQKqWzTIUZw
'' SIG '' 3C+NdUwjwkHQepY7w0vdzZImdHZcN6CaJJ5OX07Tjw/l
'' SIG '' E09ZRGVLQ2TPSPhnZ7lNv8wNsTow0KE9SK16ZeTs3+AB
'' SIG '' 8LMqSjmswaT5qX010DJAoLEZKhghssh9BXEaSyc2quCY
'' SIG '' HIN158d+S4RDzUP7kJd2KhKsQMFwW5kKQPqAbZRhe8hu
'' SIG '' uchnZyRcUI0BIN4H9wHU+C4RzZ2D5fjKJRxEPSflsIZH
'' SIG '' KgsbhHZ9e2hPjbf3E7TtoC3ucw/ZELqdmSx813UfjxDE
'' SIG '' lOZ+JOWVSoiMJ9aFZh35rmR2kehI/shVCu0pwx/eOKbA
'' SIG '' FPsyPfipg2I2yMO+AIccq/pKQhyJA9z1XHxw2V14Tu6f
'' SIG '' XiDmCWp8KwijSPUV/ARP380hHHrl9Y4a1LlAMYIFeTCC
'' SIG '' BXUCAQEwgZAwfDELMAkGA1UEBhMCR0IxGzAZBgNVBAgT
'' SIG '' EkdyZWF0ZXIgTWFuY2hlc3RlcjEQMA4GA1UEBxMHU2Fs
'' SIG '' Zm9yZDEYMBYGA1UEChMPU2VjdGlnbyBMaW1pdGVkMSQw
'' SIG '' IgYDVQQDExtTZWN0aWdvIFJTQSBDb2RlIFNpZ25pbmcg
'' SIG '' Q0ECEHunlQxDIiTZXVcM5VXbpQMwCQYFKw4DAhoFAKBw
'' SIG '' MBAGCisGAQQBgjcCAQwxAjAAMBkGCSqGSIb3DQEJAzEM
'' SIG '' BgorBgEEAYI3AgEEMBwGCisGAQQBgjcCAQsxDjAMBgor
'' SIG '' BgEEAYI3AgEVMCMGCSqGSIb3DQEJBDEWBBRZUIjL6qj2
'' SIG '' FRdFVROnAgSa5TwldDANBgkqhkiG9w0BAQEFAASCAQBp
'' SIG '' JDMlufn1srXthwZuTOyosqf65UQNmHTEcYvhe9hYGqUn
'' SIG '' DCj7d9a9MYGy/03Z1+vlGfoofkQWC7GpOEk+fGSPBFq3
'' SIG '' kCpij5e3oUOMFXwDHl99TgelnTeTtHu+0FnPFsSU9TES
'' SIG '' 7aDLCn98Jz/Yw7hfDh2I1xvbi5SaYzKLoVov81o2W7gN
'' SIG '' +gaAQVU1q0wXXlM2Td2rGNvf73rlP/+MhL0Q2P4jcSKe
'' SIG '' wcHc9Kim0YdYZUDHKRwOBCHCbcZExiFQ91D1V/Pn8mYd
'' SIG '' BD51MXg5FQ58IUtzpAoRCp4pjzZ9PZshHtNbYGHzgMRq
'' SIG '' nsCho1mP7LfvBdUnIl5XQSGcmuTL2EdOoYIDSzCCA0cG
'' SIG '' CSqGSIb3DQEJBjGCAzgwggM0AgEBMIGRMH0xCzAJBgNV
'' SIG '' BAYTAkdCMRswGQYDVQQIExJHcmVhdGVyIE1hbmNoZXN0
'' SIG '' ZXIxEDAOBgNVBAcTB1NhbGZvcmQxGDAWBgNVBAoTD1Nl
'' SIG '' Y3RpZ28gTGltaXRlZDElMCMGA1UEAxMcU2VjdGlnbyBS
'' SIG '' U0EgVGltZSBTdGFtcGluZyBDQQIQOUwl4XygbSeoZeI7
'' SIG '' 2R0i1DANBglghkgBZQMEAgIFAKB5MBgGCSqGSIb3DQEJ
'' SIG '' AzELBgkqhkiG9w0BBwEwHAYJKoZIhvcNAQkFMQ8XDTIz
'' SIG '' MDcyMDE0MjczM1owPwYJKoZIhvcNAQkEMTIEMFFbIFGw
'' SIG '' 7yT/ya+eWqDta5VL4J50BGP6n4oNwqNZg8fGdRPUtyIv
'' SIG '' KjwDFKiVV42Q6jANBgkqhkiG9w0BAQEFAASCAgCY4JWI
'' SIG '' /sAb/LREZKOnpm4tCJ9Nl92w0aVBQMM/40VCZTMfR3uV
'' SIG '' NhKWQbJ7gBRhw5Q6kQS1brDq4CdzhsArlNulXiDGSpJL
'' SIG '' 4Zj0c8fP13b+g9FhsJxlJpUTgePNUsgS2+ZzCF7+LiTK
'' SIG '' D4syI1n5OCI72M6PSuAKiHxqNAzztH9bTNdTUot9Qnkj
'' SIG '' +1uSZtVJHjeBqMIeEtM6143J7P3PBatW2hJ/e7Ay+uQw
'' SIG '' sJ9RU2wWb6LxFCD+PxI6bPeCUuliEJe0Oprb2N+1AdU7
'' SIG '' M5v5XD1HfyBobITBl7UL5ndJRcM8Hf3fYEx45WJOfLp8
'' SIG '' lD4jOIVg6hTqtzu+d9xnWPtI2sapkaV+0m8UBUfW+mYE
'' SIG '' Ir6PLXzPK0FOOhqfeUIcO7hdgyk6N00njkzBFISAnRyp
'' SIG '' ZfqxuQHyyTltPxK/ayUNMaJ+5GMp8atFYs6pw4gnm4gv
'' SIG '' B06AkFX8Bqzg9W7gxaKYh0OW/iqEduRBynj1GOV/ADGz
'' SIG '' qX/BIOVyLGE6CsbMmVeRYBPiuZYJUePV5hedJfdvilDB
'' SIG '' r+DAemsGrgdo1VYayBAAX9pVkrlnZPES/cx3PI6NPCmj
'' SIG '' dVVho4SI/ZVrKh3saUTkkBGzA3H8ChNFRpTXKgUPzhlM
'' SIG '' F3f42LEhHgUGIGuYmlDkhjnePVbxfdqWkueRya5gDUcC
'' SIG '' iXR/2lv2kEvxxvt6Gw==
'' SIG '' End signature block
