'*******************************************************************************************
'*******************************************************************************************
'***************************      bitfarm Archiv 2024      *********************************
'*******************************************************************************************
'***************  sendlinkmail.vbs    GPL  *************************************************
'*******************************************************************************************
'***************  Version 3.6.2.1          *************************************************
'*******************************************************************************************
'***************  Programm zum Versenden einer linkmail zB zur               ***************
'***************  Benachrichtung des Admins                                  ***************
'***************                                                             ***************
'***************  Syntax: <programmpfad>sendlinkmail.vbs <adresse><dokid>{nachricht} *******
'***************  dokid: kann eine mit semikolon getrennte liste             ***************
'***************         mit DokIds oder Dateinamen sein. Fr Dateiname      ***************
'***************         wird ein -file:Dateiname bergeben                  ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************


On Error Resume Next


Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set fs      = WScript.CreateObject("Scripting.FileSystemObject") 
Set oArgs    = WScript.Arguments 


workflowabgesang1= "<DIV><EM>bitfarm-<FONT color=#ff0000>Archiv</FONT> Dokumentenmanagement</EM> </DIV>"
workflowabgesang2= "<DIV><FONT id=""""><EM>Hilfe und Untersttzung: 0271 / 31396 - 0</EM></FONT></DIV>"

adresse=""
dokID=""
message=""
profil=""
smtpserver=""
sendername=""
authuser=""
authpass=""
isfile=False
cleanup=True
bfa_server_smtp=False

Err.clear
fullpath = WScript.ScriptFullName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit(1)
End If 
scriptname = WScript.ScriptName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit(1)
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit(1)
End If 
If Len(programm)=0 Then
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit(1)
End If

temp = programm & "Temp\"

inilesen

erfolg = readconfig(profil)

If bfa_server_smtp=True Then
	If Not fs.FileExists(programm & "bfa_sendmail.exe") Then
		bfa_server_smtp=False
		objWshShell.LogEvent 1, "sendlinkmail.vbs: " & programm & "bfa_sendmail.exe nicht gefunden! verwende blat.exe fr den Mailversand."
	End If
End If

If erfolg = False Then
    objWSHShell.LogEvent 1,"sendlinkmail.vbs: Das Profil konnte nicht gelesen werden" & vbCrLf & profil
    WScript.Quit(1)
End If	

If oArgs.Count < 2 Then	
    objWSHShell.LogEvent 1,"sendlinkmail.vbs: Es wurden keine/zuwenig Parameter bergeben"
    WScript.Quit(1)
End If


If oArgs.Count => 1 Then
    adresse = oArgs.Item(0)
    If InStr(1,adresse,"@") = 0 Then
        objWSHShell.LogEvent 1,"sendlinkmail.vbs: Adresse scheint keine eMAil-Adresse zu sein" & vbCrLf & adresse
        WScript.Quit(1)
    End If
End If

If oArgs.Count => 2 Then
    dokID = oArgs.Item(1)
    
    If InStr(1,dokID,"-file:") <> 0 Then
        dokID = Replace(dokID,"-file:","")
        isfile = True	
        
        
    Else
        If InStr(1,dokID,".") = 0 And Not IsNumeric(dokID) Then
            objWSHShell.LogEvent 1,"sendlinkmail.vbs: Dok_Id scheint nicht korrekt zu sein" & vbCrLf & dokID
            WScript.Quit(1)
        End If
    End If
    
End If

If oArgs.Count => 3 Then
    message = oArgs.Item(2)
    
End If

If message="" Then
    message="Sie haben eine automatische Benachrichtungsmail vom Archiv-Server erhalten. Bitte prfen Sie das Dokument"
End If

Sendlinkmail()

' ####################  Programmausstieg
WScript.Quit(0)





Function Sendlinkmail()
    On Error Resume Next
    
    mailtemplate=""
    
    betreff = "bitfarm-Archiv: Server-Automail (" & objWSHShell.ExpandEnvironmentStrings("%computername%") & ") " & Now()
    
    
    
    nachricht = message
    
    
    
    
    '**********************************  suchen nach freiem Mailto ****************************************
    i=0
    mailto=temp&"mailto"&i&".bat"
    flag10=False
    If fs.FileExists(mailto) Then
        flag10=False
    Else
        flag10=True
    End If
    
    Do While flag10=False
        i = i + 1
        mailto=temp&"mailto"&i&".bat"
        If fs.FileExists(mailto) Then
            flag10=False
        Else
            flag10=True
        End If
    Loop
    
    mailtotxt=temp&"mailto"&i&".txt"
    
    mailto1 = programm & "blat.exe -install " & smtpserver & " " & sendername &" "
    If authuser <> "" Then
        mailto2 = programm & "blat.exe " & mailtotxt & " -html -s " & Chr(34) & betreff & Chr(34) & " -t " &  adresse & " -u "&authuser&" -pw "&authpass&" "
    Else
        mailto2 = programm & "blat.exe " & mailtotxt & " -html -s " & Chr(34) & betreff & Chr(34) & " -t " &  adresse & " "
    End If 
    
    
    
    If dokID<>"" Then
        'workflowtxt1="fr dieses Dokument ist ein Workflow definiert, d.h. wenn Sie mit der Bearbeitung fertig sind,"
        'workflowtxt2="senden Sie diese Nachricht einfach zurck an "&sendername&" oder drucken Sie diesen Text auf den workflow-drucker."
        workflowtxt3="Dok_Id="&dokID
    Else
        workflowtxt1=""
        workflowtxt2=""
        workflowtxt3=""
    End If
    
    Set mailfile=fs.CreateTextFile(mailto,True,False)
    if bfa_server_smtp=True Then
        mailto1 =chr(34) &  programm & "bfa_sendmail.exe" & chr(34) & " --subject " & chr(34) & betreff & chr(34) & " --htmlfile " & chr(34) & mailtotxt & chr(34) & " --htmlfile_encoding cp1252 " & " --con " & chr(34) & programm&profil&".con" & chr(34) & " --recipients " & adresse
        mailfile.writeline mailto1
    Else
        mailfile.writeline mailto1
        mailfile.writeline mailto2
    End If
    mailfile.close
    Set mailfile=Nothing
    
    Set txtfile=fs.CreateTextFile(mailtotxt,True,False)
    txtfile.writeline "<BODY style=""FONT: 10pt Arial"" bgColor=#ffffff leftMargin=5 topMargin=5>"
    txtfile.writeline "<DIV>&nbsp;</DIV><STRONG>Achtung: <FONT color=#ff0000>"&nachricht&"</FONT></STRONG>"
    'txtfile.writeline "<DIV>&nbsp;</DIV>"&workflowtxt3
    
    txtfile.writeline "<DIV>&nbsp;</DIV>"
    txtfile.writeline "<DIV>&nbsp;</DIV>"
    If dokID <> "0.0" Then
        If InStr(1,dokID,";" ) Then
            Do While ((InStr(1,dokID,";" ) <> 0) Or (dokID <> ""))
            	If InStr(dokId, ";") <> 0 Then
                	strid = Left(dokId,InStr(1,dokID,";" )-1)
                End If
                If (InStr(dokId, ";") = 0) And (dokId <> "") Then
                	strid = dokId
                	dokId = ""
                End If
                
                If isfile = True Then
                    txtfile.writeline "<DIV>Zum Dokument <A href=""file:///"&strid&""">" & strid & "</A></DIV>"
                Else
                	If InStr(strid, ".") <> 0 Then	
                    	txtfile.writeline "<DIV><A href=""docid:"&strid&""">Zum Dokument " & strid & "</A></DIV>"
                    Else
                    	txtfile.writeline "<DIV><A href=""gdocid:"&strid&""">Zum Dokument " & strid & "</A></DIV>"
                    End If
                End If
                dokid = Right(dokid,Len(dokid) - InStr(1,dokID,";" ))
            Loop
            
        Else
            If isfile = True Then
                txtfile.writeline "<DIV>Zum Dokument <A href=""file:///"&dokID&""">" & dokID & "</A></DIV>"
            Else	
                If InStr(dokID, ".") <> 0 Then
                	txtfile.writeline "<DIV><A href=""docid:"&dokID&""">Zum Dokument </A></DIV>"
                Else
                	txtfile.writeline "<DIV><A href=""gdocid:"&dokID&""">Zum Dokument </A></DIV>"
                End if
            End If
        End If
    End If
    txtfile.writeline "<DIV>&nbsp;</DIV>"
    txtfile.writeline "<DIV>&nbsp;</DIV>"
    txtfile.writeline "<DIV>&nbsp;</DIV>"
    txtfile.writeline "<DIV><FONT id="""" color=#ff0000></FONT>&nbsp;</DIV>"
    
    txtfile.WriteLine workflowabgesang1
    txtfile.WriteLine workflowabgesang2
    txtfile.WriteLine "</BODY></HTML>"
    
    
    'txtfile.writeline "<DIV><EM>bitfarm-<FONT color=#ff0000>ARCHIV</FONT> Dokumentenmanagement</EM> </DIV>"
    'txtfile.writeline "<DIV><FONT id=""""><EM>Hilfe und Untersttzung: 0271 / 31396 - 0</EM></FONT></DIV></BODY></HTML>"
    
    txtfile.close
    Set txtfile=Nothing
    
    WScript.Sleep 200
    
    
    
    Set oExec    = objWSHShell.Exec(mailto)
    
    Do While Not oExec.StdOut.AtEndOfStream
        strinput = strinput & oExec.StdOut.Read(1)	
    Loop
    
    durch = False
    schleife = 0
    Do While schleife < 50
        If oExec.Status = 1 Then 
            durch = True
            Exit Do
        End If
        
        WScript.Sleep 100  
        schleife = schleife +1
    Loop
    
    
    
    
    If oExec.ExitCode <> 0 Or schleife>=50  Then
        objWSHShell.LogEvent 1, "sendlinkmail.vbs: Fehler bei Mailversand" & vbCrLf & strinput
        
    End If
    
    WScript.Sleep 200
    
    
    
    
    Err.clear
    If cleanup=True Then
	    If fs.fileexists(mailto) Then
	        fs.DeleteFile mailto, True
	        If Err.number <> 0 Then
	            Err.clear
	            objWshShell.LogEvent 1, "workflow: kann mailto.bat nicht erneuern." & vbCrLf & mailto
	            WScript.Quit(1)
	        End If
	    End If
	    
	    If fs.fileexists(mailtotxt) Then
	        fs.DeleteFile mailtotxt, True
	        If Err.number <> 0 Then
	            Err.clear
	            objWshShell.LogEvent 1, "workflow: kann nachricht.txt nicht erneuern." & vbCrLf & mailtotxt
	            WScript.Quit(1)
	        End If
	    End If 
	End If
	    
End Function



Function readconfig(profil)
    On Error Resume Next
    
    readconfig=True
    Err.clear
    
    If Not fs.FileExists(programm&profil&".con") Then
        Err.clear
        errortxt=profil&".con Datei nicht im Scriptpfad vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        readconfig=False
        Err.clear
    End If
    
    If readconfig=True Then	
        Set confile = fs.OpenTextFile(programm&profil&".con",1)
        If Err.number Then
            Err.clear
            errortxt="Profilfdatei nicht im Scriptpfad vorhanden oder nicht lesbar."
            objWshShell.LogEvent 1, errortxt
            Err.clear
            readconfig=False
            
        End If 
    End If
    
    If readconfig=True Then	
        kette=confile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        Do While Scriptsflag = 0
            kette=confile.readline
            Scriptsflag=InStr(1,kette,"[Scripts]")
            If confile.AtEndOfStream = True Then
                confile.close
                Set confile=Nothing
                scriptsflag=1
                errortxt="Fehler beim Lesen der CON-Datei - falsche Formatierung."
                objWshShell.LogEvent 1, errortxt
                readconfig = False
                
            End If
        Loop
        
    End If
    
    
    If readconfig = True Then
        
        Do While confile.AtEndOfStream <> True
            kette=confile.readline
            If Left(kette,1)<>";" Then
                
                
                If InStr(1,kette,"smtpserver",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"smtpserver",1)+10)
                    smtpserver = wert
                End If
                
                If InStr(1,kette,"authuser",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"authuser",1)+8)
                    authuser = wert
                End If
                
                If InStr(1,kette,"authpass",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"authpass",1)+8)
                    authpass = wert
                End If
                
                
                
                If InStr(1,kette,"sendername",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"sendername",1)+10)
                    sendername = wert
                End If
                
                
                If InStr(1,kette,"adminmail",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"adminmail",1)+9)
                    adminmail = wert
                End If

                If InStr(1,kette,"bfa_server_smtp",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"bfa_server_smtp",1)+15)
                    if lcase(wert)="true" Then
                        bfa_server_smtp = True
                    End If
                End If
                
                
                
                
            End If
            
        Loop
        confile.close
        Set confile = Nothing
        
    End If
    
    
End Function

Function inilesen()
    On Error Resume Next
    
    Err.clear
    Set inifile = fs.OpenTextFile(programm&"scripts.ini",1)
    If Err.number Then
        objWshShell.LogEvent 1, "scripts.ini nicht im Scriptpfad vorhanden oder nicht lesbar."
        Err.clear
        WScript.Quit(1)
    End If 
    
    kette=inifile.readline
    Scriptsflag=InStr(1,kette,"[Scripts]")
    Do While Scriptsflag = 0
        kette=inifile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        If inifile.AtEndOfStream = True Then
            inifile.close
            objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - falsche Formatierung."
            WScript.Quit(1)
        End If
    Loop
    
    
    Do While inifile.AtEndOfStream <> True
        kette=inifile.readline
        If Left(kette,1)<>";" Then
            
            
            If InStr(1,kette,"Profil",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"Profil",1)+7)
                If profil="" Then
                    profil = wert
                End If
            End If
            
            If InStr(1,kette,"workflowabgesang1=",1)<>0 Then
                wert=Right(kette,Len(kette)-(InStr(1,kette,"workflowabgesang1=",1)+17))
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    workflowabgesang1 = wert
                End If
            End If
            
            If InStr(1,kette,"workflowabgesang2=",1)<>0 Then
                wert=Right(kette,Len(kette)-(InStr(1,kette,"workflowabgesang2=",1)+17))
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    workflowabgesang2 = wert
                End If
            End If				
            
        End If
        
    Loop
    inifile.close
    Set inifile = Nothing
    If programm="" Then
        objWshShell.LogEvent 2, "Fehler beim Lesen der scripts.ini - kein Programmpfad."
        WScript.Quit(1)
    End If
    
    
End Function


Private Function GetString(kette,pos)
    On Error Resume Next
    
    zeichen=""
    ergebnis=""
    index=0
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (zeichen<>"	") And (index<80)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,pos+index,1)
        index=index+1
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=")) And (ergebnis="") Then
            zeichen=""
        End If
    Loop
    Trim(ergebnis)
    GetString=ergebnis
End Function
