'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'***************  verteiler.vbs        *****************************************************
'*******************************************************************************************
'***************  Version 3.6.2.2  GPL *****************************************************
'*******************************************************************************************
'***************  Programm zur Kontrolle des Server-Verzeichnisses           ***************
'***************  auf neue Dateien von den Clients                           ***************
'***************  (postscripttreiber, redrun, clientspooler.vbs,             ***************
'***************  scantoarchiv.vbs)                                          ***************
'***************                                                             ***************
'***************  Bei neuen Dateien werden diese an das script               ***************
'***************  Archivspooler.vbs bergeben.                               ***************
'***************                                                             ***************
'***************  wird auf dem Server durch die Controler.vbs programmatisch ***************
'***************  gestartet und berwacht (ber Prozess-ID des Mutterpro-    ***************
'***************  zesses verteiler.bat, also CMD.EXE)                        ***************
'***************  ----------------------                                     ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************

scriptdebug=False

looptime = 1000

'*******************************************************************************************
'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

Set objWshShell = WScript.CreateObject("WScript.Shell")
Set fs = CreateObject("Scripting.FileSystemObject")
Set oArgs    = WScript.Arguments 

ReDim ext(60)
extension = ""
loopcounter=0

stempel = Timer

On Error Resume Next

'*******************************************************************************************
'*******************************************************************************************

For i=0 To 59
    ext(i)="...."
Next

extcounter=0

acceptdoc=False
acceptxls=False
acceptdwg=False
acceptppt=False
acceptallfiletypes=False
MSOffice2007installed=True

importpath=""
importpath2=""
spoolplugin=""
autoexportpath=""
loopcounter2=0
delayedscannerimport=False
delay=30
Datei=""
Dateiname=""
fehlertext=""
archmsg=False

fullpath = WScript.ScriptFullName
scriptname = WScript.ScriptName
mypath = Left(fullpath,Len(fullpath)-Len(scriptname))

If mypath = "" Then
    objWshShell.LogEvent 1, "bitfarm-archiv: Verteiler: Kein Pfad aufgelst"
    WScript.Quit
End If 
Err.clear
programm = mypath
clientspooler=""
Profil=""
Profil = oArgs.item(0) 
If Err.number<>0 Then
    Err.clear
    objWshShell.LogEvent 1, "bitfarm-Archiv: Verteiler: Fehlender Parameter: Profil."
    Err.clear
    WScript.Quit
End If 

If (Profil="") Or (Profil=" ") Or (Profil="	") Then
    objWshShell.LogEvent 1, "bitfarm-Archiv: Verteiler: Fehlender Parameter: Profil."
    WScript.Quit
End If


erfolg=readconfig(Profil)
If erfolg=False Then
    objWshShell.LogEvent 1, "bitfarm-archiv: Verteiler: Konnte Profil nicht lesen."
    WScript.Quit
End If

verzeichnis = Trim(clientspooler)

If Not fs.FolderExists(verzeichnis) Then 
    objWshShell.LogEvent 1, "bitfarm-archiv: Verteiler: Verzeichnis nicht vorhanden." & vbCrLf & verzeichnis
    WScript.Quit
End If


inilesen

ext(0)=".tif"
ext(1)=".ps"
ext(2)=".pdf"
ext(3)=".bmp"
ext(4)=".jpg"
ext(5)=".gif"
ext(6)=".eml"
ext(7)=".pcl"
ext(8)=".msg"

extcounter=9

If acceptdoc=True Then
    ext(extcounter)=".doc"
    ext(extcounter+1)=".rtf"
    ext(extcounter+2)=".htm"
    ext(extcounter+3)=".txt"
    
    extcounter=extcounter+4
End If

If acceptxls=True Then
    ext(extcounter)=".xls"
    ext(extcounter+1)=".dbf"
    ext(extcounter+2)=".tab"
    extcounter=extcounter+3
End If

If acceptppt=True Then
    ext(extcounter)=".ppt"
    ext(extcounter+1)=".pps"
    extcounter=extcounter+2
End If

If acceptdwg=True Then
    ext(extcounter)=".dwg"
    ext(extcounter+1)=".dxf"
    extcounter=extcounter+2
End If

If MSOffice2007installed=True Then
    ext(extcounter)=".docx"
    ext(extcounter+1)=".docm"
    ext(extcounter+2)=".dotx"
    ext(extcounter+3)=".dotm"
    ext(extcounter+4)=".xlsx"
    ext(extcounter+5)=".xlsm"
    ext(extcounter+6)=".xltx"
    ext(extcounter+7)=".xltm"
    extcounter=extcounter+8
    
End If



'************************************** Endlos - Hauptschleife ********************************


moverevent=False
spoolevent=False
XMLevent=False
folderevent=False
wfevent=False

a = 0
Do While a = 0
    loopcounter = loopcounter + 1
    movecounter=0
    Err.clear
    On Error Resume Next
    Set folder = fs.GetFolder(verzeichnis)
    For Each datei In folder.files
        zeit = 0
        Uhrzeit = Now() 
        If scriptdebug=True Then      
        	objwshshell.LogEvent 0, "verteiler.vbs: Neue Datei in " & verzeichnis & vbCrLf & datei & vbCrLf & "Jetzt: " & Uhrzeit & vbCrLf & "Dateigre: " &Datei.Size& vbCrLf & "Last modified: " & Datei.DateLastModified
        End If
        If LCase(Right(datei,4))=".var" Then
            Err.clear
            On Error Resume Next
            fs.deletefile datei, True
            Err.clear
            On Error Resume Next
        End If
        
        If LCase(fs.GetExtensionName(datei))="jpeg" Then
            jpgname = Left(datei,Len(datei)-4) & "jpg"
            fs.movefile datei , jpgname
            WScript.Sleep 50
            datei = fs.GetFile(jpgname)
        End If
        
        If LCase(fs.GetExtensionName(datei))="tiff" Then
            tifname = Left(datei,Len(datei)-4) & "tif"
            fs.movefile datei , tifname
            WScript.Sleep 50
            datei = fs.GetFile(tifname)
        End If
        
        
        If fs.FileExists(datei) Then
            dateiname=Datei.Path
            w=0
            abbruch=False
            extension=""
            
            If fs.GetExtensionName(datei)<>"" Then
                extension = "." & fs.GetExtensionName(datei)
                extension=LCase(extension)
            End If
            
            If Right(datei,9)="dummy.txt" Then
                fs.deletefile datei, True
            End If
            
            If archmsg=False And extension = ".msg" Then
                ' auf doc warten
                keepwaiting=True
                wrounds=0
                
                While keepwaiting=True
                    
                    If (fs.FileExists(Replace(datei,extension,".doc")) Or fs.FileExists(Replace(datei,extension,".docx")) Or fs.FileExists(Replace(datei,extension,".htm"))) Then
                        keepwaiting=False
                    End If
                    
                    If wrounds>30 Then
                        keepwaiting=False
                    End If
                    
                    wrounds = wrounds+1
                    WScript.Sleep 100
                    
                Wend
            End If
            
            Err.clear
            On Error Resume Next
            
            thisqueue = True
            If thisqueue = True Then
                If acceptallfiletypes=True Then
                    If (extension<>".var") And (extension<>".job") And (extension<>".wfend") And (extension<>".wfend_active")  And (extension<>".iev") And (extension<>".kom") And (extension<>".bfa") And (extension<>".move") And (extension<>".movx") And (extension<>".ftx") And (extension<>".vtx") And (extension<>".slw") And (extension<>".swd") Then
                        If (((extension<>".msg") Or (InStr(1,datei,"msgfile",1)=0)) And ((extension<>".msg") Or (InStr(1,datei,"msgfast",1)=0))) Or (extension=".msg" And Not (fs.FileExists(Replace(datei,extension,".doc")) Or fs.FileExists(Replace(datei,extension,".docx")))) Then
                            
                            If spoolevent=True Then
                                WScript.sleep 2000
                            End If
                            runplugin(spoolplugin)
                            
                            If fs.fileexists(datei) Then
                                
                                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"archivspooler.bat"&Chr(34)&" """&datei&""" "&Profil,0,True)
                                
                            End If
                            If Err.Number Then
                                objWshShell.LogEvent 1,"bitfarm-Archiv: Verteiler.vbs:  Fehler bei bergabe an archivspooler.vbs(1)." & vbCrLf & Datei &vbCrLf& Err.number &vbCrLf& Err.description&vbCrLf&stempel
                                Err.clear
                            End If
                            spoolevent=True
                        End If
                    End If
                Else
                    t=0
                    Do While t<=extcounter

                        If extension=ext(t) Then
                            
                            If spoolevent=True Then
                                WScript.sleep 2000
                            End If
                            runplugin(spoolplugin)
                            If fs.fileexists(datei) Then
                                
                                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"archivspooler.bat"&Chr(34)&" """&datei&""" "&Profil,0,True)
                                
                            End If
                            If Err.Number Then
                                objWshShell.LogEvent 1,"bitfarm-Archiv: Verteiler.vbs:  Fehler bei bergabe an archivspooler.vbs.(2)" & vbCrLf & Datei &vbCrLf& Err.number &vbCrLf& Err.description&vbCrLf&stempel
                                Err.clear
                            End If
                            spoolevent=True
                            
                            t=10000
                        End If
                        t=t+1
                    Loop
                End If	
                
            End If
            
              
            lockdatei=programm&"temp\movelock"
            
            If fs.fileexists(lockdatei) = False Then
                
                If LCase(extension) = ".move" Or LCase(extension) = ".movx" Then
                    If moverevent=True Then
                        WScript.sleep 2000
                    End If
                    If scriptdebug=True Then
                        objWshShell.LogEvent 4, "verteiler.vbs (1) Movelock nicht vorhanden, starte mover.vbs"
                        
                    End If
                    Err.clear
                    On Error Resume Next
                    runplugin(spoolplugin)
                    If fs.fileexists(datei) Then
                        
                        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"mover.bat"&Chr(34)&" "&Chr(34)&datei&Chr(34),0,True)
                        
                    End If
                    If Err.Number Then
                        Err.clear
                        objWshShell.LogEvent 1, "bitfarm-Archiv: Verteiler: Fehler bei Aufruf des Archiv-Movers." & vbCrLf & Chr(34)&programm&"mover.bat"&Chr(34)&" "&Chr(34)&datei&Chr(34)
                    End If
                    
                    moverevent=True
                    movecounter=movecounter+1
                End If
                
                
                If LCase(extension) = ".kom" Then
                    If moverevent=True Then
                        WScript.sleep 3000
                    End If
                    runplugin(spoolplugin)
                    If fs.fileexists(datei) Then
                        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"mover.bat"&Chr(34)&" "&Chr(34)&datei&Chr(34),0,True)
                    End If
                    If Err.Number Then
                        Err.clear
                        objWshShell.LogEvent 1, "bitfarm-Archiv: Verteiler: Fehler bei Aufruf des Archiv-Movers."
                    End If
                    moverevent=True
                    movecounter=movecounter+1
                    
                End If
            End If
            
            If (LCase(extension) = ".fend") Or (LCase(extension) = ".wfend") Then
                If wfevent=True Then
                    WScript.sleep 2000
                End If
                runplugin(spoolplugin)
                If fs.fileexists(datei) Then
                	Dateiname = Datei.path
                	fs.MoveFile Datei, Datei&"_active"
                    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"workflow.bat"&Chr(34)&" "&Chr(34)&Dateiname&"_active"&Chr(34)&" 0 1 "&profil&" 1 1",0,True)
                End If
                If Err.Number Then
                    
                    objWshShell.LogEvent 1, "bitfarm-Archiv: Verteiler: Fehler bei Aufruf des Workflow-Scriptes." & vbCrLf & cmd & vbCrLf & err.number & vbCrLf & err.Description
                    Err.clear
                End If
                wfevent=True
            End If
            
        End If
        
        
    Next
    
    
    Set folder=Nothing
    WScript.sleep 50
    
    '****************************** Netzwerkscanner Import **********************************
    On Error Resume Next
    Err.clear
    If importpath<>"" Then
        If fs.folderexists(importpath) Then 
            Set folder = fs.GetFolder(importpath)
            Err.clear
            On Error Resume Next
            If scriptdebug = True Then
		    	objwshshell.LogEvent 4, "verteiler.vbs debug: Prfe Verzeichnis " & folder.Name & " auf neue Dateien."
		    End If
            For Each datei In folder.Files
                Uhrzeit = Now()
                If scriptdebug=True Then
                	objwshshell.LogEvent 0, "verteiler.vbs: Neue Datei in " & importpath & vbCrLf & datei & vbCrLf & "Jetzt: " & Uhrzeit & vbCrLf & "Dateigre: " &Datei.Size& vbCrLf & "Last modified: " & Datei.DateLastModified
                End If
                
                If LCase(Right(datei,4))=".var" Then
                    Err.clear
                    On Error Resume Next
                    fs.deletefile datei, True
                    Err.clear
                    On Error Resume Next
                End If
                
                If LCase(fs.GetExtensionName(datei))="jpeg" Then
                    jpgname = Left(datei,Len(datei)-4) & "jpg"
                    fs.movefile datei , jpgname
                    WScript.Sleep 100
                    datei = fs.GetFile(jpgname)
                End If
                
                If LCase(fs.GetExtensionName(datei))="tiff" Then
                    tifname = Left(datei,Len(datei)-4) & "tif"
                    fs.movefile datei , tifname
                    WScript.Sleep 50
                    datei = fs.GetFile(tifname)
                End If
                
                Err.clear
                On Error Resume Next
                zeit = 0
                If fs.FileExists(datei) Then
                    dateiname=Datei.Path
                    If fs.GetExtensionName(datei)<>"" Then
                        extension = "." & fs.GetExtensionName(datei)
                        extension=LCase(extension)
                    End If
                    
                    '############# delayedscannerimport Auswertung ###########################
					filetooyoung = False
                    if (extension<>".var") And (extension<>".job") And (extension<>".iev") And (extension<>".wfend") And (extension<>".wfend_active") And (extension<>".kom") And (extension<>".bfa") And (extension<>".move") And (extension<>".movx") And (extension<>".ftx") And (extension<>".vtx") And (extension<>".slw") And (extension<>".swd") Then
                		If delayedscannerimport = True Then
            	        	If CheckCreated(datei)<delay Then
            	        		filetooyoung = True
            	        	End If
            	       	End If
            	    End If
                    
                    if filetooyoung = False Then
						thisqueue = True
						If thisqueue = True Then
							If acceptallfiletypes=True Then
								If (extension<>".var") And (extension<>".job") And (extension<>".wfend") And (extension<>".wfend_active") And (extension<>".iev") And (extension<>".kom") And (extension<>".bfa") And (extension<>".move") And (extension<>".movx") And (extension<>".ftx") And (extension<>".vtx") And (extension<>".slw") And (extension<>".swd") Then
									If (((extension<>".msg") Or (InStr(1,datei,"msgfile",1)=0)) And ((extension<>".msg") Or (InStr(1,datei,"msgfast",1)=0))) Or (extension=".msg" And Not (fs.FileExists(Replace(datei,extension,".doc")) Or fs.FileExists(Replace(datei,extension,".docx")))) Then
										If delayedscannerimport = True Then
											If CheckCreated(datei)>delay Then
												If spoolevent=True Then
													WScript.sleep 2000
												End If
												runplugin(spoolplugin)
												If fs.fileexists(datei) Then
													
													lngReturnCode = objWSHShell.Run(Chr(34)&programm&"archivspooler.bat"&Chr(34)&" """&datei&""" "&Profil,0,True)
													
												End If
												
												If Err.Number Then
													objWshShell.LogEvent 1,"bitfarm-Archiv: Verteiler.vbs:  Fehler bei bergabe an archivspooler.vbs.(3)" & vbCrLf & Datei &vbCrLf& Err.number &vbCrLf& Err.description&vbCrLf&stempel
													Err.clear
													On Error Resume Next
												End If
												spoolevent=True
											Else
												WScript.Sleep 2000
												
											End If
										Else
											If spoolevent=True Then
												WScript.sleep 2000
											End If
											runplugin(spoolplugin)
											If fs.fileexists(datei) Then
												
												lngReturnCode = objWSHShell.Run(Chr(34)&programm&"archivspooler.bat"&Chr(34)&" """&datei&""" "&Profil,0,True)
												
											End If
											
											If Err.Number Then
												objWshShell.LogEvent 1,"bitfarm-Archiv: Verteiler.vbs:  Fehler bei bergabe an archivspooler.vbs.(3)" & vbCrLf & Datei &vbCrLf& Err.number &vbCrLf& Err.description&vbCrLf&stempel
												Err.clear
												On Error Resume Next
											End If
											spoolevent=True
										End If
									End If
								End If
							Else
								
								t=0
								Do While t<=extcounter
									
									If extension=ext(t) Then
										If delayedscannerimport = True Then
											If CheckCreated(datei)>delay Then
												If spoolevent=True Then
													WScript.sleep 2000
												End If
												runplugin(spoolplugin)
												If fs.fileexists(datei) Then
													
													lngReturnCode = objWSHShell.Run(Chr(34)&programm&"archivspooler.bat"&Chr(34)&" """&datei&""" "&Profil,0,True)
													
												End If
												
												If Err.Number Then
													objWshShell.LogEvent 1,"bitfarm-Archiv: Verteiler.vbs:  Fehler bei bergabe an archivspooler.vbs.(3)" & vbCrLf & Datei &vbCrLf& Err.number &vbCrLf& Err.description&vbCrLf&stempel
													Err.clear
												End If
												spoolevent=True
											Else
												WScript.Sleep 2000
											End If
											t=10000
										Else
											
											
											If spoolevent=True Then
												WScript.sleep 2000
											End If
											runplugin(spoolplugin)
											If fs.fileexists(datei) Then
												
												lngReturnCode = objWSHShell.Run(Chr(34)&programm&"archivspooler.bat"&Chr(34)&" """&datei&""" "&Profil,0,True)
												
											End If
											
											If Err.Number Then
												objWshShell.LogEvent 1,"bitfarm-Archiv: Verteiler.vbs:  Fehler bei bergabe an archivspooler.vbs.(4)" & vbCrLf & Datei &vbCrLf& Err.number &vbCrLf& Err.description&vbCrLf&stempel
												Err.clear
											End If
											spoolevent=True
											t=10000
										End If
									End If
									t=t+1
									
								Loop
								If t<10000 Then
									On Error Resume Next
									fs.deletefile datei, True
									If Err.Number Then
										Err.clear
									End If
									objWshShell.LogEvent 2, "bitfarm-Archiv: Verteiler: Nicht untersttzten Dateityp aus Scannerimportpfad gelscht:"&Datei
								End If	
							End If
						End If
					End If
                End If
            Next
            
            For Each unterordner In folder.subfolders
                Err.clear
                On Error Resume Next
                For Each datei In unterordner.files
                    Err.clear
                    On Error Resume Next
                    zeit = 0
                    If fs.FileExists(datei) Then
                        
                        If LCase(Right(datei,4))=".var" Then
                            Err.clear
                            On Error Resume Next
                            fs.deletefile datei, True
                            Err.clear
                            On Error Resume Next
                        End If
                        
                        If LCase(fs.GetExtensionName(datei))="jpeg" Then
                            jpgname = Left(datei,Len(datei)-4) & "jpg"
                            fs.movefile datei , jpgname
                            WScript.Sleep 100
                            datei = fs.GetFile(jpgname)
                        End If
                        
                        dateiname=Datei.Path
                        If fs.GetExtensionName(datei)<>"" Then
                            extension = "." & fs.GetExtensionName(datei)
                            extension=LCase(extension)
                        End If
                        
						'############# delayedscannerimport Auswertung ###########################
						filetooyoung = False
						if (extension<>".var") And (extension<>".job") And (extension<>".iev") And (extension<>".wfend") And (extension<>".wfend_active") And (extension<>".kom") And (extension<>".bfa") And (extension<>".move") And (extension<>".movx") And (extension<>".ftx") And (extension<>".vtx") And (extension<>".slw") And (extension<>".swd") Then
							If delayedscannerimport = True Then
								If CheckCreated(datei)<delay Then
									filetooyoung = True
								End If
							End If
						End If
						
                        If filetooyoung = False Then
							thisqueue = True             
							If thisqueue = True Then
								If acceptallfiletypes=True Then
									If (extension<>".var") And (extension<>".job") And (extension<>".wfend") And (extension<>".wfend_active") And (extension<>".iev") And (extension<>".kom") And (extension<>".bfa") And (extension<>".move") And (extension<>".movx") And (extension<>".ftx") And (extension<>".vtx") And (extension<>".slw") And (extension<>".swd") Then
										If (((extension<>".msg") Or (InStr(1,datei,"msgfile",1)=0)) And ((extension<>".msg") Or (InStr(1,datei,"msgfast",1)=0))) Or (extension=".msg" And Not (fs.FileExists(Replace(datei,extension,".doc")) Or fs.FileExists(Replace(datei,extension,".docx")))) Then
											
											If delayedscannerimport = True Then
												If CheckCreated(datei)>delay Then
													If spoolevent=True Then
														WScript.sleep 2000
													End If
													runplugin(spoolplugin)
													If fs.fileexists(datei) Then
														
														lngReturnCode = objWSHShell.Run(Chr(34)&programm&"archivspooler.bat"&Chr(34)&" """&datei&""" "&Profil,0,True)
														
													End If
													
													If Err.Number Then
														objWshShell.LogEvent 1,"bitfarm-Archiv: Verteiler.vbs:  Fehler bei bergabe an archivspooler.vbs.(3)" & vbCrLf & Datei &vbCrLf& Err.number &vbCrLf& Err.description&vbCrLf&stempel
														Err.clear
														On Error Resume Next
													End If
													spoolevent=True
												Else
													WScript.Sleep 2000
													
												End If
											Else
												
												If spoolevent=True Then
													WScript.sleep 2000
												End If
												runplugin(spoolplugin)
												If fs.fileexists(datei) Then
													
													lngReturnCode = objWSHShell.Run(Chr(34)&programm&"archivspooler.bat"&Chr(34)&" """&datei&""" "&Profil,0,True)
													
												End If
												If Err.Number Then
													objWshShell.LogEvent 1,"bitfarm-Archiv: Verteiler.vbs:  Fehler bei bergabe an archivspooler.vbs.(5)" & vbCrLf & Datei &vbCrLf& Err.number &vbCrLf& Err.description&vbCrLf&stempel
													Err.clear
												End If
												spoolevent=True
												
											End If
										End If
									End If
								Else
									
									t=0
									Do While t<=extcounter
										
										If extension=ext(t) Then
											
											If delayedscannerimport = True Then
												If CheckCreated(datei)>delay Then
													If spoolevent=True Then
														WScript.sleep 2000
													End If
													runplugin(spoolplugin)
													If fs.fileexists(datei) Then
														
														lngReturnCode = objWSHShell.Run(Chr(34)&programm&"archivspooler.bat"&Chr(34)&" """&datei&""" "&Profil,0,True)
														
													End If
													
													If Err.Number Then
														objWshShell.LogEvent 1,"bitfarm-Archiv: Verteiler.vbs:  Fehler bei bergabe an archivspooler.vbs.(3)" & vbCrLf & Datei &vbCrLf& Err.number &vbCrLf& Err.description&vbCrLf&stempel
														Err.clear
													End If
													spoolevent=True
												Else
													WScript.Sleep 2000
												End If
												t=10000
												
											Else
												
												If spoolevent=True Then
													WScript.sleep 2000
												End If
												runplugin(spoolplugin)
												If fs.fileexists(datei) Then
													
													lngReturnCode = objWSHShell.Run(Chr(34)&programm&"archivspooler.bat"&Chr(34)&" """&datei&""" "&Profil,0,True)
													
												End If
												If Err.Number Then
													objWshShell.LogEvent 1,"bitfarm-Archiv: Verteiler.vbs:  Fehler bei bergabe an archivspooler.vbs.(6)" & vbCrLf & Datei &vbCrLf& Err.number &vbCrLf& Err.description&vbCrLf&stempel
													Err.clear
												End If
												spoolevent=True
												t=10000
												
											End If 
											
										End If
										t=t+1
									Loop
									If t<10000 Then
										On Error Resume Next
										fs.deletefile datei,True
										If Err.Number Then
											Err.clear
											On Error Resume Next
										End If
										objWshShell.LogEvent 2, "bitfarm-Archiv: Verteiler: Nicht untersttzten Dateityp aus Scannerimportpfad gelscht:"&Datei
									End If
								End If	
							End If
						End If
                    End If
                Next
            Next
            Set unterordner=Nothing
            Set folder = Nothing
            WScript.Sleep 30
            
            
        End If
    End If
    
    
    
    '****************************** Extended Import **********************************
    On Error Resume Next
    Err.clear
    
    If importpath2<>"" Then
        If fs.folderexists(importpath2) Then 
            Set folder = fs.GetFolder(importpath2)
            Err.Clear
            If scriptdebug = True Then
		    	objwshshell.LogEvent 4, "verteiler.vbs debug: Prfe Verzeichnis " & folder.Name & " auf neue Dateien."
		    End If
            On Error Resume Next
            For Each datei In folder.Files
                Uhrzeit = Now()
                If scriptdebug=True Then
                	objwshshell.LogEvent 0, "verteiler.vbs: Neue Datei in " & importpath2 & vbCrLf & datei & vbCrLf & "Jetzt: " & Uhrzeit & vbCrLf & "Dateigre: " &Datei.Size& vbCrLf & "Last modified: " & Datei.DateLastModified
                End If
                If LCase(Right(datei,4))=".var" Then
                    Err.clear
                    On Error Resume Next
                    fs.deletefile datei, True
                    Err.clear
                    On Error Resume Next
                End If
                
                
                If LCase(fs.GetExtensionName(datei))="jpeg" Then
                    jpgname = Left(datei,Len(datei)-4) & "jpg"
                    fs.movefile datei , jpgname
                    WScript.Sleep 100
                    datei = fs.GetFile(jpgname)
                End If
                
                If LCase(fs.GetExtensionName(datei))="tiff" Then
                    tifname = Left(datei,Len(datei)-4) & "tif"
                    fs.movefile datei , tifname
                    WScript.Sleep 50
                    datei = fs.GetFile(tifname)
                End If
                
                dateiname=Datei.Path
                Err.clear
                On Error Resume Next
                zeit = 0
                If fs.FileExists(datei) Then
                    If fs.GetExtensionName(datei)<>"" Then
                        extension = "." & fs.GetExtensionName(datei)
                        extension=LCase(extension)
                    End If
                    
                    If acceptallfiletypes=False Then
                        
                        t=0
                        Do While t<=extcounter
                            
                            If extension=ext(t) Then
                                If delayedscannerimport = True Then
                                    If CheckCreated(datei)>delay Then
                                        If spoolevent=True Then
                                            WScript.sleep 2000
                                        End If
                                        runplugin(spoolplugin)
                                        If fs.fileexists(datei) Then
                                            
                                            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"archivspooler.bat"&Chr(34)&" """&datei&""" "&Profil,0,True)
                                            
                                        End If
                                        
                                        If Err.Number Then
                                            objWshShell.LogEvent 1,"bitfarm-Archiv: Verteiler.vbs:  Fehler bei bergabe an archivspooler.vbs.(3)" & vbCrLf & Datei &vbCrLf& Err.number &vbCrLf& Err.description&vbCrLf&stempel
                                            Err.clear
                                            On Error Resume Next
                                        End If
                                        spoolevent=True
                                    Else
                                        WScript.Sleep 2000
                                        
                                    End If
                                Else
                                    If spoolevent=True Then
                                        WScript.sleep 2000
                                    End If
                                    runplugin(spoolplugin)
                                    If fs.fileexists(datei) Then
                                        
                                        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"archivspooler.bat"&Chr(34)&" """&datei&""" "&Profil,0,True)
                                        
                                    End If
                                    
                                    If Err.Number Then
                                        objWshShell.LogEvent 1,"bitfarm-Archiv: Verteiler.vbs:  Fehler bei bergabe an archivspooler.vbs.(7)" & vbCrLf & Datei &vbCrLf& Err.number &vbCrLf& Err.description&vbCrLf&stempel
                                        Err.clear
                                        On Error Resume Next
                                    End If
                                    spoolevent=True
                                    t=10000
                                End If
                            End If
                            t=t+1
                        Loop
                        If t<10000 Then
                            On Error Resume Next
                            fs.deletefile datei, True
                            If Err.Number Then
                                Err.clear
                            End If
                            objWshShell.LogEvent 2, "bitfarm-Archiv: Verteiler: Nicht untersttzten Dateityp aus Scannerimportpfad gelscht:"&Datei
                        End If
                        
                    Else
                        If delayedscannerimport = True Then
                            If CheckCreated(datei)>delay Then
                                If spoolevent=True Then
                                    WScript.sleep 2000
                                End If
                                runplugin(spoolplugin)
                                If fs.fileexists(datei) Then
                                    
                                    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"archivspooler.bat"&Chr(34)&" """&datei&""" "&Profil,0,True)
                                    
                                End If
                                
                                If Err.Number Then
                                    objWshShell.LogEvent 1,"bitfarm-Archiv: Verteiler.vbs:  Fehler bei bergabe an archivspooler.vbs.(7)" & vbCrLf & Datei &vbCrLf& Err.number &vbCrLf& Err.description&vbCrLf&stempel
                                    Err.clear
                                    On Error Resume Next
                                End If
                                spoolevent=True
                            Else
                                WScript.Sleep 2000
                                
                            End If
                        Else
                            If spoolevent=True Then
                                WScript.sleep 2000
                            End If
                            runplugin(spoolplugin)
                            If fs.fileexists(datei) Then
                                
                                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"archivspooler.bat"&Chr(34)&" """&datei&""" "&Profil,0,True)
                                
                            End If
                            
                            If Err.Number Then
                                objWshShell.LogEvent 1,"bitfarm-Archiv: Verteiler.vbs:  Fehler bei bergabe an archivspooler.vbs.(8)" & vbCrLf & Datei &vbCrLf& Err.number &vbCrLf& Err.description&vbCrLf&stempel
                                Err.clear
                            End If
                            spoolevent=True
                        End If
                        
                    End If
                End If
            Next
            
            For Each unterordner In folder.subfolders
                Err.clear
                On Error Resume Next
                For Each datei In unterordner.files
                    Uhrzeit = Now()
                    If scriptdebug=True Then
                    	objwshshell.LogEvent 0, "verteiler.vbs: Neue Datei in " & unterordner & vbCrLf & datei & vbCrLf & "Jetzt: " & Uhrzeit & vbCrLf & "Dateigre: " &Datei.Size& vbCrLf & "Last modified: " & Datei.DateLastModified
                    End If
                    If LCase(Right(datei,4))=".var" Then
                        Err.clear
                        On Error Resume Next
                        fs.deletefile datei, True
                        Err.clear
                        On Error Resume Next
                    End If
                    
                    If LCase(fs.GetExtensionName(datei))="jpeg" Then
                        jpgname = Left(datei,Len(datei)-4) & "jpg"
                        fs.movefile datei , jpgname
                        WScript.Sleep 100
                        datei = fs.GetFile(jpgname)
                    End If
                    
                    If LCase(fs.GetExtensionName(datei))="tiff" Then
                        tifname = Left(datei,Len(datei)-4) & "tif"
                        fs.movefile datei , tifname
                        WScript.Sleep 50
                        datei = fs.GetFile(tifname)
                    End If
                    
                    dateiname=Datei.Path
                    Err.clear
                    On Error Resume Next
                    zeit = 0
                    If fs.FileExists(datei) Then
                        If fs.GetExtensionName(datei)<>"" Then
                            extension = "." & fs.GetExtensionName(datei)
                            extension=LCase(extension)
                        End If	
						
                        '############# delayedscannerimport Auswertung ###########################
						filetooyoung = False
						if (extension<>".var") And (extension<>".job") And (extension<>".iev") And (extension<>".wfend") And (extension<>".wfend_active") And (extension<>".kom") And (extension<>".bfa") And (extension<>".move") And (extension<>".movx") And (extension<>".ftx") And (extension<>".vtx") And (extension<>".slw") And (extension<>".swd") Then
							If delayedscannerimport = True Then
								If CheckCreated(datei)<delay Then
									filetooyoung = True
								End If
							End If
						End If
                        If filetooyoung=False Then
							If acceptallfiletypes=True Then
								If (extension<>".var") And (extension<>".job") And (extension<>".wfend") And (extension<>".wfend_active") And (extension<>".iev") And (extension<>".kom") And (extension<>".bfa") And (extension<>".move") And (extension<>".movx") And (extension<>".ftx") And (extension<>".vtx") And (extension<>".slw") And (extension<>".swd") Then
									If (((extension<>".msg") Or (InStr(1,datei,"msgfile",1)=0)) And ((extension<>".msg") Or (InStr(1,datei,"msgfast",1)=0))) Or (extension=".msg" And Not (fs.FileExists(Replace(datei,extension,".doc")) Or fs.FileExists(Replace(datei,extension,".docx")))) Then
										If delayedscannerimport = True Then
											If CheckCreated(datei)>delay Then
												
												WScript.sleep 2000
												
												runplugin(spoolplugin)
												If fs.fileexists(datei) Then
													
													lngReturnCode = objWSHShell.Run(Chr(34)&programm&"archivspooler.bat"&Chr(34)&" """&datei&""" "&Profil,0,True)
													
												End If
												
												If Err.Number Then
													objWshShell.LogEvent 1,"bitfarm-Archiv: Verteiler.vbs:  Fehler bei bergabe an archivspooler.vbs.(3)" & vbCrLf & Datei &vbCrLf& Err.number &vbCrLf& Err.description&vbCrLf&stempel
													Err.clear
													On Error Resume Next
												End If
												spoolevent=True
											Else
												WScript.Sleep 2000
												
											End If
										Else
											runplugin(spoolplugin)
											If fs.fileexists(datei) Then
												lngReturnCode = objWSHShell.Run(Chr(34)&programm&"archivspooler.bat"&Chr(34)&" """&datei&""" "&Profil,0,True)
											End If
											If Err.Number Then
												objWshShell.LogEvent 1,"bitfarm-Archiv: Verteiler.vbs:  Fehler bei bergabe an archivspooler.vbs.(9)" & vbCrLf & Datei &vbCrLf& Err.number &vbCrLf& Err.description&vbCrLf&stempel
												Err.clear
											End If
											spoolevent=True
										End If
									End If
								End If
							Else
								t=0
								Do While t<=extcounter
									If extension=ext(t) Then
										If delayedscannerimport = True Then
											If CheckCreated(datei)>delay Then
												If spoolevent=True Then
													WScript.sleep 2000
												End If
												runplugin(spoolplugin)
												If fs.fileexists(datei) Then
													
													lngReturnCode = objWSHShell.Run(Chr(34)&programm&"archivspooler.bat"&Chr(34)&" """&datei&""" "&Profil,0,True)
													
												End If
												
												If Err.Number Then
													objWshShell.LogEvent 1,"bitfarm-Archiv: Verteiler.vbs:  Fehler bei bergabe an archivspooler.vbs.(3)" & vbCrLf & Datei &vbCrLf& Err.number &vbCrLf& Err.description&vbCrLf&stempel
													Err.clear
													On Error Resume Next
												End If
												spoolevent=True
											Else
												WScript.Sleep 2000
												
											End If
										Else
											If spoolevent=True Then
												WScript.sleep 2000
											End If
											runplugin(spoolplugin)
											If fs.fileexists(datei) Then
												
												lngReturnCode = objWSHShell.Run(Chr(34)&programm&"archivspooler.bat"&Chr(34)&" """&datei&""" "&Profil,0,True)
												
											End If
											If Err.Number Then
												
												objWshShell.LogEvent 1,"bitfarm-Archiv: Verteiler.vbs:  Fehler bei bergabe an archivspooler.vbs.(10)" & vbCrLf & Datei &vbCrLf& Err.number &vbCrLf& Err.description&vbCrLf&stempel
												Err.clear
											End If
											spoolevent=True
											t=10000
										End If
									End If
									t=t+1
								Loop
								If t<10000 Then
									On Error Resume Next
									fs.deletefile datei,True
									If Err.Number Then
										Err.clear
									End If
									objWshShell.LogEvent 2, "bitfarm-Archiv: Verteiler: Nicht untersttzten Dateityp aus Scannerimportpfad gelscht:"&Datei
								End If
								
							End If	
						End If
					End If
                Next
            Next
            Set unterordner=Nothing
            Set folder = Nothing
            WScript.Sleep 30
            
            
        End If
    End If

    On Error Resume Next
    Err.clear

    '**************************************** Aufrumen **********************************
    
    If movecounter>20 Then
        lockdatei=programm&"temp\movelock"
        
        If fs.fileexists(lockdatei) Then
            fs.deletefile lockdatei, True
            If Err.number>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "bitfarm-Archiv: Verteiler: Fehler beim aufrumen des Move-Locks."
            Else
                objWshShell.LogEvent 4, "bitfarm-Archiv: Verteiler: Move-Lock entfernt."
            End If
        End If
    End If
    
    
    moverevent=False
    spoolevent=False
    XMLevent=False
    folderevent=False
    wfevent=False
    WScript.sleep 200
    

    'If loopcounter2 = 0 Then
        'loopcounter2=1
        'If fs.folderexists(autoexportpath) Then
            
            'Set folder = fs.GetFolder(autoexportpath)
            'For Each datei In folder.files
                
                'alter=checkage(datei)
                'If alter > 10 Then
                    'On Error Resume Next
                    'fehlertext = fehlertext & datei.path & " - " & alter & vbCrLf
                    'fs.deletefile datei, True
                    
                    'If Err.number <>0 Then
                        'Err.clear
                        'On Error Resume Next
                        'objWshShell.LogEvent 1, "Verteiler.vbs: konnte alte Datei nicht lschen:" & datei
                    'End If
                    
                'End If
            'Next
            'If fehlertext<>"" Then
                'objWshShell.LogEvent 4, "bitfarm-Archiv: Verteiler: Alte Dateien aufgerumt (autoexportpath)." & vbCrLf & fehlertext
                'fehlertext = ""	
            'End If
            
            'Set folder = Nothing
            'WScript.Sleep 200
        'End If
        
    'End If
    
    'If loopcounter > 100 Then
        'loopcounter = 0
        'loopcounter2=loopcounter2+1
        'If loopcounter2=100 Then
            'loopcounter2=0
        'End If
        'Set folder = fs.GetFolder(verzeichnis)
        'For Each datei In folder.files
            
            'alter=checkage(datei)
            'If alter > 0 Then
                'On Error Resume Next
                'fehlertext = fehlertext & datei.path & " - " & alter & vbCrLf
                'fs.deletefile datei, True
                
                'If Err.number <>0 Then
                    'Err.clear
                    'On Error Resume Next
                    'objWshShell.LogEvent 1, "Verteiler.vbs: konnte alte Datei nicht lschen:" & datei
                'End If
            'End If
        'Next
        'If fehlertext<>"" Then
            'objWshShell.LogEvent 4, "bitfarm-Archiv: Verteiler: Alte Dateien aufgerumt" & vbCrLf & fehlertext
            'fehlertext = ""	
        'End If
        'Set folder = Nothing
        'WScript.Sleep 200
        
    'End If
    
    
    WScript.Sleep looptime
    
    
Loop
WScript.Quit


'*******************************************************************************************
'*******************************************************************************************
'********************************          Ende             ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

Function readconfig(profil)
    On Error Resume Next
    readconfig=True
    Err.clear
    
    If Not fs.FileExists(programm&profil&".con") Then
        Err.clear
        errortxt=profil&".con Datei nicht im Scriptpfad vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        readconfig=False
        Err.clear
    End If
    
    If readconfig=True Then	
        Set confile = fs.OpenTextFile(programm&profil&".con",1)
        If Err.number Then
            Err.clear
            errortxt="Profildatei nicht im Scriptpfad vorhanden oder nicht lesbar."
            objWshShell.LogEvent 1, errortxt
            Err.clear
            readconfig=False
        End If 
    End If
    
    If readconfig=True Then	
        kette=confile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        Do While Scriptsflag = 0
            kette=confile.readline
            Scriptsflag=InStr(1,kette,"[Scripts]")
            If confile.AtEndOfStream = True Then
                confile.close
                Set confile=Nothing
                scriptsflag=1
                errortxt="Fehler beim Lesen der CON-Datei - falsche Formatierung."
                objWshShell.LogEvent 1, errortxt
                readconfig = False
            End If
        Loop
    End If
    
    If readconfig = True Then
        Do While confile.AtEndOfStream <> True
            kette=Trim(confile.readline)
            kette = Replace(kette,vbTab,"")
            If Left(kette,1)<>";" Then
                If Len(kette)>13 Then		
                    If LCase(Left(kette,13))="clientspooler" Then
						wert = Right(kette,Len(kette) -14)
						clientspooler = Trim(wert)
                    End If
                End If
            End If
        Loop
        confile.close
        Set confile = Nothing
    End If
   
End Function


Function inilesen()
    On Error Resume Next
    Err.clear
    Set inifile = fs.OpenTextFile(programm&"scripts.ini",1)
    If Err.number Then
        objWshShell.LogEvent 1, "scripts.ini nicht im Scriptpfad vorhanden oder nicht lesbar."
        Err.clear
        WScript.Quit
    End If 
    
    kette=inifile.readline
    Scriptsflag=InStr(1,kette,"[Scripts]")
    Do While Scriptsflag = 0
        kette=inifile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        If inifile.AtEndOfStream = True Then
            inifile.close
            objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - falsche Formatierung."
            WScript.Quit
        End If
    Loop
    
    
    Do While inifile.AtEndOfStream <> True
        kette=inifile.readline
        If Left(kette,1)<>";" Then
                  
            If InStr(1,kette,"MSWordinstalled",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"MSWordinstalled",1)+16)
                If LCase(wert)="true" Then
                    acceptdoc = True
                End If	
            End If
            
            If InStr(1,kette,"MSExcelinstalled",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"MSExcelinstalled",1)+17)
                If LCase(wert)="true" Then
                    acceptxls = True
                End If	
            End If
            
            If InStr(1,kette,"MSPowerPointinstalled",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"MSPowerPointinstalled",1)+22)
                If LCase(wert)="true" Then
                    acceptppt = True
                End If	
            End If
            
            If InStr(1,kette,"MSOffice2007installed",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"MSOffice2007installed",1)+22)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        MSOffice2007installed=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"DWGViewerinstalled",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"DWGViewerinstalled",1)+19)
                If LCase(wert)="true" Then
                    acceptdwg = True
                End If	
            End If
            
            If InStr(1,kette,"VarialImportPath=",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"VarialImportPath=",1)+17)
                varialdatapath=wert
            End If
            
            If InStr(1,kette,"ScannerImportPath=",1)<>0 Then
                'wert=GetString(kette,InStr(1,kette,"ScannerImportPath=",1)+18)
                wert = Right(kette, Len(kette)-18)
                importpath=wert
            End If
            
            If InStr(1,kette,"ExtendedImportPath=",1)<>0 Then
                'wert=GetString(kette,InStr(1,kette,"ExtendedImportPath=",1)+19)
                wert = Right(kette, Len(kette)-19)
                importpath2=wert
            End If
            
            If InStr(1,kette,"acceptallfiletypes",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"acceptallfiletypes",1)+19)
                If LCase(wert)="true" Then
                    acceptallfiletypes = True
                End If	
            End If
                       
            If InStr(1,kette,"delayedscannerimport",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"delayedscannerimport",1)+21)
                If LCase(wert)="true" Then
                    delayedscannerimport=True
                    delay=30
                ElseIf IsNumeric(wert) Then
                    delayedscannerimport=True
                    On Error Resume Next
                    delay=CInt(wert)
                    If Err.Number<>0 Then
                        Err.Clear
                        objwshshell.LogEvent 1, "verteiler.vbs: Bitte prfen Sie den Wert der scripts.ini-Variable delayedscannerimport (True/False oder Zeit in Sek als Zahl)"
                        delay=30
                    End If
                Else
                    delayedscannerimport=False
                    delay=30
                End If	
            End If
            
            If InStr(1,kette,"autoexportpath",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"autoexportpath",1)+15)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    autoexportpath=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"spoolplugin",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"spoolplugin",1)+12)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    spoolplugin=Trim(wert)
                End If
            End If
            
            
            
            
            
            If InStr(1,kette,"archmsg",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"archmsg",1)+7)
                If LCase(wert)="true" Then
                    archmsg=True
                End If
            End If            
        End If
    Loop
    inifile.close
    Set inifile = Nothing
    If programm="" Then
        objWshShell.LogEvent 2, "Fehler beim Lesen der scripts.ini - kein Programmpfad."
        WScript.Quit
    End If
    
    
End Function


Function runplugin(plugin)
    On Error Resume Next
    runplugin=True
    Err.clear
    
    If Not fs.fileexists(programm&"plugins\"&plugin) Then
        runplugin=False
    End If
    
    If LCase(Right(datei,4))=".var" Then
        runplugin=False
    End If
    
    
    If runplugin=True Then
        writearray(Dateiname)
    End If
    
    '###############################   Plugin starten  ############################
    
    If runplugin=True Then
        If scriptdebug=True Then
            objWshShell.LogEvent 4, "Verteiler.vbs(debug25): starte Plugin "&plugin
        End If
        
        cmd = Chr(34)&pluginspath & plugin&Chr(34)&" "&Chr(34)&datei & Chr(34)
        If scriptdebug=True Then
            objWshShell.LogEvent 0, cmd
        End If
        lngReturnCode = objWSHShell.Run(cmd,0,True)
        
        
        
        If scriptdebug=True Then
            objWshShell.LogEvent 4, "verteiler(debug26): Rckkehr aus Plugin "&plugin
        End If
        
        
        WScript.sleep 80
    End If
    
    '###############################   Feld zurcklesen  ##########################
    
    If runplugin=True Then
        readarray(Dateiname)
    End If
    
End Function


Function writearray(tempname)
    On Error Resume Next
    '##############
    '##############
    '##############  Schreibt Dateiinformationen in die VAR-Datei
    '##############  zur bergabe an ein Plugin.
    '##############  
    '##############
    writearray=True
    Err.clear
    
    If fs.FileExists(tempname&".var") Then
        Err.clear
        fs.deletefile tempname&".var", True
        If Err.number Then
            Err.clear
            errortxt="bitfarm-Archiv: Pluginmeldung(Spooler): Kann alte var-datei nicht lschen."
            objWshShell.LogEvent 2, errortxt
            writearray=False
        End If 
        Err.clear
    End If
    
    If writearray=True Then	
        Set varfile = fs.OpenTextFile(tempname&".var",8,True)
        If Err.number Then
            Err.clear
            errortxt="bitfarm-Archiv: Pluginmeldung(Spooler): Kann var-datei nicht zum schreiben ffnen."
            objWshShell.LogEvent 2, errortxt
            writearray=False
            varfile.close
            Set varfile=Nothing
        End If 
    End If
    
    If writearray = True Then   
        varfile.writeline("Datei="&Datei)   
        varfile.close
        Set varfile=Nothing
        WScript.sleep 50
    End If
    
    
End Function



Function readarray(tempname)
    On Error Resume Next
    '##############
    '##############
    '##############  liest Dateiinformationen aus der vom Plugin
    '##############  zurckgegebenen VAR-Datei.
    '##############  
    '##############
    readarray=True
    Err.clear
    
    If readarray=True Then
        If fs.fileexists(tempname&".var") Then
            kette=""
            wert1=""
            wert2=""
            Set varfile = fs.OpenTextFile(tempname&".var",1)
            Do While varfile.atendofstream=False
                kette=varfile.readline
                                    
                If InStr(1,kette,"Datei=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Datei=",1)+5))
                    Datei=Trim(wert)                    
                End If             
            Loop
            varfile.close
            Set varfile=Nothing
            WScript.sleep 30
        End If
    End If
    
    If fs.fileexists(tempname&".var") Then
        Err.clear
        On Error Resume Next
        fs.deletefile tempname&".var", True
        If Err.number<>0 Then
            objWshShell.LogEvent 2, "bitfarm-Archiv: Verteiler: konnte VAR-Datei nicht lschen nach Pluginaufruf"	
            Err.clear
            On Error Resume Next
        End If
    End If
End Function



'***************************************************************************************
'***************************************************************************************
'***************************************************************************************


Function finddoc(basisdatei)
	' findet im gleiche Verzeichnis wie basisdatei die erste gleichnamige Datei, 
	' deren Endung nicht job oder tif ist
	basedir = fs.GetParentFolderName(basisdatei)
	basefilename = fs.GetBaseName(basisdatei)
	finddoc = ""
    Set folder = fs.GetFolder(basedir)
    For Each otherfile In folder.Files
    	If LCase(fs.GetExtensionName(otherfile)) <> "job" And LCase(fs.GetExtensionName(otherfile)) <> "tif" Then

			If LCase(basefilename) = LCase(fs.GetBaseName(otherfile)) Then
	    		finddoc = otherfile.path
	    		Exit for
	    	End If
	    End If
    Next
End Function





Function Countpages(tifdatei)
    On Error Resume Next
    If fs.Fileexists(tifdatei) And LCase(fs.GetextensionName(tifdatei)) = "tif" And fs.FileExists(programm & "CountPages.exe") Then
        
        On Error Resume Next
        strinput = ""
        schleife = 0
        
        Set oExec    = objWSHShell.Exec(Chr(34)&programm&"CountPages.exe"&Chr(34)&" "&Chr(34)&tifdatei&Chr(34))
        
        Do While Not oExec.StdOut.AtEndOfStream
            strinput = strinput & oExec.StdOut.Read(1)	
        Loop
        
        durch = False
        schleife = 0
        Do While schleife < 50
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If           
            WScript.Sleep 100  
            schleife = schleife +1
        Loop
        
        If durch = False Then
            objWshShell.LogEvent 1, "Archivierung.vbs Function countpages: Schwerwiegender Fehler" & vbCrLf & "Countpages.exe antwortet nicht oder wird nicht beendet" & vbCrLf & "Status: " & oExec.Status & vbCrLf & "Exitcode " & oExec.ExitCode & vbCrLf & "Schleife: " & schleife
            countpages = 0 
            oExec.Terminate      
        Else        
            If InStr(1,strinput,"Seiten:") <> 0 Then            
                strinput = Trim(Right(strinput,Len(strinput)-InStr(1,strinput,"Seiten:")-6))
                strinput = Left(strinput,InStr(1,strinput,Chr(13))-1)
                countpages = strconvert(strinput)
            End If  
        End If
    Else
        'keine tif-datei oder nicht vorhanden
        countpages = 0 
    End If
    
End Function


Private Function StrConvert(String)
    On Error Resume Next
    wert1=0
    l = Len(String)
    
    For x = 1 To l
        wert1=wert1+((Asc(Mid(String,x,1))-48)*(10^(l-x)))
    Next
    StrConvert=wert1
End Function


Private Function GetString(kette,pos)
    On Error Resume Next
    zeichen=""
    ergebnis=""
    index=0
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (zeichen<>"	") And (index<250)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,pos+index,1)
        index=index+1
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=")) And (ergebnis="") Then
            zeichen=""
        End If
    Loop
    Trim(ergebnis)
    GetString=ergebnis
End Function

Function CheckAge(datei)
    On Error Resume Next
    Set datei1=fs.getfile(datei)
    'zugriff = datei1.DateLastModified
    zugriff = datei1.DateLastAccessed
    Set datei1=Nothing
    If Err.Number = 0 Then
        CheckAge = DateDiff("d", zugriff, Now())
    Else
        Err.clear
        On Error Resume Next
        CheckAge = -1
    End If
End Function


Function CheckCreated(datei)
    On Error Resume Next
    Set datei1=fs.getfile(datei)
    zugriff = datei1.DateLastModified
    'zugriff = datei1.DateLastAccessed
    Set datei1=Nothing
    If Err.Number = 0 Then
        lastmodifieddiff = DateDiff("s", zugriff, Now())
        lastaccessdiff = DateDiff("s", zugriff2, Now())
        If lastmodifieddiff > lastaccessdiff Then
        	CheckCreated = lastaccessdiff
        Else
        	CheckCreated = lastmodifieddiff
        End If
    Else
        Err.clear
        On Error Resume Next
        CheckCreated = -1
    End If
    If scriptdebug=True Then
    	objwshshell.LogEvent 1, "verteiler.vbs checkcreated " & datei.Name & vbCrLf & "last modified " & zugriff & vbCrLf & Now() & vbCrLf & checkcreated
    End If
End Function



Function RegRead(tempkey)
    On Error Resume Next
    privkey = tempkey
    
    RegRead = objWSHShell.RegRead(privkey)
    If Not Err.number=0 Then
        objWshShell.LogEvent 1, "Fehler: Registrierungsschlssel nicht gesetzt."
        RegRead=""
        Err.clear
        WScript.Quit
    End If
End Function


Function getmovelockvar
    On Error Resume Next
    getmovelockvar=0
    
    Set WshEnv = objWSHShell.Environment("System")
    
    getmovelockvar = WshEnv("movelock")
    
    
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
    End If
    
    Set WshEnv=Nothing
    
End Function

Function setmovelockvar
    On Error Resume Next
    Set WshEnv = objWSHShell.Environment("System")
    WshEnv.Item("movelock") = 1
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
    End If
    Set WshEnv=Nothing
End Function

Function unsetmovelockvar
    On Error Resume Next
    Set WshEnv = objWSHShell.Environment("System")
    WshEnv.Item("movelock") = 0
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
    End If
    Set WshEnv=Nothing
End Function


Function getEnvironVar(varname)
    On Error Resume Next
    
    Set WshEnv = objWSHShell.Environment("System")
    
    getEnvironVar = WshEnv(varname)
        
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        getEnvironVar=""
    End If
    
    Set WshEnv=Nothing
    
End Function

Function setEnvironVar(varname,varvalue)
    On Error Resume Next
    setEnvironVar=True
    Set WshEnv = objWSHShell.Environment("System")
    WshEnv.Item(varname) = varvalue
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        setEnvironVar=False
    End If
    Set WshEnv=Nothing
End Function



Function getfifo(fifopath,fifoname)
    On Error Resume Next
    
    If fs.fileexists(fifopath&"Thumbs.db") Then
        fs.deletefile fifopath&"Thumbs.db", True
        If Err.number<>0 Then
            objWshShell.LogEvent 1, "Archivierung.vbs: konnte Thums.db nicht lschen"
        End If       
    End If
      
    Dim fifofile
    Dim fifofolder
    Beginn = Timer
    tempnumber=""
    fifoname=LCase(fifoname)
    
    highest = 0
      
    fifofile = GetLastFile(fifopath, fifoname&"*.*")
    If fifofile<>"" Then
        strfifo = fs.GetBaseName(fifofile)
        If InStr(1,strfifo,"_0") <> 0 Then
            strfifo = Replace(strfifo,"_0","")
        End If
        If InStr(1,strfifio,"-archiv") <> 0 Then
            strfifo = Replace(strfifo,"-archiv","")
        End If
        If InStr(1,strfifio,"-temp") <> 0 Then
            strfifo = Replace(strfifo,"-temp","")
        End If
        strnumber = Right(strfifo,5)
        If IsNumeric(strnumber) Then
            highest= strConvert(strnumber)
        Else

            fifofile = GetLastFile(fifopath, fifoname&"*.job")
            If fifofile<>"" Then
                strfifo = fs.GetBaseName(fifofile)
                strnumber = Right(strfifo,5)
                If IsNumeric(strnumber) Then
                    highest= strConvert(strnumber)
                End If
            Else
                'es gibt keinen job 
            End If
        End If
            
        If highest = 99999 Then       ' zahlenbereich fr diesen dateinamen voll, umbenennen
            If fifoname = "prio" Then
                
                objWshShell.LogEvent 2,"bitfarm-Archiv: Achtung Totaler Overflow - Queue vollgelaufen !"&vbCrLf&"Es werden keine Dokumente mehr gespoolt"
                
                Set fifofolder = Nothing
                WScript.Quit
            Else
                fifoname = "prio"
                
                getfifo = getfifo(fifopath,fifoname)
                
                Exit Function
            End If
        End If
    End If
      
    tempnumber = MakeFifoString(highest +1)
    
    WScript.Sleep 200
       
    fifofile = GetLastFile(fifopath,fifoname&"*.*")
    strfifo = fs.GetBaseName(fifofile)
        
    If strfifo = fifoname& tempnumber Then
        If scriptdebug = True Then
            objWshShell.LogEvent 0, "Archivierung.vbs" &vbCrLf& "Slot schon besetzt, Routine wird nochmals aufgerufen" &vbCrLf& tempnumber &vbCrLf& jetzt
        End If
        
        getfifo = getfifo(fifopath,fifoname)
        
        Exit Function
    End If
    
    'vielleicht wurde aus unbekannten grnden doch ein schon vergebener name ermittelt
    
    If fs.FileExists(fifopath & fifoname& tempnumber & extension) Then
        highest = highest + 1
        tempnumber = MakeFifoString(highest +1)
        
        Do While fs.FileExists(fifopath & fifoname& tempnumber & extension) And highest <99999
            highest = highest + 1
            tempnumber = MakeFifoString(highest +1)
        Loop
    End If
    
    
    If tempnumber<>"" Then
        getfifo = fifopath & fifoname & tempnumber
    Else
        'alternativ alte routine
        highest = 0
        
        Set fifofolder = fs.GetFolder(fifopath)
        
        For Each fifofile In fifofolder.Files
            
            strfifo = fs.GetBaseName(fifofile)
            If InStr(1,strfifo,"_0") <> 0 Then
                strfifo = Replace(strfifo,"_0","")
            End If
            If InStr(1,strfifio,"-archiv") <> 0 Then
                strfifo = Replace(strfifo,"-archiv","")
            End If
            If InStr(1,strfifio,"-temp") <> 0 Then
                strfifo = Replace(strfifo,"-temp","")
            End If
            ' Bedingung Basename = fifoname+ 5 stellige Zahl
            
            If Len(strfifo) = Len(fifoname)+5 Then
                If LCase(Left(strfifo,Len(strfifo)-5)) = fifoname Then
                    
                    strnumber = Right(strfifo,5)
                    If IsNumeric(strnumber) Then
                        strnumber= strConvert(strnumber)
                        'MsgBox "strnumber=" & strnumber		
                    End If
                    If strnumber> highest Then
                        highest =  strnumber
                    End If
                End If
            End If
            
            
            If highest = 99999 Then       ' zahlenbereich fr diesen dateinamen voll, umbenennen
                If fifoname = "prio" Then                    
                    objWshShell.LogEvent 2,"bitfarm-Archiv: Achtung Totaler Overflow - Queue vollgelaufen !"&vbCrLf&"Es werden keine Dokumente mehr gespoolt"                 
                    Set fifofolder = Nothing
                    WScript.Quit
                Else
                    fifoname = "prio"                    
                    getfifo = getfifo(fifopath,fifoname)
                    Exit Function
                End If
            End If     
        Next 
        Set fifofolder = Nothing
        Set fifofile = Nothing
        
        
        tempnumber = MakeFifoString(highest +1)
        
        WScript.Sleep 1000
    
        Set fifofolder = fs.GetFolder(fifopath)
        
        For Each fifofile In fifofolder.Files         
            strfifo = fs.GetBaseName(fifofile)
            
            If strfifo = fifoname& tempnumber Then

                If scriptdebug = True Then
                    objWshShell.LogEvent 0, "Archivierung.vbs" &vbCrLf& "Slot schon besetzt, Routine wird nochmals aufgerufen" &vbCrLf& tempnumber &vbCrLf& jetzt
                End If
                
                getfifo = getfifo(fifopath,fifoname)
                Set fifofolder = Nothing
                Set fifofile = Nothing
                Exit Function
            End If          
        Next 
        Set fifofolder = Nothing
        Set fifofile = Nothing
        
        getfifo = fifopath & fifoname & tempnumber
             
    End If
    Ende = Timer

    If scriptdebug = True Then
        objWshShell.LogEvent 0, "Archivierung.vbs: ermittelter tempname=" & getfifo
    End If    
End Function


Function MakeFiFoString(nummer) 
    On Error Resume Next
    
    If Len(nummer) = 1 Then MakeFiFoString = "0000" & nummer
    If Len(nummer) = 2 Then MakeFiFoString = "000" & nummer
    If Len(nummer) = 3 Then MakeFiFoString = "00" & nummer
    If Len(nummer) = 4 Then MakeFiFoString = "0" & nummer
    If Len(nummer) = 5 Then MakeFiFoString = "" & nummer   
End Function


Function GetFirstFile(folder,mask)
    On Error Resume Next
    
    GetFirstFile=""
    If fs.FileExists(programm&"countfiles.exe") Then
        Set oExec    = objWSHShell.Exec(Chr(34)&programm&"countfiles.exe"&Chr(34)&" "& Chr(34)&folder & Chr(34)&" " & mask & " -lf")     
        strinput = oExec.StdOut.ReadAll
        durch = False
        schleife = 0
        Do While schleife < 5000
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 1
            schleife = schleife +1
        Loop
        timer4 = Timer
        
        strname = strinput
        strname=Right(strinput,Len(strinput)-InStrRev(strinput,Chr(13),Len(strinput)-2)-1)
        strname = Left(strname,InStr(strname,Chr(13))-1)
        
        'MsgBox oExec.ExitCode & vbtab & timer4-timer3 & vbTab & schleife & vbCrLf  & ">>" & strname
        GetFirstFile=strname
        
        Set oExec = Nothing
    Else
        objWSHShell.LogEvent 1, "Archivierung.vbs: " & programm&"countfiles.exe nicht gefunden"
    End If
    
End Function


Function GetLastFile(folder,mask)
    On Error Resume Next
    
    GetLastFile=""
    
    If fs.FileExists(programm&"countfiles.exe") Then
        Set oExec    = objWSHShell.Exec(Chr(34)&programm&"countfiles.exe"&Chr(34)&" "& Chr(34)&folder & Chr(34)&" " & mask & " -ll")

        strinput = oExec.StdOut.ReadAll
              
        durch = False
        schleife = 0
        Do While schleife < 5000
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 1
            schleife = schleife +1
        Loop
        timer4 = Timer
        
        strname = strinput
        strname=Right(strinput,Len(strinput)-InStrRev(strinput,Chr(13),Len(strinput)-2)-1)
        strname = Left(strname,InStr(strname,Chr(13))-1)
        GetLastFile=strname
        
        Set oExec = Nothing
    Else
        objWSHShell.LogEvent 1, "Archivierung.vbs: " & programm&"countfiles.exe nicht gefunden"
    End If 
End Function


Function CountFiles(folder,mask)
    On Error Resume Next
    
    CountFiles=0
    If fs.FileExists(programm&"countfiles.exe") Then
        Set oExec    = objWSHShell.Exec(Chr(34)&programm&"countfiles.exe"&Chr(34)&" "& Chr(34)&folder & Chr(34)&" " & mask)
        strinput = oExec.StdOut.ReadAll
        durch = False
        schleife = 0
        Do While schleife < 5000
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 1
            schleife = schleife +1
        Loop
        timer4 = Timer
        
        strname = strinput
        strname = Right(strinput,Len(strinput)-InStrRev(strinput,Chr(13),Len(strinput)-2)-1)
        strname = Left(strname,InStr(strname,Chr(13))-1)
        
        If InStr(strname,"Anzahl:") Then
            strname = Right(strname,Len(strname)-7)
            CountFiles = Strconvert(strname)
        End If
        
        Set oExec = Nothing
    Else
        objWSHShell.LogEvent 1, "Archivierung.vbs: " & programm&"countfiles.exe nicht gefunden"
    End If
    
End Function






