'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'***************  workflow.vbs       GPL  **************************************************
'*******************************************************************************************
'***************  Version 3.6.2.3         **************************************************
'*******************************************************************************************
'***************  Programm zur Realisierung von Workflows anhand von         ***************
'***************  bestimmten Eigenschaften gerade zu archivierender          ***************
'***************  Dokumente                                                  ***************
'***************                                                             ***************
'***************  geht die workflow.ini durch und vergleicht mit dem         ***************
'***************  Ergebnis der Volltextindizierung und lst die definierten  ***************
'***************  Aktionen aus.                                              ***************
'***************                                                             ***************
'***************  Wird am Ende der Archivierung gestartet.                   ***************
'***************  Parameter ist die Datei im Achivbaum ohne Endung.          ***************
'***************                                                             ***************
'***************  Syntax: <programmpfad>workflow.vbs <Datei> <Tabelle>       ***************
'***************  <DokumentID> <Benutzer>                                    ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************

cleanup = True
scriptdebug = False
bfa_server_smtp = False
mailaddrstr = ""
limit = 80

workflowabgesang1= "<DIV><EM>bitfarm-<FONT color=#ff0000>Archiv</FONT> Dokumentenmanagement</EM> </DIV>"
workflowabgesang2= "<DIV><FONT id=""""><EM>Hilfe und Untersttzung: 0271 / 31396 - 0</EM></FONT></DIV>"
workflowabgesang1=""
workflowabgesang2=""
'*******************************************************************************************
'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
extrajob = False

On Error Resume Next

Dim objWSHShell, fso, FileIn, FileOut 
Dim Datei, Text, Txt, i, arrSort, arrTest(), oArgs, Druckername
Dim lngReturnCode


Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set fs      = WScript.CreateObject("Scripting.FileSystemObject") 
Set oArgs    = WScript.Arguments 


If scriptdebug=True Then
    
    For i = 0 To oArgs.Count -1
        
        arg = arg & oArgs.Item(i) & vbCrLf
        
    Next 
    objWshShell.LogEvent 4, "workflow.vbs gestartet (1)" & vbCrLf & arg
    
    
End If

'*******************************************************************************************
'**************************  Startparameter initialisieren  ********************************
Err.clear
fullpath = WScript.ScriptFullName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
scriptname = WScript.ScriptName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))

If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
If Len(programm)=0 Then
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If

' per default, allerdings wird das workflowsverzeichnis aus der con gelesen
workflows=programm&"workflows\"
temp=programm&"temp\"


smtpserver = ""
sendername = ""
authuser = ""
authpass = ""
clientprogramm = ""
newstatus=""
StatStr=""
folderID="0"
folderName=""
newstatuslang="deutsch"
doc_loc=""
ori_loc = ""
archivverzeichnis=""
archivkopie = ""
archive_rs = ""
archive_nrs = ""
storages = ""
myname = ""
exportpath=""
exportscript=""
nowvl=False
makepdf=False

'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************


ReDim params(20)
ReDim email(limit)
ReDim bearbeiter(limit)
ReDim controller(limit) 
ReDim versatz(limit)
ReDim alarmversatz(limit)
ReDim options(limit)
ReDim txttofind(limit)
ReDim andor(limit)
ReDim Tabelle(limit)
ReDim operator(limit)
ReDim operant(limit)
ReDim Zusatzfeldname(limit)
ReDim zusfeld(limit)
ReDim zuswert(limit)
ReDim addresslist(limit)

For i = 0 To limit
    email(i)=""
    txttofind(i)=""
    andor(i)=0
    Tabelle(i)=""
    bearbeiter(i)=""
    controller(i)="System"
    versatz(i)=0
    'alarmversatz(i)=0
    options(i)=""
    operator(i)=""
    operant(i)=""
    Zusatzfeldname(i)=""
    zusfeld(i)=""
    zuswert(i)=""
    addresslist(i)=""
Next
laststatus = "0"
continuecount = 0
flag1 = False
tabellencount=0
emailcount = 0
txtfindcount = 0
bearbeitercount = 0
bearbeiterzaehler=0
bodytxt = ""
headertxt = ""
setworkflow=""
sendfile=False
msgheadr=""
msgbody=""
DokID=""
viewerwf=False
moverwf=False
mywfID=Zufallszahl(0,99999)
wfID=""
debugcounter=0
heute=Date()
lateworkflowarchiv=""
lateworkflowdokid=""
wfabbruch=False
workflowplugin=""
lateworkflow=False
intervalworkflow=False
intervalworkflowarchiv=""
intervalworkflowdokid=""
webviewerlink=False
webviewer=""
inilesen()

'*******************************************************************************************
'*************************************   Parameterbergabe   *******************************
'*******************************************************************************************

Archiv=""
Datei=""
benutzer=""

Datei = Trim(oArgs.item(0))
If Err.number<>0 Then
    objWshShell.LogEvent 1, "workflow: Parameter fehlt (Datei)."
    Err.clear
    WScript.Quit
End If 

wfID = Trim(oArgs.item(1))
If Err.number<>0 Then
    objWshShell.LogEvent 1, "workflow: Parameter fehlt (wfID)."
    Err.clear
    WScript.Quit
End If   

DokID = Trim(oArgs.item(2))
If Err.number<>0 Then
    objWshShell.LogEvent 1, "workflow: Parameter fehlt (DokID)."
    Err.clear
    WScript.Quit
End If   

Profil = Trim(oArgs.item(3))
If Err.number<>0 Then
    objWshShell.LogEvent 1, "workflow: Parameter fehlt (Profil)."
    Err.clear
    WScript.Quit
End If   

benutzer = Trim(oArgs.item(4))
If Err.number<>0 Then
    objWshShell.LogEvent 1, "workflow: Parameter fehlt (Benutzer)."
    Err.clear
    WScript.Quit
End If   

Archiv = Trim(oArgs.item(5))
If Err.number<>0 Then
    objWshShell.LogEvent 1, "workflow: Parameter fehlt (Archiv)."
    Err.clear
    WScript.Quit
End If   

NRSDatei=""
If oArgs.Count = 7 Then
    NRSDatei = Trim(oArgs.item(6))
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        NRSDatei=""
    End If 
End If

If scriptdebug=True Then
    objWshShell.LogEvent 4, "workflow: DATEI:"&datei&" WFID:"&wfID&" DOKID:"&dokID&" PROFIL:"&profil&" BENUTZER:"&benutzer&" ARCHIV:"&archiv&" NRSDATEI:"&NRSDatei
End If


If (archiv<>"") And (archiv<>"workflow") And (fs.fileexists(programm & profil & "-" & Archiv & ".wfd")) Then
	workflowfile = programm & profil & "-" & Archiv & ".wfd"
Else
	workflowfile = programm & profil & ".wfd"
End If	
	
erfolg=readconfig(profil)

If bfa_server_smtp=True Then
	If Not fs.FileExists(programm & "bfa_sendmail.exe") Then
		bfa_server_smtp=False
		objWshShell.LogEvent 1, "workflow.vbs: " & programm & "bfa_sendmail.exe nicht gefunden! verwende blat.exe fr den Mailversand."
	End If
End If

If Not fs.FolderExists(workflows) Then
    Set tes1 = fs.CreateFolder(workflows)
    Set tes1 = Nothing
    WScript.sleep 200
    If Err.number<>0 Then
        objWshShell.LogEvent 1, "workflow.vbs(0): kann das Verzeichnis" & vbCrLf & workflows & " nicht erstellen!" & vbCrLf & Err.Number & vbTab & Err.Description
        
        Err.clear
        WScript.Quit
    End If 
    
    If Not fs.FolderExists(foldername) Then
        objWshShell.LogEvent 1, "workflow.vbs(0b): kann das Verzeichnis" & vbCrLf & workflows& " nicht erstellen!" & vbCrLf & Err.Number & vbTab & Err.Description
        
        WScript.Quit
    End If
End If

If erfolg=False Then
    objWshShell.LogEvent 1, "bitfarm-Archiv: workflow: Fehler beim lesen der Konfiguration."
    Err.clear
    WScript.Quit
End If

If storages = "" Or archive_rs = "" Or archive_nrs = "" Then
	errortxt="workflow.vbs Fehler beim ermitteln der Archivablage-Verzeichnisse"& vbCrLf & "storages: " & storages & vbCrLf & "archive_rs: " & archive_rs & vbCrLf & "archive_nrs: " & archive_nrs
	objWSHShell.LogEvent 1, errortxt
    WScript.Quit
Else
	archivbasedir = objWSHShell.ExpandEnvironmentStrings(storages)    
	archivverzeichnis = archivbasedir & "\" & archive_rs & "\"
	archivkopie = archivbasedir & "\" & archive_nrs & "\"
	If Not fs.FolderExists(archivverzeichnis) Then
		errortxt="workflow.vbs Fehler: Archivverzeichnis "& archivverzeichnis &" nicht erreichbar -> beende"
		objWSHShell.LogEvent 1, errortxt
        WScript.Quit
	End If
	If Not fs.FolderExists(archivkopie) Then
		errortxt = "workflow.vbs Fehler: Archivkopie "& archivkopie &" nicht erreichbar -> beende"
		objWSHShell.LogEvent 1, errortxt
        WScript.Quit
	End If
End If

If DokID="1" Then
    viewerwf=True
    archiv="workflow"
End If

If benutzer="2" Then
    moverwf=True
    benutzer="System"
End If

If Datei = "" Then
    objWshShell.LogEvent 1, "workflow.vbs: Paramter falsch."
    WScript.Quit
End If

If (viewerwf=False) And (Not fs.FileExists(Datei&".txt")) Then 
    objWshShell.LogEvent 1, "workflow.vbs: Datei fehlt(1): "&Datei&".txt"
    WScript.Quit
End If

If (viewerwf=True) And (Not fs.FileExists(Datei)) Then 
    objWshShell.LogEvent 1, "workflow.vbs: Datei fehlt(2): "&Datei
    WScript.Quit
End If

If (viewerwf=False) And (Not fs.FileExists(workflowfile)) Then 
    objWshShell.LogEvent 1, "workflow.vbs: workflow-Datei fehlt. " & workflowfile
    WScript.Quit
End If

If Archiv = "" Then
    objWshShell.LogEvent 1, "workflow.vbs: Paramter falsch.(1)"
    WScript.Quit
End If

If DokID = "" Then
    objWshShell.LogEvent 1, "workflow.vbs: Paramter falsch.(2)"
    WScript.Quit
End If

If benutzer = "" Then
    objWshShell.LogEvent 1, "workflow: Paramter falsch.(3)"
    WScript.Quit
End If

datum = Date()

ready=False
If (viewerwf=True) And fs.fileexists(datei&".job") Then
    erfolg = readjob(Datei&".job")
    ready=True
End If

If (viewerwf=False) And fs.fileexists(datei&".txt") Then
    erfolg = readjob(Datei&".txt")
  
End If

'*******************************************************************************************
'***********************************  haben wir einen mehrstufigen Workflow?  **************
'*******************************************************************************************
myIDstring=""
myusername=""
noworkflowfile=False
workflowflag = False


If scriptdebug=True Then
    If fs.folderexists(programm&"workflowdebug")= False Then
		Set test = fs.CreateFolder(programm&"workflowdebug")
        Set test = Nothing
        WScript.sleep 200
        If Err.number<>0 Then
            objWshShell.LogEvent 1, "workflow(0): kann debug-verzeichnis nicht erstellen - Berechtigung?"
            On Error Resume Next
            Err.clear
            WScript.Quit
        End If 
    End If
    mydate=Date()
    mytime=Time()
    mytime=Replace(mytime,":", "")
    myversatz=zufallszahl(100,999)
    test = programm&"workflowdebug\"&mydate&mytime&myversatz&"-"&debugcounter&".txt"
    debugcounter=debugcounter+1
    If fs.fileexists(datei) Then
        fs.copyfile datei, test, True
    ElseIf fs.fileexists(datei&".txt") Then
        fs.copyfile datei&".txt", test, True
    End If
End If


If Archiv = "workflow" Then
    workflowflag = True
    myIDstring=getworkflowID(Datei)
    myusername=getworkflowlastuser(Datei)
    
    getworkflowfields(Datei)
    
    If myIDstring="" Then
        'fs.Deletefile Datei&".txt", True
        objWshShell.LogEvent 1, "workflow: keine ID lesbar: "&Datei
        WScript.Quit
    End If 
    WScript.Sleep 200
    
    dateistring=programm&Datei&".txt"
    
    If fs.fileexists(dateistring) Then
        fs.DeleteFile dateistrin, True
    End If
    
    myID = myIDstring
    DokID = myIDString 
    pos=InStr(1,myIDstring,".",1)
    If pos<>0 Then
        myID=Right(myIDstring,Len(myIDstring)-pos)
    End If
    
    myIDfile=workflows&"workflow"&myID&"-"&wfID&".txt"
    If scriptdebug=True Then
        objWshShell.LogEvent 4, "myIDfile: "&myIDfile
    End If
    
    If Not fs.fileexists(myIDfile) Then
        noworkflowfile=True
        
    Else
        If scriptdebug=True Then
            If fs.folderexists(programm&"workflowdebug")= False Then
                Set test = fs.CreateFolder(programm&"workflowdebug")
                Set test = Nothing
                WScript.sleep 200
                If Err.number<>0 Then
                    objWshShell.LogEvent 1, "workflow(0): kann debug-verzeichnis nicht erstellen - Berechtigung?"
                    On Error Resume Next
                    Err.clear
                    WScript.Quit
                End If 
            End If
            mydate=Date()
            mytime=Time()
            mytime=Replace(mytime,":", "")
            myversatz=zufallszahl(100,999)
            test=programm&"workflowdebug\"&mydate&mytime&myversatz&"-"&debugcounter&".txt"
            debugcounter=debugcounter+1
            
            fs.copyfile Chr(34)&myIDfile&Chr(34), Chr(34)& test &Chr(34), True
        End If
        
        
        ' t.hassler 22.05.2012
        ' Anzahl Zeilen bestimmen (alte workflow.vbs schreibt keinen Benutzer ins workflow-File
        ' Wenn 8 Zeilen vorhanden, dann ist der Benutzer drin und wird ausgelesen
        ' Wenn nicht, ist kein Benutzer vorhanden und wird auch nicht ausgelesen
        Set workflowinfo = fs.OpenTextFile(myIDfile,1)
        lines = 0
        Do While Not workflowinfo.AtEndOfStream
            line = workflowinfo.ReadLine
            lines = lines + 1
        Loop
        workflowinfo.Close()
        
        Set workflowinfo = fs.OpenTextFile(myIDfile,1)
        oldworkflowID = workflowinfo.readline
        Datei=workflowinfo.readline
        datum=workflowinfo.readline
        mail=workflowinfo.ReadLine
        
        ' t.hassler 22.05.2012
        ' nur wenn 8 Zeilen im File vorhanden sind, steht an dieser Stelle der Benutzer
        If lines=8 Then
            benutzer=workflowinfo.ReadLine
        End If
        displayname=workflowinfo.readline
        xDokID=workflowinfo.readline
        laststatus=workflowinfo.readline
        workflowinfo.close
        Set workflowinfo = Nothing
        noworkflowfile=False
        fs.DeleteFile myIDfile, True
        endebearbeitung()
        If scriptdebug=True Then
            objWshShell.LogEvent 4, oldworkflowID&":"&Datei&":"&datum&":"&username
        End If
    End If 
End If

If noworkflowfile=True Then
    If scriptdebug=True Then
        objWshShell.LogEvent 4, "noworkflowfile: "&myIDfile
    End If
    'If myusername<>""Then
    '	sendnoworkflowmsg(myusername)
    'End If
    'WScript.Quit
End If

If ready=False Then
    pos=0
    pos=InStr(1,dokid,".",1)
    arc=""
    doc=""
    If pos<>0 Then
        doc=Right(dokid,Len(dokid)-pos)
        arc=Left(dokid,pos-1)
    End If
    
    If (arc<>"") And (doc<>"") Then
        If fs.fileexists(programm&"temp\wf"&myID&"-"&wfID&".job") Then
            fs.deletefile programm&"temp\wf"&myID&"-"&wfID&".job", True
            WScript.sleep 50
        End If
        Set oExec    = objWSHShell.Exec(Chr(34)&programm&"createnewjobfile.exe"&Chr(34)&" "&Chr(34)&profil&Chr(34)&" "&arc&" "&doc&" "&Chr(34)&programm&"temp\wf"&myID&"-"&wfID&Chr(34))
        Do While Not oExec.StdOut.AtEndOfStream
            strinput = strinput & oExec.StdOut.Read(1)	
        Loop
        Set oexec=Nothing
        
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
        End If
        If fs.fileexists(programm&"temp\wf"&myID&"-"&wfID&".job") Then
            erfolg=readjob(programm&"temp\wf"&myID&"-"&wfID&".job")
            fs.deletefile programm&"temp\wf"&myID&"-"&wfID&".job", True
        End If
    End If
End If	


'*******************************************************************************************
'***********************************  Hauptschleife  ***************************************
'*******************************************************************************************
If (noworkflowfile=False) And (wfabbruch=False) Then
    If scriptdebug=True Then	
        objWshShell.LogEvent 4, "workflow.vbs: Hauptschleife begonnen " & vbCrLf & "Workflowfile:" & workflowfile
    End If
    
    If Not fs.FileExists(workflowfile) Then
        objWshShell.LogEvent 1, "workflow.vbs: workflowfile nicht vorhanden" & vbCrLf & workflowfile	
    Else
        Set wfdatei = fs.OpenTextFile(workflowfile,1)
        extrajob = False
        endflag = False
        sendfile=False
        workflowID=0
        setworkflow=""
        
        If wfdatei.AtEndOfStream <> True Then
            kette = Trim(Replace(Trim(wfdatei.readline), vbTab, ""))
        Else
            endflag = True
        End If
        continue=""
        workflowcount = 0
        If scriptdebug=True Then
            objWshShell.LogEvent 4, "Workflow Trap1"
        End If
        
        Do While endflag <> True
            If Archiv="workflow" Then
                nowvl=False
                If continuelesen() = True Then
                    If continueauswertung() = True Then
                        If scriptdebug=True Then
                            objWshShell.LogEvent 4, "Workflow Trap2 Continueaktion("&workflowcount&") ausgelst"
                        End If
                        continueaktion()
                        continuecount = continuecount + 1
                    End If
                End If
            Else
            	nowvl=False
                If workflowlesen()=True Then
                    If workflowauswertung() = True Then
                        If scriptdebug=True Then
                            objWshShell.LogEvent 4, "Workflow Trap3 Workflowaktion("&workflowcount&") ausgelst"
                        End If
                        workflowaktion()
                    End If
                End If
            End If
            
            If wfdatei.AtEndOfStream <> True Then
                kette = Trim(Replace(Trim(wfdatei.readline), vbTab, ""))
            Else
                endflag = True
            End If
            
        Loop
        wfdatei.close
        Set wfdatei = Nothing
    End If 
End If

'################ late-workflows #############################

If (noworkflowfile=True) And (viewerwf=True) And (wfabbruch=False) And (intervalworkflow=False) Then
    archiv=lateworkflowarchiv
    dokid=lateworkflowdokid
    lateworkflow=True
    
    If Len(dokid)<3 Then
        objWshShell.LogEvent 1, "bitfarm-Archiv: Workflow: Fehler bei late-workflow: keine DokID"
        WScript.Quit
    End If
    
    If Not fs.FileExists(workflowfile) Then
        objWshShell.LogEvent 1, "workflow.vbs: workflowfile nicht vorhanden" & vbCrLf & workflowfile	
    Else
        Set wfdatei = fs.OpenTextFile(workflowfile,1)
        extrajob = False
        endflag = False
        sendfile=False
        workflowID=0
        setworkflow=""
        
        If wfdatei.AtEndOfStream <> True Then
            kette = Trim(Replace(Trim(wfdatei.readline), vbTab, ""))
        Else
            endflag = True
        End If
        continue=""
        workflowcount = 0
        If scriptdebug=True Then
            objWshShell.LogEvent 4, "Workflow Trap1"
        End If
        
        Do While endflag <> True
        	nowvl=False
            If late_workflowlesen()=True Then
                If workflowauswertung() = True Then
                    If scriptdebug=True Then
                        objWshShell.LogEvent 4, "Workflow Trap4 Workflowaktion("&workflowcount&") ausgelst"
                    End If
                    workflowaktion()
                End If
            End If
            
            If wfdatei.AtEndOfStream <> True Then
                kette = Trim(Replace(Trim(wfdatei.readline), vbTab, ""))
            Else
                endflag = True
            End If
            
        Loop
        wfdatei.close
        Set wfdatei = Nothing
    End If 
End If


'################ Interval-workflows #######################

If (noworkflowfile=True) And (viewerwf=True) And (wfabbruch=False) And (intervalworkflow=True) Then
    archiv=intervalworkflowarchiv
    dokid=intervalworkflowdokid
    
    If Len(dokid)<3 Then
        objWshShell.LogEvent 1, "bitfarm-Archiv: Workflow: Fehler bei interval-workflow: keine DokID"
        WScript.Quit
    End If
    
    Set wfdatei = fs.OpenTextFile(workflowfile,1)
    extrajob = False
    endflag = False
    sendfile=False
    workflowID=0
    setworkflow=""
    
    If wfdatei.AtEndOfStream <> True Then
        kette = Trim(Replace(Trim(wfdatei.readline), vbTab, ""))
    Else
        endflag = True
    End If
    continue=""
    workflowcount = 0
    If scriptdebug=True Then
        objWshShell.LogEvent 4, "interval Workflow Trap1"
    End If
    
    Do While endflag <> True
        nowvl=False
        If interval_workflowlesen()=True Then
            If workflowauswertung() = True Then
                If scriptdebug=True Then
                    objWshShell.LogEvent 4, "interval Workflow Trap4 Workflowaktion("&workflowcount&") ausgelst"
                End If
                workflowaktion()
            End If
        End If
        
        If wfdatei.AtEndOfStream <> True Then
            kette = Trim(Replace(Trim(wfdatei.readline), vbTab, ""))
        Else
            endflag = True
        End If
        
    Loop
    wfdatei.close
    Set wfdatei = Nothing
End If

'*******************************************************************************************
'*************************************  ENDE  *****************************************


If cleanup Then
    If fs.fileexists(Datei & ".txt") And InStr(1, LCase(Datei), LCase(archivverzeichnis))=0 And InStr(1, LCase(Datei), LCase(archivkopie))=0 Then
        fs.Deletefile Datei & ".txt",True
        Err.clear
    End If
    't.hassler 22.05.2012 Nur Lschen wenn "Datei" nicht in Archivablage liegt
    If fs.fileexists(Datei) And InStr(1, LCase(Datei), LCase(archivverzeichnis))=0 And InStr(1, LCase(Datei), LCase(archivkopie))=0 Then
        objwshshell.logevent 0, "workflow.vbs: Datei " & Datei.name & " Verarbeitung beendet, wird gelscht..."
        fs.Deletefile Datei,True
        objwshshell.logevent 0, "workflow.vbs: Datei " & Datei.name & " wurde gelscht..."
        Err.clear
    End If
    
End If 

WScript.Quit			



'*******************************************************************************************
'****************************  lesen eines normalen workflows  *****************************
'*******************************************************************************************

Function workflowlesen()
    On Error Resume Next
    workflowlesen = False
    
    If Left(kette,1)<>";" Then
        If LCase(Left(kette,16))="workflow section" Then
            workflowlesen=True
            workflowcount=workflowcount+1
            flag1 = False
            tabellencount=0
            casecount=0
            emailcount = 0
            bearbeitercount = 0
            txtfindcount = 0
            bodytxt = ""
            headertxt = ""
            setworkflow=""
            sendfile=False
            makepdf=False
            webviewerlink=False
            msgbody=""
            exportpath=""
            exportscript=""
            
            For ii = 0 To limit
                txttofind(ii)=""
                andor(ii)=0
                zusatzfeldname(ii)=""
                operator(ii)=""
                operant(ii)=""
                versatz(ii)=0
                alarmversatz(ii)=Empty
            Next 
            andor(1)=2
            
            Do While flag1 = False 
                If wfdatei.AtEndOfStream=False Then
                    kette = Trim(Replace(Trim(wfdatei.readline), vbTab, ""))
                Else 
                    flag1=True
                    'endflag=true
                End If
                
                If Left(kette,11)="end section" Then
                    flag1 = True
                End If
                
                If Left(kette,12)="orindocument" Then
                    txtfindcount=txtfindcount+1
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"orindocument=",1)+12))
                    'wert=GetString(kette,InStr(1,kette,"orindocument",1)+12)
                    txttofind(txtfindcount)=wert
                    andor(txtfindcount)=1
                End If 

                If Left(kette,5)="nowvl" Then
                    nowvl = True
                End If
                
                If Left(kette,10)="exportpath" Then
                    laenge=Len(kette)+1
                    pos1=InStr(1,kette,"exportpath",1)+11
                    wert=Mid(kette,pos1,laenge-pos1)
                    exportpath=wert
                    If Right(exportpath,1)<>"\" Then
                        exportpath=exportpath&"\"
                    End If
                End If
                
                If Left(kette,12)="exportscript" Then
                    laenge=Len(kette)+1
                    pos1=InStr(1,kette,"exportscript",1)+13
                    wert=Mid(kette,pos1,laenge-pos1)
                    exportscript=wert
                End If
                
                If Left(kette,13)="andindocument" Then
                    txtfindcount=txtfindcount+1
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"andindocument=",1)+13))
                    'wert=GetString(kette,InStr(1,kette,"andindocument",1)+13)
                    txttofind(txtfindcount)=wert
                    andor(txtfindcount)=2
                End If 
                
                If Left(kette,13)="notindocument" Then
                    txtfindcount=txtfindcount+1
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"notindocument=",1)+13))
                    'wert=GetString(kette,InStr(1,kette,"andindocument",1)+13)
                    txttofind(txtfindcount)=wert
                    andor(txtfindcount)=3
                End If 
                
                If Left(kette,14)="zusatzworkflow" Then
                    extrajob=True
                End If 
                
                If Left(kette,13)="webviewerlink" Then
                    webviewerlink=True
                End If 		
                
                If Left(kette,8)="sendfile" Then
                    sendfile=True
                End If 
                
                If Left(kette,7)="sendpdf" Then
                    sendfile=True
                    makepdf=True
                End If 
                
                If Left(kette,13)="archivtabelle" Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"archivtabelle=",1)+13))
                    If Len(wert)>1 Then
                        Tabelle(tabellencount)=wert
                        tabellencount=tabellencount+1
                    End If
                End If 
                
                If Left(LCase(kette),4)="case" Then
                    casecount=casecount+1
                    laenge=Len(kette)
                    pos1=0
                    zwischenkette=Trim(Right(kette,Len(kette)-4))
                    
                    If InStr(1,zwischenkette,"=") Then
                        pos1=InStr(1,zwischenkette,"=")
                        operator(casecount)="="
                    End If
                    
                    If InStr(1,zwischenkette,"#") Then
                        pos1=InStr(1,zwischenkette,"#")
                        operator(casecount)="#"
                    End If
                    
                    If InStr(1,zwischenkette,">") Then
                        pos1=InStr(1,zwischenkette,">")
                        operator(casecount)=">"
                    End If
                    
                    If InStr(1,zwischenkette,"<") Then
                        pos1=InStr(1,zwischenkette,"<")
                        operator(casecount)="<"
                    End If
                    
                    If InStr(1,zwischenkette,"~") Then
                        pos1=InStr(1,zwischenkette,"~")
                        operator(casecount)="~"
                    End If
                    
                    zusatzfeldname(casecount)=Trim(Left(zwischenkette,pos1-1))
                    operant(casecount)=Trim(Right(zwischenkette,Len(zwischenkette)-pos1))
                    
                    If (operator(casecount)<>">") And (operator(casecount)<>"=") And (operator(casecount)<>"<") And (operator(casecount)<>"#" And (operator(casecount)<>"~")) Then
                        operant(casecount)=""
                        operator(casecount)=""
                        Zusatzfeldname(casecount)=""
                        casecount=casecount-1
                    End If
                End If	
                
                If Left(kette,12)="nextworkflow" Then
                    wert=GetString(kette,InStr(1,kette,"nextworkflow",1)+12)
                    setworkflow=wert
                End If 
                
                If Left(kette,10)="sendmailto" Then
                    wert=Trim(Right(kette, Len(kette)-11))
                    email(emailcount)=wert
                    emailcount=emailcount+1
                End If 
                
                If Left(kette,7)="sendmsg" Then
                    laenge=Len(kette)+1
                    pos1=InStr(1,kette,"sendmsg",1)+8
                    wert=Mid(kette,pos1,laenge-pos1)
                    msgbody=wert
                End If 
                
                If Left(kette,9)="sendheadr" Then
                    laenge=Len(kette)+1
                    pos1=InStr(1,kette,"sendheadr",1)+10
                    wert=Mid(kette,pos1,laenge-pos1)
                    msgheadr=wert
                End If 
                
                If Left(kette,10)="bearbeiter" Then
                    'wert=GetString(kette,InStr(1,kette,"bearbeiter",1)+11)
                    wert = Right(kette, Len(kette)-11)
                    bearbeiter(bearbeitercount)=wert
                End If 
                
                If LCase(Left(kette,6))="termin" Then
                    wert=GetString(kette,InStr(1,kette,"termin",1)+7)
                    If InStr(wert,"%") Then
                        wert=parsestrings(wert)
                        wert=DateValue(wert)-Date()
                    End If
                    versatz(bearbeitercount)=strConvert(wert)
                End If 
                
                If LCase(Left(kette,5))="alarm" Then
                    wert=GetString(kette,InStr(1,kette,"alarm",1)+6)
                    If InStr(wert,"%") Then
                        wert=parsestrings(wert)
                        wert=DateValue(wert)-Date()-versatz(bearbeitercount)
                    End If                    
                    alarmversatz(bearbeitercount)=strconvert(wert)
                End If 
                
                If LCase(Left(kette,7))="options" Then
                    wert = Right(kette,Len(kette) -8)
                    options(bearbeitercount)=wert
                End If 
                
                If Left(kette,10)="controller" Then
                	wert=Right(kette, Len(kette) - InStr(1, kette, "="))
                    controller(bearbeitercount)=wert
                    If LCase(wert)="auslser" Then
                        controller(bearbeitercount)=benutzer
                    End If
                    bearbeitercount=bearbeitercount+1
                End If 
                
                If Left(kette,9)="controler" Then
                    wert=Right(kette, Len(kette) - InStr(1, kette, "="))
                    controller(bearbeitercount)=wert
                    If LCase(wert)="auslser" Then
                        controller(bearbeitercount)=benutzer
                    End If
                    bearbeitercount=bearbeitercount+1
                End If 
                
                If Left(kette,11)="end section" Then
                    flag1=True
                End If 
            Loop
        End If
    End If 
End Function


'*******************************************************************************************
'************************************    Kontrolle    **************************************
'*******************************************************************************************

Function workflowauswertung()
    On Error Resume Next
    workflowauswertung=False
    
    zutreffendtxt = False
    'If andor(0) = 2 Then
    '	zutreffendtxt=true
    'End If
    
    If andor(1) = 2 Then
        zutreffendtxt=True
    End If
    
    If andor(1) = 3 Then
        zutreffendtxt=True
    End If
    
    If txtfindcount > 0 Then
        i=1
        Do While i <= txtfindcount
            
            If scriptdebug = True Then
                objWshShell.LogEvent 4,"Workflow " & i & "/" & workflowcount&": Find="&txttofind(i)& " (andor= " & andor(i)& ")" &vbCrLf &Datei&" isintext:"&isintextfile(txttofind(i),Datei)
            End If
            If andor(i) = 1 Then
                zutreffendtxt = zutreffendtxt Or isintextfile(txttofind(i),Datei)
            ElseIf andor(i) = 2 Then
                zutreffendtxt = zutreffendtxt And isintextfile(txttofind(i),Datei)
            ElseIf andor(i) = 3 Then
                zutreffendtxt = zutreffendtxt And Not isintextfile(txttofind(i),Datei)
            End If
            i=i+1
        Loop
    Else
        zutreffendtxt=True
    End If
    
    zutreffendtabelle=False
    If tabellencount=0 Then
        zutreffendtabelle=True
    Else
        
        i=0
        Do While i<>tabellencount
            resulttablelenght=0
            resulttable=""	
            '###########  Fallunterscheidung * davor / dahinter / beides / keins #########
            
            If Left(tabelle(i),1)="*" Then
                If (Right(tabelle(i),1)="*") And (Len(tabelle(i))>2) Then '### beides ###
                    
                    resulttable=Right(tabelle(i),Len(tabelle(i)-1))
                    resulttable=Left(resulttable,Len(resulttable-1))
                    If Len(archiv)>=Len(resulttable) Then
                        If InStr(1,Archiv,resulttable,1)<>0 Then
                            zutreffendtabelle = True
                            If scriptdebug = True Then
                                objWshShell.LogEvent 4, "Fall1 zutreffend: Suchstring: "&tabelle(i)&" Archiv: "&Archiv
                            End If
                        End If
                    End If
                    
                Else '### davor ###
                    
                    resulttable=Right(tabelle(i),Len(tabelle(i))-1)
                    resulttablelenght=Len(resulttable)
                    If Len(Archiv)>resulttablelenght Then
                        If LCase(resulttable)=LCase(Right(Archiv,resulttablelenght)) Then
                            zutreffendtabelle = True
                            If scriptdebug = True Then
                                objWshShell.LogEvent 4, "Fall2a zutreffend: Suchstring: "&tabelle(i)&" Archiv: "&Archiv
                            End If
                        End If
                    ElseIf Len(Archiv)=resulttablelenght Then
                        If LCase(resulttable)=LCase(Archiv) Then
                            zutreffendtabelle = True
                            If scriptdebug = True Then
                                objWshShell.LogEvent 4, "Fall2b zutreffend: Suchstring: "&tabelle(i)&" Archiv: "&Archiv
                            End If
                        End If
                    End If
                    
                End If
                
                
                
            ElseIf Right(tabelle(i),1)="*" Then '### dahinter ###
                resulttable=Left(tabelle(i),Len(tabelle(i))-1)
                resulttablelenght=Len(resulttable)
                If Len(Archiv)>resulttablelenght Then
                    If LCase(resulttable)=LCase(Left(Archiv,resulttablelenght)) Then
                        zutreffendtabelle = True
                        If scriptdebug = True Then
                            objWshShell.LogEvent 4, "Fall3a zutreffend: Suchstring: "&tabelle(i)&" Archiv: "&Archiv
                        End If
                    End If
                ElseIf Len(Archiv)=resulttablelenght Then
                    If LCase(resulttable)=LCase(Archiv) Then
                        zutreffendtabelle = True
                        If scriptdebug = True Then
                            objWshShell.LogEvent 4, "Fall3b zutreffend: Suchstring: "&tabelle(i)&" Archiv: "&Archiv
                        End If			
                    End If
                End If
                
                
            Else	'### keins ###
                
                
                If LCase(tabelle(i))=LCase(Archiv) Or tabelle(i)=folderID Then
                    zutreffendtabelle = True
                    If scriptdebug = True Then
                        objWshShell.LogEvent 4, "Fall4 zutreffend: Suchstring: "&tabelle(i)&" Archiv: "&Archiv
                    End If
                End If
                
            End If	
            
            '###########################################################################
            
            
            i=i+1
        Loop
    End If
    
    
    
    
    '###################  Beginn: CASE-Auswertung #################################
    
    casecount=1
    zutreffendcasegesamt=True
    zutreffendcase=True
    If scriptdebug = True Then
        objWshShell.LogEvent 4, "Beginne CASE-late-workflow"
    End If
    Do While operator(casecount)<>""
        'objWshShell.LogEvent 0, "Trap-case1" & vbCrLf & "zusatzfeldname("&casecount&")="&zusatzfeldname(casecount) & vbCrLf & "operator("&casecount&")="&operator(casecount)  & vbCrLf &  "operant("&casecount&")="&operant(casecount)
        
        If (Zusatzfeldname(casecount)<>"") And (operator(casecount)<>"") And (operant(casecount)<>"") Then
            zutreffendcase=False
            wert=""
            gefunden=False
            x=0
            Do While gefunden=False
                If LCase(Trim(zusfeld(x)))=LCase(Trim(Zusatzfeldname(casecount))) Then
                    gefunden=True
                End If
                If gefunden=False Then
                    x=x+1
                End If
                If x>=limit Then
                    gefunden=True
                End If
            Loop
            
            If x<limit Then
                'wert=LCase(Trim(zuswert(x))
                wert=zuswert(x)
                
            End If
            
            If (viewerwf=False) And (moverwf=False) Then
                wert=getzusatzfeldwert(Zusatzfeldname(casecount))
            End If
            
            
            'operant enthlt den Wert, gegen den geprft wird
            'wenn operant ";" enthlt splitten und gegen einzelne Werte prfen
            If InStr(operant(casecount),";")<>0 Then
                orOperants=Split(operant(casecount), ";")
                orCase=False
            Else
                orOperants=False
                orCase=False
            End If
            
            If orOperants Then
                For operantIndex = 0 To UBound(orOperants)
                    thisOperant = orOperants(operantIndex)
                    If Left(thisOperant,1)="$" Or Not IsNumeric(thisOperant) Then
                        If Left(thisOperant,1)="$" Then
                            thisOperant=Right(thisOperant,Len(thisOperant)-1)
                        End If 
                        If operator(casecount)="=" Then
                            'MsgBox("hier!")
                            'MsgBox("operant:"&operant(casecount)&":wert:"&wert)
                            If LCase(wert)=LCase(thisOperant) Then
                                zutreffendcase=True
                            Else
                                zutreffendcase=False
                            End If
                        End If
                        If operator(casecount)="#" Then
                            If LCase(wert)<>LCase(thisOperant) Then
                                zutreffendcase=True
                            Else
                                zutreffendcase=False
                            End If
                        End If
                        If operator(casecount)="~" Then
                            If InStr(1,LCase(wert),LCase(thisOperant))<>0 Then
                                zutreffendcase=True
                            Else
                                zutreffendcase=False
                            End If
                        End If
                        
                    Else	
                        If LCase(thisOperant) <> "true" And LCase(thisOperant) <> "false" Then
                            valoperant=strconvert(thisOperant)
                            'valwert=strconvert(wert)
                            valwert=valconvert(wert)
                        Else
                            valoperant=LCase(thisOperant)
                            'valwert=strconvert(wert)
                            valwert=LCase(wert)
                            
                        End If 
                        
                        
                        If operator(casecount)="=" Then
                            If valwert=valoperant Then
                                zutreffendcase=True
                            Else
                                zutreffendcase=False
                            End If
                        End If
                        If operator(casecount)="#" Then
                            
                            If valwert<>valoperant Then
                                zutreffendcase=True
                            Else
                                zutreffendcase=False
                            End If
                        End If
                        If operator(casecount)=">" Then
                            If valwert>valoperant Then
                                zutreffendcase=True
                            Else
                                zutreffendcase=False
                            End If
                        End If
                        If operator(casecount)="<" Then
                            If valwert<valoperant Then
                                zutreffendcase=True
                            Else
                                zutreffendcase=False
                            End If
                        End If
                    End If
                    If zutreffendcase=True Then
                        orCase = True
                    End If
                Next
                
            Else
                If Left(operant(casecount),1)="$" Or Not IsNumeric(operant(casecount)) Then
                    If Left(operant(casecount),1)="$" Then
                        operant(casecount)=Right(operant(casecount),Len(operant(casecount))-1)
                    End If 
                    If operator(casecount)="=" Then
                        'MsgBox("hier!")
                        'MsgBox("operant:"&operant(casecount)&":wert:"&wert)
                        If LCase(wert)=LCase(operant(casecount)) Then
                            zutreffendcase=True
                        Else
                            zutreffendcase=False
                        End If
                    End If
                    If operator(casecount)="#" Then
                        If LCase(wert)<>LCase(operant(casecount)) Then
                            zutreffendcase=True
                        Else
                            zutreffendcase=False
                        End If
                    End If
                    If operator(casecount)="~" Then
                        If InStr(1,LCase(wert),LCase(operant(casecount)))<>0 Then
                            zutreffendcase=True
                        Else
                            zutreffendcase=False
                        End If
                    End If
                    
                Else	
                    
                    If LCase(operant(casecount)) <> "true" And LCase(operant(casecount)) <> "false" Then
                        valoperant=strconvert(operant(casecount))
                        'valwert=strconvert(wert)
                        valwert=valconvert(wert)
                    Else
                        valoperant=LCase(operant(casecount))
                        'valwert=strconvert(wert)
                        valwert=LCase(wert)
                        
                    End If 
                    
                    
                    If operator(casecount)="=" Then
                        If valwert=valoperant Then
                            zutreffendcase=True
                        Else
                            zutreffendcase=False
                        End If
                    End If
                    If operator(casecount)="#" Then
                        
                        If valwert<>valoperant Then
                            zutreffendcase=True
                        Else
                            zutreffendcase=False
                        End If
                    End If
                    If operator(casecount)=">" Then
                        If valwert>valoperant Then
                            zutreffendcase=True
                        Else
                            zutreffendcase=False
                        End If
                    End If
                    If operator(casecount)="<" Then
                        If valwert<valoperant Then
                            zutreffendcase=True
                        Else
                            zutreffendcase=False
                        End If
                    End If
                End If
            End If
            
        Else
            zutreffendcase=True
        End If
        
        If orCase = True Then
            zutreffendcase=True
        End If
        
        If scriptdebug=True Then
            
            objWshShell.LogEvent 4, "Workflow-Debug: CASE-Analyse(1): Ergebnis:"&zutreffendcase & vbCrLf & "zusatzfeldname("&casecount&")="&zusatzfeldname(casecount) & vbCrLf & "operator("&casecount&")="&operator(casecount)  & vbCrLf &  "operant("&casecount&")="&operant(casecount)& vbCrLf & "wert:" & wert
            
        End If
        casecount=casecount+1
        
        If (zutreffendcase=True) And (zutreffendcasegesamt=True) Then
            zutreffendcasegesamt=True
        Else
            zutreffendcasegesamt=False
        End If
        
    Loop
    
    zutreffendcase=zutreffendcasegesamt
    
    
    '##################### fertig: case analyse #############
    
    
    If scriptdebug=True Then
        tabellen=""
        x=0
        Do While x<=tabellencount
            tabellen=tabellen&x&":"&tabelle(x)&vbCrLf
            x=x+1
        Loop
        
        andindocuments=""
        x=1
        Do While x<=txtfindcount
            andindocuments=andindocuments&x&":"&txttofind(x)&":"&andor(x)&vbCrLf
            x=x+1
        Loop
        
        casecondition=""
        x=0
        Do While x<casecount
            casecondition=casecondition&vbCrLf&"Zusatzfeldname: "&zusatzfeldname(x)&vbCrLf&"Operator: "&operator(x)&vbCrLf&"Operant: "&operant(x)
            x=x+1
        Loop
        objWshShell.LogEvent 4, "bitfarm-Archiv Workflow-Debug: Workflowauswertung fr ein Dokument aus "&Archiv&vbCrLf & "Workflow:" & workflowcount & vbCrLf &"Archivtabelle="&zutreffendtabelle&vbCrLf& "andindocument= "&zutreffendtxt&vbCrLf&"CASE= "&zutreffendcase& vbCrLf&"ARCHIVTABELLEN:"&vbCrLf&tabellen&vbCrLf&"ANDINDOCUMENTS:"&vbCrLf&andindocuments&vbCrLf&casecondition
        
    End If
    
    If (zutreffendtabelle = True) And (zutreffendtxt = True) And (zutreffendcase = True) Then
        
        workflowauswertung = True
    End If
    For ii = 0 To limit
        zusatzfeldname(ii)=""
        operator(ii)=""
        operant(ii)=""
    Next 
    wert=""
    casecount=0
    
End Function 


'*******************************************************************************************
'****************************************   Workflow-aktion   ******************************
'*******************************************************************************************


Function workflowaktion()
    On Error Resume Next
    
    resolvevariables()
    
    runplugin(workflowplugin)
    
    workflowID="0"
    
    If exportpath<>"" Then
        ' createnewjobfile nach exportpath
        ' exportscript prfen und gffs. ausfhren
        If arc = "" And doc = "" Then
            dokidsplit=Split(dokid,".")
            arc = dokidsplit(0)
            doc = dokidsplit(1)
        End If

        Set oExec    = objWSHShell.Exec(Chr(34)&programm&"createnewjobfile.exe" &Chr(34)& " " &profil&" "&arc&" "&doc&" "&Chr(34)&exportpath&arc&"."&doc&Chr(34))
        Do While Not oExec.StdOut.AtEndOfStream
            strinput = strinput & oExec.StdOut.Read(1)	
        Loop

        Set oexec=Nothing
        objWSHShell.LogEvent 0, Chr(34) &exportscript & Chr(34) & " " & Chr(34)&exportpath&arc&"."&doc&".job"&Chr(34)
        If fs.FileExists(exportscript) Then
            rc = objWSHShell.Run(Chr(34) &exportscript & Chr(34) & " " & Chr(34)&exportpath&arc&"."&doc&".job"&Chr(34) ,0,False)	
        End If
        
    End If
    
    If emailcount > 0 Then
        t=0
        Do While t<>emailcount
            'WScript.sleep 500
            'MsgBox(t&":"&emailcount)
            If sendfile=False Then
                sendlinkmail(email(t))
            Else
                sendfilemail(email(t))
            End If
            t=t+1
        Loop
        
    End If
    
    
    
    If bearbeitercount > 0 Then
        bearbeiterzaehler=0
        Do While bearbeiterzaehler<bearbeitercount
            
            wiedervorlage()
            bearbeiterzaehler=bearbeiterzaehler+1
            
        Loop
    End If
    
    If setworkflow <> "" Then
        workflowID = createworkfile()
    End If
    
    
    
End Function 



'*******************************************************************************************
'****************************  lesen eines spten workflows  *****************************
'*******************************************************************************************

Function late_workflowlesen()
    On Error Resume Next
    late_workflowlesen = False
    
    If Left(kette,1)<>";" Then
        If LCase(Left(kette,21))="late-workflow section" Then
            late_workflowlesen=True
            workflowcount=workflowcount+1
            flag1 = False
            tabellencount=0
            casecount=0
            emailcount = 0
            bearbeitercount = 0
            txtfindcount = 0
            bodytxt = ""
            headertxt = ""
            setworkflow=""
            sendfile=False
            makepdf=False
            webviewerlink=False
            msgbody=""
            exportpath=""
            exportscript=""
            For ii = 0 To limit
                txttofind(ii)=""
                andor(ii)=0
                zusatzfeldname(ii)=""
                operator(ii)=""
                operant(ii)=""
                versatz(ii)=0
                alarmversatz(ii)=Empty
            Next 
            andor(1)=2
            
            
            Do While flag1 = False 
                If wfdatei.AtEndOfStream=False Then
                    kette = Trim(Replace(Trim(wfdatei.readline), vbTab, ""))
                Else 
                    flag1=True
                    'endflag=true
                End If
                
                If Left(kette,11)="end section" Then
                    flag1 = True
                End If
                
                
                If Left(kette,12)="orindocument" Then
                    txtfindcount=txtfindcount+1
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"orindocument=",1)+12))
                    'wert=GetString(kette,InStr(1,kette,"orindocument",1)+12)
                    txttofind(txtfindcount)=wert
                    andor(txtfindcount)=1
                    
                End If 
                
                If Left(kette,13)="andindocument" Then
                    txtfindcount=txtfindcount+1
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"andindocument=",1)+13))
                    'wert=GetString(kette,InStr(1,kette,"andindocument",1)+13)
                    txttofind(txtfindcount)=wert
                    andor(txtfindcount)=2
                    
                End If 
                
                If Left(kette,5)="nowvl" Then
                    nowvl = True
                End If
                                
                If Left(kette,10)="exportpath" Then
                    laenge=Len(kette)+1
                    pos1=InStr(1,kette,"exportpath",1)+11
                    wert=Mid(kette,pos1,laenge-pos1)
                    exportpath=wert
                    If Right(exportpath,1)<>"\" Then
                        exportpath=exportpath&"\"
                    End If
                End If
                
                If Left(kette,12)="exportscript" Then
                    laenge=Len(kette)+1
                    pos1=InStr(1,kette,"exportscript",1)+13
                    wert=Mid(kette,pos1,laenge-pos1)
                    exportscript=wert
                End If
                
                If Left(kette,13)="notindocument" Then
                    txtfindcount=txtfindcount+1
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"notindocument=",1)+13))
                    'wert=GetString(kette,InStr(1,kette,"andindocument",1)+13)
                    txttofind(txtfindcount)=wert
                    andor(txtfindcount)=3
                End If 
                
                If Left(kette,14)="zusatzworkflow" Then
                    extrajob=True
                End If 
                
                If Left(kette,14)="webviewerlink" Then
                    webviewerlink=True
                End If 
                
                If Left(kette,8)="sendfile" Then
                    sendfile=True
                End If 
                
                If Left(kette,7)="sendpdf" Then
                    sendfile=True
                    makepdf=True
                End If 
                
                If Left(kette,13)="archivtabelle" Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"archivtabelle=",1)+13))
                    If Len(wert)>1 Then
                        Tabelle(tabellencount)=wert
                        tabellencount=tabellencount+1
                    End If
                End If 
                
                
                If Left(LCase(kette),4)="case" Then
                    casecount=casecount+1
                    laenge=Len(kette)
                    pos1=0
                    zwischenkette=Trim(Right(kette,Len(kette)-4))
                    
                    If InStr(1,zwischenkette,"=") Then
                        pos1=InStr(1,zwischenkette,"=")
                        operator(casecount)="="
                    End If
                    
                    If InStr(1,zwischenkette,"#") Then
                        pos1=InStr(1,zwischenkette,"#")
                        operator(casecount)="#"
                    End If
                    
                    If InStr(1,zwischenkette,">") Then
                        pos1=InStr(1,zwischenkette,">")
                        operator(casecount)=">"
                    End If
                    
                    If InStr(1,zwischenkette,"<") Then
                        pos1=InStr(1,zwischenkette,"<")
                        operator(casecount)="<"
                    End If
                    
                    zusatzfeldname(casecount)=Trim(Left(zwischenkette,pos1-1))
                    operant(casecount)=Trim(Right(zwischenkette,Len(zwischenkette)-pos1))
                    
                    If (operator(casecount)<>">") And (operator(casecount)<>"=") And (operator(casecount)<>"<") And (operator(casecount)<>"#") Then
                        operant(casecount)=""
                        operator(casecount)=""
                        Zusatzfeldname(casecount)=""
                        casecount=casecount-1
                    End If
                End If	
                
                
                If Left(kette,12)="nextworkflow" Then
                    wert=GetString(kette,InStr(1,kette,"nextworkflow",1)+12)
                    setworkflow=wert
                End If 
                
                If Left(kette,10)="sendmailto" Then
                    wert=Trim(Right(kette, Len(kette)-11))
                    email(emailcount)=wert
                    emailcount=emailcount+1
                    
                End If 
                
                If Left(kette,7)="sendmsg" Then
                    laenge=Len(kette)+1
                    pos1=InStr(1,kette,"sendmsg",1)+8
                    wert=Mid(kette,pos1,laenge-pos1)
                    msgbody=wert
                End If 
                
                If Left(kette,9)="sendheadr" Then
                    laenge=Len(kette)+1
                    pos1=InStr(1,kette,"sendheadr",1)+10
                    wert=Mid(kette,pos1,laenge-pos1)
                    msgheadr=wert
                End If 
                
                If Left(kette,10)="bearbeiter" Then
                    'wert=GetString(kette,InStr(1,kette,"bearbeiter",1)+11)
                    wert = Right(kette, Len(kette)-11)
                    bearbeiter(bearbeitercount)=wert
                    
                    
                End If 
                
                If LCase(Left(kette,6))="termin" Then
                    wert=GetString(kette,InStr(1,kette,"termin",1)+7)
                    If InStr(wert,"%") Then
                        wert=parsestrings(wert)
                        wert=DateValue(wert)-Date()
                    End If                    
                    versatz(bearbeitercount)=strconvert(wert)
                    
                    
                End If 
                
                If LCase(Left(kette,5))="alarm" Then
                    wert=GetString(kette,InStr(1,kette,"alarm",1)+6)
                    If InStr(wert,"%") Then
                        wert=parsestrings(wert)
                        wert=DateValue(wert)-Date()-versatz(bearbeitercount)
                    End If                        
                    alarmversatz(bearbeitercount)=strconvert(wert)
                    
                    
                End If 
                
                If LCase(Left(kette,7))="options" Then
                    wert = Right(kette,Len(kette) -8)
                    options(bearbeitercount)=wert
                    
                End If 
                
                If Left(kette,10)="controller" Then
                    wert=GetString(kette,InStr(1,kette,"controller",1)+11)
                    controller(bearbeitercount)=wert
                    If LCase(wert)="auslser" Then
                        controller(bearbeitercount)=benutzer
                    End If
                    bearbeitercount=bearbeitercount+1
                    
                End If 
                
                If Left(kette,9)="controler" Then
                    wert=GetString(kette,InStr(1,kette,"controler",1)+10)
                    controller(bearbeitercount)=wert
                    If LCase(wert)="auslser" Then
                        controller(bearbeitercount)=benutzer
                    End If
                    bearbeitercount=bearbeitercount+1
                    
                End If 
                
                
                If Left(kette,11)="end section" Then
                    flag1=True
                End If 
                
            Loop
        End If
        
    End If 
End Function


'*******************************************************************************************
'****************************  lesen eines spten workflows  *****************************
'*******************************************************************************************

Function interval_workflowlesen()
    On Error Resume Next
    interval_workflowlesen = False
    
    If Left(kette,1)<>";" Then
        If LCase(Left(kette,25))="interval-workflow section" Then
            interval_workflowlesen=True
            workflowcount=workflowcount+1
            flag1 = False
            tabellencount=0
            casecount=0
            emailcount = 0
            bearbeitercount = 0
            txtfindcount = 0
            bodytxt = ""
            headertxt = ""
            setworkflow=""
            sendfile=False
            webviewerlink=False
            exportpath=""
            exportscript=""
            makepdf=False
            For ii = 0 To limit
                txttofind(ii)=""
                andor(ii)=0
                zusatzfeldname(ii)=""
                operator(ii)=""
                operant(ii)=""
                versatz(ii)=0
                alarmversatz(ii)=Empty
            Next 
            andor(1)=2
            
            
            Do While flag1 = False 
                If wfdatei.AtEndOfStream=False Then
                    kette = Trim(Replace(Trim(wfdatei.readline), vbTab, ""))
                Else 
                    flag1=True
                    'endflag=true
                End If
                
                If Left(kette,11)="end section" Then
                    flag1 = True
                End If
                
                If Left(kette,5)="nowvl" Then
                    nowvl = True
                End If
                
                
                If Left(kette,12)="orindocument" Then
                    txtfindcount=txtfindcount+1
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"orindocument=",1)+12))
                    'wert=GetString(kette,InStr(1,kette,"orindocument",1)+12)
                    txttofind(txtfindcount)=wert
                    andor(txtfindcount)=1
                    
                End If 
                
                If Left(kette,13)="andindocument" Then
                    txtfindcount=txtfindcount+1
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"andindocument=",1)+13))
                    'wert=GetString(kette,InStr(1,kette,"andindocument",1)+13)
                    txttofind(txtfindcount)=wert
                    andor(txtfindcount)=2
                    
                    
                End If 
                
                
                If Left(kette,10)="exportpath" Then
                    laenge=Len(kette)+1
                    pos1=InStr(1,kette,"exportpath",1)+11
                    wert=Mid(kette,pos1,laenge-pos1)
                    exportpath=wert
                    If Right(exportpath,1)<>"\" Then
                        exportpath=exportpath&"\"
                    End If
                End If
                
                If Left(kette,12)="exportscript" Then
                    laenge=Len(kette)+1
                    pos1=InStr(1,kette,"exportscript",1)+13
                    wert=Mid(kette,pos1,laenge-pos1)
                    exportscript=wert
                End If
                
                If Left(kette,13)="notindocument" Then
                    txtfindcount=txtfindcount+1
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"notindocument=",1)+13))
                    'wert=GetString(kette,InStr(1,kette,"andindocument",1)+13)
                    txttofind(txtfindcount)=wert
                    andor(txtfindcount)=3
                End If 
                
                
                
                If Left(kette,14)="zusatzworkflow" Then
                    extrajob=True
                End If 
                
                If Left(kette,14)="webviewerlink" Then
                    webviewerlink=True
                End If 
                
                If Left(kette,8)="sendfile" Then
                    sendfile=True
                End If 
                
                If Left(kette,7)="sendpdf" Then
                    sendfile=True
                    makepdf=True
                End If 
                
                If Left(kette,13)="archivtabelle" Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"archivtabelle=",1)+13))
                    If Len(wert)>1 Then
                        Tabelle(tabellencount)=wert
                        tabellencount=tabellencount+1
                    End If
                End If 
                
                
                If Left(LCase(kette),4)="case" Then
                    casecount=casecount+1
                    laenge=Len(kette)
                    pos1=0
                    zwischenkette=Trim(Right(kette,Len(kette)-4))
                    
                    If InStr(1,zwischenkette,"=") Then
                        pos1=InStr(1,zwischenkette,"=")
                        operator(casecount)="="
                    End If
                    
                    If InStr(1,zwischenkette,"#") Then
                        pos1=InStr(1,zwischenkette,"#")
                        operator(casecount)="#"
                    End If
                    
                    If InStr(1,zwischenkette,">") Then
                        pos1=InStr(1,zwischenkette,">")
                        operator(casecount)=">"
                    End If
                    
                    If InStr(1,zwischenkette,"<") Then
                        pos1=InStr(1,zwischenkette,"<")
                        operator(casecount)="<"
                    End If
                    
                    zusatzfeldname(casecount)=Trim(Left(zwischenkette,pos1-1))
                    operant(casecount)=Trim(Right(zwischenkette,Len(zwischenkette)-pos1))
                    
                    If (operator(casecount)<>">") And (operator(casecount)<>"=") And (operator(casecount)<>"<") And (operator(casecount)<>"#") Then
                        operant(casecount)="Fehler"
                        operator(casecount)="Fehler"
                        Zusatzfeldname(casecount)="Fehler"
                        casecount=casecount-1
                    End If
                    
                    
                End If	
                
                
                
                If Left(kette,12)="nextworkflow" Then
                    wert=GetString(kette,InStr(1,kette,"nextworkflow",1)+12)
                    setworkflow=wert
                End If 
                
                If Left(kette,10)="sendmailto" Then
                    wert=Trim(Right(kette, Len(kette)-11))
                    email(emailcount)=wert
                    emailcount=emailcount+1
                    
                End If 
                
                If Left(kette,7)="sendmsg" Then
                    laenge=Len(kette)+1
                    pos1=InStr(1,kette,"sendmsg",1)+8
                    wert=Mid(kette,pos1,laenge-pos1)
                    msgbody=wert
                End If 
                
                If Left(kette,9)="sendheadr" Then
                    laenge=Len(kette)+1
                    pos1=InStr(1,kette,"sendheadr",1)+10
                    wert=Mid(kette,pos1,laenge-pos1)
                    msgheadr=wert
                End If 
                
                If Left(kette,10)="bearbeiter" Then
                    'wert=GetString(kette,InStr(1,kette,"bearbeiter",1)+11)
                    wert = Right(kette, Len(kette)-11)
                    bearbeiter(bearbeitercount)=wert
                    
                    
                End If 
                
                If LCase(Left(kette,6))="termin" Then
                    wert=GetString(kette,InStr(1,kette,"termin",1)+7)
                    If InStr(wert,"%") Then
                        wert=parsestrings(wert)
                        wert=DateValue(wert)-Date()
                    End If                    
                    versatz(bearbeitercount)=strconvert(wert)
                    
                    
                End If 
                
                If LCase(Left(kette,5))="alarm" Then
                    wert=GetString(kette,InStr(1,kette,"alarm",1)+6)
                    If InStr(wert,"%") Then
                        wert=parsestrings(wert)
                        wert=DateValue(wert)-Date()-versatz(bearbeitercount)
                    End If                        
                    alarmversatz(bearbeitercount)=strconvert(wert)
                    
                    
                End If 
                
                If LCase(Left(kette,7))="options" Then
                    wert = Right(kette,Len(kette) -8)
                    options(bearbeitercount)=wert
                    
                End If 
                
                If Left(kette,10)="controller" Then
                    wert=GetString(kette,InStr(1,kette,"controller",1)+11)
                    controller(bearbeitercount)=wert
                    If LCase(wert)="auslser" Then
                        controller(bearbeitercount)=benutzer
                    End If
                    bearbeitercount=bearbeitercount+1
                    
                End If 
                
                If Left(kette,9)="controler" Then
                    wert=GetString(kette,InStr(1,kette,"controler",1)+10)
                    controller(bearbeitercount)=wert
                    If LCase(wert)="auslser" Then
                        controller(bearbeitercount)=benutzer
                    End If
                    bearbeitercount=bearbeitercount+1
                    
                End If 
                
                
                If Left(kette,11)="end section" Then
                    flag1=True
                End If 
                
            Loop
        End If
        
    End If 
End Function


'*******************************************************************************************
'****************************  bearbeitung eines continue workflows  ***********************
'*******************************************************************************************

Function continuelesen()
    On Error Resume Next
    continuelesen=False
    If Left(kette,1)<>";" Then
        If InStr(1,kette,"continue section",1)<>0 Then
            continuelesen=True
            continue=""
            workflowcount=workflowcount+1
            flag1 = False
            tabellencount=0
            emailcount = 0
            txtfindcount = 0
            casecount = 0
            bearbeitercount=0
            bodytxt = ""
            headertxt = ""
            setworkflow=""
            zusatzfeldname(casecount)=""
            operator(casecount)=""
            operant(casecount)=""
            msgbody=""
            exportpath=""
            exportscript=""
            
            For ii = 0 To limit
                txttofind(ii)=""
                andor(ii)=0
                zusatzfeldname(ii)=""
                operator(ii)=""
                operant(ii)=""
                versatz(ii)=0
                alarmversatz(ii)=Empty
            Next 
            andor(1)=2
            
            Do While flag1 = False 
                kette = Trim(Replace(Trim(wfdatei.readline), vbTab, ""))
                If Left(kette,11)="end section" Then
                    flag1 = True
                End If
                
                If Left(kette,12)="orindocument" Then
                    txtfindcount=txtfindcount+1
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"orindocument=",1)+12))
                    'wert=GetString(kette,InStr(1,kette,"orindocument",1)+12)
                    txttofind(txtfindcount)=wert
                    andor(txtfindcount)=1
                    
                End If 
                
                If Left(kette,13)="andindocument" Then
                    txtfindcount=txtfindcount+1
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"andindocument=",1)+13))
                    'wert=GetString(kette,InStr(1,kette,"andindocument",1)+13)
                    txttofind(txtfindcount)=wert
                    andor(txtfindcount)=2
                    
                End If 
                
                If Left(kette,5)="nowvl" Then
                    nowvl = True
                End If
                
                If Left(kette,13)="notindocument" Then
                    txtfindcount=txtfindcount+1
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"notindocument=",1)+13))
                    'wert=GetString(kette,InStr(1,kette,"andindocument",1)+13)
                    txttofind(txtfindcount)=wert
                    andor(txtfindcount)=3
                    
                End If 
                
                
                If Left(LCase(kette),4)="case" Then
                    casecount=casecount+1
                    laenge=Len(kette)
                    pos1=0
                    zwischenkette=Trim(Right(kette,Len(kette)-4))
                    
                    If InStr(1,zwischenkette,"=") Then
                        pos1=InStr(1,zwischenkette,"=")
                        operator(casecount)="="
                    End If
                    
                    If InStr(1,zwischenkette,"#") Then
                        pos1=InStr(1,zwischenkette,"#")
                        operator(casecount)="#"
                    End If
                    
                    If InStr(1,zwischenkette,">") Then
                        pos1=InStr(1,zwischenkette,">")
                        operator(casecount)=">"
                    End If
                    
                    If InStr(1,zwischenkette,"<") Then
                        pos1=InStr(1,zwischenkette,"<")
                        operator(casecount)="<"
                    End If
                    
                    If InStr(1,zwischenkette,"~") Then
                        pos1=InStr(1,zwischenkette,"~")
                        operator(casecount)="~"
                    End If 
                    
                    zusatzfeldname(casecount)=Trim(Left(zwischenkette,pos1-1))
                    operant(casecount)=Trim(Right(zwischenkette,Len(zwischenkette)-pos1))
                    
                    If (operator(casecount)<>">") And (operator(casecount)<>"=") And (operator(casecount)<>"<") And (operator(casecount)<>"#") And (operator(casecount)<>"~") Then
                        operant(casecount)=""
                        operator(casecount)=""
                        Zusatzfeldname(casecount)=""
                        casecount=casecount-1
                    End If
                End If	
                
                If Left(kette,14)="zusatzworkflow" Then
                    extrajob=True
                End If 
                
                If Left(kette,8)="sendfile" Then
                    sendfile=True
                End If 
                
                If Left(kette,7)="sendpdf" Then
                    sendfile=True
                    makepdf=True
                End If 
                
                If Left(kette,13)="archivtabelle" Then
                    wert=GetString(kette,InStr(1,kette,"archivtabelle",1)+13)
                    If Len(wert)>1 Then
                        Tabelle(tabellencount)=wert
                        tabellencount=tabellencount+1
                    End If
                End If 
                
                If Left(kette,8)="continue" Then
                    wert=GetString(kette,InStr(1,kette,"continue",1)+8)
                    continue=wert
                End If 
                
                
                If Left(kette,12)="nextworkflow" Then
                    wert=GetString(kette,InStr(1,kette,"nextworkflow",1)+12)
                    setworkflow=wert
                End If 
                
                If Left(kette,10)="sendmailto" Then
                    wert=Trim(Right(kette, Len(kette)-11))
                    email(emailcount)=wert
                    emailcount=emailcount+1
                    
                End If 
                
                If Left(kette,7)="sendmsg" Then
                    laenge=Len(kette)+1
                    pos1=InStr(1,kette,"sendmsg",1)+8
                    wert=Mid(kette,pos1,laenge-pos1)
                    msgbody=wert
                End If 
                
                If Left(kette,10)="exportpath" Then
                    laenge=Len(kette)+1
                    pos1=InStr(1,kette,"exportpath",1)+11
                    wert=Mid(kette,pos1,laenge-pos1)
                    exportpath=wert
                    If Right(exportpath,1)<>"\" Then
                        exportpath=exportpath&"\"
                    End If
                End If
                
                If Left(kette,12)="exportscript" Then
                    laenge=Len(kette)+1
                    pos1=InStr(1,kette,"exportscript",1)+13
                    wert=Mid(kette,pos1,laenge-pos1)
                    exportscript=wert
                End If
                
                If Left(kette,9)="sendheadr" Then
                    laenge=Len(kette)+1
                    pos1=InStr(1,kette,"sendheadr",1)+10
                    wert=Mid(kette,pos1,laenge-pos1)
                    msgheadr=wert
                End If 
                
                If Left(kette,10)="bearbeiter" Then
                    'wert=GetString(kette,InStr(1,kette,"bearbeiter",1)+11)
                    wert = Right(kette, Len(kette)-11)
                    bearbeiter(bearbeitercount)=wert
                    
                    
                End If 
                
                If LCase(Left(kette,6))="termin" Then
                    wert=GetString(kette,InStr(1,kette,"termin",1)+7)
                    If InStr(wert,"%") Then
                        wert=parsestrings(wert)
                        wert=DateValue(wert)-Date()
                    End If
                    versatz(bearbeitercount)=strconvert(wert)
                    
                    
                End If 
                
                If LCase(Left(kette,5))="alarm" Then
                    wert=GetString(kette,InStr(1,kette,"alarm",1)+6)
                    If InStr(wert,"%") Then
                        wert=parsestrings(wert)
                        wert=DateValue(wert)-Date()-versatz(bearbeitercount)
                    End If                        
                    alarmversatz(bearbeitercount)=strconvert(wert)
                    
                    
                End If 
                
                If LCase(Left(kette,7))="options" Then
                    wert = Right(kette,Len(kette) -8)
                    options(bearbeitercount)=wert
                    
                End If 
                
                If Left(kette,10)="controller" Then
                    wert=GetString(kette,InStr(1,kette,"controller",1)+11)
                    controller(bearbeitercount)=wert
                    If LCase(wert)="auslser" Then
                        controller(bearbeitercount)=benutzer
                    End If
                    bearbeitercount=bearbeitercount+1
                    
                End If 
                
                If Left(kette,9)="controler" Then
                    wert=GetString(kette,InStr(1,kette,"controler",1)+10)
                    controller(bearbeitercount)=wert
                    If LCase(wert)="auslser" Then
                        controller(bearbeitercount)=benutzer
                    End If
                    bearbeitercount=bearbeitercount+1
                    
                End If 
                
                If Left(kette,11)="end section" Then
                    flag1=True
                End If 
                
            Loop
        End If
    End If 
End Function
'*******************************************************************************************
'****************************************   Aktion continue  *******************************
'*******************************************************************************************
Function continueaktion()
    On Error Resume Next
    
    resolvevariables()	
    
    runplugin(workflowplugin)
    
    
    workflowID="0"
    
    '	If setworkflow <> "" Then
    '		workflowID = createwrkfile()
    '	End If
    'MsgBox(emailcount&":"&sendfile)	
    
    If emailcount > 0 Then
        t=0
        Do While t<>emailcount
            'WScript.sleep 500
            'MsgBox(t&":"&emailcount)
            If sendfile=False Then
                sendlinkmail(email(t))
            Else
                sendfilemail(email(t))
            End If
            t=t+1
        Loop
        
    End If
    
    If exportpath<>"" Then
        testvar=0
        Set oExec    = objWSHShell.Exec(Chr(34)&programm&"createnewjobfile.exe"& Chr(34)&" "&profil&" "&arc&" "&doc&" "&Chr(34)&exportpath&arc&"."&doc&Chr(34))
        Do While Not oExec.StdOut.AtEndOfStream
            strinput = strinput & oExec.StdOut.Read(1)	
        Loop
        Set oexec=Nothing
        
        objWSHShell.LogEvent 0, Chr(34) &exportscript & Chr(34) & " " & Chr(34)&exportpath&arc&"."&doc&".job"&Chr(34)
        
        If fs.FileExists(exportscript) Then
            rc = objWSHShell.Run(Chr(34) &exportscript & Chr(34) & " " & Chr(34)&exportpath&arc&"."&doc&".job"&Chr(34) ,0,False)	
        End If
        ' createnewjobfile nach exportpath
        ' exportscript prfen und gffs. ausfhren
    End If
    
    If bearbeitercount > 0 Then
        bearbeiterzaehler=0
        Do While bearbeiterzaehler<bearbeitercount
            
            wiedervorlage()
            bearbeiterzaehler=bearbeiterzaehler+1
            
        Loop
    End If
    
    If setworkflow <> "" Then
        workflowID = createworkfile()
    End If
    
    
    
End Function 


'*******************************************************************************************
'************************************    continue-auswertung    ****************************
'*******************************************************************************************

Function continueauswertung ()
    On Error Resume Next
    If scriptdebug = True Then
        objWshShell.LogEvent 4, "Workflow.vbs: hier startet die continue-auswertung"
    End If
    continueauswertung = False
    zutreffendtxt = False
    If andor(1) = 2 Then
        zutreffendtxt=True
    End If
    
    If andor(1) = 3 Then
        zutreffendtxt=True
    End If
    
    If txtfindcount > 0 Then
        i=1
        
        
        
        Do While i <= txtfindcount
            'objWshShell.LogEvent 1, "****** i: "&i&"  txttofind(i): "&txttofind(i)&"  andor(i): "&andor(i)
            
            
            If scriptdebug = True Then
                objWshShell.LogEvent 4,"Workflow-continue " & i & "/" & workflowcount&": Find="&txttofind(i)& " (andor= " & andor(i)& ")" &vbCrLf &Datei&" isintext:"&isintextfile(txttofind(i),Datei)
            End If
            
            
            
            If andor(i) = 1 Then
                zutreffendtxt = zutreffendtxt Or isintextfile(txttofind(i),Datei)
            ElseIf andor(i)=2 Then
                zutreffendtxt = zutreffendtxt And isintextfile(txttofind(i),Datei)
            Else
                zutreffendtxt = zutreffendtxt And Not isintextfile(txttofind(i),Datei)
            End If
            i=i+1
            
            'objWshShell.LogEvent 1, "*****##### zutreffendtxt: "&zutreffendtxt
            
        Loop
    Else
        zutreffendtxt=True
    End If
    
    zutreffendtabelle=False
    If tabellencount=0 Then
        zutreffendtabelle=True
    Else
        i=0
        Do While i<>tabellencount
            
            
            resulttablelenght=0
            resulttable=""	
            '###########  Fallunterscheidung * davor / dahinter / beides / keins #########
            
            If Left(tabelle(i),1)="*" Then
                If (Right(tabelle(i),1)="*") And (Len(tabelle(i))>2) Then '### beides ###
                    
                    resulttable=Right(tabelle(i),Len(tabelle(i)-1))
                    resulttable=Left(resulttable,Len(resulttable-1))
                    If Len(archiv)>=Len(resulttable) Then
                        If InStr(1,Archiv,resulttable,1)<>0 Then
                            zutreffendtabelle = True
                            If scriptdebug = True Then
                                objWshShell.LogEvent 4, "Fall1 zutreffend: Suchstring: "&tabelle(i)&" Archiv: "&Archiv
                            End If
                        End If
                    End If
                    
                Else '### davor ###
                    
                    resulttable=Right(tabelle(i),Len(tabelle(i))-1)
                    resulttablelenght=Len(resulttable)
                    If Len(Archiv)>resulttablelenght Then
                        If LCase(resulttable)=LCase(Right(Archiv,resulttablelenght)) Then
                            zutreffendtabelle = True
                            If scriptdebug = True Then
                                objWshShell.LogEvent 4, "Fall2a zutreffend: Suchstring: "&tabelle(i)&" Archiv: "&Archiv
                            End If
                        End If
                    ElseIf Len(Archiv)=resulttablelenght Then
                        If LCase(resulttable)=LCase(Archiv) Then
                            zutreffendtabelle = True
                            If scriptdebug = True Then
                                objWshShell.LogEvent 4, "Fall2b zutreffend: Suchstring: "&tabelle(i)&" Archiv: "&Archiv
                            End If
                        End If
                    End If
                    
                End If
                
                
                
            ElseIf Right(tabelle(i),1)="*" Then '### dahinter ###
                resulttable=Left(tabelle(i),Len(tabelle(i))-1)
                resulttablelenght=Len(resulttable)
                If Len(Archiv)>resulttablelenght Then
                    If LCase(resulttable)=LCase(Left(Archiv,resulttablelenght)) Then
                        zutreffendtabelle = True
                        If scriptdebug = True Then
                            objWshShell.LogEvent 4, "Fall3a zutreffend: Suchstring: "&tabelle(i)&" Archiv: "&Archiv
                        End If
                    End If
                ElseIf Len(Archiv)=resulttablelenght Then
                    If LCase(resulttable)=LCase(Archiv) Then
                        zutreffendtabelle = True
                        If scriptdebug = True Then
                            objWshShell.LogEvent 4, "Fall3b zutreffend: Suchstring: "&tabelle(i)&" Archiv: "&Archiv
                        End If			
                    End If
                End If
                
                
            Else	'### keins ###
                
                
                If LCase(tabelle(i))=LCase(Archiv) Or tabelle(i)=folderID Or LCase(Archiv)="workflow" Then
                    zutreffendtabelle = True
                    If scriptdebug = True Then
                        objWshShell.LogEvent 4, "Fall4 zutreffend: Suchstring: "&tabelle(i)&" Archiv: "&Archiv
                    End If
                End If
                
            End If	
            
            '###########################################################################
            
            
            i=i+1
        Loop
    End If
    
    
    
    
    '###################  Beginn: CASE-Auswertung #################################
    
    casecount=1
    zutreffendcasegesamt=True
    zutreffendcase=True
    'objWshShell.LogEvent 4, "Beginne CASE-continue"
    Do While operator(casecount)<>""
        If (Zusatzfeldname(casecount)<>"") And (operator(casecount)<>"") And (operant(casecount)<>"") Then
            zutreffendcase=False
            wert=""
            gefunden=False
            x=0
            Do While gefunden=False
                If LCase(Trim(zusfeld(x)))=LCase(Trim(Zusatzfeldname(casecount))) Then
                    gefunden=True
                End If
                If gefunden=False Then
                    x=x+1
                End If
                If x>=limit Then
                    gefunden=True
                End If
            Loop
            
            If x<limit Then
                'wert=LCase(Trim(zuswert(x))
                wert=zuswert(x)
                
            End If
            
            
            If (viewerwf=False) And (moverwf=False) And (wert="") Then
                wert=getzusatzfeldwert(Zusatzfeldname(casecount))
            End If
            
            
            'If scriptdebug=True Then
            'objWshShell.LogEvent 1, "Workflow-Debug: CASE-Analyse: Zusatzfeldname:"&zusatzfeldname(casecount)&" operator(casecount):"&operator(casecount)&" operant:"&operant(casecount)&vbCrLf & " wert:"&wert
            'End If
            
            
            If Left(operant(casecount),1)="$" Or Not IsNumeric(operant(casecount)) Then
                If Left(operant(casecount),1)="$" Then
                    operant(casecount)=Right(operant(casecount),Len(operant(casecount))-1)
                End If 
                If operator(casecount)="=" Then
                    If LCase(wert)=LCase(operant(casecount)) Then
                        zutreffendcase=True
                    Else
                        zutreffendcase=False
                    End If
                End If
                If operator(casecount)="#" Then
                    If LCase(wert)<>LCase(operant(casecount)) Then
                        zutreffendcase=True
                    Else
                        zutreffendcase=False
                    End If
                End If
                If operator(casecount)="~" Then
                    If InStr(1,LCase(wert),LCase(operant(casecount)))<>0 Then
                        zutreffendcase=True
                    Else
                        zutreffendcase=False
                    End If
                End If
            Else
                
                If LCase(operant(casecount)) <> "true" And LCase(operant(casecount)) <> "false" Then
                    valoperant=strconvert(operant(casecount))
                    'valwert=strconvert(wert)
                    valwert=valconvert(wert)
                Else
                    valoperant=LCase(operant(casecount))
                    'valwert=strconvert(wert)
                    valwert=LCase(wert)
                    
                End If 
                
                If operator(casecount)="=" Then
                    If valwert=valoperant Then
                        zutreffendcase=True
                    Else
                        zutreffendcase=False
                    End If
                End If
                If operator(casecount)="#" Then
                    
                    If valwert<>valoperant Then
                        zutreffendcase=True
                    Else
                        zutreffendcase=False
                    End If
                End If
                If operator(casecount)=">" Then
                    If valwert>valoperant Then
                        zutreffendcase=True
                    Else
                        zutreffendcase=False
                    End If
                End If
                If operator(casecount)="<" Then
                    If valwert<valoperant Then
                        zutreffendcase=True
                    Else
                        zutreffendcase=False
                    End If
                End If
            End If
            
            
        Else
            zutreffendcase=True
        End If
        
        If scriptdebug=True Then
            'objWshShell.LogEvent 0, "Workflow-Debug: CASE-Analyse(2): Ergebnis:"&zutreffendcase & vbCrLf & "zusatzfeldname("&casecount&")="&zusatzfeldname(casecount) & vbCrLf & "operator("&casecount&")="&operator(casecount)  & vbCrLf &  "operant("&casecount&")="&operant(casecount)& vbCrLf & "wert:" & wert
        End If
        casecount=casecount+1
        
        If (zutreffendcase=True) And (zutreffendcasegesamt=True) Then
            zutreffendcasegesamt=True
        Else
            zutreffendcasegesamt=False
        End If
        
    Loop
    
    zutreffendcase=zutreffendcasegesamt
    
    
    '##################### fertig: case analyse #############
    
    
    
    zutreffendcontinue = False
    If oldworkflowID=continue Then
        zutreffendcontinue = True
    End If
    
    
    If scriptdebug=True Then
        tabellen=""
        x=0
        Do While x<=tabellencount
            tabellen=tabellen&x&":"&tabelle(x)&vbCrLf
            x=x+1
        Loop
        
        andindocuments=""
        x=1
        Do While x<=txtfindcount
            andindocuments=andindocuments&x&":"&txttofind(x)&":"&andor(x)&vbCrLf
            x=x+1
        Loop
        
        casecondition=""
        x=1
        Do While x<casecount
            casecondition=casecondition&vbCrLf&"Zusatzfeldname: "&zusatzfeldname(x)&vbCrLf&"Operator: "&operator(x)&vbCrLf&"Operant: "&operant(x)
            x=x+1
        Loop
        objWshShell.LogEvent 4, "bitfarm-Archiv Workflow-Debug: Continue-Workflowauswertung fr ein Dokument aus "&Archiv&vbCrLf & "Workflow:" & workflowcount & vbCrLf &"Archivtabelle="&zutreffendtabelle&vbCrLf& "andindocument= "&zutreffendtxt&vbCrLf&"CASE= "&zutreffendcase& vbCrLf & "Continue= "&zutreffendcontinue&vbCrLf&"ARCHIVTABELLEN:"&vbCrLf&tabellen&vbCrLf&"ANDINDOCUMENTS:"&vbCrLf&andindocuments&vbCrLf&casecondition&vbCrLf&vbCrLf & "continue:"&continue & vbCrLf & "oldworkflowID:" & oldworkflowID
        
    End If
    
    
    
    If (zutreffendtabelle = True) And (zutreffendtxt = True) And (zutreffendcase = True) And (zutreffendcontinue = True) Then
        continueauswertung = True
    End If
    
End Function 



'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

Function endebearbeitung()
    On Error Resume Next
    
    ReDim params(10)
    'StatStr="Bearbeitung von "&Benutzer&" beendet."
    StatStr=getstatustext("status07",params) 
    'StatStr="Bearbeitung / Workflowschritt beendet." 
    'If laststatus = "10" Then
    '	newstatus = "12"
    'Else
    '	newstatus = "13"
    'End If 
    
    newstatus="-1"
    
    erfolg=writejob()
    If erfolg=False Then
        objWshShell.LogEvent 1, "bitfarm-Archiv: workflow: Fehler beim Schreiben der Jobdatei."
        WScript.Quit
    End If
    
    '**************************************  bergabe des Events an Archiv  **********************
    
    'lngReturnCode = objWSHShell.Run(programm&"DBImpV3.exe "&temp&"workflow.job",0,true)
    lngReturnCode=dbimp(temp&"workflow"&mywfID)
    
    If lngReturnCode = 7 Then
        objWshShell.LogEvent 2, "workflow.vbs: Warte 3sek und versuche nochmals dbimp durchzufhren (endebearbeitung)"
        WScript.Sleep 3000
        lngReturnCode=dbimp(temp&"workflow"&mywfID)
    End If
    
    If lngReturnCode <> 0 And lngReturnCode <> 6 Then
        objWSHShell.LogEvent 1, "bitfarm-Archiv: workflow: Fehler bei Eventbergabe Datenbank"
        WScript.Quit
    End If
    WScript.Sleep 100
    If cleanup=True Then
        If fs.fileexists(temp&"workflow"&mywfID&".job") Then
            fs.DeleteFile temp&"workflow"&mywfID&".job", True
            If Err.number <> 0 Then
                Err.clear
                objWshShell.LogEvent 1, "workflow: kann alte workflow.job nicht lschen."
                WScript.Quit
            End If
        End If
    End If
    WScript.Sleep 100
End Function 


'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************


Function wiedervorlage()
    On Error Resume Next
    If nowvl=True Then
        Exit Function
    End If    
    erfolg=writewiedervorlage()
    If erfolg=False Then
        objWshShell.LogEvent 1, "bitfarm-Archiv: workflow: Fehler beim Schreiben der Jobdatei."
        WScript.Quit
    End If
    
    
    'lngReturnCode = objWSHShell.Run(programm&"DBImpV3.exe "&temp&"workflow.job",0,true)
    lngReturnCode=dbimp(temp&"workflow"&mywfID)
    
    If lngReturnCode = 7 Then
        objWshShell.LogEvent 2, "workflow.vbs: Warte 3sek und versuche nochmals dbimp durchzufhren (Wiedervorlage)"
        WScript.Sleep 3000
        lngReturnCode=dbimp(temp&"workflow"&mywfID)
    End If
    
    
    If lngReturnCode <> 0 And lngReturnCode <> 6 Then
        objWSHShell.LogEvent 1, "bitfarm-Archiv: workflow: Fehler bei Workflowbergabe an Datenbank ("&lngreturncode&")"
        WScript.Quit
    End If
    WScript.Sleep 100
    If cleanup=True Then
        If fs.fileexists(temp&"workflow"&mywfID&".job") Then
            fs.DeleteFile temp&"workflow"&mywfID&".job", True
            If Err.number <> 0 Then
                Err.clear
                objWshShell.LogEvent 1, "workflow: kann alte workflow.job nicht lschen."
                WScript.Quit
            End If
        End If
    End If
    WScript.Sleep 100
    
End Function



'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************



Function createworkfile()
    On Error Resume Next
    'i=1
    'wrkfile=programm&"workflow"&i&".txt"
    'flag10=false
    'If fs.FileExists(wrkfile) Then
    '	flag10=false
    'Else
    '	flag10=true
    'End If
    
    'Do While flag10=false
    '	i = i + 1
    '	wrkfile=programm&"workflow"&i&".txt"
    '	If fs.FileExists(wrkfile) Then
    '		flag10=false
    '	Else
    '		flag10=true
    '	End If
    'loop
    
    'If (laststatus = "13") or (laststatus = "11") Then
    '	newstatus1 = "11"
    'Else
    '	newstatus1 = "10"
    'End If 
    
    ipos = InStr(1,DokID,".",1)
    If ipos <> 0 Then
        gdocid = Right(DokID,Len(DokID)-ipos)
    End If    
    
    If (wfID<>"0") And (wfID<>"-1") Then
        newstatus1="+1"
        
        'wrkfile=workflows&"workflow"&DokID&"-"&wfID&".txt"
        wrkfile=workflows&"workflow"&gdocid&"-"&wfID&".txt"

        If (LCase(Trim(setworkflow))<>"nil") And (Trim(setworkflow)<>"") Then
            
            Set workfile=fs.CreateTextFile(wrkfile,True,False)
            workfile.writeline(setworkflow)
            workfile.writeline(Datei)
            workfile.writeline(Date())
            workfile.writeline(EMAIL(0))
            workfile.writeline(benutzer)
            workfile.writeline(displayname)
            'workfile.writeline(DokID)
            workfile.writeline(gdocid)
            workfile.writeline(newstatus1)
            workfile.close
            Set workfile = Nothing
        End If
    End If
    
    createwrkfile = DokID
End Function




'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************


Function isintextfile(suchtext,suchdatei)
    On Error Resume Next
    If scriptdebug = True Then
        'objWSHShell.LogEvent 0,"isintextfile:"&suchtext&":"&suchdatei
    End If
    gefunden=False
    dateiname=suchdatei&".txt"
    karl=suchtext
    fertig = False
    If fs.fileexists(dateiname) = True Then
        Set tempfsobj = fs.OpenTextFile(dateiname,1)
        Do While fertig=False
            
            If tempfsobj.AtEndOfStream = True Then
                fertig=True
            Else
                zs=tempfsobj.readline
                If InStr(1,zs,karl,1)<>0 Then
                    gefunden=True
                    fertig=True
                End If
            End If 
        Loop
        tempfsobj.close
        Set tempfsobj=Nothing
        isintextfile=gefunden
        'objWshShell.LogEvent 1,"ergebnis:"&gefunden
    Else
        isintextfile=False
        objWshShell.LogEvent 2,"workflow.vbs: isintextfile: ergebnis: keine datei"
    End If
    
End Function


'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************


Function getworkflowID(wrkdatei)
    On Error Resume Next
    gefunden=False
    
    dateiname=wrkdatei&".txt"
    karl="msg="
    If viewerwf=True Then
        dateiname=wrkdatei
        karl=""
    End If
    
    fertig = False
    wert = ""
    Set tempfsobj = fs.OpenTextFile(dateiname,1)
    Do While fertig=False
        
        If tempfsobj.AtEndOfStream = True Then
            fertig=True
        Else
            zs=tempfsobj.readline
            If viewerwf=True Then
                wert=zs
                fertig=True
                If tempfsobj.AtEndOfStream<>True Then
                    wfID=tempfsobj.readline
                    'objWshShell.LogEvent 1, "WFID ber wfend-Datei: "&wfID
                End If
                
            ElseIf InStr(1,zs,karl,1)<>0 Then
                wert=GetString(zs,InStr(1,zs,karl,1)+4)
                gefunden=True
                fertig=True
            End If
        End If 
    Loop
    tempfsobj.close
    Set tempfsobj=Nothing
    getworkflowID=wert
    'MsgBox(gefunden&":"&dateiname&":"&wert)
End Function



'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************


Function getworkflowlastuser(wrkdatei)
    On Error Resume Next
    gefunden=False
    If viewerwf=False Then
        dateiname=wrkdatei&".txt"
        karl="An:"
        fertig = False
        wert = ""
        Set tempfsobj = fs.OpenTextFile(dateiname,1)
        Do While fertig=False
            
            If tempfsobj.AtEndOfStream = True Then
                fertig=True
            Else
                zs=tempfsobj.readline
                If InStr(1,zs,karl,1)<>0 Then
                    wert=GetString(zs,InStr(1,zs,karl,1)+3)
                    gefunden=True
                    fertig=True
                End If
            End If 
        Loop
        tempfsobj.close
        Set tempfsobj=Nothing
        
        getworkflowlastuser=wert
    Else
        getworkflowlastuser="System"
        'If fs.fileexists(wrkdatei) Then
        '	err.clear
        '	On Error Resume next
        '	fs.deletefile wrkdatei, true
        '	If err.number <> 0 Then
        '		err.clear
        '		wscript.quit
        '	End If
        'End If
        
    End If
    'MsgBox(gefunden&":"&dateiname&":"&wert)
End Function



'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************


Function getworkflowfields(wrkdatei)
    On Error Resume Next
    gefunden=False
    zuscounter=0
    dateiname=wrkdatei&".txt"
    
    If viewerwf=True Then
        dateiname=wrkdatei
        
    End If
    
    fertig = False
    wert = ""
    linecounter=0
    
    'MsgBox(dateiname)
    
    If fs.fileexists(dateiname)=True Then
        
        Set tempfsobj = fs.OpenTextFile(dateiname,1)
        'MsgBox("ffne datei: "&dateiname)
        
        If tempfsobj.AtEndOfStream = True Then
            fertig=True
        Else
            lateworkflowdokid=tempfsobj.readline
            intervalworkflowdokid=lateworkflowdokid
            
        End If
        
        If tempfsobj.AtEndOfStream = True Then
            fertig=True
        End If
        
        Do While fertig=False
            
            If tempfsobj.AtEndOfStream = True Then
                fertig=True
            Else
                zs=tempfsobj.readline
                linecounter=linecounter+1
                skipline=False
                
                If LCase(Left(zs,7))="abbruch" Then
                    wfabbruch=True
                End If
                
                If LCase(Left(zs,2))="-2" Then
                    intervalworkflow=True
                End If
                
                If LCase(Left(zs,11))="archivname=" Then
                    If intervalworkflow=False Then
                        'lateworkflowarchiv=GetString(zs,InStr(1,kette,"archivname",1)+11)
                        lateworkflowarchiv = Right(zs, Len(zs)-11)
                    Else
                        'intervalworkflowarchiv=GetString(zs,InStr(1,kette,"archivname",1)+11)
                        intervalworkflowarchiv = Right(zs, Len(zs)-11)
                    End If
                End If
                
                If LCase(Left(zs,7))="docloc=" Then
                    Datei=Trim(GetString(zs,InStr(1,kette,"docloc",1)+7))
                    
                    If Right(datei,1)="." Then
                        Datei=Left(datei,Len(datei)-1)
                    End If
                    If Right(datei,4)=".tif" Then
                        Datei=Left(datei,Len(datei)-4)
                    End If
                End If
                
                If (InStr(1,zs,"Zusatzfelder",1)<>0) Or (InStr(1,zs,"Zusatzstatus",1)<>0) Or (linecounter<3) Then
                    skipline=True
                End If
                
                If skipline=False Then
                    
                    laenge=Len(zs)
                    gefunden=False
                    getroffen=False
                    x=1
                    Do While gefunden=False
                        If Mid(zs,x,1)=":" Then
                            gefunden=True
                        End If
                        If gefunden=False Then
                            x=x+1
                        End If
                        If x>=laenge Then
                            gefunden=True
                        End If
                    Loop
                    If (x<laenge) And (x>1) And (Mid(zs,x+1,1)="=") Then
                        zusfeld(zuscounter)=Mid(zs,1,x-1)
                        zuswert(zuscounter)=Mid(zs,x+2,laenge-(x+1))
                        'MsgBox("lese wert fr zusatzfeld "&zusfeld(zuscounter)&":"&zuswert(zuscounter))
                        zuscounter=zuscounter+1
                        getroffen=True
                        
                        
                    End If
                    
                    If getroffen=False Then
                        
                        laenge=Len(zs)
                        gefunden=False
                        x=1
                        Do While gefunden=False
                            If Mid(zs,x,1)="=" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                x=x+1
                            End If
                            If x>=laenge Then
                                gefunden=True
                            End If
                        Loop
                        
                        If (x<laenge) And (x>1) Then
                            zusfeld(zuscounter)="Status_"&Mid(zs,1,x-1)
                            zuswert(zuscounter)=Mid(zs,x+1,laenge-x)
                            If zuswert(zuscounter)<>"0" Then
                                zuswert(zuscounter)="True"
                            Else
                                zuswert(zuscounter)="False"
                            End If
                            zuscounter=zuscounter+1
                        End If
                    End If
                    
                End If
                
                
            End If 
        Loop
        tempfsobj.close
        Set tempfsobj=Nothing
        WScript.sleep 20
    End If
    
    
    
    If fs.fileexists(wrkdatei) Then
        
        Err.clear
        On Error Resume Next
        fs.deletefile wrkdatei, True
        If Err.number <> 0 Then
            Err.clear
            WScript.quit
        End If
    End If
    
    
End Function





'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************


Function sendnoworkflowmsg(hisusername)
    On Error Resume Next
    adresse = hisusername
    betreff = "Fehler: Workflow existiert nicht"
    
    '**********************************  suchen nach freiem Mailto ****************************************
    i=0
    mailto=temp&"mailto"&i&".bat"
    flag10=False
    If fs.FileExists(mailto) Then
        flag10=False
    Else
        flag10=True
    End If
    
    Do While flag10=False
        i = i + 1
        mailto=temp&"mailto"&i&".bat"
        If fs.FileExists(mailto) Then
            flag10=False
        Else
            flag10=True
        End If
    Loop
    
    mailtotxt=temp&"mailto"&i&".txt"
    
    mailto1 = programm & "blat.exe -install " & smtpserver & " " & sendername &" -q"
    If authuser <> "" Then
        mailto2 = programm & "blat.exe " & mailtotxt & " -html -s " & Chr(34) & betreff & Chr(34) & " -t " &  adresse & " -u "&authuser&" -pw "& Chr(34) & authpass & Chr(34) & " -q"
    Else
        mailto2 = programm & "blat.exe " & mailtotxt & " -html -s " & Chr(34) & betreff & Chr(34) & " -t " &  adresse&" -q"
    End If 
    

    Set mailfile=fs.CreateTextFile(mailto,True,False)
    if bfa_server_smtp=True Then
        mailto1 = chr(34) &  programm & "bfa_sendmail.exe" & chr(34) & " --subject " & chr(34) & betreff & chr(34) & " --htmlfile_encoding cp1252 " & " --htmlfile " & chr(34) & mailtotxt & chr(34) & " --con " & chr(34) & programm&profil&".con" & chr(34) & " --recipients " & adresse
        if scriptdebug=True Then
            objWshShell.LogEvent 0, "workflow.vbs debug: mail-command:" & vbcrlf & mailto1
        End If
        mailfile.writeline "chcp 1252"
        mailfile.writeline mailto1
    Else
        mailfile.writeline "chcp 1252"
        mailfile.writeline mailto1
        mailfile.writeline mailto2
    End If
    mailfile.close
    Set mailfile=Nothing
    
    Set txtfile=fs.CreateTextFile(mailtotxt,True,False)
    txtfile.writeline "<BODY style=""FONT: 10pt Arial"" bgColor=#ffffff leftMargin=5 topMargin=5>"
    'txtfile.writeline "<DIV>&nbsp;</DIV>"
    txtfile.writeline "<DIV>&nbsp;</DIV><STRONG>Dieser Workflow existiert nicht.</STRONG> "
    txtfile.writeline "<DIV>&nbsp;</DIV>"
    txtfile.writeline "Sie haben ein Dokument zur Weiterbearbeitung an das Archiv geschickt. Es existiert aber keine Workflow-Anweisung"
    txtfile.writeline "zum weiteren Vorgehen. Vielleicht haben Sie das Dokument schon frher einmal an das Archiv geschickt, so dass"
    txtfile.writeline "der Workflow bereits erledigt ist. Oder es handelt sich um ein Dokument, fr das kein Workflow definiert ist."
    txtfile.writeline "Wenn Sie das Dokument an einen Mitarbeiter oder nach extern verschicken mchten, nutzen Sie bitte die E-Mail"
    txtfile.writeline "Funktion des Archiv-Viewers."
    txtfile.writeline "<DIV>&nbsp;</DIV>"
    txtfile.writeline "<DIV>&nbsp;</DIV>"
    txtfile.writeline "<DIV>&nbsp;</DIV>"
    txtfile.writeline "<DIV><FONT id="""" color=#ff0000></FONT>&nbsp;</DIV>"
    txtfile.writeline workflowabgesang1
    txtfile.writeline workflowabgesang2
    txtfile.WriteLine "</BODY></HTML>"
    txtfile.close
    Set txtfile=Nothing
    
    WScript.Sleep 200
    
    Set oExec = objWSHShell.Exec(mailto)
    strinput = ""
    strerrinput = ""
    Do While Not oExec.StdOut.AtEndOfStream
        strinput = strinput & oExec.StdOut.Read(1)	
    Loop
    strerrinput=""
    Do While Not oExec.StdErr.AtEndOfStream
        strerrinput = strerrinput & oExec.StdErr.Read(1)	
    Loop 
	If scriptdebug = True Then
		objWSHShell.LogEvent 1, "workflow debug: mailto 1 returned:"&vbCrLf&strinput&vbCrLf&strerrinput
	End If
	
'    lngReturnCode = objWSHShell.Run(mailto,0,True)
'    If lngReturnCode <> 0 Then
'        objWSHShell.LogEvent 1, "workflow: Fehler bei Mailversand (sendfilemail)"
'        
'    End If
    
    WScript.Sleep 200
    
    
    If cleanup = True Then 
        If fs.fileexists(mailto) Then
            fs.DeleteFile mailto, True
            If Err.number <> 0 Then
                Err.clear
                objWshShell.LogEvent 1, "workflow: kann mailto.bat nicht erneuern."
                WScript.Quit
            End If
        End If
        
        If fs.fileexists(mailtotxt) Then
            fs.DeleteFile mailtotxt, True
            If Err.number <> 0 Then
                Err.clear
                objWshShell.LogEvent 1, "workflow: kann nachricht.txt nicht erneuern."
                WScript.Quit
            End If
        End If 
    End If 
    
End Function



'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************


Function Sendlinkmail(adresse)
    On Error Resume Next
    mailtemplate=""
    If msgheadr="" Then
        betreff = "Archiv: neues Dokument"
    Else
        betreff = CStr(msgheadr)
    End If
    
    
    
    If msgbody="" Then
        nachricht = ""
    Else
        nachricht = msgbody
    End If
    
    
    If myusername <> "" Then
        standardnachricht = displayname&" weitergeleitet von "&myusername&" am "&Date()
    Else
        standardnachricht = displayname&" erzeugt/gescannt von "&benutzer&" am "&Date()
    End If
    
    '**********************************  suchen nach freiem Mailto ****************************************
    i=0
    mailto=temp&"mailto"&i&".bat"
    flag10=False
    If fs.FileExists(mailto) Then
        flag10=False
    Else
        flag10=True
    End If
    
    Do While flag10=False
        i = i + 1
        mailto=temp&"mailto"&i&".bat"
        If fs.FileExists(mailto) Then
            flag10=False
        Else
            flag10=True
        End If
    Loop
    
    mailtotxt=temp&"mailto"&i&".txt"
    
    betrefffilename = temp&"mailsubj"&i&".txt"
    Set betrefffile=fs.CreateTextFile(Chr(34)& betrefffilename &Chr(34),True,False)
    betrefffile.WriteLine betreff
    betrefffile.close
    Set betrefffile=Nothing
    bfa_sendmail_adresse = adresse
    ' Adressatenliste erstellen
    If Left(adresse,1) = "#" Or Left(adresse,1) = "" Then
    	mailaddrstr = ""
        stradrfile = makeadresslist(adresse, i)
        bfa_sendmail_adresse = mailaddrstr
        If stradrfile <> "" Then
            stradresse = " -tf " &  Chr(34) & stradrfile & Chr(34)
        Else
            stradresse = " -t " & adresse
        End If 
    ElseIf InStr(1, adresse, "@") = 0 Then
    	If scriptdebug=True Then
    		objWSHShell.LogEvent 1, "workflow.vbs Mailadresse fr user " & adresse & " ermitteln"
    	End If
    	useradresse = usermailinfo(adresse)
    	stradresse = " -t " & useradresse
    	bfa_sendmail_adresse = useradresse
    	If scriptdebug=True Then
    		objWSHShell.LogEvent 1, "workflow.vbs Mailadresse fr user " & adresse & ": " & useradresse    
    	End If
    Else
        stradresse = " -t " & adresse
        bfa_sendmail_adresse = adresse
    End If 
    
    
    
    
    
    mailto1 = Chr(34)&programm & "blat.exe" & Chr(34)& " -install " & smtpserver & " " & sendername &" -q"
    If authuser <> "" Then
        mailto2 = Chr(34)&programm & "blat.exe"&Chr(34)& " " & mailtotxt & " -html -sf " & Chr(34) & betrefffilename & Chr(34) & stradresse & " -u "&authuser&" -pw " & Chr(34) & authpass & Chr(34) & " -q"
    Else
        mailto2 = Chr(34)&programm & "blat.exe"&Chr(34)& " " & mailtotxt & " -html -sf " & Chr(34) & betrefffilename & Chr(34) & stradresse & " -q"
    End If 
    
    If archiv="workflow" Then
        benachrichtigungstext = "weitergeleitetes Dokument zur Bearbeitung"
    Else
        benachrichtigungstext = "neues Dokument zur Bearbeitung"
    End If 
    
    
    
    If dokID<>"" Then
        'workflowtxt1="fr dieses Dokument ist ein Workflow definiert, d.h. wenn Sie mit der Bearbeitung fertig sind,"
        'workflowtxt2="senden Sie diese Nachricht einfach zurck an "&sendername&" oder drucken Sie diesen Text auf den workflow-drucker."
        'workflowtxt3="msg="&dokID
        workflowtxt3=""
    Else
        workflowtxt1=""
        workflowtxt2=""
        workflowtxt3=""
    End If
    
   

    Set mailfile=fs.CreateTextFile(Chr(34)& mailto &Chr(34),True,False)
    if bfa_server_smtp=True Then
        mailto1 = chr(34) &  programm & "bfa_sendmail.exe" & chr(34) & " --subject " & chr(34) & betreff & chr(34) & " --htmlfile_encoding cp1252 " & " --htmlfile " & chr(34) & mailtotxt & chr(34) & " --con " & chr(34) & programm&profil&".con" & chr(34) & " --recipients " & bfa_sendmail_adresse
        if scriptdebug=True Then
            objWshShell.LogEvent 0, "workflow.vbs debug: mail-command:" & vbcrlf & mailto1
        End If
        mailfile.writeline "chcp 1252"
        mailfile.writeline mailto1
    Else
        mailfile.writeline "chcp 1252"
        mailfile.writeline mailto1
        mailfile.writeline mailto2
    End If
    mailfile.close
    Set mailfile=Nothing


    
    Set txtfile=fs.CreateTextFile(mailtotxt,True,False)
    txtfile.writeline "<BODY style=""FONT: 10pt Arial"" bgColor=#ffffff leftMargin=5 topMargin=5>"
    txtfile.writeline "<DIV>&nbsp;</DIV>"&workflowtxt3
    txtfile.writeline "<DIV>&nbsp;</DIV><STRONG>"&benachrichtigungstext&"</STRONG> "
    txtfile.writeline "<DIV>&nbsp;</DIV>"
    txtfile.writeline standardnachricht
    txtfile.writeline "<DIV>&nbsp;</DIV>"
    dokidsplit=Split(dokid,".")
    arc = dokidsplit(0)
    gdocid = dokidsplit(1)
    txtfile.writeline "<DIV><A href=""gdocid:"&gdocid&""">Zum Dokument</A></DIV>"
    If (webviewerlink=True) And (webviewer<>"") Then
        doclnk = webviewer+"?showdoc="+gdocid
        txtfile.writeline "<DIV><A href="""&doclnk&""">Zum Dokument (im Browser ffnen)</A></DIV>"
        txtfile.writeline "<DIV>&nbsp;</DIV>"
    End If
    'txtfile.writeline "<DIV><A href=""file://"&Datei&".tif""><STRONG>Dokumentenansicht</STRONG></A>       	 <A href=""file://"&Datei&".txt""><STRONG>erkannter Text</STRONG></A></DIV>"
    txtfile.writeline "<DIV>&nbsp;</DIV>"
    txtfile.writeline "<DIV>&nbsp;</DIV><STRONG>Aufgabe: <FONT color=#ff0000>"&nachricht&"</FONT></STRONG>"
    txtfile.writeline "<DIV>&nbsp;</DIV>"
    txtfile.writeline workflowtxt1
    txtfile.writeline workflowtxt2
    'txtfile.writeline workflowtxt3
    txtfile.writeline "<DIV>&nbsp;</DIV>"
    
    txtfile.writeline "<DIV><FONT id="""" color=#ff0000></FONT>&nbsp;</DIV>"
    txtfile.writeline workflowabgesang1
    txtfile.writeline workflowabgesang2
    txtfile.WriteLine "</BODY></HTML>"
    txtfile.close
    Set txtfile=Nothing
    
    WScript.Sleep 200
    'objWSHShell.LogEvent 1, "mailto:"&mailto

    Set oExec = objWSHShell.Exec(Chr(34)&mailto&Chr(34))
    strinput = ""
    strerrinput = ""
    Do While Not oExec.StdOut.AtEndOfStream
        strinput = strinput & oExec.StdOut.Read(1)	
    Loop
    strerrinput=""
    Do While Not oExec.StdErr.AtEndOfStream
        strerrinput = strerrinput & oExec.StdErr.Read(1)	
    Loop 
	If scriptdebug = True Then
		objWSHShell.LogEvent 1, "workflow debug: mailto 2 returned:"&vbCrLf&strinput&vbCrLf&strerrinput
	End If
	
'    lngReturnCode = objWSHShell.Run(mailto,0,True)
'    If lngReturnCode <> 0 Then
'        objWSHShell.LogEvent 1, "workflow: Fehler bei Mailversand (sendfilemail)"
'        
'    End If
    
    WScript.Sleep 200
    
    '*******************************************************************************************
    '**************************************  Mitteilung ber Workflow an Archiv ****************
    
    '************************************ textdatei anlegen  ***********************************
    ReDim params(10)
    params(1)=adresse
    If setworkflow = "" Then
        StatStr=getstatustext("status08", params)
        'StatStr= "Dokument automatisch gesendet an "&adresse
    Else
        StatStr=getstatustext("status09", params)
        'StatStr= "warten auf Bearbeitung durch "&adresse
    End If
    
    
    'If (laststatus = "13") or (laststatus = "11") Then
    '	newstatus = "11"
    'Else
    '	newstatus = "10"
    'End If 
    
    'If setworkflow = "" Then
    '	newstatus = "3"
    'End If 
    
    newstatus="+0"
    
    
    erfolg=writejob()
    If erfolg=False Then
        objWshShell.LogEvent 1, "bitfarm-Archiv: workflow: Fehler beim Schreiben der Jobdatei."
        WScript.Quit
    End If
    
    '**************************************  bergabe des Events an Archiv  **********************
    
    'lngReturnCode = objWSHShell.Run(programm&"DBImpV3.exe "&temp&"workflow.job",0,true)
    lngReturnCode=dbimp(temp&"workflow"&mywfID)
    
    If lngReturnCode = 7 Then
        objWshShell.LogEvent 2, "workflow.vbs: Warte 3sek und versuche nochmals dbimp durchzufhren (sendlinkmail)"
        WScript.Sleep 3000
        lngReturnCode=dbimp(temp&"workflow"&mywfID)
    End If
    
    If lngReturnCode <> 0 And lngReturnCode <> 6 Then
        objWSHShell.LogEvent 1, "bitfarm-Archiv: workflow: Fehler bei Workflowbergabe an Datenbank ("&lngreturncode&") DOKID:"&dokid
        WScript.Quit
    End If
    WScript.Sleep 100
    If cleanup=True Then
        If fs.fileexists(temp&"workflow"&mywfID&".job") Then
            fs.DeleteFile temp&"workflow"&mywfID&".job", True
            If Err.number <> 0 Then
                Err.clear
                objWshShell.LogEvent 1, "workflow: kann alte workflow.job nicht lschen." & vbCrLf & temp&"workflow"&mywfID&".job"
                WScript.Quit
            End If
        End If
    End If
    WScript.Sleep 100
    '*******************************************************************************************
    '*************************************  aufrumen  *****************************************
    
    
    Err.clear
    If cleanup = True Then 
        If fs.fileexists(mailto) Then
            fs.DeleteFile mailto, True
            If Err.number <> 0 Then
                Err.clear
                objWshShell.LogEvent 1, "workflow: kann mailto.bat nicht erneuern." & vbCrLf & mailto
                WScript.Quit
            End If
        End If
        
        If fs.fileexists(betrefffilename) Then
            fs.DeleteFile betrefffilename, True
            If Err.number <> 0 Then
                Err.clear
                objWshShell.LogEvent 1, "workflow: kann mailsubj.txt nicht erneuern." & vbCrLf & betrefffilename
                WScript.Quit
            End If
        End If
        
        
        If fs.fileexists(mailtotxt) Then
            fs.DeleteFile mailtotxt, True
            If Err.number <> 0 Then
                Err.clear
                objWshShell.LogEvent 1, "workflow: kann nachricht.txt nicht erneuern." & vbCrLf & mailtotxt
                WScript.Quit
            End If
        End If
        
        
        If fs.fileexists(stradrfile) Then
            WScript.sleep 500
            fs.DeleteFile stradrfile, True
            If Err.number <> 0 Then
                Err.clear
                objWshShell.LogEvent 1, "workflow: kann empfngerliste.txt nicht erneuern." & vbCrLf & stradrfile	
                WScript.Quit
            End If
        End If 
        
        
    End If 
    
End Function

'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************


Function Sendfilemail(adresse)
    On Error Resume Next
    mailtemplate=""
    If msgheadr="" Then
        betreff = "Archiv: neues Dokument"
    Else
        betreff = msgheadr
    End If
    
    If msgbody="" Then
        nachricht = ""
    Else
        nachricht = msgbody
    End If
    
    If myusername <> "" Then
        standardnachricht = displayname&" weitergeleitet von "&myusername&" am "&Date()
    Else
        standardnachricht = displayname&" erzeugt/gescannt von "&benutzer&" am "&Date()
    End If
    
    
    '**********************************  suchen nach freiem Mailto ****************************************
    i=0
    mailto=temp&"mailto"&i&".bat"
    flag10=False
    If fs.FileExists(mailto) Then
        flag10=False
    Else
        flag10=True
    End If
    
    Do While flag10=False
        i = i + 1
        mailto=temp&"mailto"&i&".bat"
        If fs.FileExists(mailto) Then
            flag10=False
        Else
            flag10=True
        End If
    Loop
    
    betrefffilename = temp&"mailsubj"&i&".txt"
    Set betrefffile=fs.CreateTextFile(betrefffilename,True,False)
    betrefffile.WriteLine betreff
    betrefffile.close
    Set betrefffile=Nothing
    
    mailtotxt=temp&"mailto"&i&".txt"
    bfa_sendmail_adresse = adresse
    ' Adressatenliste erstellen
    If Left(adresse,1) = "#" Or Left(adresse,1) = "" Then
    	mailaddrstr = ""
        stradrfile = makeadresslist(adresse, i)
        bfa_sendmail_adresse = mailaddrstr
        stradresse = " -tf " &  Chr(34) & stradrfile & Chr(34)
    ElseIf InStr(1, adresse, "@") = 0 Then
    	If scriptdebug=True Then
    		objWSHShell.LogEvent 1, "workflow.vbs Mailadresse fr user " & adresse & " ermitteln"
    	End If
    	useradresse = usermailinfo(adresse)
    	stradresse = " -t " & useradresse
    	bfa_sendmail_adresse = useradresse
    	If scriptdebug=True Then
    		objWSHShell.LogEvent 1, "workflow.vbs Mailadresse fr user " & adresse & ": " & useradresse    
    	End If
    Else
        stradresse = " -t " & adresse
    End If 
    
    
    
    mailto1 = programm & "blat.exe -install " & smtpserver & " " & sendername&" -q"
    
     
	
    If NRSDatei="" Then
        sAttachfile=""
        temp_tif = ""
        temp_pdf = ""
        If makepdf=False Then
	        If Not fs.FileExists(Datei&".tif") Then
	            sAttachfile = doc_loc
	        Else
	            sAttachfile = Datei&".tif"
	        End If 
		Else
			If fs.FileExists(Datei&".pdf") Then
				sAttachfile = Datei&".pdf"
			Else
				If fs.FileExists(objWSHShell.ExpandEnvironmentStrings(ori_loc)) And LCase(fs.GetExtensionName(objWSHShell.ExpandEnvironmentStrings(ori_loc)))="pdf" Then
					sAttachfile = objWSHShell.ExpandEnvironmentStrings(ori_loc)
				Else
					objWSHShell.LogEvent 1, "workflow.vbs sendpdf debug: ori_loc nicht vorhanden oder nicht pdf, verwende tiff2pdf"
				
					tif2pdfpth = Chr(34) & programm & "tiff2pdf.exe" & Chr(34)
					thistif = Datei&".tif"
					If Not fs.FileExists(thistif) Then
						thistif = ""
						If fs.FileExists(objWSHShell.ExpandEnvironmentStrings(doc_loc)) and LCase(Right(doc_loc,4))=".tif" Then
							thistif=objWSHShell.ExpandEnvironmentStrings(doc_loc)
						End If
					End If
					If thistif = "" Then
						sAttachfile = doc_loc
					End If
					If Not fs.FileExists(thistif) Then
		            	sAttachfile = doc_loc
		            Else
		           		fname = fs.GetBaseName(thistif)
		           		temp_tif = programm&"temp\" & fname & ".tif"
		           		temp_pdf = programm&"temp\" & fname & ".pdf"
		           		fs.CopyFile thistif, programm&"temp\" & fname & ".tif" , True
		           		cmd = tif2pdfpth & " " & temp_tif
						objWSHShell.Run cmd, 0, True
		           		If Not fs.FileExists(temp_pdf) Then
		           			sAttachfile = Datei & ".tif"
		           			objWSHShell.LogEvent 1, "workflow.vbs -> Tif nach PDF Wandlung gescheitert, verwende nun tif fr Mailversand. Aufruf:" & vbCrLf & cmd
		           		Else
		           			sAttachfile = temp_pdf
		           		End If
		           	End If
		       End If
			End If
		End If       
        If authuser <> "" Then
            mailto2 = programm & "blat.exe " & mailtotxt & " -html -sf " & Chr(34) & betrefffilename & Chr(34) & stradresse & " -u "&authuser&" -pw " & Chr(34) & authpass & Chr(34) & " -attach "&sAttachfile&" -q"
        Else
            mailto2 = programm & "blat.exe " & mailtotxt & " -html -sf " & Chr(34) & betrefffilename & Chr(34) & stradresse &" -attach "&sAttachfile&" -q"
        End If
        
    Else
        
        If authuser <> "" Then
            mailto2 = programm & "blat.exe " & mailtotxt & " -html -sf " & Chr(34) & betrefffilename & Chr(34) & stradresse & " -u "&authuser&" -pw " & Chr(34) & authpass & Chr(34) & " -attach "&NRSDatei&".tif -q"
        Else
            mailto2 = programm & "blat.exe " & mailtotxt & " -html -sf " & Chr(34) & betrefffilename & Chr(34) & stradresse &" -attach "&NRSDatei&".tif -q"
        End If
        
        
    End If 
    
    If archiv="workflow" Then
        benachrichtigungstext = "weitergeleitetes Dokument zur Bearbeitung"
    Else
        benachrichtigungstext = "Neues Dokument zur Bearbeitung"
    End If 
    
    
    If dokid<>"" Then
        'workflowtxt1="fr dieses Dokument ist ein Workflow definiert, d.h. wenn Sie mit der Bearbeitung fertig sind,"
        'workflowtxt2="senden Sie diese Nachricht einfach zurck an "&sendername&" oder drucken Sie diesen Text auf den workflow-drucker."
        'workflowtxt3="msg="&dokid
        workflowtxt3=""
    Else
        workflowtxt1=""
        workflowtxt2=""
        workflowtxt3=""
    End If

    Set mailfile=fs.CreateTextFile(mailto,True,False)
    if bfa_server_smtp=True Then
        mailto1 = chr(34) &  programm & "bfa_sendmail.exe" & chr(34) & " --subject " & chr(34) & betreff & chr(34) & " --htmlfile_encoding cp1252 " & " --htmlfile " & chr(34) & mailtotxt & chr(34) & " --con " & chr(34) & programm&profil&".con" & chr(34) & " --recipients " & bfa_sendmail_adresse
        If NRSDatei="" Then
            mailto1 = mailto1 & " --attachments " & chr(34) & sAttachfile & chr(34)
        Else
            mailto1 = mailto1 & " --attachments " & chr(34) &NRSDatei&".tif" & chr(34) 
        End If
        if scriptdebug=True Then
            objWshShell.LogEvent 0, "workflow.vbs debug: mail-command:" & vbcrlf & mailto1
        End If
        mailfile.writeline "chcp 1252"
        mailfile.writeline mailto1
    Else
        mailfile.writeline "chcp 1252"
        mailfile.writeline mailto1
        mailfile.writeline mailto2
    End If

    mailfile.close
    Set mailfile=Nothing
    
    Set txtfile=fs.CreateTextFile(mailtotxt,True,False)
    txtfile.writeline "<BODY style=""FONT: 10pt Arial"" bgColor=#ffffff leftMargin=5 topMargin=5>"
    txtfile.writeline "<DIV>&nbsp;</DIV>"&workflowtxt3
    txtfile.writeline "<DIV>&nbsp;</DIV><STRONG>"&benachrichtigungstext&"</STRONG> "
    txtfile.writeline "<DIV>&nbsp;</DIV>"
    txtfile.writeline standardnachricht
    'txtfile.writeline "<DIV>&nbsp;</DIV>"
    txtfile.writeline "<DIV>&nbsp;</DIV>"
    
    txtfile.writeline "<DIV>&nbsp;</DIV><STRONG>Aufgabe: <FONT color=#ff0000>"&nachricht&"</FONT></STRONG>"
    txtfile.writeline "<DIV>&nbsp;</DIV>"
    txtfile.writeline workflowtxt1
    txtfile.writeline workflowtxt2
    'txtfile.writeline workflowtxt3
    txtfile.writeline "<DIV>&nbsp;</DIV>"
    txtfile.writeline "<DIV><FONT id="""" color=#ff0000></FONT>&nbsp;</DIV>"
    txtfile.writeline workflowabgesang1
    txtfile.writeline workflowabgesang2
    txtfile.WriteLine "</BODY></HTML>"
    txtfile.close
    Set txtfile=Nothing
    
    WScript.Sleep 200
    'objWSHShell.LogEvent 1, "mailto:"&mailto
    Set oExec = objWSHShell.Exec(mailto)
    strinput = ""
    strerrinput = ""
    Do While Not oExec.StdOut.AtEndOfStream
        strinput = strinput & oExec.StdOut.Read(1)	
    Loop
    strerrinput=""
    Do While Not oExec.StdErr.AtEndOfStream
        strerrinput = strerrinput & oExec.StdErr.Read(1)	
    Loop 
    If scriptdebug = True Then
		objWSHShell.LogEvent 1, "workflow debug: mailto 3 returned:"&vbCrLf&strinput&vbCrLf&strerrinput
	End If
	
'    lngReturnCode = objWSHShell.Run(mailto,0,True)
'    If lngReturnCode <> 0 Then
'        objWSHShell.LogEvent 1, "workflow: Fehler bei Mailversand (sendfilemail)"
'        
'    End If
    
    If temp_tif <> "" Then
    	fs.DeleteFile temp_tif, True
    End If
   	If temp_pdf <> "" Then
    	fs.DeleteFile temp_pdf, True
    End If
    
    '*******************************************************************************************
    '**************************************  Mitteilung ber Workflow an Archiv ****************
    
    '************************************ textdatei anlegen  ***********************************
    ReDim params(10)
    params(1)=adresse
    If setworkflow = "" Then
        StatStr= getstatustext("status08", params)
        'StatStr= "Dokument automatisch gesendet an "&adresse
    Else
        StatStr= getstatustext("status09", params)
        'StatStr= "warten auf Bearbeitung durch "&adresse
    End If
    
    'If (laststatus = "13") or (laststatus = "11") Then
    '	newstatus = "11"
    'Else
    '	newstatus = "10"
    'End If 
    
    'If setworkflow = "" Then
    '	newstatus = "3"
    'End If 
    
    newstatus="+0"
    
    
    erfolg=writejob()
    If erfolg=False Then
        objWshShell.LogEvent 1, "bitfarm-Archiv: workflow: Fehler beim Schreiben der Jobdatei."
        WScript.Quit
    End If
    '**************************************  bergabe des Events an Archiv  **********************
    
    'lngReturnCode = objWSHShell.Run(programm&"DBImpV3.exe "&temp&"workflow.job",0,true)
    lngReturnCode=dbimp(temp&"workflow"&mywfID)
    
    If lngReturnCode = 7 Then
        objWshShell.LogEvent 2, "workflow.vbs: Warte 3sek und versuche nochmals dbimp durchzufhren (sendfilemail)"
        WScript.Sleep 3000
        lngReturnCode=dbimp(temp&"workflow"&mywfID)
    End If
    
    If lngReturnCode <> 0 And lngReturnCode <> 6 Then
        objWSHShell.LogEvent 1, "bitfarm-Archiv: workflow: Fehler bei Eventbergabe Datenbank. DOKID:"&dokid&" EventID:"&lngreturncode
        fs.copyfile temp&"workflow"&mywfID&".job", temp&"workflow"&mywfID&".err", True
        WScript.Quit
    End If
    WScript.Sleep 100
    If cleanup=True Then
        If fs.fileexists(temp&"workflow"&mywfID&".job") Then
            fs.DeleteFile temp&"workflow"&mywfID&".job", True
            If Err.number <> 0 Then
                Err.clear
                objWshShell.LogEvent 1, "workflow: kann alte workflow.job nicht lschen." & vbCrLf & temp&"workflow"&mywfID&".job"
                WScript.Quit
            End If
        End If
    End If
    WScript.Sleep 100
    
    '*******************************************************************************************
    '*************************************  aufrumen  *****************************************
    
    
    
    WScript.Sleep 200
    
    If cleanup = True Then 
        If fs.fileexists(mailto) Then
            fs.DeleteFile mailto, True
            If Err.number <> 0 Then
                Err.clear
                objWshShell.LogEvent 1, "workflow: kann mailto.bat nicht erneuern." & vbCrLf & mailto
                WScript.Quit
            End If
        End If
        
        If fs.fileexists(betrefffilename) Then
            fs.DeleteFile betrefffilename, True
            If Err.number <> 0 Then
                Err.clear
                objWshShell.LogEvent 1, "workflow: kann mailsubj.txt nicht erneuern." & vbCrLf & betrefffilename
                WScript.Quit
            End If
        End If
        
        If fs.fileexists(mailtotxt) Then
            fs.DeleteFile mailtotxt, True
            If Err.number <> 0 Then
                Err.clear
                objWshShell.LogEvent 1, "workflow: kann nachricht.txt nicht erneuern." & vbCrLf & mailtotxt	
                WScript.Quit
            End If
        End If 
        
        If fs.fileexists(stradrfile) Then
            WScript.sleep 500
            fs.DeleteFile stradrfile, True
            If Err.number <> 0 Then
                Err.clear
                objWshShell.LogEvent 1, "workflow: kann empfngerliste.txt nicht erneuern." & vbCrLf & stradrfile	
                WScript.Quit
            End If
        End If 
    End If 
    
    
End Function


Function makeadresslist(ByVal stradr, index)
    
    
    If scriptdebug = True Then
        objWshShell.LogEvent 4, "workflow.vbs: makeadresslist(" &  stradr	& "," & index & ")"
    End If 	
    
    mykey=zufallszahl(1000,9999)
    count = 0
    pos = InStr(1,stradr,";")
    If InStr(1,stradr,";") > 0 Then
        Do Until stradr = "" Or count >= limit Or pos = 0
            
            pos = InStr(1,stradr,";")
            If pos > 0 Then
                strsingle = Left(stradr,InStr(1,stradr,";")-1)
            Else
                strsingle = stradr
            End If 
            addresslist(count) = strsingle
            count = count +1
            stradr = Right(stradr, Len(stradr) - pos)
            
        Loop	
    Else
        addresslist(count) = stradr
        count = count +1
    End If 
    
    
    For i = 0 To count -1 
        
        stradr = Right(addresslist(i),Len(addresslist(i))-1)
        strinput = ""
        Set oExec    = objWSHShell.Exec(programm&"userinfo.exe -gn " & profil & " " & Chr(34) & stradr & Chr(34))
        
        Do While Not oExec.StdOut.AtEndOfStream
            strinput = strinput & oExec.StdOut.Read(1)	
        Loop
        
        durch = False
        schleife = 0
        Do While schleife < 50
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 100  
            schleife = schleife +1
        Loop
        Ende = Timer
        
        If durch = False Then
            objWshShell.LogEvent 1, "workflow.vbs userinfo.exe: Schwerwiegender Fehler" & vbCrLf & "userinfo.exe antwortet nicht oder wird nicht beendet" & vbCrLf & "Status: " & oExec.Status & vbCrLf & "Exitcode " & oExec.ExitCode & vbCrLf & "Schleife: " & schleife
            returnvalue  = 8
            oExec.Terminate
            'Exit Do
        Else
            returnvalue = oExec.ExitCode
        End If
        
        If scriptdebug=True Then
            objWshShell.LogEvent 4, "workflow.vbs Function userinfo: userinfo.exe ausgefhrt" & vbCrLf & "Status: " & oExec.Status & vbCrLf & "Exitcode " & oExec.ExitCode & vbCrLf & "Schleife: " & schleife &vbCrLf& strinput
            
        End If
        
        pos = 0
        Do Until strinput = "" Or InStr(1,strinput,"usr_mail:") = 0 
            pos = InStr(1, strinput, "usr_mail:")
            
            If pos <> 0 Then
                pos_crlf = InStr(pos,strinput,vbCrLf)
                
                If Mid(strinput,pos + 9,1) = vbCrLf Then
                    'nicht gefunden
                Else
                    'gefunden
                    usr_mail =  Mid(strinput,pos + 9,InStr(pos + 9, strinput, vbCrLf) - (pos +9)) 
                    If usr_mail <> "" Then
                        strusr = strusr & usr_mail & ";"
                    End If 
                End If 
                
                strinput = Right(strinput,Len(strinput) - pos_crlf)
                
            End If 
        Loop
    Next    
    
    
    If strusr <> "" Then
    	mailaddrstr = strusr
        Set adrfile = fs.CreateTextFile(temp & "mailtolist" & mykey & index & ".txt")
        
        Do Until strusr = "" Or pos = 0
            
            pos = InStr(1,strusr,";")
            If pos > 0 Then
                strfile = Left(strusr,InStr(1,strusr,";")-1)
            Else
                strfile = strusr
            End If 
            adrfile.WriteLine strfile
            strusr = Right(strusr, Len(strusr) - pos)
            
        Loop
        
        adrfile.close
        makeadresslist = temp & "mailtolist" & mykey & index & ".txt"
        
    Else
        makeadresslist = ""
    End If 
    
    
End Function



'********************************************************************************
'********************************************************************************
'********************************************************************************
'********************************************************************************
'********************************************************************************


Function dbimp(Datei)
    On Error Resume Next
    If scriptdebug=True Then
        objWshShell.LogEvent 4, "workflow.vbs Function dbimp_neu: Datei " & Datei
        If fs.folderexists(programm&"workflowdebug")= False Then
            Set test = fs.CreateFolder(programm&"workflowdebug")
            Set test = Nothing
            WScript.sleep 200
            If Err.number<>0 Then
                objWshShell.LogEvent 1, "workflow(0): kann debug-verzeichnis nicht erstellen - Berechtigung?"
                On Error Resume Next
                Err.clear
                WScript.Quit
            End If 
        End If
        mydate=Date()
        mytime=Time()
        mytime=Replace(mytime,":", "")
        myversatz=zufallszahl(100,999)
        
        test=programm&"workflowdebug\"&mydate&mytime&myversatz&"-"&debugcounter&".job"
        debugcounter=debugcounter+1
        
        fs.copyfile datei&".job", test, True
        
        If Not (fs.fileexists(programm & "workflow_dbimp.log")) Then
            Set outfile = fs.CreateTextFile(programm & "workflow_dbimp.log")
            outfile.close
            Set outfile = Nothing
        End If
        Set outfile = fs.OpenTextFile(programm & "workflow_dbimp.log",8)
    End If 
    wfid = 0	
    dokid = 0	
    Do While dokid = 0 And wfid = 0 
        
        strinput = ""
        schleife = 0
        
        Beginn = Timer
        ' > c:\bitfarm-archiv\garbage\dbimp.log
        
        Set oExec    =  objWSHShell.Exec(Chr(34)&programm&"DBImpV3.exe"&Chr(34)&" "&Chr(34)&Datei&".job"&Chr(34))
        
        Do While Not oExec.StdOut.AtEndOfStream
            strinput = strinput & oExec.StdOut.Read(1)	
        Loop
        
        durch = False
        schleife = 0
        Do While schleife < 50
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 100  
            schleife = schleife +1
        Loop
        Ende = Timer
        
        If durch = False Then
            objWshShell.LogEvent 1, "workflow.vbs Function dbimp: Schwerwiegender Fehler" & vbCrLf & "dbimpV3.exe antwortet nicht oder wird nicht beendet" & vbCrLf & "Status: " & oExec.Status & vbCrLf & "Exitcode " & oExec.ExitCode & vbCrLf & "Schleife: " & schleife
            returnvalue  = 8
            oExec.Terminate
            Exit Do
        Else
            returnvalue = oExec.ExitCode
        End If
        
        If scriptdebug=True Then
            objWshShell.LogEvent 4, "workflow.vbs Function dbimp: dbimpV3.exe ausgefhrt" & vbCrLf & "Status: " & oExec.Status & vbCrLf & "Exitcode " & oExec.ExitCode & vbCrLf & "Schleife: " & schleife &vbCrLf& strinput
            
        End If
        
        'strinput = LCase(strinput)
        
        If (InStr(1,strinput,"DokID:") <> 0) Or (InStr(1,strinput,"DocID:") <> 0) Then
            If InStr(1,strinput,"DokID:") <> 0 Then
                strdokid = Right(strinput,Len(strinput)-InStr(1,strinput,"DokID:")-5)
            Else
                strdokid = Right(strinput,Len(strinput)-InStr(1,strinput,"DocID:")-5)
            End If
            
            strdokid = Left(strdokid,InStr(1,strdokid,Chr(13))-1)
            DokID = strdokid	
        End If
        
        If InStr(1,strinput,"WfID:") <> 0 Then
            strwfid = Right(strinput,Len(strinput)-InStr(1,strinput,"WfID:")-4)
            strwfid = Left(strwfid,InStr(1,strwfid,Chr(13))-1)
            wfID = strwfid
        End If
        
        If Not IsNumeric(strdokid) Then
            returnvalue = 10
        End If
        
        If returnvalue <>0 Then Exit Do
        
    Loop	
    
    If InStr(1,LCase(strinput),"erfolgreich" )<> 0 Then
        exec_dbimp = "DbImpV3 erfolgreich in " & Ende - Beginn
    Else
        If InStr(1,LCase(strinput),"fehler" )<> 0 Then
            exec_dbimp = "DbImpV3 Fehler in " & Ende - Beginn
            objWshShell.LogEvent 1, "workflow.vbs Function dbimp: dbimpV3.exe meldet einen Fehler:" & vbCrLf & strinput
            
        Else
            exec_dbimp = " DbImpV3 unbekannte Rckmeldung " & Ende - Beginn
        End If
    End If
    
    
    If scriptdebug = True Then
        
        outfile.Writeline "Workflow.vbs --- " & Now()
        outfile.Writeline strinput 
        outfile.Writeline exec_dbimp
        outfile.WriteLine "Durchlauf:" & durchlauf
        outfile.WriteLine "Versuch:" & versuch
        outfile.WriteLine "Datei:" & datei
        outfile.WriteLine 
        outfile.WriteLine 
        If fs.fileexists(Datei&".job") Then
            outfile.WriteLine "Inhalt der Jobdatei:"
            outfile.WriteLine "---------------------------------------------------"
            Set myjobfile = fs.OpenTextFile(Datei&".job",1)
            Do While myjobfile.atendofstream=False
                kette=myjobfile.readline
                outfile.writeline(kette)
            Loop
            myjobfile.close
            Set myjobfile=Nothing
            outfile.WriteLine "---------------------------------------------------"
        End If
        
        outfile.close		
        objWshShell.LogEvent 4, "workflow.vbs Function dbimp: retval " & returnvalue
    Else
        
        If returnvalue <> 0 Then
            objWshShell.LogEvent 4, "workflow.vbs Function dbimp: retval " & returnvalue & vbCrLf & strinput
        End If
    End If
    
    
    Set oExec = Nothing
    dbimp=returnvalue
End Function



'********************************************************************************
'********************************************************************************
'********************************************************************************
'********************************************************************************


Function getdbimpvar
    On Error Resume Next
    getdbimpvar=0
    
    Set WshEnv = objWSHShell.Environment("System")
    
    getdbimpvar = WshEnv("dbimp")
    
    
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
    End If
    
    Set WshEnv=Nothing
    
End Function

Function setdbimpvar(myzahl)
    On Error Resume Next
    Set WshEnv = objWSHShell.Environment("System")
    WshEnv("dbimp") = myzahl
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
    End If
    Set WshEnv=Nothing
End Function


'********************************************************************************
'********************************************************************************
'********************************************************************************
'********************************************************************************
Function resolvevariables()
    On Error Resume Next
    '*************  mappen von %Feldname% auf den Bearbeiter und E-Mail
    '*************  Neu ab 3.5.0.3: Auch %Archiv% oder %Archivname% mglich
    '*************  baut auch Strings mit mehreren Variablen zusammen
    '*************  Auch im Messagetext knnen jetzt Variabeln ausgewertet werden
    
    
    For x=0 To limit
        bearbeiter(x)=parsestrings(bearbeiter(x))
        controller(x)=parsestrings(controller(x))
        
        EMail(x)=parsestrings(EMail(x))
        msgbody=parsestrings(msgbody)
        msgheadr=parsestrings(msgheadr)
    Next
    
    
    
End Function


'###############################################################
'###########  Parsefunktion fr alle mglichen variable  #######
'###############################################################


Function parsestrings(inputstring)
    
    If InStr(1,inputstring,"%",1)<>0 Then
        abbruch=False
        myvariable=""
        '##############  Suche die Positionen der ersten beiden % heraus
        Do While abbruch=False
            pos1=0
            pos2=0
            laenge=Len(inputstring)
            z=1
            gefunden=False
            If z<laenge Then
                zeichen=Mid(inputstring,z,1)
                
                Do While gefunden=False
                    If zeichen="%" Then
                        gefunden=True
                        pos1=z
                    Else
                        z=z+1
                        zeichen=Mid(inputstring,z,1)
                    End If
                    If z=laenge+1 Then
                        gefunden=True
                    End If
                Loop
            End If
            
            gefunden=False
            z=z+1
            If z<laenge Then
                zeichen=Mid(inputstring,z,1)
                Do While gefunden=False
                    If zeichen="%" Then
                        gefunden=True
                        pos2=z
                    Else
                        z=z+1
                        zeichen=Mid(inputstring,z,1)
                    End If
                    If z=laenge+1 Then
                        gefunden=True
                    End If
                Loop
            End If
            
            If (pos1<>0) And (pos2<>0) And (pos2>pos1) Then
                tempstring=""
                myvariable=""
                tempstring=Trim(LCase(Mid(inputstring,pos1+1,pos2-pos1-1)))
                
                For y=0 To limit
                    If Trim(LCase(zusfeld(y)))=tempstring Then
                        myvariable=zuswert(y)
                    End If
                Next
                If (tempstring="archiv") Or (tempstring="archive") Or (tempstring="archivtabelle") Then
                    objWshShell.LogEvent 1, "folderID:"&folderID&" archiv:"&archiv
                    If (folderName<>"") And (folderName<>"") And (archiv="workflow") Then
                        myvariable=folderName
                    Else
                        myvariable=archiv
                    End If
                End If
                '###############  jetzt stringvariable herauslschen und durch reslove ersetzen
                mystring=""
                For z=1 To pos1-1
                    mystring=mystring&Mid(inputstring,z,1)
                Next
                
                mystring=mystring&myvariable
                If pos2<laenge Then
                    For z=pos2+1 To laenge
                        mystring=mystring&Mid(inputstring,z,1)
                    Next
                End If
                inputstring=mystring
                
                
            Else
                abbruch=True
            End If
            
        Loop
        'objWshShell.LogEvent 1, "Parsestrings:"&inputstring
    End If
    
    parsestrings=inputstring
    
End Function


'***************************************************************************************
'***************************************************************************************
'*******************************************************************************
Function appendBackslash(thepath)
    If Right(thepath,1)<>"\" Then
        thepath=thepath&"\"
    End If
    appendBackslash=thepath
End Function

'*******************************************************************************
'***************************************************************************************

Function readconfig(profil)
    On Error Resume Next
    readconfig=True
    Err.clear
    
    If Not fs.FileExists(programm&profil&".con") Then
        Err.clear
        errortxt="Workflow.vbs:" &profil&".con Datei nicht im Scriptpfad vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        readconfig=False
        Err.clear
    End If
    
    If readconfig=True Then	
        Set confile = fs.OpenTextFile(programm&profil&".con",1)
        If Err.number Then
            Err.clear
            errortxt="Profilfdatei nicht im Scriptpfad vorhanden oder nicht lesbar."
            objWshShell.LogEvent 1, errortxt
            Err.clear
            readconfig=False
            
        End If 
    End If
    
    If readconfig=True Then	
        kette=confile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        Do While Scriptsflag = 0
            kette=confile.readline
            Scriptsflag=InStr(1,kette,"[Scripts]")
            If confile.AtEndOfStream = True Then
                confile.close
                Set confile=Nothing
                scriptsflag=1
                errortxt="Fehler beim Lesen der CON-Datei - falsche Formatierung."
                objWshShell.LogEvent 1, errortxt
                readconfig = False
                
            End If
        Loop
        
    End If
    
    
    If readconfig = True Then
        
        Do While confile.AtEndOfStream <> True
            kette=Trim(confile.readline)
            kette = Replace(kette,vbTab,"")
            If Left(kette,1)<>";" Then
              
                If InStr(1,kette,"serverprogramm",1)<>0 Then
                    'wert=GetString(kette,InStr(1,kette,"serverprogramm",1)+14)
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"serverprogramm=",1)+14))
					programm = wert
                    queue=programm&"queue\"
                    garbagepath=programm&"garbage\"
                    workflows=programm&"workflows\"
                    masks=programm&"masks\"
                    forms=programm&"forms\"
                End If
                
                If InStr(1,kette,"clientprogramm",1)<>0 Then
                    wert = Right(kette,Len(kette) -15)
                    clientprogramm = Trim(wert)
                End If
                
                If Left(kette,13) = "clientspooler" Then
                    wert = Right(kette,Len(kette) -14)
                    clientspooler = Trim(wert)
                End If
                
                If Left(kette,16) = "uncclientspooler" Then
                    wert = Right(kette,Len(kette) -17)
                    uncclientspooler = Trim(wert)
                End If
                
                If InStr(1,kette,"archivverzeichnis",1)<>0 Then
                    wert = Right(kette,Len(kette) -18)
                    archivverzeichnis = Trim(wert)
                End If
                
                If InStr(1,kette,"archivkopie",1)<>0 Then
                    wert = Right(kette,Len(kette) -12)
                    archivkopie = Trim(wert)
                End If
                
                If InStr(1,kette,"archive_rs",1)<>0 Then
                    wert = Right(kette,Len(kette) -11)
                    archive_rs = Trim(wert)
                End If
                
                If InStr(1,kette,"archive_nrs",1)<>0 Then
                    wert = Right(kette,Len(kette) -12)
                    archive_nrs = Trim(wert)
                End If
                
                If InStr(1,kette,"storages",1)<>0 Then
                    wert = Right(kette,Len(kette) -9)
                    storages = Trim(wert)
                End If
                
                If InStr(1,kette,"omnipage",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"omnipage=",1)+8))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        omnipage = Trim(wert)
                    End If
                End If
                
                If InStr(1,kette,"ghostscript",1)<>0 Then
                    wert = Right(kette,Len(kette) -12)
                    ghostscript = Trim(wert)
                End If
                
                If InStr(1,kette,"gsview",1)<>0 Then
                    wert = Right(kette,Len(kette) -7)
                    gsview = Trim(wert)
                End If		
                
                If InStr(1,kette,"druckserver1",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"druckserver1",1)+12)
                    druckserver1 = wert
                End If		
                
                If InStr(1,kette,"druckserver2",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"druckserver2",1)+12)
                    druckserver2 = wert
                End If
                
                If InStr(1,kette,"druckserver3",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"druckserver3",1)+12)
                    druckserver3 = wert
                End If
                
                If InStr(1,kette,"druckserver4",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"druckserver4",1)+12)
                    druckserver4 = wert
                End If
                
                If InStr(1,kette,"smtpserver",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"smtpserver",1)+10)
                    smtpserver = wert
                End If
                
                If InStr(1,kette,"authuser",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"authuser",1)+8)
                    authuser = wert
                End If
                
                If InStr(1,kette,"authpass",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"authpass",1)+8)
                    authpass = wert
                End If
                
                If InStr(1,kette,"backuppath",1)<>0 Then
                    wert = Right(kette,Len(kette) -11)
                    backuppath = Trim(wert)
                End If
                
                If InStr(1,kette,"backupstart",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"backupstart",1)+11)
                    backupstart = wert
                End If
                
                If InStr(1,kette,"sqldatapath",1)<>0 Then
                    wert = Right(kette,Len(kette) -12)
                    sqldatapath = Trim(wert)
                End If
                
                If InStr(1,kette,"sendername",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"sendername",1)+10)
                    sendername = wert
                End If
                
                If InStr(1,kette,"schattenarchiv",1)<>0 Then
                    wert = Right(kette,Len(kette) -15)
                    If LCase(wert)="true" Then
                        schattenarchiv=True
                    Else
                        schattenarchiv=False
                    End If
                End If
                
                If InStr(1,kette,"dublettenpruefung",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"dublettenpruefung",1)+17)
                    
                    If LCase(wert)="true" Then
                        dublettenpruefung=True
                    Else
                        dublettenpruefung=False
                    End If
                    
                End If
                
                If InStr(1,kette,"adminmail",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"adminmail",1)+9)
                    adminmail = Trim(wert)
                End If
                
                If InStr(1,kette,"templates",1)<>0 Then
                    wert = Right(kette,Len(kette) -10)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        templates=Trim(wert)
                        templates=appendBackslash(templates)
                    End If
                End If	
                
                If Left(Trim(LCase(Replace(kette,vbTab,""))),9)="workflows" Then
                    wert = Right(kette,Len(kette) -10)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        workflows=Trim(wert)
                    End If
                End If	
                
                If InStr(1,kette,"workflowfile",1)<>0 Then
                    wert = Right(kette,Len(kette) -13)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        workflowfile=Trim(wert)
                    End If
                End If	
                
                If InStr(1,kette,"unverteilt",1)<>0 Then
                    wert = Right(kette,Len(kette) -11)
                    unverteilt = Trim(wert)
                End If

                If InStr(1,kette,"bfa_server_smtp",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"bfa_server_smtp",1)+15)
                    if lcase(wert)="true" Then
                        bfa_server_smtp = True
                    End If
                End If
                
            End If
            
        Loop
        confile.close
        Set confile = Nothing
        
    End If
    
    
End Function



'***************************************************************************************
'***************************************************************************************
'***************************************************************************************


Function runplugin(plugin)
    On Error Resume Next
    runplugin=True
    Err.clear
    
    If Not fs.fileexists(programm&"plugins\"&plugin) Then
        runplugin=False
    End If
    
    zahl=zufallszahl(0,999999)
    
    vardatei=programm&"temp\"&zahl&".var"
    
    
    If fs.FileExists(vardatei&".var") Then
        Err.clear
        fs.deletefile vardatei&".var", True
        If Err.number Then
            Err.clear
            errortxt="Kann alte var-datei nicht lschen."
            objWshShell.LogEvent 1, errortxt
            runplugin=False
        End If 
        Err.clear
    End If
    
    If runplugin=True Then	
        Set varfile = fs.OpenTextFile(vardatei&".var",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann var-datei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            runplugin=False
            varfile.close
            Set varfile=Nothing
        End If 
    End If
    
    
    
    
    If runplugin = True Then
        For x=0 To limit
            
            If email(x)<>"" Then
                varfile.writeline("email="&email(x))
            End If
            If bearbeiter(x)<>"" Then
                varfile.writeline("bearbeiter="&bearbeiter(x))
            End If
            
        Next
        If benutzer<>"" Then	
            varfile.writeline("Benutzer="&benutzer)
        End If
        varfile.writeline("viewerwf="&viewerwf)
        varfile.writeline("moverwf="&moverwf)
        If archiv<>"" Then
            varfile.writeline("Archiv="&archiv)
        End If
        If statstr<>"" Then
            varfile.writeline("Statstr="&statstr)
        End If
        If newstatus<>"" Then
            varfile.writeline("newstatus="&newstatus)
        End If
        If dokid<>"" Then
            varfile.writeline("docid="&dokid)
        End If
        If wfid<>"" Then
            varfile.writeline("wfid="&wfid)
        End If
        
        For x=0 To limit
            If zusfeld(x)<>"" Then
                varfile.writeline(zusfeld(x)&"="&zuswert(x))
            End If
        Next
        
        varfile.close
        Set varfile=Nothing
        WScript.sleep 50
    End If
    
    
    
    
    '###############################   Plugin starten  ############################
    
    If runplugin=True Then
        If scriptdebug=True Then
            objWshShell.LogEvent 4, "workflow(debug25): starte Plugin "&plugin
        End If
        'MsgBox(programm&"plugins\"&plugin&" "&vardatei)
        lngReturnCode = objWSHShell.Run(programm&"plugins\"&plugin&" "&vardatei,0,True)
        
        If scriptdebug=True Then
            objWshShell.LogEvent 4, "workflow(debug26): Rckkehr aus Plugin "&plugin
        End If
        
        WScript.sleep 50
    End If
    
    '###############################   Feld zurcklesen  ##########################
    
    If runplugin=True Then
        emailcounter=0
        bearbeitercounter=0
        For x=0 To limit
            email(emailcounter)=""
            bearbeiter(bearbeitercounter)=""
        Next
        If fs.fileexists(vardatei&".var") Then
            'fs.CopyFile vardatei&".var","C:\bitfarm-archiv\temp\temp.var"
            kette=""
            wert1=""
            wert2=""
            Set varfile = fs.OpenTextFile(vardatei&".var",1)
            Do While varfile.atendofstream=False
                kette=varfile.readline
                
                If InStr(1,kette,"benutzer",1)<>0 Then
                    wert1=Trim(Right(kette,Len(kette)-(InStr(1,kette,"benutzer",1)+8)))
                    benutzer=wert1
                End If
                
                If InStr(1,kette,"newstatus",1)<>0 Then
                    wert1=Trim(Right(kette,Len(kette)-(InStr(1,kette,"newstatus",1)+9)))
                    newstatus=wert1
                End If
                
                If InStr(1,kette,"statstr",1)<>0 Then
                    wert1=Trim(Right(kette,Len(kette)-(InStr(1,kette,"statstr",1)+7)))
                    statstr=wert1
                End If
                
                If InStr(1,kette,"bearbeiter",1)<>0 Then
                    wert1=Trim(Right(kette,Len(kette)-(InStr(1,kette,"bearbeiter",1)+10)))
                    bearbeiter(bearbeitercounter)=wert1
                    bearbeitercounter=bearbeitercounter+1
                End If
                
                If InStr(1,kette,"email",1)<>0 Then
                    wert1=Trim(Right(kette,Len(kette)-(InStr(1,kette,"email",1)+5)))
                    email(emailcounter)=wert1
                    emailcounter=emailcounter+1
                End If
                
            Loop
            varfile.close
            Set varfile=Nothing
            WScript.sleep 30
            fs.deletefile vardatei&".var", True
        End If
    End If  	
    
End Function




'***************************************************************************************
'***************************************************************************************
'***************************************************************************************


Function getzusatzfeldwert(Zusatzfeldname)
    On Error Resume Next
    functioninternalerror=False
    getzusatzfeldwert=""
    Err.clear
    
    If Not fs.FileExists(programm&"temp\workflowinfo.txt") Then
        Err.clear
        'errortxt="Workflowinfos nicht vorhanden."
        'objWshShell.LogEvent 1, errortxt
        
        functioninternalerror=True
        Err.clear
    End If
    
    If functioninternalerror=False Then	
        Set jobfile = fs.OpenTextFile(programm&"temp\workflowinfo.txt",1)
        If Err.number Then
            Err.clear
            'errortxt="Workflowinfos nicht vorhanden oder nicht lesbar."
            'objWshShell.LogEvent 1, errortxt
            
            functioninternalerror=True
            
        End If 
    End If
    
    
    If functioninternalerror=False Then
        
        Do While jobfile.AtEndOfStream <> True
            kette=jobfile.readline
            stripname=""
            
            If InStr(1,kette,Zusatzfeldname,1)<>0 Then
                
                laenge=Len(kette)+1
                pos1=Len(Zusatzfeldname)+2
                If laenge>pos1 Then
                    
                    pos2 = InStr(1,kette,"=")
                    stripname=Trim(Left(kette,pos2-1))
                    If stripname=Zusatzfeldname Then
                        wert=Trim(Mid(kette,pos2+1,laenge-pos2))
                        getzusatzfeldwert=wert
                    End If
                End If
                
            End If
            
        Loop
        jobfile.close
        Set jobfile = Nothing
        
    End If
    
    
End Function



'***************************************************************************************
'***************************************************************************************
'***************************************************************************************


Function writejob()
    On Error Resume Next
    writejob=True
    Err.clear
    
    If fs.FileExists(temp&"workflow"&mywfID&".job") Then
        fs.DeleteFile(temp&"workflow"&mywfID&".job")
        If Err.number Then
            Err.clear
            errortxt="Zwischendatei fr workflow-jobdatei existierte noch, kann diese aber nicht lschen."
            objWshShell.LogEvent 1, errortxt
            writejob=False
            
        End If 
        
    End If
    
    If writejob=True Then	
        Set quelljobfile = fs.OpenTextFile(programm&"workflow.tpl",1)
        If Err.number Then
            Err.clear
            errortxt="Kann Workflow-Template (workflow.tpl) nicht lesen."
            objWshShell.LogEvent 1, errortxt
            writejob=False
            
        End If 
    End If
    
    
    If writejob=True Then
        Set zieljobfile = fs.OpenTextFile(temp&"workflow"&mywfID&".job",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann workflow-Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writejob=False
            quelljobfile.close
            Set quelljobfile=Nothing
        End If 
    End If
    
    
    
    If writejob = True Then
        
        ersatzstring=""	
        Do While quelljobfile.AtEndOfStream <> True
            kette=quelljobfile.readline
            
            ersatzstring=""
            
            If (Profil<>"") And (InStr(1,kette,"Profil=",1)<>0) Then
                ersatzstring="Profil="&Profil
            End If
            
            If (dokID<>"") And (InStr(1,kette,"DOCID=",1)<>0) Then
                ersatzstring="DOCID="&dokID
            End If
            
            If (myname<>"") And (InStr(1,kette,"Titel=",1)<>0) Then
                ersatzstring="Titel="&myname
            End If
            
            If (newstatus<>"0") And (InStr(1,kette,"Status=",1)<>0) Then
                ersatzstring="Status="&newstatus
            End If
            
            If (StatStr<>"")And (InStr(1,kette,"StatStr=",1)<>0) Then
                ersatzstring="StatStr="&StatStr
            End If
            
            If ersatzstring<>"" Then
                zieljobfile.writeline(ersatzstring)
            Else
                zieljobfile.writeline(kette)
            End If
            
        Loop
        quelljobfile.close
        Set quelljobfile = Nothing
        zieljobfile.close
        Set zieljobfile=Nothing
        WScript.sleep 200
        Err.clear
    End If
    
End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function writewiedervorlage()
    On Error Resume Next
    writewiedervorlage=True
    Err.clear
    
    If fs.FileExists(temp&"workflow"&mywfID&".job") Then
        fs.DeleteFile(temp&"workflow"&mywfID&".job")
        If Err.number Then
            Err.clear
            errortxt="Zwischendatei fr workflow-jobdatei existierte noch, kann diese aber nicht lschen."
            objWshShell.LogEvent 1, errortxt
            writewiedervorlage=False
            
        End If 
        
    End If
    
    If writewiedervorlage=True Then	
        Set quelljobfile = fs.OpenTextFile(programm&"workflow.tpl",1)
        If Err.number Then
            Err.clear
            errortxt="Kann Workflow-Template (workflow.tpl) nicht lesen."
            objWshShell.LogEvent 1, errortxt
            writewiedervorlage=False
            
        End If 
    End If
    
    
    If writewiedervorlage=True Then
        Set zieljobfile = fs.OpenTextFile(temp&"workflow"&mywfID&".job",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann workflow-Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writewiedervorlage=False
            quelljobfile.close
            Set quelljobfile=Nothing
        End If 
    End If
    
    
    
    If writewiedervorlage = True Then
        newstatus="+1"
        StatStr="Dokument in Bearbeitung"
        
        Termin=Date()+versatz(bearbeiterzaehler)
        If Not IsEmpty(alarmversatz(bearbeiterzaehler)) Then
            
            'If alarmversatz(bearbeiterzaehler)<>0 Then
            Alarm=Date()+alarmversatz(bearbeiterzaehler)+versatz(bearbeiterzaehler)
        Else
            Alarm=Date()+7+versatz(bearbeiterzaehler)
        End If
        
        Timeroptions=0
        
        If InStr(1,options(bearbeiterzaehler),"returntosender",1)<>0 Then
            Timeroptions=Timeroptions Or 2
        End If
        
        If InStr(1,options(bearbeiterzaehler),"mailonalarm",1)<>0 Then
            Timeroptions=Timeroptions Or 4
        End If
        
        
        
        ersatzstring=""	
        Do While quelljobfile.AtEndOfStream <> True
            kette=quelljobfile.readline
            
            ersatzstring=""
            
            If (Profil<>"") And (InStr(1,kette,"Profil=",1)<>0) Then
                ersatzstring="Profil="&Profil
            End If
            
            If (dokID<>"") And (InStr(1,kette,"DOCID=",1)<>0) Then
                ersatzstring="DOCID="&dokID
            End If
            
            If (myname<>"") And (InStr(1,kette,"Titel=",1)<>0) Then
                ersatzstring="Titel="&myname
            End If
            
            If (Termin<>"") And (InStr(1,kette,"Termin=",1)<>0) Then
                ersatzstring="Termin="&Termin
            End If
            
            If (Alarm<>"") And (InStr(1,kette,"Alarm=",1)<>0) Then
                ersatzstring="Alarm="&Alarm
            End If
            
            If (InStr(1,kette,"Bearbeiter=",1)<>0) Then
                ersatzstring="Bearbeiter="&bearbeiter(bearbeiterzaehler)
            End If
            
            If (InStr(1,kette,"Benutzer=",1)<>0) Then
                ersatzstring="Benutzer="&controller(bearbeiterzaehler)
            End If
            
            If (InStr(1,kette,"TimerOptionen=",1)<>0) Then
                ersatzstring="TimerOptionen="&Timeroptions
            End If
            
            If (msgbody<>"") And (InStr(1,kette,"Notiz=",1)<>0) Then
                ersatzstring="Notiz="&msgbody
            End If
            
            If (newstatus<>"0") And (InStr(1,kette,"Status=",1)<>0) Then
                ersatzstring="Status="&newstatus
            End If
            
            If (StatStr<>"")And (InStr(1,kette,"StatStr=",1)<>0) Then
                ersatzstring="StatStr="&StatStr
            End If
            
            
            
            If ersatzstring<>"" Then
                zieljobfile.writeline(ersatzstring)
            Else
                zieljobfile.writeline(kette)
            End If
            
        Loop
        quelljobfile.close
        Set quelljobfile = Nothing
        zieljobfile.close
        Set zieljobfile=Nothing
        WScript.sleep 200
        Err.clear
    End If
    
End Function



'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function inilesen()
    On Error Resume Next
    inilesen=True
    Err.clear
    Set inifile = fs.OpenTextFile(programm&"scripts.ini",1)
    If Err.number Then
        objWshShell.LogEvent 1, "bitfarm-Archiv: workflow: scripts.ini nicht im Scriptpfad vorhanden oder nicht lesbar."
        Err.clear
        inilesen=False
    End If 
    
    If inilesen=True Then	
        kette=inifile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        Do While Scriptsflag = 0
            kette=inifile.readline
            Scriptsflag=InStr(1,kette,"[Scripts]")
            If inifile.AtEndOfStream = True Then
                inifile.close
                objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - falsche Formatierung."
                WScript.Quit
            End If
        Loop
        
        
        Do While inifile.AtEndOfStream <> True
            kette=inifile.readline
            If Left(kette,1)<>";" Then
                
                
                If InStr(1,kette,"newstatuslang=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"newstatuslang=",1)+13))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        newstatuslang = LCase(wert)
                    Else newstatuslang = "deutsch"
                    End If
                End If	
                
                If InStr(1,kette,"workflowabgesang1=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"workflowabgesang1=",1)+17))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        workflowabgesang1 = wert
                    End If
                End If
                
                If InStr(1,kette,"workflowabgesang2=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"workflowabgesang2=",1)+17))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        workflowabgesang2 = wert
                    End If
                End If
                
                If InStr(1,kette,"newstatuslang=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"newstatuslang=",1)+13))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        newstatuslang = LCase(wert)
                    Else newstatuslang = "deutsch"
                    End If
                End If
                
                If InStr(1,kette,"workflowplugin",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"workflowplugin",1)+15)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        workflowplugin=Trim(wert)
                    End If
                End If
                
                If InStr(1,kette,"webviewer",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"webviewer",1)+9)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        webviewer=Trim(wert)
                    End If
                End If
                
            End If
            
        Loop
        inifile.close
        Set inifile = Nothing
        If programm="" Then
            objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - kein Programmpfad."
            WScript.Quit
        End If
    End If
    
End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************





Function SMSSend(Nummer)
    On Error Resume Next
    For i = 0 To UBound(Nummer)
        If Nummer(i) <> "" Then
            SMS1 = mypath & "SMS.EXE -f "&mypath&"SMS.txt "&nummer(i)&" > null"
            Set WshShell = WScript.CreateObject("WScript.Shell")
            Set fso = CreateObject("Scripting.FileSystemObject")
            Set fm = fso.CreateTextFile(mypath & "sms"&CStr(i)&".bat",True,False)
            fm.writeline SMS1
            fm.close
            mm=WshShell.Run(mypath & "sms"&CStr(i)&".bat",0,True)
        End If
    Next
    
End Function



Private Function strConvert(str)	
    On Error Resume Next 
    
    If Not IsNumeric(str) Then
        strConvert = 0
        
    ElseIf (InStr(1,str,".") And InStr(1,str,",")) Then
        strConvert = 0
    Else
        
        
        str1=""
        str2=""
        neg = False
        
        If InStr(1,str,",") Then
            
            str1 = Left(str,InStr(1,str,",")-1)
            str2 = Right(str,Len(str)-InStr(1,str,","))
            
        ElseIf InStr(1,str,".") Then
            
            str1 = Left(str,InStr(1,str,".")-1)
            str2 = Right(str,Len(str)-InStr(1,str,"."))
            
        Else
            str1 =str
            str2="0"
            
        End If
        
        If Left(str1,1) = "-" Then
            neg = True
            str1 = Replace(str1,"-","")
        End If 
        
        
        
        wert1=0
        l = Len(str1)
        
        For x = 1 To l
            wert1=wert1+((Asc(Mid(str1,x,1))-48)*(10^(l-x)))
        Next
        
        wert2=0
        l = Len(str2)
        
        For x = 1 To l
            wert2=wert2+((Asc(Mid(str2,x,1))-48)*(10^(l-x)))
        Next
        
        wert2 = wert2/(10^Len(str2))
        
        StrConvert=wert1+wert2
        
        If neg = True  Then
            strConvert = 0 - strConvert
        End If
        
        
    End If
    
    
End Function



Private Function StrConvert_alt(String)
    On Error Resume Next
    wert1=0
    For x = 1 To Len(String)
        wert1=wert1+((Asc(Mid(String,x,1))-48)*(10^(Len(String)-x)))
    Next
    StrConvert_alt=wert1
End Function

Private Function ValConvert(String)
    On Error Resume Next
    Err.Clear
    ValConvert = CDbl(String)
    If Err.number <> 0 Then
        Err.Clear
        If Len(String)>2 Then
            If InStr(1,String,",",1)<>0 Then
                breakevent = False
                laenge=Len(String)
                t=laenge
                Do While breakevent=False
                    If Mid(String,t,1)="," Then
                        breakevent=True
                    Else
                        t=t-1
                    End If
                    If t=0 Then
                        breakevent=True
                    End If
                    
                Loop
                If t<>0 Then
                    String=Left(String,t-1)
                End If	
            End If
        End If		
        wert1=0
        For x = 1 To Len(String)
            wert1=wert1+((Asc(Mid(String,x,1))-48)*(10^(Len(String)-x)))
        Next
        If t<>0 Then
            wert1=wert1-1
        End If
        ValConvert=wert1
        'objWshShell.LogEvent 2, "Trap1:"&wert1
    End If
End Function

' Private Function GetString(kette,pos)
    ' On Error Resume Next
    ' zeichen=""
    ' ergebnis=""
    ' index=0
    ' charwert=0
    ' If Len(zeichen)=1 Then
        ' charwert=Asc(zeichen)
    ' End If
    ' Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (charwert<>13) And (zeichen<>"	") And (index<=Len(kette)-pos+1)
        ' ergebnis=ergebnis+zeichen
        ' zeichen=Mid(kette,pos+index,1)
        ' index=index+1
        ' If Len(zeichen)=1 Then
            ' charwert=Asc(zeichen)
        ' End If
        ' If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=") Or (charwert=13)) And (ergebnis="") Then
            ' zeichen=""
        ' End If
        
    ' Loop
    ' Trim(ergebnis)
    ' GetString=ergebnis
' End Function

Private Function GetString(kette,pos)
    On Error Resume Next
    
    zeichen=""
    ergebnis=""
    index=0
    charwert=0
    If Len(zeichen)=1 Then
        charwert=Asc(zeichen)
    End If
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (charwert<>13) And (charwert<>10) And (zeichen<>"	") And (index<255)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,pos+index,1)
        index=index+1
        If Len(zeichen)=1 Then
            charwert=Asc(zeichen)
        End If
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=") Or (charwert=10) Or (charwert=13)) And (ergebnis="") Then
            zeichen=""
        End If
        
    Loop
    
    GetString=Trim(ergebnis)
End Function


Private Function GetWord(kette,pos)
    On Error Resume Next
    zeichen=""
    ergebnis=""
    index1=pos
    'MsgBox(Len(kette)&":"&pos)
    charwert=0
    If Len(zeichen)=1 Then
        charwert=Asc(zeichen)
    End If
    Do While (zeichen<>" ") And (zeichen<>"	") And (charwert<>13) And (index1>1)
        index1=index1-1
        zeichen=Mid(kette,index1,1)
        If Len(zeichen)=1 Then
            charwert=Asc(zeichen)
            If charwert=13 Then
                
                index1=index1+1
            End If
        End If
        
    Loop
    'MsgBox(index1)
    zeichen=""
    index2=0
    charwert=0
    If Len(zeichen)=1 Then
        charwert=Asc(zeichen)
    End If
    
    maxindex2=Len(kette)-index1+2
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (charwert<>13) And (zeichen<>"	") And (index2<maxindex2)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,index1+index2,1)
        index2=index2+1
        If Len(zeichen)=1 Then
            charwert=Asc(zeichen)
        End If
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=") Or (charwert=13)) And (ergebnis="") Then
            zeichen=""
        End If
        
    Loop
    'MsgBox(index)
    Trim(ergebnis)
    
    'GetWord=normstring(ergebnis)
    GetWord=ergebnis
End Function

Private Function NormString(String)
    On Error Resume Next
    tempkette=""
    wert1=0
    l = Len(String)
    
    For x = 1 To l
        wert1=Asc(Mid(String,x,1))
        If (wert1>=0) And (wert1<=32) Then
            tempkette=tempkette&" "
        Else
            
            If wert1=151 Then
                wert1=45
            End If
            If wert1=150 Then
                wert1=45
            End If
            'If wert1=95 Then
            '	wert1=45
            'End If
            If wert1=173 Then
                wert1=45
            End If
            If wert1=175 Then
                wert1=45
            End If
            If wert1=170 Then
                wert1=97
            End If	
            If wert1=161 Then
                wert1=105
            End If
            If wert1=181 Then
                wert1=117
            End If
            If wert1=213 Then
                wert1=214
            End If
            If wert1=195 Then
                wert1=196
            End If
            If wert1=229 Then
                wert1=97
            End If
            If wert1=230 Then
                tempkette=tempkette&"a"
                wert1=101
            End If
            If wert1=209 Then
                wert1=78
            End If
            If wert1=199 Then
                wert1=67
            End If
            If wert1=231 Then
                wert1=99
            End If
            If wert1=241 Then
                wert1=110
            End If
            If wert1=245 Then
                wert1=246
            End If
            If wert1=251 Then
                wert1=252
            End If
            If wert1=253 Then
                wert1=121
            End If
            If wert1=197 Then
                wert1=65
            End If
            
            If wert1=44 Then
                wert1=46
            End If
            
            If (wert1>=204) And (wert1<=207) Then
                wert1=73
            End If
            If (wert1>=200) And (wert1<=203) Then
                wert1=69
            End If
            If (wert1>=192) And (wert1<=194) Then
                wert1=65
            End If
            If (wert1>=210) And (wert1<=211) Then
                wert1=79
            End If	
            If (wert1>=212) And (wert1<=213) Then
                wert1=214
            End If
            If (wert1>=217) And (wert1<=218) Then
                wert1=85
            End If
            If wert1=219 Then
                wert1=220
            End If			
            If (wert1>=224) And (wert1<=225) Then
                wert1=97
            End If
            If (wert1>=226) And (wert1<=227) Then
                wert1=228
            End If
            If (wert1>=224) And (wert1<=225) Then
                wert1=97
            End If
            If (wert1>=232) And (wert1<=235) Then
                wert1=101
            End If
            If (wert1>=236) And (wert1<=239) Then
                wert1=105
            End If	
            If (wert1>=242) And (wert1<=243) Then
                wert1=111
            End If
            If (wert1>=249) And (wert1<=250) Then
                wert1=117
            End If
            
            
            If ((wert1>=44) And (wert1<=46)) Or ((wert1>=47) And (wert1<=58)) Or ((wert1>=63) And (wert1<=90)) Or ((wert1>=97) And (wert1<=122)) Or (wert1=95) Or (wert1=196) Or (wert1=214) Or (wert1=220) Or (wert1=223) Or (wert1=228) Or (wert1=246) Or (wert1=252) Or (wert1=40) Or (wert1=41) Or (wert1=42) Or (wert1=37) Or (wert1=61) Or (wert1=92) Or (wert1=61) Or (wert1=35) Or (wert1=33) Then		
                tempkette=tempkette+Chr(wert1)
            Else
                tempkette=tempkette&""
            End If
        End If
        
        
        
    Next
    tempkette2=""
    
    l = Len(tempkette)
    'If l>3 Then
    u=1
    Do While u<=(l-2)
        c1=Mid(tempkette,u,1)
        If c1<>" " Then
            o=0
            wort=c1
            Do While ((o+u)<l) And (c1<>" ")
                o=o+1
                c1=Mid(tempkette,u+o,1)
                If c1<>" " Then
                    wort=wort&c1
                End If
            Loop
            u=u+o
            If dropshortstrings=True Then
                If Len(wort)>2 Then
                    tempkette2=tempkette2&" "&wort
                End If
            Else
                tempkette2=tempkette2&" "&wort
            End If
        End If
        u=u+1
        
    Loop
    
    NormString=Trim(tempkette2)
    
    
End Function

Function Zufallszahl(von, bis)
    On Error Resume Next
    anzahl = bis-von+1
    Randomize
    Zufallszahl = Fix(Rnd*(anzahl))+von
End Function

Function RegRead(tempkey)
    On Error Resume Next
    privkey = tempkey
    
    RegRead = objWSHShell.RegRead(privkey)
    If Not Err.number=0 Then
        objWshShell.LogEvent 1, "Fehler: Registrierungsschlssel nicht gesetzt."
        RegRead=""
        Err.clear
        WScript.Quit
    End If
End Function

Function readjob(tempname)
    
    On Error Resume Next
    Err.Clear
    readjob=True
    
    If Not fs.FileExists(tempname) Then
        Err.clear
        errortxt=tempname&" Datei nicht vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        readjob=False
        Err.clear
    End If
    
    If readjob=True Then	
        Set jobfile = fs.OpenTextFile(tempname,1)
        If Err.number Then
            Err.clear
            errortxt="Jobdatei nicht vorhanden oder nicht lesbar."
            objWshShell.LogEvent 1, errortxt
            
            readjob=False
            
        End If 
    End If
    
    
    
    
    If readjob = True Then
        
        Do While jobfile.AtEndOfStream <> True
            kette=jobfile.readline
            If Left(kette,1)<>";" Then
                
                
                If InStr(1,kette,"Tabelle=",1)<>0 Then
                    
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Tabelle=",1)+7))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        folderID = wert
                    End If
                End If
                
                If InStr(1,kette,"Orginal=",1)<>0 Then
                    
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Orginal=",1)+7))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        doc_loc = wert
                    End If
                End If
                
                If InStr(1,kette,"Quelle=",1)<>0 Then
                    
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Quelle=",1)+6))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        ori_loc = wert
                    End If
                End If
                
                If InStr(1,kette,"Name=",1)<>0 Then
                    
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Name=",1)+4))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        folderName = wert
                    End If
                End If
                
                If InStr(1,kette,"Titel=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Titel=",1)+5))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        myname = wert
                    End If
                End If
                
                If InStr(1,kette,"Felder=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Felder=",1)+7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Zusatzfelder = strconvert(wert)
                        If Zusatzfelder > limit Then
                            errortxt="Jobdatei: mehr als "&limit&" Zusatzfelder werden nicht untersttzt."
                            objWshShell.LogEvent 1, errortxt
                            readjob=False
                        End If
                        'If Zusatzfelder > 0 Then
                        '	checkOCR=false
                        'End If
                    End If
                End If
                
                
                If InStr(1,kette,"ZusTitel",1)<>0 Then
                    
                    wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"ZusTitel",1)+9)))
                    If Len(wert)>0 Then
                        If Left(wert,1)="=" Then
                            wert=Right(wert,Len(wert)-1)
                        End If
                    End If
                    
                    gefunden=False
                    x=0
                    Do While gefunden=False
                        If Zusfeld(x)="" Then
                            gefunden=True
                            Zusfeld(x)=wert
                        End If
                        If gefunden=False Then
                            x=x+1
                        End If
                    Loop
                    
                End If
                
                If InStr(1,kette,"ZusWert",1)<>0 Then
                    wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"ZusWert",1)+8)))
                    If Len(wert)>0 Then
                        If Left(wert,1)="=" Then
                            wert=Right(wert,Len(wert)-1)
                        End If
                    End If
                    
                    pos1=InStr(InStr(1,kette,"=",1),kette,wert,1)
                    If wert="" Then
                        pos1=0
                    End If
                    If pos1>3 Then
                        wert=Right(kette,Len(kette)-pos1+1)
                    Else
                        wert=""
                    End If
                    
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Zuswert(x)=wert
                    End If
                End If
                
            End If
            
        Loop
        jobfile.close
        Set jobfile = Nothing
        
    End If
    
    
End Function



Function getstatustext(thestatus, params)
    readlangfile=True
    statustextfound=False
    i=1
    '********* newstatus.lang vorhanden und lesbar?
    If Not fs.FileExists(programm&"newstatus.lang") Then
        Err.clear
        errortxt="newstatus.lang nicht im Scriptpfad vorhanden oder nicht lesbar."
        objWshShell.LogEvent 2, errortxt
        Err.clear
        readlangfile=False
    Else
        Err.clear	
        Set langfile = fs.OpenTextFile(programm&"newstatus.lang",1)
        
        If Err.number Then
            
            errortxt="newstatus.lang nicht im Scriptpfad vorhanden oder nicht lesbar."&vbCrLf&Err.Description
            objWshShell.LogEvent 2, errortxt
            Err.clear
            readlangfile=False
        End If 
    End If
    
    '********** nach passendem status-text suchen
    If readlangfile=True Then
        kette=langfile.readline	
        While langfile.AtEndOfStream <> True And statustextfound <> True 
            '*** passende Sprache gefunden
            If (Trim(kette)=newstatuslang) Then                     
                While langfile.AtEndOfStream <> True And kette <> "end" And statustextfound = False
                    kette=langfile.readline
                    '*** passender Status gefunden
                    If Left(Trim(kette), 8)=thestatus Then 
                        statustext=Right(Trim(kette),Len(Trim(kette))-9)
                        While (params(i)<>"")
                            statustext=Replace(statustext, "%"&i, params(i))
                            i = i + 1                     	
                        Wend
                        getstatustext=statustext
                        statustextfound=True
                    End If 
                Wend
            End If
            kette=langfile.readline
        Wend
    End If
    
    '*** newstatus.lang nicht gefunden oder kein passender Text in newstatus.lang gefunden
    '*** standard-Text wird zurckgegeben
    
    If readlangfile=False Or statustextfound = False Then
        getstatustext="status-Text nicht gefunden!"
    End If
    
End Function


Function usermailinfo(stradr)
	Set oExec    = objWSHShell.Exec(programm&"userinfo.exe -u " & profil & " " & Chr(34) & stradr & Chr(34))
    
    Do While Not oExec.StdOut.AtEndOfStream
        strinput = strinput & oExec.StdOut.Read(1)	
    Loop
    
    durch = False
    schleife = 0
    Do While schleife < 50
        If oExec.Status = 1 Then 
            durch = True
            Exit Do
        End If
        
        WScript.Sleep 100  
        schleife = schleife +1
    Loop
    Ende = Timer
    
    If durch = False Then
        objWshShell.LogEvent 1, "workflow.vbs userinfo.exe: Schwerwiegender Fehler" & vbCrLf & "userinfo.exe antwortet nicht oder wird nicht beendet" & vbCrLf & "Status: " & oExec.Status & vbCrLf & "Exitcode " & oExec.ExitCode & vbCrLf & "Schleife: " & schleife
        returnvalue  = 8
        oExec.Terminate
        'Exit Do
    Else
        returnvalue = oExec.ExitCode
    End If
    
    If scriptdebug=True Then
        objWshShell.LogEvent 4, "workflow.vbs Function userinfo: userinfo.exe ausgefhrt" & vbCrLf & "Status: " & oExec.Status & vbCrLf & "Exitcode " & oExec.ExitCode & vbCrLf & "Schleife: " & schleife &vbCrLf& strinput
        
    End If
    usr_mail = ""
    pos = 0
    Do Until strinput = "" Or InStr(1,strinput,"usr_mail:") = 0 
        pos = InStr(1, strinput, "usr_mail:")
        
        If pos <> 0 Then
            pos_crlf = InStr(pos,strinput,vbCrLf)
            
            If Mid(strinput,pos + 9,1) = vbCrLf Then
                'nicht gefunden
            Else
                'gefunden
                usr_mail =  Mid(strinput,pos + 9,InStr(pos + 9, strinput, vbCrLf) - (pos +9)) 
                If usr_mail <> "" Then
                    strusr = strusr & usr_mail & ";"
                End If 
            End If 
            
            strinput = Right(strinput,Len(strinput) - pos_crlf)
            
        End If 
    Loop
    usermailinfo = usr_mail
End Function

