unit bfaBaseParser;

interface

uses
  bfaBaseObjects,
  XMLIntf,
  Generics.Collections,
  ComCtrls,
  Classes,
//  EncdDecd,
  bfaCommonUtils
  //,
  //bfaCommonMethods
  ;

function ObjectToXML(ObjList : TList<TbfaBaseObject>; CreateList : Boolean = False;
  XMLEncoding : string = 'US-ASCII'; FileName : string = '';
  BookMarkName : string = ''; XML : IXMLDocument = nil;
  RootNode: IXMLNode = nil; WithAddfieldItems : Boolean = True) : WideString;

function XMLToObject(XMLNode : IXMLNode; FileName : string = '') : TList<TbfaBaseObject>;
function XMLStringToObject(xmlstr : string; FileName : string = '') : TList<TbfaBaseObject>;
//function XMLToAddField(XMLNode : IXMLNode): TbfaAddField;
//function XMLToStsField(XMLNode : IXMLNode): TbfaStateField;
//function XMLToHistory(XMLNode : IXMLNode): TbfaHistory;
//function XMLToSvnField(XMLNode : IXMLNode): TbfaSvnField;
//function XMLToWorkflow(XMLNode : IXMLNode): TbfaWorkflow;
//function XMLToFieldRights(XMLNode : IXMLNode): TList<TbfaFieldRight>;
//function XMLToADEntry(XMLNode : IXMLNode): TbfaADEntry;
//function XMLToPredictionResult(XMLNode : IXMLNode): TbfaPredictionResult;
function XMLToGridConfig(XMLNode : IXMLNode): TbfaGridConfig;
function XMLToColumnConfig(XMLNode : IXMLNode): TbfaColumnConfig;

//procedure LoadBookmarkList(Log : TbfaLog; TV : TJvTreeView;
//  TvRootNode : TTreeNode; FavType : Integer; User : TbfaUser // 0 - History, 1 - Lokale Lese, 2 - Globale Lese
//  );
//procedure SaveBookmarkList((*AThread : TThread; *)Log : TbfaLog; TNode : TTreeNode;
//  FileName : string = ''; BookMarkName : string = '');
//
//procedure AddOneNode(TNode : TTreeNode; XML : IXMLDocument; RootNode : IXMLNode);
//
//function AddTreeviewNode(Log : TbfaLog; TV : TJVTreeView;
//  RootNode : TTreeNode; Obj : TObject; FavType : Integer; // 0 - History, 1 - Lokale Lese, 2 - Globale Lese
//  First : Boolean = False; NName : string = ''; NodeType : Integer = 0) : TTreeNode;

//procedure SearchObjToXML(XML : IXMLDocument; RootNode : IXMLNode;
//  SObj : TbfaSearch; FavID : Integer = -1; isitem: Boolean = False);
//function XMLToSearchObj(XMLNode : IXMLNode): TbfaSearch;

implementation

uses
  SysUtils, Variants, ActiveX, XMLDoc,
  Windows, IdCoderMIME, StrUtils
  ;

function GetSearchFieldTypes(Value : String) : Integer;
begin
  Result := -1;
  if Value = 'edit' then
    Result := 0
  else if Value = 'date' then
    Result := 1
  else if Value = 'combo' then
    Result := 2
  else if Value = 'comboChecked' then
    Result := 3
  else if Value = 'interval-spin' then
    Result := 5
  else if Value = 'zahl' then
    Result := 6
  else if Value = '0' then
    Result := 0
  else if Value = '1' then
    Result := 1
  else if Value = '2' then
    Result := 2
  else if Value = '3' then
    Result := 3
  else if Value = '4' then
    Result := 4
  else if Value = '5' then
    Result := 5
  else if Value = '6' then
    Result := 6
  else if Value = '7' then
    Result := 7
  else if Value = '8' then
    Result := 8
  else if Value = '9' then
    Result := 9
  else if Value = '10' then
    Result := 10;
end;

function GetSearchTypes(idx : Integer) : string;
begin
  case idx of
    0 : Result := 'search';
    1 : Result := 'locale';
    2 : Result := 'globale';
    3 : Result := 'history';
    4 : Result := 'resub';
    5 : Result := 'addfields';
  end;
end;

procedure DecodeStream(StreamStr : WideString; DocAnnoStream : TMemoryStream);
var
  StreamDecoder : TIdDecoderMIME;
begin
  try
    StreamDecoder := TIdDecoderMIME.Create(nil);
    DocAnnoStream.Clear;
    DocAnnoStream.Position := 0;
    StreamDecoder.DecodeBegin(DocAnnoStream);
    try
      StreamDecoder.Decode(StreamStr);
    finally
      StreamDecoder.DecodeEnd;
    end;
  finally
    FreeAndNil(StreamDecoder);
  end;
end;

//function XMLToAddField(XMLNode : IXMLNode): TbfaAddField;
//var
//  i, j : Integer;
//  Node, SubNode : IXMLNode;
//  formatSettings : TFormatSettings;
//begin
//  GetLocaleFormatSettings(GetUserDefaultLCID, formatSettings);
//  formatSettings.DateSeparator := '-';
//  formatSettings.ShortDateFormat := 'yyyy-mm-dd';
//  Result := TbfaAddField.Create;
//  try
//    for i := 0 to XMLNode.ChildNodes.Count - 1 do
//    begin
//      Node := XMLNode.ChildNodes[i];
//      //Result.Typ := otAdditionalField;
//      if LowerCase(Node.NodeName) = 'rights' then  // Rechtesatz wird noch nicht ausgelesen
//        continue;
//      if (LowerCase(Node.NodeName) = 'items') and (Node.Attributes['typ'] = 'list') then
//      begin
//        for j := 0 to Node.ChildNodes.Count - 1 do
//        begin
//          SubNode := Node.ChildNodes[j];
//          if not VarIsNull(SubNode.NodeValue) then
//            Result.Items.Add(SubNode.NodeValue);
//        end;
//        continue;
//      end;
//      if (LowerCase(Node.NodeName) = 'flags') and (Node.Attributes['typ'] = 'set') then
//      begin
//        for j := 0 to Node.ChildNodes.Count - 1 do
//        begin
//          SubNode := Node.ChildNodes[j];
//          if not VarIsNull(SubNode.NodeValue) then
//          begin
//            if LowerCase(SubNode.NodeValue) = 'enabled' then
//              Result.Flags := 1
//            else if LowerCase(SubNode.NodeValue) = 'deleted' then
//              Result.Flags := 2;
//          end;
//        end;
//        continue;
//      end;
//      try
//        if VarIsNull(Node.NodeValue) then  //14.03.2018 hatte bei flags abgestrzt weil noch nicht implementiert war, aber try except bleibt trotzdem
//          continue;
//      except
//        Continue;
//      end;
//      if LowerCase(Node.NodeName) = 'add' then
//        Result.Name := Node.NodeValue
////      else if LowerCase(Node.NodeName) = 'type' then
////        Result.ValueType := StrToInt64(Node.Text)
//      else if LowerCase(Node.NodeName) = 'type' then
//        Result.Typ := GetSearchFieldTypes(Node.NodeValue)
//      else if ((LowerCase(Node.NodeName) = '_bitfarmaddfield__value') or
//               (LowerCase(Node.NodeName) = 'value') or
//               (LowerCase(Node.NodeName) = 'valueug')) then
//      begin
//        if VarIsNull(Node.Attributes['typ']) then
//           Result.Value := Node.NodeValue
//        else if (Lowercase(Node.Attributes['typ']) = 'datetime.datetime') then
//        begin
//          try
//            if LowerCase(Node.NodeValue) = 'null' then
//              Result.Value := NULL
//            else
//              Result.Value := StrToDateTime(Node.NodeValue, formatSettings)
//          except
//            Result.Value := NULL
//          end;
//        end else if (Lowercase(Node.Attributes['typ']) = 'float') then
//        begin
//          try   // von der Datenbank kommt immer Punkt als Trennzeichen, wir ndern in das clientspezifische Trennzeichen
//            Result.Value := ReplaceStr(Node.NodeValue, '.', formatSettings.DecimalSeparator);
//          Except
//            Result.Value := 0;
//          end;
//        end else
//          Result.Value := Node.NodeValue;
//      end
//      else if ((LowerCase(Node.NodeName) = 'valuehigh') or (LowerCase(Node.NodeName) = 'valueog')) then
//      begin
//        if (not VarIsNull(Node.Attributes['typ'])) and (Lowercase(Node.Attributes['typ']) = 'datetime.datetime') then
//        begin
//          try
//            if LowerCase(Node.NodeValue) = 'null' then
//              Result.ValueHigh := NULL
//            else
//              Result.ValueHigh := StrToDateTime(Node.NodeValue, formatSettings)
//          except
//            Result.ValueHigh := NULL
//          end;
//        end else if (not VarIsNull(Node.Attributes['typ'])) and (Lowercase(Node.Attributes['typ']) = 'float') then
//        begin
//          try     // von der Datenbank kommt immer Punkt als Trennzeichen, wir ndern in das clientspezifische Trennzeichen
//            Result.Value := ReplaceStr(Node.NodeValue, '.', formatSettings.DecimalSeparator);
//          Except
//            Result.Value := 0;
//          end;
//        end else
//          Result.ValueHigh := Node.NodeValue;
//      end
//      else if (LowerCase(Node.NodeName) = 'oldvalue') then
//      begin
//        if (not VarIsNull(Node.Attributes['typ'])) and (Lowercase(Node.Attributes['typ']) = 'datetime.datetime') then
//        begin
//          try
//            if LowerCase(Node.NodeValue) = 'null' then
//              Result.OldValue := NULL
//            else
//              Result.OldValue := StrToDateTime(Node.NodeValue, formatSettings)
//          except
//            Result.OldValue := NULL
//          end;
//        end else if (not VarIsNull(Node.Attributes['typ'])) and (Lowercase(Node.Attributes['typ']) = 'float') then
//        begin
//          try   // von der Datenbank kommt immer Punkt als Trennzeichen, wir ndern in das clientspezifische Trennzeichen
//            Result.Value := ReplaceStr(Node.NodeValue, '.', formatSettings.DecimalSeparator);
//          Except
//            Result.Value := 0;
//          end;
//        end else
//          Result.OldValue := Node.NodeValue;
//      end
//      else if (LowerCase(Node.NodeName) = 'negbtn') then
//        Result.Negate := (Node.NodeValue = '0')
//      else if (LowerCase(Node.NodeName) = 'negated') then
//        Result.Negate := (LowerCase(Node.NodeValue) = 'true')
//      else if (LowerCase(Node.NodeName) = 'displayname') then
//        Result.DisplayName := Node.NodeValue
//      else if (LowerCase(Node.NodeName) = 'id') then
//        Result.ID := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'defaultvalue') then
//        Result.DefaultValue := Node.NodeValue
//      else if (LowerCase(Node.NodeName) = 'indextableid') then
//        Result.IndexTableID := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'controltype') then
//        Result.ControlType := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'enabled') then
//        Result.Enabled := (LowerCase(Node.NodeValue) = 'true')
//      else if (LowerCase(Node.NodeName) = 'controlitems') then
//        Result.ControlItems := Node.NodeValue
//      else if (LowerCase(Node.NodeName) = 'size') then
//        Result.Size := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'mode') then
//        Result.Mode := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'options') then
//        Result.Options := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'modified_search') then
//        Result.ModifiedSearch := (LowerCase(Node.NodeValue) = 'true')
//      else if (LowerCase(Node.NodeName) = 'modified') then
//        Result.Modified := (LowerCase(Node.NodeValue) = 'true')
//      else if (LowerCase(Node.NodeName) = 'checkprogram') then
//        Result.Checkprogram := Node.NodeValue
//    end;
//
//  except
//    Result := nil;
//  end;
//end;

//procedure AddFieldToXML(XML : IXMLDocument; RootNode : IXMLNode;
//  AddField : TbfaAddField; isitem: Boolean = False; WithAddfieldItems : Boolean = True);
//var
//  FirstNode, CurNode : IXMLNode;
//  fieldtype: string;
//begin
//  try
//    if RootNode = nil then
//    begin
//      RootNode := XML.AddChild('BitfarmAddfield');
//      FirstNode := RootNode;
//    end
//    else if not isitem then
//      FirstNode := RootNode.AddChild('BitfarmAddfield')
//    else
//      FirstNode := RootNode;
//
//    fieldtype := 'unicode';
//    case AddField.Typ of
//      0,2,3,4,5,11,13,14:
//        fieldtype := 'str';
//      1, 12:
//        fieldtype := 'datetime.datetime';
//      6:
//        fieldtype := 'int';
//      7,8:
//        fieldtype := 'float';
//    end;
//
////15.09.2017 Variant Fehler Dtae kann nicht als string geprft werden   if not (VarIsNull(AddField.Value) or (AddField.Value = '0') or (AddField.Value = '0,00') or
////     (AddField.Value = '0,0000000000') or (AddField.Value = '0T')) then
//    if (not VarIsNull(AddField.Value)) and
//       ( not ((VarIsType(AddField.Value, varUString)) and (
////15.01.2018 Ticket 12363 -->
////       (AddField.Value = '0') or
////      (AddField.Value = '0,00') or (AddField.Value = '0,0000000000') or
////15.01.2018 Ticket 12363 <--
//
////  SJ 18.07.2019
////  Eingrenzung der berprfung auf Intervall Felder
////  Erweiterung der berprfung um '0W', '0M', '0J', 'T', 'W', 'M', 'J'
////       (AddField.Value = '0T')
//         (AddField.Typ in [5]) and (
//          (LeftStr(AddField.Value, Length(AddField.Value)-1) = '0') or
//          (LeftStr(AddField.Value, Length(AddField.Value)-1) = '')
//        )
//      ))
//       )
//    then
//    begin
//      CurNode := FirstNode.AddChild('_BitfarmAddfield__value');
//      CurNode.Attributes['typ'] := fieldtype;
//      if (AddField.Typ in [1,12]) then
//      begin
//        if VarIsType(AddField.Value, varDate) and (not IsEmptyDate(AddField.Value)) then
////25.04.2018 Ticket 13347 -->
//          CurNode.Text := FormatDateTime('yyyy-mm-dd 00:00:00', AddField.Value)
////25.04.2018          CurNode.Text := FormatDateTime('yyyy-mm-dd', AddField.Value)
//        else if VarIsType(AddField.Value, varUString) and (AddField.Value <> '') then
////25.04.2018 Ticket 13347
//          CurNode.Text := FormatDateTime('yyyy-mm-dd 00:00:00', VarToDateTime(AddField.Value))
//        else if VarIsType(AddField.Value, varString) and (AddField.Value <> '') then
//          CurNode.Text := FormatDateTime('yyyy-mm-dd 00:00:00', StrToDate(AddField.Value));
////25.04.2018          CurNode.Text := FormatDateTime('yyyy-mm-dd', StrToDate(AddField.Value))
////25.04.2018 Ticket 13347 <--
//
//      end else if (AddField.Typ in [7,8]) then
//      begin     // falls ein Komma drin stehen sollte, wird es zu Punkt gewandelt, das erwartet die DB
//        CurNode.Text := ReplaceStr(AddField.Value, ',', '.');
//      end
//      else
//        CurNode.Text := AddField.Value;
//    end else
//    begin
//      CurNode := FirstNode.AddChild('_BitfarmAddfield__value');
//      CurNode.Attributes['typ'] := fieldtype;
//      if AddField.Typ in [1,5,6,7,8,12] then
//      begin
//        if VarIsNull(AddField.Value) and (AddField.ModifiedSearch) then // Bei der Suche brauchen wir NULL fr Suche nach leeren Zusatzfelder
//          CurNode.Text := 'NULL'
//        else
//          CurNode.Text := '';
//      end;
//    end;
//
//    if not VarIsNull(AddField.ValueHigh) then
//    begin
//      CurNode := FirstNode.AddChild('valuehigh');
//      CurNode.Attributes['typ'] := fieldtype;
//      if (AddField.Typ in [1,12]) then
//      begin
//          if VarIsType(AddField.ValueHigh, varDate) and (not IsEmptyDate(AddField.ValueHigh)) then
//            CurNode.Text := FormatDateTime('yyyy-mm-dd 00:00:00', AddField.ValueHigh)
//          else if VarIsType(AddField.ValueHigh, varUString) and (AddField.ValueHigh <> '') then
//            CurNode.Text := FormatDateTime('yyyy-mm-dd 00:00:00', VarToDateTime(AddField.ValueHigh))
//          else if VarIsType(AddField.ValueHigh, varString) and (AddField.ValueHigh <> '') then
//            CurNode.Text := FormatDateTime('yyyy-mm-dd 00:00:00', StrToDate(AddField.ValueHigh));
//      end else if (AddField.Typ in [7,8]) then
//      begin    // falls ein Komma drin stehen sollte, wird es zu Punkt gewandelt, das erwartet die DB
//        CurNode.Text := ReplaceStr(AddField.ValueHigh, ',', '.');
//      end
//      else
//        CurNode.Text := AddField.ValueHigh;
//    end;
//
//    if not VarIsNull(AddField.OldValue) then
//    begin
//      CurNode := FirstNode.AddChild('oldvalue');
//      CurNode.Attributes['typ'] := fieldtype;
//      if (AddField.Typ in [1,12]) then
//      begin
//        if VarIsType(AddField.OldValue, varDate) and (not IsEmptyDate(AddField.OldValue)) then
//          CurNode.Text := FormatDateTime('yyyy-mm-dd 00:00:00', AddField.OldValue)
//        else if VarIsType(AddField.Value, varUString) and (AddField.OldValue <> '') then
////30.08.2021 Ticket 28297 Workaround, muss geprft werden! -->
////          CurNode.Text := FormatDateTime('yyyy-mm-dd 00:00:00', StrToDate(AddField.OldValue))
//        begin
//          if Pos(' ', AddField.OldValue) > 0 then
//            CurNode.Text := Copy(AddField.OldValue, 1, Pos(' ', AddField.OldValue) - 1)
//          else
//            CurNode.Text := FormatDateTime('yyyy-mm-dd 00:00:00', StrToDate(AddField.OldValue));
//        end;
////30.08.2021 Ticket 28297 <--
//      end else if (AddField.Typ in [7,8]) then
//      begin    // falls ein Komma drin stehen sollte, wird es zu Punkt gewandelt, das erwartet die DB
//        CurNode.Text := ReplaceStr(AddField.OldValue, ',', '.');
//      end
//      else
//        CurNode.Text := AddField.OldValue;
//    end;
//
//    CurNode := FirstNode.AddChild('add');
//    CurNode.Attributes['typ'] := 'unicode';
//    CurNode.Text := AddField.Name;
//
//    CurNode := FirstNode.AddChild('type');
//    CurNode.Attributes['typ'] := 'int';
//    CurNode.Text := IntToStr(AddField.Typ);
//
//    CurNode := FirstNode.AddChild('indextableid');
//    CurNode.Attributes['typ'] := 'int';
//    CurNode.Text := IntToStr(AddField.IndexTableID);
//
//    if AddField.Negate then
//    begin
//      CurNode := FirstNode.AddChild('negated');
//      CurNode.Attributes['typ'] := 'bool';
//      if (AddField.Negate) then
//        CurNode.Text := 'True'
//      else
//        CurNode.Text := 'False';
//    end;
//
//    if AddField.Or_Junction then
//    begin
//      CurNode := FirstNode.AddChild('or_junction');
//      CurNode.Attributes['typ'] := 'bool';
//      if (AddField.Or_Junction) then
//        CurNode.Text := 'True'
//      else
//        CurNode.Text := 'False';
//    end;
//
//    if AddField.DisplayName <> '' then
//    begin
//      CurNode := FirstNode.AddChild('name');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := AddField.DisplayName;
//    end;
//
//    if AddField.Checkprogram <> '' then
//    begin
//      CurNode := FirstNode.AddChild('checkprogram');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := AddField.Checkprogram;
//    end;
//
//    if AddField.ValuesQuery <> '' then
//    begin
//      CurNode := FirstNode.AddChild('values_query');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := AddField.ValuesQuery;
//    end;
//
//    if AddField.Description <> '' then
//    begin
//      CurNode := FirstNode.AddChild('description');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := AddField.Description;
//    end;
//
//    CurNode := FirstNode.AddChild('id');
//    CurNode.Attributes['typ'] := 'long';
//    CurNode.Text := IntToStr(AddField.ID);
//
//    if AddField.DefaultValue <> '' then
//    begin
//      CurNode := FirstNode.AddChild('defaultvalue');
//      CurNode.Attributes['typ'] := fieldtype;
//      CurNode.Text := AddField.DefaultValue;
//    end;
//
//    if AddField.ControlType <> -1 then
//    begin
//      CurNode := FirstNode.AddChild('controltype');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(AddField.ControlType);
//    end;
//
//    if WithAddfieldItems then //25.07.2018 bei der Suche macht Probleme mit mehreren 100 Eintrgen, deswegen eingebut
//    begin
//      if AddField.ControlItems <> '' then
//      begin
//        CurNode := FirstNode.AddChild('controlitems');
//        CurNode.Attributes['typ'] := 'unicode';
//        CurNode.Text := AddField.ControlItems;
//      end;
//
//      if AddField.Items.Count > 0 then
//      begin
//        CurNode := FirstNode.AddChild('items');
//        CurNode.Attributes['typ'] := 'unicode';
//          CurNode.Text := ParseNotAllowedChars(AddField.Items.DelimitedText);
//      end;
//    end;
//
//    if AddField.Size <> -1 then
//    begin
//      CurNode := FirstNode.AddChild('size');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(AddField.Size);
//    end;
//
//    if AddField.Mode <> -1 then
//    begin
//      CurNode := FirstNode.AddChild('mode');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(AddField.Mode);
//    end;
//
//    if AddField.Options <> -1 then
//    begin
//      CurNode := FirstNode.AddChild('options');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(AddField.Options);
//    end;
//
//    if AddField.Flags <> -1 then
//    begin
//      CurNode := FirstNode.AddChild('flags');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(AddField.Flags);
//    end;
//
//    if AddField.Enabled then
//    begin
//      CurNode := FirstNode.AddChild('enabled');
//      CurNode.Attributes['typ'] := 'bool';
//      if (AddField.Enabled) then
//        CurNode.Text := 'True'
//      else
//        CurNode.Text := 'False';
//    end;
//
//    if AddField.ModifiedSearch then
//    begin
//      CurNode := FirstNode.AddChild('modified_search');
//      CurNode.Attributes['typ'] := 'bool';
//      if (AddField.ModifiedSearch) then
//        CurNode.Text := 'True'
//      else
//        CurNode.Text := 'False';
//    end;
//
//    if AddField.Modified then
//    begin
//      CurNode := FirstNode.AddChild('modified');
//      CurNode.Attributes['typ'] := 'bool';
//      if (AddField.Modified) then
//        CurNode.Text := 'True'
//      else
//        CurNode.Text := 'False';
//    end;
//
//    if GUIDToString(AddField.TempID) <> cEmptyGUID then
//    begin
//      CurNode := FirstNode.AddChild('tempid');
//      CurNode.Attributes['typ'] := 'str';
//      CurNode.Text := GUIDToString(AddField.TempID);
//    end;
//
//  except
//
//  end;
//end;

//function XMLToStsField(XMLNode : IXMLNode): TbfaStateField;
//var
//  i : Integer;
//  Node : IXMLNode;
//begin
//  Result := TbfaStateField.Create;
//  try
//    for i := 0 to XMLNode.ChildNodes.Count - 1 do
//    begin
//      Node := XMLNode.ChildNodes[i];
//      Result.Typ := otStatusField;
//      if LowerCase(Node.NodeName) = 'rights' then  // Rechtesatz wird noch nicht ausgelesen
//        continue;
//      if VarIsNull(Node.NodeValue) then
//        continue;
//      if LowerCase(Node.NodeName) = 'name' then
//        Result.DisplayName := Node.NodeValue
//      else if ((LowerCase(Node.NodeName) = 'bitmask') or (LowerCase(Node.NodeName) = '_bitfarmstatefield__bitmask')) then
//      begin
//        if Lowercase(Node.NodeValue) = 'none' then
//          continue;
//
//        Result.Bitmask := StrToInt64(Node.NodeValue);
//      end
//      else if ((LowerCase(Node.NodeName) = 'value') or (LowerCase(Node.NodeName) = '_bitfarmstatefield__value')) then
//        Result.Value := Node.NodeValue
//      else if (LowerCase(Node.NodeName) = 'oldvalue') then
//        Result.OldValue := Node.NodeValue
//      else if (LowerCase(Node.NodeName) = 'negbtn') then
//        Result.Negate := (Node.NodeValue = '1')
//      else if (LowerCase(Node.NodeName) = 'negated') then
//        Result.Negate := (LowerCase(Node.NodeValue) = 'true')
//      else if (LowerCase(Node.NodeName) = 'displayname') then
//        Result.DisplayName := Node.NodeValue
//      else if (LowerCase(Node.NodeName) = 'id') then
//        Result.ID := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'defaultvalue') then
//        Result.DefaultValue := Node.NodeValue
//      else if (LowerCase(Node.NodeName) = 'indexcolumnid') then
//        Result.IndexColumnID := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'enabled') then
//        Result.Enabled := (LowerCase(Node.NodeValue) = 'true')
//      else if LowerCase(Node.NodeName) = 'addfieldid' then
//        Result.AddfieldID := StrToInt(Node.NodeValue)
//      else if LowerCase(Node.NodeName) = 'func' then
//        Result.Func := StrToInt(Node.NodeValue);
//
//    end;
//  except
//    Result := nil;
//  end;
//end;
//
//function XMLToHistory(XMLNode : IXMLNode): TbfaHistory;
//var
//  i : Integer;
//  Node : IXMLNode;
//  formatSettings : TFormatSettings;
//begin
//  GetLocaleFormatSettings(GetUserDefaultLCID, formatSettings);
//  formatSettings.DateSeparator := '-';
//  formatSettings.ShortDateFormat := 'yyyy-mm-dd';
//  Result := TbfaHistory.Create;
//  try
//    for i := 0 to XMLNode.ChildNodes.Count - 1 do
//    begin
//      Node := XMLNode.ChildNodes[i];
//
//      if VarIsNull(Node.NodeValue) then
//        continue;
//      if LowerCase(Node.NodeName) = '_msg' then
//        Result.Msg := Node.NodeValue
//      else if (LowerCase(Node.NodeName) = 'value1') then
//        Result.Value1 := Node.NodeValue
//      else if (LowerCase(Node.NodeName) = 'value2') then
//        Result.Value2 := Node.NodeValue
//      else if (LowerCase(Node.NodeName) = 'value3') then
//        Result.Value3 := Node.NodeValue
//      else if (LowerCase(Node.NodeName) = 'username') then
//        Result.Username := Node.NodeValue
//      else if (LowerCase(Node.NodeName) = 'taskid') then
//        Result.Taskid := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = '_gdocid') then
//        Result.Gdocid := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'userid') then
//        Result.Userid := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = '_date') then
//      begin
//        try
//          Result.Date := StrToDateTime(Node.NodeValue,formatSettings);
//        except
//          Result.Date := NULL
//        end;
//      end;
//    end;
//  except
//    Result := nil;
//  end;
//end;
//
//
//function XMLToADEntry(XMLNode : IXMLNode): TbfaADEntry;
//var
//  i : Integer;
//  Node : IXMLNode;
//begin
//  Result := TbfaADEntry.Create;
//  try
//    for i := 0 to XMLNode.ChildNodes.Count - 1 do
//    begin
//      Node := XMLNode.ChildNodes[i];
//
//      if VarIsNull(Node.NodeValue) then
//        continue;
//      if LowerCase(Node.NodeName) = 'adclass' then
//        Result.ADClass := Node.NodeValue
//     else if LowerCase(Node.NodeName) = 'adpath' then
//        Result.ADPath := Node.NodeValue
//     else if (LowerCase(Node.NodeName) = 'displayname') then
//        Result.Displayname := Node.NodeValue
//      else if (LowerCase(Node.NodeName) = 'samaccountname') then
//        Result.SamAccountname := Node.NodeValue
//      else if (LowerCase(Node.NodeName) = 'mail') then
//        Result.Mail :=  Node.NodeValue
//      else if (LowerCase(Node.NodeName) = 'useraccountcontrol') then
//        Result.UserAccountControl := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'has_user') then
//        Result.HasUser := LowerCase(Node.NodeValue) = 'true';
//    end;
//  except
//    Result := nil;
//  end;
//end;
//
//function XMLToPredictionResult(XMLNode : IXMLNode): TbfaPredictionResult;
//var
//  i : Integer;
//  Node : IXMLNode;
//begin
//  Result := TbfaPredictionResult.Create;
//  try
//    for i := 0 to XMLNode.ChildNodes.Count - 1 do
//    begin
//      Node := XMLNode.ChildNodes[i];
//
//      if VarIsNull(Node.NodeValue) then
//        continue;
//      if LowerCase(Node.NodeName) = 'guid' then
//        Result.GUID := Node.NodeValue
//      else if LowerCase(Node.NodeName) = 'page' then
//        Result.Page := StrToInt(Node.NodeValue)
//      else if LowerCase(Node.NodeName) = 'classid' then
//        Result.ClassID := StrToInt(Node.NodeValue)
//    end;
//  except
//    Result := nil;
//  end;
//end;
//
function XMLToColumnConfig(XMLNode : IXMLNode): TbfaColumnConfig;
var
  i : Integer;
  Node : IXMLNode;
begin
  Result := TbfaColumnConfig.Create;
  try
    for i := 0 to XMLNode.ChildNodes.Count - 1 do
    begin
        Node := XMLNode.ChildNodes[i];

      if VarIsNull(Node.NodeValue) then
        continue;
      if LowerCase(Node.NodeName) = 'name' then
        Result.Name := Node.NodeValue
      else if LowerCase(Node.NodeName) = 'fieldname' then
        Result.Fieldname := Node.NodeValue
      else if LowerCase(Node.NodeName) = 'columntype' then
        Result.ColumnType := TbfaColumnType(StrToInt(Node.NodeValue))
      else if LowerCase(Node.NodeName) = 'valuetype' then
        Result.ValueType := TbfaValueType(StrToInt(Node.NodeValue))
      else if LowerCase(Node.NodeName) = 'summarytype' then
        Result.SummaryType := TbfaSummaryKind(StrToInt(Node.NodeValue))
      else if LowerCase(Node.NodeName) = 'readonly' then
        Result.ReadOnly:= LowerCase(Node.NodeValue) = 'true'
      else if LowerCase(Node.NodeName) = 'displayformat' then
        Result.DisplayFormat := Node.NodeValue
      else if LowerCase(Node.NodeName) = 'editformat' then
        Result.EditFormat := Node.NodeValue
      else if LowerCase(Node.NodeName) = 'expression' then
        Result.Expression := Node.NodeValue
      else if LowerCase(Node.NodeName) = 'listtype' then
        Result.ListType := TbfaListType(StrToInt(Node.NodeValue))
      else if LowerCase(Node.NodeName) = 'listitems' then
        Result.ListItems.DelimitedText := Node.NodeValue
      else if LowerCase(Node.NodeName) = 'listaddfield' then
        Result.ListAddfield := StrToInt(Node.NodeValue)
      else if LowerCase(Node.NodeName) = 'colwidth' then
        Result.ColWidth := StrToInt(Node.NodeValue)
      else if LowerCase(Node.NodeName) = 'defaultvalue' then
        Result.DefaultValue := Node.NodeValue        ;
    end;
  except
    Result := nil;
  end;
end;

function XMLToGridConfig(XMLNode : IXMLNode): TbfaGridConfig;
var
  i, j : Integer;
  Node, SubNode : IXMLNode;
begin
  Result := TbfaGridConfig.Create;
  try
    for i := 0 to XMLNode.ChildNodes.Count - 1 do
    begin
      Node := XMLNode.ChildNodes[i];
      if LowerCase(Node.NodeName) = 'columns' then
      begin
        for j := 0 to Node.ChildNodes.Count -1 do
        begin
          SubNode := Node.ChildNodes[j];
          Result.Columns.Add(XMLToColumnConfig(SubNode))
        end;
        Continue;
      end;
      if VarIsNull(Node.NodeValue) then
        continue;
      if LowerCase(Node.NodeName) = 'displayname' then
        Result.Displayname := Node.NodeValue
      else if LowerCase(Node.NodeName) = 'showsummary' then
        Result.ShowSummary := LowerCase(Node.NodeValue) = 'true'
      else if LowerCase(Node.NodeName) = 'showheader' then
        Result.ShowHeader := LowerCase(Node.NodeValue) = 'true'
      else if LowerCase(Node.NodeName) = 'showgoupbybox' then
        Result.ShowGroupbybox := LowerCase(Node.NodeValue) = 'true'
      else if LowerCase(Node.NodeName) = 'showindicator' then
        Result.ShowIndicator:= LowerCase(Node.NodeValue) = 'true'
      else if LowerCase(Node.NodeName) = 'usepopups' then
        Result.UsePopups := LowerCase(Node.NodeValue) = 'true'
      else if LowerCase(Node.NodeName) = 'usecolumnnames' then
        Result.UseColumnNames := LowerCase(Node.NodeValue) = 'true'
      else if LowerCase(Node.NodeName) = 'export_addfields' then
        Result.ExportAddfields := LowerCase(Node.NodeValue) = 'true'
      else if LowerCase(Node.NodeName) = 'export_unicode' then
        Result.ExportUnicode := LowerCase(Node.NodeValue) = 'true'
      else if LowerCase(Node.NodeName) = 'manualsorting' then
        Result.ManualSorting := LowerCase(Node.NodeValue) = 'true'
//      else if LowerCase(Node.NodeName) = 'alternate_rows' then
//        Result.AlternateRows := LowerCase(Node.NodeValue) = 'true'
      else if LowerCase(Node.NodeName) = 'multiselect' then
        Result.MultiSelect := LowerCase(Node.NodeValue) = 'true'
      else if LowerCase(Node.NodeName) = 'stamp_transparent' then
        Result.Stamp_Transparent := LowerCase(Node.NodeValue) = 'true'
      else if LowerCase(Node.NodeName) = 'stamp_size' then
        Result.Stamp_Size := StrToInt(Node.NodeValue)
      else if LowerCase(Node.NodeName) = 'stamp_color' then
        Result.Stamp_Color := Node.NodeValue
      else if LowerCase(Node.NodeName) = 'searchfield' then
        Result.SearchField := Node.NodeValue;
    end;
  except
    Result := nil;
  end;
end;
//
//function XMLToDLM(XMLNode : IXMLNode): TbfaDLM;
//var
//  i : Integer;
//  Node : IXMLNode;
//  formatSettings : TFormatSettings;
//begin
//  GetLocaleFormatSettings(GetUserDefaultLCID, formatSettings);
//  formatSettings.DateSeparator := '-';
//  formatSettings.ShortDateFormat := 'yyyy-mm-dd';
//  Result := TbfaDLM.Create;
//  try
//    for i := 0 to XMLNode.ChildNodes.Count - 1 do
//    begin
//      Node := XMLNode.ChildNodes[i];
//
//      if VarIsNull(Node.NodeValue) then
//        continue;
//      if LowerCase(Node.NodeName) = 'id' then
//        Result.ID := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'item') then
//        Result.Item := Node.NodeValue
//      else if (LowerCase(Node.NodeName) = 'interval') then
//        Result.interval := Node.NodeValue
//      else if (LowerCase(Node.NodeName) = 'type') then
//        Result.Typ := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'fieldid') then
//        Result.Fieldid := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'prio') then
//        Result.Prio := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'mode') then
//        Result.Mode := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'date') then
//      begin
//        try
//          Result.Date := StrToDateTime(Node.NodeValue,formatSettings);
//        except
//          Result.Date := NULL
//        end;
//      end;
//    end;
//  except
//    Result := nil;
//  end;
//end;
//
//function XMLToSvnField(XMLNode : IXMLNode): TbfaSvnField;
//var
//  i : Integer;
//  Node : IXMLNode;
//  formatSettings : TFormatSettings;
//begin
//  GetLocaleFormatSettings(GetUserDefaultLCID, formatSettings);
//  formatSettings.DateSeparator := '-';
//  formatSettings.ShortDateFormat := 'yyyy-mm-dd';
//  Result := TbfaSvnField.Create;
//  try
//    for i := 0 to XMLNode.ChildNodes.Count - 1 do
//    begin
//      Node := XMLNode.ChildNodes[i];
//
//      if VarIsNull(Node.NodeValue) then
//        continue;
//      if LowerCase(Node.NodeName) = 'svn_info' then
//        Result.Info := Node.NodeValue
//      else if (LowerCase(Node.NodeName) = '_svn_id') then
//        Result.ID := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = '_gdocid') then
//        Result.Gdocid := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'svn_userid') then
//        Result.Userid := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = '_svn_version') then
//        Result.Version := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = '_svn_revision') then
//        Result.Revision := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = '_svn_date') then
//      begin
//        try
//          Result.Date := StrToDateTime(Node.NodeValue,formatSettings);
//        except
//          Result.Date := NULL
//        end;
//      end;
//    end;
//  except
//    Result := nil;
//  end;
//end;
//
//function XMLToWorkflow(XMLNode : IXMLNode): TbfaWorkflow;
//var
//  i : Integer;
//  Node : IXMLNode;
//  formatSettings : TFormatSettings;
//begin
//  GetLocaleFormatSettings(GetUserDefaultLCID, formatSettings);
//  formatSettings.DateSeparator := '-';
//  formatSettings.ShortDateFormat := 'yyyy-mm-dd';
//  Result := TbfaWorkflow.Create;
//  try
//    for i := 0 to XMLNode.ChildNodes.Count - 1 do
//    begin
//      Node := XMLNode.ChildNodes[i];
//
//      if VarIsNull(Node.NodeValue) then
//        continue;
//      if LowerCase(Node.NodeName) = 'info' then
//        Result.Info := Node.NodeValue
//      else if LowerCase(Node.NodeName) = 'comment' then
//        Result.Comment := Node.NodeValue
//      else if (LowerCase(Node.NodeName) = 'tim_id') then
//        Result.TimID := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'tim_ref') then
//        Result.TimRef := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = '_BitfarmBaseObject__gdocid') then
//        Result.Gdocid := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'status') then
//        Result.Status := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'options') then
//        Result.Options := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'status') then
//        Result.Status := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'userid_work') then
//        Result.UseridWork := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'userid_shed') then
//        Result.UseridShed := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'groupid') then
//        Result.GroupID := StrToInt(Node.NodeValue)
//      else if (LowerCase(Node.NodeName) = 'date') then
//      begin
//        try
//          Result.Date := StrToDateTime(Node.NodeValue,formatSettings);
//        except
//          Result.Date := NULL
//        end;
//      end
//      else if (LowerCase(Node.NodeName) = 'alarm_date') then
//      begin
//        try
//          Result.AlarmDate := StrToDateTime(Node.NodeValue,formatSettings);
//        except
//          Result.AlarmDate := NULL
//        end;
//      end
//      else if (LowerCase(Node.NodeName) = 'modified_date') then
//      begin
//        try
//          Result.ModifiedDate := StrToDateTime(Node.NodeValue,formatSettings);
//        except
//          Result.ModifiedDate := NULL
//        end;
//      end;
//    end;
//  except
//    Result := nil;
//  end;
//end;
//
//
//function XMLToWordPos(XMLNode : IXMLNode): TbfaWordPos;
//var
//  i, j, k, Page, Left, Right, Top, Bottom : Integer;
//  Node, PageNode, PagePos : IXMLNode;
//  Attr : Variant;
//  Coordinate : TbfaCoordinates;
//begin
//  try
////    for i := 0 to XMLNode.ChildNodes.Count - 1 do
////    begin
////      Node := XMLNode.ChildNodes[i];
//      Node := XMLNode;
//
//      if (LowerCase(Node.NodeName) = 'item') and
//         (Lowercase(Node.Attributes['typ']) = 'list') and
//         (Lowercase(Node.Attributes['tagtyp']) = 'int') then
//      begin
//        Attr := Node.Attributes['name'];
//        if not VarIsNULL(Attr) then
//        begin
//          Result := TbfaWordPos.Create;
//          Page := Attr - 1; // ImageEN fngt an von 0!
//          for j := 0 to Node.ChildNodes.Count - 1 do
//          begin
//            PageNode := Node.ChildNodes[j];
//            Attr := PageNode.Attributes['typ'];
//            if LowerCase(Attr) = 'dict' then
//            begin
//              for k := 0 to PageNode.ChildNodes.Count - 1 do
//              begin
//                PagePos := PageNode.ChildNodes[k];
//                Attr := PagePos.Attributes['name'];
//                if not VarIsNull(Attr) then
//                begin
//                  if LowerCase(Attr) = 'tl' then
//                  begin
//                    Top := PagePos.ChildNodes[0].NodeValue;
//                    Left := PagePos.ChildNodes[1].NodeValue;
//                  end
//                  else if LowerCase(Attr) = 'br' then
//                  begin
//                    Bottom := PagePos.ChildNodes[0].NodeValue;
//                    Right := PagePos.ChildNodes[1].NodeValue;
//                  end
//                end;
//              end;
//              SetLength(Result.Coordinates, Length(Result.Coordinates) + 1);
//              Result.Page := Page;
//              Result.Coordinates[Length(Result.Coordinates) - 1].Top := Top;
//              Result.Coordinates[Length(Result.Coordinates) - 1].Left := Left;
//              Result.Coordinates[Length(Result.Coordinates) - 1].Right := Right;
//              Result.Coordinates[Length(Result.Coordinates) - 1].Bottom := Bottom;
//            end;
//          end;
//        end;
//      end;
//
//  except
//    Result := nil;
//  end;
//end;
//
//procedure StsFieldToXML(XML : IXMLDocument; RootNode : IXMLNode; StsField : TbfaStateField; isitem: Boolean = False);
//var
//  FirstNode, CurNode : IXMLNode;
//begin
//  try
//    if RootNode = nil then
//    begin
//      RootNode := XML.AddChild('BitfarmStatefield');
//      FirstNode := RootNode;
//    end
//    else if not isitem then
//      FirstNode := RootNode.AddChild('BitfarmStatefield')
//    else
//      FirstNode := RootNode;
//
//    if not VarIsNull(StsField.Value) then
//    begin
//      CurNode := FirstNode.AddChild('_BitfarmStatefield__value');
//      CurNode.Attributes['typ'] := 'bool';
//      CurNode.Text := StsField.Value;
//    end;
//    if not VarIsNull(StsField.OldValue) then
//    begin
//      CurNode := FirstNode.AddChild('_BitfarmStatefield__oldvalue');
//      CurNode.Attributes['typ'] := 'bool';
//      CurNode.Text := StsField.OldValue;
//    end;
//
//    CurNode := FirstNode.AddChild('name');
//    CurNode.Attributes['typ'] := 'unicode';
//    CurNode.Text := StsField.DisplayName;
//    CurNode := FirstNode.AddChild('id');
//    CurNode.Attributes['typ'] := 'int';
//    CurNode.Text := IntToStr(StsField.ID);
//    CurNode := FirstNode.AddChild('indexcolumnid');
//    CurNode.Attributes['typ'] := 'int';
//    CurNode.Text := IntToStr(StsField.IndexColumnID);
//    CurNode := FirstNode.AddChild('_BitfarmStatefield__bitmask');
//    CurNode.Attributes['typ'] := 'int';
//    CurNode.Text := IntToStr(StsField.Bitmask);
//    CurNode := FirstNode.AddChild('displayname');
//    CurNode.Attributes['typ'] := 'unicode';
//    CurNode.Text := StsField.DisplayName;
//
//    if StsField.Negate then
//    begin
//      CurNode := FirstNode.AddChild('negated');
//      CurNode.Attributes['typ'] := 'bool';
//      if (StsField.Negate) then
//        CurNode.Text := 'True'
//      else
//        CurNode.Text := 'False';
//    end;
//
//    if StsField.Or_Junction then
//    begin
//      CurNode := FirstNode.AddChild('or_junction');
//      CurNode.Attributes['typ'] := 'bool';
//      if (StsField.Or_Junction) then
//        CurNode.Text := 'True'
//      else
//        CurNode.Text := 'False';
//    end;
//
//    if StsField.DefaultValue <> '' then
//    begin
//      CurNode := FirstNode.AddChild('defaultvalue');
//      CurNode.Attributes['typ'] := 'bool';
//      CurNode.Text := StsField.DefaultValue;
//    end;
//
//    if StsField.AddfieldID <> 0 then
//    begin
//      CurNode := FirstNode.AddChild('addfieldid');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(StsField.AddfieldID);
//    end;
//
//    if StsField.Func <> 0 then
//    begin
//      CurNode := FirstNode.AddChild('func');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(StsField.Func);
//    end;
//
//    if StsField.Flags <> 0 then
//    begin
//      CurNode := FirstNode.AddChild('flags');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(StsField.Flags);
//    end;
//
//    if StsField.Enabled then
//    begin
//      CurNode := FirstNode.AddChild('enabled');
//      CurNode.Attributes['typ'] := 'bool';
//      if (StsField.Enabled) then
//        CurNode.Text := 'True'
//      else
//        CurNode.Text := 'False';
//    end;
//
//    if StsField.ModifiedSearch then
//    begin
//      CurNode := FirstNode.AddChild('modified_search');
//      CurNode.Attributes['typ'] := 'bool';
//      if (StsField.ModifiedSearch) then
//        CurNode.Text := 'True'
//      else
//        CurNode.Text := 'False';
//    end;
//
//    if StsField.Modified then
//    begin
//      CurNode := FirstNode.AddChild('modified');
//      CurNode.Attributes['typ'] := 'bool';
//      if (StsField.Modified) then
//        CurNode.Text := 'True'
//      else
//        CurNode.Text := 'False';
//    end;
//    if GUIDToString(StsField.TempID) <> cEmptyGUID then
//    begin
//      CurNode := FirstNode.AddChild('tempid');
//      CurNode.Attributes['typ'] := 'str';
//      CurNode.Text := GUIDToString(StsField.TempID);
//    end;
//  except
//
//  end;
//end;
//
//procedure HistoryToXML(XML : IXMLDocument; RootNode : IXMLNode; Hist : TbfaHistory; isitem: Boolean = False);
//var
//  FirstNode, CurNode : IXMLNode;
//  base64string : WideString;
//begin
//  try
//    if RootNode = nil then
//    begin
//      RootNode := XML.AddChild('BitfarmHistory');
//      FirstNode := RootNode;
//    end
//    else if not isitem then
//      FirstNode := RootNode.AddChild('BitfarmHistory')
//    else
//      FirstNode := RootNode;
//
//    if not VarIsNull(Hist.Msg) then
//    begin
//      CurNode := FirstNode.AddChild('_msg');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := Hist.Msg;
//    end;
//
//    if not VarIsNull(Hist.Value1) then
//    begin
//      CurNode := FirstNode.AddChild('value1');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := Hist.Value1;
//    end;
//
//    if not VarIsNull(Hist.Value2) then
//    begin
//      CurNode := FirstNode.AddChild('value2');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := Hist.Value2;
//    end;
//
//    if not VarIsNull(Hist.Value3) then
//    begin
//      CurNode := FirstNode.AddChild('value3');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := Hist.Value3;
//    end;
//
//    if Hist.Userid <> 0 then
//    begin
//      CurNode := FirstNode.AddChild('userid');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Hist.Userid);
//    end;
//
//    if VarIsNull(Hist.Gdocid) then     // bei History gibt es gdocid = 0
//      Hist.Gdocid := 0;                // das sind eintrge fr das adminlog
//
//    CurNode := FirstNode.AddChild('_gdocid');
//    CurNode.Attributes['typ'] := 'int';
//    CurNode.Text := IntToStr(Hist.Gdocid);
//
//
//    if Hist.Taskid <> 0 then
//    begin
//      CurNode := FirstNode.AddChild('taskid');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Hist.Taskid);
//    end;
//
//    if not VarIsNull(Hist.Date) then
//    begin
//      CurNode := FirstNode.AddChild('_date');
//      CurNode.Attributes['typ'] := 'datetime.datetime';
//      CurNode.Text := FormatDateTime('yyyy-mm-dd  hh:nn:ss', Hist.Date);
//    end;
//
//    if not VarIsNull(Hist.Username) then
//    begin
//      CurNode := FirstNode.AddChild('username');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := Hist.Username;
//    end;
//
//  except
//
//  end;
//end;
//
//procedure AnnotationToXML(XML : IXMLDocument; RootNode : IXMLNode; Anno : TbfaAnnotation; isitem: Boolean = False);
//var
//  FirstNode, CurNode : IXMLNode;
//  base64string : WideString;
//  i : Integer;
//begin
//  try
//    if RootNode = nil then
//    begin
//      RootNode := XML.AddChild('BitfarmAnnotation');
//      FirstNode := RootNode;
//    end
//    else if not isitem then
//      FirstNode := RootNode.AddChild('BitfarmAnnotation')
//    else
//      FirstNode := RootNode;
//
//    if not VarIsNull(Anno.FilePath) then
//    begin
//      CurNode := FirstNode.AddChild('filepath');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := Anno.FilePath;
//    end;
//
//    if not VarIsNull(Anno.Text) then
//    begin
//      CurNode := FirstNode.AddChild('text');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := Anno.Text;
//    end;
//
//    if Anno.Modified then
//    begin
//      CurNode := FirstNode.AddChild('modified');
//      CurNode.Attributes['typ'] := 'bool';
//      if (Anno.Modified) then
//        CurNode.Text := 'True'
//      else
//        CurNode.Text := 'False';
//    end;
//
//    if Anno.Layer <> 0 then
//    begin
//      CurNode := FirstNode.AddChild('layer');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Anno.Layer);
//    end;
//
//    if Anno.Page <> 0 then
//    begin
//      CurNode := FirstNode.AddChild('page');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Anno.Page);
//    end;
//
//    if Anno.AnnoStream.Size > 0 then
//    begin
//      CurNode := FirstNode.AddChild('iev');
//      CurNode.Attributes['typ'] := 'BitfarmStream';
//      CurNode := CurNode.AddChild('stream');
//      CurNode.Attributes['typ'] := 'base64';
//      base64string := EncodeBase64(Anno.AnnoStream.Memory, Anno.AnnoStream.Size);
//      CurNode.Text := base64string;
//    end;
//
//    if ((Anno.History <> nil) and (Anno.History.Count > 0)) then
//    begin
//      CurNode := FirstNode.AddChild('history');
//      CurNode.Attributes['typ'] := 'list';
//      for i := 0 to Anno.History.Count - 1 do
//      begin
//        if Anno.History[i] <> nil then
//          HistoryToXML(XML, CurNode, Anno.History[i]);
//      end;
//    end;
//
//  except
//
//  end;
//end;
//
procedure UserToXML(XML : IXMLDocument; RootNode : IXMLNode; User : TbfaUser; isitem: Boolean = False);
var
  FirstNode, CurNode : IXMLNode;
  base64string : WideString;
begin
  try
    if RootNode = nil then
    begin
      RootNode := XML.AddChild('BitfarmUser');
      FirstNode := RootNode;
    end
    else if not isitem then
      FirstNode := RootNode.AddChild('BitfarmUser')
    else
      FirstNode := RootNode;

    if not VarIsNull(User.Name) then
    begin
      CurNode := FirstNode.AddChild('name');
      CurNode.Attributes['typ'] := 'unicode';
      CurNode.Text := User.Name;
    end;

    if not VarIsNull(User.Password) then
    begin
      CurNode := FirstNode.AddChild('password');
      CurNode.Attributes['typ'] := 'unicode';
      CurNode.Text := User.Password;
    end;

    if not VarIsNull(User.DisplayName) then
    begin
      CurNode := FirstNode.AddChild('displayname');
      CurNode.Attributes['typ'] := 'unicode';
      CurNode.Text := User.DisplayName;
    end;

    if not VarIsNull(User.Email) then
    begin
      CurNode := FirstNode.AddChild('email');
      CurNode.Attributes['typ'] := 'unicode';
      CurNode.Text := User.Email;
    end;

    if User.Modified then
    begin
      CurNode := FirstNode.AddChild('modified');
      CurNode.Attributes['typ'] := 'bool';
      if (User.Modified) then
        CurNode.Text := 'True'
      else
        CurNode.Text := 'False';
    end;

    if User.ID <> 0 then
    begin
      CurNode := FirstNode.AddChild('id');
      CurNode.Attributes['typ'] := 'int';
      CurNode.Text := IntToStr(User.ID);
    end;

    if User.Src_Userid <> 0 then
    begin
      CurNode := FirstNode.AddChild('src_userid');
      CurNode.Attributes['typ'] := 'int';
      CurNode.Text := IntToStr(User.Src_Userid);
    end;

    if User.Rights <> 0 then
    begin
      CurNode := FirstNode.AddChild('rights');
      CurNode.Attributes['typ'] := 'int';
      CurNode.Text := IntToStr(User.Rights);
    end;

    if User.Role <> 0 then
    begin
      CurNode := FirstNode.AddChild('role');
      CurNode.Attributes['typ'] := 'long';
      CurNode.Text := IntToStr(User.Role);
    end;

    if User.Flags <> 0 then
    begin
      CurNode := FirstNode.AddChild('flags');
      CurNode.Attributes['typ'] := 'int';
      CurNode.Text := IntToStr(User.Flags);
    end;

    if User.EmployeesList.Count > 0 then
    begin
      CurNode := FirstNode.AddChild('employees');
      CurNode.Attributes['typ'] := 'str';
      CurNode.Text := User.EmployeesList.DelimitedText;
    end;
    if GUIDToString(User.TempID) <> cEmptyGUID then
    begin
      CurNode := FirstNode.AddChild('tempid');
      CurNode.Attributes['typ'] := 'str';
      CurNode.Text := GUIDToString(User.TempID);
    end;
  except

  end;
end;

procedure GroupToXML(XML : IXMLDocument; RootNode : IXMLNode; Group : TbfaGroup; isitem: Boolean = False);
var
  FirstNode, CurNode : IXMLNode;
  base64string : WideString;
begin
  try
    if RootNode = nil then
    begin
      RootNode := XML.AddChild('BitfarmGroup');
      FirstNode := RootNode;
    end
    else if not isitem then
      FirstNode := RootNode.AddChild('BitfarmGroup')
    else
      FirstNode := RootNode;

    if not VarIsNull(Group.Name) then
    begin
      CurNode := FirstNode.AddChild('name');
      CurNode.Attributes['typ'] := 'unicode';
      CurNode.Text := Group.Name;
    end;

    if Group.Modified then
    begin
      CurNode := FirstNode.AddChild('modified');
      CurNode.Attributes['typ'] := 'bool';
      if (Group.Modified) then
        CurNode.Text := 'True'
      else
        CurNode.Text := 'False';
    end;

    if Group.ID <> 0 then
    begin
      CurNode := FirstNode.AddChild('id');
      CurNode.Attributes['typ'] := 'int';
      CurNode.Text := IntToStr(Group.ID);
    end;

    if Group.Role <> 0 then
    begin
      CurNode := FirstNode.AddChild('role');
      CurNode.Attributes['typ'] := 'long';
      CurNode.Text := IntToStr(Group.Role);
    end;

    if Group.Flags <> 0 then
    begin
      CurNode := FirstNode.AddChild('flags');
      CurNode.Attributes['typ'] := 'int';
      CurNode.Text := IntToStr(Group.Flags);
    end;

    if Group.Members.Count > 0 then
    begin
      CurNode := FirstNode.AddChild('members');
      CurNode.Attributes['typ'] := 'str';
      CurNode.Text := Group.Members.DelimitedText;
    end;

    if Group.ADPath <> '' then
    begin
      CurNode := FirstNode.AddChild('adpath');
      CurNode.Attributes['typ'] := 'unicode';
      CurNode.Text := Group.ADPath;
    end;
    if Group.Email <> '' then
    begin
      CurNode := FirstNode.AddChild('email');
      CurNode.Attributes['typ'] := 'unicode';
      CurNode.Text := Group.Email;
    end;
    if GUIDToString(Group.TempID) <> cEmptyGUID then
    begin
      CurNode := FirstNode.AddChild('tempid');
      CurNode.Attributes['typ'] := 'str';
      CurNode.Text := GUIDToString(Group.TempID);
    end;
  except

  end;
end;
//
//procedure DLMToXML(XML : IXMLDocument; RootNode : IXMLNode; DLM : TbfaDLM; isitem: Boolean = False);
//var
//  FirstNode, CurNode : IXMLNode;
//  base64string : WideString;
//begin
//  try
//    if RootNode = nil then
//    begin
//      RootNode := XML.AddChild('BitfarmDLM');
//      FirstNode := RootNode;
//    end
//    else if not isitem then
//      FirstNode := RootNode.AddChild('BitfarmDLM')
//    else
//      FirstNode := RootNode;
//
//    if DLM.Modified then
//    begin
//      CurNode := FirstNode.AddChild('modified');
//      CurNode.Attributes['typ'] := 'bool';
//      if (DLM.Modified) then
//        CurNode.Text := 'True'
//      else
//        CurNode.Text := 'False';
//    end;
//
//    CurNode := FirstNode.AddChild('type');
//    CurNode.Attributes['typ'] := 'int';
//    CurNode.Text := IntToStr(DLM.Typ);
//
//    if DLM.ID <> 0 then
//    begin
//      CurNode := FirstNode.AddChild('id');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(DLM.ID);
//    end;
//
//    if DLM.Fieldid <> 0 then
//    begin
//      CurNode := FirstNode.AddChild('fieldid');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(DLM.Fieldid);
//    end;
//
//    if DLM.Prio <> 0 then
//    begin
//      CurNode := FirstNode.AddChild('prio');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(DLM.Prio);
//    end;
//
//    if DLM.Mode <> 0 then
//    begin
//      CurNode := FirstNode.AddChild('mode');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(DLM.Mode);
//    end;
//
//    if DLM.Duration <> 0 then
//    begin
//      CurNode := FirstNode.AddChild('duration');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(DLM.Duration);
//    end;
//
//    if DLM.Item <> '' then
//    begin
//      CurNode := FirstNode.AddChild('item');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := DLM.Item;
//    end;
//
//    if DLM.Interval <> '' then
//    begin
//      CurNode := FirstNode.AddChild('interval');
//      CurNode.Attributes['typ'] := 'str';
//      CurNode.Text := DLM.Interval;
//    end;
//
//    if not (VarIsNull(DLM.Date) or IsEmptyDate(DLM.Date)) then
//    begin
//      CurNode := FirstNode.AddChild('date');
//      CurNode.Attributes['typ'] := 'datetime.datetime';
//      CurNode.Text := FormatDateTime('yyyy-mm-dd  hh:nn:ss', DLM.Date);
//    end;
//
//    if GUIDToString(DLM.TempID) <> cEmptyGUID then
//    begin
//      CurNode := FirstNode.AddChild('tempid');
//      CurNode.Attributes['typ'] := 'str';
//      CurNode.Text := GUIDToString(DLM.TempID);
//    end;
//  except
//
//  end;
//end;
//
//procedure PredictionResultToXML(XML : IXMLDocument; RootNode : IXMLNode; Pred : TbfaPredictionResult; isitem: Boolean = False);
//var
//  FirstNode, CurNode : IXMLNode;
//  base64string : WideString;
//begin
//  try
//    if RootNode = nil then
//    begin
//      RootNode := XML.AddChild('BitfarmPredictionResult');
//      FirstNode := RootNode;
//    end
//    else if not isitem then
//      FirstNode := RootNode.AddChild('BitfarmPredictionResult')
//    else
//      FirstNode := RootNode;
//
//    if Pred.Page <> 0 then
//    begin
//      CurNode := FirstNode.AddChild('page');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Pred.Page);
//    end;
//
//    if Pred.ClassID <> 0 then
//    begin
//      CurNode := FirstNode.AddChild('classid');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Pred.ClassID);
//    end;
//
//    if Pred.GUID <> '' then
//    begin
//      CurNode := FirstNode.AddChild('tempid');
//      CurNode.Attributes['typ'] := 'str';
//      CurNode.Text := Pred.GUID;
//    end;
//  except
//
//  end;
//end;

procedure FieldRightToXML(XML : IXMLDocument; RootNode : IXMLNode; Right : TbfaFieldRight; isitem: Boolean = False);
var
  FirstNode, CurNode : IXMLNode;
  base64string : WideString;
begin
  try
    if RootNode = nil then
    begin
      RootNode := XML.AddChild('BitfarmFieldRight');
      FirstNode := RootNode;
    end
    else if not isitem then
      FirstNode := RootNode.AddChild('BitfarmFieldRight')
    else
      FirstNode := RootNode;

    if not VarIsNull(Right.ArcID) and (Right.ArcID > -1) then
    begin
      CurNode := FirstNode.AddChild('_BitfarmFieldRight__arcid');
      CurNode.Attributes['typ'] := 'long';
      CurNode.Text := IntToStr(Right.ArcID);
    end;

    if not VarIsNull(Right.Rights) then
    begin
      CurNode := FirstNode.AddChild('_BitfarmFieldRight__rights');
      CurNode.Attributes['typ'] := 'int';
      CurNode.Text := IntToStr(Right.Rights);
    end;

    if not VarIsNull(Right.FieldID) and (Right.FieldID > -1) then
    begin
      CurNode := FirstNode.AddChild('_BitfarmFieldRight__fieldid');
      CurNode.Attributes['typ'] := 'long';
      CurNode.Text := IntToStr(Right.FieldID);
    end;

    if not VarIsNull(Right.Fieldpos) and (Right.FieldPos > -1) then
    begin
      CurNode := FirstNode.AddChild('_BitfarmFieldRight__fieldpos');
      CurNode.Attributes['typ'] := 'long';
      CurNode.Text := IntToStr(Right.Fieldpos);
    end;

    if not VarIsNull(Right.Userid) and (Right.Userid > -1) then
    begin
      CurNode := FirstNode.AddChild('_BitfarmFieldRight__userid');
      CurNode.Attributes['typ'] := 'long';
      CurNode.Text := IntToStr(Right.Userid);
    end;

    if not VarIsNull(Right.Groupid) and (Right.Groupid > -1) then
    begin
      CurNode := FirstNode.AddChild('_BitfarmFieldRight__groupid');
      CurNode.Attributes['typ'] := 'long';
      CurNode.Text := IntToStr(Right.Groupid);
    end;

    if not VarIsNull(Right.Modified) then
    begin
      CurNode := FirstNode.AddChild('modified');
      CurNode.Attributes['typ'] := 'bool';
      if (Right.Modified) then
        CurNode.Text := 'True'
      else
        CurNode.Text := 'False';
    end;

    if not VarIsNull(Right.Deleted) then
    begin
      CurNode := FirstNode.AddChild('deleted');
      CurNode.Attributes['typ'] := 'bool';
      if (Right.Deleted) then
        CurNode.Text := 'True'
      else
        CurNode.Text := 'False';
    end;

  except

  end;
end;

//procedure ArcRightToXML(XML : IXMLDocument; RootNode : IXMLNode; Right : TbfaArcRight; isitem: Boolean = False);
//var
//  FirstNode, CurNode : IXMLNode;
//  base64string : WideString;
//begin
//  try
//    if RootNode = nil then
//    begin
//      RootNode := XML.AddChild('BitfarmRights');
//      FirstNode := RootNode;
//    end
//    else if not isitem then
//      FirstNode := RootNode.AddChild('BitfarmRights')
//    else
//      FirstNode := RootNode;
//
//    if not VarIsNull(Right.ArcID) then
//    begin
//      CurNode := FirstNode.AddChild('_BitfarmRights__arcid');
//      CurNode.Attributes['typ'] := 'long';
//      CurNode.Text := IntToStr(Right.ArcID);
//    end;
//
//    //24.01.2022 Ticket  29625 -->
//    if GUIDToString(Right.ArcTempID) <> cEmptyGUID then
//    begin
//      CurNode := FirstNode.AddChild('_BitfarmRights__arctempid');
//      CurNode.Attributes['typ'] := 'str';
//      CurNode.Text := GUIDToString(Right.ArcTempID);
//    end;
//    //24.01.2022 Ticket  29625 <--
//
//    if not VarIsNull(Right.Rights) then
//    begin
//      CurNode := FirstNode.AddChild('_BitfarmRights__rights');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Right.Rights);
//    end;
//
//    if not VarIsNull(Right.Userid) and (Right.Userid > -1) then
//    begin
//      CurNode := FirstNode.AddChild('_BitfarmRights__userid');
//      CurNode.Attributes['typ'] := 'long';
//      CurNode.Text := IntToStr(Right.Userid);
//    end;
//
//    if not VarIsNull(Right.Groupid) and (Right.Groupid > -1) then
//    begin
//      CurNode := FirstNode.AddChild('_BitfarmRights__groupid');
//      CurNode.Attributes['typ'] := 'long';
//      CurNode.Text := IntToStr(Right.Groupid);
//    end;
//
//    if not VarIsNull(Right.Modified) then
//    begin
//      CurNode := FirstNode.AddChild('modified');
//      CurNode.Attributes['typ'] := 'bool';
//      if (Right.Modified) then
//        CurNode.Text := 'True'
//      else
//        CurNode.Text := 'False';
//    end;
//
//    if not VarIsNull(Right.Deleted) then
//    begin
//      CurNode := FirstNode.AddChild('deleted');
//      CurNode.Attributes['typ'] := 'bool';
//      if (Right.Deleted) then
//        CurNode.Text := 'True'
//      else
//        CurNode.Text := 'False';
//    end;
//
//  except
//
//  end;
//end;
//
//procedure ArchiveToXML(XML : IXMLDocument; RootNode : IXMLNode; Arc : TbfaArchive; isitem: Boolean = False);
//var
//  FirstNode, CurNode, fieldsNode, fieldNode, itemNode, rightNode, rightItemNode : IXMLNode;
//  base64string : WideString;
//  i, j : Integer;
//  fieldrights : TList<TbfaFieldRight>;
//  right_modified: Boolean;
//begin
//  try
//    if RootNode = nil then
//    begin
//      RootNode := XML.AddChild('BitfarmArchive');
//      FirstNode := RootNode;
//    end
//    else if not isitem then
//      FirstNode := RootNode.AddChild('BitfarmArchive')
//    else
//      FirstNode := RootNode;
//
//    if not VarIsNull(Arc.ID) then
//    begin
//      CurNode := FirstNode.AddChild('id');
//      CurNode.Attributes['typ'] := 'long';
//      CurNode.Text := IntToStr(Arc.ID);
//    end;
//
//    if not VarIsNull(Arc.Lgrid) then
//    begin
//      CurNode := FirstNode.AddChild('lgrid');
//      CurNode.Attributes['typ'] := 'long';
//      CurNode.Text := IntToStr(Arc.Lgrid);
//    end;
//
//    if not VarIsNull(Arc.Flags) then
//    begin
//      CurNode := FirstNode.AddChild('flags');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Arc.Flags);
//    end;
//
//    if not VarIsNull(Arc.Typ) then
//    begin
//      CurNode := FirstNode.AddChild('type');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Arc.Typ);
//    end;
//
//    if not VarIsNull(Arc.Options) then
//    begin
//      CurNode := FirstNode.AddChild('options');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Arc.Options);
//    end;
//
//    if not VarIsNull(Arc.Storageid) then
//    begin
//      CurNode := FirstNode.AddChild('storageid');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Arc.Storageid);
//    end;
//
//    if not VarIsNull(Arc.Rights) then
//    begin
//      CurNode := FirstNode.AddChild('rights');
//      CurNode.Attributes['typ'] := 'long';
//      CurNode.Text := IntToStr(Arc.Rights);
//    end;
//
//    if not VarIsNull(Arc.Backpic) then
//    begin
//      CurNode := FirstNode.AddChild('backpic');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := Arc.Backpic;
//    end;
//
//    if not VarIsNull(Arc.DefDocname) then
//    begin
//      CurNode := FirstNode.AddChild('defdocname');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := Arc.DefDocname;
//    end;
//
//    if not VarIsNull(Arc.Name) then
//    begin
//      CurNode := FirstNode.AddChild('arcname');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := Arc.Name;
//    end;
//
//    if not VarIsNull(Arc.Tblname) then
//    begin
//      CurNode := FirstNode.AddChild('tblname');
//      CurNode.Attributes['typ'] := 'str';
//      CurNode.Text := Arc.Tblname;
//    end;
//
//    if not VarIsNull(Arc.Duration) then
//    begin
//      CurNode := FirstNode.AddChild('duration');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Arc.Duration);
//    end;
//
//    if not VarIsNull(Arc.Interval) then
//    begin
//      CurNode := FirstNode.AddChild('interval');
//      CurNode.Attributes['typ'] := 'str';
//      CurNode.Text := Arc.Interval;
//    end;
//
//    if Arc.Modified then
//    begin
//      CurNode := FirstNode.AddChild('modified');
//      CurNode.Attributes['typ'] := 'bool';
//      if (Arc.Modified) then
//        CurNode.Text := 'True'
//      else
//        CurNode.Text := 'False';
//    end;
//
//    if Arc.Modified_User then
//    begin
//      CurNode := FirstNode.AddChild('modified_user');
//      CurNode.Attributes['typ'] := 'bool';
//      if (Arc.Modified_User) then
//        CurNode.Text := 'True'
//      else
//        CurNode.Text := 'False';
//    end;
//
//    if Arc.Modified_Addfields then
//    begin
//      CurNode := FirstNode.AddChild('modified_addfields');
//      CurNode.Attributes['typ'] := 'bool';
//      if (Arc.Modified_Addfields) then
//        CurNode.Text := 'True'
//      else
//        CurNode.Text := 'False';
//    end;
//
//    if Arc.Modified_Statefields then
//    begin
//      CurNode := FirstNode.AddChild('modified_statefields');
//      CurNode.Attributes['typ'] := 'bool';
//      if (Arc.Modified_Statefields) then
//        CurNode.Text := 'True'
//      else
//        CurNode.Text := 'False';
//    end;
//
//    if (Arc.Users.Count > 0) or (Arc.Groups.Count > 0)  then
//    begin
//      right_modified := False;
//      for i := 0 to Arc.Users.Count -1 do
//      begin
//        right_modified := right_modified or TbfaArcRight(Arc.Users.Objects[i]).Modified;
//      end;
//      for i := 0 to Arc.Groups.Count -1 do
//      begin
//        right_modified := right_modified or TbfaArcRight(Arc.Groups.Objects[i]).Modified;
//      end;
//
//      if right_modified then
//      begin
//        CurNode := FirstNode.AddChild('rights_list');
//        CurNode.Attributes['typ'] := 'list';
//
//        for i := 0 to Arc.Users.Count -1 do
//        begin
//          if TbfaArcRight(Arc.Users.Objects[i]).Modified then
//          begin
//            itemNode :=  CurNode.AddChild('item');
//            itemNode.Attributes['typ'] := 'BitfarmRights';
//            ArcRightToXML(XML, itemNode, TbfaArcRight(Arc.Users.Objects[i]), True);
//          end;
//        end;
//        for i := 0 to Arc.Groups.Count -1 do
//        begin
//          if TbfaArcRight(Arc.Groups.Objects[i]).Modified then
//          begin
//            itemNode :=  CurNode.AddChild('item');
//            itemNode.Attributes['typ'] := 'BitfarmRights';
//            ArcRightToXML(XML, itemNode, TbfaArcRight(Arc.Groups.Objects[i]), True);
//          end;
//        end;
//      end;
//    end;
//
//    if Arc.Addfields.Count > 0 then
//    begin
//      right_modified := False;
//      for i := 0 to Arc.Addfields.Count -1 do
//      begin
//        fieldrights := TList<TbfaFieldRight>(Arc.Addfields.Objects[i]);
//        for j := 0 to fieldrights.Count -1 do
//        begin
//          right_modified := right_modified or fieldrights[j].Modified;
//        end;
//      end;
//
//      if right_modified then
//      begin
//        fieldsNode := FirstNode.AddChild('addfields');
//        fieldsNode.Attributes['typ'] := 'list';
//
//        for i := 0 to Arc.Addfields.Count -1 do
//        begin
//          fieldrights := TList<TbfaFieldRight>(Arc.Addfields.Objects[i]);
//          right_modified := False;
//          if fieldrights.Count > 0 then
//          begin
//            for j := 0 to fieldrights.Count -1 do
//            begin
//              right_modified := right_modified or fieldrights[j].Modified;
//            end;
//
//            if right_modified then
//            begin
//              fieldNode := fieldsNode.AddChild('item');
//              fieldNode.Attributes['typ'] := 'BitfarmAddfield';
//
//              itemNode := fieldNode.AddChild('id');
//              itemNode.Attributes['typ'] := 'long';
//              itemNode.Text := Arc.Addfields[i];
//
//              itemNode := fieldNode.AddChild('rights');
//              itemNode.Attributes['typ'] := 'BitfarmFieldRights';
//
//              rightNode := itemNode.AddChild('_rights');
//              rightNode.Attributes['typ'] := 'list';
//
//              for j := 0 to fieldrights.Count -1 do
//              begin
//                if fieldrights[j].Modified then
//                begin
//                  rightItemNode := rightNode.AddChild('item');
//                  rightItemNode.Attributes['typ'] := 'BitfarmFieldRight';
//                  FieldRightToXML(XML, rightItemNode, fieldrights[j], True);
//                end;
//              end;
//            end;
//          end;
//        end;
//      end;
//    end;
//
//    if Arc.Statefields.Count > 0 then
//    begin
//      right_modified := False;
//      for i := 0 to Arc.Statefields.Count -1 do
//      begin
//        fieldrights := TList<TbfaFieldRight>(Arc.Statefields.Objects[i]);
//        for j := 0 to fieldrights.Count -1 do
//        begin
//          right_modified := right_modified or fieldrights[j].Modified;
//        end;
//      end;
//
//      if right_modified then
//      begin
//        fieldsNode := FirstNode.AddChild('statefields');
//        fieldsNode.Attributes['typ'] := 'list';
//
//        for i := 0 to Arc.Statefields.Count -1 do
//        begin
//          fieldrights := TList<TbfaFieldRight>(Arc.Statefields.Objects[i]);
//          right_modified := False;
//          if fieldrights.Count > 0 then
//          begin
//            for j := 0 to fieldrights.Count -1 do
//            begin
//              right_modified := right_modified or fieldrights[j].Modified;
//            end;
//
//            if right_modified then
//            begin
//              fieldNode := fieldsNode.AddChild('item');
//              fieldNode.Attributes['typ'] := 'BitfarmStatefield';
//
//              itemNode := fieldNode.AddChild('id');
//              itemNode.Attributes['typ'] := 'long';
//              itemNode.Text := Arc.Statefields[i];
//
//              itemNode := fieldNode.AddChild('rights');
//              itemNode.Attributes['typ'] := 'BitfarmFieldRights';
//
//              rightNode := itemNode.AddChild('_rights');
//              rightNode.Attributes['typ'] := 'list';
//
//              for j := 0 to fieldrights.Count -1 do
//              begin
//                if fieldrights[j].Modified then
//                begin
//                  rightItemNode := rightNode.AddChild('item');
//                  rightItemNode.Attributes['typ'] := 'BitfarmFieldRight';
//                  FieldRightToXML(XML, rightItemNode, fieldrights[j], True);
//                end;
//              end;
//            end;
//          end;
//        end;
//      end;
//    end;
//
//    if GUIDToString(Arc.TempID) <> cEmptyGUID then
//    begin
//      CurNode := FirstNode.AddChild('tempid');
//      CurNode.Attributes['typ'] := 'str';
//      CurNode.Text := GUIDToString(Arc.TempID);
//    end;
//
//  except
//
//  end;
//end;
//
//procedure WorkflowToXML(XML : IXMLDocument; RootNode : IXMLNode; WF : TbfaWorkflow; isitem: Boolean = False);
//var
//  FirstNode, CurNode : IXMLNode;
//  base64string : WideString;
//begin
//  try
//    if RootNode = nil then
//    begin
//      RootNode := XML.AddChild('BitfarmWorkflow');
//      FirstNode := RootNode;
//    end
//    else if not isitem then
//      FirstNode := RootNode.AddChild('BitfarmWorkflow')
//    else
//      FirstNode := RootNode;
//
//    if not VarIsNull(WF.Profile) then
//    begin
//      CurNode := FirstNode.AddChild('profile');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := WF.Profile;
//    end;
//
//    if not VarIsNull(WF.Info) then
//    begin
//      CurNode := FirstNode.AddChild('info');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := WF.Info;
//    end;
//
//    if not VarIsNull(WF.Comment) then
//    begin
//      CurNode := FirstNode.AddChild('comment');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := WF.Comment;
//    end;
//
//    if not VarIsNull(WF.Users) then
//    begin
//      CurNode := FirstNode.AddChild('users');
//      CurNode.Attributes['typ'] := 'str';
//      CurNode.Text := WF.Users;
//    end;
//
//    if not VarIsNull(WF.Groups) then
//    begin
//      CurNode := FirstNode.AddChild('groups');
//      CurNode.Attributes['typ'] := 'str';
//      CurNode.Text := WF.Groups;
//    end;
//
//    if WF.Modified then
//    begin
//      CurNode := FirstNode.AddChild('modified');
//      CurNode.Attributes['typ'] := 'bool';
//      if (WF.Modified) then
//        CurNode.Text := 'True'
//      else
//        CurNode.Text := 'False';
//    end;
//
//    if WF.UseridWork > 0 then
//    begin
//      CurNode := FirstNode.AddChild('userid_work');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(WF.UseridWork);
//    end;
//
//    if WF.UseridShed > 0 then
//    begin
//      CurNode := FirstNode.AddChild('userid_shed');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(WF.UseridShed);
//    end;
//
//    if not VarIsNull(WF.Date) then
//    begin
//      CurNode := FirstNode.AddChild('date');
//      CurNode.Attributes['typ'] := 'datetime.datetime';
//      CurNode.Text := FormatDateTime('yyyy-mm-dd  hh:nn:ss', WF.Date);
//    end;
//
//    if not VarIsNull(WF.AlarmDate) then
//    begin
//      CurNode := FirstNode.AddChild('alarm_date');
//      CurNode.Attributes['typ'] := 'datetime.datetime';
//      CurNode.Text := FormatDateTime('yyyy-mm-dd  hh:nn:ss', WF.AlarmDate);
//    end;
//
//    if WF.Options > 0 then
//    begin
//      CurNode := FirstNode.AddChild('options');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(WF.Options);
//    end;
//
//    if WF.Status > 0 then
//    begin
//      CurNode := FirstNode.AddChild('status');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(WF.Status);
//    end;
//
//    if WF.TimID > 0 then
//    begin
//      CurNode := FirstNode.AddChild('tim_id');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(WF.TimID);
//    end;
//
//    if WF.TimRef > 0 then
//    begin
//      CurNode := FirstNode.AddChild('tim_ref');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(WF.TimRef);
//    end;
//
//    if WF.Gdocid > 0 then
//    begin
//      CurNode := FirstNode.AddChild('_BitfarmBaseObject__gdocid');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(WF.Gdocid);
//    end;
//
//  except
//
//  end;
//end;
//
//procedure DocumentToXML(XML : IXMLDocument; RootNode : IXMLNode; Doc : TbfaDocument; isitem: Boolean = False);
//var
//  FirstNode, CurNode, ItemNode: IXMLNode;
//  i : Integer;
//  str : WideString;
//begin
//  try
//    if RootNode = nil then
//    begin
//      RootNode := XML.AddChild('BitfarmDocument');
//      FirstNode := RootNode;
//    end
//    else if not isitem then
//      FirstNode := RootNode.AddChild('BitfarmDocument')
//    else
//      FirstNode := RootNode;
//
//    if Doc.ID > 0 then
//    begin
//      CurNode := FirstNode.AddChild('_BitfarmBaseObject__gdocid');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Doc.ID);
//    end;
//
//    if GUIDToString(Doc.TempID) <> cEmptyGUID then
//    begin
//      CurNode := FirstNode.AddChild('tempid');
//      CurNode.Attributes['typ'] := 'str';
//      CurNode.Text := GUIDToString(Doc.TempID);
//    end;
//    if Doc.ArcID > 0 then
//    begin
//      CurNode := FirstNode.AddChild('_BitfarmBaseObject__arcid');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Doc.ArcID);
//    end;
//    if Doc.Addfields_Arcid > 0 then
//    begin
//      CurNode := FirstNode.AddChild('fields_arcid');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Doc.Addfields_Arcid);
//    end;
//    if Doc.DocLoc <> '' then
//    begin
//      CurNode := FirstNode.AddChild('docloc');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := Doc.DocLoc;
//    end;
//    if Doc.ExtLoc <> '' then
//    begin
//      CurNode := FirstNode.AddChild('extloc');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := Doc.ExtLoc;
//    end;
//    if Doc.OriLoc <> '' then
//    begin
//      CurNode := FirstNode.AddChild('oriloc');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := Doc.OriLoc;
//    end;
//    if Doc.DocName <> '' then
//    begin
////08.07.2016      CurNode := FirstNode.AddChild('docname');
//      CurNode := FirstNode.AddChild('title');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := Doc.DocName;
//    end;
//    if Doc.DocTags <> '' then
//    begin
//      CurNode := FirstNode.AddChild('doctags');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := Doc.DocTags;
//      CurNode.Text := StringReplace(CurNode.Text, #13#10, ';', [rfReplaceAll]);
//      CurNode.Text := StringReplace(CurNode.Text, #10, ';', [rfReplaceAll]);
//    end;
//    if Doc.FullTXT <> '' then
//    begin
//      CurNode := FirstNode.AddChild('fulltxt');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := Doc.FullTXT;
//    end;
//    if Doc.UserID > 0 then
//    begin
//      CurNode := FirstNode.AddChild('userid');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Doc.UserID);
//    end;
//    if Doc.UserName <> '' then
//    begin
//      CurNode := FirstNode.AddChild('user');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := Doc.UserName;
//    end;
//    if Doc.CheckOutUserID > 0 then
//    begin
//      CurNode := FirstNode.AddChild('chechout_userid');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Doc.CheckOutUserID);
//    end;
////15.01.2016     if Doc.PageCount > 0 then
////    begin
////      CurNode := FirstNode.AddChild('pages');
////      CurNode.Attributes['typ'] := 'int';
////      CurNode.Text := IntToStr(Doc.PageCount);
////    end;
//    if Doc.DocType > 0 then
//    begin
//      CurNode := FirstNode.AddChild('doctype');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Doc.DocType);
//    end;
//    if Doc.OcrType <> '' then
//    begin
//      CurNode := FirstNode.AddChild('ocrtype');
//      CurNode.Attributes['typ'] := 'str';
//      CurNode.Text := Doc.OcrType;
//    end;
//    if Doc.FileType <> '' then
//    begin
//      CurNode := FirstNode.AddChild('filetype');
//      CurNode.Attributes['typ'] := 'str';
//      CurNode.Text := Doc.FileType;
//    end;
//(*17.05.2017    if Doc.FilePath <> '' then
//    begin
//      CurNode := FirstNode.AddChild('filepath');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := Doc.FilePath;
//    end; *)
//    if Doc.Filter <> '' then
//    begin
//      CurNode := FirstNode.AddChild('filter');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := Doc.Filter;
//    end;
//    if Doc.Name <> '' then
//    begin
//      CurNode := FirstNode.AddChild('archive');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := Doc.Name;
//    end;
//    if Doc.FileName <> '' then
//    begin
//      CurNode := FirstNode.AddChild('filename');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := Doc.FileName;
//    end;
//    if Doc.HasPreview then
//    begin
//      CurNode := FirstNode.AddChild('haspreview');
//      CurNode.Attributes['typ'] := 'bool';
//      if Doc.Haspreview then
//        CurNode.Text := '1'
//      else
//        CurNode.Text := '0';
//    end;
//    if Doc.SymbolicArcID >= 0 then
//    begin
//      CurNode := FirstNode.AddChild('symbolic_arcid');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Doc.SymbolicArcID);
//    end;
//    if Doc.TimID >= 0 then
//    begin
//      CurNode := FirstNode.AddChild('tim_id');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Doc.TimID);
//    end;
//    if Doc.HasSymlinks <> '' then
//    begin
//      CurNode := FirstNode.AddChild('hassymlinks');
//      CurNode.Attributes['typ'] := 'str';
//      CurNode.Text := Doc.HasSymlinks;
//    end;
//    if not VarIsNull(Doc.DocDate) then
//    begin
//      CurNode := FirstNode.AddChild('date');
//      CurNode.Attributes['typ'] := 'datetime.datetime';
//      CurNode.Text := FormatDateTime('yyyy-mm-dd  hh:nn:ss', Doc.DocDate);
//    end;
//
//    if Doc.Modified then
//    begin
//      CurNode := FirstNode.AddChild('modified');
//      CurNode.Attributes['typ'] := 'bool';
//      CurNode.Text := 'True';
//    end;
//
//    if Doc.AddFields.Count > 0 then
//    begin
//      CurNode := FirstNode.AddChild('fields');
//      CurNode.Attributes['typ'] := 'OrderedDict';
//
//      for i := 0 to Doc.AddFields.Count -1 do
//      begin
//        ItemNode := CurNode.AddChild('item');
//        ItemNode.Attributes['name'] :=  Doc.AddFields[i].Name;
//        ItemNode.Attributes['tagtyp'] := 'unicode';
//        ItemNode.Attributes['typ'] := 'BitfarmAddfield';
//        AddFieldToXML(XML, ItemNode, Doc.AddFields[i], True);
//      end;
//
//    end;
//
//    if Doc.StateFields.Count > 0 then
//    begin
//      CurNode := FirstNode.AddChild('statefields');
//      CurNode.Attributes['typ'] := 'OrderedDict';
//      for i := 0 to Doc.StateFields.Count -1 do
//      begin
//        ItemNode := CurNode.AddChild('item');
//        ItemNode.Attributes['name'] := IntToStr(Doc.StateFields[i].ID);
//        ItemNode.Attributes['tagtyp'] := 'unicode';
//        ItemNode.Attributes['typ'] := 'BitfarmStatefield';
//
//        StsFieldToXML(XML, ItemNode, Doc.StateFields[i], True);
//      end;
//
//    end;
//
//    if (Doc.Annotations.Count > 0) then
//    begin
//      CurNode := FirstNode.AddChild('annotations');
//      CurNode.Attributes['typ'] := 'list';
//      for i := 0 to Doc.Annotations.Count -1 do
//      begin
//        ItemNode := CurNode.AddChild('item');
//        ItemNode.Attributes['typ'] := 'BitfarmAnnotation';
//
//        AnnotationToXML(XML, ItemNode, Doc.Annotations[i], True);
//      end;
//
//    end;
//
//    if (Doc.History.Count > 0) then
//    begin
//      CurNode := FirstNode.AddChild('history');
//      CurNode.Attributes['typ'] := 'list';
//      for i := 0 to Doc.History.Count -1 do
//      begin
//        ItemNode := CurNode.AddChild('item');
//        ItemNode.Attributes['typ'] := 'BitfarmHistory';
//
//        HistoryToXML(XML, ItemNode, Doc.History[i], True);
//      end;
//    end;
//
//
//    if Assigned(Doc.DocLinkList) and (Length(Doc.DocLinkList) > 0) then
//    begin
//      str := '';
//      CurNode := FirstNode.AddChild('links');
//      CurNode.Attributes['typ'] := 'unicode';
//      str := '';
//      for i := Low(Doc.DocLinkList) to High(Doc.DocLinkList) do
//      begin
//        if str <> '' then
//          str := str + ';';
//        str := str + Doc.DocLinkList[i].RefName;
//      end;
//      CurNode.Text := str;
//    end;
//
//    if Doc.Info <> '' then
//    begin
//      CurNode := FirstNode.AddChild('info');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := Doc.Info;
//    end;
//
//    if Doc.Editor <> '' then
//    begin
//      CurNode := FirstNode.AddChild('editor');
//      CurNode.Attributes['typ'] := 'unicode';
//      CurNode.Text := Doc.Editor;
//    end;
//
//    if not VarIsNull(Doc.TargetDate)  then
//    begin
//      CurNode := FirstNode.AddChild('target_date');
//      CurNode.Attributes['typ'] := 'datetime.datetime';
//      CurNode.Text := FormatDateTime('yyyy-mm-dd  hh:nn:ss', Doc.TargetDate);
//    end;
//
////24.01.2019 Ticket 17715 Im Importer mit 0 sollte auch die WVL erstellt werden  if Doc.Alarm > 0 then
//    if (Doc.Alarm >= 0) and (not VarIsNull(Doc.TargetDate)) then
//    begin
//      CurNode := FirstNode.AddChild('alarm');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Doc.Alarm);
//    end;
//
//    if Doc.TimerOptions >= 0 then
//    begin
//      CurNode := FirstNode.AddChild('timeroptions');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Doc.TimerOptions);
//    end;
//
//    if Doc.ImporterDocNameModified then
//    begin
//      CurNode := FirstNode.AddChild('imorterdocname_modified');
//      CurNode.Text := 'True';
//    end;
//
//    if not VarIsNull(Doc.Expired)  then
//    begin
//      CurNode := FirstNode.AddChild('expired');
//      CurNode.Attributes['typ'] := 'datetime.datetime';
////07.05.2019 Ticket 19145 -->
////      CurNode.Text := FormatDateTime('yyyy-mm-dd  hh:nn:ss', Doc.Expired);
//        if VarIsType(Doc.Expired, varDate) and (not IsEmptyDate(Doc.Expired)) then
//          CurNode.Text := FormatDateTime('yyyy-mm-dd 00:00:00', Doc.Expired)
//        else if VarIsType(Doc.Expired, varUString) and (Doc.Expired <> '') then
//          CurNode.Text := FormatDateTime('yyyy-mm-dd 00:00:00', StrToDate(Doc.Expired))
////07.05.2019 Ticket 19145 <--
//
//    end;
//
//    if Doc.Expired_Userid >= 0 then
//    begin
//      CurNode := FirstNode.AddChild('expired_userid');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Doc.Expired_Userid);
//    end;
//
//    if Doc.Expired_Setby >= 0 then
//    begin
//      CurNode := FirstNode.AddChild('expired_setby');
//      CurNode.Attributes['typ'] := 'int';
//      CurNode.Text := IntToStr(Doc.Expired_Setby);
//    end;
//
//    if Doc.Expired_Modified then
//    begin
//      CurNode := FirstNode.AddChild('expired_modified');
//      CurNode.Attributes['typ'] := 'bool';
//      CurNode.Text := 'True';
//    end;
//
//  except
//
//  end;
//end;
//
//procedure SearchObjToXML(XML : IXMLDocument; RootNode : IXMLNode;
//  SObj : TbfaSearch; FavID : Integer = -1; isitem: Boolean = False);
//var
//  FirstNode, CurNode : IXMLNode;
//  i : Integer;
//begin
//  try
//    if RootNode = nil then
//    begin
//      RootNode := XML.AddChild('fav');
//      FirstNode := RootNode;
//    end
//    else if not isitem then
//      FirstNode := RootNode.AddChild('fav')
//    else
//      FirstNode := RootNode;
//
//    if  not VarIsNull(SObj.Date) then
//      FirstNode.Attributes['date'] := SObj.Date;
//    if FavID > -1 then
//      FirstNode.Attributes['id'] := FavID
//    else if SObj.ID > -1 then
//      FirstNode.Attributes['id'] := SObj.ID;
//
//    if SObj.Name <> '' then
//      FirstNode.Attributes['name_fav'] := SObj.Name;
//    if SObj.UserID > -1 then
//      FirstNode.Attributes['userid'] := SObj.UserID;
//    if SObj.GroupID > -1 then
//      FirstNode.Attributes['groupid'] := SObj.GroupID;
//    if not VarIsNull(SObj.URights) then
//      FirstNode.Attributes['urights'] := SObj.URights;
//    if not VarIsNull(SObj.GRights) then
//      FirstNode.Attributes['grights'] := SObj.GRights;
//
//    FirstNode.Attributes['version'] := 36;
//
//    if SObj.GUID <> '' then
//    begin
//      CurNode := FirstNode.AddChild('guid');
//      CurNode.Text := SObj.GUID;
//    end;
//
//    if SObj.SelectedArcID > -1 then
//    begin
//      CurNode := FirstNode.AddChild('selectedarcid');
//      CurNode.Text := IntToStr(SObj.SelectedArcID);
//    end;
//
//    if not VarIsNull(SObj.SearchDate) then
//    begin
//      CurNode := FirstNode.AddChild('searchdate');
//      CurNode.Text := SObj.SearchDate;
//    end;
//    if not VarIsNull(SObj.SearchDateHigh) then
//    begin
//      CurNode := FirstNode.AddChild('searchdatehigh');
//      CurNode.Text := SObj.SearchDateHigh;
//    end;
//    if SObj.SearchDateNegated then
//    begin
//      CurNode := FirstNode.AddChild('searchdate_negated');
//      CurNode.Text := 'True';
//    end;
//    if not VarIsNull(SObj.SearchDateType) and (SObj.SearchDateType <> 0) then       // 0 ist default, mssen wir nicht extra speichern
//    begin
//      CurNode := FirstNode.AddChild('searchdatetype');
//      CurNode.Text := IntToStr(SObj.SearchDateType);
//    end;
//    if not VarIsNull(SObj.ResubAlarm) then
//    begin
//      CurNode := FirstNode.AddChild('resubalarm');
//      CurNode.Text := SObj.ResubAlarm;
//    end;
//    if not VarIsNull(SObj.ResubAlarmHigh) then
//    begin
//      CurNode := FirstNode.AddChild('resubalarmhigh');
//      CurNode.Text := SObj.ResubAlarmHigh;
//    end;
//    if SObj.ResubAlarmNegated then
//    begin
//      CurNode := FirstNode.AddChild('resubalarm_negated');
//      CurNode.Text := 'True';
//    end;
//    if not VarIsNull(SObj.ResubDate) then
//    begin
//      CurNode := FirstNode.AddChild('resubdate');
//      CurNode.Text := SObj.ResubDate;
//    end;
//    if not VarIsNull(SObj.ResubDateHigh) then
//    begin
//      CurNode := FirstNode.AddChild('resubdatehigh');
//      CurNode.Text := SObj.ResubDateHigh;
//    end;
//    if SObj.ResubDateNegated then
//    begin
//      CurNode := FirstNode.AddChild('resubdate_negated');
//      CurNode.Text := 'True';
//    end;
//    if SObj.ResubUserID > -1 then
//    begin
//      CurNode := FirstNode.AddChild('resubuserid');
//      CurNode.Text := IntToStr(SObj.ResubUserID);
//    end;
//    if SObj.ResubUserIDNegated then
//    begin
//      CurNode := FirstNode.AddChild('resubuserid_negated');
//      CurNode.Text := 'True';
//    end;
//    if SObj.ResubControllerID > -1 then
//    begin
//      CurNode := FirstNode.AddChild('resubcontrollerid');
//      CurNode.Text := IntToStr(SObj.ResubControllerID);
//    end;
//    if SObj.ResubControllerIDNegated then
//    begin
//      CurNode := FirstNode.AddChild('resubcontrollerid_negated');
//      CurNode.Text := 'True';
//    end;
//    if not VarIsNull(SObj.ResubDateHigh) then
//    begin
//      CurNode := FirstNode.AddChild('resubdate_high');
//      CurNode.Text := SObj.ResubDateHigh;
//    end;
//    if SObj.ResubState > -1 then
//    begin
//      CurNode := FirstNode.AddChild('resubstate');
//      CurNode.Text := IntToStr(SObj.ResubState);
//    end;
//    if SObj.ResubNotState > -1 then
//    begin
//      CurNode := FirstNode.AddChild('resubnotstate');
//      CurNode.Text := IntToStr(SObj.ResubNotState);
//    end;
//    if SObj.ResubStateNegated then
//    begin
//      CurNode := FirstNode.AddChild('resubstate_negated');
//      CurNode.Text := 'True';
//    end;
//    if SObj.ArcID.Count > 0 then
//    begin
//      CurNode := FirstNode.AddChild('arcid');
//      CurNode.Text := SObj.ArcID.CommaText;
//    end;
//    if SObj.GDocID.Count > 0 then
//    begin
//      CurNode := FirstNode.AddChild('gdocid');
//      CurNode.Text := SObj.GDocID.CommaText;
//    end;
//    if SObj.TimRef.Count > 0 then
//    begin
//      CurNode := FirstNode.AddChild('timref');
//      CurNode.Text := SObj.TimRef.CommaText;
//    end;
//    if SObj.GroupList.Count > 0 then
//    begin
//      CurNode := FirstNode.AddChild('grouplist');
//      CurNode.Text := SObj.GroupList.CommaText;
//    end;
//    if SObj.SearchType > -1 then
//    begin
//      CurNode := FirstNode.AddChild('searchtype');
//      CurNode.Text := IntToStr(SObj.SearchType);
//    end;
//    if not VarIsNull(SObj.SQLWhere) and (SObj.SQLWhere <> '') then
//    begin
//      CurNode := FirstNode.AddChild('sqlwhere');
//      CurNode.Text := SObj.SQLWhere;
//    end;
//    if (SObj.SQLWhereOperator <> '') and (SObj.SQLWhereOperator <> 'and') then   // and ist default, mssen wir nicht extra speichern
//    begin
//      CurNode := FirstNode.AddChild('sqlwhere_operator');
//      CurNode.Text := SObj.SQLWhereOperator;
//    end;
//    if SObj.SQLWhereOnly then
//    begin
//      CurNode := FirstNode.AddChild('sqlwhere_only');
//      CurNode.Text := 'True';
//    end;
//    if SObj.MaxValues > -1 then
//    begin
//      CurNode := FirstNode.AddChild('maxvalues');
//      CurNode.Text := IntToStr(SObj.MaxValues);
//    end;
//{      if fav.state is not None:
//        _sub = eTree.SubElement(_elem, 'state')
//        _sub.text = str(fav.state)
//    if fav.notstate is not None:
//        _sub = eTree.SubElement(_elem, 'notstate')
//        _sub.text = str(fav.notstate)   }
//    if SObj.FtxFields > -1 then
//    begin
//      CurNode := FirstNode.AddChild('ftx_fields');
//      CurNode.Text := IntToStr(SObj.FtxFields);
//    end;
//    if not VarIsNull(SObj.SearchString) then
//    begin
//      CurNode := FirstNode.AddChild('ftx');
//      CurNode.Text := SObj.SearchString;
//    end;
//    if SObj.SearchStringNegated then
//    begin
//      CurNode := FirstNode.AddChild('ftx_negated');
//      CurNode.Text := 'True';
//    end;
//    if SObj.Checkout > -1 then
//    begin
//      CurNode := FirstNode.AddChild('checkout');
//      CurNode.Text := IntToStr(SObj.CheckOut);
//    end;
//    if SObj.Count then
//    begin
//      CurNode := FirstNode.AddChild('count');
//      CurNode.Text := 'True';
//    end;
//    if SObj.FtxMatchAgainst then
//    begin
//      CurNode := FirstNode.AddChild('ftx_matchagainst');
//      CurNode.Text := 'True';
//    end;
//    if SObj.FtxNaturalMode then
//    begin
//      CurNode := FirstNode.AddChild('ftx_naturalmode');
//      CurNode.Text := 'True';
//    end;
//    if SObj.FtxBooleanMode then
//    begin
//      CurNode := FirstNode.AddChild('ftx_booleanmode');
//      CurNode.Text := 'True';
//    end;
//    if SObj.FtxWithQueryExpansion then
//    begin
//      CurNode := FirstNode.AddChild('ftx_withqueryexpansion');
//      CurNode.Text := 'True';
//    end;
//    if not VarIsNull(SObj.RefSearch) then
//    begin
//      CurNode := FirstNode.AddChild('refsearch');
//      CurNode.Text := SObj.RefSearch;
//    end;
//    if SObj.SearchUserID > -1 then
//    begin
//      CurNode := FirstNode.AddChild('searchuserid');
//      CurNode.Text := IntToStr(SObj.SearchUserID);
//    end;
//    if not VarIsNull(SObj.SearchUser) then
//    begin
//      CurNode := FirstNode.AddChild('searchuser');
//      CurNode.Text := SObj.SearchUser;
//    end;
//    if SObj.SearchUserNegated then
//    begin
//      CurNode := FirstNode.AddChild('searchuser_negated');
//      CurNode.Text := 'True';
//    end;
//    if SObj.SearchGroupID > -1 then
//    begin
//      CurNode := FirstNode.AddChild('searchgroupid');
//      CurNode.Text := IntToStr(SObj.SearchGroupID);
//    end;
//    if not VarIsNull(SObj.SearchGroup) then
//    begin
//      CurNode := FirstNode.AddChild('searchgroup');
//      CurNode.Text := SObj.SearchGroup;
//    end;
//    if SObj.SearchGroupNegated then
//    begin
//      CurNode := FirstNode.AddChild('searchgroup_negated');
//      CurNode.Text := 'True';
//    end;
//    if SObj.Constructive then
//    begin
//      CurNode := FirstNode.AddChild('constructive');
//      CurNode.Text := 'True';
//    end;
//    if SObj.Verify then
//    begin
//      CurNode := FirstNode.AddChild('verify');
//      CurNode.Text := 'True';
//    end;
//    if not VarIsNull(SObj.SelectedCols) then
//    begin
//      CurNode := FirstNode.AddChild('selected_cols');
//      CurNode.Text := SObj.SelectedCols;
//    end;
//    if not VarIsNull(SObj.GroupBy) then
//    begin
//      CurNode := FirstNode.AddChild('groupby');
//      CurNode.Text := SObj.GroupBy;
//    end;
//    if not VarIsNull(SObj.Direction) then
//    begin
//      CurNode := FirstNode.AddChild('direction');
//      CurNode.Text := SObj.Direction;
//    end;
//    if not VarIsNull(SObj.DocName) then
//    begin
//      CurNode := FirstNode.AddChild('docname');
//      CurNode.Text := SObj.DocName;
//    end;
//    if SObj.DocNameNegated then
//    begin
//      CurNode := FirstNode.AddChild('docname_negated');
//      CurNode.Text := 'True';
//    end;
//    if not VarIsNull(SObj.Order) then
//    begin
//      CurNode := FirstNode.AddChild('order');
//      CurNode.Text := SObj.Order;
//    end;
//    if ((SObj.AddFields.Count > 0) or (SObj.StsFields.Count > 0)) then
//    begin
//      CurNode := FirstNode.AddChild('searchfields');
//
//      if (SObj.AddFields.Count > 0) then
//      begin
//        for i := 0 to SObj.AddFields.Count - 1 do
//        begin
//          if SObj.AddFields[i].ModifiedSearch then
//            AddFieldToXML(XML, CurNode, SObj.AddFields[i]);
//        end;
//      end;
//
//      if (SObj.StsFields.Count > 0) then
//      begin
//        for i := 0 to SObj.stsFields.Count - 1 do
//        begin
//          if ((SObj.StsFields[i].ModifiedSearch) and (not VarISNULL(SObj.StsFields[i].Value))) then
//            StsFieldToXML(XML, CurNode, SObj.StsFields[i]);
//        end;
//      end;
//    end;
//    if SObj.RightsMask > -1 then
//    begin
//      CurNode := FirstNode.AddChild('rightsmask');
//      CurNode.Text := IntToStr(SObj.RightsMask);
//    end;
//    if SObj.DontRefreshDataSet then
//    begin
//      CurNode := FirstNode.AddChild('dont_refresh_dataset');
//      CurNode.Text := 'True';
//    end;
//    if SObj.DontInheritate then
//    begin
//      CurNode := FirstNode.AddChild('dont_inheritate');
//      CurNode.Text := 'True';
//    end;
//  except
//
//  end;
//end;


procedure RequestToXML(XML : IXMLDocument; RootNode : IXMLNode; Request : TbfaRequest; isitem : Boolean = False);
var
  FirstNode, CurNode, ChildNode : IXMLNode;
  i: Integer;
begin
  try
    if RootNode = nil then
    begin
      RootNode := XML.AddChild('bfaReq');
      FirstNode := RootNode;
    end
    else if not isitem then
      FirstNode := RootNode.AddChild('bfaReq')
    else
      FirstNode := RootNode;

    if Request.ReqType <> '' then
    begin
      CurNode := FirstNode.AddChild('_bfaReq__reqtype');
      CurNode.Attributes['typ'] := 'str';
      CurNode.Text := Request.ReqType;
    end;
    if Request.Profile <> '' then
    begin
      CurNode := FirstNode.AddChild('profile');
      CurNode.Attributes['typ'] := 'unicode';
      CurNode.Text := Request.Profile;
    end;

    if Request.Prio > 0 then
    begin
      CurNode := FirstNode.AddChild('prio');
      CurNode.Attributes['typ'] := 'int';
      CurNode.Text := IntToStr(Request.Prio);
    end;
    if Request.Gdocid > 0 then
    begin
      CurNode := FirstNode.AddChild('_BitfarmBaseObject__gdocid');
      CurNode.Attributes['typ'] := 'int';
      CurNode.Text := IntToStr(Request.Gdocid);
    end;
    if Request.Arcid > 0 then
    begin
      CurNode := FirstNode.AddChild('_BitfarmBaseObject__arcid');
      CurNode.Attributes['typ'] := 'int';
      CurNode.Text := IntToStr(Request.Arcid);
    end;
    if Request.Addfields_Arcid > 0 then
    begin
      CurNode := FirstNode.AddChild('fields_arcid');
      CurNode.Attributes['typ'] := 'int';
      CurNode.Text := IntToStr(Request.Addfields_Arcid);
    end;
    if Request.SymbolicArcID > 0 then
    begin
      CurNode := FirstNode.AddChild('symbolic_arcid');
      CurNode.Attributes['typ'] := 'int';
      CurNode.Text := IntToStr(Request.SymbolicArcID);
    end;
    if Request.ResubUserID > 0 then
    begin
      CurNode := FirstNode.AddChild('resubuser');
      CurNode.Attributes['typ'] := 'int';
      CurNode.Text := IntToStr(Request.ResubUserID);
    end;
    if Request.Version > 0 then
    begin
      CurNode := FirstNode.AddChild('version');
      CurNode.Attributes['typ'] := 'int';
      CurNode.Text := IntToStr(Request.Version);
    end;
    if Request.Revision > 0 then
    begin
      CurNode := FirstNode.AddChild('revision');
      CurNode.Attributes['typ'] := 'int';
      CurNode.Text := IntToStr(Request.Revision);
    end;
    if Request.UserID > 0 then
    begin
      CurNode := FirstNode.AddChild('userid');
      CurNode.Attributes['typ'] := 'int';
      CurNode.Text := IntToStr(Request.UserID);
    end;
    if Request.TimID > 0 then
    begin
      CurNode := FirstNode.AddChild('tim_id');
      CurNode.Attributes['typ'] := 'int';
      CurNode.Text := IntToStr(Request.TimID);
    end;
    if Request.DataLen > 0 then
    begin
      CurNode := FirstNode.AddChild('datalen');
      CurNode.Attributes['typ'] := 'int';
      CurNode.Text := IntToStr(Request.DataLen);
    end;
    if Request.FileName <> '' then
    begin
      CurNode := FirstNode.AddChild('filename');
      CurNode.Attributes['typ'] := 'unicode';
      CurNode.Text := Request.FileName;
    end;
    if Request.FileHash <> '' then
    begin
      CurNode := FirstNode.AddChild('filehash');
      CurNode.Attributes['typ'] := 'str';
      CurNode.Text := Request.FileHash;
    end;
    if Request.Parameter <> '' then
    begin
      CurNode := FirstNode.AddChild('parameter');
      CurNode.Attributes['typ'] := 'unicode';
      CurNode.Text := Request.Parameter;
    end;
    if (Request.ParameterList <> nil) and (Request.ParameterList.Count > 0) then
    begin
      CurNode := FirstNode.AddChild('parameter');
      CurNode.Attributes['typ'] := 'list';
      for i := 0 to Request.ParameterList.Count -1 do
      begin
        ChildNode := CurNode.AddChild('item');
        ChildNode.Attributes['typ'] := 'str';
        ChildNode.Text := Request.ParameterList[i];
      end;
    end;
    if Request.Lang <> '' then
    begin
      CurNode := FirstNode.AddChild('lang');
      CurNode.Attributes['typ'] := 'str';
      CurNode.Text := Request.Lang;
    end;
    if Request.FileDate <> cUnassignedDate then
    begin
      CurNode := FirstNode.AddChild('filedate');
      CurNode.Attributes['typ'] := 'datetime.datetime';
      CurNode.Text := FormatDateTime('yyyy-mm-dd  hh:nn:ss', Request.FileDate);
    end;
    if Request.Sessionid <> '' then
    begin
      CurNode := FirstNode.AddChild('sessionid');
      CurNode.Attributes['typ'] := 'str';
      CurNode.Text := Request.Sessionid;
    end;
    if Request.DataType<> '' then
    begin
      CurNode := FirstNode.AddChild('datatype');
      CurNode.Attributes['typ'] := 'unicode';
      CurNode.Text := Request.DataType;
    end;
    if Request.DataString <> '' then
    begin
      CurNode := FirstNode.AddChild('_bfaReq__data');
      CurNode.Attributes['typ'] := 'unicode';
      CurNode.Text := Request.DataString;
    end else
    begin
      if (Request.Data <> nil) and (Request.Data.Count > 0) then
      begin
        CurNode := FirstNode.AddChild('_bfaReq__data');
        if Request.Data.Count = 1 then  //wenn wir nur ein Objekt haben, dann mssen wir den typ angeben
        begin
//            if (Request.Data[0] is TbfaBaseDocument) or (Request.Data[0] is TbfaDocument) then
//            begin
//              CurNode.Attributes['typ'] := 'BitfarmDocument';
//              DocumentToXML(XML, CurNode, TbfaDocument(Request.Data[0]), True);
//            end
//            else if (Request.Data[0] is TbfaAddField) then
//            begin
//              CurNode.Attributes['typ'] := 'BitfarmAddfield';
//              AddFieldToXML(XML, CurNode, TbfaAddField(Request.Data[0]), True);
//            end
//            else if (Request.Data[0] is TbfaStateField) then
//            begin
//              CurNode.Attributes['typ'] := 'BitfarmStatefield';
//              StsFieldToXML(XML, CurNode, TbfaStateField(Request.Data[0]), True);
//            end
//            else if (Request.Data[0] is TbfaBaseSearch) then
//            begin
//              CurNode.Attributes['typ'] := 'BitfarmSearch';
//            end
//            else if (Request.Data[0] is TbfaAnnotation) then
//            begin
//              CurNode.Attributes['typ'] := 'BitfarmAnnotation';
//              AnnotationToXML(XML,CurNode, TbfaAnnotation(Request.Data[0]), True);
//            end
//            else if (Request.Data[0] is TbfaUser) then
//            begin
//              CurNode.Attributes['typ'] := 'BitfarmUser';
//              UserToXML(XML, CurNode, TbfaUser(Request.Data[0]), True);
//            end
//            else if (Request.Data[0] is TbfaGroup) then
//            begin
//              CurNode.Attributes['typ'] := 'BitfarmGroup';
//              GroupToXML(XML, CurNode, TbfaGroup(Request.Data[0]), True);
//            end
//            else if (Request.Data[0] is TbfaArchive) then
//            begin
//              CurNode.Attributes['typ'] := 'BitfarmArchive';
//              ArchiveToXML(XML, CurNode, TbfaArchive(Request.Data[0]), True);
//            end
//            else if (Request.Data[0] is TbfaHistory) then
//            begin
//              CurNode.Attributes['typ'] := 'BitfarmHistory';
//              HistoryToXML(XML, CurNode, TbfaHistory(Request.Data[0]), True);
//            end
//            else if (Request.Data[0] is TbfaWorkflow) then
//            begin
//              CurNode.Attributes['typ'] := 'BitfarmWorkflow';
//              WorkflowToXML(XML, CurNode, TbfaWorkflow(Request.Data[0]), True);
//            end
//            else if (Request.Data[0] is TbfaDLM) then
//            begin
//              CurNode.Attributes['typ'] := 'BitfarmDLM';
//              DLMToXML(XML, CurNode, TbfaDLM(Request.Data[0]), True);
//            end
//            else if (Request.Data[0] is TbfaPredictionResult) then
//            begin
//              CurNode.Attributes['typ'] := 'BitfarmPredictionResult';
//              PredictionResultToXML(XML, CurNode, TbfaPredictionResult(Request.Data[0]), True);
//            end
//            else
            if (Request.Data[0] is TbfaRequest) then
            begin
              CurNode.Attributes['typ'] := 'bfaReq';
            end;
        end
        else
        begin
          CurNode.Attributes['typ'] := 'list';
          ObjectToXML(Request.Data, False, 'US-ASCII', '','', XML, CurNode);
        end;
      end;
    end;
  except

  end;
end;

//procedure ColumnConfigToXML(XML : IXMLDocument; RootNode : IXMLNode; Column : TbfaColumnConfig; isitem: Boolean = False);
//var
//  FirstNode, CurNode : IXMLNode;
//begin
//  if RootNode = nil then
//  begin
//    RootNode := XML.AddChild('BitfarmColumnConfig');
//    FirstNode := RootNode;
//  end
//  else if not isitem then
//    FirstNode := RootNode.AddChild('BitfarmColumnConfig')
//  else
//    FirstNode := RootNode;
//
//  if not VarIsNull(Column.Name) then
//  begin
//    CurNode := FirstNode.AddChild('name');
//    CurNode.Attributes['typ'] := 'str';
//    CurNode.Text := Column.Name;
//  end;
//
//  if not VarIsNull(Column.Fieldname) then
//  begin
//    CurNode := FirstNode.AddChild('fieldname');
//    CurNode.Attributes['typ'] := 'str';
//    CurNode.Text := Column.Fieldname;
//  end;
//
//  if not VarIsNull(Column.ColumnType) then
//  begin
//    CurNode := FirstNode.AddChild('columntype');
//    CurNode.Attributes['typ'] := 'int';
//    CurNode.Text := IntToStr(Integer(Column.ColumnType));
//  end;
//
//  if not VarIsNull(Column.ValueType) then
//  begin
//    CurNode := FirstNode.AddChild('valuetype');
//    CurNode.Attributes['typ'] := 'int';
//    CurNode.Text := IntToStr(Integer(Column.ValueType));
//  end;
//
//  if not VarIsNull(Column.SummaryType) then
//  begin
//    CurNode := FirstNode.AddChild('summarytype');
//    CurNode.Attributes['typ'] := 'int';
//    CurNode.Text := IntToStr(Integer(Column.SummaryType));
//  end;
//
//  if Column.ReadOnly then
//  begin
//    CurNode := FirstNode.AddChild('readonly');
//    CurNode.Attributes['typ'] := 'bool';
//    CurNode.Text := 'True'
//  end;
//
//  if not VarIsNull(Column.ListType) then
//  begin
//    CurNode := FirstNode.AddChild('listtype');
//    CurNode.Attributes['typ'] := 'int';
//    CurNode.Text := IntToStr(Integer(Column.ListType));
//  end;
//
//  if not VarIsNull(Column.ListAddfield) and (Column.ListAddfield > -1) then
//  begin
//    CurNode := FirstNode.AddChild('listaddfield');
//    CurNode.Attributes['typ'] := 'int';
//    CurNode.Text := IntToStr(Integer(Column.ListAddfield));
//  end;
//
//  if (Column.ListItems.Count > 0) then
//  begin
//    CurNode := FirstNode.AddChild('listitems');
//    CurNode.Attributes['typ'] := 'str';
//    CurNode.Text := Column.ListItems.DelimitedText;
//  end;
//
//  if not VarIsNull(Column.DefaultValue) then
//  begin
//    CurNode := FirstNode.AddChild('defaultvalue');
//    CurNode.Attributes['typ'] := 'str';
//    CurNode.Text := Column.DefaultValue;
//  end;
//
//  if not VarIsNull(Column.Expression) then
//  begin
//    CurNode := FirstNode.AddChild('expression');
//    CurNode.Attributes['typ'] := 'str';
//    CurNode.Text := Column.Expression;
//  end;
//
//  if not VarIsNull(Column.EditFormat) then
//  begin
//    CurNode := FirstNode.AddChild('editformat');
//    CurNode.Attributes['typ'] := 'str';
//    CurNode.Text := Column.EditFormat;
//  end;
//
//  if not VarIsNull(Column.DisplayFormat) then
//  begin
//    CurNode := FirstNode.AddChild('displayformat');
//    CurNode.Attributes['typ'] := 'str';
//    CurNode.Text := Column.DisplayFormat;
//  end;
//
//  if not VarIsNull(Column.ColWidth) and (Column.ColWidth > -1) then
//  begin
//    CurNode := FirstNode.AddChild('colwidth');
//    CurNode.Attributes['typ'] := 'int';
//    CurNode.Text := IntToStr(Integer(Column.ColWidth));
//  end;
//
//end;
//
//procedure GridConfigToXML(XML : IXMLDocument; RootNode : IXMLNode; Config : TbfaGridConfig; isitem: Boolean = False);
//var
//  FirstNode, CurNode, ItemNode : IXMLNode;
//  i: Integer;
//begin
//  if RootNode = nil then
//  begin
//    RootNode := XML.AddChild('BitfarmGridConfig');
//    FirstNode := RootNode;
//  end
//  else if not isitem then
//    FirstNode := RootNode.AddChild('BitfarmGridConfig')
//  else
//    FirstNode := RootNode;
//
//  if not VarIsNull(Config.Displayname) then
//  begin
//    CurNode := FirstNode.AddChild('displayname');
//    CurNode.Attributes['typ'] := 'str';
//    CurNode.Text := Config.Displayname;
//  end;
//
//  if Config.ShowSummary then
//  begin
//    CurNode := FirstNode.AddChild('showsummary');
//    CurNode.Attributes['typ'] := 'bool';
//    CurNode.Text := 'True';
//  end;
//
//  if Config.ShowHeader then
//  begin
//    CurNode := FirstNode.AddChild('showheader');
//    CurNode.Attributes['typ'] := 'bool';
//    CurNode.Text := 'True';
//  end;
//
//  if Config.ShowGroupbybox then
//  begin
//    CurNode := FirstNode.AddChild('showgoupbybox');
//    CurNode.Attributes['typ'] := 'bool';
//    CurNode.Text := 'True';
//  end;
//
//  if Config.ShowIndicator then
//  begin
//    CurNode := FirstNode.AddChild('showindicator');
//    CurNode.Attributes['typ'] := 'bool';
//    CurNode.Text := 'True';
//  end;
//
//  if Config.UsePopups then
//  begin
//    CurNode := FirstNode.AddChild('usepopups');
//    CurNode.Attributes['typ'] := 'bool';
//    CurNode.Text := 'True';
//  end;
//
//  if Config.UseColumnNames then
//  begin
//    CurNode := FirstNode.AddChild('usecolumnnames');
//    CurNode.Attributes['typ'] := 'bool';
//    CurNode.Text := 'True';
//  end;
//
//  if Config.ExportAddfields then
//  begin
//    CurNode := FirstNode.AddChild('export_addfields');
//    CurNode.Attributes['typ'] := 'bool';
//    CurNode.Text := 'True';
//  end;
//
//  if Config.ExportUnicode then
//  begin
//    CurNode := FirstNode.AddChild('export_unicode');
//    CurNode.Attributes['typ'] := 'bool';
//    CurNode.Text := 'True';
//  end;
//
//  if Config.ManualSorting then
//  begin
//    CurNode := FirstNode.AddChild('manualsorting');
//    CurNode.Attributes['typ'] := 'bool';
//    CurNode.Text := 'True';
//  end;
//
////  if Config.AlternateRows then
////  begin
////    CurNode := FirstNode.AddChild('alternate_rows');
////    CurNode.Attributes['typ'] := 'bool';
////    CurNode.Text := 'True';
////  end;
//
//  if Config.MultiSelect then
//  begin
//    CurNode := FirstNode.AddChild('multiselect');
//    CurNode.Attributes['typ'] := 'bool';
//    CurNode.Text := 'True';
//  end;
//
//  if Config.Stamp_Transparent then
//  begin
//    CurNode := FirstNode.AddChild('stamp_transparent');
//    CurNode.Attributes['typ'] := 'bool';
//    CurNode.Text := 'True';
//  end;
//
//  if not VarIsNull(Config.Stamp_Color) then
//  begin
//    CurNode := FirstNode.AddChild('stamp_color');
//    CurNode.Attributes['typ'] := 'str';
//    CurNode.Text := Config.Stamp_Color;
//  end;
//
//  if not VarIsNull(Config.Stamp_Size) then
//  begin
//    CurNode := FirstNode.AddChild('stamp_size');
//    CurNode.Attributes['typ'] := 'int';
//    CurNode.Text := IntToStr(Config.Stamp_Size);
//  end;
//
//  if not VarIsNull(Config.SearchField) then
//  begin
//    CurNode := FirstNode.AddChild('searchfield');
//    CurNode.Attributes['typ'] := 'str';
//    CurNode.Text := Config.SearchField;
//  end;
//
//  if (Config.Columns.Count > 0) then
//  begin
//    CurNode := FirstNode.AddChild('columns');
//    CurNode.Attributes['typ'] := 'list';
//    for i := 0 to Config.Columns.Count -1 do
//    begin
//      ItemNode := CurNode.AddChild('item');
//      ItemNode.Attributes['typ'] := 'BitfarmColumnConfig';
//
//      ColumnConfigToXML(XML, ItemNode, Config.Columns[i], True);
//    end;
//  end;
//end;
//


procedure DoObjectToXML(XML: IXMLDocument; RootNode: IXMLNode;
  ObjList : TList<TbfaBaseObject>; CreateList : Boolean = False;
  WithAddfieldItems : Boolean = True);
var
  i : Integer;
  addlistitems : Boolean;
  CurNode  : IXMLNode;
begin
  if RootNode = nil then
  begin
    if ((ObjList.Count > 1) or (CreateList)) then
    begin
      RootNode := XML.AddChild('objlist');
      RootNode.Attributes['typ'] := 'list';
      addlistitems := True;
    end;
  end else
  begin
    if ((ObjList.Count > 1) or (CreateList)) then
    begin
      addlistitems := True;
      RootNode.Attributes['typ'] := 'list';
    end;
  end;

  for i := 0 to ObjList.Count - 1 do
  begin
    CurNode := RootNode;

//    if (ObjList[i] is TbfaBaseDocument) or (ObjList[i] is TbfaDocument) then
//    begin
//      if addlistitems then
//      begin
//        CurNode := RootNode.AddChild('item');
//        CurNode.Attributes['typ'] := 'BitfarmDocument';
//      end else
//      begin
//        if RootNode = nil then
//          CurNode := XML.AddChild('BitfarmDocument')
//        else
//          CurNode := RootNode.AddChild('BitfarmDocument');
//      end;
//
//      DocumentToXML(XML, CurNode, TbfaDocument(ObjList[i]), True);
//    end
//    else if (ObjList[i] is TbfaAddField) then
//    begin
//      if addlistitems then
//      begin
//        CurNode := RootNode.AddChild('item');
//        CurNode.Attributes['typ'] := 'BitfarmAddfield';
//      end else
//      begin
//        if RootNode = nil then
//          CurNode := XML.AddChild('BitfarmAddfield')
//        else
//          CurNode := RootNode.AddChild('BitfarmAddfield');
//      end;
//
//      AddFieldToXML(XML, CurNode, TbfaAddField(ObjList[i]), True, WithAddfieldItems);
//    end
//    else if (ObjList[i] is TbfaStateField) then
//    begin
//      if addlistitems then
//      begin
//        CurNode := RootNode.AddChild('item');
//        CurNode.Attributes['typ'] := 'BitfarmStatefield';
//      end else
//      begin
//        if RootNode = nil then
//          CurNode := XML.AddChild('BitfarmStatefield')
//        else
//          CurNode := RootNode.AddChild('BitfarmStatefield');
//      end;
//
//      StsFieldToXML(XML, CurNode, TbfaStateField(ObjList[i]), True);
//    end
//    else

//    if (ObjList[i] is TbfaBaseSearch) then
//    begin
//      if addlistitems then
//      begin
//        CurNode := RootNode.AddChild('item');
//        CurNode.Attributes['typ'] := 'fav';
//      end else
//      begin
//        if RootNode = nil then
//          CurNode := XML.AddChild('fav')
//        else
//          CurNode := RootNode.AddChild('fav');
//      end;
//
//      SearchObjToXML(XML, CurNode, TbfaSearch(ObjList[i]), i, True);
//    end
//    else if (ObjList[i] is TbfaAnnotation) then
//    begin
//      if addlistitems then
//      begin
//        CurNode := RootNode.AddChild('item');
//        CurNode.Attributes['typ'] := 'BitfarmAnnotation';
//      end else
//      begin
//        if RootNode = nil then
//          CurNode := XML.AddChild('BitfarmAnnotation')
//        else
//          CurNode := RootNode.AddChild('BitfarmAnnotation');
//      end;
//
//      AnnotationToXML(XML, CurNode, TbfaAnnotation(ObjList[i]), True);
//    end
//    else
    if (ObjList[i] is TbfaUser) then
    begin
      if addlistitems then
      begin
        CurNode := RootNode.AddChild('item');
        CurNode.Attributes['typ'] := 'BitfarmUser';
      end else
      begin
        if RootNode = nil then
          CurNode := XML.AddChild('BitfarmUser')
        else
          CurNode := RootNode.AddChild('BitfarmUser');
      end;

      UserToXML(XML, CurNode, TbfaUser(ObjList[i]), True);
    end
    else if (ObjList[i] is TbfaGroup) then
    begin
      if addlistitems then
      begin
        CurNode := RootNode.AddChild('item');
        CurNode.Attributes['typ'] := 'BitfarmGroup';
      end else
      begin
        if RootNode = nil then
          CurNode := XML.AddChild('BitfarmGroup')
        else
          CurNode := RootNode.AddChild('BitfarmGroup');
      end;

      GroupToXML(XML, CurNode, TbfaGroup(ObjList[i]), True);
    end
//    else if (ObjList[i] is TbfaArchive) then
//    begin
//      if addlistitems then
//      begin
//        CurNode := RootNode.AddChild('item');
//        CurNode.Attributes['typ'] := 'BitfarmArchive';
//      end else
//      begin
//        if RootNode = nil then
//          CurNode := XML.AddChild('BitfarmArchive')
//        else
//          CurNode := RootNode.AddChild('BitfarmArchive');
//      end;
//
//      ArchiveToXML(XML, CurNode, TbfaArchive(ObjList[i]), True);
//    end
//    else if (ObjList[i] is TbfaHistory) then
//    begin
//      if addlistitems then
//      begin
//        CurNode := RootNode.AddChild('item');
//        CurNode.Attributes['typ'] := 'BitfarmHistory';
//      end else
//      begin
//        if RootNode = nil then
//          CurNode := XML.AddChild('BitfarmHistory')
//        else
//          CurNode := RootNode.AddChild('BitfarmHistory');
//      end;
//
//      HistoryToXML(XML, CurNode, TbfaHistory(ObjList[i]), True);
//    end
//    else if (ObjList[i] is TbfaWorkflow) then
//    begin
//      if addlistitems then
//      begin
//        CurNode := RootNode.AddChild('item');
//        CurNode.Attributes['typ'] := 'BitfarmWorkflow';
//      end else
//      begin
//        if RootNode = nil then
//          CurNode := XML.AddChild('BitfarmWorkflow')
//        else
//          CurNode := RootNode.AddChild('BitfarmWorkflow');
//      end;
//
//      WorkflowToXML(XML, CurNode, TbfaWorkflow(ObjList[i]), True);
//    end
//    else if (ObjList[i] is TbfaDLM) then
//    begin
//      if addlistitems then
//      begin
//        CurNode := RootNode.AddChild('item');
//        CurNode.Attributes['typ'] := 'BitfarmDLM';
//      end else
//      begin
//        if RootNode = nil then
//          CurNode := XML.AddChild('BitfarmDLM')
//        else
//          CurNode := RootNode.AddChild('BitfarmDLM');
//      end;
//
//      DLMToXML(XML, CurNode, TbfaDLM(ObjList[i]), True);
//    end
//    else if (ObjList[i] is TbfaPredictionResult) then
//    begin
//      if addlistitems then
//      begin
//        CurNode := RootNode.AddChild('item');
//        CurNode.Attributes['typ'] := 'BitfarmPredictionResult';
//      end else
//      begin
//        if RootNode = nil then
//          CurNode := XML.AddChild('BitfarmPredictionResult')
//        else
//          CurNode := RootNode.AddChild('BitfarmPredictionResult');
//      end;
//
//      PredictionResultToXML(XML, CurNode, TbfaPredictionResult(ObjList[i]), True);
//    end
//    else if (ObjList[i] is TbfaGridConfig) then
//    begin
//      if addlistitems then
//      begin
//        CurNode := RootNode.AddChild('item');
//        CurNode.Attributes['typ'] := 'BitfarmGridConfig';
//      end else
//      begin
//        if RootNode = nil then
//          CurNode := XML.AddChild('BitfarmGridConfig')
//        else
//          CurNode := RootNode.AddChild('BitfarmGridConfig');
//      end;
//
//      GridConfigToXML(XML, CurNode, TbfaGridConfig(ObjList[i]), True);
//    end
    else if (ObjList[i] is TbfaRequest) then
    begin
      if addlistitems then
      begin
        CurNode := RootNode.AddChild('item');
        CurNode.Attributes['typ'] := 'bfaReq';
      end else
      begin
        if RootNode = nil then
          CurNode := XML.AddChild('bfaReq')
        else
          CurNode := XML.AddChild('bfaReq');
      end;

      RequestToXML(XML, CurNode, TbfaRequest(ObjList[i]), True);
    end;
  end;

end;

function XMLToFieldRights(XMLNode : IXMLNode): TList<TbfaFieldRight>;
var
  i, j, k: Integer;
  Node, SubNode, SubNode2, SubNode3 : IXMLNode;
  formatSettings : TFormatSettings;
  rights, userid, groupid: Integer;
  fieldright : TBfaFieldRight;
begin
  GetLocaleFormatSettings(GetUserDefaultLCID, formatSettings);
  formatSettings.DateSeparator := '-';
  formatSettings.ShortDateFormat := 'yyyy-mm-dd';
  Result := TList<TbfaFieldRight>.Create;
  try
    for i := 0 to XMLNode.ChildNodes.Count - 1 do
    begin
      Node := XMLNode.ChildNodes[i];

//      if VarIsNull(Node.NodeValue) then
//        continue;
      if LowerCase(Node.NodeName) = '_rights' then
      begin
        SubNode := XMLNode.ChildNodes[i];
        for j := 0 to SubNode.ChildNodes.Count -1 do
        begin
          SubNode2 := SubNode.ChildNodes[j];
//          if VarIsNull(SubNode2.NodeValue) then
//            continue;
          if LowerCase(SubNode2.NodeName) = 'item' then
          begin
            rights := 0;
            userid := 0;
            groupid := 0;
//            SubNode3 := SubNode2.ChildNodes[j];
            for k := 0 to SubNode2.ChildNodes.Count -1 do
            begin
//              if VarIsNull(SubNode3.NodeValue) then
//                continue;
              if LowerCase(SubNode2.ChildNodes[k].NodeName) = '_bitfarmfieldright__rights' then
              begin
                rights := StrToInt(SubNode2.ChildNodes[k].Text);
              end;
              if LowerCase(SubNode2.ChildNodes[k].NodeName) = '_bitfarmfieldright__userid' then
              begin
                userid := StrToInt(SubNode2.ChildNodes[k].Text);
              end;
              if LowerCase(SubNode2.ChildNodes[k].NodeName) = '_bitfarmfieldright__groupid' then
              begin
                groupid := StrToInt(SubNode2.ChildNodes[k].Text);
              end;
            end;
            fieldright := TbfaFieldRight.Create;
            fieldright.Rights := rights;
            fieldright.Userid := userid;
            fieldright.Groupid := groupid;
            Result.Add(fieldright);
          end;
        end;
      end;
    end;
  except

  end;
end;

//function XMLToDocument(XMLNode : IXMLNode): TbfaDocument;
//var
//  i, j, k, l : Integer;
//  Node, AnnoNode, IEVNode, StreamNode, FieldNode, Element, ValueNode, LinkNode : IXMLNode;
//  Attr : OleVariant;
//  AnnoObj : TbfaAnnotation;
//  Addfield : TbfaAddfield;
//  Statefield : TbfaStatefield;
//  formatSettings : TFormatSettings;
//  i64: UInt64;
//  StrVar : Variant;
//  img : TbfaImageEnVect;
//  str : WideString;
//begin
//  GetLocaleFormatSettings(GetUserDefaultLCID, formatSettings);
//  formatSettings.DateSeparator := '-';
//  formatSettings.ShortDateFormat := 'yyyy-mm-dd';
//  Result := TbfaDocument.Create;
//  try
//    for i := 0 to XMLNode.ChildNodes.Count - 1 do
//    begin
//      Node := XMLNode.ChildNodes[i];
//      if LowerCase(Node.NodeName) = '_bitfarmbaseobject__gdocid' then
//        Result.ID := StrToInt64(Node.Text)
//      else if LowerCase(Node.NodeName) = 'tempid' then
//        Result.TempID := StringToGUID(Node.Text)
//      else if LowerCase(Node.NodeName) = '_bitfarmbaseobject__arcid' then
//        Result.ArcID := StrToInt64(Node.Text)
//      else if LowerCase(Node.NodeName) = 'fields_arcid' then
//        Result.Addfields_Arcid := StrToInt64(Node.Text)
//      else if LowerCase(Node.NodeName) = 'docname' then
//        Result.DocName := Node.Text
//      else if LowerCase(Node.NodeName) = 'docloc' then
//        Result.DocLoc := Node.Text
//      else if LowerCase(Node.NodeName) = 'extloc' then
//        Result.ExtLoc := Node.Text
//      else if LowerCase(Node.NodeName) = 'oriloc' then
//        Result.OriLoc := Node.Text
//      else if LowerCase(Node.NodeName) = 'title' then
//        Result.DocName := Node.Text
//      else if LowerCase(Node.NodeName) = 'is_revisionsave' then
//        Result.revsave := (Lowercase(Node.Text) = 'true')
//      else if LowerCase(Node.NodeName) = 'doctags' then
//        Result.DocTags := Node.Text
//      else if LowerCase(Node.NodeName) = 'fulltxt' then
//      begin
//        Result.FullTXT := SysUtils.AdjustLineBreaks(Node.Text);
//      end
//      else if LowerCase(Node.NodeName) = 'checkout_userid' then
//        Result.CheckOutUserID := StrToInt64(Node.Text)
////15.01.2016      else if LowerCase(Node.NodeName) = 'pages' then
////        Result.PageCount := StrToInt(Node.Text)
//      else if LowerCase(Node.NodeName) = 'in_progress' then
//        Result.EditmodeUserID := StrToInt64(Node.Text)
//      else if LowerCase(Node.NodeName) = 'doctype' then
//        Result.DocType := StrToInt(Node.Text)
//      else if LowerCase(Node.NodeName) = 'filetype' then
//        Result.FileType := Node.Text
////17.05.2017      else if LowerCase(Node.NodeName) = 'filepath' then
////        Result.FilePath := Node.Text
//      else if LowerCase(Node.NodeName) = 'filename' then
//        Result.FileName := Node.Text
//      else if LowerCase(Node.NodeName) = 'haspreview' then
//        Result.HasPreview := (Node.Text = '1')
//      else if LowerCase(Node.NodeName) = 'symarcid' then
//        Result.SymbolicArcID := StrToInt(Node.Text)
//      else if LowerCase(Node.NodeName) = 'symlinks' then
//        Result.HasSymlinks := Node.Text
//      else if LowerCase(Node.NodeName) = 'date' then
//        Result.DocDate := StrToDateTime(Node.Text, formatSettings)
//      else if LowerCase(Node.NodeName) = 'modified_date' then
//        Result.ModifiedDate := StrToDateTime(Node.Text, formatSettings)
//      else if LowerCase(Node.NodeName) = 'expired' then
//      begin
//        if Node.Text <> '' then //16.05.2019 sonst strzt hier ab und wird nicht im importer angezeigt
//          Result.Expired := StrToDateTime(Node.Text, formatSettings);
//      end
//      else if LowerCase(Node.NodeName) = 'expired_setby' then
//        Result.Expired_Setby := StrToInt(Node.Text)
//      else if LowerCase(Node.NodeName) = 'expired_modified' then
//        Result.Expired_Modified := (Lowercase(Node.Text) = 'true')
//      else if LowerCase(Node.NodeName) = 'expired_userid' then
//        Result.Expired_Userid := StrToInt(Node.Text)
//      else if LowerCase(Node.NodeName) = 'rights' then
//        Result.Rights := StrToInt64(Node.Text)
////26.10.2017 Ticket 11031      else if LowerCase(Node.NodeName) = 'symbolicarcid' then
//      else if LowerCase(Node.NodeName) = 'symbolic_arcid' then
//        Result.SymbolicArcID := StrToInt64(Node.Text)
//      else if LowerCase(Node.NodeName) = 'hassymlinks' then
//        Result.HasSymlinks := Node.Text
//      else if LowerCase(Node.NodeName) = 'userid' then
//        Result.UserID := StrToInt64(Node.Text)
//      else if LowerCase(Node.NodeName) = 'abo_userid' then
//        Result.AboUserid.DelimitedText := Node.Text
//      else if LowerCase(Node.NodeName) = 'in_editmode' then
//        Result.InEditIDs := Node.Text
//      else if LowerCase(Node.NodeName) = 'tim_id' then
//        Result.TimID := StrToInt64(Node.Text)
//      else if LowerCase(Node.NodeName) = 'imorterdocname_modified' then
//        Result.ImporterDocNameModified := (LowerCase(Node.NodeValue) = 'true')
//      else if LowerCase(Node.NodeName) = 'links' then
//      begin
//        for j := 0 to Node.ChildNodes.Count - 1 do
//        begin
//          LinkNode := Node.ChildNodes[j];
//          if LowerCase(LinkNode.NodeName) = 'item' then
//          begin
//            SetLength(Result.DocLinkList, length(Result.DocLinkList) +1);
//            l := length(Result.DocLinkList) -1;
//            Result.DocLinkList[l].RefName := LinkNode.Text;
//            Result.DocLinkList[l].Count := -1;
//            Result.DocLinkList[l].GDocID := -1;
//            Result.DocLinkList[l].RefID := -1;
//          end;
//        end;
//      end
//      else if LowerCase(Node.NodeName) = 'annotations' then
//      begin
//        for j := 0 to Node.ChildNodes.Count - 1 do
//        begin
//          AnnoNode := Node.ChildNodes[j];
//          if LowerCase(AnnoNode.NodeName) = 'item' then
//          begin
//            Attr := AnnoNode.Attributes['typ'];
//            if not VarIsNULL(Attr) then
//            begin
//              if (LowerCase(Attr) = 'bitfarmannotation') then
//              begin
//                AnnoObj := TbfaAnnotation.Create;
//
//                AnnoObj.Page := 0;
//                AnnoObj.Layer := 0;
//                for k := 0 to AnnoNode.ChildNodes.Count - 1 do
//                begin
//                  IEVNode := AnnoNode.ChildNodes[k];
//                  if LowerCase(IEVNode.NodeName) = 'filepath' then
//                  begin
//                    AnnoObj.FilePath := IEVNode.Text;
//                  end;
//                  if LowerCase(IEVNode.NodeName) = 'page' then
//                  begin
//                    AnnoObj.Page := StrToInt(IEVNode.Text);
//                  end;
//                  if LowerCase(IEVNode.NodeName) = 'layer' then
//                  begin
//                    AnnoObj.Layer := StrToInt(IEVNode.Text);
//                  end;
//                  if LowerCase(IEVNode.NodeName) = 'iev' then
//                  begin
//                    for l := 0 to IEVNode.ChildNodes.Count - 1 do
//                    begin
//                      StreamNode := IEVNode.ChildNodes[l];
//                      if LowerCase(StreamNode.NodeName) = 'stream' then
//                      begin
//                        Str := StringReplace(StreamNode.Text, #$A, '', [rfReplaceAll]);
//                        DecodeStream(str, AnnoObj.AnnoStream);
//                      end;
//                    end;
//                  end;
//                  if LowerCase(IEVNode.NodeName) = 'rights' then
//                  begin
//                    AnnoObj.Rights := StrToInt(IEVNode.Text);
//                  end;
//                end;
//
//                if (AnnoObj.AnnoStream <> nil) and (AnnoObj.AnnoStream.Size > 0)
//                  and (AnnoObj.Layer = 0) then
//                begin
//                  img := TbfaImageEnVect.Create(nil);
//                  img.Visible := False;
//                  try
//                    AnnoObj.AnnoStream.Position := 0;
//                    img.LoadFromStreamIEV(AnnoObj.AnnoStream);
//
//                    for l := 0 to img.ObjectsCount - 1 do
//                    begin
//                      SetLength(AnnoObj.ObjList, Length(AnnoObj.ObjList) + 1);
//                      with AnnoObj.ObjList[High(AnnoObj.ObjList)] do
//                      begin
//                        ID := img.GetObjFromIndex(l);
//                        ObjKind := img.ObjKind[l];
//                        ObjText := img.ObjText[l];
//                        Modified := False;
//                        NewText := '';
//                        ModifiedType := 0;
//                      end;
//                    end;
//                  finally
//                    FreeAndNil(img);
//                  end;
//                end;
//
//                Result.Annotations.Add(AnnoObj);
//
//              end;
//            end;
//          end;
//        end;
//      end
//      else if LowerCase(Node.NodeName) = 'fields' then
//      begin
//        for j := 0 to Node.ChildNodes.Count - 1 do
//        begin
//          FieldNode := Node.ChildNodes[j];
//          if LowerCase(FieldNode.NodeName) = 'item' then
//          begin
//            Attr := FieldNode.Attributes['typ'];
//            if not VarIsNULL(Attr) then
//            begin
//              if (LowerCase(Attr) = 'bitfarmaddfield') then
//              begin
//                Result.AddFields.Add(TbfaAddField.Create);
//                Result.AddFields[j].Typ := 0;
//                Result.AddFields[j].IndexTableID := 0;
//                for k := 0 to FieldNode.ChildNodes.Count - 1 do
//                begin
//                  Element := FieldNode.ChildNodes[k];
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = 'name' then
//                  begin
//                    Result.AddFields[j].DisplayName := FieldNode.ChildNodes[k].Text;
//                  end;
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = 'id' then
//                  begin
//                     Result.AddFields[j].ID := StrToInt64(FieldNode.ChildNodes[k].Text);
//                  end;
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = 'add' then
//                  begin
//                     Result.AddFields[j].Name := FieldNode.ChildNodes[k].Text;
//                  end;
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = 'mode' then
//                  begin
//                     Result.AddFields[j].Mode := StrToInt(FieldNode.ChildNodes[k].Text);
//                  end;
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = 'options' then
//                  begin
//                     Result.AddFields[j].Options := StrToInt(FieldNode.ChildNodes[k].Text);
//                  end;
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = 'indextableid' then
//                  begin
//                     Result.AddFields[j].IndexTableID := StrToInt(FieldNode.ChildNodes[k].Text);
//                  end;
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = '_bitfarmaddfield__value' then
//                  begin
//                    try
//                      Attr := FieldNode.ChildNodes[k].Attributes['typ'];
//                      if not VarIsNULL(Attr) then
//                      begin
//                        if (LowerCase(Attr) = 'list') then
//                        begin
//                          if FieldNode.ChildNodes[k].HasChildNodes then
//                          begin
//                            StrVar := '';
//                            for l := 0 to FieldNode.ChildNodes[k].ChildNodes.Count - 1 do
//                            begin
//                              ValueNode := FieldNode.ChildNodes[k].ChildNodes[l];
//                              if LowerCase(ValueNode.NodeName) = 'item' then
//                              begin
//                                if StrVar <> '' then
//                                  StrVar := StrVar + ';' + ValueNode.Text
//                                else
//                                  StrVar := ValueNode.Text;
//                              end;
//                            end;
//                            Result.AddFields[j].Value := StrVar;
//                          end
//                          else
//                            Result.AddFields[j].Value := FieldNode.ChildNodes[k].Text;
//                        end
//                        else if (Attr = 'datetime.datetime') then
//                        begin
////                            Result.AddFields[j].Value := FormatDateTime(formatSettings.ShortDateFormat,
////                              StrToDateTime(FieldNode.ChildNodes[k].Text, formatSettings))
//                          try
//                            if VarIsNull(FieldNode.ChildNodes[k].Text) or
//                              (LowerCase(FieldNode.ChildNodes[k].Text) = 'null') OR
//                              (LowerCase(FieldNode.ChildNodes[k].Text) = '') then
//                              Result.AddFields[j].Value := NULL
//                            else
//                              Result.AddFields[j].Value := StrToDateTime(FieldNode.ChildNodes[k].Text, formatSettings);
//                          except
//                            Result.AddFields[j].Value := NULL;
//                          end;
//                        end
//                        else if (Attr = 'float') then
//                        begin
//                          try   // von der Datenbank kommt immer Punkt als Trennzeichen, wir ndern in das clientspezifische Trennzeichen
//                            Result.AddFields[j].Value:= ReplaceStr(FieldNode.ChildNodes[k].Text, '.', formatSettings.DecimalSeparator);
//                          except
//                            Result.AddFields[j].Value := 0;
//                          end;
//                        end
//                        else if (LowerCase(Attr) = 'decimal') then
//                        begin
//                          try  // von der Datenbank kommt immer Punkt als Trennzeichen, wir ndern in das clientspezifische Trennzeichen
//                            Result.AddFields[j].Value := ReplaceStr(FieldNode.ChildNodes[k].Text, '.', formatSettings.DecimalSeparator);
//                          except
//                            Result.AddFields[j].Value := 0;
//                          end;
//                        end
//                        else
//                          Result.AddFields[j].Value := FieldNode.ChildNodes[k].Text;
//                      end
//                      else
//                        Result.AddFields[j].Value := FieldNode.ChildNodes[k].Text;
//                    except
//
//                    end;
//                  end;
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = 'type' then
//                  begin
//                     Result.AddFields[j].Typ := StrToInt(FieldNode.ChildNodes[k].Text);
//                  end;
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = 'rights' then
//                  begin
//                     Attr := FieldNode.ChildNodes[k].Attributes['typ'];
//                     if (LowerCase(Attr) = 'bitfarmfieldrights') then
//                       Result.AddFields[j].FieldRights := XMLToFieldRights(FieldNode.ChildNodes[k]);
//                  end;
//                end;
//              end;
//            end;
//          end;
//        end;
//      end
//      else if LowerCase(Node.NodeName) = 'statefields' then
//      begin
//        for j := 0 to Node.ChildNodes.Count - 1 do
//        begin
//          FieldNode := Node.ChildNodes[j];
//          if LowerCase(FieldNode.NodeName) = 'item' then
//          begin
//            Attr := FieldNode.Attributes['typ'];
//            if not VarIsNULL(Attr) then
//            begin
//              if (LowerCase(Attr) = 'bitfarmstatefield') then
//              begin
//                Result.StateFields.Add(TbfaStateField.Create);
//                Result.StateFields[j];
//                Result.StateFields[j].Value := False;
//                for k := 0 to FieldNode.ChildNodes.Count - 1 do
//                begin
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = 'id' then
//                  begin
//                     Result.StateFields[j].ID := StrToInt64(FieldNode.ChildNodes[k].Text);
//                  end;
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = 'name' then
//                  begin
//                    Result.StateFields[j].DisplayName := FieldNode.ChildNodes[k].Text;
//                  end;
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = '_bitfarmstatefield__bitmask' then
//                  begin
//                    Result.StateFields[j].Bitmask := StrToInt64(FieldNode.ChildNodes[k].Text);
//                  end;
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = '_bitfarmstatefield__value' then
//                  begin
//                    try
//                      if FieldNode.ChildNodes[k].Text <> '' then
//                        Result.StateFields[j].Value := StrToBool(FieldNode.ChildNodes[k].Text);
//                    except
//
//                    end;
//                  end;
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = 'indexcolumnid' then
//                  begin
//                     Result.StateFields[j].IndexColumnID := StrToInt(FieldNode.ChildNodes[k].Text);
//                  end;
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = 'addfieldid' then
//                  begin
//                     Result.StateFields[j].AddfieldID := StrToInt(FieldNode.ChildNodes[k].Text);
//                  end;
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = 'function' then
//                  begin
//                     Result.StateFields[j].Func := StrToInt(FieldNode.ChildNodes[k].Text);
//                  end;
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = 'rights' then
//                  begin
//                     Attr := FieldNode.ChildNodes[k].Attributes['typ'];
//                     if (LowerCase(Attr) = 'bitfarmfieldrights') then
//                       Result.StateFields[j].FieldRights := XMLToFieldRights(FieldNode.ChildNodes[k]);
//                  end;
//                end;
//              end;
//            end;
//          end;
//        end;
//      end
//      else if LowerCase(Node.NodeName) = 'svn_history' then
//      begin
//        for j := 0 to Node.ChildNodes.Count - 1 do
//        begin
//          FieldNode := Node.ChildNodes[j];
//          if LowerCase(FieldNode.NodeName) = 'item' then
//          begin
//            Attr := FieldNode.Attributes['typ'];
//            if not VarIsNULL(Attr) then
//            begin
//              if (LowerCase(Attr) = 'bitfarmsvnfield') then
//              begin
//                Result.SvnHistory.Add(TbfaSvnField.Create);
//                for k := 0 to FieldNode.ChildNodes.Count - 1 do
//                begin
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = '_svn_id' then
//                  begin
//                     Result.SvnHistory[j].ID := StrToInt64(FieldNode.ChildNodes[k].Text);
//                  end;
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = '_gdocid' then
//                  begin
//                     Result.SvnHistory[j].GdocID := StrToInt64(FieldNode.ChildNodes[k].Text);
//                  end;
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = '_svn_version' then
//                  begin
//                     Result.SvnHistory[j].Version := StrToInt(FieldNode.ChildNodes[k].Text);
//                  end;
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = '_svn_revision' then
//                  begin
//                     Result.SvnHistory[j].Revision := StrToInt(FieldNode.ChildNodes[k].Text);
//                  end;
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = '_svn_userid' then
//                  begin
//                     Result.SvnHistory[j].Userid := StrToInt(FieldNode.ChildNodes[k].Text);
//                  end;
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = '_svn_date' then
//                  begin
//                    try
//                      Result.svnHistory[j].Date := StrToDateTime(FieldNode.ChildNodes[k].Text, formatSettings);
//                    except
//                      Result.svnHistory[j].Date := NULL
//                    end;
//                  end;
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = 'svn_info' then
//                  begin
//                     Result.SvnHistory[j].Info := FieldNode.ChildNodes[k].Text;
//                  end;
//                end;
//              end;
//            end;
//          end;
//        end;
//      end
//      else if LowerCase(Node.NodeName) = 'workflows' then
//      begin
//        for j := 0 to Node.ChildNodes.Count - 1 do
//        begin
//          FieldNode := Node.ChildNodes[j];
//          if LowerCase(FieldNode.NodeName) = 'item' then
//          begin
//            Attr := FieldNode.Attributes['typ'];
//            if not VarIsNULL(Attr) then
//            begin
//              if (LowerCase(Attr) = 'bitfarmworkflow') then
//              begin
//                Result.Workflows.Add(TbfaWorkflow.Create);
//                for k := 0 to FieldNode.ChildNodes.Count - 1 do
//                begin
//                  if VarIsNull(FieldNode.ChildNodes[k].NodeValue) then
//                    continue;
//                  if LowerCase(FieldNode.ChildNodes[k].NodeName) = 'info' then
//                    Result.Workflows[j].Info := FieldNode.ChildNodes[k].NodeValue
//                  else if LowerCase(FieldNode.ChildNodes[k].NodeName) = 'comment' then
//                    Result.Workflows[j].Comment := FieldNode.ChildNodes[k].NodeValue
//                  else if (LowerCase(FieldNode.ChildNodes[k].NodeName) = 'tim_id') then
//                    Result.Workflows[j].TimID := StrToInt(FieldNode.ChildNodes[k].NodeValue)
//                  else if (LowerCase(FieldNode.ChildNodes[k].NodeName) = 'tim_ref') then
//                    Result.Workflows[j].TimRef := StrToInt(FieldNode.ChildNodes[k].NodeValue)
//                  else if (LowerCase(FieldNode.ChildNodes[k].NodeName) = '_BitfarmBaseObject__gdocid') then
//                    Result.Workflows[j].Gdocid := StrToInt(FieldNode.ChildNodes[k].NodeValue)
//                  else if (LowerCase(FieldNode.ChildNodes[k].NodeName) = 'status') then
//                    Result.Workflows[j].Status := StrToInt(FieldNode.ChildNodes[k].NodeValue)
//                  else if (LowerCase(FieldNode.ChildNodes[k].NodeName) = 'options') then
//                    Result.Workflows[j].Options := StrToInt(FieldNode.ChildNodes[k].NodeValue)
//                  else if (LowerCase(FieldNode.ChildNodes[k].NodeName) = 'userid_work') then
//                    Result.Workflows[j].UseridWork := StrToInt(FieldNode.ChildNodes[k].NodeValue)
//                  else if (LowerCase(FieldNode.ChildNodes[k].NodeName) = 'userid_shed') then
//                    Result.Workflows[j].UseridShed := StrToInt(FieldNode.ChildNodes[k].NodeValue)
//                  else if (LowerCase(FieldNode.ChildNodes[k].NodeName) = 'groupid') then
//                    Result.Workflows[j].GroupID := StrToInt(FieldNode.ChildNodes[k].NodeValue)
//                  else if (LowerCase(FieldNode.ChildNodes[k].NodeName) = 'date') then
//                  begin
//                    try
//                      Result.Workflows[j].Date := StrToDateTime(FieldNode.ChildNodes[k].NodeValue,formatSettings);
//                    except
//                      Result.Workflows[j].Date := NULL
//                    end;
//                  end
//                  else if (LowerCase(FieldNode.ChildNodes[k].NodeName) = 'alarm_date') then
//                  begin
//                    try
//                      Result.Workflows[j].AlarmDate := StrToDateTime(FieldNode.ChildNodes[k].NodeValue,formatSettings);
//                    except
//                      Result.Workflows[j].AlarmDate := NULL
//                    end;
//                  end
//                  else if (LowerCase(FieldNode.ChildNodes[k].NodeName) = 'modified_date') then
//                  begin
//                    try
//                      Result.Workflows[j].ModifiedDate := StrToDateTime(FieldNode.ChildNodes[k].NodeValue,formatSettings);
//                    except
//                      Result.Workflows[j].ModifiedDate := NULL
//                    end;
//                  end;
//                end;
//              end;
//            end;
//          end;
//        end;
//      end;
//    end;
//  except
//    Result := nil;
//  end;
//end;
//
//
//
//function XMLToSearchObj(XMLNode : IXMLNode): TbfaSearch;
//var
//  Node : IXMLNode;
//  Attr : OleVariant;
//  i, j, ver : Integer;
//  Tmp : TStringList;
//  Fld : TbfaAddField;
//  Sts : TbfaStateField;
//  FieldsNode, FieldNode, ChildNode : IXMLNode;
//begin
//  Result := TbfaSearch.Create;
//  try
//    Tmp := TStringList.Create;
//    try
//
//      Attr := XMLNode.Attributes['version'];
//      if not VarIsNULL(Attr) then
//        ver := Attr
//      else
//        ver := -1;
//      Attr := XMLNode.Attributes['name_fav'];
//      if not VarIsNULL(Attr) then
//        Result.Name := Attr;
//      Attr := XMLNode.Attributes['id'];
//      if not VarIsNULL(Attr) then
//        Result.ID := Attr;
//      Attr := XMLNode.Attributes['Suchdatum'];
//      if not VarIsNULL(Attr) then
//        Result.Date := Attr;
//      if VarIsNull(Result.Date) then
//      begin
//        Attr := XMLNode.Attributes['date'];
//        if not VarIsNULL(Attr) then
//          Result.Date := Attr;
//      end;
//      Attr := XMLNode.Attributes['userid'];
//      if not VarIsNULL(Attr) then
//          Result.UserID := Attr;
//      Attr := XMLNode.Attributes['groupid'];
//      if not VarIsNULL(Attr) then
//          Result.GroupID := Attr;
//      for i := 0 to XMLNode.ChildNodes.Count - 1 do
//      begin
//        ChildNode := XMLNode.ChildNodes[i];
//        if LowerCase(ChildNode.NodeName) = 'guid' then
//        begin
//          Result.GUID := ChildNode.NodeValue;
//        end
//        else if LowerCase(ChildNode.NodeName) = 'gbadvusrsrc' then
//        begin
//          Result.SQLWhereOnly := ChildNode.NodeValue = '-1';
//        end
//        else if LowerCase(ChildNode.NodeName) = 'sqlwhereonly' then
//        begin
//          Result.SQLWhereOnly := (LowerCase(ChildNode.NodeValue) = 'true');
//        end
//        else if LowerCase(ChildNode.NodeName) = 'sqlwhere' then
//        begin
//          Result.SQLWhere := ChildNode.NodeValue;
//        end
//        else if LowerCase(ChildNode.NodeName) = 'arcid' then
//        begin
//          Result.ArcID.CommaText := ChildNode.NodeValue;
//        end
//        else if LowerCase(ChildNode.NodeName) = 'selectedarcid' then
//        begin
//          Result.SelectedArcID := ChildNode.NodeValue;
//        end
//        else if LowerCase(ChildNode.NodeName) = 'gdocid' then
//        begin
//          Result.GdocID.CommaText := ChildNode.NodeValue;
//        end
//        else if LowerCase(ChildNode.NodeName) = 'searchtype' then
//        begin
//          Result.SearchType := StrToInt(ChildNode.NodeValue);
//        end
//        else if LowerCase(ChildNode.NodeName) = 'maxvalues' then
//        begin
//          if ((Lowercase(ChildNode.NodeValue) <> 'alle') and (LowerCase(ChildNode.NodeValue) <> 'all')) then
//            Result.MaxValues := ChildNode.NodeValue
//          else
//            Result.MaxValues := 0;
//        end
//        else if ((LowerCase(ChildNode.NodeName) = 'istat') or (LowerCase(ChildNode.NodeName) = 'state')) then
//        begin
//          Result.State := ChildNode.NodeValue;
//        end
//        else if ((LowerCase(ChildNode.NodeName) = 'nistat') or (LowerCase(ChildNode.NodeName) = 'notstate')) then
//        begin
//          Result.NotState := ChildNode.NodeValue;
//        end
//        else if ((LowerCase(ChildNode.NodeName) = 'notslw') or (LowerCase(ChildNode.NodeName) = 'ftx_negated')) then
//        begin
//          Result.SearchStringNegated := ChildNode.NodeValue;
//        end
//        else if LowerCase(ChildNode.NodeName) = 'icheckout' then
//        begin
//          Result.CheckOut := StrToInt(ChildNode.NodeValue);
//        end
//        else if LowerCase(ChildNode.NodeName) = 'checkout' then
//        begin
//          Result.CheckOut := StrToInt(ChildNode.NodeValue);
//        end
//        else if LowerCase(ChildNode.NodeName) = 'inresub' then
//        begin
//          Result.InResub := (LowerCase(ChildNode.NodeValue) = 'true');
//        end
//        else if LowerCase(ChildNode.NodeName) = 'inresub_negated' then
//        begin
//          Result.InResubNegated := (LowerCase(ChildNode.NodeValue) = 'true');
//        end
//        else if LowerCase(ChildNode.NodeName) = 'verify' then
//        begin
//          Result.Verify := (LowerCase(ChildNode.NodeValue) = 'true');
//        end
//        else if LowerCase(ChildNode.NodeName) = 'count' then
//        begin
//          Result.Count := ChildNode.NodeValue;
//        end
//        else if ((LowerCase(ChildNode.NodeName) = 'vtx') or (LowerCase(ChildNode.NodeName) = 'ftx') or (LowerCase(ChildNode.NodeName) = 'slw')) then
//        begin
//          if ((LowerCase(ChildNode.NodeName) = 'vtx') or (LowerCase(ChildNode.NodeName) = 'ftx')) then
//            Result.FtxFields := Result.FtxFields or 1
//          else
//            Result.FtxFields := Result.FtxFields or 2;
//
//          if (VarIsNull(Result.SearchString) or (Result.SearchString = '')) then
//            Result.SearchString := ChildNode.NodeValue
//          else
//            Result.SearchString := Result.SearchString + ' ' + ChildNode.NodeValue;
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'ftx_fields') then
//        begin
//          Result.FtxFields := ChildNode.NodeValue;
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'sqlwhere_operator') then
//        begin
//          Result.SQLWhereOperator := ChildNode.NodeValue;
//        end
//        else if LowerCase(ChildNode.NodeName) = 'ftx_matchagainst' then
//        begin
//          Result.FtxMatchAgainst := (LowerCase(ChildNode.NodeValue) = 'true');
//        end
//        else if LowerCase(ChildNode.NodeName) = 'ftx_booleanmode' then
//        begin
//          Result.FtxBooleanMode := (LowerCase(ChildNode.NodeValue) = 'true');
//        end
//        else if LowerCase(ChildNode.NodeName) = 'ftx_naturalmode' then
//        begin
//          Result.FtxNaturalMode := (LowerCase(ChildNode.NodeValue) = 'true');
//        end
//        else if LowerCase(ChildNode.NodeName) = 'ftx_withqueryexpansion' then
//        begin
//          Result.FtxWithQueryExpansion := (LowerCase(ChildNode.NodeValue) = 'true');
//        end
//        else if LowerCase(ChildNode.NodeName) = 'refsearch' then
//        begin
//          Result.RefSearch := ChildNode.NodeValue;
//        end
//        else if LowerCase(ChildNode.NodeName) = 'timref' then
//        begin
//          Result.TimRef.CommaText := ChildNode.NodeValue;
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'searchuserid') then
//        begin
//          Result.SearchUserID := StrToInt(ChildNode.NodeValue);
//        end
//        else if ((LowerCase(ChildNode.NodeName) = 'benutzer') or (LowerCase(ChildNode.NodeName) = 'searchuser')) then
//        begin
//          Result.SearchUser := ChildNode.NodeValue;
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'notbenutzer') then
//        begin
//          Result.SearchUser := ChildNode.NodeValue;
//          Result.SearchUserNegated := True;
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'searchuser_negated') then
//        begin
//          Result.SearchUserNegated := (LowerCase(ChildNode.NodeValue) = 'true');
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'searchgroupid') then
//        begin
//          Result.SearchGroupID := StrToInt(ChildNode.NodeValue);
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'searchgroup') then
//        begin
//          Result.SearchGroup := ChildNode.NodeValue;
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'searchgroup_negated') then
//        begin
//          Result.SearchGroupNegated := (LowerCase(ChildNode.NodeValue) = 'true');
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'constructive') then
//        begin
//          Result.Constructive := (LowerCase(ChildNode.NodeValue) = 'true');
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'selected_cols') then
//        begin
//          Result.SelectedCols := ChildNode.NodeValue;
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'datevom') then
//        begin
//          Result.SearchDate := FloatToStr(ChildNode.NodeValue);
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'datebis') then
//        begin
//          Result.SearchDateHigh := FloatToStr(ChildNode.NodeValue);
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'notdatevom') then
//        begin
//          Result.SearchDate := FloatToStr(ChildNode.NodeValue);
//          Result.SearchDateNegated := True;
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'searchdate') then
//        begin
//          try
////            Result.SearchDate := FormatDateTime('yyyy-mm-dd  hh:nn:ss', StrToDate(ChildNode.NodeValue));
//            Result.SearchDate := VarToDateTime(ChildNode.NodeValue);
//          except
//            Result.SearchDate := NULL;
//          end;
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'searchdatehigh') then
//        begin
//          try
////            Result.SearchDateHigh := FormatDateTime('yyyy-mm-dd  hh:nn:ss', StrToDate(ChildNode.NodeValue));
//            Result.SearchDateHigh := VarToDateTime(ChildNode.NodeValue);
//          except
//            Result.SearchDateHigh := NULL;
//          end;
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'searchdate_negated') then
//        begin
//          Result.SearchDateNegated := (LowerCase(ChildNode.NodeValue) = 'true');
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'searchdatetype') then
//        begin
//          Result.SearchDateType:= StrToInt(ChildNode.NodeValue);
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'groupby') then
//          Result.GroupBy := ChildNode.NodeValue
//        else if (LowerCase(ChildNode.NodeName) = 'direction') then
//        begin
//          Result.Direction := ChildNode.NodeValue;
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'order') then
//        begin
//          Result.Order := ChildNode.NodeValue;
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'docname') then
//        begin
//          Result.DocName := ChildNode.NodeValue;
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'docname_negated') then
//        begin
//          Result.DocNameNegated := (LowerCase(ChildNode.NodeValue) = 'true');
//        end
//        else if LowerCase(ChildNode.NodeName) = 'grouplist' then
//        begin
//          if not VarIsNull(ChildNode.NodeValue) then  //04.08.2017 kann NULL sein so hier kommt ein exception
//            Result.GroupList.CommaText := ChildNode.NodeValue;
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'resubalarm') then
//        begin
//          try
////            Result.ResubAlarm := FormatDateTime('yyyy-mm-dd  hh:nn:ss', StrToDate(ChildNode.NodeValue));
//            Result.ResubAlarm := VarToDateTime(ChildNode.NodeValue);
//          except
//            Result.ResubAlarm := NULL;
//          end;
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'resubalarmhigh') then
//        begin
//          try
////            Result.ResubAlarmHigh := FormatDateTime('yyyy-mm-dd  hh:nn:ss', StrToDate(ChildNode.NodeValue));
//            Result.ResubAlarmHigh := VarToDateTime(ChildNode.NodeValue);
//          except
//            Result.ResubAlarmHigh := NULL;
//          end;
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'resubalarm_negated') then
//        begin
//          Result.ResubAlarmNegated := (LowerCase(ChildNode.NodeValue) = 'true');
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'resubdate') then
//        begin
//          try
////            Result.ResubDate := FormatDateTime('yyyy-mm-dd  hh:nn:ss', StrToDate(ChildNode.NodeValue));
//            Result.ResubDate := VarToDateTime(ChildNode.NodeValue);
//          except
//            Result.ResubDate := NULL;
//          end;
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'resubdatehigh') then
//        begin
//          try
////            Result.ResubDateHigh := FormatDateTime('yyyy-mm-dd  hh:nn:ss', StrToDate(ChildNode.NodeValue));
//            Result.ResubDateHigh := VarToDateTime(ChildNode.NodeValue);
//          except
//            Result.ResubDateHigh := NULL;
//          end;
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'resubdate_negated') then
//        begin
//          Result.ResubDateNegated := (LowerCase(ChildNode.NodeValue) = 'true');
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'resubcontrollerid') then
//        begin
//          Result.ResubControllerID := StrToInt(ChildNode.NodeValue);
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'resubcontrollerid_negated') then
//        begin
//          Result.ResubControllerIDNegated := (LowerCase(ChildNode.NodeValue) = 'true');
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'resubuserid') then
//        begin
//          Result.ResubUserID := StrToInt(ChildNode.NodeValue);
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'resubuserid_negated') then
//        begin
//          Result.ResubUserIDNegated := (LowerCase(ChildNode.NodeValue) = 'true');
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'resubstate') then
//        begin
//          Result.ResubState := StrToInt(ChildNode.NodeValue);
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'resubnotstate') then
//        begin
//          Result.ResubNotState := StrToInt(ChildNode.NodeValue);
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'resulttype') then
//        begin
//          Result.ResultType := ChildNode.NodeValue;
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'searchfields') then
//        begin
//          for j := 0 to ChildNode.ChildNodes.Count - 1 do
//          begin
//            FieldsNode := ChildNode.ChildNodes[j];
//            if LowerCase(FieldsNode.NodeName) = 'bitfarmaddfield' then
//            begin
//              Fld := XMLToAddField(FieldsNode);
//              Fld.ModifiedSearch := True;
//              Result.AddFields.Add(Fld);
//            end
//            else if LowerCase(FieldsNode.NodeName) = 'bitfarmstatefield' then
//            begin
//              Sts := XMLToStsField(FieldsNode);
//              Sts.ModifiedSearch := True;
//              Result.StsFields.Add(Sts);
//            end;
//          end;
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'rightsmask') then
//        begin
//          Result.RightsMask := StrToInt(ChildNode.NodeValue);
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'dont_refresh_dataset') then
//        begin
//          Result.DontRefreshDataSet := (LowerCase(ChildNode.NodeValue) = 'true');
//        end
//        else if (LowerCase(ChildNode.NodeName) = 'dont_inheritate') then
//        begin
//          Result.DontInheritate := (LowerCase(ChildNode.NodeValue) = 'true');
//        end
//      end;
//
//      if VarIsNull(Result.SelectedCols) then
//        Result.SelectedCols := 'gdocid,docname,username,docdate, sd.modified AS doc_modified';
//
//      if (Result.SelectedArcID = -1) and
//          (Result.ArcID.Count = 1) then
//        Result.SelectedArcID := StrToInt(Result.ArcID[0]);
//
//
//    finally
//      FreeAndNil(Tmp);
//    end;
//
//  except
//    Result := nil;
//  end;
//end;


function XMLToRequest(XMLNode : IXMLNode; Lst : TList<TbfaBaseObject>): TbfaRequest;

//  function GetFtxColor(clidx : Integer) : TColor;
//  begin
//    if clidx > 4 then
//      clidx := clidx - 4;
//
//    case clidx of
//      0 : Result := gclRed;
//      1 : Result := gclBlue; //15.04.2021 clBlue;
//      2 : Result := gclGreen; //15.04.2021 clGreen;
//      3 : Result := clMaroon;
//    end;
//  end;

var
  i, j, k : Integer;
  Node, SubNode : IXMLNode;
  Attr : OleVariant;
//  FtxPos : TbfaFtxPos;
  formatSettings : TFormatSettings;
begin
  GetLocaleFormatSettings(GetUserDefaultLCID, formatSettings);
  formatSettings.DateSeparator := '-';
  formatSettings.ShortDateFormat := 'yyyy-mm-dd';
  Result := TbfaRequest.Create;
  try
    for i := 0 to XMLNode.ChildNodes.Count - 1 do
    begin
      Node := XMLNode.ChildNodes[i];
      if LowerCase(Node.NodeName) = '_bfareq__reqtype' then
        Result.ReqType := Node.Text
      else if LowerCase(Node.NodeName) = 'filename' then
        Result.FileName := Node.Text
      else if LowerCase(Node.NodeName) = 'filehash' then
        Result.FileHash := Node.Text
      else if LowerCase(Node.NodeName) = 'filedate' then
        Result.FileDate := StrToDateTime(LeftStr(Node.Text,19),formatSettings)
      else if LowerCase(Node.NodeName) = '_bitfarmbaseobject__gdocid' then
      begin
        Result.ID := StrToInt64(Node.Text);
        Result.Gdocid := StrToInt64(Node.Text);
      end
      else if LowerCase(Node.NodeName) = 'fields_arcid' then
        Result.Addfields_Arcid := StrToInt(Node.Text)
      else if LowerCase(Node.NodeName) = 'datalen' then
        Result.DataLen := StrToInt(Node.Text)
      else if LowerCase(Node.NodeName) = 'revision' then
        Result.Revision := StrToInt(Node.Text)
      else if LowerCase(Node.NodeName) = 'version' then
        Result.Version := StrToInt(Node.Text)
      else if LowerCase(Node.NodeName) = 'userid' then
        Result.UserID := StrToInt(Node.Text)
      else if LowerCase(Node.NodeName) = 'parameter' then
        Result.Parameter := Node.Text
      else if LowerCase(Node.NodeName) = 'datatype' then
        Result.DataType := Node.Text
      else if LowerCase(Node.NodeName) = 'lang' then
        Result.Lang := Node.Text
      else if LowerCase(Node.NodeName) = 'sessionid' then
        Result.Sessionid := Node.Text
      else if LowerCase(Node.NodeName) = '_bitfarmbaseobject__errortext' then
        Result.DataString := Node.Text
      else if LowerCase(Node.NodeName) = '_bfareq__data' then
      begin
        Attr := Node.Attributes['typ'];
        if not VarIsNULL(Attr) then
        begin
          if (Lowercase(Attr) = 'bitfarmdocument') then
          begin
//            Lst.Add(XMLToDocument(Node));
          end
          else if Lowercase(Attr) = 'list' then
          begin
            for j := 0 to Node.ChildNodes.Count - 1 do
            begin
              SubNode := Node.ChildNodes[j];
//              if (LowerCase(SubNode.NodeName) = 'item') and
//                  (Lowercase(SubNode.Attributes['typ']) = 'bitfarmhistory') then
//                Lst.Add(XMLToHistory(SubNode));
//              if (LowerCase(SubNode.NodeName) = 'item') and
//                  (Lowercase(SubNode.Attributes['typ']) = 'svn_history') then
//                Lst.Add(XMLToSvnField(SubNode));
//              if (LowerCase(SubNode.NodeName) = 'item') and
//                  (Lowercase(SubNode.Attributes['typ']) = 'workflows') then
//                Lst.Add(XMLToWorkflow(SubNode));
//              if (LowerCase(SubNode.NodeName) = 'item') and
//                  (Lowercase(SubNode.Attributes['typ']) = 'bitfarmaddfield') then
//                Lst.Add(XMLToAddField(SubNode));
//              if (LowerCase(SubNode.NodeName) = 'item') and
//                  (Lowercase(SubNode.Attributes['typ']) = 'bitfarmdlm') then
//                Lst.Add(XMLToDLM(SubNode));
//              if (LowerCase(SubNode.NodeName) = 'item') and
//                  (Lowercase(SubNode.Attributes['typ']) = 'bitfarmadentry') then
//                Lst.Add(XMLToADEntry(SubNode));
//              if (LowerCase(SubNode.NodeName) = 'item') and
//                  (Lowercase(SubNode.Attributes['typ']) = 'bitfarmpredictionresult') then
//                Lst.Add(XMLToPredictionResult(SubNode));
            end;
          end
          else if Lowercase(Attr) = 'dict' then
          begin

            for j := 0 to Node.ChildNodes.Count - 1 do
            begin
              SubNode := Node.ChildNodes[j];
              if (LowerCase(SubNode.NodeName) = 'item') and
                  (Lowercase(SubNode.Attributes['typ']) = 'dict') then
              begin
                for k := 0 to SubNode.ChildNodes.Count - 1 do
                begin
//                  FtxPos := TbfaFtxPos.create;
//                  FtxPos.Word := SubNode.Attributes['name'];
//                  FtxPos.Color := GetFtxColor(j);
//                  FtxPos.WordList.Add(XMLToWordPos(SubNode.ChildNodes[k]));
//                  Lst.Add(FtxPos);
                end;
              end;
            end;


          end
          else if (Lowercase(Attr) = 'str') or (Lowercase(Attr) = 'unicode') then
          begin
            Result.DataString := Node.Text;
          end;
        end;
      end;

    end;
  except
    Result := nil;
  end;
end;

procedure ReadOneNode(XMLNode : IXMLNode; Lst : TList<TbfaBaseObject>);
var
    Attr : OleVariant;
begin
  try
    Attr := XMLNode.Attributes['typ'];
    if not VarIsNULL(Attr) then
    begin
//      if (Lowercase(Attr) = 'bitfarmdocument') then
//      begin
//        Lst.Add(XMLToDocument(XMLNode));
//      end
//      else if (LowerCase(Attr) = 'bitfarmaddfield') then
//      begin
//        Lst.Add(XMLToAddField(XMLNode));
//      end
//      else if (LowerCase(Attr) = 'bitfarmstatefield') then
//      begin
//        Lst.Add(XMLToStsField(XMLNode));
//      end
//      else
      if (LowerCase(Attr) = 'bfareq') then
      begin
        Lst.Add(XMLToRequest(XMLNode, Lst));
      end
//      else if (LowerCase(Attr) = 'svn_history') then
//      begin
//        Lst.Add(XMLToSvnField(XMLNode));
//      end
//      else if (LowerCase(Attr) = 'workflows') then
//      begin
//        Lst.Add(XMLToWorkflow(XMLNode));
//      end
//      else if (LowerCase(Attr) = 'fav') then
//      begin
//        Lst.Add(XMLToSearchObj(XMLNode));
//      end
//      else if (LowerCase(Attr) = 'bitfarmdlm') then
//      begin
//        Lst.Add(XMLToDLM(XMLNode));
//      end;
    end
    else
    begin
      if (LowerCase(XMLNode.NodeName) = 'bitfarmdocument') then
      begin
//        Lst.Add(XMLToDocument(XMLNode));
      end
      else if (LowerCase(XMLNode.NodeName) = 'bitfarmaddfield') then
      begin
//        Lst.Add(XMLToAddField(XMLNode));
      end
      else if (LowerCase(XMLNode.NodeName) = 'bitfarmstatefield') then
      begin
//        Lst.Add(XMLToStsField(XMLNode));
      end
      else if (LowerCase(XMLNode.NodeName) = 'bfareq') then
      begin
        Lst.Add(XMLToRequest(XMLNode, Lst));
      end
      else if (LowerCase(XMLNode.NodeName) = 'workflows') then
      begin
//        Lst.Add(XMLToWorkflow(XMLNode));
      end
      else if (LowerCase(XMLNode.NodeName) = 'svn_fields') then
      begin
//        Lst.Add(XMLToSvnField(XMLNode));
      end
      else if (LowerCase(XMLNode.NodeName) = 'fav') then
      begin
//        Lst.Add(XMLToSearchObj(XMLNode));
      end
      else if (LowerCase(XMLNode.NodeName) = 'bitfarmdlm') then
      begin
//        Lst.Add(XMLToDLM(XMLNode));
      end;
    end;

  except

  end;
end;

function XMLStringToObject(xmlstr : string; FileName : string = '') : TList<TbfaBaseObject>;
var
  i : Integer;
  XMLDoc : IXMLDocument;
  RootNode, Node : IXMLNode;
  nodes : IXMLNodeList;
begin
  CoInitialize(nil);
  XMLDoc := TXMLDocument.Create(nil);
  try
    try
      XMLDoc.LoadFromXML(xmlstr);
      nodes := XMLDoc.ChildNodes;
      Result := XMLToObject(nodes[1], FileName);
    except
      Result := TList<TbfaBaseObject>.Create;
    end;
  finally
    XMLDoc := nil;
    nodes := nil;
    CoUninitialize;
  end;
end;

function XMLToObject(XMLNode : IXMLNode; FileName : string = '') : TList<TbfaBaseObject>;
var
  i : Integer;
  XMLDoc : IXMLDocument;
  RootNode, Node : IXMLNode;
begin
  if (XMLNode <> nil) and (FileName = '') then
  begin
    Result := TList<TbfaBaseObject>.Create;
    try
      if (Lowercase(XMLNode.NodeName) = 'objlist') or
         (Lowercase(XMLNode.NodeName) = 'bookmark') or
         (LowerCase(XMLNode.NodeName) = 'lesezeichen') // or
         //(Lowercase(XMLNode.NodeName) = 'bfareq')
      then
      begin
        for i := 0 to XMLNode.ChildNodes.Count - 1 do
          ReadOneNode(XMLNode.ChildNodes[i], Result);
      end
      else
        ReadOneNode(XMLNode, Result);
    except
      Result := nil;
    end;
  end
  else if (XMLNode = nil) and (FileName <> '') then
  begin
    if ((FileName = '') or not FileExists(FileName)) then
    begin
      Result := nil;
      Exit;
    end;

    Result := TList<TbfaBaseObject>.Create;

    CoInitialize(nil);
    try
      XMLDoc := TXMLDocument.Create(nil);
      try
        try
          XMLDoc.LoadFromFile(FileName);

          RootNode := XMLDoc.DocumentElement;

          if (LowerCase(RootNode.NodeName) = 'objlist') or
             (LowerCase(RootNode.NodeName) = 'bookmark') or
             (LowerCase(RootNode.NodeName) = 'lesezeichen')
          then
          begin
            for i := 0 to RootNode.ChildNodes.Count - 1 do
              ReadOneNode(RootNode.ChildNodes[i], Result);
          end
          else
            ReadOneNode(RootNode, Result);
        except
          Result := nil;
        end;
      finally
        XMLDoc := nil; //07.08.2017
      end;
    finally
      CoUninitialize;
    end;
  end
  else
    Result := nil;
end;

function ObjectToXML(ObjList : TList<TbfaBaseObject>; CreateList : Boolean = False;
  XMLEncoding : string = 'US-ASCII'; FileName : string = '';
  BookMarkName : string = ''; XML : IXMLDocument = nil; RootNode : IXMLNode = nil;
  WithAddfieldItems : Boolean = True) : WideString;
Var
  i : Integer;
  XMLString : WideString;
  XMLStream: TStringStream;
  CurNode  : IXMLNode;
  s : WideString;
  freeXMLObj : Boolean;
begin
  try
    if ObjList <> nil then
    begin
      if ObjList.Count > 0 then
      begin
        CoInitialize(nil);
        freeXMLObj := False;
        if XML = nil then
        begin
          XML := NewXMLDocument;
          XML.Encoding := XMLEncoding;
          XML.Options := [doNamespaceDecl];
          freeXMLObj := True;
        end;

        try
          DoObjectToXML(XML, RootNode, ObjList, CreateList, WithAddfieldItems);
          if FileName <> '' then
          begin
            if not DirectoryExists(ExtractFilePath(FileName)) then
              ForceDirectories(ExtractFilePath(FileName));

            XML.SaveToFile(FileName);
          end;

          XMLStream := TStringStream.Create;
          XML.SaveToStream(XMLStream);
          Result := XmlStream.DataString;
          XMLStream.Free;

          if freeXMLObj then
            XML := nil;  //07.08.2017

          Result := ReplaceStr(Result, #13#10, '');
        finally
          CoUnInitialize;
        end;
      end;
    end;
  except
    Result := '';
  end;
end;

//function AddTreeviewNode(Log : TbfaLog; TV : TJVTreeView;
//  RootNode : TTreeNode; Obj : TObject; FavType : Integer; // 3 - History, 1 - Lokale Lese, 2 - Globale Lese
//  First : Boolean = False; NName : string = ''; NodeType : Integer = 0) : TTreeNode;
//var
//  NodeName : String;
//begin
//  try
//    if RootNode <> nil then
//    begin
//      NodeName := NName;
//
//      if (Obj <> nil) and (Obj is TbfaSearch) then
//      begin
//        TbfaSearch(Obj).SearchType := FavType;
//        if FavType = 3 then
//          if VarIsNull(TbfaSearch(Obj).Date) then
//            NodeName := DateTimeToStr(Now())
//          else
//            NodeName := TbfaSearch(Obj).Date
//        else if FavType = 1 then
//          NodeName := TbfaSearch(Obj).Name
//        else if FavType = 2 then
//          NodeName := TbfaSearch(Obj).Name;
//      end else if NodeType = 0 then
//        Exit;
//
//      if First then
//        Result := TV.Items.AddChildObjectFirst(RootNode, NodeName, Obj)
//      else
//        Result := TV.Items.AddChildObject(RootNode, NodeName, Obj);
//
//      if NodeType = 0 then
//      begin
//        if FavType = 1 then
//        begin
//          if TbfaSearch(Obj).Verify then
//          begin
//            Result.ImageIndex := Integer(icoidx_bookmark_check);
//            Result.SelectedIndex := Integer(icoidx_bookmark_check_selected);
//          end else
//          begin
//            Result.ImageIndex := Integer(icoidx_bookmark);
//            Result.SelectedIndex := Integer(icoidx_bookmark_selected);
//          end;
//        end
//        else if FavType = 2 then
//        begin
//          if TbfaSearch(Obj).Verify then
//          begin
//            Result.ImageIndex := Integer(icoidx_bookmark_global_check);
//            Result.SelectedIndex := Integer(icoidx_bookmark_global_selected_check);
//          end else
//          begin
//            Result.ImageIndex := Integer(icoidx_bookmark_global);
//            Result.SelectedIndex := Integer(icoidx_bookmark_global_selected);
//          end;
//        end else // History
//        begin
//          Result.ImageIndex := Integer(icoidx_bookmark);
//          Result.SelectedIndex := Integer(icoidx_bookmark_selected);
//        end;
//      end else if NodeType = 1 then
//      begin
//        Result.ImageIndex := Integer(icoidx_bookmark_folder);
//        Result.SelectedIndex := Integer(icoidx_bookmark_folder);
//        Result.ExpandedImageIndex := Integer(icoidx_bookmark_folder_expanded);
//      end else if NodeType = 2 then  // Lesezeichen von Benutzer/Gruppe xy
//      begin
//        Result.ImageIndex := Integer(icoidx_bookmark_folder);
//        Result.SelectedIndex := Integer(icoidx_bookmark_folder);
//        Result.ExpandedImageIndex := Integer(icoidx_bookmark_folder_expanded);
//      end;
//    end;
//  except
//    Log.Write(llNormal, ltException, 'AddTreeviewNode', 'bfaParser');
//  end;
//end;
//
//procedure ReadOneBookmarkNode(RootNode : IXMLNode; SObj : TbfaSearch; Log : TbfaLog; TV : TJvTreeView;
//  TvRootNode : TTreeNode; FavType : Integer; User : TbfaUser);
//var
//  i : Integer;
//  Attr : OleVariant;
//  Node : TTreeNode;
//  NodeInfo : TbfaNodeInfo;
//  folder_guid : OleVariant;
//begin
//  try
//    for i := 0 to RootNode.ChildNodes.Count - 1 do
//    begin
//      if (Lowercase(RootNode.ChildNodes[i].NodeName) = 'fav') then
//      begin
//        SObj := XMLToSearchObj(RootNode.ChildNodes[i]);
//        if SObj.DontInheritate and (SObj.UserID <> User.ID) and not User.isAdmin then
//          Continue;
//        AddTreeviewNode(Log, TV, TvRootNode, SObj, FavType);//, True);
//      end
//      else if (Lowercase(RootNode.ChildNodes[i].NodeName) = 'folder') then
//      begin
//        Attr := RootNode.ChildNodes[i].Attributes['folder_name'];
//        folder_guid := RootNode.ChildNodes[i].Attributes['guid'];
//
//        NodeInfo := TbfaNodeInfo.Create;
//        NodeInfo.Typ := 1;
//
//        if (not VarIsNull(folder_guid))  then
//          NodeInfo.GUID := RootNode.ChildNodes[i].Attributes['guid'];
//
//        if (not VarIsNull(Attr)) and (not VarIsNull(folder_guid)) then
//          Node := AddTreeviewNode(Log, TV, TvRootNode, NodeInfo, FavType, (FavType = 3), Attr, 1)
////          Node := AddTreeviewNode(Log, TV, TvRootNode, TbfaString.Create(folder_guid), FavType, (FavType = 3), Attr, 1)
//        else if not VarIsNull(Attr) then
//          Node := AddTreeviewNode(Log, TV, TvRootNode, nil, FavType, (FavType = 3), Attr, 1);
//
//        ReadOneBookMarkNode(RootNode.ChildNodes[i], SObj, Log, TV, Node, FavType, User);
//      end else if (Lowercase(RootNode.ChildNodes[i].NodeName) = 'global_folder') then
//      begin
//        Attr := RootNode.ChildNodes[i].Attributes['folder_name'];
//        folder_guid := RootNode.ChildNodes[i].Attributes['guid'];
//        NodeInfo := TbfaNodeInfo.Create;
//        NodeInfo.Userid := StrToInt(RootNode.ChildNodes[i].Attributes['userid']);
//        NodeInfo.Groupid := StrToInt(RootNode.ChildNodes[i].Attributes['groupid']);
//        NodeInfo.Typ := -1;
//        if (not VarIsNull(folder_guid))  then
//          NodeInfo.GUID := RootNode.ChildNodes[i].Attributes['guid'];
//
//        if not VarIsNull(Attr) then
//          Node := AddTreeviewNode(Log, TV, TvRootNode, NodeInfo, FavType, (FavType = 3), Attr, 2);
//
//        ReadOneBookMarkNode(RootNode.ChildNodes[i], SObj, Log, TV, Node, FavType, User);
//      end;
//    end;
//  except
//
//  end;
//end;
//
//procedure LoadBookmarkList(Log : TbfaLog; TV : TJvTreeView;
//  TvRootNode : TTreeNode; FavType : Integer; User : TbfaUser  // 1 - Lokale Lese, 2 - Globale Lese, 3 - History, 4 - Lesen aus Datei
//  );
//var
//  XMLDoc, XMLTemp : IXMLDocument;
//  RootNode, TempNode, XMLNode, XMLRoot : IXMLNode;
//  i, j : Integer;
//  Node : TTreeNode;
//  SObj : TbfaSearch;
//  FName : string;
//  lmq : TUniQuery;
//  userid, groupid : Int64;
//  guid: OleVariant;
//begin
//  try
//    if FavType = 4 then
//      FName := BD.AppdataBitfarmPd + 'History';
//
//    CoInitialize(nil);
//    try
//      XMLDoc := TXMLDocument.Create(nil);
//      XMLTemp := TXMLDocument.Create(nil);
//      try
////          XMLDoc.LoadFromFile(FName + '.xml');
//        if FavType = 4 then
//        begin
//
//          if FileExists(Fname + '.v36') then
//          begin
//            if TvRootNode.HasChildren then
//              TvRootNode.DeleteChildren;
//
//            XMLDoc.LoadFromFile(FName + '.v36')
//          end
//        end
//        else begin
//          lmq := DbCreateQuery;
//          if FavType = 3 then
//            lmq.SQL.Text := 'select bookmark from sys_bookmarks where type = 2 and userid = ' + IntToStr(User.ID)
//          else if FavType = 1 then
//            lmq.SQL.Text := 'select bookmark from sys_bookmarks where type = 1 and userid = ' + IntToStr(User.ID)
//          else if FavType = 2 then
//          begin
//            if User.isAdmin then
//              lmq.SQL.Text := 'select userid, groupid, bookmark from sys_bookmarks where type = 0'
//            else
//              lmq.SQL.Text := Format('select userid, groupid, bookmark from sys_bookmarks where type = 0 and ' +
//                '((userid in(%s)) or (userid = 0 and groupid in(%s)))', [User.HolidayList.CommaText, User.GroupList.CommaText]);
//
//            XMLTemp := NewXMLDocument;
//            XMLTemp.Encoding := 'utf-8';
//            XMLTemp.Options := [doNodeAutoIndent];
//            RootNode := XMLTemp.AddChild('bookmark');
//            XMLDoc.Active := True;
//
//            XMLRoot := XMLDoc.AddChild('bookmark');
//          end;
//
//          i := 0;
//          lmq.Execute;
//          if lmq.RecordCount > 0 then
//          begin
//            while not lmq.Eof do
//            begin
//              if (FavType <> 2) then
//                XMLDoc.LoadFromXML(lmq.FieldByName('bookmark').AsString)
//              else begin
//                if User.isAdmin then
//                begin
//                  userid := lmq.FieldByName('userid').AsInteger;
//                  groupid := lmq.FieldByName('groupid').AsInteger;
//
//                  if (userid = 0) and (groupid = 0) then
//                  begin
//                    XMLNode := XMLRoot.AddChild('global_folder');
//                    XMLNode.Attributes['folder_name'] := _('Lesezeichen fr alle Benutzer');
//                  end else if userid <> 0 then
//                  begin
//                     XMLNode := XMLRoot.AddChild('global_folder');
//                     XMLNode.Attributes['folder_name'] := _('Lesezeichen fr Benutzer ') + DBGetUserName(userid);
//                  end else if groupid <> 0 then
//                  begin
//                      XMLNode := XMLRoot.AddChild('global_folder');
//                      XMLNode.Attributes['folder_name'] := _('Lesezeichen fr Gruppe ') + DBGetGroupName(groupid)
//                  end;
//                  XMLNode.Attributes['userid'] := IntToStr(userid);
//                  XMLNode.Attributes['groupid'] := IntToStr(groupid);
//                end else
//                  XMLNode := XMLRoot;
//
//                XMLTemp.LoadFromXML(lmq.FieldByName('bookmark').AsString);
//                TempNode := XMLTemp.DocumentElement;
//                guid := TempNode.Attributes['guid'];
//                if not VarIsNull(guid) then
//                  XMLNode.Attributes['guid'] := guid;
//                for j  := 0 to TempNode.ChildNodes.Count -1 do
//                  XMLNode.ChildNodes.Add(TempNode.ChildNodes[j]);
//                inc(i);
//              end;
//
//              lmq.Next;
//            end;
//          end;
//
//          lmq.Free;
//        end;
//
//        if not XMLDoc.Active then
//          Exit;
//
//        RootNode := XMLDoc.DocumentElement;
//
//        try
//          if (LowerCase(RootNode.NodeName) = 'bookmark')
//              or (LowerCase(RootNode.NodeName) = 'lesezeichen') then
//          begin
//              ReadOneBookMarkNode(RootNode, SObj, Log, TV, TvRootNode, FavType, User);
//          end else
//          begin
//            SObj := XMLToSearchObj(RootNode);
//            AddTreeviewNode(Log, TV, TvRootNode, SObj, FavType, (FavType = 3));
//          end;
//        except
//          on e:exception do
//            Log.Write(llNormal, ltException, Format('Es hat einen Fehler beim Laden der %s Lesezeichen gegeben: %s',[TvRootNode.Text, e.Message]) );
//        end;
//      except
//        on e:exception do
//          Log.Write(llNormal, ltException, 'Es hat einen allgemeinen Fehler beim Laden der Lesezeichen gegeben: ' + e.Message);
//      end;
//    finally
//      XMLDoc := nil; //07.08.2017
//      XMLTemp := nil; //07.08.2017
//      CoUninitialize;
//    end;
//  except
//  end;
//end;
//
//
//procedure AddOneNode(TNode : TTreeNode; XML : IXMLDocument; RootNode : IXMLNode);
//var
//  i : Integer;
//  CurNode : IXMLNode;
//begin
//  if Assigned(TNode) then
//  begin
//    try
//      for i := 0 to TNode.Count - 1 do
//      begin
//        if (TNode[i].Data <> nil) and (TObject(TNode[i].Data) is TbfaSearch) then
//        begin
//          SearchObjToXML(XML, RootNode, TbfaSearch(TNode[i].Data), i);
//        end
//        else if (TNode[i].Data <> nil) and (TObject(TNode[i].Data) is TbfaNodeInfo) then
//        begin
//          CurNode := RootNode.AddChild('folder');
//          CurNode.Attributes['folder_name'] := TNode[i].Text;
//          CurNode.Attributes['guid'] := TbfaNodeInfo(TNode[i].Data).GUID;
//          AddOneNode(TNode[i], XML, CurNode);
//        end
//        else
//        begin
//          CurNode := RootNode.AddChild('folder');
//          CurNode.Attributes['folder_name'] := TNode[i].Text;
//          AddOneNode(TNode[i], XML, CurNode);
//        end;
//      end;
//    except
//    end;
//  end;
//end;
//
//procedure SaveBookmarkList((*AThread : TThread; *)Log : TbfaLog; TNode : TTreeNode;
//  FileName : string = ''; BookMarkName : string = '');
//Var
//  XML : IXMLDocument;
//  RootNode,
//  CurNode : IXMLNode;
//  i : Integer;
//begin
//  try
//    CoInitialize(nil);
//    XML := NewXMLDocument;
//    try
//      XML.Encoding := 'utf-8';
//      XML.Options := [doNodeAutoIndent];
//      RootNode := XML.AddChild('bookmark');
//      if BookMarkName <> '' then
//        RootNode.Attributes['name'] := BookMarkName
//      else
//        RootNode.Attributes['name'] := 'Verlaufs-Lesezeichen';
//
//      AddOneNode(TNode, XML, RootNode);
//
//(*            CurNode := RootNode.AddChild('BitfarmStatefield');
//    //    CurNode := CurNode.AddChild('_encoding');
//    //    CurNode.Text := XML.Encoding;
//    //    CurNode.Attributes['typ'] := 'str';
//        CurNode2 := CurNode.AddChild('__value');
//        CurNode2.Text := FStsFields[i].Value;
//        CurNode2 := CurNode.AddChild('name');
//        CurNode2.Text := FStsFields[i].Name;
//        CurNode2 := CurNode.AddChild('id');
//        CurNode2.Text := IntToStr(FStsFields[i].ID);
//        CurNode2 := CurNode.AddChild('indexcolumnid');
//        CurNode2.Text := IntToStr(FStsFields[i].IndexColumnID);
//        CurNode2 := CurNode.AddChild('__bitmask');
//        CurNode2.Text := IntToStr(FStsFields[i].Bitmask);
//        CurNode2 := CurNode.AddChild('modified_search');
//        CurNode2.Text := 'True';
//
//      end;   *)
//
//      if (FileName <> '') then
//      begin
//        if not DirectoryExists(ExtractFilePath(FileName)) then
//          ForceDirectories(ExtractFilePath(FileName));
//
//        XML.SaveToFile(FileName);
//      end;
//    finally
//      CoUnInitialize;
//    end;
//  except
//
//  end;
//end;

end.

initialization
CoInitialize(nil);

finalization
CoUnInitialize;



