unit bfaBasePreview;

interface

uses
  GnuGetText, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Registry, ExtCtrls, Buttons, ComCtrls, bfaBaseObjects,
  Generics.Collections, bfaObjects36, TB2Dock, System.Generics.Defaults,
  bfaCommonDB, bfaCommonUtils,
  {$IFDEF IMAGEEN1140}
  hyiedefs, hyieutils, iexBitmaps, iesettings,
  iexLayers, iexRulers, iexToolbars, iexUserInteractions, iexProcEffects,
  {$ELSE}
  hyiedefs, hyieutils,
  {$ENDIF}
  bfaImageEnVect, imageenio, imageenproc, ieview,
  imageenview, ievect, ietextc;

type
  TbfaIETextControl = class(TIETextControl)
  // wir leiten die ab, damit wir Zugriff auf protected erhalten
  end;

  Tfrm_Voransicht = class (TFrame)
    img_DocView: TbfaImageEnVect;
    Label1: TLabel;

    procedure img_DocViewDblClick(Sender: TObject);
    procedure img_DocViewMouseWheel(Sender: TObject; Shift: TShiftState;
       WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure img_DocViewImageChange(Sender: TObject);
    procedure img_DocViewViewChange(Sender: TObject; Change: Integer);
    procedure img_DocViewMouseDown(Sender: TObject; Button: TMouseButton;
       Shift: TShiftState; X, Y: Integer);
    procedure img_DocViewMouseUp(Sender: TObject; Button: TMouseButton;
       Shift: TShiftState; X, Y: Integer);
    procedure img_DocViewNewObject(Sender: TObject; hobj: Integer);
    procedure img_DocViewObjectOver(Sender: TObject; hobj: Integer);
    procedure img_DocViewDeactivateTextEdit(Sender: TObject);
    procedure img_DocViewActivateTextEdit(Sender: TObject);
    procedure img_DocViewMouseLeave(Sender: TObject);
    procedure img_DocViewMouseEnter(Sender: TObject);
    procedure img_DocViewObjectMoveResize(Sender: TObject; hobj,
       Grip: Integer; var OffsetX, OffsetY: Integer);
    procedure img_DocViewKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    function GetLongestLine(fstl: TStrings): string;
    procedure textanObjektpassen(fstl: TStrings; idx: Integer = -1);
    procedure ObjektAnTextAnpassen(hobj: Integer; Force: Boolean = False);
	  procedure ClearHistory;
    procedure img_DocViewUserSelectObject(Sender: TObject; hobj: Integer);
    procedure img_DocViewUserDeselectObject(Sender: TObject; hobj: Integer);
    procedure img_DocViewSelectObject(Sender: TObject);
    procedure img_DocViewTextKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

  private
    { Private-Deklarationen }
    fsaveenabled, fObjectMoved, fobjdel: Boolean;
    fobjposition, fobjdimension: array of TPoint;
    fStartPos: TPoint;
    fObjWidth, fObjHeight, FStampWidth, FStampHeight: Integer;
    FRemovedObjects: TStringList;

    function GetPage(FtxPos : TList<TbfaFtxPos>; ActPage, NewPage: Integer;
        Next: Boolean): Boolean;

  public
    { Public-Deklarationen }
    fnt: TFont;
    fAnnoType: Byte;
    fParentHandle: THandle;
    fLastControl: TWinControl;
    fObjVersion, fPrivAnnoID: Integer;
    fphistorymessage, fOldtext, StampPlugin: string;
    fHistoryDeleted, fHistoryNew, fNoteVTX, fNoteSLW: TStringList;
    fSaveBtN, fPubAnnoBTN, fPrivAnnoBTN, fCbx_Zoom, fCbx_MainFormZoom: TObject;
    gbAnnoNotSaved, gbAnnoNotAccessible, fRefreshInOtherPrevs, fTextAnnoCreated,
    bGDelObj, fdoubleklicked, fzooming, fsavingobjs, fAutozoom, fAnnosRotated,
    fNewTextObject, fChangeZoomtextNotView, fEndPolylineOnMouseUp, fbmouseinim,
    fNoteslwrecord, fNotevtxrecord, GraphicClipboardStamp: Boolean;
    {$IFDEF ENTERPRISE}
    VirtualPluginMenuItem: TPluginObj;
    {$ENDIF}

    fOnObjectOver: procedure(annodata: PAnnoData) of object;
    fOnDblClick: procedure of object;
    fOnMouseLeave: procedure of object;
    fAfterSaveObjects: procedure of object;
    fOnNewObject: procedure of object;
    fOnObjectMoveResize: procedure of object;
    fOnMouseUpSelection: procedure of object;
    fOnAnnoConflict: procedure of object;
    OnPluginExecuteOnStamp: procedure(PreviewObj: TObject; AnnoData: PAnnoData) of object;

    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    procedure updateobjects;
    procedure createannodata(fidx: Integer);
//      procedure saveannodata(fidx: Integer);
    function ReadObjVals(ObjType, Idx: Integer): Boolean;
    function CheckObjVals: Boolean;
    function LoadStamp(StampKey: string): Boolean;
    procedure AnnoDelete(Sender: TObject; Doc: TbfaDocument = nil; SelectNext: Boolean = True);
//16.09.2024    function ObjKindToStr(hobj: Integer; ): string;
    function ObjKindToStr(hobj: Integer; translate: boolean = true): string;
    procedure RotateImage(degree: Integer);
    procedure SelectNextAnno;
    procedure SelectNextFtxSearchPos;
    procedure SelectPreviousFtxSearchPos;
    procedure SelectPrevAnno;
    procedure EditSelectedAnno;
    procedure EscOnTextEdit;
    procedure ZoomIn;
    procedure ZoomOut;
    procedure ScrollLeft;
    procedure ScrollRight;
    procedure ScrollUp;
    procedure ScrollDown;
    function CheckAnnoRights: Boolean;
    procedure saveannostream(preproc: Boolean = True; Doc: TbfaDocument = nil); overload;
    procedure saveannostream(Doc: TbfaDocument); overload;
    procedure SetObjectPosition;
   end;

  // Record used in SelectNextAnno + SelectPrevAnno
  THobj = record
    ind: Integer;
    top: Integer;
    left: Integer;
  end;

function ObjTypeToStr (ObjType: Integer): string;


implementation

uses
  StrUtils, uni, SpTBXItem, SpTBXEditors, bfaLog, bfaApplication, bfaPreview36, MainDataModule,
  SpTBXDkPanels, MainForm, bfaCommonImageEN, bfaCommonMethods, bfaCommonDialogs,
  Vectors, ClipBrd, collision, u_bfaAddfield, {07.11.2022 ImageEn1140 hyiedefs, }RegularExpressions;

{$R *.dfm}

var
   md_mouseX1, md_mouseY1: Integer;

function ObjTypeToStr(ObjType: Integer): string;
begin
  case ObjType of
     0: Result := 'Line';
     1: Result := 'Box';
     2: Result := 'Ellipse';
     3: Result := 'Arc';
     4: Result := 'Bitmap';
     5: Result := 'Text';
     6: Result := 'Ruler';
     7: Result := 'Polyline';
     8: Result := 'Angle';
     9: Result := 'Note';
    10: Result := 'LineLabel';
    11: Result := 'HiLite';
    12: Result := 'Poligon';
    13: Result := 'FreeHand';
    14: Result := 'Arrow';
    15: Result := 'Text';
    16: Result := 'Freihand';
    17: Result := 'Freihand1';
    18: Result := 'Freihand2';
    19: Result := 'Freihand3';
    20: Result := 'Freihand4';
    21: Result := 'Text1';
    22: Result := 'Text2';
    23: Result := 'Text3';
    24: Result := 'Text4';
    25: Result := 'Note1';
    26: Result := 'Note2';
    27: Result := 'Note3';
    28: Result := 'Note4';
    29: Result := 'HiLite1';
    30: Result := 'HiLite2';
    31: Result := 'HiLite3';
    32: Result := 'HiLite4';
    33: Result := 'Buchungsstempel';
  end;
end;

//16.09.2024function Tfrm_Voransicht.ObjKindToStr(hobj: Integer): string;
function Tfrm_Voransicht.ObjKindToStr(hobj: Integer; translate: boolean = true): string;
begin
//   if fphistorymessage <> '' then
//   begin
//      Result := fphistorymessage;
//   	Exit;
//   end;

   case img_DocView.ObjKind[hobj] of
      iekBOX:
      begin
        if translate then
          Result := _('Box')
        else
          Result := 'Box';
      end;

      iekLINE:
      begin
        if translate then
          Result := _('Pfeil')
        else
          Result := 'Pfeil';
      end;

      iekPOLYLINE:
      begin
        if translate then
          Result := _('Linie')
        else
          Result := 'Linie';
      end;

      iekELLIPSE:
      begin
        if translate then
          Result := _('Ellipse')
        else
          Result := 'Ellipse';
      end;

      iekARC, iekANGLE:
      begin
        if translate then
          Result := _('Winkel')
        else
          Result := 'Winkel';
      end;

      iekRULER:
      begin
        if translate then
          Result := _('Lineal')
        else
          Result := 'Lineal';
      end;
      iekBITMAP:
      begin
        if translate then
          Result := _('Bild')
        else
          Result := 'Bild';
      end;
      iekTEXT:
      begin
        if translate then
          Result := _('Text')
        else
          Result := 'Text';
      end;
      iekMEMO:
      begin
        if translate then
          Result := _('Text')
        else
          Result := 'Text';
      end;
      iekLINELABEL:
      begin
        if translate then
          Result := _('Label')
        else
          Result := 'Label';
      end;
   end;

end;

constructor Tfrm_Voransicht.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  fHistoryDeleted := TStringList.Create();
  fHistoryNew := TStringList.Create();
  fNoteVTX := TStringList.Create();
  fNoteSLW := TStringList.Create();

  fRefreshInOtherPrevs := False;
  fSaveBtN := nil;
  fPubAnnoBTN := nil;
  fPrivAnnoBTN := nil;
  fCbx_Zoom := nil;
  fCbx_MainFormZoom := nil;
  fLastControl := nil;
  fOnObjectOver := nil;
  img_DocView.MouseInteract := [miScroll];
  FRemovedObjects := TStringList.Create;
  img_DocView.BitmapResampleFilter := rfFastLinear; //06.10.2021

  FStampWidth := -1;
  FStampHeight := -1;
  fnt := TFont.Create;
  fObjVersion := -1;
  bGDelObj := False;   // Ticket 15654 (Nebeneffekt Uninitialisierte Variable)
  {$IFDEF ENTERPRISE}
  VirtualPluginMenuItem := nil;
  {$ENDIF}
  GraphicClipboardStamp := False;
end;

destructor Tfrm_Voransicht.Destroy;
begin
  try
    FreeAndNil(fHistoryDeleted);
    FreeAndNil(fHistoryNew);
    FreeAndNil(fNoteVTX);
    FreeAndNil(fNoteSLW);
    FreeAndNil(FRemovedObjects);
    inherited Destroy;
  except

  end;
end;

function Tfrm_Voransicht.ReadObjVals(ObjType, Idx: integer): boolean;
var
  reg: TRegistry;
  fsTmp: TFontStyles;
  {$IFDEF IMAGEEN1140}
  shTmp: TIEVArrowShape;
  {$ELSE}
  shTmp: TIEShape;
  {$ENDIF}
  bsTmp: TBrushStyle;
  lpTmp: TIELabelPos;
  psTmp: TPenStyle;
  rtTmp: TIEVRulerType;
  ruTmp: TIEUnits;
  osTmp: TIEVStyle;
  taTmp: TIEAlignment;
  sRegKeyName: string;
  CharInfo: TIEMemoEditCharInfo;
  {$IFDEF AFONT}
  AFont: TFont;
  {$ENDIF}
begin
  Result := True;
  CheckObjVals;
  fObjVersion := -1;
  reg := TRegistry.Create;

  sRegKeyName := ObjTypeToStr(ObjType);
  {$IFDEF AFONT}
  AFont := TFont.Create;
  {$ENDIF}

  try
    try
      with reg do
      begin
        RootKey := HKEY_CURRENT_USER;
        OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\' + sRegKeyName, True);
        with img_DocView do
        begin
          // ObjTransparency[idx]:=120; // Transparenz setzen
          if ValueExists('ObjArcEndingAngle') then
            ObjArcEndingAngle[idx] := ReadFloat('ObjArcEndingAngle')
          else
            ObjArcEndingAngle[idx] := 90;

          if ValueExists('ObjArcStartingAngle') then
            ObjArcStartingAngle[idx] := ReadFloat('ObjArcStartingAngle')
          else
            ObjArcStartingAngle[idx] := 0;

          if ValueExists('ObjBeginShape') then
            ReadBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp))
          else
            shTmp := iesNONE;
          ObjBeginShape[Idx] := shTmp;

          if ValueExists('ObjBitmapBorder') then
            ObjBitmapBorder[idx] := ReadBool('ObjBitmapBorder')
          else
            ObjBitmapBorder[idx] := False;

          if ValueExists('ObjBoxHighLight') then
            ObjBoxHighLight[idx] := ReadBool('ObjBoxHighLight')
          else
            ObjBoxHighLight[idx] := False;

          if ValueExists('ObjBrushColor') then
            ObjBrushColor[idx] := ReadInteger('ObjBrushColor')
          else
            ObjBrushColor[idx] := gclYellow;

          if ValueExists('ObjBrushStyle') then
            ReadBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp))
          else
          begin
            if (ObjType > 15) and (ObjType < 21) then
              bsTmp := bsClear
            else
              bsTmp := bsSolid;
          end;

          ObjBrushStyle[idx] := bsTmp;
          if ValueExists('ObjEndShape') then
            ReadBinaryData('ObjEndShape', shTmp, SizeOf(shTmp))
          else
            shTmp := iesNONE;
          ObjEndShape[Idx] := shTmp;

          {$IFDEF AFONT}
          if ValueExists('ObjFontAngle') then
            AFont.Orientation := Round(ReadFloat('ObjFontAngle'))
          else
            AFont.Orientation := 0;

          if ValueExists('ObjFontHeight') then
            AFont.Size := ReadInteger('ObjFontHeight')
          else
            AFont.Size := 72;

          if ValueExists('ObjFontName') then
            AFont.Name := ReadString('ObjFontName')
          else
            AFont.Name := 'Arial';

          if ValueExists('ObjFontStyles') then
            ReadBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp))
          else
            fsTmp := [];
          AFont.Style := fsTmp;
          {$ELSE}
          if ValueExists('ObjFontAngle') then
            ObjFontAngle[idx] := ReadFloat('ObjFontAngle')
          else
            ObjFontAngle[idx] := 0;

          if ValueExists('ObjFontHeight') then
            ObjFontHeight[idx] := ReadInteger('ObjFontHeight')
          else
            ObjFontHeight[idx] := 72;

          if img_DocView.DpiX < 300 then //17.03.2011 b.takacs 3.5.0.167
            if ObjFontHeight[idx] = 72 then
              ObjFontHeight[idx]:= round((img_DocView.DpiX*72)/300);

          if ValueExists('ObjFontName') then
            ObjFontName[idx] := ReadString('ObjFontName')
          else
            ObjFontName[idx] := 'Arial';

          if ValueExists('ObjFontStyles') then
            ReadBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp))
          else
            fsTmp := [];
          ObjFontStyles[idx] := fsTmp;
          {$ENDIF}

          ObjFontLocked[idx] := False;

          if ValueExists('ObjLabelBrushColor') then
            ObjLabelBrushColor[idx] := ReadInteger('ObjLabelBrushColor')
          else
            ObjLabelBrushColor[idx] := gclGreen; //15.04.2021 clGreen;

          if ValueExists('ObjLabelBrushStyle') then
            ReadBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp))
          else
            bsTmp := bsSolid;
          ObjLabelBrushStyle[idx] := bsTmp;

          if ValueExists('ObjMemoCharsBrushStyle') then
            ReadBinaryData('ObjMemoCharsBrushStyle', bsTmp, SizeOf(bsTmp))
          else
            bsTmp := bsClear;
          ObjMemoCharsBrushStyle[idx] := bsTmp;

          if ValueExists('ObjLabelPosition') then
            ReadBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp))
          else
            lpTmp := ielBegin;
          ObjLabelPosition[idx] := lpTmp;

          if ValueExists('ObjMemoBorderColor') then
            ObjMemoBorderColor[idx] := ReadInteger('ObjMemoBorderColor')
          else
            ObjMemoBorderColor[idx] := clBlack;

          if ValueExists('ObjMemoBorderStyle') then
            ReadBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp))
          else
            psTmp := psSolid;
          ObjMemoBorderStyle[idx] := psTmp;

          if ValueExists('ObjMemoFixedHeight') then
            ObjMemoFixedHeight[idx] := ReadInteger('ObjMemoFixedHeight')
          else
            ObjMemoFixedHeight[idx] := 0;

          if ValueExists('ObjMemoLineSpace') then
            ObjMemoLineSpace[idx] := ReadInteger('ObjMemoLineSpace')
          else
            ObjMemoLineSpace[idx] := 0;

          try
            if ValueExists('ObjName') then
              ObjName[idx] := ReadString('ObjName')
            else
              ObjName[idx] := _('Neues Objekt')+' '+ IntToStr(idx);
          except
            //14.06.2018 Wegen Crashlog eingebaut
          end;

          if ValueExists('ObjPenColor') then
            ObjPenColor[idx] := ReadInteger('ObjPenColor')
          else
            ObjPenColor[idx] := clBlack;

          if ValueExists('ObjAutoSize') then
            ObjTextAutoSize[idx] := ReadBool('ObjAutoSize'); // SJ 05.09.2023

          if ValueExists('ObjPenStyle') then
            ReadBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp))
          else
            psTmp := psSolid;
          ObjPenStyle[idx] := psTmp;

          if ValueExists('ObjPenWidth') then
            ObjPenWidth[idx] := ReadInteger('ObjPenWidth')
          else
            ObjPenWidth[idx] := 1;

          // MaxValue, weil MouseMove sonst sehr unpeformant wird (FindNearObj)
          if ObjPenWidth[idx] > 200 then
            ObjPenWidth[idx] := 200
          else if ObjPenWidth[idx] < 1 then
            ObjPenWidth[idx] := 1;

          if ValueExists('ObjPolylineClosed') then
            ObjPolylineClosed[idx] := ReadBool('ObjPolylineClosed')
          else
            ObjPolylineClosed[idx] := False;

          if ValueExists('ObjRulerType') then
            ReadBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp))
          else
            rtTmp := iertRULER;
          ObjRulerType[idx] := rtTmp;

          if ValueExists('ObjRulerUnit') then
            ReadBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp))
          else
            ruTmp := ieuPIXELS;
          ObjRulerUnit[idx] := ruTmp;

          if ValueExists('ObjShapeHeight') then
            ObjShapeHeight[idx] := ReadInteger('ObjShapeHeight')
          else
            ObjShapeHeight[idx] := 0;

          if ValueExists('ObjShapeWidth') then
            ObjShapeWidth[idx] := ReadInteger('ObjShapeWidth')
          else
            ObjShapeWidth[idx] := 0;

          if ValueExists('ObjStyle') then
            ReadBinaryData('ObjStyle', osTmp, SizeOf(osTmp))
          else
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
           // SJ 05.07.2021 - Auswhlbar und Sichtbar entfernt - jetzt immer wahr
          if not (ievsSelectable in osTmp) then
            osTmp := osTmp + [ievsSelectable];
          if not (ievsVisible in osTmp) then
            osTmp := osTmp + [ievsVisible];
          ObjStyle[idx] := osTmp;

          if ValueExists('ObjTextAlign') then
            ReadBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp))
          else
            taTmp := iejLeft;
          ObjTextAlign[idx] := taTmp;

          case ObjType of
            15, 16, 22, 23, 24, 5, 9, 10, 11, 20:
              ObjTextAutoSize[idx] := True;  // jetzt immer an, das automatische Anpassen der text und memo annos
          end;

          if ValueExists('ObjTextCurveCharRot') then
            ObjTextCurveCharRot[idx] := ReadFloat('ObjTextCurveCharRot')
          else
            ObjTextCurveCharRot[idx] := 0;

          if ValueExists('ObjText') then
            ObjText[idx] := StringReplace(ReadString('ObjText'), '\n\r', sLineBreak, [rfReplaceAll])
          else
            ObjText[idx] := '';

          if ValueExists('ObjTransparency') then
            ObjTransparency[idx] := ReadInteger('ObjTransparency')
          else
            ObjTransparency[idx] := 255;

          if ValueExists('Objwidth') then
            ObjWidth[idx] := ReadInteger('Objwidth');

          if ValueExists('objheight') then
            ObjHeight[idx] := ReadInteger('objheight');

          if ObjName[idx] = _('Neue Notiz')+' ' then
            ObjName[idx] := '';

          if Pos(WideString(_('Neuer Text')), WideString(ObjName[idx])) > 0 then
            ObjName[idx] := '';

          //01.06.2017 Ticket 10703 -->
          // ab Version 36 die Schriftgren werden richtig angepasst,
          // aber das kann bei vorher (V35) erstellten Stempel falsch dargestellt werden
          // (beim TextObjekten ist es nicht schlimm, weil die keine feste gre haben
          // und werden immer angepasst),
          // deswegen wird hier Version abgefragt, das gilt erst ab Version 3.6.0.945

          fObjVersion := 36; // SJ 28.07.2023 - Stempel laufen ber LoadStamps. Deswegen kann hier immer 36 gesetzt werden

          {$IFDEF AFONT}
          if not bitfarmApp.ViewerOptions.GeneralOptions.SetAnnoDPI then
          begin
            AFont.Color := img_DocView.ObjPenColor[idx];
            SetObjFont(Idx, AFont);
          end else if bitfarmApp.ViewerOptions.GeneralOptions.SetAnnoDPI then //25.10.2017 bei Kunden muss wie vorher in 3.5 war!!!
          begin
            fnt.Color := img_DocView.ObjPenColor[idx];

            if (AFont <> nil) and (AFont.Name <> '') then
              fnt.Name := AFont.Name
            else
              fnt.Name := img_DocView.ObjFontName[idx];

            if (AFont <> nil) and (AFont.Size > 0) then
              fnt.Size := AFont.Size
            else
              fnt.Size := img_DocView.ObjFontHeight[idx];

//            fnt.Height := img_DocView.ObjFontHeight[idx];
            if (AFont <> nil) then
              fnt.Style := AFont.Style;

            SetObjFont(Idx, fnt);
            //01.06.2017 Ticket 10703 <--
          end;
          {$ELSE}
          if bitfarmApp.ViewerOptions.GeneralOptions.SetAnnoDPI then //25.10.2017 bei Kunden muss wie vorher in 3.5 war!!!
          begin
            //01.06.2017 Ticket 10703 -->
            // ab Version 36 die Schriftgren werden richtig angepasst,
            // aber das kann bei vorher (V35) erstellten Stempel falsch dargestellt werden
            // (beim TextObjekten ist es nicht schlimm, weil die keine feste gre haben
            // und werden immer angepasst),
            // deswegen wird hier Version abgefragt, das gilt erst ab Version 3.6.0.945
            fnt.Color := img_DocView.ObjPenColor[idx];
            fnt.Name := img_DocView.ObjFontName[idx];
            fnt.Size := img_DocView.ObjFontHeight[idx];

            SetObjFont(Idx, fnt);
//01.06.2017 Ticket 10703 <--
          end;
          {$ENDIF}
        end;
        CloseKey;
      end;
    except
      on e: Exception do
      begin
        BfShowMessage(_('Fehler bei Laden aus der Registrierung: ') + e.Message);
        Result := False;
      end;
    end;
  finally
    if Assigned(reg) then
      FreeAndNil(reg);
  end;
end;

function Tfrm_Voransicht.CheckObjVals: boolean;
var
  reg: TRegistry;
  fsTmp: TFontStyles;
  {$IFDEF IMAGEEN1140}
  shTmp: TIEVArrowShape;
  {$ELSE}
  shTmp: TIEShape;
  {$ENDIF}
  bsTmp: TBrushStyle;
  lpTmp: TIELabelPos;
   //    ssTmp: TIEVSoftShadow;
  psTmp: TPenStyle;
  rtTmp: TIEVRulerType;
  ruTmp: TIEUnits;
  osTmp: TIEVStyle;
  taTmp: TIEAlignment;
  licounter: integer;
  lszus: string;
begin
   Result := True;
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            // Linie definieren
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsClear;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Line', True);
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', _('Neue Linie'));
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', gclBlue); //15.04.2021 clBlue);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 2);
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 0);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 0);
            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            CloseKey;
            // Box definieren
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsClear;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Box', True);
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjBoxHighLight') then
               WriteBool('ObjBoxHighLight', False);
            if not ValueExists('ObjBrushColor') then
               WriteInteger('ObjBrushColor', clWhite);
            if not ValueExists('ObjBrushStyle') then
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', _('Neues Rechteck'));
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', clBlack);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 2);
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 0);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 0);
            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            CloseKey;
            // HiLite definieren
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsClear;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            for licounter := 0 to 4 do
            begin
               if licounter = 0 then
               begin
                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\HiLite', True);
               end
               else
               begin
                  lszus := inttostr(licounter);
                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\HiLite' + lszus, True);
               end;
               case licounter of
                  0:
                  begin
                     if not ValueExists('ObjBrushColor') then
                        WriteInteger('ObjBrushColor', gclYellow);
                  end;
                  1:
                  begin
                     if not ValueExists('ObjBrushColor') then
                        WriteInteger('ObjBrushColor', gclLime); //15.04.2021 cllime);
                  end;
                  2:
                  begin
                     if not ValueExists('ObjBrushColor') then
                        WriteInteger('ObjBrushColor', gclRed); //15.04.2021 clred);
                  end;
                  3:
                  begin
                     if not ValueExists('ObjBrushColor') then
                        WriteInteger('ObjBrushColor', gclBlue); //15.04.2021 );
                  end;
                  4:
                  begin
                     if not ValueExists('ObjBrushColor') then
                        WriteInteger('ObjBrushColor', cColorOrange); //15.04.2021 $000080FF);
                  end;
               end;
               if not ValueExists('ObjBeginShape') then
                  WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
               if not ValueExists('ObjEndShape') then
                  WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
               if not ValueExists('ObjBoxHighLight') then
                  WriteBool('ObjBoxHighLight', True);
               if not ValueExists('ObjBrushColor') then
                  WriteInteger('ObjBrushColor', gclYellow);
               if not ValueExists('ObjBrushStyle') then
                  WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
               if not ValueExists('ObjName') then
                  WriteString('ObjName', _('Neues Rechteck'));
               if not ValueExists('ObjPenColor') then
                  WriteInteger('ObjPenColor', gclYellow);
               if not ValueExists('ObjPenStyle') then
                  WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
               if not ValueExists('ObjPenWidth') then
                  WriteInteger('ObjPenWidth', 2);
               if not ValueExists('ObjShapeHeight') then
                  WriteInteger('ObjShapeHeight', 0);
               if not ValueExists('ObjShapeWidth') then
                  WriteInteger('ObjShapeWidth', 0);
               //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
               if not ValueExists('ObjStyle') then
                  WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
               if not ValueExists('ObjTransparency') then
                  WriteInteger('ObjTransparency', 255);
               if not ValueExists('Objwidth') then
                  WriteInteger('Objwidth', 400);
               if not ValueExists('objheight') then
                  WriteInteger('objheight', 400);
               CloseKey;
            end;
            // Elipse definieren
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsClear;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Ellipse', True);
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjBoxHighLight') then
               WriteBool('ObjBoxHighLight', False);
            if not ValueExists('ObjBrushColor') then
               WriteInteger('ObjBrushColor', clWhite);
            if not ValueExists('ObjBrushStyle') then
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', _('Neue Ellipse'));
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', gclGreen); //15.04.2021 clGreen);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 2);
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 0);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 0);
            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            CloseKey;
            // Winkel definieren
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsClear;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Arc', True);
            if not ValueExists('ObjArcEndingAngle') then
               WriteFloat('ObjArcEndingAngle', 90);
            if not ValueExists('ObjArcStartingAngle') then
               WriteFloat('ObjArcStartingAngle', 90);
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjBrushColor') then
               WriteInteger('ObjBrushColor', clWhite);
            if not ValueExists('ObjBrushStyle') then
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', _('Neuer Winkel'));
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', clBlack);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 2);
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 0);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 0);
            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            CloseKey;
            // Text definieren
            shTmp := iesNONE;
            psTmp := psClear;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsClear;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;

            for licounter := 0 to 4 do
            begin
               if licounter = 0 then
               begin
                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Text', True);
               end
               else
               begin
                  lszus := inttostr(licounter);
                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Text' + lszus, True);
               end;
               case licounter of
                  0:
                  begin
                     if not ValueExists('ObjText') then
                        WriteString('ObjText', '');
                     // it will read hex!!! so 72 in dec= 114!
                     if not ValueExists('ObjFontHeight') then
                        WriteInteger('ObjFontHeight', 72);
                     if not ValueExists('ObjPenColor') then
                        WriteInteger('ObjPenColor', clBlack);
                  end;
                  1:
                  begin
                     if not ValueExists('ObjText') then
                        WriteString('ObjText', '');
                     // it will read hex!!! so 72 in dec= 114!
                     if not ValueExists('ObjFontHeight') then
                        WriteInteger('ObjFontHeight', 72);
                     if not ValueExists('ObjPenColor') then
                        WriteInteger('ObjPenColor', gclRed); //15.04.2021 clred);
                  end;
                  2:
                  begin
                     if not ValueExists('ObjText') then
                        WriteString('ObjText', '');
                     // it will read hex!!! so 72 in dec= 114!
                     if not ValueExists('ObjFontHeight') then
                        WriteInteger('ObjFontHeight', 72);
                     if not ValueExists('ObjPenColor') then
                        WriteInteger('ObjPenColor', gclGreen); //15.04.2021 clgreen);
                  end;
                  3:
                  begin
                     if not ValueExists('ObjText') then
                        WriteString('ObjText', '');
                     // it will read hex!!! so 72 in dec= 114!
                     if not ValueExists('ObjFontHeight') then
                        WriteInteger('ObjFontHeight', 96);
                     if not ValueExists('ObjPenColor') then
                        WriteInteger('ObjPenColor', clBlack);
                  end;
                  4:
                  begin
                     if not ValueExists('ObjText') then
                        WriteString('ObjText', '');
                     // it will read hex!!! so 72 in dec= 114!
                     if not ValueExists('ObjFontHeight') then
                        WriteInteger('ObjFontHeight', 36); //3.5.0.72
                     if not ValueExists('ObjPenColor') then
                        WriteInteger('ObjPenColor', gclRed); //15.04.2021 clRed); //3.5.0.72
                  end;
               end;

               if not ValueExists('ObjBeginShape') then
                  WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
               if not ValueExists('ObjEndShape') then
                  WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
               if not ValueExists('ObjBrushColor') then
                  WriteInteger('ObjBrushColor', clWhite);
               if not ValueExists('ObjBrushStyle') then
                  WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
               if not ValueExists('ObjFontAngle') then
                  WriteFloat('ObjFontAngle', 0);
//               if not ValueExists('ObjFontLocked') then
//                  WriteBool('ObjFontLocked', False);
               if not ValueExists('ObjFontName') then
                  WriteString('ObjFontName', 'Arial');
               if not ValueExists('ObjFontStyles') then
                  WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
               if not ValueExists('ObjName') then
                  WriteString('ObjName', '');
               if not ValueExists('ObjPenStyle') then
                  WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
               if not ValueExists('ObjMemoBorderColor') then
                  WriteInteger('ObjMemoBorderColor', gclNone);
//               if not ValueExists('ObjAutoIncreaseLine') then
//                  WriteInteger('ObjAutoIncreaseLine', gclNone);
//               if not ValueExists('ObjAutoIncreaseHeight') then
//                  WriteInteger('ObjAutoIncreaseHeight', gclNone);
               if not ValueExists('ObjPenWidth') then
                  WriteInteger('ObjPenWidth', 2);
               if not ValueExists('ObjShapeHeight') then
                  WriteInteger('ObjShapeHeight', 0);
               if not ValueExists('ObjShapeWidth') then
                  WriteInteger('ObjShapeWidth', 0);

               if not ValueExists('ObjLabelBrushStyle') then
                  WriteBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
               if not ValueExists('ObjMemoBorderStyle') then
                  WriteBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));
               //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
               if not ValueExists('ObjStyle') then
                  WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
               if not ValueExists('ObjTransparency') then
                  WriteInteger('ObjTransparency', 255);
               if not ValueExists('Objwidth') then
                  WriteInteger('Objwidth', 400);
               if not ValueExists('objheight') then
                  WriteInteger('objheight', 200);
               if not ValueExists('ObjTextAlign') then
                  WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
//               if not ValueExists('ObjTextAutoSize') then
//                  WriteBool('ObjTextAutoSize', False);
               if not ValueExists('ObjTextCurveCharRot') then
                  WriteFloat('ObjTextCurveCharRot', 0);
               if not ValueExists('Showtextform') then
                  WriteBool('Showtextform', false);
               CloseKey;
            end;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Stempel', True);
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjBrushColor') then
               WriteInteger('ObjBrushColor', clWhite);
            if not ValueExists('ObjBrushStyle') then
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjFontAngle') then
               WriteFloat('ObjFontAngle', 0);
            if not ValueExists('ObjFontHeight') then
               WriteInteger('ObjFontHeight', 72);
//            if not ValueExists('ObjFontLocked') then
//               WriteBool('ObjFontLocked', False);
            if not ValueExists('ObjFontName') then
               WriteString('ObjFontName', 'Arial');
            if not ValueExists('ObjFontStyles') then
               WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', '');
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', clBlack);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 2);
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 0);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 0);
            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            if not ValueExists('ObjTextAlign') then
               WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
//            if not ValueExists('ObjTextAutoSize') then
//               WriteBool('ObjTextAutoSize', False);
            if not ValueExists('ObjTextCurveCharRot') then
               WriteFloat('ObjTextCurveCharRot', 0);
            if not ValueExists('ObjText') then
               WriteString('ObjText', '');
            CloseKey;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Buchungsstempel', True);
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjBrushColor') then
               WriteInteger('ObjBrushColor', clWhite);
            if not ValueExists('ObjBrushStyle') then
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjFontAngle') then
               WriteFloat('ObjFontAngle', 0);
            if not ValueExists('ObjFontHeight') then
               WriteInteger('ObjFontHeight', 72);
//            if not ValueExists('ObjFontLocked') then
//               WriteBool('ObjFontLocked', False);
            if not ValueExists('ObjFontName') then
               WriteString('ObjFontName', 'Arial');
            if not ValueExists('ObjFontStyles') then
               WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', _('Buchungsstempel'));
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', clBlack);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 2);
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 0);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 0);
            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            if not ValueExists('ObjTextAlign') then
               WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
//            if not ValueExists('ObjTextAutoSize') then
//               WriteBool('ObjTextAutoSize', False);
            if not ValueExists('ObjTextCurveCharRot') then
               WriteFloat('ObjTextCurveCharRot', 0);
            if not ValueExists('ObjText') then
               WriteString('ObjText', '');
            CloseKey;
            // Notiz definieren
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsSolid;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            for licounter := 0 to 4 do
            begin
               if licounter = 0 then
               begin
                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Note', True);
               end
               else
               begin
                  lszus := inttostr(licounter);
                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Note' + lszus, True);
               end;
               if not ValueExists('ObjBeginShape') then
                  WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
               if not ValueExists('ObjEndShape') then
                  WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
               case licounter of
                  0:
                  begin
                     if not ValueExists('ObjBrushColor') then
                        WriteInteger('ObjBrushColor', gclYellow);
                  end;
                  1:
                  begin
                     if not ValueExists('ObjBrushColor') then
                        WriteInteger('ObjBrushColor', gclLime); //15.04.2021 cllime);
                  end;
                  2:
                  begin
                     if not ValueExists('ObjBrushColor') then
                        WriteInteger('ObjBrushColor', gclRed); //15.04.2021 clred);
                     if not ValueExists('ObjPenColor') then
		                  WriteInteger('ObjPenColor', clWhite);
                  end;
                  3:
                  begin
                     if not ValueExists('ObjBrushColor') then
                        WriteInteger('ObjBrushColor', gclBlue); //15.04.2021 );
                     if not ValueExists('ObjPenColor') then
		                  WriteInteger('ObjPenColor', clWhite);
                  end;
                  4:
                  begin
                     if not ValueExists('ObjBrushColor') then
                        WriteInteger('ObjBrushColor', cColorOrange); //15.04.2021 $000080FF);
                  end;
               end;
               if not ValueExists('ObjBrushStyle') then
                  WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
               if not ValueExists('ObjFontAngle') then
                  WriteFloat('ObjFontAngle', 0);
               if not ValueExists('ObjFontHeight') then
                  WriteInteger('ObjFontHeight', 72);
//               if not ValueExists('ObjFontLocked') then
//                  WriteBool('ObjFontLocked', False);
               if not ValueExists('ObjFontName') then
                  WriteString('ObjFontName', 'Arial');
               if not ValueExists('ObjFontStyles') then
                  WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
               if not ValueExists('ObjMemoBorderColor') then
                  WriteInteger('ObjMemoBorderColor', clBlack);
//               if not ValueExists('ObjAutoIncreaseLine') then
//                  WriteInteger('ObjAutoIncreaseLine', gclNone);
//               if not ValueExists('ObjAutoIncreaseHeight') then
//                  WriteInteger('ObjAutoIncreaseHeight', gclNone);
               if not ValueExists('ObjMemoBorderStyle') then
                  WriteBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));
               if not ValueExists('ObjMemoFixedHeight') then
                  WriteInteger('ObjMemoFixedHeight', 0);
               if not ValueExists('ObjMemoLineSpace') then
                  WriteInteger('ObjMemoLineSpace', 0);
               if not ValueExists('ObjName') then
                  WriteString('ObjName', '');
               if not ValueExists('ObjPenColor') then
                  WriteInteger('ObjPenColor', clBlack);
               if not ValueExists('ObjPenStyle') then
                  WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
               if not ValueExists('ObjPenWidth') then
                  WriteInteger('ObjPenWidth', 2);
               if not ValueExists('ObjShapeHeight') then
                  WriteInteger('ObjShapeHeight', 0);
               if not ValueExists('ObjShapeWidth') then
                  WriteInteger('ObjShapeWidth', 0);
               //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
               if not ValueExists('ObjStyle') then
                  WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
               if not ValueExists('ObjTransparency') then
                  WriteInteger('ObjTransparency', 255);
               if not ValueExists('Objwidth') then
                  WriteInteger('Objwidth', 400);
               if not ValueExists('objheight') then
                  WriteInteger('objheight', 400);
               if not ValueExists('ObjTextAlign') then
                  WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
//               if not ValueExists('ObjTextAutoSize') then
//                  WriteBool('ObjTextAutoSize', False);
               if not ValueExists('ObjTextCurveCharRot') then
                  WriteFloat('ObjTextCurveCharRot', 0);
               if not ValueExists('ObjText') then
                  WriteString('ObjText', '');
               CloseKey;
            end;
            // Poligon definieren
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsSolid;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Poligon', True);
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjBrushColor') then
               WriteInteger('ObjBrushColor', clSkyBlue);
            if not ValueExists('ObjBrushStyle') then
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', _('Neue PolyLinie'));
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', gclBlue); //15.04.2021 clBlue);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 2);
            if not ValueExists('ObjPolylineClosed') then
            begin
               WriteBool('ObjPolylineClosed', True);
            end;
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 0);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 0);
            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            CloseKey;
            // Polyline definieren
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsClear;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Polyline', True);
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', _('Neue PolyLinie'));
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', gclBlue); //15.04.2021 clBlue);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 2);
            if not ValueExists('ObjPolylineClosed') then
               WriteBool('ObjPolylineClosed', False);
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 0);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 0);
            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            CloseKey;
            // LineLabel definieren
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsSolid;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\LineLabel', True);
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjBrushColor') then
               WriteInteger('ObjBrushColor', clInfoBk);
            if not ValueExists('ObjBrushStyle') then
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjFontAngle') then
               WriteFloat('ObjFontAngle', 0);
            if not ValueExists('ObjFontHeight') then
               WriteInteger('ObjFontHeight', 72);
//            if not ValueExists('ObjFontLocked') then
//               WriteBool('ObjFontLocked', False);
            if not ValueExists('ObjFontName') then
               WriteString('ObjFontName', 'Arial');
            if not ValueExists('ObjFontStyles') then
               WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
            if not ValueExists('ObjLabelBrushColor') then
               WriteInteger('ObjLabelBrushColor', clInfoBK);
            if not ValueExists('ObjLabelBrushStyle') then
               WriteBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjLabelPosition') then
               WriteBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', _('Neue Notiz'));
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', clBlack);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 1);
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 0);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 0);
            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            if not ValueExists('ObjTextAlign') then
               WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
//            if not ValueExists('ObjTextAutoSize') then
//               WriteBool('ObjTextAutoSize', False);
            if not ValueExists('ObjTextCurveCharRot') then
               WriteFloat('ObjTextCurveCharRot', 0);
            if not ValueExists('ObjText') then
               WriteString('ObjText', _('Neuer Aufkleber'));
            CloseKey;
            // Messlinie definieren
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsSolid;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertQUOTECENTER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Ruler', True);
            shTmp := iesOUTARROW;
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjBrushColor') then
               WriteInteger('ObjBrushColor', clInfoBk);
            if not ValueExists('ObjBrushStyle') then
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjFontAngle') then
               WriteFloat('ObjFontAngle', 0);
            if not ValueExists('ObjFontHeight') then
               WriteInteger('ObjFontHeight', 8);
//            if not ValueExists('ObjFontLocked') then
//               WriteBool('ObjFontLocked', False);
            if not ValueExists('ObjFontName') then
               WriteString('ObjFontName', 'MS Sans Serif');
            if not ValueExists('ObjFontStyles') then
               WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
            if not ValueExists('ObjLabelBrushColor') then
               WriteInteger('ObjLabelBrushColor', clInfoBK);
            if not ValueExists('ObjLabelBrushStyle') then
               WriteBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjLabelPosition') then
               WriteBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', _('Neue Messlinie'));
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', clBlack);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 1);
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 30);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 30);
            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            if not ValueExists('ObjTextAlign') then
               WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
//            if not ValueExists('ObjTextAutoSize') then
//               WriteBool('ObjTextAutoSize', False);
            if not ValueExists('ObjTextCurveCharRot') then
               WriteFloat('ObjTextCurveCharRot', 0);
            if not ValueExists('ObjText') then
               WriteString('ObjText', _('Neue Messlinie'));
            if not ValueExists('ObjRulerType') then
               WriteBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp));
            if not ValueExists('ObjRulerUnit') then
               WriteBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp));
            CloseKey;
            // Winkelmessen definieren
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsSolid;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Angle', True);
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjBrushColor') then
               WriteInteger('ObjBrushColor', clInfoBk);
            if not ValueExists('ObjBrushStyle') then
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjFontAngle') then
               WriteFloat('ObjFontAngle', 0);
            if not ValueExists('ObjFontHeight') then
               WriteInteger('ObjFontHeight', 8);
//            if not ValueExists('ObjFontLocked') then
//               WriteBool('ObjFontLocked', False);
            if not ValueExists('ObjFontName') then
               WriteString('ObjFontName', 'MS Sans Serif');
            if not ValueExists('ObjFontStyles') then
               WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
            if not ValueExists('ObjLabelBrushColor') then
               WriteInteger('ObjLabelBrushColor', clInfoBK);
            if not ValueExists('ObjLabelBrushStyle') then
               WriteBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjLabelPosition') then
               WriteBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', _('Neue Messlinie'));
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', clBlack);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 1);
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 30);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 30);
            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            if not ValueExists('ObjTextAlign') then
               WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
//            if not ValueExists('ObjTextAutoSize') then
//               WriteBool('ObjTextAutoSize', False);
            if not ValueExists('ObjTextCurveCharRot') then
               WriteFloat('ObjTextCurveCharRot', 0);
            if not ValueExists('ObjText') then
               WriteString('ObjText', _('Neue Messlinie'));
            if not ValueExists('ObjRulerType') then
               WriteBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp));
            if not ValueExists('ObjRulerUnit') then
               WriteBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp));
            CloseKey;
            // Pfeil definieren
            shTmp := iesOUTARROW;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsSolid;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Arrow', True);
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            shTmp := iesNONE;
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjBrushColor') then
               WriteInteger('ObjBrushColor', clNavy);
            if not ValueExists('ObjBrushStyle') then
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', _('Neuer Pfeil'));
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', clBlack);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 2);
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 30);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 30);
            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            CloseKey;
            //Freihand
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsClear;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            for licounter := 0 to 4 do
            begin
               if licounter = 0 then
               begin
                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Freihand', True);
               end
               else
               begin
                  lszus := inttostr(licounter);
                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Freihand' + lszus, True);
               end;
               case licounter of
                  0:
                  begin
                     if not ValueExists('ObjPenColor') then
                        WriteInteger('ObjPenColor', clBlack);
                  end;
                  1:
                  begin
                     if not ValueExists('ObjPenColor') then
                        WriteInteger('ObjPenColor', gclGreen); //15.04.2021 clGreen);
                  end;
                  2:
                  begin
                     if not ValueExists('ObjPenColor') then
                        WriteInteger('ObjPenColor', gclRed); //15.04.2021 clred);
                  end;
                  3:
                  begin
                     if not ValueExists('ObjPenColor') then
                        WriteInteger('ObjPenColor', gclBlue); //15.04.2021 clblue);
                  end;
                  4:
                  begin
                     if not ValueExists('ObjPenColor') then
                        WriteInteger('ObjPenColor', cColorOrange); //15.04.2021 $000080FF);
                  end;
               end;
               if not ValueExists('ObjBrushStyle') then
                  WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
               if not ValueExists('ObjBeginShape') then
                  WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
               if not ValueExists('ObjEndShape') then
                  WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
               if not ValueExists('ObjName') then
                  WriteString('ObjName', _('Neue PolyLinie'));
               if not ValueExists('ObjPenStyle') then
                  WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
               if not ValueExists('ObjPenWidth') then
                  WriteInteger('ObjPenWidth', 2);
               if not ValueExists('ObjPolylineClosed') then
                  WriteBool('ObjPolylineClosed', False);
               if not ValueExists('ObjShapeHeight') then
                  WriteInteger('ObjShapeHeight', 0);
               if not ValueExists('ObjShapeWidth') then
                  WriteInteger('ObjShapeWidth', 0);
               //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
               if not ValueExists('ObjStyle') then
                  WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
               if not ValueExists('ObjTransparency') then
                  WriteInteger('ObjTransparency', 255);
               if not ValueExists('Objwidth') then
                  WriteInteger('Objwidth', 400);
               if not ValueExists('objheight') then
                  WriteInteger('objheight', 400);
               CloseKey;
            end;
         end;
      except
         on e: Exception do
         begin
            BfShowMessage('Fehler beim berprfen der Registrierung: ' + e.Message);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;



function Tfrm_Voransicht.LoadStamp(StampKey: string): boolean;
var
  reg: TRegistry;
  fsTmp: TFontStyles;
  bmpTmp: TImageEnView;
  mesTmp: TIEUnits;
  sStampText, sFileName, splittext: String;
  iSWidth, iSHeight, liDeckkraft, i, liStatefield: Integer;
  memo2: TStringList;
  bFitToText, bFixedSize: Boolean;
  bsTmp: TBrushStyle;
  psTmp: TPenStyle;
  AFont: TFont;
  foobar: Boolean;
begin
  Result := True;
  reg := TRegistry.Create;
  fObjVersion := -1;

  bmpTmp := TImageEnView.Create(nil);
  memo2 := TStringList.Create();
  AFont := TFont.Create;

  try
    try
      with reg do
      begin
        RootKey := HKEY_CURRENT_USER;
        if not KeyExists('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey) then
           Exit;
        OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey, True);
        with img_DocView do
        begin
          try
            if ValueExists('StampName') then
              ObjName[-1] := 'Stempel: ' + ReadString('StampName')
            else
              ObjName[-1] := _('Neuer Stempel');
          except
            //14.06.2018 wegen CrashLog eingebaut
          end;
          try
            if (Self.Owner <> nil) and (Self.Owner is TbfaPreview) then
              TbfaPreview(Self.Owner).StampStatefield := -1;
          except

          end;
          if ValueExists('StampTyp') then
          begin
            if not ReadBool('StampTyp') then
            begin
              // Text Stempel
              ObjKind[-1] := iekMEMO;

              // f.schneider
              // so jetzt mal alles neu und nur was wir wirklich brauchen
              // um abwrtskompatibel zu sein wird beim fehlen in der registry von
              // ObjMemoCharsBrushStyle dieser Wert von ObjBrushStyle genommen
              // und gespeichert, danach ist der Wert angelegt

              if ValueExists('StampText') then
                sStampText := ReadString('StampText')
              else
                sStampText := _('(kein Text)');

              GraphicClipboardStamp := False;

              foobar := True;
              if not foobar then
              begin
                if ValueExists('FontColor') then
                  ObjPenColor[-1] := ReadInteger('FontColor')
                else
                  ObjPenColor[-1] := 0;

                if ValueExists('FontName') then
                  ObjFontName[-1] := ReadString('FontName')
                else
                  ObjFontName[-1] := 'Arial';

                if ValueExists('FontStyle') then
                begin
                  ReadBinaryData('FontStyle', fsTmp, SizeOf(fsTmp));
                  ObjFontStyles[-1] := fsTmp;
                end
                else
                  ObjFontStyles[-1] := [];

                if ValueExists('FontSize') then
                  ObjFontHeight[-1] := ReadInteger('FontSize')
                else
                  ObjFontHeight[-1] := 72;
              end else
              begin
                if ValueExists('FontColor') then
                  AFont.Color := ReadInteger('FontColor')
                else
                  AFont.Color := 0;

                if ValueExists('FontName') then
                  AFont.Name := ReadString('FontName')
                else
                  AFont.Name := 'Arial';

                if ValueExists('FontStyle') then
                begin
                  ReadBinaryData('FontStyle', fsTmp, SizeOf(fsTmp));
                  AFont.Style := fsTmp;
                end
                else
                  AFont.Style := [];

//                if ValueExists('FontSize') then
//                  AFont.Size := ReadInteger('FontSize')
//                else
//                  AFont.Size := 72;
                if ValueExists('FontSize') then
                  AFont.Height := ReadInteger('FontSize')
                else
                  AFont.Height := 72;

                SetObjFont(-1, AFont);
                ObjFontName[-1] := AFont.Name; //17.07.2024 bfacrm:ticket__show__39370
              end;

              if ValueExists('StampHeight') then
                iSHeight := ReadInteger('StampHeight')
              else
                iSHeight := 30;

              if ValueExists('StampWidth') then
                iSWidth := ReadInteger('StampWidth')
              else
                iSWidth := 40;

              if ValueExists('ObjBrushColor') then
                ObjBrushColor[-1] := ReadInteger('ObjBrushColor')
              else
                ObjBrushColor[-1] := gclYellow;

              if ValueExists('ObjBrushStyle') then
                ReadBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp))
              else
                bsTmp := bsSolid;

              ObjBrushStyle[-1] := bsTmp;

              if ValueExists('ObjMemoBorderStyle') then
                ReadBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp))
              else
                psTmp := psClear;

              ObjMemoBorderStyle[-1] := psTmp;

              if ValueExists('ObjMemoBorderColor') then
                ObjMemoBorderColor[-1] := ReadInteger('ObjMemoBorderColor')
              else
                ObjMemoBorderColor[-1] := clBlack;

              if ValueExists('ObjTransparency') then
                liDeckkraft := ReadInteger('ObjTransparency')
              else
                liDeckkraft := 255;

              if liDeckkraft < 51 then  // f.schneider 3.5.0.133  Kein Stempel mehr unter 20% Deckkraft
              begin
                liDeckkraft := 255;
                WriteInteger('ObjTransparency', liDeckkraft);
              end;

              ObjTransparency[-1] := liDeckkraft;

              if ValueExists('ObjMemoCharsBrushStyle') then
                ReadBinaryData('ObjMemoCharsBrushStyle', bsTmp, SizeOf(bsTmp))
              else
                bsTmp := bsClear;

              ObjMemoCharsBrushStyle[-1] := bsTmp;

              if ValueExists('StampFitToText') then
                bFitToText := ReadBool('StampFitToText')
              else
                bFitToText := True;

              if ValueExists('StampFixedSize') then
                bFixedSize := ReadBool('StampFixedSize')
              else
                bFixedSize := True;

              ObjFontLocked[-1] := False;	// die Schrift sollte vernderbar sein, bei einem Textstempel

              // SJ 02.07.21 - viele der StringReplace nach img_DocViewNewObject verschoben
              // dann werden zB Sekunden zum Zeitpunkt des Stempelns gesetzt. Nicht beim laden vom Stempel
//              sStampText := StringReplace(sStampText, '%GDOCID', IntToStr(bitfarmApp.CurrentContainer[0].ID), [rfReplaceAll,rfIgnoreCase]); //11.06.2018 Ticket 14728
//              sStampText := StringReplace(sStampText, '%U', bitfarmApp.User.Name, [rfReplaceAll,rfIgnoreCase]);
//              sStampText := StringReplace(sStampText, '%A', bitfarmApp.User.DisplayName, [rfReplaceAll,rfIgnoreCase]);

//29.02.2024 bfacrm:ticket__show__37814 -->
//              if not bFitToText then
              if (not bFitToText) or
                 (bFitToText and bFixedSize)
//29.02.2024 bfacrm:ticket__show__37814 <--
              then
              begin
                mesTmp := MUnit;
                MUnit := ieuMILLIMETERS;
                ObjWidth[-1] := Round(iSWidth / MeasureCoefX);
                ObjHeight[-1] := Round(iSHeight / MeasureCoefY);
                MUnit := mesTmp;
              end;

//              splittext := sStampText;
//              while Pos(#13#10,splittext) > 0 do
//              begin
//                memo2.Add(LeftStr(splittext,Pos(#13#10,splittext)));
//                splittext := RightStr(splittext,Length(splittext) - Pos(#13#10,splittext)-1);
//              end;
//
//              if splittext <> '' then
//                memo2.Add(splittext);
              sStampText := StringReplace(sStampText, '\n\r', #13#10, [rfReplaceAll,rfIgnoreCase]);
              if bFitToText then
                memo2 := StrToWordsLF(sStampText);

              ObjStyle[-1] := [ievsSelectable, ievsMoveable, ievsVisible];
//29.02.2024 bfacrm:ticket__show__37814              if not bFixedSize then
              if not bFixedSize or bFitToText then
                ObjStyle[-1] := ObjStyle[-1] + [ievsSizeable];

              MouseInteractVT := [miPutmemo];

//29.02.2024 bfacrm:ticket__show__37814              if bFitToText then
              if bFitToText and (not bFixedSize) then
                textanObjektpassen(memo2)
              else
                ObjText[-1] := sStampText;

              if ValueExists('StampStatefield') then
              begin
                liStatefield := ReadInteger('StampStatefield');
                if (Self.Owner <> nil) and (Self.Owner is TbfaPreview) and (liStatefield > 0) then
                  TbfaPreview(Self.Owner).StampStatefield := liStatefield;
              end;

              {$IFDEF ENTERPRISE}
              if ValueExists('StampPlugin') then
                StampPlugin := ReadString('StampPlugin')
              else
                StampPlugin := '';

              if (StampPlugin <> '') and (frmMainForm.mnuPlugins <> nil) and
                 (frmMainForm.mnuPlugins.Count > 0) then
              begin
              var found: Boolean;
                  found := False;
                for I := 0 to High(bitfarmApp.PluginsArray) do
                begin
                  if bitfarmApp.PluginsArray[I].Name = StampPlugin then
                  begin
                    if not Assigned(VirtualPluginMenuItem) then
                      VirtualPluginMenuItem := TPluginObj.Create;
                    VirtualPluginMenuItem.Name := ChangeFileExt(bitfarmApp.PluginsArray[I].Name, '');
                    VirtualPluginMenuItem.FileName := bitfarmApp.PluginsArray[I].Name;
                    VirtualPluginMenuItem.Parameters := bitfarmApp.PluginsArray[I].Parameters;
                    VirtualPluginMenuItem.Command := bitfarmApp.PluginsArray[I].Command;
                    VirtualPluginMenuItem.Index := bitfarmApp.PluginsArray[I].Index;
                    found := True;
                    Break;
                  end;
                end;
                if not found then
                  VirtualPluginMenuItem := nil;
              end else
                VirtualPluginMenuItem := nil;
              {$ENDIF}
            end
            else
            begin
              // Bild Stempel
              ObjKind[-1] := iekBITMAP;
              if ValueExists('StampClipboard') and ReadBool('StampClipboard') then
                GraphicClipboardStamp := True
              else if ValueExists('StampFile') then
              begin
                sFileName := ReadString('StampFile');
                GraphicClipboardStamp := False;
              end else
              begin
                GraphicClipboardStamp := False;
                BfShowMessage(_('Der Bildstempel konnte nicht geladen werden. Keine Bilddatei angegeben'));
                Exit;
              end;

              if FileExists(sFileName) and (not GraphicClipboardStamp) then
              begin
                SetObjBitmapFromFile(-1, sFileName);
//12.12.2017 nur Transparente Bildstempel drfen bsClear sein -->
//                       if (ExtractFileExt(sFileName) = '.gif') then
                if (LowerCase(ExtractFileExt(sFileName)) = '.gif') or
                   (LowerCase(ExtractFileExt(sFileName)) = '.png')
                then
                  ObjBrushStyle[-1] := bsClear
                else
                  ObjBrushStyle[-1] := bsSolid;
//12.12.2017 nur Transparente Bildstempel drfen bsClear sein <--
              end
              else if (not GraphicClipboardStamp) then
              begin
                BfShowMessage(_('Der Bildstempel konnte nicht geladen werden. Bilddatei nicht gefunden'));
                Exit;
              end;

              if ValueExists('StampHeight') then
                iSHeight := ReadInteger('StampHeight')
              else
                iSHeight := 30;

              if ValueExists('StampWidth') then
                iSWidth := ReadInteger('StampWidth')
              else
                iSWidth := 40;

              if ValueExists('ObjTransparency') then
                liDeckkraft := ReadInteger('ObjTransparency')
              else
                liDeckkraft := 255;

              if liDeckkraft < 51 then  // f.schneider 3.5.0.133  Kein Stempel mehr unter 20% Deckkraft
              begin
                liDeckkraft := 255;
                WriteInteger('ObjTransparency', liDeckkraft);
              end;

              ObjTransparency[-1] := liDeckkraft;

              if ValueExists('StampFixedSize') then
                bFixedSize := ReadBool('StampFixedSize')
              else
//12.03.2024                bFixedSize := True;
// wegen dieses Ticket  bfacrm:ticket__show__28910 muss hier False sein!!!
                bFixedSize := False;

              if ValueExists('StampStatefield') then
              begin
                liStatefield := ReadInteger('StampStatefield');
                if (Self.Owner <> nil) and (Self.Owner is TbfaPreview) and (liStatefield > -1) then
                  TbfaPreview(Self.Owner).StampStatefield := liStatefield;
              end;

              {$IFDEF ENTERPRISE}
              if ValueExists('StampPlugin') then
                StampPlugin := ReadString('StampPlugin')
              else
                StampPlugin := '';

              if (StampPlugin <> '') and (frmMainForm.mnuPlugins <> nil) and
                 (frmMainForm.mnuPlugins.Count > 0) then
              begin
              var found: Boolean;
                  found := False;
                for I := 0 to High(bitfarmApp.PluginsArray) do
                begin
                  if bitfarmApp.PluginsArray[I].Name = StampPlugin then
                  begin
                    if not Assigned(VirtualPluginMenuItem) then
                      VirtualPluginMenuItem := TPluginObj.Create;
                    VirtualPluginMenuItem.Name := ChangeFileExt(bitfarmApp.PluginsArray[I].Name, '');
                    VirtualPluginMenuItem.FileName := bitfarmApp.PluginsArray[I].Name;
                    VirtualPluginMenuItem.Parameters := bitfarmApp.PluginsArray[I].Parameters;
                    VirtualPluginMenuItem.Command := bitfarmApp.PluginsArray[I].Command;
                    VirtualPluginMenuItem.Index := bitfarmApp.PluginsArray[I].Index;
                    found := True;
                    Break;
                  end;
                end;
                if not found then
                  VirtualPluginMenuItem := nil;
              end else
                VirtualPluginMenuItem := nil;
              {$ENDIF}

              EnableAlphaChannel := True;
              ObjBrushColor[-1] := 16777215;
              mesTmp := MUnit;
              MUnit := ieuMILLIMETERS;
              ObjWidth[-1] := Round(iSWidth / MeasureCoefX);
              ObjHeight[-1] := Round(iSHeight / MeasureCoefY);
              MUnit := mesTmp;
              ObjBitmapBorder[-1] := False;

              ObjStyle[-1] := [ievsSelectable, ievsMoveable, ievsVisible];
//29.02.2024 bfacrm:ticket__show__37814              if not bFixedSize then
              if not bFixedSize or bFitToText then
                ObjStyle[-1] := ObjStyle[-1] + [ievsSizeable];

              MouseInteractVT := [miPutBitmap];
            end;

            FStampWidth := ObjWidth[-1];
            FStampHeight := ObjHeight[-1];

//            if GraphicClipboardStamp then
//              TbfaPreview(Self.Owner).tbiClipboardAsStampClick(nil);
          end
          else
            Exit; // Stempel Typ unbekannt - verlassen!
        end;

        if ValueExists('Version') then
          fObjVersion := ReadInteger('Version')
        else
          fObjVersion := -1;
            
        if bitfarmApp.ViewerOptions.GeneralOptions.SetAnnoDPI then //25.10.2017 bei Kunden muss wie vorher in 3.5 war!!!
        begin
          // 01.06.2017 Ticket 10703 -->
          // ab Version 36 die Schriftgren werden richtig angepasst,
          // aber das kann bei vorher (V35) erstellten Stempel falsch dargestellt werden
          // (beim TextObjekten ist es nicht schlimm, weil die keine feste gre haben
          // und werden immer angepasst),
          // deswegen wird hier Version abgefragt, das gilt erst ab Version 3.6.0.945
          fnt.Color := img_DocView.ObjPenColor[-1];
          fnt.Name := img_DocView.ObjFontName[-1];
          fnt.Size := img_DocView.ObjFontHeight[-1];
          fnt.Style := img_DocView.ObjFontStyles[-1];
          if fObjVersion >= 36 then
            img_DocView.SetObjFont(-1, fnt);
          // 01.06.2017 Ticket 10703 <--
        end;

        // 01.02.2019 TIcket 17141 -->
        if fObjVersion >= 36 then
        begin
          if bFitToText and (not bFixedSize) then
            img_DocView.ObjTextAutoSize[-1] := True
          else
            img_DocView.ObjTextAutoSize[-1] := False;
        end
        else
          img_DocView.ObjTextAutoSize[-1] := False;
        // 01.02.2019 TIcket 17141 -->

        CloseKey;
      end;
    except
      on e: Exception do
      begin
        BfShowMessage(_('Fehler beim Lesen der Registrierung: ') + e.Message);
        Result := False;
      end;
    end;
  finally
    reg.CloseKey;
    if Assigned(reg) then
      FreeAndNil(reg);
    if Assigned(bmpTmp) then
      FreeAndNil(bmpTmp);
  end;
end;

procedure Tfrm_Voransicht.ClearHistory;
begin
  fHistoryNew.Clear;
  fHistoryDeleted.Clear;
  fNoteSLW.Clear;
  fNoteVTX.Clear;
end;

procedure Tfrm_Voransicht.ObjektAnTextAnpassen(hobj: Integer; Force: Boolean = False);
var
  lilen, linelength, inewlen, inewheight, ioldwidth: integer;
  lslongestline: string;
  fstl : TStringList;
begin
  //10.10.2018 Ticket 16336-->
  if not (ievsSizeable in img_DocView.ObjStyle[hobj]) then
    Exit;
  //10.10.2018 Ticket 16336<--

  inewlen := 0; //11.01.2024 bfacrm:ticket__show__37369
  inewheight := 0; //11.01.2024 bfacrm:ticket__show__37369

  fstl := StrToWordsLF(img_DocView.ObjText[hobj]);
  lilen := length(fstl.Text);

  lslongestline := GetLongestLine(fstl);
  if lslongestline = '' then
  begin
    img_DocView.ObjText[hobj] := '';
    Exit;
  end;

  if (fObjVersion >= 36) and (bitfarmApp.ViewerOptions.GeneralOptions.SetAnnoDPI) then
    img_DocView.GetCanvas.Font := fnt;
  linelength := img_DocView.GetCanvas.TextWidth(lslongestline);

  //25.10.2017 bei Kunden muss wie vorher in 3.5 war!!!
  if (fObjVersion >= 36) and (bitfarmApp.ViewerOptions.GeneralOptions.SetAnnoDPI) then
  begin
    inewlen := trunc((linelength * abs(fnt.height) / 11) + (abs(fnt.Height) / 2));
    inewheight := (fstl.Count * (trunc((abs(fnt.height) * 3) / 2.5))) + 2;
  end
  else if (img_DocView.ObjWidth[hobj] = bitfarmApp.LastAnnoDefaultWidth) and (img_DocView.ObjHeight[hobj] = bitfarmApp.LastAnnoDefaultHeight) then
  begin
//23.05.2019 manchmal wird negativ wert sein, dann wird ausser Seite gemalt   inewlen := trunc((linelength * img_DocView.ObjFontHeight[hobj] / 11) + (img_DocView.ObjFontHeight[hobj] / 2));
    inewlen := trunc((linelength * Abs(img_DocView.ObjFontHeight[hobj]) / 14) + (Abs(img_DocView.ObjFontHeight[hobj]) / 2));
    inewheight := (fstl.Count * (trunc(abs(img_DocView.ObjFontHeight[hobj]) * 3 / 2.5))) +2;
  end;
  ioldwidth := img_DocView.ObjWidth[hobj];

//11.01.2024 bfacrm:ticket__show__37369  if (inewlen < img_DocView.ObjWidth[hobj]) or Force or
  if ((inewlen <> 0) and (inewlen < img_DocView.ObjWidth[hobj])) or Force or
     ((fObjVersion >= 36) and (bitfarmApp.ViewerOptions.GeneralOptions.SetAnnoDPI)) then
  begin
//11.01.2024 bfacrm:ticket__show__37369   if inewlen < img_DocView.IO.Params.Width then
    if (inewlen <> 0 ) and (inewlen < img_DocView.IO.Params.Width) then
   	  img_DocView.ObjWidth[hobj] := inewlen;

    // wenn zu gro, trotzdem ndern, aber nach oben schieben
//11.01.2024    if (inewheight < img_DocView.ObjHeight[hobj]) or
//11.01.2024       ((inewheight + img_DocView.ObjTop[hobj]) <= img_DocView.IO.Params.Height)
    if ((inewheight <> 0) and (inewheight < img_DocView.ObjHeight[hobj])) or
       ((inewheight <> 0) and ((inewheight + img_DocView.ObjTop[hobj]) <= img_DocView.IO.Params.Height))
    then
      img_DocView.ObjHeight[hobj] := inewheight;

//07.10.2020 <--
    // Position anpassen, je nachdem ob rechtsbndig oder zentriert
    if inewlen <> 0 then //11.01.2024 bfacrm:ticket__show__37369
    begin
      if img_DocView.ObjTextAlign[hobj] = iejRight then
        img_DocView.ObjLeft[hobj] := img_DocView.ObjLeft[hobj] + (ioldwidth - inewlen)
      else if img_DocView.ObjTextAlign[hobj] = iejCenter then
        img_DocView.ObjLeft[hobj] := img_DocView.ObjLeft[hobj] + trunc((ioldwidth - inewlen) / 2);
    end;
  end;
  FreeAndNil(fstl);
end;

procedure Tfrm_Voransicht.RotateImage(degree: Integer);
var
  idx, hobj, ileft, itop, iwidth, iheight, imgwidth, imgheight, iowidth, ioheight: Integer;
begin
  img_DocView.LockPaint;
  try
    img_DocView.Proc.Rotate(degree);
    img_DocView.Update;

    if degree <> 180 then
    begin
      // tausche Bildhhe und Breite
      if (Self.Owner <> nil) and
         (TbfaPreview(Self.Owner).ActiveDoc <> nil) and
         (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView <> nil) and
         (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolViewLoaded) then
      begin
        imgwidth := img_DocView.Bitmap.Width;
        imgheight := img_DocView.Bitmap.Height;
        img_DocView.IO.Params.Width := imgwidth;
        img_DocView.IO.Params.Height := imgheight;
      end
      else begin
        imgwidth := img_DocView.IO.Params.Width;
        imgheight := img_DocView.IO.Params.Height;
        img_DocView.IO.Params.Width := imgheight;
        img_DocView.IO.Params.Height := imgwidth;
      end;
    end;

    img_DocView.Update;

    if img_DocView.ObjectsCount > 0 then
    begin
      for idx := 0 to img_DocView.ObjectsCount -1 do
      begin
        hobj := img_DocView.GetObjFromIndex(idx);
        ileft := img_DocView.ObjLeft[hobj];
        itop := img_DocView.ObjTop[hobj];
        iwidth := img_DocView.ObjWidth[hobj];
        iheight := img_DocView.ObjHeight[hobj];

        if degree = 90 then
        begin
          img_DocView.ObjLeft[hobj] := itop;
          img_DocView.ObjTop[hobj] := img_DocView.IO.Params.Height - ileft;
        end
        else if degree = -90 then
        begin
          img_DocView.ObjLeft[hobj] := img_DocView.IO.Params.Width - itop;
          img_DocView.ObjTop[hobj] := ileft;
        end
        else if degree = 180 then
        begin
          img_DocView.ObjLeft[hobj] := img_DocView.IO.Params.Width - ileft;
          img_DocView.ObjTop[hobj] := img_DocView.IO.Params.Height - itop;
        end;

        // prfen ob wir den Bildrand verlassen
        if img_DocView.ObjTop[hobj] + iheight > img_DocView.IO.Params.Height then
           img_DocView.ObjTop[hobj] := img_DocView.ObjTop[hobj] - (img_DocView.ObjTop[hobj] +
           iheight - img_DocView.IO.Params.Height);

        if img_DocView.ObjLeft[hobj] + iwidth > img_DocView.IO.Params.Width then
           img_DocView.ObjLeft[hobj] := img_DocView.ObjLeft[hobj] - (img_DocView.ObjLeft[hobj] +
             iwidth - img_DocView.IO.Params.Width);

        if img_DocView.ObjLeft[hobj] < 0 then
           img_DocView.ObjLeft[hobj] := 0;
        if img_DocView.ObjTop[hobj] < 0 then
           img_DocView.ObjTop[hobj] := 0;

      end;
      fAnnosRotated := True;  // damit diese unabhngig von den Rechten auch gedreht werden drfen
      gbAnnoNotSaved := True;
    end
  finally
    img_DocView.UnLockPaint;
  end;
end;

procedure Tfrm_Voransicht.saveannostream(Doc: TbfaDocument);
begin
  saveannostream(True, Doc);
end;

procedure Tfrm_Voransicht.img_DocViewDblClick(Sender: TObject);
var
  idx2, rights, imgidx: Integer;
  AnnoObj: TbfaAnnotation;
  ModifieRight: Boolean;
  FloatingForm: TForm;
begin
  try
    if TbfaPreview(Self.Owner).ActiveDoc = nil then
      Exit;
    FloatingForm := nil;
    ModifieRight := False;

    if fsavingobjs then
      fdoubleklicked := True
    else
    begin
      if (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView <> nil) and
         (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolViewLoaded)
      then
        imgidx := TbfaPreview(Self.Owner).ActivePage
      else
        imgidx := img_DocView.IO.Params.ImageIndex;

      TbfaPreview(Self.Owner).ActiveDoc.GetAnnotation(imgidx,
        TbfaPreview(Self.Owner).CurrentLayer, idx2);

      if idx2 <> -1 then
        rights := TbfaPreview(Self.Owner).ActiveDoc.Annotations[idx2].Rights
      else
        rights := TbfaPreview(Self.Owner).ActiveDoc.Rights;

      ModifieRight := (((rights and rightAWrite) = rightAWrite) or
                       ((rights and rightAPWrite) = rightAPWrite) or
                       (TbfaPreview(Owner).ActiveDoc.ID = -1));

      if not img_DocView.IsEmpty then
      begin
        if (img_DocView.MouseInteractVt = [miPutPolyLine]) {and ModifieRight} then
        begin
          {$IFNDEF IMAGEEN1140}  //17.01.2024
          img_DocView.CancelInteracts;
          img_DocView.DeSelect;
          img_DocView.UnSelAllObjects;
          img_DocView.MouseInteractVt := [];
//06.10.2021          img_DocView.BitmapResampleFilter := rfLinear;
          img_DocView.BitmapResampleFilter := rfFastLinear;
          createannodata(img_DocView.ObjHeapCount -1);
          {$ENDIF}
          if fAnnoType = 0 then
            fHistoryNew.Add(Format( _('Neue Anmerkungen (%s) auf Seite %s'),
              [ObjKindToStr(img_DocView.ObjTextEditMode), inttostr(imgidx + 1)]));
          gbAnnoNotSaved := True;
          TbfaPreview(Self.Owner).ActiveDoc.Modified_Annos := True;

          AnnoObj := TbfaPreview(Self.Owner).ActiveDoc.GetAnnotation(imgidx, TbfaPreview(Self.Owner).CurrentLayer, idx2);
          if AnnoObj = nil then
          begin
            AnnoObj := TbfaAnnotation.Create;
            AnnoObj.Page := imgidx;
            AnnoObj.Layer := TbfaPreview(Self.Owner).CurrentLayer;
            TbfaPreview(Self.Owner).ActiveDoc.Annotations.Add(AnnoObj);
          end;
          idx2 := img_DocView.GetIndexFromObj(-1);
          SetLength(AnnoObj.ObjList, Length(AnnoObj.ObjList) + 1);
          with AnnoObj.ObjList[High(AnnoObj.ObjList)] do
          begin
            ID := idx2;
            ObjKind := img_DocView.ObjKind[idx2];
            ModifiedType := 0;
            if (img_DocView.ObjKind[idx2] in [iekBOX, iekTEXT, iekMEMO]) then
              ObjText := img_DocView.ObjText[idx2];
            NewText := '';
            Modified := True;
//16.09.2024            Name := ObjKindToStr(img_DocView.ObjTextEditMode);
            Name := ObjKindToStr(img_DocView.ObjTextEditMode, false);
          end;
          CreateThumbnailWithAnno(img_DocView, TbfaPreview(Self.Owner), TbfaPreview(Self.Owner).ActiveDoc);

          {$IFNDEF IMAGEEN1140}  //17.01.2024
          img_DocView.MouseInteractVt := [miPutPolyLine];
          Abort;   // ganz wichtig! sonst wird hiernach TImageEnVect.MouseDown ausgefhrt und
                   // das neue Polygon beginnt genau dort wo das alte aufhren sollte
          {$ENDIF}
        end
        else if (img_DocView.MouseInteractVt = [miObjectSelect]) and ModifieRight then
        begin
          if not gbAnnoNotAccessible then
          begin
            gbAnnoNotSaved := True;
            TbfaPreview(Self.Owner).ActiveDoc.Modified_Annos := True;
            EditSelectedAnno;
            img_DocView.SetFocus;
          end;
          Exit;
        end else
        begin
          if (not (TbfaPreview(Owner).ActiveDoc.InProcess or TbfaPreview(Owner).ActiveDoc.InSaveProcess)) then
          begin
            case bitfarmApp.CurrentView of
              tvkViewer, tvkResub, tvkFavorites:
              begin
                if bitfarmApp.ViewerOptions.EditorOptions.DocNoAction then
                  Exit
                else if bitfarmApp.ViewerOptions.EditorOptions.AutoEditMode then
                begin
                  if (TbfaPreview(Owner).ActiveDoc.ID <> -1) then
                    TbfaPreview(Owner).SkipEditMode;
                end
                // FloatingForms werden eingedockt
                else if TbfaPreview(Owner).Floating then
                begin
                  bitfarmApp.InDockChanged := True;
                  // bfacrm:ticket__show__28944
                  FloatingForm := TForm(TbfaPreview(Owner).Parent.Parent.Parent);
                  try
                    with bitfarmApp.ViewerOptions.GUIOptions do
                    begin
                      StoredFloatingPosX := FloatingForm.Left;
                      StoredFloatingPosY := FloatingForm.Top;
                      StoredFloatingWidth := FloatingForm.Width;
                      StoredFloatingHeight := FloatingForm.Height;
                      StoredFloatingFullScreen := (FloatingForm.WindowState = wsMaximized);
                    end;
                    TbfaPreview(Owner).ShowToolbars(False);
                    FloatingForm.Hide;
//                    TForm(TbfaPreview(Owner).Parent.Parent.Parent).Hide;
                    // bfacrm:ticket__show__28944
                    TSpTBXDockablePanel(Owner.Owner).CurrentDock := frmMainForm.dckDocumentEditors;
                  finally
                    bitfarmApp.InDockChanged := False;
                  end;
                end
                // eigenstndige Tabs
                else if (not TbfaPreview(Owner).Floating) and (Self.Parent.Parent.Parent.Tag > pvtWorkplace) then
                  bitfarmApp.TabDblClick(frmMainform.tstDocumentEditors.ActiveTab)
                // Standard-Tabs
                else
                  TbfaPreview(Owner).OpenDocInNewTab;

                Exit;
              end;

              tvkImporter:
              begin
                // FloatingForms werden eingedockt
                if TbfaPreview(Owner).Floating then
                begin
                  bitfarmApp.InDockChanged := True;
                  // bfacrm:ticket__show__28944
                  FloatingForm := TForm(TbfaPreview(Owner).Parent.Parent.Parent);
                  try
                    with bitfarmApp.ViewerOptions.GUIOptions do
                    begin
                      StoredFloatingPosX := FloatingForm.Left;
                      StoredFloatingPosY := FloatingForm.Top;
                      StoredFloatingWidth := FloatingForm.Width;
                      StoredFloatingHeight := FloatingForm.Height;
                      StoredFloatingFullScreen := (FloatingForm.WindowState = wsMaximized);
                    end;
                    TbfaPreview(Owner).ShowToolbars(False);
                    FloatingForm.Hide;
//                    TForm(TbfaPreview(Owner).Parent.Parent.Parent).Hide;
                    // bfacrm:ticket__show__28944
                    TSpTBXDockablePanel(Owner.Owner).CurrentDock := frmMainForm.dckDocumentEditors;
                  finally
                    bitfarmApp.InDockChanged := False;
                  end;
                end
                // eigenstndige Tabs
                else if (not TbfaPreview(Owner).Floating) and (Self.Parent.Parent.Parent.Tag > pvtWorkplace) then
                  bitfarmApp.TabDblClick(frmMainform.tstDocumentEditors.ActiveTab)
                // Standard-Tabs
                else
                  TbfaPreview(Owner).OpenDocInNewTab;

                Exit;
              end;

              tvkWorkplace:
              begin
                // sollte eigentlich schon beim ffnen in EditMode sein. Nur ergnzend hier
                if bitfarmApp.ViewerOptions.EditorOptions.WorkplaceAutoEditMode then
                begin
                  if (TbfaPreview(Owner).ActiveDoc.ID <> -1) and (not TbfaPreview(Owner).ActiveDoc.InEditMode) then
                    TbfaPreview(Owner).SkipEditMode;
                end;

                // FloatingForms werden eingedockt
                if TbfaPreview(Owner).Floating then
                begin
                  bitfarmApp.InDockChanged := True;
                  // bfacrm:ticket__show__28944
                  FloatingForm := TForm(TbfaPreview(Owner).Parent.Parent.Parent);
                  try
                    with bitfarmApp.ViewerOptions.GUIOptions do
                    begin
                      StoredFloatingPosX := FloatingForm.Left;
                      StoredFloatingPosY := FloatingForm.Top;
                      StoredFloatingWidth := FloatingForm.Width;
                      StoredFloatingHeight := FloatingForm.Height;
                      StoredFloatingFullScreen := (FloatingForm.WindowState = wsMaximized);
                    end;
                    TbfaPreview(Owner).ShowToolbars(False);
                    FloatingForm.Hide;
//                    TForm(TbfaPreview(Owner).Parent.Parent.Parent).Hide;
                    // bfacrm:ticket__show__28944
                    TSpTBXDockablePanel(Owner.Owner).CurrentDock := frmMainForm.dckDocumentEditors;
                  finally
                    bitfarmApp.InDockChanged := False;
                  end;
                end
                // eigenstndige Tabs
                else if (not TbfaPreview(Owner).Floating) and (Self.Parent.Parent.Parent.Tag > pvtWorkplace) then
                  bitfarmApp.TabDblClick(frmMainform.tstDocumentEditors.ActiveTab)
                // Standard-Tabs
                else
                  TbfaPreview(Owner).OpenDocInNewTab;

                Exit;
              end;
            end;
          end;
        end;
      end
      else if (img_DocView.MouseInteractVt = [miPutPolyLine]) and ModifieRight then // Ticket 14802  Linienwerkzeug beenden,
      begin
         Exit;
      end else
      begin
        if not (TbfaPreview(Owner).ActiveDoc.InProcess or TbfaPreview(Owner).ActiveDoc.InSaveProcess) then
        begin
         if Assigned(fOnDblClick) then
           fOnDblClick;
         Abort;
        end;
      end;

      if not ModifieRight then
        ShowMessage(_('Hinweis') + #13 + _('Dieses Dokument drfen Sie nicht verndern.'));
    end;
  except
    on E : Exception do
      // SJ 13.10.2021 bfacrm:ticket__show__28722
      // brauchen wir damit TImageEnVect.MouseDown nicht ausgefhrt wird
      if E.ClassType = EAbort then
        Raise
      else
        bitfarmLog.Write(llNormal, ltException, 'Tfrm_Voransicht.img_DocViewDblClick(Sender: TObject);', ClassName);
  end;
end;

procedure Tfrm_Voransicht.img_DocViewMouseWheel(Sender: TObject;
   Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
   //MF 09-12-17 bug gemeldet von HS mit Zoomen mit Rausrad wenn gerade neue Notiz draufgemacht wurde
  if not fbmouseinim then
   	Abort;

  if img_DocView.ObjTextEditMode = -1 then
    img_DocView.ZoomAt(MousePos.X, MousePos.Y, 0, False)
  else
   	Abort;

end;

procedure Tfrm_Voransicht.img_DocViewImageChange(Sender: TObject);
begin
  if (frmMainform = nil) or (not frmMainform.fAppStarted) then
    Exit;

  fChangeZoomtextNotView := True;
  if Assigned(fCbx_Zoom) then
	  (fCbx_Zoom as TSPTBXComboBox).Text := FloatToStrF(img_DocView.Zoom, ffFixed, 7, 2) + ' %';
  if Assigned(fCbx_MainFormZoom) then
	  (fCbx_MainFormZoom as TSPTBXComboBox).Text := FloatToStrF(img_DocView.Zoom, ffFixed, 7, 2) + ' %';

  fChangeZoomtextNotView := False;
  with img_DocView do
    if (VertScrollBar.IsScrollBarVisible or HorzScrollBar.IsScrollBarVisible) and (MouseInteract = []) then
      MouseInteract := [miScroll];
end;

procedure Tfrm_Voransicht.img_DocViewViewChange(Sender: TObject; Change: integer);
var
  imgcnt : Integer;
begin
   if Change = 1 then
   begin
      fChangeZoomtextNotView := True;
      //13.06.2024 SD -->bfacrm:ticket__show__39017
//      if img_DocView.Zoom < 10.0 then
//          img_DocView.Zoom := 10.0;
      if img_DocView.Zoom < 1.0 then
          img_DocView.Zoom := 1.0;
      //13.06.2024 SD <--bfacrm:ticket__show__39017
      if img_DocView.Zoom > 600.0 then
          img_DocView.Zoom := 600.0;
      if Assigned(fCbx_Zoom) then
	      (fCbx_Zoom as TSPTBXComboBox).Text := FloatToStrF(img_DocView.Zoom, ffFixed, 7, 2) + ' %';
      if Assigned(fCbx_MainFormZoom) then
	      (fCbx_MainFormZoom as TSPTBXComboBox).Text := FloatToStrF(img_DocView.Zoom, ffFixed, 7, 2) + ' %';
      fChangeZoomtextNotView := False;
   end
   else
   begin
      if img_DocView.IsEmpty and (not fAutozoom) then
      begin
//01.07.2016 sonst wird nach Reset immer 10%!         img_DocView.Zoom := 0.1;
         fChangeZoomtextNotView := true;
         if Assigned(fCbx_Zoom) then
	         (fCbx_Zoom as TSPTBXComboBox).Text := '';
         if Assigned(fCbx_MainFormZoom) then
	         (fCbx_MainFormZoom as TSPTBXComboBox).Text := '';
         fChangeZoomtextNotView := false;
      end;
   end;

  if (TbfaPreview(Self.Owner).ActiveDoc <> nil) and
     (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView <> nil) and
     (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolViewLoaded) then
    imgcnt := TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView.ImageCount
  else
    imgcnt := img_DocView.IO.Params.ImageCount;

   if img_DocView.IsEmpty or (imgcnt = 0) then
   	 img_DocView.BackgroundStyle := iebsSolid
   else
   	 img_DocView.BackgroundStyle := iebsCropShadow;
end;

procedure Tfrm_Voransicht.img_DocViewMouseDown(Sender: TObject;
   Button: TMouseButton; Shift: TShiftState; X, Y: integer);
var
  idx :Integer;
begin
  if button = MbMiddle then
  begin
    md_mouseX1 := X;
    md_mousey1 := Y;
  end;

  if ((img_DocView.MouseInteractVt = [miPutBitmap]) and GraphicClipboardStamp) then
    TbfaPreview(Self.Owner).tbiClipboardAsStampClick(nil);
end;

procedure Tfrm_Voransicht.img_DocViewMouseUp(Sender: TObject;
   Button: TMouseButton; Shift: TShiftState; X, Y: integer);
var
  idx, hobj, colobj, i, j, idx2, rights, imgidx, imgwidth, imgheight: Integer;
  lbhcol, found: Boolean;
  A, B: TPolygon; MTD: TVector2f;
  AnnoObj: TbfaAnnotation;
begin
  try
    if (TbfaPreview(Self.Owner).ActiveDoc <> nil) and
       (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView <> nil) and
       (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolViewLoaded) then
    begin
      imgidx := TbfaPreview(Self.Owner).ActivePage;
      imgwidth := img_DocView.Bitmap.Width;
      imgheight := img_DocView.Bitmap.Height;
    end else
    begin
      imgidx := img_DocView.IO.Params.ImageIndex;
      imgwidth := img_DocView.IO.Params.Width;
      imgheight := img_DocView.IO.Params.Height;
    end;

    if Button = mbMiddle then
    begin
      img_DocView.Select(md_mouseX1, md_mousey1, x, y);
      img_DocView.ZoomSelection(True);
    end;

    if ((img_DocView.MouseInteractVt = [miPutPolyLine]) and
        fEndPolylineOnMouseUp) then
    begin
      img_DocView.CancelInteracts;
      createannodata(img_DocView.ObjHeapCount -1);
//06.10.2021      img_DocView.BitmapResampleFilter := rfLinear;
      img_DocView.BitmapResampleFilter := rfFastLinear;
      if fAnnoType = 0 then
        fHistoryNew.Add(Format( _('Neue Anmerkungen (%s) auf Seite %s'),
          [ObjKindToStr(img_DocView.ObjHeapCount - 1),
          inttostr(imgidx + 1)]));
      gbAnnoNotSaved := True;
      TbfaPreview(Self.Owner).ActiveDoc.Modified_Annos := True;

      AnnoObj := TbfaPreview(Self.Owner).ActiveDoc.GetAnnotation(
        imgidx, TbfaPreview(Self.Owner).CurrentLayer, idx2);

      if AnnoObj = nil then
      begin
        AnnoObj := TbfaAnnotation.Create;
        AnnoObj.Page := imgidx;
        AnnoObj.Layer := TbfaPreview(Self.Owner).CurrentLayer;
        TbfaPreview(Self.Owner).ActiveDoc.Annotations.Add(AnnoObj);
      end;

      idx2 := img_DocView.GetIndexFromObj(-1);
      SetLength(AnnoObj.ObjList, Length(AnnoObj.ObjList) + 1);

      with AnnoObj.ObjList[High(AnnoObj.ObjList)] do
      begin
        ID := idx2;
        ObjKind := img_DocView.ObjKind[idx2];
        ModifiedType := 0;
        if (img_DocView.ObjKind[idx2] in [iekBOX, iekTEXT, iekMEMO]) then
          ObjText := img_DocView.ObjText[idx2];

        NewText := '';
//16.09.2024        Name := ObjKindToStr(img_DocView.ObjHeapCount - 1);
        Name := ObjKindToStr(img_DocView.ObjHeapCount - 1, false);
        Modified := True;
      end;

      CreateThumbnailWithAnno(img_DocView, TbfaPreview(Self.Owner),
        TbfaPreview(Self.Owner).ActiveDoc);
    end;

    if fObjectMoved and (img_DocView.ObjectsCount > 1) then
    begin
      SetObjectPosition;
//      hobj := img_DocView.SelObjects[0];
//      B := nil;
//      A := nil;
//
//      TbfaPreview(Self.Owner).ActiveDoc.GetAnnotation(imgidx, TbfaPreview(Self.Owner).CurrentLayer, idx2);
//      if idx2 <> -1 then
//        rights := TbfaPreview(Self.Owner).ActiveDoc.Annotations[idx2].Rights
//      else
//        rights := TbfaPreview(Self.Owner).ActiveDoc.Rights;
//
//      if (((img_DocView.ObjKind[hobj] <> iekLINE) and
//           (img_DocView.ObjBrushStyle[hobj] <> bsClear)) or
//          ((img_DocView.ObjKind[hobj] = iekBox) and
//           (img_DocView.ObjBoxHighLight[hobj])) or
//          (img_DocView.ObjKind[hobj] = iekMEMO))
//         and
//         (not (((rights and rightAModify) = rightAModify) or
//           ((rights and rightAPModify) = rightAPModify))) then
//      begin
//        try
//          A := TPolygon.Create;
//          with A do
//          begin
//            position := to_v2f(img_DocView.ObjLeft[hobj], img_DocView.ObjTop[hobj]);
//            AddVertex(to_v2f(0, 0));
//            AddVertex(to_v2f(img_DocView.ObjWidth[hobj], 0));
//            AddVertex(to_v2f(img_DocView.ObjWidth[hobj], img_DocView.ObjHeight[hobj]));
//            AddVertex(to_v2f(0, img_DocView.ObjHeight[hobj]));
//          end;
//
//          i := 0;
//          j := 0;
//          while i < img_DocView.ObjectsCount do
//          begin
//            colobj := img_DocView.GetObjFromIndex(i);
//            if colobj = hobj then
//            begin
//              i := i + 1;
//              Continue;
//            end;
//
//            B := TPolygon.Create;
//            with B do
//            begin
//              position := to_v2f(img_DocView.ObjLeft[colobj], img_DocView.ObjTop[colobj]);
//              AddVertex(to_v2f(0, 0));
//              AddVertex(to_v2f(img_DocView.ObjWidth[colobj], 0));
//              AddVertex(to_v2f(img_DocView.ObjWidth[colobj], img_DocView.ObjHeight[colobj]));
//              AddVertex(to_v2f(0, img_DocView.ObjHeight[colobj]));
//            end;
//            i := i + 1;
//
//            if PolyPolyIntersect(a, b, MTD) and ((MTD.x <> 0) or (MTD.y <> 0)) then
//            begin
//              lbhcol := true;
//
//              while PolyPolyIntersect(a, b, MTD) and ((MTD.x <> 0) or (MTD.y <> 0)) do
//              begin
//                if (MTD.x = 0) and (MTD.y = 0) then
//                begin
//                  MTD.x := -1;
//                  MTD.y := -1;
//                end
//                else
//                begin
//                  MTD := v2f_Scale(MTD, (1.05));
//                end;
//                a.position := v2f_add(a.position, MTD);
//              end;
//
//              img_DocView.ObjLeft[hobj] := trunc(a.position.x);
//              img_DocView.ObjTop[hobj] := trunc(a.position.y);
//
//              if img_DocView.ObjLeft[hobj] + img_DocView.ObjWidth[hobj] > imgWidth then
//                img_DocView.ObjLeft[hobj] := Trunc(b.Position.X) - img_DocView.ObjWidth[hobj];
//              if img_DocView.ObjTop[hobj] + img_DocView.ObjHeight[hobj] > imgHeight then
//                img_DocView.ObjTop[hobj] := Trunc(b.Position.Y) - img_DocView.ObjHeight[hobj];
//
//              if img_DocView.ObjLeft[hobj] < 0 then // mit Rand kollidiert ;-)
//                img_DocView.ObjLeft[hobj] := Trunc(b.Position.X) + Trunc(b.Vertices[2].X);
//
//              if img_DocView.ObjTop[hobj] < 0 then
//                img_DocView.ObjTop[hobj] := Trunc(b.Position.Y) + Trunc(b.Vertices[2].Y);
//
//              A := nil;
//              A := TPolygon.Create;
//              with A do
//              begin
//                position := to_v2f(img_DocView.ObjLeft[hobj], img_DocView.ObjTop[hobj]);
//                AddVertex(to_v2f(0, 0));
//                AddVertex(to_v2f(img_DocView.ObjWidth[hobj], 0));
//                AddVertex(to_v2f(img_DocView.ObjWidth[hobj], img_DocView.ObjHeight[hobj]));
//                AddVertex(to_v2f(0, img_DocView.ObjHeight[hobj]));
//              end;
//            end;
//
//            if lbhcol then
//            begin
//              i := 0;
//              j := j + 1;
//              if j > 50 then
//              begin
//                Break;
//              end;
//              lbhcol := false;
//            end;
//            if assigned(b) then
//              FreeAndNil(b);
//          end;
//
//          if lbhcol or ((img_DocView.ObjLeft[hobj] < 0) or (img_DocView.ObjTop[hobj] < 0) or
//              (img_DocView.ObjLeft[hobj] + img_DocView.ObjWidth[hobj] > imgWidth) or
//              (img_DocView.ObjTop[hobj] + img_DocView.ObjHeight[hobj] > imgHeight))then
//          begin
//            img_DocView.ObjLeft[hobj] := fStartPos.X;
//            img_DocView.ObjTop[hobj] := fStartPos.Y;
//            img_DocView.ObjWidth[hobj] := fObjWidth;
//            img_DocView.ObjHeight[hobj] := fObjHeight;
//            Exit;
//          end;
//        finally
//          begin
//            if assigned(A) then
//              FreeAndNil(A);
//            if assigned(B) then
//              FreeAndNil(B);
//          end;
//        end;
//      end;
//      fStartPos.X := img_DocView.ObjLeft[hobj];
//      fStartPos.y := img_DocView.ObjTop[hobj];
//      fObjWidth := img_DocView.ObjWidth[hobj];
//      fObjHeight := img_DocView.ObjHeight[hobj];
    end;

    if fObjectMoved and (img_DocView.ObjectsCount > 0) then
      saveannostream;

    fObjectMoved := False;

    if (img_DocView.MouseInteract = [miSelect]) and
       (img_DocView.Selected) and
       (img_DocView.SelectionAbsWidth > 0) and
       (img_DocView.SelectionAbsHeight > 0) and (Button = mbLeft) then
    begin
      if Assigned(fOnMouseUpSelection) then
        fOnMouseUpSelection;
    end;

    // SJ 22.06.2022 - man konnte Annos auf die man keine Rechte hatte selektieren
    // (bei Multiselect) und dann verschieben oder Gre ndern.
    // Grund scheinbar dass hobj sich bei deselect ndert. Jetzt via SelObjectsCount downto
    if img_DocView.SelObjectsCount > 0 then
    begin
      img_DocView.LockPaint;
      try
        for idx := img_DocView.SelObjectsCount - 1 downto 0 do
        begin
          hobj := img_DocView.SelObjects[idx];
          if img_DocView.ObjUserData[hobj] <> nil then
          begin
            TbfaPreview(Self.Owner).ActiveDoc.GetAnnotation(imgidx, TbfaPreview(Self.Owner).CurrentLayer, idx2);
            if idx2 <> -1 then
              rights := TbfaPreview(Self.Owner).ActiveDoc.Annotations[idx2].Rights
            else
              rights := TbfaPreview(Self.Owner).ActiveDoc.Rights;

            if (
                 (bitfarmApp.User.Name <> PAnnoData(img_DocView.ObjUserData[hobj])^.Ersteller)
                 and
                 (
                   (not ((rights and rightAModify) = rightAModify))
                   and
                   (not ((rights and rightAPModify) = rightAPModify))
                 )
               )
            then
            begin
              img_DocView.UnSelObject(hobj);
            end;
          end;
        end;
      finally
        img_DocView.UnLockPaint;
      end;
    end;

//    for idx := 0 to img_DocView.ObjectsCount - 1 do
//    begin
//      hobj := img_DocView.GetObjFromIndex(idx);
//      if img_DocView.ObjUserData[hobj] <> nil then
//      begin
//        TbfaPreview(Self.Owner).ActiveDoc.GetAnnotation(imgidx, TbfaPreview(Self.Owner).CurrentLayer, idx2);
//
//        if idx2 <> -1 then
//          rights := TbfaPreview(Self.Owner).ActiveDoc.Annotations[idx2].Rights
//        else
//          rights := TbfaPreview(Self.Owner).ActiveDoc.Rights;
//
//        if (
//             (bitfarmApp.User.Name <> PAnnoData(img_DocView.ObjUserData[hobj])^.Ersteller)
//             and
//             (
//               (not ((rights and rightAModify) = rightAModify))
//               and
//               (not ((rights and rightAPModify) = rightAPModify))
//             )
//           )
//        then
//          img_DocView.UnSelObject(hobj);
//      end;
//    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'img_DocViewMouseUp', ClassName);
  end;
end;

procedure Tfrm_Voransicht.img_DocViewNewObject(Sender: TObject; hobj: Integer);
var
  A, B: TPolygon;
  i, colobj, idx, idx2, rights, imgidx, ImgX, ImgY: Integer;
  MTD: TVector2f;
  lbinter, loopbreak, setStatefieldError, setStatefieldRightsError,
  MandatoryAddfieldsError: Boolean;
  AnnoObj: TbfaAnnotation;
  sDate, sTime, sDay, sMonth, sYear, sHour, sMinute, sSecond, ls: String;
  dtNow : TDateTime;
  MySettings: TFormatSettings;
  initialText: WideString;
  //29.02.2024 bfacrm:ticket__show__33962 -->
  AddfieldCompText: string;
  MatchCollection: TMatchCollection;
  Match: TMatch;
  //29.02.2024 bfacrm:ticket__show__33962 <--
begin
  fTextAnnoCreated := False;	//zurcksetzen bei jeder neuen Anno
  if Assigned(fOnNewObject) then
    fOnNewObject;
  fobjdel := False;
  img_DocView.ObjEditOnNewText := True;
  try
    initialText := img_DocView.ObjText[hobj];
    loopbreak := False;
    setStatefieldError := False;
    A := nil;
    B := nil;

    DateTimeToString(sDate, 'dd.mm.yyyy', Now);
    DateTimeToString(sTime, 'hh:nn:ss', Now);
    DateTimeToString(sDay, 'dd', Now);
    DateTimeToString(sMonth, 'mm', Now);
    DateTimeToString(sYear, 'yyyy', Now);
    DateTimeToString(sHour, 'hh', Now);
    DateTimeToString(sMinute, 'nn', Now);
    DateTimeToString(sSecond, 'ss', Now);

    ls := GetCurrentLanguage;
    if Copy(ls,0,2) = 'en' then
    begin
      dtNow := Now();
      GetLocaleFormatSettings(GetUserDefaultLCID, MySettings);
      MySettings.ShortDateFormat := 'MM.dd.yyyy';
      MySettings.DateSeparator := '/';
      sDate := FormatDateTime('MM/dd/yyyy', dtNow, MySettings);
    end;

    if (TbfaPreview(Self.Owner).ActiveDoc <> nil) and
       (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView <> nil) and
       (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolViewLoaded)
    then
      imgidx := TbfaPreview(Self.Owner).ActivePage
    else
      imgidx := img_DocView.IO.Params.ImageIndex;

    try
      try
        if (img_DocView.ObjKind[hobj] in [iekMEMO]) and img_DocView.ObjTextAutoSize[hobj] and
           (img_DocView.ObjWidth[hobj] = bitfarmApp.LastAnnoDefaultWidth) and
           (img_DocView.ObjHeight[hobj] = bitfarmApp.LastAnnoDefaultHeight)
        then
          ObjektAnTextAnpassen(hobj, img_DocView.ObjTextAutoSize[hobj]);

        // Stempel setzt Statusfeld?
        if (img_DocView.ObjKind[hobj] in [iekMEMO, iekBITMAP]) and
           (TbfaPreview(Self.Owner).StampStatefield > 0) then
        begin
          // Fehlermeldung wird erst im finally ausgegeben,
          // weil sonst der StringReplace noch nicht stattgefunden hat
          var found: Boolean;
          var stateid: Integer;
          found := False;
          setStatefieldRightsError := False;

          for I := 0 to aCurrentStatefields.Count - 1 do
          begin
            if aCurrentStatefields[I].ID = TbfaPreview(Self.Owner).StampStatefield then
            begin
              found := True;
              aCurrentStatefields[I].Component.SetValueAsClick(fsSet);
              aCurrentStatefields[I].Component.Modified := True;
              aCurrentStatefields[I].Modified := True;
              stateid := aCurrentStatefields[I].ID;
              Break;
            end;
          end;
          if not found then
            setStatefieldError := True
          else if found and (stateid > 0) then
          begin
            //07.08.2024 SD -->bfacrm:ticket__show__39555
//            if not (((aStateFieldRights[stateid] and rightWrite) = rightWrite) or
//                    ((aStateFieldRights[stateid] and rightModify) = rightModify))
            if not (((aStateFieldRights[stateid] and rFieldWrite) = rFieldWrite) or
                    ((aStateFieldRights[stateid] and rFieldModify) = rFieldModify))
            //07.08.2024 SD <--bfacrm:ticket__show__39555
            then
              setStatefieldRightsError := True;
          end;
          if setStatefieldRightsError or setStatefieldError then
          begin
            img_DocView.DeSelect;
            img_DocView.CancelInteracts;
            img_DocView.UnSelObject(hobj);
            img_DocView.RemoveObject(hobj);
            img_DocView.ObjEditOnNewText := False;
            fobjdel := True;
            Exit;
          end;
        end;

        {$IFDEF ENTERPRISE}
        if Assigned(OnPluginExecuteOnStamp) and (VirtualPluginMenuItem <> nil) and
          (Self.Owner is TbfaPreview) and Assigned(aCurrentAddfields) and Assigned(bitfarmApp) then
        begin
          MandatoryAddfieldsError := not bitfarmApp.AllowedToLeaveCurrentDocs(True, False);
          if MandatoryAddfieldsError then
          begin
            img_DocView.DeSelect;
            img_DocView.CancelInteracts;
            img_DocView.UnSelObject(hobj);
            img_DocView.RemoveObject(hobj);
            img_DocView.ObjEditOnNewText := False;
            fobjdel := True;
            Exit;
          end;
        end;
      {$ENDIF}

      except
        setStatefieldError := True;
        bitfarmLog.Write(llNormal, ltException, 'img_DocViewNewObject - StampStatefield', ClassName);
        Exit;
      end;

    finally
        if setStatefieldError and (TbfaPreview(Self.Owner).StampStatefield <> -1) and
           (aStatefields[TbfaPreview(Self.Owner).StampStatefield] = nil) then
        begin
          BfShowMessage(_('Stempel kann nicht aufgebracht werden.')+#13#10+_('Statusfeld nicht gefunden.'));
          Abort;
        end;

      if setStatefieldError then
        BfShowMessage(Format(_('Stempel kann nicht aufgebracht werden.')+#13#10+_('Statusfeld "%s" konnte nicht gesetzt werden.'), [aStatefields[TbfaPreview(Self.Owner).StampStatefield].Displayname]));

      if setStatefieldRightsError then
        BfShowMessage(Format(_('Stempel kann nicht aufgebracht werden.')+#13#10+_('Keine Berechtigungen zum ndern auf Statusfeld "%s".'), [aStatefields[TbfaPreview(Self.Owner).StampStatefield].Displayname]));

      if MandatoryAddfieldsError then
        BfShowMessage(_('Plugin-Stempel konnte nicht aufgebracht werden.')+#13#10+#13#10+
                      _('Sie mssen erst die Pflichtfelder ausfllen.') + #13#10 +
                      _('Pflichtfelder haben einen fetten Bezeichner bzw. sind hell-orange hinterlegt.'));

      if setStatefieldError or setStatefieldRightsError or MandatoryAddfieldsError then
        Abort;
    end;

    if posex('%clipboard%', Lowercase(img_DocView.ObjText[hobj]), 1) > 0 then
    begin
      if Clipboard.HasFormat(CF_TEXT) then
        img_DocView.ObjText[hobj] := StringReplace(img_DocView.ObjText[hobj], '%clipboard%', Clipboard.AsText, [rfReplaceAll,rfIgnoreCase])
      else
        img_DocView.ObjText[hobj] := StringReplace(img_DocView.ObjText[hobj], '%clipboard%', '', [rfReplaceAll,rfIgnoreCase]);
    end;

    // SJ: neue Stempelvariable %add_x%
    try
//29.02.2024 bfacrm:ticket__show__33962     var MatchCollection: TMatchCollection;
//29.02.2024 bfacrm:ticket__show__33962     var Match: TMatch;
      MatchCollection := TRegEx.Matches(Lowercase(img_DocView.ObjText[hobj]), '%(add_\d+)%');

      for Match in MatchCollection do
      begin
        // Match.Groups[0].Value = %add_123% // for replace
        // Match.Groups[1].Value = add_123 // for comparing with current Addfield Name
//29.02.2024 bfacrm:ticket__show__33962       var AddfieldCompText: String;
        AddfieldCompText := '';

          if (aCurrentAddfields.Count > 0) then
          begin
            for I := 0 to aCurrentAddfields.Count - 1 do
              if (Match.Groups.Count > 1) and (Match.Groups[1].Value = aCurrentAddfields[I].Name) then
              begin
                AddfieldCompText := TEdit(aCurrentAddfields[I].Component.comp).Text;
                Break;
              end;
          end;

        img_DocView.ObjText[hobj] := StringReplace(img_DocView.ObjText[hobj],
          Match.Groups[0].Value, AddfieldCompText, [rfReplaceAll,rfIgnoreCase]);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'img_DocViewNewObject - replace %add_%', ClassName);
    end;

    if PosEx('%F', img_DocView.ObjText[hobj], 1) > 0 then
    begin
      try
//29.02.2024 bfacrm:ticket__show__33962       var Match: TMatch;
//29.02.2024 bfacrm:ticket__show__33962       var AddfieldCompText: string;
        while TRegEx.IsMatch(Lowercase(img_DocView.ObjText[hobj]), '%f(\d+)%?') do
        begin
          // Match.Groups[0].Value = %Fx // for replace
          // Match.Groups[1].Value = x in %Fx // for current Addfield Value
//29.02.2024 bfacrm:ticket__show__33962       var AddfieldCompText: String;
          AddfieldCompText := '';
          Match := TRegEx.Match(Lowercase(img_DocView.ObjText[hobj]), '%f(\d+)%?');
          if (StrToInt(Match.Groups[1].Value) > 0) and (StrToInt(Match.Groups[1].Value) < aCurrentAddfields.Count) then
            AddfieldCompText := TEdit(aCurrentAddfields[StrToInt(Match.Groups[1].Value)-1].Component.comp).Text;

          // Kein rfReplaceAll
          // sonst werden auch Teilbereiche ersetzt (zB %F1 von %F10)
          img_DocView.ObjText[hobj] := StringReplace(img_DocView.ObjText[hobj], Match.Groups[0].Value, AddfieldCompText, [rfIgnoreCase]);
        end;
      except
        bitfarmLog.Write(llNormal, ltException, 'img_DocViewNewObject - replace %Fx / %Fx%', ClassName);
      end;


// //   <!---- SJ 23.08.2021: Die alte Methode fr %Fx - ersetzt durch RegEx-Methode
//      var lbfin: Boolean;
//      var lszusnr, sValue: string;
//      var lstPos: TStringList;
//      var lizus, liposzus, liposzus1, liposzus2: Integer;
//      lbfin := False;
//      lizus := 0;
//
//      if aCurrentAddfields.Count > 0 then
//      begin
//        lstPos := TStringList.Create;
//
//        for i := 0 to aCurrentAddfields.Count - 1 do
//        begin
//          lstPos.Add(IntToStr(aCurrentAddfields[i].ID));
//        end;
//      end
//      else
//        lbfin := True;   // keine Felder, dann braucht man auch nicht mappen
//
//      liposzus := 0;
//      while not lbfin do
//      begin
//        liposzus2 := PosEx('%F', img_DocView.ObjText[hobj], liposzus + 1);
//        if liposzus2 > 0 then
//        begin
//          if (liposzus > liposzus2) then
//            Break;
//          liposzus1 := liposzus2;
//          while (copy(img_DocView.ObjText[hobj], liposzus1, 1) <> ' ') and
//                (copy(img_DocView.ObjText[hobj], liposzus1, 2) <> '\n') and
//                (length(img_DocView.ObjText[hobj]) >= liposzus1) do
//          begin
//            liposzus1 := liposzus1 + 1;
//          end;
//
//          lszusnr := copy(img_DocView.ObjText[hobj], liposzus2 + 2, liposzus1 - liposzus2 - 2);    // Nr %F2
//          try
//            lizus := StrToInt(lszusnr);
//          except
//            on e: Exception do
//            begin
//              lizus := -1;
//            end;
//          end;
//
//          if lizus > -1 then
//          begin
//            if lizus <= lstPos.Count then
//            begin
//              for i := 0 to aCurrentAddfields.Count - 1 do
//              begin
//                if IntToStr(aCurrentAddfields[i].ID) = lstPos[lizus -1] then
//                begin
// //                  // Ticket 16363 Bei Null, wird Variable nicht ausgefllt
// //                  sValue := VarToStrDef(bitfarmApp.CurrentContainer[0].AddFields[i].Value, '');
//                  sValue := TEdit(aCurrentAddfields[i].Component.comp).Text;
//
//                 // Kein rfReplaceAll
//                 // Erklrung: Da die Prozedur eh alle %Fx findet und durchgeht,
//                 // mssen wir immer nur das erste ersetzen, dass er findet
//                 // Andernfalls, ersezt %F2 auch einen Teil von %F20 wegen dem rfReplaceAll (Ticket 14198)
//                  img_DocView.ObjText[hobj] := StringReplace(img_DocView.ObjText[hobj], '%F' + lszusnr, sValue, [rfIgnoreCase]);
//                end;
//              end;
//            end;
//          end;
//        end;
//
//        liposzus := liposzus2;
//        if (length(img_DocView.ObjText[hobj]) <= liposzus) or (liposzus2 = 0) then
//          lbfin := True;
//      end;
// //   SJ 23.08.2021: Die alte Methode fr %Fx - ersetzt durch RegEx-Methode ---->
    end;

    img_DocView.ObjText[hobj] := StringReplace(img_DocView.ObjText[hobj], '%D', sDate, [rfReplaceAll,rfIgnoreCase]);
    img_DocView.ObjText[hobj] := StringReplace(img_DocView.ObjText[hobj], '%Z', sTime, [rfReplaceAll,rfIgnoreCase]);
    img_DocView.ObjText[hobj] := StringReplace(img_DocView.ObjText[hobj], '%T', sDay, [rfReplaceAll,rfIgnoreCase]);
    img_DocView.ObjText[hobj] := StringReplace(img_DocView.ObjText[hobj], '%M', sMonth, [rfReplaceAll,rfIgnoreCase]);
    img_DocView.ObjText[hobj] := StringReplace(img_DocView.ObjText[hobj], '%J', sYear, [rfReplaceAll,rfIgnoreCase]);
    img_DocView.ObjText[hobj] := StringReplace(img_DocView.ObjText[hobj], '%H', sHour, [rfReplaceAll,rfIgnoreCase]);
    img_DocView.ObjText[hobj] := StringReplace(img_DocView.ObjText[hobj], '%N', sMinute, [rfReplaceAll,rfIgnoreCase]);
    img_DocView.ObjText[hobj] := StringReplace(img_DocView.ObjText[hobj], '%S', sSecond, [rfReplaceAll,rfIgnoreCase]);
    img_DocView.ObjText[hobj] := StringReplace(img_DocView.ObjText[hobj], '\n\r', #13#10, [rfReplaceAll,rfIgnoreCase]);
    img_DocView.ObjText[hobj] := StringReplace(img_DocView.ObjText[hobj], '%GDOCID', IntToStr(bitfarmApp.CurrentContainer[0].ID), [rfReplaceAll,rfIgnoreCase]); //11.06.2018 Ticket 14728
    img_DocView.ObjText[hobj] := StringReplace(img_DocView.ObjText[hobj], '%U', bitfarmApp.User.Name, [rfReplaceAll,rfIgnoreCase]);
    img_DocView.ObjText[hobj] := StringReplace(img_DocView.ObjText[hobj], '%A', bitfarmApp.User.DisplayName, [rfReplaceAll,rfIgnoreCase]);

    if (img_DocView.ObjKind[hobj] in [iekMEMO, iekTEXT {SJ 08.08.23}]) and img_DocView.ObjTextAutoSize[hobj] then
    begin
      var splittext: string;
      var memo2: TStringList;

      memo2 := TStringList.Create;
      splittext := img_DocView.ObjText[hobj];

//      while Pos(#13#10,splittext) > 0 do
//      begin
//        memo2.Add(LeftStr(splittext,Pos(#13#10,splittext)));
//        splittext := RightStr(splittext,Length(splittext) - Pos(#13#10,splittext)-1);
//      end;
//
//      if splittext <> '' then
//        memo2.Add(splittext);
      splittext := StringReplace(splittext, '\n\r', #13#10, [rfReplaceAll,rfIgnoreCase]);
      memo2 := StrToWordsLF(splittext);

//      textanObjektpassen(memo2, hobj);
    end;

    if ((ievsSizeable in img_DocView.ObjStyle[hobj]) or (img_DocView.ObjKind[hobj] in [iekBOX, iekMEMO, iekTEXT {SJ 08.08.23}])) and
       (img_DocView.ObjKind[hobj] <> iekLINE) and (not img_DocView.ObjTextAutoSize[hobj]) then
    begin
      if ((TbfaPreview(Owner).tbi_fav1.Checked or TbfaPreview(Owner).tbi_fav2.Checked or
           TbfaPreview(Owner).tbi_fav3.Checked or TbfaPreview(Owner).tbi_fav4.Checked or
           TbfaPreview(Owner).tbi_fav5.Checked or TbfaPreview(Owner).tbi_fav6.Checked or
           TbfaPreview(Owner).tbi_fav7.Checked or TbfaPreview(Owner).tbi_fav8.Checked or
           TbfaPreview(Owner).tbi_fav9.Checked or TbfaPreview(Owner).tbi_fav10.Checked) and
          ((FStampWidth <> -1) and (FStampHeight <> -1)) and (not GraphicClipboardStamp)) then
      begin
        if img_DocView.ObjWidth[hobj] <> FStampWidth then
          img_DocView.ObjWidth[hobj] := FStampWidth;
        if img_DocView.ObjHeight[hobj] <> FStampHeight then
          img_DocView.ObjHeight[hobj] := FStampHeight;
      end
      else
//25.10.2017 beim Marker hatte auch angepasst sollte aber nicht sein -->
      if (not TbfaPreview(Owner).tbsub_highlight.Checked) and
         (not TbfaPreview(Owner).tbi_highlite1.Checked) and
         (not TbfaPreview(Owner).tbi_highlite2.Checked) and
         (not TbfaPreview(Owner).tbi_highlite3.Checked) and
         (not TbfaPreview(Owner).tbi_highlite4.Checked) and
         (not TbfaPreview(Owner).tbi_highlite5.Checked) then
//25.10.2017 beim Marker hatte auch angepasst sollte aber nicht sein <--
      begin
        if img_DocView.ObjWidth[hobj] < 70 then
          img_DocView.ObjWidth[hobj] := 70;
        if img_DocView.ObjHeight[hobj] < 70 then
          img_DocView.ObjHeight[hobj] := 70;
      end;
    end;

    // <!-- SJ 01.03.2023: nach unten verschoben. Muss nach ObjektAnTextAnpassen / textanObjektpassen sein
//    // bei Grafikstempeln (aus der Zwischenablage) setzen wir die Grafik so gro,
//    // wie noch Platz bis zum Ende des Dokuments ist.
//    // Das Verhltnis Width:Height behalten wir bei
//    if (img_DocView.ObjKind[hobj] = iekBITMAP) and GraphicClipboardStamp then
//    begin
//      var scale: Real;
//      scale := 1;
//
//      // fr den Fall dass zu breit
//      if img_DocView.ObjLeft[hobj] + img_DocView.ObjWidth[hobj] > img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Width then
//      begin
//        scale := (img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Width - img_DocView.ObjLeft[hobj]) / img_DocView.ObjWidth[hobj];
//        img_DocView.ObjWidth[hobj] := Round(img_DocView.ObjWidth[hobj] * scale);
//        img_DocView.ObjHeight[hobj] := Round(img_DocView.ObjHeight[hobj] * scale);
//      end;
//
//      // wenn es dann auch noch zu hoch ist
//      if img_DocView.ObjTop[hobj] + img_DocView.ObjHeight[hobj] > img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Height then
//      begin
//        scale := (img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Height - img_DocView.ObjTop[hobj]) / img_DocView.ObjHeight[hobj];
//        img_DocView.ObjWidth[hobj] := Round(img_DocView.ObjWidth[hobj] * scale);
//        img_DocView.ObjHeight[hobj] := Round(img_DocView.ObjHeight[hobj] * scale);
//      end;
//    end else if (img_DocView.ObjKind[hobj] <> iekLINE) then
//    begin
//    // bei anderen Stempeln setzen wir die Anno weiter nach links, wenn es ber
//    // den Dokumentenrand hinaus gehen wrde. Oder weiter nach oben.
//      if img_DocView.ObjWidth[hobj] > img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Width then
//        img_DocView.ObjWidth[hobj] := img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Width;
//      if img_DocView.ObjHeight[hobj] > img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Height then
//        img_DocView.ObjHeight[hobj] := img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Height;
//
//      if img_DocView.ObjLeft[hobj] + img_DocView.ObjWidth[hobj] > img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Width then
//        img_DocView.ObjLeft[hobj] := img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Width - img_DocView.ObjWidth[hobj] - 1;
//      if img_DocView.ObjTop[hobj] + img_DocView.ObjHeight[hobj] > img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Height then
//        img_DocView.ObjTop[hobj] := img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Height - img_DocView.ObjTop[hobj] - 1;
//    end;
//
//    // zu weit links?
//    if img_DocView.ObjLeft[hobj] < 0 then
//      img_DocView.ObjLeft[hobj] := 0;
//
//    // zu weit oben?
//    if img_DocView.ObjTop[hobj] < 0 then
//      img_DocView.ObjTop[hobj] := 0;
  // SJ 01.03.2023 -->

//    if ((img_DocView.ObjBrushStyle[hobj] <> bsClear) and (img_DocView.ObjKind[hobj] <> iekLine))
//       or
//       ((img_DocView.ObjKind[hobj] = iekBOX) and (img_DocView.ObjBoxHighLight[hobj]))
//       or
//       ((img_DocView.ObjBrushStyle[hobj] <> bsClear) and (img_DocView.ObjKind[hobj] = iekMEMO)) then
//    begin
//      TbfaPreview(Self.Owner).ActiveDoc.GetAnnotation(imgidx, TbfaPreview(Self.Owner).CurrentLayer, idx2);
//      if idx2 <> -1 then
//        rights := TbfaPreview(Self.Owner).ActiveDoc.Annotations[idx2].Rights
//      else
//        rights := TbfaPreview(Self.Owner).ActiveDoc.Rights;
//
//      if (TbfaPreview(Self.Owner).ActiveDoc.ID <> -1) and
//         (not (((rights and rightAModify) = rightAModify) or
//              ((rights and rightAPModify) = rightAPModify))) then
//      begin
//        A := TPolygon.Create;
//        with A do
//        begin
//          position := to_v2f(img_DocView.ObjLeft[hobj], img_DocView.ObjTop[hobj]);
//          AddVertex(to_v2f(0, 0));
//          AddVertex(to_v2f(img_DocView.ObjWidth[hobj], 0));
//          AddVertex(to_v2f(img_DocView.ObjWidth[hobj], img_DocView.ObjHeight[hobj]));
//          AddVertex(to_v2f(0, img_DocView.ObjHeight[hobj]));
//        end;
//        i := 0;
//        loopbreak := False;
//        while i < img_DocView.ObjectsCount do
//        begin
//          colobj := img_DocView.GetObjFromIndex(i);
//          if colobj = hobj then
//          begin
//            i := i + 1;
//            Continue;
//          end;
//          B := TPolygon.Create;
//          with B do
//          begin
//            position := to_v2f(img_DocView.ObjLeft[colobj], img_DocView.ObjTop[colobj]);
//            AddVertex(to_v2f(0, 0));
//            AddVertex(to_v2f(img_DocView.ObjWidth[colobj], 0));
//            AddVertex(to_v2f(img_DocView.ObjWidth[colobj], img_DocView.ObjHeight[colobj]));
//            AddVertex(to_v2f(0, img_DocView.ObjHeight[colobj]));
//          end;
//          i := i + 1;
//          lbinter := False;
//          loopbreak := False;
//          if PolyPolyIntersect(A, B, MTD) then
//          begin
//            img_DocView.DeSelect;
//            img_DocView.CancelInteracts;
//            img_DocView.RemoveObject(hobj);
//            fobjdel := True;
//
//            //22.06.2021 Ticket 27675 -->
//            BfMessageDialogWithCheckBox(_('Hinweis'),
//                            _('Platzieren Sie bitte die Notiz auf eine freie Stelle!'),
//                            mtWarning, [mbOK], [_('OK')], True, bitfarmApp.ViewerOptions,
//                                  'PlaceAnno');
//            //BfShowMessage(_('Platzieren Sie bitte die Notiz auf eine freie Stelle!'));
//            //22.06.2021 Ticket 27675 <--
//            img_DocView.UnSelAllObjects;
//            img_DocView.ObjEditOnNewText := False;
//            if Assigned(A) then
//              FreeAndNil(A);
//            if Assigned(B) then
//              FreeAndNil(B);
//            Abort;
//          end;
//
//          if loopbreak then
//          begin
//            img_DocView.RemoveObject(hobj);
//            Break;
//          end;
//          if lbinter then
//          begin
//            img_DocView.ObjTop[hobj] := Round(A.position.y);
//            img_DocView.ObjLeft[hobj] := Round(A.position.x);
//          end;
//
//          if Assigned(B) then
//            FreeAndNil(B);
//        end;
//      end;
//      if not loopbreak then
//      begin
//        createannodata(hobj);
//        img_DocView.ObjEditOnNewText := True;
//      end
//      else
//      begin
//        ShowMessage(_('Die Notiz konnte nicht auf eine freie Stelle platziert werden.'));
//        Exit;
//      end;
//    end else
//    begin
//      createannodata(hobj);
//
//      if img_DocView.ObjKind[hobj] <> iekBITMAP then
//	      img_DocView.ObjEditOnNewText := True;
//    end;

    if (img_DocView.ObjBrushStyle[hobj] = bsClear) or
       (img_DocView.ObjKind[hobj] = iekLine)
    then
   		img_DocView.SetObjFrontOf(hobj,-1);

    // History von Text, Memo wird bei OnDeactivateText geschrieben, von Polyline bei OnMouseUP
    if (img_DocView.ObjKind[hobj] <> iekMEMO) and
       (img_DocView.ObjKind[hobj] <> iekTEXT) and
       (img_DocView.ObjKind[hobj] <> iekPOLYLINE) then    // f.schneider   v3.5.1.62
    begin
      if fAnnoType = 0 then
	      fHistoryNew.Add(Format( _('Neue Anmerkungen (%s) auf Seite %s'),
            [ObjKindToStr(img_DocView.ObjTextEditMode),
            inttostr(imgidx + 1)]));
      gbAnnoNotSaved := True;
      TbfaPreview(Self.Owner).ActiveDoc.Modified_Annos := True;

     // 09.03.2017 -->
      AnnoObj := TbfaPreview(Self.Owner).ActiveDoc.GetAnnotation(imgidx, TbfaPreview(Self.Owner).CurrentLayer, idx2);
      if AnnoObj = nil then
      begin
        AnnoObj := TbfaAnnotation.Create;
        AnnoObj.Page := imgidx;
        AnnoObj.Layer := TbfaPreview(Self.Owner).CurrentLayer;
        TbfaPreview(Self.Owner).ActiveDoc.Annotations.Add(AnnoObj);
      end;
      idx2 := img_DocView.GetIndexFromObj(-1);
      SetLength(AnnoObj.ObjList, Length(AnnoObj.ObjList) + 1);

      with AnnoObj.ObjList[High(AnnoObj.ObjList)] do
      begin
        ID := idx2;
        ObjKind := img_DocView.ObjKind[idx2];
        ModifiedType := 0;
        if (img_DocView.ObjKind[idx2] in [iekBOX, iekTEXT, iekMEMO]) then
          ObjText := img_DocView.ObjText[idx2];

        NewText := '';
//16.09.2024        Name := ObjKindToStr(img_DocView.ObjTextEditMode);
        Name := ObjKindToStr(img_DocView.ObjTextEditMode);
        Modified := True;
      end;
    end else
    begin
      gbAnnoNotSaved := True;
      TbfaPreview(Self.Owner).ActiveDoc.Modified_Annos := True;
    end;

    if (img_DocView.ObjKind[hobj] in [iekTEXT, iekMEMO]) then
    begin
      fNewTextObject := True;
      if img_DocView.ObjText[hobj] > '' then
      begin
       	if fNoteslwrecord then
          fNoteSLW.Add(img_DocView.ObjText[hobj]);

        if fNotevtxrecord then
          fNoteVTX.Add(img_DocView.ObjText[hobj]);
      end;
    end;

    if initialText <> img_DocView.ObjText[hobj] then
      ObjektAnTextAnpassen(hobj);

    // <!-- SJ 01.03.2023
    // bei Grafikstempeln (aus der Zwischenablage) setzen wir die Grafik so gro,
    // wie noch Platz bis zum Ende des Dokuments ist.
    // Das Verhltnis Width:Height behalten wir bei
    if (img_DocView.ObjKind[hobj] = iekBITMAP) and GraphicClipboardStamp then
    begin
      var scale: Real;
      scale := 1;

      // fr den Fall dass zu breit
      if img_DocView.ObjLeft[hobj] + img_DocView.ObjWidth[hobj] > img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Width then
      begin
        scale := (img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Width - img_DocView.ObjLeft[hobj]) / img_DocView.ObjWidth[hobj];
        img_DocView.ObjWidth[hobj] := Round(img_DocView.ObjWidth[hobj] * scale);
        img_DocView.ObjHeight[hobj] := Round(img_DocView.ObjHeight[hobj] * scale);
      end;

      // wenn es dann auch noch zu hoch ist
      if img_DocView.ObjTop[hobj] + img_DocView.ObjHeight[hobj] > img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Height then
      begin
        scale := (img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Height - img_DocView.ObjTop[hobj]) / img_DocView.ObjHeight[hobj];
        img_DocView.ObjWidth[hobj] := Round(img_DocView.ObjWidth[hobj] * scale);
        img_DocView.ObjHeight[hobj] := Round(img_DocView.ObjHeight[hobj] * scale);
      end;
    end else if (img_DocView.ObjKind[hobj] <> iekLINE) then
    begin
    // bei anderen Stempeln setzen wir die Anno weiter nach links, wenn es ber
    // den Dokumentenrand hinaus gehen wrde. Oder weiter nach oben.
      if img_DocView.ObjWidth[hobj] > img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Width then
        img_DocView.ObjWidth[hobj] := img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Width;
      if img_DocView.ObjHeight[hobj] > img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Height then
        img_DocView.ObjHeight[hobj] := img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Height;

      if img_DocView.ObjLeft[hobj] + img_DocView.ObjWidth[hobj] > img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Width then
        img_DocView.ObjLeft[hobj] := img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Width - img_DocView.ObjWidth[hobj] - 1;
      if img_DocView.ObjTop[hobj] + img_DocView.ObjHeight[hobj] > img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Height then
        img_DocView.ObjTop[hobj] := img_DocView.{$IFNDEF IMAGEEN1140}IO.{$ENDIF}Bitmap.Height - img_DocView.ObjHeight[hobj] - 1;
    end;

    // zu weit links?
    if img_DocView.ObjLeft[hobj] < 0 then
      img_DocView.ObjLeft[hobj] := 0;

    // zu weit oben?
    if img_DocView.ObjTop[hobj] < 0 then
      img_DocView.ObjTop[hobj] := 0;
    // SJ 01.03.2023 -->

    // <!-- SJ 02.03.2023
    if ((img_DocView.ObjBrushStyle[hobj] <> bsClear) and (img_DocView.ObjKind[hobj] <> iekLine))
       or
       ((img_DocView.ObjKind[hobj] = iekBOX) and (img_DocView.ObjBoxHighLight[hobj]))
       or
       ((img_DocView.ObjBrushStyle[hobj] <> bsClear) and (img_DocView.ObjKind[hobj] = iekMEMO)) then
    begin
      TbfaPreview(Self.Owner).ActiveDoc.GetAnnotation(imgidx, TbfaPreview(Self.Owner).CurrentLayer, idx2);
      if idx2 <> -1 then
        rights := TbfaPreview(Self.Owner).ActiveDoc.Annotations[idx2].Rights
      else
        rights := TbfaPreview(Self.Owner).ActiveDoc.Rights;

      if (TbfaPreview(Self.Owner).ActiveDoc.ID <> -1) and
         (not (((rights and rightAModify) = rightAModify) or
              ((rights and rightAPModify) = rightAPModify))) then
      begin
        A := TPolygon.Create;
        with A do
        begin
          position := to_v2f(img_DocView.ObjLeft[hobj], img_DocView.ObjTop[hobj]);
          AddVertex(to_v2f(0, 0));
          AddVertex(to_v2f(img_DocView.ObjWidth[hobj], 0));
          AddVertex(to_v2f(img_DocView.ObjWidth[hobj], img_DocView.ObjHeight[hobj]));
          AddVertex(to_v2f(0, img_DocView.ObjHeight[hobj]));
        end;
        i := 0;
        loopbreak := False;
        while i < img_DocView.ObjectsCount do
        begin
          colobj := img_DocView.GetObjFromIndex(i);
          if (colobj = hobj) or not(
               (img_DocView.ObjKind[colobj] = iekMEMO) and (img_DocView.ObjKind[hobj] = iekMEMO) and
               (img_DocView.ObjBrushStyle[colobj] = bsSolid) and (img_DocView.ObjBrushStyle[hobj] = bsSolid)
             ) then
          begin
            if (img_DocView.ObjKind[colobj] <> iekMEMO) and (img_DocView.ObjKind[hobj] = iekMEMO) then
              img_DocView.SetObjBackTo(hobj, colobj)
            else if (img_DocView.ObjKind[colobj] = iekMEMO) and (img_DocView.ObjKind[hobj] <> iekMEMO) then
              img_DocView.SetObjBackTo(colobj, hobj)
            else if (img_DocView.ObjKind[colobj] = iekMEMO) and (img_DocView.ObjKind[hobj] = iekMEMO) and
                    (img_DocView.ObjBrushStyle[colobj] = bsSolid) and (img_DocView.ObjBrushStyle[hobj] <> bsSolid) then
              img_DocView.SetObjFrontOf(hobj, colobj)
            else if (img_DocView.ObjKind[colobj] = iekMEMO) and (img_DocView.ObjKind[hobj] = iekMEMO) and
                    (img_DocView.ObjBrushStyle[colobj] <> bsSolid) and (img_DocView.ObjBrushStyle[hobj] = bsSolid) then
              img_DocView.SetObjFrontOf(colobj, hobj);

            i := i + 1;
            Continue;
          end;
          B := TPolygon.Create;
          with B do
          begin
            position := to_v2f(img_DocView.ObjLeft[colobj], img_DocView.ObjTop[colobj]);
            AddVertex(to_v2f(0, 0));
            AddVertex(to_v2f(img_DocView.ObjWidth[colobj], 0));
            AddVertex(to_v2f(img_DocView.ObjWidth[colobj], img_DocView.ObjHeight[colobj]));
            AddVertex(to_v2f(0, img_DocView.ObjHeight[colobj]));
          end;
          i := i + 1;
          lbinter := False;
          loopbreak := False;
          if PolyPolyIntersect(A, B, MTD) then
          begin
            img_DocView.DeSelect;
            img_DocView.CancelInteracts;
            img_DocView.RemoveObject(hobj);
            fobjdel := True;

            //22.06.2021 Ticket 27675 -->
            BfMessageDialogWithCheckBox(_('Hinweis'),
                            _('Platzieren Sie bitte die Notiz auf eine freie Stelle!'),
                            mtWarning, [mbOK], [_('OK')], True, bitfarmApp.ViewerOptions,
                                  'PlaceAnno');
            //BfShowMessage(_('Platzieren Sie bitte die Notiz auf eine freie Stelle!'));
            //22.06.2021 Ticket 27675 <--
            img_DocView.UnSelAllObjects;
            img_DocView.ObjEditOnNewText := False;
            if Assigned(A) then
              FreeAndNil(A);
            if Assigned(B) then
              FreeAndNil(B);
            Abort;
          end;

          if loopbreak then
          begin
            img_DocView.RemoveObject(hobj);
            Break;
          end;
          if lbinter then
          begin
            img_DocView.ObjTop[hobj] := Round(A.position.y);
            img_DocView.ObjLeft[hobj] := Round(A.position.x);
          end;

          if Assigned(B) then
            FreeAndNil(B);
        end;
      end;
      if not loopbreak then
      begin
        createannodata(hobj);
        img_DocView.ObjEditOnNewText := True;
      end
      else
      begin
        ShowMessage(_('Die Notiz konnte nicht auf eine freie Stelle platziert werden.'));
        Exit;
      end;
    end else
    begin
      createannodata(hobj);

      if img_DocView.ObjKind[hobj] <> iekBITMAP then
	      img_DocView.ObjEditOnNewText := True;
    end;
    // SJ 02.03.2023 -->

    saveannostream;
    {$IFDEF ENTERPRISE}
    if Assigned(OnPluginExecuteOnStamp) and (VirtualPluginMenuItem <> nil) and (Self.Owner is TbfaPreview) then
      OnPluginExecuteOnStamp(TbfaPreview(Self.Owner), img_DocView.ObjUserData[hobj]);
    {$ENDIF}

    img_DocView.ObjGraphicRender := False;
    img_DocView.EnableAlphaChannel := False;

    if bitfarmApp.LastAnnoDefaultWidth <> -1 then
      img_DocView.ObjWidth[-1] := bitfarmApp.LastAnnoDefaultWidth;
    if bitfarmApp.LastAnnoDefaultHeight <> -1 then
      img_DocView.ObjHeight[-1] := bitfarmApp.LastAnnoDefaultHeight;

  finally
    if Assigned(A) then
      FreeAndNil(A);
    if Assigned(B) then
      FreeAndNil(B);
  end;
end;

procedure Tfrm_Voransicht.AnnoDelete(Sender: TObject; Doc: TbfaDocument = nil; SelectNext: Boolean = True);
var
  idx, idx2, rights, i, j, imgidx: integer;
  bContinue, foundPublicAnno: Boolean;
  ADocument: TbfaDocument;
begin
  bitfarmLog.DebugBegin(llDebug, 'AnnoDelete', ClassNAme);
  try
    try
      if Doc = nil then
      begin
        ADocument := TbfaPreview(Self.Owner).ActiveDoc;
        bitfarmLog.Write(llNormal, ltDebug, 'AnnoDelete - ADocument = ActiveDoc', ClassName);
      end else
      begin
        ADocument := Doc;
        bitfarmLog.Write(llNormal, ltDebug, 'AnnoDelete - ADocument = Doc', ClassName);
      end;

      for i := img_DocView.SelObjectsCount - 1 downto 0 do
      begin
        bContinue := False;
        idx := img_DocView.SelObjects[i];

        bitfarmLog.Write(llNormal, ltDebug, 'AnnoDelete - idx = ' + idx.ToString, ClassName);

        if (ADocument <> nil) and (ADocument.ScanPoolView <> nil) and (ADocument.ScanPoolViewLoaded) then
          imgidx := TbfaPreview(Self.Owner).ActivePage
        else
          imgidx := img_DocView.IO.Params.ImageIndex;

        ADocument.GetAnnotation(imgidx, TbfaPreview(Self.Owner).CurrentLayer, idx2);

        bitfarmLog.Write(llNormal, ltDebug, 'AnnoDelete - idx2 = ' + idx2.ToString, ClassName);

        if idx2 <> -1 then
          rights := ADocument.Annotations[idx2].Rights
        else
          rights := ADocument.Rights;

        bitfarmLog.Write(llNormal, ltDebug, 'AnnoDelete - rights = ' + rights.ToString, ClassName);

        if not (((rights and rightAModify) = rightAModify) or
                ((rights and rightAPModify) = rightAPModify)) then
        begin
          if img_DocView.ObjUserDataLength[idx] > 0 then
          begin
            if (bitfarmApp.User.Name <> PAnnoData(img_DocView.ObjUserData[idx])^.Ersteller) then
              bContinue := True;
          end
          else if (img_DocView.ObjUserDataLength[idx] = 0) then
            bContinue := True;
        end;

        if not bContinue then
        begin
          bGDelObj := True;
          ADocument.Modified_AnnosDelete := True;
          if fAnnoType = 0 then
            if img_DocView.ObjText[idx] = '' then
              fHistoryDeleted.Add(Format(_('Anmerkung (%s) auf Seite %s wurde entfernt.'),
                      [ObjKindToStr(idx),inttostr(imgidx + 1)]))
            else
              fHistoryDeleted.Add(Format(_('Anmerkung mit Text "%s" auf Seite %s wurde entfernt'),
                      [img_DocView.ObjText[idx],inttostr(imgidx + 1)]));

          img_DocView.ObjLeft[idx] := 0;
          img_DocView.ObjTop[idx] := 0;
          img_DocView.ObjWidth[idx] := 0;
          img_DocView.ObjHeight[idx] := 0;
          img_DocView.RemoveObject(idx);

          FRemovedObjects.Add(IntToStr(idx));
  //      <!--
          if idx2 <> -1 then
            ADocument.Annotations[idx2].Deleted := True;

          foundPublicAnno := False;
          bitfarmLog.Write(llNormal, ltDebug, 'AnnoDelete - Annotations Count = ' + ADocument.Annotations.Count.ToString, ClassName);
          // bei LogMeldungen beachten dass .Count nicht -1
          for j := 0 to ADocument.Annotations.Count - 1 do
          begin
            if (ADocument.Annotations[j].Layer = 0) and not ADocument.Annotations[j].Deleted then
            begin
              foundPublicAnno := True;
              bitfarmLog.Write(llNormal, ltDebug, 'AnnoDelete - foundPublicAnno - j = ' + j.ToString, ClassName);
              Break;
            end;
          end;
          CreateThumbnailWithAnno(img_DocView, TbfaPreview(Self.Owner), ADocument, foundPublicAnno);

  //        if img_DocView.ObjectsCount = 0 then
  //        begin
  //          CreateThumbnailWithAnno(img_DocView, TbfaPreview(Self.Owner),
  //            ADocument, False);
  //        end;
  //      -->

          saveannostream(True, ADocument);

        end;
      end;

      if bGDelObj then
      begin
        if SelectNext then
          SelectNextAnno;
        if Assigned(fSaveBtN) then
        begin
          if fSaveBtN is TBitBtn then
            (fSaveBtN as TBitBtn).Enabled := True;
          if fSaveBtN is TSPTBXItem then
            (fSaveBtN as TSPTBXItem).Enabled := True;
        end;
        fTextAnnoCreated := False;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'AnnoDelete', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'AnnoDelete', ClassNAme);
  end;
end;

procedure Tfrm_Voransicht.img_DocViewObjectOver(Sender: TObject; hobj: integer);
var
  mydata: PAnnoData;
begin
  try
    mydata := img_DocView.ObjUserData[hobj];
    if Assigned(fOnObjectOver) then
      fOnObjectOver(mydata);
  except
    bitfarmLog.Write(llNormal, ltException, 'img_DocViewObjectOver', ClassName);
  end;
end;

procedure Tfrm_Voransicht.img_DocViewDeactivateTextEdit(Sender: TObject);
var
  hobj, i, j, colobj, imgidx, imgwidth, imgheight: Integer;
  lstext: String;
  lbhcol: Boolean;
  A, B: TPolygon;
  MTD: TVector2f;
begin
  try
    hobj := img_DocView.ObjTextEditMode;

    lstext := trim(ParseSQLString(img_DocView.ObjText[hobj]));

    if (img_DocView.ObjKind[hobj] in [iekTEXT,iekMEMO]) and
       {(img_DocView.ObjBrushStyle[hobj] = bsClear) and} // SJ 05.09.2023
       (img_DocView.ObjName[hobj] <> 'ClipboardAsStamp') //25.04.2019 diese mssen nicht angepasst werden!
    then
      ObjektAnTextAnpassen(hobj, img_DocView.ObjTextAutoSize[hobj]);

    if (TbfaPreview(Self.Owner).ActiveDoc <> nil) and
       (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView <> nil) and
       (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolViewLoaded) then
    begin
      imgidx := TbfaPreview(Self.Owner).ActivePage;
      imgwidth := img_DocView.Bitmap.Width;
      imgheight := img_DocView.Bitmap.Height;
    end else
    begin
      imgidx := img_DocView.IO.Params.ImageIndex;
      imgwidth := img_DocView.IO.Params.Width;
      imgheight := img_DocView.IO.Params.Height;
    end;

    if fAnnoType = 0 then
    begin
      if fHistoryNew <> nil then
      begin
        if (lstext <> '') and (lstext <> fOldtext) then
        begin
          if lstext <> '' then
          begin
            if fNewTextObject then
              fHistoryNew.Add(Format(_('neue Anmerkung "%s" auf Seite %s'), [lstext,inttostr(imgidx + 1)]))
            else if fOldtext = '' then
              fHistoryNew.Add(Format(_('leere Anmerkung gendert nach "%s" auf Seite %s'), [lstext,inttostr(imgidx + 1)]))
            else
              fHistoryNew.Add(Format(_('Anmerkung "%s" gendert nach "%s" auf Seite %s'), [fOldtext, lstext, inttostr(imgidx + 1)]));

            if fNoteslwrecord then
              fNoteSLW.Add(lstext);

            if fNotevtxrecord then
              fNoteVTX.Add(lstext);
          end
          else
            fHistoryNew.Add(Format( _('Neue Anmerkungen (%s) auf Seite %s'),[ObjKindToStr(hobj), inttostr(imgidx + 1)]));
        end
        else if lstext <> '' then		// lstext = fOldtext  (bei Stempeln der Fall)
			  begin
          if ((img_DocView.ObjKind[hobj] in [iekTEXT,iekMEMO]) and (img_DocView.ObjBrushStyle[hobj] = bsClear)) then
            fHistoryNew.Add(Format(_('neue Anmerkung "%s" auf Seite %s'), [lstext,inttostr(imgidx + 1)]))
        end
			  else if fOldtext = '' then
        begin
          if fNewTextObject then
            if not ((img_DocView.ObjKind[hobj] in [iekTEXT,iekMEMO]) and (img_DocView.ObjBrushStyle[hobj] = bsClear)) then
              fHistoryNew.Add(Format( _('Neue Anmerkungen (%s) auf Seite %s'), [ObjKindToStr(hobj),inttostr(imgidx + 1)]));
        end
        else
          fHistoryNew.Add(Format(_('Text von Anmerkung "%s" geleert auf Seite %s'), [fOldtext, inttostr(imgidx + 1)]));
      end;
    end;

    hobj := img_DocView.SelObjects[0];
    B := nil;
    A := nil;
    if (img_DocView.ObjKind[hobj] <> iekLINE) and (img_DocView.ObjBrushStyle[hobj] <> bsClear) and
       (not ((TbfaPreview(Owner).ActiveDoc.Rights and rightAModify) = rightAModify)) and
       (img_DocView.ObjectsCount > 1)
    then
    begin
      try
        A := TPolygon.Create;
        with A do
        begin
          position := to_v2f(img_DocView.ObjLeft[hobj], img_DocView.ObjTop[hobj]);
          AddVertex(to_v2f(0, 0));
          AddVertex(to_v2f(img_DocView.ObjWidth[hobj], 0));
          AddVertex(to_v2f(img_DocView.ObjWidth[hobj], img_DocView.ObjHeight[hobj]));
          AddVertex(to_v2f(0, img_DocView.ObjHeight[hobj]));
        end;
        i := 0;
        j := 0;
        while i < img_DocView.ObjectsCount do
        begin
          colobj := img_DocView.GetObjFromIndex(i);

          if (img_DocView.ObjKind[colobj] = iekMEMO) and (img_DocView.ObjBrushStyle[colobj] = bsSolid) then
            img_DocView.SetObjBackTo(colobj, -1);

          if (colobj = hobj) or
             not((img_DocView.ObjKind[colobj] = iekMEMO) and (img_DocView.ObjBrushStyle[colobj] = bsSolid) and
                 (img_DocView.ObjKind[hobj] = iekMEMO) and (img_DocView.ObjBrushStyle[hobj] = bsSolid)) then
          begin
            i := i + 1;
            Continue;
          end;
          B := TPolygon.Create;
          with B do
          begin
            position := to_v2f(img_DocView.ObjLeft[colobj], img_DocView.ObjTop[colobj]);
            AddVertex(to_v2f(0, 0));
            AddVertex(to_v2f(img_DocView.ObjWidth[colobj], 0));
            AddVertex(to_v2f(img_DocView.ObjWidth[colobj], img_DocView.ObjHeight[colobj]));
            AddVertex(to_v2f(0, img_DocView.ObjHeight[colobj]));
          end;
          i := i + 1;
          if PolyPolyIntersect(a, b, MTD) and ((MTD.x <> 0) or (MTD.y <> 0)) then
          begin
            lbhcol := True;

            while PolyPolyIntersect(a, b, MTD) and ((MTD.x <> 0) or (MTD.y <> 0)) do
            begin
              if (MTD.x = 0) and (MTD.y = 0) then
              begin
                MTD.x := -1;
                MTD.y := -1;
              end
              else
                MTD := v2f_Scale(MTD, (1.05));

              a.position := v2f_add(a.position, MTD);
            end;

            // nur berlagernde Memos werden verschoben
            if (img_DocView.ObjKind[colobj] = iekMEMO) and (img_DocView.ObjKind[hobj] = iekMEMO) then
            begin
              img_DocView.ObjLeft[hobj] := trunc(a.position.x);
              img_DocView.ObjTop[hobj] := trunc(a.position.y);
            end;

            if img_DocView.ObjLeft[hobj] < 0 then // mit Rand kollidiert ;-)
              img_DocView.ObjLeft[hobj] := Trunc(b.Position.X) + Trunc(b.Vertices[2].X);

            if img_DocView.ObjTop[hobj] < 0 then
              img_DocView.ObjTop[hobj] := Trunc(b.Position.Y) + Trunc(b.Vertices[2].Y);

            if img_DocView.ObjLeft[hobj] + img_DocView.ObjWidth[hobj] > imgWidth then
              img_DocView.ObjLeft[hobj] := Trunc(b.Position.X) - img_DocView.ObjWidth[hobj];

            if img_DocView.ObjTop[hobj] + img_DocView.ObjHeight[hobj] > imgHeight then
              img_DocView.ObjTop[hobj] := Trunc(b.Position.Y) - img_DocView.ObjHeight[hobj];

            A := nil;
            A := TPolygon.Create;
            with A do
            begin
              position := to_v2f(img_DocView.ObjLeft[hobj], img_DocView.ObjTop[hobj]);
              AddVertex(to_v2f(0, 0));
              AddVertex(to_v2f(img_DocView.ObjWidth[hobj], 0));
              AddVertex(to_v2f(img_DocView.ObjWidth[hobj], img_DocView.ObjHeight[hobj]));
              AddVertex(to_v2f(0, img_DocView.ObjHeight[hobj]));
            end;
          end;
          if lbhcol then
          begin
            i := 0;
            j := j + 1;
            if j > 50 then
            begin
              Break;
            end;
            lbhcol := false;
          end;
          if Assigned(b) then
            FreeAndNil(b);
        end;
        if lbhcol then
        begin
          img_DocView.ObjLeft[hobj] := fStartPos.X;
          img_DocView.ObjTop[hobj] := fStartPos.Y;
          img_DocView.ObjWidth[hobj] := fObjWidth;
          img_DocView.ObjHeight[hobj] := fObjHeight;
          Exit;
        end;
      finally
        begin
          if Assigned(A) then
            FreeAndNil(A);
          if Assigned(B) then
            FreeAndNil(B);
        end;
      end;
    end;

    fOldtext := '';
    gbAnnoNotSaved := True;
    TbfaPreview(Self.Owner).ActiveDoc.Modified_Annos := True;
    fdoubleklicked := False;
    fNewTextObject := False;
    fTextAnnoCreated := True;
    img_DocView.Update;

    saveannostream(False);
  except
    bitfarmLog.Write(llNormal, ltException, 'DocViewDeactivateTextEdit', ClassName);
  end;
end;

procedure Tfrm_Voransicht.img_DocViewActivateTextEdit(Sender: TObject);
var
  lbmod: Boolean;
  idx, rights, imgidx: Integer;
begin
  try
    if img_DocView.ObjTextEditMode < 0 then
    begin
      img_DocView.CancelInteracts;
      Exit;
    end;

    if (TbfaPreview(Self.Owner).ActiveDoc <> nil) and
       (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView <> nil) and
       (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolViewLoaded)
    then
      imgidx := TbfaPreview(Self.Owner).ActivePage
    else
      imgidx := img_DocView.IO.Params.ImageIndex;

    lbmod := False;
    if img_DocView.ObjUserDataLength[img_DocView.ObjTextEditMode] > 0 then
    begin
      TbfaPreview(Self.Owner).ActiveDoc.GetAnnotation(imgidx, TbfaPreview(Self.Owner).CurrentLayer, idx);

      if idx <> -1 then
        rights := TbfaPreview(Self.Owner).ActiveDoc.Annotations[idx].Rights
      else
        rights := TbfaPreview(Self.Owner).ActiveDoc.Rights;

      if (
        (bitfarmApp.User.Name = PAnnoData(img_DocView.ObjUserData[img_DocView.ObjTextEditMode])^.Ersteller)
            or
            ((rights and rightAModify) = rightAModify)
            or
            ((rights and rightAPModify) = rightAPModify)
         )
      then
        lbmod := True;
    end;

    if lbmod then
    begin
      gbAnnoNotSaved := True;
      TbfaPreview(Self.Owner).ActiveDoc.Modified_Annos := True;
      fOldtext := img_DocView.ObjText[img_DocView.ObjTextEditMode];
      fStartPos.X := img_DocView.ObjLeft[img_DocView.ObjTextEditMode];
      fStartPos.y := img_DocView.ObjTop[img_DocView.ObjTextEditMode];
      fObjWidth := img_DocView.ObjWidth[img_DocView.ObjTextEditMode];
      fObjHeight := img_DocView.ObjHeight[img_DocView.ObjTextEditMode];
    end else
      img_DocView.CancelInteracts;
  except
    bitfarmLog.Write(llNormal, ltException, 'img_DocViewActivateTextEdit', ClassName);
  end;
end;

procedure Tfrm_Voransicht.img_DocViewUserSelectObject(Sender: TObject; hobj: Integer);
var
  i, idx, rights, imgidx, colobj: Integer;
begin
  try
    if (TbfaPreview(Self.Owner).ActiveDoc <> nil) and
       (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView <> nil) and
       (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolViewLoaded)
    then
      imgidx := TbfaPreview(Self.Owner).ActivePage
    else
      imgidx := img_DocView.IO.Params.ImageIndex;

    gbAnnoNotAccessible := False;
    rights := 0;
    fStartPos.X := img_DocView.ObjLeft[hobj];
    fStartPos.y := img_DocView.ObjTop[hobj];
    fObjWidth := img_DocView.ObjWidth[hobj];
    fObjHeight := img_DocView.ObjHeight[hobj];
    if (img_DocView.ObjKind[hobj] <> iekMEMO) then
      img_DocView.SetObjFrontOf(hobj, -1);

    if img_DocView.ObjUserData[hobj] <> nil then
    begin
      TbfaPreview(Self.Owner).ActiveDoc.GetAnnotation(imgidx, TbfaPreview(Self.Owner).CurrentLayer, idx);
      if idx <> -1 then
        rights := TbfaPreview(Self.Owner).ActiveDoc.Annotations[idx].Rights
      else
        rights := TbfaPreview(Self.Owner).ActiveDoc.Rights;
      
      if (
           (bitfarmApp.User.Name <> PAnnoData(img_DocView.ObjUserData[hobj])^.ersteller)
           and
          ((not ((rights and rightAModify) = rightAModify))
             and
          (not ((rights and rightAPModify) = rightAPModify)))
         )
      then
      begin
        img_DocView.UnSelAllObjects;
        gbAnnoNotAccessible := True;
      end else
      begin
        for I := 0 to img_DocView.ObjectsCount - 1 do
        begin
          colobj := img_DocView.GetObjFromIndex(i);

          if (hobj <> colobj) and
             (img_DocView.ObjKind[hobj] = iekMEMO) and (img_DocView.ObjKind[colobj] = iekMEMO) and
             (img_DocView.ObjBrushStyle[hobj] = bsSolid) and (img_DocView.ObjBrushStyle[colobj] = bsSolid)
          then
            img_DocView.SetObjFrontOf(hobj, colobj);
        end;
      end;
    end;
    fTextAnnoCreated := False;
  except
    bitfarmLog.Write(llNormal, ltException, 'img_DocViewUserSelectObject', ClassName);
  end;
end;

procedure Tfrm_Voransicht.ScrollLeft;
begin
  try
    img_DocView.ViewX := Round(img_DocView.ViewX - (img_DocView.Width * (img_DocView.MouseWheelParams.Value / 100)));
  except
    bitfarmLog.Write(llNormal, ltException, 'ScrollLeft', ClassName);
  end;
end;

procedure Tfrm_Voransicht.ScrollRight;
begin
  try
    img_DocView.ViewX := Round(img_DocView.ViewX + (img_DocView.Width * (img_DocView.MouseWheelParams.Value / 100)));
  except
    bitfarmLog.Write(llNormal, ltException, 'ScrollRight', ClassName);
  end;
end;

procedure Tfrm_Voransicht.ScrollUp;
begin
  try
    img_DocView.ViewY := Round(img_DocView.ViewY - (img_DocView.Height * (img_DocView.MouseWheelParams.Value / 100)));
  except
    bitfarmLog.Write(llNormal, ltException, 'ScrollUp', ClassName);
  end;
end;

procedure Tfrm_Voransicht.ScrollDown;
begin
  try
    img_DocView.ViewY := Round(img_DocView.ViewY + (img_DocView.Height * (img_DocView.MouseWheelParams.Value / 100)));
  except
    bitfarmLog.Write(llNormal, ltException, 'ScrollDown', ClassName);
  end;
end;

procedure Tfrm_Voransicht.SelectNextAnno;
var
  index, idx, hobj, rights, imgidx: integer;
  FHobjList: TList<THobj>;
  FHobj, iselect: THobj;
  Found: Boolean;
begin
  try
    try
      if (TbfaPreview(Self.Owner).ActiveDoc <> nil) and
         (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView <> nil) and
         (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolViewLoaded)
      then
        imgidx := TbfaPreview(Self.Owner).ActivePage
      else
        imgidx := img_DocView.IO.Params.ImageIndex;


      iselect.ind := -1;
      iselect.top := -1;
      iselect.left := -1;

      FHobjList := TList<THobj>.Create;

      for index := 0 to img_DocView.ObjectsCount -1 do
      begin
        idx := index;
        hobj := img_DocView.GetObjFromIndex(idx);
        if img_docview.ObjUserData[hobj] <> nil then
        begin
          TbfaPreview(Self.Owner).ActiveDoc.GetAnnotation(imgidx, TbfaPreview(Self.Owner).CurrentLayer, idx);
          if idx <> -1 then
            rights := TbfaPreview(Self.Owner).ActiveDoc.Annotations[idx].Rights
          else
            rights := TbfaPreview(Self.Owner).ActiveDoc.Rights;

          if (
               (bitfarmApp.User.Name = PAnnoData(img_docview.ObjUserData[hobj])^.ersteller)
                or
               ((rights and rightAModify) = rightAModify)
               or
               ((rights and rightAPModify) = rightAPModify)
             )
          then
          begin
            FHobj.ind := hobj;
            FHobj.top := img_docview.ObjTop[hobj];
            FHobj.left := img_docview.ObjLeft[hobj];
            FHobjList.Add(FHobj);
            if img_DocView.IsSelObject(hobj) then
            begin
              iselect := FHobj;
              Found := True;
            end;
          end;
        end;
      end;

      FHobjList.Sort(
        TComparer<THobj>.Construct(
          function(const Item1, Item2: THobj): Integer
          begin
            Result := 0;
            if (Item1.top > Item2.top) then
              Result := 1
            else if (Item1.top < Item2.top) then
              Result := -1
            else if (Item1.top = Item2.top) then
            begin
              if (Item1.left > Item2.left) then
                Result := 1
              else if (Item1.left < Item2.left) then
                Result := -1
            end;
          end
        )
      );

      if (iselect.ind = -1) then
      begin
        idx := 0;
        Found := False;
      end
      else
        idx := FHobjList.IndexOf(iselect);

      if (idx <> -1) and (FHobjList.Count > 0) then
      begin
        if (idx < FHobjList.Count - 1) and Found then
          inc(idx)
        else if (idx = FHobjList.Count - 1) and Found then
        begin
          img_DocView.Deselect;
          img_DocView.UnSelAllObjects;
          Self.Perform(WM_NEXTDLGCTL, 0, 0);
          Exit;
        end
        else
          idx := 0;

        img_DocView.Deselect;
        img_DocView.UnSelAllObjects;
        img_DocView.AddSelObject(FHobjList[idx].ind);
      end;
      img_DocView.SetFocus;
    finally
      try
        FHobjList.Free;
      except
        //
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SelectNextAnno', ClassName);
  end;
end;
//procedure Tfrm_Voransicht.SelectNextAnno;
//var
//  index, idx, hobj, iselect, iself, rights, imgidx: Integer;         // -->9/15/2020 bfacrm:ticket__show__24054
//  hobjids: TStringList;
//  found: boolean;
//begin
//  try
//    if not (TbfaPreview(Self.Owner).ActiveDoc.InEditMode) then
//      Exit;
//
////12.06.2018 Ticket 14576 -->
//    if (bitfarmApp.WithScanPool) and (TbfaPreview(Self.Owner).ActiveDoc <> nil) and
//       (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView <> nil) and
//       (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolViewLoaded) then
//    begin
////      if (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView.SelectedImage) <> -1 then
////19.09.2018        imgidx := TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView.SelectedImage
//      imgidx := TbfaPreview(Self.Owner).ActivePage;
////      else
////        imgidx := 0;
//    end
//    else
//    begin
//      imgidx := img_DocView.IO.Params.ImageIndex;
//    end;
////12.06.2018 Ticket 14576 <--
//
//
//    hobjids := TStringList.Create;
//    iselect := -1;
//    for index := 0 to img_DocView.ObjectsCount -1 do         // --> 9/15/2020 bfacrm:ticket__show__24054
//    begin
//      idx := index;                                           //--> 9/15/2020 bfacrm:ticket__show__24054
//      hobj := img_DocView.GetObjFromIndex(idx);
//      if img_DocView.IsSelObject(hobj) then
//        iselect := hobj;
//
//      if img_docview.ObjUserData[hobj] <> nil then
//      begin
//        TbfaPreview(Self.Owner).ActiveDoc.GetAnnotation(imgidx, TbfaPreview(Self.Owner).CurrentLayer, idx);
//        if idx <> -1 then
//          rights := TbfaPreview(Self.Owner).ActiveDoc.Annotations[idx].Rights
//        else
//          rights := TbfaPreview(Self.Owner).ActiveDoc.Rights;
//
//        if (
//             (bitfarmApp.User.Name = PAnnoData(img_docview.ObjUserData[hobj])^.ersteller)
//              or
//             ((rights and rightAModify) = rightAModify)
//             or
//             ((rights and rightAPModify) = rightAPModify)
//           )
//        then
//          hobjids.add(IntToStr(hobj));
//      end;
//    end;
//    idx := -1;
//    if iselect = -1 then
//    begin
//      idx := 0;
//      found := False;
//    end
//    else
//    begin
//      idx := hobjids.IndexOf(IntToStr(iselect));
//      found := True;
//    end;
//
//    if (hobjids.Count = 0) or (idx = hobjids.Count - 1) then
//    begin
//      img_DocView.Deselect;
//      img_DocView.UnSelAllObjects;
//      Self.Perform(WM_NEXTDLGCTL, 0, 0);
//      Exit;
//    end;
//
//    if (idx <> -1) and (hobjids.Count > 0) then
//    begin
//      if (idx < hobjids.Count - 1) or ((idx = 0) and (not found)) then
//      begin
//        if found then
//          inc(idx);
//      end else
//      begin
//        img_DocView.Deselect;
//        img_DocView.UnSelAllObjects;
//        Self.Perform(WM_NEXTDLGCTL, 0, 0);
//        Exit;
//      end;
//      img_DocView.Deselect;
//      img_DocView.UnSelAllObjects;
//      img_DocView.AddSelObject(StrToInt(hobjids[idx]));
//    end;
//    img_DocView.SetFocus;
//
////    if (idx <> -1) and (hobjids.Count > 0) then
////    begin
////      if (idx < hobjids.Count - 1) or ((idx = 0) and (not found)) then
////      begin
////        if ((idx = 0) and (not found)) then
////        begin
////          if found then
////            inc(idx);
////        end;
////      end else
////      begin
////        img_DocView.Deselect;
////        img_DocView.UnSelAllObjects;
////        Self.Perform(WM_NEXTDLGCTL, 0, 0);
////        Exit;
////      end;
////      img_DocView.Deselect;
////      img_DocView.UnSelAllObjects;
////      img_DocView.AddSelObject(StrToInt(hobjids[idx]));
////    end;
////    img_DocView.SetFocus;
//  except
//
//  end;
//end;

function Tfrm_Voransicht.GetPage(FtxPos : TList<TbfaFtxPos>; ActPage,
  NewPage : Integer; Next : Boolean) : Boolean;
var
  i, j : Integer;
  found : Boolean;
begin
  try
    i := 0;
    found := False;
    while  ((not found) and (i <= FtxPos.Count - 1)) do
    begin
      j := 0;
      if ((FtxPos[i].WordList <> nil) and (FtxPos[i].WordList.Count > 0)) then
      begin
        while ((not found) and (j <= FtxPos[i].WordList.Count - 1)) do
        begin
          if Next then
          begin
            if (ActPage < NewPage) and
               (FtxPos[i].WordList[j].Page > ActPage) and
               (FtxPos[i].WordList[j].Page = NewPage)
            then
              found := True
            else
              Inc(j);
          end
          else
          begin
            if (ActPage > NewPage) and
               (FtxPos[i].WordList[j].Page < ActPage) and
               (FtxPos[i].WordList[j].Page = NewPage)
            then
              found := True
            else
              Inc(j);
          end;
        end;
      end;
      inc(i);
    end;

    Result := Found;
  except
    Result := False;
    bitfarmLog.Write(llNormal, ltException, 'GetPage', ClassName);
  end;
end;

procedure Tfrm_Voransicht.SelectNextFtxSearchPos;
var
  ActPage, imgidx, imgcnt : Integer;
  found : Boolean;
begin
  try
    found := False;
    if (TbfaPreview(Self.Owner).ActiveDoc <> nil) and
       (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView <> nil) and
       (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolViewLoaded) then
    begin
      imgidx := TbfaPreview(Self.Owner).ActivePage;
      imgcnt := TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView.ImageCount;
    end
    else
    begin
      imgidx := img_DocView.IO.Params.ImageIndex;
      imgcnt := img_DocView.IO.Params.ImageCount;
    end;

    with TbfaPreview(Self.Owner) do
    begin
      if (FtxPos <> nil) and
         ((FtxObjList.Count > 0)
            and
            (
          ((FtxSearchPos < (FtxObjList.Count - 1)) and (imgcnt > 1))
              or
          ((FtxSearchPos <= (FtxObjList.Count - 1)) and (imgcnt = 1)))
         )
      then
      begin
        img_DocView.Deselect;
        img_DocView.UnSelAllObjects;

        if FtxSearchPos <> -1 then
        begin
          if FtxSearchPosOldColor <> -1 then
          begin
            img_DocView.ObjBrushStyle[StrToInt(FtxObjList[FtxSearchPos])] := bsClear;
            img_DocView.ObjTransparency[StrToInt(FtxObjList[FtxSearchPos])] := 255;
          end;
        end;

        if (FtxSearchPos = -1)then
          FtxSearchPos := 0
        else
        begin
          Inc(FtxSearchPos);
          if FtxObjList.Count - 1 < FtxSearchPos then
            FtxSearchPos := 0;
        end;

        FtxSearchPosOldColor := img_DocView.ObjPenColor[StrToInt(FtxObjList[FtxSearchPos])];
        img_DocView.ObjBrushStyle[StrToInt(FtxObjList[FtxSearchPos])] := bsSolid;
        img_DocView.ObjTransparency[StrToInt(FtxObjList[FtxSearchPos])] := 150;
        img_DocView.UpDate;
      end
      else if (FtxPos <> nil) then
      begin
        ActPage := imgidx + 1;
        while ((not found) and (ActPage <= imgcnt - 1)) do
        begin
          found := GetPage(FtxPos, imgidx, ActPage, True);
          if not found then
            Inc(ActPage);
        end;

        if not found then
        begin
//          if  (imgidx >= imgcnt - 1) and ((*(bitfarmApp.GetActivePreview.SearchbarChkCircle.Checked) or*)
//        Commit 14445 ist SearchbarChkCircle.Checked raus geflogen. Gabs da nen Grund fr?
          if  (ActPage >= imgcnt - 1) and
              (
                ((TbfaPreview(Self.Owner) <> nil) and TbfaPreview(Self.Owner).SearchbarChkCircle.Checked) or
                (BfMessageDlg(_('Kein weiteres Vorkommen gefunden.\nMchten Sie vom Dokumentenanfang weitersuchen?'),
                  mtConfirmation, [mbYes,mbNo]) = mrYes)
              ) then
          begin
            ActPage := -1;
            while ((not found) and (ActPage <= imgidx)) do
            begin
              found := GetPage(FtxPos, -1, ActPage, True);
              if not found then
                Inc(ActPage);
            end;
          end;
        end;

        if ((found) and (ActPage >= 0)) then
        begin
          ShowPage(ActiveDoc, ActPage);
          FtxSearchPos := -1;
          SelectNextFtxSearchPos;
        end;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SelectNextFtxSearchPos', ClassName);
  end;
end;

procedure Tfrm_Voransicht.SelectPreviousFtxSearchPos;
var
  ActPage, imgidx, imgcnt : Integer;
  found : Boolean;
begin
  try
    found := False;

    if (TbfaPreview(Self.Owner).ActiveDoc <> nil) and
       (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView <> nil) and
       (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolViewLoaded) then
    begin
      imgidx := TbfaPreview(Self.Owner).ActivePage;
      imgcnt := TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView.ImageCount;
    end else
    begin
      imgidx := img_DocView.IO.Params.ImageIndex;
      imgcnt := img_DocView.IO.Params.ImageCount;
    end;

    with TbfaPreview(Self.Owner) do
    begin
      if (FtxPos <> nil) and
         ((FtxObjList.Count > 0)
            and
          (((FtxSearchPos > 0) and (imgcnt > 1))
              or
          ((FtxSearchPos >= 0) and (imgcnt = 1)))
         )
         then
      begin
        img_DocView.Deselect;
        img_DocView.UnSelAllObjects;

        if FtxSearchPos <> -1 then
        begin
          if FtxSearchPosOldColor <> -1 then
          begin
            if FtxSearchPos = FtxObjList.Count then
            begin
              img_DocView.ObjBrushStyle[StrToInt(FtxObjList[0])] := bsClear;
              img_DocView.ObjTransparency[StrToInt(FtxObjList[0])] := 255;
            end
            else
            begin
              img_DocView.ObjBrushStyle[StrToInt(FtxObjList[FtxSearchPos])] := bsClear;
              img_DocView.ObjTransparency[StrToInt(FtxObjList[FtxSearchPos])] := 255;
            end;
          end;
        end;

        if (FtxSearchPos < 0)then
          FtxSearchPos := FtxObjList.Count - 1
        else
        begin
          Dec(FtxSearchPos);
          if FtxSearchPos < 0 then
            FtxSearchPos := FtxObjList.Count - 1;
        end;
        FtxSearchPosOldColor := img_DocView.ObjPenColor[StrToInt(FtxObjList[FtxSearchPos])];
        img_DocView.ObjBrushStyle[StrToInt(FtxObjList[FtxSearchPos])] := bsSolid;
        img_DocView.ObjTransparency[StrToInt(FtxObjList[FtxSearchPos])] := 150;
        img_DocView.Update;
      end
      else if (FtxPos <> nil) then
      begin
        ActPage := imgidx;
        while ((not found) and (ActPage >= 0)) do
        begin
          found := GetPage(FtxPos, imgidx, ActPage, False);
          if not found then
            Dec(ActPage);
        end;

        if not found then
        begin
//          if  (imgidx <= 0) and ((*(bitfarmApp.GetActivePreview.SearchbarChkCircle.Checked) or *)
//        Commit 14445 ist SearchbarChkCircle.Checked raus geflogen. Gabs da nen Grund fr?
          if  (ActPage <= 0) and (
              ((TbfaPreview(Self.Owner) <> nil) and TbfaPreview(Self.Owner).SearchbarChkCircle.Checked) or
              (BfMessageDlg(_('Kein weiteres Vorkommen gefunden.\nMchten Sie vom Dokumentenende weitersuchen?'),
                mtConfirmation, [mbYes,mbNo]) = mrYes)) then
          begin
            ActPage := imgcnt;
            while ((not found) and (ActPage >= imgidx)) do
            begin
              found := GetPage(FtxPos, imgcnt + 1, ActPage, False);
              if not found then
                Dec(ActPage);
            end;
          end;
        end;

        if ((found) and (ActPage >= 0)) then
        begin
          ShowPage(ActiveDoc, ActPage);
          FtxSearchPos := FtxObjList.Count;
          SelectPreviousFtxSearchPos;
        end;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SelectPreviousFtxSearchPos', ClassName);
  end;
end;

/// <Description>
///   Annos drfen sich nicht berlagern, wenn keine Anno-Admin Rechte.
///   - Stift, Linien und Textmarker sind ausgenommen
/// </Description>
procedure Tfrm_Voransicht.SetObjectPosition;
var
  MTD: TVector2f;
  A, B: TPolygon;
  lbhcol: Boolean;
  hobj, idx2, rights, i, j, k, colobj, imgidx, imgWidth, imgHeight: Integer;
begin
  try
    if (TbfaPreview(Self.Owner).ActiveDoc <> nil) and
       (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView <> nil) and
       (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolViewLoaded) then
    begin
      imgidx := TbfaPreview(Self.Owner).ActivePage;
      imgWidth := img_DocView.Bitmap.Width;
      imgHeight := img_DocView.Bitmap.Height;
    end else
    begin
      imgidx := img_DocView.IO.Params.ImageIndex;
      imgWidth := img_DocView.IO.Params.Width;
      imgHeight := img_DocView.IO.Params.Height;
    end;

    if (img_DocView.SelObjectsCount > 0) then
    begin
      for k := 0 to img_DocView.SelObjectsCount - 1 do
      begin
        hobj := img_DocView.SelObjects[k];
        B := nil;
        A := nil;
        lbhcol := False;

        TbfaPreview(Self.Owner).ActiveDoc.GetAnnotation(imgidx, TbfaPreview(Self.Owner).CurrentLayer, idx2);
        if idx2 <> -1 then
          rights := TbfaPreview(Self.Owner).ActiveDoc.Annotations[idx2].Rights
        else
          rights := TbfaPreview(Self.Owner).ActiveDoc.Rights;

        // da es sein kann dass wir Admin-Rechte haben und nicht in die Schleife unten kommen, setzen wir hier erstmal alles.
        // wenn wir eine deckende Anno haben, holen wir alle durchsichtigen Annos nach vorne
        for I := 0 to img_DocView.ObjectsCount - 1 do
        begin
          colobj := img_DocView.GetObjFromIndex(i);
          if colobj = hobj then
            Continue;

          // hobj ObjKind = iekMEMO && ObjBrushStyle = bsClear - hobj nach vorne holen
          if (img_DocView.ObjKind[hobj] = iekMEMO) and (img_DocView.ObjBrushStyle[hobj] = bsClear) then
            img_DocView.SetObjFrontOf(hobj, -1)

          // 2x ObjKind <> iekMEMO && ObjBrushStyle egal - hobj nach vorne holen
          else if (img_DocView.ObjKind[hobj] <> iekMEMO) and (img_DocView.ObjKind[colobj] <> iekMEMO) then
            img_DocView.SetObjFrontOf(hobj, -1)

          // 2x ObjKind = iekMEMO && 2x ObjBrushStyle <> bsClear
          // wir holen hobj vor colobj
          else if (img_DocView.ObjKind[hobj] = iekMEMO) and (img_DocView.ObjBrushStyle[hobj] <> bsClear) and
                  (img_DocView.ObjKind[colobj] = iekMEMO) and (img_DocView.ObjBrushStyle[colobj] <> bsClear) then
            img_DocView.SetObjFrontOf(hobj, colobj)

          // 2x memo - 1x = clear | 1x <> clear
          // wir setzen = bsClear vor <> bsClear
          else if (img_DocView.ObjKind[hobj] = iekMEMO) and (img_DocView.ObjKind[colobj] = iekMEMO) and
                  (img_DocView.ObjBrushStyle[hobj] <> bsClear) and (img_DocView.ObjBrushStyle[colobj] = bsClear) then
            img_DocView.SetObjFrontOf(colobj, hobj)
          else if (img_DocView.ObjKind[hobj] = iekMEMO) and (img_DocView.ObjKind[colobj] = iekMEMO) and
                  (img_DocView.ObjBrushStyle[hobj] = bsClear) and (img_DocView.ObjBrushStyle[colobj] <> bsClear) then
            img_DocView.SetObjFrontOf(hobj, colobj)

          // 1x memo | 1x egal && memo <> clear - egal clear egal
          else if (img_DocView.ObjKind[hobj] = iekMEMO) and (img_DocView.ObjBrushStyle[hobj] <> bsClear) and (img_DocView.ObjKind[colobj] <> iekMEMO) then
            img_DocView.SetObjFrontOf(colobj, hobj)

          else
            img_DocView.SetObjFrontOf(hobj, colobj);
          // 1x memo | 1x egal - memo = clear - egal clear egal
        end;

        if (((img_DocView.ObjKind[hobj] <> iekLINE) and (img_DocView.ObjBrushStyle[hobj] <> bsClear)) or
            ((img_DocView.ObjKind[hobj] = iekBox) and (img_DocView.ObjBoxHighLight[hobj])) or
            (img_DocView.ObjKind[hobj] = iekMEMO)
           ) and
           (not (((rights and rightAModify) = rightAModify) or ((rights and rightAPModify) = rightAPModify)))
        then
        begin
          try
            A := TPolygon.Create;
            with A do
            begin
              position := to_v2f(img_DocView.ObjLeft[hobj], img_DocView.ObjTop[hobj]);
              AddVertex(to_v2f(0, 0));
              AddVertex(to_v2f(img_DocView.ObjWidth[hobj], 0));
              AddVertex(to_v2f(img_DocView.ObjWidth[hobj], img_DocView.ObjHeight[hobj]));
              AddVertex(to_v2f(0, img_DocView.ObjHeight[hobj]));
            end;

            i := 0;
            j := 0;
            while i < img_DocView.ObjectsCount do
            begin
              colobj := img_DocView.GetObjFromIndex(i);
//              if colobj = hobj then // wir prfen nur bei Notiz ber Notiz auf Kollision
/////////                 not((img_DocView.ObjKind[colobj] = iekMEMO) and (img_DocView.ObjKind[hobj] = iekMEMO)) then
//              var ursprung, ziel: Boolean;
//              // wenn wahr, dann
//              ursprung := not((img_DocView.ObjKind[hobj] = iekMEMO) and (img_DocView.ObjBrushStyle[hobj] = bsSolid));
//              ziel := not((img_DocView.ObjKind[colobj] = iekMEMO) and (img_DocView.ObjBrushStyle[colobj] = bsSolid));
//
//              if ursprung and ziel then
//              begin
//                if (img_DocView.ObjKind[hobj] = iekMEMO) and (img_DocView.ObjBrushStyle[hobj] = bsSolid) then
//                  img_DocView.SetObjBackTo(hobj, colobj)
//                else if (img_DocView.ObjKind[colobj] = iekMEMO) and (img_DocView.ObjBrushStyle[colobj] = bsSolid) then
//                  img_DocView.SetObjBackTo(colobj, hobj);
//              end;

              // wir ignorieren wenn
              if (colobj = hobj) or
                 not((img_DocView.ObjKind[colobj] = iekMEMO) and (img_DocView.ObjBrushStyle[colobj] = bsSolid) and
                     (img_DocView.ObjKind[hobj] = iekMEMO) and (img_DocView.ObjBrushStyle[hobj] = bsSolid)) then
              begin
                i := i + 1;
                Continue;
              end;

              B := TPolygon.Create;
              with B do
              begin
                position := to_v2f(img_DocView.ObjLeft[colobj], img_DocView.ObjTop[colobj]);
                AddVertex(to_v2f(0, 0));
                AddVertex(to_v2f(img_DocView.ObjWidth[colobj], 0));
                AddVertex(to_v2f(img_DocView.ObjWidth[colobj], img_DocView.ObjHeight[colobj]));
                AddVertex(to_v2f(0, img_DocView.ObjHeight[colobj]));
              end;
              i := i + 1;

              if PolyPolyIntersect(a, b, MTD) and ((MTD.x <> 0) or (MTD.y <> 0)) then
              begin
                lbhcol := True;

                while PolyPolyIntersect(a, b, MTD) and ((MTD.x <> 0) or (MTD.y <> 0)) do
                begin
                  if (MTD.x = 0) and (MTD.y = 0) then
                  begin
                    MTD.x := -1;
                    MTD.y := -1;
                  end
                  else
                  begin
                    MTD := v2f_Scale(MTD, (1.05));
                  end;
                  a.position := v2f_add(a.position, MTD);
                end;

                // nur berlagernde Memos werden verschoben
                if ((img_DocView.ObjKind[colobj] = iekMEMO) and (img_DocView.ObjBrushStyle[colobj] <> bsClear)) and
                   ((img_DocView.ObjKind[hobj] = iekMEMO) and (img_DocView.ObjBrushStyle[hobj] <> bsClear)) then
                begin
                  img_DocView.ObjLeft[hobj] := trunc(a.position.x);
                  img_DocView.ObjTop[hobj] := trunc(a.position.y);
                end else
                  lbhcol := False;

                if img_DocView.ObjLeft[hobj] + img_DocView.ObjWidth[hobj] > imgWidth then
                  img_DocView.ObjLeft[hobj] := Trunc(b.Position.X) - img_DocView.ObjWidth[hobj];
                if img_DocView.ObjTop[hobj] + img_DocView.ObjHeight[hobj] > imgHeight then
                  img_DocView.ObjTop[hobj] := Trunc(b.Position.Y) - img_DocView.ObjHeight[hobj];

                if img_DocView.ObjLeft[hobj] < 0 then // mit Rand kollidiert ;-)
                  img_DocView.ObjLeft[hobj] := Trunc(b.Position.X) + Trunc(b.Vertices[2].X);

                if img_DocView.ObjTop[hobj] < 0 then
                  img_DocView.ObjTop[hobj] := Trunc(b.Position.Y) + Trunc(b.Vertices[2].Y);

                A := nil;
                A := TPolygon.Create;
                with A do
                begin
                  position := to_v2f(img_DocView.ObjLeft[hobj], img_DocView.ObjTop[hobj]);
                  AddVertex(to_v2f(0, 0));
                  AddVertex(to_v2f(img_DocView.ObjWidth[hobj], 0));
                  AddVertex(to_v2f(img_DocView.ObjWidth[hobj], img_DocView.ObjHeight[hobj]));
                  AddVertex(to_v2f(0, img_DocView.ObjHeight[hobj]));
                end;
              end;

              if lbhcol then
              begin
                i := 0;
                j := j + 1;
                if j > 50 then
                begin
                  Break;
                end;
                lbhcol := false;
              end;
              if assigned(b) then
                FreeAndNil(b);
            end;

            if lbhcol or ((img_DocView.ObjLeft[hobj] < 0) or (img_DocView.ObjTop[hobj] < 0) or
                (img_DocView.ObjLeft[hobj] + img_DocView.ObjWidth[hobj] > imgWidth) or
                (img_DocView.ObjTop[hobj] + img_DocView.ObjHeight[hobj] > imgHeight)) then
            begin
              img_DocView.ObjLeft[hobj] := fStartPos.X;
              img_DocView.ObjTop[hobj] := fStartPos.Y;
              img_DocView.ObjWidth[hobj] := fObjWidth;
              img_DocView.ObjHeight[hobj] := fObjHeight;
              Exit;
            end;
          finally
            begin
              if assigned(A) then
                FreeAndNil(A);
              if assigned(B) then
                FreeAndNil(B);
            end;
          end;
        end;
        fStartPos.X := img_DocView.ObjLeft[hobj];
        fStartPos.y := img_DocView.ObjTop[hobj];
        fObjWidth := img_DocView.ObjWidth[hobj];
        fObjHeight := img_DocView.ObjHeight[hobj];
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetObjectPosition', ClassName);
  end;
end;

procedure Tfrm_Voransicht.SelectPrevAnno;
var
  index, idx, hobj, rights, imgidx: integer;
  FHobjList: TList<THobj>;
  FHobj, iselect: THobj;
  Found: Boolean;
begin
  try
    try
      //12.06.2018 Ticket 14576 -->
      if (TbfaPreview(Self.Owner).ActiveDoc <> nil) and
         (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView <> nil) and
         (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolViewLoaded)
      then
        imgidx := TbfaPreview(Self.Owner).ActivePage
      else
        imgidx := img_DocView.IO.Params.ImageIndex;
      //12.06.2018 Ticket 14576 <--

      iselect.ind := -1;
      iselect.top := -1;
      iselect.left := -1;

      FHobjList := TList<THobj>.Create;

      for index := 0 to img_DocView.ObjectsCount -1 do
      begin
        idx := index;
        hobj := img_DocView.GetObjFromIndex(idx);
        if img_docview.ObjUserData[hobj] <> nil then
        begin
          TbfaPreview(Self.Owner).ActiveDoc.GetAnnotation(imgidx, TbfaPreview(Self.Owner).CurrentLayer, idx);

          if idx <> -1 then
            rights := TbfaPreview(Self.Owner).ActiveDoc.Annotations[idx].Rights
          else
            rights := TbfaPreview(Self.Owner).ActiveDoc.Rights;

          if (
               (bitfarmApp.User.Name = PAnnoData(img_docview.ObjUserData[hobj])^.ersteller)
                or
               ((rights and rightAModify) = rightAModify)
               or
               ((rights and rightAPModify) = rightAPModify)
             )
          then
          begin
            FHobj.ind := hobj;
            FHobj.top := img_docview.ObjTop[hobj];
            FHobj.left := img_docview.ObjLeft[hobj];
            FHobjList.Add(FHobj);
            if img_DocView.IsSelObject(hobj) then
            begin
              iselect := FHobj;
              Found := True;
            end;
          end;
        end;
      end;

      FHobjList.Sort(
        TComparer<THobj>.Construct(
          function(const Item1, Item2: THobj): Integer
          begin
            Result := 0;
            if (Item1.top > Item2.top) then
              Result := 1
            else if (Item1.top < Item2.top) then
              Result := -1
            else if (Item1.top = Item2.top) then
            begin
              if (Item1.left > Item2.left) then
                Result := 1
              else if (Item1.left < Item2.left) then
                Result := -1
            end;
          end
        )
      );

      if (iselect.ind = -1) then
      begin
        idx := FHobjList.Count - 1;
        Found := False;
      end
      else
        idx := FHobjList.IndexOf(iselect);

      if (idx <> -1) and (FHobjList.Count > 0) then
      begin
        if (idx > 0) and Found then
          dec(idx)
        else if (idx = 0) then
        begin
          img_DocView.Deselect;
          img_DocView.UnSelAllObjects;
          Self.Perform(WM_NEXTDLGCTL, 1, 0);
          Exit;
        end
        else
          idx := FHobjList.Count - 1;

        img_DocView.Deselect;
        img_DocView.UnSelAllObjects;
        img_DocView.AddSelObject(FHobjList[idx].ind);
      end;
      img_DocView.SetFocus;
    finally
      try
        FHobjList.Free;
      except
        //
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SelectPrevAnno', ClassName);
  end;
end;
//procedure Tfrm_Voransicht.SelectPrevAnno;
//var
//	index, idx, hobj, iselect, iself, rights, imgidx : integer;
//	hobjids : TStringList;
//  found: Boolean;
//begin
//  if not (TbfaPreview(Self.Owner).ActiveDoc.InEditMode) then
//    Exit;
//
////12.06.2018 Ticket 14576 -->
//    if (bitfarmApp.WithScanPool) and (TbfaPreview(Self.Owner).ActiveDoc <> nil) and
//       (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView <> nil) and
//       (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolViewLoaded) then
//    begin
////      if (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView.SelectedImage) <> -1 then
////19.09.2018        imgidx := TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView.SelectedImage
//        imgidx := TbfaPreview(Self.Owner).ActivePage;
////      else
////        imgidx := 0;
//
//    end
//    else
//      imgidx := img_DocView.IO.Params.ImageIndex;
////12.06.2018 Ticket 14576 <--
//
//	hobjids := TStringList.Create;
//  iselect := -1;
//
//  for index := 0 to img_DocView.ObjectsCount -1 do
////  for index := img_DocView.ObjectsCount -1 downto 0 do
//  begin
//    idx := index;
//   	hobj := img_DocView.GetObjFromIndex(idx);
//
//    if img_DocView.IsSelObject(hobj) then
//      iselect := hobj;
//
//    if img_docview.ObjUserData[hobj] <> nil then
//    begin
//      TbfaPreview(Self.Owner).ActiveDoc.GetAnnotation(imgidx, TbfaPreview(Self.Owner).CurrentLayer, idx);
//      if idx <> -1 then
//      begin
//        rights := TbfaPreview(Self.Owner).ActiveDoc.Annotations[idx].Rights;
//
//      end else
//        rights := TbfaPreview(Self.Owner).ActiveDoc.Rights;
//      if (
//         (bitfarmApp.User.Name = PAnnoData(img_docview.ObjUserData[hobj])^.ersteller)
//         or
//         ((rights and rightAModify) = rightAModify)
//         or
//         ((rights and rightAPModify) = rightAPModify)
//          )
//      then
//      begin
//        hobjids.add(IntToStr(hobj));
//      end;
//    end;
//  end;
//
//  if iselect = -1 then
//  begin
//  	idx := (hobjids.Count - 1);
//    found := False;
//  end
//  else
//  begin
//  	idx := hobjids.IndexOf(IntToStr(iselect));
//    found := True;
//  end;
//
//  if (idx <> -1) and (hobjids.Count > 0) then
//  begin
//    if (idx > 0) and found then
//      	dec(idx)
//      else
//    if (idx = 0) then
//    begin
//      img_DocView.Deselect;
//      img_DocView.UnSelAllObjects;
//      Self.Perform(WM_NEXTDLGCTL, 1, 0);
//      Exit;
//    end
//    else
//     	idx := hobjids.Count -1;
//
//    img_DocView.Deselect;
//    img_DocView.UnSelAllObjects;
//      img_DocView.AddSelObject(StrToInt(hobjids[idx]));
//  end;
//
//  img_DocView.SetFocus;
//end;



procedure Tfrm_Voransicht.EditSelectedAnno;
var
	idx, hobj: integer;
begin
  try
    for idx := 0 to img_DocView.ObjectsCount -1 do
    begin
      hobj := img_DocView.GetObjFromIndex(idx);
      if img_DocView.IsSelObject(hobj) then
      begin
        img_DocView.ObjTextEditMode := hobj;
        Break;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'EditSelectedAnno', ClassName);
  end;
end;

procedure Tfrm_Voransicht.EscOnTextEdit;
begin
  try
    if img_DocView.ObjTextEditMode > -1 then
      img_DocView.CancelInteracts;
  except
    bitfarmLog.Write(llNormal, ltException, 'EscOnTextEdit', ClassName);
  end;
end;

procedure Tfrm_Voransicht.img_DocViewKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  try
    if Shift = [] then
    begin
      case Key of
        VK_DELETE: AnnoDelete(self);
        VK_RETURN: EditSelectedAnno;
        VK_TAB: SelectNextAnno;
        VK_ESCAPE: EscOnTextEdit;
      end;

      if Key = VK_BACK then
      begin
        if TbfaPreview(Owner).PreviewKind = pvkMultiSingle then
          frmMainForm.actPreviewBack.Execute;
      end;
    end
    else if Shift = [ssShift] then
    begin
      case Key of
        VK_TAB: SelectPrevAnno;
      end;
    end
    else if Shift = [ssCtrl] then
    begin
      case Key of
        Ord('A'):
        begin
          if ((TbfaPreview(Owner).ActiveDoc <> nil) and
              ((TbfaPreview(Owner).ActiveDoc.ID = -1 ) or
              (TbfaPreview(Owner).ActiveDoc.InEditMode))) then
          begin
            img_DocView.SelAllObjects;
          end;
        end;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'img_DocViewKeyUp', ClassName);
  end;
end;

procedure Tfrm_Voransicht.createannodata(fidx: integer);
var
  mydata: PAnnoData;
  lstmp: string;
begin
  try
    GetMem(mydata, SizeOf(TAnnoData));
    mydata^.Ersteller := bitfarmApp.User.Name;
    mydata^.Veraenderer := '';
    DateTimeToString(lstmp, 'dd.mm.yyyy hh:nn:ss', now);
    mydata^.Datum := lstmp;
    // SJ 12.07.2021 - nderung auf 0.2 // siehe TAnnoData Deklaration
    mydata^.version := '0.2';
    CreateGUID(mydata^.GUID);
    img_DocView.ObjUserDataLength[fidx] := SizeOf(TAnnoData);
    img_DocView.ObjUserData[fidx] := mydata;
  except
    bitfarmLog.Write(llNormal, ltException, 'createannodata', ClassName);
  end;
end;

procedure Tfrm_Voransicht.img_DocViewMouseLeave(Sender: TObject);
begin
  if img_DocView.ObjTextEditMode <> -1 then   // tatschlich wird beim stellen einer Anno in TextEditMode MouseLeave aufgerufen
    Exit;                                    // wir mssen hier wieder raus, damit fLastControl nicht wieder den Focus erhlt (Trefferliste)

  fbmouseinim := False;
  try
    if Assigned(fOnMouseLeave) then
      fOnMouseLeave;
    img_DocView.Cursor := 0;
  except on e: exception do
    bitfarmLog.Write(llNormal, ltException, 'img_DocViewMouseLeave: e='+e.Message, ClassName);
  end;
end;

function Tfrm_Voransicht.CheckAnnoRights: Boolean;
begin
  try
    Result := False;

    if TbfaPreview(Owner).ActiveDoc.ID = -1 then
      Result := True
    else
    begin
      if fAnnoType = 0 then
      begin
        if (not ((TbfaPreview(Owner).ActiveDoc.Rights and rightAWrite) = rightAWrite)) then
          Result := False
        else
          Result := True;
      end;

      if fAnnoType = 1 then
      begin
        if (fPrivAnnoID <> 0) and (bitfarmApp.User.ID <> fPrivAnnoID) then
        begin
          if (not ((TbfaPreview(Owner).ActiveDoc.Rights and rightAPWrite) = rightAPWrite)) then
            Result := False
          else
            Result := True;
        end
        else  // eigenen Layer darf man immer
          Result := True;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'CheckAnnoRights', ClassName);
  end;
end;

procedure Tfrm_Voransicht.img_DocViewMouseEnter(Sender: TObject);
begin
  try
    if img_DocView.MouseInteractVt <> [] then
    begin
      if img_DocView.MouseInteractVt = [miObjectSelect] then
        img_DocView.Cursor := 1780
      else
        img_DocView.Cursor := 1785;
    end;
    fbmouseinim := true;
  except
    bitfarmLog.Write(llNormal, ltException, 'img_DocViewMouseEnter', ClassName);
  end;
end;

procedure Tfrm_Voransicht.updateobjects;
var
	i, liobjcount: integer;
begin
  try
    liobjcount := img_DocView.ObjectsCount;
    setlength(fobjposition, liobjcount);
    setlength(fobjdimension, liobjcount);
    i := 0;
    while i < liobjcount do
    begin
      fobjposition[i].X := img_DocView.ObjLeft[i];
      fobjposition[i].Y := img_DocView.ObjTop[i];
      fobjdimension[i].X := img_DocView.Objwidth[i];
      fobjdimension[i].Y := img_DocView.Objheight[i];
      inc(i);
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'updateobjects', ClassName);
  end;
end;

procedure Tfrm_Voransicht.ZoomIn;
// siehe TfrmQuickPreview.imgQuickPreviewZoomIn;
  function imax(v1, v2: Integer): Integer;
  asm
    cmp	edx,eax
    jng	@1
    mov	eax,edx
  @1:
  end;
begin
  try
    img_DocView.Zoom := img_DocView.Zoom + imax(round(img_DocView.Zoom * img_DocView.MouseWheelParams.Value / 100), 1) * 1;
  except
    bitfarmLog.Write(llNormal, ltException, 'ZoomIn', ClassName);
  end;
end;

procedure Tfrm_Voransicht.ZoomOut;
// siehe TfrmQuickPreview.imgQuickPreviewZoomOut;
  function imax(v1, v2: Integer): Integer;
  asm
    cmp	edx,eax
    jng	@1
    mov	eax,edx
  @1:
  end;
begin
  try
    img_DocView.Zoom := img_DocView.Zoom + imax(round(img_DocView.Zoom * img_DocView.MouseWheelParams.Value / 100), 1) * -1;
  except
    bitfarmLog.Write(llNormal, ltException, 'ZoomIn', ClassName);
  end;
end;

function Tfrm_Voransicht.GetLongestLine(fstl: TStrings): string;
var
  i, lil, lilinel, lftextwidth: integer;
begin
  try
    if fstl.Count = 0 then
    begin
      Result := '';
      Exit;
    end;

    lilinel := 0;
    lftextwidth := 0;

    for i := 0 to fstl.Count - 1 do
    begin
      lil := length(fstl.Strings[i]);
      if lftextwidth < lil then
      begin
        lftextwidth := lil;
        lilinel := i;
      end;
    end;
    Result := fstl.Strings[lilinel];
  except
    bitfarmLog.Write(llNormal, ltException, 'GetLongestLine', ClassName);
  end;
end;

procedure Tfrm_Voransicht.textanObjektpassen(fstl: TStrings; idx: Integer = -1);
var
  lilinelength: integer;
  lslongestline: string;
begin
  try
    lslongestline := GetLongestLine(fstl);
    if lslongestline = '' then
    begin
      img_DocView.ObjText[idx] := '';
      Exit;
    end;
    lilinelength := img_DocView.GetCanvas.TextWidth(lslongestline);
    img_DocView.ObjWidth[idx] := trunc(lilinelength * img_DocView.ObjFontHeight[idx] / 12);
    img_DocView.ObjHeight[idx] := fstl.Count * (trunc(abs(img_DocView.ObjFontHeight[idx]) * 3 / 2.5));
    img_DocView.ObjText[idx] := Copy(fstl.Text, 1, length(fstl.Text) -1);
  except
    bitfarmLog.Write(llNormal, ltException, 'textanObjektpassen', ClassName);
  end;
end;

procedure Tfrm_Voransicht.img_DocViewObjectMoveResize(Sender: TObject; hobj, Grip: Integer; var OffsetX, OffsetY: Integer);
begin
  try
    if Assigned(fOnObjectMoveResize) then
      fOnObjectMoveResize;

    fObjectMoved := True;

    fobjdel := False;
    img_DocView.ObjEditOnNewText := False;
    gbAnnoNotSaved := True;
    TbfaPreview(Self.Owner).ActiveDoc.Modified_Annos := True;
    img_DocView.ObjGraphicRender := False;
    img_DocView.EnableAlphaChannel := False;
    if length(fobjposition) <= hobj then
      setlength(fobjposition, hobj + 1);

    fobjposition[hobj].X := img_DocView.ObjLeft[hobj];
    fobjposition[hobj].y := img_DocView.ObjTop[hobj];
  except on e: exception do
    bitfarmLog.Write(llNormal, ltException, 'img_DocViewObjectMoveResize: e='+e.Message, ClassName);
  end;
end;

// setzt die durchsichtigen Annos nach vorne
procedure Tfrm_Voransicht.img_DocViewUserDeselectObject(Sender: TObject;
  hobj: Integer);
var
  rights, imgidx, idx2: Integer;
begin
  try
    if (TbfaPreview(Self.Owner).ActiveDoc <> nil) and
       (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView <> nil) and
       (TbfaPreview(Self.Owner).ActiveDoc.ScanPoolViewLoaded)
    then
      imgidx := TbfaPreview(Self.Owner).ActivePage
    else
      imgidx := img_DocView.IO.Params.ImageIndex;

    TbfaPreview(Self.Owner).ActiveDoc.GetAnnotation(imgidx, TbfaPreview(Self.Owner).CurrentLayer, idx2);
    if idx2 <> -1 then
      rights := TbfaPreview(Self.Owner).ActiveDoc.Annotations[idx2].Rights
    else
      rights := TbfaPreview(Self.Owner).ActiveDoc.Rights;

    if (not (((rights and rightAModify) = rightAModify) or
            ((rights and rightAPModify) = rightAPModify))) then
    begin
      if img_DocView.ObjBrushStyle[hobj] <> bsClear then
        img_DocView.SetObjBackTo(hobj, -1);
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'img_DocViewUserDeselectObject', ClassName);
  end;
end;

// setzt die durchsichtigen Annos nach vorne
procedure Tfrm_Voransicht.img_DocViewSelectObject(Sender: TObject);
var
  hobj, idx: integer;
begin
  try
    for idx := 0 to img_DocView.ObjectsCount -1 do
    begin
    	hobj := img_DocView.GetObjFromIndex(idx);
      if (img_DocView.ObjBrushStyle[hobj] = bsClear) or
      	 (img_DocView.ObjKind[hobj] = iekLine)
      then
   		  img_DocView.SetObjFrontOf(hobj,-1);
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'img_DocViewSelectObject', ClassName);
  end;
end;

procedure Tfrm_Voransicht.img_DocViewTextKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  AInsertValue: AnsiString;
begin
  if (Sender is TIETextControl) and (ssCtrl in Shift) and (Key = 226) {< | >} then
  begin
    try
      try
        Self.img_DocView.LockPaint;
        if (ssShift in Shift) then
          AInsertValue := AnsiString(FormatDateTime(formatSettings.ShortDateFormat, Now()))
        else
          AInsertValue := AnsiString(bitfarmApp.User.Name);

        if (AInsertValue <> '') then
        begin
          if TbfaIETextControl(Sender).fSelStop > TbfaIETextControl(Sender).fSelStart then
            TbfaIETextControl(Sender).RemoveSelected;

          if Length(AInsertValue) > 0 then
            for var I := 1 to Length(AInsertValue) do
              {$IFDEF IMAGEEN1140}
              TbfaIETextControl(Sender).AddChar(Char(AInsertValue[I]));
              {$ELSE}
              TbfaIETextControl(Sender).AddChar(AInsertValue[I]);
              {$ENDIF}
        end;
      except
        bitfarmLog.Write(llNormal, ltException, 'img_DocViewTextKeyDown', ClassName);
      end;
    finally
      Self.img_DocView.Update;
      Self.img_DocView.UnLockPaint;
    end;
  end;
end;

procedure Tfrm_Voransicht.saveannostream(preproc : Boolean = True; Doc: TbfaDocument = nil);
var
  idx, idx2, i, k, l, j, imgidx : integer;
  AnnoObj : TbfaAnnotation;
  found: Boolean;
  ADocument: TbfaDocument;

  function GetIVectObjKind(ObjKind : TIEVObjectKind) : string;
  begin
    try
      Result := '';
      case ObjKind of
        iekLINE : Result := 'iekLINE';
        iekBOX : Result := 'iekBOX';
        iekELLIPSE : Result := 'iekELLIPSE';
        iekARC : Result := 'iekARC';
        iekBITMAP : Result := 'iekBITMAP';
        iekTEXT : Result := 'iekTEXT';
        iekRULER : Result := 'iekRULER';
        iekPOLYLINE : Result := 'iekPOLYLINE';
        iekANGLE : Result := 'iekANGLE';
        iekMEMO : Result := 'iekMEMO';
        iekLINELABEL : Result := 'iekLINELABEL';
      end;
    except
      Result := '';
    end;
  end;

begin
  bitfarmLog.DebugBegin(llDebug, 'saveannostream', ClassName);
  try
    try
      if Doc = nil then
        ADocument := TbfaPreview(Self.Owner).ActiveDoc
      else
        ADocument := Doc;

      if ADocument = nil then
      begin
        bitfarmLog.Write(llDebug, ltInfo, 'TbfaPreview(Self.Owner).ActiveDoc = nil', ClassName);
        Exit;
      end;

      if (ADocument.ScanPoolView <> nil) and (ADocument.ScanPoolViewLoaded) then
        imgidx := TbfaPreview(Self.Owner).ActivePage
      else
        imgidx := img_DocView.IO.Params.ImageIndex;

      ADocument.GetAnnotation(imgidx, TbfaPreview(Self.Owner).CurrentLayer, idx);

      if idx = -1 then
      begin
        bitfarmLog.Write(llDebug, ltInfo, 'saveannostream - idx = -1', ClassName);

        if img_DocView.ObjectsCount > 0 then  //15.12.2017 Ticket 12410
        begin
          bitfarmLog.Write(llDebug, ltInfo, 'saveannostream - img_DocView.ObjectsCount = ' + IntToStr(img_DocView.ObjectsCount), ClassName);
          idx := 0;
          AnnoObj := TbfaAnnotation.Create;
          img_DocView.SaveToStreamIEV(AnnoObj.AnnoStream);
          AnnoObj.AnnoStream.Position := 0;
          AnnoObj.Page := imgidx;
          AnnoObj.Layer := TbfaPreview(Self.Owner).CurrentLayer;

          if AnnoObj.Layer = 0 then   // beim public layer gelten die Archivrechte
            AnnoObj.rights := ADocument.Rights
          else if AnnoObj.Layer = bitfarmApp.User.ID then   // private Layer hat alle Rechte
            AnnoObj.rights := (rightAPRead or rightAPWrite or rightAPModify)
          else
          begin  // freigegebener layer ohne eine annotation bisher? datenbankabfrage
            AnnoObj.rights := DbTableColumnGetInteger(Format('select bit_or(rights) from sys_docxs where gdocid = %d and src_userid = %d and userid = %d',
              [ADocument.ID, AnnoObj.Layer, bitfarmApp.User.ID]));
          end;

          AnnoObj.Modified := True;

          bitfarmLog.Write(llDebug, ltInfo, 'saveannostream - img_DocView.SelObjectsCount = ' + IntToStr(img_DocView.SelObjectsCount), ClassName);
          for i := 0 to img_DocView.SelObjectsCount - 1 do
          begin
            idx2 := img_DocView.SelObjects[i];
            SetLength(AnnoObj.ObjList, Length(AnnoObj.ObjList) + 1);
            with AnnoObj.ObjList[High(AnnoObj.ObjList)] do
            begin
              ID := idx2;
              ObjKind := img_DocView.ObjKind[idx2];
              ModifiedType := 0;
              if (img_DocView.ObjKind[idx2] in [iekBOX, iekTEXT, iekMEMO]) then
                ObjText := img_DocView.ObjText[idx2];

              NewText := '';
              Modified := True;
            end;
            bitfarmLog.Write(llDebug, ltInfo, 'saveannostream - AnnoObj.ObjList[High(AnnoObj.ObjList)].ID: ' + IntToStr(idx2), ClassName);
            bitfarmLog.Write(llDebug, ltInfo, 'saveannostream - AnnoObj.ObjList[High(AnnoObj.ObjList)].ObjKind: ' + GetIVectObjKind(AnnoObj.ObjList[High(AnnoObj.ObjList)].ObjKind), ClassName);
            bitfarmLog.Write(llDebug, ltInfo, 'saveannostream - AnnoObj.ObjList[High(AnnoObj.ObjList)].ObjText: ' + AnnoObj.ObjList[High(AnnoObj.ObjList)].ObjText, ClassName);
          end;

          ADocument.Annotations.Add(AnnoObj);
          bitfarmLog.Write(llDebug, ltInfo, 'saveannostream - TbfaPreview(Self.Owner).ActiveDoc.Annotations.Add(AnnoObj);', ClassName);

          if TbfaPreview(Self.Owner).ShowThumbnail then
          begin
            //15.03.2017
            CreateThumbnailWithAnno(img_DocView, TbfaPreview(Self.Owner), ADocument);
          end;
          
          if (ADocument.ID = -1) and (ADocument.ThumbnailView <> nil) and (TbfaPreview(Self.Owner).Floating) then
            ADocument.ThumbnailView.Clear;
        end;
      end
      else
      begin
        bitfarmLog.Write(llDebug, ltInfo, 'saveannostream - idx <> -1', ClassName);

        if preproc then
          img_DocView.CancelInteracts;

        if (img_DocView.SelObjectsCount > 0) then
        begin
          for i := 0 to img_DocView.SelObjectsCount - 1 do
          begin
            idx2 := img_DocView.SelObjects[i];
            found := False;
            k := 0;
            while ((not found) and (k <= High(ADocument.Annotations[idx].ObjList))) do
            begin
              if (idx2 = ADocument.Annotations[idx].ObjList[k].ID) and
                 (ADocument.Annotations[idx].ObjList[k].ModifiedType <> 2)
              then //25.04.2019 gelscht bleibt auch in der Liste wegen Historyeintrag!
                found := True
              else
                Inc(k);
            end;

            if found then
            begin
              with ADocument.Annotations[idx].ObjList[k] do
              begin
                if not ((Modified) and (ModifiedType = 0)) then
                begin
                  ModifiedType := 1;
                  if (img_DocView.ObjKind[idx2] in [iekBOX, iekTEXT, iekMEMO]) and
                     (ObjText <> img_DocView.ObjText[idx2])
                  then
                    NewText := img_DocView.ObjText[idx2];
                end
                else
                begin
                  if (img_DocView.ObjKind[idx2] in [iekBOX, iekTEXT, iekMEMO]) and
                     (ObjText <> img_DocView.ObjText[idx2])
                  then
                    ObjText := img_DocView.ObjText[idx2];
                end;
                Modified := True;
              end;

              bitfarmLog.Write(llDebug, ltInfo, 'saveannostream - found: True', ClassName);
              bitfarmLog.Write(llDebug, ltInfo, 'saveannostream - TbfaPreview(Self.Owner).ActiveDoc.Annotations[idx].ObjList[k].ModifiedType: ' + IntToStr(TbfaPreview(Self.Owner).ActiveDoc.Annotations[idx].ObjList[k].ModifiedType), ClassName);
              bitfarmLog.Write(llDebug, ltInfo, 'saveannostream - TbfaPreview(Self.Owner).ActiveDoc.Annotations[idx].ObjList[k].ID: ' + IntToStr(idx2), ClassName);
              bitfarmLog.Write(llDebug, ltInfo, 'saveannostream - TbfaPreview(Self.Owner).ActiveDoc.Annotations[idx].ObjList[k].ObjKind: ' + GetIVectObjKind(TbfaPreview(Self.Owner).ActiveDoc.Annotations[idx].ObjList[k].ObjKind), ClassName);
              bitfarmLog.Write(llDebug, ltInfo, 'saveannostream - TbfaPreview(Self.Owner).ActiveDoc.Annotations[idx].ObjList[k].ObjText: ' + TbfaPreview(Self.Owner).ActiveDoc.Annotations[idx].ObjList[k].ObjText, ClassName);
              bitfarmLog.Write(llDebug, ltInfo, 'saveannostream - TbfaPreview(Self.Owner).ActiveDoc.Annotations[idx].ObjList[k].NewText: ' + TbfaPreview(Self.Owner).ActiveDoc.Annotations[idx].ObjList[k].NewText, ClassName);

            end
            else
            begin
              SetLength(ADocument.Annotations[idx].ObjList, Length(ADocument.Annotations[idx].ObjList) + 1);
              with ADocument.Annotations[idx].ObjList[High(ADocument.Annotations[idx].ObjList)] do
              begin
                ID := idx2;
                ObjKind := img_DocView.ObjKind[idx2];
                ModifiedType := 0;
                if (img_DocView.ObjKind[idx2] in [iekBOX, iekTEXT, iekMEMO]) then
                  ObjText := img_DocView.ObjText[idx2];
                NewText := '';
                Modified := True;

                bitfarmLog.Write(llDebug, ltInfo, 'saveannostream - found: False', ClassName);
                bitfarmLog.Write(llDebug, ltInfo, 'saveannostream - ID: ' + IntToStr(idx2), ClassName);
                bitfarmLog.Write(llDebug, ltInfo, 'saveannostream - ObjKind: ' + GetIVectObjKind(img_DocView.ObjKind[idx2]), ClassName);
                bitfarmLog.Write(llDebug, ltInfo, 'saveannostream - ObjText: ' + img_DocView.ObjText[idx2], ClassName);
              end;
            end;
          end;
        end;

        if FRemovedObjects.Count > 0 then
        begin
          for i := Low(ADocument.Annotations[idx].ObjList) to High(ADocument.Annotations[idx].ObjList) do
          begin
            for j := 0 to FRemovedObjects.Count - 1 do
            begin
              if ADocument.Annotations[idx].ObjList[i].ID = StrToInt(FRemovedObjects[j]) then
              begin
                with ADocument.Annotations[idx].ObjList[i] do
                begin
//                  if Name = '' then
//                    Name := ObjKindToStr(ADocument.Annotations[idx].ObjList[i].ID);
                  ModifiedType := 2;
                  Modified := True;

                  bitfarmLog.Write(llDebug, ltInfo, 'saveannostream - Deleted - ID: ' + IntToStr(ADocument.Annotations[idx].ObjList[i].ID), ClassName);
                  bitfarmLog.Write(llDebug, ltInfo, 'saveannostream - Deleted - ObjKind: ' + GetIVectObjKind(ADocument.Annotations[idx].ObjList[i].ObjKind), ClassName);
                  bitfarmLog.Write(llDebug, ltInfo, 'saveannostream - Deleted - ObjText: ' + ADocument.Annotations[idx].ObjList[i].ObjText, ClassName);
                end;
              end;
            end;
          end;
        end;
        if img_DocView.ObjectsCount > 0 then
        begin
          ADocument.Annotations[idx].AnnoStream.Clear;
          img_DocView.SaveToStreamIEV(ADocument.Annotations[idx].AnnoStream);
          ADocument.Annotations[idx].AnnoStream.Position := 0;
          ADocument.Annotations[idx].Modified := True;
        end
        else if (img_DocView.ObjectsCount = 0) and (FRemovedObjects.Count > 0) then
        begin
          ADocument.Annotations[idx].AnnoStream.Clear;
          ADocument.DeleteAnno(ADocument.Annotations[idx].Page);
          ADocument.Modified_AnnosDelete := True;
          if idx < ADocument.Annotations.Count then
            ADocument.Annotations[idx].Modified := True;
        end;

        if (TbfaPreview(Self.Owner).ShowThumbnail) then
          CreateThumbnailWithAnno(img_DocView, TbfaPreview(Self.Owner), ADocument);

        if (ADocument.ID = -1) and (ADocument.ThumbnailView <> nil) and (TbfaPreview(Self.Owner).Floating) then
          ADocument.ThumbnailView.Clear;

        gbAnnoNotSaved := False;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'saveannostream', ClassName);
    end;
  finally
    fRefreshInOtherPrevs := True;
    FRemovedObjects.Clear;
    bitfarmLog.DebugEnd(llDebug, 'saveannostream', ClassName);
  end;
end;

end.

