unit AdminFrame;

{$optimization off}

interface

uses
  gnugettext, Windows, Messages, SysUtils, System.Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SpTBXTabs, TB2Item, SpTBXItem, u_bfaInputCombo, SpTBXControls, WinApi.ActiveX, System.Win.ComObj,
  StdCtrls, CheckLst, SpTBXEditors, u_bfaSelector, u_bfaInputEdit, ExtCtrls,
  DBGrids, Grids, CRGrid, u_bfaGrid, cxGraphics, cxControls, cxLookAndFeels,
  cxLookAndFeelPainters, cxContainer, cxEdit, ComCtrls, cxDateUtils,
  cxTextEdit, cxMaskEdit, cxDropDownEdit, cxCalendar, Mask, JvExMask, Vcl.OleServer,
  JvToolEdit, JvCombobox, bfaObjects36, bfaBaseObjects, bfaParser, ContractMgmt,
  Generics.Collections, Uni, SplashForm, {ActiveDs_TLB, adshlp, u_ActivediretoryUtils,}
  u_ActiveDirectoryVorschau, DB, DBAccess, MemDS, DLMForm, ChoseReportForm, dxCore, graphutil,
  LoggedinUserForm, SpTBXDkPanels, SpTBXCustomizer, u_bfaSplitter, Vcl.Menus;

resourcestring
  sHintRightsShow                         = 'Dokumente Anzeigen, Zoomen, zum Arbeitsplatz senden'; // Anzeigen
  sHintRightsSearch                       = 'Suchen im Archiv mit Anzeige Trefferliste (bentigt Anzeigen)'; // Suchen
  sHintRightsEdit                         = 'Dokument bearbeiten (Zusatzfelder, Statusfelder, Schlagworte), Voransicht bearbeiten (Invertieren, Rand entfernen, Drehen, Verbinden)'; // ndern/Bearbeiten
  sHintRightsWrite                        = 'Originaldatei ffnen, Dokument lokal speichern (Original, als Tiff, als PDF), Seite in Zwischenablage kopieren'; // Schreiben
  sHintRightsEmail                        = 'Alle Emailfunktionen'; // Email-Versand
  sHintRightsMove                         = 'Dokumente innerhalb des Archives verschieben. Im Zielarchiv muss man Importrechte haben'; // Verschieben
  sHintRightsDelete                       = 'NRS (nicht revisionssichere) - Dokumente lschen'; // Lschen
  sHintRightsExport                       = 'Zum Export markieren, Ordner exportieren'; // Exportieren
  sHintRightsPrint                        = 'Alle Druckfunktionen'; // Drucken
  sHintRightsLinks                        = 'Verknpfung erstellen, Dokumente aus Verknpfungen entfernen'; // Verknpfung
  sHintRightsImport                       = 'Dokument archivieren (Importer) und verschieben im Viewer (im Zielarchiv bentigt)'; // Importieren
  sHintRightsHistory                      = 'History-Reiter anzeigen'; // History anzeigen
  sHintRightsWorkflow                     = 'Anzeige des Abbrechen-Buttons in der Wiedervorlage'; // Workflow abbrechen
  sHintRightsAdminFunctions               = 'globale Lesezeichen erstellen (Editor), Originaldokument wiederherstellen, ausgecheckte Dokumente anderer User sehen'; // Admin-Funktionen
  sHintRightsLogShowDoc                   = 'Es wird ein Historyeintrag erzeugt, wenn der Benutzer das Dokument gesehen hat.'; // Lesen protokollieren
  sHintRightsSetRevSave                   = 'Dokument revisionssicher ablegen'; // Revisionssicher ablegen
  sHintRightsReadAnnos                    = 'Anmerkungen ansehen'; // Anmerkungen lesen
  sHintRightsWriteAnnos                   = 'Anmerkungen anlegen und ndern (nur eigene), Diskussionen schreiben'; // Anmerkungen schreiben
  sHintRightsEditAnnos                    = 'Anmerkungen anderer Benutzer ndern/lschen, Diskussionen ndern / lschen'; // Anmerkungen ndern

const
  cDbTrue  = '*';
  cDbFalse = '-';

    CheckListBoxHints: array[0..18] of string = (
      sHintRightsShow,
      sHintRightsSearch,
      sHintRightsEdit,
      sHintRightsWrite,
      sHintRightsEmail,
      sHintRightsMove,
      sHintRightsDelete,
      sHintRightsExport,
      sHintRightsPrint,
      sHintRightsLinks,
      sHintRightsImport,
      sHintRightsHistory,
      sHintRightsWorkflow,
      sHintRightsAdminFunctions,
      sHintRightsLogShowDoc,
      sHintRightsSetRevSave,
      sHintRightsReadAnnos,
      sHintRightsWriteAnnos,
      sHintRightsEditAnnos
    );

type
  TGroup = record
    Name: string;
    Ldap: string;
    Adclass: string;
    AdUser: TStringList;
    AdMail: TStringList;
    AdDispName: TStringList;
  end;

  TAdGroups = array of TGroup;

  type TDummy = TList<Integer>;

type
  TfraAdmin = class(TFrame)
    pnlButtons: TSpTBXPanel;
    btnSaveAdmin: TSpTBXButton;
    btnCancelAdmin: TSpTBXButton;
    btnApplyAdmin: TSpTBXSpeedButton;
    dsResubSearch: TUniDataSource;
    mqResubSearch: TUniQuery;
    SpTBXPanel2: TSpTBXPanel;
    tabctrAdmin: TSpTBXTabControl;
    tabGlobale: TSpTBXTabItem;
    tabAssign: TSpTBXTabItem;
    tabResub: TSpTBXTabItem;
    tabLog: TSpTBXTabItem;
    SpTBXTabSheet4: TSpTBXTabSheet;
    grpbxWvlSearch: TSpTBXGroupBox;
    rbID: TSpTBXRadioButton;
    rbUser: TSpTBXRadioButton;
    edtArcid: TSpTBXEdit;
    edtGdocid: TSpTBXEdit;
    edtTimref: TSpTBXEdit;
    cbxResubUser: TSpTBXComboBox;
    cbxResubSearchMode: TSpTBXComboBox;
    dtResubDate: TcxDateEdit;
    btnSearchresub: TSpTBXButton;
    btnResetSearch: TSpTBXButton;
    btnDeleteResub: TSpTBXButton;
    lblWvlArcId: TSpTBXLabel;
    lblGdocid: TSpTBXLabel;
    lblTimref: TSpTBXLabel;
    lblResubUser: TSpTBXLabel;
    lblResubDate: TSpTBXLabel;
    SpTBXTabSheet6: TSpTBXTabSheet;
    grpbxHistorySearch: TSpTBXGroupBox;
    cbxLogUser: TSpTBXComboBox;
    dtDateLogStart: TcxDateEdit;
    dtDateLogEnd: TcxDateEdit;
    lblLogUser: TSpTBXLabel;
    lblDateLogStart: TSpTBXLabel;
    lblDateLogEnd: TSpTBXLabel;
    rbAdminLog: TSpTBXRadioButton;
    rbDocHistory: TSpTBXRadioButton;
    lblLogGdocid: TSpTBXLabel;
    edtLogGdocid: TSpTBXEdit;
    btnSearchLog: TSpTBXButton;
    btnSearchLogCancel: TSpTBXButton;
    btnOffsetDec: TSpTBXButton;
    btnOffsetInc: TSpTBXButton;
    lblRecords: TSpTBXLabel;
    lblRange: TSpTBXLabel;
    lbl1: TSpTBXLabel;
    lbl2: TSpTBXLabel;
    lvAdminLog: TListView;
    SpTBXTabSheet2: TSpTBXTabSheet;
    SpTBXPanel8: TSpTBXPanel;
    SpTBXPanel11: TSpTBXPanel;
    grpbxTreeviewControls: TSpTBXGroupBox;
    btnCheckAll: TSpTBXButton;
    btnUnCheckAll: TSpTBXButton;
    btnExpandAll: TSpTBXButton;
    btnCollapseAll: TSpTBXButton;
    lblSelected: TSpTBXLabel;
    lblCurrent: TSpTBXLabel;
    lblAssignUsersAndGroups: TSpTBXLabel;
    bfsAssignUser: TbfaSelector;
    SpTBXPanel12: TSpTBXPanel;
    lblArchiveRights: TSpTBXLabel;
    lblRoleArcRights: TSpTBXLabel;
    cbxArcRights: TSpTBXComboBox;
    chbxArchiveRights: TSpTBXCheckListBox;
    SpTBXSplitter6: TSpTBXSplitter;
    SpTBXPanel9: TSpTBXPanel;
    SpTBXPanel13: TSpTBXPanel;
    lblAssignAddfields: TSpTBXLabel;
    bfsAssignAddfields: TbfaSelector;
    SpTBXPanel14: TSpTBXPanel;
    lblAssignUserGroupsToAddfields: TSpTBXLabel;
    bfsAddfieldsUser: TbfaSelector;
    SpTBXPanel15: TSpTBXPanel;
    chbxAddfieldRights: TSpTBXCheckListBox;
    lblAddfieldRights: TSpTBXLabel;
    SpTBXSplitter7: TSpTBXSplitter;
    SpTBXSplitter8: TSpTBXSplitter;
    SpTBXSplitter4: TSpTBXSplitter;
    SpTBXSplitter5: TSpTBXSplitter;
    SpTBXPanel10: TSpTBXPanel;
    SpTBXPanel16: TSpTBXPanel;
    lblAssignStatefields: TSpTBXLabel;
    bfsAssignStatefields: TbfaSelector;
    SpTBXPanel17: TSpTBXPanel;
    lblAssignUserGroupsToStatefields: TSpTBXLabel;
    bfsStatefieldsUser: TbfaSelector;
    SpTBXPanel18: TSpTBXPanel;
    lblStatefieldRights: TSpTBXLabel;
    chbxStatefieldRights: TSpTBXCheckListBox;
    SpTBXSplitter9: TSpTBXSplitter;
    SpTBXSplitter10: TSpTBXSplitter;
    SpTBXTabSheet1: TSpTBXTabSheet;
    SpTBXPanel19: TSpTBXPanel;
    SpTBXPanel21: TSpTBXPanel;
    grpbxLager: TSpTBXGroupBox;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    bfiRepos: TbfaInputCombo;
    bfiArchives: TbfaInputCombo;
    bfiAddfields: TbfaInputCombo;
    bfiStatefields: TbfaInputCombo;
    lblReposDescr: TSpTBXLabel;
    lblArcDescr: TSpTBXLabel;
    lblAddfield: TSpTBXLabel;
    lblStatefields: TSpTBXLabel;
    lblReposID: TSpTBXLabel;
    lblArcID: TSpTBXLabel;
    edtDocname: TSpTBXEdit;
    lblStandardDoctitle: TSpTBXLabel;
    lblStationary: TSpTBXLabel;
    edtStationary: TSpTBXButtonEdit;
    chkDocnameMandatory: TSpTBXCheckBox;
    cbxAddfieldType: TSpTBXComboBox;
    cbxSearchMode: TSpTBXComboBox;
    btnAddListItems: TSpTBXButton;
    chkStrictmode: TSpTBXCheckBox;
    chkAddfieldmandatory: TSpTBXCheckBox;
    chkLinkfield: TSpTBXCheckBox;
    chkSavename: TSpTBXCheckBox;
    cbxStatefieldLink: TSpTBXComboBox;
    cbxLinkType: TSpTBXComboBox;
    lblStatefieldLink: TSpTBXLabel;
    lblLinkType: TSpTBXLabel;
    btnCreateTPLFile: TSpTBXButton;
    btnCreateFNDFile: TSpTBXButton;
    lblAddfieldType: TSpTBXLabel;
    lblSearchmode: TSpTBXLabel;
    chkDocnameArchive: TSpTBXCheckBox;
    lblAddfieldID: TSpTBXLabel;
    lblStatefieldID: TSpTBXLabel;
    edtAddfieldDescription: TSpTBXEdit;
    lblAddfieldDescription: TSpTBXLabel;
    lblAddname: TSpTBXLabel;
    lblBitmask: TSpTBXLabel;
    lblIndex: TSpTBXLabel;
    lblDocLife: TSpTBXLabel;
    edtDuration: TSpTBXSpinEdit;
    chkDLM: TSpTBXCheckBox;
    cbxInterval: TSpTBXComboBox;
    grpbxReport: TSpTBXGroupBox;
    btnReport: TSpTBXButton;
    btnDLM: TSpTBXButton;
    SpTBXPanel22: TSpTBXPanel;
    grpbxUsers: TSpTBXGroupBox;
    bfiUser: TbfaInputCombo;
    lblUser: TSpTBXLabel;
    lblDisplayName: TSpTBXLabel;
    lblPassword: TSpTBXLabel;
    lblEmail: TSpTBXLabel;
    edtDisplayName: TSpTBXEdit;
    edtPassword: TSpTBXEdit;
    edtEmail: TSpTBXEdit;
    chkMustChangePass: TSpTBXCheckBox;
    chkUserDenied: TSpTBXCheckBox;
    chkAdmin: TSpTBXCheckBox;
    btnMemberOf: TSpTBXButton;
    cbxUserRole: TSpTBXComboBox;
    lblRole: TSpTBXLabel;
    lblUserID: TSpTBXLabel;
    lblCntUser: TSpTBXLabel;
    grpbxGroups: TSpTBXGroupBox;
    bfiGroups: TbfaInputCombo;
    bfsGroupsUser: TbfaSelector;
    cbxGroupRole: TSpTBXComboBox;
    lblGroupRole: TSpTBXLabel;
    lblGroupEmail: TSpTBXLabel;
    edtGroupEmail: TSpTBXEdit;
    lblGroups: TSpTBXLabel;
    lblGroupID: TSpTBXLabel;
    grpbxStatus: TSpTBXGroupBox;
    btnServerInfo: TSpTBXButton;
    btnUserInfo: TSpTBXButton;
    btnReloadServerConfig: TSpTBXButton;
    SpTBXSplitter12: TbfaSplitter;
    tabUsermgr: TSpTBXTabItem;
    pnlUsermgr: TSpTBXTabSheet;
    btnSaveHistoryToFile: TSpTBXButton;
    edtLogEntry: TSpTBXEdit;
    lblLogEntry: TSpTBXLabel;
    //18.07.2024 SD -->bfacrm:ticket__show__21571
//bt    btnSaveHistoryToFile: TSpTBXButton;
    procedure btnSaveHistoryToFileClick(Sender: TObject);
    procedure SaveHistoryToFile;
    //18.07.2024 SD <--bfacrm:ticket__show__21571
    procedure bfiAddfieldsDelete(Sender: TObject; AValue: WideString; AObject:
        TObject);
    procedure bfiAddfieldsModify(Sender: TObject; AValue: WideString; AObject:
        TObject);
    procedure bfiAddfieldsNew(Sender: TObject; AValue: WideString);
    procedure bfiArchivesDelete(Sender: TObject; AValue: WideString; AObject:
        TObject);
    procedure bfiArchivesModify(Sender: TObject; AValue: WideString; AObject: TObject);
    procedure bfiArchivesNew(Sender: TObject; AValue: WideString);
    procedure bfiGroupsDelete(Sender: TObject; AValue: WideString; AObject:
        TObject);
    procedure bfiGroupsModify(Sender: TObject; AValue: WideString; AObject:
        TObject);
    procedure bfiGroupsNew(Sender: TObject; AValue: WideString);
    procedure bfiReposDelete(Sender: TObject; AValue: WideString; AObject: TObject);
    procedure bfiReposModify(Sender: TObject; AValue: WideString; AObject: TObject);
    procedure bfiReposNew(Sender: TObject; AValue: WideString);
    procedure bfiStatefieldsDelete(Sender: TObject; AValue: WideString; AObject:
        TObject);
    procedure bfiStatefieldsModify(Sender: TObject; AValue: WideString; AObject:
        TObject);
    procedure bfiStatefieldsNew(Sender: TObject; AValue: WideString);
    procedure bfiUserDelete(Sender: TObject; AValue: WideString; AObject: TObject); virtual;
    procedure bfiUserModify(Sender: TObject; AValue: WideString; AObject: TObject);
    procedure bfiUserNew(Sender: TObject; AValue: WideString);
    procedure btnAddListItemsClick(Sender: TObject);
    procedure btnApplyAdminClick(Sender: TObject);
    procedure btnCancelAdminClick(Sender: TObject);
    procedure btnCheckAllClick(Sender: TObject);
    procedure btnCollapseAllClick(Sender: TObject);
    procedure btnExpandAllClick(Sender: TObject);
    procedure btnSaveAdminClick(Sender: TObject);
    procedure btnUnCheckAllClick(Sender: TObject);
    procedure cbxAddfieldTypeChange(Sender: TObject);
    procedure cbxGroupRoleChange(Sender: TObject);
    procedure cbxLinkTypeChange(Sender: TObject);
    procedure cbxSearchModeChange(Sender: TObject);
    procedure cbxStatefieldLinkChange(Sender: TObject);
    procedure cbxUserRoleChange(Sender: TObject);
    procedure CheckAdminTimestamp;
    procedure chkAddfieldmandatoryClick(Sender: TObject);
    procedure chkAdminClick(Sender: TObject);
    procedure chkDocnameMandatoryClick(Sender: TObject);
//    procedure chkFromADClick(Sender: TObject);
    procedure chkLinkfieldClick(Sender: TObject);
    procedure chkMustChangePassClick(Sender: TObject);
//    procedure chkPluginactiveClick(Sender: TObject);
    procedure chkSavenameClick(Sender: TObject);
    procedure chkStrictmodeClick(Sender: TObject);
//    procedure chkSuperiorClick(Sender: TObject);
    procedure chkUserDeniedClick(Sender: TObject); virtual;
//    procedure edtCheckprogramSubEditButton0Click(Sender: TObject);
    procedure edtDisplayNameChange(Sender: TObject);
    procedure edtDocnameChange(Sender: TObject);
    procedure edtEmailChange(Sender: TObject);
    procedure edtPasswordChange(Sender: TObject);
    procedure edtStationarySubEditButton0Click(Sender: TObject);
    procedure tabctrAdminActiveTabChange(Sender: TObject; TabIndex: Integer);
    procedure chbxArchiveRightsClickCheck(Sender: TObject); virtual;
    procedure chbxAddfieldRightsClickCheck(Sender: TObject);
    procedure chbxStatefieldRightsClickCheck(Sender: TObject);
    procedure chbxAddfieldRightsClick(Sender: TObject);
    procedure chbxStatefieldRightsClick(Sender: TObject);
    procedure chbxArchiveRightsClick(Sender: TObject);
    procedure btnSearchresubClick(Sender: TObject);
    procedure btnResetSearchClick(Sender: TObject);
    procedure btnDeleteResubClick(Sender: TObject);
    procedure bfaDBGrid1CellClick(Column: TColumn);
    procedure btnSearchLogClick(Sender: TObject);
    procedure rbAdminLogClick(Sender: TObject);
    procedure rbDocHistoryClick(Sender: TObject);
    procedure btnSearchLogCancelClick(Sender: TObject);
    procedure btnOffsetIncClick(Sender: TObject);
    procedure btnOffsetDecClick(Sender: TObject);
    procedure OnBeginEditInput(Sender: TObject);
    procedure OnEndEditInput(Sender: TObject);
    procedure edtGroupEmailChange(Sender: TObject);
    procedure btnContractClick(Sender: TObject);
    procedure btnReportClick(Sender: TObject);

    procedure cbxArcRightsChange(Sender: TObject);
    procedure EnableInputGroups(Sender: TObject; enable: Boolean); virtual;

    procedure chkDocnameArchiveClick(Sender: TObject);
//    procedure chkConcurrentClick(Sender: TObject);
    procedure btnCreateTPLFileClick(Sender: TObject);
    procedure btnCreateFNDFileClick(Sender: TObject);
    procedure edtAddfieldDescriptionChange(Sender: TObject);
    procedure chbxArchiveRightsMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure btnMemberOfClick(Sender: TObject);
    procedure rbUserClick(Sender: TObject);
    procedure rbIDClick(Sender: TObject);
    procedure edtStationaryChange(Sender: TObject);
    procedure edtPasswordClick(Sender: TObject);
    procedure edtPasswordKeyPress(Sender: TObject; var Key: Char);
    procedure btnDLMClick(Sender: TObject);
    procedure edtDurationValueChanged(Sender: TObject);
    procedure cbxIntervalCloseUp(Sender: TObject);
    procedure cbxIntervalChange(Sender: TObject);
    procedure edtDurationChange(Sender: TObject);
    procedure chkDLMClick(Sender: TObject);
    procedure lvAdminLogCustomDrawItem(Sender: TCustomListView; Item: TListItem;
      State: TCustomDrawState; var DefaultDraw: Boolean);
//    procedure btnGetADClick(Sender: TObject);
    procedure btnServerInfoClick(Sender: TObject);
    procedure btnUserInfoClick(Sender: TObject);
//    procedure rbBitfarmuserClick(Sender: TObject);
//    procedure rbWindowsuserClick(Sender: TObject);
    procedure SpTBXSplitter11Moving(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
    procedure SpTBXSplitter2Moving(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
    procedure SpTBXSplitter3Moving(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
//    procedure SpTBXSplitter1Moving(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
    procedure SpTBXSplitter12Moving(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
    procedure SpTBXSplitter6Moving(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
    procedure SpTBXSplitter4Moving(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
    procedure SpTBXSplitter8Moving(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
    procedure SpTBXSplitter7Moving(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
    procedure SpTBXSplitter5Moving(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
    procedure SpTBXSplitter10Moving(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
    procedure SpTBXSplitter9Moving(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
    procedure edtArcidKeyPress(Sender: TObject; var Key: Char);
    procedure edtGdocidKeyPress(Sender: TObject; var Key: Char);
    procedure edtTimrefKeyPress(Sender: TObject; var Key: Char);
    procedure chbxArchiveRightsDrawItem(Sender: TObject; ACanvas: TCanvas; var ARect: TRect; Index: Integer;
      const State: TOwnerDrawState; const PaintStage: TSpTBXPaintStage; var PaintDefault: Boolean);
//    procedure SpTBXItem2Click(Sender: TObject);
//    procedure SpTBXItem1Click(Sender: TObject);
//    procedure edtWinUserKeyPress(Sender: TObject; var Key: Char);
//    procedure edtWinPassKeyPress(Sender: TObject; var Key: Char);
    procedure tabctrAdminActiveTabChanging(Sender: TObject; TabIndex, NewTabIndex: Integer; var Allow: Boolean);
    procedure cbxResubSearchModeKeyPress(Sender: TObject; var Key: Char);
    procedure edtLogGdocidKeyPress(Sender: TObject; var Key: Char);
    procedure edtDocnameKeyPress(Sender: TObject; var Key: Char);

  private
    bfaDBGrid1: TbfaDBGrid; //22.10.2019

    FModified: Boolean;


    FUserClickedApplyJustToSave: Boolean;

    FLastModified: TDateTime;
    FModifiedUserid,
    FprevIndex: Integer;

    FSelectedAddfieldID: Integer;
    FSelectedStatefieldID: Integer;

    FAdminLogOffset: Integer;

//    sSelectedGroups: string; // Ausgewhlte Gruppen
//    slAdUser: TStringList;
//    slAdMail: TStringList;
//    slAdDispName: TStringList;
//    slAdMemberOf: TStringList;
//    gADClass,gLDAP: WideString;
//    slAddAdGroup: TStringList;
////    ADEntries: TList<TbfaADEntry>;   // AD Eintrge, die vom Server geliefert werden
//    slRemoveADGroup: TStringList;
//
//    slAddHoliday, slModifyHoliday, slDeleteHoliday,
    Intervals: TStringList;
//    FADModified: Boolean;
//    CriticalX: TRTLCriticalSection;
    FArcRightsToCopy: TbfaArchive;
    FAddRights: Boolean;
//    FSkipCheck, FDisableCheck: Boolean;
//    FOldADGroupsLVProc: TWndMethod;
    FPasteAllObjects: Boolean;
    FPasteAllObjetcsMResult: TModalResult;

    procedure PaintWindow(DC: HDC); override;

    // OnChanges
    procedure OnChangeArchive(Sender: TObject);


    procedure OnChangeRepos(Sender: TObject);
    procedure ShowReposProperties(archive: TbfaArchive);

    procedure OnChangeAddfield(Sender: TObject);
//    procedure ShowAddfieldProperties(addfield: TbfaAddField);

    procedure OnChangeStatefield(Sender: TObject);
    procedure ShowStatefieldProperties(statefield: TbfaStatefield);

    procedure OnChangeUser(Sender: TObject);

    procedure OnChangeGroup(Sender: TObject);
    procedure ShowGroupProperties(group: TbfaGroup);

    procedure OnSelectArchiveUser(AValue: WideString; AObject: TObject);
    procedure OnSelectedEmptyArchiveUser;
    procedure OnDeselectArchiveUser;

    procedure OnSelectAddfield(AValue: WideString; AObject: TObject);
    procedure OnSelectAddfieldUser(AValue: WideString; AObject: TObject);
    procedure OnSelectedEmptyAddfieldUser;
    procedure OnDeselectAddfieldsUser;

    procedure OnSelectStatefield(AValue: WideString; AObject: TObject);
    procedure OnSelectStatefieldUser(AValue: WideString; AObject: TObject);
    procedure OnSelectedEmptyStatefieldUser;
    procedure OnDeselectStatefieldUser;

    procedure OnAddGroupsUser(AValue: WideString; AObject: TObject);
    procedure OnRemoveGroupsUser(AValue: WideString; AObject: TObject);

    procedure OnAddAssignUser(AValue: WideString; AObject: TObject);
    procedure OnRemoveAssignUser(AValue: WideString; AObject: TObject);

    procedure OnAddAssignFields(AValue: WideString; AObject: TObject);
    procedure OnRemoveAssignFields(AValue: WideString; AObject: TObject);
    procedure OnDeselectAddfield;
    procedure OnDeselectStatefield;

    procedure OnAddAddfieldUser(AValue: WideString; AObject: TObject);
    procedure OnRemoveAddfieldUser(AValue: WideString; AObject: TObject);

    procedure OnAddStatefieldUser(AValue: WideString; AObject: TObject);
    procedure OnRemoveStatefieldUser(AValue: WideString; AObject: TObject);

    //procedure OnAddInferior(AValue: WideString; AObject: TObject);
    //procedure OnRemoveInferior(AValue: WideString; AObject: TObject);

//    procedure OnSelectAllADGroups(AValue: WideString; AObject: TObject);
//    procedure OnDblClickAllADGroups(AValue: WideString; AObject: TObject);
//    procedure OnAddADGroups(AValue: WideString; AObject: TObject);
//    procedure ADListDrawItem(Sender: TCustomListView; Item: TListItem;
//              Rect: TRect; State: TOwnerDrawState);
//    procedure OnRemoveADGroups(AValue: WideString; AObject: TObject);
//    procedure OnSelectADGroups(AValue: WideString; AObject: TObject);

    procedure OnSelectedSortedAddfields(AObject: TObject; AList: TListItems);
    procedure OnSelectedSortedStatefields(AObject: TObject; AList: TListItems);
    procedure bfiAddfieldsDropDown(Sender: TObject);
    procedure EnableSearchModebyType(FieldType: Integer);
//    procedure GetUserFromSelectedGroups(AValue: WideString; AObject: TObject);
    procedure ReconnectDomain(sLdap: string);
//    procedure ListsToListView(slUser, slMail, slAd, slOf: TStrings; ListView: TListView);

    function DBAddGroup(AValue: WideString; AObject: TObject): Int64;
    function DbAddUser(Name, Mail, Pass, DispName: string; Enabled, isAd: Boolean): Integer;
    procedure DbDelUserName(Name: string; NurAd: Boolean);
    procedure GetGroupList(List: TStrings);
    procedure DbUserUpdateMail(Name, Mail, DispName: string; isAd: Boolean);
    procedure GetGroupUserList(Group: string; Users, Mails, Ad: TStrings);
    procedure DbAddUserToGroup(UserName, GroupName: string);
    procedure DbDelUserFromGroup(UserName, GroupName: string);
    procedure ShowResubIds;
    procedure getFieldsAndStates(arcid: Integer; SList: TStringList);
    procedure getDLMFields(arcid: Integer; SList: TStringList; all: Boolean = False);
    procedure ShowHistoryRecords;
    procedure CreateUserReport;
    procedure CreateListUsersReport; //27.06.2024 SD -->bfacrm:ticket__show__39119
    procedure CreatePropertiesUsersReportCSV; //25.07.2024 SD -->bfacrm:ticket__show__39458
    procedure CreateArchiveReport(showfields: Boolean = False; showuser: Boolean = False; showdlm: Boolean = False);
    procedure InitRoleList;
    procedure InitLinkTypes;
    procedure InitAddfieldtypes;
    procedure InitSearchModes;
    
//    procedure SelectorPopup(Sender: TObject);
    //procedure ADGroupsCheckbox(Litem: TListItem; chk: Boolean);
    //procedure ADGroupsWndProc(var Message: TMessage);
    //procedure SetADLviewChecked(Value: Boolean);
    function GetAddRights(Typ: Integer; out func: Boolean): TModalResult;
    procedure edtCheckprogramSubEditButton0Click(Sender: TObject);
    { Private-Deklarationen }
  public
    { Public-Deklarationen }

    RoleList: TStringList;
    StateFieldFunctions: TStringList;
    Addfieldtypes: TStringList;
    SearchModes: TStringList;
    FArcidMax: Int64;
    FAddfieldidMax: Int64;
    FStatefieldidMax: Int64;
    FUseridMax: Integer;
    FGroupidMax: Integer;
    FDomain, sAdUser, lsmyq: WideString;
    sEnvRoot, sDsQueryExe, sDsGetExe, sEnvTemp: string;
    gbAdChanged: Boolean;
    frmDLMDialog: TfrmDLM;
    frmContractMgmt: TfrmContractMgmt;
    FSkipChangeEvents: Boolean;

    FCurrentArchive: TbfaArchive;
    FCurrentAddfield: TbfaAddField;
    FCurrentStateField: TbfaStateField;
    FCurrentUser: TbfaUser;
    FCurrentGroup: TbfaGroup;

    constructor Create(AOwner: TComponent); virtual;
    destructor Destroy; virtual;

    procedure EnableFunctions(enable: Boolean); virtual;
    procedure SelectorPopup(Sender: TObject);
//    procedure EnableAddHoliday;
    procedure EnableBySelect;
    procedure SetModified;
    procedure LoadAdminFrame; virtual;
    procedure ReloadAdminFrame;
    procedure LoadTreeview;
    procedure ClearObjectsLists;
    procedure ClearComponents; virtual;
    procedure LoadObjectLists;
//    procedure LoadADGroups;
    //procedure LoadHolidayList;
    //procedure AddToHolidayList(user, repl, datestart, dateend: WideString);
    //procedure ModifyHolidayList(holid, user, repl, datestart, dateend: WideString);
    //procedure DeleteFromHolidayList(holid: WideString);
    procedure LoadRegistration;
    procedure AssignObjectLists;
    procedure SaveObjects;
    procedure CancelAdmin; virtual;
    procedure UnModify;
    procedure SelectArchive(arcid : Integer);
    procedure ShowAddfieldProperties(addfield: TbfaAddField); virtual;
    procedure ShowArchiveRights(right: Int64); virtual;
    procedure ShowAddFieldRights(right: Integer);
    procedure ShowStateFieldRights(right: Integer);
    procedure AdminTreeDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure AdminTreeDragDrop(Sender, Source: TObject; X, Y: Integer);
//    procedure LoadOU;
    procedure WriteTemplate(arcids: TStringList; WithDlg : Boolean = True);
    procedure CopyArchiveObjects(Sender : TObject);
    procedure PasteArchiveRights(Sender: TObject);
    procedure PasteAddfields(Sender: TObject);
    procedure PasteStateFields(Sender: TObject);
    procedure PasteAllObjects(Sender: TObject);

    function GetArchiveByID(id: Integer): TbfaArchive;
    function GetUserByID(id: Integer): TbfaUser;
    function GetGroupByID(id: Integer): TbfaGroup;
    function GetAddfieldByID(id: Integer): TbfaAddfield;
    function GetStatefieldByID(id: Integer): TbfaStateField;
    procedure SelectEntryByObject(list: TbfaInputCombo; AObject: TObject);
    procedure   EnableResubSearchFields;
    procedure Retranslate;
    property Modified: Boolean read FModified write FModified;
    property CurrentArchive: TbfaArchive read FCurrentArchive;
//    property ADModified: Boolean read FADModified write FADModified;
    property bfaGrid: TbfaDBGrid read bfaDBGrid1 write bfaDBGrid1;
    property ArcRightsToCopy: TbfaArchive read FArcRightsToCopy;
    procedure ShowUserProperties(usr: TbfaUser); virtual;
    procedure ShowArchiveProperties(archive: TbfaArchive); virtual;
    procedure saveMemberShip(sUser: string; sText: TStringList; isGroups: Boolean = False);
    //21.08.2024 SD -->bfacrm:ticket__show__39655
//    procedure saveAdminLog(sFileName: string; sText: TStringList; ItsHistory: Boolean);  //18.07.2024 SD <--bfacrm:ticket__show__21571
    function saveAdminLog(sFileName: string; sText: TStringList; ItsHistory: Boolean; withDialog: Boolean = True; withMsg: Boolean = True): String;
    //21.08.2024 SD <--bfacrm:ticket__show__39655
    procedure SaveReportCSV(sReportName: string; sText: TStringList);  //25.07.2024 SD <--bfacrm:ticket__show__39458
    procedure SaveReport(sName: string; sText: TStringList);
    procedure getMembership(UserID: Integer; SList: TStringList); virtual;
    procedure getGroupDetails(GroupID: Integer; GroupName: string; GroupEmail: string;
                FromAd: Boolean; ADPath: string; Rights: Integer; SList: TStringList); virtual;
    procedure getUserAndGroups(arcid: Integer; SList: TStringList);
    procedure CreateGroupReport; virtual;

  end;

implementation

{$R *.dfm}

uses
    MainForm, BfaCommonDB, bfaCommonUtils, bfaCommonMethods, bfaCommonDialogs, MainDataModule, u_bfaTreeView,
    IniFiles, StrUtils, DateUtils, bfaLog, bfaIconsDM, bfaCommonStyles,
  {$IFDEF ENTERPRISE}
    bitfarm_enterprise, AdminFrameEnterprise,
  {$ELSE}
    bitfarm_core,
  {$ENDIF}
    bfaApplication, CommonGUIUtils, InfoBoxForm,
    bfaSocketConnection, u_MemberOf, CommCtrl;

procedure TfraAdmin.EnableBySelect;
begin
  bfsAddfieldsUser.Editable := (bfsAssignAddfields.lvList2.SelCount > 0) and bitfarmApp.AdminEditMode;
  bfsStatefieldsUser.Editable := (bfsAssignStatefields.lvList2.SelCount > 0) and bitfarmApp.AdminEditMode;
  chbxArchiveRights.Enabled := (bfsAssignUser.lvList2.SelCount > 0) and bitfarmApp.AdminEditMode;
  chbxAddfieldRights.Enabled := (bfsAddfieldsUser.lvList2.SelCount > 0) and bitfarmApp.AdminEditMode;
  chbxStatefieldRights.Enabled := (bfsStatefieldsUser.lvList2.SelCount > 0) and bitfarmApp.AdminEditMode;

  if bfiGroups.cbbInput.ItemIndex > -1 then
  begin
//    bfiGroups.Editable := (TbfaGroup(bfiGroups.cbbInput.Items.Objects[bfiGroups.cbbInput.ItemIndex]).ID <> 0) and (bitfarmApp.AdminEditMode);
    bfiGroups.Editable := bitfarmApp.AdminEditMode;
    if bitfarmApp.AdminEditMode then
      bfiGroups.DisableButtons := TbfaGroup(bfiGroups.cbbInput.Items.Objects[bfiGroups.cbbInput.ItemIndex]).ID = 0;
    bfsGroupsUser.Editable := bfiGroups.Editable;
  end;
end;

procedure TfraAdmin.EnableFunctions(enable: Boolean);
begin
  bfiArchives.Editable := enable;
  bfiRepos.Editable := enable;
  bfiAddfields.Editable := enable;
  bfiStatefields.Editable := enable;
  bfiUser.Editable := enable;
  bfiGroups.Editable := enable;
//  btnAddListItems.Enabled := enable;
  bfsAssignUser.Editable := enable;
  bfsAssignAddfields.Editable := enable;
  bfsAssignStatefields.Editable := enable;
//  bfsAddfieldsUser.Editable := enable;
//  bfsStatefieldsUser.Editable := enable;
//  bfsADGroups.Editable := enable;
//  bfsInferior.Editable := enable;
  bfsGroupsUser.Editable := enable;
  cbxArcRights.Enabled := enable;
  if not cbxArcRights.Enabled then
  begin
    cbxArcRights.Style := csDropDown;
    cbxArcRights.Text := _('Archivberechtigung');
  end else begin
    cbxArcRights.Style := csDropDownList;
  end;


//  chbxArchiveRights.Enabled := enable;
//  chbxAddfieldRights.Enabled := enable;
//  chbxStatefieldRights.Enabled := enable;

  cbxStatefieldLink.Enabled := enable;
  cbxLinkType.Enabled := enable;
  btnCancelAdmin.Enabled := enable;

  edtDocname.Enabled := enable;
  edtStationary.Enabled := enable;
  cbxAddfieldType.Enabled := enable;
  cbxSearchMode.Enabled := enable;

  edtAddfieldDescription.Enabled := enable;
  chkDocnameMandatory.Enabled := enable;

  chkDocnameArchive.Enabled := enable;
  chkStrictmode.Enabled := enable;
  chkAddfieldmandatory.Enabled := enable;
  chkLinkfield.Enabled := enable;
  chkSavename.Enabled := enable;
  edtDuration.Enabled := enable;
  cbxInterval.Enabled := enable;

  edtPassword.Enabled := enable;
  edtDisplayName.Enabled := enable;
  edtEmail.Enabled := enable;
  cbxUserRole.Enabled := enable;
  cbxGroupRole.Enabled := enable;
  edtGroupEmail.Enabled := enable;
//  chkEmailFromAD.Enabled := enable;
  chkMustChangePass.Enabled := enable;
  chkUserDenied.Enabled := enable;
  chkAdmin.Enabled := enable and (bitfarmApp.User.Flags and 128 = 128);

  btnDLM.Enabled := enable;
  chkDLM.Enabled := enable;

  EnableBySelect;
end;

procedure TfraAdmin.EnableInputGroups(Sender: TObject; enable: Boolean);
begin
  if TObject(Sender) = bfiAddfields then
  begin
    cbxAddfieldType.Enabled := enable;
    cbxSearchMode.Enabled := enable;

    edtAddfieldDescription.Enabled := enable;
    btnAddListItems.Enabled := enable;
    chkStrictmode.Enabled := enable;
    //27.09.2024 SD -->bfacrm:ticket__show__39043
    if (not (FCurrentAddfield.Typ in [2,3,11])) then
    begin
      chkStrictmode.Enabled := False;
      chkStrictmode.Checked := False;
      FCurrentAddfield.Options := FCurrentAddfield.Options and not 8;
    end;
    //27.09.2024 SD <--bfacrm:ticket__show__39043
    chkAddfieldmandatory.Enabled := enable;
    chkLinkfield.Enabled := enable;
    chkSavename.Enabled := enable;
  end;

  if TObject(Sender) = bfiStatefields then
  begin
    cbxStatefieldLink.Enabled := enable;
    cbxLinkType.Enabled := enable;
  end;

  if TObject(Sender) = bfiArchives then
  begin
    edtDocname.Enabled := enable;
    edtStationary.Enabled := enable;
    chkDocnameMandatory.Enabled := enable;
    chkDocnameArchive.Enabled := enable;
    //26.06.2024 SD -->bfacrm:ticket__show__39161
    edtDuration.Enabled := enable;
    cbxInterval.Enabled := enable;
    btnCreateTPLFile.Enabled := enable;
    btnCreateFNDFile.Enabled := enable;
    frmMainForm.SpTBXPanel7.Enabled := enable;
    //26.06.2024 SD <--bfacrm:ticket__show__39161
  end;

  if TObject(Sender) = bfiUser then
  begin
    edtDisplayName.Enabled := enable;
    edtPassword.Enabled := enable;
    edtEmail.Enabled := enable;
    cbxUserRole.Enabled := enable;
    chkMustChangePass.Enabled := enable;
    chkUserDenied.Enabled := enable;
    chkAdmin.Enabled := enable and (bitfarmApp.User.Flags and 128 = 128);
  end;

  if TObject(Sender) = bfiGroups then
  begin
    cbxGroupRole.Enabled := enable;
    edtGroupEmail.Enabled := enable;
    bfsGroupsUser.Enabled := enable;
  end;
end;

procedure TfraAdmin.EnableResubSearchFields;
begin
  edtArcid.Enabled := rbID.Checked;
  edtGdocid.Enabled := rbID.Checked;
  edtTimref.Enabled := rbID.Checked;
  cbxResubUser.Enabled := rbUser.Checked;
  cbxResubSearchMode.Enabled := rbUser.Checked;
  dtResubDate.Enabled := rbUser.Checked;
end;

procedure TfraAdmin.EnableSearchModebyType(FieldType: Integer);
begin
  cbxSearchMode.Enabled := bitfarmApp.AdminEditMode and (FieldType in [0,2,3,11]);
end;

function TfraAdmin.GetAddfieldByID(id: Integer): TbfaAddfield;
var
  i : Integer;
begin
  Result := nil;
  for i := 0  to bitfarmApp.GAddfields.Count -1 do
  begin
    if bitfarmApp.GAddfields[i].ID = id then
    begin
      Result :=  bitfarmApp.GAddfields[i];
      Break;
    end;
  end;
end;

function TfraAdmin.GetArchiveByID(id: Integer): TbfaArchive;
var
  i : Integer;
begin
  Result := nil;
  for i := 0 to bitfarmApp.GArchives.Count -1 do
  begin
    if bitfarmApp.GArchives[i].ID = id then
    begin
      Result :=  bitfarmApp.GArchives[i];
      Break;
    end;
  end;
end;

procedure TfraAdmin.getDLMFields(arcid: Integer; SList: TStringList; all: Boolean = False);
var
  qry : TUniQuery;
  GroupList, fieldids : TStringList;
  lifecycle : string;
begin
  bitfarmLog.DebugBegin(llDebug, 'getDLMFields', ClassName);
  try
    try
      qry := TUniQuery.Create(nil);
      try
        qry.Connection := dmMain.cntMain;

        fieldids := TStringList.Create;

        qry.SQL.Text := 'select x.fieldid from sys_addfieldxs as x left join sys_addfields as a on x.fieldid = a.addfieldid where a.type = 11'; //erst zusatzfelder
        if not all then
          qry.SQL.Text := qry.SQL.Text  + ' and x.arcid = '+ IntToStr(arcid);
        qry.Execute;
        if qry.RecordCount > 0 then
        begin
          qry.First;
          while not qry.Eof do
          begin
            fieldids.Add(qry.FieldByName('fieldid').AsString);
            qry.Next;
          end;
        end;

        qry.SQL.Text := 'select x.fieldid from sys_statefieldxs as x left join sys_statefields as a on x.fieldid = a.stateid where a.flags & 4 = 4'; //dann statusfelder
        if not all then
          qry.SQL.Text := qry.SQL.Text  + ' and x.arcid = '+ IntToStr(arcid);
        qry.Execute;
        if qry.RecordCount > 0 then
        begin
          qry.First;
          while not qry.Eof do
          begin
            fieldids.Add(qry.FieldByName('fieldid').AsString);
            qry.Next;
          end;
        end;

        if fieldids.Count > 0 then
        begin
          qry.SQL.Text := 'SELECT d.type, d.fieldid, d.item, d.duration, d.`interval`, d.date, d.prio, a.displayname as aname, s.displayname as sname FROM sys_doclifecycle as d ' +
                          'left join sys_addfields as a on d.fieldid = a.addfieldid ' +
                          'left join sys_statefields as s on d.fieldid = s.stateid ';

          if not all then
             qry.SQL.Text :=  qry.SQL.Text + ' where d.fieldid in( '+ fieldids.CommaText + ') ';

          qry.SQL.Text :=  qry.SQL.Text + ' order by d.prio asc';

          qry.Execute;
          if qry.RecordCount > 0 then
          begin
            qry.First;
            while not qry.Eof do
            begin
              if qry.FieldByName('type').Asinteger = 0 then
                SList.Add('   ' + qry.FieldByName('sname').AsWideString + #9 + '(Statusfeld)')
              else
                SList.Add('   ' + qry.FieldByName('aname').AsWideString + #9 + '(Zusatzfeld)' + #9 + 'Auswahl: ' + qry.FieldByName('item').AsWideString);

              if qry.FieldByName('duration').AsInteger > 0 then
              begin
                if qry.FieldByName('interval').AsString = 'd' then
                  if qry.FieldByName('duration').AsInteger = 1 then
                    lifecycle := _('Tag')
                  else
                    lifecycle := _('Tage');

                if qry.FieldByName('interval').AsString = 'w' then
                  if qry.FieldByName('duration').AsInteger = 1 then
                    lifecycle := _('Woche')
                  else
                    lifecycle := _('Wochen');

                if qry.FieldByName('interval').AsString = 'm' then
                  if qry.FieldByName('duration').AsInteger = 1 then
                    lifecycle := _('Monat')
                  else
                    lifecycle := _('Monate');

                if qry.FieldByName('interval').AsString = 'y' then
                  if qry.FieldByName('duration').AsInteger = 1 then
                    lifecycle := _('Jahr')
                  else
                    lifecycle := _('Jahre');

                if qry.FieldByName('interval').AsString = 'c' then
                  lifecycle := _('Nie (leer setzen)');

                sList.Add(_('     Lebensdauer: ' + qry.FieldByName('duration').AsString + ' ' + lifecycle));
              end
              else if qry.FieldByName('interval').AsString = 'c' then
              begin
                lifecycle := _('Nie (leer setzen)');
                sList.Add(_('     Lebensdauer: ' + qry.FieldByName('duration').AsString + ' ' + lifecycle));
              end
              else if qry.FieldByName('date').AsString <> '' then begin
                sList.Add(_('     Lschdatum: ' + qry.FieldByName('date').AsString));

              end;

              qry.Next;
            end;
          end;
        end;
      finally
        FreeAndNil(qry);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'getDLMFields', ClassName);
    end;
  finally
    FreeAndNil(fieldids);
    bitfarmLog.DebugEnd(llDebug, 'getDLMFields', ClassName);
  end;
end;

procedure TfraAdmin.getFieldsAndStates(arcid: Integer; SList: TStringList);
var
  qry : TUniQuery;
  GroupList : TStringList;
begin
  bitfarmLog.DebugBegin(llDebug, 'getFieldsAndStates', ClassName);
  try
    try
      qry := TUniQuery.Create(nil);
      try
        qry.Connection := dmMain.cntMain;

        qry.SQL.Text := 'select displayname from sys_addfieldxs as x left join sys_addfields as f on x.fieldid = f.addfieldid ' +
                        ' where x.arcid = '+ IntToStr(arcid) + ' and flags & 1 = 1 group by x.fieldid, x.xsid order by pos asc'; //erst zusatzfelder
        qry.Execute;
        if qry.RecordCount > 0 then
        begin
          SList.Add(_('   Zusatzfelder: '));

          qry.First;
          while not qry.Eof do
          begin
            SList.Add('   ' + qry.FieldByName('displayname').AsWideString);
            qry.Next;
          end;
        end;

        qry.SQL.Text := 'select displayname from sys_statefieldxs as x left join sys_statefields as f on x.fieldid = f.stateid ' +
                        ' where x.arcid = '+ IntToStr(arcid) + ' and flags & 1 = 1 group by x.fieldid, x.xsid order by pos asc'; //dann statusfelder
        qry.Execute;
        if qry.RecordCount > 0 then
        begin
          SList.Add('');
          SList.Add(_('   Statusfelder: '));
          qry.First;
          while not qry.Eof do
          begin
            SList.Add('   ' + qry.FieldByName('displayname').AsWideString);
            qry.Next;
          end;
        end;
      finally
        FreeAndNil(qry);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'getFieldsAndStates', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'getFieldsAndStates', ClassName);
  end;
end;


function TfraAdmin.GetGroupByID(id: Integer): TbfaGroup;
var
  i : Integer;
begin
  Result := nil;
  for i := 0  to bitfarmApp.GGroups.Count -1 do
  begin
    if bitfarmApp.GGroups[i].ID = id then
    begin
      Result :=  bitfarmApp.GGroups[i];
      Break;
    end;
  end;
end;

procedure TfraAdmin.getGroupDetails(GroupID: Integer; GroupName: string; GroupEmail: string; FromAd: Boolean; ADPath: string; Rights: Integer; SList: TStringList);
var
  qry, QryUsers: TUniQuery;
  GroupList: TStringList;
begin
  bitfarmLog.DebugBegin(llDebug, 'getGroupDetails', ClassName);
  try
    try
      SList.Add(_('Name: ') + GroupName + ' ' + '[ID: ' + GroupID.ToString + ']');
      SList.Add(_('Email: ') + GroupEmail);

      if Rights >= rRoleAdmin then
        SList.Add(_('Rolle:') + ' ' + _('Admin'))
      else if Rights >= rRolePower then
        SList.Add(_('Rolle:') + ' ' + _('Erweitert'))
      else if Rights >= rRoleStandard then
        SList.Add(_('Rolle:') + ' ' + _('Standard'))
      else if Rights >= rRoleImport then
        SList.Add(_('Rolle:') + ' ' + _('Importer'))
      else if Rights >= rRoleSearch then
        SList.Add(_('Rolle:') + ' ' + _('Recherche'))
      else
        SList.Add(_('Rolle:'));

      SList.Add('');
//      if FromAd then
//      begin
//        SList.Add(_('AD-Abgleich:') +' '+ _('ja'));
//        SList.Add(_('AD-Pfad:') +' '+ ADPath);
//      end else
//      begin
//        SList.Add(_('AD-Abgleich:') +' '+ _('nein'));
//      end;
//      SList.Add('');

      SList.Add(_('Mitglieder:'));

      qry := TUniQuery.Create(nil);
      QryUsers := TUniQuery.Create(nil);
      try
        qry.Connection := dmMain.cntMain;
        QryUsers.Connection := dmMain.cntMain;

        qry.SQL.Text := 'select userid from sys_groupuser where groupid = ' + IntToStr(GroupID) + ';';
        qry.Execute;
        if qry.RecordCount > 0 then
        begin
          qry.First;
          while not qry.Eof do
          begin
            QryUsers.SQL.Text := 'SELECT username, IF(flags & 1 <> 1, '+#39+'True'+#39+', '+#39+'False'+#39+') as IsBanned '+
              'FROM sys_user where FIND_IN_SET('+#39+'deleted'+#39+',Flags) < 1 and userid ='+qry.FieldByName('userid').AsString;
            QryUsers.Execute;
            if QryUsers.RecordCount = 1 then
            begin
              QryUsers.First;
              if QryUsers.FieldByName('IsBanned').AsBoolean then
                SList.Add(QryUsers.FieldByName('username').AsString + ' ' + _('(gesperrt)'))
              else
                SList.Add(QryUsers.FieldByName('username').AsString);
              QryUsers.Close;
            end;
            qry.Next;
          end;
        end;

        qry.SQL.Text := 'select arc.arcname, lgr.arcname as lgrname from sys_arcxs as a ' +
          'left join sys_arc as arc on (a.arcid = arc.arcid) ' +
          'left join sys_arc as lgr on (arc.lgrid = lgr.arcid) '+
          'where (groupid = ' + inttostr(GroupID) + ') '+
          'group by a.arcid order by arc.arcname, lgr.arcname;';

        qry.Execute;
        if qry.RecordCount > 0 then
        begin
          SList.Add('');
          SList.Add(_('Archive:'));
          qry.First;
          while not qry.Eof do
          begin
            SList.Add(qry.FieldByName('arcname').AsString +
              #9 + ' ['+  qry.FieldByName('lgrname').AsString + ']');
            qry.Next;
          end;
        end;

      finally
        FreeAndNil(qry);
        FreeAndNil(QryUsers);
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'getGroupDetails', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'getGroupDetails', ClassName);
  end;
end;

procedure TfraAdmin.GetGroupList(List: TStrings);
begin
  ShowMessage('GetGroupList');
end;

procedure TfraAdmin.GetGroupUserList(Group: string; Users, Mails, Ad: TStrings);
begin
  ShowMessage('GetGroupUserList');
end;

//function TfraAdmin.GetLDAPClass(AValue: WideString): WideString;
//var
//  p : Integer;
//begin
//  Result := '';
//  p := Pos(':',AValue);
//  if p=0 then Exit;
//
//  Result := Copy(AValue,1,p-1);
//end;
//
//function TfraAdmin.GetLDAPDisplayname(AValue: WideString): WideString;
//var
//  p : Integer;
//begin
//  Result := '';
//  p := Pos('=',AValue);
//  if p=0 then Exit;
//
//  Result := RightStr(AValue,length(AValue) - p);
//  Result := Trim(Result);
//end;
//
//function TfraAdmin.GetLDAPName(AValue: WideString): WideString;
//var
//  p : Integer;
//begin
//  Result := '';
//  p := Pos(':',AValue);
//  if p=0 then Exit;
//
//  Result := RightStr(AValue,length(AValue) - p);
//  Result := Trim(Result);
//end;

function TfraAdmin.GetStatefieldByID(id: Integer): TbfaStateField;
var
  i : Integer;
begin
  Result := nil;
  for i := 0  to bitfarmApp.GStatefields.Count -1 do
  begin
    if bitfarmApp.GStatefields[i].ID = id then
    begin
      Result :=  bitfarmApp.GStatefields[i];
      Break;
    end;
  end;
end;

procedure TfraAdmin.getUserAndGroups(arcid: Integer; SList: TStringList);
var
  qry : TUniQuery;
  GroupList : TStringList;
begin
  bitfarmLog.DebugBegin(llDebug, 'getUserAndGroups', ClassName);
  try
    try
      qry := TUniQuery.Create(nil);
      try
        qry.Connection := dmMain.cntMain;

        qry.SQL.Text := 'select x.arcid, x.userid, x.groupid, x.rights, g.groupname as gname, u.username as uname from sys_arcxs as x left join sys_group as g on x.groupid = g.groupid left join sys_user as u on x.userid = u.userid ' +
                        ' where x.arcid = '+ IntToStr(arcid) + ' and x.userid = 0 and g.flags & 2 = 0'; //erst gruppen
        qry.Execute;
        if qry.RecordCount > 0 then
        begin
          SList.Add(_('   Gruppen: '));

          qry.First;
          while not qry.Eof do
          begin
            SList.Add('   ' + qry.FieldByName('gname').AsWideString + #9 + '(' + qry.FieldByName('rights').AsString + ')');
            qry.Next;
          end;
        end;

        qry.SQL.Text := 'select x.arcid, x.userid, x.groupid, x.rights, g.groupname as gname, u.username as uname from sys_arcxs as x left join sys_group as g on x.groupid = g.groupid left join sys_user as u on x.userid = u.userid ' +
                        ' where x.arcid = '+ IntToStr(arcid) + ' and x.userid <> 0 and u.flags & 2 = 0'; //erst user
        qry.Execute;
        if qry.RecordCount > 0 then
        begin
          SList.Add('');
          SList.Add(_('   Benutzer: '));
          qry.First;
          while not qry.Eof do
          begin
            SList.Add('   ' + qry.FieldByName('uname').AsWideString + #9 + '('+ qry.FieldByName('rights').AsString + ')');
            qry.Next;
          end;
        end;
      finally
        FreeAndNil(qry);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'getUserAndGroups', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'getUserAndGroups', ClassName);
  end;
end;

function TfraAdmin.GetUserByID(id: Integer): TbfaUser;
var
  i : Integer;
begin
  Result := nil;
  for i := 0 to bitfarmApp.GUser.Count -1 do
  begin
    if bitfarmApp.GUser[i].ID = id then
    begin
      Result :=  bitfarmApp.GUser[i];
      Break;
    end;
  end;
end;

procedure TfraAdmin.LoadAdminFrame;
var
  id : Int64;
begin
  if Assigned(Self) and (Self.Modified) and (bitfarmApp.AdminEditMode) then  // kein Neuladen wenn verndert und im Editmode
    Exit;

  try
    frmMainForm.frmSplash.Show;
    frmMainForm.frmSplash.Update;

    frmMainForm.frmSplash.lblLoading.Caption := sMsgAdminRefresh;
    frmMainForm.frmSplash.Update;
    EnableFunctions(bitfarmApp.AdminEditMode);
    frmMainForm.frmSplash.lblInfo.Caption := sMsgAdminLoadTreeviews;
    frmMainForm.frmSplash.Update;

    LoadTreeview;

    frmMainForm.frmSplash.lblInfo.Caption := sMsgAdminInitialize;
    frmMainForm.frmSplash.Update;
    bitfarmLog.Debug(llDebug, 'ClearObjectsLists', ClassName);
    ClearObjectsLists;
    bitfarmLog.Debug(llDebug, 'ClearComponents', ClassName);
    ClearComponents;

    frmMainForm.frmSplash.lblInfo.Caption := sMsgAdminLoadArchives;
    frmMainForm.frmSplash.Update;
    bitfarmLog.Debug(llDebug, 'LoadObjectLists', ClassName);
    LoadObjectLists;
    frmMainForm.frmSplash.Update;
    bitfarmLog.Debug(llDebug, 'AssignObjectLists', ClassName);
    AssignObjectLists;
    frmMainForm.frmSplash.Update;

    //LoadADGroups;
    //frmMainForm.frmSplash.Update;
//
    //LoadHolidayList;
    //frmMainForm.frmSplash.Update;
    //dtDateStart.Date := Date();
    //dtDateEnd.Date := Date();

    LoadRegistration;
    frmMainForm.frmSplash.Update;

    if (TbfaTreeView(frmMainForm.FAdminTreeview).LastSelected > 0)  then
    begin
        SelectArchive(TbfaTreeView(frmMainForm.FAdminTreeview).LastSelected);
        if frmMainForm.FAdminTreeview.Selected <> nil then  //30.03.2017
           frmMainForm.FAdminTreeview.CheckOneNode(frmMainForm.FAdminTreeview.Selected);
        bitfarmApp.CountChecked;
    end;
    if (TbfaTreeView(frmMainForm.FAdminTreeview).Selected = nil) or (FCurrentArchive = nil) then
    begin
      if frmMainForm.FAdminTreeview.RootNode <> nil then //20.07.2022 wegen CrashLog, wenn keine Lager/Archive im DB ist z.B. ein Fehler bei neuinstallation
      begin
        if FCurrentArchive = nil then
        begin
          frmMainForm.FAdminTreeview.RootNode.Selected := True;
          frmMainForm.FAdminTreeview.Checked[frmMainForm.FAdminTreeview.RootNode] := False;
          id := PbfaInt64(frmMainForm.FAdminTreeview.RootNode.Data).Value;
        end else
          id := FCurrentArchive.ID;

        SelectArchive(id);
      end;
    end;

    btnSaveAdmin.Visible := tabctrAdmin.ActiveTabIndex in [0,1,2];
    btnCancelAdmin.Visible := tabctrAdmin.ActiveTabIndex in [0,1,2];
    pnlButtons.Visible := tabctrAdmin.ActiveTabIndex in [0,1,2];

    //if lvHoliday.Selected <> nil then
    //begin
      //btnModifyHoliday.Enabled := bitfarmApp.AdminEditMode;
      //btnDeleteHoliday.Enabled := bitfarmApp.AdminEditMode;
      //btnCancelHoliday.Enabled := bitfarmApp.AdminEditMode;
    //end;

    EnableResubSearchFields;
    frmMainForm.frmSplash.Update;

    //01.03.2023 bfacrm:ticket__show__34057 -->
    var qry: TUniQuery;
    qry := TUniQuery.Create(nil);
    try
      qry.Connection := dmMain.cntMain;
      qry.SQL.Text := 'SELECT * From sys_arc Where lgrid=arcid';

      qry.Execute;
      if qry.RecordCount > 0 then
        BfMessageDlg(_('Fehler: Ein Archiv kann sich nicht selbst als Lager referenzieren.'), TMsgDlgType.mtWarning, [mbOK], False, _('Warning'));
    finally
      FreeAndNil(qry);
    end;
    //01.03.2023 bfacrm:ticket__show__34057 <--

  finally
    frmMainForm.frmSplash.lblInfo.Caption := '';
    frmMainForm.frmSplash.Hide;
  end;
end;

//procedure TfraAdmin.LoadHolidayList;
//var
  //lmq: TUniQuery;
  //item: TListItem;
  //idx : Integer;
//begin
  //bitfarmLog.DebugBegin(llDebug, 'LoadHolidayList', ClassName);
  //try
    //try
      //if lvHoliday.Selected <> nil then
        //idx := lvHoliday.ItemIndex
      //else
        //idx := -1;
//
      //lvHoliday.Items.Clear;
      //lmq := DbCreateQuery;
      //try
        //lmq.SQL.Text := 'select holid, userid_src, src.username as srcname, userid_dst, dst.username as dstname, start, end from sys_holiday' +
                        //' left join sys_user as src on userid_src = src.userid' +
                        //' left join sys_user as dst on userid_dst = dst.userid order by start desc';
        //lmq.Execute;
        //if lmq.RecordCount > 0 then
        //begin
          //lmq.First;
          //while not lmq.Eof do
          //begin
            //item := lvHoliday.Items.Add;
            //item.Caption := lmq.FieldByName('srcname').AsString;
            //item.SubItems.Add(lmq.FieldByName('dstname').AsString);
            //item.SubItems.Add(lmq.FieldByName('start').AsString);
            //item.SubItems.Add(lmq.FieldByName('end').AsString);
            //item.SubItems.Add(lmq.FieldByName('holid').AsString);
            //item.SubItems.Add(lmq.FieldByName('userid_src').AsString);
            //lmq.Next;
          //end;
        //end;
      //finally
        //lmq.Free;
      //end;
//
      //if (idx <> -1) and (idx > lvHoliday.Items.Count -1)then
        //Dec(idx);
      //lvHoliday.ItemIndex := idx;
    //except
    //bitfarmLog.Write(llNormal, ltException, 'LoadHolidayList', ClassName);
    //end;
  //finally
   //bitfarmLog.DebugEnd(llDebug, 'LoadHolidayList', ClassName);
  //end;
//end;

procedure TfraAdmin.LoadObjectLists;
var
  lmq : TUniQuery;
  arc : TbfaArchive;
  user: TbfaUser;
  group: TbfaGroup;
  addfield: TbfaAddField;
  statefield: TbfaStateField;
  i, idx, idx2: Integer;
  arcid, groupid, userid, addfieldid, statefieldid, fieldpos: string;    // die item-bezeichner in den Tstringlisten
  right : Int64;  // eine Rechtesatz als Bitmask
  fieldright : TbfaFieldRight;
  fieldrights: TList<TbfaFieldRight>;
  statefieldrights: TList<TbfaFieldRight>;
  arcright : TbfaArcRight;
begin
  bitfarmApp.cnt_enabled := 0;
  lmq := DbCreateQuery;
  try
    lmq.SQL.Text := 'select arcid, lgrid, arcname, tblname, flags +0, backpic, icon, type, options, defdocname, storageid, duration, `interval` from sys_arc where (flags & 2) = 0';   // alle die nicht deletetd sind
    lmq.Execute;
    if lmq.RecordCount > 0 then
    begin
      while not lmq.Eof do
      begin
        arc := TbfaArchive.Create;

        arc.ID := lmq.FieldByName('arcid').AsInteger;
        arc.Lgrid := lmq.FieldByName('lgrid').AsInteger;
        arc.Name := lmq.FieldByName('arcname').AsWideString;
        arc.Tblname := lmq.FieldByName('tblname').AsString;
        arc.Backpic := lmq.FieldByName('backpic').AsWideString;
        arc.Typ := lmq.FieldByName('type').AsInteger;
        arc.Options := lmq.FieldByName('options').AsInteger;
        arc.DefDocname := lmq.FieldByName('defdocname').AsWideString;
        arc.Storageid := lmq.FieldByName('storageid').AsInteger;
        arc.Flags := lmq.FieldByName('flags +0').AsInteger;
        arc.Duration :=  lmq.FieldByName('duration').AsInteger;
        arc.Interval := lmq.FieldByName('interval').AsString;
        bitfarmApp.GArchives.Add(arc);

        lmq.Next;
      end;
    end;
  finally
    lmq.Free;
  end;

  lmq := DbCreateQuery;
  try
    lmq.SQL.Text := 'select userid, username, displayname, userpass, flags +0, usermail, role +0 from sys_user where (flags & 2) = 0';   // alle die nicht deletetd sind
    lmq.Execute;
    if lmq.RecordCount > 0 then
    begin
      while not lmq.Eof do
      begin
        user := TbfaUser.Create;
        user.ID := lmq.FieldByName('userid').AsInteger;
        user.Name := lmq.FieldByName('username').AsWideString;
        user.DisplayName := lmq.FieldByName('displayname').AsWideString;
        user.Password := lmq.FieldByName('userpass').AsWideString;
        user.Flags := lmq.FieldByName('flags +0').AsInteger;
        user.Email  := lmq.FieldByName('usermail').AsWideString;
        user.Role := lmq.FieldByName('role +0').AsInteger;

        bitfarmApp.GUser.Add(user);

        if user.ID  > FUseridMax then
          FUseridMax := user.ID;

        if (user.Flags and 1 = 1) and (user.ID <> 1) and (user.Flags and 192 = 0) then  //enabled named user
          Inc(bitfarmApp.cnt_enabled);

        lmq.Next;
      end;
    end;
  finally
    lmq.Free;
  end;

  lmq := DbCreateQuery;
  try
    lmq.SQL.Text := 'select groupid, groupname, role +0, flags +0, adpath, email from sys_group where (flags & 2) = 0';
    lmq.Execute;
    if lmq.RecordCount > 0 then
    begin
      while not lmq.Eof do
      begin
        group := TbfaGroup.Create;
        group.ID := lmq.FieldByName('groupid').AsInteger;
//13.09.2024        group.Name := lmq.FieldByName('groupname').AsWideString;
        group.Name := bitfarmApp.TranslateGroupName(lmq.FieldByName('groupname').AsWideString);
        group.Role := lmq.FieldByName('role +0').AsInteger;
        group.Flags := lmq.FieldByName('flags +0').AsInteger;
        group.ADPath := lmq.FieldByName('adpath').AsWideString;
        group.Email := lmq.FieldByName('email').AsWideString;

        bitfarmApp.GGroups.Add(group);

        if group.ID  > FGroupidMax then
          FGroupidMax := group.ID;

        lmq.Next;
      end;
    end;
  finally
    lmq.Free;
  end;

  lmq := DbCreateQuery;
  try
    lmq.SQL.Text := 'select addfieldid, fieldname, displayname, type, items, mode, options, checkprogram, values_query, indextableid, flags +0, description from sys_addfields where (flags & 2) = 0';
    lmq.Execute;
    if lmq.RecordCount > 0 then
    begin
      while not lmq.Eof do
      begin
        addfield := TbfaAddField.Create;

        addfield.ID := lmq.FieldByName('addfieldid').AsInteger;
        addfield.Name := lmq.FieldByName('fieldname').AsString;
        addfield.DisplayName := lmq.FieldByName('displayname').AsWideString;
        addfield.Typ := lmq.FieldByName('type').AsInteger;
        addfield.Options := lmq.FieldByName('options').AsInteger;
        addfield.Mode := lmq.FieldByName('mode').AsInteger;
        addfield.IndexTableID := lmq.FieldByName('indextableid').AsInteger;
        addfield.Checkprogram := lmq.FieldByName('checkprogram').AsWideString;
        addfield.ValuesQuery :=  lmq.FieldByName('values_query').AsWideString;
        addfield.Items.DelimitedText := lmq.FieldByName('items').AsWideString;
        addfield.Flags := lmq.FieldByName('flags +0').AsInteger;
        addfield.Description := lmq.FieldByName('description').AsWideString;

        bitfarmApp.GAddfields.Add(addfield);

        if addfield.ID  > FAddfieldidMax then
          FAddfieldidMax := addfield.ID;

        lmq.Next;
      end;
    end;
  finally
    lmq.Free;
  end;

  lmq := DbCreateQuery;
  try
    lmq.SQL.Text := 'select stateid, displayname, bitmask, addfieldid, `function`, indexcolumnid, flags +0 from sys_statefields where (flags & 2) = 0';
    lmq.Execute;
    if lmq.RecordCount > 0 then
    begin
      while not lmq.Eof do
      begin
        statefield := TBfaStateField.Create;

        statefield.ID := lmq.FieldByName('stateid').AsInteger;
        statefield.DisplayName := lmq.FieldByName('displayname').AsWideString;
        statefield.Bitmask := trunc(lmq.FieldByName('bitmask').AsFloat);
        statefield.AddfieldID := lmq.FieldByName('addfieldid').AsInteger;
        statefield.Func := lmq.FieldByName('function').AsInteger;
        statefield.IndexColumnID := lmq.FieldByName('indexcolumnid').AsInteger;
        statefield.Flags := lmq.FieldByName('flags +0').AsInteger;

        bitfarmApp.GStatefields.Add(statefield);

        if statefield.ID  > FStatefieldidMax then
          FStatefieldidMax := statefield.ID;

        lmq.Next;
      end;
    end;
  finally
    lmq.Free;
  end;

  // jetzt ergnzen wir die user und gruppen objekte mit ihren member
  lmq := DbCreateQuery;
  try
    for i := 0 to bitfarmApp.GGroups.Count -1 do
    begin
      lmq.SQL.Text := 'SELECT g.userid, u.username from sys_groupuser as g left join sys_user as u on g.userid = u.userid where u.flags & 2 = 0 and groupid = ' + IntToStr(bitfarmApp.GGroups[i].ID);
      lmq.Execute;
      if lmq.RecordCount > 0 then
      begin
        while not lmq.Eof do
        begin
          if bitfarmApp.GGroups[i].Members.IndexOf(lmq.FieldByName('userid').AsString) = -1 then
            bitfarmApp.GGroups[i].Members.AddObject(lmq.FieldByName('userid').AsString, TbfaString.Create(lmq.FieldByName('username').AsString));
          lmq.Next;
        end;
      end;
//        bitfarmApp.GGroups[i].Members.CommaText := lmq.FieldByName('userid').AsString;

    end;
  finally
    lmq.Free;
  end;

  lmq := DbCreateQuery;
  try
    for i := 0 to bitfarmApp.GUser.Count -1 do
    begin
      lmq.SQL.Text := 'SELECT group_concat(groupid) from sys_groupuser where userid = ' + IntToStr(bitfarmApp.GUser[i].ID);
      lmq.Execute;
      if lmq.RecordCount > 0 then
        bitfarmApp.GUser[i].GroupList.CommaText := lmq.FieldByName('group_concat(groupid)').AsString;

      if (bitfarmApp.GUser[i].Flags and 16) = 16 then  // sind wir vorgesetzter?
      begin
        lmq.SQL.Text := 'SELECT group_concat(inf_userid) from sys_superior where sup_userid = ' + IntToStr(bitfarmApp.GUser[i].ID);
        lmq.Execute;
        if lmq.RecordCount > 0 then
          bitfarmApp.GUser[i].EmployeesList.CommaText := lmq.FieldByName('group_concat(inf_userid)').AsString;
      end;

    end;
  finally
    lmq.Free;
  end;

  lmq := DbCreateQuery;   // aktuellen Timestamp holen
  try
    lmq.SQL.Text := 'select modified, modified_userid from sys_doc where gdocid = 0';
    lmq.Execute;
    if lmq.RecordCount > 0 then
    begin
      FLastModified := lmq.FieldByName('modified').AsDateTime;
      FModifiedUserid := lmq.FieldByName('modified_userid').AsInteger;
    end else begin
      FLastModified := Now();
      FModifiedUserid := User.ID
    end;
  finally
    lmq.Free;
  end;


  // so, jetzt wirds lustig: wir lesen die aktuellen Zuordnungen (User, Groups, Addfields, Statefields)
  // und packen sie in die Archive-Objekte

  lmq := DbCreateQuery;
  try
    for i := 0 to bitfarmApp.GArchives.Count -1 do
    begin
      // erst die basiseintrge der gruppen holen
      lmq.SQL.Text := 'select groupid, rights +0 from sys_arcxs where userid = 0 and arcid = ' + IntToStr(bitfarmApp.GArchives[i].ID);
      lmq.Execute;
      if lmq.RecordCount > 0 then
      begin
        lmq.First;
        while not lmq.Eof do
        begin
          groupid := lmq.FieldByName('groupid').AsString;
          right := lmq.FieldByName('rights +0').AsInteger;
          arcright := TbfaArcRight.Create;
          arcright.Groupid := StrToInt(groupid);
          arcright.Rights := right;
          arcright.ArcID := bitfarmApp.GArchives[i].ID;
          bitfarmApp.GArchives[i].Groups.AddObject(groupid, arcright);
          lmq.Next;
        end;
      end;

      // dann noch die einzeluser hinzu
      lmq.SQL.Text := 'select userid, rights +0 from sys_arcxs where groupid = 0 and arcid = ' + IntToStr(bitfarmApp.GArchives[i].ID);
      lmq.Execute;
      if lmq.RecordCount > 0 then
      begin
        lmq.First;
        while not lmq.Eof do
        begin
          userid := lmq.FieldByName('userid').AsString;
          right := lmq.FieldByName('rights +0').AsInteger;
          arcright := TbfaArcRight.Create;
          arcright.Userid := StrToInt(userid);
          arcright.Rights := right;
          arcright.ArcID := bitfarmApp.GArchives[i].ID;
          bitfarmApp.GArchives[i].Users.AddObject(userid, arcright);
          lmq.Next;
        end;
      end;

      // jetzt wirds spannend: Addfields mit einer Liste von TbfaFieldRights
      // erst alle gruppen, gruppe 0 bedeutet alle User
//      fieldrights := TList<TbfaFieldRight>.Create;
      lmq.SQL.Text := 'select arcid, fieldid, userid, groupid, pos, rights +0 from sys_addfieldxs where userid = 0 and arcid =' + IntToStr(bitfarmApp.GArchives[i].ID) + ' order by pos';
      lmq.Execute;
      if lmq.RecordCount > 0 then
      begin
        lmq.First;
        while not lmq.Eof do
        begin
          addfieldid := lmq.FieldByName('fieldid').AsString;
          right := lmq.FieldByName('rights +0').AsInteger;

          fieldright := TbfaFieldRight.Create;
          fieldright.FieldID := StrToInt(addfieldid);
          fieldright.Groupid := lmq.FieldByName('groupid').AsInteger;
          fieldright.Rights := right;
          fieldright.Fieldpos := lmq.FieldByName('pos').AsInteger;
          fieldright.ArcID := lmq.FieldByName('arcid').AsInteger;

          idx := bitfarmApp.GArchives[i].Addfields.IndexOf(addfieldid);
          if idx = -1 then   // wir haben noch kein Addfield mit dieser ID? Anlegen und Liste als Object erzeugen
          begin
            fieldrights := TList<TbfaFieldRight>.Create;
            idx := bitfarmApp.GArchives[i].Addfields.AddObject(addfieldid, fieldrights);
            fieldrights.Add(fieldright);
          end else begin // wir haben das Feld schon? dann die Feldberechtigung zur Liste hinzufgen
            fieldrights := TList<TbfaFieldRight>(bitfarmApp.GArchives[i].Addfields.Objects[idx]);
            fieldrights.Add(fieldright);
          end;
          lmq.Next;
        end;
      end;

      // so, jetzt noch einzeluser, da wir den gruppe 0 eintrag schon haben, wird dieser nicht nochmal abgefragt
      lmq.SQL.Text := 'select arcid, fieldid, userid, groupid, pos, rights +0 from sys_addfieldxs where userid <> 0 and arcid =' + IntToStr(bitfarmApp.GArchives[i].ID) + ' order by pos';
      lmq.Execute;
      if lmq.RecordCount > 0 then
      begin
        lmq.First;
        while not lmq.Eof do
        begin
          addfieldid := lmq.FieldByName('fieldid').AsString;
          right := lmq.FieldByName('rights +0').AsInteger;

          fieldright := TbfaFieldRight.Create;
          fieldright.FieldID := StrToInt(addfieldid);
          fieldright.Userid := lmq.FieldByName('userid').AsInteger;
          fieldright.Rights := right;
          fieldright.Fieldpos := lmq.FieldByName('pos').AsInteger;
          fieldright.ArcID := lmq.FieldByName('arcid').AsInteger;

          idx := bitfarmApp.GArchives[i].Addfields.IndexOf(addfieldid);
          if idx = -1 then   // wir haben noch kein Addfield mit dieser ID? Anlegen und Liste als Object erzeugen
          begin
            fieldrights := TList<TbfaFieldRight>.Create;
            bitfarmApp.GArchives[i].Addfields.AddObject(addfieldid, fieldrights);
            fieldrights.Add(fieldright);
          end else begin // wir haben das Feld schon? dann die Feldberechtigung zur Liste hinzufgen
            fieldrights := TList<TbfaFieldRight>(bitfarmApp.GArchives[i].Addfields.Objects[idx]);
            fieldrights.Add(fieldright);
          end;
          lmq.Next;
        end;
      end;

      // und das ganze jetzt fr statefields
//      statefieldrights := TList<TbfaFieldRight>.Create;
      lmq.SQL.Text := 'select arcid, fieldid, userid, groupid, pos, rights +0 from sys_statefieldxs where userid = 0 and arcid =' + IntToStr(bitfarmApp.GArchives[i].ID) + ' order by pos';
      lmq.Execute;
      if lmq.RecordCount > 0 then
      begin
        lmq.First;
        while not lmq.Eof do
        begin
          statefieldid := lmq.FieldByName('fieldid').AsString;
          right := lmq.FieldByName('rights +0').AsInteger;

          fieldright := TbfaFieldRight.Create;
          fieldright.FieldID := StrToInt(statefieldid);
          fieldright.Groupid := lmq.FieldByName('groupid').AsInteger;
          fieldright.Rights := right;
          fieldright.Fieldpos := lmq.FieldByName('pos').AsInteger;
          fieldright.ArcID := lmq.FieldByName('arcid').AsInteger;

          idx := bitfarmApp.GArchives[i].Statefields.IndexOf(statefieldid);
          if idx = -1 then   // wir haben noch kein Addfield mit dieser ID? Anlegen und Liste als Object erzeugen
          begin
             statefieldrights := TList<TbfaFieldRight>.Create;
             bitfarmApp.GArchives[i].Statefields.AddObject(statefieldid, statefieldrights);
             statefieldrights.Add(fieldright);
          end else begin // wir haben das Feld schon? dann die Feldberechtigung zur Liste hinzufgen
            statefieldrights := TList<TbfaFieldRight>(bitfarmApp.GArchives[i].Statefields.Objects[idx]);
            statefieldrights.Add(fieldright);
          end;
          lmq.Next;
        end;
      end;

      // so, jetzt noch einzeluser, da wir den gruppe 0 eintrag schon haben, wird dieser nicht nochmal abgefragt
      lmq.SQL.Text := 'select arcid, fieldid, userid, groupid, pos, rights +0 from sys_statefieldxs where userid <> 0 and arcid =' + IntToStr(bitfarmApp.GArchives[i].ID) + ' order by pos';
      lmq.Execute;
      if lmq.RecordCount > 0 then
      begin
        lmq.First;
        while not lmq.Eof do
        begin
          statefieldid := lmq.FieldByName('fieldid').AsString;
          right := lmq.FieldByName('rights +0').AsInteger;

          fieldright := TbfaFieldRight.Create;
          fieldright.Fieldid := StrToInt(statefieldid);
          fieldright.Userid := lmq.FieldByName('userid').AsInteger;
          fieldright.Rights := right;
          fieldright.Fieldpos := lmq.FieldByName('pos').AsInteger;
          fieldright.ArcID := lmq.FieldByName('arcid').AsInteger;

          idx := bitfarmApp.GArchives[i].Statefields.IndexOf(statefieldid);
          if idx = -1 then   // wir haben noch kein Addfield mit dieser ID? Anlegen und Liste als Object erzeugen
          begin
             statefieldrights := TList<TbfaFieldRight>.Create;
             bitfarmApp.GArchives[i].Statefields.AddObject(statefieldid, statefieldrights);
             statefieldrights.Add(fieldright);
          end else begin // wir haben das Feld schon? dann die Feldberechtigung zur Liste hinzufgen
            statefieldrights := TList<TbfaFieldRight>(bitfarmApp.GArchives[i].Statefields.Objects[idx]);
            statefieldrights.Add(fieldright);
          end;
          lmq.Next;
        end;
      end;
    end;
  finally
    lmq.Free;
  end;

end;

procedure TfraAdmin.LoadRegistration;
var
  req: TbfaRequest;
  lmq : TUniQuery;
  UserAction : PUserAction;
begin
 req := TbfaRequest.Create;
  try
    req.ReqType := 'reqRegistration';
    req.UserID := bitfarmApp.User.ID;
    req.Profile := bitfarmApp.Profile;
    req.Lang := bitfarmApp.Lang;
    bitfarmApp.MainSocket.SendRequestToServer(req);

    req := bitfarmApp.MainSocket.ReceiveResponse;
    if req = nil then
      Exit;

    if req.ReqType = 'respAuthError' then
    begin
      BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'));
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actRelogin';
      bitfarmApp.MainThread.Add(UserAction);
      Exit;
    end
    else
    if req.ReqType = 'respError' then
    begin
      BfShowMessage(_(req.DataString));
    end else if req.Datastring <> '' then
    begin
      try
        bitfarmApp.max_named := StrToInt(LeftStr(req.Datastring,Pos(';', req.DataString) -1));
        bitfarmApp.max_concurrent := StrToInt(RightStr(req.Datastring, Length(req.Datastring) - Pos(';', req.DataString)));
      except
        bitfarmApp.max_named := 0;
        bitfarmApp.max_concurrent := 0;
      end;
    end;
  finally
    FreeAndNil(req);
  end;

  lmq := DbCreateQuery;
  try
    lmq.SQL.Text := 'SELECT count(*) FROM sys_user where flags & 1 = 1 and flags & 194 = 0 and userid <> 1';
    lmq.Execute;
    if lmq.RecordCount > 0 then
    begin
      lmq.First;
      bitfarmApp.cnt_named := lmq.FieldByName('count(*)').AsInteger;
    end;
    lmq.SQL.Text := 'SELECT count(*) FROM sys_user where flags & 2 = 0 and flags & 65 = 65';
    lmq.Execute;
    if lmq.RecordCount > 0 then
    begin
      lmq.First;
      bitfarmApp.cnt_concurrent := lmq.FieldByName('count(*)').AsInteger;
    end;
  finally
    lmq.Free;
  end;
  ShowUserProperties(nil);

end;

procedure TfraAdmin.LoadTreeview;
begin
  frmMainForm.FAdminTreeview.ClearTreeview;
  frmMainForm.FAdminTreeview.Checkboxes := True;
//29.03.2017 Ticket 10202    frmMainForm.FAdminTreeview.Load(False);

  if bitfarmApp.User.isAdmin then
  begin
    if bitfarmApp.User.DMSAdmin then
      frmMainForm.FAdminTreeview.Right := 0
    else
      frmMainForm.FAdminTreeview.Right := rightAdmin;

    frmMainForm.FAdminTreeview.Load(True);
  end;

end;

procedure TfraAdmin.lvAdminLogCustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
begin
  // SJ 12.12.2019: bfacrm:ticket__show__20648
  if bitfarmApp.ViewerOptions.GeneralOptions.RowColorEvenOdd and (Item.Index mod 2 <> 0) then
    Sender.Canvas.brush.color := ColorAdjustLuma(colortorgb(Sender.Canvas.brush.color),-15,false);
end;

//procedure TfraAdmin.lvHolidaySelectItem(Sender: TObject; Item: TListItem;
  //Selected: Boolean);
//var
  //holid: string;
  //user: TbfaUser;
  //i: Integer;
//begin
  //if Selected then
  //begin
    //// Listen wieder vervollstndigen
//
    //cbxHolidayUser.Items.BeginUpdate;
    //cbxReplacement.Items.BeginUpdate;
    //cbxHolidayUser.Items.Clear;
    //cbxReplacement.Items.Clear;
//
    //try
      //for i := 0 to bitfarmApp.GUser.Count -1 do
      //begin
        //cbxHolidayUser.Items.AddObject(bitfarmApp.GUser[i].Name, bitfarmApp.GUser[i]);
        //cbxReplacement.Items.AddObject(bitfarmApp.GUser[i].Name, bitfarmApp.GUser[i]);
      //end;
    //finally
      //cbxHolidayUser.Items.EndUpdate;
      //cbxReplacement.Items.EndUpdate;
    //end;
//
    //holid := Item.SubItems[3];
    //cbxHolidayUser.ItemIndex := cbxHolidayUser.Items.IndexOf(Item.Caption);
    //cbxReplacement.ItemIndex := cbxReplacement.Items.IndexOf(Item.SubItems[0]);
    //dtDateStart.Text := Item.SubItems[1];
    //dtDateEnd.Text := Item.SubItems[2];
//
  //end;
  //btnModifyHoliday.Enabled := Selected and bitfarmApp.AdminEditMode;
  //btnDeleteHoliday.Enabled := Selected and bitfarmApp.AdminEditMode;
  //btnCancelHoliday.Enabled := Selected and bitfarmApp.AdminEditMode;
//end;

//procedure TfraAdmin.ModifyHolidayList(holid, user, repl, datestart,
  //dateend: WideString);
//var
  //i : Integer;
//begin
  //for i := 0 to lvHoliday.Items.Count -1 do
  //begin
    //if lvHoliday.Items[i].SubItems[3] = holid then
    //begin
      //lvHoliday.Items[i].Caption := user;
      //lvHoliday.Items[i].SubItems[0] := repl;
      //lvHoliday.Items[i].SubItems[1] := datestart;
      //lvHoliday.Items[i].SubItems[2] := dateend;
    //end;
  //end;
//end;

procedure TfraAdmin.OnAddAssignFields(AValue: WideString; AObject: TObject);
var
  i : Integer;
  arc : TbfaArchive;
  arcrights : TbfaArcRight;
  right : TbfaFieldRight;
  fieldrights: TList<TbfaFieldRight>;
  id, idx : Int64;
begin
  if frmMainForm.FAdminTreeview.CountChecked > 0 then
  begin
    for i := 0 to frmMainForm.FAdminTreeview.Items.Count -1 do
    begin
      if not frmMainForm.FAdminTreeview.Checked[frmMainForm.FAdminTreeview.Items.Item[i]] then
        Continue;

      id := PbfaInt64(frmMainForm.FAdminTreeview.Items.Item[i].Data).Value;

      arc := GetArchiveByID(id);
      if arc <> nil then
      begin
        if AObject is TbfaAddField then
        begin
          idx := arc.Addfields.IndexOf(IntToStr(TbfaAddField(AObject).ID));
          if idx = -1 then
            idx := arc.Addfields.AddObject(IntToStr(TbfaAddField(AObject).ID), TList<TbfaFieldRight>.Create);
          arc.Modified_Addfields := True;

          if bitfarmApp.ViewerOptions.AdminOptions.DefaultAddfieldGroup then
          begin
            right := TbfaFieldRight.Create;
            right.ArcID := arc.ID;
            right.FieldID := TbfaAddField(AObject).ID;
            right.Groupid := 0;
            right.Rights := bitfarmApp.ViewerOptions.AdminOptions.DefaultAddfieldGroupRights;
            right.Modified := True;
            right.Fieldpos := bfsAssignAddfields.ListSelected.IndexOfObject(AObject);
            fieldrights := TList<TbfaFieldRight>(arc.Addfields.Objects[idx]);
            fieldrights.Add(right);
          end;
        end else if AObject is TbfaStateField then
        begin
          idx := arc.Statefields.IndexOf(IntToStr(TbfaStateField(AObject).ID));
          if idx = -1 then
            idx := arc.Statefields.AddObject(IntToStr(TbfaStateField(AObject).ID), TList<TbfaFieldRight>.Create);
          arc.Modified_Statefields := True;

          if bitfarmApp.ViewerOptions.AdminOptions.DefaultStatefieldGroup then
          begin
            right := TbfaFieldRight.Create;
            right.ArcID := arc.ID;
            right.FieldID := TbfaAddField(AObject).ID;
            right.Groupid := 0;
            right.Rights := bitfarmApp.ViewerOptions.AdminOptions.DefaultStatefieldGroupRights;
            right.Modified := True;
            right.Fieldpos := bfsAssignStatefields.ListSelected.IndexOfObject(AObject);
            fieldrights := TList<TbfaFieldRight>(arc.Statefields.Objects[idx]);
            fieldrights.Add(right);
          end;
        end;
        SetModified;
      end;
    end;
  end;
  EnableBySelect;
//  ShowArchiveRights(0);   // da der neue Eintrag erstmal nicht selektiert ist, zeigen wir keine rechte

end;

procedure TfraAdmin.OnAddAssignUser(AValue: WideString; AObject: TObject);
var
  i : Integer;
  arc : TbfaArchive;
  id : Int64;
  arcrights: TbfaArcRight;
begin
  if frmMainForm.FAdminTreeview.CountChecked > 0 then
  begin
    for i := 0 to frmMainForm.FAdminTreeview.Items.Count -1 do
    begin
      if not frmMainForm.FAdminTreeview.Checked[frmMainForm.FAdminTreeview.Items.Item[i]] then
        Continue;

      id := PbfaInt64(frmMainForm.FAdminTreeview.Items.Item[i].Data).Value;

      arc := GetArchiveByID(id);
      if arc <> nil then
      begin
        if AObject is TBfaUser then
        begin
          arcrights := TbfaArcRight.Create;
          arcrights.ArcID := id;
          arcrights.ArcTempID := arc.TempID;
          arcrights.Userid := TbfaUser(AObject).ID;
          arcrights.Rights := TbfaUser(AObject).Role;
          arcrights.Modified := True;
          if arc.Users.IndexOf(IntToStr(TbfaUser(AObject).ID)) = -1 then
            arc.Users.AddObject(IntToStr(TbfaUser(AObject).ID), arcrights)
          else
            arc.Users.Objects[arc.Users.IndexOf(IntToStr(TbfaUser(AObject).ID))] := arcrights;
          arc.Modified_User := True;
        end else if AObject is TbfaGroup then
        begin
          arcrights := TbfaArcRight.Create;
          arcrights.ArcID := id;
          arcrights.ArcTempID := arc.TempID;
          arcrights.Groupid := TbfaGroup(AObject).ID;
          arcrights.Rights := TbfaGroup(AObject).Role;
          arcrights.Modified := True;
          arc.Groups.AddObject(IntToStr(TbfaGroup(AObject).ID), arcrights);
          arc.Modified_User := True;
        end;
        SetModified;
      end;
    end;
  end;

  ShowArchiveRights(0);   // da der neue Eintrag erstmal nicht selektiert ist, zeigen wir keine rechte
end;

procedure TfraAdmin.OnAddAddfieldUser(AValue: WideString; AObject: TObject);
var
  i, j, idx: Integer;
  arc : TbfaArchive;
  id : Int64;
  field : TbfaAddField;
  right : TbfaFieldRight;
  fieldrights: TList<TbfaFieldRight>;
begin
  if frmMainForm.FAdminTreeview.CountChecked > 0 then
  begin
    for i := 0 to frmMainForm.FAdminTreeview.Items.Count -1 do
    begin
      if not frmMainForm.FAdminTreeview.Checked[frmMainForm.FAdminTreeview.Items.Item[i]] then
        Continue;

      id := PbfaInt64(frmMainForm.FAdminTreeview.Items.Item[i].Data).Value;

      arc := GetArchiveByID(id);
      if arc <> nil then
      begin
        for j := 0 to bfsAssignAddfields.lvList2.Items.Count -1 do
        begin
          if bfsAssignAddfields.lvList2.Items[j].Selected then
          begin
            field := TbfaAddField(bfsAssignAddfields.lvList2.Items[j].Data);
            idx := arc.Addfields.IndexOf(IntToStr(field.ID));

            if idx > -1 then
            begin
              if AObject is TBfaUser then
              begin
                right := TbfaFieldRight.Create;
                right.ArcID := arc.ID;
                right.FieldID := field.ID;
                right.Userid := TbfaUser(AObject).ID;
                right.Fieldpos := j;
                right.Rights := 4;
                right.Modified := True;

                fieldrights := TList<TbfaFieldRight>(arc.Addfields.Objects[idx]);
                fieldrights.Add(right);
                arc.Modified_Addfields := True;
              end else if AObject is TbfaGroup then
              begin
                right := TbfaFieldRight.Create;
                right.ArcID := arc.ID;
                right.FieldID := field.ID;
                right.Groupid := TbfaGroup(AObject).ID;
                right.Fieldpos := j;
                right.Rights := 4;
                right.Modified := True;

                fieldrights := TList<TbfaFieldRight>(arc.Addfields.Objects[idx]);
                fieldrights.Add(right);
                arc.Modified_Addfields := True;
              end;
              SetModified;
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure TfraAdmin.OnAddGroupsUser(AValue: WideString; AObject: TObject);
begin
  if AObject <> nil then
  begin
    if FCurrentGroup.Members.IndexOf(IntToStr(TbfaUser(AObject).ID)) = -1 then
    begin
      FCurrentGroup.Members.Add(IntToStr(TbfaUser(AObject).ID));
      FCurrentGroup.Modified := True;
      SetModified;
    end;
  end;
end;

//procedure TfraAdmin.OnAddInferior(AValue: WideString; AObject: TObject);
//var
  //user, inf: TbfaUser;
  //i, id : Integer;
//begin
  //if cbxSuperior.ItemIndex > -1 then
  //begin
    //user := TbfaUser(cbxSuperior.Items.Objects[cbxSuperior.ItemIndex]);
    //id := TbfaUser(AObject).ID;
    //if user.EmployeesList.IndexOf(IntToStr(id)) = -1 then
    //begin
      //user.EmployeesList.Add(IntToStr(id));
      //user.Modified := True;
      //SetModified;
    //end;
  //end;
//end;

procedure TfraAdmin.OnAddStatefieldUser(AValue: WideString; AObject: TObject);
var
  i, j, idx: Integer;
  arc : TbfaArchive;
  id : Int64;
  field : TbfaStateField;
  right : TbfaFieldRight;
  fieldrights: TList<TbfaFieldRight>;
begin
  if frmMainForm.FAdminTreeview.CountChecked > 0 then
  begin
    for i := 0 to frmMainForm.FAdminTreeview.Items.Count -1 do
    begin
      if not frmMainForm.FAdminTreeview.Checked[frmMainForm.FAdminTreeview.Items.Item[i]] then
        Continue;

      id := PbfaInt64(frmMainForm.FAdminTreeview.Items.Item[i].Data).Value;

      arc := GetArchiveByID(id);
      if arc <> nil then
      begin
        for j := 0 to bfsAssignStatefields.lvList2.Items.Count -1 do
        begin
          if bfsAssignStatefields.lvList2.Items[j].Selected then
          begin
            field := TbfaStateField(bfsAssignStatefields.lvList2.Items[j].Data);
            idx := arc.Statefields.IndexOf(IntToStr(field.ID));

            if idx > -1 then
            begin
              if AObject is TBfaUser then
              begin
                right := TbfaFieldRight.Create;
                right.ArcID := arc.ID;
                right.FieldID := field.ID;
                right.Userid := TbfaUser(AObject).ID;
                right.Fieldpos := j;
                right.Rights := 4;
                right.Modified := True;

                fieldrights := TList<TbfaFieldRight>(arc.Statefields.Objects[idx]);
                fieldrights.Add(right);
                arc.Modified_Statefields := True;
              end else if AObject is TbfaGroup then
              begin
                right := TbfaFieldRight.Create;
                right.ArcID := arc.ID;
                right.FieldID := field.ID;
                right.Groupid := TbfaGroup(AObject).ID;
                right.Fieldpos := j;
                right.Rights := 4;
                right.Modified := True;

                fieldrights := TList<TbfaFieldRight>(arc.Statefields.Objects[idx]);
                fieldrights.Add(right);
                arc.Modified_Statefields := True;
              end;
              SetModified;
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure TfraAdmin.OnBeginEditInput(Sender: TObject);   // Solange eine Eingabe geschieht, Speichern disablen
var
  arc : TbfaArchive;
begin
  //28.06.2024 SD -->bfacrm:ticket__show__38644
  // die Auswahlcombos Lagerort-Bezeichnung aktualisieren
  arc := GetArchiveByID(frmMainForm.FAdminTreeview.lastSelected);
  if arc.Typ = 0 then
    FCurrentArchive := GetArchiveByID(arc.ID)
  else
    FCurrentArchive := GetArchiveByID(arc.Lgrid);
  if not (Sender = bfiRepos) then
  begin
    if bfiRepos.cbbInput.ItemIndex <> bfiRepos.cbbInput.Items.IndexOfObject(FCurrentArchive) then
      bfiRepos.cbbInput.ItemIndex := bfiRepos.cbbInput.Items.IndexOfObject(FCurrentArchive);
  end;
  //28.06.2024 SD <--bfacrm:ticket__show__38644

  EnableInputGroups(Sender, False);

  bfiRepos.EnableAllControls(Sender = bfiRepos);   // Wenn mehrere Frames im Editmodus-> aktiviert SaveButton
  bfiAddfields.EnableAllControls(Sender = bfiAddfields);
  bfiStatefields.EnableAllControls(Sender = bfiStatefields);
  bfiArchives.EnableAllControls(Sender = bfiArchives);
  bfiUser.EnableAllControls(Sender = bfiUser);
  bfiGroups.EnableAllControls(Sender = bfiGroups);

  btnSaveAdmin.Enabled := False;
//  btnApplyAdmin.Enabled := False;
end;

procedure TfraAdmin.OnChangeAddfield(Sender: TObject);
begin
  if FSkipChangeEvents then
    Exit;

  if bfiAddfields.cbbInput.ItemIndex = -1 then
    Exit;

  if bfiAddfields.cbbInput.Items.Objects[bfiAddfields.cbbInput.ItemIndex] = nil then
    Exit;

  if not (bfiAddfields.cbbInput.Items.Objects[bfiAddfields.cbbInput.ItemIndex] is TbfaAddField) then
  begin
    BfShowMessage(_('Falsches Objekt in der Zusatzfeldliste'));
    Exit;
  end;

  FCurrentAddfield := TbfaAddfield(bfiAddfields.cbbInput.Items.Objects[bfiAddfields.cbbInput.ItemIndex]);

  ShowAddfieldProperties(FCurrentAddfield);
end;

procedure TfraAdmin.OnChangeArchive(Sender: TObject);
begin
  if FSkipChangeEvents then
    Exit;

  if bfiArchives.cbbInput.ItemIndex = -1 then
    Exit;

  if bfiArchives.cbbInput.Items.Objects[bfiArchives.cbbInput.ItemIndex] = nil then
    Exit;

  if not (bfiArchives.cbbInput.Items.Objects[bfiArchives.cbbInput.ItemIndex] is TbfaArchive) then
  begin
    BfShowMessage(_('Falsches Objekt in der Archivliste'));
    Exit;
  end;

  if FCurrentArchive.Modified and ((edtDuration.Value <> 0) or (cbxInterval.ItemIndex > 0))then   // wurde das Archiv gendert und eins der beiden Felder gendert
  begin
    if ((edtDuration.Value <> 0) and (cbxInterval.ItemIndex = 0)) or        // wenn nicht beides gesetzt wurde
        ((edtDuration.Value = 0) and (cbxInterval.ItemIndex > 0)) then
    begin
      BfShowMessage(_('Es wurde das Document Lifecycle Intervall nicht vollstndig angegeben. Eingabe wird verworfen.'));
      FCurrentArchive.Duration := 0;
      FCurrentArchive.Interval := '';
      edtDuration.Value := 0;
      cbxInterval.ItemIndex := 0;
    end;
  end;

  FCurrentArchive := TbfaArchive(bfiArchives.cbbInput.Items.Objects[bfiArchives.cbbInput.ItemIndex]);

  ShowArchiveProperties(FCurrentArchive);
end;


procedure TfraAdmin.OnChangeGroup(Sender: TObject);
begin
  if FSkipChangeEvents then
    Exit;

  if bfiGroups.cbbInput.ItemIndex = -1 then
    Exit;

  if bfiGroups.cbbInput.Items.Objects[bfiGroups.cbbInput.ItemIndex] = nil then
    Exit;

  if not (bfiGroups.cbbInput.Items.Objects[bfiGroups.cbbInput.ItemIndex] is TbfaGroup) then
  begin
    BfShowMessage(_('Falsches Objekt in der Gruppenliste'));
    Exit;
  end;

  FCurrentGroup := TbfaGroup(bfiGroups.cbbInput.Items.Objects[bfiGroups.cbbInput.ItemIndex]);

  ShowGroupProperties(FCurrentGroup);

//  bfiGroups.Editable := (FCurrentGroup.ID <> 0) and (bitfarmApp.AdminEditMode);
  bfiGroups.Editable := bitfarmApp.AdminEditMode;
  if bitfarmApp.AdminEditMode then
    bfiGroups.DisableButtons := FCurrentGroup.ID = 0;

  bfsGroupsUser.Editable := bfiGroups.Editable and (FCurrentGroup.ID <> 0);

end;

procedure TfraAdmin.OnChangeRepos(Sender: TObject);
begin
  if FSkipChangeEvents then
    Exit;

  if bfiRepos.cbbInput.ItemIndex = -1 then
    Exit;

  if bfiRepos.cbbInput.Items.Objects[bfiRepos.cbbInput.ItemIndex] = nil then
    Exit;

  if not (bfiRepos.cbbInput.Items.Objects[bfiRepos.cbbInput.ItemIndex] is TbfaArchive) then
  begin
    BfShowMessage(_('Falsches Objekt in der Lagerliste'));
    Exit;
  end;

  FCurrentArchive := TbfaArchive(bfiRepos.cbbInput.Items.Objects[bfiRepos.cbbInput.ItemIndex]);

  ShowReposProperties(FCurrentArchive);
end;

procedure TfraAdmin.OnChangeStatefield(Sender: TObject);
begin
  if FSkipChangeEvents then
    Exit;

  if bfiStatefields.cbbInput.ItemIndex = -1 then
    Exit;

  if bfiStatefields.cbbInput.Items.Objects[bfiStatefields.cbbInput.ItemIndex] = nil then
    Exit;

  if not (bfiStatefields.cbbInput.Items.Objects[bfiStatefields.cbbInput.ItemIndex] is TbfaStateField) then
  begin
    BfShowMessage(_('Falsches Objekt in der Statusfeldliste'));
    Exit;
  end;

  FCurrentStateField := TbfaStateField(bfiStatefields.cbbInput.Items.Objects[bfiStatefields.cbbInput.ItemIndex]);

  ShowStatefieldProperties(FCurrentStateField);
end;

procedure TfraAdmin.OnChangeUser(Sender: TObject);
begin
  try
    if FSkipChangeEvents then
      Exit;

    if bfiUser.cbbInput.ItemIndex = -1 then
      Exit;

    if bfiUser.cbbInput.Items.Objects[bfiUser.cbbInput.ItemIndex] = nil then
      Exit;

    if not (bfiUser.cbbInput.Items.Objects[bfiUser.cbbInput.ItemIndex] is TbfaUser) then
    begin
      BfShowMessage(_('Falsches Objekt in der Benutzerliste'));
      Exit;
    end;

    FCurrentUser := TbfaUser(bfiUser.cbbInput.Items.Objects[bfiUser.cbbInput.ItemIndex]);

    ShowUserProperties(FCurrentUser);
  except
    bitfarmLog.Write(llDebug, ltException, 'TfraAdmin.OnChangeUser', ClassName);
  end;
end;

procedure TfraAdmin.OnDeselectAddfield;
begin
   bfsAddfieldsUser.DisableControls := True;
   bfsAddfieldsUser.ClearSelected;
   bfsAddfieldsUser.DisableControls := False;
   ShowAddFieldRights(0);
   EnableBySelect;
end;

procedure TfraAdmin.OnDeselectAddfieldsUser;
begin
  ShowAddFieldRights(0);
  EnableBySelect;
end;

procedure TfraAdmin.OnDeselectArchiveUser;
begin
  //ShowArchiveRights(0);
  EnableBySelect;
end;

procedure TfraAdmin.OnDeselectStatefield;
begin
   bfsStatefieldsUser.DisableControls := True;
   bfsStatefieldsUser.ClearSelected;
   bfsStatefieldsUser.DisableControls := False;
   ShowStateFieldRights(0);
   EnableBySelect;
end;

procedure TfraAdmin.OnDeselectStatefieldUser;
begin
   ShowStateFieldRights(0);
   EnableBySelect;
end;

procedure TfraAdmin.OnEndEditInput(Sender: TObject);
begin
  //28.06.2024 SD -->bfacrm:ticket__show__38644
  if not (Sender = bfiRepos) then
  begin
    FCurrentArchive := GetArchiveByID(frmMainForm.FAdminTreeview.lastSelected);
    bfiArchives.cbbInput.ItemIndex := bfiArchives.cbbInput.Items.IndexOfObject(FCurrentArchive);
  end;
  //28.06.2024 SD <--bfacrm:ticket__show__38644

  EnableInputGroups(Sender, True);

  bfiRepos.EnableAllControls(true);
  bfiAddfields.EnableAllControls(true);
  bfiStatefields.EnableAllControls(true);
  bfiArchives.EnableAllControls(true);
  bfiUser.EnableAllControls(true);
  bfiGroups.EnableAllControls(true);

  btnSaveAdmin.Enabled := True;
//  btnApplyAdmin.Enabled := FModified;
end;

procedure TfraAdmin.OnRemoveAssignFields(AValue: WideString; AObject: TObject);
var
  i, j, k, idx : Integer;
  arc : TbfaArchive;
  id : Int64;
  aField : TbfaAddField;
  sField : TbfaStateField;
  fieldrights: TList<TbfaFieldRight>;
begin
  if frmMainForm.FAdminTreeview.CountChecked > 0 then
  begin
    for i := 0 to frmMainForm.FAdminTreeview.Items.Count -1 do
    begin
      if not frmMainForm.FAdminTreeview.Checked[frmMainForm.FAdminTreeview.Items.Item[i]] then
        Continue;

      id := PbfaInt64(frmMainForm.FAdminTreeview.Items.Item[i].Data).Value;

      arc := GetArchiveByID(id);
      if arc <> nil then
      begin
        if AObject is TbfaAddField then
        begin
          idx := arc.Addfields.IndexOf(IntToStr(TbfaAddField(AObject).ID));
          if idx > -1 then
          begin
            for j := 0 to TList(arc.Addfields.Objects[idx]).Count -1 do
              if TbfaFieldRight(TList(arc.Addfields.Objects[idx]).Items[j]).FieldID = TbfaAddField(AObject).ID then
//                 TbfaFieldRight(TList(arc.Addfields.Objects[idx]).Items[j]).Free;
              begin
                 TbfaFieldRight(TList(arc.Addfields.Objects[idx]).Items[j]).Modified := True;
                 TbfaFieldRight(TList(arc.Addfields.Objects[idx]).Items[j]).Deleted := True;
              end;
            //08.08.2024 SD -->bfacrm:ticket__show__39579
            //Aktualisierung der Position der Felder gem der Liste
            for j := 0 to bfsAssignAddfields.lvList2.Items.Count -1 do
            begin
              aField := TbfaAddField(bfsAssignAddfields.lvList2.Items[j].Data);
              idx := arc.Addfields.IndexOf(IntToStr(aField.ID));
              if idx > -1 then
              begin
                fieldrights := TList<TbfaFieldRight>(arc.Addfields.Objects[idx]);
                for k := fieldrights.Count -1 downto 0 do
                begin
                  if (TbfaFieldRight(fieldrights[k]).ArcID = arc.ID) and
                     (TbfaFieldRight(fieldrights[k]).FieldID = aField.ID)  then
                  begin
                     TbfaFieldRight(fieldrights[k]).Fieldpos := j;
                     TbfaFieldRight(fieldrights[k]).Modified := True;
                  end;
                end;
              end;
            end;
            //08.08.2024 SD -->bfacrm:ticket__show__39579
//            arc.Addfields.Delete(idx);
            arc.Modified_Addfields := True;
          end;
        end else if AObject is TbfaStateField then
        begin
          idx := arc.Statefields.IndexOf(IntToStr(TbfaStateField(AObject).ID));
          if idx > -1 then
          begin
            for j := 0 to TList(arc.Statefields.Objects[idx]).Count -1 do
              if TbfaFieldRight(TList(arc.Statefields.Objects[idx]).Items[j]).FieldID = TbfaStateField(AObject).ID then
//                  TbfaFieldRight(TList(arc.Statefields.Objects[idx]).Items[j]).Free;
              begin
                  TbfaFieldRight(TList(arc.Statefields.Objects[idx]).Items[j]).Modified := True;
                  TbfaFieldRight(TList(arc.Statefields.Objects[idx]).Items[j]).Deleted := True;
              end;
            //08.08.2024 SD -->bfacrm:ticket__show__39579
            //Aktualisierung der Position der Felder gem der Liste
            for j := 0 to bfsAssignStatefields.lvList2.Items.Count -1 do
            begin
              sField := TbfaStateField(bfsAssignStatefields.lvList2.Items[j].Data);
              idx := arc.Statefields.IndexOf(IntToStr(sField.ID));
              if idx > -1 then
              begin
                fieldrights := TList<TbfaFieldRight>(arc.Statefields.Objects[idx]);
                for k := fieldrights.Count -1 downto 0 do
                begin
                  if (TbfaFieldRight(fieldrights[k]).ArcID = arc.ID) and
                     (TbfaFieldRight(fieldrights[k]).FieldID = sField.ID)  then
                  begin
                     TbfaFieldRight(fieldrights[k]).Fieldpos := j;
                     TbfaFieldRight(fieldrights[k]).Modified := True;
                  end;
                end;
              end;
            end;
            //08.08.2024 SD -->bfacrm:ticket__show__39579
//            arc.Statefields.Delete(idx);
            arc.Modified_Statefields := True;
          end;
        end;
        SetModified;
      end;
    end;
  end;
  EnableBySelect;
end;

procedure TfraAdmin.OnRemoveAssignUser(AValue: WideString; AObject: TObject);
var
  i, idx : Integer;
  id : Int64;
  arc: TbfaArchive;
begin
  if frmMainForm.FAdminTreeview.CountChecked > 0 then
  begin
    for i := 0 to frmMainForm.FAdminTreeview.Items.Count -1 do
    begin
      if not frmMainForm.FAdminTreeview.Checked[frmMainForm.FAdminTreeview.Items.Item[i]] then
        Continue;

      id := PbfaInt64(frmMainForm.FAdminTreeview.Items.Item[i].Data).Value;

      arc := GetArchiveByID(id);
      if arc <> nil then
      begin
        if AObject is TBfaUser then
        begin
          idx := arc.Users.IndexOf(IntToStr(TbfaUser(AObject).ID));
          if idx > -1 then
          begin
//            arc.Users.Delete(idx);
            TbfaArcRight(arc.Users.Objects[idx]).Deleted := True;
            TbfaArcRight(arc.Users.Objects[idx]).Modified := True;
            arc.Modified_User := True;
          end;
        end else if AObject is TbfaGroup then
        begin
          idx := arc.Groups.IndexOf(IntToStr(TbfaGroup(AObject).ID));
          if idx > -1 then
          begin
//            arc.Groups.Delete(idx);
            TbfaArcRight(arc.Groups.Objects[idx]).Deleted := True;
            TbfaArcRight(arc.Groups.Objects[idx]).Modified := True;
            arc.Modified_User := True;
          end;
        end;
        SetModified;
      end;
    end;
  end;
  ShowArchiveRights(0);   // da der entfernte Eintrag nicht selektiert ist, zeigen wir keine rechte
end;

procedure TfraAdmin.OnRemoveAddfieldUser(AValue: WideString; AObject: TObject);
var
  i, j, k, idx: Integer;
  arc : TbfaArchive;
  id : Int64;
  field : TbfaAddField;
  right : TbfaFieldRight;
  fieldrights: TList<TbfaFieldRight>;
begin
  if frmMainForm.FAdminTreeview.CountChecked > 0 then
  begin
    for i := 0 to frmMainForm.FAdminTreeview.Items.Count -1 do
    begin
      if not frmMainForm.FAdminTreeview.Checked[frmMainForm.FAdminTreeview.Items.Item[i]] then
        Continue;

      id := PbfaInt64(frmMainForm.FAdminTreeview.Items.Item[i].Data).Value;

      arc := GetArchiveByID(id);
      if arc <> nil then
      begin
        for j := 0 to bfsAssignAddfields.lvList2.Items.Count -1 do
        begin
          if bfsAssignAddfields.lvList2.Items[j].Selected then
          begin
            field := TbfaAddField(bfsAssignAddfields.lvList2.Items[j].Data);
            idx := arc.Addfields.IndexOf(IntToStr(field.ID));

            if idx > -1 then
            begin
              if AObject is TBfaUser then
              begin
                fieldrights := TList<TbfaFieldRight>(arc.Addfields.Objects[idx]);
                for k := fieldrights.Count -1 downto 0 do
                begin
                  if (TbfaFieldRight(fieldrights[k]).ArcID = arc.ID) and
                     (TbfaFieldRight(fieldrights[k]).FieldID = field.ID) and
                     (TbfaFieldRight(fieldrights[k]).Userid = TbfaUser(AObject).ID) then
                  begin
                     //fieldrights.Remove(TbfaFieldRight(fieldrights[k]));
                     TbfaFieldRight(fieldrights[k]).Deleted := True;   // 0 setzen, zum lschen kennzeichnen
                     TbfaFieldRight(fieldrights[k]).Modified := True;
                  end;
                end;
                arc.Modified_Addfields := True;
              end else if AObject is TbfaGroup then
              begin
                fieldrights := TList<TbfaFieldRight>(arc.Addfields.Objects[idx]);
                for k := fieldrights.Count -1 downto 0 do
                begin
                  if (TbfaFieldRight(fieldrights[k]).ArcID = arc.ID) and
                     (TbfaFieldRight(fieldrights[k]).FieldID = field.ID) and
                     (TbfaFieldRight(fieldrights[k]).Groupid = TbfaGroup(AObject).ID) then
                  begin
//                     fieldrights.Remove(TbfaFieldRight(fieldrights[k]));
                     TbfaFieldRight(fieldrights[k]).Deleted := True;  // 0 setzen, zum lschen kennzeichnen
                     TbfaFieldRight(fieldrights[k]).Modified := True;
                  end;

                end;
                arc.Modified_Addfields := True;
              end;
              SetModified;
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure TfraAdmin.OnRemoveGroupsUser(AValue: WideString; AObject: TObject);
var
  idx : Integer;
begin
  if AObject <> nil then
  begin
    idx := FCurrentGroup.Members.IndexOf(IntToStr(TbfaUser(AObject).ID));
    if idx > -1 then
    begin
      FCurrentGroup.Members.Delete(idx);
      FCurrentGroup.Modified := True;
      SetModified;
    end;
  end;
end;

//procedure TfraAdmin.OnRemoveInferior(AValue: WideString; AObject: TObject);
//var
  //user, inf: TbfaUser;
  //i, id : Integer;
//begin
  //if cbxSuperior.ItemIndex > -1 then
  //begin
    //user := TbfaUser(cbxSuperior.Items.Objects[cbxSuperior.ItemIndex]);
    //id := TbfaUser(AObject).ID;
    //if user.EmployeesList.IndexOf(IntToStr(id)) > -1 then
    //begin
      //user.EmployeesList.Delete(user.EmployeesList.IndexOf(IntToStr(id)));
      //user.Modified := True;
      //SetModified;
    //end;
  //end;
//end;

procedure TfraAdmin.OnRemoveStatefieldUser(AValue: WideString;
  AObject: TObject);
var
  i, j, k, idx: Integer;
  arc : TbfaArchive;
  id : Int64;
  field : TbfaAddField;
  right : TbfaFieldRight;
  fieldrights: TList<TbfaFieldRight>;
begin
  if frmMainForm.FAdminTreeview.CountChecked > 0 then
  begin
    for i := 0 to frmMainForm.FAdminTreeview.Items.Count -1 do
    begin
      if not frmMainForm.FAdminTreeview.Checked[frmMainForm.FAdminTreeview.Items.Item[i]] then
        Continue;

      id := PbfaInt64(frmMainForm.FAdminTreeview.Items.Item[i].Data).Value;

      arc := GetArchiveByID(id);
      if arc <> nil then
      begin
        for j := 0 to bfsAssignStatefields.lvList2.Items.Count -1 do
        begin
          if bfsAssignStatefields.lvList2.Items[j].Selected then
          begin
            field := TbfaAddField(bfsAssignStatefields.lvList2.Items[j].Data);
            idx := arc.Statefields.IndexOf(IntToStr(field.ID));

            if idx > -1 then
            begin
              if AObject is TBfaUser then
              begin
                fieldrights := TList<TbfaFieldRight>(arc.Statefields.Objects[idx]);
                for k := fieldrights.Count -1 downto 0 do
                begin
                  if (TbfaFieldRight(fieldrights[k]).ArcID = arc.ID) and
                     (TbfaFieldRight(fieldrights[k]).FieldID = field.ID) and
                     (TbfaFieldRight(fieldrights[k]).Userid = TbfaUser(AObject).ID) then
                  begin
//                     fieldrights.Remove(TbfaFieldRight(fieldrights[k]));
                      TbfaFieldRight(fieldrights[k]).Deleted := True;
                      TbfaFieldRight(fieldrights[k]).Modified := True;
                  end;
                end;
                arc.Modified_Statefields := True;
              end else if AObject is TbfaGroup then
              begin
                fieldrights := TList<TbfaFieldRight>(arc.Statefields.Objects[idx]);
                for k := fieldrights.Count -1 downto 0 do
                begin
                  if (TbfaFieldRight(fieldrights[k]).ArcID = arc.ID) and
                     (TbfaFieldRight(fieldrights[k]).FieldID = field.ID) and
                     (TbfaFieldRight(fieldrights[k]).Groupid = TbfaGroup(AObject).ID) then
                  begin
//                     fieldrights.Remove(TbfaFieldRight(fieldrights[k]));
                      TbfaFieldRight(fieldrights[k]).Deleted := True;
                      TbfaFieldRight(fieldrights[k]).Modified := True;
                  end;

                end;
                arc.Modified_Statefields := True;
              end;
              SetModified;
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure TfraAdmin.OnSelectAddfield(AValue: WideString; AObject: TObject);
var
  i, idx: Integer;
  fieldid : string;
  fieldright : TbfaFieldRight;
  user : TbfaUser;
  group : TbfaGroup;
begin
  chbxAddfieldRights.CheckAll(cbUnchecked);
  bfsAddfieldsUser.DisableControls := True;

  bfsAddfieldsUser.ClearSelected;

  try
    fieldid := IntToStr(TbfaAddField(AObject).ID);
    FSelectedAddfieldID := TbfaAddField(AObject).ID;
    idx := FCurrentArchive.Addfields.IndexOf(fieldid);

    if idx = -1 then
      Exit;

    FCurrentAddfield := GetAddfieldByID(FSelectedAddfieldID);
    SelectEntryByObject(bfiAddfields, FCurrentAddfield);
    ShowAddfieldProperties(FCurrentAddfield);

    for i := 0 to TList(FCurrentArchive.Addfields.Objects[idx]).Count -1 do
    begin
      fieldright := TList(FCurrentArchive.Addfields.Objects[idx])[i];
      if fieldright.FieldID = FSelectedAddfieldID then
      begin
        if fieldright.Deleted then   // Element die zum Lschen markiert wurden, nicht nochmal anzeigen
          continue;
        if fieldright.Groupid <> -1 then
        begin
          group := GetGroupByID(fieldright.Groupid);
          if group <> nil then
             bfsAddfieldsUser.AddListSelected(group.Name, group);
        end;

        if fieldright.Userid <> -1 then
        begin
          user := GetUserByID(fieldright.Userid);
          if user <> nil then
            bfsAddfieldsUser.AddListSelected(user.Name, user);
        end;
      end;
    end;
  finally
    bfsAddfieldsUser.DisableControls := False;
    EnableBySelect;
  end;
end;

procedure TfraAdmin.OnSelectAddfieldUser(AValue: WideString; AObject: TObject);
var
  right : Integer;
  i, idx: Integer;
  fieldid : string;
  fieldright : TbfaFieldRight;
  user : TbfaUser;
  group : TbfaGroup;

begin
  right := 0;
  idx := FCurrentArchive.Addfields.IndexOf(IntToStr(FSelectedAddfieldID));

  if idx = -1 then
    Exit;

  for i := 0 to TList(FCurrentArchive.Addfields.Objects[idx]).Count -1 do
  begin
    fieldright := TList(FCurrentArchive.Addfields.Objects[idx])[i];
    if fieldright.FieldID = FSelectedAddfieldID then
    begin
      if fieldright.Deleted then
        Continue;

      if TObject(AObject) is TBfaUser then
      begin
        if TbfaUser(AObject).ID = fieldright.Userid then
        begin
          right := fieldright.Rights;
          Break;
        end;

        FCurrentUser := GetUserByID(TbfaUser(AObject).ID);
        SelectEntryByObject(bfiUser, FCurrentUser);
        ShowUserProperties(FCurrentUser);
      end else if TObject(AObject) is TBfaGroup then
      begin
        if TbfaGroup(AObject).ID = fieldright.Groupid then
        begin
          right := fieldright.Rights;
          Break;
        end;

        FCurrentGroup := GetGroupByID(TBfaGroup(AObject).ID);
        SelectEntryByObject(bfiGroups, FCurrentGroup);
        ShowGroupProperties(FCurrentGroup);
      end;
    end;
  end;
  EnableBySelect;
  ShowAddFieldRights(right);
end;

//procedure TfraAdmin.OnSelectADGroups(AValue: WideString; AObject: TObject);
//begin
  //GetUserFromSelectedGroups(AValue, AObject);
//end;

//procedure TfraAdmin.OnSelectAllADGroups(AValue: WideString; AObject: TObject);
//var
//  p: Integer;
//  lsClass, sListItem: string;
//begin
//  bitfarmLog.DebugBegin(llDebug, 'OnSelectAllADGroups', ClassName);
//  try
//    try
//      if bfsADGroups.lvList1.Itemindex < 0 then
//      begin
//        bfsADGroups.btn1.Enabled := False;
//        Exit;
//      end;
//
//      lsClass := GetLDAPClass(AValue);
//      if lsClass = '' then Exit;
//
//      bfsADGroups.btn1.Enabled := ((lsClass='group') or (lsClass='container') or (lsClass='organizationalUnit')) and bitfarmApp.AdminEditMode;
//
//      if ((lsClass='group') or (lsClass='container') or (lsClass='organizationalUnit')) then
//        GetUserFromSelectedGroups(AValue, AObject);
//
//    except
//      bitfarmLog.Write(llNormal, ltException, 'OnSelectAllADGroups', ClassName);
//    end;
//  finally
//     bitfarmLog.DebugEnd(llDebug, 'OnSelectAllADGroups', ClassName);
//  end;
//end;

procedure TfraAdmin.OnSelectArchiveUser(AValue: WideString; AObject: TObject);
var
  right : Int64;
begin
  right := 0;
  if TObject(AObject) is TBfaUser then
  begin
    if FCurrentArchive.Users.IndexOf(IntToStr(TbfaUser(AObject).ID)) > -1 then
      right := TbfaArcRight(FCurrentArchive.Users.Objects[FCurrentArchive.Users.IndexOf(IntToStr(TbfaUser(AObject).ID))]).Rights;

    FCurrentUser := GetUserByID(TbfaUser(AObject).ID);
    SelectEntryByObject(bfiUser, FCurrentUser);
    ShowUserProperties(FCurrentUser);

  end else if TObject(AObject) is TBfaGroup then
  begin
    if FCurrentArchive.Groups.IndexOf(IntToStr(TBfaGroup(AObject).ID)) > -1 then
      right := TbfaArcRight(FCurrentArchive.Groups.Objects[FCurrentArchive.Groups.IndexOf(IntToStr(TBfaGroup(AObject).ID))]).Rights;

    FCurrentGroup := GetGroupByID(TBfaGroup(AObject).ID);
    SelectEntryByObject(bfiGroups, FCurrentGroup);
    ShowGroupProperties(FCurrentGroup);

  end;
  EnableBySelect;
  ShowArchiveRights(right);
end;

procedure TfraAdmin.OnSelectedEmptyAddfieldUser;
begin
  EnableBySelect;
  ShowAddFieldRights(0);
end;

procedure TfraAdmin.OnSelectedEmptyArchiveUser;
begin
  EnableBySelect;
  ShowArchiveRights(0);
end;

procedure TfraAdmin.OnSelectedEmptyStatefieldUser;
begin
  EnableBySelect;
  ShowStateFieldRights(0);
end;

procedure TfraAdmin.OnSelectedSortedAddfields(AObject: TObject;
  AList: TListItems);
var
  i, j, k, idx: Integer;
  arc : TbfaArchive;
  id : Int64;
  field : TbfaAddField;
  right : TbfaFieldRight;
  fieldrights: TList<TbfaFieldRight>;
begin
  if frmMainForm.FAdminTreeview.CountChecked > 0 then
  begin
    for i := 0 to frmMainForm.FAdminTreeview.Items.Count -1 do
    begin
      if not frmMainForm.FAdminTreeview.Checked[frmMainForm.FAdminTreeview.Items.Item[i]] then
        Continue;

      id := PbfaInt64(frmMainForm.FAdminTreeview.Items.Item[i].Data).Value;

      arc := GetArchiveByID(id);
      if arc <> nil then
      begin
        for j := 0 to AList.Count -1 do
        begin
          field := TbfaAddField(AList[j].Data);
          idx := arc.Addfields.IndexOf(IntToStr(field.ID));

          if idx > -1 then
          begin
            fieldrights := TList<TbfaFieldRight>(arc.Addfields.Objects[idx]);
            for k := fieldrights.Count -1 downto 0 do
            begin
              if (TbfaFieldRight(fieldrights[k]).ArcID = arc.ID) and
                 (TbfaFieldRight(fieldrights[k]).FieldID = field.ID)  then
              begin
                 TbfaFieldRight(fieldrights[k]).Fieldpos := j;
                 TbfaFieldRight(fieldrights[k]).Modified := True;
              end;
            end;
            arc.Modified_Addfields := True;

            SetModified;
          end;
        end;
      end;
    end;
  end;
end;

procedure TfraAdmin.OnSelectedSortedStatefields(AObject: TObject;
  AList: TListItems);
var
  i, j, k, idx: Integer;
  arc : TbfaArchive;
  id : Int64;
  field : TbfaStatefield;
  right : TbfaFieldRight;
  fieldrights: TList<TbfaFieldRight>;
begin
  if frmMainForm.FAdminTreeview.CountChecked > 0 then
  begin
    for i := 0 to frmMainForm.FAdminTreeview.Items.Count -1 do
    begin
      if not frmMainForm.FAdminTreeview.Checked[frmMainForm.FAdminTreeview.Items.Item[i]] then
        Continue;

      id := PbfaInt64(frmMainForm.FAdminTreeview.Items.Item[i].Data).Value;

      arc := GetArchiveByID(id);
      if arc <> nil then
      begin
        for j := 0 to AList.Count -1 do
        begin
          field := TbfaStatefield(AList[j].Data);
          idx := arc.Statefields.IndexOf(IntToStr(field.ID));

          if idx > -1 then
          begin
            fieldrights := TList<TbfaFieldRight>(arc.Statefields.Objects[idx]);
            for k := fieldrights.Count -1 downto 0 do
            begin
              if (TbfaFieldRight(fieldrights[k]).ArcID = arc.ID) and
                 (TbfaFieldRight(fieldrights[k]).FieldID = field.ID)  then
              begin
                 TbfaFieldRight(fieldrights[k]).Fieldpos := j;
                 TbfaFieldRight(fieldrights[k]).Modified := True;
              end;
            end;
            arc.Modified_Statefields := True;

            SetModified;
          end;
        end;
      end;
    end;
  end;
end;

procedure TfraAdmin.OnSelectStatefield(AValue: WideString; AObject: TObject);
var
  i, idx: Integer;
  fieldid : string;
  fieldright : TbfaFieldRight;
  user : TbfaUser;
  group : TbfaGroup;
begin
  chbxStatefieldRights.CheckAll(cbUnchecked);
  bfsStatefieldsUser.DisableControls := True;

  bfsStatefieldsUser.ClearSelected;

  try
    fieldid := IntToStr(TbfaStateField(AObject).ID);
    FSelectedStatefieldID := TbfaStateField(AObject).ID;
    idx := FCurrentArchive.Statefields.IndexOf(fieldid);

    if idx = -1 then
      Exit;

    FCurrentStateField := GetStatefieldByID(FSelectedStatefieldID);
    SelectEntryByObject(bfiStatefields, FCurrentStateField);
    ShowStatefieldProperties(FCurrentStateField);

    for i := 0 to TList(FCurrentArchive.Statefields.Objects[idx]).Count -1 do
    begin
      fieldright := TList(FCurrentArchive.Statefields.Objects[idx])[i];
      if fieldright.FieldID = FSelectedStatefieldID then
      begin
        if fieldright.Deleted then   // Elemente die zum Lschen markiert wurden, nicht nochmal anzeigen
          continue;
        if fieldright.Groupid <> -1 then
        begin
          group := GetGroupByID(fieldright.Groupid);
          if group <> nil then
            bfsStatefieldsUser.AddListSelected(group.Name, group);
        end;

        if fieldright.Userid <> -1 then
        begin
          user := GetUserByID(fieldright.Userid);
          if user <> nil then
            bfsStatefieldsUser.AddListSelected(user.Name, user);
        end;
      end;
    end;
  finally
    bfsStatefieldsUser.DisableControls := False;
    EnableBySelect;
  end;
end;

procedure TfraAdmin.OnSelectStatefieldUser(AValue: WideString; AObject: TObject);
var
  right : Integer;
  i, idx: Integer;
  fieldid : string;
  fieldright : TbfaFieldRight;
  user : TbfaUser;
  group : TbfaGroup;

begin
  right := 0;
  idx := FCurrentArchive.Statefields.IndexOf(IntToStr(FSelectedStatefieldID));

  if idx = -1 then
    Exit;

  for i := 0 to TList(FCurrentArchive.Statefields.Objects[idx]).Count -1 do
  begin
    fieldright := TList(FCurrentArchive.Statefields.Objects[idx])[i];
    if fieldright.FieldID = FSelectedStatefieldID then
    begin
      if fieldright.Deleted then
        Continue;

      if TObject(AObject) is TBfaUser then
      begin
        if TbfaUser(AObject).ID = fieldright.Userid then
        begin
          right := fieldright.Rights;
          Break;
        end;

        FCurrentUser := GetUserByID(TbfaUser(AObject).ID);
        SelectEntryByObject(bfiUser, FCurrentUser);
        ShowUserProperties(FCurrentUser);
      end else if TObject(AObject) is TBfaGroup then
      begin
        if TbfaGroup(AObject).ID = fieldright.Groupid then
        begin
          right := fieldright.Rights;
          Break;
        end;

        FCurrentGroup := GetGroupByID(TBfaGroup(AObject).ID);
        SelectEntryByObject(bfiGroups, FCurrentGroup);
        ShowGroupProperties(FCurrentGroup);
      end;
    end;
  end;
  EnableBySelect;
  ShowStateFieldRights(right);
end;

procedure TfraAdmin.PaintWindow(DC: HDC);
var
  C: TCanvas;
  R: TRect;
  cl : TColor;
begin
  inherited;
  if bitfarmApp.AdminEditMode then
    cl := gclLime
  else
    cl := frmMainForm.grdResultlistDevExView.clFree;

  Self.BorderWidth := 3;
  Self.Color := cl;
  GetWindowRect(Handle, R);
  C := TCanvas.Create;
  C.Handle := GetWindowDC(Handle);
  C.Pen.Color := cl;
  C.Pen.Width := 3;
  C.Brush.Style := bsClear;
  C.Rectangle(1, 1, R.Right - R.Left, R.Bottom - R.Top);
  C.Free;
end;

procedure TfraAdmin.rbAdminLogClick(Sender: TObject);
begin
  edtLogGdocid.Enabled := False;
end;

//procedure TfraAdmin.rbBitfarmuserClick(Sender: TObject);
//begin
//  rbBitfarmuser.Checked := True;
//  rbWindowsuser.Checked := False;
//  edtWinUser.Enabled := False;
//  edtWinPass.Enabled := False;
//end;

procedure TfraAdmin.rbDocHistoryClick(Sender: TObject);
begin
   edtLogGdocid.Enabled := True;
end;

procedure TfraAdmin.rbIDClick(Sender: TObject);
begin
  EnableResubSearchFields;
end;

procedure TfraAdmin.rbUserClick(Sender: TObject);
begin
  EnableResubSearchFields;
end;

//procedure TfraAdmin.rbWindowsuserClick(Sender: TObject);
//begin
//  rbBitfarmuser.Checked := False;
//  rbWindowsuser.Checked := True;
//  edtWinUser.Enabled := True;
//  edtWinPass.Enabled := True;
//end;

procedure TfraAdmin.ReconnectDomain(sLdap: string);
var
   sCurLDAP: string;
begin
//  bitfarmLog.DebugBegin(llDebug, 'ReconnectDomain:' + sLdap, ClassName);
//  try
//   	try
//      // wenn der LDAP Abfragestring eine andere Domain enthlt als die aktuell
//      // geladene, dann mache eine erneute Anmeldung
//
//      sCurLDAP := ADsHelper.LdapString('', '');
//
//      if Pos(sCurLDAP, sLDAP) = 0 then  //ummelden
//      begin
//
//        if Assigned(ADsHelper) then
//        begin
//          bitfarmLog.Write(llNormal, ltException, 'ReconnectDomain -  Assigned(ADsHelper)');
//          FreeAndNil(ADsHelper);
//        end;
//
//        (*  listen nicht freisetzen, sonst funktioniert das sammeln nicht mehr
//        slAdUser.Clear;
//        slAdMail.Clear;
//        slBfUser.Clear;
//        slBfMail.Clear;
//        slBfAd.Clear;
//        *)
//
//        sLDAP:=  copy(sLDAP, Posex('dc=', sLDAP, 0) +3, length(sLDAP));
//        fdomain:=StringReplace(sLDAP,',dc=','.',[rfReplaceAll]);
//
//        bitfarmLog.Write(llNormal, ltException, 'ReconnectDomain - fdomain=' + fdomain);
//
//        ADsHelper := TADsHelper.Create(fdomain);
//        ADsHelper.bLogRq := true;
//
//         // Abfragen gehen beim Ummelden nur auf Domnenebene
//        ADsHelper.sADRoot := 'LDAP://';
//
//        rbGlobaleCatalog.Checked := False;
//        rbDomainController.Checked := True;
//
//        sAdUser := AduGetUserName(Self);
//        lsmyq := copy(sAdUser, Posex('DC=', sAdUser, 0), length(sAdUser));
//        bitfarmLog.Write(llNormal, ltException, 'ReconnectDomain - sAdUser=' + sAdUser);
//      end;
//
//    except
//      bitfarmLog.Write(llNormal, ltException, 'ReconnectDomain', ClassName);
//    end;
//  finally
//     bitfarmLog.DebugEnd(llDebug, 'ReconnectDomain', ClassName);
//  end;
end;

procedure TfraAdmin.ReloadAdminFrame;
var
  arcid : Int64;
  arc : TbfaArchive;
begin
  try
  //  Screen.Cursor := crHourGlass;
    if FCurrentArchive <> nil then
      arcid := FCurrentArchive.ID
    else
      arcid := 0;

    EnableFunctions(bitfarmApp.AdminEditMode);

    frmMainForm.frmSplash.lblLoading.Caption := sMsgAdminRefresh;
    frmMainForm.frmSplash.Update;
  //  LoadTreeview;

    frmMainForm.frmSplash.lblInfo.Caption := sMsgAdminInitialize;
    frmMainForm.frmSplash.Update;

    ClearObjectsLists;
    ClearComponents;
    frmDLMDialog.Entries.Clear;

    frmMainForm.frmSplash.lblInfo.Caption := sMsgAdminLoadArchives;
    frmMainForm.frmSplash.Update;

    LoadObjectLists;
    AssignObjectLists;

    if arcid <> 0 then
    begin
      arc := GetArchiveByID(arcid);
      if arc <> nil then
        FCurrentArchive := arc;
    end;

    LoadRegistration;
  except
    bitfarmLog.Write(llNormal, ltException, 'ReloadAdminFrame', ClassName);
  end;
end;

procedure TfraAdmin.SaveObjects;
var
  is_modified, user_modified, group_modified,
  arc_modified, add_modified, state_modified, dlm_modified,
  arc_modified_user, arc_modified_addfields, arc_modified_statefields, arc_modified_expired : Boolean;
  i, j, k, idx, cnt_modified_expired, insert_offset: Integer;
  req : TbfaRequest;
  xmlstr, msg : WideString;
  lst, lst2 : TList<TbfaBaseObject>;
  resp : string;
  params, ids : TStringList;
  fieldrights: TList<TbfaFieldRight>;
  m: Integer;
  arcids : TStringList; //29.08.2017 Ticket 11401 Templates mssen nochmal gespeichert werden
  Useraction : PUserAction;
  sock: TSocketConnection;
begin
  is_modified := False;
  user_modified := False;
  group_modified := False;
  arc_modified := False;
  arc_modified_user := False;
  arc_modified_addfields := False;
  arc_modified_statefields := False;
  arc_modified_expired := False;
  add_modified := False;
  state_modified := False;
  dlm_modified := False;
  cnt_modified_expired := 0;

  for i := 0 to bitfarmApp.GArchives.Count -1 do
  begin
    if bitfarmApp.Garchives[i].Modified then
    begin
      arc_modified := True;
      is_modified := True;
      Break;
    end;
  end;

  for i := 0 to bitfarmApp.GArchives.Count -1 do
  begin
    if bitfarmApp.Garchives[i].Modified_User then
    begin
      arc_modified_user := True;
      is_modified := True;
      Break;
    end;
  end;

  for i := 0 to bitfarmApp.GArchives.Count -1 do
  begin
    if bitfarmApp.Garchives[i].Modified_Addfields then
    begin
      arc_modified_addfields := True;
      is_modified := True;
      Break;
    end;
  end;

  for i := 0 to bitfarmApp.GArchives.Count -1 do
  begin
    if bitfarmApp.Garchives[i].Modified_Statefields then
    begin
      arc_modified_statefields := True;
      is_modified := True;
      Break;
    end;
  end;

  for i := 0 to bitfarmApp.GArchives.Count -1 do
  begin
    if bitfarmApp.Garchives[i].Modified_Expired then
    begin
      arc_modified_expired := True;
      is_modified := True;
      Inc(cnt_modified_expired);
    end;
  end;


  for i := 0 to bitfarmApp.GAddfields.Count -1 do
  begin
    if bitfarmApp.GAddfields[i].Modified then
    begin
      add_modified := True;
      is_modified := True;
      Break;
    end;
  end;

  for i := 0 to bitfarmApp.GStatefields.Count -1 do
  begin
    if bitfarmApp.GStatefields[i].Modified then
    begin
      state_modified := True;
      is_modified := True;
      Break;
    end;
  end;

  for i := 0 to bitfarmApp.GUser.Count -1 do
  begin
    if bitfarmApp.GUser[i].Modified then
    begin
      user_modified := True;
      is_modified := True;
      Break;
    end;
  end;

  for i := 0 to bitfarmApp.GGroups.Count -1 do
  begin
    if bitfarmApp.GGroups[i].Modified then
    begin
      group_modified := True;
      is_modified := True;
      Break;
    end;
  end;

  for i := 0 to frmDLMDialog.Entries.Count -1 do
  begin
    if frmDLMDialog.Entries[i].Modified then
    begin
      dlm_modified := True;
      is_modified := True;
      Break;
    end;
  end;

  {$IFDEF ENTERPRISE}
  if (TfraAdminEnterprise(Self).slAddHoliday.Count > 0) or (TfraAdminEnterprise(Self).slModifyHoliday.Count > 0) or (TfraAdminEnterprise(Self).slDeleteHoliday.Count > 0) then
    is_modified := True;
  {$ENDIF}

  if not is_modified and not FUserClickedApplyJustToSave then
  begin
    BfShowMessage(_('Seit dem letzten Speichern/bernehmen wurden keine nderungen durchgefhrt.'));
    Exit;
  end;

  if arc_modified_expired then
  begin
    if cnt_modified_expired = 1 then
      msg := _('Es wurde die Dokumentenlebensdauer eines Archives gendert.\nDies fhrt zur Neuberechnung aller Dokumente in diesem Archiv.\nSoll die nderung durchgefhrt werden?')
    else
      msg := Format(_('Es wurde die Dokumentenlebensdauer in %d Archive gendert.\nDies fhrt zur Neuberechnung aller Dokumente in diesen Archiven.\nSoll die nderung durchgefhrt werden?'), [cnt_modified_expired]);

    if BfMessageDlg(msg, mtConfirmation,mbOKCancel) <> mrOk then
    begin
      BfShowMessage(_('Speichern wurde abgebrochen.'));
      Exit;
    end;
  end;

  // Sammeln aller Oobjekte, erst User, Groups, dann Archive, Addfields, Statefields

  lst := TList<TbfaBaseObject>.Create;
  lst2 := TList<TbfaBaseObject>.Create;
  insert_offset := 0;  // wir insertieren neue objekt immer zu beginn eines Blocks, User, Groups, Archives

  arcids := TStringList.Create;
  arcids.Duplicates := dupIgnore;
  arcids.Sorted := True;
  arcids.Delimiter := ';';
  arcids.StrictDelimiter := True;

  if user_modified then
  begin
    for i := 0 to bitfarmApp.GUser.Count -1 do
    begin
      if bitfarmApp.GUser[i].Modified then
      begin
        if (bitfarmApp.GUser[i].ID < 0) then
        begin
          if (bitfarmApp.GUser[i].Flags and 2 = 0) then
            lst.Insert(insert_offset, bitfarmApp.GUser[i])
        end
        else
          lst.Add(bitfarmApp.GUser[i]);
      end;
    end;
  end;

  insert_offset := lst.Count;

  if group_modified then
  begin
    for i := 0 to bitfarmApp.GGroups.Count -1 do
    begin
      if bitfarmApp.GGroups[i].Modified then
      begin
        if (bitfarmApp.GGroups[i].ID < 0) then
        begin
          if (bitfarmApp.GGroups[i].Flags and 2 = 0) then
            lst.Insert(insert_offset, bitfarmApp.GGroups[i])
        end
        else
          lst.Add(bitfarmApp.GGroups[i]);
      end;
    end;
  end;

  insert_offset := lst.Count;

  if arc_modified or arc_modified_user or arc_modified_addfields or arc_modified_statefields then
  begin
    for i := 0 to bitfarmApp.GArchives.Count -1 do
    begin
      if bitfarmApp.GArchives[i].Modified or
          bitfarmApp.GArchives[i].Modified_User or
          bitfarmApp.GArchives[i].Modified_Addfields or
          bitfarmApp.GArchives[i].Modified_Statefields then
      begin
        if (bitfarmApp.GArchives[i].ID < 0) then
        begin
          if (bitfarmApp.GArchives[i].Flags and 2 = 0) then
            lst.Insert(insert_offset, bitfarmApp.GArchives[i])
        end
        else
          lst.Add(bitfarmApp.GArchives[i]);
      end;
      if (bitfarmApp.GArchives[i].Modified or bitfarmApp.GArchives[i].Modified_Addfields) and
          (bitfarmApp.GArchives[i].Flags and 2 = 0) and
          (bitfarmApp.GArchives[i].Typ = 1) then  // nur Archive, keine Templates fr Lager
        arcids.Add(IntToStr(bitfarmApp.GArchives[i].ID)); //29.08.2017 Ticket 11401
    end;
  end;

  insert_offset := lst.Count;

  if add_modified then
  begin
    for i := 0 to bitfarmApp.GAddfields.Count -1 do
    begin
      if bitfarmApp.GAddfields[i].Modified then
      begin
        if (bitfarmApp.GAddfields[i].ID < 0) then
        begin
          if (bitfarmApp.GAddfields[i].Flags and 2 = 0) then
            lst.Insert(insert_offset, bitfarmApp.GAddfields[i])
        end
        else
          lst.Add(bitfarmApp.GAddfields[i]);
        for j := 0 to bitfarmApp.GArchives.Count -1 do
        begin
          idx := bitfarmApp.GArchives[j].Addfields.IndexOf(IntToStr(bitfarmApp.GAddfields[i].ID));

          if idx > -1 then
          begin
            fieldrights := TList<TbfaFieldRight>(bitfarmApp.GArchives[j].Addfields.Objects[idx]);
            for k := fieldrights.Count -1 downto 0 do
            begin
              if arcids.IndexOf(IntToStr(fieldrights[k].Arcid)) = -1 then
                arcids.Add(IntToStr(fieldrights[k].Arcid));
            end;
          end;
        end;
      end;
    end;
  end;

  insert_offset := lst.Count;

  if state_modified then
  begin
    for i := 0 to bitfarmApp.GStatefields.Count -1 do
    begin
      if bitfarmApp.GStatefields[i].Modified then
      begin  // wenn eins der Properties 0 ist dann auch das andere 0 setzen
        if (bitfarmApp.GStatefields[i].AddfieldID = 0) and (bitfarmApp.GStatefields[i].Func <> 6) then   // Ausnahme DLM Statefields
          bitfarmApp.GStatefields[i].Func := 0
        else if bitfarmApp.GStatefields[i].Func = 0 then
          bitfarmApp.GStatefields[i].AddfieldID := 0;

        if (bitfarmApp.GStatefields[i].ID < 0) then
        begin
          if (bitfarmApp.GStatefields[i].Flags and 2 = 0) then
            lst.Insert(insert_offset, bitfarmApp.GStatefields[i])
        end
        else
          lst.Add(bitfarmApp.GStatefields[i]);
      end;
    end;
  end;

  if dlm_modified then
  begin
    for i := 0 to frmDLMDialog.Entries.Count -1 do
    begin
      if frmDLMDialog.Entries[i].Modified then
        lst.Add(frmDLMDialog.Entries[i]);
    end;
  end;

  if lst.Count > 0 then
  begin
    sock := TSocketConnection.Create(bitfarmApp.bfaServerNoSSL, bitfarmApp.bfaServer, bitfarmApp.bfaServerPort, '');
    sock.CreateComponents;
    sock.ServerReadTimeout := 120000; // 2min Timeout

    if sock.Connect then
    begin
      req := TbfaRequest.Create;
      try
        req.ReqType := 'reqSaveAdmin';
        req.UserID := bitfarmApp.User.ID;
        req.Profile := bitfarmApp.Profile;
        req.Gdocid := 0;
        req.Parameter := '';
        req.Data := lst;
        req.Lang :=  bitfarmApp.Lang;
        lst2.Add(req);
        if BD.DevDebug then
          xmlstr := ObjectToXML(lst2, False, 'US-ASCII', '.\reqSaveAdmin.xml');

        sock.SendRequestToServer(req);

        req :=  sock.ReceiveResponse;
        sock.Disconnect;
        if req = nil then
          Exit;

  //27.11.2018 Ticket 16957 -->
        if req.ReqType = 'respAuthError' then
        begin
          BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'));
          UserAction := bitfarmApp.CreateUserAction;
          UserAction^.ActionName := 'actRelogin';
          bitfarmApp.MainThread.Add(UserAction);
          Exit;
        end else
  //27.11.2018 Ticket 16957 <--
        if (req.ReqType = 'respError') or (req.ReqType = 'respSaveAdminError') then
        begin
          BfShowMessage(_('Fehler beim Speichern im Administrator!')+ #13#10+ req.DataString);
        end
        else
          // alle modified zurcksetzen
          UnModify;

        // fr neue Objekte die IDs anhand der GUIDs zurckschreiben
        if req.Parameter <> '' then
        begin
          params := TStringList.Create;
          params.Delimiter := ';';
          params.DelimitedText := req.Parameter;

          ids := TStringList.Create;
          ids.Delimiter := ',';

          for i := 0 to params.Count -1 do
          begin
            ids.Clear;
            ids.DelimitedText := params[i];
            if arc_modified then
            begin
              for j := 0 to bitfarmApp.GArchives.Count -1 do
              begin
                if (bitfarmApp.GArchives[j].ID < 0) and
                   (GUIDToString(bitfarmApp.GArchives[j].TempID) = ids[0]) then
                begin
                  if arcids.IndexOf(IntToStr(bitfarmApp.GArchives[j].ID)) > -1 then
                  begin
                    arcids.Delete(arcids.IndexOf(IntToStr(bitfarmApp.GArchives[j].ID)));
                    arcids.Add(ids[1]);
                  end;

                  bitfarmApp.GArchives[j].ID := StrToInt64(ids[1]);
                  if FCurrentArchive.TempID = bitfarmApp.GArchives[j].TempID then
                    FCurrentArchive := bitfarmApp.GArchives[j];
                  bitfarmApp.GArchives[j].TempID.Empty;

                  // Eintrag im Tree finden
                  for k := 0 to frmMainForm.FAdminTreeview.Items.Count -1 do
                  begin
                    if (frmMainForm.FAdminTreeview.Items[k].Text = bitfarmApp.GArchives[j].Name) and
                        (PbfaInt64(frmMainForm.FAdminTreeview.Items[k].Data).Value < 0) then
                    begin
                      PbfaInt64(frmMainForm.FAdminTreeview.Items[k].Data).Value :=
                        bitfarmApp.GArchives[j].ID;
                    end;
                  end;

                  for k := 0 to bitfarmApp.GArchives[j].Users.Count -1 do
                  begin
                    if TbfaArcRight(bitfarmApp.GArchives[j].Users[k]).ArcID < 0 then
                      TbfaArcRight(bitfarmApp.GArchives[j].Users[k]).ArcID :=
                        bitfarmApp.GArchives[j].ID;
                  end;

                  for k := 0 to bitfarmApp.GArchives[j].Addfields.Count -1 do
                  begin
                    fieldrights := TList<TbfaFieldRight>(bitfarmApp.GArchives[j].Addfields.Objects[k]);
                    for m := 0 to fieldrights.Count -1 do
                    begin
                      if TbfaFieldRight(fieldrights[m]).ArcID < 0 then
                        TbfaFieldRight(fieldrights[m]).ArcID := bitfarmApp.GArchives[j].ID;
                    end;
                  end;
                  for k := 0 to bitfarmApp.GArchives[j].Statefields.Count -1 do
                  begin
                    fieldrights := TList<TbfaFieldRight>(bitfarmApp.GArchives[j].Statefields.Objects[k]);
                    for m := 0 to fieldrights.Count -1 do
                    begin
                      if TbfaFieldRight(fieldrights[m]).ArcID < 0 then
                        TbfaFieldRight(fieldrights[m]).ArcID := bitfarmApp.GArchives[j].ID;
                    end;
                  end;
                  Break;
                end;
              end;
            end;
            if add_modified then
            begin
              for j := 0 to bitfarmApp.GAddfields.Count -1 do
              begin
                if (bitfarmApp.GAddfields[j].ID = -1) and (GUIDToString(bitfarmApp.GAddfields[j].TempID) = ids[0]) then
                begin
                  bitfarmApp.GAddfields[j].ID := StrToInt64(ids[1]);
                  bitfarmApp.GAddfields[j].IndexTableID := StrToInt(ids[2]);
                  if FCurrentAddfield.TempID = bitfarmApp.GAddfields[j].TempID then
                    FCurrentAddfield := bitfarmApp.GAddfields[j];
                  bitfarmApp.GAddfields[j].TempID.Empty;
                  Break;
                end;
              end;
            end;
            if state_modified then
            begin
              for j := 0 to bitfarmApp.GStatefields.Count -1 do
              begin
                if (bitfarmApp.GStatefields[j].ID = -1) and (GUIDToString(bitfarmApp.GStatefields[j].TempID) = ids[0]) then
                begin
                  bitfarmApp.GStatefields[j].ID := StrToInt64(ids[1]);
                  bitfarmApp.GStatefields[j].IndexColumnID:= StrToInt(ids[2]);
                  if FCurrentStatefield.TempID = bitfarmApp.GStatefields[j].TempID then
                    FCurrentStatefield := bitfarmApp.GStatefields[j];
                  bitfarmApp.GStatefields[j].TempID.Empty;
                  Break;
                end;
              end;
            end;
            if user_modified then
            begin
              for j := 0 to bitfarmApp.GUser.Count -1 do
              begin
                if (bitfarmApp.GUser[j].ID = -1) and (GUIDToString(bitfarmApp.GUser[j].TempID) = ids[0]) then
                begin
                  bitfarmApp.GUser[j].ID := StrToInt64(ids[1]);
                  if FCurrentUser.TempID = bitfarmApp.GUser[j].TempID then
                    FCurrentUser := bitfarmApp.GUser[j];
                  bitfarmApp.GUser[j].TempID.Empty;
                  Break;
                end;
              end;
            end;
            if group_modified then
            begin
              for j := 0 to bitfarmApp.GGroups.Count -1 do
              begin
                if (bitfarmApp.GGroups[j].ID = -1) and (GUIDToString(bitfarmApp.GGroups[j].TempID) = ids[0]) then
                begin
                  bitfarmApp.GGroups[j].ID := StrToInt64(ids[1]);
                  if FCurrentGroup.TempID = bitfarmApp.GGroups[j].TempID then
                    FCurrentGroup := bitfarmApp.GGroups[j];
                  bitfarmApp.GGroups[j].TempID.Empty;
                  Break;
                end;
              end;
            end;
          end;
        end;

        WriteTemplate(arcids, False);
      finally
        if Assigned(sock) then
          FreeAndNil(sock);
        FreeAndNil(req);
        FreeAndNil(arcids);
      end;
    end;
  end;

  {$IFDEF ENTERPRISE}
  if TfraAdminEnterprise(Self).slAddHoliday.Count > 0 then
  begin
    for i := 0 to TfraAdminEnterprise(Self).slAddHoliday.Count -1 do
    begin
      req := TbfaRequest.Create;
      try
        req.ReqType := 'reqSaveHoliday';
        req.UserID := bitfarmApp.User.ID;
        req.Profile := bitfarmApp.Profile;
        req.Parameter := TfraAdminEnterprise(Self).slAddHoliday[i];
        req.Lang := bitfarmApp.Lang;
        bitfarmApp.MainSocket.SendRequestToServer(req);

        req := bitfarmApp.MainSocket.ReceiveResponse;
        if req = nil then
          Exit;

//27.11.2018 Ticket 16957 -->
        if req.ReqType = 'respAuthError' then
        begin
          BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'));
          UserAction := bitfarmApp.CreateUserAction;
          UserAction^.ActionName := 'actRelogin';
          bitfarmApp.MainThread.Add(UserAction);
          Exit;
        end
        else
//27.11.2018 Ticket 16957 <--
        if req.ReqType = 'respError' then
        begin
           BfShowMessage(_('Fehler beim Speichern:') + ' ' + req.DataString);

        end;
      finally
        FreeAndNil(req);
      end;
    end;
    TfraAdminEnterprise(Self).slAddHoliday.Clear;
  end;

  if TfraAdminEnterprise(Self).slModifyHoliday.Count > 0 then
  begin
    for i := 0 to TfraAdminEnterprise(Self).slModifyHoliday.Count -1 do
    begin
      req := TbfaRequest.Create;
      try
        req.ReqType := 'reqModifyHoliday';
        req.UserID := bitfarmApp.User.ID;
        req.Profile := bitfarmApp.Profile;
        req.Parameter := TfraAdminEnterprise(Self).slModifyHoliday[i];
        req.Lang := bitfarmApp.Lang;
        bitfarmApp.MainSocket.SendRequestToServer(req);

        req := bitfarmApp.MainSocket.ReceiveResponse;
        if req = nil then
          Exit;

        if req.ReqType = 'respAuthError' then
        begin
          BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'));
          UserAction := bitfarmApp.CreateUserAction;
          UserAction^.ActionName := 'actRelogin';
          bitfarmApp.MainThread.Add(UserAction);
          Exit;
        end
        else
        if req.ReqType = 'respError' then
        begin
           BfShowMessage(_('Fehler beim Speichern:') + ' ' + req.DataString);
        end;
      finally
        FreeAndNil(req);
      end;
    end;
    TfraAdminEnterprise(Self).slModifyHoliday.Clear;
  end;

  if TfraAdminEnterprise(Self).slDeleteHoliday.Count > 0 then
  begin
    for i := 0 to TfraAdminEnterprise(Self).slDeleteHoliday.Count -1 do
    begin
      req := TbfaRequest.Create;
      try
        req.ReqType := 'reqDeleteHoliday';
        req.UserID := bitfarmApp.User.ID;
        req.Profile := bitfarmApp.Profile;
        req.Parameter := TfraAdminEnterprise(Self).slDeleteHoliday[i];
        req.Lang := bitfarmApp.Lang;
        bitfarmApp.MainSocket.SendRequestToServer(req);

        req := bitfarmApp.MainSocket.ReceiveResponse;
        if req = nil then
          Exit;
//27.11.2018 Ticket 16957 -->
        if req.ReqType = 'respAuthError' then
        begin
          BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'));
          UserAction := bitfarmApp.CreateUserAction;
          UserAction^.ActionName := 'actRelogin';
          bitfarmApp.MainThread.Add(UserAction);
          Exit;
        end
        else
//27.11.2018 Ticket 16957 <--
        if req.ReqType = 'respError' then
        begin
           BfShowMessage(_('Fehler beim Speichern:') + ' ' + req.DataString);
        end;
      finally
        FreeAndNil(req);
      end;
    end;
    TfraAdminEnterprise(Self).slDeleteHoliday.Clear;
  end;
  {$ENDIF}
end;

procedure TfraAdmin.SaveReport(sName: string; sText: TStringList);
var
  sFileName : string;
begin
  bitfarmLog.DebugBegin(llDebug, 'SaveReport', ClassName);
  try
    try
      sFileName:= 'bitfarm-Report_' + sName + '.txt';
      if PromptForFileName(sFilename, 'Text-Dateien (*.TXT)|*.TXT', 'txt',
        _('Report erstellen...'), '', True) then
      begin
        if sFilename <> '' then
        begin
          sText.SaveToFile(sFileName);
          BfShowMessage(_('Report wurde erstellt.'), nil);
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'SaveReport', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SaveReport', ClassName);
  end;
end;

procedure TfraAdmin.SelectArchive(arcid: Integer);
var
  i, j: Integer;
  arc : TbfaArchive;
  user: TbfaUser;
  group: TbfaGroup;
  addfield: TbfaAddField;
  statefield: TbfaStateField;
  node: TTreeNode;
  deleted : Boolean;
  addfieldsorted: TList<TbfaAddField>;
  statefieldsorted : TList<TbfaStatefield>;
  fieldpos : Integer;
begin
  FCurrentArchive := GetArchiveByID(arcid);
  if FCurrentArchive = nil then
    Exit;

   node := frmMainForm.FAdminTreeview.GetTreeNodeByID(arcid);
   if node = nil then
    Exit;

   node.Selected := True;
   bfiRepos.btnDelete.Enabled := not node.IsFirstNode and bitfarmApp.AdminEditMode;

  // die Auswahlcombos aktualisieren
  FSkipChangeEvents := True;
  try
    if FCurrentArchive.Typ = 0 then
      bfiRepos.cbbInput.ItemIndex := bfiRepos.cbbInput.Items.IndexOfObject(FCurrentArchive)
    else begin
      arc := GetArchiveByID(FCurrentArchive.Lgrid);
      if arc <> nil then
        bfiRepos.cbbInput.ItemIndex := bfiRepos.cbbInput.Items.IndexOfObject(arc);

      bfiArchives.cbbInput.ItemIndex := bfiArchives.cbbInput.Items.IndexOfObject(FCurrentArchive);
    end;
  finally
    FSkipChangeEvents := False;
  end;

  if tabctrAdmin.ActiveTabIndex = 0 then
  begin
    if FCurrentArchive.Typ = 0 then
      ShowReposProperties(FCurrentArchive)
    else
      ShowArchiveProperties(FCurrentArchive);
  end else if tabctrAdmin.ActiveTabIndex = 1 then
  begin
    // Gruppen und User

    bfsAssignUser.DisableControls := True;
    bfsAssignAddfields.DisableControls := True;
    bfsAssignStatefields.DisableControls := True;
    bfsAddfieldsUser.DisableControls := True;
    bfsStatefieldsUser.DisableControls := True;

    bfsAssignUser.ClearSelected;
    bfsAssignAddfields.ClearSelected;
    bfsAssignStatefields.ClearSelected;
    bfsAddfieldsUser.ClearSelected;
    bfsStatefieldsUser.ClearSelected;
//14.03.2024
//    chbxArchiveRights.Items.BeginUpdate;//19.02.2024
//    try
      chbxArchiveRights.CheckAll(cbUnchecked);
//    finally
//      chbxArchiveRights.Items.EndUpdate;//19.02.2024
//    end;
//    chbxAddfieldRights.Items.BeginUpdate; //19.02.2024
//    try
      chbxAddfieldRights.CheckAll(cbUnchecked);
//    finally
//      chbxAddfieldRights.Items.EndUpdate; //19.02.2024
//    end;
//    chbxStatefieldRights.Items.BeginUpdate; //19.02.2024
//    try
      chbxStatefieldRights.CheckAll(cbUnchecked);
//    finally
//      chbxStatefieldRights.Items.EndUpdate; //19.02.2024
//    end;

    try
      for i := 0 to FCurrentArchive.Groups.Count -1 do
      begin
        group := GetGroupByID(StrToInt(FCurrentArchive.Groups[i]));
        if group = nil then
          Continue;
        if TbfaArcRight(FCurrentArchive.Groups.Objects[i]).Deleted then   // wenn auf deleted gesetzt, nicht mehr anzeigen
          Exit;
        bfsAssignUser.AddListSelected(group.Name, group);
      end;

      for i := 0 to FCurrentArchive.Users.Count -1 do
      begin
        user := GetUserByID(StrToInt(FCurrentArchive.Users[i]));
        if user = nil then
          Continue;
        if TbfaArcRight(FCurrentArchive.Users.Objects[i]).Deleted then   // wenn auf deleted gesetzt, nicht mehr anzeigen
          Exit;
        bfsAssignUser.AddListSelected(user.Name, user);
      end;

    // Zusatzfelder

      addfieldsorted := TList<TbfaAddField>.Create;
      for i := 0 to FCurrentArchive.Addfields.Count -1 do
      begin
        addfield := GetAddfieldByID(StrToInt(FCurrentArchive.Addfields[i]));
        fieldpos := 0;
        if addfield = nil then
          Continue;
        deleted := False;
        for j := 0 to TList(FCurrentArchive.Addfields.Objects[i]).Count -1 do
          if (TbfaFieldRight(TList(FCurrentArchive.Addfields.Objects[i]).Items[j]).FieldID = addfield.ID) then
          begin
              fieldpos := TbfaFieldRight(TList(FCurrentArchive.Addfields.Objects[i]).Items[j]).Fieldpos;
              if (TbfaFieldRight(TList(FCurrentArchive.Addfields.Objects[i]).Items[j]).Deleted) then
                 deleted := True;
          end;

        if not deleted then
          if fieldpos > addfieldsorted.Count then
            addfieldsorted.Add(addfield)
          else
            addfieldsorted.Insert(fieldpos, addfield);
      end;

      for i := 0 to addfieldsorted.Count -1 do
      begin
        if addfieldsorted[i] <> nil then
          bfsAssignAddfields.AddListSelected(addfieldsorted[i].DisplayName, addfieldsorted[i]);
      end;

    // Statusfelder
      statefieldsorted := TList<TbfaStateField>.Create;

      for i := 0 to FCurrentArchive.Statefields.Count -1 do
      begin
        statefield := GetStatefieldByID(StrToInt(FCurrentArchive.Statefields[i]));
        fieldpos := 0;
        if statefield = nil then
          Continue;
        deleted := False;
        for j := 0 to TList(FCurrentArchive.Statefields.Objects[i]).Count -1 do
          if (TbfaFieldRight(TList(FCurrentArchive.Statefields.Objects[i]).Items[j]).FieldID = statefield.ID) then
          begin
              fieldpos := TbfaFieldRight(TList(FCurrentArchive.Statefields.Objects[i]).Items[j]).Fieldpos;
              if (TbfaFieldRight(TList(FCurrentArchive.Statefields.Objects[i]).Items[j]).Deleted) then
                 deleted := True;
          end;

        if not deleted then
          if fieldpos > statefieldsorted.Count then
            statefieldsorted.Add(statefield)
          else
            statefieldsorted.Insert(fieldpos, statefield);
      end;

      for i := 0 to statefieldsorted.Count -1 do
      begin
        if statefieldsorted[i] <> nil then
          bfsAssignStatefields.AddListSelected(statefieldsorted[i].DisplayName, statefieldsorted[i]);
      end;
    finally
      bfsAssignUser.DisableControls := False;
      bfsAssignAddfields.DisableControls := False;
      bfsAssignStatefields.DisableControls := False;
      bfsAddfieldsUser.DisableControls := False;
      bfsStatefieldsUser.DisableControls := False;
    end;

    bfsAssignUser.Enabled := FCurrentArchive.Typ <> 2;    // im Wiedervorlageneintrag disablen

  end;
end;

procedure TfraAdmin.SelectEntryByObject(list: TbfaInputCombo; AObject: TObject);
var
  i : Integer;
begin
  for i := 0 to list.cbbInput.Items.Count -1 do
  begin
    if list.cbbInput.Items.Objects[i] = AObject then
    begin
      list.cbbInput.ItemIndex := i;
      Break;
    end;
  end;
end;

procedure TfraAdmin.SetModified;
begin
  FModified := bitfarmApp.AdminEditMode and True;
//  btnApplyAdmin.Enabled := FModified;
  FUserClickedApplyJustToSave := False;
end;

procedure TfraAdmin.ShowAddfieldProperties(addfield: TbfaAddField);
begin
  if addfield = Nil then
    Exit;

  FSkipChangeEvents := True;
  try
    cbxSearchMode.ItemIndex := IndexOfTbfaInt(SearchModes, addfield.Mode);
    cbxAddfieldType.ItemIndex := IndexOfTbfaInt(Addfieldtypes, addfield.Typ);
    cbxAddfieldType.Enabled := not (addfield.Typ in [13,14]);
//    edtCheckprogram.Text := addfield.Checkprogram;
//    edtCheckprogram.Enabled := addfield.Typ <> 14;
    edtAddfieldDescription.Text := addfield.Description;
    edtAddfieldDescription.Enabled := addfield.Typ <> 14;
    chkAddfieldmandatory.Checked := (addfield.Options and 1) = 1;
    chkLinkfield.Checked := (addfield.Options and 2) = 2;
    chkSavename.Checked := (addfield.Options and 4) = 4;
    chkStrictmode.Checked := (addfield.Options and 8) = 8;
    chkStrictmode.Enabled := (addfield.Typ in [2,3]) and bitfarmApp.AdminEditMode;
    btnAddListItems.Enabled := (addfield.Typ in [2,3,11,13]) and bitfarmApp.AdminEditMode;
    if addfield.Typ = 13 then
      btnAddListItems.Caption := _('Konfiguration')
    else
      btnAddListItems.Caption := _('Liste');
    lblAddfieldID.Caption := _('Feld-ID:') + '   ' + IntToStr(addfield.ID);
    lblAddname.Caption := _('Bezeichner:') + '   ' + addfield.Name;
    chkAddfieldmandatory.Enabled := not (addfield.Typ in [13,14]);
    chkLinkfield.Enabled := not (addfield.Typ in [13,14]);
    chkSavename.Enabled := not (addfield.Typ in [13,14]);
    bfiAddfields.btnModify.Enabled := (not (addfield.Typ in [14])) and bitfarmApp.AdminEditMode;
    bfiAddfields.btnDelete.Enabled := (not (addfield.Typ in [14])) and bitfarmApp.AdminEditMode ;

    EnableSearchModebyType(addfield.Typ);
  finally
    FSkipChangeEvents := False;
  end;
end;

procedure TfraAdmin.ShowAddFieldRights(right: Integer);
begin
  FSkipChangeEvents := True;
  try
    chbxAddfieldRights.Checked[0] := (right and 1) = 1;
    chbxAddfieldRights.Checked[1] := (right and 2) = 2;
    chbxAddfieldRights.Checked[2] := (right and 4) = 4;
  finally
    FSkipChangeEvents := False;
  end;
end;

procedure TfraAdmin.ShowArchiveProperties(archive: TbfaArchive);
var
  idx : Integer;
begin
  if archive = Nil then
    Exit;

  FSkipChangeEvents := True;
  try
    idx := bfiArchives.cbbInput.Items.IndexOfObject(archive);
    if idx > -1 then
    begin
      if idx <> bfiArchives.cbbInput.ItemIndex then
        bfiArchives.cbbInput.ItemIndex := idx;
    end;

    edtDocname.Text := archive.DefDocname;
    edtStationary.Text := archive.Backpic;
    chkDocnameMandatory.Checked := (archive.Options and 1) = 1;
    chkDocnameArchive.Checked := (archive.Options and 2) = 2;
//    chkPluginactive.Checked := (archive.Options and 4) = 4;
    edtDocname.Enabled := (not chkDocnameArchive.Checked) and bitfarmApp.AdminEditMode;
    lblArcID.Caption := _('Archiv-ID:') + '   '+ IntToStr(archive.ID);
    btnCreateTPLFile.Enabled := archive.ID > 0;
    btnCreateFNDFile.Enabled := archive.ID > 0;
    if archive.Duration = -1 then
      edtDuration.Value := 0
    else
      edtDuration.Value := archive.Duration;
    cbxInterval.ItemIndex := Intervals.IndexOf(archive.Interval);
  finally
    FSkipChangeEvents := False;
  end;
end;

procedure TfraAdmin.ShowArchiveRights(right: Int64);
var
  i : Integer;
  arcright : Int64;
begin
  FSkipChangeEvents := True;
  try
    right := right and not 2121728;   //private Annorechte entfernen wir, sind fr die Anzeige und Prfung nicht relevant

    chbxArchiveRights.Items.BeginUpdate;
    //Achtung, Suchen und Anzeigen sind in der CheckboxListe vertauscht
    chbxArchiveRights.Checked[1] := (right and rightList) = rightList;
    chbxArchiveRights.Checked[0] := (right and rightRead) = rightRead;
    chbxArchiveRights.Checked[2] := (right and rightModify) = rightModify;
    chbxArchiveRights.Checked[3] := (right and rightWrite) = rightWrite;
    chbxArchiveRights.Checked[4] := (right and rightEmail) = rightEmail;
    chbxArchiveRights.Checked[5] := (right and rightMove) = rightMove;
    chbxArchiveRights.Checked[6] := (right and rightDelete) = rightDelete;
//    chbxArchiveRights.Checked[6] := (right and rightExport) = rightExport;
    chbxArchiveRights.Checked[7] := (right and rightPrint) = rightPrint;
    chbxArchiveRights.Checked[8] := (right and rightLink) = rightLink;
    chbxArchiveRights.Checked[9] := (right and rightImport) = rightImport;
    chbxArchiveRights.Checked[10] := (right and rightHistory) = rightHistory;
    chbxArchiveRights.Checked[11] := (right and rightWFBreak) = rightWFBreak;
    chbxArchiveRights.Checked[12] := (right and rightAdmin) = rightAdmin;
    chbxArchiveRights.Checked[13] := (right and rightListProtokoll) = rightListProtokoll;
    chbxArchiveRights.Checked[14] := (right and rightRevSave) = rightRevSave;
    chbxArchiveRights.Checked[15] := (right and rightARead) = rightARead;
    chbxArchiveRights.Checked[16] := (right and rightAWrite) = rightAWrite;
    chbxArchiveRights.Checked[17] := (right and rightAModify) = rightAModify;
    chbxArchiveRights.Items.EndUpdate;

    cbxArcRights.ItemIndex := -1;
    if right > 0 then
    begin
      for i := 0 to cbxArcRights.Items.Count -1 do
      begin
        arcright := 0;
        if Assigned(cbxArcRights.Items.Objects[i]) then
          arcright := TbfaInt64(cbxArcRights.Items.Objects[i]).Value;
        arcright := arcright and not 2121728;
        if (arcright > 0) and (arcright = right) then
          cbxArcRights.ItemIndex := i;
      end;
      if cbxArcRights.ItemIndex = -1 then
        cbxArcRights.Text := _('Benutzerdefiniert');
    end;
  finally
    FSkipChangeEvents := False;
  end;
end;


procedure TfraAdmin.ShowGroupProperties(group: TbfaGroup);
var
  i, j : Integer;
begin
  FSkipChangeEvents := True;
  try
     cbxGroupRole.ItemIndex := IndexOfTbfaInt(RoleList, group.Role);
     edtGroupEmail.Text := group.Email;
     bfsGroupsUser.DisableControls := True;
     bfsGroupsUser.clearSelected;
     lblGroupID.Caption := _('Gruppen-ID:') + '   ' + IntToStr(group.ID);
     try
       if group.Members <> nil then
       begin
         for i := 0 to group.Members.Count -1 do
         begin
           for j := 0 to bitfarmApp.GUser.Count -1 do
           begin
             if StrToInt(group.Members[i]) = bitfarmApp.GUser[j].ID then
             begin
               bfsGroupsUser.AddListSelected(bitfarmApp.GUser[j].Name, bitfarmApp.GUser[j]);
               Break;
             end;
           end;
         end;
       end;
     finally
       bfsGroupsUser.DisableControls := False;
     end;
  finally
    FSkipChangeEvents := False;
  end;
end;

procedure TfraAdmin.ShowHistoryRecords;
begin
  if lvAdminLog.Items.Count = 0 then
  begin
    lblRange.Caption := '';
    lblRecords.Caption := '';
  end
  else if lvAdminLog.Items.Count < 100 then
    lblRange.Caption :=  IntToStr((FAdminLogOffset * 100) + 1) + ' - ' + IntToStr((FAdminLogOffset * 100) + lvAdminLog.Items.Count)
  else
    lblRange.Caption :=  IntToStr((FAdminLogOffset * 100) + 1) + ' - ' + IntToStr((FAdminLogOffset + 1) * 100);

end;

procedure TfraAdmin.ShowReposProperties(archive: TbfaArchive);
begin
  if archive = Nil then
    Exit;
  FSkipChangeEvents := True;
  try
    lblReposID.Caption := _('Lager-ID:') + '   '+ IntToStr(archive.ID);
  finally
    FSkipChangeEvents := False;
  end;
end;

procedure TfraAdmin.ShowResubIds;
begin
   if mqResubSearch.RecordCount > 0 then
   begin
      edtArcid.Text := mqResubSearch.fieldbyname('arcid').asstring;
      edtGdocid.Text := mqResubSearch.fieldbyname('Gdocid').asstring;
      edtTimref.Text := mqResubSearch.fieldbyname('RefID').asstring;
      btnDeleteResub.Enabled := bfaDBGrid1.SelectedRows.Count > 0;
   end else
      btnDeleteResub.Enabled := False;
end;

procedure TfraAdmin.ShowStatefieldProperties(statefield: TbfaStatefield);
var
  field : TbfaAddfield;
begin
  FSkipChangeEvents := True;
  try
    field := GetAddfieldByID(statefield.AddfieldID);
    cbxStatefieldLink.ItemIndex := cbxStatefieldLink.Items.IndexOfObject(field);
    cbxLinkType.ItemIndex :=  IndexOfTbfaInt(StateFieldFunctions, statefield.Func);
    lblStatefieldID.Caption := _('Feld-ID:') + '   ' + IntToStr(statefield.ID);
    lblIndex.Caption := _('Index:') + '   ' + IntToStr(statefield.IndexColumnID);
    lblBitmask.Caption := _('Bitmaske:') + ' ' + IntToStr(statefield.Bitmask);
    chkDLM.Checked := statefield.Flags and 4 = 4;

  finally
    FSkipChangeEvents := False;
  end;
end;

procedure TfraAdmin.ShowStateFieldRights(right: Integer);
begin
  FSkipChangeEvents := True;
  try
    chbxStatefieldRights.Checked[0] := (right and 1) = 1;
    chbxStatefieldRights.Checked[1] := (right and 2) = 2;
    chbxStatefieldRights.Checked[2] := (right and 4) = 4;
  finally
    FSkipChangeEvents := False;
  end;
end;

procedure TfraAdmin.ShowUserProperties(usr: TbfaUser);
var
  cntuser : string;
begin
  FSkipChangeEvents := True;
  try
    try
      if usr <> nil then
      begin
        edtDisplayName.Text :=  usr.DisplayName;
        edtPassword.Text := '********';
        edtEmail.Text := usr.Email;
        chkUserDenied.Checked := (usr.Flags and 1) = 0;
//        chkFromAD.Checked := (usr.Flags and 4) = 4; Enterprise
        chkAdmin.Checked := (usr.Flags and 8) = 8;
//        chkSuperior.Checked := (usr.Flags and 16) = 16;
        chkMustChangePass.Checked := (usr.Flags and 32) = 32;
//        chkConcurrent.Checked := (usr.Flags and 64) = 64;
        cbxUserRole.ItemIndex := IndexOfTbfaInt(RoleList, usr.Role);
        lblUserID.Caption := _('Benutzer-ID:') + '   ' + IntToStr(usr.ID);

        //System oder DMSAdmin
        edtPassword.Enabled := not ((usr.ID = 1) or (usr.Flags and 128 = 128)) and bitfarmApp.AdminEditMode;
        if (bitfarmApp.User.Flags and 128 = 128) and (usr.Flags and 128 = 128) then   // nur dmsadmin darf das dmsadmin-passwort ndern
          edtPassword.Enabled := bitfarmApp.AdminEditMode;
        edtEmail.Enabled := not ((usr.ID = 1) or (usr.Flags and 128 = 128)) and bitfarmApp.AdminEditMode;
        edtDisplayName.Enabled := not ((usr.ID = 1) or (usr.Flags and 128 = 128)) and bitfarmApp.AdminEditMode;
        chkUserDenied.Enabled := not ((usr.ID = 1) or (usr.Flags and 128 = 128)) and bitfarmApp.AdminEditMode;
//        chkFromAD.Enabled := not ((usr.ID = 1) or (usr.Flags and 128 = 128)) and bitfarmApp.AdminEditMode;
        chkAdmin.Enabled := (bitfarmApp.User.Flags and 128 = 128) and (usr.Flags and 128 = 0) and bitfarmApp.AdminEditMode;  //dmsadmin kann sich nicht das admin-flag nehmen
//        chkSuperior.Enabled := not ((usr.ID = 1) or (usr.Flags and 128 = 128)) and bitfarmApp.AdminEditMode;
        chkMustChangePass.Enabled := not ((usr.ID = 1) or (usr.Flags and 128 = 128)) and bitfarmApp.AdminEditMode;
//        chkConcurrent.Enabled := not ((usr.ID = 1) or (usr.Flags and 128 = 128)) and bitfarmApp.AdminEditMode;
        cbxUserRole.Enabled := not ((usr.ID = 1) or (usr.Flags and 128 = 128)) and bitfarmApp.AdminEditMode;
        if bitfarmApp.AdminEditMode then
          bfiUser.DisableButtons := ((usr.ID = 1) or (usr.Flags and 128 = 128)) and bitfarmApp.AdminEditMode;

      end;

      cntuser := bitfarmApp.cnt_enabled.ToString; //17.07.2024 bfacrm:ticket__show__39362

      lblCntUser.Caption := _('Anzahl Benutzer:') + ' ' + cntuser;
    except
      bitfarmLog.Write(llDebug, ltException, 'ShowUserProperties', ClassName);
    end;
  finally
    FSkipChangeEvents := False;
  end;
end;

//procedure TfraAdmin.SetADLviewChecked(Value : Boolean);
//begin
//  try
//    for var i : integer := 0 to bfsADGroups.lvList2.Items.Count - 1  do
//      if bfsADGroups.lvList2.Items[i].Selected then
//        ADGroupsCheckbox(bfsADGroups.lvList2.Items[i], Value);
//  except
//    //
//  end;
//end;


//procedure TfraAdmin.SpTBXItem1Click(Sender: TObject);
//begin
//  SetADLviewChecked(True);
//end;
//
//procedure TfraAdmin.SpTBXItem2Click(Sender: TObject);
//begin
//  SetADLviewChecked(False);
//end;

//procedure TfraAdmin.SpTBXItem1Click(Sender: TObject);
//begin
//
//end;
//
//procedure TfraAdmin.SpTBXItem2Click(Sender: TObject);
//begin
//
//end;

procedure TfraAdmin.SpTBXSplitter10Moving(Sender: TObject; var NewSize: Integer;
  var Accept: Boolean);
begin
  if NewSize < 180 then
    NewSize := 180
  else if SpTBXTabSheet1.Width - NewSize < 600 then
    NewSize := SpTBXTabSheet1.Width - 600;
end;

procedure TfraAdmin.SpTBXSplitter11Moving(Sender: TObject; var NewSize: Integer;
  var Accept: Boolean);
begin
  if NewSize < 60 then
    NewSize := 60
  else if SpTBXTabSheet1.Height - NewSize < 700 then
    NewSize := SpTBXTabSheet1.Height - 700;
end;

procedure TfraAdmin.SpTBXSplitter12Moving(Sender: TObject; var NewSize: Integer;
  var Accept: Boolean);
begin
  if NewSize < 500 then
    NewSize := 500
  else if SpTBXTabSheet1.Width - NewSize < 500 then
    NewSize := SpTBXTabSheet1.Width - 500;
end;

//procedure TfraAdmin.SpTBXSplitter1Moving(Sender: TObject; var NewSize: Integer;
//  var Accept: Boolean);
//begin
//  if NewSize < 600 then
//    NewSize := 600
//  else if (SpTBXSplitter1.Left < NewSize) and (SpTBXPanel6.Width < 500) then
//    Accept := False;
//end;

procedure TfraAdmin.SpTBXSplitter2Moving(Sender: TObject; var NewSize: Integer;
  var Accept: Boolean);
begin
  if NewSize < 300 then
    NewSize := 300
  else if SpTBXTabSheet1.Height - NewSize < 200 then
    NewSize := SpTBXTabSheet1.Height - 200;
end;

procedure TfraAdmin.SpTBXSplitter3Moving(Sender: TObject; var NewSize: Integer;
  var Accept: Boolean);
begin
  if NewSize < 250 then
    NewSize := 250
  else if SpTBXTabSheet1.Height - NewSize < 200 then
    NewSize := SpTBXTabSheet1.Height - 200;
end;

procedure TfraAdmin.SpTBXSplitter4Moving(Sender: TObject; var NewSize: Integer;
  var Accept: Boolean);
begin
  if NewSize < 230 then
    NewSize := 230
  else if SpTBXTabSheet1.Height - NewSize < (SpTBXTabSheet1.Height div 3) then
    NewSize := SpTBXTabSheet1.Height - (SpTBXTabSheet1.Height div 3);
end;

procedure TfraAdmin.SpTBXSplitter5Moving(Sender: TObject; var NewSize: Integer;
  var Accept: Boolean);
begin
  if NewSize < 200 then
    NewSize := 200
  else if SpTBXTabSheet1.Height - NewSize < 400 then
    NewSize := SpTBXTabSheet1.Height - 400;
end;

procedure TfraAdmin.SpTBXSplitter6Moving(Sender: TObject; var NewSize: Integer;
  var Accept: Boolean);
begin
  if NewSize < 550 then
    NewSize := 550
  else if (SpTBXSplitter6.Left < NewSize) and (SpTBXPanel12.Width < 430) then
    Accept := False;
end;

procedure DoSplitterMovingAtRights(LeftPanel, MittelPanel : TSpTBXPanel;
  LeftSelector, RightSelector : TbfaSelector; var NewSize : Integer; var Accept: Boolean);
var
  Diff : Integer;
begin
//06.01.2022 Ticket  -->
  if (NewSize < LeftPanel.Width) and
     (LeftSelector.Width > LeftPanel.Width - 17) then
  begin
    if LeftSelector.SpTBXPanel2.Width <=
       LeftSelector.SpTBXPanel2.Constraints.MinWidth then
    begin
      Diff := LeftSelector.Width - (LeftPanel.Width - 17);
      LeftSelector.SpTBXPanel1.Width := LeftSelector.SpTBXPanel1.Width - Diff;
      LeftSelector.SpTBXSplitter1.Left := LeftSelector.SpTBXSplitter1.Left - Diff;
    end;
    LeftSelector.Width := LeftPanel.Width - 17;
  end
  else
  if (NewSize >= LeftPanel.Width) and
     (RightSelector.Width > MittelPanel.Width - 17) then
  begin
    if RightSelector.SpTBXPanel2.Width <=
       RightSelector.SpTBXPanel2.Constraints.MinWidth then
    begin
      Diff := RightSelector.Width - (MittelPanel.Width - 17);
      RightSelector.SpTBXPanel1.Width := RightSelector.SpTBXPanel1.Width - Diff;
      RightSelector.SpTBXSplitter1.Left := RightSelector.SpTBXSplitter1.Left - Diff;
      if RightSelector.SpTBXPanel1.Width = RightSelector.SpTBXPanel1.Constraints.MinWidth then
        RightSelector.SpTBXPanel2.Width := RightSelector.SpTBXPanel2.Width - Diff;
    end;
    RightSelector.Width := MittelPanel.Width - 17;
    if (NewSize > LeftPanel.Width) and
       (RightSelector.Width > MittelPanel.Width - 17) then
    begin
      Accept := False;
      Diff := RightSelector.Width - (MittelPanel.Width - 17);
      RightSelector.SpTBXPanel1.Width := RightSelector.SpTBXPanel1.Width - Diff;
      RightSelector.SpTBXSplitter1.Left := RightSelector.SpTBXSplitter1.Left - Diff;
      if RightSelector.SpTBXPanel1.Width = RightSelector.SpTBXPanel1.Constraints.MinWidth then
        RightSelector.SpTBXPanel2.Width := RightSelector.SpTBXPanel2.Width - Diff;
      NewSize := MittelPanel.Width - 17;
      RightSelector.Width := MittelPanel.Width - 17;
    end;
  end
//06.01.2022 Ticket  <--
end;

procedure TfraAdmin.SpTBXSplitter7Moving(Sender: TObject; var NewSize: Integer;
  var Accept: Boolean);
begin
  if NewSize < 400 then
    NewSize := 400;
  DoSplitterMovingAtRights(SpTbxPanel13, SpTBXPanel14, bfsAssignAddfields, bfsAddfieldsUser, NewSize, Accept);
end;

procedure TfraAdmin.SpTBXSplitter8Moving(Sender: TObject; var NewSize: Integer;
  var Accept: Boolean);
begin
  if NewSize < 180 then
    NewSize := 180
  else if SpTBXTabSheet1.Width - NewSize < 600 then
    NewSize := SpTBXTabSheet1.Width - 600;
end;

procedure TfraAdmin.SpTBXSplitter9Moving(Sender: TObject; var NewSize: Integer;
  var Accept: Boolean);
begin
  if NewSize < 400 then
    NewSize := 400;
  DoSplitterMovingAtRights(SpTbxPanel16, SpTBXPanel17, bfsAssignStatefields, bfsStatefieldsUser, NewSize, Accept);
end;

procedure TfraAdmin.btnCreateFNDFileClick(Sender: TObject);
var
  i : Integer;
  sFileName : String;
begin
  {$IFDEF ENTERPRISE}
  bitfarmLog.DebugBegin(llDebug, 'btnCreateFNDFileClick', ClassName);
  try
    try
      if (FCurrentArchive <> nil) then
      begin
        if PromptForFileName(sFileName, 'Suchvorlagen (*.FND)|*.FND', 'FND',
          'Bitte geben Sie einen Namen fr die Suchvorlage ein:', ExtractFilePath(ParamStr(0)), True) then
        begin

          bitfarmApp.WriteJobFile(sFileName, True, 1, nil, FCurrentArchive.ID);
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'btnCreateFNDFileClick', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'btnCreateFNDFileClick', ClassName);
  end;
  {$ENDIF}
end;

procedure TfraAdmin.btnCreateTPLFileClick(Sender: TObject);
var
  i : Integer;
  arcids : TStringList;
begin
  bitfarmLog.DebugBegin(llDebug, 'btnCreateTPLFileClick', ClassName);
  try
    try
      arcids := TStringList.Create;
      try
        arcids.Delimiter := ';';
        arcids.StrictDelimiter := True;
        if frmMainForm.FAdminTreeview.CountChecked > 0 then
        begin
          for i := 0 to frmMainForm.FAdminTreeview.Items.Count -1 do
          begin
            if (frmMainForm.FAdminTreeview.Checked[frmMainForm.FAdminTreeview.Items.Item[i]]) and
               (PbfaInt64(frmMainForm.FAdminTreeview.Items.Item[i].Data).Value <= High(aSysArc)) and
               (aSysArc[PbfaInt64(frmMainForm.FAdminTreeview.Items.Item[i].Data).Value].Typ = 1)then
              arcids.Add(IntToStr(PbfaInt64(frmMainForm.FAdminTreeview.Items.Item[i].Data).Value));
          end;
        end else if (frmMainForm.fraAdmin.FCurrentArchive.ID <= High(aSysArc)) and
                    (aSysArc[frmMainForm.fraAdmin.FCurrentArchive.ID].Typ = 1) then
          arcids.Add(IntToStr(frmMainForm.fraAdmin.FCurrentArchive.ID));

        if frmMainForm.fraAdmin.FCurrentArchive <> nil then
          WriteTemplate(arcids);

      finally
        FreeAndNil(arcids);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'btnCreateTPLFileClick', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'btnCreateTPLFileClick', ClassName);
  end;
end;

procedure TfraAdmin.WriteTemplate(arcids : TStringList; WithDlg : Boolean = True);
var
  req : TbfaRequest;
  sock: TSocketConnection;
begin
  bitfarmLog.DebugBegin(llDebug, 'WriteTemplate', ClassName);
  try
    try
      if arcids.Count > 0 then
      begin
        sock := TSocketConnection.Create(bitfarmApp.bfaServerNoSSL, bitfarmApp.bfaServer, bitfarmApp.bfaServerPort, '');
        req := TbfaRequest.Create;
        try
          sock.CreateComponents;
          if sock.Connect then
          begin
            req.ReqType := 'reqWriteTemplate';
            req.UserID := bitfarmApp.User.ID;
            req.Parameter := arcids.DelimitedText;
            req.Lang := bitfarmApp.Lang;
            req.Profile := bitfarmApp.Profile;
            sock.SendRequestToServer(req);

            req := sock.ReceiveResponse;
            if req = nil then
              Exit;

            if req.ReqType = 'respOK' then
            begin
              if WithDlg then
              begin
                if arcids.Count = 1 then
                    BfShowMessage(_('Importvorlage wurde erstellt.'))
                else
                  BfShowMessage(_('Importvorlagen wurden erstellt.'));
              end;
            end else
              BfShowMessage(req.DataString);
          end;
        finally
          FreeAndNil(req);
          FreeAndNil(sock);
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'WriteTemplate', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'WriteTemplate', ClassName);
  end;
end;

procedure TfraAdmin.btnSaveAdminClick(Sender: TObject);
var
  i: Integer;

  function CheckInputCombosInEditmode: Boolean;
  begin
    Result := false;

    if bfiRepos.IsInUse then
    begin
      BfShowMessage(_('Bitte speichern Sie den Lagerort!'));
      Result := true;
      exit;
    end;

    if bfiArchives.IsInUse then
    begin
      BfShowMessage(_('Bitte speichern Sie das Archiv!'));
      Result := true;
      exit;
    end;

    if bfiAddfields.IsInUse then
    begin
      BfShowMessage(_('Bitte speichern Sie das Zusatzfeld!'));
      Result := true;
      exit;
    end;

    if  bfiStatefields.IsInUse then
    begin
      BfShowMessage(_('Bitte speichern Sie das Statusfeld!'));
      Result := true;
      exit;
    end;

    if bfiUser.IsInUse then
    begin
      BfShowMessage(_('Bitte speichern Sie den Benutzer!'));
      Result := true;
      exit;
    end;

    if bfiGroups.IsInUse then
    begin
      BfShowMessage(_('Bitte speichern Sie die Gruppe!'));
      Result := true;
      exit
    end;
  end;

begin
  frmMainForm.ActiveControl := nil;
  if bitfarmApp.AdminEditMode then
  begin
    if CheckInputCombosInEditmode then
      Exit;

    {$IFDEF ENTERPRISE}
    if TfraAdminEnterprise(Self).ADModified and (Sender <> nil) then  // wenn wir ber den btnSaveAdminClick direkt reinkommen und die AD Konfiguration gendert haben
    begin
      if BfMessageDlg(_('Sie haben nderungen an der AD-Konfiguration vorgenommen. Wollen Sie einen AD-Abgleich durchfhren?'),
                      mtConfirmation, mbYesNo) = mrYes then
      begin
        TfraAdminEnterprise(Self).btnADSyncClick(nil);
        Exit;
//      end else
//      begin
//        for i := 0 to bitfarmApp.GGroups.Count -1 do
//        begin
//          if bitfarmApp.GGroups[i].Modified and (bitfarmApp.GGroups[i].Flags and 4 = 4) then
//            bitfarmApp.GGroups[i].Modified := False;  // zurcksetzen, wenn wir keinen AD Abgleich durchfhren wollen, sonst wird die Gruppe gespeichert
//
//        end;
      end;
    end;
    {$ENDIF}

    bitfarmApp.AdminEditMode := False; //14.08.2017 Ticket 11475
    frmMainForm.frmSplash.Show;
    frmMainForm.frmSplash.lblLoading.Caption := sMsgAdminSaveConfig;
    frmMainForm.frmSplash.lblInfo.Caption := sMsgAdminSaveObjects;
    frmMainForm.frmSplash.Update;
    SaveObjects;
    frmMainForm.frmSplash.lblInfo.Caption := sMsgAdminRefreshView;
    frmMainForm.frmSplash.Update;
    bitfarmApp.LoadArrays; //02.02.2018 Ticket 12490
    bitfarmApp.LoadUser;
    ReloadAdminFrame;
    frmMainForm.frmSplash.lblInfo.Caption := sMsgAdminRefreshConfig;
    frmMainForm.frmSplash.Update;
    bitfarmApp.ReadSysArc;
    bitfarmApp.ReadSortings;
    bitfarmApp.ReadUserList;
    bitfarmApp.ReadResubUserGroups(frmMainForm.fraResub);
    if (frmMainForm.fraFloatingResub <> nil) and (frmMainForm.fraFloatingResub.fraResub <> nil) then
      bitfarmApp.ReadResubUserGroups(frmMainForm.fraFloatingResub.fraResub);
    bitfarmApp.Reloadfields;
    frmMainForm.frmSplash.lblInfo.Caption := sMsgAdminRefreshTreeviews;
    frmMainForm.frmSplash.Update;
    frmMainForm.FViewerTreeview.FSkipChangeEvents := True;
    frmMainForm.FViewerTreeview.ChangeDelay := 0;
    frmMainForm.FImporterTreeview.FSkipChangeEvents := True;
    frmMainForm.FImporterTreeview.ChangeDelay := 0;
    try
      bitfarmApp.ReloadTrees(True);
    finally
      frmMainForm.FViewerTreeview.FSkipChangeEvents := False;
      frmMainForm.FImporterTreeview.FSkipChangeEvents := False;
      frmMainForm.FViewerTreeview.ChangeDelay := tvChangeDelay;
      frmMainForm.FImporterTreeview.ChangeDelay := tvChangeDelay;
    end;
    FModified := False;
    {$IFDEF ENTERPRISE}
    TfraAdminEnterprise(Self).ADModified := False;
    TfraAdminEnterprise(Self).EnableADSync;
    frmMainForm.SetStatusBar; //30.09.2024 SD <--bfacrm:ticket__show__39456
    try
      //06.03.2024 if tabctrAdmin.ActiveTabIndex in [2] then
      if tabctrAdmin.ActiveTabIndex = 2 then
      begin
        TfraAdminEnterprise(Self).LoadADGroups;
        TfraAdminEnterprise(Self).LoadHolidayList;
      end;
    except
      // CrashLog von 03.2024
    end;
    {$ENDIF}

    btnSaveAdmin.Caption := sCaptionModify;
    btnSaveAdmin.ImageIndex := Integer(icoidx_edit);

    bitfarmApp.CheckHoliday;
    if bitfarmApp.GetActivePreview <> nil then
      bitfarmApp.GetActivePreview.SetActions;
    EnableFunctions(bitfarmApp.AdminEditMode);
    if tabctrAdmin.ActiveTabIndex in [0,1] then
    begin
      frmMainForm.FAdminTreeview.SelectTreeNode(FCurrentArchive.ID);
      frmMainForm.FAdminTreeview.CheckOneNode(frmMainForm.FAdminTreeview.Selected);
      bitfarmApp.CountChecked;
      SelectArchive(FCurrentArchive.ID);
    end;

    frmMainForm.frmSplash.lblInfo.Caption := '';
    frmMainForm.frmSplash.Hide;
  end else
  begin
    bitfarmApp.AdminEditMode := True;
    FModified := False;

    btnSaveAdmin.Caption := sCaptionSave;
    btnSaveAdmin.ImageIndex := Integer(icoidx_ok);
    EnableFunctions(bitfarmApp.AdminEditMode);

    if FCurrentUser <> nil then
      ShowUserProperties(FCurrentUser);
    if FCurrentAddfield <> nil then
      ShowAddfieldProperties(FCurrentAddfield);
    if FCurrentArchive <> nil then
      ShowArchiveProperties(FCurrentArchive);
    if FCurrentStateField <> nil then
      ShowStatefieldProperties(FCurrentStateField);
    if FCurrentGroup <> nil then
    begin
      ShowGroupProperties(FCurrentGroup);
      bfsGroupsUser.Editable := FCurrentGroup.ID <> 0;    // sollten wir zufllig auf Alle(Builtin) stehen -> disablen
    end;

    bitfarmApp.CurrentFields := -1;
    bitfarmApp.CurrentViewerFields := -1;
    bitfarmApp.CurrentImporterFields := -1;

    // f.schneider: denkbar schlechteste Stelle! Einmal luft das ber den MainTread, wobei alles andere im Adnnistrator
    //              nicht gethreaded ist. Dann wird es bei jedem Klick auf Speichern aufgerufen, obwohl wir die Hauptansichten Viewer, Importer oder WVL
    //              schon lngst verlassen haben. Dies gehrt in SetActiveView
    //frmMainForm.actReset.Execute; //03.04.2017 Ticket 10202

    CheckAdminTimestamp;
  end;

  PaintWindow(Self.Handle);
  Self.Repaint;
  Sleep(500);

end;

procedure TfraAdmin.btnSearchLogCancelClick(Sender: TObject);
begin
  lvAdminLog.Items.Clear;
  edtLogGdocid.Text := '';
  cbxLogUser.ItemIndex := -1;
  dtDateLogStart.Text := '';
  dtDateLogEnd.Text := '';
  edtLogEntry.Text := ''; //21.08.2024 SD <--bfacrm:ticket__show__39655
  btnOffsetDec.Enabled := False;
  btnOffsetInc.Enabled := False;
  FAdminLogOffset := 0;
  ShowHistoryRecords;
end;

procedure TfraAdmin.btnSearchLogClick(Sender: TObject);
var
  req: TbfaRequest;
  sock: TSocketConnection;
  hist, histAll : TList<TbfaHistory>; //22.08.2024 SD <--bfacrm:ticket__show__39655
  i : Integer;
  item : TListItem;
  gdocid : Int64;
  userid : Integer;
  datefrom, dateto, logEntry, logMsg : string; //22.08.2024 SD <--bfacrm:ticket__show__39655
  param, paramAll : TStringList; //22.08.2024 SD <--bfacrm:ticket__show__39655
  lmq: TUniQuery;
  query : string;
  LogOffsetAll : Integer; //22.08.2024 SD <--bfacrm:ticket__show__39655
begin
  bitfarmLog.DebugBegin(llDebug, 'btnSearchLogClick', ClassName);
  try
    try
      param := TStringList.Create;
      param.Delimiter := ';';
      param.StrictDelimiter := True;
      query := '';
      logEntry := LowerCase(Trim(edtLogEntry.Text));

      if rbDocHistory.Checked then
      begin
        if (edtLogGdocid.Text <> '') then
        begin
          param.Add('gdocid:' + ParseSQLString(edtLogGdocid.Text));
          query := 'gdocid = ' + ParseSQLString(edtLogGdocid.Text);
        end else begin
          param.Add('gdocid_neg:0');
          query := 'gdocid <> 0';
        end;
      end else
        query := 'gdocid = 0';

//22.08.2024 SD <--bfacrm:ticket__show__39655
//      param.Add('limit:100');
//      param.Add('offset:' + IntToStr(FAdminLogOffset * 100));
//22.08.2024 SD <--bfacrm:ticket__show__39655

      if cbxLogUser.ItemIndex > -1 then
      begin
        param.Add('userid:' + IntToStr(TbfaUser(cbxLogUser.Items.Objects[cbxLogUser.ItemIndex]).ID));
        if query <> '' then
          query := query + ' and ';
        query := query + 'userid = ' + IntToStr(TbfaUser(cbxLogUser.Items.Objects[cbxLogUser.ItemIndex]).ID);
      end;
      if dtDateLogStart.Text <> '' then
      begin
        param.Add('datefrom:' + FormatDateTime('yyyy-mm-dd', dtDateLogStart.Date));
        if query <> '' then
          query := query + ' and ';
        query := query + 'tstamp >= ' + #39 + FormatDateTime('yyyy-mm-dd', dtDateLogStart.Date) + #39;
      end;
      if dtDateLogEnd.Text <> '' then
      begin
        param.Add('dateto:' + FormatDateTime('yyyy-mm-dd', IncDay(dtDateLogEnd.Date, 1)));
        if query <> '' then
          query := query + ' and ';
        query := query + 'tstamp <= ' + #39 + FormatDateTime('yyyy-mm-dd', dtDateLogEnd.Date) + #39;
      end;

      if (TObject(Sender) = btnSearchLog) and (query <> '') {22.08.2024 SD <--bfacrm:ticket__show__39655} and (logEntry = '') then   // wenn wir auf Suchen klicken, dann holen wir uns die Gesamtzahl
      begin
        lmq := DbCreateQuery;
        try
          lmq.SQL.Text := 'select count(*) from sys_history where ' + query;
          lmq.Execute;
          if lmq.RecordCount > 0 then
          begin
            lmq.First;
            lblRecords.Caption := lmq.FieldByName('count(*)').AsString;
          end;
        finally
          lmq.Free;
        end;
      end;

      sock := TSocketConnection.Create(bitfarmApp.bfaServerNoSSL, bitfarmApp.bfaServer, bitfarmApp.bfaServerPort, '');
      sock.CreateComponents;
      if sock.Connect then
      begin
        req := TbfaRequest.Create;
        try
          req.ReqType := 'reqHistory';
          req.UserID := bitfarmApp.User.ID;
          req.Gdocid := 0;     // wenn wir das Log als Admin abfragen, dann ist gdocid immer 0
                              // soll eine gdocid gefiltert werden, dann wird die als Parameter bergeben
          req.Profile := bitfarmApp.Profile;
          req.Lang := bitfarmApp.Lang;

          //22.08.2024 SD <--bfacrm:ticket__show__39655
          if (logEntry <> '') then
          begin
            histAll := TList<TbfaHistory>.Create;
            LogOffsetAll := 0;
            paramAll := param;
            paramAll.Add('limit:1000');
            paramAll.Add('offset: 0');
            while LogOffsetAll <> -1 do
            begin
              req.Parameter := paramAll.DelimitedText;
              sock.SendRequestToServer(req);
              hist := TList<TbfaHistory>.Create;
              req := sock.ReceiveHistory(hist);
              for i := 0 to hist.Count - 1 do
              begin
                logMsg := LowerCase(Trim(hist[i].Msg));
                if Pos(logEntry, logMsg) = 0 then
                  Continue;
                histAll.Add(hist[i])
              end;
              if hist.Count < 1000 then
                LogOffsetAll := -1
              else
              begin
                Inc(LogOffsetAll);
                paramAll[paramAll.Count - 1] := 'offset:' + IntToStr(LogOffsetAll * 1000);
              end;
            end;
            if histAll.Count > 0 then
               lblRecords.Caption := IntToStr(histAll.Count);

            lvAdminLog.Items.Clear;
            lvAdminLog.Items.BeginUpdate;
            try
              for i := 0 to histAll.Count - 1 do
              begin
                if ((i+1) > (FAdminLogOffset * 100)) and ((i+1) <= ((FAdminLogOffset * 100) + 100)) then
                begin
                  item := lvAdminLog.Items.Add;
                  item.Caption := DateTimeToStr(histAll[i].Date);
                  item.SubItems.Add(IntToStr(histAll[i].Gdocid));
                  item.SubItems.Add(histAll[i].UserName);
                  item.SubItems.Add(histAll[i].Msg);
                end;
              end;
            finally
              lvAdminLog.Items.EndUpdate;
            end
          end
          //22.08.2024 SD <--bfacrm:ticket__show__39655
          else
          begin
            param.Add('limit:100');
            param.Add('offset:' + IntToStr(FAdminLogOffset * 100));
            req.Parameter := param.DelimitedText;
            sock.SendRequestToServer(req);
            hist := TList<TbfaHistory>.Create;
            req := sock.ReceiveHistory(hist);
  //14.03.2024          lvAdminLog.Items.BeginUpdate;
            lvAdminLog.Items.Clear;
            lvAdminLog.Items.BeginUpdate;//14.03.2024
            try
              for i := 0 to hist.Count - 1 do
              begin
                item := lvAdminLog.Items.Add;
        //                item.Caption := DateToStr(hist[i].Date);
                item.Caption := DateTimeToStr(hist[i].Date);
                item.SubItems.Add(IntToStr(hist[i].Gdocid));
                item.SubItems.Add(hist[i].UserName);
                item.SubItems.Add(hist[i].Msg);
              end;
            finally
              lvAdminLog.Items.EndUpdate;
            end;
          end;

          sock.Disconnect;

          btnOffsetInc.Enabled := lvAdminLog.Items.Count >= 100;  // hundert Eintrge dann OffsetInc anbieten
          ShowHistoryRecords;
        finally
          FreeAndNil(req);
          FreeAndNil(sock);
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'btnSearchLogClick', ClassName);
    end;
  finally
    param.Free;
    bitfarmLog.DebugEnd(llDebug, 'btnSearchLogClick', ClassName);
  end;
end;

procedure TfraAdmin.btnSearchresubClick(Sender: TObject);
var
  lsstring, lssql: string;
  userid : Integer;
  xDate: TDateTime;
  lmq : TUniQuery;
begin
  Screen.Cursor := crHourGlass;
  try
    if rbID.Checked then
    begin
      if edtArcid.Text <> '' then
        lsstring := 'doc.arcid =' + ParseSQLString(edtArcid.Text);
      if edtGdocid.Text <> '' then
      begin
        if lsstring <> '' then
          lsstring := lsstring + ' and tim.gdocid=' + ReplaceStr(ParseSQLString(edtGdocid.Text), 'gdocid:', '')
        else
          lsstring := 'tim.gdocid =' + ReplaceStr(ParseSQLString(edtGdocid.Text), 'gdocid:', '');
      end;
      if edtTimref.Text <> '' then
      begin
        if lsstring <> '' then
          lsstring := lsstring + ' and tim.timref=' + (edtTimref.Text)
        else
          lsstring := 'tim.timref =' + (edtTimref.Text);
      end;
    end else
    begin
      if cbxResubUser.ItemIndex = -1 then
        Exit;

      userid := TbfaUser(cbxResubUser.Items.Objects[cbxResubUser.ItemIndex]).ID;
      lsstring := 'userid_work = ' + IntToStr(userid);

      if dtResubDate.Text <> '' then
      begin

        xDate := dtResubDate.Date;

        Case cbxResubSearchMode.ItemIndex of

         0:
           lsstring := lsstring + ' and date like ' +#39+FormatDateTime ('yyyy-mm-dd', xDate)+'%'+#39;
         1:
           lsstring := lsstring + ' and date > ' +#39+FormatDateTime ('yyyy-mm-dd', xDate)+#39;
         2:
           lsstring := lsstring + ' and date < ' +#39+FormatDateTime ('yyyy-mm-dd', xDate)+#39;
         3:
           lsstring := lsstring + ' and date not like  ' +#39+FormatDateTime ('yyyy-mm-dd', xDate)+'%'+#39;

         end;
      end;
    end;

    lssql := 'select date as Termin, arc.arcname as Archiv, doc.docname as Titel, info as Info, ' +
              ' usr.username as Bearbeiter,usr2.username as Controller, '+
              ' if(status & 4 = 4,'+#39+'fertig'+#39+', if(status & 2 = 2,'+#39+'in Arbeit'+#39 +
              ', if(status & 1 = 1,'+#39+'offen'+#39+','+#39+#39+'))) as Status, ' +
              ' tim.timref as RefID, tim.gdocid as GDOCID, tim.groupid, doc.arcid from sys_timer as tim '+
              ' left join sys_doc as doc on doc.gdocid = tim.gdocid ' +
              ' left join sys_arc as arc on arc.arcid = doc.arcid '+
              ' left join sys_user as usr on tim.userid_work = usr.userid '+
              ' left join sys_user as usr2 on tim.userid_shed = usr2.userid';

    if lsstring <> '' then
      lssql := lssql + ' where ' + lsstring;

    lssql := lssql + ' ORDER BY Termin DESC;'; //06.01.2022 bfacrm:ticket__show__29551

    mqResubSearch.SQL.Text := lssql;

    mqResubSearch.Execute;
    bfaDBGrid1.AdjustColumns;

  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TfraAdmin.btnServerInfoClick(Sender: TObject);
var
  req: TbfaRequest;
  sock: TSocketConnection;
begin
  bitfarmLog.DebugBegin(llDebug, 'btnServerInfoClick', ClassName);
  try
    try
      sock := TSocketConnection.Create(bitfarmApp.bfaServerNoSSL, bitfarmApp.bfaServer, bitfarmApp.bfaServerPort, '');

      sock.CreateComponents;
      if sock.Connect then
      begin
        req := TbfaRequest.Create;
        if Sender = btnServerInfo then
          req.ReqType := 'reqServerInfo'
        else if Sender = btnUserInfo then
          req.ReqType := 'reqUserInfo'
        else
          req.ReqType := 'reqReloadConfig';

        req.UserID := bitfarmApp.User.ID;
        req.Profile :=  bitfarmApp.Profile;
        req.Lang := bitfarmApp.Lang;
        sock.SendRequestToServer(req);

        req := sock.ReceiveResponse;
        if req = nil then
          Exit;

        if req.ReqType = 'respOK' then
        begin
          if (Sender = btnServerInfo) or (Sender = btnUserInfo) then
          begin
            frmMainForm.frmInfoBox := TfrmInfoBox.Create(Self);
            frmMainForm.frmInfoBox.Color := stlControl.Color;
            frmMainForm.frmInfoBox.Font.Color := stlControl.TextColor;
            frmMainForm.frmInfoBox.pnl1.Color := stlControl.Color;
            frmMainForm.frmInfoBox.pnl1.Font.Color := stlControl.TextColor;
            frmMainForm.frmInfoBox.redtInfo.Color := stlControl.Color;
            frmMainForm.frmInfoBox.redtInfo.Font.Color := stlControl.TextColor;
            frmMainForm.frmInfoBox.InfoText := req.DataString;
            frmMainForm.frmInfoBox.ShowModal;
            frmMainForm.frmInfoBox.Release;
            FreeAndNil(frmMainForm.frmInfoBox);
          end else begin
            BfShowMessage(_('Neuladen der Serverkonfigurationsdateien durchgefhrt.'));
            LoadRegistration;
          end;
        end else
          BfShowMessage(_('Fehler:') + ' ' + req.DataString);

        sock.Disconnect;

      end;
    except
      on e: exception do
        bitfarmLog.Write(llNormal, ltException, 'btnServerInfoClick' + e.Message, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'btnServerInfoClick', ClassName);
    if Assigned(req) then
      FreeAndNil(req);
    if Assigned(sock) then
      FreeAndNil(sock);
  end;
end;

procedure TfraAdmin.CheckAdminTimestamp;
var
  lmq : TUniQuery;
  reload: Boolean;
begin
    lmq := DbCreateQuery;   // aktuellen Timestamp holen
    try
      lmq.SQL.Text := 'select modified, modified_userid from sys_doc where gdocid = 0';
      lmq.Execute;
      if lmq.RecordCount > 0 then
      begin
        if True then
          reload := FLastModified <> lmq.FieldByName('modified').AsDateTime;
        FLastModified := lmq.FieldByName('modified').AsDateTime;
        FModifiedUserid := lmq.FieldByName('modified_userid').AsInteger;
      end else begin
        FLastModified := Now();
        FModifiedUserid := bitfarmApp.User.ID
      end;
    finally
      lmq.Free;
    end;

    if reload  then
    begin
      frmMainForm.frmSplash.lblLoading.Caption := _('Archivkonfiguration wurde gendert und muss neu geladen werden. Bitte ein Moment Geduld...');
      LoadAdminFrame;
    end;
end;



procedure TfraAdmin.ClearComponents;
begin

  FSkipChangeEvents := True;
  try
    bfiArchives.cbbInput.Items.Clear;
    bfiRepos.cbbInput.Items.Clear;
    bfiAddfields.cbbInput.Items.Clear;
    bfiStatefields.cbbInput.Items.Clear;
    bfiUser.cbbInput.Items.Clear;
    bfiGroups.cbbInput.Items.Clear;

    bfiArchives.cbbInput.ItemIndex := -1;
    bfiRepos.cbbInput.ItemIndex := -1;
    bfiAddfields.cbbInput.ItemIndex := -1;
    bfiStatefields.cbbInput.ItemIndex := -1;
    bfiUser.cbbInput.ItemIndex := -1;
    bfiGroups.cbbInput.ItemIndex := -1;
  finally
    FSkipChangeEvents := False;
  end;

  edtDisplayName.Text := '';
  edtPassword.Text := '';
  edtEmail.Text := '';
  edtDocname.Text := '';
  edtStationary.Text := '';
//  edtCheckprogram.Text := '';
  edtAddfieldDescription.Text := '';

//  edtOU.Text := '';

  bfsAssignUser.ListAll.Clear;
  bfsAssignUser.ListSelected.Clear;

  bfsAssignAddfields.ListAll.Clear;
  bfsAssignAddfields.ListSelected.Clear;

  bfsAssignStatefields.ListAll.Clear;
  bfsAssignStatefields.ListSelected.Clear;

  bfsAddfieldsUser.ListAll.Clear;
  bfsAddfieldsUser.ListSelected.Clear;

  bfsStatefieldsUser.ListAll.Clear;
  bfsStatefieldsUser.ListSelected.Clear;

//  bfsADGroups.ListAll.Clear;
//  bfsADGroups.ListSelected.Clear;

  bfsGroupsUser.ListAll.Clear;
  bfsGroupsUser.ListSelected.Clear;

  chbxArchiveRights.CheckAll(cbUnchecked);
  chbxAddfieldRights.CheckAll(cbUnchecked);
  chbxStatefieldRights.CheckAll(cbUnchecked);

  cbxStatefieldLink.Items.Clear;
  cbxStatefieldLink.ItemIndex := -1;

//  cbxSuperior.Items.Clear;
//  cbxSuperior.ItemIndex := -1;

//  cbxAddfieldType.Items.Clear;
  cbxAddfieldType.ItemIndex := -1;

  cbxStatefieldLink.Items.Clear;
  cbxStatefieldLink.ItemIndex := -1;

//  cbxLinkType.Items.Clear;
  cbxLinkType.ItemIndex := -1;

//  cbxSearchMode.Items.Clear;
  cbxSearchMode.ItemIndex := -1;

//  cbxUserRole.Items.Clear;
  cbxUserRole.ItemIndex := -1;
  cbxArcRights.ItemIndex := -1;
//  cbxGroupRole.Items.Clear;
  cbxGroupRole.ItemIndex := -1;
  edtGroupEmail.Text := '';

//  bfsInferior.ListAll.Clear;
//  bfsInferior.ListSelected.Clear;

end;

procedure TfraAdmin.ClearObjectsLists;
var i : Integer;
begin
  if bitfarmApp.GArchives <> nil then
  begin
    for i := 0 to bitfarmApp.GArchives.Count - 1 do
    begin
      if bitfarmApp.GArchives[i] <> nil then
         bitfarmApp.GArchives[i].Free;

    end;
    bitfarmApp.GArchives.Clear;
  end;

  if bitfarmApp.GUser <> nil then
  begin
    for i := 0 to bitfarmApp.GUser.Count - 1 do
    begin
      if bitfarmApp.GUser[i] <> nil then
         bitfarmApp.GUser[i].Free;
    end;
    bitfarmApp.GUser.Clear;
  end;

  if bitfarmApp.GGroups <> nil then
  begin
    for i := 0 to bitfarmApp.GGroups.Count - 1 do
    begin
      if bitfarmApp.GGroups[i] <> nil then
         bitfarmApp.GGroups[i].Free;
    end;
    bitfarmApp.GGroups.Clear;
  end;

  if bitfarmApp.GAddfields <> nil then
  begin
    for i := 0 to bitfarmApp.GAddfields.Count - 1 do
    begin
      if bitfarmApp.GAddfields[i] <> nil then
         bitfarmApp.GAddfields[i].Free;
    end;
    bitfarmApp.GAddfields.Clear;
  end;

  if bitfarmApp.GStatefields <> nil then
  begin
    for i := 0 to bitfarmApp.GStatefields.Count - 1 do
    begin
      if bitfarmApp.GStatefields[i] <> nil then
         bitfarmApp.GStatefields[i].Free;
    end;
    bitfarmApp.GStatefields.Clear;
  end;
end;

procedure TfraAdmin.CopyArchiveObjects(Sender : TObject);
begin
  try
    FArcRightsToCopy := TbfaArchive.Create;
    FArcRightsToCopy.Clone(FCurrentArchive);
  except
    on e: exception do
      bitfarmLog.Write(llNormal, ltException, 'CopyArchiveObjects ' + e.Message, ClassName);
  end;
end;

function TfraAdmin.GetAddRights(Typ : Integer; out func : Boolean) : TModalResult;
var
  Str : string;
begin
  if FPasteAllObjects and (FPasteAllObjetcsMResult <> mrNone) then
    Result := FPasteAllObjetcsMResult
  else
  begin
    if Typ = 0 then
      str := _('Mchten Sie die Rechte ersetzen?')
    else if Typ = 1 then
      str := _('Mchten Sie die Zusatzfelder ersetzen?')
    else if Typ = 2 then
      str := _('Mchten Sie die Statusferlder ersetzen?')
    else if Typ = 3 then
      str := _('Mchten Sie die Objekte ersetzen?');

    Result := BfMessageDlg(str, mtConfirmation,
      mbYesNoCancel, True, '');

    func := (Result = mrNo);
  end;
end;

procedure TfraAdmin.PasteArchiveRights(Sender : TObject);
var
  i, j, k, TmpRights : Integer;
  user : TbfaUser;
  group : TbfaGroup;
  arc : TbfaArchive;
  id : Int64;
  arcrights : TbfaArcRight;
  DialogTyp : Integer;
begin
  try
    if FPasteAllObjects then
      DialogTyp := 3
    else
      DialogTyp := 0;
    FPasteAllObjetcsMResult := GetAddRights(DialogTyp, FAddRights);

    if FPasteAllObjetcsMResult = mrCancel then
      Exit ;

    for k := 0 to frmMainForm.FAdminTreeview.Items.Count - 1 do
    begin
      if not frmMainForm.FAdminTreeview.Checked[frmMainForm.FAdminTreeview.Items.Item[k]] then
        Continue;

      id := PbfaInt64(frmMainForm.FAdminTreeview.Items.Item[k].Data).Value;
      arc := GetArchiveByID(id);
      for i := 0 to FArcRightsToCopy.Users.Count - 1 do
      begin
        arcrights := TbfaArcRight.Create;
        arcrights.ArcID := arc.ID;
        arcrights.ArcTempID := arc.TempID;
        arcrights.Userid := FArcRightsToCopy.Users[i].ToInteger;
        arcrights.Modified := True;
        if arc.Users.IndexOf(FArcRightsToCopy.Users[i]) = -1 then
        begin
          arcrights.Rights := TbfaArcRight(FArcRightsToCopy.Users.Objects[i]).Rights;
          arc.Users.AddObject(FArcRightsToCopy.Users[i], arcrights);
        end
        else
        begin
          if FAddRights then
          begin
            TmpRights := 0;
            for j := 0 to arc.Users.Count - 1 do
            begin
              if arc.Users[j].ToInteger = arcrights.UserID then
              begin
                TmpRights := TbfaArcRight(arc.Users.Objects[j]).Rights;
                Break;
              end;
            end;
            TmpRights := TmpRights or TbfaArcRight(FArcRightsToCopy.Users.Objects[i]).Rights;
            arcrights.Rights := TmpRights;
          end
          else
            arcrights.Rights := TbfaArcRight(FArcRightsToCopy.Users.Objects[i]).Rights;
          arc.Users.Objects[arc.Users.IndexOf(FArcRightsToCopy.Users[i])] := arcrights;
        end;
        arc.Modified_User := True;
      end;

      for i := 0 to FArcRightsToCopy.Groups.Count - 1 do
      begin
        arcrights := TbfaArcRight.Create;
        arcrights.ArcID := arc.ID;
        arcrights.ArcTempID := arc.TempID;
        arcrights.Groupid := FArcRightsToCopy.Groups[i].ToInteger;
        arcrights.Modified := True;
        if arc.Groups.IndexOf(FArcRightsToCopy.Groups[i]) = -1 then
        begin
          arcrights.Rights := TbfaArcRight(FArcRightsToCopy.Groups.Objects[i]).Rights;
          arc.Groups.AddObject(FArcRightsToCopy.Groups[i], arcrights);
        end
        else
        begin
          if FAddRights then
          begin
            TmpRights := 0;
            for j := 0 to arc.Groups.Count - 1 do
            begin
              if arc.Users[j].ToInteger = arcrights.GroupID then
              begin
                TmpRights := TbfaArcRight(arc.Groups.Objects[i]).Rights;
                Break;
              end;
            end;
            TmpRights := TmpRights or TbfaArcRight(FArcRightsToCopy.Groups.Objects[i]).Rights;
            arcrights.Rights := TmpRights;
          end
          else
            arcrights.Rights := TbfaArcRight(FArcRightsToCopy.Groups.Objects[i]).Rights;
          arc.Groups.Objects[arc.Groups.IndexOf(FArcRightsToCopy.Groups[i])] := arcrights;
        end;
        arc.Modified_User := True;
      end;
    end;


    SetModified;

    bfsAssignUser.DisableControls := True;
    bfsAssignUser.ClearSelected;
    chbxArchiveRights.CheckAll(cbUnchecked);
    try
      for i := 0 to FCurrentArchive.Users.Count -1 do
      begin
        user := GetUserByID(StrToInt(FCurrentArchive.Users[i]));
        if user = nil then
          Continue;
        if TbfaArcRight(FCurrentArchive.Users.Objects[i]).Deleted then   // wenn auf deleted gesetzt, nicht mehr anzeigen
          Exit;
        bfsAssignUser.AddListSelected(user.Name, user);
      end;

      for i := 0 to FCurrentArchive.Groups.Count -1 do
      begin
        group := GetGroupByID(StrToInt(FCurrentArchive.Groups[i]));
        if group = nil then
          Continue;
        if TbfaArcRight(FCurrentArchive.Groups.Objects[i]).Deleted then   // wenn auf deleted gesetzt, nicht mehr anzeigen
          Exit;
        bfsAssignUser.AddListSelected(group.Name, group);
      end;
    finally
      bfsAssignUser.DisableControls := False;
    end;
  except
    on e: exception do
      bitfarmLog.Write(llNormal, ltException, 'PasteArchiveRights ' + e.Message, ClassName);
  end;
end;

procedure TfraAdmin.PasteAddfields(Sender: TObject);
var
  i, j, k, idx : Integer;
  right : TbfaFieldRight;
  Lst, fieldrights : TList<TbfaFieldRight>;
  addfield : TbfaAddfield;
  id : Int64;
  arc : TbfaArchive;
begin
  try
    if GetAddRights(1, FAddRights) = mrCancel then
      Exit ;

    for k := 0 to frmMainForm.FAdminTreeview.Items.Count - 1 do
    begin
      if not frmMainForm.FAdminTreeview.Checked[frmMainForm.FAdminTreeview.Items.Item[k]] then
        Continue;

      id := PbfaInt64(frmMainForm.FAdminTreeview.Items.Item[k].Data).Value;
      arc := GetArchiveByID(id);

      for i := 0 to FArcRightsToCopy.Addfields.Count - 1 do
      begin
        idx := arc.Addfields.IndexOf(FArcRightsToCopy.Addfields[i]);
        if idx = -1 then
          idx := arc.Addfields.AddObject(FArcRightsToCopy.Addfields[i],
                   TList<TbfaFieldRight>.Create);

        Lst := TList<TbfaFieldRight>(FArcRightsToCopy.Addfields.Objects[i]);
        for j := 0 to Lst.Count - 1 do
        begin
          right := TbfaFieldRight.Create;
          right.ArcID := arc.ID;
          right.ArcTempID := arc.TempID;
          right.FieldID := TbfaFieldRight(Lst[j]).FieldID;
          right.Groupid := TbfaFieldRight(Lst[j]).Groupid;
          right.Userid := TbfaFieldRight(Lst[j]).Userid;
          right.Rights := TbfaFieldRight(Lst[j]).Rights;
          right.Modified := True;
          right.Fieldpos := idx;
          fieldrights := TList<TbfaFieldRight>(arc.Addfields.Objects[idx]);
          fieldrights.Add(right);
        end;
      end;
      if arc = FCurrentArchive then
      begin
        bfsAssignAddfields.DisableControls := True;
        try
          for i := 0 to arc.Addfields.Count - 1 do
          begin
            fieldrights := TList<TbfaFieldRight>(arc.Addfields.Objects[i]);
            addfield := GetAddfieldByID(StrToInt(arc.Addfields[i]));
            bfsAssignAddfields.AddListSelected(addfield.DisplayName, addfield);
          end;
        finally
          bfsAssignAddfields.DisableControls := False;
        end;
      end;
      arc.Modified_Addfields := True;
      SetModified;
    end;
  except
    on e: exception do
      bitfarmLog.Write(llNormal, ltException, 'PasteAddfields ' + e.Message, ClassName);
  end;
end;

procedure TfraAdmin.PasteStateFields(Sender: TObject);
var
  i, j, k, idx : Integer;
  right : TbfaFieldRight;
  Lst, fieldrights : TList<TbfaFieldRight>;
  stsfield : TbfaStateField;
  arc : TbfaArchive;
  id : Int64;
begin
  try
    if GetAddRights(1, FAddRights) = mrCancel then
      Exit ;

    for k := 0 to frmMainForm.FAdminTreeview.Items.Count - 1 do
    begin
      if not frmMainForm.FAdminTreeview.Checked[frmMainForm.FAdminTreeview.Items.Item[k]] then
        Continue;

      id := PbfaInt64(frmMainForm.FAdminTreeview.Items.Item[k].Data).Value;
      arc := GetArchiveByID(id);

      for i := 0 to FArcRightsToCopy.Statefields.Count - 1 do
      begin
        idx := arc.Statefields.IndexOf(FArcRightsToCopy.Statefields[i]);
        if idx = -1 then
          idx := arc.Statefields.AddObject(FArcRightsToCopy.Statefields[i],
                   TList<TbfaFieldRight>.Create);

        Lst := TList<TbfaFieldRight>(FArcRightsToCopy.Statefields.Objects[i]);
        for j := 0 to Lst.Count - 1 do
        begin
          right := TbfaFieldRight.Create;
          right.ArcID := arc.ID;
          right.ArcTempID := arc.TempID;
          right.FieldID := TbfaFieldRight(Lst[j]).FieldID;
          right.Groupid := TbfaFieldRight(Lst[j]).Groupid;
          right.Userid := TbfaFieldRight(Lst[j]).Userid;
          right.Rights := TbfaFieldRight(Lst[j]).Rights;
          right.Modified := True;
          right.Fieldpos := idx;
          fieldrights := TList<TbfaFieldRight>(arc.Statefields.Objects[idx]);
          fieldrights.Add(right);
        end;
      end;
      if arc = FCurrentArchive then
      begin
        bfsAssignStatefields.DisableControls := True;
        try
          for i := 0 to arc.Statefields.Count - 1 do
          begin
            fieldrights := TList<TbfaFieldRight>(arc.Statefields.Objects[i]);
            stsfield := GetStatefieldByID(StrToInt(arc.Statefields[i]));
            bfsAssignStatefields.AddListSelected(stsfield.DisplayName,
              stsfield);
          end;
        finally
          bfsAssignStatefields.DisableControls := False;
        end;
      end;
      arc.Modified_Statefields := True;
      SetModified;
    end;
  except
    on e: exception do
      bitfarmLog.Write(llNormal, ltException, 'PasteStateFields ' + e.Message, ClassName);
  end;
end;

procedure TfraAdmin.PasteAllObjects(Sender: TObject);
begin
  try
    FPasteAllObjects := True;
    FPasteAllObjetcsMResult := mrNone;
    try
      PasteArchiveRights(Sender);
      PasteAddfields(Sender);
      PasteStateFields(Sender);
    finally
      FPasteAllObjetcsMResult := mrNone;
      FPasteAllObjects := False;
    end;
  except
    on e: exception do
      bitfarmLog.Write(llNormal, ltException, 'PasteAllObjects ' + e.Message, ClassName);
  end;
end;

procedure TfraAdmin.InitRoleList;  // Fr bersetzung
var
 i: integer;
begin
  try
    for i := 0 to RoleList.Count -1 do
        RoleList.Objects[i].Free;

    // Speziallfall, da cbxArcRights noch ein Element zustzlich hat.
    for i := RoleList.Count to cbxArcRights.Items.Count -1 do
        cbxArcRights.Items.Objects[i].Free;

    RoleList.Clear;  // Wichtig!
    RoleList.AddObject('', TbfaInt64.Create(0));  //25.09.2024 SD <--bfacrm:ticket__show__40032
    RoleList.AddObject(_('Recherche'), TbfaInt64.Create(rRoleSearch));
    RoleList.AddObject(_('Importer'), TbfaInt64.Create(rRoleImport));
    RoleList.AddObject(_('Standard'), TbfaInt64.Create(rRoleStandard));
    RoleList.AddObject(_('Erweitert'), TbfaInt64.Create(rRolePower));
    RoleList.AddObject(_('Admin'), TbfaInt64.Create(rRoleAdmin));

    cbxUserRole.Items.Assign(RoleList);  // Hinweis: Assign fhrt intern ein Clear aus
    cbxGroupRole.Items.Assign(RoleList);
    cbxArcRights.Items.Assign(RoleList);
//    cbxArcRights.Items.AddObject(_('Zurcksetzen'), TbfaInt64.Create(0)); //25.09.2024 SD <--bfacrm:ticket__show__40032
  except
    //21.06.2019
  end;
end;

procedure TfraAdmin.InitLinkTypes;
var
  i: integer;

begin
  for i := 0 to StateFieldFunctions.Count - 1 do
    TbfaInt64(StateFieldFunctions.Objects[i]).Free;

  StateFieldFunctions.Clear;  // Wichtig!
  StateFieldFunctions.AddObject('', TbfaInt.Create(0));
  StateFieldFunctions.AddObject(_('Uhrzeit'), TbfaInt.Create(1));
  StateFieldFunctions.AddObject(_('Datum'), TbfaInt.Create(2));
  StateFieldFunctions.AddObject(_('Zeitstempel'), TbfaInt.Create(3));
  StateFieldFunctions.AddObject(_('Benutzername'), TbfaInt.Create(4));
  StateFieldFunctions.AddObject(_('Benutzer') + ' + ' + _('Zeitstempel'), TbfaInt.Create(5));

  cbxLinkType.Items.Assign(StateFieldFunctions);  // Hinweis: Assign fhrt intern ein Clear aus
end;


procedure TfraAdmin.InitAddFieldTypes;
var
  i: integer;
begin
  for i:=0 to Addfieldtypes.Count -1 do
    TbfaInt(Addfieldtypes.Objects[i]).Free;

  Addfieldtypes.Clear;  // Wichtig!
  Addfieldtypes.AddObject(_('Universal'), TbfaInt.Create(0));
  Addfieldtypes.AddObject(_('Datum'), TbfaInt.Create(1));
  Addfieldtypes.AddObject(_('Auswahl'), TbfaInt.Create(2));
  Addfieldtypes.AddObject(_('Mehrfach-Auswahl'), TbfaInt.Create(3));
  Addfieldtypes.AddObject(_('Interval'), TbfaInt.Create(5));
  Addfieldtypes.AddObject(_('Ganzzahl'), TbfaInt.Create(6));
  Addfieldtypes.AddObject(_('Fliekomma'), TbfaInt.Create(7));
  Addfieldtypes.AddObject(_('Whrung'), TbfaInt.Create(8));
  Addfieldtypes.AddObject(_('DLM Auswahlfeld'), TbfaInt.Create(11));
  Addfieldtypes.AddObject(_('DLM Datumsfeld'), TbfaInt.Create(12));
  Addfieldtypes.AddObject(_('Grid Feld'), TbfaInt.Create(13));
  Addfieldtypes.AddObject(_('Grid Spalte'), TbfaInt.Create(14));

  cbxAddfieldType.Items.Assign(Addfieldtypes);  // Hinweis: Assign fhrt intern ein Clear aus
end;

procedure TfraAdmin.InitSearchModes;
begin
  for var i := 0 to SearchModes.Count-1 do
    TbfaInt(SearchModes.Objects[i]).Free;

  SearchModes.Clear; // Wichtig!
  SearchModes.AddObject(_('Wortanfang'), TbfaInt.Create(2));
  SearchModes.AddObject(_('Wortende'), TbfaInt.Create(1));
  SearchModes.AddObject(_('Bestandteil'), TbfaInt.Create(3));
  SearchModes.AddObject(_('Exakt'), TbfaInt.Create(0));

  cbxSearchMode.Items.Assign(SearchModes);
end;

procedure TfraAdmin.SelectorPopup(Sender: TObject);
begin
  tabctrAdmin.Toolbar.BeginUpdate;
  try
    tabctrAdmin.ActiveTabIndex := 0;
    if TObject(TTBRootItem(Sender).Tag) is TbfaUser then
    begin
      FCurrentUser := TbfaUser(TTBRootItem(Sender).Tag);
      SelectEntryByObject(bfiUser, FCurrentUser);
      ShowUserProperties(FCurrentUser);
    end
    else if TObject(TTBRootItem(Sender).Tag) is TbfaGroup then
    begin
      FCurrentGroup := TbfaGroup(TTBRootItem(Sender).Tag);
      SelectEntryByObject(bfiGroups, FCurrentGroup);
      ShowGroupProperties(FCurrentGroup);
    end
    else if TObject(TTBRootItem(Sender).Tag) is TbfaAddField then
    begin
      FCurrentAddfield := TbfaAddField(TTBRootItem(Sender).Tag);
      SelectEntryByObject(bfiAddfields, FCurrentAddfield);
      ShowAddfieldProperties(FCurrentAddfield)
    end
    else if TObject(TTBRootItem(Sender).Tag) is TbfaStatefield then
    begin
      FCurrentStateField := TbfaStatefield(TTBRootItem(Sender).Tag);
      SelectEntryByObject(bfiStatefields, FCurrentStateField);
      ShowStatefieldProperties(FcurrentStateField);
    end;
  finally
    tabctrAdmin.Toolbar.EndUpdate;
    EnableBySelect;
  end;
end;

constructor TfraAdmin.Create(AOwner: TComponent);
var
  item: TListColumn;
begin
  inherited Create(AOwner);

  tabUsermgr.Visible := {$IFDEF ENTERPRISE}True{$ELSE}False{$ENDIF}; //21.09.2023

  FPasteAllObjects := False;
  FPasteAllObjetcsMResult := mrNone;

  bfaDBGrid1 := TbfaDBGrid.Create(Self); //22.10.2019
  bitfarmApp.DrawIcons(bfsAssignAddfields);
  bitfarmApp.DrawIcons(bfsAssignStatefields);
  bitfarmApp.DrawIcons(bfsAssignUser);
  bitfarmApp.DrawIcons(bfsAddfieldsUser);
  bitfarmApp.DrawIcons(bfsStatefieldsUser);
  bitfarmApp.DrawIcons(bfsGroupsUser);
//  bitfarmApp.DrawIcons(bfsADGroups);
//  bitfarmApp.DrawIcons(bfsInferior);

  btnSaveAdmin.Images := bfaIconsDM.bfaIcons.ilMainMenu;
  btnSaveAdmin.ImageIndex := Integer(icoidx_edit);
  btnCancelAdmin.Images := bfaIconsDM.bfaIcons.ilMainMenu;
  btnCancelAdmin.ImageIndex := Integer(icoidx_abort);
  //18.07.2024 SD -->bfacrm:ticket__show__21571
  btnSaveHistoryToFile.Images := bfaIconsDM.bfaIcons.ilMainMenu;
  btnSaveHistoryToFile.ImageIndex := Integer(icoidx_files_download);
  btnSaveHistoryToFile.Hint := _('Das Protokoll speichern');
  //18.07.2024 SD <--bfacrm:ticket__show__21571

  //22.12.2021 mssen Runtime gesetzt werden -->
  with bfsGroupsUser do
  begin
    AllowChangeKind := False;
    SelectedSortable := False;
    SelectorKind := skUser;
    RejectDoubles := False;
//29.02.2024    popInfo1.OnPopup := SelectorPopup;
//29.02.2024    popInfo2.OnPopup := SelectorPopup;
    OnClickItems := SelectorPopup;
  end;
  with bfsAssignUser do
  begin
    AllowChangeKind := True;
    SelectedSortable := False;
    SelectorKind := skGroupsUser;
    RejectDoubles := False;
    OnClickItems := SelectorPopup;
  end;
  with bfsAssignAddfields do
  begin
    AllowChangeKind := False;
    SelectedSortable := True;
    SelectorKind := skNormal;
    RejectDoubles := False;
    OnClickItems := SelectorPopup;
  end;
  with bfsAddfieldsUser do
  begin
    AllowChangeKind := True;
    SelectedSortable := False;
    SelectorKind := skGroupsUser;
    RejectDoubles := False;
    OnClickItems := SelectorPopup;
  end;
  with bfsAssignStatefields do
  begin
    AllowChangeKind := False;
    SelectedSortable := True;
    SelectorKind := skNormal;
    RejectDoubles := False;
    OnClickItems := SelectorPopup;
  end;
  with bfsStatefieldsUser do
  begin
    AllowChangeKind := True;
    SelectedSortable := False;
    SelectorKind := skGroupsUser;
    RejectDoubles := False;
    OnClickItems := SelectorPopup;
  end;
//  //22.12.2021 mssen Runtime gestzt werden <--

  with bfaDBGrid1 do
  begin
    Parent := SpTBXTabSheet4;
    Left := 10;
    Top := 170;
    Width := SpTBXTabSheet4.Width - (2 * Left);
    Height := SpTBXTabSheet4.Height - 175;
    Font.Size := bfaFontSize;
    Anchors := [akLeft, akTop, akRight, akBottom];
    DataSource := dsResubSearch;
    Options := [dgTitles, dgColumnResize, dgColLines, dgRowLines, dgTabs, dgConfirmDelete, dgCancelOnExit, dgMultiSelect];
    ReadOnly := True;
    TabOrder := 1;
    TitleFont.Charset := DEFAULT_CHARSET;
    TitleFont.Color := clWindowText;
    TitleFont.Height := -11;
    TitleFont.Name := 'Tahoma';
    TitleFont.Style := [];
    OnCellClick := bfaDBGrid1CellClick;
    ChangeDelay := 250;
    Kind := gkNone;
    Userid := 0;
    WordWrap := False;
    SelectedAll := False;
    RowColorEvenOdd := bitfarmApp.ViewerOptions.GeneralOptions.RowColorEvenOdd;  // SJ 12.12.2019: bfacrm:ticket__show__20648
    Columns.Add;
    with Columns[0] do
    begin
      Expanded := False;
      FieldName := 'Termin';
      Font.Size := bfaFontSize;
      Width := 60;
      Visible := True;
    end;
    Columns.Add;
    with Columns[1] do
    begin
      Expanded := False;
      FieldName := 'Archiv';
      Font.Size := bfaFontSize;
      Width := 60;
      Visible := True;
    end;
    Columns.Add;
    with Columns[2] do
    begin
      Expanded := False;
      FieldName := 'Titel';
      Font.Size := bfaFontSize;
      Width := 60;
      Visible := True;
    end;
    Columns.Add;
    with Columns[3] do
    begin
      Expanded := False;
      FieldName := 'Info';
      Font.Size := bfaFontSize;
      Width := 60;
      Visible := True;
    end;
    Columns.Add;
    with Columns[4] do
    begin
      Expanded := False;
      FieldName := 'Bearbeiter';
      Font.Size := bfaFontSize;
      Width := 60;
      Visible := True;
    end;
    Columns.Add;
    with Columns[5] do
    begin
      Expanded := False;
      FieldName := 'Controller';
      Font.Size := bfaFontSize;
      Width := 60;
      Visible := True;
    end;
    Columns.Add;
    with Columns[6] do
    begin
      Expanded := False;
      FieldName := 'Status';
      Font.Size := bfaFontSize;
      Width := 60;
      Visible := True;
    end;
    Columns.Add;
    with Columns[7] do
    begin
      Expanded := False;
      FieldName := 'RefID';
      Font.Size := bfaFontSize;
      Width := 60;
      Visible := True;
    end;
    Columns.Add;
    with Columns[8] do
    begin
      Expanded := False;
      FieldName := 'GDOCID';
      Title.Caption := 'Gdocid';
      Font.Size := bfaFontSize;
      Width := 60;
      Visible := True;
    end;
    Columns.Add;
    with Columns[9] do
    begin
      Expanded := False;
      Width := -1;
      Visible := False;
    end;
    Columns.Add;
    with Columns[10] do
    begin
      Expanded := False;
      Width := -1;
      Visible := False;
    end;
  end;

  lvAdminLog.OnCustomDrawItem := lvAdminLogCustomDrawItem;
  lvAdminLog.RowSelect := True;

  bitfarmApp.GArchives := TList<TbfaArchive>.Create;
  bitfarmApp.GUser := TList<TbfaUser>.Create;
  bitfarmApp.GGroups := TList<TbfaGroup>.Create;
  bitfarmApp.GADGroups := TList<TbfaGroup>.Create;
  bitfarmApp.GAddfields := TList<TbfaAddField>.Create;
  bitfarmApp.GStatefields := TList<TbfaStateField>.Create;

  RoleList := TStringlist.Create;  // Global

  InitRoleList;   // ToDo: ItemIndex merken
  StateFieldFunctions := TStringList.Create;

  InitLinkTypes;  // ToDo: ItemIndex merken

  Addfieldtypes := TStringList.Create;
  InitAddfieldtypes;   // ToDo: ItemIndex merken

  SearchModes:= TStringList.Create;
  InitSearchModes; // ToDo: ItemIndex merken

  bfsAssignAddfields.SpTBXSplitter1.Color := cColorWhite;
  bfsAssignStatefields.SpTBXSplitter1.Color := cColorWhite;
  bfsAssignUser.SpTBXSplitter1.Color := cColorWhite;
  bfsAddfieldsUser.SpTBXSplitter1.Color := cColorWhite;
  bfsStatefieldsUser.SpTBXSplitter1.Color := cColorWhite;
  bfsGroupsUser.SpTBXSplitter1.Color := cColorWhite;

//  bfsInferior.SpTBXSplitter1.Color := cColorWhite;

  bfiArchives.OnChange := OnChangeArchive;
  bfiRepos.OnChange := OnChangeRepos;
  bfiAddfields.OnChange := OnChangeAddfield;
  bfiStatefields.OnChange := OnChangeStatefield;
  bfiUser.OnChange := OnChangeUser;
  bfiGroups.OnChange := OnChangeGroup;

  bfiArchives.OnDropDown := frmMainForm.OnComboDropDown;
  bfiRepos.OnDropDown := frmMainForm.OnComboDropDown;
  bfiAddfields.OnDropDown := bfiAddfieldsDropDown;
  bfiStatefields.OnDropDown := frmMainForm.OnComboDropDown;
  bfiUser.OnDropDown := frmMainForm.OnComboDropDown;
  bfiGroups.OnDropDown := frmMainForm.OnComboDropDown;

  cbxAddfieldType.OnDropDown := frmMainForm.OnComboDropDown;
  cbxSearchMode.OnDropDown := frmMainForm.OnComboDropDown;
  cbxStatefieldLink.OnDropDown := frmMainForm.OnComboDropDown;
  cbxLinkType.OnDropDown := frmMainForm.OnComboDropDown;
  cbxUserRole.OnDropDown := frmMainForm.OnComboDropDown;
  cbxGroupRole.OnDropDown := frmMainForm.OnComboDropDown;
  cbxArcRights.OnDropDown := frmMainForm.OnComboDropDown;
//  cbxHolidayUser.OnDropDown := frmMainForm.OnComboDropDown;
//  cbxReplacement.OnDropDown := frmMainForm.OnComboDropDown;
//  cbxSuperior.OnDropDown := frmMainForm.OnComboDropDown;
  cbxResubUser.OnDropDown := frmMainForm.OnComboDropDown;
  cbxResubSearchMode.OnDropDown := frmMainForm.OnComboDropDown;
  cbxLogUser.OnDropDown := frmMainForm.OnComboDropDown;

  bfiArchives.OnCloseUp := frmMainForm.OnComboCloseUp;
  bfiRepos.OnCloseUp := frmMainForm.OnComboCloseUp;
  bfiAddfields.OnCloseUp := frmMainForm.OnComboCloseUp;
  bfiStatefields.OnCloseUp := frmMainForm.OnComboCloseUp;
  bfiUser.OnCloseUp := frmMainForm.OnComboCloseUp;
  bfiGroups.OnCloseUp := frmMainForm.OnComboCloseUp;

  bfiAddfields.OnDouble := frmMainForm.OnComboDouble;
  bfiStatefields.OnDouble := frmMainForm.OnComboDouble;
  bfiUser.OnDouble := frmMainForm.OnComboDouble;
  bfiGroups.OnDouble := frmMainForm.OnComboDouble;

  bfsAssignAddfields.OnSelectedSorted := OnSelectedSortedAddfields;
  bfsAssignStatefields.OnSelectedSorted := OnSelectedSortedStatefields;

  cbxAddfieldType.OnCloseUp := frmMainForm.OnComboCloseUp;
  cbxSearchMode.OnCloseUp := frmMainForm.OnComboCloseUp;
  cbxStatefieldLink.OnCloseUp := frmMainForm.OnComboCloseUp;
  cbxLinkType.OnCloseUp := frmMainForm.OnComboCloseUp;
  cbxUserRole.OnCloseUp := frmMainForm.OnComboCloseUp;
  cbxGroupRole.OnCloseUp := frmMainForm.OnComboCloseUp;
  cbxArcRights.OnCloseUp := frmMainForm.OnComboCloseUp;
  cbxResubUser.OnCloseUp := frmMainForm.OnComboCloseUp;
  cbxResubSearchMode.OnCloseUp := frmMainForm.OnComboCloseUp;
  cbxLogUser.OnCloseUp := frmMainForm.OnComboCloseUp;

  dtResubDate.Properties.OnPopup := frmMainForm.OnComboDropDown;
  dtResubDate.Properties.OnCloseUp := frmMainForm.OnComboCloseUp;
  dtResubDate.Properties.InputKind := ikRegExpr;
  dtResubDate.Properties.EditFormat := FormatSettings.ShortDateFormat;

  dtDateLogStart.Properties.OnPopup := frmMainForm.OnComboDropDown;
  dtDateLogStart.Properties.OnCloseUp := frmMainForm.OnComboCloseUp;
  dtDateLogStart.Properties.InputKind := ikRegExpr;
  dtDateLogStart.Properties.EditFormat := FormatSettings.ShortDateFormat;

  dtDateLogEnd.Properties.OnPopup := frmMainForm.OnComboDropDown;
  dtDateLogEnd.Properties.OnCloseUp := frmMainForm.OnComboCloseUp;
  dtDateLogEnd.Properties.InputKind := ikRegExpr;
  dtDateLogEnd.Properties.EditFormat := FormatSettings.ShortDateFormat;

  bfsAssignUser.OnSelectSelected := OnSelectArchiveUser;
  bfsAssignUser.OnSelectedEmpty := OnSelectedEmptyArchiveUser;
  bfsAssignUser.OnDeselect := OnDeselectArchiveUser;

  bfsAssignAddfields.OnSelectSelected := OnSelectAddfield;
  bfsAssignStatefields.OnSelectSelected := OnSelectStatefield;

  bfsAddfieldsUser.OnSelectSelected := OnSelectAddfieldUser;
  bfsAddfieldsUser.OnSelectedEmpty := OnSelectedEmptyAddfieldUser;
  bfsAddfieldsUser.OnDeselect := OnDeselectAddfieldsUser;

  bfsStatefieldsUser.OnSelectSelected := OnSelectStatefieldUser;
  bfsStatefieldsUser.OnSelectedEmpty := OnSelectedEmptyStatefieldUser;
  bfsStatefieldsUser.OnDeselect := OnDeselectStatefieldUser;

  bfsGroupsUser.OnAddToSelected := OnAddGroupsUser;
  bfsGroupsUser.OnRemoveFromSelected := OnRemoveGroupsUser;

  bfsAssignUser.OnAddToSelected := OnAddAssignUser;
  bfsAssignUser.OnRemoveFromSelected := OnRemoveAssignUser;

  bfsAssignAddfields.OnAddToSelected := OnAddAssignFields;
  bfsAssignAddfields.OnRemoveFromSelected := OnRemoveAssignFields;
  bfsAssignAddfields.OnDeselect := OnDeselectAddfield;

  bfsAssignStatefields.OnAddToSelected := OnAddAssignFields;
  bfsAssignStatefields.OnRemoveFromSelected := OnRemoveAssignFields;
  bfsAssignStatefields.OnDeselect := OnDeselectStatefield;

  bfsAddfieldsUser.OnAddToSelected := OnAddAddfieldUser;
  bfsAddfieldsUser.OnRemoveFromSelected := OnRemoveAddfieldUser;

  bfsStatefieldsUser.OnAddToSelected := OnAddStateFieldUser;
  bfsStatefieldsUser.OnRemoveFromSelected := OnRemoveStatefieldUser;

  FArcidMax := -1;
  FAddfieldidMax := -1;
  FStatefieldidMax := -1;
  FUseridMax := -1;
  FGroupidMax := -1;

  FAdminLogOffset := 0;

  sEnvRoot := getenvironmentvariable('systemroot');
  sDsQueryExe := sEnvRoot + '\system32\dsquery.exe';
  sDsGetExe := sEnvRoot + '\system32\dsget.exe';
  sEnvTemp := BD.EnvTemp;

  mqResubSearch.Connection := MainDataModule.dmMain.cntMain;

  frmContractMgmt := TfrmContractMgmt.Create(Self);
  frmDLMDialog := TfrmDLM.Create(Self);

  cbxResubSearchMode.ItemIndex := 0;

  FprevIndex := -1;

  FUserClickedApplyJustToSave := False;
//
////  11.02.2022 Ticket 15897 -->
//  FSkipCheck := False;
//  FDisableCheck := False;
//  FOldADGroupsLVProc := bfsADGroups.lvList2.WindowProc;
//  bfsADGroups.lvList2.WindowProc := ADGroupsWndProc;
//  bfsADGroups.lvList2.PopupMenu := popADGroupsList2;
////  11.02.2022 Ticket 15897 <--
//
  Intervals := TStringList.Create;
  Intervals.CommaText := ',d,w,m,y';
  cbxInterval.ItemIndex := 0;
  tabAssign.Options := tabAssign.Options + [tboNoAutoHint];
  tabGlobale.Options := tabGlobale.Options + [tboNoAutoHint];
  tabLog.Options := tabLog.Options + [tboNoAutoHint];
  tabResub.Options := tabResub.Options + [tboNoAutoHint];

  bfiRepos.cbbInput.MaxLength := 80;
  bfiArchives.cbbInput.MaxLength := 80;
  bfiAddfields.cbbInput.MaxLength := 64;
  bfiStatefields.cbbInput.MaxLength := 64;
  bfiUser.cbbInput.MaxLength := 64;
  bfiGroups.cbbInput.MaxLength := 64;

  try
    TranslateComponent(Self, 'ViewerV36');
  except

  end;
end;

//11.02.2022 Ticket 15897 -->
//procedure TfraAdmin.ADGroupsCheckbox(Litem : TListItem; chk : Boolean);
//begin
  //if not bfsADGroups.SkipChecking then
  //begin
    //FSkipCheck := True;
    //try
      //11.02.2022 Muss so bleiben Litem.Checked := chk; funktioniert hier nicht!
      //if chk then
        //Litem.Checked := False
      //else
        //Litem.Checked := True;
    //finally
      //FSkipCheck := False;
    //end;
  //end;
//end;
//
//procedure TfraAdmin.ADGroupsWndProc(var Message: TMessage);
//var
//   listItem : TListItem;
//   chk : Boolean;
//begin
//  if (Message.Msg = CN_NOTIFY) and (not FDisableCheck) then
//  begin
//    if PNMHdr(Message.LParam)^.Code = LVN_ITEMCHANGED then
//    begin
//      with PNMListView(Message.LParam)^ do
//      begin
//        if (uChanged and LVIF_STATE) <> 0 then
//        begin
//          if ((uOldState and LVIS_STATEIMAGEMASK) shr 12) <>
//              ((uNewState and LVIS_STATEIMAGEMASK) shr 12) then
//          begin
//            if not FSkipCheck then
//            begin
//              listItem := bfsADGroups.lvList2.Items[iItem];
//              chk := ListItem.Checked;
//              ADGroupsCheckbox(listItem, chk);
//            end;
//          end;
//        end;
//      end;
//    end;
//  end;
//  FOldADGroupsLVProc(Message);
//end;
//11.02.2022 Ticket 15897 <--

procedure TfraAdmin.Retranslate;
begin
  InitRoleList;
  InitLinkTypes;
  InitAddFieldTypes;
  InitSearchModes;
end;

procedure TfraAdmin.CreateArchiveReport(showfields, showuser, showdlm: Boolean);
var
  lmq : TUniQuery;
  sArchives, options : TStringList;
  lifecycle : string;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateArchiveReport', ClassName);
  try
    try
      lmq := DbCreateQuery;
      sArchives := TStringList.Create;
      options := TStringList.Create;

      if showdlm then
      begin
        sArchives.Add(_('DLM aktive Felder (in absteigender Prioritt)'));
        getDLMFields(0, sArchives, True);

        sArchives.Add('');
        sArchives.Add('');
        sArchives.Add('--------------------------------------------------------');
      end;

      lmq.SQL.Text := 'SELECT a.arcid, a.lgrid, a.arcname as aname, a.tblname, a.flags, a.backpic, a.type, a.options, a.defdocname, a.storageid, a.duration, a.`interval`, b.arcname as bname ' +
                      'FROM sys_arc as a left join sys_arc as b on a.lgrid = b.arcid where a.type = 1 and a.flags & 1 = 1 order by a.arcname asc';
      lmq.Execute;
      if lmq.RecordCount > 0 then
      begin
        lmq.First;
        while not lmq.Eof do
        begin
          sArchives.Add(_('Archiv: ') + lmq.FieldByName('aname').AsWideString);
          sArchives.Add(_('Lager: ') + lmq.FieldByName('bname').AsWideString);
          sArchives.Add(_('Storage-ID: ') + lmq.FieldByName('storageid').AsWideString);
          if lmq.FieldByName('options').AsInteger > 0 then
          begin
            options.Clear;
            if lmq.FieldByName('options').AsInteger and 1 = 1 then
              options.Add(_('Titelpflicht'));

            if lmq.FieldByName('options').AsInteger and 2 = 2 then
              options.Add(_('Titel wie Archivname'));

            if lmq.FieldByName('options').AsInteger and 4 = 4 then
              options.Add(_('Plugin aktiv'));

            sArchives.Add(_('Optionen: ' + options.CommaText));

          end;

          if lmq.FieldByName('defdocname').AsWideString <> '' then
            sArchives.Add(_('Standard Dokumentenname: ') + lmq.FieldByName('defdocname').AsWideString);

          if lmq.FieldByName('backpic').AsWideString <> '' then
            sArchives.Add(_('Briefpapier: ') + lmq.FieldByName('backpic').AsWideString);

          if showuser then
          begin
            sArchives.Add('');
            sArchives.Add(_('Zugeodnete Benutzer und Gruppen:'));

            getUserAndGroups(lmq.FieldByName('arcid').AsInteger, sArchives);
          end;

          if showfields then
          begin
            sArchives.Add('');
            sArchives.Add(_('Zugeodnete Zusatz und Statusfelder:'));

            getFieldsAndStates(lmq.FieldByName('arcid').AsInteger, sArchives);
          end;

          if showdlm then
          begin
            sArchives.Add('');
            sArchives.Add(_('Konfiguration Document Lifecycle:'));

            if lmq.FieldByName('duration').AsInteger > 0 then
            begin
              if lmq.FieldByName('interval').AsString = 'd' then
                if lmq.FieldByName('duration').AsInteger = 1 then
                  lifecycle := _('Tag')
                else
                  lifecycle := _('Tage');

              if lmq.FieldByName('interval').AsString = 'w' then
                if lmq.FieldByName('duration').AsInteger = 1 then
                  lifecycle := _('Woche')
                else
                  lifecycle := _('Wochen');

              if lmq.FieldByName('interval').AsString = 'm' then
                if lmq.FieldByName('duration').AsInteger = 1 then
                  lifecycle := _('Monat')
                else
                  lifecycle := _('Monate');

              if lmq.FieldByName('interval').AsString = 'y' then
                if lmq.FieldByName('duration').AsInteger = 1 then
                  lifecycle := _('Jahr')
                else
                  lifecycle := _('Jahre');
              sArchives.Add(_('   Standard Lebensdauer: ' + lmq.FieldByName('duration').AsString + ' ' + lifecycle));
            end;

            getDLMFields(lmq.FieldByName('arcid').AsInteger, sArchives);

          end;

          sArchives.Add('');
          sArchives.Add('');
          sArchives.Add('--------------------------------------------------------');

          lmq.Next;
        end;
      end;

      if sArchives.Count > 0 then
        SaveReport('Archivbersicht', sArchives);

    except
        on e: exception do
          bitfarmLog.Write(llNormal, ltException, 'CreateArchiveReport' + e.Message, ClassName);
    end;
  finally
    lmq.Free;
    bitfarmLog.DebugEnd(llDebug, 'CreateArchiveReport', ClassName);
  end;
end;

procedure TfraAdmin.CreateGroupReport;
var
  qrygrp: TUniQuery;
  sList: TStringList;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateGroupReport', ClassName);
  try
    try
      qrygrp := TUniQuery.Create(nil);
      sList := TStringList.Create;
      try
        qrygrp.Connection := dmMain.cntMain;

        qrygrp.SQL.Text := 'SELECT groupid, email, groupname,' +
          'IF(flags & 4 = 4, '+#39+'True'+#39+', '+#39+'False'+#39+') as IsAD, role+0 as rights, adpath ' +
          'FROM sys_group where FIND_IN_SET(' + #39 + 'enabled' + #39 + ',Flags) > 0 order by groupname, groupid';
        qrygrp.Execute;
        if qrygrp.RecordCount > 0 then
        begin
          qrygrp.First;
          while not qrygrp.Eof do
          begin
//13.09.2024            getGroupDetails(qrygrp.FieldByName('groupid').AsInteger, qrygrp.FieldByName('groupname').AsString,
            getGroupDetails(qrygrp.FieldByName('groupid').AsInteger,  bitfarmApp.TranslateGroupName(qrygrp.FieldByName('groupname').AsString),
                qrygrp.FieldByName('email').AsString, qrygrp.FieldByName('IsAD').AsBoolean,
                qrygrp.FieldByName('adpath').AsString, qrygrp.FieldByName('rights').AsInteger, sList);
            sList.Add('');
            sList.Add('');
            sList.Add('--------------------------------------------------------');
            qrygrp.Next;
          end;
          qrygrp.Close;

          if sList.Count > 0 then
            saveMemberShip('Alle_Gruppen', sList, True);
        end;
      finally
        FreeAndNil(qrygrp);
        FreeAndNil(sList);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'CreateGroupReport', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateGroupReport', ClassName);
  end;
end;

procedure TfraAdmin.CreateUserReport;
var
  qryusr: TUniQuery;
  sMembers: TStringList;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateUserReport', ClassName);
  try
    try
      qryusr := TUniQuery.Create(nil);
      sMembers := TStringList.Create;
      try
        qryusr.Connection := dmMain.cntMain;

        qryusr.SQL.Text := 'select userid from sys_user where FIND_IN_SET(' +
          #39 + 'enabled' + #39 + ',Flags) > 0 order by displayname, username';
        qryusr.Execute;
        if qryusr.RecordCount > 0 then
        begin
          qryusr.First;
          while not qryusr.Eof do
          begin
            getMembership(qryusr.FieldByName('userid').AsInteger, sMembers);
            sMembers.Add('');
            sMembers.Add('');
            sMembers.Add('--------------------------------------------------------');
            qryusr.Next;
          end;
          qryusr.Close;

          if sMembers.Count > 0 then
            saveMemberShip('Alle_Benutzer', sMembers);
        end;
      finally
        FreeAndNil(qryusr);
        FreeAndNil(sMembers);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'CreateUserReport', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateUserReport', ClassName);
  end;
end;

//27.06.2024 SD -->bfacrm:ticket__show__39119
procedure TfraAdmin.CreateListUsersReport;
var
  qryusr: TUniQuery;
  sMembers: TStringList;
  sItem, sFlags: String;
  aFlags: array of String;
  i, j, maxName, maxDName, maxMail, maxFlags, qSpace: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateListUsersReport', ClassName);
  try
    try
      qryusr := TUniQuery.Create(nil);
      sMembers := TStringList.Create;
      try
        qryusr.Connection := dmMain.cntMain;

        qryusr.SQL.Text := 'select userid, username, displayname, flags, usermail from sys_user where (FIND_IN_SET(' + #39 + 'enabled' +
          #39 + ',Flags) > 0) and (username <> ' + #39 + 'DMSAdmin' + #39 + ') and (username <> ' + #39 + 'system' + #39 +    //18.07.2024 SD <--bfacrm:ticket__show__39119
          ') order by displayname, username';
        qryusr.Execute;
        if qryusr.RecordCount > 0 then
        begin
          maxName := 4;
          maxDName := 12;
          maxMail := 6;
          maxFlags := 5;
          qryusr.First;
          while not qryusr.Eof do
          begin
            if Length(qryusr.FieldByName('username').AsString) > maxName then
              maxName := Length(qryusr.FieldByName('username').AsString);
            if Length(qryusr.FieldByName('displayname').AsString) > maxDName then
              maxDName := Length(qryusr.FieldByName('displayname').AsString);
            if Length(qryusr.FieldByName('usermail').AsString) > maxMail then
              maxMail := Length(qryusr.FieldByName('usermail').AsString);
            sFlags := '';
            if Pos('admin', qryusr.FieldByName('flags').AsString) > 0 then
              sFlags := _('Administrator');
            if Pos('from_ad', qryusr.FieldByName('flags').AsString) > 0 then
            begin
              if sFlags <> '' then sFlags := sFlags + ',';
              sFlags := sFlags + _('AD-Benutzer');
            end;
            if Pos('superior', qryusr.FieldByName('flags').AsString) > 0 then
            begin
              if sFlags <> '' then sFlags := sFlags + ',';
              sFlags := sFlags + _('Vorgesetzter');
            end;
            if Pos('concurrent', qryusr.FieldByName('flags').AsString) > 0 then
            begin
              if sFlags <> '' then sFlags := sFlags + ',';
              sFlags := sFlags + _('Gleichzeitiger Benutzer');
            end;
            if Length(sFlags) > maxFlags then
              maxFlags := Length(sFlags);
            SetLength(aFlags, Length(aFlags) + 1);
            aFlags[Length(aFlags) - 1] := sFlags;

            qryusr.Next;
          end;

          sItem := _('Name');
          qSpace := maxName - (Length(sItem) - 1);
          for i := 0 to qSpace do sItem := sItem + ' ';
          sItem := sItem + _('Display Name');
          qSpace := maxDName - (Length(_('Display Name')) - 1);
          for i := 0 to qSpace do sItem := sItem + ' ';
          sItem := sItem + _('E-mail');
          qSpace := maxMail - (Length(_('E-mail')) - 1);
          for i := 0 to qSpace do sItem := sItem + ' ';
          sItem := sItem + _('Flags');
          sMembers.Add(sItem);
          sItem := '';
          for i := 0 to maxName + maxDName + maxMail + maxFlags + 3 do sItem := sItem + '=';
          sMembers.Add(sItem);

          j := 0;
          qryusr.First;
          while not qryusr.Eof do
          begin
            sItem := qryusr.FieldByName('username').AsString;
            qSpace := maxName - Length(qryusr.FieldByName('username').AsString) + 1;
            for i := 0 to qSpace do sItem := sItem + ' ';
            sItem := sItem + qryusr.FieldByName('displayname').AsString;
            qSpace := maxDName - Length(qryusr.FieldByName('displayname').AsString) + 1;
            for i := 0 to qSpace do sItem := sItem + ' ';
            sItem := sItem + qryusr.FieldByName('usermail').AsString;
            sFlags := aFlags[j];
            if sFlags <> '' then
            begin
              qSpace := maxMail - Length(qryusr.FieldByName('usermail').AsString) + 1;
              for i := 0 to qSpace do sItem := sItem + ' ';
              sItem := sItem + sFlags;
            end;
            sMembers.Add(sItem);
            inc(j);
            qryusr.Next;
          end;

          sItem := '';
          for i := 0 to maxName + maxDName + maxMail + maxFlags + 3 do sItem := sItem + '-';
          sMembers.Add(sItem);
          sItem := _('Anzahl der Benutzer: ') + IntToStr(Length(aFlags));
          sMembers.Add(sItem);

          qryusr.Close;

          if sMembers.Count > 0 then
            saveMemberShip(_('Benutzerliste'), sMembers);
        end;
      finally
        FreeAndNil(qryusr);
        FreeAndNil(sMembers);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'CreateListUsersReport', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateListUsersReport', ClassName);
  end;
end;
//27.06.2024 SD <--bfacrm:ticket__show__39119

//25.07.2024 SD -->bfacrm:ticket__show__39458
procedure TfraAdmin.CreatePropertiesUsersReportCSV;
var
  qryusr, qryusrgrp: TUniQuery;
  sMembers, param: TStringList;
  sItem, sFlags, sGroups: String;
  aFlags, aGroups: array of String;
  i, j, maxName, maxDName, maxMail, maxFlags, qSpace: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreatePropertiesUsersReportCSV', ClassName);
  try
    try
      qryusr := TUniQuery.Create(nil);
      qryusrgrp := TUniQuery.Create(nil);
      sMembers := TStringList.Create;
      try
        qryusrgrp.Connection := dmMain.cntMain;
        qryusrgrp.SQL.Text := 'select gu.userid, gu.groupid, g.groupname as groupname from sys_groupuser as gu join sys_group as g on g.groupid = gu.groupid where FIND_IN_SET(' + #39 + 'enabled' + #39 + ',g.Flags) > 0';
        qryusrgrp.Execute;

        qryusr.Connection := dmMain.cntMain;
        qryusr.SQL.Text := 'select u.userid, u.username, u.displayname, u.flags, u.usermail, max(h.tstamp) as tstamp,'  + #39 + '' + #39 + 'as usrgrp from sys_user as u left join sys_history as h on u.userid = h.userid where (FIND_IN_SET(' + #39 + 'enabled' +
          #39 + ',u.Flags) > 0) and (u.username <> ' + #39 + 'DMSAdmin' + #39 + ') and (u.username <> ' + #39 + 'system' + #39 +
          ') group by u.userid order by u.displayname, u.username';

        qryusr.Execute;
        if qryusr.RecordCount > 0 then
        begin
          maxName := 4;
          maxDName := 12;
          maxMail := 6;
          maxFlags := 5;
          qryusr.First;
          while not qryusr.Eof do
          begin
            if Length(qryusr.FieldByName('username').AsString) > maxName then
              maxName := Length(qryusr.FieldByName('username').AsString);
            if Length(qryusr.FieldByName('displayname').AsString) > maxDName then
              maxDName := Length(qryusr.FieldByName('displayname').AsString);
            if Length(qryusr.FieldByName('usermail').AsString) > maxMail then
              maxMail := Length(qryusr.FieldByName('usermail').AsString);

            sGroups := '';
            qryusrgrp.First;
            while not qryusrgrp.Eof do
            begin
              if qryusrgrp.FieldByName('userid').AsInteger = qryusr.FieldByName('userid').AsInteger then
              begin
                if sGroups <> '' then
                  sGroups := sGroups + ', ';
//13.09.2024                sGroups := sGroups + qryusrgrp.FieldByName('groupname').AsString;
                sGroups := sGroups +  bitfarmApp.TranslateGroupName(qryusrgrp.FieldByName('groupname').AsString);
              end;
              qryusrgrp.Next;
            end;
            SetLength(aGroups, Length(aGroups) + 1);
            aGroups[Length(aGroups) - 1] := sGroups;

            sFlags := '';
            if Pos('admin', qryusr.FieldByName('flags').AsString) > 0 then
              sFlags := _('Administrator');
            if Pos('from_ad', qryusr.FieldByName('flags').AsString) > 0 then
            begin
              if sFlags <> '' then sFlags := sFlags + ',';
              sFlags := sFlags + _('AD-Benutzer');
            end;
            if Pos('superior', qryusr.FieldByName('flags').AsString) > 0 then
            begin
              if sFlags <> '' then sFlags := sFlags + ',';
              sFlags := sFlags + _('Vorgesetzter');
            end;
            if Pos('concurrent', qryusr.FieldByName('flags').AsString) > 0 then
            begin
              if sFlags <> '' then sFlags := sFlags + ',';
              sFlags := sFlags + _('Gleichzeitiger Benutzer');
            end;
            if Length(sFlags) > maxFlags then
              maxFlags := Length(sFlags);
            SetLength(aFlags, Length(aFlags) + 1);
            aFlags[Length(aFlags) - 1] := sFlags;

            qryusr.Next;
          end;

//          sItem := '';
          sItem := #34 + _('Name') + #34 + ';';
//          qSpace := maxName - (Length(sItem) - 1);
//          for i := 0 to qSpace do sItem := sItem + ' ';
          sItem := sItem + #34 + _('Display Name') + #34 + ';';
//          qSpace := maxDName - (Length(_('Display Name')) - 1);
//          for i := 0 to qSpace do sItem := sItem + ' ';
          sItem := sItem + #34 + _('E-mail') + #34 + ';';
//          qSpace := maxMail - (Length(_('E-mail')) - 1);
//          for i := 0 to qSpace do sItem := sItem + ' ';
          sItem := sItem + #34 + _('Letzte Aktivitt') + #34 + ';';
//          qSpace := maxMail - (Length(_('Letzter Anmeldung')) - 1);
//          for i := 0 to qSpace do sItem := sItem + ' ';
          sItem := sItem + #34 + _('Gruppen') + #34 + ';';
//          qSpace := maxMail - (Length(_('Letzter Anmeldung')) - 1);
//          for i := 0 to qSpace do sItem := sItem + ' ';
          sItem := sItem + #34 + _('Flags') + #34 + ';';
          sMembers.Add(sItem);
//          sItem := '';
//          for i := 0 to maxName + maxDName + maxMail + maxFlags + 3 do sItem := sItem + '=';
//          sMembers.Add(sItem);

          j := 0;
          qryusr.First;
          while not qryusr.Eof do
          begin
            sItem := #34 + qryusr.FieldByName('username').AsString + #34 + ';';
//            qSpace := maxName - Length(qryusr.FieldByName('username').AsString) + 1;
//            for i := 0 to qSpace do sItem := sItem + ' ';
            sItem := sItem + #34 + qryusr.FieldByName('displayname').AsString + #34 + ';';
//            qSpace := maxDName - Length(qryusr.FieldByName('displayname').AsString) + 1;
//            for i := 0 to qSpace do sItem := sItem + ' ';
            sItem := sItem + #34 + qryusr.FieldByName('usermail').AsString + #34 + ';';
//            qSpace := maxMail - Length(qryusr.FieldByName('usermail').AsString) + 1;
//            for i := 0 to qSpace do sItem := sItem + ' ';

//            sItem := sItem + #34 + sGroups + #34 + ';';
//            sItem := sItem + #34 + qryusr.FieldByName('tstamp').AsString + #34 + ';';
            if qryusr.FieldByName('tstamp').AsDateTime = 0 then
              sItem := sItem + #34 + #34 + ';'
            else
              sItem := sItem + #34 + FormatDateTime('yyyy.mm.dd hh.mm.ss', qryusr.FieldByName('tstamp').AsDateTime) + #34 + ';';
//            sItem := sItem + #34 + qryusr.FieldByName('tstamp').AsString + #34 + ';';

//            qSpace := maxMail - Length(qryusr.FieldByName('usermail').AsString) + 1;
//            for i := 0 to qSpace do sItem := sItem + ' ';
            sGroups := aGroups[j];
            if sGroups = '' then
              sItem := sItem + #34 + #34 + ';'
            else
            begin
//              qSpace := maxMail - Length(qryusr.FieldByName('tstamp').AsString) + 1;
//              for i := 0 to qSpace do sItem := sItem + ' ';
              sItem := sItem + #34 + sGroups + #34 + ';';
            end;

//            sItem := sItem + #34 + qryusr.FieldByName('usrgrp').AsString + #34 + ';';
            sFlags := aFlags[j];
            if sFlags <> '' then
            begin
//              qSpace := maxMail - Length(qryusr.FieldByName('tstamp').AsString) + 1;
//              for i := 0 to qSpace do sItem := sItem + ' ';
              sItem := sItem + #34 + sFlags + #34 + ';';
            end;
            sMembers.Add(sItem);
            inc(j);
            qryusr.Next;
          end;

//          sItem := '';
//          for i := 0 to maxName + maxDName + maxMail + maxFlags + 3 do sItem := sItem + '-';
//          sMembers.Add(sItem);
          sItem := #34 + _('Anzahl der Benutzer: ') + IntToStr(Length(aFlags)) + #34 + ';;;;;';
          sMembers.Add(sItem);

          qryusr.Close;
          qryusrgrp.Close;

          if sMembers.Count > 0 then
            saveReportCSV(_('Benutzereigenschaften'), sMembers);

        end;
      finally
        FreeAndNil(qryusr);
        FreeAndNil(qryusrgrp);
        FreeAndNil(sMembers);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'CreatePropertiesUsersReportCSV', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreatePropertiesUsersReportCSV', ClassName);
  end;
end;
//25.07.2024 SD <--bfacrm:ticket__show__39458

function TfraAdmin.DBAddGroup(AValue: WideString; AObject: TObject): Int64;
var
  group: TbfaGroup;
begin

  if AValue <> '' then
  begin
    Inc(FGroupidMax);
    group := TbfaGroup.Create;
    group.Name := AValue;
    group.ID := FGroupidMax;
    group.Flags := 1;
    group.Modified := True;
    group.ADPath := TBfaADObject(AObject).Typ + ': ' + TBfaADObject(AObject).Ldap;
    bitfarmApp.GGroups.Add(group);

    SetModified;
  end;
end;

function TfraAdmin.DbAddUser(Name, Mail, Pass, DispName: string; Enabled, isAd: Boolean): integer;
var
  user: TbfaUser;
begin

  if Name <> '' then
  begin
    Inc(FUseridMax);
    user := TbfaUser.Create;
    user.Name := Name;
    user.DisplayName := DispName;
    user.ID := FUseridMax;
    user.Flags := 5;
    user.Email := Mail;

    user.Modified := True;

    bitfarmApp.GUser.Add(user);

    SetModified;
  end;
end;

procedure TfraAdmin.DbAddUserToGroup(UserName, GroupName: string);
var
  i, j : Integer;
begin

  for i := 0 to bitfarmApp.GGroups.Count -1 do
  begin
    if bitfarmApp.GGroups[i].Name = GroupName then
    begin
      for j := 0 to bitfarmApp.GUser.Count -1 do
      begin
        if bitfarmApp.GUser[j].Name = UserName then
        begin
           if bitfarmApp.GGroups[i].Members.IndexOf(IntToStr(bitfarmApp.GUser[j].ID)) = -1 then
           begin
             bitfarmApp.GGroups[i].Members.Add(IntToStr(bitfarmApp.GUser[j].ID));
             bitfarmApp.GGroups[i].Modified := True;
             SetModified;
             Break;
           end;
        end;
      end;
    end;
  end;
end;

procedure TfraAdmin.DbDelUserFromGroup(UserName, GroupName: string);
var
  i, j, idx : Integer;
begin

  for i := 0 to bitfarmApp.GGroups.Count -1 do
  begin
    if bitfarmApp.GGroups[i].Name = GroupName then
    begin
      for j := 0 to bitfarmApp.GUser.Count -1 do
      begin
        if bitfarmApp.GUser[j].Name = UserName then
        begin
           if bitfarmApp.GGroups[i].Members.IndexOf(IntToStr(bitfarmApp.GUser[j].ID)) > -1 then
           begin
             idx := bitfarmApp.GGroups[i].Members.IndexOf(IntToStr(bitfarmApp.GUser[j].ID));
             bitfarmApp.GGroups[i].Members.Delete(idx);
             bitfarmApp.GGroups[i].Modified := True;
             SetModified;
             Break;
           end;
        end;
      end;
    end;
  end;
end;

procedure TfraAdmin.DbDelUserName(Name: string; NurAd: Boolean);
var
  i : Integer;
begin
  for i := 0 to bitfarmApp.GUser.Count -1 do
  begin
    if (bitfarmApp.GUser[i].Name = Name) and (bitfarmApp.GUser[i].Flags and 4 = 4) then
    begin
       bitfarmApp.GUser[i].Flags := bitfarmApp.GUser[i].Flags or 2;
       bitfarmApp.GUser[i].Modified := True;
       SetModified;
       Break;
    end;
  end;
end;

procedure TfraAdmin.DbUserUpdateMail(Name, Mail, DispName: string; isAd: Boolean);
var
  i : Integer;
begin

  for i := 0 to bitfarmApp.GUser.Count -1 do
  begin
    if (bitfarmApp.GUser[i].Name = Name) then
    begin
      if (LowerCase(bitfarmApp.GUser[i].Email) <> LowerCase(Mail)) then
      begin
        bitfarmApp.GUser[i].Email := Mail;
        bitfarmApp.GUser[i].Modified := True;
        SetModified;
      end;

      if (LowerCase(bitfarmApp.GUser[i].DisplayName) <> LowerCase(DispName)) then
      begin
        bitfarmApp.GUser[i].DisplayName := DispName;
        bitfarmApp.GUser[i].Modified := True;
        SetModified;
      end;
      Break;
    end;
  end;
end;

//procedure TfraAdmin.DeleteFromHolidayList(holid: WideString);
//var
  //i : Integer;
//begin
  //for i := 0 to lvHoliday.Items.Count -1 do
  //begin
    //if lvHoliday.Items[i].SubItems[3] = holid then
    //begin
      //lvHoliday.Items[i].Delete;
      //Break;
    //end;
  //end;
//end;

destructor TfraAdmin.Destroy;
begin
  try
    if frmDLMDialog <> nil then
      frmDLMDialog.Release;
  finally
    frmDLMDialog := nil;
  end;

//  FreeAndNil(slAdUser);
//  FreeAndNil(slAdMail);
//  FreeAndNil(slAdDispName);
//  FreeAndNil(slAddAdGroup);
//  FreeAndNil(slAdMemberOf);
//  FreeAndNil(slRemoveADGroup);
//  FreeAndNil(ADsHelper);
  FreeAndNil(RoleList);
  FreeAndNil(StateFieldFunctions);
  FreeAndNil(Addfieldtypes);
  FreeAndNil(SearchModes);
//  FreeAndNil(slAddHoliday);
//  FreeAndNil(slModifyHoliday);
//  FreeAndNil(slDeleteHoliday);
//  DeleteCriticalSection(CriticalX);
  inherited Destroy;
end;

//procedure TfraAdmin.dtDateEndPropertiesEditValueChanged(Sender: TObject);
//begin
    //if dtDateEnd.Date < dtDateStart.Date  then
    //dtDateStart.Date := dtDateEnd.Date;
//end;

//procedure TfraAdmin.dtDateStartPropertiesEditValueChanged(Sender: TObject);
//begin
  //if dtDateStart.Date > dtDateEnd.Date then
    //dtDateEnd.Date := dtDateStart.Date;
//end;

//procedure TfraAdmin.AddToHolidayList(user, repl, datestart, dateend: WideString);
//var
  //item : TListItem;
//begin
  //item := lvHoliday.Items.Insert(0);
  //item.Caption := user;
  //item.SubItems.Add(repl);
  //item.SubItems.Add(datestart);
  //item.SubItems.Add(dateend);
  //item.SubItems.Add('-1');
//end;

procedure TfraAdmin.AdminTreeDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  AnItem: TTreeNode;
  AttachMode: TNodeAttachMode;
  HT: THitTests;
  childarc : TbfaArchive;
  id : Int64;
begin
  if TbfaTreeView(Sender).Selected = nil then Exit;
  HT := TbfaTreeView(Sender).GetHitTestInfoAt(X, Y);
  AnItem := TbfaTreeView(Sender).GetNodeAt(X, Y);
  if (HT - [htOnItem, htOnIcon, htNowhere, htOnIndent] <> HT) then
  begin
    if (htOnItem in HT) or (htOnIcon in HT) then
      AttachMode := naAddChild
    else if htNowhere in HT then AttachMode := naAdd
    else if htOnIndent in HT then AttachMode := naInsert;
    TbfaTreeView(Sender).Selected.MoveTo(AnItem, AttachMode);

    id := PbfaInt64(TbfaTreeView(Sender).Selected.Data).Value;
    childarc := GetArchiveByID(id);
    if (childarc <> nil) and (childarc.ID <> PbfaInt64(AnItem.Data).Value) then
    begin
      childarc.Lgrid := PbfaInt64(AnItem.Data).Value;
      childarc.Modified := True;
    end;
    frmMainForm.FAdminTreeview.FAutoscroll.Enabled := False;
  end;
end;

procedure TfraAdmin.AdminTreeDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
var
  AnItem: TTreeNode;
begin

  if y < 15 then
  begin
     frmMainForm.FAdminTreeview.fbscroll_down := True;
     frmMainForm.FAdminTreeview.FAutoscroll.Enabled := True;
  end
  else
  if (frmMainForm.FAdminTreeview.Height - y) < 15 then
  begin
     frmMainForm.FAdminTreeview.fbscroll_down := False;
     frmMainForm.FAdminTreeview.FAutoscroll.Enabled := True;
  end
  else
     frmMainForm.FAdminTreeview.FAutoscroll.Enabled := False;


  Accept := (Source is TTreeView) and bitfarmApp.AdminEditMode;
  if not Accept then
    Exit;
  Accept := TbfaTreeView(Sender).Selected <> TbfaTreeView(Sender).Items.GetFirstNode;
  if not Accept then
    Exit;
  AnItem := TbfaTreeView(Sender).GetNodeAt(X, Y);
  Accept := Accept and (AnItem <> nil) and (AnItem.ImageIndex in [Integer(icoidx_warehouse_open), Integer(icoidx_warehouse_closed)]);
end;

procedure TfraAdmin.AssignObjectLists;
var
  i : Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'AssignObjectLists', ClassName);
  try
    try
      bfsAssignAddfields.DisableControls := True;
      bfsAssignStatefields.DisableControls := True;
      bfsAssignUser.DisableControls := True;
      bfsAddfieldsUser.DisableControls := True;
      bfsStatefieldsUser.DisableControls := True;
      bfsGroupsUser.DisableControls := True;

      {$IFDEF ENTERPRISE}
      TfraAdminEnterprise(Self).bfsInferior.DisableControls := True;
      {$ENDIF}

      bfiRepos.cbbInput.Items.BeginUpdate;
      bfiArchives.cbbInput.Items.BeginUpdate;
      bfiAddfields.cbbInput.Items.BeginUpdate;
      bfiStatefields.cbbInput.Items.BeginUpdate;
      bfiGroups.cbbInput.Items.BeginUpdate;
      bfiUser.cbbInput.Items.BeginUpdate;

      cbxStatefieldLink.Items.BeginUpdate;

      for i := 0 to bitfarmApp.GArchives.Count -1 do
      begin
        if bitfarmApp.GArchives[i].Typ = 0 then
        begin
          bfiRepos.cbbInput.Items.AddObject(bitfarmApp.GArchives[i].Name, bitfarmApp.GArchives[i]);

        end else
        begin
          bfiArchives.cbbInput.Items.AddObject(bitfarmApp.GArchives[i].Name, bitfarmApp.GArchives[i]);

        end;
      end;

      cbxStatefieldLink.Items.AddObject('', TbfaAddField.Create(0));
      for i := 0 to bitfarmApp.GAddfields.Count -1 do
      begin
        bfiAddfields.cbbInput.Items.AddObject(bitfarmApp.GAddfields[i].DisplayName, bitfarmApp.GAddfields[i]);
        if bitfarmApp.GAddfields[i].Typ = 14 then  // Grid-Spaltenfelder werden nicht AssignAddfields und StatefieldLinks bernommen
          Continue;
        bfsAssignAddfields.AddListAll(bitfarmApp.GAddfields[i].DisplayName, bitfarmApp.GAddfields[i]);
        cbxStatefieldLink.Items.AddObject(bitfarmApp.GAddfields[i].DisplayName, bitfarmApp.GAddfields[i]);
      end;

      for i := 0 to bitfarmApp.GStatefields.Count -1 do
      begin
        bfiStatefields.cbbInput.Items.AddObject(bitfarmApp.GStatefields[i].DisplayName, bitfarmApp.GStatefields[i]);
        bfsAssignStatefields.AddListAll(bitfarmApp.GStatefields[i].DisplayName, bitfarmApp.GStatefields[i]);
      end;

      for i := 0 to bitfarmApp.GGroups.Count -1 do
      begin
        bfiGroups.cbbInput.Items.AddObject(bitfarmApp.GGroups[i].Name, bitfarmApp.GGroups[i]);
        bfsAssignUser.AddListAll(bitfarmApp.GGroups[i].Name, bitfarmApp.GGroups[i]);
        bfsAddfieldsUser.AddListAll(bitfarmApp.GGroups[i].Name, bitfarmApp.GGroups[i]);
        bfsStatefieldsUser.AddListAll(bitfarmApp.GGroups[i].Name, bitfarmApp.GGroups[i]);
        bfsGroupsUser.AddListAll(bitfarmApp.GGroups[i].Name, bitfarmApp.GGroups[i]);
      end;

      {$IFDEF ENTERPRISE}
      TfraAdminEnterprise(Self).cbxSuperior.Items.Clear;
      TfraAdminEnterprise(Self).cbxHolidayUser.Items.Clear;
      TfraAdminEnterprise(Self).cbxReplacement.Items.Clear;

      TfraAdminEnterprise(Self).cbxSuperior.Items.BeginUpdate;
      TfraAdminEnterprise(Self).cbxHolidayUser.Items.BeginUpdate;
      TfraAdminEnterprise(Self).cbxReplacement.Items.BeginUpdate;

      {$ENDIF}

      cbxResubUser.Items.Clear;
      cbxLogUser.Items.Clear;

      cbxResubUser.Items.BeginUpdate;
      cbxLogUser.Items.BeginUpdate;

      for i := 0 to bitfarmApp.GUser.Count -1 do
      begin
        bfiUser.cbbInput.Items.AddObject(bitfarmApp.GUser[i].Name, bitfarmApp.GUser[i]);
        bfsAssignUser.AddListAll(bitfarmApp.GUser[i].Name, bitfarmApp.GUser[i]);
        bfsAddfieldsUser.AddListAll(bitfarmApp.GUser[i].Name, bitfarmApp.GUser[i]);
        bfsStatefieldsUser.AddListAll(bitfarmApp.GUser[i].Name, bitfarmApp.GUser[i]);
        bfsGroupsUser.AddListAll(bitfarmApp.GUser[i].Name, bitfarmApp.GUser[i]);
        cbxResubUser.Items.AddObject(bitfarmApp.GUser[i].Name, bitfarmApp.GUser[i]);
        cbxLogUser.Items.AddObject(bitfarmApp.GUser[i].Name, bitfarmApp.GUser[i]);

        {$IFDEF ENTERPRISE}
        TfraAdminEnterprise(Self).bfsInferior.AddListAll(bitfarmApp.GUser[i].Name, bitfarmApp.GUser[i]);
        if (bitfarmApp.GUser[i].Flags and 16) = 16 then
           TfraAdminEnterprise(Self).cbxSuperior.Items.AddObject(bitfarmApp.GUser[i].Name, bitfarmApp.GUser[i]);
        //19.08.2024 SD -->bfacrm:ticket__show__39657
//        TfraAdminEnterprise(Self).cbxHolidayUser.Items.AddObject(bitfarmApp.GUser[i].Name, bitfarmApp.GUser[i]);
//        TfraAdminEnterprise(Self).cbxReplacement.Items.AddObject(bitfarmApp.GUser[i].Name, bitfarmApp.GUser[i]);
        if (bitfarmApp.GUser[i].Flags and 2) = 2 then
        begin
          TfraAdminEnterprise(Self).cbxHolidayUser.Items.AddObject(bitfarmApp.GUser[i].Name + ' ' + _('(gelscht)'), bitfarmApp.GUser[i]);
          TfraAdminEnterprise(Self).cbxReplacement.Items.AddObject(bitfarmApp.GUser[i].Name + ' ' + _('(gelscht)'), bitfarmApp.GUser[i])
        end
        else
          if (bitfarmApp.GUser[i].Flags and 1) <> 1 then
          begin
            TfraAdminEnterprise(Self).cbxHolidayUser.Items.AddObject(bitfarmApp.GUser[i].Name + ' ' + _('(gesperrt)'), bitfarmApp.GUser[i]);
            TfraAdminEnterprise(Self).cbxReplacement.Items.AddObject(bitfarmApp.GUser[i].Name + ' ' + _('(gesperrt)'), bitfarmApp.GUser[i])
          end
          else
          begin
            TfraAdminEnterprise(Self).cbxHolidayUser.Items.AddObject(bitfarmApp.GUser[i].Name, bitfarmApp.GUser[i]);
            TfraAdminEnterprise(Self).cbxReplacement.Items.AddObject(bitfarmApp.GUser[i].Name, bitfarmApp.GUser[i])
          end;
        //19.08.2024 SD <--bfacrm:ticket__show__39657
        {$ENDIF}
      end;

      {$IFDEF ENTERPRISE}
      TfraAdminEnterprise(Self).cbxSuperior.Items.EndUpdate;
      TfraAdminEnterprise(Self).cbxHolidayUser.Items.EndUpdate;
      TfraAdminEnterprise(Self).cbxReplacement.Items.EndUpdate;
      {$ENDIF}

      cbxResubUser.Items.EndUpdate;
      cbxLogUser.Items.EndUpdate;
      cbxStatefieldLink.Items.EndUpdate;

      bfiRepos.cbbInput.Items.EndUpdate;
      bfiArchives.cbbInput.Items.EndUpdate;
      bfiAddfields.cbbInput.Items.EndUpdate;
      bfiStatefields.cbbInput.Items.EndUpdate;
      bfiGroups.cbbInput.Items.EndUpdate;
      bfiUser.cbbInput.Items.EndUpdate;

      bfsAssignAddfields.DisableControls := False;
      bfsAssignStatefields.DisableControls := False;
      bfsAssignUser.DisableControls := False;
      bfsAddfieldsUser.DisableControls := False;
      bfsStatefieldsUser.DisableControls := False;
      bfsGroupsUser.DisableControls := False;

      {$IFDEF ENTERPRISE}
      TfraAdminEnterprise(Self).bfsInferior.DisableControls := False;
      {$ENDIF}

      if bfiRepos.cbbInput.Items.Count > 0 then
      begin
        bfiRepos.cbbInput.ItemIndex := 0;
        OnChangeRepos(nil);
      end;
      if bfiArchives.cbbInput.Items.Count > 0 then
      begin
        bfiArchives.cbbInput.ItemIndex := 0;
        OnChangeArchive(nil);
      end;
      if bfiAddfields.cbbInput.Items.Count > 0 then
      begin
        bfiAddfields.cbbInput.ItemIndex := 0;
        OnChangeAddfield(nil);
      end;
      if bfiStatefields.cbbInput.Items.Count > 0 then
      begin
        bfiStatefields.cbbInput.ItemIndex := 0;
        OnChangeStatefield(nil);
      end;
      if bfiUser.cbbInput.Items.Count > 0 then
      begin
        bfiUser.cbbInput.ItemIndex := 0;
        OnChangeUser(nil);
      end;
      if bfiGroups.cbbInput.Items.Count > 0 then
      begin
        bfiGroups.cbbInput.ItemIndex := 0;
        OnChangeGroup(nil);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'AssignObjectLists', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'AssignObjectLists', ClassName);
  end;
end;

procedure TfraAdmin.bfaDBGrid1CellClick(Column: TColumn);
begin
  ShowResubIds;

end;

procedure TfraAdmin.bfiAddfieldsDelete(Sender: TObject; AValue: WideString;
    AObject: TObject);
var
  field: TbfaAddField;
  idx : Integer;
begin
  if AObject <> nil then
  begin
    field := TbfaAddField(AObject);

    if BfMessageDlg(Format(sMsgAdminDeleteAddfield,[field.DisplayName]),mtConfirmation,mbOKCancel, True) = mrOk then
    begin
      field.Flags := field.Flags or 2; // 2 = Delete
      field.Modified := True;

      idx := bfiAddfields.cbbInput.Items.IndexOfObject(field);
      if idx > -1 then
      begin
        bfiAddfields.cbbInput.Items.Objects[idx] := nil;
        bfiAddfields.cbbInput.Items.Delete(idx);
        bfiAddfields.cbbInput.Text := '';
      end;

      SetModified;
    end;
  end;
end;

procedure TfraAdmin.bfiAddfieldsDropDown(Sender: TObject);
begin
  frmMainform.OnComboDropDown(Sender);
//  bfiAddfields.cbbInput.AutoComplete := False;
//  bfiAddfields.cbbInput.Sorted := False;
  SelectEntryByObject(bfiAddfields, FCurrentAddfield);
end;

procedure TfraAdmin.bfiAddfieldsModify(Sender: TObject; AValue: WideString;
    AObject: TObject);
var
  field: TbfaAddField;
begin
  field := TbfaAddField(AObject);
  field.DisplayName := AValue;
  field.Modified := True;
  FCurrentAddfield := field;
  ShowAddfieldProperties(FCurrentAddfield);
  SetModified;
end;

procedure TfraAdmin.bfiAddfieldsNew(Sender: TObject; AValue: WideString);
var
  field: TbfaAddField;
  idx: Integer;
  guid: TGUID;
begin
  if AValue <> '' then
  begin
    Inc(FAddfieldidMax);
    field := TbfaAddField.Create;
    field.Typ := 0;
//    field.ID := FAddfieldidMax;
    field.ID := -1; // lassen wir besser vom Server vergeben
    CreateGUID(guid);
    field.TempID := guid;
//    field.Name := 'add_' + IntToStr(FAddfieldidMax);
    field.DisplayName := AValue;
    field.Options := 0;
    field.Mode := 2;
    field.Flags := 1;
    field.Modified := True;

    bitfarmApp.GAddfields.Add(field);

    idx :=  bfiAddfields.cbbInput.Items.IndexOf(AValue);
    if idx > -1 then
      bfiAddfields.cbbInput.Items.Objects[idx] := field;
    bfiAddfields.cbbInput.ItemIndex := idx;
    FCurrentAddField := field;

    ShowAddfieldProperties(FCurrentAddfield);
    SetModified;
  end;
end;

procedure TfraAdmin.bfiArchivesDelete(Sender: TObject; AValue: WideString;
    AObject: TObject);
var
  arc : TbfaArchive;
  Node: TTreeNode;
  idx: Integer;
begin
  if AObject <> nil then
  begin
    arc := TbfaArchive(AObject);

    if arc.Typ = 2 then
    begin
      BfShowMessage('Der Wiedervorlage-Eintrag kann nicht entfernt werden.');
      Exit;
    end;

    if BfMessageDlg(Format(_('Soll das Archiv %s entfernt werden?'),[arc.Name]),mtConfirmation,mbOKCancel, True) = mrOk then
    begin
      arc.Flags := arc.Flags or 2; // 2 = Delete
      arc.Modified := True;

      Node := frmMainForm.FAdminTreeview.GetTreeNodeByID(arc.ID);

      idx := bfiArchives.cbbInput.Items.IndexOfObject(arc);
      if idx > -1 then
      begin
        bfiArchives.cbbInput.Items.Objects[idx] := nil;
        bfiArchives.cbbInput.Items.Delete(idx);
        bfiArchives.cbbInput.Text := '';
      end;
      if Node <> nil then
        frmMainForm.FAdminTreeview.Items.Delete(Node);
      SetModified;
    end;
  end;
end;

procedure TfraAdmin.bfiArchivesModify(Sender: TObject; AValue: WideString; AObject: TObject);
var
  arc: TbfaArchive;
  node: TTreeNode;
  idx: Integer;
begin
  if AValue <> '' then
  begin
    if FCurrentArchive.Typ = 0 then
    begin
      if AObject = nil then
        arc := TbfaArchive(bfiArchives.cbbInput.Items.Objects[bfiArchives.cbbInput.ItemIndex])
      else
        arc := TbfaArchive(AObject);

      if arc <> nil then
      begin
        FCurrentArchive := arc;
        FCurrentArchive.Name := AValue;
        FCurrentArchive.Modified := True;

        node := frmMainForm.FAdminTreeview.GetTreeNodeByID(FCurrentArchive.ID);
        if node <> nil then
          node.Text := AValue;
      end;
    end else begin
      FCurrentArchive.Name := AValue;
      FCurrentArchive.Modified := True;
      node := frmMainForm.FAdminTreeview.GetTreeNodeByID(FCurrentArchive.ID);
      if node <> nil then
        node.Text := AValue;
    end;
    SetModified;
  end;
end;

procedure TfraAdmin.bfiArchivesNew(Sender: TObject; AValue: WideString);
var
  arc : TbfaArchive;
  group : TbfaGroup;
  arcrights : TbfaArcRight;
  Node, PNode : TTreeNode;
  idx: Integer;
  pID : PbfaInt64;
  guid: TGUID;
begin
  //23.02.2023 bfacrm:ticket__show__33705 -->
  if bfiRepos.cbbInput.ItemIndex = -1 then
  begin
    BfShowMessage(_('Es hat einen Fehler bei der Lagerauswahl gegeben. Bitte selektieren Sie das Lager erneut.'));
    Exit;
  end
  else
    FCurrentArchive := TbfaArchive(bfiRepos.cbbInput.Items.Objects[bfiRepos.cbbInput.ItemIndex]);
  //23.02.2023 bfacrm:ticket__show__33705 <--

  if FCurrentArchive = nil then
  begin
    BfShowMessage(_('Es hat einen Fehler bei der Archivauswahl gegeben. Bitte selektieren Sie das Archiv erneut.'));
    Exit;
  end;

  if FCurrentArchive.Typ = 2 then
  begin
    BfShowMessage(_('Man kann kein Archiv unterhalb der Wiedervorlage anlegen. Bitte selektieren Sie ein anderes Lager.'));
    Exit;
  end;

  if AValue <> '' then
  begin
    arc := TbfaArchive.Create;
    arc.Typ := 1;
    arc.Name := AValue;
    arc.Flags := 1;
    arc.Modified := True;
    if FCurrentArchive.Typ = 0  then
    begin
      arc.Lgrid := FCurrentArchive.ID
    end else begin
      arc.Lgrid := FCurrentArchive.Lgrid;
    end;
    Dec(FArcidMax);
    arc.ID := FArcidMax;
    CreateGUID(guid);
    arc.TempID := guid;

    arc.Tblname := FormatDateTime('ddmmyyyyhhnnss', Now());
    Sleep(900);

    if bitfarmApp.ViewerOptions.AdminOptions.DefaultArchiveGroup then
    begin
      arcrights := TbfaArcRight.Create;
      arcrights.ArcID := arc.ID;
      arcrights.ArcTempID := arc.TempID;
      arcrights.Groupid := 0;
      arcrights.Rights := bitfarmApp.ViewerOptions.AdminOptions.DefaultArchiveGroupRights;
      arcrights.Modified := True;
      arc.Groups.AddObject('0', arcrights);
      arc.Modified_User := True;
    end;

    if bitfarmApp.User.isAdmin and not bitfarmApp.User.DMSAdmin then     // wenn wir Admin sind aber nicht DMSAdmin
    begin                                                                // dann werden wir als user mit adminrecht
      arcrights := TbfaArcRight.Create;
      arcrights.ArcID := arc.ID;
      arcrights.ArcTempID := arc.TempID;
      arcrights.Userid := bitfarmApp.User.ID;
      arcrights.Groupid := 0;
      arcrights.Rights := rightAdmin;
      arcrights.Modified := True;
      arc.Users.AddObject(IntToStr(bitfarmApp.User.ID), arcrights);
      arc.Modified_User := True;                                                                // zu jedem von uns erstellten Archiv hinzugefgt
    end;

    bitfarmApp.GArchives.Add(arc);

    idx :=  bfiArchives.cbbInput.Items.IndexOf(AValue);
    if idx > -1 then
      bfiArchives.cbbInput.Items.Objects[idx] := arc;

    bfiArchives.cbbInput.ItemIndex := idx;
    FCurrentArchive := arc;

    PNode := frmMainForm.FAdminTreeview.GetTreeNodeByID(arc.Lgrid);
    Node := frmMainForm.FAdminTreeview.Items.AddChild(PNode, AValue);

    New(pID);
    pID^ := TbfaInt64.Create;
    pID.Value := FArcidMax;
    Node.Data := pID;
    Node.ImageIndex := Integer(icoidx_folder_closed);
    Node.SelectedIndex := Integer(icoidx_folder_open);
    if PNode <> nil then
      if not PNode.Expanded then
        PNode.Expand(False);
    ShowArchiveProperties(FCurrentArchive);
    SetModified;
  end;

end;

procedure TfraAdmin.bfiGroupsDelete(Sender: TObject; AValue: WideString;
    AObject: TObject);
var
  group: TbfaGroup;
  idx : Integer;
begin
  if AObject <> nil then
  begin
    group := TbfaGroup(AObject);

    if BfMessageDlg(Format(_('Soll die Gruppe %s entfernt werden?'),[group.Name]),mtConfirmation,mbOKCancel, True) = mrOk then
    begin
      group.Flags := group.Flags or 2; // 2 = Delete
      group.Modified := True;

      idx := bfiGroups.cbbInput.Items.IndexOfObject(group);
      if idx > -1 then
      begin
        bfiGroups.cbbInput.Items.Objects[idx] := nil;
        bfiGroups.cbbInput.Items.Delete(idx);
        bfiGroups.cbbInput.Text := '';
      end;

      SetModified;
    end;
  end;

end;

procedure TfraAdmin.bfiGroupsModify(Sender: TObject; AValue: WideString;
    AObject: TObject);
var
  group: TbfaGroup;
begin
  group := TbfaGroup(AObject);
  group.Name := AValue;
  group.Modified := True;
  FCurrentGroup := group;
  ShowGroupProperties(FCurrentGroup);
  SetModified;
end;

procedure TfraAdmin.bfiGroupsNew(Sender: TObject; AValue: WideString);
var
  group: TbfaGroup;
  idx: Integer;
  guid: TGUID;
begin
  if AValue <> '' then
  begin
    Inc(FGroupidMax);
    group := TbfaGroup.Create;
    group.Name := AValue;
    group.ID := -1;
    CreateGUID(guid);
    group.TempID := guid;
    group.Flags := 1;
    group.Modified := True;

    bitfarmApp.GGroups.Add(group);

    idx :=  bfiGroups.cbbInput.Items.IndexOf(AValue);
    if idx > -1 then
      bfiGroups.cbbInput.Items.Objects[idx] := group;
    bfiGroups.cbbInput.ItemIndex := idx;
    FCurrentGroup := group;

    ShowGroupProperties(FCurrentGroup);
    SetModified;
  end;
end;

procedure TfraAdmin.bfiReposDelete(Sender: TObject; AValue: WideString;
    AObject: TObject);
var
  arc, childarc : TbfaArchive;
  Node, child, pnode : TTreeNode;
  idx, id, parentid: Integer;
begin
  arc := TbfaArchive(AObject);

  Node := frmMainForm.FAdminTreeview.GetTreeNodeByID(arc.ID);

  if Node = nil then  //31.01.2018 wegen CrashLog eingebaut
  begin
    BfShowMessage(_('Das Lager muss im Baum sichtbar sein.'));
    Exit;
  end;

  if Node.IsFirstNode then
  begin
    BfShowMessage(_('Die Archivwurzel kann nicht entfernt werden'));
    Exit;
  end;

  if BfMessageDlg(Format(_('Soll das Lager %s entfernt werden?'),[arc.Name]),mtConfirmation,mbOKCancel, True) = mrOk then
  begin
    arc.Flags := arc.Flags or 2; // 2 = Delete
    arc.Modified := True;

    idx := bfiRepos.cbbInput.Items.IndexOfObject(arc);
    if idx > -1 then
    begin
      bfiRepos.cbbInput.Items.Objects[idx] := nil;
      bfiRepos.cbbInput.Items.Delete(idx);
      bfiRepos.cbbInput.Text := '';
    end;

    if Node.HasChildren then
    begin
      Node.Expand(False);
      pnode := Node.Parent;
      parentid := PbfaInt64(pnode.Data).Value;

      child := Node.getFirstChild;
      while Assigned(child) do
      begin
        if (child.Parent = Node) then
        begin
          child.MoveTo(pnode, naAddChild);
          id := PbfaInt64(child.Data).Value;
          childarc := GetArchiveByID(id);
          if childarc <> nil then
          begin
            childarc.Lgrid := parentid;
            childarc.Modified := True;
          end;
        end;
        child := Node.getFirstChild;
      end;
    end;

    frmMainForm.FAdminTreeview.Items.Delete(Node);
    SetModified;
  end;
end;

procedure TfraAdmin.bfiReposModify(Sender: TObject; AValue: WideString; AObject: TObject);
var
  arc: TbfaArchive;
  node: TTreeNode;
  id, idx: Int64;
begin
  if AValue <> '' then
  begin
    if FCurrentArchive.Typ = 0 then
    begin
      FCurrentArchive.Name := AValue;
      FCurrentArchive.Modified := True;

      node := frmMainForm.FAdminTreeview.GetTreeNodeByID(FCurrentArchive.ID);
      if node <> nil then
        node.Text := AValue;
    end else begin
      arc := GetArchiveByID(FCurrentArchive.Lgrid);
      if arc <> nil then
      begin
        FCurrentArchive := arc;
        FCurrentArchive.Name := AValue;
        FCurrentArchive.Modified := True;

        node := frmMainForm.FAdminTreeview.GetTreeNodeByID(FCurrentArchive.ID);
        if node <> nil then
          node.Text := AValue;
      end;
    end;

    idx :=  bfiRepos.cbbInput.Items.IndexOfObject(FCurrentArchive);
    bfiRepos.cbbInput.ItemIndex := idx;
    SetModified;
  end;
end;

procedure TfraAdmin.bfiReposNew(Sender: TObject; AValue: WideString);
var
  arc : TbfaArchive;
  Node, PNode : TTreeNode;
  idx: Integer;
  pID : PbfaInt64;
  guid: TGUID;
begin
  if FCurrentArchive = nil then
  Begin
    BfShowMessage(_('Es hat einen Fehler bei der Lagerauswahl gegeben. Bitte selektieren Sie das Lager erneut.'));
    Exit;
  End;

  if FCurrentArchive.Typ = 2 then
  Begin
    BfShowMessage(_('Man kann kein Lager unterhalb der Wiedervorlage anlegen. Bitte selektieren Sie ein anderes Lager.'));
    Exit;
  End;

  if AValue <> '' then
  begin
    arc := TbfaArchive.Create;
    arc.Typ := 0;
    arc.Name := AValue;
    arc.Flags := 1;
    arc.Modified := True;
    if FCurrentArchive.Typ = 0  then
    begin
      arc.Lgrid := FCurrentArchive.ID
    end else begin
      arc.Lgrid := FCurrentArchive.Lgrid;
    end;

    Dec(FArcidMax);
    arc.ID := FArcidMax;
    CreateGUID(guid);
    arc.TempID := guid;
    arc.Tblname := FormatDateTime('ddmmyyyyhhnnss', Now());
    Sleep(900);
    bitfarmApp.GArchives.Add(arc);

    //TODO: was passiert bei Namensgleichheit
    idx :=  bfiRepos.cbbInput.Items.IndexOf(AValue);
    if idx > -1 then
      bfiRepos.cbbInput.Items.Objects[idx] := arc;

    bfiRepos.cbbInput.ItemIndex := idx;
    //18.01.2022 Ticket 14618 Punkt 2 FCurrentArchive := arc;

    PNode := frmMainForm.FAdminTreeview.GetTreeNodeByID(arc.Lgrid);
    Node := frmMainForm.FAdminTreeview.Items.AddChild(PNode, AValue);

    New(pID);
    pID^ := TbfaInt64.Create;
    pID.Value := FArcidMax;
    Node.Data := pID;
    Node.ImageIndex := Integer(icoidx_warehouse_closed);
    Node.SelectedIndex := Integer(icoidx_warehouse_open);

    //18.01.2022 Ticket 14618 Punkt 2 -->
    //frmMainForm.FAdminTreeview.Select(Node);
    bfiRepos.cbbInput.ItemIndex := bfiRepos.cbbInput.Items.IndexOfObject(FCurrentArchive);
    if PNode <> nil then
      if not PNode.Expanded then
        PNode.Expand(False);
    //18.01.2022 Ticket 14618 Punkt 2 <--
    ShowReposProperties(FCurrentArchive);
    SetModified;
  end;
end;

procedure TfraAdmin.bfiStatefieldsDelete(Sender: TObject; AValue: WideString;
    AObject: TObject);
var
  field: TbfaStateField;
  idx : Integer;
begin
  if AObject <> nil then
  begin
    field := TbfaStateField(AObject);

    if BfMessageDlg(Format(_('Soll das Statusfeld %s entfernt werden?'),[field.DisplayName]),mtConfirmation,mbOKCancel, True) = mrOk then
    begin
      field.Flags := field.Flags or 2; // 2 = Delete
      field.Modified := True;

      idx := bfiStatefields.cbbInput.Items.IndexOfObject(field);
      if idx > -1 then
      begin
        bfiStatefields.cbbInput.Items.Objects[idx] := nil;
        bfiStatefields.cbbInput.Items.Delete(idx);
        bfiStatefields.cbbInput.Text := '';
      end;

      SetModified;
    end;
  end;

end;

procedure TfraAdmin.bfiStatefieldsModify(Sender: TObject; AValue: WideString;
    AObject: TObject);
var
  field: TbfaStateField;
begin
  field := TbfaStateField(AObject);
  field.DisplayName := AValue;
  field.Modified := True;
  FCurrentStateField := field;
  ShowStatefieldProperties(FCurrentStateField);
  SetModified;
end;

procedure TfraAdmin.bfiStatefieldsNew(Sender: TObject; AValue: WideString);
var
  field: TbfaStateField;
  idx: Integer;
  guid: TGUID;
begin
  if AValue <> '' then
  begin
    Inc(FStatefieldidMax);
    field := TbfaStateField.Create;
    field.Typ := 0;
    field.ID := -1;
    CreateGUID(guid);
    field.TempID := guid;
    field.DisplayName := AValue;
    field.Func := 0;
    field.Flags := 1;
    field.Modified := True;

    bitfarmApp.GStatefields.Add(field);

    idx :=  bfiStatefields.cbbInput.Items.IndexOf(AValue);
    if idx > -1 then
      bfiStatefields.cbbInput.Items.Objects[idx] := field;
    bfiStatefields.cbbInput.ItemIndex := idx;
    FCurrentStateField := field;

    ShowStatefieldProperties(FCurrentStateField);
    SetModified;
  end;
end;

procedure TfraAdmin.bfiUserDelete(Sender: TObject; AValue: WideString; AObject:
    TObject);
var
  user: TbfaUser;
  idx: Integer;
  username: Widestring;
begin
  if AObject <> nil then
  begin
    user := TbfaUser(AObject);

    if (user.ID = 1) or (user.Flags and 128 = 128) then
      Exit;

    if user.Displayname <> '' then
      username := user.Displayname
    else
      username := user.Name;

    if BfMessageDlg(Format(_('Soll der Benutzer %s entfernt werden?'),[username]),mtConfirmation,mbOKCancel, True) = mrOk then
    begin
      if user.Flags and 65 = 65 then  //concurrent und enabled
        dec(bitfarmApp.cnt_concurrent)
      else if user.Flags and 1 = 1 then   // enabled      // disabled user werden nicht gezhlt, weder named noch concurrent
        dec(bitfarmApp.cnt_named);

      user.Flags := user.Flags or 2; // 2 = Delete
      user.Modified := True;

      idx := bfiUser.cbbInput.Items.IndexOfObject(user);
      if idx > -1 then
      begin
        bfiUser.cbbInput.Items.Objects[idx] := nil;
        bfiUser.cbbInput.Items.Delete(idx);
        bfiUser.cbbInput.Text := '';
        edtDisplayName.Text := '';
        edtPassword.Text := '';
        edtEmail.Text := '';
        FSkipChangeEvents := True;
        cbxUserRole.ItemIndex := 0;
        chkMustChangePass.Checked := False;
        chkUserDenied.Checked := False;

        chkAdmin.Checked := False;


        FSkipChangeEvents := False;
      end;

      SetModified;
      ShowUserProperties(nil);
    end;
  end;

end;

procedure TfraAdmin.bfiUserModify(Sender: TObject; AValue: WideString; AObject:
    TObject);
var
  user: TbfaUser;
begin
  user := TbfaUser(AObject);

  if not Assigned(User) then   // Crashlog 20.08.2018 (Kai Honer)
    exit;

  if (user.ID = 1) or (user.Flags and 128 = 128) then
    Exit;

  user.Name := AValue;
  user.Modified := True;
  FCurrentUser := user;
  ShowUserProperties(FCurrentUser);
  SetModified;
end;

procedure TfraAdmin.bfiUserNew(Sender: TObject; AValue: WideString);
var
  user: TbfaUser;
  idx: Integer;
  guid: TGUID;
  qry: TUniQuery;
  userid: Integer;
begin
  if (bitfarmApp.max_named <> -1) and
      ((bitfarmApp.cnt_named + 1 > bitfarmApp.max_named) or
      (bitfarmApp.cnt_enabled + 1 > bitfarmApp.max_named))
       and (bitfarmApp.max_concurrent = 0) then
  begin
    BfShowMessage(_('Die maximale Anzahl der Named User wurde erreicht.'));
    SelectEntryByObject(bfiUser, FCurrentUser);
    Exit;
  end;

  if AValue <> '' then
  begin
    userid := -1;
    qry := TUniQuery.Create(nil);
    try
      qry.Connection := dmMain.cntMain;

      qry.SQL.Text := 'select userid, flags +0 from sys_user where username = ' + #39 + AValue + #39;
      qry.Execute;
      if qry.RecordCount > 0 then
      begin
        if qry.FieldByName('flags +0').AsInteger and 2 = 2 then
        begin
          if BfMessageDlg(Format(_('Der Benutzer %s war schon mal vorhanden. Soll dieser reaktiviert werden?'),[AValue]), mtConfirmation, [mbYes, mbNo], True) = mrYes then
          begin
            userid := qry.FieldByName('userid').AsInteger;
          end;
        end;
      end;
    finally
      FreeAndNil(qry);
    end;

    Inc(FUseridMax);
    user := TbfaUser.Create;
    user.Name := AValue;
    user.ID := userid;
    if userid = -1 then
    begin
      CreateGUID(guid);
      user.TempID := guid;
    end;

    if bitfarmApp.max_named = -1 then
    begin
       user.Flags := 1;
       inc(bitfarmApp.cnt_named);
    end else
    if bitfarmApp.cnt_named + 1> bitfarmApp.max_named then
    begin
       user.Flags := 65;
       inc(bitfarmApp.cnt_concurrent);
    end else begin
       user.Flags := 1;
       inc(bitfarmApp.cnt_named);
    end;

    user.Modified := True;

    bitfarmApp.GUser.Add(user);

    idx := bfiUser.cbbInput.Items.IndexOf(AValue);
    if idx > -1 then
      bfiUser.cbbInput.Items.Objects[idx] := user;
    bfiUser.cbbInput.ItemIndex := idx;
    FCurrentUser := user;

    ShowUserProperties(FCurrentUser);
    SetModified;
  end;
end;

//procedure TfraAdmin.btnAddHolidayClick(Sender: TObject);
//var
  //req: TbfaRequest;
  //user, repl: TbfaUser;
  //datestart, dateend : string;
//begin
  //bitfarmLog.DebugBegin(llDebug, 'btnAddHolidayClick', ClassName);
  //try
    //try
      //user := TbfaUser(cbxHolidayUser.Items.Objects[cbxHolidayUser.ItemIndex]);
      //repl := TbfaUser(cbxReplacement.Items.Objects[cbxReplacement.ItemIndex]);
      //datestart := FormatDateTime('yyyy-mm-dd', dtDateStart.Date);
      //dateend := FormatDateTime('yyyy-mm-dd', dtDateEnd.Date);
//
      //if not bitfarmApp.checkholidayloop(user.ID, repl.ID,dtDateStart.Date, dtDateEnd.Date) then
      //begin
        //BfShowMessage(_('Dieser Eintrag ist nicht mglich, da sonst eine zirkulre Vertretung erzeugt wird'));
        //Exit;
      //end;
//
      //slAddHoliday.Add(IntToStr(user.ID)+';'+inttostr(repl.ID)+';'+datestart+';'+dateend);
      //SetModified;
////      req := TbfaRequest.Create;
      //try
////        req.ReqType := 'reqSaveHoliday';
////        req.UserID := bitfarmApp.User.ID;
////        req.Profile := bitfarmApp.Profile;
////        req.Parameter := IntToStr(user.ID)+';'+inttostr(repl.ID)+';'+datestart+';'+dateend;
////
////
////        req.Lang := bitfarmApp.Lang;
////        bitfarmApp.MainSocket.SendRequestToServer(req);
////
////        req := bitfarmApp.MainSocket.ReceiveResponse;
////        if req = nil then
////          Exit;
////
////        if (req.ReqType = 'respError') or (req.ReqType = 'respAuthError') then
////        begin
////          BfShowMessage(_('Server meldet Fehler: ') + req.DataString, nil);
////
////        end;
      //finally
        //FreeAndNil(req);
        //btnAddHoliday.Enabled := False;
        //AddToHolidayList(user.Name, repl.Name, dtDateStart.Text, dtDateEnd.Text);
////        LoadHolidayList;
      //end;
//
    //except
      //bitfarmLog.Write(llNormal, ltException, 'btnAddHolidayClick', ClassName);
    //end;
  //finally
     //bitfarmLog.DebugEnd(llDebug, 'btnAddHolidayClick', ClassName);
  //end;
//end;

procedure TfraAdmin.btnAddListItemsClick(Sender: TObject);
var
  XMLString: string;
  Lst: TList<TbfaBaseObject>;
begin
  try
    if (FCurrentAddfield.Typ = 13) and bitfarmApp.AdminEditMode then
    begin
      frmMainForm.frmGridConfig.Gridfield := FCurrentAddfield;
      frmMainForm.frmGridConfig.Addfields := bitfarmApp.GAddfields;
      frmMainform.frmGridConfig.AddfieldComp :=  bitfarmApp.CreateGridFieldComp(frmMainform.frmGridConfig.scrbxGrid,
                        FCurrentAddfield);
//      frmMainform.frmGridConfig.AddfieldComp.Label1.Visible := False;
//      frmMainform.frmGridConfig.AddfieldComp.compEdit.Visible := False;
      frmMainform.frmGridConfig.ShowModal;

      if (frmMainform.frmGridConfig.ModalResult = mrOk) and frmMainform.frmGridConfig.Modified then
      begin
        frmMainForm.fraAdmin.Modified := True;
        Lst := Tlist<TbfaBaseObject>.Create;
        Lst.Add(frmMainform.frmGridConfig.AddfieldComp.compGrid.Config);
        XMLString := ObjectToXML(Lst, False, 'us-ascii');
        if XMLString <> '' then
        begin
          FCurrentAddfield.Modified := True;
          FCurrentAddfield.ValuesQuery := XMLString;
        end;
      end;
    end else
    begin
      frmMainForm.frmListItems.Editable := bitfarmApp.AdminEditMode;

      frmMainForm.frmListItems.bfaInputEdit1.edtInput.Text := '';
      frmMainForm.frmListItems.bfaInputEdit1.DirectMode := True;
      if (FCurrentAddfield <> nil) then
      begin
        frmMainForm.frmListItems.Strictmode := (FCurrentAddfield.Options and 8) = 8;
        frmMainForm.frmListItems.Addname := FCurrentAddfield.Name;
        frmMainForm.frmListItems.AddIdx := FCurrentAddfield.IndexTableID;
        frmMainForm.frmListItems.CurrentField := FCurrentAddfield;
        if (FCurrentAddfield.Items <> nil) and
            (FCurrentAddfield.Items.Count > 0) then
        begin
          frmMainForm.frmListItems.lbItems.Items.Assign(FCurrentAddfield.Items)
        end else
          frmMainForm.frmListItems.lbItems.Items.Clear;
      end;

      frmMainForm.frmListItems.ShowModal;

      if bitfarmApp.AdminEditMode and (frmMainForm.frmListItems.ModalResult = mrOk) then
      begin
        FCurrentAddfield.Items.Assign(frmMainForm.frmListItems.lbItems.Items);
        FCurrentAddfield.Items.Delimiter := ';';
        FCurrentAddfield.Items.StrictDelimiter := True;
        FCurrentAddfield.Modified := True;
        SetModified;
      end;
    end;
  except
     bitfarmLog.Debug(llDebug, 'btnAddListItemsClick', ClassName);
  end;
end;

procedure TfraAdmin.btnApplyAdminClick(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  SaveObjects;
  bitfarmApp.AdminEditMode := True;
  FModified := False;
  Screen.Cursor := crDefault;
  FUserClickedApplyJustToSave := True;
end;

procedure TfraAdmin.btnCancelAdminClick(Sender: TObject);
begin
   CancelAdmin;
   PaintWindow(Self.Handle);
end;

procedure TfraAdmin.CancelAdmin;
begin
  bitfarmApp.AdminEditMode := False;
  FModified := False;
//  FADModified := False;
  btnSaveAdmin.Caption := sCaptionModify;
  btnSaveAdmin.ImageIndex := Integer(icoidx_edit);
  btnSaveAdmin.Enabled := True;
  btnCancelAdmin.Enabled := False;

  bfiUser.DoCancel(nil);
  bfiRepos.DoCancel(nil);
  bfiArchives.DoCancel(nil);
  bfiAddfields.DoCancel(nil);
  bfiStatefields.DoCancel(nil);
  bfiGroups.DoCancel(nil);
  frmDLMDialog.Entries.Clear;

  frmMainForm.frmSplash.lblInfo.Caption := sMsgAdminRefreshView;
  frmMainForm.frmSplash.Show;
  ReloadAdminFrame;
  bitfarmApp.Reloadfields;
  frmMainForm.frmSplash.lblInfo.Caption := sMsgAdminRefreshTreeviews;
  frmMainForm.frmSplash.Update;
  bitfarmApp.ReloadTrees;
  btnSaveAdmin.Caption := sCaptionModify;
  btnSaveAdmin.ImageIndex := Integer(icoidx_edit);
  EnableFunctions(bitfarmApp.AdminEditMode);

  if tabctrAdmin.ActiveTabIndex in [0,1] then
    SelectArchive(FCurrentArchive.ID);

  //10.02.2022 sollte eingecheckt werden, wenn selected...
  if (frmMainForm.FAdminTreeview.Selected <> nil) and not frmMainForm.FAdminTreeview.Checked[frmMainForm.FAdminTreeview.Selected] then
    frmMainForm.FAdminTreeview.Checked[frmMainForm.FAdminTreeview.Selected] := True;

  CheckAdminTimestamp;

  frmMainForm.frmSplash.lblInfo.Caption := '';
  frmMainForm.frmSplash.Hide;

  FUserClickedApplyJustToSave := False;
end;

//procedure TfraAdmin.btnCancelHolidayClick(Sender: TObject);
//begin
  //btnModifyHoliday.Enabled := False;
  //btnDeleteHoliday.Enabled := False;
  //btnCancelHoliday.Enabled := False;
  //btnAddHoliday.Enabled := False;
  //cbxHolidayUser.ItemIndex := -1;
  //cbxReplacement.ItemIndex := -1;
  //dtDateStart.Date := Date;
  //dtDateEnd.Date := Date;
//
  //lvHoliday.Selected.Selected := False;
//end;

procedure TfraAdmin.btnCheckAllClick(Sender: TObject);
var
  i: Integer;
begin
  frmMainForm.FAdminTreeview.CheckChilds := True;
  try
    for i := 0 to frmMainForm.FAdminTreeview.Items.Count -1 do
    begin
      if (frmMainForm.FAdminTreeview.Items.Item[i].ImageIndex in [Integer(icoidx_warehouse_open), Integer(icoidx_warehouse_closed)]) and
          (not frmMainForm.FAdminTreeview.Items.Item[i].Expanded) then  // Lager zugeklappt berspringen
        Continue;
      if (frmMainForm.FAdminTreeview.Items.Item[i].Parent <> nil) and frmMainForm.FAdminTreeview.Items.Item[i].Parent.Expanded then
        frmMainForm.FAdminTreeview.Checked[frmMainForm.FAdminTreeview.Items.Item[i]] := True;
    end;
    bitfarmApp.CountChecked;
  finally
    frmMainForm.FAdminTreeview.CheckChilds := False;
  end;
end;

procedure TfraAdmin.btnCollapseAllClick(Sender: TObject);
var
  i: Integer;
begin
   frmMainForm.FAdminTreeview.FullCollapse;
end;


procedure TfraAdmin.btnContractClick(Sender: TObject);
var
  i, cnt_date, cnt_interval : Integer;
  msg : WideString;
  ini : Tinifile;
  fname, fdir, sFileName : string;
  linimwvl : Tinifile;
  licounter, licounter1 : integer;
  lstrl : Tstringlist;
  lbvalue : boolean;
begin
  frmContractMgmt.cbx_archive.Items.Clear;
  frmContractMgmt.cbx_start.Items.Clear;
  frmContractMgmt.cbx_end.Items.Clear;
  frmContractMgmt.cbx_lastactivated.Items.Clear;
  frmContractMgmt.cbx_interval.Items.Clear;
  frmContractMgmt.cbx_notice.Items.Clear;
  frmContractMgmt.ClearFields;

  for i := 0 to bitfarmApp.GAddfields.Count -1 do
  begin
    if bitfarmApp.GAddfields[i].Typ in [1,12] then
    begin
      frmContractMgmt.cbx_start.AddItem(bitfarmApp.GAddfields[i].DisplayName, bitfarmApp.GAddfields[i]);
      frmContractMgmt.cbx_end.AddItem(bitfarmApp.GAddfields[i].DisplayName, bitfarmApp.GAddfields[i]);
      frmContractMgmt.cbx_lastactivated.AddItem(bitfarmApp.GAddfields[i].DisplayName, bitfarmApp.GAddfields[i]);
      inc(cnt_date);
    end;
    if bitfarmApp.GAddfields[i].Typ = 5 then
    begin
      frmContractMgmt.cbx_interval.AddItem(bitfarmApp.GAddfields[i].DisplayName, bitfarmApp.GAddfields[i]);
      frmContractMgmt.cbx_notice.AddItem(bitfarmApp.GAddfields[i].DisplayName, bitfarmApp.GAddfields[i]);
      inc(cnt_interval);
    end;
  end;

  for i := 0 to bitfarmApp.GArchives.Count -1 do
  begin
    if bitfarmApp.GArchives[i].Typ = 1 then
    begin
      frmContractMgmt.cbx_archive.AddItem(bitfarmApp.GArchives[i].Name, bitfarmApp.GArchives[i]);
    end;
  end;

  if (bitfarmApp.GArchives.Count = 0) or (cnt_date < 3) or (cnt_interval < 2) then
  begin
    msg := _('Es sind nicht alle Vorraussetzungen erfllt, um ein Vertragsarchiv zu konfigurieren.');
    if (bitfarmApp.GArchives.Count = 0) then
      msg := msg + #13#10 + _('Es muss mindestens ein Archiv vorhanden sein.');
    if (cnt_date < 3) then
      msg := msg + #13#10 + _('Es mssen mindestens drei Datumsfelder vorhanden sein.');
    if (cnt_interval < 2)  then
      msg := msg + #13#10 + _('Es mssen mindestens zwei Intervalfelder vorhanden sein.');
    BfShowMessage(msg);
    Exit;
  end;

  if frmContractMgmt.cbx_archive.Items.Count > 0 then
    frmContractMgmt.cbx_archive.ItemIndex := 0;
  if frmContractMgmt.cbx_start.Items.Count > 0 then
    frmContractMgmt.cbx_start.ItemIndex := 0;
  if frmContractMgmt.cbx_end.Items.Count > 0 then
    frmContractMgmt.cbx_end.ItemIndex := 0;
  if frmContractMgmt.cbx_lastactivated.Items.Count > 0 then
    frmContractMgmt.cbx_lastactivated.ItemIndex := 0;
  if frmContractMgmt.cbx_interval.Items.Count > 0 then
    frmContractMgmt.cbx_interval.ItemIndex := 0;
  if frmContractMgmt.cbx_notice.Items.Count > 0 then
    frmContractMgmt.cbx_notice.ItemIndex := 0;

  frmContractMgmt.ShowModal;
  if frmContractMgmt.ModalResult = mrOk then
  begin
    if PromptForFileName(frmContractMgmt.fname, mwlFiletypes, fdir, _('Datei ffnen'), '', True) then
    begin
      if ExtractFileExt(frmContractMgmt.fname) <> '.mwl' then
        frmContractMgmt.fname := frmContractMgmt.fname + '.mwl';

      ini := TIniFile.Create(frmContractMgmt.fname);
      ini.EraseSection('Info');
      ini.WriteInteger('Info','archiveid', TbfaArchive(frmContractMgmt.cbx_archive.Items.Objects[frmContractMgmt.cbx_archive.ItemIndex]).ID);
      ini.WriteString('Info','startfield', TbfaAddField(frmContractMgmt.cbx_start.Items.Objects[frmContractMgmt.cbx_start.ItemIndex]).Name);
      ini.WriteString('Info','intervalfield', TbfaAddField(frmContractMgmt.cbx_interval.Items.Objects[frmContractMgmt.cbx_interval.ItemIndex]).Name);
      ini.WriteString('Info','endfield', TbfaAddField(frmContractMgmt.cbx_end.Items.Objects[frmContractMgmt.cbx_end.ItemIndex]).Name);
      ini.WriteString('Info','lastactivatedfield', TbfaAddField(frmContractMgmt.cbx_lastactivated.Items.Objects[frmContractMgmt.cbx_lastactivated.ItemIndex]).Name);
      ini.WriteString('Info','noticefield', TbfaAddField(frmContractMgmt.cbx_notice.Items.Objects[frmContractMgmt.cbx_notice.ItemIndex]).Name);
      ini.WriteString('Info','offset', frmContractMgmt.edt_offset.Text);

      ini.UpdateFile;

//24.04.2018 Ticket 12017 -->
      sFileName := frmContractMgmt.fname;
      linimwvl := tinifile.create(ExtractFilePath(sFileName) + 'List.ini');
      lstrl := Tstringlist.create;
      try
        licounter := linimwvl.ReadInteger('Files', 'Counter', 0);
        if licounter <> 0 then
        begin
          linimwvl.ReadSectionValues('Files', lstrl);
          lbvalue := false;
          for licounter1 := 0 to lstrl.Count - 1 do
          begin
            if pos(lowercase(sFileName), lowercase(lstrl.Strings[licounter1])) > 0 then
            begin
              lbvalue := true;
              break;
            end;
          end;
          if lbvalue then
          begin

          end
          else
          begin
            linimwvl.WriteInteger('Files', 'Counter', licounter + 1);
            linimwvl.WriteString('Files', 'Datei' + inttostr(licounter), sFileName);
          end;
        end
        else
        begin
          linimwvl.WriteInteger('Files', 'Counter', licounter + 1);
          linimwvl.WriteString('Files', 'Datei' + inttostr(licounter), sFileName);
        end;
      finally
        linimwvl.free;
      end;
//24.04.2018 Ticket 12017 <--

    end;
  end;
end;

//procedure TfraAdmin.btnDeleteHolidayClick(Sender: TObject);
//var
  //req: TbfaRequest;
  //user, repl: TbfaUser;
  //datestart, dateend, holid, user_src: string;
  //holidList: TList;
  //i, nrToDel, newIdx: Integer;
  //startdate, enddate: TDateTime;
//begin
  //if lvHoliday.Selected = nil then
    //Exit;
//
  //bitfarmLog.DebugBegin(llDebug, 'btnDeleteHolidayClick', ClassName);
  //try
    ////Mehrfachauswahl fr die Lschung von Urlaubsvertretungen mglich
    //try
      //// da jeweils ein Eintrag aus der Liste gelscht wird muss der
      //// Index mit z und anzahl angepasst werden
      //newIdx := 0;
      //nrToDel := 0;
      //for i := 0 to lvHoliday.Items.Count - 1 do
      //begin
        //newIdx := i - nrToDel;
        //if (lvHoliday.Items[newIdx].Selected) then
        //begin
          //holid := lvHoliday.Items[newIdx].SubItems[3];
          //user_src := lvHoliday.Items[newIdx].SubItems[4];
          //datestart := lvHoliday.Items[newIdx].SubItems[1];
          //dateend :=  lvHoliday.Items[newIdx].SubItems[2];
          //startdate := StrToDate(datestart);
          //enddate := StrToDate(dateend);
          //datestart := FormatDateTime('yyyy-mm-dd', startdate);
          //dateend := FormatDateTime('yyyy-mm-dd', enddate);
//
          //slDeleteHoliday.Add(holid + ';' + user_src + ';' + datestart + ';' + dateend);
          //DeleteFromHolidayList(holid);
          //nrToDel :=nrToDel + 1;
          //SetModified;
        //end;
      //end;
//
      //btnAddHoliday.Enabled := False;
    //except
      //bitfarmLog.Write(llNormal, ltException, 'btnDeleteHolidayClick',
        //ClassName);
    //end;
  //finally
    //bitfarmLog.DebugEnd(llDebug, 'btnDeleteHolidayClick', ClassName);
  //end;
//end;

procedure TfraAdmin.btnDeleteResubClick(Sender: TObject);
var
  lsrefid, liarcid, lidocid: string;
  iCount: Integer;
  req: TbfaRequest;
  param : TStringList;
begin
  if (bfaDBGrid1.DataSource = nil) or (bfaDBGrid1.DataSource.DataSet = nil) then
    Exit;

  if bfaDBGrid1.SelectedRows.Count = 0 then
    Exit;

  param := TStringList.Create;
  param.Delimiter := ';';
  param.StrictDelimiter := True;

  if BfMessageDlg(_('Sind Sie sicher, dass Sie diese Wiedervorlage lschen mchten?')+#13+
          _('(Bei Gruppenwiedervorlagen wird die gesamte Wiedervorlage gelscht!)')
    , mtWarning, [mbYes, mbCancel], True) = mrYes then
  begin
    for iCount := 0 to bfaDBGrid1.SelectedRows.Count -1 do
    begin
      {$IF CompilerVersion >= 26}
      mqResubSearch.GotoBookmark(TBookmark(bfaDBGrid1.SelectedRows.Items[iCount]));
      {$ELSE}
      mqResubSearch.GotoBookmark(Pointer(bfaDBGrid1.SelectedRows.Items[iCount]));
      {$IFEND}

       liarcid := mqResubSearch.fieldbyname('arcid').asstring;
       lidocid := mqResubSearch.fieldbyname('Gdocid').asstring;
       lsrefid := mqResubSearch.fieldbyname('RefID').asstring;
       param.Add(lsrefid + ',' + lidocid);
    end;

    req := TbfaRequest.Create;
    try
      req.ReqType := 'reqDeleteResub';
      req.UserID := bitfarmApp.User.ID;
      req.Profile := bitfarmApp.Profile;
      req.Parameter := param.DelimitedText;
      req.Lang := bitfarmApp.Lang;
      bitfarmApp.MainSocket.SendRequestToServer(req);

      req := bitfarmApp.MainSocket.ReceiveResponse;
      if req = nil then
        Exit;

      if req.ReqType <> 'respOK' then
      begin
        BfShowMessage(_('Fehler beim Lschen einer Wiedervorlage'), nil);
      end
      else
        frmMainForm.CheckResubAction; //28.08.2017 Ticket 11035
    finally
      FreeAndNil(req);
    end;

    mqResubSearch.Refresh;
  end;
  param.Free;

  ShowResubIds;

end;

procedure TfraAdmin.btnDLMClick(Sender: TObject);
var
  req: TbfaRequest;
  lst, lst2 : TList<TbfaBaseObject>;
  xmlstr : WideString;
  i : Integer;
begin
  frmDLMDialog.ShowModal;
end;

procedure TfraAdmin.btnExpandAllClick(Sender: TObject);
var
  i: Integer;
begin
   frmMainForm.FAdminTreeview.FullExpand;
end;

//procedure TfraAdmin.btnGetADClick(Sender: TObject);
//begin
//  slAdUser.Clear;
//  slAdMail.Clear;
//  slAdMemberOf.Clear;
//  slAdDispName.Clear;
//end;

procedure TfraAdmin.btnMemberOfClick(Sender: TObject);
var
  sMemberOf : TStringList;
  frmMemberOf : Tfrm_MemberOf;
begin
  bitfarmLog.DebugBegin(llDebug, 'btnMemberOfClick', ClassName);
  try
    try
      if FCurrentUser <> nil then
      begin
        sMemberOf := TStringList.Create;
        try
          getMembership(FCurrentUser.ID, sMemberOf);
          if sMemberOf.Count > 0 then
          begin
            frmMemberOf := Tfrm_MemberOf.Create(nil);
            try
              frmMemberOf.mmo_MemberOf.Text := StringReplace(sMemberOf.CommaText,
                ',', #13 + #10, [rfReplaceAll]);
              if frmMemberOf.ShowModal = mrOk then
                saveMemberShip(FCurrentUser.Name, sMemberOf);
            finally
              frmMemberOf.Release;
            end;
          end;
        finally
          FreeAndNil(sMemberOf);
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'btnMemberOfClick', ClassName);
    end;
  finally
     bitfarmLog.DebugEnd(llDebug, 'btnMemberOfClick', ClassName);
  end;
end;

//procedure TfraAdmin.btnModifyHolidayClick(Sender: TObject);
//var
  //req: TbfaRequest;
  //user, repl: TbfaUser;
  //datestart, dateend, holid : string;
//begin
  //if lvHoliday.Selected = nil then
    //Exit;
//
  //if (cbxHolidayUser.ItemIndex = -1) or (cbxReplacement.ItemIndex = -1) then
    //Exit;
//
  //bitfarmLog.DebugBegin(llDebug, 'btnModifyHolidayClick', ClassName);
  //try
    //try
      //holid := lvHoliday.Selected.SubItems[3];
      //user := TbfaUser(cbxHolidayUser.Items.Objects[cbxHolidayUser.ItemIndex]);
      //repl := TbfaUser(cbxReplacement.Items.Objects[cbxReplacement.ItemIndex]);
      //datestart := FormatDateTime('yyyy-mm-dd', dtDateStart.Date);
      //dateend := FormatDateTime('yyyy-mm-dd', dtDateEnd.Date);
//
      //if not bitfarmApp.checkholidayloop(user.ID, repl.ID,dtDateStart.Date, dtDateEnd.Date) then
      //begin
        //BfShowMessage(_('Dieser Eintrag ist nicht mglich, da sonst eine zirkulre Vertretung erzeugt wird.'));
        //Exit;
      //end;
//
      //slModifyHoliday.Add(holid+';'+IntToStr(user.ID)+';'+inttostr(repl.ID)+';'+datestart+';'+dateend);
      //SetModified;
      //btnAddHoliday.Enabled := False;
      //ModifyHolidayList(holid, user.Name, repl.Name, dtDateStart.Text, dtDateEnd.Text);
//
    //except
      //bitfarmLog.Write(llNormal, ltException, 'btnModifyHolidayClick', ClassName);
    //end;
  //finally
     //bitfarmLog.DebugEnd(llDebug, 'btnModifyHolidayClick', ClassName);
  //end;
//end;

procedure TfraAdmin.btnOffsetDecClick(Sender: TObject);
begin
  if FAdminLogOffset > 0 then
  begin
    Dec(FAdminLogOffset);
    btnSearchLogClick(Sender);
  end;

end;

procedure TfraAdmin.btnOffsetIncClick(Sender: TObject);
begin
  Inc(FAdminLogOffset);
  btnOffsetDec.Enabled := True;
  btnSearchLogClick(Sender);

end;

//18.07.2024 SD -->bfacrm:ticket__show__21571
procedure TfraAdmin.btnSaveHistoryToFileClick(Sender: TObject);
begin
  SaveHistoryToFile
end;

//21.08.2024 SD -->bfacrm:ticket__show__39655
//procedure TfraAdmin.SaveHistoryToFile;
//var
//  qryusr: TUniQuery;
//  req: TbfaRequest;
//  sock: TSocketConnection;
//  hist : TList<TbfaHistory>;
//  sHistory, param: TStringList;
//  query, sItem, sFileName: String;
//  i, j, maxDate, maxGdocid, maxName, maxMessage, qSpace: Integer;
//begin
//  bitfarmLog.DebugBegin(llDebug, 'SaveHistoryToFile', ClassName);
//  try
//    try
//      qryusr := DbCreateQuery;
//      sHistory := TStringList.Create;
//      try
//        param := TStringList.Create;
//        param.Delimiter := ';';
//        param.StrictDelimiter := True;
//        query := '';
//
//        if rbDocHistory.Checked then
//        begin
//          if (edtLogGdocid.Text <> '') then
//          begin
//            param.Add('gdocid:' + ParseSQLString(edtLogGdocid.Text));
//            query := 'gdocid = ' + ParseSQLString(edtLogGdocid.Text);
//          end else begin
//            param.Add('gdocid_neg:0');
//            query := 'gdocid <> 0';
//          end;
//        end else
//          query := 'gdocid = 0';
//
//        param.Add('limit:100');
//        param.Add('offset:' + IntToStr(FAdminLogOffset * 100));
//
//        if cbxLogUser.ItemIndex > -1 then
//        begin
//          param.Add('userid:' + IntToStr(TbfaUser(cbxLogUser.Items.Objects[cbxLogUser.ItemIndex]).ID));
//          if query <> '' then
//            query := query + ' and ';
//          query := query + 'userid = ' + IntToStr(TbfaUser(cbxLogUser.Items.Objects[cbxLogUser.ItemIndex]).ID);
//        end;
//        if dtDateLogStart.Text <> '' then
//        begin
//          param.Add('datefrom:' + FormatDateTime('yyyy-mm-dd', dtDateLogStart.Date));
//          if query <> '' then
//            query := query + ' and ';
//          query := query + 'tstamp >= ' + #39 + FormatDateTime('yyyy-mm-dd', dtDateLogStart.Date) + #39;
//        end;
//        if dtDateLogEnd.Text <> '' then
//        begin
//          param.Add('dateto:' + FormatDateTime('yyyy-mm-dd', IncDay(dtDateLogEnd.Date, 1)));
//          if query <> '' then
//            query := query + ' and ';
//          query := query + 'tstamp <= ' + #39 + FormatDateTime('yyyy-mm-dd', dtDateLogEnd.Date) + #39;
//        end;
//
//        if query <> '' then
//        begin
//          qryusr.SQL.Text := 'select count(*) from sys_history where ' + query;
//          qryusr.Execute;
//          if qryusr.RecordCount > 0 then
//          begin
//            sock := TSocketConnection.Create(bitfarmApp.bfaServerNoSSL, bitfarmApp.bfaServer, bitfarmApp.bfaServerPort, '');
//
//            sock.CreateComponents;
//            if sock.Connect then
//            begin
//              req := TbfaRequest.Create;
//              try
//                req.ReqType := 'reqHistory';
//                req.UserID := bitfarmApp.User.ID;
//                req.Gdocid := 0;
//                req.Profile := bitfarmApp.Profile;
//                req.Lang := bitfarmApp.Lang;
//                req.Parameter := param.DelimitedText;
//                sock.SendRequestToServer(req);
//                hist := TList<TbfaHistory>.Create;
//
//                req := sock.ReceiveHistory(hist);
//                sock.Disconnect;
//
//                maxDate := 6;
//                maxGdocid := 6;
//                maxName := 8;
//                maxMessage := 10;
//                for i := 0 to hist.Count - 1 do
//                begin
//                  if Length(DateTimeToStr(hist[i].Date)) > maxDate then
//                    maxDate := Length(DateTimeToStr(hist[i].Date));
//                  if Length(IntToStr(hist[i].Gdocid)) > maxGdocid then
//                    maxGdocid := Length(IntToStr(hist[i].Gdocid));
//                  if Length(hist[i].UserName) > maxName then
//                    maxName := Length(hist[i].UserName);
//                  if Length(hist[i].Msg) > maxMessage then
//                    maxMessage := Length(hist[i].Msg);
//                end;
//                sItem := _('Datum');
//                qSpace := maxDate - (Length(sItem) - 1);
//                for i := 0 to qSpace do sItem := sItem + ' ';
//                sItem := sItem + 'Gdocid';
//                qSpace := maxGdocid - (Length('Gdocid') - 1);
//                for i := 0 to qSpace do sItem := sItem + ' ';
//                sItem := sItem + _('Benutzer');
//                qSpace := maxName - (Length(_('Benutzer')) - 1);
//                for i := 0 to qSpace do sItem := sItem + ' ';
//                sItem := sItem + _('Eintrag');
//                sHistory.Add(sItem);
//                sItem := '';
//                for i := 0 to maxDate + maxGdocid + maxName + maxMessage + 3 do sItem := sItem + '=';
//                sHistory.Add(sItem);
//                for i := 0 to hist.Count - 1 do
//                begin
//                  sItem := DateTimeToStr(hist[i].Date);
//                  qSpace := maxDate - Length(DateTimeToStr(hist[i].Date)) + 1;
//                  for j := 0 to qSpace do sItem := sItem + ' ';
//                  sItem := sItem + IntToStr(hist[i].Gdocid);
//                  qSpace := maxGdocid - Length(IntToStr(hist[i].Gdocid)) + 1;
//                  for j := 0 to qSpace do sItem := sItem + ' ';
//                  sItem := sItem + hist[i].UserName;
//                  qSpace := maxName - Length(hist[i].UserName) + 1;
//                  for j := 0 to qSpace do sItem := sItem + ' ';
//                  sItem := sItem + hist[i].Msg;
//                  sHistory.Add(sItem);
//                end;
//                if sHistory.Count > 0 then
//                begin
//                  if rbDocHistory.Checked then
//                    sFileName := 'History_log_'
//                  else
//                    sFileName := 'Admin_log_';
//                  if cbxLogUser.ItemIndex > -1 then
//                    sFileName := sFileName + TbfaUser(cbxLogUser.Items.Objects[cbxLogUser.ItemIndex]).Name + '_';
//
//                  sFileName := sFileName + '_' + FormatDateTime('yyyy-mm-dd', Now());
//                  saveAdminLog(sFileName, sHistory, rbDocHistory.Checked);
//
//                end;
//              finally
//                FreeAndNil(req);
//                FreeAndNil(sock);
//              end;
//            end;
//          end;
//        end;
//      finally
//        FreeAndNil(qryusr);
//        FreeAndNil(sHistory);
//      end;
//    except
//      bitfarmLog.Write(llNormal, ltException, 'SaveHistoryToFile', ClassName);
//    end;
//  finally
//    bitfarmLog.DebugEnd(llDebug, 'SaveHistoryToFile', ClassName);
//  end;
//end;
//18.07.2024 SD <--bfacrm:ticket__show__21571

procedure TfraAdmin.SaveHistoryToFile;
var
  req: TbfaRequest;
  sock: TSocketConnection;
  hist : TList<TbfaHistory>;
  sHistory, param: TStringList;
  sItem, sFileName, nFilename, logEntry, logMsg: String;
  i, j, maxDate, maxGdocid, maxName, maxMessage, histCount, qSpace, LogLimit, LogOffset, PosDrop: Integer;
  paramSelected, isFileSelected : Boolean;
begin
  bitfarmLog.DebugBegin(llDebug, 'SaveHistoryToFile', ClassName);
  try
    try
      sHistory := TStringList.Create;
      try
        param := TStringList.Create;
        param.Delimiter := ';';
        param.StrictDelimiter := True;
        paramSelected := False;
        logEntry := LowerCase(Trim(edtLogEntry.Text));

        if rbDocHistory.Checked then
        begin
          if (edtLogGdocid.Text <> '') then
          begin
            param.Add('gdocid:' + ParseSQLString(edtLogGdocid.Text));
            paramSelected := True;
          end else begin
            param.Add('gdocid_neg:0');
          end;
        end;

        if cbxLogUser.ItemIndex > -1 then
        begin
          param.Add('userid:' + IntToStr(TbfaUser(cbxLogUser.Items.Objects[cbxLogUser.ItemIndex]).ID));
          paramSelected := True;
        end;
        if dtDateLogStart.Text <> '' then
        begin
          param.Add('datefrom:' + FormatDateTime('yyyy-mm-dd', dtDateLogStart.Date));
          paramSelected := True;
        end;
        if dtDateLogEnd.Text <> '' then
        begin
          param.Add('dateto:' + FormatDateTime('yyyy-mm-dd', IncDay(dtDateLogEnd.Date, 1)));
          paramSelected := True;
        end;
        if (logEntry <> '') then
          paramSelected := True;

        if paramSelected then
        begin
          LogLimit := 1000;
          LogOffset := 0;
        end
        else
        begin
          LogLimit := 100;
          LogOffset := FAdminLogOffset;
        end;

        param.Add('limit:' + IntToStr(LogLimit));
        param.Add('offset:' + IntToStr(LogOffset * LogLimit));
        isFileSelected := False;

        sock := TSocketConnection.Create(bitfarmApp.bfaServerNoSSL, bitfarmApp.bfaServer, bitfarmApp.bfaServerPort, '');
        sock.CreateComponents;
        if sock.Connect then
        begin
          req := TbfaRequest.Create;
          try
            req.ReqType := 'reqHistory';
            req.UserID := bitfarmApp.User.ID;
            req.Gdocid := 0;
            req.Profile := bitfarmApp.Profile;
            req.Lang := bitfarmApp.Lang;
            while LogOffset <> -1 do
            begin
              req.Parameter := param.DelimitedText;
              sock.SendRequestToServer(req);
              hist := TList<TbfaHistory>.Create;

              req := sock.ReceiveHistory(hist);
              sock.Disconnect;

              maxDate := 6;
              maxGdocid := 6;
              maxName := 8;
              maxMessage := 10;
              histCount := 0;
              for i := 0 to hist.Count - 1 do
              begin
                if (logEntry <> '') then
                begin
                  logMsg := LowerCase(Trim(hist[i].Msg));
                  if Pos(logEntry, logMsg) = 0 then
                    Continue;
                end;
                if Length(DateTimeToStr(hist[i].Date)) > maxDate then
                  maxDate := Length(DateTimeToStr(hist[i].Date));
                if Length(IntToStr(hist[i].Gdocid)) > maxGdocid then
                  maxGdocid := Length(IntToStr(hist[i].Gdocid));
                if Length(hist[i].UserName) > maxName then
                  maxName := Length(hist[i].UserName);
                if Length(hist[i].Msg) > maxMessage then
                  maxMessage := Length(hist[i].Msg);
                Inc(histCount);
              end;
              sItem := _('Datum');
              qSpace := maxDate - (Length(sItem) - 1);
              for i := 0 to qSpace do sItem := sItem + ' ';
              sItem := sItem + 'Gdocid';
              qSpace := maxGdocid - (Length('Gdocid') - 1);
              for i := 0 to qSpace do sItem := sItem + ' ';
              sItem := sItem + _('Benutzer');
              qSpace := maxName - (Length(_('Benutzer')) - 1);
              for i := 0 to qSpace do sItem := sItem + ' ';
              sItem := sItem + _('Eintrag');
              sHistory.Add(sItem);
              sItem := '';
              for i := 0 to maxDate + maxGdocid + maxName + maxMessage + 3 do sItem := sItem + '=';
              sHistory.Add(sItem);
              for i := 0 to hist.Count - 1 do
              begin
                if (logEntry <> '') then
                begin
                  logMsg := LowerCase(Trim(hist[i].Msg));
                  if Pos(logEntry, logMsg) = 0 then
                    Continue;
                end;
                sItem := DateTimeToStr(hist[i].Date);
                qSpace := maxDate - Length(DateTimeToStr(hist[i].Date)) + 1;
                for j := 0 to qSpace do sItem := sItem + ' ';
                sItem := sItem + IntToStr(hist[i].Gdocid);
                qSpace := maxGdocid - Length(IntToStr(hist[i].Gdocid)) + 1;
                for j := 0 to qSpace do sItem := sItem + ' ';
                sItem := sItem + hist[i].UserName;
                qSpace := maxName - Length(hist[i].UserName) + 1;
                for j := 0 to qSpace do sItem := sItem + ' ';
                sItem := sItem + hist[i].Msg;
                sHistory.Add(sItem);
              end;
              if sHistory.Count > 0 then
              begin
                if isFileSelected then
                begin
                  nFilename := sFileName;
                  PosDrop := LastDelimiter('.', nFilename);
                  Insert('_' + IntToStr(LogOffset), nFilename, PosDrop);
                  if histCount < LogLimit then
                    nFilename := saveAdminLog(nFilename, sHistory, rbDocHistory.Checked, False, True)
                  else
                    nFilename := saveAdminLog(nFilename, sHistory, rbDocHistory.Checked, False, False);
                  if nFilename = '' then
                     LogOffset := -1;
                end
                else
                begin
                  if rbDocHistory.Checked then
                    sFileName := 'History_log_'
                  else
                    sFileName := 'Admin_log_';
                  if cbxLogUser.ItemIndex > -1 then
                  sFileName := sFileName + TbfaUser(cbxLogUser.Items.Objects[cbxLogUser.ItemIndex]).Name + '_';
                  sFileName := sFileName + '_' + FormatDateTime('yyyy-mm-dd', Now());
                  if paramSelected then
                  begin
                    if histCount < LogLimit then
                      sFileName := saveAdminLog(sFileName, sHistory, rbDocHistory.Checked, True, True)
                    else
                      sFileName := saveAdminLog(sFileName, sHistory, rbDocHistory.Checked, True, False);
                  end
                  else
                    sFileName := saveAdminLog(sFileName, sHistory, rbDocHistory.Checked, True, True);
                  if (not paramSelected) or (sFileName = '') then
                  begin
                    FreeAndNil(req);
                    FreeAndNil(sock);
                    Break
                  end;
                  isFileSelected := True;
                end;
              end;
              sHistory.Clear;
              if histCount < LogLimit then
                LogOffset := -1
              else
              begin
                Inc(LogOffset);
                param[param.Count - 1] := 'offset:' + IntToStr(LogOffset * LogLimit);
              end;

            end;
          finally
            FreeAndNil(req);
            FreeAndNil(sock);
          end;
        end;
      finally
        FreeAndNil(sHistory);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'SaveHistoryToFile', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SaveHistoryToFile', ClassName);
  end;
end;
//21.08.2024 SD <--bfacrm:ticket__show__39655

procedure TfraAdmin.btnReportClick(Sender: TObject);
var
  frmChoseReport: TfrmChoseReport;
begin
  bitfarmLog.DebugBegin(llDebug, 'btnReportClick', ClassName);
  try
    try
      frmChoseReport := TfrmChoseReport.Create(nil);
      frmChoseReport.Color := stlControl.Color;
      frmChoseReport.Font.Color := stlControl.TextColor;
      frmChoseReport.cbxReport.Color := stlControl.Color;
      frmChoseReport.cbxReport.Font.Color := stlControl.TextColor;
      frmChoseReport.ShowModal;

      if frmChoseReport.ModalResult = mrOK then
      begin
        if frmChoseReport.cbxReport.ItemIndex = 0 then
          CreateListUsersReport   //27.06.2024 SD <--bfacrm:ticket__show__39119
        else if frmChoseReport.cbxReport.ItemIndex = 1 then
          CreatePropertiesUsersReportCSV    //25.07.2024 SD <--bfacrm:ticket__show__39458
        else if frmChoseReport.cbxReport.ItemIndex = 2 then
          CreateUserReport
        else if frmChoseReport.cbxReport.ItemIndex = 3 then
          CreateGroupReport
        else if frmChoseReport.cbxReport.ItemIndex = 4 then
          CreateArchiveReport(True, True, True)
        else if frmChoseReport.cbxReport.ItemIndex = 5 then
          CreateArchiveReport(False, True, False)
        else if frmChoseReport.cbxReport.ItemIndex = 6 then
          CreateArchiveReport(True, False, False)
        else if frmChoseReport.cbxReport.ItemIndex = 7 then
          CreateArchiveReport(False, False, True);
      end;
    except
      on e: exception do
        bitfarmLog.Write(llNormal, ltException, 'btnReportClick' + e.Message, ClassName);
    end;
  finally
    frmChoseReport.Release;
    frmChoseReport.Free;
    bitfarmLog.DebugEnd(llDebug, 'btnReportClick', ClassName);
  end;
end;

procedure TfraAdmin.getMembership(UserID: Integer; SList: TStringList);
var
  qry: TUniQuery;
  GroupList: TStringList;
begin
  bitfarmLog.DebugBegin(llDebug, 'getMembership', ClassName);
  try
    try
      qry := TUniQuery.Create(nil);
      try
        qry.Connection := dmMain.cntMain;

        qry.SQL.Text := 'select * from sys_user where userid = ' + IntToStr(UserID) + ';';
        qry.Execute;
        if qry.RecordCount > 0 then
        begin
          qry.First;
          SList.Add(_('Name: ') + qry.FieldByName('username').AsString);
          SList.Add(_('Email: ') + qry.FieldByName('usermail').AsString);
          if Pos('enabled', qry.FieldByName('Flags').AsString) > 0 then
  	        SList.Add(_('gesperrt: nein'))
      		else
          	SList.Add(_('gesperrt: ja'));
//          if Pos('from_ad', qry.FieldByName('Flags').AsString) > 0 then
//	          SList.Add(_('AD-Abgleich: ja'))
//   		    else
//         	  SList.Add(_('AD-Abgleich: nein'));
        end;

        qry.SQL.Text := 'select sg.* from sys_groupuser sgu LEFT JOIN sys_group sg ON ' +
          '(sgu.groupid = sg.groupid) where ((sg.flags & 2) = 0) AND (sgu.userid = ' + IntToStr(UserID) + ');';
        qry.Execute;
        if qry.RecordCount > 0 then
        begin
          SList.Add('');
          SList.Add(_('Mitgliedschaft:'));
          qry.First;
          while not qry.Eof do
          begin
//13.09.2024            SList.Add(qry.FieldByName('groupname').AsString);
            SList.Add(bitfarmApp.TranslateGroupName(qry.FieldByName('groupname').AsString));
            qry.Next;
          end;

        end;

        GroupList := TStringList.Create;
        try
          qry.SQL.Text := 'select * from sys_groupuser where userid = ' + IntToStr(UserID);
          qry.Execute;
          if qry.RecordCount > 0 then
          begin
            qry.First;
            while not qry.Eof do
            begin
               GroupList.Add(qry.FieldByName('groupid').AsString);
               qry.Next;
            end;
          end;

          if GroupList.Count > 0 then
            qry.SQL.Text := 'select arc.arcname, lgr.arcname as lgrname from sys_arcxs as a ' +
              'left join sys_arc as arc on (a.arcid = arc.arcid) ' +
              'left join sys_arc as lgr on (arc.lgrid = lgr.arcid) '+
              'where ((userid = ' + inttostr(UserID) + ') OR (userid = 0 AND ' +
              'groupid IN (' + GroupList.CommaText + '))) ' +
              'group by a.arcid order by arc.arcname, lgr.arcname;'
          else
            qry.SQL.Text := 'select arc.arcname, lgr.arcname as lgrname from sys_arcxs as a ' +
              'left join sys_arc as arc on (a.arcid = arc.arcid) ' +
              'left join sys_arc as lgr on (arc.lgrid = lgr.arcid) '+
              'where (userid = ' + inttostr(UserID) + ')' +
              'group by a.arcid order by arc.arcname, lgr.arcname;';

          qry.Execute;
          if qry.RecordCount > 0 then
          begin
            SList.Add('');
            SList.Add(_('Archive:'));
            qry.First;
            while not qry.Eof do
            begin
              SList.Add(qry.FieldByName('arcname').AsString +
                #9 + ' ['+  qry.FieldByName('lgrname').AsString + ']');
              qry.Next;
            end;

          end;
        finally
          FreeAndNil(GroupList);
        end;

      finally
        FreeAndNil(qry);
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'getMembership', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'getMembership', ClassName);
  end;
end;

procedure TfraAdmin.saveMemberShip(sUser: string; sText: TStringList; isGroups: Boolean = False);
var
  sFileName: string;
begin
  bitfarmLog.DebugBegin(llDebug, 'saveMemberShip', ClassName);
  try
    try
      if isGroups then
      begin
        sFileName := 'bitfarm-GroupReport_' + sUser + '.txt';

        if PromptForFileName(sFilename, 'Text-Dateien (*.TXT)|*.TXT', 'txt',
          _('Group-Report erstellen...'), '', True) then
        begin
          if sFilename <> '' then
          begin
            sText.SaveToFile(sFileName);
            BfShowMessage(_('Group-Report wurde erstellt.'), nil);
          end;
        end;
      end else
      begin
        sFileName := 'bitfarm-UserReport_' + sUser + '.txt';

      if PromptForFileName(sFilename, 'Text-Dateien (*.TXT)|*.TXT', 'txt',
        _('User-Report erstellen...'), '', True) then
      begin
        if sFilename <> '' then
        begin
          sText.SaveToFile(sFileName);
          BfShowMessage(_('User-Report wurde erstellt.'), nil);
        end;
      end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'saveMemberShip', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'saveMemberShip', ClassName);
  end;
end;

//21.08.2024 SD -->bfacrm:ticket__show__39655
//18.07.2024 SD -->bfacrm:ticket__show__21571
//procedure TfraAdmin.saveAdminLog(sFileName: string; sText: TStringList; ItsHistory: Boolean);
//var
//  Msg: string;
//begin
//  bitfarmLog.DebugBegin(llDebug, 'saveAdminLog', ClassName);
//  try
//    try
//
//      sFileName := sFileName + '.txt';
//
//      if ItsHistory then
//        Msg := _('Historie erstellen...')
//      else
//        Msg := _('Log erstellen...');
//
//
//      if PromptForFileName(sFilename, _('Text-Dateien (*.TXT)|*.TXT'), 'txt',
//        Msg, '', True) then
//      begin
//        if sFilename <> '' then
//        begin
//          sText.SaveToFile(sFileName);
//          if ItsHistory then
//            BfShowMessage(_('Historie gespeichert.'), nil)
//          else
//            BfShowMessage(_('Log gespeichert.'), nil);
//        end;
//      end;
//
//    except
//      bitfarmLog.Write(llNormal, ltException, 'saveAdminLog', ClassName);
//    end;
//  finally
//    bitfarmLog.DebugEnd(llDebug, 'saveAdminLog', ClassName);
//  end;
//end;
//18.07.2024 SD <--bfacrm:ticket__show__21571

function TfraAdmin.saveAdminLog(sFileName: string; sText: TStringList; ItsHistory: Boolean; withDialog: Boolean = True; withMsg: Boolean = True): String;
var
  fullFileName, Msg: string;
  PosDrop: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'saveAdminLog', ClassName);
  try
    try

      fullFileName := sFileName;

      if withDialog then
      begin
        if ItsHistory then
          Msg := _('Historie erstellen...')
        else
          Msg := _('Log erstellen...');

        if not PromptForFileName(fullFileName, _('Text-Dateien (*.TXT)|*.TXT'), 'txt',
          Msg, '', True) then
        begin
          Result := '';
          Exit;
        end

      end;
      if fullFileName <> '' then
      begin
        sText.SaveToFile(fullFileName);
        if withMsg then
          if ItsHistory then
            BfShowMessage(_('Historie gespeichert.'), nil)
          else
            BfShowMessage(_('Log gespeichert.'), nil);
      end;

    except
      Result := '';
      bitfarmLog.Write(llNormal, ltException, 'saveAdminLog', ClassName);
    end;
  finally
    Result := fullFileName;

    bitfarmLog.DebugEnd(llDebug, 'saveAdminLog', ClassName);
  end;
end;
//21.08.2024 SD <--bfacrm:ticket__show__39655

//25.07.2024 SD -->bfacrm:ticket__show__39458
procedure TfraAdmin.saveReportCSV(sReportName: string; sText: TStringList);
var
  sFileName: string;
begin
  bitfarmLog.DebugBegin(llDebug, 'saveReportCSV', ClassName);
  try
    try

      sFileName := 'Report_' + sReportName + '.csv';

      if PromptForFileName(sFilename, _('CSV-Dateien (*.CSV)|*.CSV'), 'csv',
        _('User-Report erstellen...'), '', True) then
      begin
        if sFilename <> '' then
        begin
          try
            sText.SaveToFile(sFileName);
            BfShowMessage(sReportName + _(' gespeichert.'), nil)
          except
            on e: Exception do
            begin
              bitfarmLog.Write(llNormal, ltException, _('Problem beim Speichern einer csv-Datei ') + sFilename + _(', Fehler: ') + e.message, ClassName);
            end;
          end;
        end;
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'saveReportCSV', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'saveReportCSV', ClassName);
  end;
end;
//25.07.2024 SD <--bfacrm:ticket__show__39458

procedure TfraAdmin.btnResetSearchClick(Sender: TObject);
begin
   edtArcid.Text := '';
   edtGdocid.Text := '';
   edtTimref.Text := '';
   cbxResubUser.ItemIndex := -1;
   cbxResubSearchMode.ItemIndex := 0;
   dtResubDate.Text := '';

   mqResubSearch.Close;
end;

procedure TfraAdmin.btnUnCheckAllClick(Sender: TObject);
var
  i: Integer;
begin
  frmMainForm.FAdminTreeview.CheckChilds := True;
  try
    for i := 0 to frmMainForm.FAdminTreeview.Items.Count -1 do
      frmMainForm.FAdminTreeview.Checked[frmMainForm.FAdminTreeview.Items.Item[i]] := frmMainForm.FAdminTreeview.Items.Item[i].Selected;
    bitfarmApp.CountChecked;
  finally
    frmMainForm.FAdminTreeview.CheckChilds := False;
  end;
end;

procedure TfraAdmin.btnUserInfoClick(Sender: TObject);
var
  frmLoggedinUser: TfrmLoggedinUser;
  req: TbfaRequest;
begin
  bitfarmLog.DebugBegin(llDebug, 'btnUserInfoClick', ClassName);
  try
    try
      req := TbfaRequest.Create;
      try
        req.ReqType := 'reqLoggedonUser';
        req.UserID := bitfarmApp.User.ID;
        req.Profile := bitfarmApp.Profile;
        req.Lang := bitfarmApp.Lang;
        bitfarmApp.MainSocket.SendRequestToServer(req);

        req := bitfarmApp.MainSocket.ReceiveResponse;
        if req = nil then
          Exit;

        if req.ReqType = 'respError' then
          BfShowMessage(_(''))
        else begin
          frmLoggedinUser := TfrmLoggedinUser.Create(nil);
          frmLoggedinUser.Color := stlControl.Color;
          frmLoggedinUser.Font.Color := stlControl.TextColor;
          frmLoggedinUser.lstUser.Color := stlControl.Color;
          frmLoggedinUser.lstUser.Font.Color := stlControl.TextColor;
          frmLoggedinUser.lstloggedon.CommaText := req.DataString;
          frmLoggedinUser.FillList;
          frmLoggedinUser.ShowModal;
          frmLoggedinUser.lstUser.Clear;
          frmLoggedinUser.Free;
        end;
      finally
        FreeAndNil(req);
      end;

    except
      on e: exception do
        bitfarmLog.Write(llNormal, ltException, 'btnUserInfoClick' + e.Message, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'btnUserInfoClick', ClassName);
  end;

end;

procedure TfraAdmin.cbxAddfieldTypeChange(Sender: TObject);
var
  newtype: Integer;
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentAddfield = nil then
    Exit;

    // fr ein neues Zusatfeld kann man nicht Grid Spalte auswhlen
  if (FCurrentAddfield.ID = -1) and (cbxAddfieldType.ItemIndex = cbxAddfieldType.Items.IndexOf(_('Grid Spalte'))) then
  begin
    cbxAddfieldType.ItemIndex := 0;
    Exit;
  end;

  if FCurrentAddfield.Typ = 13 then   // Grid Feld kann man nicht ndern
  begin
    cbxAddfieldType.ItemIndex := cbxAddfieldType.Items.IndexOf(_('Grid Feld'));
    Exit;
  end;

  if FCurrentAddfield.Typ = 14 then   // Grid Spalte kann man nicht ndern
  begin
    cbxAddfieldType.ItemIndex := cbxAddfieldType.Items.IndexOf(_('Grid Spalte'));
    Exit;
  end;

  newtype := TbfaInt(cbxAddfieldType.Items.Objects[cbxAddfieldType.ItemIndex]).Value;
  if FCurrentAddfield.ID <> -1 then
  begin
    if newtype in [13, 14] then   // man kann keine anderen Felder in Gridfelder oder Spalten ndern
    begin
      cbxAddfieldType.ItemIndex := IndexOfTbfaInt(AddfieldTypes, FCurrentAddfield.Typ);
      Exit;
    end;

    if ((not FCurrentAddfield.Typ in [1,12]) and (newtype in [1,12])) or    // nicht Datum auf Datum
       ((FCurrentAddfield.Typ in [0,1,2,3,11]) and (newtype in [5,6,7,8])) or  //universal,datum,auswahl,mehrfach nach zahlenfelder
       ((FCurrentAddfield.Typ in [5]) and (newtype in [6,7,8])) or  //interval nach Zahlenfelder
       ((FCurrentAddfield.Typ in [6]) and (newtype in [5])) or         // ganzzahl nach interval
       ((FCurrentAddfield.Typ in [7]) and (newtype in [5,6,8])) or     // fliekomma nach interval,ganzzahl,whrung
       ((FCurrentAddfield.Typ in [8]) and (newtype in [5,6]))          //whrung nach interval, ganzzahl
    then begin
      if BfMessageDlg(_('Achtung! Bei der Umwandlung zwischen diesen Feldtypen kann es zu Datenverlusten kommen. Fortfahren?'),
        mtConfirmation, mbOKCancel, True) = mrCancel then
      begin
        cbxAddfieldType.ItemIndex := IndexOfTbfaInt(AddfieldTypes, FCurrentAddfield.Typ);
        Exit;
      end;
    end;
  end else
  begin
    // Datum, Interval, Ganzzahl, Fliekomma, Whrung, DLM Datumsfeld
    // -> Suchmethode Exakt
    if newtype in [1,5,6,7,8,12] then
      FCurrentAddfield.Mode := 0;
    // Mehrfachauswahl und Gridfeld, bzw Spalte
    if newtype in [3,13,14] then
      FCurrentAddfield.Mode := 3;
  end;
  FCurrentAddfield.Typ := newtype;
  FCurrentAddfield.Modified := True;

  if (FCurrentAddfield.Typ = 11)  then
  begin
    chkStrictmode.Checked := True;
    FCurrentAddfield.Options := FCurrentAddfield.Options or 8;
  end;

  if (not (FCurrentAddfield.Typ in [2,3,11])) and (chkStrictmode.Checked) then
  begin
    chkStrictmode.Checked := False;
    FCurrentAddfield.Options := FCurrentAddfield.Options and not 8;
  end;
  ShowAddfieldProperties(FCurrentAddfield);
  SetModified;
end;

procedure TfraAdmin.cbxArcRightsChange(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;

  if cbxArcRights.ItemIndex = -1 then
    Exit;

  ShowArchiveRights(TbfaInt64(cbxArcRights.Items.Objects[cbxArcRights.ItemIndex]).Value);
  chbxArchiveRightsClickCheck(Sender);
end;

procedure TfraAdmin.cbxGroupRoleChange(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentGroup = nil then
    Exit;

  FCurrentGroup.Role := TbfaInt64(cbxGroupRole.Items.Objects[cbxGroupRole.ItemIndex]).Value;
  FCurrentGroup.Modified := True;

  SetModified;
end;

procedure TfraAdmin.cbxIntervalChange(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentArchive = nil then
    Exit;

  if (cbxInterval.ItemIndex > 0) and (edtDuration.Value = 0) then
    edtDuration.Value := 1
  else if (cbxInterval.ItemIndex = 0) then
    edtDuration.Value := 0;
  FCurrentArchive.Duration := Trunc(edtDuration.Value);
  FCurrentArchive.Interval := Intervals[cbxInterval.ItemIndex];
  FCurrentArchive.Modified := True;
  FCurrentArchive.Modified_Expired := True;

  SetModified;
end;

procedure TfraAdmin.cbxIntervalCloseUp(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentArchive = nil then
    Exit;

  if (cbxInterval.ItemIndex > 0) and (edtDuration.Value = 0) then
    edtDuration.Value := 1
  else if (cbxInterval.ItemIndex = 0) then
    edtDuration.Value := 0;
  FCurrentArchive.Duration := Trunc(edtDuration.Value);
  FCurrentArchive.Interval := Intervals[cbxInterval.ItemIndex];
  FCurrentArchive.Modified := True;
  FCurrentArchive.Modified_Expired := True;

  SetModified;
end;

procedure TfraAdmin.cbxLinkTypeChange(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentStateField = nil then
    Exit;

  FCurrentStateField.Func := TbfaInt(cbxLinkType.Items.Objects[cbxLinkType.ItemIndex]).Value;
  FCurrentStateField.Modified := True;

  ShowStatefieldProperties(FCurrentStateField);
  SetModified;
end;

procedure TfraAdmin.cbxResubSearchModeKeyPress(Sender: TObject; var Key: Char);
begin
  DisableBeep(Key); //11.03.2024 bfacrm:ticket__show__38134
end;

procedure TfraAdmin.cbxSearchModeChange(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentAddfield = nil then
    Exit;

  FCurrentAddfield.Mode := TbfaInt(cbxSearchMode.Items.Objects[cbxSearchMode.ItemIndex]).Value;
  FCurrentAddfield.Modified := True;

  SetModified;
end;

procedure TfraAdmin.cbxStatefieldLinkChange(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentStateField = nil then
    Exit;

  FCurrentStateField.AddfieldID := TbfaAddField(cbxStatefieldLink.Items.Objects[cbxStatefieldLink.ItemIndex]).ID;
  FCurrentStateField.Modified := True;

  SetModified;
end;

procedure TfraAdmin.cbxUserRoleChange(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentUser = nil then
    Exit;

  FCurrentUser.Role := TbfaInt64(cbxUserRole.Items.Objects[cbxUserRole.ItemIndex]).Value;
  FCurrentUser.Modified := True;

  SetModified;
end;

procedure TfraAdmin.chbxAddfieldRightsClick(Sender: TObject);
begin
  if chbxAddfieldRights.Checked[chbxAddfieldRights.ItemIndex] then
    Exit
  else
    chbxAddfieldRightsClickCheck(Sender);
end;

procedure TfraAdmin.chbxAddfieldRightsClickCheck(Sender: TObject);
var
  i, j, k, m, id, idx, arcid: Integer;
  right: Int64;
  arc: TbfaArchive;
  field: TbfaAddField;
  fieldrights: TList<TbfaFieldRight>;
begin

  right := 0;
  if chbxAddfieldRights.ItemIndex = 0 then
  begin
    right := (right or 1);
    chbxAddfieldRights.Checked[0] := True;
    chbxAddfieldRights.Checked[1] := False;
    chbxAddfieldRights.Checked[2] := False;
  end
  else if chbxAddfieldRights.ItemIndex = 1 then
  begin
    right := (right or 2);
    chbxAddfieldRights.Checked[0] := False;
    chbxAddfieldRights.Checked[1] := True;
    chbxAddfieldRights.Checked[2] := False;
  end
  else if chbxAddfieldRights.ItemIndex = 2 then
  begin
    right := (right or 4);
    chbxAddfieldRights.Checked[0] := False;
    chbxAddfieldRights.Checked[1] := False;
    chbxAddfieldRights.Checked[2] := True;
  end;

  if frmMainForm.FAdminTreeview.CountChecked > 0 then
  begin
    for i := 0 to frmMainForm.FAdminTreeview.Items.Count -1 do
    begin
      if not frmMainForm.FAdminTreeview.Checked[frmMainForm.FAdminTreeview.Items.Item[i]] then
        Continue;

      arcid := PbfaInt64(frmMainForm.FAdminTreeview.Items.Item[i].Data).Value;

      arc := GetArchiveByID(arcid);
      if arc <> nil then
      begin
        for k := 0 to bfsAssignAddfields.lvList2.Items.Count -1 do
        begin
          if bfsAssignAddfields.lvList2.Items[k].Selected then
          begin
            field := TbfaAddField(bfsAssignAddfields.lvList2.Items[k].Data);

            for j := 0 to bfsAddfieldsUser.lvList2.Items.Count -1 do
            begin
              if bfsAddfieldsUser.lvList2.Items[j].Selected then
              begin
                if TObject(bfsAddfieldsUser.lvList2.Items[j].Data) is TbfaUser then
                begin
                  id := TbfaUser(bfsAddfieldsUser.lvList2.Items[j].Data).ID;
                  idx := arc.Addfields.IndexOf(IntToStr(field.ID));
                  if idx > -1 then
                  begin
                    fieldrights := TList<TbfaFieldRight>(arc.Addfields.Objects[idx]);
                    for m := fieldrights.Count -1 downto 0 do
                    begin
                      if (TbfaFieldRight(fieldrights[m]).ArcID = arc.ID) and
                         (TbfaFieldRight(fieldrights[m]).FieldID = field.ID) and
                         (TbfaFieldRight(fieldrights[m]).Userid = id) then
                      begin
                         TbfaFieldRight(fieldrights[m]).Rights := right;
                         TbfaFieldRight(fieldrights[m]).Modified := True;
                      end;
                    end;
                    arc.Modified_Addfields := True;
                  end;

                end else if TObject(bfsAddfieldsUser.lvList2.Items[j].Data) is TbfaGroup then
                begin
                  id := TbfaGroup(bfsAddfieldsUser.lvList2.Items[j].Data).ID;
                  idx := arc.Addfields.IndexOf(IntToStr(field.ID));
                  if idx > -1 then
                  begin
                    fieldrights := TList<TbfaFieldRight>(arc.Addfields.Objects[idx]);
                    for m := fieldrights.Count -1 downto 0 do
                    begin
                      if (TbfaFieldRight(fieldrights[m]).ArcID = arc.ID) and
                         (TbfaFieldRight(fieldrights[m]).FieldID = field.ID) and
                         (TbfaFieldRight(fieldrights[m]).Groupid = id) then
                      begin
                         TbfaFieldRight(fieldrights[m]).Rights := right;
                         TbfaFieldRight(fieldrights[m]).Modified := True;
                      end;
                    end;
                    arc.Modified_Addfields := True;
                  end;
                end;
                SetModified;
              end;
            end;
          end;
        end;
      end
    end;
  end;
end;

procedure TfraAdmin.chbxArchiveRightsClick(Sender: TObject);
begin
  try
    if chbxArchiveRights.ItemIndex > -1 then
    begin
      if ((GetAsyncKeyState(VK_LBUTTON) > 0)) then
        chbxArchiveRights.Checked[chbxArchiveRights.ItemIndex] :=
          not chbxArchiveRights.Checked[chbxArchiveRights.ItemIndex];
      chbxArchiveRightsClickCheck(Sender);
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'chbxArchiveRightsClick',
      ClassName);
  end;
end;

procedure TfraAdmin.chbxArchiveRightsClickCheck(Sender: TObject);
var
  i, j, id, arcid: Integer;
  right: Int64;
  arc: TbfaArchive;
begin
  // Wenn ich nicht Anzeigen darf, dann darf ich auch nicht Suchen
  if (chbxArchiveRights.ItemIndex = 0) and not (chbxArchiveRights.Checked[0]) then
    chbxArchiveRights.Checked[1] := False;

  // Wenn ich Suchen darf, dann darf ich auch anzeigen
  if chbxArchiveRights.Checked[1] then
    chbxArchiveRights.Checked[0] := True;

  //08.12.2023 bfacrm:ticket__show__37159 -->
  if chbxArchiveRights.Checked[16] then
    chbxArchiveRights.Checked[15] := True;

  if chbxArchiveRights.Checked[17] then
  begin
    chbxArchiveRights.Checked[16] := True;
    chbxArchiveRights.Checked[15] := True;
  end;
  //08.12.2023 bfacrm:ticket__show__37159 <--

  right := 0;
  //Achtung, Suchen und Anzeigen sind in der CheckboxListe vertauscht
  if chbxArchiveRights.Checked[1] then right := (right or rightList);
  if chbxArchiveRights.Checked[0] then right := (right or rightRead);
  if chbxArchiveRights.Checked[2] then right := (right or rightModify);
  if chbxArchiveRights.Checked[3] then right := (right or rightWrite);
  if chbxArchiveRights.Checked[4] then right := (right or rightEmail);
  if chbxArchiveRights.Checked[5] then right := (right or rightMove);
  if chbxArchiveRights.Checked[6] then right := (right or rightDelete);
//  if chbxArchiveRights.Checked[6] then right := (right or rightExport);
  if chbxArchiveRights.Checked[7] then right := (right or rightPrint);
  if chbxArchiveRights.Checked[8] then right := (right or rightLink);
  if chbxArchiveRights.Checked[9] then right := (right or rightImport);
  if chbxArchiveRights.Checked[10] then right := (right or rightHistory);
  if chbxArchiveRights.Checked[11] then right := (right or rightWFBreak);
  if chbxArchiveRights.Checked[12] then right := (right or rightAdmin);
  if chbxArchiveRights.Checked[13] then right := (right or rightListProtokoll);
  if chbxArchiveRights.Checked[14] then right := (right or rightRevSave);
  if chbxArchiveRights.Checked[15] then right := (right or rightARead);
  if chbxArchiveRights.Checked[16] then right := (right or rightAWrite);
  if chbxArchiveRights.Checked[17] then right := (right or rightAModify);

  if frmMainForm.FAdminTreeview.CountChecked > 0 then
  begin
    for i := 0 to frmMainForm.FAdminTreeview.Items.Count -1 do
    begin
      if not frmMainForm.FAdminTreeview.Checked[frmMainForm.FAdminTreeview.Items.Item[i]] then
        Continue;

      arcid := PbfaInt64(frmMainForm.FAdminTreeview.Items.Item[i].Data).Value;

      arc := GetArchiveByID(arcid);
      if arc <> nil then
      begin
        for j := 0 to bfsAssignUser.lvList2.Items.Count -1 do
        begin
          if bfsAssignUser.lvList2.Items[j].Selected then
          begin
            if TObject(bfsAssignUser.lvList2.Items[j].Data) is TbfaUser then
            begin
              id := TbfaUser(bfsAssignUser.lvList2.Items[j].Data).ID;
              if arc.Users.IndexOf(IntToStr(id)) > -1 then
              begin
                TbfaArcRight(arc.Users.Objects[arc.Users.IndexOf(IntToStr(id))]).Rights := right;
                TbfaArcRight(arc.Users.Objects[arc.Users.IndexOf(IntToStr(id))]).Modified := True;
                arc.Modified_User := True;
              end;
            end else if TObject(bfsAssignUser.lvList2.Items[j].Data) is TbfaGroup then
            begin
              id := TbfaGroup(bfsAssignUser.lvList2.Items[j].Data).ID;
              if arc.Groups.IndexOf(IntToStr(id)) > -1 then
              begin
                TbfaArcRight(arc.Groups.Objects[arc.Groups.IndexOf(IntToStr(id))]).Rights := right;
                TbfaArcRight(arc.Groups.Objects[arc.Groups.IndexOf(IntToStr(id))]).Modified := True;
                arc.Modified_User := True;
              end;
            end;
            SetModified;
          end;
        end;
      end
    end;
  end;
  Abort;
end;

procedure TfraAdmin.chbxArchiveRightsDrawItem(Sender: TObject; ACanvas: TCanvas; var ARect: TRect; Index: Integer;
  const State: TOwnerDrawState; const PaintStage: TSpTBXPaintStage; var PaintDefault: Boolean);
begin
  if chbxArchiveRights.Enabled then
    ACanvas.Font.Color := stlControl.TextColor
  else
    ACanvas.Font.Color := clGray;
end;

procedure TfraAdmin.chbxArchiveRightsMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  index: integer;
begin
  index := chbxArchiveRights.ItemAtPos(point(X, Y), true);
  if index <> -1 then
    chbxArchiveRights.Hint := CheckListBoxHints[index]
  else
    chbxArchiveRights.Hint := '';
  if index <> FprevIndex then
    Application.CancelHint;
  FprevIndex := index;
end;

procedure TfraAdmin.chbxStatefieldRightsClick(Sender: TObject);
begin
  if chbxStatefieldRights.Checked[chbxStatefieldRights.ItemIndex] then
    Exit
  else
    chbxStatefieldRightsClickCheck(Sender);
end;

procedure TfraAdmin.chbxStatefieldRightsClickCheck(Sender: TObject);
var
  i, j, k, m, id, idx, arcid: Integer;
  right: Int64;
  arc: TbfaArchive;
  field : TbfaStateField;
  fieldrights : TList<TbfaFieldRight>;
begin
  right := 0;
  if chbxStatefieldRights.ItemIndex = 0 then
  begin
    right := (right or 1);
    chbxStatefieldRights.Checked[0] := True;
    chbxStatefieldRights.Checked[1] := False;
    chbxStatefieldRights.Checked[2] := False;
  end
  else if chbxStatefieldRights.ItemIndex = 1 then
  begin
    right := (right or 2);
    chbxStatefieldRights.Checked[0] := False;
    chbxStatefieldRights.Checked[1] := True;
    chbxStatefieldRights.Checked[2] := False;
  end
  else if chbxStatefieldRights.ItemIndex = 2 then
  begin
    right := (right or 4);
    chbxStatefieldRights.Checked[0] := False;
    chbxStatefieldRights.Checked[1] := False;
    chbxStatefieldRights.Checked[2] := True;
  end;

  if frmMainForm.FAdminTreeview.CountChecked > 0 then
  begin
    for i := 0 to frmMainForm.FAdminTreeview.Items.Count -1 do
    begin
      if not frmMainForm.FAdminTreeview.Checked[frmMainForm.FAdminTreeview.Items.Item[i]] then
        Continue;

      arcid := PbfaInt64(frmMainForm.FAdminTreeview.Items.Item[i].Data).Value;

      arc := GetArchiveByID(arcid);
      if arc <> nil then
      begin
        for k := 0 to bfsAssignStatefields.lvList2.Items.Count -1 do
        begin
          if bfsAssignStatefields.lvList2.Items[k].Selected then
          begin
            field := TbfaStateField(bfsAssignStatefields.lvList2.Items[k].Data);

            for j := 0 to bfsStatefieldsUser.lvList2.Items.Count -1 do
            begin
              if bfsStatefieldsUser.lvList2.Items[j].Selected then
              begin
                if TObject(bfsStatefieldsUser.lvList2.Items[j].Data) is TbfaUser then
                begin
                  id := TbfaUser(bfsStatefieldsUser.lvList2.Items[j].Data).ID;
                  idx := arc.Statefields.IndexOf(IntToStr(field.ID));
                  if idx > -1 then
                  begin
                    fieldrights := TList<TbfaFieldRight>(arc.Statefields.Objects[idx]);
                    for m := fieldrights.Count -1 downto 0 do
                    begin
                      if (TbfaFieldRight(fieldrights[m]).ArcID = arc.ID) and
                         (TbfaFieldRight(fieldrights[m]).FieldID = field.ID) and
                         (TbfaFieldRight(fieldrights[m]).Userid = id) then
                      begin
                         TbfaFieldRight(fieldrights[m]).Rights := right;
                         TbfaFieldRight(fieldrights[m]).Modified := True;
                      end;
                    end;
                    arc.Modified_Statefields := True;
                  end;

                end else if TObject(bfsStatefieldsUser.lvList2.Items[j].Data) is TbfaGroup then
                begin
                  id := TbfaGroup(bfsStatefieldsUser.lvList2.Items[j].Data).ID;
                  idx := arc.Statefields.IndexOf(IntToStr(field.ID));
                  if idx > -1 then
                  begin
                    fieldrights := TList<TbfaFieldRight>(arc.Statefields.Objects[idx]);
                    for m := fieldrights.Count -1 downto 0 do
                    begin
                      if (TbfaFieldRight(fieldrights[m]).ArcID = arc.ID) and
                         (TbfaFieldRight(fieldrights[m]).FieldID = field.ID) and
                         (TbfaFieldRight(fieldrights[m]).Groupid = id) then
                      begin
                         TbfaFieldRight(fieldrights[m]).Rights := right;
                         TbfaFieldRight(fieldrights[m]).Modified := True;
                      end;
                    end;
                    arc.Modified_Statefields := True;
                  end;
                end;
                SetModified;
              end;
            end;
          end;
        end;
      end
    end;
  end;
end;

procedure TfraAdmin.chkAddfieldmandatoryClick(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentAddfield = nil then
    Exit;

  if chkAddfieldmandatory.Checked then
     FCurrentAddfield.Options := FCurrentAddfield.Options or 1
  else
     FCurrentAddfield.Options := FCurrentAddfield.Options and not 1;
  FCurrentAddfield.Modified := True;

  SetModified;
end;

procedure TfraAdmin.chkAdminClick(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentUser = nil then
    Exit;

  if chkAdmin.Checked then
     FCurrentUser.Flags := FCurrentUser.Flags or 8
  else
     FCurrentUser.Flags := FCurrentUser.Flags and not 8;
  FCurrentUser.Modified := True;

  SetModified;
end;

//procedure TfraAdmin.chkConcurrentClick(Sender: TObject);
//begin
//  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
//    Exit;
//  if FCurrentUser = nil then
//    Exit;
//
//  FSkipChangeEvents := True;
//  try
//    if chkConcurrent.Checked then
//    begin
//       FCurrentUser.Flags := FCurrentUser.Flags or 64;
//       FCurrentUser.Modified := True;
//       Inc(bitfarmApp.cnt_concurrent);
//       if not chkUserDenied.Checked then
//         Dec(bitfarmApp.cnt_enabled);
//    end else begin
//      if (bitfarmApp.max_named <> -1) and
//        ((bitfarmApp.cnt_named + 1 > bitfarmApp.max_named) or
//        (bitfarmApp.cnt_enabled + 1 > bitfarmApp.max_named)) and
//        not chkUserDenied.Checked then
//      begin
//        BfShowMessage(_('Die maximale Anzahl der Named User wurde erreicht.'));
//        FSkipChangeEvents := True;
//        chkConcurrent.Checked := True;
//        FSkipChangeEvents := True;
//        Exit;
//      end else begin
//        FCurrentUser.Flags := FCurrentUser.Flags and not 64;
//        FCurrentUser.Modified := True;
//        Dec(bitfarmApp.cnt_concurrent);
//        if not chkUserDenied.Checked then
//          Inc(bitfarmApp.cnt_enabled);
//      end;
//    end;
//
//    ShowUserProperties(FCurrentUser);
//
//    SetModified;
//  finally
//    FSkipChangeEvents := False;
//  end;
//end;

procedure TfraAdmin.chkDLMClick(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentStateField = nil then
    Exit;

  if chkDLM.Checked then
  begin
    FCurrentStateField.Flags := FCurrentStateField.Flags or 4;
  end else
  begin
    FCurrentStateField.Flags := FCurrentStateField.Flags and not 4;
  end;
  FCurrentStateField.Modified := True;

  SetModified;
end;

procedure TfraAdmin.chkDocnameArchiveClick(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentArchive = nil then
    Exit;

  if chkDocnameArchive.Checked then
  begin
    FCurrentArchive.Options := FCurrentArchive.Options or 2;
    edtDocname.Text := '';
    edtDocname.Enabled := False;
  end else
  begin
    FCurrentArchive.Options := FCurrentArchive.Options and not 2;
    edtDocname.Enabled := True;
  end;
  FCurrentArchive.Modified := True;

  SetModified;
end;

procedure TfraAdmin.chkDocnameMandatoryClick(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentArchive = nil then
    Exit;

  if chkDocnameMandatory.Checked then
    FCurrentArchive.Options := FCurrentArchive.Options or 1
  else
    FCurrentArchive.Options := FCurrentArchive.Options and not 1;
  FCurrentArchive.Modified := True;

  SetModified;
end;

//procedure TfraAdmin.chkFromADClick(Sender: TObject);
//begin
//  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
//    Exit;
//  if FCurrentUser = nil then
//    Exit;
//
//  if chkFromAD.Checked then
//     FCurrentUser.Flags := FCurrentUser.Flags or 4
//  else
//     FCurrentUser.Flags := FCurrentUser.Flags and not 4;
//  FCurrentUser.Modified := True;
//  ShowUserProperties(FCurrentUser);
//
//  SetModified;
//end;

procedure TfraAdmin.chkLinkfieldClick(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentAddfield = nil then
    Exit;

  if chkLinkfield.Checked then
     FCurrentAddfield.Options := FCurrentAddfield.Options or 2
  else
     FCurrentAddfield.Options := FCurrentAddfield.Options and not 2;
  FCurrentAddfield.Modified := True;

  SetModified;
end;

procedure TfraAdmin.chkMustChangePassClick(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentUser = nil then
    Exit;

  if chkMustChangePass.Checked then
     FCurrentUser.Flags := FCurrentUser.Flags or 32
  else
     FCurrentUser.Flags := FCurrentUser.Flags and not 32;
  FCurrentUser.Modified := True;

  SetModified;
end;

//procedure TfraAdmin.chkPluginactiveClick(Sender: TObject);
//begin
//  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
//    Exit;
//  if FCurrentArchive = nil then
//    Exit;
//
//  if chkPluginactive.Checked then
//    FCurrentArchive.Options := FCurrentArchive.Options or 4
//  else
//    FCurrentArchive.Options := FCurrentArchive.Options and not 4;
//  FCurrentArchive.Modified := True;
//
//  SetModified;
//end;

procedure TfraAdmin.chkSavenameClick(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentAddfield = nil then
    Exit;

  if chkSavename.Checked then
     FCurrentAddfield.Options := FCurrentAddfield.Options or 4
  else
     FCurrentAddfield.Options := FCurrentAddfield.Options and not 4;
  FCurrentAddfield.Modified := True;

  SetModified;
end;

procedure TfraAdmin.chkStrictmodeClick(Sender: TObject);
var
  outlist: TStringList;
  siaResult: TStrictItemsAction;
  Addfields: TList<TbfaBaseObject>;
  field: TbfaAddfield;
  i: Integer;
  req: TbfaRequest;
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentAddfield = nil then
    Exit;

  if chkStrictmode.Checked then
  begin
    FCurrentAddfield.Options := FCurrentAddfield.Options or 8;
    outlist := TStringList.Create;
    siaResult := bitfarmApp.CheckStrictfieldItems(FCurrentAddfield, outlist);

    if siaResult = siaAddToList then
    begin
     FCurrentAddfield.Items.AddStrings(outlist);
    end else if (siaResult = siaDelete) and (outlist.Count > 0) then
    begin
      Addfields := TList<TbfaBaseObject>.Create;
      for i := 0 to outlist.Count -1 do
      begin
        field := TbfaAddField.Create;
        field.Clone(FCurrentAddfield);
        field.Modified := True;
        field.OldValue := outlist[i];
        field.Value := '';
        Addfields.Add(field)
      end;

      req := TbfaRequest.Create;
      try
        req.ReqType := 'reqResetAddfields';
        req.UserID := bitfarmApp.User.ID;
        req.Profile := bitfarmApp.Profile;
        req.Lang := bitfarmApp.Lang;
        req.Data := Addfields;
        bitfarmApp.MainSocket.SendRequestToServer(req);

        req := BitfarmApp.MainSocket.ReceiveResponse;
        if req = nil then
          Exit;

        if req.ReqType = 'respError' then
          BfShowMessage(_('Fehler beim Zurcksetzen der Zusatzfelder') +#13#10 + req.DataString);

      finally
        FreeAndNil(req);
      end;
    end;
  end
  else
     FCurrentAddfield.Options := FCurrentAddfield.Options and not 8;
  FCurrentAddfield.Modified := True;

  SetModified;
end;

procedure TfraAdmin.chkUserDeniedClick(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentUser = nil then
    Exit;

  if not chkUserDenied.Checked then   // ! Achtung: gesperrt heit 'nicht enabled'
  begin
     FCurrentUser.Flags := FCurrentUser.Flags or 1;
     Inc(bitfarmApp.cnt_enabled);
  end
  else begin
     FCurrentUser.Flags := FCurrentUser.Flags and not 1;
     Dec(bitfarmApp.cnt_enabled);
  end;
  FCurrentUser.Modified := True;

  ShowUserProperties(FCurrentUser);

  SetModified;
end;

procedure TfraAdmin.edtAddfieldDescriptionChange(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentAddfield = nil then
    Exit;

  FCurrentAddfield.Description := ParseSQLString(edtAddfieldDescription.Text);
  FCurrentAddfield.Modified := True;

  SetModified;
end;

procedure TfraAdmin.edtArcidKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    btnSearchresubClick(Sender);
  end;
end;

procedure TfraAdmin.edtCheckprogramSubEditButton0Click(Sender: TObject);
begin

end;

//procedure TfraAdmin.edtCheckprogramChange(Sender: TObject);
//begin
//  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
//    Exit;
//  if FCurrentAddfield = nil then
//    Exit;
//
//  FCurrentAddfield.Checkprogram := ParseFilepath(edtCheckprogram.Text); // analog zu Pfad zu Briefpapier (Ticket 14102)
//  FCurrentAddfield.Modified := True;
//
//  SetModified;
//end;
//
//procedure TfraAdmin.edtCheckprogramSubEditButton0Click(Sender: TObject);
//var
//  OpenDlg: TOpenDialog;
//begin
//  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
//    Exit;
//  if FCurrentAddfield = nil then
//    Exit;
//
//  OpenDlg := TOpenDialog.Create (nil);
//  try
//    OpenDlg.Options := [ofPathMustExist, ofFileMustExist];
//    if not OpenDlg.Execute then
//      Exit;
//
//    FCurrentAddfield.Checkprogram := OpenDlg.Files[0];
//    FCurrentAddfield.Modified := True;
//
//  finally
//    OpenDlg.Free;
//  end;
//
//  ShowAddfieldProperties(FCurrentAddfield);
//  SetModified;
//end;

procedure TfraAdmin.edtDisplayNameChange(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentUser = nil then
    Exit;

  FCurrentUser.DisplayName := ParseSQLString(edtDisplayName.Text);
  FCurrentUser.Modified := True;

  SetModified;
end;

procedure TfraAdmin.edtDocnameChange(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentArchive = nil then
    Exit;

  FCurrentArchive.DefDocname := ParseSQLString(edtDocname.Text);
  FCurrentArchive.Modified := True;
  SetModified;
end;

procedure TfraAdmin.edtDocnameKeyPress(Sender: TObject; var Key: Char);
begin
  DisableBeep(Key); //11.03.2024 bfacrm:ticket__show__38134
end;

procedure TfraAdmin.edtDurationChange(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentArchive = nil then
    Exit;

  if edtDuration.Value = 0 then
    cbxInterval.ItemIndex := 0;
  FCurrentArchive.Duration := Trunc(edtDuration.Value);
  FCurrentArchive.Interval := Intervals[cbxInterval.ItemIndex];
  FCurrentArchive.Modified := True;
  FCurrentArchive.Modified_Expired := True;

  SetModified;
end;

procedure TfraAdmin.edtDurationValueChanged(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentArchive = nil then
    Exit;

  if edtDuration.Value = 0 then
    cbxInterval.ItemIndex := 0;
  FCurrentArchive.Duration := Trunc(edtDuration.Value);
  FCurrentArchive.Interval := Intervals[cbxInterval.ItemIndex];
  FCurrentArchive.Modified := True;
  FCurrentArchive.Modified_Expired := True;

  SetModified;
end;

procedure TfraAdmin.edtEmailChange(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentUser = nil then
    Exit;

  FCurrentUser.Email := ParseSQLString(edtEmail.Text);
  FCurrentUser.Modified := True;

  SetModified;
end;

procedure TfraAdmin.edtGdocidKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    btnSearchresubClick(Sender);
  end;
end;

procedure TfraAdmin.edtGroupEmailChange(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentGroup = nil then
    Exit;

  FCurrentGroup.Email := ParseSQLString(edtGroupEmail.Text);
  FCurrentGroup.Modified := True;

  SetModified;
end;

procedure TfraAdmin.edtLogGdocidKeyPress(Sender: TObject; var Key: Char);
begin
  DisableBeep(Key); //11.03.2024 bfacrm:ticket__show__38134
end;

procedure TfraAdmin.edtPasswordChange(Sender: TObject);
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentUser = nil then
    Exit;

  if Pos(';', edtPassword.Text) > 0 then
  begin
    BfShowMessage(_('Ein Semikolon kann nicht im Passwort verwendet werden!'));
    edtPassword.Text := '';
  end;

  FCurrentUser.Password := EnCrypt(Trim(edtPassword.Text), GlobalKey);
  FCurrentUser.Modified := True;

  SetModified;
end;

procedure TfraAdmin.edtPasswordClick(Sender: TObject);
begin
  edtPassword.Text := '';
end;

procedure TfraAdmin.edtPasswordKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key = ';') then
  begin
    BfShowMessage(_('Ein Semikolon kann nicht im Passwort verwendet werden!'));
    Key := #0;
    Abort;
  end;
end;

procedure TfraAdmin.edtStationaryChange(Sender: TObject);
var
  fpath: TStringList;
  i: Integer;
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentArchive = nil then
    Exit;

  fpath := TStringLIst.Create;
  fpath.StrictDelimiter := True;
  fpath.Delimiter := '|';
  fpath.DelimitedText := edtStationary.Text;

  for i := 0 to fpath.Count -1 do
    fpath[i] := ParseFilepath(fpath[i]);

  FCurrentArchive.Backpic := fpath.DelimitedText;
  FCurrentArchive.Modified := True;

  ShowArchiveProperties(FCurrentArchive);
  SetModified;
  FreeAndNil(fpath);
end;

procedure TfraAdmin.edtStationarySubEditButton0Click(Sender: TObject);
var
  OpenDlg: TOpenDialog;
  i: Integer;
  stationaries: TStringList;
begin
  if FSkipChangeEvents or not bitfarmApp.AdminEditMode then
    Exit;
  if FCurrentArchive = nil then
    Exit;

  OpenDlg := TOpenDialog.Create (nil);
  try
    OpenDlg.Options := [ofAllowMultiSelect];
    if not OpenDlg.Execute then
      Exit;

    stationaries := TStringList.Create;
    stationaries.Delimiter := '|';
    stationaries.StrictDelimiter := True;

    for i := 0 to OpenDlg.Files.Count - 1 do
      stationaries.Add(OpenDlg.Files[i]);
    FCurrentArchive.Backpic := stationaries.DelimitedText;
    FCurrentArchive.Modified := True;
    FreeAndNil(stationaries);
  finally
    OpenDlg.Free;
  end;

  ShowArchiveProperties(FCurrentArchive);
  SetModified;
end;

procedure TfraAdmin.edtTimrefKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    btnSearchresubClick(Sender);
  end;
end;

procedure TfraAdmin.tabctrAdminActiveTabChange(Sender: TObject; TabIndex: Integer);
begin
  try
    if tabctrAdmin.ActiveTabIndex in [0,1,2] then
    begin
      if FCurrentArchive <> nil then //13.12.2023 neu
        SelectArchive(FCurrentArchive.ID);
      btnSaveAdmin.Visible := True;
      btnCancelAdmin.Visible := True;
      pnlButtons.Visible := True;
    end else
    begin
      bitfarmApp.Askfor_SaveAdmin;
      btnSaveAdmin.Visible := False;
      btnCancelAdmin.Visible := False;
      pnlButtons.Visible := False;
    end;
    {$IFDEF ENTERPRISE}
    if tabctrAdmin.ActiveTabIndex = 2 then
      TfraAdminEnterprise(Self).LoadADGroups;
    {$ENDIF}
    if tabctrAdmin.ActiveTabIndex = 3 then
      EnableResubSearchFields;
  except
    bitfarmLog.Write(llNormal, ltException, 'tabctrAdminActiveTabChange', ClassName);
  end;
end;

procedure TfraAdmin.tabctrAdminActiveTabChanging(Sender: TObject; TabIndex, NewTabIndex: Integer; var Allow: Boolean);
var
  i: Integer;
  found: Boolean;
begin
  try
    //17.02.2022 Workaround so lange das Ticket 29625 erledigt wird -->
    if bitfarmApp.AdminEditMode then
    begin
      found := False;
      for i := 0 to bitfarmApp.GArchives.Count -1 do
      begin
        found := bitfarmApp.Garchives[i].Modified or
                 bitfarmApp.Garchives[i].Modified_User or
                 bitfarmApp.Garchives[i].Modified_Addfields or
                 bitfarmApp.Garchives[i].Modified_Statefields or
                 bitfarmApp.Garchives[i].Modified_Expired;
        if found then
          Break;
      end;

      if not found then
      begin
        for i := 0 to bitfarmApp.GAddfields.Count -1 do
        begin
          found := bitfarmApp.GAddfields[i].Modified;
          if found then
            Break;
        end;
      end;

      if not found then
      begin
        for i := 0 to bitfarmApp.GStatefields.Count -1 do
        begin
          found := bitfarmApp.GStatefields[i].Modified;
          if found then
            Break;
        end;
      end;

      if not found then
      begin
        for i := 0 to bitfarmApp.GUser.Count -1 do
        begin
          found := bitfarmApp.GUser[i].Modified;
          if found then
            Break;
        end;
      end;

      if not found then
      begin
        for i := 0 to bitfarmApp.GGroups.Count -1 do
        begin
          found := bitfarmApp.GGroups[i].Modified;
          if found then
            Break;
        end;
      end;

      Allow := not found;

      if found then
        BfMessageDlg(_('Bitte speichern Sie erst die nderungen!'), mtWarning, [mbOK]);
    end;
    //17.02.2022 <--
  except

  end;
end;

procedure TfraAdmin.UnModify;
var
  i, j, m: Integer;
  fieldrights: TList<TbfaFieldRight>;
  arc_modified: Boolean;
begin
  for i := 0 to bitfarmApp.GArchives.Count -1 do
  begin
      arc_modified := False or bitfarmApp.Garchives[i].Modified or
                      bitfarmApp.Garchives[i].Modified_User or
                      bitfarmApp.Garchives[i].Modified_Addfields or
                      bitfarmApp.Garchives[i].Modified_Statefields;

    if arc_modified then
    begin
      bitfarmApp.Garchives[i].Modified := False;
      if bitfarmApp.Garchives[i].Modified_User then
      begin
        bitfarmApp.Garchives[i].Modified_User := False;
        for j := 0 to bitfarmApp.Garchives[i].Users.Count -1 do
        begin
          TbfaArcRight(bitfarmApp.Garchives[i].Users.Objects[j]).Modified := False;
          TbfaArcRight(bitfarmApp.Garchives[i].Users.Objects[j]).Deleted := False;
        end;
        for j := 0 to bitfarmApp.Garchives[i].Groups.Count -1 do
        begin
          TbfaArcRight(bitfarmApp.Garchives[i].Groups.Objects[j]).Modified := False;
          TbfaArcRight(bitfarmApp.Garchives[i].Groups.Objects[j]).Deleted := False;
        end;
      end;
      if bitfarmApp.Garchives[i].Modified_Addfields then
      begin
        bitfarmApp.Garchives[i].Modified_Addfields := False;
        for j  := 0 to bitfarmApp.Garchives[i].Addfields.Count -1 do
        begin
          fieldrights := TList<TbfaFieldRight>(bitfarmApp.Garchives[i].Addfields.Objects[j]);
          for m := fieldrights.Count -1 downto 0 do
          begin
            TbfaFieldRight(fieldrights[m]).Modified := False;
            TbfaFieldRight(fieldrights[m]).Deleted := False;
          end;
        end;
      end;
      if bitfarmApp.Garchives[i].Modified_Statefields then
      begin
        bitfarmApp.Garchives[i].Modified_Statefields := False;
        for j  := 0 to bitfarmApp.Garchives[i].Statefields.Count -1 do
        begin
          fieldrights := TList<TbfaFieldRight>(bitfarmApp.Garchives[i].Statefields.Objects[j]);
          for m := fieldrights.Count -1 downto 0 do
          begin
            TbfaFieldRight(fieldrights[m]).Modified := False;
            TbfaFieldRight(fieldrights[m]).Deleted := False;
          end;
        end;
      end;
    end;
  end;

  for i := 0 to bitfarmApp.GAddfields.Count -1 do
  begin
    if bitfarmApp.GAddfields[i].Modified then
    begin
      bitfarmApp.GAddfields[i].Modified := False;
    end;
  end;

  for i := 0 to bitfarmApp.GStatefields.Count -1 do
  begin
    if bitfarmApp.GStatefields[i].Modified then
    begin
      bitfarmApp.GStatefields[i].Modified := False;
    end;
  end;

  for i := 0 to bitfarmApp.GUser.Count -1 do
  begin
    if bitfarmApp.GUser[i].Modified then
    begin
      bitfarmApp.GUser[i].Modified := False;
    end;
  end;

  for i := 0 to bitfarmApp.GGroups.Count -1 do
  begin
    if bitfarmApp.GGroups[i].Modified then
    begin
      bitfarmApp.GGroups[i].Modified := False;
    end;
  end;

  for i := 0 to frmDLMDialog.Entries.Count -1 do
  begin
    if frmDLMDialog.Entries[i].Modified then
      frmDLMDialog.Entries[i].Modified := False;
  end;

end;

initialization

NullStrictConvert := False;

finalization

end.
