unit MainForm;

interface

uses
  gnugettext, Windows, Messages, SysUtils, Variants, Classes, Graphics, VCL.Controls, Forms,
  Dialogs, SpTBXControls, SpTBXDkPanels, SpTBXItem, TB2Dock, TB2Toolbar, TB2Item,
  SpTBXTabs, VCL.Grids, DBGrids, ImgList, bfaPreview36, ActnList, XPMan,
  SpTBXEditors, StdCtrls, SpTBXCustomizer, Menus, u_bfaStandardToolbar,
  u_bfaTlbStandard, u_bfaTlbPreview, CheckLst, SpTBXExtEditors, JvComponentBase, JvFormPlacement, JvAppStorage,
  JvAppIniStorage, u_bfaAddfield, SpTBXPageScroller, VCL.Printers,
  MainDataModule, u_bfaScrollBox, u_bfaGrid, CRGrid, JvExComCtrls, JvComCtrls,
  ImporterFrameGPL, WorkplaceFrameGPL, ResubFrameGPL, Winapi.IpHlpApi, WinApi.IpTypes,
  u_Info,   //03.07.2024 SD <--bfacrm:ticket__show__38700
  NewDocLink, //10.09.2024 SD <--bfacrm:ticket__show__39893
  bfaQuickPreview, ShowBookmark,//16.10.2024 SD <--bfacrm:ticket__show__40274
  AdminFrame,
  {$IFDEF ENTERPRISE}
  AdminFrameEnterprise,
  {$ENDIF}
  IniFiles, u_bfaSplitter, bfaCommonUtils, bfaLog, Generics.Collections,
  u_bfaTreeView, ListItemsForm, SplashForm, ScanFunctionsFrame, LinkMailForm,
  AddGlobalBookmarkFolder, cxGraphics, cxControls, cxLookAndFeels,
  cxLookAndFeelPainters, cxContainer, cxEdit, ComCtrls, dxCore, cxDateUtils,
  cxTextEdit, cxMaskEdit, cxDropDownEdit, cxCalendar, cxButtonEdit, dxTokenEdit, Uni,
  UniProvider, MySQLUniProvider, DASQLMonitor, UniSQLMonitor, bfaObjects36, InfoBoxForm,
  OptionsForm, ResubDialogForm, hyieutils, ieview, iemview, cxClasses,
  dxAlertWindow, DocLinksFrame, FloatingForm, StdActns, ExtCtrls,
  DropSource, DragDropFile, DragDrop, DropTarget, ActiveX, DropComboTarget,
  SpTBXSkins, AppEvnts, CreateImporterResubFrame, cxMemo, u_Rights,
  CreateGlobalBookmark, PasswordForm, TagsForm, PrivateLayer, imageenview, ievect, ietextc,
  System.ImageList, System.Actions, System.Notification, VCl.ImageCollection,
  MoveDocForm, cxGroupBox, cxLabel, cxGrid, cxGridLevel, bfaGridDBTableView, cxSplitter,
  cxGridCustomTableView, cxStyles, cxGridCustomPopupMenu, cxGridPopupMenu,
  cxGridCustomView, dxPSCore, dxPScxGridLnk, cxGridTableView, cxScrollBox,
  FloatingResubFrame, Vcl.ExtDlgs, GridConfigForm, Win11Forms,
  bfaSearchThread, ScanFunctions, IdBaseComponent, IdAntiFreezeBase,
  IdAntiFreeze
  //  {$IFDEF DEVEXSKIN}
//  , dxSkinsCore, dxSkinProject1, dxSkinsForm
//  {$ENDIF}
  ;

type
  TControlProc = reference to procedure(const AControl: TControl);
  TcxControlAccess = class (TcxControl);

  TfrmGPL = class(TForm)
    actCheckoutDocs: TAction;
    actCheckoutDocsAdmin: TAction;
    SpTBXDock1: TSpTBXDock;
    tlbMainMenu: TSpTBXToolbar;
    tlbGraphic: TSpTBXToolbar;
    mnuGraphicOptions: TSpTBXItem;
    mnuInverted: TSpTBXItem;
    mnuDeScrew: TSpTBXItem;
    mnuDeSpeckle: TSpTBXItem;
    mnuRemoveBorder: TSpTBXItem;
    mnuRotateLeft_: TSpTBXItem;
    mnuFlip_: TSpTBXItem;
    mnuRotateRight_: TSpTBXItem;
    tlbTools: TSpTBXToolbar;
    mnuRestoreOriginal: TSpTBXItem;
    mnuDocEditor: TSpTBXItem;
    mnuRefreshDoc: TSpTBXItem;
    mnuCreateEmptyDoc: TSpTBXSubmenuItem;
    mnuCreateEmptyDocText: TSpTBXItem;
    mnuMergeDoc: TSpTBXItem;
    mnuDuplicateDoc: TSpTBXItem;
    mnuExportMeta: TSpTBXSubmenuItem;
    mnuExportCSV: TSpTBXItem;
    mnuExportXLS: TSpTBXItem;
    mnuExportOO: TSpTBXItem;
    mnuDeleteDoc: TSpTBXItem;
    mnuAuditProof: TSpTBXItem;
    tlbDocState: TSpTBXToolbar;
    clItemLinks: TSpTBXItem;
    clItemOriginalfile: TSpTBXItem;
    clItemCheckout: TSpTBXItem;
    clItemInProgress: TSpTBXItem;
    clItemIsAuditProof: TSpTBXItem;
    clItemInResub: TSpTBXItem;
    tlbStatefields: TSpTBXToolbar;
    tlbPlugins: TSpTBXToolbar;
    bfaTlbStandard1: TbfaTlbStandard;
    bfaTlbPreview1: TbfaTlbPreview;
    tlbResubFavs: TSpTBXToolbar;
    SpTBXStatusBar1: TSpTBXStatusBar;
    SpTBXLabelItem1: TSpTBXLabelItem;
    itmUserName: TSpTBXLabelItem;
    TBSeparatorItem10: TTBSeparatorItem;
    SpTBXLabelItem6: TSpTBXLabelItem;
    itmProfile: TSpTBXLabelItem;
    sep1: TTBSeparatorItem;
    SpTBXLabelItem2: TSpTBXLabelItem;
    itmServerName: TSpTBXLabelItem;
    TBSeparatorItem1: TTBSeparatorItem;
    SpTBXLabelItem5: TSpTBXLabelItem;
    itmDBName: TSpTBXLabelItem;
    TBSeparatorItem9: TTBSeparatorItem;
    itm2: TSpTBXLabelItem;
    itmID: TSpTBXLabelItem;
    TBSeparatorItem11: TTBSeparatorItem;
    SpTBXLabelItem4: TSpTBXLabelItem;
    itmInfo: TSpTBXLabelItem;
    TBSeparatorItem12: TTBSeparatorItem;
    itmNotification: TSpTBXLabelItem;
    splTreeview: TbfaSplitter;
    XPManifest1: TXPManifest;
    SpTBXCustomizer1: TSpTBXCustomizer;
    popMainMenu: TSpTBXPopupMenu;
    popMainMenuGroupItem1: TTBGroupItem;
    SpTBXSeparatorItem2: TTBSeparatorItem;
    mnuCustomize: TSpTBXItem;
    tbsubLayout_: TSpTBXSubmenuItem;
    popMainMenuGroupItem2: TSpTBXSkinGroupItem;
    popLimit: TSpTBXPopupMenu;
    tbiLimit1: TSpTBXItem;
    tbiLimit10: TSpTBXItem;
    tbiLimit50: TSpTBXItem;
    tbiLimit100: TSpTBXItem;
    tbiLimit500: TSpTBXItem;
    tbiLimit1000: TSpTBXItem;
    tbiLimit5000: TSpTBXItem;
    tbiLimitAll: TSpTBXItem;
    popSearchOption1: TSpTBXPopupMenu;
    tbiSoFTX: TSpTBXItem;
    tbiSoTags: TSpTBXItem;
    tbiSoFtxTags: TSpTBXItem;
    popSearchOption2: TSpTBXPopupMenu;
    tbiSoUser: TSpTBXItem;
    tbiSOGroup: TSpTBXItem;
    popSearchOption3: TSpTBXPopupMenu;
    tbiSoArchived: TSpTBXItem;
    tbiSoModified: TSpTBXItem;
    tbiSoExpired: TSpTBXItem;
    popSearchOption4: TSpTBXPopupMenu;
    tbiSoLinks: TSpTBXItem;
    tbiSoTitle: TSpTBXItem;
    tbiSoType: TSpTBXItem;
    itmGDocID: TSpTBXItem;
    popResubFavs: TSpTBXPopupMenu;
    SpTBXItem4: TSpTBXItem;
    SpTBXItem3: TSpTBXItem;
    SpTBXItem2: TSpTBXItem;
    SpTBXItem1: TSpTBXItem;
    JvFormStorage1: TJvFormStorage;
    JvAppIniFileStorage1: TJvAppIniFileStorage;
    popFavTree: TSpTBXPopupMenu;
    tbiAddFolder: TSpTBXItem;
    tbiDeleteFolder: TSpTBXItem;
    tbiCreateBookmark: TSpTBXItem;
    tbiChangeBookmark: TSpTBXItem;
    tbiReplaceBookmark: TSpTBXItem;
    tbiCopyBookmark: TSpTBXItem;
    popTreeView: TSpTBXPopupMenu;
    mnuTreeviewTools: TSpTBXSubmenuItem;
    itmCollapseAll: TSpTBXItem;
    itmExpandAll: TSpTBXItem;
    itmRefresh: TSpTBXItem;
    itmExport: TSpTBXItem;
    SpTBXSeparatorItem1: TTBSeparatorItem;
    popInEditmode: TSpTBXPopupMenu;
    dxAlertWindowManager1: TdxAlertWindowManager;
    popDocLinks: TSpTBXPopupMenu;
    popAddFields: TSpTBXPopupMenu;
    SpTBXItem7: TSpTBXItem;
    TBSeparatorItem3: TTBSeparatorItem;
    SpTBXItem11: TSpTBXItem;
    SpTBXItem10: TSpTBXItem;
    SpTBXItem9: TSpTBXItem;
    SpTBXItem8: TSpTBXItem;
    TBSeparatorItem6: TTBSeparatorItem;
    SpTBXItem12: TSpTBXItem;
    TBSeparatorItem7: TTBSeparatorItem;
    mnuPopupCreateLink: TSpTBXItem;
    mnuHideSearchDetails: TSpTBXItem;
    mnuIndexing: TSpTBXItem;
    mnuIndexingWithLimit: TSpTBXItem;
    tmrSearchPanel: TTimer;
    tmrStatusBar: TTimer;
    dftMainForm: TDropComboTarget;
    desResultGrid: TDropEmptySource;
    DataFormatAdapter1: TDataFormatAdapter;
    ImageList1: TImageList;
    detViewer: TDropEmptyTarget;
    detViewerDataFormat: TDataFormatAdapter;
    dctImporterTarget: TDropComboTarget;
    popSVN1: TSpTBXPopupMenu;
    ppmTools: TSpTBXPopupMenu;
    mnuBack: TSpTBXItem;
    TBSeparatorItem2: TTBSeparatorItem;
    mnuSingleSave: TSpTBXSubmenuItem;
    itmSavePDF: TSpTBXItem;
    itmSaveTIF: TSpTBXItem;
    itmSaveOriginal: TSpTBXItem;
    itmSaveLink: TSpTBXItem;
    itmSavePreview: TSpTBXItem;
    mnuSingleEmail: TSpTBXSubmenuItem;
    itmEmailPDFAttachment: TSpTBXItem;
    itmEmailTIFAttachment: TSpTBXItem;
    itmEmailOriginal: TSpTBXItem;
    itmEmailLink: TSpTBXItem;
    itmEmailPreview: TSpTBXItem;
    mnuSinglePrint: TSpTBXSubmenuItem;
    itmPrintStandard: TSpTBXItem;
    itmPrintPreview: TSpTBXItem;
    mnuSingleClipboard: TSpTBXSubmenuItem;
    itmDocToClipboard: TSpTBXItem;
    itmOriDocToClipboard: TSpTBXItem;
    itmPageToClipboard: TSpTBXItem;
    itmDokLinkToClipboard: TSpTBXItem;
    mnuChangeDocName: TSpTBXItem;
    mnuGoToSourceArchive: TSpTBXItem;
    sep2: TTBSeparatorItem;
    mnuNewLink: TSpTBXItem;
    mnuAutoRef: TSpTBXItem;
    mnuAddLink: TSpTBXSubmenuItem;
    sep7: TTBSeparatorItem;
    mnuExport: TSpTBXSubmenuItem;
    mnuExportCSVFile: TSpTBXItem;
    mnuExportOpenOffice: TSpTBXItem;
    mnuExportExcel: TSpTBXItem;
    mnuResubCreate: TSpTBXSubmenuItem;
    sep3: TTBSeparatorItem;
    mnuBookmarks: TSpTBXSubmenuItem;
    mnuCreateBookmarkForGDocID_: TSpTBXItem;
    sep4: TTBSeparatorItem;
    mnuCreateCopy: TSpTBXItem;
    mnuSendTo: TSpTBXSubmenuItem;
    mnuDocToWorkplace: TSpTBXItem;
    mnuSendCopyToWorkplace: TSpTBXItem;
    mnuPagesToWorkplace: TSpTBXItem;
    mnuPagesToWorkplaceasOneDoc: TSpTBXItem;
    TBSeparatorItem4: TTBSeparatorItem;
    mnuDocToImporter: TSpTBXItem;
    mnuDocPreviewToImporter: TSpTBXItem;
    mnuPagesToImporter: TSpTBXItem;
    mnuPagesToImporterasOneDoc: TSpTBXItem;
    TBSeparatorItem5: TTBSeparatorItem;
    mnuGroup: TSpTBXItem;
    mnuUnGroup: TSpTBXItem;
    mnuOCRAddfields: TSpTBXSubmenuItem;
    mnuDocTools: TSpTBXSubmenuItem;
    mnuPlugins: TSpTBXSubmenuItem;
    sep6: TTBSeparatorItem;
    mnuDelete: TSpTBXItem;
    tmrCloseForm: TTimer;
    tmrCheckResub: TTimer;
    ApplicationEvents1: TApplicationEvents;
    DropFileSource1: TDropFileSource;
    detViewer2: TDropComboTarget;
    popInResub: TSpTBXPopupMenu;
    popLinksList: TSpTBXPopupMenu;
    popFilterBar: TSpTBXPopupMenu;
    tbiSearchBar: TSpTBXItem;
    tmrNotification: TTimer;
    cxStyleRepository1: TcxStyleRepository;
//    stlColumn: TcxStyle;
//    stlUrgent: TcxStyle;
//    stlUrgentSelected: TcxStyle;
//    stlWork: TcxStyle;
//    stlWorkSelected: TcxStyle;
//    stlDone: TcxStyle;
//    stlDoneSelected: TcxStyle;
//    stlFree: TcxStyle;
//    stlSelected: TcxStyle;
//    stlProgress: TcxStyle;
//    stlProgressSelected: TcxStyle;
    cxGridPopupMenu1: TcxGridPopupMenu;
//    stlControl: TcxStyle;
//    stlControlNoRight: TcxStyle;
//    stlControlRequired: TcxStyle;
//    stlControlModified: TcxStyle;
//    stlTreeview: TcxStyle;
//    stlTreeViewSelected: TcxStyle;
//    stlImageEn: TcxStyle;
//    stlImageEnSelected: TcxStyle;
    mnuUndockDocument: TSpTBXSubmenuItem;
    itmDocInNewTab: TSpTBXItem;
    itmDocInNewWindow: TSpTBXItem;
//09.09.2020    BfaStatefieldComp1: TBfaStatefieldComp;
    popPrivateAnno: TSpTBXPopupMenu;
    sep5: TTBSeparatorItem;
    mnuCollectDocs: TSpTBXItem;
    mnuEmailCollection: TSpTBXSubmenuItem;
    mnuSaveCollection: TSpTBXSubmenuItem;
    mnuCancelCollection: TSpTBXItem;
    itmEmailCollectionPDF: TSpTBXItem;
    itmEmailCollectionSinglePDF: TSpTBXItem;
    itmEmailCollectionTIF: TSpTBXItem;
    itmEmailCollectionOriginal: TSpTBXItem;
    itmSaveCollectionPDF: TSpTBXItem;
    itmSaveCollectionSinglePDF: TSpTBXItem;
    itmSaveCollectionTIF: TSpTBXItem;
    itmSaveCollectionOriginal: TSpTBXItem;
    tlbQueueCount: TSpTBXToolbar;
    pgrQueue: TSpTBXProgressBar;
    itm1: TTBControlItem;
    TBSeparatorItem13: TTBSeparatorItem;
    mnuAddfieldDetails: TSpTBXItem;
    SpTBXPanel1: TSpTBXPanel;
    SpTBXMultiDock2: TSpTBXMultiDock;
    pnlSearchOptions: TSpTBXDockablePanel;
    TBControlItem2: TTBControlItem;
    pnlQuickSearch: TSpTBXPanel;
    pnlSearchTimer: TPanel;
    pnlLoadDoc: TPanel;
    SpTBXPanel3: TSpTBXPanel;
    SpTBXMultiDock3: TSpTBXMultiDock;
    SpTBXDockablePanel1: TSpTBXDockablePanel;
    SpTBXPanel4: TSpTBXPanel;
    tcSearch: TSpTBXTabControl;
    tabSearchStandard: TSpTBXTabItem;
    tabSearchAddfields: TSpTBXTabItem;
    tabSearchAddfields2: TSpTBXTabItem;
    tabSearchLinks: TSpTBXTabItem;
    tabDocLinks: TSpTBXTabSheet;
    tabStandard: TSpTBXTabSheet;
    pnlStandard: TSpTBXPanel;
    scrbxStandard: TbfaScrollBox;
    btnSearchOption1: TSpTBXButton;
    btnSearchOption2: TSpTBXButton;
    btnSearchOption3: TSpTBXButton;
    btnSearchOption4: TSpTBXButton;
    scrbxStandardImporter: TbfaScrollBox;
    pnlImporterResub: TSpTBXPanel;
    grbImporterResub: TSpTBXGroupBox;
    pnlImporterFields: TSpTBXPanel;
    tokenDocLinks: TbfaCheckedCombo;
    lblDocLinksImporter: TbfaLabel;
    tokenDocTags: TbfaCheckedCombo;
    lblDocTagsImporter: TbfaLabel;
    lblDocnameImporter: TbfaLabel;
    edtDocName: TbfaTextEdit;
    splStandard: TSpTBXSplitter;
    pnlDocLink: TSpTBXPanel;
    tabAddfields: TSpTBXTabSheet;
    scrbxViewerAddfields: TbfaScrollBox;
    grpIndexing: TSpTBXGroupBox;
    btnIndexing: TSpTBXButton;
    btnIndexingReset: TSpTBXButton;
    btnCloseIndexing: TSpTBXButton;
    tabAddfields2: TSpTBXTabSheet;
    scrbxAddfields2: TbfaScrollBox;
    SpTBXSplitter3: TbfaSplitter;
    SpTBXMultiDock4: TSpTBXMultiDock;
    SpTBXDockablePanel2: TSpTBXDockablePanel;
    SpTBXPanel5: TSpTBXPanel;
    pnlSearch: TSpTBXPanel;
    btnSave: TSpTBXButton;
    btnCancel: TSpTBXButton;
    SpTBXLabel1: TSpTBXLabel;
    btnBack: TSpTBXButton;
    btnForward: TSpTBXButton;
    btnSearch: TSpTBXButton;
    btnReset: TSpTBXButton;
    btnLimit: TSpTBXButton;
    SpTBXSplitter2: TbfaSplitter;
    SpTBXPanel2: TSpTBXPanel;
    SpTBXMultiDock1: TSpTBXMultiDock;
    pnlPreview: TSpTBXDockablePanel;
    tstDocumentEditors: TSpTBXTabSet;
    SpTBXPanel6: TSpTBXPanel;
    dckDocumentEditors: TSpTBXMultiDock;
    smiDescription: TSpTBXSubmenuItem;
    mnuDescription: TSpTBXItem;
    dlgSaveGrid: TSaveTextFileDialog;
    mnuMarkModified: TSpTBXItem;
    dckTreeView: TSpTBXMultiDock;
    SpTBXDockablePanel3: TSpTBXDockablePanel;
    SpTBXPanel7: TSpTBXPanel;
    SpTBXMultiDock5: TSpTBXMultiDock;
    pnlTreeView: TSpTBXDockablePanel;
    TBControlItem3: TTBControlItem;
    TBControlItem1: TTBControlItem;
    pnlImporter: TSpTBXDockablePanel;
    pnlResubmission: TSpTBXDockablePanel;
    pnlFavorites: TSpTBXDockablePanel;
    trvBookmarks: TJvTreeView;
    pnlWorkspace: TSpTBXDockablePanel;
    pnlAdmin: TSpTBXDockablePanel;
    tmrQueueCount: TTimer;
    tmrHeartbeat: TTimer;
    mnuFiles: TSpTBXSubmenuItem;
    mnuRelogin: TSpTBXItem;
    mnuChangePassword: TSpTBXItem;
    SpTBXSeparatorItem5: TSpTBXSeparatorItem;
    mnuOptions: TSpTBXItem;
    SpTBXSeparatorItem3: TSpTBXSeparatorItem;
    mnuLocalSave: TSpTBXSubmenuItem;
    mnuLocalSavePDF: TSpTBXItem;
    mnuLocalSaveTIF: TSpTBXItem;
    mnuLocalSaveOriginal: TSpTBXItem;
    mnuLocalSaveLink: TSpTBXItem;
    mnuLocalSavePreview: TSpTBXItem;
    mnuEmail: TSpTBXSubmenuItem;
    mnuEmailPDFAttachment: TSpTBXItem;
    mnuEmailTIFAttachment: TSpTBXItem;
    mnuEmailOriginal: TSpTBXItem;
    mnuEmailLink: TSpTBXItem;
    mnuEmailPreview: TSpTBXItem;
    mnuPrint: TSpTBXSubmenuItem;
    mnuPrintStandard: TSpTBXItem;
    mnuPrintSelect: TSpTBXItem;
    mnuPrintPreview: TSpTBXItem;
    mnuCopyToClipboard: TSpTBXSubmenuItem;
    mnuDocToClipboard: TSpTBXItem;
    mnuOriDocToClipboard: TSpTBXItem;
    mnuPageToClipboard: TSpTBXItem;
    mnuDocLinkToClipboard: TSpTBXItem;
    SpTBXSeparatorItem4: TSpTBXSeparatorItem;
    mnuQuit: TSpTBXItem;
    mnuView: TSpTBXSubmenuItem;
    mnuViewNavigation: TSpTBXItem;
    mnuViewSearchOptions: TSpTBXItem;
    mnuViewPreview: TSpTBXItem;
    mnuViewThumbnails: TSpTBXItem;
    mnuViewFloatingWVL: TSpTBXItem;
    tlbMainMenuSeparatorItem8: TSpTBXSeparatorItem;
    tbsubToolbars: TSpTBXSubmenuItem;
    mStandard: TSpTBXItem;
    mTools: TSpTBXItem;
    mGraphic: TSpTBXItem;
    mPreview: TSpTBXItem;
    mQueueCount: TSpTBXItem;
    mResubFavorites: TSpTBXItem;
    tlbMainMenuSeparatorItem3: TSpTBXSeparatorItem;
    tbsubSkin: TSpTBXSubmenuItem;
    tlbMainMenuSkinGroupItem1: TSpTBXSkinGroupItem;
    tlbMainMenuSeparatorItem4: TSpTBXSeparatorItem;
    tbsubLanguages: TSpTBXSubmenuItem;
    mnuLanguageDE: TSpTBXItem;
    mnuLanguageEN: TSpTBXItem;
    tlbMainMenuSeparatorItem5: TSpTBXSeparatorItem;
    tbsubLayout: TSpTBXSubmenuItem;
    tbiLayoutSave: TSpTBXItem;
    tbiLayoutDelete: TSpTBXItem;
    tbiLayoutStandard: TSpTBXItem;
    tlbMainMenuSeparatorItem6: TSpTBXSeparatorItem;
    mnuDeleteColumnOrder: TSpTBXItem;
    SpTBXSubmenuItem2: TSpTBXSubmenuItem;
    mnuCreateBookmark: TSpTBXItem;
    mnuCreateBookmarkDialog: TSpTBXItem;
    mnuCreateBookmarkForGDocID: TSpTBXItem;
    SpTBXSeparatorItem6: TSpTBXSeparatorItem;
    mnuGetLastDocument: TSpTBXItem;
    mnuGetDoc1: TSpTBXItem;
    mnuGetDoc2: TSpTBXItem;
    mnuGetDoc3: TSpTBXItem;
    mnuGetDoc4: TSpTBXItem;
    mnuGetDoc5: TSpTBXItem;
    SpTBXSeparatorItem7: TSpTBXSeparatorItem;
    mnuSetDoc1: TSpTBXItem;
    mnuSetDoc2: TSpTBXItem;
    mnuSetDoc3: TSpTBXItem;
    mnuSetDoc4: TSpTBXItem;
    mnuSetDoc5: TSpTBXItem;
    SpTBXSeparatorItem8: TSpTBXSeparatorItem;
    mnuCheckoutDocs: TSpTBXItem;
    mnuCheckoutAllDocs: TSpTBXItem;
    mnuTools: TSpTBXSubmenuItem;
    mnuAuditProof_Main: TSpTBXItem;
    mnuRestoreOriginal_Main: TSpTBXItem;
    mnuDocEditor_Main: TSpTBXItem;
    mnuRefreshDoc_Main: TSpTBXItem;
    tbsubCreateEmptyDoc: TSpTBXSubmenuItem;
    tbiCreateEmptyText: TSpTBXItem;
    mnuCreateEmptyDoc_Main: TSpTBXItem;
    mnuMergeDoc_Main: TSpTBXItem;
    mnuDuplicateDoc_Main: TSpTBXItem;
    mnuExportMeta_Main: TSpTBXSubmenuItem;
    mnuExportCSV_Main: TSpTBXItem;
    mnuExportXLS_Main: TSpTBXItem;
    mnuExportOO_Main: TSpTBXItem;
    mnuDeleteDoc_Main: TSpTBXItem;
    mnuEditTags: TSpTBXItem;
    mnuNewLink_Main: TSpTBXItem;
    mnuAddLink_Main: TSpTBXSubmenuItem;
    mnuResetDLM: TSpTBXItem;
    mnuSaveImportValues: TSpTBXItem;
    mnuGraphic: TSpTBXSubmenuItem;
    mnuInverted_Main: TSpTBXItem;
    mnuDeScrew_Main: TSpTBXItem;
    mnuDeSpeckle_Main: TSpTBXItem;
    mnuRemoveBorder_Main: TSpTBXItem;
    TBSeparatorItem14: TTBSeparatorItem;
    mnuRotateLeft: TSpTBXItem;
    mnuFlip: TSpTBXItem;
    mnuRotateRight: TSpTBXItem;
    TBSeparatorItem15: TTBSeparatorItem;
    mnuGraphicOptions_Main: TSpTBXItem;
    mnuHelp: TSpTBXSubmenuItem;
    mnuInfo: TSpTBXItem;
    mnuSupport: TSpTBXItem;
    mnuHandbooks: TSpTBXItem;
    mnuVideos: TSpTBXItem;
    IdAntiFreeze1: TIdAntiFreeze;
    popCheckout: TSpTBXPopupMenu;

    procedure actLayoutSaveExecute(Sender: TObject);
    procedure FillLayoutList(CurrentLayout: string);
    procedure actLayoutDeleteExecute(Sender: TObject);
    procedure actLayoutStandardExecute(Sender: TObject);
    procedure EnableLayoutDelete;
    procedure EmptyDocItemClick(Sender: TObject);
    procedure SetEmptyDocItem(Caption: string);
    procedure mnuCustomizeClick(Sender: TObject);
    procedure mnuMarkModifiedClick(Sender: TObject);
    procedure actInProgressExecute(Sender: TObject);
    procedure actLanguageDEExecute(Sender: TObject);
    procedure actLanguageENExecute(Sender: TObject);
    procedure actViewNavigationExecute(Sender: TObject);
    procedure actViewPreviewExecute(Sender: TObject);
    procedure actViewSearchOptionsExecute(Sender: TObject);
    procedure actViewThumbnailsExecute(Sender: TObject);
    procedure actViewFloatingWVLExecute(Sender: TObject);
    procedure LayoutsItemClick(Sender: TObject);
//    procedure LoadStandardLayout;
    procedure tbiLimitClick(Sender: TObject);
    procedure SetLimit(Limit: Integer);
    procedure SetSearchOption(Option: Integer);
    procedure tbiSO1Click(Sender: TObject);
    procedure tbiSo2Click(Sender: TObject);
    procedure tbiSo3Click(Sender: TObject);
    procedure tbiSo4Click(Sender: TObject);
    procedure SpTBXSplitter2Moving(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
    procedure splTreeviewMoving(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
    procedure SpTBXSplitter3Moving(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure AfterScrollVert(Sender: TObject);
    procedure AfterScrollHorz(Sender: TObject);
    procedure SetListBoxPosition;
    procedure OnCheckListClick(Field: TBfaAddfieldComp);
    procedure grdOnSelectAll;
    procedure grdOnDeselect;
    procedure pnlSearchOptionsResize(Sender: TObject);
    procedure ReadViewerIni;
    procedure InitViewer;
    procedure pnlPreviewDockChanged(Sender: TObject);
    procedure pnlResubmissionResize(Sender: TObject);
    procedure actListExecute(Sender: TObject);
    procedure tstDocumentEditorsActiveTabChange(Sender: TObject; TabIndex: Integer);
    procedure SetNavigationPanels;
    procedure FormShow(Sender: TObject);
    procedure pnlTreeViewWindowStateChanged(Sender: TObject; AWindowState: TWindowState);
    procedure pnlImporterWindowStateChanged(Sender: TObject; AWindowState: TWindowState);
    procedure grdResultlistColumnMoved(Sender: TObject; FromIndex, ToIndex: Integer);
//21.10.2019    procedure grdResultlistTitleClick(Column: TColumn);
    procedure grdResultlistOnColSizing;
    procedure pnlResubmissionWindowStateChanged(Sender: TObject; AWindowState: TWindowState);
    procedure pnlFavoritesWindowStateChanged(Sender: TObject; AWindowState: TWindowState);
    procedure pnlWorkspaceWindowStateChanged(Sender: TObject; AWindowState: TWindowState);
    procedure dteSearchPropertiesEditValueChanged(Sender: TObject);
    procedure dteSearchPropertiesValidate(Sender: TObject; var DisplayValue: Variant; var ErrorText: TCaption; var Error: Boolean);
    procedure cbxSearchLinksChange(Sender: TObject);
    procedure actDeletePagesExecute(Sender: TObject);
    procedure actDeleteSelectedExecute(Sender: TObject);
    procedure trvBookmarksDblClick(Sender: TObject);
    procedure popFavTreePopup(Sender: TObject);
    procedure actAddFolderExecute(Sender: TObject);
    procedure actCreateBookmarkExecute(Sender: TObject);
    procedure trvBookmarksEdited(Sender: TObject; Node: TTreeNode; var S: string);
    function NodeHint(tn: TTreeNode): string;

    procedure trvBookmarksMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure trvBookmarksDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    procedure trvBookmarksDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure actDeleteFolderExecute(Sender: TObject);
    procedure actDeleteFavoriteExecute(Sender: TObject);
    procedure trvBookmarksEditing(Sender: TObject; Node: TTreeNode; var AllowEdit: Boolean);
    procedure dckDocumentEditorsRequestDock(Sender: TObject; Bar: TTBCustomDockableWindow; var Accept: Boolean);
    procedure SpTBXMultiDock1RequestDock(Sender: TObject; Bar: TTBCustomDockableWindow; var Accept: Boolean);
    procedure dckTreeViewRequestDock(Sender: TObject; Bar: TTBCustomDockableWindow; var Accept: Boolean);
    procedure pnlSearchOptionsDockChanging(Sender: TObject; Floating: Boolean; DockingTo: TTBDock);
    procedure actGetDoc1Execute(Sender: TObject);
    procedure actGetDoc2Execute(Sender: TObject);
    procedure actGetDoc3Execute(Sender: TObject);
    procedure actGetDoc4Execute(Sender: TObject);
    procedure actGetDoc5Execute(Sender: TObject);
    procedure actSetDoc1Execute(Sender: TObject);
    procedure actSetDoc2Execute(Sender: TObject);
    procedure actSetDoc3Execute(Sender: TObject);
    procedure actSetDoc4Execute(Sender: TObject);
    procedure actSetDoc5Execute(Sender: TObject);
    procedure actGetLastDocumentExecute(Sender: TObject);
    procedure popTreeViewPopup(Sender: TObject);
    procedure itmExpandAllClick(Sender: TObject);
    procedure itmCollapseAllClick(Sender: TObject);
    procedure itmRefreshClick(Sender: TObject);
    procedure actSendDocumentsToWorkplaceExecute(Sender: TObject);
    procedure ppmPrintClick(Sender: TObject);
    procedure ppmEmailClick(Sender: TObject);
    procedure ppmSaveClick(Sender: TObject);
    procedure actNewLinkExecute(Sender: TObject);
    procedure actAutoRefExecute(Sender: TObject);
    procedure actFloatingNextExecute(Sender: TObject);
    procedure actFloatingPreviousExecute(Sender: TObject);
    procedure pnlSearchOptionsDockChanged(Sender: TObject);
    procedure SpTBXItem7Click(Sender: TObject);
    procedure SpTBXItem11Click(Sender: TObject);
    procedure SpTBXItem10Click(Sender: TObject);
    procedure SpTBXItem9Click(Sender: TObject);
    procedure SpTBXItem8Click(Sender: TObject);
    procedure SpTBXItem12Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure actAddLinkExecute(Sender: TObject);
    procedure actAddGlobalExecute(Sender: TObject);
    procedure actDeleteGlobalExecute(Sender: TObject);
    procedure actReplaceBookmarkExecute(Sender: TObject);
    procedure tmrSearchPanelTimer(Sender: TObject);
    procedure tmrStatusBarTimer(Sender: TObject);
    procedure actCopyDocToClipboardExecute(Sender: TObject);
    procedure actCopyOriginalDocToClipboardExecute(Sender: TObject);
    procedure actCopyPageToClipboardExecute(Sender: TObject);
    procedure actCopyDocLinkToClipboardExecute(Sender: TObject);
    procedure actDeleteLinkExecute(Sender: TObject);
    procedure actRemoveLinkExecute(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure AddTag(Tag: Widestring; bCloneCurrentDocs: Boolean = false);
    procedure actEditTagsExecute(Sender: TObject);
    procedure actPreviousPageExecute(Sender: TObject);
    procedure actNextPageExecute(Sender: TObject);
    procedure actCreateSymbolicLinkInImporterExecute(Sender: TObject);
    procedure actPublicAnnoExecute(Sender: TObject);
    procedure actPrivateAnnoExecute(Sender: TObject);
    procedure actScanExecute(Sender: TObject);
    procedure actScanDialogExecute(Sender: TObject);
    procedure actChangeDocNameExecute(Sender: TObject);
    procedure actStationeryExecute(Sender: TObject);
    procedure actFtxPosExecute(Sender: TObject);
//    procedure actDeleteSymbolicLinkExecute(Sender: TObject);
    procedure actSendPagesToWorkplaceExecute(Sender: TObject);
    procedure actSendPagesMergedToWorkplaceExecute(Sender: TObject);
    procedure actQuitExecute(Sender: TObject);
    procedure dftMainFormDragOver(Sender: TObject; ShiftState: TShiftState; APoint: TPoint; var Effect: Integer);
    procedure desResultGridDrop(Sender: TObject; DragType: TDragType; var ContinueDrop: Boolean);
    procedure detViewerDragOver(Sender: TObject; ShiftState: TShiftState; APoint: TPoint; var Effect: Integer);
    procedure desResultGridFeedback(Sender: TObject; Effect: Integer; var UseDefaultCursors: Boolean);
    procedure detViewerDrop(Sender: TObject; ShiftState: TShiftState; APoint: TPoint; var Effect: Integer);
    procedure dctImporterTargetDragOver(Sender: TObject; ShiftState: TShiftState; APoint: TPoint; var Effect: Integer);
    procedure dctImporterTargetDrop(Sender: TObject; ShiftState: TShiftState; APoint: TPoint; var Effect: Integer);
    procedure actSendDocumentsToImporterExecute(Sender: TObject);
    procedure actSendPagesToImporterExecute(Sender: TObject);
    procedure actSendPagesMergedToImporterExecute(Sender: TObject);
    procedure actFirstPageExecute(Sender: TObject);
    procedure actLastPageExecute(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure SpTBXSplitter2DblClick(Sender: TObject);
    procedure actResubCreateExecute(Sender: TObject);
    procedure actMergeDocExecute(Sender: TObject);
    procedure actWPGroupExecute(Sender: TObject);
    procedure actWPUngroupExecute(Sender: TObject);
    procedure actShowIndexingExecute(Sender: TObject);
    procedure actHideIndexingExecute(Sender: TObject);
    procedure pnlAdminWindowStateChanged(Sender: TObject; AWindowState: TWindowState);
    procedure popAddFieldsPopup(Sender: TObject);
    procedure ppmToolsPopup(Sender: TObject);
    procedure tmrCloseFormTimer(Sender: TObject);
    procedure actCreateBookmarkForGDocIDExecute(Sender: TObject);
    procedure trvBookmarksKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure actCtrlAltLeftExecute(Sender: TObject);
    procedure actCtrlAltRightExecute(Sender: TObject);
    procedure tmrCheckResubTimer(Sender: TObject);
    procedure ApplicationEvents1Message(var Msg: tagMSG; var Handled: Boolean);
    procedure btnCloseIndexingClick(Sender: TObject);
    procedure ShowTasks;
    procedure detViewerLeave(Sender: TObject);
    procedure dftMainFormLeave(Sender: TObject);
    procedure dctImporterTargetLeave(Sender: TObject);
    procedure desResultGridAfterDrop(Sender: TObject; DragResult: TDragResult; Optimized: Boolean);
    procedure actChangeBookmarkExecute(Sender: TObject);
    procedure actReOCRExecute(Sender: TObject);
    procedure actAuditProofExecute(Sender: TObject);
    procedure DropFileSource1Drop(Sender: TObject; DragType: TDragType; var ContinueDrop: Boolean);
    procedure DropFileSource1AfterDrop(Sender: TObject; DragResult: TDragResult; Optimized: Boolean);
    procedure detViewer2Enter(Sender: TObject; ShiftState: TShiftState; APoint: TPoint; var Effect: Integer);
    procedure dctImporterTargetEnter(Sender: TObject; ShiftState: TShiftState; APoint: TPoint; var Effect: Integer);
    procedure detViewerEnter(Sender: TObject; ShiftState: TShiftState; APoint: TPoint; var Effect: Integer);
    procedure clItemInProgressClick(Sender: TObject);
    procedure actRestoreOriginalExecute(Sender: TObject);
    procedure actRangeOCRExecute(Sender: TObject);
    procedure actSendCopyToWorkplaceExecute(Sender: TObject);
    procedure actCreateCopyExecute(Sender: TObject);
    procedure pnlPreviewCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure actShowIndexingWithLimitExecute(Sender: TObject);
    procedure actCopyBookmarkExecute(Sender: TObject);
    procedure actCreateBookmarkMenuExecute(Sender: TObject);
    procedure actCreateBookmarkDialogExecute(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure tbiSearchBarClick(Sender: TObject);
    procedure actLanguageExecute(Sender: TObject);
    procedure actSendDocumentPreviewsToImportExecute(Sender: TObject);
    procedure tlbDocStateMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

    procedure actAddLinkHint(var HintStr: string; var CanShow: Boolean);
    procedure NoSubmenuItemHint(var HintStr: string; var CanShow: Boolean);
    procedure SetNotificationBar(Info: WideString; AThread: TThread = nil);
    procedure ResetNotificationBar(Sender: TObject);
    procedure detViewer2GetDropEffect(Sender: TObject; ShiftState: TShiftState;
      APoint: TPoint; var Effect: Integer);
//    procedure dftMainFormEnter(Sender: TObject; ShiftState: TShiftState;
//      APoint: TPoint; var Effect: Integer);
    procedure cxGridPopupMenu1Popup(ASenderMenu: TComponent;
      AHitTest: TcxCustomGridHitTest; X, Y: Integer; var AllowPopup: Boolean);
    procedure popFilterBarPopup(Sender: TObject);
    procedure actInsertExecute(Sender: TObject);
    procedure actAltNExecute(Sender: TObject);

    procedure tokenDocLinksPropertiesChange(Sender: TObject);
    procedure trvBookmarksCollapsed(Sender: TObject; Node: TTreeNode);
    procedure trvBookmarksExpanded(Sender: TObject; Node: TTreeNode);
    procedure cxGridPopupMenu1MenuItemClick(ASender: TObject;
      AHitTest: TcxCustomGridHitTest; var AHandler: TNotifyEvent;
      AParams: TList; var AHandled: Boolean);
    procedure SpTBXDockablePanel3Resize(Sender: TObject);
    procedure SpTBXMultiDock2RequestDock(Sender: TObject;
      Bar: TTBCustomDockableWindow; var Accept: Boolean);
    procedure mnuReloginClick(Sender: TObject);
    procedure popMainMenuPopup(Sender: TObject);
    procedure tmrHeartbeatTimer(Sender: TObject);
    procedure tmrQueueCountTimer(Sender: TObject);
    procedure tcSearchActiveTabChange(Sender: TObject; TabIndex: Integer);
    procedure SpTBXSplitter3MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

  private
    { Private-Deklarationen }
    LastCheckedList: TComponent;
    ForiginalEvent: TNotifyEvent;
    FDblClick, FMouseDown, FGridColumnMouseDown, FPpmToolsPopupInResultGrid: Boolean;
    fpnlTreeviewWidth, fpnlSearchWidth : Integer;
    FSearchTimerCounter: Integer;
    FMouseDownArea: TRect;
    lastHintNode: TTreeNode;
    fMouseOverRow: integer;
    FWindowsIsShuttingDown : Boolean; //08.06.2017 Ticket 10801
    FBookmarksAutoscroll: TTimer;
    FBookmarksscroll_down : Boolean;
    FInitialLoadImporterDone, FInitialLoadWorkplaceDone: Boolean;
    FBalloonHint: TBalloonHint;
    SaveInitLayout: Boolean;
    procedure FooterCustomDrawFooterCell(
      Sender: TcxGridTableView; ACanvas: TcxCanvas;
      AViewInfo: TcxGridColumnHeaderViewInfo; var ADone: Boolean);
    procedure SearchEditChange(Sender: TObject);
    procedure SearchEditEditValueChanged(Sender: TObject);
    procedure ImporterScanProfilChange(Sender: TObject);
    procedure GetSetDocExecute(Sender: TObject; Idx: Integer);
    procedure GetLastDocExecute(Sender: TObject; Idx: Integer);
    procedure PopupClick(Sender: TObject);
    procedure SetPreviewSubMenus(Prev: TbfaPreview);
    procedure grdResultlistMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure grdResultlistMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure grdResultlistMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: integer);
    function GridClickIsOnTitle(Grid: TbfaDBGrid): Boolean;
    procedure grdResultlistDblClick(Sender: TObject);
    procedure OnGetStream(Sender: TFileContentsStreamOnDemandClipboardFormat; Index: integer; out AStream: IStream);
    procedure WMSize(var Msg: TMessage); message WM_SIZE;
    procedure WMDisplayChange(var Msg: TMessage); message WM_DISPLAYCHANGE;
    function SetExportStateFields(Select: WideString): WideString;
    procedure WMQueryEndSession(var Message: TWMQueryEndSession); message WM_QUERYENDSESSION; //08.06.2017 Ticket 10801
    procedure WMEndSession(var Message: TWMEndSession); message WM_ENDSESSION; //08.06.2017 Ticket 10801
    procedure CMDialogKey(var Message: TCMDialogKey); message CM_DIALOGKEY;
    procedure BookmarksAutoscroll(Sender: TObject);
    procedure DoItemClick(Sender: TObject);
    procedure popInResubOnPopup(Sender: TObject);
    procedure OnActiveControlChange(Sender: TObject);
    procedure ClickItemPopupMenu(Sender: TObject);
    procedure tvwResultCustomDrawGroupCell(Sender: TcxCustomGridTableView; ACanvas: TcxCanvas;
      AViewInfo: TcxGridTableCellViewInfo; var ADone: Boolean);
    procedure FocusedRecordChanged(Sender: TcxCustomGridTableView; APrevFocusedRecord,
      AFocusedRecord: TcxCustomGridRecord; ANewItemRecordFocusingChanged: Boolean);
    procedure CanLeaveCurrentView(var Allow: Boolean);
    procedure ChangeTheSelectedLanguage(Sender: TObject);

  published
    edtGeneralSearch: TbfaButtonEdit; // bfacrm:ticket__show__28579
    procedure SetControlStyle(const AControl: TControl);
    procedure ExitonLogin;
    procedure SearchEditKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure SearchEditKeyPress(Sender: TObject; var Key: Char);
    procedure TVChange(Sender: TObject; Node: TTreeNode);
    procedure TVSelectionChanging(Sender: TObject; OldNode, NewNode: TJvTreeNode;
      Cause: TJvNodeSelectCause; var Allow: Boolean);
    procedure TVClick(Sender: TObject);
    procedure TVMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TVMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure SetTabStop(Ctrl: TWinControl; Value: Boolean);
    procedure ChangeSkin(Sender: TObject);
    procedure SaveViewerIniAndTreeViews;
    procedure ChangeSkinAtCreate; //12.06.2023
    procedure AddSubMenuLanguageXX; //09.07.2024
    procedure SaveLayoutAndIni;

  protected
    VisibleListControl: TObject;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure WndProc(var Msg: TMessage); override;
    procedure SetCheckActionLanguage;
    procedure AlignToolbarsToLeft;
    Procedure InitPanelResubmissionCaption;
    Procedure SetPanelResubmissionCaption;

  public
    { Public-Deklarationen }
//    {$IFDEF DEVEXSKIN}
//    dxSkinController1 : TdxSkinController;
//    {$ENDIF}
    FSelectedSkinName: string; //14.06.2019 10.3
    frmFloatingSearch: TbfaFloatingForm;
    frmLogin: TForm;
    frmSplash: TfrmSplash;
    frmListItems: TfrmListItems;
    frmCreateGlobal: TfrmCreateGlobalBookmark;
    frmTags: TfrmTags;
    fraImporter: TfraImporter;
    fraWorkplace: TfraWorkplace;
    fraResub: TfraResub;
    fraImporterResub: TfraCreateImporterResub;
    fraScanFunctions: TfraScanFunctions;
    fraDocLinks: TfraDocLinksList;
    {$IFDEF ENTERPRISE}
    fraAdmin: TfraAdminEnterprise;
    {$ELSE}
    fraAdmin: TfraAdmin;
    {$ENDIF}
    fraAdminScrollBox: TScrollBox;
    frmLinkMails: TfrmLinkMails;
    frmPassword: TfrmPassword;
    frmMovedoc: TfrmMoveDoc; //02.11.2020 hier eingebaut wegen scrolling
    MainMenu: TSpTBXToolBar;
    fAppStarted, fSkipTabChangeEvent, fSkipMaximizeEvent, FIsDragging, FRelogin, FInside, FDefaultLayout: Boolean;

    FSelectedSkinIndex, FLastActivePreview, FLastActiveTab, splTreeviewTop, splTreeviewPrevSize,
    Splitter2Top, Splitter2PrevSize, Splitter3Top, Splitter3PrevSize, PreviewWidth,
    fSearchOption: Integer;    // 0= empty, 1= ftx, 2= tags, 4= date_archived, 8= date_modified
                               // 16= user, 32= group, 64 = links, 128= title, 256= type, 512= field
                               // 1024=state
    fLastDir: string;
    fDebug, FShowMySQLError, dteSearchDisable: Boolean;
    FViewerTreeview, FImporterTreeview, FAdminTreeview: TbfaTreeview;
    FSearchthread: TQueryThread;
    grdResultlistDevEx : TcxGrid;
    grdResultlistDevExView: TbfaGridDBTableView;
    grdResultlistDevExLevel: TcxGridLevel;
    grdSplitter : TcxSplitter;
    tbiGroupByBox, tbiFooterBox, tbiPrinter, tbiColumnCustomization, tbiDeleteColumnOrder: TSpTBXItem;
    dxComponentPrinter1 : TdxComponentPrinter;
    dxComponentPrinter1Link1 : TdxGridReportLink;
//    stlGroupByBoxStyle, stlBackgroundStyle: TcxStyle;
    fraFloatingResub : TfraFloatingResub;
    pnlFloatingResub : TSpTBXDockablePanel;
    ShowFloatingResub : Boolean;
    tbiFloatingResub : TSpTBXItem;
    bfaNotificationCenter : TNotificationCenter;
    frmOptions: TfrmOptions;
    frmResubDialog: TfrmResubDialog;
    edtSearchFTX, cbxSearchUser, dteSearch, cbxSearchLinks: TBfaAddfieldComp;
    grbxSqlWhere: TSpTBXGroupBox;
    mmoSqlWhere: TMemo;
    chkSQLWhereOr: TSpTBXCheckBox;
    chkSQLWhereConstructive: TSpTBXCheckBox;
    CF_RTF: word;
    OpenDropDown: Boolean;
    frm_Rights: Tfrm_Rights;
    frmPrivateLayer : TfrmPrivateLayer;
    frmInfoBox : TfrmInfoBox;
    frmGridConfig: TfrmGridConfig;
    actSaveImportValues, actCollectDocs, actCancelCollection,
    actSaveCollectionPDF, actSaveCollectionSinglePDF, actSaveCollectionTIF,
    actSaveCollectionOriginal, actEmailCollectionPDF, actEmailCollectionSinglePDF, actEmailCollectionTIF,
    actEmailCollectionOriginal : TAction;
    FViewerThumbnailsVisible, FImporterThumbnailsVisible, FWorkplaceThumbnailsVisible: Boolean;

    actQuit, actRelogin, actCreateBookmark, actCreateEmptyDoc, actChangePassword,
    actOptions, actEmailTIFAttachment, actEmailOriginal, actEmailLink, actPrintStandard,
    actPrintSelect, actPrintPreview, actViewNavigation, actViewSearchOptions, actViewFloatingWVL,
    actViewPreview, actViewThumbnails, actDeleteColumnOrder, actGetLastDocument,
    actGetDoc1, actGetDoc2, actGetDoc3, actGetDoc4, actGetDoc5, actSetDoc1,
    actSetDoc2, actSetDoc3, actSetDoc4, actSetDoc5, actRestoreOriginal,
    actDocEditor, actRefreshDoc, actDuplicateDoc, actExportCSV, actDeleteDoc,
    actGraphicOptions, actInverted, actDeScrew, actDeSpeckle, actRemoveBorder,
    actRotateLeft, actExportXLS, actExportOO, actFlip, actRotateRight, actInfo,
    actSupport, actMergeDoc, actPreviousPage, actNextPage, actPublicAnno,
    actPrivateAnno, actStationery, actAutozoom, actZoom100, actZoomPage,
    actZoomWidth, actZoomHeight, actZoomSelect, actZoomOff, actAuditProof,
    actEditTags, actNewLink, actAddLink, actLinks, actOriginalfile,
    actCheckout, actInProgress, actIsAuditProof, actLanguageDE, actLanguageEN,
    actSave, actCancel, actLayoutSave, actLayoutDelete, actLayoutStandard,
    actSearch, actReset, actBack, actForward, actMyTasks, actDelegateTasks,
    actShowCW, actCWPrevious, actCWNext, actResubOpen, actResubWork, actResubCancel,
    actResubForward, actResubDone, actScan, actScanDialog, actLoadFile,
    actDeleteSelected, actArchive, actWPGroup, actWPUngroup,
    actWPClear, actWPLoad, actWPSave, actResubQuickForward, actPreviewBack,
    actChangeArchive, actDeletePages, actChangeDocName, actAddFolder,
    actDeleteFolder, actDeleteFavorite, actExpandAll, actCollapseAll, actRefreshTreeView,
    actExportTree, actLocalSavePreview, actEmailPreview, actSendDocumentsToWorkplace,
    actAutoRef, actShareLayer, actAddGlobal, actDeleteGlobal, actReplaceBookmark,
    actFtxPos, actCreateSymbolicLinkInImporter, actGoToOriginalDocument,
//    actDocAbo, actShowAbo, actDeleteAbo,
    actShowAllSymbolicLinks, actDeleteSymbolicLink, actRemoveLink,
    actDeleteLink, actAddAutoReference, actCopyOriginalDocToClipboard,
    actCopyPageToClipboard, actCopyDocLinkToClipboard, actSendPagesToWorkplace,
    actSendPagesMergedToWorkplace, actSendDocumentsToImporter,
    actSendPagesToImporter, actSendPagesMergedToImporter, actFirstPage,
    actLastPage, actClearFields, actLocalSaveLink, actEmailPDFAttachment,
    actSaveResub, actResubCreate, actHideSearchDetails, actShowIndexing,
    actHideIndexing, actCreateBookmarkForGDocID, actAlt1, actAlt1Num,
    actAlt2, actAlt2Num, actAlt3, actAlt3Num, actAlt4, actAlt4Num, actAlt5, actAlt5Num,
    actAlt6, actAlt6Num, actAlt7, actAlt7Num, actAlt8, actAlt8Num, actAlt9, actAlt9Num,
    actAlt0, actAlt0Num, actF4, actCtrlF, actCtrlTab, actCtrlAltLeft, actCtrlAltRight,
    actGoToSourceArchive, actScanOptions, actArchiveWithDD, actChangeBookmark, actInResub,
    actShowInResub, actRangeOCR, actF11, actSendCopyToWorkplace, actCreateCopy,
    actShowPageSortingsFrame, actHidePageSortingsFrame, actAltF11,
    actCtrlAltF, actShowIndexingWithLimit, actCopyBookmark, actCreateBookmarkDialog,
    actCreateBookmarkMenu, actResetImporter, actResetDLM, actLanguage,
    actSendDocumentPreviewsToImport, actVideos, actHandbooks,
    actLocalSavePDF, actLocalSaveTIF, actLocalSaveOriginal, actReOCR,
    actCopyDocToClipboard, actInsert, actAltN, actF2,
    actZoomIn1, actZoomIn2, actZoomOut1, actZoomOut2, actSyncFulltextZoom,
    actScrollLeft, actScrollRight, actScrollUp, actScrollDown,
    actCallDoSave, actUndockInNewTab, actUndockInNewWindow, actUndockDefault: TAction;

    actList, actListPreview : TActionList;

    constructor Create(AOwner: TComponent); override;
    procedure HandleParam(const Params: TStringList);
    procedure SetActiveTab;
    procedure SetTabButton;
    function CreateLoginForm: TForm; virtual;
    procedure grdResultlistChange(Sender: TObject);
    procedure DoResultlistChange(AThread : TThread);
    procedure SetStatusBar;
    procedure SetStatusBarID(ArcID, GDocID: Int64; GUID: string = '');
    procedure LoadDocumentsFromXML(ContType : Integer);
    procedure LoadBookmarks;
    procedure CheckResubAction;
    procedure cbxScanProfileChange(Sender: TObject);
    procedure btnIndexingClick(Sender: TObject);
    procedure btnInProgressClick(Sender: TObject);
    procedure ResultListStartDrag(Sender: TObject);
    procedure CreateDragImage(NotLoaded: Boolean = False);
    procedure DropExecute(Outside: Boolean = False);
    procedure SetAdminGUI;
    procedure TranslateAdminTreeviewItemResub;
    procedure AdminTreeviewLoad(Value: Boolean);
    procedure CreateOcrMenu;
    procedure OnComboDropDown(Sender: TObject);
    procedure OnComboCloseUp(Sender: TObject);
    procedure MainFormMouseActivate(Sender: TObject; Button: TMouseButton; ShiftState: TShiftState;
      X, Y: Integer; HitTest: Integer; var MouseActivate: TMouseActivate);
    procedure OnComboDouble(Sender: TObject; AValue: WideString);
    function CreateGlobalNode(userid, groupid: Integer; name: WideString): TTreeNode;
    procedure TreeView1CustomDrawItem(Sender: TCustomTreeView; Node: TTreeNode; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure TreeMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure LoadLayout(LayoutName: string);
    procedure SetMouseOverRow(const Value: integer);
    procedure EmptyKeyQueue;
    procedure ShowIndexing(Sender: TObject);
    procedure ChangeLanguageAfter; virtual;
    //procedure SetCheckedMenuProfile;
    procedure SetCollectionsCaptions;
    procedure DisableMainFormActions;
    procedure CreateActions(aList, aList2: TActionList; CreateActions: Boolean = True); virtual;
    procedure SetUpdaterCaption; virtual; // SJ Abschlussprojekt
    procedure SetMainFormTabStop;
    procedure SetMainFormFocus;
    procedure FillImageLists(imgCollection : TImageCollection; ColorType : String);
    procedure FillDevExImageLists(imgList : TcxImageList; ColorType : String);
    procedure OnColumnCustomizationClick(Sender: TObject);
    procedure OnClickGroupping(Sender: TObject);
    procedure OnClickFooter(Sender: TObject);
    procedure OnClickPrinter(Sender: TObject);
    procedure GridColumnPosChanged(Sender: TcxGridTableView; AColumn: TcxGridColumn);
    procedure GridColumnSizeChanged(Sender: TcxGridTableView; AColumn: TcxGridColumn);
    procedure GridColumnSortingChanged(Sender: TObject);
    procedure grdResultListSelectionChanged(Sender: TcxCustomGridTableView);
    procedure grdResultlistDevExCanFocusRecord(Sender: TcxCustomGridTableView;
      ARecord: TcxCustomGridRecord; var AAllow: Boolean);
    procedure tvwResultCustomDrawCell(Sender: TcxCustomGridTableView;
      ACanvas: TcxCanvas; AViewInfo: TcxGridTableDataCellViewInfo;
      var ADone: Boolean);
    procedure SetGridDBTableViewSettings(grdDBTableView: TbfaGridDBTableView);
    procedure SetAdminFrame;
    procedure SetAdminFrameControls ; virtual;
    function IsFloatingResubShowing : Boolean;
    procedure SaveAdminFrameControls(iniFile: TIniFile); virtual;
    function checkBookmark(tvSelected: TTreeNode; obj: TbfaSearch; isGlobal: Boolean): Boolean;
    procedure edtPageNumberKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);

    property MouseOverRow: integer read fMouseOverRow write SetMouseOverRow;
    property edtSearchText: TbfaButtonEdit read edtGeneralSearch write edtGeneralSearch; // bfacrm:ticket__show__28579
    property InitialLoadImporterDone: Boolean read FInitialLoadImporterDone write FInitialLoadImporterDone;
    property InitialLoadWorkplaceDone: Boolean read FInitialLoadWorkplaceDone write FInitialLoadWorkplaceDone;
    property ppmToolsPopupInResultGrid: Boolean read FPpmToolsPopupInResultGrid write FPpmToolsPopupInResultGrid;
  end;

  TControlAccess = class(TControl);

const
  WM_HOTKEY_WVL_MESSAGE = WM_APP + 0;
  WM_HOTKEY_RECONNECT = WM_APP + 1;
  WM_HOTKEY_ENABLE_DISABLE = WM_APP + 2; // WParam 1 = enable, WParam 0 = disable
  WM_HOTKEY_RELOAD_CONFIG = WM_APP + 3;

var
  frmMainForm: TfrmGPL;

implementation

uses
  CommonGUIUtils, DB, bfaBaseObjects, ShellAPI, u_Message, cxVariants, cxDateNavigator,
  bfaCommonMethods, bfaCommonDialogs, bfaCommonFiles, bfaCommonImageEN, bfaCommonDB, bfaOptions, bfaCommonStyles,
  bfaApplication, LoginGPL,
  {$IFDEF ENTERPRISE}
  bfaApplicationEnterprise, LoginEnterprise, MainFormEnterprise,
  {$ENDIF}
  imageenio, DateUtils, TypInfo, Math, bfaParser, bfaProcessing, PreviewDlg, bfaIconsDM,
  CommCtrl, USingleInst, types, bfaBasePreview, Registry, u_bfaInputEdit, u_bfaInputCombo,
  u_bfaSelector,  cxButtons, cxEditConsts,
  PNGImage, cxGridStdPopupMenu, cxGridDBDataDefinitions, bfaCalloutPopup,
  cxGridMenuOperations, cxGridFooterPopupMenuItems, ClipBrd, ExportForm,
  bfaImageEnVect
  {$IFDEF IMAGEEN1140}
  , hyiedefs, iexBitmaps
  {$ENDIF}
  , SVNInfoForm, EditHolidayForm, dxGDIPlusClasses, System.IOUtils;

{$R *.dfm}
{$R 'bfaIcons362.RES'}
{$R 'bfaIcons362_preview.RES'}
{$R 'bfaIcons362_flags.RES'}
{$R 'icons.RES'}

procedure AddResourceImageToImageList(imgList: TImageCollection; ImageName, Typ: String);
var
  BMPImg: TBitmap;
  PNGImg: TPngImage;
begin
  try
    PNGImg:= TPngImage.Create;
    PNGImg.LoadFromResourceName(hInstance, Typ + ImageName);
    imgList.add(ImageName, HInstance, Typ + ImageName);
  finally
    FreeAndNil(PNGImg);
  end;
end;

procedure AddResourceImageToDevExImageList(imgList: TcxImageList; ImageName, Typ: String);
var
  SVGImg: TdxSmartImage;
begin
  try
    SVGImg:= TdxSmartImage.Create;
    SVGImg.LoadFromResource(hInstance, Typ + ImageName, RT_RCDATA);
    imgList.Add(SVGImg);
  finally
    FreeAndNil(SVGImg);
  end;
end;


procedure TfrmGPL.FillDevExImageLists(imgList : TcxImageList; ColorType : String);
  procedure ResourceToDevExImgList;
  begin
//09.07.2024
//    for var i := 0 to imgList.Count - 1 do
//      imgList.Delete(i);

    imgList.Clear;

    if imgList = bfaIcons.imlLanguage then
    begin
      AddResourceImageToDevExImageList(imgList, 'flag_ar', ColorType);
      AddResourceImageToDevExImageList(imgList, 'flag_bg', ColorType);
      AddResourceImageToDevExImageList(imgList, 'flag_da', ColorType);
      AddResourceImageToDevExImageList(imgList, 'flag_el', ColorType);
      AddResourceImageToDevExImageList(imgList, 'flag_es', ColorType);
      AddResourceImageToDevExImageList(imgList, 'flag_fi', ColorType);
      AddResourceImageToDevExImageList(imgList, 'flag_fr', ColorType);
      AddResourceImageToDevExImageList(imgList, 'flag_hi', ColorType);
      AddResourceImageToDevExImageList(imgList, 'flag_hu', ColorType);
      AddResourceImageToDevExImageList(imgList, 'flag_it', ColorType);
      AddResourceImageToDevExImageList(imgList, 'flag_ja', ColorType);
      AddResourceImageToDevExImageList(imgList, 'flag_nb', ColorType);
      AddResourceImageToDevExImageList(imgList, 'flag_nl', ColorType);
      AddResourceImageToDevExImageList(imgList, 'flag_pl', ColorType);
      AddResourceImageToDevExImageList(imgList, 'flag_pt', ColorType);
      AddResourceImageToDevExImageList(imgList, 'flag_ro', ColorType);
      AddResourceImageToDevExImageList(imgList, 'flag_sk', ColorType);
      AddResourceImageToDevExImageList(imgList, 'flag_sv', ColorType);
      AddResourceImageToDevExImageList(imgList, 'flag_tr', ColorType);
      AddResourceImageToDevExImageList(imgList, 'flag_uk', ColorType);
      AddResourceImageToDevExImageList(imgList, 'flag_zh', ColorType);
    end;
  end;
begin
  try
    ResourceToDevExImgList;
  except
    //
  end;
end;

procedure TfrmGPL.FillImageLists(imgCollection : TImageCollection; ColorType : String);
  procedure ResourceToimgList(imgList : TImageCollection; Typ : string);
  begin
    for var i := 0 to imgList.Count - 1 do
      imgList.Delete(i);

    if imgCollection = bfaIcons.imcMain then
    begin
      AddResourceImageToImageList(imgList, 'abort', Typ);
      AddResourceImageToImageList(imgList, 'admin_clock', Typ);
      AddResourceImageToImageList(imgList, 'admin_clock_selected', Typ);
      AddResourceImageToImageList(imgList, 'annotation_delete', Typ);
      AddResourceImageToImageList(imgList, 'annotation_no', Typ);
      AddResourceImageToImageList(imgList, 'annotation_private', Typ);
      AddResourceImageToImageList(imgList, 'annotation_public', Typ);
      AddResourceImageToImageList(imgList, 'archive_document', Typ);
      AddResourceImageToImageList(imgList, 'arrow_down', Typ);
      AddResourceImageToImageList(imgList, 'arrow_left', Typ);
      AddResourceImageToImageList(imgList, 'arrow_right', Typ);
      AddResourceImageToImageList(imgList, 'arrow_up', Typ);
      AddResourceImageToImageList(imgList, 'autoreference', Typ);
      AddResourceImageToImageList(imgList, 'away', Typ);
      AddResourceImageToImageList(imgList, 'away_remove', Typ);
      AddResourceImageToImageList(imgList, 'bell', Typ);
      AddResourceImageToImageList(imgList, 'bell_remove', Typ);
      AddResourceImageToImageList(imgList, 'bell_view', Typ);
      AddResourceImageToImageList(imgList, 'book', Typ);
      AddResourceImageToImageList(imgList, 'bookmark', Typ);
      AddResourceImageToImageList(imgList, 'bookmark_check', Typ);
      AddResourceImageToImageList(imgList, 'bookmark_check_selected', Typ);
      AddResourceImageToImageList(imgList, 'bookmark_create', Typ);
      AddResourceImageToImageList(imgList, 'bookmark_dialog', Typ);
      AddResourceImageToImageList(imgList, 'bookmark_edit', Typ);
      AddResourceImageToImageList(imgList, 'bookmark_folder', Typ);
      AddResourceImageToImageList(imgList, 'bookmark_folder_selected', Typ);
      AddResourceImageToImageList(imgList, 'bookmark_global', Typ);
      AddResourceImageToImageList(imgList, 'bookmark_global_check', Typ);
      AddResourceImageToImageList(imgList, 'bookmark_global_selected', Typ);
      AddResourceImageToImageList(imgList, 'bookmark_global_selected_check', Typ);
      AddResourceImageToImageList(imgList, 'bookmark_selected', Typ);
      AddResourceImageToImageList(imgList, 'checkout_disabled', Typ);
      AddResourceImageToImageList(imgList, 'checkout_unselected', Typ);
      AddResourceImageToImageList(imgList, 'clipboard', Typ);
      AddResourceImageToImageList(imgList, 'clipboard_file', Typ);
      AddResourceImageToImageList(imgList, 'clipboard_link', Typ);
      AddResourceImageToImageList(imgList, 'clipboard_page', Typ);
      AddResourceImageToImageList(imgList, 'clipboard_stamp', Typ);
      AddResourceImageToImageList(imgList, 'clock', Typ);
      AddResourceImageToImageList(imgList, 'clock_abort', Typ);
      AddResourceImageToImageList(imgList, 'clock_check', Typ);
      AddResourceImageToImageList(imgList, 'clock_create', Typ);
      AddResourceImageToImageList(imgList, 'clock_disabled', Typ);
      AddResourceImageToImageList(imgList, 'clock_enabled', Typ);
      AddResourceImageToImageList(imgList, 'clock_forward', Typ);
      AddResourceImageToImageList(imgList, 'clock_unselected', Typ);
      AddResourceImageToImageList(imgList, 'cut_border', Typ);
      AddResourceImageToImageList(imgList, 'database_close', Typ);
      AddResourceImageToImageList(imgList, 'database_create', Typ);
      AddResourceImageToImageList(imgList, 'database_export', Typ);
      AddResourceImageToImageList(imgList, 'database_start', Typ);
      AddResourceImageToImageList(imgList, 'date', Typ);
      AddResourceImageToImageList(imgList, 'date_deleteDate_recalculate', Typ);
      AddResourceImageToImageList(imgList, 'delete_nrs', Typ);
      AddResourceImageToImageList(imgList, 'document', Typ);
      AddResourceImageToImageList(imgList, 'document_bookmark', Typ);
      AddResourceImageToImageList(imgList, 'document_checkout', Typ);
      AddResourceImageToImageList(imgList, 'document_checkout_all', Typ);
      AddResourceImageToImageList(imgList, 'document_copy', Typ);
      AddResourceImageToImageList(imgList, 'document_create_empty', Typ);
      AddResourceImageToImageList(imgList, 'document_delete', Typ);
      AddResourceImageToImageList(imgList, 'document_info', Typ);
      AddResourceImageToImageList(imgList, 'document_invert_color', Typ);
      AddResourceImageToImageList(imgList, 'document_last', Typ);
      AddResourceImageToImageList(imgList, 'document_link_add', Typ);
      AddResourceImageToImageList(imgList, 'document_link_remove', Typ);
      AddResourceImageToImageList(imgList, 'document_merge', Typ);
      AddResourceImageToImageList(imgList, 'document_reload', Typ);
      AddResourceImageToImageList(imgList, 'document_split', Typ);
      AddResourceImageToImageList(imgList, 'edit', Typ);
      AddResourceImageToImageList(imgList, 'edit_enabled', Typ);
      AddResourceImageToImageList(imgList, 'edit_graphics', Typ);
      AddResourceImageToImageList(imgList, 'edit_password', Typ);
      AddResourceImageToImageList(imgList, 'edit_unselected', Typ);
      AddResourceImageToImageList(imgList, 'export_csv', Typ);
      AddResourceImageToImageList(imgList, 'export_meta', Typ);
      AddResourceImageToImageList(imgList, 'export_odt', Typ);
      AddResourceImageToImageList(imgList, 'export_xls', Typ);
      AddResourceImageToImageList(imgList, 'fields', Typ);
      AddResourceImageToImageList(imgList, 'fields_save', Typ);
      AddResourceImageToImageList(imgList, 'files_download', Typ);
      AddResourceImageToImageList(imgList, 'files_load', Typ);
      AddResourceImageToImageList(imgList, 'flag_britain', Typ);
      AddResourceImageToImageList(imgList, 'flag_germany', Typ);
      AddResourceImageToImageList(imgList, 'folder_closed', Typ);
      AddResourceImageToImageList(imgList, 'folder_closed_importer', Typ);
      AddResourceImageToImageList(imgList, 'folder_open', Typ);
      AddResourceImageToImageList(imgList, 'folder_open_importer', Typ);
      AddResourceImageToImageList(imgList, 'forwarded', Typ);
      AddResourceImageToImageList(imgList, 'group', Typ);
      AddResourceImageToImageList(imgList, 'help', Typ);
      AddResourceImageToImageList(imgList, 'hourglass', Typ);
      AddResourceImageToImageList(imgList, 'importer_document_pages', Typ);
      AddResourceImageToImageList(imgList, 'importer_pages', Typ);
      AddResourceImageToImageList(imgList, 'importer_reset', Typ);
      AddResourceImageToImageList(imgList, 'importer_send', Typ);
      AddResourceImageToImageList(imgList, 'importer_send_view', Typ);
      AddResourceImageToImageList(imgList, 'info', Typ);
      AddResourceImageToImageList(imgList, 'jump_to_original_archive', Typ);
      AddResourceImageToImageList(imgList, 'language_select', Typ);
      AddResourceImageToImageList(imgList, 'layouts', Typ);
      AddResourceImageToImageList(imgList, 'layout_delete', Typ);
      AddResourceImageToImageList(imgList, 'layout_save', Typ);
      AddResourceImageToImageList(imgList, 'letter', Typ);
      AddResourceImageToImageList(imgList, 'link_create', Typ);
      AddResourceImageToImageList(imgList, 'link_delete', Typ);
      AddResourceImageToImageList(imgList, 'link_enabled', Typ);
      AddResourceImageToImageList(imgList, 'link_unselected', Typ);
      AddResourceImageToImageList(imgList, 'lock', Typ);
      AddResourceImageToImageList(imgList, 'lock_no', Typ);
      AddResourceImageToImageList(imgList, 'mail_file', Typ);
      AddResourceImageToImageList(imgList, 'mail_link', Typ);
      AddResourceImageToImageList(imgList, 'mail_pdf', Typ);
      AddResourceImageToImageList(imgList, 'mail_tif', Typ);
      AddResourceImageToImageList(imgList, 'mail_view', Typ);
      AddResourceImageToImageList(imgList, 'move', Typ);
      AddResourceImageToImageList(imgList, 'ok', Typ);
      AddResourceImageToImageList(imgList, 'original_file_enabled', Typ);
      AddResourceImageToImageList(imgList, 'original_file_unselected', Typ);
      AddResourceImageToImageList(imgList, 'original_restore', Typ);
      AddResourceImageToImageList(imgList, 'original_view', Typ);
      AddResourceImageToImageList(imgList, 'page_delete', Typ);
      AddResourceImageToImageList(imgList, 'paint_settings', Typ);
      AddResourceImageToImageList(imgList, 'plugin', Typ);
      AddResourceImageToImageList(imgList, 'pointer', Typ);
      AddResourceImageToImageList(imgList, 'preview_auto', Typ);
      AddResourceImageToImageList(imgList, 'preview_height', Typ);
      AddResourceImageToImageList(imgList, 'preview_no_autozoom', Typ);
      AddResourceImageToImageList(imgList, 'preview_original', Typ);
      AddResourceImageToImageList(imgList, 'preview_width', Typ);
      AddResourceImageToImageList(imgList, 'print', Typ);
      AddResourceImageToImageList(imgList, 'print_view', Typ);
      AddResourceImageToImageList(imgList, 'profile_change', Typ);
      AddResourceImageToImageList(imgList, 'relog', Typ);
      AddResourceImageToImageList(imgList, 'remove_dots', Typ);
      AddResourceImageToImageList(imgList, 'rename_document', Typ);
      AddResourceImageToImageList(imgList, 'reset', Typ);
      AddResourceImageToImageList(imgList, 'resubmission_everybody', Typ);
      AddResourceImageToImageList(imgList, 'resubmission_everybody_forward', Typ);
      AddResourceImageToImageList(imgList, 'resubmission_group', Typ);
      AddResourceImageToImageList(imgList, 'resubmission_group_forward', Typ);
      AddResourceImageToImageList(imgList, 'resubmission_own', Typ);
      AddResourceImageToImageList(imgList, 'resubmission_own_forward', Typ);
      AddResourceImageToImageList(imgList, 'rotate_180', Typ);
      AddResourceImageToImageList(imgList, 'rotate_left', Typ);
      AddResourceImageToImageList(imgList, 'rotate_right', Typ);
      AddResourceImageToImageList(imgList, 'save_file', Typ);
      AddResourceImageToImageList(imgList, 'save_link', Typ);
      AddResourceImageToImageList(imgList, 'save_pdf', Typ);
      AddResourceImageToImageList(imgList, 'save_tif', Typ);
      AddResourceImageToImageList(imgList, 'save_view', Typ);
      AddResourceImageToImageList(imgList, 'scan_dialog', Typ);
      AddResourceImageToImageList(imgList, 'scan_page', Typ);
      AddResourceImageToImageList(imgList, 'scan_profile_create', Typ);
      AddResourceImageToImageList(imgList, 'scan_profile_export', Typ);
      AddResourceImageToImageList(imgList, 'scan_profile_global', Typ);
      AddResourceImageToImageList(imgList, 'scan_profile_import', Typ);
      AddResourceImageToImageList(imgList, 'scan_profile_local', Typ);
      AddResourceImageToImageList(imgList, 'scan_profile_remove', Typ);
      AddResourceImageToImageList(imgList, 'scan_settings', Typ);
      AddResourceImageToImageList(imgList, 'search', Typ);
      AddResourceImageToImageList(imgList, 'search_left', Typ);
      AddResourceImageToImageList(imgList, 'search_result_highlighting', Typ);
      AddResourceImageToImageList(imgList, 'search_result_highlighting_no', Typ);
      AddResourceImageToImageList(imgList, 'search_right', Typ);
      AddResourceImageToImageList(imgList, 'select', Typ);
      AddResourceImageToImageList(imgList, 'send_to', Typ);
      AddResourceImageToImageList(imgList, 'settings', Typ);
      AddResourceImageToImageList(imgList, 'sorting_abort', Typ);
      AddResourceImageToImageList(imgList, 'start', Typ);
      AddResourceImageToImageList(imgList, 'status_check_out', Typ);
      AddResourceImageToImageList(imgList, 'status_field_disabled', Typ);
      AddResourceImageToImageList(imgList, 'status_field_enabled', Typ);
      AddResourceImageToImageList(imgList, 'status_field_unselected', Typ);
      AddResourceImageToImageList(imgList, 'straighten', Typ);
      AddResourceImageToImageList(imgList, 'surface', Typ);
      AddResourceImageToImageList(imgList, 'switch', Typ);
      AddResourceImageToImageList(imgList, 'symbolic_link', Typ);
      AddResourceImageToImageList(imgList, 'symbolic_link_remove', Typ);
      AddResourceImageToImageList(imgList, 'symbolic_link_view', Typ);
      AddResourceImageToImageList(imgList, 'tag_edit', Typ);
      AddResourceImageToImageList(imgList, 'team_viewer', Typ);
      AddResourceImageToImageList(imgList, 'thumbnail', Typ);
      AddResourceImageToImageList(imgList, 'toolbar', Typ);
      AddResourceImageToImageList(imgList, 'tree', Typ);
      AddResourceImageToImageList(imgList, 'tree_expand', Typ);
      AddResourceImageToImageList(imgList, 'tree_reduce', Typ);
      AddResourceImageToImageList(imgList, 'tree_reload', Typ);
      AddResourceImageToImageList(imgList, 'tree_tools', Typ);
      AddResourceImageToImageList(imgList, 'update', Typ);
      AddResourceImageToImageList(imgList, 'user', Typ);
      AddResourceImageToImageList(imgList, 'video', Typ);
      AddResourceImageToImageList(imgList, 'warehouse_closed', Typ);
      AddResourceImageToImageList(imgList, 'warehouse_closed_importer', Typ);
      AddResourceImageToImageList(imgList, 'warehouse_open', Typ);
      AddResourceImageToImageList(imgList, 'warehouse_open_importer', Typ);
      AddResourceImageToImageList(imgList, 'workspace_copy', Typ);
      AddResourceImageToImageList(imgList, 'workspace_document', Typ);
      AddResourceImageToImageList(imgList, 'workspace_document_pages', Typ);
      AddResourceImageToImageList(imgList, 'workspace_pages', Typ);

    end
    else if imgCollection = bfaIcons.imcPreview then begin
      AddResourceImageToImageList(imgList, 'arrow', Typ);
      AddResourceImageToImageList(imgList, 'change_color', Typ);
      AddResourceImageToImageList(imgList, 'change_format', Typ);
      AddResourceImageToImageList(imgList, 'clipboard_fields', Typ);
      AddResourceImageToImageList(imgList, 'clipboard_objects', Typ);
      AddResourceImageToImageList(imgList, 'clipboard_rights', Typ);
      AddResourceImageToImageList(imgList, 'clipboard_status_field', Typ);
      AddResourceImageToImageList(imgList, 'copy_objects', Typ);
      AddResourceImageToImageList(imgList, 'dialog_stamp', Typ);
      AddResourceImageToImageList(imgList, 'document_reserve_mail_file', Typ);
      AddResourceImageToImageList(imgList, 'document_reserve_mail_pdf', Typ);
      AddResourceImageToImageList(imgList, 'document_reserve_mail_tif', Typ);
      AddResourceImageToImageList(imgList, 'document_reserve_remove', Typ);
      AddResourceImageToImageList(imgList, 'document_reserve_save_file', Typ);
      AddResourceImageToImageList(imgList, 'document_reserve_save_pdf', Typ);
      AddResourceImageToImageList(imgList, 'document_reserve_save_tif', Typ);
      AddResourceImageToImageList(imgList, 'document_reserve', Typ);
      AddResourceImageToImageList(imgList, 'document_reserved_view_1', Typ);
      AddResourceImageToImageList(imgList, 'document_reserved_view_2', Typ);
      AddResourceImageToImageList(imgList, 'document_reserved_view_3', Typ);
      AddResourceImageToImageList(imgList, 'document_reserved_view_4', Typ);
      AddResourceImageToImageList(imgList, 'document_reserved_view_5', Typ);
      AddResourceImageToImageList(imgList, 'document_reserve_1', Typ);
      AddResourceImageToImageList(imgList, 'document_reserve_2', Typ);
      AddResourceImageToImageList(imgList, 'document_reserve_3', Typ);
      AddResourceImageToImageList(imgList, 'document_reserve_4', Typ);
      AddResourceImageToImageList(imgList, 'document_reserve_5', Typ);
      AddResourceImageToImageList(imgList, 'filetype_ANY', Typ);
      AddResourceImageToImageList(imgList, 'filetype_STAR', Typ);
      AddResourceImageToImageList(imgList, 'info_dialog', Typ);
      AddResourceImageToImageList(imgList, 'legal_dialog', Typ);
      AddResourceImageToImageList(imgList, 'line', Typ);
      AddResourceImageToImageList(imgList, 'marker_blue', Typ);
      AddResourceImageToImageList(imgList, 'marker_green', Typ);
      AddResourceImageToImageList(imgList, 'marker_orange', Typ);
      AddResourceImageToImageList(imgList, 'marker_red', Typ);
      AddResourceImageToImageList(imgList, 'marker_yellow', Typ);
      AddResourceImageToImageList(imgList, 'note_blue', Typ);
      AddResourceImageToImageList(imgList, 'note_green', Typ);
      AddResourceImageToImageList(imgList, 'note_orange', Typ);
      AddResourceImageToImageList(imgList, 'note_red', Typ);
      AddResourceImageToImageList(imgList, 'note_yellow', Typ);
      AddResourceImageToImageList(imgList, 'ocr', Typ);
      AddResourceImageToImageList(imgList, 'open_new_tab', Typ);
      AddResourceImageToImageList(imgList, 'open_new_window', Typ);
      AddResourceImageToImageList(imgList, 'pencil_blue', Typ);
      AddResourceImageToImageList(imgList, 'pencil_green', Typ);
      AddResourceImageToImageList(imgList, 'pencil_orange', Typ);
      AddResourceImageToImageList(imgList, 'pencil_red', Typ);
      AddResourceImageToImageList(imgList, 'pencil_yellow', Typ);
      AddResourceImageToImageList(imgList, 'resubmission_user_01', Typ);
      AddResourceImageToImageList(imgList, 'resubmission_user_02', Typ);
      AddResourceImageToImageList(imgList, 'resubmission_user_03', Typ);
      AddResourceImageToImageList(imgList, 'resubmission_user_04', Typ);
      AddResourceImageToImageList(imgList, 'resubmission_user_05', Typ);
      AddResourceImageToImageList(imgList, 'resubmission_user_06', Typ);
      AddResourceImageToImageList(imgList, 'resubmission_user_07', Typ);
      AddResourceImageToImageList(imgList, 'resubmission_user_08', Typ);
      AddResourceImageToImageList(imgList, 'resubmission_user_09', Typ);
      AddResourceImageToImageList(imgList, 'resubmission_user_10', Typ);
      AddResourceImageToImageList(imgList, 'resubmission_view', Typ);
      AddResourceImageToImageList(imgList, 'stamp_aqua', Typ);
      AddResourceImageToImageList(imgList, 'stamp_black', Typ);
      AddResourceImageToImageList(imgList, 'stamp_blue', Typ);
      AddResourceImageToImageList(imgList, 'stamp_green', Typ);
      AddResourceImageToImageList(imgList, 'stamp_grey', Typ);
      AddResourceImageToImageList(imgList, 'stamp_image', Typ);
      AddResourceImageToImageList(imgList, 'stamp_no', Typ);
      AddResourceImageToImageList(imgList, 'stamp_orange', Typ);
      AddResourceImageToImageList(imgList, 'stamp_pink', Typ);
      AddResourceImageToImageList(imgList, 'stamp_purple', Typ);
      AddResourceImageToImageList(imgList, 'stamp_red', Typ);
      AddResourceImageToImageList(imgList, 'stamp_text', Typ);
      AddResourceImageToImageList(imgList, 'stamp_yellow', Typ);
      AddResourceImageToImageList(imgList, 'tag_assistant_enabled', Typ);
      AddResourceImageToImageList(imgList, 'tag_assistant_unselected', Typ);
      AddResourceImageToImageList(imgList, 'text', Typ);
      AddResourceImageToImageList(imgList, 'text_1', Typ);
      AddResourceImageToImageList(imgList, 'text_2', Typ);
      AddResourceImageToImageList(imgList, 'text_3', Typ);
      AddResourceImageToImageList(imgList, 'text_4', Typ);
      AddResourceImageToImageList(imgList, 'text_5', Typ);

    end;
  end;
begin
  try
    ResourceToimgList(imgCollection, ColorType);
  except
    //
  end;
end;

procedure TfrmGPL.actLayoutDeleteExecute(Sender: TObject);
var
  S: string;
  SL : TStringList;
  I : Integer;
  bool: Boolean;
begin
  try
    inherited;
    SL := TStringList.Create;
    for I := 3 to tbsubLayout.Count -1 do
    begin
      SL.Add(tbsubLayout.Items[I].Caption);
    end;

    bool := bfaInputQuery(_('Layout lschen'), _('Bitte whlen Sie ein Layout aus der Liste!'), S, SL, True);
    SL.Free;
    if S <> '' then
    begin
//09.01.2020 neue Ini      SpTBXCustomizer1.DeleteLayout(BD.AppdataBitfarmPd + 'layout.ini', S);
      SpTBXCustomizer1.DeleteLayout(BD.AppdataBitfarmPd + 'ViewerLayout.ini', S);
      for I := 3 to tbsubLayout.Count -1 do
      begin
        if tbsubLayout.Items[I].Caption = S then
        begin
          tbsubLayout.Delete(I);
          Break;
        end;
      end;
      EnableLayoutDelete;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'actLayoutDeleteExecute', ClassName);
  end;
end;

procedure TfrmGPL.actLayoutSaveExecute(Sender: TObject);
var
  S : string;
  i : Integer;
begin
  try
    inherited;
    {$IFNDEF UNICODE}
    S := TntDialogs.WideInputBox(_('Save Layout'), _('Save current layout as:'), '');
    {$ELSE}
    bfaCommonDialogs.bfaInputQuery(_('Save Layout'), _('Save current layout as:'), S, '');  //01.09.2022 DarkSkin
    //01.09.2022 S := InputBox(_('Save Layout'), _('Save current layout as:'), '');
    {$ENDIF}
    if S <> '' then
    begin
      if S = 'Standard' then
        if BfMessageDlg('Wollen Sie das Standard-Layout wirklich berschreiben?', mtConfirmation, [mbYes,mbNo], True) = mrNo then
          Exit;

//09.01.2020 neue Ini      SpTBXCustomizer1.SaveLayout(BD.AppdataBitfarmPd + 'layout.ini', S);
      SpTBXCustomizer1.SaveLayout(BD.AppdataBitfarmPd + 'ViewerLayout.ini', S);
      FillLayoutList(S);

      for i := 0 to frmMainForm.tbsubLayout.Count - 1 do
      begin
        if Lowercase(frmMainForm.tbsubLayout.Items[i].Caption) = LowerCase(S) then
          frmMainForm.tbsubLayout.Items[i].Checked := True
        else
          frmMainForm.tbsubLayout.Items[i].Checked := False;
      end;

    end;
  except
    bitfarmLog.Write(llNormal, ltInfo, 'actLayoutSaveExecute', ClassName);
  end;
end;

procedure TfrmGPL.actLayoutStandardExecute(Sender: TObject);
begin
  try
    LoadLayout('Standard');
  except
    bitfarmLog.Write(llNormal, ltException, 'actLayoutStandardExecute', ClassName);
  end;
end;

procedure TfrmGPL.FillLayoutList(CurrentLayout: string);
var
  I: integer;
  item : TSpTBXItem;
begin

  for I := 0 to tbsubLayout.Count -1 do
  begin
    if tbsubLayout.Items[I].Caption = CurrentLayout then
      Exit;
  end;

  item := TSpTBXItem.Create(tbsubLayout);
  item.Caption:= CurrentLayout;
  item.OnClick := LayoutsItemClick;
  tbsubLayout.Add(item);
  EnableLayoutDelete;
end;

procedure TfrmGPL.EnableLayoutDelete;
begin
  if tbsubLayout.Count > 3 then
    actLayoutDelete.Enabled := True
  else
    actLayoutDelete.Enabled := False;
end;

function TfrmGPL.IsFloatingResubShowing : Boolean;
begin
  // frmMainForm
  Result := (Self.fraFloatingResub <> nil) and
      (Self.fraFloatingResub.fraResub <> nil) and
      Self.pnlFloatingResub.Showing;
end;

procedure TfrmGPL.SearchEditChange(Sender: TObject);
var
  fValue: Widestring;
  CursorPos: Integer;
begin
  if (frmMainform = nil) or (not frmMainform.fAppStarted) then
    Exit;

  if (
      ((TbfaButtonEdit(Sender).EditingValue = '') or (TbfaButtonEdit(Sender).EditingValue = Null)) and
      (TbfaButtonEdit(Sender).Text = '')
     ) or (TbfaButtonEdit(Sender).Text = TbfaButtonEdit(Sender).Properties.Nullstring)
  then
    edtGeneralSearch.Style.StyleController := ctlGeneralSearch
  else
    edtGeneralSearch.Style.StyleController := ctlModified;

  // <!-- SJ 07.08.2019
  if (ParseNotAllowedChars(edtGeneralSearch.Text) <> edtGeneralSearch.Text) then
    begin
      fValue := ParseNotAllowedChars(edtGeneralSearch.Text);
      CursorPos := edtGeneralSearch.SelStart - (Length(edtGeneralSearch.Text) - Length(fValue));
      edtGeneralSearch.Text := fValue;
      try
        if FBalloonHint = nil then
          FBalloonHint := TBalloonHint.Create(Self);
        FBalloonHint.Delay := 0;
        FBalloonHint.HideAfter := 800;
        FBalloonHint.Description := _(sMsgNotAllowedCharachters) + sNotAllowedChar;
        FBalloonHint.ShowHint(TbfaButtonEdit(Sender));
      except
        //
      end;
      edtGeneralSearch.SelStart := CursorPos;
    end
  // SJ 07.08.2019 -->
end;

procedure TfrmGPL.SearchEditEditValueChanged(Sender: TObject);
begin
  if not frmMainForm.fAppStarted then
    Exit;

  if TcxTextEdit(Sender).EditValue = '' then
    TcxTextEdit(Sender).EditValue := Null;
end;


function TfrmGPL.CreateLoginForm: TForm;
var
  frmLogin : TfrmLoginGPL;
 // muss in vererbten Forms geschrieben werden
begin
  try
    frmLogin := TfrmLoginGPL.Create(Self);
    Result := frmLogin;
  except
    Result := nil;
  end;
end;

procedure TfrmGPL.dckDocumentEditorsRequestDock(Sender: TObject; Bar: TTBCustomDockableWindow; var Accept: Boolean);
begin
  if (Bar.Name = 'pnlSearchOptions') or (Bar.Name = 'SpTBXDockablePanel3') then
    Accept := False;
end;

procedure TfrmGPL.dckTreeViewRequestDock(Sender: TObject; Bar: TTBCustomDockableWindow; var Accept: Boolean);
begin
  if Bar.Name = 'pnlSearchOptions' then
    Accept := False;
end;

procedure TfrmGPL.dctImporterTargetDragOver(Sender: TObject; ShiftState: TShiftState; APoint: TPoint; var Effect: Integer);
var
  TreeNode: TTreeNode;
  Ctrl: TWinControl;
begin
  try
    if (TCustomDropTarget(Sender).Target is TWinControl) then
    begin
      Ctrl := dctImporterTarget.FindTarget((TCustomDropTarget(Sender).Target as TWinControl).ClientToScreen(APoint));
      if Ctrl <> nil then
      begin
        if Ctrl = FImporterTreeview then
        begin
          TreeNode := FImporterTreeview.GetNodeAt(APoint.X, APoint.Y);
          if (TreeNode <> nil) then
          begin
//// 27.04.2017 Ticket 10406 -->
            if not FIsDragging then
              FIsDragging := True;
//// 27.04.2017 Ticket 10406 <--

            TreeNode.Selected := True;
            if (TreeNode = FImporterTreeview.RootNode) and (TreeNode.Selected) and (TreeNode.HasChildren) and (not TreeNode.Expanded) then // 27.04.2017 Ticket 10406
            begin
              TreeNode.Expand(False);
            end;

            if not ((TbfaInt64(TreeNode.Data^).Value <> -1) and (aSysArc[TbfaInt64(TreeNode.Data^).Value].Typ <> 0) and ((aSysArc[TbfaInt64(TreeNode.Data^).Value].Rights and rightImport) = rightImport)) then
            begin
              Effect := DROPEFFECT_NONE;
//              bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 8', ClassName);
            end;
          end
          else
          begin
            Effect := DROPEFFECT_NONE;
//            bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 9', ClassName);
          end;
        end
        else if (Ctrl = fraImporter.dropImporter) or (Ctrl = pnlImporter) or (Ctrl = fraImporter.lblImportObjects) or (Ctrl = fraImporter.SpTBXLabel1) or (Ctrl = fraImporter.SpTBXLabel2) or (Ctrl = bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView) or (Ctrl = bitfarmApp.PreviewContainer.ImporterItem.Preview.SingleView) or (Ctrl = bitfarmApp.PreviewContainer.ImporterItem.Preview.ThumbnailView) then
        begin
          if (bitfarmApp.PreviewContainer.ImporterItem.Preview.PreviewKind <> pvkMulti) then
            bitfarmApp.PreviewContainer.ImporterItem.Preview.PreviewKind := pvkMulti
          else if (Ctrl = fraImporter.dropImporter) or (Ctrl = fraImporter.lblImportObjects) or (Ctrl = fraImporter.SpTBXLabel1) or (Ctrl = fraImporter.SpTBXLabel2) then
          begin
            if (bitfarmApp.DragObject <> nil) and (bitfarmApp.DragObject.DragSource = bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView) then
              Effect := DROPEFFECT_NONE
            else
            begin
              if (bitfarmApp.DragObject <> nil) and (bitfarmApp.DragObject.DocumentList[0].ID <> -1) then
                Effect := DROPEFFECT_COPY
              else
              begin
                if (GetKeyState(VK_CONTROL) < 0) then
                  Effect := DROPEFFECT_COPY
                else
                  Effect := DROPEFFECT_MOVE;
              end;
            end;
          end;
        end
        else
        begin
          Effect := DROPEFFECT_NONE;
//          bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 11', ClassName);
        end;
      end
      else
      begin
        Effect := DROPEFFECT_NONE;
//        bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 12', ClassName);
      end;
    end
    else
    begin
      Effect := DROPEFFECT_NONE;
//      bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 13', ClassName);
    end;

    if bitfarmApp.DragObject <> nil then
    begin
      if (Effect <> DROPEFFECT_NONE) and (Ctrl <> nil) then
        bitfarmApp.DragObject.DragSender := Ctrl
      else
        bitfarmApp.DragObject.DragSender := nil;
    end;
  except
    Effect := DROPEFFECT_NONE;
//    bitfarmLog.Write(llNormal, ltException, 'DROPEFFECT_NONE - 14', ClassName);
  end;
end;

procedure TfrmGPL.dctImporterTargetDrop(Sender: TObject; ShiftState: TShiftState; APoint: TPoint; var Effect: Integer);
var
  TreeNode: TTreeNode;
  Ctrl: TWinControl;
begin
  try
    try
      if (TCustomDropTarget(Sender).Target is TWinControl) then
      begin
        Ctrl := dctImporterTarget.FindTarget((TCustomDropTarget(Sender).Target as TWinControl).ClientToScreen(APoint));
        if Ctrl <> nil then
        begin
          if bitfarmApp.DragObject = nil then  // kommt von aussen
          begin
            if Ctrl = FImporterTreeview then
            begin
              if (Effect = DROPEFFECT_MOVE) and (not bitfarmApp.ViewerOptions.GeneralOptions.DragDropAsWindows) then
                Effect := DROPEFFECT_COPY;

              bitfarmApp.CreateLoadAction(Effect, dctImporterTarget);
            end
            else if (Ctrl = fraImporter.dropImporter) or (Ctrl = fraImporter.lblImportObjects) or (Ctrl = fraImporter.SpTBXLabel1) or (Ctrl = fraImporter.SpTBXLabel2) or (Ctrl = bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView) then
            begin
              if (Effect = DROPEFFECT_MOVE) and (not bitfarmApp.ViewerOptions.GeneralOptions.DragDropAsWindows) then
                Effect := DROPEFFECT_COPY;

              bitfarmApp.CreateLoadAction(Effect, dctImporterTarget);
            end
            else
            begin
              Effect := DROPEFFECT_NONE;
//              bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 15', ClassName);
            end;
          end
          else
          begin
            if Ctrl = FImporterTreeview then
            begin
              TreeNode := FImporterTreeview.GetNodeAt(APoint.X, APoint.Y);
              if (TreeNode <> nil) then
              begin
                TreeNode.Selected := True;
                bitfarmApp.CurrentImportArchive.Name := TreeNode.Text;
                bitfarmApp.CurrentImportArchive.Arcid := pBfaInt64(TreeNode.Data).Value;
                //25.11.2020 Ticket 25242 -->
                bitfarmApp.CurrentImportArchive.Typ := pBfaInt64(TreeNode.Data).ArcType;
//                if TreeNode.ImageIndex in [Integer(icoidx_warehouse_open),
//                   Integer(icoidx_warehouse_closed),
//                   Integer(icoidx_warehouse_open_importer),  //25.11.2020 Ticket  25242
//                   Integer(icoidx_warehouse_closed_importer)
//                   ] then  //Lager
//                  bitfarmApp.CurrentImportArchive.Typ := 0
//                else
//                  bitfarmApp.CurrentImportArchive.Typ := 1;
                //25.11.2020 Ticket 25242 <--
              end;

              actArchive.Execute;
              Effect := DROPEFFECT_NONE;
//              bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 16', ClassName);

              FIsDragging := False;
              if bitfarmApp.DragObject <> nil then
              begin
                bitfarmApp.DragObject.Free;
                bitfarmApp.DragObject := nil;
              end;
              bitfarmApp.ChangeArchiveAction(frmMainForm.FImporterTreeview, TreeNode);

            end
            else if (Ctrl = fraImporter.dropImporter) or (Ctrl = fraImporter.lblImportObjects) or (Ctrl = fraImporter.SpTBXLabel1) or (Ctrl = fraImporter.SpTBXLabel2) then
            begin
              if (bitfarmApp.DragObject.DragKind = dkDocuments) then
                bitfarmApp.SendDocumentsTo(bitfarmApp.PreviewContainer.ImporterItem.Preview, True)
              else if bitfarmApp.DragObject.DragKind = dkPages then
              begin
                bitfarmApp.DragObject.Move := (Effect = DROPEFFECT_MOVE);
                bitfarmApp.GetActivePreview.MViewDragDrop(bitfarmApp.DragObject.DragSender, bitfarmApp.DragObject, APoint.X, APoint.Y);
              end;
            end
            else
            begin
              Effect := DROPEFFECT_NONE;
//              bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 17', ClassName);
            end;
          end;
        end
        else
        begin
          Effect := DROPEFFECT_NONE;
//          bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 18', ClassName);
        end;
      end
      else
      begin
        Effect := DROPEFFECT_NONE;
//        bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 19', ClassName);
      end;
    except
      Effect := DROPEFFECT_NONE;
//      bitfarmLog.Write(llNormal, ltException, 'DROPEFFECT_NONE - 20', ClassName);
    end;
  finally
    FIsDragging := False;
  end;
end;

procedure TfrmGPL.dctImporterTargetEnter(Sender: TObject; ShiftState: TShiftState; APoint: TPoint; var Effect: Integer);
begin
  Finside := True;
end;

procedure TfrmGPL.dctImporterTargetLeave(Sender: TObject);
begin
  FIsDragging := False;
  Finside := False;
//23.08.2017 Ticket 10999 -->
  if Sender is TDropComboTarget then
  begin
    if TDropComboTarget(Sender).Target = FViewerTreeView then
      FViewerTreeview.Repaint;
    if TDropComboTarget(Sender).Target = FImporterTreeView then
      FImporterTreeview.Repaint;
  end;
//23.08.2017 Ticket 10999 <--

end;

procedure TfrmGPL.desResultGridAfterDrop(Sender: TObject; DragResult: TDragResult; Optimized: Boolean);
begin
  FIsDragging := False;
end;

procedure TfrmGPL.desResultGridDrop(Sender: TObject; DragType: TDragType; var ContinueDrop: Boolean);
begin
//18.05.2016  FIsDragging := False;
  //OutputDebugString('GridDrop');
end;

procedure TfrmGPL.desResultGridFeedback(Sender: TObject; Effect: Integer; var UseDefaultCursors: Boolean);
var
  MyPoint: TPoint;
  InsideTheForm, GotRights: Boolean;
  Arcid: Int64;
  CursorIndex: Integer;
begin
  UseDefaultCursors := False;

  MyPoint := frmMainForm.ScreenToClient(Mouse.CursorPos);
  InsideTheForm := PtInRect(frmMainForm.ClientRect, MyPoint) and frmMainForm.Active;
  {$IFNDEF ENTERPRISE}
    TDropFileSource(Sender).DragTypes := [dtMove, dtLink];
  {$ELSE}
    TDropFileSource(Sender).DragTypes := [dtCopy, dtMove, dtLink];
  {$ENDIF}
  if bitfarmApp.DragObject.DocumentList.Count > 0 then
  begin
    GotRights := True;
    for var I := 0 to bitfarmApp.DragObject.DocumentList.Count - 1 do
    begin
      if GotRights then
      begin
        Arcid := bitfarmApp.DragObject.DocumentList[I].ArcID;

        GotRights := GotRights and (
          (bitfarmApp.DragObject.DocumentList[I].ID = -1) or
          ((High(aSysArc) > 0) and (Arcid > -1) and (Arcid <= High(aSysArc)) and (aSysArc[Arcid].Rights and rightWrite > 0))
        )
      end;
    end;
  end
  else
  begin
    Arcid := bitfarmApp.CurrentArchive.Arcid;
    GotRights := (High(aSysArc) > 0) and (Arcid > -1) and (Arcid <= High(aSysArc)) and
      (aSysArc[Arcid].Rights and rightWrite > 0);
  end;

//  if bitfarmApp.DragObject.DocumentList.Count > 0 then
//    Arcid := bitfarmApp.DragObject.DocumentList[0].ArcID
//  else
//    Arcid := bitfarmApp.CurrentArchive.Arcid;

//  OutputDebugString(PWideChar('Effect:' + IntToStr(DWORD(Effect))));
  case DWORD(Effect) and not DWORD(DROPEFFECT_SCROLL) of
    DROPEFFECT_COPY:
      begin
        if InsideTheForm then
        begin
          if FindVCLWindow(Mouse.CursorPos) = FViewerTreeview then
            Windows.SetCursor(Screen.Cursors[crSymLinkCursor])
          else
            Windows.SetCursor(Screen.Cursors[crCopyCursor]);
        end else
        begin
          if GotRights then
          begin
            Windows.SetCursor(Screen.Cursors[crCopyCursor]);
          end else
          begin
            Windows.SetCursor(Screen.Cursors[crNoDrop]); // Ticket 21428
            TDropFileSource(Sender).DragTypes := [];     // DragTypes leer setzen, damit DropFileSource1Drop nicht auslst
          end;
        end;
      end;
    DROPEFFECT_MOVE:
      begin
        if InsideTheForm then
          Windows.SetCursor(Screen.Cursors[crMoveCursor])
        else
          Windows.SetCursor(Screen.Cursors[crCopyCursor]);
      end;
    DROPEFFECT_LINK:
      begin
        if InsideTheForm then
          Windows.SetCursor(Screen.Cursors[crCopyCursor])
        else
          Windows.SetCursor(Screen.Cursors[crCopyCursor]);
      end;
  else
    Windows.SetCursor(Screen.Cursors[crNoDrop]);
  end;
end;

procedure TfrmGPL.detViewer2Enter(Sender: TObject; ShiftState: TShiftState; APoint: TPoint; var Effect: Integer);
begin
  FInside := True;
end;

procedure TfrmGPL.detViewer2GetDropEffect(Sender: TObject;
  ShiftState: TShiftState; APoint: TPoint; var Effect: Integer);
begin
  if ssAlt in ShiftState then
    Effect := 4
  else if ssCtrl in ShiftState then
    Effect := 1
  else
    Effect := 2;
end;

procedure TfrmGPL.detViewerDragOver(Sender: TObject; ShiftState: TShiftState; APoint: TPoint; var Effect: Integer);
var
  TreeNode: TTreeNode;
  Ctrl: TWinControl;
  Accept: Boolean;
  hitTest : THitTests;
begin
  //OutputDebugString(PChar('detViewerDragOver'));
  try
    if (TCustomDropTarget(Sender).Target is TWinControl) then
    begin
      Ctrl := detViewer2.FindTarget((TCustomDropTarget(Sender).Target as TWinControl).ClientToScreen(APoint));
      //OutputDebugString(PChar('detViewerDragOver - Ctrl:' + Ctrl.ClassName));
      if Ctrl <> nil then
      begin
        if Ctrl = FViewerTreeview then
        begin
          if (bitfarmApp.DragObject = nil) or ((bitfarmApp.DragObject <> nil) and (not bitfarmApp.DragObject.MoveRight)) then
          begin
            Effect := DROPEFFECT_NONE;
            Exit;
          end;

          TreeNode := FViewerTreeview.GetNodeAt(APoint.X, APoint.Y);
          hitTest := FViewerTreeview.GetHitTestInfoAt(APoint.X, APoint.Y) ;
          if (TreeNode <> nil) then
          begin
            Accept := TreeNode.Focused;
            TreeNode.Focused := True;

            if (TreeNode.HasChildren) and (not TreeNode.Expanded) and
              (hitTest <= [htOnItem, htOnIcon, htOnLabel, htOnStateIcon]) then
              TreeNode.Expand(False);

            if not Accept then
            begin
              FViewerTreeview.Refresh;
              FViewerTreeview.OnCustomDrawItem(FViewerTreeview, TreeNode, [], Accept);
            end;

            if ((TbfaInt64(TreeNode.Data^).Value <> -1)) and
              ((aSysArc[TbfaInt64(TreeNode.Data^).Value].Typ = 0) //Lager muss ausgeschlossen sein
                or
                ((aSysArc[TbfaInt64(TreeNode.Data^).Value].Rights and rightImport) = 0) // im Zielarchiv kein Importrecht
                or
                bitfarmApp.AreSelectedDocsNotMovable(TbfaInt64(TreeNode.Data^).Value)) then // Alle sektierten Dokumente befinden sich schon im Archiv oder haben kein Verschiebenrecht
            begin
              Effect := DROPEFFECT_NONE;
              Exit;
            end;
            if GetKeyState(VK_MENU) < 0 then
              Effect := DROPEFFECT_LINK;
          end else
          begin
            Effect := DROPEFFECT_NONE;
//            bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 23', ClassName);
          end;
        end
        else if (Ctrl = pnlWorkspace) then
        begin
          if ((bitfarmApp.DragObject <> nil) and (((bitfarmApp.DragObject.DragKind = dkPages) and (bitfarmApp.DragObject.DocumentList[0].ID <> -1)) or ((bitfarmApp.DragObject.DragKind = dkDocuments) and (bitfarmApp.DragObject.DragSource <> bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView)))) then
          begin
            Effect := DROPEFFECT_COPY;
          end else
          begin
            Effect := DROPEFFECT_NONE;
//            bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 24', ClassName);
          end;
        end
        else if (Ctrl = pnlImporter) then
        begin
          if ((bitfarmApp.DragObject <> nil) and ((bitfarmApp.DragObject.DragKind = dkPages) or ((bitfarmApp.DragObject.DragKind = dkDocuments) and (bitfarmApp.DragObject.DragSource <> bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView)))) then
          begin
            Effect := DROPEFFECT_COPY;
          end else
          begin
            Effect := DROPEFFECT_NONE;
//            bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 25', ClassName);
          end;
        end
        else if (Ctrl = pnlResubmission) then
        begin
          if ((bitfarmApp.DragObject <> nil) and ({(bitfarmApp.DragObject.DragKind = dkPages) or} ((bitfarmApp.DragObject.DragKind = dkDocuments) and (bitfarmApp.DragObject.DragSource <> bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView)))) then
          begin
            Effect := DROPEFFECT_COPY;
          end else
          begin
            Effect := DROPEFFECT_NONE;
//            bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 26', ClassName);
          end;
        end else
        begin
          Effect := DROPEFFECT_NONE;
//          bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 27', ClassName);
//          bitfarmLog.Write(llDebug, ltInfo, 'Ctrl.ClassName: ' + Ctrl.ClassName, ClassName);
        end;
      end else
      begin
        Effect := DROPEFFECT_NONE;
//        bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 28', ClassName);
      end;
    end else
    begin
      Effect := DROPEFFECT_NONE;
//      bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 29', ClassName);
    end;
  except
    Effect := DROPEFFECT_NONE;
//    bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 30', ClassName);
  end;
end;

// Droppen auf das Treeview
procedure TfrmGPL.detViewerDrop(Sender: TObject; ShiftState: TShiftState; APoint: TPoint; var Effect: Integer);
var
  Ctrl: TWinControl;
  TreeNode: TTreeNode;
  Accept: Boolean;
begin
  try
    try
      if (TCustomDropTarget(Sender).Target is TWinControl) then
      begin
//10.02.2017        Ctrl := detViewer.FindTarget((TCustomDropTarget(Sender).Target as TWinControl).ClientToScreen(APoint));
        Ctrl := detViewer2.FindTarget((TCustomDropTarget(Sender).Target as TWinControl).ClientToScreen(APoint));
//24.07.2017 Ticket 10474        if (Ctrl <> nil) then
        if (Ctrl <> nil) and (bitfarmApp.DragObject <> nil) then
        begin
          if Ctrl = FViewerTreeview then
          begin
            TreeNode := FViewerTreeview.GetNodeAt(APoint.X, APoint.Y);

            if (TbfaInt64(TreeNode.Data^).Value <> -1) then
            begin
              if (Effect = DROPEFFECT_COPY) then             // CreateSymLink
                bitfarmApp.MoveDocAction(TreeNode, TbfaInt64(TreeNode.Data^).Value)
              else if (bitfarmApp.DragObject <> nil) and (not bitfarmApp.DragObject.MoveRight) then
              begin
                Effect := DROPEFFECT_NONE;
//                bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 31', ClassName);
                Exit;
              end
              else if (Effect = DROPEFFECT_MOVE) then       // MoveDoc
                bitfarmApp.MoveDocAction(TreeNode, -1)
              else if (Effect = DROPEFFECT_LINK) then       // DuplicateDoc
                bitfarmApp.MoveDocAction(TreeNode, -1, True);
            end;

            TreeNode.Focused := False;
            FViewerTreeview.Refresh;
            FViewerTreeview.OnCustomDrawItem(FViewerTreeview, TreeNode, [], Accept);
          end
          else if Ctrl = pnlWorkspace then
          begin
            if (bitfarmApp.DragObject.DragKind = dkDocuments) then
              bitfarmApp.SendDocumentsTo(bitfarmApp.PreviewContainer.WorkplaceItem.Preview, True)
            else if bitfarmApp.DragObject.DragKind = dkPages then
              bitfarmApp.GetActivePreview.SendPagesTo(bitfarmApp.PreviewContainer.WorkplaceItem.Preview, True);
          end
          else if Ctrl = pnlImporter then
          begin
            if (bitfarmApp.DragObject.DragKind = dkDocuments) then
              bitfarmApp.SendDocumentsTo(bitfarmApp.PreviewContainer.ImporterItem.Preview, True)
            else if bitfarmApp.DragObject.DragKind = dkPages then
              bitfarmApp.GetActivePreview.SendPagesTo(bitfarmApp.PreviewContainer.ImporterItem.Preview, True);
          end
          else if Ctrl = pnlResubmission then
          begin
            if (bitfarmApp.DragObject.DragKind = dkDocuments) then
              bitfarmApp.ResubCreateExecute(bitfarmApp.DragObject.DocumentList[0]);
          end;
        end;
      end;
    except
//      Effect := DROPEFFECT_NONE;
    end;
  finally

    FIsDragging := False;
    if bitfarmApp.DragObject <> nil then  // Ticket 14035: Importer - Drag and Drop nicht mglich, wenn vorher Drag&Drop in Lager und Archive
    begin
      bitfarmApp.DragObject.Free;
      bitfarmApp.DragObject := nil;
    end;
  end;
end;

procedure TfrmGPL.detViewerEnter(Sender: TObject; ShiftState: TShiftState; APoint: TPoint; var Effect: Integer);
begin
  Finside := True;
end;

procedure TfrmGPL.detViewerLeave(Sender: TObject);
begin
  FIsDragging := False;
  FInside := False;
//23.08.2017 Ticket 10999 -->
  if Sender is TDropComboTarget then
  begin
    if TDropComboTarget(Sender).Target = FViewerTreeView then
      FViewerTreeview.Repaint;
    if TDropComboTarget(Sender).Target = FImporterTreeView then
      FImporterTreeview.Repaint;
  end;
//23.08.2017 Ticket 10999 <--
end;

procedure TfrmGPL.dftMainFormDragOver(Sender: TObject; ShiftState: TShiftState; APoint: TPoint; var Effect: Integer);
begin
  if bitfarmApp.FUseFileTarget then
  begin
    if bitfarmApp.PreviewContainer.ActiveItem <> pvtImporter then
//      bitfarmApp.SetActiveViewAction(pvtImporter, nil, tvkImporter);
      bitfarmApp.SetViewAndArchiveAction(tvkImporter);

  end
  else
  begin
    Effect := DROPEFFECT_NONE;
//    bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 32', ClassName);
  end;
end;

//procedure TfrmGPL.dftMainFormEnter(Sender: TObject; ShiftState: TShiftState;
//  APoint: TPoint; var Effect: Integer);
//begin
//////
//end;

procedure TfrmGPL.dftMainFormLeave(Sender: TObject);
begin
  FIsDragging := False;
//23.08.2017 Ticket 10999 -->
  if Sender is TDropComboTarget then
  begin
    if TDropComboTarget(Sender).Target = FViewerTreeView then
      FViewerTreeview.Repaint;
    if TDropComboTarget(Sender).Target = FImporterTreeView then
      FImporterTreeview.Repaint;
  end;
//23.08.2017 Ticket 10999 <--
end;

procedure TfrmGPL.dteSearchPropertiesEditValueChanged(Sender: TObject);
begin
  if dteSearchDisable then
    Exit;
  //OutputDebugString('dteSearchFromPropertiesEditValueChanged');
  try
    dteSearchDisable := True;
    if TcxDateEdit(Sender) = dteSearch.compDateLow then
    begin
      if TcxDateEdit(Sender).Date > dteSearch.compDateHigh.Date then
        dteSearch.compDateHigh.Date := TcxDateEdit(Sender).Date;
      if TcxDateEdit(Sender).Text = '' then
        dteSearch.compDateHigh.Text := '';
    end;
    if TcxDateEdit(Sender) = dteSearch.compDateHigh then
    begin
      if dteSearch.compDateLow.Text = '' then
        dteSearch.compDateLow.Date := Date();
      if TcxDateEdit(Sender).Date < dteSearch.compDateLow.Date then
        dteSearch.compDateLow.Date := TcxDateEdit(Sender).Date;
    end;
  finally
    dteSearchDisable := False;
  end;
end;

procedure TfrmGPL.dteSearchPropertiesValidate(Sender: TObject; var DisplayValue: Variant; var ErrorText: TCaption; var Error: Boolean);
var
  dt: TDateTime;
begin
  //OutputDebugString('dteSearchFromPropertiesValidate');
  if Error then
  begin
    Error := False;
    TcxDateEdit(Sender).Date := Date();
    DisplayValue := TcxDateEdit(Sender).Text;
  end;
end;

procedure TfrmGPL.edtPageNumberKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  Bool: Boolean;
  text: String;
  Msg: TMsg;
begin
  if (Key = VK_RETURN) and (Sender is TSpTBXEdit) then
  begin
    Bool := True;
    text := TSpTBXEdit(Sender).Text;
    bitfarmApp.AcceptText(Sender, text, Bool);
    PeekMessage(Msg, 0, WM_CHAR, WM_CHAR, PM_REMOVE);
  end;
end;

procedure TfrmGPL.SearchEditKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
//  if edtGeneralSearch.Text <> '' then  // SJ 13.11.2020 bfacrm:ticket__show__24708
  if (Key = VK_RETURN) and actSearch.Enabled then
  begin
    // bfacrm:ticket__show__28576
    if edtGeneralSearch.Text <> Trim(edtGeneralSearch.Text) then
      edtGeneralSearch.Text := Trim(edtGeneralSearch.Text);
    actSearch.Execute;
  end;
end;

procedure TfrmGPL.SearchEditKeyPress(Sender: TObject; var Key: Char);
var
  CtrlPressed, AllowedCtrlKeys, AltGrPressed: Boolean;
begin
  CtrlPressed := False;
  AltGrPressed := False;
  AllowedCtrlKeys := False;

  CtrlPressed := (GetKeyState(VK_CONTROL) < 0);
  AltGrPressed := (GetKeyState(VK_RMENU) < 0);
  AllowedCtrlKeys := ((GetKeyState(Ord('A')) < 0) or (GetKeyState(Ord('C')) < 0) or (GetKeyState(Ord('V')) < 0) or (GetKeyState(Ord('X')) < 0));

  if Pos(Key, sNotAllowedChar) <> 0 then
  begin
    try
      if FBalloonHint = nil then
        FBalloonHint := TBalloonHint.Create(Self);
      FBalloonHint.Delay := 0;
      FBalloonHint.HideAfter := 800;
      FBalloonHint.Description := _(sMsgNotAllowedCharachters) + sNotAllowedChar;
      FBalloonHint.ShowHint(TbfaButtonEdit(Sender));
      Key := #0;
      Beep;
      Abort;
    except
    //
    end;
  end;

//  if (Key = #6) {Strg+F} or (Key = #$13) {Strg+S} or (Key = #27) {ESC} or //12.07.2019 b.takacs Ergnzung
  if (Key = #27) {ESC} or //12.07.2019 b.takacs Ergnzung
     ((Key = #13) {Enter} and (Sender is TSpTBXEdit)) or
     (CtrlPressed and not AllowedCtrlKeys and not AltGrPressed) then
  begin
    Key := #0;
  end;
end;

procedure TfrmGPL.SetAdminGUI;
var
  inifile: TIniFile;
begin
  if bitfarmApp.User.isAdmin and not bitfarmApp.OfflineMode then
  begin
    pnlAdmin.Visible := True;
    if FAdminTreeview = nil then
    begin
      FAdminTreeview := TbfaTreeView.Create(Self);
      with FAdminTreeview do
      begin
        Parent := pnlAdmin;
        Name := 'AdminTreeView';
        Align := alClient;
        BorderStyle := bsNone;
        Font.Size := bfaFontSize; //04.09.2020
        ShowRoot := False; //17.09.2020
        Images := bfaIcons.ilMainMenu;
        OnChange := TVChange;
        OnMouseDown := TVMouseDown;
        OnDragOver := fraAdmin.AdminTreeDragOver;
        OnDragDrop := fraAdmin.AdminTreeDragDrop;
        DragMode := dmAutomatic;
        ViewKind := tvkAdministrator;
        Ininame := 'Viewer.ini';
        IniSectionName := bitfarmApp.TreeViewProfile;
        PopupMenu := popTreeView;
        Cnt := dmMain.cntMain;
        bfaLog := bitfarmApp.Log;
        User := bitfarmApp.User;
        OnNodeChecked := bitfarmApp.CountChecked;
        Color := stlControl.Color;
        Font.color := stlControl.TextColor;
      end;
    end;

    if fraAdmin = nil then
    begin
      {$IFDEF ENTERPRISE}
      fraAdmin := TfraAdminEnterprise.Create(Self);
      {$ELSE}
      fraAdmin := TfraAdmin.Create(Self);
      {$ENDIF}
      fraAdminScrollBox := TScrollBox.Create(Self);
      fraAdminScrollBox.Visible := False;
      fraAdminScrollBox.Align := alClient;
      fraAdminScrollBox.Parent := pnlPreview;
      fraAdminScrollBox.BorderStyle := bsNone;
      fraAdminScrollBox.ParentColor := True;
      fraAdminScrollBox.AutoScroll := False;
      fraAdminScrollBox.HorzScrollBar.Range := 1200;
      fraAdminScrollBox.VertScrollBar.Range := 720;
      fraAdmin.Visible := False;
      fraAdmin.Parent := fraAdminScrollBox;
      fraAdmin.Align := alClient;

      fraAdmin.bfsAssignUser.ImageList := TImageList(bfaIcons.ilMainMenu);
      fraAdmin.bfsAddfieldsUser.ImageList := TImageList(bfaIcons.ilMainMenu);
      fraAdmin.bfsStatefieldsUser.ImageList := TImageList(bfaIcons.ilMainMenu);
      fraAdmin.bfsGroupsUser.ImageList := TImageList(bfaIcons.ilMainMenu);

      bitfarmApp.ChangeAdminSkin;

      {$IFDEF ENTERPRISE}
      inifile := TIniFile.Create(BD.EnvAppdataPd + 'bitfarm-archiv\Viewer.ini');
      fraAdmin.edtWinUser.Text := inifile.ReadString('General', 'edtWinUser', '');
      fraAdmin.chkEmailFromAD.Checked := inifile.ReadBool('General', 'chkEmailFromAD', True);
      {$ENDIF}
    end;
  end else
  begin
    if Assigned(pnlAdmin) then
      pnlAdmin.Visible := False;
    if Assigned(grbxSqlWhere) then
      grbxSqlWhere.Visible := False;
    if Assigned(mmoSqlWhere) then
      mmoSqlWhere.Visible := False;
  end;
end;

procedure TfrmGPL.AdminTreeviewLoad(Value: Boolean);
begin
  if FAdminTreeview <> nil then
  begin
    FAdminTreeview.Load(Value);
    TranslateAdminTreeviewItemResub;
  end;
end;

procedure TfrmGPL.TranslateAdminTreeviewItemResub;
const
  sWIEDERVORLAGE = 'Wiedervorlage';

var
  aNodeEnum: TTreeNodesEnumerator;
  aNode: TTreeNode;
  ID: Int64;
  typ: integer;
  name: string;

begin
  if not assigned (FAdminTreeview) then
   exit;

  aNodeEnum := FAdminTreeview.Items.GetEnumerator;
  try
    while aNodeEnum.MoveNext do
    begin
      aNode := aNodeEnum.Current;
      if (aNode.level = 0) and assigned(aNode.Data)then
      begin
        Id := TbfaInt64(aNode.Data^).Value;
        if (Length(ASysArc)-1) >= Id then
        begin
          typ := ASysArc[Id].Typ;
          name := ASysArc[Id].Name;
          if (typ = 2) and (name = sWIEDERVORLAGE) then
            aNode.Text := sCaptionResubmission;
        end;
      end;
    end;
  finally
    aNodeEnum.Free;
  end;
end;

procedure TfrmGPL.CheckResubAction;
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'CheckResubAction - ', Classname);
  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actCheckResub';
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'CheckResubAction - ', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CheckResubAction - ', Classname);
  end;
end;

procedure TfrmGPL.clItemInProgressClick(Sender: TObject);
begin
  actInProgress.Execute; //09.03.2017 Ticket 9998
end;

procedure TfrmGPL.tlbDocStateMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
Var
  Item: TTBCustomItem;
begin
  if bitfarmApp.OfflineMode then
    Exit;

  try
    if Assigned(tlbDocState) and Assigned(tlbDocState.View) and
       Assigned(tlbDocState.View.Selected) and Assigned(tlbDocState.View.Selected.Item) then
    begin
      Item := tlbDocState.View.Selected.Item;
      if item = clItemInresub then
      begin
        if (Button = mbRight) then
        begin
          actInResub.Tag := Integer(Button);
          actInResub.Execute;
          actInResub.Tag := 0;
        end
        else
          actInResub.Execute;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'TfrmGPL.tlbDocStateMouseDown', ClassName);
  end;
end;

//09.03.2018 Workaround fr TcxDateEdit, wenn man auf Tab drckt -->
function ConvertEditText(const AText: string; var ADate: TDateTime): Boolean;

  function IsNumericData(AData: string): Boolean;
  var
    I, ACount: Integer;
  begin
    ACount := 0;
    for I := 1 to Length(AData) do
      if IsNumericChar(AData[I], ntInteger) then
        ACount := ACount + 1;
    Result := ACount = Length(AData);
  end;

  function GetValidDay(ADay: Integer): Integer;
  var
    ADaysCount: Integer;
  begin
    Result := ADay;
    ADaysCount := DaysPerMonth(dxGetDateElement(Now, deYear), dxGetDateElement(Now, deMonth));
    if ADay > ADaysCount then
      Result := ADaysCount;
  end;

var
  str : string;
begin
  Result := False;
  str := AText;
  if (Length(str) = 3) and (str[3] = '.')  then
    str := Copy(str, 1, 2);
  if (Length(str) in [1,2]) and IsNumericData(str) then
  begin
    ADate := EncodeDate(dxGetDateElement(Now, deYear), dxGetDateElement(Now, deMonth),
      GetValidDay(StrToInt(str)));
    Result := True;
  end
  //06.09.2024 SD -->bfacrm:ticket__show__39725
  //Wenn die DevExpress-Komponente das Datum aus den Aktionen des Benutzers nicht erkennen kann, wird das aktuelle Datum eingefgt
  else
  if (Length(str) in [1,2]) and not IsNumericData(str) then
  begin
    ADate := Now();
    Result := True;
  end;
  //06.09.2024 SD <--bfacrm:ticket__show__39725
end;
//09.03.2018 Workaround fr TcxDateEdit, wenn man auf Tab drckt <--

procedure TfrmGPL.OnColumnCustomizationClick(Sender: TObject);
begin
  try
    if grdResultListDevExView.FilterRow.Visible  then
      TbfaGridIndicatorAccess(grdResultListDevExView.ViewInfo.IndicatorViewInfo.Items[1]).DropDown
    else
      TbfaGridIndicatorAccess(grdResultListDevExView.ViewInfo.IndicatorViewInfo.Items[0]).DropDown;
  except
  end;
end;

procedure TfrmGPL.OnClickGroupping(Sender: TObject);
begin
  bitfarmApp.CurrentViewerArchive.GroupingBar := not bitfarmApp.CurrentViewerArchive.GroupingBar;
  aSysArc[bitfarmApp.CurrentViewerArchive.ArcID].GroupingBar := bitfarmApp.CurrentViewerArchive.GroupingBar;
  grdResultlistDevExView.OptionsView.GroupByBox := bitfarmApp.CurrentViewerArchive.GroupingBar;
  tbiGroupByBox.Checked := grdResultlistDevExView.OptionsView.GroupByBox;
  //25.05.2022 Ticket 31088 -->
  if not bitfarmApp.CurrentViewerArchive.GroupingBar then
  begin
    for var i := 0 to grdResultlistDevExView.ColumnCount - 1 do
    begin
      if grdResultlistDevExView.Columns[i].DataBinding.FieldName = 'docdate' then
      begin
        grdResultlistDevExView.Columns[i].SortIndex := 0;
        grdResultlistDevExView.Columns[i].SortOrder := TdxSortOrder(soDescending);
      end
      else
      begin
        grdResultlistDevExView.Columns[i].SortIndex := -1;
        grdResultlistDevExView.Columns[i].SortOrder := TdxSortOrder(soNone);
      end;
      if grdResultlistDevExView.Columns[i].GroupIndex <> -1 then
      begin
        grdResultlistDevExView.Columns[i].GroupIndex := -1;
        grdResultlistDevExView.Columns[i].Visible := True;
        for var j := Low(aColSortings[bitfarmApp.CurrentViewerArchive.ArcID]) to High(aColSortings[bitfarmApp.CurrentViewerArchive.ArcID]) do
        begin
          if aColSortings[bitfarmApp.CurrentViewerArchive.ArcID, j].Field = grdResultlistDevExView.Columns[i].DataBinding.FieldName then
          begin
            aColSortings[bitfarmApp.CurrentViewerArchive.ArcID, j].GroupingIndex := -1;
            aColSortings[bitfarmApp.CurrentViewerArchive.ArcID, j].Visible := True;
            if grdResultlistDevExView.Columns[i].DataBinding.FieldName = 'docdate' then
            begin
              aColSortings[bitfarmApp.CurrentViewerArchive.ArcID, j].SortIndex := 0;
              aColSortings[bitfarmApp.CurrentViewerArchive.ArcID, j].SortOrder := Integer(soDescending);
            end
            else
            begin
              aColSortings[bitfarmApp.CurrentViewerArchive.ArcID, j].SortIndex := -1;
              aColSortings[bitfarmApp.CurrentViewerArchive.ArcID, j].SortOrder := Integer(soNone);
            end;
            Break;
          end;
        end;
      end;
    end;
  end;
  //25.05.2022 Ticket 31088 <--
end;

procedure TfrmGPL.OnClickFooter(Sender: TObject);
begin
  bitfarmApp.CurrentViewerArchive.Footer := not bitfarmApp.CurrentViewerArchive.Footer;
  aSysArc[bitfarmApp.CurrentViewerArchive.ArcID].Footer := bitfarmApp.CurrentViewerArchive.Footer;
  grdResultlistDevExView.OptionsView.Footer := bitfarmApp.CurrentViewerArchive.Footer;
  grdResultlistDevExView.OptionsView.FooterMultiSummaries := True;
  if bitfarmApp.CurrentViewerArchive.Footer then
    grdResultlistDevExView.OptionsView.GroupFooters := gfAlwaysVisible
  else
    grdResultlistDevExView.OptionsView.GroupFooters := gfInvisible;
  tbiFooterBox.Checked := grdResultlistDevExView.OptionsView.Footer;
end;

procedure TfrmGPL.OnClickPrinter(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  try
    //29.11.2021 bt von Create hier umgewandelt, beim Start dauert erst zu lange ... -->
    if dxComponentPrinter1 = nil then
    begin
      dxComponentPrinter1 := TdxComponentPrinter.Create(Self);
      dxComponentPrinter1Link1 := TdxGridReportLink.Create(Self);
      with dxComponentPrinter1Link1 do
      begin
        ComponentPrinter := dxComponentPrinter1;
        Component := grdResultlistDevEx;
        Active := True;
      end;

      TranslateComponent(dxComponentPrinter1, 'Shared36');
      TranslateComponent(dxComponentPrinter1Link1, 'Shared36');

      dxComponentPrinter1.AddLink(dxComponentPrinter1Link1);
      dxComponentPrinter1.CurrentLinkIndex := 0;
    end;
    //29.11.2021 <--
    dxComponentPrinter1Link1.OptionsView.FilterBar := False;
    dxComponentPrinter1Link1.ReportTitleMode := tmOnFirstPage;
    if bitfarmApp.FSearchObj.SearchType in [1, 2] then
      dxComponentPrinter1Link1.ReportTitleText := bitfarmApp.FSearchObj.Name;
//10.10.2022  Ticket 32326  else
//      dxComponentPrinter1Link1.ReportTitleText := '';

    dxComponentPrinter1Link1.ReportFootnotes.Text := FormatDateTime('dd.mm.yyyy', now()) +
      ' ' + _('Benutzer:') + ' ' + bitfarmApp.User.Name;
    dxComponentPrinter1Link1.ReportFootnotes.Mode := fnmOnEveryBottomPage;

    dxComponentPrinter1.Preview(True, dxComponentPrinter1Link1);
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TfrmGPL.GridColumnPosChanged(
  Sender: TcxGridTableView; AColumn: TcxGridColumn);
begin
  grdResultlistOnColSizing;
end;

procedure TfrmGPL.GridColumnSizeChanged(
  Sender: TcxGridTableView; AColumn: TcxGridColumn);
begin
  grdResultlistOnColSizing;
end;

procedure TfrmGPL.GridColumnSortingChanged(Sender: TObject);
begin
  if not bitfarmApp.GridCreating then
    grdResultlistOnColSizing;
end;

//procedure TfrmGPL.GridLayoutChanged(Sender: TcxCustomGrid; AGridView: TcxCustomGridView);
//begin
//  inherited;
//  if frmMainForm.fAppStarted then
//    grdResultlistOnColSizing;
//end;

procedure TfrmGPL.tvwResultCustomDrawCell(Sender: TcxCustomGridTableView;
      ACanvas: TcxCanvas; AViewInfo: TcxGridTableDataCellViewInfo;
      var ADone: Boolean);
begin
//14.10.2020 Muss hier sein, sonst TbfaDBGridTableView.DoCustomDrawCell wird nicht gettigt!
end;

procedure TfrmGPL.FocusedRecordChanged(
Sender: TcxCustomGridTableView; APrevFocusedRecord,
AFocusedRecord: TcxCustomGridRecord; ANewItemRecordFocusingChanged: Boolean);
var
  AGroup: TcxGridGroupRow;
  b : Boolean;
begin
  try

    if (AFocusedRecord <> nil) and not AFocusedRecord.IsData then
    begin
//27.10.2022
//      AGroup := (AFocusedRecord as TcxGridGroupRow);
//      b:= AGroup.Expanded;
////      if b and (AGroup.ValueCount > 1) then
////        Sender.Controller.FocusNextRecordWithSelection(AGroup.Index, True, False, True)
////      ; //20.04.2022
////      else
////      if not b then
////        AGroup.Expand(True);
    end;
  except

  end;
end;

procedure TfrmGPL.tvwResultCustomDrawGroupCell(Sender: TcxCustomGridTableView;
      ACanvas: TcxCanvas; AViewInfo: TcxGridTableCellViewInfo;
      var ADone: Boolean);
begin
//14.10.2020 Muss hier sein, sonst TbfaDBGridTableView.DoCustomDrawGroupCell wird nicht gettigt!
end;

procedure TfrmGPL.grdResultlistDevExCanFocusRecord(Sender: TcxCustomGridTableView;
    ARecord: TcxCustomGridRecord; var AAllow: Boolean);
begin
  try
    // bfacrm:ticket__show__30743
    if AAllow then
      AAllow := bitfarmApp.AllowedToLeaveCurrentDocs(AAllow);

    //26.07.2022 Ticket 31661/3 -->
    if AAllow then
    begin
      if (bitfarmApp.CurrentContainer.Count > 0) and (bitfarmApp.CurrentContainer[0].ID > -1) and
         //11.01.2023(
         (bitfarmApp.CurrentContainer[0].InEditMode)
         {11.01.2023 hier gibt es noch keinen modified, die werden erst im DoSave gesetzt, aber davor darf keine Zeile gewechselt werden
         and
         ((bitfarmApp.CurrentContainer[0].modified or bitfarmApp.CurrentContainer[0].Modified_Preview or
          bitfarmApp.CurrentContainer[0].Modified_Annos or bitfarmApp.CurrentContainer[0].Modified_AnnosDelete) //gendert
         or
         (GetKeyState(VK_SHIFT) < 0)) //oder SHIFT gedrckt muss erst gespeichert werden}
         and not bitfarmApp.RefreshGridInProcess //11.01.2023
      then
      begin
        AAllow := False;
        var msg := _('Sie haben nderungen am Dokument vorgenommen.\nBitte zuerst speichern oder abbrechen');
        BfMessageBox(msg, _('Hinweis'), 0);
      end;
    end;
    //26.07.2022 Ticket 31661/3 <--
  except
    AAllow := True;
    bitfarmLog.Write(llNormal, ltException, 'grdResultlistDevExCanFocusRecord', ClassName);
  end;
end;

procedure TfrmGPL.grdResultListSelectionChanged(Sender: TcxCustomGridTableView);
begin
  bitfarmApp.Log.DebugBegin(llDebug, 'grdResultListSelectionChanged', ClassName);
  try
    try
      DoResultlistChange(nil);
    except
      bitfarmApp.Log.Write(llNormal, ltException, 'grdResultListSelectionChanged', ClassName);
    end;
  finally
    bitfarmApp.Log.DebugEnd(llDebug, 'grdResultListSelectionChanged', ClassName);
  end
end;

procedure TfrmGPL.SetGridDBTableViewSettings(grdDBTableView: TbfaGridDBTableView);
begin
  with grdDBTableView do
  begin
    FilterRow.Visible := False;
    OptionsView.GroupByBox := False;

    OptionsCustomize.ColumnsQuickCustomization := False;
    OptionsCustomize.ColumnsQuickCustomizationShowCommands := False;

    OptionsCustomize.GroupBySorting := False;
    OptionsView.FooterMultiSummaries := True;
    OptionsData.Appending := False;
    OptionsData.CancelOnExit := False;
    OptionsData.Deleting := False;
    OptionsData.DeletingConfirmation := False;
    OptionsData.Editing := False;
    OptionsData.Inserting := False;
    OptionsSelection.MultiSelect:= True;
    OptionsSelection.CellSelect := False;
    OptionsSelection.InvertSelect := True;
    OptionsSelection.UnselectFocusedRecordOnExit := False;
    OptionsView.FocusRect := False;
    OptionsView.NoDataToDisplayInfoText := '';
    OptionsView.GroupFooters := gfInvisible;
    Navigator.Visible := True;
    Navigator.InfoPanel.DisplayMask := '[RecordIndex] / [RecordCount]';
    Navigator.InfoPanel.Visible := True;
    Navigator.Buttons.First.Visible := False;
    Navigator.Buttons.PriorPage.Visible := False;
    Navigator.Buttons.Prior.Visible := False;
    Navigator.Buttons.Next.Visible := False;
    Navigator.Buttons.NextPage.Visible := False;
    Navigator.Buttons.Last.Visible := False;
    Navigator.Buttons.Insert.Visible := False;
    Navigator.Buttons.Append.Visible := False;
    Navigator.Buttons.Delete.Visible := False;
    Navigator.Buttons.Edit.Visible := False;
    Navigator.Buttons.Post.Visible := False;
    Navigator.Buttons.Cancel.Visible := False;
    Navigator.Buttons.Refresh.Visible := False;
    Navigator.Buttons.SaveBookmark.Visible := False;
    Navigator.Buttons.GotoBookmark.Visible := False;
    Navigator.Buttons.Filter.Visible := False;

  end;
end;

procedure TfrmGPL.ChangeTheSelectedLanguage(Sender: TObject);
var
  UserAction: PUserAction;
begin
  try
    bitfarmApp.Lang := bitfarmApp.GetLangNativeNameById(TSpTBXItem(Sender).Tag);

    bitfarmLog.Write(llDebug, ltInfo, 'bitfarmApp.Lang: ' + bitfarmApp.Lang, ClassName);

    UserAction := bitfarmApp.CreateUserAction;
    UserAction^.ActionName := 'actLanguageXX';
    UserAction^.Params.Add(bitfarmApp.Lang);
    bitfarmApp.MainThread.Add(UserAction);
  except

  end;
end;

// Es wird dynamisch ein neues Untermen erstellt
// um zur Laufzeit die Sprache wechseln zu knnen.
procedure TfrmGPL.AddSubMenuLanguageXX;
  function GetIconIdx(lng: string): Integer;
  begin
    if lng = 'ar' then result := Integer(icoidx_flag_ar)
    else if lng = 'bg' then result := Integer(icoidx_flag_bg)
    else if lng = 'da' then result := Integer(icoidx_flag_da)
    else if lng = 'el' then result := Integer(icoidx_flag_el)
    else if lng = 'es' then result := Integer(icoidx_flag_es)
    else if lng = 'fi' then result := Integer(icoidx_flag_fi)
    else if lng = 'fr' then result := Integer(icoidx_flag_fr)
    else if lng = 'hi' then result := Integer(icoidx_flag_hi)
    else if lng = 'hu' then result := Integer(icoidx_flag_hu)
    else if lng = 'it' then result := Integer(icoidx_flag_it)
    else if lng = 'ja' then result := Integer(icoidx_flag_ja)
    else if lng = 'nb' then result := Integer(icoidx_flag_nb)
    else if lng = 'nl' then result := Integer(icoidx_flag_nl)
    else if lng = 'pl' then result := Integer(icoidx_flag_pl)
    else if lng = 'pt' then result := Integer(icoidx_flag_pt)
    else if lng = 'ro' then result := Integer(icoidx_flag_ro)
    else if lng = 'sk' then result := Integer(icoidx_flag_sk)
    else if lng = 'sv' then result := Integer(icoidx_flag_sv)
    else if lng = 'tr' then result := Integer(icoidx_flag_tr)
    else if lng = 'uk' then result := Integer(icoidx_flag_uk)
    else if lng = 'zh' then result := Integer(icoidx_flag_zh)
    else
      result := -1;
  end;

var
  mniItem: TSpTBXItem;
  sCaption, lang: string;
  Folders: TStringDynArray;
begin
  try
    if DirectoryExists(BD.ExeDir + '\locale\') then
    begin
      Folders := TDirectory.GetDirectories(BD.ExeDir + '\locale\');
      if Length(Folders) > 0 then
      begin
        for var i := Low(Folders) to High(Folders) do
        begin
          lang := StringReplace(Folders[i], BD.ExeDir + '\locale\', '', [rfReplaceAll]);
          if (lang <> 'en') and (lang <> 'de') then
          begin
            sCaption := bitfarmApp.GetLangNativeName(lang);
            if sCaption = '' then
              Continue;

            mniItem := TSpTBXItem.Create(tbsubLanguages);
            mniItem.Caption := sCaption;
            mniItem.Images := bfaIcons.imlLanguage;
            mniItem.ImageIndex := GetIconIdx(lang);
            mniItem.Tag := bitfarmApp.GetIdNativeName(lang);
            mniItem.OnClick := ChangeTheSelectedLanguage;
            mniItem.Enabled := True;
            mniItem.Checked := (lang = bitfarmApp.Lang);
            tbsubLanguages.Add(mniItem);
          end;
        end;
      end;
    end;

// 09.07.2024
//
//    if (bitfarmApp.Lang <> 'en') and (bitfarmApp.Lang <> 'de') then
//    begin
//      sCaption := bitfarmApp.GetLangNativeName(bitfarmApp.Lang);
//      if sCaption = '' then
//        Exit;
//
//      actLanguage.Caption := sCaption;
//      actLanguage.Tag := bitfarmApp.GetIdNativeName(bitfarmApp.Lang);
//      mniItem := TSpTBXItem.Create(tbsubLanguages);
//      mniItem.Action := actLanguage;
//      tbsubLanguages.Add(mniItem);
//      actLanguage.Enabled := True;
//      mniItem.Enabled := True;
//    end;
  finally
    //09.07.2024
  end;
end;

constructor TfrmGPL.Create(AOwner: TComponent);
  procedure SetPopupFonts(popM  : TSpTBXPopupMenu);
  var
    i, j : Integer;
    subitem : TSpTBXSubmenuItem;
  begin
    for i := 0 to popM.Items.count - 1 do
    begin
      if (popM.Items[i] is TSpTBXSubmenuItem) then
      begin
        subitem := TSpTBXSubmenuItem(popM.Items[i]);
        subitem.FontSettings.Size := bfaFontSettingsSize;
        for j := 0 to subitem.Count - 1 do
        begin
          if (subitem.Items[j] is TSpTBXItem) then
            TSpTBXItem(subitem.Items[j]).FontSettings.Size := bfaFontSettingsSize;
        end;
      end
      else if (popM.Items[i] is TSpTBXItem) then
        TSpTBXItem(popM.Items[i]).FontSettings.Size := bfaFontSettingsSize;
    end;
  end;

var
  i, iPos, Cnt: Integer;
  addfield: TBfaAddfieldComp;
  mitem: TSpTBXItem;
  Ini: Tinifile;
  ls, lsPar, lsParL, lsParCom, lsParVal, lsLangPath, CurrentLayout,
  LayoutName, inistr, Path: string;

  EdtTabOrder: Integer;
  Item: TbfaPreviewContainerItem;
  reg: TRegistry;
  FilePath: string;
  CreateReg: Boolean;
  pAdapterInfo: PIP_ADAPTER_INFO; // Linked list of adapters
  pAdapter: PIP_ADAPTER_INFO; // Single adapter
  BufLen: DWORD;
  Status: DWORD;
  ipadress: string;
begin
  {$IFNDEF ENTERPRISE}
  bfaIcons := TbfaIcons.Create(AOwner);
  bitfarmApp := TbfaApplication.Create;

  for i := 1 to ParamCount do
  begin
    lsPar := ParamStr(i);
    ls := inttostr(i);
    lsParL := lowercase(lsPar);
    iPos := Pos(':', lsParL);
    if iPos = 0 then
      iPos := maxint - 1;
    lsParCom := Copy(lsParL, 1, iPos - 1); // das vor dem Doppelpunkt (oder alles wenn keiner)
    lsParVal := Copy(lsParL, iPos + 1, maxint); // das vor nach Doppelpunkt (oder nix wenn keiner)
    if lsParL = '-debug' then
    begin
      BD.LogOn := true;
      Continue;
    end;
    if lsPar = '-devdebug' then
    begin
      BD.DevDebug := True;
      bitfarmLog.ChangeLogLevel(llDebug); //02.04.2024
      Continue;
    end;
    if lsPar = '-setduplex' then
    begin
      BD.SetDuplex := True;
      Continue;
    end;
    if lsPar = '-debugMySQL' then
    begin
      Continue;
    end;
    if lsParCom = '-lang' then   //z.B. "-lang:en"
    begin
      bitfarmApp.Lang := lsParVal;
      Continue;
    end;
    if lsParCom = '-langpath' then   //z.B. "-langpath:"
    begin
      lsLangPath := lsParVal;
      Continue;
    end;
  end;

  // Falls spezifisches Spachverzeichnis(..\locale) nicht vorhanden, setze Englisch
  if bitfarmApp.Lang <> 'de' then
  begin
    Path := IncludeTrailingPathDelimiter(BD.ExeDir + 'locale\' + bitfarmApp.Lang);
    if not Directoryexists(Path) then
      bitfarmApp.Lang := 'en'
  end;

  //13.06.2019 Ticket 19510 -->
    if not DirectoryExists(BD.AppdataBitfarmPd) then
      ForceDirectories(BD.AppdataBitfarmPd);
  //13.06.2019 Ticket 19510 <--

  frmLogin := CreateLoginForm;
  //if bitfarmApp.ViewerOptions.GeneralOptions.MsLogon then
    //TfrmLoginGPL(frmLogin).TryLoginAsCurrentWindowsUser
  //else
    frmLogin.ShowModal;

  if (frmLogin.ModalResult <> mrOk) or (not SingleInst.CanStartApp) then
  begin
    bitfarmApp.Free;
    ExitOnLogin;
    Exit;
  end
  else
  begin
    FDefaultLayout := (TfrmLoginGPL(frmLogin).cbx_login_optionen.ItemIndex = 2);

    bitfarmApp.GPL;
    frmOptions := TfrmOptions.Create(Application);

    frmOptions.tbScanProfiles.Images := bfaIcons.ilMainMenu;
    frmOptions.aclOptionsForm.Images := bfaIcons.ilMainMenu;
    frmOptions.cbxScanProfile.Properties.Images := bfaIcons.ilMainMenu;
    frmOptions.cbxScanProfile.Style.StyleController := ctlGeneral;

//    fraScanFunctions := TfraScanFunctions.Create(Self);
//    fraScanFunctions.Parent := SpTBXPanel5;
//    fraScanFunctions.Align := alTop;
//    fraScanFunctions.Visible := False;
//    fraScanFunctions.cbxScanProfile.Properties.OnChange := cbxScanProfileChange;
////    btnIndexing.OnClick := btnIndexingClick;
//    fraScanFunctions.btnScan.Images := bfaIcons.ilMainMenu32;
//    fraScanFunctions.btnScanDialog.Images := bfaIcons.ilMainMenu32;
//    fraScanFunctions.btnLoadFile.Images := bfaIcons.ilMainMenu32;
//    fraScanFunctions.btnSaveFile.Images := bfaIcons.ilMainMenu32;
//    fraScanFunctions.btnDeleteSelected.Images := bfaIcons.ilMainMenu32;
//    fraScanFunctions.btnArchive.Images := bfaIcons.ilScanIcons;
//    fraScanFunctions.btnReset.Images := bfaIcons.ilScanIcons;
//    fraScanFunctions.cbxScanProfile.Style.StyleController := ctlGeneral;
//    fraScanFunctions.btnScanProfilOptions.Images := bfaIcons.ilScanIcons;
//    fraScanFunctions.chkImportOCR.Checked := not bitfarmApp.ViewerOptions.GeneralOptions.NoOCR;
//    fraScanFunctions.chkColor.Checked := bitfarmApp.ViewerOptions.GeneralOptions.Importcolor;
//    fraScanFunctions.chkHiRes.Checked := bitfarmApp.ViewerOptions.GeneralOptions.ImportHighRes;
//    //fraScanFunctions.chkBarcodemerge.Checked := bitfarmApp.ViewerOptions.GeneralOptions.ImportBarcode;
//    fraScanFunctions.chkPrintAfterArchive.Checked := bitfarmApp.ViewerOptions.GeneralOptions.PrintAfterArchiving; // Ticket 14649
//    fraScanFunctions.cbxScanProfile.Properties.Images := bfaIcons.ilMainMenu;
  end;
  {$ENDIF}

  inherited Create(AOwner);

  bitfarmApp.SetInisProfile;
  EmptyKeyQueue; //27.09.2017 Ticket 12011
  bitfarmLog.DebugBegin(llDebug, 'TbfaScannerProfiles.Create(' + sSysScannerProfilesINI + ')', ClassName);
  try
    bitfarmApp.ScannerProfiles := TbfaScannerProfiles.Create(sSysScannerProfilesINI);
  finally
    bitfarmLog.DebugEnd(llDebug, 'TbfaScannerProfiles.Create(' + sSysScannerProfilesINI + ')', ClassName);
  end;

  if ((bitfarmApp.User.Flags and 32) = 32) then
    bitfarmApp.ChangePassword(nil);


  try
    gnugettext.TP_Ignore(frmMainForm.tabSearchAddfields2, 'Caption');
    gnugettext.TP_GlobalIgnoreClass(TJvAppIniFileStorage); //10.07.2024

//09.10.2024 ??????    WindowState := wsNormal;
    SmartTextToDateFunc := ConvertEditText;
    FGridColumnMouseDown := False;
    frmMovedoc := nil;

    RoundedCorners := rcOn; //03.06.2022 Win11

    ctlGeneral := TcxEditStyleController.Create(Self);
    ctlGeneral.Style.LookAndFeel.NativeStyle := False;
    ctlModified := TcxEditStyleController.Create(Self);
    ctlModified.Style.LookAndFeel.NativeStyle := False;
    ctlRequired := TcxEditStyleController.Create(Self);
    ctlRequired.Style.LookAndFeel.NativeStyle := False;
    ctlDisabled := TcxEditStyleController.Create(Self);
    ctlDisabled.Style.LookAndFeel.NativeStyle := False;
    ctlRedBackground := TcxEditStyleController.Create(Self);
    ctlRedBackground.Style.LookAndFeel.NativeStyle := False;
    ctlGeneralSearch := TcxEditStyleController.Create(Self);
    ctlGeneralSearch.Style.LookAndFeel.NativeStyle := False;
    ctlGeneralTextHighlighted := TcxEditStyleController.Create(Self);
    ctlGeneralTextHighlighted.Style.LookAndFeel.NativeStyle := False;
    ctlModifiedTextHighlighted := TcxEditStyleController.Create(Self);
    ctlModifiedTextHighlighted.Style.LookAndFeel.NativeStyle := False;
    ctlRequiredTextHighlighted := TcxEditStyleController.Create(Self);
    ctlRequiredTextHighlighted.Style.LookAndFeel.NativeStyle := False;
    ctlDisabledTextHighlighted := TcxEditStyleController.Create(Self);
    ctlDisabledTextHighlighted.Style.LookAndFeel.NativeStyle := False;
    ctlWhite := TcxEditStyleController.Create(Self);
    ctlWhite.Style.LookAndFeel.NativeStyle := False;
    stlControl := TcxStyle.Create(Self);
    stlControlNoRight := TcxStyle.Create(Self);
    stlControlRequired := TcxStyle.Create(Self);
    stlControlModified := TcxStyle.Create(Self);
    stlColumn := TcxStyle.Create(Self);
    stlColumn.Font.Name := 'Arial';
    stlUrgent := TcxStyle.Create(Self);
    stlUrgentSelected := TcxStyle.Create(Self);
    stlWork := TcxStyle.Create(Self);
    stlWorkSelected := TcxStyle.Create(Self);
    stlDone := TcxStyle.Create(Self);
    stlDoneSelected := TcxStyle.Create(Self);
    stlFree := TcxStyle.Create(Self);
    stlSelected := TcxStyle.Create(Self);
    stlProgress := TcxStyle.Create(Self);
    stlProgressSelected := TcxStyle.Create(Self);
    stlGroupByBoxStyle := TcxStyle.Create(Self);
    stlBackgroundStyle := TcxStyle.Create(Self);
    stlTreeview := TcxStyle.Create(Self);
    stlTreeViewSelected := TcxStyle.Create(Self);
    stlImageEn := TcxStyle.Create(Self);
    stlImageEnSelected := TcxStyle.Create(Self);

//    {$IFDEF DEVEXSKIN}
//    dxSkinController1 := TdxSkinController.Create(Self);
//    dxSkinController1.NativeStyle := True;
//    dxSkinController1.SkinName := '';
//    dxSkinController1.UseSkins := False;
//    {$ENDIF}


    JvAppIniFileStorage1.FileName := BD.AppdataBitfarmPd + 'ViewerLayout.ini';
    JvAppIniFileStorage1.Location := JvAppStorage.flCustom;
    JvAppIniFileStorage1.AutoReload := True; // bfacrm:ticket__show__32573
    JvAppIniFileStorage1.AutoFlush := True; // bfacrm:ticket__show__32573


    actList := TActionList.Create(Self);
    actListPreview := TActionList.Create(Self);
    CreateActions(actList, actListPreview);

    FillDevExImageLists(bfaIcons.imlLanguage, '');
    FillImageLists(bfaIcons.imcMain, '');
    bfaIcons.ilMainMenu.ImageCollection := bfaIcons.imcMain;
    bfaIcons.ilMainMenu16.ImageCollection := bfaIcons.imcMain;
    bfaIcons.ilMainMenu32.ImageCollection := bfaIcons.imcMain;
    FillImageLists(bfaIcons.imcPreview, '');
    bfaIcons.ilPreview.ImageCollection := bfaIcons.imcPreview;
    bfaIcons.ilPreview16.ImageCollection := bfaIcons.imcPreview;
    bfaIcons.ilPreview32.ImageCollection := bfaIcons.imcPreview;

    mnuSendTo.ImageIndex := Integer(icoidx_send_to);
    mnuBookmarks.ImageIndex := Integer(icoidx_bookmark_selected);
    mnuPlugins.ImageIndex := Integer(icoidx_plugin);
    mnuTreeviewTools.Imageindex := Integer(icoidx_tree_tools);
    mnuDeleteDoc.ImageIndex := Integer(icoidx_delete_nrs);

    tlbDocState.Images := bfaIcons.ilMainMenu;
    tlbStatefields.Images := bfaIcons.ilMainMenu;
    tlbStatefields.DisplayMode := tbdmSelectiveCaption;
    btnSearchOption1.Height := 30;
    btnSearchOption2.Height := 30;
    btnSearchOption3.Height := 30;
    btnSearchOption4.Height := 30;
    SpTBXStatusBar1.Font.Size := bfaFontSize;
    SpTBXLabelItem1.FontSettings.Size := bfaFontSettingsSize;
    itmUserName.FontSettings.Size := bfaFontSettingsSize;
    SpTBXLabelItem6.FontSettings.Size := bfaFontSettingsSize;
    itmProfile.FontSettings.Size := bfaFontSettingsSize;
    SpTBXLabelItem2.FontSettings.Size := bfaFontSettingsSize;
    itmServerName.FontSettings.Size := bfaFontSettingsSize;
    SpTBXLabelItem5.FontSettings.Size := bfaFontSettingsSize;
    itmDBName.FontSettings.Size := bfaFontSettingsSize;
    itm2.FontSettings.Size := bfaFontSettingsSize;
    itmID.FontSettings.Size := bfaFontSettingsSize;
    SpTBXLabelItem4.FontSettings.Size := bfaFontSettingsSize;
    itmInfo.FontSettings.Size := bfaFontSettingsSize;
    itmNotification.FontSettings.Size := bfaFontSettingsSize;
    SetPopupFonts(ppmTools);
    SetPopupFonts(popMainMenu);
    SetPopupFonts(popLimit);
    SetPopupFonts(popSearchOption1);
    SetPopupFonts(popSearchOption2);
    SetPopupFonts(popSearchOption3);
    SetPopupFonts(popSearchOption4);
    SetPopupFonts(popResubFavs);
    SetPopupFonts(popFavTree);
    SetPopupFonts(popInEditmode);
    SetPopupFonts(popTreeView);
    SetPopupFonts(popDocLinks);
    SetPopupFonts(popAddFields);
    SetPopupFonts(popSVN1);
    SetPopupFonts(popInResub);
    SetPopupFonts(popLinksList);
    SetPopupFonts(popFilterBar);
    scrbxViewerAddfields.AutoScroll := True;
    scrbxViewerAddfields.VertScrollBar.Visible := True;
    scrbxViewerAddfields.VertScrollBar.Tracking := True;
    scrbxAddfields2.AutoScroll := True;
    scrbxAddfields2.VertScrollBar.Visible := True;
    scrbxAddfields2.VertScrollBar.Tracking := True;
    scrbxStandard.AutoScroll := True;
    scrbxStandard.VertScrollBar.Visible := True;
    scrbxStandard.VertScrollBar.Tracking := True;
    scrbxStandardImporter.AutoScroll := True;
    scrbxStandardImporter.VertScrollBar.Visible := True;
    scrbxStandardImporter.VertScrollBar.Tracking := True;
    {$IFDEF DEVEXSCROLLBOX}
    scrbxViewerAddfields.LookAndFeel.NativeStyle := True;
    scrbxViewerAddfields.LookAndFeel.ScrollbarMode := sbmClassic;
    scrbxAddfields2.LookAndFeel.NativeStyle := True;
    scrbxAddfields2.LookAndFeel.ScrollbarMode := sbmClassic;
    scrbxStandard.LookAndFeel.NativeStyle := True;
    scrbxStandard.LookAndFeel.ScrollbarMode := sbmClassic;
    scrbxStandardImporter.LookAndFeel.NativeStyle := True;
    scrbxStandardImporter.LookAndFeel.ScrollbarMode := sbmClassic;
    {$ENDIF}
    ShowFloatingResub := False;

    //08.04.2021 Ticket -->
    bitfarmApp.ppmCalloutBallon := TbfaCalloutPopup.Create(frmMainForm);
    bitfarmApp.CanPopupBallon := False;
    var bmp : Graphics.TBitmap;
    bmp := Graphics.TBitmap.Create;
    try
      bfaIcons.ilMainMenu.GetBitmap(Integer(icoidx_info), bmp);
      bitfarmApp.ppmCalloutBallon.CalloutFrame.Image1.Picture.Bitmap.Assign(bmp);
    finally
      FreeAndNil(bmp);
    end;
    //08.04.2021 Ticket <--

    FRelogin := False;
    FInside := False;
    fAppStarted := false;
    FInitialLoadImporterDone := false;
    FInitialLoadWorkplaceDone := false;

    frmSplash := TfrmSplash.Create(Self);
    frmSplash.lblLoading.Style.Font.Size := bfaFontSize; //10.09.2020
    frmSplash.lblLoading.Caption := sMsgLoadViewer;
    frmSplash.lblInfo.Style.Font.Size := bfaFontSize; //10.09.2020
    frmSplash.FormType := sftViewer;
    frmSplash.UseTimer := True;
    frmSplash.pgbDocuments.Style.LookAndFeel.NativeStyle := False;
    frmSplash.pgbDocuments.Properties.BeginColor := $000D66FD;
    frmSplash.pgbDocuments.Properties.BorderWidth := 4;
    frmSplash.pgbDocuments.Style.BorderColor := $00E5E5E5;
    frmSplash.pgbDocuments.Style.Color := $00E5E5E5;
    frmSplash.pgbBytes.Style.LookAndFeel.NativeStyle := False;
    frmSplash.pgbBytes.Properties.BeginColor := $000D66FD;
    frmSplash.pgbBytes.Properties.BorderWidth := 4;
    frmSplash.pgbBytes.Style.BorderColor := $00E5E5E5;
    frmSplash.pgbBytes.Style.Color := $00E5E5E5;
    //24.01.2023 Ticket 33576 -->
    frmSplash.FormStyle := fsNormal;
    frmSplash.PopupParent := Self;
    //24.01.2023 Ticket 33576 <--
    frmSplash.Show;

    FWindowsIsShuttingDown := False;

//12.02.2024    bitfarmApp.SetOptionsFormColor; //09.02.2024

      bfaTlbStandard1.Font.Size := bfaFontSize;
      bfaTlbPreview1.Font.Size := bfaFontSize;

      frmResubDialog := TfrmResubDialog.Create(Self); // GP: Parameter Self (statt Applikation), sonst werden nicht alle Komponenten bersetzt

      fraImporter := TfraImporter.Create(Self);
      fraImporter.Parent := pnlImporter;
      fraImporter.Align := alClient;

      fraWorkplace := TfraWorkplace.Create(Self);
      fraWorkplace.Parent := pnlWorkspace;
      fraWorkplace.Align := alClient;

      fraResub := TfraResub.Create(Self);
      fraResub.Parent := pnlResubmission;
      fraResub.Align := alClient;

      fraResub.cxDateNavigator1 := TcxDateNavigator.Create(Self);
      with fraResub.cxDateNavigator1 do
      begin
        Parent := fraResub.ResubScrollBox;
        Left := 3;
        Top := fraResub.btnShowCW.Top + fraResub.btnShowCW.Height + 6;
        Width := 228;
        Height := 160;
        Anchors := [akLeft, akTop, akRight];
        TabStop := False; // s.jansen 24.08.2020
        OnClick := fraResub.cxDateNavigator1Click;
        OnCustomDrawDayNumber := fraResub.cxDateNavigator1CustomDrawDayNumber;
        OnPeriodChanged := fraResub.cxDateNavigator1PeriodChanged;
      end;
      fraResub.lblCW.Top:= fraResub.cxDateNavigator1.Top +
        fraResub.cxDateNavigator1.Height + 20;
//27.02.2024      fraResub.cxDateNavigator1.Styles.Background := stlBackgroundStyle;
      fraResub.cxDateNavigator1.Styles.Background := stlControl;
      fraResub.cxDateNavigator1.Styles.Content := stlFree;
      fraResub.cxDateNavigator1.Styles.Header := stlColumn;
      fraResub.cxDateNavigator1.Styles.Selection := stlSelected;

      fraResub.btnResubForward.PopupMenu := popResubFavs;
      fraResub.popDelegate.Items[0].Checked := True;
      fraResub.popMyTasks.Items[0].Checked := True;
      fraResub.btnSaveResub.OnClick := bitfarmApp.btnSaveResubClick;
      fraResub.btnResubForward.OnClick := bitfarmApp.btnresubForwardClick;
      fraResub.btnResubDone.OnClick := bitfarmApp.btnResubDoneClick;
      fraResub.btnResubCancel.OnClick := bitfarmApp.btnResubCancelClick;
      fraResub.cxDateEdit1.Style.StyleController := ctlGeneral;
      // SJ 06.10.2021 - ikRegExpr deaktiviert SmartInput (Today, Yesterday, Sunday, ...)
      fraResub.cxDateEdit1.Properties.InputKind := ikRegExpr;
      fraResub.cxDateEdit1.Properties.EditFormat := FormatSettings.ShortDateFormat;

      fraImporterResub := TfraCreateImporterResub.Create(Self);
      fraImporterResub.Parent := grbImporterResub;//14.03.2017 pnlImporterResub;
      fraImporterResub.SpTBXPanel1.Borders := False;
      fraImporterResub.Align := alClient;
      fraImporterResub.dtDate1.Date := Date();
      fraImporterResub.dtDate1.Enabled := True;
      fraImporterResub.btnOk.Enabled := False;
      fraImporterResub.btnCancel.Enabled := False;
      fraImporterResub.btnOk.Visible := False;
      fraImporterResub.btnCancel.Visible := False;

      fraImporterResub.dtDate1.Style.StyleController := ctlGeneral;

      // SJ 26.11.2020
      // Eingabefelder gegen TokenEdit von DevEx ausgetauscht
      lblDocNameImporter.Transparent := True;
      lblDocLinksImporter.Transparent := True;
      lblDocTagsImporter.Transparent := True;
      tokenDocTags.Style.StyleController := ctlGeneral;
      tokenDocLinks.Style.StyleController := ctlGeneral;
      // SJ 26.11.2020

//06.12.2018 Im Importer bei Enter sollte archivieren ausgefhrt -->
      edtDocName.OnKeyDown := bitfarmApp.ImporterFieldsKeyDown;
      edtDocName.Properties.OnChange := bitfarmApp.ImporterFieldsOnChange;
      fraImporterResub.cbbFavorites.OnKeyDown := bitfarmApp.ImporterFieldsKeyDown;
      fraImporterResub.edtInfoCreate.OnKeyDown := bitfarmApp.ImporterFieldsKeyDown;
      fraImporterResub.edtInfoFoward.OnKeyDown := bitfarmApp.ImporterFieldsKeyDown;
      fraImporterResub.edtAlarm1.OnKeyDown := bitfarmApp.ImporterFieldsKeyDown;
      fraImporterResub.cbbUser.OnKeyDown := bitfarmApp.ImporterFieldsKeyDown;
      fraImporterResub.cbbGroup.OnKeyDown := bitfarmApp.ImporterFieldsKeyDown;
//06.12.2018 Im Importer bei Enter sollte archivieren ausgefhrt <--

      //09.02.2024 muss hier rein bfacrm:ticket__show__37742 -->
      {$IF CompilerVersion >= 35}
      edtDocName.Width := 175;
      tokenDocLinks.Width := 175;
      tokenDocTags.Width := 175;
      {$ENDIF}
      //09.02.2024 bfacrm:ticket__show__37742 <--

      scrbxStandardImporter.AutoScroll := True;
      scrbxStandardImporter.AfterScrollVert := frmMainForm.AfterScrollVert;
      scrbxStandardImporter.AfterScrollHorz := frmMainForm.AfterScrollHorz;
      scrbxStandardImporter.Update;

      {$IFNDEF ENTERPRISE}
      fraScanFunctions := TfraScanFunctions.Create(Self);
      fraScanFunctions.Parent := SpTBXPanel5;
      fraScanFunctions.Align := alTop;
      fraScanFunctions.Visible := False;
      fraScanFunctions.cbxScanProfile.Properties.OnChange := cbxScanProfileChange;
      fraScanFunctions.btnScan.Images := bfaIcons.ilMainMenu32;
      fraScanFunctions.btnScanDialog.Images := bfaIcons.ilMainMenu32;
      fraScanFunctions.btnLoadFile.Images := bfaIcons.ilMainMenu32;
      fraScanFunctions.btnSaveFile.Images := bfaIcons.ilMainMenu32;
      fraScanFunctions.btnDeleteSelected.Images := bfaIcons.ilMainMenu32;
      fraScanFunctions.btnArchive.Images := bfaIcons.ilScanIcons;
      fraScanFunctions.btnReset.Images := bfaIcons.ilScanIcons;
      fraScanFunctions.cbxScanProfile.Style.StyleController := ctlGeneral;
      fraScanFunctions.btnScanProfilOptions.Images := bfaIcons.ilScanIcons;
      fraScanFunctions.chkImportOCR.Checked := not bitfarmApp.ViewerOptions.GeneralOptions.NoOCR;
      fraScanFunctions.chkColor.Checked := bitfarmApp.ViewerOptions.GeneralOptions.Importcolor;
      fraScanFunctions.chkHiRes.Checked := bitfarmApp.ViewerOptions.GeneralOptions.ImportHighRes;
      //fraScanFunctions.chkBarcodemerge.Checked := bitfarmApp.ViewerOptions.GeneralOptions.ImportBarcode;
      fraScanFunctions.chkPrintAfterArchive.Checked := bitfarmApp.ViewerOptions.GeneralOptions.PrintAfterArchiving; // Ticket 14649
      fraScanFunctions.cbxScanProfile.Properties.Images := bfaIcons.ilMainMenu;
      {$ENDIF}


      popTreeView.Images := bfaIcons.ilMainMenu;
      popAddFields.Images := bfaIcons.ilMainMenu;

      itmCollapseAll.ImageIndex := Integer(icoidx_tree_reduce);
      itmExpandAll.ImageIndex := Integer(icoidx_tree_expand);
      itmRefresh.ImageIndex := Integer(icoidx_tree_reload);
      itmExport.ImageIndex := -1;
      itmExport.Visible := False;

      FViewerTreeview := TbfaTreeView.Create(Self);
      with FViewerTreeview do
      begin
        Parent := pnlTreeView;
        Name := 'ViewerTreeView';
        TabOrder := 0;
        Align := alClient;
        AutoScroll := True;
        ShowRoot := False; //17.09.2020
        BorderStyle := bsNone;
        Font.Size := bfaFontSize; //04.09.2020
        Images := bfaIcons.ilMainMenu;
        OnChange := TVChange;
        OnMouseDown := TVMouseDown;
        OnMouseUp := TVMouseUp;
        OnSelectionChanging := TVSelectionChanging;
        OnClick := TVClick;
        ViewKind := tvkViewer;
        Ininame := 'Viewer.ini';
        IniSectionName := bitfarmApp.TreeViewProfile;
        PopupMenu := popTreeView;
        OnCustomDrawItem := frmMainForm.TreeView1CustomDrawItem;
        OnMouseMove := frmMainForm.TreeMouseMove;
      end;

      FImporterTreeview := TbfaTreeView.Create(Self);
      with FImporterTreeview do
      begin
        Parent := fraImporter;
        Name := 'ImporterTreeView';
        TabOrder := 0;
        Align := alClient;
        BorderStyle := bsNone;
        Font.Size := bfaFontSize; //04.09.2020
        ShowRoot := False; //17.09.2020
        Images := bfaIcons.ilMainMenu;
        OnChange := TVChange;
        OnMouseUp := TVMouseUp;
        OnMouseDown := TVMouseDown;
        OnClick := TVClick;
        ViewKind := tvkImporter;
        Ininame := 'Viewer.ini';
        IniSectionName := bitfarmApp.TreeViewProfile;
        PopupMenu := popTreeView;
        OnCustomDrawItem := frmMainForm.TreeView1CustomDrawItem;
        OnMouseMove := frmMainForm.TreeMouseMove;
      end;


      Self.tlbMainMenu.Images := bfaIcons.ilMainMenu;
      Self.tlbMainMenu.Color := SpTBXDock1.Color;

//      CommonGUIUtils.InitActionList(Self as TfrmGPL);

      tbiCreateEmptyText.OnClick := EmptyDocItemClick;
      mnuCreateEmptyDocText.OnClick := EmptyDocItemClick;
      for i := 0 to bitfarmApp.emptydocs.Count -1 do
      begin
        //mitem := TSpTBXItem.Create(tbsubCreateEmptyDoc);
        //mitem.Caption := bitfarmApp.emptydocs[i];
        //mitem.OnClick := EmptyDocItemClick;
        //tbsubCreateEmptyDoc.Add(mitem);

        mitem := TSpTBXItem.Create(mnuCreateEmptyDoc);
        mitem.Caption := bitfarmApp.emptydocs[i];
        mitem.OnClick := EmptyDocItemClick;
        mnuCreateEmptyDoc.Add(mitem);
      end;
      tbsubCreateEmptyDoc.LinkSubItems := mnuCreateEmptyDoc;

      mGraphic.Control := tlbGraphic;
      mTools.Control := tlbTools;
      mPreview.Control := bfaTlbPreview1;
      mStandard.Control := bfaTlbStandard1;
      mQueueCount.Control := tlbQueueCount;
      mResubFavorites.Control := tlbResubFavs;

      popMainMenuGroupItem1.LinkSubitems := tbsubToolbars;
      popMainMenuGroupItem2.LinkSubitems := tbsubLayout;
      tbiLayoutSave.Action := actLayoutSave;
      tbiLayoutDelete.Action := actLayoutDelete;
      tbiLayoutStandard.Action := actLayoutStandard;

      if (bitfarmApp.GlobalViewerLayout <> '') then
        Inistr := bitfarmApp.GlobalViewerLayout
      else if (bitfarmApp.ViewerLayout <> '') then
        Inistr := bitfarmApp.ViewerLayout
      else
      begin
        if FileExists(ExtractFilePath(Application.ExeName) + 'layout.ini') then
          Inistr := ExtractFilePath(Application.ExeName) + 'layout.ini'
        else if FileExists(BD.AppdataBitfarmPd + 'layout.ini') then
          Inistr := BD.AppdataBitfarmPd + 'layout.ini';
      end;
      if (inistr <> '') then
      begin
        Ini := TInifile.Create(inistr);
//09.01.2020 <--
        try
          cnt := ini.ReadInteger('Layouts', 'Count', 0);
          if cnt > 0 then
          begin
            for i := 0 to cnt - 1 do
            begin
              CurrentLayout := Ini.ReadString('Layouts', IntToStr(i), '');
              if (CurrentLayout <> '') and (LowerCase(CurrentLayout) <> 'standard') then
              begin
                mitem := TSpTBXItem.Create(tbsubLayout);
                mitem.Caption := CurrentLayout;
                mitem.OnClick := LayoutsItemClick;
                tbsubLayout.Add(mitem);
              end;
            end;
          end;
        finally
          FreeAndNil(ini);
        end;
      end;

      bfaTlbStandard1.CreateComponents;
      bfaTlbStandard1.Images := bfaIcons.ilMainMenu;
//      bfaTlbStandard1.tlbStandardSave.Action := actSave;
//      bfaTlbStandard1.tlbStandardCancel.Action := actCancel;
      bfaTlbStandard1.tlbStandardTreeView.Action := actViewNavigation;
      bfaTlbStandard1.tlbStandardSearchOptions.Action := actViewSearchOptions;
      bfaTlbStandard1.tlbStandardThumbnail.Action := actViewThumbnails;
      bfaTlbStandard1.tlbStandardFloatingWVL.Action := actViewFloatingWVL;
      bfaTlbStandard1.tlbStandardFloatingWVL.Images := bfaIcons.ilPreview;
      bfaTlbStandard1.tlbStandardFloatingWVL.ImageIndex := Integer(icoidx_resubmission_view);
      bfaTlbStandard1.tlbStandardRotateLeft.Action := actRotateLeft;
      bfaTlbStandard1.tlbStandardFlip.Action := actFlip;
      bfaTlbStandard1.tlbStandardRotateRight.Action := actRotateRight;
      bfaTlbStandard1.tlbStandardEditTags.Action := actEditTags;
      bfaTlbStandard1.tlbStandardAutoRef.Action := actAutoRef;
      bfaTlbStandard1.tlbStandardNewLink.Action := actNewLink;
      bfaTlbStandard1.tlbStandardAddLink.Action := actAddLink;
      bfaTlbStandard1.tlbStandardDeletePage.Action := actDeletePages;
      bfaTlbStandard1.tlbStandardSubmenuItemSave.Action := actLocalSaveOriginal;
      bfaTlbStandard1.tlbStandardSubmenuItemSave.ImageIndex := actLocalSaveOriginal.ImageIndex;
      bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action := actEmailPDFAttachment;
      bfaTlbStandard1.tlbStandardSubmenuItemEmail.ImageIndex := actEmailPDFAttachment.ImageIndex;
      bfaTlbStandard1.tlbStandardSubmenuItemPrint.Action := actPrintStandard;
      bfaTlbStandard1.tlbStandardSubmenuItemPrint.ImageIndex := actPrintStandard.ImageIndex;
      bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action := actCopyDocToClipboard;
      bfaTlbStandard1.tlbStandardSubmenuItemClipboard.ImageIndex := actCopyDocToClipboard.ImageIndex;

      TranslateToolbar(bfaTlbStandard1);

      mnuDocTools.ImageIndex := Integer(icoidx_edit_graphics);
      mnuExport.ImageIndex := Integer(icoidx_export_meta);
      mnuExportMeta.ImageIndex := Integer(icoidx_export_meta);
      mnuExportMeta_Main.ImageIndex := Integer(icoidx_export_meta);
      mnuResubCreate.LinkSubitems := popResubFavs.Items;
      mnuAddLink.LinkSubitems := popLinksList.Items;
      mnuAddLink.LinkSubitems := popLinksList.Items;
      mnuExportMeta.ImageIndex := Integer(icoidx_export_meta);
      mnuGraphicOptions.LinkSubitems := mnuGraphicOptions;
      mnuDocTools.LinkSubitems := mnuGraphic;

      bfaTlbPreview1.CreateComponents;
      bfaTlbPreview1.Images := bfaIcons.ilMainMenu;
      bfaTlbPreview1.mnuPreviousPage.Action := actPreviousPage;
      bfaTlbPreview1.mnuNextPage.Action := actNextPage;
      bfaTlbPreview1.mnuPublicAnno.Action := actPublicAnno;
      bfaTlbPreview1.mnuPrivateAnno.Action := actPrivateAnno;
      bfaTlbPreview1.mnuStationery.Action := actStationery;
      bfaTlbPreview1.mnuZoom100.Action := actZoom100;
      bfaTlbPreview1.mnuZoomPage.Action := actZoomPage;
      bfaTlbPreview1.mnuZoomWidth.Action := actZoomWidth;
      bfaTlbPreview1.mnuZoomHeight.Action := actZoomHeight;
      bfaTlbPreview1.mnuZoomSelect.Action := actZoomSelect;
      bfaTlbPreview1.mnuZoomOff.Action := actZoomOff;
      bfaTlbPreview1.cbxZoom.OnChange := bitfarmApp.ZoomComboChange;
      bfaTlbPreview1.mnuFtxPos.Action := actFtxPos;

      tlbPlugins.Font.Size := bfaFontSize;
      if tlbPlugins.Items.Count = 0 then
        tlbPlugins.Visible := False;
      if tlbStatefields.Items.Count = 0 then
        tlbStatefields.Visible := False;

      scrbxViewerAddfields.AutoScroll := True;
      scrbxViewerAddfields.AfterScrollVert := AfterScrollVert;
      scrbxViewerAddfields.AfterScrollHorz := AfterScrollHorz;

      scrbxAddfields2.AutoScroll := True;
      scrbxAddfields2.AfterScrollVert := AfterScrollVert;
      scrbxAddfields2.AfterScrollHorz := AfterScrollHorz;

    frm_Message := Tfrm_Message.Create(Application);
    frmListItems := TfrmListItems.Create(Application);
    frmLinkMails := TfrmLinkMails.Create(Application);
    frmLinkMails.bfsLinkMail.ImageList := TImageList(bfaIcons.ilMainMenu);
    bitfarmApp.DrawIcons(frmLinkMails.bfsLinkMail); //26.10.2022 Ticket 23647
    frmGridConfig := TfrmGridConfig.Create(Application);

    pnlFloatingResub := TSpTBXDockablePanel.Create(Self);
    with pnlFloatingResub do
    begin
      Visible := False;
      Parent := Self;
      Name := 'pnlFloatingResub';
      Caption := _('Wiedervorlage');
      DockableTo := [];
      DockMode := dmCanFloat;
      UseLastDock := False;
      Images := bfaIcons.ilMainMenu;
      Options.CaptionImageIndex := Integer(icoidx_clock);
      Options.TitleBarMaxSize := 30;
      OnClose := bitfarmApp.CloseFloatingResub;
      OnCanResize := bitfarmApp.CanResizeFloatingResub;
    end;

    popInResub.OnPopup := popInResubOnPopup;

    ReadColorscheme;

   //load stamps
    if fileexists(PChar(BD.ExeDir + 'signs\' + bitfarmApp.User.Name + '.tif')) then
    begin
      try
        reg := TRegistry.Create;
        try
          with reg do
          begin
             RootKey := HKEY_CURRENT_USER;
             OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + bitfarmApp.User.Name, True);
             WriteString('StampFile', BD.ExeDir + 'signs\' +
                bitfarmApp.User.Name + '.tif');
             WriteBool('StampTyp', True);
             if not ValueExists('StampName') then
                WriteString('StampName', 'Unterschrift von ' + bitfarmApp.User.Name);
             if not ValueExists('StampHeight') then
                WriteInteger('StampHeight', 30);
             if not ValueExists('StampWidth') then
                WriteInteger('StampWidth', 40);
             if not ValueExists('favnr') then
                WriteInteger('favnr', 1);
             CloseKey;
          end;
        except
          on e: Exception do
          begin
            //
          end;
        end;
      finally
        FreeAndNil(reg);
      end;
    end;

    bitfarmLog.Write(llNormal, ltInfo, 'Viewer startet version: ' + appversion, ClassName);

    GetAdaptersInfo(nil, BufLen);
    pAdapterInfo := AllocMem(BufLen);
    try
      Status := GetAdaptersInfo(pAdapterInfo, BufLen);

      if (Status <> ERROR_SUCCESS) then
      begin
        case Status of
          ERROR_NOT_SUPPORTED:
            bitfarmLog.Write(llNormal, ltInfo, 'GetAdaptersInfo is not supported by the operating system running on the local computer.', ClassName);
          ERROR_NO_DATA:
            bitfarmLog.Write(llNormal, ltInfo, 'No network adapter on the local computer.', ClassName);
        else
          bitfarmLog.Write(llNormal, ltInfo, 'GetAdaptersInfo failed with error #' + IntToStr(Status), ClassName);
        end;
      end else begin

        pAdapter := pAdapterInfo;

        while (pAdapter <> nil) do
        begin
          ipadress := pAdapter^.IpAddressList.IpAddress.S;
          if ipadress <> '0.0.0.0' then
          begin
            bitfarmLog.Write(llNormal, ltInfo, 'Network Adapter: ' + pAdapter^.Description, ClassName);
            bitfarmLog.Write(llNormal, ltInfo, 'IP address: ' + pAdapter^.IpAddressList.IpAddress.S, ClassName);
          end;
          pAdapter := pAdapter^.Next;
        end;
      end;
    finally
      FreeMem(pAdapterInfo);
    end;

    SingleInst.OnProcessParam := HandleParam;
    fpnlTreeviewWidth := 275;
    fpnlSearchWidth := 345;

    SpTBXMultiDock2.Width := fpnlSearchWidth;
    dckTreeView.Width := fpnlTreeviewWidth;
    pnlTreeView.Maximize;
    pnlImporter.Minimize;
    pnlFavorites.Minimize;
    pnlResubmission.Minimize;
    pnlWorkspace.Minimize;
    pnlAdmin.Minimize;

    FMouseDown := False;
    FMouseDownArea := Classes.Rect(Point(0, 0), Point(0, 0));

    FDblClick := False;

    EdtTabOrder := btnSearchOption1.TabOrder + 1;

    btnIndexing.OnClick := btnIndexingClick;

    if bitfarmApp.ViewerLayout <> '' then
      JvAppIniFileStorage1.FileName := bitfarmApp.ViewerLayout;

    edtSearchFTX := TBfaAddfieldComp.Create(Self, zfld00_Universal, '');
    with edtSearchFTX do
    begin
      Parent := scrbxStandard;
      {$IFDEF VERSION37}
      Left := (btnSearchOption1.Left * 2) + btnSearchOption1.Width;
      Top := btnSearchOption1.Top - 5;
      Width := scrbxStandard.Width - Left - 5;
      Height := ScaleValue(30);
      compEdit.Left := compEdit.Left - 10;
      compEdit.Top := compEdit.Top - 16;
      compEdit.Width := compEdit.Width - 105;
      tlbNeg.Top := ScaleValue(15);
      tlbNeg.Left := Width - 20;
      btnAdd.Left := compEdit.Left + compEdit.Width + 2;
      btnAdd.Top := compEdit.Top;
      btnAdd.Height := compEdit.Height;
      btnAdd.Width := btnAdd.Height;
      {$ELSE}
      Left := (btnSearchOption1.Left * 2) + btnSearchOption1.Width;
      Top := btnSearchOption1.Top + 2;
      Width := scrbxStandard.Width - Left - 5;
      compEdit.Left := compEdit.Left - 10;
      compEdit.Top := compEdit.Top - 16;
      {$IF CompilerVersion >= 35}
      compEdit.Width := compEdit.Width - 73;
      {$ELSE}
      compEdit.Width := compEdit.Width - 81;
      {$ENDIF}
      tlbNeg.Top := 5;
      tlbNeg.Left := Width - 16;
      {$IF CompilerVersion >= 35}
      btnAdd.Left := compEdit.Left + compEdit.Width - 25;
      {$ELSE}
      btnAdd.Left := compEdit.Left + compEdit.Width + 2;
      {$ENDIF}
      btnAdd.Top := compEdit.Top;
      btnAdd.Height := compEdit.Height;
      btnAdd.Width := btnAdd.Height;
      {$ENDIF}
      PopupMenu := popAddFields;
      Label1.Visible := False;
      compEdit.OnKeyDown := bitfarmApp.AddFieldKeyDown;
      compEdit.PopupMenu := popAddFields;
      AddButton := True;
      btnAdd.OnClick := btnAddClick;
      btnAdd.Hint := _('Das Schlagwort dem aktuellen Dokument zuordnen');
      TabOrder := EdtTabOrder;
      TbfaTextEdit(compEdit).Style.StyleController := ctlGeneral;
      TbfaTextEdit(compEdit).Style.StyleController := ctlGeneral;
    end;

    inc(EdtTabOrder);
    btnSearchOption2.TabOrder := EdtTabOrder;
    inc(EdtTabOrder);

    cbxSearchUser := TBfaAddfieldComp.Create(Self, zfld02_Auswahl, '');
    with cbxSearchUser do
    begin
      Parent := scrbxStandard;
      Left := (btnSearchOption2.Left * 2) + btnSearchOption2.Width;
      Top := btnSearchOption2.Top + 2;
      Width := scrbxStandard.Width - Left - 5;
      Label1.Visible := False;
      compComboBox.AutoComplete := not bitfarmApp.ViewerOptions.GeneralOptions.ComboAutoDown;
      compComboBox.AutoDropDown := bitfarmApp.ViewerOptions.GeneralOptions.ComboAutoDown;

      PopupMenu := popAddFields;
      compComboBox.Left := compComboBox.Left - 10;
      compComboBox.Top := compComboBox.Top - 16;
      compComboBox.Width := compComboBox.Width - 79;
      tlbNeg.Top := 5;
      tlbNeg.Left := Width - 20;
      compComboBox.OnKeyDown := bitfarmApp.AddFieldKeyDown;
      compComboBox.PopupMenu := popAddFields;
      compComboBox.Properties.OnInitPopup := frmMainForm.OnComboDropDown;
      compComboBox.Properties.OnCloseUp := frmMainForm.OnComboCloseUp;
      compComboBox.Style.StyleController := ctlGeneral;

      TabOrder := EdtTabOrder;
    end;

    inc(EdtTabOrder);
    btnSearchOption3.TabOrder := EdtTabOrder;
    inc(EdtTabOrder);

    dteSearch := TBfaAddfieldComp.Create(Self, zfld01_Datum, '');
    with dteSearch do
    begin
      Parent := scrbxStandard;
      Left := (btnSearchOption3.Left * 2) + btnSearchOption3.Width;    //91;
      Top := btnSearchOption3.Top + 2;
      Width := scrbxStandard.Width - Left - 5;
      Label1.Visible := False;
      Label2.Visible := False;
      PopupMenu := popAddFields;
      compDateLow.Left := compDateLow.Left - 10;
      compDateLow.Top := compDateLow.Top - 16;
      compDateLow.Width := compDateLow.Width - 9;
      compDateHigh.Left := compDateLow.Left + compDateLow.Width + 6;
      compDateHigh.Top := compDateHigh.Top - 16;
      compDateHigh.Width := compDateHigh.Width - 9;
      tlbNeg.Top :=  5;
      tlbNeg.Left :=  Width - 20;
//      OnResize := nil;
      TcxDateEdit(compDateLow).Style.StyleController := ctlGeneral;
      TcxDateEdit(compDateHigh).Style.StyleController := ctlGeneral;
      TcxDateEdit(compDateLow).OnKeyDown := bitfarmApp.AddFieldKeyDown;
      TcxDateEdit(compDateHigh).OnKeyDown := bitfarmApp.AddFieldKeyDown;
      TcxDateEdit(compDateLow).PopupMenu := popAddFields;
      TcxDateEdit(compDateHigh).PopupMenu := popAddFields;
      dteSearch.OnComboDropDown := frmMainForm.OnComboDropDown;
      dteSearch.OnComboCloseUp := frmMainForm.OnComboCloseUp;
      dteSearch.OnModified := bitfarmApp.OnModifiedDateField;
      TabOrder := EdtTabOrder;
    end;

    inc(EdtTabOrder);
    btnSearchOption4.TabOrder := EdtTabOrder;
    inc(EdtTabOrder);

    cbxSearchLinks := TBfaAddfieldComp.Create(Self, zfld02_Auswahl, '');
    with cbxSearchLinks do
    begin
      Parent := scrbxStandard;
      Left := (btnSearchOption4.Left * 2) + btnSearchOption4.Width;
      Top := btnSearchOption4.Top + 2;
      Width := scrbxStandard.Width - Left - 5;
      Label1.Visible := False;
      compComboBox.AutoComplete := not bitfarmApp.ViewerOptions.GeneralOptions.ComboAutoDown; //09.04.2018
      compComboBox.AutoDropDown := bitfarmApp.ViewerOptions.GeneralOptions.ComboAutoDown; //09.04.2018

      PopupMenu := popAddFields;
      compComboBox.Left := compComboBox.Left - 10;
      compComboBox.Top := compComboBox.Top - 16;
      compComboBox.Width := compComboBox.Width - 79;
      ForiginalEvent := compComboBox.Properties.OnChange;
      compComboBox.Properties.OnChange := cbxSearchLinksChange;
      compComboBox.Properties.OnPopup := frmMainForm.OnComboDropDown;
      compComboBox.Properties.OnCloseUp := frmMainForm.OnComboCloseUp;
      compComboBox.Style.StyleController := ctlGeneral;
      tlbNeg.Top := 5;
      tlbNeg.Left := Width - 20;
      compComboBox.OnKeyDown := bitfarmApp.AddFieldKeyDown;
      compComboBox.PopupMenu := popAddFields;
      TabOrder := EdtTabOrder;
    end;

    scrbxStandard.AutoScroll := True;
    scrbxStandard.AfterScrollVert := frmMainForm.AfterScrollVert;
    scrbxStandard.AfterScrollHorz := frmMainForm.AfterScrollHorz;
    scrbxStandard.Update;

    tstDocumentEditors.TabCloseButton := tcbNone;

    bitfarmApp.PreviewContainer.Owner := Self;
    bitfarmApp.PreviewContainer.Parent := dckDocumentEditors;
    bitfarmApp.PreviewContainer.Dock := dckDocumentEditors;
    bitfarmApp.PreviewContainer.TabSet := tstDocumentEditors;
    bitfarmApp.PreviewContainer.PreviewPanel := pnlPreview;
    bfaNotificationCenter := TNotificationCenter.Create(Self); //21.04.2020

    stlGroupByBoxStyle := TcxStyle.Create(Self);
    stlBackgroundStyle := TcxStyle.Create(Self);

    grdResultlistDevEx := TcxGrid.Create(Self);
    grdResultlistDevEx.Parent := SpTBXPanel5;
    grdResultlistDevEx.Align := alClient;
    grdResultlistDevEx.Name := 'grdResultlistDevEx';
    grdResultlistDevEx.LookAndFeel.ScrollbarMode := sbmClassic;
//10.11.2021    grdResultlistDevEx.LookAndFeel.NativeStyle := False;
    grdResultlistDevEx.LookAndFeel.NativeStyle := True;
    grdResultlistDevExLevel := grdResultlistDevEx.Levels.Add;
    grdResultlistDevExLevel.Name := 'grdResultlistDevEx_LevelName';
    grdResultlistDevExView := grdResultlistDevEx.CreateView(TbfaGridDBTableView) as TbfaGridDBTableView;
    grdResultlistDevExView.Name := 'grdResultlistDevEx_ViewName';
    grdResultlistDevExView.Grd := grdResultlistDevEx;
    grdResultlistDevExView.OnCanFocusRecord := grdResultlistDevExCanFocusRecord;

    grdResultlistDevExLevel.GridView := grdResultlistDevExView;
    grdResultlistDevEx.Width := 500;
    grdResultlistDevEx.PopupMenu := ppmTools;
    cxGridPopupMenu1.Grid := grdResultlistDevEx;
    grdResultlistDevExView.Styles.Header := stlColumn;
    grdResultlistDevExView.Styles.Footer := stlColumn;
    grdResultlistDevExView.Styles.GroupByBox := stlGroupByBoxStyle;
    grdResultlistDevExView.Styles.Navigator := stlGroupByBoxStyle;
    grdResultlistDevExView.Styles.NavigatorInfoPanel := stlGroupByBoxStyle;
    grdResultlistDevExView.Styles.Background := stlBackgroundStyle;
    grdResultlistDevExView.Styles.Group := stlColumn;
    grdResultlistDevExView.RowColorEvenOdd := bitfarmApp.ViewerOptions.GeneralOptions.RowColorEvenOdd;
    grdResultlistDevExView.ImageList := TImageList(bfaIcons.ilMainMenu);
    SetGridDBTableViewSettings(grdResultlistDevExView);
    grdResultlistDevExView.ChangeDelay := 250;
    grdResultlistDevExView.OnSelectionChanged := grdResultListSelectionChanged;
    grdResultlistDevExView.OnFocusedRecordChanged := FocusedRecordChanged; //30.03.2022
    grdResultlistDevExView.OnCustomDrawCell := tvwResultCustomDrawCell;
    grdResultlistDevExView.OnCustomDrawGroupCell := tvwResultCustomDrawGroupCell;
    grdResultlistDevExView.OnMouseDown := grdResultlistMouseDown;
    grdResultlistDevExView.OnMouseUp := grdResultlistMouseUp;
    grdResultlistDevExView.OnMouseMove := grdResultlistMouseMove;
    grdResultlistDevExView.OnColumnSizeChanged := GridColumnSizeChanged;
    grdResultlistDevExView.OnColumnPosChanged := GridColumnPosChanged;
    grdResultlistDevExView.OnDblClick := grdResultlistDblClick;
    grdResultlistDevExView.OnCustomDrawFooterCell := FooterCustomDrawFooterCell;
    grdResultlistDevExView.DataController.OnSortingChanged := GridColumnSortingChanged;
    grdResultlistDevExView.OnDeselect := grdOnDeselect;

    // hier wurden alle frmMainForm durch Self ersetzt
    tbiColumnCustomization := TSpTBXItem.Create(Self.popFilterBar);
//    tbiColumnCustomization := TSpTBXItem.Create(frmMainForm.popFilterBar);
    tbiColumnCustomization.Caption := _('Spalten ein/ausblenden');
    tbiColumnCustomization.FontSettings.Size := bfaFontSettingsSize;
    tbiColumnCustomization.Enabled := True;
    tbiColumnCustomization.Visible := True;
    tbiColumnCustomization.OnClick := OnColumnCustomizationClick;
    Self.popFilterBar.Items.Add(tbiColumnCustomization);

    tbiGroupByBox := TSpTBXItem.Create(Self.popFilterBar);
    //25.01.2023 bfacrm:ticket__show__33648 tbiGroupByBox.Caption := _('Sortierleiste');
    tbiGroupByBox.Caption := _('Gruppierleiste');
    tbiGroupByBox.FontSettings.Size := bfaFontSettingsSize;
    tbiGroupByBox.Enabled := True;
    tbiGroupByBox.Visible := True;
    tbiGroupByBox.OnClick := OnClickGroupping;
    Self.popFilterBar.Items.Add(tbiGroupByBox);

    tbiFooterBox := TSpTBXItem.Create(Self.popFilterBar);
    tbiFooterBox.Caption := _('Fuzeile');
    tbiFooterBox.FontSettings.Size := bfaFontSettingsSize;
    tbiFooterBox.Enabled := True;
    tbiFooterBox.Visible := True;
    tbiFooterBox.OnClick := OnClickFooter;
    Self.popFilterBar.Items.Add(tbiFooterBox);

    tbiPrinter := TSpTBXItem.Create(Self.popFilterBar);
    tbiPrinter.Caption := _('Report');
    tbiPrinter.FontSettings.Size := bfaFontSettingsSize;
    tbiPrinter.Enabled := True;
    tbiPrinter.Visible := True;
    tbiPrinter.OnClick := OnClickPrinter;
    Self.popFilterBar.Items.Add(tbiPrinter);

    tbiDeleteColumnOrder := TSpTBXItem.Create(Self.popFilterBar);
    tbiDeleteColumnOrder.FontSettings.Size := bfaFontSettingsSize;
    tbiDeleteColumnOrder.Enabled := True;
    tbiDeleteColumnOrder.Visible := True;
    tbiDeleteColumnOrder.Action := actDeleteColumnOrder;
    Self.popFilterBar.Items.Add(tbiDeleteColumnOrder);

    tbiFloatingResub := TSpTBXItem.Create(Self.ppmTools);
    tbiFloatingResub.Caption := _('Wiedervorlage in eigenem Fenster');
    tbiFloatingResub.FontSettings.Size := bfaFontSettingsSize;
    tbiFloatingResub.Enabled := True;
    tbiFloatingResub.Visible := True;
    tbiFloatingResub.Images := bfaIcons.ilPreview;
    tbiFloatingResub.ImageIndex := Integer(icoidx_resubmission_view);
    tbiFloatingResub.OnClick := bitfarmApp.EnableFloatingResub;
    Self.ppmTools.Items.Add(tbiFloatingResub);

    stlUrgent.Color := gclUrgent;
    stlUrgent.TextColor := gclUrgentText;
    stlUrgentSelected.Color := gclUrgentSelected;
    stlUrgentSelected.TextColor := gclUrgentSelectedText;
    stlWork.Color := gclWork;
    stlWork.TextColor := gclWorkText;
    stlWorkSelected.Color := gclWorkSelected;
    stlWorkSelected.TextColor := gclWorkSelectedText;
    stlDone.Color := gclDone;
    stlDone.TextColor := gclDoneText;
    stlDoneSelected.Color := gclDoneSelected;
    stlDoneSelected.TextColor := gclDoneSelectedText;
    stlFree.Color := gclFree;
    stlFree.TextColor := gclFreeText;
    stlSelected.Color := gclSelected;
    stlSelected.TextColor := gclSelectedText;
    stlProgress.Color := gclProgress;
    stlProgress.TextColor := gclProgressText;
    stlProgressSelected.Color := gclProgressSelected;
    stlProgressSelected.TextColor := gclProgressSelectedText;

    bitfarmApp.SetFooterOptions;

    trvBookmarks.OnCustomDrawItem := TreeView1CustomDrawItem;
    frmSplash.Update;

    // bfacrm:ticket__show__31488
    // ReadViewerIni ist zu spt. Kann aber auch nicht vorgezogen werden,
    // weil hier Toolbars etc noch nicht erzeugt sind.
    try
      var ViewerIni: TIniFile;
      ViewerIni := TIniFile.Create(BD.AppdataBitfarmPd + 'Viewer.ini');
      FViewerThumbnailsVisible := ViewerIni.ReadBool('General', 'ViewerThumbnailsVisible', True);
      FImporterThumbnailsVisible := ViewerIni.ReadBool('General', 'ImporterThumbnailsVisible', True);
      FWorkplaceThumbnailsVisible := ViewerIni.ReadBool('General', 'WorkplaceThumbnailsVisible', True);
    except
      //
    end;
    // bfacrm:ticket__show__31488

    bitfarmApp.PreviewContainer.ViewerItem := bitfarmApp.PreviewContainer.AddItem(_('Viewer'));
    bitfarmApp.PreviewContainer.ViewerItem.Panel.DockMode := dmCannotFloatOrChangeDocks;
    bitfarmApp.PreviewContainer.ViewerItem.Preview.List := TList<TbfaDocument>.Create;
    bitfarmApp.PreviewContainer.ViewerItem.Preview.PreviewKind := pvkSingle;
    bitfarmApp.PreviewContainer.ViewerItem.Preview.ThumbnailView.TabStop := False;
    bitfarmApp.PreviewContainer.ViewerItem.Panel.DockMode := dmCannotFloatOrChangeDocks;
    bitfarmApp.PreviewContainer.ViewerItem.Preview.PreviewActiveated := True;
    bitfarmApp.PreviewContainer.ImporterItem := bitfarmApp.PreviewContainer.AddItem(_('Importer'));
    bitfarmApp.PreviewContainer.ImporterItem.Panel.DockMode := dmCannotFloatOrChangeDocks;
    bitfarmApp.PreviewContainer.ImporterItem.Preview.CreateImporterToolbar;
    bitfarmApp.PreviewContainer.ImporterItem.Preview.List := bitfarmApp.ImportContainer;
    bitfarmApp.PreviewContainer.ImporterItem.Preview.PreviewKind := pvkMulti;
    bitfarmApp.PreviewContainer.ImporterItem.Preview.ShowThumbnail := bitfarmApp.ViewerOptions.EditorOptions.ShowImporterThumbnail or FImporterThumbnailsVisible;
    bitfarmApp.PreviewContainer.ImporterItem.Preview.itmBack.Caption := _('Zurck zum Importer');
    bitfarmApp.PreviewContainer.ImporterItem.Preview.itmBack.ImageIndex := Integer(icoidx_arrow_left);
    bitfarmApp.RefreshPanelCaption(bitfarmApp.PreviewContainer.ImporterItem.Panel.Tag);
    bitfarmApp.PreviewContainer.ImporterItem.Panel.Hide;
    bitfarmApp.PreviewContainer.ImporterItem.Tab.Visible := False;
    bitfarmApp.PreviewContainer.ImporterItem.Preview.bfaTlbImporter.cbxScanProfile.Properties.OnChange := ImporterScanProfilChange;
    bitfarmApp.PreviewContainer.ImporterItem.Preview.PreviewActiveated := True;

    bitfarmApp.PreviewContainer.WorkplaceItem := bitfarmApp.PreviewContainer.AddItem(_('Arbeitsplatz'));
    bitfarmApp.PreviewContainer.WorkplaceItem.Panel.DockMode := dmCannotFloatOrChangeDocks;
    bitfarmApp.PreviewContainer.WorkplaceItem.Preview.List := bitfarmApp.WorkplaceContainer;
    bitfarmApp.PreviewContainer.WorkplaceItem.Preview.PreviewKind := pvkMulti;
    bitfarmApp.PreviewContainer.WorkplaceItem.Preview.ShowThumbnail := bitfarmApp.ViewerOptions.EditorOptions.ShowWorkplaceThumbnail or FWorkplaceThumbnailsVisible;
    bitfarmApp.PreviewContainer.WorkplaceItem.Preview.itmBack.Caption := _('Zurck zum Arbeitsplatz');
    bitfarmApp.PreviewContainer.WorkplaceItem.Preview.itmBack.ImageIndex := Integer(icoidx_arrow_left);
    bitfarmApp.RefreshPanelCaption(bitfarmApp.PreviewContainer.WorkplaceItem.Panel.Tag);
    bitfarmApp.PreviewContainer.WorkplaceItem.Panel.Hide;
    bitfarmApp.PreviewContainer.WorkplaceItem.Tab.Visible := False;
    bitfarmApp.PreviewContainer.WorkplaceItem.Preview.PreviewActiveated := True;

    bitfarmApp.PreviewContainer.ResubItem := bitfarmApp.PreviewContainer.
      AddItem('Resub', False, False, False, False);
    bitfarmApp.PreviewContainer.ResubItem.Panel.DockMode := dmCannotFloatOrChangeDocks;
    bitfarmApp.PreviewContainer.ResubItem.Preview.List := nil;
    bitfarmApp.PreviewContainer.ResubItem.Preview.PreviewKind := pvkMulti;
    bitfarmApp.PreviewContainer.ResubItem.Panel.Hide;
    bitfarmApp.PreviewContainer.ResubItem.Tab.Visible := False;
    bitfarmApp.PreviewContainer.ResubItem.Preview.PreviewActiveated := True;

    bitfarmApp.PreviewContainer.FavoritesItem := bitfarmApp.PreviewContainer.
      AddItem('Favorites', False, False, False, False);
    bitfarmApp.PreviewContainer.FavoritesItem.Panel.DockMode := dmCannotFloatOrChangeDocks;
    bitfarmApp.PreviewContainer.FavoritesItem.Preview.List := nil;
    bitfarmApp.PreviewContainer.FavoritesItem.Preview.PreviewKind := pvkMulti;
    bitfarmApp.PreviewContainer.FavoritesItem.Panel.Hide;
    bitfarmApp.PreviewContainer.FavoritesItem.Tab.Visible := False;
    bitfarmApp.PreviewContainer.FavoritesItem.Preview.PreviewActiveated := True;

    bitfarmApp.PreviewContainer.AdminItem := bitfarmApp.PreviewContainer.
      AddItem('Admin', False, False, False, False);
    bitfarmApp.PreviewContainer.AdminItem.Panel.DockMode := dmCannotFloatOrChangeDocks;
    bitfarmApp.PreviewContainer.AdminItem.Preview.List := nil;
    bitfarmApp.PreviewContainer.AdminItem.Preview.PreviewKind := pvkMulti;
    bitfarmApp.PreviewContainer.AdminItem.Panel.Hide;
    bitfarmApp.PreviewContainer.AdminItem.Tab.Visible := False;
    bitfarmApp.PreviewContainer.AdminItem.Preview.PreviewActiveated := True;

    bitfarmApp.PreviewContainer.ImporterItem.Preview.bfaTlbImporter.
        cbxScanProfile.Properties.Images := bfaIcons.ilMainMenu;

    // Voransicht erzeugen (gehided)
    bitfarmApp.PreviewContainer.PageSortingsItem := bitfarmApp.PreviewContainer.
      CreatePageSortingsFrame(_('Voransicht'), True);
    with bitfarmApp.PreviewContainer.PageSortingsItem.Preview do
    begin
      List := TList<TbfaDocument>.Create;
      PreviewKind := pvkSingle;
      Name := 'PageSortingsItem';
      if MultiView <> nil then
      begin
        MultiView.Enabled := False;
        MultiView.Visible := False;
      end;
      previewToolWindow.Enabled := False;
      previewToolWindow.Visible := False;
      previewSelectToolbar.Enabled := False;
      previewSelectToolbar.Visible := False;
      AnnoToolbar.Enabled := False;
      AnnoToolbar.Visible := False;
    end;
    bitfarmApp.PreviewContainer.PageSortingsItem.Panel.OnResize := bitfarmApp.PageSortingsOnResize;
    bitfarmApp.PreviewContainer.PageSortingsItem.Panel.ShowCaptionWhenDocked := True;
    bitfarmApp.PreviewContainer.PageSortingsItem.Panel.Hide;
//    bitfarmLog.Write(llNormal, ltInfo, 'Viewer: 8419 : 16', ClassName);

    tstDocumentEditors.ActiveTabIndex := 0; //Zum Viewer Zurcksetzen

    tlbGraphic.Images := bfaIcons.ilMainMenu;
    tlbTools.Images := bfaIcons.ilMainMenu;
    btnSearch.Images := bfaIcons.ilMainMenu;
    btnReset.Images := bfaIcons.ilMainMenu;
    btnSave.Images := bfaIcons.ilMainMenu;
    btnCancel.Images := bfaIcons.ilMainMenu;
    btnBack.Images := bfaIcons.ilMainMenu;
    btnForward.Images := bfaIcons.ilMainMenu;
    actList.Images := bfaIcons.ilMainMenu;
    actListPreview.Images := bfaIcons.ilPreview;
    dxAlertWindowManager1.OptionsButtons.Images := bfaIcons.ilMainMenu;
    trvBookmarks.Images := bfaIcons.ilMainMenu;
//    bitfarmLog.Write(llNormal, ltInfo, 'Viewer: 8419 : 17', ClassName);

    FBookmarksAutoscroll := TTimer.Create(AOwner);
    FBookmarksAutoscroll.OnTimer := BookmarksAutoscroll;
    FBookmarksAutoscroll.Interval := 150;
    FBookmarksAutoscroll.Enabled := False;
    FBookmarksscroll_down := False;

//    edtGeneralSearch := TcxButtonEdit.Create(Self);
    edtGeneralSearch := TbfaButtonEdit.Create(Self); // bfacrm:ticket__show__28579
    with edtGeneralSearch do
    begin
      Parent := pnlQuickSearch;
      Left := 8;
      Top := 3;
      Height := 30;
      Width := pnlQuickSearch.Width - pnlSearchTimer.width - pnlLoadDoc.Width - 20;
      Anchors := [akLeft, akTop, akRight];
      Properties.Images := bfaIcons.ilMainMenu;
      Self.edtGeneralSearch.Properties.Buttons[0].Action := actSearch;
      Self.edtGeneralSearch.Properties.Buttons[0].Hint := _('Suchen');
      Properties.Buttons[0].Kind := bkGlyph;
      Properties.Buttons[0].ImageIndex := Integer(icoidx_search);
      Properties.Buttons[0].LeftAlignment := True;
      Properties.Buttons[0].Width := 28;
      Properties.Alignment.Vert := tavCenter;
      Properties.UseNullString := True;
      Properties.Nullstring := sOrigSearchText;
//      Text := sOrigSearchText;
      OnKeyDown := SearchEditKeyDown;
      OnKeyPress := SearchEditKeyPress;
      Properties.OnChange := SearchEditChange;
      Properties.OnEditValueChanged := SearchEditEditValueChanged;
      BeepOnEnter := False;
      PopupMenu := popAddFields;
      Style.StyleController := ctlGeneralSearch;
      StyleHot.StyleController := ctlGeneralSearch;
      StyleDisabled.StyleController := ctlGeneralSearch;
      StyleFocused.StyleController := ctlGeneralSearch;
    end;

//    bitfarmLog.Write(llNormal, ltInfo, 'Viewer: 8419 : 18', ClassName);

    FSearchthread := TQueryThread.Create(True);
    FSearchthread.FreeOnTerminate := True;
    FSearchthread.cnt := dmMain.cntSearch;
    FSearchthread.SearchObj := TbfaSearch.Create;
    FSearchthread.SearchProc := bitfarmApp.FSearchProc;
//30.03.2021    FSearchthread.bfagrid := grdResultlist;
    FSearchthread.bfagrid := nil;
    FSearchthread.dbView := grdResultlistDevExView;
    FSearchthread.dbView.DataController.MultiSelect := True;
    FSearchthread.tmr := tmrSearchPanel;
    FSearchthread.pnl := pnlSearchTimer;
    FSearchthread.actHide := Self.actHideSearchDetails;

//    bitfarmLog.Write(llNormal, ltInfo, 'Viewer: 8419 : 19', ClassName);
    scrbxViewerAddfields.Visible := False;
    scrbxViewerAddfields.Align := alClient;
    scrbxAddfields2.Visible := False;
    scrbxAddfields2.Align := alClient;

    bitfarmApp.HistoryListNode := TTreeNode.Create(trvBookmarks.Items);
    bitfarmApp.GlobalListNode := TTreeNode.Create(trvBookmarks.Items);
    bitfarmApp.LocalListNode := TTreeNode.Create(trvBookmarks.Items);
//    bitfarmLog.Write(llNormal, ltInfo, 'Viewer: 8419 : 20', ClassName);

    mnuBack.Action := actPreviewBack;
    mnuNewLink.Action := actNewLink;
    mnuAutoRef.Action := actAutoRef;
    mnuAddLink.Action := actAddLink;
    mnuResubCreate.Action := actResubCreate;
//    mnuShowAllSymLink.Action := actShowAllSymbolicLinks;
//    mnuDeleteSymLink.Action := actDeleteSymbolicLink;
//    mnuDocAbo.Action := actDocAbo;
//    mnuDeleteAbo.Action := actDeleteAbo;
    mnuDelete.Action := actDeleteSelected;
    mnuChangeDocName.Action := actChangeDocName;
    mnuExportCSVFile.Action := actExportCSV;
    mnuExportOpenOffice.Action := actExportOO;
    mnuExportExcel.Action := actExportXLS;
//    mnuCreateBookmarkForGDocID.Action := actCreateBookmarkForGDocID;
    mnuGoToSourceArchive.Action := actGoToSourceArchive;
    mnuCollectDocs.Action := actCollectDocs;
    mnuCancelCollection.Action := actCancelCollection;
    mnuSaveCollection.Action := actSaveCollectionPDF;
    mnuEmailCollection.Action := actEmailCollectionPDF;
    itmSaveCollectionPDF.Action := actSaveCollectionPDF;
    itmSaveCollectionSinglePDF.Action := actSaveCollectionSinglePDF;
    itmSaveCollectionTIF.Action := actSaveCollectionTIF;
    itmSaveCollectionOriginal.Action := actSaveCollectionOriginal;
    itmEmailCollectionPDF.Action := actEmailCollectionPDF;
    itmEmailCollectionSinglePDF.Action := actEmailCollectionSinglePDF;
    itmEmailCollectionTIF.Action := actEmailCollectionTIF;
    itmEmailCollectionOriginal.Action := actEmailCollectionOriginal;
    mnuCollectDocs.Images := bfaIcons.ilPreview;
    mnuCancelCollection.Images := bfaIcons.ilPreview;
    mnuSaveCollection.Images := bfaIcons.ilPreview;
    mnuEmailCollection.Images := bfaIcons.ilPreview;
    itmSaveCollectionPDF.Images := bfaIcons.ilPreview;
    itmSaveCollectionSinglePDF.Images := bfaIcons.ilPreview;
    itmSaveCollectionTIF.Images := bfaIcons.ilPreview;
    itmSaveCollectionOriginal.Images := bfaIcons.ilPreview;
    itmEmailCollectionPDF.Images := bfaIcons.ilPreview;
    itmEmailCollectionSinglePDF.Images := bfaIcons.ilPreview;
    itmEmailCollectionTIF.Images := bfaIcons.ilPreview;
    itmEmailCollectionOriginal.Images := bfaIcons.ilPreview;
    mnuHideSearchDetails.Action := actHideSearchDetails;
    mnuIndexing.Action := actShowIndexing;
    mnuPopupCreateLink.Action := actNewLink;
    mnuPopupCreateLink.ImageIndex := -1; //20.07.2021 die Rest hat auch keinen Ikon
    mnuIndexingWithLimit.Action := actShowIndexingWithLimit;

    trvBookmarks.Font.Size := bfaFontSize; //07.09.2020
    trvBookmarks.ItemHeight := 28; //16.10.2020

    if pnlAdmin.Items.Count > 0 then
      pnlAdmin.Items[0].Hint := _('Administration') + ' (Alt+0)';
    if pnlTreeView.Items.Count > 0 then
      pnlTreeView.Items[0].Hint := _('Lager und Archive') + ' (Alt+1)';
    if pnlImporter.Items.Count > 0 then
      pnlImporter.Items[0].Hint := _('Importer') + ' (Alt+2)';
    if pnlResubmission.Items.Count > 0 then
      pnlResubmission.Items[0].Hint := _('Wiedervorlage') + ' (Alt+3)';
    if pnlFavorites.Items.Count > 0 then
      pnlFavorites.Items[0].Hint := _('Lesezeichen') + ' (Alt+4)';
    if pnlWorkspace.Items.Count > 0 then
      pnlWorkspace.Items[0].Hint := _('Arbeitsplatz') + ' (Alt+5)';

//    bitfarmLog.Write(llNormal, ltInfo, 'Viewer: 8419 : 21', ClassName);

    // bfacrm:ticket__show__30743
    pnlTreeView.OnBfaCanLeavePanel := CanLeaveCurrentView;
    pnlWorkspace.OnBfaCanLeavePanel := CanLeaveCurrentView;
    pnlImporter.OnBfaCanLeavePanel := CanLeaveCurrentView;
    pnlResubmission.OnBfaCanLeavePanel := CanLeaveCurrentView;
    pnlAdmin.OnBfaCanLeavePanel := CanLeaveCurrentView;
    pnlFavorites.OnBfaCanLeavePanel := CanLeaveCurrentView;
    // bfacrm:ticket__show__30743

    CF_RTF := RegisterClipboardFormat('Rich Text Format');

    (DataFormatAdapter1.DataFormat as TVirtualFileStreamDataFormat).OnGetStream := OnGetStream;
//    bitfarmLog.Write(llNormal, ltInfo, 'Viewer: 8419 : 22', ClassName);

    SetCheckActionLanguage;
    Screen.OnActiveControlChange := OnActiveControlChange;

    SpTBXDockablePanel3.Images := bfaIcons.ilMainMenu;
    SpTBXDockablePanel3.Options.CaptionImageIndex := Integer(icoidx_tree);
    SpTBXDockablePanel3.Options.TitleBarMaxSize := 30;
    pnlSearchOptions.Images := bfaIcons.ilMainMenu;
    pnlSearchOptions.Options.CaptionImageIndex := Integer(icoidx_fields);
    pnlSearchOptions.Options.TitleBarMaxSize := 30;

      bitfarmLog.Write(llDebug, ltInfo, 'lade Konfiguration...', ClassName);
      frmSplash.lblLoading.Caption := sMsgLoadConfiguration;
      frmSplash.Update;

//15.07.2020 muss spter sein sonst wird doppelt beim start ausgefhrt!      tlbMainMenuSkinGroupItem1.OnSkinChange := ChangeSkin;

      Self.InitViewer;
      Self.ReadViewerIni;
//23.08.2017 -->
      bitfarmApp.PreviewContainer.WorkplaceItem.Preview.MultiView.ThumbWidth := bitfarmApp.MViewThumbWidth;
      bitfarmApp.PreviewContainer.WorkplaceItem.Preview.MultiView.ThumbHeight := bitfarmApp.MViewThumbHeight;
      bitfarmApp.PreviewContainer.WorkplaceItem.Preview.FActThumbnailWidth := bitfarmApp.MViewThumbWidth;
      bitfarmApp.PreviewContainer.WorkplaceItem.Preview.FActThumbnailHeight := bitfarmApp.MViewThumbHeight;
      bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView.ThumbWidth := bitfarmApp.MViewThumbWidth;
      bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView.ThumbHeight := bitfarmApp.MViewThumbHeight;
      bitfarmApp.PreviewContainer.ImporterItem.Preview.FActThumbnailWidth := bitfarmApp.MViewThumbWidth;
      bitfarmApp.PreviewContainer.ImporterItem.Preview.FActThumbnailHeight := bitfarmApp.MViewThumbHeight;
//23.08.2017 <--

      bitfarmApp.LoadArrays;

      bitfarmLog.Write(llDebug, ltInfo, 'lade Baumansicht Viewer...', ClassName);
      frmSplash.lblLoading.Caption := sMsgLoadTreeviewViewer;
      frmSplash.Update;

      FViewerTreeview.Cnt := dmMain.cntMain;
      FViewerTreeview.bfaLog := bitfarmApp.Log;
      FViewerTreeview.User := bitfarmApp.User;
      FViewerTreeview.Load(True); //03.04.2017 Ticket 10202 auf True gesetzt

      bitfarmLog.Write(llDebug, ltInfo, 'lade Baumansicht Importer...', ClassName);
      frmSplash.lblLoading.Caption := sMsgLoadTreeviewImporter;
      frmSplash.Update;
      FImporterTreeview.Cnt := dmMain.cntMain;
      FImporterTreeview.bfaLog := bitfarmApp.Log;
      FImporterTreeview.User := bitfarmApp.User;
      FImporterTreeview.Load(True); //03.04.2017 Ticket 10202 auf True gesetzt

      // Defaulteinstellung falls nicht schon durch ReadViewerIni gelesen
      if fSearchOption = 0 then
      begin
        tbiSo1Click(popSearchOption1.Items[0]);
        tbiSo2Click(popSearchOption2.Items[0]);  // ruft ReadUserlist auf
        tbiSo3Click(popSearchOption3.Items[0]);
        tbiSo4Click(popSearchOption4.Items[0]);
      end;
//15.12.2017 Ticket 12095 if fLimit = 0 then
      if bitfarmApp.ViewerOptions.SearchOptions.Limit <= 0 then
          tbiLimitClick(popLimit.Items[2]);

      bitfarmApp.PreviewContainer.ViewerItem.Preview.SingleView.fCbx_MainFormZoom :=
        frmMainForm.bfaTlbPreview1.cbxZoom;
      bitfarmApp.PreviewContainer.ImporterItem.Preview.SingleView.fCbx_MainFormZoom :=
        frmMainForm.bfaTlbPreview1.cbxZoom;
      bitfarmApp.PreviewContainer.WorkplaceItem.Preview.SingleView.fCbx_MainFormZoom :=
        frmMainForm.bfaTlbPreview1.cbxZoom;

      {$IFNDEF ENTERPRISE}
      bitfarmApp.PreviewContainer.ImporterItem.Preview.ThumbnailView.TabOrder :=
        fraScanFunctions.btnArchive.TabOrder + 1;
      bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView.TabOrder :=
        fraScanFunctions.btnArchive.TabOrder + 2;
      bitfarmApp.PreviewContainer.ImporterItem.Preview.SingleView.TabOrder :=
        fraScanFunctions.btnArchive.TabOrder + 3;
      {$ENDIF}

        // Enterprise ??
      //frmSVNInfo := TfrmSVNInfo.Create(Self);
      //popSVNInfo.PopupForm := frmSVNInfo;

      ControlStyle := ControlStyle + [csDisplayDragImage];
      for I := 0 to ControlCount -1  do
      begin
        SetControlStyle(Controls[i]);
      end;

      dctImporterTarget.Register(FImporterTreeview);
      dctImporterTarget.Register(frmMainForm.fraImporter);
      dctImporterTarget.Register(frmMainForm.fraImporter.dropImporter);
      dctImporterTarget.Register(frmMainForm.fraImporter.SpTBXLabel1);
      dctImporterTarget.Register(frmMainForm.fraImporter.lblImportObjects);
      dctImporterTarget.Register(frmMainForm.fraImporter.SpTBXLabel2);

      detViewer2.Register(FViewerTreeview);
      detViewer2.Register(pnlTreeView);
      detViewer2.Register(pnlWorkspace);
      detViewer2.Register(pnlImporter);
      detViewer2.Register(pnlResubmission);

      dftMainForm.Register(Self);

      ini := TIniFile.Create(Inistr); //09.01.2020 inistr ist oben schon ausgewertet
      try
        LayoutName := ini.ReadString('Layouts', 'Default', 'Standard');
      finally
        FreeAndNil(ini);
      end;

      try
        LoadLayout(LayoutName);
      except
        bitfarmLog.Write(llNormal, ltException, 'LoadLayout(LayoutName);', ClassName);
      end;

//09.07.2024 weiter unten war auch einmal
//    {$IFDEF GPL}
//    ChangeSkinAtCreate;
//    {$ENDIF}

    // wir selecten das letzte Archiv des angezeigten Treeviews
    // im anderen TReeview setzen wir LastSelected, damit der SelectTreeNode
    // kein Archivwechsel auslst

    for i := 1 to ParamCount do
    begin
      lsPar := lowercase(ParamStr(i));
      if (pos('-f:', LowerCase(lsPar)) = 1) or (pos('-fd:', LowerCase(lsPar)) = 1) or
         (pos('-d:', LowerCase(lsPar)) = 1) or (pos('-dd:', LowerCase(lsPar)) = 1) //22.04.2024 then
         or (pos('-dds:', LowerCase(lsPar)) = 1) then
      begin
        FLastActivePreview := 1;     // wenn Dokumente beim Start an den Importer bergeben werden, dann ffnen wir auch direkt den Importer
        Break;
      end;
    end;


    tlbMainMenuSkinGroupItem1.OnSkinChange := ChangeSkin; //15.07.2020
    tbsubSkin.ImageIndex := Integer(icoidx_surface);
    tbsubToolbars.ImageIndex := Integer(icoidx_toolbar);
    tbsubLanguages.ImageIndex := Integer(icoidx_language_select);
    tbsubLayout.ImageIndex := Integer(icoidx_layouts);

    mnuGetDoc1.Images := bfaIcons.ilPreview;
    mnuGetDoc1.ImageIndex := Integer(icoidx_document_reserved_view_1);
    mnuSetDoc1.Images := bfaIcons.ilPreview;
    mnuSetDoc1.ImageIndex := Integer(icoidx_document_reserve_1);
    mnuGetDoc2.Images := bfaIcons.ilPreview;
    mnuGetDoc2.ImageIndex := Integer(icoidx_document_reserved_view_2);
    mnuSetDoc2.Images := bfaIcons.ilPreview;
    mnuSetDoc2.ImageIndex := Integer(icoidx_document_reserve_2);
    mnuGetDoc3.Images := bfaIcons.ilPreview;
    mnuGetDoc3.ImageIndex := Integer(icoidx_document_reserved_view_3);
    mnuSetDoc3.Images := bfaIcons.ilPreview;
    mnuSetDoc3.ImageIndex := Integer(icoidx_document_reserve_3);
    mnuGetDoc4.Images := bfaIcons.ilPreview;
    mnuGetDoc4.ImageIndex := Integer(icoidx_document_reserved_view_4);
    mnuSetDoc4.Images := bfaIcons.ilPreview;
    mnuSetDoc4.ImageIndex := Integer(icoidx_document_reserve_4);
    mnuGetDoc5.Images := bfaIcons.ilPreview;
    mnuGetDoc5.ImageIndex := Integer(icoidx_document_reserved_view_5);
    mnuSetDoc5.Images := bfaIcons.ilPreview;
    mnuSetDoc5.ImageIndex := Integer(icoidx_document_reserve_5);

    mnuCheckoutDocs.ImageIndex := Integer(icoidx_status_check_out);
    mnuCheckoutAllDocs.ImageIndex := Integer(icoidx_document_checkout_all);

    {$IFNDEF ENTERPRISE}
    ChangeSkinAtCreate; //12.06.2023
    AddSubMenuLanguageXX; //09.07.2024
    {$ENDIF}
    //30.09.2024 SD -->bfacrm:ticket__show__39456
    TBSeparatorItem1.Visible := False;
    SpTBXLabelItem5.Visible := False;
    itmDBName.Visible := False;
    //30.09.2024 SD <--bfacrm:ticket__show__39456

  finally
    bitfarmLog.Write(llNormal, ltInfo, 'Ende Base FormCreate', ClassName);
  end;
end;

procedure TfrmGPL.ChangeSkinAtCreate;
var
  i: Integer;
  bfaSkin: string;
  SkinObj: TSpTBXSkinsListEntry;
begin
  bitfarmLog.DebugBegin(llDebug, 'ChangeSkinAtCreate', ClassName);
  try
    if FSelectedSkinName <> '' then
    begin
      //08.03.2024 noch bevor das Skin gesetzt ist muss geprft werden, ob es vorhanden ist z.B. im Offline-Modus kann es vorkommen...
      //  SkinManager.SetSkin(FSelectedSkinName);
      bfaSkin := 'bitfarm-Archiv';
      if SkinManager.SkinsList.TryGetValue(FSelectedSkinName, SkinObj) then
        SkinManager.SetSkin(FSelectedSkinName)
      else if SkinManager.SkinsList.TryGetValue(bfaSkin, SkinObj) then
        SkinManager.SetSkin(bfaSkin)
      else
        SkinManager.SetSkin('Default');
    end
    else if (FSelectedSkinName = '') and (FSelectedSkinIndex >= 0) then
    begin
      Case FSelectedSkinIndex of
        0 : FSelectedSkinName := 'Aluminium';
        1 : FSelectedSkinName := 'Athen';
        2 : FSelectedSkinName := 'bitfarm-Archiv';
        3 : FSelectedSkinName := 'Dream';
        4 : FSelectedSkinName := 'Eos';
        5 : FSelectedSkinName := 'Human';
        6 : FSelectedSkinName := 'Leopard';
        7 : FSelectedSkinName := 'Xito';
        8 : FSelectedSkinName := 'Office XP';
        9 : FSelectedSkinName := 'Office 2003';
        10 : FSelectedSkinName := 'Office 2007 Blue';
        11 : FSelectedSkinName := 'Office 2007 Black';
        12 : FSelectedSkinName := 'Office 2007 Silver';
        else FSelectedSkinName := 'Default';
      end;
      SkinManager.SetSkin(FSelectedSkinName)
    end
    else
      SkinManager.SetSkin('Default');
    ChangeSkin(Self);
  finally
    bitfarmLog.DebugEnd(llDebug, 'ChangeSkinAtCreate', ClassName);
  end;
end;

procedure TfrmGPL.SetCheckActionLanguage;
begin
  actLanguageDE.Checked := false;
  actLanguageEN.Checked := false;
  actLanguage.Checked := false;
  if bitfarmApp.Lang = 'de' then
    actLanguageDE.Checked := true
  else if bitfarmApp.Lang = 'en' then
    actLanguageEN.Checked := true
  else if (bitfarmApp.Lang <> 'en') and (bitfarmApp.Lang <> 'de') then
    actLanguage.Checked := true;
end;

procedure TfrmGPL.ChangeLanguageAfter;
var
 i, j: integer;
 ArcId: Int64;
 searchgrid: TbfaDBGrid;
 s: string;
 IsResubColumn, IsResubGrid: Boolean;
 Acomp: TBfaAddfieldComp; //13.09.2024

 procedure RetranslateBookmarksTreeNodes;
 begin
   bitfarmApp.GlobalListNode.Text := _('Globale Lesezeichen');
   bitfarmApp.LocalListNode.Text := _('Lokale Lesezeichen');
   bitfarmApp.HistoryListNode.Text := _('Verlaufs-Lesezeichen');
 end;

begin
  try
    frmMainform.bfaTlbPreview1.bfaTlbPreviewLabelPage.Caption := sCaptionPage;
    frmMainform.bfaTlbPreview1.cbxZoom.Hint := sCaptionZoomFactor;

//    frmMainForm.actLocalSavePDF.Caption := sCaptionSaveDocumentAsPDFOnLocalDevice;
//    frmMainForm.actEmailPDFAttachment.Caption := sCaptionEmailPDFAttachment;
//    frmMainForm.actPrintPreview.Caption := sCaptionPrintPreview;
//    frmMainForm.actCopyDocToClipboard.Caption := sCaptionCopyDocToClipboard;

//    frmMainForm.actLocalSavePDF.Hint := sCaptionSaveDocumentAsPDFOnLocalDevice;
//    frmMainForm.actEmailPDFAttachment.Hint := sCaptionEmailPDFAttachment;
//    frmMainForm.actPrintPreview.Hint := sCaptionPrintPreview;
//    frmMainForm.actCopyDocToClipboard.Hint := sCaptionCopyDocToClipboard;

//    frmMainform.actChangeDocName.Caption := sCaptionChangeDocname;
//    mnuChangeDocName.Caption := sCaptionChangeDocname;

//    actRotateLeft.Caption := sCaptionRotateLeft;
//    actFlip.Caption := sCaptionFlip;
//    actRotateRight.Caption := sCaptionRotateRight;

//    actEditTags.Caption := sCaptionEditTags;
//    frmMainform.actNewLink.Caption := sCaptionCreateNewLink;
//    frmMainform.actAddLink.Caption := sCaptionAddLink;

//    frmMainform.actResubCreate.Caption := sCaptionCreateResubmission;
//    mnuResubCreate.Caption := sCaptionCreateResubmission;

//    frmMainform.actDocAbo.Caption := sCaptionSubscribeToDocument;
//    frmMainform.actShowAllSymbolicLinks.Caption := sCaptionShowAllSymbolicLinks;
//    frmMainform.actDeleteSymbolicLink.Caption := sCaptionDeleteDymbolicLink;
//    frmMainform.actCreateBookmarkForGDocID.Caption:= sCaptionSaveDocumentAsBookmark;

//    frmMainform.actRestoreOriginal.Caption := sCaptionRecoverOriginalFile;
//    frmMainform.actRefreshDoc.Caption := sCaptionRefreshDocument;
//    frmMainform.actCreateEmptyDoc.Caption := sCaptionCreateEmptyDocument;
//    frmMainform.actDeleteDoc.Caption := sCaptionDeleteNRSDocument;

//    frmMainform.actHideSearchDetails.Caption:= sCaptionHideSearchDetails;
//    mnuHideSearchDetails.Caption := sCaptionHideSearchDetails;

//    frmMainform.actShowIndexingWithLimit.Caption := sCaptionShowIndexingWithLimit;
//    mnuIndexingWithLimit.Caption := sCaptionShowIndexingWithLimit;

//    frmMainform.actMyTasks.Caption := sCaptionMyTasks;
    fraResub.btnMyTasks.Caption := sCaptionMyTasks;

//    frmMainform.actDelegateTasks.Caption := sCaptionDelegateTasks;
    fraResub.btnDelegateTasks.Caption := sCaptionDelegateTasks;
    cxSetResourceString(@cxSDatePopupClear, sCaptionDelete);
    cxSetResourceString(@cxSNoMatchesFound, sCaptionNoMatchesFound);

    bitfarmApp.ResetButtons(False);
    frmMainForm.pnlSearchOptions.Caption := sCaptionActViewSearchOptions;
//07.10.2020    TbfaSearchEditProperties(edtGeneralSearch.ActiveProperties).EmptyString := sOrigSearchText;
    edtGeneralSearch.Properties.Nullstring := sOrigSearchText;
    edtGeneralSearch.Clear;
    // sonst ist der falsche StyleControler gesetzt
    if Assigned(edtGeneralSearch.Properties.OnChange) then
      edtGeneralSearch.Properties.OnChange(edtGeneralSearch);

    for i := 0 to bitfarmApp.PreviewContainer.Containers.Count - 1 do
      bitfarmApp.PreviewContainer.Containers[i].Preview.Retranslate;

    CreateActions(actList, actListPreview, False); // Actions werden nicht erzeugt, nur bersetzt

    bitfarmApp.CreateResubPopup;
    bitfarmApp.CreateResubFavsInPreviews; //14.02.2023 bfacrm:ticket__show__33967

    // Anmerkung:
    // 2. Variante mit TP_GlobalHandleClass(TbfaSelector,HandleTbfaSelector) hat nicht funktioniert!
    if fraAdmin <> nil then
    begin
      for i := 0 to fraAdmin.ComponentCount - 1 do
      begin
        if fraAdmin.Components[i] is tbfaSelector then
        begin
          tbfaSelector(fraAdmin.Components[i]).ReTranslate;
        end;
      end;

      //19.08.2024 SD -->bfacrm:ticket__show__39657
      {$IFDEF ENTERPRISE}
      fraAdmin.HolidayRefresh;  //39657
      TbfaApplicationEnterprise(bitfarmApp).SetMainFormTitle; //12.09.2024
      {$ENDIF}
      //19.08.2024 SD <--bfacrm:ticket__show__39657

      fraAdmin.frmDLMDialog.Retranslate;

      TranslateAdminTreeviewItemResub;

      fraAdmin.Retranslate;

      fraAdmin.LoadAdminFrame; //16.09.2024 wegen Built-In gruppe muss neu geladen werden
    end;

    frmLinkMails.Retranslate;
    frmListItems.Retranslate;
    frmGridConfig.Retranslate;
    if fraFloatingResub <> nil then
      fraFloatingResub.Retranslate;
    //18.10.2024 -->
    if fraDocLinks <> nil then
      fraDocLinks.Retranslate;
    //18.10.2024 <--

    bitfarmApp.RetranslateSearchgrid(FSearchthread.bfagrid);
    //12.09.2024 -->
    try
      bitfarmApp.ReadUserlist;

      for i := 0 to aCurrentViewerAddfields.Count - 1 do
      begin
        AComp := aCurrentViewerAddfields[i].Component;
        if AComp <> nil then
        begin
          RetranslateComponent(AComp, 'Shared36');
          if (Acomp.AddfieldType = zfld13_Grid) then
          begin
            try
              AComp.SetcompGridPopupConfigCaptions;
            except
              //
            end;
          end;
        end;
      end;
      for i := 0 to aCurrentImporterAddfields.Count - 1 do
      begin
        AComp := aCurrentImporterAddfields[i].Component;
        if AComp <> nil then
        begin
          RetranslateComponent(AComp, 'Shared36');
          if (Acomp.AddfieldType = zfld13_Grid) then
          begin
            try
              AComp.SetcompGridPopupConfigCaptions;
            except
              //
            end;
          end;
        end;
      end;
      for i := 0 to aCurrentResubAddfields.Count - 1 do
      begin
        AComp := aCurrentResubAddfields[i].Component;
        if AComp <> nil then
        begin
          RetranslateComponent(AComp, 'Shared36');
          if (Acomp.AddfieldType = zfld13_Grid) then
          begin
            try
              AComp.SetcompGridPopupConfigCaptions;
            except
              //
            end;
          end;
        end;
      end;
    except

    end;
    //12.09.2024 <--

    {$IFNDEF ENTERPRISE}
    if (frmLogin <> nil) and (frmLogin is TfrmLoginGPL)  then
    begin
      TfrmLoginGPL(frmLogin).Retranslate;
    end;
    {$ENDIF}

    actCreateEmptyDoc.Hint := Format(_(sCaptionNewDocument) + ' (%s)',[bitfarmApp.currentEmptyDoc]);
    tbsubCreateEmptyDoc.Caption := actCreateEmptyDoc.Hint;

    RetranslateBookmarksTreeNodes;

    mnuSingleSave.LinkSubitems := nil;
    mnuSingleEmail.LinkSubitems := nil;
    mnuSinglePrint.LinkSubitems := nil;
    mnuSingleClipboard.LinkSubitems := nil;

//    actLocalSaveOriginal.Caption := _('Original-Datei speichern');
//    actLocalSaveOriginal.Hint := _('Original-Datei speichern');
//    actLocalSavePDF.Caption := _('Dokument lokal als PDF speichern');
//    actLocalSavePDF.Hint := _('Dokument lokal als PDF speichern');
//    actLocalSaveTIF.Caption := _('Dokument lokal als TIF speichern');
//    actLocalSaveTIF.Hint := _('Dokument lokal als TIF speichern');
//    actLocalSaveLink.Caption := _('Verknpfung auf dem Desktop erstellen');
//    actLocalSaveLink.Hint := _('Verknpfung auf dem Desktop erstellen');
//    actLocalSavePreview.Caption := _('Speichern mit Vorschau');
//    actLocalSavePreview.Hint := _('Lokal speichern mit Vorschau (Umschalt+Strg+L)');
//    actEmailPDFAttachment.Caption := _('Dokument als PDF versenden');
//    actEmailPDFAttachment.Hint := _('Dokument als PDF versenden');
//    actEmailTIFAttachment.Caption := _('Dokument als TIF versenden');
//    actEmailTIFAttachment.Hint := _('Dokument als TIF versenden');
//    actEmailOriginal.Caption := _('Originaldatei versenden');
//    actEmailOriginal.Hint := _('Originaldatei versenden');
//    actEmailLink.Caption := _('Verknpfung versenden');
//    actEmailLink.Hint := _('Verknpfung versenden');
//    actEmailPreview.Caption := _('E-Mail mit Vorschau versenden');
//    actEmailPreview.Hint := _('E-Mail mit Vorschau versenden');
//    actPrintStandard.Caption := _('Standarddrucker');
//    actPrintStandard.Hint := _('Drucken auf Standarddrucker');
//    actPrintSelect.Caption := _('Druckerauswahl');
//    actPrintSelect.Hint := _('Drucken mit Druckerauswahl');
//    actPrintPreview.Caption := _('Drucken mit Vorschau');
//    actPrintPreview.Hint := _('Drucken mit Vorschau');
//    actCopyDocToClipboard.Caption := _('Dokument in Zwischenablage kopieren');
//    actCopyDocToClipboard.Hint := _('Dokument in Zwischenablage kopieren');
//    actCopyOriginalDocToClipboard.Caption := _('Originaldokument in Zwischenablage kopieren');
//    actCopyOriginalDocToClipboard.Hint := _('Originaldokument in Zwischenablage kopieren');
//    actCopyPageToClipboard.Caption := _('Seite in Zwischenablage kopieren');
//    actCopyPageToClipboard.Hint := _('Seite in Zwischenablage kopieren');
//    actCopyDocLinkToClipboard.Caption := _('Doklink in Zwischenablage kopieren');
//    actCopyDocLinkToClipboard.Hint := _('Doklink in Zwischenablage kopieren');

    mnuSingleSave.LinkSubitems := mnuLocalSave;
    mnuSingleEmail.LinkSubitems := mnuEmail;
    mnuSinglePrint.LinkSubitems := mnuPrint;
    mnuSingleClipboard.LinkSubitems := mnuCopyToClipboard;

    frmMainForm.fraWorkplace.lblWorkplaceObjects.Caption := IntToStr(bitfarmApp.WorkplaceContainer.Count) + _(' Objekte');
    bitfarmApp.PreviewContainer.WorkplaceItem.Panel.Caption := _('Arbeitsplatz') + ' (' + IntToStr(bitfarmApp.WorkplaceContainer.Count) + ')';
    bitfarmApp.PreviewContainer.WorkplaceItem.Tab.Caption := _('Arbeitsplatz') + ' (' + IntToStr(bitfarmApp.WorkplaceContainer.Count) + ')';
    frmMainForm.pnlWorkspace.Caption := _('Arbeitsplatz') + ' (' + IntToStr(bitfarmApp.WorkplaceContainer.Count) + ')';

    SetPanelResubmissionCaption;

    if pnlAdmin.Items.Count > 0 then
      pnlAdmin.Items[0].Hint := _('Administration') + ' (Alt+0)';
    if pnlTreeView.Items.Count > 0 then
      pnlTreeView.Items[0].Hint := _('Lager und Archive') + ' (Alt+1)';
    if pnlImporter.Items.Count > 0 then
      pnlImporter.Items[0].Hint := _('Importer') + ' (Alt+2)';
    if pnlResubmission.Items.Count > 0 then
      pnlResubmission.Items[0].Hint := _('Wiedervorlage') + ' (Alt+3)';
    if pnlFavorites.Items.Count > 0 then
      pnlFavorites.Items[0].Hint := _('Lesezeichen') + ' (Alt+4)';
    if pnlWorkspace.Items.Count > 0 then
      pnlWorkspace.Items[0].Hint := _('Arbeitsplatz') + ' (Alt+5)';

    AlignToolbarsToLeft;

    //14.02.2023 bfacrm:ticket__show__33967 -->
    frmMainForm.edtGeneralSearch.Properties.Buttons[0].Hint := _('Suchen');
    //14.02.2023 <--

    SetCheckActionLanguage;
  except
    bitfarmLog.Write(llNormal, ltException, 'ChangeLanguageAfter', ClassName);
  end;
end;

//procedure TfrmGPL.SetCheckedMenuProfile;
//var
 //i: integer;
 //mnu: TSpTbxItem;
//begin
  //if not mnuChangeProfile.Visible or (mnuChangeProfile.Count <= 1) then
    //exit;
//
  //for i := 0 to mnuChangeProfile.Count -1 do
  //begin
    //mnu := TSpTbxItem(mnuChangeProfile.Items[i]);
    //mnu.Checked := false;
    //mnu.Enabled := true;
//
    //if LowerCase(mnu.Caption) = LowerCase(bitfarmApp.Profile) then
    //begin
      //mnu.Checked := true;
      //mnu.Enabled := false;
    //end;
  //end;
//end;

procedure TfrmGPL.actAddFolderExecute(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'actAddFolderExecute', Classname);
  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actAddFolder';
      if (trvBookmarks.Selected.Data <> nil) then
        if (TObject(trvBookmarks.Selected.Data) is TbfaNodeInfo) then
          UserAction^.Objects.Add(trvBookmarks.Selected)
        else if trvBookmarks.Selected.Parent <> nil then
          UserAction^.Objects.Add(trvBookmarks.Selected.Parent)
        else
          UserAction^.Objects.Add(trvBookmarks.Selected)
      else
        UserAction^.Objects.Add(trvBookmarks.Selected);
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'actAddFolderExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actAddFolderExecute', Classname);
  end;
end;

procedure TfrmGPL.actCreateBookmarkDialogExecute(Sender: TObject);
begin
  actCreateBookmark.Execute();
end;

procedure TfrmGPL.actCreateBookmarkExecute(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'actCreateBookmarkExecute', Classname);
  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actCreateBookmarkDialog';
      if ((trvBookmarks.Selected <> nil) and (GetRootNode(trvBookmarks.Selected) = bitfarmApp.LocalListNode)) then
      begin
//        if (trvBookmarks.Selected.Data <> nil) and (trvBookmarks.Selected <> bitfarmApp.LocalListNode) then
//          UserAction^.Objects.Add(trvBookmarks.Selected.Parent)
//        else
//          UserAction^.Objects.Add(trvBookmarks.Selected);
        if (trvBookmarks.Selected.Data <> nil) then
        begin
          if TObject(trvBookmarks.Selected.Data) is TbfaNodeInfo then
            UserAction^.Objects.Add(trvBookmarks.Selected)
          else
            UserAction^.Objects.Add(trvBookmarks.Selected.Parent);
        end;
      end
      else if ((trvBookmarks.Selected <> nil) and (GetRootNode(trvBookmarks.Selected) = bitfarmApp.GlobalListNode)) {and bitfarmApp.User.isAdmin} then   // Ticket 20864
      begin
        if trvBookmarks.Selected.Data <> nil then
        begin
          if TObject(trvBookmarks.Selected.Data) is TbfaNodeInfo then
            UserAction^.Objects.Add(trvBookmarks.Selected)
          else
            UserAction^.Objects.Add(trvBookmarks.Selected.Parent)
        end
        else
          UserAction^.Objects.Add(trvBookmarks.Selected);
      end
      else
        UserAction^.Objects.Add(bitfarmApp.LocalListNode);
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'actCreateBookmarkExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actCreateBookmarkExecute', Classname);
  end;
end;

procedure TfrmGPL.actCreateBookmarkForGDocIDExecute(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'actCreateBookmarkForGDocIDExecute', Classname);
  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actCreateBookmarkForGDocID';
      bitfarmApp.CloneCurrentDocs(UserAction, True);
      UserAction^.Objects.Add(bitfarmApp.LocalListNode);
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'actCreateBookmarkForGDocIDExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actCreateBookmarkForGDocIDExecute', Classname);
  end;
end;

procedure TfrmGPL.actCreateBookmarkMenuExecute(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'actCreateBookmarkMenuExecute', Classname);
  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actCreateBookmark';
      bitfarmApp.CloneCurrentDocs(UserAction, True);
      UserAction^.Objects.Add(bitfarmApp.LocalListNode);
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'actCreateBookmarkMenuExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actCreateBookmarkMenuExecute', Classname);
  end;
end;

procedure TfrmGPL.actCreateCopyExecute(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'actCreateCopyExecute', Classname);
  try
    try
      bitfarmApp.SendDocumentsTo(bitfarmApp.PreviewContainer.WorkplaceItem.Preview, False, True);
    except
      bitfarmLog.Write(llNormal, ltException, 'actCreateCopyExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actCreateCopyExecute', Classname);
  end;
end;

procedure TfrmGPL.actCreateSymbolicLinkInImporterExecute(Sender: TObject);
var
  UserAction: PUserAction;
begin
// Implementiert wird erst ab Version 3.6.1
//
//  bitfarmLog.DebugBegin(llDebug, 'actCreateSymbolicLinkInImporterExecute', Classname);
//  try
//    try
//      UserAction := bitfarmApp.CreateUserAction;
//      UserAction^.ActionName := 'actCreateSymbolicLink';
//      UserAction^.Preview := bitfarmApp.GetActivePreview;
//      bitfarmApp.CloneCurrentDocs(UserAction, True);
//      UserAction^.Params.Add(IntToStr(-1));
//      bitfarmApp.MainThread.Add(UserAction);
//    except
//      bitfarmLog.Write(llNormal, ltException, 'actCreateSymbolicLinkInImporterExecute', ClassName);
//    end;
//  finally
//    bitfarmLog.DebugEnd(llDebug, 'actCreateSymbolicLinkInImporterExecute', Classname);
//  end;
end;

procedure TfrmGPL.actCtrlAltLeftExecute(Sender: TObject);
begin
  GetLastDocExecute(actGetLastDocument, 0);
end;

procedure TfrmGPL.actCtrlAltRightExecute(Sender: TObject);
begin
  GetLastDocExecute(actGetLastDocument, 1);
end;

procedure TfrmGPL.actAddGlobalExecute(Sender: TObject);
var
  frmDialog: TfrmAddGlobalBookmarkFolder;
  userid, groupid: Int64;
begin
  bitfarmLog.DebugBegin(llDebug, 'actAddGlobalExecute', Classname);
  try
    try
      frmDialog := TfrmAddGlobalBookmarkFolder.Create(Self, bitfarmApp.GlobalListNode);
      frmDialog.ShowModal;
      userid := 0;
      groupid := 0;

      if frmDialog.ModalResult = mrOk then
      begin
        if frmDialog.SpTBXRadioGroup1.ItemIndex = 1 then
        begin
          userid := integer(frmDialog.cbbUser.Items.Objects[frmDialog.cbbUser.ItemIndex])
        end
        else if frmDialog.SpTBXRadioGroup1.ItemIndex = 2 then
        begin
          groupid := integer(frmDialog.cbbUser.Items.Objects[frmDialog.cbbUser.ItemIndex])
        end;

        CreateGlobalNode(userid, groupid, frmDialog.edtName.Text);

      end;
      frmDialog.Release;
      frmDialog.Free;
    except
      bitfarmLog.Write(llNormal, ltException, 'actAddGlobalExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actAddGlobalExecute', Classname);
  end;
end;

procedure TfrmGPL.actAddLinkExecute(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'actAddLinkExecute', Classname);
  try
    try
      bitfarmApp.CreateNewLinkAction(False, False, True);
    except
      bitfarmLog.Write(llNormal, ltException, 'actAddLinkExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actAddLinkExecute', Classname);
  end;
end;

procedure TfrmGPL.actAddLinkHint(var HintStr: string; var CanShow: Boolean);
begin
  if (frmMainForm.actAddLink.Enabled) then
    HintStr := '';
    //CanShow := False;
end;

procedure TfrmGPL.actAuditProofExecute(Sender: TObject);
var
  UserAction: PUserAction;
  i: Integer;
begin
  if bitfarmApp.CurrentContainer.Count = 0 then
    Exit;

  bitfarmLog.DebugBegin(llDebug, 'actAuditProofExecute', ClassName);
  try
    if bitfarmApp.CurrentContainer[0].RevSave then
    begin
      BfShowMessage(_('Das Dokument liegt bereits revisionssicher.'));
      Exit;
    end;

    try
      try
        UserAction := bitfarmApp.CreateUserAction;
        UserAction^.ActionName := 'actAuditProof';
        for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
          UserAction^.Params.Add(IntToStr(bitfarmApp.CurrentContainer[i].ID));
        UserAction^.Preview := bitfarmApp.GetActivePreview;
        bitfarmApp.MainThread.Add(UserAction);
      except
        bitfarmLog.Write(llNormal, ltException, 'actAuditProofExecute - ', ClassName);
      end;
    except
      on e: exception do
        bitfarmLog.Write(llNormal, ltException, 'actAuditProofExecute' + e.Message, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actAuditProofExecute', ClassName);
  end;
end;

procedure TfrmGPL.actAutoRefExecute(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'actAutoRefExecute', Classname);
  try
    try
      bitfarmApp.CreateNewLinkAction(False, True, False);
    except
      bitfarmLog.Write(llNormal, ltException, 'actAutoRefExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actAutoRefExecute', Classname);
  end;
end;

procedure TfrmGPL.actNewLinkExecute(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'actNewLinkExecute', Classname);
  try
    try
      bitfarmApp.CreateNewLinkAction(False, False, False);
    except
      bitfarmLog.Write(llNormal, ltException, 'actNewLinkExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actNewLinkExecute', Classname);
  end;
end;

procedure TfrmGPL.actNextPageExecute(Sender: TObject);
var
  UserAction: PUserAction;
  imgidx, imgcnt: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'actNextPageExecute', Classname);
  try
    try
      if (bitfarmApp.GetActivePreview <> nil) and (bitfarmApp.GetActivePreview.ActiveDoc <> nil) then
      begin
        if (bitfarmApp.GetActivePreview.ActiveDoc <> nil) and
           (bitfarmApp.GetActivePreview.ActiveDoc.ScanPoolView <> nil) and
           (bitfarmApp.GetActivePreview.ActiveDoc.ScanPoolViewLoaded) then
        begin
        // SJ 28.09.2022 - wurde wohl von Preview hier her verschoben...
        // Self.Owner ist kein TbfaPreview mehr
//          imgidx := TbfaPreview(Self.Owner).ActivePage;
//          imgcnt := TbfaPreview(Self.Owner).ActiveDoc.ScanPoolView.ImageCount;
          imgidx := bitfarmApp.GetActivePreview.ActivePage;
          imgcnt := bitfarmApp.GetActivePreview.ActiveDoc.ScanPoolView.ImageCount;
        end
        else
        begin
          imgidx := bitfarmApp.GetActivePreview.SingleView.img_DocView.IO.Params.ImageIndex;
          imgcnt := bitfarmApp.GetActivePreview.SingleView.img_DocView.IO.Params.ImageCount;
        end;
      end;

      if (imgidx < imgcnt - 1) then
      begin
        UserAction := bitfarmApp.CreateUserAction;
        UserAction^.ActionName := 'actNextPage';
        UserAction^.Params.Add('0');
        UserAction^.Preview := bitfarmApp.GetActivePreview;
        bitfarmApp.MainThread.Add(UserAction);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'actNextPageExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actNextPageExecute', Classname);
  end;
end;

procedure TfrmGPL.actDeleteFavoriteExecute(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'actDeleteFavoriteExecute', Classname);
  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actDeleteTreeNode';
      UserAction^.Objects.Add(trvBookmarks.Selected);
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'actDeleteFavoriteExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actDeleteFavoriteExecute', Classname);
  end;
end;

procedure TfrmGPL.actDeleteFolderExecute(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'actDeleteFolderExecute', Classname);
  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actDeleteTreeNode';
      UserAction^.Objects.Add(trvBookmarks.Selected);
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'actDeleteFolderExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actDeleteFolderExecute', Classname);
  end;
end;

procedure TfrmGPL.actDeleteGlobalExecute(Sender: TObject);
var
  UserAction: PUserAction;
begin
  if not bitfarmApp.User.isAdmin then
    Exit;

  if not (TObject(trvBookmarks.Selected.Data) is TbfaNodeInfo) then
    Exit;

  bitfarmLog.DebugBegin(llDebug, 'actDeleteGlobalExecute', Classname);
  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actDeleteGlobalBookmark';
      UserAction^.Objects.Add(trvBookmarks.Selected);
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'actDeleteGlobalExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actDeleteGlobalExecute', Classname);
  end;
end;

procedure TfrmGPL.actDeleteLinkExecute(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'actDeleteLinkExecute', Classname);
  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actDeleteLink';
      UserAction^.Params.Add(fraDocLinks.lvwDocLink.Selected.Caption);
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'actDeleteLinkExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actDeleteLinkExecute', Classname);
  end;
end;

procedure TfrmGPL.actDeletePagesExecute(Sender: TObject);
var
  UserAction: PUserAction;
  i: Integer;
  Mr: TModalResult;
  Doc: TbfaBaseDocument;
  prev: TbfaPreview;
begin
  bitfarmLog.DebugBegin(llDebug, 'actDeletePagesExecute', Classname);
  try
    try
      prev := bitfarmApp.GetActivePreview;

      if (prev.ThumbnailThread <> nil) then
      begin
        if prev.GetThumbnailInProcess then
        begin
          frm_Message.Show;
          frm_Message.Update;
          Exit;
        end;
      end;

      if ((prev.List.Count > 0) and (prev.ThumbnailView.SelectedImage <> -1)) then
      begin
        if prev.PreviewKind = pvkSingle then
          Doc := prev.List[0]
        else
          Doc := prev.List[prev.MultiView.MultiSelectedImages[0]];

        if Doc.ID <> -1 then    //09.05.2018 Ticket 14499
          Mr := BfMessageDlg(_('Mchten Sie die ausgewhlten Seiten wirklich lschen?' + #10 + #13 + 'Die Notizen auf dieser Seite werden ebenfalls gelscht!'), mtConfirmation, [mbYes, mbNo], True)
        else
          Mr := mrYes;

        if (Mr = mrYes) then
        begin
          if prev.ThumbnailView.ImageCount = prev.ThumbnailView.MultiSelectedImagesCount then
          begin
            BfMessageDlg(_('Alle Seiten entfernen ist nicht mglich!'), mtError, [mbOK]);
          end
          else
          begin
            if (not Doc.GetInProcesses) then
            begin
              Doc.StartProcess;

              UserAction := bitfarmApp.CreateUserAction;
              UserAction^.ActionName := 'actDeletePages';
              UserAction^.Objects.Add(prev.ThumbnailView);
              UserAction^.Objects.Add(Doc);
              for i := prev.ThumbnailView.MultiSelectedImagesCount - 1 downto 0 do
              begin
                UserAction^.Params.Add(IntToStr(prev.ThumbnailView.MultiSelectedImages[i]));
              end;
              UserAction^.Preview := prev;
              UserAction^.Options := Mr;
              bitfarmApp.MainThread.Add(UserAction);
            end;
          end;
        end;
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'actDeletePagesExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actDeletePagesExecute', Classname);
  end;
end;

procedure TfrmGPL.actDeleteSelectedExecute(Sender: TObject);
var
  UserAction: PUserAction;
  i: Integer;
  Mr: TModalResult;
  prev: TbfaPreview;
begin
  bitfarmLog.DebugBegin(llDebug, 'actDeleteSelectedExecute', Classname);
  try
    try
      prev := bitfarmApp.GetActivePreview;

      if ((prev.List.Count > 0) and (prev.MultiView.MultiSelectedImagesCount <> 0)) then
      begin
          Mr := mrYes;

        if (Mr = mrYes) then
        begin
          UserAction := bitfarmApp.CreateUserAction;
          UserAction^.ActionName := 'actDeleteSelected';
          for i := (prev.MultiView.MultiSelectedImagesCount - 1) downto 0 do
          begin
            if (not prev.List[prev.MultiView.MultiSelectedImages[i]].GetInProcesses) then
            begin
              prev.List[prev.MultiView.MultiSelectedImages[i]].StartDeleteProcess;
              UserAction^.Params.Add(IntToStr(prev.MultiView.MultiSelectedImages[i]));
            end;
          end;
          UserAction^.Preview := prev;
          UserAction^.Options := Mr;
          bitfarmApp.MainThread.Add(UserAction);
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'actDeleteSelectedExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actDeleteSelectedExecute', Classname);
  end;
end;

procedure TfrmGPL.actEditTagsExecute(Sender: TObject);
var
  UserAction: PUserAction;
  i: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'actEditTagsExecute - ', Classname);
  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actEditTags';
      for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
      begin
        if bitfarmApp.CurrentContainer[i].InEditMode then
          UserAction^.Params.Add(InttoStr(bitfarmApp.CurrentContainer[i].ID));
      end;
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'actEditTagsExecute - ', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actEditTagsExecute - ', Classname);
  end;
end;

//procedure TfrmGPL.actDeleteSymbolicLinkExecute(Sender: TObject);
//var
//  UserAction: PUserAction;
//  Doc: TbfaDocument;
//  i: Integer;
//begin
//  bitfarmLog.DebugBegin(llDebug, 'actDeleteSymbolicLinkExecute', Classname);
//  try
//    try
//      UserAction := bitfarmApp.CreateUserAction;
//      UserAction^.ActionName := 'actDeleteSymbolicLink';
//      UserAction^.Documents := TList.Create;
//      for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
//      begin
//        Doc := TbfaDocument.Create;
//        Doc.Clone(bitfarmApp.CurrentContainer[i]);
//        UserAction^.Documents.Add(Doc);
//      end;
//      UserAction^.Preview := bitfarmApp.GetActivePreview;
//      bitfarmApp.MainThread.Add(UserAction);
//    except
//      bitfarmLog.Write(llNormal, ltException, 'actDeleteSymbolicLinkExecute', ClassName);
//    end;
//  finally
//    bitfarmLog.DebugEnd(llDebug, 'actDeleteSymbolicLinkExecute', Classname);
//  end;
//end;

procedure TfrmGPL.GetSetDocExecute(Sender: TObject; Idx: Integer);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, TAction(Sender).Name + IntToStr(Idx) + 'Execute');
  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := TAction(Sender).Name;
      UserAction^.Params.Add(IntToStr(Idx));
      UserAction^.Preview := nil;
      UserAction^.Options := -1;
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, TAction(Sender).Name + IntToStr(Idx) + 'Execute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, TAction(Sender).Name + IntToStr(Idx) + 'Execute');
  end;
end;

procedure TfrmGPL.GetLastDocExecute(Sender: TObject; Idx: Integer);
var
  UserAction: PUserAction;
begin
  bitfarmApp.Log.DebugBegin(llDebug, TAction(Sender).Name + IntToStr(Idx) + 'Execute');
  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := TAction(Sender).Name;
      UserAction^.Params.Add(IntToStr(Idx));
      UserAction^.Preview := nil;
      UserAction^.Options := -1;
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmApp.Log.Write(llNormal, ltException, TAction(Sender).Name + IntToStr(Idx) + 'Execute', ClassName);
    end;
  finally
    bitfarmApp.Log.DebugEnd(llDebug, TAction(Sender).Name + IntToStr(Idx) + 'Execute');
  end;
end;

procedure TfrmGPL.actGetDoc1Execute(Sender: TObject);
begin
  GetSetDocExecute(Sender, 1);
end;

procedure TfrmGPL.actGetDoc2Execute(Sender: TObject);
begin
  GetSetDocExecute(Sender, 2);
end;

procedure TfrmGPL.actGetDoc3Execute(Sender: TObject);
begin
  GetSetDocExecute(Sender, 3);
end;

procedure TfrmGPL.actGetDoc4Execute(Sender: TObject);
begin
  GetSetDocExecute(Sender, 4);
end;

procedure TfrmGPL.actGetDoc5Execute(Sender: TObject);
begin
  GetSetDocExecute(Sender, 5);
end;

procedure TfrmGPL.actGetLastDocumentExecute(Sender: TObject);
begin
  GetLastDocExecute(Sender, 0);
end;

procedure TfrmGPL.actHideIndexingExecute(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'actHideIndexingExecute', Classname);
  try
    try
      bitfarmApp.Log.Debug(llDebug, 'actHideIndexingExecute doIndexing', ClassName);

      // Ticket 14138: Nach Rcksprache mit HS sollen beim Verlassen der Verschlagwortungshilfe
      //               die eingegebenen Werte stehen bleiben. Also kein Clearen der Felder
      // actClearFields.Execute;

      bitfarmApp.FShowIndexingWithLimit := False;

      if bitfarmApp.GetActivePreview <> bitfarmApp.PreviewContainer.ImporterItem.Preview then
        bitfarmApp.ViewerShowIndexing := False
      else
        bitfarmApp.ImporterShowIndexing := False;

      if bitfarmApp.ViewerUseIndexing or bitfarmApp.ImporterUseIndexing then
        btnIndexingClick(Sender)
      else
        grpIndexing.Visible := False;

      mnuIndexing.Action := actShowIndexing;
      mnuIndexingWithLimit.Visible := True;
    except
      bitfarmLog.Write(llNormal, ltException, 'actHideIndexingExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actHideIndexingExecute', Classname);
  end;
end;

procedure TfrmGPL.actInProgressExecute(Sender: TObject);
var
  UserAction: PUserAction;
  i: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'actInProgressExecute', Classname);
  try
    try
      if (bitfarmApp.CurrentContainer.Count > 0) and (bitfarmApp.CurrentContainer[0] <> nil) then
      begin
        UserAction := bitfarmApp.CreateUserAction;
//15.09.2020        if ((clItemInProgress.Color = (*31.08.2020 Farben Anpassung clWhite*)cColorWhite)
        if ((clItemInProgress.ImageIndex = Integer(icoidx_edit_unselected))
        and (not bitfarmApp.CurrentContainer[0].InEditMode)) then
        begin
          UserAction^.ActionName := 'actInProgress';
          for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
            UserAction^.Documents.Add(bitfarmApp.CurrentContainer[i]);
          UserAction^.Preview := bitfarmApp.GetActivePreview;
        end
//15.09.2020        else if clItemInProgress.Color = gclLime then
        else if clItemInProgress.ImageIndex = Integer(icoidx_edit_enabled) then
        begin
          if bitfarmApp.CurrentContainer[0].EditmodeUserID = bitfarmApp.User.ID then
          begin
            UserAction^.ActionName := 'actSave';
            UserAction^.Preview := bitfarmApp.GetActivePreview;
          end
          else if bitfarmApp.CurrentContainer[0].EditmodeUserID <> 0 then
            frmMainForm.popInEditmode.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y)
          else
            UserAction^.ActionName := 'actCancel';
        end;
        if UserAction^.ActionName <> '' then
          bitfarmApp.MainThread.Add(UserAction);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'actInProgressExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actInProgressExecute', Classname);
  end;
end;

procedure TfrmGPL.actInsertExecute(Sender: TObject);
var
  AComp: TbfaAddfieldComp;
begin
  try
  bitfarmLog.DebugBegin(llDebug, 'actInsertExecute', Classname);
    try
      if (Screen.ActiveControl.Parent.Parent is TbfaAddfieldComp) then
      begin
        AComp := TbfaAddfieldComp(Screen.ActiveControl.Parent.Parent);

        if (Screen.ActiveControl.Parent is TcxDateEdit) then
        begin
          if (TcxDateEdit(Screen.ActiveControl.Parent).Text = '') then
          begin
            TcxDateEdit(Screen.ActiveControl.Parent).Date := Today;
            TcxDateEdit(Screen.ActiveControl.Parent).PostEditValue;
            Exit;
          end else if (TcxDateEdit(Screen.ActiveControl.Parent).Text <> '') then
          begin
            TcxDateEdit(Screen.ActiveControl.Parent).PostEditValue;
            if (Screen.ActiveControl.Parent = AComp.comp) then
            begin
              if not TcxDateEdit(AComp.comp2).Enabled then
                Exit;
              TcxDateEdit(AComp.comp2).Date := TcxDateEdit(AComp.comp).Date;
              TcxDateEdit(AComp.comp2).PostEditValue;
              TcxDateEdit(AComp.comp).PostEditValue;
              TcxDateEdit(AComp.comp2).SetFocus;
            end else if (Screen.ActiveControl.Parent = AComp.comp2) then
            begin
              if not TcxDateEdit(AComp.comp).Enabled then
                Exit;
              TcxDateEdit(AComp.comp).Date := TcxDateEdit(AComp.comp2).Date;
              TcxDateEdit(AComp.comp).PostEditValue;
              TcxDateEdit(AComp.comp2).PostEditValue;
              TcxDateEdit(AComp.comp).SetFocus;
            end;
          end;
        end
        else if (Screen.ActiveControl.Parent is TbfaSpinEdit) then
        begin
          if (TbfaSpinEdit(Screen.ActiveControl.Parent).Text <> '') then
          begin
            TbfaSpinEdit(Screen.ActiveControl.Parent).PostEditValue;
            if (Screen.ActiveControl.Parent = AComp.comp) then
            begin
              if not TbfaSpinEdit(AComp.comp2).Enabled then
                Exit;
              TbfaSpinEdit(AComp.comp2).Text := TbfaSpinEdit(AComp.comp).Text;
              TbfaSpinEdit(AComp.comp2).PostEditValue;
              TbfaSpinEdit(AComp.comp).PostEditValue;
              TbfaSpinEdit(AComp.comp2).SetFocus;
            end else if (Screen.ActiveControl.Parent = AComp.comp2) then
            begin
              if not TbfaSpinEdit(AComp.comp).Enabled then
                Exit;
              TbfaSpinEdit(AComp.comp).Text := TbfaSpinEdit(AComp.comp2).Text;
              TbfaSpinEdit(AComp.comp).PostEditValue;
              TbfaSpinEdit(AComp.comp2).PostEditValue;
              TbfaSpinEdit(AComp.comp).SetFocus;
            end;
          end;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'actInsertExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actInsertExecute', Classname);
  end;
end;

procedure TfrmGPL.actAltNExecute(Sender: TObject);
begin
  try
    try
      bitfarmLog.DebugBegin(llDebug, 'actAltNExecute', Classname);
      if (Screen.ActiveControl.Parent <> nil) and
         (Screen.ActiveControl.Parent.Parent <> nil) and
         (Screen.ActiveControl.Parent.Parent is TbfaAddfieldComp) and
         (TBfaAddfieldComp(Screen.ActiveControl.Parent.Parent).cliNeg.Visible = True) then
      begin
        TBfaAddfieldComp(Screen.ActiveControl.Parent.Parent).cliNeg.Click;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'actAltNExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actAltNExecute', Classname);
  end;
end;

procedure TfrmGPL.actLanguageExecute(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmApp.Lang := bitfarmApp.GetLangNativeNameById(actLanguage.Tag);

  bitfarmLog.Write(llDebug, ltInfo, 'bitfarmApp.Lang: ' + bitfarmApp.Lang, ClassName);

  UserAction := bitfarmApp.CreateUserAction;
  UserAction^.ActionName := 'actLanguageXX';
  UserAction^.Params.Add(bitfarmApp.Lang);
  bitfarmApp.MainThread.Add(UserAction);
end;

procedure TfrmGPL.actLanguageDEExecute(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmApp.Lang := 'de';
  UserAction := bitfarmApp.CreateUserAction;
  UserAction^.ActionName := 'actLanguageXX';
  UserAction^.Params.Add(bitfarmApp.Lang);
  bitfarmApp.MainThread.Add(UserAction);
end;

procedure TfrmGPL.actLanguageENExecute(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmApp.Lang := 'en';
  UserAction := bitfarmApp.CreateUserAction;
  UserAction^.ActionName := 'actLanguageXX';
  UserAction^.Params.Add(bitfarmApp.Lang);
  bitfarmApp.MainThread.Add(UserAction);
end;

procedure TfrmGPL.actLastPageExecute(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'actLastPageExecute', Classname);
  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actLastPage';
      UserAction^.Params.Add('0');
      UserAction^.Preview := bitfarmApp.GetActivePreview;
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'actLastPageExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actLastPageExecute', Classname);
  end;
end;

procedure TfrmGPL.SetEmptyDocItem(Caption: string);
begin
  for var i := 0 to tbsubCreateEmptyDoc.Count -1 do
  begin
    if UpperCase(tbsubCreateEmptyDoc.Items[i].Caption) = UpperCase(Caption) then
    begin
      tbsubCreateEmptyDoc.Items[i].Checked := True;
      tbsubCreateEmptyDoc.Caption := Format(_(sCaptionNewDocument) + ' (%s)',[Caption]);
    end else
      tbsubCreateEmptyDoc.Items[i].Checked := False;
  end;
  for var i := 0 to mnuCreateEmptyDoc.Count -1 do
  begin
    if UpperCase(mnuCreateEmptyDoc.Items[i].Caption) = UpperCase(Caption) then
    begin
      mnuCreateEmptyDoc.Items[i].Checked := True;
      actCreateEmptyDoc.Hint := Format(_(sCaptionNewDocument) + ' (%s)',[Caption]);
    end else
      mnuCreateEmptyDoc.Items[i].Checked := False;
  end;
end;

procedure TfrmGPL.EmptyDocItemClick(Sender: TObject);
begin
  bitfarmApp.currentEmptyDoc := TSpTBXItem(Sender).Caption;
  SetEmptyDocItem(bitfarmApp.currentEmptyDoc);
  actCreateEmptyDoc.Execute;
end;

function TfrmGPL.SetExportStateFields(Select: WideString): WideString;
var
  i: Integer;
  col: WideString;
begin
  try
    if VarIsNull(Select) then
      Select := '';

    Result := Select;
    for i := 0 to aCurrentStatefields.Count - 1 do
    begin
      col := 'docstate_' + IntToStr(aCurrentStatefields[i].IndexColumnID);
      if (Pos(col, Result) = 0) then
        Result := Result + ',' + col;
    end;
  except
    Result := Select
  end;
end;

procedure TfrmGPL.actListExecute(Sender: TObject);
var
  UserAction: PUserAction;
  OpenDlg: TOpenDialog;
  i, j, symlinks: Integer;
  lsfname: string;
  SObj: TbfaSearch;
  StsField: TbfaStateField;
  found : Boolean;
  Doc: TbfaDocument;
begin
  bitfarmLog.DebugBegin(llDebug, 'actListExecute');

  // hier ist die zentrale Stelle, wo (fast) jeder Funktionsaufruf beginnt
  // sollten wir Annotations haben, die noch nicht im Stream gespeichert sind,
  // wre das wahrscheinlich die beste Stelle dies zu tun

  Screen.Cursor := crDefault;

  UserAction := bitfarmApp.CreateUserAction;
  UserAction^.ActionName := TAction(Sender).Name;
  bitfarmLog.Debug(llDebug, 'Action:' + UserAction^.ActionName);
  UserAction^.Preview := bitfarmApp.GetActivePreview;
  UserAction^.Options := -1;

//21.02.2024 bfacrm:ticket__show__29722 -->
  if (UserAction^.ActionName = 'actLocalSaveTIF') or (UserAction^.ActionName = 'actGoToSourceArchive') or (UserAction^.ActionName = 'actChangeDocName') then
  begin
    if (bitfarmApp.GetActivePreview.SingleView.img_DocView.SelObjectsCount = 1) and //funktioniert nur beim einem Objekt
       (bitfarmApp.GetActivePreview.SingleView.img_DocView.ObjTextEditMode <> -1)  //muss auch in Editmode sein
    then
    begin
      if Assigned(bitfarmApp.GetActivePreview.SingleView.img_DocView.MemoEdit) then
      begin
        if (UserAction^.ActionName = 'actLocalSaveTIF') then
          bitfarmApp.GetActivePreview.SingleView.img_DocView.MemoEdit.InsertAlign(iejLeft)
        else if (UserAction^.ActionName = 'actChangeDocName') then
          bitfarmApp.GetActivePreview.SingleView.img_DocView.MemoEdit.InsertAlign(iejRight)
        else if (UserAction^.ActionName = 'actGoToSourceArchive') then
        begin
          var fnt: TFont;
          fnt := bitfarmApp.GetActivePreview.SingleView.img_DocView.MemoEdit.DefaultFont;
          if (TFontStyle.fsUnderline in fnt.Style) then
            fnt.Style := fnt.Style - [fsUnderline]
          else
            fnt.Style := fnt.Style + [fsUnderline];
          bitfarmApp.GetActivePreview.SingleView.img_DocView.MemoEdit.SetXFont(fnt);
        end;
        bitfarmApp.GetActivePreview.SingleView.img_DocView.MemoEdit.Update;
        Exit;
      end;
    end;
  end;
//21.02.2024 bfacrm:ticket__show__29722 <--

  if UserAction^.Preview <> nil then
  begin
    UserAction^.Preview.SingleView.img_DocView.Cursor := 0;
    UserAction^.Preview.SingleView.img_DocView.MouseInteractVt := [];

    if UserAction^.Preview.SingleView.gbAnnoNotSaved then
      UserAction^.Preview.SingleView.saveannostream;

//25.04.2019 hier muss in anderen previews auch aktualisiert werden-->
    if UserAction^.Preview.SingleView.fRefreshInOtherPrevs then
    begin
      bitfarmApp.CreateRefreshDocumentInPreviewsAction(UserAction^.Preview.ActiveDoc,
        UserAction^.Preview, nil, False, False); //25.04.2019 von saveannostream raus, hier rein!
      UserAction^.Preview.SingleView.fRefreshInOtherPrevs := False;
    end;
//25.04.2019 <--
  end;

//////////////////////////////////////////////////////////// Preview Actions -->
  if UserAction^.ActionName = 'actGraphicOptions' then
    UserAction^.Preview.actGraphicOptions.Execute

//////////////////////////////////////////////////////////// Preview Actions <--
  else if Pos('actChangeProfile',UserAction^.ActionName) = 1 then
  begin
    i := TAction(Sender).Tag;
    UserAction^.Params.AddObject(TAction(Sender).Caption, TObject(i));
    bitfarmApp.MainThread.Add(UserAction);
  end
  else if UserAction^.ActionName = 'actPrintStandard' then
    bitfarmApp.CreatePrintStandardAction(UserAction, False, False)
  else if UserAction^.ActionName = 'actPrintSelect' then
  begin
    //wir nutzen actPrintPreview statt actPrintSelect!
  end
  else if UserAction^.ActionName = 'actPrintPreview' then
    bitfarmApp.CreatePrintPreviewAction(UserAction, False)
  else if UserAction^.ActionName = 'actEmailTIFAttachment' then
    bitfarmApp.CreateEmailAttachmentAction(UserAction, False, sftTIF)
  else if UserAction^.ActionName = 'actEmailPDFAttachment' then
    bitfarmApp.CreateEmailAttachmentAction(UserAction, False, sftPDF)
  else if UserAction^.ActionName = 'actEmailOriginal' then
    bitfarmApp.CreateEmailOriginalAction(UserAction, False)
  else if UserAction^.ActionName = 'actEmailLink' then
  begin
    bitfarmApp.BackThread.Add(UserAction);
  end
  else if (UserAction^.ActionName = 'actEmailPreview') then
    bitfarmApp.CreateEmailPreviewAction(UserAction, False)
  else if (UserAction^.ActionName = 'actLocalSavePreview') then
    bitfarmApp.CreateLocalSavePreviewAction(UserAction, False)
  else if (UserAction^.ActionName = 'actLocalSavePDF') then
    bitfarmApp.CreateLocalSavePDFAction(UserAction, False)
  else if (UserAction^.ActionName = 'actLocalSaveTIF') then
      bitfarmApp.CreateLocalSaveTIFAction(UserAction, False)
  else if (UserAction^.ActionName = 'actLocalSaveLink') then
  begin
    if (bitfarmApp.GetActivePreview <> nil) and not bitfarmApp.GetActivePreview.Floating then
    begin
//14.10.2019      frmMainForm.MainMenu.mnuLocalSave.ImageIndex := frmMainForm.actLocalSaveLink.ImageIndex;
//      frmMainForm.MainMenu.mnuLocalSave.Action := frmMainForm.actLocalSaveLink;
//      frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItem1.Action := frmMainForm.actLocalSaveLink;
      frmMainForm.mnuLocalSave.ImageIndex := bitfarmApp.GetActivePreview.actLocalSaveLink.ImageIndex;
      frmMainForm.mnuLocalSave.Action := bitfarmApp.GetActivePreview.actLocalSaveLink;
      frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action := bitfarmApp.GetActivePreview.actLocalSaveLink;
    end;
    bitfarmApp.CloneCurrentDocs(UserAction, False);
    bitfarmApp.BackThread.Add(UserAction)
  end
  else if (UserAction^.ActionName = 'actLocalSaveOriginal') then
    bitfarmApp.CreateLocalSaveOriginalAction(UserAction, False)
  else if (UserAction^.ActionName = 'actExportCSV') or (UserAction^.ActionName = 'actExportXLS') or (UserAction^.ActionName = 'actExportOO') then
  begin
    if (UserAction^.ActionName = 'actExportCSV') then
    begin
      if not PromptForFileName(lsfname, 'CSV|*.CSV', 'csv', 'Wie soll die Offline-Datei heien?', '', True) then
      begin
        Dispose(UserAction);
        exit;
      end;
      UserAction^.Params.Add(lsfname);
    end
    else
      UserAction^.Params.Add('');
    SObj := TbfaSearch.Create;
//30.05.2017 Ticket 10703    SObj.Clone(bitfarmApp.FSearchObj);
    SObj.Clone(FSearchthread.SearchObj);
    UserAction^.Objects.Add(SObj);
    for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do // die ausgewhlte Dokumente
      SObj.GdocID.Add(IntToStr(bitfarmApp.CurrentContainer[i].ID));
    SObj.SelectedCols := SetExportStateFields(SObj.SelectedCols);
    for i := 0 to aCurrentStatefields.Count - 1 do
    begin
      StsField := TbfaStateField.Create;
      StsField.Clone(aCurrentStatefields[i]);
      UserAction^.Objects.Add(StsField);
    end;
    bitfarmApp.BackThread.Add(UserAction);
  end
  else if UserAction^.ActionName = 'actGoToOriginalDocument' then
  begin
    bitfarmApp.CloneCurrentDocs(UserAction, True);
    bitfarmApp.MainThread.Add(UserAction);
  end
  else if UserAction^.ActionName = 'actShowAllSymbolicLinks' then
  begin
    bitfarmApp.CloneCurrentDocs(UserAction, True);
    bitfarmApp.MainThread.Add(UserAction);
  end
  else if UserAction^.ActionName = 'actDeleteDoc' then
  begin
    bitfarmApp.CloneCurrentDocs(UserAction, False, rightDelete);
    bitfarmApp.MainThread.Add(UserAction);
  end
  else if UserAction^.ActionName = 'actGoToSourceArchive' then
  begin
    bitfarmApp.CloneCurrentDocs(UserAction, True);
    UserAction^.Params.Add(IntToStr(bitfarmApp.CurrentContainer[0].SymbolicArcID));
    bitfarmApp.MainThread.Add(UserAction);
  end
  else if UserAction^.ActionName = 'actArchive' then
  begin
    UserAction^.Params.Add('0');
    bitfarmApp.MainThread.Add(UserAction);
  end
  else if UserAction^.ActionName = 'actArchiveWithDD' then
  begin
    UserAction^.Params.Add('1');
    bitfarmApp.MainThread.Add(UserAction);
  end
  else if (UserAction^.ActionName = 'actResetDLM') then
  begin
    UserAction^.Params.Delimiter := ';';
    UserAction^.Params.StrictDelimiter := True;
    for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
      UserAction^.Params.Add(IntToStr(bitfarmApp.CurrentContainer[i].ID));

    bitfarmApp.MainThread.Add(UserAction);
  end
  else if (UserAction^.ActionName = 'actDuplicateDoc') then
  begin
    symlinks := 0;
    UserAction^.Params.Delimiter := ';';
    UserAction^.Params.StrictDelimiter := True;
    for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
    begin
      if bitfarmApp.CurrentContainer[i].SymbolicArcID = -1 then
        UserAction^.Params.Add(IntToStr(bitfarmApp.CurrentContainer[i].ID) +','+ IntToStr(bitfarmApp.CurrentContainer[i].arcid) +
                              ',' + IntToStr(bitfarmApp.CurrentContainer[i].arcid))
      else
        inc(symlinks);
    end;

    if symlinks > 0 then
    begin
      if UserAction^.Params.Count = 0 then
      begin
        BfShowMessage(_('SymbolicLinks knnen nicht dupliziert werden.'));
        Dispose(UserAction);
        Exit;
      end else begin
        if symlinks = 1 then
          BfShowMessage(_('In der Auswahl war ein SymbolicLink, diese knnen nicht dupliziert werden.'))
        else
          BfShowMessage(Format(_('In der Auswahl waren %d SymbolicLinks, diese knnen nicht dupliziert werden.'), [symlinks]));
      end;
    end;

    if frmMainForm.bfaTlbPreview1.mnuPublicAnno.Checked then
      UserAction^.Params.Add('public');
    bitfarmApp.MainThread.Add(UserAction);
  end
  else if (UserAction^.ActionName = 'actInResub') then
  begin
    if TMouseButton(actInResub.Tag) = mbRight then
      UserAction^.Params.Add('1');
    bitfarmApp.MainThread.Add(UserAction);
  end
  else if ((UserAction^.ActionName = 'actLoadFile') or (UserAction^.ActionName = 'actWPLoad')) then
  begin
    OpenDlg := TOpenDialog.Create(nil);
    try
      OpenDlg.Options := [ofAllowMultiSelect];
      if not OpenDlg.Execute then
      begin
        bitfarmLog.Write(llNormal, ltInfo, 'LoadFile End via Exit #2', ClassName);
        UserAction^.Params.Free;
        Dispose(UserAction);
        Exit;
      end;

      var FileObj : TbfaFileObj; //02.03.2021 wegen Dateigre
      for i := 0 to OpenDlg.Files.Count - 1 do
//02.03.2021 -->
      begin
//      wo mglich ist wird auch die Dateigre mitgeliefert, deswegen als Object hier
//      UserAction^.Params.Add(OpenDlg.Files[i]);
        FileObj := TbfaFileObj.Create;
        FileObj.FileName := OpenDlg.Files[i];
        FileObj.FileSize := round(FileSize(OpenDlg.Files[i]) / 1024);
        UserAction^.Params.AddObject(IntToStr(i), FileObj);
      end;
//02.03.2021 <--
      UserAction^.Options := DROPEFFECT_COPY;
      bitfarmApp.MainThread.Add(UserAction);
    finally
      OpenDlg.Free;
    end;
  end
  else if (UserAction^.ActionName = 'actCollectDocs') then
  begin
    for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
    begin
      found := False;
      for j := 0 to bitfarmApp.CollectionContainer.Count -1 do
      begin
        if bitfarmApp.CurrentContainer[i].ID = bitfarmApp.CollectionContainer[j].ID then
        begin
          found := True;
          Break;
        end;
      end;
      if not found then
      begin
        Doc := TbfaDocument.Create;
        Doc.Clone(bitfarmApp.CurrentContainer[i]);
        bitfarmApp.CollectionContainer.Add(Doc);
      end;
    end;

    SetCollectionsCaptions;

  end
  else if (UserAction^.ActionName = 'actCancelCollection') then
  begin
    for i := bitfarmApp.CollectionContainer.Count -1 downto 0 do
    begin
      try
        bitfarmApp.CollectionContainer[i] := nil;
        bitfarmApp.CollectionContainer.Delete(i);
      except

      end;
    end;

    SetCollectionsCaptions;

  end
  else if (UserAction^.ActionName = 'actSaveCollectionPDF') then
  begin
    mnuSaveCollection.Action := actSaveCollectionPDF;
    bitfarmApp.CreateLocalSaveAction(UserAction, False);
    SetCollectionsCaptions;
  end
  else if (UserAction^.ActionName = 'actSaveCollectionSinglePDF') then
  begin
    mnuSaveCollection.Action :=  actSaveCollectionSinglePDF;
    bitfarmApp.CreateLocalSaveAction(UserAction, False);
    SetCollectionsCaptions;
  end
  else if (UserAction^.ActionName = 'actSaveCollectionTIF') then
  begin
    mnuSaveCollection.Action :=  actSaveCollectionTIF;
    bitfarmApp.CreateLocalSaveAction(UserAction, False);
    SetCollectionsCaptions;
  end
  else if (UserAction^.ActionName = 'actSaveCollectionOriginal') then
  begin
    mnuSaveCollection.Action :=  actSaveCollectionOriginal;
    bitfarmApp.CreateLocalSaveAction(UserAction, False);
    SetCollectionsCaptions;
  end
  else if (UserAction^.ActionName = 'actEmailCollectionTIF') then
  begin
    mnuEmailCollection.Action := actEmailCollectionTIF;
    bitfarmApp.CreateEmailCollectionAction(UserAction);
    SetCollectionsCaptions;
  end
  else if (UserAction^.ActionName = 'actEmailCollectionPDF') then
  begin
    mnuEmailCollection.Action := actEmailCollectionPDF;
    bitfarmApp.CreateEmailCollectionAction(UserAction);
    SetCollectionsCaptions;
  end
  else if (UserAction^.ActionName = 'actEmailCollectionSinglePDF') then
  begin
    mnuEmailCollection.Action := actEmailCollectionSinglePDF;
    bitfarmApp.CreateEmailCollectionAction(UserAction);
    SetCollectionsCaptions;
  end
  else if (UserAction^.ActionName = 'actEmailCollectionOriginal') then
  begin
    mnuEmailCollection.Action := actEmailCollectionOriginal;
    bitfarmApp.CreateEmailCollectionAction(UserAction);
    SetCollectionsCaptions;
  end
  else if (UserAction^.ActionName = 'actZoomIn1') or (UserAction^.ActionName = 'actZoomIn2') then
  begin
    if (UserAction^.Preview.ActiveView = avDocument) then
      UserAction^.Preview.SingleView.ZoomIn
    else if (UserAction^.Preview.ActiveView = avFulltext) then
      bitfarmApp.ActFulltextZoom(UserAction);
  end
  else if (UserAction^.ActionName = 'actZoomOut1') or (UserAction^.ActionName = 'actZoomOut2') then
  begin
    if (UserAction^.Preview.ActiveView = avDocument) then
      UserAction^.Preview.SingleView.ZoomOut
    else if (UserAction^.Preview.ActiveView = avFulltext) then
      bitfarmApp.ActFulltextZoom(UserAction);
  end
  else if (UserAction^.ActionName = 'actScrollLeft') then
    UserAction^.Preview.SingleView.ScrollLeft
  else if (UserAction^.ActionName = 'actScrollRight') then
    UserAction^.Preview.SingleView.ScrollRight
  else if (UserAction^.ActionName = 'actScrollUp') then
  begin
  // TODO SJ IFNDEF DEVEXADDFIELDS
    if (Screen.ActiveControl is TcxCustomComboBoxInnerEdit) then
      TbfaComboBox(Screen.ActiveControl.Parent).DroppedDown := (not TbfaComboBox(Screen.ActiveControl.Parent).DroppedDown)
    else if (Screen.ActiveControl.Parent <> nil) and (Screen.ActiveControl.Parent is TbfaCheckedCombo) then
      TbfaCheckedCombo(Screen.ActiveControl.Parent).Properties.OnButtonClick(nil, 0)
  else
      UserAction^.Preview.SingleView.ScrollUp;
  end
  else if (UserAction^.ActionName = 'actScrollDown') then
  begin
  // TODO SJ IFNDEF DEVEXADDFIELDS
    if (Screen.ActiveControl is TcxCustomComboBoxInnerEdit) then
      TbfaComboBox(Screen.ActiveControl.Parent).DroppedDown := (not TbfaComboBox(Screen.ActiveControl.Parent).DroppedDown)
    else if (Screen.ActiveControl.Parent <> nil) and (Screen.ActiveControl.Parent is TbfaCheckedCombo) then
      TbfaCheckedCombo(Screen.ActiveControl.Parent).Properties.OnButtonClick(nil, 0)
    else
      UserAction^.Preview.SingleView.ScrollDown;
  end
  else
    bitfarmApp.MainThread.Add(UserAction);

  bitfarmLog.DebugEnd(llDebug, 'actListExecute');
end;

procedure TfrmGPL.actMergeDocExecute(Sender: TObject);
var
  UserAction: PUserAction;
  i, idx, j, k: Integer;
  found, CanMerge, haspreview : Boolean;
  NewDoc: TbfaDocument;
  AnnoObj: TbfaAnnotation;
begin
  bitfarmLog.DebugBegin(llDebug, 'actMergeDocExecute', Classname);
  try
    try
      frmSplash.lblLoading.Caption := _('Die Dokumente werden vorbereitet...');
      frmSplash.Update;
      frmSplash.Show;
      try
        haspreview := True;
        for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
        begin
          if not bitfarmApp.CurrentContainer[i].HasPreview then
          begin
            haspreview := false;
            Break;
          end;
        end;

        if (not haspreview) then
        begin
          BfMessageDlg(_('Fehler beim Zusammenfhren der Dokumente. Es knnen nur Dokumente vom Typ TIF zusammengefhrt werden'),
                    mtError, [mbOK]);
          Exit;
        end;

        CanMerge := True;
        for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
        begin
          if bitfarmApp.CurrentContainer[i].ID <> -1 then
          begin
            found := True;
            Break;
          end;
        end;

        if found then
          CanMerge := (BfMessageDlg(_('Hierdurch wird ein neues Dokument erzeugt.') +
            #13#10 + _(' Mchten Sie trotzdem fortfahren?'), mtWarning, [mbYes, mbNo], True, _('Hinweis')) = mrYes);

        if CanMerge then
        begin
          if (bitfarmApp.GetActivePreview = bitfarmApp.PreviewContainer.WorkplaceItem.Preview) or (bitfarmApp.GetActivePreview = bitfarmApp.PreviewContainer.ImporterItem.Preview) then
          begin
            for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
            begin
              frmmainform.frmSplash.update;
              if bitfarmApp.CurrentContainer[i].ID <> -1 then
              begin
  //28.03.2017              bitfarmApp.CurrentContainer[i].ID := -1;

  //28.03.2017 Ticket 10252 -->

                NewDoc := TbfaDocument.Create;
                NewDoc.DocStream.Position := 0;
                bitfarmApp.CurrentContainer[i].DocStream.Position := 0;
                NewDoc.DocStream.CopyFrom(bitfarmApp.CurrentContainer[i].DocStream, bitfarmApp.CurrentContainer[i].DocStream.Size);
                for k := 0 to bitfarmApp.CurrentContainer[i].Annotations.Count - 1 do
                begin
                  AnnoObj := TbfaAnnotation.Create;
                  AnnoObj.Clone(bitfarmApp.CurrentContainer[i].Annotations[k]);
                  NewDoc.Annotations.Add(AnnoObj);
                end;
                NewDoc.HasPreview := bitfarmApp.CurrentContainer[i].HasPreview;

                bitfarmApp.CurrentContainer[i].Reset;
                bitfarmApp.CurrentContainer[i].Clone(NewDoc);
  //28.03.2017 Ticket 10252 <--

              end;
            end;
          end;

          UserAction := bitfarmApp.CreateUserAction;
          UserAction^.ActionName := 'actMergeDoc';
          bitfarmApp.CloneCurrentDocs(UserAction, False, rightModify);
          UserAction^.Preview := bitfarmApp.GetActivePreview;
          idx := bitfarmApp.GetActivePreview.MultiView.MultiSelectedImages[0];
          if idx = -1 then
          begin
            for i := 0 to bitfarmApp.GetActivePreview.List.Count - 1 do
            begin
              for j := 0 to bitfarmApp.CurrentContainer.Count - 1 do
              begin
                if bitfarmApp.CurrentContainer[j] = bitfarmApp.GetActivePreview.List[i] then
                begin
                  if j = 0 then
                    UserAction^.Options := i;
                  UserAction^.Params.add(IntToStr(i));
                end;
              end;
            end;
          end
          else
          begin
            UserAction^.Options := idx;
            for i := 0 to bitfarmApp.GetActivePreview.MultiView.MultiSelectedImagesCount - 1 do
              UserAction^.Params.add(IntToStr(bitfarmApp.GetActivePreview.MultiView.MultiSelectedImages[i]));
          end;

          UserAction^.SList.Add(IntToStr(bitfarmApp.GetActivePreview.MultiView.ImageX[idx]));
          UserAction^.SList.Add(IntToStr(bitfarmApp.GetActivePreview.MultiView.ImageY[idx]));

          bitfarmApp.MainThread.Add(UserAction);
        end;
      finally
        frmSplash.Hide;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'actMergeDocExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actMergeDocExecute', Classname);
  end;
end;

procedure TfrmGPL.actPreviousPageExecute(Sender: TObject);
var
  UserAction: PUserAction;
  imgidx: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'actPreviousPageExecute', Classname);
  try
    try
      if (bitfarmApp.GetActivePreview <> nil) and (bitfarmApp.GetActivePreview.ActiveDoc <> nil) then
      begin
        if (bitfarmApp.GetActivePreview.ActiveDoc <> nil) and
           (bitfarmApp.GetActivePreview.ActiveDoc.ScanPoolView <> nil) and
           (bitfarmApp.GetActivePreview.ActiveDoc.ScanPoolViewLoaded) then
        begin
        // SJ 28.09.2022 - wurde wohl von Preview hier her verschoben...
        // Self.Owner ist kein TbfaPreview mehr
//          imgidx := TbfaPreview(Self.Owner).ActivePage;
          imgidx := bitfarmApp.GetActivePreview.ActivePage;
        end
        else
        begin
          imgidx := bitfarmApp.GetActivePreview.SingleView.img_DocView.IO.Params.ImageIndex;
        end;
      end;

      if (imgidx > 0) then
      begin
        UserAction := bitfarmApp.CreateUserAction;
        UserAction^.ActionName := 'actPreviousPage';
        UserAction^.Params.Add('0');
        UserAction^.Preview := bitfarmApp.GetActivePreview;
        bitfarmApp.MainThread.Add(UserAction);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'actPreviousPageExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actPreviousPageExecute', Classname);
  end;
end;

procedure TfrmGPL.actPrivateAnnoExecute(Sender: TObject);
var
  UserAction: PUserAction;
  prev: TbfaPreview;
begin
  bitfarmLog.DebugBegin(llDebug, 'actPrivateAnnoExecute', Classname);
  try
    try
      prev := bitfarmApp.GetActivePreview;

      prev.bfaTlbPreview.mnuPrivateAnno.Checked := not prev.bfaTlbPreview.mnuPrivateAnno.Checked;
      if prev.bfaTlbPreview.mnuPrivateAnno.Checked then
        prev.bfaTlbPreview.mnuPublicAnno.Checked := False;

      if not prev.Floating then
      begin
        frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Checked := prev.bfaTlbPreview.mnuPrivateAnno.Checked;
        frmMainForm.bfaTlbPreview1.mnuPublicAnno.Checked := prev.bfaTlbPreview.mnuPublicAnno.Checked;
      end;

      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actPrivateAnno';
      UserAction^.Preview := prev;
      UserAction^.Params.Add(IntToStr(bitfarmApp.User.ID));
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'actPrivateAnnoExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actPrivateAnnoExecute', Classname);
  end;
end;

procedure TfrmGPL.actPublicAnnoExecute(Sender: TObject);
var
  UserAction: PUserAction;
  prev: TbfaPreview;
begin
  bitfarmLog.DebugBegin(llDebug, 'actPublicAnnoExecute', Classname);
  try
    try
      prev := bitfarmApp.GetActivePreview;

      prev.bfaTlbPreview.mnuPublicAnno.Checked := not prev.bfaTlbPreview.mnuPublicAnno.Checked;
      if prev.bfaTlbPreview.mnuPublicAnno.Checked then
        prev.bfaTlbPreview.mnuPrivateAnno.Checked := False;

      if not prev.Floating then
      begin
        frmMainForm.bfaTlbPreview1.mnuPublicAnno.Checked := prev.bfaTlbPreview.mnuPublicAnno.Checked;
        frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Checked := prev.bfaTlbPreview.mnuPrivateAnno.Checked;
      end;

      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actPublicAnno';
      UserAction^.Preview := prev;
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'actPublicAnnoExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actPublicAnnoExecute', Classname);
  end;
end;

procedure TfrmGPL.actQuitExecute(Sender: TObject);
begin
  frmMainForm.Close;
end;

procedure TfrmGPL.actRangeOCRExecute(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'actRangeOCRExecute', Classname);
  try
    try
      if (bitfarmApp <> nil) and (bitfarmApp.GetActivePreview <> nil) and
        (bitfarmApp.GetActivePreview.PreviewKind <> pvkMulti) then
      begin
        with bitfarmApp.GetActivePreview do
        begin
          if tbi_rangeocr.Checked then
          begin
            UnCheckAllGraphicTools;
            SingleView.img_DocView.DeSelect;
            SingleView.img_DocView.MouseInteract := [];
          end
          else
          begin
            UnCheckAllGraphicTools;
            tbi_rangeocr.Checked := True;
            tbi_normalmouse.Checked := False;
            frmMainForm.mnuOCRAddfields.Visible := ((ActiveDoc <> nil) and
              (ActiveDoc.ID <> -1)) and (PreviewKind = pvkSingle);
            SingleView.img_DocView.MouseInteract := [miSelect];

            if (ActiveDoc <> nil) and ActiveDoc.InEditMode and Assigned(bitfarmApp) then
              bitfarmApp.LastUsedAnnoTool := TSpTBXItem(tbi_rangeocr).Name;
          end;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'actRangeOCRExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actRangeOCRExecute', Classname);
  end;
end;

procedure TfrmGPL.actRemoveLinkExecute(Sender: TObject);
var
  UserAction: PUserAction;
  i: Integer;
  Doc: TbfaDocument;
begin
  bitfarmLog.DebugBegin(llDebug, 'actRemoveLinkExecute', Classname);
  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actRemoveLink';
      UserAction^.Params.Add(fraDocLinks.lvwDocLink.Selected.Caption);
      UserAction^.Documents := TList.Create;
      for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
      begin
        Doc := TbfaDocument.Create;
        Doc.Clone(bitfarmApp.CurrentContainer[i]);
        UserAction^.Documents.Add(Doc);
      end;
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'actRemoveLinkExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actRemoveLinkExecute', Classname);
  end;
end;

procedure TfrmGPL.actReplaceBookmarkExecute(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'actReplaceBookmarkExecute', Classname);
  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actReplaceBookmark';
      if ((trvBookmarks.Selected <> nil) and (GetRootNode(trvBookmarks.Selected) = bitfarmApp.LocalListNode)) then
      begin
        if trvBookmarks.Selected.Data <> nil then
          UserAction^.Objects.Add(trvBookmarks.Selected);
      end
      else if ((trvBookmarks.Selected <> nil) and (GetRootNode(trvBookmarks.Selected) = bitfarmApp.GlobalListNode)) and bitfarmApp.User.isAdmin then
      begin
        if trvBookmarks.Selected.Data <> nil then
          UserAction^.Objects.Add(trvBookmarks.Selected);
      end;
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'actReplaceBookmarkExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actReplaceBookmarkExecute', Classname);
  end;
end;

procedure TfrmGPL.actRestoreOriginalExecute(Sender: TObject);
var
  UserAction: PUserAction;
  i: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'actRestoreOriginalExecute', ClassName);
  try
    try
      try
        UserAction := bitfarmApp.CreateUserAction;
        UserAction^.ActionName := 'actRestoreOriginal';
        for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
          UserAction^.Params.Add(IntToStr(bitfarmApp.CurrentContainer[i].ID));
        UserAction^.Preview := bitfarmApp.GetActivePreview;
        bitfarmApp.MainThread.Add(UserAction);
      except
        bitfarmLog.Write(llNormal, ltException, 'actRestoreOriginalExecute - ', ClassName);
      end;
    except
      on e: exception do
        bitfarmLog.Write(llNormal, ltException, 'actRestoreOriginalExecute' + e.Message, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actRestoreOriginalExecute', ClassName);
  end;
end;

procedure TfrmGPL.actResubCreateExecute(Sender: TObject);
begin
  bitfarmApp.ResubCreateExecute;
end;

procedure TfrmGPL.actScanDialogExecute(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'actScanDialogExecute', Classname);
  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actScanDialog';
      UserAction^.Params.Add('1');
      UserAction^.Preview := bitfarmApp.GetActivePreview;
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'actScanDialogExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actScanDialogExecute', Classname);
  end;
end;

procedure TfrmGPL.actScanExecute(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'actScanExecute', Classname);
  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actScan';
      UserAction^.Params.Add('0');
      UserAction^.Preview := bitfarmApp.GetActivePreview;
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'actScanExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actScanExecute', Classname);
  end;
end;

procedure TfrmGPL.actSendCopyToWorkplaceExecute(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'actSendCopyToWorkplaceExecute', Classname);
  try
    try
      bitfarmApp.SendDocumentsTo(bitfarmApp.PreviewContainer.WorkplaceItem.Preview, False, True);
    except
      bitfarmLog.Write(llNormal, ltException, 'actSendCopyToWorkplaceExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actSendCopyToWorkplaceExecute', Classname);
  end;
end;

// OriginalDokument an Importer schicken
procedure TfrmGPL.actSendDocumentsToImporterExecute(Sender: TObject);
var
  UserAction: PUserAction;

begin
  bitfarmLog.DebugBegin(llDebug, 'actSendDocumentsToImporterExecute', Classname);
  try
    try
//14.11.2023      bitfarmApp.SendDocumentsTo(bitfarmApp.PreviewContainer.ImporterItem.Preview, False, false, true);
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actSendDocsToImporter';
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'actSendDocumentsToImporterExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actSendDocumentsToImporterExecute', Classname);
  end;
end;

// Voransicht an Importer schicken (wie bisher)
procedure TfrmGPL.actSendDocumentPreviewsToImportExecute(Sender: TObject);
begin

  bitfarmLog.DebugBegin(llDebug, 'actSendDocumentPreviewsToImportExecute', Classname);
  try
    try
      bitfarmApp.SendDocumentsTo(bitfarmApp.PreviewContainer.ImporterItem.Preview, false, True);
    except
      bitfarmLog.Write(llNormal, ltException, 'actSendDocumentPreviewsToImportExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actSendDocumentPreviewsToImportExecute', Classname);
  end;

end;

procedure TfrmGPL.actSendDocumentsToWorkplaceExecute(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'actSendDocumentsToWorkplaceExecute', Classname);
  try
    try
//16.11.2023      bitfarmApp.SendDocumentsTo(bitfarmApp.PreviewContainer.WorkplaceItem.Preview);
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actSendDocsToWorkplace';
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'actSendDocumentsToWorkplaceExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actSendDocumentsToWorkplaceExecute', Classname);
  end;
end;

procedure TfrmGPL.actSendPagesMergedToImporterExecute(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'actSendPagesMergedToImporterExecute', Classname);
  try
    try
      bitfarmApp.GetActivePreview.SendPagesTo(bitfarmApp.PreviewContainer.ImporterItem.Preview, True);
    except
      bitfarmLog.Write(llNormal, ltException, 'actSendPagesMergedToImporterExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actSendPagesMergedToImporterExecute', Classname);
  end;
end;

procedure TfrmGPL.actSendPagesMergedToWorkplaceExecute(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'actSendPagesToWorkplaceExecute', Classname);
  try
    try
      bitfarmApp.GetActivePreview.SendPagesTo(bitfarmApp.PreviewContainer.WorkplaceItem.Preview, True);
    except
      bitfarmLog.Write(llNormal, ltException, 'actSendPagesToWorkplaceExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actSendPagesToWorkplaceExecute', Classname);
  end;
end;

procedure TfrmGPL.actSendPagesToImporterExecute(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'actSendPagesToImporterExecute', Classname);
  try
    try
      bitfarmApp.GetActivePreview.SendPagesTo(bitfarmApp.PreviewContainer.ImporterItem.Preview, False);
    except
      bitfarmLog.Write(llNormal, ltException, 'actSendPagesToImporterExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actSendPagesToImporterExecute', Classname);
  end;
end;

procedure TfrmGPL.actSendPagesToWorkplaceExecute(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'actSendPagesToWorkplaceExecute', Classname);
  try
    try
      bitfarmApp.GetActivePreview.SendPagesTo(bitfarmApp.PreviewContainer.WorkplaceItem.Preview, False);
    except
      bitfarmLog.Write(llNormal, ltException, 'actSendPagesToWorkplaceExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actSendPagesToWorkplaceExecute', Classname);
  end;
end;

procedure TfrmGPL.actSetDoc1Execute(Sender: TObject);
begin
  GetSetDocExecute(Sender, 1);
end;

procedure TfrmGPL.actSetDoc2Execute(Sender: TObject);
begin
  GetSetDocExecute(Sender, 2);
end;

procedure TfrmGPL.actSetDoc3Execute(Sender: TObject);
begin
  GetSetDocExecute(Sender, 3);
end;

procedure TfrmGPL.actSetDoc4Execute(Sender: TObject);
begin
  GetSetDocExecute(Sender, 4);
end;

procedure TfrmGPL.actSetDoc5Execute(Sender: TObject);
begin
  GetSetDocExecute(Sender, 5);
end;

procedure TfrmGPL.actShowIndexingExecute(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'actShowIndexingExecute', Classname);
  try
    try
      bitfarmApp.FShowIndexingWithLimit := False;
      ShowIndexing(Sender);
    except
      bitfarmLog.Write(llNormal, ltException, 'actShowIndexingExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actShowIndexingExecute', Classname);
  end;
end;

procedure TfrmGPL.actShowIndexingWithLimitExecute(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'actShowIndexingWithLimitExecute', Classname);
  try
    try
      bitfarmApp.FShowIndexingWithLimit := True;
      ShowIndexing(Sender);
    except
      bitfarmLog.Write(llNormal, ltException, 'actShowIndexingWithLimitExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actShowIndexingWithLimitExecute', Classname);
  end;
end;

procedure TfrmGPL.ShowIndexing(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'ShowIndexing', Classname);
  try
    try
      bitfarmApp.Log.Debug(llDebug, 'ShowIndexing doIndexing', ClassName);
      if bitfarmApp.GetActivePreview <> bitfarmApp.PreviewContainer.ImporterItem.Preview then
        bitfarmApp.ViewerShowIndexing := True
      else
        bitfarmApp.ImporterShowIndexing := True;

      btnIndexingClick(Sender);
      mnuIndexing.Action := actHideIndexing;
      mnuIndexingWithLimit.Visible := False;
    except
      bitfarmLog.Write(llNormal, ltException, 'ShowIndexing', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ShowIndexing', Classname);
  end;
end;

procedure TfrmGPL.actStationeryExecute(Sender: TObject);
var
  UserAction: PUserAction;
  prev: TbfaPreview;
begin
  bitfarmLog.DebugBegin(llDebug, 'actStationeryExecute', Classname);
  try
    try
      prev := bitfarmApp.GetActivePreview;

      prev.bfaTlbPreview.sbmStationery.Checked := not prev.bfaTlbPreview.sbmStationery.Checked;
      prev.bfaTlbPreview.mnuStationery.Checked := not prev.bfaTlbPreview.mnuStationery.Checked;

      if not prev.Floating then
      begin
        frmMainForm.bfaTlbPreview1.sbmStationery.Checked := prev.bfaTlbPreview.sbmStationery.Checked;
        frmMainForm.bfaTlbPreview1.mnuStationery.Checked := prev.bfaTlbPreview.mnuStationery.Checked;
      end;

      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actStationery';
      if (prev.bfaTlbPreview.mnuStationery.Checked or prev.bfaTlbPreview.sbmStationery.Checked)
      //21.04.2016 or (frmMainForm.bfaTlbPreview1.mnuStationery.Checked or frmMainForm.bfaTlbPreview1.sbmStationery.Checked)
        then
        UserAction^.Params.Add('1')
      else
        UserAction^.Params.Add('0');
      UserAction^.Preview := prev;
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'actStationeryExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actStationeryExecute', Classname);
  end;
end;

procedure TfrmGPL.actFirstPageExecute(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'actFirstPageExecute', Classname);
  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actFirstPage';
      UserAction^.Params.Add('0');
      UserAction^.Preview := bitfarmApp.GetActivePreview;
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'actFirstPageExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actFirstPageExecute', Classname);
  end;
end;

procedure TfrmGPL.actFloatingNextExecute(Sender: TObject);
begin
  try
    if bitfarmApp.FloatingForms.Count > 0 then
    begin
      Inc(bitfarmApp.FloatingFormsIdx);

      if (bitfarmApp.FloatingFormsIdx = -1) or (bitfarmApp.FloatingFormsIdx >= bitfarmApp.FloatingForms.Count) then
        bitfarmApp.FloatingFormsIdx := 0;

      if (TObject(bitfarmApp.FloatingForms[bitfarmApp.FloatingFormsIdx]) is TbfaFloatingForm) then
        TbfaFloatingForm(bitfarmApp.FloatingForms[bitfarmApp.FloatingFormsIdx]).Show
      else if (TObject(bitfarmApp.FloatingForms[bitfarmApp.FloatingFormsIdx]) is TfrmGPL) then
        Self.BringToFront;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'actFloatingNextExecute', ClassName);
  end;
end;

procedure TfrmGPL.actFloatingPreviousExecute(Sender: TObject);
begin
  try
    if bitfarmApp.FloatingForms.Count > 0 then
    begin
      Dec(bitfarmApp.FloatingFormsIdx);

      if (bitfarmApp.FloatingFormsIdx < 0) then
        bitfarmApp.FloatingFormsIdx := bitfarmApp.FloatingForms.Count - 1;

      if (TObject(bitfarmApp.FloatingForms[bitfarmApp.FloatingFormsIdx]) is TbfaFloatingForm) then
        TbfaFloatingForm(bitfarmApp.FloatingForms[bitfarmApp.FloatingFormsIdx]).Show
      else if (TObject(bitfarmApp.FloatingForms[bitfarmApp.FloatingFormsIdx]) is TfrmGPL) then
        Self.BringToFront;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'actFloatingPreviousExecute', ClassName);
  end;
end;

procedure TfrmGPL.actFtxPosExecute(Sender: TObject);
var
  UserAction: PUserAction;
  Stat: Boolean;
  prev: TbfaPreview;
begin
  bitfarmLog.DebugBegin(llDebug, 'actFtxPosExecute', Classname);
  try
    try
      prev := bitfarmApp.GetActivePreview;

      prev.bfaTlbPreview.mnuFtxPos.Checked := not prev.bfaTlbPreview.mnuFtxPos.Checked;

      if not prev.Floating then
        frmMainForm.bfaTlbPreview1.mnuFtxPos.Checked := prev.bfaTlbPreview.mnuFtxPos.Checked;

      Stat := prev.bfaTlbPreview.mnuFtxPos.Checked;

      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actFtxPos';
      if Stat then
        UserAction^.Params.Add('1')
      else
        UserAction^.Params.Add('0');
      UserAction^.Params.Add(IntToStr(prev.SingleView.img_DocView.IO.Params.ImageIndex));
      UserAction^.Preview := prev;
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'actFtxPosExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actFtxPosExecute', Classname);
  end;
end;

procedure TfrmGPL.actViewFloatingWVLExecute(Sender: TObject);
begin
  try
    ShowFloatingResub := not bfaTlbStandard1.tlbStandardFloatingWVL.Checked;
    if ShowFloatingResub then
      bitfarmApp.ShowFloatingResub
    else
    begin
      pnlFloatingResub.Hide;
      bfaTlbStandard1.tlbStandardFloatingWVL.Checked := False;
      ShowFloatingResub := False;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'actViewFloatingWVLExecute', ClassName);
  end;
end;

procedure TfrmGPL.actViewNavigationExecute(Sender: TObject);
begin
  if ((splTreeview.Minimized) or (dckTreeView.Width = 0)) then
  begin
    splTreeview.Restore;
    if dckTreeView.Width = 0 then
      dckTreeView.Width := fpnlTreeviewWidth;
    frmMainForm.bfaTlbStandard1.tlbStandardTreeView.Checked := True;
  end
  else
  begin
    splTreeview.Minimize;
    if dckTreeView.Width <> 0 then
      dckTreeView.Width := 0;
    frmMainForm.bfaTlbStandard1.tlbStandardTreeView.Checked := False;
  end;
end;

procedure TfrmGPL.actViewPreviewExecute(Sender: TObject);
begin
  if not pnlPreview.Visible then
  begin
    SpTBXSplitter2.Align := alLeft;
    SpTBXMultiDock1.Visible := True;
    pnlPreview.Visible := True;
    Exit;
  end
  else
  begin
    SpTBXMultiDock1.Visible := False;
    pnlPreview.Visible := False;
    SpTBXSplitter2.Align := alRight;
  end;

  if SpTBXSplitter2.Minimized then
  begin
    SpTBXSplitter2.Restore
  end
  else
    SpTBXSplitter2.Minimize;
end;

procedure TfrmGPL.actViewSearchOptionsExecute(Sender: TObject);
//var
//  ScreenWidth, ScreenHeight : Integer;
begin
//  if pnlSearchOptions.Floating then
//  begin
//    ScreenWidth := -1;
//    ScreenWidth := GetSystemMetrics(SM_CXVIRTUALSCREEN);
//    ScreenHeight := -1;
//    ScreenHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
//    if pnlSearchOptions.parent.Top > ScreenHeight then
//      pnlSearchOptions.parent.Top := 0;
//    if pnlSearchOptions.parent.Left > ScreenWidth then
//      pnlSearchOptions.parent.Left := 0;
//  end;

  if SpTBXSplitter3.Minimized then
  begin
    SpTBXSplitter3.Restore;
    frmMainForm.bfaTlbStandard1.tlbStandardSearchOptions.Checked := True;
  end
  else
  begin
    SpTBXSplitter3.Minimize;
    frmMainForm.bfaTlbStandard1.tlbStandardSearchOptions.Checked := False;
  end;
end;

procedure TfrmGPL.actViewThumbnailsExecute(Sender: TObject);
var
  UserAction: PUserAction;
  prev: TbfaPreview;
begin
  bitfarmLog.DebugBegin(llDebug, 'actViewThumbnailsExecute', Classname);
  try
    try
      prev := bitfarmApp.GetActivePreview;
      if (prev = nil) or (prev.ShowingThumbnail) then
        Exit;

      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actViewThumbnails';
      if prev.ShowThumbnail then
        UserAction^.Params.Add('0')
      else
        UserAction^.Params.Add('1');
      UserAction^.Preview := prev;
      bitfarmApp.MainThread.Add(UserAction);
      prev.ShowingThumbnail := True;
    except
      bitfarmLog.Write(llNormal, ltException, 'actViewThumbnailsExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actViewThumbnailsExecute', Classname);
  end;
end;

procedure TfrmGPL.actWPGroupExecute(Sender: TObject);
begin
  actMergeDoc.Execute;
end;

procedure TfrmGPL.actWPUngroupExecute(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'actWPUngroupExecute', Classname);
  try
    try
      frmSplash.lblLoading.Caption := _('Die Dokumente werden vorbereitet...');
      frmSplash.Update;
      frmSplash.Show;
      try
        UserAction := bitfarmApp.CreateUserAction;
        UserAction^.ActionName := 'actWPUngroup';
        bitfarmApp.CloneCurrentDocs(UserAction, False, 0, -1, True);
        UserAction^.Preview := bitfarmApp.GetActivePreview;
        bitfarmApp.MainThread.Add(UserAction);
      finally
        frmSplash.Hide;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'actWPUngroupExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actWPUngroupExecute', Classname);
  end;
end;

procedure TfrmGPL.AfterScrollHorz(Sender: TObject);
begin
  SetListBoxPosition;
end;

procedure TfrmGPL.AfterScrollVert(Sender: TObject);
begin
  SetListBoxPosition;
end;

procedure TfrmGPL.ApplicationEvents1Message(var Msg: tagMSG; var Handled: Boolean);
var
  vsb: TControlScrollbar;
  pt, ptSTC: TPoint;
  ActControl, ScrollControl, WinCtrl: TWinControl;
  i, j : Integer;
  FloatingForm: Boolean;
  CursorInArea : Boolean; //14.05.2019 Ticket 19076
  frm: TbfaFloatingForm;
  AScrollPos: Integer;
  prev: TbfaPreview;
begin
  if (Msg.message <> WM_MOUSEWHEEL) and (Msg.message <> WM_MOUSEHWHEEL) then
    Exit;

  if ((not fappStarted) or (bitfarmApp = nil)) or ((bitfarmApp <> nil) and (bitfarmApp.ClosingMainForm)) then
    Exit;

  if OpenDropDown then
    Exit;

  if Assigned(frmOptions) and frmOptions.Showing then
    Exit;

  if Assigned(frmCreateGlobal) and frmCreateGlobal.Showing then
    Exit;

  if Assigned(frmCreateGlobalBookmark) and frmCreateGlobalBookmark.Showing then
    Exit;

  if Assigned(frmLinkMails) and frmLinkMails.Showing then
    Exit;

  {$IFDEF ENTERPRISE}
  if Assigned(TfrmEnterprise(frmMainForm).frmExport) and TfrmEnterprise(frmMainForm).frmExport.Showing then
    Exit;

  if Screen.ActiveForm is TfrmEditHoliday then
    Exit;
  {$ENDIF}

  if (bitfarmApp.GetActivePreview <> nil) and
     Assigned(bitfarmApp.GetActivePreview.frm_DocEditOpt) and
     bitfarmApp.GetActivePreview.frm_DocEditOpt.Showing
  then
    Exit;

  if Msg.Message = WM_MOUSEWHEEL then
  begin
//    bitfarmApp.Log.Write(llDebug, ltDebug, 'FormMouseWheel', ClassName);
    try
      frm := nil;
      FloatingForm := False;
      CursorInArea := False; //14.05.2019 Ticket 19076

      pt := Mouse.CursorPos;
      WinCtrl := FindVCLWindow(pt);

      // do we scroll in a TbfaCheckedCombo ?
      // if top or bottom is not reached - Exit, so the TbfaCheckedCombo scrolls
      // necessary in Importer (DokLinks and DocTags)
      ScrollControl := FindControl(WindowFromPoint(pt));
      if (ScrollControl is TbfaCheckedCombo) and (ScrollControl is TcxControl)
         and (TcxControlAccess(ScrollControl).VScrollBar.Visible) then
      begin
        var Delta: Integer;
        Delta := HIWORD(Msg.wParam);
        if ((Delta < 0) and ((TcxControlAccess(ScrollControl).VScrollBar.PageSize
             + TcxControlAccess(ScrollControl).VScrollBar.Position)
             <= TcxControlAccess(ScrollControl).VScrollBar.Max)) or
           ((Delta > 0) and
           (TcxControlAccess(ScrollControl).VScrollBar.Position > TcxControlAccess(ScrollControl).VScrollBar.Min))
        then
          Exit;
      end;

      if Assigned(frmMainForm.frmMovedoc) and (frmMainForm.frmMovedoc.Showing) then
      begin
        ptSTC := frmMainForm.frmMovedoc.scrbxMoveDocAddfields.ScreenToClient(pt);
        if (ptSTC.x > -1) and (ptSTC.Y > -1) and
          (ptSTC.x <= frmMainForm.frmMovedoc.scrbxMoveDocAddfields.ClientWidth) and
          (ptSTC.Y <= frmMainForm.frmMovedoc.scrbxMoveDocAddfields.ClientHeight) then
        begin
          Msg.message := WM_KEYDOWN;
          Msg.lParam := 0;
          try
            i := Msg.wParam;
          except
            i := 0;
          end;

          if i > 0 then
          begin
            Msg.wParam := SendMessage(frmMainForm.frmMovedoc.scrbxMoveDocAddfields.Handle, WM_VSCROLL, SB_LINEUP, 0);
            Msg.wParam := SendMessage(frmMainForm.frmMovedoc.scrbxMoveDocAddfields.Handle, WM_VSCROLL, SB_LINEUP, 0);
          end else
          begin
            Msg.wParam := SendMessage(frmMainForm.frmMovedoc.scrbxMoveDocAddfields.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
            Msg.wParam := SendMessage(frmMainForm.frmMovedoc.scrbxMoveDocAddfields.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
          end;

          Handled := True;
          Exit;
        end;
      end;

      if Assigned(frmMainForm.pnlFloatingResub) and (frmMainForm.pnlFloatingResub.Visible) and
        (frmMainForm.fraFloatingResub.fraResub <> nil) then
      begin
        ptSTC := frmMainForm.fraFloatingResub.fraResub.ResubScrollBox.ScreenToClient(pt);
        if (ptSTC.x > -1) and (ptSTC.Y > -1) and
          (ptSTC.x <= frmMainForm.fraFloatingResub.fraResub.ResubScrollBox.ClientWidth) and
          (ptSTC.Y <= frmMainForm.fraFloatingResub.fraResub.ResubScrollBox.ClientHeight) then
        begin
          Msg.message := WM_KEYDOWN;
          Msg.lParam := 0;
          try
            i := Msg.wParam;
          except
            i := 0;
          end;

          if i > 0 then
          begin
            Msg.wParam := SendMessage(frmMainForm.fraFloatingResub.fraResub.ResubScrollBox.Handle, WM_VSCROLL, SB_LINEUP, 0);
            Msg.wParam := SendMessage(frmMainForm.fraFloatingResub.fraResub.ResubScrollBox.Handle, WM_VSCROLL, SB_LINEUP, 0);
          end else
          begin
            Msg.wParam := SendMessage(frmMainForm.fraFloatingResub.fraResub.ResubScrollBox.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
            Msg.wParam := SendMessage(frmMainForm.fraFloatingResub.fraResub.ResubScrollBox.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
          end;

          Handled := True;
          Exit;
        end;

        ptSTC := frmMainForm.fraFloatingResub.grdResultlistDevEx.ScreenToClient(pt);
        if (ptSTC.x > -1) and (ptSTC.Y > -1) and
          (ptSTC.x <= frmMainForm.fraFloatingResub.grdResultlistDevEx.ClientWidth) and
          (ptSTC.Y <= frmMainForm.fraFloatingResub.grdResultlistDevEx.ClientHeight) then
        begin
          Exit;
        end;

      end;

      ActControl := Screen.ActiveControl;
      if (ActControl is TbfaImageEnVect) then
      begin
        Self.DefocusControl(ActControl, False);

        if (ActControl.Owner is Tfrm_Voransicht) then
        begin
          if ((ActControl.Owner).Owner is TbfaPreview) then
          begin
            if TbfaPreview(ActControl.Owner.Owner).Floating then
            begin
              frm := TbfaFloatingForm(TbfaPreview(ActControl.Owner.Owner).Parent.Parent);
              frm.SetFocus;
              FloatingForm := True;
            end
            else
              frmMainForm.SetFocus;
          end
          else
            frmMainForm.SetFocus;
        end
        else
          frmMainForm.SetFocus;
      end
      else if ((ActControl.Owner) is TbfaPreview) then
      begin
        if TbfaPreview(ActControl.Owner).Floating then
        begin
          frm := TbfaFloatingForm(TbfaPreview(ActControl.Owner).Parent.Parent);
          frm.SetFocus;
          FloatingForm := True;
        end
        else
          frmMainForm.SetFocus;
      end
      else if (ActControl.Owner is TbfaFloatingForm) then
      begin
        frm := TbfaFloatingForm(ActControl.Owner);
        frm.SetFocus;
        FloatingForm := True;
      end;

      // Floating Forms
      if ((frm <> nil) and (FloatingForm)) then
      begin
        prev := bitfarmApp.GetActivePreview;
        if (prev.SingleView <> nil) and (prev.SingleView.Visible) and
            (prev.SingleView.img_DocView <> nil) and
            (prev.SingleView.img_DocView.visible) then
        begin
          ptSTC := prev.SingleView.img_DocView.ScreenToClient(pt);
          if (ptSTC.x > -1) and (ptSTC.Y > -1) and	// sind wir innerhalb der bitfarmApp.GetActivePreview.SingleView?
            (ptSTC.x <= prev.SingleView.img_DocView.ClientWidth) and (ptSTC.Y <= prev.SingleView.img_DocView.ClientHeight) then
          begin
            if not prev.SingleView.img_DocView.Focused then
              prev.SingleView.img_DocView.SetFocus;
            Exit;
          end;
        end;

        if (prev.MultiView <> nil) and (prev.MultiView.Visible) then
        begin
          ptSTC := prev.MultiView.ScreenToClient(pt);
          if (ptSTC.x > -1) and (ptSTC.Y > -1) and	// sind wir innerhalb der bitfarmApp.GetActivePreview.MultiView?
            (ptSTC.x <= prev.MultiView.ClientWidth) and (ptSTC.Y <= prev.MultiView.ClientHeight) then
          begin
            Msg.message := WM_KEYDOWN;
            Msg.lParam := 0;

            try
              i := Msg.wParam;
            except
              i := 0;
            end;

            if i > 0 then
              Msg.wParam := SendMessage(prev.MultiView.Handle, WM_VSCROLL, SB_LINEUP, 0)
            else
              Msg.wParam := SendMessage(prev.MultiView.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
            Handled := True;
            Exit;
          end;
        end;

        if (prev.ThumbnailView <> nil) and (prev.ThumbnailView.Visible) then
        begin
          ptSTC := prev.ThumbnailView.ScreenToClient(pt);
          if (ptSTC.x > -1) and (ptSTC.Y > -1) and	// sind wir innerhalb der bitfarmApp.GetActivePreview.ThumbnailView?
            (ptSTC.x <= prev.ThumbnailView.ClientWidth) and (ptSTC.Y <= prev.ThumbnailView.ClientHeight) then
          begin
            Msg.message := WM_KEYDOWN;
            Msg.lParam := 0;

            try
              i := Msg.wParam;
            except
              i := 0;
            end;

            if i > 0 then
              Msg.wParam := SendMessage(prev.ThumbnailView.Handle, WM_VSCROLL, SB_LINEUP, 0)
            else
              Msg.wParam := SendMessage(prev.ThumbnailView.Handle, WM_VSCROLL, SB_LINEDOWN, 0);

            Handled := True;
            Exit;
          end;
        end;
      end;

      // Dialoge, Forms
      if Assigned(frmMainForm.frm_rights) and frmMainForm.frm_rights.Visible then
      begin
        Msg.message := WM_KEYDOWN;
        Msg.lParam := 0;

        try
          i := Msg.wParam;
        except
          i := 0;
        end;

        if i > 0 then
        begin
          Msg.wParam := SendMessage(frmMainForm.frm_rights.redt_Rights.Handle, WM_VSCROLL, SB_LINEUP, 0);
          Msg.wParam := SendMessage(frmMainForm.frm_rights.redt_Rights.Handle, WM_VSCROLL, SB_LINEUP, 0);
        end else
        begin
          Msg.wParam := SendMessage(frmMainForm.frm_rights.redt_Rights.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
          Msg.wParam := SendMessage(frmMainForm.frm_rights.redt_Rights.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
        end;

        Handled := True;
        Exit;
      end;

      if Assigned(frmMainForm.frmTags) and (frmMainForm.frmTags.Showing) then
      begin
        ptSTC := frmMainForm.frmTags.mmoTags.ScreenToClient(pt);
        if (ptSTC.x > -1) and (ptSTC.Y > -1) and
          (ptSTC.x <= frmMainForm.frmTags.mmoTags.ClientWidth) and (ptSTC.Y <= frmMainForm.frmTags.mmoTags.ClientHeight) then
        begin
          Msg.message := WM_KEYDOWN;
          Msg.lParam := 0;

          try
            i := Msg.wParam;
          except
            i := 0;
          end;

          if i > 0 then
          begin
            Msg.wParam := SendMessage(frmMainForm.frmTags.mmoTags.Handle, WM_VSCROLL, SB_LINEUP, 0);
            Msg.wParam := SendMessage(frmMainForm.frmTags.mmoTags.Handle, WM_VSCROLL, SB_LINEUP, 0);
          end else
          begin
            Msg.wParam := SendMessage(frmMainForm.frmTags.mmoTags.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
            Msg.wParam := SendMessage(frmMainForm.frmTags.mmoTags.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
          end;

          Handled := True;
          Exit;
        end;
      end;

      if Assigned(frmMainForm.frmInfoBox) and (frmMainForm.frmInfoBox.Showing) then
      begin
        ptSTC := frmMainForm.frmInfoBox.redtInfo.ScreenToClient(pt);
        if (ptSTC.x > -1) and (ptSTC.Y > -1) and
          (ptSTC.x <= frmMainForm.frmInfoBox.redtInfo.ClientWidth) and (ptSTC.Y <= frmMainForm.frmInfoBox.redtInfo.ClientHeight) then
        begin
          Msg.message := WM_KEYDOWN;
          Msg.lParam := 0;

          try
            i := Msg.wParam;
          except
            i := 0;
          end;

          if i > 0 then
          begin
            Msg.wParam := SendMessage(frmMainForm.frmInfoBox.redtInfo.Handle, WM_VSCROLL, SB_LINEUP, 0);
            Msg.wParam := SendMessage(frmMainForm.frmInfoBox.redtInfo.Handle, WM_VSCROLL, SB_LINEUP, 0);
          end else
          begin
            Msg.wParam := SendMessage(frmMainForm.frmInfoBox.redtInfo.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
            Msg.wParam := SendMessage(frmMainForm.frmInfoBox.redtInfo.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
          end;

          Handled := True;
          Exit;
        end;
      end;

      if Assigned(frmMainForm.frmPrivateLayer) and frmMainForm.frmPrivateLayer.Showing then
      begin
        Msg.message := WM_KEYDOWN;
        Msg.lParam := 0;

        try
          i := Msg.wParam;
        except
          i := 0;
        end;

        if i > 0 then
        begin
          Msg.wParam := SendMessage(frmMainForm.frmPrivateLayer.lstUser.Handle, WM_VSCROLL, SB_LINEUP, 0);
          Msg.wParam := SendMessage(frmMainForm.frmPrivateLayer.lstUser.Handle, WM_VSCROLL, SB_LINEUP, 0);
        end else
        begin
          Msg.wParam := SendMessage(frmMainForm.frmPrivateLayer.lstUser.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
          Msg.wParam := SendMessage(frmMainForm.frmPrivateLayer.lstUser.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
        end;

        Handled := True;
        Exit;
      end;

      if Assigned(frmMainForm.frmListItems) and frmMainForm.frmListItems.Showing then
      begin
        ptSTC := frmMainForm.frmListItems.lbItems.ScreenToClient(pt);
        if (ptSTC.x > -1) and (ptSTC.Y > -1) and
          (ptSTC.x <= frmMainForm.frmListItems.lbItems.ClientWidth) and (ptSTC.Y <= frmMainForm.frmListItems.lbItems.ClientHeight) then
        begin
          Msg.message := WM_KEYDOWN;
          Msg.lParam := 0;

          try
            i := Msg.wParam;
          except
            i := 0;
          end;

          if i > 0 then
          begin
            Msg.wParam := SendMessage(frmMainForm.frmListItems.lbItems.Handle, WM_VSCROLL, SB_LINEUP, 0);
            Msg.wParam := SendMessage(frmMainForm.frmListItems.lbItems.Handle, WM_VSCROLL, SB_LINEUP, 0);
          end
          else
          begin
            Msg.wParam := SendMessage(frmMainForm.frmListItems.lbItems.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
            Msg.wParam := SendMessage(frmMainForm.frmListItems.lbItems.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
          end;

          Handled := True;
          Exit;
        end;
      end;

      if (fraAdmin <> nil) and Assigned(fraAdmin.frmDLMDialog) and fraAdmin.frmDLMDialog.Showing then
      begin
        ptSTC := fraAdmin.frmDLMDialog.grdDLM.ScreenToClient(pt);
        if (ptSTC.x > -1) and (ptSTC.Y > -1) and
          (ptSTC.x <= fraAdmin.frmDLMDialog.grdDLM.ClientWidth) and (ptSTC.Y <= fraAdmin.frmDLMDialog.grdDLM.ClientHeight) then
        begin
          Msg.message := WM_KEYDOWN;
          Msg.lParam := 0;

          try
            i := Msg.wParam;
          except
            i := 0;
          end;
          AScrollPos := fraAdmin.frmDLMDialog.grdDLMTable.Site.VScrollBar.Position;
          if i > 0 then
          begin
            TcxControlAccess( fraAdmin.frmDLMDialog.grdDLMTable.Site).Scroll(sbVertical, scLineUp, AScrollPos);
          end else
          begin
            TcxControlAccess( fraAdmin.frmDLMDialog.grdDLMTable.Site).Scroll(sbVertical, scLineDown, AScrollPos);
          end;

          Handled := True;
          Exit;
        end;
      end;

      {$IFDEF ENTERPRISE}
      if (DlgActiveDirectoryVorschau <> nil) and DlgActiveDirectoryVorschau.Showing then
      begin
        ptSTC := DlgActiveDirectoryVorschau.Memo1.ScreenToClient(pt);
        if (ptSTC.x > -1) and (ptSTC.Y > -1) and	// sind wir innerhalb der trvBookmarks?
          (ptSTC.x <= DlgActiveDirectoryVorschau.ClientWidth) and (ptSTC.Y <= DlgActiveDirectoryVorschau.ClientHeight) then
        begin
          //OutputDebugString(PChar('FormMouseWheel - trvBookmarks'));
          Msg.message := WM_KEYDOWN;
          Msg.lParam := 0;

          try
            i := Msg.wParam;
          except
            i := 0;
          end;

          if i > 0 then
            Msg.wParam := SendMessage(DlgActiveDirectoryVorschau.Memo1.Handle, WM_VSCROLL, SB_LINEUP, 0)
          else
            Msg.wParam := SendMessage(DlgActiveDirectoryVorschau.Memo1.Handle, WM_VSCROLL, SB_LINEDOWN, 0);

          Handled := True;
          Exit;
        end;
      end;
      {$ENDIF}

      if (fraAdmin <> nil) and (bitfarmApp.CurrentView = tvkAdministrator) then
      begin
        ptSTC := fraAdminScrollBox.ScreenToClient(pt);
        if (ptSTC.x > -1) and (ptSTC.Y > -1) and	// sind wir innerhalb der Grid?
          (ptSTC.x <= fraAdminScrollBox.ClientWidth) and (ptSTC.Y <= fraAdminScrollBox.ClientHeight) then
        begin
          //OutputDebugString(PChar('FormMouseWheel - fraAdminScrollBox'));
          ActControl := Screen.ActiveControl;
          ScrollControl := FindControl(WindowFromPoint(pt));
          if not (ScrollControl is TListView) and not (ScrollControl is TbfaDBGrid) then
              ScrollControl := fraAdminScrollBox;

          Msg.message := WM_KEYDOWN;
          Msg.lParam := 0;

          try
            i := Msg.wParam;
          except
            i := 0;
          end;

          if i > 0 then
          begin
            Msg.wParam := SendMessage(ScrollControl.Handle, WM_VSCROLL, SB_LINEUP, 0);
            Msg.wParam := SendMessage(ScrollControl.Handle, WM_VSCROLL, SB_LINEUP, 0);
          end else
          begin
            Msg.wParam := SendMessage(ScrollControl.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
            Msg.wParam := SendMessage(ScrollControl.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
          end;
          if (ActControl <> fraAdminScrollBox) and ActControl.Enabled and ActControl.Visible then
            ActControl.SetFocus;

          Handled := True;
          Exit;
        end;
      end;

      if (bitfarmApp.frmQuickPreview <> nil) and (bitfarmApp.frmQuickPreview.Showing) then
      begin
        ptSTC := bitfarmApp.frmQuickPreview.ScreenToClient(pt);
        if (ptSTC.x > -1) and (ptSTC.Y > -1) and
           (ptSTC.x <= bitfarmApp.frmQuickPreview.ClientWidth) and
           (ptSTC.Y <= bitfarmApp.frmQuickPreview.ClientHeight) then
        begin
          //OutputDebugString(PChar('FormMouseWheel - bitfarmApp.frmQuickPreview'));

          if not bitfarmApp.frmQuickPreview.imgQuickPreview.Focused then
            bitfarmApp.frmQuickPreview.imgQuickPreview.SetFocus;
          Exit;
        end;
      end;

      if (bitfarmApp.PreviewContainer.PageSortingsItem.Panel <> nil) and
         (bitfarmApp.PreviewContainer.PageSortingsItem.Panel.Showing) then
      begin
        ptSTC := bitfarmApp.PreviewContainer.PageSortingsItem.Preview.SingleView.img_DocView.ScreenToClient(pt);
        if (ptSTC.x > -1) and (ptSTC.Y > -1) and
            (ptSTC.x <= bitfarmApp.PreviewContainer.PageSortingsItem.Preview.SingleView.img_DocView.ClientWidth) and
            (ptSTC.Y <= bitfarmApp.PreviewContainer.PageSortingsItem.Preview.SingleView.img_DocView.ClientHeight) then
        begin
          //OutputDebugString(PChar('FormMouseWheel - bitfarmApp.PreviewContainer.PageSortingsItem.Preview.SingleView.img_DocView'));

          if not bitfarmApp.PreviewContainer.PageSortingsItem.Preview.SingleView.img_DocView.Focused then
            bitfarmApp.PreviewContainer.PageSortingsItem.Preview.SingleView.img_DocView.SetFocus;
          Exit;
        end;
      end;

      ptSTC := scrbxViewerAddfields.ScreenToClient(pt);
      if (ptSTC.x > -1) and (ptSTC.Y > -1) and	// sind wir innerhalb der Scrollbox?
        (tcSearch.ActiveTab = tabSearchAddfields) and
        (ptSTC.x <= scrbxViewerAddfields.ClientWidth) and
        (ptSTC.Y <= scrbxViewerAddfields.ClientHeight) then
      begin
        // erst Richtung ermitteln
        try
          i := Msg.wParam;
        except
          i := 0;
        end;
//        prev := bitfarmApp.GetActivePreview;
//        if prev.SingleView.img_DocView.MouseInteractVt = [miPutBitmap] then
//        begin
//          prev.SingleView.img_DocView.CancelInteracts;
//          prev.SingleView.img_DocView.MouseInteractVt := [];
//        end;
        // dann prfen ob in einem Gridfeld gescrollt werden muss
        if (ScrollControl is TcxGridSite) and
          (ScrollControl is TcxControl) and (TcxControlAccess(ScrollControl).VScrollBar.Visible) then
        begin
          if (((i <= 0) and ((TcxControlAccess(ScrollControl).VScrollBar.PageSize
               + TcxControlAccess(ScrollControl).VScrollBar.Position)
               <= TcxControlAccess(ScrollControl).VScrollBar.Max)) or
             ((i > 0) and
             (TcxControlAccess(ScrollControl).VScrollBar.Position > TcxControlAccess(ScrollControl).VScrollBar.Min)))
          then
            Exit;
        end;

        // check if there is a TokenEdit with open PopupWindow
        if scrbxViewerAddfields.ControlCount > 0 then
        begin
          for j := 0 to scrbxViewerAddfields.ControlCount - 1 do
          begin
            if scrbxViewerAddfields.Controls[j] is TbfaAddfieldComp then
            begin
              if TbfaAddfieldComp(scrbxViewerAddfields.Controls[j]).comp is TbfaCheckedCombo then
                if TbfaCheckedListBox(TbfaAddfieldComp(scrbxViewerAddfields.Controls[j]).comp2).Visible or
                   TbfaCheckedCombo(TbfaAddfieldComp(scrbxViewerAddfields.Controls[j]).comp).HasPopupWindow then
                  Exit;
            end;
          end;
        end;

        Msg.message := WM_KEYDOWN;
        Msg.lParam := 0;

        if i > 0 then
        begin
          Msg.wParam := SendMessage(scrbxViewerAddfields.Handle, WM_VSCROLL, SB_LINEUP, 0);
          Msg.wParam := SendMessage(scrbxViewerAddfields.Handle, WM_VSCROLL, SB_LINEUP, 0);
        end else
        begin
          Msg.wParam := SendMessage(scrbxViewerAddfields.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
          Msg.wParam := SendMessage(scrbxViewerAddfields.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
        end;

        Handled := True;
        Exit;
      end;

      ptSTC := scrbxAddfields2.ScreenToClient(pt);
      if (ptSTC.x > -1) and (ptSTC.Y > -1) and	// sind wir innerhalb der Scrollbox?
        (tcSearch.ActiveTab = tabSearchAddfields2) and
        (ptSTC.x <= scrbxAddfields2.ClientWidth) and
        (ptSTC.Y <= scrbxAddfields2.ClientHeight) then
      begin
        // erst Richtung ermitteln
        try
          i := Msg.wParam;
        except
          i := 0;
        end;
        // dann prfen ob in einem Gridfeld gescrollt werden muss
        if (ScrollControl is TcxGridSite) and
          (ScrollControl is TcxControl) and (TcxControlAccess(ScrollControl).VScrollBar.Visible) then
        begin
          if (((i <= 0) and ((TcxControlAccess(ScrollControl).VScrollBar.PageSize
               + TcxControlAccess(ScrollControl).VScrollBar.Position)
               < TcxControlAccess(ScrollControl).VScrollBar.Max)) or
             ((i > 0) and
             (TcxControlAccess(ScrollControl).VScrollBar.Position > TcxControlAccess(ScrollControl).VScrollBar.Min)))
          then
            Exit;
        end;

        // check if there is a TokenEdit with open PopupWindow
        if scrbxAddfields2.ControlCount > 0 then
        begin
          for j := 0 to scrbxAddfields2.ControlCount - 1 do
          begin
            if scrbxAddfields2.Controls[j] is TbfaAddfieldComp then
            begin
              if TbfaAddfieldComp(scrbxAddfields2.Controls[j]).comp is TbfaCheckedCombo then
                if TbfaCheckedListBox(TbfaAddfieldComp(scrbxAddfields2.Controls[j]).comp2).Visible or
                   TbfaCheckedCombo(TbfaAddfieldComp(scrbxAddfields2.Controls[j]).comp).HasPopupWindow then
                  Exit;
            end;
          end;
        end;

        Msg.message := WM_KEYDOWN;
        Msg.lParam := 0;

        if i > 0 then
        begin
          Msg.wParam := SendMessage(scrbxAddfields2.Handle, WM_VSCROLL, SB_LINEUP, 0);
          Msg.wParam := SendMessage(scrbxAddfields2.Handle, WM_VSCROLL, SB_LINEUP, 0);
        end else
        begin
          Msg.wParam := SendMessage(scrbxAddfields2.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
          Msg.wParam := SendMessage(scrbxAddfields2.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
        end;

        Handled := True;
        Exit;
      end;

      //14.05.2019 Ticket 19076  -->
      if Assigned(frmMainForm.fraScanFunctions) and frmMainForm.fraScanFunctions.Showing then
      begin
        //die DevExpress Combobox bieten keine Height Property, daher ausrechnen
        //ber Anzahl der Elemente und begrenzen auf die Hhe des ScanFunctions
        //Elementes abzgl eines oberen Rahmens
        i := (frmMainForm.fraScanFunctions.cbxScanProfile.Properties.Items.Count) *
              (frmMainForm.fraScanFunctions.cbxScanProfile.ClientHeight);
        if (i > (frmMainForm.fraScanFunctions.Height - 23)) then
          i := frmMainForm.fraScanFunctions.Height - 23;

        ptSTC := frmMainForm.fraScanFunctions.cbxScanProfile.ScreenToClient(pt);
        if (frmMainForm.fraScanFunctions.cbxScanProfile.DroppedDown) then
        begin
          if (ptSTC.x > -1) and (ptSTC.Y > -1) and
             (ptSTC.x <= frmMainForm.fraScanFunctions.cbxScanProfile.ClientWidth) and
             (ptSTC.Y <= i)
          then
            CursorInArea := True;
        end else
        begin
          if (ptSTC.x > -1) and (ptSTC.Y > -1) and
            (ptSTC.x <= frmMainForm.fraScanFunctions.cbxScanProfile.ClientWidth) and
            (ptSTC.Y <= frmMainForm.fraScanFunctions.cbxScanProfile.ClientHeight)
          then
            CursorInArea := True;
        end;
        if (CursorInArea) then
        begin
          //OutputDebugString(PChar('FormMouseWheel - bitfarmApp.frmQuickPreview'));
          if not frmMainForm.fraScanFunctions.cbxScanProfile.Focused then
            frmMainForm.fraScanFunctions.cbxScanProfile.SetFocus;
          Exit;
        end;
      end;
      //14.05.2019 Ticket 19076  <--

      if fraDocLinks <> nil then
      begin
        ptSTC := fraDocLinks.lvwDocLink.ScreenToClient(pt);
        if (ptSTC.x > -1) and (ptSTC.Y > -1) and	// sind wir innerhalb der Scrollbox?
          (
            ((tcSearch.ActiveTab = tabSearchStandard) and (bitfarmApp.ViewerOptions.GeneralOptions.ShowDocLinks) and
            (not bitfarmApp.ViewerOptions.GeneralOptions.ShowDocLinksInTab))
            or
            ((tcSearch.ActiveTab = tabSearchLinks) and (bitfarmApp.ViewerOptions.GeneralOptions.ShowDocLinks) and
            (bitfarmApp.ViewerOptions.GeneralOptions.ShowDocLinksInTab))
          )
          and
          (ptSTC.x <= fraDocLinks.lvwDocLink.ClientWidth) and
          (ptSTC.Y <= fraDocLinks.lvwDocLink.ClientHeight) then
        begin
          //OutputDebugString(PChar('FormMouseWheel - fraDocLinks.scrbxDocLinkList'));

          Msg.message := WM_KEYDOWN;
          Msg.lParam := 0;

          try
            i := Msg.wParam;
          except
            i := 0;
          end;

          if i > 0 then
          begin
            Msg.wParam := SendMessage(fraDocLinks.lvwDocLink.Handle, WM_VSCROLL, SB_LINEUP, 0);
            Msg.wParam := SendMessage(fraDocLinks.lvwDocLink.Handle, WM_VSCROLL, SB_LINEUP, 0);
          end
          else begin
            Msg.wParam := SendMessage(fraDocLinks.lvwDocLink.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
            Msg.wParam := SendMessage(fraDocLinks.lvwDocLink.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
          end;
          Handled := True;
          Exit;
        end;
      end;

      // Treeviews
      ptSTC := FViewerTreeView.ScreenToClient(pt);
      if (WinCtrl = FViewerTreeView) and (ptSTC.x > -1) and (ptSTC.Y > -1) and	// sind wir innerhalb der FViewerTreeView?
        (ptSTC.x <= FViewerTreeView.ClientWidth) and (ptSTC.Y <= FViewerTreeView.ClientHeight) then
      begin
        //OutputDebugString(PChar('FormMouseWheel - FViewerTreeView'));

        Msg.message := WM_KEYDOWN;
        Msg.lParam := 0;

        try
          i := Msg.wParam;
        except
          i := 0;
        end;

        if i > 0 then
          Msg.wParam := SendMessage(FViewerTreeView.Handle, WM_VSCROLL, SB_LINEUP, 0)
        else
          Msg.wParam := SendMessage(FViewerTreeView.Handle, WM_VSCROLL, SB_LINEDOWN, 0);

        Handled := True;
        Exit;
      end;

      ptSTC := FImporterTreeView.ScreenToClient(pt);
      if (WinCtrl = FImporterTreeView) and (ptSTC.x > -1) and (ptSTC.Y > -1) and	// sind wir innerhalb der FImporterTreeView?
        (ptSTC.x <= FImporterTreeView.ClientWidth) and (ptSTC.Y <= FImporterTreeView.ClientHeight) then
      begin
        //OutputDebugString(PChar('FormMouseWheel - FImporterTreeView'));
        Msg.message := WM_KEYDOWN;
        Msg.lParam := 0;

        try
          i := Msg.wParam;
        except
          i := 0;
        end;

        if i > 0 then
          Msg.wParam := SendMessage(FImporterTreeView.Handle, WM_VSCROLL, SB_LINEUP, 0)
        else
          Msg.wParam := SendMessage(FImporterTreeView.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
        Handled := True;
        Exit;
      end;

      if FAdminTreeview <> nil then
      begin
        ptSTC := FAdminTreeView.ScreenToClient(pt);
        if (WinCtrl = FAdminTreeView) and (ptSTC.x > -1) and (ptSTC.Y > -1) and	// sind wir innerhalb der FAdminTreeView?
          (ptSTC.x <= FAdminTreeView.ClientWidth) and (ptSTC.Y <= FAdminTreeView.ClientHeight) then
        begin
          //OutputDebugString(PChar('FormMouseWheel - FAdminTreeView'));
          Msg.message := WM_KEYDOWN;
          Msg.lParam := 0;

          try
            i := Msg.wParam;
          except
            i := 0;
          end;

          if i > 0 then
            Msg.wParam := SendMessage(FAdminTreeView.Handle, WM_VSCROLL, SB_LINEUP, 0)
          else
            Msg.wParam := SendMessage(FAdminTreeView.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
          Handled := True;
          Exit;
        end;
      end;

      ptSTC := trvBookmarks.ScreenToClient(pt);
      if (WinCtrl = trvBookmarks) and (ptSTC.x > -1) and (ptSTC.Y > -1) and	// sind wir innerhalb der trvBookmarks?
        (ptSTC.x <= trvBookmarks.ClientWidth) and (ptSTC.Y <= trvBookmarks.ClientHeight) then
      begin
        //OutputDebugString(PChar('FormMouseWheel - trvBookmarks'));
        Msg.message := WM_KEYDOWN;
        Msg.lParam := 0;

        try
          i := Msg.wParam;
        except
          i := 0;
        end;

        if i > 0 then
          Msg.wParam := SendMessage(trvBookmarks.Handle, WM_VSCROLL, SB_LINEUP, 0)
        else
          Msg.wParam := SendMessage(trvBookmarks.Handle, WM_VSCROLL, SB_LINEDOWN, 0);

        Handled := True;
        Exit;
      end;

      // Previews
      prev := bitfarmApp.GetActivePreview;
      if prev <> nil then
      begin
        if (prev.SingleView <> nil) and (prev.SingleView.Visible) and
           (prev.SingleView.img_DocView <> nil) and
           (prev.SingleView.img_DocView.visible) and
           ((frmMainForm.Active) or ((frmMovedoc <> nil) and frmMovedoc.Showing)) then
        begin
          ptSTC := prev.SingleView.img_DocView.ScreenToClient(pt);
          if (ptSTC.x > -1) and (ptSTC.Y > -1) and	// sind wir innerhalb der prev.SingleView?
            (ptSTC.x <= prev.SingleView.img_DocView.ClientWidth) and (ptSTC.Y <= prev.SingleView.img_DocView.ClientHeight) then
          begin
            if (frmMainForm.Active) then
            begin
              if not prev.SingleView.img_DocView.Focused then
                if prev.SingleView.img_DocView.Visible and prev.SingleView.img_DocView.Enabled and (prev.ActiveDoc <> nil) then
                  prev.SingleView.img_DocView.SetFocus;
              Exit;
            //23.11.2021 bt Ticket 12487 -->
            end else
            begin
              Msg.message := WM_KEYDOWN;
              Msg.lParam := 0;

              try
                i := Msg.wParam;
              except
                i := 0;
              end;

              if i > 0 then
              begin
                prev.SingleView.img_DocView.Zoom := prev.SingleView.img_DocView.Zoom + 1;
                prev.SingleView.img_DocView.SetViewXY(ptSTC.x, ptSTC.y);
              end
              else
              begin
                prev.SingleView.img_DocView.Zoom := prev.SingleView.img_DocView.Zoom - 1;
                prev.SingleView.img_DocView.SetViewXY(ptSTC.x, ptSTC.Y);
              end;
            end;
            //23.11.2021 bt Ticket 12487 <--
          end;
        end;

        if (prev.MultiView <> nil) and (prev.MultiView.Visible) then
        begin
          ptSTC := prev.MultiView.ScreenToClient(pt);
          if (ptSTC.x > -1) and (ptSTC.Y > -1) and	// sind wir innerhalb der prev.MultiView?
            (ptSTC.x <= prev.MultiView.ClientWidth) and (ptSTC.Y <= prev.MultiView.ClientHeight) then
          begin
            Msg.message := WM_KEYDOWN;
            Msg.lParam := 0;

            try
              i := Msg.wParam;
            except
              i := 0;
            end;

            if (GetKeyState(VK_CONTROL) < 0) then
            begin
              if (prev.MultiView.Tag = tagCollectionMView) then
              begin
                if ((i > 0) and (not bitfarmApp.ViewerOptions.EditorOptions.InvertDirection)) or ((i < 0) and (bitfarmApp.ViewerOptions.EditorOptions.InvertDirection)) then
                  prev.ResizeThumbnail(prev.MultiView, 10)
                else if ((i < 0) and (not bitfarmApp.ViewerOptions.EditorOptions.InvertDirection)) or ((i > 0) and (bitfarmApp.ViewerOptions.EditorOptions.InvertDirection)) then
                  prev.ResizeThumbnail(prev.MultiView, -10);
              end;
            end else
            begin
              if i > 0 then
                Msg.wParam := SendMessage(prev.MultiView.Handle, WM_VSCROLL, SB_LINEUP, 0)
              else
                Msg.wParam := SendMessage(prev.MultiView.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
            end;
            Handled := True;
            Exit;
          end;
        end;

        if (prev.ThumbnailView <> nil) and (prev.ThumbnailView.Visible) then
        begin
          ptSTC := prev.ThumbnailView.ScreenToClient(pt);
          if (ptSTC.x > -1) and (ptSTC.Y > -1) and	// sind wir innerhalb der prev.ThumbnailView?
            (ptSTC.x <= prev.ThumbnailView.ClientWidth) and (ptSTC.Y <= prev.ThumbnailView.ClientHeight) then
          begin
            Msg.message := WM_KEYDOWN;
            Msg.lParam := 0;

            try
              i := Msg.wParam;
            except
              i := 0;
            end;

            if i > 0 then
              Msg.wParam := SendMessage(prev.ThumbnailView.Handle, WM_VSCROLL, SB_LINEUP, 0)
            else
              Msg.wParam := SendMessage(prev.ThumbnailView.Handle, WM_VSCROLL, SB_LINEDOWN, 0);

            Handled := True;
            Exit;
          end;
        end;
      end;

      // Scrollboxen und Trefferliste setzen wir ans Ende, weil diese Bereiche je nach View (zb Workplace) nicht deaktiviert sind
      // und ScreenToClient ggf passende Werte fr den Cursor liefert
      // oder wir mssen hier noch nach View differentieren

      // Scrollboxen
      ptSTC := scrbxViewerAddfields.ScreenToClient(pt);
      if (ptSTC.x > -1) and (ptSTC.Y > -1) and	// sind wir innerhalb der Scrollbox?
        (tcSearch.ActiveTab = tabSearchAddfields) and (ptSTC.x <= scrbxViewerAddfields.ClientWidth) and
        (ptSTC.Y <= scrbxViewerAddfields.ClientHeight) and (not SpTBXSplitter3.Minimized) then
      begin
        //OutputDebugString(PChar('FormMouseWheel - scrbxViewerAddfields'));
        Msg.message := WM_KEYDOWN;
        Msg.lParam := 0;

        try
          i := Msg.wParam;
        except
          i := 0;
        end;

        if i > 0 then
        begin
          Msg.wParam := SendMessage(scrbxViewerAddfields.Handle, WM_VSCROLL, SB_LINEUP, 0);
          Msg.wParam := SendMessage(scrbxViewerAddfields.Handle, WM_VSCROLL, SB_LINEUP, 0);
        end
        else
        begin
          Msg.wParam := SendMessage(scrbxViewerAddfields.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
          Msg.wParam := SendMessage(scrbxViewerAddfields.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
        end;

        Handled := True;
        Exit;
      end;

      ptSTC := scrbxStandard.ScreenToClient(pt);
      if (ptSTC.x > -1) and (ptSTC.Y > -1) and	// sind wir innerhalb der Scrollbox?
         (tcSearch.ActiveTab = tabSearchStandard) and (scrbxStandard.Visible) and
         (ptSTC.x <= scrbxStandard.ClientWidth) and (ptSTC.Y <= scrbxStandard.ClientHeight)
         and (not SpTBXSplitter3.Minimized) then
      begin
        //OutputDebugString(PChar('FormMouseWheel - scrbxStandard'));
        Msg.message := WM_KEYDOWN;
        Msg.lParam := 0;

        try
          i := Msg.wParam;
        except
          i := 0;
        end;

        if i > 0 then
        begin
          Msg.wParam := SendMessage(scrbxStandard.Handle, WM_VSCROLL, SB_LINEUP, 0);
          Msg.wParam := SendMessage(scrbxStandard.Handle, WM_VSCROLL, SB_LINEUP, 0);
        end else
        begin
          Msg.wParam := SendMessage(scrbxStandard.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
          Msg.wParam := SendMessage(scrbxStandard.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
        end;

        Handled := True;
        Exit;
      end;

      ptSTC := scrbxStandardImporter.ScreenToClient(pt);
      if (ptSTC.x > -1) and (ptSTC.Y > -1) and	// sind wir innerhalb der Scrollbox?
         (tcSearch.ActiveTab = tabSearchStandard) and (scrbxStandardImporter.Visible) and
         (ptSTC.x <= scrbxStandardImporter.ClientWidth) and
         (ptSTC.Y <= scrbxStandardImporter.ClientHeight) then
      begin
        //OutputDebugString(PChar('FormMouseWheel - scrbxStandardImporter'));
        if frmMainForm.tokenDocLinks.HasPopupWindow or frmMainForm.tokenDocTags.HasPopupWindow then
          Exit;

        Msg.message := WM_KEYDOWN;
        Msg.lParam := 0;

        try
          i := Msg.wParam;
        except
          i := 0;
        end;

        if i > 0 then
        begin
          Msg.wParam := SendMessage(scrbxStandardImporter.Handle, WM_VSCROLL, SB_LINEUP, 0);
          Msg.wParam := SendMessage(scrbxStandardImporter.Handle, WM_VSCROLL, SB_LINEUP, 0);
        end else
        begin
          Msg.wParam := SendMessage(scrbxStandardImporter.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
          Msg.wParam := SendMessage(scrbxStandardImporter.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
        end;

        Handled := True;
        Exit;
      end;

      if fraResub <> nil then
      begin
        ptSTC := fraResub.ResubScrollBox.ScreenToClient(pt);
        if (ptSTC.x > -1) and (ptSTC.Y > -1) and	// sind wir innerhalb der Scrollbox?
           (fraResub.ResubScrollBox.VertScrollBar.IsScrollBarVisible) and
           (ptSTC.x <= fraResub.ResubScrollBox.ClientWidth) and
           (ptSTC.Y <= fraResub.ResubScrollBox.ClientHeight) then
        begin
          Msg.message := WM_KEYDOWN;
          Msg.lParam := 0;

          try
            i := Msg.wParam;
          except
            i := 0;
          end;

          if i > 0 then
          begin
            Msg.wParam := SendMessage(fraResub.ResubScrollBox.Handle, WM_VSCROLL, SB_LINEUP, 0);
            Msg.wParam := SendMessage(fraResub.ResubScrollBox.Handle, WM_VSCROLL, SB_LINEUP, 0);
          end else
          begin
            Msg.wParam := SendMessage(fraResub.ResubScrollBox.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
            Msg.wParam := SendMessage(fraResub.ResubScrollBox.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
          end;

          Handled := True;
          Exit;
        end;
      end;
    except
      bitfarmApp.Log.Write(llNormal, ltException, 'FormMouseWheel', ClassName);
    end;
  end;
end;

procedure TfrmGPL.BookmarksAutoscroll(Sender: TObject);
begin
   if FBookmarksscroll_down then
      SendMessage(trvBookmarks.Handle, WM_VSCROLL, SB_LINEUP, 0)
   else
      SendMessage(trvBookmarks.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
end;

procedure TfrmGPL.btnAddClick(Sender: TObject);
var
  tag: WideString;
begin
  bitfarmLog.DebugBegin(llDebug, 'btnAddClick', ClassName);

  try
  tag := Trim(ParseSearchfield(edtSearchFTX.compEdit.Text));
    AddTag(Tag);
  finally
    bitfarmLog.DebugEnd(llDebug, 'btnAddClick - ', Classname);
  end;
end;

procedure TfrmGPL.AddTag(Tag: Widestring; bCloneCurrentDocs:Boolean = false);
var
  UserAction: PUserAction;
  i: Integer;
  doc: TbfaDocument;
begin
  bitfarmLog.DebugBegin(llDebug, 'AddTag', ClassName);

  if tag = '' then
    Exit;

  if bitfarmApp.CurrentContainer.Count = 0 then
    Exit;

  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actAddTag';
      UserAction^.Params.Add(tag);
      for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
      begin
        UserAction^.Params.Add(IntToStr(bitfarmApp.CurrentContainer[i].ID));
      end;

      if bCloneCurrentDocs then
        bitfarmApp.CloneCurrentDocs(UserAction, True, rightModify);

      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'AddTag - ', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'AddTag - ', Classname);
  end;
end;

procedure TfrmGPL.btnCloseIndexingClick(Sender: TObject);
begin
  if bitfarmApp.GetActivePreview <> bitfarmApp.PreviewContainer.ImporterItem.Preview then
  begin
//    bitfarmApp.ViewerUseIndexing := False;
    bitfarmApp.ViewerShowIndexing := False;
  end
  else
  begin
//    bitfarmApp.ImporterUseIndexing := False;
    bitfarmApp.ImporterShowIndexing := False;
  end;
  btnIndexingClick(Sender);
//  scrbxViewerAddfields.Update;
  actHideIndexingExecute(Sender);
end;

procedure TfrmGPL.btnIndexingClick(Sender: TObject);
var
  i: Integer;
  doIndexing, ShowIndexing: Boolean;
  UserAction: PUserAction;
begin
  bitfarmApp.Log.DebugBegin(llDebug, 'btnIndexingClick', ClassName);
  try
    try
      doIndexing := False;
      ShowIndexing := True;

      if (bitfarmApp.CurrentView = tvkViewer) then
      begin
        bitfarmApp.UseIndexing := bitfarmApp.ViewerUseIndexing;
        ShowIndexing := bitfarmApp.ViewerShowIndexing;
      end
      else if (bitfarmApp.CurrentView = tvkResub) then
      begin
        bitfarmApp.UseIndexing := bitfarmApp.ViewerUseIndexing;
        ShowIndexing := bitfarmApp.ViewerShowIndexing;
      end
      else if bitfarmApp.CurrentView = tvkImporter then
      begin
        bitfarmApp.UseIndexing := bitfarmApp.ImporterUseIndexing;
        ShowIndexing := bitfarmApp.ImporterShowIndexing;
      end;

      for i := 0 to aCurrentAddfields.Count - 1 do
      begin
        if (aCurrentAddfields[i] = nil) or (aCurrentAddfields[i].Component = nil) then
          Continue;
        if (aCurrentAddfields[i].Component.chkIndexing.Checked) then
        begin
          bitfarmApp.Log.Debug(llDebug, 'btnIndexingClick Addfield checked ' + aCurrentAddfields[i].DisplayName, ClassName);
          doIndexing := True;
          Break;
        end;
      end;

      if doIndexing and bitfarmApp.UseIndexing and ShowIndexing then
      begin
        bitfarmApp.Log.Debug(llDebug, 'btnIndexingClick doIndexing', ClassName);
        UserAction := bitfarmApp.CreateUserAction;
        UserAction^.ActionName := 'actDoIndexing';
        bitfarmApp.MainThread.Add(UserAction);
      end
      else
      begin
        bitfarmApp.UseIndexing := not bitfarmApp.UseIndexing;

        if (bitfarmApp.CurrentView = tvkViewer) then
        begin
          bitfarmApp.ViewerUseIndexing := bitfarmApp.UseIndexing;
          grpIndexing.Visible := bitfarmApp.ViewerShowIndexing;
        end
        else if (bitfarmApp.CurrentView = tvkResub) then
        begin
          bitfarmApp.ViewerUseIndexing := bitfarmApp.UseIndexing;
          grpIndexing.Visible := bitfarmApp.ViewerShowIndexing;
        end
        else if bitfarmApp.CurrentView = tvkImporter then
        begin
          bitfarmApp.ImporterUseIndexing := bitfarmApp.UseIndexing;
          grpIndexing.Visible := bitfarmApp.ImporterShowIndexing;
        end;

        for i := 0 to aCurrentAddfields.Count - 1 do
        begin
          if (aCurrentAddfields[i] = nil) or (aCurrentAddfields[i].Component = nil) then
            Continue;

          if not bitfarmApp.UseIndexing then
          begin
            if aCurrentAddfields[i].Component.cbxIndexing.Visible then
            begin
              if aCurrentAddfields[i].Component.btnIndexing <> nil then
                aCurrentAddfields[i].Component.btnIndexing.Click;
            end;
          end;
          aCurrentAddfields[i].Component.Indexing := bitfarmApp.UseIndexing;
        end;

        scrbxViewerAddfields.Update;

        if bitfarmApp.UseIndexing then
          btnIndexing.Caption := _('Suchen')
        else
          btnIndexing.Caption := _('Verschlagwortungshilfe');
        bitfarmApp.Log.Debug(llDebug, 'btnIndexingClick ShowIndexing', ClassName);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'btnIndexingClick', ClassName);
    end;
  finally
    bitfarmApp.Log.DebugEnd(llDebug, 'btnIndexingClick', ClassName);
  end;
end;

procedure TfrmGPL.btnInProgressClick(Sender: TObject);
begin
  bitfarmApp.Log.DebugBegin(llDebug, 'btnInProgressClick', ClassName);

  try
    actInProgress.Execute;
  finally
    bitfarmApp.Log.DebugEnd(llDebug, 'btnInProgressClick', ClassName);
  end;
end;

procedure TfrmGPL.CanLeaveCurrentView(var Allow: Boolean);
begin
  if Allow then
    Allow := bitfarmApp.AllowedToLeaveCurrentDocs(Allow);
end;

procedure TfrmGPL.AlignToolbarsToLeft;
  Var
  i, j: integer;
  iDockRows: integer;
  sl: TList;
  tb1: TSpTBXToolbar;
  tb2: TSpTBXToolbar;

  function Compare(Item1, Item2: Pointer): Integer;
  begin
    Result := TSpTBXToolbar(Item1).DockPos - TSpTBXToolbar(Item2).DockPos;
  end;

begin
  try
    // Ermittle Anzahl Zeilen
    iDockRows := 0;
    for i:= 0 to sptbxDock1.ToolbarCount -1 do
    begin
      if iDockRows < sptbxDock1.Toolbars[i].DockRow then
        iDockRows := sptbxDock1.Toolbars[i].DockRow;
    end;

    // Toolbars pro Zeile nach Links verschieben
    for i := 0 to iDockRows do
    begin
      sl := TList.Create;

      // Pro Zeile nach DockPos sortieren
      for j := 0 to sptbxDock1.ToolbarCount -1 do
      begin
        if i = sptbxDock1.Toolbars[j].DockRow then
        begin
          sl.Add(Pointer(sptbxDock1.Toolbars[j]));
          sl.Sort(@Compare);
        end;
      end;

      // Pro Zeile Toolbars nach links verschieben
      if sl.Count > 1 then
      begin
        for j := 1 to sl.Count-1 do
        begin
          tb1 := TSpTBXToolbar(sl.Items[j-1]);
          tb2 := TSpTBXToolbar(sl.Items[j]);
          tb2.DockPos := tb1.DockPos + tb1.Width;
        end;
      end;

      sl.Free;
    end;
  except
    on e: exception do
      bitfarmLog.Debug(llDebug, 'TfrmGPL.AlignToolbarsToLeft: ' + e.Message, Classname);
  end;
end;

procedure TfrmGPL.cbxSearchLinksChange(Sender: TObject);
begin
  if Assigned(ForiginalEvent) then
    ForiginalEvent(Sender);

  if (not (GetKeyState(VK_DOWN) < 0)) and (not (GetKeyState(VK_UP) < 0)) then // sonst fll immer neu die Liste
  begin
  // 09.05.2017 Ticket 10600 -->
    if (Sender is TComboBox) and (not (Sender is TSpTBXComboBox)) then
    begin
//23.01.2019 Ticket 17684      TComboBox(Sender).Text := ParseAddfields(TComboBox(Sender).Text);
      if Length(Trim(TComboBox(Sender).Text)) < bitfarmApp.LinkChars then
      begin
        if TComboBox(Sender).Items.Count > 0 then
          TComboBox(Sender).Items.Clear;
        TComboBox(Sender).SelStart := Length(TComboBox(Sender).Text);
      end
      else if Length(Trim(TComboBox(Sender).Text)) = bitfarmApp.LinkChars then
      begin
        if bitfarmApp.ViewerOptions.SearchOptions.ShowDocLinks then
          bitfarmApp.ReadRefnamesOrTitels(TComboBox(Sender), Trim(TComboBox(Sender).Text), 0);
        TComboBox(Sender).SelStart := Length(TComboBox(Sender).Text);
      end;
    end
    else
    begin
      try
  // 09.05.2017 Ticket 10600 <--
//23.01.2019 Ticket 17684      cbxSearchLinks.compComboBox.Text := ParseAddfields(cbxSearchLinks.compComboBox.Text);
        cbxSearchLinks.compComboBox.Properties.BeginUpdate;
      cbxSearchLinks.compComboBox.Properties.IncrementalFiltering := False;
      if Length(Trim(cbxSearchLinks.compComboBox.Text)) < bitfarmApp.LinkChars then
      begin
          if TbfaComboBox(Sender).Properties.Items.Count > 0 then
            cbxSearchLinks.compComboBox.Properties.Items.Clear;
        cbxSearchLinks.compComboBox.SelStart := Length(cbxSearchLinks.compComboBox.Text);
        cbxSearchLinks.compComboBox.DroppedDown := False;
      end
      else if Length(Trim(cbxSearchLinks.compComboBox.Text)) = bitfarmApp.LinkChars then
      begin
        if bitfarmApp.ViewerOptions.SearchOptions.ShowDocLinks then
        begin
          if (frmMainForm.fSearchOption and 64) = 64 then
            bitfarmApp.ReadRefnamesOrTitels(cbxSearchLinks, Trim(cbxSearchLinks.compComboBox.Text), 0)
          else if (frmMainForm.fSearchOption and 128) = 128 then // Titel
            bitfarmApp.ReadRefnamesOrTitels(cbxSearchLinks, Trim(cbxSearchLinks.compComboBox.Text), 1);
        end;
        cbxSearchLinks.compComboBox.SelStart := Length(cbxSearchLinks.compComboBox.Text);
        cbxSearchLinks.compComboBox.DroppedDown := True;
      end;
      finally
      cbxSearchLinks.compComboBox.Properties.IncrementalFiltering := True;
        cbxSearchLinks.compComboBox.Properties.EndUpdate;
    end;
  end;
  end;
end;

procedure TfrmGPL.FormActivate(Sender: TObject);
begin
  if (not fAppStarted) or (bitfarmApp = nil) then
    Exit;

  bitfarmLog.DebugBegin(llDebug, 'TfrmGPL.FormActivate', Classname);
  try
    try
      if ((bitfarmApp.PreviewContainer.ActiveItem <> tstDocumentEditors.ActiveTabIndex) and
         ((not bitfarmApp.InDockChanged) or (bitfarmApp.InPanelClose)) and
         ((bitfarmApp.PreviewContainer.ActiveItem <> 5) and
           (bitfarmApp.CurrentView <> tvkAdministrator)) and  //01.07.2019 Ticket 17938
         (bitfarmApp.GetPanelByTab(tstDocumentEditors.ActiveTab).tag < 6)) then
        bitfarmApp.SetActiveViewAction(bitfarmApp.GetPanelByTab(tstDocumentEditors.ActiveTab).tag, nil, bitfarmApp.CurrentView)
      else if ((bitfarmApp.PreviewContainer.ActiveItem <> tstDocumentEditors.ActiveTabIndex) and
         ((not bitfarmApp.InDockChanged) or (bitfarmApp.InPanelClose)) and
         ((bitfarmApp.PreviewContainer.ActiveItem <> 5) and
           (bitfarmApp.CurrentView <> tvkAdministrator)) and
         (bitfarmApp.GetPanelByTab(tstDocumentEditors.ActiveTab).tag >= 6)) then
        bitfarmApp.ShowActiveTabAction(bitfarmApp.GetPanelByTab(tstDocumentEditors.ActiveTab).tag);
    except
      bitfarmLog.Write(llNormal, ltException, 'TfrmGPL.FormActivate', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'TfrmGPL.FormActivate', Classname);
  end;
end;

procedure TfrmGPL.FormClose(Sender: TObject; var Action: TCloseAction);
var
  inifile: TIniFile;
  DlgResult: TModalResult;
  i: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'FormClose', Classname);
  try
    try
      if bitfarmApp.Exportmode and bitfarmApp.isExporting then
      begin
        BfShowMessage(_('Es ist noch ein Export aktiv. Bitte warten Sie bis der Export abgeschlossen ist.'));
        Action := caNone;
        Exit;
      end;

      tmrSearchPanel.Enabled := False;
      tmrStatusBar.Enabled := False;
      tmrHeartBeat.Enabled := False;
      tmrQueueCount.Enabled := False;

      // bfacrm:ticket__show__29299
      //08.03.2024 if bitfarmApp.ViewerOptions.GeneralOptions.DisplayCheckoutAtShutdown then
      if (not bitfarmApp.OfflineMode) and bitfarmApp.ViewerOptions.GeneralOptions.DisplayCheckoutAtShutdown then
      begin
        var req: TbfaRequest;
        req := TbfaRequest.Create;
        req.ReqType := 'reqGetCheckouts';
        req.UserID := bitfarmApp.User.ID;
        req.Profile := bitfarmApp.Profile;
        req.Lang := bitfarmApp.Lang;
        bitfarmApp.MainSocket.SendRequestToServer(req);
        req := bitfarmApp.MainSocket.ReceiveResponse;

      // TODO SJ: reqGetCheckouts
        if (req.ReqType <> 'respError') and (req.ReqType <> 'respAuthError') and
           (req.DataString <> '') then
        begin
          // SJ: BfMessageDialogWithCheckbox ausgebaut. Macht hier keinen Sinn...

          // im Hintergrund? Nach vorne holen. BringToFont funktioniert nicht...
          if IsIconic(frmMainForm.Handle) then
          begin
            ShowWindow(frmMainForm.Handle, SW_RESTORE);
            bitfarmApp.ForceForegroundWindow(frmMainForm.Handle);
          end;

          DlgResult := BfMessageDlg(_('Sie haben ausgecheckte Dokumente.') + #13#10 + _('Trotzdem beenden?'),
                mtConfirmation, [mbYes, mbNo, mbCancel]);
          case DlgResult of
            mrNo:
            begin
              actCheckoutDocs.Execute;
              Action := caNone;
              Exit;
            end;
            mrCancel:
            begin
              Action := caNone;
              Exit;
            end;
            // mrYes einfach fortfahren
          end;
        end;
      end;

      if (bitfarmApp.PreviewContainer.ImporterItem <> nil) and
         (bitfarmApp.PreviewContainer.ImporterItem.Preview.List.Count > 0) and
         (not FWindowsIsShuttingDown) and (not bitfarmApp.OfflineMode) and
         (not bitfarmApp.Exportmode) and (not bitfarmApp.SkipAskArchiveOnClose) then
      begin
        try
          // im Hintergrund? Nach vorne holen. BringToFont funktioniert nicht...
          if IsIconic(frmMainForm.Handle) then
          begin
            ShowWindow(frmMainForm.Handle, SW_RESTORE);
            bitfarmApp.ForceForegroundWindow(frmMainForm.Handle);
          end;

          DlgResult := BfMessageDialogWithCheckBox(_('Hinweis'),
                          _('Es sind noch Dokumente im Importer vorhanden.') +
                          #13#10 + _('Mchten Sie die Dokumente archivieren?'),
                          mtConfirmation, [mbYes, mbNo, mbCancel],
                          [_('Ja'), _('Nein'), _('Abbrechen')], True, bitfarmApp.ViewerOptions,
                          'CloseImporter', mrNo);
        except
          DlgResult := mrNo;
          bitfarmLog.Write(llNormal, ltException, 'ImportQuestionByClose', ClassName);
        end;
        if DlgResult <> mrNo then
        begin
          try
            if DlgResult = mrYes then
              bitfarmApp.SetActiveView(nil, pvtImporter, nil, pvtImporter);
          except
            bitfarmLog.Write(llNormal, ltException, 'bitfarmApp.SetActiveView(nil, pvtImporter, nil, pvtImporter);', ClassName);
          end;
          bitfarmLog.Write(llNormal, ltDebug, 'FormClose - Dialog result: '+inttostr(DlgResult), ClassName);
          Action := caNone;
          Exit;
        end;
      end;

      Screen.Cursor := crHourGlass;

      if IsIconic(frmMainForm.Handle) then
      begin
        ShowWindow(frmMainForm.Handle, SW_RESTORE);
        bitfarmApp.ForceForegroundWindow(frmMainForm.Handle);
      end;

      bitfarmApp.ClosingMainForm := True;

      if bitfarmApp.CurrentView = tvkAdministrator then //23.03.2017 Ticket 10153
      begin
        frmMainForm.SpTBXDock1.Visible := False;
        bitfarmApp.ShowToolbars(True);      // 10/16/2020 bfacrm:ticket__show__24556
      end;

      if not bitfarmApp.OfflineMode then
      begin
        //08.03.2024 -->
        if dmMain.cntMain.Connected then //12.02.2019 wenn kein Verbindung mehr z.B beim falschen Profilwechseln, dann hier absturz!
          bitfarmApp.CheckResub(nil);
        //08.03.2024 <--

        try
          if bitfarmApp.MainSocket.Connected then //12.02.2019 wenn kein Verbindung mehr z.B beim falschen Profilwechseln, dann hier absturz!
            bitfarmApp.SaveHistoryBookmark
          else
            bitfarmLog.Write(llNormal, ltError, 'Keine Verbindung zum Server. Suchhistorie konnte nicht gespeichert werden.', Classname);
        except
          BfShowMessage(_('Keine Verbindung zum Server. Suchhistorie konnte nicht gespeichert werden.'));
          bitfarmLog.Write(llNormal, ltException, 'Keine Verbindung zum Server. Suchhistorie konnte nicht gespeichert werden.', Classname);
        end;
        try
          if bitfarmApp.MainSocket.Connected then //12.02.2019 wenn kein Verbindung mehr z.B beim falschen Profilwechseln, dann hier absturz!
            bitfarmApp.DisconnectUser
          else
            bitfarmLog.Write(llNormal, ltError, 'Keine Verbindung zum Server. Kein Abmelderequest fr den User mglich.', Classname);
        except
          bitfarmLog.Write(llNormal, ltError, 'Keine Verbindung zum Server. Kein Abmelderequest fr den User mglich.', Classname);
        end;
      end;

      if (not bitfarmApp.OfflineMode) and (frmMainForm.fAppStarted) then
      begin
        frmSplash.Show;
        frmSplash.BringToFront;
        frmSplash.lblLoading.Caption := _('Dokumente im Importer werden gespeichert...');
        frmSplash.Update;
        frmSplash.Show;
        if InitialLoadImporterDone then
        begin
          bitfarmApp.SaveDocumentsToXML(bitfarmApp.ImportContainer, BD.EnvAppdataImporterPd);
          if bitfarmApp.ImportContainer.Count = 0 then
            if DirectoryExists(BD.EnvAppdataImporter) then
              DeleteDirectory(BD.EnvAppdataImporter);
        end;
        frmSplash.lblLoading.Caption := _('Dokumente im Arbeitsplatz werden gespeichert...');
        frmSplash.Update;
        if FInitialLoadWorkplaceDone then  //28.08.2019 Ticket 15823
        begin
          bitfarmApp.SaveDocumentsToXML(bitfarmApp.WorkplaceContainer, BD.EnvAppdataWorkplacePd);
          if bitfarmApp.WorkplaceContainer.Count = 0 then
            if DirectoryExists(BD.EnvAppdataWorkplace) then
              DeleteDirectory(BD.EnvAppdataWorkplace);
        end;
        frmSplash.Hide;
      end;

      //15.08.2024 -->
      SaveLayoutAndIni;
      //15.08.2024 <--

      // <!-- SJ 22.07.2022 - bfacrm:ticket__show__31539
      // siehe commit vom 11.08.2022. Beim Relogin werden Einstellungen zwar neu geladen, aber nicht
      // gespeichert. Hat dazu gefhrt, dass vorher gespeicherte nderungen teilweise nicht in den inis waren,
      // welche dann neu geladen wurden... Speichern wurde in Subfunktion ausgelagert -> SaveViewerIniAndTreeViews
      // und wird jetzt auch bei Relogin durchgefhrt.
      try
        SaveViewerIniAndTreeViews;
      // SJ 22.07.2022 -->

        bitfarmApp.WriteSortings;

        try
          try
            if Assigned(frmOptions) then
              frmOptions.Release;
          finally
            frmOptions := nil;
          end;
        except
          bitfarmLog.Write(llNormal, ltException, 'FormClose - frmOptions.Release', Classname);
        end;

        if DirectoryExists(BD.EnvTempPd + 'bfa_dd') then
        begin
          bitfarmLog.Write(llDebug, ltinfo, 'DeleteDirectory: ' + BD.EnvTempPd + 'bfa_dd', Classname);
          DeleteDirectory(BD.EnvTempPd + 'bfa_dd');
          bitfarmLog.Write(llDebug, ltinfo, 'Directory deleted', Classname);
        end;

//04.07.2023 vielleicht sollten wir doch lschen...
//        if DirectoryExists(BD.EnvAppdataPd + 'Bug Reports') then
//        begin
//          bitfarmLog.Write(llDebug, ltinfo, 'DeleteDirectory: ' + BD.EnvAppdataPd + 'Bug Reports', Classname);
//          DeleteDirectory(BD.EnvAppdataPd + 'Bug Reports');
//          bitfarmLog.Write(llDebug, ltinfo, 'Directory deleted', Classname);
//        end;

        TerminateProcess(GetCurrentProcess, 0); //08.03.2019 wegen abstrze beim schlieen ein Versuch...

      finally
        bitfarmLog.Write(llDebug, ltinfo, 'inifile.Free', Classname);
        inifile.Free;
        bitfarmLog.Write(llDebug, ltinfo, 'inifile destroyed', Classname);
        Screen.Cursor := crDefault;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'FormClose', Classname);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'FormClose', Classname);
  end;
end;

procedure TfrmGPL.SaveAdminFrameControls(iniFile: TIniFile);
begin
  try
    try
      //17.12.2021 AdminFrame GUI Einstellungen speichern. Erst ab Version 3.6.2.60 -->
      if fraAdmin <> nil then
      begin
        iniFile.WriteInteger('fraAdminFrame', 'ActiveTabIndex', fraAdmin.tabctrAdmin.ActiveTabIndex); //13.12.2023 neu 3.6.2.203
        iniFile.WriteInteger('fraAdminFrame', 'SpTBXPanel21', fraAdmin.SpTBXPanel21.Width);
        iniFile.WriteInteger('fraAdminFrame', 'bfsGroupsUser', fraAdmin.bfsGroupsUser.SpTBXPanel1.Width);
        iniFile.WriteInteger('fraAdminFrame', 'SpTBXPanel11', fraAdmin.SpTBXPanel11.Width);
        iniFile.WriteInteger('fraAdminFrame', 'bfsAssignUser', fraAdmin.bfsAssignUser.SpTBXPanel1.Width);
        iniFile.WriteInteger('fraAdminFrame', 'SpTBXPanel13', fraAdmin.SpTBXPanel13.Width);
        iniFile.WriteInteger('fraAdminFrame', 'bfsAssignAddfields', fraAdmin.bfsAssignAddfields.SpTBXPanel1.Width);
        iniFile.WriteInteger('fraAdminFrame', 'bfsAddfieldsUser', fraAdmin.bfsAddfieldsUser.SpTBXPanel1.Width);
        iniFile.WriteInteger('fraAdminFrame', 'SpTBXPanel16', fraAdmin.SpTBXPanel16.Width);
        iniFile.WriteInteger('fraAdminFrame', 'bfsAssignStatefields', fraAdmin.bfsAssignStatefields.SpTBXPanel1.Width);
        iniFile.WriteInteger('fraAdminFrame', 'bfsStatefieldsUser', fraAdmin.bfsStatefieldsUser.SpTBXPanel1.Width);
        iniFile.WriteInteger('fraAdminFrame', 'SpTBXPanel8', fraAdmin.SpTBXPanel8.Height);
        iniFile.WriteInteger('fraAdminFrame', 'SpTBXPanel10', fraAdmin.SpTBXPanel10.Height);
//        iniFile.WriteInteger('fraAdminFrame', 'SpTBXPanel3', fraAdmin.SpTBXPanel3.Width);
//        iniFile.WriteInteger('fraAdminFrame', 'SpTBXPanel4', fraAdmin.SpTBXPanel4.Height);
//        iniFile.WriteInteger('fraAdminFrame', 'SpTBXPanel7', fraAdmin.SpTBXPanel7.Height);
//        iniFile.WriteInteger('fraAdminFrame', 'bfsADGroups', fraAdmin.bfsADGroups.SpTBXPanel1.Width);
//        iniFile.WriteInteger('fraAdminFrame', 'bfsInferior', fraAdmin.bfsInferior.SpTBXPanel1.Width);
      end;
      //17.12.2021 AdminFrame GUI Einstellungen speichern. Erst ab Version 3.6.2.60 <--
    except
      bitfarmLog.Write(llNormal, ltException, 'SaveAdminFrameControls', Classname);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SaveAdminFrameControls', Classname);
  end;
end;

procedure TfrmGPL.SaveViewerIniAndTreeViews;
var
  inifile: TIniFile;
begin
  try
    bitfarmApp.ViewerOptions.GUIOptions.SearchPanelFloating := pnlSearchOptions.Floating; //06.12.2021(pnlSearchOptions.Parent.Name = 'dckFloating');

    if bitfarmApp.ViewerOptions.SaveOptions then
    begin
      bitfarmApp.ViewerOptions.Save;
    end
    else
    begin
      bitfarmApp.ViewerOptions.SaveGUIOptions;
      bitfarmApp.ViewerOptions.SaveSystemOptions(True);
      bitfarmApp.ViewerOptions.SaveResubOptions(True);
    end;

    inifile := TIniFile.Create(BD.EnvAppdataPd + 'bitfarm-archiv\Viewer.ini');
    try

      // SJ - bfacrm:ticket__show__33571
      if bfaTlbStandard1.tlbStandardSubmenuItemSave.Action <> nil then
      begin
        if frmMainForm.actLocalSaveOriginal.Tag = 1 then
          inifile.WriteInteger('General', 'LocalSave', 0)
        else if frmMainForm.actLocalSavePDF.Tag = 1 then
          inifile.WriteInteger('General', 'LocalSave', 1)
        else if frmMainForm.actLocalSaveTIF.Tag = 1 then
          inifile.WriteInteger('General', 'LocalSave', 2)
        else if frmMainForm.actLocalSaveLink.Tag = 1 then
          inifile.WriteInteger('General', 'LocalSave', 3)
        else if frmMainForm.actLocalSavePreview.Tag = 1 then
          inifile.WriteInteger('General', 'LocalSave', 4);
      end;

      if bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action <> nil then
      begin
        if frmMainForm.actEmailPDFAttachment.Tag = 1 then
          inifile.WriteInteger('General', 'Email', 0)
        else if frmMainForm.actEmailTIFAttachment.Tag = 1 then
          inifile.WriteInteger('General', 'Email', 1)
        else if frmMainForm.actEmailOriginal.Tag = 1 then
          inifile.WriteInteger('General', 'Email', 2)
        else if frmMainForm.actEmailLink.Tag = 1 then
          inifile.WriteInteger('General', 'Email', 3)
        else if frmMainForm.actEmailPreview.Tag = 1 then
          inifile.WriteInteger('General', 'Email', 4);
      end;

      if bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action <> nil then
      begin
        if frmMainForm.actCopyDocToClipboard.Tag = 1 then
          inifile.WriteInteger('General', 'Copy', 0)
        else if frmMainForm.actCopyOriginalDocToClipboard.Tag = 1 then
          inifile.WriteInteger('General', 'Copy', 1)
        else if frmMainForm.actCopyPageToClipboard.Tag = 1 then
          inifile.WriteInteger('General', 'Copy', 2)
        else if frmMainForm.actCopyDocLinkToClipboard.Tag = 1 then
          inifile.WriteInteger('General', 'Copy', 3);
      end;
//      if bfaTlbStandard1.tlbStandardSubmenuItemSave.Action <> nil then
//      begin
//        if bfaTlbStandard1.tlbStandardSubmenuItemSave.Action.Name = 'actLocalSaveOriginal' then
//          inifile.WriteInteger('General', 'LocalSave', 0)
//        else if bfaTlbStandard1.tlbStandardSubmenuItemSave.Action.Name = 'actLocalSavePDF' then
//          inifile.WriteInteger('General', 'LocalSave', 1)
//        else if bfaTlbStandard1.tlbStandardSubmenuItemSave.Action.Name = 'actLocalSaveTIF' then
//          inifile.WriteInteger('General', 'LocalSave', 2)
//        else if bfaTlbStandard1.tlbStandardSubmenuItemSave.Action.Name = 'actLocalSaveLink' then
//          inifile.WriteInteger('General', 'LocalSave', 3)
//        else if bfaTlbStandard1.tlbStandardSubmenuItemSave.Action.Name = 'actLocalSavePreview' then
//          inifile.WriteInteger('General', 'LocalSave', 4);
//      end;
//
//      if bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action <> nil then
//      begin
//        if bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action.Name = 'actEmailPDFAttachment' then
//          inifile.WriteInteger('General', 'Email', 0)
//        else if bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action.Name = 'actEmailTIFAttachment' then
//          inifile.WriteInteger('General', 'Email', 1)
//        else if bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action.Name = 'actEmailOriginal' then
//          inifile.WriteInteger('General', 'Email', 2)
//        else if bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action.Name = 'actEmailLink' then
//          inifile.WriteInteger('General', 'Email', 3)
//        else if bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action.Name = 'actEmailPreview' then
//          inifile.WriteInteger('General', 'Email', 4);
//      end;
//
//      if bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action <> nil then
//      begin
//        if bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action.Name = 'actCopyDocToClipboard' then
//          inifile.WriteInteger('General', 'Copy', 0)
//        else if bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action.Name = 'actCopyOriginalDocToClipboard' then
//          inifile.WriteInteger('General', 'Copy', 1)
//        else if bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action.Name = 'actCopyPageToClipboard' then
//          inifile.WriteInteger('General', 'Copy', 2)
//        else if bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action.Name = 'actCopyDocLinkToClipboard' then
//          inifile.WriteInteger('General', 'Copy', 3);
//      end;
      // SJ - bfacrm:ticket__show__33571

      if bfaTlbStandard1.tlbStandardSubmenuItemPrint.Action <> nil then
      begin
        if bfaTlbStandard1.tlbStandardSubmenuItemPrint.Action.Name = 'actPrintStandard' then
          inifile.WriteInteger('General', 'Print', 0)
        else if bfaTlbStandard1.tlbStandardSubmenuItemPrint.Action.Name = 'actPrintSelect' then
          inifile.WriteInteger('General', 'Print', 1)
        else if bfaTlbStandard1.tlbStandardSubmenuItemPrint.Action.Name = 'actPrintPreview' then
          inifile.WriteInteger('General', 'Print', 2);
      end;

      if bitfarmApp.currentEmptyDoc <> '' then
        inifile.WriteString('General', 'EmptyDoc', bitfarmApp.currentEmptyDoc);

      inifile.WriteInteger('General', 'Skin', FSelectedSkinIndex);
      inifile.WriteString('General', 'SkinName', FSelectedSkinName); //14.06.2019 10.3
      inifile.WriteInteger('General', 'SearchOption', fSearchOption);
      inifile.WriteBool('General', 'ShowAllReposAddfields', bitfarmApp.ShowAllReposAddfields);
      inifile.WriteBool('General', 'OrderFieldsByName', bitfarmApp.OrderFieldsByName);
      inifile.WriteInteger('General', 'MViewThumbWidth', bitfarmapp.MViewThumbWidth);
      inifile.WriteInteger('General', 'MViewThumbHeight', bitfarmApp.MViewThumbHeight);

      // 4 = AutoZoomOff (-> LastZoomLevel speichern!)
      // 6 = letzte Einstellung merken
      if (bitfarmApp.ViewerOptions.EditorOptions.AutoZoom in [4,6]) then
      begin
        if bitfarmApp.ViewerOptions.EditorOptions.AutoZoom = 6 then
        begin
          if bfaTlbPreview1.sbmAutozoom.ImageIndex = Integer(icoidx_preview_original) then
            inifile.WriteInteger('General', 'Zoom', 0)
          else if bfaTlbPreview1.sbmAutozoom.ImageIndex = Integer(icoidx_preview_auto) then
            inifile.WriteInteger('General', 'Zoom', 1)
          else if bfaTlbPreview1.sbmAutozoom.ImageIndex = Integer(icoidx_preview_width) then
            inifile.WriteInteger('General', 'Zoom', 2)
          else if bfaTlbPreview1.sbmAutozoom.ImageIndex = Integer(icoidx_preview_height) then
            inifile.WriteInteger('General', 'Zoom', 3)
          else if bfaTlbPreview1.sbmAutozoom.ImageIndex = Integer(icoidx_select) then
            inifile.WriteInteger('General', 'Zoom', 4)
          else if bfaTlbPreview1.sbmAutozoom.ImageIndex = Integer(icoidx_preview_no_autozoom) then
            inifile.WriteInteger('General', 'Zoom', 5);
        end;

        if (bfaTlbPreview1.sbmAutozoom.ImageIndex = Integer(icoidx_preview_no_autozoom)) and
           (bfaTlbPreview1.cbxZoom.Text <> '') and (Pos('%', bfaTlbPreview1.cbxZoom.Text) <> -1) then
        begin
          var AZoom: string;
          var fpZoom: Double;
          var iPos: Integer;
          fpZoom := -1;
          iPos := Pos('%', bfaTlbPreview1.cbxZoom.Text);
          AZoom := trim(copy(bfaTlbPreview1.cbxZoom.Text, 0, iPos - 2));
          AZoom := StringReplace(AZoom, ',', bitfarmApp.FormatSettings.DecimalSeparator, [rfReplaceAll]);
          TryStrToFloat(AZoom, fpZoom, bitfarmApp.FormatSettings);
          if fpZoom <> -1 then
            inifile.WriteFloat('General', 'LastZoomLevel', fpZoom);
        end;
      end;

      //Muss speichern welche war der letzte Active Preview, weil dass brauchen wir beim Start
      //GP: Refactoring: bitfarmApp.CurrentView kann hier genutzt werden (nach Rcksprache mit BT)

      if (bitfarmApp.PreviewContainer.ViewerItem <> nil) and (bitfarmApp.PreviewContainer.ViewerItem.Tab.Visible) and (bitfarmApp.CurrentView = tvkViewer) then
        inifile.WriteInteger('General', 'LastActivePreview', bitfarmApp.PreviewContainer.ViewerItem.Panel.tag)
      else if (bitfarmApp.PreviewContainer.ViewerItem <> nil) and (bitfarmApp.PreviewContainer.ViewerItem.Tab.Visible) and (bitfarmApp.CurrentView = tvkResub) then
        inifile.WriteInteger('General', 'LastActivePreview', bitfarmApp.PreviewContainer.ResubItem.Panel.tag)
      else if (bitfarmApp.PreviewContainer.ImporterItem <> nil) and (bitfarmApp.PreviewContainer.ImporterItem.Tab.Visible) then
        inifile.WriteInteger('General', 'LastActivePreview', bitfarmApp.PreviewContainer.ImporterItem.Panel.tag)
      else if (bitfarmApp.PreviewContainer.WorkplaceItem <> nil) and (bitfarmApp.PreviewContainer.WorkplaceItem.Tab.Visible) then
        inifile.WriteInteger('General', 'LastActivePreview', bitfarmApp.PreviewContainer.WorkplaceItem.Panel.tag);

      //GP: Nach RS mit BT ist bitfarmApp.CurrentView spter reingekommen, daher kann diese einfachere Variante genutzt werden.
      if (bitfarmApp.CurrentView = tvkFavorites) then
        inifile.WriteInteger('General', 'LastActivePreview', 4);

      if (bitfarmApp.CurrentView = tvkAdministrator) then
        inifile.WriteInteger('General', 'LastActivePreview', 5);

      // letzte Searchpanel Tab muss auch gespeichert werden
      inifile.WriteInteger('General', 'LastActiveTab', tcSearch.ActiveTabIndex);

      // Ticket 22451
      inifile.WriteBool('General', 'ViewerThumbnailsVisible', bitfarmApp.PreviewContainer.ViewerItem.Preview.ShowThumbnail);
      inifile.WriteBool('General', 'ImporterThumbnailsVisible', bitfarmApp.PreviewContainer.ImporterItem.Preview.ShowThumbnail);
      inifile.WriteBool('General', 'WorkplaceThumbnailsVisible', bitfarmApp.PreviewContainer.WorkplaceItem.Preview.ShowThumbnail);
      // SJ Abschlussprojekt
      {$IFDEF ENTERPRISE}
        inifile.WriteInteger('General', sSysUpdate, bitfarmApp.ViewerOptions.GeneralOptions.Update);
        inifile.WriteBool('General', sSysUpdateFailed, (bitfarmApp.fUpdateStatus = bfaObjects36.eUpdateError));
        if (fraAdmin <> nil) then
        begin
          inifile.WriteString('General', 'edtWinUser', fraAdmin.edtWinUser.Text);
          inifile.WriteBool('General', 'chkEmailFromAD', fraAdmin.chkEmailFromAD.Checked);
        end;
      {$ENDIF}
      // SJ Abschlussprojekt

      inifile.WriteInteger('General', sSysStartingArea, bitfarmApp.ViewerOptions.GeneralOptions.StartingArea);
      inifile.WriteBool('General', sSysNegativeCurrency, bitfarmApp.ViewerOptions.GeneralOptions.NegativeCurrency);

      if (frmMainForm.actUndockDefault = frmMainForm.actUndockInNewTab) then
        inifile.WriteInteger('General', 'UndockDocument', 0)
      else if (frmMainForm.actUndockDefault = frmMainForm.actUndockInNewWindow) then
        inifile.WriteInteger('General', 'UndockDocument', 1)
      else
        inifile.WriteInteger('General', 'UndockDocument', 0);

      // SJ 16.12.2021 - bfacrm:ticket__show__28243
      inifile.WriteString('General', sSysLanguage, bitfarmApp.Lang);

    except
      bitfarmLog.Write(llNormal, ltException, 'WriteIni General', Classname);
    end;

    try
      inifile.WriteBool('Preview', 'Floating', pnlPreview.Floating);
      inifile.WriteInteger('Preview', 'Floating_x', pnlPreview.FloatingPosition.X);
      inifile.WriteInteger('Preview', 'Floating_y', pnlPreview.FloatingPosition.Y);
    except
      bitfarmLog.Write(llNormal, ltException, 'WriteIni Preview', Classname);
    end;

    try
      inifile.WriteBool('FulltextView', 'displaySearchToolbar', bitfarmApp.PreviewContainer.ViewerItem.Preview.SearchbarToolbar.Visible);
      inifile.WriteInteger('FulltextView', 'SearchToolbarLastPosition', bitfarmApp.PreviewContainer.ViewerItem.Preview.SearchbarToolbar.DockPos);
      inifile.WriteString('FulltextView', 'SearchToolbarLastDock', bitfarmApp.PreviewContainer.ViewerItem.Preview.SearchbarToolbar.CurrentDock.Name);
      inifile.WriteBool('FulltextView', 'SearchbarChkAccurate', bitfarmApp.PreviewContainer.ViewerItem.Preview.SearchbarChkAccurate.Checked);
      inifile.WriteBool('FulltextView', 'wholeword', bitfarmApp.PreviewContainer.ViewerItem.Preview.SearchbarChkWholeWords.Checked);
      inifile.WriteBool('FulltextView', 'circlesearch', bitfarmApp.PreviewContainer.ViewerItem.Preview.SearchbarChkCircle.Checked);
      inifile.WriteInteger('FulltextView', 'FullTextZoom', bitfarmApp.FullTextZoom);
    except
      bitfarmLog.Write(llNormal, ltException, 'WriteIni FulltextView', Classname);
    end;

    try
      inifile.WriteString('Resub', 'TimidList', bitfarmApp.TimidList.DelimitedText);
      inifile.WriteInteger('Resub', 'NewResubs', bitfarmApp.FNewResubs);
      if bitfarmApp.BMResub <> 0 then
        inifile.WriteInteger('Resub', 'BMResub', bitfarmApp.BMResub);
      if bitfarmApp.BMDelegateResub <> 0 then
        inifile.WriteInteger('Resub', 'BMDelegateResub', bitfarmApp.BMDelegateResub);
    except
      bitfarmLog.Write(llNormal, ltException, 'WriteIni Resub', Classname);
    end;

    try
      inifile.WriteString('PopupLinkList', 'PopupLinkList', bitfarmApp.PopupLinkList.DelimitedText);
    except
      bitfarmLog.Write(llNormal, ltException, 'WriteIni PopupLinkList', Classname);
    end;

    try
      inifile.WriteString(sSysMarkedDocs, bitfarmApp.MarkedDocsProfile, bitfarmApp.MarkedDocsString);
    except
      bitfarmLog.Write(llNormal, ltException, 'WriteIni MarkedDocsString', Classname);
    end;

    inifile.UpdateFile;

    if FViewerTreeview <> nil then
    begin
      try
        FViewerTreeview.SaveToINI;
      except
        bitfarmLog.Write(llNormal, ltException, 'FViewerTreeview.SaveToINI;', ClassName);
      end;
    end;
    if FImporterTreeview <> nil then
    begin
      try
        FImporterTreeview.SaveToINI;
      except
        bitfarmLog.Write(llNormal, ltException, 'FImporterTreeview.SaveToINI;', ClassName);
      end;
    end;
    if FAdminTreeview <> nil then
    begin
      try
        FAdminTreeview.SaveToINI;
      except
        bitfarmLog.Write(llNormal, ltException, 'FAdminTreeview.SaveToINI;', ClassName);
      end;
    end;
    bitfarmApp.SaveTreeViewBookmarkExpanded;

  except
    bitfarmLog.Write(llNormal, ltException, 'SaveViewerIniAndTreeViews', Classname);
  end;
end;

procedure TfrmGPL.FormCreate(Sender: TObject);
var
  hd: HWND;
  i: Integer;
begin
  try
    hd := FindWindow('bitfarm.hotsearch.V36', nil);
    if hd <> 0 then
      PostMessage(hd, WM_HOTKEY_ENABLE_DISABLE, 1, 0);

    Self.OnMouseActivate := MainFormMouseActivate;
  except
    bitfarmLog.Write(llNormal, ltException, 'MainForm.Create - HotSearch WM_HOTKEY_ENABLE_DISABLE', ClassName);
  end;

  try
    {$IFNDEF ENTERPRISE}
    TranslateToolbar(tlbMainMenu);
    TranslateToolbar(tlbGraphic);
    TranslateToolbar(tlbTools);
    TranslateToolbar(tlbDocState);
    TranslateToolbar(tlbStatefields);
    TranslateToolbar(tlbPlugins);
    TranslateToolbar(tlbResubFavs);
    TranslateToolbar(tlbQueueCount);

    try
      TranslateComponent(Self, sSysGnuViewerDomain);
      TranslateComponent(Self.frmOptions, sSysGnuViewerDomain);
    except
      //03.12.2018
    end;
    {$ENDIF}
    //03.12.2021  SetPreview1Actions;
    cxSetResourceString(@cxSDatePopupClear, _('Lschen'));
    cxSetResourceString(@cxSNoMatchesFound, sCaptionNoMatchesFound);

    InitPanelResubmissionCaption;

    CommonGUIUtils.InitActionList(Self as TfrmGPL);

    if bitfarmApp.currentEmptyDoc <> '' then
      SetEmptyDocItem(bitfarmApp.currentEmptyDoc);

    // bfacrm:ticket__show__28247
    // DMSAdmin immer im Admin-bereich starten
    if (Lowercase(bitfarmApp.User.Name) = Lowercase(sSysDMSAdmin)) then
      FLastActivePreview := 5;

    //08.03.2024 im Offline-Modus gibt es keinen Administration -->
    if bitfarmApp.OfflineMode and (FLastActivePreview = 5) then
      FLastActivePreview := 0;
    //08.03.2024 im Offline-Modus gibt es keinen Administration <--


    if (FLastActivePreview = 0) or
      ((FLastActivePreview = 5) and (not bitfarmApp.User.isAdmin)) then     //11/4/2020 bfacrm:ticket__show__24765
    begin
      FImporterTreeview.LastSelected := -1;
      FImporterTreeview.SelectTreeNode(bitfarmApp.CurrentImportArchive.Arcid);
      for i := 0 to bitfarmApp.PreviewContainer.Containers.Count - 1 do
      begin
        if bitfarmApp.PreviewContainer.Containers[i].Tab = bitfarmApp.PreviewContainer.ViewerItem.Tab then
        begin
          bitfarmApp.PreviewContainer.Containers[i].Tab.Visible := True;
          bitfarmApp.PreviewContainer.Containers[i].Panel.Visible := True;
          tstDocumentEditors.ActiveTabIndex := bitfarmApp.PreviewContainer.Containers[i].Panel.Tag;
        end
        else
        begin
          bitfarmApp.PreviewContainer.Containers[i].Tab.Visible := False;
          bitfarmApp.PreviewContainer.Containers[i].Panel.Visible := False;
        end;
      end;
      pnlTreeView.Maximize;

      bitfarmApp.SetActiveView(nil, pvtViewer, nil, integer(tvkViewer));
      FViewerTreeview.SelectTreeNode(bitfarmApp.CurrentArchive.Arcid);
      FViewerTreeview.TabStop := True;
    end
    else if FLastActivePreview = 1 then
    begin
      FViewerTreeview.LastSelected := -1;
      FViewerTreeview.SelectTreeNode(bitfarmApp.CurrentArchive.Arcid);
      for i := 0 to bitfarmApp.PreviewContainer.Containers.Count - 1 do
      begin
        if bitfarmApp.PreviewContainer.Containers[i].Tab = bitfarmApp.PreviewContainer.ImporterItem.Tab then
        begin
          bitfarmApp.PreviewContainer.Containers[i].Tab.Visible := True;
          bitfarmApp.PreviewContainer.Containers[i].Panel.Visible := True;
          tstDocumentEditors.ActiveTabIndex := bitfarmApp.PreviewContainer.Containers[i].Panel.Tag;
        end
        else
        begin
          bitfarmApp.PreviewContainer.Containers[i].Tab.Visible := False;
          bitfarmApp.PreviewContainer.Containers[i].Panel.Visible := False;
        end;
      end;
      pnlImporter.Maximize;

      bitfarmApp.SetActiveView(nil, pvtImporter, nil, Integer(tvkImporter));
      FImporterTreeview.SelectTreeNode(bitfarmApp.CurrentImportArchive.Arcid);
      FImporterTreeview.TabStop := True;
    end
    else if FLastActivePreview = 2 then
    begin
      for i := 0 to bitfarmApp.PreviewContainer.Containers.Count - 1 do
      begin
        if bitfarmApp.PreviewContainer.Containers[i].Tab = bitfarmApp.PreviewContainer.WorkplaceItem.Tab then
        begin
          bitfarmApp.PreviewContainer.Containers[i].Tab.Visible := True;
          bitfarmApp.PreviewContainer.Containers[i].Panel.Visible := True;
          tstDocumentEditors.ActiveTabIndex := bitfarmApp.PreviewContainer.Containers[i].Panel.Tag;
        end
        else
        begin
          bitfarmApp.PreviewContainer.Containers[i].Tab.Visible := False;
          bitfarmApp.PreviewContainer.Containers[i].Panel.Visible := False;
        end;
      end;
      pnlWorkspace.Maximize;

      bitfarmApp.SetActiveView(nil, pvtWorkplace, nil, Integer(tvkWorkplace));
    end
    else if FLastActivePreview = 3 then
    begin
      for i := 0 to bitfarmApp.PreviewContainer.Containers.Count - 1 do
      begin
        if bitfarmApp.PreviewContainer.Containers[i].Tab = bitfarmApp.PreviewContainer.ViewerItem.Tab then
        begin
          bitfarmApp.PreviewContainer.Containers[i].Tab.Visible := True;
          bitfarmApp.PreviewContainer.Containers[i].Panel.Visible := True;
          tstDocumentEditors.ActiveTabIndex := bitfarmApp.PreviewContainer.Containers[i].Panel.Tag;
        end
        else
        begin
          bitfarmApp.PreviewContainer.Containers[i].Tab.Visible := False;
          bitfarmApp.PreviewContainer.Containers[i].Panel.Visible := False;
        end;
      end;
      pnlResubmission.Maximize;

      bitfarmApp.SetActiveView(nil, pvtViewer, nil, Integer(tvkResub));
    end
    else if FLastActivePreview = 4 then
    begin
      for i := 0 to bitfarmApp.PreviewContainer.Containers.Count - 1 do
      begin
        if bitfarmApp.PreviewContainer.Containers[i].Tab = bitfarmApp.PreviewContainer.ViewerItem.Tab then
        begin
          bitfarmApp.PreviewContainer.Containers[i].Tab.Visible := True;
          bitfarmApp.PreviewContainer.Containers[i].Panel.Visible := True;
          tstDocumentEditors.ActiveTabIndex := bitfarmApp.PreviewContainer.Containers[i].Panel.Tag;
        end
        else
        begin
          bitfarmApp.PreviewContainer.Containers[i].Tab.Visible := False;
          bitfarmApp.PreviewContainer.Containers[i].Panel.Visible := False;
        end;
      end;
      pnlFavorites.Maximize;
      bitfarmApp.SetActiveView(nil, pvtViewer, nil, Integer(tvkFavorites));
    end
    else if (FLastActivePreview = 5) and (bitfarmApp.User.isAdmin) then // 11/4/2020 bfacrm:ticket__show__24765
    begin
      for i := 0 to bitfarmApp.PreviewContainer.Containers.Count - 1 do
      begin
        bitfarmApp.PreviewContainer.Containers[i].Tab.Visible := False;
        bitfarmApp.PreviewContainer.Containers[i].Panel.Visible := False;
      end;
      pnlAdmin.Maximize;
      if fraAdmin = nil then
        SetAdminGUI;
      bitfarmApp.SetActiveView(nil, pvtAdmin, nil, Integer(tvkAdministrator));
    end
    else
    begin
      for i := 0 to bitfarmApp.PreviewContainer.Containers.Count - 1 do
      begin
        if bitfarmApp.PreviewContainer.Containers[i].Tab = bitfarmApp.PreviewContainer.ViewerItem.Tab then
        begin
          bitfarmApp.PreviewContainer.Containers[i].Tab.Visible := True;
          bitfarmApp.PreviewContainer.Containers[i].Panel.Visible := True;
          tstDocumentEditors.ActiveTabIndex := bitfarmApp.PreviewContainer.Containers[i].Panel.Tag;
        end
        else
        begin
          bitfarmApp.PreviewContainer.Containers[i].Tab.Visible := False;
          bitfarmApp.PreviewContainer.Containers[i].Panel.Visible := False;
        end;
      end;
      pnlTreeView.Maximize;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'MainForm.Create', ClassName);
  end;
end;

procedure TfrmGPL.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  pnl : TSpTBXDockablePanel;
  UserAction : PUserAction;
  i, j, editmode: Integer;
  gdocid, arcid, symarcid, TimID, ResubUserID: Int64;
  doc: TbfaDocument;
  found: Boolean;
  lBM: TBookmark;
  AAddfieldComp: TbfaAddfieldComp;
  Msg: TMsg;
  prev: TbfaPreview;
begin
  if bitfarmApp.ActivePreview = nil then   // AdminFrame
    Exit;

// hier mssen die ShortCuts als Ausnahmen definiert werden, die beim TextEdit
// von Annos wirksam sind
// also Strg + L, auerdem ESC, um den TextEditMode verlassen zu knnen
// Version 3.5
  if (bitfarmApp.GetActivePreview.SingleView.img_DocView.ObjTextEditMode <> -1) and
    (    ((Shift = [ssCtrl]) and (Key = 76)) {Strg + L}
      or ((Shift = [ssCtrl]) and (Key = Ord('F'))) {Strg + F}
      or ((Shift = [ssCtrl]) and (Key = Ord('U'))) {Strg + U}
      or ((Shift = [ssCtrl]) and (Key = Ord('L'))) {Strg + L}
      or ((Shift = [ssCtrl]) and (Key = Ord('R'))) {Strg + R}
    )
  then
  	Exit;

  try
    try
      if (Key = VK_SPACE) and IsDebuggerPresent then
        bitfarmLog.Write(llDebug, ltInfo, 'Active Control: '+Screen.ActiveControl.ToString, ClassName);

      if Key = VK_F2 then
      begin
        bitfarmLog.Write(llDebug, ltInfo, 'TfrmGPL.FormKeyDown - VK_F2', ClassName);
      end;

      if Shift = [] then
      begin
        case Key of
          VK_ESCAPE:
            begin
              if bitfarmApp.CurrentView = tvkAdministrator then
              begin
//                Das kann zu Problemen fhren, wenn man eine bfaInputCombo/Edit mit ESC verlsst
//                if fraAdmin.btnSaveAdmin.Enabled and bitfarmApp.AdminEditMode then
//                  fraAdmin.btnCancelAdminClick(nil)
//17.08.2017 Ticket 11468 ich versuche mal bfaInputCombo/Edit ausschlieen

//09.09.2024 SD -->bfacrm:ticket__show__39712
//                if (fraAdmin.btnSaveAdmin.Enabled) and (bitfarmApp.AdminEditMode)
//                   and (((ActiveControl <> nil)
//                          and (not (ActiveControl.Owner is TbfaInputCombo)) and
//                          (not (ActiveControl.Owner is TbfaInputEdit)))
//                        or
//                        (ActiveControl = nil))
//                then
//                  fraAdmin.btnCancelAdminClick(nil);
                if (fraAdmin.btnSaveAdmin.Enabled) and (bitfarmApp.AdminEditMode) then
                begin
                  if (ActiveControl <> nil) then
                  begin
                    if (ActiveControl.Owner is TbfaInputCombo) and (TbfaInputCombo(ActiveControl.Owner).cbbInput.ItemIndex = -1) and (TbfaInputCombo(ActiveControl.Owner).cbbInput.Items.Count > 0) then
                    begin
                      TbfaInputCombo(ActiveControl.Owner).cbbInput.ItemIndex := 0;
                      TbfaInputCombo(ActiveControl.Owner).cbbInput.Text := TbfaInputCombo(ActiveControl.Owner).cbbInput.Items.Strings[0];
                    end
                    //24.09.2024 SD -->bfacrm:ticket__show__38613
                    //die erste Drckung von Esc lscht das Filter-Schlsselwort
                    //die zweite Drckung von Esc verlsst den Bearbeitungsmodus
                    else if (ActiveControl.Owner is TbfaSelector) and (ActiveControl is TListView) then
                    begin
                      if ((ActiveControl.Name = 'lvList1') and (TbfaSelector(ActiveControl.Owner).edtFilter1.Text = ''))
                        or ((ActiveControl.Name = 'lvList2') and (TbfaSelector(ActiveControl.Owner).edtFilter2.Text = '')) then
                        fraAdmin.btnCancelAdminClick(nil)
                    end
                    //24.09.2024 SD <--bfacrm:ticket__show__38613
                    else
                     fraAdmin.btnCancelAdminClick(nil)
                  end
                  else
                    fraAdmin.btnCancelAdminClick(nil)
                end
//09.09.2024 SD <--bfacrm:ticket__show__39712
              end
              else if (bitfarmApp.CurrentView = tvkImporter) and
                      (bitfarmApp.PreviewContainer.ImporterItem.Preview.PreviewKind = pvkMulti) and
                      (bitfarmApp.PreviewContainer.PageSortingsItem.Panel.Showing) then
              begin
                actHidePagesortingsFrame.Execute;
              end
//              else if (Screen.ActiveControl.ClassName <> 'TIETextControl') then
//              begin
//                if bitfarmApp.ActivePreview.ActiveDoc <> nil then
//                begin
//                  if (bitfarmApp.ActivePreview.ActiveDoc.ID <> -1) and (bitfarmApp.ActivePreview.ActiveDoc.InEditMode) then
//                    frmMainForm.actCancel.Execute;
//                end;
//              end;
              else if (Screen.ActiveControl.ClassName <> 'TIETextControl') then
              begin
                AAddfieldComp := nil;
                if (Screen.ActiveControl.Parent <> nil) and
                   (Screen.ActiveControl.Parent.Parent <> nil) and
                   (Screen.ActiveControl.Parent.Parent is TbfaAddfieldComp)
                then
                  AAddfieldComp := TBfaAddfieldComp(Screen.ActiveControl.Parent.Parent);

                if AAddfieldComp = nil then
                  Exit;

                // bei Intervall ist egal wo wir stehen, wir setzen beide comps zurck
                if (AAddfieldComp.AddfieldType = zfld05_Intervall) and
                   (AAddfieldComp.Modified or AAddfieldComp.ModifiedHigh) then
                begin
                  AAddfieldComp.Value := AAddfieldComp.OldValue;
                  AAddfieldComp.Modified := False;
                  AAddfieldComp.ModifiedHigh := False;
                  if Assigned(AAddfieldComp.OnValueSet) then
                    AAddfieldComp.OnValueSet(AAddfieldComp.Value, AAddfieldComp.ValueHigh, AAddfieldComp.Modified, AAddfieldComp.ModifiedHigh);
//                  PeekMessage(Msg, 0, WM_CHAR, WM_CHAR, PM_REMOVE); // gegen PLING-Ton
//                  for i := 0 to aCurrentAddfields.Count - 1 do
//                  begin
//                    if aCurrentAddfields[i].Component = AAddfieldComp then
//                    begin
//                      aCurrentAddfields[i].Modified := AAddfieldComp.Modified;
//                      aCurrentAddfields[i].ModifiedHigh := AAddfieldComp.ModifiedHigh;
//                      aCurrentAddfields[i].Value := AAddfieldComp.Value;
//                      Break;
//                    end;
//                  end;
                  Exit;
                end
                else if (AAddfieldComp.Modified) and (Screen.ActiveControl.Parent = AAddfieldComp.comp) and
                        (not frmMainform.OpenDropDown) then
                begin
                  AAddfieldComp.Value := AAddfieldComp.OldValue;

                  // PostEditValue damit TBfaAddfieldComp.DateOnEditValueChanged nicht modified setzt
                  if (Screen.ActiveControl.Parent is TcxDateEdit) then
                  begin
                    TcxDateEdit(Screen.ActiveControl.Parent).Date := -700000;
//                    TcxDateEdit(Screen.ActiveControl.Parent).PostEditValue;
                  end;
                  AAddfieldComp.Modified := False;
                  if Assigned(AAddfieldComp.OnValueSet) then
                    AAddfieldComp.OnValueSet(AAddfieldComp.Value, AAddfieldComp.ValueHigh, AAddfieldComp.Modified, AAddfieldComp.ModifiedHigh);

//                  for i := 0 to aCurrentAddfields.Count - 1 do
//                  begin
//                    if aCurrentAddfields[i].Component = AAddfieldComp then
//                    begin
//                      aCurrentAddfields[i].Modified := AAddfieldComp.Modified;
//                      aCurrentAddfields[i].Value := AAddfieldComp.Value;
//                      Break;
//                    end;
//                  end;

                  Exit;
                end else if (AAddfieldComp <> nil) and Assigned(AAddfieldComp.comp2) and
                            (Screen.ActiveControl.Parent = AAddfieldComp.comp2) and
                            (AAddfieldComp.ModifiedHigh) then
                begin
                  AAddfieldComp.ValueHigh := '';
                  if (Screen.ActiveControl.Parent is TcxDateEdit) then
                    TcxDateEdit(Screen.ActiveControl.Parent).Date := -700000;
                  AAddfieldComp.ModifiedHigh := False;

                  if Assigned(AAddfieldComp.OnValueSet) then
                    AAddfieldComp.OnValueSet(AAddfieldComp.Value, AAddfieldComp.ValueHigh, AAddfieldComp.Modified, AAddfieldComp.ModifiedHigh);

//                  for i := 0 to aCurrentAddfields.Count - 1 do
//                  begin
//                    if aCurrentAddfields[i].Component = AAddfieldComp then
//                    begin
//                      aCurrentAddfields[i].ModifiedHigh := AAddfieldComp.ModifiedHigh;
//                      aCurrentAddfields[i].ValueHigh := AAddfieldComp.ValueHigh;
//                      Break;
//                    end;
//                  end;
                  Exit;
                end;

                if (bitfarmApp.ActivePreview.ActiveDoc <> nil) and
                   (bitfarmApp.ActivePreview.ActiveDoc.ID <> -1) and
                   (bitfarmApp.ActivePreview.ActiveDoc.InEditMode)
                then
                  frmMainForm.actCancel.Execute;
              end;
            end;
          VK_F3:
            begin
              if (bitfarmApp.ActivePreview.PreviewKind = pvkSingle) and
                 (bitfarmApp.ActivePreview.ActiveDoc <> nil) and
                 (bitfarmApp.ActivePreview.ActiveDoc.ID <> -1)
              then
                bitfarmApp.ActivePreview.SearchbarButtonDownClick(Sender);
            end;
          VK_F7:
            begin
              if ((bitfarmApp.ActivePreview.PreviewKind = pvkSingle) or
                  (bitfarmApp.ActivePreview.PreviewKind = pvkMultiSingle))
                 and (bitfarmApp.ActivePreview.tbi_normalmouse.Enabled)
              then
                bitfarmApp.ActivePreview.tbi_normalmouseClick(Sender);
            end;
          VK_F8:
            begin
              if ((bitfarmApp.ActivePreview.PreviewKind = pvkSingle) or
                  (bitfarmApp.ActivePreview.PreviewKind = pvkMultiSingle))
                 and (bitfarmApp.ActivePreview.tbi_annoselect.Enabled)
              then
                bitfarmApp.ActivePreview.tbi_annoselectClick(Sender);
            end;
           VK_F9: //Ticket 15458: Lsungsvorschlag 1  (sauberere Lsung) + Shortcut F9 aus der Action (in dfm) herausgenommen.
            begin
               if (bitfarmApp.CurrentView = tvkImporter) and
                  (bitfarmApp.PreviewContainer.ImporterItem.Preview.PreviewKind = pvkMulti) and
                  (bitfarmApp.CurrentContainer.Count > 0) then
               begin
                 if (bitfarmApp.PreviewContainer.PageSortingsItem.Panel.Showing) then
                   bitfarmApp.CreateHidePageSortingsFrameAction
                 else
                   bitfarmApp.CreateShowPageSortingsFrameAction;
               end;
            end;
          VK_F12:
            begin
              if frmMainForm.Active then
              begin
                if frmMainForm.WindowState <> wsMaximized then
                  frmMainForm.WindowState := wsMaximized
                else
                  frmMainForm.WindowState := wsNormal;
              end else
              begin
                if bitfarmApp.PreviewContainer.ActiveItem <> -1 then
                begin
                  pnl := bitfarmApp.PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].Panel;
                  bitfarmApp.MaximizePanel(pnl);
                end;
              end;
            end;
          VK_RETURN:
            begin
              if (Screen.ActiveControl = FViewerTreeview) and frmMainForm.actSearch.Enabled then
              begin
                frmMainForm.actSearch.Execute;
                PeekMessage(Msg, 0, WM_CHAR, WM_CHAR, PM_REMOVE); // SJ 13.11.2020 bfacrm:ticket__show__24708
              end;
            end;
        end;
      end
      else if Shift = [ssShift] then
      begin
        case Key of
          VK_F3:
            begin
              if (bitfarmApp.ActivePreview.PreviewKind = pvkSingle) and (bitfarmApp.ActivePreview.ActiveDoc <> nil)
                  and (bitfarmApp.ActivePreview.ActiveDoc.ID <> -1) then
              begin
                bitfarmApp.ActivePreview.SearchbarButtonUpClick(Sender);
              end;
            end;
        end;
      end
      else if Shift = [ssCtrl] then
      begin
        case Key of
          Ord('F'):
          begin
            if bitfarmApp.ActivePreview = bitfarmApp.PreviewContainer.ViewerItem.Preview then
            begin
              frmMainForm.edtSearchText.Selectall;
              frmMainForm.edtSearchText.SetFocus;
              PeekMessage(Msg, 0, WM_CHAR, WM_CHAR, PM_REMOVE); // SJ 24.01.2020 - gegen PLING-Ton
            end
            else if not bitfarmApp.ActivePreview.SingleView.gbAnnoNotSaved then
              actCtrlF.Execute;
          end;

          Ord('S'):
          begin
            if bitfarmApp.CurrentView = tvkAdministrator then
              fraAdmin.btnApplyAdminClick(nil)
            else
              actSave.Execute;

          end;
          {Ord('L'):
            begin
              if bitfarmApp.CurrentView <> tvkAdministrator then
                actLocalSaveTIF.Execute;

            end;}

           // -- > 7/15/2020 bfacrm:ticket__show__23623
          Ord('A'):
          begin
            if not (bitfarmApp.CurrentView = tvkAdministrator) then
            begin
              if (Screen.Activecontrol.Classname = 'TbfaGridSite') and  //03.11.2020 Ticket 24702
                 (grdResultlistDevExView.Focused) then
              begin
                grdResultlistDevExView.Controller.SelectAll;
                bitfarmApp.SelectedRowsToCurrentContainer(grdResultlistDevExView);
              end;
            end;
          end;
          // <--  7/15/2020 bfacrm:ticket__show__23623

          Ord('U'):
          begin
            if (frmMainForm.grdResultlistDevExView.DataController.DataSource <> nil) and
               (frmMainForm.grdResultlistDevExView.DataController.DataSource.DataSet <> nil) and
               (frmMainForm.grdResultlistDevExView.DataController.DataSource.DataSet.RecordCount > 0)
            then
              bitfarmApp.GridLastSelectedGdDocID :=
                frmMainForm.grdResultlistDevExView.DataController.GetValue(
                  frmMainForm.grdResultlistDevExView.ActRec,
                  frmMainForm.grdResultlistDevExView.DataController.GetItemByFieldName('gdocid').Index);
              actGoToSourceArchive.Execute;
          end;

          vk_numpad0:				// Ticket 14121
            actGetLastDocument.Execute;
          vk_numpad1:
            actGetDoc1.Execute;
          vk_numpad2:
            actGetDoc2.Execute;
          vk_numpad3:
            actGetDoc3.Execute;
          vk_numpad4:
            actGetDoc4.Execute;
          vk_numpad5:
            actGetDoc5.Execute;


          Ord('C'):
          begin
            prev := bitfarmApp.ActivePreview;
            if (prev <> nil) and (prev.ActiveDoc <> nil) and (prev.SingleView <> nil) and
               (prev.SingleView.img_DocView <> nil) and (prev.SingleView.img_DocView.SelObjectsCount > 0)
            then
              prev.SingleView.img_DocView.ObjCopyToClipboard;
          end;

          // ACHTUNG: siehe auch TbfaFloatingForm.FormKeyUp
          Ord('V'):
          begin
            prev := bitfarmApp.ActivePreview;

            // Datei(en) in Zwischenablage? Importer.
            if Clipboard.HasFormat(CF_HDROP) then
                bitfarmApp.CreateLoadAction(DROPEFFECT_COPY, nil)

            else if (prev <> nil) and (prev.ActiveDoc <> nil) and (prev.SingleView <> nil) and
               (prev.SingleView.img_DocView <> nil) and
               (prev.SingleView.img_DocView.ObjIsClipboardAvailable) and
               (prev.SingleView.CheckAnnoRights) and (
                 (prev.ActiveDoc.EditmodeUserID = bitfarmApp.User.ID) or
                 (prev.ActiveDoc.ID = -1)
               )
            then
            begin
              var hobj, idx: Integer;
              var AnnoObj: TbfaAnnotation;

              if prev.SingleView.img_DocView.SelObjectsCount > 0 then
                prev.SingleView.img_DocView.UnSelAllObjects;

              prev.SingleView.img_DocView.ObjPasteFromClipboard(25,25);
              prev.SingleView.gbAnnoNotSaved := True;
              prev.ActiveDoc.Modified_Annos := True;
              if prev.SingleView.img_DocView.SelObjectsCount > 0 then
              begin
                AnnoObj := prev.ActiveDoc.GetAnnotation(prev.ActivePage, prev.CurrentLayer, idx);
                if AnnoObj = nil then
                begin
                  AnnoObj := TbfaAnnotation.Create;
                  AnnoObj.Page := prev.ActivePage;
                  AnnoObj.Layer := prev.CurrentLayer;
                  AnnoObj.Modified := True;
                  //01.08.2024 SD -->bfacrm:ticket__show__39252
                  if AnnoObj.Layer = 0 then
                    AnnoObj.rights := prev.ActiveDoc.Rights
                  else if AnnoObj.Layer = bitfarmApp.User.ID then
                    AnnoObj.rights := (rightAPRead or rightAPWrite or rightAPModify)
                  else
                  begin
                    AnnoObj.rights := DbTableColumnGetInteger(Format('select bit_or(rights) from sys_docxs where gdocid = %d and src_userid = %d and userid = %d',
                      [prev.ActiveDoc.ID, AnnoObj.Layer, bitfarmApp.User.ID]));
                  end;
                  //01.08.2024 SD <--bfacrm:ticket__show__39252
                  prev.ActiveDoc.Annotations.Add(AnnoObj);
                end else
                  AnnoObj.Modified := True;

                for i := 0 to prev.SingleView.img_DocView.SelObjectsCount - 1 do
                begin
                  hobj := prev.SingleView.img_DocView.SelObjects[i];
                  prev.SingleView.createannodata(hobj);
                end;
                prev.SingleView.SetObjectPosition;
              end;
              prev.SingleView.saveannostream(True);
            end
            else
              Exit;
          end;
        end;
      end;

      // <!-- bfacrm:ticket__show__25771
      // SJ 28.09.2021 Lsung von Sagar war leider nicht vollstndig...
//      end
//      else if Shift = [ssAlt] then
//      begin
//        case Key of
//          vk_numpad0:{48:}         //--> 2/23/2021 bfacrm:ticket__show__25771
//            actAlt0.Execute;
//          {vk_numpad1:}49:
//           actAlt1.Execute;
//          {vk_numpad2:}50:
//            actAlt2.Execute;
//          {vk_numpad3:}51:
//            actAlt3.Execute;
//          {vk_numpad4:}52:
//            actAlt4.Execute;
//          {vk_numpad5:}53:
//            actAlt5.Execute;
//          {vk_numpad6:}54:
//            actAlt6.Execute;
//           {vk_numpad7:}55:
//            actAlt7.Execute;
//          {vk_numpad8:}56:
//            actAlt8.Execute;
//          {vk_numpad9:}57:         //<-- 2/23/2021 bfacrm:ticket__show__25771
//            actAlt9.Execute;
//        end;
//      end;
      // bfacrm:ticket__show__25771 -->
    except
      bitfarmApp.Log.Write(llNormal, ltException, 'FormKeyDown', ClassName);
    end;
  finally
//    bitfarmApp.Log.DebugEnd(llDebug, 'FormKeyDown', ClassName);
  end;
end;

procedure TfrmGPL.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  i, j, editmode: Integer;
  gdocid, arcid, symarcid, TimID, ResubUserID: Int64;
  doc: TbfaDocument;
  found: Boolean;
//24.05.2022  dsc : TDataSource;
begin
  if (not fAppStarted) or
     ((bitfarmapp <> nil) and bitfarmApp.ClosingMainForm) then
    Exit;

  try
    if Shift = [ssShift] then
    begin
      case Key of
        VK_UP, VK_DOWN:
        begin
//24.05.2022          dsc := grdResultlistDevExView.DataController.DataSource;

          if (Screen.ActiveControl is TcxGridSite) and (Screen.ActiveControl.Parent = grdResultlistDevEx) then
          begin
//13.03.2020 Das ist ein Workaround hier. Sonst berschreibt FThumbnailThread.SetObjectsWithList das gerade angezeigte Doc object mit clone (aber warum?) -->
            var tmpdoc : TbfaDocument;
            tmpdoc := bitfarmApp.CurrentContainer[0];
            bitfarmApp.ClearCurrentContainer;   //entfernt Document-Objekte, wenn nicht in Tabs geffnet
            grdResultlistDevExView.Controller.FocusedRecord.Selected := True;
            bitfarmApp.SelectedRowsToCurrentContainer(grdResultlistDevExView);
            var k : Integer;
            for k := 0 to bitfarmApp.CurrentContainer.count - 1 do
            begin
              if bitfarmApp.CurrentContainer[k].id = tmpdoc.ID then
              begin
                if (not bitfarmApp.CurrentContainer[k].Loaded) and tmpdoc.Loaded then
                begin
                  bitfarmApp.CurrentContainer[k] := nil;
                  bitfarmApp.CurrentContainer[k] := TbfaDocument.Create;
                  bitfarmApp.CurrentContainer[k].Clone(tmpdoc, True);
                end;
                Break;
              end;
            end;
//13.03.2020 <--
            grdResultlistChange(Sender);
          end;
        end;
      end;
    end
    else if Shift = [ssCtrl] then
    begin
      case Key of
        VK_UP, VK_DOWN:
        begin
          if not (bitfarmApp.CurrentView = tvkAdministrator) then  //25.08.2017 Ticket 11581
          begin
            if grdResultlistDevExView.DataController.RecordCount > 0 then
            begin
//05.04.2022              grdResultlistDevExView.Controller.FocusedRow.Selected := True;
              grdResultlistDevExView.Controller.FocusedRecord.Selected := True;
              bitfarmApp.SelectedRowsToCurrentContainer(grdResultlistDevExView);
            end;
          end;
        end;
      end;
    end
    //09.02.2024 bfacrm:ticket__show__37242 -->
    else if Shift = [ssCtrl,ssShift] then
    begin
      case Key of
        VK_HOME, VK_END:
        begin
          if not (bitfarmApp.CurrentView = tvkAdministrator) then  //25.08.2017 Ticket 11581
          begin
            if grdResultlistDevExView.DataController.RecordCount > 0 then
            begin
              grdResultlistDevExView.Controller.FocusedRecord.Selected := True;
              bitfarmApp.SelectedRowsToCurrentContainer(grdResultlistDevExView);
            end;
          end;
        end;
      end;
    end;
    //09.02.2024 bfacrm:ticket__show__37242 <--
    // SJ 26.04.2022
//    else if Shift = [] then
//    begin
//      case Key of
//        // 06.06.2019 bfacrm:ticket__show__20096  In KeyUp gewandert, weil in der Keydown kommt es zu doppelter Ausfhrung, wenn man zu lange drckt
//        VK_F2:
//          begin
//            if (bitfarmApp.CurrentView = tvkAdministrator) then
//            begin
//              if fraAdmin.btnSaveAdmin.Enabled then
//                fraAdmin.btnSaveAdminClick(nil);
//            end else
//            begin
//              if bitfarmApp.ActivePreview.ActiveDoc <> nil then
//              begin
//                if bitfarmApp.ActivePreview.PreviewKind = pvkMulti then
//                begin
//                  if (bitfarmApp.ActivePreview.ActiveDoc.ID <> -1) then
//                  begin
//                    if (not bitfarmApp.ActivePreview.ActiveDoc.InEditMode) then
//                      frmMainForm.actInProgress.Execute
//                    else
//                      frmMainForm.actSave.Execute;
//                  end
//                  else
//                    frmMainForm.actChangeDocName.Execute;
//                end
//                else if (bitfarmApp.ActivePreview.ActiveDoc.ID <> -1) then
//                begin
//                  if (not bitfarmApp.ActivePreview.ActiveDoc.InEditMode) then
//                    frmMainForm.actInProgress.Execute
//                  else
//                  begin
//                    if Assigned(Activecontrol) {Task 14604 Speichern mit F2} and
//                       Assigned(Activecontrol.Parent) and (Activecontrol.Parent is TcxDateEdit) and
//                      (TcxDateEdit(ActiveControl.Parent).Parent is TbfaAddfieldComp) then
//                      // Der Vergleich ist nicht erforderlich: Man kann immer den sichtbaren Wert durchposten.
//                      // Bei leerem Feld, fhr dies zu auerdem zu einer Exception
//                      {(TbfaAddfieldComp(TcxDateEdit(ActiveControl.Parent).Parent).compDateLow.Text <>
//                           TbfaAddfieldComp(TcxDateEdit(ActiveControl.Parent).Parent).compDateLow.EditValue) then }
//                      TbfaAddfieldComp(TcxDateEdit(ActiveControl.Parent).Parent).compDateLow.PostEditValue;
//                    frmMainForm.actSave.Execute;
//                  end;
//                end;
//              end;
//            end;
//          end;
//      end;
//    end;
// SJ 26.04.2022
  except
    bitfarmApp.Log.Write(llNormal, ltException, 'FormKeyUp', ClassName);
  end;
end;

//10.12.2021 Admin Frame Anpassungen -->
procedure TfrmGPL.SetAdminFrame;
var
  H, W : Integer;
begin
  if not frmMainForm.fraAdminScrollBox.VertScrollBar.IsScrollBarVisible
     or
     (frmMainForm.fraAdminScrollBox.Height - 5 < frmMainForm.fraAdmin.Height)
  then
  begin
    H := frmMainForm.fraAdminScrollBox.Height - 5;
    if H < 730 then
      H := 730;
    frmMainForm.fraAdmin.Height := H;
  end;
  if not frmMainForm.fraAdminScrollBox.HorzScrollBar.IsScrollBarVisible
     or
     (frmMainForm.fraAdminScrollBox.Width - 5 < frmMainForm.fraAdmin.Width)
  then
  begin
    W := frmMainForm.fraAdminScrollBox.Width - 5;
    if W < 1200 then
      W := 1200;
    frmMainForm.fraAdmin.Width := W;
  end;

end;
//10.12.2021 <--

procedure TfrmGPL.SetAdminFrameControls;
begin
  try
    //17.12.2021 gespeicherte Einstellungen laden. Erst ab Version 3.6.2.60 -->
    fraAdmin.bfsAssignAddfields.Left := 7;
    fraAdmin.bfsAssignAddfields.Width := fraAdmin.bfsAssignAddfields.Parent.Width - 14;
    fraAdmin.bfsAddfieldsUser.Left := 7;
    fraAdmin.bfsAddfieldsUser.Width := fraAdmin.bfsAddfieldsUser.Parent.Width - 14;
    fraAdmin.bfsAssignStatefields.Left := 7;
    fraAdmin.bfsAssignStatefields.Width := fraAdmin.bfsAssignStatefields.Parent.Width - 14;
    fraAdmin.bfsStatefieldsUser.Left := 7;
    fraAdmin.bfsStatefieldsUser.Width := fraAdmin.bfsStatefieldsUser.Parent.Width - 14;
    fraAdmin.chbxArchiveRights.Left := 9;
    fraAdmin.chbxArchiveRights.Width := fraAdmin.chbxArchiveRights.Parent.Width - 18;

    if FileExists(BD.AppdataBitfarmPd + 'ViewerLayout.ini') then
    begin
      var IniFile : TIniFile;
      IniFile := TIniFile.Create(BD.AppdataBitfarmPd + 'ViewerLayout.ini');
      try
        fraAdmin.tabctrAdmin.ActiveTabIndex := iniFile.ReadInteger('fraAdminFrame', 'ActiveTabIndex', 0); //13.12.2023 neu 3.6.2.203
        fraAdmin.SpTBXPanel21.Width := iniFile.ReadInteger('fraAdminFrame', 'SpTBXPanel21', 550);
        fraAdmin.bfsGroupsUser.SpTBXPanel1.Width := iniFile.ReadInteger('fraAdminFrame', 'bfsGroupsUser', 200);
        fraAdmin.SpTBXPanel11.Width := iniFile.ReadInteger('fraAdminFrame', 'SpTBXPanel11', 550);
        fraAdmin.bfsAssignUser.SpTBXPanel1.Width := iniFile.ReadInteger('fraAdminFrame', 'bfsAssignUser', 200);
        fraAdmin.SpTBXPanel13.Width := iniFile.ReadInteger('fraAdminFrame', 'SpTBXPanel13', 440);
        fraAdmin.bfsAssignAddfields.SpTBXPanel1.Width := iniFile.ReadInteger('fraAdminFrame', 'bfsAssignAddfields', 200);
        fraAdmin.bfsAddfieldsUser.SpTBXPanel1.Width := iniFile.ReadInteger('fraAdminFrame', 'bfsAddfieldsUser', 200);
        fraAdmin.SpTBXPanel16.Width := iniFile.ReadInteger('fraAdminFrame', 'SpTBXPanel16', 440);
        fraAdmin.bfsAssignStatefields.SpTBXPanel1.Width := iniFile.ReadInteger('fraAdminFrame', 'bfsAssignStatefields', 200);
        fraAdmin.bfsStatefieldsUser.SpTBXPanel1.Width := iniFile.ReadInteger('fraAdminFrame', 'bfsStatefieldsUser', 200);
        fraAdmin.SpTBXPanel8.Height := iniFile.ReadInteger('fraAdminFrame', 'SpTBXPanel8', 250);
        fraAdmin.SpTBXPanel10.Height := iniFile.ReadInteger('fraAdminFrame', 'SpTBXPanel10', 220);
//        fraAdmin.SpTBXPanel3.Width := iniFile.ReadInteger('fraAdminFrame', 'SpTBXPanel3', 600);
//        fraAdmin.SpTBXPanel4.Height := iniFile.ReadInteger('fraAdminFrame', 'SpTBXPanel4', 300);
//        fraAdmin.SpTBXPanel7.Height := iniFile.ReadInteger('fraAdminFrame', 'SpTBXPanel7', 300);
//        fraAdmin.bfsADGroups.SpTBXPanel1.Width := iniFile.ReadInteger('fraAdminFrame', 'bfsADGroups', 200);
//        fraAdmin.bfsInferior.SpTBXPanel1.Width := iniFile.ReadInteger('fraAdminFrame', 'bfsInferior', 200);
      finally
        FreeAndNil(IniFile);
      end;
    end else
    begin
      fraAdmin.tabctrAdmin.ActiveTabIndex := 0; //13.12.2023 neu 3.6.2.203
      fraAdmin.SpTBXPanel21.Width := 550;
      fraAdmin.bfsGroupsUser.SpTBXPanel1.Width := 200;
      fraAdmin.SpTBXPanel11.Width := 550;
      fraAdmin.bfsAssignUser.SpTBXPanel1.Width := 200;
      fraAdmin.SpTBXPanel13.Width := 440;
      fraAdmin.bfsAssignAddfields.SpTBXPanel1.Width := 432;
      fraAdmin.bfsAddfieldsUser.SpTBXPanel1.Width := 432;
      fraAdmin.SpTBXPanel16.Width := 440;
      fraAdmin.bfsAssignStatefields.SpTBXPanel1.Width := 432;
      fraAdmin.bfsStatefieldsUser.SpTBXPanel1.Width := 432;
      fraAdmin.SpTBXPanel8.Height := 250;
      fraAdmin.SpTBXPanel10.Height := 220;
//      fraAdmin.SpTBXPanel3.Width := 600;
//      fraAdmin.SpTBXPanel4.Height := 300;
//      fraAdmin.SpTBXPanel7.Height := 300;
//      fraAdmin.bfsADGroups.SpTBXPanel1.Width := 200;
//      fraAdmin.bfsInferior.SpTBXPanel1.Width := 200;
    end;
    //17.12.2021 gespeicherte Einstellungen laden. Erst ab Version 3.6.2.60 <--
  except

  end;
end;

procedure TfrmGPL.FormResize(Sender: TObject);
begin
  if (frmMainform = nil) or (not frmMainform.fAppStarted) then
    Exit;

  if (bitfarmApp <> nil) and (bitfarmApp.ClosingMainForm) then
    Exit;

  try
    if bitfarmApp.CurrentView = tvkAdministrator then
      SetAdminFrame
    else
    begin
      if bitfarmApp.CurrentView = tvkImporter then
      begin
        frmMainForm.SpTBXDockablePanel1.Height :=
          frmMainForm.pnlSearchOptions.Height -
          frmMainForm.fraScanFunctions.SpTBXGroupBox1.Height -
          frmMainForm.SpTBXSplitter3.Height - 45;
        bitfarmApp.FImporterSplitterSize := frmMainForm.SpTBXDockablePanel1.Height; //07.09.2023
      end
      else
      begin
        if frmMainForm.pnlSearchOptions.Height <=
           (frmMainForm.SpTBXDockablePanel1.Height +
            200 + frmMainForm.SpTBXSplitter3.Height) then
        begin
         frmMainForm.SpTBXDockablePanel1.Height :=
           frmMainForm.pnlSearchOptions.Height -
           200 - frmMainForm.SpTBXSplitter3.Height - 45;
        end;
      end;
    end;
  except
    bitfarmApp.Log.Write(llDebug, ltException, 'FormResize', ClassName);
  end;
end;

procedure TfrmGPL.TVChange(Sender: TObject; Node: TTreeNode);
var
  UserAction: PUserAction;
  Accept, CtrlPressed: Boolean;
begin
  if (Sender is TbfaTreeview) then
  begin
    if ((Node = nil) and not (TbfaTreeView(Sender) = FAdminTreeview)) or (not FappStarted) then
      Exit;
    if bitfarmApp.fDocumentSearch then
      Exit;

    if TbfaTreeView(Sender).FSkipChangeEvents then
      Exit;

    try
      CtrlPressed := (GetKeyState(VK_CONTROL) < 0); //04.02.2022

      if (Sender is TbfaTreeView) then
      begin
        // in der Admin Ansicht brauchen wir eine andere Action beim Archivwechsel
        if (TbfaTreeView(Sender) = FAdminTreeview) or ((bitfarmApp.CurrentView = tvkAdministrator) and   // nur wenn beides tvkAdministrator ist, sind wir im Adminframe
          (TbfaTreeView(Sender).ViewKind = tvkAdministrator)) then
        begin
          if (Node <> nil) and (TbfaTreeView(Sender).LastSelected <> PbfaInt64(Node.Data).Value) then
          begin
            if (TbfaTreeView(Sender).CountChecked = 1) and
               (TbfaTreeView(Sender).LastSelected > 0) and
               (TbfaTreeView(Sender).GetTreeNodeByID(TbfaTreeView(Sender).LastSelected) <> nil) and
               not CtrlPressed then   // wenn nur ein Element gechecked ist
              TbfaTreeView(Sender).Checked[TbfaTreeView(Sender).GetTreeNodeByID(TbfaTreeView(Sender).LastSelected)] := False;
            TbfaTreeView(Sender).CheckChilds := True;
            //04.02.2022 sollte wie im Explorer funktionieren... -->
            if not CtrlPressed then
            begin
              for var i := 0 to TbfaTreeView(Sender).Items.Count - 1 do
                TbfaTreeView(Sender).Checked[TbfaTreeView(Sender).Items.Item[i]] := False;
            end;
            //04.02.2022 sollte wie im Explorer funktionieren... <--
            TbfaTreeView(Sender).Checked[Node] := True;
            TbfaTreeView(Sender).CheckChilds := False;
            TbfaTreeView(Sender).LastSelected := PbfaInt64(Node.Data).Value;
            fraAdmin.SelectArchive(PbfaInt64(Node.Data).Value);
            fraAdmin.lblSelected.Caption := _('Selektiert:') + ' ' +IntToStr(TbfaTreeView(Sender).CountChecked);
          end;
        end else
        begin
          if (Node.Selected) and (Node.HasChildren) and (FIsDragging) then
            Node.Expand(False);

          if (TbfaTreeView(Sender).LastSelected <> PbfaInt64(Node.Data).Value) or (TbfaTreeView(Sender).ViewKind <> bitfarmApp.CurrentView) or (FRelogin) then
          begin
            // wenn wir mit einem aktualisierungspush vom server arbeiten, dann knnen wir das hier sparen
            UserAction := bitfarmApp.CreateUserAction;
            UserAction^.ActionName := 'actChangeArchive';
            UserAction^.Params.Add(GetEnumName(TypeInfo(TbfaViewKind), integer(TbfaTreeView(Sender).ViewKind)));
            UserAction^.Params.Add(IntToStr(TbfaTreeView(Sender).LastSelected));
            UserAction^.Params.Add(GetEnumName(TypeInfo(TbfaViewKind), integer(bitfarmApp.CurrentView)));

            UserAction^.Objects.Add(Node);
            UserAction^.Objects.Add(Sender); // wichtig im Action, wenn TreeviewClick passiert, dann Zusatzfelder mssen neu geladen werden

            if TbfaTreeView(Sender).ViewKind = tvkViewer then
            begin
              FViewerTreeview.LastSelected := PbfaInt64(Node.Data).Value;
              frmMainForm.FViewerTreeview.Refresh;
              frmMainForm.FViewerTreeview.OnCustomDrawItem(frmMainForm.FViewerTreeview, frmMainForm.FViewerTreeview.selected, [cdsSelected], Accept);
            end
            else if TbfaTreeView(Sender).ViewKind = tvkImporter then
            begin
              FImporterTreeview.LastSelected := PbfaInt64(Node.Data).Value;
              frmMainForm.FImporterTreeview.Refresh;
              frmMainForm.FImporterTreeview.OnCustomDrawItem(frmMainForm.FImporterTreeview, frmMainForm.FImporterTreeview.selected, [cdsSelected], Accept);
            end;
            TbfaTreeView(Sender).SaveToINI;
            bitfarmApp.MainThread.Add(UserAction);
          end;
        end;
      end;
    except
      bitfarmApp.Log.Write(llDebug, ltException, 'TVChange', ClassName);
    end;
  end;
end;

procedure TfrmGPL.TVMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var Node : TTreeNode;
begin
  inherited;
  if Button = mbRight then begin
    Node := TbfaTreeView(Sender).GetNodeAt(X,Y);
    if Node <> nil then Node.Selected := true;
  end;
end;

procedure TfrmGPL.TVMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var Node : TTreeNode;
begin
  inherited;
  if Button = mbRight then begin
    Node := TbfaTreeView(Sender).Selected;
    if Node <> nil then Node.Selected := true;
  end;
end;

procedure TfrmGPL.TVSelectionChanging(Sender: TObject; OldNode, NewNode: TJvTreeNode;
  Cause: TJvNodeSelectCause; var Allow: Boolean);
begin
  try
    if Allow then
      Allow := bitfarmApp.AllowedToLeaveCurrentDocs(Allow);
  except
    Allow := True;
    bitfarmLog.Write(llNormal, ltException, 'TVSelectionChanging', ClassName);
  end;
end;

{
//------------------------------------------------------------------------------
Name: TVClick
Parameters:
Beschreibung:
  Treeview OnClick Event
  Prft ob der Treeview zu der angezeigte Preview gehrt, wenn nicht dann
  setzt erst mal der richtige Preview und dann macht ein TreeviewChange
//------------------------------------------------------------------------------
}
procedure TfrmGPL.TVClick(Sender: TObject);
var
  AAllow: Boolean;
begin
  AAllow := True;
  try
    if (Sender is TbfaTreeview) then
    begin
      if ((bitfarmApp.CurrentView <> TbfaTreeView(Sender).ViewKind) or
         ((bitfarmApp.CurrentView = tvkViewer) and
          (not bitfarmApp.PreviewContainer.ViewerItem.Tab.Visible)) or
          ((bitfarmApp.CurrentView = tvkImporter) and
          (not bitfarmApp.PreviewContainer.ImporterItem.Tab.Visible))) then
      begin
        if TbfaTreeView(Sender).ViewKind = tvkViewer then
          bitfarmApp.SetActiveViewAction(pvtViewer, nil, tvkViewer)
        else if TbfaTreeView(Sender).ViewKind = tvkImporter then
          bitfarmApp.SetActiveViewAction(pvtImporter, nil, tvkImporter);

        if Assigned(TbfaTreeview(Sender).OnChanging) then
          TbfaTreeview(Sender).OnChanging(Sender, TbfaTreeView(Sender).Selected, AAllow);

        if Assigned(TbfaTreeview(Sender).OnChange) and AAllow then
          TbfaTreeview(Sender).OnChange(Sender, TbfaTreeView(Sender).Selected);
  //        TVChange(Sender, TbfaTreeView(Sender).Selected);
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'TVClick', ClassName);
  end;
end;

procedure TfrmGPL.SetPanelResubmissionCaption;
begin
  if bitfarmApp.FNewResubs > 0 then
    frmMainForm.pnlResubmission.Caption :=
      sCaptionResubmission + ' (' + IntToStr(bitfarmApp.TimidList.Count) + ')  ' +
      sCaptionNewResubmission + ' (' + IntToStr(bitfarmApp.FNewResubs) + ')'
  else
    frmMainForm.pnlResubmission.Caption :=
      sCaptionResubmission + ' (' + IntToStr(bitfarmApp.TimidList.Count) + ')';
end;

procedure TfrmGPL.SetPreviewSubMenus(Prev: TbfaPreview);
begin
  try
    Prev.bfaTlbStandard.tlbStandardSubmenuItemSave.Action := frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action;
    Prev.bfaTlbStandard.tlbStandardSubmenuItemEmail.Action := frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action;
    Prev.bfaTlbStandard.tlbStandardSubmenuItemPrint.Action := frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemPrint.Action;
    Prev.bfaTlbStandard.tlbStandardSubmenuItemClipboard.Action := frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetPreviewSubMenus', ClassName);
  end;
end;

procedure TfrmGPL.SetTabStop(Ctrl: TWinControl; Value: Boolean);
var
  i: Integer;
begin
  try
    for i := 0 to Ctrl.ComponentCount - 1 do
    begin
      if (Ctrl.Components[i] is TWinControl) and
          not ((Ctrl.Components[i] is TbfaInputCombo) or (Ctrl.Components[i] is TSpTBXGroupBox) {or (Ctrl.Components[i] is TbfaSelectoror)})
      then
        TWinControl(Ctrl.Components[i]).TabStop := Value;
    end;
    Ctrl.TabStop := Value;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetTabStop', ClassName);
  end;
end;

procedure TfrmGPL.SetUpdaterCaption;
begin
  // Enterprise-Feature
end;

procedure TfrmGPL.ShowTasks;
var
  HD : HWND;
begin
  bitfarmApp.SetCW(Date);
  bitfarmApp.RefreshCWLabel(nil, Date);

  hd := FindWindow('bitfarm.hotsearch.V36', nil);
  bitfarmLog.Write(llDebug, ltInfo, 'ShowTasks befor sendMessage', ClassName);
  sendMessage(hd, WM_HOTKEY_WVL_MESSAGE, 1, 1);
  bitfarmLog.Write(llDebug, ltInfo, 'ShowTasks after sendMessage', ClassName);
//22.02.2022 -->
//  if (bitfarmApp.ResubKind = rkMyTasks) or (bitfarmApp.ResubKind = bfaCommonUtils.rkNone) then
//    actMyTasks.Execute
//  else if (bitfarmApp.ResubKind = rkController) then
//    actDelegateTasks.Execute;
  if (Self.fraResub.ResubKind = rkMyTasks) or (Self.fraResub.ResubKind = bfaCommonUtils.rkNone) then
    actMyTasks.Execute
  else if (Self.fraResub.ResubKind = rkController) then
    actDelegateTasks.Execute;
//22.02.2022 <--
end;

//procedure TfrmGPL.SetNavigationPanelsTabStop;
//begin
//  try
//    SetTabStop(pnlTreeView, False);
//    SetTabStop(fraImporter, False);
//    SetTabStop(fraWorkplace, False);
//    SetTabStop(fraResub, False);
//    FViewerTreeview.TabStop := False;
//    FImporterTreeview.TabStop := False;
//    if FAdminTreeview <> nil then
//      FAdminTreeview.TabStop := False;
//    trvBookmarks.TabStop := False;
//  except
//    bitfarmLog.Write(llNormal, ltException, 'SetNavigationPanelsTabStop', ClassName);
//  end;
//end;

procedure TfrmGPL.SetNavigationPanels;
var
  ShowButton: Boolean;
begin
  bitfarmLog.DebugBegin(llDebug, 'SetNavigationPanels', Classname);
  try
    try
//10.01.2020 neue Inis      if (not FDefaultLayout) and FileExists(BD.AppdataBitfarm + '\Mainform.ini') and
      if (not FDefaultLayout) and ((bitfarmApp.ViewerLayout <> '') or
         FileExists(BD.AppdataBitfarm + '\Mainform.ini'))
      then
      begin
        if (bitfarmApp.ViewerLayout = '') and FileExists(BD.AppdataBitfarm + '\Mainform.ini') then
          JvAppIniFileStorage1.FileName :=  BD.AppdataBitfarm + '\Mainform.ini'; //Rckwertskompatibilitt beim erstart von 36
        JvFormStorage1.RestoreFormPlacement;
        // wir setzen den Pfad zurck
        JvAppIniFileStorage1.FileName := BD.AppdataBitfarmPd + 'ViewerLayout.ini';
      end
      else
      begin
        // keine inis - default Einstellungen der Toolbars
        Self.tlbGraphic.Visible := False;
        Self.tlbMainMenu.Visible := True;
        Self.tlbTools.Visible := False;
        Self.tlbStatefields.Visible := False;
        Self.tlbDocState.Visible := True;
        Self.tlbPlugins.Visible := False;
        Self.bfaTlbStandard1.Visible := True;
        Self.bfaTlbPreview1.Visible := True;
        Self.tlbResubFavs.Visible := False;
        Self.tlbQueueCount.Visible := True;

        if (FLastActivePreview = 0) then
        begin
          pnlTreeView.Maximize;
          pnlFavorites.Minimize;
          pnlWorkspace.Minimize;
          pnlImporter.Minimize;
          pnlResubmission.Minimize;
          pnlAdmin.Minimize;
        end
        else if FLastActivePreview = 1 then
        begin
          pnlImporter.Maximize;
          pnlFavorites.Minimize;
          pnlWorkspace.Minimize;
          pnlResubmission.Minimize;
          pnlAdmin.Minimize;
          pnlTreeView.Minimize;
        end
        else if FLastActivePreview = 2 then
        begin
          pnlWorkspace.Maximize;
          pnlFavorites.Minimize;
          pnlImporter.Minimize;
          pnlResubmission.Minimize;
          pnlAdmin.Minimize;
          pnlTreeView.Minimize;
        end
        else if FLastActivePreview = 3 then
        begin
          pnlResubmission.Maximize;
          pnlFavorites.Minimize;
          pnlWorkspace.Minimize;
          pnlImporter.Minimize;
          pnlAdmin.Minimize;
          pnlTreeView.Minimize;
        end
        else if FLastActivePreview = 4 then
        begin
          pnlFavorites.Maximize;
          pnlResubmission.Minimize;
          pnlWorkspace.Minimize;
          pnlImporter.Minimize;
          pnlAdmin.Minimize;
          pnlTreeView.Minimize;
        end
        else if (FLastActivePreview = 5) and bitfarmApp.User.isAdmin then
        begin
          pnlAdmin.Maximize;
          pnlResubmission.Minimize;
          pnlFavorites.Minimize;
          pnlWorkspace.Minimize;
          pnlImporter.Minimize;
          pnlTreeView.Minimize;
        end
        else
        begin
          pnlTreeView.Maximize;
          pnlFavorites.Minimize;
          pnlWorkspace.Minimize;
          pnlImporter.Minimize;
          pnlResubmission.Minimize;
          pnlAdmin.Minimize;
          FLastActivePreview := 0; // SJ 20.11.2020 - invalid Preview? Set to valid
        end;
      end;
      bitfarmApp.ShowToolbars(not ((FLastActivePreview = 5) and (bitfarmApp.User.isAdmin)));

      ShowButton := False; //22.10.2021 war immer True (not bitfarmApp.ViewerOptions.GeneralOptions.SimpleNavigationView);
      pnlTreeView.Options.MinimizeButton.Visible := ShowButton;
      pnlTreeView.Options.MaximizeButton.Visible := ShowButton;
      pnlTreeView.Resizable := ShowButton;
      pnlFavorites.Options.MinimizeButton.Visible := ShowButton;
      pnlFavorites.Options.MaximizeButton.Visible := ShowButton;
      pnlFavorites.Resizable := ShowButton;
      pnlWorkspace.Options.MinimizeButton.Visible := ShowButton;
      pnlWorkspace.Options.MaximizeButton.Visible := ShowButton;
      pnlWorkspace.Resizable := ShowButton;
      pnlImporter.Options.MinimizeButton.Visible := ShowButton;
      pnlImporter.Options.MaximizeButton.Visible := ShowButton;
      pnlImporter.Resizable := ShowButton;
      pnlResubmission.Options.MinimizeButton.Visible := ShowButton;
      pnlResubmission.Options.MaximizeButton.Visible := ShowButton;
      pnlResubmission.Resizable := ShowButton;
      pnlAdmin.Options.MinimizeButton.Visible := ShowButton;
      pnlAdmin.Options.MaximizeButton.Visible := ShowButton;
      pnlAdmin.Resizable := ShowButton;
    except
      bitfarmLog.Write(llNormal, ltException, 'SetNavigationPanels', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetNavigationPanels', Classname);
  end;
end;

procedure TfrmGPL.FormShow(Sender: TObject);
var
  i: Integer;
  ini: TIniFile;
  LayoutName, lsLgrname, lsArcname : string;
  fndfile : Boolean;
  UserAction: PUserAction;
  ScreenWidth, ScreenHeight : Integer;
begin
  Screen.Cursor := crHourGlass;
  bitfarmLog.DebugBegin(llDebug, 'FormShow', ClassName);
  try

    if bitfarmApp.ViewerOptions.GeneralOptions.DragDropAsWindows then
      Self.dftMainForm.DragTypes := [dtCopy, dtMove]
    else
      Self.dftMainForm.DragTypes := [dtCopy];

    DropFileSource1.DragTypes := [dtMove, dtLink];   // In der GPL keine SymbolicLinks durchs verschieben

    dxAlertWindowManager1.OnButtonClick := bitfarmApp.AlertWindowButtonClick;

    SetStatusBar;
    bitfarmApp.RefreshCWLabel(nil, Date);

    Self.trvBookmarks.BorderStyle := bsNone;

// weil im Create gibt es nocht nicht deswegen muss hier eingestellt werden...
    SetPreviewSubMenus(bitfarmApp.PreviewContainer.ViewerItem.Preview);
    SetPreviewSubMenus(bitfarmApp.PreviewContainer.ImporterItem.Preview);
    SetPreviewSubMenus(bitfarmApp.PreviewContainer.WorkplaceItem.Preview);

    bitfarmLog.Write(llDebug, ltInfo ,'lade Importer...', ClassName);
    frmSplash.lblLoading.Caption := sMsgLoadImporter;
    frmSplash.Update;

//26.02.2024 bfacrm:ticket__show__35767 -->
//    // SJ 15.11.2021 - in SetNavigationPanels wird RestoreFormPlacement aufgerufen.
//    //               - dort wurden die Toolbars wieder eingeblendet. Deswegen vorziehen
//    SetNavigationPanels;

    if (bitfarmApp.CurrentView = tvkAdministrator) then
    begin
      if not(frmMainForm.tlbGraphic.Visible = bitfarmApp.tlbGraphicVisible) then
        bitfarmApp.tlbGraphicVisible := frmMainForm.tlbGraphic.Visible;

      if not(frmMainForm.bfaTlbStandard1.Visible = bitfarmApp.bfaTlbStandard1Visible) then
        bitfarmApp.bfaTlbStandard1Visible := frmMainForm.bfaTlbStandard1.Visible;

      if not(frmMainForm.bfaTlbPreview1.Visible = bitfarmApp.bfaTlbPreview1Visible) then
        bitfarmApp.bfaTlbPreview1Visible := frmMainForm.bfaTlbPreview1.Visible;

      if not(frmMainForm.tlbTools.Visible = bitfarmApp.tlbToolsVisible) then
        bitfarmApp.tlbToolsVisible := frmMainForm.tlbTools.Visible;

      if not(frmMainForm.tlbStatefields.Visible = bitfarmApp.tlbStatefieldsVisible) then
        bitfarmApp.tlbStatefieldsVisible := frmMainForm.tlbStatefields.Visible;

      if not(frmMainForm.tlbDocState.Visible = bitfarmApp.tlbDocStateVisible) then
        bitfarmApp.tlbDocStateVisible := frmMainForm.tlbDocState.Visible;

      if not(frmMainForm.tlbResubFavs.Visible = bitfarmApp.tlbResubFavsVisible) then
        bitfarmApp.tlbResubFavsVisible := frmMainForm.tlbResubFavs.Visible;

      {$IFDEF ENTERPRISE}
      if not(frmMainForm.tlbPlugins.Visible = bitfarmApp.tlbPluginsVisible) and not bitfarmApp.OfflineMode then
        bitfarmApp.tlbPluginsVisible := frmMainForm.tlbPlugins.Visible;
      {$ENDIF}

      frmMainForm.tlbGraphic.Visible := False;
      frmMainForm.tlbTools.Visible := False;
      frmMainForm.tlbStatefields.Visible := False;
      frmMainForm.tlbStatefields.Visible := False;
      {$IFDEF ENTERPRISE}
      frmMainForm.tlbPlugins.Visible := False;
      {$ENDIF}
      frmMainForm.bfaTlbStandard1.Visible := False;
      frmMainForm.bfaTlbPreview1.Visible := False;
      frmMainForm.tlbResubFavs.Visible := False;
    end;

    // SJ 15.11.2021 - in SetNavigationPanels wird RestoreFormPlacement aufgerufen.
    //               - dort wurden die Toolbars wieder eingeblendet. Deswegen vorziehen
    SetNavigationPanels;
//26.02.2024 bfacrm:ticket__show__35767 <--


    //15.03.2022 FloatingResubPanel muss auch gespeichert werden. wegen ein Fehler wird nicht mit SaveLayout gepaichert -->
    ini := TIniFile.Create(BD.AppdataBitfarmPd + 'ViewerLayout.ini');
    try
      var X, Y : Integer;
      X := ini.ReadInteger('pnlFloatingResub', 'FloatLeft', 50);
      Y := ini.ReadInteger('pnlFloatingResub', 'FloatTop', 50);

      ScreenWidth := GetSystemMetrics(SM_CXVIRTUALSCREEN);
      if (X > ScreenWidth) then
        X := 50;
      ScreenHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
      if (Y > ScreenHeight) then
        Y := 50;
      pnlFloatingResub.FloatingPosition := Point(X,Y);
      pnlFloatingResub.Height := ini.ReadInteger('pnlFloatingResub', 'Height', 353);
      pnlFloatingResub.Width := ini.ReadInteger('pnlFloatingResub', 'Width', 995);
      pnlFloatingResub.Visible := ini.ReadBool('pnlFloatingResub', 'Visible', False);


      bitfarmApp.FViewerSplitterSize := ini.ReadInteger('Splitter', 'FViewerSplitterSize', 318);
      bitfarmApp.FImporterSplitterSize := ini.ReadInteger('Splitter', 'FImporterSplitterSize', 318);
      if (bitfarmApp.FViewerSplitterSize <> 0) and (bitfarmApp.CurrentView = tvkViewer) then
        Self.SpTBXDockablePanel1.Height := bitfarmApp.FViewerSplitterSize
      //07.09.2023 -->
      else if (bitfarmApp.FImporterSplitterSize <> 0) and (bitfarmApp.CurrentView = tvkImporter) then
        Self.SpTBXDockablePanel1.Height := bitfarmApp.FImporterSplitterSize;
      //07.09.2023 <--
    finally
      FreeAndNil(ini);
    end;
    //15.03.2022 FloatingResubPanel muss auch gespeichert werden. wegen ein Fehler wird nicht mit SaveLayout gepaichert <--

    if Splitter3Top <> 0 then    // Gemeinerweise konnte man die Top und PrevSize Properties der Splitter nicht per JvFormStorage1 speichern
    begin                        // wenn der Splitter minimiert war und das in der FormCreate wiederhergestellt wurde, dann wurde das minimierte
      SpTBXPanel3.Height := Splitter3Top - pnlQuickSearch.Height - 19;  // SpTBXPanel3 hinterher nicht mehr angezeigt
      SpTBXSplitter3.Top := Splitter3Top;                           // daher wird das hier umstndlicherweise in der FormShow wiederhergestellt
    end;                                                 // und die Properties mssen in der ViewerLayout.Ini gespeichert werden

    if splTreeviewPrevSize <> 0 then
      splTreeview.PrevSize := splTreeviewPrevSize;
    if Splitter2PrevSize <> 0 then
      SpTBXSplitter2.PrevSize := Splitter2PrevSize;
    if Splitter3PrevSize <> 0 then
      SpTBXSplitter3.PrevSize := Splitter3PrevSize;

    with bitfarmApp.PreviewContainer.PageSortingsItem.Panel do
    begin
      LastDock := Self.SpTBXMultiDock2;
      CurrentDock := Self.SpTBXMultiDock2;
    end;

    bitfarmApp.FillMarkedDocs;
    bitfarmApp.RefreshMarkedDocs(nil);

    pnlSearchOptions.bfaMaximizePanel := bitfarmApp.DockSearchOptions;

    bitfarmApp.RefreshScanCombos(True);

//17.01.2024 als thrtead gestartet, dort sollte angezeigt werden
//    bitfarmLog.Write(llDebug, ltInfo, 'lade Lesezeichen...', Classname);
//    frmSplash.lblLoading.Caption := sMsgLoadBookmarks;
//    frmSplash.Update;

    LoadBookmarks;

    if not bitfarmApp.OfflineMode then
    begin
      LoadDocumentsFromXML(0);
      LoadDocumentsFromXML(1);
    end;

    fAppStarted := True;

    if bitfarmApp.ViewerOptions.ResubOptions.ResubOnStartup then
      CheckResubAction;

    FRelogin := True;
    try
      FViewerTreeview.ChangeDelay := tvChangeDelay;
      FImporterTreeview.ChangeDelay := tvChangeDelay;
      fndfile := False;
      for i := 0 to ParamCount do
      begin
        if Pos('.fnd', ParamStr(i)) > 0 then
        begin
          try
            ini := TIniFile.Create(ParamStr(i));
            lsLgrname := ParseSQLString(ini.ReadString('Lager', 'Name', ''));
            lsArcname := ParseSQLString(ini.ReadString('Archiv', 'Name', ''));
          finally
            FreeAndNil(ini);
          end;
          fndfile := (lsLgrname <> '') or (lsArcname <> '');
          Break;
        end;
      end;

      if (FLastActivePreview = pvtViewer) and (not fndfile) then
        TVChange(FViewerTreeview, FViewerTreeview.Selected)
      else if FLastActivePreview = pvtImporter then
        TVChange(FImporterTreeview, FImporterTreeview.Selected)
      else if (FLastActivePreview = pvtResub) and (not fndfile) then
      begin
        bitfarmApp.CurrentArchive := bitfarmApp.CurrentResubArchive;
        bitfarmApp.SetActiveViewAction(pvtViewer, nil, tvkResub);
        ShowTasks;
      end;
    finally
      FRelogin := False;
    end;

    if (bfaTlbPreview1 <> nil) and (bfaTlbPreview1.edtPageNumber <> nil) then
    begin
      bfaTlbPreview1.edtPageNumber.OnChange := bitfarmApp.PageNumberChange;
      bfaTlbPreview1.edtPageNumber.OnKeyDown := Self.edtPageNumberKeyUp;
//30.08.2022      bfaTlbPreview1.edtPageNumber.OnAcceptText := bitfarmApp.AcceptText;
    end;

    tcSearch.Toolbar.BeginUpdate;
    try
      if (FLastActiveTab <= tcSearch.Items.Count - 1) and (tcSearch.Items[FLastActiveTab].Visible) then //03.03.2017 Ticket 9986
        tcSearch.ActiveTabIndex := FLastActiveTab
      else
        tcSearch.ActiveTabIndex := 0;
    finally
      tcSearch.Toolbar.EndUpdate;
    end;

    if ParamCount > 0 then
    begin
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actHandleParam';
      for i := 1 to ParamCount do
        UserAction^.Params.Add(ParamStr(i));
      bitfarmApp.MainThread.Add(UserAction);
    end;

    if bitfarmApp.GetActivePreview = bitfarmApp.PreviewContainer.ImporterItem.Preview then
      bitfarmApp.PreviewContainer.ImporterItem.Preview.SetActions;

    if fraImporterResub <> nil then
      bitfarmApp.FillResubFavCombo(fraImporterResub.cbbFavorites);

    actRangeOCR.ShortCut := bitfarmApp.ViewerOptions.EditorOptions.OCRKey;

    SetLimit(bitfarmApp.ViewerOptions.SearchOptions.Limit);

    if not bitfarmApp.User.isAdmin then
    begin
      fSearchOption := (fSearchOption and not 1024);
      tbiSo3Click(popSearchOption3.Items[0]);
    end;

    Self.bfaTlbStandard1.tlbStandardTreeView.Checked := pnlTreeView.Maximized and (dckTreeView.Width <> 0);
    Self.bfaTlbStandard1.tlbStandardSearchOptions.Checked := not SpTBXSplitter3.Minimized;
    Self.bfaTlbStandard1.tlbStandardThumbnail.Checked := (bitfarmApp.GetActivePreview <> nil) and
      (bitfarmApp.GetActivePreview.ShowThumbnail);

    if FSearchthread.bfagrid <> nil then //09.07.2024
      bitfarmApp.RetranslateSearchgrid(FSearchthread.bfagrid);
    pnlSearch.Borders := False;

    if pnlFloatingResub.Visible then
    begin
      Self.ShowFloatingResub := True;
      bitfarmApp.ShowFloatingResub;
    end;

    //25.11.2021 bt weil in Version 361 noch einige Einstellungen Probleme auslsen knnen, deswegen hier sicherheitshalber ... -->
    Self.bfaTlbStandard1.tlbStandardTreeView.Checked := dckTreeView.Width <> 0; //beim start manchmal nicht checked
    if (splTreeView.Left > 0) and (splTreeView.Left < fpnlTreeviewWidth) then
      splTreeView.PrevSize := fpnlTreeviewWidth;
    if pnlTreeView.CurrentDock <> SpTBXMultiDock5 then
      pnlTreeView.CurrentDock := SpTBXMultiDock5;
    if pnlImporter.CurrentDock <> SpTBXMultiDock5 then
      pnlImporter.CurrentDock := SpTBXMultiDock5;
    if pnlWorkspace.CurrentDock <> SpTBXMultiDock5 then
      pnlWorkspace.CurrentDock := SpTBXMultiDock5;
    if pnlResubmission.CurrentDock <> SpTBXMultiDock5 then
      pnlResubmission.CurrentDock := SpTBXMultiDock5;
    if pnlFavorites.CurrentDock <> SpTBXMultiDock5 then
      pnlFavorites.CurrentDock := SpTBXMultiDock5;
    if pnlAdmin.CurrentDock <> SpTBXMultiDock5 then
      pnlAdmin.CurrentDock := SpTBXMultiDock5;
    if bitfarmApp.ViewerLayout = '' then
    begin
      if (bitfarmApp.CurrentView in [tvkViewer, tvkFavorites, tvkResub, tvkNone]) or
         ((bitfarmApp.CurrentView = tvkAdministrator) and not bitfarmApp.User.isAdmin)
      then
        pnlTreeView.Maximize
      else if bitfarmApp.CurrentView = tvkImporter then
        pnlImporter.Maximize
      else if bitfarmApp.CurrentView = tvkWorkplace then
        pnlWorkspace.Maximize
      else if bitfarmApp.CurrentView = tvkAdministrator then
        pnlAdmin.Maximize;

      if (not FDefaultLayout) and (bitfarmApp.ViewerOptions.GUIOptions.SearchPanelFloating) then
      begin
        pnlSearchOptions.Visible := False;
        try
          ScreenWidth := -1;
          ScreenWidth := GetSystemMetrics(SM_CXVIRTUALSCREEN);
          with bitfarmApp.ViewerOptions.GUIOptions do
          begin
            var Pos : TPoint;
            if (ScreenWidth <> -1) and (SearchPanelFloatingPosX < ScreenWidth) then
              Pos.X := SearchPanelFloatingPosX
            else
              Pos.X := 0;
            Pos.Y := SearchPanelFloatingPosY;
            pnlSearchOptions.FloatingPosition := Pos;
            pnlSearchOptions.FloatingClientHeight := SearchPanelFloatingHeight;
            pnlSearchOptions.FloatingClientWidth := SearchPanelFloatingWidth;
          end;
        finally
          pnlSearchOptions.Floating := True;
          pnlSearchOptions.Visible := True;
        end;
      end;
    end;
    //25.11.2021 bt <--

    edtGeneralSearch.Width := pnlQuickSearch.Width - pnlSearchTimer.width - pnlLoadDoc.Width - 20; //09.07.2020 Ticket 23626

//10.09.2020 -->
    frmMainForm.Font.Size := bfaFontSize;
    tcSearch.Font.Size := bfaFontSize;
    tabSearchStandard.FontSettings.Size := bfaFontSettingsSize;
    tabSearchAddfields.FontSettings.Size := bfaFontSettingsSize;
    tabSearchLinks.FontSettings.Size := bfaFontSettingsSize;
//10.09.2020 <--

    //bt17.12.2021 gespeicherte Einstellungen laden. Erst ab Version 3.6.2.60 -->
    //Wichtig wenn im Adminbereich geffnet werden muss
    if frmMainForm.fAppStarted and (fraAdmin <> nil) then
    begin
      frmMainForm.SetAdminFrame;
      frmMainForm.SetAdminFrameControls;
      //bt07.02.2022 Ticket 29947 -->
      if bitfarmApp.CurrentView = tvkAdministrator then
      begin
        if (FAdminTreeview.Selected <> nil) and (not FAdminTreeview.Checked[FAdminTreeview.Selected]) then
          FAdminTreeview.Checked[FAdminTreeview.Selected] := True;
      end;
      //bt07.02.2022 Ticket 29947 <--
    end;
    //bt17.12.2021 gespeicherte Einstellungen laden. Erst ab Version 3.6.2.60 <--

    frmMainForm.tmrQueueCount.Enabled := not bitfarmApp.OfflineMode;
    frmMainForm.tmrHeartbeat.Interval := System.Trunc((bitfarmApp.Usertimeout * 0.4)) * 1000;   // 2/5tel vom Timeout
    frmMainForm.tmrHeartBeat.Enabled := bitfarmApp.Autoreconnect and not frmMainForm.tmrQueueCount.Enabled;  //nur noch aktivieren, wenn es keinen QueueCount gibt

    if Width < 350 then
      Width := 350;

    if SaveInitLayout then
    begin
      SpTBXMultiDock2.Width := fpnlSearchWidth;
      dckTreeView.Width := fpnlTreeviewWidth;
      SaveLayoutAndIni;
    end;
  finally
    FDefaultLayout := False;
    frmSplash.Hide;

    bitfarmApp.ViewChanging := False;
    Screen.Cursor := crDefault;

    SetMainFormFocus; // bfacrm:ticket__show__24708

    bitfarmLog.Write(llNormal, ltInfo, 'Ende Base FormShow', ClassName);
    bitfarmLog.DebugEnd(llDebug, 'FormShow', ClassName);
  end;
end;

procedure TfrmGPL.SaveLayoutAndIni;
var
  Inifile: TIniFile;
begin
  try
    // SJ 10.10.2022 - die Probleme die es bei tvkAdministrator gab (Toolbars) sollten durch das hinzufgen
    // zu JvFormStorage1 gelst sein.
    if not bitfarmApp.OfflineMode then
    begin
      try
        // muss vor JvFormStorage1.SaveFormPlacement sein
        SpTBXCustomizer1.SaveLayout(BD.AppdataBitfarmPd + 'ViewerLayout.ini', 'Standard'); //09.01.2020 Schreiben muss immer nur Lokal
        bitfarmLog.Write(llDebug, ltinfo, 'Layout Saved: ' + BD.AppdataBitfarmPd + 'ViewerLayout.ini', Classname);
      except
        bitfarmLog.Write(llNormal, ltException, 'SpTBXCustomizer1.SaveLayout;', ClassName);
      end;


      // SJ 10.10.2022
      // SpTBXCustomizer1.SaveLayout luft vorher.
      // JvAppIniFileStorage1 hat AutoReload und AutoFlush gesetzt, dadurch wird das vorherigen SaveLayout neu geladen
      // sonst kann es passieren dass die eine Komponente die Werte der anderen Komponente berschreibt...
      if JvAppIniFileStorage1.FileName <> (BD.AppdataBitfarmPd + 'ViewerLayout.ini') then
        JvAppIniFileStorage1.FileName := BD.AppdataBitfarmPd + 'ViewerLayout.ini'; //10.01.2020 neue Inis
      JvFormStorage1.SaveFormPlacement;

      IniFile := TIniFile.Create(BD.AppdataBitfarmPd + 'ViewerLayout.ini');
      try
        SaveAdminFrameControls(IniFile);

        //15.03.2022 FloatingResubPanel muss auch gespeichert werden. wegen ein Fehler wird nicht mit SaveLayout gepaichert -->
        iniFile.WriteInteger('pnlFloatingResub', 'FloatLeft', pnlFloatingResub.FloatingPosition.X);
        iniFile.WriteInteger('pnlFloatingResub', 'FloatTop', pnlFloatingResub.FloatingPosition.Y);
        iniFile.WriteInteger('pnlFloatingResub', 'Height', pnlFloatingResub.Height);
        iniFile.WriteInteger('pnlFloatingResub', 'Width', pnlFloatingResub.Width);
        iniFile.WriteBool('pnlFloatingResub', 'Visible', pnlFloatingResub.Visible);
        //15.03.2022 FloatingResubPanel muss auch gespeichert werden. wegen ein Fehler wird nicht mit SaveLayout gepaichert <--

        iniFile.WriteInteger('Splitter', 'FViewerSplitterSize', bitfarmApp.FViewerSplitterSize);
        iniFile.WriteInteger('Splitter', 'FImporterSplitterSize', bitfarmApp.FImporterSplitterSize);
      finally
        FreeAndNil(IniFile);
      end;
    end;
    SaveInitLayout := False;
  except
    //
  end;
end;

procedure TfrmGPL.grdOnDeselect;
begin
  try
    bitfarmApp.ClearCurrentContainer;
    grdOnSelectAll;
  except
    bitfarmLog.Write(llNormal, ltException, 'grdOnDeselect', ClassName);
  end;
end;

procedure TfrmGPL.grdOnSelectAll;
var
  lBM: TBookmark;
  i, j, editmode: Integer;
  gdocid, arcid, symarcid, TimID, ResubUserID: Int64;
  found: Boolean;
  doc: TbfaDocument;
begin
//30.03.2021
//  try
//    if lBM = nil then
//      lBM := grdResultlist.DataSource.DataSet.GetBookmark;
//    grdResultlist.DataSource.DataSet.DisableControls;
//
//    for i := 0 to grdResultlist.SelectedRows.Count - 1 do
//    begin
//      {$IF CompilerVersion >= 26}
//      grdResultlist.DataSource.DataSet.GotoBookmark(TBookmark(grdResultlist.SelectedRows.Items[i]));
//      {$ELSE}
//      grdResultlist.DataSource.DataSet.GotoBookmark(Pointer(grdResultlist.SelectedRows.Items[i]));
//      {$IFEND}
//
//      gdocid := grdResultlist.DataSource.DataSet.FieldByName('gdocid').AsInteger;
//      if (grdresultList.DataSource.DataSet.FieldDefList.Find('arcid') <> nil) and
//          ((not VarIsNull(grdresultList.DataSource.DataSet.FieldValues['arcid'])) and
//          VarIsNumeric(grdresultList.DataSource.DataSet.FieldValues['arcid'])) then
//        arcid := grdresultList.DataSource.DataSet.FieldByName('arcid').AsLargeInt
//      else
//        arcid := -1;
//
//      if (grdresultList.DataSource.DataSet.FieldDefList.Find('symarcid') <> nil) and
//          ((not VarIsNull(grdresultList.DataSource.DataSet.FieldValues['symarcid'])) and
//          VarIsNumeric(grdresultList.DataSource.DataSet.FieldValues['symarcid'])) then
//        symarcid := grdresultList.DataSource.DataSet.FieldByName('symarcid').AsLargeInt
//      else
//        symarcid := -1;
//
//      if (grdresultList.DataSource.DataSet.FieldDefList.Find('timid') <> nil) and
//          ((not VarIsNull(grdresultList.DataSource.DataSet.FieldValues['timid'])) and
//          VarIsNumeric(grdresultList.DataSource.DataSet.FieldValues['timid'])) then
//        TimID := grdresultList.DataSource.DataSet.FieldByName('timid').AsLargeInt
//      else
//        TimID := -1;
//
//      if (grdresultList.DataSource.DataSet.FieldDefList.Find('userid_shed') <> nil) and
//          ((not VarIsNull(grdresultList.DataSource.DataSet.FieldValues['userid_shed'])) and
//          VarIsNumeric(grdresultList.DataSource.DataSet.FieldValues['userid_shed'])) then
//        ResubUserID := grdresultList.DataSource.DataSet.FieldByName('userid_shed').AsLargeInt
//      else
//        ResubUserID := -1;
//
//      if (grdresultList.DataSource.DataSet.FieldDefList.Find('editmode') <> nil) and
//          ((not VarIsNull(grdresultList.DataSource.DataSet.FieldValues['editmode'])) and
//          VarIsNumeric(grdresultList.DataSource.DataSet.FieldValues['editmode'])) then
//        editmode := grdresultList.DataSource.DataSet.FieldByName('editmode').AsLargeInt
//      else
//        editmode := 0;
//
//      found := False;
//      for j := 0 to bitfarmApp.CurrentContainer.Count - 1 do
//      begin
//        if TimID = -1 then
//        begin
//          if gdocid = bitfarmApp.CurrentContainer[j].ID then
//          begin
//            found := True;
//            Break;
//          end;
//        end else begin
//          if (gdocid = bitfarmApp.CurrentContainer[j].ID) and (TimID = bitfarmApp.CurrentContainer[j].TimID) then
//          begin
//            found := True;
//            Break;
//          end;
//        end;
//      end;
//
//      if not found then
//      begin
//        doc := TbfaDocument.Create;
//        doc.ID := gdocid;
//        doc.ArcID := arcid;
//        doc.SymbolicArcID := symarcid;
//        doc.SymbolicArcID := symarcid;
//        doc.TimID := TimID;
//        doc.ResubUserID := ResubUserID;
//        doc.InEditMode := editmode > 0;
//        bitfarmApp.CurrentContainer.Add(doc);
//      end;
//    end;
//    grdResultlist.DataSource.DataSet.GotoBookmark(lBM);
//    grdResultlist.DataSource.DataSet.EnableControls;
//  except
//    bitfarmApp.Log.Write(llNormal, ltException, 'grdOnSelectAll', ClassName);
//  end;
end;

procedure TfrmGPL.grdResultlistChange(Sender: TObject);
begin
  bitfarmApp.Log.DebugBegin(llDebug, 'grdResultlistChange', ClassName);
  try
    try
      DoResultlistChange(nil);
    except
      bitfarmApp.Log.Write(llNormal, ltException, 'grdResultlistChange', ClassName);
    end;
  finally
    bitfarmApp.Log.DebugEnd(llDebug, 'grdResultlistChange', ClassName);
  end
end;

procedure TfrmGPL.DoResultlistChange(AThread : TThread);
var
  DocArc: TDocArc;
  SymArcID, TimID, ResubUserID: Int64;
  UserAction: PUserAction;
  dsc : TDatasource;
  gdc : TcxGridDBDataController;
  RNo : Integer;
  gdocid, arcid, userid_shed : Int64;
begin
  bitfarmApp.Log.DebugBegin(llDebug, 'DoResultlistChange', ClassName);
  try
    try
      dsc := grdResultlistDevExView.DataController.DataSource;
      gdc := grdResultlistDevExView.DataController;
      if grdResultlistDevExView.ActRec > -1 then
      begin
        RNo := grdResultlistDevExView.ActRec;
        try
          if (gdc.RecordCount > 0) and (RNo < grdResultlistDevExView.DataController.RecordCount) then
            gdocid := gdc.GetValue(RNo, gdc.GetItemByFieldName('gdocid').Index)
          else
            gdocid := 0;
        except
          gdocid := 0;
        end;
      end else
        gdocid := 0;

      if ((dsc <> nil) and (dsc.DataSet <> nil) and (gdocid > 0)) then
      begin
        try
          if (dsc.DataSet.FieldDefList.Find('symarcid') <> nil) and
             (not VarIsNull(gdc.GetValue(RNo, gdc.GetItemByFieldName('symarcid').Index))
              and VarIsNumeric(gdc.GetValue(RNo, gdc.GetItemByFieldName('symarcid').Index)))
            and
              ((bitfarmApp.CurrentViewerArchive.Arcid <> gdc.GetValue(RNo, gdc.GetItemByFieldName('arcid').Index))
              or (gdc.GetValue(RNo, gdc.GetItemByFieldName('arcid').Index) <> gdc.GetValue(RNo, gdc.GetItemByFieldName('symarcid').Index))
              or (bitfarmApp.ShowAllSymLinks and
                 (bitfarmApp.CurrentViewerArchive.Arcid = gdc.GetValue(RNo, gdc.GetItemByFieldName('arcid').Index)) and
                 (bitfarmApp.CurrentViewerArchive.Arcid <> gdc.GetValue(RNo, gdc.GetItemByFieldName('symarcid').Index))))
          then
            SymArcID := gdc.GetValue(RNo, gdc.GetItemByFieldName('symarcid').Index)
          else
            SymArcID := -1;
        except
          SymArcID := -1;
        end;

        try
          if (dsc.DataSet.FieldDefList.Find('timid') <> nil) and
             (not VarIsNull(gdc.GetValue(RNo, gdc.GetItemByFieldName('timid').Index)) and
               VarIsNumeric(gdc.GetValue(RNo, gdc.GetItemByFieldName('timid').Index)))
          then
            TimID := gdc.GetValue(RNo, gdc.GetItemByFieldName('timid').Index)
          else
            TimID := -1;
        except
          TimID := -1;
        end;

        try
          if (dsc.DataSet.FieldDefList.Find('userid_shed') <> nil) and
             ((not VarIsNull(gdc.GetValue(RNo, gdc.GetItemByFieldName('userid_shed').Index))) and
               VarIsNumeric(gdc.GetValue(RNo, gdc.GetItemByFieldName('userid_shed').Index)))
          then
            ResubUserID := gdc.GetValue(RNo, gdc.GetItemByFieldName('userid_shed').Index)
          else
            ResubUserID := -1;
        except
          ResubUserID := -1;
        end;

        if ((bitfarmApp.PreviewContainer.ViewerItem.Preview.ActiveDoc = nil) or
            (bitfarmApp.PreviewContainer.ViewerItem.Preview.ActiveDoc.ID <> gdocid) or
            (bitfarmApp.PreviewContainer.ViewerItem.Preview.ActiveDoc.SymbolicArcID <> SymArcID) or
            (bitfarmApp.PreviewContainer.ViewerItem.Preview.ActiveDoc.TimID <> TimID)) then
        begin
          bitfarmApp.PreviewContainer.ViewerItem.Preview.KillThumbnailThread(False);

          if AThread = nil then
          begin
            bitfarmApp.PreviewContainer.ViewerItem.Preview.SingleView.img_DocView.DeSelect; //17.11.2016 b.takacs Ticket 8729

            bitfarmApp.ShowPreview(nil,
              gdocid,
              False, False, (FDblClick and bitfarmApp.ViewerOptions.EditorOptions.AutoEditMode),
              bitfarmApp.PreviewContainer.ViewerItem.Preview, SymArcID, TimID, ResubUserID);
          end else
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                bitfarmApp.PreviewContainer.ViewerItem.Preview.SingleView.img_DocView.DeSelect; //17.11.2016 b.takacs Ticket 8729

                bitfarmApp.ShowPreview(nil,
                  gdocid,
                  False, False, (FDblClick and bitfarmApp.ViewerOptions.EditorOptions.AutoEditMode),
                  bitfarmApp.PreviewContainer.ViewerItem.Preview, SymArcID, TimID, ResubUserID);
              end);
          end;
        end else
        begin
          if AThread = nil then
          begin
            if (pnlSearchTimer.Caption <> '') then
              pnlSearchTimer.Caption := '';
          end else
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                if (pnlSearchTimer.Caption <> '') then
                  pnlSearchTimer.Caption := '';
              end);
          end;
        end;
      end else
      begin
        if (bitfarmApp.PreviewContainer.ViewerItem.Preview.ActiveDoc <> nil) then
        begin
          UserAction := bitfarmApp.CreateUserAction;
          UserAction^.ActionName := 'actResetViewer';
          bitfarmApp.MainThread.Add(UserAction);
          if (dsc <> nil) and (dsc.DataSet <> nil) and (dsc.DataSet.RecordCount = 0) then
          begin
            UserAction := bitfarmApp.CreateUserAction;
            UserAction^.ActionName := 'actClearFields';
            bitfarmApp.MainThread.Add(UserAction);
          end;
        end;
      end;
    except
      bitfarmApp.Log.Write(llNormal, ltException, 'DoResultlistChange', ClassName);
    end;
  finally
    FDblClick := False;
    bitfarmApp.Log.DebugEnd(llDebug, 'DoResultlistChange', ClassName);
  end
end;

function TfrmGPL.GridClickIsOnTitle(Grid: TbfaDBGrid): Boolean;
var
  Pt: TPoint;
begin
  Pt := Grid.ScreenToClient(SmallPointToPoint(types.SmallPoint(GetMessagePos)));
  Result := (Grid.MouseCoord(Pt.X, Pt.Y).Y = 0) and (dgTitles in Grid.Options);
end;

procedure TfrmGPL.FooterCustomDrawFooterCell(
  Sender: TcxGridTableView; ACanvas: TcxCanvas;
  AViewInfo: TcxGridColumnHeaderViewInfo; var ADone: Boolean);
begin
//12.05.2020
//  with AViewInfo do
//  begin
//    LookAndFeelPainter.DrawFooterCellContent(ACanvas, Bounds, AlignmentHorz,
//      AlignmentVert, MultiLine, Text, Font, Params.TextColor, Params.Color);
//    ACanvas.FrameRect(Bounds, Params.Color);
//  end;
//  ADone := True;
end;

procedure TfrmGPL.grdResultlistDblClick(Sender: TObject);
var
  Doc: TbfaDocument;
  gdocid : Integer;
  AHitTest: TcxCustomGridHitTest;
  AColumnCaption: String;
  MouseDownPos : TPoint;
  FException : Boolean;
begin
  FException := False;
  if (grdResultlistDevExView.DataController.DataSource = nil) or
     (grdResultlistDevExView.DataController.DataSource.DataSet = nil) or
     (grdResultlistDevExView.DataController.RecordCount = 0) then
    Exit;

  //05.04.2022 Wenn grouping aktiv, dann nur klick auf ein Dokument ausfhren
  if not TcxGridGroupRow(grdResultlistDevExView.Controller.FocusedRecord).IsData then
    Exit;

  MouseDownPos := grdResultlistDevEx.ScreenToClient(mouse.cursorpos);
  AHitTest := TcxGridSite(Sender).ViewInfo.GetHitTest(MouseDownPos.X, MouseDownPos.Y);
  FGridColumnMouseDown := (AHitTest.HitTestCode = htColumnHeader) or
    (AHitTest.HitTestCode = htColumnHeaderHorzSizingEdge) or
    (AHitTest.HitTestCode = htColumnHeaderFilterButton);

  if FGridColumnMouseDown then
    Exit;
  if (Self.grdResultlistDevExView.ActRec > -1) then
  begin
    try
      gdocid :=
        Self.grdResultlistDevExView.DataController.GetValue(
        Self.grdResultlistDevExView.ActRec,
        Self.grdResultlistDevExView.DataController.GetItemByFieldName('gdocid').Index);
    except
      gdocid := 0;
      FException := True;
    end;
  end
  else
    gdocid := 0;

  bitfarmApp.Log.DebugBegin(llDebug, 'grdResultlistDblClick', ClassName);
  try
    try
      if bitfarmApp.ViewerOptions.EditorOptions.DocNoAction then
        Exit
      else if bitfarmApp.ViewerOptions.EditorOptions.AutoEditMode then
      begin
        if bitfarmApp.PreviewContainer.ViewerItem.Preview.ActiveDoc <> nil then
        begin
          if not bitfarmApp.PreviewContainer.ViewerItem.Preview.ActiveDoc.InEditMode then
          begin
            if FException or ((bitfarmApp.CurrentContainer.Count > 0) and (bitfarmApp.CurrentContainer[0] <> nil) and
                (bitfarmApp.CurrentContainer[0].ID <> gdocid)) then
            begin
              FDblClick := True;
              grdResultlistChange(Sender)
            end
            else
              actInProgress.Execute;
          end
          else
          begin
            if FException or ((bitfarmApp.CurrentContainer.Count > 0) and (bitfarmApp.CurrentContainer[0] <> nil) and
               (bitfarmApp.CurrentContainer[0].ID <> gdocid)) then
            begin
              FDblClick := True;
              grdResultlistChange(Sender)
            end
            else
            begin
            // SJ 16.10.2020
              actCallDoSave.Execute;
//              bitfarmApp.ShowPreview(bitfarmApp.PreviewContainer.ViewerItem.Preview.ActiveDoc,
//                -1, True, (GetKeyState(VK_MENU) < 0), True, nil);
            // SJ 16.10.2020
            end;
          end;
        end;
      end
      else
      begin
        if (bitfarmApp.CurrentContainer.Count > 0) and (bitfarmApp.CurrentContainer[0] <> nil) and
           (bitfarmApp.CurrentContainer[0].ID <> gdocid) then
        begin
          FDblClick := True;
          grdResultlistChange(Sender)
        end
        else
        begin
          bitfarmApp.ShowPreview(bitfarmApp.PreviewContainer.ViewerItem.Preview.ActiveDoc, -1,
            True, (GetKeyState(VK_MENU) < 0), False, nil);
        end;
      end;
    except
      bitfarmApp.Log.Write(llNormal, ltException, 'grdResultlistDblClick', ClassName);
    end;
  finally
    bitfarmApp.Log.DebugEnd(llDebug, 'grdResultlistDblClick', ClassName);
  end;
end;

procedure TfrmGPL.grdResultlistColumnMoved(Sender: TObject; FromIndex, ToIndex: Integer);
begin
  grdResultlistOnColSizing;
end;

procedure TfrmGPL.grdResultlistMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  moveright, oldstate: Boolean;
  i: Integer;
  drg: TDragObject;
begin
  try
    if ssLeft in Shift then
    begin
      if FMouseDown then
      begin
        if (not PtInRect(FMouseDownArea, Point(X, Y))) and (Y > 17) and
           (bitfarmApp.CurrentContainer.Count > 0) then
        begin
          if (not FIsDragging) and (not bitfarmApp.ShowDocumentInProcess)
            and (not FGRidColumnMouseDown) then
          begin
            moveright := True;
            for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
            begin
              if ((aSysArc[bitfarmApp.CurrentContainer[i].arcid].Rights and rightMove) = 0) then
                moveright := False;
              if (bitfarmApp.CurrentContainer[i].SymbolicArcID <> -1) and
                 ((aSysArc[bitfarmApp.CurrentContainer[i].SymbolicArcID].Rights and rightMove) = 0) then
                moveright := False;
              if not moveright then
                Break;
            end;

            FIsDragging := True;

            bitfarmApp.FUseFileTarget := False;
            ResultListStartDrag(grdResultlistDevEx);
            bitfarmApp.DragObject.MoveRight := moveright;
            desResultGrid.ImageIndex := 0;
            DropFileSource1.ImageIndex := 0;
            DropExecute(True);
          end;
        end;
      end;
    end;
  except
    bitfarmApp.Log.Write(llNormal, ltException, 'grdResultlistMouseMove', ClassName);
  end;
end;

procedure TfrmGPL.grdResultlistMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  MouseDownPos: TPoint;
  AHitTest: TcxCustomGridHitTest;
  AColumnCaption: String;
begin
  try
    try
      FMouseDown := True;
      FIsDragging := False;
      MouseDownPos := grdResultlistDevEx.ScreenToClient(mouse.cursorpos);
      AHitTest := TcxGridSite(Sender).ViewInfo.GetHitTest(X, Y);
      FGridColumnMouseDown := (AHitTest.HitTestCode = htColumnHeader) or
        (AHitTest.HitTestCode = htColumnHeaderHorzSizingEdge) or
        (AHitTest.HitTestCode = htColumnHeaderFilterButton);
      FMouseDownArea := Classes.Rect(Point(MouseDownPos.X - 5, MouseDownPos.Y - 5), Point(MouseDownPos.X + 5, MouseDownPos.Y + 5));
    except
      bitfarmApp.Log.Write(llNormal, ltException, 'grdResultlistMouseDown', ClassName);
    end;
  finally
  end;
end;

procedure TfrmGPL.grdResultlistMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
var
  UserAction: PUserAction;
  i: Integer;
  doc: TbfaDocument;
  found: Boolean;
  MouseDownPos: TPoint;
  TitleRect: TRect;
  Pt1, Pt2: TPoint;
  src, dest: TList;
  dsc : TDataSource;
begin
  try
    FMouseDown := False;
    FIsDragging := False;

    MouseDownPos := grdResultlistDevEx.ScreenToClient(mouse.cursorpos);
    Pt1.X := 0;
    Pt1.Y := 0;
    Pt2.X := grdResultlistDevEx.ClientWidth;
    Pt2.Y := 18;

    TitleRect := Classes.rect(Pt1, Pt2);
    if (Shift = []) and (PtInRect(TitleRect, MouseDownPos)) then
      if not ((grdResultlistDevExView.DataController.DataSource = nil) or
              (grdResultlistDevExView.DataController.DataSet = nil))
      then
        Self.grdResultlistOnColSizing;

    dsc := grdResultlistDevExView.DataController.DataSource;
    if (Button = mbRight) or (dsc = nil) or (dsc.DataSet = nil) or
       (grdResultlistDevExView.ActRec = -1)
    then
      Exit;

    grdResultlistDevExView.DoMouseUp(Button, Shift, X, Y);
    src := TList.Create;

    for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
      if bitfarmApp.CurrentContainer[i].InEditMode then
        src.Add(Pointer(bitfarmApp.CurrentContainer[i].ID));

    if (Shift = [ssShift]) or (Shift = [ssCtrl]) or (Shift = [ssShift,ssCtrl]) then
    begin
      dsc.DataSet.DisableControls;
      try
        if Shift = [ssCtrl] then
        begin
          if grdResultlistDevExView.Controller.FocusedRecord <> nil then
            grdResultlistDevExView.Controller.FocusedRecord.Selected := True;
          bitfarmApp.SelectedRowsToCurrentContainer(grdResultlistDevExView);
        end
//24.01.2024 bfacrm:ticket__show__37544       else if Shift = [ssShift] then
        else if (Shift = [ssShift]) or (Shift = [ssShift,ssCtrl]) then
        begin
          bitfarmApp.ClearCurrentContainer;   //entfernt Document-Objekte, wenn nicht in Tabs geffnet
          bitfarmApp.SelectedRowsToCurrentContainer(grdResultlistDevExView, False, src);
        end;
      finally
        dsc.DataSet.EnableControls;
      end;

      if src.Count > 0 then
      begin
        try
          try
            UserAction := bitfarmApp.CreateUserAction;
            UserAction^.ActionName := 'actBackgroundCancel';
            for i := 0 to src.Count - 1 do
              UserAction^.Params.Add(IntToStr(Integer(src[i])));
            UserAction^.Options := 1; //FCurrentContainer[0] muss aktualisiert werden Ticket  31661/3
            bitfarmApp.BackThread.Add(UserAction);
          except
            bitfarmLog.Write(llNormal, ltException, 'grdResultlistMouseUp - ', ClassName);
          end;
        finally
        end;
      end;
    end
    else if (Shift = []) then
    begin
      dsc.DataSet.DisableControls;
      try
//13.07.2022 Ticket 31271      if not grdResultlistDevExView.DataController.IsGridMode then
        if grdResultlistDevExView.OptionsView.GroupByBox then
        begin
          if not grdResultlistDevExView.Controller.FocusedRecord.IsData then
          begin
            actCallDoSave.Execute;

            UserAction := bitfarmApp.CreateUserAction;
            UserAction^.ActionName := 'actSelectedRowsToCurrentContainer';
            bitfarmApp.MainThread.Add(UserAction);
          end;
        end
        else  //13.07.2022 Ticket 31271 -->
        begin
          if grdResultlistDevExView.Controller.SelectedRecordCount <> bitfarmApp.CurrentContainer.Count then
            bitfarmApp.SelectedRowsToCurrentContainer(grdResultlistDevExView);
        end; //13.07.2022 Ticket 31271 <--
      finally
        dsc.DataSet.EnableControls;
      end;
    end;
  except
    bitfarmApp.Log.Write(llNormal, ltException, 'grdResultlistMouseUp', ClassName);
  end;
end;

procedure TfrmGPL.grdResultlistOnColSizing;
var
  i: Integer;
  sort: TSorting;
  arcid: Int64;
begin
  try
    if bitfarmApp.CurrentView = tvkViewer then
      arcid := bitfarmApp.CurrentArchive.Arcid
    else if bitfarmApp.CurrentView = tvkImporter then
      arcid := bitfarmApp.CurrentImportArchive.Arcid
    else if bitfarmApp.CurrentView = tvkResub then
      arcid := bitfarmApp.CurrentResubFields;

    SetLength(aColSortings[arcid], 0);
    Setlength(aColSortings[arcid], grdResultlistDevExView.ColumnCount);
    for i := 0 to grdResultlistDevExView.ColumnCount - 1 do
    begin
      if
        (grdResultlistDevExView.Columns[i].DataBinding.FieldName <> 'gdocid') and
        (grdResultlistDevExView.Columns[i].DataBinding.FieldName <> 'arcid') and
        (grdResultlistDevExView.Columns[i].DataBinding.FieldName <> 'symarcid') and
        (grdResultlistDevExView.Columns[i].DataBinding.FieldName <> 'status') and
        (grdResultlistDevExView.Columns[i].DataBinding.FieldName <> 'groupid') and
        (grdResultlistDevExView.Columns[i].DataBinding.FieldName <> 'options') and
        (grdResultlistDevExView.Columns[i].DataBinding.FieldName <> 'userid_work') and
        (grdResultlistDevExView.Columns[i].DataBinding.FieldName <> 'userid_shed') and
        (grdResultlistDevExView.Columns[i].DataBinding.FieldName <> 'timid') and
        (grdResultlistDevExView.Columns[i].DataBinding.FieldName <> 'editmode')
      then
      begin
        sort.Title := grdResultlistDevExView.Columns[i].Caption;
        sort.Field := grdResultlistDevExView.Columns[i].DataBinding.FieldName;
        sort.SortOrder := Integer(grdResultlistDevExView.Columns[i].SortOrder);
        sort.Width := grdResultlistDevExView.Columns[i].Width;
        sort.GroupingIndex := grdResultlistDevExView.Columns[i].GroupIndex;
        sort.SortIndex := grdResultlistDevExView.Columns[i].SortIndex;
        sort.Visible := grdResultlistDevExView.Columns[i].Visible;
        sort.FooterKind := Integer(grdResultlistDevExView.Columns[i].Summary.FooterKind); //23.09.2021 Ticket 24736
        aColSortings[arcid, i] := sort;
      end;
    end;
  except
    bitfarmApp.Log.Write(llNormal, ltException, 'grdResultlistOnColSizing', ClassName);
  end;
end;

// Setzte die Caption der Wiedervolage-Panels
procedure TfrmGPL.InitPanelResubmissionCaption;
begin
 // wenn nicht beim Start geprft wird, dann lesen wir den aktuellen Stand im Hintergrund ein
 // da fAppstarted false ist, wird dann trotz nderung in Checkresub keine Meldung erzeugt

  tmrCheckResub.Enabled := bitfarmApp.ViewerOptions.ResubOptions.ResubTimer;
  tmrCheckResub.Interval := bitfarmApp.ViewerOptions.ResubOptions.ResubTimerInterval * 60000;

  if not bitfarmApp.ViewerOptions.ResubOptions.ResubOnStartup then
    bitfarmApp.CheckResub(nil);

  SetPanelResubmissionCaption;
end;


procedure TfrmGPL.InitViewer;
var
  lbhascygwin : Boolean;
  reg: TRegistry;
begin
  bitfarmLog.DebugBegin(llDebug, 'InitViewer', ClassName);
  try
    try
      fLastDir := '\';
      fDebug := True;
      bitfarmApp.handleparamaktiv := False;

      dmMain.cntMain.Debug := fDebug;
      dmMain.monUniSQL.Active := fDebug;
      try
        reg := TRegistry.Create;
        try
          with reg do
          begin
             RootKey := HKEY_CURRENT_USER;
             if OpenKey('\SOFTWARE\Cygnus Solutions\Cygwin\mounts v2', false) then
             begin
                lbhascygwin := true;
             end;
             CloseKey;
          end;
        except
          on e: Exception do
             bitfarmLog.Write(llNormal, ltException,  _('Fehler beim Erstellen der Standart Werte:') + e.Message);
        end;
        // not have cygwin create it also (normal case)
        if not lbhascygwin then
        begin
          try
             with reg do
             begin
                RootKey := HKEY_CURRENT_USER;
                OpenKey('\SOFTWARE\Cygnus Solutions\Cygwin\mounts v2\/usr/local/share', true);
                WriteInteger('Flags', 10);   //binmode active
                WriteString('native', BD.ExeDir + 'Viewer-Files\ocrocmd');
                CloseKey;
             end;
          except
             on e: Exception do
                bitfarmLog.Write(llNormal, ltException,  _('Fehler beim Erstellen der Standart Werte:') + e.Message);
          end;

        end;
      finally
        FreeAndNil(reg);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'InitViewer', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'InitViewer', ClassName);
  end;
end;

procedure TfrmGPL.itmCollapseAllClick(Sender: TObject);
var
  UserAction: PUserAction;
  tv: TbfaTreeView;
begin
  bitfarmApp.Log.DebugBegin(llDebug, 'itmCollapseAllClick', ClassName);
  try
    try
      if (popTreeView.PopupComponent is TbfaTreeView) then
      begin
        tv := TbfaTreeView(popTreeView.PopupComponent);
        UserAction := bitfarmApp.CreateUserAction;
        UserAction^.ActionName := actCollapseAll.Name;
        UserAction^.Objects.Add(tv);
        bitfarmApp.MainThread.Add(UserAction);
      end;
    except
      bitfarmApp.Log.Write(llNormal, ltException, 'itmCollapseAllClick', ClassName);
    end;
  finally
    bitfarmApp.Log.DebugEnd(llDebug, 'itmCollapseAllClick', ClassName);
  end;
end;

procedure TfrmGPL.itmExpandAllClick(Sender: TObject);
var
  UserAction: PUserAction;
  tv: TbfaTreeView;
begin
  bitfarmApp.Log.DebugBegin(llDebug, 'itmExpandAllClick', ClassName);
  try
    try
      if (popTreeView.PopupComponent is TbfaTreeView) then
      begin
        tv := TbfaTreeView(popTreeView.PopupComponent);
        UserAction := bitfarmApp.CreateUserAction;
        UserAction^.ActionName := actExpandAll.Name;
        UserAction^.Objects.Add(tv);
        bitfarmApp.MainThread.Add(UserAction);
      end;
    except
      bitfarmApp.Log.Write(llNormal, ltException, 'itmExpandAllClick', ClassName);
    end;
  finally
    bitfarmApp.Log.DebugEnd(llDebug, 'itmExpandAllClick', ClassName);
  end;
end;

procedure TfrmGPL.itmRefreshClick(Sender: TObject);
var
  UserAction: PUserAction;
  tv: TbfaTreeView;
begin
  bitfarmApp.Log.DebugBegin(llDebug, 'itmRefreshClick', ClassName);
  try
    try
      if (popTreeView.PopupComponent is TbfaTreeView) then
      begin
        tv := TbfaTreeView(popTreeView.PopupComponent);
        UserAction := bitfarmApp.CreateUserAction;
        UserAction^.ActionName := actRefreshTreeView.Name;
        UserAction^.Objects.Add(tv);
        bitfarmApp.MainThread.Add(UserAction);
      end;
    except
      bitfarmApp.Log.Write(llNormal, ltException, 'itmRefreshClick', ClassName);
    end;
  finally
    bitfarmApp.Log.DebugEnd(llDebug, 'itmRefreshClick', ClassName);
  end;
end;

procedure TfrmGPL.mnuCustomizeClick(Sender: TObject);
begin
  SpTBXCustomizer1.Show;
end;

procedure TfrmGPL.mnuMarkModifiedClick(Sender: TObject);
begin
  try
    try
      if (frmMainForm.ActiveControl.Owner <> nil) and
         (frmMainForm.ActiveControl.Owner.Owner <> nil) and
         (frmMainForm.ActiveControl.Owner.Owner is TBfaAddfieldComp)
      then
      begin
        if (frmMainForm.ActiveControl.Owner = TBfaAddfieldComp(frmMainForm.ActiveControl.Owner.Owner).comp) then
          TBfaAddfieldComp(frmMainForm.ActiveControl.Owner.Owner).Modified := True
        else if (frmMainForm.ActiveControl.Owner = TBfaAddfieldComp(frmMainForm.ActiveControl.Owner.Owner).comp2) then
          TBfaAddfieldComp(frmMainForm.ActiveControl.Owner.Owner).ModifiedHigh := True;
      end;
    except
      bitfarmApp.Log.Write(llNormal, ltException, 'mnuMarkModifiedClick', ClassName);
    end;
  finally
    bitfarmApp.Log.DebugEnd(llDebug, 'mnuMarkModifiedClick', ClassName);
  end;
end;

procedure TfrmGPL.mnuReloginClick(Sender: TObject);
var
  DoRelogin: Boolean;
  DlgResult: TModalResult;
  Useraction: PUserAction;
  req: TbfaRequest;
begin
  try
  // bfacrm:ticket__show__29299
    try
      DoRelogin := True;
      req := TbfaRequest.Create;
      if bitfarmApp.ViewerOptions.GeneralOptions.DisplayCheckoutAtShutdown then
      begin
        req.ReqType := 'reqGetCheckouts';
        req.UserID := bitfarmApp.User.ID;
        req.Profile := bitfarmApp.Profile;
        req.Lang := bitfarmApp.Lang;
        bitfarmApp.MainSocket.SendRequestToServer(req);
        req := bitfarmApp.MainSocket.ReceiveResponse;

          if req = nil then
            Exit;
        // TODO -o s.jansen: reqGetCheckouts
        if (req.ReqType <> 'respError') and (req.ReqType <> 'respAuthError') and
           (req.DataString <> '') then
        begin
          // SJ: BfMessageDialogWithCheckbox ausgebaut. Macht hier keinen Sinn...
          DlgResult := BfMessageDlg(_('Sie haben ausgecheckte Dokumente.') + #13#10 + _('Trotzdem ausloggen?'),
                mtConfirmation, [mbYes, mbNo, mbCancel]);
          case DlgResult of
            mrNo:
              actCheckoutDocs.Execute;
          end;
          DoRelogin := (DlgResult = mrYes);
        end;
      end;

      if DoRelogin then
      begin
        UserAction := bitfarmApp.CreateUserAction;
        UserAction^.ActionName := 'actRelogin';
        bitfarmApp.MainThread.Add(UserAction);
      end;
    finally
      if req <> nil then
        FreeAndNil(req);
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'mnuReloginClick', ClassName);
  end;
end;

procedure TfrmGPL.SetLimit(Limit: Integer);
var
  i: Integer;
begin
  try
    for i := 0 to popLimit.Items.Count - 1 do
    begin
      popLimit.Items[i].Checked := False;
      if popLimit.Items[i].Caption = IntToStr(Limit) then
      begin
        popLimit.Items[i].Checked := True;
        btnLimit.Caption := IntToStr(Limit);
      end;
      if Limit = -1 then
      begin
        if popLimit.Items[i].Caption = _('Alle') then
        begin
          popLimit.Items[i].Checked := True;
          btnLimit.Caption := _('Alle');
        end;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetLimit', ClassName);
  end;
end;

procedure TfrmGPL.SetListBoxPosition;
var
  i: Integer;
  xcomp: TBfaAddfieldComp;
begin
  try
    for i := 0 to scrbxViewerAddfields.ComponentCount - 1 do
    begin
      try
        if scrbxViewerAddfields.Components[i] is TBfaAddfieldComp then
        begin
          xcomp := TBfaAddfieldComp(scrbxViewerAddfields.Components[i]);
          if TBfaAddfieldComp(xcomp).AddfieldType = zfld03_MehrfachAuswahl then
          begin
            if TbfaCheckedListBox(TBfaAddfieldComp(xcomp).comp2).Visible then
            begin
              // SJ: wenn das "Hauptcontrol" noch vollstndig in der Scrollbox ist, wird die
              //     Position neu gesetzt. Sonst wird die Liste ausgeblendet
              //     Achtung: Parent der ListBox wird in OnCheckListClick auf pnlSearchOptions gesetzt
              if ((TbfaCheckedCombo(TBfaAddfieldComp(xcomp).comp).ClientOrigin.Y + TbfaCheckedCombo(TBfaAddfieldComp(xcomp).comp).Height)
                          > (scrbxViewerAddfields.ClientOrigin.Y + scrbxViewerAddfields.Height)) or
                 (TbfaCheckedCombo(TBfaAddfieldComp(xcomp).comp).ClientOrigin.Y
                          < scrbxViewerAddfields.ClientOrigin.Y)
              then
                TbfaCheckedListBox(TBfaAddfieldComp(xcomp).comp2).Hide
              else
                TbfaCheckedListBox(TBfaAddfieldComp(xcomp).comp2).Top :=
                  TbfaCheckedCombo(TBfaAddfieldComp(xcomp).comp).ClientOrigin.Y - TbfaCheckedListBox(TBfaAddfieldComp(xcomp).comp2).Parent.ClientOrigin.Y + TbfaCheckedCombo(TBfaAddfieldComp(xcomp).comp).Height;
            end;
          end;
        end;
      except
        on e: exception do
          bitfarmLog.Write(llNormal, ltException, 'SetListBoxPosition - loop: '+e.Message, ClassName);
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetListBoxPosition', ClassName);
  end;
end;

procedure TfrmGPL.SetSearchOption(Option: Integer);
begin
  if (Option and 1) = 1 then
    tbiSo1Click(popSearchOption1.Items[0]);
  if (Option and 2) = 2 then
    tbiSo1Click(popSearchOption1.Items[1]);
  if (Option and 3) = 3 then
    tbiSo1Click(popSearchOption1.Items[2]);
  if (Option and 16) = 16 then
    tbiSo2Click(popSearchOption2.Items[0]);
  if (Option and 32) = 32 then
    tbiSo2Click(popSearchOption2.Items[1]);
  if (Option and 4) = 4 then
    tbiSo3Click(popSearchOption3.Items[0]);
  if (Option and 8) = 8 then
    tbiSo3Click(popSearchOption3.Items[1]);
  if (Option and 1024) = 1024 then
    tbiSo3Click(popSearchOption3.Items[2]);
  if (Option and 64) = 64 then
    tbiSo4Click(popSearchOption4.Items[0]);
  if (Option and 128) = 128 then
    tbiSo4Click(popSearchOption4.Items[1]);
  if (Option and 256) = 256 then
    tbiSo4Click(popSearchOption4.Items[2]);
  if (Option and 512) = 512 then
    tbiSo4Click(popSearchOption4.Items[3]);

end;

procedure TfrmGPL.SpTBXDockablePanel3Resize(Sender: TObject);
begin
  SpTBXMultiDock5.Width := SpTBXPanel7.Width - 4;
end;

procedure TfrmGPL.SpTBXItem10Click(Sender: TObject);
begin
  try
    SendMessage(TWinControl(Self.ActiveControl).Handle, WM_COPY, 0, 0);
  except
    bitfarmLog.Write(llNormal, ltException, 'SpTBXItem10Click', ClassName);
  end;
end;

procedure TfrmGPL.SpTBXItem11Click(Sender: TObject);
begin
  try
    SendMessage(TWinControl(Self.ActiveControl).Handle, WM_CUT, 0, 0);
  except
    bitfarmLog.Write(llNormal, ltException, 'SpTBXItem11Click', ClassName);
  end;
end;

procedure TfrmGPL.SpTBXItem12Click(Sender: TObject);
begin
  try
    SendMessage(TWinControl(Self.ActiveControl).Handle, EM_SETSEL, 0, -1);
  except
    bitfarmLog.Write(llNormal, ltException, 'SpTBXItem12Click', ClassName);
  end;
end;

procedure TfrmGPL.SpTBXItem7Click(Sender: TObject);
begin
  try
    SendMessage(TWinControl(Self.ActiveControl).Handle, WM_UNDO, 0, 0);
  except
    bitfarmLog.Write(llNormal, ltException, 'SpTBXItem7Click', ClassName);
  end;
end;

procedure TfrmGPL.SpTBXItem8Click(Sender: TObject);
begin
  try
    SendMessage(TWinControl(Self.ActiveControl).Handle, WM_CLEAR, 0, 0);
  except
    bitfarmLog.Write(llNormal, ltException, 'SpTBXItem8Click', ClassName);
  end;
end;

procedure TfrmGPL.SpTBXItem9Click(Sender: TObject);
begin
  try
    SendMessage(TWinControl(Self.ActiveControl).Handle, WM_PASTE, 0, 0);
  except
    bitfarmLog.Write(llNormal, ltException, 'SpTBXItem9Click', ClassName);
  end;
end;

procedure TfrmGPL.SpTBXMultiDock1RequestDock(Sender: TObject; Bar: TTBCustomDockableWindow; var Accept: Boolean);
begin
  if (Bar.Name = 'pnlSearchOptions') or (Bar.Name = 'SpTBXDockablePanel3') then
    Accept := False;
end;

procedure TfrmGPL.SpTBXMultiDock2RequestDock(Sender: TObject;
  Bar: TTBCustomDockableWindow; var Accept: Boolean);
begin
  if Bar.Name = 'SpTBXDockablePanel3' then
    Accept := False;
end;

procedure TfrmGPL.splTreeviewMoving(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
begin
  if (NewSize > splTreeview.Left) and
    (NewSize > pnlSearchOptions.Width + SpTBXMultiDock1.Width - (fpnlSearchWidth + 3))
  then
    Accept := False;

  if (NewSize < fpnlTreeviewWidth) and (NewSize > 0) then
    NewSize := fpnlTreeviewWidth;

  //27.05.2024 SD -->bfacrm:ticket__show__38630
  if  frmMainForm.Width = pnlSearchOptions.Width + 48 then
    pnlSearchOptions.Width := frmMainForm.Width - (NewSize + 48);
  if (frmMainForm.Width - (NewSize + 48)) < pnlSearchOptions.Width then
       Accept := False;
  //27.05.2024 SD <--bfacrm:ticket__show__38630

  Self.bfaTlbStandard1.tlbStandardTreeView.Checked := NewSize > 0; //01.08.2022 Ticket 28947
end;

procedure TfrmGPL.SpTBXSplitter2DblClick(Sender: TObject);
begin
  if pnlPreview.Width > 10 then
  begin
    //fpnlSearchWidth := SpTBXMultiDock2.Width;       // 10/28/2020 bfacrm:ticket__show__24858 Searchbar auf maximale Breite festgelegt
      with bitfarmApp.ViewerOptions.GUIOptions do     // 10/28/2020 bfacrm:ticket__show__24858
        begin
          SearchPanelWidth := SpTBXMultiDock2.Width;

        end;

    SpTBXMultiDock2.Width := SpTBXMultiDock2.Width + pnlPreview.Width;
    pnlPreview.Width := 0;
  end
  else if pnlPreview.Width = 0 then
    SpTBXMultiDock2.Width := fpnlSearchWidth;
end;

procedure TfrmGPL.SpTBXSplitter2Moving(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
begin
  if (NewSize < 345) and (NewSize > 0) then //08.03.2019 auf 345 erhht weil Suchen Knopf war schon nicht ganz sichtbar
    Accept := False
  else if (NewSize < 345) then
    NewSize := 345;
end;

//07.10.2024 SD -->bfacrm:ticket__show__39992
procedure TfrmGPL.SpTBXSplitter3MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  AThread : TThread;
begin
    if not (bitfarmApp.CurrentView = tvkImporter) then
    begin
      AThread.Synchronize(nil,
        procedure
        begin
          bfaPreview36.RefreshSizeAddFields;
        end);
    end;
end;
//07.10.2024 SD <--bfacrm:ticket__show__39992

procedure TfrmGPL.SpTBXSplitter3Moving(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
begin
  if bitfarmApp.CurrentView = tvkImporter then
    Accept := False
  else if (NewSize > pnlSearchOptions.Height - 250) then
    Accept := False;

  if Accept then
  begin
    if bitfarmApp.CurrentView = tvkImporter then
      bitfarmApp.FImporterSplitterSize := Self.SpTBXDockablePanel1.Height
    else
      bitfarmApp.FViewerSplitterSize := Self.SpTBXDockablePanel1.Height;
  end;
end;

procedure TfrmGPL.tbiLimitClick(Sender: TObject);
var
  i: Integer;
begin
  try
    for i := 0 to popLimit.Items.Count - 1 do
      popLimit.Items[i].Checked := False;
    btnLimit.Caption := TTBCustomItem(Sender).Caption;
    TTBCustomItem(Sender).Checked := True;
  except
    bitfarmLog.Write(llNormal, ltException, 'tbiLimitClick', ClassName);
  end;
end;

procedure TfrmGPL.tbiSearchBarClick(Sender: TObject);
begin
//30.03.2021
//  if dgeSearchBar in grdResultlist.OptionsEx then
//  begin
//    grdResultlist.OptionsEx := grdResultlist.OptionsEx - [dgeSearchBar];
//    tbiSearchBar.Checked := False;
//  end else
//  begin
//    grdResultlist.OptionsEx := grdResultlist.OptionsEx + [dgeSearchBar];
//    tbiSearchBar.Checked := True;
//  end;
end;

procedure TfrmGPL.tbiSO1Click(Sender: TObject);    //VTX und SWL
var
  i: Integer;
begin
  if btnSearchOption1.Caption = TTBCustomItem(Sender).Caption then
    Exit;

  try
    for i := 0 to popSearchOption1.Items.Count - 1 do
      popSearchOption1.Items[i].Checked := False;
    btnSearchOption1.Caption := TTBCustomItem(Sender).Caption;
    TTBCustomItem(Sender).Checked := True;
    fSearchOption := (fSearchOption and not 7);
    fSearchOption := (fSearchOption or TTBCustomItem(Sender).tag);
  except
    bitfarmLog.Write(llNormal, ltException, 'tbiSo1Click', ClassName);
  end;

end;

procedure TfrmGPL.tbiSo2Click(Sender: TObject);    // User und Group
var
  i: Integer;
begin
  if btnSearchOption2.Caption = TTBCustomItem(Sender).Caption then
    Exit;

  try
    for i := 0 to popSearchOption2.Items.Count - 1 do
      popSearchOption2.Items[i].Checked := False;
    btnSearchOption2.Caption := TTBCustomItem(Sender).Caption;
    TTBCustomItem(Sender).Checked := True;
    fSearchOption := (fSearchOption and not 48);
    fSearchOption := (fSearchOption or TTBCustomItem(Sender).tag);
    bitfarmApp.ReadUserlist;
  except
    bitfarmLog.Write(llNormal, ltException, 'tbiSo2Click', ClassName);
  end;

end;

procedure TfrmGPL.tbiSo3Click(Sender: TObject);   // Date
var
  i: Integer;
begin
  if btnSearchOption3.Caption = TTBCustomItem(Sender).Caption then
    Exit;
  try
    for i := 0 to popSearchOption3.Items.Count - 1 do
    begin
      popSearchOption3.Items[i].Checked := False;
    end;
    btnSearchOption3.Caption := TTBCustomItem(Sender).Caption;
    TTBCustomItem(Sender).Checked := True;
    fSearchOption := (fSearchOption and not 1036);
    fSearchOption := (fSearchOption or TTBCustomItem(Sender).tag);   // 4 Archiviert, 8 Modified, 1024 Lschdatum
    //04.09.2024 SD -->bfacrm:ticket__show__39649
    //Wenn eine andere Suchart gewhlt wird, mssen die Suchdaten gelscht werden.
//    if (dteSearch.compDateLow.EditText = '') and (dteSearch.compDateHigh.EditText = '') then   //06.06.2024 SD <--bfacrm:ticket__show__38704
//    begin
    //04.09.2024 SD <--bfacrm:ticket__show__39649
      dteSearch.ClearValue;
      bitfarmApp.SetLastYearSearch; //07.01.2019 sollte beim klick richtig angezeigt werden.
      //04.09.2024 SD -->bfacrm:ticket__show__39649
      //Bei der Suche nach dem Lschungsdatum muss das Lschungsdatum angezeigt werden.
      if (TTBCustomItem(Sender).tag = 1024) and (not frmMainForm.dteSearch.Modified) and (bitfarmApp.CurrentContainer.Count > 0) then
        bitfarmApp.ShowDocumentProperties(bitfarmApp.CurrentContainer[0], bitfarmApp.GetActivePreview);
//    end;
      //04.09.2024 SD <--bfacrm:ticket__show__39649
  except
    bitfarmLog.Write(llNormal, ltException, 'tbiSo3Click', ClassName);
  end;
end;

procedure TfrmGPL.tbiSo4Click(Sender: TObject);    // Links, Title, Type
var
  i: Integer;
begin
  if btnSearchOption4.Caption = TTBCustomItem(Sender).Caption then
    Exit;
  try
    for i := 0 to popSearchOption4.Items.Count - 1 do
      popSearchOption4.Items[i].Checked := False;
    btnSearchOption4.Caption := TTBCustomItem(Sender).Caption;
    TTBCustomItem(Sender).Checked := True;
    fSearchOption := (fSearchOption and not 960);
    fSearchOption := (fSearchOption or TTBCustomItem(Sender).tag);
    // Self
    Self.cbxSearchLinks.cliNeg.Enabled := (TTBCustomItem(Sender).tag <> 512);
  except
    bitfarmLog.Write(llNormal, ltException, 'tbiSo4Click', ClassName);
  end;
end;

procedure TfrmGPL.tcSearchActiveTabChange(Sender: TObject; TabIndex: Integer);
var
  UserAction: PUserAction;
  AThread : TThread;
begin
  bitfarmLog.DebugBegin(llDebug, 'tcSearchActiveTabChange - ', Classname);
  try
    if tcSearch.ActivePage = tabDocLinks then
    begin
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actReloadDocLinks';
      bitfarmApp.MainThread.Add(UserAction);
    end
    //09.10.2024 SD -->bfacrm:ticket__show__39992
    else if (tcSearch.Items[TabIndex] = tabSearchAddfields) or (tcSearch.Items[TabIndex] = tabSearchAddfields2) then
    begin
      AThread.Synchronize(nil,
        procedure
        begin
          bfaPreview36.RefreshSizeAddFields;
        end);
    end;
    //09.10.2024 SD <--bfacrm:ticket__show__39992
  finally
    bitfarmLog.DebugEnd(llDebug, 'tcSearchActiveTabChange - ', Classname);
  end;
end;

procedure TfrmGPL.tmrCheckResubTimer(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'tmrCheckResubTimer - ', Classname);
  try
    CheckResubAction;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tmrCheckResubTimer - ', Classname);
  end;
end;

procedure TfrmGPL.tmrCloseFormTimer(Sender: TObject);
begin
  tmrCloseForm.Enabled := False;
  Self.Close;
end;

procedure TfrmGPL.tmrSearchPanelTimer(Sender: TObject);
begin
  try
    pnlSearchTimer.ParentBackground := False;
    pnlSearchTimer.Color := $00000000 + 256 * trunc(91 * (sin(PI * FSearchTimerCounter / 16))) + 255 + trunc(256 * 91);
    FSearchTimerCounter := FSearchTimerCounter + 1;
  except
    bitfarmLog.Write(llNormal, ltException, 'tmrSearchPanelTimer', ClassName);
  end;
end;

procedure TfrmGPL.tmrStatusBarTimer(Sender: TObject);
begin
  try
    bitfarmApp.SetStandardStatusInfo(nil);
  finally
    tmrStatusBar.Enabled := False;
  end;
end;

procedure TfrmGPL.tokenDocLinksPropertiesChange(Sender: TObject);
begin
  try
    if bitfarmApp.ViewerOptions.SearchOptions.ShowDocLinks then
    begin
//17.01.2024 bfacrm:ticket__show__37495     if Length(Trim(TbfaCheckedCombo(Sender).EditingValue)) = 2 then
      if Length(Trim(TbfaCheckedCombo(Sender).EditingValue)) = bitfarmApp.LinkChars then
      begin
        Windows.SetCursor(Screen.Cursors[crSQLWait]);
        bitfarmApp.ReadRefnamesOrTitels(TbfaCheckedCombo(Sender), Trim(TbfaCheckedCombo(Sender).EditingValue), 0);
        Windows.SetCursor(Screen.Cursors[crDefault]);
      end;
    end;

//17.01.2024 bfacrm:ticket__show__37495     if Length(TbfaCheckedCombo(Sender).EditingValue) < 2 then
    if Length(TbfaCheckedCombo(Sender).EditingValue) < bitfarmApp.LinkChars then
    begin
      TbfaCheckedCombo(Sender).Properties.BeginUpdate;
      try
      TbfaCheckedCombo(Sender).Properties.Tokens.Clear;
      finally
        TbfaCheckedCombo(Sender).Properties.EndUpdate;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'tokenDocLinksPropertiesChange', ClassName);
  end;
end;

procedure TfrmGPL.trvBookmarksCollapsed(Sender: TObject; Node: TTreeNode);
begin
  try
    Node.ImageIndex := Integer(icoidx_bookmark_folder);
    Node.SelectedIndex := Integer(icoidx_bookmark_folder);
  except
    bitfarmLog.Write(llNormal, ltException, 'trvBookmarksCollapsed', ClassName);
  end;
end;

procedure TfrmGPL.trvBookmarksDblClick(Sender: TObject);
var
  UserAction: PUserAction;
  sobj: TbfaSearch;
begin
  try
    if (trvBookmarks.Selected <> nil) and (trvBookmarks.Selected.Data <> nil) then
    begin
      if TObject(trvBookmarks.Selected.Data) is TbfaSearch then
      begin
        {$IFNDEF DISABLE_HISTORY_FUTURE_DELETE} // SJ 14.07.2023 - bfacrm:ticket__show__35313
        if TbfaSearch(trvBookmarks.Selected.Data).SearchType = 3 then
          bitfarmApp.DeleteFutureHistoryNodes := trvBookmarks.Selected.Data
        else
          bitfarmApp.DeleteFutureHistoryNodes := nil;
        {$ENDIF}

        sobj := TbfaSearch.Create;
        sobj.Clone(trvBookmarks.Selected.Data);
        UserAction := bitfarmApp.CreateUserAction;
        UserAction^.ActionName := 'actBookmarkSearch';
        UserAction^.Objects.Add(sobj);
        bitfarmApp.MainThread.Add(UserAction);
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'trvBookmarksDblClick', ClassName);
  end;
end;

procedure TfrmGPL.trvBookmarksDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  AnItem: TTreeNode;
  UserAction: PUserAction;
begin
  if trvBookmarks.Selected = nil then
    Exit;
  AnItem := trvBookmarks.GetNodeAt(X, Y);
  FBookMarksAutoscroll.Enabled := False;

  if ((AnItem = bitfarmApp.GlobalListNode) or (AnItem = bitfarmApp.HistoryListNode)) then
    Exit;

  try
    UserAction := bitfarmApp.CreateUserAction;
    UserAction^.ActionName := 'actBookmarksTreeViewDragDrop';
    UserAction^.Objects.Add(Sender);
    UserAction^.Objects.Add(Source);
    UserAction^.Objects.Add(trvBookmarks);
    UserAction^.Objects.Add(trvBookmarks.Selected);
    UserAction^.Objects.Add(AnItem);
    UserAction^.Params.Add(IntToStr(X));
    UserAction^.Params.Add(IntToStr(Y));
    bitfarmApp.MainThread.Add(UserAction);
  except
    bitfarmLog.Write(llNormal, ltException, 'trvBookmarksDragDrop', ClassName);
  end;
end;

procedure TfrmGPL.trvBookmarksDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
var
  Target: TTreeNode;
begin
  if Y < 15 then
  begin
     FBookmarksscroll_down := True;
     FBookMarksAutoscroll.Enabled := True;
  end
  else if (Self.trvBookmarks.Height - Y) < 15 then
  begin
     FBookmarksscroll_down := False;
     FBookMarksAutoscroll.Enabled := True;
  end
  else
     FBookMarksAutoscroll.Enabled := False;

  if (Source = nil) or (Source <> Sender) or (TTreeView(Sender).Selected = nil) then
  begin
    Accept := False;
    Exit;
  end;

  Target := TTreeView(Sender).getNodeAt(X, Y);

  if Target <> nil then
  begin
    if bitfarmApp.User.isAdmin then
    begin     //  and TbfaNodeInfo(TTreeView(Sender).Selected.Data).Typ = -1)
//      Accept := not ((Node = bitfarmApp.HistoryListNode) or (GetRootNode(Node) = bitfarmApp.HistoryListNode) or ((TObject(TTreeView(Sender).Selected.Data) is TbfaNodeInfo)) );
      Accept := not ((GetRootNode(Target) = bitfarmApp.HistoryListNode) or
                     (Target = bitfarmApp.GlobalListNode) or
                     (
                        (TObject(TTreeView(Sender).Selected.Data) is TbfaNodeInfo) and
                        (TbfaNodeInfo(TTreeView(Sender).Selected.Data).Typ = -1)
                     )
                    );
    end
    else if (GetRootNode(Target) = bitfarmApp.GlobalListNode) or
            (GetRootNode(Target) = bitfarmApp.HistoryListNode) or
            (GetRootNode(TTreeView(Sender).Selected) = bitfarmApp.GlobalListNode)
    then
      Accept := False
    else
      Accept := True;
  end
  else
    Accept := False;
end;

procedure TfrmGPL.trvBookmarksEdited(Sender: TObject; Node: TTreeNode; var S: string);
var
  UserAction: PUserAction;
  PNode: TTreeNode;
begin
  bitfarmLog.DebugBegin(llDebug, 'trvBookmarksEdited', ClassName);
  try
    try
      if GetRootNode(Node) = bitfarmApp.LocalListNode then
      begin
        if (Node.Data <> nil) and (TObject(Node.Data) is TbfaSearch) then
          TbfaSearch(Node.Data).Name := S;

        UserAction := bitfarmApp.CreateUserAction;
        UserAction^.ActionName := 'actSaveLocalBookmark';
        bitfarmApp.BackThread.Add(UserAction);

      end
      else if (GetRootNode(Node) = bitfarmApp.GlobalListNode) and bitfarmApp.User.isAdmin then
      begin
        if (Node.Data <> nil) and (TObject(Node.Data) is TbfaSearch) then
          TbfaSearch(Node.Data).Name := S;

        PNode := GetParentNode(Node);
        UserAction := bitfarmApp.CreateUserAction;
        UserAction^.ActionName := 'actSaveGlobalBookmark';
        UserAction^.Objects.Add(PNode);
        bitfarmApp.BackThread.Add(UserAction);

      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'trvBookmarksEdited', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'trvBookmarksEdited', ClassName);
  end;
end;

procedure TfrmGPL.trvBookmarksEditing(Sender: TObject; Node: TTreeNode; var AllowEdit: Boolean);
var
  RNode: TTreeNode;
begin
//  if ((Node = bitfarmApp.LocalListNode) or
//      (Node = bitfarmApp.GlobalListNode) or
//      ((Node.Data <> nil) and (TObject(Node.Data) is TbfaNodeInfo)) or
//      (Node = bitfarmApp.HistoryListNode))
//  then
//    AllowEdit := False
//  else
//  begin
//    RNode := GetRootNode(Node);
//    if (((RNode = bitfarmApp.GlobalListNode) and not bitfarmApp.User.isAdmin) or (RNode = bitfarmApp.HistoryListNode)) then
//      AllowEdit := False;
//  end;
  RNode := GetRootNode(Node);
  if (Node = RNode) or (RNode = bitfarmApp.HistoryListNode) then
    AllowEdit := False
  else if ((RNode = bitfarmApp.GlobalListNode) and not bitfarmApp.User.isAdmin) then
    AllowEdit := False;
end;

procedure TfrmGPL.trvBookmarksExpanded(Sender: TObject; Node: TTreeNode);
begin
  try
    Node.ImageIndex := Integer(icoidx_bookmark_folder_expanded);
    Node.SelectedIndex := Integer(icoidx_bookmark_folder_expanded);
  except
    bitfarmLog.Write(llNormal, ltException, 'trvBookmarksExpanded', ClassName);
  end;
end;

procedure TfrmGPL.trvBookmarksKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_RETURN then
    trvBookmarksDblClick(Sender);
end;

procedure TfrmGPL.trvBookmarksMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  Node: TTreeNode;
  hitTest: THitTests;
begin
  Node := trvBookmarks.GetNodeAt(X, Y);

  if Node = nil then
    Exit;

  hitTest := trvBookmarks.GetHitTestInfoAt(X, Y);

  if (csLButtonDown in trvBookmarks.ControlState) and (not trvBookmarks.Dragging) and (Node.ImageIndex <> 0) then
  begin
    trvBookmarks.BeginDrag(false, 20);
  end;

  if (lastHintNode <> Node) then
  begin
    Application.CancelHint;

    if (hitTest <= [htOnItem, htOnIcon, htOnLabel, htOnStateIcon]) then
    begin
      lastHintNode := Node;
      trvBookmarks.Hint := NodeHint(Node);
    end;
  end;

end;

function TfrmGPL.NodeHint(tn: TTreeNode): string;
begin
  try
  if (tn.Data <> nil) and (TObject(tn.Data) is TbfaSearch) then
  begin
    if TbfaSearch(tn.Data).SelectedArcID > 0 then
    begin
      if (TbfaSearch(tn.Data).SelectedArcID <= High(aSysArc)) then
      begin
        if aSysArc[TbfaSearch(tn.Data).SelectedArcID].Typ = 0 then
          Result := _('Lager:') + ' ' + aSysArc[TbfaSearch(tn.Data).SelectedArcID].Name
        else
          Result := _('Archiv:') + ' ' + aSysArc[TbfaSearch(tn.Data).SelectedArcID].Name;
      end;
    end else if TbfaSearch(tn.Data).SelectedArcID = 0 then
      Result := _('aktuelles Archiv')
    else
      Result := _('Alle Archive');
  end
  else
    Result := '';
  except
    bitfarmLog.Write(llNormal, ltException, 'NodeHint', ClassName);
  end;
end;

procedure TfrmGPL.NoSubmenuItemHint(var HintStr: string; var CanShow: Boolean);
begin
  HintStr := '';
end;

procedure TfrmGPL.SetNotificationBar(Info: WideString; AThread: TThread = nil);
var
  ActControl: TfrmGPL;
  CurrentPreview: TbfaPreview;
  NotificationLabel: TSpTBXLabelItem;
  TimerItem: TTimer;
begin
  bitfarmLog.DebugBegin(llDebug, 'SetNotificationBar', Classname);
  Info := StringReplace(Info, '&', '&&', [rfReplaceAll]);
  CurrentPreview := bitfarmApp.GetActivePreview;
  try
    try
      if CurrentPreview.Floating then
      begin
        NotificationLabel := TbfaFloatingForm((TSpTBXDockablePanel(CurrentPreview.Owner).Parent).Parent).itmNotification;
        TimerItem := TbfaFloatingForm((TSpTBXDockablePanel(CurrentPreview.Owner).Parent).Parent).tmrNotification;
      end else
      begin
        NotificationLabel := Self.itmNotification;
        TimerItem := Self.tmrNotification;
      end;

      if AThread = nil then
      begin
        TimerItem.Enabled := False;
        TimerItem.Enabled := True;
        NotificationLabel.FontSettings.Style := [fsBold];
        NotificationLabel.Caption := Info;
        NotificationLabel.Visible := True;
      end else
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            TimerItem.Enabled := False;
            TimerItem.Enabled := True;
            NotificationLabel.FontSettings.Style := [fsBold];
            NotificationLabel.Caption := Info;
            NotificationLabel.Visible := True;
          end);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'SetNotificationBar', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetNotificationBar', Classname);
  end;
end;

procedure TfrmGPL.ResetNotificationBar(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'ResetNotificationBar', Classname);
  try
    try
      begin
        // Self
        Self.tmrNotification.Enabled := False;
        Self.itmNotification.Visible := False;
        Self.itmNotification.Caption := '';
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'ResetNotificationBar', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ResetNotificationBar', Classname);
  end;
end;

procedure TfrmGPL.SetActiveTab;
var
  i: Integer;
  ActTab: TSpTBXTabItem;
  found: Boolean;
begin
  if (not fAppStarted) or (bitfarmApp.InPanelClose) then
    Exit;

  try
    if tstDocumentEditors.Items.Count > 0 then
    begin
      if (tstDocumentEditors.ActiveTab <> nil) and (tstDocumentEditors.ActiveTab.Visible) then
        ActTab := tstDocumentEditors.ActiveTab
      else
      begin
        i := 0;
        found := False;
        while ((not found) and (i <= tstDocumentEditors.Items.Count - 1)) do
        begin
          if tstDocumentEditors.Items[i].Visible then
            found := True
          else
            inc(i);
        end;

        if found then
          ActTab := TSpTBXTabItem(tstDocumentEditors.Items[i])
        else
          ActTab := bitfarmApp.PreviewContainer.ViewerItem.Tab;
      end;

      for i := 0 to bitfarmApp.PreviewContainer.Containers.Count - 1 do
      begin
        if Assigned(bitfarmApp.PreviewContainer.Containers[i]) then
        begin
          if ActTab = bitfarmApp.PreviewContainer.Containers[i].Tab then
          begin
            bitfarmApp.PreviewContainer.Containers[i].Panel.Visible := True;
            if (not bitfarmApp.PreviewContainer.Containers[i].Panel.Floating) then
            begin
              if (not bitfarmApp.PreviewContainer.Containers[i].Tab.Visible) then
                bitfarmApp.PreviewContainer.Containers[i].Tab.Visible := True;
              bitfarmApp.ActivatePrev(bitfarmApp.PreviewContainer.Containers[i].Preview); //24.07.2017 Ticket 11157
            end;
          end
          else if ((not bitfarmApp.PreviewContainer.Containers[i].Panel.Floating) and
            (bitfarmApp.PreviewContainer.Containers[i].Panel.Parent.Name <> 'dckFloating') and
            (bitfarmApp.PreviewContainer.Containers[i].Panel <> bitfarmApp.PreviewContainer.PageSortingsItem.Panel)
            ) then
            bitfarmApp.PreviewContainer.Containers[i].Panel.Visible := False;
        end;
      end;

      if (ActTab <> nil) and (ActTab <> tstDocumentEditors.ActiveTab) then
        ActTab.Click;

      SetTabButton;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetActiveTab', ClassName);
  end;
end;

procedure TfrmGPL.tstDocumentEditorsActiveTabChange(Sender: TObject; TabIndex: Integer);
begin
  try
    if (fAppStarted) and ((bitfarmApp <> nil) and (not bitfarmApp.ClosingMainForm) and
       (not bitfarmApp.fSkipTabChangeEvent)) then
    begin
      SetActiveTab;
      if TabIndex < 6 then   // die ersten 6 Tabs sind reserviert
        bitfarmApp.SetActiveViewAction(TabIndex, nil, bitfarmApp.CurrentView)
      else
        bitfarmApp.ShowActiveTabAction(TabIndex);
    end
    else
      SetTabButton;
  except
    bitfarmLog.Write(llNormal, ltException, 'tstDocumentEditorsActiveTabChange', ClassName);
  end;
end;

procedure TfrmGPL.SetTabButton;
begin
  if not fAppStarted then
    Exit;

  if bitfarmApp = nil then
    Exit;

  try
    if (((bitfarmApp.PreviewContainer.ImporterItem <> nil) and (tstDocumentEditors.ActiveTab = bitfarmApp.PreviewContainer.ImporterItem.Tab)) or ((bitfarmApp.PreviewContainer.WorkplaceItem <> nil) and (tstDocumentEditors.ActiveTab = bitfarmApp.PreviewContainer.WorkplaceItem.Tab)) or ((bitfarmApp.PreviewContainer.ViewerItem <> nil) and (tstDocumentEditors.ActiveTab = bitfarmApp.PreviewContainer.ViewerItem.Tab))) then
    begin
      tstDocumentEditors.TabCloseButton := tcbNone;
    end
    else
      tstDocumentEditors.TabCloseButton := tcbActive;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetTabButton', ClassName);
  end;
end;

procedure TfrmGPL.LayoutsItemClick(Sender: TObject);
begin
  try
    if Sender is TSpTBXItem then
      LoadLayout(TSpTBXItem(Sender).Caption);
  except
    bitfarmLog.Write(llNormal, ltException, 'LayoutsItemClick', ClassName);
  end;
end;

procedure TfrmGPL.LoadLayout(LayoutName: string);
var
  i: Integer;
  ini: Tinifile;
  Inistr : string;
begin
  bitfarmLog.DebugBegin(llDebug, 'LoadLayout(' + LayoutName + ')', Classname);
  SaveInitLayout := False;
  try
    for i := 0 to frmMainForm.tbsubLayout.Count - 1 do
      frmMainForm.tbsubLayout.Items[i].Checked := False;

    inistr := '';
    if not FDefaultLayout then
    begin
      if (bitfarmApp.GlobalViewerLayout <> '') then
        Inistr := bitfarmApp.GlobalViewerLayout
      else if (bitfarmApp.ViewerLayout <> '') then
        Inistr := bitfarmApp.ViewerLayout
      else
      begin
        if FileExists(ExtractFilePath(Application.ExeName) + 'layout.ini') then
          Inistr := ExtractFilePath(Application.ExeName) + 'layout.ini'
        else if FileExists(BD.AppdataBitfarmPd + 'layout.ini') then
          Inistr := BD.AppdataBitfarmPd + 'layout.ini';
      end;
    end;

    if (not FDefaultLayout) and (inistr <> '') then
    begin
      SpTBXCustomizer1.LoadLayout(inistr, LowerCase(LayoutName));
    end else
    begin
      FLastActivePreview := 0;
      FLastActiveTab := 0;

      // bses, bses xsMaximized: Wenn das hier gesetzt wird geht kein Drag n Drop in den Viewer rein.
//      Self.WindowState := wsMaximized; //03.07.2023

      with tlbMainMenu do
      begin
        Visible := True;
        CurrentDock := SpTBXDock1;
        LastDock := SpTBXDock1;
        DockRow := 0;
        DockPos := 0;
        DisplayMode := tbdmSelectiveCaption;
      end;

      with tlbGraphic do
      begin
        Visible := False;
        CurrentDock := SpTBXDock1;
        LastDock := SpTBXDock1;
        DockRow := 3;
        DockPos := 0;
        DisplayMode := tbdmSelectiveCaption;
      end;

      with tlbTools do
      begin
        Visible := False;
        CurrentDock := SpTBXDock1;
        LastDock := SpTBXDock1;
        DockRow := 3;
        DockPos := 194;
        DisplayMode := tbdmSelectiveCaption;
      end;

      with tlbDocState do
      begin
        Visible := True;
        CurrentDock := SpTBXDock1;
        LastDock := SpTBXDock1;
        DockRow := 1;
        DockPos := 0;
        DisplayMode := tbdmSelectiveCaption;
      end;

      with tlbStatefields do
      begin
        Visible := False;
        CurrentDock := SpTBXDock1;
        LastDock := SpTBXDock1;
        DockRow := 1;
        DockPos := 476;
        DisplayMode := tbdmSelectiveCaption;
        Visible := False;
        Options := [tboNoAutoHint];
      end;

      with tlbPlugins do
      begin
        Visible := False;
        CurrentDock := SpTBXDock1;
        LastDock := SpTBXDock1;
        DockRow := 0;
        DockPos := 873;
        DisplayMode := tbdmSelectiveCaption;
      end;

      with bfaTlbStandard1 do
      begin
        Visible := True;
        CurrentDock := SpTBXDock1;
        LastDock := SpTBXDock1;
        DockRow := 0;
        DockPos := 314;
        DisplayMode := tbdmSelectiveCaption
      end;

      with bfaTlbPreview1 do
      begin
        Visible := True;
        CurrentDock := SpTBXDock1;
        LastDock := SpTBXDock1;
        DockRow := 0;
        DockPos := 572;
        DisplayMode := tbdmSelectiveCaption;
      end;

      dckTreeView.Width := fpnlTreeviewWidth;
      SpTBXMultiDock2.Width := fpnlSearchWidth;

      with pnlTreeView do
      begin
        Visible := True;
        CurrentDock := SpTBXMultiDock5;
        LastDock := SpTBXMultiDock5;
        DockRow := 0;
        DockPos := 0;
        if bitfarmApp.User.isAdmin then
          Height := SpTBXMultiDock5.Height - (5 * 23)
        else
          Height := SpTBXMultiDock5.Height - (4 * 23);
        FloatingClientWidth := 0;
        FloatingClientHeight := 0;
      end;

      with pnlImporter do
      begin
        Visible := True;
        CurrentDock := SpTBXMultiDock5;
        LastDock := SpTBXMultiDock5;
        DockRow := 0;
        DockPos := pnlTreeView.Height;
        Height := 23;
        FloatingClientWidth := 0;
        FloatingClientHeight := 0;
      end;

      with pnlResubmission do
      begin
        Visible := True;
        CurrentDock := SpTBXMultiDock5;
        LastDock := SpTBXMultiDock5;
        DockRow := 0;
        DockPos := pnlImporter.DockPos + 23;
        Height := 23;
        FloatingClientWidth := 0;
        FloatingClientHeight := 0;
      end;

      with pnlFavorites do
      begin
        Visible := True;
        CurrentDock := SpTBXMultiDock5;
        LastDock := SpTBXMultiDock5;
        DockRow := 0;
        DockPos := pnlResubmission.DockPos + 23;
        Height := 23;
        FloatingClientWidth := 0;
        FloatingClientHeight := 0;
      end;

      with pnlWorkspace do
      begin
        Visible := True;
        CurrentDock := SpTBXMultiDock5;
        LastDock := SpTBXMultiDock5;
        DockRow := 0;
        DockPos := pnlFavorites.DockPos + 23;
        Height := 23;
        FloatingClientWidth := 0;
        FloatingClientHeight := 0;
      end;

      with pnlAdmin do
      begin
        Visible := bitfarmApp.User.isAdmin;
        CurrentDock := SpTBXMultiDock5;
        LastDock := SpTBXMultiDock5;
        DockRow := 0;
        DockPos := pnlWorkspace.DockPos + 23;
        Height := 23;
        FloatingClientWidth := 0;
        FloatingClientHeight := 0;
      end;

      pnlTreeView.Maximize;
      pnlImporter.Minimize;
      pnlResubmission.Minimize;
      pnlFavorites.Minimize;
      pnlWorkspace.Minimize;
      pnlAdmin.Minimize;

      SaveInitLayout := True;   // wenn wir ohne ViewerLayout.ini gestartet sind und ein InitailLayout erstellt haben
                                // dann speichern wir das am Ende der FormShow
    end;

    SetAdminGUI;

    for i := 0 to frmMainForm.tbsubLayout.Count - 1 do
    begin
      if Lowercase(frmMainForm.tbsubLayout.Items[i].Caption) = LowerCase(LayoutName) then
      begin
        frmMainForm.tbsubLayout.Items[i].Checked := True;
        Break;
      end;
    end;

    if bitfarmApp.OfflineMode then
    begin
      pnlImporter.Visible := False;
      pnlResubmission.Visible := False;
    end;

    if fAppStarted then
    begin
      if (pnlTreeView.Maximized) and (bitfarmApp.CurrentView <> tvkViewer) then
        pnlTreeView.Maximize
      else if (pnlImporter.Maximized) and (bitfarmApp.CurrentView <> tvkImporter) then
        pnlImporter.Maximize
      else if (pnlResubmission.Maximized) and (bitfarmApp.CurrentView <> tvkResub) then
        pnlResubmission.Maximize
      else if (pnlFavorites.Maximized) and (bitfarmApp.CurrentView <> tvkFavorites) then
        pnlFavorites.Maximize
      else if (pnlWorkspace.Maximized) and (bitfarmApp.CurrentView <> tvkWorkplace) then
        pnlWorkspace.Maximize
      else if (pnlAdmin.Maximized) and (bitfarmApp.CurrentView <> tvkAdministrator) then
        pnlAdmin.Maximize;
    end;

    ini := TIniFile.Create(BD.AppdataBitfarmPd + 'ViewerLayout.ini');
    try
      ini.WriteString('Layouts', 'Default', LayoutName);
    finally
      FreeAndNil(ini);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'LoadLayout(' + LayoutName + ')', Classname);
  end;
end;

//procedure TfrmGPL.LoadStandardLayout;
//begin
//  try
//    LoadLayout('Standard');
//  except
//    bitfarmLog.Write(llNormal, ltException, 'LoadStandardLayout', ClassName);
//  end;
//end;

procedure TfrmGPL.MainFormMouseActivate(Sender: TObject; Button: TMouseButton; ShiftState: TShiftState;
  X, Y: Integer; HitTest: Integer; var MouseActivate: TMouseActivate);
var
  tp1, tp2: TPoint;
begin
  // weil das Mehrfachauswahl-Feld aus zwei Komponenten besteht (TokenEdit und CheckedListBox)
  // prfen wir ob in das Control geklickt wurde oder wo anders auf der Form.
  // wenn auerhalb, blenden wir CheckedListBox aus.
  // der OnMouseDown- und OnClick-Event triggert nicht, deswegen OnMouseActivate.

  // SJ 23.08.22 - TfrmMoveDoc hat den Event auch zugeordnet
  try
    if (Self.VisibleListControl <> nil) and
       (Self.VisibleListControl is TbfaCheckedListBox) then
    begin
      tp1 := TbfaCheckedListBox(Self.VisibleListControl).ScreenToClient(Mouse.CursorPos);
      tp2 := TbfaCheckedCombo(TbfaAddfieldComp(TbfaCheckedListBox(Self.VisibleListControl).Owner).comp).ScreenToClient(Mouse.CursorPos);

      // maActivateAndEat muss vor .Hide sein, sonst ist VisibleListControl = nil
      if PtInRect(TbfaCheckedCombo(TbfaAddfieldComp(TbfaCheckedListBox(Self.VisibleListControl).Owner).comp).ClientRect, tp2) then
        MouseActivate := maActivateAndEat;

      if not PtInRect(TbfaCheckedListBox(Self.VisibleListControl).ClientRect, tp1) then
        TbfaCheckedListBox(Self.VisibleListControl).Hide;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'MainFormMouseActivate', ClassName);
  end;
end;

procedure TfrmGPL.OnActiveControlChange(Sender: TObject);
begin
  try
    if  Assigned(bitfarmApp) and
        (
         (bitfarmApp.CurrentView = tvkViewer) or
         (bitfarmApp.CurrentView = tvkFavorites) or
         (bitfarmApp.CurrentView = tvkResub)
        )
        // Self
        and (Self.tcSearch.ActiveTab = Self.tabSearchAddfields)
        and (Screen.ActiveControl <> nil)
        and (Screen.ActiveControl is TWinControl)
        and (TWinControl(Screen.ActiveControl).Parent <> nil)
        and (TWinControl(Screen.ActiveControl.Parent) is TcxControl)
        and (TcxControl(Screen.ActiveControl.Parent).IsFocused)
        and (TcxControl(Screen.ActiveControl.Parent).Parent <> nil)
        and ((TcxControl(Screen.ActiveControl.Parent).Parent is TbfaAddfieldComp)
        or (TcxControl(Screen.ActiveControl.Parent).Parent is TcxGrid)
        or (TcxControl(Screen.ActiveControl.Parent).Parent is TcxGridSite))
        and (TcxControl(Screen.ActiveControl.Parent).Parent.Parent <> nil) then
    begin
      if (TcxControl(Screen.ActiveControl.Parent).Parent.Parent = Self.scrbxViewerAddfields) then
        bitfarmApp.FLastFocusedAddfield := TbfaAddfieldComp(TcxControl(Screen.ActiveControl.Parent).Parent)
      else if (TcxControl(Screen.ActiveControl.Parent).Parent.Parent is TbfaAddfieldComp) then
        bitfarmApp.FLastFocusedAddfield := TbfaAddfieldComp(TcxControl(Screen.ActiveControl.Parent).Parent.Parent)
    end
    else if (Screen.ActiveControl <> Self.btnSave) then
      bitfarmApp.FLastFocusedAddfield := nil;

  except
    bitfarmLog.Write(llNormal, ltException, 'OnActiveControlChange', ClassName);
  end;
end;

procedure TfrmGPL.OnCheckListClick(Field: TBfaAddfieldComp);
var
  tp, tp3: TPoint;
  lst: TStringList;
  i: Integer;
begin
  TbfaCheckedListBox(Field.comp2).Width := TbfaCheckedCombo(Field.comp).Width;
  TbfaCheckedListBox(Field.comp2).Height := 160;
  tp := Field.ClientOrigin;
  if Self.Active then
  begin
    tp3 := Self.pnlSearchOptions.ScreenToClient(tp);
    TbfaCheckedListBox(Field.comp2).Left := tp3.X + Field.IndexingOffset + 10;
    TbfaCheckedListBox(Field.comp2).Top := tp3.Y + muldiv(Field.Height - 4, Screen.PixelsPerInch, 96);
    TbfaCheckedListBox(Field.comp2).SetParentComponent(pnlSearchOptions);
  end
  else
  begin
    if (Screen.ActiveForm is TfrmMoveDoc) then
    begin
      tp3 := TfrmMoveDoc(Screen.ActiveForm).scrbxMoveDocAddfields.ScreenToClient(tp);
      TbfaCheckedListBox(Field.comp2).Left := tp3.X + Field.IndexingOffset + 10;
      TbfaCheckedListBox(Field.comp2).Top := tp3.Y + muldiv(Field.Height - 4, Screen.PixelsPerInch, 96);
      TbfaCheckedListBox(Field.comp2).SetParentComponent(TfrmMoveDoc(Screen.ActiveForm).scrbxMoveDocAddfields);
    end;
  end;

  if (Self.LastCheckedList = Field) and Field.ListClose then
  begin
    TbfaCheckedListBox(Field.comp2).Visible := False;
    Self.LastCheckedList := nil;
    TSpTBXButtonEdit(Field.comp).SelStart := Length(TSpTBXButtonEdit(Field.comp).Text);
  end
  else
  begin
    TbfaCheckedListBox(Field.comp2).Visible := not TbfaCheckedListBox(Field.comp2).Visible;
    Self.LastCheckedList := Field;
  end;

  if TbfaCheckedListBox(Field.comp2).Visible then
  begin
    if Field.Value <> '' then
    begin
      lst := TStringList.Create;
      lst.Delimiter := ';';
      lst.StrictDelimiter := True;
      lst.DelimitedText := Field.Value;
      lst.CaseSensitive := True;

      for i := 0 to lst.Count - 1 do
      begin
{
      17.07.2019 Ticket 13925 SJ
      Da bei gleichen Werten mit verschiedener gro-/kleinschreibung immer der erste
      Index gechecked wurde, obwohl diese (case-technisch) nicht der korrekte seien
      musste wurde hier eine eigene IndexOf implementiert. Fr den Fall dass der
      Wert aus lst[i] nicht CaseSensitive gefunden wird, wird dann noch die normale
      IndexOf Methode als Fallback aufgerufen.
}
//        if TbfaCheckedListBox(Field.comp2).Items.IndexOf(lst[i]) > -1 then
        if IndexOfCaseSensitive(TbfaCheckedListBox(Field.comp2).ItemsString, lst[i]) > -1 then
          TbfaCheckedListBox(Field.comp2).Items[IndexOfCaseSensitive(TbfaCheckedListBox(Field.comp2).ItemsString, lst[i])].Checked := True
        else if TbfaCheckedListBox(Field.comp2).Items.IndexOf(lst[i]) > -1 then
          TbfaCheckedListBox(Field.comp2).Items[TbfaCheckedListBox(Field.comp2).Items.IndexOf(lst[i])].Checked := True;
      end;
      FreeAndNil(lst);
    end;
    OnComboDropDown(Field.comp2);
    TbfaCheckedListBox(Field.comp2).SetFocus;
  end
  else
    OnComboCloseUp(Field.comp2);

end;

procedure TfrmGPL.OnComboCloseUp(Sender: TObject);
begin
  if (Sender is TbfaCheckedListBox) then
    TbfaCheckedListBox(Sender).Hide;

  OpenDropDown := False;
  Self.VisibleListControl := nil;
end;

procedure TfrmGPL.OnComboDropDown(Sender: TObject);
begin
  OpenDropDown := True;
  Self.VisibleListControl := Sender;
end;

procedure TfrmGPL.OnComboDouble(Sender: TObject; AValue: WideString);
begin
  BfShowMessage(Format(_('Es gibt schon einen Eintrag %s.'), [AValue]));
end;

procedure TfrmGPL.pnlFavoritesWindowStateChanged(Sender: TObject; AWindowState: TWindowState);
begin
  if fAppStarted and pnlFavorites.Maximized and (bitfarmApp.CurrentView <> tvkFavorites) then
  begin
    if FViewerTreeview.Selected = nil then
      FViewerTreeview.Selected := FViewerTreeview.Items[0];

    bitfarmApp.SetActiveViewAction(pvtViewer, nil, tvkFavorites);

// SJ 01.08.2022 - TVChange lst SetActiveViewAction aus und setzt tvkViewer
//    TVChange(FViewerTreeview, FViewerTreeview.Selected);
  end;
end;

procedure TfrmGPL.pnlImporterWindowStateChanged(Sender: TObject; AWindowState: TWindowState);
begin
  if fSkipMaximizeEvent then
    Exit;

  if fAppStarted and pnlImporter.Maximized and (bitfarmApp.CurrentView <> tvkImporter) then
  begin
    bitfarmApp.SetActiveViewAction(pvtImporter, nil, tvkImporter);
    if FImporterTreeview.Selected = nil then
      if FImporterTreeview.Items.Count > 0 then
        FImporterTreeview.Selected := FImporterTreeview.Items[0];
    if FImporterTreeview.Selected <> nil then
      TVChange(FImporterTreeview, FImporterTreeview.Selected);
  end;
end;

procedure TfrmGPL.pnlPreviewCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
  if fAppStarted and bitfarmApp.FShowPageSortings then
    Resize := False;
end;

procedure TfrmGPL.pnlPreviewDockChanged(Sender: TObject);
begin  //fr SpTBXDockablePanel3 Form wurde umstrukturiert...
  try
    if not pnlPreview.Floating then
      pnlPreview.Width := PreviewWidth
    else
      PreviewWidth := pnlPreview.Width;
    Self.bfaTlbPreview1.sbmAutozoom.Click;

    //27.05.2024 SD -->bfacrm:ticket__show__38630
    if dckTreeView.width > 0 then
    begin
      if pnlSearchOptions.Floating then
      begin
        if dckTreeView.width > Round((frmMainForm.Width - 48) / 2) then
          dckTreeView.width := Round((frmMainForm.Width - 48) / 2)
      end
      else
      begin
        if dckTreeView.width > Round((frmMainForm.Width - 48) / 3) then
          dckTreeView.width := Round((frmMainForm.Width - 48) / 3);
        if (frmMainForm.Width - (dckTreeView.width + 48)) < pnlSearchOptions.Width then
          pnlSearchOptions.Width := Round((frmMainForm.Width - (dckTreeView.width + 48)) / 2);
      end;
    end;
    //27.05.2024 SD <--bfacrm:ticket__show__38630

  except
    bitfarmApp.Log.Write(llNormal, ltException, 'pnlPreviewDockChanged', Classname);
  end;
end;

procedure TfrmGPL.pnlResubmissionResize(Sender: TObject);
begin
  bitfarmApp.DoResubPanelResize(fraResub);
end;

procedure TfrmGPL.pnlResubmissionWindowStateChanged(Sender: TObject; AWindowState: TWindowState);
begin
  if fSkipMaximizeEvent then
    Exit;

  if fAppStarted and pnlResubmission.Maximized and (bitfarmApp.CurrentView <> tvkResub)then
  begin
    bitfarmApp.SetActiveViewAction(pvtViewer, nil, tvkResub);
    ShowTasks;
  end;
end;

procedure TfrmGPL.pnlSearchOptionsDockChanged(Sender: TObject);
begin
  try
    Self.OnResize(Sender);
    Self.bfaTlbPreview1.sbmAutozoom.Click;
  except
    bitfarmApp.Log.Write(llNormal, ltException, 'pnlSearchOptionsDockChanged', Classname);
  end;
end;

procedure TfrmGPL.pnlSearchOptionsDockChanging(Sender: TObject; Floating: Boolean; DockingTo: TTBDock);
begin
  try
    if DockingTo <> nil then
      begin
        pnlSearchOptionsResize(Sender);
        //27.05.2024 SD -->bfacrm:ticket__show__38630
        if dckTreeView.width > Round((frmMainForm.Width - 48) / 3) then
          dckTreeView.width := Round((frmMainForm.Width - 48) / 3);
        pnlSearchOptions.Width := Round((frmMainForm.Width - (dckTreeView.width + 48)) / 2);
        //27.05.2024 SD <--bfacrm:ticket__show__38630
      end;
 except
    bitfarmApp.Log.Write(llNormal, ltException, 'pnlSearchOptionsDockChanging', Classname);
  end;
end;

procedure TfrmGPL.pnlSearchOptionsResize(Sender: TObject);
var
  i, j : Integer;
begin
  try
    if (fAppStarted) and (bitfarmApp <> nil) and (not bitfarmApp.ClosingMainForm) then
    begin
      if (pnlSearchOptions.Parent <> nil) and (pnlSearchOptions.Parent.Name <> 'dckFloating') then
      begin
        if (pnlSearchOptions.Width < fpnlSearchWidth) or (pnlPreview.Width = 0) then    // bfacrm:ticket__show__24858 10/28/2020  Auf Anfangsposition nach dem Doppelklick setzen, wenn die Breite des Vorschaubereichs 0 wird.
          pnlSearchOptions.Width := fpnlSearchWidth;
        with bitfarmApp.ViewerOptions.GUIOptions do
        begin
          SearchPanelWidth := pnlSearchOptions.Width;
        end;
      end;

      if edtGeneralSearch.Width < pnlQuickSearch.Width - pnlSearchTimer.width - pnlLoadDoc.Width - 20 then
        edtGeneralSearch.Width := pnlQuickSearch.Width - pnlSearchTimer.width - pnlLoadDoc.Width - 20;

      if (bitfarmApp.CurrentView = tvkImporter) and pnlSearchOptions.Floating then //ScanFrame anpassen wenn ausgedockt
        Self.OnResize(Sender);
    end;
  except
    bitfarmApp.Log.Write(llNormal, ltException, 'pnlSearchOptionsResize', Classname);
  end;
end;

procedure TfrmGPL.pnlTreeViewWindowStateChanged(Sender: TObject; AWindowState: TWindowState);
begin
  if fSkipMaximizeEvent then
    Exit;

  if fAppStarted and pnlTreeView.Maximized and (bitfarmApp.CurrentView <> tvkViewer) then
  begin
    bitfarmApp.SetActiveViewAction(pvtViewer, nil, tvkViewer);

    if FViewerTreeview.Selected = nil then
      if FViewerTreeview.Items.Count > 0 then
        FViewerTreeview.Selected := FViewerTreeview.Items[0];

    if FViewerTreeview.Selected <> nil then
      TVChange(FViewerTreeview, FViewerTreeview.Selected);
  end;
end;

procedure TfrmGPL.pnlWorkspaceWindowStateChanged(Sender: TObject; AWindowState: TWindowState);
begin
  if fSkipMaximizeEvent then
    Exit;

  if fAppStarted and pnlWorkspace.Maximized and (bitfarmApp.CurrentView <> tvkWorkplace) then
    bitfarmApp.SetActiveViewAction(pvtWorkplace, nil, tvkWorkplace);
end;

procedure TfrmGPL.popAddFieldsPopup(Sender: TObject);
begin
  try
    try
      mnuIndexing.Visible := (bitfarmApp.CurrentView in [tvkViewer, tvkImporter, tvkResub]);
    except
      mnuIndexing.Visible := False;
    end;
    // bfacrm:ticket__show__28312 + bfacrm:ticket__show__23319
    mnuAddfieldDetails.Caption := '';
    mnuDescription.Caption := '';
    try
      if (TSpTBXPopupMenu(Sender).PopupComponent <> nil) and
         (TSpTBXPopupMenu(Sender).PopupComponent.Owner <> nil) and
         (TSpTBXPopupMenu(Sender).PopupComponent.Owner is TBfaAddfieldComp) and
         (TBfaAddfieldComp(TSpTBXPopupMenu(Sender).PopupComponent.Owner).FieldID <> 0) then
      begin
        mnuAddfieldDetails.Caption := TBfaAddfieldComp(TSpTBXPopupMenu(Sender).PopupComponent.Owner).FieldName;
        case aAddfields[TBfaAddfieldComp(TSpTBXPopupMenu(Sender).PopupComponent.Owner).FieldID].Mode of
          0:
            mnuAddfieldDetails.Caption := mnuAddfieldDetails.Caption + ' | ' + _('Suchmethode') + ': ' + _('Exakt');
          1:
            mnuAddfieldDetails.Caption := mnuAddfieldDetails.Caption + ' | ' + _('Suchmethode') + ': ' + _('Wortende');
          2:
            mnuAddfieldDetails.Caption := mnuAddfieldDetails.Caption + ' | ' + _('Suchmethode') + ': ' + _('Wortanfang');
          3:
            mnuAddfieldDetails.Caption := mnuAddfieldDetails.Caption + ' | ' + _('Suchmethode') + ': ' + _('Bestandteil');
        end;
        if (aAddfields[TBfaAddfieldComp(TSpTBXPopupMenu(Sender).PopupComponent.Owner).FieldID].Options and 2) = 2 then
          mnuAddfieldDetails.Caption := mnuAddfieldDetails.Caption + ' | ' + _('Verknpfungsfeld');

        // Addfield-Beschreibung
        mnuDescription.Caption := aAddfields[TBfaAddfieldComp(TSpTBXPopupMenu(Sender).PopupComponent.Owner).FieldID].Description;
      end;

      //12.07.2024 SD -->bfacrm:ticket__show__11295
      if frmMainForm.tcSearch.ActiveTabIndex = 1 then
      begin
        frmMainForm.actHideSearchDetails.Enabled := True;
        bitfarmApp.SetDocLinkActions; //03.09.2024SD <--bfacrm:ticket__show__39649  der Menpunkt Neue Verknpfung erzeugen sollte verfgbar sein, wenn das aktuelle Dokument existiert
        frmMainForm.actShowIndexing.Enabled := True;
        frmMainForm.actShowIndexingWithLimit.Enabled := True;
      end
      else
      //03.09.2024 SD -->bfacrm:ticket__show__39649
      //Die Standard-Suchleiste bietet jetzt auch die Mglichkeit, Werte auszublenden
      if frmMainForm.tcSearch.ActiveTabIndex = 0 then
      begin
        frmMainForm.actHideSearchDetails.Enabled := True;
        frmMainForm.actNewLink.Enabled := False;
        frmMainForm.actShowIndexing.Enabled := False;
        frmMainForm.actShowIndexingWithLimit.Enabled := False;
      end
      //03.09.2024 SD <--bfacrm:ticket__show__39649

      else
      begin
        frmMainForm.actHideSearchDetails.Enabled := False;
        frmMainForm.actNewLink.Enabled := False;  //03.09.2024SD <--bfacrm:ticket__show__39649
        frmMainForm.actShowIndexing.Enabled := False;
        frmMainForm.actShowIndexingWithLimit.Enabled := False;
      end;
      //12.07.2024 SD <--bfacrm:ticket__show__11295

    except
      bitfarmLog.Write(llNormal, ltException, 'popAddFieldsPopup', Classname);
    end;

    try
      mnuMarkModified.Enabled := not ((Screen.ActiveControl is TcxGridSite) or (Screen.ActiveControl is TcxGrid));
    except
      mnuMarkModified.Enabled := False;
    end;

  finally
    mnuAddfieldDetails.Visible := (mnuAddfieldDetails.Caption <> '');
    mnuDescription.Visible := (mnuDescription.Caption <> '');
    smiDescription.Visible := (mnuDescription.Caption <> '');
  end;
  // bfacrm:ticket__show__28312 + bfacrm:ticket__show__23319
end;

procedure TfrmGPL.popFavTreePopup(Sender: TObject);
var
  SelNode, RootNode: TTreenode;
  bNotAllowed: Boolean;
begin
  bNotAllowed := False;
  SelNode := trvBookmarks.Selected;
  RootNode := GetRootNode(SelNode);
  if (SelNode = bitfarmApp.LocalListNode) or (SelNode = bitfarmApp.HistoryListNode) or
     (SelNode = bitfarmApp.GlobalListNode) then
  begin
    tbiDeleteFolder.Action := nil;
    tbiDeleteFolder.Enabled := False;
  end
  else
  begin
    tbiDeleteFolder.Enabled := True;
    if (SelNode.Data <> nil) and (TObject(SelNode.Data) is TbfaNodeInfo) and
       (TbfaNodeInfo(SelNode.Data).Typ = 1)
    then
      tbiDeleteFolder.Action := actDeleteFolder
    else if (SelNode.Data <> nil) and (TObject(SelNode.Data) is TbfaNodeInfo) and
            (bitfarmApp.User.isAdmin) and (
              (TbfaNodeInfo(SelNode.Data).Typ = 0) or
              (TbfaNodeInfo(SelNode.Data).Typ = -1)
            )
    then
      tbiDeleteFolder.Action := actDeleteGlobal
    else if (SelNode.Data <> nil) and (TObject(SelNode.Data) is TbfaSearch) then
      tbiDeleteFolder.Action := actDeleteFavorite;
  end;

  actDeleteFavorite.Enabled := (SelNode.Data <> nil);

  if (SelNode = bitfarmApp.LocalListNode) or (GetRootNode(SelNode) = bitfarmApp.LocalListNode) then
    tbiCreateBookmark.Enabled := True
  else if ((GetRootNode(SelNode) = bitfarmApp.GlobalListNode) and
           (SelNode <> bitfarmApp.GlobalListNode)) and bitfarmApp.User.isAdmin
  then
    tbiCreateBookmark.Enabled := True
  else
    tbiCreateBookmark.Enabled := False;

  if (SelNode = bitfarmApp.GlobalListNode) and (bitfarmApp.User.isAdmin) then
  begin
    tbiAddFolder.Action := actAddGlobal;
    actAddGlobal.Enabled := True;
    tbiAddFolder.Enabled := True;
    tbiDeleteFolder.Enabled := False;
  end
  else
    tbiAddFolder.Action := actAddFolder;

    tbiReplaceBookmark.Visible := False;
  tbiChangeBookmark.Visible := (TObject(SelNode.Data) is TbfaSearch) and
  (((GetRootNode(SelNode) = bitfarmApp.GlobalListNode) and (bitfarmApp.User.isAdmin)) or
   (GetRootNode(SelNode) = bitfarmApp.LocalListNode));

     tbiCopyBookmark.Visible := (TObject(SelNode.Data) is TbfaSearch) and
  (((GetRootNode(SelNode) = bitfarmApp.GlobalListNode) and (bitfarmApp.User.isAdmin)) or
   (GetRootNode(SelNode) = bitfarmApp.LocalListNode));

  tbiDeleteFolder.Visible := tbiDeleteFolder.Enabled;
  tbiCreateBookmark.Visible := tbiCreateBookmark.Enabled;

  bNotAllowed := (((RootNode = bitfarmApp.GlobalListNode) and not bitfarmApp.User.isAdmin) or (RootNode = bitfarmApp.HistoryListNode));

  if bNotAllowed then
  begin
    trvBookmarks.ClearSelection(True);
    trvBookmarks.Select(SelNode);
    Abort;
  end;
end;

procedure TfrmGPL.popFilterBarPopup(Sender: TObject);
begin
  tbiGroupByBox.Checked := grdResultlistDevExView.OptionsView.GroupByBox;
  tbiFooterBox.Checked := grdResultlistDevExView.OptionsView.Footer;
end;

procedure TfrmGPL.popInResubOnPopup(Sender: TObject);
var
  i : Integer;
begin
  for i := 0 to Self.popInResub.Items.Count - 1 do
  begin
    if Self.popInResub.Items[i].Tag <> 0 then
    begin
      Self.popInResub.Items[i].Enabled :=
        (bitfarmApp.CurrentContainer.Count = 1) and (bitfarmApp.CurrentView <> tvkResub);
      Break;
    end;
  end;
end;

procedure TfrmGPL.popMainMenuPopup(Sender: TObject);
begin
  if bitfarmApp.CurrentView = tvkAdministrator then
    Abort;
end;

procedure TfrmGPL.popTreeViewPopup(Sender: TObject);
var
  licount, licount1, i, j : integer;
  lmi_newItem: TSpTBXItem;
  lmi_newSub: TSpTBXSubmenuItem;
  lmi_seperator: TTBSeparatorItem;
  ltn_local: TTreeNode;
  lp_clmouse, lp_scmouse: TPoint;
  tv: TbfaTreeView;
  obj: TBfaSearch;
  enableEditBookmarks: Boolean;

  function checkIfFolderHasBookmark(TreeNodeToCheck : TTreeNode; isGlobal : Boolean) : Boolean;
  var
    i: integer;
  begin
    Result := False;
    try
      for i := 0 to (TreeNodeToCheck.Count - 1) do
      begin
         //wenn Lesezeichen
         if (TObject(TreeNodeToCheck[i].Data) is TbfaSearch) then
         // dann check ob Archiv richtig
           if (checkBookmark(ltn_local, TbfaSearch(TreeNodeToCheck[i].Data), isGlobal)) then
             Result := True;
      end;
    except
      Result := False;
      bitfarmLog.Write(llNormal, ltException, 'checkIfFolderHasBookmark', Classname);
    end;
  end;

  procedure MenuItemData(TreeNode : TTreeNode; MenuItem : TSpTBXItem; lmi_caption : string);
  begin
    try
      MenuItem.Images := bfaIcons.ilMainMenu;
      MenuItem.Caption := lmi_caption;
      MenuItem.Hint := lmi_caption;
      MenuItem.Tag := Integer(TbfaSearch(TreeNode.Data));
      MenuItem.ImageIndex := TreeNode.SelectedIndex;
      MenuItem.OnClick := PopupClick;
    except
      bitfarmLog.Write(llNormal, ltException, 'MenuItemData', Classname);
    end;
  end;

  procedure SubMenuItemData(SubMenuItem : TSpTBXSubmenuItem; lmi_caption : string);
  begin
    try
      SubMenuItem.Images := bfaIcons.ilMainMenu;
      SubMenuItem.Caption := lmi_caption;
      SubMenuItem.Hint := lmi_caption;
      SubMenuItem.ImageIndex := Integer(icoidx_bookmark_folder);
      SubMenuItem.OnClick := PopupClick;
    except
      bitfarmLog.Write(llNormal, ltException, 'SubMenuItemData', Classname);
    end;
  end;

  procedure Add(TreeElement : TTreeNode; MenuItem : TSpTBXSubmenuItem; isGlobal : Boolean );
  var
    i : integer;
    lmi_newItem2 : TSpTBXItem;
    lmi_newSub2 : TSpTBXSubmenuItem;
  begin
    for i := 0 to (TreeElement.Count - 1) do
    begin
      if TreeElement.Item[i].HasChildren then
      //wir haben einen Ordner vor uns
      //prfen ob Ordner Lesezeichen mit Berechtigung enthlt
      begin
        if (checkIfFolderHasBookmark(TreeElement.Item[i], isGlobal)) then
        begin
          lmi_newSub2 := TSpTBXSubmenuItem.Create(popTreeView);
          SubMenuItemData(lmi_newSub2, TreeElement.Item[i].Text);
          Add(TreeElement.Item[i], lmi_newSub2, isGlobal);
          if (lmi_newSub2.Count > 0) then
            MenuItem.Add(lmi_newSub2);
        end;
      end
      else
        //kein Ordner
      begin
        //prfen ob Lesezeichen vorliegt
        if (TObject(TreeElement[i].Data) is TbfaSearch) then
          // dann check ob Archiv richtig
          if (checkBookmark(ltn_local, TbfaSearch(TreeElement[i].Data), isGlobal)) then
          begin
            lmi_newItem2 := TSpTBXItem.Create(popTreeView);
//            ganzes TreeElement bergeben - dann hat man auch den IconIndex !
            MenuItemData(TreeElement[i], lmi_newItem2, TreeElement.Item[i].Text);
            MenuItem.Add(lmi_newItem2);
            if bitfarmApp.User.isAdmin or not isGlobal then
              enableEditBookmarks := True;
          end;
      end;
    end;
  end;

begin
  bitfarmApp.Log.DebugBegin(llDebug, 'popTreeViewPopup', ClassName);
  try
    try
      // get arcid
      // search entries
      // add entries
      if FViewerTreeview = popTreeView.PopupComponent then
        tv := FViewerTreeview
      else if FAdminTreeview = popTreeView.PopupComponent then
        tv := FAdminTreeview
      else
        tv := FImporterTreeview;

      licount1 := 0;
      ltn_local := tv.Selected;
      enableEditBookmarks := False;
      while licount1 < popTreeView.Items.Count do
      begin
        if (popTreeView.Items.Items[licount1].Tag > -1) then
          popTreeView.Items.Delete(licount1)
        else
          licount1 := licount1 + 1;
      end;

      if tv = TbfaTreeview(FViewerTreeview) then
      begin
        bitfarmApp.Log.Debug(llDebug, 'popTreeViewPopup - FViewerTreeview', ClassName);
        i := 0;
        while (i <= trvBookmarks.Items.Count - 1) do
        begin
          if (trvBookmarks.Items[i].Count > 0) then
          // es sind Elemente vorhanden
          // Globales Lesezeichen von Lokalem Lesezeichen und Ordner unterscheiden
          begin
            if (trvBookmarks.Items[i] = bitfarmApp.HistoryListNode) then
              Break;

            if (trvBookmarks.Items[i] = bitfarmApp.GlobalListNode) then
            begin
              try
                bitfarmApp.Log.Debug(llDebug, 'popTreeViewPopup - GlobalListNode', ClassName);
                for licount := 0 to trvBookmarks.Items[i].Count - 1 do
                begin
                  if trvBookmarks.Items[i][licount].Data <> nil then
                  begin
                    if (TObject(trvBookmarks.Items[i][licount].Data) is TbfaSearch) then
                    begin
                      if (checkBookmark(ltn_local, trvBookmarks.Items[i][licount].Data, True)) then
                      begin
                        lmi_newItem := TSpTBXItem.Create(popTreeView);
                        MenuItemData(trvBookmarks.Items[i][licount], lmi_newItem,
                          trvBookmarks.Items[i][licount].Text);
                        bitfarmApp.Log.Debug(llDebug, 'popTreeViewPopup - Add1: ' + trvBookmarks.Items[i][licount].Text, ClassName);
                        popTreeView.Items.Add(lmi_newItem);
                        if bitfarmApp.User.isAdmin then
                          enableEditBookmarks := True;
                      end
                      //es ist kein geeignetes Lesezeichen
                      //es ist ein Ordner
                      else if (trvBookmarks.Items[i][licount].HasChildren) then
                      begin
                        lmi_newSub := TSpTBXSubmenuItem.Create(popTreeView);
                        SubMenuItemData(lmi_newSub, trvBookmarks.Items[i][licount].Text);
                        bitfarmApp.Log.Debug(llDebug, 'popTreeViewPopup - Add2: ' + trvBookmarks.Items[i][licount].Text, ClassName);
                        Add(trvBookmarks.Items[i][licount], lmi_newSub, True);
                        if(lmi_newSub.Count > 0) then
                          popTreeView.Items.Add(lmi_newSub);
                      end;
                    end;

                    if (TObject(trvBookmarks.Items[i][licount].Data) is TbfaNodeInfo) and
                       (trvBookmarks.Items[i][licount].Count > 0) then
                    begin
                      for j := 0 to trvBookmarks.Items[i][licount].Count - 1 do
                      begin
                        //wenn es ein Lesezeichen ist - hinzufgen
                        if ((trvBookmarks.Items[i][licount][j].Data <> nil) and
                            ((TObject(trvBookmarks.Items[i][licount][j].Data) is TbfaSearch)) and
                            (checkBookmark(ltn_local, trvBookmarks.Items[i][licount][j].Data, True))) then
                        begin
                          lmi_newItem := TSpTBXItem.Create(popTreeView);
                          MenuItemData(trvBookmarks.Items[i][licount][j], lmi_newItem,
                            trvBookmarks.Items[i][licount][j].Text);
                          bitfarmApp.Log.Debug(llDebug, 'popTreeViewPopup - Add3: ' + trvBookmarks.Items[i][licount][j].Text, ClassName);
                          popTreeView.Items.Add(lmi_newItem);
                          enableEditBookmarks := True;
                        end
                        //es ist kein geeignetes Lesezeichen
                        //es ist ein Ordner
                        else if (trvBookmarks.Items[i][licount][j].HasChildren) then
                        begin
                          lmi_newSub := TSpTBXSubmenuItem.Create(popTreeView);
                          SubMenuItemData(lmi_newSub, trvBookmarks.Items[i][licount][j].Text);
                          bitfarmApp.Log.Debug(llDebug, 'popTreeViewPopup - Add4: ' + trvBookmarks.Items[i][licount][j].Text, ClassName);
                          Add(trvBookmarks.Items[i][licount][j], lmi_newSub, True);
                          if(lmi_newSub.Count > 0) then
                            popTreeView.Items.Add(lmi_newSub);
                        end;
                      end;
                    end;
                  end
                  //es ist kein geeignetes Lesezeichen
                  //es ist ein Ordner
                  else if (trvBookmarks.Items[i][licount].HasChildren) then
                  begin
                    lmi_newSub := TSpTBXSubmenuItem.Create(popTreeView);
                    SubMenuItemData(lmi_newSub, trvBookmarks.Items[i][licount].Text);
                    bitfarmApp.Log.Debug(llDebug, 'popTreeViewPopup - Add5: ' + trvBookmarks.Items[i][licount].Text, ClassName);
                    Add(trvBookmarks.Items[i][licount], lmi_newSub, True);
                    if(lmi_newSub.Count > 0) then
                      popTreeView.Items.Add(lmi_newSub);
                  end;
                end;
              except
                bitfarmApp.Log.Write(llNormal, ltException, 'popTreeViewPopup - bitfarmApp.GlobalListNode', ClassName);
              end;
            end

            else if (trvBookmarks.Items[i] = bitfarmApp.LocalListNode) then
            //lokales Lesezeichen
            begin
              try
                bitfarmApp.Log.Debug(llDebug, 'popTreeViewPopup - LocalListNode', ClassName);
                for licount := 0 to trvBookmarks.Items[i].Count - 1 do
                begin
                  if ((trvBookmarks.Items[i][licount].Data <> nil) and
                      (TObject(trvBookmarks.Items[i][licount].Data) is TbfaSearch) and
                      (checkBookmark(ltn_local, trvBookmarks.Items[i][licount].Data, False))) then
                  begin
                    lmi_newItem := TSpTBXItem.Create(popTreeView);
                    MenuItemData(trvBookmarks.Items[i][licount], lmi_newItem,
                      trvBookmarks.Items[i][licount].Text);
                    popTreeView.Items.Add(lmi_newItem);
                    enableEditBookmarks := True;
                  end
                  //es ist kein geeignetes Lesezeichen
                  //es ist ein Ordner
                  else if (trvBookmarks.Items[i][licount].HasChildren) then
                  begin
                    lmi_newSub := TSpTBXSubmenuItem.Create(popTreeView);
                    SubMenuItemData(lmi_newSub, trvBookmarks.Items[i][licount].Text);
                    Add(trvBookmarks.Items[i][licount], lmi_newSub, False);
                    if(lmi_newSub.Count > 0) then
                      popTreeView.Items.Add(lmi_newSub);
                  end;
                end;
              except
                bitfarmApp.Log.Write(llNormal, ltException, 'popTreeViewPopup - bitfarmApp.LocalListNode', ClassName);
              end;
            end;
          end;
          inc(i);
        end;
        lmi_seperator := TTBSeparatorItem.Create(popTreeView);
        popTreeView.Items.Add(lmi_seperator);

        lmi_newItem := TSpTBXItem.Create(popTreeView);
        lmi_newItem.Caption := _('Lesezeichen bearbeiten');
        lmi_newItem.Enabled := enableEditBookmarks;
        lmi_newItem.Images := bfaIconsDM.bfaIcons.ilMainMenu;
        lmi_newItem.ImageIndex := Integer(icoidx_bookmark_edit);
        lmi_newItem.OnClick := actChangeBookmarkExecute;
        popTreeView.Items.Add(lmi_newItem);
      end
      else if (tv = TbfaTreeView(FAdminTreeview)) and (fraAdmin <> nil) then
      begin
        bitfarmApp.Log.Debug(llDebug, 'popTreeViewPopup - FAdminTreeview', ClassName);

        lmi_seperator := TTBSeparatorItem.Create(popTreeView);
        popTreeView.Items.Add(lmi_seperator);

        lmi_newItem := TSpTBXItem.Create(popTreeView);
        lmi_newItem.Caption := _('Objekte des ausgewhlten Archives kopieren');
        lmi_newItem.Enabled := bitfarmApp.AdminEditMode;
        lmi_newItem.Images := bfaIconsDM.bfaIcons.ilPreview;
        lmi_newItem.ImageIndex := Integer(copy_objects);
        lmi_newItem.OnClick := fraAdmin.CopyArchiveObjects;
        popTreeView.Items.Add(lmi_newItem);

        lmi_seperator := TTBSeparatorItem.Create(popTreeView);
        popTreeView.Items.Add(lmi_seperator);

        lmi_newItem := TSpTBXItem.Create(popTreeView);
        lmi_newItem.Caption := _('Kopierte Rechte einfgen');
        lmi_newItem.Enabled :=
          bitfarmApp.AdminEditMode and (fraAdmin.ArcRightsToCopy <> nil) and
          ((FAdminTreeview.Selected.Data <> nil) and
          (TbfaInt64(FAdminTreeview.Selected.Data^).Value <> fraAdmin.ArcRightsToCopy.ID));
        lmi_newItem.Images := bfaIconsDM.bfaIcons.ilPreview;
        lmi_newItem.ImageIndex := Integer(clipboard_rights);
        lmi_newItem.OnClick := fraAdmin.PasteArchiveRights;
        popTreeView.Items.Add(lmi_newItem);

        lmi_newItem := TSpTBXItem.Create(popTreeView);
        lmi_newItem.Caption := _('Kopierte Zusatzfelder einfgen');
        lmi_newItem.Enabled :=
          bitfarmApp.AdminEditMode and (fraAdmin.ArcRightsToCopy <> nil) and
          ((FAdminTreeview.Selected.Data <> nil) and
          (TbfaInt64(FAdminTreeview.Selected.Data^).Value <> fraAdmin.ArcRightsToCopy.ID));
        lmi_newItem.Images := bfaIconsDM.bfaIcons.ilPreview;
        lmi_newItem.ImageIndex := Integer(clipboard_fields);
        lmi_newItem.OnClick := fraAdmin.PasteAddfields;
        popTreeView.Items.Add(lmi_newItem);

        lmi_newItem := TSpTBXItem.Create(popTreeView);
        lmi_newItem.Caption := _('Kopierte Statusfelder einfgen');
        lmi_newItem.Enabled :=
          bitfarmApp.AdminEditMode and (fraAdmin.ArcRightsToCopy <> nil) and
          ((FAdminTreeview.Selected.Data <> nil) and
          (TbfaInt64(FAdminTreeview.Selected.Data^).Value <> fraAdmin.ArcRightsToCopy.ID));
        lmi_newItem.Images := bfaIconsDM.bfaIcons.ilPreview;
        lmi_newItem.ImageIndex := Integer(clipboard_status_field);
        lmi_newItem.OnClick := fraAdmin.PasteStateFields;
        popTreeView.Items.Add(lmi_newItem);

        lmi_newItem := TSpTBXItem.Create(popTreeView);
        lmi_newItem.Caption := _('Kopierte Objekte einfgen');
        lmi_newItem.Enabled :=
          bitfarmApp.AdminEditMode and (fraAdmin.ArcRightsToCopy <> nil) and
          ((FAdminTreeview.Selected.Data <> nil) and
          (TbfaInt64(FAdminTreeview.Selected.Data^).Value <> fraAdmin.ArcRightsToCopy.ID));
        lmi_newItem.Images := bfaIconsDM.bfaIcons.ilPreview;
        lmi_newItem.ImageIndex := Integer(clipboard_objects);
        lmi_newItem.OnClick := fraAdmin.PasteAllObjects;
        popTreeView.Items.Add(lmi_newItem);
      end;
    except
      bitfarmApp.Log.Write(llNormal, ltException, 'popTreeViewPopup', ClassName);
    end;
  finally
    bitfarmApp.Log.DebugEnd(llDebug, 'popTreeViewPopup', ClassName);
  end;
end;

procedure TfrmGPL.PopupClick(Sender: TObject);
var
  UserAction: PUserAction;
  SObj: TbfaSearch;
begin
  try
    try
      if (Sender is TSpTBXItem) and not (Sender is TSpTBXSubmenuItem) then //24.04.2019 wenn ein Ordner ist, dann es ist kein Lezezeichen Ticket 455
      begin
        with (Sender as TSpTBXItem) do
        begin
          UserAction := bitfarmApp.CreateUserAction;
          UserAction^.ActionName := 'actBookmarkSearch';
          SObj := TbfaSearch.Create;
          SObj.Clone(TbfaSearch(Tag));
          UserAction^.Objects.Add(sobj);
          bitfarmApp.MainThread.Add(UserAction);
        end;
      end;
    except
      bitfarmApp.Log.Write(llNormal, ltException, 'PopupClick', ClassName);
    end;
  finally
  end;
end;

procedure TfrmGPL.ppmEmailClick(Sender: TObject);
begin
  bitfarmApp.Log.DebugBegin(llDebug, 'ppmEmailClick', Classname);
  try
    try
      bfaTlbStandard1.tlbStandardSubmenuItemEmail.Click;
    except
      bitfarmApp.Log.Write(llNormal, ltException, 'ppmEmailClick', ClassName);
    end;
  finally
    bitfarmApp.Log.DebugEnd(llDebug, 'ppmEmailClick', Classname);
  end;
end;

procedure TfrmGPL.ppmPrintClick(Sender: TObject);
begin
  bitfarmApp.Log.DebugBegin(llDebug, 'ppmPrintClick', Classname);
  try
    try
      bfaTlbStandard1.tlbStandardSubmenuItemPrint.Click;
    except
      bitfarmApp.Log.Write(llNormal, ltException, 'ppmPrintClick', ClassName);
    end;
  finally
    bitfarmApp.Log.DebugEnd(llDebug, 'ppmPrintClick', Classname);
  end;
end;

procedure TfrmGPL.ppmSaveClick(Sender: TObject);
begin
  bitfarmApp.Log.DebugBegin(llDebug, 'ppmSaveClick', Classname);
  try
    try
      bfaTlbStandard1.tlbStandardSubmenuItemSave.Click;
    except
      bitfarmApp.Log.Write(llNormal, ltException, 'ppmSaveClick', ClassName);
    end;
  finally
    bitfarmApp.Log.DebugEnd(llDebug, 'ppmSaveClick', Classname);
  end;
end;

procedure TfrmGPL.ReadViewerIni;
var
  inifile: TIniFile;
  tp: TPoint;
  lastid: Integer;
  i: Integer;
  caption, inistr : string;
  sle : TSpTBXSkinsListEntry;
begin
  bitfarmLog.DebugBegin(llDebug, 'ReadViewerIni', ClassName);
  try
    try
      if FileExists(ExtractFilePath(Application.ExeName) + 'Viewer.ini') then
        inifile := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'Viewer.ini')
      else
        inifile := TIniFile.Create(BD.EnvAppdataPd + 'bitfarm-archiv\Viewer.ini');
      try
        if inifile.SectionExists('General') then
        begin
          if inifile.ValueExists('General', 'LocalSave') then
          begin
            case inifile.ReadInteger('General', 'LocalSave', 1) of
              0:
              begin
                bfaTlbStandard1.tlbStandardSubmenuItemSave.Action := actLocalSaveOriginal;
                frmMainForm.actLocalSavePDF.Tag := 0;
                frmMainForm.actLocalSaveTIF.Tag := 0;
                frmMainForm.actLocalSaveOriginal.Tag := 1;
                frmMainForm.actLocalSavePreview.Tag := 0;
                frmMainForm.actLocalSaveLink.Tag := 0;
              end;
              1:
              begin
                bfaTlbStandard1.tlbStandardSubmenuItemSave.Action := actLocalSavePDF;
                frmMainForm.actLocalSavePDF.Tag := 1;
                frmMainForm.actLocalSaveTIF.Tag := 0;
                frmMainForm.actLocalSaveOriginal.Tag := 0;
                frmMainForm.actLocalSavePreview.Tag := 0;
                frmMainForm.actLocalSaveLink.Tag := 0;
              end;
              2:
              begin
                bfaTlbStandard1.tlbStandardSubmenuItemSave.Action := actLocalSaveTIF;
                frmMainForm.actLocalSavePDF.Tag := 0;
                frmMainForm.actLocalSaveTIF.Tag := 1;
                frmMainForm.actLocalSaveOriginal.Tag := 0;
                frmMainForm.actLocalSavePreview.Tag := 0;
                frmMainForm.actLocalSaveLink.Tag := 0;
              end;
              3:
              begin
                bfaTlbStandard1.tlbStandardSubmenuItemSave.Action := actLocalSaveLink;
                frmMainForm.actLocalSavePDF.Tag := 0;
                frmMainForm.actLocalSaveTIF.Tag := 0;
                frmMainForm.actLocalSaveOriginal.Tag := 0;
                frmMainForm.actLocalSavePreview.Tag := 0;
                frmMainForm.actLocalSaveLink.Tag := 1;
              end;
              4:
              begin
                bfaTlbStandard1.tlbStandardSubmenuItemSave.Action := actLocalSavePreview;
                frmMainForm.actLocalSavePDF.Tag := 0;
                frmMainForm.actLocalSaveTIF.Tag := 0;
                frmMainForm.actLocalSaveOriginal.Tag := 0;
                frmMainForm.actLocalSavePreview.Tag := 1;
                frmMainForm.actLocalSaveLink.Tag := 0;
              end;
            end;
            frmMainForm.mnuLocalSave.Action := bfaTlbStandard1.tlbStandardSubmenuItemSave.Action;
          end;
          if inifile.ValueExists('General', 'Email') then
          begin
            case inifile.ReadInteger('General', 'Email', 0) of
              0:
              begin
                bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action := actEmailPDFAttachment;
                actEmailPDFAttachment.Tag := 1;
                actEmailTIFAttachment.Tag := 0;
                actEmailOriginal.Tag := 0;
                actEmailLink.Tag := 0;
                actEmailPreview.Tag := 0;
              end;
              1:
              begin
                bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action := actEmailTIFAttachment;
                actEmailPDFAttachment.Tag := 0;
                actEmailTIFAttachment.Tag := 1;
                actEmailOriginal.Tag := 0;
                actEmailLink.Tag := 0;
                actEmailPreview.Tag := 0;
              end;
              2:
              begin
                bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action := actEmailOriginal;
                actEmailPDFAttachment.Tag := 0;
                actEmailTIFAttachment.Tag := 0;
                actEmailOriginal.Tag := 1;
                actEmailLink.Tag := 0;
                actEmailPreview.Tag := 0;
              end;
              3:
              begin
                bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action := actEmailLink;
                actEmailPDFAttachment.Tag := 0;
                actEmailTIFAttachment.Tag := 0;
                actEmailOriginal.Tag := 0;
                actEmailLink.Tag := 1;
                actEmailPreview.Tag := 0;
              end;
              4:
              begin
                bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action := actEmailPreview;
                actEmailPDFAttachment.Tag := 0;
                actEmailTIFAttachment.Tag := 0;
                actEmailOriginal.Tag := 0;
                actEmailLink.Tag := 0;
                actEmailPreview.Tag := 1;
              end;
            end;
            frmMainForm.mnuEmail.Action := bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action;
          end;
          if inifile.ValueExists('General', 'Print') then
          begin
            case inifile.ReadInteger('General', 'Print', 0) of
              0:
                bfaTlbStandard1.tlbStandardSubmenuItemPrint.Action := actPrintStandard;
              1:
                bfaTlbStandard1.tlbStandardSubmenuItemPrint.Action := actPrintSelect;
              2:
                bfaTlbStandard1.tlbStandardSubmenuItemPrint.Action := actPrintPreview;
            end;
            frmMainForm.mnuPrint.Action := bfaTlbStandard1.tlbStandardSubmenuItemPrint.Action;
          end;
          if inifile.ValueExists('General', 'Copy') then
          begin
            case inifile.ReadInteger('General', 'Copy', 0) of
              0:
              begin
                bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action := actCopyDocToClipboard;
                frmMainForm.actCopyDocToClipboard.Tag := 1;
                frmMainForm.actCopyOriginalDocToClipboard.Tag := 0;
                frmMainForm.actCopyPageToClipboard.Tag := 0;
                frmMainForm.actCopyDocLinkToClipboard.Tag := 0;
              end;
              1:
              begin
                bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action := actCopyOriginalDocToClipboard;
                frmMainForm.actCopyDocToClipboard.Tag := 0;
                frmMainForm.actCopyOriginalDocToClipboard.Tag := 1;
                frmMainForm.actCopyPageToClipboard.Tag := 0;
                frmMainForm.actCopyDocLinkToClipboard.Tag := 0;
              end;
              2:
              begin
                bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action := actCopyPageToClipboard;
                frmMainForm.actCopyDocToClipboard.Tag := 0;
                frmMainForm.actCopyOriginalDocToClipboard.Tag := 0;
                frmMainForm.actCopyPageToClipboard.Tag := 1;
                frmMainForm.actCopyDocLinkToClipboard.Tag := 0;
              end;
              3:
              begin
                bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action := actCopyDocLinkToClipboard;
                frmMainForm.actCopyDocToClipboard.Tag := 0;
                frmMainForm.actCopyOriginalDocToClipboard.Tag := 0;
                frmMainForm.actCopyPageToClipboard.Tag := 0;
                frmMainForm.actCopyDocLinkToClipboard.Tag := 1;
              end;
            end;
            frmMainForm.mnuCopyToClipboard.Action := bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action;
          end;

          bitfarmApp.currentEmptyDoc := inifile.ReadString('General', 'EmptyDoc', 'Text');

          if inifile.ValueExists('General', 'SearchOption') then
          begin
            fSearchOption := inifile.ReadInteger('General', 'SearchOption', 0);
            SetSearchOption(fSearchOption);
          end;

          bitfarmApp.MViewThumbWidth := inifile.ReadInteger('General', 'MViewThumbWidth', MINTHUMBWIDTH);
          bitfarmApp.MViewThumbHeight := inifile.ReadInteger('General', 'MViewThumbHeight', MINTHUMBHEIGHT);

          if inifile.ValueExists('General', 'ShowAllReposAddfields') then
            bitfarmApp.ShowAllReposAddfields := inifile.ReadBool('General', 'ShowAllReposAddfields', False);

          if inifile.ValueExists('General', 'OrderFieldsByName') then
            bitfarmApp.OrderFieldsByName := inifile.ReadBool('General', 'OrderFieldsByName', False);

          if (bitfarmApp.ViewerOptions.EditorOptions.AutoZoom in [4,6]) then
          begin
            if inifile.ValueExists('General', 'Zoom') then
            begin
              case inifile.ReadInteger('General', 'Zoom', 2) of
                0:
                  bfaTlbPreview1.sbmAutozoom.Action := actZoom100;
                1:
                  bfaTlbPreview1.sbmAutozoom.Action := actZoomPage;
                2:
                  bfaTlbPreview1.sbmAutozoom.Action := actZoomWidth;
                3:
                  bfaTlbPreview1.sbmAutozoom.Action := actZoomHeight;
                4:
                  bfaTlbPreview1.sbmAutozoom.Action := actZoomSelect;
                5:
                  begin
                    bfaTlbPreview1.sbmAutozoom.Action := actZoomOff;
                    if inifile.ValueExists('General', 'LastZoomLevel') then
                    begin
                      try
                        var LastZoomLevel: Double;
                        LastZoomLevel := inifile.ReadFloat('General', 'LastZoomLevel', 100);
                        bfaTlbPreview1.cbxZoom.Text := FormatFloat('0.00', LastZoomLevel) + ' %';
                        bitfarmApp.PreviewContainer.ViewerItem.Preview.bfaTlbPreview.cbxZoom.OnChange(bfaTlbPreview1.cbxZoom);
                      except
                        bitfarmApp.Log.Write(llNormal, ltException, 'LastZoomLevel', ClassName);
                      end;
                    end;
                  end
              else
                bfaTlbPreview1.sbmAutozoom.Action := actZoomPage;
              end;
            end else
              bfaTlbPreview1.sbmAutozoom.Action := actZoomPage;
          end else
          begin
            case bitfarmApp.ViewerOptions.EditorOptions.AutoZoom of
              0:
                bfaTlbPreview1.sbmAutozoom.Action := actZoom100;
              1:
                bfaTlbPreview1.sbmAutozoom.Action := actZoomPage;
              2:
                bfaTlbPreview1.sbmAutozoom.Action := actZoomWidth;
              3:
                bfaTlbPreview1.sbmAutozoom.Action := actZoomSelect;
              5:
                bfaTlbPreview1.sbmAutozoom.Action := actZoomHeight;
            else
              bfaTlbPreview1.sbmAutozoom.Action := actZoomPage;
            end;
          end;

          for I := 0 to bitfarmApp.PreviewContainer.Containers.Count - 1 do
          begin
            bitfarmApp.PreviewContainer.Containers[I].Preview.bfaTlbPreview.sbmAutozoom.Action := bfaTlbPreview1.sbmAutozoom.Action;
          end;

          if inifile.ValueExists('General', 'UndockDocument') then
          begin
            case inifile.ReadInteger('General', 'UndockDocument', 0) of
              0:
                actUndockDefault := actUndockInNewTab;
              1:
                actUndockDefault := actUndockInNewWindow;
            else
              actUndockDefault := actUndockInNewTab;
            end;
          end else
            actUndockDefault := actUndockInNewTab;

          bitfarmApp.PreviewContainer.ViewerItem.Preview.bfaTlbPreview.sbmAutozoom.Action :=
            bfaTlbPreview1.sbmAutozoom.Action;

          //LastActivePreview und LastActiveTab muss erst geladen werden!
          if (not FDefaultLayout) and (inifile.ValueExists('General', 'LastActivePreview')) then
          begin
            FLastActivePreview := inifile.ReadInteger('General', 'LastActivePreview', 0);
            FLastActiveTab := inifile.ReadInteger('General', 'LastActiveTab', 0);
          end else
          begin
            FLastActivePreview := 0;
            FLastActiveTab := 0;
          end;

          bitfarmApp.ViewerOptions.GeneralOptions.StartingArea := inifile.ReadInteger('General', sSysStartingArea, 0);
          // 0 = letzte Einstellung; deswegen -1, damit Wert dem FLastActivePreview enstpricht
          if (not fAppStarted) and (bitfarmApp.ViewerOptions.GeneralOptions.StartingArea <> 0) then
            FLastActivePreview := bitfarmApp.ViewerOptions.GeneralOptions.StartingArea - 1;

          bitfarmApp.ViewerOptions.GeneralOptions.NegativeCurrency := inifile.ReadBool('General', sSysNegativeCurrency, True);

          if inifile.ValueExists('Preview', 'Floating') then
            pnlPreview.Floating := inifile.ReadBool('Preview', 'Floating', False);
          if inifile.ValueExists('Preview', 'Floating_x') then
            tp.X := inifile.ReadInteger('Preview', 'Floating_x', 0);
          if inifile.ValueExists('Preview', 'Floating_y') then
            tp.Y := inifile.ReadInteger('Preview', 'Floating_y', 0);

          if pnlPreview.Floating then
            pnlPreview.FloatingPosition := tp;

          bitfarmApp.PreviewContainer.ViewerItem.Preview.FulltextView.chkWholeWords.Checked :=
            inifile.ReadBool('FulltextView', 'wholeword', False);
          bitfarmApp.PreviewContainer.ViewerItem.Preview.FulltextView.chkCircle.Checked :=
            inifile.ReadBool('FulltextView', 'circlesearch', False);
          bitfarmApp.FullTextZoom := inifile.ReadInteger('FulltextView', 'FullTextZoom', 100);

          if inifile.ReadString('FulltextView', 'SearchToolbarLastDock', bitfarmApp.PreviewContainer.ViewerItem.Preview.SearchbarToolbar.DefaultDock.Name) = 'previewDockTop' then
            bitfarmApp.PreviewContainer.ViewerItem.Preview.SearchbarToolbar.CurrentDock := bitfarmApp.PreviewContainer.ViewerItem.Preview.previewDockTop
          else
            bitfarmApp.PreviewContainer.ViewerItem.Preview.SearchbarToolbar.CurrentDock := bitfarmApp.PreviewContainer.ViewerItem.Preview.previewDockBottom;
          bitfarmApp.PreviewContainer.ViewerItem.Preview.SearchbarToolbar.Visible := inifile.ReadBool('FulltextView', 'displaySearchToolbar', false);
          bitfarmApp.PreviewContainer.ViewerItem.Preview.SearchbarToolbar.DockPos := inifile.ReadInteger('FulltextView', 'SearchToolbarLastPosition', 0);
          bitfarmApp.PreviewContainer.ViewerItem.Preview.SearchbarChkAccurate.Checked := inifile.ReadBool('FulltextView', 'SearchbarChkAccurate', False);
          bitfarmApp.PreviewContainer.ViewerItem.Preview.SearchbarChkCircle.Checked := inifile.ReadBool('FulltextView', 'circlesearch', False);
          bitfarmApp.PreviewContainer.ViewerItem.Preview.SearchbarChkWholeWords.Checked := inifile.ReadBool('FulltextView', 'wholeword', False);

          //20.04.2022 Rckwrtskompatibilitt 361 -->
          var IniSection : string;
          if inifile.SectionExists(bitfarmApp.TreeViewProfile) then
            IniSection := bitfarmApp.TreeViewProfile
          else
            IniSection := sSysTreeView;
          //20.04.2022 Rckwrtskompatibilitt 361 <--

          if inifile.ValueExists(IniSection, sSysViewLastID) then
            bitfarmApp.CurrentArchive.Arcid := inifile.ReadInteger(IniSection, sSysViewLastID, -1);
          if inifile.ValueExists(IniSection, sSysImportLastID) then
            bitfarmApp.CurrentImportArchive.Arcid := inifile.ReadInteger(IniSection, sSysImportLastID, -1);

          if (inifile.ValueExists('General', 'Skin') or inifile.ValueExists('General', 'SkinName')) then
          begin
            FSelectedSkinIndex := inifile.ReadInteger('General', 'Skin', -1);
            FSelectedSkinName := inifile.ReadString('General', 'SkinName', '');
          end;
            if ((FSelectedSkinName = '') or (FSelectedSkinName = 'bitfarm-Archiv')) and
                (FileExists(ExtractFilePath(Application.ExeName) + '\Viewer-files\Skins\bitfarm-Archiv.skn')) then
            begin
              if SkinManager.SkinsList.TryGetValue('bitfarm-Archiv', sle) then
                FSelectedSkinName := 'bitfarm-Archiv'
              else
                FSelectedSkinName := '';
              FSelectedSkinIndex := -1;
            end;
        end else
        begin
          bfaTlbStandard1.tlbStandardSubmenuItemSave.Action := actLocalSavePDF;
          frmMainForm.mnuLocalSave.Action := bfaTlbStandard1.tlbStandardSubmenuItemSave.Action;
          bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action := actEmailPDFAttachment;
          frmMainForm.mnuEmail.Action := bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action;
          bfaTlbStandard1.tlbStandardSubmenuItemPrint.Action := actPrintPreview;
          frmMainForm.mnuPrint.Action := bfaTlbStandard1.tlbStandardSubmenuItemPrint.Action;
          bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action := actCopyDocToClipboard;
          frmMainForm.mnuCopyToClipboard.Action := bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action;
          actUndockDefault := actUndockInNewTab;
          if FileExists(ExtractFilePath(Application.ExeName) + '\Viewer-files\Skins\bitfarm-Archiv.skn') then
          begin
            if SkinManager.SkinsList.TryGetValue('bitfarm-Archiv', sle) then
              FSelectedSkinName := 'bitfarm-Archiv'
            else
              FSelectedSkinName := '';
            FSelectedSkinIndex := -1;
          end
          else
            FSelectedSkinIndex := -1;
        end;

        if inifile.SectionExists('Resub') then
        begin
          if inifile.ValueExists('Resub', 'TimidList') then
            bitfarmApp.TimidList.DelimitedText := inifile.ReadString('Resub', 'TimidList', '');
          if inifile.ValueExists('Resub', 'Newresubs') then
            bitfarmApp.FNewResubs := inifile.ReadInteger('Resub', 'Newresubs', 0);

          try
            if inifile.ValueExists('Resub', 'BMResub') then
              bitfarmApp.BMResub := inifile.ReadInteger('Resub', 'BMResub', 0);
            if inifile.ValueExists('Resub', 'BMDelegateResub') then
              bitfarmApp.BMDelegateResub := inifile.ReadInteger('Resub', 'BMDelegateResub', 0);
          except
          end;
        end;

        if inifile.SectionExists(sSysMarkedDocs) then
        begin
          if inifile.ValueExists(sSysMarkedDocs, bitfarmApp.MarkedDocsProfile) then
            bitfarmApp.MarkedDocsString := inifile.ReadString(sSysMarkedDocs, bitfarmApp.MarkedDocsProfile, '');
        end;

        bitfarmApp.PopupLinkList.DelimitedText := inifile.ReadString('PopupLinkList', 'PopupLinkList', '');
      finally
        inifile.Free;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'ReadViewerIni', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ReadViewerIni', ClassName);
  end;
end;

procedure TfrmGPL.SetCollectionsCaptions;
begin
    // jetzt noch die Beschriftungen anpassen
    if bitfarmApp.CollectionContainer.Count = 0 then
    begin
      actCollectDocs.Caption := _('Dokumente vormerken');
      actCancelCollection.Enabled := False;
      mnuSaveCollection.Enabled := False;
      mnuEmailCollection.Enabled := False;
    end else begin
      actCollectDocs.Caption := _('Dokumente vormerken') + ' (' + IntToStr(bitfarmApp.CollectionContainer.Count) + ')';
      actCancelCollection.Enabled := True;
      mnuSaveCollection.Enabled := True;
      mnuEmailCollection.Enabled := True;
    end;
    if bitfarmApp.CollectionContainer.Count <= 1 then
    begin
      actSaveCollectionPDF.Caption := _('Gemerktes Dokument als PDF speichern');
      actSaveCollectionSinglePDF.Caption := _('Gemerktes Dokument als ein PDF speichern');
      actSaveCollectionTIF.Caption := _('Gemerktes Dokument als TIF speichern');
      actSaveCollectionOriginal.Caption := _('Gemerktes Dokument als Original speichern');

      actEmailCollectionPDF.Caption := _('Gemerktes Dokument als PDF versenden');
      actEmailCollectionSinglePDF.Caption := _('Gemerktes Dokument als ein PDF versenden');
      actEmailCollectionTIF.Caption := _('Gemerktes Dokument als TIF versenden');
      actEmailCollectionOriginal.Caption := _('Gemerktes Dokument als Original versenden');
    end else begin
      actSaveCollectionPDF.Caption := _('Gemerkte Dokumente als PDF speichern');
      actSaveCollectionSinglePDF.Caption := _('Gemerkte Dokumente als ein PDF speichern');
      actSaveCollectionTIF.Caption := _('Gemerkte Dokumente als TIF speichern');
      actSaveCollectionOriginal.Caption := _('Gemerkte Dokumente als Original speichern');

      actEmailCollectionPDF.Caption := _('Gemerkte Dokumente als PDF versenden');
      actEmailCollectionSinglePDF.Caption := _('Gemerkte Dokumente als ein PDF versenden');
      actEmailCollectionTIF.Caption := _('Gemerkte Dokumente als TIF versenden');
      actEmailCollectionOriginal.Caption := _('Gemerkte Dokumente als Original versenden');
    end;
//    mnuCollectDocs.Images := bfaIcons.ilMainMenu;
//    mnuCancelCollection.Images := bfaIcons.ilMainMenu;
//    mnuSaveCollection.Images := bfaIcons.ilMainMenu;
//    mnuEmailCollection.Images := bfaIcons.ilMainMenu;
//    mnuCollectDocs.ImageIndex := 260;
//    mnuCancelCollection.ImageIndex := 263;
//    mnuSaveCollection.ImageIndex := 261;
//    mnuEmailCollection.ImageIndex := 262;
end;

procedure TfrmGPL.SetControlStyle(const AControl: TControl);
var
  i: Integer;
begin
  if AControl = nil then
    Exit;

  try
    if (AControl is TWinControl) then
    begin
      (AControl as TWinControl).ControlStyle := (AControl as TWinControl).ControlStyle + [csDisplayDragImage];

      for i := 0 to TWinControl(AControl).ControlCount - 1 do
        SetControlStyle(TWinControl(AControl).Controls[i]);
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetControlStyle', ClassName);
  end;
end;

procedure TfrmGPL.ExitonLogin;
begin
  try
    Application.ShowMainForm := False;
    dmMain.Destroy;
  finally
    TerminateProcess(GetCurrentProcess, 0);
  end;
end;

procedure TfrmGPL.SetStatusBar;

  function IsWrongIP(Ip: string): Boolean;
  const
    Z =['0'..'9', '.'];
  var
    I, J, P: Integer;
    W: string;
  begin
    Result := True;
    if (Length(Ip) > 15) or (Ip[1] = '.') then
      Exit;
    I := 1;
    J := 0;
    P := 0;
    W := '';
    repeat
      if (Ip[I] in Z) and (J < 4) then
      begin
        if Ip[I] = '.' then
        begin
          Inc(P);
          J := 0;
          try
            StrToInt(Ip[I + 1]);
          except
            Exit;
          end;
          W := '';
        end
        else
        begin
          W := W + Ip[I];
          if (StrToInt(W) > 255) or (Length(W) > 3) then
            Exit;
          Inc(J);
        end;
      end
      else
        Exit;
      Inc(I);
    until I > Length(Ip);
    if P < 3 then
      Exit;
    Result := False;
  end;

  function ServerCaption(Server: string): string;
  var
    idx: Integer;
  begin
    if IsWrongIP(Server) then
    begin
      idx := Pos('.', Server);
      if idx > 0 then
        Result := Copy(Server, 0, idx - 1)
      else
        Result := Server;
    end
    else
      Result := dmMain.cntMain.Server;
  end;

begin
  try
    //30.09.2024 SD -->bfacrm:ticket__show__39456
    {$IFDEF ENTERPRISE}
      if (bitfarmApp.User.Flags and 64) = 64 then
        itmUserName.Caption := bitfarmApp.User.Name + _(' (concurrent)')
      else
        itmUserName.Caption := bitfarmApp.User.Name + _(' (named)');
    {$ELSE}
      itmUserName.Caption := bitfarmApp.User.Name;
//      itmDBName.Caption := ServerCaption(dmMain.cntMain.Database);
    {$ENDIF}
    //30.09.2024 SD <--bfacrm:ticket__show__39456
    itmServerName.Caption := ServerCaption(bitfarmApp.bfaServer);
    itmProfile.Caption := bitfarmApp.Profile;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetStatusBar', ClassName);
  end;
end;

procedure TfrmGPL.SetStatusBarID(ArcID, GDocID: Int64; GUID: string = '');
begin
  try
    // Self
    if ((ArcID <> -1) and (GDocID <> -1)) then
      Self.itmID.Caption := IntToStr(ArcID) + '/' + IntToStr(GDocID)
    else
      Self.itmID.Caption := '';
  except
    bitfarmLog.Write(llNormal, ltException, 'SetStatusBarID', ClassName);
  end;
end;

procedure TfrmGPL.LoadDocumentsFromXML(ContType : Integer);
var
  UserAction: PUserAction;
begin
  try
    UserAction := bitfarmApp.CreateUserAction;
    if ContType = 0 then
      UserAction^.ActionName := 'actLoadImporterDocumentsFromXML'
    else if ContType = 1 then
      UserAction^.ActionName := 'actLoadWorkplaceDocumentsFromXML';
    UserAction^.Params.Add('1');  // SetInitialLoadFlag = 1
    bitfarmApp.MainThread.Add(UserAction);
  except
    bitfarmLog.Write(llNormal, ltException, 'LoadDocumentsFromXML', ClassName);
  end;
end;

procedure TfrmGPL.LoadBookmarks;
var
  UserAction: PUserAction;
begin
  try
    UserAction := bitfarmApp.CreateUserAction;
    UserAction^.ActionName := 'actLoadBookmarks';
    bitfarmApp.MainThread.Add(UserAction);
  except
    bitfarmLog.Write(llNormal, ltException, 'LoadBookmarks', ClassName);
  end;
end;

procedure TfrmGPL.ImporterScanProfilChange(Sender: TObject);
begin
  try
    fraScanFunctions.cbxScanProfile.ItemIndex := bitfarmApp.PreviewContainer.ImporterItem.Preview.bfaTlbImporter.cbxScanProfile.ItemIndex;
  except
    bitfarmLog.Write(llNormal, ltException, 'ImporterScanProfilChange', ClassName);
  end;
end;

procedure TfrmGPL.cbxScanProfileChange(Sender: TObject);
begin
  try
    bitfarmApp.PreviewContainer.ImporterItem.Preview.bfaTlbImporter.cbxScanProfile.ItemIndex := fraScanFunctions.cbxScanProfile.ItemIndex;
  except
    bitfarmLog.Write(llNormal, ltException, 'cbxScanProfileChange', ClassName);
  end;
end;

procedure TfrmGPL.ResultListStartDrag(Sender: TObject);
var
  p: TPoint;
  Doc: TbfaDocument;
  i: Integer;
  diff: Boolean;
  gdocid: Int64;
begin
  bitfarmLog.DebugBegin(llDebug, 'ResultListStartDrag', Classname);
  try
    try
      p := ScreenToClient(Mouse.CursorPos);
      if Assigned(bitfarmApp.DragObject) then
        bitfarmApp.DragObject.Destroy;
      bitfarmApp.DragObject := TbfaDragObject.Create; //(grdResultlist);
      bitfarmApp.DragObject.DragKind := dkDocuments;
//05.03.2020      bitfarmApp.DragObject.DragSource := grdResultlist;
      bitfarmApp.DragObject.DragSource := grdResultlistDevEx;
      bitfarmApp.DragObject.DocumentList.Clear;

      //23.05.2023 bfacrm:ticket__show__34879 -->
      diff := False;
      if bitfarmApp.CurrentView in [tvkViewer, tvkResub, tvkFavorites] then
      begin
        diff := bitfarmApp.CurrentContainer.Count <> grdResultlistDevExView.Controller.SelectedRecordCount;
        i := 0;
        while (not diff) and (i <= grdResultlistDevExView.Controller.SelectedRecordCount - 1) do
        begin
          if grdResultlistDevExView.Controller.SelectedRecords[i].IsData then
          begin
            try
              gdocid := grdResultlistDevExView.DataController.GetValue(grdResultlistDevExView.Controller.SelectedRecords[i].RecordIndex,
                grdResultlistDevExView.DataController.GetItemByFieldName('gdocid').Index);
            except
              gdocid := 0;
            end;

            diff := bitfarmApp.CurrentContainer[i].ID <> gdocid;
          end;

          inc(i);
        end;

      end;

      if diff then
      begin
        for i := 0 to grdResultlistDevExView.Controller.SelectedRecordCount - 1 do
        begin
          if grdResultlistDevExView.Controller.SelectedRecords[i].IsData then
          begin
            Doc := TbfaDocument.Create;
            Doc.ID := grdResultlistDevExView.DataController.GetValue(grdResultlistDevExView.Controller.SelectedRecords[i].RecordIndex,
                grdResultlistDevExView.DataController.GetItemByFieldName('gdocid').Index);
            try
              Doc.ArcID := grdResultlistDevExView.DataController.GetValue(grdResultlistDevExView.Controller.SelectedRecords[i].RecordIndex,
                  grdResultlistDevExView.DataController.GetItemByFieldName('arcid').Index);
            except
              Doc.ArcID := -1;
            end;
            Doc.Loaded := False;
            bitfarmApp.DragObject.Cloned := False; //10.05.2023
            bitfarmApp.DragObject.Changed := True; //23.05.2023 bfacrm:ticket__show__34879
            bitfarmApp.DragObject.DocumentList.Add(Doc);
          end;
        end;
      end
      else
      begin
      for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
      begin
        Doc := TbfaDocument.Create;
        Doc.Clone(bitfarmApp.CurrentContainer[i]);
          bitfarmApp.DragObject.Cloned := True; //10.05.2023
        bitfarmApp.DragObject.DocumentList.Add(Doc);
      end;
      end;
      //23.05.2023 bfacrm:ticket__show__34879-->

      CreateDragImage(diff);
    except
      bitfarmLog.Write(llNormal, ltException, 'ResultListStartDrag', Classname);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ResultListStartDrag', Classname);
  end;
end;

procedure TfrmGPL.CreateDragImage(NotLoaded: Boolean = False);

  procedure DoDragImage(G: TGraphic);
  var
    bmp: Graphics.TBitmap;
    W, H: Integer;
  begin
    ImageList1.Clear;
    bmp := Graphics.TBitmap.Create;
    try
      bmp.Canvas.Brush.Color := clFuchsia;
      bmp.Width := G.Width;
      bmp.Height := G.Height;
      try
        bmp.Canvas.Draw(0, 0, G);

        if (G.Height > G.Width) then
        begin
          W := 80;
          H := 100;
        end
        else
        begin
          W := 100;
          H := 80;
        end;

        ResizeBitmap(bmp, W, H, clFuchsia);

        ImageList1.Width := W;
        ImageList1.Height := H;
        ImageList1.AddMasked(bmp, clFuchsia);
      except
        bitfarmLog.Write(llNormal, ltException, 'DoDragImage', Classname);
      end;
    finally
      bmp.Free;
    end;
  end;

var
  myBmp : Graphics.TBitmap;
  H, W, idx: Integer;
  img: TbfaImageEnVect;
  iebmp2 : TIEBitmap;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateDragImage', Classname);
  try
    try
      if NotLoaded then
      begin
        img := CreateInvisibleVect(nil);
        try
          CreateEmptyImage(img, '', clWhite);

          W := 80;
          H := 100;

          if bitfarmApp.DragObject.DocumentList.Count > 1 then
          begin
            myBmp := Graphics.TBitmap.Create;
            try
              CreateBitmapMorePages(img.Bitmap, myBmp, W, H);
              DoDragImage(myBmp);
            finally
              FreeAndNil(myBmp);
            end;
          end else
          begin
            myBmp := Graphics.TBitmap.Create;
            try
              CreateBitmapOnePage(img.Bitmap, myBmp, W, H);
              DoDragImage(myBmp);
            finally
              FreeAndNil(myBmp);
            end;
          end;
        finally
          FreeAndNil(img);
        end;
      end
      else
      begin
      if bitfarmApp.CurrentContainer.Count = 0 then
        Exit;

      img := CreateInvisibleVect(nil);
      try
        if (bitfarmApp.CurrentContainer[0].HasPreview) and
          ((bitfarmApp.CurrentContainer[0].DocStream.Size > 0)
           or ((bitfarmApp.CurrentContainer[0].ScanPoolView <> nil)
           and (bitfarmApp.CurrentContainer[0].ScanPoolViewLoaded))) then
        begin
          if bitfarmApp.GetactivePreview.previewToolWindow.Visible and
            bitfarmApp.GetactivePreview.ThumbnailView.Focused then
          begin
            img.IO.Params.ImageIndex := bitfarmApp.GetactivePreview.ThumbnailView.SelectedImage;
            idx := bitfarmApp.GetactivePreview.ThumbnailView.SelectedImage;
            if idx = -1 then
            begin
              if bitfarmApp.GetactivePreview.ThumbnailView.MultiSelectedImagesCount > 0 then
                idx := bitfarmApp.GetactivePreview.ThumbnailView.MultiSelectedImages[0];
            end;
          end
          else
          begin
            idx := 0;
            img.IO.Params.ImageIndex := 0;
          end;

          if (bitfarmApp.CurrentContainer[0].ScanPoolView <> nil) and (bitfarmApp.CurrentContainer[0].ScanPoolViewLoaded) then
          begin
            img.IO.Params.ImageIndex := 0;
            iebmp2 := TIEBitmap.Create;
            try
              bitfarmApp.CurrentContainer[0].ScanPoolView.CopyToIEBitmap(idx, iebmp2);
              {$IFDEF ImageEN1140}
              img.Bitmap.Assign(iebmp2.VclBitmap);
              {$ELSE}
              img.IO.Bitmap.Assign(iebmp2.VclBitmap);
              {$ENDIF}
            finally
              FreeandNil(iebmp2);
            end;
          end else
          begin
            img.IO.Params.ImageIndex := 0;
            bitfarmApp.CurrentContainer[0].DocStream.Position := 0;
            img.IO.LoadFromStreamTIFF(bitfarmApp.CurrentContainer[0].DocStream);
          end;

          if (img.Bitmap.Height > img.Bitmap.Width) then
          begin
            W := 80;
            H := 100;
          end else
          begin
            W := 100;
            H := 80;
          end;

          if bitfarmApp.CurrentContainer.Count > 1 then
          begin
            myBmp := Graphics.TBitmap.Create;
            try
              CreateBitmapMorePages(img.Bitmap, myBmp, W, H);
              DoDragImage(myBmp);
            finally
              FreeAndNil(myBmp);
            end;
          end else
          begin
            myBmp := Graphics.TBitmap.Create;
            try
              CreateBitmapOnePage(img.Bitmap, myBmp, W, H);
              DoDragImage(myBmp);
            finally
              FreeAndNil(myBmp);
            end;
          end;
        end else
        begin
          if bitfarmApp.CurrentContainer[0].DocLoc <> '' then
          begin
            CreateEmptyImage(img, ExtractFileExt(bitfarmApp.CurrentContainer[0].DocLoc), clWhite);

            W := 80;
            H := 100;

            if bitfarmApp.CurrentContainer.Count > 1 then
            begin
              myBmp := Graphics.TBitmap.Create;
              try
                CreateBitmapMorePages(img.Bitmap, myBmp, W, H);
                DoDragImage(myBmp);
              finally
                FreeAndNil(myBmp);
              end;
            end else
            begin
              myBmp := Graphics.TBitmap.Create;
              try
                CreateBitmapOnePage(img.Bitmap, myBmp, W, H);
                DoDragImage(myBmp);
              finally
                FreeAndNil(myBmp);
              end;
            end;
          end;
        end;
      finally
        FreeAndNil(img);
      end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'CreateDragImage', Classname);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateDragImage', Classname);
  end;
end;

function TfrmGPL.CreateGlobalNode(userid, groupid: Integer; name: WideString): TTreeNode;
var
  NodeInfo: TbfaNodeInfo;
  Node: TTreeNode;
begin
  Result := nil;
  {$IFDEF ENTERPRISE}
  bitfarmLog.DebugBegin(llDebug, 'CreateGlobalNode', ClassName);
  try
    try
      NodeInfo := TbfaNodeInfo.Create;
      NodeInfo.Userid := userid;
      NodeInfo.Groupid := groupid;
      NodeInfo.Typ := 0;

      name := ParseSQLString(name);
      if (userid = 0) and (groupid = 0) then
      begin
        if name = '' then
          name := _('Lesezeichen fr alle Benutzer');
      end
      else if userid <> 0 then
      begin
        if name = '' then
          name := _('Lesezeichen fr Benutzer ') + DBGetUserName(userid);
      end
      else if groupid <> 0 then
      begin
        if name = '' then
          name := _('Lesezeichen fr Gruppe ') + DBGetGroupName(groupid)
      end;

      Node := AddTreeviewNode(bitfarmApp.Log, Self.trvBookmarks,
                  bitfarmApp.GlobalListNode, NodeInfo, 0, False, name, 2);

      bitfarmApp.SaveBookmarks(Node, 0, userid, groupid);

      Result := Node;
    except
      on e: exception do
        bitfarmLog.Write(llNormal, ltException, 'CreateGlobalNode' + e.Message, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateGlobalNode', ClassName);
  end;
  {$ENDIF}
end;

procedure TfrmGPL.actChangeBookmarkExecute(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'actChangeBookmarkExecute', Classname);
  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actChangeBookmark';

      if (Sender is TSpTBXItem) and (TSpTBXItem(Sender).Parent <> nil) and
         (TSpTBXItem(Sender).Parent.Owner = popFavTree) then
      begin
      // wir kommen ber ein bestimmtes Lesezeichen (CurrentView = tvkFavorites)
      if ((trvBookmarks.Selected <> nil) and (GetRootNode(trvBookmarks.Selected) = bitfarmApp.LocalListNode)) then
      begin
        if trvBookmarks.Selected.Data <> nil then
          UserAction^.Objects.Add(trvBookmarks.Selected);
      end
      else if ((trvBookmarks.Selected <> nil) and (GetRootNode(trvBookmarks.Selected) = bitfarmApp.GlobalListNode)) and bitfarmApp.User.isAdmin then
      begin
        if trvBookmarks.Selected.Data <> nil then
          UserAction^.Objects.Add(trvBookmarks.Selected);
      end;

      end
      else if (Sender is TSpTBXItem) and (TSpTBXItem(Sender).Parent <> nil) and
              (TSpTBXItem(Sender).Parent.Owner = popTreeView) then
      begin
      // wir kommen ber den TreeView von Lager und Archive (CurrentView = tvkViewer)
        UserAction^.Objects.Add(trvBookmarks);
      end;
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'actChangeBookmarkExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actChangeBookmarkExecute', Classname);
  end;
end;

procedure TfrmGPL.actChangeDocNameExecute(Sender: TObject);
var
  UserAction: PUserAction;
  i: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'actChangeDocNameExecute', Classname);
  try
    try
      if (bitfarmApp.GetActivePreview.ActiveDoc <> nil) then
      begin
        //21.02.2024 -->
        if (bitfarmApp.GetActivePreview.SingleView.img_DocView.SelObjectsCount = 1) and //funktioniert nur beim einem Objekt
           (bitfarmApp.GetActivePreview.SingleView.img_DocView.ObjTextEditMode <> -1)  //muss auch in Editmode sein
        then
        begin
          actListExecute(Sender);
        end
        else
        begin
        //21.02.2024 <--
          UserAction := bitfarmApp.CreateUserAction;
          UserAction^.ActionName := 'actChangeDocName';
          if (bitfarmApp.GetActivePreview.PreviewKind = pvkMulti) {09.07.2024 SD <--bfacrm:ticket__show__31605}  or (bitfarmApp.GetActivePreview.PreviewKind = pvkMultiSingle) then
          begin
            for i := 0 to bitfarmApp.GetActivePreview.MultiView.MultiSelectedImagesCount - 1 do
              UserAction^.Objects.Add(bitfarmApp.GetActivePreview.List[bitfarmApp.GetActivePreview.MultiView.MultiSelectedImages[i]]);
          end
          else if (bitfarmApp.GetActivePreview = bitfarmApp.PreviewContainer.ViewerItem.Preview) and (bitfarmApp.CurrentContainer.Count > 0) then
          begin
            for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
              UserAction^.Objects.Add(bitfarmApp.CurrentContainer[i]);
          end
          else
            UserAction^.Objects.Add(bitfarmApp.GetActivePreview.List[0]);
          UserAction^.Preview := bitfarmApp.GetActivePreview;
          bitfarmApp.MainThread.Add(UserAction);
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'actChangeDocNameExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actChangeDocNameExecute', Classname);
  end;
end;

procedure TfrmGPL.actCopyBookmarkExecute(Sender: TObject);
var
  UserAction: PUserAction;

begin
  bitfarmLog.DebugBegin(llDebug, 'actCopyBookmarkExecute', Classname);
  try
    try
      if (trvBookmarks.Selected <> nil) and (trvBookmarks.Selected.Data <> nil) and
          (TObject(trvBookmarks.Selected.Data) is TbfaSearch) then
      begin
        if (GetRootNode(trvBookmarks.Selected) = bitfarmApp.LocalListNode) or
           ((GetRootNode(trvBookmarks.Selected) = bitfarmApp.GlobalListNode) and bitfarmApp.User.isAdmin) then
        begin
          UserAction := bitfarmApp.CreateUserAction;
          UserAction^.ActionName := 'actCopyBookmark';
          UserAction^.Objects.Add(trvBookmarks.Selected);
          bitfarmApp.MainThread.Add(UserAction);
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'actCopyBookmarkExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actCopyBookmarkExecute', Classname);
  end;
end;

procedure TfrmGPL.actCopyDocLinkToClipboardExecute(Sender: TObject);
var
  ActDoc: TbfaDocument;
  prev: TbfaPreview;
  hist : TbfaHistory;
begin
  bitfarmLog.DebugBegin(llDebug, 'actCopyDocLinkToClipboardExecute', Classname);
  try
    try
      prev := bitfarmApp.GetActivePreview;
      ActDoc := prev.ActiveDoc;

      frmMainForm.actCopyDocToClipboard.Tag := 0;
      frmMainForm.actCopyOriginalDocToClipboard.Tag := 0;
      frmMainForm.actCopyPageToClipboard.Tag := 0;
      frmMainForm.actCopyDocLinkToClipboard.Tag := 1;

      if ActDoc <> nil then
      begin
        if not prev.Floating then
        begin
//14.10.2019          Self.MainMenu.mnuCopyToClipboard.ImageIndex := Self.actCopyDocLinkToClipboard.ImageIndex;
//          Self.MainMenu.mnuCopyToClipboard.Action := Self.actCopyDocLinkToClipboard;
//          Self.bfaTlbStandard1.tlbStandardSubmenuItem4.Action := Self.actCopyDocLinkToClipboard;
          frmMainForm.mnuCopyToClipboard.ImageIndex := prev.actCopyDocLinkToClipboard.ImageIndex;
          frmMainForm.mnuCopyToClipboard.Action := prev.actCopyDocLinkToClipboard;
          bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action := prev.actCopyDocLinkToClipboard;
        end;

//14.10.2019        prev.bfaTlbStandard.tlbStandardSubmenuItem4.Action := Self.actCopyDocLinkToClipboard;
        prev.bfaTlbStandard.tlbStandardSubmenuItemClipboard.Action := prev.actCopyDocLinkToClipboard;

        bfaCommonFiles.CopyLinkToClipboard('gdocid:' + IntToStr(ActDoc.ID), '<html><body><!--StartFragment--><a href="gdocid:' + IntToStr(ActDoc.ID) + '">' + StrToHtml(ActDoc.DocName) + '</a><!--EndFragment--></body></html>');

        hist := TbfaHistory.Create;
        hist.Userid := bitfarmApp.User.ID;
        hist.Gdocid := ActDoc.ID;
        hist.Date := Now();
        hist.Taskid := 243;
        bitfarmApp.WriteHistory(nil, hist);
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'actCopyDocLinkToClipboardExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actCopyDocLinkToClipboardExecute', Classname);
  end;
end;

procedure TfrmGPL.actCopyDocToClipboardExecute(Sender: TObject);
var
  prev: TbfaPreview;
begin
  bitfarmLog.DebugBegin(llDebug, 'actCopyDocToClipboardExecute', Classname);
  try
    try
      prev := bitfarmApp.GetActivePreview;

      // -> CreateCopyToClipboardAction
//      frmMainForm.actCopyDocToClipboard.Tag := 1;
//      frmMainForm.actCopyOriginalDocToClipboard.Tag := 0;
//      frmMainForm.actCopyPageToClipboard.Tag := 0;
//      frmMainForm.actCopyDocLinkToClipboard.Tag := 0;

      bitfarmApp.CreateCopyToClipboardAction(False, prev.bfaTlbPreview.mnuStationery.Checked,
        (prev.bfaTlbPreview.mnuPrivateAnno.Enabled and prev.bfaTlbPreview.mnuPrivateAnno.Checked),
        (prev.bfaTlbPreview.mnuPublicAnno.Enabled and prev.bfaTlbPreview.mnuPublicAnno.Checked), prev);

    except
      bitfarmLog.Write(llNormal, ltException, 'actCopyDocToClipboardExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actCopyDocToClipboardExecute', Classname);
  end;
end;

procedure TfrmGPL.actCopyOriginalDocToClipboardExecute(Sender: TObject);
var
  prev: TbfaPreview;
begin
  bitfarmLog.DebugBegin(llDebug, 'actCopyOriginalDocToClipboardExecute', Classname);
  try
    try
      prev := bitfarmApp.GetActivePreview;

      // -> CreateCopyToClipboardAction
//      frmMainForm.actCopyDocToClipboard.Tag := 0;
//      frmMainForm.actCopyOriginalDocToClipboard.Tag := 1;
//      frmMainForm.actCopyPageToClipboard.Tag := 0;
//      frmMainForm.actCopyDocLinkToClipboard.Tag := 0;

      bitfarmApp.CreateCopyToClipboardAction(True, prev.bfaTlbPreview.mnuStationery.Checked,
      (prev.bfaTlbPreview.mnuPrivateAnno.Enabled and prev.bfaTlbPreview.mnuPrivateAnno.Checked),
      (prev.bfaTlbPreview.mnuPublicAnno.Enabled and prev.bfaTlbPreview.mnuPublicAnno.Checked), prev);
    except
      bitfarmLog.Write(llNormal, ltException, 'actCopyOriginalDocToClipboardExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actCopyOriginalDocToClipboardExecute', Classname);
  end;
end;

procedure TfrmGPL.actCopyPageToClipboardExecute(Sender: TObject);
var
  ActDoc: TbfaDocument;
  prev: TbfaPreview;
  hist : TbfaHistory;
begin
  bitfarmLog.DebugBegin(llDebug, 'actCopyPageToClipboardExecute', Classname);
  try
    try
      prev := bitfarmApp.GetActivePreview;
      ActDoc := prev.ActiveDoc;

      frmMainForm.actCopyDocToClipboard.Tag := 0;
      frmMainForm.actCopyOriginalDocToClipboard.Tag := 0;
      frmMainForm.actCopyPageToClipboard.Tag := 1;
      frmMainForm.actCopyDocLinkToClipboard.Tag := 0;

      if not prev.Floating then
      begin
//14.10.2019        Self.MainMenu.mnuCopyToClipboard.ImageIndex := Self.actCopyPageToClipboard.ImageIndex;
//        Self.MainMenu.mnuCopyToClipboard.Action := Self.actCopyPageToClipboard;
//        Self.bfaTlbStandard1.tlbStandardSubmenuItem4.Action := Self.actCopyPageToClipboard;
        frmMainForm.mnuCopyToClipboard.ImageIndex := prev.actCopyPageToClipboard.ImageIndex;
        frmMainForm.mnuCopyToClipboard.Action := prev.actCopyPageToClipboard;
        bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action := prev.actCopyPageToClipboard;
      end;

//14.10.2019      prev.bfaTlbStandard.tlbStandardSubmenuItem4.Action := Self.actCopyPageToClipboard;
      prev.bfaTlbStandard.tlbStandardSubmenuItemClipboard.Action := prev.actCopyPageToClipboard;

      if ActDoc <> nil then
      begin
        prev.SingleView.img_DocView.Proc.CopyToClipboard;

        hist := TbfaHistory.Create;
        hist.Userid := bitfarmApp.User.ID;
        hist.Gdocid := ActDoc.ID;
        hist.Date := Now();
        hist.Value1 := IntToStr(prev.ActivePage +1);
        hist.Taskid := 246;
        bitfarmApp.WriteHistory(nil, hist);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'actCopyPageToClipboardExecute', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actCopyPageToClipboardExecute', Classname);
  end;
end;

procedure TfrmGPL.DropExecute(Outside: Boolean = False);
var
  Data: TVirtualFileStreamDataFormat;
  i: Integer;
  PageStr: WideString;
begin
  if not Outside then
  begin
    Data := TVirtualFileStreamDataFormat(DataFormatAdapter1.DataFormat);
    Data.FileNames.Clear;

    PageStr := '';
    if bitfarmApp.DragObject <> nil then
    begin
      if bitfarmApp.DragObject.DragKind = dkPages then
      begin
        if bitfarmApp.DragObject.PageList.Count = 1 then
          PageStr := '_' + sCaptionPage + '_' + IntToStr(StrToInt(bitfarmApp.DragObject.PageList[0]) + 1);
      end;
    end;

    for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
    begin
      if bitfarmApp.CurrentContainer[i].DocName <> '' then
      begin
        if bitfarmApp.CurrentContainer[i].HasPreview then
          Data.FileNames.Add(bitfarmApp.CurrentContainer[i].DocName + PageStr + '.tif')
        else
          Data.FileNames.Add(bitfarmApp.CurrentContainer[i].DocName + '.' + bitfarmApp.CurrentContainer[i].FileType);
      end
      else
      begin
        if bitfarmApp.CurrentContainer[i].HasPreview then
          Data.FileNames.Add('Dokument' + IntToStr(i) + PageStr + '.tif')
        else
          Data.FileNames.Add('Dokument' + IntToStr(i) + '.' + bitfarmApp.CurrentContainer[i].FileType);
      end;
    end;

    try
      if Data.FileNames.Count > 0 then
        desResultGrid.Execute(True);
    except
      bitfarmLog.Write(llNormal, ltException, 'DropExecute', ClassName);
    end;
  end
  else
  begin
    DropFileSource1.Files.Clear;
    //23.05.2023 bfacrm:ticket__show__34879 -->
    if bitfarmApp.DragObject.Changed then
    begin
      for i := 0 to bitfarmApp.DragObject.DocumentList.Count - 1 do
        DropFileSource1.Files.Add(IntToStr(i));  // wird im onDrop gesetzt!
    end
    else
    begin
    for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
      DropFileSource1.Files.Add(IntToStr(i));  // wird im onDrop gesetzt!
    end;
//    for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
//      DropFileSource1.Files.Add(IntToStr(i));  // wird im onDrop gesetzt!
    //23.05.2023 bfacrm:ticket__show__34879 <--
    DropFileSource1.Execute;
  end;
  //23.05.2023 bfacrm:ticket__show__34879 -->
  if (bitfarmApp.DragObject <> nil) and bitfarmApp.DragObject.Changed then
  begin
    grdResultlistDevExView.SetBookmark;
    grdResultlistDevExView.Controller.FocusedRecord.Selected := True;
    grdResultListSelectionChanged(grdResultlistDevExView);
  end;
  //23.05.2023 bfacrm:ticket__show__34879 <--
end;

procedure TfrmGPL.DropFileSource1AfterDrop(Sender: TObject; DragResult: TDragResult; Optimized: Boolean);
begin
  bitfarmApp.FUseFileTarget := True;
end;

procedure TfrmGPL.DropFileSource1Drop(Sender: TObject; DragType: TDragType; var ContinueDrop: Boolean);
var
  i, j, fileindex: Integer;
  FType, FName: WideString;
  DoPDF, DoTIF, DoOri, CtrlPressed, found: Boolean;
  Lst: TList<TbfaDocument>;
  MStream: TMemoryStream;
  FileNameArray: array of string;
  hist : TbfaHistory;
  ErrorList : TStringList;

  procedure DoTifStream;
  begin
    if // 03.03.2017 DoTIF and
      (bitfarmApp.DragObject.DocumentList[i].HasPreview) and
      (Self.bfaTlbPreview1.mnuStationery.Checked or
      (Self.bfaTlbPreview1.mnuPrivateAnno.Enabled and Self.bfaTlbPreview1.mnuPrivateAnno.Checked) or
      (Self.bfaTlbPreview1.mnuPublicAnno.Enabled and Self.bfaTlbPreview1.mnuPublicAnno.Checked)) then
    begin
      Lst := TList<TbfaDocument>.Create;
      try
        Lst.Add(bitfarmApp.DragObject.DocumentList[i]);
        MStream := bfaImageRendering(nil, Lst,
          Self.bfaTlbPreview1.mnuStationery.Enabled and Self.bfaTlbPreview1.mnuStationery.Checked,
          False, Self.bfaTlbPreview1.mnuPublicAnno.Enabled and Self.bfaTlbPreview1.mnuPublicAnno.Checked);
      finally
        FreeAndNil(Lst);
      end;

      DropFileSource1.Files[i] := BD.EnvTempPd + 'bfa_dd\' + FName + '.tif';

      MStream.Position := 0;
      MStream.SaveToFile(DropFileSource1.Files[i]);
    end
    else
    begin
      if bitfarmApp.DragObject.DocumentList[i].FileType <> '' then
        FType := bitfarmApp.DragObject.DocumentList[i].FileType
      else
        FType := ExtractFileExt(bitfarmApp.DragObject.DocumentList[i].DocLoc);

      DropFileSource1.Files[i] := BD.EnvTempPd + 'bfa_dd\' + FName + FType;

      bitfarmApp.DragObject.DocumentList[i].DocStream.SaveToFile(DropFileSource1.Files[i]);
    end;
  end;

begin
  bitfarmLog.DebugBegin(llDebug, 'DropFileSource1Drop', Classname);
  bitfarmApp.DoDropping := True;
  try
    try
      ErrorList := TStringList.Create;
      CtrlPressed := (GetKeyState(VK_CONTROL) < 0);

      DoOri := CtrlPressed;
      DoPDF := not DoOri;

      if not FInside then
      begin
        if not DirectoryExists(BD.EnvTempPd + 'bfa_dd') then //06.09.2017 Bei Kunde dauert lande diese Verzeichnis zu lschen
        begin
          bitfarmLog.Write(llDebug, ltinfo, 'ForceDirectories: ' + BD.EnvTempPd + 'bfa_dd', Classname);
          ForceDirectories(BD.EnvTempPd + 'bfa_dd'); //06.09.2017
          bitfarmLog.Write(llDebug, ltinfo, 'Directory created', Classname);
        end;

        if bitfarmApp.DragObject <> nil then
        begin
          if bitfarmApp.DragObject.DragKind = dkDocuments then
          begin
            SetLength(FileNameArray, bitfarmApp.DragObject.DocumentList.Count); // SJ 06.08.2019 - bfacrm:ticket__show__19018
            for i := 0 to bitfarmApp.DragObject.DocumentList.Count - 1 do
            begin
              if (High(aSysArc) > 0) and ( bitfarmApp.DragObject.DocumentList[i].Arcid > -1) and ( bitfarmApp.DragObject.DocumentList[i].Arcid <= High(aSysArc))
                  and (aSysArc[ bitfarmApp.DragObject.DocumentList[i].Arcid].Rights and rightWrite = 0) then
              begin
                ErrorList.Add(IntToStr(bitfarmApp.DragObject.DocumentList[i].ID));
                Continue;
              end;

              //10.02.2023 bfacrm:ticket__show__33894 -->
              //if not bitfarmApp.DragObject.DocumentList[i].Loaded then
              //  bitfarmApp.LoadDocumentViaSocket(bitfarmApp.DragObject.DocumentList[i], 'base;paths;iev', nil);
              if not bitfarmApp.OfflineMode and not bitfarmApp.DragObject.DocumentList[i].Loaded then
                bitfarmApp.LoadDocumentViaSocket(bitfarmApp.DragObject.DocumentList[i], 'base;paths;iev', nil)
              else if bitfarmApp.OfflineMode and not bitfarmApp.DragObject.DocumentList[i].Loaded then
                bitfarmApp.DBLoadDocument(bitfarmApp.DragObject.DocumentList[i]);
              //10.02.2023 bfacrm:ticket__show__33894 -->


              bitfarmApp.DragObject.DocumentList[i].SelectedPages.Clear;

              if bitfarmApp.DragObject.DocumentList[i].DocName <> '' then
//28.07.2017 Ticket 11280                FName := bitfarmApp.DragObject.DocumentList[i].DocName
                FName := ParseFilename(bitfarmApp.DragObject.DocumentList[i].DocName)
              else
                FName := _('Dokument');

              if bitfarmApp.DragObject.DocumentList[i].FileType <> '' then
                FType := bitfarmApp.DragObject.DocumentList[i].FileType
              else
                FType := ExtractFileExt(bitfarmApp.DragObject.DocumentList[i].OriLoc);

//            <!--
//            SJ 06.08.2019 - bfacrm:ticket__show__19018
//            berprfung ob FName beim Drag&Drop mehrfach vorkommt und ggf. Index anhngen
              fileindex := 0;
              for j := 0 to High(FileNameArray) do
              begin
                found := False;
                if FileNameArray[j] = FName + FType then
                begin
                // Dateiname bereits erhalten
                  found := True;
                  Inc(fileindex);
                  FName := ParseFilename(bitfarmApp.DragObject.DocumentList[i].DocName) + '_' + IntToStr(fileindex);
                end;
              end;
              if not found then
                FileNameArray[i] := FName + FType;
//            -->

              if (DoPDF) and (bitfarmApp.DragObject.DocumentList[i].HasPreview) then
              begin
                Lst := TList<TbfaDocument>.Create;
                try
                  Lst.Add(bitfarmApp.DragObject.DocumentList[i]);
                  MStream := bfaImageRendering(nil, Lst, Self.bfaTlbPreview1.mnuStationery.Enabled and
                    Self.bfaTlbPreview1.mnuStationery.Checked, False, Self.bfaTlbPreview1.mnuPublicAnno.Enabled
                    and Self.bfaTlbPreview1.mnuPublicAnno.Checked);
                finally
                  FreeAndNil(Lst);
                end;

                if (MStream <> nil) and (MStream.Size > 0) then
                begin
                  DropFileSource1.Files[i] := BD.EnvTempPd + 'bfa_dd\' + FName + '.pdf';

                  bitfarmApp.CreatePDFFile(MStream, DropFileSource1.Files[i],
                    bitfarmApp.DragObject.DocumentList[i].FullTXT);
                end;
              end
              else
              begin
                if (DoOri or (not bitfarmApp.DragObject.DocumentList[i].HasPreview)) and //03.08.2017 Ticket 11374
                (bitfarmApp.DragObject.DocumentList[i].OriLoc <> '') then
                begin
                  DropFileSource1.Files[i] := BD.EnvTempPd + 'bfa_dd\' + FName + FType;

                  if (bitfarmApp.DragObject.DocumentList[i].OriStream = nil) or
                    (bitfarmApp.DragObject.DocumentList[i].OriStream.Size = 0) then
//14.06.2023                    bitfarmApp.DragObject.DocumentList[i].OriStream :=
//                  bitfarmApp.GetOriStream(bitfarmApp.DragObject.DocumentList[i]);
                  if bitfarmApp.GetOriStream(bitfarmApp.DragObject.DocumentList[i], nil, DropFileSource1.Files[i]) then
                  begin
//14.06.2023
//                  if (bitfarmApp.DragObject.DocumentList[i].OriStream <> nil) and
//                    (bitfarmApp.DragObject.DocumentList[i].OriStream.Size > 0) then
////24.05.2023                    bitfarmApp.DragObject.DocumentList[i].OriStream.SaveToFile(DropFileSource1.Files[i])
//                    CopyFile(PWideChar(TFileStream(bitfarmApp.DragObject.DocumentList[i].OriStream).FileName),
//                             PWideChar(DropFileSource1.Files[i]),
//                             False)
//31.07.2023 bfacrm:ticket__show__35903 -->
                    bitfarmApp.DragObject.DocumentList[i].OriStream.Free;
                    DragType := dtCopy;
//31.07.2023 <--
                  end
                  else
                    DoTifStream;
                end
                else
                  DoTifStream;
              end;

              hist := TbfaHistory.Create;
              hist.Userid := bitfarmApp.User.ID;
              hist.Gdocid := bitfarmApp.DragObject.DocumentList[i].Id;
              hist.Date := Now();
              hist.Taskid := 241;
              //hist.Value1 := DropFileSource1.Files[i];

              if not bitfarmApp.OfflineMode then
                bitfarmApp.WriteHistory(nil, hist);
            end;

            if ErrorList.Count > 0 then
            begin
              if ErrorList.Count = 1 then
                BfShowMessage(Format(_('Es konnten ein Dokument [%s] nicht gespeichert werden, da Sie nicht\ndie notwendige Schreibberechtigung fr dieses Dokument besitzen.'),[ErrorList[0]]))
              else
                BfShowMessage(Format(_('Es konnten %d Dokumente [%s] nicht gespeichert werden, da Sie nicht\ndie notwendige Schreibberechtigung fr diese Dokumente besitzen.'),[ErrorList.Count, ErrorList.CommaText]));
            end;

            SetLength(FileNameArray, 0); // SJ 06.08.2019 - bfacrm:ticket__show__19018
          end
          else
          begin
            bitfarmApp.DragObject.DocumentList[0].SelectedPages.Clear;
            for i := 0 to bitfarmApp.DragObject.SelectedList.Count - 1 do
            begin
              bitfarmApp.DragObject.DocumentList[0].SelectedPages.Add(
                IntToStr(StrToInt(bitfarmApp.DragObject.SelectedList[i]) + 1));
            end;

            if bitfarmApp.DragObject.DocumentList[0].DocName <> '' then
              FName := bitfarmApp.DragObject.DocumentList[0].DocName
            else
              FName := _('Dokument');

            Lst := TList<TbfaDocument>.Create;
            try
              Lst.Add(bitfarmApp.DragObject.DocumentList[0]);
              MStream := bfaImageRendering(nil, Lst, Self.bfaTlbPreview1.mnuStationery.Enabled and
                Self.bfaTlbPreview1.mnuStationery.Checked, False, Self.bfaTlbPreview1.mnuPublicAnno.Enabled and
                Self.bfaTlbPreview1.mnuPublicAnno.Checked);
            finally
              FreeAndNil(Lst);
            end;

            if (DoPDF) and (bitfarmApp.DragObject.DocumentList[0].HasPreview) then
            begin
              DropFileSource1.Files[0] := BD.EnvTempPd + 'bfa_dd\' + FName + '.pdf';

              bitfarmApp.CreatePDFFile(MStream, DropFileSource1.Files[0], bitfarmApp.DragObject.DocumentList[0].FullTXT);
            end
            else
            begin
              DropFileSource1.Files[0] := BD.EnvTempPd + 'bfa_dd\' + FName + '.tif';

              MStream.Position := 0;
              MStream.SaveToFile(DropFileSource1.Files[0]);
            end;

            hist := TbfaHistory.Create;
            hist.Userid := bitfarmApp.User.ID;
            hist.Gdocid := bitfarmApp.DragObject.DocumentList[0].Id;
            hist.Date := Now();
            hist.Taskid := 242;
            hist.Value1 := bitfarmApp.DragObject.DocumentList[0].SelectedPages.CommaText;

            if not bitfarmApp.OfflineMode then
              bitfarmApp.WriteHistory(nil, hist);
          end;
        end;

        //23.05.2023 bfacrm:ticket__show__34879 -->
        if (bitfarmApp.DragObject <> nil) and bitfarmApp.DragObject.Changed then
        begin
          grdResultlistDevExView.SetBookmark;
          grdResultlistDevExView.Controller.FocusedRecord.Selected := True;
          grdResultListSelectionChanged(grdResultlistDevExView);
        end;
        //23.05.2023 bfacrm:ticket__show__34879 <--
        bitfarmApp.DragObject.Free;
        bitfarmApp.DragObject := nil;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'DropFileSource1Drop', ClassName);
    end;
  finally
    bitfarmApp.DoDropping := False;
    bitfarmLog.DebugEnd(llDebug, 'DropFileSource1Drop', Classname);
  end;
end;

procedure TfrmGPL.OnGetStream(Sender: TFileContentsStreamOnDemandClipboardFormat; Index: integer;
  out AStream: IStream);
var
  Data: TVirtualFileStreamDataFormat;
  Lst: TList<TbfaDocument>;
  i: Integer;
begin
  Data := TVirtualFileStreamDataFormat(DataFormatAdapter1.DataFormat);

  if (Index < bitfarmApp.CurrentContainer.Count) then
  begin
    //10.02.2023 bfacrm:ticket__show__33894 -->
    //if not bitfarmApp.CurrentContainer[Index].Loaded then
    //  bitfarmApp.LoadDocumentViaSocket(bitfarmApp.CurrentContainer[Index], 'base;paths;iev', nil);
    if not bitfarmApp.OfflineMode and not bitfarmApp.CurrentContainer[Index].Loaded then
      bitfarmApp.LoadDocumentViaSocket(bitfarmApp.CurrentContainer[Index], 'base;paths;iev', nil)
    else if bitfarmApp.OfflineMode and not bitfarmApp.CurrentContainer[Index].Loaded then
      bitfarmApp.DBLoadDocument(bitfarmApp.CurrentContainer[Index]);
    //10.02.2023 bfacrm:ticket__show__33894 -->

    if bitfarmApp.DragObject.DragKind = dkDocuments then
    begin
      if ((GetKeyState(VK_CONTROL) < 0) and (GetKeyState(VK_SHIFT) < 0)) then
      begin
        Lst := TList<TbfaDocument>.Create;
        try
          Lst.Add(bitfarmApp.CurrentContainer[Index]);
          AStream := TStreamAdapter.Create(bfaImageRendering(nil, Lst, Self.bfaTlbPreview1.mnuStationery.Checked,
            Self.bfaTlbPreview1.mnuPrivateAnno.Checked, Self.bfaTlbPreview1.mnuPublicAnno.Checked), soOwned);
        finally
          FreeAndNil(Lst);
        end;
      end
      else if ((GetKeyState(VK_MENU) < 0) and (GetKeyState(VK_SHIFT) < 0)) then
      begin
        if ((bitfarmApp.CurrentContainer[Index].OriStream <> nil) and (bitfarmApp.CurrentContainer[Index].OriStream.Size > 0)) then
        begin
          AStream := TStreamAdapter.Create(bitfarmApp.CurrentContainer[Index].OriStream, soReference);
        end
        else if (bitfarmApp.CurrentContainer[Index].ID = -1) then
        begin
          AStream := TStreamAdapter.Create(bitfarmApp.CurrentContainer[Index].DocStream, soReference);
        end
        else
        begin
//14.06.2023          bitfarmApp.CurrentContainer[Index].OriStream := bitfarmApp.GetOriStream(bitfarmApp.CurrentContainer[Index]);
          bitfarmApp.GetOriStream(bitfarmApp.CurrentContainer[Index], nil, '');

          AStream := TStreamAdapter.Create(bitfarmApp.CurrentContainer[Index].OriStream, soReference);
        end;
      end
      else
      begin
        AStream := TStreamAdapter.Create(bitfarmApp.CurrentContainer[Index].DocStream, soReference);
      end;
    end
    else
    begin
      try
        bitfarmApp.CurrentContainer[Index].SelectedPages.Clear;
        for i := 0 to bitfarmApp.DragObject.SelectedList.Count - 1 do
        begin
          bitfarmApp.CurrentContainer[Index].SelectedPages.Add(IntToStr(StrToInt(bitfarmApp.DragObject.SelectedList[i]) + 1));
        end;

        if ((GetKeyState(VK_CONTROL) < 0) and (GetKeyState(VK_SHIFT) < 0)) then
        begin
          Lst := TList<TbfaDocument>.Create;
          try
            Lst.Add(bitfarmApp.CurrentContainer[Index]);
            AStream := TStreamAdapter.Create(bfaImageRendering(nil, Lst, Self.bfaTlbPreview1.mnuStationery.Checked,
            Self.bfaTlbPreview1.mnuPrivateAnno.Checked, Self.bfaTlbPreview1.mnuPublicAnno.Checked), soOwned);
          finally
            FreeAndNil(Lst);
          end;
        end
        else
        begin
          Lst := TList<TbfaDocument>.Create;
          try
            Lst.Add(bitfarmApp.CurrentContainer[Index]);
            AStream := TStreamAdapter.Create(bfaImageRendering(nil, Lst, False, False, False), soOwned);
          finally
            FreeAndNil(Lst);
          end;
        end;
      finally
        bitfarmApp.CurrentContainer[Index].SelectedPages.Clear;
      end;
    end;
  end;
end;

procedure TfrmGPL.pnlAdminWindowStateChanged(Sender: TObject; AWindowState: TWindowState);
begin
  if fSkipMaximizeEvent then
    Exit;

  if fAppStarted and pnlAdmin.Maximized and (bitfarmApp.CurrentView <> tvkAdministrator) then
  begin
    bitfarmApp.SetActiveViewAction(pvtAdmin, nil, tvkAdministrator);
    if FAdminTreeview <> nil then
    begin
      if (FAdminTreeview.Items.Count > 0) and (FAdminTreeview.Selected = nil) then
        FAdminTreeview.Selected := FAdminTreeview.RootNode;
      if FAdminTreeview.Selected <> nil then
        TVChange(FAdminTreeview, FAdminTreeview.Selected);
    end;
  end;
end;

procedure TfrmGPL.ppmToolsPopup(Sender: TObject);
var
  prev: TbfaPreview;
  mouse, selpos, selpos2: TPoint;
  selrect: TRect;
  hasMultiPageDocument: Boolean;
begin
  // muss vor try except/finally passieren
  if (bitfarmApp.CurrentContainer.Count = 0) then
    Abort;

  bitfarmLog.DebugBegin(llnormal, 'ppmToolsPopup', ClassName);
  try
    try
      prev := bitfarmApp.GetActivePreview;
      GetCursorPos(mouse);
      selpos := prev.SingleView.img_DocView.ScreenToClient(mouse);

      selpos.X := prev.SingleView.img_DocView.XScr2Bmp(selpos.X);
      selpos.Y := prev.SingleView.img_DocView.YScr2Bmp(selpos.Y);

      FPpmToolsPopupInResultGrid := (ppmTools.PopupComponent is TcxGrid);
      tbiFloatingResub.Enabled := (bitfarmapp.CurrentView = tvkViewer);

      mnuOCRAddfields.Images := bfaIcons.ilPreview;
      mnuOCRAddfields.ImageIndex := Integer(icoidx_ocr);
      mnuUnDockDocument.Images := bfaIcons.ilPreview;
      itmDocInNewTab.Images := bfaIcons.ilPreview;
      itmDocInNewWindow.Images := bfaIcons.ilPreview;
      if (not actUndockDefault.Enabled) and (actUndockDefault = actUndockInNewTab) and actUndockInNewWindow.Enabled then
        mnuUnDockDocument.Action := actUndockInNewWindow
      else if (not actUndockDefault.Enabled) and (actUndockDefault = actUndockInNewWindow) and actUndockInNewTab.Enabled then
        mnuUnDockDocument.Action := actUndockInNewTab
      else
        mnuUnDockDocument.Action := actUndockDefault;

      // noch die SubItems setzen
      itmDocInNewTab.Action := actUndockInNewTab;
      itmDocInNewTab.Enabled := actUndockInNewTab.Enabled;
      itmDocInNewWindow.Action := actUndockInNewWindow;
      itmDocInNewWindow.Enabled := actUndockInNewWindow.Enabled;

      if (ppmTools.PopupComponent is TIEView) then
      begin
        var p: TPoint;
        GetCursorPos(p);
        bitfarmApp.ControlAtMousePos := FindVCLWindow(p);
        if (bitfarmApp.ControlAtMousePos is TIETextControl) or
           (prev.SingleView.img_DocView.SelObjectsCount > 0)  then
          prev.ppmAnnotations.Popup(p.X, p.Y)
        else if (ppmTools.PopupComponent.Owner is TbfaPreview) or
                (ppmTools.PopupComponent.Owner is Tfrm_Voransicht) then
        begin
          mnuBack.Action := actPreviewBack;

          if (ppmTools.PopupComponent.Owner is TbfaPreview) then
          begin
            mnuBack.Visible :=
              (TbfaPreview(ppmTools.PopupComponent.Owner).PreviewKind = pvkMultiSingle);
            if TbfaPreview(ppmTools.PopupComponent.Owner) =
               bitfarmApp.PreviewContainer.ImporterItem.Preview
            then
              mnuBack.Caption := _('Zurck zum Importer')
            else if TbfaPreview(ppmTools.PopupComponent.Owner) =
              bitfarmApp.PreviewContainer.WorkplaceItem.Preview
            then
              mnuBack.Caption := _('Zurck zum Arbeitsplatz');
          end
          else
          begin
            mnuBack.Visible :=
              (TbfaPreview((ppmTools.PopupComponent.Owner).Owner).PreviewKind = pvkMultiSingle);
            if TbfaPreview((ppmTools.PopupComponent.Owner).Owner) =
               bitfarmApp.PreviewContainer.ImporterItem.Preview
            then
              mnuBack.Caption := _('Zurck zum Importer')
            else if TbfaPreview((ppmTools.PopupComponent.Owner).Owner) =
              bitfarmApp.PreviewContainer.WorkplaceItem.Preview
            then
              mnuBack.Caption := _('Zurck zum Arbeitsplatz');

          end;

          if (ppmTools.PopupComponent.Tag = tagThumbnailMView) then
          begin
            mnuDelete.Action := prev.actDeletePages;
            mnuDelete.Visible := (prev.actDeletePages <> nil) and prev.actDeletePages.Enabled;
          end else
          begin
            mnuDelete.Action := prev.actDeleteSelected;
            mnuDelete.Visible := (prev.actDeleteSelected <> nil) and prev.actDeleteSelected.Enabled
          end;
        end
        else
        begin
          mnuBack.Visible := False;
          mnuDelete.Action := prev.actDeleteSelected;
          mnuDelete.Visible := (prev.actDeleteSelected <> nil) and prev.actDeleteSelected.Enabled;
        end;
      end else
      begin
        mnuBack.Visible := False;
        mnuDelete.Action := prev.actDeleteSelected;
        mnuDelete.Visible := (prev.actDeleteSelected <> nil) and prev.actDeleteSelected.Enabled;
      end;

      if (bitfarmApp.CurrentContainer.Count > 0) and
         (bitfarmApp.CurrentContainer[0].SymbolicArcID > -1) and
         (bitfarmApp.CurrentContainer[0].SymbolicArcID <> bitfarmApp.CurrentContainer[0].arcid) then
      begin
        mnuGoToSourceArchive.Visible := ((bitfarmApp.CurrentContainer.Count > 0) and
          (bitfarmApp.CurrentContainer[0].SymbolicArcID > 0) and
          (aSysArc[bitfarmApp.CurrentContainer[0].SymbolicArcID].arcid <> 0) and
          (aSysArc[bitfarmApp.CurrentContainer[0].SymbolicArcID].Rights <> 0));
        // SJ 11.10.2022 - bfacrm:ticket__show__31223 - unntig weil Action am Menpunkt hngt
//        mnuGoToSourceArchive.Caption := Self.actGoToSourceArchive.Caption; // 10/21/2020 bfacrm:ticket__show__24751

      end
      //-->              bfacrm:ticket__show__23235
      else if (bitfarmApp.CurrentContainer.Count > 0) and (prev.ActiveDoc <> nil) and
              ((bitfarmApp.CurrentContainer[0].ArcID = prev.ActiveDoc.ArcID) and
               (bitfarmApp.CurrentArchive.Arcid = prev.ActiveDoc.ArcID)) and
              (bitfarmApp.CurrentView = tvkViewer)
      then
        mnuGoToSourceArchive.Enabled := False
      else
      begin
        mnuGoToSourceArchive.Visible := True;
        // SJ 11.10.2022 - bfacrm:ticket__show__31223 - unntig weil Action am Menpunkt hngt
//        mnuGoToSourceArchive.Enabled := True;
//        mnuGoToSourceArchive.Caption := Self.actGoToSourceArchive.Caption;
      end;

//      mnuSymLinkImImporter.Action := Self.actGoToOriginalDocument;
      mnuSingleSave.Action := prev.bfaTlbStandard.tlbStandardSubmenuItemSave.Action;
      mnuSingleEmail.Action := prev.bfaTlbStandard.tlbStandardSubmenuItemEmail.Action;
      mnuSinglePrint.Action := prev.bfaTlbStandard.tlbStandardSubmenuItemPrint.Action;
      mnuSingleClipboard.Action := prev.bfaTlbStandard.tlbStandardSubmenuItemClipboard.Action;
      mnuGroup.Action := Self.actWPGroup;
      mnuUnGroup.Action := Self.actWPUnGroup;

      hasMultiPageDocument := False;
      for var i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
      begin
        if (bitfarmApp.CurrentContainer[i].PageCount > 1) then
        begin
          hasMultiPageDocument := True;
          Break;
        end;
      end;
      actWPUnGroup.Enabled := (prev.PreviewKind = pvkMulti) and hasMultiPageDocument;

      if (prev <> bitfarmApp.PreviewContainer.WorkplaceItem.Preview) and
         (prev <> bitfarmApp.PreviewContainer.ImporterItem.Preview) then
      begin
        mnuCreateCopy.Visible := False;
        mnuGroup.Visible := False;
        mnuUnGroup.Visible := False;
        mnuSendTo.Visible := True;
        TBSeparatorItem5.Visible := True;
        mnuDocToWorkplace.Action := prev.actSendDocumentsToWorkplace;
        mnuSendCopyToWorkplace.Action := prev.actSendCopyToWorkplace;
        mnuSendCopyToWorkplace.Caption := _('Kopie an Arbeitsplatz senden');
        if (prev.ActiveDoc <> nil) then
        begin
          mnuDocToWorkplace.visible := (prev.ActiveDoc <> nil) and (prev.ActiveDoc.ID <> -1);
          mnuSendCopyToWorkplace.visible := (prev.ActiveDoc <> nil) and (prev.ActiveDoc.ID <> -1);
        end;
        TBSeparatorItem1.Visible := True;
        mnuDocToImporter.Action := prev.actSendDocumentsToImporter;
        mnuDocPreviewToImporter.Action := prev.actSendDocumentPreviewsToImport;
        if prev.PreviewKind <> pvkMulti then
        begin
          mnuPagesToWorkplace.Action := prev.actSendPagesToWorkplace;
          mnuPagesToWorkplaceasOneDoc.Action := prev.actSendPagesMergedToWorkplace;
          if (prev.ActiveDoc <> nil) then
          begin
            mnuPagesToWorkplace.Visible := (prev.ActiveDoc <> nil) and
              (prev.ActiveDoc.ID <> -1);
            mnuPagesToWorkplaceasOneDoc.Visible := (prev.ActiveDoc <> nil) and
              (prev.ActiveDoc.ID <> -1);
          end;
          mnuPagesToImporter.Visible := True;
          mnuPagesToImporterasOneDoc.Visible := True;
          mnuPagesToImporter.Action := prev.actSendPagesToImporter;
          mnuPagesToImporterasOneDoc.Action := prev.actSendPagesMergedToImporter;
        end else
        begin
          mnuPagesToWorkplace.Visible := False;
          mnuPagesToWorkplaceasOneDoc.Visible := False;
          mnuPagesToImporter.Visible := False;
          mnuPagesToImporterasOneDoc.Visible := False;
        end;
      end
      else if (prev = bitfarmApp.PreviewContainer.WorkplaceItem.Preview) then
      begin
        mnuCreateCopy.Action := actCreateCopy;
        mnuCreateCopy.Visible := (bitfarmApp.CurrentContainer.Count > 0) and
          (bitfarmApp.CurrentContainer[0].ID <> -1);
        mnuGroup.Visible := True;
        mnuUnGroup.Visible := True;
        mnuSendTo.Visible := True;
        TBSeparatorItem5.Visible := True;
        mnuDocToWorkplace.Visible := False;
        mnuSendCopyToWorkplace.Visible := False;
        TBSeparatorItem1.Visible := False;
        mnuDocToImporter.Action := prev.actSendDocumentsToImporter;
        mnuDocPreviewToImporter.Action := prev.actSendDocumentPreviewsToImport;
        if prev.PreviewKind <> pvkMulti then
        begin
          mnuPagesToWorkplace.Action := nil;
          mnuPagesToWorkplaceasOneDoc.Action := nil;
          mnuPagesToWorkplace.Visible := False;
          mnuPagesToWorkplaceasOneDoc.Visible := False;
          mnuPagesToImporter.Visible := True;
          mnuPagesToImporterasOneDoc.Visible := True;
          mnuPagesToImporter.Action := prev.actSendPagesToImporter;
          mnuPagesToImporterasOneDoc.Action := prev.actSendPagesMergedToImporter;
        end
        else
        begin
          mnuPagesToWorkplace.Visible := False;
          mnuPagesToWorkplaceasOneDoc.Visible := False;
          mnuPagesToImporter.Visible := False;
          mnuPagesToImporterasOneDoc.Visible := False;
        end;
      end else
      begin
        mnuCreateCopy.Visible := False;
        if (prev = bitfarmApp.PreviewContainer.ImporterItem.Preview) then
        begin
          mnuGroup.Visible := True;
          mnuUnGroup.Visible := True;
        end else
        begin
          mnuGroup.Visible := False;
          mnuUnGroup.Visible := False;
        end;
        mnuSendTo.Visible := False;
        TBSeparatorItem5.Visible := False;
      end;

      mnuExport.Visible := (prev.ActiveDoc <> nil) and (prev.ActiveDoc.ID <> -1);
      mnuPlugins.Visible := (mnuPlugins.Count > 0) and
        ((prev.ActiveDoc <> nil) and (prev.ActiveDoc.ID <> -1)) and (prev.PreviewKind = pvkSingle)
        and not bitfarmApp.OfflineMode;
      CreateOcrMenu;
      mnuOCRAddfields.visible := prev.tbi_rangeocr.checked and
       prev.SingleView.img_DocView.Selected and
       (bitfarmApp.GetActivePreview.ActiveDoc <> nil) and
       ((bitfarmApp.GetActivePreview.PreviewKind = pvkSingle) or
       (bitfarmApp.GetActivePreview.PreviewKind = pvkMultiSingle));

      if mnuOCRAddfields.visible then
      begin
        if prev.tbi_rangeocr.checked and prev.SingleView.img_DocView.Selected then
        begin
          selrect := Rect(prev.SingleView.img_DocView.SelX1, prev.SingleView.img_DocView.SelY1,
            prev.SingleView.img_DocView.SelX2, prev.SingleView.img_DocView.SelY2);
          if PtInRect(selrect, selpos) then
            mnuOCRAddfields.Popup(mouse.X, mouse.Y, True);
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'ppmToolsPopup', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llNormal, 'ppmToolsPopup', ClassName);
  end;
end;

procedure TfrmGPL.CreateParams(var Params: TCreateParams);
begin
  inherited;
  StrCopy(Params.WinClassName, 'bitfarm.Viewer.V36');
  Params.ExStyle := Params.ExStyle or WS_EX_APPWINDOW; //24.10.2019
  SingleInst.CreateParams(Params);
end;

procedure TfrmGPL.ClickItemPopupMenu(Sender: TObject);
begin
  grdResultlistOnColSizing;
end;

procedure TfrmGPL.cxGridPopupMenu1MenuItemClick(ASender: TObject;
  AHitTest: TcxCustomGridHitTest; var AHandler: TNotifyEvent; AParams: TList;
  var AHandled: Boolean);
var
  LOperation: TcxGridPopupMenuOperation;
begin
  LOperation := (ASender as TcxGridPopupMenuItem).Operation;
  if (LOperation is TcxGridFooterSummaryOperation) then
  begin
//23.09.2021 Ticket 14736 Workaround von DevExpress, weil hier nocht nicht mglich  die
//  FooterItem zu erkennen, deswegen muss nachher ein eigenes Method aufruf sein
    AHandler(ASender);
    AHandled := true;
    AHandler := ClickItemPopupMenu;
  end;
end;

procedure TfrmGPL.cxGridPopupMenu1Popup(ASenderMenu: TComponent;
  AHitTest: TcxCustomGridHitTest; X, Y: Integer; var AllowPopup: Boolean);

  function IsItemsExists(AMenu: TcxGridStdHeaderMenu): Boolean;
  var
    I: Integer;
  begin
    Result := False;
    with AMenu.Items do
      for I := 0 to Count - 1 do
        if (Items[I].Name = 'itmCopyToClbrd') (*or (Items[I].Name = 'CollapseItem')*) then
        begin
          Result := True;
          System.Break;
        end;
  end;


var
  s, selpos2 : TPoint;
  selrect : TRect;
  AItem : TMenuItem;
begin
  try
    if (ASenderMenu is TcxGridStdHeaderMenu) or
       (ASenderMenu is TcxGridStdGroupByBoxMenu) or
       (ASenderMenu is TcxGridStdGroupRowMenu)
// 29.07.2021 muss berprfen...       or         (ASenderMenu is TcxGridStdFooterMenu)
    then
    begin
      S.X := X;
      S.Y := Y;
      selpos2 := grdResultlistDevEx.ScreenToClient(s);

      popFilterBar.Popup(X, Y);
      AllowPopup := False;
    end
    else if (ASenderMenu is TcxGridStdFooterMenu) then
    begin
//04.03.2022{ TODO :  } Wir knnen noch berlegen, ob wir das noch brauchen...
//      if not IsItemsExists(TcxGridStdHeaderMenu(ASenderMenu)) then
//        with TcxGridStdHeaderMenu(ASenderMenu) do
//        begin
//          AItem := TMenuItem.Create(Self);
//          AItem.Caption := _('Copy');
//          AItem.Visible := True;
//          AItem.Name := 'itmCopyToClbrd';
//          AItem.OnClick := DoItemClick;
//          Items.Add(AItem);
//        end;
    end;
  except

  end;
end;

procedure TfrmGPL.DoItemClick(Sender: TObject);
begin
//04.03.2022  ShowMessage(TMenuItem(Sender).Caption);
end;

procedure TfrmGPL.WndProc(var Msg: TMessage);
begin
  if not SingleInst.HandleMessages(Msg) then
    inherited;
end;

procedure TfrmGPL.HandleParam(const Params: TStringList);
var
  UserAction: PUserAction;
  i: Integer;
begin
  try
    UserAction := bitfarmApp.CreateUserAction;
    UserAction^.ActionName := 'actHandleParam';
    for i := 0 to Params.Count -1 do
      UserAction^.Params.Add(Params[i]);
    bitfarmApp.MainThread.Add(UserAction);
  except
    bitfarmLog.Write(llNormal, ltException, 'HandleParam', ClassName);
  end;
end;

procedure TfrmGPL.CreateOcrMenu;
var
  TmpMnu: TSpTBXItem;
  i: Integer;
  SeparatorItem: TTBSeparatorItem;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateOcrMenu', Classname);
  try
    try
      mnuOCRAddfields.Clear;

      // <!-- SJ 30.07.2021 - bfacrm:ticket__show__27988
      TmpMnu := TSpTBXItem.Create(mnuOCRAddfields);
      TmpMnu.Caption := _('Suchen im Dokument');
      TmpMnu.Enabled := True;
      TmpMnu.Visible := True;
      TmpMnu.OnClick := bitfarmApp.OCRResultToSearchToolbar;
      TmpMnu.Hint := _('Kopiert das OCR-Ergebnis in die Suchtoolbar');
      TmpMnu.Options := TmpMnu.Options + [tboShowHint];
      TmpMnu.Images := bfaIcons.ilMainMenu;
      TmpMnu.ImageIndex := Integer(icoidx_search);
      mnuOCRAddfields.Add(TmpMnu);

      //08.05.2024 SD neuer Menpunkt -->bfacrm:ticket__show__38698
      TmpMnu := TSpTBXItem.Create(mnuOCRAddfields);
      TmpMnu.Caption := _('ber kompletten Baum suchen');
      TmpMnu.Enabled := True;
      TmpMnu.Visible := True;
      TmpMnu.OnClick := bitfarmApp.OCRResultToGeneralSearchInTree;
      TmpMnu.Hint := _('Sucht ber den gesamten Baum');
      TmpMnu.Options := TmpMnu.Options + [tboShowHint];
      TmpMnu.Images := bfaIcons.ilMainMenu;
      TmpMnu.ImageIndex := Integer(icoidx_tree);
      mnuOCRAddfields.Add(TmpMnu);
      //08.05.2024 SD <--bfacrm:ticket__show__38698

      TmpMnu := TSpTBXItem.Create(mnuOCRAddfields);
      TmpMnu.Caption := _('Suchen im Archiv');
      TmpMnu.Enabled := True;
      TmpMnu.Visible := True;
      TmpMnu.OnClick := bitfarmApp.OCRResultToGeneralSearch;
      TmpMnu.Hint := _('Sucht im aktuellen Archiv ber die generelle Suche');
      TmpMnu.Options := TmpMnu.Options + [tboShowHint];
      TmpMnu.Images := bfaIcons.ilMainMenu;
      TmpMnu.ImageIndex := Integer(icoidx_folder_open);
      mnuOCRAddfields.Add(TmpMnu);
      // SJ 30.07.2021 - bfacrm:ticket__show__27988 -->

      TmpMnu := TSpTBXItem.Create(mnuOCRAddfields);
      TmpMnu.Caption := _('Zwischenablage');
      TmpMnu.Enabled := True;
      TmpMnu.Visible := True;
      TmpMnu.OnClick := bitfarmApp.CopyOCRResultToClipbrd;
      TmpMnu.Hint := _('Kopiert das OCR-Ergebnis in die Zwischenablage');
      TmpMnu.Options := TmpMnu.Options + [tboShowHint];
      TmpMnu.Images := bfaIcons.ilMainMenu;
      TmpMnu.ImageIndex := Integer(icoidx_clipboard);
      mnuOCRAddfields.Add(TmpMnu);

      TmpMnu := TSpTBXItem.Create(mnuOCRAddfields);
      TmpMnu.Caption := _('Schlagwort');
      TmpMnu.Enabled := bitfarmApp.GetActivePreview.ActiveDoc.InEditMode;
      TmpMnu.Visible := True;
      TmpMnu.OnClick := bitfarmApp.CopyOCRResultToSlw;
      if not bitfarmApp.GetActivePreview.ActiveDoc.InEditMode then
        TmpMnu.Hint := _('Bearbeiten-Modus erforderlich.') + #13#10 + _('Kopiert das OCR-Ergebnis in die Schlagwrter')
      else
      TmpMnu.Hint := _('Kopiert das OCR-Ergebnis in die Schlagwrter');
      TmpMnu.Options := TmpMnu.Options + [tboShowHint];
      TmpMnu.Images := bfaIcons.ilMainMenu;
      TmpMnu.ImageIndex := Integer(icoidx_tag_edit);
      mnuOCRAddfields.Add(TmpMnu);

      if (bitfarmApp.GetActivePreview.ActiveDoc <> nil) and
        (bitfarmApp.CurrentView <> tvkWorkplace) then
      begin
        SeparatorItem := TTBSeparatorItem.Create(mnuOCRAddfields);
        mnuOCRAddfields.Add(SeparatorItem);

        TmpMnu := TSpTBXItem.Create(mnuOCRAddfields);
        TmpMnu.Caption := _('Zusatzfelder:');
        TmpMnu.Enabled := False;
        mnuOCRAddfields.Add(TmpMnu);

        for i := 0 to scrbxViewerAddfields.ComponentCount - 1 do
        begin
          if scrbxViewerAddfields.Components[i] is TBfaAddfieldComp then
          begin
            TmpMnu := TSpTBXItem.Create(mnuOCRAddfields);
            TmpMnu.Caption := TBfaAddfieldComp(scrbxViewerAddfields.Components[i]).Dispname;
            TmpMnu.Enabled := True;
            TmpMnu.Visible := True;
            TmpMnu.OnClick := bitfarmApp.CopyOCRResultToAddField;
            TmpMnu.ImageIndex := -1;
            mnuOCRAddfields.Add(TmpMnu);
          end;
        end;
      end;

      mnuOCRAddfields.Visible := False;

    except
      bitfarmLog.Write(llNormal, ltException, 'CreateOcrMenu', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateOcrMenu', Classname);
  end;
end;

procedure TfrmGPL.ChangeSkin(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'ChangeSkin', Classname);
  try
    try
      if fAppStarted then
      begin
        //25.01.2023 bfacrm:ticket__show__33644 --> Verursacht sonst doppelter Aufruf
        if not bitfarmApp.ChangeSkinRunning then
        begin
          bitfarmApp.ChangeSkinRunning := True;
        //25.01.2023 bfacrm:ticket__show__33644 <--
        UserAction := bitfarmApp.CreateUserAction;
        UserAction^.ActionName := 'actChangeSkin';
        bitfarmApp.MainThread.Add(UserAction);
        end;
      end
      else
        bitfarmApp.DoChangeSkin;
    except
      bitfarmLog.Write(llNormal, ltException, 'ChangeSkin', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ChangeSkin', Classname);
  end;
end;

function TfrmGPL.checkBookmark(tvSelected: TTreeNode; obj: TbfaSearch; isGlobal: Boolean): Boolean;
var
  archivOkay : Boolean;
  idx: Integer;
begin
  Result := False;
  archivOkay := False;
  try
    if (isGlobal) then
    begin
      //globales Lesezeichen
      //check ob Archiv passt
      if ((((obj.ArcID <> nil) and
        (obj.ArcID.Count > 0) and
        obj.ArcID.Find(IntToStr(pBfaInt64(tvSelected.Data).Value), Idx))) or
        (obj.SelectedArcID = pBfaInt64(tvSelected.Data).Value)) or
        (obj.SelectedArcID <= 0) then   //'Alle Archive' und 'aktuelles Archiv' Lesezeichen
        archivOkay := True;
    end else
    begin
      //globales Lesezeichen
      //check ob Archiv passt
      if (obj.ArcID.Find(IntToStr(pBfaInt64(tvSelected.Data).Value), Idx)) or
        (obj.SelectedArcID = pBfaInt64(tvSelected.Data).Value) or
        (obj.SelectedArcID = 0) then  //'aktuelles Archiv' Lesezeichen
         archivOkay := True;
    end;
    if (archivOkay) then
    begin
      Result := True;
      if obj.userid > 0 then
      begin
        if not bitfarmApp.User.HolidayList.Find(IntToStr(obj.userid), Idx) then
          Result := False;
      end
      else if obj.groupid > -1 then
      begin
        if not bitfarmApp.User.GroupList.Find(IntToStr(obj.groupid), Idx) then
          Result := False;
      end;
    end;
  except
    Result := False;
    bitfarmLog.Write(llNormal, ltException, 'checkBookmark', Classname);
  end;
end;

procedure TfrmGPL.WMSize(var Msg: TMessage);
var
  i: Integer;
begin
  try
    inherited;
    if (bitfarmApp <> nil) and (not bitfarmApp.ClosingMainForm) and (Msg.WParam = SIZE_MAXIMIZED) and
      (bitfarmApp.PreviewContainer <> nil) then
    begin
      for i := 0 to bitfarmApp.PreviewContainer.Containers.Count - 1 do
      begin
        if (not bitfarmApp.PreviewContainer.Containers[i].Preview.Floating) and
           ((bitfarmApp.PreviewContainer.Containers[i].Preview.PreviewKind = pvkSingle) or
           (bitfarmApp.PreviewContainer.Containers[i].Preview.PreviewKind = pvkMultiSingle)) then
          bitfarmApp.PreviewContainer.Containers[i].Preview.bfaTlbPreview.sbmAutozoom.Click;
      end;
    end;
    //27.05.2024 SD -->bfacrm:ticket__show__38630
    if (bitfarmApp <> nil) and (not bitfarmApp.ClosingMainForm) and (dckTreeView <> nil) and (Msg.WParam = SIZE_RESTORED) then
    if frmMainForm.Width < (dckTreeView.width + pnlSearchOptions.Width + 48) then
    begin
        if dckTreeView.width > Round((frmMainForm.Width - 48) / 3) then
          dckTreeView.width := Round((frmMainForm.Width - 48) / 3);
        pnlSearchOptions.Width := Round((frmMainForm.Width - (dckTreeView.width + 48)) / 2);
    end;
    //27.05.2024 SD <--bfacrm:ticket__show__38630
  except
    bitfarmLog.Write(llNormal, ltException, 'TfrmGPL.WMSize', Classname);
  end;
end;

//03.06.2024 SD -->bfacrm:ticket__show__38630
//Wenn die Monitoreinstellungen gendert werden oder der Monitor abgetrennt wird,
//werden getrennte Fenster (Panels) an das Hauptform angedockt
procedure TfrmGPL.WMDisplayChange(var Msg: TMessage);
begin
  try
    inherited;
    if (Screen.MonitorCount > 1) then
    begin
      if SpTBXDockablePanel3.Floating then
      begin
        SpTBXDockablePanel3.Floating := False;
        SpTBXDockablePanel3.Parent := dckTreeView;
      end;
      if pnlSearchOptions.Floating then
      begin
        pnlSearchOptions.Floating := False;
        pnlSearchOptions.Parent := SpTBXMultiDock2;
      end;
    end;
    LoadBookmarks;  //10.09.2024 SD -->bfacrm:ticket__show__34654 & 39318
  except
    bitfarmLog.Write(llNormal, ltException, 'TfrmGPL.WMDisplayChange', ClassName);
  end;
end;
//03.06.2024 SD <--bfacrm:ticket__show__38630

procedure TfrmGPL.actReOCRExecute(Sender: TObject);
var
  UserAction : PUserAction;
//  infomsg, msg : string;
//  doreocr : Boolean;
//  i, revcnt, notrevcnt : Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'actReOCRExecute - ', Classname);
  try
    try
//      infomsg := '';
//      revcnt := 0;
//      notrevcnt := 0;
//      if bitfarmApp.SVNInfo then
//      begin
//        for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
//          if bitfarmApp.CurrentContainer[i].revsave then
//            inc(revcnt);
//        if revcnt > 0 then
//          BfShowMessage(_('In der Auswahl waren revisionssichere Dokumente.\nNeue' +
//                          ' Versionen werden nur fr nicht-revisionssichere Dokumente angelegt.' +
//                          '\n(Aktualisiert werden aber alle Dokumente.)'));
//
//      end;
//      infomsg := ParseSQLString(infomsg);

      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actReOCR';
      UserAction^.Params.Add(''); //(infomsg);
      UserAction^.Params.Add(bitfarmApp.User.Name);

      for var i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
      begin
        UserAction^.Params.Add(InttoStr(bitfarmApp.CurrentContainer[i].ID));
      end;

      bitfarmApp.BackThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'actReOCRExecute - ', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'actReOCRExecute - ', Classname);
  end;
end;

procedure TfrmGPL.DisableMainFormActions;
begin
  //Self
  bitfarmLog.DebugBegin(llDebug, 'DisableMainFormActions', Classname);
  try
    try
      Self.actInProgress.Enabled := False;
      Self.actIsAuditProof.Enabled := False;
      Self.actEditTags.Enabled := False;
      Self.actCreateBookmarkForGDocID.Enabled := False;
      Self.mnuBookmarks.Enabled := False; // Keine Action;
      Self.actGoToSourceArchive.Enabled := False;
      Self.actPreviousPage.Enabled := False;
      Self.actNextPage.Enabled := False;
      Self.actFirstPage.Enabled := False;
      Self.actLastPage.Enabled := False;
      Self.actAutozoom.Enabled := False;
      Self.actZoom100.Enabled := False;
      Self.actZoomPage.Enabled := False;
      Self.actZoomWidth.Enabled := False;
      Self.actZoomHeight.Enabled := False;
      Self.actZoomSelect.Enabled := False;
      Self.actZoomOff.Enabled := False;
      Self.actRotateLeft.Enabled := False;
      Self.actRotateRight.Enabled := False;
      Self.actFlip.Enabled := False;
      Self.actDeleteSelected.Enabled := False;
      Self.actDeletePages.Enabled := False;
      Self.actPublicAnno.Enabled := False;
      Self.actPrivateAnno.Enabled := False;
      Self.actPrintStandard.Enabled := False;
      Self.actPrintSelect.Enabled := False;
      Self.actPrintPreview.Enabled := False;
      Self.actStationery.Enabled := False;
      Self.actLocalSavePDF.Enabled := False;
      Self.actLocalSaveTIF.Enabled := False;
      Self.actLocalSaveOriginal.Enabled := False;
      Self.actLocalSaveLink.Enabled := False;
      Self.actLocalSavePreview.Enabled := False;
      Self.actEmailPreview.Enabled := False;
      Self.actEmailTIFAttachment.Enabled := False;
      Self.actEmailPDFAttachment.Enabled := False;
      Self.actEmailOriginal.Enabled := False;
      Self.actEmailLink.Enabled := False;
      //29.07.2022 Ticket 28973 -->
      Self.actSaveCollectionPDF.Enabled := False;
      Self.actSaveCollectionSinglePDF.Enabled := False;
      Self.actSaveCollectionTIF.Enabled := False;
      Self.actSaveCollectionOriginal.Enabled := False;
      Self.actEmailCollectionPDF.Enabled := False;
      Self.actEmailCollectionSinglePDF.Enabled := False;
      Self.actEmailCollectionTIF.Enabled := False;
      Self.actEmailCollectionOriginal.Enabled := False;
      //29.07.2022 Ticket 28973 <--
      Self.actSendDocumentsToWorkplace.Enabled := False;
      Self.actSendCopyToWorkplace.Enabled := False;
      Self.actSendPagesToWorkplace.Enabled := False;
      Self.actCreateCopy.Enabled := False;
      Self.actSendPagesMergedToWorkplace.Enabled := False;
      Self.actSendDocumentsToImporter.Enabled := False;
      Self.actSendDocumentPreviewsToImport.Enabled := False;
      Self.actSendPagesToImporter.Enabled := False;
      Self.actSendPagesMergedToImporter.Enabled := False;
      Self.actInverted.Enabled := False;
      Self.actDeScrew.Enabled := False;
      Self.actDeSpeckle.Enabled := False;
      Self.actRemoveBorder.Enabled := False;
      Self.actShareLayer.Enabled := False;
      Self.actDeleteDoc.Enabled := False;
      Self.actAuditProof.Enabled := False;
      Self.actCreateSymbolicLinkInImporter.Enabled := False;
      Self.actGoToOriginalDocument.Enabled := False;
      Self.actEditTags.Enabled := False;
      Self.actCopyDocToClipboard.Enabled := False;
      Self.actCopyOriginalDocToClipboard.Enabled := False;
      Self.actCopyPageToClipboard.Enabled := False;
      Self.actCopyDocLinkToClipboard.Enabled := False;
      Self.actMergeDoc.Enabled := False;
      Self.actWPGroup.Enabled := False;
      Self.actWPUnGroup.Enabled := False;
//      Self.actChangeDocName.Enabled := False; //bfacrm:ticket__show__30572
      Self.actResubCreate.Enabled := False;
      Self.fraResub.btnResubCancel.Enabled := False;
      Self.actRefreshDoc.Enabled := False;
      Self.mnuExportMeta.Enabled := false; // Das ist ein bergeordnetes Menu ohne Action
      Self.mnuExportMeta.Enabled := False;          // Das ist ein bergeordnetes Menu ohne Action
      Self.actExportCSV.Enabled := False;
      Self.actExportXLS.Enabled := False;
      Self.actExportOO.Enabled := False;
      Self.actAutoRef.Enabled := False;
      Self.actNewLink.Enabled := False;
      Self.actAddLink.Enabled := False;
      Self.actRestoreOriginal.Enabled := False;
      Self.actDuplicateDoc.Enabled := False;
      Self.mnuInverted.Enabled := False;
      Self.mnuDeScrew.Enabled := False;
      Self.mnuDeSpeckle.Enabled := False;
      Self.mnuRemoveBorder.Enabled := False;
      Self.mnuRestoreOriginal.Enabled := False;
      Self.mnuRefreshDoc.Enabled := False;
      Self.mnuCreateEmptyDoc.Enabled := False;
      Self.mnuDeleteDoc.Enabled := False;
      Self.mnuAuditProof.Enabled := False;
      Self.mnuExportCSV.Enabled := False;
      Self.mnuExportXLS.Enabled := False;
      Self.mnuExportOO.Enabled := False;
      Self.actRangeOCR.Enabled := False;
      Self.mnuNewLink.Enabled := False;
      Self.mnuAutoRef.Enabled := False;
      Self.mnuAddLink.Enabled := False;
      Self.mnuDelete.Enabled := False;
      Self.mnuChangeDocName.Enabled := False;
      Self.actScrollLeft.Enabled := False;
      Self.actScrollRight.Enabled := False;
      Self.actScrollUp.Enabled := False;
      Self.actScrollDown.Enabled := False;
      Self.actUndockInNewTab.Enabled := False;
      Self.actUndockInNewWindow.Enabled := False;

      Self.actFtxPos.Enabled := False;
      {$IFDEF ENTERPRISE}
      TfrmEnterprise(Self).actDocAbo.Enabled := False;
      Self.actDeleteSymbolicLink.Enabled := False;
      Self.actShowAllSymbolicLinks.Enabled := False;
      {$ENDIF}

      if Self.bfaTlbPreview1.mnuPublicAnno <> nil then
        Self.bfaTlbPreview1.mnuPublicAnno.Enabled := False;
      if Self.bfaTlbPreview1.mnuPrivateAnno <> nil then
        Self.bfaTlbPreview1.mnuPrivateAnno.Enabled := False;
      if Self.bfaTlbPreview1.mnuStationery <> nil then
        Self.bfaTlbPreview1.mnuStationery.Enabled := False;
      if Self.bfaTlbPreview1.sbmStationery <> nil then
        Self.bfaTlbPreview1.sbmStationery.Enabled := False;
      if Self.bfaTlbPreview1.mnuFtxPos <> nil then
        Self.bfaTlbPreview1.mnuFtxPos.Enabled := False;
      if Self.bfaTlbPreview1.mnuPreviousPage <> nil then
        Self.bfaTlbPreview1.mnuPreviousPage.Enabled := False;
      if Self.bfaTlbPreview1.mnuNextPage <> nil then
        Self.bfaTlbPreview1.mnuNextPage.Enabled := False;
      if Self.bfaTlbPreview1.sbmAutozoom <> nil then
        Self.bfaTlbPreview1.sbmAutozoom.Enabled := False;
      if Self.bfaTlbStandard1.tlbStandardEditTags <> nil then
        Self.bfaTlbStandard1.tlbStandardEditTags.Enabled := False;
      if Self.bfaTlbStandard1.tlbStandardAutoRef <> nil then
        Self.bfaTlbStandard1.tlbStandardAutoRef.Enabled := False;
      if Self.bfaTlbStandard1.tlbStandardNewLink <> nil then
        Self.bfaTlbStandard1.tlbStandardNewLink.Enabled := False;
      if Self.bfaTlbStandard1.tlbStandardAddLink <> nil then
        Self.bfaTlbStandard1.tlbStandardAddLink.Enabled := False;
      if Self.bfaTlbStandard1.tlbStandardRotateLeft <> nil then
        Self.bfaTlbStandard1.tlbStandardRotateLeft.Enabled := False;
      if Self.bfaTlbStandard1.tlbStandardRotateRight <> nil then
        Self.bfaTlbStandard1.tlbStandardRotateRight.Enabled := False;
      if Self.bfaTlbStandard1.tlbStandardFlip <> nil then
        Self.bfaTlbStandard1.tlbStandardFlip.Enabled := False;
      if Self.bfaTlbStandard1.tlbStandardDeletePage <> nil then
        Self.bfaTlbStandard1.tlbStandardDeletePage.Enabled := False;

    except
      bitfarmLog.Write(llNormal, ltException, 'DisableMainFormActions', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'DisableMainFormActions', Classname);
  end;
end;

procedure TfrmGPL.CreateActions(aList, aList2: TActionList; CreateActions: Boolean = True);
var
  i: Integer;
begin
  if not CreateActions then
    bitfarmLog.DebugBegin(llDebug, 'CreateActions - only Translations', Classname)
  else
    bitfarmLog.DebugBegin(llDebug, 'CreateActions', Classname);
  try
    try
      if CreateActions then
        actQuit := TAction.Create(aList);
      with actQuit do
      begin
        if CreateActions then
        begin
          Name := 'actQuit';
          Enabled := False;
          ImageIndex := Integer(icoidx_switch);
          ActionList := aList;
          OnExecute := actQuitExecute;
        end;
        Caption := sCaptionActQuit;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actQuit, sSysGnuViewerDomain);

      if CreateActions then
        actInResub := TAction.Create(aList);
      with actInResub do
      begin
        if CreateActions then
        begin
          Name := 'actInResub';
          Enabled := True;
          ImageIndex := -1;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActInResub;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actInResub, sSysGnuViewerDomain);

      if CreateActions then
        actRelogin := TAction.Create(aList);
      with actRelogin do
      begin
        if CreateActions then
        begin
          Name := 'actRelogin';
          Enabled := False;
          ImageIndex := Integer(icoidx_relog);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActRelogin;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actRelogin, sSysGnuViewerDomain);

      if CreateActions then
        actCreateEmptyDoc := TAction.Create(aList);
      with actCreateEmptyDoc do
      begin
        if CreateActions then
        begin
          Name := 'actCreateEmptyDoc';
          Enabled := False;
          ImageIndex := Integer(icoidx_document_create_empty);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActCreateEmptyDoc;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actCreateEmptyDoc, sSysGnuViewerDomain);

      if CreateActions then
        actChangePassword := TAction.Create(aList);
      with actChangePassword do
      begin
        if CreateActions then
        begin
          Name := 'actChangePassword';
          Enabled := False;
          ImageIndex := Integer(icoidx_edit_password);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Hint := sEmptyString;
        Caption := sCaptionActChangePassword;
      end;
      if CreateActions then
        TranslateComponent(actChangePassword, sSysGnuViewerDomain);

      if CreateActions then
        actScanOptions := TAction.Create(aList);
      with actScanOptions do
      begin
        if CreateActions then
        begin
          Name := 'actScanOptions';
          Enabled := False;
          ImageIndex := Integer(icoidx_scan_settings);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sHintActScanOptions;
      end;
      if CreateActions then
        TranslateComponent(actScanOptions, sSysGnuViewerDomain);

      if CreateActions then
        actOptions := TAction.Create(aList);
      with actOptions do
      begin
        if CreateActions then
        begin
          Name := 'actOptions';
          Enabled := False;
          ImageIndex := Integer(icoidx_settings);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActOptions;
        Hint := sHintActOptions;
      end;
      if CreateActions then
        TranslateComponent(actOptions, sSysGnuViewerDomain);

      if CreateActions then
        actViewNavigation := TAction.Create(aList);
      with actViewNavigation do
      begin
        if CreateActions then
        begin
          Name := 'actViewNavigation';
          ImageIndex := Integer(icoidx_tree);
          Enabled := False;
          ActionList := aList;
          OnExecute := actViewNavigationExecute;
        end;
        Caption := sCaptionActViewNavigation;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actViewNavigation, sSysGnuViewerDomain);

      if CreateActions then
        actViewSearchOptions := TAction.Create(aList);
      with actViewSearchOptions do
      begin
        if CreateActions then
        begin
          Name := 'actViewSearchOptions';
          ImageIndex := Integer(icoidx_fields);
          Enabled := False;
          ActionList := aList;
          OnExecute := actViewSearchOptionsExecute;
        end;
        Caption := sCaptionActViewSearchOptions;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actViewSearchOptions, sSysGnuViewerDomain);

      if CreateActions then
        actViewPreview := TAction.Create(aList);
      with actViewPreview do
      begin
        if CreateActions then
        begin
          Name := 'actViewPreview';
          ImageIndex := Integer(-1);
          Enabled := False;
          ActionList := aList;
          OnExecute := actViewPreviewExecute;
        end;
        Caption := sCaptionActViewPreview;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actViewPreview, sSysGnuViewerDomain);

      if CreateActions then
        actViewThumbnails := TAction.Create(aList);
      with actViewThumbnails do
      begin
        if CreateActions then
        begin
          Name := 'actViewThumbnails';
          ImageIndex := Integer(icoidx_thumbnail);
          Enabled := False;
  //        ShortCut := 16468;
          ActionList := aList;
          OnExecute := actViewThumbnailsExecute;
        end;
        Caption := sCaptionActViewThumbnails;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actViewThumbnails, sSysGnuViewerDomain);

      if CreateActions then
        actViewFloatingWVL := TAction.Create(aList);
      with actViewFloatingWVL do
      begin
        if CreateActions then
        begin
          Name := 'actViewFloatingWVL';
          Enabled := False;
          ImageIndex := Integer(icoidx_resubmission_view);
          ActionList := aList;
          OnExecute := actViewFloatingWVLExecute;
        end;
        Caption := sCaptionActViewFloatingWVL;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actViewFloatingWVL, sSysGnuViewerDomain);

      if CreateActions then
        actDeleteColumnOrder := TAction.Create(aList);
      with actDeleteColumnOrder do
      begin
        if CreateActions then
        begin
          Name := 'actDeleteColumnOrder';
          Enabled := False;
          ImageIndex := Integer(icoidx_sorting_abort);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActDeleteColumnOrder;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actDeleteColumnOrder, sSysGnuViewerDomain);

      if CreateActions then
        actGetLastDocument := TAction.Create(aList);
      with actGetLastDocument do
      begin
        if CreateActions then
        begin
          Name := 'actGetLastDocument';
          Enabled := False;
          ShortCut := 16432; {Strg + 0}
          ImageIndex := Integer(icoidx_document_last);
          ActionList := aList;
          OnExecute := actGetLastDocumentExecute;
        end;
        Caption := sCaptionActGetLastDocument;
        Hint := sCaptionActGetLastDocument;
      end;
      if CreateActions then
        TranslateComponent(actGetLastDocument, sSysGnuViewerDomain);

      if CreateActions then
        actGetDoc1 := TAction.Create(aList);
      with actGetDoc1 do
      begin
        if CreateActions then
        begin
          Name := 'actGetDoc1';
          Enabled := False;
          ShortCut := 16433; {Strg + 1}
          ImageIndex := Integer(icoidx_document_reserved_view_1);
          ActionList := aList;
          OnExecute := actGetDoc1Execute;
        end;
        Caption := sCaptionActGetDoc1;
        Hint := sHintActGetDoc1;
      end;
      if CreateActions then
        TranslateComponent(actGetDoc1, sSysGnuViewerDomain);

      if CreateActions then
        actGetDoc2 := TAction.Create(aList);
      with actGetDoc2 do
      begin
        if CreateActions then
        begin
          Name := 'actGetDoc2';
          Enabled := False;
          ShortCut := 16434; {Strg + 2}
          ImageIndex := Integer(icoidx_document_reserved_view_2);
          ActionList := aList;
          OnExecute := actGetDoc2Execute;
        end;
        Caption := sCaptionActGetDoc2;
        Hint := sHintActGetDoc2;
      end;
      if CreateActions then
        TranslateComponent(actGetDoc2, sSysGnuViewerDomain);

      if CreateActions then
        actGetDoc3 := TAction.Create(aList);
      with actGetDoc3 do
      begin
        if CreateActions then
        begin
          Name := 'actGetDoc3';
          Enabled := False;
          ShortCut := 16435; {Strg + 3}
          ImageIndex := Integer(icoidx_document_reserved_view_3);
          ActionList := aList;
          OnExecute := actGetDoc3Execute;
        end;
        Caption := sCaptionActGetDoc3;
        Hint := sHintActGetDoc3;
      end;
      if CreateActions then
        TranslateComponent(actGetDoc3, sSysGnuViewerDomain);

      if CreateActions then
        actGetDoc4 := TAction.Create(aList);
      with actGetDoc4 do
      begin
        if CreateActions then
        begin
          Name := 'actGetDoc4';
          Enabled := False;
          ShortCut := 16436; {Strg + 4}
          ImageIndex := Integer(icoidx_document_reserved_view_4);
          ActionList := aList;
          OnExecute := actGetDoc4Execute;
        end;
        Caption := sCaptionActGetDoc4;
        Hint := sHintActGetDoc4;
      end;
      if CreateActions then
        TranslateComponent(actGetDoc4, sSysGnuViewerDomain);

      if CreateActions then
        actGetDoc5 := TAction.Create(aList);
      with actGetDoc5 do
      begin
        if CreateActions then
        begin
          Name := 'actGetDoc5';
          Enabled := False;
          ShortCut := 16437; {Strg + 5}
          ImageIndex := Integer(icoidx_document_reserved_view_5);
          ActionList := aList;
          OnExecute := actGetDoc5Execute;
        end;
        Caption := sCaptionActGetDoc5;
        Hint := sHintActGetDoc5;
      end;
      if CreateActions then
        TranslateComponent(actGetDoc5, sSysGnuViewerDomain);

      if CreateActions then
        actSetDoc1 := TAction.Create(aList);
      with actSetDoc1 do
      begin
        if CreateActions then
        begin
          Name := 'actSetDoc1';
          Enabled := False;
          ShortCut := 24625; {Strg + Shift + 1}
          ImageIndex := Integer(icoidx_document_reserve_1);
          ActionList := aList;
          OnExecute := actSetDoc1Execute;
        end;
        Caption := sCaptionActSetDoc1;
        Hint := sHintActSetDoc1;
      end;
      if CreateActions then
        TranslateComponent(actSetDoc1, sSysGnuViewerDomain);

      if CreateActions then
        actSetDoc2 := TAction.Create(aList);
      with actSetDoc2 do
      begin
        if CreateActions then
        begin
          Name := 'actSetDoc2';
          Enabled := False;
          ShortCut := 24626; {Strg + Shift + 2}
          ImageIndex := Integer(icoidx_document_reserve_2);
          ActionList := aList;
          OnExecute := actSetDoc2Execute;
        end;
        Caption := sCaptionActSetDoc2;
        Hint := sHintActSetDoc2;
      end;
      if CreateActions then
        TranslateComponent(actSetDoc2, sSysGnuViewerDomain);

      if CreateActions then
        actSetDoc3 := TAction.Create(aList);
      with actSetDoc3 do
      begin
        if CreateActions then
        begin
          Name := 'actSetDoc3';
          Enabled := False;
          ShortCut := 24627; {Strg + Shift + 3}
          ImageIndex := Integer(icoidx_document_reserve_3);
          ActionList := aList;
          OnExecute := actSetDoc3Execute;
        end;
        Caption := sCaptionActSetDoc3;
        Hint := sHintActSetDoc3;
      end;
      if CreateActions then
        TranslateComponent(actSetDoc3, sSysGnuViewerDomain);

      if CreateActions then
        actSetDoc4 := TAction.Create(aList);
      with actSetDoc4 do
      begin
        if CreateActions then
        begin
          Name := 'actSetDoc4';
          Enabled := False;
          ShortCut := 24628; {Strg + Shift + 4}
          ImageIndex := Integer(icoidx_document_reserve_4);
          ActionList := aList;
          OnExecute := actSetDoc4Execute;
        end;
        Caption := sCaptionActSetDoc4;
        Hint := sHintActSetDoc4;
      end;
      if CreateActions then
        TranslateComponent(actSetDoc4, sSysGnuViewerDomain);

      if CreateActions then
        actSetDoc5 := TAction.Create(aList);
      with actSetDoc5 do
      begin
        if CreateActions then
        begin
          Name := 'actSetDoc5';
          Enabled := False;
          ShortCut := 24629; {Strg + Shift + 5}
          ImageIndex := Integer(icoidx_document_reserve_5);
          ActionList := aList;
          OnExecute := actSetDoc5Execute;
        end;
        Caption := sCaptionActSetDoc5;
        Hint := sHintActSetDoc5;
      end;
      if CreateActions then
        TranslateComponent(actSetDoc5, sSysGnuViewerDomain);

      if CreateActions then
        actGraphicOptions := TAction.Create(aList);
      with actGraphicOptions do
      begin
        if CreateActions then
        begin
          Name := 'actGraphicOptions';
          Enabled := True;
          ImageIndex := Integer(icoidx_paint_settings);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionactGraphicOptions;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actGraphicOptions, sSysGnuViewerDomain);

      if CreateActions then
        actInfo := TAction.Create(aList);
      with actInfo do
      begin
        if CreateActions then
        begin
          Name := 'actInfo';
          Enabled := False;
          ImageIndex := Integer(icoidx_info);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActInfo;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actInfo, sSysGnuViewerDomain);

      if CreateActions then
        actSupport := TAction.Create(aList);
      with actSupport do
      begin
        if CreateActions then
        begin
          Name := 'actSupport';
          Enabled := False;
          ImageIndex := Integer(icoidx_help);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActSupport;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actSupport, sSysGnuViewerDomain);

      if CreateActions then
        actVideos := TAction.Create(aList);
      with actVideos do
      begin
        if CreateActions then
        begin
          Name := 'actVideos';
          Enabled := True;
          ImageIndex := Integer(icoidx_video);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActVideos;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actVideos, sSysGnuViewerDomain);

      if CreateActions then
        actHandbooks := TAction.Create(aList);
      with actHandbooks do
      begin
        if CreateActions then
        begin
          Name := 'actHandbooks';
          Enabled := True;
          ImageIndex := Integer(icoidx_book);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActHandbooks;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actHandbooks, sSysGnuViewerDomain);

      if CreateActions then
        actLanguageDE := TAction.Create(aList);
      with actLanguageDE do
      begin
        if CreateActions then
        begin
          Name := 'actLanguageDE';
          Enabled := False;
          ImageIndex := Integer(icoidx_flag_germany);
          ActionList := aList;
          OnExecute := actLanguageDEExecute;
        end;
        Caption := sCaptionActLanguageDE;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actLanguageDE, sSysGnuViewerDomain);

      if CreateActions then
        actLanguageEN := TAction.Create(aList);
      with actLanguageEN do
      begin
        if CreateActions then
        begin
          Name := 'actLanguageEN';
          Enabled := False;
          ImageIndex := Integer(icoidx_flag_britain);
          ActionList := aList;
          OnExecute := actLanguageENExecute;
        end;
        Caption := sCaptionActLanguageEN;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actLanguageEN, sSysGnuViewerDomain);

      if CreateActions then
        actSave := TAction.Create(aList);
      with actSave do
      begin
        if CreateActions then
        begin
          Name := 'actSave';
          Enabled := False;
          ImageIndex := Integer(icoidx_ok);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActSave;
        Hint := sHintActSave;
      end;
      if CreateActions then
        TranslateComponent(actSave, sSysGnuViewerDomain);

      if CreateActions then
        actCancel := TAction.Create(aList);
      with actCancel do
      begin
        if CreateActions then
        begin
          Name := 'actCancel';
          Enabled := False;
          ImageIndex := Integer(icoidx_abort);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActCancel;
        Hint := sHintActCancel;
      end;
      if CreateActions then
        TranslateComponent(actCancel, sSysGnuViewerDomain);

      if CreateActions then
        actLayoutSave := TAction.Create(aList);
      with actLayoutSave do
      begin
        if CreateActions then
        begin
          Name := 'actLayoutSave';
          ImageIndex := Integer(icoidx_layout_save);
          Enabled := True;
          ActionList := aList;
        end;
        Caption := sCaptionActLayoutSave;
        Hint := sEmptyString;
        OnExecute := actLayoutSaveExecute;
      end;
      if CreateActions then
        TranslateComponent(actLayoutSave, sSysGnuViewerDomain);

      if CreateActions then
        actLayoutDelete := TAction.Create(aList);
      with actLayoutDelete do
      begin
        if CreateActions then
        begin
          Name := 'actLayoutDelete';
          ImageIndex := Integer(icoidx_layout_delete);
          Enabled := True;
          ActionList := aList;
        end;
        Caption := sCaptionActLayoutDelete;
        Hint := sEmptyString;
        OnExecute := actLayoutDeleteExecute;
      end;
      if CreateActions then
        TranslateComponent(actLayoutDelete, sSysGnuViewerDomain);

      if CreateActions then
        actLayoutStandard := TAction.Create(aList);
      with actLayoutStandard do
      begin
        if CreateActions then
        begin
          Name := 'actLayoutStandard';
          Enabled := True;
          ActionList := aList;
        end;
        Caption := sCaptionActLayoutStandard;
        Hint := sEmptyString;
        OnExecute := actLayoutStandardExecute;
      end;
      if CreateActions then
        TranslateComponent(actLayoutStandard, sSysGnuViewerDomain);

      if CreateActions then
        actSearch := TAction.Create(aList);
      with actSearch do
      begin
        if CreateActions then
        begin
          Name := 'actSearch';
          ImageIndex := Integer(icoidx_start);
          Enabled := False;
          ShortCut := 116;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActSearch;
        Hint := sHintActSearch;
      end;
      if CreateActions then
        TranslateComponent(actSearch, sSysGnuViewerDomain);

      if CreateActions then
        actReset := TAction.Create(aList);
      with actReset do
      begin
        if CreateActions then
        begin
          Name := 'actReset';
          ImageIndex := Integer(icoidx_reset);
          Enabled := False;
          ShortCut := 117;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActReset;
        Hint := sHintActReset;
      end;
      if CreateActions then
        TranslateComponent(actReset, sSysGnuViewerDomain);

      if CreateActions then
        actBack := TAction.Create(aList);
      with actBack do
      begin
        if CreateActions then
        begin
          Name := 'actBack';
          ImageIndex := Integer(icoidx_search_left);
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sHintActBack;
      end;
      if CreateActions then
        TranslateComponent(actBack, sSysGnuViewerDomain);

      if CreateActions then
        actResetImporter := TAction.Create(aList);
      with actResetImporter do
      begin
        if CreateActions then
        begin
          Name := 'actResetImporter';
          Enabled := False;
          ImageIndex := Integer(icoidx_importer_reset);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActResetImporter;
        Hint := sCaptionActResetImporter;
      end;
      if CreateActions then
        TranslateComponent(actResetImporter, sSysGnuViewerDomain);

      if CreateActions then
        actForward := TAction.Create(aList);
      with actForward do
      begin
        if CreateActions then
        begin
          Name := 'actForward';
          ImageIndex := Integer(icoidx_search_right);
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sHintActForward;
      end;
      if CreateActions then
        TranslateComponent(actForward, sSysGnuViewerDomain);

      if CreateActions then
        actMyTasks := TAction.Create(aList);
      with actMyTasks do
      begin
        if CreateActions then
        begin
          Name := 'actMyTasks';
          ImageIndex := Integer(icoidx_resubmission_own);
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActMyTasks;
        Hint := sHintActMyTasks;
      end;
      if CreateActions then
        TranslateComponent(actMyTasks, sSysGnuViewerDomain);

      if CreateActions then
        actDelegateTasks := TAction.Create(aList);
      with actDelegateTasks do
      begin
        if CreateActions then
        begin
          Name := 'actDelegateTasks';
          //14.02.2023 ImageIndex := Integer(icoidx_resubmission_group);
          ImageIndex := Integer(icoidx_forwarded);
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActDelegateTasks;
        Hint := sHintActDelegateTasks;
      end;
      if CreateActions then
        TranslateComponent(actDelegateTasks, sSysGnuViewerDomain);

      if CreateActions then
        actShowCW := TAction.Create(aList);
      with actShowCW do
      begin
        if CreateActions then
        begin
          Name := 'actShowCW';
          ImageIndex := Integer(icoidx_date);
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sHintActShowCW;
      end;
      if CreateActions then
        TranslateComponent(actShowCW, sSysGnuViewerDomain);

      if CreateActions then
        actCWPrevious := TAction.Create(aList);
      with actCWPrevious do
      begin
        if CreateActions then
        begin
          Name := 'actCWPrevious';
          ImageIndex := Integer(icoidx_arrow_left);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sHintActCWPrevious;
      end;
      if CreateActions then
        TranslateComponent(actCWPrevious, sSysGnuViewerDomain);

      if CreateActions then
        actCWNext := TAction.Create(aList);
      with actCWNext do
      begin
        if CreateActions then
        begin
          Name := 'actCWNext';
          ImageIndex := Integer(icoidx_arrow_right);
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sHintActCWNext;
      end;
      if CreateActions then
        TranslateComponent(actCWNext, sSysGnuViewerDomain);

      if CreateActions then
        actResubOpen := TAction.Create(aList);
      with actResubOpen do
      begin
        if CreateActions then
        begin
          Name := 'actResubOpen';
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActResubOpen;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actResubOpen, sSysGnuViewerDomain);

      if CreateActions then
        actResubWork := TAction.Create(aList);
      with actResubWork do
      begin
        if CreateActions then
        begin
          Name := 'actResubWork';
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActResubWork;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actResubWork, sSysGnuViewerDomain);

      if CreateActions then
        actResubCancel := TAction.Create(aList);
      with actResubCancel do
      begin
        if CreateActions then
        begin
          Name := 'actResubCancel';
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actResubCancel, sSysGnuViewerDomain);

      if CreateActions then
        actResubForward := TAction.Create(aList);
      with actResubForward do
      begin
        if CreateActions then
        begin
          Name := 'actResubForward';
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActResubForward;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actResubForward, sSysGnuViewerDomain);

      if CreateActions then
        actResubDone := TAction.Create(aList);
      with actResubDone do
      begin
        if CreateActions then
        begin
          Name := 'actResubDone';
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActResubDone;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actResubDone, sSysGnuViewerDomain);

      if CreateActions then
        actResubQuickForward := TAction.Create(aList);
      with actResubQuickForward do
      begin
        if CreateActions then
        begin
          Name := 'actResubQuickForward';
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actResubQuickForward, sSysGnuViewerDomain);

      if CreateActions then
        actScan := TAction.Create(aList);
      with actScan do
      begin
        if CreateActions then
        begin
          Name := 'actScan';
          Enabled := False;
          ImageIndex := Integer(icoidx_scan_page);
          ActionList := aList;
          OnExecute := actScanExecute;
        end;
        Caption := sCaptionActScan;
        Hint := sCaptionActScan;
      end;
      if CreateActions then
        TranslateComponent(actScan, sSysGnuViewerDomain);

      if CreateActions then
        actScanDialog := TAction.Create(aList);
      with actScanDialog do
      begin
        if CreateActions then
        begin
          Name := 'actScanDialog';
          Enabled := False;
          ImageIndex := Integer(icoidx_scan_dialog);
          ActionList := aList;
          OnExecute := actScanDialogExecute;
        end;
        Caption := sEmptyString;
        Hint := sHintActScanDialog;
      end;
      if CreateActions then
        TranslateComponent(actScanDialog, sSysGnuViewerDomain);

      if CreateActions then
        actLoadFile := TAction.Create(aList);
      with actLoadFile do
      begin
        if CreateActions then
        begin
          Name := 'actLoadFile';
          Enabled := False;
          ImageIndex := Integer(icoidx_files_load);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sHintActLoadFile;
      end;
      if CreateActions then
        TranslateComponent(actLoadFile, sSysGnuViewerDomain);

      if CreateActions then
        actDeleteSelected := TAction.Create(aList);
      with actDeleteSelected do
      begin
        if CreateActions then
        begin
          Name := 'actDeleteSelected';
          Enabled := False;
          ImageIndex := Integer(icoidx_document_delete);
          ActionList := aList;
          OnExecute := actDeleteSelectedExecute;
        end;
        Caption := sCaptionActDeleteSelected;
        Hint := sCaptionActDeleteSelected;
      end;
      if CreateActions then
        TranslateComponent(actDeleteSelected, sSysGnuViewerDomain);

      if CreateActions then
        actArchive := TAction.Create(aList);
      with actArchive do
      begin
        if CreateActions then
        begin
          Name := 'actArchive';
          ImageIndex := Integer(icoidx_archive_document);
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActArchive;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actArchive, sSysGnuViewerDomain);

      if CreateActions then
        actWPGroup := TAction.Create(aList);
      with actWPGroup do
      begin
        if CreateActions then
        begin
          Name := 'actWPGroup';
          Enabled := False;
          ImageIndex := Integer(icoidx_document_merge);
          ActionList := aList;
          OnExecute := actWPGroupExecute;
        end;
        Caption := sCaptionActWPGroup;
        Hint := sCaptionActWPGroup;
      end;
      if CreateActions then
        TranslateComponent(actWPGroup, sSysGnuViewerDomain);

      if CreateActions then
        actWPUngroup := TAction.Create(aList);
      with actWPUngroup do
      begin
        if CreateActions then
        begin
          Name := 'actWPUngroup';
          Enabled := False;
          ImageIndex := Integer(icoidx_document_split);
          ActionList := aList;
          OnExecute := actWPUngroupExecute;
        end;
        Caption := sCaptionActWPUngroup;
        Hint := sCaptionActWPUngroup;
      end;
      if CreateActions then
        TranslateComponent(actWPUngroup, sSysGnuViewerDomain);

      if CreateActions then
        actWPClear := TAction.Create(aList);
      with actWPClear do
      begin
        if CreateActions then
        begin
          Name := 'actWPClear';
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actWPClear, sSysGnuViewerDomain);

      if CreateActions then
        actArchiveWithDD := TAction.Create(aList);
      with actArchiveWithDD do
      begin
        if CreateActions then
        begin
          Name := 'actArchiveWithDD';
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActArchiveWithDD;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actArchiveWithDD, sSysGnuViewerDomain);

      if CreateActions then
        actWPLoad := TAction.Create(aList);
      with actWPLoad do
      begin
        if CreateActions then
        begin
          Name := 'actWPLoad';
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actWPLoad, sSysGnuViewerDomain);

      if CreateActions then
        actWPSave := TAction.Create(aList);
      with actWPSave do
      begin
        if CreateActions then
        begin
          Name := 'actWPSave';
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actWPSave, sSysGnuViewerDomain);

      if CreateActions then
        actPreviewBack := TAction.Create(aList);
      with actPreviewBack do
      begin
        if CreateActions then
        begin
          Name := 'actPreviewBack';
          Enabled := False;
          ImageIndex := Integer(icoidx_arrow_left);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actPreviewBack, sSysGnuViewerDomain);

      if CreateActions then
        actChangeArchive := TAction.Create(aList);
      with actChangeArchive do
      begin
        if CreateActions then
        begin
          Name := 'actChangeArchive';
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actChangeArchive, sSysGnuViewerDomain);

      if CreateActions then
        actAddFolder := TAction.Create(aList);
      with actAddFolder do
      begin
        if CreateActions then
        begin
          Name := 'actAddFolder';
          Enabled := False;
          ActionList := aList;
          OnExecute := actAddFolderExecute;
        end;
        Caption := sCaptionActAddFolder;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAddFolder, sSysGnuViewerDomain);

      if CreateActions then
        actDeleteFolder := TAction.Create(aList);
      with actDeleteFolder do
      begin
        if CreateActions then
        begin
          Name := 'actDeleteFolder';
          Enabled := False;
          ActionList := aList;
          OnExecute := actDeleteFolderExecute;
        end;
        Caption := sCaptionActDeleteFolder;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actDeleteFolder, sSysGnuViewerDomain);

      if CreateActions then
        actDeleteFavorite := TAction.Create(aList);
      with actDeleteFavorite do
      begin
        if CreateActions then
        begin
          Name := 'actDeleteFavorite';
          Enabled := False;
          ActionList := aList;
          OnExecute := actDeleteFavoriteExecute;
        end;
        Caption := sCaptionActDeleteFavorite;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actDeleteFavorite, sSysGnuViewerDomain);

      if CreateActions then
        actExpandAll := TAction.Create(aList);
      with actExpandAll do
      begin
        if CreateActions then
        begin
          Name := 'actExpandAll';
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActExpandAll;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actExpandAll, sSysGnuViewerDomain);

      if CreateActions then
        actCollapseAll := TAction.Create(aList);
      with actCollapseAll do
      begin
        if CreateActions then
        begin
          Name := 'actCollapseAll';
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActCollapseAll;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actCollapseAll, sSysGnuViewerDomain);

      if CreateActions then
        actRefreshTreeView := TAction.Create(aList);
      with actRefreshTreeView do
      begin
        if CreateActions then
        begin
          Name := 'actRefreshTreeView';
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActRefreshTreeView;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actRefreshTreeView, sSysGnuViewerDomain);

      if CreateActions then
        actExportTree := TAction.Create(aList);
      with actExportTree do
      begin
        if CreateActions then
        begin
          Name := 'actExportTree';
          Enabled := False;
          Visible := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActExportTree;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actExportTree, sSysGnuViewerDomain);

      if CreateActions then
        actAddGlobal := TAction.Create(aList);
      with actAddGlobal do
      begin
        if CreateActions then
        begin
          Name := 'actAddGlobal';
          Enabled := False;
          ActionList := aList;
          OnExecute := actAddGlobalExecute;
        end;
        Caption := sCaptionActAddGlobal;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAddGlobal, sSysGnuViewerDomain);

      if CreateActions then
        actDeleteGlobal := TAction.Create(aList);
      with actDeleteGlobal do
      begin
        if CreateActions then
        begin
          Name := 'actDeleteGlobal';
          Enabled := False;
          ActionList := aList;
          OnExecute := actDeleteGlobalExecute;
        end;
        Caption := sCaptionActDeleteGlobal;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actDeleteGlobal, sSysGnuViewerDomain);

      if CreateActions then
        actReplaceBookmark := TAction.Create(aList);
      with actReplaceBookmark do
      begin
        if CreateActions then
        begin
          Name := 'actReplaceBookmark';
          Enabled := False;
          ActionList := aList;
          OnExecute := actReplaceBookmarkExecute;
        end;
        Caption := sCaptionActReplaceBookmark;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actReplaceBookmark, sSysGnuViewerDomain);

      if CreateActions then
        actCreateBookmark := TAction.Create(aList);
      with actCreateBookmark do
      begin
        if CreateActions then
        begin
          Name := 'actCreateBookmark';
          Enabled := False;
          ActionList := aList;
          OnExecute := actCreateBookmarkExecute;
        end;
        Caption := sCaptionActCreateBookmark;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actCreateBookmark, sSysGnuViewerDomain);

      if CreateActions then
        actCopyBookmark := TAction.Create(aList);
      with actCopyBookmark do
      begin
        if CreateActions then
        begin
          Name := 'actCopyBookmark';
          Enabled := False;
          ActionList := aList;
          OnExecute := actCopyBookmarkExecute;
        end;
        Caption := sCaptionActCopyBookmark;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actCopyBookmark, sSysGnuViewerDomain);

      if CreateActions then
        actCreateBookmarkForGDocID := TAction.Create(aList);
      with actCreateBookmarkForGDocID do
      begin
        if CreateActions then
        begin
          Name := 'actCreateBookmarkForGDocID';
          ImageIndex := Integer(icoidx_document_bookmark);
          Enabled := False;
          ActionList := aList;
          OnExecute := actCreateBookmarkForGDocIDExecute;
        end;
        Caption := sCaptionActCreateBookmarkForGDocID;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actCreateBookmarkForGDocID, sSysGnuViewerDomain);

      if CreateActions then
        actCreateBookmarkDialog := TAction.Create(aList);
      with actCreateBookmarkDialog do
      begin
        if CreateActions then
        begin
          Name := 'actCreateBookmarkDialog';
          Enabled := False;
          ImageIndex := Integer(icoidx_bookmark_dialog);
          ActionList := aList;
          OnExecute := actCreateBookmarkDialogExecute;
        end;
        Caption := sCaptionActCreateBookmarkDialog;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actCreateBookmarkDialog, sSysGnuViewerDomain);

      if CreateActions then
        actCreateBookmarkMenu := TAction.Create(aList);
      with actCreateBookmarkMenu do
      begin
        if CreateActions then
        begin
          Name := 'actCreateBookmarkMenu';
          Enabled := False;
          ImageIndex := Integer(icoidx_bookmark_create);
          ActionList := aList;
          OnExecute := actCreateBookmarkMenuExecute;
        end;
        Caption := sCaptionActCreateBookmarkMenu;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actCreateBookmarkMenu, sSysGnuViewerDomain);

      if CreateActions then
        actChangeBookmark := TAction.Create(aList);
      with actChangeBookmark do
      begin
        if CreateActions then
        begin
          Name := 'actChangeBookmark';
          Enabled := False;
          ActionList := aList;
          OnExecute := actChangeBookmarkExecute;
        end;
        Caption := sCaptionActChangeBookmark;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actChangeBookmark, sSysGnuViewerDomain);

      if CreateActions then
        actCreateSymbolicLinkInImporter := TAction.Create(aList);
      with actCreateSymbolicLinkInImporter do
      begin
        if CreateActions then
        begin
          Name := 'actCreateSymbolicLinkInImporter';
          Enabled := False;
          ImageIndex := Integer(-1);
          ActionList := aList;
          OnExecute := actCreateSymbolicLinkInImporterExecute;
        end;
        Caption := sCaptionActCreateSymbolicLinkInImporter;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actCreateSymbolicLinkInImporter, sSysGnuViewerDomain);

      if CreateActions then
        actGoToOriginalDocument := TAction.Create(aList);
      with actGoToOriginalDocument do
      begin
        if CreateActions then
        begin
          Name := 'actGoToOriginalDocument';
          Enabled := False;
          ImageIndex := Integer(icoidx_original_view);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActGoToOriginalDocument;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actGoToOriginalDocument, sSysGnuViewerDomain);

//      if CreateActions then
//        actShowAllSymbolicLinks := TAction.Create(aList);
//      with actShowAllSymbolicLinks do
//      begin
//        if CreateActions then
//        begin
//          Name := 'actShowAllSymbolicLinks';
//          Enabled := False;
//          ImageIndex := Integer(icoidx_symbolic_link_view);
//          ActionList := aList;
//          OnExecute := actListExecute;
//        end;
//        Caption := sCaptionActShowAllSymbolicLinks;
//        Hint := sEmptyString;
//      end;
//      if CreateActions then
//        TranslateComponent(actShowAllSymbolicLinks, sSysGnuViewerDomain);
//
//      if CreateActions then
//        actDeleteSymbolicLink := TAction.Create(aList);
//      with actDeleteSymbolicLink do
//      begin
//        if CreateActions then
//        begin
//          Name := 'actDeleteSymbolicLink';
//          Enabled := False;
//          ImageIndex := Integer(icoidx_symbolic_link_remove);
//          ActionList := aList;
//          OnExecute := actDeleteSymbolicLinkExecute;
//        end;
//        Caption := sCaptionActDeleteSymbolicLink;
//        Hint := sEmptyString;
//      end;
//      if CreateActions then
//        TranslateComponent(actDeleteSymbolicLink, sSysGnuViewerDomain);

      if CreateActions then
        actCopyOriginalDocToClipboard := TAction.Create(aList);
      with actCopyOriginalDocToClipboard do
      begin
        if CreateActions then
        begin
          Name := 'actCopyOriginalDocToClipboard';
          Enabled := False;
          ImageIndex := Integer(icoidx_clipboard_file);
          ShortCut := 41005;
          ActionList := aList;
          OnExecute := actCopyOriginalDocToClipboardExecute;
        end;
        Caption := sCaptionActCopyOriginalDocToClipboard;
        Hint := sCaptionActCopyOriginalDocToClipboard;
      end;
      if CreateActions then
        TranslateComponent(actCopyOriginalDocToClipboard, sSysGnuViewerDomain);

      if CreateActions then
        actCopyPageToClipboard := TAction.Create(aList);
      with actCopyPageToClipboard do
      begin
        if CreateActions then
        begin
          Name := 'actCopyPageToClipboard';
          Enabled := False;
          ImageIndex := Integer(icoidx_clipboard_page);
          ShortCut := 49197;
          ActionList := aList;
          OnExecute := actCopyPageToClipboardExecute;
        end;
        Caption := sCaptionActCopyPageToClipboard;
        Hint := sCaptionActCopyPageToClipboard;
      end;
      if CreateActions then
        TranslateComponent(actCopyPageToClipboard, sSysGnuViewerDomain);

      if CreateActions then
        actCopyDocLinkToClipboard := TAction.Create(aList);
      with actCopyDocLinkToClipboard do
      begin
        if CreateActions then
        begin
          Name := 'actCopyDocLinkToClipboard';
          Enabled := False;
          ImageIndex := Integer(icoidx_clipboard_link);
          ShortCut := 24621;
          ActionList := aList;
          OnExecute := actCopyDocLinkToClipboardExecute;
        end;
        Caption := sCaptionActCopyDocLinkToClipboard;
        Hint := sCaptionActCopyDocLinkToClipboard;
      end;
      if CreateActions then
        TranslateComponent(actCopyDocLinkToClipboard, sSysGnuViewerDomain);

      if CreateActions then
        actRemoveLink := TAction.Create(aList);
      with actRemoveLink do
      begin
        if CreateActions then
        begin
          Name := 'actRemoveLink';
          Enabled := False;
          ActionList := aList;
          OnExecute := actRemoveLinkExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actRemoveLink, sSysGnuViewerDomain);

      if CreateActions then
        actDeleteLink := TAction.Create(aList);
      with actDeleteLink do
      begin
        if CreateActions then
        begin
          Name := 'actDeleteLink';
          Enabled := False;
          ActionList := aList;
          OnExecute := actDeleteLinkExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actDeleteLink, sSysGnuViewerDomain);

      if CreateActions then
        actAddAutoReference := TAction.Create(aList);
      with actAddAutoReference do
      begin
        if CreateActions then
        begin
          Name := 'actAddAutoReference';
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAddAutoReference, sSysGnuViewerDomain);

      if CreateActions then
        actSendPagesToWorkplace := TAction.Create(aList);
      with actSendPagesToWorkplace do
      begin
        if CreateActions then
        begin
          Name := 'actSendPagesToWorkplace';
          Enabled := False;
          ImageIndex := Integer(icoidx_workspace_pages);
          ActionList := aList;
          OnExecute := actSendPagesToWorkplaceExecute;
        end;
        Caption := sCaptionActSendPagesToWorkplace;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actSendPagesToWorkplace, sSysGnuViewerDomain);

      if CreateActions then
        actSendPagesMergedToWorkplace := TAction.Create(aList);
      with actSendPagesMergedToWorkplace do
      begin
        if CreateActions then
        begin
          Name := 'actSendPagesMergedToWorkplace';
          Enabled := False;
          ImageIndex := Integer(icoidx_workspace_document_pages);
          ActionList := aList;
          OnExecute := actSendPagesMergedToWorkplaceExecute;
        end;
        Caption := sCaptionActSendPagesMergedToWorkplace;
        Hint := sCaptionActSendPagesMergedToWorkplace;
      end;
      if CreateActions then
        TranslateComponent(actSendPagesMergedToWorkplace, sSysGnuViewerDomain);

      if CreateActions then
        actSendDocumentsToImporter := TAction.Create(aList);
      with actSendDocumentsToImporter do
      begin
        if CreateActions then
        begin
          Name := 'actSendDocumentsToImporter';
          Enabled := False;
          ImageIndex := Integer(icoidx_importer_send);
          ActionList := aList;
          OnExecute := actSendDocumentsToImporterExecute;
        end;
        Caption := sCaptionActSendDocumentsToImporter;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actSendDocumentsToImporter, sSysGnuViewerDomain);

      if CreateActions then
        actSendDocumentPreviewsToImport := TAction.Create(aList);
      with actSendDocumentPreviewsToImport do
      begin
        if CreateActions then
        begin
          Name := 'actSendDocumentPreviewsToImport';
          Enabled := False;
          ImageIndex := Integer(icoidx_importer_send_view);
          ActionList := aList;
          OnExecute := actSendDocumentPreviewsToImportExecute;
        end;
        Caption := sCaptionActSendDocumentPreviewsToImport;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actSendDocumentPreviewsToImport, sSysGnuViewerDomain);

      if CreateActions then
        actSendPagesToImporter := TAction.Create(aList);
      with actSendPagesToImporter do
      begin
        if CreateActions then
        begin
          Name := 'actSendPagesToImporter';
          Enabled := False;
          ImageIndex := Integer(icoidx_importer_pages);
          ActionList := aList;
          OnExecute := actSendPagesToImporterExecute;
        end;
        Caption := sCaptionActSendPagesToImporter;
        Hint := sCaptionActSendPagesToImporter;
      end;
      if CreateActions then
        TranslateComponent(actSendPagesToImporter, sSysGnuViewerDomain);

      if CreateActions then
        actSendPagesMergedToImporter := TAction.Create(aList);
      with actSendPagesMergedToImporter do
      begin
        if CreateActions then
        begin
          Name := 'actSendPagesMergedToImporter';
          Enabled := False;
          ImageIndex := Integer(icoidx_importer_document_pages);
          ActionList := aList;
          OnExecute := actSendPagesMergedToImporterExecute;
        end;
        Hint := sCaptionActSendPagesMergedToImporter;
        Caption := sCaptionActSendPagesMergedToImporter;
      end;
      if CreateActions then
        TranslateComponent(actSendPagesMergedToImporter, sSysGnuViewerDomain);

      if CreateActions then
        actSendCopyToWorkplace := TAction.Create(aList);
      with actSendCopyToWorkplace do
      begin
        if CreateActions then
        begin
          Name := 'actSendCopyToWorkplace';
          Enabled := False;
          ImageIndex := Integer(icoidx_workspace_copy);
          ActionList := aList;
          OnExecute := actSendCopyToWorkplaceExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actSendCopyToWorkplace, sSysGnuViewerDomain);

      if CreateActions then
        actClearFields := TAction.Create(aList);
      with actClearFields do
      begin
        if CreateActions then
        begin
          Name := 'actClearFields';
          Enabled := True;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActClearFields;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actClearFields, sSysGnuViewerDomain);

      if CreateActions then
        actSaveResub := TAction.Create(aList);
      with actSaveResub do
      begin
        if CreateActions then
        begin
          Name := 'actSaveResub';
          ActionList := aList;
          Enabled := False;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actSaveResub, sSysGnuViewerDomain);

      if CreateActions then
        actResubCreate := TAction.Create(aList);
      with actResubCreate do
      begin
        if CreateActions then
        begin
          Name := 'actResubCreate';
          Enabled := False;
          ImageIndex := Integer(icoidx_clock_create);
          ShortCut := 41047;
          ActionList := aList;
          OnExecute := actResubCreateExecute;
        end;
        Caption := sCaptionActResubCreate;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actResubCreate, sSysGnuViewerDomain);

      if CreateActions then
        actHideSearchDetails := TAction.Create(aList);
      with actHideSearchDetails do
      begin
        if CreateActions then
        begin
          Name := 'actHideSearchDetails';
          Enabled := False;
          ShortCut := 49160;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActHideSearchDetails;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actHideSearchDetails, sSysGnuViewerDomain);

      if CreateActions then
        actShowIndexingWithLimit := TAction.Create(aList);
      with actShowIndexingWithLimit do
      begin
        if CreateActions then
        begin
          Name := 'actShowIndexingWithLimit';
          Enabled := True;
          ActionList := aList;
          OnExecute := actShowIndexingWithLimitExecute;
        end;
        Caption := sCaptionActShowIndexingWithLimit;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actShowIndexingWithLimit, sSysGnuViewerDomain);

      if CreateActions then
        actShowIndexing := TAction.Create(aList);
      with actShowIndexing do
      begin
        if CreateActions then
        begin
          Name := 'actShowIndexing';
          Enabled := True;
          ActionList := aList;
          OnExecute := actShowIndexingExecute;
        end;
        Caption := sCaptionActShowIndexing;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actShowIndexing, sSysGnuViewerDomain);

      if CreateActions then
        actHideIndexing := TAction.Create(aList);
      with actHideIndexing do
      begin
        if CreateActions then
        begin
          Name := 'actHideIndexing';
          Enabled := True;
          ImageIndex := Integer(-1);
          ActionList := aList;
          OnExecute := actHideIndexingExecute;
        end;
        Caption := sCaptionActHideIndexing;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actHideIndexing, sSysGnuViewerDomain);

      if CreateActions then
        actGoToSourceArchive := TAction.Create(aList);
      with actGoToSourceArchive do
      begin
        if CreateActions then
        begin
          Name := 'actGoToSourceArchive';
          Enabled := False;
          ShortCut := 16469; //16.02.2024
          ImageIndex := Integer(icoidx_jump_to_original_archive);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActGoToSourceArchive;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actGoToSourceArchive, sSysGnuViewerDomain);

      if CreateActions then
        actAlt1 := TAction.Create(aList);
      with actAlt1 do
      begin
        if CreateActions then
        begin
          Name := 'actAlt1';
          ShortCut := 32817;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAlt1, sSysGnuViewerDomain);

      if CreateActions then
        actAlt1Num := TAction.Create(aList);
      with actAlt1Num do
      begin
        if CreateActions then
        begin
          Name := 'actAlt1Num';
          ShortCut := 32865;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAlt1Num, sSysGnuViewerDomain);

      if CreateActions then
        actAlt2 := TAction.Create(aList);
      with actAlt2 do
      begin
        if CreateActions then
        begin
          Name := 'actAlt2';
          ShortCut := 32818;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAlt2, sSysGnuViewerDomain);

      if CreateActions then
        actAlt2Num := TAction.Create(aList);
      with actAlt2Num do
      begin
        if CreateActions then
        begin
          Name := 'actAlt2Num';
          ShortCut := 32866;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAlt2Num, sSysGnuViewerDomain);

      if CreateActions then
        actAlt3 := TAction.Create(aList);
      with actAlt3 do
      begin
        if CreateActions then
        begin
          Name := 'actAlt3';
          ShortCut := 32819;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAlt3, sSysGnuViewerDomain);

      if CreateActions then
        actAlt3Num := TAction.Create(aList);
      with actAlt3Num do
      begin
        if CreateActions then
        begin
          Name := 'actAlt3Num';
          ShortCut := 32867;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAlt3Num, sSysGnuViewerDomain);

      if CreateActions then
        actAlt4 := TAction.Create(aList);
      with actAlt4 do
      begin
        if CreateActions then
        begin
          Name := 'actAlt4';
          ShortCut := 32820;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAlt4, sSysGnuViewerDomain);

      if CreateActions then
        actAlt4Num := TAction.Create(aList);
      with actAlt4Num do
      begin
        if CreateActions then
        begin
          Name := 'actAlt4Num';
          ShortCut := 32868;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAlt4Num, sSysGnuViewerDomain);

      if CreateActions then
        actAlt5 := TAction.Create(aList);
      with actAlt5 do
      begin
        if CreateActions then
        begin
          Name := 'actAlt5';
          ShortCut := 32821;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAlt5, sSysGnuViewerDomain);

      if CreateActions then
        actAlt5Num := TAction.Create(aList);
      with actAlt5Num do
      begin
        if CreateActions then
        begin
          Name := 'actAlt5Num';
          ShortCut := 32869;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAlt5Num, sSysGnuViewerDomain);

      if CreateActions then
        actAlt6 := TAction.Create(aList);
      with actAlt6 do
      begin
        if CreateActions then
        begin
          Name := 'actAlt6';
          ShortCut := 32822;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAlt6, sSysGnuViewerDomain);

      if CreateActions then
        actAlt6Num := TAction.Create(aList);
      with actAlt6Num do
      begin
        if CreateActions then
        begin
          Name := 'actAlt6Num';
          ShortCut := 32870;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAlt6Num, sSysGnuViewerDomain);

      if CreateActions then
        actAlt7 := TAction.Create(aList);
      with actAlt7 do
      begin
        if CreateActions then
        begin
          Name := 'actAlt7';
          ShortCut := 32823;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAlt7, sSysGnuViewerDomain);

      if CreateActions then
        actAlt7Num := TAction.Create(aList);
      with actAlt7Num do
      begin
        if CreateActions then
        begin
          Name := 'actAlt7Num';
          ShortCut := 32871;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAlt7Num, sSysGnuViewerDomain);

      if CreateActions then
        actAlt8 := TAction.Create(aList);
      with actAlt8 do
      begin
        if CreateActions then
        begin
          Name := 'actAlt8';
          ShortCut := 32824; //  2/23/2021 bfacrm:ticket__show__25771
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAlt8, sSysGnuViewerDomain);

      if CreateActions then
        actAlt8Num := TAction.Create(aList);
      with actAlt8Num do
      begin
        if CreateActions then
        begin
          Name := 'actAlt8Num';
          ShortCut := 32872; //  2/23/2021 bfacrm:ticket__show__25771
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAlt8Num, sSysGnuViewerDomain);

      if CreateActions then
        actAlt9 := TAction.Create(aList);
      with actAlt9 do
      begin
        if CreateActions then
        begin
          Name := 'actAlt9';
          ShortCut := 32825;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAlt9, sSysGnuViewerDomain);

      if CreateActions then
        actAlt9Num := TAction.Create(aList);
      with actAlt9Num do
      begin
        if CreateActions then
        begin
          Name := 'actAlt9Num';
          ShortCut := 32873;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAlt9Num, sSysGnuViewerDomain);

      if CreateActions then
        actAlt0 := TAction.Create(aList);
      with actAlt0 do
      begin
        if CreateActions then
        begin
          Name := 'actAlt0';
          ShortCut := 32816;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAlt0, sSysGnuViewerDomain);

      if CreateActions then
        actAlt0Num := TAction.Create(aList);
      with actAlt0Num do
      begin
        if CreateActions then
        begin
          Name := 'actAlt0Num';
          ShortCut := 32864;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAlt0Num, sSysGnuViewerDomain);

      if CreateActions then
        actF4 := TAction.Create(aList);
      with actF4 do
      begin
        if CreateActions then
        begin
          Name := 'actF4';
          ShortCut := 115; // VK_F4
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actF4, sSysGnuViewerDomain);

      if CreateActions then
        actCtrlF := TAction.Create(aList);
      with actCtrlF do
      begin
        if CreateActions then
        begin
          Name := 'actCtrlF';
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actCtrlF, sSysGnuViewerDomain);

      if CreateActions then
        actCtrlAltF := TAction.Create(aList);
      with actCtrlAltF do
      begin
        if CreateActions then
        begin
          Name := 'actCtrlAltF';
          ShortCut := 49222;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actCtrlAltF, sSysGnuViewerDomain);

      if CreateActions then
        actCtrlTab := TAction.Create(aList);
      with actCtrlTab do
      begin
        if CreateActions then
        begin
          Name := 'actCtrlTab';
          ShortCut := 16393;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actCtrlTab, sSysGnuViewerDomain);

      if CreateActions then
        actCtrlAltLeft := TAction.Create(aList);
      with actCtrlAltLeft do
      begin
        if CreateActions then
        begin
          Name := 'actCtrlAltLeft';
          ShortCut := 49189;
          ActionList := aList;
          OnExecute := actCtrlAltLeftExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actCtrlAltLeft, sSysGnuViewerDomain);

      if CreateActions then
        actCtrlAltRight := TAction.Create(aList);
      with actCtrlAltRight do
      begin
        if CreateActions then
        begin
          Name := 'actCtrlAltRight';
          ShortCut := 49191;
          ActionList := aList;
          OnExecute := actCtrlAltRightExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actCtrlAltRight, sSysGnuViewerDomain);

      if CreateActions then
        actShowInResub := TAction.Create(aList);
      with actShowInResub do
      begin
        if CreateActions then
        begin
          Name := 'actShowInResub';
          Enabled := True;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActShowInResub;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actShowInResub, sSysGnuViewerDomain);

      if CreateActions then
        actRangeOCR := TAction.Create(aList);
      with actRangeOCR do
      begin
        if CreateActions then
        begin
          Name := 'actRangeOCR';
          Enabled := False;
          ImageIndex := Integer(icoidx_ocr);
          ActionList := aList;
          OnExecute := actRangeOCRExecute;
        end;
        Caption := sCaptionActRangeOCR;
        Hint := sCaptionActRangeOCR;
      end;
      if CreateActions then
        TranslateComponent(actRangeOCR, sSysGnuViewerDomain);

      if CreateActions then
        actF11 := TAction.Create(aList);
      with actF11 do
      begin
        if CreateActions then
        begin
          Name := 'actF11';
          Enabled := True;
          ShortCut := 122;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actF11, sSysGnuViewerDomain);

      if CreateActions then
        actAltF11 := TAction.Create(aList);
      with actAltF11 do
      begin
        if CreateActions then
        begin
          Name := 'actAltF11';
          Enabled := True;
          ShortCut := 32890;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAltF11, sSysGnuViewerDomain);

      if CreateActions then
        actShowPageSortingsFrame := TAction.Create(aList);
      with actShowPageSortingsFrame do
      begin
        if CreateActions then
        begin
          Name := 'actShowPageSortingsFrame';
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actShowPageSortingsFrame, sSysGnuViewerDomain);

      if CreateActions then
        actHidePageSortingsFrame := TAction.Create(aList);
      with actHidePageSortingsFrame do
      begin
        if CreateActions then
        begin
          Name := 'actHidePageSortingsFrame';
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actHidePageSortingsFrame, sSysGnuViewerDomain);

      if CreateActions then
        actResetDLM := TAction.Create(aList);
      with actResetDLM do
      begin
        if CreateActions then
        begin
          Name := 'actResetDLM';
          Enabled := False;
          ImageIndex := Integer(icoidx_date_deleteDate_recalculate);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActResetDLM;
        Hint := sHintActResetDLM;
      end;
      if CreateActions then
        TranslateComponent(actResetDLM, sSysGnuViewerDomain);

      if CreateActions then
        actLanguage := TAction.Create(aList);
      with actLanguage do
      begin
        if CreateActions then
        begin
          Name := 'actLanguage';
          ActionList := aList;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actLanguage, sSysGnuViewerDomain);

//      if CreateActions then
//        actShowAbo := TAction.Create(aList);
//      with actShowAbo do
//      begin
//        if CreateActions then
//        begin
//          Name := 'actShowAbo';
//          Enabled := False;
//          ActionList := aList;
//          OnExecute := actListExecute;
//        end;
//        Caption := sCaptionActShowAbo;
//        Hint := sEmptyString;
//      end;
//      if CreateActions then
//        TranslateComponent(actShowAbo, sSysGnuViewerDomain);

      if CreateActions then
        actCheckoutDocs := TAction.Create(aList);
      with actCheckoutDocs do
      begin
        if CreateActions then
        begin
          Name := 'actCheckoutDocs';
          ImageIndex := Integer(icoidx_status_check_out);
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActCheckoutDocs;
        Hint := sHintActCheckoutDocs;
      end;
      if CreateActions then
        TranslateComponent(actCheckoutDocs, sSysGnuViewerDomain);

      if CreateActions then
        actReOCR := TAction.Create(aList);
      with actReOCR do
      begin
        if CreateActions then
        begin
          Name := 'actReOCR';
          Enabled := False;
          ImageIndex := Integer(icoidx_document_reload);
          ActionList := aList;
          OnExecute := actReOCRExecute;
        end;
        Caption := sCaptionActReOCR;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actReOCR, sSysGnuViewerDomain);

      if CreateActions then
        actCheckoutDocsAdmin := TAction.Create(aList);
      with actCheckoutDocsAdmin do
      begin
        if CreateActions then
        begin
          Name := 'actCheckoutDocsAdmin';
          ImageIndex := Integer(icoidx_document_checkout_all);
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActCheckoutDocsAdmin;
        Hint := sHintActCheckoutDocsAdmin;
      end;
      if CreateActions then
        TranslateComponent(actCheckoutDocsAdmin, sSysGnuViewerDomain);

      if CreateActions then
        actOriginalfile := TAction.Create(actList);
      with actOriginalfile do
      begin
        if CreateActions then
        begin
          Name := 'actOriginalfile';
          Enabled := True;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActOriginalfile;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actOriginalfile, sSysGnuViewerDomain);

      if CreateActions then
        actCheckout := TAction.Create(aList);
      with actCheckout do
      begin
        if CreateActions then
        begin
          Name := 'actCheckout';
          Enabled := True;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActCheckout;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actCheckout, sSysGnuViewerDomain);

      if CreateActions then
        actLinks := TAction.Create(aList);
      with actLinks do
      begin
        if CreateActions then
        begin
          Name := 'actLinks';
          Enabled := True;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActLinks;
        Hint := sHintActLinks;
      end;
      if CreateActions then
        TranslateComponent(actLinks, sSysGnuViewerDomain);

      if CreateActions then
        actLocalSavePDF := TAction.Create(aList);
      with actLocalSavePDF do
      begin
        if CreateActions then
        begin
          Name := 'actLocalSavePDF';
          Enabled := False;
          ImageIndex := Integer(icoidx_save_pdf);
          ShortCut := 49228;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActLocalSavePDF;
        Hint := sCaptionActLocalSavePDF;
      end;
      if CreateActions then
        TranslateComponent(actLocalSavePDF, sSysGnuViewerDomain);

      if CreateActions then
        actLocalSaveTIF := TAction.Create(aList);
      with actLocalSaveTIF do
      begin
        if CreateActions then
        begin
          Name := 'actLocalSaveTIF';
          Enabled := False;
          ImageIndex := Integer(icoidx_save_tif);
          ShortCut := 16460;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActLocalSaveTIF;
        Hint := sCaptionActLocalSaveTIF;
      end;
      if CreateActions then
        TranslateComponent(actLocalSaveTIF, sSysGnuViewerDomain);

      if CreateActions then
        actLocalSaveOriginal := TAction.Create(aList);
      with actLocalSaveOriginal do
      begin
        if CreateActions then
        begin
          Name := 'actLocalSaveOriginal';
          Enabled := False;
          ImageIndex := Integer(icoidx_save_file);
          ShortCut := 41036;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActLocalSaveOriginal;
        Hint := sCaptionActLocalSaveOriginal;
      end;
      if CreateActions then
        TranslateComponent(actLocalSaveOriginal, sSysGnuViewerDomain);

      if CreateActions then
        actLocalSaveLink := TAction.Create(aList);
      with actLocalSaveLink do
      begin
        if CreateActions then
        begin
          Name := 'actLocalSaveLink';
          Enabled := False;
          ImageIndex := Integer(icoidx_save_link);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActLocalSaveLink;
        Hint := sCaptionActLocalSaveLink;
      end;
      if CreateActions then
        TranslateComponent(actLocalSaveLink, sSysGnuViewerDomain);

      if CreateActions then
        actLocalSavePreview := TAction.Create(aList);
      with actLocalSavePreview do
      begin
        if CreateActions then
        begin
          Name := 'actLocalSavePreview';
          Enabled := False;
          ImageIndex := Integer(icoidx_save_view);
          ShortCut := 24652;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActLocalSavePreview;
        Hint := sHintActLocalSavePreview;
      end;
      if CreateActions then
        TranslateComponent(actLocalSavePreview, sSysGnuViewerDomain);

      if CreateActions then
        actEmailTIFAttachment := TAction.Create(aList);
      with actEmailTIFAttachment do
      begin
        if CreateActions then
        begin
          Name := 'actEmailTIFAttachment';
          Enabled := False;
          ImageIndex := Integer(icoidx_mail_tif);
          ShortCut := 41037;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActEmailTIFAttachment;
        Hint := sCaptionActEmailTIFAttachment;
      end;
      if CreateActions then
        TranslateComponent(actEmailTIFAttachment, sSysGnuViewerDomain);

      if CreateActions then
        actEmailPDFAttachment := TAction.Create(aList);
      with actEmailPDFAttachment do
      begin
        if CreateActions then
        begin
          Name := 'actEmailPDFAttachment';
          Enabled := False;
          ImageIndex := Integer(icoidx_mail_pdf);
          ShortCut := 16461;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActEmailPDFAttachment;
        Hint := sCaptionActEmailPDFAttachment;
      end;
      if CreateActions then
        TranslateComponent(actEmailPDFAttachment, sSysGnuViewerDomain);

      if CreateActions then
        actEmailOriginal := TAction.Create(aList);
      with actEmailOriginal do
      begin
        if CreateActions then
        begin
          Name := 'actEmailOriginal';
          Enabled := False;
          ImageIndex := Integer(icoidx_mail_file);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActEmailOriginal;
        Hint := sCaptionActEmailOriginal;
      end;
      if CreateActions then
        TranslateComponent(actEmailOriginal, sSysGnuViewerDomain);

      if CreateActions then
        actEmailLink := TAction.Create(aList);
      with actEmailLink do
      begin
        if CreateActions then
        begin
          Name := 'actEmailLink';
          Enabled := False;
          ImageIndex := Integer(icoidx_mail_link);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActEmailLink;
        Hint := sCaptionActEmailLink;
      end;
      if CreateActions then
        TranslateComponent(actEmailLink, sSysGnuViewerDomain);

      if CreateActions then
        actEmailPreview := TAction.Create(aList);
      with actEmailPreview do
      begin
        if CreateActions then
        begin
          Name := 'actEmailPreview';
          Enabled := False;
          ImageIndex := Integer(icoidx_mail_view);
          ShortCut := 24653;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActEmailPreview;
        Hint := sCaptionActEmailPreview;
      end;
      if CreateActions then
        TranslateComponent(actEmailPreview, sSysGnuViewerDomain);

      if CreateActions then
        actPrintStandard := TAction.Create(aList);
      with actPrintStandard do
      begin
        if CreateActions then
        begin
          Name := 'actPrintStandard';
          Enabled := False;
          ImageIndex := Integer(icoidx_print);
          ShortCut := 24656;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActPrintStandard;
        Hint := sHintActPrintStandard;
      end;
      if CreateActions then
        TranslateComponent(actPrintStandard, sSysGnuViewerDomain);

      if CreateActions then
        actPrintSelect := TAction.Create(aList);
      with actPrintSelect do
      begin
        if CreateActions then
        begin
          Name := 'actPrintSelect';
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActPrintSelect;
        Hint := sHintActPrintSelect;
      end;
      if CreateActions then
        TranslateComponent(actPrintSelect, sSysGnuViewerDomain);

      if CreateActions then
        actPrintPreview := TAction.Create(aList);
      with actPrintPreview do
      begin
        if CreateActions then
        begin
          Name := 'actPrintPreview';
          Enabled := False;
          ImageIndex := Integer(icoidx_print_view);
          ShortCut := 16464;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActPrintPreview;
        Hint := sCaptionActPrintPreview;
      end;
      if CreateActions then
        TranslateComponent(actPrintPreview, sSysGnuViewerDomain);

      if CreateActions then
        actSendDocumentsToWorkplace := TAction.Create(aList);
      with actSendDocumentsToWorkplace do
      begin
        if CreateActions then
        begin
          Name := 'actSendDocumentsToWorkplace';
          Enabled := False;
          ImageIndex := Integer(icoidx_workspace_document);
          ShortCut := 16471;
          ActionList := aList;
          OnExecute := actSendDocumentsToWorkplaceExecute;
        end;
        Caption := sCaptionActSendDocumentsToWorkplace;
        Hint := sCaptionActSendDocumentsToWorkplace;
      end;
      if CreateActions then
        TranslateComponent(actSendDocumentsToWorkplace, sSysGnuViewerDomain);

      if CreateActions then
        actInverted := TAction.Create(aList);
      with actInverted do
      begin
        if CreateActions then
        begin
          Name := 'actInverted';
          Enabled := False;
          ImageIndex := Integer(icoidx_document_invert_color);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActInverted;
        Hint := sCaptionActInverted;
      end;
      if CreateActions then
        TranslateComponent(actInverted, sSysGnuViewerDomain);

      if CreateActions then
        actRestoreOriginal := TAction.Create(aList);
      with actRestoreOriginal do
      begin
        if CreateActions then
        begin
          Name := 'actRestoreOriginal';
          Enabled := False;
          ImageIndex := Integer(icoidx_original_restore);
          ActionList := aList;
          OnExecute := actRestoreOriginalExecute;
        end;
        Caption := sCaptionActRestoreOriginal;
        Hint := sCaptionActRestoreOriginal;
      end;
      if CreateActions then
        TranslateComponent(actRestoreOriginal, sSysGnuViewerDomain);

      if CreateActions then
        actRefreshDoc := TAction.Create(aList);
      with actRefreshDoc do
      begin
        if CreateActions then
        begin
          Name := 'actRefreshDoc';
          Enabled := False;
          ImageIndex := Integer(icoidx_document_reload);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActRefreshDoc;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actRefreshDoc, sSysGnuViewerDomain);

      if CreateActions then
        actDuplicateDoc := TAction.Create(aList);
      with actDuplicateDoc do
      begin
        if CreateActions then
        begin
          Name := 'actDuplicateDoc';
          Enabled := False;
          ImageIndex := Integer(icoidx_document_copy);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActDuplicateDoc;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actDuplicateDoc, sSysGnuViewerDomain);

      if CreateActions then
        actExportCSV := TAction.Create(aList);
      with actExportCSV do
      begin
        if CreateActions then
        begin
          Name := 'actExportCSV';
          Enabled := False;
          ImageIndex := Integer(icoidx_export_csv);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActExportCSV;
        Hint := sHintActExportCSV;
      end;
      if CreateActions then
        TranslateComponent(actExportCSV, sSysGnuViewerDomain);

      if CreateActions then
        actDeleteDoc := TAction.Create(aList);
      with actDeleteDoc do
      begin
        if CreateActions then
        begin
          Name := 'actDeleteDoc';
          Enabled := False;
          ImageIndex := Integer(icoidx_delete_nrs);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActDeleteDoc;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actDeleteDoc, sSysGnuViewerDomain);

      if CreateActions then
        actDeScrew := TAction.Create(aList);
      with actDeScrew do
      begin
        if CreateActions then
        begin
          Name := 'actDeScrew';
          Enabled := False;
          ImageIndex := Integer(icoidx_straighten);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActDeScrew;
        Hint := sCaptionActDeScrew;
      end;
      if CreateActions then
        TranslateComponent(actDeScrew, sSysGnuViewerDomain);

      if CreateActions then
        actDeSpeckle := TAction.Create(aList);
      with actDeSpeckle do
      begin
        if CreateActions then
        begin
          Name := 'actDeSpeckle';
          Enabled := False;
          ImageIndex := Integer(icoidx_remove_dots);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActDeSpeckle;
        Hint := sCaptionActDeSpeckle;
      end;
      if CreateActions then
        TranslateComponent(actDeSpeckle, sSysGnuViewerDomain);

      if CreateActions then
        actRemoveBorder := TAction.Create(aList);
      with actRemoveBorder do
      begin
        if CreateActions then
        begin
          Name := 'actRemoveBorder';
          Enabled := False;
          ImageIndex := Integer(icoidx_cut_border);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActRemoveBorder;
        Hint := sCaptionActRemoveBorder;
      end;
      if CreateActions then
        TranslateComponent(actRemoveBorder, sSysGnuViewerDomain);

      if CreateActions then
        actRotateLeft := TAction.Create(aList);
      with actRotateLeft do
      begin
        if CreateActions then
        begin
          Name := 'actRotateLeft';
          Enabled := False;
          ImageIndex := Integer(icoidx_rotate_left);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActRotateLeft;
        Hint := sCaptionActRotateLeft;
      end;
      if CreateActions then
        TranslateComponent(actRotateLeft, sSysGnuViewerDomain);

      if CreateActions then
        actExportXLS := TAction.Create(aList);
      with actExportXLS do
      begin
        if CreateActions then
        begin
          Name := 'actExportXLS';
          Enabled := False;
          ImageIndex := Integer(icoidx_export_xls);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActExportXLS;
        Hint := sHintActExportXLS;
      end;
      if CreateActions then
        TranslateComponent(actExportXLS, sSysGnuViewerDomain);

      if CreateActions then
        actExportOO := TAction.Create(aList);
      with actExportOO do
      begin
        if CreateActions then
        begin
          Name := 'actExportOO';
          Enabled := False;
          ImageIndex := Integer(icoidx_export_odt);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActExportOO;
        Hint := sHintActExportOO;
      end;
      if CreateActions then
        TranslateComponent(actExportOO, sSysGnuViewerDomain);

      if CreateActions then
        actFlip := TAction.Create(aList);
      with actFlip do
      begin
        if CreateActions then
        begin
          Name := 'actFlip';
          Enabled := False;
          ImageIndex := Integer(icoidx_rotate_180);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActFlip;
        Hint := sCaptionActFlip;
      end;
      if CreateActions then
        TranslateComponent(actFlip, sSysGnuViewerDomain);

      if CreateActions then
        actRotateRight := TAction.Create(aList);
      with actRotateRight do
      begin
        if CreateActions then
        begin
          Name := 'actRotateRight';
          Enabled := False;
          ImageIndex := Integer(icoidx_rotate_right);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActRotateRight;
        Hint := sCaptionActRotateRight;
      end;
      if CreateActions then
        TranslateComponent(actRotateRight, sSysGnuViewerDomain);

      if CreateActions then
        actMergeDoc := TAction.Create(aList);
      with actMergeDoc do
      begin
        if CreateActions then
        begin
          Name := 'actMergeDoc';
          ImageIndex := Integer(icoidx_document_merge);
          Enabled := False;
          ActionList := aList;
          OnExecute := actMergeDocExecute;
        end;
        Caption := sCaptionActMergeDoc;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actMergeDoc, sSysGnuViewerDomain);

      if CreateActions then
        actPreviousPage := TAction.Create(aList);
      with actPreviousPage do
      begin
        if CreateActions then
        begin
          Name := 'actPreviousPage';
          ImageIndex := Integer(icoidx_arrow_left);
          Enabled := False;
          ActionList := aList;
          OnExecute := actPreviousPageExecute;
        end;
        Caption := sCaptionActPreviousPage;
        Hint := sCaptionActPreviousPage;
      end;
      if CreateActions then
        TranslateComponent(actPreviousPage, sSysGnuViewerDomain);

      if CreateActions then
        actNextPage := TAction.Create(aList);
      with actNextPage do
      begin
        if CreateActions then
        begin
          Name := 'actNextPage';
          ImageIndex := Integer(icoidx_arrow_right);
          Enabled := False;
          ActionList := aList;
          OnExecute := actNextPageExecute;
        end;
        Caption := sCaptionActNextPage;
        Hint := sCaptionActNextPage;
      end;
      if CreateActions then
        TranslateComponent(actNextPage, sSysGnuViewerDomain);

      if CreateActions then
        actPublicAnno := TAction.Create(aList);
      with actPublicAnno do
      begin
        if CreateActions then
        begin
          Name := 'actPublicAnno';
          ImageIndex := Integer(icoidx_annotation_public);
          Enabled := False;
          ActionList := aList;
          OnExecute := actPublicAnnoExecute;
        end;
        Caption := sCaptionActPublicAnno;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actPublicAnno, sSysGnuViewerDomain);

      if CreateActions then
        actPrivateAnno := TAction.Create(aList);
      with actPrivateAnno do
      begin
        if CreateActions then
        begin
          Name := 'actPrivateAnno';
          ImageIndex := Integer(icoidx_annotation_private);
          Enabled := False;
          ActionList := aList;
          OnExecute := actPrivateAnnoExecute;
        end;
        Caption := sCaptionActPrivateAnno;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actPrivateAnno, sSysGnuViewerDomain);

      if CreateActions then
        actStationery := TAction.Create(aList);
      with actStationery do
      begin
        if CreateActions then
        begin
          Name := 'actStationery';
          ImageIndex := Integer(icoidx_letter);
          Enabled := False;
          ActionList := aList;
          OnExecute := actStationeryExecute;
        end;
        Caption := sCaptionActStationery;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actStationery, sSysGnuViewerDomain);

      if CreateActions then
        actFtxPos := TAction.Create(aList);
      with actFtxPos do
      begin
        if CreateActions then
        begin
          Name := 'actFtxPos';
          Enabled := False;
          ImageIndex := Integer(icoidx_search_result_highlighting);
          OnExecute := frmMainForm.actFtxPosExecute;
        end;
        Caption := sEmptyString;
        Hint := sHintActFtxPos;
      end;
      if CreateActions then
        TranslateComponent(actFtxPos, sSysGnuViewerDomain);

      if CreateActions then
        actAutozoom := TAction.Create(aList);
      with actAutozoom do
      begin
        if CreateActions then
        begin
          Name := 'actAutozoom';
          ImageIndex := Integer(icoidx_preview_auto);
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionactAutozoom;
        Hint := sCaptionactAutozoom;
      end;
      if CreateActions then
        TranslateComponent(actAutozoom, sSysGnuViewerDomain);

      if CreateActions then
        actZoom100 := TAction.Create(aList);
      with actZoom100 do
      begin
        if CreateActions then
        begin
          Name := 'actZoom100';
          ImageIndex := Integer(icoidx_preview_original);
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActZoom100;
        Hint := sCaptionActZoom100;
      end;
      if CreateActions then
        TranslateComponent(actZoom100, sSysGnuViewerDomain);

      if CreateActions then
        actZoomPage := TAction.Create(aList);
      with actZoomPage do
      begin
        if CreateActions then
        begin
          Name := 'actZoomPage';
          ImageIndex := Integer(icoidx_preview_auto);
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActZoomPage;
        Hint := sCaptionActZoomPage;
      end;
      if CreateActions then
        TranslateComponent(actZoomPage, sSysGnuViewerDomain);

      if CreateActions then
        actZoomWidth := TAction.Create(aList);
      with actZoomWidth do
      begin
        if CreateActions then
        begin
          Name := 'actZoomWidth';
          ImageIndex := Integer(icoidx_preview_width);
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActZoomWidth;
        Hint := sCaptionActZoomWidth;
      end;
      if CreateActions then
        TranslateComponent(actZoomWidth, sSysGnuViewerDomain);

      if CreateActions then
        actZoomHeight := TAction.Create(aList);
      with actZoomHeight do
      begin
        if CreateActions then
        begin
          Name := 'actZoomHeight';
          ImageIndex := Integer(icoidx_preview_height);
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActZoomHeight;
        Hint := sCaptionActZoomHeight;
      end;
      if CreateActions then
        TranslateComponent(actZoomHeight, sSysGnuViewerDomain);

      if CreateActions then
        actZoomSelect := TAction.Create(aList);
      with actZoomSelect do
      begin
        if CreateActions then
        begin
          Name := 'actZoomSelect';
          ImageIndex := Integer(icoidx_select);
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActZoomSelect;
        Hint := sCaptionActZoomSelect;
      end;
      if CreateActions then
        TranslateComponent(actZoomSelect, sSysGnuViewerDomain);

      if CreateActions then
        actZoomOff := TAction.Create(aList);
      with actZoomOff do
      begin
        if CreateActions then
        begin
          Name := 'actZoomOff';
          ImageIndex := Integer(icoidx_preview_no_autozoom);
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActZoomOff;
        Hint := sCaptionActZoomOff;
      end;
      if CreateActions then
        TranslateComponent(actZoomOff, sSysGnuViewerDomain);

      if CreateActions then
        actAuditProof := TAction.Create(aList);
      with actAuditProof do
      begin
        if CreateActions then
        begin
          Name := 'actAuditProof';
          ImageIndex := Integer(icoidx_lock);
          Enabled := False;
          ActionList := aList;
          OnExecute := actAuditProofExecute;
        end;
        Caption := sCaptionActAuditProof;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAuditProof, sSysGnuViewerDomain);

      if CreateActions then
        actEditTags := TAction.Create(aList);
      with actEditTags do
      begin
        if CreateActions then
        begin
          Name := 'actEditTags';
          ImageIndex := Integer(icoidx_tag_edit);
          Enabled := False;
          ActionList := aList;
          OnExecute := actEditTagsExecute;
        end;
        Caption := sCaptionActEditTags;
        Hint := sCaptionActEditTags;
      end;
      if CreateActions then
        TranslateComponent(actEditTags, sSysGnuViewerDomain);

      if CreateActions then
        actNewLink := TAction.Create(aList);
      with actNewLink do
      begin
        if CreateActions then
        begin
          Name := 'actNewLink';
          ImageIndex := Integer(icoidx_link_create);
          Enabled := False;
          ShortCut := 41046;
          ActionList := aList;
          OnExecute := actNewLinkExecute;
        end;
        Caption := sCaptionActNewLink;
        Hint := sCaptionActNewLink;
      end;
      if CreateActions then
        TranslateComponent(actNewLink, sSysGnuViewerDomain);

      if CreateActions then
        actAddLink := TAction.Create(aList);
      with actAddLink do
      begin
        if CreateActions then
        begin
          Name := 'actAddLink';
          ImageIndex := Integer(icoidx_document_link_add);
          Enabled := False;
          ActionList := aList;
          OnExecute := actAddLinkExecute;
        end;
        Caption := sCaptionActAddLink;
        Hint := sCaptionActAddLink;
      end;
      if CreateActions then
        TranslateComponent(actAddLink, sSysGnuViewerDomain);

      if CreateActions then
        actInProgress := TAction.Create(aList);
      with actInProgress do
      begin
        if CreateActions then
        begin
          Name := 'actInProgress';
          Enabled := False;
          ImageIndex := Integer(icoidx_edit);
          ActionList := aList;
          OnExecute := actInProgressExecute;
        end;
        Caption := sCaptionActInProgress;
        Hint := sHintActInProgress;
      end;
      if CreateActions then
        TranslateComponent(actInProgress, sSysGnuViewerDomain);

      if CreateActions then
        actIsAuditProof := TAction.Create(aList);
      with actIsAuditProof do
      begin
        if CreateActions then
        begin
          Name := 'actIsAuditProof';
          Enabled := False;
          ImageIndex := Integer(icoidx_lock);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActIsAuditProof;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actIsAuditProof, sSysGnuViewerDomain);

      if CreateActions then
        actDeletePages := TAction.Create(aList);
      with actDeletePages do
      begin
        if CreateActions then
        begin
          Name := 'actDeletePages';
          Enabled := False;
          ImageIndex := Integer(icoidx_page_delete);
          ActionList := aList;
          OnExecute := actDeletePagesExecute;
        end;
        Caption := sCaptionActDeletePages;
        Hint := sCaptionActDeletePages;
      end;
      if CreateActions then
        TranslateComponent(actDeletePages, sSysGnuViewerDomain);

      if CreateActions then
        actChangeDocName := TAction.Create(aList);
      with actChangeDocName do
      begin
        if CreateActions then
        begin
          Name := 'actChangeDocName';
          Enabled := False;
          ImageIndex := Integer(icoidx_rename_document);
          ShortCut := 16466; // Strg + R
  //        ShortCut := 16462; // Strg + N  ->  neues Fenster
          ActionList := aList;
          OnExecute := actChangeDocNameExecute;
        end;
        Caption := sCaptionActChangeDocName;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actChangeDocName, sSysGnuViewerDomain);

      if CreateActions then
        actAutoRef := TAction.Create(aList);
      with actAutoRef do
      begin
        if CreateActions then
        begin
          Name := 'actAutoRef';
          Enabled := False;
          ImageIndex := Integer(icoidx_autoreference);
          ActionList := aList;
          OnExecute := actAutoRefExecute;
        end;
        Caption := sCaptionActAutoRef;
        Hint := sCaptionActAutoRef;
      end;
      if CreateActions then
        TranslateComponent(actAutoRef, sSysGnuViewerDomain);

      if CreateActions then
        actShareLayer := TAction.Create(aList);
      with actShareLayer do
      begin
        if CreateActions then
        begin
          Name := 'actShareLayer';
          Enabled := False;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActShareLayer;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actShareLayer, sSysGnuViewerDomain);

      if CreateActions then
        actFirstPage := TAction.Create(aList);
      with actFirstPage do
      begin
        if CreateActions then
        begin
          Name := 'actFirstPage';
          Enabled := False;
          ActionList := aList;
          OnExecute := actFirstPageExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actFirstPage, sSysGnuViewerDomain);

      if CreateActions then
        actLastPage := TAction.Create(aList);
      with actLastPage do
      begin
        if CreateActions then
        begin
          Name := 'actLastPage';
          Enabled := False;
          ActionList := aList;
          OnExecute := actLastPageExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actLastPage, sSysGnuViewerDomain);

      if CreateActions then
        actCreateCopy := TAction.Create(aList);
      with actCreateCopy do
      begin
        if CreateActions then
        begin
          Name := 'actCreateCopy';
          Enabled := False;
          ImageIndex := Integer(icoidx_workspace_copy);
          ActionList := aList;
          OnExecute := actCreateCopyExecute;
        end;
        Caption := sCaptionActCreateCopy;
        Hint := sCaptionActCreateCopy;
      end;
      if CreateActions then
        TranslateComponent(actCreateCopy, sSysGnuViewerDomain);

      if CreateActions then
        actCopyDocToClipboard := TAction.Create(aList);
      with actCopyDocToClipboard do
      begin
        if CreateActions then
        begin
          Name := 'actCopyDocToClipboard';
          Enabled := False;
          ImageIndex := Integer(icoidx_clipboard);
          ShortCut := 16429;
          ActionList := aList;
          OnExecute := frmMainForm.actCopyDocToClipboardExecute;
        end;
        Caption := sCaptionActCopyDocToClipboard;
        Hint := sCaptionActCopyDocToClipboard;
      end;
      if CreateActions then
        TranslateComponent(actCopyDocToClipboard, sSysGnuViewerDomain);

      if CreateActions then
        actSaveImportValues := TAction.Create(aList);
      with actSaveImportValues do
      begin
        if CreateActions then
        begin
          Name := 'actSaveImportValues';
          Enabled := False;
          ImageIndex := Integer(icoidx_fields_save);
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActSaveImportValues;
        Hint := sCaptionActSaveImportValues;
      end;
      if CreateActions then
        TranslateComponent(actSaveImportValues, sSysGnuViewerDomain);

      if CreateActions then
        actInsert := TAction.Create(aList);
      with actInsert do
      begin
        if CreateActions then
        begin
          Name := 'actInsert';
          Enabled := True;
          ShortCut := VK_INSERT;
          ActionList := aList;
          OnExecute := actInsertExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actInsert, sSysGnuViewerDomain);

      if CreateActions then
        actAltN := TAction.Create(aList);
      with actAltN do
      begin
        if CreateActions then
        begin
          Name := 'actAltN';
          Enabled := True;
          Shortcut := 32846;
          ActionList := aList;
          OnExecute := actAltNExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAltN, sSysGnuViewerDomain);

      if CreateActions then
        actZoomIn1 := TAction.Create(aList);
      with actZoomIn1 do
      begin
        if CreateActions then
        begin
          Name := 'actZoomIn1';
          Enabled := False;
          Shortcut := 32955; // Alt +
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actZoomIn1, sSysGnuViewerDomain);

      if CreateActions then
        actZoomIn2 := TAction.Create(aList);
      with actZoomIn2 do
      begin
        if CreateActions then
        begin
          Name := 'actZoomIn2';
          Enabled := False;
          Shortcut := 32875; // Alt + (Zehnertastatur)
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actZoomIn2, sSysGnuViewerDomain);

      if CreateActions then
        actZoomOut1 := TAction.Create(aList);
      with actZoomOut1 do
      begin
        if CreateActions then
        begin
          Name := 'actZoomOut1';
          Enabled := False;
          Shortcut := 32957; // Alt -
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actZoomOut1, sSysGnuViewerDomain);

      if CreateActions then
        actZoomOut2 := TAction.Create(aList);
      with actZoomOut2 do
      begin
        if CreateActions then
        begin
          Name := 'actZoomOut2';
          Enabled := False;
          Shortcut := 32877; // Alt - (Zehnertastatur)
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actZoomOut2, sSysGnuViewerDomain);

      if CreateActions then
        actSyncFulltextZoom := TAction.Create(aList);
      with actSyncFulltextZoom do
      begin
        if CreateActions then
        begin
          Name := 'actSyncFulltextZoom';
          Enabled := True;
          ActionList := aList;
          OnExecute := bitfarmApp.SyncFulltextZoom;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actSyncFulltextZoom, sSysGnuViewerDomain);

      if CreateActions then
        actScrollLeft := TAction.Create(aList);
      with actScrollLeft do
      begin
        if CreateActions then
        begin
          Name := 'actScrollLeft';
          Enabled := False;
          Shortcut := 32805; // Alt Pfeil-Links
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actScrollLeft, sSysGnuViewerDomain);

      if CreateActions then
        actScrollRight := TAction.Create(aList);
      with actScrollRight do
      begin
        if CreateActions then
        begin
          Name := 'actScrollRight';
          Enabled := False;
          Shortcut := 32807; // Alt Pfeil-Rechts
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actScrollRight, sSysGnuViewerDomain);

      if CreateActions then
        actScrollUp := TAction.Create(aList);
      with actScrollUp do
      begin
        if CreateActions then
        begin
          Name := 'actScrollUp';
          Enabled := False;
          Shortcut := 32806; // Alt Pfeil-Hoch
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actScrollUp, sSysGnuViewerDomain);

      if CreateActions then
        actScrollDown := TAction.Create(aList);
      with actScrollDown do
      begin
        if CreateActions then
        begin
          Name := 'actScrollDown';
          Enabled := False;
          Shortcut := 32808; // Alt Pfeil-Runter
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actScrollDown, sSysGnuViewerDomain);

      if CreateActions then
        actCallDoSave := TAction.Create(aList);
      with actCallDoSave do
      begin
        if CreateActions then
        begin
          Name := 'actCallDoSave';
          Enabled := True;
          ActionList := aList;
          OnExecute := actListExecute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actCallDoSave, sSysGnuViewerDomain);

      if CreateActions then
        actUndockInNewTab := TAction.Create(aList);
      with actUndockInNewTab do
      begin
        if CreateActions then
        begin
          Name := 'actUndockInNewTab';
          Enabled := False;
          ShortCut := 16468; // Strg + T
          ImageIndex := Integer(icoidx_open_new_tab);
          ActionList := aList;
          OnExecute := bitfarmApp.actUndockInNewTabExecute;
        end;
        Caption := sCaptionActUndockInNewTab;
        Hint := sCaptionActUndockInNewTab;
      end;
      if CreateActions then
        TranslateComponent(actUndockInNewTab, sSysGnuViewerDomain);

      if CreateActions then
        actUndockInNewWindow := TAction.Create(aList);
      with actUndockInNewWindow do
      begin
        if CreateActions then
        begin
          Name := 'actUndockInNewWindow';
          Enabled := False;
          ShortCut := 16462; // Strg + N
          ImageIndex := Integer(icoidx_open_new_window);
          ActionList := aList;
          OnExecute := bitfarmApp.actUndockInNewWindowExecute;
        end;
        Caption := sCaptionActUndockInNewWindow;
        Hint := sCaptionActUndockInNewWindow;
      end;
      if CreateActions then
        TranslateComponent(actUndockInNewWindow, sSysGnuViewerDomain);

      if CreateActions then
        actF2 := TAction.Create(aList);
      with actF2 do
      begin
        if CreateActions then
        begin
          Name := 'actF2';
          Enabled := True;
          ShortCut := VK_F2;
          ActionList := aList;
          OnExecute := bitfarmApp.actF2Execute;
        end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actF2, sSysGnuViewerDomain);

      if CreateActions then
        actCollectDocs := TAction.Create(actListPreview);
      with actCollectDocs do
      begin
        if CreateActions then
        begin
          Name := 'actCollectDocs';
          Enabled := True;
          ImageIndex := Integer(icoidx_document_reserve);
          ActionList := actListPreview;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActCollectDocs;
        Hint := sHintActCollectDocs;
      end;
      if CreateActions then
        TranslateComponent(actCollectDocs, sSysGnuViewerDomain);

      if CreateActions then
        actCancelCollection := TAction.Create(actListPreview);
      with actCancelCollection do
      begin
        if CreateActions then
        begin
          Name := 'actCancelCollection';
          Enabled := False;
          ImageIndex := Integer(icoidx_document_reserve_remove);
          ActionList := actListPreview;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActCancelCollection;
        Hint := sHintActCancelCollection;
      end;
      if CreateActions then
        TranslateComponent(actCancelCollection, sSysGnuViewerDomain);

      if CreateActions then
        actSaveCollectionPDF := TAction.Create(actListPreview);
      with actSaveCollectionPDF do
      begin
        if CreateActions then
        begin
          Name := 'actSaveCollectionPDF';
          Enabled := True;
          ImageIndex := Integer(icoidx_document_reserve_save_pdf);
          ActionList := actListPreview;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActSaveCollectionPDF;
        Hint := sHintActSaveCollectionPDF;
      end;
      if CreateActions then
        TranslateComponent(actSaveCollectionPDF, sSysGnuViewerDomain);

      if CreateActions then
        actSaveCollectionSinglePDF := TAction.Create(actListPreview);
      with actSaveCollectionSinglePDF do
      begin
        if CreateActions then
        begin
          Name := 'actSaveCollectionSinglePDF';
          Enabled := True;
          ImageIndex := Integer(icoidx_document_reserve_save_pdf);
          ActionList := actListPreview;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActSaveCollectionSinglePDF;
        Hint := sHintActSaveCollectionSinglePDF;
      end;
      if CreateActions then
        TranslateComponent(actSaveCollectionSinglePDF, sSysGnuViewerDomain);

      if CreateActions then
        actSaveCollectionTIF := TAction.Create(actListPreview);
      with actSaveCollectionTIF do
      begin
        if CreateActions then
        begin
          Name := 'actSaveCollectionTIF';
          Enabled := True;
          ImageIndex := Integer(icoidx_document_reserve_save_tif);
          ActionList := actListPreview;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActSaveCollectionTIF;
        Hint := sHintActSaveCollectionTIF;
      end;
      if CreateActions then
        TranslateComponent(actSaveCollectionTIF, sSysGnuViewerDomain);

      if CreateActions then
        actSaveCollectionOriginal := TAction.Create(actListPreview);
      with actSaveCollectionOriginal do
      begin
        if CreateActions then
        begin
          Name := 'actSaveCollectionOriginal';
          Enabled := True;
          ImageIndex := Integer(icoidx_document_reserve_save_file);
          ActionList := actListPreview;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActSaveCollectionOriginal;
        Hint := sHintActSaveCollectionOriginal;
      end;
      if CreateActions then
        TranslateComponent(actSaveCollectionOriginal, sSysGnuViewerDomain);

      if CreateActions then
        actEmailCollectionPDF := TAction.Create(actListPreview);
      with actEmailCollectionPDF do
      begin
        if CreateActions then
        begin
          Name := 'actEmailCollectionPDF';
          Enabled := True;
          ImageIndex := Integer(icoidx_document_reserve_mail_pdf);
          ActionList := actListPreview;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActEmailCollectionPDF;
        Hint := sHintActEmailCollectionPDF;
      end;
      if CreateActions then
        TranslateComponent(actEmailCollectionPDF, sSysGnuViewerDomain);

      if CreateActions then
        actEmailCollectionSinglePDF := TAction.Create(actListPreview);
      with actEmailCollectionSinglePDF do
      begin
        if CreateActions then
        begin
          Name := 'actEmailCollectionSinglePDF';
          Enabled := True;
          ImageIndex := Integer(icoidx_document_reserve_mail_pdf);
          ActionList := actListPreview;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActEmailCollectionSinglePDF;
        Hint := sHintActEmailCollectionSinglePDF;
      end;
      if CreateActions then
        TranslateComponent(actEmailCollectionSinglePDF, sSysGnuViewerDomain);

      if CreateActions then
        actEmailCollectionTIF := TAction.Create(actListPreview);
      with actEmailCollectionTIF do
      begin
        if CreateActions then
        begin
          Name := 'actEmailCollectionTIF';
          Enabled := True;
          ImageIndex := Integer(icoidx_document_reserve_mail_tif);
          ActionList := actListPreview;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActEmailCollectionTIF;
        Hint := sHintActEmailCollectionTIF;
      end;
      if CreateActions then
        TranslateComponent(actEmailCollectionTIF, sSysGnuViewerDomain);

      if CreateActions then
        actEmailCollectionOriginal := TAction.Create(actListPreview);
      with actEmailCollectionOriginal do
      begin
        if CreateActions then
        begin
          Name := 'actEmailCollectionOriginal';
          Enabled := True;
          ImageIndex := Integer(icoidx_document_reserve_mail_file);
          ActionList := actListPreview;
          OnExecute := actListExecute;
        end;
        Caption := sCaptionActEmailCollectionOriginal;
        Hint := sHintActEmailCollectionOriginal;
      end;
      if CreateActions then
        TranslateComponent(actEmailCollectionOriginal, sSysGnuViewerDomain);
    except
      bitfarmLog.Write(llNormal, ltException, 'CreateActions', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateActions', Classname);
  end;
end;

procedure TfrmGPL.TreeView1CustomDrawItem(Sender: TCustomTreeView; Node: TTreeNode;
  State: TCustomDrawState; var DefaultDraw: Boolean);
var
  pt: TPoint;
  FontColor: TColor;
  BackColor: TColor;
begin
  pt := mouse.CursorPos;
  pt := Sender.ScreenToClient(pt);
  if (Node <> nil) and Node.Focused and (Node = Sender.GetNodeAt(pt.X, pt.Y)) then
  begin
    with Sender.Canvas do
    begin
      Brush.Color := stlSelected.color;
      Font.Color := stlSelected.TextColor;
    end;
  end
  else
  begin
    if Node <> nil then
      Node.Focused := False;

    with Sender.Canvas do
    begin
      if TbfaTreeView(Sender).ViewKind = tvkImporter then
      begin
        Brush.Color := stlControl.color;
        Font.Color := stlControl.TextColor;
      end
      else
      begin
        Brush.Color := stlControl.color;
        Font.Color := stlControl.TextColor;
      end
    end;
  end;

  if cdsSelected in State then
    Sender.Canvas.Font.Style := Sender.Canvas.Font.Style + [fsBold];
  DefaultDraw := True;
end;

procedure TfrmGPL.TreeMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  gc: Tpoint;
begin
  try
    gc := FViewerTreeview.ScreenToClient(Point(X, Y));
    MouseOverRow := gc.Y;
  except
  //
  end;
end;

procedure TfrmGPL.SetMainFormFocus;
begin
  try
    begin
      case bitfarmApp.CurrentView of
        tvkViewer:
          Self.FViewerTreeview.SetFocus;
        tvkImporter:
          Self.FImporterTreeview.SetFocus;
        tvkAdministrator:
        begin
          if Self.FAdminTreeview <> nil then //08.03.2024 Wegen Offline Viewer
            Self.FAdminTreeview.SetFocus;
        end;
        tvkFavorites:
          Self.trvBookmarks.SetFocus;
        tvkWorkplace:
        begin
          if bitfarmApp.PreviewContainer.WorkplaceItem.Panel.visible then //31.08.2022 hat manchmal ins exception gelaufen, weil noch nicht dargestellt war z.B. nachde start von WVL zu Arbeitsplatz
          begin
            if (bitfarmApp.GetActivePreview <> nil) and (bitfarmApp.GetActivePreview.PreviewKind = pvkMulti) then
              bitfarmApp.GetActivePreview.MultiView.SetFocus
            else
              bitfarmApp.GetActivePreview.SingleView.img_DocView.SetFocus;
          end;
        end;
        tvkResub:  // grdResultList Focus @ MainForm TQueryThread.Execute
//          if not Self.fraResub.btnDelegateTasks.Checked then  //11.09.2024 SD <--bfacrm:ticket__show__39894
//            Self.fraResub.btnMyTasks.SetFocus;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetMainFormFocus', ClassName);
  end;
end;

procedure TfrmGPL.SetMainFormTabStop;
begin
  try
    bitfarmLog.Write(llDebug, ltDebug, 'SetMainFormTabStop', ClassName);

    SetTabStop(pnlTreeView, False);
    SetTabStop(fraImporter, False);
    SetTabStop(fraWorkplace, (bitfarmApp.CurrentView = tvkWorkplace));

    fraWorkplace.TabStop := False;
    fraWorkplace.SpTBXGroupBox1.TabStop := False;

    SetTabStop(fraResub, (bitfarmApp.CurrentView = tvkResub));
    fraResub.TabStop := False;
    fraResub.ResubScrollBox.TabStop := False;
    fraResub.SpTBXToolbar1.TabStop := False;

    FViewerTreeview.TabStop := (bitfarmApp.CurrentView = tvkViewer);
    FImporterTreeView.TabStop := (bitfarmApp.CurrentView = tvkImporter);

    if FAdminTreeview <> nil then
      FAdminTreeview.TabStop := (bitfarmApp.CurrentView = tvkAdministrator);

    trvBookmarks.TabStop := (bitfarmApp.CurrentView = tvkFavorites);
    except
      bitfarmLog.Write(llNormal, ltException, 'SetMainFormTabStop', ClassName);
    end;
  end;

procedure TfrmGPL.SetMouseOverRow(const Value: integer);
var
  Accept: Boolean;
begin
//  if fMouseOverRow <> Value then
//  begin
//    fMouseOverRow := Value;
//    FViewerTreeview.Repaint;
//          FViewerTreeview.Update;
//          FViewerTreeview.Refresh;
//    TreeView1CustomDrawItem(FViewerTreeview, nil, [], Accept);

//  end;
end;

// 08.06.2017 Ticket 10801 -->
procedure TfrmGPL.WMQueryEndSession(var Message: TWMQueryEndSession);
begin
  FWindowsIsShuttingDown := True;
  inherited;
end;

procedure TfrmGPL.WMEndSession(var Message: TWMEndSession);
begin
  FWindowsIsShuttingDown := Message.EndSession;
  inherited;
end;
// 08.06.2017 Ticket 10801 <--

// Ticket 14129: Navigieren durch Annos (Tab wird abgefangen)
procedure TfrmGPL.CMDialogKey(var Message: TCMDialogKey);
begin
  // Wir fangen die Message ab
  if     (message.charcode =  vk_tab)
     and (bitfarmApp.GetActivePreview <> nil)
     and (bitfarmApp.GetActivePreview.SingleView <> nil)
     and (bitfarmApp.GetActivePreview.SingleView.img_DocView <> nil)
     and (bitfarmApp.GetActivePreview.SingleView.img_DocView.SelObjectsCount > 0) then
  begin
    exit;
  end;

  inherited; //Standardverhalten sicherstellen
end;

//27.09.2017 Ticket 12011 -->
procedure TfrmGPL.EmptyKeyQueue;
var
  Msg: TMsg;
begin
  while PeekMessage(Msg, 0, WM_KEYFIRST, WM_KEYLAST,
    PM_REMOVE or PM_NOYIELD) do;
end;

procedure TfrmGPL.tmrHeartbeatTimer(Sender: TObject);
var
  UserAction: PUserAction;
begin
  if bitfarmApp.OriginalfileLock or bitfarmApp.FSkipDoQueueCount or bitfarmApp.OfflineMode then
    Exit;

  // hier brauchen wir das auch, weil entweder luft DoQueueCount ODER DOHeartbeat
  //25.07.2024 FS -->bfacrm:ticket__show__38700
  if bitfarmApp.Autoreconnect and ((Screen.ActiveControl.Owner is TfrmOptions) or (Screen.ActiveControl.Owner is TfrmCreateGlobalBookmark)
    or (Screen.ActiveControl.Owner is TfrmExport) or (Screen.ActiveControl.Owner is Tfrm_info)
    or (Screen.ActiveControl.Owner is TfrmTags) or (Screen.ActiveControl.Owner is Tfrm_NewDocLink)  //10.09.2024 SD <--bfacrm:ticket__show__39893
    //16.10.2024 SD -->bfacrm:ticket__show__40274
    or (Screen.ActiveControl.Owner is TfrmQuickPreview) or (Screen.ActiveControl.Owner is TfrmInfoBox) or (Screen.ActiveControl.Owner is TfrmPrivateLayer)
    or (Screen.ActiveControl.Owner is Tfrm_Dialog) or (Screen.ActiveControl.Owner is TfrmShowBookmark)
    //16.10.2024 SD <--bfacrm:ticket__show__40274
    ) then
  begin
        bitfarmApp.DoHeartBeat(nil);
  //25.07.2024 FS <--bfacrm:ticket__show__38700
  end else
  begin
    UserAction := bitfarmApp.CreateUserAction;
    UserAction^.ActionName := 'actDoHeartBeat';
    bitfarmApp.MainThread.Add(UserAction);
  end;

end;

//procedure TfrmGPL.tmrQueueCountTimer(Sender: TObject);
//begin
//  if not bitfarmApp.OfflineMode then
//    bitfarmApp.DoQueueCount;
//  tmrQueueCount.Interval := 25000;  // nach dem Start, wo nach 2 sec abgefragt wird, stellen wir auf 25 sec
//end;

procedure TfrmGPL.tmrQueueCountTimer(Sender: TObject);
var
  UserAction: PUserAction;
//  ActControl: TWinControl;  //03.07.2024 SD <--bfacrm:ticket__show__38700
begin
  tmrQueueCount.Interval := 30000;  // nach dem Start, wo nach 2 sec abgefragt wird, stellen wir auf 30 sec

  if bitfarmApp.OriginalfileLock or bitfarmApp.FSkipDoQueueCount or bitfarmApp.OfflineMode then
    Exit;


  //03.07.2024 SD -->bfacrm:ticket__show__38700
  if bitfarmApp.Autoreconnect and ((Screen.ActiveControl.Owner is TfrmOptions) or (Screen.ActiveControl.Owner is TfrmCreateGlobalBookmark)
    or (Screen.ActiveControl.Owner is TfrmExport) or (Screen.ActiveControl.Owner is Tfrm_info)
    or (Screen.ActiveControl.Owner is TfrmTags) or (Screen.ActiveControl.Owner is Tfrm_NewDocLink)  //10.09.2024 SD <--bfacrm:ticket__show__39893
    //16.10.2024 SD -->bfacrm:ticket__show__40274
    or (Screen.ActiveControl.Owner is TfrmQuickPreview) or (Screen.ActiveControl.Owner is TfrmInfoBox) or (Screen.ActiveControl.Owner is TfrmPrivateLayer)
    or (Screen.ActiveControl.Owner is Tfrm_Dialog) or (Screen.ActiveControl.Owner is TfrmShowBookmark)
    //16.10.2024 SD <--bfacrm:ticket__show__40274
    ) then
      bitfarmApp.DoQueueCount(nil)
  //03.07.2024 SD <--bfacrm:ticket__show__38700
  else
  begin
    UserAction := bitfarmApp.CreateUserAction;
    UserAction^.ActionName := 'actDoQueueCount';
    bitfarmApp.MainThread.Add(UserAction);
  end;

end;

//27.09.2017 Ticket 12011 <--

// { TQueryThread }
//
//constructor TQueryThread.Create(createsuspended: Boolean);
//begin
//  inherited Create(createsuspended);
//  locate_gdocid := 0;
//  AutoCheckout := False; // SJ 01.12.2021 - bfacrm:ticket__show__28712
//end;
//
//procedure TQueryThread.ExpandGroupRecursive(var AGroup: TcxGridGroupRow; var b: Boolean);
//begin
//  try
//    if (AGroup <> nil) and not AGroup.IsData then
//    begin
//      AGroup.Expand(False);
//      try
//        b := AGroup.Expanded;
//      except
//        b := False; //22.07.2022 Ticket 31661/1 manchmal Expanded nicht erreichbar
//      end;
//      if (b and (AGroup.ValueCount > 1)) or AGroup.IsData then
//        dbView.Controller.FocusNextRecordWithSelection(AGroup.Index, True, False, True);
//
//      if (dbView.Controller.FocusedRecord <> nil) and not dbView.Controller.FocusedRecord.IsData then
//      begin
//        AGroup := (dbView.Controller.FocusedRecord as TcxGridGroupRow);
//        try
//          b := AGroup.Expanded;
//        except
//          b := False; //22.07.2022 31661/1 manchmal Expanded nicht erreichbar
//        end;
//        if not b and not AGroup.IsData then
//          ExpandGroupRecursive(AGroup, b);
//      end;
//    end;
//  except
//
//  end;
//end;
//
//procedure TQueryThread.Execute;
//var
//  dsc2: TUniDataSource;
//  tmStart: TTime;
//  sTime: string;
//  OldColor: TColor;
//  arcid: Int64;
//  SL : TStringList;
//  j, k, idx : Integer;
//  foundsymarcid, colsorted : boolean;
//  ErrorStr: string;
//begin
//  inherited;
//  try
//    if not cnt.Connected then
//      cnt.Connect;
//
//    while not Self.Terminated do
//    begin
//      try
//        OldColor := pnl.Color;
//        tmr.Enabled := True;
//        tmStart := GetTime;
//        Synchronize(
//          procedure
//          begin
//            Screen.Cursor := crHourGlass;
//            dbView.DataController.DataSource := nil;
//            pnl.Caption := ' ' + _('Suche aktiv ...');
//            bitfarmApp.ResubListLoaded := False;
//          end);
//
//        try
//          if dsc <> nil then
//            dsc.Free;
//
//          dsc := TUniDataSource.Create(nil);
//
//          SL := TStringList.Create;
//          try
//            SL.CommaText := SearchObj.SelectedCols;
//            for j := SL.Count - 1 downto 0 do
//            begin
//              if LowerCase(copy(sl[j], 1, 4)) <> 'add_' then
//                SL.Delete(j)
//              else
//              begin
//                for k := Low(aAddfields) to High(aAddfields) do
//                begin
//                  idx := Pos(':', sl[j]);
//                  if idx > 0 then
//                    sl[j] := Copy(Sl[j], 0, Pos(':', sl[j]) - 1);
//
//                  if (aAddfields[k] <> nil) and (aAddfields[k].Name = sl[j]) then
//                  begin
//                    if not ((aAddfields[k].Typ = 3) or (aAddfields[k].Typ = 0)) then  //21.01.2019 die mehr als 255 Charachter sein knnen sonst wird (WideMEMO) in der Trefferliste
//                      SL.Delete(j);
//                    Break;
//                  end;
//                end;
//              end;
//            end;
//            dsc.DataSet := SearchProc.Search(cnt, SearchObj, ErrorStr, SL);
//
//            if ErrorStr <> '' then
//            begin
//              Synchronize(
//              procedure
//              begin
//                Self.SetNotificationBar(ErrorStr);
//              end);
//            end;
//          finally
//            FreeAndNil(SL);
//          end;
//
//          Synchronize(
//            procedure
//            var
//              i: Integer;
//            begin
//              tmr.Enabled := False;
//              pnl.Color := OldColor;
//              pnl.ParentBackground := True;
//
//              tmStart := GetTime - tmStart;
//              DateTimeToString(sTime, 'nn:ss:zzz', tmStart);
//              pnl.Caption := ' ' + sTime;
//
//              if dsc.DataSet <> nil then
//              begin
//                dbView.DataController.DataSource := dsc;
//                if dbView.DataController.DataSource.DataSet.RecordCount > 0 then
//                begin
//                  if bitfarmApp.CurrentView = tvkResub then
//                  begin
//                    if Self.fraResub.btnMyTasks.Checked then
//                    begin
//                      if bitfarmApp.BMResub > 0 then
//                      begin
//                        dbView.Controller.ClearSelection;
//                        dbView.DataController.DataSource.DataSet.Locate('timid', IntToStr(bitfarmApp.BMResub), []);
//                      end;
//                    end
//                    else if Self.fraResub.btnDelegateTasks.Checked then
//                    begin
//                      if bitfarmApp.BMDelegateResub > 0 then
//                      begin
//                        dbView.Controller.ClearSelection;
//                        dbView.DataController.DataSource.DataSet.Locate('timid', IntToStr(bitfarmApp.BMDelegateResub), []);
//                      end;
//                    end;
//                  end
//                  else
//                    if locate_gdocid > 0 then
//                      dbView.DataController.DataSource.DataSet.Locate('gdocid', IntToStr(locate_gdocid), []);
//                  if bitfarmApp.CurrentView = tvkViewer then
//                  begin
//                    if bitfarmApp.GridLastSelectedGdDocID > 0 then
//                    begin
//                      dbView.Controller.ClearSelection;
//                      dbView.DataController.DataSource.DataSet.Locate('gdocid', IntToStr(bitfarmApp.GridLastSelectedGdDocID), []);
//                      bitfarmApp.GridLastSelectedGdDocID := 0;
//                    end;
//                  end;
//
//                  dbview.SetBookmark;
//                  dbview.Controller.FocusedRecord.Selected := True;
//                  dbView.OnSelectionChanged(dbview);
//
//                  if (dbView.Controller.FocusedRecord <> nil) and not dbView.Controller.FocusedRecord.IsData then
//                  begin
//                    var GridGroup: TcxGridGroupRow;
//                    var GroupExpanded: Boolean;
//                    GridGroup := (dbView.Controller.FocusedRecord as TcxGridGroupRow);
//                    GroupExpanded := GridGroup.Expanded;
//                    ExpandGroupRecursive(GridGroup, GroupExpanded);
//                  end;
//
//                  // bfacrm:ticket__show__24708
//                  if (bitfarmApp.GetActivePreview = bitfarmApp.PreviewContainer.ViewerItem.Preview) and
//                     Self.grdResultlistDevEx.Enabled and Self.grdResultlistDevEx.Visible
//                  then
//                    if (Screen.ActiveControl is TbfaGridSite) and
//                       (TbfaGridSite(Screen.ActiveControl).Parent <> nil) and
//                       (TbfaGridSite(Screen.ActiveControl).Parent is TcxGrid) and
//                       (TcxGrid(TbfaGridSite(Screen.ActiveControl).Parent).Owner <> nil) and
//                       (TcxGrid(TbfaGridSite(Screen.ActiveControl).Parent).Owner = Self.fraFloatingResub)
//                    then
//                      TcxGrid(TbfaGridSite(Screen.ActiveControl).Parent).SetFocus
//                    else
//                      Self.grdResultlistDevEx.SetFocus;
//                end
//                else
//                begin
//                  if (pnl.Caption <> '') then
//                    pnl.Caption := '';
//
//                  for i := 0 to aCurrentViewerAddfields.Count - 1 do
//                  begin
//                    if (not aCurrentViewerAddfields[i].ModifiedSearch) and
//                       (aCurrentViewerAddfields[i].Component <> nil)
//                    then
//                      aCurrentViewerAddfields[i].Component.ClearValue;
//                  end;
//                  bitfarmApp.GetActivePreview.SetActions;
//
//                  Self.SetNotificationBar(_('Die Suche ergab keinen Treffer!'), nil); //01.08.2022 Ticket 27900
//                end;
//
//                locate_gdocid := 0;
//              end
//              else
//              begin
//                if (pnl.Caption <> '') then
//                  pnl.Caption := '';
//                dbView.DataController.DataSource := nil;
//                bitfarmApp.GetActivePreview.SetActions;
//              end;
//
//            end);
//        finally
//          Synchronize(
//            procedure
//            begin
//              actHide.Enabled := True;
//              Screen.Cursor := crDefault;
//            end);
//        end;
//
//        // SJ 01.12.2021 - bfacrm:ticket__show__28712
//        try
//          if Self.AutoCheckout and bitfarmApp.ViewerOptions.GeneralOptions.CheckoutNewDocuments then
//          begin
//            var UserAction: PUserAction;
//            UserAction := bitfarmApp.CreateUserAction;
//            UserAction^.ActionName := 'actCheckout';
//            bitfarmApp.MainThread.Add(UserAction);
//
//            UserAction := bitfarmApp.CreateUserAction;
//            UserAction^.ActionName := 'actOriginalfile';
//            UserAction^.Params.Add('edit');
//            bitfarmApp.MainThread.Add(UserAction);
//          end;
//        finally
//          Self.AutoCheckout := False;
//        end;
//        // SJ 01.12.2021 - bfacrm:ticket__show__28712
//
//        Self.Suspend;
//      except
//        dbView.DataController.DataSource := nil;
//        tmr.Enabled := False;
//        Self.Suspend;
//      end;
//    end;
//  finally
//    cnt.Close;
//    Synchronize(
//      procedure
//      begin
//        dbView.Invalidate;
//      end);
//  end;
//end;

initialization
  TForm.DefaultRoundedCorners := rcOff; //03.06.2022 Win11

end.


