unit bfaApplication;

interface

uses
  gnugettext, Windows, Classes, Forms, bfaObjects36, bfaPreview36, bfaOptions, ieview,
  Graphics, Messages, Generics.Collections,
  bfaBaseObjects, Controls, SpTBXTabs, SpTBXControls, SpTBXDkPanels, TB2Dock, bfaLog, SpTBXEditors,
  cxImageComboBox, imageenview, u_bfaAddfield, ComCtrls, JvComCtrls, bfaThreadUtils, OleCtrls, SHDocVw,
  u_bfaScrollBox, u_bfaTreeView, VCL.Printers, SpTBXItem, TB2Item, SysUtils, bfaBasePreview,
  bfaSocketConnection, dxAlertWindow, JVMail, PrivateLayer, ievect, imageenio, iemview,
  DropComboTarget, IniFiles, u_bfaGrid, bfaQuickPreview, DBClient, DBGrids,
  hyieutils, ExtCtrls, DB, SpTBXSkins, CRGrid, bfaCommonUtils, System.Notification
  , bfaGridDBTableView, dxCore, cxLookAndFeels, cxControls, bfaCalloutPopup, Dialogs
  , FloatingResubFrame, ResubFrameGPL, bfaImageEnVect, bfaImageEnMView, u_bfaSelector
  {$IFDEF IMAGEEN1140}
  , ietwain, iexAcquire
  {$ENDIF}
  ;

const
//Preview Types in Panel Tag wird gespeichert
  pvtViewer = 0;
  pvtImporter = 1;
  pvtWorkplace = 2;
  pvtResub = 3;
  pvtFavorites = 4;
  pvtAdmin = 5;

//SaveFile Types
  sftTIF = 0;
  sftPDF = 1;
  sftORI = 2;

// Alertz Message Types
  alPrint = 0;
  alSave = 1;
  alEmail = 2;
  alDocLink = 3;
  alResub = 4;

// E-Mail Types
  emtOriginal = 0;
  emtAttachment = 1;
  emtLink = 2;

//Treeview Change Delay
  tvChangeDelay = 250;

//MetaData Export Type
  mdeCSV = 0;
  mdeOO = 1;
  mdeXLS = 2;

  FLD_TYP = 'typ';
  FLD_DATE = 'date';
  FLD_ARCNAME = 'arcname';
  FLD_DOCNAME = 'docname';
  FLD_INFO = 'info';
  FLD_USER_WORK = 'user_work';
  FLD_USER_SHED = 'user_shed';
  FLD_COMMENT = 'comment';

  FLD_DOCUSERNAME = 'docusername';
  FLD_DOCDATE = 'docdate';
  FLD_DOCMODIFIED = 'doc_modified';

  stdcol = 'Titel,docname,0,100,-1,-1,True;Benutzer,docusername,0,100,-1,-1,True;Datum,docdate,2,100,-1,-1,True;'
            + 'nderungsdatum,doc_modified,0,100,-1,-1,True'; //02.08.2022 Ticket 23066
  resubcol = 'Typ,typ,0,25,-1,-1,True;Termin,date,2,100,-1,-1,True;Archiv,arcname,0,100,-1,-1,True;' +
             'Titel,docname,0,100,-1,-1,True;Info,info,0,100,-1,-1,True;Bearbeiter,user_work,0,100,-1,-1,True;' +
             'Controller,user_shed,0,100,-1,-1,True;Kommentar,comment,0,100,-1,-1,True;'
             + 'nderungsdatum,doc_modified,0,100,-1,-1,True'; //02.08.2022 Ticket 23066

type
//15.03.2021  TbfaStringList = class(TStringList); //12.03.2021 nur fr bestimmte Aufgaben,
  //  wie z.B statt Filename ein TbfaFileObj zurckliefern
  PbfaFileObj = ^TbfaFileObj;
  TbfaFileObj = class(TObject)
  public
    FileName: WideString;
    Directory: WideString;
    FileSize: Double; //02.03.2021 wurde ergnzt
  end;

  PString = ^string;

  PUserAction = ^TUserAction;

  TUserAction = record
    ActionName: string;
    Documents: TList;
    FreeObjects: Boolean; // .Documents
    Objects: TList;
    Params: TStringList;
    Options: Integer;
    Preview: TbfaPreview;
    SList: TStringList;
    Msg: string;
  end;

  TArchive = record
    Name: string;
    Arcid: Int64;
    Lgrid: Int64;
    Typ: Integer;
    Flags: Integer;
    Backpic: string;
    Options: Integer;
    DefDocname: string;
    Storageid: Integer;
    Rights: Int64;
    //21.09.2021 Ticket 24736 -->
    // die mssen Archiv eben gespeichert werden, kommen aber vom Sortings.ini
    GroupingBar,
    Footer : Boolean;
    //21.09.2021 Ticket 24736 <--
  end;

  TDocArc = record
    GdocID: Int64;
    ArcID: Int64;
  end;

  TAddfield = record
    FieldID: Integer;
    Displayname: string;
    Fieldname: string;
    FieldTyp: Integer;
    Items: TStringList;
    Mode: Integer;
    Options: Integer;
    Checkprogram: string;
    ValuesQuery: string;
    IndextableID: Integer;
    Rights: Int64;
    Component: TBfaAddfieldComp;
  end;

  TSorting = record
    Title: string;
    Field: string;
    SortOrder: Integer;
    Width: Integer;
    GroupingIndex : Integer;
    SortIndex : Integer;
    Visible : Boolean;
    FooterKind : Integer;
  end;

  TImportValues = record
    Field,
    Value : string;
  end;

  TStationery = record
    Arcid: integer;
    Name: string;
    Stream: TMemoryStream;
    Arcids: TList<Integer>;
  end;

  PResub = ^TResub;

  TResub = record     // Record, um die notwendigen Infos fr Wiedervorlage Favoriten bzw Weiterleitung zusammenzufassen
    ID: Integer;
    Name: WideString;
    Info: WideString;
    FwdInfo: WideString;
    Comment: WideString;
    Options: Integer;
    Date: TDateTime;
    AlarmDate: TDateTime;
    Alarm: Integer;  // Tage bis Alarm
    Users: string;  //semikolongetrennte Liste der Userids
    Groups: string;  //semikolongetrennte Liste der Userids
    Modified: Boolean;
    TimID: Int64;
    TimRef: Int64;
    Status: Integer;
    UseridShed: Integer;
    FavIcon: Integer;
    AdditionalDays: Integer; // Datum wird auf n Tage in der Zukunft gesetzt
  end;

  TbfaHotKey = record
    ID, HotKey, State {0-Aktiv, 1-Deleted}, StoreID, ArchiveID: Integer;
    Name, StoreName, ArchiveName: WideString;
    Screenshot, DocLink, Modified, GDocIDSearch: Boolean;
  end;

//  TSpTBXbitfarmArchivSkin = class(TSpTBXSkinOptions)
//  public
//    procedure FillOptions; override;
//    procedure PaintBackground(ACanvas: TCanvas; ARect: TRect; Component: TSpTBXSkinComponentsType;
//      State: TSpTBXSkinStatesType; Background, Borders: Boolean; Vertical: Boolean = False;
//      ForceRectBorders: TAnchors = []); override;
//  end;

  TbfaDragKind = (dkNone, dkDocuments, dkPages);

  TbfaDragInsertMode = (dimNone, dimBefore, dimAfter, dimMerge);

  TbfaDragObject = class(TObject)
  private
    FDragSource, FDragSender: TControl;
    FMove, FMoveRight //verschieben recht default True, nur im Viewer wird gendert
      : Boolean;
    FDocumentList: TList<TbfaDocument>;
    FPageList: TStringList;
    FSelectedList: TStringList;
    FDragKind: TbfaDragKind;
    FDragInsertMode: TbfaDragInsertMode;
    FCloned: Boolean; //10.05.2023 Wenn die Objekte geklont sind mssen auch destroyed sein.
    FChanged: Boolean; //23.05.2023 bfacrm:ticket__show__34879

  public
    constructor Create;
    destructor Destroy; override;
    property DragSource: TControl read FDragSource write FDragSource;
    property DragSender: TControl read FDragSender write FDragSender;
    property Move: Boolean read FMove write FMove;
    property MoveRight: Boolean read FMoveRight write FMoveRight; //verschieben recht
    property DocumentList: TList<TbfaDocument> read FDocumentList write FDocumentList;
    property PageList: TStringList read FPageList write FPageList;
    property SelectedList: TStringList read FSelectedList write FSelectedList;
    property DragKind: TbfaDragKind read FDragKind write FDragKind;
    property DragInsertMode: TbfaDragInsertMode read FDragInsertMode write FDragInsertMode;
    property Cloned: Boolean read FCloned write FCloned;
    property Changed: Boolean read FChanged write FChanged; //23.05.2023 bfacrm:ticket__show__34879

  end;

  TbfaPreviewContainer = class;

  TbfaPrinter = class(TPrinter)
  public
    function Clone(Source: TPrinter) : string;
    function GetPrnDuplex: boolean;
  end;

  //06.06.2019 Ticket 17923
  TPrinterDevice = class
    Driver, Device, Port: String;
  end;
  //06.06.2019 Ticket 17923

  TbfaApplication = class(TObject)
  protected
    FLogInitialized, FPluginIsRunning, FSearchInResub, FSearchInResubNegated: Boolean;
    FLog: TbfaLog;
    FUser: TbfaUser;
    FDomain, FOfflineDB
    {$IFDEF ENTERPRISE}
      , FMovePlugin, FSavePlugin, FImporterPlugin //19.07.2024 nicht verwendet, FUncClientSpooler
    {$ENDIF}
      : WideString;
    FViewerOptions: TbfaViewerOptions;
    FMainThread: TThreadPool; // blocked Thread fr Funktionen die seriell laufen mssen
    FBackThread: TThreadPool; // asynchron Thread fr Funktionen, die im Hintergrund laufen knnen
    FImportContainer: TList<TbfaDocument>;
    FWorkplaceContainer: TList<TbfaDocument>;
    FCurrentContainer: TList<TbfaDocument>;
    FCollectionContainer: TList<TbfaDocument>;
    FPreviewContainer: TbfaPreviewContainer;
    procedure ChangeArchiveFromProgram(ArcID: Int64; AThread: TThread);
    function SaveAnnoHistory(CurrentIdx, AnnoIdx, ObjIdx: Integer; var delcnt: Integer): TbfaHistory;

  private
    FViewerLayout, FGlobalViewerLayout : string; //09.01.2020 neue ini Dateiname
    FLastPanelIdx: Integer;
    FScanPool: TbfaImageEnMView;
    FDragObject: TbfaDragObject;
    FFormatSettings: TFormatSettings;
    FScannerProfiles: TbfaScannerProfiles;
    FHistoryListNode, FGlobalListNode, FLocalListNode: TTreeNode;
    JVMail1: TJVMail;
    FHasOutlookAsStd, Fbingetocrtext: Boolean;
    FCreateGrid_CS: TRTLCriticalSection;
    FClearContainer_CS: TRTLCriticalSection;
    FGridLastSelectedGdDocID: Int64; //28.06.2019 Ticket 19612
    regs: TStringList;
    FSid: string;
    FCurrentView: TbfaViewKind;
    FMarkedDocsProfile: string; //12.04.2022 wird im Viewer.ini profileabhngig gespeichert
    FFirstStart362 : Boolean; //06.09.2022 erster Start mit Version362

    procedure SetBookmarkNodeImage(AWhereNode, ASelNode: TTreeNode);
    procedure SetPanelCaption(var Cptn: WideString; Idx: Integer);
    procedure SetPanelCaptionActiv(Idx: Integer);
    procedure RefreshImporterCounter;
    procedure ActivatePreview;
    procedure ChangeDocName(AThread: TThread; Objects: TList; prev: TbfaPreview);
    procedure SaveNewDocName(AThread: TThread; Objects: TList; Params: TStringList; prev: TbfaPreview);
    procedure AddFolder(AThread: TThread; Objects: TList);
    procedure CreateBookmark(AThread: TThread; Objects: TList);
    procedure CreateBookmarkDialog(AThread: TThread; Objects: TList);
    procedure CreateBookmarkForGDocID(AThread: TThread; UserAction: PUserAction);
    procedure ReplaceBookmark(AThread: TThread; Objects: TList);
    procedure ChangeBookmark(AThread: TThread; Objects: TList);
    procedure CopyBookmark(AThread: TThread; Objects: TList);
    procedure SaveGlobalBookmark(Data: PUserAction);
    procedure SaveLocalBookmark;
    procedure ExecuteBookmarkSave;
    procedure DeleteGlobalBookmarkRequest(AThread: TThread; Data: PUserAction);
    procedure BookmarksTreeViewDragDrop(AThread: TThread; Sender, Source: TObject; TV: TJVTreeview; SelNode, WhereNode: TTreeNode; X, Y: Integer);
    procedure DeleteTreeNode(AThread: TThread; SelNode: TTreeNode);
    procedure DeleteGlobalBookmark(AThread: TThread; SelNode: TTreeNode);
    procedure SelectHistoryNode(AThread: TThread; Direction: Integer = 0);
    function GetIndexTableID(fieldname: WideString): WideString;
    // SJ 01.12.2021 - bfacrm:ticket__show__28712
//    procedure DoGDocIDSearch(AThread: TThread; GDocID: Int64; WithSymLink: Boolean = False;
//      GDocIDList: WideString = ''; ArcIDs: WideString = '');
    procedure DoGDocIDSearch(AThread: TThread; GDocID: Int64; WithSymLink: Boolean = False;
      GDocIDList: WideString = ''; ArcIDs: WideString = ''; AutoCheckout: Boolean = False);
    procedure DoChangeArchiveFromProgram(ArcName: WideString; AThread: TThread; LgrID: Int64 = -1);
    procedure DoRefreshMarkedDocs;
    procedure SChanged(Sender: TObject; AWindowState: TWindowState);
    procedure ShowPrintAlertWindow(Data: PUserAction; AThread: TThread);
    procedure SendEmail(Data: PUserAction; AThread: TThread);
    function CreateMailComponent: Boolean;
    procedure JvMail1Error(Sender: TJvMail; ErrorCode: cardinal);
    procedure BuildClientList;
    procedure DoImageCorrection(prev: TbfaPreview; Doc: TbfaDocument; func: Integer);
    procedure popDocLinksOnClick(Sender: TObject);
    procedure popResubFavsOnClick(Sender: TObject);
    procedure popLinksListOnClick(Sender: TObject);
    procedure ShowPanelUndocked(AThread: TThread; pnl: TSpTBXDockablePanel);
    procedure SetImporterScrollBox;
    procedure HideFrame;
    procedure ShowQuickPreview(AThread: TThread);
    function AddFieldsModified(fields: TList<TbfaAddField>): Boolean; //27.05.2020 umgelagert aus DoSave wegen Ticket 10862
    procedure SetFocusToFirstVisibleAddfield;
    procedure DoRefreshCWLabel(fraRes: TfraResub; day: TDate);
    function GetMarkedDocsProfile: string;
    procedure RefreshDocumentAfterCancel(AThread: TThread; req: TbfaRequest; modified: boolean);
    procedure SetCurrentView(const Value: TbfaViewKind);
    function ExtendedGroupList(List: TStringList): WideString;
    procedure ChangeResubFrameSkin(fra: TFrame);
    {$IFNDEF DISABLE_HISTORY_FUTURE_DELETE} // SJ 14.07.2023 - bfacrm:ticket__show__35313
    procedure SetDeleteFutureHistoryNodes(const Value: TbfaSearch);
    procedure CheckHistoryNodes(NewHistoryNode: TbfaSearch);
    {$ENDIF}
    function CopyFileWithBuffer(SourceStream: TStream; FileName, DestName: TFileName; SplForm: Boolean; AThread: TThread = nil): Integer;
    procedure SendDocsToImporter(AThread: TThread); //14.11.2023
    procedure SendDocsToWorkplace(AThread: TThread);
    procedure SelectNextDocumentOrDeselect(prev: TbfaPreview);

  public
    {$IFDEF ENTERPRISE}
    PluginsArray: array of TPlugin;
    BugReportEmail: string; //22.03.2024
    LogSaveDirectory: String; //22.03.2024
    {$ENDIF}
    SortingsProfile, SortingsFloatingResubProfile, //11.04.2022 Sectionname im sortings.ini
    TreeViewProfile, //11.04.2022 Sectionname fr Treeviews im Viewer.ini
    MarkedDocsString: string; //12.04.2022 aus ViewerOptions.ini hier eingebaut
    GlobalCounter: Integer;
    FViewerSplitterSize,
    FImporterSplitterSize: Integer; //07.09.2023  Start mit Imporer Splitter falsch
    PActionName: PString;
    CurrentArchive: TArchive;
    CurrentViewerArchive: TArchive;
    CurrentImportArchive: TArchive;
    CurrentResubArchive: TArchive;
    CurrentFields, CurrentImporterFields, CurrentViewerFields, CurrentResubFields: Int64;
    LastView: TbfaViewKind;
    frmQuickPreview: TfrmQuickPreview;
    PopupLinkList: TStringList;
    MViewThumbWidth, MViewThumbHeight: Integer;
    LastDocArc: TDocArc;
    DocHistoryFirstItem: Boolean; // Das erste Dokument sollte nachher hinzugefgt werden, nicht sofort bei auruf
    GridCreating, AddFieldsCreating, CancelProcess: Boolean;
    TVFontSize : Integer;
    BgColor, SlColor: TColor;
//14.04.2021 b.takacs Ticket 26789 -->
    ControlAtMousePos : TWinControl;
    FontDlg : TFontDialog;
    ColorDlg : TColorDialog;
//14.04.2021 b.takacs Ticket 26789 <--
    ShowAllReposAddfields, OrderFieldsByName, UseMatchAgainst, UseIndexing, ViewerUseIndexing, ViewerShowIndexing,
    ImporterUseIndexing, ImporterShowIndexing, OfflineMode, ExportMode, isExporting, bParamHandled, SVNInfo,
    MViewSelectingByMouseMove, FDoSave, FUseFileTarget, fSkipAutoDisplay, FDoCreateGrid, FSendingEmail, FFirstResize,
    FShowPageSortings, FUseSearch35, FUseState35, SetAnnoDPIFromCon, UseFileNameAsDocNameFromCon, FIgnoreRightsAtImport,
    OriginalfileLock: Boolean;
    FDoPluginWithAnno//12.06.2017 Ticket 10795 Muss drei mglichkeit sein 1- NULL(noch nicht gesetzt), 2 - Ja, 3 - Nein
      : Variant;
    LinkChars, bfaServerPort: Integer;
    bfaServerNoSSL: Integer; // sctpSSL = 0, sctpNoSSL = 1
    bfaServer, OfflineDB: string;
    max_named, cnt_named, max_concurrent, cnt_concurrent, cnt_enabled: Integer;  // cnt_enabled Anzahl der aktiven named user zur laufzeit im admin (vor speicherung)
    Profile: WideString;
    FSearchObj: TbfaSearch;
    FSearchProc: TbfaSearchProcessing;
    DocHistory: array of TDocArc;
    MarkedDocs: array[1..5] of TDocArc;
    DocHistoryIdx: Integer;
    LastDocSearch: Boolean;
    fDocumentSearch: Boolean;
    DateDeletionSearch: Boolean; //03.09.2024 SD <--bfacrm:ticket__show__39649 Suchstatus nach Lschungsdatum
    MainSocket: TSocketConnection;
    MainThreadInExecute, ShowInNewTab: Boolean;
    FloatingForms: TList;
    FloatingFormsIdx: Integer;
    DockSearchPanel: Boolean;
    InCreateFloatingForm, InPanelClose, InDockChanged, ClosingMainForm, ShowDocumentInProcess, ShowAllSymLinks, DoDropping: Boolean;
    UserList: TStringList;
    UserListHist: TStringList;
    GroupList: TStringList;
    TimidList: TStringList;
    Standardcols: TStringList;
    StandardResubcols: TStringList;
    ReadRightsArcids: TStringList;    // ArchivIDs in denen wir readberechtigung haben
    haveseennew: Boolean;
    FNewResubs: Integer;
    Lang: string;
    LanguageNativeNames: TStringList;
    currentEmptyDoc: string;
    StationeryIndex: integer;
//22.02.2022 Wandert sich nach TfraResub!    ResubKind: TbfaResubKind;
    currentCW: Word;
    dateCWFirstDay: TDateTime;
    dateCWLastDay: TDateTime;
    handleparamaktiv, ViewChanging, // nur bei HotKeys wichtig!
    fSkipTabChangeEvent, FShowIndexingWithLimit, FSkipDoQueueCount: Boolean;
    FGlobalKey: string;
    GArchives: TList<TbfaArchive>;
    GUser: TList<TbfaUser>;
    GGroups: TList<TbfaGroup>;
    GEmailuser: TList<TbfaUser>;
    GEmailGroups: TList<TbfaGroup>;
    GADGroups: TList<TbfaGroup>;
    GAddfields: TList<TbfaAddField>;
    GStatefields: TList<TbfaStateField>;
    AdminEditMode: Boolean;
    tlbMainMenuVisible, tlbGraphicVisible, tlbToolsVisible, tlbDocStateVisible,
    tlbStatefieldsVisible, tlbPluginsVisible, bfaTlbStandard1Visible,
    bfaTlbPreview1Visible, tlbResubFavsVisible, tlbQueueCountVisible: Boolean;
    BMResub, BMDelegateResub: Int64; //14.05.2018
    ResubListLoaded: Boolean; //14.05.2018
    SelectFirstHistoryNode: Boolean; //08.05.2019 Ticket 19057
    FDeleteFutureHistoryNodes: TbfaSearch; //SJ 14.07.2023 - bfacrm:ticket__show__35313
    Autoreconnect: Boolean;
    SkipAskArchiveOnClose: Boolean;
    FullTextZoom: Integer;
    Usertimeout: Integer;
    Ldap_SSL: Boolean;
    FLastFocusedAddfield: TWinControl;
    ppmCalloutBallon : TbfaCalloutPopup; //08.04.2021 Ticket 26775
    CanPopupBallon : Boolean; //08.04.2021 Ticket 26775
    // <!-- ViewerOptions.EditorOptions.RememberLastAnnoTool
    // Achtung: nicht verwechseln mit fLastAnnoTool + fLastAnnoSender fr F7 + F8 (bfaPreview36)
    LastUsedAnnoTool: String;
    LastUsedAnnoToolSender: TObject;
    LastSelectedStamp, LastSelectedStampTool: String;
    LastSelectedStampToolSender: TObject;
    LastAnnoDefaultWidth, LastAnnoDefaultHeight: Integer;
    // ViewerOptions.EditorOptions.RememberLastAnnoTool -->
    RefreshGridInProcess: Boolean;
    ChangeSkinRunning: Boolean;  //25.01.2023 bfacrm:ticket__show__33644
    emptydocs: TStringList;

    constructor Create; virtual;
    destructor Destroy; override;
    procedure DrawIcons(selector : TbfaSelector);
    procedure SetInisProfile;
    procedure InitNativeLanguageNames;
    function GetLangNativeName(LanguageCode: string): string;
    function GetIdNativeName(LanguageCode: string): integer;
    function GetLangNativeNameById(Id: integer): string;
    procedure CountChecked;
    procedure DestroyAddFields(fields: TList<TbfaAddField>);
    procedure DestroyStateFields(fields: TList<TbfaStateField>);
    procedure DocumentSearch(ArcID, GDocID: Int64; AThread: TThread;
      WithSymLink: Boolean = False; ArcIDs: WideString = ''; GDocIDs: WideString = ''); //14.09.2017 ergnzt wegen Ticket 11457
    function checkholidayloop(liusridsrc, ldusriddst: integer; ldstart, ldend: Tdatetime): boolean;
    function ReadConFile(ConFileName: string; Key: string): Boolean;
    function Login(ConFile, Profile, UserName, Password, Key: string): Boolean; virtual;
    procedure RefreshPanelCaption(Idx: Integer);
    {$IFDEF ImageEn1140}
    procedure InitScan(Dlg: Boolean; TwainPrm: TIETwainParams; img: TbfaImageEnMView; Combo: TcxImageComboBox; AThread: TThread); overload;
    procedure InitScan(Dlg: Boolean; img: TbfaImageEnMView; Combo: TcxImageComboBox; AThread: TThread); overload;
    procedure AfterScan(Dlg: Boolean; img: TbfaImageEnMView; TwainPrm: TIETwainParams; Combo: TcxImageComboBox); overload;
    procedure AfterScan(Dlg: Boolean; img: TbfaImageEnMView; Combo: TcxImageComboBox); overload;
    {$ELSE}
    procedure InitScan(Dlg: Boolean; TwainPrm: TIETwainParams; img: TbfaImageEnMView; Combo: TcxImageComboBox; AThread: TThread);
    procedure AfterScan(Dlg: Boolean; img: TbfaImageEnMView; TwainPrm: TIETwainParams; Combo: TcxImageComboBox);
    {$ENDIF}
    procedure SetImporterObjectCount(AThread: TThread);
    procedure SetWorkplaceObjectCount(AThread: TThread);
    function CanSetFocus: Boolean;
    procedure SaveBookmarks(Node: TTreeNode; Typ: Integer; Userid, Groupid: Int64; Attrname: WideString = '');
    procedure SaveBookmarkNode(Node: TTreeNode);
    procedure ParseSQLWhereSObj(sobj: TbfaSearch);
    function CreateUserAction: PUserAction;
    procedure DeleteNode(Node: TTreeNode);
    function GetActivePreview: TbfaPreview;
    function SetFileName(Data: PUserAction; i, Typ: Integer; SaveDir: WideString; Doc: TbfaDocument; filelist: TStringList = nil): WideString;
    function SetSelectedColumns(resub: Boolean = False; checkout: Boolean = False; preset: WideString = ''): WideString;
    procedure AddArchiveColumn(AThread: TThread; SObj: TbfaSearch);
    procedure LoadArrays;
    procedure GPL;
    procedure Relogin(AThread: TThread; Profile: string = ''); virtual;
    procedure ReloginMySQLError(AThread: TThread);
    function ChangePassword(AThread: TThread): Boolean;
    procedure CheckHoliday; virtual;
    procedure CheckForInvalidHolidday(AThread: TThread); virtual;
    procedure StartHoliday(AThread: TThread = nil); virtual;
    procedure EndHoliday(AThread: TThread); virtual;
    procedure EditHoliday(AThread: TThread); virtual;
    procedure DocAbo(AThread: TThread); virtual;
    procedure ShowAbo(AThread: TThread); virtual;
    procedure DeleteAbo(AThread: TThread); virtual;
    procedure CreateExportDB(AThread: TThread); virtual;
    procedure StartExport(AThread: TThread; expfile: WideString = ''; userids: string = ''; groupids: string = ''); virtual;
    procedure DoExport(AThread: TThread); virtual;
    procedure CheckResub(AThread: TThread);
    procedure ResetDLM(Data: PUserAction; AThread: TThread);
    procedure RefreshTimidList;
//    procedure DeleteFromDir(ContType: Integer);
    procedure ShowSelectedMainPreview(Idx: Integer; AThread: TThread = nil);
    procedure OnDocSelect(arcid: Integer; gdocid: Int64);
    procedure Options(AThread: TThread; Tab: Integer = 0); virtual;
    function CreateLocalSaveAction(UserAction: PUserAction; OnlyFirstDoc: Boolean; DocIdx: Integer = -1;
                                    SaveDir: WideString = ''; FileName: WideString = ''; ThreadType: Integer = 0;
                                    Doc: TbfaDocument = nil): Boolean;
//14.06.2023    procedure LocalSave(Data: PUserAction; AThread: TThread;
//                        SLst: TStringList = nil; FreeStream: Boolean = True);
    function LocalSave(Data: PUserAction; AThread: TThread;
                        SLst: TStringList = nil; FreeStream: Boolean = True): Boolean;
    procedure LocalSavePDF(Data: PUserAction; AThread: TThread);
    procedure LocalSaveTIF(Data: PUserAction; AThread: TThread);
    procedure LocalSaveLink(Data: PUserAction; AThread: TThread);
    procedure LocalSaveOriginal(Data: PUserAction; AThread: TThread);
    procedure LocalSavePreview(Data: PUserAction; AThread: TThread);
    procedure EmailPreview(Data: PUserAction; AThread: TThread);
    procedure EmailAttachment(Data: PUserAction; AThread: TThread);
    procedure EmailOriginal(Data: PUserAction; AThread: TThread);
    procedure EmailLink(Data: PUserAction; AThread: TThread);
    procedure PrintStandard(Data: PUserAction; AThread: TThread);
    procedure PrintSelect(Data: PUserAction; AThread: TThread);
    procedure PrintPreview(Data: PUserAction; AThread: TThread);
    procedure Quit(AThread: TThread);
    procedure ViewThumbnails(Data: PUserAction; AThread: TThread);
    procedure DeleteColumnOrder(AThread: TThread);
    procedure GetLastDocument(AThread: TThread; Params: TStringList);
    procedure GetDoc(Data: PUserAction; AThread: TThread);
    procedure SetDoc(Data: PUserAction; AThread: TThread);
    procedure LoadDoc(Data: PUserAction; AThread: TThread);
    procedure RestoreOriginal(Data: PUserAction; AThread: TThread);
    procedure btnSaveResubClick(Sender: TObject);
    procedure btnResubForwardClick(Sender: TObject);
    procedure ResubCreateExecute(doc: TbfaDocument = nil);
    procedure btnResubDoneClick(Sender: TObject);
    procedure OnClickSetOwnResubDone(Sender: TObject);
    procedure btnResubCancelClick(Sender: TObject);
    function ExecuteCheckProgram(GDocID, ArcID: Int64; AddField: TbfaAddfield): Boolean;
    procedure SyncFulltextZoom(Sender: TObject);
    procedure RefreshDoc(AThread: TThread);
    procedure CreateEmptyDoc(AThread: TThread);
    procedure MergeDoc(Data: PUserAction; AThread: TThread);
    procedure DuplicateDoc(Data: PUserAction; AThread: TThread);
    procedure ExportMetaData(ExportType: Integer; UserAction: PUserAction; AThread: TThread);
//    procedure SaveImporter(Data: PUserAction);
    procedure DeleteDoc(AThread: TThread; UserAction: PUserAction);
    procedure GraphicOptions;
    procedure Inverted(Data: PUserAction; AThread: TThread);
    procedure DeScrew(Data: PUserAction; AThread: TThread);
    procedure DeSpeckle(Data: PUserAction; AThread: TThread);
    procedure RemoveBorder(Data: PUserAction; AThread: TThread);
    procedure RotateLeft(AThread: TThread; prev: TbfaPreview);
    procedure Flip(AThread: TThread; prev: TbfaPreview);
    procedure RotateRight(AThread: TThread; prev: TbfaPreview);
    procedure Info(AThread: TThread);
    procedure Support(AThread: TThread); virtual;
    procedure TeamViewer(AThread: TThread); virtual;
    procedure Videos(AThread: TThread); virtual;
    procedure Handbooks(AThread: TThread); virtual;
    procedure LoadFtxPos(var FtxPos: TList<TbfaFtxPos>; SearchString: WideString); virtual;
    function FtxWordPos(SearchString: WideString): TList<TbfaFtxPos>; virtual;
    procedure ShowFtxPos(img: TbfaImageEnVect; Doc: TbfaDocument; prev: TbfaPreview; PageIdx: Integer); virtual;
    procedure DoPluginClick(AThread: TThread; UserAction: PUserAction); virtual;
    procedure CheckForFailedUpdates(AThread: TThread); virtual; // SJ Abschlussprojekt
    procedure PluginStamp(AThread: TThread; UserAction: PUserAction); virtual;
    procedure ExecutePluginViaStamp(PreviewObj: TObject; AnnoData: PAnnoData); virtual;
    procedure ShowFtxPosWithButton(AThread: TThread; Params: TStringList; Prev: TbfaPreview); virtual;
    procedure AuditProof(Data: PUserAction; AThread: TThread);
    procedure PreviousPage(AThread: TThread; prev: TbfaPreview; Params: TStringList);
    procedure NextPage(AThread: TThread; prev: TbfaPreview; Params: TStringList);
    procedure FirstPage(AThread: TThread; prev: TbfaPreview; Params: TStringList);
    procedure LastPage(AThread: TThread; prev: TbfaPreview; Params: TStringList);
    procedure PublicAnno(AThread: TThread; prev: TbfaPreview);
    procedure PrivateAnno(AThread: TThread; prev: TbfaPreview; Layer: Int64);
    procedure ShareLayer(AThread: TThread; prev: TbfaPreview);
    procedure Stationery(AThread: TThread; SList: TStringList; prev: TbfaPreview);
    procedure Autozoom(prev: TbfaPreview; AThread: TThread = nil);
    procedure Zoom100(prev: TbfaPreview; img_DocView: TbfaImageEnVect = nil; AThread: TThread = nil);
    procedure ZoomPage(prev: TbfaPreview; img_DocView: TbfaImageEnVect = nil; AThread: TThread = nil);
    procedure ZoomWidth(prev: TbfaPreview; img_DocView: TbfaImageEnVect = nil; AThread: TThread = nil);
    procedure ZoomHeight(prev: TbfaPreview; img_DocView: TbfaImageEnVect = nil; AThread: TThread = nil);
    procedure ZoomSelect(prev: TbfaPreview; img_DocView: TbfaImageEnVect = nil; AThread: TThread = nil);
    procedure ZoomOff(prev: TbfaPreview; img_DocView: TbfaImageEnVect = nil; AThread: TThread = nil);
    procedure EditTags(UserAction: PUserAction; AThread: TThread);
    procedure NewLink(UserAction: PUserAction; AThread: TThread);
    procedure CreatePDFFile(MStream: TMemoryStream; FileName, FullText: WideString);
    procedure ActivatePrev(prev: TbfaPreview);
    procedure Links(AThread: TThread);
    procedure InResub(AThread: TThread; bRightMouseButtonClick: Boolean = false);
//12.06.2024 auch fr GPL -->
//    procedure Originalfile(UserAction: PUserAction; AThread: TThread); virtual;
//    procedure Checkout(UserAction: PUserAction; AThread: TThread); virtual;
//    procedure CheckoutDocs(UserAction: PUserAction; AThread: TThread); virtual;
//    procedure CheckoutDocsAdmin(UserAction: PUserAction; AThread: TThread); virtual;
    procedure Originalfile(UserAction: PUserAction; AThread: TThread);
    procedure Checkout(UserAction: PUserAction; AThread: TThread);
    procedure CheckoutDocs(UserAction: PUserAction; AThread: TThread);
    procedure CheckoutDocsAdmin(UserAction: PUserAction; AThread: TThread);
    function GetDocLauncher(AThread: TThread): Boolean;
//12.06.2024 <--
    procedure OnSharedLayerClick(Sender: TObject);
    procedure OnStationeryClick(Sender: TObject);
    procedure InEditMode(Docs: TList<TbfaDocument>; prev: TbfaPreview; AThread: TThread);
    procedure IsAuditProof(AThread: TThread);
    procedure ChangeLanguageAfter;
    procedure LanguageXX(AThread: TThread; LangCode: string);
    procedure Save(AThread: TThread);
    procedure DoCancelRequest(Doc: TbfaDocument; AThread: TThread;
      RefreshActPreview: Boolean = True; OnlyDoc : Boolean = False);
    procedure BackgroundCancel(UserAction: PUserAction; AThread: TThread);
    procedure ExportToDB(UserAction: PUserAction; AThread: TThread); virtual;
    procedure DoCheck(Doc: TbfaDocument; var Rslt: Boolean; TmpFields: TList<TbfaAddField>; movedoc: Boolean);
    function CheckAddFields(AThread: TThread; Doc: TbfaDocument; TmpFields: TList<TbfaAddField>; movedoc: Boolean): Boolean;
    function DoSave(AThread: TThread; Data: PUserAction = nil): Boolean;
    procedure Cancel(AThread: TThread);
    procedure FillFieldsWithSearchObject(SObj: TbfaSearch);
    procedure BookmarkSearch(AThread: TThread; SObj: TbfaSearch);
    procedure Search(AThread: TThread; SaveBookmark: Boolean = True);
    procedure AddToHistoryList(AThread: TThread; SObj: TbfaSearch);
    procedure Reset(AThread: TThread; btnResetClick: Boolean = False);
    procedure ResetImporter(AThread: TThread);
    procedure ResetViewer(AThread: TThread);
    procedure ClearFields(AThread: TThread; btnResetClick: Boolean = False);
    procedure ResetFields(AThread: TThread; btnResetClick: Boolean = False; AfterCreateFields: Boolean = False);
    procedure ResetImporterFields(AThread: TThread);
    procedure ResetDocState(AThread: TThread);
    procedure ResetStandardSearch(AThread: TThread);
    procedure SetLastYearSearch;
    procedure ShowInResub(AThread: TThread);
    procedure MyTasks(AThread: TThread; gdocid: Int64 = 0);
    procedure MyTasksQuery(AThread: TThread; gdocid: Int64 = 0);
    procedure FillMyTasksSearch(fraResub : TfraResub; GridView: TbfaGridDBTableView; var SObj : TbfaSearch);
    procedure DelegateTasks(AThread: TThread);
    procedure DelegateTasksQuery(AThread: TThread);
    procedure FillDelegateTasksSearch(fraResub : TfraResub; GridView: TbfaGridDBTableView; var SObj : TbfaSearch);
    procedure ShowCW(AThread: TThread);
    procedure CWPrevious(AThread: TThread);
    procedure CWNext(AThread: TThread);
    procedure SetCW(day: TDate);
    procedure RefreshCWLabel(AThread: TThread; day: TDate);
    procedure ResubCancel(Data: PUserAction; AThread: TThread);
    procedure SaveResub(Data: PUserAction; AThread: TThread);
    procedure ResubDone(Data: PUserAction; AThread: TThread);
    procedure Scan(Dlg, InNewDoc: Boolean; AThread: TThread);
    procedure LoadFile(Data: PUserAction; AThread: TThread);
    procedure LoadDocumentsFromXML(AThread: TThread; Path: WideString; Container: TList<TbfaDocument>);
    procedure LoadBookmarks(AThread: TThread);
    procedure ExpandLastBookmarkNodes;
    procedure MViewImageSelect(Sender: TObject; prev: TbfaPreview; idx: Integer;
      DeselectIdx: Integer = -1; SetCurrent: Boolean = True; InNewTab: Boolean = False;
      InBackGroundTab: Boolean = False; InEditMode: Boolean = False; SetFocus: Boolean = False;
      ChangeToMultiSingle: Boolean = False; ReloadThumbnail: Boolean = False; SetImagePos: Boolean = False;
      SetImagePosTothetop: Boolean = False; Autozoom: Boolean = True; PageDirection: Integer = -1;
      Floating: Boolean = False; MouseClick: Boolean = False);
    function GetSearchString: WideString;
    procedure ShowDocument(Params: TStringList; prev: TbfaPreview; Objects: TList; Documents: TList; AThread: TThread);
    procedure DeleteSelected(prev: TbfaPreview; SList: TStringList;
      AThread: TThread; Mr: TModalResult = mrNone; WithSplashForm : Boolean = True);
    procedure DeleteFromCurrentContainer(gdocid: Int64);
    procedure ClearCurrentContainer;
    procedure SetMouseWheelParams(Sender: TObject; Param: TIEMouseWheelParamsAction);
    procedure PreviewMouseWheel(prev: TbfaPreview; frm: TfrmQuickPreview; img_DocView: TbfaImageEnVect; Shift: TShiftState; WheelDelta: Integer; var Handled: Boolean);
    procedure CreateShowPageSortingsFrameAction;
    procedure CreateHidePageSortingsFrameAction;
    procedure ShowPageSortingsFrame(AThread: TThread);
    procedure HidePageSortingsFrame(AThread: TThread);
    procedure PageSortingsOnResize(Sender: TObject);
    procedure Archive(AThread: TThread; UserAction: PUserAction);
    procedure WPUngroup(Data: PUserAction; AThread: TThread);
    procedure WPClear(AThread: TThread);
    procedure WPLoad(sList: TStringList; AThread: TThread);
    procedure WPSave;
    procedure PreviewBack(AThread: TThread; prev: TbfaPreview);
    procedure MainThreadExecute(Data: Pointer; AThread: TThread);
    procedure BackThreadExecute(Data: Pointer; AThread: TThread);
//04.08.2023 wegen abstrze bei OutlookAddin ein test   function CreatePDocument(FileName: WideString = ''): TbfaDocument;
    function CreatePDocument(FileName: WideString = ''; WithoutOriStreamButFileName: Boolean = False): TbfaDocument;
    procedure RefreshImporterMultiView(AThread: TThread; Add: Boolean; cnt: Integer = -1);
    procedure RefreshWorkplaceMultiView(AThread: TThread; Add: Boolean; cnt: Integer = -1);
    procedure RefreshMultiView(AThread: TThread; prev: TbfaPreview; sList: TStringList);
    procedure RefreshPreviewCounter(AThread: TThread; prev: TbfaPreview);
    procedure MViewDragDrop(AThread: TThread; prev: TbfaPreview; sList: TStringList; Objs: TList);
    procedure DeletePagesFromDocument(AThread: TThread; prev: TbfaPreview; sList: TStringList; Objs: TList);
    function CreateNewPList: TList<TbfaDocument>;
    procedure SetViewAndArchiveAction(newview: TbfaViewKind);
    procedure SetViewAndArchive(AThread: TThread; newview: TbfaViewKind);  // zum Programmatischen Wechsel zwischen den Views
    procedure SetActiveView(AThread: TThread; Idx: Integer; Sender: TObject = nil; ViewKind: Integer = 0; force_loadfields : Boolean = False);
    procedure SetActiveViewAction(Idx: Integer = pvtViewer; Sender: TObject = nil; ViewKind: TbfaViewKind = tvkViewer);
    procedure ShowActiveTab(AThread: TThread; Idx: Integer);
    procedure ShowActiveTabAction(Idx: Integer);
    procedure CreateFields(AThread: TThread; Lst: TStringList; ArcID: Int64 = -1);
    procedure SetCurrentDocs(Doc: TbfaDocument; DocList: TList = nil; prev: TbfaPreview = nil; AThread: TThread = nil; InNewTab: Boolean = False; InEditMode: Boolean = false);
    procedure ZoomComboChange(Sender: TObject);
//30.08.2022    procedure PageNumberChange(Sender: TObject; const Text: String);
    procedure PageNumberChange(Sender: TObject);
    procedure AcceptText(Sender: TObject; var NewText: String; var Accept: Boolean);
    function GetCurrentDocumentInProcess(Idx: Integer = -1): Boolean;
    procedure CurrentDocumentStartCloneProcess(Idx: Integer = -1);
    procedure CurrentDocumentEndCloneProcess(Idx: Integer = -1);
    procedure CurrentDocumentStartSaveProcess(Idx: Integer = -1);
    procedure CurrentDocumentEndSaveProcess(Idx: Integer = -1);
    procedure RotatePages(prev: TbfaPreview; Grad: Integer; AThread: TThread);
    function CheckBeforeRotate(prev: TbfaPreview; AThread: TThread): Boolean;
    procedure SaveAnnoObjects(AThread: TThread; DocView: Tfrm_Voransicht; ActiveDoc: TbfaDocument; prev: TbfaPreview; SetInteracts, SetIntervtBack: Boolean; IgnoreRights: Boolean = False);
    procedure SaveAnnotation(AThread: TThread; DocView: Tfrm_Voransicht; Doc: TbfaDocument);
    function SaveDocumentsToXML(DocList: Tlist<TbfaDocument>; Path: string;
      idx: Integer = -1; WithSplashForm : Boolean = True; AThread: TThread = nil): Boolean;
    procedure PanelClose(AThread: TThread; Objects: TList);
    procedure ChangeArchive(params: TStringList; objects: TList; AThread: TThread);
    procedure CreateAddfields(arcids: TStringList; AThread: TThread; intersection: Boolean = False);
    procedure CreateStatefields(arcids: TStringList; AThread: TThread; intersection: Boolean = False);
    procedure AddDocumentFields(Doc: TbfaDocument; AThread: TThread);
    procedure DeleteAddfields(AThread: TThread);
    procedure DeleteStatefields(AThread: TThread);
    procedure DeleteAddCompFromArray(comp: TComponent);
    procedure DeleteStateCompFromArray(comp: TComponent);
    function DoCreateAddfieldComp(AOwner: TComponent; addid, position: Integer;
      Idx: Boolean; var lastposition: Integer;
      multiarcs: Boolean = False; posoffset: Integer = 0): TBfaAddfieldComp;
    function CreateGridfieldComp(AOwner: TComponent; Addfield: TbfaAddfield) : TBfaAddfieldComp;
    function CloneAddfields(Source: TList<TbfaAddfield>): TList<TbfaAddfield>;
    function CloneStatefields(Source: TList<TbfaStatefield>): TList<TbfaStatefield>;
    procedure CleanAddfieldsList(Source: TList<TbfaAddfield>);
    procedure CleanStatefieldsList(Source: TList<TbfaStatefield>);
    procedure ReadSysArc;
    procedure SetArcRights(ArcID: Int64);
    procedure ReadAddfields;
    procedure Reloadfields;
    procedure ReloadTrees(all: Boolean = False);
    procedure ReadStatefields;
    procedure ReadFieldRights(arcids: TStringList);
    procedure ReadAddfieldRights(arcids: TStringList);
    procedure ReadStatefieldRights(arcids: TStringList);
    function GetArcids(lgrid: Int64; userid: Int64 = -1): TStringList;
    procedure CreateGrid(arcid: Int64; AThread: TThread);
    procedure CreateStdColumns;
    procedure SetFooterOptions;
    procedure RefreshGrid(AThread: TThread);
    procedure UpdateGridWithFields(Athread: TThread; LstAddfields: TList<TbfaAddfield>);
    procedure RetranslateSearchGrid(searchgrid: TbfaDBGrid);
    function GetSortTitle(FieldName: String): string; overload;
    procedure GetSortTitle(Fieldname: string; Var OrgTitle: string); overload;
    procedure ReadSortings;
    procedure ReadImportValues;
    procedure WriteSortings;
    procedure CreateResubColumns;
    procedure ReadHotSearchOptions;
    procedure ReadResubFavs;
    procedure ReadResubUserGroups(var fraResub : TfraResub);
    procedure WriteResubFavs;
    procedure RefreshGUIByOption;
    procedure WriteHotSearchOptions;
    function GetResubFavIcon(FavIcon : Integer) : Integer;
    procedure CreateResubPopup;
    procedure CreateResubFavsInPreviews(WithActivePreview : TbfaPreview = nil);
    procedure CreateLinkListPopup;
    procedure DeleteResubFavs(index: Integer);
    procedure FillScanProfiles2(Combo: TSpTBXComboBox; SelectDefault: Boolean = False);
    procedure FillScanProfiles(Combo: TcxImageComboBox; SelectDefault: Boolean = False);
    procedure RefreshScanCombos(SelectDefault: Boolean = False);
    function LoadUser: Boolean; virtual;
    procedure ShowPreview(ActDoc: TbfaDocument; GDocID: Int64; NewTab: Boolean = False; InBackgroundTab: Boolean = False; InEditMode: Boolean = False; prev: TbfaPreview = nil; SymArcID: Int64 = -1; TimID: Int64 = -1; ResubUserID: Int64 = -1);
    procedure ReadUserlist;
    procedure ReadEmailUser;
    procedure ReadRefnamesOrTitels(cbx: TObject; sub: string; Refname: Integer = 0);
    procedure DoFieldSearch(Field: TbfaAddfieldComp; value: string);
    procedure DoIndexing(AThread: TThread);
    procedure TabDblClick(Sender: TObject);
    procedure TabClose(Sender: TObject);
    function GetPanelByTab(ATab: TSpTBXTabItem): TSPTbxDockablePanel;
    procedure MaximizePanel(pnl: TSpTBXCustomDockablePanel);
    procedure DockSearchOptions(pnl: TSpTBXCustomDockablePanel);
    procedure PanelKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure PanelDockChanging(Sender: TObject; Floating: Boolean; DockingTo: TTBDock);
    procedure SetDocState(Doc: TbfaDocument); virtual;
    procedure SetDocLinkActions;
    procedure DoResizeAddfields(Sender: TObject; NewWidth, NewHeight: Integer; IsSettingValue: Boolean);
    function SQLQueryReadRefNamesOrTitles(sub: string = ''; Refname: Integer = 0): String;
    procedure SetAnnoLayer(Doc: TbfaDocument; prev: TbfaPreview);
    procedure ResetButtons(Enable: Boolean);
    procedure SetSaveButton(prev: TbfaPreview);
    procedure RefreshMarkedDocs(AThread: TThread);
    procedure ExpandAll(TV: TbfaTreeView; AThread: TThread);
    procedure CollapseAll(TV: TbfaTreeView; AThread: TThread);
    procedure ChangeArchiveAction(TV: TbfaTreeView; Node: TTreeNode);
    procedure RefreshTreeView(TV: TbfaTreeView; AThread: TThread);
    procedure AddFieldKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ImporterFieldsKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState); //06.12.2018 muss im Importer beim Enter archivieren ausfhren
    procedure ImporterFieldsOnChange(Sender: TObject); //06.05.2020
    procedure CallShowDocument(Doc: TbfaDocument; Docs: TList<TbfaDocument>;
      Objs: TList; DocIdx, PageIdx: Integer; SetCurrent, NewTab, InBackgroundTab,
      InEditMode, SetFocus, ReloadThumbnail: Boolean; prev: TbfaPreview = nil;
      ChangeToMultiSingle: Boolean = False; SearchString: WideString = ''; Reload: Boolean = False;
      SetImagePos: Boolean = False; SetImagePosTothetop: Boolean = False; Autozoom: Boolean = True;
      PageDirection: Integer = -1; Floating: Boolean = False; MouseClick: Boolean = False);
    procedure ShowDocumentProperties(Doc: TbfaDocument; prev: TbfaPreview);
    procedure ShowResubFields(Doc: TbfaDocument; var fraResub : TfraResub);
    procedure ResetDocumentProperties;
    procedure ReloadCurrentDocs(AThread: TThread);
    procedure ButtonPreviewClick(AThread: TThread; prev: TbfaPreview);  //     //16.05.2024 SD Klick auf ButtonPreviewClick - Umsetzung durch UserAction
    procedure LeaveCurrentDocs(AThread: TThread);
    procedure LeaveCurrentDocsImMultiView(AThread: TThread; UserAction: PUserAction);
    procedure Print(MStream: TMemoryStream; MLeft, MTop, MRight, MBottom, SWidth,
      SHeight, Gamma: Double; VPos: TIEVerticalPos; HPos: TIEHorizontalPos;
      Size: TIESize; Rotate: Boolean; Prn: TPrinter);
    procedure ShowAlertWindow(Typ: Integer; Text: WideString; FileObj: TbfaFileObj = nil);
    procedure AlertWindowButtonClick(Sender: TObject; AAlertWindow: TdxAlertWindow; AButtonIndex: Integer);
    function CloneCurrentDocs(UserAction: PUserAction; OnlyFirstDoc: Boolean;
      Rights: Integer = 0; DocIdx: Integer = -1; WithThumbnailView : Boolean = True; Sorting: Boolean = False): Boolean;
//14.02.2019 Ticket 18008    procedure CreatePrintStandardAction(UserAction: PUserAction; OnlyFirstDoc: Boolean);
    procedure CreatePrintStandardAction(UserAction: PUserAction; OnlyFirstDoc: Boolean; AlreadyClonedDocs: Boolean);
    procedure CreatePrintPreviewAction(UserAction: PUserAction; OnlyFirstDoc: Boolean);
    procedure CreateLocalSavePDFAction(UserAction: PUserAction; OnlyFirstDoc: Boolean; ThreadType: Integer = 0);
    procedure CreateLocalSaveTIFAction(UserAction: PUserAction; OnlyFirstDoc: Boolean; DocIdx: Integer = -1; SaveDir: WideString = ''; FileName: WideString = ''; ThreadType: Integer = 0);
    procedure CreateLocalSaveOriginalAction(UserAction: PUserAction; OnlyFirstDoc: Boolean; ThreadType: Integer = 0);
    procedure CreateLocalSavePreviewAction(UserAction: PUserAction; OnlyFirstDoc: Boolean);
    procedure CreateEmailAttachmentAction(UserAction: PUserAction; OnlyFirstDoc: Boolean; DocType: Integer);
    procedure CreateEmailOriginalAction(UserAction: PUserAction; OnlyFirstDoc: Boolean);
    procedure CreateEmailPreviewAction(UserAction: PUserAction; OnlyFirstDoc: Boolean);
    procedure CreateEmailCollectionAction(UserAction: PUserAction);
    procedure CopyAnno(OriDoc, Doc: TbfaDocument; SelectedPages: TStringList);
    procedure SendPagesTo(UserAction: PUserAction; AThread: TThread);
    procedure LoadDocumentViaSocket(Doc: TbfaDocument; Param: WideString; AThread: TThread; OnlyDoc: Boolean = False; ShowErrorMsg: Boolean = True);
    procedure LoadHistoryViaSocket(Doc: TbfaDocument; AThread: TThread);
    procedure LoadCommentary(Doc: TbfaDocument; AThread: TThread);
    procedure CreateCommentary(UserAction: PUserAction; AThread: TThread);
    procedure ModifyCommentary(UserAction: PUserAction; AThread: TThread);
    procedure DeleteCommentary(UserAction: PUserAction; AThread: TThread);
    procedure HideSearchDetails(AThread: TThread);
    procedure FillDocLinkList;
    procedure ShowDocLinkList;
    procedure CreateRefSearchAction(RefName: WideString);
    procedure RefSearch(UserAction: PUserAction; AThread: TThread);
    procedure CreateNewLinkAction(OnlyFirstObject, AutoRef, UseLastLink: Boolean; RefName: string = '');
    function CreateAutoRefID: WideString;
    procedure SetStdStsInfo(itm: TSpTBXLabelItem; AThread: TThread);
    procedure SetStandardStatusInfo(AThread: TThread);
    procedure SetStatusInfo(Info: WideString; AThread: TThread; tmr: Boolean = True);
    procedure SetStatusBarID(ArcID, GDocID: Int64; GUID: WideString; AThread: TThread);
    function IsFloatingForms: Boolean;
    function GetInNewTab(prev: TbfaPreview; Ctrl: Boolean = False): Boolean;
    function GetInUnDockedTab(prev: TbfaPreview): Boolean;
    procedure SaveHistoryBookmark;
    procedure ParseSobjToSQLWhere(var sobj: TBfaSearch; var lstSQLWhere: TStringList);
    procedure CreateBookmarkSobj(var sobj: TbfaSearch; var lstSQLWhere: TStringList);
    function ParseSQLWhere(sql: TStringList): TStringList;
    function DeleteBraces(sql: TStringList): TStringList;
    procedure CreateSymbolicLinks(SrcDoc: TList<TbfaDocument>; SymArcID: Int64; AThread: TThread);
    procedure CreateSymbolicLinksAction(SymArcID: Int64);
    function AreSelectedDocsNotMovable(ArcID: Int64): Boolean;
    procedure MoveDocAction(Node: TTreeNode; SymArcID: Int64 = -1; DuplicateDoc : Boolean = False);
    procedure MoveDoc(SrcDoc: TList<TbfaDocument>; Arcid: Int64; Arcname: string; SymArcID: Int64; ShowDoc, DuplicateDoc : Boolean; AThread: TThread);
    procedure DeleteSymbolicLink(AThread: TThread; SrcDoc: TList<TbfaDocument>);
    procedure SetFtxIcon(prev: TbfaPreview; ImageIndex: Integer; HintText: WideString; Enable: Boolean = True);
    procedure CopyDocToClipboard(AThread: TThread; Data: PUserAction);
    procedure ReOCR(AThread: TThread; Data: PUserAction);
    procedure CreateCopyToClipboardAction(Original, Stationery, Priv, Pub: Boolean; prev: TbfaPreview);
    procedure DeleteLink(AThread: TThread; RefName: string);
    procedure RemoveLink(AThread: TThread; SrcDoc: TList<TbfaDocument>; RefName: string);
    procedure AddTag(AThread: TThread; UserAction: PUserAction);
    procedure LoadStationaries(arcid: Int64);
    procedure CreateLoadAction(Eff: Integer; Target: TDropComboTarget);
    procedure SendDocumentsTo(prev: TbfaPreview; WithDraggedDocs: Boolean = False;
              //14.11.2023  Copy: Boolean = False; LoadOriginalDoc: Boolean = False);
              Copy: Boolean = False; LoadOriginalDoc: Boolean = False; AThread: TThread = nil);
    procedure CreateRefreshPageInThumbnailsAction(Doc: TbfaDocument; ActPrev: TbfaPreview; Page: Integer; Bmp: TBitmap);
    procedure CreateRefreshDocumentInPreviewsAction(Doc: TbfaDocument; ActPrev1, ActPrev2: TbfaPreview; OnlyObjects: Boolean = False; SetInProcess: Boolean = False; ReloadThumbnails: Boolean = False);
    function RunPlugin(AThread: TThread; liprefix: Integer; lspname, listname: string;
      tlsljob: TStringList; slZMetaField: TStringList = nil; slZMetaName: TStringList = nil;
      slZMetaFieldValues: TStringList = nil; slZMetaFieldType: TStringList = nil): Integer; virtual;

    procedure ReadJobFile(AThread: TThread; Doc: TbfaDocument; fsDocname: string;
      var slZMetaField, slZMetaName, slZMetaFieldValues, slZMetaFieldType: TStringList;
      var Error : Boolean; var ErrorStr : string; SObj: TbfaSearch = nil);
    {$IFDEF ENTERPRISE}
    procedure WritePluginHistory(AThread: TThread; Pluginname: String; Result: Integer;
      Document: TbfaDocument); virtual;
    //    procedure ReadFNDFile(AThread: TThread; FileName: WideString);
    procedure WriteJobFile(fsDocname: string; fusefield: boolean; Typ: Integer = 0; Doc: TbfaDocument = nil; ArcID: Integer = -1);
    procedure WriteJobFileDest(fsDocname: string; DestArcID: Integer; slZMetaField, slZMetaName, slZMetaFieldValues, slZMetaFieldType: TStringList);
    procedure WriteIndexDataToJobFile(ini: TIniFile; Doc: TbfaDocument = nil; ArcID: Integer = -1);
    {$ENDIF}

    procedure WriteHistory(ATHread: TThread; taskid: Integer; gdocid: Int64; value1: Widestring = ''; value2: Widestring = ''; value3: Widestring = ''); overload;
    procedure WriteHistory(ATHread: TThread; hist: TbfaHistory); overload;
    procedure GetAllFilesInDir(Dir: string; Lst: TStringList; DoSubDir: Boolean = False);
    procedure HandleParam(ATHread: TThread; Params: TStringList);
    procedure PrepareForSearchLinks(ATHread: TThread; sText: string);
    procedure senduserpermessage(fapp: string);
    function ForceForegroundWindow(hwnd: THandle): Boolean;
    procedure LoadStationerytoDocument(Doc: TbfaDocument; StatName: WideString);
    //13.06.2023 function GetOriStream(SrcDoc: TbfaDocument; AThread: TThread = nil): TMemoryStream;
    function GetOriStream(SrcDoc: TbfaDocument; AThread: TThread = nil; FileName: string = ''): Boolean;
    function GetPreviewStream(SrcDoc: TbfaDocument): TMemoryStream;
    procedure OnModifiedSpinEdit(Field: TBfaAddfieldComp);
    procedure OnModifiedDateField(Field: TBfaAddfieldComp);
    procedure OnGridExport(Field: TBfaAddfieldComp);
    procedure OnGridStamp(Field: TBfaAddfieldComp);
    procedure OnGridStamp2(Field: TBfaAddfieldComp);
    procedure ReloadImportTreeview;
    procedure Alt1(AThread: TThread);
    procedure Alt2(AThread: TThread);
    procedure Alt3(AThread: TThread);
    procedure Alt4(AThread: TThread);
    procedure Alt5(AThread: TThread);
    procedure Alt6(AThread: TThread);
    procedure Alt7(AThread: TThread);
    procedure Alt8(AThread: TThread);
    procedure SetFocusToFirstAddfield(AThread: TThread);
    procedure Alt9(AThread: TThread);
    procedure Alt0(AThread: TThread);
    procedure F4(AThread: TThread);
    procedure F11(AThread: TThread);
    procedure AltF11(AThread: TThread);
    procedure CtrlF(AThread: TThread; AltKey: Boolean = False; SkipClearSearch: Boolean = False);
    procedure CtrlTab(AThread: TThread);
    procedure SetActiveControl(Ctrl: TWinControl; AThread: TThread);
    procedure SetSearchTabActive(AThread: TThread);
    procedure CopyOCRResultToClipbrd(Sender: TObject);
    procedure CopyOCRResultToSlw(Sender: TObject);
    procedure CopyOCRResultToAddField(Sender: TObject);
    procedure OCRResultToGeneralSearch(Sender: TObject);
    procedure OCRResultToGeneralSearchInTree(Sender: TObject);
    procedure OCRResultToSearchToolbar(Sender: TObject);
    function GetOCRText: TStrings;
//    procedure CopyOCRResultToClipbrdAction;
    procedure CopyOCRResultToSlwAction;
    procedure CopyOCRResultToAddFieldAction(Sender: TObject);
    procedure CopyResultToAddFieldAction(Sender: TObject; sText: string = '');
    procedure DoCopyOCRResultToClipbrd(AThread: TThread);
    procedure DoCopyOCRResultToSlw(AThread: TThread);
    procedure DoOCRResultToGeneralSearch(AThread: TThread);
    procedure DoOCRResultToGeneralSearchInTree(AThread: TThread);
    procedure DoOCRResultToSearchToolbar(AThread: TThread);
    procedure DoCopyOCRResultToAddField(AThread: TThread; UserAction: PUserAction);
    procedure GoToSourceArchive(AThread: TThread; Doc: TbfaDocument; SymArcID: Int64);
    /// <summary>
    ///   Aktualisiert die Style Komponent Eigenschaften von Developer Express
    ///   Komponents.
    /// </summary>
    /// <seealso cref="ChangeSkin" />
    /// <seealso cref="ChangeDevexpSkin" />
    procedure ChangeDevexpSkin;
    /// <summary>
    ///   Aktualisiert die Farben und Font Eigenschaften.
    /// </summary>
    /// <seealso cref="ChangeSkin" />
    /// <seealso cref="ChangeDevexpSkin" />
    procedure ChangeGridSkin(Grid : TObject);
    procedure ChangePreviewSkin(prev: TbfaPreview);
    procedure ChangeImporterSkin;
    procedure ChangeDocLinkListSkin;
    procedure ChangeAdminSkin; virtual;
    procedure ChangeGridConfigSkin;
    procedure ChangeDLMSkin;
    procedure ChangeCreateBookmarkSkin;
    /// <summary>
    ///   Alle Objekten die nicht durch SPTBX oder DevExpress aktualisiert
    ///   sind, mssen hier angepasst werden.
    ///   z.B Treeviews, Panels, Listviews.
    /// </summary>
    /// <seealso cref="ChangeSkin" />
    /// <seealso cref="ChangeDevexpSkin" />
    procedure ChangeObjectsSkin;
    procedure FillImporterFields;
    procedure SetImporterDocName(Value: string);
    /// <summary>
    ///   Aktualisiert die Anwendung zum ausgewhlten Skin. Hier werden alle
    ///   Komponenten und Fonts angepasst.
    /// </summary>
    /// <remarks>
    ///   Die Skin Dateien (.skn) mssen unter 'Viewer-files\Skins\'
    ///   Verzeichnis liegen.
    /// </remarks>
    /// <seealso cref="ChangeDevexpSkin" />
    /// <seealso cref="ChangeGridSkin" />
    /// <seealso cref="ChangePreviewSkin" />
    /// <seealso cref="ChangeObjectsSkin" />
    /// <seealso cref="ChangeImporterSkin" />
    procedure ChangeSkin(AThread: TThread);
    procedure DoChangeSkin;
    function GetAddfieldByID(id: Integer): TbfaAddfield;
    function GetAddfieldByName(name: string): TbfaAddfield;
    function GetStatefieldByID(id: Integer): TbfaStatefield;
    procedure ShowToolbars(show: Boolean);
    function ParseMatchAgainstString(search: Widestring): Widestring;
    procedure Askfor_SaveAdmin;
    procedure SelectNodeByID(tree: TbfaTreeView; arcid: Int64);
    function GetDesktopFolder: string;
    function CreateDesktopShellLink(const DocName: string; const DocID: Integer): Boolean;
    function GetInResubSQLText(Doc: TbfaBaseDocument): string;
    procedure LoadWVLFavorite(Frm: TFrame; idx: integer);
    procedure FillResubFavCombo(cbb: TSpTBXComboBox);
    procedure OpenInApp(AThread: TThread; Doc: TbfaDocument);
    procedure SortingClientDataSet(Grid: TbfaDBGrid; Cds: TClientDataSet; Column: TColumn);
    procedure SetEditModeList(EditIds: string; AThread: TThread);
    procedure ShowQuickPreviewAnnos;
    procedure ClearPreviewScanPool(prev: TbfaPreview; AThread: TThread);
    procedure TranslateMenu; virtual;
    procedure DoHeartBeat(AThread: TThread);
    procedure DoQueueCount(AThread: TThread);
    procedure DisconnectUser;
    procedure SaveImportValues(AThread: TThread);
    procedure SetBlueArrows;
    procedure ReloadDocument(Doc: TbfaDocument; InEditmode: Boolean; AThread: TThread;
      OnlyDoc : Boolean = False);
    function DBLoadDocument(Doc: TbfaBaseDocument): Integer;
    procedure StartSearchThread(ASearchObj: TbfaSearch; AHistorySearchObj: TBfaSearch = nil; DoAutoCheckout: Boolean = False);
    function GetUpdateFilelist: TBfaRequest; virtual;
    function ReceiveReqSendUpdates(Files: TStringList; Targetpath, Filename: Widestring): Boolean; virtual;
    function ExecuteUpdate(HideSplash: Boolean = True): Boolean; virtual;
    procedure ActFulltextZoom(Data: PUserAction);
    procedure FulltextZoomResized(Sender: TObject);
    procedure actUndockInNewTabExecute(Sender: TObject);
    procedure actUndockInNewWindowExecute(Sender: TObject);
    procedure actF2Execute(Sender: TObject);
    procedure SelectedRowsToCurrentContainer(GridView : TbfaGridDBTableView;
      OnlyDoc : Boolean = False; src : TList = nil);
    function SelectedRowsToList(GridView : TbfaGridDBTableView): TList<TbfaDocument>; //15.10.2024 SD <--bfacrm:ticket__show__39532
    procedure ExecuteSearch;
    procedure ShowFloatingResub;
    procedure EnableFloatingResub(Sender : TObject);
    procedure CloseFloatingResub(Sender: TObject);
    procedure ClearUserAction(UserAction: PUserAction);
    procedure SaveTreeViewBookmarkExpanded;
    function CheckStrictfieldItems(addfield: TbfaAddfield; out outlist: TStringList; AOldValue: string = ''; ANewValue : string =''): TStrictItemsAction;
    procedure DoResubPanelResize(fra: TfraResub);
    procedure ChangeResubFrameColor(fraResub: TfraResub);
    procedure SetDelegateTaskControls(var fraResub : TfraResub);
    procedure SetMyTaskControls(var fraResub : TfraResub);
    procedure CanResizeFloatingResub(Sender: TObject; var NewWidth, NewHeight: Integer; var Resize: Boolean);
    procedure SetChkPrintAfterArchive(prev: TbfaPreview);
    procedure FillMarkedDocs;
    function GetSortRec(stlsort: TStringList): TSorting;
    procedure DoSelectedRowsToCurrentContainer(AThread: TThread);
    function AllowedToLeaveCurrentDocs(PreviousAllow: Boolean = True;
      ShowDialog: Boolean = True; AThread: TThread = nil): Boolean;
    procedure SetSearchOrder(SObj: TbfaSearch; GridView: TbfaGridDBTableView);
    procedure SetOptionsFormColor; //09.02.2024
    procedure SetBugReportEmail; virtual; //22.03.2024
    procedure SetLogDirectory; virtual; //22.03.2024
    procedure ReloadDocLinks(AThread: TThread); //10.04.2024
    function TranslateGroupName(GroupName: string): string; //12.09.2024

    property Log: TbfaLog read FLog;
    property User: TbfaUser read FUser;
    property MainThread: TThreadPool read FMainThread; // blocked Thread fr Funktionen die seriell laufen mssen
    property BackThread: TThreadPool read FBackThread; // asynchron Thread fr Funktionen, die im Hintergrund laufen knnen
    property ImportContainer: TList<TbfaDocument> read FImportContainer;
    property WorkplaceContainer: TList<TbfaDocument> read FWorkplaceContainer;
    property CurrentContainer: TList<TbfaDocument> read FCurrentContainer;
    property CollectionContainer: TList<TbfaDocument> read FCollectionContainer;
    property PreviewContainer: TbfaPreviewContainer read FPreviewContainer;
    property DragObject: TbfaDragObject read FDragObject write FDragObject;
    property FormatSettings: TFormatSettings read FFormatSettings;
    property ActivePreview: TbfaPreview read GetActivePreview;
    property ScannerProfiles: TbfaScannerProfiles read FScannerProfiles write FScannerProfiles;
    property ViewerOptions: TbfaViewerOptions read FViewerOptions write FViewerOptions;
    property LocalListNode: TTreeNode read FLocalListNode write FLocalListNode;
    property GlobalListNode: TTreeNode read FGlobalListNode write FGlobalListNode;
    property HistoryListNode: TTreeNode read FHistoryListNode write FHistoryListNode;
    property GridLastSelectedGdDocID: Int64 read FGridLastSelectedGdDocID write FGridLastSelectedGdDocID; //26.06.2019 Ticket 19612
    property Sid: string read FSid write FSid;
    property ViewerLayout: string read FViewerLayout; //09.01.2020
    property GlobalViewerLayout: string read FGlobalViewerLayout; //09.01.2020
    property MarkedDocsProfile: string read GetMarkedDocsProfile; //12.04.2022
    property CurrentView: TbfaViewKind read FCurrentView write SetCurrentView;
    {$IFNDEF DISABLE_HISTORY_FUTURE_DELETE} // SJ 14.07.2023 - bfacrm:ticket__show__35313
    property DeleteFutureHistoryNodes: TbfaSearch read FDeleteFutureHistoryNodes write SetDeleteFutureHistoryNodes;
    {$ENDIF}
    property FirstStart362: Boolean read FFirstStart362; //14.08.2024
  end;

  TbfaPreviewContainerItem = class(TObject)
  private
    FPanel: TSpTBXDockablePanel;
    FPanelCaption: WideString;
    FPreview: TbfaPreview;
    FTab: TSpTBXTabItem;
    fPreviousClientWidth: Integer;
  public
    constructor Create(AOwner: TComponent; PanelPrnt: TWinControl; ActDock: TSpTBXMultiDock;
      TabPrnt: TSpTBXTabSet; PCaption: WideString; Idx: Integer; CloseOption: Boolean = False;
      InBackground: Boolean = False; Flt: Boolean = False; ItemTag: Integer = -1;
      WithMultiAndThumbnailView : Boolean = True); overload;
    constructor CreateWithoutTab(AOwner: TComponent; PanelPrnt: TWinControl;
      ActDock: TSpTBXMultiDock; TabPrnt: TSpTBXTabSet; PCaption: WideString;
      Idx: Integer; CloseOption: Boolean = False; ItemTag: Integer = -1;
      WithMultiAndThumbnailView : Boolean = False); overload;
    destructor Destroy; override;
    property Panel: TSpTBXDockablePanel read FPanel;
    property Preview: TbfaPreview read FPreview;
    property Tab: TSpTBXTabItem read FTab;
    property PanelCaption: WideString read FPanelCaption;
    property PreviousClientWidth: Integer read fPreviousClientWidth write fPreviousClientWidth;
  end;

  TbfaPreviewContainer = class(TObject)
  private
    /// <Beschreibung>Aktiv Item Index</Beschreibung>
    /// <Description></Description>
    FActive: Integer;
    FImporter, FWorkplace, FViewer, FPageSortingsItem, FAdmin: TbfaPreviewContainerItem;
    FContainers: TList<TbfaPreviewContainerItem>;
    FOwner: TComponent;
    FParent: TWinControl;
    FDock: TSpTBXMultiDock;
    FTabSet: TSpTBXTabSet;
    FPreviewPanel: TSpTBXDockablePanel;
    FMaxItemIdx: Integer;
    FResubItem: TbfaPreviewContainerItem;
    FFavoritesItem: TbfaPreviewContainerItem;
    procedure ContainerDockChanged(Sender: TObject);
    procedure SetActive(Value: Integer);
  public
    constructor Create;
    destructor Destroy; override;
    function AddItem(PanelCaption: WideString; CloseOption: Boolean = False;
      InBackground: Boolean = False; Flt: Boolean = False;
      WithMultiAndThumbnailView : Boolean = True): TbfaPreviewContainerItem;
    function CreatePageSortingsFrame(PanelCaption: WideString; CloseOption: Boolean = False): TbfaPreviewContainerItem;
    procedure PanelCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure OneContainerDockChanged(Tab: TSpTBXTabItem; Pnl: TSpTBXDockablePanel);
    property Owner: TComponent read FOwner write FOwner;
    property Parent: TWinControl read FParent write FParent;
    property Dock: TSpTBXMultiDock read FDock write FDock;
    property TabSet: TSpTBXTabSet read FTabSet write FTabSet;
    property ActiveItem: Integer read FActive write SetActive;
    property ImporterItem: TbfaPreviewContainerItem read FImporter write FImporter;
    property WorkplaceItem: TbfaPreviewContainerItem read FWorkplace write FWorkplace;
    property ViewerItem: TbfaPreviewContainerItem read FViewer write FViewer;
    property PageSortingsItem: TbfaPreviewContainerItem read FPageSortingsItem write FPageSortingsItem;
    property AdminItem: TbfaPreviewContainerItem read FAdmin write FAdmin;
    property ResubItem: TbfaPreviewContainerItem read FResubItem write FResubItem;
    property FavoritesItem: TbfaPreviewContainerItem read FFavoritesItem write FFavoritesItem;
    property Containers: TList<TbfaPreviewContainerItem> read FContainers;
    property PreviewPanel: TSpTBXDockablePanel read FPreviewPanel write FPreviewPanel;
  end;

const
  EmptyResub: TResub = ();

var
  aSysArc: array of TArchive;
  aAddfields: array of TbfaAddField;
  aAddfieldRights: array of Integer;
  aStateFieldRights: array of Integer;
  aStatefields: array of TbfaStateField;
  aCurrentAddfields: TList<TbfaAddfield>;
  aCurrentViewerAddfields: TList<TbfaAddfield>;
  aCurrentImporterAddfields: TList<TbfaAddfield>;
  aCurrentResubAddfields: TList<TbfaAddfield>;
  aCurrentStatefields: TList<TbfaStatefield>;
  aCurrentViewerStatefields: TList<TbfaStatefield>;
  aCurrentImporterStatefields: TList<TbfaStatefield>;
  aCurrentResubStatefields: TList<TbfaStatefield>;
  aColSortings: array of array of TSorting;        //Liste mit Spaltensortierung
  aImportValues: array of array of TImportValues;  //Liste mit Importer Standardwerte
  aStationeries: array of TStationery;
  aResubFavs: array of TResub;
  aHotKeys: array of TbfaHotKey;
  aHotKeyProfil: string;

implementation

uses
  bfaIconsDM, DateUtils, CommonGUIUtils, Variants, TypInfo, StrUtils,
  bfaCommonDB, bfaCommonMethods, bfaCommonDialogs, bfaCommonFiles, bfaCommonStyles,
  SynZip, //12.06.2024
  MainForm, OptionsForm, LoginGPL, ScanFunctions,
  {$IFDEF ENTERPRISE}
  MainFormEnterprise, OptionsFormEnterprise, LoginEnterprise, ScanFunctionsEnterprise,
  bfaApplicationEnterprise, //23.09.2024 SD <--bfacrm:ticket__show__33611
  {$ENDIF}
  bfaCommonImageEN, bfaBaseImageEN, ActnList, Uni,
  MySQLUniProvider, XMLDoc, XMLIntf, u_OpenOffice, imageenproc, bfaProcessing,
  u_Message, DocLinksFrame, bfaParser, ShellAPI,
  ActiveX, TagsForm, MainDataModule, Types, cxCalendar, Outlook_TLB, NewDocLink,
  ComObj, PreviewDlg, hyiedefs, TB2Common, cxButtonEdit, cxTextEdit,
  FloatingForm, MoveDocForm, IOUtils, Registry, u_Info, Clipbrd,
  cxEdit, StdCtrls, dragDrop, CreateGlobalBookmark, PasswordForm,
  HTTPApp, u_DeSpeckle, ShlObj, RegularExpressions, CreateResubFrame, consts,
  Grids, bfaSP, StrictItemsDialog, SplashForm, cxGridDBTableView,
  u_bfaInputEdit, u_bfaInputCombo, cxButtons,
  cxCustomData, cxDBLookupComboBox, cxGridDBDataDefinitions, Winapi.CommCtrl,
  cxGridTableView, EncdDecd
  {$IFDEF IMAGEEN1140}
  , iexBitmaps, iexClasses
  {$ENDIF}
  ;

//constructor TbfaDragObject.Create(AControl : TControl);
constructor TbfaDragObject.Create;
begin
  inherited;
  FMove := True;
  FMoveRight := True;
  FDocumentList := TList<TbfaDocument>.Create;
  FPageList := TStringList.Create;
  FSelectedList := TStringList.Create;
  FDragKind := dkNone;
  FDragInsertMode := dimNone;
  FDragSender := nil;
  FDragSource := nil;
  FCloned := False;
  FChanged := False; //23.05.2023
end;

destructor TbfaDragObject.Destroy;
begin
  FDocumentList.Clear;
  FreeAndNil(FDocumentList);
  FPageList.Clear;
  FreeAndNil(FPageList);
  FSelectedList.Clear;
  FreeAndNil(FSelectedList);
  inherited Destroy;
end;

procedure TbfaApplication.DrawIcons(selector : TbfaSelector);
begin
  with selector do
  begin
    btn1.Caption := '';
    btn1.Images := bfaIcons.ilMainMenu16;
    btn1.ImageIndex := Integer(icoidx_arrow_right);
    btn2.Caption := '';
    btn2.Images := bfaIcons.ilMainMenu16;
    btn2.ImageIndex := Integer(icoidx_arrow_left);
    btnClear1.Caption := '';
    btnClear1.Images := bfaIcons.ilMainMenu16;
    btnClear1.ImageIndex := Integer(icoidx_reset);
    btnClear2.Caption := '';
    btnClear2.Images := bfaIcons.ilMainMenu16;
    btnClear2.ImageIndex := Integer(icoidx_reset);
  end;
end;

function TbfaApplication.GetMarkedDocsProfile: string;
begin
  if FMarkedDocsProfile <> '' then
    Result := FMarkedDocsProfile
  else
    Result := sSysMarkedDocs;
end;

procedure TbfaApplication.CreateEmptyDoc(AThread: TThread);
var
  req: TbfaRequest;
  Useraction: PUserAction;
  found: Boolean;
begin
  req := TbfaRequest.Create;
  found := False;

  if (CurrentViewerArchive.Typ = 0) then
  begin
    BfShowMessage(_('Auf Lagern knnen keine Dokumente erzeugt werden.'), AThread);
    Exit;
  end;

  try
    for var I := 0 to aCurrentAddfields.Count - 1 do
    begin
      if (aCurrentAddfields[I].Options and cAddfieldOptMandatory) = cAddfieldOptMandatory then
      begin
        if (aAddfieldRights[aCurrentAddfields[I].Id] and (rFieldWrite or rFieldModify)) = 0 then
          Continue // nur lesen Berechtigung
        else
          found := True;
      end;
    end;

    if found then
    begin
      AThread.Synchronize(nil,
        procedure
        begin
          if frmMainForm.frmMovedoc = nil then
            frmMainForm.frmMovedoc := TfrmMoveDoc.Create(nil)
          //21.09.2022 Ticket 32291 -->
          else
            frmMainForm.frmMovedoc.DeleteAllAddfields;
          //21.09.2022 Ticket 32291 <--
          try
            frmMainForm.frmMovedoc.scrbxMoveDocAddfields.Color := frmMainForm.grdResultlistDevExView.clFree;
            frmMainForm.frmMovedoc.Panel1.Color := frmMainForm.grdResultlistDevExView.clFree;
            frmMainForm.frmMovedoc.Color := frmMainForm.grdResultlistDevExView.clFree;
            frmMainForm.frmMovedoc.Position := poMainFormCenter;
            frmMainForm.frmMovedoc.CreateAddfields(CurrentViewerArchive.Arcid);
            if Assigned(frmMainForm.frmMovedoc.Doc) then
              FreeAndNil(frmMainForm.frmMovedoc.Doc);
            frmMainForm.frmMovedoc.Doc := TbfaDocument.Create;
            frmMainForm.frmMovedoc.OnMouseActivate := frmMainForm.MainFormMouseActivate;
            frmMainForm.frmMovedoc.ShowModal;
          except

          end;
        end);
    end;

    if ((frmMainForm.frmMovedoc <> nil) and (frmMainForm.frmMovedoc.ModalResult = mrOK)) or (not found) then
    begin
      req.ReqType := 'reqCreateEmptyDoc';
      req.UserID := User.ID;
      req.Profile := Self.Profile;
      req.Parameter := IntToStr(CurrentViewerArchive.Arcid) + ';' + currentEmptyDoc;
      req.Lang := Lang;

      if ((frmMainForm.frmMovedoc <> nil) and (frmMainForm.frmMovedoc.TmpAddfields.Count > 0)) and found then
      begin
        var Lst: TList<TbfaBaseObject>;
        Lst := TList<TbfaBaseObject>.Create;
        for var I := 0 to frmMainForm.frmMovedoc.TmpAddfields.Count - 1 do
          Lst.Add(frmMainForm.frmMovedoc.TmpAddfields[I]);
        req.Data := Lst;
      end;

      MainSocket.SendRequestToServer(req);

      req := MainSocket.ReceiveResponse(AThread);
      if req = nil then
        Exit;

  //27.11.2018 Ticket 16957 -->
      if req.ReqType = 'respAuthError' then
      begin
        BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
        UserAction := CreateUserAction;
        UserAction^.ActionName := 'actRelogin';
        MainThread.Add(UserAction);
        Exit;
      end
      else
  //27.11.2018 Ticket 16957 <--
      if req.ReqType = 'respError' then
        BfShowMessage(Format(_('Es konnte kein leeres %s Dokument erzeugt werden.'), [currentEmptyDoc]) + #13#10 + req.DataString, AThread)
      else begin
        if bitfarmApp.ViewerOptions.GeneralOptions.CheckoutNewDocuments and
            (aSysArc[CurrentViewerArchive.Arcid].Rights and rightModify = 0) then
        begin
          BfShowMessage(_('Sie haben die Option Automatisches Auschecken und ffnen aktiviert,\nin diesem Archiv allerdings kein Bearbeiten Recht.\nDas Dokument wird daher nicht automatisch ausgecheckt.'), AThread);
          DoGDocIDSearch(AThread, req.ID);
        end else
          DoGDocIDSearch(AThread, req.ID, False, '', '', True);
  //      DoGDocIDSearch(AThread, req.ID); // SJ 01.12.2021 - bfacrm:ticket__show__28712
      end;
    end
  finally
    FreeAndNil(req);
  end;
end;

procedure TbfaApplication.CreateExportDB(AThread: TThread);
begin
  // -> bfaApplicationEnterprise
end;

procedure TbfaApplication.CreateStdColumns;
begin
  frmMainForm.grdResultlistDevExView.CreateDBColumn(
    'gdocid', 'gdocid', 'gdocid', '', 90, False //08.09.2021 Ticket 28323 );
    , soNone, -1, -1, False);
  frmMainForm.grdResultlistDevExView.CreateDBColumn(
    'arcid', 'arcid', 'arcid', '', 90, False //08.09.2021 Ticket 28323 );
    , soNone, -1, -1, False);
  frmMainForm.grdResultlistDevExView.CreateDBColumn(
    'symarcid', 'symarcid', 'symarcid', '', 90, False //08.09.2021 Ticket 28323 );
    , soNone, -1, -1, False);
  frmMainForm.grdResultlistDevExView.CreateDBColumn(
    'editmode', 'editmode', 'editmode', '', 90, False //08.09.2021 Ticket 28323 );
    , soNone, -1, -1, False);

  frmMainForm.grdResultlistDevExView.ColAlarm := nil;

  if (frmMainForm.grdResultlistDevExView.Kind = gkResub) or
     (frmMainForm.grdResultlistDevExView.Kind = gkResubDelegate)
  then
  begin
    frmMainForm.grdResultlistDevExView.CreateDBColumn(
      'status', 'status', 'status', '', 90, False //08.09.2021 Ticket 28323 );
    , soNone, -1, -1, False);
    frmMainForm.grdResultlistDevExView.CreateDBColumn(
      'groupid', 'groupid', 'groupid', '', 90, False //08.09.2021 Ticket 28323 );
    , soNone, -1, -1, False);
    frmMainForm.grdResultlistDevExView.CreateDBColumn(
      'options', 'options', 'options', '', 90, False //08.09.2021 Ticket 28323 );
    , soNone, -1, -1, False);
    frmMainForm.grdResultlistDevExView.CreateDBColumn(
      'alarm', _('Alarm'), 'alarm', '', 90,
      bitfarmApp.ViewerOptions.ResubOptions.ColumnAlarm //08.09.2021 Ticket 28323 );
    , soNone, -1, -1, False);
    frmMainForm.grdResultlistDevExView.CreateDBColumn(
      'timid', 'timid', 'timid', '', 90, False //08.09.2021 Ticket 28323 );
    , soNone, -1, -1, False);
    frmMainForm.grdResultlistDevExView.CreateDBColumn(
      'userid_work', 'userid_work', 'userid_work', '', 90, False //08.09.2021 Ticket 28323 );
    , soNone, -1, -1, False);
    frmMainForm.grdResultlistDevExView.CreateDBColumn(
      'userid_shed', 'userid_shed', 'userid_shed', '', 90, False //08.09.2021 Ticket 28323 );
    , soNone, -1, -1, False);
  end;
end;

procedure TbfaApplication.CreateGrid(arcid: Int64; AThread: TThread);
var
  i, j, icol, ColTyp, GrpIdx, SIdx, FKind : Integer;
  aTemp: array of TSorting;
  found: Boolean;
  sort: TSorting;
  sord : TdxSortOrder;
  vsbl, DoGrouping : Boolean;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateGrid', ClassName);
  GridCreating := True;
  try
    DoGrouping := False;

    AThread.Synchronize(nil,
      procedure
      begin
        frmMainForm.grdResultlistDevExView.OptionsView.GroupByBox := bitfarmApp.CurrentArchive.GroupingBar;
        frmMainForm.grdResultlistDevExView.OptionsView.Footer := bitfarmApp.CurrentArchive.Footer;
        frmMainForm.grdResultlistDevExView.FilterRow.Visible := False; //18.10.2021 brauchen wir nicht mehr bitfarmApp.CurrentArchive.FilterBar;
      end);

    if arcid = -1 then
    begin
      AThread.Synchronize(nil,
        procedure
        var
          i, j: Integer;
          sortings: TStringList;
        begin
          sortings := TStringList.Create;
          sortings.Delimiter := ',';
          sortings.StrictDelimiter := True;

          if (frmMainForm.grdResultlistDevExView.DataController.DataSource <> nil) and
             (frmMainForm.grdResultlistDevExView.DataController.DataSource.DataSet <> nil) then
            frmMainForm.grdResultlistDevExView.DataController.DataSource.DataSet.Close;

          try
            frmMainForm.grdResultlistDevExView.ClearItems;
            CreateStdColumns;

            i := 0;
            for j := 0 to Standardcols.Count - 1 do
            begin
              if Standardcols[j] = '' then
                Continue;

              sortings.DelimitedText := Standardcols[j];

              case StrToInt(sortings[2]) of
                0:
                  sord := soNone;
                1:
                  sord := soAscending;
                2:
                  sord := soDescending;
              end;

              if (sortings.Count >= 7) then
              begin
                GrpIdx := StrToInt(sortings[4]);
                SIdx := StrToInt(sortings[5]);
                Vsbl := StrToBool(sortings[6]);
                if sortings.Count > 7 then
                  FKind := StrToInt(sortings[7])
                else
                  FKind := 0;
              end else
              begin
                GrpIdx := -1;
                SIdx := -1;
                Vsbl := True;
                FKind := 0;
              end;

              if not DoGrouping then
                DoGrouping := (GrpIdx <> -1);


              frmMainForm.grdResultlistDevExView.CreateDBColumn(
                sortings[1], _(sortings[0]), //28.09.2022
                sortings[1], '', StrToInt(sortings[3]), Vsbl, sord, GrpIdx, SIdx,
                True, bTrue, -1, FKind);
              inc(i);
            end;
          except
            on E: Exception do
              bitfarmLog.Write(llNormal, ltException, 'CreateGrid StandardColumns aufbauen: ' + E.Message, ClassName);
          end;
          FreeAndNil(sortings);

        end);

      Exit;
    end;

        // die Liste der Sortings abgleichen mit der Liste der Zusatzfelder (spter auch Statusfelder) des Archivs
        // Die Standardspalten werden bersprungen, Felder in der Sortings die nicht in den Zusatzfeldern sind
        // werden raussortiert, Zusatzfelder die nicht in der  Sortings sind werden hinzugefgt
        // aCurrentAddfields := aCurrentViewerAddfields;
    try
      SetLength(aTemp, High(aColSortings[arcid]) + 1);
      for i := Low(aColSortings[arcid]) to High(aColSortings[arcid]) do
      begin
        if LeftStr(aColSortings[arcid, i].Field, 4) <> 'add_' then
        begin
          aTemp[i] := aColSortings[arcid, i];
          Continue;
        end;
        found := False;
        for j := 0 to aCurrentAddfields.Count - 1 do
        begin
          if aColSortings[arcid, i].Field = aCurrentAddfields[j].Name then
          begin
            found := True;
            Break;
          end;
        end;
        if found then
          aTemp[i] := aColSortings[arcid, i];
      end;

      for i := 0 to aCurrentAddfields.Count - 1 do
      begin
        found := False;
        for j := 0 to High(aTemp) do
        begin
          if aCurrentAddfields[i] = nil then  // Feld gibt es nicht? berspringen...
          begin
            found := True;
            Break;
          end;
          if aCurrentAddfields[i].Name = aTemp[j].Field then
          begin
            found := True;
            Break;
          end;
        end;
        if (not found) and aCurrentAddfields[i].Assigned then     // nur Zusatzfelder zum Grid die Assigned sind
        begin
          SetLength(aTemp, High(aTemp) + 2);
          sort.Title := aCurrentAddfields[i].Displayname;
          sort.Field := aCurrentAddfields[i].Name;
          sort.SortOrder := 0;
          sort.Width := 100;
          sort.GroupingIndex := -1;
          sort.SortIndex := -1;
          sort.Visible := True;
          sort.FooterKind := 0; //23.09.2021 Ticket 24736
          aTemp[j] := sort;
        end;
      end;

      SetLength(aColSortings[arcid], 0);

      icol := 0;
      for i := 0 to High(aTemp) do
      begin
        if aTemp[i].Title <> '' then
        begin
          SetLength(aColSortings[arcid], icol + 1);
          aColSortings[arcid, icol] := aTemp[i];
          Inc(icol);
        end;
      end;

    except
      on E: Exception do
        bitfarmLog.Write(llNormal, ltException, 'CreateGrid: ' + E.Message, ClassName);
    end;

    AThread.Synchronize(nil,
      procedure
      var
        i, j, k : Integer;
      begin
        bitfarmLog.Debug(llDebug, 'CreateGrid Columns aufbauen arcid=' + IntToStr(arcid), ClassName);
        bitfarmLog.Debug(llDebug, 'Low(aColSortings[arcid])=' + IntToStr(Low(aColSortings[arcid])), ClassName);
        bitfarmLog.Debug(llDebug, 'High(aColSortings[arcid])=' + IntToStr(High(aColSortings[arcid])), ClassName);

        if (frmMainForm.grdResultlistDevExView.DataController.DataSource <> nil) and
           (frmMainForm.grdResultlistDevExView.DataController.DataSource.DataSet <> nil) then
          frmMainForm.grdResultlistDevExView.DataController.DataSource.DataSet.Close;

        try
          frmMainForm.grdResultlistDevExView.ClearItems;

          frmMainForm.grdResultlistDevExView.BeginUpdate;

          CreateStdColumns;

          for i := Low(aColSortings[arcid]) to High(aColSortings[arcid]) do
          begin
            try
              case aColSortings[arcid, i].SortOrder of
                0:
                  sord := soNone;
                1:
                  sord := soAscending;
                2:
                  sord := soDescending;
              end;
              ColTyp := -1;
              if Pos('add_', aColSortings[arcid, i].Field) > 0 then
              begin
                try
                  for k := Low(aAddfields) to High(aAddfields) do
                  begin
                    if aAddfields[k] = nil then
                      Continue;
                    if (aAddfields[k].Name = aColSortings[arcid, i].Field) and
                       (aAddfields[k].Typ = 8) then
                    begin
                      ColTyp := aAddfields[k].Typ;
                      Break;
                    end;
                  end;
                except
                  on E: Exception do
                    bitfarmLog.Write(llNormal, ltException, 'CreateGrid Currency: ' + E.Message, ClassName);
                end;
              end;

              if not DoGrouping then
                DoGrouping := (aColSortings[arcid, i].GroupingIndex <> -1);

              frmMainForm.grdResultlistDevExView.CreateDBColumn(
                aColSortings[arcid, i].Field, _(aColSortings[arcid, i].Title), //28.09.2022
                aColSortings[arcid, i].Field, '', aColSortings[arcid, i].Width,
                aColSortings[arcid, i].Visible, sord,
                aColSortings[arcid, i].GroupingIndex, aColSortings[arcid, i].SortIndex,
                True, bTrue, ColTyp, aColSortings[arcid, i].FooterKind);

            except
              on E: Exception do
                bitfarmLog.Write(llNormal, ltException, 'CreateGrid Add columns: ' + E.Message, ClassName);
            end;
          end;
          if (frmMainForm.grdResultlistDevExView.ColAlarm <> nil) and
             frmMainForm.grdResultlistDevExView.ColAlarm.visible
          then
            frmMainForm.grdResultlistDevExView.ColAlarm.Index :=
              frmMainForm.grdResultlistDevExView.ColumnCount - 1;

          //03.08.2022 Ticket 23066 -->
          found := False;
          for j := 0 to frmMainForm.grdResultlistDevExView.ColumnCount - 1 do
          begin
            if frmMainForm.grdResultlistDevExView.Columns[j].DataBinding.FieldName = 'doc_modified' then
            begin
              frmMainForm.grdResultlistDevExView.Columns[j].Visible := ViewerOptions.SearchOptions.DocModified;
              found := True;
              Break;
            end;
          end;

          if ViewerOptions.SearchOptions.DocModified then
          begin
            if not found then
            begin
              frmMainForm.grdResultlistDevExView.CreateDBColumn(
                  'doc_modified',  _('nderungsdatum'), 'doc_modified', '', 140,
                  bitfarmApp.ViewerOptions.SearchOptions.DocModified);

              SetLength(aColSortings[arcid], High(aColSortings[arcid]) + 2);
              sort.Title := 'nderungsdatum';
              sort.Field := 'doc_modified';
              sort.SortOrder := 0;
              sort.Width := 100;
              sort.GroupingIndex := -1;
              sort.SortIndex := -1;
              sort.Visible := True;
              sort.FooterKind := 0; //23.09.2021 Ticket 24736
              aColSortings[arcid, High(aColSortings[arcid])] := sort;
            end;
          end;
          //03.08.2022 Ticket 23066 <--

          if (bitfarmApp.CurrentArchive.Typ = 0) or
             ((not VarIsNull(bitfarmApp.FSearchObj.RefSearch)) and
             (bitfarmApp.FSearchObj.RefSearch <> '')) or
             (bitfarmApp.FSearchObj.AboUserid > -1) then
          begin
            try
              found := False;
              for j := 0 to frmMainForm.grdResultlistDevExView.ColumnCount - 1 do
              begin
                if frmMainForm.grdResultlistDevExView.Columns[j].DataBinding.FieldName = 'arcname' then
                begin
                  found := True;
                  Break;
                end;
              end;

              if not found then
                frmMainForm.grdResultlistDevExView.CreateDBColumn(
                  'arcname', _('Archiv'), 'arcname', '', 150);
            except
              on E: Exception do
                bitfarmLog.Write(llNormal, ltException, 'CreateGrid Add column arcname: ' + E.Message, ClassName);
            end;
          end;
        except
          on E: Exception do
            bitfarmLog.Write(llNormal, ltException, 'CreateGrid Columns aufbauen: ' + E.Message, ClassName);
        end;
      end);
  finally
//03.07.2023 bfacrm:ticket__show__35043   GridCreating := False;
    AThread.Synchronize(nil,
      procedure
      begin
        frmMainForm.grdResultlistDevExView.EndUpdate;
        frmMainForm.grdResultlistDevExView.OptionsView.GroupByBox := DoGrouping;
      end);
    GridCreating := False; //03.07.2023 bfacrm:ticket__show__35043
    bitfarmLog.DebugEnd(llDebug, 'CreateGrid', ClassName);
  end;
end;

procedure TbfaApplication.CWNext(AThread: TThread);
begin
  dateCWFirstDay := Dateutils.IncDay(dateCWFirstDay, 7);
  SetCW(dateCWFirstDay);
  RefreshCWLabel(AThread, dateCWFirstDay);
  if frmMainForm.IsFloatingResubShowing then
  begin
    AThread.Synchronize(AThread,
      procedure
      begin
        frmMainForm.fraFloatingResub.btnMyTasksClick(nil);
      end);
  end
  else
    MyTasksQuery(AThread);
end;

procedure TbfaApplication.CWPrevious(AThread: TThread);
begin
  dateCWFirstDay := Dateutils.IncDay(dateCWFirstDay, -7);
  SetCW(dateCWFirstDay);
  RefreshCWLabel(AThread, dateCWFirstDay);
  if frmMainForm.IsFloatingResubShowing then
  begin
    AThread.Synchronize(AThread,
      procedure
      begin
        frmMainForm.fraFloatingResub.btnMyTasksClick(nil);
      end);
  end
  else
    MyTasksQuery(AThread);
end;

procedure TbfaApplication.AddTag(AThread: TThread; UserAction: PUserAction);
var
  req: TbfaRequest;
  i: Integer;
  UAction: PUserAction;
begin
  if (UserAction^.Documents.Count > 0) and (TbfaDocument(UserAction^.Documents[0]).ID = -1) then
  begin
    AThread.Synchronize(nil,
      procedure
      begin
        // SJ 26.11.2020
//        frmMainForm.mmoDocTags.Lines.Add(UserAction^.Params[0]);
        frmMainForm.tokenDocTags.Text := frmMainForm.tokenDocTags.Text + ';' + UserAction^.Params[0];
        // SJ 26.11.2020
      end);
  end
  else
  begin
    req := TbfaRequest.Create;
    try
      req.ReqType := 'reqAddTag';
      req.UserID := User.ID;
      req.Profile := Self.Profile;
      UserAction^.Params.Delimiter := ';';
      UserAction^.Params.StrictDelimiter := True;
      req.Parameter := UserAction^.Params.DelimitedText;
      req.Lang := Lang;
      MainSocket.SendRequestToServer(req);

      req := MainSocket.ReceiveResponse(AThread);
      if req = nil then
        Exit;

//27.11.2018 Ticket 16957 -->
      if req.ReqType = 'respAuthError' then
      begin
        BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
        UAction := CreateUserAction;
        UAction^.ActionName := 'actRelogin';
        MainThread.Add(UAction);
        Exit;
      end
      else
//27.11.2018 Ticket 16957 <--
      if req.ReqType = 'respError' then
      begin
        BfShowMessage(Format(_('Fehler beim Hinzufgen eines Schlagwortes.\n%s'), [req.DataString]), AThread);
      end else
      begin
        if UserAction^.Documents.Count > 0 then
        begin
          for i := 0 to UserAction^.Documents.Count - 1 do
          begin
            if TbfaDocument(UserAction^.Documents[i]).Loaded then
            begin
              TbfaDocument(UserAction^.Documents[i]).DocTags := TbfaDocument(UserAction^.Documents[i]).DocTags + #10 + #13 + UserAction^.Params[0];
              RefreshDocumentInPreviews(AThread, TbfaDocument(UserAction^.Documents[i]), nil, nil);
            end;
          end;
        end
//02.02.2018 Ticket 12471 -->
        else
          ReloadDocument(FCurrentContainer[0], False, AThread);
//02.02.2018 Ticket 12471 <--
      end;
    finally
      FreeAndNil(req);
    end;
  end;
end;

procedure TbfaApplication.Archive(AThread: TThread; UserAction: PUserAction);
var
  i, j, l, options, rc, dllength: Integer;
  req: TbfaRequest;
  SendSocket: TSocketConnection;
  lst: TList<TbfaBaseObject>;
  addfield: TbfaAddField;
  statefield: TbfaStateField;
  sList, TmpList, DocLinkLst: TStringList;
  lsmydir, lsdname, ErrorStr: string;
  PluginFile: string; //18.09.2024 SD <--bfacrm:ticket__show__39998
  slZMetaField, slZMetaName, slZMetaFieldValues, slZMetaFieldType: TStringList;
  found, Error: Boolean;
  UAction: PUserAction;
  Doc: TbfaDocument;
  Fname: string;
  MaxDocCount : Integer; //15.12.2023
begin
  if FCurrentContainer.Count = 0 then
  begin
    BfShowMessage(_('Sie mssen erst ein Dokument auswhlen.'), AThread);
    Exit;
  end;

  bitfarmLog.DebugBegin(llDebug, 'Archive', ClassName);
  if CurrentImportArchive.Arcid = -1 then
  begin
    BfShowMessage(_('Bitte whlen Sie ein Zielarchiv.'), AThread);
    Exit;
  end;

  if CurrentImportArchive.Typ <> 1 then
  begin
    BfShowMessage(_('Sie mssen erst ein Archiv auswhlen\num ein Dokument zu archivieren.'), AThread);
    Exit;
  end;

//22.03.2017 Ticket 10168
  if ((CurrentImportArchive.Rights and rightImport) = rightImport) then
  begin
    BfShowMessage(_('Sie haben kein Importrecht.'), AThread);
    Exit;
  end;

  if ((aSysArc[CurrentImportArchive.Arcid].options and 1) > 0) and (frmMainForm.edtDocName.Text = '') then
  begin
    BfShowMessage(_('Fr dieses Archiv besteht Titelpflicht.') + #13 + _('Bitte geben Sie einen Dokumententitel ein.'), AThread);
    if frmMainForm.tcSearch.ActiveTabIndex <> 0 then
      AThread.Synchronize(nil,
        procedure
        begin
          frmMainForm.tcSearch.Toolbar.BeginUpdate;
          try
            frmMainForm.tcSearch.ActiveTabIndex := 0
          finally
            frmMainForm.tcSearch.Toolbar.EndUpdate;
          end;
        end);
    Exit;
  end;

//27.04.2018 Ticket 13251 -->
  found := False;
  for j := 0 to aCurrentAddfields.Count - 1 do
  begin
    if aCurrentAddfields[j].Component <> nil then
    begin
      if aCurrentAddfields[j].Typ in [2, 11] then
      begin
        // TODO: auf styles umstellen
        if aCurrentAddfields[j].Component.compComboBox.Style.Color = cColorRed then
        begin
          found := True;
          Break;
        end;
      end
      else if aCurrentAddfields[j].Typ = 3 then
      begin
        // TODO: auf styles umstellen
        if aCurrentAddfields[j].Component.compCheckedCombo.Style.Color = cColorRed then
        begin
          found := True;
          Break;
        end;
      end;
    end;
  end;

  if found then
  begin
    BfShowMessage(_('Bitte berprfen Sie die Zusatzfelder.'), AThread);
    Exit;
  end;

  if (frmMainForm.fraImporterResub.cbbUser.Text <> '') or       // Wiedervorlage anlegen nur wenn User oder Gruppe ausgewhlt ist
     (frmMainForm.fraImporterResub.cbbGroup.Text <> '') then
  begin
    if frmMainForm.fraImporterResub.dtDate1.Text = '' then
    begin
      BfShowMessage(_('Bitte berprfen Sie das Wiedervorlage Datum.'), AThread);
      Exit;
    end;

    if frmMainForm.fraImporterResub.edtAlarm1.Text = '' then
    begin
      BfShowMessage(_('Bitte berprfen Sie die Wiedevorlage Erinnerungstage.'), AThread);
      Exit;
    end;
  end;

//27.04.2018 Ticket 13251 <--
  bitfarmLog.DebugBegin(llDebug, 'Archive - CheckAddfields', ClassName);
  try
    if not CheckAddfields(AThread, FCurrentContainer[0], aCurrentAddfields, False) then
    begin
      if frmMainForm.tcSearch.ActiveTabIndex <> 1 then
        AThread.Synchronize(nil,
          procedure
          begin
            frmMainForm.tcSearch.Toolbar.BeginUpdate;
            try
              frmMainForm.tcSearch.ActiveTabIndex := 1;
            finally
              frmMainForm.tcSearch.Toolbar.EndUpdate;
            end;
          end);
      Exit;
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'Archive - CheckAddfields', ClassName);
  end;

  try
    try
      bitfarmLog.DebugBegin(llDebug, 'Archive - SetActiveView', ClassName);
      try
        if GetActivePreview.PreviewKind = pvkMultiSingle then
          AThread.Synchronize(nil,
            procedure
            begin
              GetActivePreview.PreviewKind := pvkMulti;
            end);

        if GetActivePreview <> FPreviewContainer.ImporterItem.Preview then
          SetActiveView(AThread, pvtImporter, nil, integer(tvkImporter));
      finally
        bitfarmLog.DebugEnd(llDebug, 'Archive - SetActiveView', ClassName);
      end;

      AThread.Synchronize(nil,
        procedure
        begin
          frmMainForm.frmSplash.lblLoading.Caption := _('Archivierung...');
          frmMainForm.frmSplash.Update;
          if not frmMainForm.frmSplash.Showing then
          begin
            frmMainForm.frmSplash.FormType := sftArchiveDocs;
            frmMainForm.frmSplash.UseTimer := True;
            frmMainForm.frmSplash.pgbDocuments.Properties.Min := 0;
            frmMainForm.frmSplash.pgbDocuments.Position := 0;
            frmMainForm.frmSplash.pgbDocuments.Properties.Max := FCurrentContainer.Count;
            frmMainForm.frmSplash.Show;
          end;
        end);

      sList := TStringList.Create;
      bitfarmLog.DebugBegin(llDebug, 'Archive - Verarbeitung', ClassName);
      try
        bitfarmapp.CancelProcess := False;
        MaxDocCount := FCurrentContainer.Count;
        i := 0;
        while (i <= FCurrentContainer.Count - 1) and (not bitfarmApp.CancelProcess) do
        begin
          sList.Clear;

          AThread.Synchronize(nil,
            procedure
            begin
              frmMainForm.frmSplash.lblLoading.Caption := _('Archivierung...');
              frmMainForm.frmSplash.lblInfo.Caption :=
                    ' (' + IntToStr(MaxDocCount - FCurrentContainer.Count + 1) + '/' + IntToStr(MaxDocCount) + ')';
              frmMainForm.frmSplash.btnCancel.Enabled := FCurrentContainer.Count > 1;
              frmMainForm.frmSplash.Canceled := False;
              frmMainForm.frmSplash.btnCancel.Visible := FCurrentContainer.Count > 1;
              frmMainForm.frmSplash.Update;
            end);

          req := TbfaRequest.Create;
          if FCurrentContainer[i].ScanPoolViewchanged then
          begin
            bitfarmLog.Write(llDebug, ltInfo, 'Archive - Verarbeitung: i=' + i.ToString + ' - ScanPoolView', ClassName);
            if FCurrentContainer[i].ScanPoolView <> nil then
            begin
              try
                FCurrentContainer[i].DocStream.Clear;
                FCurrentContainer[i].DocStream.Position := 0;
                FCurrentContainer[i].ScanPoolView.MIO.SaveToStreamTIFF(FCurrentContainer[i].DocStream, False);
              finally
                FCurrentContainer[i].ScanPoolViewchanged := False;
              end;
            end;
          end;

          bitfarmLog.Write(llDebug, ltInfo, 'Archive - Verarbeitung: i=' + i.ToString + ' - TSocketConnection.Create', ClassName);
          SendSocket := TSocketConnection.Create(bfaServerNoSSL, bfaServer, bfaServerPort, '');
          try
            bitfarmLog.Write(llDebug, ltInfo, 'Archive - Verarbeitung: i=' + i.ToString + ' - SendSocket.CreateComponents', ClassName);
            SendSocket.CreateComponents;
            if SendSocket.Connect then
            begin
              bitfarmLog.Write(llDebug, ltInfo, 'Archive - Verarbeitung: i=' + i.ToString + ' - SendSocket.Connected', ClassName);
              bitfarmLog.DebugBegin(llDebug, 'Archive - Verarbeitung: i=' + i.ToString + ' - Standardwerte werden gesetzt', ClassName);
              try
                FCurrentContainer[i].arcid := CurrentImportArchive.Arcid;
                FCurrentContainer[i].Name := CurrentImportArchive.Name;
                FCurrentContainer[i].UserID := User.ID;
                FCurrentContainer[i].UserName := User.Name;

                if (not FCurrentContainer[i].ImporterDocNameModified) and
                   (not ((FCurrentContainer[i].DocName <> '') and
                   FViewerOptions.GeneralOptions.UseFileNameAsDocName))
                then
                begin
                  if ((aSysArc[CurrentImportArchive.Arcid].options and 2) = 2) then
                    FCurrentContainer[i].DocName := aSysArc[CurrentImportArchive.Arcid].Name
                  else if aSysArc[CurrentImportArchive.Arcid].DefDocname <> '' then
                    FCurrentContainer[i].DocName := aSysArc[CurrentImportArchive.Arcid].DefDocname
                  else
                    FCurrentContainer[i].DocName := '';
                end;
              finally
                bitfarmLog.DebugEnd(llDebug, 'Archive - Verarbeitung: i=' + i.ToString + ' - Standardwerte werden gesetzt', ClassName);
              end;

              bitfarmLog.DebugBegin(llDebug, 'Archive - Verarbeitung: i=' + i.ToString + ' - AddFields', ClassName);
              try
                FCurrentContainer[i].AddFields.Clear;
                for j := 0 to aCurrentAddfields.Count - 1 do
                begin
                  addfield := TbfaAddField.Create;
                  addfield.Clone(aCurrentAddfields[j]);
                  if addfield.Typ = 13 then  // bei Gridfeldern gibt im Importer gibt es noch keine addfield.value
                  begin
                    addfield.Value := aCurrentAddfields[j].Component.compGrid.GetValue();
                  end;

                  if (aAddfieldRights[addfield.ID] and 7) = 1 then // nur lesen, nicht schreiben, nicht ndern
                  begin
                    addfield.Value := null;
                    addfield.ValueHigh := null;
                  end;
                  FCurrentContainer[i].AddFields.Add(addfield);
                end;
              finally
                bitfarmLog.DebugEnd(llDebug, 'Archive - Verarbeitung: i=' + i.ToString + ' - AddFields', ClassName);
              end;

              bitfarmLog.DebugBegin(llDebug, 'Archive - Verarbeitung: i=' + i.ToString + ' - StateFields', ClassName);
              try
                FCurrentContainer[i].StateFields.Clear;
                for j := 0 to aCurrentStatefields.Count - 1 do
                begin
                  statefield := TbfaStateField.Create;
                  statefield.Clone(aCurrentStatefields[j]);
                  FCurrentContainer[i].StateFields.Add(statefield);
                end;
              finally
                bitfarmLog.DebugEnd(llDebug, 'Archive - Verarbeitung: i=' + i.ToString + ' - StateFields', ClassName);
              end;


              bitfarmLog.DebugBegin(llDebug, 'Archive - Verarbeitung: i=' + i.ToString + ' - Filter, DocName, DocTags', ClassName);
              try
                if not frmMainForm.fraScanFunctions.chkImportOCR.Checked then
                  FCurrentContainer[i].OcrType := 'TXT'
                else
                  FCurrentContainer[i].OcrType := 'OMP';

                if (ViewerOptions.GeneralOptions.ImportFilter <> '') then
                begin
                  if FCurrentContainer[i].Filter <> '' then
                    FCurrentContainer[i].Filter := FCurrentContainer[i].Filter + ';';
                  FCurrentContainer[i].Filter := FCurrentContainer[i].Filter + ViewerOptions.GeneralOptions.ImportFilter;
                end;

                if (frmMainForm.fraScanFunctions.chkColor.Checked) and (Pos('Color', FCurrentContainer[i].Filter) = 0) then
                begin
                  if FCurrentContainer[i].Filter <> '' then
                    FCurrentContainer[i].Filter := FCurrentContainer[i].Filter + ';';
                  FCurrentContainer[i].Filter := FCurrentContainer[i].Filter + 'Color';
                end;

                if (frmMainForm.fraScanFunctions.chkHiRes.Checked) and (Pos('Highres', FCurrentContainer[i].Filter) = 0) then
                begin
                  if FCurrentContainer[i].Filter <> '' then
                    FCurrentContainer[i].Filter := FCurrentContainer[i].Filter + ';';
                  FCurrentContainer[i].Filter := FCurrentContainer[i].Filter + 'Highres';
                end;

                {$IFDEF ENTERPRISE}
                if (TfraScanFunctionsEnterprise(frmMainForm.fraScanFunctions).chkBarcodemerge.Checked) and (Pos('barcodemerge', FCurrentContainer[i].Filter) = 0) then
                begin
                  if FCurrentContainer[i].Filter <> '' then
                    FCurrentContainer[i].Filter := FCurrentContainer[i].Filter + ';';
                  FCurrentContainer[i].Filter := FCurrentContainer[i].Filter + 'barcodemerge';
                end;
                {$ENDIF}

                if (frmMainForm.edtDocName.Text <> '') and (frmMainForm.edtDocName.Text <> FCurrentContainer[i].DocName) then
                  FCurrentContainer[i].DocName := frmMainForm.edtDocName.Text;

                if (Length(frmMainForm.tokenDocTags.Text) > 0) and (frmMainForm.tokenDocTags.Text <> FCurrentContainer[i].DocTags) then
                  FCurrentContainer[i].DocTags := FCurrentContainer[i].DocTags + ';' + StringReplace(frmMainForm.tokenDocTags.Text, #13#10, ';', [rfReplaceAll]);

                if (frmMainForm.tokenDocLinks.Text <> '') then
                begin
                  DocLinkLst := TStringList.Create(#0, ';', [soStrictDelimiter]);
                  DocLinkLst.DelimitedText := Trim(frmMainForm.tokenDocLinks.Text);

                  if (DocLinkLst <> nil) and (DocLinkLst.Count > 0) then
                  begin
                    dllength := Length(FCurrentContainer[i].DocLinkList);
                    SetLength(FCurrentContainer[i].DocLinkList, dllength + DocLinkLst.Count);

                    for l := 0 to DocLinkLst.Count - 1 do
                    begin
                      FCurrentContainer[i].DocLinkList[dllength + l].RefName := DocLinkLst[l];
                      FCurrentContainer[i].DocLinkList[dllength + l].Count := -1;
                      FCurrentContainer[i].DocLinkList[dllength + l].GDocID := -1;
                      FCurrentContainer[i].DocLinkList[dllength + l].RefID := -1;
                    end;
                  end;
                end;
              finally
                bitfarmLog.DebugEnd(llDebug, 'Archive - Verarbeitung: i=' + i.ToString + ' - Filter, DocName, DocTags', ClassName);
              end;

              bitfarmLog.DebugBegin(llDebug, 'Archive - Verarbeitung: i=' + i.ToString + ' - WVL', ClassName);
              try
                if (frmMainForm.fraImporterResub.cbbUser.Text <> '') or       // Wiedervorlage anlegen nur wenn User oder Gruppe ausgewhlt ist
                  (frmMainForm.fraImporterResub.cbbGroup.Text <> '') then
                begin
                  FCurrentContainer[i].Info := frmMainForm.fraImporterResub.edtInfoCreate.Text;
                  FCurrentContainer[i].TargetDate := frmMainForm.fraImporterResub.dtDate1.Date;
                  FCurrentContainer[i].Alarm := StrToInt(frmMainForm.fraImporterResub.edtAlarm1.Text);
                  if (frmMainForm.fraImporterResub.cbbUser.Text <> '') then
                    FCurrentContainer[i].Editor := frmMainForm.fraImporterResub.cbbUser.Text;
                  if (frmMainForm.fraImporterResub.cbbGroup.Text <> '') then
                  begin
                    TmpList := TStringList.Create;
                    try
                      TmpList.Delimiter := ';';
                      TmpList.StrictDelimiter := True;
                      TmpList.DelimitedText := frmMainForm.fraImporterResub.cbbGroup.Text;
                      for l := 0 to TmpList.Count - 1 do
                      begin
                        if (frmMainForm.fraImporterResub.chkEveryone.Checked) then // chkEveryOne ist Jeder Einzeln, dh 
                          TmpList[l] := '' + TmpList[l]
                        else if (frmMainForm.fraImporterResub.chkOnlyOne.Checked) then //chkOnlyOne ist Einer fr Alle, dh #
                          TmpList[l] := '#' + TmpList[l];
                      end;

                      if FCurrentContainer[i].Editor <> '' then
                        FCurrentContainer[i].Editor := FCurrentContainer[i].Editor + ';';

                      FCurrentContainer[i].Editor := FCurrentContainer[i].Editor + TmpList.DelimitedText;
                    finally
                      FreeAndNil(TmpList);
                    end;
                  end;

                  options := 0;
                  if frmMainForm.fraImporterResub.chkEveryone.Checked then
                    options := (options or 1);
                  if frmMainForm.fraImporterResub.chkReturnToSender.Checked then
                    options := (options or 2);
                  if frmMainForm.fraImporterResub.chkEmailreminder.Checked then
                    options := (options or 4);
                  if frmMainForm.fraImporterResub.chkNotifyByMail.Checked then
                    options := (options or 64);

                  FCurrentContainer[i].TimerOptions := options;
                end;
              finally
                bitfarmLog.DebugEnd(llDebug, 'Archive - Verarbeitung: i=' + i.ToString + ' - WVL', ClassName);
              end;

              {$IFDEF ENTERPRISE}
              if (FImporterPlugin <> '') then
              begin
                bitfarmLog.DebugBegin(llDebug, 'Archive - Verarbeitung: i=' + i.ToString + ' - ImporterPlugin', ClassName);
                try
                  //18.09.2024 SD -->bfacrm:ticket__show__39998
                  if Pos('\', FImporterPlugin) > 0 then
                    PluginFile := Trim(FImporterPlugin)
                  else
                    PluginFile := extractfilepath(ParamStr(0)) + '\Viewer-Files\plugins\' + Trim(FImporterPlugin);

//                  bitfarmLog.Write(llNormal, ltInfo, 'ImporterPlugin: ' + extractfilepath(ParamStr(0)) + '\Viewer-Files\plugins\' +
//                                   FImporterPlugin + ' wird ausgefhrt...', ClassName);
                  bitfarmLog.Write(llNormal, ltInfo, 'ImporterPlugin: ' + PluginFile + ' wird ausgefhrt...', ClassName);

//                  if FileExists(extractfilepath(ParamStr(0)) + '\Viewer-Files\plugins\' + FImporterPlugin) then
                  if FileExists(PluginFile) then
                  //18.09.2024 SD <--bfacrm:ticket__show__39998
                  begin
                    try
                      lsmydir := BD.EnvTemp + '\Viewer\';
                      if not DirectoryExists(lsmydir) then
                        ForceDirectories(lsmydir);
                      DateTimeToString(lsdname, 'ddmmyyyyhhnnss', now);
                      lsdname := lsdname + inttostr(Random(99999));
                      bitfarmApp.WriteJobFile(lsmydir + lsdname + '.job', true, 0, FCurrentContainer[i]);
                      //18.09.2024 SD -->bfacrm:ticket__show__39998
//                      rc := ShellExecute_AndWait('', '"' + extractfilepath(ParamStr(0)) + '\Viewer-Files\plugins\' +
//                        FImporterPlugin + '"' , '"' + lsmydir + lsdname + '"' + ' ' + '"' + FUser.Name + '"' + ' ' + '"' + FUser.Password + '"' + ' ' + '"' + Bd.ExeDir + bitfarmApp.Profile + '.con' + '"', '"' + extractfilepath(ParamStr(0)) + '"', SW_hide, True);
                      rc := ShellExecute_AndWait('', '"' + PluginFile + '"' , '"' + lsmydir + lsdname + '"' + ' ' + '"' + FUser.Name + '"' + ' ' + '"' +
                        FUser.Password + '"' + ' ' + '"' + Bd.ExeDir + bitfarmApp.Profile + '.con' + '"', '"' + extractfilepath(ParamStr(0)) + '"', SW_hide, True);
                      //18.09.2024 SD <--bfacrm:ticket__show__39998
                      if rc <> 0 then
                      begin
                        //27.09.2024 SD -->bfacrm:ticket__show__28581
                        AThread.Synchronize(nil,
                          procedure
                          begin
                            frmMainForm.frmSplash.UseTimer := False;
                            frmMainForm.frmSplash.Hide;
                          end);
                        //27.09.2024 SD <--bfacrm:ticket__show__28581
                        if rc = 127 then
                        begin
                          frmMainForm.SetNotificationBar(_('Plugin: Abbruch durch den Benutzer'), AThread); // SJ 14.08.2019
                          bitfarmLog.Write(llNormal, ltError, _('Plugin: Abbruch durch den Benutzer'));
                          AThread.Synchronize(nil,
                            procedure
                            begin
                              BfShowMessage(_('Plugin: Abbruch durch den Benutzer'));
                            end);
                          Exit;
                        end;
                        if rc = 255 then  // Abbruch ohne Rckmeldung, Programm kann weiter verwendet werden
                        begin
                          bitfarmLog.Write(llNormal, ltDebug, _('Plugin: Abbruch durch das Plugin rc = 255'));
                          Exit;
                        end;
                      end;

                      if FileExists(lsmydir + lsdname + '.job') then
                      begin
                        ReadJobFile(AThread, FCurrentContainer[i], lsmydir + lsdname + '.job', slZMetaField, slZMetaName, slZMetaFieldValues, slZMetaFieldType, Error, ErrorStr);
                        try
                          DeleteFile(lsmydir + lsdname + '.job');
                        except
                          bitfarmLog.Write(llNormal, ltException, 'Plugin JOB Datei konnte nicht gelscht werden: ' + lsmydir + lsdname + '.job');
                        end;
                      end;
                    except
                      on e: exception do
                        bitfarmLog.Write(llNormal, ltException, 'Fehler beim Ausfhren des Importerplugins: ' + e.Message, ClassName);
                    end;
                    bitfarmLog.Write(llNormal, ltDebug, _('Plugin durchgefhrt...'));
                  end
                  else
                    //18.09.2024 SD -->bfacrm:ticket__show__39998
//                    bitfarmLog.Write(llNormal, ltError, 'Plugin: ' + extractfilepath(ParamStr(0)) + '\Viewer-Files\plugins\' + FImporterPlugin + ' konnte nicht gefunden werden');
                    bitfarmLog.Write(llNormal, ltError, 'Plugin: ' + PluginFile + ' konnte nicht gefunden werden');
                    //18.09.2024 SD <--bfacrm:ticket__show__39998
                finally
                  bitfarmLog.DebugEnd(llDebug, 'Archive - Verarbeitung: i=' + i.ToString + ' - ImporterPlugin', ClassName);
                end;
              end;
              {$ENDIF}            // hier das Plugin ansetzen

              lst := TList<TbfaBaseObject>.Create;
              lst.Add(FCurrentContainer[i]);
              bitfarmLog.Write(llDebug, ltInfo, 'Archive - Verarbeitung: i=' + i.ToString + ' - Create Request reqArchive', ClassName);
              req.ReqType := 'reqArchive';
              req.UserID := User.ID;
              req.Profile := Self.Profile;
              req.Gdocid := -1;

              if FCurrentContainer[i].FileType <> '' then
                req.Parameter := FCurrentContainer[i].FileType
              else
                req.Parameter := '.tif';

              if ViewerOptions.GeneralOptions.LateOCR then   //Wenn LateOCR gesetz ist, dann muss hier hizugefgt werden, und der Server lst das auf Ticket 17687
                req.Parameter := req.Parameter + ';fast';

              req.Data := lst;
              req.Lang := Lang;
              if FCurrentContainer[i].DocType = dtFile then
              begin
                bitfarmLog.DebugBegin(llDebug, 'Archive - Verarbeitung: i=' + i.ToString + ' - SendSocket.SendDataToServer (dtFile)', ClassName);
                try
                  req.DataLen := FCurrentContainer[i].OriStream.Size;
                  req := SendSocket.SendDataToServer(req, FCurrentContainer[i].OriStream, AThread, frmMainForm.frmSplash)
                finally
                  bitfarmLog.DebugEnd(llDebug, 'Archive - Verarbeitung: i=' + i.ToString + ' - SendSocket.SendDataToServer (dtFile)', ClassName);
                end;
              end else
              begin
                bitfarmLog.DebugBegin(llDebug, 'Archive - Verarbeitung: i=' + i.ToString + ' - SendSocket.SendDataToServer', ClassName);
                try
                  req.DataLen := FCurrentContainer[i].DocStream.Size;
                  req := SendSocket.SendDataToServer(req, FCurrentContainer[i].DocStream, AThread, frmMainForm.frmSplash);
                finally
                  bitfarmLog.DebugEnd(llDebug, 'Archive - Verarbeitung: i=' + i.ToString + ' - SendSocket.SendDataToServer', ClassName);
                end;
              end;
              if req = nil then
                Exit;

              bitfarmLog.Write(llDebug, ltInfo, 'Archive - Verarbeitung: i=' + i.ToString + ' - req.ReqType=' + req.ReqType, ClassName);

              if req.ReqType = 'respAuthError' then
              begin
                BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
                UAction := CreateUserAction;
                UAction^.ActionName := 'actRelogin';
                MainThread.Add(UAction);
                Exit;
              end
              else if req.ReqType = 'respError' then
              begin
                BfShowMessage(_('Fehler beim Archivieren.') + #13#10 + req.DataString, AThread);
                Exit;
              end else
              begin
                bitfarmLog.DebugBegin(llDebug, 'Archive - Verarbeitung: i=' + i.ToString + ' - sList.Add(IntToStr(j))', ClassName);
                try
                  for j := 0 to FPreviewContainer.ImporterItem.Preview.List.Count - 1 do
                  begin
                    if FCurrentContainer[i] = FPreviewContainer.ImporterItem.Preview.List[j] then
                      sList.Add(IntToStr(j));
                  end;
                finally
                  bitfarmLog.DebugEnd(llDebug, 'Archive - Verarbeitung: i=' + i.ToString + ' - sList.Add(IntToStr(j))', ClassName);
                end;

                if frmMainForm.fraScanFunctions.chkPrintAfterArchive.Checked and
                   FCurrentContainer[i].HasPreview then
                begin
                  bitfarmLog.DebugBegin(llDebug, 'Archive - Verarbeitung: i=' + i.ToString + ' - PrintAfterArchive', ClassName);
                  try
                    UserAction := CreateUserAction;
                    UserAction^.ActionName := 'actPrintStandard';
                    UserAction^.Preview := FPreviewContainer.ImporterItem.Preview;
                    UserAction^.options := -1;

                    AThread.Synchronize(nil,
                      procedure
                      var
                        k: Integer;
                      begin
                        Doc := TbfaDocument.Create;
                        Doc.Clone(FCurrentContainer[i], True, True, True, True);

                        if ((Doc.LetterStream <> nil) and (Doc.LetterStream.Size = 0)) and
                           ((UserAction^.Preview <> nil) and (UserAction^.Preview.bfaTlbPreview.sbmStationery.Checked)) then
                        begin
                          Fname := '';
                          for k := 0 to UserAction^.Preview.bfaTlbPreview.sbmStationery.Count - 1 do
                            if UserAction^.Preview.bfaTlbPreview.sbmStationery[k].Checked then
                              Fname := UserAction^.Preview.bfaTlbPreview.sbmStationery[k].Caption;

                          LoadStationeryToDocument(Doc, Fname);
                        end;

                        UserAction^.Documents.Add(Doc);
                        CreatePrintStandardAction(UserAction, False, True);
                      end);
                  finally
                    bitfarmLog.DebugEnd(llDebug, 'Archive - Verarbeitung: i=' + i.ToString + ' - PrintAfterArchive', ClassName);
                  end;
                end;

                try
                  if Assigned(sList) then
                  begin
                    if sList.count > 0 then
                    begin
                      bitfarmLog.Write(llDebug, ltInfo, 'Archive - Verarbeitung: i=' + i.ToString + ' - DeleteSelected', ClassName);
                      DeleteSelected(FPreviewContainer.ImporterItem.Preview, sList,
                        AThread, mrYes, False);
                      AThread.Synchronize(nil,
                        procedure
                        begin
                          bitfarmApp.GetActivePreview.ShowPageNumber;
                        end);
                    end;
                  end;
                except
                  on e: exception do
                    bitfarmLog.Write(llNormal, ltException, 'Archive - DeleteSelected: ' + e.Message, ClassName);
                end;

              end;
            end;
          finally
            if lst <> nil then
            begin
              lst.Clear;
              FreeAndNil(lst);
            end;

            if Assigned(req) then
              FreeAndNil(req);
            if Assigned(SendSocket) then
            begin
              SendSocket.Disconnect;
              FreeAndNil(SendSocket);
            end;
          end;
        end;
      finally
        bitfarmLog.DebugEnd(llDebug, 'Archive - Verarbeitung', ClassName);
      end;

      if ViewerOptions.GeneralOptions.ResetFieldsAfterArchiving then
        ResetImporterFields(AThread);

      AThread.Synchronize(nil,
        procedure
        begin
          frmMainForm.fraScanFunctions.chkImportOCR.Checked := not ViewerOptions.GeneralOptions.NoOCR;
          frmMainForm.fraScanFunctions.chkColor.Checked := ViewerOptions.GeneralOptions.ImportColor;
          frmMainForm.fraScanFunctions.chkHiRes.Checked := ViewerOptions.GeneralOptions.ImportHighRes;
          {$IFDEF ENTERPRISE}
          TfraScanFunctionsEnterprise(frmMainForm.fraScanFunctions).chkBarcodemerge.Checked := ViewerOptions.GeneralOptions.ImportBarcode;
          {$ENDIF}

          //15.12.2023 bfacrm:ticket__show__37266 -->
          SelectNextDocumentOrDeselect(FPreviewContainer.ImporterItem.Preview);
          //15.12.2023 bfacrm:ticket__show__37266 <--
        end);
    except
      on e: exception do
        bitfarmLog.Write(llNormal, ltException, 'Archive: ' + e.Message, ClassName);
    end;
  finally
    if frmMainForm.frmSplash.Showing or frmMainForm.frmSplash.UseTimer then //27.09.2024 SD <--bfacrm:ticket__show__28581
    begin
      AThread.Synchronize(nil,
        procedure
        begin
          frmMainForm.frmSplash.UseTimer := False;
          frmMainForm.frmSplash.Hide;
        end);
    end;
    bitfarmLog.DebugEnd(llDebug, 'Archive', ClassName);
  end;
end;

procedure TbfaApplication.ResetImporterFields(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'ResetImporterFields', ClassName);
  try
    try
      ClearFields(AThread);
      ResetFields(AThread);     // f.schneider hier muss ja wohl eher ResetFields aufgerufen werden
      AThread.Synchronize(nil,
        procedure
        var
          i, j, k: Integer;
          cols, values: TStringList;
        begin
          frmMainForm.edtDocName.Text := '';
          // SJ 04.02.2021
//          frmMainForm.mmoDocLinks.Clear;
//          frmMainForm.mmoDocTags.Clear;
          frmMainForm.tokenDocLinks.Clear;
          frmMainForm.tokenDocTags.Clear;
          // SJ 04.02.2021
          with frmMainForm.fraImporterResub do
          begin
            cbbFavorites.Text := '';
            edtAlarm1.Text := '7';
            edtAlarm1.Value := 7;
            dtDate1.Date := Date();
            edtName.Text := '';
            edtInfoCreate.Text := '';
            edtInfoFoward.Text := '';
            cbbUser.SetUnCheckedAll;
            cbbGroup.SetUnCheckedAll;
            chkReturnToSender.Checked := False;
            chkEmailreminder.Checked := False;
            chkOnlyOne.Checked := False;
            chkEveryone.Checked := False;
            chkNotifyByMail.Checked := False;
          end;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'ResetImporterFields', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ResetImporterFields', ClassName);
  end;
end;

procedure TbfaApplication.Askfor_SaveAdmin;
begin
  if bitfarmApp.AdminEditMode then
  begin
    if frmMainForm.fraAdmin.Modified then
    begin
      if BfMessageDialogWithCheckBox(_('Info'),
           _('Es wurden nderungen im Administrator durchgefhrt. Mchten Sie diese speichern?'),
           mtConfirmation, [mbYes, mbNo], [_('Ja'), _('Nein')], True, bitfarmApp.ViewerOptions,
           'SaveAdmin', mrYes) = mrYes
      then
        frmMainForm.fraAdmin.btnSaveAdmin.Click
      else
      begin
        frmMainForm.fraAdmin.btnCancelAdmin.Click;
        bitfarmApp.LoadUser;
        bitfarmApp.ReadSysArc;
        bitfarmApp.Reloadfields;
        bitfarmApp.ReloadTrees;
      end;
    end else
    begin
      frmMainForm.fraAdmin.btnCancelAdmin.Click;
      bitfarmApp.LoadUser;
      bitfarmApp.ReadSysArc;
      bitfarmApp.Reloadfields;
      bitfarmApp.ReloadTrees;
    end;
  end;
end;

procedure TbfaApplication.ChangeArchive(params: TStringList; objects: TList; AThread: TThread);
var
  i, arcid, j: Integer;
  arcids: TStringList;
  showfields, FieldsCreated, ViewHasChanged: Boolean;
  LastViewerAddfields: Int64;
begin
  Log.DebugBegin(llDebug, 'ChangeArchive', ClassName);
  try
    try
      if FCurrentContainer.Count > 0 then
        LeaveCurrentDocs(AThread);

      FieldsCreated := False;
      FLastFocusedAddfield := nil;

      CurrentArchive.Name := TTreeNode(objects[0]).Text;
      CurrentArchive.Arcid := PbfaInt64(TTreeNode(objects[0]).Data).Value;
      arcid := CurrentArchive.Arcid;  // nur workaround
      CurrentArchive.Typ := PbfaInt64(TTreeNode(objects[0]).Data).ArcType;
      CurrentArchive.GroupingBar := aSysArc[CurrentArchive.ArcID].GroupingBar;
      CurrentArchive.Footer := aSysArc[CurrentArchive.ArcID].Footer;

      if (params[0] = 'tvkViewer') or (params[0] = 'tvkFavorites') then
      begin
        CurrentViewerArchive.Name := TTreeNode(objects[0]).Text;
        CurrentViewerArchive.Arcid := PbfaInt64(TTreeNode(objects[0]).Data).Value;
        CurrentViewerArchive.Typ := PbfaInt64(TTreeNode(objects[0]).Data).ArcType;
        CurrentViewerArchive.GroupingBar := aSysArc[CurrentViewerArchive.ArcID].GroupingBar;
        CurrentViewerArchive.Footer := aSysArc[CurrentViewerArchive.ArcID].Footer;

        if params[0] = 'tvkViewer' then
          CurrentView := tvkViewer
        else
          CurrentView := tvkFavorites;
      end
      else if params[0] = 'tvkImporter' then
      begin
        CurrentImportArchive.Name := TTreeNode(objects[0]).Text;
        CurrentImportArchive.Arcid := PbfaInt64(TTreeNode(objects[0]).Data).Value;
        CurrentImportArchive.Typ := PbfaInt64(TTreeNode(objects[0]).Data).ArcType;
        CurrentImportArchive.GroupingBar := aSysArc[CurrentImportArchive.ArcID].GroupingBar;
        CurrentImportArchive.Footer := aSysArc[CurrentImportArchive.ArcID].Footer;

        CurrentView := tvkImporter;

        AThread.Synchronize(nil,
          procedure
          begin
            frmMainForm.SetStatusBarID(CurrentArchive.Arcid, 0);
          end);
      end;

      if (CurrentView = tvkViewer) and (params[2] = 'tvkViewer') then
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            try
              if Assigned(frmMainForm.grdResultlistDevExView.DataController.DataSource) then
                if Assigned(frmMainForm.grdResultlistDevExView.DataController.DataSource.DataSet) then
                  frmMainForm.grdResultlistDevExView.DataController.DataSource := nil;
            except
              Log.Write(llNormal, ltException, 'ChangeArchive - Synchronize - 1', ClassName);
            end;
            try
              frmMainForm.tbiLimitAll.Visible := ((aSysArc[CurrentArchive.arcid].Rights and rightAdmin) = rightAdmin);
            except
              Log.Write(llNormal, ltException, 'ChangeArchive - Synchronize - 2', ClassName);
            end;

            if ((frmMainForm.btnLimit.Caption = '') or ((not frmMainForm.tbiLimitAll.Visible) and (frmMainForm.btnLimit.Caption = _('Alle')))) then
              frmMainForm.SetLimit(50);

            if FPreviewContainer.ActiveItem = FPreviewContainer.ViewerItem.Panel.Tag then
              ResetButtons(False);

          end);
        ResetViewer(AThread);
      end;

      if CurrentArchive.Typ <> 0 then
      begin
        AThread.Synchronize(nil,
          procedure
          var
            k : Integer;
          begin
            for k := 0 to frmMainForm.grdResultlistDevExView.ColumnCount - 1 do
            begin
              if frmMainForm.grdResultlistDevExView.Columns[k].DataBinding.FieldName = 'arcname' then
              begin
                frmMainForm.grdResultlistDevExView.Columns[k].Visible := False;
                Break;
              end;
            end;
          end);
      end;

      ViewHasChanged :=  GetEnumName(TypeInfo(TbfaViewKind), integer(CurrentView)) <> params[2];  //wurde der Treeview gewechselt?

      if (CurrentView = tvkViewer) and (FPreviewContainer.ActiveItem <> -1) and
        (CurrentArchive.Arcid > 0 ) and (CurrentViewerFields <> CurrentArchive.Arcid) then
      begin
        AThread.Synchronize(nil,
        procedure
        begin
          LoadStationaries(CurrentArchive.Arcid);
        end);
      end;

      // Zusatzfelder
      // zuerst ausblenden und entfernen

      if FPreviewContainer.ActiveItem <> -1 then
      begin
        if (FPreviewContainer.ActiveItem = FPreviewContainer.ViewerItem.Panel.Tag) and
            ((CurrentView = tvkViewer) or (CurrentView = tvkFavorites)) then
        //if ((FPreviewContainer.ActiveItem = FPreviewContainer.ViewerItem.Panel.Tag) and
            //(CurrentView = tvkViewer)) then
        begin  //wenn wir von der Wiedervorlage kommen, mssen wir auf jeden Fall neu laden, da sich das Grid gendert hat.
          showfields :=  (CurrentViewerFields <> CurrentArchive.Arcid) or (params[2] = 'tvkResub')
                          or ((LastView = tvkResub) or (LastView = tvkFavorites))
                          or ((LastView = tvkImporter) and (CurrentView = tvkFavorites)) //31.01.2024 bfacrm:ticket__show__37544
                          or ViewHasChanged;
        end;

        if ((FPreviewContainer.ActiveItem = FPreviewContainer.ImporterItem.Panel.Tag) and
            (CurrentView = tvkImporter))
           or
           ((CurrentView = tvkImporter) and (GetActivePreview.PreviewKind = pvkSingle) and
            (GetActivePreview.ActiveDoc <> nil) and ((GetActivePreview.ActiveDoc.ID = -1)))
        then
          showfields := (CurrentImporterFields <> CurrentArchive.Arcid) or ViewHasChanged;

        if ((FPreviewContainer.ActiveItem = FPreviewContainer.ResubItem.Panel.Tag) and
          (CurrentView = tvkResub))
        then
          showfields := (CurrentResubFields <> CurrentArchive.Arcid) or ViewHasChanged;
      end else   // beim Start des Viewers ist noch kein ActiveItem gesetzt
      begin      // wir zeigen die Felder der aktive Preview
          showfields := (frmMainForm.FlastActivePreview = 0) or (frmMainForm.FlastActivePreview = 1);
      end;

      if showfields then
      begin
        LastViewerAddfields := CurrentViewerFields;  // wir merken uns CurrentViewerFields, die wird in CreateAddfields berschrieben
        if (TTreeNode(objects[0]).ImageIndex in [Integer(icoidx_warehouse_open), Integer(icoidx_warehouse_closed)]) and ShowAllReposAddfields then
          arcids := GetArcids(arcid, User.ID)
        else
        begin
          arcids := TStringList.Create;
          arcids.Add(inttostr(arcid));
        end;

        CreateFields(AThread, arcids);
        FieldsCreated := True;

        if ((CurrentView = tvkViewer) and (FPreviewContainer.ActiveItem = 0) and (CurrentArchive.Arcid <> LastViewerAddfields))       // nur CreateGrid innerhalb des Viewers, wenn Archiv gewechselt
          or ((params[2] = 'tvkResub') or (params[2] = 'tvkFavorites'))
          or ((CurrentView = tvkViewer) and ((LastView = tvkResub) or (LastView = tvkFavorites)))
        then                      // oder wenn wir von der Resubview kommen
        begin
          ResetViewer(AThread); //24.05.2022 Ticket 30901
          CreateGrid(arcid, AThread);
        end;

        FreeAndNil(arcids);

        CurrentFields := CurrentArchive.Arcid;
        if (CurrentView = tvkViewer) or (CurrentView = tvkFavorites) then
          CurrentViewerFields := CurrentArchive.Arcid
        else if CurrentView = tvkImporter then
          CurrentImporterFields := CurrentArchive.Arcid;
      end
      else if FPreviewContainer.ActiveItem = -1 then
          CreateGrid(arcid, AThread);  //beim start wenn nicht der Viewer ist aktiv...

      //28.06.2024 BT wenn Tab Strg+U muss nicht neu geladen werden, aber gesetzt schon -->
      if (CurrentView = tvkViewer) or (CurrentView = tvkFavorites) then
      begin
        if (not showfields) and (CurrentViewerFields <> CurrentArchive.Arcid)  then
          CurrentViewerFields := CurrentArchive.Arcid;
      end;
      //28.06.2024 BT <--

      if ((FCurrentContainer.Count = 0) or (frmMainForm.grdResultlistDevExView.DataController.DataSource = nil) or
         (frmMainForm.grdResultlistDevExView.DataController.DataSource.DataSet = nil)) then
      begin
        ClearFields(AThread);
        ResetFields(AThread);
      end
      else
        ResetFields(AThread); //22.03.2018 beim Viewwechsel mssen die Auswahlfelder nochmal angepasst werden "StoredItems"

      bfaPreview36.RefreshSizeAddFields;  //09.10.2024 SD <--bfacrm:ticket__show__39992

      if (FPreviewContainer.ActiveItem = -1) then
      begin
        if (frmMainForm.FlastActivePreview = 0) then
        begin
          CurrentView := tvkViewer;
          SetActiveView(AThread, -1);
          CurrentArchive := CurrentViewerArchive;
          aCurrentViewerAddfields := aCurrentAddfields;
          aCurrentViewerStatefields := aCurrentStatefields;
          CreateGrid(arcid, AThread);
        end
        else if (frmMainForm.FlastActivePreview = 1) then
        begin
          CurrentView := tvkImporter;
          SetActiveView(AThread, -1);
          CurrentArchive := CurrentImportArchive;
          aCurrentImporterAddfields := aCurrentAddfields;
          aCurrentImporterStatefields := aCurrentStatefields;
          CreateGrid(arcid, AThread);
        end
        else if (frmMainForm.FlastActivePreview = 2) then
        begin
          CurrentView := tvkWorkplace;
          SetActiveView(AThread, -1);
          CreateGrid(arcid, AThread);
        end
        else if (frmMainForm.FlastActivePreview = 3) then
        begin
          CurrentView := tvkResub;
          SetActiveView(AThread, -1);
          CurrentArchive := CurrentResubArchive;
          aCurrentResubAddfields := aCurrentAddfields;
          aCurrentResubStatefields := aCurrentStatefields;
          CreateGrid(arcid, AThread);
        end;
      end;

      if not bitfarmApp.ViewerOptions.SearchOptions.DontResetOnArcSet then
        bitfarmApp.ResetStandardSearch(AThread);

      // Suche zurcksetzen
      FSearchObj.Reset;

      if CurrentArchive.Arcid > 0 then
        SetArcRights(CurrentArchive.Arcid);

      try
        AThread.Synchronize(nil,
          procedure
          begin
            if (CurrentView in [tvkViewer, tvkResub, tvkFavorites]) then
              frmMainForm.actSearch.Enabled := ((CurrentArchive.Typ = 0) and (aSysArc[CurrentArchive.Arcid].Rights = 0)) or
                                               ((aSysArc[CurrentArchive.Arcid].Rights and rightList) > 0) or
                                               (bitfarmApp.CurrentView = tvkResub)
            else
              frmMainForm.actSearch.Enabled := False;
          end);
      except
        Log.Write(llNormal, ltException, 'ChangeArchive - frmMainForm.actSearch.Enabled', ClassName);
      end;

      if (CurrentView = tvkViewer) then
      begin
        if (FPreviewContainer.ActiveItem <> pvtViewer) and (FViewerOptions.GeneralOptions.AutoViewerAtArchiveChange) then
          SetActiveView(AThread, pvtViewer);

        if (params[2] = 'tvkViewer') and ((aSysArc[CurrentArchive.Arcid].Rights and rightList) > 0) then
        begin
          if (FViewerOptions.SearchOptions.AutoDisplay) and (not fSkipAutoDisplay) then
            Search(AThread, true)
        end;
      end;

      if (CurrentView = tvkImporter) then
      begin
        AThread.Synchronize(nil,
        procedure
        begin
          if ((aSysArc[CurrentArchive.Arcid].options and 1) > 0) then
            frmMainForm.edtDocName.Style.StyleController := ctlRequired
          else
            frmMainForm.edtDocName.Style.StyleController := ctlGeneral;
        end);
      end;
    except
      Log.Write(llNormal, ltException, 'ChangeArchive', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'ChangeArchive', ClassName);
  end;
end;

procedure TbfaApplication.AuditProof(Data: PUserAction; AThread: TThread);
var
  req: TbfaRequest;
  UserAction: PUserAction;
begin
  Log.DebugBegin(llDebug, 'AuditProof', ClassName);
  try
    AThread.Synchronize(nil,
      procedure
      begin
        if BfMessageDlg(_('Wenn Sie dieses Dokument revisionssicher ablegen, knnen Sie keine\n' +
          'nderungen mehr an ihm vornehmen. nderungen an einem revisions-\n' +
          'sicheren Dokument werden als zweite Version im Archiv abgelegt.\n\n' +
          'Soll das aktuelle Dokument revisionssicher abgelegt werden?'), mtConfirmation, [mbYes, mbNo]) = mrYes then
        begin
          req := TbfaRequest.Create;
          try
            Data^.params.Delimiter := ';';
            Data^.params.StrictDelimiter := True;
            req.ReqType := 'reqAuditProof';
            req.UserID := User.ID;
            req.Profile := Self.Profile;
            req.Gdocid := -1;
            req.Parameter := Data^.params.DelimitedText;
            req.Lang := Lang;
            MainSocket.SendRequestToServer(req);

            req := MainSocket.ReceiveResponse(AThread);
            if req = nil then
              Exit;

//27.11.2018 Ticket 16957 -->
                if req.ReqType = 'respAuthError' then
            begin
              BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
              UserAction := CreateUserAction;
              UserAction^.ActionName := 'actRelogin';
              MainThread.Add(UserAction);
              Exit;
            end
            else
//27.11.2018 Ticket 16957 <--
              if req.ReqType = 'respError' then
              BfShowMessage(_('Fehler beim revisionssicheren Ablegen.') + #13#10 + req.DataString, AThread)
            else
            begin
              FCurrentContainer[0].RevSave := True;
              frmMainForm.mnuAuditProof.ImageIndex := Integer(icoidx_lock);
              frmMainForm.mnuAuditProof.Hint := _('Das Dokument ist revisionssicher abgelegt.');
              if Data^.Preview <> nil then
                Data^.Preview.itmAuditProof.ImageIndex := Integer(icoidx_lock);
            end;

          finally
            FreeAndNil(req);
          end;
        end;
      end);

  finally
    Log.DebugEnd(llDebug, 'AuditProof', ClassName);
  end;
end;

procedure TbfaApplication.Autozoom(prev: TbfaPreview; AThread: TThread = nil);
begin
  Log.DebugBegin(llDebug, 'Autozoom', ClassName);
  try
    try
      if ((prev = nil) or ((prev <> nil) and (prev.SingleView = nil)) or
         ((prev <> nil) and (prev.SingleView <> nil) and (prev.SingleView.img_DocView = nil)))
      then
        Exit;

      if prev.SingleView.img_DocView.MouseInteract = [miSelectZoom] then
      begin
        prev.UnCheckAllGraphicTools;
        prev.SingleView.img_DocView.MouseInteract := [];
      end;

      if prev.SingleView.img_DocView.IsEmpty then
        Exit;

      case prev.bfaTlbPreview.sbmAutozoom.ImageIndex of
        Integer(icoidx_preview_width):
          ZoomWidth(prev, nil, AThread);
        Integer(icoidx_preview_auto):
          ZoomPage(prev, nil, AThread);
        Integer(icoidx_preview_original):
          Zoom100(prev, nil, AThread);
        Integer(icoidx_preview_height):
          ZoomHeight(prev, nil, AThread);
        Integer(icoidx_select):
          ZoomSelect(prev, nil, AThread);
        Integer(icoidx_preview_no_autozoom):
          ZoomOff(prev, nil, AThread);
      end;

    except
      Log.Write(llNormal, ltException, 'Autozoom', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'Autozoom', ClassName);
  end;
end;

procedure TbfaApplication.ActivatePrev(prev: TbfaPreview); //24.07.2017 Ticket 11157
begin
  Log.DebugBegin(llDebug, 'ActivatePrev', ClassName);
  try
    try
      if (prev = nil) or (prev.SingleView = nil) or
         (prev.SingleView.img_DocView = nil) or prev.PreviewActiveated
      then
        Exit;

      bitfarmApp.Autozoom(prev);
      prev.PreviewActiveated := True;

    except
      Log.Write(llNormal, ltException, 'ActivatePrev', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'ActivatePrev', ClassName);
  end;
end;

procedure TbfaApplication.BackgroundCancel(UserAction: PUserAction; AThread: TThread);
var
  i: Integer;
  req: TbfaRequest;
  SendSocket: TSocketConnection;
begin
  Log.DebugBegin(llDebug, 'BackgroundCancel', 'BackThread');
  UserAction^.params.Delimiter := ';';
  UserAction^.params.StrictDelimiter := True;

  req := TbfaRequest.Create;
  try
    req.ReqType := 'reqCancel';
    req.UserID := User.ID;
    req.Gdocid := StrToInt(UserAction^.params[0]);
    UserAction^.params.Delete(0);
    req.Profile := Self.Profile;
    req.Parameter := UserAction^.params.DelimitedText;
    req.Lang := Lang;

    SendSocket := TSocketConnection.Create(bfaServerNoSSL, bfaServer, bfaServerPort, '');
    SendSocket.CreateComponents;
    if SendSocket.Connect then
    begin
      SendSocket.SendRequestToServer(req);

      req := SendSocket.ReceiveResponse(AThread);
      if req = nil then
      begin
        bitfarmLog.Debug(llDebug, 'ReceiveResponse = nil', ClassName);
        Exit;
      end;

      try
        //26.07.2022 Ticket 31661/3 -->
        if UserAction^.Options = 1 then
        begin
          var modified := FCurrentContainer[0].modified or FCurrentContainer[0].Modified_Preview or
                      FCurrentContainer[0].Modified_Annos or FCurrentContainer[0].Modified_AnnosDelete;
          RefreshDocumentAfterCancel(AThread, req, modified);
        end
        else
        //26.07.2022 Ticket 31661/3 <--
        RefreshGrid(AThread);
      except

      end;
    end
    else
      bitfarmLog.Write(llDebug, ltInfo, 'Es konnte keine Socketverbindung aufgebaut werden (BackgroundCancel)');
  finally
    if req <> nil then
      FreeAndNil(req); //07.08.2017
    SendSocket.Disconnect;
    FreeAndNil(SendSocket);
    Log.DebugEnd(llDebug, 'BackgroundCancel', 'BackThread');
  end;
end;

procedure TbfaApplication.BackThreadExecute(Data: Pointer; AThread: TThread);
var
  i: Integer;
begin
  Log.DebugBegin(llDebug, 'BackThreadExecute', 'BackThread');
  try
    if PUserAction(Data).ActionName = 'actPrintStandard' then
      PrintStandard(Data, AThread)
    else if PUserAction(Data).ActionName = 'actPrintSelect' then
      PrintSelect(Data, AThread)
    else if PUserAction(Data).ActionName = 'actPrintPreview' then
      PrintPreview(Data, AThread)
    else if PUserAction(Data).ActionName = 'actEmailTIFAttachment' then
      EmailAttachment(Data, AThread)
    else if PUserAction(Data).ActionName = 'actEmailPDFAttachment' then
      EmailAttachment(Data, AThread)
    else if PUserAction(Data).ActionName = 'actEmailOriginal' then
      EmailOriginal(Data, AThread)
    else if PUserAction(Data).ActionName = 'actEmailLink' then
      EmailLink(Data, AThread)
    else if PUserAction(Data).ActionName = 'actEmailPreview' then
      EmailPreview(Data, AThread)
    else if PUserAction(Data).ActionName = 'actLocalSavePDF' then
      LocalSavePDF(Data, AThread)
    else if PUserAction(Data).ActionName = 'actLocalSavePreview' then
      LocalSavePreview(Data, AThread)
    else if PUserAction(Data).ActionName = 'actLocalSaveTIF' then
      LocalSaveTIF(Data, AThread)
    else if PUserAction(Data).ActionName = 'actLocalSaveLink' then
      LocalSaveLink(Data, AThread)
    else if PUserAction(Data).ActionName = 'actLocalSaveOriginal' then
      LocalSaveOriginal(Data, AThread)
    else if PUserAction(Data).ActionName = 'actExportCSV' then
      ExportMetaData(mdeCSV, Data, AThread)
    else if PUserAction(Data).ActionName = 'actExportOO' then
      ExportMetaData(mdeOO, Data, AThread)
    else if PUserAction(Data).ActionName = 'actExportXLS' then
      ExportMetaData(mdeXLS, Data, AThread)
//    else if PUserAction(Data).ActionName = 'actSaveImporter' then
//      SaveImporter(Data)
    else if PUserAction(Data).ActionName = 'actSaveGlobalBookmark' then
      SaveGlobalBookmark(Data)
    else if PUserAction(Data).ActionName = 'actSaveLocalBookmark' then
      SaveLocalBookmark
    else if PUserAction(Data).ActionName = 'actDeleteGlobalBookmarkRequest' then
      DeleteGlobalBookmarkRequest(AThread, Data)
    else if PUserAction(Data).ActionName = 'actCopyDocToClipboard' then
      CopyDocToClipboard(AThread, Data)
    else if PUserAction(Data).ActionName = 'actSaveHistoryBookmark' then
      SaveHistoryBookmark
    else if PUserAction(Data).ActionName = 'actReOCR' then
      ReOCR(AThread, Data)
    else if PUserAction(Data).ActionName = 'actBackgroundCancel' then
      BackgroundCancel(Data, AThread)
    else if PUserAction(Data).ActionName = 'actExportToDB' then
      ExportToDB(Data, AThread);
  finally
    with PUserAction(Data)^ do
    begin
      if objects <> nil then
        objects.Free;
      if Documents <> nil then
      begin
        if FreeObjects then
        begin
          try
            for i := 0 to Documents.Count - 1 do
            begin
//19.06.2018 Ticket 14576 -->
//19.06.2018              TbfaDocument(Documents[i]).Free;
//              Documents[i] := nil;
//24.09.2018              bitfarmApp.Garbagecontainer.Add(Documents[i]);
//              if not bitfarmApp.GarbageTimer.Enabled then
//                bitfarmApp.GarbageTimer.Enabled := True;
              try
//17.01.2019                TbfaDocument(Documents[i]).SetProcesses(False);
//17.01.2019                bitfarmApp.AddDocToGarbageContainer(Documents[i]);

//29.08.2023 -->
////10.05.2023 -->
////                TbfaDocument(Documents[i]).Free;
//                AThread.Synchronize(nil,
//                  procedure
//                  begin
//                TbfaDocument(Documents[i]).Free;
//                  end);
////10.05.2023 <--
                {$IFDEF IMAGEEN_SYNCHRONIZED}
                AThread.Synchronize(nil,
                  procedure
                  begin
                    TbfaDocument(Documents[i]).Free;
                  end);
                {$ELSE}
                TbfaDocument(Documents[i]).Free;
                {$ENDIF}
//29.08.2023 <--
              finally
                Documents[i] := nil;
              end;
//19.06.2018 Ticket 14576 <--
            end;
            Documents.Clear;
          except
            Log.Write(llNormal, ltException, 'BackThreadExecute - FreeObjects', 'MainThread');
          end;
        end;
        Documents.Free;
      end;
      if params <> nil then
        params.Free;
      if sList <> nil then
        sList.Free;
    end;

    Dispose(Data);

    bitfarmLog.DebugEnd(llDebug, 'BackThreadExecute', 'BackThread');
  end;
end;

procedure TbfaApplication.RefreshDocumentAfterCancel(AThread: TThread; req: TbfaRequest; modified: boolean);
begin
  bitfarmLog.DebugBegin(llDebug, 'RefreshDocumentAfterCancel', ClassName);
  try
    bitfarmLog.Debug(llDebug, 'InEditMode := False', ClassName);
    FCurrentContainer[0].InEditMode := False;
    FCurrentContainer[0].EditmodeUserID := 0;

    if (req.Parameter <> '') and (FCurrentContainer.Count > 0) then // bei Multiselect alle Dokumente aus Editmode nehmen
    begin
      var docids := TStringList.Create;
      try
        docids.Delimiter := ';';
        docids.StrictDelimiter := True;
        docids.DelimitedText := req.Parameter;
        for var i := 1 to FCurrentContainer.Count - 1 do
        begin
          if docids.IndexOf(IntToStr(FCurrentContainer[i].ID)) > -1 then
            FCurrentContainer[i].InEditMode := False;
        end;
      finally
        docids.Free;
      end;
    end;

    // Component.Reset sets StyleController. Synchronize needed
    AThread.Synchronize(nil,
      procedure
      begin
        for var j: Integer := 0 to aCurrentAddfields.Count - 1 do
        begin
          if aCurrentAddfields[j].Component <> nil then
          begin
            aCurrentAddfields[j].Component.EditMode := False;
            aCurrentAddfields[j].Component.Reset;
          end;
        end;
      end);

    // bfacrm:ticket__show__30986 - Synchronize fehlte
    AThread.Synchronize(nil,
      procedure
      begin
        for var j: Integer := 0 to aCurrentStatefields.Count - 1 do
        begin
          if aCurrentStatefields[j].Component <> nil then
          begin
            aCurrentStatefields[j].Component.EditMode := False;
            aCurrentStatefields[j].Component.Reset;
          end;
        end;
      end);

    AThread.Synchronize(nil,
      procedure
      begin
//31.01.2024 sollte nur bei Lschdatum nicht zurckgesetzt werden                 if frmMainForm.dteSearch.Modified or frmMainForm.dteSearch.ModifiedHigh then
        //05.09.2024 SD -->bfacrm:ticket__show__39649
        if (frmMainForm.dteSearch.Modified or frmMainForm.dteSearch.ModifiedHigh) and (frmMainForm.tbiSoExpired.Checked) then
        begin
          frmMainForm.dteSearch.Modified := False;
          frmMainForm.dteSearch.ClearValue;
        end;
        frmMainForm.dteSearch.Editmode := False;
        //05.09.2024 SD <--bfacrm:ticket__show__39649

        ShowDocumentProperties(FCurrentContainer[0], GetActivePreview);

        bfaPreview36.ShowAddFields(FCurrentContainer[0], False);
        bfaPreview36.ShowStateFields(FCurrentContainer[0]);
        if (CurrentView = tvkResub) then
          ShowResubFields(FCurrentContainer[0], frmMainForm.fraResub);
      end);
    RefreshGrid(AThread);
    ReloadCurrentDocs(AThread);
    RefreshDocumentInPreviews(AThread, FCurrentContainer[0], GetActivePreview, nil, False, False, modified);
  finally
    bitfarmLog.DebugEnd(llDebug, 'RefreshDocumentAfterCancel', ClassName);
  end;
end;

procedure TbfaApplication.Cancel(AThread: TThread);
var
  UserAction: PUserAction;
  param: string;
  modified: Boolean;
begin
  bitfarmLog.DebugBegin(llDebug, 'Cancel', ClassName);
  try
    bitfarmLog.Debug(llDebug, 'FCurrentContainer.Count = ' + IntToStr(FCurrentContainer.Count), ClassName);
    if (FCurrentContainer.Count > 0) then
    begin
      if (FCurrentContainer[0].ID <> -1) and ((FCurrentContainer[0].InEditMode) or (bitfarmApp.CurrentContainer[0].EditmodeUserID = bitfarmApp.User.ID)) then
      begin
        bitfarmLog.Debug(llDebug, 'InEditMode = True', ClassName);

        modified := FCurrentContainer[0].modified or FCurrentContainer[0].Modified_Preview or
                    FCurrentContainer[0].Modified_Annos or FCurrentContainer[0].Modified_AnnosDelete;

        param := '';
        if FCurrentContainer.Count > 1 then
        begin
          for var i := 1 to FCurrentContainer.Count - 1 do
          begin
            if param = '' then
              param := IntToStr(FCurrentContainer[i].ID)
            else
              param := param + ';' + IntToStr(FCurrentContainer[i].ID);
          end;
        end;

        bitfarmLog.Debug(llDebug, 'reqCancel', ClassName);

        var req := TbfaRequest.Create;
        try
          req.ReqType := 'reqCancel';
          req.UserID := User.ID;
          req.Gdocid := FCurrentContainer[0].ID;
          req.Profile := Self.Profile;
          req.Parameter := param;
          req.Lang := Lang;
          MainSocket.SendRequestToServer(req);
          req := MainSocket.ReceiveResponse(AThread);
          if req = nil then
          begin
            bitfarmLog.Debug(llDebug, 'ReceiveResponse = nil', ClassName);
            Exit;
          end
          else if req.ReqType = 'respAuthError' then
          begin
            BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
            UserAction := CreateUserAction;
            UserAction^.ActionName := 'actRelogin';
            FMainThread.Add(UserAction);
            Exit;
          end else
          begin
            try
              RefreshDocumentAfterCancel(AThread, req, modified);
            except
              bitfarmLog.Write(llNormal, ltException, 'Cancel', ClassName);
            end;
          end;

          AThread.Synchronize(nil,
            procedure
            begin
              FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.tbi_normalmouseClick(nil); //18.07.2018 Ticket 14803
              if (frmMainForm.grdResultlistDevEx.Visible) and (frmMainForm.grdResultlistDevEx.Enabled) and
                 (not frmMainForm.grdResultlistDevEx.Focused) and
                 (GetActivePreview = FPreviewContainer.ViewerItem.Preview)
              then
                frmMainForm.grdResultlistDevEx.SetFocus;
            end);
        finally
          FreeAndNil(req);
        end;
      end;
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'Cancel', ClassName);
  end;
end;

procedure TbfaApplication.Reloadfields;
begin
  SetLength(aAddfields, 0);
  ReadAddfields;
  SetLength(aStatefields, 0);
  ReadStatefields;
end;

procedure TbfaApplication.ReloadCurrentDocs(AThread: TThread);
var
  i, Page: Integer;
begin
  Log.DebugBegin(llDebug, 'ReloadCurrentDocs', ClassName);
  try
    try
      if (FCurrentContainer.Count > 0) then
      begin
        if FCurrentContainer[0].Modified_Preview or FCurrentContainer[0].Modified_Annos or FCurrentContainer[0].Modified_AnnosDelete then
        begin
          if (not FDoSave) then //22.02.2017 weil in DoSave gibt es auch
          begin
            try
              if GetActivePreview.SingleView.img_DocView.IO.Params.ImageIndex >= 0 then
                Page := GetActivePreview.SingleView.img_DocView.IO.Params.ImageIndex
              else
                Page := 0;
            except
              Page := 0;
            end;
            bfaPreview36.ShowDocument(AThread, FCurrentContainer[0], nil, GetActivePreview, Page, True, False, False, nil, True, False, False, True);
            RefreshDocumentInPreviews(AThread, FCurrentContainer[0], GetActivePreview, nil);
          end;
        end
        else
        begin
          if (not FDoSave) then //14.03.2017 in CancelReq wird schon gemacht
          begin
            ReloadDocument(FCurrentContainer[0], False, AThread);  //14.03.2017
            AThread.Synchronize(nil,
              procedure
              begin
                FCurrentContainer[0].InEditMode := False;
                ShowDocumentProperties(FCurrentContainer[0], GetActivePreview);
              end);
            RefreshDocumentInPreviews(AThread, FCurrentContainer[0], GetActivePreview, nil);
          end;
        end;
      end;

      if FCurrentContainer.Count > 1 then
      begin
        for i := 1 to FCurrentContainer.Count - 1 do
        begin
          if FCurrentContainer[i].Modified_Preview then
          begin
            ReloadDocument(FCurrentContainer[i], False, AThread);
            RefreshDocumentInPreviews(AThread, FCurrentContainer[i], nil, nil);
          end
          else
            FCurrentContainer[i].InEditMode := False;
        end;
      end;
    except
      Log.Write(llNormal, ltException, 'ReloadCurrentDocs', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'ReloadCurrentDocs', ClassName);
  end;
end;

procedure TbfaApplication.ReloadImportTreeview;
begin
  bitfarmLog.DebugBegin(llDebug, 'ReloadImportTreeview', ClassName);
  try
    try
      frmMainForm.FImporterTreeview.Items.Clear;
      frmMainForm.FImporterTreeview.Checkboxes := ViewerOptions.GeneralOptions.EnableSymlinks;
      frmMainForm.FImporterTreeview.Load;
    except
      on e: exception do
        bitfarmLog.Write(llNormal, ltException, 'ReloadImportTreeview' + e.Message, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ReloadImportTreeview', ClassName);
  end;
end;

procedure TbfaApplication.ReloadTrees(all: Boolean = False);
begin
  bitfarmLog.DebugBegin(llDebug, 'ReloadTrees', ClassName);
  try
    try
      if all then
      begin
        frmMainForm.FViewerTreeview.Load(True); //31.03.2017 war False Ticket 10202
        frmMainForm.FImporterTreeview.Load(True); //31.03.2017 war False Ticket 10202
      end;
      frmMainForm.AdminTreeviewLoad(not frmMainForm.fAppStarted);

    except
      on e: exception do
        bitfarmLog.Write(llNormal, ltException, 'ReloadTrees' + e.Message, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ReloadTrees', ClassName);
  end;
end;

function TbfaApplication.ChangePassword(AThread: TThread): Boolean;
var
  req: TbfaRequest;
  newPassword: WideString;
  UserAction: PUserAction;
begin
  Result := False;
  bitfarmLog.DebugBegin(llDebug, 'ChangePassword', ClassName);
  try
    try
      if AThread <> nil then
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            frmMainForm.frmPassword := TfrmPassword.Create(frmMainForm);
            frmMainForm.frmPassword.Color := stlControl.Color;
            frmMainForm.frmPassword.SpTBXLabel1.Color := stlControl.Color;
            frmMainForm.frmPassword.SpTBXLabel1.Font.Color := stlControl.TextColor;
            frmMainForm.frmPassword.SpTBXLabel2.Color := stlControl.Color;
            frmMainForm.frmPassword.SpTBXLabel2.Font.Color := stlControl.TextColor;
            frmMainForm.frmPassword.SpTBXLabel3.Color := stlControl.Color;
            frmMainForm.frmPassword.SpTBXLabel3.Font.Color := stlControl.TextColor;
            frmMainForm.frmPassword.edtOldPassword.Color := stlControl.Color;
            frmMainForm.frmPassword.edtOldPassword.Font.Color := stlControl.TextColor;
            frmMainForm.frmPassword.edtnewPassword.Color := stlControl.Color;
            frmMainForm.frmPassword.edtnewPassword.Font.Color := stlControl.TextColor;
            frmMainForm.frmPassword.edtConfirm.Color := stlControl.Color;
            frmMainForm.frmPassword.edtConfirm.Font.Color := stlControl.TextColor;

            if ((FUser.Flags and 32) = 32) then
              frmMainForm.frmPassword.Caption := _('Das Passwort muss bei der ersten Anmeldung gendert werden.')
            else
              frmMainForm.frmPassword.Caption := _('Passwort ndern');
            frmMainForm.frmPassword.OldPassword := FUser.Password;
            frmMainForm.frmPassword.MustChange := (FUser.Flags and 32) = 32;
            frmMainForm.frmPassword.ShowModal;
          end);
      end
      else
      begin
        frmMainForm.frmPassword := TfrmPassword.Create(frmMainForm);
        if ((FUser.Flags and 32) = 32) then
          frmMainForm.frmPassword.Caption := _('Das Passwort muss bei der ersten Anmeldung gendert werden.')
        else
          frmMainForm.frmPassword.Caption := _('Passwort ndern');
        frmMainForm.frmPassword.OldPassword := FUser.Password;
        frmMainForm.frmPassword.MustChange := (FUser.Flags and 32) = 32;
        frmMainForm.frmPassword.ShowModal;
      end;

      if (frmMainForm.frmPassword.ModalResult = mrCancel) and ((FUser.Flags and 32) = 0) then
        Exit;

      if frmMainForm.frmPassword.ModalResult = mrOK then
      begin
        req := TbfaRequest.Create;
        newPassword := EnCrypt(frmMainForm.frmPassword.edtnewPassword.Text, FGlobalKey);

        try
          req.ReqType := 'reqSavePassword';
          req.UserID := User.ID;
          req.Profile := Self.Profile;
          req.Parameter := newPassword;
          req.Lang := Lang;
          MainSocket.SendRequestToServer(req);

          req := MainSocket.ReceiveResponse(AThread);
          if req = nil then
            Exit;

          //27.11.2018 Ticket 16957 -->
          if req.ReqType = 'respAuthError' then
          begin
            BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
            UserAction := CreateUserAction;
            UserAction^.ActionName := 'actRelogin';
            MainThread.Add(UserAction);
            Exit;
          end
          else
          //27.11.2018 Ticket 16957 <--
          if req.ReqType = 'respError' then
          begin
            BfShowMessage(_('Fehler beim Passwort ndern.') + #13#10 + req.DataString, AThread);
            Result := False;
          end
          else
          begin
            Result := True;
            FUser.Password := newPassword;
            FUser.Flags := FUser.Flags and not 32;
          end;

        finally
          FreeAndNil(req);
        end;
      end
      else
        Result := not ((FUser.Flags and 32) = 32);

      frmMainForm.frmPassword.Release;

      if Result then
        BfShowMessage(_('Das Passwort wurde gendert.'), AThread)
      else
        Result := ChangePassword(AThread);
    except
      on e: exception do
        bitfarmLog.Write(llNormal, ltException, 'ChangePassword' + e.Message, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ChangePassword', ClassName);
  end;
end;

procedure TbfaApplication.Checkout(UserAction: PUserAction; AThread: TThread);
var
  req: TbfaRequest;
  checkout: Boolean;
  infomsg, msg: String;
  docheckin: Boolean;
  item: TTBCustomItem;
  h: THandle;
  i, fdate: Integer;
  handles: THandleArray;
  cmdline: string;
  fpath, fname: string;
  fsize: Int64;
  fStream: TFileStream;
  fnames: TStrings;
  sock: TSocketConnection;
  UAction: PUserAction;
begin
  if OfflineMode or (FCurrentContainer.Count = 0) then
    Exit;

  req := TbfaRequest.Create;
  try
    if (FCurrentContainer[0].EditmodeUserID > 0) and (FCurrentContainer[0].EditmodeUserID <> User.ID) then
    begin
      msg := Format(_('Das Dokument wird aktuell von %s bearbeitet. Auschecken nicht mglich.'), [DBGetUserName(FCurrentContainer[0].EditmodeUserID)]);
      bitfarmLog.Write(llDebug, ltInfo, msg, ClassName);
      BfShowMessage(msg, AThread);
      Exit;
    end;

    if FCurrentContainer[0].CheckOutUserID > 0 then
    begin
      bitfarmLog.Write(llDebug, ltInfo, 'CheckOutUserID: ' + IntToStr(FCurrentContainer[0].CheckOutUserID) , ClassName);
      bitfarmLog.Write(llDebug, ltInfo, 'SuAnnoList.IndexOf: ' + IntToStr(FUser.SuAnnoList.IndexOf(IntToStr(FCurrentContainer[0].ArcID))) , ClassName);

      if (FCurrentContainer[0].CheckOutUserID = User.ID) or
         (FUser.SuAnnoList.IndexOf(IntToStr(FCurrentContainer[0].ArcID))> -1) then
      begin
//        # hier prfen ob das dokument ggf im bfaDocLauncher offen ist
        handles := getProcessHandles('bfaDocLauncher.exe');
        for i := Low(handles) to High(handles) do
        begin
          h := handles[i];
          if h <> 0 then
          begin
            try
              cmdline := GetCommandLineFromPidWMI(h);
              if Pos('checkout\' + IntToStr(FCurrentContainer[0].ID), cmdline) > 0 then
              begin
                bitfarmLog.Write(llDebug, ltInfo, 'Das Dokument scheint noch geffnet zu sein oder wurde noch nicht vollstndig bertragen. Einchecken nicht mglich.', ClassName);
                BfShowMessage(_('Das Dokument scheint noch geffnet zu sein\noder wurde noch nicht vollstndig bertragen.\nEinchecken nicht mglich.'), AThread);
                Exit;
              end;
            except
              begin
                bitfarmLog.Write(llDebug, ltException, 'Das Dokument scheint noch geffnet zu sein oder wurde noch nicht vollstndig bertragen. Einchecken nicht mglich.', ClassName);
                BfShowMessage(_('Das Dokument scheint noch geffnet zu sein\noder wurde noch nicht vollstndig bertragen.\nEinchecken nicht mglich.'), AThread);
                Exit;
              end;
            end;
          end;
        end;

        handles := getProcessHandles('bfaResyncDoc.exe');
        for i := Low(handles) to High(handles) do
        begin
          h := handles[i];
          if h <> 0 then
          begin
            try
              cmdline := GetCommandLineFromPidWMI(h);
              if Pos('checkout\' + IntToStr(FCurrentContainer[0].ID), cmdline) > 0 then
              begin
                bitfarmLog.Write(llDebug, ltInfo, 'Das Dokument wird aktuell bertragen. Versuchen Sie es gleich noch einmal.', ClassName);
                BfShowMessage(_('Das Dokument wird aktuell bertragen. Versuchen Sie es gleich noch einmal.'), AThread);
                Exit;
              end;
            except
              begin
                bitfarmLog.Write(llDebug, ltException, 'Das Dokument wird aktuell bertragen. Versuchen Sie es gleich noch einmal.', ClassName);
                BfShowMessage(_('Das Dokument wird aktuell bertragen. Versuchen Sie es gleich noch einmal.'), AThread);
                Exit;
              end;
            end;
          end;
        end;

        // als nchstes Prfen, ob das Dokument noch lokal liegt (wenn zB der bfaDocLauncher seinen Dienst quittieren
        // musste, weil die Anwendung sich nicht berwachen lie

        fpath := BD.AppdataBitfarmPd + 'checkout\' + IntToStr(FCurrentContainer[0].ID);
        bitfarmLog.Write(llDebug, ltInfo, 'fpath: ' + fpath , ClassName);
        bitfarmLog.Write(llDebug, ltInfo, 'FCurrentContainer[0].RevSave: ' + BoolToStr(FCurrentContainer[0].RevSave) , ClassName);

        if DirectoryExists(fpath) and not FCurrentContainer[0].RevSave then   // nur nrs dokumente werden hochgespielt
        begin
          fnames := TStringList.Create;
          FindAllFiles(fnames, fpath + '\', '*.*', False, False);
          bitfarmLog.Write(llDebug, ltInfo, 'fnames.Count: ' + IntToStr(fnames.Count) , ClassName);

          if fnames.Count > 0 then
          begin
            infomsg := '';
            if bitfarmApp.SVNInfo and not FCurrentContainer[0].RevSave then
            begin
              AThread.Synchronize(nil,
              procedure
              begin
                docheckin := bfaInputQuery(_('Info fr Version ...'), _('Bitte geben Sie eine Information zu dieser Version des Dokumentes an'), infomsg);
              end);

              if not docheckin then
                Exit;
            end;
            infomsg := ParseSQLString(infomsg);

            sock := TSocketConnection.Create(bfaServerNoSSL, bfaServer, bfaServerPort, '');
            sock.CreateComponents;
            if sock.Connect then
            begin
              fname := fnames[0];
              fsize := FileSize(fname);
              fdate := FileAge(fname);
              try
                fStream := TFileStream.Create(fname, fmOpenRead);
              except
                msg := Format(_('Die Datei %s scheint noch geffnet zu sein.\nbertragung an den Server nicht mglich.\nVersuchen Sie es gleich noch einmal.'), [ExtractFileName(fname)]);
                BfShowMessage(msg, AThread);
                bitfarmLog.Write(llDebug, ltWarning, msg , ClassName);

                Exit;
              end;
              req.reqtype := 'reqSyncDoc';
              req.gdocid := FCurrentContainer[0].ID;
              req.userid := FUser.ID;
              req.profile := Self.Profile;
              req.datalen := fsize;
              req.filename := ExtractFileName(fname);
        //        fdate = datetime.datetime.fromtimestamp(stats.st_mtime)
        //        fdate = fdate.replace(microsecond = 0)
        //        req.filedate = fdate
              req.Parameter := IntToStr(FCurrentContainer[0].CheckOutUserID);
              req.Parameter := req.Parameter + ';' + infomsg + ';' + bitfarmApp.User.Name;
              req.parameter := req.Parameter + ';checkin';
              req.FileDate := FileDateToDateTime(fdate);

              req := sock.SendDataToServer(req, fStream, AThread);
              fStream.Free;

              if req = nil then
                Exit;

              //27.11.2018 Ticket 16957 -->
              if req.ReqType = 'respAuthError' then
              begin
                msg := _('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.');
                bitfarmLog.Write(llDebug, ltWarning, msg , ClassName);
                BfShowMessage(msg, AThread);
                UAction := CreateUserAction;
                UAction^.ActionName := 'actRelogin';
                MainThread.Add(UAction);
                Exit;
              end else //27.11.2018 Ticket 16957 <--
              if req.ReqType = 'respError' then
              begin
                msg := _('Fehler beim bertragen der Datei zum Server') + #13#10 + req.DataString;
                bitfarmLog.Write(llDebug, ltWarning, msg , ClassName);
                BfShowMessage(msg, AThread);
                Exit;
              end else
              begin
                try
                  frmMainForm.SetNotificationBar(Format(_('Die Datei %s wurde zum Server bertragen'), [ExtractFileName(fname)]), AThread);
                  KillFile(fname);
                  DeleteDirectory(fpath)
                except
                  Log.Write(llNormal, ltException, 'Konnte Verzeichnis nicht lschen:' + fpath, ClassName);
                end;

                FCurrentContainer[0].CheckOutUserID := -1;
                Exit;     // wurde erfolgreich gesynct wird hier ausgestiegen

              end;
            end else
            begin
              msg := _('Konnte keine Verbindung zum Server aufbauen');
              bitfarmLog.Write(llDebug, ltWarning, msg , ClassName);
              BfShowMessage(msg, AThread);
              Exit;
            end;
          end;
        end;

        // kein Datei zum Syncen vorhanden oder gefunden? Dann einfaches Checkin
        req.ReqType := 'reqCheckin';
        checkout := False;

        infomsg := '';
        if bitfarmApp.SVNInfo and not FCurrentContainer[0].RevSave then
        begin
          AThread.Synchronize(nil,
          procedure
          begin
            docheckin := bfaInputQuery(_('Info fr Version ...'), _('Bitte geben Sie eine Information zu dieser Version des Dokumentes an'), infomsg);
          end);

          if not docheckin then
            Exit;
        end;
        infomsg := ParseSQLString(infomsg);
      end else
      begin
        bitfarmLog.Write(llDebug, ltInfo, 'Show Checkout Popup', ClassName);
        AThread.Synchronize(nil,
        procedure
        begin
          frmMainForm.popCheckout.Items.Clear;
          item := TTBCustomItem.Create(frmMainForm.popCheckout);
          item.Caption := _('Ausgecheckt von: ') + DBGetUserName(FCurrentContainer[0].CheckOutUserID);
          frmMainForm.popCheckout.Items.Add(item);
          frmMainForm.popCheckout.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
        end);
        Exit;
      end;
    end else
    begin  // war das Dokument nicht ausgecheckt, dann wird es jetzt ausgecheckt
      req.ReqType := 'reqCheckout';
      checkout := True;
    end;

    req.UserID := User.ID;
    req.Profile := Self.Profile;
    req.Gdocid := FCurrentContainer[0].ID;
    req.Parameter := IntToStr(FCurrentContainer[0].CheckOutUserID);
    if not checkout and (infomsg <> '') then
      req.Parameter := req.Parameter + ';' + infomsg + ';' + bitfarmApp.User.Name;
    req.Lang := Lang;
    MainSocket.SendRequestToServer(req);

    req := MainSocket.ReceiveResponse(AThread);
    if req = nil then
      Exit;

    //27.11.2018 Ticket 16957 -->
    if req.ReqType = 'respAuthError' then
    begin
      msg := _('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.');
      bitfarmLog.Write(llDebug, ltWarning, msg , ClassName);
      BfShowMessage(msg, AThread);
      UAction := CreateUserAction;
      UAction^.ActionName := 'actRelogin';
      MainThread.Add(UAction);
      Exit;
    end else
    //27.11.2018 Ticket 16957 <--
    if req.ReqType = 'respError' then
    begin
      if checkout then
        msg := Format(_('Fehler beim Auschecken des Dokuments.\n%s'), [req.DataString])
      else
        msg := Format(_('Fehler beim Einchecken des Dokuments.\n%s'), [req.DataString]);
      bitfarmLog.Write(llDebug, ltWarning, msg , ClassName);
      BfShowMessage(msg, AThread);
    end else
    begin
      if checkout then
        FCurrentContainer[0].CheckOutUserID := User.ID
      else
        FCurrentContainer[0].CheckOutUserID := -1;
    end;

  finally
    AThread.Synchronize(nil,
      procedure
      begin
        SetDocState(FCurrentContainer[0]);
        GetActivePreview.SetActions;
//30.01.2019        RefreshGrid;
      end);
    RefreshGrid(AThread);
    FreeAndNil(req);
  end;

end;

procedure TbfaApplication.CheckoutDocs(UserAction: PUserAction; AThread: TThread);
var
  SObj : TbfaSearch;
begin
  bitfarmLog.DebugBegin(llDebug, 'CheckoutDocs', ClassName);
  try
    try
      if (not FPreviewContainer.ViewerItem.Tab.Visible) or (CurrentView <> TbfaViewKind(pvtViewer)) then
      begin
        frmMainForm.fSkipMaximizeEvent := True;
        try
          frmMainForm.pnlTreeView.Maximize;
        finally
          frmMainForm.fSkipMaximizeEvent := False;
        end;
        SetActiveView(AThread, pvtViewer);
        CurrentViewerArchive.Arcid := -1;
        CurrentViewerFields := -1;
        ChangeArchiveFromProgram(frmMainForm.FViewerTreeview.LastSelected, AThread);
      end;

      Reset(AThread);

      SObj := TbfaSearch.Create;
      try
        with SObj do
        begin
          Reset;
          SObj.UserContext := bitfarmApp.User.ID;
          SObj.CheckOut := bitfarmApp.User.ID;
          SelectedCols := SetSelectedColumns(False, True);
        end;

        AddArchiveColumn(AThread, SObj);

        StartSearchThread(SObj);

      finally
        FreeAndNil(SObj);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'CheckoutDocs', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CheckoutDocs', ClassName);
  end;
end;

procedure TbfaApplication.CheckoutDocsAdmin(UserAction: PUserAction; AThread: TThread);
var
  SObj : TbfaSearch;
begin
  if bitfarmApp.User.SuAnnoList.Count = 0 then
  begin
    BfShowMessage(_('Sie bentigen Adminberechtigung in wenigstens einem Archiv.'), AThread);
    Exit;
  end;

  try
    try
      if (not FPreviewContainer.ViewerItem.Tab.Visible) or (CurrentView <> TbfaViewKind(pvtViewer)) then
      begin
        frmMainForm.fSkipMaximizeEvent := True;
        try
          frmMainForm.pnlTreeView.Maximize;
        finally
          frmMainForm.fSkipMaximizeEvent := False;
        end;
        SetActiveView(AThread, pvtViewer);
        CurrentViewerArchive.Arcid := -1;
        CurrentViewerFields := -1;
        ChangeArchiveFromProgram(frmMainForm.FViewerTreeview.LastSelected, AThread);
      end;

      Reset(AThread);

      SObj := TbfaSearch.Create;
      try
        with SObj do
        begin
          Reset;
          SObj.UserContext := bitfarmApp.User.ID;
          SObj.CheckOut := 0;
          SelectedCols := SetSelectedColumns(False, True);
        end;
        AddArchiveColumn(AThread, SObj);
        StartSearchThread(SObj);
      finally
        FreeAndNil(SObj);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'CheckoutDocsAdmin', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CheckoutDocsAdmin', ClassName);
  end;
end;

procedure TbfaApplication.CheckResub(AThread: TThread);
var
  lmq: TUniQuery;
  changed: Boolean;
  delta_new_resub: Integer;
  inifile: TIniFile;
begin
  bitfarmLog.DebugBegin(llDebug, 'CheckResub', ClassName);
  FSkipDoQueueCount := True;  // damit wir uns nicht mit dem Queuecount Timer in die Quere kommen
  try
    try
      delta_new_resub := 0;
      changed := False;
      lmq := DbCreateQuery;
      if lmq.Connection = nil then
        Exit;
      try
        try
          lmq.SQL.Text := 'select timid from sys_timer where (status & 4) = 0 and '
                          + 'userid_work in (' + bitfarmApp.User.HolidayList.CommaText + ') and '
                          + 'date(date) <= str_to_date(' + #39 + FormatDateTime('yyyy-mm-dd', dateCWLastDay)
                          + #39 + ', ' + #39 + '%Y-%m-%d' + #39 + ')' +
                          //AND (NOT (tmr.status & 4 = 4)) 03.08.2022 kann sein dass es wir hier noch brauchen...
                          ' GROUP BY timref, timid;'; //03.08.2022 Ticket 31785

          lmq.Execute;
        except
          on e: Exception do
          begin
            if lmq <> nil then
              Log.Write(llNormal, ltException, 'Fehler bei CheckResub: ' + lmq.SQL.Text, ClassName)
            else
              Log.Write(llNormal, ltException, 'Fehler bei CheckResub: ' + e.Message, ClassName);
          end;
        end;

        if lmq.RecordCount > 0 then //28.07.2017 wegen CrashLog eingebaut: Operation bei geschlossener Datenmenge nicht ausfhrbar.
        begin

        // Wir mssen jedes Element der alten Liste mit jedem Element der neuen Liste vergleichen
        // Allgemeine Flle:
        // A) Keine nderung
        // B) Neue WVL hizugekommen
        // C) WVL weggefallen
        // D) n WVL weggefallen und n WVL hinzugekommen (count in beiden Fllen gleich)
        // E) n WVL weggefallen und m WVL hinzugekommen
        // F) m WVL weggefallen und n WVL hinzugekommen
          changed := lmq.RecordCount <> TimidList.Count;
          lmq.First;
          while not lmq.Eof do
          begin
            if TimidList.IndexOf(lmq.FieldByName('timid').AsString) = -1 then  // aktuelle timid nicht in liste der letzten timids?
            begin                                                              // dann liste gendert
              changed := True;
              inc(delta_new_resub);
            end;
            lmq.Next;
          end;

          // Neu: new_resub kann negativ werden, wenn etwas wegefallen ist
          //      new_resub wird von Fnew_resubs abgezogen (negative addition),
          //      Falls Fnew_resubs <=0 dann setzen wir Fnew_resubs = 0;

          if TimidList.Count > lmq.RecordCount then
            delta_new_resub := delta_new_resub - (TimidList.Count - lmq.RecordCount);

          if (delta_new_resub = 0) and (FNewResubs = 0) then   // keine neuen WVL?
          begin                                                   // anzeige zurcksetzen
            changed := True;
      //      FNewResubs := 0;
          end;

          // jetzt noch timidlist aktualisieren
          TimidList.Clear;             // Fall: wir lschen alle vorhanden WVL
          lmq.First;
          while not lmq.Eof do
          begin
            TimidList.Add(lmq.FieldByName('timid').AsString);
            lmq.Next;
          end;

          if (changed) and (frmMainForm.fAppStarted) and (not ClosingMainForm) then
          begin
            FNewResubs := FNewResubs + delta_new_resub;  // nderung zu vorher addieren/subtrahieren
            if FNewResubs < 0 then                       // negative nderungen brauche nicht angezeigt zu werden
              FNewResubs := 0;

//22.02.2022            if (CurrentView = tvkResub) and (ResubKind = rkMyTasks) then
            if (CurrentView = tvkResub) and (frmMainForm.fraResub.ResubKind = rkMyTasks) then
              RefreshGrid(AThread)
            else
            begin
              AThread.Synchronize(nil,
                procedure
                begin
                  if FNewResubs > 0 then
                  begin
                    if (FViewerOptions.GeneralOptions.AlertWindow) then
                      ShowAlertWindow(alResub, _('Ihre Wiedervorlagenliste hat sich gendert'))
                    else
                      frmMainForm.SetNotificationBar(_('Ihre Wiedervorlagenliste hat sich gendert'), nil); // SJ 14.08.2019
                  end;
                end);
            end;

            AThread.Synchronize(nil,
              procedure
              begin
                if FNewResubs > 0 then
                  frmMainForm.pnlResubmission.Caption := sCaptionResubmission + ' (' + IntToStr(TimidList.Count) + ')  ' + sCaptionNewResubmission + ' (' + IntToStr(FNewResubs) + ')'
                else
                  frmMainForm.pnlResubmission.Caption := sCaptionResubmission + ' (' + IntToStr(TimidList.Count) + ')';
              end);
          end;
        end
        else
        begin
          TimidList.Clear;  // Wenn wir keine WVL haben, dann clearen wir die Liste
          FNewResubs := 0;  // und setzen FNewResubs auf 0

          AThread.Synchronize(nil,
            procedure
            begin
              frmMainForm.pnlResubmission.Caption := sCaptionResubmission;
            end);
        end;

        if not ClosingMainForm then
        begin
          inifile := TIniFile.Create(BD.EnvAppdataPd + 'bitfarm-archiv\Viewer.ini');
          try
            inifile.WriteString('Resub', 'TimidList', bitfarmApp.TimidList.DelimitedText);
            inifile.WriteInteger('Resub', 'NewResubs', bitfarmApp.FNewResubs);
          finally
            FreeAndNil(inifile);
          end;
        end;
      finally
        lmq.Free;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'CheckResub', ClassName);
    end;
  finally
    FSkipDoQueueCount := False;
    bitfarmLog.DebugEnd(llDebug, 'CheckResub', ClassName);
  end;
end;

// Funktion checkt ob Werte auerhalb der Itemsliste eines Zusatzfeldes vorkommen
// wird kein Wert zur Prfung (aOldValue) bergeben, werden alle distinct Werte aus der DB geholt
// und in outlist befinden sich die entsprechenden Werte.
// Wird ein Wert zur Prfung bergeben befinden sich in outlist alle gdocids, welche diesen Wert tragen
// Wird ein Wert zur Prfung und kein neuer Wert angegeben (Lschen eines Wertes) kann der zu prfende
// Wert auch eine Liste (semikolongetrennt) sein

function TbfaApplication.CheckStrictfieldItems(addfield: TbfaAddfield; out outlist: TStringList;
  AOldValue: string = ''; ANewValue : string =''): TStrictItemsAction;
var
  lmq: TUniQuery;
  newitems, olditems: TStringList;
  msg: string;
  i : Integer;
begin
  Result := siaNone;
  if addfield.Options and 8 = 0 then  //kein Strict feld? Dann wieder raus
    Exit;

  if addfield.ID = -1 then  // neu angelegtes Feld, welches noch nicht gespeichert wurde
    Exit;

  bitfarmLog.DebugBegin(llDebug, 'CheckStrictfieldItems', ClassName);

  try
    try

      lmq := DbCreateQuery;
      try
        if AOldValue = '' then
        begin

          newitems := TStringList.Create;
          newitems.StrictDelimiter := True;
          newitems.Delimiter := ';';
          lmq.SQL.Text := 'select distinct('+ addfield.Name+ ') from sys_docidx_' + IntToStr(addfield.IndexTableID) + ' where ' +
                           addfield.Name+ ' is not Null';

          lmq.Execute;
          bitfarmLog.Write(llNormal, ltDebug, 'CheckStrictfieldItems ' + lmq.SQL.Text, ClassName);
          if lmq.RecordCount = 0 then   // der Wert wurde bei keinem Dokument vergeben, raus mit siaNone
            Exit;

          lmq.First;
          while not lmq.Eof do
          begin
            newitems.Clear;

            if addfield.Typ = 3 then  // Mehrfach
              newitems.DelimitedText := lmq.FieldByName(addfield.Name).AsString
            else
              newitems.Add(lmq.FieldByName(addfield.Name).AsString);

            for i := 0 to newitems.Count -1 do
            begin
              if addfield.Items.IndexOf(newitems[i]) = -1 then
              begin

                outlist.Add(lmq.FieldByName(addfield.Name).AsString);
              end;
            end;
            lmq.Next;
          end;

          if outlist.Count = 0 then
            Exit;

          if outlist.Count = 1 then
            msg := _('Es wurde ein Eintrag im Archiv gefunden, welcher nicht in der Liste ist!\n' +
                    'Soll dieser Eintrag zur Liste hinzugefgt werden,\noder soll der Wert im Archiv entfernt werden\n' +
                    'oder soll keine nderung durchgefhrt werden? (Werte im Archiv bleiben bestehen)')
          else
            msg := Format(_('Es wurden %d Eintrge im Archiv gefunden, die nicht in der Liste sind!\n' +
                    'Sollen diese Eintrge zur Liste hinzugefgt werden,\noder sollen die Eintrge im Archiv entfernt werden\n' +
                    'oder soll keine nderung durchgefhrt werden?  (Werte im Archiv bleiben bestehen)'),[outlist.Count]);
          msg := msg + #13#10 + _('(Achtung, nderungen werden direkt ausgefhrt)');
          frmStrictItemsDialog := TfrmStrictItemsDialog.Create(nil);
          frmStrictItemsDialog.lbl1.Caption := ParseMsg(msg);
          frmStrictItemsDialog.ShowModal;

          if frmStrictItemsDialog.ModalResult = mrYes then
            Result := siaAddToList
          else if frmStrictItemsDialog.ModalResult = mrNo then
            Result := siaDelete
          else if frmStrictItemsDialog.ModalResult = mrCancel then
            Result := siaNoChanges;

        end else
        begin
          if (ANewValue = '') then
          begin
            if Pos(';', AOldValue) > 0 then
            begin
              olditems := TStringList.Create;
              olditems.Delimiter := ';';
              olditems.StrictDelimiter := True;
              olditems.DelimitedText := AOldValue;
              AOldValue := #39 + olditems[0] + #39;
              for i := 1 to olditems.Count -1 do
                AOldValue := AOldValue + ',' + #39 + olditems[i] + #39;
            end else
              AOldValue := #39+ AOldValue + #39;
          end else
            AOldValue := #39+ AOldValue + #39;

          lmq.SQL.Text := 'select gdocid from sys_docidx_' + IntToStr(addfield.IndexTableID) + ' where ' +
                 addfield.Name+ ' in (' + AOldValue + ')';

          lmq.Execute;
          if lmq.RecordCount = 0 then   // der Wert wurde bei keinem Dokument vergeben, raus mit siaNone
            Exit;

          if (ANewValue = '') then    // Delete
          begin
            if lmq.RecordCount =1 then
//              msg := Format(_('Der Wert %s wurde bei einem Dokument im Archiv gefunden.\n' +
//                      'Soll dieser Wert in der Liste beibehalten werden,\noder soll der Wert im Archiv entfernt werden\n' +
//                      'oder soll keine nderung im Archiv durchgefhrt werden?'), [AOldValue])
              msg := Format(_('Der Wert %s wurde bei einem Dokument im Archiv gefunden.\n' +
                      'Soll dieser Wert nur aus der Liste entfernt, bei den Dokumenten aber behalten werden\noder soll der Wert aus der Liste und den Dokumenten entfernt werden\n' +
                      'oder soll keine nderung durchgefhrt werden?'), [AOldValue])
            else
//              msg := Format(_('Der Wert %s wurde bei %d Dokumenten im Archiv gefunden.\n' +
//                      'Soll dieser Wert in der Liste beibehalten werden,\noder soll der Wert im Archiv entfernt werden\n' +
//                      'oder soll keine nderung im Archiv durchgefhrt werden?'),[AOldValue, lmq.RecordCount]);
              msg := Format(_('Der Wert %s wurde bei %d Dokument im Archiv gefunden.\n' +
                      'Soll dieser Wert nur aus der Liste entfernt, bei den Dokumenten aber behalten werden\noder soll der Wert aus der Liste und den Dokumenten entfernt werden\n' +
                      'oder soll keine nderung durchgefhrt werden?'), [AOldValue, lmq.RecordCount])
          end else
          begin             // Modify
            if lmq.RecordCount = 1 then
              msg := Format(_('Der Wert %s wurde bei einem Dokument im Archiv gefunden.\n' +
                      'Soll dieser Wert bei dem Dokument in den neuen Wert %s gendert werden,\noder soll der Wert bei dem Dokument entfernt werden\n' +
                      'oder soll keine nderung bei dem Dokument durchgefhrt werden?'), [AOldValue, ANewValue])
            else
              msg := Format(_('Der Wert %s wurde bei %d Dokumenten im Archiv gefunden.\n' +
                      'Soll dieser Wert bei den Dokumenten in den neuen Wert %s gendert werden,\noder soll der Wert bei den Dokumenten entfernt werden\n' +
                      'oder soll keine nderung bei den Dokumenten durchgefhrt werden?'),[AOldValue, lmq.RecordCount, ANewValue]);
          end;

          msg := msg + #13#10 + _('(Achtung, nderungen werden direkt ausgefhrt)');
          frmStrictItemsDialog := TfrmStrictItemsDialog.Create(nil);
          frmStrictItemsDialog.lbl1.Caption := ParseMsg(msg);

          if (ANewValue = '') then
          begin
            frmStrictItemsDialog.btnYes.Caption := _('Nur aus Liste entfernen');
            frmStrictItemsDialog.btnNo.Caption := _('Komplett entfernen');
          end else
            frmStrictItemsDialog.btnYes.Caption := _('ndern');

          frmStrictItemsDialog.ShowModal;

          if frmStrictItemsDialog.ModalResult in [mrYes, mrNo] then
          begin
            lmq.First;
            while not lmq.Eof do
            begin
              outlist.Add(lmq.FieldByName('gdocid').AsString);
              lmq.Next;
            end;
          end;
          if (ANewValue = '') then
          begin
            if frmStrictItemsDialog.ModalResult = mrYes then
              Result := siaNoChanges  //siaAddToList
            else if frmStrictItemsDialog.ModalResult = mrNo then
              Result := siaDelete
            else if frmStrictItemsDialog.ModalResult = mrCancel then
              Result := siaAddToList; //siaNoChanges;
          end else
          begin
            if frmStrictItemsDialog.ModalResult = mrYes then
              Result := siaAddToList
            else if frmStrictItemsDialog.ModalResult = mrNo then
              Result := siaDelete
            else if frmStrictItemsDialog.ModalResult = mrCancel then
              Result := siaNoChanges;
          end;
        end;
      finally
        lmq.Free;
      end;

    except
      on e: exception do
        bitfarmLog.Write(llNormal, ltException, 'CheckStrictfieldItems' + e.Message, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CheckStrictfieldItems', ClassName);
  end;
end;

procedure TbfaApplication.CleanAddfieldsList(Source: TList<TbfaAddfield>);
var
  i: Integer;
begin
  for i := Source.Count - 1 downto 0 do
    if Source[i] = nil then
      Source.Delete(i);
end;

procedure TbfaApplication.CleanStatefieldsList(Source: TList<TbfaStatefield>);
var
  i: Integer;
begin
  for i := Source.Count - 1 downto 0 do
    if Source[i] = nil then
      Source.Delete(i);
end;

procedure TbfaApplication.ClearCurrentContainer;
var
  found: Boolean;
  i, j, k: Integer;
  gdocid: Int64;
begin
  Log.DebugBegin(llDebug, 'ClearCurrentContainer', ClassName);
  EnterCriticalSection(FClearContainer_CS);
  try
    try
      for k := FCurrentContainer.Count - 1 downto 0 do
      begin
        found := False;
        gdocid := FCurrentContainer[k].ID;
        for i := 0 to FPreviewContainer.Containers.Count - 1 do
        begin
          if (FPreviewContainer.Containers[i].Preview <> nil) and (FPreviewContainer.Containers[i].Preview.List <> nil) then
          begin
            for j := 0 to FPreviewContainer.Containers[i].Preview.List.Count - 1 do
            begin
              if gdocid = FPreviewContainer.Containers[i].Preview.List[j].ID then
              begin
                found := True;
                Break;
              end;
            end;
            if found then
              Break;
          end;
        end;

        if not found and (FCurrentContainer.Count > k) then
        begin
          try
            try
              if (FCurrentContainer[k] <> nil) and (FCurrentContainer[k].ID <> 0) then
              begin
                try
//17.01.2019                    FCurrentContainer[k].Free;
                except
                  FCurrentContainer[k] := nil;
                end;
              end;
            finally
              FCurrentContainer[k] := nil;
            end;

            try
              FCurrentContainer.Delete(k);
            except
              Log.Write(llnormal, ltException, 'ClearCurrentContainer - FCurrentContainer.Delete(k)', ClassName);
            end;
          except
          end;
        end;
      end;
    except
      Log.Write(llnormal, ltException, 'ClearCurrentContainer', ClassName);
    end;
  finally
    LeaveCriticalSection(FClearContainer_CS);
    Log.DebugEnd(llDebug, 'ClearCurrentContainer', ClassName);
  end;
end;

constructor TbfaApplication.Create;
var
  reg: TRegistry;

  procedure SetAnnoColorsAtFirstStart362(RegStr: string);
  var
    RegColor: TColor;
  begin
    try
      if reg.ValueExists(RegStr) then
      begin
        RegColor := reg.ReadInteger(RegStr);
        case RegColor of
          clBlue : reg.WriteInteger(RegStr, gclBlue);
          clRed : reg.WriteInteger(RegStr, gclRed);
          clLime : reg.WriteInteger(RegStr, gclLime);
          $000080ff : reg.WriteInteger(RegStr, cColorOrange);
          clYellow : reg.WriteInteger(RegStr, gclYellow);
        end;
      end;
    except
    end;
  end;
begin
  try
    inherited Create;
    FFirstStart362 := False; //06.09.2022 bleibt alles, wie bisher in 361
    RefreshGridInProcess := False; //11.01.2023
    ChangeSkinRunning := False;  //25.01.2023 bfacrm:ticket__show__33644

    reg := TRegistry.Create;
    try
      reg.RootKey := HKEY_CURRENT_USER;
      if reg.KeyExists('Software\bitfarm\Archiv_V3\Viewer\Annotation') then
      begin
        reg.OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation', False);
        if reg.ValueExists('ViewerVersion') then
        begin
          var VVer : string;
          VVer := reg.ReadString('ViewerVersion');
          FFirstStart362 := (VVer <> '362');
        end
        else
          FFirstStart362 := True;
        reg.CloseKey;

        if FFirstStart362 then
        begin
          for var i := 0 to 4 do
          begin
            var SubStr, SubStr2: string;
            if i > 0 then
              SubStr := i.ToString() + '\'
            else
              SubStr := '';

            SubStr2 := 'Software\bitfarm\Archiv_V3\Viewer\Annotation\Freihand' + SubStr;
            reg.OpenKey(SubStr2, True);
            SetAnnoColorsAtFirstStart362('ObjBrushColor');
            SetAnnoColorsAtFirstStart362('ObjPenColor');
            reg.CloseKey;
            SubStr2 := 'Software\bitfarm\Archiv_V3\Viewer\Annotation\HiLite' + SubStr;
            reg.OpenKey(SubStr2, True);
            SetAnnoColorsAtFirstStart362('ObjBrushColor');
            SetAnnoColorsAtFirstStart362('ObjPenColor');
            reg.CloseKey;
            SubStr2 := 'Software\bitfarm\Archiv_V3\Viewer\Annotation\Note' + SubStr;
            reg.OpenKey(SubStr2, True);
            SetAnnoColorsAtFirstStart362('ObjBrushColor');
            SetAnnoColorsAtFirstStart362('ObjPenColor');
            reg.CloseKey;
          end;

          reg.OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation', False);
          reg.WriteString('ViewerVersion', '362');

          //26.10.2022 Ticket 32681 -->
          if FileExists(BD.AppdataBitfarmPd + 'ViewerLayout.ini') then
          begin
            var IniFile : TIniFile;
            IniFile := TIniFile.Create(BD.AppdataBitfarmPd + 'ViewerLayout.ini');
            try
              if iniFile.SectionExists('Standard @ SpTBXDockablePanel3') then
                if inifile.ValueExists('Standard @ SpTBXDockablePanel3', 'DockedTo') and (IniFile.ReadString('Standard @ SpTBXDockablePanel3', 'DockedTo', '') = '+') then
                  IniFile.WriteString('Standard @ SpTBXDockablePanel3', 'DockedTo',
                    IniFile.ReadString('Standard @ SpTBXDockablePanel3', 'LastDock', 'dckTreeView'));
            finally
              FreeAndNil(IniFile);
            end;
          end;
          //26.10.2022 Ticket 32681 <--
        end;
      end;
    finally
      FreeAndNil(reg);
    end;

    GridCreating := False; //13.07.2020
    AddFieldsCreating := False;
    TVFontSize := 10; //22.10.2020
    CancelProcess := False;

    UseMatchAgainst := False;
    FUseSearch35 := False;
    FIgnoreRightsAtImport := False;
    fSkipTabChangeEvent := False;
    MViewSelectingByMouseMove := False;
    FDoSave := False;
    ShowAllSymLinks := False;
    FUseFileTarget := True;
    DoDropping := False;
    fSkipAutoDisplay := False;
    FDoPluginWithAnno := NULL;
    FDoCreateGrid := False;
    FSendingEmail := False;
    FFirstResize := False;
    PopupLinkList := TStringList.Create;
    PopupLinkList.Delimiter := ';';
    PopupLinkList.StrictDelimiter := True;
    PopupLinkList.DelimitedText := '';
    DocHistoryFirstItem := True;
    FShowIndexingWithLimit := False;
    BMResub := 0; //14.05.2018 Ticket 14130
    BMDelegateResub := 0; //14.05.2018 Ticket 14130
    ResubListLoaded := False; //14.05.2018 Ticket 14130
    SelectFirstHistoryNode := False; // 08.05.2019 Ticket 19057
    MViewThumbWidth := MINTHUMBWIDTH;
    MViewThumbHeight := MINTHUMBHEIGHT;
//18.12.2020 -->
    sCaptionOnlySearch := _('--- nur Suchen mglich ---');
    sColorBlack := _('Schwarz');
    sColorBrown := _('Braun');
    sColorGreen := _('Grn');
    sColorOlive := _('Olivgrn');
    sColorDarkblue := _('Dunkelblau');
    sColorPurple := _('Purpur');
    sColorGreenblue := _('Grnblau');
    sColorGray := _('Grau');
    sColorSilver := _('Silber');
    sColorRed := _('Rot');
    sColorLime := _('Limone');
    sColorYellow := _('Gelb');
    sColorBlue := _('Blau');
    sColorFuchsia := _('Fuchsie');
    sColorAquamarine := _('Aquamarin');
    sColorWhite := _('Wei');
    sColorDollargreen := _('Dollargrn');
    sColorLightblue := _('Himmelblau');
    sColorCream := _('Creme');
    sColorMediumgray := _('Mittelgrau');

    sCaptionNewPolyline := _('Neue PolyLinie');
    sCaptionNewEllipse := _('Neue Ellipse');
    sCaptionNewRectangle := _('Neues Rechteck');
    sCaptionNewMeasureline := _('Neue Messlinie');
//18.12.2020 <--

    LastView := tvkNone; //14.08.2017 ticket 10774

    FSid := '';

    FFormatSettings := TFormatSettings.Create(LOCALE_USER_DEFAULT);
    FFormatSettings.ShortDateFormat := StringReplace(FFormatSettings.ShortDateFormat, '/', FFormatSettings.DateSeparator, [rfReplaceAll]);

    if bitfarmLog = nil then //06.09.2017 Log in ViewerV36.dpr eingebaut
    begin
      FLog := TbfaLog.Create;
      FLogInitialized := FLog.Init(BD.EnvTempPd, '', llDebug, 'ViewerV36', BD.DevDebug);
      bitfarmLog := FLog;
    end
    else
    begin
      Flog := bitfarmLog;
      FLogInitialized := bitfarmLog.Initialized;
    end;

    FPluginIsRunning := False;
    FUser := TbfaUser.Create;
    FMainThread := TThreadPool.Create(MainThreadExecute, 1);
    FBackThread := TThreadPool.Create(BackThreadExecute, 1);
    MainThreadInExecute := False;

    FWorkplaceContainer := TList<TbfaDocument>.Create;
    FImportContainer := TList<TbfaDocument>.Create;
    FCurrentContainer := TList<TbfaDocument>.Create;
    FCollectionContainer := TList<TbfaDocument>.Create;
    FPreviewContainer := TbfaPreviewContainer.Create;

    FSearchObj := TbfaSearch.Create;
    FSearchProc := TbfaSearchProcessing.Create;
    {$IFNDEF DISABLE_HISTORY_FUTURE_DELETE} // SJ 14.07.2023 - bfacrm:ticket__show__35313
    FSearchProc.OnCheckHistoryNodes := CheckHistoryNodes;
    {$ENDIF}

    if not DirectoryExists(BD.EnvProgramDataPD + 'bitfarm-archiv\') then
    begin
      Flog.DebugBegin(llDebug, 'Create directory %ProgramData%\bitfarm-archiv', ClassName);
      try
        ForceDirectories(BD.EnvProgramDataPD + 'bitfarm-archiv\');
      finally
        Flog.DebugEnd(llDebug, 'Create directory %ProgramData%\bitfarm-archiv', ClassName);
      end;
    end;

    Flog.DebugBegin(llDebug, 'Create FViewerOptions', ClassName);
    try
      FViewerOptions := TbfaViewerOptions.Create(ostIniFile, BD.AppdataBitfarmPd + 'ViewerOptions.ini', ExtractFilePath(Application.ExeName) + 'ViewerOptions.ini', UseMatchAgainst);
    finally
      Flog.DebugEnd(llDebug, 'Create FViewerOptions', ClassName);
    end;

    if bitfarmLog.LogLevel <> FViewerOptions.AdminOptions.LogLevel then
      bitfarmLog.ChangeLogLevel(FViewerOptions.AdminOptions.LogLevel);

    FViewerLayout := '';
    FGlobalViewerLayout := '';

   if FileExists(BD.AppdataBitfarmPd + 'ViewerLayout.ini') then
      FViewerLayout := BD.AppdataBitfarmPd + 'ViewerLayout.ini';
    if FileExists(ExtractFilePath(Application.ExeName) + 'ViewerLayout.ini') then
      FGlobalViewerLayout := ExtractFilePath(Application.ExeName) + 'ViewerLayout.ini';

    CurrentFields := -1;
    CurrentViewerFields := -1;
    CurrentImporterFields := -1;
    CurrentResubFields := -1;
    aCurrentAddfields := TList<TbfaAddfield>.Create;
    aCurrentViewerAddfields := TList<TbfaAddfield>.Create;
    aCurrentImporterAddfields := TList<TbfaAddfield>.Create;
    aCurrentResubAddfields := TList<TbfaAddfield>.Create;

    aCurrentStatefields := TList<TbfaStatefield>.Create;
    aCurrentViewerStatefields := TList<TbfaStatefield>.Create;
    aCurrentImporterStatefields := TList<TbfaStatefield>.Create;
    aCurrentResubStatefields := TList<TbfaStatefield>.Create;

    UseIndexing := False;
    ViewerUseIndexing := False;
    ViewerShowIndexing := False;
    ImporterUseIndexing := False;
    ImporterShowIndexing := True;
    fDocumentSearch := False;

    SetLength(DocHistory, 0);
    SetLength(aStationeries, 0);
    DocHistoryIdx := 0;
    LastDocSearch := False;

//12.04.2022    Marked := FViewerOptions.SystemOptions.MarkedDocs;
//    DocArc.GdocID := -1;
//    DocArc.ArcID := -1;
//    Marked := MarkedDocsString;
//
//    if Marked = '' then
//    begin
//      MarkedDocs[1] := DocArc;
//      MarkedDocs[2] := DocArc;
//      MarkedDocs[3] := DocArc;
//      MarkedDocs[4] := DocArc;
//      MarkedDocs[5] := DocArc;
//    end
//    else
//    begin
//      sList := SplitString(Marked, ';');
//      for i := Low(sList) to High(sList) - 1 do
//      begin
//        sList2 := SplitString(sList[i], ',');
//        MarkedDocs[i + 1].gdocid := StrToInt64(sList2[0]);
//        MarkedDocs[i + 1].arcid := StrToInt64(sList2[1]);
//      end;
//    end;

    GEmailUser := TList<TbfaUser>.Create;
    GEmailGroups := TList<TbfaGroup>.Create;
    TimidList := TStringList.Create;
    TimidList.Delimiter := ';';
    TimidList.StrictDelimiter := True;

    Standardcols := TStringList.Create;
    Standardcols.Delimiter := ';';
    Standardcols.StrictDelimiter := True;

    StandardResubcols := TStringList.Create;
    StandardResubcols.Delimiter := ';';
    StandardResubcols.StrictDelimiter := True;

    frmQuickPreview := TfrmQuickPreview.Create(Application);
    regs := TStringList.Create;
    regs.Add('^(not )*(docstate_)(\d+)\s*&\s*(\d+)\s*([<=>]+)\s*(\d+)');
    regs.Add('^(not )*(\S+)\s*([<=>]+|like|rlike|is)\s*(.+)');
    regs.Add('^(not )*(\S+)\s*([<=>]+|like|rlike|is)\s*str_to_date\("(\d{2}.\d{2}.\d{4}|\d{4}.\d{2}.\d{2}).*?"\)');
    regs.Add('^(not )*(\S+)\s*([<=>]+|like|rlike|is)\s*(\d+)');
    regs.Add('^(not )*(\S+)\s*(between)\s*(.+\s*and\s*.+)');
    regs.Add('^(not )*MATCH \((\S+)\) (AGAINST) \((.+) IN BOOLEAN MODE\)');
    regs.Add('^(not )*(\S+)\s*(in)\s*((.+))');

    ReadRightsArcids := TStringList.Create;

    FloatingForms := TList.Create;
    FloatingForms.Add(frmMainForm);
    FloatingFormsIdx := 0;
    ShowInNewTab := True;
    DockSearchPanel := False;
    InCreateFloatingForm := False;
    InPanelClose := False;
    InDockChanged := False;
    ClosingMainForm := False;
    ShowDocumentInProcess := False;
//22.02.2022    ResubKind := rkNone;
    SetCW(Date);
    InitializeCriticalSection(FCreateGrid_CS);
    InitializeCriticalSection(FClearContainer_CS);

    // SJ 16.12.2021 - bfacrm:ticket__show__28243
    var inifile: TIniFile;
    if FileExists(BD.EnvAppdataPd + 'bitfarm-archiv\Viewer.ini') then
    begin
      inifile := TIniFile.Create(BD.EnvAppdataPd + 'bitfarm-archiv\Viewer.ini');
      if inifile.SectionExists('General') and inifile.ValueExists('General', sSysLanguage) then
        Lang := inifile.ReadString('General', sSysLanguage, '')
      else
        Lang := GetCurrentLanguage;
    end
    else
      Lang := GetCurrentLanguage;
    // SJ 16.12.2021 - bfacrm:ticket__show__28243
    bitfarmLog.Write(llDebug, ltInfo, 'Lang: ' + Lang, ClassName);

    if (Lang = '') or (Lang = '1031') then
      Lang := 'de'
    else
      Lang := Copy(Lang, 0, 2);

    bitfarmLog.Write(llDebug, ltInfo, 'Lang: ' + Lang, ClassName);
    InitNativeLanguageNames;
    SelectFirstHistoryNode := True;  // nach Start des Viewers landet der erste Klick auf den Zurckbutton auf dem ersten Verlaufslesezeichen

//14.04.2021 b.takacs Ticket 26789 -->
    FontDlg := TFontDialog.Create(nil);
    ColorDlg := TColorDialog.Create(nil);
//14.04.2021 b.takacs Ticket 26789 <--

//    web := TWebBrowser.Create(nil);
//
//    if not Assigned(web.Document) then
//      web.Navigate('about:blank');

    LastAnnoDefaultWidth := -1;
    LastAnnoDefaultHeight := -1;
  except
    on E: Exception do
    bitfarmLog.Write(llDebug, ltException, 'TbfaApplication.Create: ' + E.Message, ClassName);
  end;
end;

procedure TbfaApplication.FillMarkedDocs;
var
  DocArc: TDocArc;
  Marked: string;
  sList, sList2: TStringDynArray;
  i: Integer;
begin
  try
    DocArc.GdocID := -1;
    DocArc.ArcID := -1;

    Marked := MarkedDocsString;

    if Marked = '' then
    begin
      MarkedDocs[1] := DocArc;
      MarkedDocs[2] := DocArc;
      MarkedDocs[3] := DocArc;
      MarkedDocs[4] := DocArc;
      MarkedDocs[5] := DocArc;
    end
    else
    begin
      sList := SplitString(Marked, ';');
      for i := Low(sList) to High(sList) - 1 do
      begin
        sList2 := SplitString(sList[i], ',');
        MarkedDocs[i + 1].gdocid := StrToInt64(sList2[0]);
        MarkedDocs[i + 1].arcid := StrToInt64(sList2[1]);
      end;
    end;

  except
  end;
end;

procedure TbfaApplication.InitNativeLanguageNames;
var
  sFileLaguageCodes: string;
begin
  try
    LanguageNativeNames := TStringList.Create;
    sFileLaguageCodes := BD.ExeDir + 'locale\LanguageCodes.txt';
    if FileExists(sFileLaguageCodes) then
      LanguageNativeNames.LoadFromFile(sFileLaguageCodes, TEncoding.UTF8); // Falls Datei nicht UTF8-BOM codiert
  except on E: Exception do
    begin
      bitfarmLog.Write(llDebug, ltDebug, 'sFileLaguageCodes: ' + sFileLaguageCodes, ClassName);
      bitfarmLog.Write(llDebug, ltException, 'InitNativeLanguageNames: ' + E.Message, ClassName);
    end;
  end;
end;

function TbfaApplication.GetLangNativeName(LanguageCode: string): string;
var
  i: integer;
  s: string;
begin
  for i := 0 to LanguageNativeNames.Count - 1 do
  begin
    s := LanguageNativeNames.Strings[i];
    if Pos(LanguageCode, s) = 1 then
      result := copy(s, 4, length(s) - 3);
  end;
end;

function TbfaApplication.GetLangNativeNameById(Id: integer): string;
var
//09.07.2024  i: integer;
  s: string;
begin
  if Id < LanguageNativeNames.Count then
  begin
//09.07.2024    s := LanguageNativeNames.Strings[i];
    s := LanguageNativeNames.Strings[id];
    result := copy(s, 1, pos(';', s) - 1);
  end;
end;

function TbfaApplication.GetIdNativeName(LanguageCode: string): Integer;
var
  i: integer;
  s: string;
begin
  result := -1;
  for i := 0 to LanguageNativeNames.Count - 1 do
  begin
    s := LanguageNativeNames.Strings[i];
    if Pos(LanguageCode, s) = 1 then
    begin
      result := i;
    end;
  end;
end;

procedure TbfaApplication.CreateAddfields(arcids: TStringList; AThread: TThread; intersection: Boolean = False);
var
  i, k, icount, edtTabOrder, lastpos, lastpos2: Integer;
  addfieldcomp: TBfaAddfieldComp;
  aTempfields: TList<TbfaAddfield>;
  addid: Integer;
  qry: TUniQuery;
  orderby, caption: string;
  loadcurrentfields: Boolean;
  Addfield: TbfaAddField;
  found: Boolean;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateAddfields', ClassName);
  try
    AddFieldsCreating := True;
    try
      try
        // wir sind auf dem Hauptpanel und haben die Addfields schon im Array
        aTempfields := TList<TbfaAddfield>.Create;
        loadcurrentfields := False;
        if (FPreviewContainer.ActiveItem = FPreviewContainer.ImporterItem.Panel.Tag) then
          UseIndexing := ImporterUseIndexing
        else
          UseIndexing := ViewerUseIndexing;

        if UseIndexing then
        begin
          frmMainForm.btnIndexing.Caption := _('Suchen');
          frmMainForm.mnuIndexing.Action := frmMainForm.actHideIndexing;
        end
        else
        begin
          frmMainForm.btnIndexing.Caption := _('Verschlagwortungshilfe');
          frmMainForm.mnuIndexing.Action := frmMainForm.actShowIndexing;
        end;

        edtTabOrder := 0;
        i := 0;
        for k := 0 to arcids.Count - 1 do
        begin
          aTempfields.Clear;
          if (((FPreviewContainer.ActiveItem = FPreviewContainer.ViewerItem.Panel.Tag) and (CurrentView = tvkViewer) and
               (StrToInt(arcids[k]) = CurrentViewerFields) and (aCurrentViewerAddfields.Count > 0)) or
              ((FPreviewContainer.ActiveItem = FPreviewContainer.ViewerItem.Panel.Tag) and (CurrentView = tvkFavorites) and
               (StrToInt(arcids[k]) = CurrentViewerFields) and (aCurrentViewerAddfields.Count > 0)) or
              ((FPreviewContainer.ActiveItem = FPreviewContainer.ViewerItem.Panel.Tag) and (CurrentView = tvkResub) and
               (StrToInt(arcids[k]) = CurrentResubFields) and (aCurrentResubAddfields.Count > 0)) or
              ((FPreviewContainer.ActiveItem = FPreviewContainer.ImporterItem.Panel.Tag) and (CurrentView = tvkImporter) and
               (StrToInt(arcids[k]) = CurrentImporterFields) and (aCurrentImporterAddfields.Count > 0)) or
              ((FPreviewContainer.ActiveItem = FPreviewContainer.WorkplaceItem.Panel.Tag) and (CurrentView = tvkWorkplace)))
          then begin
            loadcurrentfields := True;
            if (CurrentView = tvkViewer) or (CurrentView = tvkFavorites) then
              aTempfields := aCurrentViewerAddfields
            else if CurrentView = tvkImporter then
              aTempfields := aCurrentImporterAddfields
            else if CurrentView = tvkResub then
              aTempfields := aCurrentResubAddfields;
          end else // if (FPreviewContainer.ActiveItem > 5) then   // wenn wir ein Dokument im Extratab haben, nehmen wir auch seine Felder
          begin
            if (FCurrentContainer.Count > 0) and (FCurrentContainer[0].Id = -1) then   // es sei denn, wir sind ein importerdokument
            begin
              loadcurrentfields := (StrToInt(arcids[0]) = CurrentImporterFields) and (aCurrentImporterAddfields.Count > 0); // bei Archivwechsel neu laden
              aTempfields := aCurrentImporterAddfields
            end;
          end;

          if loadcurrentfields then
          begin
            AThread.Synchronize(nil,
              procedure
              var
                j, k: Integer;
              begin
                frmMainForm.scrbxViewerAddfields.AutoScroll := False;
                if frmMainForm.tcSearch.Items[2].Visible then
                  frmMainForm.scrbxAddfields2.AutoScroll := False;
                for j := 0 to aTempfields.Count - 1 do
                begin
                  if aTempfields[j] = nil then
                    Continue;

                  found := False;
                  for k := 0 to aCurrentAddfields.Count - 1 do
                  begin
                    if aTempfields[j] = aCurrentAddfields[k] then
                    begin
                      found := True;
                      Break;
                    end;
                  end;

                  if found then
                    continue;

                  addid := aTempfields[j].Id;
                  if aTempfields[j].Component = nil then
                  begin
                    if (aTempfields[j].Options and 16) = 16 then
                    begin
//                      frmMainForm.tabAddfields2.Visible := True;
                      addfieldcomp := DoCreateAddfieldComp(frmMainForm.scrbxAddfields2,
                        addid, j, UseIndexing, lastpos2, (arcids.Count > 1));
                    end else
                    addfieldcomp := DoCreateAddfieldComp(frmMainForm.scrbxViewerAddfields,
                      addid, j, UseIndexing, lastpos, (arcids.Count > 1))
                  end else
                    addfieldcomp := aTempfields[j].Component;

                  if addfieldcomp = nil then
                    Continue;
                  addfieldcomp.TabOrder := edtTabOrder;
                  inc(edtTabOrder);

                  Addfield := TbfaAddField.Create;
                  Addfield.Clone(aTempfields[j]);
                  //aCurrentAddfields[j] := aTempfields[j];
                  if addfieldcomp <> nil then
                  begin
                    //TODO: muss hier die alte Componente gefreet werden?
                    Addfield.Component := addfieldcomp;
                    Addfield.Component.Modified := aTempfields[j].modified;
                    Addfield.Component.OnValueSet := Addfield.SetValue;

                    if CurrentView = TbfaViewKind(tvkImporter) then
                      Addfield.Component.Editmode := True;

                    if Addfield.OldValue <> Null then
                      Addfield.Component.OldValue := Addfield.OldValue
                    else
                      Addfield.Component.OldValue := '';
                    if Addfield.Value <> Null then
                      Addfield.Component.Value := Addfield.Value
                    else
                      Addfield.Component.Value := '';
                    if Addfield.ValueHigh <> Null then
                      Addfield.Component.ValueHigh := Addfield.ValueHigh
                    else
                      Addfield.Component.ValueHigh := '';
                  end;

                  if (arcids.Count > 1) then    // wenn wir mehrere Archive abfragen
                  begin                         // und in Rights ist ein READ bedeutet dass das fr dieses Feld
                    if (aAddfieldRights[addid] and 1) = 1 then   // irgendwo nur READ-Rechte gesetzt wurde (in einem der Archive)
                      Addfield.Rights := 1                       // daher setzen wir dieses Feld auch nur auf READ
                        else
                      Addfield.Rights := aAddfieldRights[addid];
                  end else
                    Addfield.Rights := aAddfieldRights[addid];

                  if (CurrentView = tvkImporter) and FIgnoreRightsAtImport then
                  begin
                    Addfield.Rights := rFieldModify;   // sollen im Importer die Rechte Ignoriert werden, dann auf modify setzen
                    if Addfield.Component <> nil then
                      Addfield.Component.Rights := rFieldModify;
                  end;

                  aCurrentAddfields.Add(Addfield);
                end;

                if frmMainForm.tcSearch.Items[2].Visible then
                begin
                  frmMainForm.scrbxAddfields2.AutoScroll := True;
                  frmMainForm.scrbxAddfields2.AfterScrollVert := frmMainForm.AfterScrollVert;
                  frmMainForm.scrbxAddfields2.AfterScrollHorz := frmMainForm.AfterScrollHorz;
                  frmMainForm.scrbxAddfields2.Show;
                end;

                frmMainForm.scrbxViewerAddfields.AutoScroll := True;
                frmMainForm.scrbxViewerAddfields.AfterScrollVert := frmMainForm.AfterScrollVert;
                frmMainForm.scrbxViewerAddfields.AfterScrollHorz := frmMainForm.AfterScrollHorz;
                frmMainForm.scrbxViewerAddfields.Show;
              end);

          end else   // ansonsten neu laden
          begin
            if OrderFieldsByName then
              orderby := ' order by displayname'
            else
              orderby := ' order by pos, displayname';

            qry := TUniQuery.Create(nil);
            qry.Connection := dmMain.cntMain;
            // alte abfrage, die noch von einem basiseintrag (userid=0 and groupid=0) ausging
            // diese basiseintrge, die vom Rechte-Konzept der 35 stammen, werden jetzt mit der abfrage groupid in user.grouplist gefunden
            // da der user in der regel mitglied der gruppe Alle(builtin) ist
            qry.SQL.Text := 'SELECT distinct(sys_addfieldxs.fieldid), pos, displayname FROM sys_addfieldxs ' + 'left join sys_addfields on sys_addfieldxs.fieldid = sys_addfields.addfieldid ' + 'where arcid in (' + arcids[k] + ') ' + 'and (userid in (' + User.HolidayList.CommaText + ') ' + 'or (userid = 0 and groupid in (' + User.GroupList.CommaText + '))) and ((sys_addfields.flags & 2) = 0)' + orderby;

            bitfarmLog.Write(llDebug, ltInfo, 'CreateAddfields - qry.SQL.Text := ' + qry.SQL.Text, ClassName);

            qry.Execute;
            if qry.RecordCount > 0 then
            begin
              AThread.Synchronize(nil,
                procedure
                begin
                  if frmMainForm.tcSearch.Items[2].Visible then
                  begin
                    frmMainForm.scrbxAddfields2.AutoScroll := False;
                    frmMainForm.scrbxAddfields2.Show;
                    frmMainForm.scrbxAddfields2.Hide;
                  end;

                  frmMainForm.scrbxViewerAddfields.AutoScroll := False;
                  frmMainForm.scrbxViewerAddfields.Show;  //25.11.2020 beim Start ist sonst falsch dargestellt -->
                  frmMainForm.scrbxViewerAddfields.Hide;

                  qry.First;

                  while not qry.Eof do
                  begin
                    addid := qry.FieldByName('fieldid').AsInteger;
                    if (aAddfields[addid].Options and 16) = 16 then
                    begin
                      if not frmMainForm.tabAddfields2.Visible then
                      begin
                        frmMainForm.scrbxAddfields2.AutoScroll := False;
                        frmMainForm.scrbxAddfields2.Show;
                        frmMainForm.scrbxAddfields2.Hide;
                      end;

//                      frmMainForm.tabAddfields2.Visible := True;
                      addfieldcomp := DoCreateAddfieldComp(frmMainForm.scrbxAddfields2,
                        addid, i, UseIndexing, lastpos2, (arcids.Count > 1));
                    end else
                      addfieldcomp := DoCreateAddfieldComp(frmMainForm.scrbxViewerAddfields,
                        addid, i, UseIndexing, lastpos, (arcids.Count > 1));

                    if addfieldcomp = nil then
                    begin
                      qry.Next;
                      Continue;
                    end;

                    addfieldcomp.TabOrder := edtTabOrder;
                    inc(edtTabOrder);
                    Addfield := TbfaAddField.Create;
                    Addfield.Clone(aAddfields[addid]);
                    if addfieldcomp <> nil then
                    begin
                      Addfield.Component := addfieldcomp;
//27.04.2018 Ticket 13251 -->
                      if CurrentView = TbfaViewKind(tvkImporter) then
                        Addfield.Component.Editmode := True;
//27.04.2018 Ticket 13251 <--
                      Addfield.Component.OnValueSet := Addfield.SetValue;
                    end;

                    if (arcids.Count > 1) then    // wenn wir mehrere Archive abfragen
                    begin                         // und in Rights ist ein READ bedeutet dass das fr dieses Feld
                      if (aAddfieldRights[addid] and 1) = 1 then   // irgendwo nur READ-Rechte gesetzt wurde (in einem der Archive)
                        Addfield.Rights := 1                       // daher setzen wir dieses Feld auch nur auf READ
                      else
                        Addfield.Rights := aAddfieldRights[addid];
                    end else
                      Addfield.Rights := aAddfieldRights[addid];

                    if (CurrentView = tvkImporter) and FIgnoreRightsAtImport then
                    begin
                      Addfield.Rights := rFieldModify;   // sollen im Importer die Rechte Ignoriert werden, dann auf modify setzen
                      if Addfield.Component <> nil then
                        Addfield.Component.Rights := rFieldModify;
                    end;

                    Addfield.Assigned := True;
                    aCurrentAddfields.Add(Addfield);
                    inc(i);
                    qry.Next;
                  end;

                  if frmMainForm.tcSearch.Items[2].Visible then
                  begin
                    frmMainForm.scrbxAddfields2.AutoScroll := True;
                    frmMainForm.scrbxAddfields2.AfterScrollVert := frmMainForm.AfterScrollVert;
                    frmMainForm.scrbxAddfields2.AfterScrollHorz := frmMainForm.AfterScrollHorz;
                    frmMainForm.scrbxAddfields2.Show;
                  end;

                  frmMainForm.scrbxViewerAddfields.AutoScroll := True;
                  frmMainForm.scrbxViewerAddfields.AfterScrollVert := frmMainForm.AfterScrollVert;
                  frmMainForm.scrbxViewerAddfields.AfterScrollHorz := frmMainForm.AfterScrollHorz;
                  frmMainForm.scrbxViewerAddfields.Show;

                end);

                // wenn wir auch auf dem Viewer, Resub oder Importtab stehen, dann setzen wir die Arrays neu
                // Im Workplace setzen wir nichts bzw ViewerAddfields

              if (FPreviewContainer.ActiveItem = FPreviewContainer.ViewerItem.Panel.Tag) and (CurrentView = tvkViewer) then
              begin
                aCurrentViewerAddfields := aCurrentAddfields;
              end
              else if (FPreviewContainer.ActiveItem = FPreviewContainer.ViewerItem.Panel.Tag) and (CurrentView = tvkResub) then
              begin
                aCurrentResubAddfields := aCurrentAddfields;
              end
              else if (FPreviewContainer.ActiveItem = FPreviewContainer.ImporterItem.Panel.Tag) and (CurrentView = tvkImporter) then
              begin
                aCurrentImporterAddfields := aCurrentAddfields
              end
              else if not (FPreviewContainer.ActiveItem in [0, 1, 3]) then
                if (FCurrentContainer.Count > 0) and
                   (FCurrentContainer[0].arcid <> StrToInt(arcids[0])) then
                    for i := 0 to aCurrentAddfields.Count - 1 do
                    begin
                      Addfield := TbfaAddField.Create;
                      Addfield.Clone(aCurrentAddfields[i]);
                      FCurrentContainer[0].Addfields.Add(Addfield);
                    end;

            end;
          end;
        end;

        frmMainForm.btnIndexing.TabOrder := edtTabOrder;
        inc(edtTabOrder);
        frmMainForm.btnIndexingReset.TabOrder := edtTabOrder;

        AThread.Synchronize(nil,
          procedure
          begin
            if frmMainForm.scrbxAddfields2.ComponentCount >= 1 then       // haben wir Komponenten auf dem zweiten Tab
            begin
              // ist das erste Feld ein Gridfeld, dann prfen wir ob displayname gesetzt ist
              if TbfaAddfieldComp(frmMainForm.scrbxAddfields2.Components[0]).AddfieldType = zfld13_Grid then
              begin
                if TbfaAddfieldComp(frmMainForm.scrbxAddfields2.Components[0]).compGrid.Config.Displayname <> '' then
                begin
                  caption := TbfaAddfieldComp(frmMainForm.scrbxAddfields2.Components[0]).compGrid.Config.Displayname
                end else
                begin
                  caption := TbfaAddfieldComp(frmMainForm.scrbxAddfields2.Components[0]).Label1.Caption;
                  caption := LeftStr(caption, length(caption) -1);
                end;
              end else   // ansonsten die Caption des ersten Zusatzfeldes
              begin
                caption := TbfaAddfieldComp(frmMainForm.scrbxAddfields2.Components[0]).Label1.Caption;
                caption := LeftStr(caption, length(caption) -1);
              end;
              frmMainForm.tabSearchAddfields2.Caption := caption;

            end;
            if (frmMainForm.scrbxAddfields2.ComponentCount = 0) and (frmMainForm.tcSearch.ActiveTabIndex = 2) then
              frmMainForm.tcSearch.ActivePage := frmMainForm.tabAddfields;

            frmMainForm.tabSearchAddfields2.Visible := frmMainForm.scrbxAddfields2.ComponentCount > 0;
            frmMainForm.scrbxAddfields2.Visible := frmMainForm.scrbxAddfields2.ComponentCount > 0;
            frmMainForm.scrbxAddfields2.AutoScroll := frmMainForm.scrbxAddfields2.ComponentCount > 0;

          end);

      finally
        FreeAndNil(qry);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'CreateAddfields', ClassName);
    end;
  finally
    AddFieldsCreating := False;
    bitfarmLog.DebugEnd(llDebug, 'CreateAddfields', ClassName);
  end;
end;

function TbfaApplication.DoCreateAddfieldComp(AOwner: TComponent; addid, position: Integer;
  Idx: Boolean; var lastposition: Integer; multiarcs: Boolean = False;
  posoffset: Integer = 0) : TBfaAddfieldComp;
var
  addfieldcomp: TBfaAddfieldComp;
  lmq, lmq2: TUniQuery;
  add, str: string;
//  addtype: Integer;
  MsCombo: TStringStream;
  sl, slvalues: TStringList;
  i, j, fieldid, idxid: Integer;
  iTop: integer;
  AConfig: TbfaGridConfig;
  xmlnode : IXMLDocument;
  gridcolumn: TcxGridColumn;
  tmpdataset : TDataSet;
  tmpdatasource: TDataSource;
  inifile: TMemIniFile;
begin
  Result := nil;
  if addid > High(aAddfields) then
    Exit;

  bitfarmLog.DebugBegin(llDebug, 'DoCreateAddfieldComp', ClassName);
  try
    try
      case aAddfields[addid].Typ of
        0:
          begin
            addfieldcomp := TBfaAddfieldComp.Create(AOwner, zfld00_Universal, '',
              Idx, bfaIcons.ilPreview16);
            addfieldcomp.compEdit.OnKeyDown := AddFieldKeyDown;
            addfieldcomp.compEdit.PopupMenu := frmMainForm.popAddFields;
          end;
        1, 12:
          begin
            if aAddfields[addid].Typ = 1 then
              addfieldcomp := TBfaAddfieldComp.Create(AOwner, zfld01_Datum, '',
                Idx, bfaIcons.ilPreview16)
            else
              addfieldcomp := TBfaAddfieldComp.Create(AOwner, zfld12_DLMDate, '',
                Idx, bfaIcons.ilPreview16);
            TcxDateEdit(addfieldcomp.compDateLow).OnKeyDown := AddFieldKeyDown;
            TcxDateEdit(addfieldcomp.compDateHigh).OnKeyDown := AddFieldKeyDown;
            addfieldcomp.compDateLow.PopupMenu := frmMainForm.popAddFields;
            addfieldcomp.compDateHigh.PopupMenu := frmMainForm.popAddFields;
            addfieldcomp.OnComboDropDown := frmMainForm.OnComboDropDown;
            addfieldcomp.OnComboCloseUp := frmMainForm.OnComboCloseUp;
            addfieldcomp.OnComboDropDown := frmMainForm.OnComboDropDown;
            addfieldcomp.OnComboCloseUp := frmMainForm.OnComboCloseUp;
            addfieldcomp.OnModified := OnModifiedDateField;
          end;
        2, 11:
          begin
            if aAddfields[addid].Typ = 2 then
              addfieldcomp := TBfaAddfieldComp.Create(AOwner, zfld02_Auswahl, '',
                Idx, bfaIcons.ilPreview16)
            else
              addfieldcomp := TBfaAddfieldComp.Create(AOwner, zfld11_DLM, '',
                Idx, bfaIcons.ilPreview16);
            addfieldcomp.compComboBox.AutoComplete := not bitfarmApp.ViewerOptions.GeneralOptions.ComboAutoDown; //06.04.2018
            addfieldcomp.compComboBox.OnKeyDown := AddFieldKeyDown;
            addfieldcomp.compComboBox.PopupMenu := frmMainForm.popAddFields;
            addfieldcomp.compComboBox.Properties.OnPopup := frmMainForm.OnComboDropDown;
            addfieldcomp.compComboBox.Properties.OnCloseUp := frmMainForm.OnComboCloseUp;
          end;
        3:
          begin
            addfieldcomp := TBfaAddfieldComp.Create(AOwner, zfld03_MehrfachAuswahl, '',
              Idx, bfaIcons.ilPreview16);
            addfieldcomp.compCheckedCombo.OnKeyDown := AddFieldKeyDown;
            addfieldcomp.OnComboClick := frmMainForm.OnCheckListClick;
            addfieldcomp.compCheckedCombo.PopupMenu := frmMainForm.popAddFields;
            addfieldcomp.lstCheckedListbox.OnDropDown := frmMainForm.OnComboDropDown;
            addfieldcomp.lstCheckedListbox.OnCloseUp := frmMainForm.OnComboCloseUp;
            addfieldcomp.lstCheckedListbox.OnExit := frmMainForm.OnComboCloseUp;  //13.03.2018 Ticket 10307
            addfieldcomp.compCheckedCombo.OnResizeHeight := DoResizeAddfields;
            addfieldcomp.OnReturnSearch := ExecuteSearch;
          end;
        4:
          Exit;
        5:
          begin
            addfieldcomp := TBfaAddfieldComp.Create(AOwner, zfld05_Intervall, '',
              Idx, bfaIcons.ilPreview16);
            addfieldcomp.compSpinEditLow.OnKeyDown := AddFieldKeyDown;
            addfieldcomp.compComboBox.OnKeyDown := AddFieldKeyDown;
//29.07.2022 Ticket 23737            addfieldcomp.compComboBox.Properties.Items.DelimitedText := _('Tag,Woche,Monat,Jahr');
            addfieldcomp.compComboBox.Properties.Items.DelimitedText := _('Tag(e),Woche(n),Monat(e),Jahr(e)');
            addfieldcomp.OnModified := OnModifiedSpinEdit;
            addfieldcomp.compComboBox.Properties.OnPopup := frmMainForm.OnComboDropDown;
            addfieldcomp.compComboBox.Properties.OnCloseUp := frmMainForm.OnComboCloseUp;
            addfieldcomp.compSpinEditLow.PopupMenu := frmMainForm.popAddFields;
          end;
        6:
          begin
            addfieldcomp := TBfaAddfieldComp.Create(AOwner, zfld06_GanzZahl, '',
              Idx, bfaIcons.ilPreview16);
            addfieldcomp.compSpinEditLow.OnKeyDown := AddFieldKeyDown;
            addfieldcomp.compSpinEditHigh.OnKeyDown := AddFieldKeyDown;
            addfieldcomp.compSpinEditLow.PopupMenu := frmMainForm.popAddFields;
            addfieldcomp.compSpinEditHigh.PopupMenu := frmMainForm.popAddFields;
            addfieldcomp.OnModified := OnModifiedSpinEdit;
          end;
        7:
          begin
            addfieldcomp := TBfaAddfieldComp.Create(AOwner, zfld07_FliessKomma, '',
              Idx, bfaIcons.ilPreview16);
            addfieldcomp.compSpinEditLow.OnKeyDown := AddFieldKeyDown;
            addfieldcomp.compSpinEditHigh.OnKeyDown := AddFieldKeyDown;
            addfieldcomp.compSpinEditLow.PopupMenu := frmMainForm.popAddFields;
            addfieldcomp.compSpinEditHigh.PopupMenu := frmMainForm.popAddFields;
            addfieldcomp.OnModified := OnModifiedSpinEdit;
          end;
        8:
          begin
            addfieldcomp := TBfaAddfieldComp.Create(AOwner, zfld08_Waehrung, '',
              Idx, bfaIcons.ilPreview16);
            addfieldcomp.compSpinEditLow.OnKeyDown := AddFieldKeyDown;
            addfieldcomp.compSpinEditHigh.OnKeyDown := AddFieldKeyDown;
            addfieldcomp.compSpinEditLow.PopupMenu := frmMainForm.popAddFields;
            addfieldcomp.compSpinEditHigh.PopupMenu := frmMainForm.popAddFields;
            addfieldcomp.OnModified := OnModifiedSpinEdit;
            addfieldcomp.compSpinEditLow.NegativeCurrencyRed := bitfarmApp.ViewerOptions.GeneralOptions.NegativeCurrency;
          end;
        13:
          begin
            addfieldcomp := TBfaAddfieldComp.Create(AOwner, zfld13_Grid, '',
              Idx, bfaIcons.ilPreview16);
            addfieldcomp.edtGridSearch.OnKeyDown := AddFieldKeyDown;
            addfieldcomp.edtGridSearch.OnKeyDown := AddFieldKeyDown;
            addfieldcomp.edtGridSearch.PopupMenu := frmMainForm.popAddFields;
            addfieldcomp.edtGridSearch.PopupMenu := frmMainForm.popAddFields;
            addfieldcomp.OnGridExportClick := OnGridExport;
            addfieldcomp.OnGridStampClick := OnGridStamp;
            addfieldcomp.compGrid.OnGridComboDropDown := frmMainForm.OnComboDropDown;
            addfieldcomp.compGrid.OnGridComboCloseup :=  frmMainForm.OnComboCloseUp;
            addfieldcomp.cbxGridSearchField.Properties.OnPopup := frmMainForm.OnComboDropDown;
            addfieldcomp.cbxGridSearchField.Properties.OnCloseUp := frmMainForm.OnComboCloseUp;
            addfieldcomp.compGrid.NegativeCurrencyRed := bitfarmApp.ViewerOptions.GeneralOptions.NegativeCurrency;

            addfieldcomp.compGrid.View.Styles.Header := stlColumn;
            addfieldcomp.compGrid.View.Styles.Footer := stlColumn;
            addfieldcomp.compGrid.View.Styles.Content := stlColumn;
            addfieldcomp.compGrid.View.Styles.GroupByBox := stlGroupByBoxStyle;
            addfieldcomp.compGrid.View.Styles.Navigator := stlGroupByBoxStyle;
            addfieldcomp.compGrid.View.Styles.NavigatorInfoPanel := stlGroupByBoxStyle;
            addfieldcomp.compGrid.View.Styles.Background := stlBackgroundStyle;
            addfieldcomp.compGrid.View.Styles.Group := stlBackgroundStyle;
            addfieldcomp.compGrid.StyleFree := stlFree;
            addfieldcomp.compGrid.StyleSelected := stlSelected;
            addfieldcomp.compGrid.OnResizeHeight := DoResizeAddfields;
            if aAddfields[addid].ValuesQuery <> '' then
            begin
              CoInitialize(nil);
              xmlnode := TXMLDocument.Create(nil);
              try
                xmlnode.LoadFromXML(aAddfields[addid].ValuesQuery);
                AConfig := XMLToGridConfig(xmlnode.DocumentElement);
              finally
                CoUninitialize;
              end;
              if AConfig <> nil then
              begin
                AConfig.AlternateRows := ViewerOptions.GeneralOptions.RowColorEvenOdd;
                addfieldcomp.compGrid.LoadConfig(AConfig);
                addfieldcomp.LoadGridSearchField;
              end;
            end;
            addfieldcomp.Editmode := False;

            if FileExists(BD.AppdataBitfarmPd + 'Gridsortings.ini') then
            begin
                inifile := TMemIniFile.Create(BD.AppdataBitfarmPd + 'Gridsortings.ini');

                if inifile.SectionExists(IntToStr(FUser.ID)) then
                begin
                  if inifile.ValueExists(IntToStr(FUser.ID), IntToStr(addid)) then
                  begin
                    var sortcols : TStringList;
                    var colname, colwidth: WideString;

                    sortcols := TStringList.Create;
                    sortcols.Delimiter := ';';
                    sortcols.StrictDelimiter := True;
                    sortcols.QuoteChar := #0;
                    sortcols.DelimitedText := inifile.ReadString(IntToStr(FUser.ID), IntToStr(addid), '');

                    for i := 0 to sortcols.Count -1 do
                    begin
                      colname := Strip(SplitLeft(sortcols[i], ','));
                      colwidth := SplitRight(sortcols[i], ',');

                      for j := 0 to addfieldcomp.compGrid.View.ColumnCount -1 do
                      begin
                        if addfieldcomp.compGrid.View.Columns[j].Caption = colname then
                        begin
                          addfieldcomp.compGrid.View.Columns[j].Width := StrToInt(colwidth);
                          addfieldcomp.compGrid.View.Columns[j].Index := i;
                        end;
                      end;
                    end;
                  end;
                end;
            end;
          end;
      end;

      if addfieldcomp = nil then
        Exit;
      MsCombo := TStringStream.Create;
      sl := TStringList.Create;
      sl.Delimiter := ';';
      sl.StrictDelimiter := True;
      try
        if aAddfields[addid].Typ in [2, 11] then
        begin
          addfieldcomp.compComboBox.Properties.Items.BeginUpdate; //19.01.2018
          addfieldcomp.Strings.BeginUpdate;
          addfieldcomp.Comboitems.BeginUpdate;
        end
        else if aAddfields[addid].Typ = 3 then
        begin
          addfieldcomp.lstCheckedListbox.Items.BeginUpdate; //19.01.2018
          addfieldcomp.Strings.BeginUpdate;
          addfieldcomp.Comboitems.BeginUpdate;
        end  else if aAddfields[addid].Typ = 13 then
        begin

//          addfieldcomp.Strings.BeginUpdate;
//          addfieldcomp.Comboitems.BeginUpdate;
        end;

        addfieldcomp.Parent := TWinControl(AOwner);
        addfieldcomp.Options := aAddfields[addid].options;  //erst options setzen wegen der Farbe bei Pflichtfeldern
                                                       // dann rights wegen nur-lesen Felder
        // SJ 09.10.2020 wegen bfacrm:ticket__show__24572 Dispname nach Options
        addfieldcomp.Dispname := aAddfields[addid].Displayname;
        // SJ 09.10.2020
        addfieldcomp.FieldID := addid;
        addfieldcomp.IndexTableID := aAddfields[addid].IndexTableID;
        addfieldcomp.Fieldname := aAddfields[addid].Name;
        addfieldcomp.AddfieldType := eAddFieldType(aAddfields[addid].Typ);
        addfieldcomp.cbxIndexing.Properties.OnPopup := frmMainForm.OnComboDropDown;
        addfieldcomp.cbxIndexing.Properties.OnCloseUp := frmMainForm.OnComboCloseUp;

        if multiarcs then  // wenn wir mehrere Archive abfragen
        begin                     // und in Rights ist ein READ bedeutet dass das fr dieses Feld
          if (aAddfieldRights[addid] and 1) = 1 then   // irgendwo nur READ-Rechte gesetzt wurde (in einem der Archive)
            addfieldcomp.Rights := 1                            // daher setzen wir dieses Feld auch nur auf READ
          else
            addfieldcomp.Rights := aAddfieldRights[addid];
        end
        else
          addfieldcomp.Rights := aAddfieldRights[addid];

        if aAddfields[addid].Typ in [2, 3, 11] then
        begin
          if (aAddfields[addid].options and cAddfieldOptStrict = 0) then    // non strict? aktuelle items holen
          begin
            lmq := DbCreateQuery;
            try
              bitfarmLog.Write(llDebug, ltInfo, 'NonStrict Aktuelle Items holen', Classname);

              lmq.SQL.Text := Format('select items from sys_addfields where addfieldid = %d', [addid]);
              bitfarmLog.Write(llDebug, ltInfo, 'lmq.SQL.Text: ' + lmq.SQL.Text, Classname);
              lmq.Execute;
              bitfarmLog.Write(llDebug, ltInfo, 'lmq.SQL.Text executed ', Classname);
              if lmq.RecordCount > 0 then
              begin
                if lmq.FieldByName('items').AsString <> '' then
                begin
                  aAddfields[addid].Items := TStringList.Create;
                  aAddfields[addid].Items.Delimiter := ';';
                  aAddfields[addid].Items.CaseSensitive := True;
                  aAddfields[addid].Items.Duplicates := dupIgnore;
                  aAddfields[addid].Items.StrictDelimiter := True;
                  aAddfields[addid].Items.Options := aAddfields[addid].Items.Options - [soWriteBOM]; // bfacrm:ticket__show__33355
                  if aAddfields[addid].Typ = 3 then
                    str := '""""""' + ';' + lmq.FieldByName('items').AsString
                  else
                    str := lmq.FieldByName('items').AsString;

                  aAddfields[addid].Items.DelimitedText := str;
                  bitfarmLog.Write(llDebug, ltInfo, 'NonStrict Aktuelle Items', Classname);
                  aAddfields[addid].Items.SaveToStream(MsCombo, TEncoding.UTF8);
                  bitfarmLog.Write(llDebug, ltInfo, 'NonStrict Aktuelle Items added', Classname);
                end;
              end;
            finally
              lmq.Free;
            end;
          end else
          begin
            if Assigned(aAddfields[addid].Items) then
            begin
              if aAddfields[addid].Typ = 3 then
              begin
                str := '""""""';
                sl.DelimitedText := str;
                sl.SaveToStream(MSCombo, TEncoding.UTF8);
              end;
              bitfarmLog.Write(llDebug, ltInfo, 'Strict Aktuelle Items', Classname);
              aAddfields[addid].Items.SaveToStream(MsCombo, TEncoding.UTF8);
              bitfarmLog.Write(llDebug, ltInfo, 'Strict Aktuelle Items added', Classname);
            end;
          end;

          if (MsCombo.Size > 0) then
          begin
            MsCombo.Position := 0;
            addfieldcomp.ComboItems.LoadFromStream(MsCombo, TEncoding.UTF8);
          end;
        end else if aAddfields[addid].Typ = 13 then
        begin
          for i := 0 to addfieldcomp.compGrid.Config.Columns.Count -1 do
          begin
            if (addfieldcomp.compGrid.Config.Columns[i].ListType in [lstAddfieldItems, lstAddfieldValues]) and
               (addfieldcomp.compGrid.Config.Columns[i].ListAddfield <> -1) then
            begin
              lmq := DbCreateQuery;
              try
                bitfarmLog.Write(llDebug, ltInfo, 'NonStrict Aktuelle Items holen', Classname);
                if addfieldcomp.compGrid.Config.Columns[i].ListType = lstAddfieldItems then
                  lmq.SQL.Text := Format('select items from sys_addfields where addfieldid = %d', [addfieldcomp.compGrid.Config.Columns[i].ListAddfield])
                else begin
                  idxid := aAddfields[addfieldcomp.compGrid.Config.Columns[i].ListAddfield].IndexTableID;
                  add := aAddfields[addfieldcomp.compGrid.Config.Columns[i].ListAddfield].Name;
//                  addtype := aAddfields[addfieldcomp.compGrid.Config.Columns[i].ListAddfield].Typ;
                  lmq.SQL.Text := Format('select distinct(%s) as `items` from sys_docidx_%d where %s is not Null order by %s asc', [add, idxid, add, add]);
                end;
                bitfarmLog.Write(llDebug, ltInfo, 'lmq.SQL.Text: ' + lmq.SQL.Text, Classname);
                lmq.Execute;
                bitfarmLog.Write(llDebug, ltInfo, 'lmq.SQL.Text executed ', Classname);
                if lmq.RecordCount > 0 then
                begin
                  gridcolumn := AddfieldComp.compGrid.View.GetColumnByFieldName(addfieldcomp.compGrid.Config.Columns[i].Fieldname);
                  tmpdatasource := TcxLookupComboBoxProperties(gridcolumn.Properties).ListSource;
                  tmpdataset := tmpdatasource.DataSet;

                  if  tmpdataset.Active then
                  begin
                     tmpdataset.DisableControls;
                     try
                       while tmpdataset.RecordCount>0 do
                         tmpdataset.delete;
                     finally
                       tmpdataset.EnableControls;
                     end;
                  end;

                  if (addfieldcomp.compGrid.Config.Columns[i].ListType = lstAddfieldItems) and
                    (lmq.FieldByName('items').AsString <> '') then
                  begin
                    sl.Clear;
                    sl.CaseSensitive := True;
                    sl.Duplicates := dupIgnore;
                    sl.DelimitedText := lmq.FieldByName('items').AsString;
                    tmpdataset.DisableControls; //13.01.2023 Ticket 33513
                    try
                      tmpdataset.Edit;
                      for j := 0 to sl.Count -1 do
                      begin
                        tmpdataset.Append;
                        tmpdataSet.FieldByName('items').Value := sl[j];
                      end;
                      tmpdataset.Post;
                    finally
                      tmpdataset.EnableControls; //13.01.2023 Ticket 33513
                    end;
                  end else if (addfieldcomp.compGrid.Config.Columns[i].ListType = lstAddfieldValues) then
                  begin
                    tmpdataset.DisableControls; //13.01.2023 Ticket 33513
                    try
                      while not lmq.Eof do
                      begin
                        tmpdataset.Edit;
                        if (lmq.FieldByName('items').AsString <> '') then
                        begin
                          tmpdataset.Append;
                          tmpdataSet.FieldByName('items').Value := ReplaceStr(lmq.FieldByName('items').AsString, ';', ',');
                        end;
                        lmq.Next;
                      end;
                      tmpdataset.Post;
                    finally
                      tmpdataset.EnableControls; //13.01.2023 Ticket 33513
                    end;
                  end;
                end;
              finally
                lmq.Free;
              end;
            end;
          end;
        end;

//    f.schneider 21.07.2020  da der Server jetzt die strict Felditems aktuell hlt muss der Viewer nicht mehr danach Suchen
//    Ticket

      finally
        FreeAndNil(MsCombo);
        FreeAndNil(sl);
      end;

      if aAddfields[addid].Typ in [2, 11] then
      begin
        addfieldcomp.compComboBox.Properties.Items.EndUpdate;
        addfieldcomp.Strings.EndUpdate;
        addfieldcomp.Comboitems.EndUpdate;
      end
      else if aAddfields[addid].Typ = 3 then
      begin
        addfieldcomp.lstCheckedListbox.Items.EndUpdate;
        addfieldcomp.Strings.EndUpdate;
        addfieldcomp.Comboitems.EndUpdate;
      end else if aAddfields[addid].Typ = 13 then
      begin

//        addfieldcomp.Strings.EndUpdate;
//        addfieldcomp.Comboitems.EndUpdate;

      end;

      bitfarmLog.Write(llDebug, ltInfo, 'addfieldcomp.Comboitems.Count: ' + IntToStr(addfieldcomp.Comboitems.Count), Classname);
      addfieldcomp.top := (Muldiv(lastposition, Screen.PixelsPerInch, 96));
      lastposition := addfieldcomp.Top + addfieldcomp.Height + posoffset; // TODO SJ

      addfieldcomp.OnFieldSearch := DoFieldSearch;
      Result := addfieldcomp;
    except
      Result := nil;
    end;
  finally
    bitfarmLog.DebugEND(llDebug, 'DoCreateAddfieldComp', ClassName);
  end;
end;

function TbfaApplication.CreateGridfieldComp(AOwner: TComponent; Addfield: TbfaAddfield) : TBfaAddfieldComp;
var
  addfieldcomp: TBfaAddfieldComp;
  AConfig: TbfaGridConfig;
  xmlnode : IXMLDocument;
begin
  Result := nil;
  addfieldcomp := TBfaAddfieldComp.Create(AOwner, zfld13_Grid, '', False, bfaIcons.ilPreview16);
  addfieldcomp.edtGridSearch.OnKeyDown := AddFieldKeyDown;
  addfieldcomp.edtGridSearch.OnKeyDown := AddFieldKeyDown;
  addfieldcomp.edtGridSearch.PopupMenu := frmMainForm.popAddFields;
  addfieldcomp.edtGridSearch.PopupMenu := frmMainForm.popAddFields;
  addfieldcomp.OnGridExportClick := OnGridExport;
  addfieldcomp.OnGridStampClick := OnGridStamp;
  addfieldcomp.compGrid.View.Styles.Header := stlColumn;
  addfieldcomp.compGrid.View.Styles.Footer := stlColumn;
  addfieldcomp.compGrid.View.Styles.Content := stlColumn;
  addfieldcomp.compGrid.View.Styles.GroupByBox := stlGroupByBoxStyle;
  addfieldcomp.compGrid.View.Styles.Navigator := stlGroupByBoxStyle;
  addfieldcomp.compGrid.View.Styles.NavigatorInfoPanel := stlGroupByBoxStyle;
  addfieldcomp.compGrid.View.Styles.Background := stlBackgroundStyle;
  addfieldcomp.compGrid.View.Styles.Group := stlBackgroundStyle;
  addfieldcomp.compGrid.StyleFree := stlFree;
  addfieldcomp.compGrid.StyleSelected := stlSelected;
//            AConfig := TbfaGridConfig.Create;
  if Addfield.ValuesQuery <> '' then
  begin
    CoInitialize(nil);
    xmlnode := TXMLDocument.Create(nil);
    try
      xmlnode.LoadFromXML(Addfield.ValuesQuery);
      AConfig := XMLToGridConfig(xmlnode.DocumentElement);
    finally
      CoUninitialize;
    end;
    if AConfig <> nil then
    begin
      AConfig.AlternateRows := ViewerOptions.GeneralOptions.RowColorEvenOdd;
      addfieldcomp.compGrid.LoadConfig(AConfig);
      addfieldcomp.LoadGridSearchField;
    end;
  end;

  Result := addfieldcomp;
end;


procedure TbfaApplication.CreateCommentary(UserAction: PUserAction; AThread: TThread);
var
  req: TbfaRequest;
  UAction: PUserAction;
begin

  req := TbfaRequest.Create;
  try
    req.ReqType := 'reqCreateCommentary';
    req.UserID := User.ID;
    req.Profile := Self.Profile;
    req.Gdocid := StrToInt64(UserAction^.params[0]);
    req.DataString := StringReplace(UserAction^.params[1], #13#10, '\n', [rfReplaceAll]);
    req.Lang := Lang;
    MainSocket.SendRequestToServer(req);

    req := MainSocket.ReceiveResponse(AThread);
    if req = nil then
      Exit;

//27.11.2018 Ticket 16957 -->
    if req.ReqType = 'respAuthError' then
    begin
      BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
      UAction := CreateUserAction;
      UAction^.ActionName := 'actRelogin';
      MainThread.Add(UAction);
      Exit;
    end
    else
//27.11.2018 Ticket 16957 <--
    if req.ReqType = 'respError' then
    begin
      AThread.Synchronize(nil,
        procedure
        begin
          BfShowMessage(_('Der Kommentar konnte nicht gespeichert werden'));
        end);
    end
    else begin
      AThread.Synchronize(nil,
        procedure
        begin
          {$IFDEF COMMENTGRID}
          if FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.CommentaryView.
             grdCommentary.DataController.DataSource.DataSet <> nil then
          {$ELSE}
          if FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.CommentaryView.grdCommentary.DataSource.DataSet <> nil then
          {$ENDIF}
            FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.CommentaryView.RefreshCommentary
          else
            FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.CommentaryView.LoadCommentary(StrToInt64(UserAction^.params[0]));
        end);
    end;
  finally
    FreeAndNil(req);
  end;

end;

procedure TbfaApplication.AddFieldKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  sl, selpos: Integer;
  notAllowedChar: string;  //05.06.2019 Ticket 19429

  function GetWinControlText(wnd: HWND): WideString;
  var
    TextLength: Integer;
    Text: PChar;
  begin
    Result := '';
    if wnd = 0 then
      Exit;
    TextLength := SendMessage(wnd, WM_GETTEXTLENGTH, 0, 0);
    if TextLength <> 0 then
    begin
      GetMem(Text, TextLength * SizeOf(WideChar) + 1);
      SendMessage(wnd, WM_GETTEXT, TextLength + 1, Integer(Text));
      Result := Text;
      FreeMem(Text);
    end;
  end;

begin
  try
//07.03.2018 Standard Funktionen im Zusatzfelder -->
    if (ssCTRL in Shift) and (Key = 67) then
      TWinControl(Sender).perform(WM_COPY, 0, 0)
    else if (ssCTRL in Shift) and (Key = 88) then
      TWinControl(Sender).perform(WM_CUT, 0, 0)
    else if (ssCTRL in Shift) and ((Key = Ord('a')) or (Key = Ord('A'))) then
    begin
      if Sender is TSpTBXSpinEdit then
        TSpTBXSpinEdit(Sender).SelectAll
      else if Sender is TcxDateEdit then
        TcxDateEdit(Sender).SelectAll;
    end

    else if (ssCTRL in Shift) and ((Key = Ord('s')) or (Key = Ord('S'))) then  // Task 14530
    begin
      if Sender is TcxDateEdit then
        TcxDateEdit(Sender).PostEditValue;
    end

    else if (ssCTRL in Shift) and (Key = 226) and (Sender is TWinControl) { Taste: < | > } then
    begin
      var AInsertValue, ANewValue: string;
      var selstart, sellength, MoveCursor: integer;
      SelStart := -1;
      MoveCursor := 0;

      try
        if (Sender is TcxCustomTextEdit) then
        begin
          SelStart := TcxCustomTextEdit(Sender).SelStart;
          sellength := TcxCustomTextEdit(Sender).SelLength;
        end else if (Sender is TEdit) then
        begin
          SelStart := TEdit(Sender).SelStart;
          sellength := TEdit(Sender).SelLength;
        end;
      except
        SelStart := -1;
        sellength := 0;
      end;

      if (Sender is TbfaCheckedCombo) and
         (TbfaCheckedCombo(Sender).EditingValue <> '') and
         (TbfaCheckedCombo(Sender).EditingValue <> null)
      then
        ANewValue := GetWinControlText(TbfaCheckedCombo(Sender).InnerControl.Handle)
      else
        ANewValue := GetWinControlText(TWinControl(Sender).Handle);

      if (ssShift in Shift) then
        AInsertValue := FormatDateTime(formatSettings.ShortDateFormat, Now())
      else
        AInsertValue := bitfarmApp.User.Name;

      // wenn SelStart -1 ist, wissen wir nicht wo der Cursor steht und knnen nicht einfgen
      if SelStart <> - 1 then
      begin
        ANewValue := Copy(ANewValue, 0, SelStart) + AInsertValue +
                   Copy(ANewValue, SelStart + SelLength + 1, Length(ANewValue));
        MoveCursor := Length(AInsertValue);
      end else
        ANewValue := ANewValue + AInsertValue;

      if (Sender is TbfaCheckedCombo) then
      begin
        if (TbfaCheckedCombo(Sender).EditingValue <> '') and (TbfaCheckedCombo(Sender).EditingValue <> null) then
          SendMessage(TbfaCheckedCombo(Sender).InnerControl.Handle, WM_SETTEXT, 0, Integer(PChar(ANewValue)))
        else if (TbfaCheckedCombo(Sender).EditValue <> '') and (TbfaCheckedCombo(Sender).EditValue <> null) then
          TbfaCheckedCombo(Sender).EditingText := TbfaCheckedCombo(Sender).EditValue + TbfaCheckedCombo(Sender).Properties.EditValueDelimiter + AInsertValue
        else
          TbfaCheckedCombo(Sender).EditingText := AInsertValue;
      end else
        SendMessage(TWinControl(Sender).Handle, WM_SETTEXT, 0, Integer(PChar(ANewValue)));

      if SelStart <> -1 then
      begin
        if (Sender is TcxCustomTextEdit) then
          TcxCustomTextEdit(Sender).SelStart := SelStart + MoveCursor
        else if (Sender is TEdit) then
          TEdit(Sender).SelStart := SelStart + MoveCursor;
      end;
    end;
//07.03.2018 Standard Funktionen im Zusatzfelder <--


    if (((Key = Ord('a')) or (Key = Ord('A'))) or ((Key = Ord('c')) or (Key = Ord('C'))) or ((Key = Ord('s')) or (Key = Ord('S')))) and (ssCtrl in Shift) then
      Exit;  //13.02.2018 Ctrl+A und Ctrl+C muss raus!

//26.02.2018 ALT + VK_DOWN bei Mehrfachauswahlfeldern -->
    if (Sender is TbfaCheckedCombo) then
    begin
      if (ssAlt in Shift) and (Key = VK_DOWN) then
        if Assigned(TbfaCheckedCombo(Sender).Parent) then
        begin
          if TbfaCheckedCombo(Sender).Parent is TBfaAddfieldComp then
          begin
            if (TBfaAddfieldComp(TbfaCheckedCombo(Sender).Parent).lstCheckedListbox <> nil) and (not TBfaAddfieldComp(TSpTBXButtonEdit(Sender).Parent).lstCheckedListbox.visible) then
            begin
              frmMainForm.OnCheckListClick(TBfaAddfieldComp(TbfaCheckedCombo(Sender).Parent));
              Exit;
            end;
          end;
        end;
    end;
//26.02.2018 ALT + VK_DOWN bei Mehrfachauswahlfeldern <--

    if (Sender is TbfaComboBox) then
    begin
    // SJ 28.09.2022 - nicht mehr notwendig ??!?!
    // in AddfieldComp OnKeyPress bereits abgefangen
//      if bitfarmApp.ViewerOptions.GeneralOptions.ComboAutoDown then //06.04.2018
//      begin
//        //05.06.2019 Ticket 19429 -->
//        if (not((Key = VK_SHIFT) OR (Key = VK_CONTROL) OR (Key = ord(#18)))) then
//        begin
//          if (ssShift in Shift) then
//            notAllowedChar := #49 + #187 + #219 + #221 + #191
//          else if ((ssCtrl in Shift) and (ssAlt in Shift)) then
//            notAllowedChar := #219 + #55 + #48 + #226;
//          begin
//            if TBfaAddfieldComp(TbfaComboBox(Sender).Parent).NotAllowedChar <> '' then
//            begin
//              if Pos(char(Key), notAllowedChar) <> 0 then
//              begin
//                TBfaAddfieldComp(TbfaComboBox(Sender).Parent).ShowBalloonHint(Sender, TBfaAddfieldComp(TbfaComboBox(Sender).Parent).MsgNotAllowedChar );  //04.06.2019 Ticket 19429
//                Key := ord(#0);
//                //Abort;
//                Exit;
//              end;
//            end;
//          end;
//        end;
//        //05.06.2019 Ticket 19429 <--
//      end;

      if (Key = VK_RETURN) and frmMainForm.OpenDropDown then
        Exit;
    end;

    // <!-- SJ 05.08.2020 - in Rcksprache mit HS wird VK_BACK und VK_DELETE
    // bei Datumsfeldern wie bei anderen High-Komponenten gehandhabt. Das
    // heutige Datum kann man mit EINFG/INSERT einfgen
    // frmMainForm.actInsertExecute
//    if (Key = VK_INSERT) and not (ssShift in Shift) then
//    begin
//      if (Key in [VK_DELETE, VK_BACK]) and (TcxDateEdit(Sender).Text = '') then
//      if (Sender is TcxDateEdit) then
//      begin
//        if (TcxDateEdit(Sender).Text = '') then
//        begin
//          if Assigned(TcxDateEdit(Sender).Properties.OnCloseUp) then
//            TcxDateEdit(Sender).Properties.OnCloseUp(Sender)
//          else
//          begin
//            TcxDateEdit(Sender).Date := Today;
//            TcxDateEdit(Sender).PostEditValue;
//          end;
//          Exit;
//        end else if (TcxDateEdit(Sender).Text <> '') then
//        begin
//          TcxDateEdit(Sender).PostEditValue;
//          if (Sender = TBfaAddfieldComp(TcxDateEdit(Sender).Parent).comp) then
//          begin
//            TcxDateEdit(TBfaAddfieldComp(TcxDateEdit(Sender).Parent).comp2).Date := TcxDateEdit(Sender).Date;
//            TcxDateEdit(TBfaAddfieldComp(TcxDateEdit(Sender).Parent).comp2).PostEditValue;
//            TcxDateEdit(Sender).PostEditValue;
//            TcxDateEdit(TBfaAddfieldComp(TcxDateEdit(Sender).Parent).comp2).SetFocus;
//          end else if (Sender = TBfaAddfieldComp(TcxDateEdit(Sender).Parent).comp2) then
//          begin
//            TcxDateEdit(TBfaAddfieldComp(TcxDateEdit(Sender).Parent).comp).Date := TcxDateEdit(Sender).Date;
//            TcxDateEdit(TBfaAddfieldComp(TcxDateEdit(Sender).Parent).comp).PostEditValue;
//            TcxDateEdit(Sender).PostEditValue;
//            TcxDateEdit(TBfaAddfieldComp(TcxDateEdit(Sender).Parent).comp).SetFocus;
//          end;
//        end;
//      end else if (Sender is TbfaSpinEdit) then
//      if (Sender is TbfaSpinEdit) then
//      begin
//        if (TbfaSpinEdit(Sender).Text <> '') then
//        begin
//          TbfaSpinEdit(Sender).PostEditValue;
//          if (Sender = TBfaAddfieldComp(TbfaSpinEdit(Sender).Parent).comp) then
//          begin
//            TbfaSpinEdit(TBfaAddfieldComp(TbfaSpinEdit(Sender).Parent).comp2).Text := TbfaSpinEdit(Sender).Text;
//            TbfaSpinEdit(TBfaAddfieldComp(TbfaSpinEdit(Sender).Parent).comp2).PostEditValue;
//            TbfaSpinEdit(Sender).PostEditValue;
//            TbfaSpinEdit(TBfaAddfieldComp(TbfaSpinEdit(Sender).Parent).comp2).SetFocus;
//          end else if (Sender = TBfaAddfieldComp(TbfaSpinEdit(Sender).Parent).comp2) then
//          begin
//            TbfaSpinEdit(TBfaAddfieldComp(TbfaSpinEdit(Sender).Parent).comp).Text := TbfaSpinEdit(Sender).Text;
//            TbfaSpinEdit(TBfaAddfieldComp(TbfaSpinEdit(Sender).Parent).comp).PostEditValue;
//            TbfaSpinEdit(Sender).PostEditValue;
//            TbfaSpinEdit(TBfaAddfieldComp(TbfaSpinEdit(Sender).Parent).comp).SetFocus;
//          end;
//        end;
//      end;
//    end;
    // SJ 05.08.2020 -->

    if GetActivePreview <> FPreviewContainer.ImporterItem.Preview then
    begin
      if FCurrentContainer.Count > 0 then
      begin
        if (FCurrentContainer[0].Id <> -1) and (not FCurrentContainer[0].InEditMode) then
        begin
          if (Key = VK_RETURN) then
            frmMainForm.actSearch.Execute;
        end
        else if (FCurrentContainer[0].Id <> -1) and (FCurrentContainer[0].InEditMode) then
        begin
          if (Key = VK_RETURN) then
            frmMainForm.actSave.Execute;
        end;
      end
      else
      begin
        if (Key = VK_RETURN) then
          frmMainForm.actSearch.Execute;
      end;
    end
//06.12.2018 bei Importer muss bei Enter archiviren ausfhren -->
    else
    begin
      if FCurrentContainer.Count > 0 then
      begin
        if (FCurrentContainer[0].Id = -1) then
        begin
          if (Key = VK_RETURN) then
            frmMainForm.actArchive.Execute;
        end;
      end;
    end;
//06.12.2018 bei Importer muss bei Enter archiviren ausfhren <--
  except
    on E : Exception do
    begin
      Log.Write(llNormal, ltException, 'AddFieldKeyDown: '+e.Message, ClassName);
    end;
  end;
end;

//06.05.2020 Ticket 22885 -->
procedure TbfaApplication.ImporterFieldsOnChange(Sender: TObject);
var
  fValue: Widestring;
  CursorPos: Integer;
begin
  try
    if (ParseNotAllowedChars(TbfaTextEdit(Sender).Text) <> TbfaTextEdit(Sender).Text) then
      begin
        fValue := ParseNotAllowedChars(TbfaTextEdit(Sender).Text);
        CursorPos := TbfaTextEdit(Sender).SelStart - (Length(TbfaTextEdit(Sender).Text) - Length(fValue));
        TbfaTextEdit(Sender).Text := fValue;
        frmMainForm.dteSearch.ShowBalloonHint(Sender, _(sMsgNotAllowedCharachters) + sNotAllowedChar);
        TbfaTextEdit(Sender).SelStart := CursorPos;
      end;
  except
    Log.Write(llNormal, ltException, 'ImporterFieldsOnChange', ClassName);
  end;
end;
//06.05.2020 Ticket 22885 <--

procedure TbfaApplication.ImporterFieldsKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  try
    if (Sender is TbfaTextEdit) and (Key = VK_RETURN) and frmMainForm.OpenDropDown then
        Exit;

    if (Sender is TcxDateEdit) and (Key in [VK_DELETE, VK_BACK]) then
    begin
        TcxDateEdit(Sender).Properties.OnCloseUp(Sender);
        Exit;
      end;

    if GetActivePreview = FPreviewContainer.ImporterItem.Preview then
    begin
      if FCurrentContainer.Count > 0 then
      begin
        if (FCurrentContainer[0].Id = -1) and (Key = VK_RETURN) then
            frmMainForm.actArchive.Execute;
        end;
      end;
  except
    Log.Write(llNormal, ltException, 'ImporterFieldsKeyDown', ClassName);
  end;
end;

procedure TbfaApplication.ReadAddfieldRights(arcids: TStringList);
var
  i: Integer;
  addfieldid: Integer;
  maxid: Integer;
  qry: TUniQuery;
begin
  Log.DebugBegin(llDebug, 'ReadAddfieldRights', ClassName);
  try
    try
      try
        qry := TUniQuery.Create(nil);
        qry.Connection := dmMain.cntMain;
        qry.SQL.Text := 'select max(addfieldid) as maxid from sys_addfields';
        qry.Execute;
        if qry.RecordCount > 0 then
          maxid := qry.FieldByName('maxid').AsInteger
        else
          Exit;

        if maxid > 0 then
        begin
          SetLength(aAddfieldRights, maxid + 1);
          for i := Low(aAddfieldRights) to High(aAddfieldRights) do
            aAddfieldRights[i] := 0;  //kein Standardrecht mehr, rechte nur ber userid oder Groupid
    //         aAddfieldRights[i] := cAddfieldModify;    // Standardrecht modifiy

          // erst nach Basiseintrag abfragen (es wurden Rechte gesetzt, dH Alle haben nur lesen...
          qry.SQL.Text := 'select fieldid, bit_or(rights) from sys_addfieldxs where arcid in (' + arcids.CommaText + ') and (userid = 0 and groupid = 0) group by fieldid';

          qry.Execute;
          if qry.RecordCount > 0 then
          begin
            with qry do
            begin
              First;
              for i := 0 to RecordCount - 1 do
              begin
                if qry.FieldByName('fieldid').AsInteger <= maxid then
                  aAddfieldRights[qry.FieldByName('fieldid').AsInteger] := qry.FieldByName('bit_or(rights)').AsInteger;
                Next;
              end;
            end;
          end;

          // dann mit den persnlichen Rechte des Benutzers bzw seiner Gruppen berschreiben (falls vorhanden)
          qry.SQL.Text := 'select fieldid, bit_or(rights) from sys_addfieldxs where arcid in (' + arcids.CommaText + ') and (userid in(' + User.HolidayList.CommaText + ') or (userid = 0 and groupid in(' + User.Grouplist.CommaText + '))) group by fieldid';

          qry.Execute;
          if qry.RecordCount > 0 then
          begin
            with qry do
            begin
              First;
              for i := 0 to RecordCount - 1 do
              begin
                if qry.FieldByName('fieldid').AsInteger <= maxid then
                  aAddfieldRights[qry.FieldByName('fieldid').AsInteger] := qry.FieldByName('bit_or(rights)').AsInteger;
                Next;
              end;
            end;
          end;

        end;

      finally
        FreeAndNil(qry);
      end;
    except
      Log.Write(llNormal, ltException, 'ReadAddfieldRights', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'ReadAddfieldRights', ClassName);
  end;
end;

procedure TbfaApplication.ReadAddfields;
var
  i: Integer;
  addfieldid: Integer;
  maxid: Integer;
  qry: TUniQuery;
begin
  try
    qry := TUniQuery.Create(nil);
    qry.Connection := dmMain.cntMain;
    qry.SQL.Text := 'select max(addfieldid) as maxid from sys_addfields';
    qry.Execute;
    if qry.RecordCount > 0 then
      maxid := qry.FieldByName('maxid').AsInteger
    else
      Exit;

    if maxid > 0 then
    begin
//11.06.2024 BT bfacrm:ticket__show__38924      qry.SQL.Text := 'Select addfieldid, fieldname, displayname, type, items, mode, options, checkprogram, values_query, indextableid, description from sys_addfields';
      qry.SQL.Text := 'Select addfieldid, fieldname, displayname, type, items, mode,' +
        'options, checkprogram, values_query, indextableid, description, flags +0 from sys_addfields';
      qry.Execute;
      if qry.RecordCount > 0 then
      begin
        with qry do
        begin
          SetLength(aAddfields, maxid + 1);
          First;
          for i := 0 to RecordCount - 1 do
          begin
            addfieldid := FieldByName('addfieldid').AsInteger;
            aAddfields[addfieldid] := TbfaAddField.Create;
            aAddfields[addfieldid].Id := addfieldid;
            aAddfields[addfieldid].Name := FieldByName('fieldname').AsString;
            aAddfields[addfieldid].Displayname := FieldByName('displayname').AsString;
            aAddfields[addfieldid].Typ := FieldByName('type').AsInteger;
            aAddfields[addfieldid].Flags := FieldByName('flags +0').AsInteger; //11.06.2024 BT bfacrm:ticket__show__38924

            if FieldByName('items').AsString <> '' then
            begin
              aAddfields[addfieldid].Items := TStringList.Create;
              aAddfields[addfieldid].Items.Delimiter := ';';
              aAddfields[addfieldid].Items.StrictDelimiter := True;
              // bfacrm:ticket__show__33355
              // soWriteBOM raus, sonst haben wir vor dem ersten Item #$FEFF stehen.
              // https://docwiki.embarcadero.com/Libraries/Alexandria/en/System.Classes.TStrings.WriteBOM
              // -> "Set WriteBOM to True to cause SaveToStream to write a BOM (byte-order mark) to the stream and to cause SaveToFile to write a BOM to the file."
              // -> aAddfields[addid].Items.SaveToStream(MsCombo, TEncoding.UTF8);

              // sonst funktioniert TokenViewInfo in TBfaAddfieldComp.TokenDraw beim ersten Item nicht
              aAddfields[addfieldid].Items.Options := aAddfields[addfieldid].Items.Options - [soWriteBOM];
              aAddfields[addfieldid].Items.DelimitedText := FieldByName('items').AsString;
            end;

            aAddfields[addfieldid].Mode := FieldByName('mode').AsInteger;
            aAddfields[addfieldid].options := FieldByName('options').AsInteger;
            aAddfields[addfieldid].Checkprogram := FieldByName('checkprogram').AsString;
            aAddfields[addfieldid].Description := FieldByName('description').AsString;
            aAddfields[addfieldid].ValuesQuery := FieldByName('values_query').AsString;
            aAddfields[addfieldid].Indextableid := FieldByName('indextableid').AsInteger;
            aAddfields[addfieldid].Rights := 0;   //Initial 0, muss beim erstellen der Felder mit dem tatschlichen Recht gefllt werden. Standard 1= nur lesen 2= write 4= modify
            Next;
          end;
        end;
      end;
    end;
  finally
    FreeAndNil(qry);
  end;
end;


function TbfaApplication.ReadConFile(ConFileName: string; Key: string): Boolean;
var
  ini: TIniFile;
begin
  try
    Result := False;
    ini := TIniFile.Create(ConFileName);

    try
      if not FileExists(ini.FileName) then
        BfMessageBox(_('Con Datei ist nicht vorhanden!'), _('Fehler'), 0)
      else
      begin
        FDomain := ini.ReadString(sSysConnectionSection, sSysDomain, '');
        OfflineDB := ini.ReadString(sSysConnectionSection, sSysOfflineDB, '');
        Ldap_SSL := LowerCase(ini.ReadString(sSysConnectionSection, 'ldap_ssl', 'false')) = 'true';

        if (LowerCase(ini.ReadString(sSysOptionsSection, 'usematchagainst', 'false')) = 'true') then
        begin
          UseMatchAgainst := True;
          FViewerOptions.SearchOptions.SQLFullText := True;
        end
        else
          UseMatchAgainst := FViewerOptions.SearchOptions.SQLFullText;

        FUseSearch35 := (LowerCase(ini.ReadString(sSysOptionsSection, 'UseSearch35', 'false')) = 'true');
        FUseState35 := (LowerCase(ini.ReadString(sSysOptionsSection, 'usestatus35', 'false')) = 'true');
        FIgnoreRightsAtImport := (LowerCase(ini.ReadString(sSysOptionsSection, 'ignorerightsatimport', 'false')) = 'true');

        {$IFDEF ENTERPRISE}
        FImporterPlugin := (LowerCase(ini.ReadString(sSysOptionsSection, 'importerplugin', '')));
        if FImporterPlugin = '' then
          FImporterPlugin := (LowerCase(ini.ReadString(sSysOptionsSection, 'manuscanplugin', '')));

//19.07.2024 nicht verwendet        FUncClientSpooler := (LowerCase(ini.ReadString('Scripts', 'uncclientspooler', '')));
        BugReportEmail := (LowerCase(ini.ReadString(sSysOptionsSection, 'BugReportEmail', '')));
        LogSaveDirectory := (LowerCase(ini.ReadString(sSysOptionsSection, 'LogSaveDirectory', BD.EnvTempPd)));
        SetLogDirectory;
        {$ENDIF}

  //06.11.2017 Ticket 12362 -->
        if ini.ValueExists(sSysOptionsSection, sSysSetAnnoDPI) then
        begin
          if (LowerCase(ini.ReadString(sSysOptionsSection, sSysSetAnnoDPI, 'false')) = 'true') or (ini.ReadString(sSysOptionsSection, sSysSetAnnoDPI, 'false') = '1') then
            SetAnnoDPIFromCon := True
          else
            SetAnnoDPIFromCon := False;
        end
        else
          SetAnnoDPIFromCon := False;

        if SetAnnoDPIFromCon then
          FViewerOptions.GeneralOptions.SetAnnoDPI := True;
  //06.11.2017 Ticket 12362 <--

  //20.11.2017 Ticket 12450 -->
        if ini.ValueExists(sSysOptionsSection, sSysUseFileNameAsDocName) then
        begin
          if (LowerCase(ini.ReadString(sSysOptionsSection, sSysUseFileNameAsDocName, 'true')) = 'true') or (ini.ReadString(sSysOptionsSection, sSysUseFileNameAsDocName, 'true') = '1') then
          begin
            UseFileNameAsDocNameFromCon := True;
            FViewerOptions.GeneralOptions.UseFileNameAsDocName := True;
          end
          else if (LowerCase(ini.ReadString(sSysOptionsSection, sSysUseFileNameAsDocName, 'true')) = 'false') or (ini.ReadString(sSysOptionsSection, sSysUseFileNameAsDocName, 'true') = '0') then
          begin
            UseFileNameAsDocNameFromCon := True;
            FViewerOptions.GeneralOptions.UseFileNameAsDocName := False;
          end
          else
            UseFileNameAsDocNameFromCon := False;
        end
        else
          UseFileNameAsDocNameFromCon := False;

  //20.11.2017 Ticket 12450 <--

        with dmMain.cntMain do
        begin
          if Connected then
            Disconnect;

          Username := Decrypt(ini.ReadString(sSysConnectionSection, sSysSUUser, ' '), Key);
          Password := Decrypt(ini.ReadString(sSysConnectionSection, sSysSUPass, ' '), Key);
          Database := ini.ReadString(sSysConnectionSection, sSysDB, '');
          Server := ini.ReadString(sSysConnectionSection, sSysServer, '');
          Port := ini.ReadInteger(sSysConnectionSection, sSysPort, 3306);
          ProviderName := ini.ReadString(sSysConnectionSection, sSysDBProvider, 'MySQL');
          bfaServer := ini.ReadString(sSysServerSection, sSysBfaServer, 'localhost');
          bfaServerPort := ini.ReadInteger(sSysServerSection, sSysBfaServerPort, 50001);
          Autoreconnect := (LowerCase(ini.ReadString(sSysServerSection, sSysAutoreconnect, 'false')) = 'true') or (ini.ReadString(sSysServerSection, sSysAutoreconnect, 'false') = '1');
          Usertimeout := ini.ReadInteger(sSysServerSection, sSysUsertimeout, 90);
          bfaServerNoSSL := ((LowerCase(ini.ReadString(sSysServerSection, sSysNoSSL, 'false')) = 'true') or (ini.ReadString(sSysServerSection, sSysNoSSL, 'false') = '1')).ToInteger;
          LinkChars := ini.ReadInteger(sSysOptionsSection, 'LinkChars', 2);
          SvnInfo := ini.Readbool(sSysOptionsSection, 'SvnInfo', false) or (LowerCase(ini.ReadString(sSysOptionsSection, 'SvnInfo', 'false')) = 'true');

  //        CurrentResubFields := ini.ReadInteger(sSysScriptsSection, 'resubaddfields', -1);

          if dmMain.cntSearch.Connected then
            dmMain.cntSearch.Disconnect;

          dmMain.cntSearch.Username := Username;
          dmMain.cntSearch.Password := Password;
          dmMain.cntSearch.Database := Database;
          dmMain.cntSearch.Server := Server;
          dmMain.cntSearch.Port := Port;
          dmMain.cntSearch.ProviderName := ProviderName;

          if dmMain.cntBackThread.Connected then
            dmMain.cntBackThread.Disconnect;

          dmMain.cntBackThread.Username := Username;
          dmMain.cntBackThread.Password := Password;
          dmMain.cntBackThread.Database := Database;
          dmMain.cntBackThread.Server := Server;
          dmMain.cntBackThread.Port := Port;
          dmMain.cntBackThread.ProviderName := ProviderName;

          if dmMain.cntResubSearch.Connected then
            dmMain.cntResubSearch.Disconnect;

          dmMain.cntResubSearch.Username := Username;
          dmMain.cntResubSearch.Password := Password;
          dmMain.cntResubSearch.Database := Database;
          dmMain.cntResubSearch.Server := Server;
          dmMain.cntResubSearch.Port := Port;
          dmMain.cntResubSearch.ProviderName := ProviderName;
        end;

        Result := True;
      end;
    finally
      ini.Free;
    end;
  except
  end;
end;

procedure TbfaApplication.ReadEmailUser;
var
  lmq: TUniQuery;
  user: TbfaUser;
  group: TbfaGroup;
begin
  frmMainForm.frmLinkMails.bfsLinkMail.DisableControls := True; //19.02.2024
  try
    frmMainForm.frmLinkMails.bfsLinkMail.lvList1.Clear;
    frmMainForm.frmLinkMails.bfsLinkMail.lvList2.Clear;
    frmMainForm.frmLinkMails.bfsLinkMail.ListAll.Clear;
    frmMainForm.frmLinkMails.bfsLinkMail.ListSelected.Clear;

    lmq := DbCreateQuery;
    try
      lmq.SQL.Text := 'select userid, username, displayname, usermail from sys_user where (flags & 2) = 0';   // alle die nicht deletetd sind
      lmq.Execute;
      if lmq.RecordCount > 0 then
      begin
        while not lmq.Eof do
        begin
          if lmq.FieldByName('usermail').AsWideString <> '' then
          begin
            user := TbfaUser.Create;
            user.ID := lmq.FieldByName('userid').AsInteger;
            user.Name := lmq.FieldByName('username').AsWideString;
            user.DisplayName := lmq.FieldByName('displayname').AsWideString;
            user.Email := lmq.FieldByName('usermail').AsWideString;
            bitfarmApp.GEmailUser.Add(user);
            frmMainForm.frmLinkMails.bfsLinkMail.AddListAll(user.DisplayName, user);
          end;
          lmq.Next;
        end;
      end;
    finally
      lmq.Free;
    end;

    lmq := DbCreateQuery;
    try
      lmq.SQL.Text := 'select groupid, groupname, email from sys_group where (flags & 2) = 0';
      lmq.Execute;
      if lmq.RecordCount > 0 then
      begin
        while not lmq.Eof do
        begin
          if lmq.FieldByName('email').AsWideString <> '' then
          begin
            group := TbfaGroup.Create;
            group.ID := lmq.FieldByName('groupid').AsInteger;
//13.09.2024            group.Name := lmq.FieldByName('groupname').AsWideString;
            group.Name := TranslateGroupName(lmq.FieldByName('groupname').AsWideString);
            group.Email := lmq.FieldByName('email').AsWideString;

            bitfarmApp.GEmailGroups.Add(group);
            frmMainForm.frmLinkMails.bfsLinkMail.AddListAll(group.Name, group);
          end;
          lmq.Next;
        end;
      end;
    finally
      lmq.Free;
    end;
  finally
    frmMainForm.frmLinkMails.bfsLinkMail.DisableControls := False; //19.02.2024
  end;
end;

//12.09.2024 -->
function TbfaApplication.TranslateGroupName(GroupName: string): string;
begin
//13.09.2024 ????  if GroupName = 'Alle' then
//    Result := sCaptionAll
//  else
  if GroupName = 'Alle (Builtin)' then
    Result := sCaptionAllBuiltIn
  else
    Result := GroupName;
end;
//12.09.2024 <--

procedure TbfaApplication.ReadFieldRights(arcids: TStringList);
begin
  ReadAddfieldRights(arcids);
  ReadStatefieldRights(arcids);
end;

procedure TbfaApplication.ReadRefnamesOrTitels(cbx: TObject; sub: string; Refname: Integer = 0);
var
  i: Integer;
  qry: TUniQuery;
  sql: string;
begin
  try
    try
  //03.04.2017    Strings.Clear;
      if cbx is TBfaAddfieldComp then
      begin
        TBfaAddfieldComp(cbx).compComboBox.Properties.Items.BeginUpdate;
        TBfaAddfieldComp(cbx).compComboBox.StoredItems.BeginUpdate;
        TBfaAddfieldComp(cbx).Comboitems.BeginUpdate;
        TBfaAddfieldComp(cbx).Comboitems.Clear;
        TBfaAddfieldComp(cbx).compComboBox.StoredItems.Clear;
        TBfaAddfieldComp(cbx).compComboBox.Properties.Items.Clear;
//        TBfaAddfieldComp(cbx).compComboBox.Selstart := Length(TBfaAddfieldComp(cbx).compComboBox.Text);
      end
      else if cbx is TbfaCheckedCombo then
      begin
        TbfaCheckedCombo(cbx).Properties.BeginUpdate;
        TbfaCheckedCombo(cbx).Properties.Tokens.Clear;
      end else
      begin
        TComboBox(cbx).Items.BeginUpdate;
        TComboBox(cbx).Items.Clear;
      end;

      qry := TUniQuery.Create(nil);
      qry.Connection := dmMain.cntMain;

      qry.SQL.Text := SQLQueryReadRefNamesOrTitles(sub, Refname); // SJ 09.12.2020
      qry.Execute;
      if qry.RecordCount > 0 then
      begin
        while not qry.Eof do
        begin
          if Refname = 0 then
          begin
            if cbx is TbfaCheckedCombo then
            begin
              if (TbfaCheckedCombo(cbx).Properties.Tokens.FindByText(qry.FieldByName('refname').AsString) = nil) then
                with TbfaCheckedCombo(cbx).Properties.Tokens.Add do
                  Text := qry.FieldByName('refname').AsString;
            end else if (cbx is TBfaAddfieldComp) then
            begin
              if TBfaAddfieldComp(cbx).Comboitems.IndexOf(qry.FieldByName('refname').AsString) = -1 then
              TBfaAddfieldComp(cbx).Comboitems.Add(qry.FieldByName('refname').AsString);
            end else
              TComboBox(cbx).Items.Add(qry.FieldByName('refname').AsString);
          end else begin // Doc-Title
            if (cbx is TbfaCheckedCombo) then
          begin
              if (TbfaCheckedCombo(cbx).Properties.Tokens.FindByText(qry.FieldByName('docname').AsString) = nil) then
                with TbfaCheckedCombo(cbx).Properties.Tokens.Add do
                  Text := qry.FieldByName('docname').AsString;
            end else if (cbx is TBfaAddfieldComp) then
            begin
              if (TBfaAddfieldComp(cbx).Comboitems.IndexOf(qry.FieldByName('docname').AsString) = -1) then
            TBfaAddfieldComp(cbx).Comboitems.Add(qry.FieldByName('docname').AsString);
            end else
              TComboBox(cbx).Items.Add(qry.FieldByName('docname').AsString);
          end;
          qry.Next;
        end;
      end;
    finally
      if cbx is TBfaAddfieldComp then
      begin
        TBfaAddfieldComp(cbx).compComboBox.StoredItems.Assign(TBfaAddfieldComp(cbx).Comboitems);
        TBfaAddfieldComp(cbx).compComboBox.Properties.Items.Assign(TBfaAddfieldComp(cbx).Comboitems);
        TBfaAddfieldComp(cbx).Comboitems.EndUpdate;
        TBfaAddfieldComp(cbx).compComboBox.Properties.Items.EndUpdate;
        TBfaAddfieldComp(cbx).compComboBox.StoredItems.EndUpdate;
      end else if cbx is TbfaCheckedCombo then
        TbfaCheckedCombo(cbx).Properties.EndUpdate
      else
        TComboBox(cbx).Items.EndUpdate;

      FreeAndNil(qry);
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'ReadRefnamesOrTitels', ClassName);
  end;
end;

procedure TbfaApplication.ReadHotSearchOptions;
  function CreateDefaultHotSearchIni: TIniFile;
  var
    hd: HWND;
  begin
    try
      Result := TIniFile.Create(BD.AppdataBitfarmPd + 'HotSearchOptions.ini');
      Result.WriteString(sSysHotSearchOptions, 'Conn', bitfarmApp.Profile);
      Result.WriteInteger(sSysHotSearchOptions, 'Count', 2);
      Result.WriteString(sSysHotSearchOptions, sSysLanguage, bitfarmApp.Lang);


      for var i := 0 to 1 do
      begin
        if i = 0 then
        begin
          Result.WriteString(sSysHotSearchOptions, 'Name' + IntToStr(i), _('Standard-Hotkey'));
          Result.WriteInteger(sSysHotSearchOptions, 'HotKey' + IntToStr(i), 16450);
        end
        else if i = 1 then
        begin
          Result.WriteString(sSysHotSearchOptions, 'Name' + IntToStr(i), _('Screenshot archivieren'));
          Result.WriteInteger(sSysHotSearchOptions, 'HotKey' + IntToStr(i), 49229); //Strg + Alt + M
        end;
      end;

      Result.UpdateFile;

      hd := FindWindow('bitfarm.hotsearch.V36', nil);
      if hd <> 0 then
        SendMessage(hd, WM_HOTKEY_RELOAD_CONFIG, 0, 0);
    except
      on e: exception do
      begin
        Result := nil;
        bitfarmLog.Write(llNormal, ltException, 'CreateDefaultHotSearchIni' + e.Message, ClassName);
      end;
    end;
  end;
var
  i, cnt: Integer;
  hotkey: TbfaHotKey;
  inifile: TIniFile;
begin
  Log.DebugBegin(llDebug, 'ReadHotSearchKeys', ClassName);
  try
    aHotKeyProfil := '';
    if FileExists(ExtractFilePath(Application.ExeName) + 'HotSearchOptions.ini') then
      inifile := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'HotSearchOptions.ini')
    else if FileExists(BD.AppdataBitfarmPd + 'HotSearchOptions.ini') then
      inifile := TIniFile.Create(BD.AppdataBitfarmPd + 'HotSearchOptions.ini')
    else
      inifile := CreateDefaultHotSearchIni;
    try
      if (inifile <> nil) and FileExists(inifile.FileName) then
      begin
        aHotKeyProfil := inifile.ReadString(sSysHotSearchOptions, 'Conn', '');
        cnt := inifile.ReadInteger(sSysHotSearchOptions, sSysCount, 0);
        for i := 0 to cnt - 1 do
        begin
          SetLength(aHotKeys, i + 1);
          hotkey.ID := i;
          if i = 0 then
          begin
            hotkey.Name := _('Standard-Hotkey');
            hotkey.HotKey := inifile.ReadInteger(sSysHotSearchOptions, 'HotKey' + IntToStr(i), 16450);
          end
          else if i = 1 then
          begin
            hotkey.Name := _('Screenshot archivieren');
            hotkey.HotKey := inifile.ReadInteger(sSysHotSearchOptions, 'HotKey' + IntToStr(i), 49229); //Strg + Alt + M
          end
          else
          begin
//            hotkey.Name := _('Hotkey ' + IntToStr(i)); // bfacrm:ticket__show__28820
            hotkey.Name := inifile.ReadString(sSysHotSearchOptions, 'Name' + IntToStr(i), '');
            hotkey.HotKey := inifile.ReadInteger(sSysHotSearchOptions, 'HotKey' + IntToStr(i), 0);
          end;

          hotkey.StoreName := inifile.ReadString(sSysHotSearchOptions, 'StoreName' + IntToStr(i), '');
          hotkey.ArchiveName := inifile.ReadString(sSysHotSearchOptions, 'ArchiveName' + IntToStr(i), '');
          hotkey.Screenshot := inifile.ReadBool(sSysHotSearchOptions, 'ScreenShot' + IntToStr(i), False);
          hotkey.DocLink := inifile.ReadBool(sSysHotSearchOptions, 'DocLink' + IntToStr(i), False);
          hotkey.GDocIDSearch := inifile.ReadBool(sSysHotSearchOptions, 'GDocIDSearch' + IntToStr(i), False);
          hotkey.State := 0;
          hotkey.Modified := False;
          hotkey.StoreID := inifile.ReadInteger(sSysHotSearchOptions, 'StoreID' + IntToStr(i), -1);
          hotkey.ArchiveID := inifile.ReadInteger(sSysHotSearchOptions, 'ArchiveID' + IntToStr(i), -1);
          aHotKeys[i] := hotkey;
        end;
      end;
    finally
      if Assigned(inifile) then
        inifile.Free;
    end;
  finally
    Log.DebugEnd(llDebug, 'ReadHotSearchKeys', ClassName);
  end;
end;

procedure TbfaApplication.ReadResubFavs;
var
  i, j, k: Integer;
  resub: TResub;
  inifile: TIniFile;
  notfound: Boolean;
  task: string;
  lst: TStringList;
begin
  Log.DebugBegin(llDebug, 'ReadResubFavs', ClassName);
  try
    notfound := False;
    if FileExists(BD.AppdataBitfarmPd + 'ResubFavs.ini') then
    begin
      inifile := TIniFile.Create(BD.AppdataBitfarmPd + 'ResubFavs.ini');
      i := 0;
      while not notfound do
      begin
        task := 'Task' + Inttostr(i);
        if inifile.SectionExists(task) then
        begin
          SetLength(aResubFavs, i + 1);
          resub.ID := i;
          resub.Name := inifile.ReadString(task, 'name', task);
          resub.Info := inifile.ReadString(task, 'info', '');
          resub.FwdInfo := inifile.ReadString(task, 'fwdinfo', '');
          resub.Alarm := inifile.ReadInteger(task, 'alarm', 7);
          resub.Users := inifile.ReadString(task, 'users', '');
          resub.Groups := inifile.ReadString(task, 'groups', '');
          resub.Options := inifile.ReadInteger(task, 'options', 0);
          resub.FavIcon := inifile.ReadInteger(task, 'favicon', 0);
          resub.AdditionalDays := inifile.ReadInteger(task, 'AdditionalDays', 0);
          aResubFavs[i] := resub;
          inc(i);
        end
        else
          notfound := True;
      end;
    end
    else
    begin
      j := 0;
      lst := TStringList.Create;
      try
        lst.Delimiter := ';';
        lst.StrictDelimiter := True;
        if FileExists(BD.AppdataBitfarmPd + 'wvlfav.ini') then
        begin
          inifile := TIniFile.Create(BD.AppdataBitfarmPd + 'wvlfav.ini');
          for i := 0 to 9 do
          begin
            task := 'Task' + Inttostr(i);
            if inifile.SectionExists(task) then
            begin
              SetLength(aResubFavs, j + 1);
              resub.ID := j;
              resub.Name := _('Favorit') + ' ' + InttoStr(j + 1);
              resub.Info := inifile.ReadString(task, 'Info', '');
              if resub.Info <> '' then
                resub.Name := resub.Info;
              resub.Alarm := inifile.ReadInteger(task, 'Abstand', 7);
              resub.Options := inifile.ReadInteger(task, 'Optionen', 0);
              lst.DelimitedText := inifile.ReadString(task, 'Workerseb', '');
              if lst.DelimitedText <> '' then
              begin
                resub.Name := resub.Name + ' / ' + lst.DelimitedText;
                for k := 0 to lst.Count - 1 do
                  lst[k] := IntToStr(DBGetUserID(lst[k]));
                resub.Users := lst.DelimitedText;
              end;
              lst.DelimitedText := inifile.ReadString(task, 'Workersefa', '');
              if lst.DelimitedText <> '' then
              begin
                resub.Name := resub.Name + ' / ' + lst.DelimitedText;
                for k := 0 to lst.Count - 1 do
                  lst[k] := IntToStr(DBGetGroupID(lst[k]));
                resub.Groups := lst.DelimitedText;
              end;
              lst.DelimitedText := inifile.ReadString(task, 'Workersje', '');
              if lst.DelimitedText <> '' then
              begin
                resub.Name := resub.Name + ' / ' + lst.DelimitedText;
                resub.Options := (resub.Options or 1);
                for k := 0 to lst.Count - 1 do
                  lst[k] := IntToStr(DBGetGroupID(lst[k]));
                resub.Groups := lst.DelimitedText;
              end;
              resub.Modified := True;
              resub.FavIcon := 0;
              resub.AdditionalDays := 0;
              aResubFavs[j] := resub;
              Inc(j);
            end;
          end;
        end;
        if FileExists(BD.AppdataBitfarmPd + 'wvlwlt.ini') then
        begin
          inifile := TIniFile.Create(BD.AppdataBitfarmPd + 'wvlwlt.ini');
          for i := 0 to 9 do
          begin
            task := 'Task' + Inttostr(i);
            if inifile.SectionExists(task) then
            begin
              SetLength(aResubFavs, j + 1);
              resub.ID := j;
              resub.Name := _('Weiterleiten') + ' ' + InttoStr(j + 1);
              resub.Info := inifile.ReadString(task, 'Info', '');
              if resub.Info <> '' then
                resub.Name := resub.Info;
              resub.Alarm := inifile.ReadInteger(task, 'Abstand', 7);
              resub.Options := inifile.ReadInteger(task, 'Optionen', 0);
              lst.DelimitedText := inifile.ReadString(task, 'Workerseb', '');
              if lst.DelimitedText <> '' then
              begin
                resub.Name := resub.Name + ' / ' + lst.DelimitedText;
                for k := 0 to lst.Count - 1 do
                  lst[k] := IntToStr(DBGetUserID(lst[k]));
                resub.Users := lst.DelimitedText;
              end;
              lst.DelimitedText := inifile.ReadString(task, 'Workersefa', '');
              if lst.DelimitedText <> '' then
              begin
                resub.Name := resub.Name + ' / ' + lst.DelimitedText;
                for k := 0 to lst.Count - 1 do
                  lst[k] := IntToStr(DBGetGroupID(lst[k]));
                resub.Groups := lst.DelimitedText;
              end;
              lst.DelimitedText := inifile.ReadString(task, 'Workersje', '');
              if lst.DelimitedText <> '' then
              begin
                resub.Name := resub.Name + ' / ' + lst.DelimitedText;
                resub.Options := (resub.Options or 1);
                for k := 0 to lst.Count - 1 do
                  lst[k] := IntToStr(DBGetGroupID(lst[k]));
                resub.Groups := lst.DelimitedText;
              end;
              resub.Modified := True;
              resub.FavIcon := i + 1;
              resub.AdditionalDays := 0;
              aResubFavs[j] := resub;
              Inc(j);
            end;
          end;
        end;
//07.10.2021 ??? hier lesen wir gerade       WriteResubFavs;
      finally
        FreeAndNil(lst);
      end;
    end;

    CreateResubPopup;
    CreateResubFavsInPreviews;

  finally
    Log.DebugEnd(llDebug, 'ReadResubFavs', ClassName);
    try
      if Assigned(inifile) then
        //inifile.Free;
        FreeAndNil(inifile);
    except
      inifile := nil;
    end;
  end;
end;

procedure TbfaApplication.ReadResubUserGroups(var fraResub : TfraResub);
var
  lst: TStringList;
begin
  bitfarmLog.DebugBegin(llDebug, 'ReadResubUserGroups', ClassName);
  try
    try
      lst := DBGetGrouplist(0, 0, True, True);
      fraResub.cbbUserGroups.Items := lst;
      fraResub.IndexUserPos := lst.Count;
      frmMainForm.frmResubDialog.fraCreateResub.cbbGroup.Items := lst;
      frmMainForm.fraImporterResub.cbbGroup.Items := lst;

      lst := DBGetUserlist(0, 0, True, True);
      fraResub.cbbUserGroups.Items.AddStrings(lst);
      frmMainForm.frmResubDialog.fraCreateResub.cbbUser.Items := lst;
      frmMainForm.fraImporterResub.cbbUser.Items := lst;
    except
      on e: exception do
        bitfarmLog.Write(llNormal, ltException, 'ReadResubUserGroups' + e.Message, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ReadResubUserGroups', ClassName);
  end;
end;

procedure TbfaApplication.RetranslateSearchGrid(searchgrid: TbfaDBGrid);
var
  i, j: integer;
  ArcId: Int64;
  s: string;
  IsResubColumn, IsResubGrid: Boolean;
begin
  try
    // 1. in aColSortings alle Spaltenberschriten bersetzen
    for i := Low(aSysArc) to High(aSysArc) do
    begin
      ArcId := aSysArc[i].ArcId;
      for j := Low(aColSortings[ArcId]) to High(aColSortings[ArcId]) do
      begin
        GetSortTitle(aColSortings[ArcId, j].Field, aColSortings[ArcId, j].Title);
      end;
    end;

    // 2. Im stehenden Suchgrid auch alle Spaltenberschriften ersetzen
    if frmMainForm.grdResultlistDevExView <> nil then
    begin
      for i := 0 to frmMainForm.grdResultlistDevExView.ColumnCount - 1 do
      begin
        s := frmMainForm.grdResultlistDevExView.Columns[i].Caption;
        GetSortTitle(frmMainForm.grdResultlistDevExView.Columns[i].DataBinding.FieldName, s);
        frmMainForm.grdResultlistDevExView.Columns[i].Caption := s;
      end;
    end;

    // 3. Im stehenden Ausdockbaren WVLListe auch alle Spaltenberschriften ersetzen
    if (frmMainForm.fraFloatingResub <> nil) and (frmMainForm.fraFloatingResub.grdResubResultlistDevExView <> nil) then
    begin
      for i := 0 to frmMainForm.fraFloatingResub.grdResubResultlistDevExView.ColumnCount - 1 do
      begin
        s := frmMainForm.fraFloatingResub.grdResubResultlistDevExView.Columns[i].Caption;
        GetSortTitle(frmMainForm.fraFloatingResub.grdResubResultlistDevExView.Columns[i].DataBinding.FieldName, s);
        frmMainForm.fraFloatingResub.grdResubResultlistDevExView.Columns[i].Caption := s;
      end;
    end;

  except
    on e: Exception do
      bitfarmLog.DebugEnd(llDebug, 'RetranslateSearchGrid: ' + e.Message, ClassName);
  end;
end;

function TbfaApplication.GetSortTitle(FieldName: string): string;
begin
  try
    Result := '';

    if FieldName = FLD_TYP then
      Result := _('Typ')
    else if FieldName = FLD_DATE then
      Result := _('Termin')
    else if FieldName = FLD_ARCNAME then
      Result := _('Archiv')
    else if FieldName = FLD_DOCNAME then
      Result := _('Titel')
    else if FieldName = FLD_INFO then
      Result := _('Info')
    else if FieldName = FLD_USER_WORK then
      Result := _('Bearbeiter')
    else if FieldName = FLD_USER_SHED then
      Result := _('Controller')
    else if FieldName = FLD_COMMENT then
      Result := _('Kommentar')
    else if FieldName = FLD_DOCUSERNAME then
      Result := _('Benutzer')
    else if FieldName = FLD_DOCDATE then
      Result := _('Datum')
    else if FieldName = FLD_DOCMODIFIED then
      Result := _('nderungsdatum');
  except
    on e: Exception do
      bitfarmLog.DebugEnd(llDebug, 'GetSortTitle: ' + e.Message, ClassName);
  end;
end;

procedure TbfaApplication.GetSortTitle(FieldName: string; var OrgTitle: string);
var
  NewTitle: string;
begin
  try
    NewTitle := GetSortTitle(FieldName);

    if NewTitle <> '' then
      OrgTitle := NewTitle;

  except
    on e: Exception do
      bitfarmLog.DebugEnd(llDebug, 'GetSortTitle: ' + e.Message, ClassName);
  end;
end;

function TbfaApplication.GetSortRec(stlsort : TStringList) : TSorting;
var
  subsort: TSorting;
begin
  subsort.Title := stlsort[0];
  subsort.Field := stlsort[1];
  subsort.SortOrder := StrToInt(stlsort[2]);
  subsort.Width := StrToInt(stlsort[3]);
  if (stlsort.Count >= 7) then
  begin
    subsort.GroupingIndex := StrToInt(stlsort[4]);
    subsort.SortIndex := StrToInt(stlsort[5]);
    subsort.Visible := StrToBool(stlsort[6]);
    if (stlsort.Count > 7) then
      subsort.FooterKind := StrToInt(stlsort[7])
    else
      subsort.FooterKind := 0;
  end
  else
  begin
    subsort.GroupingIndex := -1;
    subsort.SortIndex := -1;
    subsort.Visible := True;
    subsort.FooterKind := 0;
  end;
  Result := subsort;
end;

procedure TbfaApplication.ReadSortings;
var
  i, j, ArcID, arraypos: Integer;
  sort: TSorting;
//11.04.2022  inifile: TIniFile;
  inifile: TMemIniFile;
  cols, sortings, items: TStringList;
//14.10.2021  stdcol, resubcol,
  str: string;
  FoundField, CanAdd : Boolean;
begin
  Log.DebugBegin(llDebug, 'ReadSortings', ClassName);
  try
    cols := TStringList.Create;
    cols.Delimiter := ';';
    cols.StrictDelimiter := True;
    sortings := TStringList.Create;
    sortings.Delimiter := ',';
    sortings.StrictDelimiter := True;
//14.10.2021 als const umgeleitet   stdcol := 'Titel,docname,0,100,-1,-1,True;Benutzer,docusername,0,100,-1,-1,True;Datum,docdate,2,100,-1,-1,True';
//14.10.2021 als const umgeleitet   resubcol := 'Typ,typ,0,25,-1,-1,True;Termin,date,2,100,-1,-1,True;Archiv,arcname,0,100,-1,-1,True;Titel,docname,0,100,-1,-1,True;Info,info,0,100,-1,-1,True;Bearbeiter,user_work,0,100,-1,-1,True;Controller,user_shed,0,100,-1,-1,True;Kommentar,comment,0,100,-1,-1,True';

    if FileExists(BD.AppdataBitfarmPd + 'Sortings.ini') or
       FileExists(ExtractFilePath(Application.ExeName) + 'Sortings.ini') then
    begin
      if FileExists(ExtractFilePath(Application.ExeName) + 'Sortings.ini') then
//11.04.2022        inifile := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'Sortings.ini')
        inifile := TMemIniFile.Create(ExtractFilePath(Application.ExeName) + 'Sortings.ini')
      else
//11.04.2022        inifile := TIniFile.Create(BD.AppdataBitfarmPd + 'Sortings.ini');
        inifile := TMemIniFile.Create(BD.AppdataBitfarmPd + 'Sortings.ini');

      if inifile.SectionExists('Standard') then
        Standardcols.DelimitedText := inifile.ReadString('Standard', 'cols', stdcol)
      else
        Standardcols.DelimitedText := stdcol;

      if inifile.SectionExists('Resub') then
        StandardResubcols.DelimitedText := inifile.ReadString('Resub', 'cols', resubcol)
      else
        StandardResubcols.DelimitedText := resubcol;
    end
    else
    begin
      Standardcols.DelimitedText := stdcol;
      StandardResubcols.DelimitedText := resubcol;
    end;

    SetLength(aColSortings, High(aSysArc) + 1, Standardcols.Count);

    for i := Low(aSysArc) to High(aSysArc) do
    begin
      // Standardspalten hinzufgen
      if i = CurrentResubFields then
      begin
        SetLength(aColSortings[i], StandardResubcols.Count);
        for j := 0 to StandardResubcols.Count - 1 do
        begin
          if StandardResubcols[j] = '' then
            Continue;

          sortings.DelimitedText := StandardResubcols[j];
          sort := GetSortRec(sortings);
          aColSortings[i, j] := sort;
        end;
      end
      else
      begin
        for j := 0 to Standardcols.Count - 1 do
        begin
          if Standardcols[j] = '' then
            Continue;

          sortings.DelimitedText := Standardcols[j];
          sort := GetSortRec(sortings);
          aColSortings[i, j] := sort;
        end;
      end;
    end;

    // Fallback, falls wir keine CurrentResub Archiv haben (sollte nicht vorkommen)
    if (CurrentResubFields = -1) or (CurrentResubFields > High(aSysArc)) then
    begin
      if (CurrentResubFields = -1) then
        CurrentResubFields := High(aSysArc) + 1;

      SetLength(aColSortings, High(aSysArc) + 2, StandardResubcols.Count);

      for j := 0 to StandardResubcols.Count - 1 do
      begin
        if StandardResubcols[j] = '' then
          Continue;
        sortings.DelimitedText := StandardResubcols[j];
        sort := GetSortRec(sortings);
          aColSortings[CurrentResubFields, j] := sort;
      end;
    end;

    CreateResubColumns;

    if Assigned(inifile) then
    begin
      if inifile.SectionExists(SortingsProfile) or inifile.SectionExists('Sortings') then
      begin
        items := TStringList.Create;
        var Version : Integer;  //21.09.2021 Ticket 24736
        Version := 361; //21.09.2021 Ticket 24736
        if inifile.SectionExists(SortingsProfile) then
        begin
          inifile.ReadSection(SortingsProfile, items);
          Version := 362; //21.09.2021 Ticket 24736
        end
        else
          inifile.ReadSection('Sortings', items);

        if items.Count > High(aColSortings) + 1 then
          SetLength(aColSortings, items.Count, Standardcols.Count);

        for i := 0 to items.Count - 1 do
        begin
          try
            if inifile.SectionExists(SortingsProfile) then
            begin
              try
                str := inifile.ReadString(SortingsProfile, items[i], '');
              except
                str := '';
              end;
              cols.DelimitedText := ReplaceStr(str, '"', '');
            end
            else
            begin
              try
                str := inifile.ReadString('Sortings', items[i], '');
              except
                str := '';
              end;
              cols.DelimitedText := ReplaceStr(str, '"', '');
            end;

            if cols.Count > 0 then
            begin
              SetLength(aColSortings[StrToInt(items[i])], cols.Count - 1);
              for j := 0 to cols.Count - 1 do
              begin
                if cols[j] <> '' then
                begin
                  try
                    sortings.DelimitedText := cols[j];

                    //21.09.2021 Ticket 24736 -->
                    //die Erste "Spalter" ist fr die Einstellungen fr Groupingbox, Footer und FilterListe im Archiv
                    if j = 0 then
                    begin
                      if (sortings[0] = 'ArcOptions') then
                      begin
                        aSysArc[i].GroupingBar := StrToBool(sortings[1]);
                        aSysArc[i].Footer := StrToBool(sortings[2]);
                        Continue;
                      end
                      else
                      begin
                        aSysArc[i].GroupingBar := False;
                        aSysArc[i].Footer := False;
                      end;
                    end;
                    //21.09.2021 Ticket 24736 <--

                    if sortings.Count >= 4 then
                    begin
                      ArcID := StrToInt(items[i]);
                      sort := GetSortRec(sortings);
                      arraypos := j;
                      if Version = 361 then
                        arraypos := j + 1 //hier gibt es nich keinen ArcOptions Beschreibung
                      else
                        arraypos := j;
                      aColSortings[ArcID, arraypos - 1] := sort;
                    end;
                  except
                  //
                  end;
                end;
              end;
            end;
          except
            //
          end;
        end;
      end;
    end;
  finally
    if Assigned(inifile) then
      inifile.Free;
    if Assigned(cols) then
      FreeAndNil(cols);
    if Assigned(sortings) then
      FreeAndNil(sortings);
    if Assigned(items) then
      FreeAndNil(items);   //07.08.2017

    Log.DebugEnd(llDebug, 'ReadSortings', ClassName);
  end;

end;

//19.02.2019 Tikcet 18170 -->
procedure TbfaApplication.ReadImportValues;

  function GetRegestryZusFeldData(lslZusFeld, lslZusFeldWert: TstringList; sGProfil: string; iGArcID: Integer): Boolean;
  var
    reg: TRegistry;
    slZusfields: TStringList;
    i: Integer;
  begin
    slZusfields := TStringList.Create;
    reg := TRegistry.Create;
    try
      try
        with reg do
        begin
          RootKey := HKEY_CURRENT_USER;
          OpenKey('Software\bitfarm\Archiv_V3\Importtools\' + sGProfil + '\' + inttostr(iGArcID), True);
          GetValueNames(slZusfields);
          for i := 0 to slZusfields.Count - 1 do
          begin
            lslZusFeld.Add(slZusfields[i]);
            lslZusFeldWert.Add(ReadString(slZusfields[i]));
          end;
        end;
      except
        on e: exception do
        begin
          bitfarmLog.Write(llNormal, ltDebug, 'GetRegestryZusFeldData Fehler beim Laden der Optionen:' + ' ' + e.Message);
        end;
      end;
    finally
      begin
        reg.CloseKey;
        if Assigned(reg) then
          freeandnil(reg);
      end;
    end;
  end;

var
  i, j, arrayidx: Integer;
  inifile: TIniFile;
  impValues: TImportValues;
  cols, values: TStringList;
  newValue, newField: string;
  lmq: TUniQuery;
begin
  Log.DebugBegin(llDebug, 'ReadImportValues', ClassName);
  try
    SetLength(aImportValues, High(aSysArc) + 1, 1);
    cols := TStringList.Create;
    cols.Delimiter := ';';
    cols.StrictDelimiter := True;
    values := TStringList.Create;
    values.Delimiter := ',';
    values.StrictDelimiter := True;

    if FileExists(BD.AppdataBitfarmPd + 'ImportValues.ini') or FileExists(ExtractFilePath(Application.ExeName) + 'ImportValues.ini') then
    begin
//Erst Global
      if FileExists(ExtractFilePath(Application.ExeName) + 'ImportValues.ini') then
      begin
        inifile := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'ImportValues.ini');
        try
          for i := Low(aSysArc) to High(aSysArc) do
          begin
            if (aImportValues[i, 0].Field = '') and inifile.ValueExists('Values', IntToStr(i)) then
            begin
              cols.DelimitedText := inifile.ReadString('Values', IntToStr(i), '');
              if cols.Count > 0 then
              begin
                for j := 0 to cols.Count - 1 do
                begin
                  if cols[j] <> '' then
                  begin
                    SetLength(aImportValues[i], cols.Count - 1);
                    try
                      values.DelimitedText := cols[j];
                      impValues.Field := values[0];
                      newValue := values[1];
//                      newValue := StringReplace(newValue, ',', '', [rfReplaceAll]);
                      newValue := StringReplace(newValue, ';', '', [rfReplaceAll]);
                      newValue := StringReplace(newValue, '|', ';', [rfReplaceAll]);
                      newValue := StringReplace(newValue, '!', ',', [rfReplaceAll]);
                      newValue := Trim(newValue);

                      impValues.Value := newValue;
                      aImportValues[i, j] := impValues;
                    except
                    end;
                  end;
                end;
              end;
            end;
          end;
        finally
          FreeAndNil(inifile);
        end;
      end;


//Dann mit Lokale Einstellungen Ergnzen
      if FileExists(BD.AppdataBitfarmPd + 'ImportValues.ini') then
      begin
        inifile := TIniFile.Create(BD.AppdataBitfarmPd + 'ImportValues.ini');
        try
          for i := Low(aSysArc) to High(aSysArc) do
          begin
            if (aImportValues[i, 0].Field = '') and inifile.ValueExists('Values', IntToStr(i)) then
            begin
              cols.DelimitedText := inifile.ReadString('Values', IntToStr(i), '');
              if cols.Count > 0 then
              begin
                for j := 0 to cols.Count - 1 do
                begin
                  if cols[j] <> '' then
                  begin
                    SetLength(aImportValues[i], cols.Count - 1);
                    try
                      values.DelimitedText := cols[j];
                      impValues.Field := values[0];
                      newValue := values[1];
//                      newValue := StringReplace(newValue, ',', '', [rfReplaceAll]);
                      newValue := StringReplace(newValue, ';', '', [rfReplaceAll]);
                      newValue := StringReplace(newValue, '|', ';', [rfReplaceAll]);
                      newValue := StringReplace(newValue, '!', ',', [rfReplaceAll]);
                      newValue := Trim(newValue);
                      impValues.Value := newValue;
                      aImportValues[i, j] := impValues;
                    except
                    end;
                  end;
                end;
              end;
            end;
          end;
        finally
          FreeAndNil(inifile);
        end;
      end;
    end
    else
    begin
//Sollte aus der Registry gelesen werden (Version 3.5) z.B erste Start
      for i := Low(aSysArc) to High(aSysArc) do
      begin
        cols.Clear;
        values.Clear;
        GetRegestryZusFeldData(cols, values, Profile, aSysArc[i].arcid);
        if (cols.Count > 0) and (cols.Count = values.Count) then
        begin

          lmq := DbCreateQuery;
          try
            arrayidx := 1;
            for j := 0 to cols.Count - 1 do
            begin
              try
                lmq.SQL.Text := 'SELECT * FROM sys_config WHERE name LIKE ' + #39 + cols[j] + '%' + #39 + ';';

                lmq.Execute;
              except
                on e: Exception do
                begin
                  if lmq <> nil then
                    Log.Write(llNormal, ltException, 'Fehler bei ReadImportValues: ' + lmq.SQL.Text, ClassName)
                  else
                    Log.Write(llNormal, ltException, 'Fehler bei ReadImportValues: ' + e.Message, ClassName);
                end;
              end;

              if lmq.RecordCount > 0 then
              begin
                SetLength(aImportValues[i], arrayidx);
                try
                  lmq.First;
                  newField := lmq.FieldByName('value').AsString;
                  newValue := values[j];
//                  newValue := StringReplace(newValue, ',', '', [rfReplaceAll]);
                  newValue := StringReplace(newValue, ';', '', [rfReplaceAll]);
                  newValue := StringReplace(newValue, '|', ';', [rfReplaceAll]);
                  newValue := StringReplace(newValue, '!', ',', [rfReplaceAll]);
                  newValue := Trim(newValue);

                  impValues.Field := newField;
                  impValues.Value := newValue;
                  aImportValues[i, arrayidx - 1] := impValues;
                  inc(arrayidx);
                except
                end;
              end;
            end;
          finally
            lmq.Free;
          end;

        end;
      end;
    end;

  finally
    Log.DebugEnd(llDebug, 'ReadImportValues', ClassName);
    if Assigned(inifile) then
      inifile.Free;
    if Assigned(cols) then
      FreeAndNil(cols);
    if Assigned(values) then
      FreeAndNil(values);
  end;
end;
//19.02.2019 Tikcet 18170 <--

procedure TbfaApplication.ReadStatefieldRights(arcids: TStringList);
var
  i: Integer;
  stateid: Integer;
  maxid: Integer;
  qry: TUniQuery;
begin
  try
    qry := TUniQuery.Create(nil);
    qry.Connection := dmMain.cntMain;
    qry.SQL.Text := 'select max(stateid) as maxid from sys_statefields';
    qry.Execute;
    if qry.RecordCount > 0 then
      maxid := qry.FieldByName('maxid').AsInteger
    else
      Exit;

    if maxid > 0 then
    begin
      SetLength(aStatefieldRights, maxid + 1);
      for i := Low(aStatefieldRights) to High(aStatefieldRights) do
        aStatefieldRights[i] := 0;  //kein Standardrecht mehr, rechte nur ber userid oder Groupid
//         aStatefieldRights[i] := cAddfieldModify;    // Standardrecht modifiy

      // erst nach Basiseintrag abfragen (es wurden Rechte gesetzt, dH Alle haben nur lesen...
      qry.SQL.Text := 'select fieldid, bit_or(rights) from sys_statefieldxs where arcid in (' + arcids.CommaText + ') and (userid = 0 and groupid = 0) group by fieldid';

      qry.Execute;

      if qry.RecordCount > 0 then
      begin
        with qry do
        begin
          First;
          for i := 0 to RecordCount - 1 do
          begin
            if qry.FieldByName('fieldid').AsInteger <= maxid then
              aStatefieldRights[qry.FieldByName('fieldid').AsInteger] := qry.FieldByName('bit_or(rights)').AsInteger;
            Next;
          end;
        end;
      end;

      // dann mit den persnlichen Rechte des Benutzers bzw seiner Gruppen berschreiben (falls vorhanden)
      qry.SQL.Text := 'select fieldid, bit_or(rights) from sys_statefieldxs where arcid in (' + arcids.CommaText + ') and (userid in (' + user.HolidayList.CommaText + ') or (userid = 0 and groupid in(' + user.Grouplist.CommaText + '))) group by fieldid';

      qry.Execute;
      if qry.RecordCount > 0 then
      begin
        with qry do
        begin
          First;
          for i := 0 to RecordCount - 1 do
          begin
            if qry.FieldByName('fieldid').AsInteger <= maxid then
              aStatefieldRights[qry.FieldByName('fieldid').AsInteger] := qry.FieldByName('bit_or(rights)').AsInteger;
            Next;
          end;
        end;
      end;
    end;
  finally
    FreeAndNil(qry);
  end;

end;

procedure TbfaApplication.ReadStatefields;
var
  i: Integer;
  stateid: Integer;
  maxid: Integer;
  qry: TUniQuery;
begin
  try
    // virtuelles Statusfeld mit der ID 0, Bitmask 1: auf Wiedervorlage
    // wird zB fr die Lesezeichen bentigt

    SetLength(aStatefields, 1);
    aStatefields[0] := TbfaStateField.Create;
    aStatefields[0].Id := 0;
    aStatefields[0].Displayname := _('auf Wiedervorlage');
    aStatefields[0].Bitmask := 1;
    aStatefields[0].addfieldid := 0;
    aStatefields[0].Func := 0;
    aStatefields[0].IndexColumnID := 0;
    aStatefields[0].Rights := 1;   //Standard 1= nur lesen 2= write 4= modify

    qry := TUniQuery.Create(nil);
    qry.Connection := dmMain.cntMain;
    qry.SQL.Text := 'select max(stateid) as maxid from sys_statefields';
    qry.Execute;
    if qry.RecordCount > 0 then
      maxid := qry.FieldByName('maxid').AsInteger
    else
      Exit;

    if maxid > 0 then
    begin
      qry.SQL.Text := 'Select stateid, displayname, bitmask, addfieldid, `function`, indexcolumnid, flags +0  from sys_statefields';
      qry.Execute;
      if qry.RecordCount > 0 then
      begin
        with qry do
        begin
          SetLength(aStatefields, maxid + 1);
          First;
          for i := 0 to RecordCount - 1 do
          begin
            stateid := FieldByName('stateid').AsInteger;
            aStatefields[stateid] := TbfaStateField.Create;
            aStatefields[stateid].Id := stateid;
            aStatefields[stateid].Displayname := FieldByName('displayname').AsString;
            aStatefields[stateid].Bitmask := Trunc(FieldByName('Bitmask').AsFloat);
            aStatefields[stateid].addfieldid := FieldByName('addfieldid').AsInteger;
            aStatefields[stateid].Func := FieldByName('function').AsInteger;
            aStatefields[stateid].IndexColumnID := FieldByName('indexcolumnid').AsInteger;
            aStatefields[stateid].Rights := 1;   //Standard 1= nur lesen 2= write 4= modify
            aStatefields[stateid].Flags := FieldByName('flags +0').AsInteger;
            Next;
          end;
        end;
      end;
    end;
  finally
    FreeAndNil(qry);
  end;

end;

procedure TbfaApplication.WriteResubFavs;
var
  i: Integer;
  inifile: TIniFile;
  task: string;
  resub: TResub;
begin
  Log.DebugBegin(llDebug, 'WriteResubFavs', ClassName);
  try
    try
      if FileExists(BD.AppdataBitfarmPd + 'ResubFavs.ini') then
      begin
        Log.Write(llDebug, ltInfo, 'FileExists: ' + BD.AppdataBitfarmPd + 'ResubFavs.ini', ClassName);
        if CopyFile(PWideChar(BD.AppdataBitfarmPd + 'ResubFavs.ini'), PWideChar(BD.AppdataBitfarmPd + 'ResubFavs.bak'), False) then
        begin
          Log.Write(llDebug, ltInfo, 'Copy erfolgreich, delete', ClassName);
          DeleteFile(BD.AppdataBitfarmPd + 'ResubFavs.ini');
          Log.Write(llDebug, ltInfo, BD.AppdataBitfarmPd + 'ResubFavs.ini - DELETED', ClassName);
        end
        else
        begin
          Log.Write(llDebug, ltInfo, 'Copy NICHT erfolgreich', ClassName);
        end;
      end;

      Log.Write(llDebug, ltInfo, 'Create neu ini: ' + BD.AppdataBitfarmPd + 'ResubFavs.ini', ClassName);
      inifile := TIniFile.Create(BD.AppdataBitfarmPd + 'ResubFavs.ini');
      try
        for i := 0 to High(aResubFavs) do
        begin
  //        if aResubFavs[i].Modified then
  //        begin
          resub := aResubFavs[i];
          task := 'Task' + Inttostr(i);
          inifile.WriteString(task, 'name', resub.Name);
          inifile.WriteString(task, 'info', resub.Info);
          inifile.WriteString(task, 'fwdinfo', resub.FwdInfo);
          inifile.WriteInteger(task, 'alarm', resub.Alarm);
          inifile.WriteString(task, 'users', resub.Users);
          inifile.WriteString(task, 'groups', resub.Groups);
          inifile.WriteInteger(task, 'options', resub.Options);
          inifile.WriteInteger(task, 'favicon', resub.FavIcon);
          inifile.WriteInteger(task, 'AdditionalDays', resub.AdditionalDays);
          aResubFavs[i].modified := False;
  //        end;
        end;
      finally
        inifile.UpdateFile;
        Log.Write(llDebug, ltInfo, 'WriteResubFavs', ClassName);
      end;
    except
      Log.Write(llNormal, ltException, 'Ini erstellt: ' + BD.AppdataBitfarmPd + 'ResubFavs.ini', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'WriteResubFavs', ClassName);
  end;
end;

procedure TbfaApplication.RefreshGUIByOption;
var
  i: Integer;
begin
  Log.DebugBegin(llDebug, 'RefreshGUIByOption', ClassName);
  try
    try
      if (frmMainForm.grdResultlistDevExView <> nil) then
        frmMainForm.grdResultlistDevExView.RowColorEvenOdd :=
          bitfarmApp.ViewerOptions.GeneralOptions.RowColorEvenOdd;

      for i := 0 to FPreviewContainer.Containers.Count - 1 do
      begin
        if (FPreviewContainer.Containers[i].Preview <> nil) then
        begin
          if (FPreviewContainer.Containers[i].Preview.HistoryView.grdHistory <> nil) then
          begin
            FPreviewContainer.Containers[i].Preview.HistoryView.grdHistory.RowColorEvenOdd := bitfarmApp.ViewerOptions.GeneralOptions.RowColorEvenOdd;
            {$IFDEF COMMENTGRID}
            FPreviewContainer.Containers[i].Preview.HistoryView.grdHistory.Invalidate;
            {$ELSE}
            FPreviewContainer.Containers[i].Preview.HistoryView.grdHistory.Repaint;
            {$ENDIF}
          end;

          if (FPreviewContainer.Containers[i].Preview.CommentaryView.grdCommentary <> nil) then
          begin
            FPreviewContainer.Containers[i].Preview.CommentaryView.grdCommentary.RowColorEvenOdd := bitfarmApp.ViewerOptions.GeneralOptions.RowColorEvenOdd;
            {$IFDEF COMMENTGRID}
            FPreviewContainer.Containers[i].Preview.CommentaryView.grdCommentary.Invalidate;
            {$ELSE}
            FPreviewContainer.Containers[i].Preview.CommentaryView.grdCommentary.Repaint;
            {$ENDIF}
          end;
        end;
      end;

      if bitfarmApp.ViewerOptions.GeneralOptions.DragDropAsWindows then
        frmMainForm.dftMainForm.DragTypes := [dtCopy, dtMove]
      else
        frmMainForm.dftMainForm.DragTypes := [dtCopy];
    except
      Log.Write(llNormal, ltException, 'RefreshGUIByOption', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'RefreshGUIByOption', ClassName);
  end;
end;

procedure TbfaApplication.WriteHistory(ATHread: TThread; taskid: Integer; gdocid: Int64; value1: Widestring = ''; value2: Widestring = ''; value3: Widestring = '');
var
  SendSocket: TSocketConnection;
  req: TbfaRequest;
  hist: TbfaHistory;
  lst: TList<TbfaBaseObject>;
begin
  try
    hist := TbfaHistory.Create;
    hist.Userid := FUser.ID;
    hist.Gdocid := gdocid;
    hist.Date := Now();
    hist.Taskid := taskid;
    hist.Value1 := value1;
    hist.Value2 := value2;
    hist.Value3 := value3;

    WriteHistory(ATHread, hist);
  finally
    //
  end;
end;

procedure TbfaApplication.WriteHistory(AThread: TThread; hist: TbfaHistory);
var
  SendSocket: TSocketConnection;
  req: TbfaRequest;
  lst: TList<TbfaBaseObject>;
begin
  SendSocket := TSocketConnection.Create(bfaServerNoSSL, bfaServer, bfaServerPort, '');
  try
    SendSocket.CreateComponents;
    if SendSocket.Connect then
    begin
      req := TbfaRequest.Create;
      req.ReqType := 'reqSaveHistory';
      req.UserID := FUser.ID;
      req.Profile := Profile;
      req.Lang := Lang;

      lst := TList<TbfaBaseObject>.Create;
      lst.Add(hist);

      req.Data := lst;

      SendSocket.SendRequestToServer(req);

      req := SendSocket.ReceiveResponse(AThread);
      if req = nil then
        Exit;

      if (req.ReqType = 'respError') or (req.ReqType = 'respAuthError') then
      begin
        BfShowMessage(_('Server meldet Fehler: ') + req.DataString, AThread);
        Exit;
      end;
    end
    else
      bitfarmLog.Write(llDebug, ltInfo, 'Es konnte keine Socketverbindung aufgebaut werden (WriteHistory)');
  finally
    FreeAndNil(lst);
    FreeandNil(hist);
    FreeAndNil(req);
    SendSocket.Disconnect;
    FreeAndNil(SendSocket);
  end;
end;

procedure TbfaApplication.WriteHotSearchOptions;
var
  i: Integer;
  inifile: TIniFile;
  hd: HWND;
begin
  bitfarmLog.DebugBegin(llDebug, 'WriteHotSearchOptions', ClassName);
  try
    try
      inifile := TIniFile.Create(BD.AppdataBitfarmPd + 'HotSearchOptions.ini');
      try
        inifile.WriteInteger(sSysHotSearchOptions, sSysCount, Length(aHotKeys));
        inifile.WriteString(sSysHotSearchOptions, 'Conn', aHotKeyProfil);
        for i := Low(aHotKeys) to High(aHotKeys) do
        begin
          inifile.WriteString(sSysHotSearchOptions, 'Name' + IntToStr(aHotKeys[i].Id), aHotKeys[i].Name);
          inifile.WriteString(sSysHotSearchOptions, 'StoreName' + IntToStr(aHotKeys[i].Id), aHotKeys[i].StoreName);
          inifile.WriteString(sSysHotSearchOptions, 'ArchiveName' + IntToStr(aHotKeys[i].Id), aHotKeys[i].ArchiveName);
          inifile.WriteInteger(sSysHotSearchOptions, 'StoreID' + IntToStr(aHotKeys[i].Id), aHotKeys[i].StoreID);
          inifile.WriteInteger(sSysHotSearchOptions, 'ArchiveID' + IntToStr(aHotKeys[i].Id), aHotKeys[i].ArchiveID);
          inifile.WriteInteger(sSysHotSearchOptions, 'HotKey' + IntToStr(aHotKeys[i].Id), aHotKeys[i].hotkey);
          if aHotKeys[i].ScreenShot then
            inifile.WriteInteger(sSysHotSearchOptions, 'ScreenShot' + IntToStr(aHotKeys[i].Id), 1)
          else
            inifile.WriteInteger(sSysHotSearchOptions, 'ScreenShot' + IntToStr(aHotKeys[i].Id), 0);
          if aHotKeys[i].DocLink then
            inifile.WriteInteger(sSysHotSearchOptions, 'DocLink' + IntToStr(aHotKeys[i].Id), 1)
          else
            inifile.WriteInteger(sSysHotSearchOptions, 'DocLink' + IntToStr(aHotKeys[i].Id), 0);
          inifile.WriteInteger(sSysHotSearchOptions, 'GDocIDSearch' + IntToStr(aHotKeys[i].ID), aHotKeys[i].GDocIDSearch.ToInteger);
          aHotKeys[i].modified := False;
        end;
      finally
        inifile.UpdateFile;
      end;
      try
        hd := FindWindow('bitfarm.hotsearch.V36', nil);
        if hd <> 0 then
          SendMessage(hd, WM_HOTKEY_RELOAD_CONFIG, 0, 0);
      except
        bitfarmLog.Write(llNormal, ltException, 'WriteHotSearchOptions - WM_HOTKEY_RELOAD_CONFIG', ClassName);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'WriteHotSearchOptions', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'WriteHotSearchOptions', ClassName);
  end;
end;

procedure TbfaApplication.WriteSortings;

  function CanSaveColumn(Field: String): Boolean;
  begin
    Result := (Field <> 'gdocid') and (Field <> 'arcid') and (Field <> 'symarcid') and (Field <> 'status') and
            (Field <> 'groupid') and (Field <> 'options') and (Field <> 'userid_work') and (Field <> 'userid_shed') and
            (Field <> 'timid') and (Field <> 'editmode') and (Field <> '');
  end;

var
  i, j: Integer;
  inifile: TMemIniFile;
  str: string;
  col: TcxGridDBColumn;
begin
  Log.DebugBegin(llDebug, 'WriteSortings', ClassName);
  inifile := TMemIniFile.Create(BD.AppdataBitfarmPd + 'Sortings.ini');
  try
    try
      for i := Low(aColSortings) to High(aColSortings) do
      begin
        str := '';
        //21.09.2021 Ticket 24736 -->
        //die sind im Sortings.ini gespeichert als erste Spalter in der Archiv
        str := 'ArcOptions' + ',' +
               BoolToStr(aSysArc[i].GroupingBar, True) + ',' +
               BoolToStr(aSysArc[i].Footer, True);
        //21.09.2021 Ticket 24736 <--

        for j := 0 to High(aColSortings[i]) do
        begin
          if CanSaveColumn(aColSortings[i, j].Field) then
            str := str + ';' +
              #34 + aColSortings[i, j].Title + #34 + ',' + aColSortings[i, j].Field + ',' +
              IntToStr(aColSortings[i, j].SortOrder) + ',' + IntToStr(aColSortings[i, j].Width) +
              ',' + IntToStr(aColSortings[i, j].GroupingIndex) + ',' + IntToStr(aColSortings[i, j].SortIndex) +
              ',' + BoolToStr(aColSortings[i, j].Visible, True) + ',' + IntToStr(aColSortings[i, j].FooterKind);
        end;
        inifile.WriteString(SortingsProfile, IntToStr(i), str);
      end;

      try
        if (frmMainForm.fraFloatingResub <> nil) and (frmMainForm.fraFloatingResub.grdResubResultlistDevExView <> nil) then
        begin
          str := 'ArcOptions' + ',' +
                 BoolToStr(frmMainForm.fraFloatingResub.grdResubResultlistDevExView.OptionsView.GroupByBox, True) +
                 ',' + BoolToStr(frmMainForm.fraFloatingResub.grdResubResultlistDevExView.OptionsView.Footer, True);

          for i := 0 to frmMainForm.fraFloatingResub.grdResubResultlistDevExView.ColumnCount - 1 do
          begin
            col := frmMainForm.fraFloatingResub.grdResubResultlistDevExView.Columns[i];
            if CanSaveColumn(col.DataBinding.FieldName) then
              str := str + ';' +
                #34 + col.Caption + #34 + ',' + col.DataBinding.FieldName + ',' +
                IntToStr(Integer(col.SortOrder)) + ',' + IntToStr(col.Width) + ',' + IntToStr(col.GroupIndex) + ',' +
                IntToStr(col.SortIndex) + ',' + BoolToStr(col.Visible, True) + ',' + IntToStr(Integer(col.Summary.FooterKind));
          end;
          inifile.WriteString(SortingsFloatingResubProfile, IntToStr(bitfarmApp.CurrentResubArchive.Arcid), str);

        end;
      except
        bitfarmLog.Write(llNormal, ltException, 'WriteSortings - FloatingResub', ClassName);
      end;

      inifile.UpdateFile;
    except
      bitfarmLog.Write(llNormal, ltException, 'WriteSortings', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'WriteSortings', ClassName);
      if Assigned(inifile) then
        inifile.Free;
  end;

end;

procedure TbfaApplication.ReadSysArc;
var
  i: Integer;
  curArcid: Integer;
  maxid: Integer;
  qry: TUniQuery;
begin
  try
    qry := TUniQuery.Create(nil);
    qry.Connection := dmMain.cntMain;
    qry.SQL.Text := 'select max(arcid) as maxid from sys_arc';
    qry.Execute;
    if qry.RecordCount > 0 then
      maxid := qry.FieldByName('maxid').AsInteger
    else
      Exit;

    if maxid > 0 then
    begin
      qry.SQL.Text := 'Select arcid, lgrid, arcname, flags +0, type, backpic, options, defdocname,' + ' storageid, (select bit_or(sys_arcxs.rights) from sys_arcxs where (sys_arcxs.userid = ' + IntToStr(user.ID) + ' or (sys_arcxs.userid = 0 and sys_arcxs.groupid in (' + user.GroupList.CommaText + '))) and sys_arcxs.arcid = sys_arc.arcid) as rights from sys_arc where (flags & 2) = 0';
      qry.Execute;
      if qry.RecordCount > 0 then
      begin
        with qry do
        begin
          SetLength(aSysArc, maxid + 1);
          First;
          for i := 0 to RecordCount - 1 do
          begin
            curArcid := FieldByName('arcid').AsInteger;

            aSysArc[curArcid].arcid := curArcid;
            aSysArc[curArcid].Lgrid := FieldByName('lgrid').AsInteger;
            aSysArc[curArcid].Name := FieldByName('arcname').AsString;
            aSysArc[curArcid].Flags := FieldByName('flags +0').AsInteger;
            aSysArc[curArcid].typ := FieldByName('type').AsInteger;
            aSysArc[curArcid].Backpic := FieldByName('backpic').AsString;
            aSysArc[curArcid].options := FieldByName('options').AsInteger;
            aSysArc[curArcid].DefDocname := FieldByName('defdocname').AsString;
            aSysArc[curArcid].Storageid := FieldByName('storageid').AsInteger;
            aSysArc[curArcid].Rights := FieldByName('rights').AsInteger;
            if aSysArc[curArcid].typ = 2 then  // Wiedervorlage Wurzel
            begin
              CurrentResubFields := aSysArc[curArcid].arcid;
              CurrentResubArchive := aSysArc[curArcid];
            end;

            //21.09.2021 Ticket 24736 -->
            //die sind im Sortings.ini gespeichert als erste Spalter in der Archiv
            aSysArc[curArcid].GroupingBar := False;
            aSysArc[curArcid].Footer := False;
            //21.09.2021 Ticket 24736 <--

            Next;
          end;
        end;
      end;
      for i := Low(aSysArc) to High(aSysArc) do
      begin
        if (aSysArc[i].rights and rightRead = rightRead) and (ReadRightsArcids.IndexOf(IntToStr(aSysArc[i].Arcid)) = -1) then
          ReadRightsArcids.Add(IntToStr(aSysArc[i].Arcid));

      end;
    end;
  finally
    FreeAndNil(qry);
  end;
end;

procedure TbfaApplication.SetArcRights(ArcID: Int64);
var
  qry: TUniQuery;
begin
  try
    qry := TUniQuery.Create(nil);
    qry.Connection := dmMain.cntMain;

    qry.SQL.Text := 'Select arcid, lgrid, arcname, flags, type, backpic, options, defdocname,' + ' storageid, (select bit_or(sys_arcxs.rights) from sys_arcxs where (sys_arcxs.userid = ' + IntToStr(user.ID) + ' or (sys_arcxs.userid = 0 and sys_arcxs.groupid in (' + user.GroupList.CommaText + '))) and sys_arcxs.arcid = sys_arc.arcid) as rights from sys_arc ' + 'WHERE sys_arc.arcid = ' + IntToStr(ArcID);
    qry.Execute;
    if qry.RecordCount > 0 then
    begin
      aSysArc[ArcID].Rights := qry.FieldByName('rights').AsInteger;
    end;
  finally
    FreeAndNil(qry);
  end;
end;

procedure TbfaApplication.SetBookmarkNodeImage(AWhereNode, ASelNode: TTreeNode);
begin
  try
    if TObject(ASelNode.Data) is TbfaSearch then
    begin
      if GetRootNode(AWhereNode) = FGlobalListNode then
      begin
        if TbfaSearch(ASelNode.Data).Verify then
        begin
          ASelNode.ImageIndex := Integer(icoidx_bookmark_global_check);
          ASelNode.SelectedIndex := Integer(icoidx_bookmark_global_selected_check);
        end else
        begin
          ASelNode.ImageIndex := Integer(icoidx_bookmark_global);
          ASelNode.SelectedIndex := Integer(icoidx_bookmark_global_selected);
        end
      end else if GetRootNode(AWhereNode) = FLocalListNode then
      begin
        if TbfaSearch(ASelNode.Data).Verify then
        begin
          ASelNode.ImageIndex := Integer(icoidx_bookmark_check);
          ASelNode.SelectedIndex := Integer(icoidx_bookmark_check_selected);
        end else
        begin
          ASelNode.ImageIndex := Integer(icoidx_bookmark);
          ASelNode.SelectedIndex := Integer(icoidx_bookmark_selected);
        end
      end;
    end else
    begin
      if ASelNode.Expanded then
      begin
        ASelNode.ImageIndex := Integer(icoidx_bookmark_folder_expanded);
        ASelNode.SelectedIndex := Integer(icoidx_bookmark_folder_expanded);
      end else
      begin
        ASelNode.ImageIndex := Integer(icoidx_bookmark_folder);
        ASelNode.SelectedIndex := Integer(icoidx_bookmark_folder);
      end;
    end;

    if ASelNode.HasChildren then
    begin
      var ANode: TTreeNode;

      ANode := ASelNode.getFirstChild;
      SetBookmarkNodeImage(AWhereNode, ANode);
      while ANode <> ASelNode.GetLastChild do
      begin
        ANode := ASelNode.GetNextChild(ANode);
        SetBookmarkNodeImage(AWhereNode, ANode);
      end;
    end;

  except
    FLog.Write(llNormal, ltException, 'SetBookmarkNodeImage', ClassName);
  end;
end;

procedure TbfaApplication.SetBugReportEmail;
begin
// Enterprise-Funktion
end;

procedure TbfaApplication.ReadUserlist;
var
  qry: TUniQuery;
  name: string;
begin
  bitfarmLog.DebugBegin(llDebug, 'ReadUserlist', ClassName);
  try
    try
    // frmMainForm.popSearchOption2.Items[0].Checked

      UserList := DBGetUserlist(0, 0, True, True);

      UserListHist := DBGetUserlist(0, 0, True, False, True);
      UserListHist.AddObject('System', TObject(1));

      GroupList := DBGetGrouplist(0, 0);
      GroupList.Sort;

      frmMainForm.cbxSearchUser.compComboBox.Properties.Items.Clear;
      frmMainForm.cbxSearchUser.Comboitems.Clear;

      qry := TUniQuery.Create(nil);
      try
        frmMainForm.cbxSearchUser.compComboBox.StoredItems.Clear;
        qry.Connection := dmMain.cntMain;

        if frmMainForm.popSearchOption2.Items[0].Checked then   // User
        begin
          //31.07.2024 SD -->bfacrm:ticket__show__39499 Der Benutzer "System" sollte immer in der Liste der Benutzer angezeigt werden (fr die Suche)
//          qry.SQL.Text := 'select * from sys_user where FIND_IN_SET(' + #39 + 'enabled' + #39 + ',Flags) > 0 order by displayname, username';
     		  qry.SQL.Text := 'select * from sys_user where FIND_IN_SET(' + #39 + 'enabled' + #39 + ',Flags) > 0 or userid = 1 order by displayname, username';
          //31.07.2024 SD <--bfacrm:ticket__show__39499

          qry.Execute;
          if qry.RecordCount > 0 then
          begin
            qry.First;
            while not qry.Eof do
            begin
              if qry.FieldByName('displayname').AsString <> '' then
                name := qry.FieldByName('displayname').AsString
              else
                name := qry.FieldByName('username').AsString;

              frmMainForm.cbxSearchUser.compComboBox.Properties.Items.AddObject(name, TObject(qry.FieldByName('userid').AsInteger));
              frmMainForm.cbxSearchUser.Comboitems.AddObject(name, TObject(qry.FieldByName('userid').AsInteger));

              qry.Next;
            end;
            frmMainForm.cbxSearchUser.compComboBox.StoredItems.Assign(frmMainForm.cbxSearchUser.Comboitems);
          end;
        end
        else     // Gruppen
        begin
          qry.SQL.Text := 'select * from sys_group order by groupname';
          qry.Execute;
          if qry.RecordCount > 0 then
          begin
            qry.First;
            while not qry.Eof do
            begin
//              frmMainForm.cbxSearchUser.compComboBox.Properties.Items.AddObject(qry.FieldByName('groupname').AsString, TObject(qry.FieldByName('groupid').AsInteger));
//              frmMainForm.cbxSearchUser.Comboitems.AddObject(qry.FieldByName('groupname').AsString, TObject(qry.FieldByName('groupid').AsInteger));
              frmMainForm.cbxSearchUser.compComboBox.Properties.Items.AddObject(TranslateGroupName(qry.FieldByName('groupname').AsString), TObject(qry.FieldByName('groupid').AsInteger));
              frmMainForm.cbxSearchUser.Comboitems.AddObject(TranslateGroupName(qry.FieldByName('groupname').AsString), TObject(qry.FieldByName('groupid').AsInteger));

              qry.Next;
            end;
            frmMainForm.cbxSearchUser.compComboBox.StoredItems.Assign(frmMainForm.cbxSearchUser.Comboitems);

          end;
        end;
      finally
        FreeAndNil(qry);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'ReadUserlist', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ReadUserlist', ClassName);
  end;
end;

function TbfaApplication.ReceiveReqSendUpdates(Files: TStringList; Targetpath,
  Filename: Widestring): Boolean;
begin
  // Enterprise-Funktion
end;

function TbfaApplication.Login(ConFile, Profile, UserName, Password, Key: string): Boolean;
var
  qry: TUniQuery;
  req: TbfaRequest;
  xmlstr: WideString;
  lst: TList<TbfaBaseObject>;
  ini: TIniFile;
  resp: string;
begin
  Profile := LowerCase(Profile);   // Server arbeitet auch nur mit lowercase
  FGlobalKey := Key;
  if FLogInitialized then
  begin
    FLog.Write(llHigh, ltInfo, 'Login', ClassName);

    if ReadConFile(ConFile, Key) then
    begin
      if dmMain.cntMain.Connected then
        dmMain.cntMain.Disconnect;

      // wenn wir den Socket schlieen sollte auch kein Request mehr vom Timer kommen
      if Assigned(frmMainForm.tmrHeartbeat) then
        frmMainForm.tmrHeartbeat.Enabled := False;
      if Assigned(frmMainForm.tmrQueueCount) then
        frmMainForm.tmrQueueCount.Enabled := False;

      if MainSocket <> nil then
      begin
        try
          if bitfarmApp.Autoreconnect then
            bitfarmApp.DisconnectUser;
        except

        end;
        try
          MainSocket.Free;
        Except
          MainSocket := nil;
        end;
      end;

      MainSocket := TSocketConnection.Create(bfaServerNoSSL, bfaServer, bfaServerPort, '');

      MainSocket.CreateComponents;
      MainSocket.Name := 'MainSocket';

      if BD.DevDebug then
        MainSocket.ServerReadTimeout := 300000 //300 Sekunden bei der Entwicklung
      else
        MainSocket.ServerReadTimeout := 30000; //30 Sekunden bei der Anmeldung

      if MainSocket.Connect then
      begin
        req := TbfaRequest.Create;
        try
          req.ReqType := 'reqAuthenticate';
          req.Parameter := UserName;
          req.Profile := Profile;
          req.DataString := EnCrypt(Password, Key);
          req.Lang := Lang;
          MainSocket.SendRequestToServer(req);

          req := MainSocket.ReceiveResponse;
          if req = nil then
          begin
            BfShowMessage(_('Anmeldung am Bitfarm-Server nicht mglich.') + #13 + _('Der Server ist nicht erreichbar.'));
            FLog.Write(llHigh, ltInfo, 'Anmeldung am Bitfarm-Server nicht mglich.' + #13 + 'Der Server ist nicht erreichbar.', ClassName);
            Result := False;
            Exit;
          end;
          if req.ReqType <> 'respAuth' then
          begin
            BfShowMessage(_('Anmeldung am Bitfarm-Server nicht mglich.') + #13 + req.DataString);
            FLog.Write(llHigh, ltInfo, 'Anmeldung am Bitfarm-Server nicht mglich.' + #13 + req.DataString, ClassName);
            Result := False;
            Exit;
          end;

          if req.DataString <> '' then
          begin
            BfShowMessage(req.DataString);
            FLog.Write(llHigh, ltInfo, 'req.DataString:' + req.DataString, ClassName);
          end;

          FUser.ID := req.UserID;
          FUser.Name := UserName;
          FUser.Password := EnCrypt(Password, Key);
          Self.Sid := DeCrypt(req.Sessionid, Key);
          MainSocket.SetSid(Self.Sid);  // nach der Anmeldung setzen wir einmalig die SessionID.
                                        // die SocketKomponenten benutzen dann alle diese
        finally
          FreeAndNil(req);
        end;
      end else
      begin
        BfShowMessage(_('Anmeldung am Bitfarm-Server nicht mglich.') + #13#10 + _('Der Server ist nicht erreichbar.'));
        Result := False;
        Exit;
      end;

      dmMain.cntMain.Connect;
      if dmMain.cntMain.Connected then
      begin
        try
          if not dmMain.cntSearch.Connected then
            dmMain.cntSearch.Connect;
        except
          FLog.Write(llHigh, ltError, 'dmMain.cntSearch.Connect;', ClassName);
        end;

        try
          if not dmMain.cntBackThread.Connected then
            dmMain.cntBackThread.Connect;
        except
          FLog.Write(llHigh, ltError, 'DdmMain.cntBackThread.Connect;', ClassName);
        end;

        try
          if not dmMain.cntResubSearch.Connected then
            dmMain.cntResubSearch.Connect;
        except
          FLog.Write(llHigh, ltError, 'dmMain.cntResubSearch.Connect;', ClassName);
        end;

        FLog.Write(llHigh, ltInfo, 'DB Connected', ClassName);
        bfaCommonDB.my_Con := dmMain.cntMain;

        Result := LoadUser;

        Self.Profile := Profile;
      end else
      begin
        Result := False;
        BfShowMessage(_('Keine Verbindung zur Datenbank mglich'));
        FLog.Write(llNormal, ltError, _('Keine Verbindung zur Datenbank mglich'), ClassName);
      end;

      if Result then
      begin
        emptydocs := TStringList.Create;
        ini := TIniFile.Create(ConFile);
        ini.ReadSection('EmptyDocs', emptydocs);
      end;
    end else
    begin
      Result := False;
      BfShowMessage(_('Fehler beim Lesen der Profil-Datei'));
      FLog.Write(llNormal, ltError, _('Fehler beim Lesen der Profil-Datei'), ClassName);
    end;
  end else
  begin
    Result := False;
  end;
end;

function TbfaApplication.CreateUserAction: PUserAction;
var
  UserAction: PUserAction;
begin
  New(UserAction);
  try
    UserAction^.ActionName := '';
    UserAction^.Documents := TList.Create;
    UserAction^.objects := TList.Create;
    UserAction^.params := TStringList.Create;
    UserAction^.Preview := nil;
    UserAction^.FreeObjects := False; // .Documents
    UserAction^.sList := TStringList.Create;
    UserAction^.options := -1; //02.03.2017
    Result := UserAction;
  except
    Result := nil;
  end;
end;

procedure TbfaApplication.DeleteNode(Node: TTreeNode);
var
  j: Integer;
begin
  if Assigned(Node) then
  begin
    for j := 0 to Node.Count - 1 do
    begin
      if Node[j].HasChildren then
        DeleteNode(Node[j])
      else
      begin
        if TbfaSearch(Node[j].Data) <> nil then
          try
            TbfaSearch(Node[j].Data).Free;
          except
      end;
    end;
  end;
  end;
end;

destructor TbfaApplication.Destroy;
var
  i: Integer;
begin
  try
    FLog.DebugBegin(llDebug, 'TbfaApplication.Destroy', ClassName);
    try

      if not ClosingMainForm then
      begin
        FBackThread.Free;
        FMainThread.Free;
      end;

      FLog.Write(llDebug, ltinfo, 'Threads destroyed', ClassName);

      try
        try
//25.10.2018          FPreviewContainer.Free;
        finally
          FLog.Write(llDebug, ltinfo, 'FPreviewContainer destroyed', ClassName);
        end;
      except
      end;

      try
        try
          FCurrentContainer.Clear;
          FreeAndNil(FCurrentContainer);
        except
        end;
      finally
        FLog.Write(llDebug, ltinfo, 'FCurrentContainer destroyed', ClassName);
      end;

      try
        FloatingForms.Clear;
        FreeAndNil(FloatingForms);
      finally
        FLog.Write(llDebug, ltinfo, 'FloatingForms destroyed', ClassName);
      end;

      if Assigned(FDragObject) then
      begin
        try
//24.10.2018          FDragObject.Free;
        finally
          FLog.Write(llDebug, ltinfo, 'FDragObject destroyed', ClassName);
        end;
      end;

      if Assigned(FScannerProfiles) then
      begin
        FLog.Write(llDebug, ltinfo, 'FScannerProfiles Assigned', ClassName);
        try
          FScannerProfiles.Free;
        finally
          FLog.Write(llDebug, ltinfo, 'FScannerProfiles destroyed', ClassName);
        end;
      end;

      if Assigned(FViewerOptions) then
      begin
        FLog.Write(llDebug, ltinfo, 'FViewerOptions assigned', ClassName);
        try
          FViewerOptions.Free;
        finally
          FLog.Write(llDebug, ltinfo, 'FViewerOptions destroyed', ClassName);
        end;
      end;

      if Assigned(frmMainForm) and Assigned(frmMainForm.trvBookmarks) then
        frmMainForm.trvBookmarks.Visible := False;

      try
        FSearchObj.Free;
      finally
        FLog.Write(llDebug, ltinfo, 'FSearchObj destroyed', ClassName);
      end;
      try
        FSearchProc.Free;
      finally
        FLog.Write(llDebug, ltinfo, 'FSearchProc destroyed', ClassName);
      end;

      FUser.Free;
      FLog.Write(llDebug, ltinfo, 'FUser destroyed', ClassName);

      DeleteCriticalSection(FCreateGrid_CS);
      DeleteCriticalSection(FClearContainer_CS);
      FLog.Write(llDebug, ltinfo, 'CriticalSections destroyed', ClassName);

      dmMain.cntMain.Disconnect;
      dmMain.cntMain.Free;
      dmMain.cntSearch.Disconnect;
      dmMain.cntSearch.Free;
      dmMain.cntBackThread.Disconnect;
      dmMain.cntBackThread.Free;
      dmMain.trnMain.Free;
      dmMain.monUniSQL.Free;
      FLog.Write(llDebug, ltinfo, 'DB Disconnected and destroyed', ClassName);

      if UserList <> nil then
        FreeAndNil(UserList);

      if UserListHist <> nil then
        FreeAndNil(UserListHist);

      if TimidList <> nil then
        FreeAndNil(TimidList);

//25.10.2018
//      DestroyAddFields(aCurrentAddfields);
//      DestroyAddFields(aCurrentViewerAddfields);
//      DestroyAddFields(aCurrentImporterAddfields);
//      DestroyAddFields(aCurrentResubAddfields);
//      DestroyStateFields(aCurrentStatefields);
//      DestroyStateFields(aCurrentViewerStatefields);
//      DestroyStateFields(aCurrentImporterStatefields);
//      DestroyStateFields(aCurrentResubStatefields);
      LanguageNativeNames.Free;
    finally
      FLog.DebugEnd(llDebug, 'TbfaApplication.Destroy', ClassName);
    end;
//06.09.2017    FLog.Free;
  finally
    inherited Destroy;
  end;
end;

procedure TbfaApplication.DestroyAddFields(fields: TList<TbfaAddField>);
var
  i: Integer;
  fld: TbfaAddField;
begin
  try
    try
      for i := fields.Count - 1 downto 0 do
      begin
        fld := fields[i];
        try
          if (fld <> nil) and (fld.ID > 0) and (fld.ID <= aAddfields[High(aAddfields)].Id)  //12.09.2018 wegen CrashLogs eingebaut
            then
          begin
            try
              if fld.Component <> nil then
              begin
                try
                  fld.Component.Free;
                finally
                  fld.Component := nil;
                end;
              end;
            finally
              FreeAndNil(fld);
            end;
          end
          else
            fld := nil;
        except
        end;
      end;
    finally
      fields.Clear;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'DestroyAddFields', ClassName);
  end;
end;

procedure TbfaApplication.DestroyStateFields(fields: TList<TbfaStateField>);
var
  i: Integer;
  fld: TbfaStateField;
begin
  try
    for i := fields.Count - 1 downto 0 do
    begin
      fld := fields[i];
      if (fld <> nil) and (fld.ID > 0) then
      begin
        try
          try
            if fld.Component <> nil then
            begin
              try
                fld.Component.Free;
              finally
                fld.Component := nil;
              end;
            end;
            FreeAndNil(fld);
          finally
            fld := nil;
          end;
        except
          bitfarmLog.Write(llNormal, ltException, 'DestroyStateFields - FreeAndNil(fields[i]); i: ' + IntToStr(i), ClassName);
        end;
      end
      else
        fld := nil;
    end;

    fields.Clear;
  except
    bitfarmLog.Write(llNormal, ltException, 'DestroyStateFields', ClassName);
  end;
end;

procedure TbfaApplication.DisconnectUser;
var
  req: TbfaRequest;
begin
  if MainSocket <> nil then
  begin
    req := TbfaRequest.Create;
    try
      req.ReqType := 'reqDisconnectUser';
      req.UserID := FUser.ID;
      req.Profile := Profile;
      req.Lang := Lang;
      bitfarmLog.Write(llHigh, ltInfo, 'send reqDisconnectUser', ClassName);

      MainSocket.SendRequestToServer(req);
    finally
      FreeAndNil(req);
    end;
  end;
end;

function TbfaApplication.checkholidayloop(liusridsrc, ldusriddst: integer; ldstart, ldend: Tdatetime): boolean;
var
  lmy_q: TUniQuery;
begin
  result := true;
  try
    lmy_q := DbCreateQuery;
    lmy_q.sql.text := 'select * from sys_holiday where userid_src = ' + inttostr(ldusriddst) + ' and ((:mend between start and end)  or (:mstart between start and end) or ' + '(end between :mstart and :mend) or (start between :mstart and :mend))';
    lmy_q.ParamByName('mstart').AsDateTime := ldstart;
    lmy_q.ParamByName('mend').AsDateTime := ldend;
    try
      lmy_q.Execute;

    except
      on e: exception do
      begin
        result := false;
      end;
    end;
    if lmy_q.RecordCount > 0 then
    begin
      while not lmy_q.Eof do
      begin
        if lmy_q.fieldbyname('userid_dst').AsInteger = liusridsrc then
        begin
          result := false;
          break;
        end;
        if not checkholidayloop(liusridsrc, lmy_q.fieldbyname('userid_dst').AsInteger, ldstart, ldend) then
        begin
          result := false;
          break;
        end;
        lmy_q.next;
      end;
    end;
  finally
    if assigned(lmy_q) then
      freeandnil(lmy_q);
  end;
end;

procedure TbfaApplication.SetDelegateTaskControls(var fraResub : TfraResub);
begin
  fraResub.btnDelegateTasks.Checked := True;
  fraResub.btnDropDown.Checked := True;
  fraResub.btnMyTasks.Checked := False;
  fraResub.btnResubForward.Enabled := fraResub.DelegateView <> 3;
  if fraResub.DelegateView = 3 then  //fertig
  begin
    fraResub.btnResubDone.Caption := sCaptionResubDelete;
    fraResub.btnResubDone.Enabled := True;
    frmMainForm.actSaveResub.Enabled := False;
    frmMainForm.actResubCancel.Enabled := False;
    fraResub.btnResubCancel.Enabled := False;
    frmMainForm.actResubDone.Enabled := False;
    fraResub.tbiResubWork.Enabled := False;
  end
  else
  begin
    fraResub.btnResubDone.Caption := sCaptionResubDone;
    fraResub.btnResubDone.Enabled := True;
    frmMainForm.actSaveResub.Enabled := False;
    frmMainForm.actResubCancel.Enabled := False;
    fraResub.btnResubCancel.Enabled := False;
    frmMainForm.actResubDone.Enabled := False;
    fraResub.tbiResubWork.Enabled := False;
  end;
  fraResub.lblDateOrUser.Caption := sCaptionResubEditor;
  fraResub.cbbUserGroups.Visible := True;
  fraResub.cxDateEdit1.Visible := False;
end;

procedure TbfaApplication.SetMyTaskControls(var fraResub : TfraResub);
begin
  fraResub.btnMyTasks.Checked := True;
  fraResub.btnDelegateTasks.Checked := False;
  fraResub.btnDropDown.Checked := False;
  fraResub.btnResubForward.Enabled := fraResub.MyTasksView <> 3;
  if fraResub.MyTasksView = 3 then  //fertig
  begin
    fraResub.btnResubDone.Caption := sCaptionResubDelete;
    frmMainForm.actSaveResub.Enabled := False;
    frmMainForm.actResubCancel.Enabled := False;
    fraResub.btnResubCancel.Enabled := False;
    frmMainForm.actResubDone.Enabled := True;
    fraResub.tbiResubWork.Enabled := False;
  end
  else
  begin
    fraResub.btnResubDone.Caption := sCaptionResubDone;
    frmMainForm.actSaveResub.Enabled := False;
    frmMainForm.actResubCancel.Enabled := True;
    fraResub.btnResubCancel.Enabled := True;
    frmMainForm.actResubDone.Enabled := True;
    fraResub.tbiResubWork.Enabled := True;
  end;
  fraResub.btnResubDone.Enabled := True;
  fraResub.tbiResubWork.Color := cColorWhite;
  fraResub.lblDateOrUser.Caption := _('Datum:');
  fraResub.cbbUserGroups.Visible := False;
  fraResub.cxDateEdit1.Visible := True;
  frmMainForm.actShowCW.Enabled := True;
  frmMainForm.actCWPrevious.Enabled := True;
  frmMainForm.actCWNext.Enabled := True;
  fraResub.btnShowCW.Enabled := frmMainForm.actShowCW.Enabled;
  fraResub.btnCWPrevious.Enabled := frmMainForm.actCWPrevious.Enabled;
  fraResub.btnCWNext.Enabled := frmMainForm.actCWNext.Enabled;
end;

procedure TbfaApplication.DelegateTasks(AThread: TThread);
var
  UserAction: PUserAction;
  i: Integer;
  hd : HWND;
begin
  bitfarmLog.DebugBegin(llDebug, 'DelegateTasks', ClassName);
  try
    try
      if CurrentView <> tvkResub then
      begin
        if AThread <> nil then
          bitfarmApp.SetActiveView(AThread, pvtViewer, nil, Integer(tvkResub))
        else
          bitfarmApp.SetActiveViewAction(pvtViewer, nil, tvkResub);
      end
//22.02.2022      else if ResubKind <> rkController then
      else if frmMainForm.fraResub.ResubKind <> rkController then
      begin
//22.02.2022        ResubKind := rkController;
        frmMainForm.fraResub.ResubKind := rkController;
        CreateGrid(CurrentResubFields, AThread);
      end
      else
      begin
        AThread.Synchronize(nil,
        procedure
        var
          k : Integer;
        begin
          for k := 0 to frmMainForm.grdResultlistDevExView.ColumnCount - 1 do
            if (frmMainForm.grdResultlistDevExView.Columns[k].DataBinding.FieldName = 'user_shed') then
              frmMainForm.grdResultlistDevExView.Columns[k].Visible :=
                (frmMainForm.fraResub.DelegateView = 4);
        end);
      end;

      frmMainForm.grdResultlistDevExView.Kind := gkResubDelegate;
//22.02.2022      ResubKind := rkController;
      frmMainForm.fraResub.ResubKind := rkController;
      frmMainForm.actShowCW.Enabled := False;
      frmMainForm.actCWPrevious.Enabled := False;
      frmMainForm.actCWNext.Enabled := False;

      AThread.Synchronize(nil,
        procedure
        begin
          SetDelegateTaskControls(frmMainForm.fraResub);
        end);
      Reset(AThread);
      DelegateTasksQuery(AThread);

      hd := FindWindow('bitfarm.hotsearch.V36', nil);
      bitfarmLog.Write(llDebug, ltInfo, 'ShowTasks befor sendMessage', ClassName);
      sendMessage(hd, WM_HOTKEY_WVL_MESSAGE, 1, 1);
      bitfarmLog.Write(llDebug, ltInfo, 'ShowTasks after sendMessage', ClassName);
    except
      bitfarmLog.Write(llNormal, ltException, 'DelegateTasks', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'DelegateTasks', ClassName);
  end;

end;

procedure TbfaApplication.DelegateTasksQuery(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'DelegateTasksQuery', ClassName);
  try
    try
      FillDelegateTasksSearch(frmMainForm.fraResub, frmMainForm.grdResultlistDevExView, FSearchObj);
      StartSearchThread(FSearchObj);
    except
      bitfarmLog.Write(llNormal, ltException, 'DelegateTasksQuery', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'DelegateTasksQuery', ClassName);
  end;
end;

procedure TbfaApplication.DeleteAbo(AThread: TThread);
begin

end;

procedure TbfaApplication.DeleteAddfields(AThread: TThread);
var
  comp: TComponent;
  addfieldcomp: TBfaAddfieldComp;
  inifile : TMemIniFile;
begin
  bitfarmLog.DebugBegin(llDebug, 'DeleteAddfields', ClassName);
  try
    try
      if aCurrentAddfields.Count > 0 then
      begin
        for var i := 0 to aCurrentAddfields.Count - 1 do
        begin
          try
            if aCurrentAddfields[i].Component <> nil then  //14.11.2023
            begin
              addfieldcomp := TbfaAddfieldComp(aCurrentAddfields[i].Component);
              if addfieldcomp.AddfieldType = zfld13_Grid then
              begin
                if addfieldcomp.compGrid.ColumnModified then
                begin
                  inifile := TMemIniFile.Create(BD.AppdataBitfarmPd + 'Gridsortings.ini');

  //                if not inifile.SectionExists(IntToStr(FUser.ID)) then
                  var value: string;
                  for var j := 0 to addfieldcomp.compGrid.View.ColumnCount -1 do
                  begin
                    if addfieldcomp.compGrid.View.Columns[j].Caption = 'RecID' then
                      Continue;

                    if value = '' then
                      value := #39 + addfieldcomp.compGrid.View.Columns[j].Caption + #39 + ',' +
                        IntToStr(addfieldcomp.compGrid.View.Columns[j].Width)
                    else
                      value := value + ';'+ #39 + addfieldcomp.compGrid.View.Columns[j].Caption + #39 + ',' +
                        IntToStr(addfieldcomp.compGrid.View.Columns[j].Width)

                  end;
                  inifile.WriteString(IntToStr(FUser.ID), IntToStr(addfieldcomp.FieldID), value);
                  inifile.UpdateFile;

                end;
              end;
            end;

          except
            bitfarmLog.Write(llNormal, ltException, 'DeleteAddfields - Free Comp', ClassName);
          end;
        end;
      end;

      AThread.Synchronize(nil,
        procedure
        begin
          frmMainForm.scrbxViewerAddfields.Hide;
          frmMainForm.scrbxAddfields2.Hide;

          if aCurrentAddfields.Count > 0 then
          begin
            for var i := 0 to aCurrentAddfields.Count - 1 do
            begin
              try
                comp := aCurrentAddfields[i].Component;
                DeleteAddCompFromArray(comp);
                comp := nil;
                try
                  if aCurrentAddfields[i].Component <> nil then
                  begin
                    aCurrentAddfields[i].Component.Free;
                    aCurrentAddfields[i].Component := nil;
                  end;
                finally
                  aCurrentAddfields[i].Component := nil;
                end;
              except
                bitfarmLog.Write(llNormal, ltException, 'DeleteAddfields - Free Comp', ClassName);
              end;
            end;
          end;

          if frmMainForm.scrbxViewerAddfields.ComponentCount > 0 then
          begin
            for var i := frmMainForm.scrbxViewerAddfields.ComponentCount - 1 downto 0 do
            begin
              try
                TbfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).Free;
              finally
                //14.11.2023
              end;
            end;
          end;
          if frmMainForm.scrbxAddfields2.ComponentCount > 0 then
          begin
            for var i := frmMainForm.scrbxAddfields2.ComponentCount - 1 downto 0 do
            begin
              try
                frmMainForm.scrbxAddfields2.Components[i].Free;
              finally
                //14.11.2023
              end;
            end;
          end;
        end);

      if (FPreviewContainer.ActiveItem = FPreviewContainer.ViewerItem.Panel.Tag) and (CurrentView = tvkViewer) then
      begin
        if CurrentArchive.Arcid <> CurrentViewerFields then
        begin
          aCurrentViewerAddfields.Clear;
        end;
      end
      else if (FPreviewContainer.ActiveItem = FPreviewContainer.ViewerItem.Panel.Tag) and (CurrentView = tvkResub) then
      begin
        if CurrentArchive.Arcid <> CurrentResubFields then
        begin
  //        SetLength(aCurrentResubAddfields, 0);
  //          aCurrentResubAddfields.Clear;
        end;
      end
      else if (FPreviewContainer.ActiveItem = FPreviewContainer.ImporterItem.Panel.Tag) and (CurrentView = tvkImporter) then
      begin
        if CurrentArchive.Arcid <> CurrentImporterFields then
        begin
          aCurrentImporterAddfields.Clear;
        end;
      end;

      aCurrentAddfields.Clear;
    except
      bitfarmLog.Write(llNormal, ltException, 'DeleteAddfields', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'DeleteAddfields', ClassName);
  end;
end;

procedure TbfaApplication.DeleteColumnOrder(AThread: TThread);
var
  sort: TSorting;
  sortings: TStringList;
  j: Integer;
begin
  sortings := TStringList.Create;
  try
    //18.08.2021 Ticket 28226 -->
    if FCurrentContainer.Count > 0 then
      Reset(AThread);
    //18.08.2021 Ticket 28226 <--

    //07.03.2022 sollte immer zurckgesetzt sein -->
    bitfarmApp.CurrentArchive.GroupingBar := False;
    bitfarmApp.CurrentArchive.Footer := False;
    if bitfarmApp.CurrentArchive.Arcid = bitfarmApp.CurrentViewerArchive.Arcid then
    begin
      bitfarmApp.CurrentViewerArchive.GroupingBar := False;
      bitfarmApp.CurrentViewerArchive.Footer := False;
    end
    else if bitfarmApp.CurrentArchive.Arcid = bitfarmApp.CurrentResubArchive.Arcid then
    begin
      bitfarmApp.CurrentResubArchive.GroupingBar := False;
      bitfarmApp.CurrentResubArchive.Footer := False;
    end;
    //07.03.2022 <--

    sortings.Delimiter := ',';
    sortings.StrictDelimiter := True;

    if CurrentView = tvkResub then
    begin
      SetLength(aColSortings[CurrentResubFields], 0);
      SetLength(aColSortings[CurrentResubFields], StandardResubcols.Count);
      for j := 0 to StandardResubcols.Count - 1 do
      begin
        if StandardResubcols[j] = '' then
          Continue;
        sortings.DelimitedText := StandardResubcols[j];
        sort.Title := sortings[0];
        sort.Field := sortings[1];
        sort.SortOrder := StrToInt(sortings[2]);
        sort.Width := 100;
        sort.GroupingIndex := -1;
        sort.SortIndex := -1;
        sort.Visible := True;
        sort.FooterKind := 0; //23.09.2021 Ticket 24736
        aColSortings[CurrentResubFields, j] := sort;
      end;
      CreateResubColumns;
      CreateGrid(CurrentResubFields, AThread);
    end
    else
    begin
      SetLength(aColSortings[CurrentFields], 0);
//04.01.2022 Ticket 29539     SetLength(aColSortings[CurrentFields], Standardcols.Count - 1);
      SetLength(aColSortings[CurrentFields], Standardcols.Count);
      // Standardspalten hinzufgen
      for j := 0 to Standardcols.Count - 1 do
      begin
        if Standardcols[j] = '' then
          Continue;

        sortings.DelimitedText := Standardcols[j];
        sort.Title := sortings[0];
        sort.Field := sortings[1];
        sort.SortOrder := StrToInt(sortings[2]);
        sort.Width := 100;
        sort.GroupingIndex := -1;
        sort.SortIndex := -1;
        sort.Visible := True;
        sort.FooterKind := 0; //23.09.2021 Ticket 24736
        aColSortings[CurrentFields, j] := sort;
      end;

      CreateGrid(CurrentFields, AThread);
    end;
  finally
    FreeAndNil(sortings);
  end;
end;

procedure TbfaApplication.DeleteCommentary(UserAction: PUserAction; AThread: TThread);
var
  req: TbfaRequest;
  UAction: PUserAction;
begin

  req := TbfaRequest.Create;
  try
    req.ReqType := 'reqDeleteCommentary';
    req.UserID := user.ID;
    req.Profile := Self.Profile;
    req.Gdocid := StrToInt64(UserAction^.params[0]);
    req.Parameter := UserAction^.params[1];
    req.Lang := Lang;
    MainSocket.SendRequestToServer(req);

    req := MainSocket.ReceiveResponse(AThread);
    if req = nil then
      Exit;

//27.11.2018 Ticket 16957 -->
    if req.ReqType = 'respAuthError' then
    begin
      BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
      UAction := CreateUserAction;
      UAction^.ActionName := 'actRelogin';
      MainThread.Add(UAction);
      Exit;
    end
    else
//27.11.2018 Ticket 16957 <--
if req.ReqType = 'respError' then
    begin
      BfShowMessage(_('Das Lesezeichen konnte nicht gespeichert werden'), AThread);
    end
    else
      FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.CommentaryView.RefreshCommentary;
  finally
    FreeAndNil(req);
  end;
end;

procedure TbfaApplication.DeleteAddCompFromArray(comp: TComponent);
var
  i: Integer;
begin
  try
    for i := 0 to aCurrentAddfields.Count - 1 do
    begin
      if aCurrentAddfields[i] = nil then
        Continue;

      if aCurrentAddfields[i].Component = comp then
      begin
        try
          aCurrentAddfields[i].Component.Free;
        finally
          aCurrentAddfields[i].Component := nil;
        end;
        Break;
      end;
    end;
    for i := 0 to aCurrentViewerAddfields.Count - 1 do
    begin
      if aCurrentViewerAddfields[i] = nil then
        Continue;

      if aCurrentViewerAddfields[i].Component = comp then
      begin
        try
          aCurrentViewerAddfields[i].Component.Free;
        finally
          aCurrentViewerAddfields[i].Component := nil;
        end;
        Break;
      end;
    end;
    for i := 0 to aCurrentImporterAddfields.Count - 1 do
    begin
      if aCurrentImporterAddfields[i] = nil then
        Continue;

      if aCurrentImporterAddfields[i].Component = comp then
      begin
        try
          aCurrentImporterAddfields[i].Component.Free;
        finally
          aCurrentImporterAddfields[i].Component := nil;
        end;
        Break;
      end;
    end;
    for i := 0 to aCurrentResubAddfields.Count - 1 do
    begin
      if aCurrentResubAddfields[i] = nil then
        Continue;

      if aCurrentResubAddfields[i].Component = comp then
      begin
        try
          aCurrentResubAddfields[i].Component.Free;
        finally
          aCurrentResubAddfields[i].Component := nil;
        end;
        Break;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'DeleteAddCompFromArray', ClassName);
  end;
end;

procedure TbfaApplication.DeleteStateCompFromArray(comp: TComponent);
var
  i: Integer;
begin
  try
    //Statefields
    for i := 0 to aCurrentStatefields.Count - 1 do
    begin
      if aCurrentStatefields[i] = nil then
        Continue;

      if aCurrentStatefields[i].Component = comp then
      begin
        try
          aCurrentStatefields[i].Component.Free;
        finally
          aCurrentStatefields[i].Component := nil;
        end;
        Break;
      end;
    end;
    for i := 0 to aCurrentViewerStatefields.Count - 1 do
    begin
      if aCurrentViewerStatefields[i] = nil then
        Continue;

      if aCurrentViewerStatefields[i].Component = comp then
      begin
        try
          aCurrentViewerStatefields[i].Component.Free;
        finally
          aCurrentViewerStatefields[i].Component := nil;
        end;
        Break;
      end;
    end;
    for i := 0 to aCurrentImporterStatefields.Count - 1 do
    begin
      if aCurrentImporterStatefields[i] = nil then
        Continue;

      if aCurrentImporterStatefields[i].Component = comp then
      begin
        try
          aCurrentImporterStatefields[i].Component.Free;
        finally
          aCurrentImporterStatefields[i].Component := nil;
        end;
        Break;
      end;
    end;
    for i := 0 to aCurrentResubStatefields.Count - 1 do
    begin
      if aCurrentResubStatefields[i] = nil then
        Continue;

      if aCurrentResubStatefields[i].Component = comp then
      begin
        try
          aCurrentResubStatefields[i].Component.Free;
        finally
          aCurrentResubStatefields[i].Component := nil;
        end;
        Break;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'DeleteStateCompFromArray', ClassName);
  end;
end;

procedure TbfaApplication.HideSearchDetails(AThread: TThread);
begin
  Log.DebugBegin(llDebug, 'HideSearchDetails', ClassName);
  try
    try
      ClearFields(AThread);

      if FCurrentContainer.Count > 0 then
      begin
        ReloadDocument(FCurrentContainer[0], FCurrentContainer[0].InEditMode, AThread);
        AThread.Synchronize(nil,
          procedure
          begin
            bfaPreview36.ShowAddFields(FCurrentContainer[0]);
            bfaPreview36.ShowStateFields(FCurrentContainer[0]);
            if (CurrentView = tvkResub) then
              ShowResubFields(FCurrentContainer[0], frmMainForm.fraResub);
            //04.09.2024 SD -->bfacrm:ticket__show__39649
            //in den Suchdatumsfeldern knnen nun auch die Suchwerte ausgeblendet werden
            frmMainForm.dteSearch.ClearValue;
            frmMainForm.dteSearch.Value := '';
            DateDeletionSearch := False;
            //bei der Suche nach Lschungsdaten das Lschungsdatum aktualisieren
            if ((CurrentView = tvkViewer) or (CurrentView = tvkResub)) and (frmMainForm.tbiSoExpired.Checked) then
              ShowDocumentProperties(FCurrentContainer[0], GetActivePreview);
            //04.09.2024 SD <--bfacrm:ticket__show__39649
          end);
      end
      else
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            bfaPreview36.ShowAddFields(nil);
            bfaPreview36.ShowStateFields(nil);
            if (CurrentView = tvkResub) then
              ShowResubFields(nil, frmMainForm.fraResub);
            //04.09.2024 SD -->bfacrm:ticket__show__39649
            frmMainForm.dteSearch.ClearValue;
            frmMainForm.dteSearch.Value := '';
            DateDeletionSearch := False;
            //04.09.2024 SD <--bfacrm:ticket__show__39649
          end);
      end;
    except
      Log.Write(llDebug, ltException, 'HideSearchDetails', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'HideSearchDetails', ClassName);
  end;
end;

procedure TbfaApplication.DeleteDoc(AThread: TThread; UserAction: PUserAction);
var
  docs: TStringList;
  i: Integer;
  req: TbfaRequest;
  lmq: TUniQuery;
  res: TModalResult;
  UAction: PUserAction;
begin
  if UserAction^.Documents.Count = 0 then
    Exit;

  Log.DebugBegin(llDebug, 'DeleteDoc', ClassName);
  try
    docs := TStringList.Create;
    docs.Delimiter := ';';
    docs.StrictDelimiter := True;
    docs.QuoteChar := Char(0);
    try
      lmq := DbCreateQuery;
      for i := 0 to UserAction^.Documents.Count - 1 do
      begin
        lmq.SQL.Text := GetInResubSQLText(TbfaDocument(UserAction^.Documents[i]));
        lmq.Execute;

        if (not TbfaDocument(UserAction^.Documents[i]).RevSave) and (not TbfaDocument(UserAction^.Documents[i]).InEditMode) and (TbfaDocument(UserAction^.Documents[i]).CheckOutUserID = -1) and (lmq.RecordCount = 0) then
          docs.Add(IntToStr(TbfaDocument(UserAction^.Documents[i]).Id));
      end;

      if docs.Count <> UserAction^.Documents.Count then
        BfShowMessage(_('Es knnen nicht alle selektierten Dokumente gelscht werden, da diese entweder\nrevisionssicher liegen oder aber in Bearbeitung sind.'), AThread);

      if docs.Count > 0 then
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            res := BfMessageDlg(Format(_('Sie haben %s Dokument(e) zum Lschen markiert.\nMchten Sie die ausgewhlten Dokumente wirklich lschen?'), [IntToStr(docs.Count)]), mtConfirmation, [mbYes, mbNo], True, _('Lschen besttigen'));
          end);

        if res = mrNO then
          Exit;

        req := TbfaRequest.Create;
        try
          req.ReqType := 'reqDeleteDoc';
          req.Parameter := docs.DelimitedText;
          req.UserID := user.ID;
          req.Profile := Self.Profile;
          req.Lang := Lang;

          MainSocket.SendRequestToServer(req);

          req := MainSocket.ReceiveResponse(AThread);
          if req = nil then
            Exit;

//27.11.2018 Ticket 16957 -->
          if req.ReqType = 'respAuthError' then
          begin
            BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
            UAction := CreateUserAction;
            UAction^.ActionName := 'actRelogin';
            MainThread.Add(UAction);
            Exit;
          end
          else
//27.11.2018 Ticket 16957 <--
if req.ReqType = 'respError' then
          begin
            BfShowMessage(_('Fehler beim Lschen.') + #13#10 + req.DataString, AThread);
          end
          else if req.ReqType = 'respOK' then
          begin
            if docs.Count = 1 then
              BfShowMessage(_('Das Dokument wurde gelscht'), AThread)
            else
              BfShowMessage(_('Die Dokumente wurden gelscht'), AThread);

//30.01.2019            RefreshGrid;
            RefreshGrid(AThread);
          end;
        finally
          FreeAndNil(req);
        end;
      end;
    except
      Log.Write(llDebug, ltException, 'DeleteDoc', ClassName);
    end;
  finally
    FreeAndNil(docs);
    Log.DebugEnd(llDebug, 'DeleteDoc', ClassName);
  end;
end;

procedure TbfaApplication.DeleteFromCurrentContainer(gdocid: Int64);
var
  found: Boolean;
  i, j: Integer;
begin
  found := False;
  for i := 0 to FPreviewContainer.Containers.Count - 1 do
  begin
    for j := 0 to FPreviewContainer.Containers[i].Preview.List.Count - 1 do
    begin
      if gdocid = FPreviewContainer.Containers[i].Preview.List[j].Id then
      begin
        found := True;
        Break;
      end;
    end;
  end;

  if not found then
  begin
    for i := FCurrentContainer.Count - 1 downto 0 do
    begin
      if FCurrentContainer[i].Id = gdocid then
      begin
        try
          try
            FCurrentContainer[i].Free;
            FCurrentContainer[i] := nil;
          except
            FCurrentContainer[i] := nil;
          end;
        finally  //17.01.2019
          FCurrentContainer.Delete(i);
        end;
      end;
    end;
  end;
end;

procedure TbfaApplication.DeleteGlobalBookmark(AThread: TThread; SelNode: TTreeNode);
var
  UserAction: PUserAction;
  RNode: TTreeNode;
  userid, groupid: Int64;
begin
  Log.DebugBegin(llDebug, 'DeleteGlobalBookmark', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure

          procedure DeleteOneNode(Nd: TTreeNode);

            procedure delNode(subNode: TTreeNode);
            begin
              if subNode.HasChildren then
                DeleteOneNode(subNode)
              else
              begin
                if subNode.Data <> nil then
                  TObject(subNode.Data).Free;
                subNode.Delete;
              end;
            end;

          var
            i: Integer;
          begin
            if Nd.Count > 0 then
            begin
              for i := Nd.Count - 1 downto 0 do
              begin
                delNode(Nd[i]);
              end;
            end;
            delNode(Nd);
          end;


        begin
          if BfMessageDlg(Format(_('Mchten Sie das globale Lesezeichen "%s" wirklich lschen?'), [SelNode.Text]), mtConfirmation, [mbYes, mbNo], True) = mrYes then
          begin
            RNode := GetRootNode(SelNode);
            userid := TbfaNodeInfo(SelNode.Data).userid;
            groupid := TbfaNodeInfo(SelNode.Data).groupid;
            DeleteOneNode(SelNode);

            UserAction := CreateUserAction;
            UserAction^.ActionName := 'actDeleteGlobalBookmarkRequest';
            UserAction^.params.Add(Format('0;%d;%d', [userid, groupid]));
            FBackThread.Add(UserAction);
          end;
        end);

    except
      Log.Write(llDebug, ltException, 'DeleteGlobalBookmark', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'DeleteGlobalBookmark', ClassName);
  end;
end;

procedure TbfaApplication.DeleteGlobalBookmarkRequest(AThread: TThread; Data: PUserAction);
var
  req: TbfaRequest;
  SendSocket: TSocketConnection;
  UserAction: PUserAction;
begin
  //OutputDebugString('DeleteGlobalBookmarkRequest');
  req := TbfaRequest.Create;
  try
    req.ReqType := 'reqDeleteGlobalBookmark';
    req.UserID := user.ID;
    req.Profile := Self.Profile;
    req.Parameter := Data.Params.Text;  //Typ ,userid, groupid
    req.Lang := Lang;
    SendSocket := TSocketConnection.Create(bfaServerNoSSL, bfaServer, bfaServerPort, '');
    SendSocket.CreateComponents;
    if SendSocket.Connect then
    begin
      SendSocket.SendRequestToServer(req);

      req := SendSocket.ReceiveResponse;
      if req = nil then
        Exit;

  //27.11.2018 Ticket 16957 -->
      if req.ReqType = 'respAuthError' then
      begin
        BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
        UserAction := CreateUserAction;
        UserAction^.ActionName := 'actRelogin';
        MainThread.Add(UserAction);
        Exit;
      end
      else
  //27.11.2018 Ticket 16957 <--
if req.ReqType = 'respError' then
        BfShowMessage(_('Das globale Lesezeichen konnte nicht gelscht werden'), AThread);
    end
    else
      bitfarmLog.Write(llDebug, ltInfo, 'Es konnte keine Socketverbindung aufgebaut werden (DeleteGlobalBookmarkRequest)');
  finally
    FreeAndNil(req);
    SendSocket.DisConnect;
    FreeAndNil(SendSocket);
  end;
end;

procedure TbfaApplication.DeleteLink(AThread: TThread; RefName: string);
var
  i: Integer;
  req: TbfaRequest;
  UserAction: PUserAction;
begin
  req := TbfaRequest.Create;
  try
    req.ReqType := 'reqDeleteLink';
    req.UserID := user.ID;
    req.Profile := Self.Profile;
    req.Parameter := RefName;
    req.Lang := Lang;
    MainSocket.SendRequestToServer(req);

    req := MainSocket.ReceiveResponse(AThread);
    if req = nil then
      Exit;

//27.11.2018 Ticket 16957 -->
    if req.ReqType = 'respAuthError' then
    begin
      BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
      UserAction := CreateUserAction;
      UserAction^.ActionName := 'actRelogin';
      MainThread.Add(UserAction);
      Exit;
    end
    else
//27.11.2018 Ticket 16957 <--
if req.ReqType = 'respError' then
    begin
      BfShowMessage(_('Die Verknpfung konnte nicht gelscht werden'), AThread);
    end
    else
    begin
      bfaProcessing.ReloadLinks(FCurrentContainer[0]);
      FillDocLinkList;
      SetDocState(FCurrentContainer[0]);
    end;

  finally
    FreeAndNil(req);
  end;
end;

procedure TbfaApplication.DeleteSelected(prev: TbfaPreview; SList: TStringList;
  AThread: TThread; Mr: TModalResult = mrNone; WithSplashForm: Boolean = True);
var
  i, j: Integer;
  DocInProc, tmp, found: Boolean;
  Arr: TArray<Integer>;
  Str, msg, XMLFileName, DirName: string;
  DeletedDocs : TStringList; //wegen Abbrechen eingebaut
begin
  Log.DebugBegin(llDebug, 'DeleteSelected', ClassName);
  try
    try
      if (Mr = mrNone) then
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            Mr := BfMessageDlg(_('Mchten Sie die ausgewhlten Dokumente wirklich lschen?'), mtConfirmation, [mbYes, mbNo], True);
          end);
      end;

      if (Mr = mrYes) then
      begin
        if prev.PreviewKind = pvkMultiSingle then
          PreviewBack(AThread, prev);

        DocInProc := False;
        SetLength(Arr, SList.Count);
        for i := 0 to SList.Count - 1 do
          Arr[i] := StrToInt(SList[i]);
        if SList.Count > 1 then
          TArray.Sort<Integer>(Arr);
        if WithSplashForm then
        begin
          msg := _('Dokumente werden gelscht...');
          AThread.Synchronize(nil,
            procedure
            begin
              frmMainForm.frmSplash.lblLoading.Caption := msg;
              frmMainForm.frmSplash.Update;
              frmMainForm.frmSplash.FormType := sftDeleteDocs;
              frmMainForm.frmSplash.UseTimer := True;
              frmMainForm.frmSplash.pgbDocuments.Properties.Min := 0;
              frmMainForm.frmSplash.pgbDocuments.Position := 0;
              frmMainForm.frmSplash.pgbDocuments.Properties.Max := High(Arr) + 1;
              frmMainForm.frmSplash.btnCancel.Enabled := SList.Count > 1;
              frmMainForm.frmSplash.btnCancel.Visible := SList.Count > 1;
              frmMainForm.frmSplash.Show;
            end);
        end;

        DeletedDocs := TStringList.Create;
        bitfarmapp.CancelProcess := False;
        for i := High(Arr) downto Low(Arr) do
        begin
          if WithSplashForm and bitfarmapp.CancelProcess then //Wenn das Process Abbrechen wird
            Break;

          if WithSplashForm then
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                frmMainForm.frmSplash.lblLoading.Caption := msg;
                frmMainForm.frmSplash.lblInfo.Caption := ' (' +
                  IntToStr(High(Arr) - i + 1) + '/' + IntToStr(High(Arr) + 1) + ')';
                frmMainForm.frmSplash.Update;
                if not frmMainForm.frmSplash.Showing then
                  frmMainForm.frmSplash.Show;
              end);
          end;

          j := 0;
          found := False;
          while ((not found) and (j <= FCurrentContainer.Count - 1)) do
          begin
            if prev.List[Arr[i]] = FCurrentContainer[j] then
              found := True
            else
              inc(j);
          end;
          if found then
          begin
            FCurrentContainer.Delete(j);
            DeletedDocs.Add(IntToStr(Arr[i]));
          end;

//16.06.2023 -->
          DirName := GUIDToString(prev.List[Arr[i]].TempID);
          XMLFileName := SysUtils.Format('%.*d', [4, Arr[i]]) + '.xml';
          tmp := bfaCommonImageEN.DeleteDocumentFromList(AThread, prev.List, Arr[i]);
          DocInProc := DocInProc or tmp;
//16.06.2023 <--

          // bfacrm:ticket__show__32561 - Arbeitsplatz auch eingebaut
          if (prev = bitfarmApp.PreviewContainer.ImporterItem.Preview) or
             (prev = bitfarmApp.PreviewContainer.WorkplaceItem.Preview) then
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                try
                  if (prev = bitfarmApp.PreviewContainer.ImporterItem.Preview) then
//16.06.2023                    Str := BD.EnvAppdataImporterPd + GUIDToString(prev.List[Arr[i]].TempID)
                    Str := BD.EnvAppdataImporterPd + DirName
                  else if (prev = bitfarmApp.PreviewContainer.WorkplaceItem.Preview) then
//16.06.2023                    Str := BD.EnvAppdataWorkplacePd + GUIDToString(prev.List[Arr[i]].TempID);
                    Str := BD.EnvAppdataWorkplacePd + DirName;

                  if DirectoryExists(Str) then
//16.06.2023                    bfaCommonFiles.DeleteDirectory(Str);
                    DeleteDirectory(Str);
                except
                  Log.Write(llNormal, ltException, 'Konnte nicht gelscht werden: ' + Str, ClassName);
                end;
                try
                  if (prev = bitfarmApp.PreviewContainer.ImporterItem.Preview) then
//16.06.2023                    Str := BD.EnvAppdataImporterPd + SysUtils.Format('%.*d', [4, Arr[i]]) + '.xml'
                    Str := BD.EnvAppdataImporterPd + XMLFileName
                  else if (prev = bitfarmApp.PreviewContainer.WorkplaceItem.Preview) then
//16.06.2023                    Str := BD.EnvAppdataWorkplacePd + SysUtils.Format('%.*d', [4, Arr[i]]) + '.xml';
                    Str := BD.EnvAppdataWorkplacePd + XMLFileName;

                  if FileExists(Str) then
                    DeleteFile(Str);
                except
                  Log.Write(llNormal, ltException, 'Konnte nicht gelscht werden: ' + Str, ClassName);
                end;
              end);
          end;
//16.06.2023 muss bevor Delete also, frher
//          tmp := bfaCommonImageEN.DeleteDocumentFromList(AThread, prev.List, Arr[i]);
//          DocInProc := DocInProc or tmp;

//16.11.2023 Im Update wird auch aufgerufen
//          AThread.Synchronize(nil,
//            procedure
//            begin
//              frmMainForm.frmSplash.IncProgressBar;
//            end);
        end;

        AThread.Synchronize(nil,
          procedure
          var
            k: Integer;
          begin
            if (frmMainForm.frmSplash.FormType = sftDeleteDocs) and bitfarmapp.CancelProcess then
            begin
              for k := DeletedDocs.Count - 1 downto 0 do
              begin
                prev.MultiView.DeleteImage(StrToInt(DeletedDocs[k]));
                prev.MultiView.Update;
              end;
            end
            else
            begin
              for k := High(Arr) downto Low(Arr) do
              begin
                prev.MultiView.LockPaint; //22.09.2023
                prev.MultiView.DeleteImage(Arr[k]);
                prev.MultiView.UnLockPaint; //22.09.2023
                prev.MultiView.Update;
              end;
            end;

            if DocInProc then
              BfMessageDlg(_('Es konnten nicht alle Dokumente gelscht werden!'), mtWarning, [mbOK]);

//15.12.2023 nochmal raus wegen bfacrm:ticket__show__37266
//            prev.MultiView.Deselect;
//            SetCurrentDocs(nil, nil, prev);
//            ShowDocumentProperties(nil, nil);
//            prev.SetActions;
          end);

        if prev = FPreviewContainer.ImporterItem.Preview then
          SetImporterObjectCount(AThread)
        else if prev = FPreviewContainer.WorkplaceItem.Preview then
          SetWorkplaceObjectCount(AThread);
      end;
    except
      Log.Write(llNormal, ltException, 'DeleteSelected', ClassName);
      if not bitfarmApp.CancelProcess then  //BT 03.05.2021 wird im finally ausgefhrt
      begin
        if prev = FPreviewContainer.ImporterItem.Preview then
          RefreshImporterMultiView(AThread, False)
        else if prev = FPreviewContainer.WorkplaceItem.Preview then
          RefreshWorkplaceMultiView(AThread, False);
      end;
    end;
  finally
    if (FCurrentContainer.Count = 0) and (prev = bitfarmApp.PreviewContainer.ImporterItem.Preview) and (bitfarmApp.PreviewContainer.PageSortingsItem.Panel.Showing) then
      bitfarmApp.CreateHidePageSortingsFrameAction;

    //BT 03.05.2021 Prozesse mssen zurckgesetzt werden und Multiview muss aktualisiert werden  -->
    if bitfarmApp.CancelProcess then
    begin
      for i := 0 to FCurrentContainer.Count - 1 do
        FCurrentContainer[i].SetProcesses(False);

      if prev = FPreviewContainer.ImporterItem.Preview then
        RefreshImporterMultiView(AThread, False)
      else if prev = FPreviewContainer.WorkplaceItem.Preview then
        RefreshWorkplaceMultiView(AThread, False);
    end;
    //BT 03.05.2021 <--

    AThread.Synchronize(nil,
      procedure
      begin
        if WithSplashForm then
        begin
          frmMainForm.frmSplash.UseTimer := False;
          frmMainForm.frmSplash.Hide;
        end;
      end);
    Log.DebugEnd(llDebug, 'DeleteSelected', ClassName);
  end;
end;

procedure TbfaApplication.DeleteStatefields(AThread: TThread);
var
  comp: TComponent;
begin
  bitfarmLog.DebugBegin(llDebug, 'DeleteStatefields', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        var
          i: Integer;
        begin
          frmMainForm.tlbStatefields.Hide;

          if aCurrentStatefields.Count > 0 then
          begin
            for i := 0 to aCurrentStatefields.Count - 1 do

            begin
              comp := aCurrentStatefields[i].Component;
              DeleteStateCompFromArray(comp);
              comp := nil;
              if aCurrentStatefields[i].Component <> nil then
              begin
                try
                  aCurrentStatefields[i].Component.Free;
                finally
                  aCurrentStatefields[i].Component := nil;
                end;
              end;
              aCurrentStatefields[i].Component := nil;
            end;
          end;

          if (FPreviewContainer.ActiveItem = FPreviewContainer.ViewerItem.Panel.Tag) and (CurrentView = tvkViewer) then
          begin
            if CurrentArchive.Arcid <> CurrentViewerFields then
              aCurrentViewerStatefields.Clear;
          end
          else if (FPreviewContainer.ActiveItem = FPreviewContainer.ViewerItem.Panel.Tag) and (CurrentView = tvkResub) then
          begin
            if CurrentArchive.Arcid <> CurrentResubFields then
              aCurrentResubStatefields.Clear;
          end
          else if (FPreviewContainer.ActiveItem = FPreviewContainer.ImporterItem.Panel.Tag) and (CurrentView = tvkImporter) then
          begin
            if CurrentArchive.Arcid <> CurrentImporterFields then
              aCurrentImporterStatefields.Clear;
          end;
          aCurrentStatefields.Clear;
          frmMainForm.tlbStatefields.Items.Clear;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'DeleteStatefields', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'DeleteStatefields', ClassName);
  end;
end;

procedure TbfaApplication.DeScrew(Data: PUserAction; AThread: TThread);
var
  prev: TbfaPreview;
begin
  bitfarmLog.DebugBegin(llDebug, 'DeScrew', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          prev := PUserAction(Data).Preview;
          with PUserAction(Data).Preview.ActiveDoc do
          begin
            StartSaveProcess;
            try
              DoImageCorrection(prev, PUserAction(Data).Preview.ActiveDoc, 1);
            finally
              Modified_Preview := True;
              EndSaveProcess;
            end;
          end;
        end);
      RefreshDocumentInPreviews(AThread,
        PUserAction(Data).Preview.ActiveDoc, prev, nil);
    except
      bitfarmLog.Write(llNormal, ltException, 'DeScrew', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'DeScrew', ClassName);
  end;
end;

procedure TbfaApplication.DeSpeckle(Data: PUserAction; AThread: TThread);
var
  prev: TbfaPreview;
begin
  bitfarmLog.DebugBegin(llDebug, 'DeSpeckle', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          prev := PUserAction(Data).Preview;
          with PUserAction(Data).Preview.ActiveDoc do
          begin
            StartSaveProcess;
            try
              DoImageCorrection(prev, PUserAction(Data).Preview.ActiveDoc, 2);
            finally
              Modified_Preview := True;
              EndSaveProcess;
            end;
          end;
        end);
      RefreshDocumentInPreviews(AThread,
        PUserAction(Data).Preview.ActiveDoc, prev, nil);
    except
      bitfarmLog.Write(llNormal, ltException, 'DeSpeckle', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'DeSpeckle', ClassName);
  end;
end;

procedure TbfaApplication.DoFieldSearch(Field: TbfaAddfieldComp; value: string);
var
  so: TbfaSearch;
  add: TbfaAddField;
  searchproc: TbfaSearchProcessing;
  dsc: TUniDataSource;
  ErrorStr: string;
begin
  so := TbfaSearch.Create;
  searchproc := TbfaSearchProcessing.Create;
  add := TbfaAddField.Create;
  dsc := TUniDataSource.Create(nil);
  try
    add.Name := Field.Fieldname;
    add.DisplayName := Field.Dispname;
    if Field.Value = '' then
    begin
      add.Value := '""';
      add.Negate := True;
    end
    else
      add.Value := '"' + Field.Value + '"';
    add.Modified := True;
    add.IndexTableID := Field.IndexTableID;
    add.Typ := Ord(Field.AddfieldType);
    add.Mode := aAddfields[Field.FieldID].Mode;
    so.AddFields.Add(add);
    so.SelectedCols := add.Name + ':' + IntToStr(Field.IndexTableID);
    so.UserContext := user.ID;
    so.SearchType := 5;
    so.Order := add.Name;
    so.Direction := 'ASC';
    so.UseSearch35 := FUseSearch35;
    if FShowIndexingWithLimit then
    begin
      if CurrentArchive.Typ = 0 then    //lager
      begin
        so.ArcID := GetArcids(CurrentArchive.Arcid, user.ID);
        if so.ArcID.Count = 0 then
          so.ArcID.Add(IntToStr(aSysArc[0].arcid));
      end
      else
        so.ArcID.CommaText := IntToStr(CurrentArchive.Arcid);
    end;
    dsc.DataSet := searchproc.Search(dmMain.cntSearch, so, nil, ErrorStr);

    if dsc.DataSet <> nil then
    begin
      Field.cbxIndexing.Properties.Items.BeginUpdate;
      try
        Field.cbxIndexing.Properties.Items.Clear;
        while not dsc.DataSet.Eof do
        begin
          if dsc.DataSet.FieldByName(add.Name).AsString <> '' then
            Field.cbxIndexing.Properties.Items.Add(dsc.DataSet.FieldByName(add.Name).AsString);

          dsc.DataSet.Next;
        end;
      finally
        Field.cbxIndexing.Properties.Items.EndUpdate;
      end;
      dsc.DataSet.Close;
      if Field.cbxIndexing.Properties.Items.Count = 1 then
      begin
        Field.cbxIndexing.ItemIndex := 0;
        Field.cbxIndexing.Properties.OnChange(nil);
      end
      else
        Field.cbxIndexing.ItemIndex := -1;
    end;
  finally
    FreeAndNil(so);
    FreeAndNil(searchproc);
    FreeAndNil(dsc);
  end;
end;

procedure TbfaApplication.DoIndexing(AThread: TThread);
var
  so: TbfaSearch;
  add: TbfaAddField;
  searchproc: TbfaSearchProcessing;
  dsc: TUniDataSource;
  ErrorStr: string;
begin
  so := TbfaSearch.Create;
  searchproc := TbfaSearchProcessing.Create;
  add := TbfaAddField.Create;
  dsc := TUniDataSource.Create(nil);
  so.UserContext := user.ID;
  so.SearchType := 5;
  so.Direction := 'ASC';
  so.UseSearch35 := FUseSearch35;
  try
    AThread.Synchronize(nil,
      procedure
      var
        i: Integer;
      begin
        for i := 0 to aCurrentAddfields.Count - 1 do
        begin
          if aCurrentAddfields[i].Component.chkIndexing.Checked then
          begin
            add := TbfaAddField.Create;
            add.Name := aCurrentAddfields[i].Component.Fieldname;
            add.DisplayName := aCurrentAddfields[i].Component.Dispname;
            add.Value := aCurrentAddfields[i].Component.Value;
            add.Mode := aCurrentAddfields[i].Mode;
            if aCurrentAddfields[i].Component.IsIndexing then
              add.Value := '"' + add.Value + '"';
            add.Modified := True;
            add.IndexTableID := aCurrentAddfields[i].Component.IndexTableID;
            add.Typ := Ord(aCurrentAddfields[i].Component.AddfieldType);
            so.AddFields.Add(add);
          end
          else
          begin
            if VarIsNull(so.Order) then
              so.Order := aCurrentAddfields[i].Component.Fieldname
            else
              so.Order := so.Order + ',' + aCurrentAddfields[i].Component.Fieldname;
            if VarIsNull(so.SelectedCols) then
              so.SelectedCols := aCurrentAddfields[i].Component.Fieldname + ':' + IntToStr(aCurrentAddfields[i].Component.IndexTableID)
            else
              so.SelectedCols := so.SelectedCols + ',' + aCurrentAddfields[i].Component.Fieldname + ':' + IntToStr(aCurrentAddfields[i].Component.IndexTableID);
            if not aCurrentAddfields[i].Component.Indexing then
              aCurrentAddfields[i].Component.Indexing := True;
          end;
        end;
      end);

    dsc.DataSet := searchproc.Search(dmMain.cntSearch, so, nil, ErrorStr);

    if dsc.DataSet <> nil then
    begin
      AThread.Synchronize(nil,
        procedure
        var
          i: Integer;
        begin
          for i := 0 to aCurrentAddfields.Count - 1 do
          begin
            if not aCurrentAddfields[i].Component.chkIndexing.Checked then
            begin
              aCurrentAddfields[i].Component.ShowIndexingCombo(True);
              aCurrentAddfields[i].Component.cbxIndexing.Properties.Items.BeginUpdate;
              aCurrentAddfields[i].Component.cbxIndexing.Properties.Items.Clear;
              aCurrentAddfields[i].Component.cbxIndexing.ItemIndex := -1;
              aCurrentAddfields[i].Component.cbxIndexing.Text := '';
              // TODO: auf styles umstellen
              aCurrentAddfields[i].Component.cbxIndexing.Color := (*31.08.2020 Farben Anpassung clWhite*)cColorWhite;

              try
                dsc.DataSet.First;
                while not dsc.DataSet.Eof do
                begin
                  if dsc.DataSet.FieldByName(aCurrentAddfields[i].name).AsString <> '' then
                    if aCurrentAddfields[i].Component.cbxIndexing.Properties.Items.IndexOf(dsc.DataSet.FieldByName(aCurrentAddfields[i].name).AsString) = -1 then
                      aCurrentAddfields[i].Component.cbxIndexing.Properties.Items.Add(dsc.DataSet.FieldByName(aCurrentAddfields[i].name).AsString);
                  dsc.DataSet.Next;
                end;
                if aCurrentAddfields[i].Component.cbxIndexing.Properties.Items.Count = 1 then
                begin
                  aCurrentAddfields[i].Component.cbxIndexing.ItemIndex := 0;
                  aCurrentAddfields[i].Component.cbxIndexing.Properties.OnChange(nil);
                end
                else
                  aCurrentAddfields[i].Component.cbxIndexing.ItemIndex := -1;
              finally
                aCurrentAddfields[i].Component.cbxIndexing.Properties.Items.EndUpdate;
              end;
            end;
          end;
          frmMainForm.scrbxViewerAddfields.Update;
        end);
    end;
  finally
    FreeAndNil(so);
    FreeAndNil(searchproc);
    FreeAndNil(dsc);
  end;
end;

procedure TbfaApplication.DoOCRResultToGeneralSearch(AThread: TThread);
var
  mystr: String;
  lmystr: TStrings;
begin
  bitfarmLog.DebugBegin(llDebug, 'DoOCRResultToGeneralSearch', Classname);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          lmystr := GetOCRText;
        end);

      if lmystr = nil then
        Exit;

//      {$IFDEF GetOCRText}
      mystr := lmystr.DelimitedText;
      RemoveMultipleSpaces(mystr);
//      {$ELSE}
//      mystr := lmystr.Text;
//      {$ENDIF}

      Reset(AThread);
      AThread.Synchronize(nil,
        procedure
        begin
          frmMainForm.edtGeneralSearch.Text := ParseNotAllowedChars(mystr);
        end);
      frmMainForm.actSearch.Execute;
    except
      bitfarmLog.Write(llNormal, ltException, 'DoOCRResultToGeneralSearch', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'DoOCRResultToGeneralSearch', Classname);
  end;
end;

procedure TbfaApplication.DoOCRResultToGeneralSearchInTree(AThread: TThread);      //08.05.2024 SD neuer Menpunkt -->bfacrm:ticket__show__38698
var
  mystr: String;
  lmystr: TStrings;
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'DoOCRResultToGeneralSearchInTree', Classname);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          lmystr := GetOCRText;
        end);

      if lmystr = nil then
        Exit;

//      {$IFDEF GetOCRText}
      mystr := lmystr.DelimitedText;
      RemoveMultipleSpaces(mystr);
//      {$ELSE}
//      mystr := lmystr.Text;
//      {$ENDIF}

      Reset(AThread);
      AThread.Synchronize(nil,
        procedure
        begin
          frmMainForm.edtGeneralSearch.Text := ParseNotAllowedChars(mystr);
          UserAction := bitfarmApp.CreateUserAction;
          UserAction^.ActionName := 'actCtrlAltF';
          UserAction^.params.Add('1');
          bitfarmApp.MainThread.Add(UserAction);
        end);
      frmMainForm.actSearch.Execute;
   except
      bitfarmLog.Write(llNormal, ltException, 'DoOCRResultToGeneralSearchInTree', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'DoOCRResultToGeneralSearchInTree', Classname);
  end;
end;

procedure TbfaApplication.DoOCRResultToSearchToolbar(AThread: TThread);
var
  mystr: String;
  lmystr: TStrings;
begin
  bitfarmLog.DebugBegin(llDebug, 'DoOCRResultToSearchToolbar', Classname);
  try
    try
      if bitfarmApp.GetActivePreview = nil then
        Exit;

      AThread.Synchronize(nil,
        procedure
        begin
          lmystr := GetOCRText;
        end);

      if lmystr = nil then
        Exit;

//      {$IFDEF GetOCRText}
      mystr := lmystr.DelimitedText;
      RemoveMultipleSpaces(mystr);
//      {$ELSE}
//      mystr := lmystr.Text;
//      {$ENDIF}

      AThread.Synchronize(nil,
        procedure
        begin
          if not bitfarmApp.GetActivePreview.SearchbarToolbar.Visible then
            bitfarmApp.GetActivePreview.tbi_SearchBar.Click;
          bitfarmApp.GetActivePreview.SearchbarTextEdit.Text := ParseNotAllowedChars(mystr);
          bitfarmApp.GetActivePreview.SearchbarButtonDown.Click;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'DoOCRResultToSearchToolbar', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'DoOCRResultToSearchToolbar', Classname);
  end;
end;

{$IFNDEF DISABLE_HISTORY_FUTURE_DELETE} // SJ 14.07.2023 - bfacrm:ticket__show__35313
procedure TbfaApplication.CheckHistoryNodes(NewHistoryNode: TbfaSearch);
var
  i: Integer;
  UserAction: PUserAction;
begin  // SJ 14.07.2023 - bfacrm:ticket__show__35313
  // wir lschen Verlaufslesezeichen nur, wenn wir eine neue Suche machen
  // bei der auch ein Verlaufslesezeichen angelegt wird. Das sind
  // SearchType [0,1,2] (normal, lokal, global)
  bitfarmLog.DebugBegin(llDebug, 'CheckHistoryNodes', Classname);
  try
    try
      frmMainForm.trvBookmarks.Items.BeginUpdate;

      if (DeleteFutureHistoryNodes <> nil) and (FSearchObj.SearchType in [0,1,2]) then
      begin
        bitfarmLog.Write(llNormal, ltDebug, 'CheckHistoryNodes - HistoryListNode.Count = ' + HistoryListNode.Count.ToString, Classname);

        while HistoryListNode.getFirstChild.Data <> bitfarmApp.DeleteFutureHistoryNodes do
        begin
          HistoryListNode.getFirstChild.Delete;
          SelectFirstHistoryNode := True;
        end;
      end;

      if (NewHistoryNode <> nil) then
      begin
        UserAction := CreateUserAction;
        UserAction^.ActionName := 'actAddToHistoryList';
        UserAction^.Objects.Add(NewHistoryNode);
        MainThread.Add(UserAction);
      end;

      // wir mssen den SearchType zurck setzen, weil sonst nach dem ausfhren von Verlaufslesezeichen
      // Suchen die nach Verlaufslesezeichen wegen .Constructive
      if FSearchObj.SearchType = 3 then
        FSearchObj.SearchType := 0;
    except
      bitfarmLog.Write(llNormal, ltException, 'CheckHistoryNodes', Classname);
    end;
  finally
    frmMainForm.trvBookmarks.Items.EndUpdate;
    bitfarmLog.DebugEnd(llDebug, 'CheckHistoryNodes', Classname);
  end;
end;
{$ENDIF}

procedure TbfaApplication.DuplicateDoc(Data: PUserAction; AThread: TThread);
var
  req: TbfaRequest;
  Gdocids: WideString;
begin
  bitfarmLog.DebugBegin(llDebug, 'DuplicateDoc', ClassName);

  if Data^.Params.Count = 0 then
  begin
    bitfarmLog.Write(llNormal, ltError, 'DuplicateDoc keine Dokumente bergeben', ClassName);
    Exit;
  end;

  try
    try
      req := TbfaRequest.Create;
      try
        req.ReqType := 'reqDuplicateDoc';
        req.UserID := User.ID;
        req.Profile := Self.Profile;

        req.Parameter := Data^.Params.DelimitedText;
        req.Lang := Lang;
        MainSocket.SendRequestToServer(req);

        req := MainSocket.ReceiveResponse;
        if req = nil then
          Exit;

        if (req.ReqType = 'respDuplicateError') or (req.ReqType = 'respError') then
          BfShowMessage(_(req.DataString), AThread)
        else begin
          Gdocids := StringReplace(req.DataString, ';', ',', [rfReplaceAll]);
          DoGDocIDSearch(AThread, 0, False, Gdocids);
        end;
      finally
        FreeAndNil(req);
      end;
    except
      on e: exception do
        bitfarmLog.Write(llNormal, ltException, 'DuplicateDoc' + e.Message, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'DuplicateDoc', ClassName);
  end;
 end;

procedure TbfaApplication.EditHoliday(AThread: TThread);
begin
  // Enterprise-Funktion
end;

procedure TbfaApplication.EditTags(UserAction: PUserAction; AThread: TThread);
var
  mr: TModalResult;
  req: TbfaRequest;
  lst: TStringList;
  UAction: PUserAction;
begin
  AThread.Synchronize(nil,
    procedure
    begin
      frmMainForm.frmTags := TfrmTags.Create(nil);
      try
        frmMainForm.frmTags.mmoTags.Lines.Text := FCurrentContainer[0].DocTags;
        frmMainForm.frmTags.btnOK.Enabled := FCurrentContainer[0].InEditMode and (FCurrentContainer[0].Rights and rightModify = rightModify);
        frmMainForm.frmTags.mmoTags.ReadOnly := not frmMainForm.frmTags.btnOK.Enabled; // bfacrm:ticket__show__24473
        mr := frmMainForm.frmTags.ShowModal;

        if mr = mrCancel then
          Exit;

        req := TbfaRequest.Create;
        lst := TStringList.Create;
        try
          lst.Delimiter := ';';
          lst.StrictDelimiter := True;
          req.ReqType := 'reqSaveTags';
          req.UserID := user.ID;
          req.Profile := Self.Profile;
          UserAction^.params.Delimiter := ',';
          req.Parameter := UserAction^.params.DelimitedText;
          for var i := 0 to frmMainForm.frmTags.mmoTags.Lines.Count - 1 do
            if Trim(frmMainForm.frmTags.mmoTags.Lines[i]) <> '' then
              if lst.IndexOf(Trim(frmMainForm.frmTags.mmoTags.Lines[i])) = -1 then
                lst.Add(Trim(frmMainForm.frmTags.mmoTags.Lines[i]));
          req.DataString := lst.DelimitedText;
          req.Lang := Lang;
          MainSocket.SendRequestToServer(req);

          req := MainSocket.ReceiveResponse(AThread);
          if req = nil then
            Exit;

          if req.ReqType = 'respAuthError' then
          begin
            BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'));
            UAction := CreateUserAction;
            UAction^.ActionName := 'actRelogin';
            MainThread.Add(UAction);
            Exit;
          end
          else if req.ReqType = 'respError' then
            BfShowMessage(_('Fehler beim Speichern.'))
          else if req.ReqType = 'respOK' then
            FCurrentContainer[0].DocTags := frmMainForm.frmTags.mmoTags.Lines.Text;

        finally
          FreeAndNil(req);
          FreeAndNil(lst);
        end;
      finally
        FreeAndNil(frmMainForm.frmTags);
        // SJ 11.11.2021 - nur Free fhrt zu Problem bei Assigned(frmMainForm.frmTags) @ ApplicationEvents1Message
//        frmMainForm.frmTags.Free;
      end;
    end);
end;

function TbfaApplication.SetFileName(Data: PUserAction; i, Typ: Integer; SaveDir: WideString; Doc: TbfaDocument; filelist: TStringList = nil): WideString;
var
  lsext, FileName, tmpfilename: WideString;
  j, k: Integer;
begin
  try
    Result := '';
    if (Data <> nil) and (Data^.params.Count > 11) and (Data^.params[11] <> '') then
    begin
      FileName := Data^.params[11];
      Result := FileName;
    end
    else
    begin
      FileName := '';
      if (Data <> nil) and (TbfaDocument(Data^.Documents[i]).AddFields.Count > 0) then
      begin
        for j := 0 to TbfaDocument(Data^.Documents[i]).AddFields.Count - 1 do
        begin
          if (TbfaDocument(Data^.Documents[i]).AddFields[j].options and 4) = 4 then
          begin
            if not VarIsNull(TbfaDocument(Data^.Documents[i]).AddFields[j].value) then
            begin
              if Result <> '' then
                Result := Result + '_';
              Result := Result + VarToStr(TbfaDocument(Data^.Documents[i]).AddFields[j].value);
            end;
          end;
        end;
      end
      else if (Doc <> nil) and (Doc.AddFields.Count > 0) then
      begin
        if (Doc.AddFields[j].options and 4) = 4 then
        begin
          if not VarIsNull(Doc.AddFields[j].value) then
          begin
            if Result <> '' then
              Result := Result + '_';
            Result := Result + VarToStr(Doc.AddFields[j].value);
          end;
        end;
      end;

      if Result = '' then
      begin
        if (Data <> nil) and (TbfaDocument(Data^.Documents[i]).DocName <> '') then
          Result := TbfaDocument(Data^.Documents[i]).DocName
        else if (Doc <> nil) and (Doc.DocName <> '') then
          Result := Doc.DocName
        else
          Result := 'Dokument';
      end;
    end;

    if FileName = '' then
      Result := ParseFileName(Result);

    // check for existent files and do not overwrite it!
    if Typ = sftTIF then
      lsext := '.tif'
    else if Typ = sftPDF then
      lsext := '.pdf'
    else if Typ = sftORI then
    begin
      if (Data <> nil) and (TbfaDocument(Data^.Documents[i]).FileType <> '') then
        lsext := TbfaDocument(Data^.Documents[i]).FileType
      else if (Doc <> nil) and (Doc.FileType <> '') then
        lsext := Doc.FileType;
    end;

    if FViewerOptions.GeneralOptions.OverwriteLocalSave then
    begin
      tmpfilename := Result + lsext;
      if filelist.IndexOf(tmpfilename) = -1 then
      begin
        Result := tmpfilename;
        filelist.Add(Result)
      end
      else
      begin
        k := 1;
        tmpfilename := Result + '_' + IntToStr(k) + lsext;
        while filelist.IndexOf(tmpfilename) <> -1 do
        begin
          Inc(k);
          tmpfilename := Result + '_' + IntToStr(k) + lsext;
        end;
        Result := tmpfilename;
        filelist.Add(Result);
      end
    end
    else
      Result := CalcNonExistingFilename(SaveDir, Result, lsext) + lsext;
  except
    Result := 'Dokument';
  end;
end;

function TbfaApplication.CreateMailComponent: boolean;
  procedure CreateMailComp;
  begin
    try
      if JvMail1 = nil then
      begin
        JvMail1 := TJvMail.Create(nil);
        JVMail1.SimpleMAPI.Create;

        JvMail1.LogonOptions := [loLogonUI, loNewSession];
        JvMail1.ReadOptions := [roFifo, roPeek];
        JvMail1.LongMsgId := True;
        JvMail1.OnError := JvMail1Error;
      end;
      BuildClientList;
    except
      Log.Write(llNormal, ltException, 'CreateMailComp', ClassName);
    end;
  end;

begin
  Result := False;
  Log.DebugBegin(llDebug, 'CreateMailComponent', ClassName);
  try
    try
      CreateMailComp;
      Result := true;
    except
      JVMail1 := nil;
      Result := false;
      Log.Write(llNormal, ltException, 'CreateMailComponent', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'CreateMailComponent', ClassName);
  end;
end;

procedure TbfaApplication.JvMail1Error(Sender: TJvMail; ErrorCode: cardinal);
begin
  Log.Write(llNormal, ltError, 'Konnte Nachricht nicht senden. Errorcode' + IntToStr(ErrorCode), ClassName);
end;

procedure TbfaApplication.BuildClientList;
var
  I: integer;
  sClients: TStringList;
begin
  Log.DebugBegin(llDebug, 'BuildClientList', ClassName);
  FHasOutlookAsStd := false;
  sClients := TStringList.Create;
  try
    try
      if JVMail1 <> nil then
      begin
        with JvMail1.SimpleMAPI do
        begin
          for I := 0 to ClientCount - 1 do
            sClients.Add(Clients[I].RegKeyName);
          if sClients.Count > 0 then
          begin
            bitfarmLog.Write(llNormal, ltInfo, 'SelectedClientIndex: ' + IntToStr(SelectedClientIndex), ClassName);
            bitfarmLog.Write(llNormal, ltInfo, 'sClients.Count: ' + IntToStr(sClients.Count), ClassName);
            if ((SelectedClientIndex < 0) or (SelectedClientIndex > sClients.Count)) then
            begin
              bitfarmLog.Write(llNormal, ltInfo, 'SelectedClientIndex := 0;', ClassName);
              SelectedClientIndex := 0;
            end;
            for I := 0 to sClients.Count - 1 do
            begin
              bitfarmLog.Write(llNormal, ltInfo, 'i: ' + IntToStr(I), ClassName);
              bitfarmLog.Write(llNormal, ltInfo, 'Lowercase(sClients[i]): ' + Lowercase(sClients[I]), ClassName);
              if (I = SelectedClientIndex) and (Lowercase(sClients[I]) = Lowercase('Microsoft Outlook')) then
                FHasOutlookAsStd := true;
              bitfarmLog.Write(llNormal, ltInfo, 'sClients[' + inttostr(I) + ']:' + sClients[I], ClassName);
            end;

            bitfarmLog.Write(llNormal, ltInfo, 'FHasOutlookAsStd: ' + BoolToStr(FHasOutlookAsStd, True), ClassName);
            I := 0;
            while (I <= sClients.count - 1) and (not FHasOutlookAsStd) do
            begin
              if Lowercase(sClients[I]) = Lowercase('Microsoft Outlook') then
              begin
                FHasOutlookAsStd := true;
              end;
              inc(I);
            end;
            bitfarmLog.Write(llNormal, ltInfo, 'FHasOutlookAsStd: ' + BoolToStr(FHasOutlookAsStd, True), ClassName);
          end;
        end;
      end;
    except
      on e: Exception do
      begin
        bitfarmLog.Write(llNormal, ltException, 'frm_MailForm.BuildClientList ' + e.Message, ClassName);
      end;
    end;
  finally
    FreeAndNil(sClients);
    Log.DebugEnd(llDebug, 'BuildClientList', ClassName);
  end;
end;

procedure TbfaApplication.SendEmail(Data: PUserAction; AThread: TThread);
const
  olMailItem = 0;
  olTo = 1;
  olCC = 2;
  olBCC = 3;
var
  Outlook, Inspector: OLEVariant;
  Item: OleVariant;
  newItem: MailItem;
  objOutlookRecip            // Outlook.Recipient
  : Variant;
  count: integer;
  msg, Mailto: string; //24.06.2019 Ticket 18257
  bExistent, bSent: Boolean;
  myMailItem: Variant;
  Subject: WideString;
  i, emlType: Integer;
  Lst, docs: TStringList;
  req: TbfaRequest;
  hist: TbfaHistory;
  ObjLst: TList<TbfaBaseObject>;

begin
  bitfarmLog.DebugBegin(llDebug, 'SendEmail', 'BackThread');
  FSendingEmail := True;
  try
    try
      try
        Lst := TStringList.Create;
        docs := TStringList.Create;

        emlType := StrToInt(Data^.params[12]);

        for i := 0 to Data^.Documents.Count - 1 do
        begin
          Subject := Subject + TbfaDocument(Data^.Documents[i]).DocName;
          if (Data^.Documents.Count > 1) and (i < Data^.Documents.Count - 1) then
            Subject := Subject + '; ';
          docs.Add(IntToStr(TbfaDocument(Data^.Documents[i]).Id))
        end;

        if not LocalSave(Data, AThread, Lst) then
          Exit;  //14.06.2023

        CoInitialize(nil);
        try
          bExistent := False;

          if not CreateMailComponent then
          begin
            msg := _('E-Mail-Versand nicht mglich!');
            if not FViewerOptions.GeneralOptions.FoundMailClients then
              msg := msg + #13 + _('Es konnte kein registrierter Email-Client gefunden werden.');
            BfShowMessage(msg, AThread);
            bitfarmLog.Write(llNormal, ltError, msg + ' - 1', 'BackThread');
            Exit;
          end;

          if Lst.Count = 0 then
          begin
            BfShowMessage(_('Es wurde kein Dokument zum E-Mail-Versand ausgewhlt.') + #13 +
              _('Um diese Funktion ordnungsgem zu benutzen, muss mindestens') + #13 +
              _('ein Dokument zum E-Mail-Versand ausgewhlt worden sein.'), AThread);
            bitfarmLog.Write(llNormal, ltError, msg, 'BackThread');
            exit;
          end;

          if not OfflineMode then
          begin
            for i := 0 to docs.Count - 1 do
            begin
              if docs[i] = '-1' then
                Continue;   // keine History fr Importer Dokumente

              hist := TbfaHistory.Create;
              hist.Userid := FUser.ID;
              hist.Gdocid := StrToInt(docs[i]);
              hist.Date := Now();
              if emlType = 1 then
                hist.Taskid := 208
              else if emlType = 0 then
                hist.Taskid := 209;
              WriteHistory(AThread, hist);
            end;
          end;

          bitfarmLog.Write(llDebug, ltInfo, 'FHasOutlookAsStd: ' + BoolToStr(FHasOutlookAsStd, True), 'BackThread');
          bitfarmLog.Write(llDebug, ltInfo, 'FViewerOptions.GeneralOptions.OleOutlook: ' + BoolToStr(FViewerOptions.GeneralOptions.OleOutlook, True), 'BackThread');
          if FHasOutlookAsStd and FViewerOptions.GeneralOptions.OleOutlook then
          begin
            try
              bitfarmLog.Write(llDebug, ltInfo, 'GetActiveOleObject(Outlook.Application)', 'BackThread');
              Outlook := GetActiveOleObject('Outlook.Application');
            except
              bitfarmLog.Write(llDebug, ltInfo, 'CreateOleObject(Outlook.Application)', 'BackThread');
              Outlook := CreateOleObject('Outlook.Application');
            end;

            Inspector := Outlook.ActiveInspector;
            bitfarmLog.Write(llDebug, ltInfo, 'Inspector := Outlook.ActiveInspector;', 'BackThread');
            if TVarData(Inspector).VPointer = nil then
            begin
              bitfarmLog.Write(llDebug, ltInfo, 'TVarData(Inspector).VPointer = nil', 'BackThread');
              myMailItem := Outlook.CreateItem(olMailItem);
            end
            else
            begin
              bitfarmLog.Write(llDebug, ltInfo, 'Before TVarData(Inspector).VPointer <> nil', 'BackThread');
              Item := Outlook.ActiveInspector.CurrentItem;
              bSent := Item.Sent;    // nur an neue Mails anhngen, nicht an geffnete empfangene Mails
              if not Supports(Item, MailItem, newItem) or bSent then
                myMailItem := Outlook.CreateItem(olMailItem)
              else
              begin
                myMailItem := Item;
                bExistent := True;
              end;
              bitfarmLog.Write(llDebug, ltInfo, 'After TVarData(Inspector).VPointer <> nil', 'BackThread');
            end;

            if not bExistent then
            begin
              bitfarmLog.Write(llDebug, ltInfo, 'not bExistent', 'BackThread');
              myMailItem.Subject := Subject;
              myMailItem.getinspector;
              myMailItem.HTMLBody := (*BodyEdit.Text + *)myMailItem.HTMLBody;
              count := 0;
            end;

            while count < Lst.Count do
            begin
              myMailItem.Attachments.Add(Lst[count]);
              bitfarmLog.Write(llDebug, ltInfo, 'myMailItem.Attachments.Add(Lst[' + Inttostr(count) + '])', 'BackThread');
              inc(count);
            end;
            try
              myMailItem.display;
              bitfarmLog.Write(llDebug, ltInfo, 'myMailItem.display', 'BackThread');
            finally
              Outlook := Unassigned;
              objOutlookRecip := Unassigned;
            end;
          end
          else
          begin
            bitfarmLog.Write(llDebug, ltInfo, 'JVMail1', 'BackThread');
            if JVMail1 <> nil then
            begin
              bitfarmLog.Write(llDebug, ltInfo, 'JvMail1.Clear;', 'BackThread');
              JvMail1.Clear;
              bitfarmLog.Write(llDebug, ltInfo, 'JvMail1.Recipient.AddRecipient(@);', 'BackThread');
              JvMail1.Recipient.AddRecipient('@');
              bitfarmLog.Write(llDebug, ltInfo, 'JvMail1.Subject := ' + Subject, 'BackThread');
              JvMail1.Subject := Subject;

              try
                count := 0;
                while count < Lst.Count do
                begin
                  if FileExists(Lst[count]) then
                    JvMail1.Attachment.Add(Lst[count]);
                  bitfarmLog.Write(llDebug, ltInfo, 'JvMail1.Attachment.Add(Lst[' + IntToStr(count) + ']);', 'BackThread');
                  inc(count);
                end;
              except
                on e: exception do
                begin
                  Log.Write(llNormal, ltException, 'Error on frm_MailForm.SendBtnClick ' + e.Message, ClassName);
                end;
              end;

              try
                AThread.Synchronize(nil,
                  procedure
                  begin
                    bitfarmLog.Write(llDebug, ltInfo, 'Before JvMail1.SendMail(true);', 'BackThread');
                    JvMail1.SendMail(true); // aufruf des Email Client
                    bitfarmLog.Write(llDebug, ltInfo, 'After JvMail1.SendMail(true);', 'BackThread');
                  end);
              except
                msg := _('E-Mail-Versand nicht mglich!');
                if not FViewerOptions.GeneralOptions.FoundMailClients then
                  msg := msg + #13 + _('Es konnte kein registrierter Email-Client gefunden werden.');
                if FHasOutlookAsStd then
                  msg := msg + #13 + _('Sollten Sie Microsoft Outlook verwenden setzen Sie bitte in den Optionen' + #13 + '"Outlook OLE statt MAPI verwenden"');

                BfShowMessage(msg, AThread);
                bitfarmLog.Write(llNormal, ltError, msg + ' - 2', 'BackThread');
                Exit;
              end;
            end;
          end;

        finally
          CoUninitialize;
          if DirectoryExists(BD.EnvTemp + '\bfa_send\') then
          begin
            if not IsDirectoryEmpty(BD.EnvTemp + '\bfa_send\') then
              EmptyDirectory(BD.EnvTemp + '\bfa_send');
            end;

          if assigned(JvMail1) then
          begin
            try
              FreeAndNil(JvMail1);
            except
            end;
          end;
        end;
      finally
        FreeAndNil(Lst);
        FreeandNil(docs);
      end;
      DeleteDirectory(Data^.params[4]);
    except
      bitfarmLog.Write(llNormal, ltException, 'SendEmail', 'BackThread');
    end;
  finally
    FSendingEmail := False;
    bitfarmLog.DebugEnd(llDebug, 'SendEmail', 'BackThread');
  end
end;

procedure TbfaApplication.EmailAttachment(Data: PUserAction; AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'EmailAttachment', 'BackThread');
  try
    SendEmail(Data, AThread);
  finally
    bitfarmLog.DebugEnd(llDebug, 'EmailAttachment', 'BackThread');
  end;
end;

procedure TbfaApplication.EmailLink(Data: PUserAction; AThread: TThread);
var
  req: TbfaRequest;
  SendSocket: TSocketConnection;
  i: Integer;
  param, body: WideString;
  gdocids: TStringList;
  UserAction: PUserAction;
  prev: TbfaPreview;
begin
  bitfarmLog.DebugBegin(llDebug, 'EmailLink', 'BackThread');

  AThread.Synchronize(nil,
    procedure
    begin
      frmMainForm.frmLinkMails.mmoBody.Text := '';
      frmMainForm.frmLinkMails.edtRecp.Text := '';
      frmMainForm.frmLinkMails.bfsLinkMail.DisableControls := True;
      frmMainForm.frmLinkMails.bfsLinkMail.ClearSelected;
      frmMainForm.frmLinkMails.bfsLinkMail.DisableControls := False;

      // SJ - bfacrm:ticket__show__33571
      prev := bitfarmApp.GetActivePreview;
      if prev <> nil then
      begin
        frmMainForm.mnuEmail.ImageIndex := prev.actEmailLink.ImageIndex;
        frmMainForm.mnuEmail.Action := prev.actEmailLink;
        frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action := prev.actEmailLink;
        prev.bfaTlbStandard.tlbStandardSubmenuItemEmail.Action := prev.actEmailLink;
      end;

      // wir setzen die Tags zurck und dann den korrekten
      // Achtung: nicht prev.actEmailLink sondern frmMainForm.actEmailLink
      frmMainForm.actEmailPDFAttachment.Tag := 0;
      frmMainForm.actEmailTIFAttachment.Tag := 0;
      frmMainForm.actEmailLink.Tag := 1;
      frmMainForm.actEmailOriginal.Tag := 0;
      frmMainForm.actEmailPreview.Tag := 0;
      // SJ - bfacrm:ticket__show__33571

      frmMainForm.frmLinkMails.ShowModal;
    end);

  if (frmMainForm.frmLinkMails.ModalResult = mrOk) and ((frmMainForm.frmLinkMails.bfsLinkMail.ListSelected.Count > 0) or (frmMainForm.frmLinkMails.edtRecp.Text <> '')) then
  begin
    req := TbfaRequest.Create;
    gdocids := TStringList.Create;

    try
      for i := 0 to frmMainForm.frmLinkMails.bfsLinkMail.lvList2.Items.Count - 1 do
      begin
        if TObject(frmMainForm.frmLinkMails.bfsLinkMail.lvList2.Items[i].Data) is TbfaUser then
          param := param + TbfaUser(frmMainForm.frmLinkMails.bfsLinkMail.lvList2.Items[i].Data).Email + ';'
        else if TObject(frmMainForm.frmLinkMails.bfsLinkMail.lvList2.Items[i].Data) is TbfaGroup then
          param := param + TbfaGroup(frmMainForm.frmLinkMails.bfsLinkMail.lvList2.Items[i].Data).Email + ';'
      end;

      if frmMainForm.frmLinkMails.edtRecp.Text <> '' then
        param := param + ParseSQLString(frmMainForm.frmLinkMails.edtRecp.Text) + ';';

      if frmMainForm.frmLinkMails.mmoBody.Text <> '' then
      begin
        body := ParseSQLString(frmMainForm.frmLinkMails.mmoBody.Text);
        body := ReplaceStr(body, #13#10, '\n');
        param := param + 'mailbody:' + body + ';';
      end;
      for i := 0 to FCurrentContainer.Count - 1 do
        if aSysArc[FCurrentContainer[i].ArcID].Rights and rightEmail > 0 then
        gdocids.Add(IntToStr(FCurrentContainer[i].Id));

      param := param + 'gdocid:' + gdocids.CommaText;

      req.ReqType := 'reqLinkMail';
      req.UserID := user.ID;
      req.Profile := Self.Profile;
      req.Gdocid := FCurrentContainer[0].Id;
      req.Parameter := param;
      req.Lang := Lang;

      SendSocket := TSocketConnection.Create(bfaServerNoSSL, bfaServer, bfaServerPort, '');
      SendSocket.CreateComponents;
      if SendSocket.Connect then
      begin
        SendSocket.SendRequestToServer(req);

        req := SendSocket.ReceiveResponse(AThread);
        if req = nil then
          Exit;

        if req.ReqType = 'respAuthError' then
        begin
          BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
          UserAction := CreateUserAction;
          UserAction^.ActionName := 'actRelogin';
          MainThread.Add(UserAction);
          Exit;
        end
        else if req.ReqType = 'respError' then
          BfShowMessage(_('Fehler beim Versenden einer Verknpfungsmail.') + #13#10 + req.DataString, AThread);
      end
      else
        bitfarmLog.Write(llDebug, ltInfo, 'Es konnte keine Socketverbindung aufgebaut werden (EmailLink)');
    finally
      FreeAndNil(req);
      FreeAndNil(gdocids);
      SendSocket.Disconnect;
      FreeAndNil(SendSocket);
    end;
  end;
  bitfarmLog.DebugEnd(llDebug, 'EmailLink', 'BackThread');
end;

procedure TbfaApplication.EmailOriginal(Data: PUserAction; AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'EmailOriginal', 'BackThread');
  try
    SendEmail(Data, AThread);
  finally
    bitfarmLog.DebugEnd(llDebug, 'EmailOriginal', 'BackThread');
  end;
end;

procedure TbfaApplication.EmailPreview(Data: PUserAction; AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'EmailPreview', 'BackThread');
  try
    SendEmail(Data, AThread);
  finally
    bitfarmLog.DebugEnd(llDebug, 'EmailPreview', 'BackThread');
  end;
end;

procedure TbfaApplication.EndHoliday(AThread: TThread);
begin

end;

procedure TbfaApplication.ExportMetaData(ExportType: Integer; UserAction: PUserAction; AThread: TThread);
const
  xlVAlignCenter = -4108;
  xlThin = 2;
  xlEdgeBottom = 9;
  xlDouble = -4119;
  xlThick = 4;
  xl3DColumn = -4100;
  xlColumns = 2;
  xlLocationAsObject = 2;
var
  oXL, oWB, oSheet: Variant;
  HCalc: THojaCalc;
  ColCounter, RowCounter, i, colidx, tmpid: Integer;
  bitMask, DocState: Int64;
  FieldLst, lsst: TStringList;
  lsfname, lstmp, colname, lsnf: string;
  dsc: TDataSource;
  proc: TbfaSearchProcessing;
  addFld: Boolean;
  ErrorStr: string;
begin
  bitfarmLog.DebugBegin(llDebug, 'ExportMetaData', 'BackThread');
  try
    try
      if ExportType = mdeCSV then
      begin
        lsfname := UserAction^.params[0];
        if (lsfname = '') then
          Exit;

        lsst := TStringList.Create;
      end
      else
        CoInitialize(nil);

      try
        FieldLst := TStringList.create;
        dsc := TDataSource.create(nil);
        proc := TbfaSearchProcessing.Create;
        try
          dsc.DataSet := proc.Search(dmMain.cntBackThread, TbfaSearch(UserAction^.objects[0]), nil, ErrorStr);
          if dsc.DataSet.RecordCount > 0 then
          begin
            for i := 0 to dsc.DataSet.FieldDefList.Count - 1 do
             if ((pos('docstate_', dsc.DataSet.FieldDefList[i].name) = 0) and (dsc.DataSet.FieldDefList[i].Name <> 'editmode')) then
              begin
                FieldLst.Add(dsc.DataSet.FieldDefList[i].name);
              end;

            if ExportType = mdeOO then
            begin
              try
                HCalc := THojaCalc.create(thcOpenOffice, true); //OpenOffice doc if possible, please
              except
                on e: exception do
                begin
                  BfShowMessage(_('Export nach OpenOffice nicht mglich. (Ggf. nicht installiert)'), AThread);
                  Exit;
                end;
              end;
              HCalc.FileName := 'F:\MyNewDoc'; //Needs a file name before you SaveDoc!
              HCalc.ActiveSheetName := 'Bitfarm Export';
              //--end of creation.
              //  HCalc.ActivateSheetByIndex(2); //Activate second sheet
              if HCalc.IsActiveSheetProtected then
                ShowMessage('2nd sheet of name "' + HCalc.ActiveSheetName + '" IS protected');
            end
            else if ExportType = mdeXLS then
            begin
              // Start von Excel und Aufrufen eines Anwendungsobjektes
              try
                oXL := CreateOleObject('Excel.Application');
                oXL.Visible := True;
                 //liactiverecord := dm_MainForm2.getactiverecordfromdbgrid(TDBGrid(dbgrd_Trefferliste));
                 // Aufrufen einer neuen Arbeitsmappe
                oWB := oXL.Workbooks.Add;
                oSheet := oWB.ActiveSheet;
              except
                on e: exception do
                begin
                  BfShowMessage(_('Export nach Excel nicht mglich. (Ggf. nicht installiert)'), AThread);
                  Exit;
                end;
              end;
            end;

            ColCounter := 1;

            // Spaltennamen
            for i := 0 to FieldLst.Count - 1 do
              if (pos('docstate_', FieldLst[i]) = 0) then
              begin
                if pos('add_', FieldLst[i]) > 0 then
                begin
                  try
                    colidx := StrToInt(Copy(FieldLst[i], 5, Length(FieldLst[i])));
                    colname := aAddfields[colidx].DisplayName;
                  except
                    colname := FieldLst[i];
                  end;
                end
                else
                  colname := FieldLst[i];

                if ExportType = mdeCSV then
                  lstmp := lstmp + #34 + colname + #34 + ';'
                else if ExportType = mdeOO then
                begin
                  HCalc.CellText[1, ColCounter] := colname;
                  inc(ColCounter);
                end
                else if ExportType = mdeXLS then
                begin
                  oSheet.Cells[1, ColCounter] := colname;
                  inc(ColCounter);
                end;
              end;

            for i := 1 to UserAction^.objects.Count - 1 do
            begin
              if ExportType = mdeCSV then
                lstmp := lstmp + #34 + TbfaStateField(UserAction^.objects[i]).DisplayName + #34 + ';'
              else if ExportType = mdeOO then
              begin
                HCalc.CellText[1, ColCounter] := TbfaStateField(UserAction^.objects[i]).DisplayName;
                inc(ColCounter);
              end
              else if ExportType = mdeXLS then
              begin
                oSheet.Cells[1, ColCounter] := TbfaStateField(UserAction^.objects[i]).DisplayName;
                inc(ColCounter);
              end;
            end;

            if ExportType = mdeCSV then
              lsst.Add(lstmp)
            else
              RowCounter := 2;

            if ExportType = mdeXLS then
            begin
              oSheet.Range[RefToCell(2, 1), RefToCell(2, 1)].Select;
              lsnf := oXL.Selection.NumberFormat;
            end;

            dsc.DataSet.First;
            while not dsc.DataSet.Eof do
            begin
              lstmp := '';
              ColCounter := 1;
              for i := 0 to FieldLst.Count - 1 do
              begin
                if ExportType = mdeCSV then
                  lstmp := lstmp + #34 + dsc.DataSet.FieldByName(FieldLst[i]).AsString + #34 + ';'
                else if ExportType = mdeOO then
                begin
                  HCalc.CellText[RowCounter, ColCounter] := dsc.DataSet.FieldByName(FieldLst[i]).AsString;
                  inc(ColCounter);
                end
                else if ExportType = mdeXLS then
                begin
                  if Lowercase(FieldLst[i]) = 'gdocid' then
                    oSheet.Cells[RowCounter, ColCounter] := '=HYPERLINK("gdocid:' + dsc.DataSet.FieldByName(FieldLst[i]).AsString + '")'
                  else if pos('add_', Lowercase(FieldLst[i])) > 0 then
                  begin
                    try
                      tmpid := StrToInt(Copy(FieldLst[i], 5, Length(FieldLst[i])));
                      oSheet.Range[RefToCell(RowCounter, ColCounter), RefToCell(RowCounter, ColCounter)].Select;
                      if aAddfields[tmpid].Typ = 0 then              // Feldtyp: Universal Ticket 15311
                        oXL.Selection.NumberFormat := AnsiChar('@')  // @ algemeiner Text, AnsiChar-Cast ist zwingend!
                      else if aAddfields[tmpid].Typ = 8 then         // Feldtyp: Whrung
                        oXL.Selection.NumberFormat := '0,00'
                      else
                        oXL.Selection.NumberFormat := lsnf;

                      if dsc.DataSet.FieldByName(FieldLst[i]).AsString <> '' then //wenn nicht geprft ist dann NULL Werte werden als 0 angezeigt
                      begin
                        if aAddfields[tmpid].Typ in [8, 7] then
                          oSheet.Cells[RowCounter, ColCounter] := dsc.DataSet.FieldByName(FieldLst[i]).AsFloat
                        else if aAddfields[tmpid].Typ = 6 then
                          oSheet.Cells[RowCounter, ColCounter] := dsc.DataSet.FieldByName(FieldLst[i]).AsInteger
                        else
                          oSheet.Cells[RowCounter, ColCounter] := dsc.DataSet.FieldByName(FieldLst[i]).AsString;
                      end
                      else
                        oSheet.Cells[RowCounter, ColCounter] := dsc.DataSet.FieldByName(FieldLst[i]).AsString;
                    except
                      bitfarmLog.Write(llNormal, ltException, 'Problem with field: ' + FieldLst[i], ClassName);
                    end;
                  end
                  else
                    oSheet.Cells[RowCounter, ColCounter] := dsc.DataSet.FieldByName(FieldLst[i]).AsString;
                  inc(ColCounter);
                end;
              end;

              for i := 1 to UserAction^.objects.Count - 1 do
              begin
                colidx := TbfaStateField(UserAction^.objects[i]).IndexColumnID;
                bitMask := TbfaStateField(UserAction^.objects[i]).bitMask;
                DocState := dsc.DataSet.FieldByName('docstate_' + IntToStr(colidx)).AsLargeInt;
                if ((DocState and bitMask) = bitMask) then
                begin
                  if ExportType = mdeCSV then
                    lstmp := lstmp + #34 + _('Ja') + #34 + ';'
                  else if ExportType = mdeOO then
                  begin
                    HCalc.CellText[RowCounter, ColCounter] := _('Ja');
                    inc(ColCounter);
                  end
                  else if ExportType = mdeXLS then
                  begin
                    oSheet.Cells[RowCounter, ColCounter] := _('Ja');
                    inc(ColCounter);
                  end;
                end
                else
                begin
                  if ExportType = mdeCSV then
                    lstmp := lstmp + #34 + _('Nein') + #34 + ';'
                  else if ExportType = mdeOO then
                  begin
                    HCalc.CellText[RowCounter, ColCounter] := _('Nein');
                    inc(ColCounter);
                  end
                  else if ExportType = mdeXLS then
                  begin
                    oSheet.Cells[RowCounter, ColCounter] := _('Nein');
                    inc(ColCounter);
                  end;
                end;
              end;

              if ExportType = mdeCSV then
                lsst.Add(lstmp)
              else
                Inc(RowCounter);

              dsc.DataSet.Next;
            end;
          end;
        finally
          FreeAndNil(dsc);
          FreeAndNil(proc);
          FreeAndNil(FieldLst);
        end;

        if ExportType = mdeCSV then
        begin
          try
            lsst.SaveToFile(lsfname);
            AThread.Synchronize(nil,
              procedure
              begin
                frmMainForm.SetNotificationBar(_('Die CSV Datei ist erstellt: ') + lsfname, nil); // SJ 14.08.2019
              end);
          except
            on e: Exception do
            begin
              AThread.Synchronize(nil,
                procedure
                begin
                  frmMainForm.SetNotificationBar(Format(_('Fehler beim speichern der CSV-Datei %s - Fehler: %s'), [lsfname, e.message]), nil); // SJ 14.08.2019
                end);
              bitfarmLog.Write(llNormal, ltException, 'Problem with Saving file csv ' + lsfname + ' Fehler:' + e.message, ClassName);
            end;
          end;
        end;

      finally
        if ExportType = mdeCSV then
          FreeAndNil(lsst)
        else if (ExportType = mdeOO) or (ExportType = mdeXLS) then
          CoUninitialize;
        end;
    except
      bitfarmLog.Write(llNormal, ltException, 'ExportMetaData', 'BackThread');
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ExportMetaData', 'BackThread');
  end;
end;

procedure TbfaApplication.ExportToDB(UserAction: PUserAction; AThread: TThread);
begin
  // -> bfaApplicationEnterprise
end;

function TbfaApplication.ExtendedGroupList(List: TStringList): WideString;
var
  I, J: Integer;
begin
  Result := '';
  try
    if (List <> nil) and (List.Count > 0) then
    begin
      for I := 0 to List.Count - 1 do
      begin
        Result := Result + List[I];
        if (List.Objects[I] <> nil) and (TObject(List.Objects[I]) is TStringList) and
           (TStrings(List.Objects[I]).Count > 0) then
        begin
          Result := Result + ' (';
          for J := 0 to TStringList(List.Objects[I]).Count - 1 do
          begin
            Result := Result + DBGetUserName(TStringList(List.Objects[I])[J].ToInteger, True);
            if J < TStringList(List.Objects[I]).Count - 1 then
              Result := Result + ', ' // nicht letzter Benutzer in Gruppe
            else
              Result := Result + ')'; // letztes Item
          end;
        if I < List.Count - 1 then
          Result := Result + ', '; // nicht letzte Gruppe
        end
      end;
    end;
  except
    Result := '';
    bitfarmLog.Write(llNormal, ltException, 'ExtendedGroupList', ClassName);
  end;
end;

procedure TbfaApplication.GetDoc(Data: PUserAction; AThread: TThread);
var
  Idx: Integer;
  ArcID, GDocID: Int64;
begin
  bitfarmLog.DebugBegin(llDebug, 'GetDoc', ClassName);
  try
    try
      Idx := StrToInt(Data.Params[0]);
      ArcID := MarkedDocs[Idx].ArcID;
      GDocID := MarkedDocs[Idx].GDocID;
      if ((ArcID <> -1) and (GDocID <> -1)) then
      begin
        DocumentSearch(ArcID, GDocID, AThread);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'GetDoc', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'GetDoc', ClassName);
  end;
end;

function TbfaApplication.GetDocLauncher(AThread: TThread): Boolean;
var
  req: TbfaRequest;
  Doc: TbfaDocument;
  UserAction: PUserAction;
begin
  FLog.DebugBegin(llDebug, 'GetDocLauncher', ClassName);
  Result := False;
  AThread.Synchronize(nil,
  procedure
  begin
    frmMainForm.frmSplash.Show;
    frmMainForm.frmSplash.lblLoading.Caption := _('DocLauncher wird geladen.');
    frmMainForm.frmSplash.lblInfo.Caption := _('Lade Pakete...');
    frmMainForm.frmSplash.Update;
  end);

  req := TbfaRequest.Create;
  Doc := TbfaDocument.Create;
  try
    req.ReqType := 'reqSendDocLauncher';
    req.UserID := User.ID;
    req.Profile := Self.Profile;
    req.Gdocid := 0;
    req.Lang := Lang;
    MainSocket.SendRequestToServer(req);

    req := MainSocket.ReceiveDataToFile(Doc, BD.AppdataBitfarmPd + 'bfaDocLauncher.zip', AThread);
    if req = nil then
      Exit;

//27.11.2018 Ticket 16957 -->
    if req.ReqType = 'respAuthError' then
    begin
      BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
      UserAction := CreateUserAction;
      UserAction^.ActionName := 'actRelogin';
      MainThread.Add(UserAction);
      Exit;
    end
    else
//27.11.2018 Ticket 16957 <--
    if req.ReqType = 'respError' then
    begin
      BfShowMessage(req.DataString, AThread);
      Exit;
    end
    else if req.ReqType = 'respDenied' then
    begin
      BfShowMessage(_('Keine Berechtigung.')+ #13#10 + req.DataString, AThread);
      Exit;
    end;

    FreeAndNil(req);

    // entpacken
    AThread.Synchronize(nil,
      procedure
      begin
        frmMainForm.frmSplash.lblInfo.Caption := _('Entpacke Pakete...');
        frmMainForm.frmSplash.Update;
      end);

      with TZipRead.Create(BD.AppdataBitfarmPd + 'bfaDocLauncher.zip') do
      try
        UnZipAll(BD.AppdataBitfarmPd);
      finally
        Free;
      end;

    AThread.Synchronize(nil,
      procedure
      begin
        frmMainForm.frmSplash.Hide;
      end);

   if FileExists(BD.AppdataBitfarmPd + 'bfaDocLauncher\bfaDocLauncher.exe') then
    Result := True;


  finally
    FLog.DebugEnd(llDebug, 'GetDocLauncher', ClassName);
  end;
end;

procedure TbfaApplication.DeleteSymbolicLink(AThread: TThread; SrcDoc: TList<TbfaDocument>);
var
  req: TbfaRequest;
  symlinks: TStringList;
  i: Integer;
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'DeleteSymbolicLink', ClassName);

  symlinks := TStringList.Create;
  symlinks.Delimiter := ';';
  symlinks.StrictDelimiter := True;
  try
    for i := 0 to SrcDoc.Count - 1 do
    begin
      if SrcDoc[i].SymbolicArcID <> -1 then
      begin
        symlinks.Add(IntToStr(SrcDoc[i].Id) + ',' + IntToStr(SrcDoc[i].SymbolicArcID));
      end;
    end;

    if symlinks.Count > 0 then
    begin
      req := TbfaRequest.Create;
      try
        req.ReqType := 'reqDeleteSymbolicLink';
        req.UserID := user.ID;
        req.Profile := Self.Profile;
        req.Parameter := symlinks.DelimitedText;
        req.Lang := Lang;
        MainSocket.SendRequestToServer(req);

        req := MainSocket.ReceiveResponse(AThread);
        if req = nil then
          Exit;

//27.11.2018 Ticket 16957 -->
        if req.ReqType = 'respAuthError' then
        begin
          BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
          UserAction := CreateUserAction;
          UserAction^.ActionName := 'actRelogin';
          MainThread.Add(UserAction);
          Exit;
        end else
//27.11.2018 Ticket 16957 <--
        if req.ReqType = 'respError' then
        begin
          BfShowMessage(_('SymbolicLink konnte nicht gelscht werden.') + #13#10 + req.DataString, AThread);
          Exit;
        end else
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              ShowDocumentProperties(FCurrentContainer[0], FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview);
//30.01.2019              RefreshGrid;
            end);
          RefreshGrid(AThread); // 30.01.2019
        end;
      finally
        FreeAndNil(req);
        Log.DebugEnd(llDebug, 'DeleteSymbolicLink', ClassName);
      end;
    end
    else
    begin
      BfShowMessage(_('In der Auswahl waren keine SymbolicLinks vorhanden.'), AThread);
    end
  finally
    FreeAndNil(symlinks);
  end;
end;

// SJ 01.12.2021 - bfacrm:ticket__show__28712
//procedure TbfaApplication.DoGDocIDSearch(AThread: TThread; GDocID: Int64; WithSymLink: Boolean = False; GDocIDList: WideString = ''; ArcIDs: WideString = '');
procedure TbfaApplication.DoGDocIDSearch(AThread: TThread; GDocID: Int64; WithSymLink: Boolean = False;
  GDocIDList: WideString = ''; ArcIDs: WideString = ''; AutoCheckout: Boolean = False);
var
  found: Boolean;
  j: Integer;
  Col: TColumn;
begin
  bitfarmLog.DebugBegin(llDebug, 'DoGDocIDSearch - GDocID:' + IntToStr(GDocID), ClassName);
  try
    try
      LastDocSearch := True;
      Reset(AThread);
      ShowAllSymLinks := WithSymLink;
      if WithSymLink then
      begin
        found := False;
        try
          for j := 0 to frmMainForm.grdResultlistDevExView.ColumnCount - 1 do
          begin
            if frmMainForm.grdResultlistDevExView.Columns[j].DataBinding.FieldName = 'arcname' then
            begin
              found := True;
              Break;
            end;
          end;

          if not found then
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                frmMainForm.grdResultlistDevExView.CreateDBColumn('arcname', _('Archiv'), 'arcname', '', 150);
              end);
          end;
        except
          on E: Exception do
            bitfarmLog.Write(llNormal, ltException, 'CreateGrid Add column arcname: ' + E.Message, ClassName);
        end;
      end
      else
      begin
        if CurrentArchive.Typ <> 0 then
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              for var k := 0 to frmMainForm.grdResultlistDevExView.ColumnCount - 1 do
                if frmMainForm.grdResultlistDevExView.Columns[k].DataBinding.FieldName = 'arcname' then
                begin
                  frmMainForm.grdResultlistDevExView.Columns[k].Visible := False;
                  Break;
                end;
            end);
        end;
      end;
      FSearchObj.Reset;
      FSearchObj.ID := 1;
      FSearchObj.Name := _('Verlaufs-Lesezeichen');
      FSearchObj.Date := FormatDateTime('dd.mm.yyyy hh:nn:ss', Now);
      FSearchObj.UserContext := FUser.ID;
      FSearchObj.SearchType := 0; // Normale Suche
      FSearchObj.SelectedCols := SetSelectedColumns;
      if FSearchObj.SelectedCols = '' then
        FSearchObj.SelectedCols := 'gdocid';
      if WithSymLink then
      begin
        if pos('arcname', FSearchObj.SelectedCols) = 0 then
          FSearchObj.SelectedCols := FSearchObj.SelectedCols + ', arcname';
      end;
      if GDocIDList <> '' then
        FSearchObj.GdocID.CommaText := GDocIDList
      else
        FSearchObj.GdocID.Add(IntToStr(GDocID));
      FsearchObj.GdocIDWithSymLink := WithSymLink;

      if ArcIDs <> '' then
        FSearchObj.ArcID.CommaText := ArcIDs;

      SetSearchOrder(FSearchObj, frmMainForm.grdResultlistDevExView); //BT 26.06.2024 wegen Strg+A Strg+U

      StartSearchThread(FSearchObj, nil, AutoCheckout); // SJ 01.12.2021 - bfacrm:ticket__show__28712
    except
      bitfarmLog.Write(llNormal, ltException, 'DoGDocIDSearch - GDocID:' + IntToStr(GDocID), ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'DoGDocIDSearch - GDocID:' + IntToStr(GDocID), ClassName);
  end;
end;

procedure TbfaApplication.DoHeartBeat(AThread: TThread);
var
  req: TbfaRequest;
  sock: TSocketConnection;
begin
  if OriginalfileLock or FSkipDoQueueCount then
    Exit;

  bitfarmApp.Log.DebugBegin(llDebug, 'DoHeartBeat', ClassName);
  sock := TSocketConnection.Create(bfaServerNoSSL, bfaServer, bfaServerPort, '');
  sock.CreateComponents;
  try
    if sock.Connect then
    begin
      req := TbfaRequest.Create;
      try
        req.ReqType := 'reqHeartBeat';
        req.UserID := FUser.ID;
        req.Profile := Profile;
        req.Lang := Lang;
        FLog.Write(llHigh, ltInfo, 'send reqHeartBeat', ClassName);

        sock.SendRequestToServer(req);
      finally
        FreeAndNil(req);
        FreeAndNil(sock);
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'Fehler bei DoHeartBeat, Socket konnte nicht verbunden werden', ClassName);
  end;
  bitfarmApp.Log.DebugEnd(llDebug, 'DoHeartBeat', ClassName);
end;

procedure TbfaApplication.DoQueueCount(AThread: TThread);
var
  req: TbfaRequest;
  sock: TSocketConnection;
  params: TStringList;
  i, qcnt, qsum: Integer;
  msg: string;
begin
  // ist die Toolbar ausgeschaltet gibt es keinen Request. Sollte aber Autoreconnect gesetzt sein, dann sollte zumindest
  // dieser Timer laufen
  if not frmMainForm.tlbQueueCount.Visible then
  begin
    if not frmMainForm.tmrHeartbeat.Enabled then
      frmMainForm.tmrHeartbeat.Enabled := bitfarmApp.Autoreconnect;
    Exit;
  end else
    frmMainForm.tmrHeartbeat.Enabled := False;

  if OriginalfileLock or FSkipDoQueueCount then
    Exit;

  bitfarmApp.Log.DebugBegin(llDebug, 'DoQueueCount', ClassName);
  try
    FSkipDoQueueCount := True;
    sock := TSocketConnection.Create(bfaServerNoSSL, bfaServer, bfaServerPort, '');
    sock.CreateComponents;
    try
      if sock.Connect then
      begin
        req := TbfaRequest.Create;
        try
          req.ReqType := strReqQueuecount;
          req.UserID := FUser.ID;
          req.Profile := Profile;
          req.Lang := Lang;
          FLog.Write(llHigh, ltInfo, 'send reqQueueCount', ClassName);

          sock.SendRequestToServer(req);

          req := sock.ReceiveResponse;
          if req = nil then
            Exit;

          qsum := 0;
          msg := '';
          if req.Reqtype = 'respOK' then
          begin
            params := TStringList.Create;
            params.Delimiter := ';';
            params.StrictDelimiter := True;
            params.DelimitedText := req.DataString;

            for i := 0 to params.Count -1 do
            begin
              qsum := qsum + StrToInt(Trim(params[i].Substring(Pos(':', params[i]))));
            end;

            if qsum > 0 then
              msg := _('Anzahl der Dokumente in der Server-Warteschlange:') + ' ' + IntToStr(qsum) + ' '
            else
              msg := _('Die Server-Warteschlange ist leer');

            if params.Count > 1 then
            begin
              for i := 0 to params.Count -1 do
                  msg := msg + #13#10 + params[i];
            end;

          end else begin
            msg := _('Es konnte keine Serverauslastung ermittelt werden.');
          end;

          AThread.Synchronize(nil,
            procedure
          begin
            frmMainForm.pgrQueue.Position := qsum;
            frmMainForm.pgrQueue.Caption := IntToStr(qsum);
            frmMainForm.pgrQueue.Hint := msg;
          end);
        finally
          FreeAndNil(req);
          FreeAndNil(sock);
        end;
      end;
    except
      bitfarmApp.Log.Write(llNormal, ltException, 'DoQueueCount', ClassName);
    end;
  finally
    FSkipDoQueueCount := False;
    bitfarmApp.Log.DebugEnd(llDebug, 'DoQueueCount', ClassName);
  end
end;


procedure TbfaApplication.DocumentSearch(ArcID, GDocID: Int64; AThread: TThread; WithSymLink: Boolean = False; ArcIDs: WideString = ''; GDocIDs: WideString = ''); //14.09.2017 ergnzt wegen Ticket 11457
var
  Params: TStringList;
  Objects: TList;
begin
  bitfarmLog.DebugBegin(llDebug, 'DocumentSearch - ArcID:' + IntToStr(ArcID) + ' GDocID:' + IntToStr(GDocID), ClassName);
  fDocumentSearch := True;
  frmMainForm.FViewerTreeview.ChangeDelay := 0;
  fSkipAutoDisplay := True;
  try
    try
      if CurrentView <> TbfaViewKind(pvtViewer) then
      begin
        SetActiveView(AThread, pvtViewer);
      end;

      if not frmMainForm.pnlTreeView.Maximized then
      begin
        frmMainForm.fSkipMaximizeEvent := True;
        try
          frmMainForm.pnlTreeView.Maximize;
        finally
          frmMainForm.fSkipMaximizeEvent := False;
        end;
      end;

      if ((CurrentArchive.Arcid <> CurrentViewerArchive.Arcid) or (ArcID <> CurrentViewerArchive.Arcid)) or
        (LastView <> CurrentView) then
      begin
        if ((ArcID <> CurrentViewerArchive.Arcid) and (not WithSymLink)) or
          (LastView <> CurrentView) then
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              Self.SelectNodeByID(frmMainForm.FViewerTreeview, ArcID);
              if frmMainForm.FViewerTreeview.Selected <> nil then
                frmMainForm.FViewerTreeview.LastSelected := ArcID
              else
                frmMainForm.FViewerTreeview.LastSelected := -1;
            end);

          Params := TStringList.Create();
          Objects := TList.Create;
          try
            Params.Add(GetEnumName(TypeInfo(TbfaViewKind), integer(frmMainForm.FViewerTreeview.ViewKind)));
            Params.Add(IntToStr(frmMainForm.FViewerTreeview.LastSelected));
            Params.Add(GetEnumName(TypeInfo(TbfaViewKind), integer(CurrentView)));

            Objects.Add(frmMainForm.FViewerTreeview.Selected);

            ChangeArchive(Params, Objects, AThread);

            frmMainForm.FViewerTreeview.LastSelected := ArcID;
          finally
            FreeAndNil(Params);
            FreeAndNil(Objects);
          end;
        end;
        DoGDocIDSearch(AThread, GDocID, WithSymLink, GDocIDs, ArcIDs);
      end
      else
      begin
        DoGDocIDSearch(AThread, GDocID, WithSymLink, GDocIDs, ArcIDs);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'DocumentSearch - ArcID:' + IntToStr(ArcID) + ' GDocID:' + IntToStr(GDocID), ClassName);
    end;
  finally
    fDocumentSearch := False;
    FDoCreateGrid := False;
    fSkipAutoDisplay := False;
    frmMainForm.FViewerTreeview.ChangeDelay := tvChangeDelay;
    bitfarmLog.DebugEnd(llDebug, 'DocumentSearch - ArcID:' + IntToStr(ArcID) + ' GDocID:' + IntToStr(GDocID), ClassName);
  end;
end;

procedure TbfaApplication.DoExport(AThread: TThread);
begin
  // -> bfaApplicationEnterprise
end;

procedure TbfaApplication.StartExport(AThread: TThread; expfile: WideString = ''; userids: string = ''; groupids: string = '');
begin
  // -> bfaApplicationEnterprise
end;

procedure TbfaApplication.ChangeArchiveFromProgram(ArcID: Int64; AThread: TThread);
var
  Params: TStringList;
  Objects: TList;
begin
  bitfarmLog.DebugBegin(llDebug, 'ChangeArchiveFromProgram - ArcID:' + IntToStr(ArcID), ClassName);
  fDocumentSearch := True;
  frmMainForm.FViewerTreeview.ChangeDelay := 0;
  try
    try
      if (FPreviewContainer.ActiveItem <> pvtViewer) or (CurrentView <> tvkViewer) then
      begin
        if not frmMainForm.pnlTreeView.Maximized then
        begin
          frmMainForm.fSkipMaximizeEvent := True;
          try
            frmMainForm.pnlTreeView.Maximize;
          finally
            frmMainForm.fSkipMaximizeEvent := False;
          end;
        end;
        SetActiveView(AThread, pvtViewer);
      end;

      if (CurrentArchive.Arcid <> CurrentViewerArchive.Arcid) or
         (ArcID <> CurrentViewerArchive.Arcid) or
         ((CurrentView = tvkViewer) and (LastView = tvkResub)) then
      begin
        if not frmMainForm.pnlTreeView.Maximized then
        begin
          frmMainForm.fSkipMaximizeEvent := True;
          try
            frmMainForm.pnlTreeView.Maximize;
          finally
            frmMainForm.fSkipMaximizeEvent := False;
          end;
        end;

        if (ArcID <> CurrentViewerArchive.Arcid) or
          ((CurrentView = tvkViewer) and ((LastView = tvkResub) or (LastView = tvkImporter))) then
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              Self.SelectNodeByID(frmMainForm.FViewerTreeview, ArcID);
            end);
          Params := TStringList.Create();
          Objects := TList.Create;
          try
            Params.Add(GetEnumName(TypeInfo(TbfaViewKind), integer(frmMainForm.FViewerTreeview.ViewKind)));
            Params.Add(IntToStr(frmMainForm.FViewerTreeview.LastSelected));
//29.09.2021 sonst vom Importer kommend werden die Zusatzfelder nicht aktualisiert, wenn der Viewer schon auf Root steht          Params.Add(GetEnumName(TypeInfo(TbfaViewKind), integer(CurrentView)));
            Params.Add(GetEnumName(TypeInfo(TbfaViewKind), integer(LastView)));

            Objects.Add(frmMainForm.FViewerTreeview.Selected);

            ChangeArchive(Params, Objects, AThread);

            frmMainForm.FViewerTreeview.LastSelected := ArcID;
          finally
            FreeAndNil(Params);
            FreeAndNil(Objects);
          end;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'ChangeArchiveFromProgram - ArcID:' + IntToStr(ArcID), ClassName);
    end;
  finally
    fDocumentSearch := False;
    frmMainForm.FViewerTreeview.ChangeDelay := tvChangeDelay;
    bitfarmLog.DebugEnd(llDebug, 'ChangeArchiveFromProgram - ArcID:' + IntToStr(ArcID), ClassName);
  end;
end;

procedure TbfaApplication.ChangeBookmark(AThread: TThread; Objects: TList);
var
  SelNode: TTreeNode;
  BookmarkName: string;
  TmpObj: TbfaSearch;
begin
  bitfarmLog.DebugBegin(llDebug, 'ChangeBookmark', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          SelNode := TTreeNode(Objects[0]);
          if SelNode = TTreeNode(frmMainForm.trvBookmarks) then
          begin
            var I: Integer;
            bitfarmLog.Write(llDebug, ltDebug, 'ChangeBookmark - ItemCount '+frmMainForm.trvBookmarks.Items.Count.ToString, ClassName);
            for I := 0 to frmMainForm.trvBookmarks.Items.Count - 1 do
            begin
              if (TObject(frmMainForm.trvBookmarks.Items[I].Data) is TbfaSearch) then
                bitfarmLog.Write(llDebug, ltDebug, 'ChangeBookmark - Item[' + I.ToString +']: TbfaSearch true', ClassName)
              else
                bitfarmLog.Write(llDebug, ltDebug, 'ChangeBookmark - Item[' + I.ToString +']: TbfaSearch false', ClassName);

              if (TObject(frmMainForm.trvBookmarks.Items[I].Data) is TbfaSearch)
                  and (
                    (GetRootNode(frmMainForm.trvBookmarks.Items[I]) = LocalListNode)
                    or
                    ((GetRootNode(frmMainForm.trvBookmarks.Items[I]) = GlobalListNode) and bitfarmApp.User.isAdmin)
                  ) then
              begin
                // tvkViewer = nur die im Archiv/Lager verfgbaren Lesezeichen
                if (CurrentView = tvkViewer) then
                begin
                  bitfarmLog.Write(llDebug, ltDebug, 'ChangeBookmark - CurrentView = tvkViewer', ClassName);
                  if (frmMainForm.FViewerTreeview.LastSelected = TbfaSearch(frmMainForm.trvBookmarks.Items[I].Data).SelectedArcID) or
                     (TbfaSearch(frmMainForm.trvBookmarks.Items[I].Data).SelectedArcID = 0) then
                  begin
                    SelNode := frmMainForm.trvBookmarks.Items[I];
                    Break;
                  end;
                end else
                begin
                // sonst den ersten der editierbar ist
                  bitfarmLog.Write(llDebug, ltDebug, 'ChangeBookmark - CurrentView <> tvkViewer', ClassName);
                  SelNode := frmMainForm.trvBookmarks.Items[I];
                  Break;
                end;
              end;
            end;
          end;

          //GlobalNode oder LocalNode mit Adminrecht
          if (GetRootNode(SelNode) = GlobalListNode) or
              (((SelNode = LocalListNode) or (GetRootNode(SelNode) = LocalListNode)) and
               ((TObject(SelNode.Data) is TbfaSearch))) then
          begin
            try
              bitfarmLog.Write(llDebug, ltDebug, 'ChangeBookmark - Adminrights', ClassName);
              frmMainForm.frmCreateGlobal := TfrmCreateGlobalBookmark.Create(frmMainForm, False, CurrentView);

              bitfarmApp.ChangeCreateBookmarkSkin;
              if (frmMainForm.frmCreateGlobal.cbxBookmark.Properties.Items.Count > 0) and
                 (frmMainForm.frmCreateGlobal.cbxBookmark.Properties.Items.Objects[0] is TTreeNode) and
                 (CurrentView <> tvkFavorites)
              then
                frmMainForm.frmCreateGlobal.LoadBookmark(TTreeNode(frmMainForm.frmCreateGlobal.cbxBookmark.Properties.Items.Objects[0]))
              else if (CurrentView = tvkFavorites) and (SelNode <> nil) and
                      (SelNode.Data <> nil) and (TObject(SelNode.Data) is TbfaSearch)
              then
                frmMainForm.frmCreateGlobal.LoadBookmark(SelNode)
              else
              begin
                bitfarmLog.Write(llNormal, ltError, 'ChangeBookmark - ItemCount 0 - Exit widthout Show', ClassName);
                Exit;
              end;

              frmMainForm.frmCreateGlobal.cbxUser.Enabled := False;
              frmMainForm.frmCreateGlobal.btnUser.Enabled := False;
              bitfarmLog.Write(llDebug, ltDebug, 'ChangeBookmark - before ShowModal', ClassName);

              case ViewerOptions.GeneralOptions.CloseBookmarkDialog of
                True: frmMainForm.frmCreateGlobal.chkCloseOnSave.State := cbChecked;
                else frmMainForm.frmCreateGlobal.chkCloseOnSave.State := cbUnchecked;
              end;

              frmMainForm.frmCreateGlobal.OnSave := ExecuteBookmarkSave;
              frmMainForm.frmCreateGlobal.ShowModal;
              // saving-process moved to ExecuteBookmarkSave

              case frmMainForm.frmCreateGlobal.chkCloseOnSave.State of
                cbChecked: ViewerOptions.GeneralOptions.CloseBookmarkDialog := True;
                else ViewerOptions.GeneralOptions.CloseBookmarkDialog := False;
              end;
            finally
              frmMainForm.frmCreateGlobal.Release;
              bitfarmLog.Write(llDebug, ltDebug, 'ChangeBookmark - after release', ClassName);
              // vorher nur Free. War dann aber in ApplicationEvents1Message noch Assigned
              // und hat nicht mehr gescrollt. deswegen FreeAndNil
              FreeAndNil(frmMainForm.frmCreateGlobal);
            end;
          end;
//          begin
//            frmMainForm.frmCreateGlobal := TfrmCreateGlobalBookmark.Create(frmMainForm);
//            if TObject(SelNode.Data) is TbfaSearch then
//            begin
//              frmMainForm.frmCreateGlobal.LoadBookmark(SelNode.Data);
//            end;
//            if (GetRootNode(SelNode) = GlobalListNode) then
//              frmMainForm.frmCreateGlobal.Caption := _('Globales Lesezeichen ndern')
//            else
//            begin
//              frmMainForm.frmCreateGlobal.Caption := _('Lokales Lesezeichen ndern');
//              frmMainForm.frmCreateGlobal.cbxArchive.Enabled := True;   // Ticket 20864
//            end;
//
//            frmMainForm.frmCreateGlobal.cbxUser.Enabled := False;
//            frmMainForm.frmCreateGlobal.btnUser.Enabled := False;
//            frmMainForm.frmCreateGlobal.ShowModal;
//
//            if frmMainForm.frmCreateGlobal.ModalResult = mrOk then
//            begin
//              TbfaSearch(SelNode.Data).Clone(frmMainForm.frmCreateGlobal.sobj);
//              SelNode.Text := frmMainForm.frmCreateGlobal.edtName.Text;
//
//              if frmMainForm.frmCreateGlobal.sobj.Verify then
//              begin
//                SelNode.ImageIndex := Integer(icoidx_bookmark_check);
//                SelNode.SelectedIndex := Integer(icoidx_bookmark_check_selected);
//              end
//              else
//              begin
//                SelNode.ImageIndex := Integer(icoidx_bookmark);
//                SelNode.SelectedIndex := Integer(icoidx_bookmark_selected);
//              end;
//
//              SaveBookmarkNode(SelNode);
//            end;
//            frmMainForm.frmCreateGlobal.Release;
//            frmMainForm.frmCreateGlobal.Free;
//          end;
        end);

    except
      bitfarmLog.Write(llNormal, ltException, 'ChangeBookmark', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ChangeBookmark', ClassName);
  end;
end;

procedure TbfaApplication.ChangeCreateBookmarkSkin;
//var
//  style: TTBItemStyle;
begin
  if not Assigned(frmMainform.frmCreateGlobal) then
    Exit;

  with frmMainform.frmCreateGlobal do
  begin
    pnl1.Color := ctlGeneral.Style.Color;
    edtName.Color := ctlGeneral.Style.Color;
    edtName.Font.Color := ctlGeneral.Style.Font.Color;
    lstSQLWhere.Color := ctlGeneral.Style.Color;
    cbxUser.Style.Color := ctlGeneral.Style.Color;
    cbxUser.Style.Font.Color := ctlGeneral.Style.Font.Color;
    cbxField.Style.Color := ctlGeneral.Style.Color;
    cbxField.Style.Font.Color := ctlGeneral.Style.Font.Color;
    cbxStateValue.Style.Color := ctlGeneral.Style.Color;
    cbxStateValue.Style.Font.Color := ctlGeneral.Style.Font.Color;
    edtValue.Color := ctlGeneral.Style.Color;
    edtValue.Font.Color := ctlGeneral.Style.Font.Color;
  end;
end;

procedure TbfaApplication.DoChangeArchiveFromProgram(ArcName: WideString; AThread: TThread; LgrID: Int64 = -1);
var
  qry: TUniQuery;
begin
  bitfarmLog.DebugBegin(llDebug, 'DoChangeArchiveFromProgram', ClassName);
  try
    try
      qry := TUniQuery.Create(nil);
      try
        qry.Connection := dmMain.cntMain;
        if LgrID = -1 then
          qry.SQL.Text := 'select arcid from sys_arc where (type = 0) and' + ' ((flags & 2) = 0) and (arcname = ' + #39 + ArcName + #39 + ');'
        else
          qry.SQL.Text := 'select arcid from sys_arc where (type = 1) and ' + ' (lgrid = ' + IntToStr(LgrID) + ') and ((flags & 2) = 0) and (arcname = ' + #39 + ArcName + #39 + ');';

        bitfarmLog.Write(llDebug, ltInfo, 'qry.SQL.Text: ' + qry.SQL.Text, ClassName);
        qry.Open;
        if qry.RecordCount > 0 then
        begin
          qry.First;
          bitfarmLog.Write(llDebug, ltInfo, 'ChangeArchiveFromProgram(qry.FieldByName(' + qry.FieldByName('arcid').AsString + ').AsInteger, AThread);', ClassName);
          ChangeArchiveFromProgram(qry.FieldByName('arcid').AsInteger, AThread);
        end;
        qry.Close;
      finally
        FreeAndNil(qry);
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'DoChangeArchiveFromProgram', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'DoChangeArchiveFromProgram', ClassName);
  end;
end;

procedure TbfaApplication.GetLastDocument(AThread: TThread; Params: TStringList);
var
  Idx, PPos: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'GetLastDocument', ClassName);
  try
    try
      if Length(DocHistory) > 0 then
      begin
        PPos := StrToInt(Params[0]);
        if PPos = 0 then
        begin
//04.04.2017          if DocHistoryIdx = Length(DocHistory) then
//            Idx := DocHistoryIdx - 2
//          else
          Idx := DocHistoryIdx - 1;

          if Idx >= DocHistoryIdx then
//04.04.2017            Idx := DocHistoryIdx - 2;
            Idx := DocHistoryIdx - 1;

          if Idx < 0 then
            Idx := 0;

          if Idx >= 0 then
          begin
            DocumentSearch(DocHistory[Idx].arcid, DocHistory[Idx].gdocid, AThread);
            if DocHistoryIdx > 0 then
              DocHistoryIdx := DocHistoryIdx - 1
            else
              DocHistoryIdx := 0;
          end;
        end
        else if PPos = 1 then
        begin
          Idx := DocHistoryIdx + 1;

          if Idx >= DocHistoryIdx then
//04.04.2017            Idx := DocHistoryIdx - 2;
            Idx := DocHistoryIdx - 1;

          if Idx < 0 then
            Idx := 0;

          if Idx <= Length(DocHistory) - 1 then
          begin
            DocumentSearch(DocHistory[Idx].arcid, DocHistory[Idx].gdocid, AThread);
            if DocHistoryIdx < Length(DocHistory) then
              DocHistoryIdx := DocHistoryIdx + 1
            else
              DocHistoryIdx := Length(DocHistory);
          end;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'GetLastDocument', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'GetLastDocument', ClassName);
  end;
end;

procedure TbfaApplication.GPL;
begin
//  ShowMessage('Hallo GPL');
end;

procedure TbfaApplication.GraphicOptions;
begin
  ShowMessage('GraphicOptions');
end;

procedure TbfaApplication.Info(AThread: TThread);
begin
  AThread.Synchronize(AThread,
    procedure
    var
      frmInfo: Tfrm_Info;
    begin
      frmInfo := Tfrm_Info.Create(nil);
      try
        bfaIcons.ilPreview16.GetIcon(Integer(icoidx_info_dialog), frmInfo.Icon);
        frmInfo.ShowModal;
      finally
        FreeAndNil(frmInfo);
      end;
    end);
end;

procedure TbfaApplication.DoImageCorrection(prev: TbfaPreview; Doc: TbfaDocument; func: Integer);
var
  i, iRemPixel: Integer;
  dSkew: Double;
  rgbColor: TRGB;
  frm: Tfrm_DeSpeckle;
  iebmp2 : TIEBitmap;
begin
  Log.DebugBegin(llDebug, 'DoImageCorrection', ClassName);
  try
    try
      with Doc do
      begin
        if prev.ThumbnailView = nil then
        begin
          if func = 0 then
          begin
            prev.SingleView.img_DocView.Proc.Negative;
            prev.SingleView.img_DocView.UpDate;
          end
          else if func = 1 then
          begin
            dSkew := prev.SingleView.img_DocView.Proc.SkewDetection(160, 45, 0.1, True);
            prev.SingleView.img_DocView.Proc.Rotate(dSkew, True);
            prev.SingleView.img_DocView.UpDate;
          end
          else if func = 2 then
          begin
            try
              frm := Tfrm_DeSpeckle.Create(nil);
              frm.ShowModal;
              iRemPixel := frm.Tag;
              prev.SingleView.img_DocView.Proc.RemoveIsolatedPixels(0, iRemPixel + 1); // schwarze Punkte auf weiem Hintergrund
              prev.SingleView.img_DocView.UpDate;
            finally
              frm.Release;
            end;
          end
          else if func = 3 then
          begin
            rgbColor := prev.SingleView.img_DocView.Proc.AttachedIEBitmap.Pixels[0, 0];
            bfaCommonImageEN.AutoCrop(prev.SingleView.img_DocView.Proc, rgbColor, 20, 5, 10);
            prev.SingleView.img_DocView.UpDate;
          end;

          DocStream.Position := 0;
          prev.SingleView.img_DocView.IO.ReplaceStreamTIFF(DocStream);
          DocStream.Position := 0;
        end else
        begin
          if prev.ThumbnailView.MultiSelectedImagesCount > 0 then
          begin
            for i := 0 to prev.ThumbnailView.MultiSelectedImagesCount - 1 do
            begin
              if (ScanPoolView <> nil) and ScanPoolViewLoaded then
              begin
                prev.SingleView.img_DocView.IO.Params.ImageIndex := 0;
                iebmp2 := TIEBitmap.Create;
                try
                  ScanPoolView.CopyToIEBitmap(0, iebmp2);
                  {$IFDEF ImageEN1140}
                  prev.SingleView.img_DocView.Bitmap.Assign(iebmp2.VclBitmap);
                  {$ELSE}
                  prev.SingleView.img_DocView.IO.Bitmap.Assign(iebmp2.VclBitmap);
                  {$ENDIF}
                finally
                  FreeandNil(iebmp2);
                end;
              end else
              begin
                prev.SingleView.img_DocView.IO.Params.ImageIndex := prev.ThumbnailView.MultiSelectedImages[i];
                DocStream.Position := 0;
                prev.SingleView.img_DocView.IO.LoadFromStreamTIFF(DocStream);
              end;

              if func = 0 then
              begin
                prev.SingleView.img_DocView.Proc.Negative;
                prev.SingleView.img_DocView.UpDate;
              end
              else if func = 1 then
              begin
                dSkew := prev.SingleView.img_DocView.Proc.SkewDetection(160, 45, 0.1, True);
                prev.SingleView.img_DocView.Proc.Rotate(dSkew, True);
                prev.SingleView.img_DocView.UpDate;
              end
              else if func = 2 then
              begin
                try
                  frm := Tfrm_DeSpeckle.Create(nil);
                  frm.ShowModal;
                  iRemPixel := frm.Tag;
                  prev.SingleView.img_DocView.Proc.RemoveIsolatedPixels(0, iRemPixel + 1); // schwarze Punkte auf weiem Hintergrund
                  prev.SingleView.img_DocView.UpDate;
                finally
                  frm.Release;
                end;
              end
              else if func = 3 then
              begin
                rgbColor := prev.SingleView.img_DocView.Proc.AttachedIEBitmap.Pixels[0, 0];
                bfaCommonImageEN.AutoCrop(prev.SingleView.img_DocView.Proc, rgbColor, 20, 5, 10);
                prev.SingleView.img_DocView.UpDate;
              end;

              if (ScanPoolView <> nil) and ScanPoolViewLoaded then
              begin
                ScanpoolView.SetIEBitmap(prev.ThumbnailView.MultiSelectedImages[i], prev.SingleView.img_DocView.IEBitmap);
                ScanpoolView.UpdateEx(True);
                ThumbnailView.SetIEBitmap(prev.ThumbnailView.MultiSelectedImages[i], prev.SingleView.img_DocView.IEBitmap);
                ThumbnailView.UpdateEx(True);
              end else
              begin
                DocStream.Position := 0;
                prev.SingleView.img_DocView.IO.ReplaceStreamTIFF(DocStream);
                DocStream.Position := 0;
                prev.ThumbnailView.SetIEBitmap(prev.SingleView.img_DocView.IO.Params.ImageIndex, prev.SingleView.img_DocView.IEBitmap);
                prev.ThumbnailView.UpdateEx(True);
              end;
            end;
          end;
        end;
      end;
    except
      Log.Write(llNormal, ltException, 'DoImageCorrection', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'DoImageCorrection', ClassName);
  end;
end;

procedure TbfaApplication.Inverted(Data: PUserAction; AThread: TThread);
var
  prev: TbfaPreview;
begin
  Log.DebugBegin(llDebug, 'Inverted', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          prev := PUserAction(Data).Preview;
          with PUserAction(Data).Preview.ActiveDoc do
          begin
            StartSaveProcess;
            try
              DoImageCorrection(prev, PUserAction(Data).Preview.ActiveDoc, 0);
            finally
              Modified_Preview := True;
              EndSaveProcess;
            end;
          end;
        end);

      RefreshDocumentInPreviews(AThread, PUserAction(Data).Preview.ActiveDoc, prev, nil, False, False, True);

    except
      Log.Write(llNormal, ltException, 'Inverted', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'Inverted', ClassName);
  end;
end;

procedure TbfaApplication.IsAuditProof(AThread: TThread);
begin
  AThread.Synchronize(AThread,
    procedure
    begin
      ShowMessage('IsAuditProof');
    end);
end;

// Alle Elemente, die vom bersetzer nicht bersetzt wurden knnen hier nochmal manuell zugewiesen werden.
procedure TbfaApplication.ChangeLanguageAfter;
begin
  try
    frmMainForm.ChangeLanguageAfter;
  finally
  end;
end;

procedure TbfaApplication.LanguageXX(AThread: TThread; LangCode: string);
var
  comps: array of TComponent;
begin
  Screen.Cursor := crHourGlass;
  Log.Write(llDebug, ltInfo, 'LanguageXX - LangCode: ' + LangCode, ClassName);
  Reset(AThread);
  ResetViewer(AThread);

  AThread.Synchronize(nil,
    procedure
    var
      i: Integer;
      TabCaption: string;
    begin
      try
        for i := 0 to FPreviewContainer.Containers.Count - 1 do
          FPreviewContainer.Containers[i].Preview.HistoryView.HistDataSet.Close;

        SetLength(comps, 2);
        comps[0] := frmMainForm;
        comps[1] := frmMainForm.frmOptions;
        if frmMainForm.fraAdmin <> nil then
        begin
          SetLength(comps, 3);
          comps[High(comps)] := frmMainForm.fraAdmin;
        end;

        TabCaption := frmMainForm.tabSearchAddfields2.Caption; //14.02.2023 Darf nicht bersetzt werden
        CommonGUIUtils.SpDxGetTextChangeLanguage(LangCode, '', comps);
        frmMainForm.tabSearchAddfields2.Caption := TabCaption; //14.02.2023 Darf nicht bersetzt werden
        ChangeLanguageAfter;
        frmMainForm.frmOptions.InitRoleList;
        frmMainForm.frmOptions.InitFieldRights;
        frmMainForm.frmOptions.FillCombosWithObjects;

        for i := 0 to FPreviewContainer.Containers.Count - 1 do
          FPreviewContainer.Containers[i].Preview.HistoryView.HistDataSet.CreateDataSet;

      except
        BfShowMessage(_('Es hat einen Fehler beim ndern der Anzeigesprache gegeben'));
      end;
    end);
  Screen.Cursor := crDefault;
end;

procedure TbfaApplication.Links(AThread: TThread);
begin
  Log.DebugBegin(llDebug, 'Links', Classname);
  try
    try
      if (FCurrentContainer.Count > 0) and (FCurrentContainer[0] <> nil) then
      begin
//15.09.2020        if frmMainForm.clItemLinks.Color = gclYellow then
        if frmMainForm.clItemLinks.ImageIndex = Integer(icoidx_link_enabled) then
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              frmMainForm.popDocLinks.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y)
            end);
        end;
      end;
    except
      Log.Write(llNormal, ltException, 'Links', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'Links', Classname);
  end;
end;

procedure TbfaApplication.LoadFile(Data: PUserAction; AThread: TThread);
var
  i, j, icount, idx, newdocscnt: Integer;
  AllFileSize: Double;
  PDoc: TbfaDocument;
  sList, slwList: TStringList;
  Lst: TList<TbfaDocument>;
  JobFile, SLWFile, tmp, ErrorStr, FileName, SLWFileName: string;
  found, Error: Boolean;
  slZMetaField, slZMetaName, slZMetaFieldValues, slZMetaFieldType: TStringList;
begin
  Log.DebugBegin(llDebug, 'LoadFile', ClassName);
  try
    try
      if CurrentView <> tvkImporter then
        SetActiveView(AThread, pvtImporter, nil, integer(tvkImporter));

      slwList := TStringList.Create;
      sList := TStringList.Create; //23.09.2022 Ticket 32298
      icount := PreviewContainer.ImporterItem.Preview.MultiView.ImageCount;
      newdocscnt := 0;
      AllFileSize := 0;
      for i := 0 to Data^.params.Count - 1 do
      begin
        FileName := TbfaFileObj(Data^.params.Objects[i]).FileName;
        sList.Add(TbfaFileObj(Data^.params.Objects[i]).FileName); //23.09.2022 Ticket 32298
        AllFileSize := AllFileSize + TbfaFileObj(Data^.params.Objects[i]).FileSize;
        if ((ExtractFileExt(FileName) <> '.job') and
            (ExtractFileExt(FileName) <> '.slw')) then
          newdocscnt := newdocscnt + 1;
      end;

      AThread.Synchronize(nil,
        procedure
        var
          msg: string;
        begin
          if not frmMainForm.frmSplash.Showing then
          begin
            if bitfarmApp.GetActivePreview = bitfarmapp.PreviewContainer.ImporterItem.Preview then
            begin
              frmMainForm.frmSplash.FormType := sftImporter;
              msg := _('Dokumente im Importer werden aktualisiert...');
            end
            else
            begin
              frmMainForm.frmSplash.FormType := sftWorkplace;
              msg :=  _('Dokumente im Arbeitsplatz werden aktualisiert...');
            end;

            frmMainForm.frmSplash.lblLoading.Caption := msg;
            frmMainForm.frmSplash.UseTimer := True;
            frmMainForm.frmSplash.pgbDocuments.Properties.Min := 0;
            frmMainForm.frmSplash.pgbDocuments.Position := 0;
            frmMainForm.frmSplash.pgbDocuments.Properties.Max := (AllFileSize * 2) + 1;
            frmMainForm.frmSplash.btnCancel.Visible := newdocscnt > 1;
            frmMainForm.frmSplash.Canceled := False;
            frmMainForm.frmSplash.btnCancel.Enabled := newdocscnt > 1;
            frmMainForm.frmSplash.Show;
          end;
        end);

      bitfarmApp.CancelProcess := False;
      for i := 0 to Data^.params.Count - 1 do
      begin
        if bitfarmApp.CancelProcess then
          Break;

        FileName := TbfaFileObj(Data^.params.Objects[i]).FileName;
        if (FileExists(FileName) and (ExtractFileExt(FileName) <> '.job') and
           (ExtractFileExt(FileName) <> '.slw')) then
        begin
//29.08.2023 -->
//          AThread.Synchronize(nil, // wegen ImageEn Synchron hier auch Synchronizieren
//            procedure
//            begin
//              //04.08.2023 wegen Abstrze bei OutlookAddIn ein Test -->
//              //PDoc := CreatePDocument(FileName);
//              PDoc := CreatePDocument(FileName, True); //Die Datei nicht mit TFileStream festhalten, sonder spter einfach kopieren
//              //04.08.2023 wegen Abstrze bei OutlookAddIn ein Test <--
//            end);
          {$IFDEF IMAGEEN_SYNCHRONIZED}
          AThread.Synchronize(nil, // wegen ImageEn Synchron hier auch Synchronizieren
            procedure
            begin
              //04.08.2023 wegen Abstrze bei OutlookAddIn ein Test -->
              //PDoc := CreatePDocument(FileName);
              PDoc := CreatePDocument(FileName, True); //Die Datei nicht mit TFileStream festhalten, sonder spter einfach kopieren
              //04.08.2023 wegen Abstrze bei OutlookAddIn ein Test <--
            end);
          {$ELSE}
          //04.08.2023 wegen Abstrze bei OutlookAddIn ein Test -->
          //PDoc := CreatePDocument(FileName);
          PDoc := CreatePDocument(FileName, True); //Die Datei nicht mit TFileStream festhalten, sonder spter einfach kopieren
          //04.08.2023 wegen Abstrze bei OutlookAddIn ein Test <--
          {$ENDIF}
//29.08.2023 <--
          if PDoc <> nil then
          begin
            found := False;
            JobFile := ChangeFileExt(FileName, '.job');
            for j := 0 to sList.Count - 1 do
//23.09.2022 Ticket 32298           for j := 0 to Data^.params.Count - 1 do
            begin
              if sList[j] = JobFile then
//23.09.2022 Ticket 32298              if FileName = JobFile then
              begin
                found := True;
                Break;
              end;
            end;

            if found then
              ReadJobFile(AThread, PDoc, JobFile, slZMetaField, slZMetaName,
                slZMetaFieldValues, slZMetaFieldType, Error, ErrorStr);

            found := False;
            SLWFile := ChangeFileExt(FileName, '.slw');
            for j := 0 to sList.Count - 1 do
//23.09.2022 Ticket 32298            for j := 0 to Data^.params.Count - 1 do
            begin
              SlWFileName := TbfaFileObj(Data^.params.Objects[j]).FileName;
              if sList[j] = SLWFile then
//23.09.2022 Ticket 32298              if SlWFileName = SLWFile then
              begin
                found := True;
                Break;
              end;
            end;

            if found then
            begin
              slwList.Clear;
              slwList.LoadFromFile(sList[j]);
//23.09.2022 Ticket 32298              slwList.LoadFromFile(SlWFileName);
              PDoc.DocTags := slwList.Text;
            end
            else
            begin
              tmp := FileName;
              PDoc.DocTags := 'Dateiname=' + ChangeFileExt(ExtractFileName(tmp), '');
            end;

            PDoc.EditmodeUserID := bitfarmApp.User.ID; // SJ 28.10.2020
            FImportContainer.Add(PDoc);
            Log.Write(llDebug, ltInfo, 'Doc added to FImportConatiner TempID: ' +
              GUIDToString(PDoc.TempID), ClassName);
            Lst := TList<TbfaDocument>.Create;
            try
              Lst.Add(PDoc);
              var Canceled: Boolean; //06.06.2023 Cancel mglichkeit im SaveDocumentsToXML eingebaut
              Canceled := bitfarmApp.SaveDocumentsToXML(Lst, BD.EnvAppdataImporterPd,
                FImportContainer.Count - 1, False, AThread);

              if Canceled then
                FImportContainer.Delete(FImportContainer.Count - 1) //06.06.2023 wenn beim laden gecancelt wird darf auch nicht in der Liste!
              else
              begin
                if Data^.options = DROPEFFECT_MOVE then
                begin
                  try
                    //02.08.2023 DeleteFile(FileName); //wegen Logmglichkeiten umgestellt
                    var DeleteResult: Boolean;
                    DeleteResult:= DeleteFile(FileName);
                    if DeleteResult then
                      Log.Write(llNormal, ltInfo, 'Datei wurde gelscht: ' + FileName, ClassName)
                    else
                      Log.Write(llNormal, ltInfo, 'Datei kann nicht gelscht werden: ' + FileName, ClassName);

                  except
                    Log.Write(llNormal, ltException, 'DeleteFile(FileName): ' + FileName, ClassName);
                  end;
                end;
              end;
            finally
              FreeAndNil(Lst);
            end;
            AThread.Synchronize(nil,
              procedure
              begin
                frmMainForm.frmSplash.IncProgressBar(TbfaFileObj(Data^.params.Objects[i]).FileSize);
              end);
            RefreshImporterMultiView(AThread, True, icount + newdocscnt);
            AThread.Synchronize(nil,
              procedure
              begin
                frmMainForm.frmSplash.IncProgressBar(TbfaFileObj(Data^.params.Objects[i]).FileSize);
              end);
          end
          else
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                BfMessageDlg(_('Datei wurde nicht geladen. '), mtError, [mbOK]);
              end);
          end;
        end;
      end;

      if (Data^.sList.Count > 0) and (Data^.options = DROPEFFECT_MOVE) then
      begin
        try
          Log.Write(llDebug, ltInfo, 'DeleteDirectory(Data^.sList[0]);: ' +
            Data^.sList[0], ClassName);

          //29.08.2023 -->
          //DeleteDirectory(Data^.sList[0]);
          {$IFDEF IMAGEEN_SYNCHRONIZED}
          TDirectory.Delete(Data^.sList[0], True);
          {$ELSE}
          DeleteDirectory(Data^.sList[0]);
          {$ENDIF}
          //29.08.2023 <--
        except
          Log.Write(llNormal, ltException, 'DeleteDirectory(Data^.sList[0]);' +
            Data^.sList[0], ClassName);
        end;
      end;

      AThread.Synchronize(nil,
        procedure
        var
          i: Integer;
        begin
          FPreviewContainer.ImporterItem.Preview.MultiView.LockPaint;
          try
            PreviewContainer.ImporterItem.Preview.MultiView.Deselect;
            PreviewContainer.ImporterItem.Preview.MultiView.MultiSelecting := True;
            for i := 0 to Data^.params.Count - 1 do
              PreviewContainer.ImporterItem.Preview.MultiView.SelectedImage := icount + i;
          finally
            FPreviewContainer.ImporterItem.Preview.MultiView.MultiSelecting := False;
            FPreviewContainer.ImporterItem.Preview.MultiView.UnLockPaint;
          end;

          if frmMainForm.frmSplash.Showing then
          begin
            frmMainForm.frmSplash.Hide;
            frmMainForm.frmSplash.UseTimer := False;
          end;
        end);

      bitfarmApp.MViewImageSelect(PreviewContainer.ImporterItem.Preview.MultiView,
        PreviewContainer.ImporterItem.Preview, icount + i, -1, True, False, False,
        False, False, False, True);

      if IsIconic(frmMainForm.Handle) then
        ShowWindow(frmMainForm.Handle, SW_RESTORE);

    except
      on E: Exception do
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            BfMessageDlg(_('Datei wurde nicht geladen. ') + #10 + #13 +
              E.Message, mtError, [mbOK]);
          end);
        Log.Write(llNormal, ltException, 'Loadfile - ' + E.Message, ClassName);
      end;
    end;
  finally
    bitfarmapp.CancelProcess := False;
    FreeAndNil(slwList);
    Log.DebugEnd(llDebug, 'LoadFile', ClassName);
  end;
end;

procedure TbfaApplication.LoadDoc(Data: PUserAction; AThread: TThread);
begin
  DoGDocIDSearch(AThread, StrToInt(Data^.params[1]), False);
end;

procedure TbfaApplication.LoadDocumentsFromXML(AThread: TThread; Path: WideString;
  Container: TList<TbfaDocument>);

  procedure  LoadDocFromXML(Path, Filename: WideString; Container: TList<TbfaDocument>);
  var
    RootNode: IXMLNode;
    XMLDoc: IXMLDocument;
    ObjList: TList<TbfaBaseObject>;
    j: Integer;
  begin
    CoInitialize(nil);
    XMLDoc := TXMLDocument.Create(nil);
    try
      XMLDoc.LoadFromFile(FileName);

      RootNode := XMLDoc.DocumentElement;

      if RootNode <> nil then
      begin
        ObjList := XMLToObject(RootNode);

        for j := 0 to ObjList.Count - 1 do
        begin
          if (TbfaBaseDocument(ObjList[j]).Id = -1) then
          begin
            if FileExists(Path + GUIDToString(TbfaBaseDocument(ObjList[j]).TempID) + '\StreamTIF.tif') then
            begin
              with TbfaBaseDocument(ObjList[j]).DocStream do
              begin
                Clear;
                LoadFromFile(Path + GUIDToString(TbfaBaseDocument(ObjList[j]).TempID) + '\StreamTIF.tif');
                Position := 0;
              end;
            end;
            if TbfaBaseDocument(ObjList[j]).FileType <> '' then
            begin
              if FileExists(Path + GUIDToString(TbfaBaseDocument(ObjList[j]).TempID) + '\StreamORI' + TbfaBaseDocument(ObjList[j]).FileType) then
              begin
                TbfaBaseDocument(ObjList[j]).OriStream.Free;
                TbfaBaseDocument(ObjList[j]).OriStream :=
                  TFileStream.Create(Path + GUIDToString(TbfaBaseDocument(ObjList[j]).TempID) + '\StreamORI' +
                    TbfaBaseDocument(ObjList[j]).FileType,
                    fmOpenRead or fmShareDenyNone);
                with TbfaBaseDocument(ObjList[j]).OriStream do
                begin
//24.05.2023                  Clear;
//                  LoadFromFile(Path + GUIDToString(TbfaBaseDocument(ObjList[j]).TempID) + '\StreamORI' + TbfaBaseDocument(ObjList[j]).FileType);
                  Position := 0;
                  TbfaBaseDocument(ObjList[j]).OriLoc := Path + GUIDToString(TbfaBaseDocument(ObjList[j]).TempID) + '\StreamORI' + TbfaBaseDocument(ObjList[j]).FileType;
                end;
              end;
            end
            else begin
              if FileExists(Path + GUIDToString(TbfaBaseDocument(ObjList[j]).TempID) + '\StreamORI.tif') then
              begin
//24.05.2023
//                with TbfaBaseDocument(ObjList[j]).OriStream do
//                begin
//                  Clear;
//                  LoadFromFile(Path + GUIDToString(TbfaBaseDocument(ObjList[j]).TempID) + '\StreamORI.tif');
//                  Position := 0;
//                  TbfaBaseDocument(ObjList[j]).OriLoc := Path + GUIDToString(TbfaBaseDocument(ObjList[j]).TempID) + '\StreamORI.tif';
//                end;
              end;
            end;
            if FileExists(Path + GUIDToString(TbfaBaseDocument(ObjList[j]).TempID) + '\StreamLetter.tif') then
            begin
              with TbfaBaseDocument(ObjList[j]).LetterStream do
              begin
                Clear;
                LoadFromFile(Path + GUIDToString(TbfaBaseDocument(ObjList[j]).TempID) + '\StreamLetter.tif');
                Position := 0;
              end;
            end;
          end
          else begin
            //10.02.2023 bfacrm:ticket__show__33894 -->
            //LoadDocumentViaSocket(TbfaDocument(ObjList[j]), 'base;fields;paths;iev;text;svn', AThread, False, True);
            if not bitfarmApp.OfflineMode then
              LoadDocumentViaSocket(TbfaDocument(ObjList[j]), 'base;fields;paths;iev;text;svn', AThread, False, True)
            else
              DBLoadDocument(TbfaDocument(ObjList[j]));
            //10.02.2023 bfacrm:ticket__show__33894 <--
          end;

          Container.Add(TbfaDocument(ObjList[j]));
        end;
      end;
    finally
      XMLDoc := nil;
      CoUnInitialize;
    end;
  end;

var
  FileName: WideString;
  i, j, k: Integer;
  RootNode: IXMLNode;
  XMLDoc: IXMLDocument;
  AnnoObj: TbfaAnnotation;
  IEVList: TStringList;
  ObjList: TList<TbfaBaseObject>;
  TempList: TList<TbfaDocument>;
  Lst: TStringList;
//12.03.2021  Lst: TbfaStringList;
  RequestList: TStringList;
  ErrorCount : Integer;
  Params, Msg, ErrorMsg, TempID, ContainerName : string;
  req: TbfaRequest;
  Doc : TbfaDocument;
begin
  Log.DebugBegin(llDebug, 'LoadDocumentsFromXML', ClassName);
  Lst := TStringList.Create;
//12.03.2021  Lst := TbfaStringList.Create;
  ErrorCount := 0;
  TempList := TList<TbfaDocument>.Create;
  RequestList := TStringList.Create;
  RequestList.Delimiter := ';' ;
  try
    try
      if DirectoryExists(Path) then
      begin
        GetAllFilesInDir(Path, Lst, False);

        if Lst.Count > 0 then
        begin
          if Container = FImportContainer then
            msg := _('Dokumente im Importer werden geladen...')
          else if Container = FWorkplaceContainer then
            msg := _('Dokumente im Arbeitsplatz werden geladen...');

          for  i := 0 to Lst.count-1 do
          begin
//12.03.2021 FileName := TbfaFileObj(TbfaStringList(Lst[i])).FileName;
            FileName := Lst[i];

            if Container = FImportContainer then
            begin
              if ((FileName = '') or not FileExists(FileName)) then
              begin
                ErrorCount := ErrorCount +1;
                Continue;
              end;
            end;

            if Container = WorkplaceContainer then
            begin
               CoInitialize(nil);
              XMLDoc := TXMLDocument.Create(nil);
              try
                XMLDoc.LoadFromFile(FileName);

                RootNode := XMLDoc.DocumentElement;

                if RootNode <> nil then
                begin
                  ObjList := XMLToObject(RootNode);

                  for j := 0 to ObjList.Count - 1 do
                  begin
                    if TbfaBaseDocument(ObjList[j]).Id <> -1 then
                    begin
                      if TbfaBaseDocument(ObjList[j]).SymbolicArcID <> -1 then
                      begin
                        if Params = '' then
                          Params := IntToStr(TbfaBaseDocument ( ObjList[j]).Id)+':' +
                            IntToStr(TbfaBaseDocument ( ObjList[j]).SymbolicArcID)
                        else
                          Params := Params +';'+ IntToStr(TbfaBaseDocument ( ObjList[j]).Id)+':' +
                            IntToStr(TbfaBaseDocument ( ObjList[j]).SymbolicArcID);
                      end
                      else
                      begin
                        if Params = '' then
                          Params := IntToStr(TbfaBaseDocument ( ObjList[j]).Id)+':' +
                            IntToStr(TbfaBaseDocument ( ObjList[j]).ArcID)
                        else
                          Params := Params +';'+ IntToStr(TbfaBaseDocument ( ObjList[j]).Id)+':' +
                            IntToStr(TbfaBaseDocument ( ObjList[j]).ArcID);
                      end;
                    end;
                    Doc := TbfaDocument(ObjList[j]);
                    Doc.FileName := Filename;
                    TempList.Add(Doc);

                    end;
                  end;
              finally
                XMLDoc := nil;
                CoUnInitialize;
              end;
            end;
          end;

          if (Container = WorkplaceContainer) and (Params <> '') then
          begin
            req := TbfaRequest.Create;
            try
              req.ReqType := 'reqAccessable';
              req.UserID := User.ID;
              req.Profile := Self.Profile;

              req.Parameter := Params;
              req.Lang := Lang;
              MainSocket.SendRequestToServer(req);

              req := MainSocket.ReceiveResponse;
              if req = nil then
                Exit;

              if req.ReqType = 'respError' then
                RequestList.DelimitedText := Params
              else
                RequestList.DelimitedText := req.Parameter;
            finally
              FreeAndNil(req);
            end;
          end;

          if Container = FImportContainer then
          begin
            for k := 0 to Lst.Count - 1 do
            begin
              try
                AThread.Synchronize(nil,
                  procedure
                  begin
                    frmMainForm.frmSplash.lblLoading.Caption := msg;
                    frmMainForm.frmSplash.lblInfo.Caption := ' (' + IntToStr(k + 1) +
                      '/' + IntToStr(Lst.Count) + ')';
                    frmMainForm.frmSplash.Update;
                    if not frmMainForm.frmSplash.Showing or
                      ((k = 0) and not frmMainForm.frmSplash.UseTimer) then
                    begin
                      frmMainForm.frmSplash.FormType := sftImporter;
                      frmMainForm.frmSplash.UseTimer := True;
                      frmMainForm.frmSplash.pgbDocuments.Properties.Min := 0;
                      frmMainForm.frmSplash.pgbDocuments.Position := 0;
                      frmMainForm.frmSplash.pgbDocuments.Properties.Max := Lst.Count;
                      frmMainForm.frmSplash.Show;
                    end;
                  end);

//12.03.2021  FileName := TbfaFileObj(Lst[k]).FileName;
                FileName := Lst[k];
                if ((FileName = '') or not FileExists(FileName)) then
                  Continue;

                LoadDocFromXML(Path, FileName, Container);
              except
                on E : Exception do
                begin
                  Inc(ErrorCount);
                  Log.Write(llNormal, ltException, 'LoadDocumentsFromXML - FImportContainer LoadDocFromXML Loop: ' + E.Message, ClassName);
                end;
              end;
            end;
          end else   // Workplace
          begin
            for i := 0 to TempList.Count -1 do
            begin
              try
                Doc := TempList[i];

                if Doc.ID <> -1 then
                begin
                  if Doc.SymbolicArcID > 0 then
                    TempID := IntToStr(Doc.ID) + ':' + IntToStr(Doc.SymbolicArcID)
                  else
                    TempID := IntToStr(Doc.ID) + ':' + IntToStr(Doc.ArcID);

                  if RequestList.IndexOf(TempID) > -1 then
                  begin
                    //10.02.2023 bfacrm:ticket__show__33894 -->
                    //LoadDocumentViaSocket(Doc,'base;fields;paths;iev;text;svn', AThread, False, True);
                    if not bitfarmApp.OfflineMode then
                      LoadDocumentViaSocket(Doc,'base;fields;paths;iev;text;svn', AThread, False, True)
                    else
                      DBLoadDocument(Doc);
                    //10.02.2023 bfacrm:ticket__show__33894 <--
                    Container.Add(Doc);
                  end else
                    Inc(ErrorCount);
                end else
                  LoadDocFromXML(Path, Doc.FileName, Container);
              except
                on E : Exception do
                begin
                  Inc(ErrorCount);
                  Log.Write(llNormal, ltException, 'LoadDocumentsFromXML - Workplace LoadDocFromXML Loop: ' + E.Message, ClassName);
                end;
              end;
            end;
          end;

          if ErrorCount > 0 then
          begin
            if Container = WorkplaceContainer then
              Containername := _('Arbeitsplatz')
            else if Container = ImportContainer then
              Containername := _('Importer');
            if ErrorCount = 1 then
              ErrorMsg := Format(_('Es konnte ein Dokument im %s nicht geladen werden.\n(Ggf. wurde dieses gelscht oder befindet sich nicht mehr im Zugriff)'), [ContainerName])
            else
              ErrorMsg := Format(_('Es konnten %d Dokumene im %s nicht geladen werden.\n(Ggf. wurden diese gelscht oder befinden sich nicht mehr im Zugriff)'),[ErrorCount, ContainerName]);
            BfShowMessage(ErrorMsg, AThread);
          end;

          if Container = FImportContainer then
            RefreshImporterMultiView(AThread, True, Lst.Count)
          else if Container = FWorkplaceContainer then
            RefreshWorkplaceMultiView(AThread, True, TempList.Count);
            // SJ 06.10.2022 - RequestList hat keine Kopien die lokal liegen
//            RefreshWorkplaceMultiView(AThread, True, RequestList.Count);
        end;
      end;
      if Container = FImportContainer then
        frmMainform.InitialLoadImporterDone := true
      else if Container = FWorkplaceContainer then
        frmMainform.InitialLoadWorkplaceDone := true;
    except
      Log.Write(llNormal, ltException, 'LoadDocumentsFromXML', ClassName);
    end;
  finally
    AThread.Synchronize(nil,
      procedure
      begin
        if frmMainForm.frmSplash.Showing then
          frmMainForm.frmSplash.Hide;
      end);
    FreeAndNil(Lst);
    TempList.Clear;
    FreeAndNil(TempList);
    FreeAndNil(RequestList);
    Log.DebugEnd(llDebug, 'LoadDocumentsFromXML', ClassName);
  end;
end;

procedure TbfaApplication.LoadBookmarks(AThread: TThread);
var
  Node: TTreeNode;
begin
  Log.DebugBegin(llDebug, 'LoadBookmarks', ClassName);
  frmMainForm.trvBookmarks.Items.BeginUpdate; //18.01.2023
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          //17.01.2024 bfacrm:ticket__show__37417 -->
          bitfarmLog.Write(llDebug, ltInfo, 'Lade Lesezeichen...', Classname);
          frmMainForm.frmSplash.lblLoading.Caption := sMsgLoadBookmarks;
          frmMainForm.frmSplash.Update;
          if not frmMainForm.frmSplash.Showing then
            frmMainForm.frmSplash.Show;
          //17.01.2024 bfacrm:ticket__show__37417 <--

          with frmMainForm.trvBookmarks.Items do
          begin
            Clear;

            {$IFDEF ENTERPRISE}
            FGlobalListNode := AddObject(nil, _('Globale Lesezeichen'), TbfaNodeInfo.Create(-1, '{558A8CA9-0BE7-4AC6-AFC6-C9F225715CC8}'));
            FGlobalListNode.ImageIndex := Integer(icoidx_bookmark_folder);
            FGlobalListNode.ExpandedImageIndex := Integer(icoidx_bookmark_folder_expanded);
            FGlobalListNode.SelectedIndex := Integer(icoidx_bookmark_folder);
            {$ENDIF}

            FLocalListNode := AddObject(nil, _('Lokale Lesezeichen'), TbfaNodeInfo.Create(-1, '{EC0A26C8-DE15-49FE-BFA1-595CB5760B58}'));
            FLocalListNode.ImageIndex := Integer(icoidx_bookmark_folder);
            FLocalListNode.ExpandedImageIndex := Integer(icoidx_bookmark_folder_expanded);
            FLocalListNode.SelectedIndex := Integer(icoidx_bookmark_folder);
            FHistoryListNode := AddObject(nil, _('Verlaufs-Lesezeichen'), TbfaNodeInfo.Create(-1, '{5E9199CD-FD00-4E71-B7CB-BC63A807A665}'));
            FHistoryListNode.ImageIndex := Integer(icoidx_bookmark_folder);
            FHistoryListNode.ExpandedImageIndex := Integer(icoidx_bookmark_folder_expanded);
            FHistoryListNode.SelectedIndex := Integer(icoidx_bookmark_folder);
          end;
        end);

      {$IFDEF ENTERPRISE}
      LoadBookmarkList(FLog, frmMainForm.trvBookmarks, FGlobalListNode, 2, FUser);
      {$ENDIF}
      LoadBookmarkList(FLog, frmMainForm.trvBookmarks, FLocalListNode, 1, FUser);
      LoadBookmarkList(FLog, frmMainForm.trvBookmarks, FHistoryListNode, 3, FUser);
      ExpandLastBookmarkNodes;

      //25.04.2019 Ticket 19056 -->
      //10.05.2019 Ticket 19057 -->
      AThread.Synchronize(nil,
        procedure
        begin
          if (FHistoryListNode.Count > 0) then
          begin
//            frmMainForm.actBack.Enabled := True; // SJ 12.06.2023
//            frmMainForm.actForward.Enabled := False; // SJ 12.06.2023
            SetBlueArrows; // SJ 12.06.2023
          end;
        end);
      //25.04.2019 Ticket 19056 <--
      //10.05.2019 Ticket 19057 <--
    except
      Log.Write(llNormal, ltException, 'LoadBookmarks', ClassName);
    end;
  finally
    frmMainForm.trvBookmarks.Items.EndUpdate; //18.01.2023
    AThread.Synchronize(nil,
      procedure
      begin
        if frmMainForm.frmSplash.Showing then
          frmMainForm.frmSplash.Hide;
      end);
    Log.DebugEnd(llDebug, 'LoadBookmarks', ClassName);
  end;
end;

procedure TbfaApplication.LoadCommentary(Doc: TbfaDocument; AThread: TThread);
begin
  Log.DebugBegin(llDebug, 'LoadCommentary', ClassName);
  try

    AThread.Synchronize(nil,
      procedure
      begin
        FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.CommentaryView.LoadCommentary(Doc.Id);
      end);

  finally
    Log.DebugEnd(llDebug, 'LoadCommentary', ClassName);
  end;
end;

procedure TbfaApplication.RefreshImporterCounter;
begin
  try
    frmMainForm.fraImporter.lblImportObjects.Caption := IntToStr(FImportContainer.Count) + _(' Objekte');
    RefreshPanelCaption(FPreviewContainer.ImporterItem.Panel.Tag);
    frmMainForm.pnlImporter.Caption := 'Importer (' + IntToStr(FImportContainer.Count) + ')';
  except
    Log.Write(llNormal, ltException, 'RefreshImporterCounter', ClassName);
  end;
end;

procedure TbfaApplication.SetImporterObjectCount(AThread: TThread);
begin
  try
    AThread.Synchronize(nil,
      procedure
      begin
        try
          RefreshImporterCounter;
        except
          Log.Write(llNormal, ltException, 'SetImporterObjectCount - Synchronize - ThreadID:' + IntToStr(AThread.ThreadID), ClassName);
        end;
      end);
  except
    Log.Write(llNormal, ltException, 'SetImporterObjectCount', ClassName);
  end;
end;

procedure TbfaApplication.RefreshImporterMultiView(AThread: TThread; Add: Boolean; cnt: Integer = -1);
begin
  try
    try
      RefreshMainMultiView(AThread, FPreviewContainer.ImporterItem.Preview, FImportContainer, Add, frmMainForm.frmSplash, cnt);
      SetImporterObjectCount(AThread);
    except
      Log.Write(llNormal, ltException, 'RefreshImporterMultiView', ClassName);
    end;
  finally
    if cnt = -1 then
      AThread.Synchronize(nil,
        procedure
        begin
          frmMainForm.frmSplash.Hide;
        end);
  end;
end;

procedure TbfaApplication.RefreshMultiView(AThread: TThread; prev: TbfaPreview; sList: TStringList);
var
  Add: Boolean;
begin
  try
    try
      if StrToInt(sList[0]) = 1 then
        Add := True
      else
        Add := False;

      RefreshMainMultiView(AThread, prev, prev.List, Add, frmMainForm.frmSplash);
      RefreshPreviewCounter(AThread, prev);

    except
      Log.Write(llNormal, ltException, 'RefreshMultiView', ClassName);
    end;
  finally
    if not Add then
      AThread.Synchronize(nil,
        procedure
        begin
          frmMainForm.frmSplash.Hide;
        end);
  end;
end;

procedure TbfaApplication.RefreshPreviewCounter(AThread: TThread; prev: TbfaPreview);
begin
  if prev = FPreviewContainer.ImporterItem.Preview then
    SetImporterObjectCount(AThread)
  else if prev = FPreviewContainer.WorkplaceItem.Preview then
    SetWorkplaceObjectCount(AThread);
end;

procedure TbfaApplication.RefreshWorkplaceMultiView(AThread: TThread; Add: Boolean; cnt: Integer = -1);
begin
  try
    try
      RefreshMainMultiView(AThread, FPreviewContainer.WorkplaceItem.Preview, FWorkplaceContainer, Add, frmMainForm.frmSplash, cnt);

      SetWorkplaceObjectCount(AThread);
    except
      Log.Write(llNormal, ltException, 'RefreshWorkplaceMultiView', ClassName);
    end;
  finally
    if cnt = -1 then
      AThread.Synchronize(nil,
        procedure
        begin
          frmMainForm.frmSplash.Hide;
        end);
  end;
end;

procedure TbfaApplication.SetWorkplaceObjectCount(AThread: TThread);
begin
  try
    AThread.Synchronize(nil,
      procedure
      begin
        Log.DebugBegin(llDebug, 'SetWorkplaceObjectCount - Synchronize - ThreadID:' + IntToStr(AThread.ThreadID), ClassName);
        try
          try
            frmMainForm.fraWorkplace.lblWorkplaceObjects.Caption := IntToStr(FWorkplaceContainer.Count) + _(' Objekte');
            RefreshPanelCaption(FPreviewContainer.WorkplaceItem.Panel.Tag);
            frmMainForm.pnlWorkspace.Caption := _('Arbeitsplatz') + ' (' + IntToStr(FWorkplaceContainer.Count) + ')';
          except
            Log.Write(llNormal, ltException, 'SetWorkplaceObjectCount - Synchronize - ThreadID:' + IntToStr(AThread.ThreadID), ClassName);
          end;
        finally
          Log.DebugEnd(llDebug, 'SetWorkplaceObjectCount - Synchronize - ThreadID:' + IntToStr(AThread.ThreadID), ClassName);
        end;

      end);
  except
    Log.Write(llNormal, ltException, 'SetWorkplaceObjectCount', ClassName);
  end;
end;

procedure TbfaApplication.MViewDragDrop(AThread: TThread; prev: TbfaPreview; sList: TStringList; Objs: TList);
var
  Move: Boolean;
  imgpos: Integer;
begin
  try
    if StrToInt(sList[2]) = 1 then
      Move := True
    else
      Move := False;

    try
      if (sList.Count > 3) then
        imgpos := StrToInt(sList[3]);
    except
      imgpos := -1;
    end;

    bfaCommonImageEN.MViewDragDrop(AThread, Objs[0], Objs[1], StrToInt(sList[0]), StrToInt(sList[1]), Move, imgpos, False, frmMainForm.frmSplash);

    if Assigned(bitfarmApp.DragObject) then
    begin
      //10.05.2023 -->
      if bitfarmApp.DragObject.Cloned and (bitfarmApp.DragObject.DocumentList.Count > 0) then
      begin
        for var i := 0 to bitfarmApp.DragObject.DocumentList.Count - 1 do
        begin
//29.08.2023 -->
//          AThread.Synchronize(nil,
//            procedure
//            begin
//              try
//                TbfaDocument(bitfarmApp.DragObject.DocumentList[i]).Free;
//              except
//                //
//              end;
//            end);
          {$IFDEF IMAGEEN_SYNCHRONIZED}
          AThread.Synchronize(nil,
            procedure
            begin
              try
                TbfaDocument(bitfarmApp.DragObject.DocumentList[i]).Free;
              except
                //
              end;
            end);
          {$ELSE}
          try
            TbfaDocument(bitfarmApp.DragObject.DocumentList[i]).Free;
          except
            //
        end;
          {$ENDIF}
//29.08.2023 <--
      end;
      end;
      //10.05.2023 <--
      bitfarmApp.DragObject.Free;
      bitfarmApp.DragObject := nil;
    end;

    if (FCurrentContainer.Count > 0) and (FCurrentContainer[0] <> nil) then
      CallShowDocument(FCurrentContainer[0], nil, nil, 0, 0, True, False, False, False, False, True, prev, False);

  except
    Log.Write(llNormal, ltException, 'MViewDragDrop', ClassName);
  end;
end;

procedure TbfaApplication.DeletePagesFromDocument(AThread: TThread; prev: TbfaPreview; sList: TStringList; Objs: TList);
begin
  bfaCommonImageEN.DeletePagesFromDocument(AThread, Objs[0], sList, Objs[1]);
end;

procedure TbfaApplication.DeleteResubFavs(Index: Integer);
var
  ALength: Cardinal;
  i: Cardinal;
begin
  ALength := Length(aResubFavs);
  Assert(ALength > 0);
  Assert(Index < ALength);
  for i := Index + 1 to ALength - 1 do
  begin
    aResubFavs[i - 1] := aResubFavs[i];
    aResubFavs[i - 1].modified := True;
  end;
  SetLength(aResubFavs, ALength - 1);

end;

procedure TbfaApplication.ShowDocument(Params: TStringList; prev: TbfaPreview; Objects: TList; Documents: TList; AThread: TThread);
var
  SetCurrent, ReloadThumbs, InEditMode, Reload, InNewTab, InBackGroundTab, Setfocus: Boolean;
  ChangeToMultiSingle, SetImagePos, SetImagePosTothetop, Autozoom, Floating, MouseClick: Boolean;
  i, PageDirection: Integer;
begin
  SetCurrent := (Params[2] = '1');
  InNewTab := (Params[3] = '1');
  InBackGroundTab := (Params[4] = '1');
  InEditMode := (Params[5] = '1');
  Setfocus := (Params[6] = '1');
  ReloadThumbs := (Params[7] = '1');
  ChangeToMultiSingle := (Params[8] = '1');
  Reload := (Params[9] = '1');
  // Params[10] = SearchString
  SetImagePos := (Params[11] = '1');
  SetImagePosTothetop := (Params[12] = '1');
  Autozoom := true;
  if (Params.Count >= 13) then
    Autozoom := (Params[13] = '1');
  PageDirection := StrToInt(Params[14]);
  Floating := (Params[15] = '1');
  MouseClick := (Params[16] = '1'); //12.07.2024 bfacrm:ticket__show__39299

  // beim Anzeigen eines neuen Dokumentes immer auf Public Layer schalten

  if (prev = nil) or ((Documents <> nil) and (Documents.Count > 0) and (prev.ActiveDoc <> Documents[0])) then
    AThread.Synchronize(nil,
      procedure
      begin
        frmMainForm.bfaTlbPreview1.mnuPublicAnno.Checked := True;
        frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Checked := False;
        if prev <> nil then
        begin
          prev.bfaTlbPreview.mnuPublicAnno.Checked := True;
          prev.bfaTlbPreview.mnuPrivateAnno.Checked := False;
          prev.SetCurrentLayer(0);
        end;
      end);

//05.08.2024 SD -->bfacrm:ticket__show__39527
//03.07.2024 -->
//  //21.06.2024 SD -->bfacrm:ticket__show__35622
//  //Wenn andere Tab beim klick auf Grid aktiv ist, sollte der Hauptviewer aktiv sein
//  if (prev <> nil) and (not InNewTab ) and (bitfarmApp.CurrentView in [tvkViewer, tvkResub, tvkFavorites]) and
//      (frmMainForm.tstDocumentEditors.ActiveTab <> FPreviewContainer.ViewerItem.Tab) then
//	  FPreviewContainer.ActiveItem := pvtViewer;
//  //21.06.2024 SD <--bfacrm:ticket__show__35622


//    if (prev <> nil) and (not InNewTab ) and (bitfarmApp.CurrentView in [tvkViewer, tvkResub, tvkFavorites]) and
//        (frmMainForm.tstDocumentEditors.ActiveTab <> FPreviewContainer.ViewerItem.Tab) then
//    begin
//      //24.11.2021 bt wenn andere Tab aktiv ist als Viewer beim klick auf Grid, muss zurck -->
//      if bitfarmApp.CurrentView in [tvkViewer, tvkResub, tvkFavorites] then
//        SetActiveView(AThread, pvtViewer, nil, integer(bitfarmApp.CurrentView))
//      else
//      //24.11.2021 bt wenn andere Tab aktiv ist als Viewer beim klick auf Grid, muss zurck <--
//        frmMainForm.pnlTreeView.Maximize;
//    end;
//03.07.2024 <--
//05.08.2024 SD <--bfacrm:ticket__show__39527

  if Documents.Count = 1 then
    bfaPreview36.ShowDocument(AThread, Documents[0], nil, prev, StrToInt(Params[1]),
      SetCurrent, InNewTab, InBackGroundTab, TbfaImageEnMView(Objects[0]), ReloadThumbs,
      InEditMode, Setfocus, Reload, ChangeToMultiSingle, frmMainForm.pnlSearchTimer,
      frmMainForm.pnlLoadDoc, Params[10], SetImagePos, SetImagePosTothetop, Autozoom,
      PageDirection, Floating, MouseClick)
  else if Documents.Count > 1 then
    bfaPreview36.ShowDocument(AThread, nil, TList<TbfaDocument>(Documents), prev,
      StrToInt(Params[1]), SetCurrent, InNewTab, InBackGroundTab, TbfaImageEnMView(Objects[0]),
      ReloadThumbs, InEditMode, Setfocus, Reload, ChangeToMultiSingle,
      frmMainForm.pnlSearchTimer, frmMainForm.pnlLoadDoc, Params[10], SetImagePos,
      SetImagePosTothetop, Autozoom, PageDirection, Floating, MouseClick);

  //05.08.2024 SD -->bfacrm:ticket__show__39527
  //wenn andere Tab aktiv ist als Viewer beim klick auf Grid, muss zurck (auer beim Klicken auf das Thumbnail)
  if (prev <> nil) and (not InNewTab ) and (bitfarmApp.CurrentView in [tvkViewer, tvkResub, tvkFavorites]) and
      (frmMainForm.tstDocumentEditors.ActiveTab <> FPreviewContainer.ViewerItem.Tab) and (Not MouseClick) then
  begin
    SetActiveView(AThread, pvtViewer, nil, integer(bitfarmApp.CurrentView))
  end;
  //05.08.2024 SD <--bfacrm:ticket__show__39527

  if prev <> nil then
  begin
    if not InNewTab then //23.01.2017
      prev.SetCurrentLayer(prev.CurrentLayer);   // zum Aktualisieren der Rechte
//03.07.2024
//    //<!-- bt 11.07.2023 - bfacrm:ticket__show__35622
//    if prev = FPreviewContainer.ViewerItem.Preview then
//    begin
//      if ((not InNewTab) and
//          (frmMainForm.tstDocumentEditors.ActiveTab <> FPreviewContainer.ViewerItem.Tab)) then
//      begin
//        //24.11.2021 bt wenn andere Tab aktiv ist als Viewer beim klick auf Grid, muss zurck -->
//        if bitfarmApp.CurrentView in [tvkViewer, tvkResub, tvkFavorites] then
//          SetActiveView(AThread, pvtViewer, nil, integer(bitfarmApp.CurrentView))
//        else
//        //24.11.2021 bt wenn andere Tab aktiv ist als Viewer beim klick auf Grid, muss zurck <--
//          frmMainForm.pnlTreeView.Maximize;
//      end;
//    end;
//    // bt 11.07.2023 - bfacrm:ticket__show__35622 -->
    AThread.Synchronize(nil,
      procedure
      begin
        if prev.ActiveDoc <> nil then
          frmMainForm.SetStatusBarID(prev.ActiveDoc.ArcID, prev.ActiveDoc.ID, GUIDToString(prev.ActiveDoc.TempID));

        if (prev.ActiveDoc <> nil) and (prev.ActiveDoc.InEditMode) then
        begin
          if (bitfarmApp.LastUsedAnnoTool <> '') and ViewerOptions.EditorOptions.RememberLastTool then
          begin
            bitfarmLog.Write(llDebug, ltDebug, 'RememberLastTool', ClassName);
            if (bitfarmApp.LastUsedAnnoTool <> prev.tbi_stampdialog.Name) then
            begin
              for var i := 0 to prev.AnnoToolbar.Items.Count - 1 do
              begin
                // SubMenuItems mssen rekursiv durchlaufen werden.
                if prev.AnnoToolbar.Items[i] is TSpTBXSubmenuItem then
                begin
                  var AItem: TSpTBXItem;
                  AItem := FindToolbarSubmenuItemByName(LastUsedAnnoTool, prev.AnnoToolbar.Items[i]);
                  if AItem <> nil then
                  begin
                    AItem.Click;
                    Break;
                  end;
                end else if prev.AnnoToolbar.Items[i] is TSpTBXItem then
                begin
                  if (LastUsedAnnoTool = prev.AnnoToolbar.Items[i].Name) then
                  begin
                    prev.AnnoToolbar.Items[i].Click;
                    Break;
                  end;
                end;
              end;
            end else if (prev.ActiveDoc <> nil) and (prev.ActiveDoc.InEditMode) and
                        (bitfarmApp.LastSelectedStamp <> '') then
            begin
              prev.UnCheckAllGraphicTools;
              prev.tbi_normalmouse.Checked := False;
              prev.tbi_stampdialog.Checked := True;
              prev.SingleView.LoadStamp(bitfarmApp.LastSelectedStamp);
            end;
          end else
          begin
//21.11.2023 bfacrm:ticket__show__36926 -->
            if (prev.ActiveDoc <> nil) and (prev.ActiveDoc.InEditMode) and
                        (bitfarmApp.LastSelectedStamp <> '') then
            begin
              if bitfarmApp.LastSelectedStampTool <> bitfarmApp.LastUsedAnnoTool then
              begin
                prev.UnCheckAllGraphicTools;
                prev.tbi_normalmouseClick(nil);
              end;
            end
            else
            begin
//21.11.2023 bfacrm:ticket__show__36926 <--
              prev.UnCheckAllGraphicTools;
              prev.tbi_normalmouseClick(nil);
            end; //21.11.2023 bfacrm:ticket__show__36926
          end;
        end else
        begin
          prev.UnCheckAllGraphicTools;
          prev.tbi_normalmouseClick(nil);
        end;
      end);
  end;
end;

function TbfaApplication.GetInResubSQLText(Doc: TbfaBaseDocument): string;
begin
  Result := 'select t.groupid, t.userid_work, su.displayname, gr.groupname  from sys_timer as t ' + 'left join sys_user su on t.userid_work = su.userid ' + 'left join sys_group gr on t.groupid = gr.groupid ' + 'where ((t.userid_work <> 0 and t.groupid = 0) or t.groupid <> 0) ' + 'and (status & 4 = 0) and gdocid = ' + IntToStr(Doc.ID);
end;

procedure TbfaApplication.SetDocState(Doc: TbfaDocument);
var
  UserName: string;
  item: TSpTBXItem;
  i: Integer;
  AUserList, AGroupList, AGroupUserList: TStringList;
  ismyresub: Boolean;
  wf: TbfaWorkflow;
  sMenuCaption, sDisplayName, sGroupName: string;
  sItemInResubHint: WideString;
  IsDocInResub: Boolean;
  IsMyresubAndfromUserInHoliday: Boolean;
  slOwnResubs: TStringList;
  sUser, sInfo: string;
begin
  Log.DebugBegin(llDebug, 'SetDocState', ClassName);
  ismyresub := False;
  try
    try
      if Doc <> nil then
      begin
        if Doc.ID <> -1 then
          Log.Write(llDebug, ltInfo, 'DocID: ' + IntToStr(Doc.ID), ClassName)
        else
          Log.Write(llDebug, ltInfo, 'Doc TempID: ' + GUIDToString(Doc.TempID), ClassName);

        if Doc.InEditMode then
          frmMainForm.clItemInProgress.ImageIndex := Integer(icoidx_edit_enabled)
        else
          frmMainForm.clItemInProgress.ImageIndex := Integer(icoidx_edit_unselected);
        if Doc.EditModeUserID <> 0 then
        begin
          frmMainForm.clItemInProgress.ImageIndex := Integer(icoidx_edit_enabled);
          UserName := DBGetUserName(Doc.EditModeUserID);
          frmMainForm.popInEditmode.Items.Clear;
          item := TSpTBXItem.Create(frmMainForm.popInEditmode);
          item.Caption := Format(_('Dokument in Bearbeitung von %s'), [UserName]);
          item.Enabled := True;
          item.Visible := True;
          frmMainForm.popInEditmode.Items.Add(item);
        end;

        if Doc.RevSave then
        begin
          frmMainForm.clItemIsAuditProof.ImageIndex := Integer(icoidx_lock);
          frmMainForm.clItemIsAuditProof.Hint := _('Das Dokument ist revisionssicher abgelegt.');
          frmMainForm.mnuAuditProof.ImageIndex := Integer(icoidx_lock);
          frmMainForm.mnuAuditProof.Hint := _('Das Dokument ist revisionssicher abgelegt.');
        end
        else
        begin
          frmMainForm.clItemIsAuditProof.ImageIndex := Integer(icoidx_lock_no);
          if not Doc.InEditMode then
            frmMainForm.clItemIsAuditProof.Hint := _('Die Originaldatei ist bearbeitbar.')
          else
            frmMainForm.clItemIsAuditProof.Hint := _('Legt das aktuelle Dokument revisionssicher im Archiv ab.');
          frmMainForm.mnuAuditProof.ImageIndex := Integer(icoidx_lock_no);
          if not Doc.InEditMode then
            frmMainForm.mnuAuditProof.Hint := _('Die Originaldatei ist bearbeitbar.')
          else
            frmMainForm.mnuAuditProof.Hint := _('Legt das aktuelle Dokument revisionssicher im Archiv ab.');
        end;

        frmMainForm.popDocLinks.Items.Clear;
        if Length(Doc.DocLinkList) > 0 then
        begin
          frmMainForm.clItemLinks.ImageIndex := Integer(icoidx_link_enabled);
          for i := Low(Doc.DocLinkList) to High(Doc.DocLinkList) do
          begin
            item := TSpTBXItem.Create(frmMainForm.popDocLinks);
            item.Caption := Doc.DocLinkList[i].Refname;
            if FViewerOptions.GeneralOptions.ShowLinkCount then
              item.Caption := item.Caption + ' (' + IntToStr(Doc.DocLinkList[i].count) + ')';
            item.Tag := Doc.DocLinkList[i].RefID;
            item.Enabled := True;
            item.Visible := True;
            item.OnClick := popDocLinksOnClick;
            frmMainForm.popDocLinks.Items.Add(item);
          end;

          if frmMainForm.popDocLinks.Items.Count = 1 then
            frmMainForm.clItemLinks.Hint := s(_('Verknpfung gefunden\nZu diesem Dokument gibt es\neine Verknpfung.'))
          else
            frmMainForm.clItemLinks.Hint := Format(s(_('Verknpfungen gefunden.\nZu diesem Dokument gibt es \n%d Verknpfungen.')), [frmMainForm.popDocLinks.Items.Count]);
        end
        else
        begin
          frmMainForm.clItemLinks.ImageIndex := Integer(icoidx_link_unselected);
          frmMainForm.clItemLinks.Hint := _('keine Verknpfung vorhanden');
        end;

        if Doc.OriLoc <> '' then
          frmMainForm.clItemOriginalfile.ImageIndex := Integer(icoidx_original_file_enabled)
        else
          frmMainForm.clItemOriginalfile.ImageIndex := Integer(icoidx_original_file_unselected);

        try
          IsDocInResub := false;
          IsMyresubAndfromUserInHoliday := false;
          AUserList := TStringList.Create;
          AGroupList := TStringList.Create;
          slOwnResubs := TStringList.Create;
          sItemInResubHint := '';
          for i := 0 to Doc.Workflows.Count - 1 do
          begin
            wf := Doc.Workflows[i];
            if (((wf.UseridWork <> 0) and (wf.GroupId = 0)) or (wf.GroupId <> 0)) and ((wf.status and 4) = 0) then
            begin
              IsDocInResub := true;     // Dokument befindet sich in einer Wiedervorlage
              if wf.GroupId = 0 then
              begin
                sDisplayName := DBGetUserName(wf.UseridWork);
                if AUserList.IndexOf(sDisplayName) = -1 then
                  AUserList.Add(sDisplayName);
              end
              else
              begin
                sGroupName := DBGetGroupName(wf.GroupId);
                if AGroupList.IndexOf(sGroupName) = -1 then
                begin
                  AGroupUserList := TStringList.Create;
                  AGroupUserList.Add(wf.UseridWork.ToString);
                  AGroupList.AddObject(sGroupName, AGroupUserList);
                end else
                begin
                  AGroupUserList := TStringList(AGroupList.Objects[AGroupList.IndexOf(sGroupName)]);
                  AGroupUserList.Add(wf.UseridWork.ToString);
                end;
              end;

              if wf.UseridWork = user.ID then
                ismyresub := True;

              if (bitfarmApp.User.HolidayList.IndexOf(IntToStr(wf.UseridWork)) >= 0) then
              begin
                IsMyresubAndfromUserInHoliday := True;
                sMenuCaption := _('Eigene Wiedervorlage');
                sUser := '';
                sInfo := '';
                if (wf.UseridWork <> user.ID) then
                begin
                  sMenuCaption := _('Wiedervorlage');
                  sUser := ', ' + DBGetUserName(wf.UseridWork);
                end;
                if wf.Info <> '' then
                  sInfo := ', ' + wf.Info;
                sMenuCaption := sMenuCaption + ' (' + FormatDateTime('dd.mm.yyyy', wf.Date) + sInfo + sUser + ') ' + _('fertig setzen');
                slOwnResubs.AddObject(sMenuCaption, TbfaInt64.Create(wf.TimID));
              end;
            end;
          end;

          //if lmq.RecordCount > 0 then
          if IsDocInResub then
          begin
            frmMainForm.clItemInResub.ImageIndex := Integer(icoidx_clock_enabled);
          end
          else
          begin
            frmMainForm.clItemInResub.ImageIndex := Integer(icoidx_clock_unselected);
            frmMainForm.clItemInResub.FontSettings.Style := [];
          end;

          frmMainForm.popInResub.Items.Clear;
          if ismyresub and (CurrentView <> tvkResub) then
          begin
            item := TSpTBXItem.Create(frmMainForm.popInResub);
            item.Caption := _('in Wiedervorlagenliste anzeigen');
            item.Enabled := True;
            item.Visible := True;
            item.Action := frmMainForm.actShowInResub;
            frmMainForm.popInResub.Items.Add(item);
          end;

          if IsMyresubAndfromUserInHoliday and (CurrentView <> tvkResub) then
          begin
            for i := 0 to slOwnResubs.Count - 1 do
            begin
              item := TSpTBXItem.Create(frmMainForm.popInResub);
              item.Caption := slOwnResubs.Strings[i];
              item.Enabled := True;
              item.Visible := True;
              item.OnClick := OnClickSetOwnResubDone;
              item.Tag := integer(slOwnResubs.Objects[i]); // Zeiger auf die timId
              frmMainForm.popInResub.Items.Add(item);
            end;
          end;

          if AUserList.Count > 0 then
          begin
            item := TSpTBXItem.Create(frmMainForm.popInResub);
            item.Caption := _('Benutzer:') + ' ' + AUserList.CommaText;
            item.Enabled := True;
            item.Visible := True;
            frmMainForm.popInResub.Items.Add(item);
          end;

          if AGroupList.Count > 0 then
          begin
            item := TSpTBXItem.Create(frmMainForm.popInResub);
            item.Caption := _('Gruppen:') + ' ' + AGroupList.CommaText;
            item.Enabled := True;
            item.Visible := True;
            frmMainForm.popInResub.Items.Add(item);
          end;

          try
            if (AUserList.Count = 1) and (AGroupList.Count = 0) then
              sItemInResubHint := Format(_('Auf Wiedervorlage bei Benutzer %s'), [AUserList.CommaText])
            else if (AUserList.Count > 1) and (AGroupList.Count = 0) then
              sItemInResubHint := Format(_('Auf Wiedervorlage bei Benutzern %s'), [AUserList.CommaText])
            else if (AUserList.Count = 0) and (AGroupList.Count = 1) then
              sItemInResubHint := Format(_('Auf Wiedervorlage bei Gruppe %s'), [ExtendedGroupList(AGroupList)])
            else if (AUserList.Count = 0) and (AGroupList.Count > 1) then
              sItemInResubHint := Format(_('Auf Wiedervorlage bei Gruppen %s'), [ExtendedGroupList(AGroupList)])
            else if (AUserList.Count = 1) and (AGroupList.Count = 1) then
              sItemInResubHint := Format(_('Auf Wiedervorlage bei Benutzer %s und Gruppe %s'), [AUserList.CommaText, ExtendedGroupList(AGroupList)])
            else if (AUserList.Count > 1) and (AGroupList.Count = 1) then
              sItemInResubHint := Format(_('Auf Wiedervorlage bei Benutzern %s und Gruppe %s'), [AUserList.CommaText, ExtendedGroupList(AGroupList)])
            else if (AUserList.Count = 1) and (AGroupList.Count > 1) then
              sItemInResubHint := Format(_('Auf Wiedervorlage bei Benutzer %s und Gruppen %s'), [AUserList.CommaText, ExtendedGroupList(AGroupList)])
            else if (AUserList.Count > 1) and (AGroupList.Count > 1) then
              sItemInResubHint := Format(_('Auf Wiedervorlage bei Benutzern %s und Gruppen %s'), [AUserList.CommaText, ExtendedGroupList(AGroupList)]);
          except
            Log.Write(llNormal, ltException, 'SetDocState - sItemInResubHint', ClassName);
          end;

        finally
          try
            frmMainForm.clItemInResub.Hint := sItemInResubHint;
          except
            Log.Write(llNormal, ltException, 'SetDocState - clItemInResub.Hint', ClassName);
          end;
          FreeAndNil(AUserList);
          FreeAndNil(AGroupList);
          FreeAndNil(AGroupUserList);
          slOwnResubs.Free;
        end;
        if Doc.CheckOutUserID <> -1 then
          frmMainForm.clItemCheckout.ImageIndex := Integer(icoidx_checkout_disabled)
        else
          frmMainForm.clItemCheckout.ImageIndex := Integer(icoidx_checkout_unselected);
      end else
      begin
        frmMainForm.popInEditmode.Items.Clear;
        frmMainForm.clItemCheckout.ImageIndex := Integer(icoidx_checkout_unselected);
        frmMainForm.clItemInProgress.ImageIndex := Integer(icoidx_edit_unselected);
        frmMainForm.clItemLinks.ImageIndex := Integer(icoidx_link_unselected);
        frmMainForm.clItemLinks.Hint := '';
        frmMainForm.clItemOriginalfile.ImageIndex := Integer(icoidx_original_file_unselected);
        frmMainForm.clItemIsAuditProof.ImageIndex := Integer(icoidx_lock_no);
        frmMainForm.clItemIsAuditProof.Hint := '';
        frmMainForm.mnuAuditProof.ImageIndex := Integer(icoidx_lock_no);
        frmMainForm.mnuAuditProof.Hint := '';
        frmMainForm.clItemInResub.Hint := '';
        if not FSearchInResub then
        begin
          frmMainForm.clItemInResub.Imageindex := Integer(icoidx_clock_unselected);
          frmMainForm.clItemInResub.FontSettings.Style := [];
        end;
      end;

      SetDocLinkActions;

    except
      Log.Write(llNormal, ltException, 'SetDocState', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'SetDocState', ClassName);
  end
end;

procedure TbfaApplication.SetEditModeList(EditIds: string; AThread: TThread);
begin
  if EditIds <> '' then
    frmMainForm.grdResultListDevExView.FInEditMode.CommaText := EditIds
  else
    frmMainForm.grdResultListDevExView.FInEditMode.Clear;
  if AThread <> nil then
  begin
    AThread.Synchronize(nil,
      procedure
      begin
        frmMainForm.grdResultListDevExView.Invalidate;
      end);
  end
  else
    frmMainForm.grdResultListDevExView.Invalidate;
end;

procedure TbfaApplication.SetDocLinkActions;
var
  prev : TbfaPreview;
begin
  if not frmMainForm.fAppStarted then //19.09.2019
    Exit;

  Log.DebugBegin(llDebug, 'SetDocLinkActions', ClassName);
  try
    try
      if FCurrentContainer.Count > 0 then
      begin
        if Assigned(frmMainForm) then
        begin
          prev := bitfarmApp.GetActivePreview;
          if Assigned(frmMainForm.fraDocLinks) then
          begin
            if (FPreviewContainer.ActiveItem <> -1) and
               (FPreviewContainer.ActiveItem < FPreviewContainer.Containers.Count) and
               (prev <> nil) then
            begin
              frmMainForm.actAddLink.Enabled := (FCurrentContainer[0] <> nil) and
                (FCurrentContainer[0].Id <> -1) and (bitfarmApp.CurrentView <> tvkAdministrator) and
                ((FCurrentContainer[0].Rights and rightLink) = rightLink) and
                (frmMainForm.fraDocLinks.LastLink <> '') and not bitfarmApp.OfflineMode;  //22.08.2017
//              frmMainForm.actNewLink.Enabled := frmMainForm.actAddLink.Enabled; //04.09.2024SD <--bfacrm:ticket__show__39649 der Menpunkt Neue Verknpfung erzeugen sollte verfgbar sein, wenn das aktuelle Dokument existiert
              frmMainForm.actNewLink.Enabled := (FCurrentContainer[0] <> nil) and (FCurrentContainer[0].Id <> -1)
                and (bitfarmApp.CurrentView <> tvkAdministrator) and ((FCurrentContainer[0].Rights and rightLink) = rightLink) and
                not bitfarmApp.OfflineMode;  //25.09.2024 SD <--bfacrm:ticket__show__40064  fraDocLinks.LastLink sollte die Erstellung eines neuen Links nicht verhindern
            end;
            frmMainForm.fraDocLinks.btnNewLink.Enabled := frmMainForm.actNewLink.Enabled;
            frmMainForm.fraDocLinks.edtDocLink.Enabled := frmMainForm.actNewLink.Enabled;
            frmMainForm.fraDocLinks.btnAddAutoReference.Enabled := frmMainForm.actAutoRef.Enabled;
            frmMainForm.fraDocLinks.btnAddLink.Enabled := frmMainForm.actAddLink.Enabled;
            frmMainForm.fraDocLinks.btnRemoveLink.Enabled := frmMainForm.actRemoveLink.Enabled and
              (frmMainForm.fraDocLinks.lvwDocLink.Items.Count > 0);
            frmMainForm.fraDocLinks.btnDeleteLink.Enabled := frmMainForm.actDeleteLink.Enabled and
              (frmMainForm.fraDocLinks.lvwDocLink.Items.Count > 0);

            if frmMainForm.fraDocLinks.lvwDocLink.Items.Count > 0 then
            begin
              frmMainForm.fraDocLinks.lvwDocLink.ItemIndex := 0;
            frmMainForm.fraDocLinks.lvwDocLink.TabStop := True;
            end;

            if (frmMainForm.fraDocLinks.LastLink <> '') then
            begin
              frmMainForm.actAddLink.Caption := Format(_('Aktuelles Dokument mit %s verknpfen'),
                [frmMainForm.fraDocLinks.LastLink]); //22.08.2017
              frmMainForm.actAddLink.Hint := frmMainForm.actAddLink.Caption;
              if (prev <> nil) then
              begin
              prev.actAddLink.Caption := frmMainForm.actAddLink.Caption; //05.11.2019
              prev.actAddLink.Hint := frmMainForm.actAddLink.Caption; //05.11.2019
              end;
              frmMainForm.fraDocLinks.btnAddLink.Hint := frmMainForm.actAddLink.Hint;
            end
            else
            begin
              frmMainForm.actAddLink.Caption := _('Zu Verknpfung hinzufgen');
              frmMainForm.actAddLink.Hint := _('Zur Zeit ist keine Verknpfung aktiv.');

              if(prev <> nil) then     // nil preview causes an exception   9/30/2020
              begin
                prev.actAddLink.Caption := frmMainForm.actAddLink.Caption; //05.11.2019
              prev.actAddLink.Hint := frmMainForm.actAddLink.Caption; //05.11.2019
              end;
            frmMainForm.actAddLink.Hint := frmMainForm.actAddLink.Hint;
            frmMainForm.fraDocLinks.btnAddLink.Hint := frmMainForm.actAddLink.Hint;
            end;
          end
          else
          begin
            frmMainForm.actAddLink.Enabled := False;
            frmMainForm.actAddLink.Caption := _('Zu Verknpfung hinzufgen');
            frmMainForm.actAddLink.Hint := _('Zur Zeit ist keine Verknpfung aktiv.');
            if (FPreviewContainer.ActiveItem <> -1) and (FPreviewContainer.ActiveItem < FPreviewContainer.Containers.Count) and
               (prev <> nil) then
            begin
              frmMainForm.actAddLink.Enabled := False;
              prev.actAddLink.Caption := frmMainForm.actAddLink.Caption; //05.11.2019
              prev.actAddLink.Hint := frmMainForm.actAddLink.Caption; //05.11.2019
            end;
            end;
          end;
      end
      else
      begin
        if Assigned(frmMainForm) then
        begin
          frmMainForm.actNewLink.Enabled := False;
          frmMainForm.actAutoRef.Enabled := False;
          if Assigned(frmMainForm.fraDocLinks) then
          begin
            frmMainForm.actAddLink.Enabled := False;
            frmMainForm.fraDocLinks.btnNewLink.Enabled := frmMainForm.actNewLink.Enabled;
            frmMainForm.fraDocLinks.edtDocLink.Enabled := frmMainForm.actNewLink.Enabled;
            frmMainForm.fraDocLinks.btnAddAutoReference.Enabled := frmMainForm.actAutoRef.Enabled;
            frmMainForm.fraDocLinks.btnAddLink.Enabled := frmMainForm.actAddLink.Enabled;
            frmMainForm.fraDocLinks.btnRemoveLink.Enabled := False;
            frmMainForm.fraDocLinks.btnDeleteLink.Enabled := False;
            frmMainForm.fraDocLinks.lvwDocLink.Items.Clear;
            frmMainForm.fraDocLinks.lvwDocLink.TabStop := False;
          end;
        end;
      end;
    except
      Log.Write(llNormal, ltException, 'SetDocLinkActions', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'SetDocLinkActions', ClassName);
  end
end;

function bfaSortProc(List: TStringList; Index1, Index2: Integer): Integer;
var
  Value1, Value2: Integer;
begin
  Value1 := StrToInt(List[Index1]);
  Value2 := StrToInt(List[Index2]);
  if Value1 < Value2 then
    Result := -1
  else if Value2 < Value1 then
    Result := 1
  else
    Result := 0;
end;

procedure TbfaApplication.SetAnnoLayer(Doc: TbfaDocument; prev: TbfaPreview);
var
  i, j, idx, src_userid: Integer;
  gotpublic, gotprivate, gotshared: Boolean;
  msgpublic, msgprivate, msgshared: string;
  lstpublic, lstprivate, lstshared, lstpages: TStringList;
  lmq: TUniQuery;
begin
  if Doc <> nil then
  begin
    CanPopupBallon := False;
    if ppmCalloutBallon.IsVisible then
      ppmCalloutBallon.Close;
    if (Doc.InEditMode) or (Doc.ID = -1) then
    begin
      prev.actPublicAnno.Enabled := (prev.PreviewKind <> pvkMulti) and ((Doc.ID = -1) or
        (((Doc.Rights and rightARead) = rightARead) or ((Doc.Rights and rightAWrite) = rightAWrite) or
        ((Doc.Rights and rightAModify) = rightAModify)));
      prev.actPrivateAnno.Enabled := (prev.PreviewKind <> pvkMulti) and (Doc.ID <> -1);
      prev.actShareLayer.Enabled := (prev.PreviewKind <> pvkMulti) and (Doc.ID <> -1);

      if not prev.Floating then
      begin
        frmMainForm.actPublicAnno.Enabled := prev.actPublicAnno.Enabled;
        frmMainForm.actPrivateAnno.Enabled := prev.actPrivateAnno.Enabled;
        frmMainForm.actShareLayer.Enabled := prev.actShareLayer.Enabled;

      // SJ 13.06.2022
      // das fhrt zu einem Problem im Aufrufstack. Bei SetAnnoToolbar wird vorher
      // geprft ob checked. Weil beides nein, sind Stempel und co. deaktiviert. Es wird aber
      // aber Layer als checked angezeigt. Nach Rcksprache mit HS ist es unsinn, dass hier
      // PublicAnno aktiviert wird, da bei jedem Dokumentenwechsel ohnehin PublicAnno aktiviert
      // werden. D.h. wir wrden hier die bewusste Entscheidung des Benutzers berschreiben, keine
      // Annos anzuzeigen. Wenn also die Annos beim verschlagworten stren, man sie ausblendet
      // und dann bearbeiten aktiviert fr die Verschlagwortung, dann wird es wieder aktiviert.
      // WENN man das will, dann aber ber die OnClick von mnuPublicAnno. Dann wird (vermzutlich?)
      // wenigstens der Zustand von den Stempeln und co. korrekt gesetzt...
//        if not frmMainForm.bfaTlbPreview1.mnuPublicAnno.Checked and       //nichts ausgewhlt
//          not frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Checked then
//        begin
//          frmMainForm.bfaTlbPreview1.mnuPublicAnno.Checked := True;       //dann PublicLayer
//          frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Checked := False;
//        end;
      end;
    end
    else
    begin
    // sorted muss gesetzt werden, sonst wird dupIgnore ignoriert und es knnen Seiten mehrfach vorkommen
//08.12.2023      lstpublic := TStringList.Create(dupIgnore, True, True);
//08.12.2023      lstprivate := TStringList.Create(dupIgnore, True, True);
      lstpublic := TStringList.Create(dupIgnore, False, True);
      lstprivate := TStringList.Create(dupIgnore, False, True);
      lstshared := TStringList.Create(dupIgnore, True, True);
      lstpages := TStringList.Create;
      try
        gotpublic := False;
        gotprivate := False;
        gotshared := False;
        prev.actPublicAnno.Hint := '';
        prev.actPrivateAnno.Hint := '';
        if not prev.Floating then
        begin
          frmMainForm.actPublicAnno.Hint := '';
          frmMainForm.actPrivateAnno.Hint := '';
        end;

        for i := 0 to Doc.Annotations.Count - 1 do
        begin
          if Doc.Annotations[i].Layer = 0 then
          begin
            gotpublic := True;
            lstpublic.Add(IntToStr(Doc.Annotations[i].Page + 1));
          end
          else
          begin
            if Doc.Annotations[i].Layer = user.ID then
            begin
              //23.08.2024 SD -->bfacrm:ticket__show__39650
              if not (lstprivate.Find(IntToStr(Doc.Annotations[i].Page + 1), Idx)) then
              begin
                gotprivate := True;
                lstprivate.Add(IntToStr(Doc.Annotations[i].Page + 1));
              end
            end
            else
            if (((Doc.Annotations[i].Rights and rightAPRead) = rightAPRead) or
                ((Doc.Annotations[i].Rights and rightAPWrite) = rightAPWrite) or
                ((Doc.Annotations[i].Rights and rightAPModify) = rightAPModify)) then
            begin
              //23.08.2024 SD -->bfacrm:ticket__show__39650
              if not (lstshared.Find(IntToStr(Doc.Annotations[i].Page + 1), Idx)) then
              begin
                gotshared := True;
                lstshared.Add(IntToStr(Doc.Annotations[i].Layer));
              end
           end;
          end;
        end;

        // hier mssen wir noch die sys_docxs abfragen, ob es nicht doch freigegebene Layer
        // ohne annotation gibt:
        lmq := DbCreateQuery;
        try
          lmq.SQL.Text :=
            Format('select * from sys_docxs where gdocid = %d and userid = %d and ' +
                   '(((rights & 16384) = 16384) or ((rights & 8192) = 8192) or ((rights & 2097152) = 2097152))',
                   [Doc.ID, user.ID]);
          lmq.Execute;
          if lmq.RecordCount > 0 then
          begin
            while not lmq.Eof do
            begin
              src_userid := lmq.FieldByName('src_userid').AsInteger;
              gotshared := True;
              if lstshared.IndexOf(IntToStr(src_userid)) = -1 then
                lstshared.Add(IntToStr(src_userid));
              lmq.Next;
            end;
          end;
        finally
          lmq.Free;
        end;

        prev.actPublicAnno.Enabled := (prev.PreviewKind <> pvkMulti) and gotpublic and
          (((Doc.Rights and rightARead) = rightARead) or ((Doc.Rights and rightAWrite) = rightAWrite) or
          ((Doc.Rights and rightAModify) = rightAModify));
        prev.actPrivateAnno.Enabled := (prev.PreviewKind <> pvkMulti) and (gotprivate or gotshared);
        prev.actShareLayer.Enabled := False;

        if not prev.Floating then
        begin
          frmMainForm.actPublicAnno.Enabled := prev.actPublicAnno.Enabled;
          frmMainForm.actPrivateAnno.Enabled := prev.actPrivateAnno.Enabled;
          frmMainForm.actShareLayer.Enabled := False;
        end;

        if gotpublic then
        begin
          lstpublic.CustomSort(bfaSortProc);
          msgpublic := Format(_('ffentliche Anmerkungen auf Seite %s'), [stringreplace(lstpublic.CommaText, ',', ', ', [rfReplaceAll])]);
        end;
        if gotprivate then
        begin
          lstprivate.CustomSort(bfaSortProc);
          msgprivate := Format(_('Eigene Anmerkungen auf Seite %s'), [stringreplace(lstprivate.CommaText, ',', ', ', [rfReplaceAll])]);
        end;
        if gotshared then
          for i := 0 to lstshared.Count - 1 do
          begin
            lstpages.Clear;
            for j := 0 to Doc.Annotations.Count - 1 do
            begin
              if Doc.Annotations[j].Layer = StrToInt(lstshared[i]) then
                //23.08.2024 SD -->bfacrm:ticket__show__39650
                if not (lstpages.Find(IntToStr(Doc.Annotations[j].Page + 1), Idx)) then
                begin
                  lstpages.Add(IntToStr(Doc.Annotations[j].Page + 1));
                end
            end;
            if lstpages.Count > 0 then
            begin
              if msgshared = '' then
                msgshared := Format(_('Anmerkungen von %s auf Seite %s'), [DbGetUserName(StrToInt(lstshared[i])), lstpages.CommaText])
              else
                msgshared := msgshared + #13#10 + Format(_('Anmerkungen von %s auf Seite %s'), [DbGetUserName(StrToInt(lstshared[i])), lstpages.CommaText]);
            end
            else
              msgshared := Format(_('Anmerkungen von %s vorhanden'), [DbGetUserName(StrToInt(lstshared[i]))]);
          end;

        if gotpublic then
        begin
          prev.actPublicAnno.Hint := msgpublic;
          if not prev.Floating then
            frmMainForm.actPublicAnno.Hint := msgpublic;
        end;
        if gotprivate then
        begin
          prev.actPrivateAnno.Hint := msgprivate;
          if not prev.Floating then
            frmMainForm.actPrivateAnno.Hint := msgprivate;
        end;
        if gotshared then
          if gotprivate then
          begin
            prev.actPrivateAnno.Hint := msgprivate + #13#10 + msgshared;
            if not prev.Floating then
              frmMainForm.actPrivateAnno.Hint := msgprivate + #13#10 + msgshared;
          end
          else
          begin
            prev.actPrivateAnno.Hint := msgshared;
            if not prev.Floating then
              frmMainForm.actPrivateAnno.Hint := msgshared;
          end;
{
        if prev.Floating then       -->   bfacrm:ticket__show__24052 , bfacrm:ticket__show__24051, bfacrm:ticket__show__24049
        begin    }
          frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Clear;
          frmMainForm.popPrivateAnno.Items.Clear;
          if gotshared then
          begin
            frmMainForm.bfaTlbPreview1.mnuPrivateAnno.DropdownCombo := True;
            frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Add(TSpTBXItem.Create(frmMainForm.bfaTlbPreview1.mnuPrivateAnno));
            frmMainForm.bfaTlbPreview1.mnuPrivateAnno[0].Caption := user.Name;
            frmMainForm.bfaTlbPreview1.mnuPrivateAnno[0].Tag := user.ID;
            frmMainForm.bfaTlbPreview1.mnuPrivateAnno[0].OnClick := OnSharedLayerClick;
            frmMainForm.bfaTlbPreview1.mnuPrivateAnno[0].ImageIndex := -1;

            frmMainForm.popPrivateAnno.Items.Add(TSpTBXItem.Create(frmMainForm.popPrivateAnno));
            frmMainForm.popPrivateAnno.Items[0].Caption := user.Name;
            frmMainForm.popPrivateAnno.Items[0].Tag := user.ID;
            frmMainForm.popPrivateAnno.Items[0].ImageIndex := -1;

            for i := 0 to lstshared.Count - 1 do
            begin
              frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Add(TSpTBXItem.Create(frmMainForm.bfaTlbPreview1.mnuPrivateAnno));
              frmMainForm.bfaTlbPreview1.mnuPrivateAnno[frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Count - 1].Caption := DbGetUserName(StrToInt(lstshared[i]));
              frmMainForm.bfaTlbPreview1.mnuPrivateAnno[frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Count - 1].Tag := StrToInt(lstshared[i]);
              frmMainForm.bfaTlbPreview1.mnuPrivateAnno[frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Count - 1].OnClick := OnSharedLayerClick;

              frmMainForm.popPrivateAnno.Items.Add(TSpTBXItem.Create(frmMainForm.popPrivateAnno));
              frmMainForm.popPrivateAnno.Items[frmMainForm.popPrivateAnno.Items.Count -1].Caption := DbGetUserName(StrToInt(lstshared[i]));
              frmMainForm.popPrivateAnno.Items[frmMainForm.popPrivateAnno.Items.Count -1].Tag := StrToInt(lstshared[i]);
              frmMainForm.popPrivateAnno.Items[frmMainForm.popPrivateAnno.Items.Count -1].ImageIndex := -1;
            end;
          end;

          frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Add(TTBSeparatorItem.Create(frmMainForm.bfaTlbPreview1.mnuPrivateAnno));
          frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Add(TSpTBXItem.Create(frmMainForm.bfaTlbPreview1.mnuPrivateAnno));
          frmMainForm.bfaTlbPreview1.mnuPrivateAnno[frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Count - 1].Action := {frmMainForm.actShareLayer; }prev.actShareLayer;
//          frmMainForm.bfaTlbPreview1.mnuPrivateAnno[frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Count - 1].Caption := _('Freigeben');
        {end;}
      finally
        FreeandNil(lstpublic);
        FreeandNil(lstprivate);
        FreeandNil(lstshared);
        FreeandNil(lstpages);
      end;
    end;

    if prev <> nil then
    begin
      prev.bfaTlbPreview.mnuPublicAnno.Enabled := prev.actPublicAnno.Enabled;
      prev.bfaTlbPreview.mnuPrivateAnno.Enabled := prev.actPrivateAnno.Enabled;
      prev.bfaTlbPreview.mnuPublicAnno.Hint := prev.actPublicAnno.Hint;
      prev.bfaTlbPreview.mnuPrivateAnno.Hint := prev.actPrivateAnno.Hint;
      prev.bfaTlbPreview.mnuPrivateAnno.Clear;
      prev.bfaTlbPreview.mnuPrivateAnno.DropdownCombo := True;
      for i := 0 to frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Count - 1 do
      begin
        if frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Items[i] is TSpTBXItem then
        begin
          prev.bfaTlbPreview.mnuPrivateAnno.Add(TSpTBXItem.Create(prev.bfaTlbPreview.mnuPrivateAnno));
          if i = 0 then
          begin
            prev.bfaTlbPreview.mnuPrivateAnno[i].Action := prev.actPrivateAnno;
            prev.bfaTlbPreview.mnuPrivateAnno[i].ImageIndex := -1;
          end
          else begin
            prev.bfaTlbPreview.mnuPrivateAnno[i].OnClick := frmMainForm.bfaTlbPreview1.mnuPrivateAnno[i].OnClick;
            prev.bfaTlbPreview.mnuPrivateAnno[i].Tag := frmMainForm.bfaTlbPreview1.mnuPrivateAnno[i].Tag;
          end;
          prev.bfaTlbPreview.mnuPrivateAnno[i].Caption := frmMainForm.bfaTlbPreview1.mnuPrivateAnno[i].Caption;
        end
        else if frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Items[i] is TTBSeparatorItem then
          prev.bfaTlbPreview.mnuPrivateAnno.Add(TTBSeparatorItem.Create(prev.bfaTlbPreview.mnuPrivateAnno));
      end;
      if prev.bfaTlbPreview.mnuPrivateAnno.Count > 0 then
        prev.bfaTlbPreview.mnuPrivateAnno[prev.bfaTlbPreview.mnuPrivateAnno.Count - 1].Action := prev.actShareLayer;
    end;
    if (msgpublic <> '') or (msgprivate <> '') or (msgshared <> '') or Doc.HasComment then
    begin
      ppmCalloutBallon.Close;
      var CommentMsg : string;
      if Doc.HasComment then
        CommentMsg := _('Kommentare sind zum Dokument vorhanden')
      else
        CommentMsg := '';
      if msgshared <> '' then
        msgshared := _('Anmerkungen von anderen Benutzern sind vorhanden');

      ppmCalloutBallon.SetCaptions(msgpublic, msgprivate, msgshared, CommentMsg); //23.08.2024 SD -->bfacrm:ticket__show__39650
      CanPopupBallon := True;
    end;
  end
  else
  begin
    if prev <> nil then
    begin
      prev.actPublicAnno.Enabled := False;
      prev.actPrivateAnno.Enabled := False;
      prev.actShareLayer.Enabled := False;
      prev.bfaTlbPreview.mnuPublicAnno.Hint := msgpublic;
      prev.bfaTlbPreview.mnuPrivateAnno.Hint := msgprivate;
      prev.bfaTlbPreview.mnuPublicAnno.Enabled := False;
      prev.bfaTlbPreview.mnuPrivateAnno.Enabled := False;
      prev.bfaTlbPreview.mnuPublicAnno.Hint := msgpublic;
      prev.bfaTlbPreview.mnuPrivateAnno.Hint := msgprivate;

      if not prev.Floating then
      begin
        frmMainForm.actPublicAnno.Enabled := prev.actPublicAnno.Enabled;
        frmMainForm.actPrivateAnno.Enabled := prev.actPrivateAnno.Enabled;
        frmMainForm.actShareLayer.Enabled := False;
        frmMainForm.actPublicAnno.Hint := msgpublic;
        frmMainForm.actPrivateAnno.Hint := msgprivate;
      end;
    end
    else begin
    frmMainForm.actPublicAnno.Enabled := False;
    frmMainForm.actPrivateAnno.Enabled := False;
    frmMainForm.actShareLayer.Enabled := False;
    frmMainForm.actPublicAnno.Hint := msgpublic;
    frmMainForm.actPrivateAnno.Hint := msgprivate;
    end;
  end;
end;

procedure TbfaApplication.CreatePDFFile(MStream: TMemoryStream; FileName, FullText: WideString);
var
  vec: TbfaImageEnVect;
  j, PageCount, iColors: Integer;
begin
  vec := CreateInvisibleVect(nil);
  try
    iColors := 0;
    MStream.Position := 0;
    vec.IO.LoadFromStream(MStream);
    PageCount := vec.IO.Params.ImageCount;
    vec.Clear;

    vec.IO.CreatePDFFile(FileName);
    vec.IO.Params.PDF_Creator := 'bitfarm-Archiv V3.6 (c) 2004 - ' + cCurYear + ' bitfarm Informationssysteme GmbH';
    vec.IO.Params.PDF_Keywords := FullText;
    vec.IO.Params.PDF_Producer := 'bitfarm-Archiv Viewer V3.6 (c) 2004 - ' + cCurYear + ' bitfarm Informationssysteme GmbH';
    vec.IO.Params.JPEG_Quality := 80;

    for j := 0 to PageCount - 1 do
    begin
      vec.IO.Params.ImageIndex := j;
      MStream.Position := 0;
      vec.IO.LoadFromStream(MStream);
      vec.Proc.AttachedIEBitmap := vec.IO.IEBitmap;
      iColors := vec.Proc.CalcImageNumColors;

        if vec.IO.Params.Height > vec.IO.Params.Width then
        begin
          vec.IO.Params.PDF_PaperHeight := 842;
          vec.IO.Params.PDF_PaperWidth := 595;
        end
        else
        begin
          vec.IO.Params.PDF_PaperHeight := 595;
          vec.IO.Params.PDF_PaperWidth := 842;
        end;

      if iColors < 128 then
        vec.IO.Params.PDF_Compression := ioPDF_LZW
      else
      begin
        vec.IO.Params.PDF_Compression := ioPDF_jpeg;
        vec.io.Params.BitsPerSample := 8;
        vec.io.Params.SamplesPerPixel := 3;
      end;
      vec.IO.SaveToPDF;
    end;
  finally
    vec.Free;
    vec := nil;
  end;
end;

function TbfaApplication.LocalSave(Data: PUserAction; AThread: TThread;
    SLst: TStringList = nil; FreeStream: Boolean = True): Boolean;
var
  i, j, k, Typ, cnt, Copies, AlertType, iColors: Integer;
  Stationery, Priv, Pub, Merge, Sort, FileCreated: Boolean;
  MStream: TMemoryStream;
  imgM: TbfaImageEnMView;
  img: TbfaImageEnVect;
  lttags: TIETIFFHandler;
  tmp: TMemoryStream;
  sTargetFilename, Savedir, StationeryPath, Caption, FileName: WideString;
  Lst: TList;
  ObjLst: TList<TbfaBaseObject>;
  Layer: Int64;
  req: TbfaRequest;
  hist: TbfaHistory;
  IsDocTypePDFWithoutAnnotation: Boolean;
  IsDocTypePDFButDontSaveAnnotation: Boolean;
  filelist: TStringList;
  TIFAsOriginal: Boolean;  //08.07.2024 SD <--bfacrm:ticket__show__39237

  function CreateOriginalPDFFile(Doc: TbfaDocument; sFileName: string; AThread: TThread): Boolean;
  var
    tmp: TMemoryStream;
  begin
    Result := True;
    if (Doc.ID = -1) then  //01.06.2022
    begin
      if Doc.OriStream.Size > 0  then
      begin
        Doc.OriStream.Position := 0;
        tmp := TMemoryStream.Create;
        tmp.CopyFrom(Doc.OriStream, Doc.OriStream.Size);
        if (tmp <> nil) and (tmp.Size > 0) then
        begin
          try
            tmp.SaveToFile(sFileName);
          finally
            tmp.Free;
          end;
        end;
      end;
    end
    else
    begin
      //14.06.2023 tmp :=
      Result := GetOriStream(Doc, AThread, sFileName);
//14.06.2023
//      if (tmp <> nil) and (tmp.Size > 0) then
//      begin
//        try
//          tmp.SaveToFile(sFileName);
//        finally
//          tmp.Free;
//        end;
//      end;
    end;
  end;

begin
  Result := True;
  FileCreated := True;
  Log.DebugBegin(llDebug, 'LocalSave', 'BackThread');
  try
    try
      Stationery := (Data^.params[0] = '1');
      Priv := (Data^.params[1] = '1');
      Pub := (Data^.params[2] = '1');
      Layer := StrToInt64(Data^.params[3]);
      Merge := (Data^.params[4] = '1');
      Savedir := Data^.params[5];
      Typ := StrToInt(Data^.params[6]);
      StationeryPath := Data^.params[7];
      Copies := StrToInt(Data^.params[8]);
      Sort := (Data^.params[9] = '1');
      AlertType := StrToInt(Data^.params[10]);
      FileName := Data^.params[11];
//  Email Type!    FileName := Data^.Params[12];

      if Merge then
        cnt := 0
      else
        cnt := Data^.Documents.Count - 1;

//      SJ 23.09.2019 - bfacrm:ticket__show__20606
//      Wenn berschreiben gesetzt ist, mssen wir erst durch alle Dokumente
//      durch gehen und die Dateinamen ermitteln. Grund: sollten mehrere Dokumente
//      den selben Namen haben, mssen wir einen Index anhngen.
//      Dabei sollen nur bereits vorher vorhandene Dateien berschrieben werden,
//      jedoch nicht die neu geschriebenen.
      if FViewerOptions.GeneralOptions.OverwriteLocalSave then
        filelist := TStringList.Create;

      // bfacrm:ticket__show__27375
      if not DirectoryExists(Savedir) then
        if AThread <> nil then
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              BfMessageDlg(Format(_('Der Speicherort %s ist nicht erreichbar'), [Savedir]), mtError, [mbOK])
            end);
          Exit;
        end;

      try
        for i := 0 to cnt do
        begin
//        SJ 23.09.2019 - bfacrm:ticket__show__20606
          if FViewerOptions.GeneralOptions.OverwriteLocalSave then
            sTargetFilename := SetFileName(Data, i, Typ, Savedir, nil, filelist)
          else
            sTargetFilename := SetFileName(Data, i, Typ, Savedir, nil);

          //08.07.2024 SD -->bfacrm:ticket__show__39237
          if (TbfaDocument(Data^.Documents[i]).OriLoc = '') and ((TbfaDocument(Data^.Documents[i]).FileType = '.tif') or (TbfaDocument(Data^.Documents[i]).FileType = '.tiff')) {02.08.2024 SD <--bfacrm:ticket__show__39510} and (Typ = sftTIF) then
            TIFAsOriginal := True
          else
            TIFAsOriginal := False;
          //08.07.2024 SD <--bfacrm:ticket__show__39237

          if (Typ = sftORI) {08.07.2024 SD <--bfacrm:ticket__show__39237} and not TIFAsOriginal then
          begin
//13.06.2023
//            AThread.Synchronize(nil,   //16.11.2017 wegen Ticket 12517
//              procedure
//              begin
                if TbfaDocument(Data^.Documents[i]).Id <> -1 then
                begin
//14.06.2023                  tmp :=
                 FileCreated := GetOriStream(TbfaDocument(Data^.Documents[i]), AThread, Savedir + '\' + sTargetFilename);
                 Result := FileCreated;
//13.06.2023                  if (tmp <> nil) and (tmp.Size > 0) then
//                  begin
//                    try
//                      tmp.SaveToFile(Savedir + '\' + sTargetFilename);
//                    finally
//                      FreeAndNil(tmp);
//                    end;
//                  end else
                  if not FileCreated and FSendingEmail then   // wenn wir eine Mail mit Orignaldateien senden wollen, bekommen aber keine geliefert
                  begin                           // dann nehmen stattdessen die Voransicht als PDF (wir hatten ja nichts!)
                    if Assigned(tmp) then
                      FreeAndNil(tmp);

                    tmp := GetPreviewStream(TbfaDocument(Data^.Documents[i]));
                    if (tmp <> nil) and (tmp.Size > 0) then
                    begin
                      AThread.Synchronize(nil,   //13.06.2023
                        procedure
                        begin
                          if FViewerOptions.GeneralOptions.OverwriteLocalSave then
                            sTargetFilename := SetFileName(Data, i, sftPDF, Savedir, nil, filelist)
                          else
                            sTargetFilename := SetFileName(Data, i, sftPDF, Savedir, nil);
                          CreatePDFFile(tmp, Savedir + '\' + sTargetFilename,
                            TbfaDocument(Data^.Documents[i]).FullTXT);
                        end);
                    end;
                  end;
                end
                else begin
                  if TbfaDocument(Data^.Documents[i]).OriLoc <> '' then
                    if FileExists(TbfaDocument(Data^.Documents[i]).OriLoc) then
                    begin
                      AThread.Synchronize(nil,   //13.06.2023
                        procedure
                        begin
                          CopyFile(PWideChar(TbfaDocument(Data^.Documents[i]).OriLoc),
                            PWideChar(Savedir + '\' + sTargetFilename), False);
                        end);
                    end;
                end;
//13.06.2023              end);
          end
          else
          begin
            imgM := nil;
            Lst := Tlist.Create;
            try
              if (Typ = sftTIF) {08.07.2024 SD <--bfacrm:ticket__show__39237} or TIFAsOriginal then
              begin
                if Merge then
                begin
                  MStream := bfaImageRendering(AThread,
                    Tlist<TbfaDocument>(Data^.Documents), Stationery, Priv, Pub,
                    Layer, Copies, Sort, imgM, StationeryPath);
                end
                else
                begin
                  Lst.Clear;
                  Lst.Add(Data^.Documents[i]);
                  MStream := bfaProcessing.bfaImageRendering(AThread,
                    Tlist<TbfaDocument>(Lst), Stationery, Priv, Pub, Layer, Copies,
                    Sort, imgM, StationeryPath);
                end;

                if (imgM <> nil) and (imgM.ImageCount > 0) then
                  imgM.MIO.SaveToFileTIFF(Savedir + '\' + sTargetFilename)
                else if (MStream <> nil) and (MStream.Size > 0) then
                begin
                  MStream.Position := 0;
                  // wenn wir kein Tif haben, aber es soll als Tif gespeichert werden, dann mssen wir TIF daraus machen
                  if (TbfaDocument(Data^.Documents[i]).FileType <> '.tif') and
                     (TbfaDocument(Data^.Documents[i]).FileType <> '.tiff') then
                  begin
                    imgM := TbfaImageEnMView.Create(nil);
                    imgM.MIO.LoadFromStream(MStream);

                    img := bfaCommonImageEn.CreateInvisibleVect(nil);
                    try
                      for k := 0 to imgM.ImageCount - 1 do
                      begin
                        img.Clear;
                        img.IO.Params.ImageIndex := k;
                        MStream.Position := 0;
                        img.IO.LoadFromStream(MStream);

                        CompressImage(iColors, img, imgM, k, True);
                      end;
                    finally
                      img.Free;
                      img := nil;
                    end;

                    imgM.MIO.SaveToFileTIFF(Savedir + '\' + sTargetFilename);
                  end else
                    MStream.SaveToFile(Savedir + '\' + sTargetFilename);
                end;
              end
              else if Typ = sftPDF then
              begin
                if Merge then  // Alle Dokumente kommen in einen groen Stream (Dokumenten Anzahl = 1)
                begin
                  MStream := bfaImageRendering(AThread, TList<TbfaDocument>(Data^.Documents), Stationery, Priv, Pub, Layer, Copies, Sort, nil, StationeryPath);
                  AThread.Synchronize(nil, //09.06.2023
                    procedure
                    begin
                      CreatePDFFile(MStream, Savedir + '\' + sTargetFilename, TbfaDocument(Data^.Documents[i]).FullTXT);
                    end);
                end
                else
                begin
                  Lst.Clear;
                  Lst.Add(Data^.Documents[i]);

                  IsDocTypePDFWithoutAnnotation := not TbfaDocument(Data^.Documents[i]).HasAnnotation and (LowerCase(TbfaDocument(Data^.Documents[i]).FileType) = '.pdf');

                  IsDocTypePDFButDontSaveAnnotation := (LowerCase(TbfaDocument(Data^.Documents[i]).FileType) = '.pdf') and (not Priv) and (not Pub) and (Layer = -1);

                  if (IsDocTypePDFWithoutAnnotation or IsDocTypePDFButDontSaveAnnotation) and not Stationery and
                    (TbfaDocument(Data^.Documents[i]).Id <> -1) then
                     CreateOriginalPDFFile(TbfaDocument(Data^.Documents[i]), Savedir + '\' + sTargetFilename, AThread)
                  else
                  begin
                    MStream := bfaProcessing.bfaImageRendering(AThread, Tlist<TbfaDocument>(Lst), Stationery, Priv, Pub, Layer, Copies, Sort, nil, StationeryPath);
                    AThread.Synchronize(nil, //09.06.2023
                      procedure
                      begin
                        CreatePDFFile(MStream, Savedir + '\' + sTargetFilename, TbfaDocument(Data^.Documents[i]).FullTXT);
                      end);
                  end;
                end;
              end;
            finally
              imgM.Free;
              imgM := nil;
              if Assigned(MStream) and (MStream <> nil) then
              begin
                MStream.Clear;
                FreeAndNil(MStream);
              end;
              FreeAndNil(Lst);
            end;
          end;

          if TbfaDocument(Data^.Documents[i]).Id <> -1 then
          begin
            if (not FSendingEmail) and (not FPluginIsRunning) and (not OfflineMode) then
            begin
              hist := TbfaHistory.Create;
              hist.Userid := FUser.ID;
              hist.Gdocid := TbfaDocument(Data^.Documents[i]).Id;
              hist.Date := Now();
              hist.Taskid := 206;
              hist.Value1 := Savedir;

              WriteHistory(AThread, hist);
            end;
          end;

          if SLst <> nil then
            SLst.Add(Savedir + '\' + sTargetFilename);

          if (AThread <> nil) and (not FPluginIsRunning) and (FileCreated) then
          begin
            AThread.Synchronize(nil,
              procedure
              var
                FObj: TbfaFileObj;
              begin
                if Typ = sftTIF then
                  Caption := _('TIF Datei')
                else if Typ = sftPDF then
                  Caption := _('PDF Datei')
                else if Typ = sftORI then
                  Caption := _('Originaldatei');

                if (FViewerOptions.GeneralOptions.AlertWindow) then
                begin
                  try
                    FObj := TbfaFileObj.Create;
                    FObj.FileName := Savedir + '\' + sTargetFilename;
                    FObj.Directory := Savedir;

                    ShowAlertWindow(AlertType, Format(_('Die %s wurde erstellt: '), [Caption]) + sTargetFilename, FObj);
                  finally
                    //21.08.2018 sonst wird spter nur Mll drin FreeAndNil(FObj); //07.08.2017
                  end;
                end
                else
                  frmMainForm.SetNotificationBar(Format(_('Die %s wurde erstellt: '), [Caption]) + sTargetFilename, nil); // SJ 14.08.2019
              end);
          end;
        end;
      finally
        if FreeStream then
        begin
          for i := Data^.Documents.Count - 1 downto 0 do
          begin
            try
              AThread.Synchronize(nil,
                procedure
                begin
                  TbfaDocument(Data^.Documents[i]).Free;
                end);
            finally
              Data^.Documents[i] := nil;
            end;
          end;
          Data^.Documents.Clear;
        end;

        if Assigned(filelist) then
          FreeAndNil(filelist);
      end;
    except
      Log.Write(llNormal, ltException, 'LocalSave', 'BackThread');
    end;
  finally
    Log.DebugEnd(llDebug, 'LocalSave', 'BackThread');
  end
end;

procedure TbfaApplication.LocalSaveOriginal(Data: PUserAction; AThread: TThread);
begin
  Log.DebugBegin(llDebug, 'LocalSaveOriginal', 'BackThread');
  try
    LocalSave(Data, AThread);
  finally
    Log.DebugEnd(llDebug, 'LocalSaveOriginal', 'BackThread');
  end
end;

procedure TbfaApplication.LocalSavePDF(Data: PUserAction; AThread: TThread);
begin
  Log.DebugBegin(llDebug, 'LocalSavePDF', 'BackThread');
  try
    LocalSave(Data, AThread);
  finally
    Log.DebugEnd(llDebug, 'LocalSavePDF', 'BackThread');
  end
end;

procedure TbfaApplication.LocalSaveTIF(Data: PUserAction; AThread: TThread);
begin
  Log.DebugBegin(llDebug, 'LocalSaveTIF', 'BackThread');
  try
    LocalSave(Data, AThread);
  finally
    Log.DebugEnd(llDebug, 'LocalSaveTIF', 'BackThread');
  end
end;

procedure TbfaApplication.LocalSaveLink(Data: PUserAction; AThread: TThread);
begin
  Log.DebugBegin(llDebug, 'LocalSaveLink', 'BackThread');
  try
    AThread.Synchronize(nil,
      procedure
      var
        i: Integer;
        done: Boolean;
        hist: TbfaHistory;
        prev: TbfaPreview;
      begin
        prev := bitfarmApp.GetActivePreview;
        if not prev.Floating then
        begin
          frmMainForm.mnuLocalSave.Action := prev.actLocalSaveLink;
          frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action := prev.actLocalSaveLink;
        end;
        prev.bfaTlbStandard.tlbStandardSubmenuItemSave.Action := prev.actLocalSaveLink;

        frmMainForm.actLocalSavePDF.Tag := 0;
        frmMainForm.actLocalSaveTIF.Tag := 0;
        frmMainForm.actLocalSaveOriginal.Tag := 0;
        frmMainForm.actLocalSavePreview.Tag := 0;
        frmMainForm.actLocalSaveLink.Tag := 1;

        done := False;
        for i := 0 to Data^.Documents.Count - 1 do
          if (TbfaDocument(Data^.Documents[i]).Id <> -1) and (TbfaDocument(Data^.Documents[i]).DocName <> '') then
          begin
            CreateDesktopShellLink(TbfaDocument(Data^.Documents[i]).DocName, TbfaDocument(Data^.Documents[i]).Id);
            done := True;
            hist := TbfaHistory.Create;
            hist.Userid := bitfarmApp.User.ID;
            hist.Gdocid := TbfaDocument(Data^.Documents[i]).ID;
            hist.Date := Now();
            hist.Taskid := 247;

            bitfarmApp.WriteHistory(nil, hist);
          end;
        if done then
//15.05.2020 Ticket 23047 -->
//        BfMessageDlg(_('Verknpfung ist erstellt.'), mtInformation, [mbOK]);
        begin
          if (FViewerOptions.GeneralOptions.AlertWindow) then
            ShowAlertWindow(alDocLink, _('Verknpfung ist erstellt.'))
          else
            frmMainForm.SetNotificationBar(_('Verknpfung ist erstellt.'), nil);
        end;
//15.05.2020 Ticket 23047 <--
      end);
  finally
    Log.DebugEnd(llDebug, 'LocalSaveLink', 'BackThread');
  end
end;

procedure TbfaApplication.LocalSavePreview(Data: PUserAction; AThread: TThread);
begin
  Log.DebugBegin(llDebug, 'LocalSavePreview', 'BackThread');
  try
    LocalSave(Data, AThread);
  finally
    Log.DebugEnd(llDebug, 'LocalSavePreview', 'BackThread');
  end
end;

procedure TbfaApplication.MainThreadExecute(Data: Pointer; AThread: TThread);
var
  UserAction: PUserAction;
  i: Integer;
  Key: Word;
  bRightMouseButtonClick: Boolean;
begin
  Log.DebugBegin(llDebug, 'MainThreadExecute: ' + PUserAction(Data).ActionName, 'MainThread');
  try
    MainThreadInExecute := True;

    UserAction := Data;

    if (PUserAction(UserAction).ActionName <> 'actDoQueueCount') and
        (PUserAction(UserAction).ActionName <> 'actDoHeartBeat') then
    AThread.Synchronize(nil,
      procedure
      begin
        Screen.Cursor := crHourGlass;
      end);


    if PUserAction(UserAction).ActionName = 'actRelogin' then
      Relogin(AThread)
    else if (pos('actChangeProfile', UserAction^.ActionName) = 1) then
      Relogin(AThread, UserAction^.params[0])
    else if PUserAction(UserAction).ActionName = 'actReloginMySQLError' then
      ReloginMySQLError(AThread)
    else if PUserAction(UserAction).ActionName = 'actChangePassword' then
      ChangePassword(AThread)
    else if PUserAction(UserAction).ActionName = 'actStartHoliday' then
      StartHoliday(AThread)
    else if PUserAction(UserAction).ActionName = 'actEndHoliday' then
      EndHoliday(AThread)
    else if PUserAction(UserAction).ActionName = 'actEditHoliday' then
      EditHoliday(AThread)
    else if PUserAction(UserAction).ActionName = 'actDocAbo' then
      DocAbo(AThread)
    else if PUserAction(UserAction).ActionName = 'actShowAbo' then
      ShowAbo(AThread)
    else if PUserAction(UserAction).ActionName = 'actDeleteAbo' then
      DeleteAbo(AThread)
    else if PUserAction(UserAction).ActionName = 'actLoadDoc' then
      LoadDoc(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actOptions' then
      options(AThread)
    else if PUserAction(UserAction).ActionName = 'actScanOptions' then
    begin
      if Assigned(frmMainForm.fraScanFunctions) then
        options(AThread, 4);
    end
    else if PUserAction(UserAction).ActionName = 'actQuit' then
      Quit(AThread)
    else if PUserAction(UserAction).ActionName = 'actViewThumbnails' then
      ViewThumbnails(PUserAction(UserAction), AThread)
    else if PUserAction(UserAction).ActionName = 'actDeleteColumnOrder' then
      DeleteColumnOrder(AThread)
    else if PUserAction(UserAction).ActionName = 'actGetLastDocument' then
      GetLastDocument(AThread, UserAction^.params)
    else if LeftStr(PUserAction(UserAction).ActionName, 9) = 'actGetDoc' then
      GetDoc(UserAction, AThread)
    else if LeftStr(PUserAction(UserAction).ActionName, 9) = 'actSetDoc' then
      SetDoc(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actRestoreOriginal' then
      RestoreOriginal(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actRefreshDoc' then
      RefreshDoc(AThread)
    else if PUserAction(UserAction).ActionName = 'actCreateEmptyDoc' then
      CreateEmptyDoc(AThread)
    else if PUserAction(UserAction).ActionName = 'actMergeDoc' then
      MergeDoc(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actDuplicateDoc' then
      DuplicateDoc(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actDeleteDoc' then
      DeleteDoc(AThread, UserAction)
    else if PUserAction(UserAction).ActionName = 'actGraphicOptions' then
      GraphicOptions
    else if PUserAction(UserAction).ActionName = 'actInverted' then
      Inverted(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actDeScrew' then
      DeScrew(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actDeScrew' then
      DeScrew(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actDeSpeckle' then
      DeSpeckle(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actRemoveBorder' then
      RemoveBorder(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actRotateLeft' then
      RotateLeft(AThread, UserAction^.Preview)
    else if PUserAction(UserAction).ActionName = 'actFlip' then
      Flip(AThread, UserAction^.Preview)
    else if PUserAction(UserAction).ActionName = 'actRotateRight' then
      RotateRight(AThread, UserAction^.Preview)
    else if PUserAction(UserAction).ActionName = 'actInfo' then
      Info(AThread)
    else if PUserAction(UserAction).ActionName = 'actSupport' then
      Support(AThread)
    else if PUserAction(UserAction).ActionName = 'actTeamViewer' then
      TeamViewer(AThread)
    else if PUserAction(UserAction).ActionName = 'actVideos' then
      Videos(AThread)
    else if PUserAction(UserAction).ActionName = 'actHandbooks' then
      Handbooks(AThread)
    else if PUserAction(UserAction).ActionName = 'actAuditProof' then
      AuditProof(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actPreviousPage' then
      PreviousPage(AThread, UserAction^.Preview, UserAction^.params)
    else if PUserAction(UserAction).ActionName = 'actNextPage' then
      NextPage(AThread, UserAction^.Preview, UserAction^.params)
    else if PUserAction(UserAction).ActionName = 'actFirstPage' then
      FirstPage(AThread, UserAction^.Preview, UserAction^.params)
    else if PUserAction(UserAction).ActionName = 'actLastPage' then
      LastPage(AThread, UserAction^.Preview, UserAction^.params)
    else if PUserAction(UserAction).ActionName = 'actPreviewBack' then
      PreviewBack(AThread, UserAction^.Preview)
    else if PUserAction(UserAction).ActionName = 'actPublicAnno' then
      PublicAnno(AThread, UserAction^.Preview)
    else if PUserAction(UserAction).ActionName = 'actPrivateAnno' then
      PrivateAnno(AThread, UserAction^.Preview, StrToInt64(UserAction^.params[0]))
    else if PUserAction(UserAction).ActionName = 'actShareLayer' then
      ShareLayer(AThread, UserAction^.Preview)
    else if PUserAction(UserAction).ActionName = 'actStationery' then
      Stationery(AThread, UserAction^.params, UserAction^.Preview)
    else if PUserAction(UserAction).ActionName = 'actAutozoom' then
      Autozoom(UserAction^.Preview, AThread)
    else if PUserAction(UserAction).ActionName = 'actZoom100' then
      Zoom100(UserAction^.Preview, nil, AThread)
    else if PUserAction(UserAction).ActionName = 'actZoomPage' then
      ZoomPage(UserAction^.Preview, nil, AThread)
    else if PUserAction(UserAction).ActionName = 'actZoomWidth' then
      ZoomWidth(UserAction^.Preview, nil, AThread)
    else if PUserAction(UserAction).ActionName = 'actZoomHeight' then
      ZoomHeight(UserAction^.Preview, nil, AThread)
    else if PUserAction(UserAction).ActionName = 'actZoomSelect' then
      ZoomSelect(UserAction^.Preview, nil, AThread)
    else if PUserAction(UserAction).ActionName = 'actZoomOff' then
      ZoomOff(UserAction^.Preview, nil, AThread)
    else if PUserAction(UserAction).ActionName = 'actEditTags' then
      EditTags(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actNewLink' then
      NewLink(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actLinks' then
      Links(AThread)
    else if PUserAction(UserAction).ActionName = 'actInResub' then
    begin
      if UserAction^.params.Count > 0 then
        bRightMouseButtonClick := (UserAction^.params[0] = '1');
      InResub(AThread, bRightMouseButtonClick);
    end
    else if PUserAction(UserAction).ActionName = 'actOriginalfile' then
      Originalfile(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actCheckout' then
      Checkout(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actCheckoutDocs' then
      CheckoutDocs(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actCheckoutDocsAdmin' then
      CheckoutDocsAdmin(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actInProgress' then
      InEditMode(TList<TbfaDocument>(UserAction^.Documents), UserAction^.Preview, AThread)
    else if PUserAction(UserAction).ActionName = 'actIsAuditProof' then
      IsAuditProof(AThread)
    else if PUserAction(UserAction).ActionName = 'actLanguageXX' then
      LanguageXX(AThread, UserAction^.params[0])
    else if PUserAction(UserAction).ActionName = 'actSave' then
      Save(AThread)
    else if PUserAction(UserAction).ActionName = 'actCallDoSave' then
    begin
      if UserAction^.params.Count > 0 then
        DoSave(AThread, UserAction)
      else
        DoSave(AThread);
    end
    else if PUserAction(UserAction).ActionName = 'actSelectedRowsToCurrentContainer' then
      DoSelectedRowsToCurrentContainer(AThread)
    else if PUserAction(UserAction).ActionName = 'actCancel' then
      Cancel(AThread)
    else if PUserAction(UserAction).ActionName = 'actSearch' then
      Search(AThread)
    else if PUserAction(UserAction).ActionName = 'actBookmarkSearch' then
      BookmarkSearch(AThread, UserAction^.objects[0])
    else if PUserAction(UserAction).ActionName = 'actReset' then
      Reset(AThread, True)    //07.05.2019 Ticket 19057
    else if PUserAction(UserAction).ActionName = 'actResetImporter' then
      ResetImporter(AThread)
    else if PUserAction(UserAction).ActionName = 'actClearFields' then
      ClearFields(AThread)
    else if PUserAction(UserAction).ActionName = 'actResetFields' then
//      ClearFields(AThread) // SJ 17.12.2019  bfacrm:ticket__show__18767
      ResetFields(AThread, true)
    else if PUserAction(UserAction).ActionName = 'actResetViewer' then
      ResetViewer(AThread)
    else if PUserAction(UserAction).ActionName = 'actBack' then
      SelectHistoryNode(AThread, 1)
    else if PUserAction(UserAction).ActionName = 'actForward' then
      SelectHistoryNode(AThread, 0)
    else if PUserAction(UserAction).ActionName = 'actShowInResub' then
      ShowInResub(AThread)
    else if PUserAction(UserAction).ActionName = 'actMyTasks' then
      MyTasks(AThread)
    else if PUserAction(UserAction).ActionName = 'actMyTasksQuery' then
      MyTasksQuery(AThread)
    else if PUserAction(UserAction).ActionName = 'actDelegateTasks' then
      DelegateTasks(AThread)
    else if PUserAction(UserAction).ActionName = 'actDelegateTasksQuery' then
      DelegateTasksQuery(AThread)
    else if PUserAction(UserAction).ActionName = 'actShowCW' then
      ShowCW(AThread)
    else if PUserAction(UserAction).ActionName = 'actCWPrevious' then
      CWPrevious(AThread)
    else if PUserAction(UserAction).ActionName = 'actCWNext' then
      CWNext(AThread)
    else if PUserAction(UserAction).ActionName = 'actResubCancel' then
      ResubCancel(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actSaveResub' then
      SaveResub(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actResubDone' then
      ResubDone(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actScan' then
      Scan(False, True, AThread)
    else if PUserAction(UserAction).ActionName = 'actScanDialog' then
      Scan(True, True, AThread)
    else if PUserAction(UserAction).ActionName = 'actLoadFile' then
      LoadFile(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actLoadImporterDocumentsFromXML' then
      LoadDocumentsFromXML(AThread, BD.EnvAppdataImporterPd, FImportContainer)
    else if PUserAction(UserAction).ActionName = 'actLoadWorkplaceDocumentsFromXML' then
      LoadDocumentsFromXML(AThread, BD.EnvAppdataWorkplacePd, FWorkplaceContainer)
    else if PUserAction(UserAction).ActionName = 'actLoadBookmarks' then
      LoadBookmarks(AThread)
    else if PUserAction(UserAction).ActionName = 'actSaveAnnoObjects' then
      SaveAnnoObjects(AThread, UserAction^.objects[0], UserAction^.objects[1], UserAction^.Preview, StrToBool(UserAction^.params[0]), StrToBool(UserAction^.params[1]), StrToBool(UserAction^.params[2]))
    else if PUserAction(UserAction).ActionName = 'actShowDocument' then
      ShowDocument(UserAction^.params, UserAction^.Preview, UserAction^.objects, UserAction^.Documents, AThread)
    else if PUserAction(UserAction).ActionName = 'actPanelClose' then
      PanelClose(AThread, UserAction^.objects)
    else if PUserAction(UserAction).ActionName = 'actChangeDocName' then
      ChangeDocName(AThread, UserAction^.objects, UserAction^.Preview)
    else if PUserAction(UserAction).ActionName = 'actSaveNewDocName' then
      SaveNewDocName(AThread, UserAction^.objects, UserAction^.params, UserAction^.Preview)
    else if PUserAction(UserAction).ActionName = 'actAddFolder' then
      AddFolder(AThread, UserAction^.objects)
    else if PUserAction(UserAction).ActionName = 'actCreateBookmark' then
      CreateBookmark(AThread, UserAction^.objects)
    else if PUserAction(UserAction).ActionName = 'actCreateBookmarkDialog' then
      CreateBookmarkDialog(AThread, UserAction^.objects)
    else if PUserAction(UserAction).ActionName = 'actCreateBookmarkForGDocID' then
      CreateBookmarkForGDocID(AThread, UserAction)
    else if PUserAction(UserAction).ActionName = 'actReplaceBookmark' then
      ReplaceBookmark(AThread, UserAction^.objects)
    else if PUserAction(UserAction).ActionName = 'actChangeBookmark' then
      ChangeBookmark(AThread, UserAction^.objects)
    else if PUserAction(UserAction).ActionName = 'actCopyBookmark' then
      CopyBookmark(AThread, UserAction^.objects)
    else if PUserAction(UserAction).ActionName = 'actMViewDragDrop' then
      MViewDragDrop(AThread, UserAction^.Preview, UserAction^.params, UserAction^.objects)
    else if PUserAction(UserAction).ActionName = 'actDeletePages' then
      DeletePagesFromDocument(AThread, UserAction^.Preview, UserAction^.params, UserAction^.objects)
    else if PUserAction(UserAction).ActionName = 'actSetActiveView' then
      SetActiveView(AThread, StrToInt(UserAction^.params[0]), UserAction^.objects[0], StrToInt(UserAction^.params[1]))
    else if PUserAction(UserAction).ActionName = 'actSetViewAndArchive' then
      SetViewAndArchive(AThread, TbfaViewKind(StrToInt(UserAction^.params[0])))
    else if PUserAction(UserAction).ActionName = 'actShowActiveTab' then
      ShowActiveTab(AThread, StrToInt(UserAction^.params[0]))
    else if PUserAction(UserAction).ActionName = 'actBookmarksTreeViewDragDrop' then
      BookmarksTreeViewDragDrop(AThread, UserAction^.objects[0], UserAction^.objects[1], UserAction^.objects[2], UserAction^.objects[3], UserAction^.objects[4], StrToInt(UserAction^.params[0]), StrToInt(UserAction^.params[1]))
    else if PUserAction(UserAction).ActionName = 'actDeleteTreeNode' then
      DeleteTreeNode(AThread, UserAction^.objects[0])
    else if PUserAction(UserAction).ActionName = 'actDeleteGlobalBookmark' then
      DeleteGlobalBookmark(AThread, UserAction^.objects[0])
    else if PUserAction(UserAction).ActionName = 'actRefreshMultiView' then
      RefreshMultiView(AThread, UserAction^.Preview, UserAction^.params)
    else if PUserAction(UserAction).ActionName = 'actDeleteSelected' then
    begin
      DeleteSelected(UserAction^.Preview, UserAction^.params, AThread, UserAction^.options);
      //15.12.2023 bfacrm:ticket__show__37266 -->
      AThread.Synchronize(nil,
        procedure
        begin
          SelectNextDocumentOrDeselect(UserAction^.Preview);
        end);
      //15.12.2023 bfacrm:ticket__show__37266 <--
    end
    else if (PUserAction(UserAction).ActionName = 'actArchive') or (PUserAction(UserAction).ActionName = 'actArchiveWithDD') then
      Archive(AThread, UserAction)
    else if PUserAction(UserAction).ActionName = 'actWPUngroup' then
      WPUngroup(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actWPClear' then
      WPClear(AThread)
    else if PUserAction(UserAction).ActionName = 'actWPLoad' then
      WPLoad(UserAction^.params, AThread)
    else if PUserAction(UserAction).ActionName = 'actChangeArchive' then
      ChangeArchive(UserAction^.params, UserAction^.objects, AThread)
    else if PUserAction(UserAction).ActionName = 'actExpandAll' then
      ExpandAll(UserAction^.objects[0], AThread)
    else if PUserAction(UserAction).ActionName = 'actCollapseAll' then
      CollapseAll(UserAction^.objects[0], AThread)
    else if PUserAction(UserAction).ActionName = 'actRefreshTreeView' then
      RefreshTreeView(UserAction^.objects[0], AThread)
    else if PUserAction(UserAction).ActionName = 'actRefreshWorkplaceMultiview' then
    begin
      if UserAction^.params.Count > 0 then
        RefreshWorkplaceMultiView(AThread, (UserAction^.params[0] = '1'))
      else
        RefreshWorkplaceMultiView(AThread, True);
    end
    else if PUserAction(UserAction).ActionName = 'actRefreshImporterMultiview' then
    begin
      if UserAction^.params.Count > 0 then
        RefreshImporterMultiView(AThread, (UserAction^.params[0] = '1'))
      else
        RefreshImporterMultiView(AThread, True);
    end
    else if ((PUserAction(UserAction).ActionName = 'actSendPagesToWorkplace') or (PUserAction(UserAction).ActionName = 'actSendPagesMergedToWorkplace') or (PUserAction(UserAction).ActionName = 'actSendPagesToImporter') or (PUserAction(UserAction).ActionName = 'actSendPagesMergedToImporter')) then
      SendPagesTo(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actDoIndexing' then
      DoIndexing(AThread)
    else if PUserAction(UserAction).ActionName = 'actRefSearch' then
      RefSearch(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actLoadHistory' then
      LoadHistoryViaSocket(UserAction^.Documents[0], AThread)
    else if PUserAction(UserAction).ActionName = 'actLoadCommentary' then
      LoadCommentary(UserAction^.Documents[0], AThread)
    else if PUserAction(UserAction).ActionName = 'actCreateComment' then
      CreateCommentary(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actModifyComment' then
      ModifyCommentary(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actDeleteComment' then
      DeleteCommentary(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actHideSearchDetails' then
      HideSearchDetails(AThread)
    else if PUserAction(UserAction).ActionName = 'actFtxPos' then
      ShowFtxPosWithButton(AThread, UserAction^.params, UserAction^.Preview)
    else if PUserAction(UserAction).ActionName = 'actCreateSymbolicLink' then
      CreateSymbolicLinks(TList<TbfaDocument>(UserAction^.Documents), StrToInt(UserAction^.params[0]), AThread)
    else if PUserAction(UserAction).ActionName = 'actUndockTab' then
      ShowPanelUndocked(AThread, UserAction^.objects[0])
    else if PUserAction(UserAction).ActionName = 'actMoveDoc' then
      MoveDoc(TList<TbfaDocument>(UserAction^.Documents), StrToInt(UserAction^.params[0]), UserAction^.params[1], StrToInt(UserAction^.params[2]), (UserAction^.options and 1 = 1), (UserAction^.options and 2 = 2), AThread)
    else if PUserAction(UserAction).ActionName = 'actGoToOriginalDocument' then
      DocumentSearch(TbfaDocument(UserAction^.Documents[0]).arcid, TbfaDocument(UserAction^.Documents[0]).Id, AThread)
    else if PUserAction(UserAction).ActionName = 'actShowAllSymbolicLinks' then
      DocumentSearch(TbfaDocument(UserAction^.Documents[0]).arcid, TbfaDocument(UserAction^.Documents[0]).Id, AThread, True)
    else if PUserAction(UserAction).ActionName = 'actDeleteSymbolicLink' then
      DeleteSymbolicLink(AThread, TList<TbfaDocument>(UserAction^.Documents))
    else if PUserAction(UserAction).ActionName = 'actDeleteLink' then
      DeleteLink(AThread, UserAction^.params[0])
    else if PUserAction(UserAction).ActionName = 'actRemoveLink' then
      RemoveLink(AThread, TList<TbfaDocument>(UserAction^.Documents), UserAction^.params[0])
    else if PUserAction(UserAction).ActionName = 'actAddTag' then
      AddTag(AThread, UserAction)
    else if PUserAction(UserAction).ActionName = 'actLeaveCurrentDocsImMultiView' then
      LeaveCurrentDocsImMultiView(AThread, UserAction)
    else if PUserAction(UserAction).ActionName = 'actButtonPreviewClick' then
      //16.05.2024 SD Klick auf ButtonPreviewClick - Umsetzung durch UserAction
      ButtonPreviewClick(AThread, UserAction^.Preview)
    else if PUserAction(UserAction).ActionName = 'actRefreshPageInThumbnails' then
      RefreshPageInThumbnails(AThread, TbfaDocument(UserAction^.Documents[0]), UserAction^.objects[0], StrToInt(UserAction^.params[0]), UserAction^.objects[1])
    else if PUserAction(UserAction).ActionName = 'actRefreshDocumentInPreviews' then
      RefreshDocumentInPreviews(AThread, TbfaDocument(UserAction^.Documents[0]), UserAction^.objects[0], UserAction^.objects[1], (UserAction^.params[0] = '1'), (UserAction^.params[1] = '1'), (UserAction^.params[2] = '1'))
    else if PUserAction(UserAction).ActionName = 'actHandleParam' then
      HandleParam(AThread, UserAction^.params)
    else if PUserAction(UserAction).ActionName = 'actPrepareForSearchLinks' then
      PrepareForSearchLinks(AThread, UserAction^.params[0])
    else if (PUserAction(UserAction).ActionName = 'actAlt1') or (PUserAction(UserAction).ActionName = 'actAlt1Num') then
      Alt1(AThread)
    else if (PUserAction(UserAction).ActionName = 'actAlt2') or (PUserAction(UserAction).ActionName = 'actAlt2Num') then
      Alt2(AThread)
    else if (PUserAction(UserAction).ActionName = 'actAlt3') or (PUserAction(UserAction).ActionName = 'actAlt3Num') then
      Alt3(AThread)
    else if (PUserAction(UserAction).ActionName = 'actAlt4') or (PUserAction(UserAction).ActionName = 'actAlt4Num') then
      Alt4(AThread)
    else if (PUserAction(UserAction).ActionName = 'actAlt5') or (PUserAction(UserAction).ActionName = 'actAlt5Num') then
      Alt5(AThread)
    else if (PUserAction(UserAction).ActionName = 'actAlt6') or (PUserAction(UserAction).ActionName = 'actAlt6Num') then
      Alt6(AThread)
    else if (PUserAction(UserAction).ActionName = 'actAlt7') or (PUserAction(UserAction).ActionName = 'actAlt7Num') then
      Alt7(AThread)
    else if (PUserAction(UserAction).ActionName = 'actAlt8') or (PUserAction(UserAction).ActionName = 'actAlt8Num') then
      Alt8(AThread)
    else if (PUserAction(UserAction).ActionName = 'actAlt9') or (PUserAction(UserAction).ActionName = 'actAlt9Num') then
      Alt9(AThread)
    else if (PUserAction(UserAction).ActionName = 'actAlt0') or (PUserAction(UserAction).ActionName = 'actAlt0Num') then
      Alt0(AThread)
    else if PUserAction(UserAction).ActionName = 'actF4' then
      F4(AThread)
    else if PUserAction(UserAction).ActionName = 'actF11' then
      F11(AThread)
    else if PUserAction(UserAction).ActionName = 'actAltF11' then
      AltF11(AThread)
    else if PUserAction(UserAction).ActionName = 'actCtrlF' then
      CtrlF(AThread)
    else if PUserAction(UserAction).ActionName = 'actCtrlAltF' then
    begin
      if (UserAction^.params.Count > 0) and (UserAction^.params[0] = '1') then
        CtrlF(AThread, True, True)
      else
        CtrlF(AThread, True);
    end
    else if PUserAction(UserAction).ActionName = 'actCtrlTab' then
      CtrlTab(AThread)
    else if PUserAction(UserAction).ActionName = 'actShowPageSortingsFrame' then
      ShowPageSortingsFrame(AThread)
    else if PUserAction(UserAction).ActionName = 'actHidePageSortingsFrame' then
      HidePageSortingsFrame(AThread)
    else if PUserAction(UserAction).ActionName = 'actCopyOCRResultToClipbrd' then
      DoCopyOCRResultToClipbrd(AThread)
    else if PUserAction(UserAction).ActionName = 'actCopyOCRResultToSlw' then
      DoCopyOCRResultToSlw(AThread)
    else if PUserAction(UserAction).ActionName = 'actCopyOCRResultToAddField' then
      DoCopyOCRResultToAddField(AThread, UserAction)
    else if PUserAction(UserAction).ActionName = 'actOCRResultToGeneralSearch' then
      DoOCRResultToGeneralSearch(AThread)
    else if PUserAction(UserAction).ActionName = 'actOCRResultToGeneralSearchInTree' then
      //08.05.2024 SD neuer Menpunkt -->bfacrm:ticket__show__38698
      DoOCRResultToGeneralSearchInTree(AThread)
    else if PUserAction(UserAction).ActionName = 'actOCRResultToSearchToolbar' then
      DoOCRResultToSearchToolbar(AThread)
    else if PUserAction(UserAction).ActionName = 'actGoToSourceArchive' then
      GoToSourceArchive(AThread, UserAction^.Documents[0], StrToInt(UserAction^.params[0]))
    else if PUserAction(UserAction).ActionName = 'actCheckResub' then
      CheckResub(AThread)
    else if PUserAction(UserAction).ActionName = 'actDoQueueCount' then
      DoQueueCount(AThread)
    else if PUserAction(UserAction).ActionName = 'actDoHeartBeat' then
      DoHeartBeat(AThread)
    else if PUserAction(UserAction).ActionName = 'actResetDLM' then
      ResetDLM(UserAction, AThread)
    else if PUserAction(UserAction).ActionName = 'actChangeSkin' then
      ChangeSkin(AThread)
    else if PUserAction(UserAction).ActionName = 'actSetSearchTextInFocus' then
    begin
      try
        AThread.Synchronize(nil,
          procedure
          begin
            frmMainForm.edtSearchText.SelectAll;
            frmMainForm.edtSearchText.SetFocus;
          end);
      except
        Log.Write(llNormal, ltException, 'MainThreadExecute - ', 'MainThread');
      end;
    end
    else if PUserAction(UserAction).ActionName = 'actCreateExportDB' then
      CreateExportDB(AThread)
    else if PUserAction(UserAction).ActionName = 'actStartExport' then
      StartExport(AThread)
    else if PUserAction(UserAction).ActionName = 'actDoExport' then
      DoExport(AThread)
    else if PUserAction(UserAction).ActionName = 'actSaveImportValues' then
      SaveImportValues(AThread)
    else if PUserAction(Data).ActionName = 'actAddToHistoryList' then
      AddToHistoryList(AThread, TbfaSearch(UserAction^.objects[0]))
    else if PUserAction(Data).ActionName = 'actSendDocsToImporter' then    //14.11.2023
      SendDocsToImporter(AThread)
    else if PUserAction(Data).ActionName = 'actSendDocsToWorkplace' then    //16.11.2023
      SendDocsToWorkplace(AThread)
    else if PUserAction(Data).ActionName = 'actReloadDocLinks' then    //10.04.2024
      ReloadDocLinks(AThread)
    {$IFDEF ENTERPRISE}
    else if PUserAction(UserAction).ActionName = 'actDoPluginClick' then
      DoPluginClick(AThread, UserAction)
// SJ 15.07.2021
//    else if PUserAction(UserAction).ActionName = 'actRunPlugin' then
//    begin
//      if UserAction^.objects.Count = 1 then
//        RunPlugin(AThread, StrToInt(UserAction^.params[0]), UserAction^.params[1], UserAction^.params[2], UserAction^.objects[0])
//      else
//        RunPlugin(AThread, StrToInt(UserAction^.params[0]), UserAction^.params[1], UserAction^.params[2], UserAction^.objects[0], UserAction^.objects[1], UserAction^.objects[2], UserAction^.objects[3]);
//    end
// SJ 15.07.2021
    // SJ Abschlussprojekt
    else if PUserAction(UserAction).ActionName = 'actCheckForFailedUpdates' then
      CheckForFailedUpdates(AThread)
    else if PUserAction(UserAction).ActionName = 'actCheckForInvalidHolidday' then
      CheckForInvalidHolidday(AThread)
//    else if PUserAction(UserAction).ActionName = 'actReadFNDFile' then
//      ReadFNDFile(AThread, UserAction^.params[0])
    // SJ Abschlussprojekt
    else if PUserAction(UserAction).ActionName = 'actPluginStamp' then
      PluginStamp(AThread, UserAction)
    {$ENDIF}
;

  finally
    AThread.Synchronize(nil,
      procedure
      begin
        try
          if ((PUserAction(UserAction).ActionName <> 'actSearch') or
             ((PUserAction(UserAction).ActionName = 'actSearch') and
             (frmMainForm.FSearchthread.Suspended))) then
          begin
            Screen.Cursor := crDefault;
          end;
          frmMainForm.Update;
        except
          Log.Write(llNormal, ltException, 'MainThreadExecute - finally - Synchronize', 'MainThread');
        end;
      end);

    with PUserAction(UserAction)^ do
    begin
      try
        if objects <> nil then
          objects.Free;
      except
        Log.Write(llNormal, ltException, 'MainThreadExecute - objects.Free;', 'MainThread');
      end;
      if Documents <> nil then
      begin
        if FreeObjects then
        begin
          try
            for i := 0 to Documents.Count - 1 do
            begin
              try
//29.08.2023 -->
////10.05.2023 -->
////                TbfaDocument(Documents[i]).Free;
//                AThread.Synchronize(nil,
//                  procedure
//                  begin
//                TbfaDocument(Documents[i]).Free;
//                  end);
////10.05.2023 <--
                {$IFDEF IMAGEEN_SYNCHRONIZED}
                AThread.Synchronize(nil,
                  procedure
                  begin
                    TbfaDocument(Documents[i]).Free;
                  end);
                {$ELSE}
                TbfaDocument(Documents[i]).Free;
                {$ENDIF}
//29.08.2023 <--
              finally
                Documents[i] := nil;
              end;
            end;
            Documents.Clear;
          except
            Log.Write(llNormal, ltException, 'MainThreadExecute - FreeObjects', 'MainThread');
          end;
        end;
        Documents.Free;
      end;
      try
        if params <> nil then
          params.Free;
      except
        Log.Write(llNormal, ltException, 'MainThreadExecute - params.Free;', 'MainThread');
      end;
      try
        if sList <> nil then
          sList.Free;
      except
        Log.Write(llNormal, ltException, 'MainThreadExecute - sList.Free;', 'MainThread');
      end;

    end;

    Log.DebugEnd(llDebug, 'MainThreadExecute: ' + PUserAction(Data).ActionName, 'MainThread'); //10.01.2024

    try
      Dispose(UserAction);
    except
      Log.Write(llNormal, ltException, 'MainThreadExecute - Dispose(UserAction);', 'MainThread');
    end;

    MainThreadInExecute := False;
//10.01.2024 etwas hher   Log.DebugEnd(llDebug, 'MainThreadExecute', 'MainThread');

    if ClosingMainForm then
    begin
      try
        frmMainForm.Close;
      except
        Log.Write(llNormal, ltException, 'MainThreadExecute - frmMainForm.Close;', 'MainThread');
      end;
    end;
  end;
end;

procedure TbfaApplication.DoSelectedRowsToCurrentContainer(AThread: TThread);
begin
  AThread.Synchronize(nil,
    procedure
    begin
      bitfarmApp.SelectedRowsToCurrentContainer(frmMainForm.grdResultlistDevExView);
    end);
end;

procedure TbfaApplication.SelectNextDocumentOrDeselect(prev: TbfaPreview);
begin
  Log.DebugBegin(llDebug, 'SelectNextDocumentOrDeselect', ClassName);
  try
    try
      if prev.MultiView.ImageCount > 0 then
      begin
        prev.MultiView.LockPaint;
        try
          prev.MultiView.Deselect;
          prev.MultiView.SelectedImage := 0;
        finally
          prev.MultiView.UnLockPaint;
        end;

        bitfarmApp.MViewImageSelect(prev.MultiView, prev, 0, -1, True, False,
          False, False, False, False, True);

        prev.MultiView.SetFocus;
      end
      else
      begin
        prev.MultiView.LockPaint;
        try
          prev.MultiView.Deselect;
        finally
          prev.MultiView.UnLockPaint;
        end;
        SetCurrentDocs(nil, nil, prev);
        ShowDocumentProperties(nil, nil);
        prev.SetActions;
      end;
    except
      Log.Write(llNormal, ltException, 'SelectNextDocumentOrDeselect', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'SelectNextDocumentOrDeselect', ClassName);
  end;
end;

procedure TbfaApplication.MergeDoc(Data: PUserAction; AThread: TThread);
var
  i, im: Integer;
  prev: TbfaPreview;
  UserAction: PUserAction;
  Doc: TbfaDocument;
  found, CanMerge: Boolean;
  P: TPoint;
begin
  Log.DebugBegin(llDebug, 'MergeDoc', ClassName);
  try
    try
      prev := GetActivePreview;
      if (prev = FPreviewContainer.WorkplaceItem.Preview) or (prev = FPreviewContainer.ImporterItem.Preview) then
      begin
        if Data^.Documents.Count > 1 then
        begin
          if bitfarmApp.DragObject = nil then
            bitfarmApp.DragObject := TbfaDragObject.Create;
          bitfarmApp.DragObject.DragSource := prev.MultiView;
          bitfarmApp.DragObject.DragSender := prev.MultiView;
          bitfarmApp.DragObject.Move := True;
          bitfarmApp.DragObject.DragKind := dkDocuments;
          bitfarmApp.DragObject.DragInsertMode := dimMerge;
          bitfarmApp.DragObject.DocumentList.Clear;

//          for i := 1 to Data^.Documents.Count - 1 do
          for i := Data^.Documents.Count - 2 downto 0 do
          begin
            Doc := TbfaDocument.Create;
//28.03.2017 Ticket 10252            Doc.Clone(Data^.Documents[i], True, True);
//21.04.2017 Ticket 10411 -->  Wenn das dokument archiviert ist, dann darf nur das Voransicht kopiert werden!
            if TbfaDocument(Data^.Documents[i]).Id = -1 then
              Doc.Clone(Data^.Documents[i], True, True)
            else
            begin
//21.04.2017 Ticket 10411 <--
              Doc.DocStream.Position := 0;
              TbfaDocument(Data^.Documents[i]).DocStream.Position := 0;
              Doc.DocStream.CopyFrom(TbfaDocument(Data^.Documents[i]).DocStream, TbfaDocument(Data^.Documents[i]).DocStream.Size);
            end;
            bitfarmApp.DragObject.Cloned := True; //10.05.2023
            bitfarmApp.DragObject.DocumentList.Add(Doc);
          end;

          bitfarmApp.DragObject.SelectedList.Clear;
          if Data^.params.Count > 0 then
            for i := 1 to Data^.params.Count - 1 do
              bitfarmApp.DragObject.SelectedList.Add(Data^.params[i]);

          im := Data^.options;

          UserAction := bitfarmApp.CreateUserAction;
          UserAction^.ActionName := 'actMViewDragDrop';
          UserAction^.objects.Add(prev.MultiView);
          UserAction^.objects.Add(bitfarmApp.DragObject);
          UserAction^.params.Add(Data^.sList[0]);
          UserAction^.params.Add(Data^.sList[1]);
          UserAction^.params.Add('1');
          P := prev.MultiView.ScreenToClient(Point(StrToInt(Data^.sList[0]), StrToInt(Data^.sList[1])));
          if prev.MultiView.ImageAtPos(P.X, P.Y) > -1 then  //30.06.2017 Ticket 10980, 10993
          begin
            im := prev.MultiView.InsertingPoint(P.X, P.Y);
          end
          else
          begin
            if prev.MultiView.MultiSelectedImagesCount > 0 then
              im := prev.MultiView.MultiSelectedImages[0];  //30.06.2017 Ticket 10980, 10993
          end;

          UserAction^.params.Add(IntToStr(im)); //imgpos

          UserAction^.Preview := prev;
          bitfarmApp.MainThread.Add(UserAction);

        end;
      end;
    except
      Log.Write(llNormal, ltException, 'MergeDoc', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'MergeDoc', ClassName);
  end;
end;

procedure TbfaApplication.ModifyCommentary(UserAction: PUserAction; AThread: TThread);
var
  req: TbfaRequest;
  UAction: PUserAction;
begin

  req := TbfaRequest.Create;
  try
    req.ReqType := 'reqModifyCommentary';
    req.UserID := user.ID;
    req.Profile := Self.Profile;
    req.Gdocid := StrToInt64(UserAction^.params[0]);
    req.DataString := StringReplace(UserAction^.params[1], #13#10, '\n', [rfReplaceAll]);
    req.Parameter := UserAction^.params[2];
    req.Lang := Lang;
    MainSocket.SendRequestToServer(req);

    req := MainSocket.ReceiveResponse(AThread);
    if req = nil then
      Exit;

//27.11.2018 Ticket 16957 -->
    if req.ReqType = 'respAuthError' then
    begin
      BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
      UAction := CreateUserAction;
      UAction^.ActionName := 'actRelogin';
      MainThread.Add(UAction);
      Exit;
    end
    else
//27.11.2018 Ticket 16957 <--
    if req.ReqType = 'respError' then
    begin
      BfShowMessage(_('Das Lesezeichen konnte nicht gespeichert werden'), AThread);
    end
    else
      FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.CommentaryView.RefreshCommentary;

  finally
    FreeAndNil(req);
  end;

end;

procedure TbfaApplication.CreateSymbolicLinks(SrcDoc: TList<TbfaDocument>; SymArcID: Int64; AThread: TThread);
var
  i, j: Integer;
  found: Boolean;
  NewDoc: TbfaDocument;
  req: TbfaRequest;
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateSymbolicLinks', ClassName);
  try
    try
      for i := 0 to SrcDoc.Count - 1 do
      begin
        if SymArcID = -1 then
        begin
          j := 0;
          found := False;
          while ((not found) and (j <= FImportContainer.Count - 1)) do
          begin
            if FImportContainer[j].Id = SrcDoc[i].Id then
              found := True
            else
              inc(j);
          end;

          if (not found) then
          begin
            NewDoc := TbfaDocument.Create;
            NewDoc.Clone(SrcDoc[i]);
            NewDoc.SymbolicArcID := 0;

            FImportContainer.Add(NewDoc);
          end;
        end
        else
        begin
          req := TbfaRequest.Create;
          try
            req.ReqType := 'reqCreateSymbolicLink';
            req.UserID := user.ID;
            req.Profile := Self.Profile;
            req.Gdocid := SrcDoc[i].Id;
            req.Parameter := IntToStr(SymArcID) + ';' + IntToStr(SrcDoc[i].arcid);    // keine Ahnung warum ScrDoc.Arcid mitgegeben wurde
//            req.Parameter := IntToStr(SymArcID);                                      // da die Funktion nur gdocid und ziel arcid bentigt

            req.Lang := Lang;
            MainSocket.SendRequestToServer(req);

            req := MainSocket.ReceiveResponse(AThread);
            if req = nil then
              Exit;

//27.11.2018 Ticket 16957 -->
            if req.ReqType = 'respAuthError' then
            begin
              BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
              UserAction := CreateUserAction;
              UserAction^.ActionName := 'actRelogin';
              MainThread.Add(UserAction);
              Exit;
            end
            else
//27.11.2018 Ticket 16957 <--
            if req.ReqType = 'respError' then
            begin
              BfShowMessage(_('Der Symbolic Link konnte nicht angelegt werden.') + #13#10 + req.DataString, AThread);
            end
            else if req.ReqType = 'respOK' then
            begin
//              SetStatusInfo(_('Symbolic Link wurde angelegt'), AThread);
              frmMainForm.SetNotificationBar(_('Symbolic Link wurde angelegt'), AThread); // SJ 14.08.2019
            end;
          finally
            FreeAndNil(req);
          end;
        end;
      end;

      if SymArcID = -1 then
      begin
        RefreshImporterMultiView(AThread, True);
        AThread.Synchronize(nil,
          procedure
          begin
            if frmMainForm.frmSplash.Showing then
              frmMainForm.frmSplash.Hide;
          end);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'CreateSymbolicLinks', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateSymbolicLinks', ClassName);
  end;
end;

procedure TbfaApplication.CreateSymbolicLinksAction(SymArcID: Int64);
var
  UserAction: PUserAction;
  Doc: TbfaDocument;
  i: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateSymbolicLinksAction', Classname);
  try
    try
      UserAction := CreateUserAction;
      UserAction^.ActionName := 'actCreateSymbolicLink';
      UserAction^.Documents := TList.Create;
      for i := 0 to FCurrentContainer.Count - 1 do
      begin
        Doc := TbfaDocument.Create;
        Doc.Clone(FCurrentContainer[i]);
        UserAction^.Documents.Add(Doc);
      end;
      UserAction^.params.Add(IntToStr(SymArcID));
      UserAction^.Preview := FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview;
      FMainThread.Add(UserAction);
    except
      FLog.Write(llNormal, ltException, 'CreateSymbolicLinksAction', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateSymbolicLinksAction', Classname);
  end;
end;

procedure TbfaApplication.MoveDoc(SrcDoc: TList<TbfaDocument>; Arcid: Int64;
  Arcname: string; SymArcID: Int64; ShowDoc, DuplicateDoc: Boolean; AThread: TThread);
var
  i, j, liprefix, iRC: Integer;
  found, DoCopy, respOK: Boolean;
  NewDoc, TmpDoc: TbfaDocument;
  req: TbfaRequest;
  hist: TbfaHistory;
  list: TList<TbfaBaseObject>;
  field: TbfaAddField;
  tmpdocs, docs, symlinks, slZMetaField, slZMetaName, slZMetaFieldValues,
  slZMetaFieldType, tlsljob: TStringList;
  lsmydir, lspname, lsparams, listname: WideString;
  lsdname: string;
  MItem: TTBCustomItem;
//02.11.2020 muss wegen scrollen nach frmMainForm  frmMovedoc: TfrmMoveDoc;
  qry, qry2: TUniQuery;
  arcids: TStringList;
  add, reqtypeToRefresh: string;
  lmq: TUniQuery;
  UserAction: PUserAction;
begin
  Log.DebugBegin(llDebug, 'MoveDoc', ClassName);
  try
    try
      docs := TStringList.Create;
      symlinks := TStringList.Create;
      docs.Delimiter := ';';
      docs.StrictDelimiter := True;
      docs.QuoteChar := Char(0);
      symlinks.Delimiter := ';';
      symlinks.StrictDelimiter := True;
      DoCopy := True;

      tlsljob := TStringList.Create;
      tmpdocs := TStringList.Create;
      tmpdocs.Delimiter := ';';
      tmpdocs.StrictDelimiter := True;
      respOK := True;
      reqtypeToRefresh := '';
      try
        {$IFDEF ENTERPRISE}
        if ((aSysArc[Arcid].options and cArchivOptPlugin) <> 0) and (FMovePlugin <> '') then
        begin
          MItem := nil;
          for i := 0 to frmMainForm.mnuPlugins.Count - 1 do
          begin
            if frmMainForm.mnuPlugins.Items[i].Caption = FMovePlugin then
              MItem := frmMainForm.mnuPlugins.Items[i];
          end;

          slZMetaField := TStringList.Create;
          slZMetaFieldValues := TStringList.Create;
          slZMetaName := TStringList.Create;
          slZMetaFieldType := TStringList.Create;

          slZMetaField.Clear;
          slZMetaFieldValues.Clear;
          slZMetaName.Clear;
          slZMetaFieldType.Clear;

          bitfarmLog.Write(llDebug, ltInfo, 'Length(aAddfields): ' + IntToStr(Length(aAddfields)), ClassName);

          if Length(aAddfields) > 0 then
          begin
            for i := Low(aAddfields) to High(aAddfields) do
            begin
              if aAddfields[i] = nil then
                Continue;

              bitfarmLog.Write(llDebug, ltInfo, 'i: ' + IntToStr(i), ClassName);

              bitfarmLog.Write(llDebug, ltInfo, 'aAddfields[i].Addfields_Arcid: ' + IntToStr(aAddfields[i].Addfields_Arcid), ClassName);

              if aAddfields[i].Addfields_Arcid = Arcid then
              begin
                slZMetaField.Add(aAddfields[i].name);
                slZMetaName.Add(aAddfields[i].DisplayName);
                slZMetaFieldValues.Add('');
                slZMetaFieldType.Add(IntToStr(aAddfields[i].Typ));
              end;
            end;
          end;
        end;

        {$ENDIF}

        lsmydir := BD.EnvTemp + '\Viewer\';
        if not (directoryexists(lsmydir)) then
          mkDir(lsmydir);

        for i := 0 to SrcDoc.Count - 1 do
        begin
          iRC := 0;
          {$IFDEF ENTERPRISE}
          if ((aSysArc[Arcid].options and cArchivOptPlugin) <> 0) and (FMovePlugin <> '') then
          begin
            if MItem <> nil then
            begin
              listname := lsmydir + 'mylist' + inttostr(Random(99999));
              tlsljob.Clear;

//24.04.2019              BfDeleteFile(lsmydir + '\*.*');
              EmptyDirectory(lsmydir);
              lspname := MItem.Hint;
              liprefix := MItem.Tag;
              lsparams := bitfarmApp.PluginsArray[liprefix].Parameters;

              DateTimeToString(lsdname, 'ddmmyyyyhhnnss', now());
              lsdname := lsdname + inttostr(Random(99999));

              WriteJobFile(lsmydir + lsdname + '.JOB', true, 0, SrcDoc[i]);

              WriteJobFileDest(lsmydir + lsdname + '.JOB', Arcid, slZMetaField,
                slZMetaName, slZMetaFieldValues, slZMetaFieldType);

              tlsljob.add(lsmydir + lsdname + '.JOB');
              tlsljob.SaveToFile(listname);

              iRC := RunPlugin(AThread, liprefix, lspname, listname, tlsljob,
                slZMetaField, slZMetaName, slZMetaFieldValues, slZMetaFieldType);
            WritePluginHistory(AThread, lspname, iRC, SrcDoc[i]);
              if iRC = 255 then    // kommt das Plugin mit rc=255 zurck wird nicht verschoben
                Continue;

            end;
          end;
          {$ENDIF}

          if SymArcID <> -1 then
            docs.Add(IntToStr(SrcDoc[i].Id) + ',' + IntToStr(SrcDoc[i].Arcid) +
              ',' + IntToStr(SymArcID))
          else if SrcDoc[i].SymbolicArcID = -1 then
            docs.Add(IntToStr(SrcDoc[i].Id) + ',' + IntToStr(SrcDoc[i].Arcid) +
              ',' + IntToStr(Arcid))
          else
            symlinks.Add(IntToStr(SrcDoc[i].Id) + ',' + IntToStr(SrcDoc[i].SymbolicArcID) +
              ',' + IntToStr(Arcid));

          tmpdocs.Add(IntToStr(SrcDoc[i].Id));
        end;
      finally
        FreeAndNil(tlsljob);
      end;

      found := True;
      if (tmpdocs.Count > 0) then
      begin
        req := TbfaRequest.Create;
        try
          bitfarmLog.Write(llDebug, ltInfo, 'reqAddfields', ClassName);
          bitfarmLog.Write(llDebug, ltInfo, 'SrcDoc[0].ID: ' + IntToStr(SrcDoc[0].Id), ClassName);

          req.ReqType := 'reqAddfields';
          req.UserID := user.ID;
          req.Profile := Self.Profile;
          req.Gdocid := SrcDoc[0].Id;
          req.Arcid := Arcid;
          MainSocket.SendRequestToServer(req);

          req := MainSocket.ReceiveResponse(AThread);
          if req = nil then
          begin
            bitfarmLog.Write(llDebug, ltInfo, 'reqAddfields - req=nil', ClassName);
            Exit;
          end
          else if req.ReqType = 'respAuthError' then
          begin
            BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
            UserAction := CreateUserAction;
            UserAction^.ActionName := 'actRelogin';
            MainThread.Add(UserAction);
            Exit;
          end
          else if req.ReqType = 'respError' then
          begin
            BfShowMessage(_('Zusatzfelder des Zielarchives konnten nicht ermittelt werden.') + #13#10 + req.DataString, AThread);
            bitfarmLog.Write(llDebug, ltInfo, 'reqAddfields - respError', ClassName);
            Exit;
          end
          else if req.ReqType = 'respOK' then
          begin
            bitfarmLog.Write(llDebug, ltInfo, 'reqAddfields - respOK', ClassName);
            bitfarmLog.Write(llDebug, ltInfo, 'req.Data.Count: ' + IntToStr(req.Data.Count), ClassName);
            if req.Data.Count > 0 then
            begin
              bitfarmLog.Write(llDebug, ltInfo, 'SrcDoc[0].Addfields.Count: ' + IntToStr(SrcDoc[0].Addfields.Count), ClassName);
              for i := 0 to req.Data.Count - 1 do
              begin
                found := False;
                for j := 0 to SrcDoc[0].Addfields.Count - 1 do
                begin
                  if SrcDoc[0].Addfields[j].Id = TbfaAddField(req.Data[i]).Id then
                  begin
                    found := True;
                    Break;
                  end;
                end;
                bitfarmLog.Write(llDebug, ltInfo, 'found: ' + BoolToStr(found), ClassName);
                if not found then
                begin
                  bitfarmLog.Write(llDebug, ltInfo, 'field := TbfaAddField.Create;', ClassName);
                  bitfarmLog.Write(llDebug, ltInfo, 'TbfaAddField(req.Data[i]).ID: ' +
                    IntToStr(TbfaAddField(req.Data[i]).Id), ClassName);
                  field := TbfaAddField.Create;
                  field.Clone(aAddfields[TbfaAddField(req.Data[i]).Id]);

                  bitfarmLog.Write(llDebug, ltInfo, 'SrcDoc[0].AddFields.Add(field);', ClassName);
                  SrcDoc[0].AddFields.Add(field);
                end;
              end;
            end;
          end;

          arcids := TStringList.Create;
          arcids.Add(IntToStr(Arcid));
          ReadAddfieldRights(arcids);
          FreeAndNil(arcids);

          found := False;     // Nicht ausgefllte Pflichtfelder suchen
          bitfarmLog.Write(llDebug, ltInfo, 'Nicht ausgefllte Pflichtfelder suchen', ClassName);
          try
            bitfarmLog.Write(llDebug, ltInfo, 'SrcDoc[0].Addfields.Count: ' + IntToStr(SrcDoc[0].Addfields.Count) + '; req.Data.Count: ' + IntToStr(req.Data.Count), ClassName);
            for i := 0 to SrcDoc[0].AddFields.Count - 1 do
            begin
              for j := 0 to req.Data.Count - 1 do
              begin
                bitfarmLog.Write(llDebug, ltInfo, 'SrcDoc[0].Addfields[i].ID: ' + IntToStr(SrcDoc[0].Addfields[i].Id) + '; TbfaAddField(req.Data[j]).ID): ' + IntToStr(TbfaAddField(req.Data[j]).Id) + '; ((SrcDoc[0].AddFields[i].Options and 1) = 1): ' + BoolToStr(((SrcDoc[0].AddFields[i].options and 1) = 1)), ClassName);

                if (SrcDoc[0].Addfields[i].Id = TbfaAddField(req.Data[j]).Id) and
                   ((SrcDoc[0].AddFields[i].options and cAddfieldOptMandatory) = cAddfieldOptMandatory) then
                begin
                  bitfarmLog.Write(llDebug, ltInfo, 'SrcDoc[0].AddFields[i].Value: ' + VarToStr(SrcDoc[0].AddFields[i].value), ClassName);
                  bitfarmLog.Write(llDebug, ltInfo, 'VarType(SrcDoc[0].AddFields[i].Value): ' + VarTypeAsText(VarType(SrcDoc[0].AddFields[i].value)), ClassName);

                  if VarIsNull(SrcDoc[0].AddFields[i].value) or ((VarIsType(SrcDoc[0].AddFields[i].value, varUString))
                     and (SrcDoc[0].AddFields[i].value = '')) or ((VarIsType(SrcDoc[0].AddFields[i].value, varDate))
                     and (IsEmptyDate(VarToDateTime(SrcDoc[0].AddFields[i].value)))) then
                  begin
                    if (aAddfieldRights[SrcDoc[0].Addfields[i].Id] and
                      (rFieldWrite or rFieldModify)) = 0 then  // ein nur lesend-Feld wird bei Pflichtfeldern nicht bercksichtigt
                      Continue;

                    //28.07.2017 muss noch im DB auch geprft werden
                    add := aAddfields[SrcDoc[0].AddFields[i].Id].name;
                    bitfarmLog.Write(llDebug, ltInfo, 'muss noch in der DB geprft werden. add: ' + add, ClassName);
                    lmq := DbCreateQuery;
                    try
                      lmq.SQL.Text := Format('select %s from sys_docidx_%d where gdocid = %d;', [add, aAddfields[SrcDoc[0].AddFields[i].Id].IndexTableID, SrcDoc[0].Id]);
                      lmq.Execute;
                      if lmq.RecordCount > 0 then
                      begin
                        if VarIsNull(lmq.FieldValues[add]) or
                          ((VarIsType(lmq.FieldValues[add], varUString)) and
                          (lmq.FieldValues[add] = '')) or
                          ((VarIsType(lmq.FieldValues[add], varDate)) and
                          (IsEmptyDate(VarToDateTime(lmq.FieldValues[add])))) then
                        begin
                          found := True;
                          Break;
                        end;
                      end
                      else
                      begin
                        found := True;
                        Break;
                      end;
                    finally
                      lmq.Free;
                    end;
                  end;
                end;
              end;
            end;
          except
            bitfarmLog.Write(llNormal, ltException, 'Nicht ausgefllte Pflichtfelder suchen', ClassName);
            found := True;
          end;

        finally
          FreeAndNil(req);
        end;

        bitfarmLog.Write(llDebug, ltInfo, 'found: ' + BoolToStr(found, True), ClassName);
        if found then
        begin
          AThread.Synchronize(nil,
            procedure
            var
              k, m, n: Integer;
              found: boolean;
            begin
              if frmMainForm.frmMovedoc = nil then
                frmMainForm.frmMovedoc := TfrmMoveDoc.Create(nil)
              //21.09.2022 Ticket 32291 -->
              else
                frmMainForm.frmMovedoc.DeleteAllAddfields;
              //21.09.2022 Ticket 32291 <--
              try
                frmMainForm.frmMovedoc.scrbxMoveDocAddfields.Color :=
                  frmMainForm.grdResultlistDevExView.clFree;
                frmMainForm.frmMovedoc.Panel1.Color :=
                  frmMainForm.grdResultlistDevExView.clFree;
                frmMainForm.frmMovedoc.Color :=
                  frmMainForm.grdResultlistDevExView.clFree;
                frmMainForm.frmMovedoc.Position := poMainFormCenter;
                frmMainForm.frmMovedoc.CreateAddfields(Arcid);
                if Assigned(frmMainForm.frmMovedoc.Doc) then
                  FreeAndNil(frmMainForm.frmMovedoc.Doc);
                frmMainForm.frmMovedoc.Doc := TbfaDocument.Create;
                frmMainForm.frmMovedoc.Doc.Clone(FCurrentContainer[0]);
                for n := 0 to frmMainForm.frmMovedoc.TmpAddfields.Count - 1 do
                begin
                  found := False;
                  for m := 0 to SrcDoc[0].AddFields.Count - 1 do
                  begin
                    if frmMainForm.frmMovedoc.TmpAddfields[n].Id = SrcDoc[0].AddFields[m].Id then
                    begin
                      if not VarIsNull(SrcDoc[0].AddFields[m].value) then
                      begin
                        found := True;
                        frmMainForm.frmMovedoc.TmpAddfields[n].value :=
                          ParseAddfields(SrcDoc[0].AddFields[m].value);
                        frmMainForm.frmMovedoc.TmpAddfields[n].Component.Value :=
                          ParseAddfields(SrcDoc[0].AddFields[m].value);
                        Break;
                      end;
                    end;
                  end;
                  if (not found) then //wenn noch nicht geladen dann muss aus DB holen
                  begin
                    bitfarmLog.Write(llDebug, ltInfo, 'noch nicht geladen muss aus DB holen', ClassName);
                    add := aAddfields[frmMainForm.frmMovedoc.TmpAddfields[n].Id].name;
                    lmq := DbCreateQuery;
                    try
                      lmq.SQL.Text := Format('select %s from sys_docidx_%d where gdocid = %d;', [add, aAddfields[frmMainForm.frmMovedoc.TmpAddfields[n].Id].IndexTableID, SrcDoc[0].Id]);
                      bitfarmLog.Write(llDebug, ltInfo, 'lmq.SQL.Text: ' + lmq.SQL.Text, ClassName);
                      lmq.Execute;
                      if lmq.RecordCount > 0 then
                      begin
                        if not VarIsNull(lmq.FieldValues[add]) then
                        begin
                          bitfarmLog.Write(llDebug, ltInfo, 'not VarIsNull(lmq.FieldValues[add])', ClassName);
                          bitfarmLog.Write(llDebug, ltInfo, 'lmq.FieldValues[add]: ' + VarToStr(lmq.FieldValues[add]), ClassName);
                          frmMainForm.frmMovedoc.TmpAddfields[n].value := lmq.FieldValues[add];
                          frmMainForm.frmMovedoc.TmpAddfields[n].Component.Value := lmq.FieldValues[add];
                        end;
                      end;
                    finally
                      lmq.Free;
                    end;
                  end;
                end;

                bitfarmLog.Write(llDebug, ltInfo, 'frmMovedoc.ShowModal;', ClassName);
                frmMainForm.frmMovedoc.OnMouseActivate := frmMainForm.MainFormMouseActivate;
                frmMainForm.frmMovedoc.ShowModal;
                if frmMainForm.frmMovedoc.ModalResult <> mrOK then
                begin
                  DoCopy := False;
                  bitfarmLog.Write(llDebug, ltInfo, 'frmMovedoc.ModalResult <> mrOK', ClassName);
                end
                else
                begin
                  bitfarmLog.Write(llDebug, ltInfo, 'frmMovedoc.ModalResult = mrOK', ClassName);
                  // Liste muss aufgebaut werden
                  list := TList<TbfaBaseObject>.Create;
                  for k := 0 to frmMainForm.frmMovedoc.TmpAddfields.Count - 1 do
                  begin
                    bitfarmLog.Write(llDebug, ltInfo, 'frmMovedoc.TmpAddfields[k].Name: ' +
                      frmMainForm.frmMovedoc.TmpAddfields[k].name + '; k:' + IntToStr(k), ClassName);
                    if (frmMainForm.frmMovedoc.TmpAddfields[k].modified) then
                    begin
                      bitfarmLog.Write(llDebug, ltInfo, 'frmMovedoc.TmpAddfields[k].Modified = True', ClassName);
                      bitfarmLog.Write(llDebug, ltInfo, 'frmMovedoc.TmpAddfields[k].Value: ' + VarToStr(frmMainForm.frmMovedoc.TmpAddfields[k].value), ClassName);
                      field := TbfaAddField.Create;
                      field.Clone(frmMainForm.frmMovedoc.TmpAddfields[k]);
                      bitfarmLog.Write(llDebug, ltInfo, 'field created und cloned', ClassName);
                      bitfarmLog.Write(llDebug, ltInfo, 'field.Value: ' + VarToStr(field.Value), ClassName);

                      list.Add(field);
                      bitfarmLog.Write(llDebug, ltInfo, 'list.Add(field);', ClassName);
                    end
                    else
                      bitfarmLog.Write(llDebug, ltInfo, 'frmMovedoc.TmpAddfields[k].Modified = False', ClassName);
                  end;
                end;
              finally
//02.11.2020 ist ins frmMainForm umgezogen                FreeAndNil(frmMovedoc);
              end;
            end);
        end;
      end;

      bitfarmLog.Write(llDebug, ltInfo, 'DoCopy: ' + BoolToStr(DoCopy, True), ClassName);
      if DoCopy then
      begin
        if (docs.Count > 0) then
        begin
          bitfarmLog.Write(llDebug, ltInfo, 'docs.Count > 0', ClassName);
          req := TbfaRequest.Create;
          try
            if SymArcID = -1 then
            begin
              if DuplicateDoc then
              begin
                req.ReqType := 'reqDuplicateDoc';
                bitfarmLog.Write(llDebug, ltInfo, 'req = reqDuplicateDoc', ClassName);
              end else begin
                req.ReqType := 'reqMoveDoc';
                reqtypeToRefresh := 'reqMoveDoc';
                bitfarmLog.Write(llDebug, ltInfo, 'req = reqMoveDoc', ClassName);
              end;
            end
            else
            begin
              req.ReqType := 'reqCreateSymbolicLink';
              reqtypeToRefresh := 'reqCreateSymbolicLink';
              bitfarmLog.Write(llDebug, ltInfo, 'req = reqCreateSymbolicLink', ClassName);
            end;
            req.Parameter := docs.DelimitedText;
            req.UserID := user.ID;
            req.Profile := Self.Profile;
            req.Lang := Lang;
            if DuplicateDoc and frmMainForm.bfaTlbPreview1.mnuPublicAnno.Checked then
              req.Parameter := req.Parameter + ';public';

            if (list <> nil) and (list.Count > 0) then
              req.Data := list;

            MainSocket.SendRequestToServer(req);

            req := MainSocket.ReceiveResponse(AThread);
            if req = nil then
              Exit;

            respOK := (req.ReqType = 'respOK');

//27.11.2018 Ticket 16957 -->
            if req.ReqType = 'respAuthError' then
            begin
              BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
              UserAction := CreateUserAction;
              UserAction^.ActionName := 'actRelogin';
              MainThread.Add(UserAction);
              Exit;
            end
            else
//27.11.2018 Ticket 16957 <--
            if req.ReqType = 'respError' then
            begin
              BfShowMessage(_('Fehler beim Verschieben.') + #13#10 + req.DataString, AThread);
              bitfarmLog.Write(llDebug, ltInfo, 'respError', ClassName);
            end
            else if req.ReqType = 'respOK' then
            begin
              bitfarmLog.Write(llDebug, ltInfo, 'respOK', ClassName);

              if DuplicateDoc then
              begin
                tmpdocs.Clear;
                tmpdocs.DelimitedText := req.DataString;
              end;
              //29.08.2024 SD -->bfacrm:ticket__show__39648
//              AThread.Synchronize(nil,
//                procedure
//                begin
//                  //06.08.2024 SD -->bfacrm:ticket__show__39502
//                  if SymArcID <> -1 then
//                      frmMainForm.SetNotificationBar(_('Symbolic Link angelegt.'), nil)
//                  else
//                  //06.08.2024 SD <--bfacrm:ticket__show__39502
//                    if DuplicateDoc then
//
//                      frmMainForm.SetNotificationBar(_('Das Dokument wurde kopiert'), nil)
//                    else
//                      frmMainForm.SetNotificationBar(_('Das Dokument wurde verschoben'), nil); // SJ 14.08.2019
//                end);
              //29.08.2024 SD <--bfacrm:ticket__show__39648
            end;
          finally
            FreeAndNil(req);
          end;
        end;

        if symlinks.Count > 0 then
        begin
          bitfarmLog.Write(llDebug, ltInfo, 'symlinks.Count > 0', ClassName);
          req := TbfaRequest.Create;
          try
            bitfarmLog.Write(llDebug, ltInfo, 'reqMoveSymLink', ClassName);
            req.ReqType := 'reqMoveSymlink';
            req.Parameter := symlinks.DelimitedText;
            req.UserID := user.ID;
            req.Profile := Self.Profile;
            req.Lang := Lang;
            if (list <> nil) and (list.Count > 0) then
              req.Data := list;

            MainSocket.SendRequestToServer(req);

            req := MainSocket.ReceiveResponse(AThread);
            if req = nil then
              Exit;

            respOK := (req.ReqType = 'respOK');

//27.11.2018 Ticket 16957 -->
            if req.ReqType = 'respAuthError' then
            begin
              BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
              UserAction := CreateUserAction;
              UserAction^.ActionName := 'actRelogin';
              MainThread.Add(UserAction);
              Exit;
            end
            else
//27.11.2018 Ticket 16957 <--
            if req.ReqType = 'respError' then
            begin
              BfShowMessage(_('Fehler beim Verschieben des Symbolic Link.') + #13#10 + req.DataString, AThread);
              bitfarmLog.Write(llDebug, ltInfo, 'respError', ClassName);
              Exit;
            end
            else if req.ReqType = 'respOK' then
            begin
              frmMainForm.SetNotificationBar(_('Der Symbolic Link verschoben'), AThread); // SJ 14.08.2019
              bitfarmLog.Write(llDebug, ltInfo, 'respOK', ClassName);
            end;
          finally
            FreeAndNil(req);
          end;
        end;

        if ShowDoc and respOK then
        begin
          bitfarmLog.Write(llDebug, ltInfo, 'Showdoc and respOK', ClassName);
          if tmpdocs.Count > 0 then
          begin
            bitfarmLog.Write(llDebug, ltInfo, 'tmpdocs.count > 0', ClassName);
            fSkipAutoDisplay := True;
            try
              Reset(AThread); //29.08.2017 Ticket 11596 wenn keine Berechtigung, dann darf nichts angezeigt werden
              ChangeArchiveFromProgram(Arcid, AThread);
              DoGDocIDSearch(AThread, -1, False, tmpdocs.CommaText);
            finally
              fSkipAutoDisplay := False;
            end;
          end;
        end
        else
        begin
          bitfarmLog.Write(llDebug, ltInfo, 'NOT (Showdoc and respOK)', ClassName);
          AThread.Synchronize(nil,
            procedure
            begin
            //08.04.2021 b.takacs Ticket 26735 -->
              frmMainForm.grdResultlistDevExView.Controller.ClearSelection;
//              ShowDocumentProperties(FCurrentContainer[0],
//                FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview);
              frmMainForm.grdResultlistDevExView.SetBookmark;
              frmMainForm.grdResultlistDevExView.Controller.FocusedRecord.Selected := True;
            //08.04.2021 b.takacs Ticket 26735 <--
            end);
          RefreshGrid(AThread);
//12.11.2020 Ticket 15777 -->
          if respOK then
          begin
            if reqtypeToRefresh = 'reqMoveDoc' then
            begin
              FCurrentContainer[0].ArcID := ArcID;
              SetStandardStatusInfo(AThread);
            end;
          end;
//12.11.2020 Ticket 15777 <--
        end;
//28.07.2017 Ticket 11322 -->
        if respOK then
        begin
          bitfarmLog.Write(llDebug, ltInfo, 'respOk - Load and Refresh', ClassName);
          for i := 0 to tmpdocs.Count - 1 do
          begin
            TmpDoc := TbfaDocument.Create;
            try
              TmpDoc.ID := StrToInt(tmpdocs[i]);
              if IsDocumentInOtherPreview(FPreviewContainer.ViewerItem.Preview, TmpDoc) then //29.08.2017 Ticket 11569 nur dann muss neugeladen werden, wenn noch irgendwo geffnet ist
              begin
                LoadDocumentViaSocket(TmpDoc, 'base;fields;paths;text;iev;svn', AThread);
                RefreshDocumentInPreviews(AThread, TmpDoc, nil, nil);
              end;
            finally
              FreeAndNil(TmpDoc);
            end;
          end;

          //29.08.2024 SD -->bfacrm:ticket__show__39648
          AThread.Synchronize(nil,
            procedure
            begin
              //06.08.2024 SD -->bfacrm:ticket__show__39502
              if SymArcID <> -1 then
                  frmMainForm.SetNotificationBar(_('Symbolic Link angelegt.'), nil)
              else
              //06.08.2024 SD <--bfacrm:ticket__show__39502
                if DuplicateDoc then

                  frmMainForm.SetNotificationBar(_('Das Dokument wurde kopiert'), nil)
                else
                  frmMainForm.SetNotificationBar(_('Das Dokument wurde verschoben'), nil); // SJ 14.08.2019
            end);
          //29.08.2024 SD <--bfacrm:ticket__show__39648

        end;
//28.07.2017 Ticket 11322 <--

      end;

    except
      Log.Write(llNormal, ltException, 'MoveDoc', ClassName);
    end;
  finally
    if list <> nil then
    begin
      for i := list.Count - 1 downto 0 do
      begin
        try
          TbfaAddField(list[i]).Free;
        finally
          list[i] := nil;
        end;
      end;
      FreeAndNil(list);
    end;
    FreeAndNil(docs);
    FreeAndNil(symlinks);
    FreeAndNil(tmpdocs);
    Log.DebugEnd(llDebug, 'MoveDoc', ClassName);
  end;

end;

function TbfaApplication.AreSelectedDocsNotMovable(ArcID: Int64): Boolean;
var
  i, iCountDocs: Integer;
begin
  Result := false;
  //23.05.2023 bfacrm:ticket__show__34879 -->
  if (bitfarmApp.DragObject <> nil) and (bitfarmApp.DragObject.Changed) then
  begin
    if (bitfarmApp.DragObject.DocumentList.Count = 0) then
      exit;

    iCountDocs := 0;
    for i := 0 to bitfarmApp.DragObject.DocumentList.Count - 1 do
    begin
      if (bitfarmApp.DragObject.DocumentList[i].ArcID = ArcID) then
        Inc(iCountDocs)
      else if (aSysArc[bitfarmApp.DragObject.DocumentList[i].ArcID].Rights and rightMove) = 0 then
        Inc(iCountDocs);
    end;

    Result := (iCountDocs = FCurrentContainer.Count);
  end
  else
  begin
  //23.05.2023 bfacrm:ticket__show__34879 <--

  if (FCurrentContainer.Count = 0) then  // CurrentContainer: Selektierte Dokumente
    exit;

    iCountDocs := 0;
    for i := 0 to FCurrentContainer.Count - 1 do
    begin
      if (FCurrentContainer[i].ArcID = ArcID) then
        Inc(iCountDocs)
      else if (aSysArc[FCurrentContainer[i].ArcID].Rights and rightMove) = 0 then
        Inc(iCountDocs);
    end;

    Result := (iCountDocs = FCurrentContainer.Count);
  end;
end;

procedure TbfaApplication.MoveDocAction(Node: TTreeNode; SymArcID: Int64 = -1; DuplicateDoc : Boolean = False);
var
  UserAction: PUserAction;
  Doc: TbfaDocument;
  i: Integer;
  ArcIdTargetNode: Int64;
begin
  bitfarmLog.DebugBegin(llDebug, 'MoveDocAction', Classname);
  try
    try
      ArcIdTargetNode := TbfaInt64(Node.Data^).value;

      UserAction := CreateUserAction;
      UserAction^.ActionName := 'actMoveDoc';
      UserAction^.Documents := TList.Create;
      //23.05.2023 bfacrm:ticket__show__34879 -->
      if (bitfarmApp.DragObject <> nil) and bitfarmApp.DragObject.Changed then
      begin
        for i := 0 to bitfarmApp.DragObject.DocumentList.Count - 1 do
        begin
          if bitfarmApp.DragObject.DocumentList[i].ArcID <> ArcIdTargetNode then  // Ticket 157778 Dokument lsst sich in selbe Archiv verschieben
          begin                                                  // Dragover prft vorab, ob mindestens ein Dokument aus einem anderen Archiv stammt
            Doc := TbfaDocument.Create;
            Doc.Clone(bitfarmApp.DragObject.DocumentList[i]);
            UserAction^.Documents.Add(Doc);
          end;
        end;
      end
      else
      begin
      //23.05.2023 bfacrm:ticket__show__34879 <--
      for i := 0 to FCurrentContainer.Count - 1 do
      begin
          if FCurrentContainer[i].ArcID <> ArcIdTargetNode then  // Ticket 157778 Dokument lsst sich in selbe Archiv verschieben
          begin                                                  // Dragover prft vorab, ob mindestens ein Dokument aus einem anderen Archiv stammt
          Doc := TbfaDocument.Create;
          Doc.Clone(FCurrentContainer[i]);
          UserAction^.Documents.Add(Doc);
        end;
      end;
      end;
      UserAction^.params.Add(IntToStr(ArcIdTargetNode));
      UserAction^.params.Add(Node.Text);
      UserAction^.params.Add(IntToStr(SymArcID));
      if (GetKeyState(VK_SHIFT) < 0) then
        UserAction^.options := 1
      else
        UserAction^.options := 0;

      if DuplicateDoc then
        UserAction^.options := UserAction^.options or 2;

      UserAction^.Preview := FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview;

      bitfarmLog.Write(llDebug, ltInfo, 'Value: ' + IntToStr(ArcIdTargetNode) + '; Text: ' + Node.Text, ClassName);

      FMainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'MoveDocAction', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'MoveDocAction', Classname);
  end;
end;

procedure TbfaApplication.MyTasks(AThread: TThread; gdocid: Int64 = 0);
var
  UserAction: PUserAction;
  hd : HWND;
begin
  Log.DebugBegin(llDebug, 'MyTasks', ClassName);
  try
    try
      Reset(AThread);
      if CurrentView <> tvkResub then
      begin
        if AThread <> nil then
          bitfarmApp.SetActiveView(AThread, pvtViewer, nil, Integer(tvkResub))
        else
          bitfarmApp.SetActiveViewAction(pvtViewer, nil, tvkResub);
      end
//22.02.2022      else if ResubKind <> rkMyTasks then
      else if frmMainForm.fraResub.ResubKind <> rkMyTasks then
      begin
//22.02.2022        ResubKind := rkMyTasks;
        frmMainForm.fraResub.ResubKind := rkMyTasks;
        CreateGrid(CurrentResubFields, AThread);
      end;

      frmMainForm.grdResultlistDevExView.Kind := gkResub;
//22.02.2022      ResubKind := rkMyTasks;
      frmMainForm.fraResub.ResubKind := rkMyTasks;
      frmMainForm.actShowCW.Enabled := True;
      frmMainForm.actCWPrevious.Enabled := True;
      frmMainForm.actCWNext.Enabled := True;

      AThread.Synchronize(nil,
        procedure
        begin
          SetMyTaskControls(frmMainForm.fraResub);
        end);

      MyTasksQuery(AThread, gdocid);
      FNewResubs := 0;   // ffnen wir die Wiedervorlage, dann gibt es keine neuen WVL mehr, da wir sie ja jetzt alle sehen :-)
      CheckResub(AThread);

      hd := FindWindow('bitfarm.hotsearch.V36', nil);
      bitfarmLog.Write(llDebug, ltInfo, 'ShowTasks befor sendMessage', ClassName);
      sendMessage(hd, WM_HOTKEY_WVL_MESSAGE, 1, 1);
      bitfarmLog.Write(llDebug, ltInfo, 'ShowTasks after sendMessage', ClassName);
    except
      Log.Write(llNormal, ltException, 'MyTasks', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'MyTasks', ClassName);
  end;
end;

procedure TbfaApplication.MyTasksQuery(AThread: TThread; gdocid: Int64 = 0);
begin
  bitfarmLog.DebugBegin(llDebug, 'MyTasksQuery', ClassName);
  try
    try
      FillMyTasksSearch(frmMainForm.fraResub, frmMainForm.grdResultlistDevExView, FSearchObj);
      // TODO: f.schneider hat es hier einen Zeilendrehen gegeben?
//04.06.2024      FSearchObj.GdocID.Add(IntToStr(gdocid));
      if gdocid > 0 then
      begin
        FSearchObj.GdocID.Add(IntToStr(gdocid)); //04.06.2024
        FSearchObj.ResubDateHigh := Null;
      end;
      StartSearchThread(FSearchObj);
    except
      bitfarmLog.Write(llNormal, ltException, 'MyTasksQuery', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'MyTasksQuery', ClassName);
  end;
end;

procedure TbfaApplication.NextPage(AThread: TThread; prev: TbfaPreview; Params: TStringList);
var
  iPage: Integer;
  SetFocus, SetImagePos, SetImagePosTothetop, Autozoom: Boolean;
begin
  bitfarmLog.DebugBegin(llDebug, 'NextPage', ClassName);
  try
    try
      if ((prev.PreviewKind = pvkSingle) or (prev.PreviewKind = pvkMultiSingle)) then
      begin
        prev.askforsave_annos2(AThread);

        if (Params <> nil) and (Params.Count > 0) and (Params[0] = '1') then
          SetFocus := True
        else
          SetFocus := False;

        SetImagePos := False;
        SetImagePosTothetop := False;
        Autozoom := True; // Standard

        if Params.Count >= 3 then
        begin
          SetImagePos := (Params[1] = '1');
          SetImagePosTothetop := (Params[2] = '1');
          if Params.Count >= 4 then
            Autozoom := (Params[3] = '1');
        end;
        iPage := -1; //18.09.2018 Ticket 15219

        MViewImageSelect(prev.ThumbnailView, prev, iPage, -1, False, False, False, False, SetFocus, False, False, SetImagePos, SetImagePosTothetop, Autozoom, 1);
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'NextPage', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'NextPage', ClassName);
  end;
end;

procedure TbfaApplication.FirstPage(AThread: TThread; prev: TbfaPreview; Params: TStringList);
var
  iPage: Integer;
  SetFocus: Boolean;
begin
  bitfarmLog.DebugBegin(llDebug, 'FirstPage', ClassName);
  try
    try
      if ((prev.PreviewKind = pvkSingle) or (prev.PreviewKind = pvkMultiSingle)) then
      begin
        prev.askforsave_annos2(AThread);

        iPage := 0;

        if (Params <> nil) and (Params.Count > 0) and (Params[0] = '1') then
          SetFocus := True
        else
          SetFocus := False;

        MViewImageSelect(prev.ThumbnailView, prev, iPage, -1, False, False, False, False, SetFocus);
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'FirstPage', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'FirstPage', ClassName);
  end;
end;

procedure TbfaApplication.LastPage(AThread: TThread; prev: TbfaPreview; Params: TStringList);
var
  {$IFDEF ImageEn1140}
  iPage, iViewY, mx, my: Integer;
  {$ELSE}
  iPage: Integer;
  {$ENDIF}
  SetFocus: Boolean;
begin
  bitfarmLog.DebugBegin(llDebug, 'LastPage', ClassName);
  try
    try
      if ((prev.PreviewKind = pvkSingle) or (prev.PreviewKind = pvkMultiSingle)) then
      begin
        prev.askforsave_annos2(AThread);

        {$IFDEF ImageEn1140}
        prev.SingleView.img_DocView.GetMaxViewXY(mx, my);
        iViewY := prev.SingleView.img_DocView.ViewY;
        if (prev.ActiveDoc.ScanPoolView <> nil) and (prev.ActiveDoc.ScanPoolViewLoaded) then
          iPage := prev.ActiveDoc.ScanPoolView.ImageCount - 1
        else
          iPage := prev.SingleView.img_DocView.IO.Params.TIFF_ImageCount - 1;

        if (Params <> nil) and (Params.Count > 0) and (Params[0] = '1') then
          SetFocus := True
        else
          SetFocus := False;

        if prev.ActivePage <> iPage then
          MViewImageSelect(prev.ThumbnailView, prev, iPage, -1, False, False, False, False, SetFocus)
        else if (prev.ActivePage = iPage) and (iViewY < my) then
           prev.SingleView.img_DocView.ViewY := my;
        {$ELSE}
        if (prev.ActiveDoc.ScanPoolView <> nil) and (prev.ActiveDoc.ScanPoolViewLoaded) then
          iPage := prev.ActiveDoc.ScanPoolView.ImageCount - 1
        else
          iPage := prev.SingleView.img_DocView.IO.Params.TIFF_ImageCount - 1;

        if (Params <> nil) and (Params.Count > 0) and (Params[0] = '1') then
          SetFocus := True
        else
          SetFocus := False;

        MViewImageSelect(prev.ThumbnailView, prev, iPage, -1, False, False, False, False, SetFocus);
        {$ENDIF}
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'LastPage', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'LastPage', ClassName);
  end;
end;

procedure TbfaApplication.SetFocusToFirstVisibleAddfield;
var
  I, pos: Integer;
  scrollbox : TbfaScrollbox;
begin
  try
    bitfarmLog.Write(llNormal, ltDebug, 'SetFocusToFirstVisibleAddfield', ClassName);
    if frmMainForm.tabAddfields2.Visible and (frmMainForm.tcSearch.ActiveTabIndex = 2) then
      scrollbox := frmMainForm.scrbxAddfields2
    else
      scrollbox := frmMainForm.scrbxViewerAddfields;

    for I := 0 to scrollbox.ComponentCount - 1 do
    begin
      if (scrollbox.Components[I] is TBfaAddfieldComp) then
      begin
        pos := TcxControl(TbfaAddfieldComp(scrollbox.Components[I]).comp).ClientOrigin.Y;
        if (pos < scrollbox.ClientOrigin.Y) then
            Continue
        else
        begin
          pos := scrollbox.VertScrollbar.Position
              + TBfaAddfieldComp(scrollbox.Components[I]).ClientOrigin.Y
              - scrollbox.ClientOrigin.Y;
          if (pos < scrollbox.VertScrollbar.Position) then
            scrollbox.VertScrollbar.Position := pos;
          if TbfaAddfieldComp(scrollbox.Components[I]).AddfieldType = zfld13_Grid then
          begin
            if TcxControl(TbfaAddfieldComp(scrollbox.Components[I]).comp).Enabled then
              TcxControl(TbfaAddfieldComp(scrollbox.Components[I]).comp).SetFocus
            else
              TbfaAddfieldComp(scrollbox.Components[I]).compGrid.Grid.SetFocus;
          end else
            TcxControl(TbfaAddfieldComp(scrollbox.Components[I]).comp).SetFocus;
          Break;
        end;
        // AddfieldComp - TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[I]).ClientOrigin.Y
        // Scrollbox Position - frmMainForm.scrbxViewerAddfields.ClientOrigin.Y
        // Scrollbar Position - frmMainForm.scrbxViewerAddfields.VertScrollbar.Position
      end;

//          for I := 0 to frmMainForm.scrbxViewerAddfields.ComponentCount - 1 do
//    begin
//      if (frmMainForm.scrbxViewerAddfields.Components[I] is TBfaAddfieldComp) then
//      begin
//        pos := TcxControl(TbfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[I]).comp).ClientOrigin.Y;
//        if (pos < frmMainForm.scrbxViewerAddfields.ClientOrigin.Y) then
//            Continue
//        else
//        begin
//          pos := frmMainForm.scrbxViewerAddfields.VertScrollbar.Position
//              + TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[I]).ClientOrigin.Y
//              - frmMainForm.scrbxViewerAddfields.ClientOrigin.Y;
//          if (pos < frmMainForm.scrbxViewerAddfields.VertScrollbar.Position) then
//            frmMainForm.scrbxViewerAddfields.VertScrollbar.Position := pos;
//          if TbfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[I]).AddfieldType = zfld13_Grid then
//          begin
//            if TcxControl(TbfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[I]).comp).Enabled then
//              TcxControl(TbfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[I]).comp).SetFocus
//            else
//              TbfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[I]).compGrid.Grid.SetFocus;
//          end else
//            TcxControl(TbfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[I]).comp).SetFocus;
//          Break;
//        end;
//        // AddfieldComp - TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[I]).ClientOrigin.Y
//        // Scrollbox Position - frmMainForm.scrbxViewerAddfields.ClientOrigin.Y
//        // Scrollbar Position - frmMainForm.scrbxViewerAddfields.VertScrollbar.Position
//      end;

    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetFocusToFirstVisibleAddfield', ClassName);
  end;
end;

procedure TbfaApplication.SetFooterOptions;
var
  ASummary: TcxDataSummary;
begin
  bitfarmLog.DebugBegin(llDebug, 'SetFooterOptions', ClassName);
  try
    try
      if Assigned(frmMainForm.grdResultlistDevEx.FocusedView) then
      begin
        ASummary := frmMainForm.grdResultlistDevEx.FocusedView.DataController.Summary;
        if bitfarmApp.ViewerOptions.GeneralOptions.CalculateOnSelectedRecordsOnly then
          ASummary.Options := ASummary.Options + [soSelectedRecords]
        else
          ASummary.Options := ASummary.Options - [soSelectedRecords];
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'SetFooterOptions', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetFooterOptions', ClassName);
  end;
end;

procedure TbfaApplication.options(AThread: TThread; Tab: Integer = 0);
begin
  bitfarmLog.DebugBegin(llDebug, 'Options', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        var
          bOldOptionNoOCR, bOldOptionPrintAfterArchiving, bOldOptionImportColor, bOldOptionImportHighRes, bOldOptionImportBarcode: Boolean;
        begin
          // Optionen: Wert vor ffnen der Form Options speichern Ticket 16676
          bOldOptionNoOCR := ViewerOptions.GeneralOptions.NoOCR;
          bOldOptionPrintAfterArchiving := ViewerOptions.GeneralOptions.PrintAfterArchiving;
          bOldOptionImportColor := ViewerOptions.GeneralOptions.ImportColor;
          bOldOptionImportHighRes := ViewerOptions.GeneralOptions.ImportHighRes;
          bOldOptionImportBarcode := ViewerOptions.GeneralOptions.ImportBarcode;

          frmMainForm.frmOptions.tcOptions.ActiveTabIndex := Tab;
          frmMainForm.frmOptions.ShowModal;
          if frmMainForm.frmOptions.ModalResult <> mrOk then
          begin
            FViewerOptions.Reload;
            //03.05.2019 Ticket 18972 -->
            //Options und GUI gleich?
            //Button 'Verknpfungsliste einblenden' prfen
            if (bitfarmApp.ViewerOptions.GeneralOptions.ShowDocLinks <> frmMainForm.frmOptions.chkShowDocLinkList.Checked) then
              begin
                frmMainForm.frmOptions.chkShowDocLinkList.Checked := bitfarmApp.ViewerOptions.GeneralOptions.ShowDocLinks;
              end;
            //Button 'Verknpfungsliste in Tab anzeigen' prfen
            if (bitfarmApp.ViewerOptions.GeneralOptions.ShowDocLinksInTab <> frmMainForm.frmOptions.chkDocLinkListInTab.Checked) then
              begin
                frmMainForm.frmOptions.chkDocLinkListInTab.Checked := bitfarmApp.ViewerOptions.GeneralOptions.ShowDocLinksInTab;
              end;
            bitfarmApp.ShowDocLinkList;
            //03.05.2019 Ticket 18972 <--
            SetLength(aResubFavs, 0);
            ReadResubFavs;
            ReadHotSearchOptions;
          end
          else
          begin
            CreateResubColumns;
            SetFooterOptions;
          end;
          UseMatchAgainst := FViewerOptions.SearchOptions.SQLFullText;
          frmMainForm.cbxSearchUser.compComboBox.AutoComplete := not FViewerOptions.GeneralOptions.ComboAutoDown; //09.04.2018
          frmMainForm.cbxSearchUser.compComboBox.AutoDropDown := FViewerOptions.GeneralOptions.ComboAutoDown; //09.04.2018
          frmMainForm.cbxSearchLinks.compComboBox.AutoComplete := not FViewerOptions.GeneralOptions.ComboAutoDown; //09.04.2018
          frmMainForm.cbxSearchLinks.compComboBox.AutoDropDown := FViewerOptions.GeneralOptions.ComboAutoDown; //09.04.2018

          frmMainForm.actRangeOCR.ShortCut := bitfarmApp.ViewerOptions.EditorOptions.OCRKey;

          if frmMainForm.fraScanFunctions <> nil then
          begin
            // Optionen: Falls der Wert dich gendert hat, setzen wir die Options auch im Mainform  Ticket 16676
            if bOldOptionNoOCR <> ViewerOptions.GeneralOptions.NoOCR then
              frmMainForm.fraScanFunctions.chkImportOCR.Checked := not ViewerOptions.GeneralOptions.NoOCR;

            if bOldOptionImportColor <> ViewerOptions.GeneralOptions.ImportColor then
              frmMainForm.fraScanFunctions.chkColor.Checked := ViewerOptions.GeneralOptions.ImportColor;
            if bOldOptionImportHighRes <> ViewerOptions.GeneralOptions.ImportHighRes then
              frmMainForm.fraScanFunctions.chkHiRes.Checked := ViewerOptions.GeneralOptions.ImportHighRes;
            {$IFDEF ENTERPRISE}
            if bOldOptionImportBarcode <> ViewerOptions.GeneralOptions.ImportBarcode then
              TfraScanFunctionsEnterprise(frmMainForm.fraScanFunctions).chkBarcodemerge.Checked := ViewerOptions.GeneralOptions.ImportBarcode;
            {$ENDIF}
            if bOldOptionPrintAfterArchiving <> ViewerOptions.GeneralOptions.PrintAfterArchiving then
              frmMainForm.fraScanFunctions.chkPrintAfterArchive.Checked := ViewerOptions.GeneralOptions.PrintAfterArchiving; // Task 14649
          end;

          bitfarmApp.FillResubFavCombo(frmMainForm.fraImporterResub.cbbFavorites);
          bitfarmApp.FillResubFavCombo(frmMainForm.frmResubDialog.fraCreateResub.cbbFavorites);

          if not frmMainForm.tcSearch.Items[frmMainForm.tcSearch.ActiveTabIndex].Visible then
          begin
            frmMainForm.tcSearch.Toolbar.BeginUpdate;
            try
              frmMainForm.tcSearch.ActiveTabIndex := 0;
            finally
              frmMainForm.tcSearch.Toolbar.EndUpdate;
            end;
          end;

          if frmMainForm.btnLimit.Caption <> IntToStr(FViewerOptions.SearchOptions.Limit) then
            frmMainForm.SetLimit(FViewerOptions.SearchOptions.Limit);

          if frmMainForm.frmOptions.DefaultProfilChanged then
          begin
            if FScannerProfiles.DefaultScanner <> -1 then
              frmMainForm.fraScanFunctions.cbxScanProfile.ItemIndex := FScannerProfiles.DefaultScanner
            else if frmMainForm.fraScanFunctions.cbxScanProfile.Properties.Items.Count > 0 then
              frmMainForm.fraScanFunctions.cbxScanProfile.ItemIndex := 0;
          end;
        end);

      frmMainForm.tmrCheckResub.Enabled := bitfarmApp.ViewerOptions.ResubOptions.ResubTimer;
      frmMainForm.tmrCheckResub.Interval := bitfarmApp.ViewerOptions.ResubOptions.ResubTimerInterval * 60000;

      if CurrentView = tvkResub then
        CreateGrid(CurrentResubFields, AThread);
    except
      bitfarmLog.Write(llNormal, ltException, 'Options', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'Options', ClassName);
  end;
end;

procedure TbfaApplication.Originalfile(UserAction: PUserAction; AThread: TThread);
var
  req: TbfaRequest;
  sock: TSocketConnection;
  params: string;
  Doc: TbfaDocument;
  editable, savestream: Boolean;
  fdir, fpath, fbase, fext, fdoclauncher: string;
  fmodified: TDateTime;
  gdocid: Int64;
  rc, revision: Integer;
  handles : THandleArray;
  cmdline: string;
  h: THandle;
  i : Integer;

begin
//15.09.2020  if (frmMainForm.clItemOriginalfile.Color <> gclBlue) or
  if (frmMainForm.clItemOriginalfile.ImageIndex <> Integer(icoidx_original_file_enabled)) or
     (FCurrentContainer[0].OriLoc = '') then //09.03.2017 Ticket 9998
    Exit;

  if
    (FCurrentContainer[0].ID <> -1) and
    not ((FCurrentContainer[0].Rights and rightWrite) = rightWrite) then
  begin
    BfShowMessage(_('Keine Berechtigung zum ffnen dieser Originaldatei.'), AThread);
    Exit;
  end;

  bitfarmLog.DebugBegin(llDebug, 'Originalfile', Classname);
  OriginalfileLock := True;
  try
    try
//07.03.2018 im Importer "kein Berechtigung auf das Dokument"      if OfflineMode then
      if (OfflineMode) or (FCurrentContainer[0].ID = -1) then
      begin
        OpenInApp(AThread, FCurrentContainer[0]);

      end else begin
        editable := False;
        savestream := True;

        sock := TSocketConnection.Create(bfaServerNoSSL, bfaServer, bfaServerPort, '');
        Doc := TbfaDocument.Create;
        req := TbfaRequest.Create;
        try
          sock.CreateComponents;
          if sock.Connect then
          begin
            req.ReqType := 'reqOri';
            req.UserID := User.ID;
            req.Profile := Self.Profile;
            gdocid := FCurrentContainer[0].ID;
            req.Gdocid := gdocid;
            params := 'base;paths';
            if FCurrentContainer[0].TimID <> -1 then
              req.TimID := FCurrentContainer[0].TimID;

            if (UserAction^.Params.Count > 0) and (UserAction^.Params[0] = 'revision') then
            begin
              editable := False;
              req.Revision := StrToInt(UserAction^.Params[1]);
              req.Version := StrToInt(UserAction^.Params[2]);
              revision := req.Revision;
            end
            else if (UserAction^.Params.Count > 0) and (UserAction^.Params[0] = 'readonly') then
              editable := False
            else if (FCurrentContainer[0].CheckOutUserID = User.ID) or
                    ((bitfarmApp.ViewerOptions.GeneralOptions.AutoCheckout) and (FCurrentContainer[0].CheckOutUserID = -1)) or
                    ((UserAction^.Params.Count > 0) and (UserAction^.Params[0] = 'edit')) then
            begin
              if FCurrentContainer[0].RevSave then
              begin
                BfShowMessage(_('Das Dokument liegt revisionssicher. Es kann nur zum Lesen geffnet werden.'),AThread);
              end
              else if ((FCurrentContainer[0].Rights and rightModify) = rightModify) then
              begin   //bfacrm:ticket__show__25762
                params := params + ';checkout';
                editable := True;
                if FCurrentContainer[0].CheckOutUserID = -1 then
                  FCurrentContainer[0].CheckOutUserID := FUser.ID;
              end;
            end;

            req.Parameter := params;
            req.Lang := Lang;
            sock.SendRequestToServer(req);

            //07.09.2017 Wegen ein Bugreport muss mit AThread aufgerufen werden!       req := sock.ReceiveData(Doc, nil);
            Log.Write(llDebug, ltInfo, 'BEFORE - req := sock.ReceiveData(Doc, AThread);', ClassName);
//26.05.2023            req := sock.ReceiveData(Doc, AThread);
            req := sock.ReceiveData(Doc, AThread, True, True);
            Log.Write(llDebug, ltInfo, 'AFTER - req := sock.ReceiveData(Doc, AThread);', ClassName);
            //01.03.2018 im finally gibt es auch eins        sock.Disconnect;
            if req = nil then
              Exit;

            Log.Write(llDebug, ltInfo, 'req.ReqType = ' + req.ReqType, ClassName);

            if (req.ReqType = 'respDoc') or (req.ReqType = 'respOK') then
            begin
              try
                Log.Write(llDebug, ltInfo, 'BD.EnvTempPd: ' + BD.EnvTempPd, ClassName);
              except
                Log.Write(llDebug, ltException, 'BD.EnvTempPd - EXCEPTION ', ClassName);
              end;

              try
                Log.Write(llDebug, ltInfo, 'Before - Handles', ClassName);
                handles := getProcessHandles('bfaDocLauncher.exe');
                Log.Write(llDebug, ltInfo, 'After - Handles', ClassName);
                Log.Write(llDebug, ltInfo, 'High(handles): ' + IntToStr(High(handles))  , ClassName);
                for i := Low(handles) to High(handles) do
                begin
                  h := handles[i];
                  Log.Write(llDebug, ltInfo, 'h := handles[i] i: ' + IntToStr(i)  , ClassName);
                  if h <> 0 then
                  begin
                    cmdline := GetCommandLineFromPid(h);
                    if Pos('checkout\' + IntToStr(FCurrentContainer[0].ID), cmdline) > 0 then
                    begin
                      Log.Write(llDebug, ltInfo, _('Das Dokument scheint noch geffnet zu sein.'), ClassName);
                      BfShowMessage(_('Das Dokument scheint noch geffnet zu sein.'), AThread);
                      Exit;
                    end;
                  end;
                end;
              except
                Log.Write(llDebug, ltException, 'After - Handles', ClassName);
              end;

              if not DirectoryExists(BD.EnvTempPd + 'checkout\') then
              try
                mkDir(BD.EnvTempPd + 'checkout\');
              except
                on e: exception do
                  Log.Write(llNormal, ltException, _('Konnte Verzeichnis nicht erstellen') + #13#10 + e.Message, ClassName);
              end;

              if not DirectoryExists(BD.AppdataBitfarmPd + 'checkout\') then
              try
                mkDir(BD.AppdataBitfarmPd + 'checkout\');
              except
                on e: exception do
                  Log.Write(llNormal, ltException, _('Konnte Verzeichnis nicht erstellen') + #13#10 + e.Message, ClassName);
              end;

              if editable then
                fdir := BD.AppdataBitfarmPd + 'checkout\' + IntToStr(req.Gdocid) + '\'
              else
                fdir := BD.EnvTempPd + 'checkout\';
              Log.Write(llDebug, ltInfo, 'fdir = ' + fdir , ClassName);


              if not DirectoryExists(fdir) then
              try
                mkDir(fdir);
              except
                on e: exception do
                  Log.Write(llNormal, ltException, _('Konnte Verzeichnis nicht erstellen') + #13#10 + e.Message, ClassName);
              end;

              fpath := fdir + req.FileName;

              if not editable and (revision <> -1) then
              begin
                fext :=  ExtractFileExt(fpath);
                fbase := LeftStr(fpath, length(fpath) - length(fext));
                fpath := fbase + '_rev' + IntToStr(revision) + fext;
              end;

              Log.Write(llDebug, ltInfo, 'fpath := fpath + req.FileName; - ' + fpath , ClassName);

              if not editable and FileExists(fpath) then
              begin
                Log.Write(llDebug, ltInfo, 'fpath delete' , ClassName);
                FileSetAttr(fpath, faArchive or SysUtils.faNormal);
                DeleteFile(fpath);
                Log.Write(llDebug, ltInfo, 'fpath deleted' , ClassName);
              end;

              if FileExists(fpath) then  // bearbeitbare Datei vorhanden? nderungsdatum prfen
              begin
                if editable then
                begin
                  Log.Write(llDebug, ltInfo, 'BEFORE - fmodified := GetFileModDate(fpath);' , ClassName);
                  fmodified := GetFileModDate(fpath);
                  Log.Write(llDebug, ltInfo, 'AFTER - fmodified := GetFileModDate(fpath);' , ClassName);
                  if fmodified > req.FileDate then
                  begin
                  Log.Write(llDebug, ltInfo, 'fmodified > req.FileDate' , ClassName);
                    AThread.Synchronize(nil,
                      procedure
                      begin
                        if BfMessageDlg(_('Es wurde eine aktuellere Version der Datei auf ihrem Rechner gefunden.\n' + 'Wollen Sie mit dieser weiterarbeiten?'), mtConfirmation, [mbYes, mbNo]) = mrYes then
                          savestream := False;
                      end);
                  end;
                end else
                begin
                  fext :=  ExtractFileExt(req.FileName);
                  fbase := LeftStr(req.FileName, length(req.FileName) - length(fext));
                  fpath := fdir + CalcNonExistingFilename(fdir, fbase, ExtractFileExt(req.FileName)) + fext;
                end;
              end;

              Log.Write(llDebug, ltInfo, 'editable: ' + BoolToStr(editable, True) , ClassName);
              Log.Write(llDebug, ltInfo, 'SaveStream: ' + BoolToStr(savestream, True) , ClassName);
              if savestream then
              begin
                try
//26.05.2023 -->                  Doc.DocStream.SaveToFile(fpath);
//                  var fs: TFileStream;
//                  fs := TFileStream.Create(fpath,
//                    fmCreate or fmOpenWrite or fmShareDenyNone);
//                  Doc.OriStream.Position := 0;
//                  fs.CopyFrom(Doc.OriStream, Doc.OriStream.Size);
//                  Doc.OriStream.Free;
//                  Doc.OriStream := fs;

                  sock.ReceiveStream(Doc, fpath, req.DataLen, AThread, frmMainForm.frmSplash);
                  if frmMainForm.frmSplash.Canceled then
                    Exit;

                  Sleep(10);
//26.05.2023 <--
                  FreeAndNil(Doc);
                except
                  on e: exception do
                  begin
                    Log.Write(llNormal, ltException, _('Originaldatei konnte nicht gespeichert werden') + #13#10 + e.Message, ClassName);
                    BfShowMessage(_('Originaldatei konnte nicht gespeichert werden\n(Die Datei ist ggf. noch geffnet)'), AThread);

                    Exit;
                  end;
                end;
              end;

              if editable then
              begin
                //FCurrentContainer[0].CheckOutUserID := User.ID;  // wir knnen nicht die CheckoutUserID bernehmen, wenn ein anderer das ausgecheckt hat
                params := Format('%s %s %s %s %s "%s" %s', [bitfarmApp.Profile, bitfarmApp.bfaServer, Inttostr(bitfarmApp.bfaServerPort), Inttostr(bitfarmApp.User.ID), InttoStr(gdocid), fpath, FUser.Password]);
                if bitfarmApp.ViewerOptions.GeneralOptions.AutoCheckin then
                  params := params + ' checkin';
                if bitfarmApp.bfaServerNoSSL = sctpNoSSL then
                   params := params + ' nossl';

                Log.Write(llDebug, ltInfo, 'BD.ExeDir: ' + BD.ExeDir , ClassName);
                Log.Write(llDebug, ltInfo, 'RunsLocal: ' + BoolToStr(BD.RunsLocal) , ClassName);
                fdoclauncher := '';
                if BD.RunsLocal then  // wenn wir eine lokale Installation sind, dann prfen wir, ob DocLauncher in unserem Verzeichnis liegt
                begin
                  if RightStr(BD.ExeDir,1) = '\' then
                    fdoclauncher := BD.ExeDir + 'bfaDocLauncher\bfaDocLauncher.exe'
                  else
                    fdoclauncher := BD.ExeDir + '\bfaDocLauncher\bfaDocLauncher.exe';

                  if not FileExists(fdoclauncher) then   // nicht vorhanden, dann in Appdata suchen
                  begin
                    fdoclauncher := BD.AppdataBitfarmPd + 'bfaDocLauncher\bfaDocLauncher.exe';
                    if not FileExists(fdoclauncher) then
                      fdoclauncher := '';
                  end;
                end else   // ansonsten sollte der DocLauncher in Appdata liegen
                begin
                  fdoclauncher := BD.AppdataBitfarmPd + 'bfaDocLauncher\bfaDocLauncher.exe';
                  if not FileExists(fdoclauncher) then
                    fdoclauncher := '';
                end;

                if fdoclauncher = '' then
                begin
                  Log.Write(llDebug, ltError, 'DocLauncher konnte nicht gefunden werden, lade vom Server', ClassName);

                  if not GetDocLauncher(AThread) then
                  begin
                    BfShowMessage(_('DocLauncher konnte nicht geladen werden.\nBitte wenden Sie sich an den Support.'), AThread);
                    Exit;
                  end;
                  fdoclauncher := BD.AppdataBitfarmPd + 'bfaDocLauncher\bfaDocLauncher.exe';
                end;

                Log.Write(llDebug, ltInfo, 'ShellExecute: ' + fdoclauncher + ' '+ params, ClassName);
                //rc := ShellExecute(Application.Handle, nil, PChar(fdoclauncher), PChar(params), nil, SW_HIDE);
                rc := ShellExecute(Application.Handle, nil, PWideChar(fdoclauncher), PWideChar(params), PWideChar(fdir), SW_HIDE);

                Log.Write(llDebug, ltInfo, 'DocLauncher gestartet: rc = ' + InttoStr(rc) , ClassName);
                if rc <> 42 then
                begin
                  Log.Write(llNormal, ltException, _('Originaldatei konnte nicht geffnet werden. rc = ') + InttoStr(rc), ClassName);
                  AThread.Synchronize(AThread,
                    procedure
                    begin
                      BfShowMessage(_('Es hat einen Fehler beim ffnen der Originaldatei gegeben'));
                    end);
                end;
              end
              else
              begin
                Log.Write(llDebug, ltInfo, 'bfaExecFile: ' + fpath , ClassName);
                FileSetAttr(fpath, faArchive or SysUtils.faReadOnly);
                bfaExecFile(fpath);
              end;
            end else begin
              BfShowMessage(_('Das Dokument konnte nicht geladen werden.') + #13#10 + req.DataString, AThread);
            end;

            AThread.Synchronize(nil,
              procedure
              begin
                SetDocState(FCurrentContainer[0]);
              end);
          end;

        finally
          sock.Disconnect;
          FreeAndNil(req);
          FreeAndNil(sock);
          if Assigned(Doc) then
            FreeAndNil(Doc);
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'Originalfile', ClassName);
    end;
  finally
    OriginalfileLock := False;
    bitfarmLog.DebugEnd(llDebug, 'Originalfile', Classname);
  end;
end;

procedure TbfaApplication.OnDocSelect(arcid: Integer; gdocid: Int64);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'OnDocSelect - ', Classname);
  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actLoadDoc';
      UserAction^.params.Add(IntToStr(arcid));
      UserAction^.params.Add(IntToStr(gdocid));

      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'OnDocSelect - ', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'OnDocSelect - ', Classname);
  end;
end;

procedure TbfaApplication.OnGridExport(Field: TBfaAddfieldComp);
var
  csv, header, mydir, csvfile, html : string;
  Alt, Ctrl : Boolean;
  csvlist, values: TStringList;
  i, j: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'OnGridExport', ClassName);
  Ctrl := (GetKeyState(VK_CONTROL) < 0);
  Alt := (GetKeyState(VK_MENU) < 0);
  try
    try
      if (FCurrentContainer.Count > 0)  then
      begin
        csvlist := TStringList.Create;
        Field.compGrid.GetExport(header, csv);
        csv := StringReplace(csv, '|', #13#10, [rfReplaceAll]);

        if Field.compGrid.Config.ExportAddfields then
        begin
          csvlist.Text := csv;
          if csvlist.Count > 0 then
          begin
            for i := 0 to FCurrentContainer[0].AddFields.Count -1 do
            begin
              if FCurrentContainer[0].AddFields[i].ID = Field.FieldID then
                Continue;

              if Field.compGrid.Config.UseColumnNames then
                header := header + ';' + FCurrentContainer[0].AddFields[i].DisplayName
              else
                header := header + ';' + FCurrentContainer[0].AddFields[i].Name;

              if VarIsNull(FCurrentContainer[0].AddFields[i].Value) then
                csvlist[0] := csvlist[0] + ';'
              else
                csvlist[0] := csvlist[0] + ';' + #34 + FCurrentContainer[0].AddFields[i].Value + #34;

            end;
            csv := csvlist.Text;
          end;
        end;

        if Ctrl then
        begin
          try
            frmMainForm.dlgSaveGrid.Filter := 'CSV files (*.csv)|*.csv|Any file (*.*)|*.*';
            frmMainForm.dlgSaveGrid.DefaultExt := '.csv';
            if frmMainForm.dlgSaveGrid.Execute then
            begin
              Screen.Cursor := crHourGlass;
              try
                if (header <> '') and Field.compGrid.View.OptionsView.Header then
                  csv := header + #13#10 + csv;

                if Field.compGrid.Config.ExportUnicode then
                  StringToFileUTF8(frmMainForm.dlgSaveGrid.FileName, csv)
                else
                  StringToFile(frmMainForm.dlgSaveGrid.FileName, csv);

                if (FViewerOptions.GeneralOptions.AlertWindow) then
                  ShowAlertWindow(alSave, Format(_('Das Grid wurde nach %s exportiert.'), [frmMainForm.dlgSaveGrid.FileName]))
                else
                  frmMainForm.SetNotificationBar(Format(_('Das Grid wurde nach %s exportiert.'), [frmMainForm.dlgSaveGrid.FileName]), nil);
              finally
                Screen.Cursor := crDefault;
              end;
            end;
          except
            bitfarmLog.Write(llNormal, ltException, 'actExportProfilesExecute', ClassName);
          end;
        end else if Alt then
        begin
//          csvlist := TStringList.Create;
          csvlist.Text := csv;
          values := TStringList.Create(#0,';', [soStrictDelimiter]);
          html := '<html><style>table{border-collapse:collapse;border:1px solid #000000;}table th, td{border:1px solid #000000;padding:4px}</style><body><!--StartFragment--><table>';

          if (header <> '') and Field.compGrid.View.OptionsView.Header then
          begin
            html := html + '<tr>';
            values.DelimitedText := header;
            for j := 0 to values.Count -1 do
            begin
              html := html + '<th>' + values[j] + '</th>';
            end;
            html := html + '</tr>';
          end;
          for i := 0 to csvlist.Count -1 do
          begin
            html := html + '<tr>';
            values.DelimitedText := csvlist[i];
            for j := 0 to values.Count -1 do
            begin
              html := html + '<td>' + values[j] + '</td>';
            end;
            html := html + '</tr>';
          end;
          html := html + '</table></body>';
          html := bfaCommonMethods.StrToHtml(html);
          bfaCommonFiles.CopyLinkToClipboard(csv, html);
          if (FViewerOptions.GeneralOptions.AlertWindow) then
            ShowAlertWindow(alSave, _('Das Grid wurde in die Zwischenablage kopiert.'))
          else
            frmMainForm.SetNotificationBar(_('Das Grid wurde in die Zwischenablage kopiert.'), nil);
        end else
        begin
          mydir := BD.EnvTemp + '\bfa_grid\';
          bitfarmLog.Write(llDebug, ltInfo, Format('Pfad fr Grid-Export ermittelt: %s', [mydir]), ClassName);
          if not (DirectoryExists(mydir)) then
          try
            MkDir(mydir);
          except
            bitfarmLog.Write(llNormal, ltException, Format('Fehler beim Anlegen eines Verzeichnisses: %s', [mydir]), ClassName);
          end;
          csvfile := mydir + Field.Dispname + '_' + IntToStr(FCurrentContainer[0].ID) +  '.csv';
          try
            if header <> '' then
              csv := header + #13#10 + csv;

            if Field.compGrid.Config.ExportUnicode then
              StringToFileUTF8(csvfile, csv)
            else
              StringToFile(csvfile, csv);
          except
            BfShowMessage(Format('Fehler beim Export des Grids in die Datei %s', [csvfile]), nil);
            bitfarmLog.Write(llDebug, ltError, Format('Fehler beim Export des Grids in die Datei %s', [csvfile]));
          end;
          if Field.FieldID < length(aAddfields) then
          begin
            if (aAddfields[Field.FieldID].Checkprogram <> '') and FileExists(aAddfields[Field.FieldID].Checkprogram) then
            begin
              ShellExecute(Application.Handle, nil, PWideChar(aAddfields[Field.FieldID].Checkprogram), PWideChar(csvfile), PWideChar(mydir), 0);
            end else
            begin
              ShellExecute(Application.Handle, PWideChar('open'), PWideChar(csvfile), PWideChar(''), PWideChar(mydir), 0);
            end;
          end;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'OnGridExport', ClassName);
    end;
  finally
    if Assigned(csvlist) then
      FreeAndNil(csvlist);
    bitfarmLog.DebugEnd(llDebug, 'OnGridExport', ClassName);
  end;
end;

procedure TbfaApplication.OnGridStamp(Field: TBfaAddfieldComp);
var
  csv, header, html, color, streamsize : string;
  Alt, Ctrl : Boolean;
  csvlist, values: TStringList;
  i, j, w, h, lensum, lenrow, l, colcount, stamp_size: Integer;
  lenval: Float32;
  viewObject : IViewObject;
  r : TRect;
  bitmap : TBitmap;
  web: TWebBrowser;
  Doc: Variant;
  Stream: TMemoryStream;
  prev: TbfaPreview;
//  lenarray: array of array of integer;
  lenlist: TList<TList<Integer>>;
begin
  inc(GlobalCounter);
  bitfarmLog.DebugBegin(llDebug, 'OnGridStamp', ClassName);
  Ctrl := (GetKeyState(VK_CONTROL) < 0);
  Alt := (GetKeyState(VK_MENU) < 0);
  try
    try
      if (FCurrentContainer.Count > 0)  then
      begin

        Field.compGrid.GetExport(header, csv, True);
        if Field.compGrid.Config.Stamp_Color <> '' then
          color := Field.compGrid.Config.Stamp_Color
        else
          color := '#000000';
        stamp_size := Field.compGrid.Config.Stamp_Size;
        csv := StringReplace(csv, '|', #13#10, [rfReplaceAll]);
        csvlist := TStringList.Create;
        csvlist.Text := csv;
        values := TStringList.Create(#0,';', [soStrictDelimiter]);
        html := '<html><style>table{border-collapse:collapse;border:1px solid '+color+'}table th, td{border:1px solid '+color+';padding:4px;white-space: nowrap}body {font-family: Courier, monospace;color:'+color+';}</style><body><!--StartFragment--><table>';
        w := 0;
        h := 0;
        lenval := 0;

        if (header <> '') and Field.compGrid.View.OptionsView.Header then
        begin
          html := html + '<tr>';
          values.DelimitedText := header;

          lenlist := TList<TList<Integer>>.Create;
          for i := 0 to csvlist.Count  do
            lenlist.Add(TList<Integer>.Create);

          for j := 0 to values.Count -1 do
          begin
            html := html + '<th>' + values[j] + '</th>';
            lenlist[0].Add(length(values[j]));
          end;
          html := html + '</tr>';
        end else
        begin
          if csvlist.Count > 0 then
            values.DelimitedText := csvlist[0];
          lenlist := TList<TList<Integer>>.Create;
          for i := 0 to csvlist.Count do
            lenlist.Add(TList<Integer>.Create);
        end;

        for i := 0 to csvlist.Count -1 do
        begin
          values.DelimitedText := csvlist[i];
          for j := 0 to values.Count -1 do
          begin
            lenlist[i+1].Add(length(values[j]));
          end;
        end;
        colcount := 0;
        for i := 0 to lenlist.Count -1 do
        begin
          if lenlist[i].Count > colcount then
            colcount := lenlist[i].Count;
        end;

        for i := 0 to csvlist.Count -1 do
        begin
          html := html + '<tr>';
          values.DelimitedText := csvlist[i];
          for j := 0 to values.Count -1 do
          begin
            if values.Count = 1 then         // bei Gruppen gibt es nur ein Value pro Zeile
              html := html + '<td colspan='+ IntToStr(colcount) +'>' + values[j] + '</td>'
            else
              html := html + '<td>' + values[j] + '</td>';

          end;
          html := html + '</tr>';
        end;

        // breiteste Spalte finden
        lenval := 0;
        lensum := 0;
        lenrow := 0;
        for i := 0 to colcount -1 do  // durch alle Spalten
        begin
          l := 1;       // es wird wenigstens ein Zeichen Spaltenbreite angenommen
          lenrow := 0;
          for j := 0 to lenlist.Count -1 do
          begin
            if i >= lenlist[j].Count then
              Continue;
            if lenlist[j][i] > l then
              l := lenlist[j][i];    // grter Eintrag in einer Spalte
          end;
          lensum := lensum + l;
        end;

        for i := 0 to lenlist.Count -1 do    // durch alle Reihen
        begin
          l := 1;       // es wird wenigstens ein Zeichen Spaltenbreite angenommen
          lenrow := 0;
          for j := 0 to colcount -1 do
          begin
            if j >= lenlist[i].Count then
              Continue;
            lenrow := lenrow + lenlist[i][j] +1;
          end;
          if lenrow > lensum then
            lensum := lenrow;
        end;
        lenval := (lensum * 11.2);
        w := trunc(lenval) + 40;
        h := (csvlist.Count * 28) + 30;
        if header <> '' then
          h := h + 28;

        html := html + '</tr></body>';
        html := bfaCommonMethods.StrToHtml(html);

          web := TWebBrowser.Create(nil);

          if not Assigned(web.Document) then
            web.Navigate('about:blank');

        Doc := web.Document;
        Doc.Clear;
        Doc.Write(html);
        Doc.Close;
//
        web.Width := w;
        web.Height := h;
        web.OleObject.document.body.style.overflowX:='hidden'; // hide the scroll bars
        web.OleObject.document.body.style.overflowY:='hidden';
        web.OleObject.document.body.style.borderstyle:='none'; // and remove border
        web.Document.QueryInterface(IViewObject, viewObject) ;

        if Assigned(viewObject) then
        begin
          bitmap := TBitmap.Create;
          web.Realign;
          r := Rect(0, 0, web.Width, web.Height) ;

          bitmap.Height := web.Height;
          bitmap.Width := web.Width;

          viewObject.Draw(DVASPECT_CONTENT, 1, nil, nil, 0, bitmap.Canvas.Handle, @r, nil, nil, 0) ;
//          bitmap.SaveToFile('test2.bmp');

          Stream := TMemoryStream.Create;
          try
            bitmap.SaveToStream(Stream);
            Stream.Position := 0;
            streamsize := IntToStr(Stream.Size);
            OutputDebugString(PWideChar('GridStamp Stream Size:' + streamsize));
            prev := GetActivePreview;

            if prev.SingleView.img_DocView.MouseInteractVt = [miPutBitmap] then
              prev.SingleView.img_DocView.CancelInteracts;

            prev.SingleView.img_DocView.ObjKind[-1] := iekBITMAP;
            prev.SingleView.img_DocView.EnableAlphaChannel := True;

            prev.SingleView.img_DocView.SetObjBitmapFromStream(-1, Stream);
            prev.SingleView.img_DocView.ObjWidth[-1] :=
              Round(bitmap.Width / prev.SingleView.img_DocView.MeasureCoefX / (prev.SingleView.img_DocView.Zoom / stamp_size));
            prev.SingleView.img_DocView.ObjHeight[-1] :=
              Round(bitmap.Height / prev.SingleView.img_DocView.MeasureCoefY / (prev.SingleView.img_DocView.Zoom / stamp_size));

            prev.SingleView.img_DocView.ObjBitmapBorder[-1] := False;

            prev.SingleView.img_DocView.ObjStyle[-1] := [ievsSelectable,
              ievsMoveable, ievsVisible, ievsSizeable];

            if Field.compGrid.Config.Stamp_Transparent then
              prev.SingleView.img_DocView.ObjTransparency[-1] := 150;

            prev.SingleView.img_DocView.MouseInteractVt := [miPutBitmap];

          finally
            if Assigned(bitmap) then
              FreeAndNil(bitmap);
            if Assigned(Stream) then
              FreeAndNil(Stream);

            viewObject._Release;

            //if Assigned(web) then
              //FreeAndNil(web);
          end;

        end;

      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'OnGridStamp', ClassName);
    end;
  finally

     bitfarmLog.DebugEnd(llDebug, 'OnGridStamp', ClassName);
  end;
end;

procedure TbfaApplication.OnGridStamp2(Field: TBfaAddfieldComp);
var
  lenarray: array of array of integer;
  csvlist, values: TStringList;
  csv, header, html, color, streamsize : string;
begin
  SetLength(lenarray, 1);
  SetLength(lenarray[0],1);
  Field.compGrid.GetExport(header, csv, True);
  csv := StringReplace(csv, '|', #13#10, [rfReplaceAll]);
  csvlist := TStringList.Create;
  csvlist.Text := csv;
  values := TStringList.Create(#0,';', [soStrictDelimiter]);
  values.DelimitedText := header;
  SetLength(lenarray, csvlist.Count +1);
  for var i := 0 to csvlist.Count do
    SetLength(lenarray[i], values.Count);
end;

procedure TbfaApplication.OnModifiedDateField(Field: TBfaAddfieldComp);
begin
  //OutputDebugString('OnModifiedSpinEdit');
  bitfarmLog.DebugBegin(llDebug, 'OnModifiedDateField', ClassName);
  try
    try
      // das Speichern von Leerwerten '' erlauben, soll in der Datenbank mit NULL gespeichert werden
      if (FCurrentContainer.Count > 0) and (FCurrentContainer[0].InEditMode) then
      begin
        if (Field.Value = '') then
        begin
//          Field.Modified := True;
//          Field.compDateLow.Style.Color := cColorHellgruen;
//          Field.ModifiedHigh := False;
//          Field.compDateHigh.Style.Color := clWhite;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'OnModifiedDateField', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'OnModifiedDateField', ClassName);
  end;
end;

procedure TbfaApplication.OnModifiedSpinEdit(Field: TBfaAddfieldComp);
begin
  //OutputDebugString('OnModifiedSpinEdit');
//  bitfarmLog.DebugBegin(llDebug, 'OnModifiedSpinEdit', ClassName);
  try
    try  // das Speichern von Leerwerten '' erlauben, soll in der Datenbank mit NULL gespeichert werden
      if (FCurrentContainer.Count > 0) and (FCurrentContainer[0].InEditMode) then
      begin
        if (Field.Value = '') then
        begin
//          Field.Modified := True;
//          Field.compSpinEditLow.Color := cColorHellgruen;
//          Field.ModifiedHigh := False;
//          Field.compSpinEditHigh.Color := clWhite;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'OnModifiedSpinEdit', ClassName);
    end;
  finally
//      bitfarmLog.DebugEnd(llDebug, 'OnModifiedSpinEdit', ClassName);
  end;
end;

procedure TbfaApplication.OnSharedLayerClick(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'OnSharedLayerClick', Classname);
  try
    try

      PreviewContainer.Containers[PreviewContainer.ActiveItem].Preview.bfaTlbPreview.mnuPrivateAnno.Checked := True;
      PreviewContainer.Containers[PreviewContainer.ActiveItem].Preview.bfaTlbPreview.mnuPublicAnno.Checked := False;

      frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Checked := PreviewContainer.Containers[PreviewContainer.ActiveItem].Preview.bfaTlbPreview.mnuPrivateAnno.Checked;
      frmMainForm.bfaTlbPreview1.mnuPublicAnno.Checked := PreviewContainer.Containers[PreviewContainer.ActiveItem].Preview.bfaTlbPreview.mnuPublicAnno.Checked;

      UserAction := CreateUserAction;
      UserAction^.ActionName := 'actPrivateAnno';
      UserAction^.Preview := PreviewContainer.Containers[PreviewContainer.ActiveItem].Preview;
      UserAction^.params.Add(IntToStr(TSpTBXItem(Sender).Tag));
      MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'OnSharedLayerClick', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'OnSharedLayerClick', Classname);
  end;
end;

procedure TbfaApplication.OnStationeryClick(Sender: TObject);
var
  i: Integer;
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'OnStationeryClick', Classname);
  try
    try
      if TSpTBXItem(Sender).Checked and (frmMainForm.bfaTlbPreview1.mnuStationery.Checked or frmMainForm.bfaTlbPreview1.sbmStationery.Checked) then
        Exit;

      for i := 0 to frmMainForm.bfaTlbPreview1.sbmStationery.Count - 1 do
        frmMainForm.bfaTlbPreview1.sbmStationery[i].Checked := False;
      TSpTBXItem(Sender).Checked := True;

      for i := 0 to FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.bfaTlbPreview.sbmStationery.Count - 1 do
        FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.bfaTlbPreview.sbmStationery[i].Checked := False;

      if FPreviewContainer.ActiveItem = 0 then    // Wenn die ViewerPreview aktiv ist
        for i := 0 to frmMainForm.bfaTlbPreview1.sbmStationery.Count - 1 do
          FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.bfaTlbPreview.sbmStationery[i].Checked := frmMainForm.bfaTlbPreview1.sbmStationery[i].Checked;

      StationeryIndex := TSpTBXItem(Sender).Tag;
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actStationery';
      UserAction^.params.Add('1');
      UserAction^.Preview := FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview;
      bitfarmApp.MainThread.Add(UserAction);

      FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.bfaTlbPreview.mnuStationery.Checked := True;
      FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.bfaTlbPreview.sbmStationery.Checked := True;
      frmMainForm.bfaTlbPreview1.mnuStationery.Checked := True;
      frmMainForm.bfaTlbPreview1.sbmStationery.Checked := True;

    except
      bitfarmLog.Write(llNormal, ltException, 'OnStationeryClick', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'OnStationeryClick', Classname);
  end;
end;

procedure TbfaApplication.PreviousPage(AThread: TThread; prev: TbfaPreview; Params: TStringList);
var
  iPage: Integer;
  SetFocus: Boolean;
  SetImagePos, SetImagePosTothetop, Autozoom: Boolean;
begin
  bitfarmLog.DebugBegin(llDebug, 'PreviousPage', ClassName);
  try
    try
      if ((prev.PreviewKind = pvkSingle) or (prev.PreviewKind = pvkMultiSingle)) then
      begin
        prev.askforsave_annos2(AThread);

        if (Params <> nil) and (Params.Count > 0) and (Params[0] = '1') then
          SetFocus := True
        else
          SetFocus := False;

        SetImagePos := False;
        SetImagePosTothetop := False;
        Autozoom := True;
        if Params.Count >= 3 then
        begin
          SetImagePos := (Params[1] = '1');
          SetImagePosTothetop := (Params[2] = '1');
          if Params.Count >= 4 then
            Autozoom := (Params[3] = '1');
        end;
        iPage := -1; //18.09.2018 Ticket 15219

        MViewImageSelect(prev.ThumbnailView, prev, iPage, -1, False, False, False, False, SetFocus, False, False, SetImagePos, SetImagePosTothetop, Autozoom, 0);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'PreviousPage', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'PreviousPage', ClassName);
  end;
end;

procedure TbfaApplication.ShowPrintAlertWindow(Data: PUserAction; AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'ShowPrintAlertWindow', ClassName);
  try
    try
      if (AThread <> nil) then
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            if (FViewerOptions.GeneralOptions.AlertWindow) then
            begin
              if Data^.Documents.Count > 1 then
                ShowAlertWindow(alPrint, _('Die Dokumente wurden an den Drucker gesendet.'))
              else
                ShowAlertWindow(alPrint, Format(_('Das Dokument "%s" wurde an den Drucker gesendet.'), [TbfaDocument(Data^.Documents[0]).DocName]));
            end
            else
            begin
              if Data^.Documents.Count > 1 then
//                bitfarmApp.SetStatusInfo(_('Die Dokumente wurden an den Drucker gesendet.'), nil)
                frmMainForm.SetNotificationBar(_('Die Dokumente wurden an den Drucker gesendet.'), nil) // SJ 14.08.2019
              else
//                bitfarmApp.SetStatusInfo(Format(_('Das Dokument "%s" wurde an den Drucker gesendet.'), [TbfaDocument(Data^.Documents[0]).DocName]), nil);
                frmMainForm.SetNotificationBar(Format(_('Das Dokument "%s" wurde an den Drucker gesendet.'), [TbfaDocument(Data^.Documents[0]).DocName]), nil); // SJ 14.08.2019
            end;
          end);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'ShowPrintAlertWindow', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ShowPrintAlertWindow', ClassName);
  end;
end;

procedure TbfaApplication.PrintPreview(Data: PUserAction; AThread: TThread);
var
  Stationery, Priv, Pub, Center, Rotate, Sort, Merge: Boolean;
  i, Copies: Integer;
  Left, Top, Right, Bottom, sWidth, sHeight: Double;
  ieVPos: TIEVerticalPos;
  ieHPos: TIEHorizontalPos;
  ieSize: TIESize;
  PrnLst: TList<TPrinter>;
  Lst: TList<TbfaDocument>;
  Layer: Int64;
  req: TbfaRequest;
  hist: TbfaHistory;
  ObjLst: TList<TbfaBaseObject>;
  AlwaysWithAnno, Duplex: Boolean;
  Str: TMemoryStream;
begin
  bitfarmLog.DebugBegin(llDebug, 'PrintPreview', ClassName);
  try
    try
      Stationery := (Data^.params[0] = '1');
      Priv := (Data^.params[1] = '1');
      Pub := (Data^.params[2] = '1');
      Layer := StrToInt64(Data^.params[3]);
      Merge := (Data^.params[4] = '1');
      Center := (Data^.params[5] = '1');
      Rotate := (Data^.params[6] = '1');
      Left := StrToFloat(Data^.params[7]);
      Top := StrToFloat(Data^.params[8]);
      Right := StrToFloat(Data^.params[9]);
      Bottom := StrToFloat(Data^.params[10]);
      Copies := StrToInt(Data^.params[11]);
      Sort := (Data^.params[12] = '1');
      AlwaysWithAnno := (Data^.params[16] = '1');

      if ((Data^.Documents <> nil) and (Data^.Documents.Count > 0)) then
      begin
        ShowPrintAlertWindow(Data, AThread);

        if Center then
        begin
          ieVPos := ievpCENTER;
          ieHPos := iehpCENTER;
        end
        else
        begin
          ieVPos := ieVPTop;
          ieHPos := ieHPLeft;
        end;

        ieSize := TIESize(Data^.objects[1]);

//03.08.2017 Ticket 11366        img := CreateInvisibleMView(nil);
        PrnLst := TList<TPrinter>(Data^.objects[0]);
        Lst := Tlist<TbfaDocument>.Create;
        try
          if Merge then
          begin
            if ieSize = iesSPECIFIEDSIZE then
            begin
              sWidth := StrToFloat(Data^.params[12]);
              sHeight := StrToFloat(Data^.params[13]);
            end
            else
            begin
              sWidth := 0;
              sHeight := 0;
            end;

            Str := TMemoryStream.create;
            try
              Duplex := TbfaPrinter(PrnLst[0]).GetPrnDuplex;
              Str := bfaProcessing.bfaImageRendering(AThread, TList<TbfaDocument>(Data^.Documents), Stationery, Priv, Pub, Layer, Copies, Sort, nil, Data^.params[14], AlwaysWithAnno, Duplex);

              try
                if BD.DevDebug then
                begin
                  if not DirectoryExists(BD.EnvAppdataPd + 'bitfarm-archiv\Printtest') then
                    ForceDirectories(BD.EnvAppdataPd + 'bitfarm-archiv\Printtest');
                  Str.Position := 0;
                  Str.SaveToFile(BD.EnvAppdataPd + 'bitfarm-archiv\Printtest\Prnt.tif');
                end;

              except
              end;

              Str.Position := 0;
              Print(Str, Left, Top, Right, Bottom, sWidth, sHeight, 1, ieVPos, ieHPos, ieSize, Rotate, PrnLst[0]);

            finally
              FreeAndNil(Str);
            end;
          end
          else
          begin

            for i := 0 to Data^.Documents.Count - 1 do
            begin
              if ieSize = iesSPECIFIEDSIZE then
              begin
                sWidth := StrToFloat(Data^.params[12]);
                sHeight := StrToFloat(Data^.params[13]);
              end
              else
              begin
                sWidth := 0;
                sHeight := 0;
              end;

              Lst.Clear;
              Lst.Add(TbfaDocument(Data^.Documents[i]));

              Str := TMemoryStream.create;
              try
                Duplex := TbfaPrinter(PrnLst[0]).GetPrnDuplex;


                Str := bfaProcessing.bfaImageRendering(AThread, Lst, Stationery, Priv, Pub,
                  Layer, Copies, Sort, nil, Data^.params[14], AlwaysWithAnno, Duplex);

                try
                  if BD.DevDebug then
                  begin
                    if not DirectoryExists(BD.EnvAppdataPd + 'bitfarm-archiv\Printtest') then
                      ForceDirectories(BD.EnvAppdataPd + 'bitfarm-archiv\Printtest');
                    Str.Position := 0;
                    Str.SaveToFile(BD.EnvAppdataPd + 'bitfarm-archiv\Printtest\Prnt.tif');
                  end;
                except
                end;

                Str.Position := 0;
                Print(Str, Left, Top, Right, Bottom, sWidth, sHeight, 1, ieVPos, ieHPos, ieSize, Rotate, PrnLst[i]);

              finally
                FreeAndNil(Str);
              end;

            end;
          end;

          if not OfflineMode then
          begin
            for i := 0 to Data^.Documents.Count - 1 do
            begin
              if TbfaDocument(Data^.Documents[i]).Id <> -1 then
              begin
//                req := TbfaRequest.Create;
//                try
//                  req.ReqType := 'reqSaveHistory';
//                  req.UserID := FUser.ID;
//                  req.Profile := Profile;
//                  req.Lang := Lang;

                hist := TbfaHistory.Create;
                hist.Userid := FUser.ID;
                hist.Gdocid := TbfaDocument(Data^.Documents[i]).Id;
                hist.Date := Now();
                hist.Taskid := 207;
                hist.Value1 := Printer.Printers.Strings[Printer.PrinterIndex];

                WriteHistory(AThread, hist);

//                  ObjLst := TList<TbfaBaseObject>.Create;
//                  try
//                    ObjLst.Add(hist);
//
//                    req.Data := ObjLst;
//
//                    MainSocket.SendRequestToServer(req);
//
//                    req := MainSocket.ReceiveResponse(AThread);
//                    if req = nil then
//                      Exit;
//
//                    if (req.ReqType = 'respError') or (req.ReqType = 'respAuthError') then
//                    begin
//                      BfShowMessage(_('Server meldet Fehler: ') + req.DataString, AThread);
//                      Exit;
//                    end;
//                  finally
//                    FreeAndNil(ObjLst);
//                  end;
//                finally
//                  FreeandNil(hist);
//                  FreeAndNil(req);
//                end;
              end;
            end;
          end;

        finally
//03.08.2017 Ticket 11366          img.Free;
//          img := nil;
          for i := 0 to PrnLst.Count - 1 do
          begin
            if PrnLst[i].Printing then
              PrnLst[i].EndDoc;
//18.04.2018 wegen TerminalServer Absturz auskommentiert            PrnLst[i].Free;
          end;
          PrnLst.Clear;
          FreeAndNil(PrnLst);

          FreeAndNil(Lst);
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'PrintPreview', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'PrintPreview', ClassName);
  end;
end;

procedure TbfaApplication.PrintSelect(Data: PUserAction; AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'PrintSelect', 'BackThread');
  BfShowMessage('PrintSelect', AThread);
  bitfarmLog.DebugEnd(llDebug, 'PrintSelect', 'BackThread');
end;

procedure TbfaApplication.PrintStandard(Data: PUserAction; AThread: TThread);
var
  Stationery, Priv, Pub, AlwaysWithAnno, Collate: Boolean;
  i: Integer;
  PrnLst: TList<TPrinter>;
  Layer: Int64;
  req: TbfaRequest;
  hist: TbfaHistory;
  ObjLst: TList<TbfaBaseObject>;
  Str: TMemoryStream;
  Lst: TList<TbfaDocument>;
  SendSocket: TSocketConnection;
begin
  bitfarmLog.DebugBegin(llDebug, 'PrintStandard', ClassName);
  try
    try
      Stationery := (Data^.params[0] = '1');
      Priv := (Data^.params[1] = '1');
      Pub := (Data^.params[2] = '1');
      Layer := StrToInt64(Data^.params[3]);
      AlwaysWithAnno := (Data^.params[6] = '1');
      if ((Data^.Documents <> nil) and (Data^.Documents.Count > 0)) then
      begin
//03.08.2017 Ticket 11366        img := CreateInvisibleMView(nil);
//03.08.2017 hatte ein dokument und mehrere leerseiten erstellt        PrnLst := TList<TPrinter>(Data^.Objects[0]);
        PrnLst := TList<TPrinter>(Data^.objects);
        try
          ShowPrintAlertWindow(Data, AThread);
//03.08.2017 Ticket 11366 -->
//          bfaProcessing.bfaImageRendering(TList<TbfaDocument>(Data^.Documents),
//            Stationery, Priv, Pub, Layer, 1, False, img, '', AlwaysWithAnno);
//
//          Print(img, 0, 0, 0, 0, Printer.PageWidth, Printer.PageHeight, 1,
//            ievpCENTER, iehpCENTER, iesFITTOPAGE, True, PrnLst[0]);
          for i := 0 to Data^.Documents.Count - 1 do
          begin
            Str := TMemoryStream.Create;
            Lst := TList<TbfaDocument>.Create;
            try
              Lst.Add(Data^.Documents[i]);

              Str := bfaProcessing.bfaImageRendering(AThread, Lst, //16.11.2017 wegen Ticket 12517
                Stationery, Priv, Pub, Layer, 1, False, nil, '', AlwaysWithAnno);

              Print(Str, 0, 0, 0, 0, Printer.PageWidth, Printer.PageHeight, 1, ievpCENTER, iehpCENTER, iesFITTOPAGE, True, PrnLst[i]);
            finally
              FreeAndNil(Str);
              FreeAndNil(Lst);
            end;
          end;
//03.08.2017 Ticket 11366 <--

          if not OfflineMode then
          begin
            for i := 0 to Data^.Documents.Count - 1 do
            begin
              if TbfaDocument(Data^.Documents[i]).Id <> -1 then
              begin
                hist := TbfaHistory.Create;
                hist.Userid := FUser.ID;
                hist.Gdocid := TbfaDocument(Data^.Documents[i]).Id;
                hist.Date := Now();
                hist.Taskid := 207;
                hist.Value1 := Printer.Printers.Strings[Printer.PrinterIndex];

                WriteHistory(AThread, hist);
              end;
            end;
          end;
        finally
          for i := 0 to PrnLst.Count - 1 do
          begin
            if PrnLst[i].Printing then
              PrnLst[i].EndDoc;
            PrnLst[i].Free;
          end;
          PrnLst.Clear;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'PrintStandard', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'PrintStandard', ClassName);
  end;
end;

procedure TbfaApplication.Print(MStream: TMemoryStream;
  MLeft, MTop, MRight, MBottom, SWidth, SHeight, Gamma: Double; VPos: TIEVerticalPos;
  HPos: TIEHorizontalPos; Size: TIESize; Rotate: Boolean; Prn: TPrinter);
var
  i, cnt: Integer;
  img: TbfaImageEnVect;
  tiffhandler: TIETIFFHandler;
  reload: Boolean;
begin
  bitfarmLog.DebugBegin(llDebug, 'Print', ClassName);
  try
    try
      if (MStream <> nil) and (MStream.Size > 0) then
      begin
        img := CreateInvisibleVect(nil);
        tiffhandler := TIETIFFHandler.Create;
        try
          MStream.Position := 0;
          tiffhandler.ReadStream(MStream);
          cnt := tiffhandler.GetPagesCount;
          reload := True;
          if cnt = 0 then
          begin
            img.Clear;
            img.IO.Params.ImageIndex := i;
            MStream.Position := 0;
            img.IO.LoadFromStream(MStream);
            cnt := img.IO.Params.ImageCount;
            reload := False;
          end;
          for i := 0 to cnt - 1 do
          begin
            if reload then
            begin
              img.Clear;
              img.IO.Params.ImageIndex := i;
              MStream.Position := 0;
              img.IO.LoadFromStream(MStream);
              reload := True;
            end;

            try
              if Rotate then
              begin
                if (img.IEBitmap.Height < img.IEBitmap.Width) then
                begin
                  if Prn.Orientation <> poLandscape then
                    img.Proc.Rotate(90);
                end
                else
                begin
                  if Prn.Orientation <> poPortrait then
                    img.Proc.Rotate(-90);
                end;
              end;
            except
              //26.10.2018 Ticket 16548
            end;

            img.IO.PrintImage(Prn.Canvas, MLeft, MTop, MRight, MBottom, VPos, HPos, Size, SWidth, SHeight, Gamma);

            if i < img.IO.Params.ImageCount - 1 then
              Prn.NewPage;
          end;
        finally
          FreeAndNil(img);
          FreeAndNil(tiffhandler);
        end;
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'Print', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'Print', ClassName);
  end;
end;

procedure TbfaApplication.PrivateAnno(AThread: TThread; prev: TbfaPreview; Layer: Int64);
begin
  bitfarmLog.DebugBegin(llDebug, 'PrivateAnno', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          prev.askforsave_annos2(AThread);

          if prev.bfaTlbPreview.mnuPrivateAnno.Checked then
          begin
            prev.bfaTlbPreview.mnuPublicAnno.Checked := not prev.bfaTlbPreview.mnuPrivateAnno.Checked;
            prev.SingleView.fAnnoType := 1;
          end
          else if prev.bfaTlbPreview.mnuPublicAnno.Checked then
            prev.SingleView.fAnnoType := 0;
          prev.SetCurrentLayer(Layer);
          prev.SetAnnoToolBar(prev.bfaTlbPreview.mnuPrivateAnno.Checked or prev.bfaTlbPreview.mnuPublicAnno.Checked);
          prev.RefreshPage;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'PrivateAnno', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'PrivateAnno', ClassName);
  end;
end;

procedure TbfaApplication.PublicAnno(AThread: TThread; prev: TbfaPreview);
begin
  bitfarmLog.DebugBegin(llDebug, 'PublicAnno', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          prev.askforsave_annos2(AThread);

          if prev.bfaTlbPreview.mnuPublicAnno.Checked then
          begin
            prev.bfaTlbPreview.mnuPrivateAnno.Checked := not prev.bfaTlbPreview.mnuPublicAnno.Checked;
            prev.SingleView.fAnnoType := 0;
          end
          else if prev.bfaTlbPreview.mnuPrivateAnno.Checked then
            prev.SingleView.fAnnoType := 1;

          prev.SetCurrentLayer(0);
          prev.SetAnnoToolBar(prev.bfaTlbPreview.mnuPublicAnno.Checked or prev.bfaTlbPreview.mnuPrivateAnno.Checked);
          prev.RefreshPage;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'PublicAnno', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'PublicAnno', ClassName);
  end;
end;

procedure TbfaApplication.Quit(AThread: TThread);
begin
  BfShowMessage('Quit', AThread);
end;

procedure TbfaApplication.DoRefreshCWLabel(fraRes : TfraResub; day: TDate);
begin
  try
    fraRes.lblCW.Caption := _('KW:') + ' ' + IntToStr(currentCW) + '   ' +
      DateToStr(dateCWFirstDay) + '-' + DateToStr(dateCWLastDay);
    fraRes.cxDateNavigator1.Date := day;
  except

  end;
end;

procedure TbfaApplication.RefreshCWLabel(AThread: TThread; day: TDate);
begin
  if AThread <> nil then
  begin
    AThread.Synchronize(nil,
      procedure
      begin
        if frmMainForm.IsFloatingResubShowing then
          DoRefreshCWLabel(frmMainForm.fraFloatingResub.fraResub, day)
        else
          DoRefreshCWLabel(frmMainForm.fraResub, day);
      end);
  end
  else
  begin
    if frmMainForm.IsFloatingResubShowing then
      DoRefreshCWLabel(frmMainForm.fraFloatingResub.fraResub, day)
    else
      DoRefreshCWLabel(frmMainForm.fraResub, day);
  end;
end;

procedure TbfaApplication.RefreshDoc(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'RefreshDoc', ClassName);
  try
    try
      DoCancelRequest(FCurrentContainer[0], AThread);
      AThread.Synchronize(nil,
        procedure
        begin
          bitfarmApp.FillDocLinkList; //29.05.2018 Ticket 14571
          ShowDocumentProperties(FCurrentContainer[0], GetActivePreview);
//30.01.2019          RefreshGrid;
        end);
      RefreshGrid(AThread); //30.01.2019
      RefreshDocumentInPreviews(AThread, FCurrentContainer[0], GetActivePreview, nil);
    except
      bitfarmLog.Write(llNormal, ltException, 'RefreshDoc', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'RefreshDoc', ClassName);
  end;

end;

procedure TbfaApplication.RefreshGrid(AThread: TThread);
var
  lBM, top, focused, focuseditem, datafocused: integer;
  gdocid, newGDocID: Int64;
  found, MustDochange, found_gdocid: Boolean;
  dsc: TDataSource;
begin
  bitfarmLog.DebugBegin(llDebug, 'RefreshGrid', ClassName);
  RefreshGridInProcess := True;
  try
    try
      dsc := frmMainForm.grdResultlistDevExView.DataController.DataSource;
      if (dsc <> nil) and (dsc.DataSet <> nil) and
          (dsc.DataSet.RecordCount > 0) and (FCurrentContainer.Count > 0) then
      begin
        AThread.Synchronize(nil,
          procedure
          var
            i,j: Integer;
          begin
            gdocid := FCurrentContainer[0].ID;
            datafocused := frmMainForm.grdResultlistDevExView.DataController.FocusedRecordIndex;
            focused := frmMainForm.grdResultlistDevExView.Controller.FocusedRecordIndex;
            focuseditem := frmMainForm.grdResultlistDevExView.Controller.FocusedItemIndex;
            top := frmMainForm.grdResultlistDevExView.Controller.TopRecordIndex;
            try
              dsc.DataSet.Refresh;
            except
            end;
//20.12.2022 springt manchmal deswegen spter           dsc.DataSet.DisableControls;

            //20.07.2022 Fehler bei Lesezeichen mit Plugin bleibt das Grid Disabled, als Test eingebaut -->
            //frmMainForm.grdResultlistDevExView.Controller.TopRecordIndex := top;
            //frmMainForm.grdResultlistDevExView.DataController.FocusedRecordIndex := focused;
            try
              if dsc.DataSet.RecordCount > 0 then
              begin
                //07.02.2023 bfacrm:ticket__show__33688 if (top < dsc.DataSet.RecordCount) and (focused < dsc.DataSet.RecordCount) then
                if (frmMainForm.grdResultlistDevExView.OptionsView.GroupByBox and (top < frmMainForm.grdResultlistDevExView.DataController.RowCount) and
                      (focused < frmMainForm.grdResultlistDevExView.DataController.RowCount))
                   or
                   (not frmMainForm.grdResultlistDevExView.OptionsView.GroupByBox and
                   //13.03.2023 bfacrm:ticket__show__34090   (top < dsc.DataSet.RecordCount) and (focused < dsc.DataSet.RecordCount))
                     (top < dsc.DataSet.RecordCount) and (focused <= dsc.DataSet.RecordCount))
                then
                begin
                  frmMainForm.grdResultlistDevExView.Controller.TopRecordIndex := top;
                  //13.03.2023 bfacrm:ticket__show__34090 -->
                  if (dsc.DataSet.RecordCount > 1) and (focused = dsc.DataSet.RecordCount) then
                    focused := focused - 1;
                  //13.03.2023 bfacrm:ticket__show__34090 <--
                  frmMainForm.grdResultlistDevExView.Controller.FocusedRecordIndex := focused;
                  frmMainForm.grdResultlistDevExView.Controller.FocusedItemIndex := focuseditem;
                  //13.03.2023 bfacrm:ticket__show__34090 -->
                  try
                    newGDocID := frmMainForm.grdResultlistDevExView.DataController.GetValue(
                      frmMainForm.grdResultlistDevExView.ActRec,
                      frmMainForm.grdResultlistDevExView.DataController.GetItemByFieldName('gdocid').Index);
                  except
                    newGDocID := -1;
                  end;
//                  if gdocid <> frmMainForm.grdResultlistDevExView.DataController.GetValue(
//                      frmMainForm.grdResultlistDevExView.ActRec,
//                      frmMainForm.grdResultlistDevExView.DataController.GetItemByFieldName('gdocid').Index) then
                  if gdocid <> newGDocID then
                  //13.03.2023 bfacrm:ticket__show__34090 -->
                  begin
                    lBM := -1;
                    found_gdocid := False;
                    for i := FCurrentContainer.Count - 1 downto 0 do
                    begin
                      lBM := -1;
                      found := False;
                      j:= 0;
                      while ((not found) and (j <= frmMainForm.grdResultlistDevExView.DataController.RecordCount - 1)) do
                      begin
                        if FCurrentContainer[i].ID = frmMainForm.grdResultlistDevExView.DataController.GetValue(j,
                            frmMainForm.grdResultlistDevExView.DataController.GetItemByFieldName('gdocid').Index) then
                        begin
                          found := True;
                          if not found_gdocid then  // nur beim ersten aufruf muss Clearselection laufen
                          begin
                            found_gdocid := True;
                            frmMainForm.grdResultlistDevExView.Controller.ClearSelection;
                          end;
                          lBM := j;
                        end
                        else
                          inc(j);
                      end;
                      if (found) and (lBM > -1) then
                      begin
                        if i = 0 then
                        begin
                          frmMainForm.grdResultlistDevExView.DataController.DataSet.Locate('gdocid', FCurrentContainer[i].ID, []);
                          frmMainForm.grdResultlistDevExView.DataController.ChangeRowSelection(
                            frmMainForm.grdResultlistDevExView.DataController.GetRowIndexByRecordIndex(lBM,True), True);

                          frmMainForm.grdResultlistDevExView.SetBookmark;
                        end
                        else
                          frmMainForm.grdResultlistDevExView.DataController.ChangeRowSelection(
                            frmMainForm.grdResultlistDevExView.DataController.GetRowIndexByRecordIndex(lBM,True), True);
                      end;
                    end;

                    if not found_gdocid then  // wenn nichts gefunden, dann aktuelles auswhlen
                    begin
                      frmMainForm.grdResultlistDevExView.Controller.ClearSelection;
                      frmMainForm.grdResultlistDevExView.Controller.FocusedRecord.Selected := True;
                      frmMainForm.grdResultlistDevExView.SetBookmark;
                    end;
                    MustDochange := True;
                  end
                  else
                    frmMainForm.grdResultlistDevExView.DataController.FocusedRecordIndex := datafocused;

                  frmMainForm.grdResultlistDevExView.Controller.MakeFocusedRecordVisible;
                end
                else
                begin
                  frmMainForm.grdResultlistDevExView.Controller.ClearSelection;
                  frmMainForm.grdResultlistDevExView.Controller.TopRecordIndex := 0;
                  frmMainForm.grdResultlistDevExView.DataController.FocusedRecordIndex := 0;
                  frmMainForm.grdResultlistDevExView.Controller.FocusedRecord.Selected := True;
                  frmMainForm.grdResultlistDevExView.SetBookmark;
                end;
              end;
              dsc.DataSet.DisableControls; //20.12.2022
            except
              bitfarmLog.Write(llNormal, ltException, 'RefreshGrid - Set top and focused', ClassName);
            end;
            //20.07.2022 Fehler bei Lesezeichen mit Plugin bleibt das Grid Disabled, als Test eingebaut <--
          end);
        if not MustDoChange then
        begin
          try
            MustDoChange := (frmMainForm.grdResultlistDevExView.Controller.SelectedRowCount = 0) or
              (frmMainForm.grdResultlistDevExView.DataController.RecordCount = 0) or
              ((frmMainForm.grdResultlistDevExView.Controller.SelectedRowCount > 0) and
                (gdocid <> frmMainForm.grdResultlistDevExView.DataController.GetValue(
                  frmMainForm.grdResultlistDevExView.ActRec,
                        frmMainForm.grdResultlistDevExView.DataController.GetItemByFieldName('gdocid').Index)));
          except
            MustDoChange := True;
          end;
        end;

        if MustDoChange then
          frmMainForm.DoResultlistChange(AThread);

        AThread.Synchronize(nil,
          procedure
          begin
            dsc.DataSet.EnableControls;
          end);
      end;
      AThread.Synchronize(nil,
        procedure
        begin
          frmMainForm.grdResultlistDevExView.Invalidate;
        end);

    except
      bitfarmLog.Write(llNormal, ltException, 'RefreshGrid', ClassName);
      //20.07.2022 Fehler bei Lesezeichen mit Plugin bleibt das Grid Disabled, als Test eingebaut -->
      AThread.Synchronize(nil,
        procedure
        begin
          dsc.DataSet.EnableControls;
          frmMainForm.grdResultlistDevExView.Invalidate;
        end);
      //20.07.2022 Fehler bei Lesezeichen mit Plugin bleibt das Grid Disabled, als Test eingebaut <--
    end;
  finally
    RefreshGridInProcess := False;
    bitfarmLog.DebugEnd(llDebug, 'RefreshGrid', ClassName);
  end;
end;

procedure TbfaApplication.LoadArrays;
var
  i: Integer;
  arcids: TStringList;
begin
  bitfarmLog.DebugBegin(llDebug, 'LoadArrays', ClassName);
  try
    try
      SetLength(aSysArc, 0);
      SetLength(aAddfields, 0);
      SetLength(aAddfieldRights, 0);
      SetLength(aStateFieldRights, 0);
      SetLength(aStatefields, 0);
      SetLength(aColSortings, 0);
      aCurrentAddfields.Clear;
      aCurrentViewerAddfields.Clear;
      aCurrentImporterAddfields.Clear;
      aCurrentResubAddfields.Clear;
      aCurrentStatefields.Clear;
      aCurrentViewerStatefields.Clear;
      aCurrentImporterStatefields.Clear;
      aCurrentResubStatefields.Clear;
      ReadRightsArcids.Clear;

      for i := Low(aStationeries) to High(aStationeries) do
      begin
        aStationeries[i].Stream.Clear;
        aStationeries[i].Arcids.Clear;
      end;
      SetLength(aStationeries, 0);

      arcids := TStringList.Create;

      ReadSysArc;
      ReadAddfields;
      ReadStatefields;
      ReadSortings;
      ReadResubFavs;
      ReadResubUserGroups(frmMainForm.fraResub);
      if (frmMainForm.fraFloatingResub <> nil) and (frmMainForm.fraFloatingResub.fraResub <> nil) then
        ReadResubUserGroups(frmMainForm.fraFloatingResub.fraResub);

      for i := Low(aSysArc) to High(aSysArc) do
        arcids.Add(IntToStr(aSysArc[i].Arcid));

      ReadAddfieldRights(arcids);

      ReadHotSearchOptions;

      ReadImportValues; //19.02.2019 Ticket 180170
    except
      bitfarmLog.Write(llNormal, ltException, 'LoadArrays', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'LoadArrays', ClassName);
    FreeAndNil(arcids);
  end;
end;

procedure TbfaApplication.Relogin(AThread: TThread; Profile: string = '');
var
  hd: HWND;
  i, j : integer;
  obj : TList;
begin
  if not frmMainForm.fAppStarted then
    Exit;

  //29.04.2019 Ticket  18726 -->
  if ((FPreviewContainer <> nil) and (FPreviewContainer.Containers.Count > 0)) then
  begin
    for i := FPreviewContainer.Containers.Count - 1 downto 0 do
    begin
      if (FPreviewContainer.Containers[i].Preview <> nil) and (FPreviewContainer.Containers[i].Preview.List <> nil) then
      begin
        for j := 0 to FPreviewContainer.Containers[i].Preview.List.Count - 1 do
        begin
          if FPreviewContainer.Containers[i].Preview.List[j].ID <> - 1 then
          begin
            if ((bitfarmApp.PreviewContainer.Containers[i] <> bitfarmApp.PreviewContainer.ImporterItem) and
                (bitfarmApp.PreviewContainer.Containers[i] <> bitfarmApp.PreviewContainer.ViewerItem) and
                (bitfarmApp.PreviewContainer.Containers[i] <> bitfarmApp.PreviewContainer.ResubItem) and
                (bitfarmApp.PreviewContainer.Containers[i] <> bitfarmApp.PreviewContainer.WorkplaceItem)) then
            begin
              if bitfarmApp.PreviewContainer.Containers[i].Panel <> bitfarmApp.PreviewContainer.PageSortingsItem.Panel then
              begin
                obj := TList.Create;
                try
                  if bitfarmApp.PreviewContainer.Containers[i].Panel.Parent.Name <> 'dckFloating' then
                  begin
    //                bitfarmApp.PreviewContainer.PanelCloseQuery(bitfarmApp.PreviewContainer.Containers[i].Panel, CanClose)
                    obj.Add(bitfarmApp.PreviewContainer.Containers[i].Panel);
                    bitfarmApp.PanelClose(AThread, obj);
                  end
                  else
                  begin
  //                  bitfarmApp.PreviewContainer.PanelCloseQuery(bitfarmApp.PreviewContainer.Containers[i].Panel.Parent.Parent, CanClose);
                    obj.Add(bitfarmApp.PreviewContainer.Containers[i].Panel.Parent.Parent);
                    bitfarmApp.PanelClose(AThread, obj);
                  end;
                finally
                  FreeAndNil(obj);
                end;
              end;
            end;
          end;
        end;
      end;
    end;
  end;
   //29.04.2019 Ticket  18726 <--
  bitfarmLog.DebugBegin(llDebug, 'Relogin', ClassName);
  frmMainForm.FRelogin := True;
  frmMainForm.tmrHeartBeat.Enabled := False;
  frmMainForm.tmrQueueCount.Enabled := False;

  try
    try
      LeaveCurrentDocs(AThread);
      Reset(AThread);
      DeleteAddfields(AThread);
      DeleteStatefields(AThread);
      frmMainForm.SaveViewerIniAndTreeViews; // bfacrm:ticket__show__31539
      AThread.Synchronize(nil,
        procedure
        begin
          if (Profile <> '') then
            {$IFNDEF ENTERPRISE}
//            TfrmLoginGPL(frmMainForm.frmLogin).ChangeProfile(Profile)
            {$ELSE}
            TfrmLoginEnterprise(frmMainForm.frmLogin).ChangeProfile(Profile)
            {$ENDIF}
          else
            frmMainForm.frmLogin.ShowModal;

//12.02.2019 Wenn kein 'Verbindung mehr vorhanden sind dann auf Exit muss die anwendung geschlossen sein -->
          if frmMainForm.frmLogin.ModalResult = mrCancel then
          begin
            if (not bitfarmApp.MainSocket.Connected) or (not dmMain.cntMain.Connected) then
            begin
              TerminateProcess(GetCurrentProcess, 0);
              Exit;
            end;
          end;
//12.02.2019 Wenn kein 'Verbindung mehr vorhanden sind dann auf Exit muss die anwendung geschlossen sein <--


          if frmMainForm.frmLogin.ModalResult = mrOk then
          begin
            if ((bitfarmApp.User.Flags and 32) = 32) then
              bitfarmApp.ChangePassword(nil);

            frmMainForm.frmSplash.lblLoading.Caption := _('Neu anmelden...');
            frmMainForm.frmSplash.Update;
            frmMainForm.frmSplash.Show;

            bitfarmApp.FNewResubs := 0; // Muss zurckgesetzt werden Ticket 10124
            frmMainForm.pnlResubmission.Caption := sCaptionResubmission + ' (' + IntToStr(TimidList.Count) + ')';

            if not OfflineMode then
              bitfarmApp.SaveHistoryBookmark;

            frmMainForm.frmSplash.Update;

            if (Profile = '') then // Beim Profilwechsel (Profile <> '') keine Dokumente speichern
            begin
              bitfarmApp.SaveDocumentsToXML(bitfarmApp.ImportContainer, BD.EnvAppdataImporterPd);
              bitfarmApp.SaveDocumentsToXML(bitfarmApp.WorkplaceContainer, BD.EnvAppdataWorkplacePd); //03.01.2019 beim Ticket 17347 Workplace sollte dann auch gespeichert werden
            end;

            bitfarmApp.WriteSortings;

            frmMainForm.frmSplash.Update;

            if bitfarmApp.ViewerOptions.SaveOptions then
              bitfarmApp.ViewerOptions.Save
            else
            begin
              bitfarmApp.ViewerOptions.SaveGUIOptions;
              bitfarmApp.ViewerOptions.SaveSystemOptions(True);
              bitfarmApp.ViewerOptions.SaveResubOptions(True);
            end;

            if Assigned(frmMainForm) and Assigned(frmMainForm.trvBookmarks) then
              frmMainForm.trvBookmarks.Visible := False;

            frmMainForm.trvBookmarks.Items.Clear;
            FHistoryListNode := nil;
            FLocalListNode := nil;
            FGlobalListNode := nil;

            frmMainForm.frmSplash.Update;

            frmMainForm.FViewerTreeview.Items.Clear;
            frmMainForm.FViewerTreeview.LastSelected := -1;
            frmMainForm.FImporterTreeview.Items.Clear;
            frmMainForm.FImporterTreeview.LastSelected := -1;

            bitfarmApp.CurrentFields := -1;
            bitfarmApp.CurrentViewerFields := -1;
            bitfarmApp.CurrentImporterFields := -1;
            bitfarmApp.CurrentResubFields := -1;
            bitfarmApp.CurrentArchive.Arcid := -1;
            bitfarmApp.CurrentViewerArchive.Arcid := -1;
            bitfarmApp.CurrentImportArchive.Arcid := -1;
            bitfarmApp.CurrentResubArchive.Arcid := -1;

            SetInisProfile;
            frmMainForm.ReadViewerIni; //12.04.2022 mssen die Profileabhngige Infos auch neu gelesen werden
            LoadArrays;
            ReadUserList;
            ReadEmailUser;

            frmMainForm.frmSplash.Update;
            frmMainForm.SetStatusBar;

            //frmMainForm.SetCheckedMenuProfile;

            frmMainForm.SetAdminGUI;
            CheckHoliday;
            DoRefreshMarkedDocs;
          end;
        end);

      if frmMainForm.frmLogin.ModalResult = mrOk then
      begin
        //23.09.2024 SD -->bfacrm:ticket__show__33611
        {$IFDEF ENTERPRISE}
        if bitfarmApp.ExportMode then
        begin
          AThread.Synchronize(nil,
          procedure
          begin
            TfrmEnterprise(frmMainForm).mnuCreateExportDB.Enabled := True;
            TfrmEnterprise(frmMainForm).actDoExport.Enabled := False;
            TfrmEnterprise(frmMainForm).actDoExport.Visible := False;
            TfrmEnterprise(frmMainForm).actStartExport.ImageIndex := Integer(icoidx_database_start);
            TfrmEnterprise(frmMainForm).Caption := sCaptionMainFormEnterprise;
            TfrmEnterprise(frmMainForm).mnuStartExport.Caption := _('Export starten');
            if (TbfaApplicationEnterprise(Self).FOffline <> nil) and TbfaApplicationEnterprise(Self).FOffline.DBStarted then
            begin
              TbfaApplicationEnterprise(Self).FOffline.StopDB;
            end;
            TfrmEnterprise(frmMainForm).FViewerTreeview.Items.Clear;
            TfrmEnterprise(frmMainForm).FViewerTreeview.RightsUserid := '';
            TfrmEnterprise(frmMainForm).FViewerTreeview.RightsGrouplist := '';
            TfrmEnterprise(frmMainForm).FViewerTreeview.Right := (rightList or rightImport);
            ExportMode := False;
          end);
        end;
        {$ENDIF}
        //23.09.2024 SD <--bfacrm:ticket__show__33611

        SetActiveView(AThread, pvtViewer);
        LoadBookmarks(AThread);

        AThread.Synchronize(nil,
          procedure
          begin
            frmMainForm.trvBookmarks.Visible := True;
            frmMainForm.FImporterTreeview.Load(True);
            frmMainForm.FViewerTreeview.Load(True);
            frmMainForm.pnlTreeView.Maximize;
            frmMainForm.actReset.Execute;
          end);

        hd := FindWindow('bitfarm.hotsearch.V36', nil);
        bitfarmLog.Write(llNormal, ltInfo, 'mnu_ReLoginClick vor Message WM_HOTKEY_RECONNECT', ClassName);
        PostMessage(hd, WM_HOTKEY_RECONNECT, 1, 1);
        bitfarmLog.Write(llNormal, ltInfo, 'mnu_ReLoginClick nach Message WM_HOTKEY_RECONNECT', ClassName);
        {$IFDEF ENTERPRISE}
        //if bitfarmApp.OfflineMode then
        //begin
          //TfrmEnterprise(frmMainForm).Caption := TfrmEnterprise(frmMainForm).Caption + '    ' + _('(Offline-Modus)');
          //TfrmEnterprise(frmMainForm).actStartExport.Enabled := False;
          //TfrmEnterprise(frmMainForm).actCreateExportDB.Enabled := False;
          //TfrmEnterprise(frmMainForm).actDoExport.Enabled := False;
        //end;
        {$ENDIF}
      end;

      for i := 0 to ImportContainer.Count - 1 do
      begin
        if (TbfaDocument(ImportContainer[i]).ID = -1) and TbfaDocument(ImportContainer[i]).InEditMode then
          TbfaDocument(ImportContainer[i]).EditmodeUserID := bitfarmApp.User.ID;
      end;
      for i := 0 to WorkplaceContainer.Count - 1 do
      begin
        if (TbfaDocument(WorkplaceContainer[i]).ID = -1) and TbfaDocument(WorkplaceContainer[i]).InEditMode then
          TbfaDocument(WorkplaceContainer[i]).EditmodeUserID := bitfarmApp.User.ID;
      end;
      // SJ 28.10.2020

      AThread.Synchronize(nil,
        procedure
        begin
          frmMainForm.frmSplash.Hide;
        end);

    except
      bitfarmLog.Write(llNormal, ltException, 'Relogin', ClassName);
    end;
  finally
    frmMainForm.FReLogin := True;

    frmMainForm.tmrQueueCount.Enabled := not bitfarmApp.OfflineMode;
    frmMainForm.tmrHeartBeat.Enabled := bitfarmApp.Autoreconnect and not frmMainForm.tmrQueueCount.Enabled;  //nur noch aktivieren, wenn es keinen QueueCount gibt

    bitfarmLog.DebugEnd(llDebug, 'Relogin', ClassName);
  end;
end;

procedure TbfaApplication.ReloginMySQLError(AThread: TThread);
begin
  BfShowMessage(_('Es hat einen Fehler bei der Datenbankverbindung gegeben.\nBitte melden Sie sich erneut an.'), AThread);
  Relogin(AThread);
  frmMainForm.FShowMySQLError := False;
end;

procedure TbfaApplication.RemoveBorder(Data: PUserAction; AThread: TThread);
var
  prev: TbfaPreview;
begin
  bitfarmLog.DebugBegin(llDebug, 'RemoveBorder', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          prev := PUserAction(Data).Preview;
          with PUserAction(Data).Preview.ActiveDoc do
          begin
            StartSaveProcess;
            try
              DoImageCorrection(prev, PUserAction(Data).Preview.ActiveDoc, 3);
            finally
              Modified_Preview := True;
              EndSaveProcess;
            end;
          end;
        end);

      RefreshDocumentInPreviews(AThread,
        PUserAction(Data).Preview.ActiveDoc, prev, nil);
    except
      bitfarmLog.Write(llNormal, ltException, 'RemoveBorder', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'RemoveBorder', ClassName);
  end;
end;

procedure TbfaApplication.RemoveLink(AThread: TThread; SrcDoc: TList<TbfaDocument>; RefName: string);
var
  i: Integer;
  req: TbfaRequest;
  docids: string;
  UserAction: PUserAction;
begin
  req := TbfaRequest.Create;
  try
    for i := 0 to SrcDoc.Count - 1 do
    begin
      if docids <> '' then
        docids := docids + ',' + IntToStr(SrcDoc[i].Id)
      else
        docids := IntToStr(SrcDoc[i].Id);
    end;

    req.ReqType := 'reqRemoveLink';
    req.UserID := user.ID;
    req.Profile := Self.Profile;
    req.Parameter := RefName + ';' + docids;
    req.Lang := Lang;
    MainSocket.SendRequestToServer(req);

    req := MainSocket.ReceiveResponse(AThread);
    if req = nil then
      Exit;

    if req.ReqType = 'respAuthError' then
    begin
      BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
      UserAction := CreateUserAction;
      UserAction^.ActionName := 'actRelogin';
      MainThread.Add(UserAction);
      Exit;
    end
    else if req.ReqType = 'respError' then
    begin
      AThread.Synchronize(nil,
        procedure
        begin
          BfShowMessage(_('Das Dokument konnte nicht aus der Verknpfung entfernt werden'));
        end);
    end
    else
    begin
      bfaProcessing.ReloadLinks(FCurrentContainer[0]);
      FillDocLinkList;
      SetDocState(FCurrentContainer[0]);
    end;
  finally
    FreeAndNil(req);
  end;
end;

procedure TbfaApplication.ReloadDocLinks(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'ReloadDocLinks', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          if FCurrentContainer.Count > 0 then
          begin
            bfaProcessing.ReloadLinks(FCurrentContainer[0]);
            FillDocLinkList;
          end;
        end);
    except
      on e: exception do
        bitfarmLog.Write(llNormal, ltException, 'ReloadDocLinks' + e.Message, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ReloadDocLinks', ClassName);
  end;
end;

procedure TbfaApplication.ReOCR(AThread: TThread; Data: PUserAction);
var
  SendSocket: TSocketConnection;
  req: TbfaRequest;
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'ReOCR', ClassName);
  try
    try
      req := TbfaRequest.Create;
      try
        req.ReqType := 'reqReOCR';
        req.UserID := user.ID;
        req.Profile := Self.Profile;
        req.Gdocid := 0;
        Data^.params.Delimiter := ';';
        Data^.params.StrictDelimiter := True;
        req.Parameter := Data^.params.DelimitedText;
        req.Lang := Lang;

        SendSocket := TSocketConnection.Create(bfaServerNoSSL, bfaServer, bfaServerPort, '');
        SendSocket.CreateComponents;
        if SendSocket.Connect then
        begin
          SendSocket.SendRequestToServer(req);
          req := SendSocket.ReceiveResponse(AThread);
          if req = nil then
            Exit;

          if req.ReqType = 'respAuthError' then
          begin
            BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
            UserAction := CreateUserAction;
            UserAction^.ActionName := 'actRelogin';
            MainThread.Add(UserAction);
            Exit;
          end
          else if req.ReqType = 'respError' then
            BfShowMessage(_('Fehler beim Dokument aktualisieren') + #13#10 + req.DataString, AThread);
        end
        else
          bitfarmLog.Write(llDebug, ltInfo, 'Es konnte keine Socketverbindung aufgebaut werden (ReOCR)');
      finally
        FreeAndNil(req);
        SendSocket.DisConnect;
        FreeAndNil(SendSocket);
      end;
    except
      on e: exception do
        bitfarmLog.Write(llNormal, ltException, 'ReOCR' + e.Message, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ReOCR', ClassName);
  end;
end;

procedure TbfaApplication.ReplaceBookmark(AThread: TThread; Objects: TList);
var
  SelNode: TTreeNode;
  BookmarkName: string;
  TmpObj: TbfaSearch;
begin
  bitfarmLog.DebugBegin(llDebug, 'ReplaceBookmark', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          SelNode := TTreeNode(Objects[0]);

          if FSearchObj.ID = -1 then
          begin
            BfShowMessage(_('Es wurde keine Suche ausgefhrt.'));
            Exit;
          end;

          if BfMessageDlg(Format(_('Mchten Sie das Lesezeichen %s mit der aktuellen Suche berschreiben?'), [SelNode.Text]), mtConfirmation, [mbYes, mbNo], True, _('Lesezeichen berschreiben')) = mrYes then
          begin
            TmpObj := TbfaSearch.Create;
            TmpObj.Clone(FSearchObj);
            TmpObj.Name := SelNode.Text;
            if Assigned(frmMainForm.grbxSqlWhere) then
            begin
              if frmMainForm.chkSQLWhereOr.Checked then
                TmpObj.SQLWhereOperator := 'or';
              TmpObj.Constructive := frmMainForm.chkSQLWhereConstructive.Checked;
            end;

            SelNode.Data := TmpObj;

            SaveBookmarkNode(SelNode);
          end;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'ReplaceBookmark', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ReplaceBookmark', ClassName);
  end;
end;

procedure TbfaApplication.Reset(AThread: TThread; btnResetClick: Boolean = False);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'Reset', ClassName);
  try
    try
      if FSearchProc.Fqry <> nil then
        FSearchProc.Fqry.BreakExec;
    except
      on E: Exception do
        bitfarmLog.Write(llNormal, ltException, 'Reset Fqry.BreakExec: ' + E.Message, ClassName);
    end;

    try
      ShowAllSymLinks := False;
      FSearchInResub := False;
      FSearchInResubNegated := False;

      UserAction := CreateUserAction;
      UserAction^.Params.Delimiter := ';';
      UserAction^.Params.StrictDelimiter := True;
      UserAction^.Params.DelimitedText := 'btnResetClick';
      if not DoSave(AThread, UserAction) then
        Exit;
      // Dispose(UserAction).Actionname <> 'actCallDoSave' findet in DoSave statt

      AThread.Synchronize(nil,
        procedure
        begin
          frmMainForm.actHideSearchDetails.Enabled := False;

          if frmMainForm.grdResultlistDevExView.DataController.DataSource <> nil then
            if frmMainForm.grdResultlistDevExView.DataController.DataSource.DataSet <> nil then
              frmMainForm.grdResultlistDevExView.DataController.DataSource := nil;

          frmMainForm.grdResultlistDevExView.DataController.Filter.Clear;

          ResetButtons(False);

          if Assigned(frmMainForm.fraDocLinks) then
            frmMainForm.fraDocLinks.lvwDocLink.Clear;

          frmMainForm.Update; //21.03.2023 bfacrm:ticket__show__34443
        end);
      FSearchObj.Reset;
      ResetViewer(AThread);

//27.07.2021 Ticket 26902 -->
//      ClearFields(AThread);
//
//      if btnResetClick then    // haben wir aktiv Reset geklickt? dann mssen wir die Felder Reset (vorallem wegen den Auswahlfeldern
//        ResetFields(AThread);
//27.09.2021 Ticket 28359 ClearFields(AThread);

      if not ViewerOptions.SearchOptions.ShowAllAddfields then
      begin
        ClearFields(AThread); //27.09.2021

        if btnResetClick then    // haben wir aktiv Reset geklickt? dann mssen wir die Felder Reset (vorallem wegen den Auswahlfeldern
          ResetFields(AThread, False, True);  //20.03.2023 im Clearfield gibt es auch einen Reset also hier 2mal hintereinander luft  bfacrm:ticket__show__34443
      end else if ViewerOptions.SearchOptions.ShowAllAddfields and btnResetClick then
      begin  //Sollte bei SetActiveView nur einmal laufen, deswegen nur beim btnResetClick die Zusatzfelder lschen
        DeleteAddfields(AThread);
        DeleteStatefields(AThread);
        var arcids: TStringList;
        var arcid: Int64;
        var store: boolean;
        arcids := TStringList.Create;
        try
          store := False;
          if CurrentView in [tvkViewer, tvkFavorites] then
          begin
            arcid := CurrentViewerArchive.Arcid;
            store := (CurrentViewerArchive.Typ = 0);
          end
          else if CurrentView = tvkResub then
          begin
            arcid := CurrentResubArchive.Arcid;
            store := (CurrentResubArchive.Typ = 0);
          end;

          if arcid > -1 then  ///TO-DO: Beim Favoriten sollten wir keinen ViewerAddfields darstellen, oder???
          begin
            if store and ShowAllReposAddfields then
              arcids := GetArcids(arcid, User.ID)
            else
              arcids.Add(inttostr(arcid));

            CreateAddfields(arcids, AThread);
            CreateStatefields(arcids, AThread);
            ClearFields(AThread);  //27.09.2021 Ticket 28359
          end;
        finally
          FreeAndNil(arcids);
        end;
      end;
//27.07.2021 Ticket 26902 <--
      ResetStandardSearch(AThread);

      AThread.Synchronize(AThread,
        procedure
        begin
          if CurrentArchive.Arcid <> -1 then
          begin
            frmMainForm.actSearch.Enabled :=
              (((CurrentArchive.Typ = 0) and (aSysArc[CurrentArchive.Arcid].Rights = 0))
              or
              ((aSysArc[CurrentArchive.Arcid].Rights and rightList) > 0) or
                (bitfarmApp.CurrentView = tvkResub)
              or
              ((FSearchObj <> nil) and (FSearchObj.Constructive)));

            //17.09.2021 Ticket 28196 -->
            if ((bitfarmApp.CurrentView = tvkFavorites) and (frmMainForm.grdResultlistDevExView.ColumnCount = 0)) then
              frmMainForm.actSearch.Enabled := False;
            //17.09.2021 Ticket 28196 <--

            // SJ 12.10.2021 - bfacrm:ticket__show__28694 - verschoben in ResetViewer
//            frmMainForm.SetStatusBarID(CurrentArchive.Arcid, 0);
          end;
          frmMainForm.ResetNotificationBar(nil); // SJ 14.08.2019
          if Assigned(frmMainForm.fraDocLinks) then
          begin
            frmMainForm.fraDocLinks.btnNewLink.Enabled := False;
            frmMainForm.fraDocLinks.btnAddAutoReference.Enabled := False;
          end;

          if btnResetClick then
          begin
//            frmMainForm.actBack.Enabled := True; // SJ 12.06.2023
//            frmMainForm.actForward.Enabled := False; // SJ 12.06.2023
            frmMainForm.trvBookmarks.Selected := nil; // muss vor SetBlueArrows sein!
            SetBlueArrows; // SJ 12.06.2023
            SelectFirstHistoryNode := True;

            {$IFNDEF DISABLE_HISTORY_FUTURE_DELETE} // SJ 14.07.2023 - bfacrm:ticket__show__35313
              DeleteFutureHistoryNodes := nil;
            {$ENDIF}
          end;
          FPreviewContainer.ViewerItem.Preview.SearchToolbarSetState; // SJ 06.01.2019
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'Reset', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'Reset', ClassName);
  end;
end;

procedure TbfaApplication.ResetImporter(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'ResetImporter', ClassName);
  try
    try
      ResetImporterFields(AThread);
    except
      bitfarmLog.Write(llNormal, ltException, 'ResetImporter', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ResetImporter', ClassName);
  end;
end;

procedure TbfaApplication.ResetViewer(AThread: TThread);
var
  prev: TbfaPreview;
begin
  bitfarmLog.DebugBegin(llDebug, 'ResetViewer', ClassName);
  try
    try
//20.09.2023
////24.01.2019 bei bfaThreadedThumbnail mit WaitFor gibt es deswegen manchmal deadlock, muss ausser Syncronize -->
//      if FPreviewContainer.ViewerItem.Preview.ActiveDoc <> nil then
//        FPreviewContainer.ViewerItem.Preview.KillThumbnailThread;
////24.01.2019 <--

      if (ActivePreview <> nil) and (ActivePreview.ThumbnailView <> nil) then
        ActivePreview.ThumbnailView.TabStop := False;

      AThread.Synchronize(nil,
        procedure
        var
          i: Integer;
          found: Boolean;
        begin
          //26.09.2017 wenn das letzte Dokument noch nicht zum DocHistory hinzugefgt ist, dann muss hinzufgen -->
          if ((bitfarmApp.CurrentView = tvkViewer) or (bitfarmApp.CurrentView = tvkResub)) then
          begin
            if (not bitfarmApp.DocHistoryFirstItem) and
               (not bitfarmApp.LastDocSearch) //14.05.2020 Ticket 21202
            then
            begin
              if (bitfarmApp.LastDocArc.GdocID <> 0) and (bitfarmApp.LastDocArc.ArcID <> 0) then
              begin
                if (Length(bitfarmApp.DocHistory) = 0) or ((DocHistoryIdx >= 1) and ((bitfarmApp.DocHistory[bitfarmApp.DocHistoryIdx - 1].gdocid <> bitfarmApp.LastDocArc.GdocID) or (bitfarmApp.DocHistory[bitfarmApp.DocHistoryIdx - 1].arcid <> bitfarmApp.LastDocArc.ArcID))) then
                begin
                  inc(bitfarmApp.DocHistoryIdx);
                  SetLength(bitfarmApp.DocHistory, bitfarmApp.DocHistoryIdx);
                  bitfarmApp.DocHistory[bitfarmApp.DocHistoryIdx - 1] := bitfarmApp.LastDocArc;
                  bitfarmApp.LastDocArc.GdocID := 0;
                  bitfarmApp.LastDocArc.ArcID := 0;
                  bitfarmApp.DocHistoryFirstItem := True;
                end;
              end;
            end;
          end;
          //26.09.2017 wenn das letzte Dokument noch nicht zum DocHistory hinzugefgt ist, dann muss hinzufgen <--

          // SJ 08.02.2022 - bfacrm:ticket__show__29053
          if bitfarmApp.ppmCalloutBallon.IsVisible then
            bitfarmApp.ppmCalloutBallon.Close;

//24.01.2019 bei bfaThreadedThumbnail mit WaitFor gibt es deswegen manchmal deadlock, muss ausser Syncronize         if FPreviewContainer.ViewerItem.Preview.ActiveDoc <> nil then
//            FPreviewContainer.ViewerItem.Preview.KillThumbnailThread;
//20.09.2023 nochmal zuzrck
         if FPreviewContainer.ViewerItem.Preview.ActiveDoc <> nil then
            FPreviewContainer.ViewerItem.Preview.KillThumbnailThread;

          if ((FPreviewContainer.ViewerItem.Preview.ActiveDoc <> nil) and (not IsDocumentInOtherPreview(FPreviewContainer.ViewerItem.Preview, FPreviewContainer.ViewerItem.Preview.ActiveDoc))) then
          begin
            FCurrentContainer.Clear;

            try
              if FPreviewContainer.ViewerItem.Preview.ActiveDoc <> nil then
              begin
//12.07.2018 Ticket 14576               FPreviewContainer.ViewerItem.Preview.ActiveDoc.Free;
//24.09.2018                bitfarmApp.Garbagecontainer.Add(FPreviewContainer.ViewerItem.Preview.ActiveDoc);
//                if not bitfarmApp.GarbageTimer.Enabled then
//                  bitfarmApp.GarbageTimer.Enabled := True;
//17.01.2019                FPreviewContainer.ViewerItem.Preview.ActiveDoc.SetProcesses(False);
//17.01.2019                bitfarmApp.AddDocToGarbageContainer(FPreviewContainer.ViewerItem.Preview.ActiveDoc);
                FPreviewContainer.ViewerItem.Preview.ActiveDoc.Free;
              end;
            finally //06.03.2018 Eingebut wegen CrashLog
              FPreviewContainer.ViewerItem.Preview.ActiveDoc := nil;
            end;
            ShowDocumentProperties(nil, FPreviewContainer.ViewerItem.Preview);
            FPreviewContainer.ViewerItem.Preview.itmSymLink.Enabled := False;
//18.10.2019 -->
//          end;
//          FPreviewContainer.ViewerItem.Preview.ActiveDoc := nil;
//          FPreviewContainer.ViewerItem.Preview.ActivePage := -1;
//          { TODO : Hier muss noch prfen ob das Document Objekt schon nil setzen darf }
//          FPreviewContainer.ViewerItem.Preview.List.Clear;
//          FPreviewContainer.ViewerItem.Preview.SetActions; //(False);
          end
          else
          begin
            FPreviewContainer.ViewerItem.Preview.ActiveDoc := nil;
            FPreviewContainer.ViewerItem.Preview.SetActions; //(False);
          end;

          FPreviewContainer.ViewerItem.Preview.ActivePage := -1;
          FPreviewContainer.ViewerItem.Preview.List.Clear;
//18.10.2019 -->
          FPreviewContainer.ViewerItem.Preview.SingleView.img_DocView.CancelInteracts;
          FPreviewContainer.ViewerItem.Preview.SingleView.img_DocView.DeSelect;
          FPreviewContainer.ViewerItem.Preview.SingleView.img_DocView.UnSelAllObjects;
          FPreviewContainer.ViewerItem.Preview.SingleView.img_DocView.MouseInteractVt := [];
//          FPreviewContainer.ViewerItem.Preview.SingleView.img_DocView.MouseInteract := [miscroll];

          FPreviewContainer.ViewerItem.Preview.SingleView.img_DocView.Clear;
          FPreviewContainer.ViewerItem.Preview.SingleView.img_DocView.Blank;
          FPreviewContainer.ViewerItem.Preview.ThumbnailView.Clear;
          FPreviewContainer.ViewerItem.Preview.HistoryView.Clear;
          FPreviewContainer.ViewerItem.Preview.CommentaryView.Clear;
          FPreviewContainer.ViewerItem.Preview.FulltextView.Clear;
          FPreviewContainer.ViewerItem.Preview.SetCaptionsTranslated;

          // bfacrm:ticket__show__31306
          if FPreviewContainer.ViewerItem.Preview.btnCommentary.CaptionGlow <> gldNone then
            FPreviewContainer.ViewerItem.Preview.btnCommentary.CaptionGlow := gldNone;

          // Analoges Verhalten  zu V3.5: (Ticket 15700) siehe auch: nderung in procedure ShowDocument
          // Sobald Viewer Resettet wird, schalten wir die Briefpapierfunktion wieder aus
          prev := FPreviewContainer.ViewerItem.Preview;
          if prev.bfaTlbPreview.mnuStationery.Checked or prev.bfaTlbPreview.sbmStationery.Checked then
          begin
            prev.bfaTlbPreview.mnuStationery.Checked := False;
            prev.bfaTlbPreview.sbmStationery.Checked := False;
            prev.RemoveStationery(AThread);
          end;

//        bfacrm:ticket__show__28102
          if not prev.Floating then
          begin
//            frmMainForm.bfaTlbPreview1.bfaTlbPreviewLabelPageCount.Caption := '';
//            frmMainForm.bfaTlbPreview1.edtPageNumber.Text := '';
            prev.ShowPageNumber;
//            frmMainForm.bfaTlbPreview1.cbxZoom.Text := '100,00 %';
            frmMainForm.bfaTlbPreview1.cbxZoom.Text := ''; // HS mchte lieber leer wenn kein Dokument
          end;

          case FPreviewContainer.ViewerItem.Preview.ActiveView of
            avDocument:
              FPreviewContainer.ViewerItem.Preview.Paint;
            avHistory:
              FPreviewContainer.ViewerItem.Preview.HistoryView.Update;
            avFulltext:
              FPreviewContainer.ViewerItem.Preview.FulltextView.Update;
            avCommentary:
              FPreviewContainer.ViewerItem.Preview.CommentaryView.Update;
          end;

          case bitfarmApp.CurrentView of
            tvkViewer, tvkResub, tvkWorkplace:
            begin
              FPreviewContainer.ViewerItem.Preview.fIsSettingValue := True;
              FPreviewContainer.ViewerItem.Preview.SearchbarTextEdit.Clear;
              FPreviewContainer.ViewerItem.Preview.SearchbarTextEdit.Color := cColorWhite;
              FPreviewContainer.ViewerItem.Preview.fIsSettingValue := False;
            end;
          end;

          frmMainForm.SetMainFormFocus; // bfacrm:ticket__show__24708

          // SJ 12.10.2021 - bfacrm:ticket__show__28694
          frmMainForm.SetStatusBarID(CurrentArchive.Arcid, 0);

          frmMainForm.Update; //21.03.2023 bfacrm:ticket__show__34443
        end);
//05.11.2019 eigentlich kann raus weil im showdocproperties SetDocState gerufen wird      ResetDocState(AThread);
    except
      bitfarmLog.Write(llNormal, ltException, 'ResetViewer', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ResetViewer', ClassName);
  end;
end;

procedure TbfaApplication.SyncFulltextZoom(Sender: TObject);
var
  i, param1, param2: Integer;
begin
  try
    try
      bitfarmLog.DebugBegin(llDebug, 'SyncFulltextZoom', ClassName);

      for i := 0 to FPreviewContainer.Containers.Count - 1 do
      begin
        SendMessage(TbfaPreview(FPreviewContainer.Containers[i].Preview).
            FulltextView.mmoFulltext.Handle, EM_GETZOOM, WPARAM(@param1), LPARAM(@param2));

        if (FullTextZoom <> param1) and TbfaPreview(FPreviewContainer.Containers[i].Preview).FulltextView.mmoFulltext.Visible then
          SendMessage(TbfaPreview(FPreviewContainer.Containers[i].Preview).
            FulltextView.mmoFulltext.Handle, EM_SETZOOM, WPARAM(FullTextZoom), LPARAM(100));
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'SyncFulltextZoom - in sync', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SyncFulltextZoom', ClassName);
  end;
end;

// lscht den Inhalt der Zusatz und Statusfelder
//procedure TbfaApplication.ClearFields(AThread: TThread); // SJ 17.12.2019  bfacrm:ticket__show__18767
procedure TbfaApplication.ClearFields(AThread: TThread; btnResetClick: Boolean = False);
begin
  AThread.Synchronize(nil,
    procedure
    var
      i: Integer;
    begin
      bitfarmLog.Write(llNormal, ltDebug, 'ClearFields', ClassName);

      // dann nochmal leer setzen
      for i := 0 to aCurrentAddfields.Count - 1 do
      begin
        if aCurrentAddfields[i].Component <> nil then
        begin
          aCurrentAddfields[i].Component.ClearValue;
          aCurrentAddfields[i].Component.Reset;     // 11/2/2020 bfacrm:ticket__show__24573
          aCurrentAddfields[i].Component.OnValueSet := aCurrentAddfields[i].SetValue;
        end;
        aCurrentAddfields[i].modified := False;
        aCurrentAddfields[i].ModifiedSearch := False;
        aCurrentAddfields[i].value := '';
        aCurrentAddfields[i].OldValue := '';
      end;

      for i := 0 to aCurrentStatefields.Count - 1 do
      begin
        if aCurrentStatefields[i].Component <> nil then
        begin
          aCurrentStatefields[i].Component.ClearValue;
          aCurrentStatefields[i].Component.OnValueSet := aCurrentStatefields[i].SetValue;
       end;
        aCurrentStatefields[i].modified := False;
        aCurrentStatefields[i].ModifiedSearch := False;
        aCurrentStatefields[i].value := '';
        aCurrentStatefields[i].OldValue := '';
      end;
      frmMainForm.scrbxViewerAddfields.Update;
      frmMainForm.tlbStatefields.Update;
    end);

//  ResetFields(AThread); // SJ 17.12.2019  bfacrm:ticket__show__18767
//  ResetFields(AThread, btnResetClick);    // FS 23.07.2020 wird jetzt direkt ber actResetFields aufgerufen

end;

procedure TbfaApplication.ResetDLM(Data: PUserAction; AThread: TThread);
var
  req: TbfaRequest;
  i: Integer;
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'ResetDLM', ClassName);
  try
    try
      req := TbfaRequest.Create;

      if FCurrentContainer[0].InEditMode then
        DoSave(AThread);

      req.ReqType := 'reqResetDLM';
      req.UserID := user.ID;
      req.Profile := Self.Profile;
      req.Parameter := Data^.params.DelimitedText;
      req.Lang := Lang;
      MainSocket.SendRequestToServer(req);

      i := 0;

      while i < Data^.params.Count + 1 do    // wir knnen nicht mehr antworten vom server bekommen, als Dokumente die verarbeitet werden sollen
      begin                                 // plus eine abschlieendes respOK
        req := nil;
        req := MainSocket.ReceiveResponse;
        if req = nil then
          Exit;

//27.11.2018 Ticket 16957 -->
        if req.ReqType = 'respAuthError' then
        begin
          BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
          UserAction := CreateUserAction;
          UserAction^.ActionName := 'actRelogin';
          MainThread.Add(UserAction);
          Exit;
        end
        else
//27.11.2018 Ticket 16957 <--
        if (req = nil) or (req.ReqType = 'respResetDLMError') or (req.ReqType = 'respError') then
        begin
          BfShowMessage(_('Fehler beim Zurcksetzen der Standardlebensdauer.' + #13#10 + req.DataString), AThread);
          Exit;
        end
        else if req.ReqType = 'respPending' then
        begin
//          SetStatusInfo(Format(_('Lschdatum neu berechnen: Dokument %d/%d'), [i + 1, Data^.params.Count]), AThread, False);
          frmMainForm.SetNotificationBar(Format(_('Lschdatum neu berechnen: Dokument %d/%d'), [i + 1, Data^.params.Count]), AThread); // SJ 14.08.2019
        end
        else if req.ReqType = 'respOK' then
        begin
          Break;
        end;
        Inc(i);
      end;

//      <!-- SJ 05.09.2019 - nicht mehr ntig, weil Meldung nun in NotificationBar
//      if not FCurrentContainer[0].InEditMode then  // sollte nicht vorkommen, da wir vorher ein DoSave machen
//      begin
//        ReloadDocument(FCurrentContainer[0], False, AThread);
//        AThread.Synchronize(nil,
//          procedure
//          begin
//            ShowDocumentProperties(FCurrentContainer[0], nil);
//          end);
//      end;
    except
      on e: exception do
        bitfarmLog.Write(llNormal, ltException, 'ResetDLM' + e.Message, ClassName);
    end;
  finally
    FreeAndNil(req);
    bitfarmLog.DebugEnd(llDebug, 'ResetDLM', ClassName);
  end;
end;

procedure TbfaApplication.ResetDocState(AThread: TThread);
begin
  AThread.Synchronize(nil,
    procedure
    begin
      SetDocState(nil);
    end);
end;

procedure TbfaApplication.ResetStandardSearch(AThread: TThread);
begin
  try
  AThread.Synchronize(nil,
    procedure
    begin
      bitfarmLog.Write(llNormal, ltDebug, 'ResetStandardSearch', ClassName);
      frmMainForm.edtGeneralSearch.Clear;

      frmMainForm.edtSearchFTX.Reset;
      frmMainForm.cbxSearchUser.Reset;
      frmMainForm.cbxSearchLinks.Reset;
      frmMainForm.cbxSearchLinks.compComboBox.Properties.Items.Clear;
      frmMainForm.dteSearch.Reset;
      frmMainForm.dteSearch.Modified := False;
      frmMainForm.dteSearch.ModifiedHigh := False;
      SetLastYearSearch;

      frmMainForm.clItemInResub.ImageIndex := Integer(icoidx_clock_unselected);
      frmMainForm.clItemInResub.FontSettings.Style := [];
      FSearchInResub := False;
      FSearchInResubNegated := False;
    end);
  except
    bitfarmLog.Write(llNormal, ltException, 'ResetStandardSearch', ClassName);
  end;
end;

procedure TbfaApplication.SetLastYearSearch;
begin
  bitfarmLog.DebugBegin(llDebug, 'SetLastYearSearch', ClassName);
  try
    try
//      if bitfarmApp.ViewerOptions.SearchOptions.SearchLastYear and (frmMainForm.btnSearchOption3.Caption = frmMainForm.tbiSoArchived.Caption) then  //07.01.2019 nur beim Datumsuche sollte angezeigt werden
      if bitfarmApp.ViewerOptions.SearchOptions.SearchLastYear then  //06.06.2024 SD <--bfacrm:ticket__show__38704
      begin
        frmMainForm.dteSearch.compDateLow.EditValue := IncYear(Now(), -1);
        frmMainForm.dteSearch.compDateLow.EditModified := True;
        frmMainForm.dteSearch.compDateHigh.EditValue := Now();
        frmMainForm.dteSearch.compDateHigh.EditModified := True;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'SetLastYearSearch', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetLastYearSearch', ClassName);
  end;
end;

procedure TbfaApplication.SetLogDirectory;
begin
// Enterprise-Funktion
end;

procedure TbfaApplication.RestoreOriginal(Data: PUserAction; AThread: TThread);
var
  Rslt: Integer;
  req: TbfaRequest;
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'RestoreOriginal', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          Rslt := BfMessageDlg(_('Mchten Sie dieses Dokument mit dem Original ersetzen?\n') + ' ' + _('Dadurch gehen Vernderungen verloren, wie z. B. die Drehung, Farbinvertierung, etc.\n') + ' ' + _('(Hinweis: Anmerkungen bleiben erhalten.)'), mtConfirmation, [mbYes, mbNo], True);
        end);

      if Rslt = mrYes then
      begin
        req := TbfaRequest.Create;
        try
          Data^.params.Delimiter := ';';
          Data^.params.StrictDelimiter := True;
          req.ReqType := 'reqResetPreview';
          req.UserID := user.ID;
          req.Profile := Self.Profile;
          req.Gdocid := -1;
          req.Parameter := Data^.params.DelimitedText;
          req.Lang := Lang;
          MainSocket.SendRequestToServer(req);

          req := MainSocket.ReceiveResponse(AThread);
          if req = nil then
            Exit;

//27.11.2018 Ticket 16957 -->
          if req.ReqType = 'respAuthError' then
          begin
            BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
            UserAction := CreateUserAction;
            UserAction^.ActionName := 'actRelogin';
            MainThread.Add(UserAction);
            Exit;
          end
          else
//27.11.2018 Ticket 16957 <--
if req.ReqType = 'respError' then
            BfShowMessage(_('Fehler beim Originaldokument wiederherstellen.') + #13#10 + req.DataString, AThread)
          else
          begin
            ReloadDocument(FCurrentContainer[0], False, AThread);
//              GetActivePreview.ShowPage(FCurrentContainer[0], GetActivePreview.SingleView.img_DocView.IO.Params.ImageIndex);
//              GetActivePreview.RefreshThumbnailView(FCurrentContainer[0], GetActivePreview.SingleView.img_DocView.IO.Params.ImageIndex);
            RefreshDocumentInPreviews(AThread, FCurrentContainer[0], nil, nil, False, False, True);
          end;

        finally
          FreeAndNil(req);
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'RestoreOriginal', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'RestoreOriginal', ClassName);
  end;
end;

procedure TbfaApplication.ResubCancel(Data: PUserAction; AThread: TThread);
begin
  BfShowMessage('ResubCancel');
end;

procedure TbfaApplication.ResubDone(Data: PUserAction; AThread: TThread);
begin
  BfShowMessage('ResubDone');
end;

procedure TbfaApplication.SaveResub(Data: PUserAction; AThread: TThread);
var
  resub: TResub;
  doc, tempdoc: TbfaDocument;
  req: TbfaRequest;
  LstResubs: TList<TbfaBaseObject>;
  WF, WF2: TbfaWorkflow;
  i, j, k, row, gdocid: Integer;
  found, ReloadWorkflow, OldEditMode: Boolean;
  HD: HWND;
  Str: string;
  UserAction, DoSaveData: PUserAction;
  FException: Boolean;
  dsc : TDataSource;
  lbm, RNo, OldTimID : Integer;
  gdc : TcxGridDBDataController;

begin
  bitfarmLog.DebugBegin(llDebug, 'SaveResub', ClassName);
  try
    FException := False;
    if Data^.Documents.Count = 0 then
      Exit;

    DoSaveData := CreateUserAction;
    DoSaveData^.Params.StrictDelimiter := True;
    DoSaveData^.Params.Delimiter := ';';
    DoSaveData^.Params.DelimitedText := 'btnSaveClick';
    OldEditMode := TbfaDocument(Data^.Documents[0]).InEditMode;
    OldTimID := TbfaDocument(Data^.Documents[0]).TimID;
    DoSave(AThread, DoSaveData);
    // Dispose(DoSaveData).Actionname <> 'actCallDoSave' findet in DoSave statt

    req := TbfaRequest.Create;
    LstResubs := TList<TbfaBaseObject>.Create;
    try
      for j := 0 to Data^.Documents.Count - 1 do
      begin
        found := False;
        doc := TbfaDocument(Data^.Documents[j]);
        WF := TbfaWorkflow.Create;

        if Data^.objects.Count > 0 then
          resub := TResub(Data.Objects[0]^)
        else
        begin
          Finalize(resub);
          FillChar(resub, SizeOf(resub), 0);
        end;

        if (doc.WorkFlows.Count = 0) and (Data^.params[0] <> 'delete') then    // bei fertigen Wiedervorlagen
        begin                                                                  // liefert der Server auch keien Workflow-Objekte zurck
          tempdoc := TBfaDocument.Create;
          req.ReqType := 'reqDoc';
          req.UserID := user.ID;
          req.Gdocid := doc.ID;
          req.Profile := Profile;
          req.Parameter := 'workflow';
          req.Lang := Lang;
          req.TimID := doc.TimID;  //01.02.2019 Ticket 17870

          MainSocket.SendRequestToServer(req);

          req := MainSocket.ReceiveDoc(tempdoc, AThread);
          if (req = nil) or (req.ReqType = 'respDocError') then
          begin
            BfShowMessage(_('Es hat einen Fehler bei der Workflow-Verarbeitung gegeben.') + #13#10 + req.DataString, AThread);
            Exit;
          end;
          for i := 0 to tempdoc.Workflows.Count - 1 do
            doc.Workflows.Add(tempdoc.Workflows[i]);
          resub.TimID := 0;   // zurcksetzen, damit im folgenden die timid und timref aus doc.workflows[i] genommen wird
          resub.TimRef := 0;
        end;

        if (Data^.params[0] = 'delete') then
        begin
          WF.UseridShed := user.ID;
          WF.TimID := doc.TimID;
          found := True;
        end
        else if Data^.params[0] <> 'change' then   // bei change request nicht abgleichen
        begin
          // TResub record mit Doc.Workflows abgleichen
          for i := 0 to doc.Workflows.Count - 1 do
          begin
            if doc.Workflows[i].TimID = doc.TimID then
            begin
              found := True;
              if resub.FwdInfo <> '' then
                WF.Info := resub.FwdInfo
              else if resub.Info <> '' then
                WF.Info := resub.Info
              else
                WF.Info := doc.Workflows[i].Info;

              Str := FormatDateTime('', EncodeDate(1899, 12, 30), FFormatSettings); //weil beim DatumFormat 2018-08-21 hatte AV gemacht
              if CompareDate(resub.Date, StrToDate(Str)) = 0 then
                WF.Date := IncDay(Now(), resub.AdditionalDays)
              else
                WF.Date := resub.Date;

              if CompareDate(resub.AlarmDate, StrToDate(Str)) = 0 then
                WF.AlarmDate := IncDay(WF.Date, resub.Alarm)
              else
                WF.AlarmDate := resub.AlarmDate;

              if resub.Comment <> '' then
                WF.Comment := resub.Comment
              else
                WF.Comment := doc.Workflows[i].Comment;

              WF.Options := resub.Options;

              if resub.Status <> 0 then
                WF.Status := resub.Status
              else
                WF.Status := doc.Workflows[i].Status;

              if resub.TimID <> 0 then
                WF.TimID := resub.TimID
              else
                WF.TimID := doc.Workflows[i].TimID;

              if resub.TimRef <> 0 then
                WF.TimRef := resub.TimRef
              else
                WF.TimRef := doc.Workflows[i].TimRef;

              if Data.Params[0] = 'create' then     // wird eine Wiedervorlage angelegt, sind wir immer der Controller
                WF.UseridShed := resub.UseridShed   // sonst kommt es zum Fehler wenn man in der WVL Liste eine neue WVL anlegt Ticket 15321
              else
                WF.UseridShed := doc.Workflows[i].UseridShed;

              Break;
            end;
          end;
        end;

        if not found then  // es gibt keinen bestehenden Workflow der abgeglichen werden muss
        begin              // daher kommen alle Infos aus dem record direkt in das WF Objekt
          if resub.FwdInfo <> '' then
            WF.Info := resub.FwdInfo
          else if resub.Info <> '' then
            WF.Info := resub.Info;

          Str := FormatDateTime('', EncodeDate(1899, 12, 30), FFormatSettings); //weil beim DatumFormat 2018-08-21 hatte AV gemacht
          if CompareDate(resub.Date, StrToDate(Str)) = 0 then
            WF.Date := IncDay(Now(), resub.AdditionalDays)
          else
            WF.Date := resub.Date;

          try
            if CompareDate(resub.AlarmDate, StrToDate(Str)) = 0 then
              WF.AlarmDate := IncDay(WF.Date, resub.Alarm)
            else
              WF.AlarmDate := resub.AlarmDate;
          except
            WF.AlarmDate := IncDay(WF.Date, resub.Alarm)
          end;

          WF.Comment := resub.Comment;
          WF.Options := resub.Options;
          WF.Status := resub.Status;
          WF.UseridShed := resub.UseridShed;

          // haben wir keine timid und timref aber workflows anhngig, schauen wir ob eine passende id dabei ist
          if (resub.TimID = 0) and (resub.TimRef = 0) and (doc.Workflows.Count > 0) then
          begin
            for i := 0 to doc.Workflows.Count - 1 do
            begin
              if doc.Workflows[i].TimID = doc.TimID then
              begin
                WF.TimID := doc.TimID;
                WF.TimRef := doc.Workflows[i].TimRef;
                Break;
              end;
            end;
          end
          else
          begin    // ansonsten die IDs aus dem Record
            WF.TimID := resub.TimID;
            WF.TimRef := resub.TimRef;
          end;
        end;

        WF.Gdocid := doc.ID;
        WF.Profile := Self.Profile;
        WF.Modified := True;
        WF.Users := resub.Users;
        WF.Groups := resub.Groups;
        if (WF.Groups = '') and (WF.Users = '') then
          WF.Users := IntToStr(user.ID);

        LstResubs.Add(WF);

      end;
      req.ReqType := 'reqSaveResub';
      req.UserID := user.ID;
      req.Profile := Self.Profile;
      req.Gdocid := doc.ID;
      req.Parameter := Data^.params[0];
      req.Lang := Lang;
      req.Data := LstResubs;
      MainSocket.SendRequestToServer(req);

      req := MainSocket.ReceiveResponse(AThread);
      if req = nil then
        Exit;

//27.11.2018 Ticket 16957 -->
      if req.ReqType = 'respAuthError' then
      begin
        BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
        UserAction := CreateUserAction;
        UserAction^.ActionName := 'actRelogin';
        MainThread.Add(UserAction);
        Exit;
      end
      else
//27.11.2018 Ticket 16957 <--
      if req.ReqType = 'respError' then
        BfShowMessage(_('Fehler beim Speichern der Wiedervorlage.') + #13#10 + req.DataString, AThread)
      else
        RefreshGrid(AThread);

      // nach RefreshGrid sollten alle (noch in der Liste vorhandenen) Dokumente selektiert sein.
      // wir gehen durch die Selektion, suchen den passenden Eintrag in FCurrentContainer und
      // aktualisieren TimId und ResubUserid
      dsc := frmMainForm.grdResultlistDevExView.DataController.DataSource;
      gdc := frmMainForm.grdResultlistDevExView.DataController;

//24.03.2022      for i := 0 to frmMainForm.grdResultlistDevExView.Controller.SelectedRowCount - 1 do
      for i := 0 to frmMainForm.grdResultlistDevExView.Controller.SelectedRecordCount - 1 do
      begin
//24.03.2022        RNo := frmMainForm.grdResultlistDevExView.Controller.selectedRows[i].Index;
        RNo := frmMainForm.grdResultlistDevExView.Controller.selectedRecords[i].RecordIndex;
        gdocid := gdc.GetValue(RNo, gdc.GetItemByFieldName('gdocid').Index);
        for j := 0 to FCurrentContainer.Count - 1 do
        begin
          if gdocid = FCurrentContainer[j].Id then
          begin
            if (dsc.DataSet.FieldDefList.Find('timid') <> nil) and
               ((not VarIsNull(gdc.GetValue(RNo, gdc.GetItemByFieldName('timid').Index))) and
               VarIsNumeric(gdc.GetValue(RNo, gdc.GetItemByFieldName('timid').Index))) then
              FCurrentContainer[j].TimID := gdc.GetValue(RNo, gdc.GetItemByFieldName('timid').Index)
            else
              FCurrentContainer[j].TimID := -1;
            if (dsc.DataSet.FieldDefList.Find('userid_shed') <> nil) and
               ((not VarIsNull(gdc.GetValue(RNo, gdc.GetItemByFieldName('userid_shed').Index))) and
               VarIsNumeric(gdc.GetValue(RNo, gdc.GetItemByFieldName('userid_shed').Index))) then
              FCurrentContainer[j].ResubUserID := gdc.GetValue(RNo, gdc.GetItemByFieldName('userid_shed').Index)
            else
              FCurrentContainer[j].ResubUserID := -1;

            // Zur Sicherheit entfernen wir auch die Workflow-Objekte, damit diese neu geladen werden, falls mehrere
            // Dokumente verarbeitet wurden, die danach immer noch auf der WVL stehen, aber mittlerweile andere timids erhalten haben.
            // In den Objekten stehen aber noch die vorherigen timids....
            FCurrentContainer[j].Workflows.Clear;

            tempdoc := TBfaDocument.Create;
            req.ReqType := 'reqDoc';
            req.UserID := user.ID;
            req.Gdocid := FCurrentContainer[j].Id;
            req.Profile := Profile;
            req.Parameter := 'workflow';
            req.Lang := Lang;

            MainSocket.SendRequestToServer(req);

            req := MainSocket.ReceiveDoc(tempdoc, AThread);
            if (req = nil) or (req.ReqType = 'respDocError') then
            begin
              BfShowMessage(_('Es hat einen Fehler bei der Workflow-Verarbeitung gegeben.') + #13#10 +
                req.DataString, AThread);
              Exit;
            end;
            for k := 0 to tempdoc.Workflows.Count - 1 do
              FCurrentContainer[j].Workflows.Add(tempdoc.Workflows[k]);

            Break;
          end;
        end;
      end;

      // wenn wir nach aktualisierung der wvl liste immer noch auf dem selben Dokument stehen,
      // dann muss dieses neu geladen werden zur aktualisierung),
      // ansonsten wird durch Refreshgrid ja sowieso neu geladen

      if ((frmMainForm.grdResultlistDevExView.DataController.DataSource <> nil) and
          (frmMainForm.grdResultlistDevExView.DataController.DataSource.DataSet <> nil) and
          (frmMainForm.grdResultlistDevExView.DataController.DataSource.DataSet.RecordCount > 0) and
          (frmMainForm.grdResultlistDevExView.DataController.GetValue(
            frmMainForm.grdResultlistDevExView.ActRec,
            frmMainForm.grdResultlistDevExView.DataController.GetItemByFieldName('gdocid').Index) = FCurrentContainer[0].Id)) or
          (GetActivePreview.Floating or (GetActivePreview <> FPreviewContainer.ViewerItem.Preview))
      then
      begin
        ReloadDocument(FCurrentContainer[0], False, AThread);
        ShowResubFields(FCurrentContainer[0], frmMainForm.fraResub);
        AThread.Synchronize(nil,
          procedure
          begin
            ShowDocumentProperties(FCurrentContainer[0], GetActivePreview);
            ShowAddfields(FCurrentContainer[0]);
            ShowStateFields(FCurrentContainer[0]);
          end);
      end;

      if CurrentView = tvkResub then
        FNewResubs := 0;

      Checkresub(AThread);

      HD := FindWindow('bitfarm.hotsearch.V36', nil);
      bitfarmLog.Write(llDebug, ltInfo, 'SaveResub befor sendMessage', ClassName);
      sendMessage(HD, WM_HOTKEY_WVL_MESSAGE, 1, 1);
      bitfarmLog.Write(llDebug, ltInfo, 'SaveResub after sendMessage', ClassName);

      AThread.Synchronize(nil,
        procedure
        begin
          if Assigned(frmMainForm.pnlFloatingResub) and Assigned(frmMainForm.fraFloatingResub) and
            frmMainForm.pnlFloatingResub.floating
          then
            frmMainForm.fraFloatingResub.fraResub.btnMyTasks.Click;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'SaveResub', ClassName);
      FException := True;
    end;
    if FException then
    begin
      try
        RefreshGrid(AThread);
      except
        bitfarmLog.Write(llNormal, ltException, 'SaveResub - 2', ClassName);
      end;
    end;
  finally
    FreeAndNil(req);
    FreeAndNil(LstResubs);
    FreeAndNil(WF);
    bitfarmLog.DebugEnd(llDebug, 'SaveResub', ClassName);
  end;
end;

procedure TbfaApplication.SaveTreeViewBookmarkExpanded;
var
  lstExpanededBookmarks: TStringList;
  inifile: TIniFile;
  I: Integer;
begin
  // wegen Multiuser-/Multiserver-Umgebungen knnen wir nicht einfach den String schreiben
  // wir prfen ob enthaltene Werte jetzt eingeklappt sind, dann entfernen wir sie
  // das kann zwar zu Kateileichen fhren, verhindert aber dass ein Login mit einem
  // fremden Account die gesamte Liste ber den Haufen wirft

  // TODO SJ Benutzerbasiert machen
  try
    try
      inifile := TIniFile.Create(BD.AppdataBitfarmPd + 'Viewer.ini');

      lstExpanededBookmarks := TStringList.Create;
      lstExpanededBookmarks.Delimiter := ';';
      lstExpanededBookmarks.Duplicates := dupIgnore;
      lstExpanededBookmarks.DelimitedText := inifile.ReadString('TreeView', 'ExpandedBookmarks', '');

      for I := 0 to frmMainForm.trvBookmarks.Items.Count - 1 do
      begin
        if (TObject(frmMainForm.trvBookmarks.Items[I].Data) is TbfaNodeInfo) and
           (TbfaNodeInfo(frmMainForm.trvBookmarks.Items[I].Data).GUID <> '') and
           (StringToGuid(TbfaNodeInfo(frmMainForm.trvBookmarks.Items[I].Data).GUID) <> TGUID.Empty) then
        begin
          if (lstExpanededBookmarks.IndexOf(TbfaNodeInfo(frmMainForm.trvBookmarks.Items[I].Data).GUID) = -1) and
             frmMainForm.trvBookmarks.Items[I].Expanded
          then
            lstExpanededBookmarks.Add(TbfaNodeInfo(frmMainForm.trvBookmarks.Items[I].Data).GUID)
          else if (lstExpanededBookmarks.IndexOf(TbfaNodeInfo(frmMainForm.trvBookmarks.Items[I].Data).GUID) <> -1) and
                  (not frmMainForm.trvBookmarks.Items[I].Expanded)
          then
            lstExpanededBookmarks.Delete(lstExpanededBookmarks.IndexOf(TbfaNodeInfo(frmMainForm.trvBookmarks.Items[I].Data).GUID));
        end;
      end;

      inifile.WriteString('TreeView', 'ExpandedBookmarks', lstExpanededBookmarks.DelimitedText);
    except
      bitfarmLog.Write(llNormal, ltException, 'SaveTreeViewBookmarkExpanded', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SaveTreeViewBookmarkExpanded', ClassName);
    if Assigned(inifile) then
      inifile.Free;
    if Assigned(lstExpanededBookmarks) then
      lstExpanededBookmarks.Free;
  end;
end;

procedure TbfaApplication.RotatePages(prev: TbfaPreview; Grad: Integer; AThread: TThread);
var
  sl: TStringList;
  i: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'RotatePages', ClassName);
  try
    try
      sl := TStringList.Create;
      try
        if ((prev.PreviewKind = pvkSingle) or (prev.PreviewKind = pvkMultiSingle)) then
        begin
          if ((prev.previewToolWindow.Visible) and (prev.ThumbnailView.MultiSelectedImagesCount > 1)) then
          begin
            for i := 0 to prev.ThumbnailView.MultiSelectedImagesCount - 1 do
              sl.Add(IntToStr(prev.ThumbnailView.MultiSelectedImages[i]));
          end
          else
          begin
            if (prev.ActiveDoc.ScanPoolView <> nil) and (prev.ActiveDoc.ScanPoolViewLoaded) then
              sl.Add(IntToStr(prev.ActivePage))
            else
              sl.Add(IntToStr(prev.SingleView.img_DocView.IO.Params.ImageIndex));
            end;

          bfaProcessing.Rotate(FCurrentContainer, Grad, False, sl, prev.SingleView, prev.ThumbnailView, AThread);
        end
        else if (prev.PreviewKind = pvkMulti) then
        begin
          if ((prev.previewToolWindow.Visible) and (prev.MultiView.MultiSelectedImagesCount = 1) and (prev.ThumbnailView.MultiSelectedImagesCount >= 1)) then
          begin
            for i := 0 to prev.ThumbnailView.MultiSelectedImagesCount - 1 do
              sl.Add(IntToStr(prev.ThumbnailView.MultiSelectedImages[i]));

            bfaProcessing.Rotate(FCurrentContainer, Grad, False, sl, prev.SingleView, prev.ThumbnailView, AThread);
          end
          else
            bfaProcessing.Rotate(FCurrentContainer, Grad, True, nil, nil, nil, AThread);
        end;
      finally
        FreeAndNil(sl);

        if (bitfarmApp.CurrentView = tvkImporter) and
           (bitfarmApp.PreviewContainer.ImporterItem.Preview.PreviewKind = pvkMulti) and
           (bitfarmApp.PreviewContainer.PageSortingsItem.Panel.Showing)
        then
          CallShowDocument(FCurrentContainer[0], nil, nil, 0, 0, True, False, False,
            False, False, True, prev, False);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'RotatePages', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'RotatePages', ClassName);
  end;
end;

function TbfaApplication.CheckBeforeRotate(prev: TbfaPreview; AThread: TThread): Boolean;
begin
  bitfarmLog.DebugBegin(llDebug, 'CheckBeforeRotate', ClassName);
  try
    try
      Result := True;

      if (prev.ThumbnailThread <> nil) then
      begin
        if prev.GetThumbnailInProcess then
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              frm_Message.Show;
              frm_Message.Update;
            end);
          Result := False;
        end;
      end;

      if Result then
      begin
        if ((prev.PreviewKind = pvkSingle) or (prev.PreviewKind = pvkMultiSingle)) and (prev.SingleView.img_DocView.IsEmpty) then
          Result := False;

        if Result then
        begin
          prev.askforsave_annos2(AThread);
          if ((prev.ActiveDoc.ID <> -1) and (not ((prev.ActiveDoc.Rights and rightModify) = rightModify))) then
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                ShowMessage(_('Hinweis') + #13 + _('Dieses Dokument drfen Sie nicht verndern.'));
              end);
            Result := False;
          end;
        end;
      end;
    except
      Result := False;
      bitfarmLog.Write(llNormal, ltException, 'CheckBeforeRotate', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CheckBeforeRotate', ClassName);
  end;
end;

procedure TbfaApplication.CheckForFailedUpdates(AThread: TThread);
begin
 // Enterprise only
end;

procedure TbfaApplication.CheckForInvalidHolidday(AThread: TThread);
begin
  // Enterprise only
end;

procedure TbfaApplication.CheckHoliday;
begin
  // Enterprise only
end;

procedure TbfaApplication.Flip(AThread: TThread; prev: TbfaPreview);
begin
  bitfarmLog.DebugBegin(llDebug, 'Flip', ClassName);
  try
    try
      if CheckBeforeRotate(prev, AThread) then
      begin
        RotatePages(prev, 180, AThread);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'Flip', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'Flip', ClassName);
  end;
end;

procedure TbfaApplication.RotateLeft(AThread: TThread; prev: TbfaPreview);
begin
  bitfarmLog.DebugBegin(llDebug, 'RotateLeft', ClassName);
  try
    try
      if CheckBeforeRotate(prev, AThread) then
      begin
        RotatePages(prev, 90, AThread);
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'RotateLeft', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'RotateLeft', ClassName);
  end;
end;

procedure TbfaApplication.RotateRight(AThread: TThread; prev: TbfaPreview);
begin
  bitfarmLog.DebugBegin(llDebug, 'RotateRight', ClassName);
  try
    try
      if CheckBeforeRotate(prev, AThread) then
      begin
        RotatePages(prev, -90, AThread);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'RotateRight', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'RotateRight', ClassName);
  end;
end;

procedure TbfaApplication.Save(AThread: TThread);
var
  i : Integer;
  CanSave : Boolean;
  UserAction: PUserAction;
begin
  try
  //27.05.2020 Ticket 10862 -->
    CanSave := True;
//11.07.2023 Ticket 35301 muss immer geprft werden  if AddFieldsModified(aCurrentAddfields) then
//    begin
      for i := 0 to FCurrentContainer.Count - 1 do
      begin
        if CanSave and (FCurrentContainer[i].Id <> -1) and (FCurrentContainer[i].InEditMode) and
           not CheckAddFields(AThread, FCurrentContainer[i], aCurrentAddfields, False)
        then
          CanSave := False;
//      end;
    end;
    if CanSave then
  //27.05.2020 Ticket 10862 <--
    begin
      UserAction := CreateUserAction;
      UserAction^.Params.StrictDelimiter := True;
      UserAction^.Params.Delimiter := ';';
      UserAction^.Params.DelimitedText := 'btnSaveClick';
      DoSave(AThread, UserAction);
      // Dispose(UserAction).Actionname <> 'actCallDoSave' findet in DoSave statt
    end;

    // bfacrm:ticket__show__24708
    AThread.Synchronize(nil,
      procedure
      begin
        if (frmMainForm.grdResultlistDevEx.Visible) and (frmMainForm.grdResultlistDevEx.Enabled) and
           (GetActivePreview = FPreviewContainer.ViewerItem.Preview) and
           (frmMainForm.grdResultlistDevExView <> nil) and
           (frmMainForm.grdResultlistDevExView.DataController <> nil) and
           (frmMainForm.grdResultlistDevExView.DataController.DataSet <> nil) and
           (frmMainForm.grdResultlistDevExView.DataController.DataSet.RecordCount > 0) then
          frmMainForm.grdResultlistDevEx.SetFocus;
      end);
  except
    bitfarmLog.Write(llNormal, ltException, 'Save', ClassName);
  end;
end;

procedure TbfaApplication.DocAbo(AThread: TThread);
begin
  // Enterprise only
end;

procedure TbfaApplication.DoCancelRequest(Doc: TbfaDocument; AThread: TThread;
  RefreshActPreview: Boolean = True;
  OnlyDoc : Boolean = False //13.03.2019 Ticket 18518 wenn nur gespeichert wir und bleibt stehen, dann muss nicht alles neugeladen werden
  );
var
  req: TbfaRequest;
  UserAction: PUserAction;
  i: Integer;
  param: string;
begin
  try
    req := TbfaRequest.Create;

    param := '';
    if FCurrentContainer.Count > 0 then
    begin
      for i := 0 to FCurrentContainer.Count - 1 do
      begin
        if FCurrentContainer[i].Id <> -1 then
        begin
          if param = '' then
            param := IntToStr(FCurrentContainer[i].Id)
          else
            param := param + ';' + IntToStr(FCurrentContainer[i].Id);
        end;
      end;
    end;

    bitfarmLog.DebugBegin(llDebug, 'DoCancelRequest - docs: ' + param, ClassName);

    if param <> '' then
    begin
      try
        req.ReqType := 'reqCancel';
        req.UserID := user.ID;
        req.Gdocid := Doc.ID;
        req.Profile := Profile;
        req.Parameter := param;
        req.Lang := Lang;
        MainSocket.SendRequestToServer(req);

        req := MainSocket.ReceiveResponse(AThread);
        if req = nil then
        begin
          UserAction := CreateUserAction;
          UserAction^.ActionName := 'actRelogin';
          FMainThread.Add(UserAction);
          Exit;
        end;

        if req.ReqType = 'respAuthError' then
        begin
          BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
          UserAction := CreateUserAction;
          UserAction^.ActionName := 'actRelogin';
          FMainThread.Add(UserAction);
          Exit;
        end;
      finally
        FreeAndNil(req);
      end;

      Doc.InEditMode := False;
      Doc.EditmodeUserID := 0;
      Doc.Modified := False;

      AThread.Synchronize(nil,
        procedure
          var i : Integer;
        begin
          for i := 0 to aCurrentAddfields.Count - 1 do
          begin
            if aCurrentAddfields[i].Component <> nil then
              aCurrentAddfields[i].Component.EditMode := False;
          end;

          for i := 0 to aCurrentStatefields.Count - 1 do
          begin
            if aCurrentStatefields[i].Component <> nil then
              aCurrentStatefields[i].Component.EditMode := False;
          end;

          //05.09.2024 SD -->bfacrm:ticket__show__39649
          if (frmMainForm.dteSearch.Modified or frmMainForm.dteSearch.ModifiedHigh) and (frmMainForm.tbiSoExpired.Checked) then
          begin
            frmMainForm.dteSearch.Modified := False;
            frmMainForm.dteSearch.ClearValue;
          end;
          frmMainForm.dteSearch.EditMode := False;
          //05.09.2024SD <--bfacrm:ticket__show__39649
        end);

      // hier haben wir ReloadDocument auskommentiert um ein unntigen reqPreview zu vermeiden
      // es bleibt die Frage, ob bei einem reqCancel ein Neuladen des DocObjects ntig ist (ber reqDoc)
      ReloadDocument(Doc, False, AThread, OnlyDoc); //13.03.2019 Ticket 18518 wenn nur gespeichert wir und bleibt stehen, dann muss nicht alles neugeladen werden
      AThread.Synchronize(nil,
        procedure
        begin
          bfaPreview36.ShowAddFields(Doc);
          bfaPreview36.ShowStateFields(Doc);
          if (CurrentView = tvkResub) then
            ShowresubFields(Doc, frmMainForm.fraResub);
        end);
      if (RefreshActPreview) and (not FDoSave) then
        RefreshDocumentInPreviews(AThread, Doc, nil, nil)
      else
        RefreshDocumentInPreviews(AThread, Doc, GetActivePreview, nil);
    end;
  except
    bitfarmLog.DebugEnd(llDebug, 'DoCancelRequest', ClassName);
  end;
end;

procedure TbfaApplication.ExecuteBookmarkSave;
begin
  try
    TbfaSearch(frmMainForm.frmCreateGlobal.ATreeNode.Data).Clone(frmMainForm.frmCreateGlobal.sobj);
    frmMainForm.frmCreateGlobal.ATreeNode.Text := frmMainForm.frmCreateGlobal.edtName.Text;

    if frmMainForm.frmCreateGlobal.sobj.Verify then
    begin
      if GetRootNode(frmMainForm.frmCreateGlobal.ATreeNode) = GlobalListNode then
      begin
        frmMainForm.frmCreateGlobal.ATreeNode.ImageIndex := Integer(icoidx_bookmark_global_check);
        frmMainForm.frmCreateGlobal.ATreeNode.SelectedIndex := Integer(icoidx_bookmark_global_selected_check);
      end else
      begin
        frmMainForm.frmCreateGlobal.ATreeNode.ImageIndex := Integer(icoidx_bookmark_check);
        frmMainForm.frmCreateGlobal.ATreeNode.SelectedIndex := Integer(icoidx_bookmark_check_selected);
      end;
    end
    else
    begin
      if GetRootNode(frmMainForm.frmCreateGlobal.ATreeNode) = GlobalListNode then
      begin
        frmMainForm.frmCreateGlobal.ATreeNode.ImageIndex := Integer(icoidx_bookmark_global);
        frmMainForm.frmCreateGlobal.ATreeNode.SelectedIndex := Integer(icoidx_bookmark_global_selected);
      end else
      begin
        frmMainForm.frmCreateGlobal.ATreeNode.ImageIndex := Integer(icoidx_bookmark);
        frmMainForm.frmCreateGlobal.ATreeNode.SelectedIndex := Integer(icoidx_bookmark_selected);
      end;
    end;

    SaveBookmarkNode(frmMainForm.frmCreateGlobal.ATreeNode);
  except
    bitfarmLog.Write(llNormal, ltException, 'ExecuteBookmarkSave', ClassName);
  end;
end;

function TbfaApplication.ExecuteCheckProgram(GDocID, ArcID: Int64; AddField: TbfaAddfield): Boolean;
var
  lsDispName, lsParams, value: string;
begin
  Result := True;
  lsParams := '';

  if not FileExists(AddField.Checkprogram) then
  begin
    BfShowMessage(_('Das Checkprogramm konnte nicht gefunden werden.\nWenden Sie sich bitte an ihren Administrator\n') + AddField.Checkprogram);
    result := False;
    Exit;
  end else
  begin
    lsParams := IntToStr(GDocID) + ' ' + IntToStr(ArcID) + ' ' + #34 + AddField.DisplayName + #34 +' ' + AddField.Name;
    Result := (ShellExecute_AndWait('', ExtractFileName(AddField.Checkprogram), #34 + AddField.Value + #34 + ' ' + lsParams, ExtractFilePath(AddField.checkProgram), SW_HIDE, True) = 0);
  end;

  while not Result do
  begin
    if bfaInputQuery(_('Eingabeberprfung'), _('Die Eingabe wurde zurckgewiesen. Bitte geben Sie einen gltigen Wert ein.'), value) then
    begin
      AddField.Component.compEdit.Text := ParseAddfields(value);
      Result := (ShellExecute_AndWait('', ExtractFileName(AddField.Checkprogram), #34 + AddField.value + #34 + ' ' + lsParams, ExtractFilePath(AddField.Checkprogram), SW_HIDE, True) = 0);
    end else
    begin
      Result := False;
      value := '';
      Exit;
    end;
  end;
end;

procedure TbfaApplication.ExecutePluginViaStamp(PreviewObj: TObject;
  AnnoData: PAnnoData);
begin
 // Enterprise only
end;

procedure TbfaApplication.ExecuteSearch;
begin
  try
    frmMainForm.actSearch.Execute;
  except
    bitfarmLog.Write(llDebug, ltException, 'TbfaApplication.ExecuteSearch', ClassName)
  end;
end;

function TbfaApplication.ExecuteUpdate(HideSplash: Boolean): Boolean;
begin
// Enterprise-Funktion
end;

procedure TbfaApplication.DoCheck(Doc: TbfaDocument; var Rslt: Boolean;
  TmpFields: TList<TbfaAddField>; movedoc: Boolean);
var
  j: Integer;
  uString: WideString;
begin
  bitfarmLog.DebugBegin(llDebug, 'DoCheck', ClassName);
  try
    for j := 0 to TmpFields.Count - 1 do
    begin
      if TmpFields[j].Modified or ((TmpFields[j].Component <> nil) and TmpFields[j].Component.Modified) then
      begin
        if TmpFields[j].Checkprogram <> '' then
        begin
          bitfarmLog.Write(llDebug, ltInfo, 'TmpFields[j].Checkprogram: ' + TmpFields[j].Checkprogram + '; j: ' + IntToStr(j), ClassName);
          if not ExecuteCheckProgram(Doc.ID, Doc.ArcID, TmpFields[j]) then
          begin
            Rslt := False;
            Break;
          end;
        end;
      end;

      // Pflichtfeld?
      if ((TmpFields[j].Options and cAddfieldOptMandatory) = cAddfieldOptMandatory) then
      begin
        // Ist es ein Nur-Lesen-Feld, dann wird es bei der Pflichtfeldberprfung ingnoriert
        // wir prfen gegen alle Rechte (rFieldRead or rFieldWrite or rFieldModify = 7), wenn mehr als rFieldRead
        // dabei herauskommt, dann haben wir Schreiben oder ndernrecht  // Ticket 20823
        if TmpFields[j].Rights and (rFieldRead or rFieldWrite or rFieldModify) = rFieldRead then
          Continue;

        try
          // nur leere Eintrge? Sonst war zB "";""" ein gltiger Wert
          if (VarIsType(TmpFields[j].Value, varUString)) then
          begin
            uString := StringReplace(TmpFields[j].Value, '"', '', [rfReplaceAll]);
            uString := StringReplace(uString, ';', '', [rfReplaceAll]);
          end;

          if VarIsNull(TmpFields[j].Value) or
            ((VarIsType(TmpFields[j].Value, varUString)) and // 15.02.2024(uString = '')) or
             ((uString = '') or (Trim(uString) = '') or (Trim(TmpFields[j].Value) = ''))) or //15.02.2024 bfacrm:ticket__show__37230


//              ((VarIsType(TmpFields[j].Value, varUString)) and (TmpFields[j].Value = '')) or
//              ((VarIsType(TmpFields[j].Value, varUString)) and (TmpFields[j].Value = '""')) or
            ((VarIsType(TmpFields[j].Value, varDate)) and (IsEmptyDate(VarToDateTime(TmpFields[j].Value)))) then
          begin
            if VarIsNull(TmpFields[j].Value) then
              bitfarmLog.Write(llDebug, ltError, 'VarIsNULL', ClassName)
            else
            begin
              bitfarmLog.Write(llDebug, ltInfo, 'TmpFields[j].Value: ' + TmpFields[j].Value, ClassName);
              if (VarIsType(TmpFields[j].Value, varDate) and (IsEmptyDate(VarToDateTime(TmpFields[j].value)))) then
                bitfarmLog.Write(llDebug, ltError, '((VarIsType(TmpFields[j].Value, varDate)) and ' + '(IsEmptyDate(TmpFields[j].Value))', ClassName);
            end;

            BfShowMessage(_('Sie mssen erst die Pflichtfelder ausfllen.') + #13 + _('Pflichtfelder haben einen fetten Bezeichner bzw. sind hell-orange hinterlegt.'));
            Rslt := False;
            Break;
          end;

          if TmpFields[j].Typ in [2, 11] then // zfld02_Auswahl, zfld11_DLM
          begin
            // TODO: auf styles umstellen
            if TmpFields[j].Component.compComboBox.Style.Color = cColorRed then
            begin
              BfShowMessage(_('Bitte berprfen Sie die Zusatzfelder.'));
              Rslt := False;
              Break;
            end;
          end
          else if TmpFields[j].Typ = 3 then // zfld03_MehrfachAuswahl
          begin
            if (TmpFields[j].Typ = 3) and
               ((TmpFields[j].Options and cAddfieldOptStrict) = cAddfieldOptStrict) then
            begin
              try
                var fMultiselectItems: TStrings;
                fMultiselectItems := TStringList.Create;
                fMultiselectItems.Delimiter := ';';
                fMultiselectItems.StrictDelimiter := True;
                fMultiselectItems.DelimitedText := TmpFields[j].Value;

                // <!-- bfacrm:ticket__show__33355
                // ListContains fand auch 'ol' bei Eintrag 'lol'. Ist natrlich Unsinn...
//                  if (not ListContains(TmpFields[j].Component.Comboitems, fMultiselectItems[i])) then

                for var i := fMultiselectItems.Count - 1 downto 0 do
                  if (TmpFields[j].Component.Comboitems.IndexOf(fMultiselectItems[i]) = -1) and (fMultiselectItems[i] <> '') then
                  begin
                    BfShowMessage(_('Bitte berprfen Sie die Zusatzfelder.'));
                    bitfarmLog.Write(llDebug, ltInfo, 'DoCheck - Index = -1 @ Item '+ fMultiselectItems[i], ClassName);
                    Rslt := False;
                    Break;
                  end;
                // bfacrm:ticket__show__33355  -->
              except
                bitfarmLog.Write(llDebug, ltException, 'DoCheck - failed checking strict Items', ClassName);
              end;
            end;
          end;
        except
          Rslt := False;
        end;
      end;
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'DoCheck', ClassName);
  end;
end;

function TbfaApplication.CheckAddFields(AThread: TThread; Doc: TbfaDocument;
  TmpFields: TList<TbfaAddField>; movedoc: Boolean): Boolean;
var
  Rslt: Boolean;
begin
  Rslt := True;
  Result := Rslt;
  try
    if AThread <> nil then
    begin
      AThread.Synchronize(nil,
        procedure
        begin
          DoCheck(Doc, Rslt, TmpFields, movedoc);
        end);
    end
    else
    begin
      DoCheck(Doc, Rslt, TmpFields, movedoc);
    end;
    Result := Rslt;
  except
    Result := False;
  end;
end;

//25.04.2019 Ticket 19042 -->
function TbfaApplication.SaveAnnoHistory(CurrentIdx, AnnoIdx, ObjIdx : Integer; var delcnt : Integer) : TbfaHistory;
var
  hst : TbfaHistory;
begin
  Result := nil;
  try
    if FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].ObjList[ObjIdx].Modified and
      (FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].Layer = 0) //29.08.2019 Ticket 15477
    then
    begin
      hst := TbfaHistory.Create;
      hst.Userid := FUser.ID;
      hst.Gdocid := FCurrentContainer[CurrentIdx].Id;
      hst.Date := Now();
      if FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].ObjList[ObjIdx].ObjKind in [iekBOX, iekTEXT, iekMEMO] then
      begin
        if FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].ObjList[ObjIdx].ModifiedType = 0 then
        begin
//16.09.2024          hst.Value1 := _('Text');
          hst.Value1 := 'Text'; //wird durch Server bersetzt
          hst.Value2 := FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].ObjList[ObjIdx].ObjText;
          hst.Value3 := IntToStr(FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].Page + 1);
          hst.Taskid := 303;
        end
        else if FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].ObjList[ObjIdx].ModifiedType = 1 then
        begin
          hst.Value1 := IntToStr(FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].Page + 1);
          if FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].ObjList[ObjIdx].NewText <> '' then  //02.02.2018 Ticket 12551
          begin
            hst.Value2 := FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].ObjList[ObjIdx].ObjText;
            hst.Value3 := FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].ObjList[ObjIdx].NewText;
            hst.Taskid := 305;
          end
          else
            hst.Taskid := 306;  //02.02.2018 Ticket 12551
        end
        else if FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].ObjList[ObjIdx].ModifiedType = 2 then
        begin
//25.04.2019 Ticket 19042                         hst.Value1 := _('Text');
//                          hst.Value2 := IntToStr(FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].Page + 1);
//                          hst.Taskid := 301;
          inc(delcnt);
//16.09.2024          hst.Value1 := _('Text');
          hst.Value1 := 'Text'; //wird durch Server bersetzt
          if FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].ObjList[ObjIdx].ObjText = '' then
          begin
            hst.Value2 := IntToStr(FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].Page + 1);
            hst.Taskid := 301;
          end
          else
          begin
            hst.Value2 := FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].ObjList[ObjIdx].ObjText;
            hst.Value3 := IntToStr(FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].Page + 1);
            hst.Taskid := 304;
          end;
        end;
      end
      else
      begin
        if FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].ObjList[ObjIdx].ModifiedType = 0 then
        begin
          hst.Value1 := FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].ObjList[ObjIdx].name;
          hst.Value2 := IntToStr(FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].Page + 1);
          hst.Taskid := 300;
        end
        else if FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].ObjList[ObjIdx].ModifiedType = 1 then
        begin
          hst.Value2 := IntToStr(FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].Page + 1);
          hst.Taskid := 306;
        end
        else if FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].ObjList[ObjIdx].ModifiedType = 2 then
        begin
          inc(delcnt);
          hst.Value1 := FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].ObjList[ObjIdx].name;
          hst.Value2 := IntToStr(FCurrentContainer[CurrentIdx].Annotations[AnnoIdx].Page + 1);
          hst.Taskid := 301;
        end;
      end;
      Result := hst;
//25.04.2019 Ticket 19042      FCurrentContainer[i].Annotations[j].History.Add(hst);
    end;
  except
    Result := nil;
    bitfarmLog.Write(llNormal, ltException, 'function SaveAnnoHistory() : TbfaHistory;', ClassName);
  end;
end;
//25.04.2019 Ticket 19042 <--

function TbfaApplication.AddFieldsModified(fields: TList<TbfaAddField>): Boolean;
var
  i: Integer;
begin
  Result := False;

  for i := 0 to fields.Count - 1 do
  begin
    Result := Result or (fields[i].modified or ((fields[i].Component <> nil) and fields[i].Component.Modified));
    if Result then
      Break;
  end;
end;

/// <param name="Data">
///   Wir knnen mit actCallDoSave hier rein kommen oder via Direktaufruf.
///   Bei Direktaufruf ist nur Data.Params gesetzt (Actionname nicht)
///
///   Am Ende wird Data Disposed, sofern es nicht actCallDoSave ist. Das wird
///   ber die MainThreadExecute Disposed
///
///   Data.Params = 'btnSaveClick' oder 'btnResetClick'
///   Gibt Information darber wie gespeichert wurde um ggf. abzufragen ob gespeichert werden soll
/// </param>
function TbfaApplication.DoSave(AThread: TThread; Data: PUserAction = nil): Boolean;
//  function StateFieldsModified(fields: TList<TbfaStateField>): Boolean;
//  var
//    i: Integer;
//  begin
//    Result := False;
//
//    for i := 0 to fields.Count - 1 do
//    begin
//      Result := Result or (fields[i].modified or fields[i].Component.Modified);
//      if Result then
//        Break;
//    end;
//  end;

var
  i, j, k, liprefix, cntdelete, cntdel, PluginResult: Integer;
  modified_doc, modified_annos, modified_annosdelete, modified_preview, modified_expired,
  modified_addfields, modified_statefields, CancelReq, RunSavePlugin, saved,
  btnSaveClick, btnResetClick, CallActCancel, modified_doc_without_annodelete,
  MandantoryError: Boolean;
  req: TbfaRequest;
  UserAction: PUserAction;
  msg, param, lsdname, OptionName: String;
  Lst, LstAnnos: TList<TbfaBaseObject>;
  LstAddfields: TList<TbfaAddfield>;
  tempfield : TbfaAddfield;
  docids, tlsljob, slvalues: TStringList;
  SendSocket: TSocketConnection;
  MItem: TTBCustomItem;
  lsmydir, lspname, lsparams, listname: WideString;
  hst: TbfaHistory;
  Doc: TbfaDocument;
  AnnoObj: TbfaAnnotation;
  Strings: TStrings;

  function StateFieldsModified(fields: TList<TbfaStateField>): Boolean;
  var
    l: Integer;
  begin
    Result := False;

    for l := 0 to fields.Count - 1 do
    begin
      Result := Result or (fields[l].modified or fields[l].Component.Modified);
      if Result then
        Break;
    end;
  end;

begin
  bitfarmLog.DebugBegin(llDebug, 'DoSave', ClassName);
  Result := True;
  MandantoryError := False;
  FDoSave := True;
  saved := False;
  CancelReq := False;
  btnSaveClick := False;
  btnResetClick := False;
  try
    bitfarmLog.Write(llDebug, ltInfo, 'DoSave - FCurrentContainer.Count = ' + IntToStr(FCurrentContainer.Count), ClassName);

    if (Data <> nil) and (Data.Params.Count > 0) then
    begin
      if Data.Params.IndexOf('btnSaveClick') > -1 then
        btnSaveClick := True;
      if Data.Params.IndexOf('btnResetClick') > -1 then
        btnResetClick := True and (not btnSaveClick);
    end;

    if FCurrentContainer.Count > 0 then
    begin
      RunSavePlugin := False;
      modified_doc := False;
      modified_annos := False;
      modified_annosdelete := False;
      modified_preview := False;
      modified_expired := False;
      modified_addfields := False;
      modified_statefields := False;
      modified_doc_without_annodelete := False;
      CallActCancel := False;
//25.04.2019 hier muss in anderen previews auch aktualiaisert werden-->
      if GetActivePreview.SingleView.gbAnnoNotSaved then
        GetActivePreview.SingleView.saveannostream;

      if GetActivePreview.SingleView.fRefreshInOtherPrevs then
      begin
        bitfarmApp.CreateRefreshDocumentInPreviewsAction(GetActivePreview.ActiveDoc,
          GetActivePreview, nil, False, False); //25.04.2019 von saveannostream raus, hier rein!
        GetActivePreview.SingleView.fRefreshInOtherPrevs := False;
      end;
//25.04.2019 <--

      // f.schneider 21.07.2020   wir entfernen doppelte oder endstndige semikolon
      // SJ 04.03.2021 - and we check for invalid values in strict multiselects
      for j := 0 to aCurrentAddfields.Count - 1 do
      begin
        if aCurrentAddfields[j].Component = nil then
        begin
          bitfarmLog.Write(llDebug, ltError, 'DoSave Addfield hat keine Komponente! ' + aCurrentAddfields[j].DisplayName);
          Continue;
        end;

        if aCurrentAddfields[j].Component.Modified then
        begin
          AThread.Synchronize(nil,
          procedure
          begin
            if aCurrentAddfields[j].Typ in [0,2,3,11] then  //Universal, Auswahl, Mehrfach, DLM Auswahl
            begin
              if not VarIsNull(aCurrentAddfields[j].Value) and (aCurrentAddfields[j].Value <> '') then
                aCurrentAddfields[j].Value := ParseAddfields(aCurrentAddfields[j].Value);
              if (aCurrentAddfields[j].Typ = 3) and
                 ((aCurrentAddfields[j].Options and cAddfieldOptStrict) = cAddfieldOptStrict) then
              begin
                try
                  var fModifiedValue: Boolean;
                  fModifiedValue := False;

                  var fMultiselectItems: TStrings;
                  fMultiselectItems := TStringList.Create;
                  fMultiselectItems.Delimiter := ';';
                  fMultiselectItems.StrictDelimiter := True;
                  fMultiselectItems.DelimitedText := aCurrentAddfields[j].Value;

                  var l: Integer;
                  for l := fMultiselectItems.Count - 1 downto 0 do
                    if (aCurrentAddfields[j].Component.Comboitems.IndexOf(fMultiselectItems[l]) = -1) and (fMultiselectItems[l] <> '') then
                    begin
                      bitfarmLog.Write(llDebug, ltDebug, 'DoSave - removing MultiSelect Item "'+fMultiselectItems[l]+'": not in Comboitems', ClassName);
                      fMultiselectItems.Delete(l);
                      fModifiedValue := True;
                    end;
                  if fModifiedValue then
                  begin
                    aCurrentAddfields[j].Value := fMultiselectItems.DelimitedText;
                    aCurrentAddfields[j].Component.compCheckedCombo.EditingText := fMultiselectItems.DelimitedText;
                  end;
                except
                  bitfarmLog.Write(llDebug, ltException, 'DoSave - removing invalid MultiSelect Items failed', ClassName);
                end;
              end;
            end else if aCurrentAddfields[j].Typ = 13 then
            begin
              aCurrentAddfields[j].SetValue(aCurrentAddfields[j].Component.compGrid.GetValue, null, True, False);
            end;
          end);
        end;
      end;

      for i := 0 to FCurrentContainer.Count - 1 do
      begin
        bitfarmLog.Write(llDebug, ltInfo, 'DoSave - FCurrentContainer[i].ID: ' + IntToStr(FCurrentContainer[i].Id), ClassName);
        if (FCurrentContainer[i].Id <> -1) and (FCurrentContainer[i].InEditMode) then
        begin
          bitfarmLog.Write(llDebug, ltInfo, 'DoSave - FCurrentContainer[i].ID: ' + IntToStr(FCurrentContainer[i].Id) + ', InEditMode = True', ClassName);
          modified_doc := modified_doc or FCurrentContainer[i].modified;
          modified_annos := modified_annos or FCurrentContainer[i].modified_annos;
          // SJ 13.05.2022 - bei grafischen nderungen fragen wir nicht...
          modified_doc_without_annodelete := modified_doc_without_annodelete or FCurrentContainer[i].modified;
          modified_doc := modified_doc or FCurrentContainer[i].modified_annosdelete;
          if not modified_addfields then
            modified_addfields := modified_addfields or AddFieldsModified(aCurrentAddfields);
          if not modified_statefields then
            modified_statefields := modified_statefields or StateFieldsModified(aCurrentStateFields);
          modified_preview := modified_preview or FCurrentContainer[i].modified_preview;
          if (aSysArc[FCurrentContainer[i].arcid].Rights and rightAdmin = rightAdmin) or FUser.isAdmin then
          begin
            modified_doc := modified_doc or (frmMainForm.tbiSoExpired.Checked {and FUser.isAdmin}  and frmMainForm.dteSearch.Modified);
            modified_expired := modified_expired or (frmMainForm.tbiSoExpired.Checked {and FUser.isAdmin}  and frmMainForm.dteSearch.Modified);
            modified_doc_without_annodelete := modified_doc_without_annodelete or (frmMainForm.tbiSoExpired.Checked {and FUser.isAdmin}  and frmMainForm.dteSearch.Modified);
          end;
        end;
      end;

      // Der AbfrageDialog "nderung speichern?" soll anfangs nur kommen, wenn der Resetbutton im Bearbeiten-Modus geklickt wird
      // Wir prfen dann auch, alle drei nderungsflle
      if (btnResetClick and (modified_doc or modified_addfields or modified_statefields or modified_annos or modified_preview)) or
         (btnSaveClick and (FCurrentContainer.Count > 1) and (modified_doc_without_annodelete or modified_addfields or modified_statefields)) then
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            if (FCurrentContainer.Count = 1) and btnResetClick then
            begin
              msg := _('Sie haben nderungen am Dokument vorgenommen.\nSollen die nderungen gespeichert werden?');
              OptionName := 'MultipleDocEditsReset';
            end else if (FCurrentContainer.Count > 1) and btnSaveClick then // bfacrm:ticket__show__20349
            begin
              msg := _('Sie haben mehrere Dokumente markiert.\nSollen die nderungen fr die ausgewhlten Dokumente gespeichert werden?');
              OptionName := 'MultipleDocEditsSave';
            end else
            begin
              msg := _('Sie haben nderungen vorgenommen.\nSollen die nderungen fr die ausgewhlten Dokumente gespeichert werden?');
              OptionName := 'MultipleDocEditsLeave';
            end;

            if (BfMessageDialogWithCheckBox('', msg, mtConfirmation, [mbYes, mbNo], [_('Ja'), _('Nein')],
                True, bitfarmApp.ViewerOptions, OptionName, mrYes) = mrYes) then
            begin
              if not CheckAddFields(AThread, FCurrentContainer[0], aCurrentAddfields, False) then
                MandantoryError := True
              else
                btnSaveClick := True
            end else
            begin
              modified_doc := False;
              modified_annos := False;
              modified_preview := False;
              modified_addfields := False;
              modified_statefields := False;
              modified_doc_without_annodelete := False;
              CancelReq := True;
              // SJ 13.05.2022 - ticket__show__20349 - DoCancelRequest setzt InEditMode zurck,
              // deswegen wird das Dokument nicht neu geladen wenn man danach actCancel aufruft.
              // Ist aber ntig, wenn man beim speichern nein klickt und auf dem Dokument bleibt.
              CallActCancel := (FCurrentContainer.Count > 1) and btnSaveClick;
            end;
          end);
      end {else if (FCurrentContainer.Count > 0) and  //Fr Balint - bfacrm:ticket__show__35301
                  (modified_doc or modified_addfields or modified_statefields or modified_annos or modified_preview or modified_doc_without_annodelete) and
                  (not CheckAddFields(AThread, FCurrentContainer[0], aCurrentAddfields, False)) then
      begin
        CancelReq := True;
        Result := False;
        Exit;
      end};

      if MandantoryError then
      begin
        Result := False;
        Exit;
      end;

      if modified_annos then
      begin
        // <!-- bfacrm:ticket__show__31155 - SJ 10.06.2022
        AThread.Synchronize(nil,
          procedure
          begin
            if not btnSaveClick and not btnResetClick then
            begin
              if FCurrentContainer.Count = 1 then
                msg := _('Sie haben nderungen am Dokument vorgenommen.\nSollen die nderungen gespeichert werden?')
              else
                msg := _('Sie haben nderungen vorgenommen.\nSollen die nderungen fr die ausgewhlten Dokumente gespeichert werden?');
              if BfMessageDlg(msg, mtConfirmation, [mbYes, mbNo], True) = mrYes then
                btnSaveClick := True
            end;
          end);
        if btnSaveClick then
        begin
        // bfacrm:ticket__show__31155 -->
          for i := 0 to FCurrentContainer.Count - 1 do
          begin
            req := TbfaRequest.Create;
            LstAnnos := TList<TbfaBaseObject>.Create;
            try
              req.ReqType := 'reqSave';
              req.UserID := user.ID;
              req.Profile := Self.Profile;
              req.Gdocid := FCurrentContainer[i].Id;
              req.Arcid := FCurrentContainer[0].ArcID;
              req.Lang := Lang;
              if (CurrentView = tvkResub) and (PreviewContainer.ActiveItem = 0) then
                req.Addfields_Arcid := CurrentResubArchive.Arcid
              else if (FCurrentContainer[0].ArcID <> bitfarmApp.CurrentViewerArchive.ArcID) then
                req.Addfields_Arcid := bitfarmApp.CurrentViewerArchive.ArcID;

              if FCurrentContainer[0].SymbolicArcID > 0 then
                req.SymbolicArcID := FCurrentContainer[0].SymbolicArcID;

              if (FCurrentContainer[i].Id <> -1) and (FCurrentContainer[i].InEditMode) and
                  not (FCurrentContainer[i].modified_annosdelete) then  //AnnosDeleted werden in modified_doc gespeichert
              begin
                for j := 0 to FCurrentContainer[i].Annotations.Count - 1 do
                begin
                  if FCurrentContainer[i].Annotations[j].Modified then
                  begin
                    FCurrentContainer[i].Annotations[j].ClearHistoryList;
                    for k := Low(FCurrentContainer[i].Annotations[j].ObjList) to High(FCurrentContainer[i].Annotations[j].ObjList) do
                    begin
                      if FCurrentContainer[i].Annotations[j].ObjList[k].Modified then
                      begin
                        cntdel := 0;
                        hst := SaveAnnoHistory(i, j, k, cntdel);
                        FCurrentContainer[i].Annotations[j].History.Add(hst);
                      end;
                    end;
                    LstAnnos.Add(FCurrentContainer[i].Annotations[j]);

                  end;
                end;
              end;
              req.Data := LstAnnos;
              MainSocket.SendRequestToServer(req);
              req := MainSocket.ReceiveResponse(AThread);

              if req = nil then
                Exit;

              if req.ReqType = 'respAuthError' then
              begin
                BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
                UserAction := CreateUserAction;
                UserAction^.ActionName := 'actRelogin';
                MainThread.Add(UserAction);
                Exit;
              end
              else if (req.ReqType = 'respDenied') or (req.ReqType = 'respSaveDenied') then
              begin
                BfShowMessage(_('Das Dokument ist schon von einem anderen Benutzer in Bearbeitung gesetzt.'), AThread);
                modified_annos := False;
                Exit;
              end
              else if (req.ReqType = 'respError') or ((req.ReqType = 'respSaveError')) then
              begin
                BfShowMessage(_('Fehler beim Speichern.') + #13#10 + req.DataString, AThread);
                CancelReq := True;
                Exit;
              end
              else
              begin
                FCurrentContainer[i].modified_annos := False;
              end;
            finally
              FreeAndNil(LstAnnos);
              FreeAndNil(req);
            end;
          end;
        end;
      end;

      if modified_preview then
      begin
        for i := 0 to FCurrentContainer.Count - 1 do
        begin
          if FCurrentContainer[i].modified_preview then
          begin
            req := TbfaRequest.Create;
            SendSocket := TSocketConnection.Create(bfaServerNoSSL, bfaServer, bfaServerPort, '');
            try
              SendSocket.CreateComponents;
              if SendSocket.Connect then
              begin
                req.ReqType := 'reqSavePreview';
                req.UserID := user.ID;
                req.Profile := Self.Profile;
                req.Gdocid := FCurrentContainer[i].Id;
                req.Lang := Lang;
                req.DataType := '.tif';   // Previews sind immer Tif, egal was die Ursprungsdatei war

                if (FCurrentContainer[i].ScanPoolView <> nil) and (FCurrentContainer[i].ScanPoolViewchanged) then
                begin
                  FCurrentContainer[i].DocStream.Clear;
                  FCurrentContainer[i].ScanPoolView.MIO.SaveToStreamTIFF(FCurrentContainer[i].DocStream);
                  FCurrentContainer[i].ScanPoolViewchanged := False;
                end;

                req.DataLen := FCurrentContainer[i].DocStream.Size;
                req := SendSocket.SendDataToServer(req, FCurrentContainer[i].DocStream, AThread);

                if req = nil then
                  Exit;

                if req.ReqType = 'respAuthError' then
                begin
                  BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
                  UserAction := CreateUserAction;
                  UserAction^.ActionName := 'actRelogin';
                  MainThread.Add(UserAction);
                  Exit;
                end
                else if (req.ReqType = 'respError') or (req.ReqType = 'respSaveError') then
                begin
                  BfShowMessage(_('Fehler beim Speichern.') + #13#10 + req.DataString, AThread);
                  CancelReq := True;
                  Exit;
                end;
              end;
            finally
              SendSocket.Disconnect;
              FreeAndNil(req);
              FreeAndNil(SendSocket);
            end;
          end;
        end;
      end;

      if modified_doc or modified_addfields or modified_statefields then
      begin
        AThread.Synchronize(nil,
          procedure
          var
            i, j, k: Integer;
          begin
            // Fall: Wir speichern nicht ber Buttons (Save, Reset)
            if not btnSaveClick and not btnResetClick and (modified_doc or modified_addfields or modified_statefields) then
            begin
              if FCurrentContainer.Count = 1 then
                msg := _('Sie haben nderungen am Dokument vorgenommen.\nSollen die nderungen gespeichert werden?')
              else
                msg := _('Sie haben nderungen vorgenommen.\nSollen die nderungen fr die ausgewhlten Dokumente gespeichert werden?');

              if BfMessageDlg(msg, mtConfirmation, [mbYes, mbNo], True) = mrYes then
                btnSaveClick := True;
            end;

            if btnSaveClick then
            begin
              param := '';
              if FCurrentContainer.Count > 1 then
              begin
                for i := 1 to FCurrentContainer.Count - 1 do
                begin
                  if (FCurrentContainer[i].ID <> -1) and (FCurrentContainer[i].InEditMode) then
                  begin
                    if param = '' then
                      param := IntToStr(FCurrentContainer[i].ID)
                    else
                      param := param + ';' + IntToStr(FCurrentContainer[i].ID);
                  end;
                end;
              end;

              req := TbfaRequest.Create;
              Lst := TList<TbfaBaseObject>.Create;
              LstAddfields := TList<TbfaAddField>.Create;
              try
                req.ReqType := 'reqSave';
                req.UserID := user.ID;
                req.Profile := Self.Profile;
                req.Parameter := param;
                req.Gdocid := FCurrentContainer[0].ID;
                req.Arcid := FCurrentContainer[0].ArcID;
                // sind wir in der Wiedervorlage und der Viewertab ist aktiv
                // dann geben wir die WVL Arcid mit, zur Prfung der Feldberechtigungen
                if ((CurrentView = tvkResub) and (PreviewContainer.ActiveItem = 0)) then
                  req.Addfields_Arcid := CurrentResubArchive.Arcid
                else if (FCurrentContainer[0].ArcID <> bitfarmApp.CurrentViewerArchive.ArcID) then
                  req.Addfields_Arcid := bitfarmApp.CurrentViewerArchive.ArcID;

                if FCurrentContainer[0].SymbolicArcID > 0 then
                  req.SymbolicArcID := FCurrentContainer[0].SymbolicArcID;
                req.Lang := Lang;
                if modified_addfields then
                begin
                  for j := 0 to aCurrentAddfields.Count - 1 do
                    if aCurrentAddfields[j].Component.Modified then
                    begin
                      Lst.Add(aCurrentAddfields[j]);
                      tempfield := TbfaAddField.Create;
                      tempfield.Clone(aCurrentAddfields[j]);
                      LstAddfields.Add(tempfield);
                    end;
                end;
                if modified_statefields then
                begin
                  for j := 0 to aCurrentStatefields.Count - 1 do
                    if aCurrentStatefields[j].Component.Modified then
                      Lst.Add(aCurrentStatefields[j]);
                end;
                if FCurrentContainer[0].modified_annosdelete then
                begin
                  for j := 0 to FCurrentContainer[0].Annotations.Count - 1 do
                    if FCurrentContainer[0].Annotations[j].modified then
                    begin
                      if FCurrentContainer[0].Annotations[j].History.Count = 0 then
                      begin
                        cntdelete := 0;
                        for k := Low(FCurrentContainer[0].Annotations[j].ObjList) to High(FCurrentContainer[0].Annotations[j].ObjList) do
                        begin
                          if (FCurrentContainer[0].Annotations[j].ObjList[k].modified) then
                          begin
                            hst := SaveAnnoHistory(0, j, k, cntdelete);
                            FCurrentContainer[0].Annotations[j].History.Add(hst);
                          end;
                        end;

                        if cntdelete >= Length(FCurrentContainer[0].Annotations[j].ObjList) then
                        begin
                          hst := TbfaHistory.Create;
                          hst.Userid := FUser.ID;
                          hst.Gdocid := FCurrentContainer[0].Id;
                          hst.Date := Now();
                          hst.Taskid := 302;
                          hst.Value1 := IntToStr(FCurrentContainer[0].Annotations[j].Page + 1);
                          FCurrentContainer[0].Annotations[j].History.Add(hst);
                        end
                      end;

                      Lst.Add(FCurrentContainer[0].Annotations[j]);
                    end;
                end;
                if modified_expired then
                begin
                  if (Trunc(frmMainForm.dteSearch.compDateLow.Date) <= Trunc(Now())) and
                     not (IsEmptyDate(frmMainForm.dteSearch.compDateLow.Date))
                  then
                    BfShowMessage(_('Das Lschdatum muss mindestens auf morgen gesetzt sein.'))
                  else
                  begin
                    for j := 0 to FCurrentContainer.Count - 1 do
                    begin
                      Doc := TbfaDocument.Create;
                      Doc.ID := FCurrentContainer[j].Id;
//17.06.2024 SD -->bfacrm:ticket__show__38671
//bei der nderung des Lschungsdatums sollte der Benutzer nicht gendert werden
//                      Doc.UserID := FUser.ID;
                      Doc.UserID := FCurrentContainer[j].UserID;
//17.06.2024 SD <--bfacrm:ticket__show__38671
                      Doc.DocName := FCurrentContainer[j].DocName;
                      Doc.Expired_Modified := True;
                      Doc.Expired := frmMainForm.dteSearch.compDateLow.Date;
                      Doc.Expired_Setby := 0;   // vom Admin gesetzt
                      Doc.Expired_Userid := FUser.ID;
                      Doc.Modified := True;
                      hst := TbfaHistory.Create;
                      hst.Userid := FUser.ID;
                      hst.Gdocid := FCurrentContainer[j].Id;
                      hst.Date := Now();
                      hst.Taskid := 235;
                      try
                        if frmMainForm.dteSearch.compDateLow.Text <> '' then
                          hst.Value1 := DateToStr(frmMainForm.dteSearch.compDateLow.Date)
                        else
                          hst.Value1 := '';
                      except
                        hst.Value1 := '';
                      end;
                      Doc.History.Add(hst);

                      Lst.Add(Doc);
                    end;
                  end;
                end;

                req.Data := Lst;
                MainSocket.SendRequestToServer(req);
                req := MainSocket.ReceiveResponse(AThread);

                if req = nil then
                  Exit;

                if req.ReqType = 'respAuthError' then
                begin
                  BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'));
                  UserAction := CreateUserAction;
                  UserAction^.ActionName := 'actRelogin';
                  MainThread.Add(UserAction);
                  Exit;
                end
                else if (req.ReqType = 'respDenied') or (req.ReqType = 'respSaveDenied') then
                begin
                  BfShowMessage(_('Das Dokument ist schon von einem anderen Benutzer in Bearbeitung gesetzt.'));
                  Exit;
                end
                else if (req.ReqType = 'respError') or (req.ReqType = 'respSaveError') then
                begin
                  BfShowMessage(_('Fehler beim Speichern.') + #13#10 + req.DataString);
                  Exit;
                end
                else
                begin
                  if req.DataString <> '' then
                    BfShowMessage(req.DataString);
                  try
                    saved := True;

                    for i := 0 to FCurrentContainer.Count - 1 do
                    begin
                      if (FCurrentContainer[i].Id <> -1) and (FCurrentContainer[i].InEditMode) then
                        FCurrentContainer[i].modified_annosdelete := False;
                    end;

                    if GetActivePreview.SingleView.bgDelObj then
                      GetActivePreview.SingleView.bgDelObj := False;
                  except
                    Log.Write(llNormal, ltException, 'Cancel', ClassName);
                  end;
                end;
              finally
                FreeAndNil(Lst);
                FreeAndNil(req);
              end;

              if frmMainForm.dteSearch.Modified or frmMainForm.dteSearch.ModifiedHigh then
              begin
                frmMainForm.dteSearch.Modified := False;
                frmMainForm.dteSearch.ClearValue;
              end;

              try
                if modified_addfields then
                begin
                  for i := 0 to FCurrentContainer.Count - 1 do
                  begin
                    for j := 0 to aCurrentAddfields.Count - 1 do
                      if aCurrentAddfields[j].modified then
                      begin
                        aCurrentAddfields[j].modified := False;
                        aCurrentAddfields[j].OldValue := aCurrentAddfields[j].value;
                        if aCurrentAddfields[j].Component <> nil then
                        begin

                          aCurrentAddfields[j].Component.ClearValue;
                          aCurrentAddfields[j].Component.Value := aCurrentAddfields[j].value;

                          if (aCurrentAddfields[j].Typ = 2) and (aCurrentAddfields[j].options and 8 = 0) then
                          begin
                            if aCurrentAddfields[j].Component.compComboBox.DroppedDown then
                              aCurrentAddfields[j].Component.compComboBox.DroppedDown := False;
                            if (aCurrentAddfields[j].Component.Comboitems.IndexOf(aCurrentAddfields[j].value) = -1) then
                            begin
                              aCurrentAddfields[j].Component.Strings.Add(aCurrentAddfields[j].value);
                              aCurrentAddfields[j].Component.Comboitems.Add(aCurrentAddfields[j].value);
                            end;
                          end
                          else if (aCurrentAddfields[j].Typ = 3) and (aCurrentAddfields[j].options and 8 = 0) then
                          begin
                            slvalues := TStringList.Create;
                            try
                              slvalues.Delimiter := ';';
                              slvalues.StrictDelimiter := True;
                              slvalues.DelimitedText := aCurrentAddfields[j].value;
                              for k := 0 to slvalues.Count - 1 do
                              begin
                                if (aCurrentAddfields[j].Component.Comboitems.IndexOf(slvalues[k]) = -1) then
                                begin
                                  aCurrentAddfields[j].Component.Strings.Add(slvalues[k]);
                                  aCurrentAddfields[j].Component.lstCheckedListbox.Items.Add.Text := slvalues[k];
                                end;
                              end;
                            finally
                              FreeAndNil(slvalues);
                            end;
                          end;
                          aCurrentAddfields[j].Component.Reset;

                        end;
                        for k := 0 to FCurrentContainer[i].AddFields.Count - 1 do
                        begin
                          if FCurrentContainer[i].AddFields[k].Id = aCurrentAddfields[j].Id then
                          begin
                            FCurrentContainer[i].AddFields[k].value := aCurrentAddfields[j].value;
                            FCurrentContainer[i].AddFields[k].OldValue := aCurrentAddfields[j].value;

                            if FCurrentContainer[i].AddFields[k].Component <> nil then
                            begin
                              FCurrentContainer[i].AddFields[k].Component.Reset;
                              FCurrentContainer[i].AddFields[k].Component.ClearValue;
                              FCurrentContainer[i].AddFields[k].Component.Value := aCurrentAddfields[j].value;
                            end;
                            Break;
                          end;
                        end;
                      end
                      else
                      begin
                        if aCurrentAddfields[j].Component <> nil then
                          aCurrentAddfields[j].Component.Reset;
                      end;
                  end;
                end;
                if modified_statefields then
                begin
                  for i := 0 to FCurrentContainer.Count - 1 do
                  begin
                    for j := 0 to aCurrentStatefields.Count - 1 do
                      if aCurrentStatefields[j].modified then
                      begin
                        aCurrentStatefields[j].modified := False;
                        aCurrentStatefields[j].OldValue := aCurrentStatefields[j].value;
                        if aCurrentStatefields[j].Component <> nil then
                        begin
                          aCurrentStatefields[j].Component.ClearValue;
                          if aCurrentStatefields[j].value then
                            aCurrentStatefields[j].Component.Value := fsSet
                          else
                            aCurrentStatefields[j].Component.Value := fsNone;
                        end;
                        for k := 0 to FCurrentContainer[i].StateFields.Count - 1 do
                        begin
                          if FCurrentContainer[i].StateFields[k].Id = aCurrentStatefields[j].Id then
                          begin
                            FCurrentContainer[i].StateFields[k].value := aCurrentStatefields[j].value;
                            if FCurrentContainer[i].StateFields[k].Component <> nil then
                            begin
                              FCurrentContainer[i].StateFields[k].Component.ClearValue;
                              if aCurrentStatefields[j].value then
                                FCurrentContainer[i].StateFields[k].Component.Value := fsSet
                              else
                                FCurrentContainer[i].StateFields[k].Component.Value := fsNone;
                            end;
                            Break;
                          end;
                        end;
                      end
                      else   // wenn das Statusfeld nicht gendert wurde, aber seinen Zustand verndert hat
                      begin      // wird es wohl keine Berechtigung zum ndern gegeben haben
                                 // daher setzen wir es zurck auf den alten Zustand
                        if aCurrentStatefields[j].value <> aCurrentStatefields[j].OldValue then
                        begin
                          aCurrentStatefields[j].value := aCurrentStatefields[j].OldValue;
                          if aCurrentStatefields[j].Component <> nil then
                          begin
                            aCurrentStatefields[j].Component.ClearValue;
                            if aCurrentStatefields[j].value then
                              aCurrentStatefields[j].Component.Value := fsSet
                            else
                              aCurrentStatefields[j].Component.Value := fsNone;
                          end;
                          for k := 0 to FCurrentContainer[i].StateFields.Count - 1 do
                          begin
                            if FCurrentContainer[i].StateFields[k].Id = aCurrentStatefields[j].Id then
                            begin
                              FCurrentContainer[i].StateFields[k].value := aCurrentStatefields[j].value;
                              if FCurrentContainer[i].StateFields[k].Component <> nil then
                              begin
                                FCurrentContainer[i].StateFields[k].Component.ClearValue;
                                if aCurrentStatefields[j].value then
                                  FCurrentContainer[i].StateFields[k].Component.Value := fsSet
                                else
                                  FCurrentContainer[i].StateFields[k].Component.Value := fsNone;
                              end;
                              Break;
                            end;
                          end;
                        end;
                      end;
                  end;
                end;
              except
              end;
            end
            else
              CancelReq := True;
          end);
      end;

      if (not (modified_doc or modified_annos or modified_preview or modified_addfields or modified_statefields)) and FCurrentContainer[0].InEditMode then
        CancelReq := True;

    end;
  finally
    if not MandantoryError then
    begin
      if ((modified_doc or modified_annos or modified_preview or modified_addfields or modified_statefields) and (not CancelReq)) then
      begin
        {$IFDEF ENTERPRISE}
        try

          bitfarmLog.Write(llDebug, ltinfo, 'FSavePlugin: ' + FSavePlugin, ClassName);
          if (FSavePlugin <> '') then
          begin
            tlsljob := Tstringlist.create;
            MItem := nil;
            for i := 0 to frmMainForm.mnuPlugins.Count - 1 do
            begin
              if frmMainForm.mnuPlugins.Items[i].Caption = FSavePlugin then
              begin
                MItem := frmMainForm.mnuPlugins.Items[i];
                Break;
              end;
            end;

            if MItem <> nil then
            begin
              bitfarmLog.Write(llDebug, ltinfo, 'MItem <> nil', ClassName);
              lsmydir := BD.EnvTemp + '\Viewer\';
              listname := lsmydir + 'mylist' + inttostr(Random(99999));

              if not (directoryexists(lsmydir)) then
                mkDir(lsmydir);
              EmptyDirectory(lsmydir);
              lspname := MItem.Hint;
              liprefix := MItem.Tag;
              lsparams := bitfarmApp.PluginsArray[liprefix].Parameters;

              for i := 0 to FCurrentContainer.Count - 1 do
              begin
                if ((aSysArc[FCurrentContainer[i].arcid].options and cArchivOptPlugin) <> 0) then
                begin
                  DateTimeToString(lsdname, 'ddmmyyyyhhnnss', now());
                  lsdname := lsdname + inttostr(Random(99999));
                  FCurrentContainer[i].Loaded := False;   // wir mssen das Document in WriteJobFile neu laden lassen,
                                                          // da sich zB durch Statusfelder mit Funktion auch die Zusatzfelder gendert haben knnen
                  WriteJobFile(lsmydir + lsdname + '.JOB', true, 0, FCurrentContainer[i]);
                  tlsljob.add(lsmydir + lsdname + '.JOB');
                end;
              end;
              if tlsljob.Count > 0 then
              begin
                tlsljob.SaveToFile(listname);
                RunSavePlugin := True;
              end
              else
                FreeAndNil(tlsljob);
            end;
          end;
          if RunSavePlugin then
          begin
            try
              PluginResult := RunPlugin(AThread, liprefix, lspname, listname, tlsljob);
              for i := 0 to FCurrentContainer.Count - 1 do
              begin
                WritePluginHistory(AThread, lspname, PluginResult, FCurrentContainer[i]);
              end;
            finally
              FreeAndNil(tlsljob);
            end;
          end;
        except
          bitfarmLog.Write(llNormal, ltException, 'DoSave - SavePlugin', ClassName);
        end;
        {$ENDIF}
      end;
//26.07.2017 <--

      // TODO -o b.takacs : zu prfen warum sich Reset bei Dokumenten im Edit-Mode anders verhlt.
      //                  : dafr muss die ViewerOption automatisch zur Voransicht wechselen aktiv sein
      //                  : -> Der Viewer wechselt bei Dokumenten die nicht im Edit-Mode sind nicht
      //                  :    zurck in den Voransichts-Tab
      if (modified_doc or modified_addfields or modified_statefields or modified_annos or modified_preview or CancelReq) then
      begin
        bitfarmLog.Write(llDebug, ltInfo, 'DoSave - DoCancelRequest - FCurrentContainer[0].ID: ' + IntToStr(FCurrentContainer[0].Id) + ', InEditMode = True', ClassName);

        if CallActCancel then // SJ 13.05.2022 - ticket__show__20349 - siehe oben bei CallActCancel :=
          frmMainForm.actCancel.Execute
        else
          DoCancelRequest(FCurrentContainer[0], AThread, True, False);

        ReloadCurrentDocs(AThread);
        AThread.Synchronize(nil,
          procedure
          begin
            ShowDocumentProperties(FCurrentContainer[0], FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview);
          end);
      end;

      if saved then
        if ((FSearchObj.SearchType in [1,2,3]) and FSearchObj.DontRefreshDataSet) then
          UpdateGridWithFields(Athread, LstAddfields)
        else
          RefreshGrid(AThread);
    end;

    // bfacrm:ticket__show__28598
    AThread.Synchronize(nil,
      procedure
      begin
        with FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.SingleView.img_DocView do
        begin
          CancelInteracts;
          DeSelect;
          UnSelAllObjects;
          MouseInteractVt := [];
          MouseInteract := [miscroll];
        end;

        try
          if (FCurrentContainer.Count > 0) and (FPreviewContainer.Containers.Count > 0) and
             (FPreviewContainer.ActiveItem <> -1) and
             Assigned(FPreviewContainer.Containers[FPreviewContainer.ActiveItem]) and
             Assigned(FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview)
             and (not ViewerOptions.EditorOptions.RememberLastTool)
          then
            FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.tbi_normalmouseClick(nil); //18.07.2018 Ticket 14803
        except
          bitfarmLog.Write(llNormal, ltException, 'DoSave - tbi_normalmouseClick', ClassName);
        end;
      end);

    FDoSave := False;
    if Assigned(Data) and (Data^.Actionname <> 'actCallDoSave') then
      Dispose(Data);
    bitfarmLog.DebugEnd(llDebug, 'DoSave', ClassName);
  end;
end;

procedure TbfaApplication.FillFieldsWithSearchObject(SObj: TbfaSearch);

  procedure SetComboItem(Cb: TbfaComboBox; ID: Int64);
  var
    i: Integer;
    found: Boolean;
  begin
    i := 0;
    found := False;
    while ((not found) and (i <= Cb.Properties.Items.Count - 1)) do
    begin
      if ID = Int64(Cb.Properties.Items.Objects[i]) then
        found := True
      else
        inc(i);
    end;
    if (not found) then
      Cb.ItemIndex := -1
    else
      Cb.ItemIndex := i;
  end;

  procedure SetAddField(ID: Int64; ValueLow, ValueHigh: Variant; Negated: Boolean);
  var
    i: Integer;
    found: Boolean;
  begin
    i := 0;
    found := False;
    while ((not found) and (i <= aCurrentAddfields.Count - 1)) do
    begin
      if ID = aCurrentAddfields[i].ID then
        found := True
      else
        inc(i);
    end;

    if found then
    begin
      case aCurrentAddfields[i].Typ of
        0:
          begin
            if not VarIsNull(ValueLow) then
              aCurrentAddfields[i].Component.compEdit.Text := ValueLow;
          end;
        1:
          begin
            if not VarIsNull(ValueLow) then
              aCurrentAddfields[i].Component.compDateLow.Date := VarToDateTime(ValueLow);
            if not VarIsNull(ValueHigh) then
              aCurrentAddfields[i].Component.compDateHigh.Date := VarToDateTime(ValueHigh);
          end;
        2:
          begin
            if not VarIsNull(ValueLow) then
            begin
              aCurrentAddfields[i].Component.compComboBox.Text := ValueLow;
              aCurrentAddfields[i].Component.compComboBox.Properties.OnChange(aCurrentAddfields[i].Component);
            end;
          end;
        3:
          begin
            if not VarIsNull(ValueLow) then
            begin
              aCurrentAddfields[i].Component.compCheckedCombo.Text := ValueLow;
//            aCurrentAddfields[i].Component.compCheckedCombo.
//              OnChange(aCurrentAddfields[i].Component);
//            addfield.OnComboClick := frmMainForm.OnCheckListClick;
            end;
          end;
        5:
          begin
            if not VarIsNull(ValueLow) then
              aCurrentAddfields[i].Component.compSpinEditLow.Text := ValueLow;
            if not VarIsNull(ValueHigh) then
              aCurrentAddfields[i].Component.compSpinEditHigh.Text := ValueHigh;
        //    addfield := TBfaAddfieldComp.Create(frmMainForm.scrbxAddfields, zfld05_Intervall);
          end;
        6:
          begin
            if not VarIsNull(ValueLow) then
              aCurrentAddfields[i].Component.compSpinEditLow.Text := ValueLow;
            if not VarIsNull(ValueHigh) then
              aCurrentAddfields[i].Component.compSpinEditHigh.Text := ValueHigh;
      //      addfield := TBfaAddfieldComp.Create(frmMainForm.scrbxAddfields, zfld06_GanzZahl);
          end;
        7:
          begin
            if not VarIsNull(ValueLow) then
              aCurrentAddfields[i].Component.compSpinEditLow.Text := ValueLow;
            if not VarIsNull(ValueHigh) then
              aCurrentAddfields[i].Component.compSpinEditHigh.Text := ValueHigh;
    //      addfield := TBfaAddfieldComp.Create(frmMainForm.scrbxAddfields, zfld07_FliessKomma);
          end;
        8:
          begin
            if not VarIsNull(ValueLow) then
              aCurrentAddfields[i].Component.compSpinEditLow.Text := ValueLow;
            if not VarIsNull(ValueHigh) then
              aCurrentAddfields[i].Component.compSpinEditHigh.Text := ValueHigh;
  //          addfield := TBfaAddfieldComp.Create(frmMainForm.scrbxAddfields, zfld08_Waehrung);
          end;

      end;

      if Negated then
        aCurrentAddfields[i].Component.cliNeg.Click;
    end;

  end;

  procedure SetStsField(ID: Int64; Value: Variant);
  var
    i: Integer;
    found: Boolean;
  begin
    i := 0;
    found := False;
    while ((not found) and (i <= aCurrentStatefields.Count - 1)) do
    begin
      if ID = aCurrentStatefields[i].ID then
        found := True
      else
        inc(i);
    end;

    if found then
    begin
      if Value then
        aCurrentStatefields[i].Component.SetValueAsClick(fsSet)
      else
        aCurrentStatefields[i].Component.SetValueAsClick(fsUnSet);

      aCurrentStatefields[i].Component.Modified := True;
    end;

  end;

var
  i: Integer;
begin
  try
    bitfarmLog.DebugBegin(llDebug, 'FillFieldsWithSearchObject', ClassName);
    try
      if CurrentView = tvkViewer then
      begin
        aCurrentAddfields := aCurrentViewerAddfields;
        aCurrentStatefields := aCurrentViewerStatefields;
      end
      else if CurrentView = tvkResub then
      begin
        aCurrentAddfields := aCurrentResubAddfields;
        aCurrentStatefields := aCurrentResubStatefields;
      end;

      if SObj.FtxFields <> 0 then // Volltext Suche
      begin
        if SObj.FtxFields = 1 then // nur Volltext
          frmMainForm.tbiSoFtx.Click
        else if SObj.FtxFields = 1 then // nur Schlagwrter
          frmMainForm.tbiSoTags.Click
        else if SObj.FtxFields = 3 then // Schlagwrter und Volltext
          frmMainForm.tbiSoFtxTags.Click;

        if (not VarIsNull(SObj.SearchString)) then
        begin
          frmMainForm.edtSearchFTX.compEdit.Text := SObj.SearchString;
          if SObj.SearchStringNegated then
            frmMainForm.edtSearchFTX.cliNeg.Click;
        end;
      end;

      if ((SObj.SearchUserID > -1) or (not VarIsNull(SObj.SearchUser))) then
      begin
        frmMainForm.tbiSoUser.Click;
        if not VarIsNull(SObj.SearchUser) then
          frmMainForm.cbxSearchUser.compComboBox.Text := SObj.SearchUser
        else
          SetComboItem(frmMainForm.cbxSearchUser.compComboBox, SObj.SearchUserID);

        frmMainForm.cbxSearchUser.compComboBox.Properties.OnChange(frmMainForm.cbxSearchUser);

        if SObj.SearchUserNegated then
          frmMainForm.cbxSearchUser.cliNeg.Click;
      end;

      if ((SObj.SearchGroupID > -1) or (not VarIsNull(SObj.SearchGroup))) then
      begin
        frmMainForm.tbiSoGroup.Click;
        if not VarIsNull(SObj.SearchGroup) then
          frmMainForm.cbxSearchUser.compComboBox.Text := SObj.SearchGroup
        else
          SetComboItem(frmMainForm.cbxSearchUser.compComboBox, SObj.SearchGroupID);

        frmMainForm.cbxSearchUser.compComboBox.Properties.OnChange(frmMainForm.cbxSearchUser);

        if SObj.SearchGroupNegated then
          frmMainForm.cbxSearchUser.cliNeg.Click;
      end;

      if ((not VarIsNull(SObj.SearchDate)) or (not VarIsNull(SObj.SearchDateHigh))) then
      begin
//        if SObj.UseModifiedDate then
//          frmMainForm.tbiSoModified.Click
//        else
//          frmMainForm.tbiSoArchived.Click;

        if (SObj.SearchDateType and 4) = 4 then
          frmMainForm.tbiSoArchived.Click;
        if (SObj.SearchDateType and 8) = 8 then
          frmMainForm.tbiSoModified.Click;
        if (SObj.SearchDateType and 1024) = 1024 then
          frmMainForm.tbiSoExpired.Click;

        if (not VarIsNull(SObj.SearchDate)) then
          frmMainForm.dteSearch.compDateLow.Date := VarToDateTime(SObj.SearchDate);

        if (not VarIsNull(SObj.SearchDateHigh)) then
          frmMainForm.dteSearch.compDateHigh.Date := VarToDateTime(SObj.SearchDateHigh);

        if SObj.SearchDateNegated then
          frmMainForm.dteSearch.cliNeg.Click;
      end;

      if (not VarIsNull(SObj.DocName)) then
      begin
        frmMainForm.tbiSoTitle.Click;
        frmMainForm.cbxSearchLinks.compComboBox.Text := SObj.DocName;
        frmMainForm.cbxSearchLinks.compComboBox.Properties.OnChange(frmMainForm.cbxSearchLinks);
        if SObj.DocNameNegated then
          frmMainForm.cbxSearchLinks.cliNeg.Click;
      end;

      if (not VarIsNull(SObj.RefSearch)) then
      begin
        frmMainForm.tbiSoLinks.Click;
        frmMainForm.cbxSearchLinks.compComboBox.Text := SObj.RefSearch;
        frmMainForm.cbxSearchLinks.compComboBox.Properties.OnChange(frmMainForm.cbxSearchLinks);
        if SObj.RefSearchNegated then
          frmMainForm.cbxSearchLinks.cliNeg.Click;
      end;

      if (not VarIsNull(SObj.FileType)) then
      begin
        frmMainForm.tbiSoType.Click;
        frmMainForm.cbxSearchLinks.compComboBox.Text := SObj.Filetype;
        frmMainForm.cbxSearchLinks.compComboBox.Properties.OnChange(frmMainForm.cbxSearchLinks);
        if SObj.FileTypeNegated then
          frmMainForm.cbxSearchLinks.cliNeg.Click;
      end;

      if SObj.AddFields.Count > 0 then
      begin
        for i := 0 to SObj.AddFields.Count - 1 do
        begin
          SetAddField(SObj.AddFields[i].Id, SObj.AddFields[i].value, SObj.AddFields[i].ValueHigh, SObj.AddFields[i].Negate);
        end;
      end;

      if SObj.StsFields.Count > 0 then
      begin
        for i := 0 to SObj.StsFields.Count - 1 do
        begin
          SetStsField(SObj.StsFields[i].Id, SObj.StsFields[i].value);
        end;
      end;

      if SObj.MaxValues > 0 then
      begin
        if StrToInt(frmMainForm.tbiLimit1.Caption) = SObj.MaxValues then
          frmMainForm.tbiLimit1.Click
        else if StrToInt(frmMainForm.tbiLimit10.Caption) = SObj.MaxValues then
          frmMainForm.tbiLimit10.Click
        else if StrToInt(frmMainForm.tbiLimit100.Caption) = SObj.MaxValues then
          frmMainForm.tbiLimit100.Click
        else if StrToInt(frmMainForm.tbiLimit500.Caption) = SObj.MaxValues then
          frmMainForm.tbiLimit500.Click
        else if StrToInt(frmMainForm.tbiLimit1000.Caption) = SObj.MaxValues then
          frmMainForm.tbiLimit1000.Click
        else if StrToInt(frmMainForm.tbiLimit5000.Caption) = SObj.MaxValues then
          frmMainForm.tbiLimit5000.Click
        else if StrToInt(frmMainForm.tbiLimit50.Caption) = SObj.MaxValues then
          frmMainForm.tbiLimit50.Click;
      end
      else
        frmMainForm.tbiLimitAll.Click;

      if (user.isAdmin) and Assigned(frmMainForm.grbxSqlWhere) then
      begin
        if not VarIsNull(SObj.SQLWhere) and (SObj.SQLWhere <> '') then
        begin
          frmMainForm.mmoSqlWhere.Clear;
          frmMainForm.mmoSqlWhere.Text := SObj.SQLWhere;
        end
        else
          frmMainForm.mmoSqlWhere.Clear;
        frmMainForm.chkSQLWhereConstructive.Checked := SObj.Constructive;
        frmMainForm.chkSQLWhereOr.Checked := SObj.SQLWhereOperator = 'or';
      end;
    except
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'FillFieldsWithSearchObject', ClassName);
  end;
end;

procedure TbfaApplication.FillMyTasksSearch(fraResub: TfraResub; GridView: TbfaGridDBTableView; var SObj: TbfaSearch);
begin
  SObj.Reset;
  SObj.ID := 1;
  SObj.Name := _('eigene Wiedervorlage');
  SObj.ResubDateHigh := FormatDateTime('yyyy-mm-dd', dateCWLastDay);
  SObj.UserContext := FUser.ID;
  SObj.SearchType := 4; // Wiedervorlage
  SObj.SelectedCols := SetSelectedColumns(True);
  if SObj.SelectedCols = '' then
    SObj.SelectedCols := 'gdocid';
  SObj.ResubState := 4;    // nicht fertig
  SObj.ResubStateNegated := True;
  SObj.ResubUserIDList := user.HolidayList.CommaText;
  SObj.GdocIDWithSymLink := False;
  if fraResub.MyTasksView = 0 then
    SObj.ResubNotState := 4   // offen und in Arbeit
  else if fraResub.MyTasksView = 1 then
  begin
    SObj.ResubNotState := 4;  // nicht in arbeit nicht fertig
    SObj.ResubAlarmHigh := FormatDateTime('yyyy-mm-dd', Now());
  end
  else if fraResub.MyTasksView = 2 then
  begin
    SObj.ResubState := 2;  // in Arbeit
    SObj.ResubNotState := 4; // nicht fertig
    SObj.ResubStateNegated := False;
  end
  else if fraResub.MyTasksView = 3 then
  begin
    SObj.ResubState := 4; // fertig
    SObj.ResubNotState := 16; // nicht weitergeleitet
    SObj.ResubStateNegated := False;
//  end
//  else if fraResub.MyTasksView = 4 then
//  begin
//    SObj.ResubNotState := 4; // offen und in Arbeit aller Mitarbeiter
//    SObj.ResubUserIDNegated := False;
//    if FUser.EmployeesList.Count > 0 then   //sanity, wir sollten eigentlich gar nicht erst in diese view kommen
//    begin                                   // ohne mitarbeiter
//      SObj.ResubControllerID := -1;
//      SObj.ResubUserIDList := FUser.EmployeesList.CommaText;
//    end;
  end;
  SetSearchOrder(SObj, GridView); //03.11.2022 Ticket 32729
end;

procedure TbfaApplication.BookmarkSearch(AThread: TThread; SObj: TbfaSearch);
var
  Params, SearchOrder: TStringList;
  Objects: TList;
  Node: TTreeNode;
  sqlwhere, gdocid: WideString;
  arcid: Integer;
  reg: TRegEx;
  match: TMatch;
  lmq: TUniQuery;
  BookmarkSObj: TbfaSearch;
  RestoreTreeViewKind: Boolean;
begin
//  if bitfarmApp.ExportMode then
//  begin
//    BfShowMessage('Lesezeichen im Export-Modus derzeit noch nicht untersttzt.', AThread);
//    Exit;
//  end;

  Log.DebugBegin(llDebug, 'BookmarkSearch', ClassName);
  fDocumentSearch := True;
  fSkipAutoDisplay := True; //21.12.2022 Ticket 33320
  frmMainForm.FViewerTreeview.ChangeDelay := 0;
  arcid := 0;
  RestoreTreeViewKind := False;
  try
    try
//      Reset(AThread);
      ResetViewer(AThread); // SJ 14.07.2023 - bfacrm:ticket__show__35313

      try
        if (not VarIsNull(SObj.SQLWhere)) and (pos('sd.gdocid', SObj.SQLWhere) > 0) then
        begin
          reg := TRegEx.Create('sd.gdocid = (\d*)');
          match := reg.Match(SObj.SQLWhere);
          if match.Success then
          begin
            gdocid := match.Groups[1].value;
          end else begin
            reg := TRegEx.Create('sd.gdocid in \(([0-9,]*)\)');
            match := reg.Match(SObj.SQLWhere);
            if match.Success then
              gdocid := match.Groups[1].value;
          end;

          lmq := DbCreateQuery;
          try
            lmq.SQL.Text := 'select arcid from sys_doc where gdocid in (' + gdocid + ')';
            lmq.Execute;
            if lmq.RecordCount > 0 then
            begin
              lmq.First;
              while not lmq.Eof do
              begin
                arcid := lmq.FieldByName('arcid').AsInteger;
                lmq.Next;
              end;
            end;
          finally
            lmq.Free;
          end;
        end;

        AThread.Synchronize(nil,
          procedure
          begin
            if SObj.SelectedArcID > 0 then
            begin
              SelectNodeByID(frmMainForm.FViewerTreeview, SObj.SelectedArcID);
              frmMainForm.FViewerTreeview.LastSelected := SObj.SelectedArcID; //28.06.2019 sonst wird beim Archivwechseln actChangeArchive bersprungen
            end
            else if SObj.SelectedArcID = 0 then    // aktuelles Archiv
            begin
              SObj.SelectedArcID := PbfaInt64(frmMainForm.FViewerTreeview.Selected.Data).Value;
              frmMainForm.FViewerTreeview.LastSelected := sobj.SelectedArcID; //28.06.2019 sonst wird beim Archivwechseln actChangeArchive bersprungen
            end
            else if arcid > 0 then
            begin
              SelectNodeByID(frmMainForm.FViewerTreeview, arcid);
              frmMainForm.FViewerTreeview.LastSelected := arcid; //28.06.2019 sonst wird beim Archivwechseln actChangeArchive bersprungen
            end
            else
            begin
              SelectNodeByID(frmMainForm.FViewerTreeview, 1);
              frmMainForm.FViewerTreeview.LastSelected := 1; //28.06.2019 sonst wird beim Archivwechseln actChangeArchive bersprungen
            end;

          end);

        if (SObj.SelectedArcID > 0) and (SObj.SelectedArcID <= High(aSysArc)) then
        begin
          if aSysArc[SObj.SelectedArcID].Typ = 0 then  //lager
          begin
            SObj.ArcID := bitfarmApp.GetArcids(SObj.SelectedArcID, bitfarmApp.User.ID);
      //            if ArcID.Count = 0 then
      //              ArcID.Add(IntToStr(aSysArc[0].Arcid));
            if SObj.ArcID.IndexOf(IntToStr(SObj.SelectedArcID)) = -1 then
              SObj.ArcID.Add(IntToStr(SObj.SelectedArcID));

          end
          else
            SObj.ArcID.CommaText := IntToStr(SObj.SelectedArcID);
        end;

        if (bitfarmApp.CurrentView <> tvkViewer) and (bitfarmApp.CurrentView <> tvkFavorites) then
          SetViewAndArchive(AThread, tvkViewer);

        Params := TStringList.Create();
        Node := frmMainForm.FViewerTreeview.Selected;
        Objects := TList.Create;

        // das ist nur die halbe Lsung
        // SJ 26.09.2022 - bfacrm:ticket__show__32292 + bfacrm:ticket__show__32387
        // ChangeArchive setzt tvkViewer. Bei ChangeBookmark wird auf tvkFavorites geprft.
        // also zurck setzen...
        //RestoreTreeViewKind := (bitfarmApp.CurrentView = tvkFavorites);

        Params.Add(GetEnumName(TypeInfo(TbfaViewKind), integer(CurrentView)));   // wir bleiben auf der CurrentView
        //Params.Add(GetEnumName(TypeInfo(TbfaViewKind), integer(frmMainForm.FViewerTreeview.ViewKind)));
        Params.Add(IntToStr(frmMainForm.FViewerTreeview.LastSelected));
        Params.Add(GetEnumName(TypeInfo(TbfaViewKind), integer(CurrentView)));  // und wir kommen von der CurrentView
        //Params.Add(GetEnumName(TypeInfo(TbfaViewKind), integer(tvkFavorites)));
        Objects.Add(Node);
        bitfarmLog.Write(llNormal, ltDebug, 'BookmarkSearch vor ChangeArchive', ClassName);

        ChangeArchive(Params, Objects, AThread);

        //03.03.2023 Ticket 34076 -->
        //sonst kann passieren, dass beim wechseln zum Lager und Archive die Zusatfelder nicht vom ausgewhlten Archiv kommen!
        aCurrentViewerAddfields := CloneAddfields(aCurrentAddfields);
        aCurrentViewerStatefields := CloneStatefields(aCurrentStatefields);
        //03.03.2023 Ticket 34076 <--


        // SJ 26.09.2022 - bfacrm:ticket__show__32292 + bfacrm:ticket__show__32387
        //if RestoreTreeViewKind then
          //bitfarmApp.CurrentView := tvkFavorites;

      finally
        FreeAndNil(Params);
        FreeAndNil(Objects);
      end;

      AThread.Synchronize(nil,
        procedure
        begin
          frmMainForm.actSearch.Enabled := SObj.Constructive;
        end);

      SObj.UserContext := FUser.ID;

      if SObj.SearchType = 2 then  // globale Suche, wir fgen unsere HolidayList hinzu
        SObj.UserList.Assign(FUser.HolidayList);

      SObj.SelectedCols := SetSelectedColumns(False, False, SObj.SelectedCols);

      if pos('arcname', SObj.SelectedCols) = 0 then
        SObj.SelectedCols := SObj.SelectedCols + ', arcname';

      SetSearchOrder(SObj, frmMainForm.grdResultlistDevExView);

      if not VarIsNull(Sobj.Order) and (Sobj.Order <> '') then
      begin
        var i: Integer;
        var order: string;

        SearchOrder := TStringList.Create;
        SearchOrder.StrictDelimiter := True;
        SearchOrder.Sorted := True;
        SearchOrder.Duplicates := dupIgnore;
        SearchOrder.CommaText := Sobj.Order;

        for i := 0 to SearchOrder.Count -1 do
        begin
          order := SearchOrder[i];
          if Pos(' ', order) > 0 then
            order := LeftStr(order, Pos(' ', order) -1);
          if (Pos(order, SObj.SelectedCols) = 0) then
            SObj.SelectedCols := SObj.SelectedCols + ', ' + order;
        end;
        FreeAndNil(SearchOrder);
      end;

      if not VarIsNull(Sobj.Direction) and (Sobj.Direction <> '') then
        if not VarIsNull(Sobj.Order) and (Sobj.Order <> '') and (Pos(Sobj.Direction, Sobj.Order) = 0) then
        begin
          Sobj.Order := Sobj.Order + ' '+ Sobj.Direction;
          Sobj.Direction := null;
        end;

      if not VarIsNull(SObj.SQLWhere) then
        ParseSQLWhereSObj(Sobj);

      // Fallback: falls wir ohne SearchType hier ankommen
      if not SObj.SearchType in [1, 2, 3] then
        SObj.SearchType := 1;

      AThread.Synchronize(nil,
        procedure
        begin
          frmMainForm.grdResultlistDevExView.Controller.ClearSelection;
        end);

      if (not ((frmMainForm.pnlFavorites.Maximized) or (frmMainForm.pnlTreeView.Maximized)))then
        frmMainForm.pnlTreeView.Maximize;

      if bitfarmApp.ExportMode then
        SObj.RightsMask := 524288;  // um Exportberechtigung erweitern im Exportmode

      if bitfarmApp.ExportMode then
        SObj.RightsMask := 524288;  // um Exportberechtigung erweitern im Exportmode

      FSearchObj.Clone(SObj);

      if (SObj.SearchType <> 3) then
      begin
        BookmarkSObj := TbfaSearch.Create;
        BookmarkSObj.Clone(SObj);
        BookmarkSObj.Constructive := BookmarkSObj.Constructive;
        BookmarkSObj.Date := FormatDateTime('dd.mm.yyyy hh:nn:ss', Now);
      end;

      {$IFDEF DISABLE_HISTORY_FUTURE_DELETE}
      StartSearchThread(SObj); //15.11.2022 Ticket

      if (SObj.SearchType <> 3) then
        AddToHistoryList(AThread, BookmarkSObj);
      {$ELSE}
      if (SObj.SearchType <> 3) then
        StartSearchThread(SObj, BookmarkSObj)
      else
        StartSearchThread(SObj);
      {$ENDIF}


      if (SObj.SearchType = 3) then
        AThread.Synchronize(nil,
          procedure
          begin
            // SJ 12.06.2023
            SetBlueArrows;
//            if (frmMainForm.trvBookmarks.Selected = FHistoryListNode.getFirstChild) then
//            begin
//              frmMainForm.actBack.Enabled := True;
//              frmMainForm.actForward.Enabled := False;
//            end
//            else
//            if (frmMainForm.trvBookmarks.Selected = FHistoryListNode.getLastChild) then
//            begin
//              frmMainForm.actBack.Enabled := False;
//              frmMainForm.actForward.Enabled := True;
//            end
//            else
//            if (GetRootNode(frmMainForm.trvBookmarks.Selected) <> FHistoryListNode) then
//            begin
//              frmMainForm.actBack.Enabled := False;
//              frmMainForm.actForward.Enabled := False;
//            end
//            else
//            begin
//              frmMainForm.actBack.Enabled := True;
//              frmMainForm.actForward.Enabled := True;
//            end;
            // SJ 12.06.2023
          end);
    except
      bitfarmLog.Write(llNormal, ltException, 'BookmarkSearch', ClassName);
    end;
  finally
    FreeAndNil(SObj);
    fDocumentSearch := False;
    fSkipAutoDisplay := False; //21.12.2022 Ticket 33320
    frmMainForm.FViewerTreeview.ChangeDelay := tvChangeDelay;
    bitfarmLog.DebugEnd(llDebug, 'BookmarkSearch', ClassName);
  end;
end;

//25.04.2019 Ticket 17436-->
procedure TbfaApplication.AddToHistoryList(AThread: TThread; SObj: TbfaSearch);
var
  Node: TTreeNode;
  ASearchObj: TbfaSearch;
begin
  begin
    try
      AThread.Synchronize(nil,
      procedure
        var
          n: Integer;
        begin
          // SJ: Clone notwendig, sonst gibts Probleme beim mehrfachen ausfhren des neu angelegten Verlaufslesezeichens
          ASearchObj := TbfaSearch.Create;
          ASearchObj.Clone(SObj);
          AddTreeviewNode(FLog, frmMainForm.trvBookmarks, FHistoryListNode, ASearchObj, 3, True);

          if FHistoryListNode.Count > FViewerOptions.SearchOptions.HistoryBookmarkLimit then
          begin
            for n := FHistoryListNode.Count - 1 downto FViewerOptions.SearchOptions.HistoryBookmarkLimit do
            begin
              if TbfaSearch(FHistoryListNode[n].Data) <> nil then
                TbfaSearch(FHistoryListNode[n].Data).Free;
              FHistoryListNode[n].Delete;
            end;
          end;
//20.10.2020 Treeview flackert zu viel
//          //angezeigter Node ist erster Node
//          Node := FHistoryListNode.getFirstChild;
//          if Node <> nil then
//          begin
//            frmMainForm.trvBookmarks.Select(Node);
//          end;
          //06.05.2019 Ticket 19057
          //falls im letzten Node der History List gesucht wurde muss der Forward Button wieder gesetzt werden
          //(sonst sind beide Button grau)

          // <!-- SJ 12.06.2023
//          if not (frmMainForm.actBack.Enabled) then
//            frmMainForm.actBack.Enabled := True;
//          frmMainForm.actForward.Enabled := False;

          // wenn neue HistoryBookmark, setzen wir Auswahl zurck, damit das erste Verlaufs-Lesezeichen genommen wird
          // Auer wir sind im Bereich Lesezeichen.
          if CurrentView <> tvkFavorites then // nicht in Lesezeichen
            frmMainForm.trvBookmarks.Selected := nil;
          SetBlueArrows;
          // SJ 12.06.2023

          //08.05.2019 Ticket 19057
          //falls Reset noch gesetzt ist dann bei neuer Suche nicht mehr
          SelectFirstHistoryNode := False;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'AddToHistoryList', Classname);
    end;
  end;
end;
//25.04.2019 Ticket 17436<--

procedure TbfaApplication.SetSearchOrder(SObj: TbfaSearch; GridView: TbfaGridDBTableView);
var
  i: Integer;
  TmpOrderList: TStringList;
  TmpOrder, TmpGroupBy: string;
begin
  bitfarmLog.DebugBegin(llDebug, 'SetSearchOrder', ClassName);
  try
    SObj.Order := '';
    try
      TmpOrderList := TStringlist.Create;
      TmpGroupBy := '';

      if GridView.OptionsView.GroupByBox then
      begin
        for i := 0 to GridView.ColumnCount - 1 do
        begin
          if GridView.Columns[i].GroupIndex > -1 then
          begin
            TmpOrder := '';
            if GridView.Columns[i].DataBinding.FieldName = 'typ' then  //WVL Typ sollte nicht sortiert sein, ist nicht im SQL Select drin!
              Continue;

            if GridView.Columns[i].DataBinding.FieldName = 'docusername' then
              TmpOrder := TmpOrder + 'username'
            else
              TmpOrder := TmpOrder + GridView.Columns[i].DataBinding.FieldName;

            if GridView.Columns[i].SortOrder = soAscending then
              TmpOrder := TmpOrder + ' ASC'
            else
              TmpOrder := TmpOrder + ' DESC';

            TmpOrderList.AddPair(IntToStr(GridView.Columns[i].SortIndex), TmpOrder);
          end;
        end;
      end;

      for i := 0 to GridView.ColumnCount - 1 do
      begin
        if GridView.Columns[i].Visible and (GridView.Columns[i].SortOrder <> TdxSortOrder(soNone)) then
        begin
          TmpOrder := '';

          if GridView.Columns[i].DataBinding.FieldName = 'typ' then  //WVL Typ sollte nicht sortiert sein, ist nicht im SQL Select drin!
            Continue;

          if GridView.Columns[i].DataBinding.FieldName = 'docusername' then
            TmpOrder := TmpOrder + 'username'
          else
            TmpOrder := TmpOrder + GridView.Columns[i].DataBinding.FieldName;

          if GridView.Columns[i].SortOrder = soAscending then
            TmpOrder := TmpOrder + ' ASC'
          else
            TmpOrder := TmpOrder + ' DESC';

          TmpOrderList.AddPair(IntToStr(GridView.Columns[i].SortIndex), TmpOrder);
        end;
      end;

      TmpOrderList.Sort;
      for i := 0 to TmpOrderList.Count - 1 do
      begin
        if SObj.Order = '' then
          SObj.Order := TmpOrderList.ValueFromIndex[i]
        else
          SObj.Order := SObj.Order + ', ' + TmpOrderList.ValueFromIndex[i];
      end;

      SObj.Direction := '';

      //21.12.2022 Ticket 33370 -->
      if FViewerOptions.SearchOptions.DocModified then
      begin
        if pos('doc_modified', SObj.SelectedCols) = 0 then
          SObj.SelectedCols := SObj.SelectedCols + ', sd.modified AS doc_modified';
      end;
      //21.12.2022 Ticket 33370 <--
    finally
      FreeAndNil(TmpOrderList);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetSearchOrder', ClassName);
  end;
end;

procedure TbfaApplication.Search(AThread: TThread; SaveBookmark: Boolean = True);
var
  i, j, k, Code, Value: Integer;
  selcols, str, ParsedString: string;
  found: Boolean;
  sltemp, sl: TStringList;
  HistorySObj: TbfaSearch;
  UserAction: PUserAction;
  colarcid: Int64;
  tmpAddfield: TbfaAddField;
  ResubStatefield: TbfaStateField;

  function ParseForGdocLinks(strlist: TStringList): TStringList;
  begin
    var x, val: integer;
   if (strlist <> nil) and (strlist.Count > 0) then
     for x := 0 to strlist.Count - 1 do
      if (Lowercase(Copy(strlist[x], 1, 7)) = 'gdocid:') then
        strlist[x] := Copy(strlist[x], 8, Length(strlist[x]));
   Result := strlist;
  end;
begin
  bitfarmLog.DebugBegin(llDebug, 'Search', ClassName);
  try
    ResetViewer(AThread);

    with FSearchObj do
    begin
      AThread.Synchronize(nil,
        procedure
        begin
          frmMainForm.grdResultlistDevExView.Controller.ClearSelection;
        end);
      if (FSearchObj <> nil) and FSearchObj.Constructive then
      begin
        if not VarIsNull(FSearchObj.SQLWhere) and (FSearchObj.SQLWhere <> '') then
        begin
          FSearchObj.SQLWhere := '(' + FSearchObj.SQLWhere + ')';
        end;
      end
      else
      begin
        Reset;
        Id := 1;
        FSearchObj.UseSearch35 := bitfarmApp.FUseSearch35;
        Date := FormatDateTime('dd.mm.yyyy hh:nn:ss', Now);
        Name := Date;
        Order := 'docdate';
        Direction := 'DESC';

        SearchType := 0; // Normale Suche
        SelectedArcID := CurrentArchive.Arcid;
        if CurrentArchive.Typ = 0 then    //lager
        begin
          arcid := GetArcids(CurrentArchive.Arcid, user.ID);
          if arcid.Count = 0 then
            arcid.Add(IntToStr(aSysArc[0].arcid));
        end
        else
          arcid.CommaText := IntToStr(CurrentArchive.Arcid);

        UserContext := user.ID;
      end;

      val(frmMainForm.btnLimit.Caption, Value, Code);
      if Code <> 0 then
        MaxValues := -1
      else
        MaxValues := Value;

      if CurrentView = tvkResub then
      begin
//22.02.2022        if ResubKind = rkMyTasks then
        if frmMainForm.fraResub.ResubKind = rkMyTasks then
          FillMyTasksSearch(frmMainForm.fraResub, frmMainForm.grdResultlistDevExView, FSearchObj)
        else
          FillDelegateTasksSearch(frmMainForm.fraResub, frmMainForm.grdResultlistDevExView, FSearchObj);

        ResubDateHigh := NULL; //17.05.2018 Ticket von HS (wenn suchen geklickt, dann muss alle dargestellt werden und nicht nach Datum begrenzt!) 3.6.0.1041
      end;
      if Trim(frmMainForm.edtSearchFTX.compEdit.Text) <> '' then
      begin
        SearchString := Trim(frmMainForm.edtSearchFTX.compEdit.Text);
        FtxMatchAgainst := UseMatchAgainst;
        FtxBooleanMode := True;

        // wir durchsuchen alle Suchwrter, wenn eins mit % beginnt haben wir eine LIKE Suche
        sltemp := StrToWords4(SearchString);
        for i := 0 to sltemp.Count - 1 do
        begin
          if LeftStr(sltemp[i], 1) = '%' then
          begin
            FtxMatchAgainst := False;
            FtxBooleanMode := False;
            Break;
          end;
        end;
        FreeAndNil(sltemp);
        FtxFields := (frmMainForm.fSearchOption and 3);
        SearchStringNegated := (frmMainForm.edtSearchFTX.cliNeg.Color = gclRed);
      end
      else
        SearchString := '';

      if Trim(frmMainForm.cbxSearchUser.compComboBox.Text) <> '' then
      begin
        if (frmMainForm.fSearchOption and 16) = 16 then  // User
        begin
          SearchUserNegated := (frmMainForm.cbxSearchUser.cliNeg.Color = gclRed);
          SearchUserID := Int64(frmMainForm.cbxSearchUser.compComboBox.Properties.Items.Objects[frmMainForm.cbxSearchUser.compComboBox.ItemIndex]);
          if SearchUserID <= 0 then
            SearchUserID := DBGetUserID(frmMainForm.cbxSearchUser.compComboBox.Text);
        end
        else
        begin
          SearchGroupNegated := (frmMainForm.cbxSearchUser.cliNeg.Color = gclRed);
          SearchGroupID := Int64(frmMainForm.cbxSearchUser.compComboBox.Properties.Items.Objects[frmMainForm.cbxSearchUser.compComboBox.ItemIndex]);
          if SearchGroupID <= 0 then
            SearchGroupID := DBGetGroupID(frmMainForm.cbxSearchUser.compComboBox.Text);
        end;
      end
      else
      begin
        SearchUserNegated := False;
        SearchGroupNegated := False;
        SearchGroupID := -1;
        SearchUserID := -1;
      end;

      if frmMainForm.dteSearch.Modified or frmMainForm.dteSearch.ModifiedHigh then
      begin
        SearchDateNegated := (frmMainForm.dteSearch.cliNeg.Color = gclRed);
        if (frmMainForm.dteSearch.compDateLow.Text <> '') then
          SearchDate := FormatDateTime('yyyy-mm-dd', frmMainForm.dteSearch.compDateLow.Date)
        else
          SearchDate := '';
        if (frmMainForm.dteSearch.compDateHigh.Text <> '') then
          SearchDateHigh := FormatDateTime('yyyy-mm-dd', frmMainForm.dteSearch.compDateHigh.Date)
        else
          SearchDateHigh := '';
        SearchDateType := (frmMainForm.fSearchOption and 1036);  // damit holen wir uns aus den searchoptions einen der drei bits, die fr den datumstyp stehen
        //30.08.2024 SD -->bfacrm:ticket__show__39649
        //wichtig fr die korrekte Suche, wenn keine Suchdaten angegeben sind
        if (SearchDate = '') and (SearchDateHigh = '') then
        begin
          SearchDate := null;
          SearchDateHigh := null;
        end;
        //30.08.2024 SD <--bfacrm:ticket__show__39649
        end
      else
      begin
        SearchDateNegated := False;
        SearchDate := null;
        SearchDateHigh := null
      end;
      //03.09.2024 SD -->bfacrm:ticket__show__39649 Suchmodus
      DateDeletionSearch := ((CurrentView = tvkViewer) or (CurrentView = tvkResub)) and (frmMainForm.tbiSoExpired.Checked)
        and (frmMainForm.dteSearch.Modified or frmMainForm.dteSearch.ModifiedHigh);
      //03.09.2024 SD <--bfacrm:ticket__show__39649 Suchmodus

      // Zusatzfelder
      for i := 0 to aCurrentAddfields.Count - 1 do
      begin
        if aCurrentAddfields[i].Component <> nil then
        begin
          if aCurrentAddfields[i].Component.Modified or aCurrentAddfields[i].Component.ModifiedHigh then
          begin
            if aCurrentAddfields[i].Component.Modified then
            begin
              aCurrentAddfields[i].modified := True;
              if aCurrentAddfields[i].Typ = 3 then
              begin
                if pos(';', aCurrentAddfields[i].Component.Value) > 0 then
                begin // '""' muss raus, weil beim mehreren Werten mach kein sinn
                  sl := TStringList.Create;
                  try
                    sl.Delimiter := ';';
                    sl.StrictDelimiter := True;
                    sl.DelimitedText := aCurrentAddfields[i].Component.Value;
                    for j := sl.Count - 1 downto 0 do
                    begin
                      if (sl[j] = '""') or (sl[j] = '') then
                        sl.Delete(j);
                    end;
                    aCurrentAddfields[i].Value := sl.DelimitedText;
                  finally
                    FreeAndNil(sl);
                  end;
                end
                else
                  aCurrentAddfields[i].Value := aCurrentAddfields[i].Component.Value;
              end
              else
                aCurrentAddfields[i].Value := aCurrentAddfields[i].Component.Value;
              if aCurrentAddfields[i].Typ in [1, 12] then
              begin
                if aCurrentAddfields[i].Component.compDateLow.Text = '' then
                  aCurrentAddfields[i].Value := null;
              end
              else if aCurrentAddfields[i].Typ in [5, 6, 7, 8] then
              begin
                if aCurrentAddfields[i].Component.compSpinEditLow.Text = '' then
                  aCurrentAddfields[i].Value := null;
              end;
            end;

            if aCurrentAddfields[i].Component.ModifiedHigh then
            begin
              aCurrentAddfields[i].ModifiedHigh := True;
              case aCurrentAddfields[i].Typ of
                1, 12:
                  begin
                    if aCurrentAddfields[i].Component.compDateHigh.Text = '' then
                      aCurrentAddfields[i].ValueHigh := null;
                  end;
                6:
                  aCurrentAddfields[i].ValueHigh := aCurrentAddfields[i].Component.compSpinEditHigh.Text;
                7:
                  aCurrentAddfields[i].ValueHigh := aCurrentAddfields[i].Component.compSpinEditHigh.Text;
                8:
                  aCurrentAddfields[i].ValueHigh := aCurrentAddfields[i].Component.compSpinEditHigh.Text;
              end;
            end;

            aCurrentAddfields[i].ModifiedSearch := True;
            aCurrentAddfields[i].Negate := aCurrentAddfields[i].Component.Negate;

            found := False;
            for j := 0 to AddFields.Count -1 do
            begin
              if Addfields[j].Name = aCurrentAddfields[i].Name then
              begin
                found := True;
                Break;
              end;
            end;

            if found then
            begin
               Addfields[j].Clone(aCurrentAddfields[i]);
               Addfields[j].Items.Clear;
            end else begin
              tmpAddfield := TbfaAddField.Create;
              if aCurrentAddfields[i].Typ = 13 then
              begin
                for k := Low(aAddfields) to High(aAddfields) do
                begin
                  if aAddfields[k] = nil then
                    Continue;
                  if aAddfields[k].Name = aCurrentAddfields[i].Component.Searchfield then
                  begin
                    tmpAddfield.Clone(aAddfields[k]);
                    tmpAddfield.Value := ParseSearchfield(aCurrentAddfields[i].Component.edtGridSearch.Text);
                    tmpAddfield.ModifiedSearch := True;
                    tmpAddfield.Modified := True;
                    tmpAddfield.Negate := aCurrentAddfields[i].Component.Negate;
                    tmpAddfield.Mode := aCurrentAddfields[i].Mode;
                    Break;
                  end;
                end;
              end else
                tmpAddfield.Clone(aCurrentAddfields[i]);

              tmpAddfield.Items.Clear;
              AddFields.Add(tmpAddfield);
            end;
          end;

        end;
      end;

      SetSearchOrder(FSearchObj, frmMainForm.grdResultlistDevExView);

      if bitfarmApp.CurrentView = tvkViewer then
        colarcid := bitfarmApp.CurrentArchive.Arcid
      else if bitfarmApp.CurrentView = tvkImporter then
        colarcid := bitfarmApp.CurrentImportArchive.Arcid
      else if bitfarmApp.CurrentView = tvkResub then
        colarcid := bitfarmApp.CurrentResubFields;

      // Statusfelder
      for i := 0 to aCurrentStatefields.Count - 1 do
      begin
        if aCurrentStatefields[i].Component <> nil then
        begin
          if aCurrentStatefields[i].Component.Modified then
          begin
            aCurrentStatefields[i].Value := aCurrentStatefields[i].Component.Value = fsSet;
            aCurrentStatefields[i].modified := True;
            aCurrentStatefields[i].ModifiedSearch := True;
            StsFields.Add(aCurrentStatefields[i]);
          end;
        end;
      end;

      if Trim(frmMainForm.cbxSearchLinks.compComboBox.Text) <> '' then
      begin
        ParsedString := ParseAddfields(frmMainForm.cbxSearchLinks.compComboBox.Text);
        if frmMainForm.cbxSearchLinks.compComboBox.Text <> ParsedString then
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              frmMainForm.cbxSearchLinks.compComboBox.Text := ParsedString;
            end);
        end;

        if (frmMainForm.fSearchOption and 64) = 64 then // links
        begin
          RefSearch := ParsedString;
          RefSearchNegated := (frmMainForm.cbxSearchLinks.cliNeg.Color = gclRed);
        end
        else if (frmMainForm.fSearchOption and 128) = 128 then // Titel
        begin
          DocName := ParsedString;
          DocNameNegated := (frmMainForm.cbxSearchLinks.cliNeg.Color = gclRed);
        end
        else if (frmMainForm.fSearchOption and 256) = 256 then // Type
        begin
          FileType := ParsedString;
          FileTypeNegated := (frmMainForm.cbxSearchLinks.cliNeg.Color = gclRed);
        end
        else if (frmMainForm.fSearchOption and 512) = 512 then // GDocID
        begin
          gdocid.CommaText := ParsedString;
          gdocid := ParseForGdocLinks(gdocid);
          //12.07.2024 beim GDocID Suche sollte keine ArcID mitgeben werden-->
          SelectedArcID := -1;
          if ArcID.Count > 0 then
            ArcID.Clear;
          //12.07.2024 <--
        end;
      end
      else
      begin
        DocName := Null;
        DocNameNegated := False;
        RefSearch := NULL;
      end;

      if ((frmMainForm.edtGeneralSearch.Text <> '') and
          (frmMainForm.edtGeneralSearch.Text <> frmMainForm.edtGeneralSearch.Properties.NullString)) then
      begin
        if (((frmMainForm.edtSearchFTX.compEdit.Text = '') or
             (FViewerOptions.SearchOptions.UseOnlyGeneralSearchField)) and
           (FViewerOptions.SearchOptions.FulltextSearch or
            FViewerOptions.SearchOptions.DocTagsSearch or
           FViewerOptions.SearchOptions.AnnoTxtSearch or
           FViewerOptions.SearchOptions.FieldTxtSearch)) then
        begin
          FtxMatchAgainst := UseMatchAgainst;
          FtxBooleanMode := True;
          SearchString := frmMainForm.edtGeneralSearch.Text;
          FtxFields := 0;
          if FViewerOptions.SearchOptions.FulltextSearch then
            FtxFields := FtxFields + 1;
          if FViewerOptions.SearchOptions.DocTagsSearch then
            FtxFields := FtxFields + 2;
          if FViewerOptions.SearchOptions.AnnoTxtSearch then
            FtxFields := FtxFields + 4;
          if FViewerOptions.SearchOptions.FieldTxtSearch then
            FtxFields := FtxFields + 8;
        end;
      end;

      // bei einer MatchAgainst Suche mssen wir den Suchstring ggf noch korrigieren
      if FtxMatchAgainst then
        SearchString := ParseMatchAgainstString(SearchString);

      if Assigned(frmMainForm.grbxSqlWhere) then
      begin
        if (Trim(frmMainForm.mmoSqlWhere.Text) <> '') then
        begin
          sqlwhere := Trim(frmMainForm.mmoSqlWhere.Text);
          sqlwhere := ParseSQLString(sqlwhere);
          if frmMainForm.chkSQLWhereOr.Checked then
            SQLWhereOperator := 'or';
        end;
      end;

      selcols := SetSelectedColumns(CurrentView = tvkResub);
      if selcols <> '' then
        SelectedCols := selcols;

      if (SearchType = 0) and (CurrentView = tvkViewer) then
      begin
        if (pos('alarm', selcols) > 0) or (pos('info', selcols) > 0) or (pos('comment', selcols) > 0) then
        begin
          DeleteColumnOrder(AThread);
          Search(AThread, SaveBookmark);
          Exit;
        end;
      end;

      if ((not VarIsNull(bitfarmApp.FSearchObj.RefSearch)) and (bitfarmApp.FSearchObj.RefSearch <> '')) then
      begin
        if pos('arcname', SelectedCols) = 0 then
          SelectedCols := SelectedCols + ', arcname';
      end;

      GdocIDWithSymLink := False;

      if (SearchType = 0) and (FSearchInResub or FSearchInResubNegated) then  //09.05.2017 Ticket 10419
      begin
        ResubStatefield := TbfaStateField.Create;
        if FSearchInResub then
          ResubStatefield.Value := True;
        if FSearchInResubNegated then
          ResubStatefield.Value := False;
        ResubStatefield.DisplayName := _('auf Wiedervorlage');
        ResubStatefield.ID := 0;
        ResubStatefield.Bitmask := 1;
        ResubStatefield.Modified := True;
        ResubStatefield.ModifiedSearch := True;

        StsFields.Add(ResubStatefield);
      end;

    end;

    AddArchiveColumn(AThread, FSearchObj);

    if not VarIsNull(FSearchObj.SQLWhere) then
    begin
      ParseSQLWhereSObj(FSearchObj);
//      if pos('%username%', FSearchObj.SQLWhere) > -1 then
//        FSearchObj.SQLWhere := StringReplace(FSearchObj.SQLWhere, '%username%', bitfarmApp.User.Name, [rfReplaceAll]);
//      if pos('doctxt', FSearchObj.SQLWhere) > 0 then
//        FSearchObj.SelectedCols := FSearchObj.SelectedCols + ',doctxt';
//      if pos('doctags', FSearchObj.SQLWhere) > 0 then
//        FSearchObj.SelectedCols := FSearchObj.SelectedCols + ',doctags';
//      if pos('annotxt', FSearchObj.SQLWhere) > 0 then
//        FSearchObj.SelectedCols := FSearchObj.SelectedCols + ',annotxt';
    end;

    if bitfarmApp.ExportMode then
      FSearchObj.RightsMask := 524288;  // um Exportberechtigung erweitern im Exportmode

//    if (frmMainForm.edtGeneralSearch.Text <> sOrigSearchText) then
    if (frmMainForm.edtGeneralSearch.EditValue <> Null) then
    begin
      GetActivePreview.SearchbarTextEdit.Text := frmMainForm.edtGeneralSearch.Text;
    end else
    begin
      GetActivePreview.SearchbarTextEdit.Text := '';
      GetActivePreview.HistoryView.HistDataSet.Filter := '';
      GetActivePreview.HistoryView.HistDataSet.Filtered := False;
    end;

    if SaveBookmark then
    begin
      HistorySObj := TbfaSearch.Create;
      HistorySObj.Clone(FSearchObj);
      HistorySObj.Constructive := True;
      HistorySObj.Date := FormatDateTime('dd.mm.yyyy hh:nn:ss', Now);
      HistorySObj.Name := HistorySObj.Date;
    end;

    {$IFNDEF DISABLE_HISTORY_FUTURE_DELETE}
    StartSearchThread(FSearchObj, HistorySObj);
    {$ELSE}
    StartSearchThread(FSearchObj);

    if SaveBookmark then
    begin
      //25.04.2019 Ticket 17436 -->
      AddToHistoryList(AThread, HistorySObj);
    end;
    {$ENDIF}
  finally
    bitfarmLog.DebugEnd(llDebug, 'Search', ClassName);
  end;
end;

procedure TbfaApplication.AddArchiveColumn(AThread: TThread; SObj: TbfaSearch);
begin
  AThread.Synchronize(nil,
    procedure
    var
      k: Integer;
      found: Boolean;
    begin
      if (((not VarIsNull(SObj.RefSearch)) and (SObj.RefSearch <> '')) or (SObj.AboUserid > -1))
         or
         ((not VarIsNull(SObj.CheckOut)) and (SObj.CheckOut > -1))
      then
      begin
        found := False;
        for k := 0 to frmMainForm.grdResultlistDevExView.ColumnCount - 1 do
        begin
          if frmMainForm.grdResultlistDevExView.Columns[k].DataBinding.FieldName = 'arcname' then
          begin
            found := True;
            Break;
          end;
        end;

        if not found then
          frmMainForm.grdResultlistDevExView.CreateDBColumn('arcname', _('Archiv'), 'arcname', '', 150);
      end;

      if (not VarIsNull(SObj.CheckOut)) and (SObj.CheckOut > -1) then
      begin
        found := False;
        for k := 0 to frmMainForm.grdResultlistDevExView.ColumnCount - 1 do
        begin
          if frmMainForm.grdResultlistDevExView.Columns[k].DataBinding.FieldName = 'coutusername' then
          begin
            found := True;
            Break;
          end;
        end;

        if not found then
          frmMainForm.grdResultlistDevExView.CreateDBColumn('coutusername', _('Ausgecheckt'), 'coutusername', '', 150);
      end;
    end);
end;

procedure TbfaApplication.AddDocumentFields(Doc: TbfaDocument; AThread: TThread);
var
  addfieldcomp: TBfaAddfieldComp;
  statefieldcomp: TBfaStatefieldComp;
  Addfield: TbfaAddField;
  Statefield: TbfaStateField;
  found, seperator: Boolean;
  addid, stateid, edtTabOrder, pos, lastpos, lastpos2, ScrollbarWidth: Integer;
  sepcomp: TShape;
  AFrame: TFrame;
  sepitem: TTBSeparatorItem;
begin
  try
    AThread.Synchronize(nil,
      procedure
      var
        i, j, k, VertPos: Integer;
      begin
        try
          frmMainForm.scrbxViewerAddfields.Hide;
          try
          // SJ 06.10.2021 - AutoScroll fhrt dazu, dass die ScrollBox nach oben springt
            VertPos := frmMainForm.scrbxViewerAddfields.VertScrollBar.Position;
            frmMainForm.scrbxViewerAddfields.AutoScroll := False;

            if aCurrentAddfields.Count > 0 then
            begin
              for i := 0 to aCurrentAddfields.Count - 1 do
              begin
                if aCurrentAddfields[i].Assigned then  // assigned felder berspringen
                  Continue;
                try                                    // alle anderen lschen
                  addfieldcomp := aCurrentAddfields[i].Component;
                  DeleteAddCompFromArray(addfieldcomp);
                  addfieldcomp := nil;
                  if aCurrentAddfields[i].Component <> nil then
                  begin
                    try
                      aCurrentAddfields[i].Component.Free;
                    finally
                      aCurrentAddfields[i].Component := nil;
                    end;
                  end;
                  aCurrentAddfields[i].Component := nil;
                  try
                    aCurrentAddfields[i].Free;
                  finally
                    aCurrentAddfields[i] := nil;
                  end;
                except
                  bitfarmLog.Write(llNormal, ltException, 'DeleteAddfields - Free Comp', ClassName);
                end;
              end;
              if frmMainForm.scrbxViewerAddfields.ComponentCount > 0 then
              begin
                for i := frmMainForm.scrbxViewerAddfields.ComponentCount - 1 downto 0 do
//                  if frmMainForm.scrbxViewerAddfields.Components[i] is TBevel then
                  if frmMainForm.scrbxViewerAddfields.Components[i] is TFrame then
                    frmMainForm.scrbxViewerAddfields.Components[i].Free;
              end;
            end;

            CleanAddfieldsList(aCurrentAddfields);

            edtTabOrder := aCurrentAddfields.Count;
            pos := aCurrentAddfields.Count;

            if pos = 0 then
              lastpos := 0
            else
              lastpos := TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[frmMainForm.scrbxViewerAddfields.ComponentCount - 1]).Top + TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[frmMainForm.scrbxViewerAddfields.ComponentCount - 1]).Height;

            for j := 0 to Doc.Addfields.Count - 1 do
            begin
              if Doc.Addfields[j] = nil then
                Continue;

              try
                found := False;
                for k := 0 to aCurrentAddfields.Count - 1 do
                begin
                  if Doc.Addfields[j].Id = aCurrentAddfields[k].Id then
                  begin
                    found := True;
                    Break;
                  end;
                end;

                if found then
                  continue;

                // haben wir rechte auf das Feld?
                //OutputDebugString(PChar('AddDocumentFields ID:' + IntToStr(Doc.Addfields[j].ID)));
                if aAddfieldRights[Doc.Addfields[j].Id] = 0 then
                  Continue;

                if not seperator then
                begin
                  // SJ 07.10.2021
                  // wegen DoResizeAddfields. Dort wurde durch aCurrentAddfields die Position neu gesetzt.
                  // Problem: da ist TShape nicht drin. Wenn man durch scrbxViewerAddfields iteriert,
                  // war TShape nicht an der erwarteten Stelle, sondern auf Index 0. Deswegen TFrame
                  // unter TShape. So passt der Index und man kann einfach durchiterieren.

//                  sepcomp := TShape.Create(frmMainForm.scrbxViewerAddfields);
//                  sepcomp.Parent := frmMainForm.scrbxViewerAddfields;
//                  sepcomp.Shape := stRectangle;
//                  sepcomp.Height := 1;
//                  sepcomp.Top := lastpos + 5;
//                  sepcomp.Brush.Color := cColorGray;
//                  sepcomp.Pen.Color := cColorGray;
//                  sepcomp.Left := 10;
//                  sepcomp.Width := frmMainForm.scrbxViewerAddfields.Width - 20;
//                  seperator := True;
//                  lastpos := sepcomp.Top + 5;

                  ScrollbarWidth := GetSystemMetrics(SM_CXHSCROLL);

                  AFrame := TFrame.Create(frmMainForm.scrbxViewerAddfields);
                  AFrame.Parent := frmMainForm.scrbxViewerAddfields;
                  AFrame.Anchors := [akLeft, akTop, akRight];
                  AFrame.Height := 10;
                  AFrame.Top := lastpos;
                  AFrame.Width := frmMainForm.scrbxViewerAddfields.Width - ScrollbarWidth;
//                  AFrame.Width := frmMainForm.scrbxViewerAddfields.Width;

                  sepcomp := TShape.Create(AFrame);
                  sepcomp.Parent := AFrame;
                  sepcomp.Shape := stRectangle;
                  sepcomp.Height := 1;
                  sepcomp.Top := 5;
                  sepcomp.Left := 10;
                  sepcomp.Brush.Color := cColorGray;
                  sepcomp.Pen.Color := cColorGray;
                  sepcomp.Anchors := [akLeft, akTop, akRight];
                  sepcomp.Width := AFrame.Width - 10;
//                  sepcomp.Width := frmMainForm.scrbxViewerAddfields.Width - ScrollbarWidth - 5;

                  seperator := True;
                  lastpos := AFrame.Top + AFrame.Height;
                end;
                addid := Doc.Addfields[j].Id;
                if Doc.Addfields[j].Component = nil then
                begin
                  if (Doc.Addfields[j].Options and 16) = 16 then
                  begin
//                      frmMainForm.tabAddfields2.Visible := True;
                    addfieldcomp := DoCreateAddfieldComp(frmMainForm.scrbxAddfields2,
                      addid, edtTabOrder, UseIndexing, lastpos2, False, 0);
                  end else
                    addfieldcomp := DoCreateAddfieldComp(frmMainForm.scrbxViewerAddfields,
                      addid, edtTabOrder, UseIndexing, lastpos, False, 0)
                end else
                  addfieldcomp := Doc.Addfields[j].Component;
                if addfieldcomp = nil then
                  Continue;
                addfieldcomp.TabOrder := edtTabOrder;
                inc(edtTabOrder);

                Addfield := TbfaAddField.Create;
                Addfield.Clone(Doc.Addfields[j]);

                if addfieldcomp <> nil then
                begin
                  //TODO: muss hier die alte Componente gefreet werden?
                  Addfield.Component := addfieldcomp;
                  Addfield.Component.Modified := Doc.Addfields[j].modified;
                  Addfield.Component.OnValueSet := Addfield.SetValue;
                  if Addfield.OldValue <> Null then
                    Addfield.Component.OldValue := Addfield.OldValue
                  else
                    Addfield.Component.OldValue := '';
                  if Addfield.Value <> Null then
                    Addfield.Component.Value := Addfield.Value
                  else
                    Addfield.Component.Value := '';
                  if Addfield.ValueHigh <> Null then
                    Addfield.Component.ValueHigh := Addfield.ValueHigh
                  else
                    Addfield.Component.ValueHigh := '';
//19.03.2018 wegen neue Auswahlfelder -->
                  if Addfield.Typ in [2, 11] then
                  begin
                    Addfield.Component.compComboBox.Properties.Items.AddStrings(Addfield.Component.Comboitems); //14.07.2022 Ticket
                    Addfield.Component.compComboBox.StoredItems.AddStrings(Addfield.Component.Comboitems);
                    //Addfield.Component.compComboBox.StoredItems.AddStrings(Addfield.Component.SearchItems);
                  end
                  else if Addfield.Typ = 3 then
                    Addfield.Component.Reset;
//19.03.2018 wegen neue Auswahlfelder <--
                end;
                aCurrentAddfields.Add(Addfield);
              except
                bitfarmLog.Write(llNormal, ltException, 'for i := 0 to aCurrentAddfields.Count -1 do - Synchronize', ClassName);
              end;
            end;
            frmMainForm.scrbxViewerAddfields.AutoScroll := True;
            frmMainForm.scrbxViewerAddfields.VertScrollBar.Position := VertPos;
            frmMainForm.scrbxViewerAddfields.AfterScrollVert := frmMainForm.AfterScrollVert;
            frmMainForm.scrbxViewerAddfields.AfterScrollHorz := frmMainForm.AfterScrollHorz;

            if (frmMainForm.scrbxAddfields2.ComponentCount = 0) and (frmMainForm.tcSearch.ActiveTabIndex = 2) then
              frmMainForm.tcSearch.ActivePage := frmMainForm.tabAddfields;

            frmMainForm.tabSearchAddfields2.Visible := frmMainForm.scrbxAddfields2.ComponentCount > 0;
            frmMainForm.scrbxAddfields2.Visible := frmMainForm.scrbxAddfields2.ComponentCount > 0;
            frmMainForm.scrbxAddfields2.AutoScroll := frmMainForm.scrbxAddfields2.ComponentCount > 0;

          finally
            frmMainForm.scrbxViewerAddfields.Show;
          end;

          seperator := False;

          if aCurrentStatefields.Count > 0 then
          begin
            for i := 0 to aCurrentStatefields.Count - 1 do
            begin
              if aCurrentStatefields[i].Assigned then  // assigned felder berspringen
                Continue;
              statefieldcomp := aCurrentStatefields[i].Component;
              DeleteStateCompFromArray(statefieldcomp);
              statefieldcomp := nil;
              if aCurrentStatefields[i].Component <> nil then
              begin
                try
                  aCurrentStatefields[i].Component.Free;
                finally
                  aCurrentStatefields[i].Component := nil;
                end;
              end;
              aCurrentStatefields[i].Component := nil;
              try
                aCurrentStatefields[i].Free;
              finally
                aCurrentStatefields[i] := nil;
              end;
            end;
          end;

          CleanStatefieldsList(aCurrentStatefields);

          for j := 0 to Doc.StateFields.Count - 1 do
          begin
            if Doc.StateFields[j] = nil then
              Continue;

            try
              found := False;
              for k := 0 to aCurrentStatefields.Count - 1 do
              begin
                if Doc.StateFields[j].Id = aCurrentStatefields[k].Id then
                begin
                  found := True;
                  Break;
                end;
              end;

              if found then
                continue;

                // haben wir Rechte auf das Feld?
                  if aStateFieldRights[Doc.StateFields[j].Id] = 0 then
                Continue;

              if not seperator then
              begin
                seperator := True;
                sepitem := TTBSeparatorItem.Create(frmMainForm.tlbStatefields);
                frmMainForm.tlbStatefields.Items.Add(sepitem);
              end;

              stateid := Doc.StateFields[j].Id;
              if Doc.StateFields[j].Component = nil then
                statefieldcomp := TBfaStatefieldComp.Create(frmMainForm.tlbStatefields, 0, aStatefields[stateid].Displayname)
              else
                statefieldcomp := Doc.StateFields[j].Component;
              if statefieldcomp = nil then
                Continue;

              Statefield := TbfaStateField.Create;
              Statefield.Clone(Doc.StateFields[j]);
              Statefield.Component := statefieldcomp;
              Statefield.Component.Rights := aStateFieldRights[stateid];
              Statefield.Component.Modified := Doc.StateFields[j].modified;
              Statefield.Component.OnValueSet := Statefield.SetValue;
              Statefield.Component.ViewKind := CurrentView;
              if (Statefield.OldValue <> Null) and varIsType(Statefield.OldValue, varBoolean) then
              begin
                if Statefield.OldValue then
                  Statefield.Component.OldValue := fsSet
                else
                  Statefield.Component.OldValue := fsNone;
              end
              else
                Statefield.Component.OldValue := fsNone;
              if (Statefield.Value <> Null) and varIsType(Statefield.Value, varBoolean) then
              begin
                if Statefield.Value then
                  Statefield.Component.Value := fsSet
                else
                  Statefield.Component.Value := fsNone;
              end
              else
                Statefield.Component.Value := fsNone;
              aCurrentStatefields.Add(Statefield);
              frmMainForm.tlbStatefields.Items.Add(statefieldcomp);
            except
              bitfarmLog.Write(llNormal, ltException, 'for k := 0 to aCurrentStatefields.Count -1 do - Synchronize', ClassName);
            end;
          end;
          //18.06.2019 Ticket 19615 -->
          if ((frmMainForm.tlbStatefields.Items.Count > 0) and (aCurrentStatefields.Count > 0)) then
            frmMainForm.tlbStatefields.Show
          else
            frmMainForm.tlbStatefields.Hide;
          //18.06.2019 Ticket 19615 <--
        except
          bitfarmLog.Write(llNormal, ltException, 'AddDocumentFields - Synchronize', ClassName);
        end;

      end);
  except
    bitfarmLog.Write(llNormal, ltException, 'AddDocumentFields', ClassName);
  end;
end;

function TbfaApplication.SetSelectedColumns(resub: Boolean = False; checkout: Boolean = False; preset: WideString = ''): WideString;
var
  i, j, arcid: Integer;
  found: Boolean;
  add: string;
begin
  try
    if resub then
    begin
      Result := 'gdocid,editmode,arcid,tmr.timid,tmr.timref,tmr.date,tmr.alarm,tmr.modified,tmr.groupid,userid_shed,' +
                'userid_work, IF (tmr.groupid <> 0, grwork.groupname, suwork.displayname) AS user_work, ' +
                'sushed.displayname as user_shed, tmr.status, tmr.options, sd.modified AS doc_modified';
      arcid := CurrentResubFields;
    end
    else if checkout then
    begin
      Result := 'gdocid,editmode,arcid, su.username, arcname, cout.displayname as coutusername, sd.modified AS doc_modified';
      arcid := CurrentArchive.Arcid;
    end
    else if preset <> '' then
    begin
      Result := preset;
      arcid := CurrentArchive.Arcid;
    end
    else
    begin
      Result := 'gdocid,editmode,arcid,su.username, sd.modified AS doc_modified';
      arcid := CurrentArchive.Arcid;
    end;
    if arcid = -1 then
      Exit;

    if PosEx('arcid', Result) = 0 then
      Result := 'arcid,' + Result;

    if PosEx('gdocid', Result) = 0 then
      Result := 'gdocid,' + Result;

    for i := Low(aColSortings[arcid]) to High(aColSortings[arcid]) do
    begin
      found := False;
      for j := 0 to aCurrentAddfields.Count - 1 do
      begin
        if (aCurrentAddfields[j].name = aColSortings[arcid, i].Field) and (aColSortings[arcid, i].Field <> 'doc_modified') then
        begin
          if aCurrentAddfields[j].Typ = 5 then
          begin
            add := aCurrentAddfields[j].name;
            Result := Result + ',' + 'CASE WHEN RIGHT(' + add + ', 1) = "T" THEN REPLACE(' + add + ', "T", " ' + _('Tag') + '") ' + 'WHEN RIGHT(' + add + ', 1) = "W" THEN REPLACE(' + add + ', "W", " ' + _('Woche') + '") ' + 'WHEN RIGHT(' + add + ', 1) = "M" THEN REPLACE(' + add + ', "M", " ' + _('Monat') + '") ' + 'WHEN RIGHT(' + add + ', 1) = "J" THEN REPLACE(' + add + ', "J", " ' + _('Jahr') + '") ELSE ' + add + ' END as '{30.01.2018 gedoppelt + add +', '}   + add + ':' + IntToStr(aCurrentAddfields[j].Indextableid);
          end
          else if PosEx(aCurrentAddfields[j].name + ':' + IntToStr(aCurrentAddfields[j].Indextableid), Result) = 0 then
            Result := Result + ',' + aCurrentAddfields[j].name + ':' + IntToStr(aCurrentAddfields[j].Indextableid);
          found := True;
          Break;
        end;
      end;
      if not found and (aColSortings[arcid, i].Field <> 'doc_modified') then
        if LeftStr(aColSortings[arcid, i].Field, 4) = 'add_' then
          Result := Result + ',' + GetIndexTableID(aColSortings[arcid, i].Field)
        else if (aColSortings[arcid, i].Field = 'docusername') and (Pos(string('su.displayname as docusername'), string(Result)) = 0 ) then
          Result := Result + ',' + 'su.displayname as docusername'
        else if (aColSortings[arcid, i].Field = 'docname') and (PosEx('docname', Result) = 0) then
          Result := Result + ',' + 'docname'
        else if (aColSortings[arcid, i].Field = 'docdate') and (PosEx('docdate', Result) = 0) then
          Result := Result + ',' + 'docdate'
        else if not ((aColSortings[arcid, i].Field = 'docname') or (aColSortings[arcid, i].Field = 'docusername') or
                    (aColSortings[arcid, i].Field = 'typ') or (aColSortings[arcid, i].Field = 'date') or (aColSortings[arcid, i].Field = 'docdate') or
                    (aColSortings[arcid, i].Field = 'user_work') or (aColSortings[arcid, i].Field = 'user_shed') or
                    (aColSortings[arcid, i].Field = 'coutusername')) then
          Result := Result + ',' + aColSortings[arcid, i].Field;
    end;
  except
    Result := '';
  end;
end;

procedure TbfaApplication.SetInisProfile;
var
  ini : TIniFile;
begin
  try
    Self.SortingsProfile := 'Sortings_' + Self.Profile + '_' + FUser.ID.ToString;
    Self.SortingsFloatingResubProfile := 'Sortings_FloatingResub_' + Self.Profile + '_' + FUser.ID.ToString;

    Self.TreeViewProfile := sSysTreeView + '_' + Self.Profile + '_' + FUser.ID.ToString;
    if frmMainForm.FViewerTreeview <> nil then
      frmMainForm.FViewerTreeview.IniSectionName := Self.TreeViewProfile;
    if frmMainForm.FImporterTreeview <> nil then
      frmMainForm.FImporterTreeview.IniSectionName := Self.TreeViewProfile;
    if frmMainForm.FAdminTreeview <> nil then
      frmMainForm.FAdminTreeview.IniSectionName := Self.TreeViewProfile;

    //12.04.2022 Rckwrtskompatibilitt 361 -->
    ini := TIniFile.Create(BD.AppdataBitfarmPd + 'Viewer.ini');
    try
      FMarkedDocsProfile := sSysMarkedDocs + '_' + Self.Profile + '_' + FUser.ID.ToString;
      if not ini.ValueExists(sSysMarkedDocs, FMarkedDocsProfile) then
        MarkedDocsString := FVieweroptions.SystemOptions.MarkedDocs;
    finally
      FreeAndNil(ini);
    end;
    //12.04.2022 Rckwrtskompatibilitt 361 <--


  except
  end;
end;

procedure TbfaApplication.SetDoc(Data: PUserAction; AThread: TThread);
var
  Idx, i: Integer;
  ArcID, GDocID: Int64;
  Marked: string;
begin
  bitfarmLog.DebugBegin(llDebug, 'SetDoc', ClassName);
  try
    try
      if ((FCurrentContainer.Count > 0) and (FCurrentContainer[0] <> nil)) then
      begin
        ArcID := FCurrentContainer[0].ArcID;
        GDocID := FCurrentContainer[0].Id;
        if ((ArcID <> -1) and (GDocID <> -1)) then
        begin
          Idx := StrToInt(Data.Params[0]);
          MarkedDocs[Idx].ArcID := ArcID;
          MarkedDocs[Idx].GDocID := GDocID;

          Marked := '';
          for i := 1 to 5 do
            Marked := Marked + IntToStr(MarkedDocs[i].GDocID) + ',' +
              IntToStr(MarkedDocs[i].ArcID) + ';';

          MarkedDocsString := Marked;
          RefreshMarkedDocs(AThread);
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'SetDoc', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetDoc', ClassName);
  end;
end;

procedure TbfaApplication.DoRefreshMarkedDocs;
begin
  frmMainForm.actGetDoc1.Enabled := ((MarkedDocs[1].gdocid <> -1) and (MarkedDocs[1].arcid <> -1));
  frmMainForm.actGetDoc2.Enabled := ((MarkedDocs[2].gdocid <> -1) and (MarkedDocs[2].arcid <> -1));
  frmMainForm.actGetDoc3.Enabled := ((MarkedDocs[3].gdocid <> -1) and (MarkedDocs[3].arcid <> -1));
  frmMainForm.actGetDoc4.Enabled := ((MarkedDocs[4].gdocid <> -1) and (MarkedDocs[4].arcid <> -1));
  frmMainForm.actGetDoc5.Enabled := ((MarkedDocs[5].gdocid <> -1) and (MarkedDocs[5].arcid <> -1));
  frmMainForm.actSetDoc1.Enabled := True;
  frmMainForm.actSetDoc2.Enabled := True; //((MarkedDocs[1].GdocID <> -1) and (MarkedDocs[1].ArcID <> -1));
  frmMainForm.actSetDoc3.Enabled := True; //((MarkedDocs[2].GdocID <> -1) and (MarkedDocs[2].ArcID <> -1));
  frmMainForm.actSetDoc4.Enabled := True; //((MarkedDocs[3].GdocID <> -1) and (MarkedDocs[3].ArcID <> -1));
  frmMainForm.actSetDoc5.Enabled := True; //((MarkedDocs[4].GdocID <> -1) and (MarkedDocs[4].ArcID <> -1));
end;

procedure TbfaApplication.DoResizeAddfields(Sender: TObject; NewWidth, NewHeight: Integer; IsSettingValue: Boolean);
var
  i, diff, lastposition: Integer;
  found: Boolean;
  scrollbox: TbfaScrollBox;
begin
  try
    if bitfarmApp.AddFieldsCreating or not((Sender is TbfaCheckedCombo) or
        (Sender is TbfaGridField)) then
      Exit;
    try
      try
        bitfarmLog.DebugBegin(llDebug, 'DoResizeAddfields', ClassName);

        //07.10.2024 SD -->bfacrm:ticket__show__39992 Die Gre des Objekts wird immer neu berechnet, unabhngig davon, wo es sich befindet.
//        if frmMainForm.tabAddfields2.Visible and (frmMainForm.tcSearch.ActiveTabIndex = 2) then
//          scrollbox := frmMainForm.scrbxAddfields2
//        else
//          scrollbox := frmMainForm.scrbxViewerAddfields;
        if (Sender is TbfaCheckedCombo) then
          if TbfaCheckedCombo(Sender).Parent.Parent = frmMainForm.scrbxAddfields2 Then
            scrollbox := frmMainForm.scrbxAddfields2
          else
            scrollbox := frmMainForm.scrbxViewerAddfields
        else if (Sender is TbfaGridField) then
          if TbfaGridField(Sender).Grid.Parent.Parent = frmMainForm.scrbxAddfields2 Then
            scrollbox := frmMainForm.scrbxAddfields2
          else
            scrollbox := frmMainForm.scrbxViewerAddfields;
        //07.10.2024 SD <--bfacrm:ticket__show__39992

        if (Sender is TbfaCheckedCombo) and (TbfaCheckedCombo(Sender).Height <> NewHeight) then
        begin
          found := False;
          diff := 0;
          lastposition := 0 - scrollbox.VertScrollBar.Position;

          // in aCurrentAddfields ist der Trennbalken von "Zusatzfelder des Dokuments zustzlich anzeigen" nicht enthalten
          // deswegen ber scrbxViewerAddfields arbeiten
          for i := 0 to scrollbox.ControlCount - 1 do
          begin
            // wegen 'grpIndexing'
            if scrollbox.Controls[i] is TSpTBXGroupBox then
              Continue;

            // der Trennbalken ist TFrame
            if (scrollbox.Controls[i] is TBfaAddfieldComp) or
               (scrollbox.Controls[i] is TFrame) then
            begin
              // die Addfields sind geordnet in der Liste. Deswegen prfen wir ob der Sender
              // schon erreicht wurde. Erst ab da passen wir die Position an.
              if found then
                TControl(scrollbox.Controls[i]).Top := (Muldiv(lastposition, Screen.PixelsPerInch, 96));

              if (scrollbox.Controls[i] is TbfaAddfieldComp) and
                 (TBfaAddfieldComp(scrollbox.Controls[i]).comp = Sender) then
              begin
                found := True;
                diff := (NewHeight - TbfaCheckedCombo(Sender).Height);
                TbfaCheckedCombo(scrollbox.Controls[i]).Height :=
                  TbfaCheckedCombo(scrollbox.Controls[i]).Height +
                  (NewHeight - TbfaCheckedCombo(Sender).Height);
                TbfaCheckedCombo(Sender).Invalidate;
                if not IsSettingValue then // bfacrm:ticket__show__31197
                  scrollbox.VertScrollBar.Position := scrollbox.VertScrollBar.Position + diff;
              end;
              lastposition := TFrame(scrollbox.Controls[i]).Top +
                              TFrame(scrollbox.Controls[i]).Height;
            end;
          end;
        end else if (Sender is TbfaGridField) and (TbfaGridField(Sender).Grid.Height <> NewHeight) then
        begin
          found := False;
          diff := 0;
          lastposition := 0 - scrollbox.VertScrollBar.Position;

          // in aCurrentAddfields ist der Trennbalken von "Zusatzfelder des Dokuments zustzlich anzeigen" nicht enthalten
          // deswegen ber scrbxViewerAddfields arbeiten
          for i := 0 to scrollbox.ControlCount - 1 do
          begin
            // wegen 'grpIndexing'
            if scrollbox.Controls[i] is TSpTBXGroupBox then
              Continue;

            // der Trennbalken ist TFrame
            if (scrollbox.Controls[i] is TBfaAddfieldComp) or
               (scrollbox.Controls[i] is TFrame) then
            begin
              // die Addfields sind geordnet in der Liste. Deswegen prfen wir ob der Sender
              // schon erreicht wurde. Erst ab da passen wir die Position an.
              if found then
                TControl(scrollbox.Controls[i]).Top := (Muldiv(lastposition, Screen.PixelsPerInch, 96));

              if (scrollbox.Controls[i] is TbfaAddfieldComp) and
                 (TBfaAddfieldComp(scrollbox.Controls[i]).compGrid = Sender) then
              begin
                found := True;
                diff := (NewHeight - TbfaGridField(Sender).Grid.Height);
                //07.10.2024 SD -->bfacrm:ticket__show__39992
                TBfaAddfieldComp(scrollbox.Controls[i]).Height :=
//                  TBfaAddfieldComp(scrollbox.Controls[i]).Height + diff +3;
                  TBfaAddfieldComp(scrollbox.Controls[i]).Height + diff;
                //07.10.2024 SD <--bfacrm:ticket__show__39992
                TbfaGridField(Sender).Grid.Invalidate;

                if not IsSettingValue then  // bfacrm:ticket__show__31197
                  scrollbox.VertScrollBar.Position := scrollbox.VertScrollBar.Position + diff;
              end;
              lastposition := TFrame(scrollbox.Controls[i]).Top +
                              TFrame(scrollbox.Controls[i]).Height;
            end;
          end;
        end;
      except
        bitfarmLog.Write(llNormal, ltException, 'DoResizeAddfields', ClassName);
      end;
    finally
      bitfarmLog.DebugEnd(llDebug, 'DoResizeAddfields', ClassName);
    end;
  except
    // nur damit das Exit auerhalb des try finally ist. Sonst Spam im Log oder falsche Einrckung
  end;
end;

procedure TbfaApplication.RefreshMarkedDocs(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'RefreshMarkedDocs', ClassName);
  try
    try
      if AThread <> nil then
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            DoRefreshMarkedDocs;
          end);
      end
      else
        DoRefreshMarkedDocs;
    except
      bitfarmLog.Write(llNormal, ltException, 'RefreshMarkedDocs', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'RefreshMarkedDocs', ClassName);
  end;
end;

procedure TbfaApplication.ShowCW(AThread: TThread);
begin
  SetCW(Date);
  RefreshCWLabel(AThread, Date);
  if frmMainForm.IsFloatingResubShowing then
  begin
    AThread.Synchronize(AThread,
      procedure
      begin
        frmMainForm.fraFloatingResub.btnMyTasksClick(nil);
      end);
  end
  else
    MyTasksQuery(AThread);
end;


procedure TbfaApplication.StartHoliday(AThread: TThread = nil);
begin

end;

//procedure TbfaApplication.StartSearchThread(ASearchObj: TbfaSearch); // SJ 01.12.2021 - bfacrm:ticket__show__28712
procedure TbfaApplication.StartSearchThread(ASearchObj: TbfaSearch; AHistorySearchObj: TBfaSearch = nil; DoAutoCheckout: Boolean = False);
begin
  try
    if FSearchProc.Fqry <> nil then
      FSearchProc.Fqry.BreakExec;
  except
    on E: Exception do
      bitfarmLog.Write(llNormal, ltException, 'Reset Fqry.BreakExec: ' + E.Message, ClassName);
  end;

  frmMainForm.FSearchthread.SearchObj.Clone(ASearchObj);

  {$IFNDEF DISABLE_HISTORY_FUTURE_DELETE}
  if AHistorySearchObj = nil then
    FreeAndNil(frmMainForm.FSearchthread.HistorySearchObj)
  else
  begin
    frmMainForm.FSearchthread.HistorySearchObj := TbfaSearch.Create;
    frmMainForm.FSearchthread.HistorySearchObj.Clone(AHistorySearchObj);
  end;
  {$ENDIF}

  frmMainForm.FSearchthread.SearchProc := FSearchProc;
  frmMainForm.FSearchthread.AutoCheckout := DoAutoCheckout; // SJ 01.12.2021 - bfacrm:ticket__show__28712
  frmMainForm.FSearchthread.Resume;
end;

procedure TbfaApplication.Stationery(AThread: TThread; SList: TStringList; prev: TbfaPreview);
var
  show: Boolean;
begin
  if SList[0] = '0' then
    show := False
  else if SList[0] = '1' then
    show := True;

  if (show) then
  begin
    prev.AddStationery(AThread);
  end
  else
  begin
    prev.RemoveStationery(AThread);
  end;
end;

procedure TbfaApplication.Support(AThread: TThread);
begin
  AThread.Synchronize(AThread,
    procedure
    begin
      ShellExecute(Application.Handle, nil, 'https://www.bitfarm-archiv.de/downloads-support/gpl-support.html', nil, nil, sw_shownormal);
    end);
end;

procedure TbfaApplication.TeamViewer(AThread: TThread);
begin
 // Nur im Enterprise Version
end;

procedure TbfaApplication.TranslateMenu;
begin

end;

procedure TbfaApplication.UpdateGridWithFields(Athread: TThread; LstAddfields: TList<TbfaAddfield>);
var
  dsc : TDatasource;
  gdc : TcxGridDBDataController;
  RNo, gdocid : Integer;
  i, j, k: Integer;
  field: TField;
begin
  dsc := frmMainForm.grdResultlistDevExView.DataController.DataSource;
  gdc := frmMainForm.grdResultlistDevExView.DataController;
//  AThread.Synchronize(AThread,
//    procedure
//    var i, j, k: Integer;
//    begin
      dsc.DataSet.DisableControls;

//      for i := 0 to FCurrentContainer.Count -1 do
//      begin
//        for j := 0 to gdc.RecordCount -1 do
//        begin
//          gdocid := gdc.GetValue(j, gdc.GetItemByFieldName('gdocid').Index);
//          if gdocid = FCurrentContainer[i].ID then
//          begin
//            RNo := frmMainForm.grdResultlistDevExView.ActRec;
//            for k := 0 to LstAddfields.Count -1 do
//            begin
//              //gdc.SetValue(j, gdc.GetItemByFieldName(LstAddfields[k].Name).Index, LstAddfields[k].Value);
//              dsc.DataSet.Edit;
//              field := dsc.DataSet.FieldByName(LstAddfields[k].Name);
//              field.ReadOnly := False;
//              field.Value := LstAddfields[k].Value;
//              field.ReadOnly := True;
//              dsc.DataSet.Post;
//            end;
//          end;
//        end;
//      end;

      for i := 0 to FCurrentContainer.Count -1 do
      begin
        gdocid := FCurrentContainer[i].ID;
        if dsc.DataSet.Locate('gdocid', gdocid, []) then
        begin
          RNo := frmMainForm.grdResultlistDevExView.ActRec;
          for k := 0 to LstAddfields.Count -1 do
          begin
            //gdc.SetValue(j, gdc.GetItemByFieldName(LstAddfields[k].Name).Index, LstAddfields[k].Value);
            dsc.DataSet.Edit;
            field := dsc.DataSet.FieldByName(LstAddfields[k].Name);
            field.ReadOnly := False;
            field.Value := LstAddfields[k].Value;
            field.ReadOnly := True;
            dsc.DataSet.Post;
          end;
        end;
      end;

      dsc.DataSet.EnableControls;
//    end);

end;

procedure TbfaApplication.LoadFtxPos(var FtxPos: TList<TbfaFtxPos>; SearchString: WideString);
begin
  if not OfflineMode then //08.03.2024 bfacrm:ticket__show__38079 im Offline-Modus gibt es keinen Fundstellmarkierung!
  begin
    Log.DebugBegin(llDebug, 'LoadFtxPos', ClassName);
    try
      try
        if FtxPos <> nil then
          FreeAndNil(FtxPos);

        if FViewerOptions.SearchOptions.FtxPos then
        begin
          if SearchString <> '' then
          begin
            FtxPos := FtxWordPos(SearchString);
          end;
        end;
      except
        Log.Write(llNormal, ltException, 'LoadFtxPos', ClassName);
      end;
    finally
      Log.DebugEnd(llDebug, 'LoadFtxPos', ClassName);
    end;
  end;
end;

function TbfaApplication.FtxWordPos(SearchString: WideString): TList<TbfaFtxPos>;
var
  req: TbfaRequest;
  UserAction: PUserAction;
  sock: TSocketConnection;
begin
  Log.DebugBegin(llDebug, 'FtxWordPos', ClassName);
  try
    try
      if (FCurrentContainer.Count < 1) or (Trim(SearchString) = '') then
        Exit;
      sock := TSocketConnection.Create(bfaServerNoSSL, bfaServer, bfaServerPort, '');
      sock.CreateComponents;

      if sock.Connect then
      begin
      req := TbfaRequest.Create;
      try
        req.ReqType := 'reqFtxPos';
        req.UserID := FUser.ID;
        req.Gdocid := FCurrentContainer[0].ID;
          RemoveMultipleSpaces(SearchString);
        req.DataString := SearchString;
        req.DataString := StringReplace(req.DataString, '"', '', [rfReplaceAll]); //" muss raus, weil wir im XML nur nach einzeln suchen
        req.Lang := Lang;
        req.Profile := Self.Profile;
          sock.SendRequestToServer(req);

        Result := TList<TbfaFtxPos>.Create;

        req := sock.ReceiveFtxPos(Result);
        if req = nil then
          Exit;

        if req.ReqType = 'respAuthError' then
        begin
          BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'));
          UserAction := CreateUserAction;
          UserAction^.ActionName := 'actRelogin';
          FMainThread.Add(UserAction);
          Exit;
        end else
        begin
            Log.Write(llNormal, ltDebug, 'FtxWordPos Received', ClassName);
        end;
      finally
//        FreeAndNil(req);
            FreeAndNil(sock);
        end;
      end;
    except
      Log.Write(llNormal, ltException, 'FtxWordPos', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'FtxWordPos', ClassName);
  end;
end;

procedure TbfaApplication.ActFulltextZoom(Data: PUserAction);
var
  param1, param2: Integer;
begin
  try
    SendMessage(Data^.Preview.FulltextView.mmoFulltext.Handle, EM_GETZOOM, WPARAM(@param1), LPARAM(@param2));

    if (Data^.ActionName = 'actZoomIn1') or (Data^.ActionName = 'actZoomIn2') then
    begin
      if param1 < 500 then
        param1 := param1 + 10
      else
        param1 := 500
    end
    else if (Data^.ActionName = 'actZoomOut1') or (Data^.ActionName = 'actZoomOut2') then
    begin
      if param1 > 20 then
        param1 := param1 - 10
      else
        param1 := 10;
    end else
      Exit;

    SendMessage(Data^.Preview.FulltextView.mmoFulltext.Handle, EM_SETZOOM, WPARAM(param1), LPARAM(param2));
  except
    bitfarmLog.Write(llNormal, ltException, 'ActFulltextZoom', ClassName);
  end;
end;

procedure TbfaApplication.FulltextZoomResized(Sender: TObject);
var
  param1, param2: Integer;
begin
  // if there is any Fulltext resized, we have to start a Action
  // to syncronize the zoom-level of the other previews
  try
    // get the updated zoom-level from active Preview
    SendMessage(GetActivePreview.FulltextView.mmoFulltext.Handle, EM_GETZOOM, WPARAM(@param1), LPARAM(@param2));

    // valid? will also occure when Fulltext will be cleaned up (with value 0)
    if (param1 <= 0) or (param1 > 500) then
      Exit;

    // set the global property
    FullTextZoom := param1;

    // execute action to syncroize
    frmMainForm.actSyncFulltextZoom.Execute;
  except
    bitfarmLog.Write(llNormal, ltException, 'FulltextZoomResized', ClassName);
  end;
end;

procedure TbfaApplication.ShowFtxPos(img: TbfaImageEnVect; Doc: TbfaDocument; prev: TbfaPreview; PageIdx: Integer);
var
  FtxColor: TColor;
  found, btnFound: Boolean;
  OnePos: TbfaWordPos;
  i, idx, j, hobj, k: Integer;
begin
  Log.DebugBegin(llDebug, 'ShowFtxPos', ClassName);
  try
    try
      if (prev.FtxPos <> nil) and (Doc <> nil) and (not Doc.InEditMode) then
      begin

        with img do
        begin
          CancelInteracts;
          DeSelect;
          UnSelAllObjects;
        end;
        btnFound := False;
        for i := 0 to prev.FtxPos.Count - 1 do
        begin
          FtxColor := prev.FtxPos[i].Color;
          j := 0;
          found := False;
          if ((prev.FtxPos[i].WordList <> nil) and (prev.FtxPos[i].WordList.Count > 0)) then
          begin
            while ((not found) and (j <= prev.FtxPos[i].WordList.Count - 1)) do
            begin
              if prev.FtxPos[i].WordList[j].Page = PageIdx then
              begin
                found := True;
                btnFound := True;
                OnePos := prev.FtxPos[i].WordList[j];
                try
                  if Length(prev.FtxPos[i].WordList[j].Coordinates) > 0 then
                  begin
                    for k := Low(prev.FtxPos[i].WordList[j].Coordinates) to High(prev.FtxPos[i].WordList[j].Coordinates) do
                    begin
                      with img do
                      begin
                        hobj := AddNewObject; // hobj is an integer
                        ObjKind[hobj] := iekBox;
                        ObjLeft[hObj] := OnePos.Coordinates[k].Top;
                        ObjTop[hObj] := OnePos.Coordinates[k].Left;
                        ObjWidth[hObj] := (OnePos.Coordinates[k].Bottom - OnePos.Coordinates[k].Top);
                        ObjHeight[hObj] := (OnePos.Coordinates[k].Right - OnePos.Coordinates[k].Left);

                        ObjPenStyle[hObj] := psDash;
                        ObjPenColor[hObj] := FtxColor;
                        ObjPenWidth[hObj] := 3;
                        ObjBrushColor[hObj] := FtxColor;
                        ObjBrushStyle[hObj] := bsClear;

                        prev.FtxObjList.Add(IntToStr(hObj));

                        Update;
                      end;
                    end;
                  end;
                except
                end;
              end;

              Inc(j);
            end;
          end;
        end;

        prev.bfaTlbPreview.mnuFtxPos.Checked := BtnFound;
        frmMainForm.bfaTlbPreview1.mnuFtxPos.Checked := prev.bfaTlbPreview.mnuFtxPos.Checked;

        // SJ 22.05.2020 bfacrm:ticket__show__23112
        // existiert eine ocr-xml?
        if (prev.FtxPos <> nil) and (prev.FtxPos.Count > 0) {prev.ActiveDoc.ocrxmlexists} then
          bitfarmApp.SetFtxIcon(prev, Integer(icoidx_search_result_highlighting), _('Fundstellenmarkierung'), True)
        else
          bitfarmApp.SetFtxIcon(prev, Integer(icoidx_search_result_highlighting_no), _('Keine Positionsinformationen vorhanden (OCR xml)'), False);

        //this is how it should be
//        if (prev.FtxPos <> nil) and (prev.ActiveDoc.ocrxmlexists = True) then
//          if (prev.FtxPos.Count > 0) then
//            bitfarmApp.SetFtxIcon(prev, 215, _('Suchbegriff nicht gefunden'), False)
//          else
//            bitfarmApp.SetFtxIcon(prev, 215, _('Fundstellenmarkierung'), True);
//        else
//          bitfarmApp.SetFtxIcon(prev, 221, _('Keine Positionsinformationen vorhanden (OCR xml)'), False);
        // SJ 22.05.2020 bfacrm:ticket__show__23112
      end;
    except
      Log.Write(llNormal, ltException, 'ShowFtxPos', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'ShowFtxPos', ClassName);
  end;
end;

procedure TbfaApplication.ShowFtxPosWithButton(AThread: TThread; Params: TStringList; Prev: TbfaPreview);
begin
  Log.DebugBegin(llDebug, 'ShowFtxPosWithButton', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          if Params[0] = '1' then
          begin
            ShowFtxPos(Prev.SingleView.img_DocView, Prev.ActiveDoc, Prev, StrToInt(Params[1]));
            if ((GetSearchString <> '') and ((prev.FtxPos = nil) or (prev.FtxPos.Count = 0))) then
              frmMainForm.SetNotificationBar(_('Kein OCR xml vorhanden.'), nil);
{
//          TODO -o SJ: differenzierung zwischen count=0 und keiner xml
            else if ((GetSearchString <> '') and (prev.FtxPos.Count = 0)) then
              frmMainForm.SetNotificationBar(_('Suchbegriff nicht gefunden!'), nil);
}
          end
          else
            Prev.DeleteFtxPosLayer;
        end);
    except
      Log.Write(llNormal, ltException, 'ShowFtxPosWithButton', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'ShowFtxPosWithButton', ClassName);
  end;
end;

procedure TbfaApplication.ShowInResub(AThread: TThread);
var
  UserAction: PUserAction;
  gdocid: Int64;
  i: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'ShowInResub - ', Classname);
  try
    frmMainForm.fSkipMaximizeEvent := True;
    try
      gdocid := FCurrentContainer[0].Id;

      frmMainForm.pnlResubmission.Maximize;
      MyTasks(AThread, gdocid);

    except
      bitfarmLog.Write(llNormal, ltException, 'ShowInResub - ', ClassName);
    end;
  finally
    frmMainForm.fSkipMaximizeEvent := False;
    bitfarmLog.DebugEnd(llDebug, 'ShowInResub - ', Classname);
  end;
end;

procedure TbfaApplication.DoPluginClick(AThread: TThread; UserAction: PUserAction);
begin
 // Nur im Enterprise Version
end;

procedure TbfaApplication.Videos(AThread: TThread);
var
  URL: pWideChar;
begin
  AThread.Synchronize(AThread,
    procedure
    begin
//28.06.2024 BT Ticket bfacrm:ticket__show__39079     if bitfarmApp.Lang = 'de' then
        URL := 'https://www.youtube.com/@bitfarmArchiv';
//28.06.2024 BT bfacrm:ticket__show__39079 -->
//      else
//        URL := 'https://www.bitfarm-archiv.com/document-management/videos.html#gpl';
//28.06.2024 BT bfacrm:ticket__show__39079 <--
      ShellExecute(Application.Handle, nil, URL, nil, nil, sw_shownormal);
    end);
end;

procedure TbfaApplication.ViewThumbnails(Data: PUserAction; AThread: TThread);
begin
  AThread.Synchronize(nil,
    procedure
    begin
      bitfarmLog.DebugBegin(llDebug, 'ViewThumbnails - Synchronize - ThreadID:' + IntToStr(AThread.ThreadID), ClassName);
      try
        try
          PUserAction(Data).Preview.ShowThumbnail := (PUserAction(Data).params[0] = '1');
          frmMainForm.bfaTlbStandard1.tlbStandardThumbnail.Checked := PUserAction(Data).Preview.ShowThumbnail;
        except
          bitfarmLog.Write(llNormal, ltException, 'ViewThumbnails - Synchronize - ThreadID:' + IntToStr(AThread.ThreadID), ClassName);
        end;
      finally
        bitfarmLog.DebugEnd(llDebug, 'ViewThumbnails - Synchronize - ThreadID:' + IntToStr(AThread.ThreadID), ClassName);
      end;
    end);
end;

procedure TbfaApplication.WPClear(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'WPClear', ClassName);
  try
    if FPreviewContainer.WorkplaceItem.Preview.MultiView.ImageCount = 0 then
      Exit;

    try
      AThread.Synchronize(nil,
        procedure
        var
          slist: TStringList;
          i: Integer;
        begin
          slist := TStringList.Create;
          for i := FPreviewContainer.WorkplaceItem.Preview.MultiView.ImageCount - 1 downto 0 do
            slist.Add(IntToStr(i));

          FPreviewContainer.WorkplaceItem.Preview.MultiView.SelectAll;
//04.09.2019 Ticket 20317          DeleteSelected(FPreviewContainer.WorkplaceItem.Preview, slist, AThread);
          DeleteSelected(FPreviewContainer.WorkplaceItem.Preview, slist, AThread, mrYes);
          slist.Free;
        end);
    except
      bitfarmLog.Write(llnormal, ltException, 'WPClear', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'WPClear', ClassName);
  end;
end;

procedure TbfaApplication.WPLoad(sList: TStringList; AThread: TThread);
var
  i: Integer;
  PDoc: TbfaDocument;
begin
  bitfarmLog.DebugBegin(llDebug, 'WPLoad', ClassName);
  try
    try
      if FPreviewContainer.ActiveItem <> FPreviewContainer.WorkplaceItem.Panel.Tag then
      begin
        SetActiveView(AThread, pvtWorkplace, nil, pvtWorkplace);
      end;

      for i := 0 to sList.Count - 1 do
      begin
        if FileExists(sList[i]) then
        begin
//29.08.2023 -->
//          AThread.Synchronize(nil,
//            procedure
//            begin
//              PDoc := CreatePDocument(sList[i]);
//            end);
          {$IFDEF IMAGEEN_SYNCHRONIZED}
          AThread.Synchronize(nil,
            procedure
            begin
              PDoc := CreatePDocument(sList[i]);
            end);
          {$ELSE}
          PDoc := CreatePDocument(sList[i]);
          {$ENDIF}
//29.08.2023 <--
          FWorkplaceContainer.Add(PDoc);
          Log.Write(llDebug, ltInfo, 'Doc added to FWorkplaceConatiner TempID: ' + GUIDToString(PDoc.TempID), ClassName);
        end;
      end;

      RefreshWorkplaceMultiView(AThread, True);
    except
      bitfarmLog.Write(llNormal, ltException, 'WPLoad', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'WPLoad', ClassName);
  end;
end;

procedure TbfaApplication.WPSave;
begin
  BFShowMessage('WPSave');
end;

procedure TbfaApplication.WPUngroup(Data: PUserAction; AThread: TThread);
var
  j, k: Integer;
  prev: TbfaPreview;
  UserAction: PUserAction;
  Doc: TbfaDocument;
  sList: TStringList;
  newpos: Integer;
  iebmp: TIEBitmap;
  bmp: Graphics.TBitmap;
  MView: TbfaImageEnMView;
  msg: string;
begin
  Log.DebugBegin(llDebug, 'WPUngroup', ClassName);
  try
    try
      if Data^.Documents.Count = 1 then
        msg := _('Das Dokument wird getrennt...')
      else
        msg := _('Die Dokumente werden getrennt...');

      AThread.Synchronize(nil,
        procedure
        begin
          frmMainForm.frmSplash.lblLoading.Caption := msg;
          frmMainForm.frmSplash.lblInfo.Caption := '';
          frmMainForm.frmSplash.Update;
          frmMainForm.frmSplash.Show;
        end);
      try
        prev := Data^.Preview;
        if (prev = FPreviewContainer.WorkplaceItem.Preview) or (prev = FPreviewContainer.ImporterItem.Preview) then
        begin
          newpos := prev.List.Count;
          sList := TStringList.Create;
          try
            if Data^.Documents.Count > 0 then
            begin
              for k := 0 to Data^.Documents.Count - 1 do
              begin
                for j := 0 to prev.List.Count - 1 do
                begin
                  if CompareDocumentsByID(TbfaDocument(Data^.Documents[k]), prev.List[j]) then
                  begin
                    sList.Add(IntToStr(j));
                    Break;  //04.09.2017 Ticket 11632
                  end;
                end;
              end;
            end;
            newpos := newpos - sList.Count;
            DeleteSelected(prev, sList, AThread, mrYes, False);
          finally
            FreeAndNil(sList);
          end;

          AThread.Synchronize(nil,
            procedure
            var
              i, l, k, idx: Integer;
              Anno, NewAnno: TbfaAnnotation;
              tags: TIETIFFHandler;
              PCount: Integer;
              Fimg: TbfaImageEnVect;
              iebmp2: TIEBitmap;
            begin
              tags := TIETIFFHandler.Create;
              try
                if Data^.Documents.Count > 0 then
                begin
                  for i := 0 to Data^.Documents.Count - 1 do
                  begin
  //20.06.2018 Ticket 14576 -->
                    if (TbfaDocument(Data^.Documents[i]).ScanPoolView <> nil) and (TbfaDocument(Data^.Documents[i]).ScanPoolViewLoaded) then
                    begin
                      PCount := TbfaDocument(Data^.Documents[i]).ScanPoolView.ImageCount;
                    end
                    else
                    begin
  //20.06.2018 Ticket 14576 <--
                      TbfaDocument(Data^.Documents[i]).DocStream.Position := 0;
                      tags.ReadStream(TbfaDocument(Data^.Documents[i]).DocStream);
                      PCount := tags.GetPagesCount;
                    end;

                    for l := 0 to PCount - 1 do
                    begin
                      if Data^.Documents.Count = 1 then
                      begin
                        frmMainForm.frmSplash.lblLoading.Caption := msg;
                        frmMainForm.frmSplash.lblInfo.Caption := ' (' + IntToStr(l + 1) + '/' + IntToStr(PCount) + ')';
                      end
                      else
                      begin
                        frmMainForm.frmSplash.lblLoading.Caption := msg;
                        frmMainForm.frmSplash.lblInfo.Caption := ' (Dokument: ' + IntToStr(i + 1) + '/' + IntToStr(Data^.Documents.Count) + ')' + ' (Seite: ' + IntToStr(l + 1) + '/' + IntToStr(PCount) + ')';
                      end;
                      frmMainForm.frmSplash.Update;
                      if not frmMainForm.frmSplash.Showing then
                        frmMainForm.frmSplash.Show;

                      Doc := CreatePDocument;
  //20.06.2018 Ticket 14576 -->

                      Anno := TbfaDocument(Data^.Documents[i]).GetAnnotation(l, 0, idx);
                      if (Anno <> nil) and (idx > -1) then
                      begin
                        NewAnno := TbfaAnnotation.Create;
                        NewAnno.Clone(Anno);
                        NewAnno.Page := 0;
                        Doc.Annotations.Add(NewAnno);
                      end;

                      if (TbfaDocument(Data^.Documents[i]).ScanPoolView <> nil) and (TbfaDocument(Data^.Documents[i]).ScanPoolViewLoaded) then
                      begin
                        Fimg := CreateInvisibleVect(nil);
                        try
                          Fimg.IO.Params.ImageIndex := 0;
                          iebmp2 := TIEBitmap.Create;
                          try
                            TbfaDocument(Data^.Documents[i]).ScanPoolView.CopyToIEBitmap(l, iebmp2);
                            {$IFDEF ImageEN1140}
                            Fimg.Bitmap.Assign(iebmp2.VclBitmap);
                            {$ELSE}
                            Fimg.IO.Bitmap.Assign(iebmp2.VclBitmap);
                            {$ENDIF}
                            Fimg.IO.Params.TIFF_Compression := TbfaDocument(Data^.Documents[i]).ScanPoolView.MIO.Params[l].TIFF_Compression;
                            Fimg.IO.Params.BitsPerSample := TbfaDocument(Data^.Documents[i]).ScanPoolView.MIO.Params[l].BitsPerSample;
                            Fimg.IO.Params.SamplesPerPixel := TbfaDocument(Data^.Documents[i]).ScanPoolView.MIO.Params[l].SamplesPerPixel;

                          finally
                            FreeandNil(iebmp2);
                          end;
                          Doc.DocStream.Position := 0;
                          Fimg.IO.SaveToStreamTIFF(Doc.DocStream);
                          Doc.DocStream.Position := 0;
                        finally
                          Fimg.RemoveAllObjects;
                          Fimg.Clear;
//29.08.2023 -->
////10.05.2023 -->
////                          try
////                            for k := Fimg.LayersCount - 1 downto 0 do
////                              Fimg.Layers[k].Free;
////                            Fimg.SelectionMask.Free;
////                          except
////                          end;
//                          Fimg.Free;
////10.05.2023 <--
                          {$IFDEF IMAGEEN_SYNCHRONIZED}
                          Fimg.Free;
                          {$ELSE}
                          try
                            for k := Fimg.LayersCount - 1 downto 0 do
                              Fimg.Layers[k].Free;
                            Fimg.SelectionMask.Free;
                          except
                          end;
                          {$ENDIF}
//29.08.2023 <--
                          Fimg := nil;
                        end;
                      end
                      else
                      begin
  //20.06.2018 Ticket 14576 <--
                        Doc.DocStream.Position := 0;
                        tags.WriteStream(Doc.DocStream, l);
                        Doc.DocStream.Position := 0;
                      end;

                      Doc.HasPreview := True;

                      prev.List.Add(Doc);
                    end;
                  end;
                end;
              finally
                FreeAndNil(tags);
              end;
            end);
          if (prev = FPreviewContainer.WorkplaceItem.Preview) then
          begin
            RefreshWorkplaceMultiView(AThread, True)
          end
          else if (prev = FPreviewContainer.ImporterItem.Preview) then
          begin
            RefreshImporterMultiView(AThread, True);
          end;
          AThread.Synchronize(nil,
            procedure
            begin
              if prev.MultiView.ImageCount > 0 then
              begin
                prev.MViewImageSelect(prev.Owner, newpos);
                prev.MultiView.SelectedImage := newpos;
                bitfarmApp.SetCurrentDocs(prev.List[newpos], nil, prev);
                bitfarmApp.ShowDocumentProperties(prev.List[newpos], prev);
              end;
              if (prev = FPreviewContainer.ImporterItem.Preview) then
              begin
                prev.dctPreviewTarget.Unregister(prev.MultiView);
                prev.dctPreviewTarget.Register(prev.MultiView);
              end;
            end);

          if (FCurrentContainer.Count > 0) and (FCurrentContainer[0] <> nil) then
            CallShowDocument(FCurrentContainer[0], nil, nil, 0, 0, True, False, False, False, False, True, prev, False);

        end;
      finally
        AThread.Synchronize(nil,
          procedure
          begin
            frmMainForm.frmSplash.Hide;
          end);
      end;
    except
      Log.Write(llNormal, ltException, 'WPUngroup', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'WPUngroup', ClassName);
  end;
end;

procedure TbfaApplication.PreviewBack(AThread: TThread; prev: TbfaPreview);
begin
  bitfarmLog.DebugBegin(llDebug, 'PreviewBack', ClassName);
  try
    try
      if (prev = FPreviewContainer.WorkplaceItem.Preview) or (prev = FPreviewContainer.ImporterItem.Preview) then
      begin
        prev.askforsave_annos2(AThread);

        AThread.Synchronize(nil,
          procedure
          begin
            prev.PreviewKind := pvkMulti;
            prev.itmBack.Enabled := False;
            prev.Paint; // 10/20/2020 bfacrm:ticket__show__24402

            if (prev.ThumbnailView.Visible) and (prev.previewToolWindow.Visible) then
              prev.ThumbnailView.SetFocus;
          end);
      end;

      // bfacrm:ticket__show__30572 - Punkt 4
      if (prev.SingleView.img_DocView.SelObjectsCount > 0) then
        AThread.Synchronize(nil,
          procedure
          begin
            prev.SingleView.img_DocView.UnSelAllObjects;
          end);
    except
      bitfarmLog.Write(llNormal, ltException, 'PreviewBack', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'PreviewBack', ClassName);
  end;
end;

procedure TbfaApplication.Zoom100(prev: TbfaPreview; img_DocView: TbfaImageEnVect = nil; AThread: TThread = nil);
begin
  bitfarmLog.DebugBegin(llDebug, 'Zoom100', ClassName);
  try
  if prev <> nil then
    img_DocView := prev.SingleView.img_DocView;

  img_DocView.LockPaint;
  try
    try
      if img_DocView.Zoom <> 100 then
      begin
        img_DocView.Zoom := 100;
        if prev <> nil then
        begin
          prev.UnCheckAllGraphicTools;
          img_DocView.MouseInteract := [miScroll];
        end;
      end;

      if AThread <> nil then
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            if prev <> nil then
              prev.bfaTlbPreview.sbmAutozoom.Action := prev.actZoom100;
            frmMainForm.bfaTlbPreview1.sbmAutozoom.Action := frmMainForm.actZoom100;
          end);
      end
      else
      begin
        if prev <> nil then
          prev.bfaTlbPreview.sbmAutozoom.Action := prev.actZoom100;
        frmMainForm.bfaTlbPreview1.sbmAutozoom.Action := frmMainForm.actZoom100;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'Zoom100', ClassName);
    end;
  finally
    img_DocView.UnLockPaint;
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'Zoom100', ClassName);
  end;
end;

procedure TbfaApplication.ZoomHeight(prev: TbfaPreview; img_DocView: TbfaImageEnVect = nil; AThread: TThread = nil);
begin
  bitfarmLog.DebugBegin(llDebug, 'ZoomHeight', ClassName);
  try
    if prev <> nil then
      img_DocView := prev.SingleView.img_DocView;

    img_DocView.LockPaint;
    try
      try
        if prev <> nil then
          prev.UnCheckAllGraphicTools;
        img_DocView.FitToHeight;
        img_DocView.ViewX := 0;
        img_DocView.ViewY := 0;
        img_DocView.MouseInteract := [miScroll];

        if AThread <> nil then
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              if prev <> nil then
                prev.bfaTlbPreview.sbmAutozoom.Action := prev.actZoomHeight;
              frmMainForm.bfaTlbPreview1.sbmAutozoom.Action := frmMainForm.actZoomHeight;
            end);
        end
        else
        begin
          if prev <> nil then
            prev.bfaTlbPreview.sbmAutozoom.Action := prev.actZoomHeight;
        frmMainForm.bfaTlbPreview1.sbmAutozoom.Action := frmMainForm.actZoomHeight;
        end;
      except
        bitfarmLog.Write(llNormal, ltException, 'ZoomHeight', ClassName);
      end;
    finally
      img_DocView.UnLockPaint;
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ZoomHeight', ClassName);
  end;
end;

procedure TbfaApplication.ZoomOff(prev: TbfaPreview; img_DocView: TbfaImageEnVect = nil; AThread: TThread = nil);
begin
  bitfarmLog.DebugBegin(llDebug, 'ZoomOff', ClassName);
  try
  if prev <> nil then
    img_DocView := prev.SingleView.img_DocView;

  img_DocView.LockPaint;
  try
    try
      img_DocView.MouseInteract := [miScroll];

      if AThread <> nil then
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            if prev <> nil then
            begin
              prev.SingleView.fAutozoom := False;
              prev.bfaTlbPreview.sbmAutozoom.Action := prev.actZoomOff;
            end;
            frmMainForm.bfaTlbPreview1.sbmAutozoom.Action := frmMainForm.actZoomOff;
          end);
      end
      else
      begin
        if prev <> nil then
        begin
          prev.SingleView.fAutozoom := False;
          prev.bfaTlbPreview.sbmAutozoom.Action := prev.actZoomOff;
        end;
        frmMainForm.bfaTlbPreview1.sbmAutozoom.Action := frmMainForm.actZoomOff;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'ZoomOff', ClassName);
    end;
  finally
    img_DocView.UnLockPaint;
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ZoomOff', ClassName);
  end;
end;

procedure TbfaApplication.ZoomPage(prev: TbfaPreview; img_DocView: TbfaImageEnVect = nil; AThread: TThread = nil);
begin
  bitfarmLog.DebugBegin(llDebug, 'ZoomPage', ClassName);
  try
  if prev <> nil then
    img_DocView := prev.SingleView.img_DocView;

  img_DocView.LockPaint;
  try
    try
      try
        img_DocView.Fit;
      except
        // .Fit macht Probleme bei MultiView Prev
      end;

      if AThread <> nil then
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            if prev <> nil then
              prev.bfaTlbPreview.sbmAutozoom.Action := prev.actZoomPage;
            frmMainForm.bfaTlbPreview1.sbmAutozoom.Action := frmMainForm.actZoomPage;
          end);
      end
      else
      begin
        if prev <> nil then
          prev.bfaTlbPreview.sbmAutozoom.Action := prev.actZoomPage;
        frmMainForm.bfaTlbPreview1.sbmAutozoom.Action := frmMainForm.actZoomPage;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'ZoomPage', ClassName);
    end;
  finally
    img_DocView.UnLockPaint;
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ZoomPage', ClassName);
  end;
end;

procedure TbfaApplication.ZoomSelect(prev: TbfaPreview; img_DocView: TbfaImageEnVect = nil; AThread: TThread = nil);
begin
  bitfarmLog.DebugBegin(llDebug, 'ZoomSelect', ClassName);
  try
  if prev <> nil then
    img_DocView := prev.SingleView.img_DocView;

  img_DocView.LockPaint;
  try
    try
      if prev <> nil then
        prev.UnCheckAllGraphicTools;
      img_DocView.MouseInteract := [miSelectZoom];

      if AThread <> nil then
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            if prev <> nil then
              prev.bfaTlbPreview.sbmAutozoom.Action := prev.actZoomSelect;
            frmMainForm.bfaTlbPreview1.sbmAutozoom.Action := frmMainForm.actZoomSelect;
          end);
      end
      else
      begin
        if prev <> nil then
          prev.bfaTlbPreview.sbmAutozoom.Action := prev.actZoomSelect;
        frmMainForm.bfaTlbPreview1.sbmAutozoom.Action := frmMainForm.actZoomSelect;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'ZoomSelect', ClassName);
    end;
  finally
    img_DocView.UnLockPaint;
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ZoomSelect', ClassName);
  end;
end;

procedure TbfaApplication.ZoomWidth(prev: TbfaPreview; img_DocView: TbfaImageEnVect = nil; AThread: TThread = nil);
begin
  bitfarmLog.DebugBegin(llDebug, 'ZoomWidth', ClassName);
  try
  if prev <> nil then
    img_DocView := prev.SingleView.img_DocView;

  img_DocView.LockPaint;
  try
    try
      try
        img_DocView.FitToWidth;
        img_DocView.ViewX := 0;
        img_DocView.ViewY := 0;
      except
        on e: Exception do
        begin
          bitfarmLog.Write(llNormal, ltException, 'Error on fitwidth' + e.message, ClassName);
        end;
      end;

      if AThread <> nil then
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            if prev <> nil then
              prev.bfaTlbPreview.sbmAutozoom.Action := prev.actZoomWidth;
            frmMainForm.bfaTlbPreview1.sbmAutozoom.Action := frmMainForm.actZoomWidth;
          end);
      end
      else
      begin
        if prev <> nil then
          prev.bfaTlbPreview.sbmAutozoom.Action := prev.actZoomWidth;
        frmMainForm.bfaTlbPreview1.sbmAutozoom.Action := frmMainForm.actZoomWidth;
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'ZoomWidth', ClassName);
    end;
  finally
    img_DocView.UnLockPaint;
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ZoomWidth', ClassName);
  end;
end;

//04.08.2023 wegen Abstrze bei OutlookAddIn ein Test function TbfaApplication.CreatePDocument(FileName: WideString = ''): TbfaDocument;
function TbfaApplication.CreatePDocument(FileName: WideString = ''; WithoutOriStreamButFileName: Boolean = False): TbfaDocument;
var
  pDoc: TbfaDocument;
  imgV: TbfaImageEnVect;
  imgM, ThumbView: TbfaImageEnMView;
  iColors, i: Integer;
  DoWithScanPool: Boolean; //23.05.2018 Ticket 14576
begin
  bitfarmLog.DebugBegin(llDebug, 'CreatePDocument - FileName =(' + FileName + ')', ClassName);
  try
    try
      pDoc := TbfaDocument.Create;

      DoWithScanPool := (GetActivePreview.previewToolWindow.Visible) and (GetActivePreview = FPreviewContainer.ImporterItem.Preview);

      Log.Write(llDebug, ltInfo, 'Document created TempID:' + GUIDToString(pDoc.TempID), ClassName);
      if FileName <> '' then
      begin
        pDoc.FileType := ExtractFileExt(FileName);
        pDoc.DocName := ChangeFileExt(ExtractFileName(FileName), '');
        pDoc.FileName := ChangeFileExt(ExtractFileName(FileName), '');
        pDoc.HasPreview := IsImageFile(FileName);
        if pDoc.HasPreview then
        begin
          pDoc.DocType := dtScannedPage; //08.02.2019 Ticket 18037

          imgV := CreateInvisibleVect(nil);
          imgM := CreateInvisibleMView(nil);

          try
            imgV.IO.Params.ImageIndex := 0;
            imgV.IO.LoadFromFile(FileName);

            if LowerCase(ExtractFileExt(FileName)) = '.tif' then //nur Tiffs drfen wir komprimieren
            begin
              if (imgV.IO.Params.TIFF_Compression = ioTIFF_UNCOMPRESSED) or
                 (imgV.IO.Params.TIFF_Compression = ioTIFF_UNKNOWN) or
                 (imgV.IO.Params.TIFF_Compression = ioTIFF_OLDJPEG) //28.09.2018 OldJpeg macht probleme bei TIFFHandler
              then
              begin

                if LowerCase(ExtractFileExt(FileName)) = '.tif' then
                  imgM.MIO.LoadFromFileTIFF(FileName)
                else
                  imgM.MIO.LoadFromFile(FileName);
                CompressImage(iColors, imgV, imgM, 0);

                for i := 1 to imgM.ImageCount - 1 do
                begin
                  imgV.IO.Params.ImageIndex := i;
                  imgV.IO.LoadFromFile(FileName);
                  CompressImage(iColors, imgV, imgM, i);
                end;

                imgM.MIO.SaveToStreamTIFF(pDoc.DocStream);
                pDoc.DocStream.Position := 0;
              end
              else
              begin
                pDoc.DocStream.LoadFromFile(FileName);
              end;
            end
            else
            begin
              pDoc.DocStream.LoadFromFile(FileName);
            end;
          finally
            imgV.Free;
            imgV := nil;
            imgM.Free;
            imgM := nil;
          end;
        end
        else
        begin
          pDoc.DocType := dtFile; //08.02.2019 Ticket 18037

          imgV := CreateInvisibleVect(nil);
          try
            CreateEmptyImage(imgV, LowerCase(ExtractFileExt(FileName)), clWhite);
            imgV.IO.SaveToStreamTIFF(pDoc.DocStream);
          finally
            imgV.Free;
            imgV := nil;
          end;

        end;


        // SJ 25.10.2022 - manuell Stream laden hat den Vorteil, dass wir fmShareDenyNone
        // anstelle von fmShareDenyWrite (= LoadFromFile) nutzen knnen.
        // Somit knnen wir auch geffnete Dateien laden. Wird ja dann eh in appdata gespeichert
//      pDoc.OriStream.LoadFromFile(FileName);
//04.08.2023 wegen Abstrze bei OutlookAddIn ein Test -->
        if not WithoutOriStreamButFileName then
        begin
//04.08.2023 wegen Abstrze bei OutlookAddIn ein Test <--
          var
            Stream: TStream;
          begin
            pDoc.OriStream.Free;
            pDoc.OriStream := TFileStream.Create(FileName, fmOpenRead or fmShareDenyNone);
  //24.05.2023
  //          Stream := TFileStream.Create(FileName, fmOpenRead or fmShareDenyNone);
  //          try
  //              pDoc.OriStream.LoadFromStream(Stream);
  //          finally
  //            Stream.Free;
  //          end;
          end;
//04.08.2023 wegen Abstrze bei OutlookAddIn ein Test -->
        end
        else
        begin
          pDoc.OriStream.Free;
          pDoc.OriStream := nil;
        end;
//04.08.2023 wegen Abstrze bei OutlookAddIn ein Test <--

        pDoc.OriLoc := FileName;
        pDoc.DocLoc := FileName;

        bitfarmLog.Write(llDebug, ltInfo, 'Document Info TempID:' +
          GUIDToString(pDoc.TempID) + '; DocType: ' + IntToStr(pDoc.DocType) +
          '; FileType: ' + pDoc.FileType + '; HasPreview: ' +
          BoolToStr(pDoc.HasPreview, True), ClassName);
      end;

      Result := pDoc;
    except
      Result := nil;
      bitfarmLog.Write(llNormal, ltException, 'CreatePDocument - FileName =(' + FileName + ')', ClassName);
      if Assigned(pDoc) then
        pDoc.Free;
      pDoc := nil;
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreatePDocument - FileName =(' + FileName + ')', ClassName);
  end;
end;

procedure TbfaApplication.CreateStatefields(arcids: TStringList; AThread: TThread; intersection: Boolean);
var
  i, k, icount: Integer;
  statefieldcomp: TBfaStatefieldComp;
  aTempfields: TList<TbfaStateField>;
  stateid: Integer;
  qry: TUniQuery;
  orderby: string;
  tlbStatefields: TSpTBXToolbar;
  loadcurrentfields: Boolean;
  Statefield: TbfaStateField;
  fieldright: TbfaFieldRight;
begin
  Log.DebugBegin(llDebug, 'CreateStatefields', ClassName);
  try
    try
      try
        aTempfields := TList<TbfaStateField>.Create;
        loadcurrentfields := False;

        for k := 0 to arcids.Count - 1 do
        begin
          aTempfields.Clear;
          if  {(FCurrentContainer.Count = 0) and}   // nur wenn kein Dokument geladen ist, zeigen wir aus den CurrentFields an
            (((FPreviewContainer.ActiveItem = FPreviewContainer.ViewerItem.Panel.Tag) and (CurrentView = tvkViewer) and (StrToInt(arcids[k]) = CurrentViewerFields) and (aCurrentViewerStatefields.Count > 0)) or ((FPreviewContainer.ActiveItem = FPreviewContainer.ViewerItem.Panel.Tag) and (CurrentView = tvkResub) and (StrToInt(arcids[k]) = CurrentResubFields) and (aCurrentResubStatefields.Count > 0)) or ((FPreviewContainer.ActiveItem = FPreviewContainer.ImporterItem.Panel.Tag) and (CurrentView = tvkImporter) and (StrToInt(arcids[k]) = CurrentImporterFields) and (aCurrentImporterStatefields.Count > 0)) or ((FPreviewContainer.ActiveItem = FPreviewContainer.WorkplaceItem.Panel.Tag) and (CurrentView = tvkWorkplace))) then
          begin
            loadcurrentfields := True;
            if CurrentView = tvkViewer then
              aTempfields := aCurrentViewerStatefields
            else if CurrentView = tvkImporter then
              aTempfields := aCurrentImporterStatefields
            else if CurrentView = tvkResub then
              aTempfields := aCurrentResubStatefields;
          end
          else
          begin
            if (FCurrentContainer.Count > 0) then
            begin
              if FCurrentContainer[0].Id = -1 then   // es sei denn, wir sind ein importerdokument
              begin
                loadcurrentfields := (StrToInt(arcids[0]) = CurrentImporterFields) and (aCurrentImporterStatefields.Count > 0); // bei Archivwechsel neu laden

                aTempfields := aCurrentImporterStatefields
              end;
            end;
          end;

          if loadcurrentfields then
          begin
            AThread.Synchronize(nil,
              procedure
              var
                j: Integer;
              begin
                if aTempfields.Count > 0 then
                begin
                  for j := 0 to aTempfields.Count - 1 do
                  begin
                    stateid := aTempfields[j].Id;

                    statefieldcomp := TBfaStatefieldComp.Create(frmMainForm.tlbStatefields, 0, aStatefields[stateid].Displayname);
                    if statefieldcomp = nil then
                      Continue;
                    if arcids.Count > 1 then  // wenn wir mehrere Archive abfragen
                    begin                     // und in Rights ist ein READ bedeutet dass das fr dieses Feld
                      if (aStatefieldRights[stateid] and 1) = 1 then   // irgendwo nur READ-Rechte gesetzt wurde (in einem der Archive)
                        statefieldcomp.Rights := 1                            // daher setzen wir dieses Feld auch nur auf READ
                          else
                        statefieldcomp.Rights := aStatefieldRights[stateid];
                    end
                    else
                      statefieldcomp.Rights := aStatefieldRights[stateid];

                    Statefield := TbfaStateField.Create;
                    Statefield.Clone(aTempfields[j]);
                    Statefield.Component := statefieldcomp;
                    Statefield.Component.Modified := aTempfields[j].modified;
                    Statefield.Component.OnValueSet := Statefield.SetValue;
                    Statefield.Component.ViewKind := CurrentView;
                    if (Statefield.OldValue <> Null) and varIsType(Statefield.OldValue, varBoolean) then
                    begin
                      if Statefield.OldValue then
                        Statefield.Component.OldValue := fsSet
                      else
                        Statefield.Component.OldValue := fsNone;
                    end
                    else
                      Statefield.Component.OldValue := fsNone;
                    if (Statefield.Value <> Null) and varIsType(Statefield.Value, varBoolean) then
                    begin
                      if Statefield.Value then
                        Statefield.Component.Value := fsSet
                      else
                        Statefield.Component.Value := fsNone;
                    end
                    else
                      Statefield.Component.Value := fsNone;
                    aCurrentStatefields.Add(Statefield);
                    frmMainForm.tlbStatefields.Items.Add(statefieldcomp);
                  end;
                end;
                if (frmMainForm.tlbStatefields.Items.Count > 0) then
                  frmMainForm.tlbStatefields.Show;
              end);
          end
          else
          begin
            if OrderFieldsByName then
              orderby := ' order by displayname'
            else
              orderby := ' order by pos, displayname';

            qry := TUniQuery.Create(nil);
            qry.Connection := dmMain.cntMain;
            qry.SQL.Text := 'SELECT arcid,fieldid,userid,groupid,pos,rights +0 FROM sys_statefieldxs ' +
              'left join sys_statefields on sys_statefieldxs.fieldid = sys_statefields.stateid ' +
              'where arcid in (' + arcids[k] + ')' + 'and (userid in (' + user.HolidayList.CommaText + ') ' +
              'or (userid = 0 and groupid in (' + user.GroupList.CommaText +
              '))) and ((sys_statefields.flags & 2) = 0)' + orderby;

            qry.Execute;
            if qry.RecordCount > 0 then
            begin
              AThread.Synchronize(nil,
                procedure
                var
                  k: Integer;
                  found: Boolean;
                begin

                  qry.First;
                  i := 0;
                  while not qry.Eof do
                  begin
                    found := False;
                    stateid := qry.FieldByName('fieldid').AsInteger;

                    for k := 0 to aCurrentStatefields.Count - 1 do
                    begin
                      if aCurrentStatefields[k].Id = stateid then
                      begin
                        found := True;
                        break;
                      end;
                    end;

                    if not found then
                    begin
                      statefieldcomp := TBfaStatefieldComp.Create(frmMainForm.tlbStatefields, 0, aStatefields[stateid].Displayname);
                      if statefieldcomp = nil then
                      begin
                        qry.Next;
                        Continue;
                      end;
                      if arcids.Count > 1 then  // wenn wir mehrere Archive abfragen
                      begin                     // und in Rights ist ein READ bedeutet dass das fr dieses Feld
                        if (aStatefieldRights[stateid] and 1) = 1 then   // irgendwo nur READ-Rechte gesetzt wurde (in einem der Archive)
                          statefieldcomp.Rights := 1                            // daher setzen wir dieses Feld auch nur auf READ
                            else
                          statefieldcomp.Rights := aStatefieldRights[stateid];
                      end
                      else
                        statefieldcomp.Rights := aStatefieldRights[stateid];

                      Statefield := TbfaStateField.Create;
                      Statefield.Clone(aStatefields[stateid]);
                      Statefield.Component := statefieldcomp;
                      Statefield.Component.OnValueSet := Statefield.SetValue;
                      Statefield.Component.ViewKind := CurrentView;
                      Statefield.Assigned := True;

                      fieldright := TbfaFieldRight.Create;
                      fieldright.Fieldid := stateid;
                      fieldright.Userid := qry.FieldByName('userid').AsInteger;
                      fieldright.Groupid := qry.FieldByName('groupid').AsInteger;
                      fieldright.Rights := qry.FieldByName('rights +0').AsInteger;

                      fieldright.Fieldpos := qry.FieldByName('pos').AsInteger;
                      fieldright.ArcID := qry.FieldByName('arcid').AsInteger;

                      Statefield.FieldRights := TList<TbfaFieldRight>.Create;
                      Statefield.FieldRights.Add(fieldright);
                      aCurrentStatefields.Add(Statefield);
                      frmMainForm.tlbStatefields.Items.Add(statefieldcomp);
                    end
                    else
                    begin
                      fieldright := TbfaFieldRight.Create;
                      fieldright.Fieldid := stateid;
                      fieldright.Userid := qry.FieldByName('userid').AsInteger;
                      fieldright.Groupid := qry.FieldByName('groupid').AsInteger;
                      fieldright.Rights := qry.FieldByName('rights +0').AsInteger;

                      fieldright.Fieldpos := qry.FieldByName('pos').AsInteger;
                      fieldright.ArcID := qry.FieldByName('arcid').AsInteger;

                      aCurrentStatefields[k].FieldRights.Add(fieldright);
                    end;
                    inc(i);
                    qry.Next;
                  end;
                  if (frmMainForm.tlbStatefields.Items.Count > 0) then
                    frmMainForm.tlbStatefields.Show;
                end);

                // wenn wir auch auf dem Viewer oder Importtab stehen, dann setzen wir die Arrays neu
                // Im Workplace oder Resub setzen wir nichts bzw ViewerAddfields

              if (FPreviewContainer.ActiveItem = FPreviewContainer.ViewerItem.Panel.Tag) and (CurrentView = tvkViewer) then
              begin
                aCurrentViewerStatefields := aCurrentStatefields;
              end
              else if (FPreviewContainer.ActiveItem = FPreviewContainer.ViewerItem.Panel.Tag) and (CurrentView = tvkResub) then
              begin
                aCurrentResubStatefields := aCurrentStatefields;
              end
              else if (FPreviewContainer.ActiveItem = FPreviewContainer.ImporterItem.Panel.Tag) and (CurrentView = tvkImporter) then
              begin
                aCurrentImporterStatefields := aCurrentStatefields
              end
              else if not (FPreviewContainer.ActiveItem in [0, 1, 3]) then
                if (FCurrentContainer.Count > 0) then
                  if FCurrentContainer[0].arcid <> StrToInt(arcids[0]) then
                    for i := 0 to aCurrentStatefields.Count - 1 do
                    begin
                      Statefield := TbfaStateField.Create;
                      Statefield.Clone(aCurrentStatefields[i]);
                      FCurrentContainer[0].Statefields.Add(Statefield);
                    end;

            end;
          end;
        end;
      finally
        FreeAndNil(qry);
      end;
    except
      Log.Write(llNormal, ltException, 'CreateStatefields', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'CreateStatefields', ClassName);
  end;
end;

function TbfaApplication.CreateNewPList: TList<TbfaDocument>;
var
  NewList: TList<TbfaDocument>;
begin
  try
    NewList := TList<TbfaDocument>.Create;

    Result := NewList;
  except
    Result := nil;
  end;
end;

constructor TbfaPreviewContainer.Create;
begin
  FActive := -1;
  FMaxItemIdx := 0;
  FImporter := nil;
  FWorkplace := nil;
  FContainers := TList<TbfaPreviewContainerItem>.Create;
end;

destructor TbfaPreviewContainer.Destroy;
var
  i: Integer;
begin
  try
    try
      for i := FContainers.Count - 1 downto 0 do
      begin
        try
          FContainers[i].Free;
        finally
          FContainers[i] := nil;
        end;
        FContainers.Delete(i);
      end;

      FreeAndNil(FContainers);
    except

    end;
  finally
    inherited Destroy;
  end;
end;

function TbfaPreviewContainer.AddItem(PanelCaption: WideString; CloseOption: Boolean = False; InBackground: Boolean = False;
  Flt: Boolean = False; WithMultiAndThumbnailView: Boolean = True): TbfaPreviewContainerItem;
var
  Item: TbfaPreviewContainerItem;
begin
  try
    Item := TbfaPreviewContainerItem.Create(FOwner, FParent, FDock, FTabSet, PanelCaption, FMaxItemIdx, CloseOption, InBackground, Flt, FContainers.Count, WithMultiAndThumbnailView);
    Item.Panel.OnDockChanged := ContainerDockChanged;
    Item.Panel.OnCloseQuery := PanelCloseQuery;
    Item.Panel.Options.Maximize := True;
    Item.Panel.bfaMaximizePanel := bitfarmApp.MaximizePanel;

    FContainers.Add(Item);

    if (not InBackground) and (not Item.Preview.Floating) then
    begin
      FTabSet.Toolbar.BeginUpdate;
      FTabSet.ActiveTabIndex := Item.Panel.Tag;
      FTabSet.Toolbar.EndUpdate;
    end;

    Inc(FMaxItemIdx);
    Result := Item;
  except
    Result := nil;
  end;
end;

function TbfaPreviewContainer.CreatePageSortingsFrame(PanelCaption: WideString; CloseOption: Boolean = False): TbfaPreviewContainerItem;
var
  Item: TbfaPreviewContainerItem;
begin
  try
    Item := TbfaPreviewContainerItem.CreateWithoutTab(FOwner, FParent, frmMainForm.SpTBXMultiDock2, FTabSet, PanelCaption, FMaxItemIdx, CloseOption, FContainers.Count);
    Item.Panel.OnCloseQuery := PanelCloseQuery;
    Item.Panel.Options.Maximize := False;
    FContainers.Add(Item);
    FTabSet.Toolbar.BeginUpdate;
    FTabSet.ActiveTabIndex := Item.Panel.Tag;
    FTabSet.Toolbar.EndUpdate;
    Inc(FMaxItemIdx);
    Result := Item;
  except
    Result := nil;
  end;
end;

constructor TbfaPreviewContainerItem.Create(AOwner: TComponent; PanelPrnt: TWinControl; ActDock: TSpTBXMultiDock;
  TabPrnt: TSpTBXTabSet; PCaption: WideString; Idx: Integer; CloseOption: Boolean = False; InBackground: Boolean = False;
  Flt: Boolean = False; ItemTag: Integer = -1; WithMultiAndThumbnailView: Boolean = True);
var
  i: Integer;
  frm: TbfaFloatingForm;
begin
  if InBackground then
    Flt := False;

  FPanelCaption := PCaption;

  FPanel := TSpTBXDockablePanel.Create(AOwner);
  with FPanel do
  begin
    Visible := False;
    Parent := PanelPrnt;
    Tag := ItemTag;
    DockableTo := [];
    FloatingMode := fmOnTopOfParentForm;
    DockMode := dmCannotFloat;
    Name := 'pnl_' + IntToStr(Idx);
    Caption := PCaption;
    Options.Close := CloseOption;
    ShowCaptionWhenDocked := False;
    ShowCaption := True;
    LastDock := ActDock;
    Font.Size := bfaFontSize; //10.09.2020
    if not Flt then
    begin
      CurrentDock := ActDock;
      Floating := False;
    end
    else
    begin
      CurrentDock := nil;
      Floating := Flt;

      bitfarmApp.InCreateFloatingForm := True;
      try
        frm := TbfaFloatingForm.Create(Application);
//12.09.2019 -->
        frm.PopupParent := frm;
        frm.PopupMode := pmExplicit;
        frm.ShowHint := True; //05.11.2019
//12.09.2019 <--
        frm.OldDock := frmMainForm.dckDocumentEditors;
        FPanel.CurrentDock := frm.dckFloating;
        frm.Panel := FPanel;
        frm.Caption := FPanel.Caption;
        bitfarmApp.FloatingForms.Add(frm);
        frm.Show;
        frm.BringToFront;
      finally
        frm.FormActivate(frm);
      end;
    end;

    UseLastDock := True;

    OnDockChanging := bitfarmApp.PanelDockChanging;

    Visible := (not InBackground);

  end;

  FPreview := TbfaPreview.Create(FPanel, WithMultiAndThumbnailView, Idx);
  with FPreview do
  begin
    Parent := FPanel;
    Align := alClient;
    Visible := False; //18.04.2023
    //18.04.2023 -->
    SingleView.Update;
    Visible := True;
    //18.04.2023 <--
    Name := 'Preview_' + IntToStr(Idx);
    if WithMultiAndThumbnailView then
    begin
      MultiView.Name := 'MultiView_' + IntToStr(Idx);
      ThumbnailView.Name := 'ThumbnailView_' + IntToStr(Idx);
      dctPreviewTarget.Register(MultiView);
      dctPreviewTarget.Register(ThumbnailView);
      SingleView.Name := 'SingleView_' + IntToStr(Idx);
      dctPreviewTarget.Register(SingleView);
      Multiview.Update; //18.04.2023
    end;
//    SearchbarTextEdit.Color := stlControl.Color;
    SearchbarTextEdit.Color := cColorWhite;
    SearchbarTextEdit.Font.Color := stlControl.TextColor;
    FulltextView.OnResizeZoom := bitfarmApp.FulltextZoomResized;
  end;

  FTab := TabPrnt.Add(FPanelCaption);
  with FTab do
  begin
    Name := 'tab_' + IntToStr(Idx);
    Alignment := taCenter;
    Checked := False;
    CustomHeight := -1;
    CustomWidth := -1;
    Enabled := True;
    InheritOptions := True;
    MaskOptions := [];
    Options := [];
    Wrapping := twEndEllipsis;
    Visible := not Flt;
    OnDblClick := bitfarmApp.TabDblClick;
    OnTabClose := bitfarmApp.TabClose;
    FontSettings.Size := bfaFontSettingsSize; //10.09.2020
//    OnDrawCaption := OnDrawCaptionWithoutPrefix;  // SJ 06.09.2019
  end;

  fPreviousClientWidth := 0;
end;

constructor TbfaPreviewContainerItem.CreateWithoutTab(AOwner: TComponent; PanelPrnt: TWinControl; ActDock: TSpTBXMultiDock; TabPrnt: TSpTBXTabSet; PCaption: WideString; Idx: Integer; CloseOption: Boolean = False; ItemTag: Integer = -1; WithMultiAndThumbnailView: Boolean = False);
var
  i: Integer;
  frm: TbfaFloatingForm;
begin
  FPanelCaption := PCaption;

  FPanel := TSpTBXDockablePanel.Create(AOwner);
  with FPanel do
  begin
    Visible := False;
    Parent := PanelPrnt;
    Tag := ItemTag;
    DockableTo := [];
    DockMode := dmCannotFloatOrChangeDocks;
    FloatingMode := fmOnTopOfParentForm;
    Name := 'pnl_' + IntToStr(Idx);
    Caption := PCaption;
    Options.Close := CloseOption;
    ShowCaptionWhenDocked := False;
    ShowCaption := True;
    LastDock := ActDock;
    CurrentDock := ActDock;
    Floating := False;

    UseLastDock := True;
    Visible := True;
  end;

  FPreview := TbfaPreview.Create(FPanel, WithMultiAndThumbnailView, Idx);
  with FPreview do
  begin
    Parent := FPanel;
    Align := alClient;
    Name := 'Preview_' + IntToStr(Idx);
    SingleView.Name := 'SingleView_' + IntToStr(Idx);
    FulltextView.OnResizeZoom := bitfarmApp.FulltextZoomResized;
  end;

  FTab := TabPrnt.Add(FPanelCaption);
  with FTab do
  begin
    Name := 'tab_' + IntToStr(Idx);
    Alignment := taCenter;
    Checked := False;
    CustomHeight := -1;
    CustomWidth := -1;
    Enabled := False;
    Visible := False;
  end;
  fPreviousClientwidth := 0;
end;

procedure TbfaApplication.SChanged(Sender: TObject; AWindowState: TWindowState);
begin
  MaximizePanel(TSpTBXDockablePanel(Sender));
end;

procedure TbfaApplication.PanelKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  try
    case Key of
      VK_F12:
        begin
          MaximizePanel(TSpTBXDockablePanel(Sender));
        end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'PanelKeyUp', Classname);
  end;
end;

// bei einer MatchAgainst Suche mssen wir den String noch parsen
// da die mysql ein anderes Verhalten hat, was die Steuerzeichen angeht
// jedes Wort wird per ODER gesucht es sei denn es wird + und - verwendet
// das Wildcardsymbol ist *
// in unserer Suche wird aber jedes Wort per UND gesucht, es sei denn
// es wird - oder / verwendet, Wildcard ist %
function TbfaApplication.ParseMatchAgainstString(search: Widestring): Widestring;
var
  sltemp: TStringList;
  i: Integer;
begin
  Result := '';
  try
    sltemp := StrToWords4(search);
    for i := 0 to sltemp.Count - 1 do
    begin
      if LeftStr(sltemp[i], 1) = '%' then
      begin
        sltemp[i] := RightStr(sltemp[i], Length(sltemp[i]) - 1);

      end;

      if RightStr(sltemp[i], 1) = '%' then
      begin
        sltemp[i] := LeftStr(sltemp[i], Length(sltemp[i]) - 1) + '*';

      end;

      if LeftStr(sltemp[i], 1) = '/' then
      begin
        sltemp[i] := RightStr(sltemp[i], Length(sltemp[i]) - 1) + '*';
        Continue;
      end;

      if (LeftStr(sltemp[i], 1) <> '+') and (LeftStr(sltemp[i], 1) <> '-') then
      begin
        if RightStr(sltemp[i], 1) <> '"' then
        begin
          if pos('.', sltemp[i]) > 0 then //06.12.2018 '.' ist Trennzeichen, macht Probleme bei der Suche zB 3.346,24
            sltemp[i] := '+\"' + sltemp[i] + '*\"'
          else if (pos('-', sltemp[i]) > 1) and (pos(' -', sltemp[i]) = 0) then //11.01.2019 '-' ist Trennzeichen, macht Probleme bei der Suche zB 2018-01-01-125
            sltemp[i] := '+\"' + sltemp[i] + '*\"'
          else if (pos('+', sltemp[i]) > 1) and (pos(' +', sltemp[i]) = 0) then //11.01.2019 '+' ist Trennzeichen, macht Probleme bei der Suche zB 2018+01+01-125
            sltemp[i] := '+\"' + sltemp[i] + '*\"'
          else
            sltemp[i] := '+' + sltemp[i] + '*';
        end
        else
          sltemp[i] := '+' + sltemp[i];

        Continue;
      end;
    end;

    for i := 0 to sltemp.Count - 1 do
    begin
      if Result = '' then
        Result := sltemp[i]
      else
        Result := Result + ' ' + sltemp[i];
    end;
  finally
    FreeAndNil(sltemp);
  end;
end;

procedure TbfaApplication.ParseSQLWhereSObj(sobj: TbfaSearch);
var
  reg: TRegEx;
  matches: TMatchCollection;
  i, j: Integer;
begin
  if not VarIsNull(sobj.SQLWhere) then
  begin
    if pos('%username%', sobj.SQLWhere) > 0 then
    begin
      if (pos('like "%username%"', sobj.SQLWhere) > 0) or (pos('like ''%username%''', sobj.SQLWhere) > 0) then
        sobj.SQLWhere := StringReplace(sobj.SQLWhere, '%username%', '%'+ bitfarmApp.User.Name + '%', [rfReplaceAll])
      else
        sobj.SQLWhere := StringReplace(sobj.SQLWhere, '%username%', bitfarmApp.User.Name, [rfReplaceAll]);
    end;
    if pos('doctxt', sobj.SQLWhere) > 0 then
      sobj.SelectedCols := sobj.SelectedCols + ',doctxt';
    if pos('doctags', sobj.SQLWhere) > 0 then
      sobj.SelectedCols := sobj.SelectedCols + ',doctags';
    if pos('annotxt', sobj.SQLWhere) > 0 then
      sobj.SelectedCols := sobj.SelectedCols + ',annotxt';
    if Pos('fieldtxt', sobj.SQLWhere) > 0 then
      sobj.SelectedCols := sobj.SelectedCols + ',fieldtxt';
    if Pos('sg.groupid', sobj.SQLWhere) > 0 then
      sobj.SelectedCols := sobj.SelectedCols + ',sg.groupid';

    reg := TRegEx.Create('(add_\d+)');
    matches := reg.Matches(sobj.SQLWhere);

    for i:= 0 to matches.Count -1 do
    begin
      for j := Low(aAddfields) to High(aAddfields) do
      begin
        if (aAddfields[j] <> nil) and (aAddfields[j].Name = matches[i].Value) and
            (Pos(string(matches[i].Value + ':' + IntToStr(aAddfields[j].IndexTableID)), string(sobj.SelectedCols)) = 0) then
          sobj.SelectedCols := sobj.SelectedCols + ',' + matches[i].Value + ':' + IntToStr(aAddfields[j].IndexTableID);
      end;
    end;
  end;
end;

procedure TbfaApplication.PluginStamp(AThread: TThread;
  UserAction: PUserAction);
begin
 // Enterprise only
end;

function TbfaApplication.DeleteBraces(sql: TStringList): TStringList;
var
  i : Integer;
begin
  Result := TStringList.Create;
  if sql.Count < 3 then
  begin
    Result.Assign(sql);
    Exit;
  end;

  i := 0;
  while i + 2 <= sql.Count +1 do
  begin
    if (sql[i] = '(') and
        (sql[i + 1] <> '(') and (sql[i + 1] <> ')') and
        (sql[i +2] = ')') then begin
      Result.Add(sql[i + 1]);
      i := i + 2;
    end else
      Result.Add(sql[i]);

    Inc(i);
  end;
end;

procedure TbfaApplication.CreateBookmarkSobj(var sobj: TbfaSearch; var lstSQLWhere: TStringList);
var
  i, j, k : Integer;
  sql : WideString;
  expr : TbfaExpression;
  reg : TRegEx;
  match: TMatch;
  matches : TMatchCollection;
  datestr, dateformat, sStrToDateString : string;
  value : WideString;
  statefield : TbfaStateField;
  add, state, field: string;
begin
  try
    try
      bitfarmLog.DebugBegin(llDebug, 'CreateBookmarkSobj', Classname);
      for i := 0 to lstSQLWhere.Count -1 do
      begin
        if (TObject(lstSQLWhere.Objects[i]) is TbfaBracket) and
            (TbfaBracket(lstSQLWhere.Objects[i]).Kind = brOpen) then
          sql := sql +'( ';
        if (TObject(lstSQLWhere.Objects[i]) is TbfaBracket) and
            (TbfaBracket(lstSQLWhere.Objects[i]).Kind = brClose) then
          sql := sql +' )';

        if (TObject(lstSQLWhere.Objects[i]) is TbfaJunction) and
            (TbfaJunction(lstSQLWhere.Objects[i]).Kind = jnAND) then
          sql := sql +' and ';

        if (TObject(lstSQLWhere.Objects[i]) is TbfaJunction) and
            (TbfaJunction(lstSQLWhere.Objects[i]).Kind = jnOR) then
          sql := sql +' or ';

        if (TObject(lstSQLWhere.Objects[i]) is TbfaExpression) then
        begin
          expr := TbfaExpression(lstSQLWhere.Objects[i]);
          value := expr.Value;
          if Integer(expr.Fieldtype) <> 9 then     // Addfields und DocumentFields
          begin
            if (expr.Fieldtype = zfld01_Datum) or (expr.Fieldtype = zfld12_DLMDate) or
               ((expr.Fieldtype = zfld10_Document) and
                  ((expr.Field = 'docdate')
                or (expr.Field = 'date(docdate)')
                or (expr.Field = 'day(docdate)')
                or (expr.Field = 'week(docdate)')
                or (expr.Field = 'month(docdate)')
                or (expr.Field = 'year(docdate)')
                or (expr.Field = 'sd.modified')
                or (expr.Field = 'date(sd.modified)')
                or (expr.Field = 'days(sd.modified)')
                or (expr.Field = 'week(sd.modified)')
                or (expr.Field = 'month(sd.modified)')
                or (expr.Field = 'year(sd.modified)')
                or (expr.Field = 'expired')
                or (expr.Field = 'date(expired)')
                or (expr.Field = 'day(expired)')
                or (expr.Field = 'week(expired)')
                or (expr.Field = 'month(expired)')
                or (expr.Field = 'year(expired)')  )) then
            begin
              // wenn ein datumsstring im value ist, aber kein str_to_date
              if LeftStr(value, 11) <> 'str_to_date' then
              begin
                reg := TRegEx.Create('(\d{2}.\d{2}.\d{4}|\d{4}.\d{2}.\d{2})');
                matches := reg.Matches(value);

      //          if match.Success then
                for k:= 0 to matches.Count -1 do
                begin
                  datestr := matches[k].Groups[0].Value;

                  dateformat := CheckDateFormat(datestr, sysDateFormat);
                  // Ticket 16108: Mehrfaches ersetzen fhrt zu SQL-Fehler.
                  sStrToDateString := 'str_to_date(' +#34+ datestr +#34+ ',' +#34+ dateformat +#34+ ')';
                if Pos(sStrToDateString, string(value)) <= 0 then
                  value := ReplaceStr(value, datestr, ' ' + sStrToDateString + ' ');
                end;
              end;

              if (expr.DateFormat = dtfDate) and (LeftStr(expr.Field,9) <> 'date(add_') then
                expr.Field := 'date(' + expr.Field + ')'
              else if (expr.DateFormat = dtfDay) and (LeftStr(expr.Field,8) <> 'day(add_') then
                expr.Field := 'day(' + expr.Field + ')'
              else if (expr.DateFormat = dtfMonth) and (LeftStr(expr.Field,10) <> 'month(add_')then
                expr.Field := 'month(' + expr.Field + ')'
              else if (expr.DateFormat = dtfYear) and (LeftStr(expr.Field,9) <> 'year(add_') then
                expr.Field := 'year(' + expr.Field + ')';
            end;

            if ((expr.Fieldtype = zfld10_Document) and
                ((expr.Field = 'doctxt') or (expr.Field = 'doctags') or
                (expr.Field = 'annotxt') or (expr.Field = 'fieldtxt'))) then //12.10.2017 12163
            begin
              if Pos('doctxt', sobj.SelectedCols) = 0 then
                sobj.SelectedCols := sobj.SelectedCols + ',doctxt';
              if Pos('doctags', sobj.SelectedCols) = 0 then
                sobj.SelectedCols := sobj.SelectedCols + ',doctags';
              if Pos('annotxt', sobj.SelectedCols) = 0 then
                sobj.SelectedCols := sobj.SelectedCols + ',annotxt';
              if Pos('fieldtxt', sobj.SelectedCols) = 0 then
                sobj.SelectedCols := sobj.SelectedCols + ',fieldtxt';
            end;

            if (expr.Fieldtype = zfld10_Document) and
               (expr.Field = 'refname') then
            begin
              if Pos('refname', sobj.SelectedCols) = 0 then
                sobj.SelectedCols := sobj.SelectedCols + ',refname';
            end;

            if (expr.Fieldtype = zfld10_Document) and
               (expr.Field = 'filetype') then //12.10.2017 12163
            begin
              if Pos('filetype', sobj.SelectedCols) = 0 then
                sobj.SelectedCols := sobj.SelectedCols + ',filetype';
            end;

            if expr.Fieldtype <> zfld10_Document then
            begin
              if (LeftStr(expr.Field,8) = 'day(add_') then
              begin
                field := MidStr(expr.Field, 5, Length(expr.Field) -5);
              end else if (LeftStr(expr.Field,9) = 'week(add_') then
              begin
                field := MidStr(expr.Field, 6, Length(expr.Field) -6);
              end else if (LeftStr(expr.Field,10) = 'month(add_') then
              begin
                field := MidStr(expr.Field, 7, Length(expr.Field) -7);
              end else if (LeftStr(expr.Field,9) = 'year(add_') then
              begin
                field := MidStr(expr.Field, 6, Length(expr.Field) -6);
              end else if (LeftStr(expr.Field,9) = 'date(add_') then
              begin
                field := MidStr(expr.Field, 6, Length(expr.Field) -6);
              end
              else begin
                field := expr.Field;
              end;

              add := field +':' + IntToStr(expr.IndexID);
              if Pos(add, sobj.SelectedCols) = 0 then
                sobj.SelectedCols := sobj.SelectedCols + ',' + add;
            end;

             if (expr.Fieldtype = zfld10_Document) and
                ((expr.Field = 'doctxt') or (expr.Field = 'doctags') or (expr.Field = 'fieldtxt') or (expr.Field = 'annotxt')) and
                (expr.op = 'match') then
               sql := sql + '(' + Trim(expr.junction.display + ' ' + 'MATCH (') + expr.Field + ') AGAINST (' + value + ' IN BOOLEAN MODE))'
             else
               sql := sql + '(' + Trim(expr.junction.display + ' ' + expr.Field + ' ' + expr.op + ' ' + value) +')';

          end else if Integer(expr.Fieldtype) = 9 then    // Statefields
          begin
            statefield := bitfarmApp.GetStatefieldByID(expr.ID);
            if statefield <> nil then
            begin
              if expr.Status then
                value := IntToStr(statefield.Bitmask)
              else
                value := '0';
              state := 'docstate_' + IntToStr(statefield.IndexColumnID) + ' & ' + IntToStr(statefield.Bitmask);

              sql := sql + '(' + Trim(expr.junction.display + ' ' + state + ' ' + expr.op + ' ' + value) +')';
            end;
          end;
        end;
      end;

      sobj.SQLWhere := sql;
      sobj.AddFields.Clear;
      sobj.StsFields.Clear;
      sobj.SearchString := null;
      sobj.SearchStringNegated := False;
      sobj.RefSearch := null;
      sobj.RefSearchNegated := False;
      sobj.FileType := null;
      sobj.FileTypeNegated := False;
      sobj.DocName := null;
      sobj.DocNameNegated := False;
      sobj.SearchUserID := -1;
      sobj.SearchUserNegated := False;
      sobj.SearchGroupID := -1;
      sobj.SearchGroupNegated := False;
      sobj.GdocID.Clear;
      sobj.FtxFields := 0;
      sobj.SearchDate := null;
      sobj.SearchDateHigh := null;
      sobj.SearchDateNegated := False;
    except
      bitfarmLog.Write(llNormal, ltException, 'CreateBookmarkSobj', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateBookmarkSobj', Classname);
  end;
end;

procedure TbfaApplication.PanelDockChanging(Sender: TObject; Floating: Boolean; DockingTo: TTBDock);
var
  Monitor: TRect;
begin
  try
    if DockingTo = nil then
    begin
      with FViewerOptions.GUIOptions do
      begin
        Monitor := GetRectOfMonitorContainingWindow(TSpTBXDockablePanel(Sender).Handle, True);
        if (StoredFloatingPosX < 0) or (StoredFloatingPosY < 0) then
          TSpTBXDockablePanel(Sender).FloatingPosition := Point(1, 1)
        else
          TSpTBXDockablePanel(Sender).FloatingPosition := Point(StoredFloatingPosX, StoredFloatingPosY);
        TSpTBXDockablePanel(Sender).FloatingClientWidth := StoredFloatingWidth;
        TSpTBXDockablePanel(Sender).FloatingClientHeight := StoredFloatingHeight;
        TSpTBXDockablePanel(Sender).FloatingFullScreen := StoredFloatingFullScreen;
        TSpTBXDockablePanel(Sender).FloatingOldPos := Point(StoredFloatingOldPosX, StoredFloatingOldPosY);
        TSpTBXDockablePanel(Sender).FloatingOldWidth := StoredFloatingOldWidth;
        TSpTBXDockablePanel(Sender).FloatingOldHeight := StoredFloatingOldHeight;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'PanelDockChanging', Classname);
  end;
end;

function TbfaApplication.GetPanelByTab(ATab: TSpTBXTabItem): TSPTbxDockablePanel;
var
  i: Integer;
  found: Boolean;
begin
  Result := nil;
  try
    found := False;
    i := 0;
    while ((not found) and (i <= FPreviewContainer.Containers.Count - 1)) do
    begin
      if FPreviewContainer.Containers[i].Tab = ATab then
        found := True
      else
        inc(i);
    end;
    if found then
      result := FPreviewContainer.Containers[i].Panel;
  except
    Result := nil;
  end;
end;

function TbfaApplication.GetPreviewStream(SrcDoc: TbfaDocument): TMemoryStream;
var
  req: TbfaRequest;
  sock: TSocketConnection;
  Doc: TbfaDocument;
begin
  result := nil;
  sock := TSocketConnection.Create(bfaServerNoSSL, bfaServer, bfaServerPort, '');
  Doc := TbfaDocument.Create;
  req := TbfaRequest.Create;
  try
    sock.CreateComponents;
    if sock.Connect then
    begin
      req.ReqType := 'reqPreview';
      req.UserID := user.ID;
      req.Profile := Self.Profile;
      req.Gdocid := SrcDoc.ID;
      req.Parameter := 'base;paths';
      req.Lang := Lang;
      sock.SendRequestToServer(req);

      req := sock.ReceiveData(Doc, nil);
      sock.Disconnect;
      if req = nil then
        Exit;

      if (req.ReqType = 'respDoc') or (req.ReqType = 'respOK') then
      begin
        Doc.DocStream.Position := 0;
        result := TMemoryStream.Create;
        result.CopyFrom(Doc.DocStream, Doc.DocStream.Size);
      end
      else
      begin
        BfShowMessage(_('Die Voransicht konnte nicht geladen werden.') + #13#10 + req.DataString);
      end;
    end;
  finally
    sock.Disconnect;
    FreeAndNil(req);
    FreeAndNil(sock);
    FreeAndNil(Doc);
  end;
end;

procedure TbfaApplication.TabClose(Sender: TObject);
var
  pnl: TSpTBXDockablePanel;
  CanClose: Boolean;
begin
  if (Sender is TSpTBXTabItem) then
  begin
    pnl := GetPanelByTab(TSpTBXTabItem(Sender));
    FPreviewContainer.PanelCloseQuery(pnl, CanClose);
  end;
end;

procedure TbfaApplication.ShowPanelUndocked(AThread: TThread; pnl: TSpTBXDockablePanel);
var
  frm: TbfaFloatingForm;
begin
  bitfarmLog.DebugBegin(llDebug, 'ShowPanelUndocked', Classname);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          if pnl <> nil then
          begin
            frm := TbfaFloatingForm.Create(Application);
            frm.PopupParent := frm;
            frm.PopupMode := pmExplicit;
            frm.ShowHint := True; //05.11.2019
            frm.OldDock := pnl.CurrentDock;
            bitfarmApp.fSkipTabChangeEvent := True;
            try
              pnl.CurrentDock := frm.dckFloating;
            finally
              bitfarmApp.fSkipTabChangeEvent := False;
            end;
            frm.Panel := pnl;
            frm.Caption := FCurrentContainer[0].DocName;
            FloatingForms.Add(frm);
            with FPreviewContainer.Containers[pnl.Tag].Preview do
            begin
              bfaTlbPreview.Visible := True;
              bfaTlbStandard.Visible := True;
              if bfaTlbImporter <> nil then
                bfaTlbImporter.Visible := True;

              frmMainForm.actAutozoom.Execute;
            end;

            FPreviewContainer.Containers[frmMainForm.tstDocumentEditors.ActiveTabIndex].Panel.Visible := True;
            frm.Show;

          end;
        end);
      ShowActiveTabAction(pnl.Tag);
    except
      bitfarmLog.Write(llNormal, ltException, 'ShowPanelUndocked', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ShowPanelUndocked', Classname);
  end;
end;

procedure TbfaApplication.TabDblClick(Sender: TObject);
var
  UserAction: PUserAction;
  pnl: TSpTBXDockablePanel;
begin
  if InPanelClose then
    Exit;

  bitfarmLog.DebugBegin(llDebug, 'TabDblClick', Classname);
  try
    try
      if (Sender is TSpTBXTabItem) then
      begin
        pnl := GetPanelByTab(TSpTBXTabItem(Sender));
        if (pnl.Tag > pvtWorkplace) then
        begin
          UserAction := CreateUserAction;
          UserAction^.ActionName := 'actUndockTab';
          UserAction^.objects.Add(pnl);
          FMainThread.Add(UserAction);
        end
        else if (pnl.Tag = pvtViewer) and (Self.GetActivePreview.ActiveDoc <> nil) then
          Self.GetActivePreview.OpenDocInNewTab
        else if ((pnl.Tag = pvtImporter) or (pnl.Tag = pvtWorkplace)) and
                (TbfaPreview(Self.GetActivePreview).PreviewKind = pvkMultiSingle)
        then
          Self.GetActivePreview.OpenDocInNewTab;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'TabDblClick', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'TabDblClick', Classname);
  end;
end;

destructor TbfaPreviewContainerItem.Destroy;
var
  i: Integer;
begin
  try
    try
      FreeAndNil(FTab);
      FPreview.Free;
      FreeAndNil(FPanel);
    except
    end;
  finally
    try
      inherited Destroy;
    except
    end;
  end;
end;

procedure TbfaPreviewContainer.ContainerDockChanged(Sender: TObject);
var
  Act: Integer;
  found: Boolean;
  i: Integer;
begin
  Act := TSpTBXDockablePanel(Sender).Tag;
  OneContainerDockChanged(FContainers[Act].Tab, FContainers[Act].Panel);
  FContainers[Act].Preview.SetActivePreview(Sender);

  try
    found := False;
    i := 0;
    while ((not found) and (i <= FContainers.Count - 1)) do
    begin
      if not FContainers[i].Panel.Floating then
        found := True;
      inc(i);
    end;

    if not found then
    begin
      { TODO -o b.takacs : hier muss  multidock visible false setzen }
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'ContainerDockChanged', Classname);
  end;
end;

procedure TbfaPreviewContainer.OneContainerDockChanged(Tab: TSpTBXTabItem; Pnl: TSpTBXDockablePanel);
var
  ActiveTabIdx, i: Integer;
  found: Boolean;
begin
  try
    FTabSet.Toolbar.BeginUpdate;
    try
      ActiveTabIdx := FTabSet.ActiveTabIndex;
      if ActiveTabIdx < 0 then
        ActiveTabIdx := 0;
      Tab.Visible := //(not Pnl.Floating) or
        (Pnl.Parent.Name <> 'dckFloating');
      if not Tab.Visible then
      begin
        found := false;
        i := ActiveTabIdx;
        while ((not found) and (i >= 0)) do
        begin
          if FTabSet.Items[i].Visible then
          begin
            FTabSet.ActiveTabIndex := i;
            found := True;
          end;
          dec(i);
        end;
        i := ActiveTabIdx;
        while ((not found) and (i <= FTabSet.Items.Count - 1)) do
        begin
          if FTabSet.Items[i].Visible then
          begin
            FTabSet.ActiveTabIndex := i;
            found := True;
          end;
          inc(i);
        end;

        if ((FPreviewPanel.Visible) and (found)) then
          FTabSet.ActiveTab.Click
        else if (not found) and (Pnl.Parent.Name <> 'dckFloating') then // wenn keinsichtbare Tab gefunden
          FPreviewPanel.Visible := False;
      end
      else
      begin
        if (not FPreviewPanel.Visible) then
          FPreviewPanel.Visible := True;
        Tab.Click;
      end;
    finally
      FTabSet.Toolbar.EndUpdate;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'OneContainerDockChanged', Classname);
  end;
end;

procedure TbfaPreviewContainer.PanelCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  UserAction: PUserAction;
begin
  if Sender = FPageSortingsItem.Panel then
  begin
    CanClose := False;
    bitfarmApp.CreateHidePageSortingsFrameAction;
  end
  else
  begin
    try
      bitfarmApp.InPanelClose := True;
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actPanelClose';
      UserAction^.objects.Add(Sender);
      bitfarmApp.MainThread.Add(UserAction);
      CanClose := False;
    except
      bitfarmLog.Write(llNormal, ltException, 'PanelClose', Classname);
    end;
  end;
end;

procedure TbfaApplication.PanelClose(AThread: TThread; Objects: TList);
var
  i, j, rslt: Integer;
  found, foundFloating, Floating: Boolean;
  frm: TbfaFloatingForm;
begin
  InPanelClose := True;
  try
    if True then
    try
      frm := nil;
      i := 0;
      found := False;

      Floating := (TObject(Objects[0]) is TbfaFloatingForm);

      with FViewerOptions.GUIOptions do
      begin
        if (Floating) then
        begin
          frm := TbfaFloatingForm(Objects[0]);
          StoredFloatingPosX := frm.Left;
          StoredFloatingPosY := frm.Top;
          StoredFloatingWidth := frm.Width;
          StoredFloatingHeight := frm.Height;
          StoredFloatingFullScreen := (frm.WindowState = wsMaximized);
        end;
      end;

      while ((i <= FPreviewContainer.Containers.Count - 1) and (not found)) do
      begin
        if (Assigned(frm) and (FPreviewContainer.Containers.Items[i].Panel = frm.Panel)) or
           ((not Assigned(frm)) and (FPreviewContainer.Containers.Items[i].Panel = TSpTBXDockablePanel(Objects[0]))) and
           (FPreviewContainer.Containers.Items[i].Panel <> FPreviewContainer.PageSortingsItem.Panel) and //29.06.2017 Der drfte nicht geschlossen werden!
           (FPreviewContainer.Containers.Items[i].Panel <> FPreviewContainer.ViewerItem.Panel) and
           (FPreviewContainer.Containers.Items[i].Panel <> FPreviewContainer.ImporterItem.Panel) then
        begin
          found := True;

          AThread.Synchronize(nil,
            procedure
            begin
              if FPreviewContainer.Containers.Items[i].Preview.SingleView.gbAnnoNotSaved then
              begin
                SaveAnnoObjects(AThread, FPreviewContainer.Containers[i].Preview.SingleView, FPreviewContainer.Containers[i].Preview.ActiveDoc, FPreviewContainer.Containers[i].Preview, False, False);
              end;
              if FPreviewContainer.Containers.Items[i].Preview.SingleView.fRefreshInOtherPrevs then
              begin
                bitfarmApp.CreateRefreshDocumentInPreviewsAction(FPreviewContainer.Containers.Items[i].Preview.ActiveDoc,
                  GetActivePreview, nil, False, False); //25.04.2019 von saveannostream raus, hier rein!
                FPreviewContainer.Containers.Items[i].Preview.SingleView.fRefreshInOtherPrevs := False;
              end;
            end);

          if (FPreviewContainer.Containers.Items[i].Preview.Floating) and (not IsDocumentInOtherPreview(FPreviewContainer.Containers.Items[i].Preview, FPreviewContainer.Containers.Items[i].Preview.Activedoc)) and FPreviewContainer.Containers.Items[i].Preview.Activedoc.InEditMode then
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                rslt := BfMessageDlg(_('Mchten Sie die nderungen speichern?'), mtConfirmation, [mbYes, mbNo], True);
              end);
            if rslt = mrYes then
              Save(AThread)
            else
              Cancel(AThread);
          end;

          AThread.Synchronize(nil,
            procedure
            begin
              if FPreviewContainer.Containers[i].Preview.GetThumbnailInProcess then
                FPreviewContainer.Containers[i].Preview.KillThumbnailThread;

              FPreviewContainer.Containers[i].Tab.Visible := False;
              FPreviewContainer.Containers[i].Destroy;

              FPreviewContainer.Containers.Delete(i);

              if Assigned(frm) then
              begin
                j := 0;
                foundFloating := False;
                while ((not foundFloating) and (j <= FloatingForms.Count - 1)) do
                begin
                  if FloatingForms[j] = frm then
                  begin
                    foundFloating := True;
                    FloatingForms.Delete(j);
                  end
                  else
                    inc(j);
                end;
                frm.Destroy;
              end;
            end);
        end;
        inc(i);
      end;

      for i := 0 to FPreviewContainer.Containers.Count - 1 do //Wichtig wegen ActiveItem
      begin
        FPreviewContainer.Containers.Items[i].Panel.Tag := i;
      end;

      if (not Floating) then // Dann muss ein sichtbares Tab anzeigen
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            InPanelClose := False;
            frmMainForm.SetActiveTab;
          end);
      end;

    except

    end;
  finally
    InPanelClose := False;
  end;
end;

procedure TbfaPreviewContainer.SetActive(Value: Integer);
begin
  try
    FActive := Value;
  except
    FActive := -1;
  end;
end;

procedure TbfaApplication.SetPanelCaption(var Cptn: WideString; Idx: Integer);
begin
  try
    if Assigned(FPreviewContainer.Containers[Idx]) then
    begin
      Cptn := _(FPreviewContainer.Containers[Idx].PanelCaption);

      if ((FPreviewContainer.ImporterItem <> nil) and (Idx = FPreviewContainer.ImporterItem.Panel.Tag)) then
        Cptn := Cptn + ' (' + IntToStr(FImportContainer.Count) + ')'
      else if ((FPreviewContainer.WorkplaceItem <> nil) and (Idx = FPreviewContainer.WorkplaceItem.Panel.Tag)) then
        Cptn := Cptn + ' (' + IntToStr(FWorkplaceContainer.Count) + ')';
    end;
  except

  end;
end;

procedure TbfaApplication.SetPanelCaptionActiv(Idx: Integer);
var
  Cptn: WideString;
begin
  FLog.DebugBegin(llDebug, 'SetPanelCaptionActiv', Classname);
  try
    try
      SetPanelCaption(Cptn, Idx);

      // Setzt Aktiv Panel Caption
      if Assigned(FPreviewContainer.Containers[Idx]) then
      begin
        if FPreviewContainer.Containers[Idx].Panel.Floating then
        begin
          FPreviewContainer.Containers[Idx].Panel.Caption := Cptn;
        end
        else
        begin
          FPreviewContainer.Containers[Idx].Tab.Caption := Cptn;
          FPreviewContainer.Containers[Idx].Panel.Caption := '';
        end;
      end;
    except
      FLog.Write(llNormal, ltException, 'SetPanelCaptionActiv', Classname);
    end;
  finally
    FLog.DebugEnd(llDebug, 'SetPanelCaptionActiv', Classname);
  end;
end;

procedure TbfaApplication.RefreshPanelCaption(Idx: Integer);
var
  PCaption: WideString;
begin
  bitfarmLog.DebugBegin(llDebug, 'RefreshPanelCaption', Classname);
  try
    try
      SetPanelCaptionActiv(Idx);
    except
      bitfarmLog.Write(llNormal, ltException, 'RefreshPanelCaption', Classname);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'RefreshPanelCaption', Classname);
  end;
end;

{//
Name: ActivatePreview
Parameters:
Beschreibung:
  Zeigt das Aktive Preview an. Setzt die Actions, und malt das GUI wie zB StatusKnpfe
//-----------------------------------------------------------------------------}
procedure TbfaApplication.ActivatePreview;
begin
  try
    if ((FPreviewContainer.ActiveItem <> -1) and (FPreviewContainer.ActiveItem <= FPreviewContainer.Containers.Count)) then // bfacrm:ticket__show__24275   9/30/2020

    begin
      if FPreviewContainer.ActiveItem = FPreviewContainer.Containers.Count then         // bfacrm:ticket__show__24275            9/30/2020
         FPreviewContainer.ActiveItem  :=    FPreviewContainer.ActiveItem -1;                 //bfacrm:ticket__show__24275        9/30/2020

      with FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview do
      begin
        if (list <> nil) and (list.Count > 0) and (PreviewKind <> pvkMulti) then
        begin
          ShowPageNumber;
          cbxZoomChange(bfaTlbPreview.cbxZoom);
        end;

        if (frmMainForm.bfaTlbPreview1.sbmAutozoom <> nil)
           and (bfaTlbPreview.sbmAutozoom.ImageIndex <> -1) and frmmainform.fappstarted//24.09.2020 wurde ergnzt
        then
          frmMainForm.bfaTlbPreview1.sbmAutozoom.ImageIndex := bfaTlbPreview.sbmAutozoom.ImageIndex;
      end;

      if (FCurrentContainer.Count > 0) and (CurrentView <> TbfaViewKind(tvkAdministrator)) then
        ShowDocumentProperties(FCurrentContainer[0], FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview)
      else
        ShowDocumentProperties(nil, nil);

      if FCurrentContainer.Count > 0 then
      begin
        if FCurrentContainer[0].InEditMode then
          SetSaveButton(FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview)
        else
          ResetButtons(True);
      end
      else
        ResetButtons(False);

      if GetActivePreview = FPreviewContainer.ImporterItem.Preview then
        frmMainForm.grpIndexing.Visible := ImporterShowIndexing
      else
        frmMainForm.grpIndexing.Visible := ViewerShowIndexing;

      //02.07.2019
      frmMainForm.tstDocumentEditors.Repaint;
      frmMainForm.tstDocumentEditors.UpdateControlState;
      frmMainForm.tstDocumentEditors.Refresh;
      frmMainForm.tstDocumentEditors.Update;

    end
    else
      ResetDocumentProperties;
  except
    bitfarmLog.Write(llNormal, ltException, 'ActivatePreview', Classname);
  end;
end;

procedure TbfaApplication.actUndockInNewTabExecute(Sender: TObject);
var
  prev: TbfaPreview;
  Lst: TList<TbfaDocument>;
  i, j: Integer;
  DocInEdit: Boolean;
  FloatingForm: TForm;
begin
  try
    try
      Lst := nil;
      prev := bitfarmApp.GetActivePreview;
      FloatingForm := nil;

      if (prev = nil) or (prev.ActiveDoc = nil) then
        Exit;

      // Trefferliste
      if (frmMainForm.ppmToolsPopupInResultGrid) then
      begin
        for i := 0 to FCurrentContainer.Count - 1 do
        begin
          try
            CallShowDocument(FCurrentContainer[i], nil, nil, TbfaDocument(FCurrentContainer[i]).ID, 0, False, (prev.Parent.Tag <= pvtWorkplace), True, (FCurrentContainer[i].EditmodeUserID = bitfarmApp.User.ID), True, False, prev);
          except
            bitfarmLog.Write(llNormal, ltException, 'actUndockInNewTabExecute - #1 - ResultGrid - CallShowDocument', Classname);
          end;
        end;
      end

      // Voransicht
      else if (Screen.ActiveControl is TbfaImageEnVect) then
      begin
        // Hauptitems
        if (prev.Parent.Tag <= pvtWorkplace) and (not prev.Floating) then
          CallShowDocument(FCurrentContainer[0], nil, nil, TbfaDocument(FCurrentContainer[0]).ID, prev.ActivePage, False, (prev.Parent.Tag <= pvtWorkplace), True, (FCurrentContainer[0].EditmodeUserID = bitfarmApp.User.ID), True, False, prev)

        // Floating-Forms
        else if (prev.Parent.Tag >= pvtWorkplace) and (prev.Floating) then
        begin
          try
            bitfarmApp.InDockChanged := True;
            if (prev.Parent is TSpTBXDockablePanel) and (TSpTBXDockablePanel(prev.Parent).Parent.Parent is TForm) then
            begin
              // bfacrm:ticket__show__28944
              FloatingForm := TForm(TSpTBXDockablePanel(prev.Parent).Parent.Parent);
              with bitfarmApp.ViewerOptions.GUIOptions do
              begin
                StoredFloatingPosX := FloatingForm.Left;
                StoredFloatingPosY := FloatingForm.Top;
                StoredFloatingWidth := FloatingForm.Width;
                StoredFloatingHeight := FloatingForm.Height;
                StoredFloatingFullScreen := (FloatingForm.WindowState = wsMaximized);
              end;
              FloatingForm.Hide;
              // bfacrm:ticket__show__28944
              TbfaPreview(prev).ShowToolbars(False);
              TSpTBXDockablePanel(prev.Parent).CurrentDock := frmMainForm.dckDocumentEditors;
              frmMainForm.SetFocus;
            end;
          finally
            bitfarmApp.InDockChanged := False;
            ShowActiveTabAction(prev.Parent.Tag);
          end;
        end;
      end

      // ThumbnailView
      else if (Screen.ActiveControl.Tag = tagThumbnailMView) and (prev.ActiveDoc.HasPreview) and
              (prev.ThumbnailView.MultiSelectedImagesCount > 0)
      then
        CallShowDocument(prev.ActiveDoc, nil, nil, TbfaDocument(prev.ActiveDoc).ID, prev.ThumbnailView.MultiSelectedImages[0], False, (prev.Parent.Tag <= pvtWorkplace), True, (prev.ActiveDoc.EditmodeUserID = bitfarmApp.User.ID), True, False, prev)

      // MultiView
      else if (Screen.ActiveControl is TbfaImageEnMView) and (prev.PreviewKind = pvkMulti) then
      begin
        // Einzelnes Dokument ausgewhlt
        if (prev.MultiView.MultiSelectedImagesCount = 1) and (prev.ActiveDoc.HasPreview) then
          CallShowDocument(FCurrentContainer[0], nil, nil, TbfaDocument(FCurrentContainer[0]).ID, prev.ActivePage, False, (prev.Parent.Tag <= pvtWorkplace), True, (prev.ActiveDoc.EditmodeUserID = bitfarmApp.User.ID), True, False, prev)

        // Mehrere Dokumente ausgewhlt
        // SetActions setzt die Action nur Enabled, wenn mindestens ein Dokument eine Voransicht hat
        else
        begin
          Lst := TList<TbfaDocument>.Create;
          for i := prev.MultiView.MultiSelectedImagesCount - 1 downto 0 do
          begin
            if (prev.List[prev.MultiView.MultiSelectedImages[i]].HasPreview) then
              Lst.Add(prev.List[prev.MultiView.MultiSelectedImages[i]])
            else
            begin
              if (FCurrentContainer[i] <> nil) then
              begin
                try
                  for j := 0 to FCurrentContainer.Count -1 do
                  begin
                    if (TbfaDocument(prev.List[prev.MultiView.MultiSelectedImages[j]]) = TbfaDocument(FCurrentContainer[i])) then
                    begin
                      try
                        // Dokumente ohne Voransicht werden aus CurrentContainer geworfen
                        FCurrentContainer[j] := nil;
                        FCurrentContainer.Delete(j);
                        Break;
                      except
                        bitfarmLog.Write(llNormal, ltException, 'actUndockInNewTabExecute - #2 - delete from CurrentContainer', Classname);
                      end;
                    end;
                  end;
                except
                  bitfarmLog.Write(llNormal, ltException, 'actUndockInNewTabExecute - #3 - something in the loop went wrong', Classname);
                end;
              end;
              // Dokumente ohne Voransicht werden deselektiert
              prev.MultiView.UnSelectImage(prev.MultiView.MultiSelectedImages[i]);
            end;
          end;

          try
            // Statusbar neu gesetzt
            ShowDocumentProperties(FCurrentContainer[0], prev);
            // ActiveDoc neu gesetzt
            prev.ActiveDoc := FCurrentContainer[0];
          except
            bitfarmLog.Write(llNormal, ltException, 'actUndockInNewTabExecute - #4', Classname);
          end;

          // fr jedes Dokument mit Voransicht ein neuer Tab
          if (Lst.Count > 0) then
          begin
            for i := 0 to Lst.Count-1 do
            begin
              try
                DocInEdit := (TbfaDocument(Lst[i]).ID = -1) or (FCurrentContainer[i].EditmodeUserID = bitfarmApp.User.ID);
                CallShowDocument(Lst[i], nil, nil, TbfaDocument(Lst[i]).ID, 0, True, (prev.Parent.Tag <= pvtWorkplace), True, DocInEdit, True, True, prev, False, '', True);
              except
                bitfarmLog.Write(llNormal, ltException, 'actUndockInNewTabExecute - #5 - MultiView - CallShowDocument', Classname);
              end;
            end;
          end;
        end;
      end;

      if (TAction(Sender).ActionComponent = frmMainForm.itmDocInNewTab) then
        frmMainForm.actUndockDefault := frmMainForm.actUndockInNewTab;
    except
      bitfarmLog.Write(llNormal, ltException, 'actUndockInNewTabExecute - #0', Classname);
    end;
  finally
    frmMainForm.ppmToolsPopupInResultGrid := False;
  end;
end;

procedure TbfaApplication.actUndockInNewWindowExecute(Sender: TObject);
var
  prev: TbfaPreview;
  Lst: TList<TbfaDocument>;
  i, j: Integer;
  DocInEdit: Boolean;
  UserAction: PUserAction;
begin
  try
    try
      Lst := nil;
      prev := bitfarmApp.GetActivePreview;

      if (prev = nil) or (prev.ActiveDoc = nil) then
        Exit;

      // Trefferliste
      if (frmMainForm.ppmToolsPopupInResultGrid) or (prev.Parent.Tag <= pvtWorkplace) then
      begin
        for i := 0 to FCurrentContainer.Count - 1 do
        begin
          try
            CallShowDocument(FCurrentContainer[i], nil, nil, TbfaDocument(FCurrentContainer[i]).ID, 0, False,
              (prev.Parent.Tag <= pvtWorkplace), False, TbfaDocument(FCurrentContainer[i]).InEditMode, True,
              False, prev, False, GetSearchString, False, False, False, True, -1, True);
          except
            bitfarmLog.Write(llNormal, ltException, 'actUndockInNewWindowExecute - #1 - ResultGrid - CallShowDocument', Classname);
          end;
        end;
      end

      // Voransicht
      else if (Screen.ActiveControl is TbfaImageEnVect) or (prev.Parent.Tag > pvtWorkplace) then
      begin
        // Hauptitems
        if (prev.Parent.Tag <= pvtWorkplace) and (not prev.Floating) then
          CallShowDocument(FCurrentContainer[0], nil, nil, TbfaDocument(FCurrentContainer[0]).ID, prev.ActivePage,
            False, (prev.Parent.Tag <= pvtWorkplace), False, (FCurrentContainer[0].EditmodeUserID = bitfarmApp.User.ID),
            True, False, prev, False, GetSearchString, False, False, False, True, -1, True)

        // Tabs
        else if (prev.Parent.Tag >= pvtWorkplace) and (not prev.Floating) then
        begin
          UserAction := CreateUserAction;
          UserAction^.ActionName := 'actUndockTab';
          UserAction^.Objects.Add(TSpTBXDockablePanel(prev.Parent));
          MainThread.Add(UserAction);
        end;

      // ThumbnailView
      end else if (Screen.ActiveControl.Tag = tagThumbnailMView) and (prev.ActiveDoc.HasPreview)
          and (prev.ThumbnailView.MultiSelectedImagesCount > 0) and (prev.Parent.Tag > pvtWorkplace) then
      begin
        UserAction := CreateUserAction;
        UserAction^.ActionName := 'actUndockTab';
        UserAction^.Objects.Add(TSpTBXDockablePanel(prev.Parent));
        MainThread.Add(UserAction);
      end

      // MultiView
      else if (Screen.ActiveControl is TbfaImageEnMView) and
              (
                (prev.PreviewKind = pvkMulti) or
                ((prev.ThumbnailView.MultiSelectedImagesCount > 0) and (not (prev.Parent.Tag > pvtWorkplace)))
              ) then
      begin
        // Einzelnes Dokument ausgewhlt
        if (prev.MultiView.MultiSelectedImagesCount = 1) and (prev.ActiveDoc.HasPreview) then
          CallShowDocument(FCurrentContainer[0], nil, nil, TbfaDocument(FCurrentContainer[0]).ID, prev.ActivePage, False, (prev.Parent.Tag <= pvtWorkplace), False, (prev.ActiveDoc.EditmodeUserID = bitfarmApp.User.ID), True, False, prev, False, GetSearchString, False, False, False, True, -1, True)

        // Mehrere Dokumente ausgewhlt
        // SetActions setzt die Action nur Enabled, wenn mindestens ein Dokument eine Voransicht hat
        else
        begin
          Lst := TList<TbfaDocument>.Create;
          for i := prev.MultiView.MultiSelectedImagesCount - 1 downto 0 do
          begin
            if (prev.List[prev.MultiView.MultiSelectedImages[i]].HasPreview) then
              Lst.Add(prev.List[prev.MultiView.MultiSelectedImages[i]])
            else
            begin
              if (FCurrentContainer[i] <> nil) then
              begin
                try
                  for j := 0 to FCurrentContainer.Count -1 do
                  begin
                    if (TbfaDocument(prev.List[prev.MultiView.MultiSelectedImages[j]]) = TbfaDocument(FCurrentContainer[i])) then
                    begin
                      try
                        // Dokumente ohne Voransicht werden aus CurrentContainer geworfen
                        FCurrentContainer[j] := nil;
                        FCurrentContainer.Delete(j);
                        Break;
                      except
                        bitfarmLog.Write(llNormal, ltException, 'actUndockInNewWindowExecute - #2 - delete from CurrentContainer', Classname);
                      end;
                    end;
                  end;
                except
                  bitfarmLog.Write(llNormal, ltException, 'actUndockInNewWindowExecute - #3 - something in the loop went wrong', Classname);
                end;
              end;
              // Dokumente ohne Voransicht werden deselektiert
              prev.MultiView.UnSelectImage(prev.MultiView.MultiSelectedImages[i]);
            end;
          end;

          try
            // Statusbar neu gesetzt
            ShowDocumentProperties(FCurrentContainer[0], prev);
            // ActiveDoc neu gesetzt
            prev.ActiveDoc := FCurrentContainer[0];
          except
            bitfarmLog.Write(llNormal, ltException, 'actUndockInNewWindowExecute - #4', Classname);
          end;

          // fr jedes Dokument mit Voransicht ein neues Fenster
          if (Lst.Count > 0) then
          begin
            for i := 0 to Lst.Count-1 do
            begin
              try
                DocInEdit := (TbfaDocument(Lst[i]).ID = -1) or (FCurrentContainer[i].EditmodeUserID = bitfarmApp.User.ID);
                CallShowDocument(Lst[i], nil, nil, TbfaDocument(Lst[i]).ID, 0, True, (prev.Parent.Tag <= pvtWorkplace), True, DocInEdit, True, True, prev, False, GetSearchString, True, False, False, True, -1, True);
              except
                bitfarmLog.Write(llNormal, ltException, 'actUndockInNewWindowExecute - #5 - MultiView - CallShowDocument', Classname);
              end;
            end;
          end;
        end;
      end;

      if (TAction(Sender).ActionComponent = frmMainForm.itmDocInNewWindow) then
        frmMainForm.actUndockDefault := frmMainForm.actUndockInNewWindow;
    except
      bitfarmLog.Write(llNormal, ltException, 'actUndockInNewWindowExecute - #0', Classname);
    end;
  finally
    frmMainForm.ppmToolsPopupInResultGrid := False;
  end;
end;

procedure TbfaApplication.actF2Execute(Sender: TObject);
begin
  // SJ 26.04.2022 - bfacrm:ticket__show__30789
  // Bei ausgedockten Suchoptionen hat es Probleme gemacht das ber KeyUp zu lsen.
  // KeyUp muss halt auf jeder Form einzeln definiert werden... Deswegen Action
  //
  // Sollten manche F2 Funktionen nicht funktionieren,
  // nach "bfacrm:ticket__show__30789" im Projekt suchen
  // Gab noch Lsungen in bfaPreview36 und FloatingForm, welche aber scheinbar nicht
  // bentigt werden bei der Lsung ber Action

  // <!-- TForm1.FormKeyUp
  if (bitfarmApp.CurrentView = tvkAdministrator) then
    frmMainForm.fraAdmin.btnSaveAdmin.Click
  else
  begin
    if bitfarmApp.ActivePreview.ActiveDoc <> nil then
    begin
      if bitfarmApp.ActivePreview.PreviewKind = pvkMulti then
      begin
        if (bitfarmApp.ActivePreview.ActiveDoc.ID <> -1) then
        begin
          if (not bitfarmApp.ActivePreview.ActiveDoc.InEditMode) then
            frmMainForm.actInProgress.Execute
          else
            frmMainForm.actSave.Execute;
        end
        else
          frmMainForm.actChangeDocName.Execute;
      end
      else if (bitfarmApp.ActivePreview.ActiveDoc.ID <> -1) then
      begin
        if (not bitfarmApp.ActivePreview.ActiveDoc.InEditMode) then
          frmMainForm.actInProgress.Execute
        else
        begin
          if Assigned(frmMainForm.ActiveControl) {Task 14604 Speichern mit F2} and
             Assigned(frmMainForm.ActiveControl.Parent) and
             (frmMainForm.ActiveControl.Parent is TcxDateEdit) and
             (TcxDateEdit(frmMainForm.ActiveControl.Parent).Parent is TbfaAddfieldComp)
          then
            // Der Vergleich ist nicht erforderlich: Man kann immer den sichtbaren Wert durchposten.
            // Bei leerem Feld, fhr dies zu auerdem zu einer Exception
            {(TbfaAddfieldComp(TcxDateEdit(ActiveControl.Parent).Parent).compDateLow.Text <>
                 TbfaAddfieldComp(TcxDateEdit(ActiveControl.Parent).Parent).compDateLow.EditValue) then }
            TbfaAddfieldComp(TcxDateEdit(frmMainForm.ActiveControl.Parent).Parent).compDateLow.PostEditValue;

          frmMainForm.actSave.Execute;
        end;
      end;
    end;
  end;
  // TForm1.FormKeyUp -->
end;

procedure TbfaApplication.SetImporterScrollBox;
begin
  try
    if CurrentView <> tvkImporter then
    begin
      if frmMainForm.scrbxStandardImporter.Visible then
      begin
        frmMainForm.scrbxStandardImporter.Visible := False;
        frmMainForm.scrbxStandard.Visible := True;
      end;
    end
    else
    begin
      if frmMainForm.scrbxStandard.Visible then
      begin
        frmMainForm.scrbxStandard.Visible := False;
        frmMainForm.scrbxStandardImporter.Visible := True;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetImporterScrollBox', Classname);
  end;
end;

procedure TbfaApplication.ShowFloatingResub;
  procedure EnableResubControls(Enable : Boolean);
  var
    i: Integer;
  begin
    for i := 0 to frmMainForm.fraFloatingResub.fraResub.ComponentCount - 1 do
    begin
      try
        if (frmMainForm.fraFloatingResub.fraResub.Components[i] is TSpTBXLabel) or
           (frmMainForm.fraFloatingResub.fraResub.Components[i] is TSpTBXButton) or
           (frmMainForm.fraFloatingResub.fraResub.Components[i] is TSpTBXEdit) or
           (frmMainForm.fraFloatingResub.fraResub.Components[i] is TcxDateEdit) or
           (frmMainForm.fraFloatingResub.fraResub.Components[i] is TSpTBXComboBox)
        then
          TWinControl(frmMainForm.fraFloatingResub.fraResub.Components[i]).Enabled := Enable;
      except
      end;
    end;
  end;
var
  CanEnable : Boolean;
begin
  try
    if frmmainform.fAppStarted then
    begin
      if //16.03.2022 ((CurrentView = tvkViewer) or (CurrentView = tvkFavorites)) and
          frmMainForm.ShowFloatingResub then
      begin
        if frmMainForm.fraFloatingResub = nil then
        begin
          frmMainForm.pnlFloatingResub.Floating := True;
          frmMainForm.fraFloatingResub := TfraFloatingResub.Create(frmMainForm);
          frmMainForm.fraFloatingResub.Parent := frmMainForm.pnlFloatingResub;
          frmMainForm.fraFloatingResub.Align := alClient;
          if Assigned(frmMainForm.pnlFloatingResub.Parent) and
             (frmMainForm.pnlFloatingResub.Parent.Left = 0) and
             (frmMainForm.pnlFloatingResub.Parent.Top = 0) then
          begin
            frmMainForm.pnlFloatingResub.Parent.Top := frmMainForm.Top + 150;
            frmMainForm.pnlFloatingResub.Parent.Left := frmMainForm.Left + 30;
          end;
          bitfarmApp.ChangeGridSkin(frmMainForm.fraFloatingResub.grdResubResultlistDevExView);
        end;
        ReadResubUserGroups(frmMainForm.fraFloatingResub.fraResub);

        CanEnable := CurrentView in [tvkViewer, tvkFavorites, tvkWorkplace];

        frmMainForm.fraFloatingResub.ShowResubGrid;
        frmMainForm.fraFloatingResub.Enabled := CanEnable;
        frmMainForm.fraFloatingResub.fraResub.Enabled := CanEnable;
        frmMainForm.fraFloatingResub.fraResub.cxDateNavigator1.Enabled := CanEnable;
        if CanEnable then
        begin
//27.02.2024          frmMainForm.fraFloatingResub.fraResub.cxDateNavigator1.Styles.Background := stlBackgroundStyle;
          frmMainForm.fraFloatingResub.fraResub.cxDateNavigator1.Styles.Background := stlControl;
          frmMainForm.fraFloatingResub.fraResub.cxDateNavigator1.Styles.Content := stlFree;
          frmMainForm.fraFloatingResub.fraResub.cxDateNavigator1.Styles.Header := stlColumn;
          frmMainForm.fraFloatingResub.fraResub.cxDateNavigator1.Styles.Selection := stlSelected;
        end
        else
        begin
//27.02.2024          frmMainForm.fraFloatingResub.fraResub.cxDateNavigator1.Styles.Background := stlBackgroundStyle;
          frmMainForm.fraFloatingResub.fraResub.cxDateNavigator1.Styles.Background := stlControl;
          frmMainForm.fraFloatingResub.fraResub.cxDateNavigator1.Styles.Content := stlBackgroundStyle;
          frmMainForm.fraFloatingResub.fraResub.cxDateNavigator1.Styles.Header := stlBackgroundStyle;
          frmMainForm.fraFloatingResub.fraResub.cxDateNavigator1.Styles.Selection := stlBackgroundStyle;
        end;

        EnableResubControls(CanEnable);
        frmMainForm.fraFloatingResub.grdResultlistDevEx.Enabled := CanEnable;
        frmMainForm.pnlFloatingResub.Visible := True;
        frmMainForm.fraFloatingResub.grdResultlistDevEx.Invalidate;
        bitfarmApp.CheckResub(nil);
      end
      else
      begin
        if (frmMainForm.pnlFloatingResub <> nil) and (frmMainForm.fraFloatingResub <> nil) then
        begin
//09.03.2022          frmMainForm.pnlFloatingResub.Hide;  sollte immer sichtbar sein!
          frmMainForm.fraFloatingResub.Enabled := False;
          frmMainForm.fraFloatingResub.fraResub.Enabled := False;
          frmMainForm.fraFloatingResub.fraResub.cxDateNavigator1.Enabled := False;
//27.02.2024          frmMainForm.fraFloatingResub.fraResub.cxDateNavigator1.Styles.Background := stlBackgroundStyle;
          frmMainForm.fraFloatingResub.fraResub.cxDateNavigator1.Styles.Background := stlControl;
          frmMainForm.fraFloatingResub.fraResub.cxDateNavigator1.Styles.Content := stlBackgroundStyle;
          frmMainForm.fraFloatingResub.fraResub.cxDateNavigator1.Styles.Header := stlBackgroundStyle;
          frmMainForm.fraFloatingResub.fraResub.cxDateNavigator1.Styles.Selection := stlBackgroundStyle;

          frmMainForm.fraFloatingResub.grdResultlistDevEx.Enabled := False;
          EnableResubControls(False);
          frmMainForm.fraFloatingResub.grdResultlistDevEx.Invalidate;
        end;
      end;
      frmMainForm.bfaTlbStandard1.tlbStandardFloatingWVL.Checked := frmMainForm.pnlFloatingResub.Visible;
    end;
  except
  end;
end;

procedure TbfaApplication.EnableFloatingResub(Sender: TObject);
begin
  frmMainForm.ShowFloatingResub := True;
  ShowFloatingResub;
end;

procedure TbfaApplication.CloseFloatingResub(Sender: TObject);
begin
  frmMainForm.ShowFloatingResub := False;
  frmMainForm.bfaTlbStandard1.tlbStandardFloatingWVL.Checked := False;
end;

procedure TbfaApplication.CanResizeFloatingResub(Sender: TObject; var NewWidth, NewHeight: Integer; var Resize: Boolean);
var
  MinHeight, MinWidth: Integer;
begin
  if (TSpTBXDockablePanel(Sender).Parent is TSpTBXFloatingWindowParent) then
  begin
    MinHeight := (323 + TSpTBXDockablePanel(Sender).Options.TitleBarMaxSize +
                  TSpTBXDockablePanel(Sender).GetFloatingBorderSize.X +
                  TSpTBXDockablePanel(Sender).Margins.Bottom);
    MinWidth := (595 + TSpTBXDockablePanel(Sender).GetFloatingBorderSize.Y +
                 TSpTBXDockablePanel(Sender).Margins.Right);

    if TSpTBXFloatingWindowParent(TSpTBXDockablePanel(Sender).Parent).Constraints.MinHeight <> MinHeight then
      TSpTBXFloatingWindowParent(TSpTBXDockablePanel(Sender).Parent).Constraints.MinHeight := MinHeight;

    if TSpTBXFloatingWindowParent(TSpTBXDockablePanel(Sender).Parent).Constraints.MinWidth <> MinWidth then
      TSpTBXFloatingWindowParent(TSpTBXDockablePanel(Sender).Parent).Constraints.MinWidth := MinWidth;
  end;
end;

{//-----------------------------------------------------------------------------
Name: SetActivePreview
Parameters: Idx - Preview Index welche angezeigt werden soll
Beschreibung:
  Prft das Aktiv Dokument und speichert wenn notwendig
  Schaltet die ausgewlhte Preview Tab und Panel wird angezeigt, schaltet
    zwischen Viewer und Importer
  Setzt das ausgewhlte Dokument Aktiv und aktualisiert die Zusatzfeldern
//-----------------------------------------------------------------------------}
procedure TbfaApplication.SetActiveView(AThread: TThread; Idx: Integer; Sender: TObject = nil;
  ViewKind: Integer = 0; force_loadfields : Boolean = False);
var
  arcids: TStringList;
  dontloadfields, DoCreateFields,
  changedview, ResubTabStop: Boolean;
  ReloadViewerGrid: Boolean; //16.11.2023
begin
  bitfarmLog.DebugBegin(llDebug, 'SetActiveView', Classname);
  try
    try
      dontloadfields := False;
      changedview := False;
      DoCreateFields := False;
      LastView := CurrentView; //14.08.2017

      if (TbfaViewKind(CurrentView) in [tvkViewer, tvkResub, tvkFavorites]) then
        FViewerSplitterSize := frmMainForm.SpTBXDockablePanel1.Height
      //07.09.2023 Start mit Imporer Splitter falsch -->
      else if (TbfaViewKind(CurrentView) in [tvkImporter]) then
        FImporterSplitterSize := frmMainForm.SpTBXDockablePanel1.Height
      //07.09.2023 <--
      else if TbfaViewKind(CurrentView) = tvkAdministrator then
      begin  //Splitterpositionen beim wechseln mssen auch gespeichert werden
        var IniFile : TIniFile;
        IniFile := TIniFile.Create(BD.AppdataBitfarmPd + 'ViewerLayout.ini');
        try
          frmMainForm.SaveAdminFrameControls(IniFile);
        finally
          FreeAndNil(IniFile);
        end;
      end;

      if (FPreviewContainer.Containers.Count > 0) then
      begin
        if (TbfaViewKind(ViewKind) <> CurrentView) then
        begin
          HidePageSortingsFrame(AThread); //30.06.2017 wenn geffnet, dann sollte geschloen werden

          changedview := True;
          if (CurrentView = tvkViewer) and (FPreviewContainer.ActiveItem = 0) then // wir merken uns nur die Felder wenn wir auch auf der jeweiligen Hauptview sind
          begin
            aCurrentViewerAddfields := CloneAddfields(aCurrentAddfields);
            aCurrentViewerStatefields := CloneStatefields(aCurrentStatefields);
          end
          else if (CurrentView = tvkResub) and (FPreviewContainer.ActiveItem in [0, 3]) then  // wir merken uns nur die Felder wenn wir auch auf der jeweiligen Hauptview sind
          begin
            aCurrentResubAddfields := CloneAddfields(aCurrentAddfields);
            aCurrentResubStatefields := CloneStatefields(aCurrentStatefields);
          end
          else if (CurrentView = tvkImporter) and (FPreviewContainer.ActiveItem = 1) then   // wir merken uns nur die Felder wenn wir auch auf der jeweiligen Hauptview sind
          begin
            aCurrentImporterAddfields := CloneAddfields(aCurrentAddfields);
            aCurrentImporterStatefields := CloneStatefields(aCurrentStatefields);
          end;
          if CurrentView = tvkAdministrator then  // wenn wir den Administrator verlassen checken wir Holiday
          begin                                   // es knnte sein, dass wir uns nmlich selbst rausgenommen haben
            CheckHoliday;                         // und das geht im Administrator ohne zu speichern...
            aCurrentResubAddfields.Clear;         // auerdem setzen wir die felder zurck, damit die neu geladen werden
            aCurrentResubStatefields.Clear;
            try
              if frmMainForm.FAdminTreeview <> nil then //08.03.2024 wegen Offline Viewer
              begin
                //10.01.2020 neue inis -->
                if frmMainForm.FAdminTreeview.IniName <> 'ViewerLayout.ini' then
                  frmMainForm.FAdminTreeview.Ininame := 'ViewerLayout.ini';
                //10.01.2020 <--
                frmMainForm.FAdminTreeview.SaveToINI;
              end;
            except
              bitfarmLog.Write(llNormal, ltException, ' frmMainForm.FAdminTreeview.SaveToINI;', ClassName);
            end;
          end;
        end;

        // Eingaben im ImporterAddfields merken
        if (FPreviewContainer.ActiveItem > 5) and (FCurrentContainer.Count > 0) and (FCurrentContainer[0].Id = -1) then
        begin
          aCurrentImporterAddfields := CloneAddfields(aCurrentAddfields);

          aCurrentImporterStatefields := CloneStatefields(aCurrentStatefields);
          if (TbfaViewKind(ViewKind) = tvkImporter) then
            dontloadfields := True;  // wechseln wir von einem ImporterTab auf die Importerview muss nicht neu angezeigt werden
        end;

        // wechsel des Views auf Viewer,Importer oder Lesezeichen und wir sind ein StandardTab (FPreviewContainer.ActiveItem < 6)
        if (TbfaViewKind(ViewKind) <> CurrentView) and (FPreviewContainer.ActiveItem < 6) and
           (TbfaViewKind(ViewKind) in [tvkViewer, tvkImporter, tvkFavorites])
        then
          dontloadfields := True;   //werden in ChangeArchive geladen

        // kein Wechsel des Views, wir sind im Viewer, aber Wechseln von einem Dokumenttab
        // auf den ViewerTab (zB durch Klick aufs Grid)
        if (TbfaViewKind(ViewKind) = CurrentView) and (CurrentView = tvkViewer) and
           (FPreviewContainer.ActiveItem > 5) and (Idx = 0)
        then
          dontloadfields := True;

        // hier wird der ActiveView gesetzt!
        LastView := CurrentView;
        CurrentView := TbfaViewKind(ViewKind);

        //03.07.2023 bfacrm:ticket__show__35043 -->
        if (TbfaViewKind(LastView) in [tvkViewer, tvkResub, tvkFavorites]) and
           (CurrentView = tvkAdministrator) and frmMainForm.fAppStarted then
          WriteSortings;
        //03.07.2023 bfacrm:ticket__show__35043 <--

        frmMainForm.tbsubToolbars.Enabled := CurrentView <> tvkAdministrator;
        frmMainForm.tbsubLayout.Enabled := CurrentView <> tvkAdministrator;
//14.11.2023
//        if AThread <> nil then
//        begin
//          AThread.Synchronize(nil,
//            procedure
//            begin
//              frmMainForm.SpTBXSplitter3.Visible := CurrentView <> tvkImporter; //27.09.2023 bfacrm:ticket__show__36355
//              SetImporterScrollBox;
//            end);
//        end
//        else
//        begin
//          frmMainForm.SpTBXSplitter3.Visible := CurrentView <> tvkImporter; //27.09.2023 bfacrm:ticket__show__36355
//          SetImporterScrollBox;
//        end;

        //09.08.2022 Ticket 31853 -->
        if not changedview then
        begin
          DoCreateFields := (CurrentView in [tvkViewer, tvkResub, tvkFavorites]) and
                            (FPreviewContainer.ActiveItem <> Idx);
        end;
        //09.08.2022 Ticket 31853 <--

        //16.11.2023 bfacrm:ticket__show__33996 -->
        ReloadViewerGrid := False;
        if CurrentView = tvkViewer then
          ReloadViewerGrid := not ((CurrentView = tvkViewer) and (frmMainForm.grdResultlistDevExView.Kind = gkSearch));
        //16.11.2023 <--

        if AThread <> nil then
        begin
        AThread.Synchronize(nil,
          procedure
          begin
            FPreviewContainer.ActiveItem := Idx;

            if CurrentView = tvkResub then
            begin
              if frmMainForm.fraResub.ResubKind in [rkMyTasks, rkNone] then
                frmMainForm.grdResultlistDevExView.Kind := gkResub
              else
                frmMainForm.grdResultlistDevExView.Kind := gkResubDelegate;
            end
            else
              if CurrentView in [tvkViewer, tvkFavorites] then //16.11.2023 bfacrm:ticket__show__33996
                frmMainForm.grdResultlistDevExView.Kind := gkSearch;
          end);
        end else
        begin
          FPreviewContainer.ActiveItem := Idx;

          if CurrentView = tvkResub then
          begin
            if frmMainForm.fraResub.ResubKind in [rkMyTasks, rkNone] then
              frmMainForm.grdResultlistDevExView.Kind := gkResub
            else
              frmMainForm.grdResultlistDevExView.Kind := gkResubDelegate;
          end
          else
            if CurrentView in [tvkViewer, tvkFavorites] then //16.11.2023 bfacrm:ticket__show__33996
              frmMainForm.grdResultlistDevExView.Kind := gkSearch;
        end;

        if AThread <> nil then
          AThread.Synchronize(nil,
            procedure
            begin
              ShowFloatingResub;
              ShowToolbars(CurrentView <> tvkAdministrator);
            end);

        if changedview and frmMainForm.fAppStarted then
          LeaveCurrentDocs(AThread);

        if frmMainForm.fAppStarted and //24.09.2019
           changedview and (     // es ist noch ein Dokument geladen aber die View wurde auf oder von resub gewechselt
           (//28.03.2017 Ticket 10075 (FCurrentContainer.Count > 0) and
           ((LastView = tvkResub) or (CurrentView = tvkResub))) or    // oder wir wechseln von oder auf die Favoriten
           ((LastView = tvkFavorites) or (CurrentView = tvkFavorites))) then
        begin
          // Dokument resetten
          ClearFields(AThread);
          if ((CurrentView = tvkFavorites) and (LastView <> tvkViewer)) then// 05.09.2017 Ticket 10003
          begin
            DeleteAddfields(AThread);
            DeleteStatefields(AThread);
            CreateGrid(-1, AThread);
          end;
          Reset(AThread);
        end;

        if frmMainForm.fAppStarted then    // wir wollen SetCurrentDocs nicht beim Programmstart, unntigerweise
          SetCurrentDocs(nil, nil, GetActivePreview, AThread);

        if Idx in [0, 1, 2, 5] then
        begin
          if AThread <> nil then
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                ShowSelectedMainPreview(Idx, AThread);
              end);
          end
          else
            ShowSelectedMainPreview(Idx, nil);
        end;

        if AThread <> nil then
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              if changedview then
              begin
                if CurrentView = tvkImporter then
                begin
//03.11.2021 Ticket 29005                  FViewerSplitterSize := frmMainForm.SpTBXDockablePanel1.Height;
//                  //07.09.2023 Start mit Imporer Splitter falsch-->
//                  if FImporterSplitterSize <> 0 then
//                    frmMainForm.SpTBXDockablePanel1.Height := FImporterSplitterSize
//                  else
//14.11.2023                  frmMainForm.SpTBXSplitter3.Visible := CurrentView <> tvkImporter; //27.09.2023 bfacrm:ticket__show__36355

                  //07.09.2023 <--
                  frmMainForm.SpTBXDockablePanel1.Height :=
                    frmMainForm.pnlSearchOptions.Height -
                    frmMainForm.fraScanFunctions.SpTBXGroupBox1.Height -
                    frmMainForm.SpTBXSplitter3.Height - 45;
//                  //07.09.2023 -->
//                  if frmMainForm.SpTBXPanel5.Height <> 242 then
//                  begin
//                    frmMainForm.SpTBXPanel5.Height := 242;
                    bitfarmApp.FImporterSplitterSize := frmMainForm.SpTBXDockablePanel1.Height;
//                  end;
//                  //07.09.2023 <--
                  if frmMainForm.tcSearch.ActiveTab = frmMainForm.tabSearchLinks then
                  begin
                    frmMainForm.tcSearch.Toolbar.BeginUpdate;
                    frmMainForm.tcSearch.ActiveTabIndex := 0;
                    frmMainForm.tcSearch.Toolbar.EndUpdate;
                  end;
                end
                else
                begin
                  if FViewerSplitterSize <> 0 then
                    frmMainForm.SpTBXDockablePanel1.Height := FViewerSplitterSize
                  else
                    frmMainForm.SpTBXDockablePanel1.Height := Round((frmMainForm.pnlSearchOptions.Height - 23) / 2);
                end;
              end;
            end);
        end
        else if CurrentView = tvkImporter then   // beim Programmstart
        begin
          //07.09.2023 Start mit Imporer Splitter falsch-->
          if FImporterSplitterSize <> 0 then
            frmMainForm.SpTBXDockablePanel1.Height := FImporterSplitterSize
          else
          //07.09.2023 <--
            frmMainForm.SpTBXDockablePanel1.Height :=
              frmMainForm.pnlSearchOptions.Height -
              frmMainForm.fraScanFunctions.SpTBXGroupBox1.Height -
              frmMainForm.SpTBXSplitter3.Height - 45;
          if frmMainForm.tcSearch.ActiveTab = frmMainForm.tabSearchLinks then
          begin
            frmMainForm.tcSearch.Toolbar.BeginUpdate;
            frmMainForm.tcSearch.ActiveTabIndex := 0;
            frmMainForm.tcSearch.Toolbar.EndUpdate;
          end;
        end;

        //14.11.2023 -->
        if AThread <> nil then
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              frmMainForm.SpTBXSplitter3.Visible := CurrentView <> tvkImporter; //27.09.2023 bfacrm:ticket__show__36355
              SetImporterScrollBox;
            end);
        end
        else
        begin
          frmMainForm.SpTBXSplitter3.Visible := CurrentView <> tvkImporter; //27.09.2023 bfacrm:ticket__show__36355
          SetImporterScrollBox;
        end;
        //14.11.2023 <--

        if CurrentView = tvkAdministrator then
        begin
          bitfarmApp.DeleteStatefields(AThread); //05.03.2018 Ticket 13581

          AThread.Synchronize(nil,
            procedure
            begin
              frmMainForm.frmSplash.FormType := sftAdmin;
              frmMainForm.frmSplash.lblLoading.Caption :=
                _('Archivkonfiguration wird geladen. Bitte einen Moment Geduld...');
              //17.12.2021 gespeicherte Einstellungen laden. Erst ab Version 3.6.2.60 -->
              if frmMainForm.fAppStarted then
              begin
                frmMainForm.SetAdminFrame;
                frmMainForm.SetAdminFrameControls;
              end;
              //17.12.2021 gespeicherte Einstellungen laden. Erst ab Version 3.6.2.60 <--
              if frmMainForm.fraAdmin <> nil then //08.03.2024 wegen Offline Viewer
                frmMainForm.fraAdmin.LoadAdminFrame;
            end);
        end;

        // SJ 21.09.2021 bfacrm:ticket__show__28102
        if changedView and (bitfarmApp.GetActivePreview <> nil) then
          AThread.Synchronize(nil,
            procedure
            begin
              if (bitfarmApp.GetActivePreview.ActiveDoc <> nil) then
                bitfarmApp.GetActivePreview.ShowPageNumber
              else
              begin
                bitfarmApp.GetActivePreview.ShowPageNumber;
                frmMainForm.bfaTlbPreview1.cbxZoom.Text := ''; // HS mchte lieber leer wenn kein Dokument
              end;

              case CurrentView of
                tvkImporter:
                  frmMainForm.bfaTlbStandard1.tlbStandardThumbnail.Checked :=
                    bitfarmApp.PreviewContainer.ImporterItem.Preview.ShowThumbnail;
                tvkWorkplace:
                  frmMainForm.bfaTlbStandard1.tlbStandardThumbnail.Checked :=
                    bitfarmApp.PreviewContainer.WorkplaceItem.Preview.ShowThumbnail;
                else
                  frmMainForm.bfaTlbStandard1.tlbStandardThumbnail.Checked :=
                    bitfarmApp.PreviewContainer.ViewerItem.Preview.ShowThumbnail;
              end;
            end);
        // SJ 21.09.2021 bfacrm:ticket__show__28102

        if (AThread <> nil) and (Idx <> -1) then
        begin
          if FPreviewContainer.ViewerItem.Tab.Visible then
          begin
            if FPreviewContainer.ViewerItem.Panel.Tag = Idx then    // wir sind auf dem Viewer-Tab
            begin
              AThread.Synchronize(nil,
                procedure
                begin
                  frmMainForm.grdResultlistDevEx.Enabled := True;
                end);
              RefreshGrid(AThread);
              AThread.Synchronize(nil,
                procedure
                begin
                  frmMainForm.actSearch.Enabled := True;
//                  frmMainForm.btnReset.Enabled := True; // SJ 12.06.2023
                  SetBlueArrows; // SJ 12.06.2023
                  frmMainForm.btnLimit.Enabled := True;
                end);
            end
            else
            begin
              AThread.Synchronize(nil,
                procedure
                begin
//23.06.2021 Ticket 27686                 frmMainForm.grdResultlistDevEx.Enabled := False;
                  frmMainForm.grdResultlistDevEx.Invalidate;
                  frmMainForm.actSearch.Enabled := False;
//04.07.2023 wegen Actions umgebaut                 frmMainForm.btnReset.Enabled := False;
//                  frmMainForm.btnForward.Enabled := False; // SJ 12.06.2023
//                  frmMainForm.btnBack.Enabled := False; // SJ 12.06.2023
                  SetBlueArrows; // SJ 12.06.2023
                  frmMainForm.btnLimit.Enabled := False;
                end);
            end;
          end;

          AThread.Synchronize(nil,
            procedure
            begin
              frmMainForm.fraScanFunctions.btnScan.Enabled := (Idx = 1);
              frmMainForm.fraScanFunctions.btnScanDialog.Enabled := (Idx = 1);
              frmMainForm.fraScanFunctions.btnLoadFile.Enabled := (Idx = 1);
              frmMainForm.fraScanFunctions.btnSaveFile.Enabled := (Idx = 1);
              frmMainForm.fraScanFunctions.btnDeleteSelected.Enabled := (Idx = 1);
              frmMainForm.fraScanFunctions.btnArchive.Enabled := (Idx = 1);

              if (CurrentView = tvkResub) then
                frmMainForm.fraResub.EnableControls(FPreviewContainer.ActiveItem = 0);
            end);
        end;

        if AThread <> nil then
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              ActivatePreview;
              if FCurrentContainer.Count > 0 then
                frmMainForm.SetStatusBarID(FCurrentContainer[0].arcid, FCurrentContainer[0].Id,
                  GUIDToString(FCurrentContainer[0].TempID))
              else
                frmMainForm.SetStatusBarID(-1, -1);
            end);
        end
        else
        begin
          ActivatePreview;
          frmMainForm.SetStatusBarID(-1, -1);
        end;

        if AThread <> nil then
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              if FPreviewContainer.ActiveItem <> pvtImporter then
                frmMainForm.dftMainForm.Enabled := True
              else
              begin
                frmMainForm.dftMainForm.Enabled := False;
                if (frmMainForm.fraScanFunctions.btnArchive.Enabled = False) then
                  frmMainForm.fraScanFunctions.btnArchive.Enabled := True;
              end;
            end);
        end else
        begin
        if FPreviewContainer.ActiveItem <> pvtImporter then
          frmMainForm.dftMainForm.Enabled := True
        else
        begin
          frmMainForm.dftMainForm.Enabled := False;
          if (frmMainForm.fraScanFunctions.btnArchive.Enabled = False) then
            frmMainForm.fraScanFunctions.btnArchive.Enabled := True;
        end;
        end
      end;

      if changedview or (not frmMainForm.fAppStarted) then    // SJ 27.08.2020
        frmMainForm.SetMainFormTabStop;

      // SJ 20.10.2020
      if AThread <> nil then
      begin
        try
        AThread.Synchronize(nil,
          procedure
          begin
            // bfacrm:ticket__show__24708
            if changedview and frmMainForm.fAppStarted then
              frmMainForm.SetMainFormFocus;
          end);
        except
          bitfarmLog.Write(llNormal, ltException, 'SetActiveView - setting new focus failed', ClassName);
        end;
      end;
      // SJ 20.10.2020

      if AThread <> nil then
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            if changedview and (bitfarmApp.GetActivePreview <> nil) then
              bitfarmApp.GetActivePreview.SetActions
            else if bitfarmApp.GetActivePreview = nil then
              frmMainForm.DisableMainFormActions;
          end);
      end else
      begin
        if changedview and (bitfarmApp.GetActivePreview <> nil) then
          bitfarmApp.GetActivePreview.SetActions
        else if bitfarmApp.GetActivePreview = nil then
          frmMainForm.DisableMainFormActions;
      end;

//16.11.2023 bfacrm:ticket__show__33996     if dontloadfields and not force_loadfields and not DoCreateFields then   // werden in ChangeArchive geladen
      if dontloadfields and not force_loadfields and not DoCreateFields and not ReloadViewerGrid then   // werden in ChangeArchive geladen
      begin
        if frmMainForm.fAppStarted and (LastView = tvkViewer) and (LastView = CurrentView) and (FCurrentContainer.Count > 0) then
        begin
          if AThread <> nil then
            AThread.Synchronize(nil,
              procedure
              begin
                ShowAddFields(FCurrentContainer[0]);
              end);
        end;
        Exit;
      end;

      if AThread <> nil then
      begin
        arcids := TStringList.Create;
        try
          if (
             ((FPreviewContainer.ActiveItem <> FPreviewContainer.ViewerItem.Panel.Tag)
             or DoCreateFields) //09.08.2022
             and (CurrentView = tvkViewer)) then
          begin
            if FCurrentContainer.Count > 0 then
            begin
              if FCurrentContainer[0].Id = -1 then //nicht importiertes Dokument->Importerfelder anzeigen
                arcids.Add(inttostr(CurrentImporterFields))
              else
              //28.06.2024 BT -->
              begin
                if FCurrentContainer[0].SymbolicArcID <> -1 then
                  arcids.Add(IntToStr(FCurrentContainer[0].SymbolicArcID))
                else
              //28.06.2024 BT <--
                  arcids.Add(inttostr(FCurrentContainer[0].ArcID));
              end;
            end
            else if CurrentViewerFields <> CurrentFields then
              arcids.Add(inttostr(CurrentViewerFields));

          end
          else if ((FPreviewContainer.ActiveItem <> FPreviewContainer.ViewerItem.Panel.Tag) and
                  (CurrentView = tvkResub)) then
          begin
            if FCurrentContainer.Count > 0 then
            begin
              if FCurrentContainer[0].Id = -1 then //nicht importiertes Dokument->Importerfelder anzeigen
                arcids.Add(inttostr(CurrentImporterFields))
              else
              //28.06.2024 BT -->
              begin
                if FCurrentContainer[0].SymbolicArcID <> -1 then
                  arcids.Add(IntToStr(FCurrentContainer[0].SymbolicArcID))
                else
              //28.06.2024 BT <--
                  arcids.Add(inttostr(FCurrentContainer[0].arcid));
              end;
            end
            else if CurrentResubFields <> CurrentFields then
              arcids.Add(inttostr(CurrentResubFields));

          end
          else if ((FPreviewContainer.ActiveItem <> FPreviewContainer.ImporterItem.Panel.Tag) and (CurrentView = tvkImporter)) then
          begin
            if FCurrentContainer.Count > 0 then
            begin
              if FCurrentContainer[0].Id = -1 then //nicht importiertes Dokument->Importerfelder anzeigen
                arcids.Add(inttostr(CurrentImporterFields))
              else
              //28.06.2024 BT -->
              begin
                if FCurrentContainer[0].SymbolicArcID <> -1 then
                  arcids.Add(IntToStr(FCurrentContainer[0].SymbolicArcID))
                else
              //28.06.2024 BT <--
                  arcids.Add(inttostr(FCurrentContainer[0].ArcID));
              end;
            end
            else if CurrentImporterFields <> CurrentFields then
              arcids.Add(inttostr(CurrentImporterFields));

          end
          else if (FPreviewContainer.ActiveItem = FPreviewContainer.ViewerItem.Panel.Tag) then
          begin
            if (CurrentView = tvkViewer) {or (CurrentView = tvkFavorites)} then
              arcids.Add(inttostr(CurrentViewerFields))
            else if CurrentView = tvkResub then
            begin
              arcids.Add(inttostr(CurrentResubFields));
            end;
          end
          else if (FPreviewContainer.ActiveItem = FPreviewContainer.ImporterItem.Panel.Tag) then
          begin
            if (CurrentView = tvkImporter) then
              arcids.Add(inttostr(CurrentImporterFields));
          end;

          if arcids.Count > 0 then
          begin
            CreateFields(AThread, arcids);
            ResetFields(AThread);  //19.03.2018 Ticket 13989
          end;

          if changedview and (CurrentView = tvkResub) then   // wir haben auf die Resubview gewechselt?
            CreateGrid(CurrentResubFields, AThread);          // Grid neu erstellen

          if changedview and (CurrentView = tvkViewer) then   // wir haben auf die Viewer gewechselt?
            CreateGrid(CurrentViewerFields, AThread);          // Grid neu erstellen

          if (((CurrentView = tvkResub) and ViewerOptions.ResubOptions.ShowAllAddfields)
                or ((CurrentView = tvkViewer) and ViewerOptions.SearchOptions.ShowAllAddfields)) //28.06.2024 BT
            and     // setActiveview auf Resub aber kein changedview ?
            (FCurrentContainer.Count > 0) and not changedview then // dann kommen wir wohl von einem tab
          begin
            //28.06.2024 BT -->
            if FCurrentContainer[0].SymbolicArcID <> -1 then
              arcids.Add(IntToStr(FCurrentContainer[0].SymbolicArcID))
            else
            //28.06.2024 BT <--
              arcids.Add(IntToStr(FCurrentContainer[0].arcid));
            bitfarmApp.ReadFieldRights(arcids);
            bitfarmApp.AddDocumentFields(FCurrentContainer[0], AThread);
          end;

//28.06.2024 BT  hnlich wie oben, deswegen dort if gendert
//          if (CurrentView = tvkViewer) and ViewerOptions.SearchOptions.ShowAllAddfields and     // setActiveview auf Resub aber kein changedview ?
//             (FCurrentContainer.Count > 0) and not changedview then // dann kommen wir wohl von einem tab
//          begin
//            //28.06.2024 BT -->
//            if FCurrentContainer[0].SymbolicArcID <> -1 then
//              arcids.Add(IntToStr(FCurrentContainer[0].SymbolicArcID))
//            else
//            //28.06.2024 BT -->
//              arcids.Add(IntToStr(FCurrentContainer[0].arcid));
//            bitfarmApp.ReadFieldRights(arcids);
//            bitfarmApp.AddDocumentFields(FCurrentContainer[0], AThread);
//          end;



//03.07.2024 BT muss hier raus wegen Strg+U Fehler, aber nochmal grudsetztlich testen -->
//          //25.06.2024 SD -->bfacrm:ticket__show__35622
//          if FCurrentContainer.Count > 0 then
//          begin
//            AThread.Synchronize(nil,
//              procedure
//              begin
//                ShowAddFields(FCurrentContainer[0]);
//                ShowStateFields(FCurrentContainer[0]);
//              end);
//          end;
//          //25.06.2024 SD <--bfacrm:ticket__show__35622
//03.07.2024 BT muss hier raus wegen Strg+U Fehler, aber nochmal grudsetztlich testen <--

        finally
          FreeAndNil(arcids);
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'SetActiveView', ClassName);
      FPreviewContainer.ActiveItem := -1;
    end;
  finally
    ViewChanging := False;
    bitfarmLog.DebugEnd(llDebug, 'SetActiveView', Classname);
  end;
end;

procedure TbfaApplication.CreateFields(AThread: TThread; Lst: TStringList; ArcID: Int64 = -1);
var
  arcids: TStringList;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateFields', Classname);
  try
    try
      if Lst = nil then
      begin
        arcids := TStringList.Create;
        arcids.Add(IntToStr(ArcID));
      end
      else
        arcids := Lst;
      try
        if arcids.Count > 0 then
        begin
          DeleteAddfields(AThread);
          DeleteStatefields(AThread);
          ReadFieldRights(arcids);
          CreateAddfields(arcids, AThread);
          CreateStatefields(arcids, AThread);
          CurrentFields := StrToInt(arcids[0]);
        end
        else
        begin
          DeleteAddfields(AThread);
          DeleteStatefields(AThread);
        end;
      finally
        if Lst = nil then
          FreeAndNil(arcids);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'CreateFields', Classname);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateFields', Classname);
  end;
end;

procedure TbfaApplication.ClearPreviewScanPool(prev: TbfaPreview; AThread: TThread);
var
  k: Integer;
begin
  try
    if (prev = FPreviewContainer.ImporterItem.Preview) and (prev.PreviewKind = pvkMulti) then
    begin
      for k := 0 to FImportContainer.Count - 1 do
      begin
        if (FImportContainer[k].ThumbnailView <> nil) and (FImportContainer[k].ThumbnailView.Visible) then
        begin
          if AThread <> nil then
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                try
                  if (FImportContainer[k].ThumbnailView <> nil) and
                     (FImportContainer[k].ThumbnailView.Visible) then
                  begin
                    FImportContainer[k].ThumbnailView.Visible := False;
                    FPreviewContainer.ImporterItem.Preview.Update;
                    FPreviewContainer.ImporterItem.Preview.previewToolWindow.Update;
                  end;
                except
                end;
              end);
          end
          else
          begin
            try
              FImportContainer[k].ThumbnailView.Visible := False;
              FPreviewContainer.ImporterItem.Preview.Update;
              FPreviewContainer.ImporterItem.Preview.previewToolWindow.Update;
            except
            end;
          end;
        end;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'ClearPreviewScanPool', Classname);
  end;
end;

procedure TbfaApplication.ClearUserAction(UserAction: PUserAction);
var
  i: Integer;
begin
  with PUserAction(UserAction)^ do
  begin
    if objects <> nil then
      objects.Free;
    if Documents <> nil then
    begin
      if FreeObjects then
      begin
        try
          for i := 0 to Documents.Count - 1 do
          begin
            try
              TbfaDocument(Documents[i]).Free;
            finally
              Documents[i] := nil;
            end;
          end;
          Documents.Clear;
        except
          Log.Write(llNormal, ltException, 'ClearUserAction - FreeObjects', 'MainThread');
        end;
      end;
      Documents.Free;
    end;
    if params <> nil then
      params.Free;
    if sList <> nil then
      sList.Free;
  end;
  Dispose(UserAction);
end;

procedure TbfaApplication.SetChkPrintAfterArchive(prev: TbfaPreview);
var
  FoundDocWithPreview: Boolean;
begin
  // bfacrm:ticket__show__30288
  try
    try
      // chkPrintAfterArchive wird nur Enabled, wenn mindestens ein Dokument eine Voransicht hat
      // oder kein Dokument selektiert ist

      if (prev = nil) or not(prev is TbfaPreview) then
      begin
        // wenn wir keine prev haben, dann aktivieren wir die Checkbox mal lieber...
        FoundDocWithPreview := True;
        Exit;
      end;

      // kein Dokument selektiert? Aktivieren.
      FoundDocWithPreview := (prev.MultiView.MultiSelectedImagesCount = 0);

      if prev.MultiView.MultiSelectedImagesCount > 0 then
      begin
        for var i := prev.MultiView.MultiSelectedImagesCount - 1 downto 0 do
        begin
          if prev.List[prev.MultiView.MultiSelectedImages[i]].HasPreview then
          begin
            FoundDocWithPreview := True;
            Break;
          end;
        end;
      end;
    finally
      frmMainForm.fraScanFunctions.chkPrintAfterArchive.Enabled := FoundDocWithPreview;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetChkPrintAfterArchive', Classname);
  end;
end;

procedure TbfaApplication.SetCurrentDocs(Doc: TbfaDocument; DocList: TList = nil;
  prev: TbfaPreview = nil; AThread: TThread = nil; InNewTab: Boolean = False; InEditMode: Boolean = false);
var
  i, j: Integer;
  found: Boolean;
  tempdoc: TbfaDocument;
  gdocid: Int64;
  lBM : Integer;
  founddoc, DoWithScanPool: Boolean;
  MView: TbfaImageEnMView;
begin
  bitfarmLog.DebugBegin(llDebug, 'SetCurrentDocs', Classname);
  founddoc := False;
  DoWithScanPool := False;
  try
    try
      if GetCurrentDocumentInProcess then
      begin
        bitfarmLog.Write(llNormal, ltWarning, 'CurrentDocument cannot be changed because it is in process', Classname);
        Exit;
      end;

      DoWithScanPool := ((prev <> nil) and
        (prev = FPreviewContainer.ImporterItem.Preview) and (prev.previewToolWindow.Visible));

      if (Doc <> nil) then
      begin
        if ((FCurrentContainer.Count = 0) or (Doc <> FCurrentContainer[0]) or
           ((Doc = FCurrentContainer[0]) and (FCurrentContainer.Count > 1))) then
        begin
          if not (InNewTab and InEditMode) then
            LeaveCurrentDocs(AThread);
          if prev <> nil then
          begin
            prev.ActiveDoc := nil;
            ClearPreviewScanPool(prev, AThread);
          end;

          for i := 0 to FCurrentContainer.Count - 1 do
          begin
            if CompareDocumentsByID(FCurrentContainer[i], Doc) then   // gefunden in der Liste alle ausgewhlten Dokumente
            begin
              FCurrentContainer[i] := Doc;
              founddoc := True;
              Break;
            end
          end;

          if (not founddoc) or (frmMainForm.grdResultlistDevExView.Controller.SelectedRowCount = 1) then
          begin
            FCurrentContainer.Clear;
            FCurrentContainer.Add(Doc);
          end
          else if ((prev <> nil) and founddoc and (prev.PreviewKind = pvkMulti) and   // wir sind in einer multiview
            (prev.MultiView.MultiSelectedImagesCount = 1)) then                 // und haben ein einziges dokument aus einer
          begin                                                                           // selektion angewhlt
            FCurrentContainer.Clear;                                                      // dann alle anderen entfernen
            FCurrentContainer.Add(Doc);
          end;

          if prev <> nil then
          begin
            if (prev = FPreviewContainer.ImporterItem.Preview) then
            begin
              if Doc.ScanPoolView = nil then
              begin
                if DoWithScanPool then
                  Doc.ScanPoolView := CreateInvisibleScanPoolMView(nil);
              end;
            end;
          end;
        end;

        if prev <> nil then
          prev.ActiveDoc := Doc;
      end
      else if (DocList <> nil) then
      begin
        found := False;

        i := 0;
        if FCurrentContainer.Count > 0 then
        begin
          while ((not found) and (i <= DocList.Count - 1)) do
          begin
            if ((i <= FCurrentContainer.Count - 1) and (FCurrentContainer[i] <> TbfaDocument(DocList[i]))) then
              found := True
            else
              inc(i);
          end;
        end;

        if ((FCurrentContainer.Count <> DocList.Count) or (found)) then
        begin
          if not (InNewTab and InEditMode) then
            LeaveCurrentDocs(AThread);

          FCurrentContainer.Clear;
          if (prev <> nil) and ((DocList.Count = 0) or (DocList[0] <> prev.ActiveDoc)) then
          begin
            prev.ActiveDoc := nil;
            ClearPreviewScanPool(prev, AThread);
          end;

          for i := 0 to DocList.Count - 1 do
          begin
            FCurrentContainer.Add(DocList[i]);
            if (prev = FPreviewContainer.ImporterItem.Preview) then
            begin
              if i = DocList.Count - 1 then
              begin
                if TbfaDocument(DocList[i]).ScanPoolView = nil then
                begin
                  if DoWithScanPool then
                    TbfaDocument(DocList[i]).ScanPoolView := CreateInvisibleScanPoolMView(nil);
                end;
              end;
            end;
          end;
        end;

        if prev <> nil then
          prev.ActiveDoc := DocList[0];
      end
      else if (Doc = nil) and (DocList = nil) and (prev <> nil) then
      begin
        if ((prev <> nil) and (prev.List <> nil)) then
        begin
          if prev.List.Count > 0 then
          begin
            if ((prev.PreviewKind = pvkMulti) or (prev.PreviewKind = pvkMultiSingle)) then
            begin
              if prev.MultiView.MultiSelectedImagesCount > 0 then
              begin
                found := False;

                i := 0;
                if FCurrentContainer.Count > 0 then
                begin
                  while ((not found) and (i <= prev.MultiView.MultiSelectedImagesCount - 1)) do
                  begin
                    if (i <= FCurrentContainer.Count - 1) and  //03.08.2017 Absturz beim deselect
                      (FCurrentContainer[i] <> prev.List[prev.MultiView.MultiSelectedImages[i]]) then
                      found := True
                    else
                      inc(i);
                  end;
                end;

                if ((FCurrentContainer.Count <> prev.MultiView.MultiSelectedImagesCount) or (found)) then
                begin
                  if not (InNewTab and InEditMode) then
                    LeaveCurrentDocs(AThread);

                  FCurrentContainer.Clear;
                  if prev <> nil then
                  begin
                    prev.ActiveDoc := nil;
                    ClearPreviewScanPool(prev, AThread);
                  end;

                  for i := 0 to prev.MultiView.MultiSelectedImagesCount - 1 do
                  begin
                    FCurrentContainer.Add(prev.List[prev.MultiView.MultiSelectedImages[i]]);
                    if (prev = FPreviewContainer.ImporterItem.Preview) then
                    begin
                      if TbfaDocument(prev.List[prev.MultiView.MultiSelectedImages[i]]).ScanPoolView = nil then
                      begin
                        if DoWithScanPool then
                          TbfaDocument(prev.List[prev.MultiView.MultiSelectedImages[i]]).ScanPoolView := CreateInvisibleScanPoolMView(nil);
                      end;
                    end;
                  end;
                end;

                prev.ActiveDoc := prev.List[prev.MultiView.MultiSelectedImages[0]];

              end
              else
              begin
                if not (InNewTab and InEditMode) then
                  LeaveCurrentDocs(AThread);

                FCurrentContainer.Clear;
                if prev <> nil then
                begin
                  prev.ActiveDoc := nil;
                  ClearPreviewScanPool(prev, AThread);
                end;
              end;
            end
            else if (prev.PreviewKind = pvkSingle) then
            begin
              if (FCurrentContainer.Count > 0) then
              begin
                if (prev.List[0] <> FCurrentContainer[0]) or ((prev.List[0] = FCurrentContainer[0]) and (FCurrentContainer.Count > 1)) //03.08.2017 beim ausgedockten tabs macht sonst probleme mit dem multiview
                  then   //TODO:diese Stelle muss geprft werden
                begin
                  if not (InNewTab and InEditMode) then
                    LeaveCurrentDocs(AThread);

                  FCurrentContainer.Clear;
                  if prev <> nil then
                  begin
                    prev.ActiveDoc := nil;
                    ClearPreviewScanPool(prev, AThread);
                  end;

                  FCurrentContainer.Add(prev.List[0]);
                end;
              end
              else
                FCurrentContainer.Add(prev.List[0]);
              prev.ActiveDoc := prev.List[0];

              if (prev = FPreviewContainer.ImporterItem.Preview) then
              begin
                if prev.ActiveDoc.ScanPoolView = nil then
                begin
                  if DoWithScanPool then
                    prev.ActiveDoc.ScanPoolView := CreateInvisibleScanPoolMView(nil);
                end;
              end;
            end;
          end
          else
          begin
            LeaveCurrentDocs(AThread);
            FCurrentContainer.Clear;
            if prev <> nil then
            begin
              prev.ActiveDoc := nil;
              ClearPreviewScanPool(prev, AThread);
            end;
          end;
        end;

        if (FPreviewContainer.ActiveItem = FPreviewContainer.ViewerItem.Panel.Tag) and
           (frmMainForm.grdResultlistDevExView.Controller.SelectedRowCount > 1) then
          SelectedRowsToCurrentContainer(frmMainForm.grdResultlistDevExView, True);
        end;
    except
      bitfarmLog.Write(llNormal, ltException, 'SetCurrentDocs', Classname);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetCurrentDocs', Classname);
  end;
end;

procedure TbfaApplication.SetCurrentView(const Value: TbfaViewKind);
begin
  FCurrentView := Value;
end;

procedure TbfaApplication.SelectedRowsToCurrentContainer(GridView : TbfaGridDBTableView;
  OnlyDoc : Boolean = False; src : TList = nil);
var
  tmpdoc, actDoc : TbfaDocument;
  i, j, editmode, RNo ,ip: Integer;
  gdocid, arcid, symarcid, TimID, ResubUserID: Int64;
  dsc : TDataSource;
  found : Boolean;
  gdc : TcxGridDBDataController;
  ASelection: TcxDataSelection;
begin
  try
    dsc := GridView.DataController.DataSource;
    gdc := GridView.DataController;
    //29.10.2020 Ticket 24906 -->
    // Wenn das Document schon geladen ist, dann muss nicht neu geladen werden,
    // deswegen wird hier einfach gespeichert
    if (FCurrentContainer.Count > 0) and (FCurrentContainer[0] <> nil) and
      (FCurrentContainer[0].Loaded) then
      ActDoc := FCurrentContainer[0]
    else
      ActDoc := nil;
    //29.10.2020 Ticket 24906 <--
    FCurrentContainer.Clear;
    ASelection := GridView.DataController.DataControllerInfo.Selection;
    for i := 0 to ASelection.Count - 1  do
    begin
      if ASelection[i].Level >= gdc.Groups.GroupingItemCount then  //08.04.2022
      begin
        try
          RNo := ASelection[i].RecordIndex;
        except
          Continue;         //   --> bfacrm:ticket__show__23879
        end;
        gdocid := gdc.GetValue(RNo, gdc.GetItemByFieldName('gdocid').Index);
        if not OnlyDoc then
        begin
          arcid := gdc.GetValue(RNo, gdc.GetItemByFieldName('arcid').Index);

          if (dsc.DataSet.FieldDefList.Find('symarcid') <> nil) and
             ((not VarIsNull(gdc.GetValue(RNo, gdc.GetItemByFieldName('symarcid').Index))) and
             VarIsNumeric(gdc.GetValue(RNo, gdc.GetItemByFieldName('symarcid').Index)))
          then
            symarcid := gdc.GetValue(RNo, gdc.GetItemByFieldName('symarcid').Index)
          else
            symarcid := -1;

          if (dsc.DataSet.FieldDefList.Find('timid') <> nil) and
             ((not VarIsNull(gdc.GetValue(RNo, gdc.GetItemByFieldName('timid').Index))) and
              VarIsNumeric(gdc.GetValue(RNo, gdc.GetItemByFieldName('timid').Index)))
          then
            TimID := gdc.GetValue(RNo, gdc.GetItemByFieldName('timid').Index)
          else
            TimID := -1;

          if (dsc.DataSet.FieldDefList.Find('userid_shed') <> nil) and
             ((not VarIsNull(gdc.GetValue(RNo, gdc.GetItemByFieldName('userid_shed').Index))) and
              VarIsNumeric(gdc.GetValue(RNo, gdc.GetItemByFieldName('userid_shed').Index)))
          then
            ResubUserID := gdc.GetValue(RNo, gdc.GetItemByFieldName('userid_shed').Index)
         else
            ResubUserID := -1;

          if (dsc.DataSet.FieldDefList.Find('editmode') <> nil) and
             ((not VarIsNull(gdc.GetValue(RNo, gdc.GetItemByFieldName('editmode').Index))) and
              VarIsNumeric(gdc.GetValue(RNo, gdc.GetItemByFieldName('editmode').Index)))
          then
            editmode := gdc.GetValue(RNo, gdc.GetItemByFieldName('editmode').Index)
          else
            editmode := 0;
        end;

        found := False;
        if not OnlyDoc then
        begin
          for j := 0 to FCurrentContainer.Count - 1 do
          begin
            if TimID = -1 then
            begin
//02.06.2022              if gdocid = FCurrentContainer[j].ID then
              if (gdocid = FCurrentContainer[j].ID) and (symarcid = FCurrentContainer[j].SymbolicArcID) then
              begin
                found := True;
                FCurrentContainer[j].SortingPos := i;
                Break;
              end;
            end else
            begin
//02.06.2022              if (gdocid = FCurrentContainer[j].ID) and
              if (gdocid = FCurrentContainer[j].ID) and (symarcid = FCurrentContainer[j].SymbolicArcID) and
                 (TimID = FCurrentContainer[j].TimID) then
              begin
                found := True;
                FCurrentContainer[j].SortingPos := i;
                Break;
              end;
            end;
          end;
        end else
        begin
          for j := 0 to FCurrentContainer.Count - 1 do
          begin
//02.06.2022            if gdocid = FCurrentContainer[j].ID then
            if (gdocid = FCurrentContainer[j].ID) and (symarcid = FCurrentContainer[j].SymbolicArcID) then
            begin
              found := True;
              FCurrentContainer[j].SortingPos := i;
              Break;
            end;
          end;
        end;

        if not found then
        begin
  //29.10.2020 Ticket 24906 -->
//02.06.2022          if (ActDoc <> nil) and (gdocid = ActDoc.ID) then
          if (ActDoc <> nil) and (gdocid = ActDoc.ID) and (symarcid = ActDoc.SymbolicArcID) then
          begin
            ActDoc.SortingPos := i;
            if FCurrentContainer.Count > 0 then
              FCurrentContainer.Insert(0, ActDoc)
            else
              FCurrentContainer.Add(ActDoc);
          end else
          begin
  //29.10.2020 Ticket 24906 <--
            tmpdoc := TbfaDocument.Create;
            tmpdoc.ID := gdocid;
            tmpdoc.SortingPos := i;
            if not OnlyDoc then
            begin
              tmpdoc.ArcID := arcid;
              tmpdoc.SymbolicArcID := symarcid;
              tmpdoc.TimID := TimID;
              tmpdoc.ResubUserID := ResubUserID;
              tmpdoc.InEditMode := editmode > 0;
            end;
            FCurrentContainer.Add(tmpdoc);
          end;
        end
        else if (FCurrentContainer.Count > 1) and (i <> j) then
        begin
          try
            if i < FCurrentContainer.Count then
              FCurrentContainer.Move(j, i);
          except
            bitfarmLog.Write(llNormal, ltException, 'SelectedRowsToCurrentContainer - FCurrentContainer.Move(j, i);', Classname);
          end;
        end;

        if src <> nil then
          if src.IndexOf(Pointer(gdocid)) > -1 then
            src.Delete(src.IndexOf(Pointer(gdocid)));
      end;  //08.04.2022
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SelectedRowsToCurrentContainer', Classname);
  end;
end;

//15.10.2024 SD <--bfacrm:ticket__show__39532
function TbfaApplication.SelectedRowsToList(GridView : TbfaGridDBTableView): TList<TbfaDocument>;
var
  tmpdoc, actDoc : TbfaDocument;
  i, RNo: Integer;
  gdocid: Int64;
  dsc : TDataSource;
  gdc : TcxGridDBDataController;
  ASelection: TcxDataSelection;
  Lst: TList<TbfaDocument>;
begin
  try
    dsc := GridView.DataController.DataSource;
    gdc := GridView.DataController;
    Lst := TList<TbfaDocument>.Create;

    if (FCurrentContainer.Count > 0) and (FCurrentContainer[0] <> nil) and
      (FCurrentContainer[0].Loaded) then
      ActDoc := FCurrentContainer[0]
    else
      ActDoc := nil;

    ASelection := GridView.DataController.DataControllerInfo.Selection;
    for i := 0 to ASelection.Count - 1  do
    begin
      if ASelection[i].Level >= gdc.Groups.GroupingItemCount then
      begin
        try
          RNo := ASelection[i].RecordIndex;
        except
          Continue;
        end;
        gdocid := gdc.GetValue(RNo, gdc.GetItemByFieldName('gdocid').Index);
        tmpdoc := TbfaDocument.Create;
        tmpdoc.ID := gdocid;
        tmpdoc.SortingPos := i;
        Lst.Add(tmpdoc);
      end;
    end;
    Result := Lst;
  except
    bitfarmLog.Write(llNormal, ltException, 'SelectedRowsToCurrentContainer', Classname);
  end;
end;
//15.10.2024 SD <--bfacrm:ticket__show__39532

procedure TbfaApplication.SetCW(day: TDate);
var
  currentday, firstday, lastday: Integer;
begin
  currentCW := DateUtils.WeekOfTheYear(day);
  currentday := DateUtils.DayOfTheWeek(day);
  dateCWFirstDay := DateUtils.IncDay(day, (currentday - 1) *  - 1);
  dateCWLastDay := DateUtils.IncDay(dateCWFirstDay, 6);
end;

procedure TbfaApplication.LeaveCurrentDocs(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'LeaveCurrentDocs', Classname);
  try
    try
      DoSave(AThread);

      AThread.Synchronize(nil,
        procedure
        begin
          if Assigned(frmMainForm.fraDocLinks) then
          begin
            frmMainForm.fraDocLinks.btnnewLink.Enabled := FCurrentContainer.Count > 0;
            frmMainForm.fraDocLinks.btnAddAutoReference.Enabled := FCurrentContainer.Count > 0;
          end;
        end);

    except
      bitfarmLog.Write(llNormal, ltException, 'LeaveCurrentDocs', Classname);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'LeaveCurrentDocs', Classname);
  end;
end;

procedure TbfaApplication.LeaveCurrentDocsImMultiView(AThread: TThread; UserAction: PUserAction);
var
  MView: TbfaImageEnMView;
  idx, i: Integer;
  KillThread: Boolean;
begin
  bitfarmLog.DebugBegin(llDebug, 'LeaveCurrentDocsImMultiView', Classname);
  try
    try
      LeaveCurrentDocs(AThread);

      MView := UserAction^.objects[0];

      KillThread := True;
      if UserAction^.params.Count > 1 then
        KillThread := StrToBool(UserAction^.params[1]);

      if KillThread then
        ClearPreviewScanPool(TbfaPreview(MView.Owner), AThread);

      FCurrentContainer.Clear;

      if (MView <> nil) and KillThread then
        TbfaPreview(MView.Owner).KillThumbnailThread;

      idx := StrToInt(UserAction^.params[0]);

      if (MView.MultiSelectedImagesCount > 0) and (idx <> -1) then
      begin
        if (MView.Tag = tagCollectionMView) then
        begin
          if (idx = MView.SelectedImage) then
          begin
            if MView.MultiSelectedImagesCount > 1 then
            begin
              if (idx = MView.MultiSelectedImages[0]) then
                bitfarmApp.MViewImageSelect(MView, UserAction^.Preview, MView.MultiSelectedImages[1], idx, True, False, False, False, False, False, True)
              else
                bitfarmApp.MViewImageSelect(MView, UserAction^.Preview, MView.MultiSelectedImages[0], idx, True, False, False, False, False, False, True)
            end;
          end
          else
          begin
            AThread.Synchronize(nil,
              procedure
              var
                i: Integer;
              begin
                for i := 0 to MView.MultiSelectedImagesCount - 1 do
                begin
                  if idx <> MView.MultiSelectedImages[i] then
                    FCurrentContainer.Add(TbfaPreview(MView.Owner).list[MView.MultiSelectedImages[i]]);
                end;
              end);
          end;
        end
        else
        begin
          if MView.MultiSelectedImagesCount > 1 then
          begin
            if (idx = MView.MultiSelectedImages[0]) then
              bitfarmApp.MViewImageSelect(MView, UserAction^.Preview, MView.MultiSelectedImages[1], idx, True, False, False, False, False, False, True)
            else
              bitfarmApp.MViewImageSelect(MView, UserAction^.Preview, MView.MultiSelectedImages[0], idx, True, False, False, False, False, False, True)
          end;
        end;
      end
      else
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            if MView.MultiSelectedImagesCount > 0 then
              MView.Deselect;
            UserAction^.Preview.ActiveDoc := nil;
            UserAction^.Preview.SetActions;
            if UserAction^.Preview <> FPreviewContainer.ImporterItem.Preview then  //25.09.2018
              UserAction^.Preview.ThumbnailView.Clear
            else
            begin
              try
                if (UserAction^.Preview.ThumbnailView <> nil) and (UserAction^.Preview.ThumbnailView.Parent <> nil) then
                  UserAction^.Preview.ThumbnailView.Visible := False;
              except
              end;
            end;
            ResetDocumentProperties;
            UserAction^.Preview.ShowPageNumber;
          end);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'LeaveCurrentDocsImMultiView', Classname);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'LeaveCurrentDocsImMultiView', Classname);
  end;
end;

//16.05.2024 SD Klick auf ButtonPreviewClick - Umsetzung durch UserAction
procedure TbfaApplication.ButtonPreviewClick(AThread: TThread; prev: TbfaPreview);
begin
  bitfarmLog.DebugBegin(llDebug, 'ButtonPreviewClick', Classname);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          prev.SingleView.Show;
          prev.HistoryView.Hide;
          prev.FulltextView.Hide;
          prev.CommentaryView.Hide;
          prev.btnPreview.Checked := True;
          prev.btnHistory.Checked := False;
          prev.btnFulltext.Checked := False;
          prev.btnCommentary.Checked := False;

          prev.ActiveView := avDocument;
          prev.SearchToolbarSetState;
        end);

      if prev.SearchbarPreviewModified {and FActiveDoc.ocrxmlexists} then
      begin
        bitfarmApp.LoadFtxPos(prev.FtxPos, prev.SearchbarTextEdit.Text);
        prev.RefreshPreview(AThread, prev.ActiveDoc, True);
        prev.SearchbarPreviewModified := False;
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'ButtonPreviewClick', Classname);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ButtonPreviewClick', Classname);
  end;
end;

procedure TbfaApplication.ZoomComboChange(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'ZoomComboChange', ClassName);
  try
    try
      if FPreviewContainer.ActiveItem <> pvtAdmin then
        FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.cbxZoomChange(Sender);
    except
      bitfarmLog.Write(llNormal, ltException, 'ZoomComboChange', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ZoomComboChange', ClassName);
  end;
end;

//30.08.2022procedure TbfaApplication.PageNumberChange(Sender: TObject; const Text: String);
procedure TbfaApplication.PageNumberChange(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'PageNumberChange', ClassName);
  try
    try
      if (FPreviewContainer.ActiveItem <> pvtAdmin) and (not ShowDocumentInProcess) then
//30.08.2022 Wegen komponenttausch muss AcceptText hier eingebaut werden -->
//       FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.PageNumberChange(Sender, Text);
      begin
        var MaxPage: Integer;

        if (FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.ActiveDoc <> nil) and
           (FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.ActiveDoc.ScanPoolView <> nil)
        then
          MaxPage := FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.ActiveDoc.ScanPoolView.ImageCount
        else
          MaxPage := FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.SingleView.img_DocView.IO.Params.ImageCount;

        if TSpTBXEdit(Sender).Text <> '' then
        begin
          if (MaxPage > 0) and (StrToInt(TSpTBXEdit(Sender).Text) > MaxPage) then
            TSpTBXEdit(Sender).Text := MaxPage.ToString
          else
            FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.PageNumberChange(Sender);
        end;
      end;
//30.08.2022 Wegen komponenttausch muss AcceptText hier eingebaut werden <--
    except
      bitfarmLog.Write(llNormal, ltException, 'PageNumberChange', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'PageNumberChange', ClassName);
  end;
end;

procedure TbfaApplication.AcceptText(Sender: TObject; var NewText: String; var Accept: Boolean);
var
  MaxPage: Integer;
  NewMaxPage: String;
begin
  bitfarmLog.DebugBegin(llDebug, 'AcceptText', ClassName);
  try
    try
      if FPreviewContainer.ActiveItem <> pvtAdmin then
      begin
        try
          MaxPage := FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.SingleView.img_DocView.IO.Params.ImageCount;
          if (MaxPage > 0) and (NewText.ToInteger > MaxPage) then
          begin
            NewMaxPage := MaxPage.ToString;
            FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.AcceptText(Sender, NewMaxPage, Accept);
            NewText := NewMaxPage;
          end else
          FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.AcceptText(Sender, NewText, Accept);
        except
          FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.AcceptText(Sender, NewText, Accept);
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'AcceptText', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'AcceptText', ClassName);
  end;
end;

procedure TbfaApplication.MViewImageSelect(Sender: TObject; prev: TbfaPreview; idx: Integer;
  DeselectIdx: Integer = -1; SetCurrent: Boolean = True; InNewTab: Boolean = False;
  InBackGroundTab: Boolean = False; InEditMode: Boolean = False; SetFocus: Boolean = False;
  ChangeToMultiSingle: Boolean = False; ReloadThumbnail: Boolean = False; SetImagePos: Boolean = False;
  SetImagePosTothetop: Boolean = False; Autozoom: Boolean = True; PageDirection: Integer = -1;
  Floating: Boolean = False; MouseClick: Boolean = False);
var
  i, DocIdx, PageIdx: Integer;
  LstObjs: TList;
  Lst: TList<TbfaDocument>;
  Doc: TbfaDocument;
  SearchString: WideString;
  Reload: Boolean;
begin
  bitfarmLog.DebugBegin(llDebug, 'MViewImageSelect', Classname);
  try
    try
      if (Sender is TbfaImageEnMView) then
      begin
        if TbfaImageEnMView(Sender).MultiSelecting then
          Exit;

        LstObjs := TList.Create;
        LstObjs.Add(Sender);
        Lst := nil;
        Doc := nil;
        DocIdx := 0;
        PageIdx := 0;
        Reload := False;

        if (Sender as TbfaImageEnMView).Tag = tagCollectionMView then
        begin
          Lst := TList<TbfaDocument>.Create;
          for i := prev.MultiView.MultiSelectedImagesCount - 1 downto 0 do   // 22.11.2016
          begin
            if (DeselectIdx = -1) or (prev.MultiView.MultiSelectedImages[i] <> DeselectIdx) then
            begin
              Lst.Add(prev.List[prev.MultiView.MultiSelectedImages[i]]);
              if (prev.List[prev.MultiView.MultiSelectedImages[i]].Id <> -1) and
                  (((not prev.List[prev.MultiView.MultiSelectedImages[i]].Loaded) or InEditMode) and
                  (not prev.List[prev.MultiView.MultiSelectedImages[i]].InEditMode))
              then
                Reload := True;
            end;
          end;
          DocIdx := idx;
          PageIdx := -1;
          SetChkPrintAfterArchive(prev); // bfacrm:ticket__show__30288
        end
        else if (Sender as TbfaImageEnMView).Tag = tagThumbnailMView then
        begin
          if (DeselectIdx = -1) or (prev.MultiView.SelectedImage <> DeselectIdx) then
          begin
            if prev.PreviewKind = pvkSingle then
              Doc := prev.List[0]
            else
              Doc := prev.List[prev.MultiView.SelectedImage];
            DocIdx := prev.MultiView.SelectedImage;
            PageIdx := idx;
          end
          else
            Exit;
        end;

        if (prev.PreviewKind = pvkMulti) or (((prev.ThumbnailView.Visible) and (not prev.ThumbnailView.MultiSelecting) and
            (((FCurrentContainer[0].ScanPoolView <> nil) and (FCurrentContainer[0].ScanPoolViewLoaded)) or (prev.ThumbnailView.SelectedImage <> prev.SingleView.img_DocView.IO.Params.ImageIndex))
             or (prev.PreviewKind <> pvkMultiSingle)) or (not prev.ThumbnailView.Visible))
        then
        begin
          if (prev.PreviewKind = pvkMulti) and (InNewTab) and ((FCurrentContainer.Count > 0) and (((FCurrentContainer[0].Id <> -1) and (FCurrentContainer[0].Id = prev.List[DocIdx].Id)) or ((FCurrentContainer[0].Id = -1) and (GUIDToString(FCurrentContainer[0].TempID) = GUIDToString(prev.List[DocIdx].TempID))))) then
            prev.FDelay.Enabled := False;

//12.07.2024 bfacrm:ticket__show__39299          CallShowDocument(Doc, Lst, LstObjs, DocIdx, PageIdx, SetCurrent, InNewTab, InBackGroundTab and (not Floating), InEditMode, SetFocus, ReloadThumbnail, prev, ChangeToMultiSingle, GetSearchString, Reload, SetImagePos, SetImagePosTothetop, Autozoom, PageDirection, Floating);
          CallShowDocument(Doc, Lst, LstObjs, DocIdx, PageIdx, SetCurrent, InNewTab,
            InBackGroundTab and (not Floating), InEditMode, SetFocus, ReloadThumbnail,
            prev, ChangeToMultiSingle, GetSearchString, Reload, SetImagePos, SetImagePosTothetop,
            Autozoom, PageDirection, Floating, MouseClick);
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'MViewImageSelect', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'MViewImageSelect', Classname);
  end;
end;

function TbfaApplication.GetSearchString: WideString;
var
  sl: TStringList;
  SearchString: WideString;
  str: string;
  i, delimiter: Integer;
begin
  try
    Result := '';
    SearchString := '';

    if (bitfarmApp.PreviewContainer.ViewerItem.Preview.SearchbarToolbar.Visible) and
        (bitfarmApp.PreviewContainer.ViewerItem.Preview.SearchbarTextEdit.Text <> frmMainForm.edtGeneralSearch.Text) and
          (bitfarmApp.PreviewContainer.ViewerItem.Preview.SearchbarTextEdit.Text <> '') then
      SearchString := bitfarmApp.PreviewContainer.ViewerItem.Preview.SearchbarTextEdit.Text
    else if (frmMainForm.edtSearchText.EditValue <> Null) then
      SearchString := frmMainForm.edtSearchText.Text
    else if (frmMainForm.edtSearchFTX.compEdit.Text <> '') and (not frmMainForm.edtSearchFTX.Negate) then
      SearchString := frmMainForm.edtSearchFTX.compEdit.Text;

    if SearchString <> '' then
    begin
      sl := TStringList.Create;
      try
        SearchString := StringReplace(SearchString, '/', '', [rfReplaceAll]);
        SearchString := StringReplace(SearchString, '+', '', [rfReplaceAll]);

        i := 1;
        str := '';
        delimiter := 0;
        while i <= Length(SearchString) do
        begin
          if SearchString[i] = '"' then
          begin
            inc(delimiter);
            if delimiter = 2 then
            begin
              sl.Add(str);
              str := '';
              delimiter := 0;
            end;
          end
          else if (((SearchString[i] = ' ') and (delimiter = 0)) or ((i = Length(SearchString)) and (str <> ''))) then
          begin
            if (i = Length(SearchString)) and (SearchString[i] <> '') and (SearchString[i] <> '"') then
              str := str + SearchString[i];
            sl.Add(str);
            str := '';
            delimiter := 0;
          end
          else
          begin
            str := str + SearchString[i];
          end;
          inc(i);
        end;

        for i := sl.Count - 1 downto 0 do
        begin
          if (sl[i] = '') or ((sl[i] <> '') and (sl[i][1] = '-')) then
            sl.Delete(i);
        end;

        SearchString := sl.CommaText;
        SearchString := StringReplace(SearchString, ',', ' ', [rfReplaceAll]);

      finally
        FreeAndNil(sl);
      end;
    end;

    Result := SearchString;
  except
    Result := '';
  end;
end;

function TbfaApplication.GetStatefieldByID(id: Integer): TbfaStatefield;
begin
  Result := nil;
  try
    if id <= High(aStatefields) then
    begin
      Result := TbfaStatefield.Create;
      Result.Clone(aStatefields[id]);
    end;
  except
    Result := nil;
    bitfarmLog.Write(llNormal, ltException, 'GetStatefieldByID - Id : ' + IntToStr(id), ClassName);
  end;
end;

function TbfaApplication.GetUpdateFilelist: TBfaRequest;
begin
  // Enterprise-Funktion
end;

function TbfaApplication.GetCurrentDocumentInProcess(Idx: Integer = -1): Boolean;
var
  i: Integer;
  rslt: Boolean;
begin
  bitfarmLog.DebugBegin(llDebug, 'GetCurrentDocumentInProcess - Idx : ' + IntToStr(Idx), Classname);
  Result := False;
  try
    rslt := False;
    try
      if (Idx <> -1) then
      begin
        rslt := rslt or CurrentContainer[Idx].GetInProcesses;
      end
      else
      begin
        for i := 0 to CurrentContainer.Count - 1 do
          rslt := rslt or CurrentContainer[i].GetInProcesses;
      end;
      Result := rslt;
    except
      bitfarmLog.Write(llNormal, ltException, 'GetCurrentDocumentInProcess - Idx : ' + IntToStr(Idx), ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'GetCurrentDocumentInProcess - Idx : ' + IntToStr(Idx), Classname);
  end;
end;

procedure TbfaApplication.CurrentDocumentStartCloneProcess(Idx: Integer = -1);
var
  i: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'CurrentDocumentStartCloneProcess - Idx : ' + IntToStr(Idx), Classname);
  try
    try
      if (Idx <> -1) then
      begin
        CurrentContainer[Idx].StartCloneProcess;
      end
      else
      begin
        for i := 0 to CurrentContainer.Count - 1 do
          CurrentContainer[i].StartCloneProcess;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'CurrentDocumentStartCloneProcess - Idx : ' + IntToStr(Idx), ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CurrentDocumentStartCloneProcess - Idx : ' + IntToStr(Idx), Classname);
  end;
end;

procedure TbfaApplication.CurrentDocumentEndCloneProcess(Idx: Integer = -1);
var
  i: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'CurrentDocumentEndCloneProcess - Idx : ' + IntToStr(Idx), Classname);
  try
    try
      if (Idx <> -1) then
      begin
        CurrentContainer[Idx].EndCloneProcess;
      end
      else
      begin
        for i := 0 to CurrentContainer.Count - 1 do
          CurrentContainer[i].EndCloneProcess;
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'CurrentDocumentEndCloneProcess - Idx : ' + IntToStr(Idx), ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CurrentDocumentEndCloneProcess - Idx : ' + IntToStr(Idx), Classname);
  end;
end;

procedure TbfaApplication.CurrentDocumentStartSaveProcess(Idx: Integer = -1);
var
  i: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'CurrentDocumentStartSaveProcess - Idx : ' + IntToStr(Idx), Classname);
  try
    try
      if (Idx <> -1) then
      begin
        CurrentContainer[Idx].StartSaveProcess;
      end
      else
      begin
        for i := 0 to CurrentContainer.Count - 1 do
          CurrentContainer[i].StartSaveProcess;
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'CurrentDocumentStartSaveProcess - Idx : ' + IntToStr(Idx), ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CurrentDocumentStartSaveProcess - Idx : ' + IntToStr(Idx), Classname);
  end;
end;

procedure TbfaApplication.CurrentDocumentEndSaveProcess(Idx: Integer = -1);
var
  i: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'CurrentDocumentEndSaveProcess - Idx : ' + IntToStr(Idx), Classname);
  try
    try
      if (Idx <> -1) then
        CurrentContainer[Idx].EndSaveProcess
      else
        for i := 0 to CurrentContainer.Count - 1 do
          CurrentContainer[i].EndSaveProcess;
    except
      bitfarmLog.Write(llNormal, ltException, 'CurrentDocumentEndSaveProcess - Idx : ' + IntToStr(Idx), ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CurrentDocumentEndSaveProcess - Idx : ' + IntToStr(Idx), Classname);
  end;
end;

function TbfaApplication.GetActivePreview: TbfaPreview;
begin
  try
    if ((FPreviewContainer <> nil) and
        (FPreviewContainer.Containers.Count > 0) and
        (FPreviewContainer.ActiveItem <> -1) and
        (FPreviewContainer.ActiveItem < FPreviewContainer.Containers.Count) and
        Assigned(FPreviewContainer.Containers[FPreviewContainer.ActiveItem]))
    then
      Result := FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview
    else
      Result := nil;
  except
    Result := nil;
  end;
end;

procedure TbfaApplication.SaveAnnoObjects(AThread: TThread; DocView: Tfrm_Voransicht; ActiveDoc: TbfaDocument; prev: TbfaPreview; SetInteracts, SetIntervtBack: Boolean; IgnoreRights: Boolean = False);
var
  sIEVFile, sDocPath, sExtFile, sTmpPath, lsIArcName, lssql, vtx, sCheckoutUser: string;
  liarcno, liCount, hobj, idx: integer;
  liRecNo, ievUser, iCheckoutuser: integer;
  ievType: Byte;
  ievstream: TMemoryStream;
  img: TbfaImageEnVect;
begin
  if ((DocView.fsavingobjs) or (DocView.img_DocView = nil) or (DocView.img_DocView.IsEmpty) or (ActiveDoc = nil)) then
    Exit;

  bitfarmLog.DebugBegin(llDebug, 'SaveAnnoObjects', Classname);
  try
    try
      try
        DocView.fsavingobjs := true;

        AThread.Synchronize(nil,
          procedure
          begin
            DocView.img_DocView.CancelInteracts;
            DocView.img_DocView.DeSelect;
            DocView.img_DocView.UnSelAllObjects;

            if (DocView.img_DocView.MouseInteractVt <> [miObjectSelect]) and (DocView.img_DocView.MouseInteractVt <> []) and SetIntervtBack then
              DocView.img_DocView.MouseInteractVt := [];

            liCount := 0;     // Leere Textannos lschen
            while liCount < DocView.img_DocView.ObjectsCount do
            begin
              hobj := DocView.img_DocView.GetObjFromIndex(liCount);
              if (DocView.img_DocView.ObjKind[hobj] in [iekText, iekMEMO]) and (DocView.img_DocView.ObjBrushStyle[hobj] = bsClear) and (DocView.img_DocView.ObjText[hobj] = '') then
                DocView.img_DocView.RemoveObject(hobj)
              else
                inc(liCount);
            end;
          end);

        if DocView.CheckAnnoRights or IgnoreRights or DocView.fAnnosRotated then
        begin
          if (ActiveDoc.CheckOutUserID <> -1) and (ActiveDoc.CheckOutUserID <> Self.User.ID) then
          begin
            sCheckoutUser := DBGetUserName(ActiveDoc.CheckOutUserID);
            BfShowMessage(Format(_('Das Dokument wurde von %s ausgecheckt.\nAnmerkungen speichern ist nicht mglich.'), [sCheckoutUser]), AThread);
            DocView.gbAnnoNotSaved := False;
            Exit;
          end;

          ActiveDoc.StartSaveProcess;
          RefreshDocumentInPreviews(AThread, ActiveDoc, prev, nil, True);

          if (ActiveDoc <> nil) then
          begin
            SaveAnnotation(AThread, DocView, ActiveDoc);

            if prev.ThumbnailView.Visible then
            begin
              AThread.Synchronize(nil,
                procedure
                begin
                  CreateThumbnailWithAnno(DocView.img_DocView, prev, ActiveDoc, True);
                end);
            end;
          end;
        end
        else
        begin
          BfShowMessage(_('Hinweis!') + #13 + _('Sie drfen auf diesem Dokument keine Anmerkungen speichern'), AThread);
        end;

        if SetInteracts then
        begin
          if (DocView.img_DocView.MouseInteractVt <> [miObjectSelect]) and (DocView.img_DocView.MouseInteractVt <> []) then
            DocView.img_DocView.MouseInteractVt := [];
          DocView.img_DocView.MouseInteract := [miScroll];
        end;
        DocView.bGDelObj := False;
        DocView.gbAnnoNotSaved := False;
        if Assigned(DocView.fAfterSaveObjects) then
          DocView.fAfterSaveObjects;
      finally
        DocView.fTextAnnoCreated := False;
        DocView.fAnnosRotated := False;
        DocView.fsavingobjs := False;
        ActiveDoc.EndSaveProcess;
        RefreshDocumentInPreviews(AThread, ActiveDoc, prev, nil);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'SaveAnnoObjects', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SaveAnnoObjects', Classname);
  end;
end;

procedure TbfaApplication.SaveAnnotation(AThread: TThread; DocView: Tfrm_Voransicht; Doc: TbfaDocument);
var
  ievstream: TMemoryStream;
  idx, i, imgidx: Integer;
  AnnoObj: TbfaAnnotation;
  found: Boolean;
begin
  bitfarmLog.DebugBegin(llDebug, 'SaveAnnotation', Classname);
  try
    try
      if DocView.img_DocView.ObjectsCount > 0 then
      begin
        ievstream := TMemoryStream.Create;
        try
          AThread.Synchronize(nil,
            procedure
            begin
              DocView.img_DocView.Update;
              DocView.img_DocView.DeSelect;
              DocView.img_DocView.UnSelAllObjects;
              DocView.img_DocView.SaveToStreamIEV(ievstream);
              ievstream.Position := 0;
            end);

          if (Doc.ScanPoolView <> nil) and (Doc.ScanPoolViewLoaded) then
            imgidx := TbfaPreview(DocView.Owner).ActivePage
          else
            imgidx := DocView.img_DocView.IO.Params.ImageIndex;

          Doc.GetAnnotation(imgidx, TbfaPreview(DocView.Owner).CurrentLayer, idx);
          if idx <> -1 then
          begin
            with Doc.Annotations[idx].AnnoStream do
            begin
              Clear;
              CopyFrom(ievstream, ievstream.Size);
              Position := 0;
            end;
            Doc.Annotations[idx].modified := True;
          end
          else
          begin
            AnnoObj := TbfaAnnotation.Create;
            AnnoObj.AnnoStream.CopyFrom(ievstream, ievstream.Size);
            AnnoObj.AnnoStream.Position := 0;
            AnnoObj.Layer := TbfaPreview(DocView.Owner).CurrentLayer;
            AnnoObj.Page := imgidx;
            AnnoObj.Modified := True;
            Doc.Annotations.Add(AnnoObj);
          end;
        finally
          FreeAndNil(ievstream);
        end;
      end
      else
      begin
        if Doc.Annotations.Count > 0 then
        begin
          Doc.DeleteAnno(imgidx);
        end;
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'SaveAnnotation', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SaveAnnotation', Classname);
  end;
end;

//procedure TbfaApplication.DeleteFromDir(ContType: Integer);
//var
//  Lst: TStringList;
//  i, idx: Integer;
//  Str: string;
//begin
//  bitfarmLog.DebugBegin(llDebug, 'DeleteFromImportDir', ClassName);
//  try
//    Lst := TStringList.Create;
//    try
//      if ContType = 0 then
//        GetAllFilesInDir(BD.EnvAppdataImporterPd, Lst)
//      else if ContType = 1 then
//        GetAllFilesInDir(BD.EnvAppdataWorkplacePd, Lst);
//
//      for i := 0 to Lst.Count - 1 do
//      begin
//        Str := TPath.GetFileNameWithoutExtension(Lst[i]);
//        idx := StrToInt(Str);
//        if ContType = 0 then
//        begin
//          if idx > FImportContainer.Count - 1 then
//            DeleteFile(Lst[i]);
//        end
//        else if ContType = 1 then
//        begin
//          if idx > FWorkplaceContainer.Count - 1 then
//            DeleteFile(Lst[i]);
//        end;
//
//      end;
//    finally
//      FreeAndNil(Lst);
//    end;
//  finally
//    bitfarmLog.DebugEnd(llDebug, 'DeleteFromImportDir', ClassName);
//  end;
//end;

//procedure TbfaApplication.SaveImporter(Data: PUserAction);
//begin
//  bitfarmLog.DebugBegin(llDebug, 'SaveImporter', ClassName);
//  try
//    SaveDocumentsToXML(FImportContainer, BD.EnvAppdataImporterPd);
//    DeleteFromDir(0);
//  finally
//    bitfarmLog.DebugEnd(llDebug, 'SaveImporter', ClassName);
//  end;
//end;

function TbfaApplication.SaveDocumentsToXML(DocList: Tlist<TbfaDocument>;
  Path: string; idx: Integer = -1; WithSplashForm : Boolean = True; AThread: TThread = nil): Boolean;
var
  i, j: Integer;
  AnnoName, msg, XMLFileName: WideString;
  Lst: Tlist<TbfaBaseObject>;
  Doc: TbfaDocument;
  fs: TFileStream;
begin
  Result := False; //06.06.2023 nur beim Cancel muss True sein!
  if DocList.Count = 0 then
    Exit;

  if AThread = nil then  //22.09.2023
  begin
    if bitfarmApp.ImportContainer = DocList then
      msg := _('Dokumente im Importer werden gespeichert...')
    else if bitfarmApp.WorkplaceContainer = DocList then
      msg := _('Dokumente im Arbeitsplatz werden gespeichert...');
  end
  else
  begin
    AThread.Synchronize(nil,
      procedure
      begin
        if bitfarmApp.ImportContainer = DocList then
          msg := _('Dokumente im Importer werden gespeichert...')
        else if bitfarmApp.WorkplaceContainer = DocList then
          msg := _('Dokumente im Arbeitsplatz werden gespeichert...');
      end);
  end;

  if WithSplashForm then
  begin
    if AThread = nil then  //22.09.2023
    begin
      frmMainForm.frmSplash.lblLoading.Caption := msg;
      frmMainForm.frmSplash.Update;
      if not frmMainForm.frmSplash.Showing then
        frmMainForm.frmSplash.Show;
    end
    else
    begin
      AThread.Synchronize(nil,
        procedure
        begin
          frmMainForm.frmSplash.lblLoading.Caption := msg;
          frmMainForm.frmSplash.Update;
          if not frmMainForm.frmSplash.Showing then
            frmMainForm.frmSplash.Show;
        end);
    end;
  end;

  bitfarmLog.DebugBegin(llDebug, 'SaveDocumentsToXML Path: ' + Path, Classname);
  Lst := Tlist<TbfaBaseObject>.Create;
  try
    try
      if idx = -1 then  // Beim outlookimport mit mehreren Dateien oder Attachments war immer nur 1 Datei im Verzeichniss
      begin
        if (Path = Bd.EnvAppdataImporter) or (Path = Bd.EnvAppdataImporterPd) then
        begin
          if WithSplashForm then
          begin
            if AThread = nil then  //22.09.2023
            begin
              frmMainForm.frmSplash.FormType := sftImporter;
            end
            else
            begin
              AThread.Synchronize(nil,
                procedure
                begin
                  frmMainForm.frmSplash.FormType := sftImporter;
                end);
            end;
          end;

          if DirectoryExists(BD.EnvAppdataImporter) then
          begin
            if not IsDirectoryEmpty(BD.EnvAppdataImporter) then
            begin
              EmptyDirectory(BD.EnvAppdataImporter);
            end;
          end;
        end
        else if (Path = Bd.EnvAppdataWorkplace) or (Path = Bd.EnvAppdataWorkplacePd) then
        begin
          if WithSplashForm then
          begin
            if AThread = nil then  //22.09.2023
            begin
              frmMainForm.frmSplash.FormType := sftWorkplace;
            end
            else
            begin
              AThread.Synchronize(nil,
                procedure
                begin
                  frmMainForm.frmSplash.FormType := sftWorkplace;
                end);
            end;
          end;

          if DirectoryExists(BD.EnvAppdataWorkplace) then
          begin
            if not IsDirectoryEmpty(BD.EnvAppdataWorkplace) then
            begin
              EmptyDirectory(BD.EnvAppdataWorkplace);
            end;
          end;
        end;
      end;

      if WithSplashForm then
      begin
        if AThread = nil then  //22.09.2023
        begin
          frmMainForm.frmSplash.UseTimer := True;
          frmMainForm.frmSplash.pgbDocuments.Properties.Min := 0;
          frmMainForm.frmSplash.pgbDocuments.Position := 0;
          frmMainForm.frmSplash.pgbDocuments.Properties.Max := DocList.Count;
          frmMainForm.frmSplash.Update;
        end
        else
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              frmMainForm.frmSplash.UseTimer := True;
              frmMainForm.frmSplash.pgbDocuments.Properties.Min := 0;
              frmMainForm.frmSplash.pgbDocuments.Position := 0;
              frmMainForm.frmSplash.pgbDocuments.Properties.Max := DocList.Count;
              frmMainForm.frmSplash.Update;
            end);
        end;
      end;

      bitfarmLog.Debug(llDebug, 'SaveDocumentsToXML DocList.Count: ' +
        IntToStr(DocList.Count), Classname);
      for j := 0 to DocList.Count - 1 do
      begin
        if WithSplashForm then
        begin
          if AThread = nil then  //22.09.2023
          begin
            frmMainForm.frmSplash.lblLoading.Caption := msg;
              frmMainForm.frmSplash.lblInfo.Caption := ' (' + IntToStr(j + 1) + '/' +
                IntToStr(DocList.Count) + ')';
            frmMainForm.frmSplash.Update;
          end
          else
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                frmMainForm.frmSplash.lblLoading.Caption := msg;
                  frmMainForm.frmSplash.lblInfo.Caption := ' (' + IntToStr(j + 1) + '/' +
                    IntToStr(DocList.Count) + ')';
                frmMainForm.frmSplash.Update;
              end);
          end;
        end;
        try
          if DocList[j] <> nil then
          begin
            with DocList[j] do
            begin
              bitfarmLog.DebugBegin(llDebug, 'SaveDocumentsToXML - Save one Doc to XML BEGIN - DocList[j].ID: ' +
                IntToStr(DocList[j].Id), Classname);
              if DocList[j].Id = -1 then
              begin
                if (DocList[j].ScanPoolViewchanged) or (DocList[j].ScanPoolViewLoaded and
                    ((DocList[j].DocStream = nil) or (DocList[j].DocStream.Size = 0))) then
                begin
                  DocList[j].DocStream.Clear;
                  if DocList[j].ScanPoolView <> nil then
                    DocList[j].ScanPoolView.MIO.SaveToStreamTIFF(DocList[j].DocStream);
                end;

                if FileType <> '' then
                  DocLoc := Path + GUIDToString(TempID) + '\StreamTIF' + FileType
                else
                  DocLoc := Path + GUIDToString(TempID) + '\StreamTIF.tif';

                bitfarmLog.Debug(llDebug, 'SaveDocumentsToXML - Save one Doc to XML BEGIN - DocLoc: ' +
                  DocLoc, Classname);

                if (OriStream <> nil) and (OriStream.Size > 0) then
                begin
                  if FileType <> '' then
                    OriLoc := Path + GUIDToString(TempID) + '\StreamORI' + FileType
                  else
                    OriLoc := Path + GUIDToString(TempID) + '\StreamORI.tif';
                end;
                bitfarmLog.Debug(llDebug, 'SaveDocumentsToXML - Save one Doc to XML BEGIN - OriLoc: ' +
                  OriLoc, Classname);



                Lst.Clear;
                Lst.Add(DocList[j]);
//16.06.2023 -->
//                if idx = -1 then //Beim OutlookImport kann nicht -1 sein
//                  ObjectToXML(Lst, False, 'US-ASCII', Path +
//                    SysUtils.Format('%.*d', [4, j]) + '.xml')
//                else
//                  ObjectToXML(Lst, False, 'US-ASCII', Path +
//                    SysUtils.Format('%.*d', [4, idx]) + '.xml');

                if idx = -1 then //Beim OutlookImport kann nicht -1 sein
                  XMLFileName := SysUtils.Format('%.*d', [4, j]) + '.xml'
                else
                  XMLFileName := SysUtils.Format('%.*d', [4, idx]) + '.xml';

                ObjectToXML(Lst, False, 'US-ASCII', Path + XMLFileName);
//16.06.2023 <--

                if not DirectoryExists(Path + GUIDToString(TempID)) then
                begin
                  bitfarmLog.Debug(llDebug, 'SaveDocumentsToXML - Save one Doc to XML BEGIN - ForceDirectories: ' +
                    Path + GUIDToString(TempID), Classname);
                  ForceDirectories(Path + GUIDToString(TempID));
                end;

                if DocStream.Size > 0 then
                begin
                  DocStream.Position := 0;
                  bitfarmLog.DebugBegin(llDebug, 'SaveDocumentsToXML - Save StreamTIF BEGIN', Classname);
                  DocStream.SaveToFile(Path + GUIDToString(TempID) + '\StreamTIF.tif');
                  bitfarmLog.DebugEnd(llDebug, 'SaveDocumentsToXML - Save StreamTIF END', Classname);
                  DocStream.Position := 0;
                end;
                if (OriStream <> nil) and (OriStream.Size > 0) then
                begin
                  OriStream.Position := 0;
                  bitfarmLog.DebugBegin(llDebug, 'SaveDocumentsToXML - Save StreamORI BEGIN', Classname);
                  if FileType <> '' then
                  begin
                    if (not FileExists(Path + GUIDToString(TempID) + '\StreamORI' + FileType)) then
//24.05.2023
//                      OriStream.SaveToFile(Path + GUIDToString(TempID) + '\StreamORI' + FileType);
                    begin
//14.11.2023                      CopyFileWithBuffer(OriStream, '', Path + GUIDToString(TempID) + '\StreamORI' + FileType, True, AThread);
                      CopyFileWithBuffer(OriStream, '', Path + GUIDToString(TempID) + '\StreamORI' + FileType, True, AThread);
                      Result := frmMainForm.frmSplash.Canceled; //06.06.2023 wenn durch die Verarbeitung gecancelt wird
//05.06.2023
//                      fs := TFileStream.Create(Path + GUIDToString(TempID) + '\StreamORI' + FileType,
//                        fmCreate or fmOpenWrite or fmShareDenyNone);
//                      fs.CopyFrom(OriStream, OriStream.Size);
//                      fs.Free;
                      OriStream.Free;

                      if not frmMainForm.frmSplash.Canceled then
                      begin
                        OriStream := TFileStream.Create(Path + GUIDToString(TempID) + '\StreamORI' + FileType,
                          fmOpenRead or fmShareDenyNone);
                        OriStream.Position := 0;
                        OriLoc := TFileStream(OriStream).FileName; //04.08.2023
                      end
                      else
                      begin
                        try
//                          if FileExists(Path + GUIDToString(TempID) + '\StreamORI' + FileType) then
//                            DeleteFile(Path + GUIDToString(TempID) + '\StreamORI' + FileType);
                          DeleteDirectory(Path + GUIDToString(TempID)); //16.06.2023 Muss die gsamte Verzeichnis gelscht werden wenn gecanceled beim laden wird
                          DeleteFile(Path + XMLFileName);
                        except
                          //16.06.2023
                        end;
                      end;
                    end;
                  end
                  else
                  begin
                    if (not FileExists(Path + GUIDToString(TempID) + '\StreamORI.tif')) then
                    begin
//24.05.2023
//                      OriStream.SaveToFile(Path + GUIDToString(TempID) + '\StreamORI.tif');
                      CopyFile(PWideChar(TFileStream(OriStream).FileName),
                               PWideChar(Path + GUIDToString(TempID) + '\StreamORI.tif'),
                               False);
                       OriStream.Position := 0;
                    end;
                  end;
                  bitfarmLog.DebugEnd(llDebug, 'SaveDocumentsToXML - Save StreamORI END', Classname);
                end
//04.08.2023 wegen Abstrze bei OutlookAddIn ein Test -->
                else if (OriStream = nil) and (OriLoc <> '') then
                begin
                  if FileExists(OriLoc) then //30.08.2023 zB. archivierte Dokumente zum Importer senden haben hier mnoch %bfastore0%, die als Client nicht immer erreichbar sind
                  begin
                    //erst Kopieren ins bitfarm-archiv Verzeichnis
                    CopyFile(PWideChar(OriLoc),
                             PWideChar(Path + GUIDToString(TempID) + '\StreamORI' + ExtractFileExt(OriLoc)),
                             False);
                    //dann TFileStream setzen und das Docobject zuordnen
                    OriStream := TFileStream.Create(Path + GUIDToString(TempID) + '\StreamORI' + ExtractFileExt(OriLoc),
                      fmOpenRead or fmShareDenyNone);
                    OriStream.Position := 0;
                    OriLoc := TFileStream(OriStream).FileName;
                  end;
                end;
//04.08.2023 wegen Abstrze bei OutlookAddIn ein Test <--
              end
              else
              begin
                Doc := TbfaDocument.Create;
                try
                  Doc.ID := DocList[j].Id;
                  Doc.Arcid := DocList[j].ArcID;
                  Doc.SymbolicArcID := DocList[j].SymbolicArcID; //26.10.2017 Ticket 11031
                  Lst.Clear;
                  Lst.Add(Doc);

                  if idx = -1 then //Beim OutlookImport kann nicht -1 sein
                    ObjectToXML(Lst, False, 'US-ASCII', Path +
                      SysUtils.Format('%.*d', [4, j]) + '.xml')
                  else
                    ObjectToXML(Lst, False, 'US-ASCII', Path +
                      SysUtils.Format('%.*d', [4, idx]) + '.xml');
                finally
                  FreeAndNil(Doc);
                end;
              end;
              bitfarmLog.DebugEnd(llDebug,'SaveDocumentsToXML - Save one Doc to ' +
                'XML END - DocList[j].ID: ' + IntToStr(DocList[j].Id), Classname);
            end;
          end;
        except
          bitfarmLog.Write(llNormal, ltException, _('Fehler beim Speichern' +
            ' TempID: ' + GUIDToString(DocList[i].TempID)), ClassName);
        end;
        if WithSplashForm then
        begin
          if AThread = nil then  //22.09.2023
          begin
            frmMainForm.frmSplash.IncProgressBar;
          end
          else
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                frmMainForm.frmSplash.IncProgressBar;
              end);
          end;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'SaveDocumentsToXML', ClassName);
    end;
  finally
    FreeAndNil(Lst);
    bitfarmLog.DebugEnd(llDebug, 'SaveDocumentsToXML Path: ' + Path, Classname);
  end;
end;

procedure TbfaApplication.ChangeDocName(AThread: TThread; Objects: TList;
  prev: TbfaPreview);
begin
  bitfarmLog.DebugBegin(llDebug, 'ChangeDocName', ClassName);
  try
    try
      bfaCommonImageEN.ChangeDocName(AThread, TList<TbfaDocument>(Objects), prev);
    except
      bitfarmLog.Write(llNormal, ltException, 'ChangeDocName', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ChangeDocName', ClassName);
  end;
end;

procedure TbfaApplication.AddFolder(AThread: TThread; Objects: TList);
var
  SelNode, RootNode: TTreeNode;
  FolderName: string;
  XML: IXMLDocument;
  CurNode: IXMLNode;
  req: TbfaRequest;
  NodeInfo: TbfaNodeInfo;
  tmpGuid: TGUID;
begin
  bitfarmLog.DebugBegin(llDebug, 'AddFolder', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          var Cancel: Boolean;
          Cancel := False;
          FolderName := '';

          while (FolderName = '') do
          begin
            Cancel := not bfaInputQuery(_('Ordner Hinzufgen'),
                _('Bitte geben Sie einen neuen Namen ein:'), FolderName);
            FolderName := Trim(FolderName);
            if Cancel then
              Break;
          end;

          if (FolderName <> '') then
          begin
            SelNode := TTreeNode(Objects[0]);
            CreateGuid(tmpGuid);
            NodeInfo := TbfaNodeInfo.Create;
            NodeInfo.Typ := 1;
            NodeInfo.GUID := GuidToString(tmpGuid);

            if TObject(SelNode.Data) is TbfaNodeInfo then
            begin
              NodeInfo.userid := TbfaNodeInfo(SelNode.Data).userid;
              NodeInfo.groupid := TbfaNodeInfo(SelNode.Data).groupid;
            end
            else if TObject(SelNode.Data) is TbfaSearch then
            begin
              NodeInfo.userid := TbfaSearch(SelNode.Data).userid;
              NodeInfo.groupid := TbfaSearch(SelNode.Data).groupid;
            end;


//            AddTreeviewNode(FLog, frmMainForm.trvBookmarks, SelNode, nil, 1,
//              False, FolderName, 1);
            AddTreeviewNode(FLog, frmMainForm.trvBookmarks, SelNode, NodeInfo, 1,
              False, FolderName, 1);
            SaveBookmarkNode(SelNode);
          end;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'AddFolder', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'AddFolder', ClassName);
  end;
end;

procedure TbfaApplication.SaveBookmarkNode(Node: TTreeNode);
var
  RootNode, ParentNode: TTreeNode;
  userid, groupid: Int64;
begin
  {$IFDEF ENTERPRISE}
  RootNode := GetRootNode(Node);
  if (RootNode = FGlobalListNode) and User.isAdmin then
  begin
    if Node.Data = nil then
      Node := GetParentNode(Node);
    if Node = nil then
    begin
      BfShowMessage(_('Fr das globale Lesezeichen wurde keine Zuordnung ausgewhlt.\nBitte whlen Sie unter den globalen Lesezeichen die gewnschte Zuordnung.'));
      Exit;
    end;
    if TObject(Node.Data) is TbfaSearch then
    begin
      Node := GetParentNode(Node);
      userid := TbfaNodeInfo(Node.Data).userid;
      groupid := TbfaNodeInfo(Node.Data).groupid;
    end
    else if TObject(Node.Data) is TbfaNodeInfo then
    begin
      Node := GetParentNode(Node);
      userid := TbfaNodeInfo(Node.Data).userid;
      groupid := TbfaNodeInfo(Node.Data).groupid;
    end;
    SaveBookmarks(Node, 0, userid, groupid);
  end
  else
    {$ENDIF}
    SaveBookmarks(FLocalListNode, 1, User.ID, 0, _('Lokale Lesezeichen'));

end;

procedure TbfaApplication.SaveBookmarks(Node: TTreeNode; Typ: Integer; Userid, Groupid: Int64; Attrname: WideString = '');
var
  SelNode: TTreeNode;
  FolderName: string;
  XML: IXMLDocument;
  RootNode, CurNode: IXMLNode;
  req: TbfaRequest;
  SendSocket: TSocketConnection;
  UserAction: PUserAction;
  QuickFix: Widestring; // bfacrm:ticket__show__32776
begin
  COInitialize(nil);
  XML := NewXMLDocument;
  try
    XML.Encoding := 'US-ASCII';
    XML.Options := [doNamespaceDecl];
    RootNode := XML.AddChild('bookmark');

    if (Attrname = '') and (Node.Text <> '') then
      RootNode.Attributes['name'] := Node.text
    else
      RootNode.Attributes['name'] := Attrname;

    AddOneNode(Node, XML, RootNode);

    req := TbfaRequest.Create;
    try
      req.ReqType := 'reqSaveBookmarks';
      req.UserID := user.ID;
      req.Profile := Self.Profile;
//    <!-- TODO @ SERVER ! NUR QUICKFIX FR TICKET bfacrm:ticket__show__32776
//      QuickFix := StringReplace(XML.XML.Text, '%%', '%', [rfReplaceAll]);
//      req.DataString := QuickFix;
      req.DataString := XML.XML.Text;
//    bfacrm:ticket__show__32776 -->
      req.Parameter := Format('%d;%d;%d;%s', [Typ, Userid, Groupid, RootNode.Attributes['name']]);  //Typ ,userid, groupid, name
      req.Lang := Lang;
      SendSocket := TSocketConnection.Create(bfaServerNoSSL, bfaServer, bfaServerPort, '');

      SendSocket.CreateComponents;
      if SendSocket.Connect then
      begin
        SendSocket.SendRequestToServer(req);

        req := SendSocket.ReceiveResponse(nil, bitfarmApp.ClosingMainForm);
        if req = nil then
          Exit;
      end
      else
        bitfarmLog.Write(llDebug, ltInfo, 'Es konnte keine Socketverbindung aufgebaut werden (WriteHistory)');

      if req.ReqType = 'respAuthError' then
      begin
        BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'));
        UserAction := CreateUserAction;
        UserAction^.ActionName := 'actRelogin';
        MainThread.Add(UserAction);
        Exit;
      end
      else if req.ReqType = 'respError' then
      begin
        BfShowMessage(_('Das Lesezeichen konnte nicht gespeichert werden'));

        if Node = FGlobalListNode then
        begin
          FGlobalListNode.DeleteChildren;
          LoadBookmarkList(FLog, frmMainForm.trvBookmarks, FGlobalListNode, 2, FUser);
          FGlobalListNode.Expand(True); // TODO SJ: restore
        end
        else if Node = FLocalListNode then
        begin
          FLocalListNode.DeleteChildren;
          LoadBookmarkList(FLog, frmMainForm.trvBookmarks, FLocalListNode, 1, FUser);
          FLocalListNode.Expand(True); // TODO SJ: restore
        end;
      end;
    finally
      FreeAndNil(req);
      SendSocket.DisConnect;
      FreeAndNil(SendSocket);
    end;
  finally
    CoUnInitialize;
  end;
end;

procedure TbfaApplication.CreateBookmarkDialog(AThread: TThread; Objects: TList);
var
  SelNode: TTreeNode;
  BookmarkName: string;
  TmpObj: TbfaSearch;
  userid, groupid: Integer;
  guid: TGUID;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateBookmarkDialog', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        var
          i: Integer;
          found: Boolean;
        begin
          SelNode := TTreeNode(Objects[0]);

          if (GetRootNode(SelNode) = GlobalListNode) or       //GlobalNode oder LocalNode mit Adminrecht
            (((SelNode = LocalListNode) or (GetRootNode(SelNode) = LocalListNode)) {and ((aSysArc[CurrentArchive.Arcid].Rights and rightAdmin) = rightAdmin)}) then   // Ticket 20864
          begin
            if TObject(SelNode.Data) is TbfaNodeInfo then
            begin
              userid := TbfaNodeInfo(SelNode.Data).userid;
              groupid := TbfaNodeInfo(SelNode.Data).groupid;
            end
            else if TObject(SelNode.Data) is TbfaSearch then
            begin
              userid := TbfaSearch(SelNode.Data).userid;
              groupid := TbfaSearch(SelNode.Data).groupid;
            end;

            frmMainForm.frmCreateGlobal := TfrmCreateGlobalBookmark.Create(frmMainForm, True);
            bitfarmApp.ChangeCreateBookmarkSkin;
            frmMainForm.frmCreateGlobal.chkCloseOnSave.Enabled := False;
            frmMainForm.frmCreateGlobal.chkCloseOnSave.State := cbChecked;
            TmpObj := TbfaSearch.Create;

            if (GetRootNode(SelNode) = GlobalListNode) then
            begin
//              frmMainForm.frmCreateGlobal.Caption := _('Globales Lesezeichen erstellen');
              if FSearchObj.ID <> -1 then
                TmpObj.Clone(FSearchObj);

              TmpObj.UserID := userid;
              TmpObj.GroupID := groupid;
              TmpObj.SearchType := 2;
            end
            else
            begin
//              frmMainForm.frmCreateGlobal.Caption := _('Lokales Lesezeichen erstellen');
//              frmMainForm.frmCreateGlobal.cbxUser.Enabled := False;
//              frmMainForm.frmCreateGlobal.btnUser.Enabled := False;
//              frmMainForm.frmCreateGlobal.cbxArchive.Enabled := True;
              TmpObj.Clone(FSearchObj);

              if (SelNode = LocalListNode) or (GetRootNode(SelNode) = LocalListNode) then
                TmpObj.Constructive := True;

              TmpObj.UserID := FUser.ID;
              TmpObj.GroupID := 0;
              TmpObj.SearchType := 1;
              TmpObj.SelectedArcID := CurrentArchive.Arcid;
            end;

            CreateGUID(guid);
            TmpObj.GUID := GUIDToString(guid);

//            frmMainForm.frmCreateGlobal.LoadBookmark(TmpObj);
            frmMainForm.frmCreateGlobal.LoadBookmark(SelNode, TmpObj);
            frmMainForm.frmCreateGlobal.btnOK.Enabled := True;
            frmMainForm.frmCreateGlobal.btnOK.ModalResult := mrOk;
            frmMainForm.frmCreateGlobal.ShowModal;

            if frmMainForm.frmCreateGlobal.ModalResult = mrOk then
            begin
              if (GetRootNode(SelNode) = GlobalListNode) and ((userid <> frmMainForm.frmCreateGlobal.sobj.UserID) or (groupid <> frmMainForm.frmCreateGlobal.sobj.GroupID)) then
              begin
                found := False;
                for i := 0 to FGlobalListNode.Count - 1 do
                begin
                  if (TObject(FGlobalListNode[i].Data) is TbfaNodeInfo) then
                  begin
                    if (TbfaNodeInfo(FGlobalListNode[i].Data).userid = frmMainForm.frmCreateGlobal.sobj.UserID) and
                       (TbfaNodeInfo(FGlobalListNode[i].Data).groupid = frmMainForm.frmCreateGlobal.sobj.GroupID) then
                    begin
                      SelNode := FGlobalListNode[i];
                      found := True;
                      Break;
                    end;
                  end;
                end;

                if not found then
                  SelNode := frmMainForm.CreateGlobalNode(frmMainForm.frmCreateGlobal.sobj.UserID, frmMainForm.frmCreateGlobal.sobj.GroupID, '');
              end;

              TmpObj.Clone(frmMainForm.frmCreateGlobal.sobj);
              AddTreeviewNode(FLog, frmMainForm.trvBookmarks, SelNode, TmpObj, TmpObj.SearchType);
              SaveBookmarkNode(SelNode);
//              frmMainForm.frmCreateGlobal.Release;
//              frmMainForm.frmCreateGlobal.Free;
              FreeAndNil(frmMainForm.frmCreateGlobal);
            end;
          end
          else
          begin
            if bfaInputQuery(_('Neues Lesezeichen anlegen'), _('Bitte geben Sie eine Bezeichnung fr das neue Lesezeichen ein:'), BookmarkName) then
            begin
              TmpObj := TbfaSearch.Create;
              TmpObj.Clone(FSearchObj);
              TmpObj.Name := BookmarkName;
              CreateGUID(guid);
              TmpObj.GUID := GUIDToString(guid);
              TmpObj.SearchType := 1;

              if (SelNode = LocalListNode) or (GetRootNode(SelNode) = LocalListNode) then
                TmpObj.Constructive := True;

              if (TmpObj.SelectedArcID > 0) and (TmpObj.SelectedArcID <= High(aSysArc)) and (aSysArc[TmpObj.SelectedArcID].Typ = 0) then   // Lager
                TmpObj.ArcID.Clear;

              AddTreeviewNode(FLog, frmMainForm.trvBookmarks, SelNode, TmpObj, TmpObj.SearchType);    // hier werden nur lokale lesezeichen angelegt

              SaveBookmarkNode(SelNode);
            end;
          end;
        end);

    except
      bitfarmLog.Write(llNormal, ltException, 'CreateBookmarkDialog', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateBookmarkDialog', ClassName);
  end;
end;

procedure TbfaApplication.CreateBookmark(AThread: TThread; Objects: TList);
var
  SelNode: TTreeNode;
  BookmarkName: string;
  TmpObj: TbfaSearch;
  userid, groupid: Integer;
  guid: TGUID;
  TmpList: TStringList;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateBookmark', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        var
          i: Integer;
          found: Boolean;
        begin
          SelNode := TTreeNode(Objects[0]);

          if bfaInputQuery(_('Neues Lesezeichen anlegen'), _('Bitte geben Sie eine Bezeichnung fr das neue Lesezeichen ein:'), BookmarkName) then
          begin
            TmpObj := TbfaSearch.Create;
            TmpObj.Clone(FSearchObj);
            TmpObj.Name := BookmarkName;
            CreateGUID(guid);
            TmpObj.GUID := GUIDToString(guid);
            TmpObj.SearchType := 1;
            TmpObj.Userid := FUser.ID;
            TmpObj.GroupID := 0;

            TmpList := TStringList.Create;

            ParseSobjToSQLWhere(TmpObj, TmpList);    // hier parsen wir das Sobj und erzeugen einen SQLWhere Ausdruck in TmpList
            CreateBookmarkSobj(TmpObj, TmpList);     // hier wird aus der TmpList ein SQLWhere String erzeugt

            FreeAndNil(TmpList);

            if (SelNode = LocalListNode) or (GetRootNode(SelNode) = LocalListNode) then
              TmpObj.Constructive := True;

            if (TmpObj.SelectedArcID > 0) and (TmpObj.SelectedArcID <= High(aSysArc)) and (aSysArc[TmpObj.SelectedArcID].Typ = 0) then   // Lager
              TmpObj.ArcID.Clear;

            AddTreeviewNode(FLog, frmMainForm.trvBookmarks, SelNode, TmpObj, TmpObj.SearchType);    // hier werden nur lokale lesezeichen angelegt

            SaveBookmarkNode(SelNode);
          end;

        end);

    except
      bitfarmLog.Write(llNormal, ltException, 'CreateBookmark', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateBookmark', ClassName);
  end;
end;

procedure TbfaApplication.CreateBookmarkForGDocID(AThread: TThread; UserAction: PUserAction);
var
  SelNode: TTreeNode;
  BookmarkName: string;
  TmpObj: TbfaSearch;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateBookmarkForGDocID', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          if (UserAction^.Documents.Count > 0) and (TbfaDocument(UserAction^.Documents[0]).Id <> -1) then
          begin
            if TbfaDocument(UserAction^.Documents[0]).DocName <> '' then
              BookmarkName := TbfaDocument(UserAction^.Documents[0]).DocName
            else
              BookmarkName := IntToStr(TbfaDocument(UserAction^.Documents[0]).Id);

            if bfaInputQuery(_('Neues Lesezeichen fr das Dokument anlegen'), _('Bitte geben Sie eine Bezeichnung fr das neue Lesezeichen ein:'), BookmarkName) then
            begin
              SelNode := TTreeNode(UserAction^.objects[0]);

              TmpObj := TbfaSearch.Create;
              TmpObj.Reset;
              TmpObj.UserID := FUser.ID;
              TmpObj.GroupID := -1;
              TmpObj.ID := 1;
              TmpObj.Name := BookmarkName;
              TmpObj.Date := FormatDateTime('dd.mm.yyyy hh:nn:ss', Now);
              TmpObj.UserContext := FUser.ID;
              TmpObj.SearchType := 0; // Normale Suche
              TmpObj.SelectedCols := SetSelectedColumns;
              if TmpObj.SelectedCols = '' then
                TmpObj.SelectedCols := 'gdocid';
              TmpObj.SQLWhere := '(sd.gdocid = ' + IntToStr(TbfaDocument(UserAction^.Documents[0]).Id) + ')';
              TmpObj.GdocIDWithSymLink := False;

              if (SelNode = LocalListNode) or (GetRootNode(SelNode) = LocalListNode) then
                TmpObj.Constructive := True;

              AddTreeviewNode(FLog, frmMainForm.trvBookmarks, SelNode, TmpObj, 1);
              SaveBookmarkNode(SelNode);
            end;
          end
          else
            BfMessageDlg(_('Bitte whlen Sie ein Dokument aus!'), mtWarning, [mbOK], False, _('Fehler'));
        end);

    except
      bitfarmLog.Write(llNormal, ltException, 'CreateBookmarkForGDocID', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateBookmarkForGDocID', ClassName);
  end;
end;

procedure TbfaApplication.SaveGlobalBookmark(Data: PUserAction);
var
  i: Integer;
  TNode: TTreeNode;
  userid, groupid: Int64;
begin
  {$IFDEF ENTERPRISE}
  if not user.isAdmin then
    Exit;

  if (Data.Objects = nil) or (Data.Objects.Count = 0) then
  begin
    for i := 0 to FGlobalListNode.Count - 1 do
    begin
      if (TObject(FGlobalListNode[i].Data) is TbfaNodeInfo) then
      begin
        userid := TbfaNodeInfo(FGlobalListNode[i].Data).userid;
        groupid := TbfaNodeInfo(FGlobalListNode[i].Data).groupid;
        SaveBookmarks(FGlobalListNode[i], 0, userid, groupid, _('Globale Lesezeichen'));
      end;
    end;
  end
  else
  begin
    if Data.Objects[0] <> nil then
    begin
      userid := TbfaNodeInfo(TTreeNode(Data.Objects[0]).Data).userid;
      groupid := TbfaNodeInfo(TTreeNode(Data.Objects[0]).Data).groupid;
    end
    else
    begin
      userid := user.ID;
      groupid := 0;
    end;
    SaveBookmarks(TTreeNode(Data.Objects[0]), 0, userid, groupid);
  end;
  {$ENDIF}
end;

procedure TbfaApplication.SaveLocalBookmark;
begin
  bitfarmLog.DebugBegin(llDebug, 'SaveLocalBookmark', ClassName);
  try
    try
      SaveBookmarks(FLocalListNode, 1, user.ID, 0);
    except
      bitfarmLog.Write(llNormal, ltException, 'SaveLocalBookmark', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SaveLocalBookmark', ClassName);
  end;
end;

procedure TbfaApplication.SaveHistoryBookmark;
begin
  bitfarmLog.DebugBegin(llDebug, 'SaveHistoryBookmark', ClassName);
  try
    try
      SaveBookmarks(FHistoryListNode, 2, user.ID, 0, _('Verlaufs-Lesezeichen'));

    except
      bitfarmLog.Write(llNormal, ltException, 'SaveHistoryBookmark', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SaveHistoryBookmark', ClassName);
  end;
end;

procedure TbfaApplication.ParseSobjToSQLWhere(var sobj: TBfaSearch; var lstSQLWhere: TStringList);
var
  addfield : TbfaAddField;
  statefield: TbfaStateField;
  sqlwhere, value : WideString;
  bracket: TbfaBracket;
  junc: TbfaJunction;
  expr, expr2: TbfaExpression;
  reg, reg2: TRegEx;
  match, match2: TMatch;
  matches: TMatchCollection;
  group: TGroup;
  i, j, k, ftxfields, Indent: Integer;
  sql: TStringList;
  add_value: WideString;
  eol, found: Boolean;
  datestr, dateformat, exprstr, replstr, tempstr : string;
  searchstring: TStringList;
begin
  if (sobj.Addfields.Count > 0)  or (sobj.StsFields.Count > 0)then
  begin
    bracket := TbfaBracket.Create;
    bracket.Kind := brOpen;
    lstSQLWhere.AddObject('(', bracket);
  end;

  if sobj.AddFields.Count > 0 then
  begin
    for i := 0 to sobj.AddFields.Count -1 do
    begin
      if i > 0 then
      begin
        junc := TbfaJunction.Create;
        junc.Kind := jnAND;
        lstSQLWhere.AddObject(junc.display, junc);
      end;

      expr := TbfaExpression.Create;
      if sobj.AddFields[i].Negate then
      begin
        bracket := TbfaBracket.Create;
        bracket.Kind := brOpen;
        lstSQLWhere.AddObject('(', bracket);
        expr.junction.Kind := jnNOT;
      end;
      expr.field := sobj.AddFields[i].Name;
      expr.ID := sobj.AddFields[i].ID;
      expr.IndexID := sobj.AddFields[i].IndexTableID;
      if sobj.AddFields[i].DisplayName = '' then
      begin
        if sobj.AddFields[i].ID > 0 then //08.09.2017 Ticket 11758
        begin
          addfield := bitfarmApp.GetAddfieldByID(sobj.AddFields[i].ID);
          if addfield <> nil then
            expr.Fieldname := addfield.DisplayName;
        end else
        begin
          try
            bitfarmLog.Write(llNormal, ltError, 'sobj.AddFields[i].ID < 0 ; i=' + IntToStr(i), '');
            bitfarmLog.Write(llNormal, ltError, 'sobj.AddFields[i].Name: ' + sobj.AddFields[i].Name, '');
            addfield := TbfaAddField.Create;
            addfield.Clone(sobj.AddFields[i]);
            if addfield <> nil then
              expr.Fieldname := addfield.Name;
          except
            bitfarmLog.Write(llNormal, ltException,  'sobj.AddFields[i].ID < 0 ; i=' + IntToStr(i), '');
          end;
        end;
      end else
        expr.Fieldname := sobj.AddFields[i].DisplayName;

      expr.Fieldtype := eAddFieldType(sobj.AddFields[i].Typ);

      // Sonderbehandlung von-bis Felder
      if expr.Fieldtype in [zfld01_Datum, zfld06_GanzZahl, zfld07_FliessKomma, zfld08_Waehrung, zfld12_DLMDate] then
      begin
        reg := TRegEx.Create('^str_to_date.+(\d{2}.\d{2}.\d{4}|\d{4}.\d{2}.\d{2})');

        if not IsEmptyVariant(sobj.AddFields[i].Value) then
        begin
          expr.op := '>=';
          match := reg.Match(sobj.AddFields[i].Value);

          if match.Success then
            expr.Value := match.Groups[1].Value
          else
            expr.Value := sobj.AddFields[i].Value;

          if (expr.Fieldtype in [zfld07_FliessKomma, zfld08_Waehrung]) and (Pos(',', expr.Value) > 0) then
            expr.Value := ReplaceStr(expr.Value, ',', '.');

          expr.Update;
          lstSQLWhere.AddObject(expr.Display, expr);
        end;

        if not IsEmptyVariant(sobj.AddFields[i].ValueHigh) then
        begin
          if not IsEmptyVariant(sobj.AddFields[i].Value) then
          begin
            junc := TbfaJunction.Create;
            junc.Kind := jnAND;
            lstSQLWhere.AddObject(junc.display, junc);
          end;

          expr2 := TbfaExpression.Create;
          expr2.Clone(expr);
          expr2.junction.Kind := jnEmpty;
          expr2.op := '<=';

          match := reg.Match(sobj.AddFields[i].ValueHigh);
          if match.Success then
            expr2.Value := match.Groups[1].Value
          else
            expr2.Value := sobj.AddFields[i].ValueHigh;

          if (expr2.Fieldtype in [zfld07_FliessKomma, zfld08_Waehrung]) and (Pos(',', expr2.Value) > 0) then
            expr2.Value := ReplaceStr(expr2.Value, ',', '.');

          expr2.Update;
          lstSQLWhere.AddObject(expr2.Display, expr2);
        end;
      end else if expr.Fieldtype in [zfld00_Universal, zfld02_Auswahl, zfld03_MehrfachAuswahl, zfld11_DLM, zfld14_GridColumn] then
      begin
        expr.op := '=';
        if (sobj.AddFields[i].Value = '""') then
        begin
          expr.Value := 'NULL';
          expr.op := 'is';
        end
        else if ( sobj.AddFields[i].Value = 'NULL') then
        begin
          expr.op := 'is';
          expr.Value := sobj.AddFields[i].Value;
        end
        else begin
          expr.op := 'like';
          add_value := sobj.AddFields[i].Value;
          if (sobj.AddFields[i].Mode in [1,3]) and (LeftStr(add_value,1) <> '%') then
            add_value := '%' + add_value;
          if (sobj.AddFields[i].Mode in [2,3]) and (RightStr(add_value,1) <> '%') then
            add_value := add_value + '%';

          expr.Value := '"' + add_value + '"';
        end;
        expr.Update;
        lstSQLWhere.AddObject(expr.Display, expr);
      end else
      begin
        expr.Value := '"' + sobj.AddFields[i].Value + '"';
        expr.Update;
        lstSQLWhere.AddObject(expr.Display, expr);
      end;

      if (expr.junction.Kind = jnNOT) and (expr.Value <> 'NULL') then
      begin
        junc := TbfaJunction.Create;
        junc.Kind := jnOR;
        lstSQLWhere.AddObject(junc.display, junc);
        expr2 := TbfaExpression.Create;
        expr2.Clone(expr);
        expr2.op := 'is';
        expr2.Value := 'NULL';
        expr2.junction.Kind := jnEmpty;
        expr2.Update;
        lstSQLWhere.AddObject(expr2.Display, expr2);
      end;
      if (expr.junction.Kind = jnNOT) and (expr.Value <> 'NULL') then
      begin
        bracket := TbfaBracket.Create;
        bracket.Kind := brClose;
        lstSQLWhere.AddObject(')', bracket);
      end;
    end;
  end;

  if sobj.StsFields.Count > 0 then
  begin
    if sobj.AddFields.Count > 0 then  // wenn wir addfields hatten dann ein AND dazwischen
    begin
      junc := TbfaJunction.Create;
      junc.Kind := jnAND;
      lstSQLWhere.AddObject(junc.display, junc);
    end;

    for i := 0 to sobj.StsFields.Count -1 do
    begin
      if i > 0 then
      begin
        junc := TbfaJunction.Create;
        junc.Kind := jnAND;
        lstSQLWhere.AddObject(DupeString(' ', Indent) +junc.display, junc);
      end;

      expr := TbfaExpression.Create;
      if sobj.StsFields[i].Negate then
        expr.junction.Kind := jnNOT;
      expr.field := IntToStr(sobj.StsFields[i].ID);
      expr.Fieldname := sobj.StsFields[i].DisplayName;
      expr.ID := sobj.StsFields[i].ID;
      if sobj.StsFields[i].DisplayName = '' then
      begin
        statefield := bitfarmApp.GetStatefieldByID(sobj.StsFields[i].ID);
        if statefield <> nil then
          expr.Fieldname := statefield.DisplayName;
      end else
        expr.Fieldname := sobj.StsFields[i].DisplayName;

      expr.op := '=';
      if sobj.StsFields[i].Value then
      begin
        expr.Value := 'gesetzt';
        expr.Status := True;
      end
      else begin
        expr.Value := 'nicht gesetzt';
        expr.Status := False;
      end;
      expr.Fieldtype := zfld09_Status;
      expr.Update;
      lstSQLWhere.AddObject(expr.Display, expr);
    end;
  end;

  if (sobj.Addfields.Count > 0)  or (sobj.StsFields.Count > 0) then
  begin
    bracket := TbfaBracket.Create;
    bracket.Kind := brClose;
    lstSQLWhere.AddObject(DupeString(' ', Indent) +')', bracket);
  end;

  if not VarIsNull(sobj.SQLWhere) and (sobj.SQLWhere <> '') then
  begin
    sqlwhere := sobj.SQLWhere;
    sql := TStringList.Create;
    sql.Add(sqlwhere);
    sql := ParseSQLWhere(sql);
    sql := DeleteBraces(sql);
    eol := False;

    if sql.Count > 0 then
    begin
      for k := 0 to sql.Count -1 do
      begin
        if sql[k] = '('  then
        begin
          bracket := TbfaBracket.Create;
          bracket.Kind := brOpen;
          lstSQLWhere.AddObject('(', bracket);
          Continue;
        end;
        if sql[k] = ')' then
        begin
          bracket := TbfaBracket.Create;
          bracket.Kind := brClose;
          lstSQLWhere.AddObject(')', bracket);
          Continue;
        end;
        if LowerCase(sql[k]) = 'and'  then
        begin
          junc := TbfaJunction.Create;
          junc.Kind := jnAND;
          lstSQLWhere.AddObject(junc.display, junc);
          Continue;
        end;
        if LowerCase(sql[k]) = 'or' then
        begin
          junc := TbfaJunction.Create;
          junc.Kind := jnOR;
          lstSQLWhere.AddObject(junc.display, junc);
          Continue;
        end;

        found := False;
        for i := 0 to regs.Count -1 do
        begin
          reg := TRegEx.Create(regs[i],[roIgnoreCase,roMultiline]);
          match := reg.Match(sql[k]);

          if match.Success then
          begin
            expr := TbfaExpression.Create;

            if match.Groups[1].Value <> '' then
              expr.junction.Kind := jnNOT;
            if (LeftStr(match.Groups[2].Value,4) = 'add_') or           // ich frage lieber explicit ab, anstatt einfach mit Pos('add_' ...
                (LeftStr(match.Groups[2].Value,8) = 'day(add_') or
                (LeftStr(match.Groups[2].Value,9) = 'week(add_') or
                (LeftStr(match.Groups[2].Value,10) = 'month(add_') or
                (LeftStr(match.Groups[2].Value,9) = 'year(add_') or
                (LeftStr(match.Groups[2].Value,9) = 'date(add_')
            then
            begin
              if (LeftStr(match.Groups[2].Value,8) = 'day(add_') then
              begin
                expr.Field := MidStr(match.Groups[2].Value, 5, Length(match.Groups[2].Value) -5);
                expr.DateFormat := dtfDay;
              end else if (LeftStr(match.Groups[2].Value,9) = 'week(add_') then
              begin
                expr.Field := MidStr(match.Groups[2].Value, 6, Length(match.Groups[2].Value) -6);
                expr.DateFormat := dtfWeek;
              end else if (LeftStr(match.Groups[2].Value,10) = 'month(add_') then
              begin
                expr.Field := MidStr(match.Groups[2].Value, 7, Length(match.Groups[2].Value) -7);
                expr.DateFormat := dtfMonth;
              end else if (LeftStr(match.Groups[2].Value,9) = 'year(add_') then
              begin
                expr.Field := MidStr(match.Groups[2].Value, 6, Length(match.Groups[2].Value) -6);
                expr.DateFormat := dtfYear;
              end else if (LeftStr(match.Groups[2].Value,9) = 'date(add_') then
              begin
                expr.Field := MidStr(match.Groups[2].Value, 6, Length(match.Groups[2].Value) -6);
                expr.DateFormat := dtfDate;
              end
              else begin
                expr.Field := match.Groups[2].Value;
                expr.DateFormat :=dtfNone;
              end;

              for j := 0 to High(aAddfields) do
              begin
                if aAddfields[j] = nil then
                  Continue;
                if aAddfields[j].Name = expr.Field then
                begin
                  expr.Fieldname := aAddfields[j].DisplayName;
                  expr.IndexID := aAddfields[j].IndexTableID;
                  expr.Fieldtype := eAddfieldType(aAddfields[j].Typ);
                  expr.ID := aAddfields[j].ID;
                  Break;
                end;
              end;

              // Sonderbehandlung von-bis Felder
              if expr.Fieldtype in [zfld01_Datum, zfld06_GanzZahl, zfld07_FliessKomma, zfld08_Waehrung, zfld12_DLMDate] then
              begin
                expr.op := match.Groups[3].Value;

                reg2 := TRegEx.Create('^str_to_date.+(\d{2}.\d{2}.\d{4}|\d{4}.\d{2}.\d{2})');
                match2 := reg2.Match(match.Groups[4].Value);

                if match2.Success then
                begin
                  expr.Value := match2.Groups[1].Value;
                end else
                  expr.Value := match.Groups[4].Value;

              end else begin
                expr.op := match.Groups[3].Value;
                expr.Value := match.Groups[4].Value;
              end;
            end
            else if match.Groups[2].Value = 'docstate_' then
            begin
              expr.IndexID := StrToInt(match.Groups[3].Value);

              for j := 0 to High(aStatefields) do
              begin
                if aStatefields[j] = nil then
                  Continue;
                if (aStatefields[j].IndexColumnID = expr.IndexID) and
                    (aStatefields[j].Bitmask = StrToInt64(match.Groups[4].Value)) then
                begin
                  expr.Fieldname := aStatefields[j].DisplayName;
                  expr.ID := aStatefields[j].ID;
                  Break;
                end;
              end;
              if expr.Fieldname = '' then    // Fallback fr gelschtes/nicht gefundenes Statefield
                 Continue;

              expr.op := match.Groups[5].Value;
              expr.FieldType := zfld09_Status;
              if match.Groups[6].Value = '0' then
              begin
                expr.Status := False;
                expr.Value := _('nicht gesetzt');
              end else begin
                expr.Status := True;
                expr.Value := _('gesetzt');
              end;

            end else
            begin
              expr.Field := match.Groups[2].Value;

              for j := 0 to High(aAddfields) do
              begin
                if aAddfields[j] = nil then
                  Continue;
                if aAddfields[j].DisplayName = expr.Field then
                begin
                  expr.Field := aAddfields[j].Name;
                  expr.IndexID := aAddfields[j].IndexTableID;
                  expr.Fieldtype := eAddfieldType(aAddfields[j].Typ);
                  expr.ID := aAddfields[j].ID;
                  Break;
                end;
              end;

              if expr.Field = 'su.username' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Benutzer');
                expr.ID := 1;
              end;

              if expr.Field = 'docname' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Titel');
                expr.ID := 2;
              end;

              if expr.Field = 'docdate' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Datum');
                expr.ID := 3;
                expr.DateFormat := dtfNone;
              end;

              if expr.Field = 'day(docdate)' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Datum');
                expr.ID := 3;
                expr.DateFormat := dtfDay;
              end;

              if expr.Field = 'week(docdate)' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Datum');
                expr.ID := 3;
                expr.DateFormat := dtfWeek;
              end;

              if expr.Field = 'month(docdate)' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Datum');
                expr.ID := 3;
                expr.DateFormat := dtfMonth;
              end;

              if expr.Field = 'year(docdate)' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Datum');
                expr.ID := 3;
                expr.DateFormat := dtfYear;
              end;

              if expr.Field = 'date(docdate)' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Datum');
                expr.ID := 3;
                expr.DateFormat := dtfDate;
              end;

              if expr.Field = 'sd.modified' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Bearbeitet');
                expr.ID := 4;
                expr.DateFormat := dtfNone;
              end;

              if expr.Field = 'day(sd.modified)' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Bearbeitet');
                expr.ID := 4;
                expr.DateFormat := dtfDay;
              end;

              if expr.Field = 'week(sd.modified)' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Bearbeitet');
                expr.ID := 4;
                expr.DateFormat := dtfWeek;
              end;

              if expr.Field = 'month(sd.modified)' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Bearbeitet');
                expr.ID := 4;
                expr.DateFormat := dtfMonth;
              end;

              if expr.Field = 'year(sd.modified)' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Bearbeitet');
                expr.ID := 4;
                expr.DateFormat := dtfYear;
              end;

              if expr.Field = 'date(sd.modified)' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Bearbeitet');
                expr.ID := 4;
                expr.DateFormat := dtfDate;
              end;

              if expr.Field = 'expired' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Lschdatum');
                expr.ID := 17;
                expr.DateFormat := dtfNone;
              end;

              if expr.Field = 'day(expired)' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Lschdatum');
                expr.ID := 17;
                expr.DateFormat := dtfDay;
              end;

              if expr.Field = 'week(expired)' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Lschdatum');
                expr.ID := 17;
                expr.DateFormat := dtfWeek;
              end;

              if expr.Field = 'month(expired)' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Lschdatum');
                expr.ID := 17;
                expr.DateFormat := dtfMonth;
              end;

              if expr.Field = 'year(expired)' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Lschdatum');
                expr.ID := 17;
                expr.DateFormat := dtfYear;
              end;

              if expr.Field = 'date(expired)' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Lschdatum');
                expr.ID := 17;
                expr.DateFormat := dtfDate;
              end;

              if expr.Field = 'sd.gdocid' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Gdocid');
                expr.ID := 5;
              end;

              if expr.Field = 'doctxt' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Volltext');
                expr.ID := 6;
              end;

              if expr.Field = 'doctags' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Schlagwort');
                expr.ID := 7;
              end;

              if expr.Field = 'docloc' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Dokumentpfad');
                expr.ID := 8;
              end;

              if expr.Field = 'oriloc' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Originalpfad');
                expr.ID := 9;
              end;

              if expr.Field = 'checkout' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Ausgecheckt');
                expr.ID := 10;
              end;

              if expr.Field = 'annotxt' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Annotation');
                expr.ID := 15;
              end;

              if expr.Field = 'fieldtxt' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Zusatzfelder');
                expr.ID := 18;
              end;

              if expr.Field = 'refname' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Verknpfung');
                expr.ID := 19;
              end;

              if expr.Field = 'filetype' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('Typ');
                expr.ID := 20;
              end;

              if expr.Field = 'sd.userid' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('BenutzerID');
                expr.ID := 21;
              end;

              if expr.Field = 'sg.groupid' then
              begin
                expr.Fieldtype := zfld10_Document;
                expr.Fieldname := _('GruppenID');
                expr.ID := 22;
              end;


              if match.Groups[3].Value = 'AGAINST' then
                expr.op := 'match'
              else
                expr.op := match.Groups[3].Value;
              expr.Value := match.Groups[4].Value;

              reg2 := TRegEx.Create('str_to_date.+?(\d{2}.\d{2}.\d{4}|\d{4}.\d{2}.\d{2})');
              matches := reg2.Matches(expr.Value);

              for match2 in matches do
              begin
                if match2.Success then
                begin
                  replstr := 'str_to_date("' + match2.Groups[1].Value + '","%d.%m.%Y")';
                  exprstr := expr.Value;
                  expr.Value := StringReplace(expr.Value, replstr, match2.Groups[1].Value, [rfReplaceAll]);
                end;
              end;
            end;
            expr.Update;

            if Trim(expr.Display) = '' then
              lstSQLWhere.AddObject(match.Value, expr)
            else
              lstSQLWhere.AddObject(expr.Display, expr);
            found := True;
            Break;
          end;
        end;
      end;
    end;
  end else      // wenn wir kein sqlwhere hatten, dann kommen wir wahrscheinlich direkt ber eine suche hierhin
  begin
    if not VarIsNull(sobj.SearchString) and (sobj.SearchString <> '') then
    begin
      if lstSQLWhere.Count > 0 then
      begin
        junc := TbfaJunction.Create;
        junc.Kind := jnAND;
        lstSQLWhere.AddObject(junc.display, junc);
      end;

      searchstring := StrToWords4(sobj.SearchString);

      for j := 0 to searchstring.Count -1 do   // falls mehrere Wrter im Suchausdruck sind -> iterieren
      begin
        bracket := TbfaBracket.Create;
        bracket.Kind := brOpen;
        lstSQLWhere.AddObject('(', bracket);

        ftxfields := sobj.FtxFields;

        i := 0;
        while ftxfields <> 0 do                // laufe ber die konfigurierten Suchspalten (doctxt, doctags, fieldtxt, annotxt)
        begin
          expr := TbfaExpression.Create;
          expr.Fieldtype := zfld10_Document;
          if sobj.FtxMatchAgainst then
            expr.op := 'match'
          else
            expr.op := 'like';
          if sobj.SearchStringNegated then
            expr.junction.Kind := jnNOT
          else
            expr.junction.Kind := jnEmpty;

          if (searchstring[j] = '""') then
          begin
            expr.op := 'is';
            expr.Value := 'NULL';
          end else begin
            if LeftStr(searchstring[j], 1) = '-' then
            begin
              tempstr := RightStr(searchstring[j], length(searchstring[j]) -1);
              if sobj.FtxMatchAgainst then
                    expr.Value := '"' + bitfarmApp.ParseMatchAgainstString(tempstr) + '"'
              else begin
                    expr.Value := '"%' + tempstr + '%"';
              end;
              expr.junction.Kind := jnNOT;
            end else if LeftStr(searchstring[j], 1) = '/' then
            begin
              tempstr := RightStr(searchstring[j], length(searchstring[j]) -1);
              if sobj.FtxMatchAgainst then
                expr.Value := '"' + bitfarmApp.ParseMatchAgainstString(tempstr) + '"'
              else begin
                expr.Value := '"%' + tempstr + '%"';
              end;
            end else
            begin
              if sobj.FtxMatchAgainst then
                expr.Value := '"' + bitfarmApp.ParseMatchAgainstString(searchstring[j]) + '"'
              else begin
                expr.Value := '"%' + searchstring[j] + '%"';
              end;
            end;
          end;

          if i > 0 then
          begin
            if expr.junction.Kind = jnNot then   // haben wir einen NOT Suchausdruck werden diese mit OR doctxt IS NULL ergnzt
            begin                                // und die einzelnen Suchspalten (doctxt, doctags, fieldtxt, annotxt) VERUNDET statt verodert
              junc := TbfaJunction.Create;
              junc.Kind := jnAND;
              lstSQLWhere.AddObject(junc.display, junc);
            end else
            begin
              junc := TbfaJunction.Create;
              junc.Kind := jnOR;
              lstSQLWhere.AddObject(junc.display, junc);
            end;
          end;

          inc(i);

          if (ftxfields and 1) = 1 then
          begin
            if expr.junction.Kind = jnNot then   // haben wir einen NOT Suchausdruck werden diese mit OR doctxt IS NULL ergnzt
            begin                                // dann mssen wir aber den gesamten Ausdruck Klammern
              bracket := TbfaBracket.Create;
              bracket.Kind := brOpen;
              lstSQLWhere.AddObject('(', bracket);
            end;

            expr.Fieldname := _('Volltext');
            expr.Field := 'doctxt';
            expr.ID := 6;
            ftxfields := ftxfields and not 1;
            expr.Update;
            lstSQLWhere.AddObject(expr.Display, expr);

            if expr.junction.Kind = jnNOT then
            begin
              junc := TbfaJunction.Create;
              junc.Kind := jnOR;
              lstSQLWhere.AddObject(junc.display, junc);
              expr := TbfaExpression.Create;
              expr.Fieldtype := zfld10_Document;
              expr.Fieldname := _('Volltext');
              expr.Field := 'doctxt';
              expr.ID := 6;
              expr.op := 'is';
              expr.Value := 'NULL';
              expr.Update;
              lstSQLWhere.AddObject(expr.Display, expr);
              bracket := TbfaBracket.Create;
              bracket.Kind := brClose;
              lstSQLWhere.AddObject(')', bracket);
            end;

            Continue;
          end;

          if (ftxfields and 2) = 2 then
          begin
            if expr.junction.Kind = jnNot then   // haben wir einen NOT Suchausdruck werden diese mit OR doctxt IS NULL ergnzt
            begin                                // dann mssen wir aber den gesamten Ausdruck Klammern
              bracket := TbfaBracket.Create;
              bracket.Kind := brOpen;
              lstSQLWhere.AddObject('(', bracket);
            end;

            expr.Fieldname := _('Schlagwort');
            expr.Field := 'doctags';
            expr.ID := 7;
            ftxfields := ftxfields and not 2;
            expr.Update;
            lstSQLWhere.AddObject(expr.Display, expr);

            if expr.junction.Kind = jnNOT then
            begin
              junc := TbfaJunction.Create;
              junc.Kind := jnOR;
              lstSQLWhere.AddObject(junc.display, junc);
              expr := TbfaExpression.Create;
              expr.Fieldtype := zfld10_Document;
              expr.Fieldname := _('Schlagwort');
              expr.Field := 'doctags';
              expr.ID := 7;
              expr.op := 'is';
              expr.Value := 'NULL';
              expr.Update;
              lstSQLWhere.AddObject(expr.Display, expr);
              bracket := TbfaBracket.Create;
              bracket.Kind := brClose;
              lstSQLWhere.AddObject(')', bracket);
            end;

            Continue;
          end;

          if (ftxfields and 4) = 4 then
          begin
              if expr.junction.Kind = jnNot then   // haben wir einen NOT Suchausdruck werden diese mit OR doctxt IS NULL ergnzt
              begin                                // dann mssen wir aber den gesamten Ausdruck Klammern
                bracket := TbfaBracket.Create;
                bracket.Kind := brOpen;
                lstSQLWhere.AddObject('(', bracket);
              end;
            expr.Fieldname := _('Zusatzfelder');
            expr.Field := 'fieldtxt';
            expr.ID := 18;
            ftxfields := ftxfields and not 4;
            expr.Update;
            lstSQLWhere.AddObject(expr.Display, expr);

            if expr.junction.Kind = jnNOT then
            begin
              junc := TbfaJunction.Create;
              junc.Kind := jnOR;
              lstSQLWhere.AddObject(junc.display, junc);
              expr := TbfaExpression.Create;
              expr.Fieldtype := zfld10_Document;
              expr.Fieldname := _('Zusatzfelder');
              expr.Field := 'fieldtxt';
              expr.ID := 18;
              expr.op := 'is';
              expr.Value := 'NULL';
              expr.Update;
              lstSQLWhere.AddObject(expr.Display, expr);
              bracket := TbfaBracket.Create;
              bracket.Kind := brClose;
              lstSQLWhere.AddObject(')', bracket);
            end;

            Continue;
          end;

          if (ftxfields and 8) = 8 then
          begin
              if expr.junction.Kind = jnNot then   // haben wir einen NOT Suchausdruck werden diese mit OR doctxt IS NULL ergnzt
              begin                                // dann mssen wir aber den gesamten Ausdruck Klammern
                bracket := TbfaBracket.Create;
                bracket.Kind := brOpen;
                lstSQLWhere.AddObject('(', bracket);
              end;
            expr.Fieldname := _('Annotation');
            expr.Field := 'annotxt';
            expr.ID := 15;
            ftxfields := ftxfields and not 8;
            expr.Update;
            lstSQLWhere.AddObject(expr.Display, expr);

            if expr.junction.Kind = jnNOT then
            begin
              junc := TbfaJunction.Create;
              junc.Kind := jnOR;
              lstSQLWhere.AddObject(junc.display, junc);
              expr := TbfaExpression.Create;
              expr.Fieldtype := zfld10_Document;
              expr.Fieldname := _('Annotation');
              expr.Field := 'annotxt';
              expr.ID := 15;
              expr.op := 'is';
              expr.Value := 'NULL';
              expr.Update;
              lstSQLWhere.AddObject(expr.Display, expr);
              bracket := TbfaBracket.Create;
              bracket.Kind := brClose;
              lstSQLWhere.AddObject(')', bracket);
            end;

            Continue;
          end;
        end;

        bracket := TbfaBracket.Create;
        bracket.Kind := brClose;
        lstSQLWhere.AddObject(')', bracket);

        if (searchstring.Count > 1) and (j < searchstring.Count -1) then    // wir haben mehrere Searchstrings
        begin                                                               // sind aber nicht beim letzten angelangt
          if LeftStr(searchstring[j+1], 1) = '/' then      // soll der nchste Suchbegriff verodert werden?
          begin
            junc := TbfaJunction.Create;
            junc.Kind := jnOR;
            lstSQLWhere.AddObject(junc.display, junc);
          end else
          begin
            junc := TbfaJunction.Create;
            junc.Kind := jnAND;
            lstSQLWhere.AddObject(junc.display, junc);
          end;
        end;
      end;
    end;

    if (not VarIsNull(sobj.SearchDate)) or (not VarIsNull(sobj.SearchDateHigh)) then
    begin
      if lstSQLWhere.Count > 0 then
      begin
        junc := TbfaJunction.Create;
        junc.Kind := jnAND;
        lstSQLWhere.AddObject(junc.display, junc);
      end;

      expr := TbfaExpression.Create;
      expr.Fieldtype := zfld10_Document;
      if (sobj.SearchDateType and 8) = 8 then
      begin
        expr.Fieldname := _('Bearbeitet');
        expr.Field := 'sd.modified';
        expr.ID := 4;
      end else if (sobj.SearchDateType and 1024) = 1024 then begin
        expr.Fieldname := _('Lschdatum');
        expr.Field := 'expired';
        expr.ID := 17;
      end else begin
        expr.Fieldname := _('Datum');
        expr.Field := 'docdate';
        expr.ID := 3;
      end;

      expr.op := '>=';
      if sobj.SearchDateNegated then
        expr.junction.Kind := jnNOT
      else
        expr.junction.Kind := jnEmpty;

      if (not IsEmptyVariant(sobj.SearchDate)) then
      begin
        sobj.SearchDate := VarToDateTime(sobj.SearchDate);
        value := sobj.SearchDate;
        reg := TRegEx.Create('^(\d{2}.\d{2}.\d{4}|\d{4}.\d{2}.\d{2})');
        match := reg.Match(value);

        if match.Success then
        begin
          datestr := match.Groups[1].Value;

          dateformat := CheckDateFormat(datestr, sysDateFormat);
          expr.Value := value;
        end else
          expr.Value := '"' + VarToWideStr(sobj.SearchDate) + '"';
      end;

      if (not IsEmptyVariant(sobj.SearchDateHigh)) then
      begin
        sobj.SearchDateHigh := IncDay(VarToDateTime(sobj.SearchDateHigh), 1);
        value := sobj.SearchDateHigh;
        reg := TRegEx.Create('^(\d{2}.\d{2}.\d{4}|\d{4}.\d{2}.\d{2})');
        match := reg.Match(value);

        if match.Success then
        begin
          datestr := match.Groups[1].Value;

          dateformat := CheckDateFormat(datestr, sysDateFormat);
          //if (not VarIsNull(sobj.SearchDate))  and (sobj.SearchDate <> '') then
          if (not IsEmptyVariant(sobj.SearchDate)) then
          begin
            expr.Value := expr.Value + ' and ' + value;
            expr.op := 'between';
          end else begin
            expr.Value := value;
            expr.op := '<';
          end;
        end;
      end;

      expr.Update;
      lstSQLWhere.AddObject(expr.Display, expr);
    end;

    if not VarIsNull(sobj.RefSearch) then
    begin
      if lstSQLWhere.Count > 0 then
      begin
        junc := TbfaJunction.Create;
        junc.Kind := jnAND;
        lstSQLWhere.AddObject(junc.display, junc);
      end;

      expr := TbfaExpression.Create;
      expr.Fieldtype := zfld10_Document;
      expr.ID := 19;
      expr.Fieldname := _('Verknpfung');
      expr.Field := 'refname';

      if (sobj.RefSearch = '""') then
      begin
        expr.op := 'is';
        expr.Value := 'NULL'
      end else begin
        expr.op := '=';
        expr.Value := '"' + sobj.RefSearch + '"';
      end;

      if sobj.RefSearchNegated then
        expr.junction.Kind := jnNOT
      else
        expr.junction.Kind := jnEmpty;

      expr.Update;
      lstSQLWhere.AddObject(expr.Display, expr);
    end;

    if not VarIsNull(sobj.DocName) then
    begin
      if lstSQLWhere.Count > 0 then
      begin
        junc := TbfaJunction.Create;
        junc.Kind := jnAND;
        lstSQLWhere.AddObject(junc.display, junc);
      end;

      expr := TbfaExpression.Create;
      expr.Fieldtype := zfld10_Document;
      expr.ID := 2;
      expr.Fieldname := _('Titel');
      expr.Field := 'docname';

      if (sobj.DocName = '""') then
      begin
        expr.op := 'is';
        expr.Value := 'NULL'
      end else begin
        expr.op := 'like';
        expr.Value := '"%' + sobj.DocName + '%"';
      end;

      if sobj.DocNameNegated then
        expr.junction.Kind := jnNOT
      else
        expr.junction.Kind := jnEmpty;

      expr.Update;
      lstSQLWhere.AddObject(expr.Display, expr);
    end;

    if not VarIsNull(sobj.FileType) then
    begin
      if lstSQLWhere.Count > 0 then
      begin
        junc := TbfaJunction.Create;
        junc.Kind := jnAND;
        lstSQLWhere.AddObject(junc.display, junc);
      end;

      expr := TbfaExpression.Create;
      expr.Fieldtype := zfld10_Document;
      expr.ID := 20;
      expr.Fieldname := _('Typ');
      expr.Field := 'filetype';

      if (sobj.FileType = '""') then
      begin
        expr.op := 'is';
        expr.Value := 'NULL'
      end else begin
        expr.op := 'like';
        expr.Value := '"%' + sobj.FileType + '%"';
      end;

      if sobj.FileTypeNegated then
        expr.junction.Kind := jnNOT
      else
        expr.junction.Kind := jnEmpty;

      expr.Update;
      lstSQLWhere.AddObject(expr.Display, expr);
    end;

    if not VarIsNull(sobj.SearchUserID) and (sobj.SearchUserID <> -1) then
    begin
      if lstSQLWhere.Count > 0 then
      begin
        junc := TbfaJunction.Create;
        junc.Kind := jnAND;
        lstSQLWhere.AddObject(junc.display, junc);
      end;

      expr := TbfaExpression.Create;
      expr.Fieldtype := zfld10_Document;
      expr.ID := 21;
      expr.Fieldname := _('BenutzerID');
      expr.Field := 'sd.userid';

      if (sobj.SearchUserID = 0) then
      begin
        expr.op := 'is';
        expr.Value := 'NULL'
      end else begin
        expr.op := '=';
        expr.Value := IntToStr(sobj.SearchUserID);
      end;

      if sobj.SearchUserNegated then
        expr.junction.Kind := jnNOT
      else
        expr.junction.Kind := jnEmpty;

      expr.Update;
      lstSQLWhere.AddObject(expr.Display, expr);
    end;

    if not VarIsNull(sobj.SearchGroupID) and (sobj.SearchGroupID <> -1) then
    begin
      if lstSQLWhere.Count > 0 then
      begin
        junc := TbfaJunction.Create;
        junc.Kind := jnAND;
        lstSQLWhere.AddObject(junc.display, junc);
      end;

      expr := TbfaExpression.Create;
      expr.Fieldtype := zfld10_Document;
      expr.ID := 22;
      expr.Fieldname := _('GruppenID');
      expr.Field := 'sg.groupid';

      if (sobj.SearchGroupID = 0) then
      begin
        expr.op := 'is';
        expr.Value := 'NULL'
      end else begin
        expr.op := '=';
        expr.Value := INtToStr(sobj.SearchGroupID);
      end;

      if sobj.SearchGroupNegated then
        expr.junction.Kind := jnNOT
      else
        expr.junction.Kind := jnEmpty;

      expr.Update;
      lstSQLWhere.AddObject(expr.Display, expr);
    end;

    if sobj.GDocID.Count > 0 then
    begin
      if lstSQLWhere.Count > 0 then
      begin
        junc := TbfaJunction.Create;
        junc.Kind := jnAND;
        lstSQLWhere.AddObject(junc.display, junc);
      end;

      expr := TbfaExpression.Create;
      expr.Fieldtype := zfld10_Document;
      expr.ID := 5;
      expr.Fieldname := _('Gdocid');
      expr.Field := 'sd.gdocid';

      if (sobj.GDocID[0] = '""') then
      begin
        expr.op := 'is';
        expr.Value := 'NULL'
      end else begin
        expr.op := 'in';
        expr.Value := '(' + sobj.GDocID.CommaText + ')';
      end;

      expr.Update;
      lstSQLWhere.AddObject(expr.Display, expr);
    end;
  end;

end;

function TbfaApplication.ParseSQLWhere(sql: TStringList): TStringList;
var
  i, ind, j : Integer;
  part, word : widestring;
  braces, between : Integer;
  opened : Boolean;
begin
  Result := TstringList.Create;

  for i  := 0 to sql.Count -1 do
  begin
    braces := 0;
    between := 0;
    part := sql[i];
    word := '';
    ind := 1;
    opened := False;

    if part = '(' then
    begin
      Result.Add('(');
      Continue;
    end;

    if part = ')' then
    begin
      Result.Add(')');
      Continue;
    end;

    if part = 'and' then
    begin
      Result.Add('and');
      Continue;
    end;

    if part = 'or' then
    begin
      Result.Add('or');
      Continue;
    end;

    while  ind <= Length(part) do begin

      if (MidStr(part, ind, 9) = ' between ')  and (braces = 0) then
        inc(between);

      if (MidStr(part, ind, 5) = ' and ')  and (braces = 0) then
      begin
        if between = 0 then
        begin
          if word <> '' then
            Result.Add(word);

          Result.Add('and');
          word := '';
          ind := ind + 4;
          Continue;
        end else
          dec(between);
      end;

      if (MidStr(part, ind, 4) = ' or ')  and (braces = 0) then
      begin
        if word <> '' then
          Result.Add(Trim(word));

        Result.Add('or');
        word := '';
        ind := ind + 3;
        Continue;
      end;

      if (part[ind] = '(') and (braces = 0) and (Trim(word) = '') then
      begin
        opened := True;
        Result.Add('(');
        Inc(ind);
        Inc(braces);
        Continue;
      end;

      if (part[ind] = ')') and (braces = 1) and opened then
      begin
        if word <> '' then
          Result.Add(Trim(word));
        word := '';
        Result.Add(')');
        Inc(ind);
        Dec(braces);
        opened := False;
        Continue;
      end;

      if (part[ind] = '(') then
        Inc(braces);

      if (part[ind] = ')') then
        Dec(braces);

      word := word + part[ind];

      Inc(ind);
    end;

    if Trim(word) <> '' then
      Result.Add(Trim(word));
  end;

  if Result.Count <> sql.Count then
    Result := ParseSQLWhere(Result);

end;

procedure TbfaApplication.SaveNewDocName(AThread: TThread; Objects: TList; Params: TStringList; prev: TbfaPreview);
var
  Save: Boolean;
begin
  bitfarmLog.DebugBegin(llDebug, 'SaveNewDocName', ClassName);
  try
    try
      Save := (Params[0] = '1');
      bfaCommonImageEN.SaveNewDocName(AThread, TbfaDocument(Objects[0]), Save, prev);
    except
      bitfarmLog.Write(llNormal, ltException, 'SetNewDocName', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SaveNewDocName', ClassName);
  end;
end;

function TbfaApplication.GetArcids(lgrid: Int64; userid: Int64 = -1): TStringList;
var
  i, ii: Integer;
  tempids: TStringList;
begin
  Result := TStringList.Create;

  for i := 0 to Length(aSysArc) - 1 do
  begin
    if aSysArc[i].arcid = 0 then
      continue;
    if aSysArc[i].lgrid = lgrid then
    begin
      if aSysArc[i].Typ = 0 then  //Lager
      begin
        tempids := GetArcids(aSysArc[i].arcid);
        for ii := 0 to tempids.Count - 1 do
          Result.Add(tempids[ii]);
        FreeAndNil(tempids);
      end;
      if aSysArc[i].Typ = 1 then //Archiv
      begin
        if userid = -1 then
          Result.Add(IntToStr(aSysArc[i].arcid))
        else if aSysArc[i].Rights > 0 then
          Result.Add(IntToStr(aSysArc[i].arcid));
      end;
    end;
  end;
end;

procedure TbfaApplication.FillScanProfiles2(Combo: TSpTBXComboBox; SelectDefault: Boolean = False);
var
  i: Integer;
  str: WideString;
begin
  bitfarmLog.DebugBegin(llDebug, 'FillScanProfiles', ClassName);
  try
    try
      Combo.Items.Clear;
      for i := 0 to FScannerProfiles.Container.Count - 1 do
      begin
        if FScannerProfiles.Container[i].GlobalProfile then
          str := FScannerProfiles.Container[i].ProfileName + ' - ' + _('Globales-Profil')
        else
          str := FScannerProfiles.Container[i].ProfileName + ' - ' + _('Benutzer-Profil');
        Combo.Items.AddObject(str, FScannerProfiles.Container[i]);
        if FScannerProfiles.Container[i].DefaultProfile then
          FScannerProfiles.DefaultScanner := i;
      end;

      if (SelectDefault and (FScannerProfiles.DefaultScanner <> -1)) then
        Combo.ItemIndex := FScannerProfiles.DefaultScanner;
    except
      bitfarmLog.Write(llNormal, ltException, 'FillScanProfiles', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'FillScanProfiles', ClassName);
  end;
end;

procedure TbfaApplication.FillScanProfiles(Combo: TcxImageComboBox; SelectDefault: Boolean = False);
var
  i: Integer;
  str: WideString;
  Itm: TcxImageComboBoxItem;
begin
  bitfarmLog.DebugBegin(llDebug, 'FillScanProfiles', ClassName);
  try
    try
      Combo.Properties.Items.Clear;
      for i := 0 to FScannerProfiles.Container.Count - 1 do
      begin
        if FScannerProfiles.Container[i].GlobalProfile then
          str := FScannerProfiles.Container[i].ProfileName + ' - ' + _('Globales-Profil')
        else
          str := FScannerProfiles.Container[i].ProfileName + ' - ' + _('Benutzer-Profil');

        Itm := Combo.Properties.Items.Add;
        Itm.Description := FScannerProfiles.Container[i].ProfileName;
        Itm.Value := i;
//        Itm.DisplayName := 'TestDisplayName1';
        if FScannerProfiles.Container[i].GlobalProfile then
          Itm.ImageIndex := Integer(icoidx_scan_profile_global)
        else
          Itm.ImageIndex := Integer(icoidx_scan_profile_local);

        if FScannerProfiles.Container[i].DefaultProfile then
          FScannerProfiles.DefaultScanner := i;
      end;

      if (SelectDefault and (FScannerProfiles.DefaultScanner <> -1)) then
        Combo.ItemIndex := FScannerProfiles.DefaultScanner;
    except
      bitfarmLog.Write(llNormal, ltException, 'FillScanProfiles', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'FillScanProfiles', ClassName);
  end;
end;

procedure TbfaApplication.RefreshScanCombos(SelectDefault: Boolean = False);
begin
  bitfarmLog.DebugBegin(llDebug, 'RefreshScanCombos', ClassName);
  try
    try
      FillScanProfiles(frmMainForm.fraScanFunctions.cbxScanProfile, SelectDefault);
      FillScanProfiles(FPreviewContainer.ImporterItem.Preview.bfaTlbImporter.cbxScanProfile, SelectDefault);
    except
      bitfarmLog.Write(llNormal, ltException, 'RefreshScanCombos', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'RefreshScanCombos', ClassName);
  end;
end;

{//-----------------------------------------------------------------------------
Name: ShowSelectedMainPreview
Parameters: Idx -> Preview Index (Viewer, Importer, Workplace)
Beschreibung: Setzt die statische MainPreview nach Index (Idx)
  Ausgelagerte Funktion wegen AThread.Synchronize
  Wird nur vom SetMainPreview aufgerufen
  Alle Tabs und Panels wird versteckt, nur die angegebene statische MainPreview
  wird angezeigt
//-----------------------------------------------------------------------------}
procedure TbfaApplication.ShowSelectedMainPreview(Idx: Integer; AThread: TThread = nil);

  procedure SetToolbarEnabled(TBar: TSpTBXToolbar; DoEnabled: Boolean);
  var
    j: Integer;
  begin
    for j := 0 to TBar.Items.Count - 1 do
      TBar.Items[j].Enabled := DoEnabled;
  end;

var
  i: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'ShowSelectedMainPreview', ClassName);
  try
    try
      if Idx = pvtViewer then // Viewer
      begin
        frmMainForm.pnlSearchOptions.Caption := sCaptionActViewSearchOptions;
        frmMainForm.pnlQuickSearch.Visible := True;
        if FPreviewContainer.WorkplaceItem.Tab.Visible then
        begin
          FPreviewContainer.WorkplaceItem.Panel.Hide;
          FPreviewContainer.WorkplaceItem.Tab.Visible := False;
        end;
        if FPreviewContainer.ImporterItem.Tab.Visible then
        begin
          FPreviewContainer.ImporterItem.Panel.Hide;
          FPreviewContainer.ImporterItem.Tab.Visible := False;
        end;
        if Assigned(frmMainForm.fraAdmin) and frmMainForm.fraAdmin.Visible then
        begin
          frmMainForm.fraAdmin.Visible := False;
          frmMainForm.fraAdminScrollBox.Visible := False;
        end;

        if Assigned(frmMainForm.grbxSqlWhere) then
          frmMainForm.grbxSqlWhere.Visible := FUser.isAdmin;
        if Assigned(frmMainForm.mmoSqlWhere) then
          frmMainForm.mmoSqlWhere.Visible := FUser.isAdmin;
        FPreviewContainer.ViewerItem.Panel.Show;
        FPreviewContainer.ViewerItem.Tab.Visible := True;
        fSkipTabChangeEvent := True;
        try
          frmMainForm.tstDocumentEditors.Toolbar.BeginUpdate; //03.07.2019
          frmMainForm.tstDocumentEditors.ActiveTabIndex := Idx;
          frmMainForm.tstDocumentEditors.Toolbar.EndUpdate; //03.07.2019
        finally
          fSkipTabChangeEvent := False;
        end;
      end
      else if Idx = pvtImporter then // Importer
      begin
        frmMainForm.pnlSearchOptions.Caption := _('Informationen zum Dokument');
        frmMainForm.pnlQuickSearch.Visible := False;

        if FPreviewContainer.WorkplaceItem.Tab.Visible then
        begin
          FPreviewContainer.WorkplaceItem.Panel.Hide;
          FPreviewContainer.WorkplaceItem.Tab.Visible := False;
        end;
        if FPreviewContainer.ViewerItem.Tab.Visible then
        begin
          FPreviewContainer.ViewerItem.Panel.Hide;
          FPreviewContainer.ViewerItem.Tab.Visible := False;
        end;
        if Assigned(frmMainForm.fraAdmin) and (frmMainForm.fraAdmin.Visible) then
        begin
          frmMainForm.fraAdmin.Visible := False;
          frmMainForm.fraAdminScrollBox.Visible := False;
        end;
        if Assigned(frmMainForm.grbxSqlWhere) then
          frmMainForm.grbxSqlWhere.Visible := False;
        if Assigned(frmMainForm.mmoSqlWhere) then
          frmMainForm.mmoSqlWhere.Visible := False;

        FPreviewContainer.ImporterItem.Panel.Show;
        FPreviewContainer.ImporterItem.Tab.Visible := True;
        if not frmMainForm.pnlImporter.Maximized then
          frmMainForm.pnlImporter.Maximize;
        fSkipTabChangeEvent := True;
        try
          frmMainForm.tstDocumentEditors.Toolbar.BeginUpdate; //03.07.2019
          frmMainForm.tstDocumentEditors.ActiveTabIndex := Idx;
          frmMainForm.tstDocumentEditors.Toolbar.EndUpdate; //03.07.2019
        finally
          fSkipTabChangeEvent := False;
        end;
      end
      else if Idx = pvtWorkplace then // Workplace
      begin
        if FPreviewContainer.ViewerItem.Tab.Visible then
        begin
          FPreviewContainer.ViewerItem.Panel.Hide;
          FPreviewContainer.ViewerItem.Tab.Visible := False;
        end;
        if FPreviewContainer.ImporterItem.Tab.Visible then
        begin
          FPreviewContainer.ImporterItem.Panel.Hide;
          FPreviewContainer.ImporterItem.Tab.Visible := False;
        end;
        if Assigned(frmMainForm.fraAdmin) and frmMainForm.fraAdmin.Visible then
        begin
          frmMainForm.fraAdmin.Visible := False;
          frmMainForm.fraAdminScrollBox.Visible := False;
        end;

        FPreviewContainer.WorkplaceItem.Panel.Show;
        FPreviewContainer.WorkplaceItem.Tab.Visible := True;
        fSkipTabChangeEvent := True;
        try
          frmMainForm.tstDocumentEditors.Toolbar.BeginUpdate; //03.07.2019
          frmMainForm.tstDocumentEditors.ActiveTabIndex := Idx;
          frmMainForm.tstDocumentEditors.Toolbar.EndUpdate; //03.07.2019
        finally
          fSkipTabChangeEvent := False;
        end;
      end
      else if Idx = pvtAdmin then // Administrator
      begin
        if FPreviewContainer.ViewerItem.Tab.Visible then
        begin
          FPreviewContainer.ViewerItem.Panel.Hide;
          FPreviewContainer.ViewerItem.Tab.Visible := False;
        end;
        if FPreviewContainer.ImporterItem.Tab.Visible then
        begin
          FPreviewContainer.ImporterItem.Panel.Hide;
          FPreviewContainer.ImporterItem.Tab.Visible := False;
        end;
        if FPreviewContainer.WorkplaceItem.Tab.Visible then
        begin
          FPreviewContainer.WorkplaceItem.Panel.Hide;
          FPreviewContainer.WorkplaceItem.Tab.Visible := False;
        end;

        {$IFDEF ENTERPRISE}
        if TfrmEnterprise(frmMainForm).fraAdmin <> nil then
        begin
          TfrmEnterprise(frmMainForm).fraAdminScrollBox.Visible := True;
          TfrmEnterprise(frmMainForm).fraAdmin.Visible := True;
        end;
        {$ELSE}
        if frmMainForm.fraAdmin <> nil then
        begin
          frmMainForm.fraAdminScrollBox.Visible := True;
          frmMainForm.fraAdmin.Visible := True;
        end;
        {$ENDIF}
      end;

      if Idx = pvtImporter then
      begin
        if (frmMainForm.pnlSearchOptions.Visible = False) and (not bitfarmApp.PreviewContainer.PageSortingsItem.Panel.Showing) then
          frmMainForm.pnlSearchOptions.Visible := True;
        frmMainForm.pnlSearch.Visible := False;
        frmMainForm.grdResultlistDevEx.Visible := False;
        frmMainForm.fraScanFunctions.Visible := True;
        frmMainForm.pnlSearchTimer.Visible := False;
        //frmMainForm.pnlLoadDoc.Visible := False;
        frmMainForm.edtSearchText.Width := frmMainForm.pnlQuickSearch.Width - 28;
        frmMainForm.FImporterTreeview.TabOrder := 1;
      end
      else if Idx = pvtWorkplace then
      begin
        frmMainForm.pnlSearch.Visible := False;
        frmMainForm.grdResultlistDevEx.Visible := False;
        frmMainForm.fraScanFunctions.Visible := False;
        frmMainForm.pnlSearchOptions.Visible := False;
      end
      else if Idx = pvtAdmin then
      begin
        frmMainForm.pnlSearch.Visible := False;
        frmMainForm.grdResultlistDevEx.Visible := False;
        frmMainForm.fraScanFunctions.Visible := False;
        frmMainForm.pnlSearchOptions.Visible := False;

        if frmMainForm.FAdminTreeview <> nil then
          frmMainForm.FAdminTreeview.TabOrder := 1;
      end
      else
      begin
        if frmMainForm.pnlSearchOptions.Visible = False then
          frmMainForm.pnlSearchOptions.Visible := True;
        frmMainForm.pnlSearch.Visible := True;
        frmMainForm.grdResultlistDevEx.Visible := True;
        frmMainForm.fraScanFunctions.Visible := False;

        if Idx = pvtViewer then
        begin
          frmMainForm.edtSearchText.Width := frmMainForm.pnlLoadDoc.Left - 20;
          frmMainForm.pnlSearchTimer.Visible := True;
          //frmMainForm.pnlLoadDoc.Visible := True;
          frmMainForm.FViewerTreeview.TabOrder := 1;

        end
        else
        begin
          frmMainForm.pnlSearchTimer.Visible := False;
          //frmMainForm.pnlLoadDoc.Visible := False;
          frmMainForm.edtSearchText.Width := frmMainForm.pnlQuickSearch.Width - 28;
        end;
      end;

      if Idx = pvtFavorites then
        frmMainForm.trvBookmarks.TabOrder := 1;

      if Idx = pvtResub then
        frmMainForm.fraResub.cbbUserGroups.TabOrder := 1;
      frmMainForm.tstDocumentEditors.Visible := (Idx <> pvtAdmin);

      frmMainForm.tabDocLinks.TabVisible := FViewerOptions.GeneralOptions.ShowDocLinksInTab and (Idx <> pvtImporter);

      if frmMainForm.tabDocLinks.TabVisible then
        ShowDocLinkList;

      SetToolbarEnabled(frmMainForm.tlbDocState, (Idx <> pvtAdmin));
      SetToolbarEnabled(frmMainForm.tlbStatefields, (Idx <> pvtAdmin));
      SetToolbarEnabled(frmMainForm.tlbGraphic, (Idx <> pvtAdmin));
      SetToolbarEnabled(frmMainForm.tlbTools, (Idx <> pvtAdmin));
      SetToolbarEnabled(frmMainForm.tlbPlugins, (Idx <> pvtAdmin));
      SetToolbarEnabled(frmMainForm.bfaTlbStandard1, (Idx <> pvtAdmin));
      SetToolbarEnabled(frmMainForm.bfaTlbPreview1, (Idx <> pvtAdmin));
      SetToolbarEnabled(frmMainForm.tlbQueueCount, (Idx <> pvtAdmin));

      if Idx = pvtImporter then
      begin
        if frmMainForm.fraDocLinks <> nil then
        begin
          if frmMainForm.fraDocLinks.Visible then
            frmMainForm.fraDocLinks.Visible := False;
          if frmMainForm.splStandard.Visible then
            frmMainForm.splStandard.Visible := False;
          if frmMainForm.pnlDocLink.Visible then
            frmMainForm.pnlDocLink.Visible := False;
        end;
        if frmMainForm.tcSearch.ActiveTabIndex = 2 then
        begin
          frmMainForm.tcSearch.Toolbar.BeginUpdate;
          try
            frmMainForm.tcSearch.ActiveTabIndex := 0;
          finally
            frmMainForm.tcSearch.Toolbar.EndUpdate;
          end;
        end;
      end;

      for i := 0 to FPreviewContainer.Containers.Count - 1 do
      begin
        if (FPreviewContainer.Containers[i].Panel.Tag <> Idx) and (FPreviewContainer.Containers[i].Panel.Visible) and (not FPreviewContainer.Containers[i].Preview.Floating) then
        begin
          if (Idx <> pvtImporter) or ((Idx = pvtImporter) and (FPreviewContainer.PageSortingsItem.Panel.Showing) and (FPreviewContainer.Containers[i].Panel <> FPreviewContainer.PageSortingsItem.Panel)) then
            FPreviewContainer.Containers[i].Panel.Hide;
        end;
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'ShowSelectedMainPreview', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ShowSelectedMainPreview', ClassName);
  end;
end;

procedure TbfaApplication.ShowToolbars(show: Boolean);
begin
  try
    if (not show and not ClosingMainForm) or
       (show and (not frmMainForm.fAppStarted) and
       (CurrentView = tvkAdministrator)) then
    begin
      tlbGraphicVisible := frmMainForm.tlbGraphic.Visible;
      tlbToolsVisible := frmMainForm.tlbTools.Visible;
      tlbDocStateVisible := frmMainForm.tlbDocState.Visible;
//      tlbDocStateVisible := frmMainForm.tlbStatefields.Visible;
      tlbStatefieldsVisible := frmMainForm.tlbStatefields.Visible;
      tlbPluginsVisible := frmMainForm.tlbPlugins.Visible;
      bfaTlbStandard1Visible := frmMainForm.bfaTlbStandard1.Visible;
      bfaTlbPreview1Visible := frmMainForm.bfaTlbPreview1.Visible;
      tlbResubFavsVisible := frmMainForm.tlbResubFavs.Visible;
      tlbQueueCountVisible := frmMainForm.tlbQueueCount.Visible;
    end;

    if (CurrentView <> tvkAdministrator)  then
    begin
      if ( not(frmMainForm.tlbGraphic.Visible) and not(frmMainForm.tlbTools.Visible) and
           not(frmMainForm.bfaTlbStandard1.Visible) and not(frmMainForm.bfaTlbPreview1.Visible) and
           not(frmMainForm.tlbPlugins.Visible) and not(frmMainForm.tlbStatefields.Visible)
         ) then
      begin
        frmMainForm.tlbGraphic.Visible := tlbGraphicVisible;
        frmMainForm.tlbTools.Visible := tlbToolsVisible;
//        frmMainForm.tlbStatefields.Visible := tlbDocStateVisible;// wird danach eh neu gesetzt???
        frmMainForm.tlbStatefields.Visible := tlbStatefieldsVisible;
        frmMainForm.tlbPlugins.Visible := tlbPluginsVisible;
        frmMainForm.bfaTlbStandard1.Visible := bfaTlbStandard1Visible;
        frmMainForm.bfaTlbPreview1.Visible := bfaTlbPreview1Visible;
        frmMainForm.tlbResubFavs.Visible := tlbResubFavsVisible;
        frmMainForm.tlbQueueCount.Visible := tlbQueueCountVisible;
      end;

      frmMainForm.tlbMainMenu.Visible := (CurrentView <> tvkAdministrator) or
        (not FViewerOptions.AdminOptions.AdminFullscreen);
      frmMainForm.tlbGraphic.Visible := show and frmMainForm.tlbGraphic.Visible and
        ((CurrentView <> tvkAdministrator) or ClosingMainForm);
      frmMainForm.tlbTools.Visible := show and frmMainForm.tlbTools.Visible and
        ((CurrentView <> tvkAdministrator) or ClosingMainForm);
      frmMainForm.tlbDocState.Visible := show and ((CurrentView <> tvkAdministrator) or ClosingMainForm);
      frmMainForm.tlbStatefields.Visible := show and (frmMainForm.tlbStatefields.Items.Count > 0) and
        ((CurrentView <> tvkAdministrator) or ClosingMainForm);
      frmMainForm.tlbPlugins.Visible := show and (tlbPluginsVisible or frmMainForm.tlbPlugins.Visible) and
        ((CurrentView <> tvkAdministrator) or ClosingMainForm);
      frmMainForm.bfaTlbStandard1.Visible := show and  frmMainForm.bfaTlbStandard1.Visible and
        ((CurrentView <> tvkAdministrator) or ClosingMainForm);
      frmMainForm.bfaTlbPreview1.Visible := show and frmMainForm.bfaTlbPreview1.Visible and
        ((CurrentView <> tvkAdministrator) or ClosingMainForm);
      frmMainForm.tlbResubFavs.Visible := show and frmMainForm.tlbResubFavs.Visible and
        (frmMainForm.tlbResubFavs.Items.Count > 0) and
        ((CurrentView <> tvkAdministrator) or ClosingMainForm);
      frmMainForm.tlbQueueCount.Visible := show and (frmMainForm.tlbQueueCount.Visible) and
        ((CurrentView <> tvkAdministrator) or ClosingMainForm);
    end
    else
    begin
      //08.08.2017 Ticket 11383
      frmMainForm.tlbMainMenu.Visible := (CurrentView <> tvkAdministrator) or
        (not FViewerOptions.AdminOptions.AdminFullscreen);

      frmMainForm.tlbGraphic.Visible := show and tlbGraphicVisible and
        ((CurrentView <> tvkAdministrator) or ClosingMainForm);

      frmMainForm.tlbTools.Visible := show and tlbToolsVisible and
        ((CurrentView <> tvkAdministrator) or ClosingMainForm);

      frmMainForm.tlbDocState.Visible := show and ((CurrentView <> tvkAdministrator) or ClosingMainForm);

      frmMainForm.tlbStatefields.Visible := show and (frmMainForm.tlbStatefields.Items.Count > 0) and
        ((CurrentView <> tvkAdministrator) or ClosingMainForm);

      frmMainForm.tlbPlugins.Visible := show and (tlbPluginsVisible or frmMainForm.tlbPlugins.Visible) and
        ((CurrentView <> tvkAdministrator) or ClosingMainForm);

      frmMainForm.bfaTlbStandard1.Visible := show and bfaTlbStandard1Visible and
        ((CurrentView <> tvkAdministrator) or ClosingMainForm);

      frmMainForm.bfaTlbPreview1.Visible := show and bfaTlbPreview1Visible and
        ((CurrentView <> tvkAdministrator) or ClosingMainForm);

      frmMainForm.tlbResubFavs.Visible := show and (tlbResubFavsVisible or frmMainForm.tlbResubFavs.Visible) and
        ((CurrentView <> tvkAdministrator) or ClosingMainForm) and
        (frmMainForm.tlbResubFavs.Items.Count > 0);

      frmMainForm.tlbQueueCount.Visible := show and (tlbQueueCountVisible or frmMainForm.tlbQueueCount.Visible) and
          ((CurrentView <> tvkAdministrator) or ClosingMainForm);
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'ShowToolbars', ClassName);
  end;
end;

procedure TbfaApplication.Scan(Dlg, InNewDoc: Boolean; AThread: TThread);
var
  img2: TbfaImageEnMView;
  scnResult, CreateNewDoc: Boolean;
  idx: Integer;
  TmpStream: TMemoryStream;
  PDoc: TbfaDocument;
  prev: TbfaPreview;
  DocList: TList<Integer>;

  function CreateStapel(IsDuplex: Boolean = False): TList<Integer>;
  var
    Doc: TbfaDocument;
    idx: Integer;
  begin
    try
      bitfarmApp.Log.Write(llDebug, ltInfo, 'CreateStapel', ClassName);
      var i := 0;
      Result := nil;
      if FScanpool.ImageCount > 0 then
        Result := TList<Integer>.Create;

      while (i <= FScanpool.ImageCount - 1) do
      begin
//29.08.2023 -->
//        AThread.Synchronize(nil,
//          procedure
//          begin
//            Doc := CreatePDocument;
//          end);
        {$IFDEF IMAGEEN_SYNCHRONIZED}
        AThread.Synchronize(nil,
          procedure
          begin
            Doc := CreatePDocument;
          end);
        {$ELSE}
        Doc := CreatePDocument;
        {$ENDIF}
//29.08.2023 <--
        idx := prev.List.Add(Doc);
        if idx <> -1 then
          Result.Add(idx);

        Doc.DocStream.Position := 0;
        Doc.DocType := dtScannedPage;
        Doc.FileType := '.tif';
        Doc.HasPreview := True;

        TmpStream.Position := 0;
        img2.AppendImage(TmpStream, i);

        // SJ 02.12.2021 - bfacrm:ticket__show__29291
        if IsDuplex and (i+1 <= FScanpool.ImageCount - 1) then
        begin
          inc(i);
          TmpStream.Position := 0;
          img2.AppendImage(TmpStream, i);
          bitfarmApp.Log.Write(llDebug, ltDebug, 'CreateStapel - IsDuplex', ClassName);
        end;
        // SJ 02.12.2021 - bfacrm:ticket__show__29291

        Doc.DocStream.Position := 0;
        img2.MIO.SaveToStreamTIFF(Doc.DocStream, False);

        RefreshImporterMultiView(AThread, True);

        inc(i);
        img2.Clear;
      end;
    except
      Result := nil;
      bitfarmLog.Write(llNormal, ltException, 'CreateStapel', ClassName);
    end;
  end;

begin
  bitfarmApp.Log.WriteBegin(llDebug, ltInfo, 'Scan', ClassName);
  Screen.Cursor := crHourGlass;
  try
    try
      PDoc := nil;
      prev := FPreviewContainer.ImporterItem.Preview;
      DocList := nil;
      if ((prev.List <> nil) and (frmMainForm.fraScanFunctions.cbxScanProfile.ItemIndex <> -1)) then
      begin
        try
          AThread.Synchronize(nil,
            procedure
            begin
              frmMainForm.itmInfo.Caption := _('Starte Scannen...');
            end);

          TmpStream := TMemorystream.Create;
          TmpStream.Clear;

          if (FScanPool = nil) then
            bitfarmapp.Log.Write(llDebug, ltInfo, '(FScanPool = nil)')
          else
            bitfarmapp.Log.Write(llDebug, ltInfo, '(FScanPool <> nil)');

          if (FScanPool = nil) then
          begin
//29.08.2023 -->
//            AThread.Synchronize(nil,
//              procedure
//              begin
//                FScanpool := CreateInvisibleScanPoolMView(nil); //14.11.2018 Ticket 16706 bfaCommonImageEN.CreateInvisibleMView(nil);
//              end);
            {$IFDEF IMAGEEN_SYNCHRONIZED}
            AThread.Synchronize(nil,
              procedure
              begin
                FScanpool := CreateInvisibleScanPoolMView(nil); //14.11.2018 Ticket 16706 bfaCommonImageEN.CreateInvisibleMView(nil);
              end);
            {$ELSE}
            FScanpool := CreateInvisibleScanPoolMView(nil); //14.11.2018 Ticket 16706 bfaCommonImageEN.CreateInvisibleMView(nil);
            {$ENDIF}
//29.08.2023 <--
            bitfarmapp.Log.Write(llDebug, ltInfo, 'FScanpool := bfaCommonImageEN.CreateInvisibleMView(nil);');
          end;

          img2 := nil;

          idx := frmMainForm.fraScanFunctions.cbxScanProfile.ItemIndex;

          {$IFDEF ImageEN1140}
          if BD.DevDebug then
            FScanpool.MIO.AcquireParams.AttachedTwainParams.LogFile := bitfarmLog.LogDir + '\ViewerV36' + '_' + FormatDateTime('YYYY-MM-DD', Now) + '_TWainParams.' + sSysLOG;
          {$ELSE}
          if BD.DevDebug then
            FScanpool.MIO.TwainParams.LogFile := bitfarmLog.LogDir + '\ViewerV36' + '_' + FormatDateTime('YYYY-MM-DD', Now) + '_TWainParams.' + sSysLOG;
          {$ENDIF}

          try
            with FScannerProfiles.Container[idx] do
            begin
              bitfarmapp.Log.Write(llDebug, ltInfo, 'FScannerProfiles.Container[idx].ProfileName:' + ProfileName);
              bitfarmapp.Log.Write(llDebug, ltInfo, 'FScannerProfiles.Container[idx].ScannerName:' + ScannerName);
              bitfarmapp.Log.Write(llDebug, ltInfo, 'FScannerProfiles.Container[idx].ColorMode:' + IntToStr(ColorMode));
              bitfarmapp.Log.Write(llDebug, ltInfo, 'FScannerProfiles.Container[idx].DPI:' + IntToStr(DPI));
              bitfarmapp.Log.Write(llDebug, ltInfo, 'FScannerProfiles.Container[idx].Format:' + IntToStr(Format));
              bitfarmapp.Log.Write(llDebug, ltInfo, 'FScannerProfiles.Container[idx].Orientation:' + IntToStr(Orientation));
              if ADF then
                bitfarmapp.Log.Write(llDebug, ltInfo, 'FScannerProfiles.Container[idx].ADF = True')
              else
                bitfarmapp.Log.Write(llDebug, ltInfo, 'FScannerProfiles.Container[idx].ADF = False');
              if Duplex then
                bitfarmapp.Log.Write(llDebug, ltInfo, 'FScannerProfiles.Container[idx].Duplex = True')
              else
                bitfarmapp.Log.Write(llDebug, ltInfo, 'FScannerProfiles.Container[idx].Duplex = False');

              bitfarmapp.Log.Write(llDebug, ltInfo, 'FScannerProfiles.Container[idx].Filter:' + IntToStr(Filter));
              bitfarmapp.Log.Write(llDebug, ltInfo, 'FScannerProfiles.Container[idx].Brightness:' + FloatToStr(Brightness));
              bitfarmapp.Log.Write(llDebug, ltInfo, 'FScannerProfiles.Container[idx].Contrast:' + FloatToStr(Contrast));
              bitfarmapp.Log.Write(llDebug, ltInfo, 'FScannerProfiles.Container[idx].Threshold:' + FloatToStr(Threshold));
              if CompatibleMode then
                bitfarmapp.Log.Write(llDebug, ltInfo, 'FScannerProfiles.Container[idx].CompatibleMode = True')
              else
                bitfarmapp.Log.Write(llDebug, ltInfo, 'FScannerProfiles.Container[idx].CompatibleMode = False');

              {$IFDEF ImageEn1140}
              if FScanpool.MIO.AcquireParams.SelectedSourceApi = ieaTwain then
              begin
                bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams BufferedTransfer = ' + BoolToStr(FScanpool.MIO.AcquireParams.AttachedTwainParams.BufferedTransfer, True));
                bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams UseMemoryHandle = ' + BoolToStr(FScanpool.MIO.AcquireParams.AttachedTwainParams.UseMemoryHandle, True));
                bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams FileTransfer = ' + BoolToStr(FScanpool.MIO.AcquireParams.AttachedTwainParams.FileTransfer, True));
                bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams CompatibilityMode = ' + BoolToStr(FScanpool.MIO.AcquireParams.AttachedTwainParams.CompatibilityMode, True));
              end;
              {$ENDIF}
            end;
          except

          end;

          {$IFDEF ImageEn1140}
          InitScan(Dlg, FScanpool, frmMainForm.fraScanFunctions.cbxScanProfile, AThread);

          FScanpool.MIO.AcquireParams.VisibleDialog := Dlg;
          FScanpool.MIO.AcquireParams.AttachedTwainParams.ProgressIndicators := Dlg;

          FScanpool.MIO.AcquireParams.AttachedTwainParams.LastError := 0;
          FScanpool.MIO.AcquireParams.AttachedTwainParams.LastErrorStr := '';

          try
            bitfarmapp.Log.Write(llDebug, ltInfo, 'Params PROFILE:' + frmMainForm.fraScanFunctions.cbxScanProfile.Text);
            if FScanpool.MIO.AcquireParams.SelectedSourceApi = ieaTwain then
            begin
              bitfarmapp.Log.Write(llDebug, ltInfo, 'AcquireParams.SelectedSourceApi: Twain');
              bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams LastError:' + IntToStr(FScanpool.MIO.AcquireParams.AttachedTwainParams.LastError));
              bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams XResolution:' + FloatToStr(FScanpool.MIO.AcquireParams.AttachedTwainParams.XResolution.CurrentValue));
            end else if FScanpool.MIO.AcquireParams.SelectedSourceApi = ieaWIA then
              bitfarmapp.Log.Write(llDebug, ltInfo, 'AcquireParams.SelectedSourceApi: WIA');


            case FScanpool.MIO.AcquireParams.PixelType of
              ieapMonochrome:
                bitfarmapp.Log.Write(llDebug, ltInfo, 'AcquireParams PixelType: ieapMonochrome');
              ieap8BitGrayScale:
                bitfarmapp.Log.Write(llDebug, ltInfo, 'AcquireParams PixelType: ieap8BitGrayScale');
              ieap16BitGrayScale:
                bitfarmapp.Log.Write(llDebug, ltInfo, 'AcquireParams PixelType: ieap16BitGrayScale');
              ieapFullColor:
                bitfarmapp.Log.Write(llDebug, ltInfo, 'AcquireParams PixelType: ieapFullColor');
              ieapFullColor16:
                bitfarmapp.Log.Write(llDebug, ltInfo, 'AcquireParams PixelType: ieapFullColor16');
              ieapOther:
                bitfarmapp.Log.Write(llDebug, ltInfo, 'AcquireParams PixelType: ieapOther');
            else
              bitfarmapp.Log.Write(llDebug, ltInfo, 'AcquireParams PixelType: unknown');
            end;

            bitfarmapp.Log.Write(llDebug, ltInfo, 'AcquireParams BitDepth:' + FloatToStr(FScanpool.MIO.AcquireParams.BitDepth));

            case FScanpool.MIO.AcquireParams.Orientation of
              ieaoPortrait:
                bitfarmapp.Log.Write(llDebug, ltInfo, 'AcquireParams Orientation: ieaoPortrait');
              ieaoLandscape:
                bitfarmapp.Log.Write(llDebug, ltInfo, 'AcquireParams Orientation: ieaoLandscape');
              ieaoRotate90:
                bitfarmapp.Log.Write(llDebug, ltInfo, 'AcquireParams Orientation: ieaoRotate90');
              ieaoRotate180:
                bitfarmapp.Log.Write(llDebug, ltInfo, 'AcquireParams Orientation: ieaoRotate180');
            else
              bitfarmapp.Log.Write(llDebug, ltInfo, 'AcquireParams Orientation: unknown');
            end;

            bitfarmapp.Log.Write(llDebug, ltInfo, 'AcquireParams Brightnes:' + FloatToStr(FScanpool.MIO.AcquireParams.Brightness));
            bitfarmapp.Log.Write(llDebug, ltInfo, 'AcquireParams Contrast:' + FloatToStr(FScanpool.MIO.AcquireParams.Contrast));
            bitfarmapp.Log.Write(llDebug, ltInfo, 'AcquireParams Threshold:' + FloatToStr(FScanpool.MIO.AcquireParams.Threshold));
            bitfarmapp.Log.Write(llDebug, ltInfo, 'AcquireParams AutoFeed = ' + BoolToStr(FScanpool.MIO.AcquireParams.AutoFeed, True));
            bitfarmapp.Log.Write(llDebug, ltInfo, 'AcquireParams DuplexEnabled = ' + BoolToStr(FScanpool.MIO.AcquireParams.DuplexEnabled, True));

            if FScanpool.MIO.AcquireParams.SelectedSourceApi = ieaTwain then
            begin
              bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams BufferedTransfer = ' + BoolToStr(FScanpool.MIO.AcquireParams.AttachedTwainParams.BufferedTransfer, True));
              bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams UseMemoryHandle = ' + BoolToStr(FScanpool.MIO.AcquireParams.AttachedTwainParams.UseMemoryHandle, True));
              bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams FileTransfer = ' + BoolToStr(FScanpool.MIO.AcquireParams.AttachedTwainParams.FileTransfer, True));
              bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams CompatibilityMode = ' + BoolToStr(FScanpool.MIO.AcquireParams.AttachedTwainParams.CompatibilityMode, True));
            end;
          except

          end;

          bitfarmApp.Log.Write(llDebug, ltInfo, 'Acquire', ClassName);

          scnResult := FScanpool.MIO.Acquire;

          bitfarmApp.Log.Write(llDebug, ltInfo, 'FScanpool.MIO.AcquireParams.AttachedTwainParams.LastError: ' + IntToStr(FScanpool.MIO.AcquireParams.AttachedTwainParams.LastError), ClassName);

          if (FScanpool.MIO.SelectedAcquireSource.Api = ieaTwain) and (FScanpool.MIO.AcquireParams.AttachedTwainParams.LastError <> 0) then
          begin
            Log.Write(llNormal, ltError, _('Fehler beim Scannen! Fehlercode:') + IntToStr(FScanpool.MIO.AcquireParams.AttachedTwainParams.LastError), ClassName);
            Log.Write(llNormal, ltError, _('Fehler beim Scannen! FehlerStr:') + FScanpool.MIO.AcquireParams.AttachedTwainParams.LastErrorStr, ClassName);

            // bei einem Fehler lschen wir die letzte Seite
            if not FScannerProfiles.Container[idx].IgnoreTWAINError then
            begin
              bitfarmApp.Log.Write(llDebug, ltInfo, 'not FScannerProfiles.Container[idx].IgnoreTWAINError (idx=' + IntToStr(idx) + ')', ClassName);

              if not(FScanpool.MIO.AcquireParams.AttachedTwainParams.LastError in [1,4,5,6]) then
              begin
                bitfarmApp.Log.Write(llDebug, ltInfo, 'FScanpool.ImageCount =' + IntToStr(FScanpool.ImageCount), ClassName);

                AThread.Synchronize(nil,
                  procedure
                  begin
                    if FScanpool.ImageCount > 0 then
                      FScanpool.DeleteImage(FScanpool.ImageCount - 1);

                    frmMainForm.itmInfo.Caption := (_('Fehler beim Scannen! TWAIN-Errorcode: ') + IntToStr(FScanpool.MIO.AcquireParams.AttachedTwainParams.LastError));
                  end);
              end;
            end;
          end
          else if (FScanpool.MIO.SelectedAcquireSource.Api <> ieaTwain) then
            bitfarmApp.Log.Write(llDebug, ltInfo, 'SelectedAcquireSource.Api <> ieaTwain', ClassName);

          {$ELSE}
          InitScan(Dlg, FScanpool.MIO.TWainParams, FScanpool, frmMainForm.fraScanFunctions.cbxScanProfile, AThread);

          FScanpool.MIO.TWainParams.VisibleDialog := Dlg;
          FScanpool.MIO.TWainParams.ProgressIndicators := Dlg;

          FScanpool.MIO.TWainParams.LastError := 0;
          FScanpool.MIO.TWainParams.LastErrorStr := '';

          try
            bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams PROFILE:' + frmMainForm.fraScanFunctions.cbxScanProfile.Text);
            bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams LastError:' + IntToStr(FScanpool.MIO.TWainParams.LastError));
            bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams XResolution:' + FloatToStr(FScanpool.MIO.TWainParams.XResolution.CurrentValue));
            bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams PixelType:' + FloatToStr(FScanpool.MIO.TWainParams.PixelType.CurrentValue));
            bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams BitDepth:' + FloatToStr(FScanpool.MIO.TWainParams.BitDepth.CurrentValue));
            bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams Orientation:' + FloatToStr(FScanpool.MIO.TWainParams.Orientation.CurrentValue));
            bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams Brightnes:' + FloatToStr(FScanpool.MIO.TWainParams.Brightness.CurrentValue));
            bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams Contrast:' + FloatToStr(FScanpool.MIO.TWainParams.Contrast.CurrentValue));
            bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams Threshold:' + FloatToStr(FScanpool.MIO.TWainParams.Threshold.CurrentValue));

            if FScanpool.MIO.TWainParams.AutoFeed then
              bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams AutoFeed = True')
            else
              bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams AutoFeed = False');
            if FScanpool.MIO.TWainParams.BufferedTransfer then
              bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams BufferedTransfer = True')
            else
              bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams BufferedTransfer = False');
            if FScanpool.MIO.TWainParams.UseMemoryHandle then
              bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams UseMemoryHandle = True')
            else
              bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams UseMemoryHandle = False');
            if FScanpool.MIO.TWainParams.FileTransfer then
              bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams FileTransfer = True')
            else
              bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams FileTransfer = False');
            if FScanpool.MIO.TWainParams.DuplexEnabled then
              bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams DuplexEnabled = True')
            else
              bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams DuplexEnabled = False');
            if FScanpool.MIO.TWainParams.CompatibilityMode then
              bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams CompatibilityMode = True')
            else
              bitfarmapp.Log.Write(llDebug, ltInfo, 'TWainParams CompatibilityMode = False');
          except

          end;

          bitfarmApp.Log.Write(llDebug, ltInfo, 'Acquire', ClassName);
//29.08.2023 -->
//          AThread.Synchronize(nil, //25.07.2023  wegen Ticket bfacrm:ticket__show__35831 mit Synchronize
//            procedure
//            begin
//              scnResult := FScanpool.MIO.Acquire(ieaTwain);
//            end);
          {$IFDEF IMAGEEN_SYNCHRONIZED}
          AThread.Synchronize(nil, //25.07.2023  wegen Ticket bfacrm:ticket__show__35831 mit Synchronize
            procedure
            begin
              scnResult := FScanpool.MIO.Acquire(ieaTwain);
            end);
          {$ELSE}
          scnResult := FScanpool.MIO.Acquire(ieaTwain);
          {$ENDIF}
//29.08.2023 <--

          bitfarmApp.Log.Write(llDebug, ltInfo, 'FScanpool.MIO.TWainParams.LastError: ' + IntToStr(FScanpool.MIO.TWainParams.LastError), ClassName);

          if FScanpool.MIO.TWainParams.LastError <> 0 then
          begin
            Log.Write(llNormal, ltError, _('Fehler beim Scannen! Fehlercode:') + IntToStr(FScanpool.MIO.TWainParams.LastError), ClassName);
            // bei einem Fehler lschen wir die letzte Seite
            if not FScannerProfiles.Container[idx].IgnoreTWAINError then
            begin
              bitfarmApp.Log.Write(llDebug, ltInfo, 'not FScannerProfiles.Container[idx].IgnoreTWAINError (idx=' + IntToStr(idx) + ')', ClassName);

              if (FScanpool.MIO.TWainParams.LastError <> 6) and (FScanpool.MIO.TWainParams.LastError <> 1) and (FScanpool.MIO.TWainParams.LastError <> 5) and (FScanpool.MIO.TWainParams.LastError <> 4) then
              begin

                bitfarmApp.Log.Write(llDebug, ltInfo, 'FScanpool.ImageCount =' + IntToStr(FScanpool.ImageCount), ClassName);

                AThread.Synchronize(nil,
                  procedure
                  begin
                    if FScanpool.ImageCount > 0 then
                      FScanpool.DeleteImage(FScanpool.ImageCount - 1);

                    frmMainForm.itmInfo.Caption := (_('Fehler beim Scannen! TWAIN-Errorcode: ') + IntToStr(FScanpool.MIO.TWainParams.LastError));
                  end);
              end;
            end;
          end;

          {$ENDIF}

          if scnResult then
          begin
            bitfarmApp.Log.Write(llDebug, ltInfo, 'scnResult = True', ClassName);

//29.08.2023 -->
//            AThread.Synchronize(nil, //25.07.2023
//              procedure
//              begin
//                {$IFDEF ImageEn1140}
//                AfterScan(Dlg, FScanpool, frmMainForm.fraScanFunctions.cbxScanProfile);
//                {$ELSE}
//                AfterScan(Dlg, FScanpool, FScanpool.MIO.TWainParams, frmMainForm.fraScanFunctions.cbxScanProfile);
//                {$ENDIF}
//              end);
            {$IFDEF IMAGEEN_SYNCHRONIZED}
            AThread.Synchronize(nil, //25.07.2023
              procedure
              begin
                {$IFDEF ImageEn1140}
                AfterScan(Dlg, FScanpool, frmMainForm.fraScanFunctions.cbxScanProfile);
                {$ELSE}
                AfterScan(Dlg, FScanpool, FScanpool.MIO.TWainParams, frmMainForm.fraScanFunctions.cbxScanProfile);
                {$ENDIF}
              end);
            {$ELSE}
              {$IFDEF ImageEn1140}
              AfterScan(Dlg, FScanpool, frmMainForm.fraScanFunctions.cbxScanProfile);
              {$ELSE}
              AfterScan(Dlg, FScanpool, FScanpool.MIO.TWainParams, frmMainForm.fraScanFunctions.cbxScanProfile);
              {$ENDIF}
            {$ENDIF}
//29.08.2023 <--

            CreateNewDoc := True;

            if CreateNewDoc then
              bitfarmApp.Log.Write(llDebug, ltInfo, 'CreateNewDoc = True', ClassName);

            if (CreateNewDoc) and (not ((frmMainForm.fraScanFunctions.chkStackScan.Checked))) then
            begin
              bitfarmApp.Log.Write(llDebug, ltInfo, 'CreateNewdoc = True AND NOT StackScan', ClassName);
//29.08.2023 -->
//              AThread.Synchronize(nil,
//                procedure
//                begin
//                  PDoc := CreatePDocument;
//                end);
              {$IFDEF IMAGEEN_SYNCHRONIZED}
              AThread.Synchronize(nil,
                procedure
                begin
                  PDoc := CreatePDocument;
                end);
              {$ELSE}
              PDoc := CreatePDocument;
              {$ENDIF}
//29.08.2023 <--
              prev.List.Add(PDoc);
              prev.ActiveDoc := PDoc;
              prev.ActiveDoc.DocStream.Position := 0;
              prev.ActiveDoc.DocType := dtScannedPage;
              prev.ActiveDoc.FileType := '.tif';
              prev.ActiveDoc.HasPreview := True;
              AThread.Synchronize(nil,
                procedure
                begin
                  bitfarmApp.SetCurrentDocs(prev.ActiveDoc, nil, prev);
                  bitfarmApp.ShowDocumentProperties(prev.ActiveDoc, prev);
                end);
            end;

            if (frmMainForm.fraScanFunctions.chkStackScan.Checked) or (not CreateNewDoc) then
            begin
//29.08.2023 -->
//              AThread.Synchronize(nil,
//                procedure
//                begin
//                  bitfarmApp.Log.Write(llDebug, ltInfo, 'CreateNewdoc = False AND Stackscan', ClassName);
//                  img2 := CreateInvisibleMView(nil);
//                  TmpStream.Position := 0;
//                  FScanpool.MIO.SaveToStreamTIFF(TmpStream, False);
//                  TmpStream.Position := 0;
//                end);
              {$IFDEF IMAGEEN_SYNCHRONIZED}
              AThread.Synchronize(nil,
                procedure
                begin
                  bitfarmApp.Log.Write(llDebug, ltInfo, 'CreateNewdoc = False AND Stackscan', ClassName);
                  img2 := CreateInvisibleMView(nil);
                  TmpStream.Position := 0;
                  FScanpool.MIO.SaveToStreamTIFF(TmpStream, False);
                  TmpStream.Position := 0;
                end);
              {$ELSE}
              bitfarmApp.Log.Write(llDebug, ltInfo, 'CreateNewdoc = False AND Stackscan', ClassName);
              img2 := CreateInvisibleMView(nil);
              TmpStream.Position := 0;
              FScanpool.MIO.SaveToStreamTIFF(TmpStream, False);
              TmpStream.Position := 0;
              {$ENDIF}
//29.08.2023 <--
            end;

            if (not frmMainForm.fraScanFunctions.chkStackScan.Checked) then
            begin
//29.08.2023 -->
//              AThread.Synchronize(nil,
//                procedure
//                begin
//                  bitfarmApp.Log.Write(llDebug, ltInfo, 'FScanpool.MIO.SaveToStreamTIFF', ClassName);
//                  prev.ActiveDoc.DocStream.Position := 0;
//                  FScanpool.MIO.SaveToStreamTIFF(prev.ActiveDoc.DocStream, False);
//                  bitfarmApp.Log.Write(llDebug, ltInfo, 'RefreshImporter', ClassName);
//                  RefreshImporterMultiView(AThread, True);
//                end);
              {$IFDEF IMAGEEN_SYNCHRONIZED}
              AThread.Synchronize(nil,
                procedure
                begin
                  bitfarmApp.Log.Write(llDebug, ltInfo, 'FScanpool.MIO.SaveToStreamTIFF', ClassName);
                  prev.ActiveDoc.DocStream.Position := 0;
                  FScanpool.MIO.SaveToStreamTIFF(prev.ActiveDoc.DocStream, False);
                  bitfarmApp.Log.Write(llDebug, ltInfo, 'RefreshImporter', ClassName);
                  RefreshImporterMultiView(AThread, True);
                end);
              {$ELSE}
              bitfarmApp.Log.Write(llDebug, ltInfo, 'FScanpool.MIO.SaveToStreamTIFF', ClassName);
              prev.ActiveDoc.DocStream.Position := 0;
              FScanpool.MIO.SaveToStreamTIFF(prev.ActiveDoc.DocStream, False);
              bitfarmApp.Log.Write(llDebug, ltInfo, 'RefreshImporter', ClassName);
              RefreshImporterMultiView(AThread, True);
              {$ENDIF}
//29.08.2023 <--
            end
            else
              DocList := CreateStapel(frmMainForm.fraScanFunctions.chkScanDuplex.Checked);

            AThread.Synchronize(nil,
              procedure
              begin
                frmMainForm.itmInfo.Caption := _('Scan OK.');

                if (DocList <> nil) and (DocList.Count > 0) then
                begin
                  try
                    try
                      var I: Integer;
                      prev.MultiView.LockPaint;
                      prev.MultiView.Deselect;
                      prev.MultiView.MultiSelecting := True;
                      for I := 0 to DocList.Count - 1 do
                        prev.MultiView.SelectedImage := DocList[I];
                    except
                      bitfarmLog.Write(llNormal, ltException, 'ScanOK - MultiSelection', ClassName);
                    end;
                  finally
                    prev.MultiView.MultiSelecting := False;
                    prev.MultiView.UnLockPaint;
                  end;
                end else
                  prev.MultiView.SelectedImage := prev.MultiView.ImageCount - 1;

                MViewImageSelect(prev.MultiView, prev, prev.MultiView.SelectedImage, -1, True, False, False, False, False, False, True);
                prev.MultiView.SetFocus;
              end);
          end
          else
          begin
            bitfarmApp.Log.Write(llDebug, ltInfo, 'scnResult = False', ClassName);
            AThread.Synchronize(nil,
              procedure
              begin
                {$IFDEF ImageEn1140}
                if (FScanpool.MIO.SelectedAcquireSource.Api = ieaTwain) then
                  frmMainForm.itmInfo.Caption := _('Scan abgebrochen. TWAIN-Errorcode: ') + IntToStr(FScanpool.MIO.TWainParams.LastError)
                else
                  frmMainForm.itmInfo.Caption := _('Scan abgebrochen.') + ' (WIA)';
                {$ELSE}
                frmMainForm.itmInfo.Caption := _('Scan abgebrochen. TWAIN-Errorcode: ') + IntToStr(FScanpool.MIO.TWainParams.LastError);
                {$ENDIF}
              end);
          end;
        finally
//29.08.2023 -->
//          if (not frmMainForm.fraScanFunctions.chkStackScan.Checked) and (PDoc <> nil) then
//          begin
//            bitfarmApp.Log.Write(llDebug, ltInfo, '(not frmMainForm.fraScanFunctions.chkStackScan.Checked) and (PDoc <> nil)  --> TRUE', ClassName);
//            AThread.Synchronize(nil,
//              procedure
//              begin
//                FScanPool.MIO.TWainParams.FreeResources;
//                PDoc.ScanPoolView := FScanPool;
//                FScanpool := nil; //24.07.2023 CreateInvisibleScanPoolMView(nil); //03.01.2019 ;14.11.2018 Ticket 16706 bfaCommonImageEN.CreateInvisibleMView(nil);
//              end);
//          end
//          else
//          begin
//            AThread.Synchronize(nil,
//              procedure
//              begin
//                bitfarmApp.Log.Write(llDebug, ltInfo, '(not frmMainForm.fraScanFunctions.chkStackScan.Checked) and (PDoc <> nil)  --> FALSE', ClassName);
//                FScanpool.Clear;
//              end);
//          end;
//          AThread.Synchronize(nil,
//            procedure
//            begin
//              img2.Free;
//              img2 := nil;
//            end);
          {$IFDEF IMAGEEN_SYNCHRONIZED}
          if (not frmMainForm.fraScanFunctions.chkStackScan.Checked) and (PDoc <> nil) then
          begin
            bitfarmApp.Log.Write(llDebug, ltInfo, '(not frmMainForm.fraScanFunctions.chkStackScan.Checked) and (PDoc <> nil)  --> TRUE', ClassName);
            AThread.Synchronize(nil,
              procedure
              begin
                FScanPool.MIO.TWainParams.FreeResources;
                PDoc.ScanPoolView := FScanPool;
                FScanpool := nil; //24.07.2023 CreateInvisibleScanPoolMView(nil); //03.01.2019 ;14.11.2018 Ticket 16706 bfaCommonImageEN.CreateInvisibleMView(nil);
              end);
          end
          else
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                bitfarmApp.Log.Write(llDebug, ltInfo, '(not frmMainForm.fraScanFunctions.chkStackScan.Checked) and (PDoc <> nil)  --> FALSE', ClassName);
                FScanpool.Clear;
              end);
          end;
          AThread.Synchronize(nil,
            procedure
            begin
              img2.Free;
              img2 := nil;
            end);
          {$ELSE}
          if (not frmMainForm.fraScanFunctions.chkStackScan.Checked) and (PDoc <> nil) then
          begin
            bitfarmApp.Log.Write(llDebug, ltInfo, '(not frmMainForm.fraScanFunctions.chkStackScan.Checked) and (PDoc <> nil)  --> TRUE', ClassName);
            PDoc.ScanPoolView := FScanPool;
            FScanpool := CreateInvisibleScanPoolMView(nil); //03.01.2019 ;14.11.2018 Ticket 16706 bfaCommonImageEN.CreateInvisibleMView(nil);
          end
          else
          begin
            bitfarmApp.Log.Write(llDebug, ltInfo, '(not frmMainForm.fraScanFunctions.chkStackScan.Checked) and (PDoc <> nil)  --> FALSE', ClassName);
            FScanpool.Clear;
        end;
          img2.Free;
          img2 := nil;
          {$ENDIF}
//29.08.2023 <--
      end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'Scan', ClassName);
    end;
  finally
    Screen.Cursor := crDefault;
    bitfarmApp.Log.WriteEND(llDebug, ltInfo, 'Scan', ClassName);
  end;
end;

{$IFDEF ImageEn1140}
procedure TbfaApplication.InitScan(Dlg: Boolean; img: TbfaImageEnMView; Combo: TcxImageComboBox; AThread: TThread);
var
  Scanner: TIEAcquireParams;
  Device: TIEAcquireSource;
  result: Boolean;
  ScnIdx: Integer;
begin
  bitfarmApp.Log.WriteBegin(llDebug, ltInfo, 'InitScan', ClassName);
  try
    try
      ScnIdx := Combo.ItemIndex;
      Scanner := img.MIO.AcquireParams;
      with FScannerProfiles do
      begin
        result := False;

        if not result then
        begin
          if FScannerProfiles.Container[ScnIdx].ScannerName <> '' then
          begin
            try
              Device := Scanner.FindSourceByName(FScannerProfiles.Container[ScnIdx].ScannerName);

              if ((FScanPool.MIO.TWainParams.SourceCount > 0) and
                 (FScanPool.MIO.TWainParams.SourceName[FScanPool.MIO.TWainParams.SelectedSource] <> FScannerProfiles.Container[ScnIdx].ScannerName))
                 or
                 ((FScanPool.MIO.WIAParams.DevicesInfoCount > 0) and
                 (FScanPool.MIO.WIAParams.SourceNameToIndex(FScannerProfiles.Container[ScnIdx].ScannerName) <> FScanPool.MIO.WIAParams.ConnectedDeviceIndex)) then
              begin
                result := img.MIO.SetAcquireSource(Device.Api, Device.Location);
              end else
                result := True;
            except
              on e: Exception do
              begin
                if AThread <> nil then
                begin
                  AThread.Synchronize(nil,
                    procedure
                    begin
                      Showmessage(_('Vordefinierter Scanner nicht gefunden.'));
                    end);
                end
                else
                  Showmessage(_('Vordefinierter Scanner nicht gefunden.'));
                result := false;
              end;
            end;
          end;
        end;

        if not result then
        begin
          bitfarmLog.Write(llNormal, ltDebug, 'InitScan Scanner nicht gefunden, ScannerName =  ' + FScannerProfiles.Container[ScnIdx].ScannerName, ClassName);
          result := False;
          exit;
        end;

        if Device.Api = ieaTwain then
        begin
          Scanner.AttachedTwainParams.GetFromScanner;
          if Container[ScnIdx].Format = 0 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_NONE
          else if Container[ScnIdx].Format = 1 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_A4LETTER
          else if Container[ScnIdx].Format = 2 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_B5LETTER
          else if Container[ScnIdx].Format = 3 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_USLETTER
          else if Container[ScnIdx].Format = 4 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_USLEGAL
          else if Container[ScnIdx].Format = 5 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_A5
          else if Container[ScnIdx].Format = 6 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_B4
          else if Container[ScnIdx].Format = 7 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_B6
          else if Container[ScnIdx].Format = 8 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_USLEDGER
          else if Container[ScnIdx].Format = 9 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_USEXECUTIVE
          else if Container[ScnIdx].Format = 10 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_A3
          else if Container[ScnIdx].Format = 11 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_B3
          else if Container[ScnIdx].Format = 12 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_A6
          else if Container[ScnIdx].Format = 13 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_C4
          else if Container[ScnIdx].Format = 14 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_C5
          else if Container[ScnIdx].Format = 15 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_C6
          else if Container[ScnIdx].Format = 16 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_4A0
          else if Container[ScnIdx].Format = 17 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_2A0
          else if Container[ScnIdx].Format = 18 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_A0
          else if Container[ScnIdx].Format = 19 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_A1
          else if Container[ScnIdx].Format = 20 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_A2
          else if Container[ScnIdx].Format = 21 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_A7
          else if Container[ScnIdx].Format = 22 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_A8
          else if Container[ScnIdx].Format = 23 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_A9
          else if Container[ScnIdx].Format = 24 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_A10
          else if Container[ScnIdx].Format = 25 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_ISOB0
          else if Container[ScnIdx].Format = 26 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_ISOB1
          else if Container[ScnIdx].Format = 27 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_ISOB2
          else if Container[ScnIdx].Format = 28 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_ISOB5
          else if Container[ScnIdx].Format = 29 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_ISOB7
          else if Container[ScnIdx].Format = 30 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_ISOB8
          else if Container[ScnIdx].Format = 31 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_ISOB9
          else if Container[ScnIdx].Format = 32 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_ISOB10
          else if Container[ScnIdx].Format = 33 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_JISB0
          else if Container[ScnIdx].Format = 34 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_JISB1
          else if Container[ScnIdx].Format = 35 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_JISB2
          else if Container[ScnIdx].Format = 36 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_JISB3
          else if Container[ScnIdx].Format = 37 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_JISB4
          else if Container[ScnIdx].Format = 38 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_JISB6
          else if Container[ScnIdx].Format = 39 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_JISB7
          else if Container[ScnIdx].Format = 40 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_JISB8
          else if Container[ScnIdx].Format = 41 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_JISB9
          else if Container[ScnIdx].Format = 42 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_JISB10
          else if Container[ScnIdx].Format = 43 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_C0
          else if Container[ScnIdx].Format = 44 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_C1
          else if Container[ScnIdx].Format = 45 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_C2
          else if Container[ScnIdx].Format = 46 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_C3
          else if Container[ScnIdx].Format = 47 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_C7
          else if Container[ScnIdx].Format = 48 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_C8
          else if Container[ScnIdx].Format = 49 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_C9
          else if Container[ScnIdx].Format = 50 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_C10
          else if Container[ScnIdx].Format = 51 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_USSTATEMENT
          else if Container[ScnIdx].Format = 52 then
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_BUSINESSCARD
          else
            Scanner.AttachedTwainParams.StandardSize.CurrentValue := IETW_A4LETTER;

          Scanner.AttachedTwainParams.BufferedTransfer := True;    // das muss True sein, verdammte Hacke
          case Container[ScnIdx].Transfer of
            0:
              begin
                Scanner.AttachedTwainParams.FileTransfer := True;
                Scanner.AttachedTwainParams.CompatibilityMode := False;
              end;
            1:
              begin
                Scanner.AttachedTwainParams.FileTransfer := True;
                Scanner.AttachedTwainParams.CompatibilityMode := True;
              end;
            2:
              begin
                Scanner.AttachedTwainParams.FileTransfer := False;
                Scanner.AttachedTwainParams.CompatibilityMode := False;
              end;
            3:
              begin
                Scanner.AttachedTwainParams.FileTransfer := False;
                Scanner.AttachedTwainParams.CompatibilityMode := True;
              end;
            4:
              begin
                Scanner.AttachedTwainParams.FileTransfer := False;
                Scanner.AttachedTwainParams.BufferedTransfer := False;
                Scanner.AttachedTwainParams.CompatibilityMode := False;
              end;
            5:
              begin
                Scanner.AttachedTwainParams.FileTransfer := False;
                Scanner.AttachedTwainParams.BufferedTransfer := False;
                Scanner.AttachedTwainParams.CompatibilityMode := True;
              end;
          else
            begin
              Scanner.AttachedTwainParams.FileTransfer := False;
              Scanner.AttachedTwainParams.BufferedTransfer := True;
              Scanner.AttachedTwainParams.CompatibilityMode := False;
            end;
          end;

          case Container[ScnIdx].Filter of
            1:
              Scanner.AttachedTwainParams.Filter := ietwRed;
            2:
              Scanner.AttachedTwainParams.Filter := ietwGreen;
            3:
              Scanner.AttachedTwainParams.Filter := ietwBlue;
            4:
              Scanner.AttachedTwainParams.Filter := ietwWhite;
            5:
              Scanner.AttachedTwainParams.Filter := ietwCyan;
            6:
              Scanner.AttachedTwainParams.Filter := ietwMagenta;
            7:
              Scanner.AttachedTwainParams.Filter := ietwYellow;
            8:
              Scanner.AttachedTwainParams.Filter := ietwBlack;
          end;
        end;

        Scanner.Brightness := Container[ScnIdx].Brightness;
        Scanner.Contrast := Container[ScnIdx].Contrast;
        Scanner.Orientation := TIEAcquireOrientation(Container[ScnIdx].Orientation);
        Scanner.AcquireFrameEnabled := False;
        Scanner.AcquireFrameTop := Container[ScnIdx].FrameTop;
        Scanner.AcquireFrameLeft := Container[ScnIdx].FrameLeft;
        Scanner.AcquireFrameRight := Container[ScnIdx].FrameRight;
        Scanner.AcquireFrameBottom := Container[ScnIdx].FrameBottom;
        Scanner.AcquireFrameEnabled := Container[ScnIdx].UseFrame;
        Scanner.FeederEnabled := Container[ScnIdx].ADF;

        if Container[ScnIdx].Threshold <> 0 then //06.03.2018 Das muss hier rein, sonst werden manche Scanner einfach nur weie seite scannen nach der Migration!
          Scanner.Threshold := Container[ScnIdx].Threshold;

        Scanner.DuplexEnabled := (frmMainForm.fraScanFunctions.chkScanDuplex.Checked);

        bitfarmApp.Log.Write(llDebug, ltInfo, 'Scanner.DuplexEnabled = ' + BoolToStr(Scanner.DuplexEnabled, True), ClassName);

        case Container[ScnIdx].ColorMode of
          0:
            Scanner.PixelType := TIEAcquirePixelType(0);
          1:
            Scanner.PixelType := TIEAcquirePixelType(1);
          2:
            Scanner.PixelType := TIEAcquirePixelType(2);
        else
          Scanner.PixelType := TIEAcquirePixelType(0);
        end;

        case Container[ScnIdx].BitDepth of
          0:
            Scanner.BitDepth := 1;
          1:
            Scanner.BitDepth := 4;
          2:
            Scanner.BitDepth := 8;
        else
          Scanner.BitDepth := 1;
        end;

        case Container[ScnIdx].DPI of
          0:
            Scanner.XResolution := 50;
          1:
            Scanner.XResolution := 75;
          2:
            Scanner.XResolution := 100;
          3:
            Scanner.XResolution := 150;
          4:
            Scanner.XResolution := 200;
          5:
            Scanner.XResolution := 300;
          6:
            Scanner.XResolution := 400;
          7:
            Scanner.XResolution := 600;
          8:
            Scanner.XResolution := 1200;
        else
          Scanner.XResolution := 200;
        end;

        Scanner.YResolution := Scanner.XResolution;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'InitScan', ClassName);
    end;
  finally
    bitfarmApp.Log.WriteEnd(llDebug, ltInfo, 'InitScan', ClassName);
  end;
end;
{$ENDIF}

procedure TbfaApplication.InitScan(Dlg: Boolean; TwainPrm: TIETwainParams;
  img: TbfaImageEnMView; Combo: TcxImageComboBox; AThread: TThread);
var
  Scanner: TIETwainParams;
  result: Boolean;
  ScnIdx: Integer;
begin
  bitfarmApp.Log.WriteBegin(llDebug, ltInfo, 'InitScan', ClassName);
  try
    try
      ScnIdx := Combo.ItemIndex;
      Scanner := TwainPrm;
      with FScannerProfiles do
      begin
        result := False;

        if not result then
        begin
          if FScannerProfiles.Container[ScnIdx].ScannerName <> '' then
          begin
            try
//29.08.2023 -->
//              AThread.Synchronize(nil, //25.07.2023
//                procedure
//                begin
//                  if (FScanPool.MIO.TWainParams.SourceCount > 0) and (FScanPool.MIO.TWainParams.SourceName[FScanPool.MIO.TWainParams.SelectedSource] <> FScannerProfiles.Container[ScnIdx].ScannerName) then
//                    result := Scanner.SelectSourceByName(FScannerProfiles.Container[ScnIdx].ScannerName)
//                  else
//                    result := True;
//                end);
              {$IFDEF IMAGEEN_SYNCHRONIZED}
              AThread.Synchronize(nil, //25.07.2023
                procedure
                begin
                  if (FScanPool.MIO.TWainParams.SourceCount > 0) and (FScanPool.MIO.TWainParams.SourceName[FScanPool.MIO.TWainParams.SelectedSource] <> FScannerProfiles.Container[ScnIdx].ScannerName) then
                    result := Scanner.SelectSourceByName(FScannerProfiles.Container[ScnIdx].ScannerName)
                  else
                    result := True;
                end);
              {$ELSE}
              if (FScanPool.MIO.TWainParams.SourceCount > 0) and (FScanPool.MIO.TWainParams.SourceName[FScanPool.MIO.TWainParams.SelectedSource] <> FScannerProfiles.Container[ScnIdx].ScannerName) then
                result := Scanner.SelectSourceByName(FScannerProfiles.Container[ScnIdx].ScannerName)
              else
                result := True;
              {$ENDIF}
//29.08.2023 <--
            except
              on e: Exception do
              begin
                if AThread <> nil then
                begin
                  AThread.Synchronize(nil,
                    procedure
                    begin
                      Showmessage(_('Vordefinierter Scanner nicht gefunden.'));
                    end);
                end
                else
                  Showmessage(_('Vordefinierter Scanner nicht gefunden.'));
                result := false;
              end;
            end;
          end;
        end;

        if not result then
        begin
          bitfarmLog.Write(llNormal, ltDebug, 'InitScan Scanner nicht gefunden, ScannerName =  ' + FScannerProfiles.Container[ScnIdx].ScannerName, ClassName);
          result := False;
          exit;
        end;

//29.08.2023 -->
//        AThread.Synchronize(nil, //25.07.2023
//          procedure
//          begin
        {$IFDEF IMAGEEN_SYNCHRONIZED}
        AThread.Synchronize(nil, //25.07.2023
          procedure
          begin
        {$ENDIF}
//29.08.2023 <--
          if Container[ScnIdx].Format = 0 then
            Scanner.StandardSize.CurrentValue := IETW_NONE
          else if Container[ScnIdx].Format = 1 then
            Scanner.StandardSize.CurrentValue := IETW_A4LETTER
          else if Container[ScnIdx].Format = 2 then
            Scanner.StandardSize.CurrentValue := IETW_B5LETTER
          else if Container[ScnIdx].Format = 3 then
            Scanner.StandardSize.CurrentValue := IETW_USLETTER
          else if Container[ScnIdx].Format = 4 then
            Scanner.StandardSize.CurrentValue := IETW_USLEGAL
          else if Container[ScnIdx].Format = 5 then
            Scanner.StandardSize.CurrentValue := IETW_A5
          else if Container[ScnIdx].Format = 6 then
            Scanner.StandardSize.CurrentValue := IETW_B4
          else if Container[ScnIdx].Format = 7 then
            Scanner.StandardSize.CurrentValue := IETW_B6
          else if Container[ScnIdx].Format = 8 then
            Scanner.StandardSize.CurrentValue := IETW_USLEDGER
          else if Container[ScnIdx].Format = 9 then
            Scanner.StandardSize.CurrentValue := IETW_USEXECUTIVE
          else if Container[ScnIdx].Format = 10 then
            Scanner.StandardSize.CurrentValue := IETW_A3
          else if Container[ScnIdx].Format = 11 then
            Scanner.StandardSize.CurrentValue := IETW_B3
          else if Container[ScnIdx].Format = 12 then
            Scanner.StandardSize.CurrentValue := IETW_A6
          else if Container[ScnIdx].Format = 13 then
            Scanner.StandardSize.CurrentValue := IETW_C4
          else if Container[ScnIdx].Format = 14 then
            Scanner.StandardSize.CurrentValue := IETW_C5
          else if Container[ScnIdx].Format = 15 then
            Scanner.StandardSize.CurrentValue := IETW_C6
          else if Container[ScnIdx].Format = 16 then
            Scanner.StandardSize.CurrentValue := IETW_4A0
          else if Container[ScnIdx].Format = 17 then
            Scanner.StandardSize.CurrentValue := IETW_2A0
          else if Container[ScnIdx].Format = 18 then
            Scanner.StandardSize.CurrentValue := IETW_A0
          else if Container[ScnIdx].Format = 19 then
            Scanner.StandardSize.CurrentValue := IETW_A1
          else if Container[ScnIdx].Format = 20 then
            Scanner.StandardSize.CurrentValue := IETW_A2
          else if Container[ScnIdx].Format = 21 then
            Scanner.StandardSize.CurrentValue := IETW_A7
          else if Container[ScnIdx].Format = 22 then
            Scanner.StandardSize.CurrentValue := IETW_A8
          else if Container[ScnIdx].Format = 23 then
            Scanner.StandardSize.CurrentValue := IETW_A9
          else if Container[ScnIdx].Format = 24 then
            Scanner.StandardSize.CurrentValue := IETW_A10
          else if Container[ScnIdx].Format = 25 then
            Scanner.StandardSize.CurrentValue := IETW_ISOB0
          else if Container[ScnIdx].Format = 26 then
            Scanner.StandardSize.CurrentValue := IETW_ISOB1
          else if Container[ScnIdx].Format = 27 then
            Scanner.StandardSize.CurrentValue := IETW_ISOB2
          else if Container[ScnIdx].Format = 28 then
            Scanner.StandardSize.CurrentValue := IETW_ISOB5
          else if Container[ScnIdx].Format = 29 then
            Scanner.StandardSize.CurrentValue := IETW_ISOB7
          else if Container[ScnIdx].Format = 30 then
            Scanner.StandardSize.CurrentValue := IETW_ISOB8
          else if Container[ScnIdx].Format = 31 then
            Scanner.StandardSize.CurrentValue := IETW_ISOB9
          else if Container[ScnIdx].Format = 32 then
            Scanner.StandardSize.CurrentValue := IETW_ISOB10
          else if Container[ScnIdx].Format = 33 then
            Scanner.StandardSize.CurrentValue := IETW_JISB0
          else if Container[ScnIdx].Format = 34 then
            Scanner.StandardSize.CurrentValue := IETW_JISB1
          else if Container[ScnIdx].Format = 35 then
            Scanner.StandardSize.CurrentValue := IETW_JISB2
          else if Container[ScnIdx].Format = 36 then
            Scanner.StandardSize.CurrentValue := IETW_JISB3
          else if Container[ScnIdx].Format = 37 then
            Scanner.StandardSize.CurrentValue := IETW_JISB4
          else if Container[ScnIdx].Format = 38 then
            Scanner.StandardSize.CurrentValue := IETW_JISB6
          else if Container[ScnIdx].Format = 39 then
            Scanner.StandardSize.CurrentValue := IETW_JISB7
          else if Container[ScnIdx].Format = 40 then
            Scanner.StandardSize.CurrentValue := IETW_JISB8
          else if Container[ScnIdx].Format = 41 then
            Scanner.StandardSize.CurrentValue := IETW_JISB9
          else if Container[ScnIdx].Format = 42 then
            Scanner.StandardSize.CurrentValue := IETW_JISB10
          else if Container[ScnIdx].Format = 43 then
            Scanner.StandardSize.CurrentValue := IETW_C0
          else if Container[ScnIdx].Format = 44 then
            Scanner.StandardSize.CurrentValue := IETW_C1
          else if Container[ScnIdx].Format = 45 then
            Scanner.StandardSize.CurrentValue := IETW_C2
          else if Container[ScnIdx].Format = 46 then
            Scanner.StandardSize.CurrentValue := IETW_C3
          else if Container[ScnIdx].Format = 47 then
            Scanner.StandardSize.CurrentValue := IETW_C7
          else if Container[ScnIdx].Format = 48 then
            Scanner.StandardSize.CurrentValue := IETW_C8
          else if Container[ScnIdx].Format = 49 then
            Scanner.StandardSize.CurrentValue := IETW_C9
          else if Container[ScnIdx].Format = 50 then
            Scanner.StandardSize.CurrentValue := IETW_C10
          else if Container[ScnIdx].Format = 51 then
            Scanner.StandardSize.CurrentValue := IETW_USSTATEMENT
          else if Container[ScnIdx].Format = 52 then
            Scanner.StandardSize.CurrentValue := IETW_BUSINESSCARD
          else
            Scanner.StandardSize.CurrentValue := IETW_A4LETTER;

          Scanner.BufferedTransfer := True;    // das muss True sein, verdammte Hacke
          case Container[ScnIdx].Transfer of
            0:
              begin
                Scanner.FileTransfer := True;
                Scanner.CompatibilityMode := False;
              end;
            1:
              begin
                Scanner.FileTransfer := True;
                Scanner.CompatibilityMode := True;
              end;
            2:
              begin
                Scanner.FileTransfer := False;
                Scanner.CompatibilityMode := False;
              end;
            3:
              begin
                Scanner.FileTransfer := False;
                Scanner.CompatibilityMode := True;
              end;
            4:
              begin
                Scanner.FileTransfer := False;
                Scanner.BufferedTransfer := False;
                Scanner.CompatibilityMode := False;
              end;
            5:
              begin
                Scanner.FileTransfer := False;
                Scanner.BufferedTransfer := False;
                Scanner.CompatibilityMode := True;
              end;
          else
            begin
              Scanner.FileTransfer := False;
              Scanner.BufferedTransfer := True;
              Scanner.CompatibilityMode := False;
            end;
          end;

          case Container[ScnIdx].Filter of
            1:
              Scanner.Filter := ietwRed;
            2:
              Scanner.Filter := ietwGreen;
            3:
              Scanner.Filter := ietwBlue;
            4:
              Scanner.Filter := ietwWhite;
            5:
              Scanner.Filter := ietwCyan;
            6:
              Scanner.Filter := ietwMagenta;
            7:
              Scanner.Filter := ietwYellow;
            8:
              Scanner.Filter := ietwBlack;
          end;

          Scanner.Brightness.CurrentValue := Container[ScnIdx].Brightness;
          Scanner.Contrast.CurrentValue := Container[ScnIdx].Contrast;
          if Container[ScnIdx].Threshold <> 0 then //06.03.2018 Das muss hier rein, sonst werden manche Scanner einfach nur weie seite scannen nach der Migration!
            Scanner.Threshold.CurrentValue := Container[ScnIdx].Threshold;
          Scanner.Orientation.CurrentValue := Container[ScnIdx].Orientation;
          Scanner.AcquireFrameEnabled := False;
          Scanner.AcquireFrameTop := Container[ScnIdx].FrameTop;
          Scanner.AcquireFrameLeft := Container[ScnIdx].FrameLeft;
          Scanner.AcquireFrameRight := Container[ScnIdx].FrameRight;
          Scanner.AcquireFrameBottom := Container[ScnIdx].FrameBottom;
          Scanner.AcquireFrameEnabled := Container[ScnIdx].UseFrame;
          Scanner.FeederEnabled := Container[ScnIdx].ADF;
          Scanner.DuplexEnabled :=
            (frmMainForm.fraScanFunctions.chkScanDuplex.Checked);

          if Scanner.DuplexEnabled then
            bitfarmApp.Log.Write(llDebug, ltInfo, 'Scanner.DuplexEnabled = True', ClassName)
          else
            bitfarmApp.Log.Write(llDebug, ltInfo, 'Scanner.DuplexEnabled = False', ClassName);

          case Container[ScnIdx].ColorMode of
            0:
              Scanner.PixelType.CurrentValue := 0;
            1:
              Scanner.PixelType.CurrentValue := 1;
            2:
              Scanner.PixelType.CurrentValue := 2;
          else
            Scanner.PixelType.CurrentValue := 0;
          end;
          case Container[ScnIdx].BitDepth of
            0:
              Scanner.BitDepth.CurrentValue := 1;
            1:
              Scanner.BitDepth.CurrentValue := 4;
            2:
              Scanner.BitDepth.CurrentValue := 8;
          else
            Scanner.BitDepth.CurrentValue := 1;
          end;

          case Container[ScnIdx].DPI of
            0:
              Scanner.XResolution.CurrentValue := 50;
            1:
              Scanner.XResolution.CurrentValue := 75;
            2:
              Scanner.XResolution.CurrentValue := 100;
            3:
              Scanner.XResolution.CurrentValue := 150;
            4:
              Scanner.XResolution.CurrentValue := 200;
            5:
              Scanner.XResolution.CurrentValue := 300;
            6:
              Scanner.XResolution.CurrentValue := 400;
            7:
              Scanner.XResolution.CurrentValue := 600;
            8:
              Scanner.XResolution.CurrentValue := 1200;
          else
            Scanner.XResolution.CurrentValue := 200;
          end;

          Scanner.YResolution.CurrentValue := Scanner.XResolution.CurrentValue;
//29.08.2023 -->
//       end);
        {$IFDEF IMAGEEN_SYNCHRONIZED}
        end);
        {$ENDIF}
//29.08.2023 <--

      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'InitScan', ClassName);
    end;
  finally
    bitfarmApp.Log.WriteEnd(llDebug, ltInfo, 'InitScan', ClassName);
  end;
end;

procedure TbfaApplication.InResub(AThread: TThread; bRightMouseButtonClick: Boolean = False);
begin
  Log.DebugBegin(llDebug, 'InResub', Classname);
  try
    try
      if (FCurrentContainer.Count > 0) and (FCurrentContainer[0] <> nil) then
      begin
        if frmMainForm.clItemInResub.ImageIndex = Integer(icoidx_clock_enabled) then
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              if (bRightMouseButtonClick and (frmMainForm.popInResub.Items.Count > 0)) or (CurrentView = tvkResub)
              then
                frmMainForm.popInResub.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y)
              else if not bRightMouseButtonClick then
              begin
                if not FCurrentContainer[0].InEditMode then
                begin
                  frmMainForm.clItemInResub.ImageIndex := Integer(icoidx_clock_disabled);
                  frmMainForm.clItemInResub.FontSettings.Style := [fsBold];
                  FSearchInResub := True;
                  FSearchInResubNegated := True;
                end;
              end;
            end);
        end
        else
        begin
          if CurrentView = tvkViewer then
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                if (not FCurrentContainer[0].InEditMode) and (not bRightMouseButtonClick) then
                begin
                  if frmMainForm.clItemInResub.ImageIndex = Integer(icoidx_clock_unselected) then
                  begin
                    frmMainForm.clItemInResub.ImageIndex := Integer(icoidx_clock_enabled);
                    frmMainForm.clItemInResub.FontSettings.Style := [fsBold];
                    FSearchInResub := True;
                    FSearchInResubNegated := False;
                  end
                  else if frmMainForm.clItemInResub.ImageIndex = Integer(icoidx_clock_enabled) then
                  begin
                    frmMainForm.clItemInResub.ImageIndex := Integer(icoidx_clock_disabled);
                    frmMainForm.clItemInResub.FontSettings.Style := [fsBold];
                    FSearchInResub := True;
                    FSearchInResubNegated := True;
                  end
                  else
                  begin
                    frmMainForm.clItemInResub.ImageIndex := Integer(icoidx_clock_unselected);
                    frmMainForm.clItemInResub.FontSettings.Style := [];
                    FSearchInResub := False;
                    FSearchInResubNegated := False;
                  end;
                end;
              end);
          end;
        end;
      end
      else
      begin
        if CurrentView = tvkViewer then
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              if not bRightMouseButtonClick then
              begin
                if frmMainForm.clItemInResub.ImageIndex = Integer(icoidx_clock_unselected) then
                begin
                  frmMainForm.clItemInResub.ImageIndex := Integer(icoidx_clock_enabled);
                  frmMainForm.clItemInResub.FontSettings.Style := [fsBold];
                  FSearchInResub := True;
                  FSearchInResubNegated := False;
                end
                else if frmMainForm.clItemInResub.ImageIndex = Integer(icoidx_clock_enabled) then
                begin
                  frmMainForm.clItemInResub.ImageIndex := Integer(icoidx_clock_disabled);
                  frmMainForm.clItemInResub.FontSettings.Style := [fsBold];
                  FSearchInResub := True;
                  FSearchInResubNegated := True;
                end
                else
                begin
                  frmMainForm.clItemInResub.ImageIndex := Integer(icoidx_clock_unselected);
                  frmMainForm.clItemInResub.FontSettings.Style := [];
                  FSearchInResub := False;
                  FSearchInResubNegated := False;
                end;
              end;
            end);
        end;
      end;
    except
      Log.Write(llNormal, ltException, 'InResub', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'InResub', Classname);
  end;
end;

procedure TbfaApplication.AfterScan(Dlg: Boolean; img: TbfaImageEnMView;
  TwainPrm: TIETwainParams; Combo: TcxImageComboBox);
var
  i, idx, maxPages: Integer;
  imgVect: TbfaImageEnVect;
  ms: TMemoryStream;
begin
  bitfarmApp.Log.WriteBegin(llDebug, ltInfo, 'AfterScan', ClassName);
  try
    try
      idx := Combo.ItemIndex;

      if FScannerProfiles.Container[idx].Inverse then
      begin
        bitfarmApp.Log.Write(llDebug, ltInfo, 'Inverse', ClassName);
        img.Deselect;
        for i := 0 to img.ImageCount - 1 do
        begin
          img.SelectedImage := i;
          img.Proc.Negative;
        end;
      end;

      for i := 0 to img.ImageCount - 1 do
      begin
        if Dlg then
        begin
          bitfarmApp.Log.Write(llDebug, ltInfo, 'Dlg = True', ClassName);

          case img.MIO.Params[i].BitsPerSample * img.MIO.Params[i].SamplesPerPixel of
            1:
              img.MIO.Params[i].TIFF_Compression := ioTIFF_G4FAX;
            4:
              img.MIO.Params[i].TIFF_Compression := ioTIFF_LZW;
            8:
              img.MIO.Params[i].TIFF_Compression := ioTIFF_JPEG;
            24:
              img.MIO.Params[i].TIFF_Compression := ioTIFF_JPEG;
          else
            img.MIO.Params[i].TIFF_Compression := ioTIFF_JPEG;
          end;
        end
        else
        begin
          bitfarmApp.Log.Write(llDebug, ltInfo, 'Dlg = False', ClassName);

          case FScannerProfiles.Container[idx].Compression of
            0:
              img.MIO.Params[i].TIFF_Compression := ioTIFF_UNCOMPRESSED;
            1:
              img.MIO.Params[i].TIFF_Compression := ioTIFF_G3FAX2D;
            2:
              img.MIO.Params[i].TIFF_Compression := ioTIFF_G4FAX;
            3:
              img.MIO.Params[i].TIFF_Compression := ioTIFF_JPEG;
            4:
              img.MIO.Params[i].TIFF_Compression := ioTIFF_PACKBITS;
            5:
              img.MIO.Params[i].TIFF_Compression := ioTIFF_LZW;
          else
            img.MIO.Params[i].TIFF_Compression := ioTIFF_UNCOMPRESSED;
          end;
        end;

        bitfarmApp.Log.Write(llDebug, ltInfo, 'img.MIO.TWainParams.PixelType.CurrentValue=' + IntToStr(img.MIO.TWainParams.PixelType.CurrentValue), ClassName);

        if img.MIO.TWainParams.PixelType.CurrentValue = 0 then
        begin
          img.MIO.Params[i].BitsPerSample := 1;
          img.MIO.Params[i].SamplesPerPixel := 1;
        end
        else if img.MIO.TWainParams.PixelType.CurrentValue = 1 then
        begin
          img.MIO.Params[i].BitsPerSample := FScannerProfiles.Container[idx].BitDepth;
          img.MIO.Params[i].SamplesPerPixel := 1;
        end
        else if img.MIO.TWainParams.PixelType.CurrentValue = 2 then
        begin
          img.MIO.Params[i].BitsPerSample := 8;
          img.MIO.Params[i].SamplesPerPixel := 3;
        end;
      end;

      if FScannerProfiles.Container[idx].DeletePage then
      begin
        bitfarmApp.Log.Write(llDebug, ltInfo, 'DeletePage', ClassName);

        i := 0;
        img.Deselect;
        maxPages := img.ImageCount;
        while i < maxPages do
        begin
          ms := TMemoryStream.Create;

          img.SelectedImage := i;
          imgVect := TbfaImageEnVect.Create(nil);
          imgVect.IO.Params.TIFF_Compression := img.MIO.Params[i].TIFF_Compression;
          imgVect.IEBitmap.AssignImage(img.GetTIEBitmap(img.SelectedImage));
          imgVect.IO.Params.BitsPerSample := img.MIO.Params[i].BitsPerSample;
          imgVect.IO.Params.SamplesPerPixel := img.MIO.Params[i].SamplesPerPixel;
          case (imgVect.IO.Params.BitsPerSample * imgVect.IO.Params.SamplesPerPixel) of
            1:
              imgVect.Proc.ConvertToBWOrdered;
            4:
              imgVect.Proc.ConvertToGray;
            8:
              imgVect.Proc.ConvertToGray;
            24:
              imgVect.Proc.ConvertTo24Bit;
          end;
          try
            imgVect.IO.SaveToStreamTIFF(ms);

          except
            on e: exception do
            begin
              Showmessage(e.message);
            end;
          end;
          if ms.Size < trunc(FScannerProfiles.Container[idx].DeletePageKB * 1024) then
          begin
            bitfarmApp.Log.Write(llDebug, ltInfo, 'DeleteSelectedImage', ClassName);

            img.DeleteSelectedImages;
            dec(maxPages);
          end
          else
          begin
            inc(i);
          end;
          if Assigned(ms) then
            FreeAndNil(ms);
          if Assigned(imgVect) then
            imgVect.Destroy;
        end;
        img.SelectedImage := img.ImageCount - 1;

      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'AfterScan', ClassName);
    end;
  finally
    bitfarmApp.Log.WriteEnd(llDebug, ltInfo, 'AfterScan', ClassName);
  end;
end;

{$IFDEF ImageEn1140}
procedure TbfaApplication.AfterScan(Dlg: Boolean; img: TbfaImageEnMView;
  Combo: TcxImageComboBox);
var
  i, idx, maxPages: Integer;
  imgVect: TbfaImageEnVect;
  ms: TMemoryStream;
begin
  bitfarmApp.Log.WriteBegin(llDebug, ltInfo, 'AfterScan', ClassName);
  try
    try
      idx := Combo.ItemIndex;

      if FScannerProfiles.Container[idx].Inverse then
      begin
        bitfarmApp.Log.Write(llDebug, ltInfo, 'Inverse', ClassName);
        img.Deselect;
        for i := 0 to img.ImageCount - 1 do
        begin
          img.SelectedImage := i;
          img.Proc.Negative;
        end;
      end;

      for i := 0 to img.ImageCount - 1 do
      begin
        if Dlg then
        begin
          bitfarmApp.Log.Write(llDebug, ltInfo, 'Dlg = True', ClassName);

          case img.MIO.Params[i].BitsPerSample * img.MIO.Params[i].SamplesPerPixel of
            1:
              img.MIO.Params[i].TIFF_Compression := ioTIFF_G4FAX;
            4:
              img.MIO.Params[i].TIFF_Compression := ioTIFF_LZW;
            8:
              img.MIO.Params[i].TIFF_Compression := ioTIFF_JPEG;
            24:
              img.MIO.Params[i].TIFF_Compression := ioTIFF_JPEG;
          else
            img.MIO.Params[i].TIFF_Compression := ioTIFF_JPEG;
          end;
        end
        else
        begin
          bitfarmApp.Log.Write(llDebug, ltInfo, 'Dlg = False', ClassName);

          case FScannerProfiles.Container[idx].Compression of
            0:
              img.MIO.Params[i].TIFF_Compression := ioTIFF_UNCOMPRESSED;
            1:
              img.MIO.Params[i].TIFF_Compression := ioTIFF_G3FAX2D;
            2:
              img.MIO.Params[i].TIFF_Compression := ioTIFF_G4FAX;
            3:
              img.MIO.Params[i].TIFF_Compression := ioTIFF_JPEG;
            4:
              img.MIO.Params[i].TIFF_Compression := ioTIFF_PACKBITS;
            5:
              img.MIO.Params[i].TIFF_Compression := ioTIFF_LZW;
          else
            img.MIO.Params[i].TIFF_Compression := ioTIFF_UNCOMPRESSED;
          end;
        end;

        case img.MIO.AcquireParams.PixelType of
          ieapMonochrome:
            bitfarmApp.Log.Write(llDebug, ltInfo, 'img.MIO.AcquireParams.PixelType = ieapMonochrome', ClassName);
          ieap8BitGrayScale:
            bitfarmApp.Log.Write(llDebug, ltInfo, 'img.MIO.AcquireParams.PixelType = ieap8BitGrayScale', ClassName);
          ieap16BitGrayScale:
            bitfarmApp.Log.Write(llDebug, ltInfo, 'img.MIO.AcquireParams.PixelType = ieap16BitGrayScale', ClassName);
          ieapFullColor:
            bitfarmApp.Log.Write(llDebug, ltInfo, 'img.MIO.AcquireParams.PixelType = ieapFullColor', ClassName);
          ieapFullColor16:
            bitfarmApp.Log.Write(llDebug, ltInfo, 'img.MIO.AcquireParams.PixelType = ieapFullColor16', ClassName);
          ieapOther:
            bitfarmApp.Log.Write(llDebug, ltInfo, 'img.MIO.AcquireParams.PixelType = ieapOther', ClassName);
          else
            bitfarmApp.Log.Write(llDebug, ltInfo, 'img.MIO.AcquireParams.PixelType = unknown', ClassName);
        end;

        if img.MIO.AcquireParams.PixelType = ieapMonochrome then
        begin
          img.MIO.Params[i].BitsPerSample := 1;
          img.MIO.Params[i].SamplesPerPixel := 1;
        end
        else if img.MIO.AcquireParams.PixelType in [ieap8BitGrayScale,ieap16BitGrayScale] then
        begin
          img.MIO.Params[i].BitsPerSample := FScannerProfiles.Container[idx].BitDepth;
          img.MIO.Params[i].SamplesPerPixel := 1;
        end
        else if img.MIO.AcquireParams.PixelType = ieapFullColor then
        begin
          img.MIO.Params[i].BitsPerSample := 8;
          img.MIO.Params[i].SamplesPerPixel := 3;
        end;
      end;

      if FScannerProfiles.Container[idx].DeletePage then
      begin
        bitfarmApp.Log.Write(llDebug, ltInfo, 'DeletePage', ClassName);

        i := 0;
        img.Deselect;
        maxPages := img.ImageCount;
        while i < maxPages do
        begin
          ms := TMemoryStream.Create;

          img.SelectedImage := i;
          imgVect := TbfaImageEnVect.Create(nil);
          imgVect.IO.Params.TIFF_Compression := img.MIO.Params[i].TIFF_Compression;
          imgVect.IEBitmap.AssignImage(img.GetTIEBitmap(img.SelectedImage));
          imgVect.IO.Params.BitsPerSample := img.MIO.Params[i].BitsPerSample;
          imgVect.IO.Params.SamplesPerPixel := img.MIO.Params[i].SamplesPerPixel;
          case (imgVect.IO.Params.BitsPerSample * imgVect.IO.Params.SamplesPerPixel) of
            1:
              imgVect.Proc.ConvertToBWOrdered;
            4:
              imgVect.Proc.ConvertToGray;
            8:
              imgVect.Proc.ConvertToGray;
            24:
              imgVect.Proc.ConvertTo24Bit;
          end;
          try
            imgVect.IO.SaveToStreamTIFF(ms);

          except
            on e: exception do
            begin
              Showmessage(e.message);
            end;
          end;
          if ms.Size < trunc(FScannerProfiles.Container[idx].DeletePageKB * 1024) then
          begin
            bitfarmApp.Log.Write(llDebug, ltInfo, 'DeleteSelectedImage', ClassName);

            img.DeleteSelectedImages;
            dec(maxPages);
          end
          else
          begin
            inc(i);
          end;
          if Assigned(ms) then
            FreeAndNil(ms);
          if Assigned(imgVect) then
            imgVect.Destroy;
        end;
        img.SelectedImage := img.ImageCount - 1;

      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'AfterScan', ClassName);
    end;
  finally
    bitfarmApp.Log.WriteEnd(llDebug, ltInfo, 'AfterScan', ClassName);
  end;
end;
{$ENDIF}

{//-----------------------------------------------------------------------------
Name: SetMainPreviewAction
Parameters: Idx -> Preview Index (Viewer, Importer, Workplace)
Beschreibung: Erstellt ein Action zu SetMainPreview Funktion aufzurufen
//-----------------------------------------------------------------------------}
procedure TbfaApplication.SetActiveViewAction(Idx: Integer = pvtViewer; Sender: TObject = nil; ViewKind: TbfaViewKind = tvkViewer);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'SetActiveViewAction', ClassName);

  Askfor_SaveAdmin;

  try
    try
      UserAction := CreateUserAction;
      UserAction^.ActionName := 'actSetActiveView';
      UserAction^.objects.Add(Sender);
      UserAction^.params.Add(IntToStr(Idx));
      UserAction^.params.Add(IntToStr(Integer(ViewKind)));
      FMainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'SetActiveViewAction', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetActiveViewAction', ClassName);
  end;
end;

procedure TbfaApplication.ShowPreview(ActDoc: TbfaDocument; GDocID: Int64;
  NewTab: Boolean = False; InBackgroundTab: Boolean = False;
  InEditMode: Boolean = False; prev: TbfaPreview = nil; SymArcID: Int64 = -1;
  TimID: Int64 = -1; ResubUserID: Int64 = -1);
var
  Doc: TbfaDocument;
  SearchString: WideString;
  bgTab: Boolean;
begin
  bitfarmLog.DebugBegin(llDebug, 'ShowPreview GDocID:' + IntToStr(GDocID), ClassName);
  try
    try
      if ActDoc = nil then
      begin
        Doc := TbfaDocument.Create;
        Doc.ID := GDocID;

        if SymArcID <> -1 then
          Doc.SymbolicArcID := SymArcID;
        if TimID <> -1 then
          Doc.TimID := TimID;
        if ResubUserID <> -1 then
          Doc.ResubUserID := ResubUserID;

      end
      else
        Doc := ActDoc;

      if CurrentView = tvkResub then
        Doc.Addfields_Arcid := CurrentResubFields;

      if (CurrentView = tvkViewer) and (CurrentArchive.Typ = 0) then  // wir stehen auf einem Lager?
        Doc.Addfields_Arcid := CurrentArchive.Arcid;

      bgTab := NewTab and InBackgroundTab;

      CallShowDocument(Doc, nil, nil, 0, 0, True, NewTab, bgTab, InEditMode, False, True, prev, False, GetSearchString);

      if not frmMainForm.actGetLastDocument.Enabled then
        frmMainForm.actGetLastDocument.Enabled := True;

    except
      bitfarmLog.Write(llDebug, ltException, 'ShowPreview GDocID:' + IntToStr(GDocID), ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ShowPreview GDocID:' + IntToStr(GDocID), ClassName);
  end;
end;

procedure TbfaApplication.CallShowDocument(Doc: TbfaDocument; Docs: TList<TbfaDocument>;
  Objs: TList; DocIdx, PageIdx: Integer; SetCurrent, NewTab, InBackgroundTab, InEditMode,
  SetFocus, ReloadThumbnail: Boolean; prev: TbfaPreview = nil; ChangeToMultiSingle: Boolean = False;
  SearchString: WideString = ''; Reload: Boolean = False; SetImagePos: Boolean = False;
  SetImagePosTothetop: Boolean = False; Autozoom: Boolean = True; PageDirection: Integer = -1;
  Floating: Boolean = False; MouseClick: Boolean = False);
var
  UserAction: PUserAction;
  i: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'CallShowDocument', ClassName);
  try
    try
      UserAction := CreateUserAction;
      UserAction^.ActionName := 'actShowDocument';
      if (Objs <> nil) then
      begin
        for i := 0 to Objs.Count - 1 do
          UserAction^.objects.Add(Objs[i]);
      end
      else
      begin
        UserAction^.objects.Add(nil);
      end;
      if Doc <> nil then
      begin
        UserAction^.Documents.Add(Doc);
      end
      else if (Docs <> nil) then
      begin
        for i := 0 to Docs.Count - 1 do
          UserAction^.Documents.Add(Docs[i]);
      end;
      UserAction^.params.Add(IntToStr(DocIdx)); //Params(0) DocIdx
      UserAction^.params.Add(IntToStr(PageIdx));  //Params(1) PageIdx
      if SetCurrent then
        UserAction^.params.Add(IntToStr(1))  //Params(2) SetCurrent = True
      else
        UserAction^.params.Add(IntToStr(0)); //Params(2) SetCurrent = False
      if NewTab then
        UserAction^.params.Add(IntToStr(1)) //Params(3) InNewTab = True
      else
        UserAction^.params.Add(IntToStr(0)); //Params(3) InNewTab = False
      if InBackgroundTab then
        UserAction^.params.Add(IntToStr(1)) //Params(4) InBackGroundTab = True
      else
        UserAction^.params.Add(IntToStr(0)); //Params(4) InBackGroundTab = False
      if InEditMode then
        UserAction^.params.Add(IntToStr(1)) //Params(5) InEditMode = True
      else
        UserAction^.params.Add(IntToStr(0)); //Params(5) InEditmode = False
      if SetFocus then
        UserAction^.params.Add(IntToStr(1)) //Params(6) SetFocus = True
      else
        UserAction^.params.Add(IntToStr(0)); //Params(6) SetFocus = False
      if ReloadThumbnail then
        UserAction^.params.Add(IntToStr(1)) //Params(7) ReloadThumbnail = True
      else
        UserAction^.params.Add(IntToStr(0)); //Params(7) ReloadThumbnail = False
      if ChangeToMultiSingle then
        UserAction^.params.Add(IntToStr(1)) //Params(8) ChangeToMultiSingle = True
      else
        UserAction^.params.Add(IntToStr(0)); //Params(8) ChangeToMultiSingle = False

      if Reload then
        UserAction^.params.Add(IntToStr(1)) //Params(9) Reload = True
      else
        UserAction^.params.Add(IntToStr(0)); //Params(9) Reload = False

      if (prev <> nil) and (prev.SearchbarTextEdit.Text <> '') then
        UserAction^.params.Add(prev.SearchbarTextEdit.Text) //Params(10) SearchString Toolbar
      else
        UserAction^.params.Add(SearchString); //Params(10) SearchString GeneralSearch

      if SetImagePos then
        UserAction^.params.Add(IntToStr(1)) //Params(11) SetImagePos = True
      else
        UserAction^.params.Add(IntToStr(0)); //Params(11) SetImagePos = False

      if SetImagePosTothetop then
        UserAction^.params.Add(IntToStr(1)) //Params(12) SetImagePosTothetop = True
      else
        UserAction^.params.Add(IntToStr(0)); //Params(12) SetImagePosTothetop = False

      if Autozoom then
        UserAction^.params.Add(IntToStr(1)) //Params(13) Autozoom = True
      else
        UserAction^.params.Add(IntToStr(0)); //Params(13) Autozoom = False

      UserAction^.params.Add(IntToStr(PageDirection)); //Params(14) PageDirection 0 - PreviousPage, 1 - NextPage

      if Floating then
        UserAction^.params.Add(IntToStr(1)) //Params(15) Floating = True
      else
        UserAction^.params.Add(IntToStr(0)); //Params(15) Floating = False

      if MouseClick then
        UserAction^.params.Add(IntToStr(1)) //Params(16) Floating = True
      else
        UserAction^.params.Add(IntToStr(0)); //Params(16) Floating = False

      UserAction^.Preview := prev;
      FMainThread.Add(UserAction);
    except
      bitfarmLog.Write(llDebug, ltException, 'CallShowDocument', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CallShowDocument', ClassName);
  end;
end;

procedure TbfaApplication.BookmarksTreeViewDragDrop(AThread: TThread; Sender, Source: TObject; TV: TJVTreeview; SelNode, WhereNode: TTreeNode; X, Y: Integer);
var
  RNode, PNode, NewNode, PWhereNode, RWhereNode: TTreeNode;
  UserAction: PUserAction;
  NewSObj: TbfaSearch;
  FavType: Integer;
  Expanded: Boolean;
begin
  bitfarmLog.DebugBegin(llDebug, 'BookmarksTreeViewDragDrop', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          // Verschieben der RootNodes abfangen
          if (SelNode.Parent <> nil) then
          begin
            if (TObject(SelNode.Data) is TbfaNodeInfo) and (TbfaNodeInfo(SelNode.Data).Typ = -1) then   // GlobalNodes nicht verschieben
              Exit;

            PNode := GetParentNode(SelNode);
            RNode := GetRootNode(SelNode);
            PWhereNode := GetParentNode(WhereNode);
            RWhereNode := GetRootNode(WhereNode);
            Expanded := SelNode.Expanded;
            if (WhereNode = FGlobalListNode) or (RWhereNode = FGlobalListNode) then
              FavType := 2
            else if (WhereNode = FLocalListNode) or (RWhereNode = FLocalListNode) then
              FavType := 1
            else if (WhereNode = FHistoryListNode) or (RWhereNode = FHistoryListNode) then
              FavType := 3
            else
              FavType := 1;

            if TObject(SelNode.Data) is TbfaSearch then
            begin
              if (TObject(WhereNode.Data) is TbfaNodeInfo) then
              begin
                TbfaSearch(SelNode.Data).Userid := TbfaNodeInfo(WhereNode.Data).Userid;
                TbfaSearch(SelNode.Data).Groupid := TbfaNodeInfo(WhereNode.Data).Groupid;
              end
              else if (PWhereNode <> nil) and
                (TObject(PWhereNode.Data) is TbfaNodeInfo) then
              begin
                TbfaSearch(SelNode.Data).Userid := TbfaNodeInfo(PWhereNode.Data).Userid;
                TbfaSearch(SelNode.Data).Groupid := TbfaNodeInfo(PWhereNode.Data).Groupid;
              end
              else
              begin
                TbfaSearch(SelNode.Data).Userid := User.ID;
                TbfaSearch(SelNode.Data).Groupid := 0;
              end;
            end;

            if (RNode <> FHistoryListNode) then
            begin
              // TODO SJ: beim verschieben auch Image neu setzen
              if GetRootNode(SelNode) <> GetRootNode(WhereNode) then
              begin
                SetBookmarkNodeImage(WhereNode, SelNode);
              end;
              // TODO SJ: restore Schleife durch SelNode wenn TbfaNodeInfo

              if (WhereNode.Data = nil) or
                (TObject(WhereNode.Data) is TbfaNodeInfo) then
                SelNode.MoveTo(WhereNode, naAddChild)
              else
                SelNode.MoveTo(WhereNode, naInsert);

              if Expanded then
                SelNode.Expand(False);
            end
            else
            begin
              if SelNode.Data <> nil then
              begin
                NewSObj := TbfaSearch.Create;
                NewSObj.Clone(SelNode.Data);
              end;

              if (WhereNode.Data = nil) then
                AddTreeviewNode(FLog, TV, WhereNode, NewSObj, FavType)
              else if (WhereNode.Data <> nil) and (TObject(WhereNode.Data) is TbfaNodeInfo) then
                // in der zweiten Ebene einfgen
                AddTreeviewNode(FLog, TV, WhereNode, NewSObj, FavType)
              else
                AddTreeviewNode(FLog, TV, WhereNode.Parent, NewSObj, FavType);
            end;
            UserAction := CreateUserAction;
            if RNode = FGlobalListNode then
            begin
              UserAction^.ActionName := 'actSaveGlobalBookmark';
              if FavType = 2 then // wurde in die globalen Lesezeichen geschoben
                UserAction^.Objects.Add(PWhereNode)
              else if FavType = 1 then // oder in die lokalen
                UserAction^.Objects.Add(PNode)
            end
            else if RNode = FLocalListNode then
              UserAction^.ActionName := 'actSaveLocalBookmark';
            if UserAction^.ActionName <> '' then
              FBackThread.Add(UserAction);

            if RNode <> RWhereNode then
            begin
              UserAction := CreateUserAction;
              if RWhereNode = FGlobalListNode then
              begin
                UserAction^.ActionName := 'actSaveGlobalBookmark';
                UserAction^.Objects.Add(PWhereNode);
              end
              else if RWhereNode = FLocalListNode then
                UserAction^.ActionName := 'actSaveLocalBookmark';
              if UserAction^.ActionName <> '' then
                FBackThread.Add(UserAction);
            end
            else if (RNode = FGlobalListNode) then
            // innerhalb der Global Nodes verschoben? Dann auch die Quelle speichern
            begin
              UserAction := CreateUserAction;
              UserAction^.ActionName := 'actSaveGlobalBookmark';
              UserAction^.Objects.Add(PNode);
              FBackThread.Add(UserAction);
            end;
          end;
        end);

    except
      bitfarmLog.Write(llDebug, ltException, 'BookmarksTreeViewDragDrop',
        ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'BookmarksTreeViewDragDrop', ClassName);
  end;
end;

procedure TbfaApplication.DeleteTreeNode(AThread: TThread; SelNode: TTreeNode);
var
  UserAction: PUserAction;
  RNode, PNode: TTreeNode;
begin
  bitfarmLog.DebugBegin(llDebug, 'BookmarksTreeViewDragDrop', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure

          procedure DeleteOneNode(Nd: TTreeNode);

          procedure delNode(subNode: TTreeNode);
          begin
            if subNode.HasChildren then
              DeleteOneNode(subNode)
            else
            begin
              if subNode.Data <> nil then
                TbfaSearch(subNode.Data).Free;
              subNode.Delete;
            end;
          end;

        var
          i: Integer;
        begin
          if Nd.Count > 0 then
          begin
            for i := Nd.Count - 1 downto 0 do
            begin
              delNode(Nd[i]);
            end;
          end;
          delNode(Nd);
        end;

        begin
          var DlgResult: TModalResult;
          if (SelNode.Data <> nil) and (TObject(SelNode.Data) is TbfaSearch) then
            DlgResult := BfMessageDlg(Format(_('Mchten Sie das ausgewhlte Lesezeichen "%s" wirklich lschen?'), [SelNode.Text]), mtConfirmation, [mbYes, mbNo], True)
          else if (SelNode.Data <> nil) and (TObject(SelNode.Data) is TbfaNodeInfo) then
            DlgResult := BfMessageDlg(Format(_('Mchten Sie den ausgewhlten Lesezeichen-Ordner "%s" wirklich lschen?')+#13#10#13#10+_('Achtung: die enthaltenen Lesezeichen werden ebenfalls gelscht!'), [SelNode.Text]), mtConfirmation, [mbYes, mbNo], True)
          else
            Exit;

          if (DlgResult = mrYes) then
          begin
            RNode := GetRootNode(SelNode);
            PNode := GetParentNode(SelNode);
            DeleteOneNode(SelNode);

            UserAction := CreateUserAction;
            if RNode = FGlobalListNode then
            begin
              UserAction^.ActionName := 'actSaveGlobalBookmark';
              UserAction^.objects.Add(PNode);
            end
            else if RNode = FLocalListNode then
              UserAction^.ActionName := 'actSaveLocalBookmark';
            FBackThread.Add(UserAction);
          end;
        end);

    except
      bitfarmLog.Write(llDebug, ltException, 'BookmarksTreeViewDragDrop', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'BookmarksTreeViewDragDrop', ClassName);
  end;
end;

procedure TbfaApplication.SelectHistoryNode(AThread: TThread; Direction: Integer = 0);
var
  Node: TTreeNode;
begin
  try
   AThread.Synchronize(nil,
        procedure
        begin
          if (FHistoryListNode.Count > 0) then
          begin
            if (SelectFirstHistoryNode) then
            begin
              Node := FHistoryListNode.getFirstChild;
              SelectFirstHistoryNode := False;
            end
            else if ((frmMainForm.trvBookmarks.Selected = nil) or (GetRootNode(frmMainForm.trvBookmarks.Selected) <> FHistoryListNode)) then
            begin
              Node := FHistoryListNode.getFirstChild;
              if (Node <> nil) then
                Node := FHistoryListNode.GetNextChild(Node);
            end else
            begin
              if Direction = 0 then
              begin
                if (frmMainForm.trvBookmarks.Selected.GetPrev = FHistoryListNode.getFirstChild) then
                  Node := frmMainForm.trvBookmarks.Selected.GetPrev
                else if (frmMainForm.trvBookmarks.Selected <> FHistoryListNode.getFirstChild) then
                  Node := frmMainForm.trvBookmarks.Selected.GetPrev;
              end
              else
              begin
                if (frmMainForm.trvBookmarks.Selected.GetNext = FHistoryListNode.getLastChild) then
                  Node := frmMainForm.trvBookmarks.Selected.GetNext
                else if (frmMainForm.trvBookmarks.Selected <> FHistoryListNode.getLastChild) then
                  Node := frmMainForm.trvBookmarks.Selected.GetNext;
              end;
            end;
          end;
          if (Node <> nil) then
          begin
            frmMainForm.trvBookmarks.Select(Node);
            frmMainForm.trvBookmarks.OnDblClick(frmMainForm.trvBookmarks);
          end;

        end);
  except
    bitfarmLog.Write(llNormal, ltException, 'SelectHistoryNode', Classname);
  end;
end;

procedure TbfaApplication.SelectNodeByID(tree: TbfaTreeView; arcid: Int64);
var
  node: TTreeNode;
  nodelist: TStringList;
  tempid: Int64;
  i: Integer;
begin

  node := tree.GetTreeNodeByID(arcid);

  if node <> nil then
    tree.SelectTreeNode(arcid)
  else
  begin
    if arcid <= High(aSysArc) then
    begin
      nodelist := TStringList.Create;
      nodelist.Insert(0, inttostr(arcid));
      tempid := arcid;
      if aSysArc[tempid].arcid = arcid then    //TreeNode ist zwar noch nicht geladen, sollte aber generell fr den User sichtbar sein
      begin
        while node = nil do
        begin
          if aSysArc[tempid].arcid = 0 then  // in einen toten Zweig gelaufen
            Break;

          nodelist.Insert(0, inttostr(aSysArc[tempid].LgrID));
          node := tree.GetTreeNodeByID(aSysArc[tempid].LgrID);
          tempid := aSysArc[tempid].LgrID;
        end;

        if nodelist.Count > 0 then
        begin
          for i := 0 to nodelist.Count - 1 do
            tree.SelectTreeNode(StrToInt64(nodelist[i]));
        end;
      end;
      FreeAndNil(nodelist);
    end;
  end;

end;

procedure TbfaApplication.MaximizePanel(pnl: TSpTBXCustomDockablePanel);
var
  Monitor: TRect;
begin
  try
    if ((TSpTBXDockablePanel(pnl).Parent.Name = 'dckFloating') and (TForm(TSpTBXDockablePanel(pnl).Parent.Parent).Active)) then
    begin
      if TbfaFloatingForm(TSpTBXDockablePanel(pnl).Parent.Parent).WindowState = wsMaximized then
        TbfaFloatingForm(TSpTBXDockablePanel(pnl).Parent.Parent).WindowState := wsNormal
      else
      begin
        TbfaFloatingForm(TSpTBXDockablePanel(pnl).Parent.Parent).WindowState := wsMaximized;
      end;
      GetActivePreview.bfaTlbPreview.sbmAutozoom.Click;
    end;
  except
  end;
end;

procedure TbfaApplication.DockSearchOptions(pnl: TSpTBXCustomDockablePanel);
begin
  try
    if frmMainForm.pnlSearchOptions.Parent.Name <> 'dckFloating' then
      frmMainForm.pnlSearchOptions.OnDockChanging(frmMainForm.pnlSearchOptions, False, nil)
    else
      frmMainForm.pnlSearchOptions.OnDockChanging(frmMainForm.pnlSearchOptions, False, frmMainForm.SpTBXMultiDock2);
  except
    //
  end;
end;

function TbfaApplication.CanSetFocus: Boolean;
begin
  result := True;
  try
    if frmMainForm.ActiveControl <> nil then
    begin
      if (frmMainForm.ActiveControl is TSpTBXEdit) or (frmMainForm.ActiveControl is TSpTBXComboBox) or (frmMainForm.ActiveControl is TSpTBXSpinEdit) then
        result := False;
    end;
  except
    result := True;
  end;
end;

procedure TbfaApplication.InEditMode(Docs: TList<TbfaDocument>; prev: TbfaPreview; AThread: TThread);
var
  i, TimID: Integer;
  req: TbfaRequest;
  msg, username: WideString;
  UserAction: PUserAction;
  haspreview, ReloadThumb: Boolean;
  docids: TStringList;
  addfield: TbfaAddField;
  statefield: TbfaStateField;
  OldDate: TDateTime;
  SPoolLoaded: Boolean;
  TmpStream: TMemoryStream;
  param: string;
  j, k, lastpos: Integer;
  scrollbox : TbfaScrollbox;
begin
  bitfarmLog.DebugBegin(llDebug, 'InEditMode', ClassName);
  try
    try
      param := '';
      if Docs.Count > 1 then
      begin
        for i := 1 to Docs.Count - 1 do
        begin
          if param = '' then
            param := IntToStr(Docs[i].Id)
          else
            param := param + ';' + IntToStr(Docs[i].Id);
        end;
      end;

      if not VarIsNull(Docs[0].ModifiedDate) then
        OldDate := TDateTime(Docs[0].ModifiedDate);

      req := TbfaRequest.Create;
      try
        req.ReqType := 'reqEdit';
        req.UserID := user.ID;
        req.Gdocid := Docs[0].Id;
        req.Profile := Profile;
        req.Parameter := param;
        if (CurrentView = tvkResub) and (PreviewContainer.ActiveItem = 0) then
          req.Addfields_Arcid := CurrentResubArchive.Arcid;
        if Docs[0].SymbolicArcID > 0 then
        begin
          req.Addfields_Arcid := Docs[0].SymbolicArcID;
          req.SymbolicArcID := Docs[0].SymbolicArcID;
        end;
        req.Lang := Lang;
        haspreview := Docs[0].haspreview;
        req.TimID := Docs[0].TimID;
        TimID := Docs[0].TimID;

        AThread.Synchronize(nil,
          procedure
          begin
            SPoolLoaded := Docs[0].ScanPoolViewLoaded;
            if (Docs[0].DocStream.Size > 0) then
            begin
              Docs[0].DocStream.Position := 0;
              TmpStream := TMemoryStream.Create;
              TmpStream.CopyFrom(Docs[0].DocStream, Docs[0].DocStream.Size);
            end;
          end);

        MainSocket.SendRequestToServer(req);

        req := MainSocket.ReceiveDoc(TbfaDocument(Docs[0]), AThread);
        if req = nil then
        begin
          bitfarmLog.Write(llDebug, ltError, 'Kein TRequest Objekt erhalten.', ClassName);
          Exit;
        end;

        if (req.ReqType = 'respDenied') or (req.ReqType = 'respEditDenied') then
        begin
          if req.UserID <> 0 then     // wenn es ein User auf Bearbeitung hat wird die userid geliefert, ansonsten hat man keine Berechtigung (Modify)
          begin
            Docs[0].EditmodeUserID := req.UserID;
            username := DBGetUserName(Docs[0].EditmodeUserID);
            msg := Format(_('Dokument in Bearbeitung von %s'), [username])
//            msg := Format(_('Dokument in Bearbeitung von %s'), [IntToStr(Docs[0].Id), username])
          end
          else
            msg := _('Sie haben keine Berechtigung auf das Dokument.');

          BfShowMessage(msg, AThread);
          bitfarmLog.Debug(llDebug, msg, ClassName);
          RefreshGrid(AThread);
          AThread.Synchronize(nil,
            procedure
            begin
              SetDocState(Docs[0]);
            end);
          Exit;
        end
        else if req.ReqType = 'respAuthError' then
        begin
          BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
          UserAction := CreateUserAction;
          UserAction^.ActionName := 'actRelogin';
          MainThread.Add(UserAction);
          Exit;
        end
        else if req.ReqType = 'respDocError' then
        begin
          msg := _('Das Dokument konnte nicht geladen werden.') + #13#10 + req.DataString;
          BfShowMessage(msg, AThread);
          bitfarmLog.Debug(llDebug, msg, ClassName);
          Exit;
        end
        else if req.ReqType = 'respAccess' then
        begin
          if not Docs[0].Loaded then
            Docs[0].Loaded := True;
          Docs[0].InEditMode := True;
          Docs[0].haspreview := haspreview;
          Docs[0].TimID := TimID;
          if prev <> nil then
          begin
            ReloadThumb := False;
            if not VarIsNull(Docs[0].ModifiedDate) and (CompareDateTime(OldDate, TDateTime(Docs[0].ModifiedDate)) <> EqualsValue) then
            begin
              ReloadDocument(Docs[0], False, AThread); // muss der Voransicht auch neugeladen werden!
              Docs[0].InEditMode := True;
              Docs[0].haspreview := haspreview;
              Docs[0].TimID := TimID;
              prev.RefreshThumbnailView(AThread, Docs[0], prev.SingleView.img_DocView.IO.Params.ImageIndex);
              AThread.Synchronize(nil,
                procedure
                begin
                  prev.ShowPage(Docs[0], prev.SingleView.img_DocView.IO.Params.ImageIndex);
                end);
              ReloadThumb := True;
            end
            else
            begin
              if (SPoolLoaded) and (Docs[0].ScanPoolView <> nil) and (not Docs[0].ScanPoolViewLoaded) then
                Docs[0].ScanPoolViewLoaded := True;
              if (Docs[0].DocStream.Size = 0) then
              begin
                if (TmpStream <> nil) and (TmpStream.Size > 0) then
                begin
                  try
                    AThread.Synchronize(nil,
                      procedure
                      begin
                        TmpStream.Position := 0;
                        Docs[0].DocStream.CopyFrom(TmpStream, TmpStream.Size);
                      end);
                  finally
                    FreeAndNil(TmpStream);
                  end;
                end;
              end;
              ReloadLinks(Docs[0]);  //02.12.2019 SJ bfacrm:ticket__show__21289
            end;
            AThread.Synchronize(nil,
              procedure
              begin
                ShowDocumentProperties(Docs[0], prev);
              end);
            RefreshDocumentInPreviews(AThread, TbfaDocument(Docs[0]), prev, nil, False, False, ReloadThumb);
          end else
          begin
            if (Docs[0].DocStream.Size = 0) then
            begin
              if (TmpStream <> nil) and (TmpStream.Size > 0) then
              begin
                try
                  AThread.Synchronize(nil,
                    procedure
                    begin
                      TmpStream.Position := 0;
                      Docs[0].DocStream.CopyFrom(TmpStream, TmpStream.Size);
                    end);
                finally
                  FreeAndNil(TmpStream);
                end;
              end;
            end;
          end;

          // <!-- SJ 10.11.2021 - bei Multiauswahl prfen ob alle Dokumente in Edit sind, sonst Meldung
          if (Docs.Count > 1) then
          begin
            try
              docids := TStringList.Create;
              docids.Delimiter := ';';
              docids.StrictDelimiter := True;
              docids.DelimitedText := req.Parameter;
              // Docs hat auch req.gdocid, req.Parameter jedoch nicht
              // siehe oben: for i := 1 to Docs.Count - 1 do
              // deswegen .Count - 1
              if docids.Count < Docs.Count - 1 then
                AThread.Synchronize(nil,
                  procedure
                  begin
                    BfMessageDlg(_('Mindestens ein Dokument konnte nicht in Bearbeitung genommen werden.'), mtInformation, [mbOK]);
                  end);
            finally
              FreeAndNil(docids);
            end;
          end;
          // SJ 10.11.2021 - bei Multiauswahl prfen ob alle Dokumente in Edit sind, sonst Meldung -->

          bitfarmLog.Write(llDebug, ltDebug, 'bei Multiselect alle Dokumente in Editmode setzen', ClassName);
          if (req.Parameter <> '') and (Docs.Count > 0) then // bei Multiselect alle Dokumente in Editmode setzen
          begin
            docids := TStringList.Create;
            try
              docids.Delimiter := ';';
              docids.StrictDelimiter := True;
              docids.DelimitedText := req.Parameter;
              for i := 1 to Docs.Count - 1 do
              begin
                if docids.IndexOf(IntToStr(Docs[i].Id)) > -1 then
                  Docs[i].InEditMode := True;
              end;
            finally
              FreeAndNil(docids);
            end;
          end;
              // falls das CurrentAddfield keine Komponente hat, hinzufgen,
              // dann alle Felder reseten
          bitfarmLog.Write(llDebug, ltDebug, 'alle Felder reseten', ClassName);
          lastpos := 0;
          for j := 0 to aCurrentAddfields.Count - 1 do
          begin
            try
              AThread.Synchronize(nil,
                procedure
                begin
                  if aCurrentAddfields[j].Component = nil then
                  begin
                    aCurrentAddfields[j].Component := DoCreateAddfieldComp(frmMainForm.scrbxViewerAddfields, aCurrentAddfields[j].Id, j, UseIndexing, lastpos);
                    if Assigned(aCurrentAddfields[j].Component) then
                      aCurrentAddfields[j].Component.OnValueSet := aCurrentAddfields[j].SetValue;
                  end;

                      // wenn das Feld nicht verndert wurde, oder zum Suchen verndert wurde
                  if (not aCurrentAddfields[j].Component.Modified) or (aCurrentAddfields[j].ModifiedSearch) then
                  begin
                    if Assigned(aCurrentAddfields[j].Component) then
                      aCurrentAddfields[j].Component.Reset;
                    aCurrentAddfields[j].Modified := False;
                    aCurrentAddfields[j].ModifiedSearch := False;
                  end;
                end);
            except
              bitfarmLog.Write(llNormal, ltException, 'InEditMode - AddFields', ClassName);
            end;

          end;

              // wir bernehmen in CurrentFields/CurrentStatefields die Werte des aktuellen Dokuments
          bitfarmLog.Write(llDebug, ltDebug, 'aktuelle Werte bernehmen', ClassName);
          for j := 0 to aCurrentAddfields.Count - 1 do
          begin
            bitfarmLog.Write(llDebug, ltDebug, 'vor in Editmode ' + IntToStr(j), ClassName);
            AThread.Synchronize(nil,
              procedure
              begin
                aCurrentAddfields[j].Component.EditMode := True;
              end);
            bitfarmLog.Write(llDebug, ltDebug, 'nach in Editmode', ClassName);
            for k := 0 to Docs[0].AddFields.Count - 1 do
            begin
              if Docs[0].AddFields[k].Id = aCurrentAddfields[j].Id then  //Feld gibt es schon
              begin
                if Assigned(aCurrentAddfields[j].Component) then
                begin
                  AThread.Synchronize(nil,
                    procedure
                    begin
                      // wenn das Feld nicht verndert wurde, oder zum Suchen verndert wurde
                      // oder es ist readOnly oder hat Schreibrecht(einmalig) und hat schon einen Value
                      if (not aCurrentAddfields[j].Component.Modified) or (aCurrentAddfields[j].ModifiedSearch) or (aCurrentAddfields[j].Component.Rights and 1 = 1) or ((aCurrentAddfields[j].Component.Rights and 2 = 2) and (aCurrentAddfields[j].Component.OldValue <> '')) then
                      begin
                        aCurrentAddfields[j].Modified := False;
                        aCurrentAddfields[j].Component.Modified := False;
                        if VarIsNull(Docs[0].AddFields[k].Value) then
                          aCurrentAddfields[j].Component.Value := ''
                        else
                          aCurrentAddfields[j].Component.Value := Docs[0].AddFields[k].Value;
                      end
                      else  // wenn es vom User verndert wurde aktualisieren wir es nur, wenn in der Zwischenzeit
                      begin // das Feld keinen neuen Wert erhalten hat
                        if VarIsNull(Docs[0].AddFields[k].Value) then
                        begin
                          if aCurrentAddfields[j].Component.OldValue <> '' then
                          begin
                            aCurrentAddfields[j].Component.Value := '';
                            aCurrentAddfields[j].Modified := False;
                            aCurrentAddfields[j].Component.Modified := False;
                            aCurrentAddfields[j].Component.SetColor(gclRed);
                          end
                        end
                        else
                        begin
                          if Docs[0].AddFields[k].Value <> aCurrentAddfields[j].Component.OldValue then
                          begin
                            aCurrentAddfields[j].Component.Value := Docs[0].AddFields[k].Value;
                            aCurrentAddfields[j].Modified := False;
                            aCurrentAddfields[j].Component.Modified := False;
                            aCurrentAddfields[j].Component.SetColor(gclRed);
                          end;
                        end;
                      end;
                    end);

                  Break;
                end;
                Break;
              end;
            end;
          end;

          AThread.Synchronize(nil,
          procedure
          begin
            frmMainForm.dteSearch.Editmode := True; //bfacrm:ticket__show__21312
          end);

          // falls das CurrentStatefield keine Komponente hat, hinzufgen,
          // dann alle Felder reseten
          bitfarmLog.Write(llDebug, ltDebug, 'alle statefield reseten', ClassName);

          for j := 0 to aCurrentStatefields.Count - 1 do
          begin
            try
              if aCurrentStatefields[j].Id > Length(aStatefields) then
                Break;

              AThread.Synchronize(nil,
                procedure
                begin
                  if aCurrentStatefields[j].Component = nil then
                  begin
                    aCurrentStatefields[j].Component := TBfaStatefieldComp.Create(frmMainForm.tlbStatefields, 0, aStatefields[aCurrentStatefields[j].Id].Displayname);
                    aCurrentStatefields[j].Component.OnValueSet := aCurrentStatefields[j].SetValue;
                  end;

                  // wenn das Feld nicht verndert wurde, oder zum Suchen verndert wurde
                  if (not aCurrentStatefields[j].Component.Modified) or (aCurrentStatefields[j].ModifiedSearch) then
                  begin
                    if Assigned(aCurrentStatefields[j].Component) then
                      aCurrentStatefields[j].Component.ClearValue;
                    aCurrentStatefields[j].modified := False;
                    aCurrentStatefields[j].ModifiedSearch := False;
                  end;
                end);
            except
              bitfarmLog.Write(llNormal, ltException, 'InEditMode - StateFields', ClassName);
            end;
          end;

          bitfarmLog.Write(llDebug, ltDebug, 'statefields aktuelle Werte bernehmen', ClassName);

          for j := 0 to aCurrentStatefields.Count - 1 do
          begin
            aCurrentStatefields[j].Component.EditMode := True;
            for k := 0 to Docs[0].StateFields.Count - 1 do
            begin
              if Docs[0].StateFields[k].Id = aCurrentStatefields[j].Id then  //Feld gibt es schon
              begin
                AThread.Synchronize(nil,
                  procedure
                  begin
                    if (not aCurrentStatefields[j].Component.Modified) or (aCurrentStatefields[j].ModifiedSearch) or (aCurrentStatefields[j].Component.Rights and 1 = 1) or ((aCurrentStatefields[j].Component.Rights and 2 = 2) and (aCurrentStatefields[j].Component.OldValue <> fsSet)) then
                    begin
                      if Docs[0].StateFields[k].Value then
                        aCurrentStatefields[j].Component.Value := fsSet
                      else
                        aCurrentStatefields[j].Component.Value := fsNone;
                    end
                    else  // wenn es vom User verndert wurde aktualisieren wir es nur, wenn in der Zwischenzeit
                    begin     // das Feld keinen neuen Wert erhalten hat

                      if ((Docs[0].StateFields[k].Value = False) and (aCurrentStatefields[j].Component.OldValue <> fsNone)) or ((Docs[0].StateFields[k].value = True) and (aCurrentStatefields[j].Component.OldValue <> fsSet)) then
                      begin
                        if Docs[0].StateFields[k].Value then
                          aCurrentStatefields[j].Component.Value := fsSet
                        else
                          aCurrentStatefields[j].Component.Value := fsUnset;
                        aCurrentStatefields[j].modified := False;
                      end;
                    end;
                  end);

                Break;
              end;
            end;
          end;

          bitfarmLog.Write(llDebug, ltDebug, 'onchange zuweisen fr auswahlfelder', ClassName);
          for i := 0 to aCurrentAddfields.Count - 1 do
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                if (aCurrentAddfields[i].Component.Modified or aCurrentAddfields[i].ModifiedSearch) then
                begin
                  if (aCurrentAddfields[i].Typ in [2, 11]) and ((aCurrentAddfields[i].options and cAddfieldOptStrict) = cAddfieldOptStrict) then
                    aCurrentAddfields[i].Component.compComboBox.Properties.OnChange(aCurrentAddfields[i].Component.compComboBox)
                  else if (aCurrentAddfields[i].Typ = 3) and ((aCurrentAddfields[i].options and cAddfieldOptStrict) = cAddfieldOptStrict) then
                    aCurrentAddfields[i].Component.compCheckedCombo.Properties.OnChange(aCurrentAddfields[i].Component.compCheckedCombo);
                end;
              end);
          end;

          bitfarmLog.Write(llDebug, ltDebug, 'Scrollbox update und refreshGrid', ClassName);
          AThread.Synchronize(nil,
            procedure
            begin
              frmMainForm.scrbxViewerAddfields.Update;
              frmMainForm.tlbStatefields.Update;
              if Docs[0].InEditIDs <> '' then
                frmMainForm.grdResultListDevExView.FInEditMode.CommaText := Docs[0].InEditIDs
              else
                frmMainForm.grdResultListDevExView.FInEditMode.Clear;
            end);
          if not ((FSearchObj.SearchType in [1,2,3]) and FSearchObj.DontRefreshDataSet) then
            RefreshGrid(AThread);
        end;

        bitfarmLog.Write(llDebug, ltDebug, 'FLastFocusedAddfield', ClassName);
        try
          if frmMainForm.tabAddfields2.Visible and (frmMainForm.tcSearch.ActiveTabIndex = 2) then
            scrollbox := frmMainForm.scrbxAddfields2
          else
            scrollbox := frmMainForm.scrbxViewerAddfields;

          if ((FLastFocusedAddfield <> nil) and (Screen.ActiveControl <> FLastFocusedAddfield)) then
          begin
            AThread.Synchronize(nil,
            procedure
            begin
              if (scrollbox.ComponentCount > 0) then
              begin
                // if the Addfield is scrolled out of the visible area
                if ((TcxControl(TbfaAddfieldComp(FLastFocusedAddfield).comp).ClientOrigin.Y)
                             < (scrollbox.ClientOrigin.Y))
                   or ((TcxControl(TbfaAddfieldComp(FLastFocusedAddfield).comp).ClientOrigin.Y)
                             > (scrollbox.ClientOrigin.Y + scrollbox.Height)) then
                begin
                  SetFocusToFirstVisibleAddfield;
                end else
                begin
                  if (TbfaAddfieldComp(FLastFocusedAddfield).AddfieldType = zfld13_Grid) and
                      TcxControl(TbfaAddfieldComp(FLastFocusedAddfield).compGrid.Grid).Enabled then
                    TcxControl(TbfaAddfieldComp(FLastFocusedAddfield).compGrid.Grid).SetFocus
                  else
                    if TcxControl(TbfaAddfieldComp(FLastFocusedAddfield).comp).Enabled and
                      TcxControl(TbfaAddfieldComp(FLastFocusedAddfield).comp).Visible then
                        TcxControl(TbfaAddfieldComp(FLastFocusedAddfield).comp).SetFocus;

                  bitfarmLog.Write(llDebug, ltDebug, 'SetFocus: ' + TbfaAddfieldComp(FLastFocusedAddfield).Dispname, ClassName);
                end;
              end;
            end);
          end else if (scrollbox.VertScrollbar.Position > 0) then
          begin
            bitfarmLog.Write(llDebug, ltDebug, 'SetFocusToFirstVisibleAddfield', ClassName);
            AThread.Synchronize(nil,
            procedure
            begin
              SetFocusToFirstVisibleAddfield;
            end);
          end else
            SetSearchTabActive(AThread);

        except
          bitfarmLog.Write(llDebug, ltException, 'setting focus failed', ClassName);
        end;

        if (bitfarmApp.GetActivePreview <> nil) and
           (bitfarmApp.LastUsedAnnoTool <> '') and
           ViewerOptions.EditorOptions.RememberLastTool then
        begin
          // TODO SJ: bfacrm:ticket__show__29724
          //  prfen ob der Synchronize hier sinnig ist.
          //  Treten danach noch die Probleme mit den Grafikfehlern auf der Preview auf?
          AThread.Synchronize(nil,
          procedure
          begin
            bitfarmLog.Write(llDebug, ltDebug, 'RememberLastTool', ClassName);
            if (bitfarmApp.LastUsedAnnoTool <> bitfarmApp.GetActivePreview.tbi_stampdialog.Name) then
            begin
              var APreview: TbfaPreview;
              APreview := bitfarmApp.GetActivePreview;

              for var j := 0 to APreview.AnnoToolbar.Items.Count - 1 do
              begin
                // SubMenuItems mssen rekursiv durchlaufen werden.
                if APreview.AnnoToolbar.Items[j] is TSpTBXSubmenuItem then
                begin
                  var AItem: TSpTBXItem;
                  AItem := FindToolbarSubmenuItemByName(LastUsedAnnoTool, APreview.AnnoToolbar.Items[j]);
                  if AItem <> nil then
                  begin
                    AItem.Click;
                    Break;
                  end;
                end else if APreview.AnnoToolbar.Items[j] is TSpTBXItem then
                begin
                  if (LastUsedAnnoTool = APreview.AnnoToolbar.Items[j].Name) then
                  begin
                    APreview.AnnoToolbar.Items[j].Click;
                    Break;
                  end;
                end;
              end;
            end else if (bitfarmApp.LastSelectedStamp <> '') then
            begin
              bitfarmApp.GetActivePreview.UnCheckAllGraphicTools;
              bitfarmApp.GetActivePreview.tbi_normalmouse.Checked := False;
//21.11.2023 bfacrm:ticket__show__36926              bitfarmApp.GetActivePreview.tbi_stampdialog.Checked := True;
              bitfarmApp.GetActivePreview.SingleView.LoadStamp(bitfarmApp.LastSelectedStamp);
            end;
          end);
        end;
      finally
        FreeAndNil(req);
      end;
    except
      bitfarmLog.Write(llDebug, ltException, 'InEditMode', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'InEditMode', ClassName);
  end;
end;

procedure TbfaApplication.SetSearchTabActive(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'SetSearchTabActive', ClassName);
  try
    try
      // da wir schon innerhalb eines Threads aufgerufen werden, mssen wir diese Funktionen nicht wieder durch die ThreadQueue schicken, sondern knnen sie direkt aufrufen
      if frmMainForm.tcSearch.ActiveTab = frmMainForm.tabSearchStandard then
        Alt6(AThread)
      else if (frmMainForm.tcSearch.ActiveTab = frmMainForm.tabSearchAddfields)
             or (frmMainForm.tcSearch.ActiveTab = frmMainForm.tabSearchAddfields2) then
        SetFocusToFirstAddfield(AThread)
      else if frmMainForm.tcSearch.ActiveTab = frmMainForm.tabSearchLinks then
        Alt8(AThread);
    except
      bitfarmLog.Write(llDebug, ltException, 'SetSearchTabActive', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetSearchTabActive', ClassName);
  end;
end;

procedure TbfaApplication.ShowDocumentProperties(Doc: TbfaDocument; prev: TbfaPreview);
begin
  bitfarmLog.DebugBegin(llDebug, 'ShowDocumentProperties', ClassName);
  try
    try
      if prev <> nil then
      begin
         if (CurrentView <> tvkImporter)then           // 10/20/2020 bfacrm:ticket__show__24402
            prev.Paint;                                // 10/20/2020 bfacrm:ticket__show__24402

        prev.SetAnnoToolBar(True);
        prev.SetActions;

        if (Doc <> nil) and (Doc.RevSave) then
        begin
          prev.itmAuditProof.Action := nil;
          prev.itmAuditProof.Enabled := True;
          prev.itmAuditProof.ImageIndex := Integer(icoidx_lock);
          prev.itmAuditProof.Hint := _('Das Dokument ist revisionssicher abgelegt.');
        end
        else
        begin
          prev.itmAuditProof.Action := frmMainForm.actAuditProof;
          prev.itmAuditProof.ImageIndex := Integer(icoidx_lock_no);
          if (Doc <> nil) and (not Doc.InEditMode) then
            prev.itmAuditProof.Hint := _('Die Originaldatei ist bearbeitbar.')
          else
            prev.itmAuditProof.Hint := _('Legt das aktuelle Dokument revisionssicher im Archiv ab.');
          prev.itmAuditProof.Enabled := (Doc <> nil) and (Doc.InEditMode) and (Doc.ID <> -1);
        end;

        if (Doc <> nil) and (Doc.SymbolicArcID <> Doc.ArcID) and
           (
             (Doc.SymbolicArcID >= 0)
             or
//04.07.2024             ((CurrentArchive.Arcid <> Doc.Arcid) and (pos(IntToStr(CurrentArchive.Arcid), Doc.HasSymlinks) > 0))
             ((Doc.SymbolicArcID >= 0) and (CurrentArchive.Arcid <> Doc.Arcid) and (pos(IntToStr(CurrentArchive.Arcid), Doc.HasSymlinks) > 0))
           ) then
        begin
          prev.itmSymLink.Action := nil;
          prev.itmSymLink.Enabled := True;
          prev.itmSymLink.ImageIndex := Integer(icoidx_symbolic_link);
          prev.itmSymLink.Hint := _('Das Dokument ist ein Symbolic Link.');
        end
        else
        begin
          prev.itmSymLink.Action := nil;
          prev.itmSymLink.Enabled := True;
          prev.itmSymLink.ImageIndex := Integer(icoidx_original_view);
          prev.itmSymLink.Hint := _('Original Dokument');
        end;
        SetAnnoLayer(Doc, prev);
      end
      else
        frmMainForm.DisableMainFormActions;

      SetDocState(Doc);

      if (CurrentView = tvkResub) then
        ShowresubFields(Doc, frmMainForm.fraResub);

      if ((Doc <> nil) and (not Doc.InEditMode)) then
      begin
        ResetButtons(True);
        if prev <> nil then
        begin
          prev.bfaTlbStandard.tlbStandardSave.Caption := '';
          prev.bfaTlbStandard.tlbStandardSave.Action := prev.actInProgress;
          // SJ 11.10.2022 - bfacrm:ticket__show__31264
          bitfarmApp.ShowFtxPos(prev.SingleView.img_DocView, Doc, prev, prev.ActivePage);
        end;
      end
      else if ((Doc <> nil) and (Doc.InEditMode)) then
      begin
        if prev <> nil then
        begin
          prev.DeleteFtxPosLayer;
          SetSaveButton(prev);
          prev.bfaTlbStandard.tlbStandardSave.Action := frmMainForm.actSave;
          prev.bfaTlbStandard.tlbStandardSave.Caption := '';
          //04.09.2024 SD <--bfacrm:ticket__show__39649
          DateDeletionSearch := False;
          //Bei der Suche nach dem Lschungsdatum muss das Lschungsdatum angezeigt werden.
          if ((CurrentView = tvkViewer) or (CurrentView = tvkResub)) and (frmMainForm.tbiSoExpired.Checked) then
            frmMainForm.dteSearch.Value := Doc.Expired;
          //04.09.2024 SD <--bfacrm:ticket__show__39649
        end;
      end
      else if (Doc = nil) or (not Doc.Loaded) then
      begin
        ResetButtons(True);
        if prev <> nil then
        begin
          prev.bfaTlbStandard.tlbStandardSave.Caption := '';
          prev.bfaTlbStandard.tlbStandardSave.Action := prev.actInProgress;
        end;
      end;

      if (Doc <> nil) and ((CurrentView = tvkViewer) or
         (CurrentView = tvkResub)) and (frmMainForm.tbiSoExpired.Checked)
      then
      begin
        //03.09.2024 SD -->bfacrm:ticket__show__39649 das Lschdatum nur anzeigen, wenn der Benutzer nicht versucht, die Suche zu benutzen
//          frmMainForm.dteSearch.Modified := False;
//          frmMainForm.dteSearch.ClearValue;
//          frmMainForm.dteSearch.Value := Doc.Expired;
        if not DateDeletionSearch or ((frmMainForm.dteSearch.compDateLow.Text = '') and (frmMainForm.dteSearch.compDateHigh.Text = '')) then
        begin
          frmMainForm.dteSearch.Modified := False;
          frmMainForm.dteSearch.ClearValue;
          frmMainForm.dteSearch.Value := Doc.Expired;
        end;
        //03.09.2024SD <--bfacrm:ticket__show__39649
      end
      else
      begin
      // SJ 03.08.2022 - nicht wenn modified. Sonst knnen keine Folge-Suchen durchgefhrt werden
//        if ((CurrentView = tvkViewer) or (CurrentView = tvkResub)) and (frmMainForm.tbiSoExpired.Checked) then
        if ((CurrentView = tvkViewer) or (CurrentView = tvkResub)) and
           (frmMainForm.tbiSoExpired.Checked) and (not frmMainForm.dteSearch.Modified) {04.09.2024SD <--bfacrm:ticket__show__39649} and (not frmMainForm.dteSearch.ModifiedHigh) then
        begin
//          frmMainForm.dteSearch.Modified := False; // SJ 03.08.2022
          frmMainForm.dteSearch.ClearValue;
          frmMainForm.dteSearch.Value := '';
        end;
      end;

      SetStandardStatusInfo(nil);
      if Doc <> nil then
        SetStatusBarID(Doc.ArcID, Doc.ID, '', nil);
      //12.07.2024 SD -->bfacrm:ticket__show__31605
      if (prev <> nil) then
        if prev.Floating then
          bitfarmApp.SetStdStsInfo(TbfaFloatingForm((TSpTBXDockablePanel(prev.Owner).Parent).Parent).itmFloatingInfo, nil)
        else
          bitfarmApp.SetStdStsInfo(frmMainForm.itmInfo, nil);
      //12.07.2024 SD <--bfacrm:ticket__show__31605
//      frmMainForm.ResetNotificationBar(nil);  //29.08.2024 SD <--bfacrm:ticket__show__39648

    except
      bitfarmLog.Write(llDebug, ltException, 'ShowDocumentProperties', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ShowDocumentProperties', ClassName);
  end;
end;

procedure TbfaApplication.ShowResubFields(Doc: TbfaDocument; var fraResub : TfraResub);
var
  i, k: Integer;
  found: Boolean;
  name: string;
begin
  bitfarmLog.DebugBegin(llDebug, 'ShowResubFields', 'bfaProcessing');
  try
    fraResub.LoadResub := True;
    try
      if (Doc <> nil) then
      begin
        for i := 0 to Doc.Workflows.Count - 1 do
        begin
          if Doc.Workflows[i].TimID = Doc.TimID then  // passenden Workflow in der Liste gefunden
          begin
            fraResub.edtResubInfo.Text := Doc.Workflows[i].Info;
            fraResub.edtResubComment.Text := Doc.Workflows[i].Comment;
//22.02.2022            if ResubKind = rkMyTasks then
            if fraResub.ResubKind = rkMyTasks then
              fraResub.cxDateEdit1.Date := Doc.Workflows[i].Date
//22.02.2022            else if ResubKind = rkController then
            else if fraResub.ResubKind = rkController then
            begin
              name := '';
              if Doc.Workflows[i].groupid > 0 then
                name := grouplist[grouplist.IndexOfObject(TObject(Doc.Workflows[i].groupid))]
              else
                name := userlist[userlist.IndexOfObject(TObject(Doc.Workflows[i].UseridWork))];
              fraResub.cbbUserGroups.ItemIndex := fraResub.cbbUserGroups.Items.IndexOf(name);
            end;
            if (Doc.Workflows[i].Status and 2) = 2 then
              fraResub.tbiResubWork.Color := gclYellow
            else
              fraResub.tbiResubWork.Color := cColorWhite;
            Break;
          end;
        end;
      end
      else
      begin
        fraResub.edtResubInfo.Text := '';
        fraResub.edtResubComment.Text := '';
        fraResub.cxDateEdit1.Text := '';
        fraResub.tbiResubWork.Color := cColorWhite;
        fraResub.cbbUserGroups.ItemIndex := -1;
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'ShowResubFields', 'bfaProcessing');
    end;
  finally
    fraResub.LoadResub := False;
    bitfarmLog.DebugEnd(llDebug, 'ShowResubFields', 'bfaProcessing');
  end;
end;

procedure TbfaApplication.ResetDocumentProperties;
begin
  bitfarmLog.DebugBegin(llDebug, 'ResetDocumentProperties', ClassName);
  try
    try
      ShowDocumentProperties(nil, nil);
      ResetButtons(True);
    except
      bitfarmLog.Write(llDebug, ltException, 'ResetDocumentProperties', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ResetDocumentProperties', ClassName);
  end;
end;

// Setzt die Zusatz und Statusfelder zurck auf den ursprnglichen Wert
//procedure TbfaApplication.ResetFields(AThread: TThread); // SJ 17.12.2019  bfacrm:ticket__show__18767
procedure TbfaApplication.ResetFields(AThread: TThread; btnResetClick: Boolean = False; AfterCreateFields: Boolean = False);
begin
  bitfarmLog.DebugBegin(llDebug, 'ResetFields', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        var
          i, j: Integer;
        begin
          // erst CurrentFields resetten
          for i := 0 to aCurrentAddfields.Count - 1 do
          begin
            if aCurrentAddfields[i].Component <> nil then
            begin
              if not AfterCreateFields then //21.03.2023 im CreateFields gibt es auch, deswegen luft sonst 2mal  bfacrm:ticket__show__34443
              aCurrentAddfields[i].Component.Reset;
              aCurrentAddfields[i].value := aCurrentAddfields[i].Component.Value;
              aCurrentAddfields[i].ValueHigh := aCurrentAddfields[i].Component.ValueHigh;
            end;
            aCurrentAddfields[i].modified := False;
            aCurrentAddfields[i].ModifiedSearch := False;
          end;

          if (CurrentView = tvkImporter) and (not btnResetClick) then
          begin
            try
              for i := 0 to aCurrentAddfields.Count - 1 do
              begin
                if aCurrentAddfields[i].Component <> nil then
                begin
                  if aImportValues[CurrentImportArchive.Arcid, 0].Field <> '' then
                  begin
                    for j := Low(aImportValues[CurrentImportArchive.Arcid]) to High(aImportValues[CurrentImportArchive.Arcid]) do
                    begin
                      if aCurrentAddfields[i].name = aImportValues[CurrentImportArchive.Arcid, j].Field then
                      begin
                        aCurrentAddfields[i].Component.Value := aImportValues[CurrentImportArchive.Arcid, j].value;
                        aCurrentAddfields[i].value := aCurrentAddfields[i].Component.Value;
                        aCurrentAddfields[i].Component.Modified := True;
                        aCurrentAddfields[i].modified := True;
                        aCurrentAddfields[i].ModifiedSearch := True;
                        Break;
                      end;
                    end;
                  end;
                end;
              end;
            except
              bitfarmLog.Write(llNormal, ltException, 'ResetImporterFields - FillImporterValues', ClassName);
            end;
          end;

          // erst CurrentStatefields resetten
          for i := 0 to aCurrentStatefields.Count - 1 do
          begin
            if aCurrentStatefields[i].Component <> nil then
            begin
              aCurrentStatefields[i].Component.Reset;
              aCurrentStatefields[i].value := aCurrentStatefields[i].Component.Value = fsSet;
            end;
            aCurrentStatefields[i].modified := False;
            aCurrentStatefields[i].ModifiedSearch := False;
          end;
          frmMainForm.scrbxViewerAddfields.Update;
          frmMainForm.tlbStatefields.Update;
        end);

    except
      bitfarmLog.Write(llNormal, ltException, 'ResetFields', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ResetFields', ClassName);
  end;
end;

procedure TbfaApplication.SetSaveButton(prev: TbfaPreview);
begin
  bitfarmLog.DebugBegin(llDebug, 'SetSaveButton', ClassName);
  try
    try
      if prev <> nil then
      begin
        prev.SetSaveAction(True);
//        frmMainForm.btnSave.Caption := ''; // SJ 09.11.2021 - sollte ber Action.Caption laufen...
        frmMainForm.btnSave.Action := frmMainForm.actSave;
        frmMainForm.btnSave.Enabled := True and frmMainForm.actInProgress.Enabled; // -->bfacrm:ticket__show__24078
        frmMainForm.btnCancel.Enabled := True;

        prev.bfaTlbStandard.tlbStandardSave.Action := frmMainForm.actSave;
        prev.bfaTlbStandard.tlbStandardSave.Caption := '';
      end;
    except
      bitfarmLog.Write(llDebug, ltException, 'SetSaveButton', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetSaveButton', ClassName);
  end;
end;

procedure TbfaApplication.ResetButtons(Enable: Boolean);
begin
  bitfarmLog.DebugBegin(llDebug, 'ResetButtons', ClassName);
  Enable := Enable or (FPreviewContainer.ActiveItem <> FPreviewContainer.ViewerItem.Panel.Tag);

  try
    try
      frmMainForm.btnSave.Action := nil;
      frmMainForm.btnSave.ImageIndex := Integer(icoidx_edit);
      frmMainForm.btnSave.Caption := sCaptionModify;
      frmMainForm.btnSave.Hint := _('Bearbeiten (F2)');
      frmMainForm.btnSave.OnClick := frmMainForm.btnInProgressClick;
      frmMainForm.btnSave.Enabled := Enable and frmMainForm.actInProgress.Enabled;
      frmMainForm.btnCancel.Enabled := False;
    except
      bitfarmLog.Write(llDebug, ltException, 'ResetButtons', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ResetButtons', ClassName);
  end;
end;

procedure TbfaApplication.ExpandAll(TV: TbfaTreeView; AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'ExpandAll', ClassName);
  try
    try
      try
        TV.Items.BeginUpdate;
        TV.SkipExpand := True; // OnExpanding wegen stndigem SaveToINI langsam
        TV.Items[0].Expand(True);
      finally
        TV.SkipExpand := False;
        TV.Items.EndUpdate;
        TV.SaveToINI;
      end;
//      TV.Items[0].Expand(True);
    except
      bitfarmLog.Write(llDebug, ltException, 'ExpandAll', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ExpandAll', ClassName);
  end;
end;

procedure TbfaApplication.ExpandLastBookmarkNodes;
var
  iniFile: TIniFile;
  lstExpanededBookmarks: TStringList;
  I: Integer;
begin
  try
    try
      bitfarmLog.DebugBegin(llDebug, 'ExpandLastBookmarkNodes', ClassName);
      inifile := TIniFile.Create(BD.AppdataBitfarmPd + 'Viewer.ini');

      lstExpanededBookmarks := TStringList.Create;
      lstExpanededBookmarks.Delimiter := ';';
      lstExpanededBookmarks.Duplicates := dupIgnore;
      lstExpanededBookmarks.DelimitedText := inifile.ReadString('TreeView', 'ExpandedBookmarks', '');

      for I := 0 to frmMainForm.trvBookmarks.Items.Count -1 do
      begin
        if TObject(frmMainForm.trvBookmarks.Items[I].Data) is TbfaNodeInfo then
          if lstExpanededBookmarks.IndexOf(TbfaNodeInfo(frmMainForm.trvBookmarks.Items[I].Data).GUID) <> -1 then
            frmMainForm.trvBookmarks.Items[I].Expand(False);
      end;
    except
      bitfarmLog.Write(llDebug, ltException, 'ExpandLastBookmarkNodes', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ExpandLastBookmarkNodes', ClassName);
    if Assigned(iniFile) then
      iniFile.Free;
    if Assigned(lstExpanededBookmarks) then
      lstExpanededBookmarks.Free;
  end;
end;

procedure TbfaApplication.CollapseAll(TV: TbfaTreeView; AThread: TThread);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'CollapseAll', ClassName);
  try
    try
      try
        TV.Items.BeginUpdate;
        TV.SkipExpand := True; // OnExpanding wegen stndigem SaveToINI langsam
        TV.Items[0].Collapse(True)
      finally
        TV.SkipExpand := False;
        TV.Items.EndUpdate;
        TV.SaveToINI;
      end;
//      TV.Items[0].Collapse(True);

      UserAction := CreateUserAction;
      UserAction^.ActionName := 'actChangeArchive';
      UserAction^.params.Add(GetEnumName(TypeInfo(TbfaViewKind), Integer(TV.ViewKind)));
      UserAction^.params.Add(IntToStr(PbfaInt64(TV.Items[0].Data).value));
      UserAction^.params.Add(GetEnumName(TypeInfo(TbfaViewKind), integer(CurrentView)));
      UserAction^.objects.Add(TV.Items[0]);
      FMainThread.Add(UserAction);
    except
      bitfarmLog.Write(llDebug, ltException, 'CollapseAll', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CollapseAll', ClassName);
  end;

end;

procedure TbfaApplication.ChangeArchiveAction(TV: TbfaTreeView; Node: TTreeNode);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'ChangeArchiveAction', ClassName);
  try
    try
      UserAction := CreateUserAction;
      UserAction^.ActionName := 'actChangeArchive';
      UserAction^.params.Add(GetEnumName(TypeInfo(TbfaViewKind), Integer(TV.ViewKind)));
      UserAction^.params.Add(IntToStr(PbfaInt64(Node.Data).value));
      UserAction^.params.Add(GetEnumName(TypeInfo(TbfaViewKind), integer(CurrentView)));
      UserAction^.objects.Add(Node);
      FMainThread.Add(UserAction);
    except
      bitfarmLog.Write(llDebug, ltException, 'ChangeArchiveAction', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ChangeArchiveAction', ClassName);
  end;

end;

procedure TbfaApplication.RefreshTimidList;
begin

end;

procedure TbfaApplication.RefreshTreeView(TV: TbfaTreeView; AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'RefreshTreeView', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          LoadArrays; //15.12.2017 wenn zwischendurch Archive erstellt waren, dann kommt hier ein absturz, deswegen mssen die Arrays neu geladen werden
          TV.Load(True);
        end);
    except
      bitfarmLog.Write(llDebug, ltException, 'RefreshTreeView', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'RefreshTreeView', ClassName);
  end;
end;

procedure TbfaApplication.ShareLayer(AThread: TThread; prev: TbfaPreview);
var
  req: TbfaRequest;
  layer: TStringList;
  right: integer;
  UserAction: PUserAction;
  LstUser: TList<TbfaBaseObject>;
begin
  AThread.Synchronize(nil,
    procedure
    var
      i: Integer;
    begin
      frmMainForm.frmPrivateLayer := TfrmPrivateLayer.Create(frmMainForm, user.ID, prev.ActiveDoc.ID);
      //01.08.2023 -->
      frmMainForm.frmPrivateLayer.Color := stlControl.Color;
      frmMainForm.frmPrivateLayer.lstUser.Color := stlControl.Color;
      frmMainForm.frmPrivateLayer.lstUser.Font.Color := stlControl.TextColor;
      //01.08.2023 <--

      layer := TStringList.Create;
      layer.Delimiter := ';';
      layer.StrictDelimiter := True;
      right := 0;
      try

        frmMainForm.frmPrivateLayer.Showmodal;

        if (frmMainForm.frmPrivateLayer.ModalResult = mrOK) then
        begin
          req := TbfaRequest.Create;
          LstUser := TList<TbfaBaseObject>.Create;
          try
            req.ReqType := 'reqShareLayer';
            req.UserID := user.ID;
            req.Profile := Self.Profile;
            req.Gdocid := prev.ActiveDoc.ID;
            req.Lang := Lang;
            for i := 0 to frmMainForm.frmPrivateLayer.lstObjects.Count - 1 do
            begin
              if TbfaUser(frmMainForm.frmPrivateLayer.lstObjects.Objects[i]).modified then
                LstUser.Add(TbfaUser(frmMainForm.frmPrivateLayer.lstObjects.Objects[i]));
            end;

            if LstUser.Count = 0 then  // keine markierten User in der Liste, dann exit
              Exit;

            req.Data := LstUser;
            MainSocket.SendRequestToServer(req);
            req := MainSocket.ReceiveResponse(AThread);

            if req = nil then
              Exit;

            if req.ReqType = 'respAuthError' then
            begin
              BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'));
              UserAction := CreateUserAction;
              UserAction^.ActionName := 'actRelogin';
              MainThread.Add(UserAction);
              Exit;

            end
            else if (req.ReqType = 'respDenied') or (req.ReqType = 'respShareLayerDenied') then
            begin
              BfShowMessage(_('Das Dokument ist schon von einem anderen Benutzer in Bearbeitung gesetzt.'));
              Exit;
            end
            else if req.ReqType = 'respError' then
            begin
              BfShowMessage(_('Fehler beim Freigeben der privaten Anmerkungen.') + #13#10 + req.DataString);
              Exit;
            end;
          finally
            FreeAndNil(LstUser);
            FreeAndNil(req);
          end;
        end;
        frmMainForm.frmPrivateLayer.Release;

      finally
        FreeAndNil(frmMainForm.frmPrivateLayer);
        FreeAndNil(layer);
      end;
    end);
end;

procedure TbfaApplication.ShowAbo(AThread: TThread);
begin

end;

procedure TbfaApplication.ShowActiveTab(AThread: TThread; Idx: Integer);
var
  ActPrev: TbfaPreview;
  arcids: TStringList;
  ActItem, i: Integer;
  found: Boolean;
begin
  try
    try
      if (FPreviewContainer.Containers.Count > 0) then
      begin
        ActItem := FPreviewContainer.ActiveItem;
        ActPrev := GetActivePreview;
        if (ActPrev <> nil) then
          ActPrev.askforsave_annos2(AThread);

        // Eingaben im ImporterAddfields merken
        if (FPreviewContainer.ActiveItem = 0) then
        begin
          aCurrentViewerAddfields := CloneAddfields(aCurrentAddfields);
          aCurrentViewerStatefields := CloneStatefields(aCurrentStatefields);
        end;
        if (FPreviewContainer.ActiveItem = 1) then
        begin
          aCurrentImporterAddfields := CloneAddfields(aCurrentAddfields);
          aCurrentImporterStatefields := CloneStatefields(aCurrentStatefields);
        end;
        if (FPreviewContainer.ActiveItem = 3) then
        begin
          aCurrentResubAddfields := CloneAddfields(aCurrentAddfields);
          aCurrentResubStatefields := CloneStatefields(aCurrentStatefields);
        end;

        FPreviewContainer.ActiveItem := Idx;

        SetCurrentDocs(nil, nil, GetActivePreview, AThread);

        if AThread <> nil then
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              ActivatePreview;
              if FCurrentContainer.Count > 0 then
                frmMainForm.SetStatusBarID(FCurrentContainer[0].arcid, FCurrentContainer[0].Id, GUIDToString(FCurrentContainer[0].tempid))
              else
                frmMainForm.SetStatusBarID(-1, -1);
            end);
        end
        else
        begin
          ActivatePreview;
          frmMainForm.SetStatusBarID(-1, -1);
        end;

        if (AThread <> nil) and (Idx <> -1) then
        begin
          if FPreviewContainer.ActiveItem in [0, 1, 3, 4]    // aktueller Tab ist Viewer, Importer , WVL, Lesezeichen
          then
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                frmMainForm.grdResultlistDevEx.Enabled := True;
              end);
            RefreshGrid(AThread);
            AThread.Synchronize(nil,
              procedure
              begin
                frmMainForm.actSearch.Enabled := True;
                SetBlueArrows; // SJ 12.06.2023
                frmMainForm.btnLimit.Enabled := True;
              end);
          end
          else
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                frmMainForm.grdResultlistDevExView.Invalidate;
                frmMainForm.actSearch.Enabled := False;
                SetBlueArrows; // SJ 12.06.2023
                frmMainForm.btnLimit.Enabled := False;
              end);
          end;
          AThread.Synchronize(nil,
            procedure
            begin
              if (FCurrentContainer.Count > 0) then
              begin
                frmMainForm.fraScanFunctions.btnScan.Enabled := False;
                frmMainForm.fraScanFunctions.btnScanDialog.Enabled := False;
                frmMainForm.fraScanFunctions.btnLoadFile.Enabled := False;
                frmMainForm.fraScanFunctions.btnSaveFile.Enabled := False;
                frmMainForm.fraScanFunctions.btnDeleteSelected.Enabled := False;
                frmMainForm.fraScanFunctions.btnArchive.Enabled := False;
              end;

              if (CurrentView = tvkResub) then
                frmMainForm.fraResub.EnableControls(FPreviewContainer.ActiveItem = 0);
            end);
        end;

        if FPreviewContainer.ActiveItem <> pvtImporter then
          frmMainForm.dftMainForm.Enabled := True
        else
          frmMainForm.dftMainForm.Enabled := False;
      end;

      if AThread <> nil then
      begin
        arcids := TStringList.Create;
        try
          if FCurrentContainer.Count > 0 then
          begin
            if (FCurrentContainer[0].Id = -1) then //nicht importiertes Dokument->Importerfelder anzeigen
            begin
              if CurrentArchive.Arcid <> CurrentImporterFields then
                arcids.Add(inttostr(CurrentImporterFields))
            end
            else
            begin
              //28.06.2024 BT SymbolicLink -->
              if FCurrentContainer[0].SymbolicArcID <> -1 then
                arcids.Add(inttostr(FCurrentContainer[0].SymbolicArcID))
              else
              //28.06.2024 BT SymbolicLink <--
                arcids.Add(inttostr(FCurrentContainer[0].ArcID));
            end;
          end;

          if arcids.Count > 0 then
          begin
            CreateFields(AThread, arcids);
            ResetFields(AThread);  //21.06.2024 SD <--bfacrm:ticket__show__35622
          end;

          AThread.Synchronize(nil,
            procedure
            begin
              if (GetActivePreview <> nil) and (GetActivePreview.ActiveDoc <> nil) then
              begin
                ShowAddFields(GetActivePreview.ActiveDoc);
                ShowStateFields(GetActivePreview.ActiveDoc);
                //21.06.2024 SD -->bfacrm:ticket__show__35622
                //Wenn es einen Kommentar gibt, sollte Tab farblich hervorgehoben werden.
                if GetActivePreview.ActiveDoc.HasComment then
                begin
                  GetActivePreview.btnCommentary.CaptionGlow := gldAll;
                  GetActivePreview.btnCommentary.CaptionGlowColor := $00A5FF;
                end
                else
                begin
                  GetActivePreview.btnCommentary.CaptionGlow := gldNone;
                  GetActivePreview.btnCommentary.CaptionGlowColor := gclNone;
                end;
                GetActivePreview.btnCommentary.FontSettings.Style := [];
                GetActivePreview.btnCommentary.FontSettings.Color := stlControl.TextColor;
                //21.06.2024 SD <--bfacrm:ticket__show__35622
              end;
            end);
        finally
          FreeAndNil(arcids);
        end;
      end;
    except
      FPreviewContainer.ActiveItem := -1;
    end;
  finally
    ViewChanging := False;
  end;
end;

procedure TbfaApplication.SetBlueArrows;
begin

  if (frmMainForm.trvBookmarks.Selected = nil) or
     (FHistoryListNode.Count = 0) or (FHistoryListNode = nil) or
     not(FPreviewContainer.ActiveItem in [0, 1, 3, 4]) then
  begin
    frmMainForm.actForward.Enabled := False;
    frmMainForm.actBack.Enabled := (FHistoryListNode <> nil) and not(FHistoryListNode.Count = 0) and (FPreviewContainer.ActiveItem in [0, 1, 3, 4]);
  end
  else if (frmMainForm.trvBookmarks.Selected = FHistoryListNode.GetFirstChild) then
  begin
    frmMainForm.actForward.Enabled := (frmMainForm.trvBookmarks.Selected.Index > FHistoryListNode.GetFirstChild.Index);
    frmMainForm.actBack.Enabled := True;
  end
  else if (frmMainForm.trvBookmarks.Selected = FHistoryListNode.GetLastChild) then
  begin
    frmMainForm.actForward.Enabled := True;
    frmMainForm.actBack.Enabled := False;
  end
  else if GetRootNode(frmMainForm.trvBookmarks.Selected) = FHistoryListNode then
  begin
    frmMainForm.actForward.Enabled := True;
    frmMainForm.actBack.Enabled := True;
    SelectFirstHistoryNode := False;
  end else
  begin
    frmMainForm.actForward.Enabled := False;
    frmMainForm.actBack.Enabled := True;
  end;
end;
//begin
//  if (frmMainForm.trvBookmarks.Selected <> nil) then
//  begin
//    if ((frmMainForm.trvBookmarks.Selected = FHistoryListNode.GetFirstChild))  then
//    begin
//      frmMainForm.btnForward.Enabled := False;
//      frmMainForm.btnBack.Enabled := True;
//    end
//    else if ((frmMainForm.trvBookmarks.Selected = FHistoryListNode.GetLastChild) ) then
//    begin
//      frmMainForm.btnForward.Enabled := True;
//      frmMainForm.btnBack.Enabled := False;
//    end;
//  end;
//end;

procedure TbfaApplication.ShowActiveTabAction(Idx: Integer);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'ShowActiveTabAction - ', Classname);
  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actShowActiveTab';
      UserAction^.params.Add(IntToStr(Idx));
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'ShowActiveTabAction - ', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ShowActiveTabAction - ', Classname);
  end;
end;

procedure TbfaApplication.ShowAlertWindow(Typ: Integer; Text: WideString; FileObj: TbfaFileObj = nil);

  procedure ShowNewMessage(const ACaption: WideString; AMessageText: WideString);
  var
    AAlertWindow: TdxAlertWindow;
    bfaNotification : TNotification;   //21.04.2020
  begin
    if TOSVersion.Check(6, 2) then //21.04.2020 Windows 8 oder grer
    begin
      bfaNotification := frmMainForm.bfaNotificationCenter.CreateNotification;
      try
        bfaNotification.Name := 'bitfarm Viewer 362 Notification';
        bfaNotification.Title := ACaption;
        bfaNotification.AlertBody := AMessageText;

        frmMainForm.bfaNotificationCenter.PresentNotification(bfaNotification);
      finally
        bfaNotification.Free;
      end;
    end
    else
    begin
      AAlertWindow := frmMainForm.dxAlertWindowManager1.Show(ACaption, AMessageText);
      AAlertWindow.RestartDisplayTimer;
      if Typ = alSave then
        if FileObj <> nil then
          AAlertWindow.Tag := Integer(Pointer(FileObj));
    end;
  end;

var
  Cptn: WideString;
begin
  Log.DebugBegin(llDebug, 'ShowAlertWindow', ClassName);
  try
    try
      if Typ = alSave then
      begin
        Cptn := 'Viewer36 - ' + _('Datei erstellt');
        frmMainForm.dxAlertWindowManager1.OptionsButtons.Buttons[0].Visible := True;
        frmMainForm.dxAlertWindowManager1.OptionsButtons.Buttons[1].Visible := True;
      end
      else if Typ = alEmail then
      begin
        Cptn := 'Viewer36 - ' + _('E-Mail versenden');
        frmMainForm.dxAlertWindowManager1.OptionsButtons.Buttons[0].Visible := False;
        frmMainForm.dxAlertWindowManager1.OptionsButtons.Buttons[1].Visible := False;
      end
      else if Typ = alPrint then
      begin
        Cptn := 'Viewer36 - ' + _('Dokument drucken');
        frmMainForm.dxAlertWindowManager1.OptionsButtons.Buttons[0].Visible := False;
        frmMainForm.dxAlertWindowManager1.OptionsButtons.Buttons[1].Visible := False;
      end
      else if Typ = alDocLink then
      begin
        Cptn := 'Viewer36 - ' + _('Dokument verknpfen');
        frmMainForm.dxAlertWindowManager1.OptionsButtons.Buttons[0].Visible := False;
        frmMainForm.dxAlertWindowManager1.OptionsButtons.Buttons[1].Visible := False;
      end
      else if Typ = alResub then
      begin
        Cptn := 'Viewer36 - ' + _('Wiedervorlage');
        frmMainForm.dxAlertWindowManager1.OptionsButtons.Buttons[0].Visible := False;
        frmMainForm.dxAlertWindowManager1.OptionsButtons.Buttons[1].Visible := False;
      end;

      ShowNewMessage(Cptn, Text);
    except
      bitfarmLog.Write(llDebug, ltException, 'ShowAlertWindow', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ShowAlertWindow', ClassName);
  end;
end;

procedure TbfaApplication.AlertWindowButtonClick(Sender: TObject; AAlertWindow: TdxAlertWindow; AButtonIndex: Integer);
begin
  bitfarmLog.DebugBegin(llDebug, 'AlertWindowButtonClick', ClassName);
  try
    try
      if ((Pointer(AAlertWindow.Tag) <> nil)) then
      begin
        if AButtonIndex = 0 then
        begin
          if (TbfaFileObj(Pointer(AAlertWindow.Tag)).Directory <> '') then
          begin
            ShellExecute(Application.Handle, 'explore', PWideChar(TbfaFileObj(Pointer(AAlertWindow.Tag)).Directory), nil, nil, SW_SHOWNORMAL);
          end;
        end
        else if AButtonIndex = 1 then
        begin
          if (TbfaFileObj(Pointer(AAlertWindow.Tag)).FileName <> '') then
          begin
            ShellExecute(Application.Handle, 'open', PWideChar(TbfaFileObj(Pointer(AAlertWindow.Tag)).FileName), nil, nil, SW_NORMAL)
          end;
        end;
      end;
    except
      bitfarmLog.Write(llDebug, ltException, 'AlertWindowButtonClick', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'AlertWindowButtonClick', ClassName);
  end;
end;

function TbfaApplication.AllowedToLeaveCurrentDocs(PreviousAllow: Boolean = True; ShowDialog: Boolean = True;
  AThread: TThread = nil): Boolean;
begin
  try
    Result := PreviousAllow;

    if Assigned(frmMainForm) and (not frmMainForm.fAppStarted) then
      Exit;

    if (CurrentView in [tvkViewer, tvkWorkplace, tvkResub, tvkFavorites]) and (aCurrentAddfields.Count > 0) then
    begin
      for var i := 0 to CurrentContainer.Count - 1 do
      begin
        if Result and CurrentContainer[i].InEditMode and (CurrentContainer[i].ID <> -1) then
        begin
          for var j := 0 to aCurrentAddfields.Count - 1 do
          begin
            if ((aCurrentAddfields[j].Options and cAddfieldOptMandatory) = cAddfieldOptMandatory) and
               (aCurrentAddfields[j].Modified) and
               (Trim(VarToStr(aCurrentAddfields[j].Value)) = '') and
               ((aAddfieldRights[aCurrentAddfields[j].Id] and (rFieldWrite or rFieldModify)) <> 0) then
            begin
              if ShowDialog then
                BfShowMessage(_('Sie mssen erst die Pflichtfelder ausfllen.') + #13 + _('Pflichtfelder haben einen fetten Bezeichner bzw. sind hell-orange hinterlegt.'), AThread);
              Result := False;
            end;
          end;
        end;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'AllowedToLeaveCurrentDocs', ClassName);
  end;
end;

procedure TbfaApplication.LoadDocumentViaSocket(Doc: TbfaDocument; Param: WideString;
  AThread: TThread; OnlyDoc : Boolean = False; ShowErrorMsg: Boolean = True);
var
  req: TbfaRequest;
  sock: TSocketConnection;
  TmpStream : TMemoryStream;
  UserAction: PUserAction;
  OldTimID: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'LoadDocumentViaSocket', ClassName);
  Doc.StartLoadProcess;
  try
    try
      if Doc.ID <> -1 then
      begin
        sock := TSocketConnection.Create(bfaServerNoSSL, bfaServer, bfaServerPort, '');
        req := TbfaRequest.Create;
        try
          sock.CreateComponents;
          if sock.Connect then
          begin
            if OnlyDoc then
              req.ReqType := 'reqDoc'
            else
              req.ReqType := 'reqPreview';
            req.UserID := FUser.ID;
            req.Gdocid := Doc.ID;
            if Doc.Addfields_Arcid > 0 then
              req.Addfields_Arcid := Doc.Addfields_Arcid;
            if Doc.SymbolicArcID > 0 then
              req.SymbolicArcID := Doc.SymbolicArcID;
            if Doc.ResubUserID > 0 then
              req.ResubUserID := Doc.ResubUserID;
            //20.09.2022 Ticket 31660 -->
            //if Doc.TimID > 0 then
            //  req.TimID := Doc.TimID;
            if Doc.TimID > 0 then
            begin
              req.TimID := Doc.TimID;
              OldTimID := Doc.TimID;
            end
            else
              OldTimID := -1;
            //20.09.2022 Ticket 31660 <--

            req.Profile := Profile;
            req.Parameter := Param;
            req.Lang := Lang;
            sock.SendRequestToServer(req);

            if OnlyDoc then
              req := sock.ReceiveDoc(Doc, AThread, OnlyDoc, False)  //mitten drin ist ein Clone, wo alles auf nil gesetzt wird
            else
              req := sock.ReceiveData(Doc, AThread, False);
            if req = nil then
              Exit;
            if req.ReqType = 'respDoc' then
            begin
              Doc.Loaded := True;
              Doc.HasPreview := True;
              //20.09.2022 Ticket 31660 -->
              if (Doc.TimID <= 0) and (OldTimID > 0) then
                Doc.TimID := OldTimID;
              //20.09.2022 Ticket 31660 <--
            end
            else begin
              //19.09.2022 Darf eigentlich nicht True sein, deswegen gendert. Doc.Loaded := True;
              Doc.Loaded := False;
              if ShowErrorMsg then
                BfShowMessage(_('Das Dokument konnte nicht geladen werden.') + #13#10 + req.DataString, AThread);
              if req.ReqType = 'respAuthError' then
              begin
                UserAction := bitfarmApp.CreateUserAction;
                UserAction^.ActionName := 'actRelogin';
                bitfarmApp.MainThread.Add(UserAction);
              end;
            end;
            sock.Disconnect;
          end;
        finally
          FreeAndNil(req);
          FreeAndNil(sock);
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'LoadDocumentViaSocket', ClassName);
    end;
  finally
    Doc.EndLoadProcess;
    bitfarmLog.DebugEnd(llDebug, 'LoadDocumentViaSocket', ClassName);
  end;
end;

procedure TbfaApplication.LoadHistoryViaSocket(Doc: TbfaDocument; AThread: TThread);
var
  req: TbfaRequest;
  sock: TSocketConnection;
  hist: TList<TbfaHistory>;
  i: Integer;
  lmq: TUniQuery;
begin
  bitfarmLog.DebugBegin(llDebug, 'LoadHistoryViaSocket', ClassName);
  try
    try
      if (Doc <> nil) and (Doc.ID <> -1) then
      begin
        if OfflineMode then
        begin
          AThread.Synchronize(nil,
            procedure
            var
              i: Integer;
            begin
              lmq := DbCreateQuery;
              try
                lmq.SQL.Text := 'select * from sys_history where gdocid = ' + IntToStr(Doc.ID);
                lmq.Execute;
                with FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.HistoryView do
                begin
                  HistDataSet.DisableControls;
                  HistDataSet.Open;
                  HistDataSet.First;
                  HistDataSet.EmptyDataSet;
                  if lmq.RecordCount > 0 then
                  begin
                    while not lmq.Eof do
                    begin
                      HistDataSet.Append;
                      HistDataSet.Fields[0].Value := lmq.FieldByName('tstamp').AsDateTime;
                      if UserListHist.IndexOfObject(TObject(lmq.FieldByName('userid').AsInteger)) > -1 then
                        HistDataSet.Fields[1].Value := UserListHist[UserListHist.IndexOfObject(TObject(lmq.FieldByName('userid').AsInteger))]
                      else
                        HistDataSet.Fields[1].Value := _('unbekannt');
                      HistDataSet.Fields[2].Value := lmq.FieldByName('value1').AsWideString;
                      HistDataSet.Fields[3].Value := lmq.FieldByName('tstamp').AsString;
                      HistDataSet.Post;

                      lmq.Next;
                    end;
                  end;
                  HistDataSet.First;
                  HistDataSet.Active := True;
                  HistDataSet.EnableControls;
                  {$IFDEF COMMENTGRID}
                  //
                  {$ELSE}
                  grdHistory.RefreshVerticalScrollbar;
                  {$ENDIF}
                end;
              finally
                FreeAndNil(lmq);
              end;
            end);
        end else
        begin
          sock := TSocketConnection.Create(bfaServerNoSSL, bfaServer, bfaServerPort, '');

          sock.CreateComponents;
          if sock.Connect then
          begin
            req := TbfaRequest.Create;
            try
              req.ReqType := 'reqHistory';
              req.UserID := FUser.ID;
              req.Gdocid := Doc.ID;
              req.Profile := Profile;
              req.Lang := Lang;
              sock.SendRequestToServer(req);
              hist := TList<TbfaHistory>.Create;

              AThread.Synchronize(nil,
                procedure
                var
                  i: Integer;
                begin
//                  bitfarmLog.DebugBegin(llDebug, 'LoadHistoryViaSocket - Synchronize', ClassName);
                  try
                    req := sock.ReceiveHistory(hist);
                    bitfarmLog.Write(llDebug, ltInfo, 'LoadHistoryViaSocket - Synchronize - 1', ClassName);
                    with FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.HistoryView do
                    begin
                      HistDataSet.DisableControls;
//                      bitfarmLog.Write(llDebug, ltInfo, 'LoadHistoryViaSocket - Synchronize - 2', ClassName);
                      HistDataSet.Open;
//                      bitfarmLog.Write(llDebug, ltInfo, 'LoadHistoryViaSocket - Synchronize - 3', ClassName);
                      HistDataSet.First;
//                      bitfarmLog.Write(llDebug, ltInfo, 'LoadHistoryViaSocket - Synchronize - 4', ClassName);
                      HistDataSet.EmptyDataSet;
//                      bitfarmLog.Write(llDebug, ltInfo, 'LoadHistoryViaSocket - Synchronize - 5', ClassName);
                      for i := 0 to hist.Count - 1 do
                      begin
                        HistDataSet.Append;
                        HistDataSet.Fields[0].Value := hist[i].Date;
                        if UserListHist.IndexOfObject(TObject(hist[i].userid)) > -1 then
                          HistDataSet.Fields[1].Value := UserListHist[UserListHist.IndexOfObject(TObject(hist[i].userid))]
                        else
                          HistDataSet.Fields[1].Value := _('unbekannt');
                        HistDataSet.Fields[2].Value := hist[i].msg;
                        try
                          HistDataSet.Fields[3].Value := DateTimeToStr(hist[i].Date);
                        except
                          //
                        end;
                        HistDataSet.Post;
                      end;
//                      bitfarmLog.Write(llDebug, ltInfo, 'LoadHistoryViaSocket - Synchronize - 6', ClassName);
                      HistDataSet.First;
//                      bitfarmLog.Write(llDebug, ltInfo, 'LoadHistoryViaSocket - Synchronize - 7', ClassName);
                      HistDataSet.Active := True;
//                      bitfarmLog.Write(llDebug, ltInfo, 'LoadHistoryViaSocket - Synchronize - 8', ClassName);
                      HistDataSet.EnableControls;
//                      bitfarmLog.Write(llDebug, ltInfo, 'LoadHistoryViaSocket - Synchronize - 9', ClassName);
                      {$IFDEF COMMENTGRID}
                      //
                      {$ELSE}
                      grdHistory.RefreshVerticalScrollbar;
                      {$ENDIF}
//                      bitfarmLog.Write(llDebug, ltInfo, 'LoadHistoryViaSocket - Synchronize - 10', ClassName);
                    end;
                  finally
//                    bitfarmLog.DebugEnd(llDebug, 'LoadHistoryViaSocket - Synchronize', ClassName);
                  end;
                end);

              sock.Disconnect;

            finally
              FreeAndNil(req);
            end;
          end;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'LoadHistoryViaSocket', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'LoadHistoryViaSocket', ClassName);
  end;

end;

procedure TbfaApplication.LoadStationaries(arcid: Int64);
var
  req: TbfaRequest;
  sock: TSocketConnection;
  backpics: TStringList;
  dBackpics: TDictionary<Int64, TStringList>;
  backpic: Widestring;
  i, j, idx: Integer;
  fname: string;
  found, additem: Boolean;
  Doc: TbfaDocument;
begin
  bitfarmLog.DebugBegin(llDebug, 'LoadStationaries', ClassName);

  // prfen auf vorhandensein

  try
    try
      dBackpics := TDictionary<Int64, TStringList>.Create;
      if aSysArc[arcid].Backpic <> '' then
      begin
        backpics := TStringList.Create;
        backpics.Delimiter := '|';
        backpics.StrictDelimiter := True;
        backpics.Duplicates := dupIgnore;
        backpics.DelimitedText := aSysArc[arcid].Backpic;
        dBackpics.Add(arcid, backpics);
      end;

      if aSysArc[arcid].Typ = 0 then  // Lager
      begin
        for i := Low(aSysArc) to High(aSysArc) do
        begin
          if (aSysArc[i].Lgrid = arcid) and (aSysArc[i].Backpic <> '') then
          begin
            backpics := TStringList.Create;
            backpics.Delimiter := '|';
            backpics.StrictDelimiter := True;
            backpics.Duplicates := dupIgnore;
            backpics.DelimitedText := aSysArc[i].Backpic;
            dBackpics.Add(aSysArc[i].Arcid, backpics);
          end;
        end;
      end;

      frmMainForm.bfaTlbPreview1.sbmStationery.Clear;
      frmMainForm.bfaTlbPreview1.sbmStationery.DropdownCombo := True;
      frmMainForm.bfaTlbPreview1.sbmStationery.ImageIndex := -1;
      frmMainForm.bfaTlbPreview1.sbmStationery.Action := frmMainForm.actStationery;

      FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.bfaTlbPreview.sbmStationery.Clear;
      FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.bfaTlbPreview.sbmStationery.DropdownCombo := True;
      FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.bfaTlbPreview.sbmStationery.ImageIndex := -1;
      FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.bfaTlbPreview.sbmStationery.Action := frmMainForm.actStationery;

      idx := 0;
      for arcid in dBackpics.Keys do
      begin
        dBackPics.TryGetValue(arcid, backpics);

        for i := 0 to backpics.Count -1 do
        begin
          found := False;
          additem := True;
          fname := ReplaceStr(ExtractFileName(backpics[i]), ExtractFileExt(backpics[i]), '');

          for j := Low(aStationeries) to High(aStationeries) do
          begin
            if (aStationeries[j].name = LowerCase(fname)) then
            begin
              if (aStationeries[j].Arcids.Contains(arcid)) then
              begin
                found := True;
                Break;
              end else begin
                aStationeries[j].Arcids.Add(arcid);
                found := True;
                Break;
              end;
            end;
          end;

          if not found then
          begin
            if OfflineMode then
            begin
              if FileExists(backpics[i]) then
              begin
                SetLength(aStationeries, Length(aStationeries) + 1);
                aStationeries[High(aStationeries)].Arcids := TList<Integer>.Create;
                aStationeries[High(aStationeries)].Arcids.Add(arcid);
                aStationeries[High(aStationeries)].arcid := arcid;
                aStationeries[High(aStationeries)].name := fname;
                aStationeries[High(aStationeries)].Stream := TMemoryStream.Create;
                aStationeries[High(aStationeries)].Stream.LoadFromFile(backpics[i]);
              end;
            end else
            begin
              sock := TSocketConnection.Create(bfaServerNoSSL, bfaServer, bfaServerPort, '');
              req := TbfaRequest.Create;
              Doc := TbfaDocument.Create;
              try
                sock.CreateComponents;
                if sock.Connect then
                begin
                  req.ReqType := 'reqFile';
                  req.UserID := FUser.ID;
                  req.Profile := Profile;
                  req.Gdocid := -1;
                  req.FileName := backpics[i];
                  req.Lang := Lang;
                  sock.SendRequestToServer(req);

                  req := sock.ReceiveData(Doc, nil);
                  if req = nil then
                    Exit;

                  if req.ReqType <> 'respDoc' then
                  begin
                    BfShowMessage(_('Das Briefpapier konnte nicht fr dieses Archiv geladen werden.') + #13#10 + req.DataString);
                  end
                  else
                  begin
                    SetLength(aStationeries, Length(aStationeries) + 1);
                    aStationeries[High(aStationeries)].Arcids := TList<Integer>.Create;
                    aStationeries[High(aStationeries)].Arcids.Add(arcid);

                    aStationeries[High(aStationeries)].arcid := arcid;
                    aStationeries[High(aStationeries)].name := fname;
                    aStationeries[High(aStationeries)].Stream := TMemoryStream.Create;
                    Doc.DocStream.Position := 0;
                    aStationeries[High(aStationeries)].Stream.CopyFrom(Doc.DocStream, Doc.DocStream.Size);
                  end;
                end;
              finally
                sock.Disconnect;
                FreeAndNil(req);
                FreeAndNil(sock);
                FreeAndNil(Doc);
              end;
            end;
          end;

          for j := 0 to frmMainForm.bfaTlbPreview1.sbmStationery.Count -1  do
          begin
            if frmMainForm.bfaTlbPreview1.sbmStationery[j].Caption = fname then
            begin
              additem := False;
              Break;
            end;
          end;

          if additem then
          begin
            frmMainForm.bfaTlbPreview1.sbmStationery.Add(TSpTBXItem.Create(frmMainForm.bfaTlbPreview1.sbmStationery));
            frmMainForm.bfaTlbPreview1.sbmStationery[frmMainForm.bfaTlbPreview1.sbmStationery.Count - 1].Caption := fname;
            frmMainForm.bfaTlbPreview1.sbmStationery[frmMainForm.bfaTlbPreview1.sbmStationery.Count - 1].Tag := idx;
            frmMainForm.bfaTlbPreview1.sbmStationery[frmMainForm.bfaTlbPreview1.sbmStationery.Count - 1].OnClick := OnStationeryClick;
            if idx = StationeryIndex then
              frmMainForm.bfaTlbPreview1.sbmStationery[idx].Checked := True;

            FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.bfaTlbPreview.sbmStationery.Add(TSpTBXItem.Create(frmMainForm.bfaTlbPreview1.sbmStationery));
            FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.bfaTlbPreview.sbmStationery[frmMainForm.bfaTlbPreview1.sbmStationery.Count - 1].Caption := fname;
            FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.bfaTlbPreview.sbmStationery[frmMainForm.bfaTlbPreview1.sbmStationery.Count - 1].Tag := i;
            FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.bfaTlbPreview.sbmStationery[frmMainForm.bfaTlbPreview1.sbmStationery.Count - 1].OnClick := FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.OnStationeryClick;
            if idx = FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.StationeryIndex then
              FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.bfaTlbPreview.sbmStationery[idx].Checked := True;
          end else
          begin
            if idx = StationeryIndex then
              FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.bfaTlbPreview.sbmStationery[idx].Checked := True;
          end;

          Inc(idx);
        end;
      end;

      frmMainForm.bfaTlbPreview1.mnuStationery.Visible := frmMainForm.bfaTlbPreview1.sbmStationery.Count <= 1;
      frmMainForm.bfaTlbPreview1.sbmStationery.Visible := frmMainForm.bfaTlbPreview1.sbmStationery.Count > 1;
      FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.bfaTlbPreview.mnuStationery.Visible := frmMainForm.bfaTlbPreview1.sbmStationery.Count <= 1;
      FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.bfaTlbPreview.sbmStationery.Visible := frmMainForm.bfaTlbPreview1.sbmStationery.Count > 1;

    except
      bitfarmLog.Write(llNormal, ltException, 'LoadStationaries', ClassName);
    end;
  finally
    FreeAndNil(backpics);
    bitfarmLog.DebugEnd(llDebug, 'LoadStationaries', ClassName);
  end;
end;

function TbfaApplication.CloneAddfields(Source: TList<TbfaAddfield>): TList<TbfaAddfield>;
var
  i: Integer;
  addfield: TBfaAddfield;
begin
  result := TList<TbfaAddfield>.Create;
  for i := 0 to Source.Count - 1 do
  begin
    if not Source[i].Assigned then    // nur Felder zurckschreiben, die auch der View assigned sind
      Continue;
    addfield := TbfaAddfield.Create;
    addfield.Clone(Source[i]);
    result.Add(addfield);
  end;
end;

function TbfaApplication.CloneCurrentDocs(UserAction: PUserAction; OnlyFirstDoc: Boolean;
  Rights: Integer = 0; DocIdx: Integer = -1; WithThumbnailView: Boolean = True; Sorting: Boolean = False): Boolean;
var
  Doc: TbfaDocument;
  i, j, counter: Integer;
  FName: WideString;
  msg: string;
begin
// Wenn DocIDx <> -1 bedeutet das ich das angegebenen Dokument klonen will!!!
  result := False;
  try
    msg := '';
    if ((OnlyFirstDoc) and (DocIdx = -1)) then
      counter := 0
    else
      counter := FCurrentContainer.Count - 1;

    if frmMainForm.frmSplash.Showing then
    begin
      frmMainForm.frmSplash.Update;
      msg := frmMainForm.frmSplash.lblLoading.Caption;
    end;

    for j := 0 to counter do
    begin
      if frmMainForm.frmSplash.Showing then
      begin
        frmMainForm.frmSplash.lblLoading.Caption := msg;
        frmMainForm.frmSplash.lblInfo.Caption := ' (Dokument: ' + IntToStr(j + 1) + '/' + IntToStr(counter + 1) + ')';
        frmMainForm.frmSplash.Update;
      end;

      if ((DocIdx = -1) or (DocIdx = j)) then
      begin
        if (not FCurrentContainer[j].Loaded) and (FCurrentContainer[j].Id <> -1) then
        begin
          if (not OfflineMode) then
            LoadDocumentViaSocket(FCurrentContainer[j], 'base;fields;paths;iev;text;svn', nil)
          //08.02.2023 bfacrm:ticket__show__32103 -->
          else
            DBLoadDocument(FCurrentContainer[j]);
          //08.02.2023 <--
        end;

        if (FCurrentContainer[j].haspreview) or (FCurrentContainer[j].OriLoc <> '') then
        begin
          Doc := TbfaDocument.Create;
          Doc.Clone(FCurrentContainer[j], True, True, True, (WithThumbnailView or (not (FCurrentContainer[j].DocStream.Size > 0))));

          if ((Doc.LetterStream <> nil) and (Doc.LetterStream.Size = 0)) and ((UserAction^.Preview <> nil) and (UserAction^.Preview.bfaTlbPreview.sbmStationery.Checked)) then
          begin
            FName := '';
            for i := 0 to UserAction^.Preview.bfaTlbPreview.sbmStationery.Count - 1 do
              if UserAction^.Preview.bfaTlbPreview.sbmStationery[i].Checked then
                FName := UserAction^.Preview.bfaTlbPreview.sbmStationery[i].Caption;

            bitfarmApp.LoadStationeryToDocument(Doc, FName);
          end;

          // immer hinzufgen wenn keine Rechte abgefragt werden, oder  wenn das Archivrecht vorhanden ist
          if (Rights = 0) or ((Rights > 0) and (Doc.Rights and Rights > 0)) or (Doc.ID = -1) then
          begin
            //wenn Sorting true ist, dann mssen wir die Trefferliste Selektionsreihenfolge
            //behalten.  z.B. beim Plugin ausfhren kann es sein dass FCurrentContainer[0]
            //nicht das erste Dokument im Selektion ist
            if Sorting and (counter > 1) then //wenn Selektion behalten muss und sind mehrere Dokumenten
            begin
              if Doc.SortingPos > -1 then //SortingPos muss vorher gesetzt werden!
                UserAction^.Documents.Insert(Doc.SortingPos, Doc)
              else
                UserAction^.Documents.Add(Doc); //sonst wird als letztes hinzugefgt
            end
            else //bisherige verhalten ohne sorting
              UserAction^.Documents.Add(Doc);
          end
          else if UserAction^.msg = '' then
            UserAction^.Msg := IntToStr(Doc.ID)
          else
            UserAction^.Msg := UserAction^.Msg + ',' + IntToStr(Doc.ID);
          if not result then
            result := Doc.HasAnnotation;
        end;
      end;
    end;

    UserAction^.FreeObjects := True;
  except
    result := False;
    bitfarmLog.Write(llNormal, ltInfo, 'CloneCurrentDocs', ClassName);
  end;
end;

function TbfaApplication.CloneStatefields(Source: TList<TbfaStatefield>): TList<TbfaStatefield>;
var
  i: Integer;
  statefield: TBfaStatefield;
begin
  result := TList<TBfaStatefield>.Create;
  for i := 0 to Source.Count - 1 do
  begin
    if not Source[i].Assigned then
      Continue;

    statefield := TBfaStatefield.Create;
    statefield.Clone(Source[i]);
    result.Add(statefield);
  end;
end;

procedure TbfaApplication.CreatePrintStandardAction(UserAction: PUserAction; OnlyFirstDoc: Boolean; AlreadyClonedDocs: Boolean);
var
  HasAnnotation, WithAnno: Boolean;
  PrnLst: TList<TPrinter>;
  prev: TbfaPreview;
  Prn: TPrinter;
  ADevice, ADriver, APort: string;
  ADeviceMode: THandle;
  i, DlgResult: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreatePrintStandardAction', ClassName);
  try
    try
      prev := bitfarmApp.GetActivePreview;

      if not prev.Floating then
      begin
        frmMainForm.mnuPrint.ImageIndex := prev.actPrintStandard.ImageIndex;
        frmMainForm.mnuPrint.Action := prev.actPrintStandard;
        frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemPrint.Action := prev.actPrintStandard;
      end;

      prev.bfaTlbStandard.tlbStandardSubmenuItemPrint.Action := prev.actPrintStandard;

      if FViewerOptions.GeneralOptions.DefaultPrinterName = '' then
      begin
        BfShowMessage(_('Bitte whlen Sie einen anderen Drucker aus oder benutzen') + #13 + _('Sie einen anderen Druckertreiber.'));
        bitfarmLog.Write(llNormal, ltInfo, 'PrintDoc End via Exit', ClassName);
        Exit;
      end;

      if AlreadyClonedDocs and (UserAction^.Documents.Count > 0) then
      begin
        HasAnnotation := False;
        for i := 0 to UserAction^.Documents.Count - 1 do
        begin
          if TbfaDocument(UserAction^.Documents[i]).HasAnnotation then
          begin
            HasAnnotation := True;
            Break;
          end;
        end;
      end
      else
        HasAnnotation := CloneCurrentDocs(UserAction, OnlyFirstDoc, rightPrint);

      if frmMainForm.bfaTlbPreview1.mnuStationery.Checked or frmMainForm.bfaTlbPreview1.sbmStationery.Checked then
        UserAction^.params.Add('1')
      else
        UserAction^.params.Add('0');

      WithAnno := False;
      // bfacrm:ticket__show__24796
      if HasAnnotation then
      begin
        DlgResult := BfMessageDlg(_('Das Dokument hat Anmerkungen. Sollen diese mit gedruckt werden?'), mtConfirmation, [mbYes, mbNo, mbCancel]);
        bitfarmLog.Write(llNormal, ltInfo, 'DlgResult=' + Dlgresult.ToString, ClassName); //01.08.2023
      end;

      if (HasAnnotation) and (DlgResult = mrCancel) then
      begin
        Dispose(UserAction);
        Exit;
      end else
      // bfacrm:ticket__show__24796
      if (HasAnnotation) and (DlgResult = mrYes) then
      begin
        WithAnno := True;
        if frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Enabled and frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Checked then
        begin
          UserAction^.params.Add('1'); //Private
          UserAction^.params.Add('0'); //Public
          UserAction^.params.Add(IntToStr(prev.CurrentLayer)); //Layer
        end
        else if frmMainForm.bfaTlbPreview1.mnuPublicAnno.Enabled and frmMainForm.bfaTlbPreview1.mnuPublicAnno.Checked then
        begin
          UserAction^.params.Add('0'); //Private
          UserAction^.params.Add('1'); //Public
          UserAction^.params.Add('0'); //Layer
        end
        else
        begin
          UserAction^.params.Add('0'); //Private
          UserAction^.params.Add('1'); //Public
          UserAction^.params.Add('0'); //Layer
        end;
      end else
      begin
        UserAction^.params.Add('0'); //Private
        UserAction^.params.Add('0'); //Public
        UserAction^.params.Add('-1'); //Layer
      end;

      UserAction^.params.Add(IntToStr(FPreviewContainer.Containers[FPreviewContainer.ActiveItem].Preview.CurrentLayer));

      UserAction^.params.Add('0'); // MergeDocuments

      PrnLst := TList<TPrinter>.Create;
      for i := 0 to UserAction^.Documents.Count - 1 do
      begin
        Prn := TPrinter.Create;

        if (FViewerOptions.GeneralOptions.UseDefaultPrinter) or (FViewerOptions.GeneralOptions.DefaultPrinterName = '') then //26.10.2018 Ticket 16548
          Printer.PrinterIndex := -1
        else
          Printer.PrinterIndex := Printer.Printers.IndexOf(FViewerOptions.GeneralOptions.DefaultPrinterName); //26.10.2018 Ticket 16548

        TbfaPrinter(Prn).Clone(Printer);

        if TbfaDocument(UserAction^.Documents[i]).DocName <> '' then
          Prn.Title := TbfaDocument(UserAction^.Documents[i]).DocName
        else
          Prn.Title := _('Dokument');

        try
          Prn.Copies := 1; //16.08.2018
        except
          //26.10.2018 Ticket 16548 Nicht alle Printer kann Kopie setzen
        end;
        Prn.BeginDoc;

        PrnLst.Add(Prn);
      end;
      UserAction^.objects := TList(PrnLst);

      if (HasAnnotation) and (WithAnno) then
        UserAction^.params.Add('1')
      else
        UserAction^.params.Add('0');

      FBackThread.Add(UserAction);
    except
      on e: Exception do
      begin
        bitfarmLog.Write(llNormal, ltException, 'CreatePrintStandardAction', ClassName);
        BfShowMessage(_('Fehler beim Drucken eines Dokumentes: ') + e.Message);
      end;
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreatePrintStandardAction', ClassName);
  end;
end;

procedure TbfaApplication.CreatePrintPreviewAction(UserAction: PUserAction; OnlyFirstDoc: Boolean);

  procedure PixelsPerMM(canvas: TCanvas; var x, y: single);
  var
    H: HDC;
    hres, vres, hsiz, vsiz: integer;
  begin
    H := canvas.handle;
    hres := GetDeviceCaps(H, HORZRES); {display width in pixels}
    vres := GetDeviceCaps(H, VERTRES); {display height in pixels}
    hsiz := GetDeviceCaps(H, HORZSIZE); {display width in mm}
    vsiz := GetDeviceCaps(H, VERTSIZE); {display height in mm}
    x := hres / hsiz;
    y := vres / vsiz;
  end;

var
  HasAnnotation, WithAnno,WithPublicAnnoInitial,WithPrivateAnnoInitial: Boolean;      //-->bfacrm:ticket__show__25389
  PrnLst: TList<TPrinter>;
  i, Cnt, DlgResult: Integer;
  PreviewDlg: TfrmPreviewDlg;
  prev: TbfaPreview;
  papermmx, papermmy: double;
  X, Y: single;
  FPrn: TPrinter;
  ADevice, ADriver, APort: array[0..255] of char;
  ADeviceMode: Cardinal;
  printerPort: PWideChar ; //06.06.2019 Ticket 17923
begin
  bitfarmLog.DebugBegin(llDebug, 'CreatePrintPreviewAction', ClassName);
  try
    try
      prev := bitfarmApp.GetActivePreview;

      if not prev.Floating then
      begin
        frmMainForm.mnuPrint.ImageIndex := prev.actPrintPreview.ImageIndex;
        frmMainForm.mnuPrint.Action := prev.actPrintPreview;
        frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemPrint.Action := prev.actPrintPreview;
      end;

      prev.bfaTlbStandard.tlbStandardSubmenuItemPrint.Action := prev.actPrintPreview;

      if ((not FViewerOptions.GeneralOptions.UseDefaultPrinter) and
          (FViewerOptions.GeneralOptions.DefaultPrinterName = '')) then
      begin
        BfShowMessage(_('Bitte whlen Sie einen anderen Drucker aus oder benutzen') + #13 + _('Sie einen anderen Druckertreiber.'));
        bitfarmLog.Write(llNormal, ltInfo, 'PrintDoc End via Exit #1', ClassName);
        Exit;
      end;

      PreviewDlg := TfrmPreviewDlg.Create(frmMainForm);
      try
        try
          bitfarmLog.Write(llDebug, ltInfo, 'PreviewDlg := TfrmPreviewDlg.Create(nil);', ClassName);

          if FViewerOptions.GeneralOptions.UseDefaultPrinter then
          begin
            bitfarmLog.Write(llDebug, ltInfo, 'FViewerOptions.GeneralOptions.UseDefaultPrinter', ClassName);

            if Printer <> nil then
              bitfarmLog.Write(llDebug, ltInfo, 'Printer Assigned', ClassName)
            else
              bitfarmLog.Write(llDebug, ltInfo, 'Printer NOT Assigned', ClassName);

            bitfarmLog.Write(llDebug, ltInfo, 'Printer.PrinterIndex: ' + IntToStr(Printer.PrinterIndex), ClassName);

            Printer.PrinterIndex := -1; //13.12.2017 Ticket 12890
            bitfarmLog.Write(llDebug, ltInfo, 'Printer.PrinterIndex := -1;', ClassName);
            printerPort := PChar(TPrinterDevice(Printer.Printers.Objects[Printer.PrinterIndex]).Port);
            Printer.SetPrinter(PCHar(Printer.Printers[Printer.PrinterIndex]), nil, printerPort, 0); //13.12.2017 Ticket 12887
            PreviewDlg.Caption := _('Druck - Vorschau - ') + Printer.Printers[Printer.PrinterIndex];
            bitfarmLog.Write(llDebug, ltInfo, 'PreviewDlg.Caption: ' + PreviewDlg.Caption, ClassName);
          end else
          begin
            bitfarmLog.Write(llDebug, ltInfo, 'NOT - FViewerOptions.GeneralOptions.UseDefaultPrinter', ClassName);
            PreviewDlg.Caption := _('Druck - Vorschau - ') + Printer.Printers[Printer.Printers.IndexOf(FViewerOptions.GeneralOptions.DefaultPrinterName)];
            bitfarmLog.Write(llDebug, ltInfo, 'PreviewDlg.Caption: ' + PreviewDlg.Caption, ClassName);
            Printer.PrinterIndex := Printer.Printers.IndexOf(FViewerOptions.GeneralOptions.DefaultPrinterName);
            printerPort := PChar(TPrinterDevice(Printer.Printers.Objects[Printer.PrinterIndex]).Port);
            bitfarmLog.Write(llDebug, ltInfo, 'Printer.PrinterIndex := Printer.Printers.IndexOf(FViewerOptions.GeneralOptions.DefaultPrinterName);', ClassName);
            bitfarmLog.Write(llDebug, ltInfo, 'FViewerOptions.GeneralOptions.DefaultPrinterName: ' + FViewerOptions.GeneralOptions.DefaultPrinterName, ClassName);
            Printer.SetPrinter(PCHar(FViewerOptions.GeneralOptions.DefaultPrinterName), nil, printerPort, 0); //13.12.2017 Ticket 12887
          end;
        except
          BfShowMessage(_('Bitte whlen Sie einen anderen Drucker aus oder benutzen') + #13 + _('Sie einen anderen Druckertreiber.'));
          bitfarmLog.Write(llNormal, ltInfo, 'PrintDoc End via Exit #1', ClassName);
          Exit;
        end;

        HasAnnotation := CloneCurrentDocs(UserAction, OnlyFirstDoc, rightPrint);

        PreviewDlg.Documents := UserAction^.Documents;

        if frmMainForm.popPrivateAnno.Items.Count > 0 then
        begin
          PreviewDlg.popSharedLayer.Items.Clear;
          for i := 0 to frmMainForm.popPrivateAnno.Items.Count -1 do
          begin
            PreviewDlg.popSharedLayer.Items.Add(TSpTBXItem.Create(PreviewDlg.popSharedLayer));
            PreviewDlg.popSharedLayer.Items[i].Caption := frmMainForm.popPrivateAnno.Items[i].Caption;
            PreviewDlg.popSharedLayer.Items[i].Tag := frmMainForm.popPrivateAnno.Items[i].Tag;
          end;
        end;
        if prev.CurrentLayer <> 0 then
          PreviewDlg.PrivateLayer := prev.CurrentLayer
        else
          PreviewDlg.PrivateLayer := FUser.ID;

        TbfaPrinter(PreviewDlg.Prn).Clone(Printer);
        PreviewDlg.chkAnnos.Enabled := HasAnnotation;
        // get the initial state of the checkbox
        //WithAnnoInitial := PreviewDlg.chkAnnos.Checked;      //-->bfacrm:ticket__show__25389
        WithPublicAnnoInitial := prev.bfaTlbPreview.mnuPublicAnno.Checked;  // bfacrm:ticket__show__25389
        WithPrivateAnnoInitial := prev.bfaTlbPreview.mnuPrivateAnno.Checked;  //bfacrm:ticket__show__25389
        PreviewDlg.ShowModal;

        if PreviewDlg.ModalResult = mrCancel then
        begin
          bitfarmLog.Write(llNormal, ltInfo, 'PrintDoc End via Exit #2', ClassName);
          Exit;
        end;

        if PreviewDlg.chkStationery.Checked then
          UserAction^.params.Add('1')
        else
          UserAction^.params.Add('0');

        WithAnno := False;
      //  WithAnnoFinal := PreviewDlg.chkAnnos.Checked;      //-->bfacrm:ticket__show__25389
       // if (HasAnnotation ) then
       // begin
           // -->bfacrm:ticket__show__23291
          {if (WithAnnoFinal <> WithAnnoInitial) then}

        if HasAnnotation {and (WithAnnoInitial = True )and (WithAnnoFinal= False)} then
        begin
          DlgResult := BfMessageDlg(_('Das Dokument hat Anmerkungen. Sollen diese mit gedruckt werden?'), mtConfirmation, [mbYes, mbNo, mbCancel]);
          bitfarmLog.Write(llNormal, ltInfo, 'DlgResult=' + Dlgresult.ToString, ClassName); //01.08.2023
        end;

              if ((HasAnnotation) and (DlgResult = mrYes)) then
        begin
          //if PreviewDlg.rbnPrivate.Checked then here commented
          if prev.bfaTlbPreview.mnuPrivateAnno.Checked then
          begin
            UserAction^.params.Add('1'); //Private
            UserAction^.params.Add('0'); //Public
            UserAction^.params.Add(IntToStr(user.ID)); //Layer
          end else
          begin
            UserAction^.params.Add('0'); //Private
            UserAction^.params.Add('1'); //Public
            UserAction^.params.Add('0'); //Layer
          end;
        end else
        begin
          UserAction^.params.Add('0'); //Private
          UserAction^.params.Add('0'); //Public
          UserAction^.params.Add('-1'); //Layer
        end;

            //-->bfacrm:ticket__show__25391
            { //bfacrm:ticket__show__25389
             if ((HasAnnotation) and (DlgResult = mrYes)) then
             begin
            if PreviewDlg.rbnPrivate.Checked then
            begin
              UserAction^.params.Add('1'); //Private
              UserAction^.params.Add('0'); //Public
              UserAction^.params.Add(IntToStr(user.ID)); //Layer
            end
            else
            begin
              UserAction^.params.Add('0'); //Private
              UserAction^.params.Add('1'); //Public
              UserAction^.params.Add('0'); //Layer
            end;
          end
          // bfacrm:ticket__show__24796
//          else if ((WithAnnoInitial = False) and
//           (BfMessageDlg(_('Das Dokument hat Anmerkungen. Sollen diese mit gedruckt werden?'), mtConfirmation, [mbYes, mbNo]) = mrYes)) then

          else if (WithAnnoInitial = False) then
          begin
            DlgResult := BfMessageDlg(_('Das Dokument hat Anmerkungen. Sollen diese mit gedruckt werden?'), mtConfirmation, [mbYes, mbNo, mbCancel]);
            if (DlgResult = mrCancel) then
            begin
              Dispose(UserAction);
              Exit;
            end
            else if (DlgResult = mrYes) then
            begin
            // bfacrm:ticket__show__24796
            WithAnno := True;
            if PreviewDlg.rbnPrivate.Checked then
            begin
              UserAction^.params.Add('1'); //Private
              UserAction^.params.Add('0'); //Public
                UserAction^.params.Add(IntToStr(PreviewDlg.PrivateLayer)); //Layer
            end
            else
            begin
              UserAction^.params.Add('0'); //Private
              UserAction^.params.Add('1'); //Public
              UserAction^.params.Add('0'); //Layer
            end;
          end;
          end;
         //  <-- bfacrm:ticket__show__23291
        end
        else
        begin
          UserAction^.params.Add('0'); //Private
          UserAction^.params.Add('0'); //Public
          UserAction^.params.Add('-1'); //Layer
        end;
           } //<--bfacrm:ticket__show__25391
        if PreviewDlg.chkMergeDocuments.Checked then
          UserAction^.params.Add('1')
        else
          UserAction^.params.Add('0');

        if PreviewDlg.chkCenter.Checked then
          UserAction^.params.Add('1')
        else
          UserAction^.params.Add('0');

        if PreviewDlg.chkRotate.Checked then
          UserAction^.params.Add('1')
        else
          UserAction^.params.Add('0');

        UserAction^.params.Add(VarToStr(PreviewDlg.edtLeft.Value));
        UserAction^.params.Add(VarToStr(PreviewDlg.edtTop.Value));
        UserAction^.params.Add(VarToStr(PreviewDlg.edtRight.Value));
        UserAction^.params.Add(VarToStr(PreviewDlg.edtBottom.Value));

        UserAction^.params.Add(VarToStr(PreviewDlg.edtCopies.Value));
        bitfarmLog.Write(llDebug, ltInfo, 'PreviewDlg.edtCopies.Text: ' + PreviewDlg.edtCopies.Text, ClassName);
        bitfarmLog.Write(llDebug, ltInfo, 'PreviewDlg.edtCopies.Value: ' + VarToStr(PreviewDlg.edtCopies.Value), ClassName);

        if PreviewDlg.chkSort.Checked then
          UserAction^.params.Add('1')
        else
          UserAction^.params.Add('0');

        if PreviewDlg.cbx_Size.ItemIndex = 3 then
        begin
          UserAction^.params.Add(VarToStr(PreviewDlg.nedt_SWidth.Value));
          UserAction^.params.Add(VarToStr(PreviewDlg.nedt_SHeight.Value));
        end else
        begin
          UserAction^.params.Add(FloatToStr(785.91496063));
          UserAction^.params.Add(FloatToStr(1126.412598425));
        end;

        UserAction^.params.Add(PreviewDlg.StationeryPath);

        PrnLst := TList<TPrinter>.Create;
        if PreviewDlg.chkMergeDocuments.Checked then
          Cnt := 0
        else
          Cnt := UserAction^.Documents.Count - 1;

        bitfarmLog.Write(llDebug, ltInfo, 'PrnLst := TList<TPrinter>.Create;', ClassName);

        for i := 0 to Cnt do
        begin
          FPrn := TPrinter.Create;
          if PreviewDlg.PrnName <> '' then
          begin
            TbfaPrinter(FPrn).Clone(PreviewDlg.Prn);
          end else
          begin
            bitfarmLog.Write(llDebug, ltInfo, 'PreviewDlg.PrnName = ""', ClassName);
            if Printer.PrinterIndex <> -1 then
            begin
              TbfaPrinter(FPrn).Clone(Printer);
            end else
            begin
              Printer.PrinterIndex := Printer.Printers.IndexOf(FViewerOptions.GeneralOptions.DefaultPrinterName);
              TbfaPrinter(FPrn).Clone(Printer);
            end;
          end;

          if TbfaDocument(UserAction^.Documents[i]).DocName <> '' then
            FPrn.Title := TbfaDocument(UserAction^.Documents[i]).DocName
          else
            FPrn.Title := _('Dokument');

          try
            FPrn.Copies := 1; //16.08.2018
          except
            //26.10.2018 Ticket 16548 Nicht alle Printer kann Kopie setzen
          end;
          FPrn.BeginDoc;
          bitfarmLog.Write(llDebug, ltInfo, 'Prn.BeginDoc;', ClassName);
          PrnLst.Add(FPrn);
          bitfarmLog.Write(llDebug, ltInfo, 'PrnList.Add(FPrn);', ClassName);
//          end;
        end;

        UserAction^.objects := TList.Create;
        UserAction^.objects.Add(PrnLst);

        case PreviewDlg.cbx_Size.ItemIndex of
          0:
            UserAction^.objects.Add(TObject(iesNORMAL));
          1:
            UserAction^.objects.Add(TObject(iesFITTOPAGE));
          2:
            UserAction^.objects.Add(TObject(iesFITTOPAGESTRETCH));
          3:
            UserAction^.objects.Add(TObject(iesSPECIFIEDSIZE));
        else
          UserAction^.objects.Add(TObject(iesFITTOPAGE));
        end;

        if (HasAnnotation) and (WithAnno) then
          UserAction^.params.Add('1')
        else
          UserAction^.params.Add('0');

        FBackThread.Add(UserAction);
      finally
        PreviewDlg.Release;
      end;
    except
      on e: Exception do
      begin
        bitfarmLog.Write(llNormal, ltException, 'CreatePrintPreviewAction: ' + e.Message, ClassName);
        BfShowMessage(_('Fehler beim Drucken eines Dokumentes: ') + e.Message);
      end;
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreatePrintPreviewAction', ClassName);
  end;
end;

function TbfaApplication.CreateLocalSaveAction(UserAction: PUserAction;
    OnlyFirstDoc: Boolean; DocIdx: Integer = -1; SaveDir: WideString = '';
    FileName: WideString = ''; ThreadType: Integer = 0; Doc: TbfaDocument = nil): Boolean;
var
  HasAnnotation, WithAnno, WithPublicAnnoInitial, WithPrivateAnnoInitial: Boolean;
  dlg: TFileOpenDialog;
  FName: string;
  i, j, DlgResult: Integer;
  Newdoc: TbfaDocument;
begin
// <!-- SJ 16.07.2021 - Result eingebaut
// TODO SJ: Result an anderen Stellen noch prfen
  Result := True;
  bitfarmLog.DebugBegin(llDebug, 'CreateLocalSaveAction', ClassName);
  try
    try
      if SaveDir = '' then
      begin
        if FViewerOptions.GeneralOptions.DefaultSaveDirectory = '' then
        begin
          dlg := TFileOpenDialog.Create(nil);
          try
            dlg.Title := _('Bitte whlen Sie ein Verzeichnis');
            dlg.DefaultFolder := frmMainForm.fLastDir;
            dlg.Options := [fdoPickFolders];
            if dlg.Execute then
              frmMainForm.fLastDir := dlg.FileName
            else
              Exit;
          finally
            FreeAndNil(dlg);
          end;
        end
        else
          frmMainForm.fLastDir := FViewerOptions.GeneralOptions.DefaultSaveDirectory;
      end;

      // Ticket bfacrm:ticket__show__23109
      if (ThreadType = -1) and (Doc <> nil) then  // Plugins laden das Dokument nicht ber CloneCurrentDocs, sonst werden dadurch bei Mehrfachauswahl Streams in FCurrentContainer geladen, die nie wieder freigegeben werden
      begin
        if (Doc.DocStream.Size = 0) and (Doc.Id <> -1) then
        begin
          if (not OfflineMode) then
            LoadDocumentViaSocket(Doc, 'base;paths;iev', nil)
          //10.02.2023 bfacrm:ticket__show__33894 -->
          else
            DBLoadDocument(Doc);
          //10.02.2023 bfacrm:ticket__show__33894 <--
        end;

        if ((Doc.LetterStream <> nil) and (Doc.LetterStream.Size = 0)) and ((UserAction^.Preview <> nil) and (UserAction^.Preview.bfaTlbPreview.sbmStationery.Checked)) then
        begin
          FName := '';
          for i := 0 to UserAction^.Preview.bfaTlbPreview.sbmStationery.Count - 1 do
            if UserAction^.Preview.bfaTlbPreview.sbmStationery[i].Checked then
              FName := UserAction^.Preview.bfaTlbPreview.sbmStationery[i].Caption;

          bitfarmApp.LoadStationeryToDocument(Doc, FName);
        end;

        UserAction^.Documents.Add(Doc);
        HasAnnotation := Doc.HasAnnotation;

        UserAction^.FreeObjects := True;

      end
      else if (UserAction^.ActionName = 'actSaveCollectionPDF') or
              (UserAction^.ActionName = 'actSaveCollectionSinglePDF') or
              (UserAction^.ActionName = 'actSaveCollectionTIF') or
              (UserAction^.ActionName = 'actSaveCollectionOriginal')
      then begin
        for i := 0 to CollectionContainer.Count -1 do
        begin
          Newdoc := TbfaDocument.Create;
          Newdoc.Clone(CollectionContainer[i]);
          if (Newdoc.DocStream.Size = 0) and (Newdoc.Id <> -1) then
          begin
            if (not OfflineMode) then
              LoadDocumentViaSocket(Newdoc, 'base;paths;iev', nil)
            //10.02.2023 bfacrm:ticket__show__33894 -->
            else
              DBLoadDocument(NewDoc);
            //10.02.2023 bfacrm:ticket__show__33894 <--
          end;

          //12.08.2022 Ticket 28973 -->
          if (Newdoc.Rights and rightWrite) <> rightWrite then
            Continue;
          //12.08.2022 Ticket 28973 <--


          if ((Newdoc.LetterStream <> nil) and (Newdoc.LetterStream.Size = 0)) and
              ((UserAction^.Preview <> nil) and (UserAction^.Preview.bfaTlbPreview.sbmStationery.Checked)) then
          begin
            FName := '';
            for j := 0 to UserAction^.Preview.bfaTlbPreview.sbmStationery.Count - 1 do
              if UserAction^.Preview.bfaTlbPreview.sbmStationery[j].Checked then
                FName := UserAction^.Preview.bfaTlbPreview.sbmStationery[j].Caption;

            bitfarmApp.LoadStationeryToDocument(Newdoc, FName);
          end;

          UserAction^.Documents.Add(Newdoc);
          HasAnnotation := HasAnnotation or Newdoc.HasAnnotation;
        end;
      end else
        HasAnnotation := CloneCurrentDocs(UserAction, OnlyFirstDoc, rightWrite, DocIdx, False);

      if frmMainForm.bfaTlbPreview1.mnuStationery.Checked or frmMainForm.bfaTlbPreview1.sbmStationery.Checked then
        UserAction^.params.Add('1')
      else
        UserAction^.params.Add('0');

      if not VarIsNull(FDoPluginWithAnno) then
        WithAnno := FDoPluginWithAnno
      else
        WithAnno := False;

      // SJ 17.05.2022 - bfacrm:ticket__show__30785
//       WithPublicAnnoInitial := frmMainForm.bfaTlbPreview1.mnuPublicAnno.Enabled and frmMainForm.bfaTlbPreview1.mnuPublicAnno.Checked;   // bfacrm:ticket__show__25389

      // SJ 04.10.2022 - bfacrm:ticket__show__32506
//       WithPublicAnnoInitial := (frmMainForm.bfaTlbPreview1.mnuPublicAnno.Enabled and frmMainForm.bfaTlbPreview1.mnuPublicAnno.Checked)
//         or ((UserAction^.Documents.Count > 1) and HasAnnotation and frmMainForm.bfaTlbPreview1.mnuPublicAnno.Checked);

       WithPublicAnnoInitial := (frmMainForm.bfaTlbPreview1.mnuPublicAnno.Checked and (CurrentView in [tvkImporter, tvkWorkplace])) or
         (frmMainForm.bfaTlbPreview1.mnuPublicAnno.Enabled and frmMainForm.bfaTlbPreview1.mnuPublicAnno.Checked) or
         ((UserAction^.Documents.Count > 1) and HasAnnotation and frmMainForm.bfaTlbPreview1.mnuPublicAnno.Checked);

       bitfarmLog.Write(llNormal, ltInfo, 'HasAnnotation=' + HasAnnotation.ToString, ClassName); //23.04.2024
       bitfarmLog.Write(llNormal, ltInfo, 'WithPublicAnnoInitial=' + WithPublicAnnoInitial.ToString, ClassName); //23.04.2024

       WithPrivateAnnoInitial := frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Checked;  // bfacrm:ticket__show__25389

       bitfarmLog.Write(llNormal, ltInfo, 'WithPrivateAnnoInitial=' + WithPrivateAnnoInitial.ToString, ClassName); //23.04.2024
       bitfarmLog.Write(llNormal, ltInfo, 'WithAnno=' + WithAnno.ToString, ClassName); //23.04.2024

      if (HasAnnotation) and (UserAction^.ActionName <> 'actLocalSaveOriginal') and (not WithAnno) and (VarIsNull(FDoPluginWithAnno)) then
      begin
        // bfacrm:ticket__show__24796
        // bfacrm:ticket__show__25389
        // bfacrm:ticket__show__30785
          if HasAnnotation and
//23.04.2024 ???            ((WithPublicAnnoInitial = True) and (WithPrivateAnnoInitial = False) or
             ((WithPublicAnnoInitial) and (not WithPrivateAnnoInitial) or
              (WithPrivateAnnoInitial and (UserAction^.Documents.Count > 1))) then
          begin
            DlgResult := BfMessageDlg(_('Das Dokument hat Anmerkungen. Sollen diese mit gespeichert werden?'), mtConfirmation, [mbYes, mbNo, mbCancel]);
            bitfarmLog.Write(llNormal, ltInfo, 'DlgResult=' + Dlgresult.ToString, ClassName); //01.08.2023
          end;

          if HasAnnotation and (WithPublicAnnoInitial = WithPrivateAnnoInitial) and (WithPrivateAnnoInitial = True) then
            DlgResult := mrYes;

          if HasAnnotation and (WithPublicAnnoInitial = False) and (WithPrivateAnnoInitial = True) then
            DlgResult := mrYes;

        //bfacrm:ticket__show__25389
       // DlgResult := BfMessageDlg(_('Das Dokument hat Anmerkungen. Sollen diese mit gespeichert werden?'), mtConfirmation, [mbYes, mbNo, mbCancel]);// here commented
        if (HasAnnotation) and (DlgResult = mrCancel) then
        begin
//          Dispose(UserAction);
          Result := False;
          Exit;
        end;

        WithAnno := (DlgResult = mrYes);
        // bfacrm:ticket__show__24796
        if FPluginIsRunning then
          FDoPluginWithAnno := WithAnno;
      end;

      if ((HasAnnotation) and (UserAction^.ActionName <> 'actLocalSaveOriginal') and (WithAnno)) then
      begin
        if frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Enabled and frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Checked then
        begin
          UserAction^.params.Add('1'); //Private
          UserAction^.params.Add('0'); //Public
          if (UserAction^.Preview <> nil) and (UserAction^.Preview.CurrentLayer <> -1) then
            UserAction^.params.Add(IntToStr(UserAction^.Preview.CurrentLayer)) //Layer
          else
          UserAction^.params.Add(IntToStr(user.ID)); //Layer
        end
        else if frmMainForm.bfaTlbPreview1.mnuPublicAnno.Enabled and frmMainForm.bfaTlbPreview1.mnuPublicAnno.Checked then
        begin
          UserAction^.params.Add('0'); //Private
          UserAction^.params.Add('1'); //Public
          UserAction^.params.Add('0'); //Layer
        end else
        begin
          UserAction^.params.Add('0'); //Private
          UserAction^.params.Add('1'); //Public
          UserAction^.params.Add('0'); //Layer
        end;
      end else
      begin
        UserAction^.params.Add('0'); //Private
        UserAction^.params.Add('0'); //Public
        UserAction^.params.Add('-1'); //Layer
      end;

      if (UserAction^.ActionName = 'actSaveCollectionSinglePDF') then
        UserAction^.params.Add('1')       //Merge
      else
        UserAction^.params.Add('0');

      if SaveDir = '' then
        UserAction^.params.Add(frmMainForm.fLastDir)  //SaveDir
      else
        UserAction^.params.Add(SaveDir);  //SaveDir

      if (UserAction^.ActionName = 'actLocalSaveTIF') then
        UserAction^.params.Add(IntToStr(sftTIF))
      else if (UserAction^.ActionName = 'actSaveCollectionTIF') then
      begin
        UserAction^.params.Add(IntToStr(sftTIF));
        UserAction^.ActionName := 'actLocalSaveTIF';
      end
      else if (UserAction^.ActionName = 'actLocalSavePDF') then
        UserAction^.params.Add(IntToStr(sftPDF))
      else if (UserAction^.ActionName = 'actSaveCollectionPDF') then
      begin
        UserAction^.params.Add(IntToStr(sftPDF));
        UserAction^.ActionName := 'actLocalSavePDF';
      end
      else if (UserAction^.ActionName = 'actSaveCollectionSinglePDF') then
      begin
        UserAction^.params.Add(IntToStr(sftPDF));
        UserAction^.ActionName := 'actLocalSavePDF';
      end
      else if (UserAction^.ActionName = 'actLocalSaveOriginal') then
        UserAction^.params.Add(IntToStr(sftORI))
      else if (UserAction^.ActionName = 'actSaveCollectionOriginal') then
      begin
        UserAction^.params.Add(IntToStr(sftORI));
        UserAction^.ActionName := 'actLocalSaveOriginal';
      end;

      UserAction^.params.Add('');    //StationeryPath
      UserAction^.params.Add('1');   //Copies
      UserAction^.params.Add('0');   //Sort
      UserAction^.params.Add(IntToStr(alSave)); // alSave, alEmail
      UserAction^.params.Add(FileName); // Dateiname

      if ThreadType <> -1 then // Extra fr Plugin, weil dann muss sofort ausgefhrt werden
      begin
        if ThreadType = 0 then // 0 = BackThread
          FBackThread.Add(UserAction)
        else // 1 = MainThread (Beim Plugins muss im MainThread laufen!)
          FMainThread.Add(UserAction);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'CreateLocalSaveAction', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateLocalSaveAction', ClassName);
  end;
end;

procedure TbfaApplication.CreateLocalSavePDFAction(UserAction: PUserAction; OnlyFirstDoc: Boolean; ThreadType: Integer = 0);
var
  prev: TbfaPreview;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateLocalSavePDFAction', ClassName);
  try
    try
      prev := bitfarmApp.GetActivePreview;

      if not prev.Floating then
      begin
        frmMainForm.mnuLocalSave.ImageIndex := prev.actLocalSavePDF.ImageIndex;
        frmMainForm.mnuLocalSave.Action := prev.actLocalSavePDF;
        frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action := prev.actLocalSavePDF;
      end;
      prev.bfaTlbStandard.tlbStandardSubmenuItemSave.Action := prev.actLocalSavePDF;

      frmMainForm.actLocalSavePDF.Tag := 1;
      frmMainForm.actLocalSaveTIF.Tag := 0;
      frmMainForm.actLocalSaveOriginal.Tag := 0;
      frmMainForm.actLocalSavePreview.Tag := 0;
      frmMainForm.actLocalSaveLink.Tag := 0;

      CreateLocalSaveAction(UserAction, OnlyFirstDoc, -1, '', '', ThreadType);
    except
      bitfarmLog.Write(llNormal, ltException, 'CreateLocalSavePDFAction', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateLocalSavePDFAction', ClassName);
  end;
end;

procedure TbfaApplication.CreateLocalSaveTIFAction(UserAction: PUserAction; OnlyFirstDoc: Boolean; DocIdx: Integer = -1; SaveDir: WideString = ''; FileName: WideString = ''; ThreadType: Integer = 0);
var
  prev: TbfaPreview;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateLocalSaveTIFAction', ClassName);
  try
    try
      prev := bitfarmApp.GetActivePreview;
      if not prev.Floating then
      begin
        frmMainForm.mnuLocalSave.ImageIndex := prev.actLocalSaveTIF.ImageIndex;
        frmMainForm.mnuLocalSave.Action := prev.actLocalSaveTIF;
        frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action := prev.actLocalSaveTIF;
      end;
      prev.bfaTlbStandard.tlbStandardSubmenuItemSave.Action := prev.actLocalSaveTIF;

      frmMainForm.actLocalSavePDF.Tag := 0;
      frmMainForm.actLocalSaveTIF.Tag := 1;
      frmMainForm.actLocalSaveOriginal.Tag := 0;
      frmMainForm.actLocalSavePreview.Tag := 0;
      frmMainForm.actLocalSaveLink.Tag := 0;

      CreateLocalSaveAction(UserAction, OnlyFirstDoc, DocIdx, SaveDir, FileName, ThreadType);
    except
      bitfarmLog.Write(llNormal, ltException, 'CreateLocalSaveTIFAction', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateLocalSaveTIFAction', ClassName);
  end;
end;

procedure TbfaApplication.CreateLocalSaveOriginalAction(UserAction: PUserAction; OnlyFirstDoc: Boolean; ThreadType: Integer = 0);
var
  prev: TbfaPreview;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateLocalSaveOriginalAction', ClassName);
  try
    try
      prev := bitfarmApp.GetActivePreview;
      if not prev.Floating then
      begin
        frmMainForm.mnuLocalSave.ImageIndex := prev.actLocalSaveOriginal.ImageIndex;
        frmMainForm.mnuLocalSave.Action := prev.actLocalSaveOriginal;
        frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action := prev.actLocalSaveOriginal;
      end;
      prev.bfaTlbStandard.tlbStandardSubmenuItemSave.Action := prev.actLocalSaveOriginal;

      frmMainForm.actLocalSavePDF.Tag := 0;
      frmMainForm.actLocalSaveTIF.Tag := 0;
      frmMainForm.actLocalSaveOriginal.Tag := 1;
      frmMainForm.actLocalSavePreview.Tag := 0;
      frmMainForm.actLocalSaveLink.Tag := 0;

      CreateLocalSaveAction(UserAction, OnlyFirstDoc, -1, '', '', ThreadType);
    except
      bitfarmLog.Write(llNormal, ltException, 'CreateLocalSaveOriginalAction', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateLocalSaveOriginalAction', ClassName);
  end;
end;

procedure TbfaApplication.CreateLocalSavePreviewAction(UserAction: PUserAction; OnlyFirstDoc: Boolean);
var
  PreviewDlg: TfrmPreviewDlg;
  prev: TbfaPreview;
  HasAnnotation,WithPublicAnnoInitial,WithPrivateAnnoInitial: Boolean; //-->bfacrm:ticket__show__25389   1/5/2021
  dlg : TFileOpenDialog;
  i, DlgResult: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateLocalSavePreviewAction', ClassName);
  try
    try
      prev := bitfarmApp.GetActivePreview;
      if not prev.Floating then
      begin
        frmMainForm.mnuLocalSave.ImageIndex := prev.actLocalSavePreview.ImageIndex;
        frmMainForm.mnuLocalSave.Action := prev.actLocalSavePreview;
        frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action := prev.actLocalSavePreview;
      end;
      prev.bfaTlbStandard.tlbStandardSubmenuItemSave.Action := prev.actLocalSavePreview;

      frmMainForm.actLocalSavePDF.Tag := 0;
      frmMainForm.actLocalSaveTIF.Tag := 0;
      frmMainForm.actLocalSaveOriginal.Tag := 0;
      frmMainForm.actLocalSavePreview.Tag := 1;
      frmMainForm.actLocalSaveLink.Tag := 0;

      if FViewerOptions.GeneralOptions.DefaultSaveDirectory = '' then
      begin
        dlg := TFileOpenDialog.Create(nil);
        try
          dlg.Title := _('Bitte whlen Sie ein Verzeichnis');
          dlg.DefaultFolder := frmMainForm.fLastDir;
          dlg.Options := [fdoPickFolders];
          if dlg.Execute then
            frmMainForm.fLastDir := dlg.FileName
          else
            Exit;
        finally
          FreeAndNil(dlg);
        end;
      end
      else
        frmMainForm.fLastDir := FViewerOptions.GeneralOptions.DefaultSaveDirectory;

      PreviewDlg := TfrmPreviewDlg.Create(frmMainForm);
      try
        PreviewDlg.Caption := _('Speicher - Vorschau');
        PreviewDlg.DlgType := dlgSave;

        HasAnnotation := CloneCurrentDocs(UserAction, OnlyFirstDoc, rightWrite);

        PreviewDlg.Documents := UserAction^.Documents;
       // WithAnnoInitial := PreviewDlg.chkAnnos.Checked;  //-->bfacrm:ticket__show__25389   1/5/2021
        WithPublicAnnoInitial := prev.bfaTlbPreview.mnuPublicAnno.Checked;  // bfacrm:ticket__show__25389
        WithPrivateAnnoInitial := prev.bfaTlbPreview.mnuPrivateAnno.Checked;  // bfacrm:ticket__show__25389

        if frmMainForm.popPrivateAnno.Items.Count > 0 then
        begin
          PreviewDlg.popSharedLayer.Items.Clear;
          for i := 0 to frmMainForm.popPrivateAnno.Items.Count -1 do
          begin
            PreviewDlg.popSharedLayer.Items.Add(TSpTBXItem.Create(PreviewDlg.popSharedLayer));
            PreviewDlg.popSharedLayer.Items[i].Caption := frmMainForm.popPrivateAnno.Items[i].Caption;
            PreviewDlg.popSharedLayer.Items[i].Tag := frmMainForm.popPrivateAnno.Items[i].Tag;
          end;
        end;
        if prev.CurrentLayer <> 0 then
          PreviewDlg.PrivateLayer := prev.CurrentLayer
        else
          PreviewDlg.PrivateLayer := FUser.ID;

        PreviewDlg.ShowModal;
        if PreviewDlg.ModalResult = mrCancel then
        begin
          bitfarmLog.Write(llNormal, ltInfo, 'PrintDoc End via Exit #2', ClassName);
          Exit;
        end;

        if PreviewDlg.chkStationery.Checked then
          UserAction^.params.Add('1')
        else
          UserAction^.params.Add('0');
      //  WithAnnoFinal := PreviewDlg.chkAnnos.Checked;     //-->bfacrm:ticket__show__25389   1/5/2021 here
          WithPrivateAnnoInitial := GetActivePreview.bfaTlbPreview.mnuPrivateAnno.Checked;
        // bfacrm:ticket__show__24796
        //if HasAnnotation then
        //-->bfacrm:ticket__show__25389   1/5/2021

        // if HasAnnotation then         // -->bfacrm:ticket__show__25389
        if HasAnnotation and (WithPublicAnnoInitial = True) and (WithPrivateAnnoInitial = False) then
        begin
          DlgResult := BfMessageDlg(_('Das Dokument hat Anmerkungen. Sollen diese mit gespeichert werden?'), mtConfirmation, [mbYes, mbNo, mbCancel]);
          bitfarmLog.Write(llNormal, ltInfo, 'DlgResult=' + Dlgresult.ToString, ClassName); //01.08.2023
        end;

        if HasAnnotation and (WithPublicAnnoInitial = WithPrivateAnnoInitial) and (WithPrivateAnnoInitial = True) then
            DlgResult := mrYes;

        if HasAnnotation and (WithPublicAnnoInitial = False) and (WithPrivateAnnoInitial = True) then
            DlgResult := mrYes;              // <--  // bfacrm:ticket__show__25389

        bitfarmLog.Write(llNormal, ltInfo, 'DlgResult=' + Dlgresult.ToString, ClassName); //01.08.2023

        if (DlgResult = mrCancel) then
        begin
          Dispose(UserAction);
          Exit;
        end else
        // bfacrm:ticket__show__24796
        if ((HasAnnotation) and (DlgResult = mrYes)) then          //bfacrm:ticket__show__25389
        begin
//          if PreviewDlg.rbnPrivate.Checked then          // bfacrm:ticket__show__25389
          if prev.bfaTlbPreview.mnuPrivateAnno.Checked  and prev.bfaTlbPreview.mnuPrivateAnno.Enabled then

          begin
            UserAction^.params.Add('1'); //Private
            UserAction^.params.Add('0'); //Public
            UserAction^.params.Add(IntToStr(PreviewDlg.PrivateLayer)); //Layer
          end else
          begin
            UserAction^.params.Add('0'); //Private
            UserAction^.params.Add('1'); //Public
            UserAction^.params.Add('0'); //Layer
          end;
        end else
        begin
          UserAction^.params.Add('0'); //Private
          UserAction^.params.Add('0'); //Public
          UserAction^.params.Add('-1'); //Layer
        end;

        if PreviewDlg.chkMergeDocuments.Checked then
          UserAction^.params.Add('1')
        else
          UserAction^.params.Add('0');

        UserAction^.params.Add(frmMainForm.fLastDir); //SaveDir

        if (PreviewDlg.rbnTIF.Checked) then
          UserAction^.params.Add(IntToStr(sftTIF))
        else if (PreviewDlg.rbnPDF.Checked) then
          UserAction^.params.Add(IntToStr(sftPDF))
        else if (PreviewDlg.rbnSaveOriginal.Checked) then
          UserAction^.params.Add(IntToStr(sftORI));

        UserAction^.params.Add(PreviewDlg.StationeryPath); //StationeryPath
        UserAction^.params.Add(PreviewDlg.edtCopies.Text); //Copies
        if PreviewDlg.chkSort.Checked then //Sort
          UserAction^.params.Add('1')
        else
          UserAction^.params.Add('0');

        UserAction^.params.Add(IntToStr(alSave)); // alSave, alEmail

        UserAction^.params.Add(''); //FileName

        FBackThread.Add(UserAction);
      finally
        PreviewDlg.Release;
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'CreateLocalSavePreviewAction', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateLocalSavePreviewAction', ClassName);
  end;
end;

procedure TbfaApplication.CreateEmailAttachmentAction(UserAction: PUserAction; OnlyFirstDoc: Boolean; DocType: Integer);
var
  HasAnnotation: Boolean;
  DirGUID: TGUID;
  prev: TbfaPreview;
  DlgResult: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateEmailAttachmentAction', ClassName);
  try
    try
      prev := bitfarmApp.GetActivePreview;

      if prev = nil then
      begin
        bitfarmLog.Write(llNormal, ltInfo, 'CreateEmailAttachmentAction - prev = nil', ClassName);
        Exit;
      end;

      if not prev.Floating then
      begin
        if DocType = sftTIF then
        begin
          frmMainForm.mnuEmail.ImageIndex := prev.actEmailTIFAttachment.ImageIndex;
          frmMainForm.mnuEmail.Action := prev.actEmailTIFAttachment;
          frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action := prev.actEmailTIFAttachment;
        end
        else if DocType = sftPDF then
        begin
          frmMainForm.mnuEmail.ImageIndex := prev.actEmailPDFAttachment.ImageIndex;
          frmMainForm.mnuEmail.Action := prev.actEmailPDFAttachment;
          frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action := prev.actEmailPDFAttachment;
        end;
      end;

      if DocType = sftTIF then
        prev.bfaTlbStandard.tlbStandardSubmenuItemEmail.Action := prev.actEmailTIFAttachment
      else if DocType = sftPDF then
        prev.bfaTlbStandard.tlbStandardSubmenuItemEmail.Action := prev.actEmailPDFAttachment;

      // SJ - bfacrm:ticket__show__33571
      // wir setzen die Tags zurck und dann den korrekten
      // Achtung: nicht prev.actEmailPDFAttachment/prev.actEmailTIFAttachment
      //          sondern frmMainForm.actEmailPDFAttachment/frmMainForm.actEmailPDFAttachment
      frmMainForm.actEmailPDFAttachment.Tag := (DocType = sftPDF).ToInteger;
      frmMainForm.actEmailTIFAttachment.Tag := (DocType = sftTIF).ToInteger;
      frmMainForm.actEmailLink.Tag := 0;
      frmMainForm.actEmailOriginal.Tag := 0;
      frmMainForm.actEmailPreview.Tag := 0;
      // SJ - bfacrm:ticket__show__33571

      HasAnnotation := CloneCurrentDocs(UserAction, OnlyFirstDoc, rightEmail);

      if frmMainForm.bfaTlbPreview1.mnuStationery.Checked or frmMainForm.bfaTlbPreview1.sbmStationery.Checked then
        UserAction^.params.Add('1')
      else
        UserAction^.params.Add('0');

      // bfacrm:ticket__show__24796
      if HasAnnotation then
      begin
        DlgResult := BfMessageDlg(_('Das Dokument hat Anmerkungen. Sollen diese mit versandt werden?'), mtConfirmation, [mbYes, mbNo, mbCancel]);
        bitfarmLog.Write(llNormal, ltInfo, 'DlgResult=' + Dlgresult.ToString, ClassName); //01.08.2023
      end;

      if (HasAnnotation) and (DlgResult = mrCancel) then
      begin
        Dispose(UserAction);
        Exit;
      end else
      // bfacrm:ticket__show__24796
      if (HasAnnotation) and (DlgResult = mrYes) then
      begin
        if frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Checked then
        begin
          UserAction^.params.Add('1'); //Private
          UserAction^.params.Add('0'); //Public
          UserAction^.params.Add(IntToStr(prev.CurrentLayer)); //Layer
        end
        else if frmMainForm.bfaTlbPreview1.mnuPublicAnno.Checked then
        begin
          UserAction^.params.Add('0'); //Private
          UserAction^.params.Add('1'); //Public
          UserAction^.params.Add('0'); //Layer
        end else
        begin
          UserAction^.params.Add('0'); //Private
          UserAction^.params.Add('1'); //Public
          UserAction^.params.Add('0'); //Layer
        end;
      end else
      begin
        UserAction^.params.Add('0'); //Private
        UserAction^.params.Add('0'); //Public
        UserAction^.params.Add('-1'); //Layer
      end;

      UserAction^.params.Add('0'); //MergeDocuments
      CreateGUID(DirGUID);
      if ForceDirectories(BD.EnvTempPd + 'bfa_sendnow\' + GUIDToString(DirGUID)) then
      begin
        UserAction^.params.Add(BD.EnvTempPd + 'bfa_sendnow\' + GUIDToString(DirGUID));   //SaveDir
        UserAction^.params.Add(IntToStr(DocType)); //Typ

        UserAction^.params.Add(''); //StationeryPath
        UserAction^.params.Add('1'); //Copies
        UserAction^.params.Add('0'); //Sort
        UserAction^.params.Add(IntToStr(alEmail)); // alSave, alEmail
        UserAction^.params.Add(''); //Filename
        UserAction^.params.Add(IntToStr(emtAttachment)); //E-Mail Type

        FBackThread.Add(UserAction);
      end else
      begin
        BfMessageDlg(_('Ordner kann nicht erstellt werden! (' + BD.EnvTempPd + 'bfa_sendnow\' + GUIDToString(DirGUID) + ')'), mtError, [mbOK]);
        Exit;
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'CreateEmailAttachmentAction', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateEmailAttachmentAction', ClassName);
  end;
end;

procedure TbfaApplication.CreateEmailOriginalAction(UserAction: PUserAction; OnlyFirstDoc: Boolean);
var
  HasAnnotation: Boolean;
  DirGUID: TGUID;
  prev: TbfaPreview;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateEmailOriginalAction', ClassName);
  try
    try
      prev := bitfarmApp.GetActivePreview;

      if not prev.Floating then
      begin
        frmMainForm.mnuEmail.ImageIndex := prev.actEmailOriginal.ImageIndex;
        frmMainForm.mnuEmail.Action := prev.actEmailOriginal;
        frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action := prev.actEmailOriginal;
      end;
      prev.bfaTlbStandard.tlbStandardSubmenuItemEmail.Action := prev.actEmailOriginal;

      // SJ - bfacrm:ticket__show__33571
      // wir setzen die Tags zurck und dann den korrekten
      // Achtung: nicht prev.actEmailOriginal sondern frmMainForm.actEmailOriginal
      frmMainForm.actEmailPDFAttachment.Tag := 0;
      frmMainForm.actEmailTIFAttachment.Tag := 0;
      frmMainForm.actEmailLink.Tag := 0;
      frmMainForm.actEmailOriginal.Tag := 1;
      frmMainForm.actEmailPreview.Tag := 0;
      // SJ - bfacrm:ticket__show__33571

      HasAnnotation := CloneCurrentDocs(UserAction, OnlyFirstDoc);

      UserAction^.params.Add('0'); //Stationery
      UserAction^.params.Add('0'); //Private
      UserAction^.params.Add('0'); //Public
      UserAction^.params.Add('0'); //CurrentLayer

      UserAction^.params.Add('0'); //MergeDocuments
      CreateGUID(DirGUID);
      if ForceDirectories(BD.EnvTempPd + 'bfa_sendnow\' + GUIDToString(DirGUID)) then
      begin
        UserAction^.params.Add(BD.EnvTempPd + 'bfa_sendnow\' + GUIDToString(DirGUID));   //SaveDir

        UserAction^.params.Add(IntToStr(sftORI));

        UserAction^.params.Add(''); //StationeryPath
        UserAction^.params.Add('1'); //Copies
        UserAction^.params.Add('0'); //Sort
        UserAction^.params.Add(IntToStr(alEmail)); // alSave, alEmail

        UserAction^.params.Add(''); //FileName
        UserAction^.params.Add(IntToStr(emtOriginal)); //E-Mail Type

        FBackThread.Add(UserAction);
      end else
      begin
        BfMessageDlg(_('Ordner kann nicht erstellt werden! (' + BD.EnvTempPd + 'bfa_sendnow\' + GUIDToString(DirGUID) + ')'), mtError, [mbOK]);
        Exit;
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'CreateEmailOriginalAction', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateEmailOriginalAction', ClassName);
  end;
end;

procedure TbfaApplication.CreateEmailCollectionAction(UserAction: PUserAction);
var
  HasAnnotation: Boolean;
  DirGUID: TGUID;
  prev: TbfaPreview;
  i, j: Integer;
  NewDoc: TbfaDocument;
  FName: string;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateEmailCollectionAction', ClassName);
  try
    try
      for i := 0 to CollectionContainer.Count -1 do
      begin
        Newdoc := TbfaDocument.Create;
        Newdoc.Clone(CollectionContainer[i]);
        if (Newdoc.DocStream.Size = 0) and (Newdoc.Id <> -1) then
        begin
          if (not OfflineMode) then
            LoadDocumentViaSocket(Newdoc, 'base;paths;iev', nil)
          //10.02.2023 bfacrm:ticket__show__33894 -->
          else
            DBLoadDocument(NewDoc);
          //10.02.2023 bfacrm:ticket__show__33894 <--
        end;

        //12.08.2022 Ticket 28973 -->
        if (NewDoc.Rights and rightEmail) <> rightEmail then
          Continue;
        //12.08.2022 Ticket 28973 <--

        if ((Newdoc.LetterStream <> nil) and (Newdoc.LetterStream.Size = 0)) and
            ((UserAction^.Preview <> nil) and (UserAction^.Preview.bfaTlbPreview.sbmStationery.Checked)) then
        begin
          FName := '';
          for j := 0 to UserAction^.Preview.bfaTlbPreview.sbmStationery.Count - 1 do
            if UserAction^.Preview.bfaTlbPreview.sbmStationery[j].Checked then
              FName := UserAction^.Preview.bfaTlbPreview.sbmStationery[j].Caption;

          bitfarmApp.LoadStationeryToDocument(Newdoc, FName);
        end;

        UserAction^.Documents.Add(Newdoc);
        HasAnnotation := HasAnnotation or Newdoc.HasAnnotation;
      end;

      if (UserAction^.ActionName = 'actEmailCollectionOriginal') then
      begin
        UserAction^.params.Add('0'); //Stationery
        UserAction^.params.Add('0'); //Private
        UserAction^.params.Add('0'); //Public
        UserAction^.params.Add('0'); //CurrentLayer
      end else begin
        if frmMainForm.bfaTlbPreview1.mnuStationery.Checked or frmMainForm.bfaTlbPreview1.sbmStationery.Checked then
          UserAction^.params.Add('1')
        else
          UserAction^.params.Add('0');

        if ((HasAnnotation) and (BfMessageDlg(_('Das Dokument hat Anmerkungen. Sollen diese mit versandt werden?'), mtConfirmation, [mbYes, mbNo]) = mrYes)) then
        begin
          if frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Checked then
          begin
            UserAction^.params.Add('1'); //Private
            UserAction^.params.Add('0'); //Public
  //          UserAction^.params.Add(IntToStr(user.ID)); //Layer
            UserAction^.params.Add(IntToStr(prev.CurrentLayer)); //Layer
          end
          else if frmMainForm.bfaTlbPreview1.mnuPublicAnno.Checked then
          begin
            UserAction^.params.Add('0'); //Private
            UserAction^.params.Add('1'); //Public
            UserAction^.params.Add('0'); //Layer
          end else
          begin
            UserAction^.params.Add('0'); //Private
            UserAction^.params.Add('1'); //Public
            UserAction^.params.Add('0'); //Layer
          end;
        end else
        begin
          UserAction^.params.Add('0'); //Private
          UserAction^.params.Add('0'); //Public
          UserAction^.params.Add('-1'); //Layer
        end;
      end;

      if (UserAction^.ActionName = 'actEmailCollectionSinglePDF') then
        UserAction^.params.Add('1')       //Merge
      else
        UserAction^.params.Add('0'); //MergeDocuments

      CreateGUID(DirGUID);
      if ForceDirectories(BD.EnvTempPd + 'bfa_sendnow\' + GUIDToString(DirGUID)) then
      begin
        UserAction^.params.Add(BD.EnvTempPd + 'bfa_sendnow\' + GUIDToString(DirGUID));   //SaveDir

        if (UserAction^.ActionName = 'actEmailCollectionTIF') then
          UserAction^.params.Add(IntToStr(sftTIF))
        else if (UserAction^.ActionName = 'actEmailCollectionPDF') or (UserAction^.ActionName = 'actEmailCollectionSinglePDF') then
          UserAction^.params.Add(IntToStr(sftPDF))
        else if (UserAction^.ActionName = 'actEmailCollectionOriginal') then
          UserAction^.params.Add(IntToStr(sftOri));

        UserAction^.params.Add(''); //StationeryPath
        UserAction^.params.Add('1'); //Copies
        UserAction^.params.Add('0'); //Sort
        UserAction^.params.Add(IntToStr(alEmail)); // alSave, alEmail

        UserAction^.params.Add(''); //FileName

        if (UserAction^.ActionName = 'actEmailCollectionPDF') or (UserAction^.ActionName = 'actEmailCollectionSinglePDF') then
        begin
           UserAction^.params.Add(IntToStr(emtAttachment)); //E-Mail Type
           UserAction^.ActionName := 'actEmailPDFAttachment';
        end
        else if (UserAction^.ActionName = 'actEmailCollectionTIF') then
        begin
           UserAction^.params.Add(IntToStr(emtAttachment)); //E-Mail Type
           UserAction^.ActionName := 'actEmailTIFAttachment';
        end
        else if (UserAction^.ActionName = 'actEmailCollectionOriginal') then
        begin
          UserAction^.params.Add(IntToStr(emtOriginal)); //E-Mail Type
          UserAction^.ActionName := 'actEmailOriginal';
        end;

        FBackThread.Add(UserAction);
      end
      else
      begin
        BfMessageDlg(_('Ordner kann nicht erstellt werden! (' + BD.EnvTempPd + 'bfa_sendnow\' + GUIDToString(DirGUID) + ')'), mtError, [mbOK]);
        Exit;
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'CreateEmailCollectionAction', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateEmailCollectionAction', ClassName);
  end;
end;

procedure TbfaApplication.CreateEmailPreviewAction(UserAction: PUserAction; OnlyFirstDoc: Boolean);
var
  PreviewDlg: TfrmPreviewDlg;
  DirGUID: TGUID;
  prev: TbfaPreview;
  HasAnnotation, WithPublicAnnoInitial, WithPrivateAnnoInitial: Boolean; //-->bfacrm:ticket__show__25389   1/5/2021
  i, DlgResult: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateEmailPreviewAction', ClassName);
  try
    try
      prev := bitfarmApp.GetActivePreview;

      if not prev.Floating then
      begin
        frmMainForm.mnuEmail.ImageIndex := prev.actEmailPreview.ImageIndex;
        frmMainForm.mnuEmail.Action := prev.actEmailPreview;
        frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action := prev.actEmailPreview;
      end;
      prev.bfaTlbStandard.tlbStandardSubmenuItemEmail.Action := prev.actEmailPreview;

      // SJ - bfacrm:ticket__show__33571
      // wir setzen die Tags zurck und dann den korrekten
      // Achtung: nicht prev.actEmailPreview sondern frmMainForm.actEmailPreview
      frmMainForm.actEmailPDFAttachment.Tag := 0;
      frmMainForm.actEmailTIFAttachment.Tag := 0;
      frmMainForm.actEmailLink.Tag := 0;
      frmMainForm.actEmailOriginal.Tag := 0;
      frmMainForm.actEmailPreview.Tag := 1;
      // SJ - bfacrm:ticket__show__33571

      PreviewDlg := TfrmPreviewDlg.Create(frmMainForm);
      try
        PreviewDlg.Caption := _('E-Mail - Vorschau');
        PreviewDlg.DlgType := dlgEmail;

        HasAnnotation := CloneCurrentDocs(UserAction, OnlyFirstDoc);

        PreviewDlg.Documents := UserAction^.Documents;
        //WithAnnoInitial := PreviewDlg.chkAnnos.Checked;    //-->bfacrm:ticket__show__25389   1/5/2021

        if frmMainForm.popPrivateAnno.Items.Count > 0 then
        begin
          PreviewDlg.popSharedLayer.Items.Clear;
          for i := 0 to frmMainForm.popPrivateAnno.Items.Count -1 do
          begin
            PreviewDlg.popSharedLayer.Items.Add(TSpTBXItem.Create(PreviewDlg.popSharedLayer));
            PreviewDlg.popSharedLayer.Items[i].Caption := frmMainForm.popPrivateAnno.Items[i].Caption;
            PreviewDlg.popSharedLayer.Items[i].Tag := frmMainForm.popPrivateAnno.Items[i].Tag;
          end;
        end;
        if prev.CurrentLayer <> 0 then
          PreviewDlg.PrivateLayer := prev.CurrentLayer
        else
          PreviewDlg.PrivateLayer := FUser.ID;

        PreviewDlg.ShowModal;
        if PreviewDlg.ModalResult = mrCancel then
        begin
          Log.Write(llNormal, ltInfo, 'PrintDoc End via Exit #2', ClassName);
          Exit;
        end;

        if PreviewDlg.chkStationery.Checked then
          UserAction^.params.Add('1')
        else
          UserAction^.params.Add('0');
         // WithAnnoFinal := PreviewDlg.chkAnnos.Checked;     //-->bfacrm:ticket__show__25389   1/5/2021
          WithPublicAnnoInitial := prev.bfaTlbPreview.mnuPublicAnno.Checked;  // bfacrm:ticket__show__25389
          WithPrivateAnnoInitial := prev.bfaTlbPreview.mnuPrivateAnno.Checked;  //bfacrm:ticket__show__25389
        // bfacrm:ticket__show__24796
        {
        if HasAnnotation then
          DlgResult := BfMessageDlg(_('Das Dokument hat Anmerkungen. Sollen diese mit versandt werden?'), mtConfirmation, [mbYes, mbNo, mbCancel]);
        }
        if HasAnnotation and (WithPublicAnnoInitial = True) and (WithPrivateAnnoInitial = False) then
        begin
          DlgResult := BfMessageDlg(_('Das Dokument hat Anmerkungen. Sollen diese mit gespeichert werden?'), mtConfirmation, [mbYes, mbNo, mbCancel]);
          bitfarmLog.Write(llNormal, ltInfo, 'DlgResult=' + Dlgresult.ToString, ClassName); //01.08.2023
        end;

        if HasAnnotation and (WithPublicAnnoInitial = WithPrivateAnnoInitial) and (WithPrivateAnnoInitial = True) then
            DlgResult := mrYes;

        if HasAnnotation and (WithPublicAnnoInitial = False) and (WithPrivateAnnoInitial = True) then
            DlgResult := mrYes;

        bitfarmLog.Write(llNormal, ltInfo, 'DlgResult=' + Dlgresult.ToString, ClassName); //01.08.2023

        if (HasAnnotation) and (DlgResult = mrCancel) then
        begin
          Dispose(UserAction);
          Exit;
        end else
        // bfacrm:ticket__show__24796
        if (HasAnnotation) and (DlgResult = mrYes) then
        begin
          //if PreviewDlg.rbnPrivate.Checked then  bfacrm:ticket__show__25389
          if frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Enabled and frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Checked then
          begin
            UserAction^.params.Add('1'); //Private
            UserAction^.params.Add('0'); //Public
            UserAction^.params.Add(IntToStr(PreviewDlg.PrivateLayer)); //Layer
          end else
          begin
            UserAction^.params.Add('0'); //Private
            UserAction^.params.Add('1'); //Public
            UserAction^.params.Add('0'); //Layer
          end;
        end else
        begin
          UserAction^.params.Add('0'); //Private
          UserAction^.params.Add('0'); //Public
          UserAction^.params.Add('-1'); //Layer
        end;

        if PreviewDlg.chkMergeDocuments.Checked then
          UserAction^.params.Add('1')
        else
          UserAction^.params.Add('0');

        CreateGUID(DirGUID);
        if ForceDirectories(BD.EnvTempPd + 'bfa_sendnow\' + GUIDToString(DirGUID)) then
        begin
          UserAction^.params.Add(BD.EnvTempPd + 'bfa_sendnow\' + GUIDToString(DirGUID));   //SaveDir

          if (PreviewDlg.rbnTIF.Checked) then
            UserAction^.params.Add(IntToStr(sftTIF))
          else if (PreviewDlg.rbnPDF.Checked) then
            UserAction^.params.Add(IntToStr(sftPDF))
          else if (PreviewDlg.rbnSaveOriginal.Checked) then
            UserAction^.params.Add(IntToStr(sftOri));

          UserAction^.params.Add(PreviewDlg.StationeryPath); //StationeryPath
          UserAction^.params.Add(PreviewDlg.edtCopies.Text); //Copies
          if PreviewDlg.chkSort.Checked then //Sort
            UserAction^.params.Add('1')
          else
            UserAction^.params.Add('0');

          UserAction^.params.Add(IntToStr(alEmail)); // alSave, alEmail
          UserAction^.params.Add(''); // FileName

          if (PreviewDlg.rbnAttachment.Checked) and (PreviewDlg.rbnSaveOriginal.Checked) then
            UserAction^.params.Add(IntToStr(emtOriginal))
          else if (PreviewDlg.rbnAttachment.Checked) then
            UserAction^.params.Add(IntToStr(emtAttachment))
          else if (PreviewDlg.rbnLink.Checked) then
            UserAction^.params.Add(IntToStr(emtLink));

          FBackThread.Add(UserAction);
        end else
        begin
          BfMessageDlg(_('Ordner kann nicht erstellt werden! (' + BD.EnvTempPd + 'bfa_sendnow\' + GUIDToString(DirGUID) + ')'), mtError, [mbOK]);
          Exit;
        end;
      finally
        PreviewDlg.Release;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'CreateEmailPreviewAction', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateEmailPreviewAction', ClassName);
  end;
end;

procedure TbfaApplication.CopyAnno(OriDoc, Doc: TbfaDocument; SelectedPages: TStringList);
var
  k, idx: Integer;
  SrcAnno, AnnoObj: TbfaAnnotation;
  img: TIETIFFHandler;
  Slist: TStringList;
begin
  try
    if (GetActivePreview.bfaTlbPreview.mnuPublicAnno.Checked) or (GetActivePreview.bfaTlbPreview.mnuPrivateAnno.Checked) then
    begin
      Slist := TStringList.Create;
      try
        if (SelectedPages <> nil) and (SelectedPages.Count > 0) then
        begin
          Slist.CommaText := SelectedPages.CommaText;
        end else
        begin
          img := TIETIFFHandler.Create;
          try
            OriDoc.DocStream.Position := 0;
            img.ReadStream(OriDoc.DocStream);
            for k := 1 to img.GetPagesCount do
              Slist.Add(IntToStr(k));
          finally
            FreeAndNil(img);
          end;
        end;

        for k := 0 to Slist.Count - 1 do
        begin
          SrcAnno := OriDoc.GetAnnotation(StrToInt(Slist[k]) - 1, 0, idx);
          if SrcAnno <> nil then
          begin
            AnnoObj := TbfaAnnotation.Create;
            AnnoObj.Clone(SrcAnno);
            AnnoObj.Page := k;
            Doc.Annotations.Add(AnnoObj);
          end;
        end;
      finally
        FreeAndNil(Slist);
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'CopyAnno', ClassName);
  end;
end;

procedure TbfaApplication.CopyBookmark(AThread: TThread; Objects: TList);
var
  SelNode, NewNode: TTreeNode;
  BookmarkName: string;
  TmpObj: TbfaSearch;
begin
  bitfarmLog.DebugBegin(llDebug, 'CopyBookmark', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          SelNode := GetRootNode(TTreeNode(Objects[0]));
          if SelNode = GlobalListNode then
            SelNode := GetParentNode(TTreeNode(Objects[0]));

          TmpObj := TBfaSearch.Create;
          TmpObj.Clone(TbfaSearch(TTreeNode(Objects[0]).Data));

          AddTreeviewNode(FLog, frmMainForm.trvBookmarks, SelNode, TmpObj, TmpObj.SearchType);
          SaveBookmarkNode(SelNode);
        end);
    except

    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CopyBookmark', ClassName);
  end;
end;

procedure TbfaApplication.SendPagesTo(UserAction: PUserAction; AThread: TThread);
var
  Doc: TbfaDocument;
  i: Integer;
  NewUserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'SendPagesTo', ClassName);
  try
    try
      if UserAction^.options = 0 then
      begin
        Doc := TbfaDocument.Create;
        Doc.DocStream := bfaImageRendering(AThread, TList<TbfaDocument>(UserAction^.Documents), //16.11.2017 wegen Ticket 12517
          False, False, False);
        AThread.Synchronize(nil,
          procedure
          begin
            if ((TList<TbfaDocument>(UserAction^.Documents)[0].ID = -1) or
              (((TList<TbfaDocument>(UserAction^.Documents)[0].Rights and rightARead) = rightARead) or
              ((TList<TbfaDocument>(UserAction^.Documents)[0].Rights and rightAWrite) = rightAWrite) or
              ((TList<TbfaDocument>(UserAction^.Documents)[0].Rights and rightAModify) = rightAModify)))
            then
              CopyAnno(TList<TbfaDocument>(UserAction^.Documents)[0], Doc, TList<TbfaDocument>(UserAction^.Documents)[0].SelectedPages);
          end);
        Doc.HasPreview := True;
        Doc.ScanPoolViewLoaded := False;
        Doc.ScanPoolViewchanged := False;
        UserAction^.Preview.List.Add(Doc);
      end
      else if UserAction^.options = 1 then
      begin
        for i := 0 to UserAction^.params.Count - 1 do
        begin
          TbfaDocument(UserAction^.Documents[0]).SelectedPages.Clear;
          TbfaDocument(UserAction^.Documents[0]).SelectedPages.Add(UserAction^.params[i]);
          Doc := TbfaDocument.Create;
          Doc.DocStream := bfaImageRendering(AThread, TList<TbfaDocument>(UserAction^.Documents), //16.11.2017 wegen Ticket 12517
            False, False, False);
          AThread.Synchronize(nil,
            procedure
            begin
              if ((TList<TbfaDocument>(UserAction^.Documents)[0].ID = -1) or
                (((TList<TbfaDocument>(UserAction^.Documents)[0].Rights and rightARead) = rightARead) or
                ((TList<TbfaDocument>(UserAction^.Documents)[0].Rights and rightAWrite) = rightAWrite) or
                ((TList<TbfaDocument>(UserAction^.Documents)[0].Rights and rightAModify) = rightAModify)))
              then
                CopyAnno(TList<TbfaDocument>(UserAction^.Documents)[0], Doc, TList<TbfaDocument>(UserAction^.Documents)[0].SelectedPages);
            end);
          Doc.HasPreview := True;
          Doc.ScanPoolViewLoaded := False;
          Doc.ScanPoolViewchanged := False;
          UserAction^.Preview.List.Add(Doc);
        end;
      end;

      AThread.Synchronize(nil,
        procedure
        var
          i: Integer;
        begin
          NewUserAction := CreateUserAction;
          if UserAction^.Preview = FPreviewContainer.WorkplaceItem.Preview then
          begin
            NewUserAction^.ActionName := 'actRefreshWorkplaceMultiview';
            NewUserAction^.params.Add('1');
          end
          else if UserAction^.Preview = FPreviewContainer.ImporterItem.Preview then
          begin
            NewUserAction^.ActionName := 'actRefreshImporterMultiview';
            NewUserAction^.params.Add('1');
          end;
          FMainThread.Add(NewUserAction);
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'SendPagesTo', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SendPagesTo', ClassName);
  end;
end;

procedure TbfaApplication.FillDelegateTasksSearch(fraResub: TfraResub; GridView: TbfaGridDBTableView; var SObj: TbfaSearch);
begin
  SObj.Reset;
  SObj.ID := 1;
  SObj.Name := _('delegierte Wiedervorlage');
  SObj.UserContext := FUser.ID;
  SObj.SearchType := 4; // Wiedervorlage
  SObj.SelectedCols := SetSelectedColumns(True);
  if SObj.SelectedCols = '' then
    SObj.SelectedCols := 'gdocid';

  SObj.ResubControllerID := FUser.ID;
  SObj.ResubUserID := FUser.ID;
  SObj.ResubUserIDNegated := True;
  SObj.GdocIDWithSymLink := False;

  if fraResub.DelegateView = 0 then
    SObj.ResubNotState := 4   // offen und in Arbeit
  else if fraResub.DelegateView = 1 then
  begin
    SObj.ResubNotState := 4;  // nicht in arbeit nicht fertig
    SObj.ResubAlarmHigh := FormatDateTime('yyyy-mm-dd', Now());
  end
  else if fraResub.DelegateView = 2 then
  begin
    SObj.ResubState := 2;  // in Arbeit
    SObj.ResubNotState := 4; // nicht fertig
  end
  else if fraResub.DelegateView = 3 then
  begin
    SObj.ResubState := 4; // fertig
    SObj.ResubNotState := 16; // nicht weitergeleitet
    SObj.ResubStateNegated := False;
  end
  else if fraResub.DelegateView = 4 then
  begin
    SObj.ResubNotState := 4; // offen und in Arbeit aller Mitarbeiter
    SObj.ResubUserIDNegated := False;
    if FUser.EmployeesList.Count > 0 then   //sanity, wir sollten eigentlich gar nicht erst in diese view kommen
    begin                                   // ohne mitarbeiter
      SObj.ResubControllerID := -1;
      SObj.ResubUserIDList := FUser.EmployeesList.CommaText;
    end;
  end;
  SetSearchOrder(SObj, GridView); //03.11.2022 Ticket 32729
end;

procedure TbfaApplication.FillDocLinkList;
var
  LItem: TListItem;
  i, j: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'FillDocLinkList', ClassName);
  try
    try
      if Assigned(frmMainForm.fraDocLinks) then
      begin
        frmMainForm.fraDocLinks.lvwDocLink.Items.Clear;
        for i := 0 to FCurrentContainer.Count - 1 do
        begin
          if (FCurrentContainer[i].Id <> -1) and (FCurrentContainer[i].Id > 0) and
             (Length(FCurrentContainer[i].DocLinkList) > 0) then
          begin
            if (CurrentView <> tvkImporter) and (FCurrentContainer[i].Id <> -1) and (FCurrentContainer[i].Id > 0) then
            begin
              for j := Low(FCurrentContainer[i].DocLinkList) to High(FCurrentContainer[i].DocLinkList) do
              begin
                LItem := frmMainForm.fraDocLinks.lvwDocLink.Items.Add;
                LItem.Caption := FCurrentContainer[i].DocLinkList[j].Refname;
                LItem.SubItems.Add(IntToStr(FCurrentContainer[i].DocLinkList[j].count));
                LItem.SubItems.Add(IntToStr(FCurrentContainer[i].DocLinkList[j].gdocid));
                LItem.SubItems.Add(IntToStr(FCurrentContainer[i].DocLinkList[j].RefID));
              end;
            end
            else if (CurrentView = tvkImporter) and (FCurrentContainer[i].Id = -1) then
            begin
// 13.02.2018 Fehler! beim OutlookPlugin die Dokumente haben addiert die Verknpfungen bekommen, das ist so falsch
//              frmMainForm.fraDocLinks.lvwDocLink.Items.Clear;
//              frmMainForm.mmoDocLinks.Text := '';
//              for j := Low(FCurrentContainer[i].DocLinkList) to
//                      High(FCurrentContainer[i].DocLinkList) do
//              begin
//                frmMainForm.mmoDocLinks.Lines.Add(FCurrentContainer[i].DocLinkList[j].RefName);
//              end;
            end
          end;
        end;
        SetDocLinkActions;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'FillDocLinkList', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'FillDocLinkList', ClassName);
  end;
end;

procedure TbfaApplication.ShowDocLinkList;
begin
  bitfarmLog.DebugBegin(llDebug, 'ShowDocLinkList', ClassName);
  try
    try
      if frmMainForm.fraDocLinks = nil then
      begin
        frmMainForm.fraDocLinks := TfraDocLinksList.Create(frmMainForm);
        frmMainForm.fraDocLinks.SettingLastLink := False; //05.11.2019 sonst ruft edtDocLinkChange auf
        frmMainForm.fraDocLinks.SpTBXPanel1.Borders := False;
        ChangeDocLinkListSkin;

        if PopupLinkList.Count > 0 then
          frmMainForm.fraDocLinks.LastLink := PopupLinkList[0]
        else
          frmMainForm.fraDocLinks.LastLink := '';

        CreateLinkListPopup;

        frmMainForm.fraDocLinks.btnNewLink.Images := bfaIcons.ilMainMenu;
        frmMainForm.fraDocLinks.btnNewLink.ImageIndex := Integer(icoidx_link_create);
        frmMainForm.fraDocLinks.btnAddAutoReference.Images := bfaIcons.ilMainMenu;
        frmMainForm.fraDocLinks.btnAddAutoReference.ImageIndex := Integer(icoidx_autoreference);
        frmMainForm.fraDocLinks.btnAddLink.Images := bfaIcons.ilMainMenu;
        frmMainForm.fraDocLinks.btnAddLink.ImageIndex := Integer(icoidx_document_link_add);
        frmMainForm.fraDocLinks.btnRemoveLink.Images := bfaIcons.ilMainMenu;
        frmMainForm.fraDocLinks.btnRemoveLink.ImageIndex := Integer(icoidx_document_link_remove);
        frmMainForm.fraDocLinks.btnDeleteLink.Images := bfaIcons.ilMainMenu;
        frmMainForm.fraDocLinks.btnDeleteLink.ImageIndex := Integer(icoidx_link_delete);
        frmMainForm.fraDocLinks.scrbxDocLinkList.AutoScroll := True;
        frmMainForm.fraDocLinks.scrbxDocLinkList.AfterScrollVert := frmMainForm.AfterScrollVert;
        frmMainForm.fraDocLinks.scrbxDocLinkList.AfterScrollHorz := frmMainForm.AfterScrollHorz;
        frmMainForm.fraDocLinks.scrbxDocLinkList.Update;
      end;

      if (FViewerOptions.GeneralOptions.ShowDocLinks) and (CurrentView <> TbfaViewKind(vkImporter)) then
      begin
        if FViewerOptions.GeneralOptions.ShowDocLinksInTab then
        begin
          frmMainForm.tabDocLinks.TabVisible := (GetActivePreview <> FPreviewContainer.ImporterItem.Preview);
          frmMainForm.tabSearchLinks.Visible := (GetActivePreview <> FPreviewContainer.ImporterItem.Preview);
          frmMainForm.splStandard.Visible := False;
          frmMainForm.pnlDocLink.Visible := False;
          frmMainForm.fraDocLinks.Parent := frmMainForm.tabdocLinks;
          frmMainForm.fraDocLinks.Align := alClient;
          frmMainForm.fraDocLinks.Visible := (GetActivePreview <> FPreviewContainer.ImporterItem.Preview);
        end
        else
        begin
          frmMainForm.tabDocLinks.Visible := False;
          frmMainForm.tabSearchLinks.Visible := False;
          frmMainForm.pnlDocLink.Visible := True;
          frmMainForm.splStandard.Visible := True;
          frmMainForm.fraDocLinks.Parent := frmMainForm.pnlDocLink;
          frmMainForm.fraDocLinks.Align := alClient;
          frmMainForm.fraDocLinks.Visible := (GetActivePreview <> FPreviewContainer.ImporterItem.Preview);
          if(frmMainForm.tcSearch.ActiveTabIndex = 2) then
          begin
            frmMainForm.tcSearch.Toolbar.BeginUpdate;
            try
              frmMainForm.tcSearch.ActiveTabIndex := 0;
            finally
              frmMainForm.tcSearch.Toolbar.EndUpdate;
            end;
          end;
        end
      end else
      begin
        frmMainForm.tabDocLinks.TabVisible := False;
        frmMainForm.tabSearchLinks.Visible := False;
        frmMainForm.fraDocLinks.Visible := False;
        frmMainForm.fraDocLinks.Parent := frmMainForm.pnlDocLink;
        frmMainForm.splStandard.Visible := False;
        frmMainForm.pnlDocLink.Visible := False;
        //03.05.2019 Ticket 18972
        if(frmMainForm.tcSearch.ActiveTabIndex = 2) then
        begin
          frmMainForm.tcSearch.Toolbar.BeginUpdate;
          try
            frmMainForm.tcSearch.ActiveTabIndex := 0;
          finally
            frmMainForm.tcSearch.Toolbar.EndUpdate;
          end;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'ShowDocLinkList', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ShowDocLinkList', ClassName);
  end;
end;

procedure TbfaApplication.CreateRefSearchAction(RefName: WideString);
var
  UserAction: PUserAction;
//  idx: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateRefSearchAction', ClassName);
  try
    try
      UserAction := CreateUserAction;
      UserAction^.ActionName := 'actRefSearch';
//15.08.2019 Wenn die Verknpfung () im Text hat, macht es Probleme -->
//      if FViewerOptions.GeneralOptions.ShowLinkCount then
//      begin
//        idx := pos('(', RefName) - 2;
//        if idx > 0 then
//          UserAction^.params.Add(LeftStr(RefName, idx))
//        else
//          UserAction^.params.Add(RefName);
//      end
//      else
//15.08.2019 Wenn die Verknpfung () im Text hat, macht es Probleme <--
        UserAction^.params.Add(RefName);
      FMainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'CreateRefSearchAction', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateRefSearchAction', ClassName);
  end;
end;

procedure TbfaApplication.CreateResubColumns;
var
  i: Integer;
  aTemp: array of TSorting;
  sort: TSorting;
  found: Boolean;
begin
  //  erst entfernen was nicht reingehrt
  SetLength(aTemp, 0);
  for i := 0 to High(aColSortings[CurrentResubFields]) do
  begin
    if (aColSortings[CurrentResubFields, i].Field = 'alarm') and
       not ViewerOptions.ResubOptions.ColumnAlarm
    then
      Continue;

    if (aColSortings[CurrentResubFields, i].Field = 'info') and
       not ViewerOptions.ResubOptions.ColumnInfo
    then
      Continue;

    if (aColSortings[CurrentResubFields, i].Field = 'docname') and
       not ViewerOptions.ResubOptions.ColumnTitle
    then
      Continue;

    if (aColSortings[CurrentResubFields, i].Field = 'comment') and
       not ViewerOptions.ResubOptions.ColumnComment
    then
      Continue;

    if (aColSortings[CurrentResubFields, i].Field = 'doc_modified') and
       not ViewerOptions.ResubOptions.ColumnModified
    then
      Continue;

    if (aColSortings[CurrentResubFields, i].Field = 'docdate') and
       not ViewerOptions.ResubOptions.ColumnDocDate
    then
      Continue;

    if (aColSortings[CurrentResubFields, i].Field = 'arcname') and
       not ViewerOptions.ResubOptions.ColumnArchive
    then
      Continue;

    SetLength(aTemp, High(aTemp) + 2);
    aTemp[High(aTemp)] := aColSortings[CurrentResubFields, i];

  end;
  // dann hinzufgen

  if ViewerOptions.ResubOptions.ColumnAlarm then
  begin
    found := False;
    for i := 0 to High(aTemp) do
    begin
      if aTemp[i].Field = 'alarm' then
      begin
        found := True;
        Break;
      end;
    end;

    if not found then
    begin
      SetLength(aTemp, High(aTemp) + 2);
      sort.Title := _('Alarm');
      sort.Field := 'alarm';
      sort.SortOrder := 0;
      sort.Width := 100;
      sort.GroupingIndex := -1;
      sort.SortIndex := -1;
      sort.Visible := True;
      sort.FooterKind := 0; //23.09.2021 Ticket 24736
      aTemp[High(aTemp)] := sort;
    end;
  end;

  if ViewerOptions.ResubOptions.ColumnTitle then
  begin
    found := False;
    for i := 0 to High(aTemp) do
    begin
      if aTemp[i].Field = 'docname' then
      begin
        found := True;
        Break;
      end;
    end;

    if not found then
    begin
      SetLength(aTemp, High(aTemp) + 2);
      sort.Title := _('Titel');
      sort.Field := 'docname';
      sort.SortOrder := 0;
      sort.Width := 100;
      sort.GroupingIndex := -1;
      sort.SortIndex := -1;
      sort.Visible := True;
      sort.FooterKind := 0; //23.09.2021 Ticket 24736
      aTemp[High(aTemp)] := sort;
    end;
  end;

  if ViewerOptions.ResubOptions.ColumnInfo then
  begin
    found := False;
    for i := 0 to High(aTemp) do
    begin
      if aTemp[i].Field = 'info' then
      begin
        found := True;
        Break;
      end;
    end;

    if not found then
    begin
      SetLength(aTemp, High(aTemp) + 2);
      sort.Title := _('Info');
      sort.Field := 'info';
      sort.SortOrder := 0;
      sort.Width := 100;
      sort.GroupingIndex := -1;
      sort.SortIndex := -1;
      sort.Visible := True;
      sort.FooterKind := 0; //23.09.2021 Ticket 24736
      aTemp[High(aTemp)] := sort;
    end;
  end;

  if ViewerOptions.ResubOptions.ColumnComment then
  begin
    found := False;
    for i := 0 to High(aTemp) do
    begin
      if aTemp[i].Field = 'comment' then
      begin
        found := True;
        Break;
      end;
    end;

    if not found then
    begin
      SetLength(aTemp, High(aTemp) + 2);
      sort.Title := _('Kommentar');
      sort.Field := 'comment';
      sort.SortOrder := 0;
      sort.Width := 100;
      sort.GroupingIndex := -1;
      sort.SortIndex := -1;
      sort.Visible := True;
      sort.FooterKind := 0; //23.09.2021 Ticket 24736
      aTemp[High(aTemp)] := sort;
    end;
  end;

  if ViewerOptions.ResubOptions.ColumnArchive then
  begin
    found := False;
    for i := 0 to High(aTemp) do
    begin
      if aTemp[i].Field = 'arcname' then
      begin
        found := True;
        Break;
      end;
    end;

    if not found then
    begin
      SetLength(aTemp, High(aTemp) + 2);
      sort.Title := _('Archiv');
      sort.Field := 'arcname';
      sort.SortOrder := 0;
      sort.Width := 100;
      sort.GroupingIndex := -1;
      sort.SortIndex := -1;
      sort.Visible := True;
      sort.FooterKind := 0; //23.09.2021 Ticket 24736
      aTemp[High(aTemp)] := sort;
    end;
  end;

  if ViewerOptions.ResubOptions.ColumnModified then
  begin
    found := False;
    for i := 0 to High(aTemp) do
    begin
      if aTemp[i].Field = 'doc_modified' then
      begin
        found := True;
        Break;
      end;
    end;

    if not found then
    begin
      SetLength(aTemp, High(aTemp) + 2);
      sort.Title := _('nderungsdatum');
      sort.Field := 'doc_modified';
      sort.SortOrder := 0;
      sort.Width := 100;
      sort.GroupingIndex := -1;
      sort.SortIndex := -1;
      sort.Visible := True;
      sort.FooterKind := 0; //23.09.2021 Ticket 24736
      aTemp[High(aTemp)] := sort;
    end;
  end;

  if ViewerOptions.ResubOptions.ColumnDocDate then
  begin
    found := False;
    for i := 0 to High(aTemp) do
    begin
      if aTemp[i].Field = 'docdate' then
      begin
        found := True;
        Break;
      end;
    end;

    if not found then
    begin
      SetLength(aTemp, High(aTemp) + 2);
      sort.Title := _('Datum');
      sort.Field := 'docdate';
      sort.SortOrder := 0;
      sort.Width := 100;
      sort.GroupingIndex := -1;
      sort.SortIndex := -1;
      sort.Visible := True;
      sort.FooterKind := 0; //23.09.2021 Ticket 24736
      aTemp[High(aTemp)] := sort;
    end;
  end;

  SetLength(aColSortings[CurrentResubFields], 0);
  SetLength(aColSortings[CurrentResubFields], High(aTemp) + 1);
  for i := 0 to High(aTemp) do
    aColSortings[CurrentResubFields, i] := aTemp[i];
end;

function TbfaApplication.GetResubFavIcon(FavIcon : Integer) : Integer;
begin
  try
    case FavIcon of
      1 : Result := Integer(icoidx_resubmission_user_01);
      2 : Result := Integer(icoidx_resubmission_user_02);
      3 : Result := Integer(icoidx_resubmission_user_03);
      4 : Result := Integer(icoidx_resubmission_user_04);
      5 : Result := Integer(icoidx_resubmission_user_05);
      6 : Result := Integer(icoidx_resubmission_user_06);
      7 : Result := Integer(icoidx_resubmission_user_07);
      8 : Result := Integer(icoidx_resubmission_user_08);
      9 : Result := Integer(icoidx_resubmission_user_09);
      10 : Result := Integer(icoidx_resubmission_user_10);
      else Result := -1;
    end;
  except
    Result := -1;
  end;
end;

procedure TbfaApplication.CreateResubPopup;
var
  item: TSpTBXItem;
  i, j: Integer;
  HintStr, str: string;
  lst: TStringList;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateResubPopup', ClassName);
  try
    try
      frmMainForm.popResubFavs.Items.Clear;
      frmMainForm.tlbResubFavs.Items.Clear;
      for i := 0 to High(aResubFavs) do
      begin
        item := TSpTBXItem.Create(frmMainForm.popResubFavs);
        item.Caption := aResubFavs[i].name;
        item.Tag := i;
        item.Enabled := True;
        item.Visible := True;

        if aResubFavs[i].FavIcon <> 0 then
        begin
          item.Images := bfaIconsDM.bfaIcons.ilPreview;
          item.ImageIndex := GetResubFavIcon(aResubFavs[i].FavIcon);
        end;

        item.OnClick := popResubFavsOnClick;

        // Itemreihenfolge:
        // - zuerst alle mit Icon (in aufsteigender Reihenfolge)
        // - die Favoriten ohne Icon nach Erstellungsreihenfolge
        begin
          // begin end wegen var inserted - ist weiter unten nochmal...
          var inserted: Boolean := False;
          if (aResubFavs[i].FavIcon <> 0) then
          begin
            for j := 0 to frmMainForm.popResubFavs.Items.Count - 1 do
            begin
              if (frmMainForm.popResubFavs.Items[j].ImageIndex > item.ImageIndex) or
                 (frmMainForm.popResubFavs.Items[j].ImageIndex = -1) then
              begin
                frmMainForm.popResubFavs.Items.Insert(j, item);
                inserted := True;
                Break;
              end;
            end;
          end;

          if not inserted then
            frmMainForm.popResubFavs.Items.Add(item);
        end;

        HintStr := '';

        if Trim(aResubFavs[i].Name) <> '' then
        begin
          HintStr := _('Name:') + ' ' + aResubFavs[i].Name;
        end;

        if Trim(aResubFavs[i].Info) <> '' then
        begin
          if HintStr <> '' then
            HintStr := HintStr + #13#10;
          HintStr := HintStr + _('Info:') + ' ' + aResubFavs[i].Info;
        end;

        if Trim(aResubFavs[i].FwdInfo) <> '' then
        begin
          if HintStr <> '' then
            HintStr := HintStr + #13#10;
          HintStr := HintStr + _('Weiterleitung-Info:') + ' ' + aResubFavs[i].FwdInfo;
        end;

        if Trim(aResubFavs[i].Users) <> '' then
        begin
          str := '';
          lst := TStringList.Create;
          try
            lst.Delimiter := ';';
            lst.DelimitedText := aResubFavs[i].Users;
            for j := 0 to lst.Count - 1 do
            begin
              if str <> '' then
                str := str + '; ';
              str := str + DBGetUserName(StrToInt(lst[j]));
            end;
            if HintStr <> '' then
              HintStr := HintStr + #13#10;
            HintStr := HintStr + _('Bearbeiter:') + ' ' + str;
          finally
            FreeAndNil(lst);
          end;
        end;

        if Trim(aResubFavs[i].Groups) <> '' then
        begin
          str := '';
          lst := TStringList.Create;
          try
            lst.Delimiter := ';';
            lst.DelimitedText := aResubFavs[i].Groups;
            for j := 0 to lst.Count - 1 do
            begin
              if str <> '' then
                str := str + '; ';
              str := str + DBGetGroupName(StrToInt(lst[j]));
            end;
            if HintStr <> '' then
              HintStr := HintStr + #13#10;
            HintStr := HintStr + _('Gruppen:') + ' ' + str;
          finally
            FreeAndNil(lst);
          end;
        end;

        try
          if HintStr <> '' then
            HintStr := HintStr + #13#10;
          HintStr := HintStr + Format(_('Datum: %s Tage'), [aResubFavs[i].AdditionalDays.ToString]);
          if aResubFavs[i].AdditionalDays = 0 then
            HintStr := HintStr + ' ' + _('(sofort)');
        except
          // falls ein String ohne %s vorliegt
        end;

        try
          if aResubFavs[i].Alarm > 0 then
          begin
            if HintStr <> '' then
              HintStr := HintStr + #13#10;
            HintStr := HintStr + Format(_('Frist: %s Tage'), [aResubFavs[i].Alarm.ToString]);
          end;
        except
          // falls ein String ohne %s vorliegt
        end;

//      "Optionen:" wird immer angezeigt, weil Option = 0 wird "Jeder einzeln"...
          if HintStr <> '' then
            HintStr := HintStr + #13#10;
          HintStr := HintStr + _('Optionen:') + ' ';

//      bfacrm:ticket__show__33869 / --> LoadWVLFavorite
//      chkOnlyOne.Checked := (aResubFavs[idx].options and 1) = 0;
//      chkEveryone.Checked := (aResubFavs[idx].options and 1) = 1;
        if (aResubFavs[i].Options and 1) = 0 then
          HintStr := HintStr + _('Einer fr alle')
        else
        // wenn nicht "Einer fr alle" --> "Jeder einzeln"
          HintStr := HintStr + _('Jeder einzeln');

        if (aResubFavs[i].options and 2) = 2 then
          HintStr := HintStr + ', ' + _('nach Erledigung zurck');

        if (aResubFavs[i].Options and 4) = 4 then
          HintStr := HintStr + ', ' + _('Erinnerungsmail');

        if (aResubFavs[i].Options and 64) = 64 then
          HintStr := HintStr + ', ' + _('Benachrichtigung per Mail');

        item.Hint := HintStr; // popResubFavs

        // tlbResubFavs fllen (Wiedervorlage-Mnnchen :-)

        if aResubFavs[i].FavIcon <> 0 then
        begin
          item := TSpTBXItem.Create(frmMainForm.tlbResubFavs);
          item.Images := bfaIconsDM.bfaIcons.ilPreview;
          item.ImageIndex := GetResubFavIcon(aResubFavs[i].FavIcon);
          item.Tag := i;
          item.Enabled := True;
          item.Visible := True;
          item.OnClick := popResubFavsOnClick;
          item.Hint := HintStr; // tlbResubFavs
          TranslateComponent(item, 'ViewerV3');
          if frmMainForm.tlbResubFavs.Items.Count > 0 then
          begin
            var inserted: Boolean;
            for J := 0 to frmMainForm.tlbResubFavs.Items.Count - 1 do
            begin
              inserted := False;
              if frmMainForm.tlbResubFavs.Items[J].ImageIndex > item.ImageIndex then
              begin
                frmMainForm.tlbResubFavs.Items.Insert(J, item);
                inserted := True;
                Break   //11.07.2024 SD <--bfacrm:ticket__show__36177
              end;
            end;
            if not inserted then
              frmMainForm.tlbResubFavs.Items.Add(item);
          end else
            frmMainForm.tlbResubFavs.Items.Add(item);

        end;
      end;
      // SJ 11.1.2022
//      frmMainForm.tlbResubFavs.Visible := (frmMainForm.tlbResubFavs.Items.Count > 0) and (CurrentView <> tvkAdministrator);
    except
      bitfarmLog.Write(llNormal, ltException, 'CreateResubPopup', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateResubPopup', ClassName);
  end;
end;

//28.05.2019 Ticket 18910 -->
procedure TbfaApplication.CreateResubFavsInPreviews(WithActivePreview : TbfaPreview = nil);

  procedure DoOnePreview(prev : TBfaPreview);
  var
    item : TSpTBXItem;
    j: Integer;
  begin
    try
      prev.tlbResubFavs.Items.Clear;

      for j := 0 to frmMainForm.tlbResubFavs.Items.Count - 1 do
      begin
        item := TSpTBXItem.Create(prev.tlbResubFavs);
        item.Images := bfaIconsDM.bfaIcons.ilPreview;
        item.ImageIndex := frmMainForm.tlbResubFavs.Items[j].ImageIndex;
        item.Tag := frmMainForm.tlbResubFavs.Items[j].Tag;
        item.Enabled := frmMainForm.tlbResubFavs.Items[j].Enabled;
        item.Visible := frmMainForm.tlbResubFavs.Items[j].Visible;
        item.OnClick := popResubFavsOnClick;
        item.Hint := frmMainForm.tlbResubFavs.Items[j].Hint;
        prev.tlbResubFavs.Items.Add(item);
        //11.09.2024 SD -->bfacrm:ticket__show__39919
//        prev.tlbResubFavs.Visible :=
//          (bitfarmApp.ViewerOptions.ResubOptions.ResubFavsInPreview) and
//          (prev <> bitfarmApp.PreviewContainer.ImporterItem.Preview) and
//          (prev <> bitfarmApp.PreviewContainer.WorkplaceItem.Preview);
        //11.09.2024 SD <--bfacrm:ticket__show__39919
      end;
      //11.09.2024 SD -->bfacrm:ticket__show__39919
      prev.tlbResubFavs.Visible :=
        (bitfarmApp.ViewerOptions.ResubOptions.ResubFavsInPreview) and
        (prev <> bitfarmApp.PreviewContainer.ImporterItem.Preview) and
        (prev <> bitfarmApp.PreviewContainer.WorkplaceItem.Preview) and
        (prev.tlbResubFavs.Items.Count > 0);
      //11.09.2024 SD <--bfacrm:ticket__show__39919

    except
      bitfarmLog.Write(llNormal, ltException, 'CreateResubFavsInPreviews', ClassName);
    end;
  end;

var
  i: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateResubFavsInPreviews', ClassName);
  try
    try
      if WithActivePreview <> nil then
        DoOnePreview(WithActivePreview)
      else
      begin
        for i := 0 to FPreviewContainer.Containers.Count - 1 do
          DoOnePreview(FPreviewContainer.Containers[i].Preview);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'CreateResubFavsInPreviews', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateResubFavsInPreviews', ClassName);
  end;
end;
//28.05.2019 Ticket 18910 <--

procedure TbfaApplication.CreateLinkListPopup;
var
  item: TSpTBXItem;
  i, j: Integer;
  HintStr, semicol, str: string;
  lst: TStringList;
  found: Boolean;
begin
  try
    frmMainForm.popLinksList.Items.Clear;
    for i := 0 to PopupLinkList.Count - 1 do
    begin
      found := False;
      for j := 0 to frmMainForm.popLinksList.Items.Count - 1 do
      begin
        if frmMainForm.popLinksList.Items[j].Caption = PopupLinkList[i] then
        begin
          found := True;
          Break;
        end;
      end;

      if not found then
      begin
        item := TSpTBXItem.Create(frmMainForm.popLinksList);
        item.Caption := PopupLinkList[i];
        item.Tag := i;
        item.Enabled := True;
        item.Visible := True;
        item.OnClick := popLinksListOnClick;
        item.Options := [tboNoAutoHint]; // SJ 24.01.2022 - bfacrm:ticket__show__13719
//        item.Hint := Format(_('Aktuelles Dokument mit %s verknpfen'), [PopupLinkList[i]]);

        frmMainForm.popLinksList.Items.Add(item);
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'CreateLinkListPopup', ClassName);
  end;
end;

procedure TbfaApplication.RefSearch(UserAction: PUserAction; AThread: TThread);
var
  SObj, HistorySObj: TbfaSearch;
  selcols: WideString;
begin
  bitfarmLog.DebugBegin(llDebug, 'RefSearch', ClassName);
  try
    try
      if (not FPreviewContainer.ViewerItem.Tab.Visible) or (CurrentView <> TbfaViewKind(pvtViewer)) then
      begin
        frmMainForm.fSkipMaximizeEvent := True;
        try
          frmMainForm.pnlTreeView.Maximize;
        finally
          frmMainForm.fSkipMaximizeEvent := False;
        end;
        SetActiveView(AThread, pvtViewer);
        CurrentViewerArchive.Arcid := -1;
        CurrentViewerFields := -1;
        fSkipAutoDisplay := True; //18.09.2019 Ticket 20560
        try
          ChangeArchiveFromProgram(frmMainForm.FViewerTreeview.LastSelected, AThread);
        finally
          fSkipAutoDisplay := False; //18.09.2019 Ticket 20560
        end;
      end;

      if (frmMainForm.grdResultlistDevExView.DataController.DataSource <> nil) and
         (frmMainForm.grdResultlistDevExView.DataController.DataSource.DataSet <> nil) and
         (frmMainForm.grdResultlistDevExView.DataController.DataSource.DataSet.RecordCount > 0)
      then
        bitfarmApp.GridLastSelectedGdDocID :=
            frmMainForm.grdResultlistDevExView.DataController.GetValue(
            frmMainForm.grdResultlistDevExView.ActRec,
            frmMainForm.grdResultlistDevExView.DataController.GetItemByFieldName('gdocid').Index);

      Reset(AThread);
      FSearchObj.SearchType := 0;
      SObj := TbfaSearch.Create;
      try
        with SObj do
        begin
          Reset;
          Id := 1;
          name := 'Verlaufs-Lesezeichen';
          Date := FormatDateTime('dd.mm.yyyy hh:nn:ss', Now);

          Order := 'docdate';
          Direction := 'DESC';

          SearchType := 0; // Normale Suche

          SelectedArcID := CurrentViewerArchive.Arcid;
          if CurrentViewerArchive.Typ = 0 then    //lager
          begin
            arcid := GetArcids(CurrentViewerArchive.Arcid, user.ID);
            if arcid.Count = 0 then
              arcid.Add(IntToStr(aSysArc[0].arcid));
          end
          else
            arcid.CommaText := IntToStr(CurrentViewerArchive.Arcid);

          UserContext := user.ID;

          MaxValues := -1;

          selcols := SetSelectedColumns;
          if selcols <> '' then
            SelectedCols := selcols;
//28.07.2017 Ticket 11245 -->
          if (SelectedCols <> '') and (pos('arcname', SelectedCols) = 0) then
            SelectedCols := SelectedCols + ',arcname';
//28.07.2017 Ticket 11245 <--

          RefSearch := UserAction^.params[0];
        end;

//28.07.2017 Ticket 11245 -->
        AddArchiveColumn(AThread, SObj);
//28.07.2017 Ticket 11245 <--

        HistorySObj := TbfaSearch.Create;
        HistorySObj.Clone(SObj);
        HistorySObj.SearchType := 3;
        HistorySObj.Constructive := True;
        HistorySObj.Date := FormatDateTime('dd.mm.yyyy hh:nn:ss', Now);
        HistorySObj.Name := HistorySObj.Date;

        {$IFDEF DISABLE_HISTORY_FUTURE_DELETE}
        StartSearchThread(SObj);
        {$ELSE}
        StartSearchThread(SObj, HistorySObj);
        {$ENDIF}

        frmMainForm.fraDocLinks.LastLink := Sobj.RefSearch;

        PopupLinkList.Add(Sobj.RefSearch);

        while PopupLinkList.Count > 10 do
          PopupLinkList.Delete(0);

        CreateLinkListPopup;

        //25.04.2019 Ticket 17436 -->
        {$IFDEF DISABLE_HISTORY_FUTURE_DELETE}
        AddToHistoryList(AThread, HistorySObj);
        {$ENDIF}
        //25.04.2019 Ticket 17436 <--
      finally
        FreeAndNil(SObj);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'RefSearch', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'RefSearch', ClassName);
  end;
end;

procedure TbfaApplication.NewLink(UserAction: PUserAction; AThread: TThread);
var
  UAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'NewLink', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        var
          RefName: WideString;
          OnlyFirst, AutoRef, UseLastLink, lb, found: Boolean;
          qry: TUniQuery;
          req: TbfaRequest;
          i, j: Integer;
          docids: string;
        begin
          if bitfarmApp.CurrentContainer.Count = 0 then
          begin
            BfMessageDlg(_('Bitte whlen Sie ein Dokument aus und \nwiederholen Sie den Vorgang.'), mtError, [mbOK]);
            Exit;
          end;

          OnlyFirst := (UserAction^.params[0] = '1');
          AutoRef := (UserAction^.params[1] = '1');
          UseLastLink := (UserAction^.params[2] = '1');

          if UserAction^.params.Count > 3 then
            RefName := UserAction^.params[3]
          else
            RefName := '';

          if AutoRef and (RefName = '') then
            RefName := CreateAutoRefID;

          if UseLastLink then
            RefName := frmMainForm.fraDocLinks.LastLink;

          if RefName = '' then
            lb := GetNewDocLinkName(frmMainForm, bitfarmApp.ViewerOptions.SearchOptions.ShowDocLinks, RefName)
          else
            lb := True;

//          RefName := ParseSemicolonWithoutBackslash(RefName);
              RefName := ParseAddfields(RefName);
          if RefName = '' then
            Exit;

          if lb then
          begin
//          <!-- SJ 04.09.2019
            docids := '';
            for i := 0 to FCurrentContainer.Count - 1 do
            begin
              found := False;
              for j := Low(FCurrentContainer[i].DocLinkList) to High(FCurrentContainer[i].DocLinkList) do
              begin
                if FCurrentContainer[i].DocLinkList[j].RefName = RefName then
                begin
                  found := True;
                  Break;
                end;
              end;
              if not found then
              begin
                if docids <> '' then
                  docids := docids + ',' + IntToStr(FCurrentContainer[i].Id)
                else
                  docids := IntToStr(FCurrentContainer[i].Id);
              end;
            end;

            if docids = '' then
            begin
              if FCurrentContainer.Count > 1 then
//                BfShowMessage(Format(_('Die Dokumente sind schon mit %s verknpft.'), [RefName]))
                frmMainForm.SetNotificationBar(Format(_('Die Dokumente sind schon mit %s verknpft.'), [RefName]), AThread)
              else
//                BfShowMessage(Format(_('Das Dokument ist schon mit %s verknpft.'), [RefName]));
                frmMainForm.SetNotificationBar(Format(_('Das Dokument ist schon mit %s verknpft.'), [RefName]), AThread);
              Exit;
            end;
//          SJ 04.09.2019 -->

            if not (AutoRef or UseLastLink) then
            begin
              qry := TUniQuery.Create(nil);
              try
                try
                  qry.Connection := dmMain.cntMain;
                  qry.SQL.Text := 'select refid, refname from sys_doclink where refname=' + #39 + RefName + #39;
                  qry.Open;
                  qry.First;
                  if qry.RecordCount > 0 then
                  begin
                    if RefName <> '' then

                      lb := BfMessageDlg(Format(_('Es existiert bereits eine Verknpfung mit dem Namen %s.\nSoll das Dokument mit dieser verknpft werden?'), [RefName]), mtConfirmation, [mbYes, mbNo]) = mrYes
                  end
                  else
                    lb := true;
                except
                  Log.Write(llNormal, ltException, 'NewLink', ClassName);
                end;
              finally
                qry.Close;
                FreeAndNil(qry);
              end;
            end;

            if lb then
            begin
//          <!-- SJ 04.09.2019
//              docids := '';
//              for i := 0 to FCurrentContainer.Count - 1 do
//              begin
//                found := False;
//                for j := Low(FCurrentContainer[i].DocLinkList) to High(FCurrentContainer[i].DocLinkList) do
//                begin
//                  if FCurrentContainer[i].DocLinkList[j].RefName = RefName then
//                  begin
//                    found := True;
//                    Break;
//                  end;
//                end;
//                if not found then
//                begin
//                  if docids <> '' then
//                    docids := docids + ',' + IntToStr(FCurrentContainer[i].Id)
//                  else
//                    docids := IntToStr(FCurrentContainer[i].Id);
//                end;
//              end;
//
//              if docids = '' then
//              begin
//                if FCurrentContainer.Count > 1 then
//                  BfShowMessage(Format(_('Die Dokumente sind schon mit %s verknpft.'), [RefName]))
//                else
//                  BfShowMessage(Format(_('Das Dokument ist schon mit %s verknpft.'), [RefName]));
//                Exit;
//              end;
//          SJ 04.09.2019 -->

              req := TbfaRequest.Create;
              try
                req.ReqType := 'reqCreateNewLink';
                req.UserID := user.ID;
                req.Profile := Self.Profile;
                req.Parameter := RefName + ';' + docids;
                req.Lang := Lang;
                MainSocket.SendRequestToServer(req);

                req := MainSocket.ReceiveResponse;
                if req = nil then
                  Exit;

            //27.11.2018 Ticket 16957 -->
                if req.ReqType = 'respAuthError' then
                begin
                  BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'), AThread);
                  UAction := CreateUserAction;
                  UAction^.ActionName := 'actRelogin';
                  MainThread.Add(UAction);
                  Exit;
                end
                else
            //27.11.2018 Ticket 16957 <--
                if req.ReqType = 'respError' then
                  BfShowMessage(_('Die Verknpfung konnte nicht angelegt werden.') + #13#10+ req.DataString, AThread)
                else
                begin
//25.01.2017                if not Autoref then
                  frmMainForm.fraDocLinks.LastLink := RefName;

                  PopupLinkList.Add(RefName);

                  while PopupLinkList.Count > 10 do
                    PopupLinkList.Delete(0);

                  CreateLinkListPopup;

                  if (FViewerOptions.GeneralOptions.AlertWindow) then
                    ShowAlertWindow(alDocLink, Format(_('Das Dokument wurde mit Referenz %s verknpft.'), [RefName]))
                  else
                    frmMainForm.SetNotificationBar(Format(_('Das Dokument wurde mit Referenz %s verknpft.'), [RefName]), nil); // SJ 14.08.2019

                  bfaProcessing.ReloadLinks(FCurrentContainer[0]);
                  FillDocLinkList;
                  SetDocState(FCurrentContainer[0]);
                end;
              finally
                FreeAndNil(req);
              end;
            end; {else if frmMainForm.fraDocLinks.Visible then    // bfacrm:ticket__show__20238  hier hatten wir noch eine Mglichkeit fr die Dauerschleife
              frmMainForm.fraDocLinks.lvwDocLink.SetFocus;}      // wir gehen einfach aus dem eingabefeld raus, ist zwar quick n dirty, aber alles andere wre slow and expensive

          end;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'NewLink', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'NewLink', ClassName);
  end;
end;

procedure TbfaApplication.popDocLinksOnClick(Sender: TObject);
var
  idx : Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'popDocLinksOnClick', ClassName);
  try
    try
//15.08.2019 Wenn die Verknpfung () im Text hat, macht es Probleme -->
      if FViewerOptions.GeneralOptions.ShowLinkCount then
      begin
        idx := LastDelimiter('(', TSpTBXItem(Sender).Caption) - 2;
        if idx > 0 then
          CreateRefSearchAction(LeftStr(TSpTBXItem(Sender).Caption, idx))
        else
          CreateRefSearchAction(TSpTBXItem(Sender).Caption);
      end
      else
//15.08.2019 Wenn die Verknpfung () im Text hat, macht es Probleme <--
        CreateRefSearchAction(TSpTBXItem(Sender).Caption);
    except
      bitfarmLog.Write(llNormal, ltException, 'popDocLinksOnClick', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'popDocLinksOnClick', ClassName);
  end;
end;

procedure TbfaApplication.popResubFavsOnClick(Sender: TObject);
var
  UserAction: PUserAction;
  i: Integer;
  resub: PResub;
begin
  if CurrentView = tvkImporter then
  begin
    frmMainForm.fraImporterResub.LoadResub := True;
    try
      bitfarmApp.LoadWVLFavorite(frmMainForm.fraImporterResub, TSpTBXItem(Sender).Tag);
      frmMainForm.fraImporterResub.cbbFavorites.ItemIndex :=  TSpTBXItem(Sender).Tag;
    finally
      frmMainForm.fraImporterResub.LoadResub := False;
    end;
  end else begin
    UserAction := CreateUserAction;
    UserAction^.ActionName := 'actSaveResub';
    resub := @aResubFavs[TSpTBXItem(Sender).Tag];
    for i := 0 to FCurrentContainer.Count - 1 do
      UserAction^.Documents.Add(FCurrentContainer[i]);
    if frmMainForm.popResubFavs.PopupComponent = frmMainform.fraResub.btnResubForward then
      UserAction^.params.Add('forward')
    else
    begin
      UserAction^.params.Add('create');
      resub^.UseridShed := user.ID;
    end;

    UserAction^.objects.Add(TObject(resub));
    FMainThread.Add(UserAction);
  end;
end;

procedure TbfaApplication.popLinksListOnClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llNormal, 'popLinksListOnClick', ClassName);
  try
    try
      if Assigned(frmMainForm.fraDocLinks) then
      begin
        frmMainForm.fraDocLinks.LastLink := TSpTBXItem(Sender).Caption;
        frmMainForm.actAddLink.Execute;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'popLinksListOnClick', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'popLinksListOnClick', ClassName);
  end;
end;

procedure TbfaApplication.btnResubCancelClick(Sender: TObject);
var
  UserAction: PUserAction;
  i: Integer;
begin
  if (FCurrentContainer.Count = 0) or (CurrentView <> tvkResub) then
    Exit;

//22.02.2022  if ResubKind = rkController then
  if frmMainForm.fraResub.ResubKind = rkController then
  begin
    if BfMessageDlg(_('Sie befinden sich in der delegierten Wiedervorlage.\nSoll der Vorgang wirklich durchgefhrt werden?'), mtConfirmation, mbOKCancel) = mrCancel then
      Exit;
  end;

  UserAction := CreateUserAction;
  UserAction^.ActionName := 'actSaveResub';
  for i := 0 to FCurrentContainer.Count - 1 do
    UserAction^.Documents.Add(FCurrentContainer[i]);
  UserAction^.params.Add('cancel');
  FMainThread.Add(UserAction);
end;

procedure TbfaApplication.btnResubDoneClick(Sender: TObject);
var
  UserAction: PUserAction;
  i: Integer;
begin
  bitfarmLog.DebugEnd(llDebug, 'btnResubDoneClick', ClassName);
  try
    try
      if (FCurrentContainer.Count = 0) or (CurrentView <> tvkResub) then
        Exit;

//22.02.2022      if (ResubKind = rkController) and (frmMainForm.fraResub.DelegateView <> 3) then
      if (frmMainForm.fraResub.ResubKind = rkController) and (frmMainForm.fraResub.DelegateView <> 3) then
      begin
        if BfMessageDlg(_('Sie befinden sich in der delegierten Wiedervorlage.\nSoll der Vorgang wirklich durchgefhrt werden?'), mtConfirmation, mbOKCancel) = mrCancel then
          Exit;
      end;

      UserAction := CreateUserAction;
      UserAction^.ActionName := 'actSaveResub';
      for i := 0 to FCurrentContainer.Count - 1 do
        UserAction^.Documents.Add(FCurrentContainer[i]);
//22.02.2022      if (ResubKind = rkController) and (frmMainForm.fraResub.DelegateView = 3) then
      if ((frmMainForm.fraResub.ResubKind = rkController) and (frmMainForm.fraResub.DelegateView = 3))
          or ((frmMainForm.fraResub.ResubKind = rkMyTasks) and (frmMainForm.fraResub.MyTasksView = 3)) //03.08.2022 Ticket 31787
      then
        UserAction^.params.Add('delete')
      else
        UserAction^.params.Add('set_done');
      FMainThread.Add(UserAction);

    except
      bitfarmLog.Write(llNormal, ltException, 'btnResubDoneClick', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'btnResubDoneClick', ClassName);
  end;
end;

procedure TbfaApplication.OCRResultToGeneralSearch(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'OCRResultToGeneralSearch', Classname);
  try
    try
      UserAction := CreateUserAction;
      UserAction.ActionName := 'actOCRResultToGeneralSearch';
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'OCRResultToGeneralSearch', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'OCRResultToGeneralSearch', Classname);
  end;
end;

procedure TbfaApplication.OCRResultToGeneralSearchInTree(Sender: TObject);  //08.05.2024 SD neuer Menpunkt -->bfacrm:ticket__show__38698
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'OCRResultToGeneralSearchInTree', Classname);
  try
    try
      UserAction := CreateUserAction;
      UserAction.ActionName := 'actOCRResultToGeneralSearchInTree';
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'OCRResultToGeneralSearchInTree', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'OCRResultToGeneralSearchInTree', Classname);
  end;
end;

procedure TbfaApplication.OCRResultToSearchToolbar(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'OCRResultToSearchToolbar', Classname);
  try
    try
      UserAction := CreateUserAction;
      UserAction.ActionName := 'actOCRResultToSearchToolbar';
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'OCRResultToSearchToolbar', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'OCRResultToSearchToolbar', Classname);
  end;
end;

procedure TbfaApplication.OnClickSetOwnResubDone(Sender: TObject);
var
  UserAction: PUserAction;
  i: Integer;
  Menuitem: TSpTBXItem;
  TimId: int64;
begin
  bitfarmLog.DebugEnd(llDebug, 'OnClickSetOwnResubDone', ClassName);
  try
    try
      if (FCurrentContainer.Count <> 1) or (CurrentView = tvkResub) then
        Exit;

      Menuitem := TSpTBXItem(Sender);
      TimId := TbfaInt64(Menuitem.Tag).value;
      FCurrentContainer[0].TimId := TimId;

      UserAction := CreateUserAction;
      UserAction^.ActionName := 'actSaveResub';
      UserAction^.Documents.Add(FCurrentContainer[0]);
      UserAction^.params.Add('set_done');
      FMainThread.Add(UserAction);

    except
      bitfarmLog.Write(llNormal, ltException, 'OnClickSetOwnResubDone', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'OnClickSetOwnResubDone', ClassName);
  end;
end;

procedure TbfaApplication.btnResubForwardClick(Sender: TObject);
var
  UserAction: PUserAction;
  resub: PResub;
  i, j: Integer;
begin
  if (FCurrentContainer.Count = 0) or (CurrentView <> tvkResub) then
    Exit;

  frmMainForm.frmResubDialog.fraCreateResub.LoadResub := True;
  try
    frmMainForm.frmResubDialog.Caption := _('Wiedervorlage weiterleiten');
    with frmMainForm.frmResubDialog.fraCreateResub do
    begin
      btnOk.Caption := _('Weiterleiten');
      Clear;
      edtAlarm1.Text := '7';
      cbbFavorites.ItemIndex := -1;

      for i := 0 to FCurrentContainer[0].Workflows.Count - 1 do
      begin
        if FCurrentContainer[0].Workflows[i].TimID = FCurrentContainer[0].TimID then
        begin
          InitialOptions := FCurrentContainer[0].Workflows[i].options;
          edtInfoCreate.Text := FCurrentContainer[0].Workflows[i].Info;
          edtInfoFoward.Text := FCurrentContainer[0].Workflows[i].Comment;
          dtDate1.Date := FCurrentContainer[0].Workflows[i].Date;

          chkReturnToSender.Checked := (FCurrentContainer[0].Workflows[i].options and 2) = 2;
          chkReturnToSender.Enabled := not chkReturnToSender.Checked;   // leiten wir mit rts weiter, dann bleibt return to sender stehen, man kann es nicht wieder entfernen
          chkEmailreminder.Checked := (FCurrentContainer[0].Workflows[i].options and 4) = 4;
          chkNotifyByMail.Checked := (FCurrentContainer[0].Workflows[i].options and 64) = 64;
          chkEveryone.Checked := (FCurrentContainer[0].Workflows[i].options and 1) = 1;
          chkOnlyOne.Checked := not chkEveryone.Checked;

          cbbGroup.SetUnCheckedAll;
          cbbUser.SetUnCheckedAll;
          Break;
        end
      end;

    end;
  finally
    frmMainForm.frmResubDialog.fraCreateResub.LoadResub := False

  end;

  frmMainForm.frmResubDialog.ShowModal;

  if frmMainForm.frmResubDialog.ModalResult = mrOK then
  begin
    resub := frmMainForm.frmResubDialog.fraCreateResub.GetResub;
    resub^.TimID := FCurrentContainer[0].TimID;
    UserAction := CreateUserAction;
    UserAction^.ActionName := 'actSaveResub';
    UserAction^.objects.Add(TObject(resub));
    for i := 0 to FCurrentContainer.Count - 1 do
      UserAction^.Documents.Add(FCurrentContainer[i]);
    UserAction^.params.Add('forward');
    FMainThread.Add(UserAction);
  end;
end;

procedure TbfaApplication.ResubCreateExecute(doc: TbfaDocument = nil);
var
  UserAction: PUserAction;
  resub: PResub;
  i, j: Integer;
begin
  if (doc = nil) and (FCurrentContainer.Count = 0) then   // eigentlich nur fr eins, oder?
    Exit;

  if doc = nil then
    doc := FCurrentContainer[0];

  frmMainForm.frmResubDialog.fraCreateResub.LoadResub := True;
  try
    frmMainForm.frmResubDialog.Caption := _('Wiedervorlage anlegen');
    with frmMainForm.frmResubDialog.fraCreateResub do
    begin
      btnOk.Caption := _('Anlegen');
      Clear;
      edtAlarm1.Text := '7';
      cbbFavorites.ItemIndex := -1;
      dtDate1.Date := Now();

      chkEmailreminder.Checked := ViewerOptions.ResubOptions.Emailreminder;
      chkReturnToSender.Checked := ViewerOptions.ResubOptions.ReturnToSender;
      chkReturnToSender.Enabled := not chkReturnToSender.Checked;
      chkNotifyByMail.Checked := ViewerOptions.ResubOptions.NotifyByMail;
    end;
  finally
    frmMainForm.frmResubDialog.fraCreateResub.LoadResub := False
  end;

  frmMainForm.frmResubDialog.ShowModal;

  if frmMainForm.frmResubDialog.ModalResult = mrOK then
  begin
    resub := frmMainForm.frmResubDialog.fraCreateResub.GetResub;
    resub^.TimID := doc.TimID;
    resub^.UseridShed := user.ID;

    if (frmMainForm.frmResubDialog.fraCreateResub.cbbUser.Text = '') and (frmMainForm.frmResubDialog.fraCreateResub.cbbGroup.Text = '') then
      resub^.Users := user.ID.ToString;

    UserAction := CreateUserAction;
    UserAction^.ActionName := 'actSaveResub';
    UserAction^.objects.Add(TObject(resub));
    UserAction^.Documents.Add(doc);
    for i := 1 to FCurrentContainer.Count - 1 do     // falls noch weitere Dokument ausgewhlt wurden
      UserAction^.Documents.Add(FCurrentContainer[i]);
    UserAction^.params.Add('create');
    FMainThread.Add(UserAction);
  end;
end;

procedure TbfaApplication.btnSaveResubClick(Sender: TObject);
var
  UserAction: PUserAction;
  resub: PResub;
  userid, groupid: Integer;
  i: Integer;
begin
  if FCurrentContainer.Count = 0 then
    Exit;

  New(resub);
  FillChar(resub^, SizeOf(resub^), 0);
  resub^.Info := frmMainForm.fraResub.edtResubInfo.Text;
  resub^.Comment := frmMainForm.fraResub.edtResubComment.Text;
  userid := -1;
  groupid := -1;

  for i := 0 to FCurrentContainer[0].Workflows.Count - 1 do
  begin
    if FCurrentContainer[0].Workflows[i].TimID = FCurrentContainer[0].TimID then
    begin
      resub^.TimID := FCurrentContainer[0].TimID;
      resub^.TimRef := FCurrentContainer[0].Workflows[i].TimRef;
      resub^.options := FCurrentContainer[0].Workflows[i].options;
      resub^.Status := FCurrentContainer[0].Workflows[i].Status;
      resub^.UseridShed := FCurrentContainer[0].Workflows[i].UseridShed;
//22.02.2022      if ResubKind = rkMyTasks then
      if frmMainForm.fraResub.ResubKind = rkMyTasks then
      begin
        resub^.Date := frmMainForm.fraResub.cxDateEdit1.Date;
        resub^.AlarmDate := IncDay(resub^.Date, 7);
        resub^.Users := IntToStr(FCurrentContainer[0].Workflows[i].UseridWork);
        resub^.Groups := IntToStr(FCurrentContainer[0].Workflows[i].groupid);
        if frmMainform.fraResub.tbiResubWork.Color = gclYellow then
          resub^.Status := 2
        else
          resub^.Status := 0;
      end
//22.02.2022      else if ResubKind = rkController then
      else if frmMainForm.fraResub.ResubKind = rkController then
      begin
        if frmMainform.fraResub.cbbUserGroups.ItemIndex < frmMainForm.fraResub.IndexUserPos then
          groupid := Integer(frmMainform.fraResub.cbbUserGroups.Items.Objects[frmMainform.fraResub.cbbUserGroups.ItemIndex])
        else
          userid := Integer(frmMainform.fraResub.cbbUserGroups.Items.Objects[frmMainform.fraResub.cbbUserGroups.ItemIndex]);
        resub^.Users := IntToStr(userid);
        resub^.Groups := IntToStr(groupid);
        resub^.AlarmDate := FCurrentContainer[0].Workflows[i].AlarmDate;
        resub^.Date := FCurrentContainer[0].Workflows[i].Date;

      end;
      Break;
    end;
  end;

  UserAction := CreateUserAction;
  UserAction^.ActionName := 'actSaveResub';
  UserAction^.objects.Add(TObject(resub));
  for i := 0 to FCurrentContainer.Count - 1 do
    UserAction^.Documents.Add(FCurrentContainer[i]);
  UserAction^.params.Add('change');
  FMainThread.Add(UserAction);
end;

procedure TbfaApplication.CreateNewLinkAction(OnlyFirstObject, AutoRef, UseLastLink: Boolean; RefName: string = '');
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateNewLinkAction', ClassName);
  try
    try
      UserAction := CreateUserAction;
      UserAction^.ActionName := 'actNewLink';

      if OnlyFirstObject then
        UserAction^.params.Add('1')  // nur erste Dok aus FCurrentContainer
      else
        UserAction^.params.Add('0'); // alle aus FCurrentContainer

      if AutoRef then
        UserAction^.params.Add('1')  //AutoRef erzeugen
      else
        UserAction^.params.Add('0'); //mit Dialog

      if UseLastLink then
        UserAction^.params.Add('1')
      else
        UserAction^.params.Add('0');

      if RefName <> '' then
        UserAction^.params.Add(RefName);

      FMainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'CreateNewLinkAction', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateNewLinkAction', ClassName);
  end;
end;

function TbfaApplication.CreateAutoRefID: WideString;
begin
  try
    result := 'AutoRef ' + FormatDateTime('dd.mm.yy hh:mm:ss', Now()) + '-' + IntToStr(FUser.ID);
  except
    bitfarmLog.Write(llNormal, ltException, 'CreateNewLinkAction', ClassName);
  end;
end;

procedure TbfaApplication.SetStdStsInfo(itm: TSpTBXLabelItem; AThread: TThread);
var
  str, FileSize: WideString;
begin
  if FPluginIsRunning then
    Exit;

  bitfarmLog.DebugBegin(llDebug, 'SetStdStsInfo', ClassName);
  try
    try
      str := '';
      if (FCurrentContainer.Count > 0) then
      begin
        if (FCurrentContainer[0].arcid = -1) then
          str := _('Nicht archiviert.')
        else
        begin
          if (FCurrentContainer[0].SymbolicArcID <> -1) and
             (FCurrentContainer[0].SymbolicArcID <= High(aSysArc)) then
            str := _('Archiv: ') + aSysArc[FCurrentContainer[0].SymbolicArcID].name
          else if FCurrentContainer[0].ArcID <= High(aSysArc) then
            str := _('Archiv: ') + aSysArc[FCurrentContainer[0].ArcID].name;
        end;

        if (FCurrentContainer[0].Id <> -1) and (not FCurrentContainer[0].haspreview) then
          str := _('Fehler: Die Voransicht konnte nicht geladen werden');

        try
          // bfacrm:ticket__show__29347
//          if (not FCurrentContainer[0].HasPreview) and (FCurrentContainer[0].OriLoc <> '') then
          if (FCurrentContainer[0].OriStream <> nil) and (FCurrentContainer[0].OriLoc <> '') then //01.10.2024 SD <--bfacrm:ticket__show__39480

//24.05.2023            FileSize := GetStreamSizeStr(FCurrentContainer[0].OriStream)
            FileSize := GetStreamSizeStr(TMemoryStream(FCurrentContainer[0].OriStream))
          else
            FileSize := GetStreamSizeStr(FCurrentContainer[0].DocStream);

          str := str + ' - ' + _('Dokument: ') + FCurrentContainer[0].DocName + ' - ' + _('Datum: ') +
            FormatDateTime('dd.mm.yyyy', VarToDateTime(FCurrentContainer[0].DocDate)) + ' - ' +
            _('Gre: ') + FileSize + ' - ' +
            _('Dateityp: ') + StringReplace(FCurrentContainer[0].FileType, '.', '', [rfReplaceAll]);
          str := StringReplace(str, '&', '&&', [rfReplaceAll]);
        except
          //
        end;
      end;

      if AThread <> nil then
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            itm.Caption := str;
          end);
      end else
        itm.Caption := str;

    except
      bitfarmLog.Write(llNormal, ltException, 'SetStdStsInfo', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetStdStsInfo', ClassName);
  end;
end;

procedure TbfaApplication.SetViewAndArchiveAction(newview: TbfaViewKind);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'SetViewAndArchiveAction', ClassName);

  try
    try
      UserAction := CreateUserAction;
      UserAction^.ActionName := 'actSetViewAndArchive';
      UserAction^.params.Add(IntToStr(Integer(newview)));
      FMainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'SetViewAndArchiveAction', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetViewAndArchiveAction', ClassName);
  end;
end;

// diese Funktion soll genutzt werden, um programmatisch die View zu wechseln
procedure TbfaApplication.SetViewAndArchive(AThread: TThread; newview: TbfaViewKind);
var
  curview: TbfaViewKind;
  Params: TStringList;
  Objects: TList;
  Node: TTreeNode;
begin
  curview := CurrentView;

  if (newview = tvkViewer) and (curview = tvkViewer) and (FPreviewContainer.ActiveItem = 0) then
    Exit;

  if (newview = tvkFavorites) and (curview = tvkFavorites) and (FPreviewContainer.ActiveItem = 0) then
    Exit;

  if (newview = tvkImporter) and (curview = tvkImporter) and (FPreviewContainer.ActiveItem = 1) then
    Exit;

  if (newview = tvkResub) and (curview = tvkResub) and (FPreviewContainer.ActiveItem = 0) then
    Exit;

  if (newview = tvkAdministrator) and (curview = tvkAdministrator) and (FPreviewContainer.ActiveItem = 5) then
    Exit;

  if (newview = tvkWorkplace) and (curview = tvkWorkplace) and (FPreviewContainer.ActiveItem = 2) then
    Exit;

  AThread.Synchronize(nil,
    procedure
    begin
      case newview of
        tvkViewer:
          begin
            if not frmMainForm.pnlTreeview.Maximized then
            begin
              frmMainForm.fSkipMaximizeEvent := True;
              try
                frmMainForm.pnlTreeview.Maximize;
              finally
                frmMainForm.fSkipMaximizeEvent := False;
              end;
            end;
          end;
        tvkImporter:
          begin
            if not frmMainForm.pnlImporter.Maximized then
            begin
              frmMainForm.fSkipMaximizeEvent := True;
              try
                frmMainForm.pnlImporter.Maximize;
              finally
                frmMainForm.fSkipMaximizeEvent := False;
              end;
            end;
          end;
        tvkFavorites:
          begin
            if not frmMainForm.pnlFavorites.Maximized then
            begin
              frmMainForm.fSkipMaximizeEvent := True;
              try
                frmMainForm.pnlFavorites.Maximize;
              finally
                frmMainForm.fSkipMaximizeEvent := False;
              end;
            end;
          end;
        tvkResub:
          begin
            if not frmMainForm.pnlResubmission.Maximized then
            begin
              frmMainForm.fSkipMaximizeEvent := True;
              try
                frmMainForm.pnlResubmission.Maximize;
              finally
                frmMainForm.fSkipMaximizeEvent := False;
              end;
            end;
          end;
        tvkAdministrator:
          begin
            if not frmMainForm.pnlAdmin.Maximized then
            begin
              frmMainForm.fSkipMaximizeEvent := True;
              try
                frmMainForm.pnlAdmin.Maximize;
              finally
                frmMainForm.fSkipMaximizeEvent := False;
              end;
            end;
          end;
        tvkWorkplace:
          begin
            if not frmMainForm.pnlWorkspace.Maximized then
            begin
              frmMainForm.fSkipMaximizeEvent := True;
              try
                frmMainForm.pnlWorkspace.Maximize;
              finally
                frmMainForm.fSkipMaximizeEvent := False;
              end;
            end;
          end;
      end;
    end);

  try
    Params := TStringList.Create();
    Objects := TList.Create;

    case newview of
      tvkViewer:
        begin
          SetActiveView(AThread, 0, nil, Integer(tvkViewer));
          Node := frmMainForm.FViewerTreeview.Selected;
          Params.Add(GetEnumName(TypeInfo(TbfaViewKind), integer(tvkImporter)));
          Params.Add(IntToStr(frmMainForm.FViewerTreeview.LastSelected));
          Params.Add(GetEnumName(TypeInfo(TbfaViewKind), integer(curview)));
        end;
      tvkImporter:
        begin
          SetActiveView(AThread, 1, nil, Integer(tvkImporter));
          Node := frmMainForm.FImporterTreeview.Selected;
          Params.Add(GetEnumName(TypeInfo(TbfaViewKind), integer(tvkImporter)));
          Params.Add(IntToStr(frmMainForm.FImporterTreeview.LastSelected));
          Params.Add(GetEnumName(TypeInfo(TbfaViewKind), integer(curview)));
        end;
      tvkFavorites:
        begin
          SetActiveView(AThread, 0, nil, Integer(tvkFavorites));
          Node := frmMainForm.FImporterTreeview.Selected;
          Params.Add(GetEnumName(TypeInfo(TbfaViewKind), integer(tvkFavorites)));
          Params.Add(IntToStr(frmMainForm.FImporterTreeview.LastSelected));
          Params.Add(GetEnumName(TypeInfo(TbfaViewKind), integer(curview)));
        end;
      tvkResub:
        SetActiveView(AThread, 0, nil, Integer(tvkResub));
      tvkAdministrator:
        SetActiveView(AThread, 5, nil, Integer(tvkAdministrator));
      tvkWorkplace:
        SetActiveView(AThread, 2, nil, Integer(tvkWorkplace));
    end;

    if newview in [tvkViewer, tvkImporter, tvkFavorites] then
    begin
      Objects.Add(Node);
      if newview = tvkViewer then
        fSkipAutoDisplay := True;
      try
        ChangeArchive(Params, Objects, AThread);
      finally
        fSkipAutoDisplay := False;
      end;
    end;
  finally
    FreeAndNil(Objects);
    FreeAndNil(Params);
  end;

end;

procedure TbfaApplication.SetStandardStatusInfo(AThread: TThread);
var
  itm: TSpTBXLabelItem;
begin
  if FPluginIsRunning then
    Exit;
  bitfarmLog.DebugBegin(llDebug, 'SetStandardStatusInfo', ClassName);
  try
    try
      if GetActivePreview <> nil then
      begin
        if not GetActivePreview.Floating then
          itm := frmMainForm.itmInfo
        else
          itm := TbfaFloatingForm((TSpTBXDockablePanel(GetActivePreview.Owner).Parent).Parent).itmFloatingInfo;
      end
      else
        itm := frmMainForm.itmInfo;

      SetStdStsInfo(itm, AThread);

    except
      bitfarmLog.Write(llNormal, ltException, 'SetStandardStatusInfo', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetStandardStatusInfo', ClassName);
  end;
end;

procedure TbfaApplication.SetStatusInfo(Info: WideString; AThread: TThread; tmr: Boolean = True);
begin
  if FPluginIsRunning then
    Exit;

  bitfarmLog.DebugBegin(llDebug, 'SetStatusInfo', ClassName);
  try
    try
      if AThread = nil then
      begin
        frmMainForm.itmInfo.Caption := Info;
        frmMainForm.tmrStatusBar.Enabled := tmr;
      end
      else
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            frmMainForm.itmInfo.Caption := Info;
            frmMainForm.tmrStatusBar.Enabled := tmr;
          end);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'SetStatusInfo', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetStatusInfo', ClassName);
  end;
end;

procedure TbfaApplication.SetStatusBarID(ArcID, GDocID: Int64; GUID: WideString; AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'SetStatusBarID', ClassName);
  try
    try
      if AThread = nil then
      begin
        frmMainForm.SetStatusBarID(ArcID, GDocID, GUID);
      end
      else
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            frmMainForm.SetStatusBarID(ArcID, GDocID, GUID);
          end);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'SetStatusBarID', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetStatusBarID', ClassName);
  end;
end;

function TbfaApplication.IsFloatingForms: Boolean;
begin
  result := False;
  try
    if (frmMainForm.pnlSearchOptions.Parent.Name = 'dckFloating') then
      result := (FloatingForms.Count > 2)
    else
      result := (FloatingForms.Count > 1);
  except
    result := False;
  end;
end;

// SJ 23.09.2021
//function TbfaApplication.CanFocus: Boolean;
//begin
//  result := (not (frmMainForm.ActiveControl is TSpTBXEdit)) and
//    (not (frmMainForm.ActiveControl is TcxDateEdit)) and
//    (not (frmMainForm.ActiveControl is TSpTBXComboBox)) and
//    (not (frmMainForm.ActiveControl is TSpTBXButtonEdit)) and
//    (not (frmMainForm.ActiveControl is TbfaCheckedListBox)) and
//    (not (frmMainForm.ActiveControl is TcxButtonEdit)) and
//    (not (frmMainForm.ActiveControl is TSpTBXSpinEdit)) and
////07.10.2020    (not (frmMainForm.ActiveControl is TbfaSearchTextEdit)) and
//    (not (frmMainForm.ActiveControl is TcxCustomInnerTextEdit)) and
//    (not ViewChanging);
//end;

function TbfaApplication.GetIndexTableID(fieldname: WideString): WideString;
var
  i: Integer;
begin
  result := fieldname;

  for i := Low(aAddfields) to High(aAddfields) do
  begin
    if aAddfields[i] = nil then
      Continue;

    if aAddfields[i].name = fieldname then
    begin
      result := fieldname + ':' + IntToStr(aAddfields[i].IndexTableID);
      Break;
    end;
  end;
end;

function TbfaApplication.GetInNewTab(prev: TbfaPreview; Ctrl: Boolean = False): Boolean;
begin
  try
    if Ctrl and (prev <> nil) then
    begin
      Result := True;
      Exit;
    end;

    if prev <> nil then
    begin
      if prev = FPreviewContainer.ImporterItem.Preview then
        result := not FViewerOptions.EditorOptions.ImporterOpenDocInImporter
//      else if prev = FPreviewContainer.WorkplaceItem.Preview then
//        result := (not FViewerOptions.EditorOptions.WorkplaceOpenDocInWorkplace) and not FViewerOptions.EditorOptions.WorkplaceAutoEditMode
      else if (prev = FPreviewContainer.WorkplaceItem.Preview) then
        result := (not FViewerOptions.EditorOptions.WorkplaceOpenDocInWorkplace)
      else
        result := True;
    end
    else
      result := True;
  except
    result := False;
  end;
end;

function TbfaApplication.GetInUnDockedTab(prev: TbfaPreview): Boolean;
begin
  try
    if prev <> nil then
    begin
      if prev = FPreviewContainer.ImporterItem.Preview then
        result := FViewerOptions.EditorOptions.ImporterInUnDockedPanel
      else if prev = FPreviewContainer.WorkplaceItem.Preview then
//23.08.2017 Ticket 11023        Result := not FViewerOptions.EditorOptions.WorkplaceInUnDockedPanel
        result := FViewerOptions.EditorOptions.WorkplaceInUnDockedPanel
      else
        result := FViewerOptions.EditorOptions.InUnDockedPanel;
    end
    else
      result := FViewerOptions.EditorOptions.InUnDockedPanel;
  except
    result := True;
  end;
end;

procedure TbfaApplication.SetFtxIcon(prev: TbfaPreview; ImageIndex: Integer; HintText: WideString; Enable: Boolean = True);
begin
  bitfarmLog.DebugBegin(llDebug, 'SetFtxIcon', Classname);
  try
    try
//      if prev <> nil then
//      begin
//        frmMainForm.actFtxPos.ImageIndex := ImageIndex;
//        prev.actFtxPos.Enabled := Enable;
//        prev.actFtxPos.Hint := HintText;
//      end;

      frmMainForm.actFtxPos.ImageIndex := ImageIndex;
      frmMainForm.actFtxPos.Enabled := Enable;
      frmMainForm.actFtxPos.Hint := HintText;
    except
      bitfarmLog.Write(llNormal, ltException, 'SetFtxIcon', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetFtxIcon', Classname);
  end;
end;

procedure TbfaApplication.CopyDocToClipboard(AThread: TThread; Data: PUserAction);
var
  i, Layer: Integer;
  sTargetFilename, Str: WideString;
  Lst: TList<TbfaDocument>;
  MStream: TMemoryStream;
  hist : TbfaHistory;
begin
  bitfarmLog.DebugBegin(llDebug, 'CopyDocToClipboard', Classname);
  try
    try
      Str := '';
      Lst := TList<TbfaDocument>.Create;

      try
        for i := 0 to Data^.Documents.Count - 1 do
        begin
          hist := TbfaHistory.Create;
          hist.Userid := bitfarmApp.User.ID;
          hist.Gdocid := TbfaDocument(Data^.Documents[i]).ID;
          hist.Date := Now();

          if (Data^.params[0] = '1') then
          begin
            sTargetFilename := SetFileName(Data, i, sftORI, BD.EnvTempPd, nil);
            Lst.Clear;
            Lst.Add(TbfaDocument(Data^.Documents[i]));
//14.06.2023
//            MStream.Clear;
//            MStream.Position := 0;
//            MStream := GetOriStream(TbfaDocument(Data^.Documents[i]), AThread);
            GetOriStream(TbfaDocument(Data^.Documents[i]), AThread, BD.EnvTempPd + sTargetFilename);

            hist.Taskid := 245;
          end
          else
          begin
            try
              try
                MStream := TMemoryStream.Create;
            sTargetFilename := SetFileName(Data, i, sftTIF, BD.EnvTempPd, nil);
            Lst.Clear;
            Lst.Add(TbfaDocument(Data^.Documents[i]));
            MStream.Clear;
            MStream.Position := 0;
            if (Data^.params[2] = '1') then
              Layer := user.ID
            else
              Layer := 0;

            MStream := bfaImageRendering(AThread, Lst, (Data^.params[1] = '1'), //16.11.2017 wegen Ticket 12517
              (Data^.params[2] = '1'), (Data^.params[3] = '1'), Layer);
            hist.Taskid := 244;

                if (MStream <> nil) then
          begin
            MStream.Position := 0;
            MStream.SaveToFile(BD.EnvTempPd + sTargetFilename);
          end;
              except
                bitfarmLog.Write(llNormal, ltException, 'CopyDocToClipboard - MStream', ClassName);
              end;
            finally
              FreeAndNil(MStream);
            end;
          end;

          if Str <> '' then
            Str := Str + #0;
          Str := Str + BD.EnvTempPd + sTargetFilename;

          bitfarmApp.WriteHistory(nil, hist);
        end;
        bfaCommonFiles.CopyFilesToClipboard(Str);

        if (Data^.params[0] = '1') then
          frmMainForm.SetNotificationBar(_('Originaldokument ist in Zwischenablage kopiert.'), AThread)
        else
          frmMainForm.SetNotificationBar(_('Dokument ist in Zwischenablage kopiert.'), AThread);

      finally
        FreeAndNil(Lst);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'CopyDocToClipboard', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CopyDocToClipboard', Classname);
  end;
end;

procedure TbfaApplication.CreateCopyToClipboardAction(Original, Stationery, Priv, Pub: Boolean; prev: TbfaPreview);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateCopyToClipboardAction', Classname);
  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actCopyDocToClipboard';
      UserAction^.Preview := prev;

      bitfarmApp.CloneCurrentDocs(UserAction, False);

      if Original then
      begin
        UserAction^.params.Add('1');
        if not prev.Floating then
        begin
//14.10.2019          frmMainForm.MainMenu.mnuCopyToClipboard.ImageIndex := frmMainForm.actCopyOriginalDocToClipboard.ImageIndex;
//          frmMainForm.MainMenu.mnuCopyToClipboard.Action := frmMainForm.actCopyOriginalDocToClipboard;
//          frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItem4.Action := frmMainForm.actCopyOriginalDocToClipboard;
          frmMainForm.mnuCopyToClipboard.ImageIndex := prev.actCopyOriginalDocToClipboard.ImageIndex;
          frmMainForm.mnuCopyToClipboard.Action := prev.actCopyOriginalDocToClipboard;
          frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action := prev.actCopyOriginalDocToClipboard;
        end;
//14.10.2019        prev.bfaTlbStandard.tlbStandardSubmenuItem4.Action := frmMainForm.actCopyOriginalDocToClipboard;
        prev.bfaTlbStandard.tlbStandardSubmenuItemClipboard.Action := prev.actCopyOriginalDocToClipboard;

        frmMainForm.actCopyDocToClipboard.Tag := 0;
        frmMainForm.actCopyOriginalDocToClipboard.Tag := 1;
        frmMainForm.actCopyPageToClipboard.Tag := 0;
        frmMainForm.actCopyDocLinkToClipboard.Tag := 0;
      end
      else
      begin
        UserAction^.params.Add('0');
        if not prev.Floating then
        begin
//20.09.2019
//          frmMainForm.MainMenu.mnuCopyToClipboard.ImageIndex := frmMainForm.actCopyDocToClipboard.ImageIndex;
//          frmMainForm.MainMenu.mnuCopyToClipboard.Action := frmMainForm.actCopyDocToClipboard;
//          frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItem4.Action := frmMainForm.actCopyDocToClipboard;
          frmMainForm.mnuCopyToClipboard.ImageIndex := prev.actCopyDocToClipboard.ImageIndex;
          frmMainForm.mnuCopyToClipboard.Action := prev.actCopyDocToClipboard;
          frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action := prev.actCopyDocToClipboard;
        end;
//20.09.2019        prev.bfaTlbStandard.tlbStandardSubmenuItem4.Action := frmMainForm.actCopyDocToClipboard;
        prev.bfaTlbStandard.tlbStandardSubmenuItemClipboard.Action := prev.actCopyDocToClipboard;

        frmMainForm.actCopyDocToClipboard.Tag := 1;
        frmMainForm.actCopyOriginalDocToClipboard.Tag := 0;
        frmMainForm.actCopyPageToClipboard.Tag := 0;
        frmMainForm.actCopyDocLinkToClipboard.Tag := 0;
      end;

      if Stationery then
        UserAction^.params.Add('1')
      else
        UserAction^.params.Add('0');
      if Priv then
        UserAction^.params.Add('1')
      else
        UserAction^.params.Add('0');
      if Pub then
        UserAction^.params.Add('1')
      else
        UserAction^.params.Add('0');

      FBackThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'CreateCopyToClipboardAction', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateCopyToClipboardAction', Classname);
  end;
end;

// Ticket 13547 Verschieben von Outlook anhngen direkt zum Viewer (Erweiterung)
procedure TbfaApplication.CreateLoadAction(Eff: Integer; Target: TDropComboTarget);
var
  i, numFiles: Integer;
  UserAction: PUserAction;
  s, Name, TempDragDropDir, TempFile: string;
  Stream: TStream;
  FileObj: TbfaFileObj; //02.03.2021 wegen Dateigre
  buffer: Array [0..MAX_PATH] of Char;
begin
  try
    // Fall Target.Files.Count = 0 fhrt zu einer Exception
    if (Target <> nil) and (Target.Files.Count = 0) and (Target.Data.Count = 0) then
      Exit;

    UserAction := CreateUserAction;
    UserAction^.ActionName := 'actLoadFile';

    if (Target <> nil) and (Target.Files.Count > 0) then // wie gehabt
    begin
      for i := 0 to Target.Files.Count - 1 do
      begin
//10.03.2021        UserAction^.params.Add(Target.Files[i]);
        FileObj := TbfaFileObj.Create;
        FileObj.FileName := Target.Files[i];
        FileObj.FileSize := round(FileSize(Target.Files[i]) / 1024);
        UserAction^.Params.AddObject(IntToStr(i), FileObj);
      end;
      UserAction^.options := Eff;
    end
    else if (Target <> nil) and (Target.Data.Count > 0) then  // else if, wegen Rckwrtskompatibilitt
    begin
     // Verzeichnis [temp]\bfa_dd wird immer gelscht, wenn der Viewer beendet wird.
      TempDragDropDir := BD.EnvTempPd + 'bfa_dd\' + FormatDateTime('yyyymmddnnsszzz', now);
      if not DirectoryExists(TempDragDropDir) then
        ForceDirectories(TempDragDropDir);
      for i := 0 to Target.Data.Count - 1 do
      begin
        Name := Target.Data.Names[i];
        if (Name <> '') then
        begin
          TempFile := TempDragDropDir + '\' + Name;
          Stream := TFileStream.Create(TempFile, fmCreate);
          try
            // Copy dropped data to stream (in this case a file stream).
            Stream.CopyFrom(Target.Data[i], Target.Data[i].Size);
            //10.03.2021 -->
            FileObj := TbfaFileObj.Create;
            FileObj.FileName := TempFile;
            FileObj.FileSize := round(Stream.Size / 1024);
            UserAction^.Params.AddObject(IntToStr(i), FileObj);
            //10.03.2021 -->
          finally
            Stream.Free;
          end;
//10.03.2021          UserAction^.params.Add(TempFile);
          UserAction^.options := DROPEFFECT_MOVE;  // da wir eine temporre Datei erstellen
        end;
      end;
    end
    // Target nil = wir nehmen Dokumente aus der Zwischenablage - siehe FormKeyDown
    // https://delphidabbler.github.io/delphi-tips/tips/161.html
    else if (Target = nil) and Clipboard.HasFormat(CF_HDROP) then
    begin
      try
        Clipboard.Open;

        var hndl: THandle;
        hndl := Clipboard.GetAsHandle(CF_HDROP);
        if hndl <> 0 then
        begin
          numFiles := DragQueryFile(hndl, $FFFFFFFF, nil, 0);
          for i := 0 to numfiles - 1 do
          begin
            buffer[0] := #0;
            DragQueryFile(hndl, i, buffer, sizeof(buffer));
            FileObj := TbfaFileObj.Create;
            FileObj.FileName := buffer;
            FileObj.FileSize := Round(FileSize(FileObj.FileName) / 1024);
            UserAction^.Params.AddObject(IntToStr(i), FileObj);
          end;
          UserAction^.Options := Eff;
        end;
      finally
        Clipboard.Close;
      end;
    end;
    FMainThread.Add(UserAction);
  except

  end;
end;

procedure TbfaApplication.SendDocsToImporter(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'SendDocsToImporter', Classname);
  try
    try
      bitfarmApp.SendDocumentsTo(bitfarmApp.PreviewContainer.ImporterItem.Preview, False, False, True, AThread);
    except
      bitfarmLog.Write(llNormal, ltException, 'SendDocsToImporter', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SendDocsToImporter', Classname);
  end;
end;

procedure TbfaApplication.SendDocsToWorkplace(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'SendDocsToWorkplace', Classname);
  try
    try
      bitfarmApp.SendDocumentsTo(bitfarmApp.PreviewContainer.WorkplaceItem.Preview, False, False, True, AThread);
    except
      bitfarmLog.Write(llNormal, ltException, 'SendDocsToWorkplace', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SendDocsToWorkplace', Classname);
  end;
end;


procedure TbfaApplication.SendDocumentsTo(prev: TbfaPreview; WithDraggedDocs: Boolean = False;
//14.11.2023  Copy: Boolean = False; LoadOriginalDoc: Boolean = False);
  Copy: Boolean = False; LoadOriginalDoc: Boolean = False; AThread: TThread = nil);
var
  j, i: Integer;
  DoRefresh, CloneDocs, MergeStat: Boolean;
  UserAction: PUserAction;
  Doc: TbfaDocument;
  Lst, LstDoc, SubLst: TList<TbfaDocument>;
begin
  bitfarmLog.DebugBegin(llDebug, 'SendDocumentsTo', Classname);
  AThread.Synchronize(nil,
    procedure
    begin
      Screen.Cursor := crHourGlass;
    end);
  try
    try
      DoRefresh := False;
      CloneDocs := False;
      if WithDraggedDocs then
      begin
        if (FDragObject <> nil) and (FDragObject.DragKind = dkDocuments) then
        begin
          Lst := FDragObject.DocumentList;
        end
        else
          Exit;
      end
      else if Copy then
      begin
        Lst := bitfarmApp.CurrentContainer;
        CloneDocs := False;
      end
      else
      begin
        Lst := bitfarmApp.CurrentContainer;
        CloneDocs := True;
      end;

      MergeStat := False;
      if frmMainForm.bfaTlbPreview1.mnuStationery.Checked then
      begin
        MergeStat := (BfMessageDlg(_('Briefpapier ist eingeschaltet. Mchten Sie das Briefpapier beibehalten?'),
          mtInformation, [mbYes, mbNo]) = mrYes);
      end;

      for j := 0 to Lst.Count - 1 do
      begin
        if (Lst[j].Id <> -1) or (prev = bitfarmApp.PreviewContainer.ImporterItem.Preview) then
        begin
          Doc := TbfaDocument.Create;
//15.11.2023          Doc.Clone(Lst[j], False, False, False, False, True); in Version 37 nochmal berlegen
          Doc.Clone(Lst[j], False, False, False, False, True, True, (prev <> bitfarmApp.PreviewContainer.ImporterItem.Preview));
          if (Lst[j].Id <> -1) and (not Lst[j].Loaded) then
          begin
            if (not bitfarmApp.OfflineMode) then
              bitfarmApp.LoadDocumentViaSocket(Doc, 'base;fields;paths;iev', AThread)
            //10.02.2023 bfacrm:ticket__show__33894 -->
            else
              DBLoadDocument(Doc);
            //10.02.2023 bfacrm:ticket__show__33894 <--
          end;
          if (Copy or CloneDocs or MergeStat or (prev = bitfarmApp.PreviewContainer.ImporterItem.Preview)) then
          begin
            if (Copy) or
              ((prev = bitfarmApp.PreviewContainer.ImporterItem.Preview) or
              (prev = bitfarmApp.PreviewContainer.WorkplaceItem.Preview)) then
            begin
              if (Lst[j] <> nil) and
                 (Lst[j].ScanPoolView <> nil) and (Lst[j].ScanPoolViewLoaded)
                 and (Lst[j].ScanPoolViewchanged) then
              begin
                if Doc.DocStream.Size > 0 then
                  Doc.DocStream.Clear;
                Doc.DocStream.Position := 0;
                Lst[j].ScanPoolView.MIO.SaveToStreamTIFF(Doc.DocStream);
                Doc.HasPreview := True;
              end else
              begin
                if Doc.DocStream.Size = 0 then
                begin
                  Lst[j].DocStream.Position := 0;
                  Doc.DocStream.CopyFrom(Lst[j].DocStream, Lst[j].DocStream.Size);
                  Doc.HasPreview := True;
                end;
              end;

              if LoadOriginalDoc and (Doc.OriLoc <> '') (*13.11.2023 and (Doc.OriStream <> nil)*) then
              begin
//14.06.2023                Doc.OriStream := bitfarmApp.GetOriStream(Doc);
                bitfarmApp.GetOriStream(Doc, AThread, '');
                Doc.DocType := dtFile;
                Doc.FileType := ExtractFileExt(Doc.OriLoc);
              end else
              begin     // wir haben kein Original, weil wir zB Voransicht an den Importer senden
                Doc.FileType := ExtractFileExt(Doc.DocLoc);
                if Copy then // SJ 07.10.2022 - dann mssen wir aber auch OriLoc leer setzen
                  Doc.OriLoc := '';
              end;

              if ((Lst[j].ID = -1) or (((Lst[j].Rights and rightARead) = rightARead) or
                    ((Lst[j].Rights and rightAWrite) = rightAWrite) or
                    ((Lst[j].Rights and rightAModify) = rightAModify)))
              then begin
                CopyAnno(Lst[j], Doc, nil);
              end;
            end else
             Doc.Clone(Lst[j]);

            if MergeStat then
            begin
              LstDoc := Tlist<TbfaDocument>.Create;
              try
                LstDoc.Add(Lst[j]);
                Doc.DocStream.Clear;
                Doc.DocStream := bfaImageRendering(AThread, LstDoc, True, False, False);
              finally
                FreeAndNil(LstDoc);
              end;
            end;
          end
          else
            Doc := Lst[j];

          //09.08.2024 SD -->bfacrm:ticket__show__39400
          if (not GetActivePreview.bfaTlbPreview.mnuPublicAnno.Checked) and (prev = bitfarmApp.PreviewContainer.ImporterItem.Preview) then
          begin
            for i := 0 to Doc.Annotations.Count-1 do
            begin
              Doc.Annotations[i].Free;
              Doc.Annotations[i] := nil;
            end;
            Doc.Annotations.Clear;
          end;
          //09.08.2024 SD <--bfacrm:ticket__show__39400

          if (CloneDocs and (prev <> FPreviewContainer.WorkplaceItem.Preview))
              or MergeStat or Copy
              or (prev = bitfarmApp.PreviewContainer.ImporterItem.Preview) then
          begin
            Doc.ID := -1;
            Doc.SymbolicArcID := -1;
            Doc.ArcID := -1;
          end;
          if (Doc.ID = -1) and (Doc.EditmodeUserID = 0) and Doc.InEditMode then
            Doc.EditmodeUserID := bitfarmApp.User.ID;
          Doc.ScanPoolViewLoaded := False;
          Doc.ScanPoolViewchanged := False;
          prev.List.Add(Doc);

          //31.05.2022 Ticket 31118 -->
          if (prev = bitfarmApp.PreviewContainer.ImporterItem.Preview) or
             (prev = bitfarmApp.PreviewContainer.WorkplaceItem.Preview) then
          begin
            SubLst := TList<TbfaDocument>.Create;
            try
              SubLst.Add(Doc);
              if (prev = bitfarmApp.PreviewContainer.ImporterItem.Preview) then
                bitfarmApp.SaveDocumentsToXML(SubLst, BD.EnvAppdataImporterPd,
                  FImportContainer.Count - 1, True, AThread)
              else if (prev = bitfarmApp.PreviewContainer.WorkplaceItem.Preview) then
                bitfarmApp.SaveDocumentsToXML(SubLst, BD.EnvAppdataWorkplacePd,
                  FWorkplaceContainer.Count - 1, True, AThread);
            finally
              FreeAndNil(SubLst);
            end;
          end;
          //31.05.2022 Ticket 31118 <--
          DoRefresh := True;
        end;
      end;

      if DoRefresh then
      begin
        UserAction := bitfarmApp.CreateUserAction;
        if prev = bitfarmApp.PreviewContainer.WorkplaceItem.Preview then
        begin
          UserAction^.ActionName := 'actRefreshWorkplaceMultiview';
          UserAction^.params.Add('1');
        end
        else if prev = bitfarmApp.PreviewContainer.ImporterItem.Preview then
        begin
          UserAction^.ActionName := 'actRefreshImporterMultiview';
          UserAction^.params.Add('1');
        end;
        bitfarmApp.MainThread.Add(UserAction);
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'SendDocumentsTo', ClassName);
    end;
  finally
    AThread.Synchronize(nil,
      procedure
      begin
        Screen.Cursor := crDefault;
      end);
    bitfarmLog.DebugEnd(llDebug, 'SendDocumentsTo', Classname);
  end;
end;

procedure TbfaApplication.CreateRefreshPageInThumbnailsAction(Doc: TbfaDocument; ActPrev: TbfaPreview; Page: Integer; Bmp: TBitmap);
var
  UserAction: PUserAction;
  BmpClone: TBitmap;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateRefreshPageInThumbnailsAction', Classname);
  try
    try
      UserAction := CreateUserAction;
      UserAction^.ActionName := 'actRefreshPageInThumbnails';

      UserAction^.Documents.Add(Doc);
      UserAction^.objects.Add(ActPrev);
      BmpClone := TBitmap.Create;
      BmpClone.Assign(Bmp);
      UserAction^.objects.Add(BmpClone);
      UserAction^.params.Add(IntToStr(Page));

      FMainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'CreateRefreshPageInThumbnailsAction', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateRefreshPageInThumbnailsAction', Classname);
  end;
end;

procedure TbfaApplication.CreateRefreshDocumentInPreviewsAction(Doc: TbfaDocument; ActPrev1, ActPrev2: TbfaPreview; OnlyObjects: Boolean = False; SetInProcess: Boolean = False; ReloadThumbnails: Boolean = False);
var
  i: integer;
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateRefreshDocumentInPreviewsAction', Classname);
  try
    try
      UserAction := CreateUserAction;
      UserAction^.ActionName := 'actRefreshDocumentInPreviews';

      UserAction^.Documents.Add(Doc);
      UserAction^.objects.Add(ActPrev1);
      UserAction^.objects.Add(ActPrev2);
      if OnlyObjects then
        UserAction^.params.Add('1')
      else
        UserAction^.params.Add('0');

      if SetInProcess then
        UserAction^.params.Add('1')
      else
        UserAction^.params.Add('0');

      if ReloadThumbnails then
        UserAction^.params.Add('1')
      else
        UserAction^.params.Add('0');

      FMainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'CreateRefreshDocumentInPreviewsAction', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateRefreshDocumentInPreviewsAction', Classname);
  end;
end;

procedure TbfaApplication.LoadStationerytoDocument(Doc: TbfaDocument; StatName: WideString);
var
  i: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'LoadStationerytoDocument', Classname);
  try
    try
      for i := 0 to High(aStationeries) do
      begin
//        if ((aStationeries[i].name = StatName) and (StatName <> '')) or (aStationeries[i].arcid = Doc.ArcID) then
//        if ((aStationeries[i].name = StatName) and (StatName <> '')) and (aStationeries[i].arcid = Doc.ArcID) then
//        if ((aStationeries[i].name = LowerCase(StatName)) and (StatName <> '')) and (aStationeries[i].Arcids.Contains(Doc.ArcID)) then
        if (LowerCase(aStationeries[i].name) = LowerCase(StatName)) then
        begin
          aStationeries[i].Stream.Position := 0;
          Doc.LetterStream.Clear;
          Doc.LetterStream.CopyFrom(aStationeries[i].Stream, aStationeries[i].Stream.Size);
          Break;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'LoadStationerytoDocument', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'LoadStationerytoDocument', Classname);
  end;
end;

function TbfaApplication.LoadUser: Boolean;
var
  qry: TUniQuery;
begin
  qry := TUniQuery.Create(nil);
  try
    qry.Connection := dmMain.cntMain;
    qry.SQL.Text := 'select userid, username, userpass, usermail, flags +0, displayname from sys_user where userid = ' + IntToStr(FUser.ID) + ' and FIND_IN_SET(' + #39 + 'enabled' + #39 + ',flags) > 0';

    qry.Execute;

    if qry.RecordCount > 0 then
    begin
      qry.First;
      FUser.ID := qry.FieldByName(sColUserID).AsLargeInt;
      FUser.Name := qry.FieldByName(sColUserName).AsWideString;
      FUser.DisplayName := qry.FieldByName('displayname').AsWideString;
      FUser.Flags := qry.FieldByName('flags +0').AsInteger;
      FUser.Password := qry.FieldByName('userpass').AsWideString;
      FUser.Email := qry.FieldByName('usermail').AsWideString;
      FUser.Flags := qry.FieldByName('flags +0').AsInteger;
      FUser.isAdmin := (qry.FieldByName('flags +0').AsInteger and 8) = 8;
      FUser.DMSAdmin := (qry.FieldByName('flags +0').AsInteger and 128) = 128;
      FUser.GroupList.Clear;
      FUser.SuAnnoList.Clear;
      FUser.EmployeesList.Clear;
      result := True;

      qry.SQL.Text := 'select * from sys_groupuser where userid = ' + IntToStr(FUser.ID);
      qry.Execute;
      if qry.RecordCount > 0 then
      begin
        qry.First;
        while not qry.Eof do
        begin
          FUser.GroupList.Add(qry.FieldByName('groupid').AsString);
          qry.Next;
        end;
      end
      else
        FUser.GroupList.Add('0');   // User ist per default Mitglied von Gruppe Alle

      FUser.HolidayList.CommaText := IntToStr(FUser.ID);

    end
    else
    begin
      result := False;
      BfShowMessage(_('Benutzer in der Datenbank nicht vorhanden'));
      FLog.Write(llNormal, ltError, _('Benutzer in der Datenbank nicht vorhanden'), ClassName);
    end;
  finally
    FreeAndNil(qry);
  end;
end;

//13.06.2023function TbfaApplication.GetOriStream(SrcDoc: TbfaDocument; AThread: TThread = nil): TMemoryStream;
function TbfaApplication.GetOriStream(SrcDoc: TbfaDocument; AThread: TThread = nil; FileName: string = ''): Boolean;
var
  req: TbfaRequest;
  sock: TSocketConnection;
  Doc: TbfaDocument;
begin
  Result := True;
  if OfflineMode then
  begin
    if SrcDoc.OriLoc <> '' then
    begin
//14.06.2023
//      try
//        Result := TMemoryStream.Create;
//        Result.LoadFromFile(SrcDoc.OriLoc);
//      except
//        BfShowMessage(_('Die Originaldatei konnte nicht geladen werden.'), AThread);
//        Result := nil;
//      end;
    end;
  end
  else
  begin
    sock := TSocketConnection.Create(bfaServerNoSSL, bfaServer, bfaServerPort, '');
    Doc := TbfaDocument.Create;
    req := TbfaRequest.Create;
    try
      sock.CreateComponents;
      if sock.Connect then
      begin
        req.ReqType := 'reqOri';
        req.UserID := user.ID;
        req.Profile := Self.Profile;
        req.Gdocid := SrcDoc.ID;
        req.Parameter := 'base;paths';
        req.Lang := Lang;
        sock.SendRequestToServer(req);

//13.06.2023        req := sock.ReceiveData(Doc, nil);
        req := sock.ReceiveData(Doc, AThread, True, True);
//13.06.2023        sock.Disconnect;
        if req = nil then
          Exit;

        if (req.ReqType = 'respDoc') or (req.ReqType = 'respOK') then
        begin
//13.06.2023
//          Doc.DocStream.Position := 0;
//          Result := TMemoryStream.Create;
//          Result.CopyFrom(Doc.DocStream, Doc.DocStream.Size);
            try
              if SrcDoc.OriStream <> nil then
                SrcDoc.OriStream.Free;

              if FileName = '' then
              begin
                FileName := BD.EnvTempPd + 'bfa_dd\' + FormatDateTime('yyyymmddnnsszzz', now);
                if SrcDoc.DocName <> '' then
                  FileName := FileName + '_' + SrcDoc.DocName
                else
                  FileName := FileName + '_Document';
                if SrcDoc.FileType <> '' then
                  FileName := FileName + SrcDoc.FileType
                else
                  FileName := FileName + '.ori';

                SrcDoc.OriLoc := FileName; //14.11.2023
              end;

              sock.ReceiveStream(SrcDoc, FileName, req.DataLen, AThread, frmMainForm.frmSplash);
              if frmMainForm.frmSplash.Canceled then
              begin
                Result := False;
                Exit;
              end;
            except
              on e: exception do
              begin
                Log.Write(llNormal, ltException, _('Originaldatei konnte nicht gespeichert werden') + #13#10 + e.Message, ClassName);
                BfShowMessage(_('Originaldatei konnte nicht gespeichert werden\n(Die Datei ist ggf. noch geffnet)'), AThread);
                Result := False;
                Exit;
              end;
            end;
        end
        else if not FSendingEmail then   //soll eine Email versendet werden brauchen wir keine Fehlermeldung
        begin                            // in Localsave wird stattdessen die Voransicht geholt
          BfShowMessage(_('Die Originaldatei konnte nicht geladen werden.') + #13#10 + req.DataString, AThread);
          Result := False;
        end;
      end;
    finally
      sock.Disconnect;
      FreeAndNil(req);
      FreeAndNil(sock);
      FreeAndNil(Doc);
    end;
  end;
end;

function TbfaApplication.RunPlugin(AThread: TThread; liprefix: Integer; lspname, listname: string; tlsljob: TStringList; slZMetaField: TStringList = nil; slZMetaName: TStringList = nil; slZMetaFieldValues: TStringList = nil; slZMetaFieldType: TStringList = nil): integer;
begin
 // Nur im Enterprise Version
end;

procedure TbfaApplication.GetAllFilesInDir(Dir: string; Lst: TStringList;
  DoSubDir: Boolean = False);
var
  SR: TSearchRec;
begin
  Log.DebugBegin(llDebug, 'GetAllFilesInDir', ClassName);
  try
    try
      bitfarmLog.Write(llNormal, ltInfo, 'IncludeTrailingBackslash(Dir) = ' + IncludeTrailingBackslash(Dir), ClassName);

      if FindFirst(IncludeTrailingBackslash(Dir) + '*.*', faAnyFile or faDirectory, SR) = 0 then
      begin
        try
          if Dir[Length(Dir)] <> '\' then
            Dir := Dir + '\';
          repeat
            if (SR.Attr and faDirectory) = 0 then
              Lst.Add(Dir + SR.Name)
            else if (SR.Name <> '.') and (SR.Name <> '..') and DoSubDir then
              GetAllFilesInDir(IncludeTrailingBackslash(Dir) + SR.Name, Lst, DoSubDir);
          until FindNext(SR) <> 0;
        finally
          FindClose(SR);
        end;
      end;
    except
      Log.Write(llNormal, ltException, 'GetAllFilesInDir', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'GetAllFilesInDir', ClassName);
  end;
end;

procedure TbfaApplication.PrepareForSearchLinks(ATHread: TThread; sText: string);
begin
  ATHread.Synchronize(nil,
    procedure
    begin
      frmMainForm.tbiSoLinks.Click;
//      frmMainForm.tabSearchStandard.Click; // SJ 16.06.2023 - bfacrm:ticket__show__35288
      frmMainForm.cbxSearchLinks.compComboBox.Text := sText;
    end);
end;

procedure TbfaApplication.Handbooks(AThread: TThread);
var
  URL: pWideChar;
begin
  AThread.Synchronize(AThread,
    procedure
    begin
      if bitfarmApp.Lang = 'de' then
        {$IFDEF ENTERPRISE}
        URL := 'https://www.bitfarm-archiv.de/downloads-support/dokumentationen-informationen.html'
        {$ELSE}
        URL := 'https://www.bitfarm-archiv.de/downloads-support/dokumentationen-viewer-gpl.html'
        {$ENDIF}
      else
        {$IFDEF ENTERPRISE}
        URL := 'https://www.bitfarm-archiv.com/downloads-support/documentations-viewer.html';
        {$ELSE}
        URL := 'https://www.bitfarm-archiv.com/downloads-support/documentation-viewer-gpl.html';
        {$ENDIF}
      ShellExecute(Application.Handle, nil, URL, nil, nil, sw_shownormal);
    end);
end;

procedure TbfaApplication.HandleParam(ATHread: TThread; Params: TStringList);
var
  sPStr: string;
  iLgrID, iArcID, iLgr, iArc, iSlw, iVtx, iRef, iTmpArcID, iTmpDocID, licount,
  liinterchange, liwvl, liclose, ligdoc, ligdocid, ligsearchzusfield, Value,
  Code, litmp, liwvlrecno, iTimeout, idx, iCode, iValue, iSObj, iGSobj, i, j: integer;
  lmystrl: TStringList;
  qry: TUniQuery;
  selcols, fcmdzusfieldsearch, fcmdzusvaluesearch, FileName, DirName,
  lsTmp, lsParamUp, ErrorStr, SObjPath, GSobjName, paramID, arcids, Param: string;
  aField: TbfaAddField;
  slZMetaField, slZMetaName, slZMetaFieldValues, slZMetaFieldType, filenames: TStringList;
  UserAction: PUserAction;
  Folders: TStringDynArray;
  Node: TTreeNode;
  Objects: TList;
  found, error, DoSubDir, globalsearchcontext, subDir: Boolean;
  XMLDoc: IXMLDocument;
  RootNode, FavNode: IXMLNode;
  Sobj, GSobj : TbfaSearch;

  procedure PrepareForSearchLinksAction(const Param: string);
  var
    UserAction: PUserAction;
  begin
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actPrepareForSearchLinks';
      UserAction^.Params.Add(Param);
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'PrepareForSearchLinksAction', ClassName);
    end;
  end;

  function SearchNodeByName(const node: TTreeNode; name: WideString): TbfaSearch;
  var
    i: Integer;
  begin
    name := LowerCase(name);
    Result := nil;
    for i := 0 to node.Count -1 do
    begin
      if node[i].HasChildren then
      begin
        Result := SearchNodeByName(node[i], name);
        if Result <> nil then
          break;
      end else
      if node[i].Data <> nil then
      begin
        if TObject(node[i].Data) is TbfaSearch then
        begin
          if LowerCase(TbfaSearch(node[i].Data).Name) = name then
          begin
            Result := TbfaSearch.Create;
            Result.Clone(TbfaSearch(node[i].Data));
            Break;
          end;
        end;
      end;
    end;
  end;

begin
  if handleparamaktiv then
    Exit;

  fSkipAutoDisplay := True;
  handleparamaktiv := True;
  try
    for i := 0 to Params.Count -1 do
    begin
      Param := Params[i];
      bitfarmLog.Write(llNormal, ltInfo, 'HandleParam Begin mit Param = "' + Param + '"', ClassName);
      // haben wir einen globale Suche? dann wird jedes Lesezeichen oder gdocid Aufruf in diesem Kontext ausgefhrt
      globalsearchcontext := globalsearchcontext or (Pos('-gs:', LowerCase(Param)) > 0);
    end;

    sPStr := '';
    GSobj := nil;
    liinterchange := 0;

    LeaveCurrentDocs(ATHread);

    if Params.IndexOf('-c:') <> -1 then
    begin
      frmMainForm.tmrCloseForm.Enabled := True;
      Exit;
    end;

    //05.07.2024 SD/BD -->bfacrm:ticket__show__38036
    var IsRefSearch: Boolean;
    IsRefSearch := False;
    //05.07.2024 SD/BD <--bfacrm:ticket__show__38036

    for i := 0 to Params.Count -1 do
    begin
      Param := Params[i];

      iLgr := pos('-l:', LowerCase(Param));
      iArc := pos('-a:', LowerCase(Param));
      iLgrID := pos('-lid:', LowerCase(Param));
      iArcID := pos('-aid:', LowerCase(Param));
      iSlw := pos('-s:', LowerCase(Param));
      iVtx := pos('-v:', LowerCase(Param));
      iRef := pos('-r:', LowerCase(Param));
      iSObj := pos('-so:', LowerCase(Param));
      iGSObj := pos('-gs:', LowerCase(Param));
      liinterchange := pos('-i:', LowerCase(Param));
      ligdoc := pos('-g:', LowerCase(Param));
      ligsearchzusfield := pos('-zus:', LowerCase(Param));

//      if pos('-c:', LowerCase(Param)) = 1 then
//      begin                      ping
//        frmMainForm.tmrCloseForm.Enabled := True;
//        Break;
//      end;

      if (ligdoc > 0) or (LowerCase(Copy(Param, 1, 7)) = 'gdocid:') or (LowerCase(Copy(Param, 1, 6)) = 'docid:') then
      begin
        if ligdoc = 0 then
        begin
          if (LowerCase(Copy(Param, 1, 7)) = 'gdocid:') then
            sPStr := Copy(Param, 8, Length(Param))
          else if (LowerCase(Copy(Param, 1, 6)) = 'docid:') then
          begin
            paramID := Copy(Param, 7, Length(Param));
            idx := pos('.', paramID);
            if idx > 0 then
              sPStr := Copy(paramID, idx + 1, Length(paramID))
            else
              sPStr := Copy(Param, 7, Length(Param));
          end;
        end
        else
          sPStr := Copy(Param, 4, Length(Param));

        if sPStr <> '' then
        begin
          if TryStrToInt(sPStr, ligdocid) then
          begin
            if not globalsearchcontext then
            begin
              qry := TUniQuery.Create(nil);
              try
                qry.Connection := dmMain.cntMain;
                qry.SQL.Text := 'select arcid from sys_doc where gdocid = ' + IntToStr(ligdocid) + ';';
                qry.Open;
                if qry.RecordCount > 0 then
                begin
                  qry.First;
                  DocumentSearch(qry.FieldByName('arcid').AsInteger, ligdocid, ATHread);
                end;
                qry.Close;
              finally
                FreeAndNil(qry);
              end;
            end;
          end;
        end;
      end;

      if pos('-m:', LowerCase(Param)) = 1 then
        SetViewAndArchive(AThread, tvkImporter);

      if (pos('-f:', LowerCase(Param)) = 1) or (pos('-fd:', LowerCase(Param)) = 1) then
      begin
        SetViewAndArchive(AThread, tvkImporter);

        if (pos('-fd:', LowerCase(Param)) = 1) then
          FileName := Copy(Param, 5, length(Param))
        else
          FileName := Copy(Param, 4, length(Param));

        if FileName <> '' then
        begin
          UserAction := CreateUserAction;
          filenames := TStringList.Create;
          try
            filenames.StrictDelimiter := True;
            filenames.Delimiter := '|';
            filenames.DelimitedText := FileName;
            for j := 0 to filenames.Count - 1 do
            begin
              var FileObj : TbfaFileObj;
              FileObj := TbfaFileObj.Create;
              FileObj.FileName := filenames[j];
              FileObj.FileSize := round(FileSize(filenames[j]) / 1024);
              UserAction^.Params.AddObject(IntToStr(j), FileObj);
            end;
          finally
            FreeAndNil(filenames);
          end;

          if (pos('-fd:', LowerCase(Param)) = 1) then
            UserAction^.options := DROPEFFECT_MOVE //muss gelscht werden MoveToBitfarm
          else
            UserAction^.options := DROPEFFECT_COPY; //CopyToBitfarm

          LoadFile(UserAction, AThread);
        end
        else
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              frmMainForm.actLoadFile.Execute;
            end);
        end;
      end;

//22.04.2024  Subdirectory direkt mit, ohne Frage    if (pos('-d:', LowerCase(Param)) = 1) or (pos('-dd:', LowerCase(Param)) = 1) then
      if (pos('-d:', LowerCase(Param)) = 1) or (pos('-dd:', LowerCase(Param)) = 1) or (pos('-dds:', LowerCase(Param)) = 1) then
      begin
        SetViewAndArchive(AThread, tvkImporter);

        subDir := False; //22.04.2024

        if (pos('-dd:', LowerCase(Param)) = 1) then
          DirName := Copy(Param, 5, length(Param))
        //22.04.2024 Subdirectory direkt mit, ohne Frage -->
        else if (pos('-dds:', LowerCase(Param)) = 1) then
        begin
          DirName := Copy(Param, 6, length(Param));
          subDir := True;
        end
        //22.04.2024 <--
        else
          DirName := Copy(Param, 4, length(Param));

        if (DirName <> '') and (DirectoryExists(DirName)) then
        begin
          Folders := TDirectory.GetDirectories(DirName);
          if Length(Folders) > 0 then
          begin
            if subDir then
              DoSubDir := True
            else
            begin
              AThread.Synchronize(nil,
                procedure
                begin
                  DoSubDir := BfMessageDlg(_('Mchten Sie die Dateien aus Unterverzeichnissen auch importieren?'), mtConfirmation, [mbYes, mbNo], True, _('Subfolder durchsuchen')) = mrYes;
                end);
            end;
          end
          else
            DoSubDir := False;

          UserAction := CreateUserAction;
          //22.04.2024 Subdirectory direkt mit, ohne Frage if (pos('-dd:', LowerCase(Param)) = 1) then
          if (pos('-dd:', LowerCase(Param)) = 1) or (pos('-dds:', LowerCase(Param)) = 1) then
            UserAction^.options := DROPEFFECT_MOVE //muss gelscht werden MoveToBitfarm
          else
            UserAction^.options := DROPEFFECT_COPY; //CopyToBitfarm

          var Lst : TStringList;
          Lst := TStringList.Create;
          filenames := TStringList.Create;
          try
            filenames.StrictDelimiter := True;
            filenames.Delimiter := '|';

//            GetAllFilesInDir(DirName, Lst, DoSubDir);
            GetAllFilesInDir(DirName, filenames, DoSubDir);

//            UserAction := CreateUserAction;
//            filenames.StrictDelimiter := True;
//            filenames.Delimiter := '|';
//            filenames.DelimitedText := Lst.Text;
            for j := 0 to filenames.Count - 1 do
            begin
              var FileObj : TbfaFileObj;
              FileObj := TbfaFileObj.Create;
              FileObj.FileName := filenames[j];
              FileObj.FileSize := round(FileSize(filenames[j]) / 1024);
              UserAction^.Params.AddObject(IntToStr(j), FileObj);
            end;
          finally
            FreeAndNil(Lst);
            FreeAndNil(filenames);
          end;
          UserAction^.sList.Add(DirName);   //Verzeichnis muss auch gelscht werden
          LoadFile(UserAction, AThread);
        end;
      end;

      if pos('-p:', LowerCase(Param)) = 1 then
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            frmMainForm.actPrintStandard.Execute;
          end);
      end;

      if liinterchange = 1 then
        senduserpermessage(Copy(Param, liinterchange + 3, Length(Param)));

      if pos('-w:', LowerCase(Param)) = 1 then
      begin
        SetViewAndArchive(AThread, tvkResub);
        AThread.Synchronize(nil,
          procedure
          begin
            frmMainForm.actMyTasks.Execute;
          end);
      end;

      if iLgr = 1 then     // Parameter -L fuer Lagerort auswerten
      begin
        sPStr := Copy(Param, 4, Length(Param));
        if sPStr <> '' then
        begin
          fSkipAutoDisplay := True; //18.09.2019 Ticket 20560
          try
            DoChangeArchiveFromProgram(sPStr, AThread);
          finally
            fSkipAutoDisplay := False; //18.09.2019 Ticket 20560
          end;
        end;
      end;

      if iLgrID = 1 then     // Parameter -LID fuer Lagerort auswerten
      begin
        sPStr := Copy(Param, 6, Length(Param));
        if sPStr <> '' then
        begin
          val(sPStr, iValue, iCode);
          if iCode = 0 then
          begin
            fSkipAutoDisplay := True; //18.09.2019 Ticket 20560
            try
              ChangeArchiveFromProgram(iValue, AThread);
            finally
              fSkipAutoDisplay := False; //18.09.2019 Ticket 20560
            end;
          end;
        end;
      end;

      if iArc = 1 then      // Parameter -A fuer Archiv auswerten
      begin
        sPStr := Copy(Param, 4, Length(Param));
        if (sPStr <> '') and (frmMainForm.FViewerTreeview.Selected <> nil) then
        begin
          fSkipAutoDisplay := True; //18.09.2019 Ticket 20560
          try
            DoChangeArchiveFromProgram(sPStr, AThread, TbfaInt64(frmMainForm.FViewerTreeview.Selected.Data^).Value);
          finally
            fSkipAutoDisplay := False; //18.09.2019 Ticket 20560
          end;
        end;
      end;

      if iArcID = 1 then     // Parameter -aid fuer Lagerort auswerten
      begin
        sPStr := Copy(Param, 6, Length(Param));
        if (sPStr <> '') and (frmMainForm.FViewerTreeview.Selected <> nil) then
        begin
          val(sPStr, iValue, iCode);
          if iCode = 0 then
          begin
            fSkipAutoDisplay := True; //18.09.2019 Ticket 20560
            try
              ChangeArchiveFromProgram(iValue, AThread);
            finally
              fSkipAutoDisplay := False; //18.09.2019 Ticket 20560
            end;
          end;
        end;
      end;

      if not globalsearchcontext then   // wird eine globales Lesezeichen ausgefhrt sind alle anderen Suchen
      begin                             // nicht mglich
        if ligsearchzusfield = 1 then
        begin
          litmp := posex(':', Param, 6);
          fcmdzusfieldsearch := Copy(Param, 6, litmp - 6);
          fcmdzusvaluesearch := ParseAddfields(Copy(Param, litmp + 1, length(Param)));
          with FSearchObj do
          begin
            Reset;
            Id := 1;
            FSearchObj.UseSearch35 := bitfarmApp.FUseSearch35;
            Date := FormatDateTime('dd.mm.yyyy hh:nn:ss', Now);
            name := Date;
            Order := 'docdate';
            Direction := 'DESC';
            SearchType := 0; // Normale Suche
            SelectedArcID := CurrentViewerArchive.Arcid;
            if CurrentArchive.Typ = 0 then    //lager
            begin
              arcid := GetArcids(CurrentArchive.Arcid, user.ID);
              if arcid.Count = 0 then
                arcid.Add(IntToStr(aSysArc[0].arcid));
            end
            else
              arcid.CommaText := IntToStr(CurrentArchive.Arcid);

            UserContext := user.ID;

            val(frmMainForm.btnLimit.Caption, Value, Code);
            if Code <> 0 then
              MaxValues := -1
            else
              MaxValues := Value;

            selcols := SetSelectedColumns(CurrentView = tvkResub);
            if selcols <> '' then
              SelectedCols := selcols;
          end;

          found := True;

          if LowerCase(fcmdzusfieldsearch) = 'titel' then
          begin
            FSearchObj.DocName := fcmdzusvaluesearch;
          end
          else
          begin
            qry := TUniQuery.Create(nil);
            try
              qry.Connection := dmMain.cntMain;
              arcids := GetArcids(TbfaInt64(frmMainForm.FViewerTreeview.Selected.Data^).Value).CommaText;
              if (arcids = '') then //27.03.2018 wenn leer ist dann geben wir einfach das Data.Value weiter
                arcids := IntToStr(TbfaInt64(frmMainForm.FViewerTreeview.Selected.Data^).Value);
              qry.SQL.Text := 'SELECT distinct(sys_addfieldxs.fieldid) FROM sys_addfieldxs ' + 'left join sys_addfields on sys_addfieldxs.fieldid = sys_addfields.addfieldid ' +
//27.03.2018 hatte die Archive nicht ausgelst, deswegen auch nicht gesucht                         'where arcid =' + IntToStr(TbfaInt64(frmMainForm.FViewerTreeview.Selected.Data^).Value) +
                'where arcid in (' + arcids + ') and ((userid in (' + user.HolidayList.CommaText + ') ' + 'or (userid = 0 and groupid in (' + user.GroupList.CommaText + '))) and (displayname =' + #39 + fcmdzusfieldsearch + #39 + ') and ((sys_addfields.flags & 2) = 0))' + ' order by displayname;';
              qry.Open;
              if qry.RecordCount > 0 then
              begin
                qry.First;
                aField := TbfaAddField.Create;
                aField.Clone(aAddfields[qry.FieldByName('fieldid').AsInteger]);

                aField.Modified := True;
                aField.Value := fcmdzusvaluesearch;
                if aField.Typ in [1, 12] then
                  if aField.Component.compDateLow.Text = '' then
                    aField.Value := null;
                if aField.Typ in [6, 7, 8] then
                  aField.ValueHigh := fcmdzusvaluesearch;

                FSearchObj.AddFields.Add(aField);
              end
              else
                found := False;
              qry.Close;
            finally
              FreeAndNil(qry);
            end;
          end;

          if found then //27.03.2018 wenn kein recht auf Zusatzfeld, dann darf auch nichts gesucht werden
            StartSearchThread(FSearchObj)
          else
            frmMainForm.actReset.Execute; //27.03.2018 wenn kein recht auf Zusatzfeld, dann darf auch nichts gesucht werden
        end;

        if iSlw = 1 then  // wir suchen entweder nach Schlagwrter
           // Parameter -S fuer Schlagwort auswerten
        begin
          fSkipAutoDisplay := True; //18.09.2019 Ticket 20560
          try
            ChangeArchiveFromProgram(bitfarmApp.CurrentViewerArchive.Arcid, AThread); //18.03.2019 Ticket 15971
          finally
            fSkipAutoDisplay := False; //18.09.2019 Ticket 20560
          end;

          Reset(AThread);

          AThread.Synchronize(nil,
            procedure
            begin
              frmMainForm.tbiSoTags.Click;
              frmMainForm.edtSearchFTX.compEdit.Text := ParseSemicolonUseBackslash(Trim(Copy(Param, iSlw + 3, Length(Param))));
            end);
        end;
        if iVtx = 1 then   // ... oder nach Volltext  ...
        begin
          fSkipAutoDisplay := True; //18.09.2019 Ticket 20560
          try
            ChangeArchiveFromProgram(bitfarmApp.CurrentViewerArchive.Arcid, AThread); //18.03.2019 Ticket 15971
          finally
            fSkipAutoDisplay := False; //18.09.2019 Ticket 20560
          end;

          Reset(AThread);

//10.10.2017 mit HS besprochen, und sollte im Suchschlitz gesucht werden, weil AnnoTxt ein separat Feld ist! -->
          lmystrl := StrToWords(Trim(Copy(Param, iVtx + 3, Length(Param))));
          lmystrl.Delimiter := ' ';
          try
            var newStr: string;
            newStr := '';
            for licount := 0 to lmystrl.Count - 1 do
              newStr := newstr + ' ' + StringReplace(lmystrl[licount], '''', '"', [rfReplaceAll]);

            AThread.Synchronize(nil,
              procedure
              begin
                frmMainForm.edtGeneralSearch.Text := ParseSemicolonUseBackslash(newStr);
                if Assigned(frmMainForm.edtGeneralSearch.Properties.OnChange) then
                  frmMainForm.edtGeneralSearch.Properties.OnChange(frmMainForm.edtGeneralSearch);
              end);
//            AThread.Synchronize(nil,
//              procedure
//              begin
//                frmMainForm.edtGeneralSearch.Text := '';
//              end);
//            for licount := 0 to lmystrl.Count - 1 do
//            begin
//              AThread.Synchronize(nil,
//                procedure
//                begin
//                  frmMainForm.edtGeneralSearch.Text := frmMainForm.edtGeneralSearch.Text + ' +' + ParseSemicolonUseBackslash(lmystrl.Strings[licount]);
//                end);
//            end;
          finally
            lmystrl.Destroy;
          end;
//10.10.2017 mit HS besprochen, und sollte im Suchschlitz gesucht werden, weil AnnoTxt ein separat Feld ist! -->
        end;
        if iRef = 1 then   //3.5.0.84   oder nach Verknpfungen, gleichzeitig geht das nicht
        begin              // daher mssen die Steuerelemente leergemacht werden
          Reset(AThread);

          Alt1(AThread);  // Ticket 14112 Wechsel in den Viewer (z.B wenn man vorher im Importer steht) bei Vernkpfungssuche
          PrepareForSearchLinksAction(ParseSemicolonUseBackslash(Trim(Copy(Param, iRef + 3, Length(Param))))); // // Ticket 14112 In Thread ausgelagert wegen der Synchroniesierung.
          IsRefSearch := True; //05.07.2024 SD/BD <--bfacrm:ticket__show__38036

        end;
        if LowerCase(Param) = '-go' then
           // Parameter -GO auswerten.
           // Die Suche wird ohne Interaktion des Benutzers gestartet NG060816
        begin
          //05.07.2024 SD/BD -->bfacrm:ticket__show__38036
          if frmMainForm.actSearch.Enabled then
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                frmMainForm.actSearch.Execute;
              end);
          end
          else
          begin
            if IsRefSearch then    //05.07.2024
            begin
              AThread.Synchronize(nil,
                procedure
                begin
                  try
                    frmMainForm.actSearch.Enabled := True;
                    frmMainForm.actSearch.Execute;
                  finally
                    frmMainForm.actSearch.Enabled := False;
                  end;
                end);
            end;
          end;
          //05.07.2024 SD/BD <--bfacrm:ticket__show__38036
        end;
        if LowerCase(ExtractFileExt(Param)) = '.fnd' then
        begin
          ReadJobFile(AThread, nil, Param, slZMetaField, slZMetaName, slZMetaFieldValues, slZMetaFieldType, error, ErrorStr, FSearchObj);
        end;
      end;

      if iSObj = 1 then     // Parameter -so:  SearchObject
      begin
        Sobj := nil;
        SObjPath := Copy(Param, 5, Length(Param));

        CoInitialize(nil);
        XMLDoc := TXMLDocument.Create(nil);
        try
          try
            if LowerCase(LeftStr(SObjPath, 19)) = '<?xml version=''1.0''' then
              XMLDoc.LoadFromXML(SObjPath)
            else if LowerCase(RightStr(SObjPath,4)) = '.xml' then begin
              if FileExists(SObjPath) then
              begin
                XMLDoc.LoadFromFile(SObjPath);
              end else
              begin
                bitfarmLog.Write(llNormal, ltInfo, 'Konnte externes Lesezeichen nicht finden' + SObjPath, ClassName);
                Exit
              end;
            end else
            begin  // nach namen suchen
              found := False;
              j := 0;
              // lokales Lesezeichen suchen (muss fr den Benutzer vorhanden sein)
              while (j <= frmMainForm.trvBookmarks.Items.Count - 1) and not found do
              begin
                if (frmMainForm.trvBookmarks.Items[j].Count > 0) then
                //es sind Elemente vorhanden
                //Globales Lesezeichen von Lokalem Lesezeichen und Ordner unterscheiden
                begin
                  if (frmMainForm.trvBookmarks.Items[j] = bitfarmApp.LocalListNode) then
                  begin
                    Sobj := SearchNodeByName(frmMainForm.trvBookmarks.Items[j],SObjPath);
                    if Sobj <> nil then
                    begin
                      found := True;
                      Break;
                    end;
                  end;
                end;
                Inc(j);
              end;
            end;

            if Sobj = nil then  // wenn wir das Sobj nicht nach Namen gesucht, sondern per XML bergeben haben
            begin               // mssen wir erst das XMLDoc verarbeiten
              if XMLDoc = nil then
              begin
                bitfarmLog.Write(llNormal, ltException, 'Fehler bei externes Lesezeichen: konnte XML nicht lesen', ClassName);
                Exit;
              end;

              RootNode := XMLDoc.DocumentElement;

              if RootNode = nil then
              begin
                bitfarmLog.Write(llNormal, ltException, 'Fehler bei externes Lesezeichen: kein bookmark xml', ClassName);
                Exit;
              end;

              if RootNode.NodeName = 'bookmark' then
              begin
                FavNode := RootNode.ChildNodes[0];
                if FavNode = nil then
                begin
                  bitfarmLog.Write(llNormal, ltException, 'Fehler bei externes Lesezeichen: kein child knoten', ClassName);
                  Exit;
                end;

                if FavNode.NodeName = 'fav' then
                begin
                  Sobj := XMLToSearchObj(FavNode);
                end else
                begin
                  bitfarmLog.Write(llNormal, ltException, 'Fehler bei externes Lesezeichen: kein fav knoten', ClassName);
                  Exit;
                end;
              end;
            end;

            if Sobj <> nil then
            begin
              Sobj.SearchType := 1;   // wir fhren externe Lesezeichen nur als lokale Lesezeichen aus
                                      // Globale Lesezeichen (SearchType=2) wrden unsere Berechtigungen unterminieren
              if not globalsearchcontext then  // wenn wir einen globalen Suchkontext haben wird das Lesezeichen in diesem ausgefhrt
                bitfarmApp.BookmarkSearch(AThread, sobj);
            end else begin
              bitfarmLog.Write(llNormal, ltException, 'Fehler bei externes Lesezeichen: konnte Lesezeichen nicht lesen', ClassName);
              Exit;
            end;

          except
            on e: exception do
              bitfarmLog.Write(llNormal, ltException, 'Fehler bei externes Lesezeichen' + e.Message, ClassName);
          end;
        finally
          if Assigned(XMLDoc) then
            XMLDoc := nil;
          CoUnInitialize;
        end;
      end;

      if iGSObj = 1 then     // Parameter -gs:  globales lesezeichen
      begin
        GSObjName := Copy(Param, 5, Length(Param));
        found := False;
        j := 0;
        // globales Lesezeichen suchen (muss fr den Benutzer vorhanden sein)
        while (j <= frmMainForm.trvBookmarks.Items.Count - 1) and not found do
        begin
          if (frmMainForm.trvBookmarks.Items[j].Count > 0) then
          //es sind Elemente vorhanden
          //Globales Lesezeichen von Lokalem Lesezeichen und Ordner unterscheiden
          begin
            if (frmMainForm.trvBookmarks.Items[j] = bitfarmApp.GlobalListNode) then
            begin
              GSobj := SearchNodeByName(frmMainForm.trvBookmarks.Items[j],GSobjName);
              if GSobj <> nil then
              begin
                found := True;
                Break;
              end;
            end;
          end;
          Inc(j);
        end;
      end;
    end;

    if globalsearchcontext and assigned(GSobj) and (GSobj.SQLWhere <> NULL) then  // haben wir ein globales lesezeichen?
    begin
      GSobj.SQLWhere := '(' + GSobj.SQLWhere + ')';
      if Assigned(Sobj) then
        GSobj.SQLWhere := GSobj.SQLWhere + ' and (' + Sobj.SQLWhere + ')';
      if ligdocid > 0 then
        GSobj.SQLWhere := GSobj.SQLWhere + ' and sd.gdocid = ' + IntToStr(ligdocid);
      bitfarmApp.BookmarkSearch(AThread, GSobj);
    end;

    if liinterchange = 0 then
    begin
      AThread.Synchronize(nil,
        procedure
        begin
          Application.BringToFront;
          frmMainForm.BringToFront;
//16.09.2022 Ticket 32287         ForceForegroundWindow(application.handle);
          ForceForegroundWindow(frmMainForm.handle);
        end);
    end;
  finally
    handleparamaktiv := False;
    fSkipAutoDisplay := False; //10.03.2017
    bitfarmLog.Write(llNormal, ltInfo, 'HandleParam End handleparamaktiv=' + BoolToStr(handleparamaktiv, True), ClassName);
  end;
end;

procedure Tbfaapplication.senduserpermessage(fapp: string);
var
  CopyData: TCopyDataStruct;
  lsmesg: string;
  DataSize: integer;
  Data: PChar;
  PData: PChar;
  Wdw: HWND;
begin
  Wdw := FindWindow(PChar(fapp), nil);
  lsmesg := user.Name;
  DataSize := length(lsmesg);
  Inc(DataSize, Length(lsmesg) + 1);
  Data := StrAlloc(DataSize + 1);

  try
    PData := Data;
    StrPCopy(PData, lsmesg);
    Inc(PData, Length(lsmesg) + 1);
    PData^ := #0;
    CopyData.lpData := Data;
    CopyData.cbData := DataSize;
    CopyData.dwData := $DDED;
//15.09.2016      application.ProcessMessages;
    SendMessage(Wdw, WM_COPYDATA, 0, LPARAM(@CopyData));
  finally
    StrDispose(Data);
  end;
end;

function TbfaApplication.ForceForegroundWindow(hwnd: THandle): Boolean;
const
  SPI_GETFOREGROUNDLOCKTIMEOUT = $2000;
  SPI_SETFOREGROUNDLOCKTIMEOUT = $2001;
var
  ForegroundThreadID: DWORD;
  ThisThreadID: DWORD;
  timeout: DWORD;
begin
  if IsIconic(hwnd) then
    ShowWindow(hwnd, SW_RESTORE);

  if GetForegroundWindow = hwnd then
    result := True
  else
  begin
      // Windows 98/2000 doesn't want to foreground a window when some other
      // window has keyboard focus

    if ((Win32Platform = VER_PLATFORM_WIN32_NT) and (Win32MajorVersion > 4)) or ((Win32Platform = VER_PLATFORM_WIN32_WINDOWS) and ((Win32MajorVersion > 4) or ((Win32MajorVersion = 4) and (Win32MinorVersion > 0)))) then
    begin
         // Code from Karl E. Peterson, www.mvps.org/vb/sample.htm
         // Converted to Delphi by Ray Lischner
         // Published in The Delphi Magazine 55, page 16

      result := False;
      ForegroundThreadID := GetWindowThreadProcessID(GetForegroundWindow, nil);
      ThisThreadID := GetWindowThreadPRocessId(hwnd, nil);
      if AttachThreadInput(ThisThreadID, ForegroundThreadID, True) then
      begin
        BringWindowToTop(hwnd); // IE 5.5 related hack
        SetForegroundWindow(hwnd);
        AttachThreadInput(ThisThreadID, ForegroundThreadID, False);
        result := (GetForegroundWindow = hwnd);
      end;
      if not result then
      begin
            // Code by Daniel P. Stasinski
        SystemParametersInfo(SPI_GETFOREGROUNDLOCKTIMEOUT, 0, @timeout, 0);
        SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, TObject(0), SPIF_SENDCHANGE);
        BringWindowToTop(hwnd); // IE 5.5 related hack
        SetForegroundWindow(hwnd);
        SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, TObject(timeout), SPIF_SENDCHANGE);
      end;
    end
    else
    begin
      BringWindowToTop(hwnd); // IE 5.5 related hack
      SetForegroundWindow(hwnd);
    end;

    result := (GetForegroundWindow = hwnd);
  end;
end;

{$IFDEF ENTERPRISE}
procedure TbfaApplication.WriteJobFile(fsDocname: string; fusefield: boolean; Typ: Integer = 0; Doc: TbfaDocument = nil; ArcID: Integer = -1);
var
  ini: TIniFile;
  iCount, litimeroptionen, j, i: Integer;
  sFeld, sName, sWert, lsinput1, lsinput2, tlb, sRef, ArcName: WideString;
  comp, comp1: TComponent;
  liTyp: integer;
  sGUsrName: WideString;
begin
  bitfarmLog.DebugBegin(llDebug, 'WriteJobFile', Classname);
  try
    if Typ = 0 then
      ChangeFileExt(fsDocname, '.job')
    else if Typ = 1 then
      ChangeFileExt(fsDocname, '.fnd');

    ini := TIniFile.Create(fsDocname);
    try
      try
        with ini do
        begin
          WriteString('Version', 'Version', '36');
          WriteString('Archiv', 'Profil', bitfarmApp.Profile);

          if (Doc <> nil) and (Doc.ID <> -1) and (not Doc.Loaded) then
          //10.02.2023 bfacrm:ticket__show__33894 -->
          //  bitfarmApp.LoadDocumentViaSocket(Doc, 'base;fields;paths;links;iev;text;svn', nil);
          begin
            if not bitfarmApp.OfflineMode then
              bitfarmApp.LoadDocumentViaSocket(Doc, 'base;fields;paths;links;iev;text;svn', nil)
            else
              DBLoadDocument(Doc);
          end;
          //10.02.2023 bfacrm:ticket__show__33894 <--

          WriteString('Archiv', 'Tabelle', '');

          if (Doc <> nil) then
          begin
            if Doc.SymbolicArcID <> -1 then //17.10.2017 fr Plugins ist wichtig welche war die ausgewhlte Archiv.
            begin
              for i := Low(aSysArc) to High(aSysArc) do
              begin
                if ((Doc <> nil) and (aSysArc[i].ArcID = Doc.SymbolicArcID)) then
                begin
                  WriteString('Archiv', 'Name', aSysArc[i].name);
                  Break;
                end;
              end;
              WriteString('Archiv', 'ArcID', IntToStr(Doc.SymbolicArcID));
            end
            else
            begin
              for i := Low(aSysArc) to High(aSysArc) do
              begin
                if ((Doc <> nil) and (aSysArc[i].ArcID = Doc.ArcID)) or ((ArcID <> -1) and (aSysArc[i].ArcID = ArcID)) then
                begin
                  WriteString('Archiv', 'Name', aSysArc[i].name);
                  Break;
                end;
              end;
              WriteString('Archiv', 'ArcID', IntToStr(Doc.ArcID));

            end;
            WriteString('Document', 'DOCID', IntToStr(Doc.ArcID) + '.' + IntToStr(Doc.ID));
            WriteString('Document', 'gdoc_id', IntToStr(Doc.ID));

            WriteString('Document', 'Titel', Doc.DocName);
            WriteString('Document', 'Orginal', Doc.DocLoc);
            WriteString('Document', 'Kopie', Doc.ExtLoc);
            WriteString('Document', 'Quelle', Doc.OriLoc);

            sGUsrName := FUser.DisplayName;
            if sGUsrName = '' then
              sGUsrName := BD.EnvUsername;
            if sGUsrName = '' then
              sGUsrName := 'unbekannt';

            WriteString('Document', 'Benutzer', sGUsrName);
//29.01.2019 Ticket 17687 -->
// Die brauchen wir nicht, weil im Version 36 wird hier keine Pfade mehr gespeichert
//            WriteString('Document', 'Volltext', '');
//            WriteString('Document', 'Schlagworte', '');
//            WriteString('Document', 'Filter', '');
//29.01.2019 Ticket 17687 <--
    //11.07.2016        WriteString('Document', 'Status', IntToStr(Doc.Status));
            WriteString('Document', 'StatStr', '');
            WriteString('Document', 'OCR_QF', '');
            WriteString('Document', 'OCR_Typ', 'OMP');
            WriteString('Document', 'Datum', '');
            WriteString('Document', 'userid', IntToStr(FUser.ID));

            if Length(Doc.DocLinkList) > 0 then
            begin
              iCount := 1;
              WriteInteger('Referenz', 'Anzahl', High(Doc.DocLinkList) + 1);
              for j := Low(Doc.DocLinkList) to High(Doc.DocLinkList) do
              begin
                sRef := Doc.DocLinkList[j].Refname;
                WriteString('Referenz', 'Referenz' + IntToStr(iCount), sRef);
                inc(iCount);
              end;
            end
            else
              WriteString('Referenz', 'Anzahl', '0');

            WriteString('Tasks', 'Termin', '');
            WriteString('Tasks', 'Alarm', '');
            WriteString('Tasks', 'Notiz', '');
            litimeroptionen := 0;
            WriteInteger('Tasks', 'TimerOptionen', litimeroptionen);
          end else
          begin
            if ArcID > 0 then
            begin
              WriteString('Lager', 'Name', aSysArc[aSysArc[ArcID].LgrID].name);
              WriteString('Archiv', 'ArcID', IntToStr(ArcID));
              WriteString('Archiv', 'Name', aSysArc[ArcID].name);
            end;
            WriteString('Suche', 'Benutzername', '');
            WriteString('Suche', 'Volltext', '');
            WriteString('Suche', 'Schlagworte', '');
            WriteString('Suche', 'Datum_von', '');
            WriteString('Suche', 'Datum_bis', '');
          end;

          WriteIndexDataToJobFile(ini, Doc, ArcID);

          if (Doc = nil) then
          begin
            WriteString('Option', 'Semantik', '1');
            WriteString('Option', 'VtxundSlw', '1');
          end;
        end;
      except
        on e: exception do
          BfShowMessage(_('Fehler beim Erstellen der Vorlagen Datei: ') + e.Message);
      end;
    finally
      if Assigned(ini) then
      begin
        ini.UpdateFile;
        FreeAndNil(ini);
        if (Doc = nil) and (ArcID <> -1) then
        begin
          BfShowMessage(_('Die Vorlagendatei wurde erfolgreich erstellt.'));
        end;
      end;
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'WriteJobFile', Classname);
  end;
end;

procedure TbfaApplication.WriteJobFileDest(fsDocname: string; DestArcID: Integer; slZMetaField, slZMetaName, slZMetaFieldValues, slZMetaFieldType: TStringList);
var
  ini: TIniFile;
  iFeld, {litimeroptionen,} j, i: Integer;
  tmpMetaFieldValue: Widestring;
//  sFeld, sName, sWert, lsinput1, lsinput2, tlb, sRef, ArcName: WideString;
//  comp, comp1: TComponent;
//  liTyp: integer;
//  sGUsrName: WideString;
begin
  ini := TIniFile.Create(fsDocname);
  try
    try
      with ini do
      begin
        for i := Low(aSysArc) to High(aSysArc) do
        begin
          if aSysArc[i].arcid = DestArcID then
          begin
            WriteString('Ziel_Archiv', 'Ziel_Name', aSysArc[i].name);
            Break;
          end;
        end;

        iFeld := 1;
        for i := Low(aAddfields) to High(aAddfields) do
        begin
          if aAddfields[i] = nil then
            Continue;
          if aAddfields[i].Addfields_Arcid = DestArcID then
          begin
            WriteString('Ziel_Zusatzfelder', 'ZusTitel' + IntToStr(iFeld), aAddfields[i].DisplayName);
            WriteString('Ziel_Zusatzfelder', 'ZusFeld' + IntToStr(iFeld), aAddfields[i].name);
            WriteString('Ziel_Zusatzfelder', 'ZusWert' + IntToStr(iFeld), '');
            inc(iFeld);
          end;
        end;
        WriteInteger('Ziel_Zusatzfelder', 'Felder', iFeld);

        for i := 0 to slZMetaName.Count - 1 do
        begin
          if slZMetaFieldValues[i] = '' then
            Continue;

          for j := 1 to iFeld do
          begin
            if ReadString('Ziel_Zusatzfelder', 'ZusTitel' + IntToStr(j), '') = slZMetaName[i] then
            begin
              tmpMetaFieldValue := slZMetaFieldValues[i];
              if LeftStr(tmpMetaFieldValue, 11) = 'str_to_date' then
                tmpMetaFieldValue := Copy(tmpMetaFieldValue, 14, 10);

              WriteString('Ziel_Zusatzfelder', 'ZusWert' + IntToStr(j), tmpMetaFieldValue);
              Break;
            end;
          end;
        end;
      end;
    except
      on e: exception do
        BfShowMessage(_('Fehler beim Erweitern der Job-Datei: ') + e.Message);
    end;
  finally
    if Assigned(ini) then
    begin
      ini.UpdateFile;
      FreeAndNil(ini);
    end;
  end;
end;

procedure TbfaApplication.WritePluginHistory(AThread: TThread; Pluginname: String;
  Result: Integer; Document: TbfaDocument);
begin
 // Nur im Enterprise Version
end;

procedure TbfaApplication.WriteIndexDataToJobFile(ini: TIniFile; Doc: TbfaDocument = nil; ArcID: Integer = -1);
var
  i, j, bitpos: integer;
  sWert: Variant;
  stsWert: string;
  lmq: TUniQuery;
  Bitmask: Int64;
  fieldright: TbfaFieldright;
  found: Boolean;
  list: TStringList;
  sIndexColumnId: string;
  iBitmask: Int64;
begin
  Log.DebugBegin(llDebug, 'WriteIndexDataToJobFile', ClassName);
  try
    try
      if (Doc <> nil) then
      begin
        ini.WriteInteger('Zusatzfelder', 'Felder', Doc.AddFields.Count);

        for i := 0 to Doc.AddFields.Count - 1 do
        begin
          ini.WriteString('Zusatzfelder', 'ZusTitel' + IntToStr(i + 1), Doc.AddFields[i].DisplayName);
          ini.WriteString('Zusatzfelder', 'ZusFeld' + IntToStr(i + 1), Doc.AddFields[i].name);

          if not VarIsNull(Doc.AddFields[i].value) then
          begin
            sWert := Doc.AddFields[i].value;

            if Doc.Addfields[i].Typ in [1, 12] then   // bei Datumsfelder die Uhrzeit abschneiden
              sWert := LeftStr(sWert, 10);
          end else
            sWert := '';

          ini.WriteString('Zusatzfelder', 'ZusWert' + IntToStr(i + 1), VarToStr(sWert));
        end;

        stsWert := '';
        Bitmask := 0;
        if FUseState35 then
        begin
          lmq := TUniQuery.Create(nil);
          try
            lmq.Connection := dmMain.cntMain;
            lmq.SQL.Text := GetInResubSQLText(Doc);

            lmq.Execute;

            if lmq.RecordCount > 0 then
              Bitmask := 1;
          finally
            lmq.Free;
          end;

          stsWert := IntToStr(Bitmask);
        end;
        bitpos := 0;
        list := TStringList.Create;
        for i := 0 to Doc.StateFields.Count - 1 do
        begin
          if FUseState35 then
          begin
            found := False;
            for j := 0 to Doc.StateFields[i].FieldRights.Count - 1 do
            begin
              // auf userid prfen
              if (Doc.StateFields[i].FieldRights[j].userid <> 0) and (Doc.StateFields[i].FieldRights[j].userid <> FUser.ID) then
                Continue;

              // auf groupid prfen
              if (Doc.StateFields[i].FieldRights[j].userid = 0) and (FUser.GroupList.IndexOf(IntToStr(Doc.StateFields[i].FieldRights[j].groupid)) = -1) then
                Continue;

              found := True;
            end;

            if found then  // wenn wir wenigstens einen berechtigungssatz fr dieses feld gefunden haben
            begin
              Inc(bitpos);
              if ((not VarIsNull(Doc.StateFields[i].value)) and VarIsType(Doc.StateFields[i].value, varBoolean) and (Doc.StateFields[i].value)) then
              begin
                Bitmask := Bitmask + bfaPower(bitpos);
                stsWert := IntToStr(Bitmask);
              end;
            end;
          end else
          begin  // (Ticket 15697 Viewer schreibt fehlerhafte Job-Datei mit Status)
            if ((not VarIsNull(Doc.StateFields[i].value)) and VarIsType(Doc.StateFields[i].value, varBoolean) and (Doc.StateFields[i].value)) then
            begin
              sIndexColumnId := IntToStr(Doc.StateFields[i].IndexColumnID);
              iBitmask := Doc.StateFields[i].Bitmask;

              if list.IndexOf(sIndexColumnId) < 0 then
                list.AddObject(sIndexColumnId, TbfaInt64.Create(Doc.StateFields[i].Bitmask))
              else
              begin
                iBitmask := iBitmask + TbfaInt64(list.Objects[list.IndexOf(sIndexColumnId)]).value;
                TbfaInt64(list.Objects[list.IndexOf(sIndexColumnId)]).value := iBitmask;
              end;
            end;
          end;
          {else
            begin
              if ((not VarIsNull(Doc.StateFields[i].value)) and
                 VarIsType(Doc.StateFields[i].value, varBoolean) and (Doc.StateFields[i].value)) then
            begin
              if (i > 0) and (stsWert <> '') then
                stsWert := stsWert + ';';

              stsWert := stsWert + IntToStr(Doc.StateFields[i].IndexColumnID) + ':' + IntToStr(Doc.StateFields[i].Bitmask);
            end;
          end;
          end;}
        end;

        // in V36 summieren wir in stsWert die Bitmasks pro Index auf (Ticket 15697)
        if not FUseState35 then
        begin
          for i := 0 to list.Count - 1 do
          begin
            stsWert := stsWert + list.Strings[i] + ':' + IntToStr(TbfaInt64(list.Objects[i]).value);

            if i < list.Count - 1 then
              stsWert := stsWert + ';';
          end;

          // Objekte deallokieren, Speicher aufrumen
          for i := 0 to list.Count - 1 do
            TbfaInt64(list.Objects[i]).free;
          list.Free;
        end;

        ini.WriteString('Document', 'Status', stsWert);
      end
      else if (ArcID <> -1) then
      begin
        if (frmMainForm.fraAdmin <> nil) and (frmMainForm.fraAdmin.CurrentArchive <> nil) then
        begin
          lmq := DbCreateQuery;
          try
            lmq.SQL.Text := 'SELECT distinct(sys_addfieldxs.fieldid), sys_addfields.displayname, ' + 'sys_addfields.fieldname FROM sys_addfieldxs ' + 'left join sys_addfields on sys_addfieldxs.fieldid = sys_addfields.addfieldid ' + 'where (arcid =' + IntToStr(frmMainForm.fraAdmin.CurrentArchive.ID) + ') and ' + '((sys_addfields.flags & 2) = 0) order by pos';

            lmq.Execute;

            ini.WriteInteger('Zusatzfelder', 'Felder', lmq.RecordCount);

            if lmq.RecordCount > 0 then
            begin
              i := 1;
              while not lmq.Eof do
              begin
                ini.WriteString('Zusatzfelder', 'ZusTitel' + IntToStr(i), lmq.FieldByName('displayname').AsWideString);
                ini.WriteString('Zusatzfelder', 'ZusFeld' + IntToStr(i), lmq.FieldByName('fieldname').AsString);
                ini.WriteString('Zusatzfelder', 'ZusWert' + IntToStr(i), '');

                lmq.Next;
                Inc(i);
              end;
            end;
          finally
            lmq.Free;
          end;
        end;
      end;
    except
      Log.Write(llNormal, ltException, 'WriteIndexDataToJobFile', ClassName);
    end;
  finally
    Log.DebugEnd(llDebug, 'WriteIndexDataToJobFile', ClassName);
  end;
end;
{$ENDIF}

procedure TbfaApplication.ReadJobFile(AThread: TThread; Doc: TbfaDocument; fsDocname: string;
  var slZMetaField, slZMetaName, slZMetaFieldValues, slZMetaFieldType: TStringList;
  var Error: Boolean; var ErrorStr: string; SObj: TbfaSearch = nil);
var
  ini: TIniFile;
  slRef, slwList: TStringList;
  iCount, //litimeroptionen,
  iFtxFields, i, j, k, licount, liArcid, liDocid, liTyp, liGdocid, liOldStatus, liChanged, liRef, liFields, ColID, idx: integer;
  Bitmask, tMask : Int64;
  lsProfil, lsLgrname, lsArcname, lsTblname, lsDocid, lsTitel, lsOldTitel, lsTxt, lsDocloc, lsExtloc, lsOriloc, lsBenutzer, lsVolltext, lsSLW, sStatus, lsZielname, lsDatumVon, lsDatumBis, stsWert: string;
  AddField: TbfaAddField;
  OriDoc: TbfaDocument;
  req: TbfaRequest;
  UserAction: PUserAction;
  msg, param, str, Filter, Fname: string;
  Lst: TList<TbfaBaseObject>;
  DocLst: TList<TbfaDocument>;
  StsList: TStringList;
  dStslist: TDictionary<Integer, Int64>;
  found: Boolean;
  Sts: TbfaStateField;
  StateList: TList<TbfaStateField>;
  tmpqry: TuniQuery;
  stateid, bitpos: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'ReadJobFile:' + fsDocname, Classname);
  try
    try
      slRef := TStringList.Create;
      ini := TIniFile.Create(fsDocname);
      OriDoc := nil;
      try
        try
          with ini do
          begin
            lsLgrname := ParseSQLString(ini.ReadString('Lager', 'Name', ''));
            lsArcname := ParseSQLString(ini.ReadString('Archiv', 'Name', ''));
            if SObj = nil then
            begin
              if Doc = nil then
              begin
                Doc := TbfaDocument.Create;
                lsProfil := ini.ReadString('Archiv', 'Profil', '');
                lsTblname := ParseSQLString(ini.ReadString('Archiv', 'Tabelle', ''));
                lsDocid := ini.ReadString('Document', 'DOCID', '');
                if lsDocid <> '' then
                begin
                  liArcid := strtoint(Copy(lsDocid, 1, pos('.', lsDocid) - 1));
                  Doc.ArcID := liArcid;
                  liDocid := strtoint(Copy(lsDocid, pos('.', lsDocid) + 1, Length(lsDocid) - pos('.', lsDocid) + 1));
                  Doc.ID := liDocid;
                end
                else
                begin
                  liGdocid := ini.ReadInteger('Document', 'gdoc_id', -1);
                  Doc.ID := liDocid;
                  Doc.ArcID := ini.ReadInteger('Document', 'ArcID', -1);
                end;
              end;

              Doc.Docname := ini.ReadString('Document', 'Titel', '');
//29.01.2019 Ticket 17687 -->
              if ini.ValueExists('Document', 'Volltext') then
              begin
                Fname := ini.ReadString('Document', 'Volltext', '');
                if FileExists(Fname) then
                begin
                  slwList := TStringList.Create;
                  try
                    slwList.Clear;
                    slwList.LoadFromFile(Fname);
                    Doc.FullTXT := slwList.Text;
                  finally
                    FreeAndNil(slwList);
                  end;
                end;
              end;
              if ini.ValueExists('Document', 'Schlagworte') then
              begin
                Fname := ini.ReadString('Document', 'Schlagworte', '');
                if FileExists(Fname) then
                begin
                  slwList := TStringList.Create;
                  try
                    slwList.Clear;
                    slwList.LoadFromFile(Fname);
                    Doc.DocTags := slwList.Text;
                  finally
                    FreeAndNil(slwList);
                  end;
                end;
              end;
              if ini.ValueExists('Document', 'Filter') then
                Filter := ParseSQLString(ini.ReadString('Document', 'Filter', ''));
//29.01.2019 Ticket 17687 <--

//12.03.2019 neue DocName Regelung -->
// // 09.11.2017 Outlookaddin Docname muss bernehmen -->
//              Doc.ImporterDocNameModified := (pos('fromoutlook', Filter) > 0) or (pos('fromoffice', Filter) > 0);
//              Filter := StringReplace(Filter, 'fromoffice', '', [rfReplaceAll]); //Brauchen wir nicht in der neuen Job Datei
// // 09.11.2017 Outlookaddin Docname muss bernehmen <--
//12.03.2019 neue DocName Regelung <--

              Filter := StringReplace(Filter, 'fromoffice', '', [rfReplaceAll]); //Brauchen wir nicht in der neuen Job Datei

              if Filter <> '' then
              begin
                if (Doc.Filter <> '') then
                  Doc.Filter := Doc.Filter + ';';
                Doc.Filter := Doc.Filter + Filter;
              end;

              if Doc.ID <> -1 then
              begin
                if Doc.ID = FCurrentContainer[0].Id then
                  OriDoc := FCurrentContainer[0]
                else
                begin
                  OriDoc := TbfaDocument.Create;
                  OriDoc.ID := Doc.ID;
                  //10.02.2023 bfacrm:ticket__show__33894 -->
                  //LoadDocumentViaSocket(OriDoc, 'base;fields;paths;text', AThread);
                  if not bitfarmApp.OfflineMode then
                    LoadDocumentViaSocket(OriDoc, 'base;fields;paths;text', AThread)
                  else if bitfarmApp.OfflineMode then
                    bitfarmApp.DBLoadDocument(OriDoc);
                  //10.02.2023 bfacrm:ticket__show__33894 -->
                  if (OriDoc.EditmodeUserID = FUser.ID) and (not OriDoc.InEditMode) and (FDoSave) then //27.07.2017 beim Saveplugin muss nicht nochmal in editmode setzen
                    OriDoc.InEditMode := True;
                end;
                if not OriDoc.InEditMode then
                begin
                  DocLst := TList<TbfaDocument>.Create;
                  try
                    DocLst.Add(OriDoc);
                    InEditMode(DocLst, nil, AThread);
                    ReloadLinks(OriDoc);
                  finally
                    FreeAndNil(DocLst);
                  end;
                end;

                if (not OriDoc.Loaded) or (not OriDoc.InEditMode) then
                begin
                  BfShowMessage(_('Das Dokument konnte nicht geladen werden!'), AThread);
                  Exit;
                end;

                if Doc.DocName <> OriDoc.DocName then
                  Doc.Modified := True;
              end;

              liRef := ini.ReadInteger('Referenz', 'Anzahl', 0);
              for licount := 1 to liRef do
              begin
                slRef.add(ParseSQLString(ini.ReadString('Referenz', 'Referenz' + inttostr(licount), '')));
              end;

              if Doc.ID = -1 then
              begin
                SetLength(Doc.DocLinkList, slRef.Count);
                for i := 0 to slRef.Count - 1 do
                begin
                  with Doc.DocLinkList[i] do
                  begin
                    Refname := slRef[i];
                    count := -1;
                    gdocid := -1;
                    RefID := -1;
                  end;
                end;
              end;

              liFields := ini.ReadInteger('Zusatzfelder', 'Felder', 0);
              for licount := 0 to liFields - 1 do
              begin
                AddField := TbfaAddField.Create;
                AddField.Displayname := ParseAddfields(ini.ReadString('Zusatzfelder', 'ZusTitel' + IntToStr(licount + 1), ''));
                AddField.Name := ParseAddfields(ini.ReadString('Zusatzfelder', 'ZusFeld' + IntToStr(licount + 1), ''));
                //AddField.ID := StrToInt(StringReplace(AddField.Name, 'add_', '', [rfReplaceAll]));

                for i := Low(aAddfields) to High(aAddfields) do
                begin
                  if aAddfields[i] = nil then
                    continue;

                  if aAddfields[i].name = AddField.Name then
                  begin
                    AddField.ID := aAddfields[i].Id;
                    AddField.Typ := aAddfields[i].Typ;
                    AddField.Options := aAddfields[i].options;
                    Break;
                  end;
                end;

                if AddField.Typ in [13,14] then  //Gridfield und GridSpalte
                  AddField.Value := ParseGridfields(ini.ReadString('Zusatzfelder', 'ZusWert' + IntToStr(licount + 1), ''))
                else
                  AddField.Value := ParseAddfields(ini.ReadString('Zusatzfelder', 'ZusWert' + IntToStr(licount + 1), ''));

                if OriDoc <> nil then
                begin
                  i := 0;
                  while ((i <= OriDoc.AddFields.Count - 1) and (not AddField.Modified)) do
                  begin
                    if (OriDoc.AddFields[i].name = AddField.Name) and (not VarIsNull(OriDoc.AddFields[i].value)) then
                      AddField.OldValue := OriDoc.AddFields[i].value;

                    if (OriDoc.AddFields[i].name = AddField.Name) and (((not VarIsNull(OriDoc.AddFields[i].value)) and (OriDoc.AddFields[i].value <> AddField.Value)) or ((VarIsNull(OriDoc.AddFields[i].value)) and (AddField.Value <> ''))) then
                    begin
                      if ((aAddfieldRights[AddField.ID] and rightWrite) = rightWrite) or ((aAddfieldRights[AddField.ID] and rightModify) = rightModify) then
                      begin //17.05.2018 Ticket 14571
                        AddField.Typ := OriDoc.AddFields[i].Typ;
                        AddField.IndexTableID := OriDoc.AddFields[i].IndexTableID;
                        AddField.ID := OriDoc.AddFields[i].Id;
                        AddField.Options := OriDoc.AddFields[i].options;
                        if ((AddField.Typ in [2, 3]) and ((AddField.options and cAddfieldOptStrict) = cAddfieldOptStrict)) then
                        begin
                          if aAddfields[AddField.ID].items.IndexOf(AddField.Value) <> -1 then
                            AddField.Modified := True
                          else
                          begin
                            AddField.Modified := False;
                            Error := True;
                            ErrorStr := ErrorStr + Format('Das Field %s beim Dokument (ID: %d) konnte nicht gendert werden; ' + #10 + #13, [AddField.DisplayName, OriDoc.ID]);
                          end;
                        end
                        else
                          AddField.Modified := True;
                      end
                      else
                        bitfarmLog.Write(llNormal, ltInfo, 'ReadJobFile - Keine Berechtigung an Zusatzfeld: ID:' + IntToStr(AddField.ID) + ' , Name:' + AddField.Name, ClassName);

                    end;
                    inc(i);
                  end;
                  Doc.AddFields.Add(AddField);
                end
                else
                begin
                  found := False;
                  for k := 0 to Doc.AddFields.Count - 1 do
                  begin
                    if Doc.AddFields[k].name = AddField.Name then
                    begin
                      if ((aAddfieldRights[AddField.ID] and rightWrite) = rightWrite) or ((aAddfieldRights[AddField.ID] and rightModify) = rightModify) then
                      begin  //17.05.2018 Ticket 14571
                        found := True;
                        Doc.AddFields[k].Typ := AddField.Typ;
                        Doc.AddFields[k].value := AddField.Value;
                        Doc.AddFields[k].options := AddField.Options;
                        if ((AddField.Typ in [2, 3]) and ((AddField.options and cAddfieldOptStrict) = cAddfieldOptStrict)) then
                        begin
                          if aAddfields[AddField.ID].items.IndexOf(AddField.Value) <> -1 then
                          begin
                            AddField.Modified := True;
                            Doc.AddFields[k].modified := True;
                          end
                          else
                          begin
                            AddField.Modified := False;
                            Doc.AddFields[k].modified := False;
                            Error := True;
                            ErrorStr := ErrorStr + Format('Das Field %s beim Dokument (ID: %d) konnte nicht gendert werden; ', [AddField.DisplayName, Doc.ID]);
                          end;
                        end
                        else
                          AddField.Modified := True;

                      end;
                      Break;
                    end;
                  end;
                  if (not found) then
                    Doc.AddFields.Add(AddField);
                end;
              end;

              stsWert := ini.ReadString('Document', 'Status', '');
              if stsWert <> '' then
              begin
                tmpqry := TUniQuery.Create(nil);
                try
                  tmpqry.connection := dmMain.cntMain;
                  tmpqry.SQL.Text := 'SELECT distinct(sys_statefieldxs.fieldid), pos, displayname FROM sys_statefieldxs ' + 'left join sys_statefields on sys_statefieldxs.fieldid = sys_statefields.stateid ' + 'where arcid = ' + IntToStr(Doc.Arcid) + ' and (userid in (' + user.HolidayList.CommaText + ') ' + 'or (userid = 0 and groupid in (' + user.GroupList.CommaText + '))) and ((sys_statefields.flags & 2) = 0)' + ' order by pos, displayname;';
//09.07.2024                  tmpqry.SQL.Text := 'SELECT distinct(sys_statefieldxs.fieldid) FROM sys_statefieldxs ' + 'left join sys_statefields on sys_statefieldxs.fieldid = sys_statefields.stateid ' + 'where arcid = ' + IntToStr(Doc.Arcid) + ' and (userid in (' + user.HolidayList.CommaText + ') ' + 'or (userid = 0 and groupid in (' + user.GroupList.CommaText + '))) and ((sys_statefields.flags & 2) = 0)' + ' order by pos, displayname;';
                  tmpqry.Open;
                  if tmpqry.RecordCount > 0 then
                  begin
                    tmpqry.First;
                    while not tmpqry.Eof do
                    begin
                      stateid := tmpqry.FieldByName('fieldid').AsInteger;
      //                if stateid = 1 then   // 'auf Wiedervorlagen' berspringen wir
      //                begin
      //                  qry.Next;
      //                  Continue;
      //                end;
                      found := False;
                      for i := 0 to Doc.StateFields.Count - 1 do
                      begin
                        if Doc.StateFields[i].Id = stateid then
                        begin
                          found := true;
                          if ((aStateFieldRights[stateid] and rightWrite) = rightWrite) or ((aStateFieldRights[stateid] and rightModify) = rightModify) then
                          begin //17.05.2018 Ticket 14571
                            Doc.StateFields[i].value := False;
                            //Doc.StateFields[i].modified := True;
                          end;
                          Break;
                        end;
                      end;

                      if not found then
                      begin
                        Sts := TbfaStateField.Create;
                        Sts.Clone(aStatefields[stateid]);
                        if ((aStateFieldRights[stateid] and rightWrite) = rightWrite) or ((aStateFieldRights[stateid] and rightModify) = rightModify) then
                        begin //17.05.2018 Ticket 14571
                          Sts.Value := False;
                          //Sts.Modified := True;
                        end;
                        Doc.StateFields.Add(Sts);
                      end;
                      tmpqry.Next;
                    end;
                  end;
                  tmpqry.Close;
                finally
                  FreeAndNil(tmpqry);
                end;

                StsList := TStringList.Create;
                dStslist := TDictionary<Integer, Int64>.Create;
                try
                  StsList.Delimiter := ';';
                  StsList.StrictDelimiter := True;
                  StsList.DelimitedText := stsWert;
                  for i := 0 to StsList.Count - 1 do
                  begin
                    idx := pos(':', StsList[i]);
                    if idx > 0 then
                    begin
                      str := System.Copy(StsList[i], 1, idx - 1);
                      ColID := StrToInt(str);
                      str := System.Copy(StsList[i], idx + 1, Length(StsList[i]));
                      Bitmask := StrToInt64(str);

                      If dStslist.ContainsKey(ColID) then
                      begin
                        dStslist.TryGetValue(ColID, tMask);
                        tMask := tMask+ BitMask;
                        dStslist.AddOrSetValue(ColID, tMask);
                      end else
                        dStslist.Add(ColID, BitMask);
                    end
                    else
                    begin
                      ColID := 0;
                      Bitmask := StrToInt64(StsList[i]);
                      dStslist.Add(ColID, BitMask);
                    end;
                  end;

                  for ColID in dStslist.Keys do
                  begin
                    dStslist.TryGetValue(ColID, BitMask);
                    bitpos := 0;
                    for k := 0 to Doc.StateFields.Count - 1 do
                    begin
                      Inc(bitpos);

                      // Statusfelder die uns nicht betreffen (entwerder ander Indexcolumnid oder Bitmaske die nicht gesetzt werden soll)
                      // berspringen wir

                      if FUseState35 then
                      begin
//                        if (Bitmask and bfaPower(bitpos) = 0) then
//                          Continue;

                        Doc.StateFields[k].value := (Bitmask and bfaPower(bitpos)) = bfaPower(bitpos);
                      end else begin
                        if (Doc.StateFields[k].IndexColumnID <> ColID){ or (Doc.StateFields[k].Bitmask and Bitmask = 0) }then
                          Continue;

                        Doc.StateFields[k].value := ((Bitmask and aStatefields[Doc.StateFields[k].Id].Bitmask) = aStatefields[Doc.StateFields[k].Id].Bitmask);
                      end;

                      if ((aStateFieldRights[Doc.StateFields[k].Id] and rightWrite) = rightWrite) or ((aStateFieldRights[Doc.StateFields[k].Id] and rightModify) = rightModify) then
                      begin //17.05.2018 Ticket 14571
                        Doc.StateFields[k].modified := True;
                      end;
                    end;
                  end;
                finally
                  FreeAndNil(StsList);
                  dStslist.Clear;
                  FreeAndNil(dStslist);
                end;
              end;

              if (OriDoc <> nil) and (OriDoc.ID <> FCurrentContainer[0].Id) then
                FreeAndNil(OriDoc);
            end
            else
            begin
              if (FPreviewContainer.ActiveItem <> pvtViewer) or (CurrentView <> tvkViewer) then
              begin
                frmMainForm.fSkipMaximizeEvent := True;
                try
                  frmMainForm.pnlTreeView.Maximize;
                finally
                  frmMainForm.fSkipMaximizeEvent := False;
                end;
                SetActiveView(AThread, pvtViewer);
              end;

              lsLgrname := ParseSQLString(ini.ReadString('Lager', 'Name', ''));
              lsArcname := ParseSQLString(ini.ReadString('Archiv', 'Name', ''));

              Reset(AThread);
              if lsLgrname <> '' then
              begin
                fSkipAutoDisplay := True; //18.09.2019 Ticket 20560
                try
                  DoChangeArchiveFromProgram(lsLgrname, AThread);
                finally
                  fSkipAutoDisplay := False; //18.09.2019 Ticket 20560
                end;
              end;

              if lsArcname <> '' then
              begin
                fSkipAutoDisplay := True; //18.09.2019 Ticket 20560
                try
                  DoChangeArchiveFromProgram(lsArcname, AThread, TbfaInt64(frmMainForm.FViewerTreeview.Selected.Data^).value);
                finally
                  fSkipAutoDisplay := False; //18.09.2019 Ticket 20560
                end;
              end;

              lsVolltext := ParseSQLString(ini.ReadString('Suche', 'Volltext', ''));
              lsSLW := ParseSQLString(ini.ReadString('Suche', 'Schlagworte', ''));
              lsBenutzer := ParseSQLString(ini.ReadString('Suche', 'Benutzername', ''));
              lsDatumVon := ParseSQLString(ini.ReadString('Suche', 'Datum_von', ''));
              lsDatumBis := ParseSQLString(ini.ReadString('Suche', 'Datum_bis', ''));

              if lsVolltext <> '' then
              begin
                AThread.Synchronize(nil,
                  procedure
                  begin
                    frmMainForm.edtSearchFTX.compEdit.Text := lsVolltext;
                    iFtxFields := ini.ReadInteger('Option', 'VtxundSlw', 0);
                    if iFtxFields = 0 then
                      frmMainForm.tbiSoFTX.Click
                    else if iFtxFields = 1 then
                      frmMainForm.tbiSoFtxTags.Click
                  end);
              end
              else if lsSLW <> '' then
              begin
                AThread.Synchronize(nil,
                  procedure
                  begin
                    frmMainForm.edtSearchFTX.compEdit.Text := lsSLW;
                    iFtxFields := ini.ReadInteger('Option', 'VtxundSlw', 0);
                    if iFtxFields = 0 then
                      frmMainForm.tbiSoFTX.Click
                    else if iFtxFields = 1 then
                      frmMainForm.tbiSoFtxTags.Click
                  end);
              end;
              if lsBenutzer <> '' then
              begin
                AThread.Synchronize(nil,
                  procedure
                  begin
                    frmMainForm.cbxSearchUser.compComboBox.Text := lsBenutzer;
                    frmMainForm.tbiSoUser.Click
                  end);
              end;
              if lsDatumVon <> '' then
              begin
                AThread.Synchronize(nil,
                  procedure
                  begin
                    frmMainForm.dteSearch.compDateLow.Text := lsDatumVon;
                    frmMainForm.tbiSoArchived.Click
                  end);
              end;
              if lsDatumBis <> '' then
              begin
                AThread.Synchronize(nil,
                  procedure
                  begin
                    frmMainForm.dteSearch.compDateHigh.Text := lsDatumBis;
                    frmMainForm.tbiSoArchived.Click
                  end);
              end;

              liFields := ini.ReadInteger('Zusatzfelder', 'Felder', 0);
              for licount := 0 to liFields - 1 do
              begin
                AddField := TbfaAddField.Create;
                try
                  AThread.Synchronize(nil,
                    procedure
                    var
                      l: Integer;
                    begin
                      AddField.Displayname := ParseAddfields(ini.ReadString('Zusatzfelder', 'ZusTitel' + IntToStr(licount + 1), ''));
                      AddField.Name := ParseAddfields(ini.ReadString('Zusatzfelder', 'ZusFeld' + IntToStr(licount + 1), ''));
//07.11.2017 FND Datei leersuche -->
                      if ini.ReadString('Zusatzfelder', 'ZusWert' + IntToStr(licount + 1), '') = '""' then
                        AddField.Value := '""'
                      else
//07.11.2017 FND Datei leersuche <--
                        AddField.Value := ParseAddfields(ini.ReadString('Zusatzfelder', 'ZusWert' + IntToStr(licount + 1), ''));

                      for l := 0 to aCurrentAddfields.Count - 1 do
                      begin
                        if aCurrentAddfields[l].name = AddField.Name then
                        begin
                          if aCurrentAddfields[l].Component <> nil then
                          begin
                            case aCurrentAddfields[l].Typ of
                              0:
                                begin
                                  aCurrentAddfields[l].Component.compEdit.Text := AddField.Value;
                                end;
                              1:
                                begin
                                  aCurrentAddfields[l].Component.compDateLow.Text := AddField.Value;
                                end;
                              2:
                                begin
                                  aCurrentAddfields[l].Component.compComboBox.Text := AddField.Value;
                                end;
                              3:
                                begin
                                  aCurrentAddfields[l].Component.compCheckedCombo.Text := AddField.Value;
                                end;
                              5:
                                begin
                                  aCurrentAddfields[l].Component.compComboBox.Text := AddField.Value;
                                end;
                              6:
                                begin
                                  aCurrentAddfields[l].Component.compSpinEditLow.Text := AddField.Value;
                                end;
                              7:
                                begin
                                  aCurrentAddfields[l].Component.compSpinEditLow.Text := AddField.Value;
                                end;
                              8:
                                begin
                                  aCurrentAddfields[l].Component.compSpinEditLow.Text := AddField.Value;
                                end;
                            end;
//03.11.2017 -->
                            if AddField.Value <> '' then
                            begin
                              aCurrentAddfields[l].ModifiedSearch := True;
                              aCurrentAddfields[l].modified := True;
                              aCurrentAddfields[l].Component.Value := AddField.Value;
                              aCurrentAddfields[l].Component.Modified := True;
                            end;
//03.11.2017 <--

                          end;
                        end;
                      end;
                    end);
                finally
                  FreeAndNil(AddField);
                end;
              end;

              frmMainForm.actSearch.Execute;
            end;

          end;
        except
          on e: exception do
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                BfShowMessage(_('Fehler beim Lesen des Jobfiles: ') + e.Message);
              end);
          end;
        end;

        if (SObj = nil) and (Doc.ID <> -1) then
        begin
          AThread.Synchronize(nil,
            procedure
            var
              m, n, j, lstcount: Integer;
              fnd: Boolean;
            begin
              req := TbfaRequest.Create;
              Lst := TList<TbfaBaseObject>.Create;
              try
                req.ReqType := 'reqSave';
                req.UserID := user.ID;
                req.Profile := Self.Profile;
                req.Parameter := IntToStr(Doc.ID);
                req.Gdocid := Doc.ID;
                req.Lang := Lang;
                for j := 0 to Doc.AddFields.Count - 1 do
                  if Doc.Addfields[j].modified then
                    Lst.Add(Doc.Addfields[j]);
                for j := 0 to Doc.StateFields.Count - 1 do
                  if Doc.Statefields[j].modified then
                    Lst.Add(Doc.Statefields[j]);

                if Lst.Count > 0 then
                begin
                  req.Data := Lst;
                  MainSocket.SendRequestToServer(req);
                  req := MainSocket.ReceiveResponse;

                  if req = nil then
                    Exit;

                  if req.ReqType = 'respAuthError' then
                  begin
                    BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'));
                    UserAction := CreateUserAction;
                    UserAction^.ActionName := 'actRelogin';
                    MainThread.Add(UserAction);
                    Exit;
                  end
                  else if (req.ReqType = 'respDenied') or (req.ReqType = 'respSaveDenied') then
                  begin
                    BfShowMessage(_('Das Dokument ist schon von einem anderen Benutzer in Bearbeitung gesetzt.'));
                    Exit;
                  end
                  else if (req.ReqType = 'respError') or (req.ReqType = 'respSaveError') then
                  begin
                    BfShowMessage(_('Fehler beim Speichern.') + #13#10 + req.DataString);
                    Exit;
                  end;
                end;
                ReloadLinks(Doc); //04.06.2018 Ticket 14692
              finally
                FreeAndNil(Lst);
                FreeAndNil(req);
              end;

              if Length(Doc.DocLinkList) > 0 then // muss aus allen verknpfung gelscht werden
              begin
                for m := Low(Doc.DocLinkList) to High(Doc.DocLinkList) do
                begin
                  found := False;
                  for n := 0 to Doc.AddFields.Count - 1 do
                  begin
                    if ((Doc.Addfields[n].options and 2) = 2) and (Doc.Addfields[n].value = Doc.DocLinkList[m].Refname) then
                    begin
                      found := True;
                      Break;
                    end;
                  end;

                  if found then  // haben wir ein verknpfungszusatzfeld mit einem wert, welches in der aktuellen DocLinkList zu finden ist
                    Continue;    // dann drfen wir diese verknpfung nicht wieder lschen

                  if (slRef.Count = 0) or (slRef.IndexOf(Doc.DocLinkList[m].Refname) = -1) then  //04.06.2018 Ticket 14692
                  begin
                    req := TbfaRequest.Create;
                    try
                      req.ReqType := 'reqRemoveLink';
                      req.UserID := user.ID;
                      req.Profile := Self.Profile;
                      req.Parameter := Doc.DocLinkList[m].Refname + ';' + IntToStr(Doc.ID);
                      req.Lang := Lang;
                      MainSocket.SendRequestToServer(req);

                      req := MainSocket.ReceiveResponse;
                      if req = nil then
                        Exit;

                  //27.11.2018 Ticket 16957 -->
                          if req.ReqType = 'respAuthError' then
                      begin
                        BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'));
                        UserAction := CreateUserAction;
                        UserAction^.ActionName := 'actRelogin';
                        MainThread.Add(UserAction);
                        Exit;
                      end
                      else
                  //27.11.2018 Ticket 16957 <--
                        if req.ReqType = 'respError' then
                        BfShowMessage(_('Das Dokument konnte nicht aus der Verknpfung entfernt werden'));

                    finally
                      FreeAndNil(req);
                    end;
                  end;
                end;
              end;

              if slRef.Count > 0 then
              begin
                for m := 0 to slRef.Count - 1 do
                begin
//04.06.2018 Ticket 14692 -->
                  fnd := False;
                  if (Length(Doc.DocLinkList) > 0) then
                  begin
                    for lstcount := Low(Doc.DocLinkList) to High(Doc.DocLinkList) do
                    begin
                      if Doc.DocLinkList[lstcount].Refname = slRef[m] then
                      begin
                        fnd := True;
                        Break;
                      end;

                      // wir haben ein Verknpfungsfeld, dessen Wert sich gendert hat und der alte Wert ist in der Liste der Links aus dem Jobfile
                      for n := 0 to Doc.AddFields.Count - 1 do
                      begin
                        if ((Doc.Addfields[n].options and 2) = 2) and (Doc.Addfields[n].OldValue <> Doc.Addfields[n].value) and (Doc.Addfields[n].OldValue = slRef[m]) then
                        begin
                          fnd := True;  // das fgen wir nicht wieder hinzu
                          Break;
                        end;
                      end;
                    end;
                  end;
                  if (not fnd) then
                  begin
//04.06.2018 Ticket 14692 <--
                    req := TbfaRequest.Create;
                    try
                      req.ReqType := 'reqCreateNewLink';
                      req.UserID := user.ID;
                      req.Profile := Self.Profile;
                      req.Parameter := slRef[m] + ';' + IntToStr(Doc.ID);
                      req.Lang := Lang;
                      MainSocket.SendRequestToServer(req);

                      req := MainSocket.ReceiveResponse;
                      if req = nil then
                        Exit;

                  //27.11.2018 Ticket 16957 -->
                          if req.ReqType = 'respAuthError' then
                      begin
                        BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'));
                        UserAction := CreateUserAction;
                        UserAction^.ActionName := 'actRelogin';
                        MainThread.Add(UserAction);
                        Exit;
                      end
                      else
                  //27.11.2018 Ticket 16957 <--
                        if req.ReqType = 'respError' then
                        BfShowMessage(_('Die Verknpfung konnte nicht angelegt werden.'))

                    finally
                      FreeAndNil(req);
                    end;
                  end;
                end;
              end;

              if Doc.Modified then
              begin
                req := TbfaRequest.Create;
                try
                  req.ReqType := 'reqSaveDocName';
                  req.UserID := user.ID;
                  req.Profile := Self.Profile;
                  req.Gdocid := Doc.ID;
                  req.DataString := Doc.DocName;
                  req.Parameter := IntToStr(Doc.ID);
                  req.Lang := Lang;
                  MainSocket.SendRequestToServer(req);

                  req := MainSocket.ReceiveResponse;
                  if req = nil then
                    Exit;

                  //27.11.2018 Ticket 16957 -->
                  if req.ReqType = 'respAuthError' then
                  begin
                    BfShowMessage(_('Sie haben fr diesen Vorgang keine Berechtigung. Bitte melden Sie sich erneut an.'));
                    UserAction := CreateUserAction;
                    UserAction^.ActionName := 'actRelogin';
                    MainThread.Add(UserAction);
                    Exit;
                  end
                  else
                  //27.11.2018 Ticket 16957 <--
                    if req.ReqType = 'respError' then
                    BfShowMessage(_('Der Dokumenttitel konnte nicht gendert werden.') + #13#10 + req.DataString)

                finally
                  FreeAndNil(req);
                end;
              end;
            end);

          if not FDoSave then //27.07.2017 SavePlugin
            RefreshDoc(AThread);
        end;

      finally
        if Assigned(ini) then
          FreeAndNil(ini);
        if Assigned(slRef) then
          FreeAndNil(slRef);
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'ReadJobFile:' + fsDocname, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ReadJobFile:' + fsDocname, Classname);
  end
end;

//procedure TbfaApplication.ReadFNDFile(AThread: TThread; FileName: WideString);
//var
//  ini: TIniFile;
//  slRef: TStringList;
//  iCount, //litimeroptionen,
//  iFtxFields, i, j, k, licount, liArcid, liDocid, liTyp, liGdocid, liOldStatus,
//  liChanged, liRef, liFields, ColID, Bitmask, idx: integer;
//  lsProfil, lsLgrname, lsArcname, lsTblname, lsDocid, lsTitel, lsOldTitel, lsTxt,
//  lsDocloc, lsExtloc, lsOriloc, lsBenutzer, lsVolltext, lsSLW, sStatus, lsZielname,
//  lsDatumVon, lsDatumBis, stsWert: string;
//  AddField: TbfaAddField;
//  OriDoc: TbfaDocument;
//  req: TbfaRequest;
//  UserAction: PUserAction;
//  msg, param, str, Filter : string;
//  Lst: TList<TbfaBaseObject>;
//  DocLst: TList<TbfaDocument>;
//  StsList: TStringList;
//  found : Boolean;
//  Sts: TbfaStateField;
//  StateList: TList<TbfaStateField>;
//  tmpqry: TuniQuery;
//  stateid, bitpos: Integer;

//begin
//06.12.2018 Sollte noch implementiert werden
//
//  bitfarmLog.DebugBegin(llDebug, 'ReadFNDFile:' + FileName, Classname);
//  try
//    try
//      slRef := TStringList.Create;
//      ini := TIniFile.Create(FileName);
//      try
//
//        if (FPreviewContainer.ActiveItem <> pvtViewer) or (CurrentView <> tvkViewer) then
//        begin
//          frmMainForm.fSkipMaximizeEvent := True;
//          try
//            frmMainForm.pnlTreeView.Maximize;
//          finally
//            frmMainForm.fSkipMaximizeEvent := False;
//          end;
//          SetActiveView(AThread, pvtViewer);
//        end;
//
//        lsLgrname := ParseSQLString(ini.ReadString('Lager', 'Name', ''));
//        lsArcname := ParseSQLString(ini.ReadString('Archiv', 'Name', ''));
//
//        Reset(AThread);
//        if lsLgrname <> '' then
//          DoChangeArchiveFromProgram(lsLgrname, AThread);
//
//        if lsArcname <> '' then
//          DoChangeArchiveFromProgram(lsArcname, AThread, TbfaInt64(frmMainForm.FViewerTreeview.Selected.Data^).value);
//
//        lsVolltext := ParseSQLString(ini.ReadString('Suche', 'Volltext', ''));
//        lsSLW := ParseSQLString(ini.ReadString('Suche', 'Schlagworte', ''));
//        lsBenutzer := ParseSQLString(ini.ReadString('Suche', 'Benutzername', ''));
//        lsDatumVon := ParseSQLString(ini.ReadString('Suche', 'Datum_von', ''));
//        lsDatumBis := ParseSQLString(ini.ReadString('Suche', 'Datum_bis', ''));
//
//        if lsVolltext <> '' then
//        begin
//          AThread.Synchronize(nil,
//            procedure
//            begin
//              frmMainForm.edtSearchFTX.compEdit.Text := lsVolltext;
//              iFtxFields := ini.ReadInteger('Option', 'VtxundSlw', 0);
//              if iFtxFields = 0 then
//                frmMainForm.tbiSoFTX.Click
//              else if iFtxFields = 1 then
//                frmMainForm.tbiSoFtxTags.Click
//            end);
//        end
//        else if lsSLW <> '' then
//        begin
//          AThread.Synchronize(nil,
//            procedure
//            begin
//              frmMainForm.edtSearchFTX.compEdit.Text := lsSLW;
//              iFtxFields := ini.ReadInteger('Option', 'VtxundSlw', 0);
//              if iFtxFields = 0 then
//                frmMainForm.tbiSoFTX.Click
//              else if iFtxFields = 1 then
//                frmMainForm.tbiSoFtxTags.Click
//            end);
//        end;
//        if lsBenutzer <> '' then
//        begin
//          AThread.Synchronize(nil,
//            procedure
//            begin
//              frmMainForm.cbxSearchUser.compComboBox.Text := lsBenutzer;
//              frmMainForm.tbiSoUser.Click
//            end);
//        end;
//        if lsDatumVon <> '' then
//        begin
//          AThread.Synchronize(nil,
//            procedure
//            begin
//              frmMainForm.dteSearch.compDateLow.Text := lsDatumVon;
//              frmMainForm.tbiSoArchived.Click
//            end);
//        end;
//        if lsDatumBis <> '' then
//        begin
//          AThread.Synchronize(nil,
//            procedure
//            begin
//              frmMainForm.dteSearch.compDateHigh.Text := lsDatumBis;
//              frmMainForm.tbiSoArchived.Click
//            end);
//        end;
//
//        liFields := ini.ReadInteger('Zusatzfelder', 'Felder', 0);
//        for licount := 0 to liFields - 1 do
//        begin
//          AddField := TbfaAddField.Create;
//          try
//            AThread.Synchronize(nil,
//              procedure
//              var
//                l: Integer;
//              begin
//                AddField.Displayname := ParseAddfields(ini.ReadString('Zusatzfelder', 'ZusTitel' + IntToStr(licount + 1), ''));
//                AddField.Name := ParseAddfields(ini.ReadString('Zusatzfelder', 'ZusFeld' + IntToStr(licount + 1), ''));
// // 07.11.2017 FND Datei leersuche -->
//                if ini.ReadString('Zusatzfelder', 'ZusWert' + IntToStr(licount + 1), '') = '""' then
//                  AddField.Value := '""'
//                else
// // 07.11.2017 FND Datei leersuche <--
//                  AddField.Value := ParseAddfields(ini.ReadString('Zusatzfelder', 'ZusWert' + IntToStr(licount + 1), ''));
//
//                for l := 0 to aCurrentAddfields.Count - 1 do
//                begin
//                  if aCurrentAddfields[l].name = AddField.Name then
//                  begin
//                    if aCurrentAddfields[l].Component <> nil then
//                    begin
//                      case aCurrentAddfields[l].Typ of
//                        0:
//                          begin
//                            aCurrentAddfields[l].Component.compEdit.Text := AddField.Value;
//                          end;
//                        1:
//                          begin
//                            aCurrentAddfields[l].Component.compDateLow.Text := AddField.Value;
//                          end;
//                        2:
//                          begin
//                            aCurrentAddfields[l].Component.compComboBox.Text := AddField.Value;
//                          end;
//                        3:
//                          begin
//                            aCurrentAddfields[l].Component.compCheckedCombo.Text := AddField.Value;
//                          end;
//                        5:
//                          begin
//                            aCurrentAddfields[l].Component.compComboBox.Text := AddField.Value;
//                          end;
//                        6:
//                          begin
//                            aCurrentAddfields[l].Component.compSpinEditLow.Text := AddField.Value;
//                          end;
//                        7:
//                          begin
//                            aCurrentAddfields[l].Component.compSpinEditLow.Text := AddField.Value;
//                          end;
//                        8:
//                          begin
//                            aCurrentAddfields[l].Component.compSpinEditLow.Text := AddField.Value;
//                          end;
//                      end;
// // 03.11.2017 -->
//                      if AddField.Value <> '' then
//                      begin
//                        aCurrentAddfields[l].ModifiedSearch := True;
//                        aCurrentAddfields[l].modified := True;
//                        aCurrentAddfields[l].Component.Value := AddField.Value;
//                        aCurrentAddfields[l].Component.Modified := True;
//                      end;
// // 03.11.2017 <--
//
//                    end;
//                  end;
//                end;
//              end);
//          finally
//            FreeAndNil(AddField);
//          end;
//        end;
//
//            frmMainForm.actSearch.Execute;
//      finally
//        if Assigned(ini) then
//          FreeAndNil(ini);
//        if Assigned(slRef) then
//          FreeAndNil(slRef);
//      end;
//
//    except
//      bitfarmLog.Write(llNormal, ltException, 'ReadFNDFile:' + FileName, ClassName);
//    end;
//  finally
//    bitfarmLog.DebugEnd(llDebug, 'ReadFNDFile:' + FileName, Classname);
//  end
//end;

// SJ 20.11.2020 - nowhere used - only MainForm-function called
//procedure TbfaApplication.SetNavigationPanels;
//begin
//  bitfarmLog.DebugBegin(llDebug, 'SetNavigationPanels', Classname);
//  try
//    try
//      frmMainForm.SetNavigationPanels;
//    except
//      bitfarmLog.Write(llNormal, ltException, 'SetNavigationPanels', ClassName);
//    end;
//  finally
//    bitfarmLog.DebugEnd(llDebug, 'SetNavigationPanels', Classname);
//  end;
//end;
// SJ 20.11.2020

procedure TbfaApplication.Alt1(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'Alt1', Classname);
  ViewChanging := True;
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          if not frmMainForm.pnlTreeView.Maximized then
            frmMainForm.pnlTreeView.Maximize;
//          frmMainForm.SetNavigationPanelsTabStop;
//          frmMainForm.FViewerTreeview.TabStop := True;
          frmMainForm.FViewerTreeview.SetFocus;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'Alt1', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'Alt1', Classname);
  end;
end;

procedure TbfaApplication.Alt2(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'Alt2', Classname);
  ViewChanging := True;
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          if not frmMainForm.pnlImporter.Maximized then
            frmMainForm.pnlImporter.Maximize;
//          frmMainForm.SetNavigationPanelsTabStop;
//          frmMainForm.FImporterTreeview.TabStop := True;
          frmMainForm.FImporterTreeview.SetFocus;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'Alt2', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'Alt2', Classname);
  end;
end;

procedure TbfaApplication.Alt3(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'Alt3', Classname);
  ViewChanging := True;
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          if not frmMainForm.pnlResubmission.Maximized then
            frmMainForm.pnlResubmission.Maximize;
//          frmMainForm.SetNavigationPanelsTabStop;
//          frmMainForm.SetTabStop(frmMainForm.fraResub, True);
          frmMainForm.fraResub.btnMyTasks.SetFocus;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'Alt3', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'Alt3', Classname);
  end;
end;

procedure TbfaApplication.Alt4(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'Alt4', Classname);
  ViewChanging := True;
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          if not frmMainForm.pnlFavorites.Maximized then
            frmMainForm.pnlFavorites.Maximize;
//          frmMainForm.trvBookmarks.TabStop := True;
          frmMainForm.trvBookmarks.SetFocus;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'Alt4', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'Alt4', Classname);
  end;
end;

procedure TbfaApplication.Alt5(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'Alt5', Classname);
  ViewChanging := True;
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          if not frmMainForm.pnlWorkspace.Maximize then
            frmMainForm.pnlWorkspace.Maximize;
//          frmMainForm.SetNavigationPanelsTabStop;

          frmMainForm.pnlWorkspace.SetFocus;

//          if bitfarmApp.PreviewContainer.WorkplaceItem.Preview.PreviewKind = pvkMulti then
//          begin
//            if bitfarmApp.PreviewContainer.WorkplaceItem.Preview.MultiView.Visible then
//              bitfarmApp.PreviewContainer.WorkplaceItem.Preview.MultiView.SetFocus;
//          end
//          else
//          begin
//            if bitfarmApp.PreviewContainer.WorkplaceItem.Preview.SingleView.Visible then
//              bitfarmApp.PreviewContainer.WorkplaceItem.Preview.SingleView.SetFocus;
//          end;
            end);
    except
      bitfarmLog.Write(llNormal, ltException, 'Alt5', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'Alt5', Classname);
  end;
end;

procedure TbfaApplication.Alt6(AThread: TThread);       // Search Tab
begin
  bitfarmLog.DebugBegin(llDebug, 'Alt6', Classname);
  ViewChanging := True;
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          if (CurrentView <> TbfaViewKind(tvkWorkplace)) then
          begin
            frmMainForm.tcSearch.Toolbar.BeginUpdate;
            try
              frmMainForm.tcSearch.ActiveTabIndex := 0;
            finally
              frmMainForm.tcSearch.Toolbar.EndUpdate;
            end;
            if (CurrentView <> TbfaViewKind(tvkImporter)) then
              if not ActivePreview.Floating then
                frmMainForm.edtSearchFTX.compEdit.SetFocus;
          end;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'Alt6', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'Alt6', Classname);
  end;
end;

procedure TbfaApplication.Alt7(AThread: TThread);   // Zusatzfeldtab
begin
  bitfarmLog.DebugBegin(llDebug, 'Alt7', Classname);
  ViewChanging := True;
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          if (CurrentView <> TbfaViewKind(tvkWorkplace)) then
          begin
            frmMainForm.tcSearch.Toolbar.BeginUpdate;
            try
              if frmMainForm.tcSearch.ActiveTabIndex = 1 then
              begin
                if frmMainForm.tabSearchAddfields2.Visible then //BuchungsgridTab nicht immer sichtbar
                  frmMainForm.tcSearch.ActiveTabIndex := 2;
              end
              else if frmMainForm.tcSearch.ActiveTabIndex = 2 then
                frmMainForm.tcSearch.ActiveTabIndex := 1
              else
                frmMainForm.tcSearch.ActiveTabIndex := 1;

            finally
              frmMainForm.tcSearch.Toolbar.EndUpdate;
            end;
            if not ActivePreview.Floating then
            begin
              if frmMainForm.tcSearch.ActiveTabIndex = 1 then
              begin
              if (frmMainForm.scrbxViewerAddfields.ComponentCount > 0) and (frmMainForm.Activecontrol <> nil) then
              begin
                if not (Assigned(frmMainForm.Activecontrol) and Assigned(frmMainForm.Activecontrol.parent) and ((Assigned(frmMainForm.Activecontrol.parent.parent) and (frmMainForm.Activecontrol.parent.parent.Name = 'scrbxViewerAddfields'))) or //23.11.2018 Ticket 16709
                  ((Assigned(frmMainForm.Activecontrol.parent.parent.Parent) and (frmMainForm.Activecontrol.parent.parent.Parent.Name = 'scrbxViewerAddfields')))) then //24.03.2017 Ticket 10191
                  if frmMainForm.scrbxViewerAddfields.Components[0] is TWinControl then
                    TWinControl(TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[0]).comp).Setfocus;
              end;
              end else begin
                if (frmMainForm.scrbxAddfields2.ComponentCount > 0) and (frmMainForm.Activecontrol <> nil) then
                begin
                  if not (Assigned(frmMainForm.Activecontrol) and Assigned(frmMainForm.Activecontrol.parent) and ((Assigned(frmMainForm.Activecontrol.parent.parent) and (frmMainForm.Activecontrol.parent.parent.Name = 'scrbxAddfields2'))) or //23.11.2018 Ticket 16709
                    ((Assigned(frmMainForm.Activecontrol.parent.parent.Parent) and (frmMainForm.Activecontrol.parent.parent.Parent.Name = 'scrbxAddfields2')))) then //24.03.2017 Ticket 10191
                    if frmMainForm.scrbxAddfields2.Components[0] is TWinControl then
                    begin
                      if (TBfaAddfieldComp(frmMainForm.scrbxAddfields2.Components[0]).AddfieldType = zfld13_Grid)
                        and TBfaAddfieldComp(frmMainForm.scrbxAddfields2.Components[0]).Editmode then
                        TBfaAddfieldComp(frmMainForm.scrbxAddfields2.Components[0]).compGrid.Grid.SetFocus
                      else
                        TWinControl(TBfaAddfieldComp(frmMainForm.scrbxAddfields2.Components[0]).comp).Setfocus;
                    end
                end;
              end;
            end;
          end;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'Alt7', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'Alt7', Classname);
  end;
end;

procedure TbfaApplication.SetFocusToFirstAddfield(AThread: TThread);   // Zusatzfeldtab
begin
  bitfarmLog.DebugBegin(llDebug, 'SetFocusToFirstAddfield', Classname);
  ViewChanging := True;
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          if (CurrentView <> TbfaViewKind(tvkWorkplace)) then
          begin
            if not ActivePreview.Floating then
            begin
              if frmMainForm.tcSearch.ActiveTabIndex = 1 then
              begin
                if (frmMainForm.scrbxViewerAddfields.ComponentCount > 0) and (frmMainForm.Activecontrol <> nil) then
                begin
                  if not (Assigned(frmMainForm.Activecontrol) and Assigned(frmMainForm.Activecontrol.parent) and ((Assigned(frmMainForm.Activecontrol.parent.parent) and (frmMainForm.Activecontrol.parent.parent.Name = 'scrbxViewerAddfields'))) or //23.11.2018 Ticket 16709
                    ((Assigned(frmMainForm.Activecontrol.parent.parent.Parent) and (frmMainForm.Activecontrol.parent.parent.Parent.Name = 'scrbxViewerAddfields')))) then //24.03.2017 Ticket 10191
                    if frmMainForm.scrbxViewerAddfields.Components[0] is TWinControl then
                    begin
                      if (TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[0]).AddfieldType = zfld13_Grid)
                        and TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[0]).Editmode then
                        TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[0]).compGrid.Grid.SetFocus
                      else if (frmMainForm.scrbxViewerAddfields.Components[0] is TWinControl) and
                        (TWinControl(TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[0]).comp) <> nil) and //06.02.2023
                        (TWinControl(TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[0]).comp).Enabled) and
                        (TWinControl(TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[0]).comp).Visible) then
                      TWinControl(TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[0]).comp).Setfocus;
                    end;
                end;
              end else begin
                if (frmMainForm.scrbxAddfields2.ComponentCount > 0) and (frmMainForm.Activecontrol <> nil) then
                begin
                  if not (Assigned(frmMainForm.Activecontrol) and Assigned(frmMainForm.Activecontrol.parent) and ((Assigned(frmMainForm.Activecontrol.parent.parent) and (frmMainForm.Activecontrol.parent.parent.Name = 'scrbxAddfields2'))) or //23.11.2018 Ticket 16709
                    ((Assigned(frmMainForm.Activecontrol.parent.parent.Parent) and (frmMainForm.Activecontrol.parent.parent.Parent.Name = 'scrbxAddfields2')))) then //24.03.2017 Ticket 10191
                    if frmMainForm.scrbxAddfields2.Components[0] is TWinControl then
                    begin
                      if (TBfaAddfieldComp(frmMainForm.scrbxAddfields2.Components[0]).AddfieldType = zfld13_Grid)
                        and TBfaAddfieldComp(frmMainForm.scrbxAddfields2.Components[0]).Editmode then
                        TBfaAddfieldComp(frmMainForm.scrbxAddfields2.Components[0]).compGrid.Grid.SetFocus
                      else if (frmMainForm.scrbxViewerAddfields.Components[0] is TWinControl) and
                        (TWinControl(TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[0]).comp).Enabled) and
                        (TWinControl(TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[0]).comp).Visible) then
                        TWinControl(TBfaAddfieldComp(frmMainForm.scrbxAddfields2.Components[0]).comp).Setfocus;
                    end
                end;
              end;
            end;
          end;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'SetFocusToFirstAddfield', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetFocusToFirstAddfield', Classname);
  end;
end;

procedure TbfaApplication.Alt8(AThread: TThread);    // Verknpfungstab
begin
  bitfarmLog.DebugBegin(llDebug, 'Alt8', Classname);
  ViewChanging := True;
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          if frmMainForm.tabSearchLinks.Visible then
          begin
            if (CurrentView <> TbfaViewKind(tvkWorkplace)) then
            begin
              frmMainForm.tcSearch.Toolbar.BeginUpdate;
              try
                frmMainForm.tcSearch.ActiveTabIndex := 3;
              finally
                frmMainForm.tcSearch.Toolbar.EndUpdate;
              end;
              if not ActivePreview.Floating then
              begin
                if frmMainForm.tabSearchLinks.ComponentCount > 0 then
                begin
                  if frmMainForm.tabSearchLinks.Components[0] is TWinControl then
                    TWinControl(frmMainForm.tabSearchLinks.Components[0]).Setfocus;
                end;
              end;
            end;
          end
          else
            frmMainForm.actAlt6.Execute;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'Alt8', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'Alt8', Classname);
  end;
end;

procedure TbfaApplication.Alt9(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'Alt9', Classname);
  ViewChanging := True;
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          if ActivePreview <> nil then
          begin
            if ActivePreview.PreviewKind = pvkMulti then
            begin
              ActivePreview.MultiView.SetFocus
            end
            else if ActivePreview.PreviewKind = pvkMultiSingle then
            begin
              ActivePreview.ThumbnailView.SetFocus
            end
            else if ActivePreview.PreviewKind = pvkSingle then
            begin
              ActivePreview.ThumbnailView.SetFocus;
            end;
          end;

        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'Alt9', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'Alt9', Classname);
  end;
end;

procedure TbfaApplication.Alt0(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'Alt0', Classname);
  ViewChanging := True;
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          if bitfarmApp.User.isAdmin and frmMainForm.pnlAdmin.Visible then
          begin
            if not frmMainForm.pnlAdmin.Maximized then
              frmMainForm.pnlAdmin.Maximize;
//            frmMainForm.SetNavigationPanelsTabStop;
            frmMainForm.FAdminTreeview.TabStop := True;
            frmMainForm.FAdminTreeview.SetFocus;
          end;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'Alt0', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'Alt0', Classname);
  end;
end;

procedure TbfaApplication.F4(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'F4', Classname);
  ViewChanging := True;
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          if not frmMainForm.grdResultlistDevEx.Focused then
            frmMainForm.grdResultlistDevEx.SetFocus
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'F4', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'F4', Classname);
  end;
end;

procedure TbfaApplication.F11(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'F11', Classname);
  try
    try
      frmQuickPreview.CurrentLayer := -1;
      frmQuickPreview.CurrentLayerRights := -1;
      ShowQuickPreview(AThread);
    except
      bitfarmLog.Write(llNormal, ltException, 'F11', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'F11', Classname);
  end;
end;

procedure TbfaApplication.AltF11(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'AltF11', Classname);
  try
    try
      frmQuickPreview.CurrentLayer := GetActivePreview.CurrentLayer;
      frmQuickPreview.CurrentLayerRights := GetActivePreview.CurrentLayerRights;
      ShowQuickPreview(AThread);
    except
      bitfarmLog.Write(llNormal, ltException, 'AltF11', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'AltF11', Classname);
  end;
end;

procedure TbfaApplication.ShowQuickPreview(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'ShowQuickPreview', Classname);
  try
    try
      AThread.Synchronize(nil,
        procedure
        var
          iebmp2: TIEBitmap;
          PCount: Integer;
        begin
          if (FCurrentContainer.Count > 0) and (FCurrentContainer[0].haspreview) then
          begin
            frmQuickPreview.imgQuickPreview.Clear;
            frmQuickPreview.imgQuickPreview.Blank;
            frmQuickPreview.imgQuickPreview.RemoveAllObjects;
            frmQuickPreview.imgQuickPreview.MouseInteractVt := [];
            frmQuickPreview.imgQuickPreview.MouseInteract := [];
            if GetActivePreview.PreviewKind = pvkMulti then
            begin
              if GetActivePreview.previewToolWindow.Visible then
                PCount := GetActivePreview.ThumbnailView.SelectedImage
              else
                PCount := 0
            end
            else
              PCount := GetActivePreview.SingleView.img_DocView.IO.Params.ImageIndex;

//02.11.2018 Ticket 16617 -->
//            frmQuickPreview.imgQuickPreview.IO.LoadFromStream(FCurrentContainer[0].DocStream);

            if (FCurrentContainer[0].ScanPoolView <> nil) and FCurrentContainer[0].ScanPoolViewLoaded then
            begin
              frmQuickPreview.imgQuickPreview.IO.Params.ImageIndex := 0;
              frmQuickPreview.ImgCount := 0;
              frmQuickPreview.ImageIdx := PCount;
              iebmp2 := TIEBitmap.Create;
              try
                FCurrentContainer[0].ScanPoolView.CopyToIEBitmap(frmQuickPreview.ImageIdx, iebmp2);
                {$IFDEF ImageEN1140}
                frmQuickPreview.imgQuickPreview.Bitmap.Assign(iebmp2.VclBitmap);
                {$ELSE}
                frmQuickPreview.imgQuickPreview.IO.Bitmap.Assign(iebmp2.VclBitmap);
                {$ENDIF}
              finally
                FreeandNil(iebmp2);
              end;
              frmQuickPreview.imgQuickPreview.IO.Params.Width := frmQuickPreview.imgQuickPreview.Bitmap.Width;
              frmQuickPreview.imgQuickPreview.IO.Params.Height := frmQuickPreview.imgQuickPreview.Bitmap.Height;
              frmQuickPreview.ImgCount := FCurrentContainer[0].ScanPoolView.ImageCount;
            end else
            begin
              //15.10.2024 SD <--bfacrm:ticket__show__39532
              var i: integer;
              frmQuickPreview.DocumentList := SelectedRowsToList(frmMainForm.grdResultlistDevExView);
              frmQuickPreview.DocIdx := 0;
              for i := 0 to frmQuickPreview.DocumentList.Count - 1  do
              begin
                  if frmQuickPreview.DocumentList[i].ID = FCurrentContainer[0].ID then
                  begin
                    frmQuickPreview.DocIdx := i;
                  end;
                  bitfarmApp.LoadDocumentViaSocket(frmQuickPreview.DocumentList[i], 'base;fields;paths;links;iev;text;svn', nil);
              end;
              if frmQuickPreview.DocIdx <> 0 then
              begin
                frmQuickPreview.DocIdx := 0;
                FCurrentContainer[0] := frmQuickPreview.DocumentList[0];
                frmQuickPreview.imgQuickPreview.IO.Params.ImageIndex := 0;
                frmQuickPreview.ImageIdx := 0;
              end
              else
              //15.10.2024 SD <--bfacrm:ticket__show__39532
              begin
                frmQuickPreview.imgQuickPreview.IO.Params.ImageIndex := PCount;
                frmQuickPreview.ImageIdx := PCount;
              end;
              FCurrentContainer[0].DocStream.Position := 0;
              frmQuickPreview.imgQuickPreview.IO.LoadFromStream(FCurrentContainer[0].DocStream);
              frmQuickPreview.ImgCount := frmQuickPreview.imgQuickPreview.IO.Params.ImageCount;
            end;
//02.11.2018 Ticket 16617 <--

            if frmQuickPreview.ImgCount > 1 then
            begin
              frmQuickPreview.lblPageCount.Caption := IntToStr(PCount + 1) + ' / ' + IntToStr(frmQuickPreview.ImgCount);
              frmQuickPreview.lblPageCount.Visible := True;
            end
            else
            begin
              frmQuickPreview.lblPageCount.Caption := '';
              frmQuickPreview.lblPageCount.Visible := False;
            end;

            ShowQuickPreviewAnnos;
            frmQuickPreview.ShowModal;
          end;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'ShowQuickPreview', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ShowQuickPreview', Classname);
  end;
end;

procedure TbfaApplication.ShowQuickPreviewAnnos;
var
  idx: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'ShowQuickPreviewAnnos', Classname);
  try
    try
      if ((GetActivePreview.bfaTlbPreview.mnuPublicAnno.Enabled and GetActivePreview.bfaTlbPreview.mnuPublicAnno.Checked) or (GetActivePreview.bfaTlbPreview.mnuPrivateAnno.Enabled and GetActivePreview.bfaTlbPreview.mnuPrivateAnno.Checked) and (frmQuickPreview.CurrentLayer <> -1)) and (((frmQuickPreview.CurrentLayer = 0) and (((frmQuickPreview.CurrentLayerRights and (rightARead or rightAWrite or rightAModify)) > 0) or (FCurrentContainer[0].Id = -1)  //23.08.2017 Im Importer wird sonst nicht dargestellt
        )) or (frmQuickPreview.CurrentLayer > 0) and (((frmQuickPreview.CurrentLayerRights and (rightAPRead or rightAPWrite or rightAPModify)) > 0) or (FCurrentContainer[0].Id = -1)  //23.08.2017 Im Importer wird sonst nicht dargestellt
        )) then
      begin
        try
          FCurrentContainer[0].GetAnnotation(frmQuickPreview.imgQuickPreview.IO.Params.ImageIndex, frmQuickPreview.CurrentLayer, idx);
          if idx <> -1 then
          begin
            FCurrentContainer[0].Annotations[idx].AnnoStream.Position := 0;
            frmQuickPreview.imgQuickPreview.LoadFromStreamIEV(FCurrentContainer[0].Annotations[idx].AnnoStream);
            FCurrentContainer[0].Annotations[idx].AnnoStream.Position := 0;
            frmQuickPreview.imgQuickPreview.Update;
          end;

        except
          on e: Exception do
          begin
            bitfarmLog.Write(llNormal, ltException, _('Fehler beim Laden der Anmerkung: ') + e.message, 'frmQuickPreview');
            BfShowMessage(_('Fehler beim Laden der Anmerkung: ') + e.message);
          end;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'ShowQuickPreviewAnnos', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ShowQuickPreviewAnnos', Classname);
  end;
end;

procedure TbfaApplication.CtrlF(AThread: TThread; AltKey: Boolean = False; SkipClearSearch: Boolean = False);
var
  DoMax, DoChange: Boolean;
  Suchstring: WideString;
begin
  bitfarmLog.DebugBegin(llDebug, 'CtrlF', Classname);
  ViewChanging := True;
  try
    try
      DoMax := not frmMainForm.pnlTreeView.Maximized;
      DoChange := (GetActivePreview <> FPreviewContainer.ViewerItem.Preview);
//      if //28.09.2021 Ticket 28364 (not DoMax) sollte eigentlich umgekehrt sein
//        DoMax
//        or DoChange
//      then
//        bitfarmApp.SetActiveView(AThread, pvtViewer);

      if AltKey
      and
      ( DoChange or
      (PbfaInt64(frmMainForm.FViewerTreeview.Items[0].Data).value <> bitfarmapp.CurrentArchive.Arcid)) //28.09.2021 Ticket 28364
      then
      begin
        frmMainForm.fSkipMaximizeEvent := True;
        fSkipAutoDisplay := True; //18.09.2019 Ticket 20560
        if SkipClearSearch then
          Suchstring := frmMainForm.edtGeneralSearch.Text;

        try
          ChangeArchiveFromProgram(PbfaInt64(frmMainForm.FViewerTreeview.Items[0].Data).value, AThread);
        finally
          frmMainForm.fSkipMaximizeEvent := False;
          fSkipAutoDisplay := False; //18.09.2019 Ticket 20560
        end;

        if SkipClearSearch then
          frmMainForm.edtGeneralSearch.Text := Suchstring;
      end;

      if DoMax then
      begin
        AThread.Synchronize(nil,
          procedure
          var
            UserAction: PUserAction;
          begin
            if not frmMainForm.pnlTreeView.Maximized then //29.09.2021 weil vorher schon passiert
              frmMainForm.pnlTreeView.Maximize;
            UserAction := CreateUserAction;
            UserAction.ActionName := 'actSetSearchTextInFocus';
            FMainThread.Add(UserAction);
          end);
      end
      else
      begin
        if not SkipClearSearch then
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              frmMainForm.edtSearchText.SelectAll;
              frmMainForm.edtSearchText.SetFocus;
            end);
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'CtrlF', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CtrlF', Classname);
  end;
end;

procedure TbfaApplication.CtrlTab(AThread: TThread);
begin
  ViewChanging := True;
  bitfarmLog.DebugBegin(llDebug, 'CtrlTab', Classname);
  try
    try
//      AThread.Synchronize(nil,
//        procedure
//        begin
      SetActiveControl(Screen.ActiveControl, AThread);
//        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'CtrlTab', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CtrlTab', Classname);
  end;
end;

procedure TbfaApplication.SetActiveControl(Ctrl: TWinControl; AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'SetActiveControl', Classname);
  try
    try
      if Ctrl = frmMainForm.FViewerTreeview then
        frmMainForm.actAlt2.Execute
      else if Ctrl = frmMainForm.FImporterTreeview then
        frmMainForm.actAlt3.Execute
      else if (Ctrl = frmMainForm.pnlResubmission) or (Ctrl = frmMainForm.fraResub.cbbUserGroups) or (Ctrl = frmMainForm.fraResub.edtResubInfo) or (Ctrl = frmMainForm.fraResub.edtResubComment) or (Ctrl = frmMainForm.fraResub.cxDateNavigator1) then
        frmMainForm.actAlt4.Execute
      else if Ctrl = frmMainForm.trvBookmarks then
        frmMainForm.actAlt5.Execute
      else if Ctrl = frmMainForm.pnlWorkspace then
      begin
        if FUser.isAdmin and frmMainForm.pnlAdmin.Visible then
          frmMainForm.actAlt0.Execute
        else
          frmMainForm.actAlt1.Execute;
      end
      else if Ctrl = frmMainForm.FAdminTreeview then
        frmMainForm.actAlt1.Execute
//30.03.2021      else if Ctrl = frmMainForm.grdResultlist then
      else if Ctrl = frmMainForm.grdResultlistDevEx then
        SetSearchTabActive(AThread)
      else if (Ctrl.HasParent) then
      begin
        if (Ctrl.Parent.HasParent) and ((Ctrl.Parent.Parent.Parent.Name = frmMainForm.scrbxStandard.Name) or (Ctrl.Parent.Parent.Parent.Name = frmMainForm.tabStandard.Name)) then
          frmMainForm.actAlt7.Execute
        else if (Ctrl.Parent.Parent is TBfaAddfieldComp) or (Ctrl.Parent.Parent.Name = frmMainForm.tabAddFields.Name) or ((Ctrl.Parent.Parent.HasParent) and (Ctrl.Parent.Parent.Parent.Name = frmMainForm.scrbxViewerAddfields.Name)) then
        begin
          if frmMainForm.tabSearchLinks.Visible then
            frmMainForm.actAlt8.Execute
          else
            frmMainForm.actAlt6.Execute;
        end
        else if (Ctrl.HasParent) and (Ctrl.Parent.Parent.HasParent) and (Ctrl.Parent.Parent.Parent = frmMainForm.fraDocLinks) then
        begin
          if frmMainForm.tabDocLinks.Visible then
            frmMainForm.actAlt6.Execute
          else
            frmMainForm.actAlt7.Execute;
        end;
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'SetActiveControl', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetActiveControl', Classname);
  end;
end;

procedure TbfaApplication.CopyOCRResultToClipbrd(Sender: TObject);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'CopyOCRResultToClipbrd', Classname);
  try
    try
      UserAction := CreateUserAction;
      UserAction.ActionName := 'actCopyOCRResultToClipbrd';
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'CopyOCRResultToClipbrd', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CopyOCRResultToClipbrd', Classname);
  end;
end;

procedure TbfaApplication.CopyOCRResultToSlw(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'CopyOCRResultToSlw', Classname);
  try
    try
      CopyOCRResultToSlwAction;
    except
      bitfarmLog.Write(llNormal, ltException, 'CopyOCRResultToSlw', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CopyOCRResultToSlw', Classname);
  end;
end;

procedure TbfaApplication.CopyOCRResultToAddField(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'CopyOCRResultToAddField', Classname);
  try
    try
      CopyOCRResultToAddfieldAction(Sender);
    except
      bitfarmLog.Write(llNormal, ltException, 'CopyOCRResultToAddField', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CopyOCRResultToAddField', Classname);
  end;
end;

//procedure TbfaApplication.CopyOCRResultToClipbrdAction;
//var
//  UserAction: PUserAction;
//begin
//  bitfarmLog.DebugBegin(llDebug, 'CopyOCRResultToClipbrdAction', Classname);
//  try
//    try
//      UserAction := CreateUserAction;
//      UserAction.ActionName := 'actCopyOCRResultToClipbrd';
//      bitfarmApp.MainThread.Add(UserAction);
//    except
//      bitfarmLog.Write(llNormal, ltException, 'CopyOCRResultToClipbrdAction', ClassName);
//    end;
//  finally
//    bitfarmLog.DebugEnd(llDebug, 'CopyOCRResultToClipbrdAction', Classname);
//  end;
//end;

procedure TbfaApplication.CopyOCRResultToSlwAction;
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'CopyOCRResultToSlwAction', Classname);
  try
    try
      UserAction := CreateUserAction;
      UserAction.ActionName := 'actCopyOCRResultToSlw';
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'CopyOCRResultToSlwAction', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CopyOCRResultToSlwAction', Classname);
  end;
end;

procedure TbfaApplication.CountChecked;
begin
  if frmMainForm.FAdminTreeview.Selected <> nil then
    frmMainForm.fraAdmin.lblCurrent.Caption := _('Ausgewhlt:') + ' ' + frmMainForm.FAdminTreeview.Selected.Text;
  frmMainForm.fraAdmin.lblSelected.Caption := _('Selektiert:') + ' ' + IntToStr(frmMainForm.FAdminTreeview.CountChecked);
end;

procedure TbfaApplication.CopyOCRResultToAddFieldAction(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'CopyOCRResultToAddFieldAction', Classname);
  try
    CopyResultToAddfieldAction(Sender);
  finally
    bitfarmLog.DebugEnd(llDebug, 'CopyOCRResultToAddFieldAction', Classname);
  end;
end;

procedure TbfaApplication.CopyResultToAddFieldAction(Sender: TObject; sText: string = '');
var
  UserAction: PUserAction;
begin
  try
    UserAction := CreateUserAction;
    UserAction.ActionName := 'actCopyOCRResultToAddField';
    UserAction.Objects.Add(Sender);
    if (sText <> '') then
    begin
      UserAction^.options := 1;
      UserAction^.params.Text := sText;
    end;

    bitfarmApp.MainThread.Add(UserAction);
  except
    bitfarmLog.Write(llNormal, ltException, 'CopyOCRResultToAddFieldAction', ClassName);
  end;
end;

procedure TbfaApplication.DoCopyOCRResultToClipbrd(AThread: TThread);
var
  mystr: string;
  rtfstring: PChar;
  lmystr: Tstrings;
begin
  bitfarmLog.DebugBegin(llDebug, 'DoCopyOCRResultToClipbrd', Classname);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          lmystr := GetOCRText;

          bitfarmLog.Write(llDebug, ltInfo, 'after getocrtext', ClassName);
          if lmystr = nil then
            Exit;

//          {$IFDEF GetOCRText}
          mystr := lmystr.DelimitedText;
          RemoveMultipleSpaces(mystr);
//          {$ELSE}
//          mystr := lmystr.Text;
//          {$ENDIF}

          bitfarmLog.Write(llDebug, ltInfo, 'mystr: ' + mystr, ClassName);

          with Clipboard do
          begin
            AsText := lmystr.Text;
          end;

          if ActivePreview <> nil then
          begin
            ActivePreview.SingleView.img_DocView.DeSelect;
            bitfarmLog.Write(llDebug, ltInfo, 'DeSelect', ClassName);
          end;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'DoCopyOCRResultToClipbrd', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'DoCopyOCRResultToClipbrd', Classname);
  end;
end;

procedure TbfaApplication.DoCopyOCRResultToSlw(AThread: TThread);
var
  mystr: string;
  lmystr: TStrings;
  UserAction: PUserAction;
  i: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'DoCopyOCRResultToSlw', Classname);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          lmystr := GetOCRText;
        end);

      if lmystr = nil then
        exit;

//      {$IFDEF GetOCRText}
      mystr := lmystr.DelimitedText;
      RemoveMultipleSpaces(mystr);
//      {$ELSE}
//      mystr := lmystr.Text;
//      {$ENDIF}

      UserAction := bitfarmApp.CreateUserAction;
      CloneCurrentDocs(UserAction, False);
      UserAction^.ActionName := 'actAddTag';
      UserAction^.params.Add(mystr);
      for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
      begin
        UserAction^.params.Add(IntToStr(bitfarmApp.CurrentContainer[i].Id));
      end;
      bitfarmApp.MainThread.Add(UserAction);

      AThread.Synchronize(nil,
        procedure
        begin
          if ActivePreview <> nil then
            ActivePreview.SingleView.img_DocView.DeSelect;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'DoCopyOCRResultToSlw', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'DoCopyOCRResultToSlw', Classname);
  end;
end;

//{$IFDEF GetOCRText}
function TbfaApplication.GetOCRText: TStrings;
var
  lstr: TStringList;
  req: TbfaRequest;
  Doc: TbfaDocument;
  Lst: TList<TbfaBaseObject>;
  im: TbfaImageEnVect;
  AStream: TMemoryStream;
begin
  try
    bitfarmLog.DebugBegin(llDebug, 'GetOCRText', Classname);
    Result := nil;
    lstr := nil;
    if fbingetocrtext then
    begin
      bitfarmLog.Write(llDebug, ltInfo, 'fbingetocrtext = True ', ClassName);
      BfShowMessage(_('OCR ist bereits in Benutzung, bitte warten Sie einige Sekunden ') + #13 + _('und versuchen Sie erneut.'));
      Exit;
    end;

    try
      if ActivePreview.SingleView.img_DocView.Selected then
      begin
        try
          fbingetocrtext := True;
          bitfarmLog.Write(llDebug, ltInfo, 'Bereichs-OCR wird ausgefhrt', ClassName);
          frmMainForm.SetNotificationBar(_('Bereichs-OCR wird ausgefhrt'), nil);

          req := TbfaRequest.Create;
          req.ReqType := 'reqGetOCRText';
          req.Lang := Lang;
          req.UserID := User.ID;
          req.Profile := Self.Profile;
          req.FileName := ExtractFileExt(ActivePreview.ActiveDoc.DocLoc); // kann im Importer zB auch .png sein

          // Bildausschitt in Stream speichern
          AStream := TMemoryStream.Create;
          AStream.Clear;
          //ActivePreview.SingleView.img_DocView.SaveSelectionToStream(AStream);
          im := TbfaImageEnVect.Create(nil);
          im.IO.AutoAdjustDPI := True;
          ActivePreview.SingleView.img_DocView.CopySelectionToBitmap(im.Bitmap);
          im.IO.SaveToStreamTIFF(AStream);

          AStream.Position := 0;
          req.DataString := EncodeBase64(AStream.Memory, AStream.Size);

          MainSocket.SendRequestToServer(req);

          req := MainSocket.ReceiveResponse;
          if (req <> nil) and (req.ReqType = 'respOcr') then
          begin
            lstr := TStringList.Create;
            lstr.Delimiter := ' ';
            lstr.Duplicates := dupAccept;
            lstr.StrictDelimiter := True;
            lstr.Text := req.DataString;
            Result := lstr;
            frmMainForm.SetNotificationBar(_('Bereichs-OCR abgeschlossen'), nil);
          end else if req = nil then
          begin
            bitfarmLog.Write(llDebug, ltInfo, 'Fehler bei Bereichs-OCR - no response - req=nil', ClassName);
            frmMainForm.SetNotificationBar(_('Fehler bei Bereichs-OCR'), nil);
          end
          else
          begin
            bitfarmLog.Write(llDebug, ltInfo, 'Fehler bei Bereichs-OCR - ' + req.ReqType, ClassName);
            frmMainForm.SetNotificationBar(_('Fehler bei Bereichs-OCR') + ' - ' + req.ReqType, nil);
          end;
        finally
          ActivePreview.SingleView.img_DocView.DeSelect;
          fbingetocrtext := False;
          FreeAndNil(req);
          FreeAndNil(AStream);
        end;
      end;
    except
      Result := nil;
      bitfarmLog.Write(llNormal, ltException, 'GetOCRText', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'GetOCRText', Classname);
  end;
end;
//{$ELSE}
//function TbfaApplication.GetOCRText: TStrings;
//var
//  lstr: Tstringlist;
//  im: TbfaImageEnVect;
//  lsdocname, lsoutput, lsinfo, lsErgebnis: string;
//  lst1: Tstringlist;
//  lipos1, lipos2, lipos3: integer;
//  lbnocr: boolean;
//  lsCmd1, lsCmd2: string; //3.5.0.59
//  li, i: Integer;
//begin
//  bitfarmLog.DebugBegin(llDebug, 'GetOCRText', Classname);
//  try
//    try
//      result := nil;
//      lstr := nil;
//      if fbingetocrtext then
//      begin
//        bitfarmLog.Write(llDebug, ltInfo, 'fbingetocrtext = True ', ClassName);
//        BfShowMessage(_('OCR ist bereits in Benutzung, bitte warten Sie einige Sekunden ') + #13 + _('und versuchen Sie erneut.'));
//        exit;
//      end;
//      try
//        try
//          fbingetocrtext := true;
//          if ActivePreview.SingleView.img_DocView.Selected then
//          begin
//            try
//              bitfarmLog.Write(llDebug, ltInfo, 'Bereichs-OCR wird ausgefhrt', ClassName);
//
////              SetStatusInfo(_('Bereichs-OCR wird ausgefhrt'), nil);
//              frmMainForm.SetNotificationBar(_('Bereichs-OCR wird ausgefhrt'), nil); // SJ 14.08.2019
//              lstr := Tstringlist.create;
//              im := nil;
//              im := CreateInvisibleVect(nil);
//              im.IO.AutoAdjustDPI := true;
//              try
//                ActivePreview.SingleView.img_DocView.CopySelectionToBitmap(im.Bitmap);
//                lsdocname := BD.EnvTemp + '\temp.ppm';
//                im.IO.SaveToFile(lsdocname);
//                bitfarmLog.Write(llDebug, ltInfo, 'lsdocname: ' + lsdocname, ClassName);
////27.10.2017 Access Violation beim zB Ctrl+C in anderen Anwendungen und strzt ab!!! -->
//                try
//                  im.RemoveAllObjects;
//                  im.Clear;
//                  im.SelectionMask.Empty;
//                except
//                  bitfarmLog.Write(llNormal, ltException, 'im.SelectionMask.Empty;', ClassName);
//                end;
//// 27.10.2017 Access Violation beim zB Ctrl+C in anderen Anwendungen und strzt ab!!! <--
//              finally
//// 27.10.2017 Access Violation beim zB Ctrl+C in anderen Anwendungen und strzt ab!!! -->
////                if assigned(im) then
////                   FreeAndNil(im);
////29.08.2023 -->
//////10.05.2023 -->
//////                try
//////                  im := nil;
//////                except
//////                  bitfarmLog.Write(llNormal, ltException, 'im := nil;', ClassName);
//////                end;
////                try
////                  im.Free;
////                finally
////                  im := nil;
////                end;
//////10.05.2023 <--
//                {$IFDEF IMAGEEN_SYNCHRONIZED}
//                try
//                  im.Free;
//                finally
//                  im := nil;
//                end;
//                {$ELSE}
//                try
//                  im := nil;
//                except
//                  bitfarmLog.Write(llNormal, ltException, 'im := nil;', ClassName);
//                end;
//                {$ENDIF}
////29.08.2023 <--
//
//// //27.10.2017 Access Violation beim zB Ctrl+C in anderen Anwendungen und strzt ab!!! <--
//              end;
//              lsoutput := changefileext(lsdocname, '.html');
//              bitfarmLog.Write(llDebug, ltInfo, 'lsoutput: ' + lsoutput, ClassName);
//
//              lsCmd1 := BD.ExeDir + 'Viewer-Files\ocroscript\ocroscript.exe';
//              if fileexists(lsCmd1) then
//              begin
//                bitfarmLog.Write(llDebug, ltInfo, 'lsCmd1: ' + lsCmd1, ClassName);
//
//                lsCmd2 := BD.ExeDir + 'Viewer-Files\bats\ocroscript.bat';
//
//                bitfarmLog.Write(llDebug, ltInfo, 'lsCmd2: ' + lsCmd2, ClassName);
//                bitfarmLog.Write(llDebug, ltInfo, 'ShellExecute_AndWait: "' + BD.ExeDir + 'Viewer-Files\ocroscript\ocroscript.exe" recognize "' + lsdocname + '"  "' + lsoutput + '"', ClassName);
//
//                ShellExecute_AndWait('', lsCmd2, '"' + BD.ExeDir + 'Viewer-Files\ocroscript\ocroscript.exe" recognize "' + lsdocname + '"  "' + lsoutput + '"', BD.EnvTemp, SW_show, True);
//                lbnocr := true;
//                bitfarmLog.Write(llDebug, ltInfo, 'lbnocr = True', ClassName);
//
//              end
//              else
//              begin
//                lsCmd2 := BD.ExeDir + 'Viewer-Files\bats\ocroexec.bat';
//                bitfarmLog.Write(llDebug, ltInfo, 'lsCmd2: ' + lsCmd2, ClassName);
//                if FileExists(lsCmd2) then
//                begin
//                  bitfarmLog.Write(llDebug, ltInfo, 'lsCmd2: ' + lsCmd2, ClassName);
//                  bitfarmLog.Write(llDebug, ltInfo, 'ShellExecute_AndWait: "' + BD.ExeDir + 'Viewer-Files\ocrocmd\ocrocmd.exe" "' + lsdocname + '"  "' + lsoutput + '"', ClassName);
//                  ShellExecute_AndWait('', lsCmd2, '"' + BD.ExeDir + 'Viewer-Files\ocrocmd\ocrocmd.exe" "' + lsdocname + '"  "' + lsoutput + '"', BD.ExeDir, SW_hide, True);
//                  lbnocr := false;
//                end
//                else
//                begin
//                  BfShowMessage(_('Bereichs-OCR nicht angebunden, wenden Sie sich an ihren Administrator.'));
//                  bitfarmLog.Write(llNormal, ltException, 'ocroscript.exe oder ocroexec.bat nicht vorhanden', ClassName);
//                  Exit;
//                end;
//              end;
//
//              try
//                lst1 := Tstringlist.create;
//                lst1.LoadFromFile(lsoutput);
//                bitfarmLog.Write(llDebug, ltInfo, 'lbnocr: ' + BoolToStr(lbnocr, True), ClassName);
//                bitfarmLog.Write(llDebug, ltInfo, 'lst1 Erstellt Dateiname: ' + lsoutput, ClassName);
//                bitfarmLog.Write(llDebug, ltInfo, 'lst1 Count = ' + IntToStr(lst1.Count), ClassName);
//                for li := 0 to lst1.Count - 1 do
//                begin
//                  bitfarmLog.Write(llDebug, ltInfo, 'li = ' + IntToStr(li), ClassName);
//                  bitfarmLog.Write(llDebug, ltInfo, 'lst1.Strings[li]: ' + lst1.Strings[li], ClassName);
//
//                  if lbnocr then
//                  begin
//                    lipos1 := pos('class="ocr_line" title="bbox', lst1.Strings[li]);
//                  end
//                  else
//                  begin
//                    lipos1 := pos('title=' + #39 + 'bbox', lst1.Strings[li]);
//                  end;
//
//                  bitfarmLog.Write(llDebug, ltInfo, 'lipos1 = ' + IntToStr(lipos1), ClassName);
//                  if lipos1 > 0 then
//                  begin
//                    bitfarmLog.Write(llDebug, ltInfo, 'lipos1 > 0', ClassName);
//                    lipos2 := posex('>', lst1.Strings[li], lipos1);
//                    lipos3 := posex('</span>', lst1.Strings[li], lipos2);
//                    if lipos3 = 0 then
//                      lipos3 := length(lst1.Strings[li]);
//                    bitfarmLog.Write(llDebug, ltInfo, 'lipos3 = ' + IntToStr(lipos3), ClassName);
//                    lsErgebnis := Copy(lst1.Strings[li], lipos2 + 1, lipos3 - lipos2 - 1);
//                    bitfarmLog.Write(llDebug, ltInfo, 'lsErgebnis: ' + lsErgebnis, ClassName);
//                    lsErgebnis := HTTPApp.HTMLDecode(lsErgebnis);
//                    bitfarmLog.Write(llDebug, ltInfo, 'lsErgebnis: ' + lsErgebnis, ClassName);
//                    lstr.Add(ParseSQLString(lsErgebnis));
//                    bitfarmLog.Write(llDebug, ltInfo, 'ParseSQLString(lsErgebnis): ' + ParseSQLString(lsErgebnis), ClassName);
//                  end;
//                end;
//              except
//                BfShowMessage(_('Fehler bei der OCR Erkennung.' + #13 + 'Bitte versuchen Sie erneut.'));
//                bitfarmLog.Write(llNormal, ltException, 'Fehler bei der OCR Erkennung. Bitte versuchen Sie erneut.', ClassName);
//                Exit;
//              end;
//            finally
////              bitfarmLog.Write(llDebug, ltInfo, 'SetStatusInfo: ' + lsinfo, ClassName);
////              SetStatusInfo(lsinfo, nil);
//              bitfarmLog.Write(llDebug, ltInfo, 'SetNotificationBar: ' + lsinfo, ClassName);
//              frmMainForm.SetNotificationBar(lsinfo, nil); // SJ 14.08.2019
//            end;
//          end;
//        except
//          on e: exception do
//          begin
//            bitfarmLog.Write(llNormal, ltException, 'error on GetOCRText ' + e.message, ClassName);
//          end;
//        end;
//      finally
//        ActivePreview.SingleView.img_DocView.DeSelect;
//        fbingetocrtext := false;
//      end;
//      result := lstr;
//    except
//      bitfarmLog.Write(llNormal, ltException, 'GetOCRText', ClassName);
//    end;
//  finally
//    bitfarmLog.DebugEnd(llDebug, 'GetOCRText', Classname);
//  end;
//end;
//// 26.10.2017 Bei Kunde hatte immer abgestrzt deswegen gendert <--
//{$ENDIF}

// UserAction Optionen;
// 1     = Kopiere aus UserAction^.Params ins Zusatzfeld
// sonst = Kopiere aus OCR ins Zusatzfeld
procedure TbfaApplication.DoCopyOCRResultToAddField(AThread: TThread; UserAction: PUserAction);
var
  lmystr: TStrings;
  ls: string;
  outdate: TDateTime;
  outint: Integer;
  outfloat: Extended;
begin
  bitfarmLog.DebugBegin(llDebug, 'DoCopyOCRResultToAddField', Classname);
  try
    try
      AThread.Synchronize(nil,
        procedure
        var
          i: Integer;
          found: Boolean;
          Obj: TObject;
        begin

          if UserAction^.options = 1 then
          begin
            lmystr := TStringList.Create;
            lmystr.Text := UserAction^.params.Text;
          end
          else
            lmystr := GetOCRText;

          if lmystr <> nil then
          begin
            Obj := UserAction^.objects[0];
            bitfarmLog.Write(llDebug, ltInfo, 'Obj', ClassName);
            if (Obj <> nil) and (Obj is TSpTBXItem) then
            begin
              with TSpTBXItem(Obj) do
              begin
                i := 0;
                found := False;
                bitfarmLog.Write(llDebug, ltInfo, 'TSpTBXItem(Obj)', ClassName);

                ls := Trim(lmystr.Text);
                lmystr.Free;              // ab hier nicht mehr genutzt, deshalb Free

                while ((not found) and (i < frmMainForm.scrbxViewerAddfields.ComponentCount)) do
                begin
                  if (frmMainForm.scrbxViewerAddfields.Components[i] is TBfaAddfieldComp) then
                  begin
                    if TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).Dispname = Caption then
                    begin
                      if TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).cbxIndexing.Visible then
                      begin
                        TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).cbxIndexing.Text := ls;
                        TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).cbxIndexing.Properties.OnChange(nil);
                      end else
                      begin
                        case TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).AddfieldType of
                          zfld00_Universal:
                            begin
                              if (FViewerOptions.EditorOptions.OCRAdd) and (TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).compEdit.Text <> '') then
                                ls := TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).compEdit.Text + globalDelimiter + ls;

                              TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).compEdit.Text := ls;
                              TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).compEdit.Modified := True;
                            end;
                          zfld01_Datum, zfld12_DLMDate:
                            begin
                              if TryStrToDate(ls, outdate) then
                              begin
                                TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).compDateLow.Text := ls;
                                TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).modified := True;
                              end;
                            end;
                          zfld02_Auswahl, zfld11_DLM:
                            begin
                              if (FViewerOptions.EditorOptions.OCRAdd) and (TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).compComboBox.Text <> '') then
                                ls := TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).compComboBox.Text + globalDelimiter + ls;
                              TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).compComboBox.Text := ls;
                              TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).Modified := True;
                            end;
                          zfld03_MehrfachAuswahl:
                            begin
                              if (FViewerOptions.EditorOptions.OCRAdd) and (TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).compCheckedCombo.Text <> '') then
                                ls := TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).compCheckedCombo.Text + globalDelimiter + ls;
                              TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).compCheckedCombo.Text := ls;
                              TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).Modified := True;
                            end;
                          zfld05_Intervall:
                            begin
                              TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).compEdit.Text := ls;
                              TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).Modified := True;
                            end;
                          zfld06_GanzZahl:
                            begin
//                              if TryStrToInt(ls, outint) then
                              // TryStrToInt hat Probleme mit ThousandSeparator...
                              if TryStrToInt(StringReplace(ls, FormatSettings.ThousandSeparator, '', [rfReplaceAll]), outint) then
                              begin
                                if (FViewerOptions.EditorOptions.OCRAdd) and (TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).compSpinEditLow.Text <> '') then
                                  ls := TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).compSpinEditLow.Text + globalDelimiter + ls;
                                TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).compSpinEditLow.Value := outint;
                                TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).Modified := True;
                              end;
                            end;
                          zfld07_FliessKomma, zfld08_Waehrung:
                            begin
//                              if TryStrToFloat(ls, outfloat) then
                              // TryStrToFloat hat Probleme mit ThousandSeparator...
                              if TryStrToFloat(StringReplace(ls, FormatSettings.ThousandSeparator, '', [rfReplaceAll]), outfloat, FormatSettings) then
                              begin
                                TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).compSpinEditLow.Value := outfloat;
//                                TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).compSpinEditLow.Text := ls;
                                TBfaAddfieldComp(frmMainForm.scrbxViewerAddfields.Components[i]).Modified := True;
                              end;
                            end;
                        end;
                      end;
                    end;
                  end;
                  inc(i);
                end;
              end;
            end;
          end;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'DoCopyOCRResultToAddField', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'DoCopyOCRResultToAddField', Classname);
  end;
end;

procedure TbfaApplication.GoToSourceArchive(AThread: TThread; Doc: TbfaDocument; SymArcID: Int64);
var
  i: Integer;
  ids: string;
begin
  bitfarmLog.DebugBegin(llDebug, 'GoToSourceArchive', Classname);
  try
    try
//19.10.2018 Laut 3.5.4. ist es mglich mehrere Dokumente auswhlen und mit Strg + U ins ursprungsarchiv wechseln, und da alle Dokumente die zum Archiv gehren darstellen -->
      ids := '';
      if FCurrentContainer.Count > 1 then
      begin
        for i := 0 to FCurrentContainer.Count - 1 do
        begin
          if (Doc.ArcID = FCurrentContainer[i].arcid) or (Doc.ArcID = FCurrentContainer[i].SymbolicArcID) then
          begin
            if ids <> '' then
              ids := ids + ',';
            ids := ids + IntToStr(FCurrentContainer[i].Id);
          end;
        end;
      end;
//19.10.2018 <--
(*21.05.2024
     // if SymArcID <> -1 then             //  10/21/2020 --> bfacrm:ticket__show__24751         Springen Sie zum Originalarchiv, wenn wir eine symbolische ID haben
//16.02.2018 Ticket 13580 Punkt 4        DocumentSearch(SymArcID, Doc.ID, AThread, True, IntToStr(SymArcID))
     //   DocumentSearch(SymArcID, Doc.ID, AThread, False, IntToStr(SymArcID), ids) // 10/21/2020 --> bfacrm:ticket__show__24751
     DocumentSearch(Doc.ArcID, Doc.ID, AThread, False, IntToStr(Doc.ArcID), ids)      //  10/21/2020 --> bfacrm:ticket__show__24751   um zum Originalarchiv zu springen
     // else                               //  10/21/2020 --> bfacrm:ticket__show__24751
//19.10.2018        DocumentSearch(Doc.ArcID, Doc.ID, AThread, False, '', ids); // mit Strg-U muss alle ausgewhlte Document dargestellt werden die zum Doc.ArcID gehren
     //   DocumentSearch(Doc.ArcID, Doc.ID, AThread, False, IntToStr(Doc.ArcID), ids);
*)
    if (SymArcID <> -1) and (SymArcID <> Doc.ArcID) then
      DocumentSearch(SymArcID, Doc.ID, AThread, False, IntToStr(SymArcID), ids)
    else
      DocumentSearch(Doc.ArcID, Doc.ID, AThread, False, IntToStr(Doc.ArcID), ids);

    except
      bitfarmLog.Write(llNormal, ltException, 'GoToSourceArchive', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'GoToSourceArchive', Classname);
  end;
end;

procedure TbfaApplication.ChangeDevexpSkin;
var
  t: TSpTBXSkinOptionCategory;
  te: TSpTBXSkinOptionEntry;
  i : Integer;
  cl, cl2, cl3 : TColor;
  ini : TIniFile;

  procedure SetStyleController(stlctrl : TcxEditStyleController);
  begin
    stlctrl.RestoreStyles;
    stlctrl.Style.LookAndFeel.NativeStyle := False;
    stlctrl.Style.LookAndFeel.ScrollbarMode := sbmClassic;

    stlctrl.Style.Font.Size := bfaFontSize;
    stlctrl.StyleDisabled.Font.Size := bfaFontSize;
    stlctrl.StyleFocused.Font.Size := bfaFontSize;
    stlctrl.StyleHot.Font.Size := bfaFontSize;

    t := SkinManager.CurrentSkin.Options(skncEditFrame, sknsHotTrack);
    te := t.Borders;
    stlctrl.StyleHot.BorderStyle := ebsSingle;
    stlctrl.StyleHot.BorderColor := te.Color3;
    stlctrl.StyleHot.Font.Color := t.TextColor;
    stlctrl.StyleFocused.BorderStyle := ebsSingle;
    stlctrl.StyleFocused.BorderColor := te.Color3;
    stlctrl.StyleFocused.Font.Color := t.TextColor;
    stlctrl.Style.Font.Color := t.TextColor;

    t := SkinManager.CurrentSkin.Options(skncDockablePanel, sknsNormal);
    te := t.Body;
    stlctrl.Style.Color := te.color1;

    t := SkinManager.CurrentSkin.Options(skncEditFrame, sknsNormal);
    te := t.Borders;
    stlctrl.Style.BorderStyle := ebsSingle;
    if (SkinManager.CurrentSkinName = 'bitfarm-Archiv') or (SkinManager.CurrentSkinName = 'Human') then
      stlctrl.Style.BorderColor := te.Color2
    else
      stlctrl.Style.BorderColor := te.Color3;

    t := SkinManager.CurrentSkin.Options(skncEditFrame, sknsDisabled);
    te := t.Borders;
    stlctrl.StyleDisabled.BorderStyle := ebsSingle;
    stlctrl.StyleDisabled.BorderColor := te.Color3;
  end;

begin
  try
    stlControl.RestoreDefaults;
    stlColumn.RestoreDefaults;
    stlUrgent.RestoreDefaults;
    stlUrgentSelected.RestoreDefaults;
    stlWork.RestoreDefaults;
    stlWorkSelected.RestoreDefaults;
    stlDone.RestoreDefaults;
    stlDoneSelected.RestoreDefaults;
    stlFree.RestoreDefaults;
    stlSelected.RestoreDefaults;
    stlProgress.RestoreDefaults;
    stlProgressSelected.RestoreDefaults;
    stlTreeview.RestoreDefaults;
    stlTreeviewSelected.RestoreDefaults;
    stlImageEn.RestoreDefaults;
    stlImageEnSelected.RestoreDefaults;
    stlControlNoRight.RestoreDefaults;
    stlControlRequired.RestoreDefaults;
    stlControlModified.RestoreDefaults;
    stlGroupByBoxStyle.RestoreDefaults;
    stlBackgroundStyle.RestoreDefaults;

    stlColumn.Font.Name := 'Arial';
    stlControl.Font.Size := bfaFontSize;
    stlColumn.Font.Size := bfaFontSize;
    stlUrgent.Font.Size := bfaFontSize;
    stlUrgentSelected.Font.Size := bfaFontSize;
    stlWork.Font.Size := bfaFontSize;
    stlWorkSelected.Font.Size := bfaFontSize;
    stlDone.Font.Size := bfaFontSize;
    stlDoneSelected.Font.Size := bfaFontSize;
    stlFree.Font.Size := bfaFontSize;
    stlSelected.Font.Size := bfaFontSize;
    stlProgress.Font.Size := bfaFontSize;
    stlProgressSelected.Font.Size := bfaFontSize;
    stlTreeview.Font.Size := bfaFontSize;
    stlTreeviewSelected.Font.Size := bfaFontSize;
    stlImageEn.Font.Size := bfaFontSize;
    stlImageEnSelected.Font.Size := bfaFontSize;
    stlControlNoRight.Font.Size := bfaFontSize;
    stlControlRequired.Font.Size := bfaFontSize;
    stlControlModified.Font.Size := bfaFontSize;
    stlGroupByBoxStyle.Font.Size := bfaFontSize;
    stlBackgroundStyle.Font.Size := bfaFontSize;

    t := SkinManager.CurrentSkin.Options(skncDockablePanel, sknsNormal);
    te := t.Body;
    cl := te.Color1;
    if cl = gclNone then
      cl := clBtnFace;

    stlFree.Color := cl;
    stlControl.Color := cl;
    stlTreeview.Color := cl;
    stlImageEn.Color := cl;
    stlBackgroundStyle.Color := cl;

    t := SkinManager.CurrentSkin.Options(skncListItem, sknsCheckedAndHotTrack);
    te := t.Body;
    cl3 := te.Color1;

    stlSelected.Color := cl3;
    stlTreeviewSelected.Color := cl3;
    stlImageEnSelected.Color := cl3;
    stlSelected.TextColor := t.TextColor;
    stlSelected.Font.Color := t.TextColor;
    stlTreeviewSelected.TextColor := t.TextColor;
    stlTreeviewSelected.Font.Color := t.TextColor;
    stlImageEnSelected.TextColor := t.TextColor;
    stlImageEnSelected.Font.Color := t.TextColor;

    t := SkinManager.CurrentSkin.Options(skncDockablePanelTitleBar, sknsNormal);
    te := t.Body;
    cl3 := te.Color1;
    stlGroupByBoxStyle.Color := cl3;
    if t.TextColor <> clNone then
    begin
      stlControl.TextColor := t.TextColor;
      stlControl.Font.Color := t.TextColor;
      stlGroupByBoxStyle.TextColor := t.TextColor;
      stlGroupByBoxStyle.Font.Color := t.TextColor;
    end
    else
    begin
      stlControl.TextColor := clBlack;
      stlControl.Font.Color := clBlack;
      stlGroupByBoxStyle.TextColor := clBlack;
      stlGroupByBoxStyle.Font.Color := clBlack;
    end;

    t := SkinManager.CurrentSkin.Options(skncButton, sknsNormal);
    if t.TextColor <> clNone then
    begin
      stlFree.TextColor := t.TextColor;
      stlFree.Font.Color := t.TextColor;
    end
    else
    begin
      stlFree.TextColor := clBlack;
      stlFree.Font.Color := clBlack;
    end;

    //29.02.2024 -->
    stlTreeview.TextColor := stlFree.TextColor;
    stlTreeview.Font.Color := stlFree.Font.Color;
    stlImageEn.TextColor := stlFree.TextColor;
    stlImageEn.Font.Color := stlFree.Font.Color;
    stlBackgroundStyle.TextColor := stlFree.TextColor;
    stlBackgroundStyle.Font.Color := stlFree.Font.Color;
    //29.02.2024 <--

//09.07.2020 -->
    t := SkinManager.CurrentSkin.Options(skncButton, sknsNormal);
    if t.TextColor <> clNone then
    begin
      stlColumn.TextColor := t.TextColor;
      stlColumn.Font.Color := t.TextColor;
    end
    else
    begin
      stlColumn.TextColor := clBlack;
      stlColumn.Font.Color := clBlack;
    end;
//09.07.2020 <--

    t := SkinManager.CurrentSkin.Options(skncListItem, sknsNormal);
    te := t.Body;
    if te.Color1 <> gclNone then
      cl2 := te.Color1
    else
      cl2 := cl;

    stlColumn.Color := cl2;

    if FileExists(ExtractFilePath(Application.ExeName) + 'Viewer-files\Skins\' +
      SkinManager.CurrentSkinName + '.skn') then
    begin
      ini := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'Viewer-files\Skins\' +
      SkinManager.CurrentSkinName + '.skn');
      try

      //25.08.2020 mssen angepasst werden.
        stlUrgent.Color := ini.ReadInteger('Skin', 'clUrgent', gclUrgent);
        stlUrgent.TextColor := ini.ReadInteger('Skin', 'clUrgentText', gclUrgentText);
        stlUrgentSelected.Color := ini.ReadInteger('Skin', 'clUrgentSelected', gclUrgentSelected);
        stlUrgentSelected.TextColor := ini.ReadInteger('Skin', 'clUrgentSelectedText', gclUrgentSelectedText);
        stlWork.Color := ini.ReadInteger('Skin', 'clWork', gclWork);
        stlWork.TextColor := ini.ReadInteger('Skin', 'clWorkText', gclWorkText);
        stlWorkSelected.Color := ini.ReadInteger('Skin', 'clWorkSelected', gclWorkSelected);
        stlWorkSelected.TextColor := ini.ReadInteger('Skin', 'clWorkSelectedText', gclWorkSelectedText);
        stlDone.Color := ini.ReadInteger('Skin', 'clDone', gclDone);
        stlDone.TextColor := ini.ReadInteger('Skin', 'clDoneText', gclDoneText);
        stlDoneSelected.Color := ini.ReadInteger('Skin', 'clDoneSelected', gclDoneSelected);
        stlDoneSelected.TextColor := ini.ReadInteger('Skin', 'clDoneSelectedText', gclDoneSelectedText);
        stlFree.Color := ini.ReadInteger('Skin', 'clFree', stlFree.Color);
        stlFree.TextColor := ini.ReadInteger('Skin', 'clFreeText', stlFree.TextColor);
        stlSelected.Color := ini.ReadInteger('Skin', 'clSelected', stlSelected.Color);
        stlSelected.TextColor := ini.ReadInteger('Skin', 'clSelectedText', stlSelected.TextColor);
        stlProgress.Color := ini.ReadInteger('Skin', 'clProgress', gclProgress);
        stlProgress.TextColor := ini.ReadInteger('Skin', 'clProgressText', gclProgressText);
        stlProgressSelected.Color := ini.ReadInteger('Skin', 'clProgressSelected', gclProgressSelected);
        stlProgressSelected.TextColor := ini.ReadInteger('Skin', 'clProgressSelectedText', gclProgressSelectedText);
        stlColumn.Font.Size := ini.ReadInteger('Skin', 'GridFontSize', BFAFONT);
        stlControl.Font.Size := ini.ReadInteger('Skin', 'GridFontSize', BFAFONT);
        stlControlNoRight.TextColor := ini.ReadInteger('Skin', 'clControlNoRightText', clDefault);  //02.07.2024
      finally
        FreeAndNil(ini);
      end;
    end
    else
    begin
      stlUrgent.Color := gclUrgent;
      stlUrgent.TextColor := gclUrgentText;
      stlUrgentSelected.Color := gclUrgentSelected;
      stlUrgentSelected.TextColor := gclUrgentSelectedText;
      stlWork.Color := gclWork;
      stlWork.TextColor := gclWorkText;
      stlWorkSelected.Color := gclWorkSelected;
      stlWorkSelected.TextColor := gclWorkSelectedText;
      stlDone.Color := gclDone;
      stlDone.TextColor := gclDoneText;
      stlDoneSelected.Color := gclDoneSelected;
      stlDoneSelected.TextColor := gclDoneSelectedText;
      stlFree.Color := gclFree;
      stlFree.TextColor := gclFreeText;
      stlSelected.Color := gclSelected;
      stlSelected.TextColor := gclSelectedText;
      stlProgress.Color := gclProgress;
      stlProgress.TextColor := gclProgressText;
      stlProgressSelected.Color := gclProgressSelected;
      stlProgressSelected.TextColor := gclProgressSelectedText;
      stlColumn.Font.Size := bfaFontSize;
      stlControl.Font.Size := bfaFontSize;
      stlControlNoRight.TextColor := clDefault;  //02.07.2024
    end;

//27.09.2022 -->
    SetStyleController(ctlGeneral);
    ctlGeneral.Style.Font.Size := bfaFontSize;
    ctlGeneral.Style.Font.Color := stlControl.TextColor; //13.09.2022 Zusatfeld Caption Color
    ctlGeneral.Style.TextColor := stlControl.TextColor; //13.09.2022 Zusatfeld Caption Color

    SetStyleController(ctlModified);
    ctlModified.Style.Color := cColorLightGreen;
    ctlModified.Style.Font.Size := bfaFontSize;
    ctlModified.Style.TextColor := clBlack;

    SetStyleController(ctlRequired);
    ctlRequired.Style.Color := cColorRequiredField;
    ctlRequired.Style.Font.Size := bfaFontSize;
    ctlRequired.Style.TextColor := clBlack;

    SetStyleController(ctlRedBackground);
    ctlRedBackground.Style.Color := cColorRed;
    ctlRedBackground.Style.Font.Size := bfaFontSize;

    SetStyleController(ctlDisabled);
    ctlDisabled.Style.Color := cColorNoRightInit;
    ctlDisabled.Style.TextColor := stlControlNoRight.TextColor; //02.07.2024
    ctlDisabled.Style.Font.Size := bfaFontSize;

    SetStyleController(ctlGeneralTextHighlighted);
    ctlGeneralTextHighlighted.Style.Font.Size := bfaFontSize;
    ctlGeneralTextHighlighted.Style.TextColor := cColorRed;

    SetStyleController(ctlModifiedTextHighlighted);
    ctlModifiedTextHighlighted.Style.Color := cColorLightGreen;
    ctlModifiedTextHighlighted.Style.Font.Size := bfaFontSize;
    ctlModifiedTextHighlighted.Style.TextColor := cColorRed;

    SetStyleController(ctlRequiredTextHighlighted);
    ctlRequiredTextHighlighted.Style.Color := cColorRequiredField;
    ctlRequiredTextHighlighted.Style.Font.Size := bfaFontSize;
    ctlRequiredTextHighlighted.Style.TextColor := cColorRed;

    SetStyleController(ctlDisabledTextHighlighted);
    ctlDisabledTextHighlighted.Style.Color := cColorRequiredField;
    ctlDisabledTextHighlighted.Style.Font.Size := bfaFontSize;
    ctlDisabledTextHighlighted.Style.TextColor := cColorRed;

    SetStyleController(ctlGeneralSearch);
    ctlGeneralSearch.Style.Font.Size := bfaFontSize;
    ctlGeneralSearch.Style.Font.Color := clGrayText;
    ctlGeneralSearch.Style.Font.Style := [fsItalic];
    ctlGeneralSearch.style.TextColor := clGrayText;

    SetStyleController(ctlWhite);
    ctlWhite.Style.Font.Size := bfaFontSize;
    ctlWhite.Style.Color := clWhite;
//27.09.2022 <--

  except
    bitfarmLog.Write(llNormal, ltException, 'ChangeDevexpSkin', ClassName);
  end;
end;

procedure TbfaApplication.ChangeGridConfigSkin;
begin
  if not Assigned(frmMainform.frmGridConfig) then
    Exit;

  with frmMainform.frmGridConfig do
  begin
     SpTBXPanel1.Color := ctlGeneral.Style.Color;
     SpTBXPanel2.Color := ctlGeneral.Style.Color;
     scrbxGrid.Color := ctlGeneral.Style.Color;
     cbxName.Color := ctlGeneral.Style.Color;
     cbxType.Color := ctlGeneral.Style.Color;
     cbxSummary.Color := ctlGeneral.Style.Color;
     cbxFormat.Color := ctlGeneral.Style.Color;
     btnedExpression.Color := ctlGeneral.Style.Color;
     cbxDBType.Color := ctlGeneral.Style.Color;
     cbxDBField.Color := ctlGeneral.Style.Color;
     edtDefaultValue.Color := ctlGeneral.Style.Color;
     edtTabName.Color := ctlGeneral.Style.Color;
     cbxStampSize.Color := ctlGeneral.Style.Color;
     cedtStampColor.Color := ctlGeneral.Style.Color;

     cbxName.Font.Color := ctlGeneral.Style.TextColor;
     cbxType.Font.Color := ctlGeneral.Style.TextColor;
     cbxSummary.Font.Color := ctlGeneral.Style.TextColor;
     cbxFormat.Font.Color := ctlGeneral.Style.TextColor;
     btnedExpression.Font.Color := ctlGeneral.Style.TextColor;
     cbxDBType.Font.Color := ctlGeneral.Style.TextColor;
     cbxDBField.Font.Color := ctlGeneral.Style.TextColor;
     edtDefaultValue.Font.Color := ctlGeneral.Style.TextColor;
     edtTabName.Font.Color := ctlGeneral.Style.TextColor;
     cbxStampSize.Font.Color := ctlGeneral.Style.TextColor;
     cedtStampColor.Font.Color := ctlGeneral.Style.TextColor;
  end;
end;

procedure TbfaApplication.ChangeGridSkin(Grid : TObject);
var
  t : TSpTBXSkinOptionCategory;
  te : TSpTBXSkinOptionEntry;
  i : Integer;
  cl, cl2, cl3 : TColor;
begin
  try
    if (Grid is TbfaGridDBTableView) then
    begin
      TbfaGridDBTableView(Grid).clFree := stlFree.Color;
      TbfaGridDBTableView(Grid).clFreeText := stlFree.TextColor;
      TbfaGridDBTableView(Grid).clEnabledText := stlFree.Font.Color;
      TbfaGridDBTableView(Grid).clSelected := stlSelected.Color;
      TbfaGridDBTableView(Grid).clSelectedText := stlSelected.TextColor;
      TbfaGridDBTableView(Grid).clProgress := stlProgress.Color;
      TbfaGridDBTableView(Grid).clProgressSelected := stlProgressSelected.Color;
      TbfaGridDBTableView(Grid).clProgressSelectedText := stlProgressSelected.TextColor;
      TbfaGridDBTableView(Grid).clWork := stlWork.Color;
      TbfaGridDBTableView(Grid).clWorkSelected := stlWorkSelected.Color;
      TbfaGridDBTableView(Grid).clWorkSelectedText := stlWorkSelected.TextColor;
      TbfaGridDBTableView(Grid).clDone := stlDone.Color;
      TbfaGridDBTableView(Grid).clDoneSelected := stlDoneSelected.Color;
      TbfaGridDBTableView(Grid).clDoneSelectedText := stlDoneSelected.TextColor;
      TbfaGridDBTableView(Grid).clUrgent := stlUrgent.Color;
      TbfaGridDBTableView(Grid).clUrgentSelected := stlUrgentSelected.Color;
      TbfaGridDBTableView(Grid).clUrgentSelectedText := stlUrgentSelected.TextColor;
      //07.03.2024 bfacrm:ticket__show__37933 -->
      TbfaGridDBTableView(Grid).Styles.Header := stlColumn;
      TbfaGridDBTableView(Grid).Styles.Content := stlColumn;
      //07.03.2024 bfacrm:ticket__show__37933 <--
    end
    else if (Grid is TbfaDBGrid) then
    begin
      TbfaDBGrid(Grid).clFree := stlFree.Color;
      TbfaDBGrid(Grid).clFreeText := stlFree.TextColor;
      TbfaDBGrid(Grid).Color := stlControl.Color;
      TbfaDBGrid(Grid).Font.Color := stlControl.TextColor;
      TbfaDBGrid(Grid).Canvas.Brush.Color := stlControl.Color;
      TbfaDBGrid(Grid).Canvas.Font.Color := stlControl.TextColor;
      TbfaDBGrid(Grid).clSelected := stlSelected.Color;
      TbfaDBGrid(Grid).clSelectedText := stlSelected.TextColor;
      for i := 0 to TbfaDBGrid(Grid).Columns.Count - 1 do
      begin
        TbfaDBGrid(Grid).Columns[i].Color := stlColumn.Color;
        TbfaDBGrid(Grid).Columns[i].Font.Color := stlColumn.TextColor;
        TbfaDBGrid(Grid).Columns[i].Title.Color := stlColumn.Color;
        TbfaDBGrid(Grid).Columns[i].Title.Font.Color := stlColumn.TextColor;
      end;
    end;

  except
    bitfarmLog.Write(llNormal, ltException, 'ChangeGridSkin', ClassName);
  end;
end;

procedure TbfaApplication.ChangeDLMSkin;
begin
  if frmMainForm.fraAdmin <> nil then
  begin
    with frmMainForm.fraAdmin.frmDLMDialog do
    begin
      pnlDLM.Color := ctlGeneral.Style.Color;
      btnOK.Color := ctlGeneral.Style.Color;
      btnOK.Font.Color := ctlGeneral.Style.TextColor;

      grdDLMTable.Styles.Header := stlColumn;
      grdDLMTable.Styles.Footer := stlColumn;
      grdDLMTable.Styles.Content := stlColumn;
      grdDLMTable.Styles.GroupByBox := stlGroupByBoxStyle;
      grdDLMTable.Styles.Navigator := stlGroupByBoxStyle;
      grdDLMTable.Styles.NavigatorInfoPanel := stlGroupByBoxStyle;
      grdDLMTable.Styles.Background := stlBackgroundStyle;
      grdDLMTable.Styles.Group := stlBackgroundStyle;
    end;
  end;
end;

procedure TbfaApplication.ChangePreviewSkin(prev: TbfaPreview);
var
  i: Integer;
begin
  try
    prev.Color := stlControl.Color;
    prev.SingleView.img_DocView.Background := stlBackgroundStyle.Color;
    if prev.MultiView <> nil then
    begin
      prev.MultiView.Background := stlImageEn.Color;
      prev.MultiView.ThumbnailsBackground := stlImageEn.Color;
      prev.MultiView.ThumbnailsBorderColor := stlImageEn.Color;
      prev.MultiView.ThumbnailsInternalBorderColor := stlImageEn.Color;
      prev.MultiView.SelectionColor := stlImageEnSelected.Color;
      {$IFDEF ImageEn1140}
      prev.MultiView.ThumbnailsBackgroundSelected := stlImageEn.Color;
      prev.MultiView.ThumbnailsBackgroundHover := stlImageEn.Color;
      {$ENDIF}
      prev.MultiView.Refresh;
    end;
    if prev.ThumbnailView <> nil then
    begin
      prev.ThumbnailView.Background := stlImageEn.Color;
      prev.ThumbnailView.ThumbnailsBackground := stlImageEn.Color;
      prev.ThumbnailView.ThumbnailsBorderColor := stlImageEn.Color;
      prev.ThumbnailView.ThumbnailsInternalBorderColor := stlImageEn.Color;
      prev.ThumbnailView.SelectionColor := stlImageEnSelected.Color;
      {$IFDEF ImageEn1140}
      prev.ThumbnailView.ThumbnailsBackgroundSelected := stlImageEn.Color;
      prev.ThumbnailView.ThumbnailsBackgroundHover := stlImageEn.Color;
      {$ENDIF}
    end;
    prev.previewToolWindow.Color := stlControl.Color; //26.09.2018 wegen ImporterPreview wenn ThumbnailView Visible False gesetzt wird

    BgColor := stlImageEn.Color;
    slColor := stlImageEnSelected.Color;

    for i := 0 to FImportContainer.Count - 1 do
    begin
      if FImportContainer[i].ThumbnailView <> nil then
      begin
        FImportContainer[i].ThumbnailView.Background := stlImageEn.Color;
        FImportContainer[i].ThumbnailView.ThumbnailsBackground := stlImageEn.Color;
        FImportContainer[i].ThumbnailView.ThumbnailsBorderColor := stlImageEn.Color;
        FImportContainer[i].ThumbnailView.ThumbnailsInternalBorderColor := stlImageEn.Color;
        FImportContainer[i].ThumbnailView.SelectionColor := stlImageEnSelected.Color;
      end;
    end;
    ChangeGridSkin(prev.FHistoryView.grdHistory);
    prev.FHistoryView.grdHistory.Styles.Content := stlColumn;  //07.03.2024 bfacrm:ticket__show__37933
    prev.FHistoryView.grdHistory.Styles.Header := stlColumn;  //07.03.2024 bfacrm:ticket__show__37933
    ChangeGridSkin(prev.FCommentaryView.grdCommentary);
    prev.FCommentaryView.grdCommentary.Styles.Content := stlColumn;  //07.03.2024 bfacrm:ticket__show__37933
    prev.FCommentaryView.grdCommentary.Styles.Header := stlColumn;  //07.03.2024 bfacrm:ticket__show__37933
    prev.FCommentaryView.mmoComment.Color := stlControl.Color;
    prev.FCommentaryView.mmoComment.Font.Color := stlControl.TextColor;
    prev.FFulltextView.mmoFulltext.Color := stlControl.Color;
    prev.FFulltextView.mmoFulltext.Font.Color := stlControl.TextColor;
    prev.bfaTlbPreview.edtPageNumber.Color := stlControl.Color;
    prev.bfaTlbPreview.edtPageNumber.Font.Color := stlControl.TextColor;
    prev.bfaTlbPreview.cbxZoom.Color := stlControl.Color;
    prev.bfaTlbPreview.cbxZoom.Font.Color := stlControl.TextColor;
    prev.SearchbarTextEdit.Color := stlControl.Color; //13.08.2024 SD <--bfacrm:ticket__show__39501
    prev.SearchbarTextEdit.Font.Color := stlControl.TextColor; //13.08.2024 SD <--bfacrm:ticket__show__39501
  except
    bitfarmLog.Write(llNormal, ltException, 'ChangePreviewSkin', ClassName);
  end;
end;

procedure TbfaApplication.ChangeResubFrameSkin(fra: TFrame);
begin
  with TfraCreateResub(fra) do
  begin
    edtAlarm1.Color := stlControl.Color;
    edtAlarm1.Font.Color := stlControl.TextColor;
    edtAdditionalDays.Color := stlControl.Color; //13.08.2024 SD <--bfacrm:ticket__show__39501
    edtAdditionalDays.Font.Color := stlControl.TextColor; //13.08.2024 SD <--bfacrm:ticket__show__39501
    edtName.Color := stlControl.Color;
    edtName.Font.Color := stlControl.TextColor;
    edtInfoCreate.Color := stlControl.Color;
    edtInfoCreate.Font.Color := stlControl.TextColor;
    edtInfoFoward.Color := stlControl.Color;
    edtInfoFoward.Font.Color := stlControl.TextColor;
    dtDate1.Style.StyleController := ctlGeneral;
//    cbbUser.Color := stlControl.Color;  //16.08.2024 SD <--bfacrm:ticket__show__39501
    cbbUser.Color := clWhite; //16.08.2024 SD <--bfacrm:ticket__show__39501
    cbbUser.Font.Color := clBlack; //27.09.2022 Ticket 32289 stlControl.TextColor;
//    cbbGroup.Color := stlControl.Color; //16.08.2024 SD <--bfacrm:ticket__show__39501
    cbbGroup.Color := clWhite;  //16.08.2024 SD <--bfacrm:ticket__show__39501
    cbbGroup.Font.Color := clBlack; //27.09.2022 Ticket 32289 stlControl.TextColor;
    cbbFavorites.Color := stlControl.Color;
    cbbFavorites.Font.Color := stlControl.TextColor;
    cbbFavIcon.Color := stlControl.Color;
    cbbFavIcon.Font.Color := stlControl.TextColor;
  end;
end;

procedure TbfaApplication.ChangeImporterSkin;
var
  t: TSpTBXSkinOptionCategory;
  te: TSpTBXSkinOptionEntry;
  cl, sl: TColor;
begin
  try
    frmMainForm.lblDocLinksImporter.Style.StyleController := ctlGeneral;
    frmMainForm.lblDocLinksImporter.Style.BorderStyle := ebsNone;
    frmMainForm.lblDocLinksImporter.Style.TextColor := stlFree.TextColor;
    frmMainForm.lblDocTagsImporter.Style.StyleController := ctlGeneral;
    frmMainForm.lblDocTagsImporter.Style.BorderStyle := ebsNone;
    frmMainForm.lblDocTagsImporter.Style.TextColor := stlFree.TextColor;
    frmMainForm.lblDocnameImporter.Style.StyleController := ctlGeneral;
    frmMainForm.lblDocnameImporter.Style.BorderStyle := ebsNone;
    frmMainForm.lblDocnameImporter.Style.TextColor := stlFree.TextColor;
    frmMainForm.tokenDocLinks.Style.StyleController := ctlGeneral;
    frmMainForm.tokenDocTags.Style.StyleController := ctlGeneral;
    frmMainForm.tokenDocTags.Style.StyleController := ctlGeneral;

    ChangeResubFrameSkin(frmMainForm.fraImporterResub);
    ChangeResubFrameSkin(frmMainForm.frmResubDialog.fraCreateResub);

    if frmMainForm.fraScanFunctions <> nil then
    begin
      frmMainForm.fraScanFunctions.Panel1.Color := stlSelected.color;
      frmMainForm.fraScanFunctions.SpTBXGroupBox1.Color := stlControl.Color;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'ChangeImporterSkin', ClassName);
  end;
end;

procedure TbfaApplication.ChangeAdminSkin;
var
  i, j, k : Integer;
  comp, comp2, obj2 : TComponent;
begin
  try
    if frmMainForm.FAdminTreeview <> nil then
    begin
      frmMainForm.FAdminTreeview.Color := stlControl.color;
      frmMainForm.FAdminTreeview.Font.Color := stlControl.TextColor;
      frmMainForm.pnlAdmin.Color := stlControl.color;
    end;
    if frmMainForm.fraAdmin <> nil then
    begin
      frmMainForm.fraAdmin.Color := stlControl.Color;
      frmMainForm.fraAdmin.edtDocname.Color := stlControl.Color;
      frmMainForm.fraAdmin.edtDocname.Font.Color := stlControl.TextColor;
      frmMainForm.fraAdmin.edtDisplayName.Color := stlControl.Color;
      frmMainForm.fraAdmin.edtDisplayName.Font.Color := stlControl.TextColor;
      frmMainForm.fraAdmin.edtPassword.Color := stlControl.Color;
      frmMainForm.fraAdmin.edtPassword.Font.Color := stlControl.TextColor;
      frmMainForm.fraAdmin.edtEmail.Color := stlControl.Color;
      frmMainForm.fraAdmin.edtEmail.Font.Color := stlControl.TextColor;
      frmMainForm.fraAdmin.edtStationary.Color := stlControl.Color;
      frmMainForm.fraAdmin.edtStationary.Font.Color := stlControl.TextColor;
//      frmMainForm.fraAdmin.edtCheckprogram.Color := stlControl.Color;
//      frmMainForm.fraAdmin.edtCheckprogram.Font.Color := stlControl.TextColor;

//      frmMainForm.fraAdmin.edtDomain.Color := stlControl.Color;
//      frmMainForm.fraAdmin.edtDomain.Font.Color := stlControl.TextColor;
//      frmMainForm.fraAdmin.edtOU.Color := stlControl.Color;
//      frmMainForm.fraAdmin.edtOU.Font.Color := stlControl.TextColor;

      frmMainForm.fraAdmin.edtArcid.Color := stlControl.Color;
      frmMainForm.fraAdmin.edtArcid.Font.Color := stlControl.TextColor;
      frmMainForm.fraAdmin.edtGdocid.Color := stlControl.Color;
      frmMainForm.fraAdmin.edtGdocid.Font.Color := stlControl.TextColor;
      frmMainForm.fraAdmin.edtTimref.Color := stlControl.Color;
      frmMainForm.fraAdmin.edtTimref.Font.Color := stlControl.TextColor;
      frmMainForm.fraAdmin.edtLogGdocid.Color := stlControl.Color;
      frmMainForm.fraAdmin.edtLogGdocid.Font.Color := stlControl.TextColor;
      //21.08.2024 SD -->bfacrm:ticket__show__39655
      frmMainForm.fraAdmin.edtLogEntry.Color := stlControl.Color;
      frmMainForm.fraAdmin.edtLogEntry.Font.Color := stlControl.TextColor;
      //21.08.2024 SD <--bfacrm:ticket__show__39655
      frmMainForm.fraAdmin.edtGroupEmail.Color := stlControl.Color;
      frmMainForm.fraAdmin.edtGroupEmail.Font.Color := stlControl.TextColor;
      frmMainForm.fraAdmin.edtAddfieldDescription.Color := stlControl.Color;
      frmMainForm.fraAdmin.edtAddfieldDescription.Font.Color := stlControl.TextColor;
      frmMainForm.fraAdmin.edtDuration.Color := stlControl.Color;
      frmMainForm.fraAdmin.edtDuration.Font.Color := stlControl.TextColor;
      frmMainForm.fraAdmin.cbxAddfieldType.Color := stlControl.Color;
      frmMainForm.fraAdmin.cbxAddfieldType.Font.Color := stlControl.TextColor;
      frmMainForm.fraAdmin.cbxSearchMode.Color := stlControl.Color;
      frmMainForm.fraAdmin.cbxSearchMode.Font.Color := stlControl.TextColor;
      frmMainForm.fraAdmin.cbxStatefieldLink.Color := stlControl.Color;
      frmMainForm.fraAdmin.cbxStatefieldLink.Font.Color := stlControl.TextColor;
      frmMainForm.fraAdmin.cbxLinkType.Color := stlControl.Color;
      frmMainForm.fraAdmin.cbxLinkType.Font.Color := stlControl.TextColor;

//      frmMainForm.fraAdmin.cbxSuperior.Color := stlControl.Color;
//      frmMainForm.fraAdmin.cbxSuperior.Font.Color := stlControl.TextColor;
//      frmMainForm.fraAdmin.cbxHolidayUser.Color := stlControl.Color;
//      frmMainForm.fraAdmin.cbxHolidayUser.Font.Color := stlControl.TextColor;
//      frmMainForm.fraAdmin.cbxReplacement.Color := stlControl.Color;
//      frmMainForm.fraAdmin.cbxReplacement.Font.Color := stlControl.TextColor;

      frmMainForm.fraAdmin.cbxResubUser.Color := stlControl.Color;
      frmMainForm.fraAdmin.cbxResubUser.Font.Color := stlControl.TextColor;
      frmMainForm.fraAdmin.cbxResubSearchMode.Color := stlControl.Color;
      frmMainForm.fraAdmin.cbxResubSearchMode.Font.Color := stlControl.TextColor;
      frmMainForm.fraAdmin.cbxLogUser.Color := stlControl.Color;
      frmMainForm.fraAdmin.cbxLogUser.Font.Color := stlControl.TextColor;
      frmMainForm.fraAdmin.cbxUserRole.Color := stlControl.Color;
      frmMainForm.fraAdmin.cbxUserRole.Font.Color := stlControl.TextColor;
      frmMainForm.fraAdmin.cbxGroupRole.Color := stlControl.Color;
      frmMainForm.fraAdmin.cbxGroupRole.Font.Color := stlControl.TextColor;
      frmMainForm.fraAdmin.cbxArcRights.Color := stlControl.Color;
      frmMainForm.fraAdmin.cbxArcRights.Font.Color := stlControl.TextColor;
      frmMainForm.fraAdmin.cbxInterval.Color := stlControl.Color;
      frmMainForm.fraAdmin.cbxInterval.Font.Color := stlControl.TextColor;

//      frmMainForm.fraAdmin.edtWinUser.Color := stlControl.Color;
//      frmMainForm.fraAdmin.edtWinUser.Font.Color := stlControl.TextColor;
//      frmMainForm.fraAdmin.edtWinPass.Color := stlControl.Color;
//      frmMainForm.fraAdmin.edtWinPass.Font.Color := stlControl.TextColor;
//      frmMainForm.fraAdmin.dtDateStart.Style.StyleController := ctlGeneral;
//      frmMainForm.fraAdmin.dtDateStart.StyleHot.StyleController := ctlGeneral;
//      frmMainForm.fraAdmin.dtDateStart.StyleDisabled.StyleController := ctlDisabled;
//      frmMainForm.fraAdmin.dtDateStart.StyleFocused.StyleController := ctlGeneral;
//      frmMainForm.fraAdmin.dtDateEnd.Style.StyleController := ctlGeneral;
//      frmMainForm.fraAdmin.dtDateEnd.StyleHot.StyleController := ctlGeneral;
//      frmMainForm.fraAdmin.dtDateEnd.StyleDisabled.StyleController := ctlDisabled;
//      frmMainForm.fraAdmin.dtDateEnd.StyleFocused.StyleController := ctlGeneral;

      frmMainForm.fraAdmin.dtResubDate.Style.StyleController := ctlGeneral;
      frmMainForm.fraAdmin.dtResubDate.StyleHot.StyleController := ctlGeneral;
      frmMainForm.fraAdmin.dtResubDate.StyleDisabled.StyleController := ctlDisabled;
      frmMainForm.fraAdmin.dtResubDate.StyleFocused.StyleController := ctlGeneral;
      frmMainForm.fraAdmin.dtDateLogStart.Style.StyleController := ctlGeneral;
      frmMainForm.fraAdmin.dtDateLogStart.StyleHot.StyleController := ctlGeneral;
      frmMainForm.fraAdmin.dtDateLogStart.StyleDisabled.StyleController := ctlDisabled;
      frmMainForm.fraAdmin.dtDateLogStart.StyleFocused.StyleController := ctlGeneral;
      frmMainForm.fraAdmin.dtDateLogEnd.Style.StyleController := ctlGeneral;
      frmMainForm.fraAdmin.dtDateLogEnd.StyleHot.StyleController := ctlGeneral;
      frmMainForm.fraAdmin.dtDateLogEnd.StyleDisabled.StyleController := ctlDisabled;
      frmMainForm.fraAdmin.dtDateLogEnd.StyleFocused.StyleController := ctlGeneral;

      if frmMainForm.FAdminTreeview.Items.Count > 0 then
      begin
        frmmainForm.fraAdmin.LoadTreeview;
      end;
      for i := 0 to frmMainForm.fraAdmin.ComponentCount - 1 do
      begin
        comp := frmMainForm.fraAdmin.Components[i];
        if (comp is TbfaSelector) then
        begin
          TbfaSelector(comp).Color := stlControl.color;
          TbfaSelector(comp).edtFilter1.Color := stlControl.color;
          TbfaSelector(comp).edtFilter1.Font.Color := stlControl.Textcolor;
          TbfaSelector(comp).edtFilter2.Color := stlControl.color;
          TbfaSelector(comp).edtFilter2.Font.Color := stlControl.Textcolor;
          for j := 0 to comp.ComponentCount - 1 do
          begin
            comp2 := comp.Components[j];
            if (comp2 is TListView) then
            begin
              TListView(comp2).Color := stlControl.color;
              TListView(comp2).Font.Color := stlControl.TextColor;
            end
            else if (comp2 is TSpTBXPopupMenu) then
            begin
              for k := 0 to TSpTBXPopupMenu(comp2).ComponentCount - 1 do
              begin
                obj2 := TSpTBXPopupMenu(comp2).Components[k];
                if (obj2 is TSpTBXItem) or (obj2 is TSpTBXSubmenuItem) then
                  TSpTBXItem(obj2).FontSettings.Color := stlControl.TextColor;
              end;
            end;
          end;
        end
        else if (comp is TbfaInputEdit) then
        begin
          TbfaInputEdit(comp).Color := stlControl.color;
          TbfaInputEdit(comp).pnl1.Color := stlControl.color;
          TbfaInputEdit(comp).edtInput.Color := stlControl.color;
          TbfaInputEdit(comp).edtInput.Font.color := stlControl.Textcolor;
        end
        else if (comp is TbfaInputCombo) then
        begin
          TbfaInputCombo(comp).Color := stlControl.color;
          TbfaInputCombo(comp).pnl1.Color := stlControl.color;
          TbfaInputCombo(comp).cbbInput.Color := stlControl.color;
          TbfaInputCombo(comp).cbbInput.Font.color := stlControl.Textcolor;
        end
        else if (comp is TSpTBXCheckListBox) then
        begin
          TSpTBXCheckListBox(comp).Color := stlControl.color;
          TSpTBXCheckListBox(comp).Font.Color := stlControl.TextColor;
        end
        else if (comp is TListView) then
        begin
          TListView(comp).Color := stlControl.color;
          TListView(comp).Font.Color := stlControl.TextColor;
        end
      end;
      ChangeGridSkin(frmMainForm.fraAdmin.bfagrid);

      with frm_Message do
      begin
        Color := stlControl.Color;
        Font.Color := stlControl.TextColor;
      end;
      with frmMainForm.frmListItems do
      begin
        Color := stlControl.Color;
        Font.Color := stlControl.TextColor;
        lbItems.Color := stlControl.Color;
        lbItems.Font.Color := stlControl.TextColor;
        bfaInputEdit1.edtInput.Color := stlControl.Color;
        bfaInputEdit1.edtInput.Font.Color := stlControl.TextColor;
      end;
      with frmMainForm.frmLinkMails do
      begin
        Color := stlControl.Color;
        Font.Color := stlControl.TextColor;
        mmoBody.Color := stlControl.Color;
        mmoBody.Font.Color := stlControl.TextColor;
        edtRecp.Color := stlControl.Color;
        edtRecp.Font.Color := stlControl.TextColor;
        bfsLinkMail.edtFilter1.Color := stlControl.Color;
        bfsLinkMail.edtFilter1.Font.Color := stlControl.TextColor;
        bfsLinkMail.edtFilter2.Color := stlControl.Color;
        bfsLinkMail.edtFilter2.Font.Color := stlControl.TextColor;
        bfsLinkMail.lvList1.Color := stlControl.Color;
        bfsLinkMail.lvList1.Font.Color := stlControl.TextColor;
        bfsLinkMail.lvList2.Color := stlControl.Color;
        bfsLinkMail.lvList2.Font.Color := stlControl.TextColor;
      end;
      with frmMainForm.fraAdmin.frmContractMgmt do
      begin
        Color := stlControl.Color;
        Font.Color := stlControl.TextColor;
        for i := 0 to ComponentCount - 1 do
        begin
          comp := Components[i];
          if (comp is TSpTBXPanel) then
          begin
            TSpTBXPanel(comp).Color := stlControl.color;
            TSpTBXPanel(comp).Font.color := stlControl.Textcolor;
          end
          else if (comp is TSpTBXButtonEdit) then
          begin
            TbfaInputCombo(comp).Color := stlControl.color;
            TbfaInputCombo(comp).Font.color := stlControl.Textcolor;
          end
          else if (comp is TSpTBXSpinEdit) then
          begin
            TbfaInputCombo(comp).Color := stlControl.color;
            TbfaInputCombo(comp).Font.color := stlControl.Textcolor;
          end
          else if (comp is TSpTBXComboBox) then
          begin
            TbfaInputCombo(comp).Color := stlControl.color;
            TbfaInputCombo(comp).Font.color := stlControl.Textcolor;
          end
          else if (comp is TSpTBXEdit) then
          begin
            TbfaInputCombo(comp).Color := stlControl.color;
            TbfaInputCombo(comp).Font.color := stlControl.Textcolor;
          end;
        end;
      end;
    end;
    if frmMainForm.fraAdminScrollBox <> nil then
      frmMainForm.fraAdminScrollBox.Color := stlControl.color;
  except
    bitfarmLog.Write(llNormal, ltException, 'ChangeAdminSkin', ClassName);
  end;
end;

procedure TbfaApplication.ChangeDocLinkListSkin;
begin
  try
    if frmMainForm.fraDocLinks <> nil then
    begin
      frmMainForm.fraDocLinks.Color := stlControl.Color;
      frmMainForm.fraDocLinks.Font.Color := stlControl.TextColor;
      frmMainForm.fraDocLinks.edtDocLink.Color := stlControl.Color;
      frmMainForm.fraDocLinks.edtDocLink.Font.Color := stlControl.TextColor;
      frmMainForm.fraDocLinks.SpTBXPanel1.Color := stlControl.Color;
      frmMainForm.fraDocLinks.lvwDocLink.Color := stlControl.Color;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'ChangeDocLinkListSkin', ClassName);
  end;
end;

procedure TbfaApplication.ChangeResubFrameColor(fraResub : TfraResub);
begin
  try
    fraResub.Color := stlControl.Color;
    fraResub.edtResubInfo.Color := stlControl.Color;
    fraResub.edtResubInfo.Font.Color := stlControl.TextColor;
    fraResub.edtResubComment.Color := stlControl.Color;
    fraResub.edtResubComment.Font.Color := stlControl.TextColor;
    fraResub.cbbUserGroups.Color := stlControl.Color;
    fraResub.cbbUserGroups.Font.Color := stlControl.TextColor;
    fraResub.tbiResubWork.Color := stlControl.Color;
    fraResub.ResubScrollBox.Color := stlControl.Color;
  except
  end;
end;

procedure TbfaApplication.SetOptionsFormColor;
begin
  bitfarmLog.DebugBegin(llDebug, 'SetOptionsFormColor', Classname);
  try
    try
      if frmMainForm.frmOptions <> nil then
      begin
        frmMainForm.frmOptions.SpTBXPanel1.Color := stlControl.Color;
        frmMainForm.frmOptions.tbScanProfiles.Color := stlControl.Color;
        frmMainForm.frmOptions.imgPreView.Background := stlControl.Color;
        frmMainForm.frmOptions.cbxScanProfile.Style.StyleController := ctlGeneral;
        frmMainForm.frmOptions.cbbHotkey.Style.StyleController := ctlGeneral;

        frmMainForm.frmOptions.fraCreateResub.dtDate1.Style.StyleController := ctlGeneral;
        frmMainForm.frmOptions.fraCreateResub.Color := stlControl.Color;
        frmMainForm.frmOptions.fraCreateResub.SpTBXPanel1.Color := stlControl.Color;
        frmMainForm.frmOptions.fraCreateResub.edtAlarm1.Color := stlControl.Color;
        frmMainForm.frmOptions.fraCreateResub.edtAlarm1.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.fraCreateResub.edtAdditionalDays.Color := stlControl.Color; //13.08.2024 SD <--bfacrm:ticket__show__39501
        frmMainForm.frmOptions.fraCreateResub.edtAdditionalDays.Font.Color := stlControl.TextColor; //13.08.2024 SD <--bfacrm:ticket__show__39501
        frmMainForm.frmOptions.fraCreateResub.edtName.Color := stlControl.Color;
        frmMainForm.frmOptions.fraCreateResub.edtName.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.fraCreateResub.edtInfoCreate.Color := stlControl.Color;
        frmMainForm.frmOptions.fraCreateResub.edtInfoCreate.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.fraCreateResub.edtInfoFoward.Color := stlControl.Color;
        frmMainForm.frmOptions.fraCreateResub.edtInfoFoward.Font.Color := stlControl.TextColor;
        //16.08.2024 SD -->bfacrm:ticket__show__39501
//        frmMainForm.frmOptions.fraCreateResub.cbbUser.Color := stlControl.Color;
//        frmMainForm.frmOptions.fraCreateResub.cbbUser.Font.Color := stlControl.TextColor;
//        frmMainForm.frmOptions.fraCreateResub.cbbGroup.Color := stlControl.Color;
//        frmMainForm.frmOptions.fraCreateResub.cbbGroup.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.fraCreateResub.cbbUser.Color := clWhite;
        frmMainForm.frmOptions.fraCreateResub.cbbUser.Font.Color := clBlack;
        frmMainForm.frmOptions.fraCreateResub.cbbGroup.Color := clWhite;
        frmMainForm.frmOptions.fraCreateResub.cbbGroup.Font.Color := clBlack;
        //16.08.2024 SD <--bfacrm:ticket__show__39501
        frmMainForm.frmOptions.fraCreateResub.cbbFavorites.Color := stlControl.Color;
        frmMainForm.frmOptions.fraCreateResub.cbbFavorites.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.fraCreateResub.cbbFavIcon.Color := stlControl.Color;
        frmMainForm.frmOptions.fraCreateResub.cbbFavIcon.Font.Color := stlControl.TextColor;

        frmMainForm.frmOptions.edtDefaultSaveDirectory.Color := stlControl.Color;
        frmMainForm.frmOptions.edtDefaultSaveDirectory.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.cbxDocumentPrinter.Color := stlControl.Color;
        frmMainForm.frmOptions.cbxDocumentPrinter.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.cbxTimeServer.Color := stlControl.Color;
        frmMainForm.frmOptions.cbxTimeServer.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.cbxStartingArea.Color := stlControl.Color;
        frmMainForm.frmOptions.cbxStartingArea.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.lblHotkey.Color := stlControl.Color;
        frmMainForm.frmOptions.lblHotkey.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.edtHotKeyOcr.Color := stlControl.Color;
        frmMainForm.frmOptions.edtHotKeyOcr.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.cbxAutoZoom.Color := stlControl.Color;
        frmMainForm.frmOptions.cbxAutoZoom.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.cbxLimit.Color := stlControl.Color;
        frmMainForm.frmOptions.cbxLimit.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.cbxHistoryBookmarksLimit.Color := stlControl.Color;
        frmMainForm.frmOptions.cbxHistoryBookmarksLimit.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.edtFilter.Color := stlControl.Color;
        frmMainForm.frmOptions.edtFilter.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.cbxScannerName.Color := stlControl.Color;
        frmMainForm.frmOptions.cbxScannerName.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.cbxColorMode.Color := stlControl.Color;
        frmMainForm.frmOptions.cbxColorMode.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.cbxCompression.Color := stlControl.Color;
        frmMainForm.frmOptions.cbxCompression.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.cbxDPI.Color := stlControl.Color;
        frmMainForm.frmOptions.cbxDPI.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.cbxFormat.Color := stlControl.Color;
        frmMainForm.frmOptions.cbxFormat.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.cbxOrientation.Color := stlControl.Color;
        frmMainForm.frmOptions.cbxOrientation.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.cbxTransfer.Color := stlControl.Color;
        frmMainForm.frmOptions.cbxTransfer.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.edtContrast.Color := stlControl.Color;
        frmMainForm.frmOptions.edtContrast.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.edtBrightness.Color := stlControl.Color;
        frmMainForm.frmOptions.edtBrightness.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.edtThreshold.Color := stlControl.Color;
        frmMainForm.frmOptions.edtThreshold.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.edtFrameLeft.Color := stlControl.Color;
        frmMainForm.frmOptions.edtFrameLeft.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.edtFrameTop.Color := stlControl.Color;
        frmMainForm.frmOptions.edtFrameTop.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.edtFrameRight.Color := stlControl.Color;
        frmMainForm.frmOptions.edtFrameRight.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.edtFrameBottom.Color := stlControl.Color;
        frmMainForm.frmOptions.edtFrameBottom.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.cbxFilter.Color := stlControl.Color;
        frmMainForm.frmOptions.cbxFilter.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.edtDeletePages.Color := stlControl.Color;
        frmMainForm.frmOptions.edtDeletePages.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.cbbTimerInterval.Color := stlControl.Color;
        frmMainForm.frmOptions.cbbTimerInterval.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.cbbName.Color := stlControl.Color;
        frmMainForm.frmOptions.cbbName.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.cbxDefaultArchiveGroupRights.Color := stlControl.Color;
        frmMainForm.frmOptions.cbxDefaultArchiveGroupRights.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.cbxDefaultAddfieldGroupRights.Color := stlControl.Color;
        frmMainForm.frmOptions.cbxDefaultAddfieldGroupRights.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.cbxDefaultStatefieldGroupRights.Color := stlControl.Color;
        frmMainForm.frmOptions.cbxDefaultStatefieldGroupRights.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.edtHotKey.Color := stlControl.Color;
        frmMainForm.frmOptions.edtHotKey.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.edtName.Color := stlControl.Color;
        frmMainForm.frmOptions.edtName.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.cbbHotkeyStore.Color := stlControl.Color;
        frmMainForm.frmOptions.cbbHotKeyStore.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.cbbHotkeyArchive.Color := stlControl.Color;
        frmMainForm.frmOptions.cbbHotkeyArchive.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.cbbProfil.Color := stlControl.Color;
        frmMainForm.frmOptions.cbbProfil.Font.Color := stlControl.TextColor;
        frmMainForm.frmOptions.cbxLogLevel.Color := stlControl.Color;
        frmMainForm.frmOptions.cbxLogLevel.Font.Color := stlControl.TextColor;
        {$IFDEF ENTERPRISE}
        TfrmOptionsFormEnterprise(frmMainForm.frmOptions).cbxUpdate.Color := stlControl.Color;
        TfrmOptionsFormEnterprise(frmMainForm.frmOptions).cbxUpdate.Font.Color := stlControl.TextColor;
        TfrmOptionsFormEnterprise(frmMainForm.frmOptions).edtPluginTimeOut.Color := stlControl.Color;
        TfrmOptionsFormEnterprise(frmMainForm.frmOptions).edtPluginTimeOut.Font.Color := stlControl.TextColor;


        if Assigned(TfrmOptionsFormEnterprise(frmMainForm.frmOptions).lstPluginButtons) then
          TfrmOptionsFormEnterprise(frmMainForm.frmOptions).lstPluginButtons.Color :=
            stlControl.Color;
        {$ENDIF}
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'SetOptionsFormColor', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetOptionsFormColor', Classname);
  end;
end;

procedure TbfaApplication.ChangeObjectsSkin;
var
  i, j, k: Integer;
  reloadtv: Boolean;
  obj, obj1, obj2, obj3: TObject;
begin
  try
// Treeviews
    reloadtv := False;
    frmMainForm.FViewerTreeview.Color := stlControl.Color;
    frmMainForm.FViewerTreeview.Font.Color := stlControl.TextColor;
    reloadtv := (frmMainForm.FViewerTreeview.Font.Size <> TVFontSize);
    frmMainForm.FViewerTreeview.Font.Size := TVFontSize;
    frmMainForm.FImporterTreeview.Color := stlControl.Color;
    frmMainForm.FImporterTreeview.Font.Color := stlControl.TextColor;
    reloadtv := reloadtv or (frmMainForm.FImporterTreeview.Font.Size <> TVFontSize);
    frmMainForm.FImporterTreeview.Font.Size := TVFontSize;
    if frmMainForm.trvBookmarks <> nil then
    begin
      frmMainForm.trvBookmarks.Color := stlControl.Color;
      frmMainForm.trvBookmarks.Font.Color := stlControl.TextColor;
      if frmMainForm.trvBookmarks.Font.Size <> TVFontSize then
        frmMainForm.LoadBookmarks;
      frmMainForm.trvBookmarks.Font.Size := TVFontSize;
    end;
    if reloadtv then
    //25.01.2023 bfacrm:ticket__show__33644 -->
    //    ReloadTrees(true); hat so einen ChangeArchive ausgelst
    begin
      frmMainForm.FViewerTreeview.FSkipChangeEvents := True;
      frmMainForm.FViewerTreeview.ChangeDelay := 0;
      frmMainForm.FImporterTreeview.FSkipChangeEvents := True;
      frmMainForm.FImporterTreeview.ChangeDelay := 0;
      try
      ReloadTrees(true);
      finally
        frmMainForm.FViewerTreeview.FSkipChangeEvents := False;
        frmMainForm.FViewerTreeview.ChangeDelay := tvChangeDelay;
        frmMainForm.FImporterTreeview.FSkipChangeEvents := False;
      frmMainForm.FImporterTreeview.ChangeDelay := tvChangeDelay;
      end;
    end;
    //25.01.2023 bfacrm:ticket__show__33644 <--

// SpTBX Controls
    frmMainForm.dckDocumentEditors.Color := stlControl.Color;
    frmMainForm.grpIndexing.Color := stlControl.Color;
    frmMainForm.pnlTreeView.Color := stlControl.Color;
    frmMainForm.pnlImporter.Color := stlControl.Color;
    frmmainForm.grbImporterResub.Color := stlControl.Color;
    frmmainForm.grbImporterResub.Font.Color := stlControl.TextColor;
    frmMainForm.pnlPreview.Color := stlControl.Color;
    frmMainForm.pnlFavorites.Color := stlControl.Color;
    if frmMainForm.pnlAdmin <> nil then
      frmMainForm.pnlAdmin.Color := stlControl.Color;

    frmMainForm.pnlResubmission.Color := stlControl.Color;

    if frmMainForm.fraResub <> nil then
      ChangeResubFrameColor(frmMainForm.fraResub);
    if (frmMainForm.fraFloatingResub <> nil) and (frmMainForm.fraFloatingResub.fraResub <> nil) then
      ChangeResubFrameColor(frmMainForm.fraFloatingResub.fraResub);
    if frmMainForm.fraWorkplace <> nil then
    begin
      frmMainForm.fraWorkplace.Color := stlControl.Color;
      frmMainForm.fraWorkplace.SpTBXGroupBox1.Color := stlControl.Color;
      frmMainForm.pnlWorkspace.Color := stlControl.Color;
    end;
    frmMainForm.scrbxStandard.Color := stlControl.Color;
    frmMainForm.scrbxViewerAddfields.Color := stlControl.Color;
    frmMainForm.scrbxAddfields2.Color := stlControl.Color;
    frmMainForm.scrbxStandardImporter.Color := stlControl.Color;
    ChangeDocLinkListSkin;
    if frmMainForm.frmOptions <> nil then
      SetOptionsFormColor;

    if frmMainForm.frmResubDialog <> nil then
    begin
      frmMainForm.frmResubDialog.Color := stlControl.Color;
      frmMainForm.frmResubDialog.SpTBXPanel1.Color := stlControl.Color;
      frmMainForm.frmResubDialog.fraCreateResub.Color := stlControl.Color;
      frmMainForm.frmResubDialog.fraCreateResub.SpTBXPanel1.Color :=
      stlControl.Color;
    end;

    frmMainForm.pnlSearchTimer.Color := stlControl.Color;
    frmMainForm.pnlSearchTimer.Font.Color := stlControl.TextColor;

    for i := 0 to frmMainForm.ComponentCount - 1 do
    begin
      obj := frmMainForm.Components[i];
      if (obj is TFrame) then
      begin
        TFrame(obj).Color := stlControl.Color;
        for j := 0 to TFrame(obj).ComponentCount - 1 do
        begin
          obj2 := TFrame(obj).Components[j];
          if (obj2 is TSpTBXPanel) then
            TSpTBXPanel(obj2).Color := stlControl.Color;
        end;
      end
      else if (obj is TSpTBXPopupMenu) then
      begin
//        TSpTBXPopupMenu(obj).Color := stlControl.Color;
        for j := 0 to TSpTBXPopupMenu(obj).ComponentCount - 1 do
        begin
          obj2 := TSpTBXPopupMenu(obj).Components[j];
          if (obj2 is TSpTBXItem) or (obj2 is TSpTBXSubmenuItem) then
            TSpTBXItem(obj2).FontSettings.Color := stlControl.TextColor;
        end;
      end
      else if (obj is TPanel) then
      begin
        TPanel(obj).Color := stlControl.Color;
      end
      else if (obj is TListView) then
      begin
        TListView(obj).Color := stlControl.Color;
      end
      else if (obj is TSptbxPanel) and (not (obj is TBfaAddfieldComp)) then
      begin
        TSptbxPanel(obj).Color := stlControl.Color;
        for j := 0 to TSptbxPanel(obj).ComponentCount - 1 do
        begin
          obj2 := TSptbxPanel(obj).Components[j];
          if (obj2 is TPanel) then
            TPanel(obj2).Color := stlControl.Color;
        end;
      end;

//03.08.2022 Ticket 31788 FontSize nderung kann noch spter gebraucht werden -->
//      if bfaFontSize <> BFAFONT then
//      begin
        frmMainForm.Font.Size := bfaFontSize;
        frmMainForm.tcSearch.Font.Size := bfaFontSize;
//      end;
//      if bfaFontSettingsSize <> BFAFONTSETTINGS then
//      begin
        frmMainForm.tabSearchStandard.FontSettings.Size := bfaFontSettingsSize;
        frmMainForm.tabSearchAddfields.FontSettings.Size := bfaFontSettingsSize;
        frmMainForm.tabSearchLinks.FontSettings.Size := bfaFontSettingsSize;

        if (obj is TSpTBXItem) or (obj is TSpTBXSubMenuItem) or (obj is TSpTBXLabelItem)  then
          TSpTBXItem(obj).FontSettings.Size := bfaFontSettingsSize
        else
        if (obj is TSpTBXToolbar) then
        begin
          for j := 0 to TSpTBXToolbar(obj).ComponentCount - 1 do
          begin
            obj2 := TSpTBXToolbar(obj).Components[j];
            if (obj2 is TSpTBXItem) or (obj2 is TSpTBXSubMenuItem) or (obj2 is TSpTBXLabelItem) then
              TSpTBXItem(obj2).FontSettings.Size := bfaFontSettingsSize;
            for k := 0 to TSpTBXToolbar(obj).Items.Count - 1 do
            begin
              obj3 := TSpTBXToolbar(obj).Items[k];
              if (obj3 is TSpTBXItem) or (obj3 is TSpTBXSubMenuItem) then
                TSpTBXItem(obj3).FontSettings.Size := bfaFontSettingsSize;
            end;
          end;
        end
        else if (obj is TSpTBXSkinGroupItem) then
        begin
          for k := 0 to TSpTBXSkinGroupItem(obj).Count - 1 do
          begin
            obj3 := TSpTBXSkinGroupItem(obj)[k];
            if (obj3 is TSpTBXItem) or (obj3 is TSpTBXSubMenuItem) then
              TSpTBXItem(obj3).FontSettings.Size := bfaFontSettingsSize;
          end;
        //end;
        //end
        //else if (obj is frmMainForm.tlbMainMenu) then
        //begin
          //for j := 0 to frmMainForm.tlbMainMenu.ComponentCount - 1 do
          //begin
            //obj2 := frmMainForm.tlbMainMenu.Components[j];
            //if (obj2 is TSpTBXItem) or (obj2 is TSpTBXSubMenuItem) or (obj2 is TSpTBXLabelItem) then
              //TSpTBXItem(obj2).FontSettings.Size := bfaFontSettingsSize
            //else if (obj2 is TSpTBXToolBar) then
            //begin
              //for k := 0 to TSpTBXToolbar(obj2).Items.Count - 1 do
              //begin
                //obj3 := TSpTBXToolbar(obj2).Items[k];
                //if (obj3 is TSpTBXItem) or (obj3 is TSpTBXSubMenuItem) then
                  //TSpTBXItem(obj3).FontSettings.Size := bfaFontSettingsSize;
              //end;
            //end
            //else if (obj2 is TSpTBXSkinGroupItem) then
            //begin
              //for k := 0 to TSpTBXSkinGroupItem(obj2).Count - 1 do
              //begin
                //obj3 := TSpTBXSkinGroupItem(obj2)[k];
                //if (obj3 is TSpTBXItem) or (obj3 is TSpTBXSubMenuItem) then
                  //TSpTBXItem(obj3).FontSettings.Size := bfaFontSettingsSize;
              //end;
            //end;
          //end;
        end
        else if (obj is TFrame) then
        begin
          for j := 0 to TFrame(obj).ComponentCount - 1 do
          begin
            obj2 := TFrame(obj).Components[j];
            if (obj2 is TSpTBXToolBar) then
            begin
              for k := 0 to TSpTBXToolbar(obj2).ComponentCount - 1 do
              begin
                obj3 := TSpTBXToolbar(obj2).Components[k];
                if (obj3 is TSpTBXItem) or (obj3 is TSpTBXSubMenuItem) then
                  TSpTBXItem(obj3).FontSettings.Size := bfaFontSettingsSize;
              end;
            end;
          end;
        end
        else if (obj is TSpTBXStatusBar) then
        begin
          for j := 0 to TSpTBXStatusBar(obj).Items.Count - 1 do
          begin
            obj2 := TSpTBXStatusBar(obj).Items[j];
            if (obj2 is TSpTBXItem) or (obj2 is TSpTBXSubMenuItem) or (obj2 is TSpTBXLabelItem) then
              TSpTBXItem(obj2).FontSettings.Size := bfaFontSettingsSize;
          end;
        end
        else if (obj is TSpTBXPopupMenu) then
        begin
          for j := 0 to TSpTBXPopupMenu(obj).ComponentCount - 1 do
          begin
            obj2 := TSpTBXPopupMenu(obj).Components[j];
            if (obj2 is TSpTBXItem) or (obj2 is TSpTBXSubMenuItem) then
              TSpTBXItem(obj2).FontSettings.Size := bfaFontSettingsSize;
          end;
        end
        else if (obj is TSpTBXtabSet) then
        begin
          for j := 0 to TSpTBXtabSet(obj).Items.Count - 1 do
          begin
            obj2 := TSpTBXtabSet(obj).Items[j];
            if (obj2 is TSpTBXTabItem) then
              TSpTBXTabItem(obj2).FontSettings.Size := bfaFontSettingsSize;
          end;
        end
        ;
//      end;
//03.08.2022 Ticket 31788 FontSize nderung kann noch spter gebraucht werden <--
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'ChangeObjectsSkin', ClassName);
  end;
end;

procedure TbfaApplication.FillImporterFields;
begin
  bitfarmLog.DebugBegin(llDebug, 'FillImporterFields', Classname);
  try
    try
      frmMainForm.edtDocName.Text := '';
      if FCurrentContainer.Count = 1 then
      begin
        if FCurrentContainer[0].ImporterDocNameModified or FViewerOptions.GeneralOptions.UseFileNameAsDocName then
          frmMainForm.edtDocName.Text := FCurrentContainer[0].DocName;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'FillImporterFields', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'FillImporterFields', Classname);
  end;
end;

procedure TbfaApplication.SetImporterDocName(Value: string);
begin
  bitfarmLog.DebugBegin(llDebug, 'SetImporterDocName', Classname);
  try
    try
      frmMainForm.edtDocName.Text := Value;
    except
      bitfarmLog.Write(llNormal, ltException, 'SetImporterDocName', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetImporterDocName', Classname);
  end;
end;

procedure TbfaApplication.DoChangeSkin;
var
  sle : TSpTBXSkinsListEntry;
  i : Integer;
  ini : TInifile;
//  {$IFDEF DEVEXSKIN}
//  DarkSkin : Integer;
//  {$ENDIF}
begin
  try
    try
      if SkinManager.SkinsList.TryGetValue(SkinManager.CurrentSkinName, sle) then
        frmMainForm.FSelectedSkinName := SkinManager.CurrentSkinName
      else
        frmMainForm.FSelectedSkinName := '';
    //14.06.2019 10.3 <--
      frmMainForm.FSelectedSkinIndex := -1;

    //15.07.2020 hier werden die Extra Farben ausgelesen, die man durch .skn Datei ndern kann
      if FileExists(ExtractFilePath(Application.ExeName) + 'Viewer-files\Skins\' +
        SkinManager.CurrentSkinName + '.skn') then
      begin
        ini := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'Viewer-files\Skins\' +
        SkinManager.CurrentSkinName + '.skn');
        try
          //zum Testen eingebaut
          gclLime := ini.ReadInteger('Skin', 'clLime', gclLime);
          gclRed := ini.ReadInteger('Skin', 'clRed', gclRed);
          gclGreen := ini.ReadInteger('Skin', 'clGreen', gclGreen);
          gclBlue := ini.ReadInteger('Skin', 'clBlue', gclBlue);
          gclDarkRed := ini.ReadInteger('Skin', 'clDarkRed', gclDarkRed);
          gclBrown := ini.ReadInteger('Skin', 'clBrown', gclBrown);
          gclYellow := ini.ReadInteger('Skin', 'clYellow', gclYellow);
          gclOlive := ini.ReadInteger('Skin', 'clOlive', gclOlive);
          gclTeal := ini.ReadInteger('Skin', 'clTeal', gclTeal);

          cColorWhite := ini.ReadInteger('Skin', 'cColorWhite', $00FFFFFF);
    //        {$IFDEF DEVEXSKIN}
    //        DarkSkin := ini.ReadInteger('Skin', 'DarkSkin', 0);
    //        {$ENDIF}
          TVFontSize := ini.ReadInteger('Skin', 'TVFontSize', BFAFONT);
    //03.08.2022 Ticket 31788 FontSize nderung kann noch spter gebraucht werden -->
          bfaFontSize := ini.ReadInteger('Skin', 'bfaFontSize', BFAFONT);
          bfaFontSettingsSize := ini.ReadInteger('Skin', 'bfaFontSettingsSize', BFAFONTSETTINGS);
          if bfaFontSettingsSize <> BFAFONTSETTINGS then
            bfaFontSettingsSize := bfaFontSettingsSize * 10; //Dann kann man als normale Fontgre ins Ini speichern
    //03.08.2022 Ticket 31788 FontSize nderung kann noch spter gebraucht werden <--
        finally
          FreeAndNil(ini);
        end;
      end
      else
      begin
        // die standardwerte zurcksetzen zum Testen eingebaut
        gclLime := $0076D6BC; //15.04.2021 clLime;
        gclRed := $001C44C7; //15.04.2021 $003442E3;
        gclBlue := $00D8A275; //15.04.2021 $00825305;
        gclGreen := $0076D6BC; //15.04.2021
        gclDarkRed := $002828FF;
        gclBrown := $003A3A70;
        gclYellow := $0048D3EF; //15.04.2021 $00FFFF;
        gclOlive := clOlive;
        gclTeal := clTeal;

        cColorRequiredField := $00CAE4FF;
        cColorLightGreen := $00E1FFE6; // Hellgrn - fr genderte Felder
        cColorLightBlue := $00F1FFC6; // fr genderte und gesuchte Felder
        cColorNoRightInit := $00E0E0E0;
        cColorNoRight := $00E0E0E1; //c0e1ff  //00a3d4ff   //adb4de  //hellrotbraun //No right 1
        cColorNoRightChg := $00adb4ff; //c0e1ff  //00a3d4ff   //adb4de  //hellrotbraun //No right 2
        cColorNoRightStat := $008489a9; //c0e1ff  //00a3d4ff   //8489a9  //rotbraun  //No right fr Status
        cColorWhite := $00FFFFFF;
        cColorRed := $000000FF;
        cColorBlack := $00000000;
        cColorGray := $00808080;
        cColorOrange := $001FA2F5; //15.04.2021 $000080ff;
        TVFontSize := BFAFONT;
        bfaFontSize := BFAFONT;
        bfaFontSettingsSize := BFAFONTSETTINGS;
    //      {$IFDEF DEVEXSKIN}
    //       DarkSkin := 0;
    //      {$ENDIF}
      end;

    //    {$IFDEF DEVEXSKIN}
    //    if DarkSkin = 1 then
    //    begin
    //      frmMainForm.dxSkinController1.NativeStyle := False;
    //      frmMainForm.dxSkinController1.SkinName := 'bitfarm_dark';
    //      frmMainForm.dxSkinController1.UseSkins := True;
    //    end
    //    else
    //    begin
    //      frmMainForm.dxSkinController1.NativeStyle := True;
    //      frmMainForm.dxSkinController1.SkinName := '';
    //      frmMainForm.dxSkinController1.UseSkins := False;
    //    end;
    //    {$ENDIF}

      ChangeDevexpSkin;
      ChangeGridSkin(frmMainForm.grdResultlistDevExView);
      frmMainForm.bfaTlbPreview1.edtPageNumber.Color := stlControl.Color;
      frmMainForm.bfaTlbPreview1.edtPageNumber.Font.Color := stlControl.TextColor;
      frmMainForm.bfaTlbPreview1.cbxZoom.Color := stlControl.Color;
      frmMainForm.bfaTlbPreview1.cbxZoom.Font.Color := stlControl.TextColor;

      if Assigned(frmMainForm.fraFloatingResub) then
      begin
        ChangeGridSkin(frmMainForm.fraFloatingResub.grdResubResultlistDevExView);
        if frmMainForm.fraFloatingResub.fraResub <> nil then
        begin
          frmMainForm.fraFloatingResub.Color := stlControl.Color;
          frmMainForm.fraFloatingResub.fraResub.Color := stlControl.Color;
          frmMainForm.fraFloatingResub.fraResub.edtResubInfo.Color := stlControl.Color;
          frmMainForm.fraFloatingResub.fraResub.edtResubComment.Color := stlControl.Color;
          frmMainForm.fraFloatingResub.fraResub.cbbUserGroups.Color := stlControl.Color;
          frmMainForm.fraFloatingResub.fraResub.tbiResubWork.Color := stlControl.Color;
          frmMainForm.fraFloatingResub.fraResub.ResubScrollBox.Color := stlControl.Color;
          frmMainForm.fraFloatingResub.fraResub.edtResubInfo.Font.Color := stlControl.TextColor;
          frmMainForm.fraFloatingResub.fraResub.edtResubComment.Font.Color := stlControl.TextColor;
          frmMainForm.fraFloatingResub.fraResub.cbbUserGroups.Font.Color := stlControl.TextColor;
        end;
      end;
      for i := 0 to bitfarmApp.PreviewContainer.Containers.Count - 1 do
        bitfarmApp.ChangePreviewSkin(bitfarmApp.PreviewContainer.Containers[i].Preview);
      bitfarmApp.ChangeObjectsSkin;
      bitfarmApp.ChangeImporterSkin;
      bitfarmApp.ChangeAdminSkin;
      bitfarmApp.ChangeGridConfigSkin;
      bitfarmApp.ChangeDLMSkin;
    except
      bitfarmLog.Write(llNormal, ltException, 'DoChangeSkin', ClassName);
    end;
  finally
    bitfarmApp.ChangeSkinRunning := False;  //25.01.2023 bfacrm:ticket__show__33644
  end;
end;

procedure TbfaApplication.ChangeSkin(AThread: TThread);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'ChangeSkin', Classname);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          DoChangeSkin;
        end);

      if frmMainForm.fAppStarted then
      begin
        UserAction := bitfarmApp.CreateUserAction;
        UserAction^.ActionName := 'actRefreshWorkplaceMultiview';
        UserAction^.params.Add('0');
        bitfarmApp.MainThread.Add(UserAction);

        UserAction := bitfarmApp.CreateUserAction;
        UserAction^.ActionName := 'actRefreshImporterMultiview';
        UserAction^.params.Add('0');
        bitfarmApp.MainThread.Add(UserAction);
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'ChangeSkin', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ChangeSkin', Classname);
  end;
end;

function TbfaApplication.GetAddfieldByID(id: Integer): TbfaAddfield;
begin
  result := nil;
  if id <= High(aAddfields) then
  begin
    result := TbfaAddField.Create;
    result.Clone(aAddfields[id]);
  end;
end;

function TbfaApplication.GetAddfieldByName(name: string): TbfaAddfield;
begin
  result := nil;
  for var i := 0 to High(aAddfields) do
  begin
    if aAddfields[i] = nil then
      Continue;
    if aAddfields[i].Name = name then
    begin
      result := TbfaAddField.Create;
      result.Clone(aAddfields[i]);
      Break;
    end;
  end;
end;

{$IFNDEF DISABLE_HISTORY_FUTURE_DELETE} // SJ 14.07.2023 - bfacrm:ticket__show__35313
procedure TbfaApplication.SetDeleteFutureHistoryNodes(const Value: TbfaSearch);
begin
  FDeleteFutureHistoryNodes := Value;
end;
{$ENDIF}

function TbfaApplication.GetDesktopFolder: string;
var
  PIDList: PItemIDList;
  Buffer: array[0..MAX_PATH - 1] of Char;
begin
  result := '';
  SHGetSpecialFolderLocation(Application.Handle, CSIDL_DESKTOP, PIDList);
  if Assigned(PIDList) then
    if SHGetPathFromIDList(PIDList, Buffer) then
      result := Buffer;
end;

function TbfaApplication.CreateDesktopShellLink(const DocName: string; const DocID: Integer): Boolean;
var
  IObject: IUnknown;
  ISLink: IShellLink;
  IPFile: IPersistFile;
  PIDL: PItemIDList;
  LinkName: string;
  InFolder: array[0..MAX_PATH - 1] of Char;
  Params: string;
begin
  result := False;

  IObject := CreateComObject(CLSID_ShellLink);
  ISLink := IObject as IShellLink;
  IPFile := IObject as IPersistFile;

  with ISLink do
  begin
    SetDescription('Description ...');
    Params := 'gdocid:' + IntToStr(DocID);
    SetPath(PChar(Application.ExeName));
    SetArguments(PChar(Params));
    SetWorkingDirectory(PChar(ExtractFilePath(Application.Exename)));
  end;

  SHGetSpecialFolderLocation(0, CSIDL_DESKTOPDIRECTORY, PIDL);
  SHGetPathFromIDList(PIDL, InFolder);

  LinkName := IncludeTrailingBackslash(GetDesktopFolder);
  if DocName <> '' then
    LinkName := LinkName + 'ViewerV36 Dokument-' + DocName + '.lnk'
  else
    LinkName := LinkName + 'ViewerV36 Dokument-' + IntToStr(DocID) + '.lnk';

//  if not FileExists(LinkName) then
  if IPFile.Save(PWideChar(LinkName), False) = S_OK then
    result := True;
end;

procedure TbfaApplication.LoadWVLFavorite(Frm: TFrame; idx: integer);
var
  lst: TStringList;
  i, iIndex: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'LoadWVLFavorite', ClassName);
  try
    try
      if idx = -1 then
      begin
        with TfraCreateResub(Frm) do
        begin
          edtName.Text := '';
          edtInfoCreate.Text := '';
          edtInfoFoward.Text := '';
          edtAlarm1.Text := '7';
          edtAlarm1.Value := 7;
          chkReturnToSender.Checked := ((InitialOptions and 2) = 2);
          chkEmailreminder.Checked := False;
          chkEveryone.Checked := False;
          chkOnlyOne.Checked := not chkEveryone.Checked;
          cbbUser.Text := '';
          cbbGroup.Text := '';
          edtAdditionalDays.Text := '0';
          edtAdditionalDays.Value := 0;
         // cbbName.Text := '';
        end;
      end
      else
      begin
        with TfraCreateResub(Frm) do
        begin
          edtInfoCreate.Text := aResubFavs[idx].Info;
          edtAlarm1.Text := IntToStr(aResubFavs[idx].Alarm);
          edtAlarm1.Value := aResubFavs[idx].Alarm;
          edtName.Text := aResubFavs[idx].name;
          edtInfoFoward.Text := aResubFavs[idx].FwdInfo;
          cbbUser.Text := aResubFavs[idx].Users;
          cbbGroup.Text := aResubFavs[idx].Groups;
          chkReturnToSender.Checked := ((InitialOptions and 2) = 2) or ((aResubFavs[idx].options and 2) = 2);  // wurde rts gesetzt, muss es stehen bleiben
          chkEmailreminder.Checked := (aResubFavs[idx].options and 4) = 4;
          chkOnlyOne.Checked := (aResubFavs[idx].options and 1) = 0;
          chkEveryone.Checked := (aResubFavs[idx].options and 1) = 1;
          chkNotifyByMail.Checked := (aResubFavs[idx].options and 64) = 64;
          cbbFavIcon.ItemIndex := aResubFavs[idx].FavIcon;
          edtAdditionalDays.Text := aResubFavs[idx].AdditionalDays.ToString;
          edtAdditionalDays.Value := aResubFavs[idx].AdditionalDays;
          dtDate1.Date := IncDay(Now(), aResubFavs[idx].AdditionalDays);

          lst := TStringList.Create;
          try
            lst.Delimiter := ';';
            lst.StrictDelimiter := True;
            lst.DelimitedText := aResubFavs[idx].Users;
            cbbUser.SetUnCheckedAll;
            for i := 0 to lst.Count - 1 do
            begin
              iIndex := cbbUser.Items.IndexOfObject(TObject(StrToInt(lst[i])));
              if iIndex >= 0 then  // Bug beim Testen endeckt
                cbbUser.Checked[iIndex] := True;
            end;
            lst.Clear;
            lst.DelimitedText := aResubFavs[idx].Groups;
            cbbGroup.SetUnCheckedAll;
            for i := 0 to lst.Count - 1 do
              cbbGroup.Checked[cbbGroup.Items.IndexOfObject(TObject(StrToInt(lst[i])))] := True;
          finally
            FreeAndNil(lst);
          end;

          // in der OptionsForm waren die Checkboxen initial deaktiviert
          chkEveryone.Enabled := (cbbGroup.Text <> '') or (cbbUser.CheckedCount > 1);  //mehr als ein Einzelbenutzer -> Gruppe
          chkOnlyOne.Enabled := (cbbGroup.Text <> '') or (cbbUser.CheckedCount > 1);  //mehr als ein Einzelbenutzer -> Gruppe
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'LoadWVLFavorite', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'LoadWVLFavorite', ClassName);
  end;
end;

procedure TbfaApplication.FillResubFavCombo(cbb: TSpTBXComboBox);
var
  i: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'FillResubFavCombo', ClassName);
  try
    try
      cbb.Items.Clear;
      for i := Low(aResubFavs) to High(aResubFavs) do
      begin
        cbb.AddItem(aResubFavs[i].name, TObject(i));
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'FillResubFavCombo', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'FillResubFavCombo', ClassName);
  end;
end;

procedure TbfaApplication.OpenInApp(AThread: TThread; Doc: TbfaDocument);
begin
  bitfarmLog.DebugBegin(llDebug, 'OpenInApp', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          try
            ShellExecute(Application.Handle, nil, PChar(Doc.OriLoc), nil, nil, SW_NORMAL);
          except
            bitfarmLog.Write(llNormal, ltException, 'OpenInApp - AThread', ClassName);
          end;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'OpenInApp', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'OpenInApp', ClassName);
  end;
end;

procedure TbfaApplication.SortingClientDataSet(Grid: TbfaDBGrid; Cds: TClientDataSet; Column: TColumn);
var
  so: TSortOrder;
begin
  try
    so := Grid.Columns[Column.Index].SortOrder;

    Grid.ClearSorting;
    if Cds.IndexDefs.Count > 0 then
    begin
      Cds.IndexDefs.Clear;
    end;
    if Cds.IndexFieldCount > 0 then
    begin
      try
        Cds.DeleteIndex(Column.FieldName + '_IDX');
      except

      end;
    end;

    if (so = TSortOrder(soNone)) or (so = soAsc) then
    begin
      Cds.IndexDefs.Add(Column.FieldName + '_IDX', Column.FieldName, [ixDescending]);
      Cds.AddIndex(Column.FieldName + '_IDX', Column.FieldName, [ixDescending]);

      Cds.IndexName := Column.FieldName + '_IDX';
      Grid.Columns[Column.Index].SortOrder := soDesc;
    end
    else
    begin
      Cds.IndexDefs.Add(Column.FieldName + '_IDX', Column.FieldName, []);
      Cds.AddIndex(Column.FieldName + '_IDX', Column.FieldName, []);

      Cds.IndexName := Column.FieldName + '_IDX';
      Grid.Columns[Column.Index].SortOrder := soAsc;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SortingClientDataSet', ClassName);
  end;
end;


function TbfaApplication.SQLQueryReadRefNamesOrTitles(sub: string = '';
  Refname: Integer = 0): String;
begin
  try
    if Refname = 0 then
    begin
      if sub = '' then
//21.06.2023 Ticket         Result := 'select distinct(refname), arcid, sys_doclink.gdocid from sys_doclink ' +
        Result := 'select distinct(refname) from sys_doclink ' +
                'left join sys_doc on sys_doclink.gdocid = sys_doc.gdocid ' +
                'and arcid in ('+ ReadRightsArcids.CommaText + ') order by refname'
      else
//21.06.2023 Ticket         Result := 'select distinct(refname), arcid, sys_doclink.gdocid from sys_doclink ' +
        Result := 'select distinct(refname) from sys_doclink ' +
                'left join sys_doc on sys_doclink.gdocid = sys_doc.gdocid ' +
                'where refname like ' + #39 + sub + '%' + #39 +
                'and arcid in ('+ ReadRightsArcids.CommaText + ') order by refname'
    end else if Refname = 1 then
    begin
      if sub = '' then
        Result := 'select distinct docname from sys_doc where arcid in ('+ ReadRightsArcids.CommaText +
                ') order by docname'
      else
        Result := 'select distinct docname from sys_doc where docname like ' + #39 + sub + '%' + #39 +
                ' and arcid in ('+ ReadRightsArcids.CommaText + ') order by docname';
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SQLQueryReadRefNamesOrTitles', ClassName);
    Result := '';
  end;
end;

procedure TbfaApplication.PreviewMouseWheel(prev: TbfaPreview; frm: TfrmQuickPreview;
  img_DocView: TbfaImageEnVect; Shift: TShiftState; WheelDelta: Integer; var Handled: Boolean);
var
  zDelta, nPos, xTmp, dir, mx, my, cnt, idx: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'PreviewMouseWheel', ClassName);
  try
    try
      {$IFDEF ImageEn1140}
      cnt := 0;
      idx := 0;

      if (prev = nil) and (frm <> nil) then
      begin
        cnt := img_DocView.IO.Params.ImageCount;
        idx := img_DocView.IO.Params.ImageIndex;
      end;

      if ((FViewerOptions.EditorOptions.DocEditorZoom) and (Shift = [])) or
         ((not FViewerOptions.EditorOptions.DocEditorZoom) and (Shift = [ssCtrl])) then
      begin
        img_DocView.GetMaxViewXY(mx, my);

        if prev <> nil then
        begin
          if (WheelDelta > 0) and (prev.actPreviousPage.Enabled) and (img_DocView.ViewY = 0) then
          begin
            prev.ChangePage('actPreviousPage', 1, True, False, False);
            Handled := True;
          end
          else if (WheelDelta < 0) and (prev.actNextPage.Enabled) and (img_DocView.ViewY = my) then
          begin
            prev.ChangePage('actNextPage', 1, True, True, False);
            Handled := True;
          end;
        // QuickPreview?
        end else if (frm <> nil) then
        begin
          if (WheelDelta > 0) and (prev.actPreviousPage.Enabled) and (img_DocView.ViewY = 0) then
          begin
            if idx >= 1 then
            begin
              Dec(idx);
              img_DocView.IO.Params.ImageIndex := idx;
              bitfarmApp.CurrentContainer[0].DocStream.Position := 0;
              img_DocView.ViewY := my;
              img_DocView.IO.LoadFromStream(bitfarmApp.CurrentContainer[0].DocStream);
              frm.lblPageCount.Caption := IntToStr(idx + 1) + ' / ' + IntToStr(img_DocView.IO.Params.ImageCount);
              Handled := True;
            end;
          end
          else if (WheelDelta < 0) and (prev.actNextPage.Enabled) and (img_DocView.ViewY = my) then
          begin
            if (idx < (cnt - 1)) then
            begin
              Inc(idx);
              img_DocView.IO.Params.ImageIndex := idx;
              bitfarmApp.CurrentContainer[0].DocStream.Position := 0;
              img_DocView.ViewY := 0;
              img_DocView.IO.LoadFromStream(bitfarmApp.CurrentContainer[0].DocStream);
              frm.lblPageCount.Caption := IntToStr(idx + 1) + ' / ' + IntToStr(img_DocView.IO.Params.ImageCount);
              Handled := True;
            end;
          end;
        end;
      end;
      {$ELSE}
      try
        cnt := 0;
        idx := 0;

        if (prev = nil) and (frm <> nil) then
        begin
          cnt := img_DocView.IO.Params.ImageCount;
          idx := img_DocView.IO.Params.ImageIndex;
        end;

        if Shift = [] then
        begin
          if (FViewerOptions.EditorOptions.DocEditorZoom) then
          begin
            SetMouseWheelParams(img_DocView, iemwVScroll);
            if not (GetWindowLong(img_DocView.Handle, GWL_STYLE) and WS_VSCROLL <> 0) then // keine Scrollbar vorhanden?
            begin
              if prev <> nil then
              begin
              // SJ 16.02.2023 - bfacrm:ticket__show__33991
//                if prev.bfaTlbPreview.sbmAutozoom.ImageIndex <> Integer(icoidx_preview_width) then
//                  prev.bfaTlbPreview.sbmAutozoom.ImageIndex := Integer(icoidx_preview_width);

                if (WheelDelta > 0) and (prev.actPreviousPage.Enabled) then
                  prev.ChangePage('actPreviousPage', 1, False, False, False)
                else if (WheelDelta < 0) and (prev.actNextPage.Enabled) then
                  prev.ChangePage('actNextPage', 1, False, False, False);
              end
              else if frm <> nil then
              begin
                if WheelDelta > 0 then
                begin
                  if idx >= 1 then
                  begin
                    Dec(idx);
                    img_DocView.IO.Params.ImageIndex := idx;
                    bitfarmApp.CurrentContainer[0].DocStream.Position := 0;
                    img_DocView.IO.LoadFromStream(bitfarmApp.CurrentContainer[0].DocStream);
                    frm.lblPageCount.Caption := IntToStr(idx + 1) + ' / ' + IntToStr(img_DocView.IO.Params.ImageCount);
                  end
                  else
                  begin
                    frm.SetActiveDoc(-1); //15.10.2024 SD <--bfacrm:ticket__show__39532
                  end;
                end
                else if WheelDelta < 0 then
                begin
                  if (idx < (cnt - 1)) then
                  begin
                    Inc(idx);
                    img_DocView.IO.Params.ImageIndex := idx;
                    bitfarmApp.CurrentContainer[0].DocStream.Position := 0;
                    img_DocView.IO.LoadFromStream(bitfarmApp.CurrentContainer[0].DocStream);
                    frm.lblPageCount.Caption := IntToStr(idx + 1) + ' / ' + IntToStr(img_DocView.IO.Params.ImageCount);
                  end
                  else
                  begin
                    frm.SetActiveDoc(1); //15.10.2024 SD <--bfacrm:ticket__show__39532
                  end;
                end;
              end;
            end
            else
            begin
              xTmp := -1;
              zDelta := WheelDelta;
              if zDelta < 0 then
                dir := -1
              else
                dir := 1;
              if img_DocView.MouseWheelParams.Action = iemwVScroll then
              begin
                img_DocView.GetMaxViewXY(mx, my);
                if img_DocView.MouseWheelParams.Variation = iemwPercentage then
                begin
                  if ((mx > 0) and (my = 0)) then
                  begin
                      // horizontal
                    if prev <> nil then
                      {$IFDEF IMAGEEN1140}
                      xTmp := imax(round(prev.ClientWidth * img_DocView.MouseWheelParams.Value / 100), 1)
                      {$ELSE}
                      xTmp := imageenproc.imax(round(prev.ClientWidth * img_DocView.MouseWheelParams.Value / 100), 1)
                      {$ENDIF}
                    else if frm <> nil then
                      {$IFDEF IMAGEEN1140}
                      xTmp := imax(round(frm.ClientWidth * img_DocView.MouseWheelParams.Value / 100), 1);
                      {$ELSE}
                      xTmp := imageenproc.imax(round(frm.ClientWidth * img_DocView.MouseWheelParams.Value / 100), 1);
                      {$ENDIF}
                    nPos := img_DocView.ViewX + dir * xTmp;
                  end
                  else
                  begin
                      // vertical
                    if prev <> nil then
                      xTmp := imax(round(prev.ClientHeight * img_DocView.MouseWheelParams.Value / 100), 1)
                    else if frm <> nil then
                      xTmp := imax(round(frm.ClientHeight * img_DocView.MouseWheelParams.Value / 100), 1);
                    nPos := img_DocView.ViewY + dir * xTmp;
                  end;

                  if ((nPos >= my) or ((nPos + xTmp) >= my)) and (dir = -1) then
                  begin
                    if prev <> nil then
                    begin
                      if (WheelDelta < 0) and (prev.actNextPage.Enabled) then
                      begin
                        prev.ChangePage('actNextPage', 1, True, True, False);
                      end;
                    end
                    else if frm <> nil then
                    begin
                      if WheelDelta < 0 then
                      begin
                        if (idx < (cnt - 1)) then
                        begin
                          Inc(idx);
                          img_DocView.SetViewXY(img_DocView.ViewX, 0);
                          img_DocView.IO.Params.ImageIndex := idx;
                          bitfarmApp.CurrentContainer[0].DocStream.Position := 0;
                          img_DocView.IO.LoadFromStream(bitfarmApp.CurrentContainer[0].DocStream);
                          frm.lblPageCount.Caption := IntToStr(idx + 1) + ' / ' + IntToStr(img_DocView.IO.Params.ImageCount);
                        end
                        else
                        begin
                          frm.SetActiveDoc(1); //15.10.2024 SD <--bfacrm:ticket__show__39532
                        end;
                      end;
                    end;
                  end
                  else if ((nPos <= 0) or ((nPos - xTmp) <= 0)) and (dir = 1) then
                  begin
                    if prev <> nil then
                    begin
                      if (WheelDelta > 0) and (prev.actPreviousPage.Enabled) then
                        prev.ChangePage('actPreviousPage', 1, True, False, False);
                    end
                    else if frm <> nil then
                    begin
                      if WheelDelta > 0 then
                      begin
                        if idx >= 1 then
                        begin
                          Dec(idx);
                          img_DocView.GetMaxViewXY(mx, my);
                          img_DocView.SetViewXY(img_DocView.ViewX, my);

                          img_DocView.IO.Params.ImageIndex := idx;
                          bitfarmApp.CurrentContainer[0].DocStream.Position := 0;
                          img_DocView.IO.LoadFromStream(bitfarmApp.CurrentContainer[0].DocStream);
                          frm.lblPageCount.Caption := IntToStr(idx + 1) + ' / ' + IntToStr(img_DocView.IO.Params.ImageCount);
                        end
                        else
                        begin
                          frm.SetActiveDoc(-1); //15.10.2024 SD <--bfacrm:ticket__show__39532
                        end;
                      end;
                    end;
                  end;
                end;
              end;
            end;
          end
          else // Zoom wie in 3.5 Version
          begin
            if (img_DocView.Zoom >= 0) and (img_DocView.Zoom <= 600) then
              SetMouseWheelParams(img_DocView, iemwZoom);
          end;
        end
        else if Shift = [ssCtrl] then
        begin
        // SJ 27.04.2023
//          if ((not (GetWindowLong(img_DocView.Handle, GWL_STYLE) and WS_VSCROLL <> 0)) and (WheelDelta > 0)) then
//          begin
//            Abort;
//          end
//          else
//          begin
//            // fllt weg
//            if (img_DocView.Zoom >= 0) and (img_DocView.Zoom <= 600) then
//              SetMouseWheelParams(img_DocView, iemwZoom);
//          end;
        // SJ 27.04.2023
          if (img_DocView.Zoom >= 0) and (img_DocView.Zoom <= 600) then
            SetMouseWheelParams(img_DocView, iemwZoom);
        end;
      finally
        Handled := True;
      end;
      {$ENDIF}
    except
      bitfarmLog.Write(llNormal, ltException, 'PreviewMouseWheel', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'PreviewMouseWheel', ClassName);
  end;
end;

procedure TbfaApplication.SetMouseWheelParams(Sender: TObject; Param: TIEMouseWheelParamsAction);
begin
  {$IFNDEF ImageEn1140}
  try
    if (Sender is TbfaImageEnVect) then
    begin
      with (Sender as TbfaImageEnVect) do
      begin
        MouseWheelParams.Action := Param;
        MouseWheelParams.Variation := iemwPercentage;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetMouseWheelParams', ClassName);
  end;
  {$ENDIF}
end;

procedure TbfaApplication.CreateShowPageSortingsFrameAction;
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateShowPageSortingsFrameAction', ClassName);
  try
    try
      UserAction := CreateUserAction;
      UserAction.ActionName := 'actShowPageSortingsFrame';
      FMainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'CreateShowPageSortingsFrameAction', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreateShowPageSortingsFrameAction', ClassName);
  end;
end;

procedure TbfaApplication.CreateHidePageSortingsFrameAction;
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'CreateHidePageSortingsFrameAction', ClassName);
  try
    try
      UserAction := CreateUserAction;
      UserAction.ActionName := 'actHidePageSortingsFrame';
      FMainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'CreateHidePageSortingsFrameAction', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CreatehidePageSortingsFrameAction', ClassName);
  end;
end;

procedure TbfaApplication.ShowPageSortingsFrame(AThread: TThread);
var
  Width : Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'ShowPageSortingsFrame', ClassName);
  try
    try
      if (CurrentView = tvkImporter) and (FPreviewContainer.ImporterItem.Preview.PreviewKind = pvkMulti) and (FCurrentContainer.Count > 0) then
      begin
//25.07.2017 alle dateien mssen angezeigt werden!       if FCurrentContainer[0].HasPreview then
//        begin
        Width := -1;
        AThread.Synchronize(nil,
          procedure
          var
            AutoZoom: Boolean;
          begin
            AutoZoom := True;
            if (not bitfarmApp.PreviewContainer.PageSortingsItem.Panel.Showing) then
            begin
              Width := frmMainForm.pnlImporter.ClientWidth + frmMainForm.pnlSearchOptions.ClientWidth;
              // Ticket 13642: Falls Vorsansicht schon mal geffnet, nimm gemerkte Weite
              if (bitfarmApp.PreviewContainer.PageSortingsItem.PreviousClientWidth > 0) then
                Width := bitfarmApp.PreviewContainer.PageSortingsItem.PreviousClientWidth;
              FShowPageSortings := True;
              frmMainForm.splTreeview.Minimize;
              frmMainForm.splTreeview.Enabled := False;
              if frmMainForm.pnlSearchOptions.Parent.Name <> 'dckFloating' then // Ticket 15536: Wenn ausgedockt, dann nicht hiden.
                frmMainForm.pnlSearchOptions.Hide;
              //AutoZoom := True;  // GP: berflssig wird oben schon gesetzt!
            end;

            bitfarmApp.PreviewContainer.PageSortingsItem.Preview.List.Clear;
            bitfarmApp.PreviewContainer.PageSortingsItem.Preview.List.Add(FCurrentContainer[0]);
            bitfarmApp.PreviewContainer.PageSortingsItem.Preview.ActiveDoc := FCurrentContainer[0];

            if (bitfarmApp.PreviewContainer.ImporterItem.Preview.previewToolWindow.Visible) and (bitfarmApp.PreviewContainer.ImporterItem.Preview.ThumbnailView.SelectedImage > -1) then
              bitfarmApp.PreviewContainer.PageSortingsItem.Preview.ShowPage(FCurrentContainer[0], bitfarmApp.PreviewContainer.ImporterItem.Preview.ThumbnailView.SelectedImage, AutoZoom)
            else
              bitfarmApp.PreviewContainer.PageSortingsItem.Preview.ShowPage(FCurrentContainer[0], 0, AutoZoom);

            if (not bitfarmApp.PreviewContainer.PageSortingsItem.Panel.Showing) then
            begin
              bitfarmApp.PreviewContainer.PageSortingsItem.Panel.Show;
              if Width <> -1 then
                bitfarmApp.PreviewContainer.PageSortingsItem.Panel.ClientWidth := Width;
            end;
            FFirstResize := True;
          end);
//        end
//        else
//          BfShowMessage(_('Das ausgewhlte Dokument hat keine Voransicht.\n Bitte whlen sie ein anderes Dokument.'), AThread);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'ShowPageSortingsFrame', ClassName);
    end;
  finally
    FShowPageSortings := False;
    bitfarmLog.DebugEnd(llDebug, 'ShowPageSortingsFrame', ClassName);
  end;
end;

procedure TbfaApplication.HideFrame;
begin
  try
    try
      FShowPageSortings := True;
      with bitfarmApp.PreviewContainer.PageSortingsItem do
      begin
        PreviousClientWidth := Panel.ClientWidth; // wie merken uns aktuelle Witdth frs nchste Show Ticket 13642:
        Panel.Hide;
      end;
      frmMainForm.pnlSearchOptions.Show;
      frmMainForm.splTreeview.Restore;
      frmMainForm.splTreeview.Enabled := True;
    except
      bitfarmLog.Write(llNormal, ltException, 'HideFrame', ClassName);
    end;
  finally
    FShowPageSortings := False;

   // Ticket 13642
   // FShowPageSortings = true soll verhindert, dass pnlPreview sich Realignen kann, wenn die Voransicht sich ein-/ausblendet. Warum ist unklar?
   //if (frmMainForm.pnlSearchOptions.Parent.Name = 'dckFloating') then
    frmMainForm.SpTBXMultiDock1.Realign;
    frmMainForm.pnlPreview.Realign;
  end;
end;

procedure TbfaApplication.HidePageSortingsFrame(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'HidePageSortingsFrame', ClassName);
  try
    try
      if bitfarmApp.PreviewContainer.PageSortingsItem.Panel.Showing then
      begin
        if AThread <> nil then
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              HideFrame;
            end);
        end
        else
          HideFrame;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'HidePageSortingsFrame', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'HidePageSortingsFrame', ClassName);
  end;
end;

procedure TbfaApplication.PageSortingsOnResize(Sender: TObject);
begin
  if (not frmMainForm.fAppStarted) or (ClosingMainForm) then
    Exit;

  bitfarmLog.DebugBegin(llDebug, 'PageSortingsOnResize', ClassName);
  try
    try
      if not FFirstResize then
        bitfarmApp.Autozoom(bitfarmApp.PreviewContainer.PageSortingsItem.Preview);
    except
      bitfarmLog.Write(llNormal, ltException, 'PageSortingsOnResize', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'PageSortingsOnResize', ClassName);
  end;
end;

procedure TbfaApplication.SaveImportValues(AThread: TThread);
var
  inifile: TIniFile;
  i, j, idx: Integer;
  cols: TStringList;
  impValues: TImportValues;
  Str, newValue: string;
begin
  bitfarmLog.DebugBegin(llDebug, 'SaveImportValues', ClassName);
  try
    try
      AThread.Synchronize(nil,
        procedure
        begin
          Screen.Cursor := crHourGlass;
        end);

      inifile := TIniFile.Create(BD.AppdataBitfarmPd + 'ImportValues.ini');
      cols := TStringList.Create;
      cols.Delimiter := ';';
      cols.StrictDelimiter := True;
      try

        for i := Low(aSysArc) to High(aSysArc) do
        begin
          cols.Clear;
          if aSysArc[i].arcid = CurrentImportArchive.Arcid then
          begin
            SetLength(aImportValues[CurrentImportArchive.Arcid], 0);
            idx := 1;
            for j := 0 to aCurrentAddfields.Count - 1 do
            begin
              if aCurrentAddfields[j].Component <> nil then
              begin
                if aCurrentAddfields[j].Component.Modified then
                begin
                  if aCurrentAddfields[j].Component.Value <> '' then
                  begin
                    newValue := aCurrentAddfields[j].Component.Value;
                    newValue := StringReplace(newValue, ',', '!', [rfReplaceAll]);
                    newValue := StringReplace(newValue, ';', '|', [rfReplaceAll]);
                    newValue := Trim(newValue);
                    if Str = '' then
                      Str := aCurrentAddfields[j].name + ',' + newValue
                    else
                      Str := Str + ';' + aCurrentAddfields[j].name + ',' + newValue;

                    SetLength(aImportValues[CurrentImportArchive.Arcid], idx);
                    impValues.Field := aCurrentAddfields[j].name;
                    newValue := StringReplace(newValue, '|', ';', [rfReplaceAll]);
                    newValue := StringReplace(newValue, '!', ',', [rfReplaceAll]);
                    impValues.Value := newValue;
                    aImportValues[CurrentImportArchive.Arcid, idx - 1] := impValues;
                    Inc(idx);
                  end;
                end;
              end;
            end;
            if Str <> '' then
              inifile.WriteString('Values', IntToStr(i), Str + ';')
            else
            begin
              if inifile.ValueExists('Values', IntToStr(i)) then
                inifile.WriteString('Values', IntToStr(i), '');
            end;
          end
          else
          begin
            for j := Low(aImportValues[i]) to High(aImportValues[i]) do
            begin
              if (aImportValues[i, j].Field <> '') and (aImportValues[i, j].value <> '') then
              begin
                newValue := StringReplace(aImportValues[i, j].value, ';', '|', [rfReplaceAll]);
                newValue := StringReplace(newValue, ',', '!', [rfReplaceAll]);
                cols.Add(aImportValues[i, j].Field + ',' + newValue);
              end
              else
                Break;
            end;
            if cols.DelimitedText <> '' then
              inifile.WriteString('Values', IntToStr(i), cols.DelimitedText + ';')
            else
            begin
              if inifile.ValueExists('Values', IntToStr(i)) then
                inifile.WriteString('Values', IntToStr(i), '');
            end;
          end;
        end;

      finally
        FreeAndNil(inifile);
        FreeAndNil(cols);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'SaveImportValues', ClassName);
    end;
  finally
    AThread.Synchronize(nil,
      procedure
      begin
        Screen.Cursor := crDefault;
      end);

    bitfarmLog.DebugEnd(llDebug, 'SaveImportValues', ClassName);
  end;
end;

function TbfaApplication.DBLoadDocument(Doc: TbfaBaseDocument): Integer;
var
  FErrorCode: Integer;
  FbfaSP: TbfaSP;
  fPath : WideString;
  lmq: TUniQuery;
  i, j, k : Integer;
  addfield, tmpfield: TbfaAddField;
  statefield: TbfaStateField;
  anno : TbfaAnnotation;
  annostream : TMemoryStream;
  gridconfig : TbfaGridConfig;
  gridvalues : TList<TStringList>;
  tmplist : TStringList;
  xmlnode : IXMLDocument;
  val, value : string;
begin
  FErrorCode := 0;
  bitfarmLog.Write(llDebug, ltInfo, 'DBLoadDocument', 'bfaProcessing');
  Doc.StartLoadProcess;
  try
    try
      FbfaSP := TbfaSP.Create(dmMain.cntMain, sSpSelectDocumentByGDocID);
      try
        FbfaSP.PrepareSQL;
        FbfaSP.SetParamByNameAsLargeInt(sPrmGDocID, Doc.ID);

        FbfaSP.Open;
        if FbfaSP.RecordCount > 0 then
        begin
          Doc.ArcID := FbfaSP.FieldByNameAsLargeInt(sColArcID);
          Doc.DocLoc := FbfaSP.FieldByNameAsWideString(sColDocLoc);
          Doc.ExtLoc := FbfaSP.FieldByNameAsWideString(sColExtLoc);
          Doc.OriLoc := FbfaSP.FieldByNameAsWideString(sColOriLoc);
          Doc.FullTXT := ''; //FieldByNameAsWideString(sColDocTXT);
          Doc.DocTags := ''; //FieldByNameAsWideString(sColVocabulary);
          Doc.CheckOutUserID := -1; //FieldByName(sColCheckedout);
          Doc.DocType := dtArchived; //FieldByName(sColDocLoc).AsWideString;
          Doc.FileType := FbfaSP.FieldByNameAsWideString(sColFileType);
          Doc.DocName := FbfaSp.FieldByNameAsWideString(sColDocName);
          Doc.HasPreview := True;

          if Doc.ExtLoc <> '' then
            fPath := Doc.ExtLoc
          else
            fPath := Doc.DocLoc;

          if FileExists(fPath) then
            Doc.DocStream.LoadFromFile(fPath);

          if (Doc.OriLoc <> '') and FileExists(Doc.Oriloc) then
//24.05.2023            Doc.OriStream.LoadFromFile(Doc.OriLoc);
          begin
            if Doc.OriStream <> nil then
              Doc.OriStream.Free;
            Doc.OriStream := TFileStream.Create(Doc.OriLoc, fmOpenRead or fmShareDenyNone);
          end;

          lmq := DbCreateQuery;
          try
            lmq.SQL.Text := 'select rights +0 from sys_arcxs where arcid = ' + IntToStr(Doc.ArcID) +
                            ' and (userid = ' + IntToStr(bitfarmApp.User.ID) + ' or (userid = 0 and ' +
                            ' groupid in (' + bitfarmApp.User.GroupList.CommaText + ')))';
            lmq.Execute;
            if lmq.RecordCount > 0 then
            begin
              lmq.First;
              Doc.Rights :=  lmq.FieldByName('rights +0').AsInteger;
            end;

            lmq.SQL.Text := 'select * from sys_doc where gdocid = ' + IntToStr(Doc.ID);
            lmq.Execute;
            if lmq.RecordCount > 0 then
            begin
              lmq.First;
              Doc.FullTXT := lmq.FieldByName('doctxt').AsWideString;
              Doc.DocTags := lmq.FieldByName('doctags').AsWideString;
            end;

            for i := 0 to aCurrentAddfields.Count -1 do
            begin
              addfield := TbfaAddField.Create;
              addfield.Clone(aCurrentAddfields[i]);
              TbfaDocument(Doc).Addfields.Add(addfield);
            end;

            for i := 0 to aCurrentStatefields.Count -1 do
            begin
              statefield := TbfaStatefield.Create;
              statefield.Clone(aCurrentStatefields[i]);
              TbfaDocument(Doc).Statefields.Add(statefield);
            end;

            for i := 0 to TbfaDocument(Doc).AddFields.Count -1 do
            begin
              if (TbfaDocument(Doc).AddFields[i].Typ = 13) and (TbfaDocument(Doc).AddFields[i].ValuesQuery <> '') then
              begin
                CoInitialize(nil);
                xmlnode := TXMLDocument.Create(nil);
                try
                  xmlnode.LoadFromXML(TbfaDocument(Doc).AddFields[i].ValuesQuery);
                  gridconfig := XMLToGridConfig(xmlnode.DocumentElement);
                finally
                  CoUninitialize;
                end;
                if gridconfig <> nil then
                begin
                  gridvalues := TList<TStringList>.Create;

                  for j := 0 to gridconfig.Columns.Count -1 do
                  begin
                    tmpfield := GetAddfieldByName(gridconfig.Columns[j].Fieldname);
                    if tmpField = nil then
                      Continue;

                    lmq.SQL.Text := Format('select %s from sys_docidx_%d where gdocid = %d',[tmpfield.Name,tmpfield.IndexTableID, Doc.ID]);
                    lmq.Execute;
                    if lmq.RecordCount > 0 then
                    begin
                      lmq.First;
                      tmplist := TStringList.Create;
                      tmplist.Delimiter := ';';
                      tmplist.StrictDelimiter := True;
                      tmplist.DelimitedText := tmpfield.Name + ';' + lmq.FieldByName(tmpfield.Name).AsWideString;

                      gridvalues.Add(tmplist);
                    end;
                  end;

                  if gridvalues.Count > 0 then //08.02.2023 Im Offline Viewer passiert bei gridvalues[0].Count ein AV
                  begin
                    for j := 0 to gridvalues[0].Count -1 do   // in jeder Spalte sollte die gleich Anzahl an EIntrgen sein
                    begin                                     // ansonsten ist schon was kaputt
                      val := '';
                      for k := 0 to gridvalues.Count -1 do
                      begin
                        if val = '' then
                          val := gridvalues[k][j]
                        else
                          val := val + ';' + gridvalues[k][j]
                      end;
                      if value = '' then
                        value := val
                      else
                        value := value + '|' + val
                    end;
                    TbfaDocument(Doc).AddFields[i].Value := value;
                    TbfaDocument(Doc).AddFields[i].OldValue := value;
                  end;
                end;
              end else
              begin
                lmq.SQL.Text := Format('select %s from sys_docidx_%d where gdocid = %d',[TbfaDocument(Doc).AddFields[i].Name,TbfaDocument(Doc).AddFields[i].IndexTableID, Doc.ID]);
                lmq.Execute;
                if lmq.RecordCount > 0 then
                begin
                  lmq.First;
                  if (eAddFieldType(TbfaDocument(Doc).AddFields[i].Typ) = zfld01_Datum) or
                     (eAddFieldType(TbfaDocument(Doc).AddFields[i].Typ) = zfld12_DLMDate) then
                  begin
                    TbfaDocument(Doc).AddFields[i].Value := lmq.Fields[0].AsDateTime;
                    TbfaDocument(Doc).AddFields[i].OldValue := lmq.Fields[0].AsDateTime;
                  end else
                  begin
                  TbfaDocument(Doc).AddFields[i].Value := lmq.Fields[0].AsWideString;
                  TbfaDocument(Doc).AddFields[i].OldValue := lmq.Fields[0].AsWideString;
                  end;
                end else
                begin
                  TbfaDocument(Doc).AddFields[i].Value := '';
                  TbfaDocument(Doc).AddFields[i].OldValue := '';
                end;
              end;
            end;

            for i := 0 to TbfaDocument(Doc).Statefields.Count -1 do
            begin
              lmq.SQL.Text := Format('select * from sys_doc where docstate_%d & %d > 0 and gdocid = %d',[TbfaDocument(Doc).StateFields[i].IndexColumnID, TbfaDocument(Doc).StateFields[i].Bitmask, Doc.ID]);
              lmq.Execute;
              if lmq.RecordCount > 0 then
              begin
                lmq.First;
                TbfaDocument(Doc).Statefields[i].Value := True;
                TbfaDocument(Doc).Statefields[i].OldValue := True;
              end else begin
                TbfaDocument(Doc).Statefields[i].Value := False;
                TbfaDocument(Doc).Statefields[i].OldValue := False;
              end;
            end;

            annostream := TMemoryStream.Create;
            TbfaDocument(Doc).Annotations.Clear;
            lmq.SQL.Text := 'select * from sys_annotations where gdocid = ' + IntToStr(Doc.ID);
            lmq.Execute;
            if lmq.RecordCount > 0 then
            begin
              lmq.First;
              anno := TbfaAnnotation.Create;
              anno.Layer := lmq.FieldByName('layer').AsInteger;
              anno.Page := lmq.FieldByName('page').AsInteger;

              annostream.Position := 0;
              annostream.Clear;
              annostream :=  TMemoryStream(lmq.CreateBlobStream(lmq.FieldByName('iev'), bmRead));

              anno.AnnoStream.CopyFrom(annostream, annostream.Size);
              anno.AnnoStream.Position := 0;
              TbfaDocument(Doc).Annotations.Add(anno);
            end;
          finally
            lmq.Free;
          end;
          Doc.Loaded := True;
        end
        else
          Doc.Loaded := False;

//        FbfaSP.Close;
        Result := FErrorCode;
      finally
        FreeAndNil(FbfaSP);
      end;
    except
      FErrorCode := ecConnectionLoadDocumentFailure;
      bitfarmLog.Write(llNormal, ltException, 'DBLoadDocument - ErrorCode: ' + IntToStr(FErrorCode), 'bfaProcessing');
      Result := FErrorCode;
    end;
  finally
    Doc.EndLoadProcess;
  end;
end;

procedure TbfaApplication.ReloadDocument(Doc: TbfaDocument; InEditmode: Boolean; AThread: TThread; OnlyDoc : Boolean = False);
var
  Lst: TList<TbfaDocument>;
  Params: string;
  TimID : Integer;
//  SymArcID : Int64;
begin
  bitfarmLog.DebugBegin(llDebug, 'ReloadDocument', 'Processing');
  try
    try
//      SymArcID := Doc.SymbolicArcID;

      // im OfflineMode laden wir das Dokument aus der Datenbank
      if bitfarmApp.OfflineMode then
      begin
        DBLoadDocument(Doc);
      end else  // ansonsten laden wir es vom Server
      begin
        //  wenn wir eine TimID haben fr dieses Dokument, dann sollten wir uns die 'merken'
        TimID := Doc.TimID;
        Params := 'base;fields;iev;paths;text;svn;workflow';
        //if (bitfarmApp.CurrentView = tvkResub) then
        //  Params := Params + ';workflow';}
        bitfarmApp.LoadDocumentViaSocket(Doc, Params, AThread, OnlyDoc);
        Doc.TimID := TimID;
        bitfarmApp.SetEditModeList(Doc.InEditIDs, AThread);
      end;

//      Doc.SymbolicArcID := SymArcID;
      if Doc <> nil then
      begin
        //20.06.2018 Ticket 14576 -->
        if (Doc.ID <> -1) then
        begin
          if Doc.ScanPoolView <> nil then
          begin
            Doc.ScanPoolView.Clear;
            Doc.ScanPoolViewchanged := False;
            Doc.ScanPoolViewLoaded := False;
          end;
          if Doc.ThumbnailView <> nil then
          begin
            Doc.ThumbnailView.Clear;
          end;
        end;
        //20.06.2018 Ticket 14576 <--

        if (Doc.ID <> -1) and (not Doc.Loaded) then
        begin
          bitfarmApp.SetStatusBarID(Doc.Arcid, Doc.ID, '', AThread);
//          bitfarmApp.SetStatusInfo(Format(_('Das Dokument mit ID: %s konnte nicht geladen werden!'),
//            [IntToStr(Doc.ID)]), AThread, False);
          frmMainForm.SetNotificationBar(Format(_('Das Dokument mit ID: %s konnte nicht geladen werden!'),
            [IntToStr(Doc.ID)]), AThread); // SJ 14.08.2019

          AThread.Synchronize(nil,
          procedure
          begin
            bitfarmApp.PreviewContainer.ViewerItem.Preview.ThumbnailView.Clear;
            bitfarmApp.PreviewContainer.ViewerItem.Preview.HistoryView.Clear;
            bitfarmApp.PreviewContainer.ViewerItem.Preview.CommentaryView.Clear;
            bitfarmApp.PreviewContainer.ViewerItem.Preview.FulltextView.Clear;

            case bitfarmApp.PreviewContainer.ViewerItem.Preview.ActiveView of
              avDocument: bitfarmApp.PreviewContainer.ViewerItem.Preview.Paint;
              avHistory: bitfarmApp.PreviewContainer.ViewerItem.Preview.HistoryView.Update;
              avFulltext: bitfarmApp.PreviewContainer.ViewerItem.Preview.FulltextView.Update;
              avCommentary: bitfarmApp.PreviewContainer.ViewerItem.Preview.CommentaryView.Update;
            end;
          end);
        end else if (Doc.ID <> -1) and (not Doc.HasPreview) then
        begin
          frmMainForm.SetNotificationBar(_('Fehler: Die Voransicht konnte nicht geladen werden'), AThread); // SJ 14.08.2019

          AThread.Synchronize(nil,
          procedure
          begin
            bitfarmApp.PreviewContainer.ViewerItem.Preview.ActivePage := -1;
            bitfarmApp.PreviewContainer.ViewerItem.Preview.SingleView.img_DocView.Clear;
            bitfarmApp.PreviewContainer.ViewerItem.Preview.SingleView.img_DocView.Blank;
            bitfarmApp.PreviewContainer.ViewerItem.Preview.ThumbnailView.Clear;
            bitfarmApp.PreviewContainer.ViewerItem.Preview.HistoryView.Clear;
            bitfarmApp.PreviewContainer.ViewerItem.Preview.CommentaryView.Clear;
            bitfarmApp.PreviewContainer.ViewerItem.Preview.FulltextView.Clear;
            bitfarmApp.PreviewContainer.ViewerItem.Preview.SetCaptionsTranslated;

            case bitfarmApp.PreviewContainer.ViewerItem.Preview.ActiveView of
              avDocument: bitfarmApp.PreviewContainer.ViewerItem.Preview.Paint;
              avHistory: bitfarmApp.PreviewContainer.ViewerItem.Preview.HistoryView.Update;
              avFulltext: bitfarmApp.PreviewContainer.ViewerItem.Preview.FulltextView.Update;
              avCommentary: bitfarmApp.PreviewContainer.ViewerItem.Preview.CommentaryView.Update;
            end;
          end);

          bitfarmApp.ClearFields(AThread);
        end
        else
        begin
          InEditmode := InEditmode or (Doc.EditModeUserid = bitfarmApp.User.ID);
          if ((not bitfarmApp.OfflineMode) and (InEditmode)) then
          begin
            Lst := TList<TbfaDocument>.Create;
            try
              Lst.Add(Doc);
              bitfarmApp.InEditMode(Lst, nil, AThread);
            finally
              Lst.Clear;
              FreeAndNil(Lst);
            end;
          end;

        // Automatisch zur Voransicht wechseln
          if bitfarmApp.ViewerOptions.GeneralOptions.AutoPreview and (bitfarmApp.
            PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].Preview.
              ActiveView <> avDocument) then
//12.07.2024 bfacrm:ticket__show__39299            bitfarmApp.PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].
//              Preview.btnPreview.Click;
            bitfarmApp.ButtonPreviewClick(AThread, bitfarmApp.PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].Preview); //12.07.2024

        // History leersetzen
          bitfarmApp.PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].
            Preview.HistoryView.HistDataSet.EmptyDataSet;

        // History laden
          if bitfarmApp.PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].
            Preview.ActiveView = avHistory then
              bitfarmApp.LoadHistoryViaSocket(Doc, AThread);

          AThread.Synchronize(nil,
            procedure
            var
              qry : TuniQuery;
              found : Boolean;
            begin
            // Volltext fllen
              bitfarmApp.PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].
                Preview.FulltextView.mmoFulltext.Lines.Clear;

              SendMessage(bitfarmApp.PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].
                Preview.FulltextView.mmoFulltext.Handle, EM_SETZOOM, WPARAM(bitfarmApp.FullTextZoom), LPARAM(100));

              bitfarmApp.PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].
                Preview.FulltextView.mmoFulltext.Lines.Add(Doc.FullTXT);
              bitfarmApp.PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].
                Preview.FulltextView.mmoFulltext.SelStart := 0;

            // Suchtoolbar Text setzen
              if (bitfarmApp.GetActivePreview.SearchbarTextEdit.Text <> frmMainForm.edtGeneralSearch.Text) and
                 (frmMainForm.edtGeneralSearch.EditValue <> Null) and (not bitfarmApp.GetActivePreview.SearchbarModified) then
              begin
                bitfarmApp.GetActivePreview.SearchbarTextEdit.Text := frmMainForm.edtGeneralSearch.Text;
              end;

            // Kommentare laden
              if bitfarmApp.PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].
                Preview.ActiveView = avCommentary then
              begin
                bitfarmApp.PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].
                  Preview.CommentaryView.LoadCommentary(Doc.Id);
                found := (bitfarmApp.PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].
                  Preview.CommentaryView.ComDataSource <> nil) and
                  (bitfarmApp.PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].
                  Preview.CommentaryView.ComDataSource.DataSet <> nil) and
                  (bitfarmApp.PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].
                    Preview.CommentaryView.ComDataSource.DataSet.RecordCount > 0);
              end
              else
              begin
                qry := TUniQuery.Create(nil);
                try
                  qry.Connection:= dmMain.cntMain;
                  qry.SQL.Text :=
                      'SELECT comment FROM sys_com as c '+
                      'where gdocid = ' + IntToStr(Doc.ID) +
                      ' LIMIT 1;';
                  qry.Execute;
                  found := (qry.RecordCount > 0);
                finally
                  FreeAndNil(qry);
                end;
              end;

              Doc.HasComment := found;

              if found then
              begin
                bitfarmApp.PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].
                  Preview.btnCommentary.CaptionGlow := gldAll;
                bitfarmApp.PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].
                  Preview.btnCommentary.FontSettings.Style := [];
                bitfarmApp.PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].
//                  Preview.btnCommentary.FontSettings.Color := clBlack;
                  Preview.btnCommentary.FontSettings.Color := stlControl.TextColor;
                bitfarmApp.PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].
                  Preview.btnCommentary.CaptionGlowColor := $00A5FF;
              end
              else
              begin
                bitfarmApp.PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].
                  Preview.btnCommentary.CaptionGlow := gldNone;
                bitfarmApp.PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].
                  Preview.btnCommentary.FontSettings.Style := [];
                bitfarmApp.PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].
//                  Preview.btnCommentary.FontSettings.Color := clBlack;
                  Preview.btnCommentary.FontSettings.Color := stlControl.TextColor;
                bitfarmApp.PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].
                  Preview.btnCommentary.CaptionGlowColor := gclNone;
              end;
            end);

          // Verknpfungsliste
          ReloadLinks(Doc);

        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'ReloadDocument', 'bfaProcessing');
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ReloadDocument', 'bfaProcessing');
  end;
end;

procedure TbfaApplication.DoResubPanelResize(fra : TfraResub);
var
  ControlWidth : Integer;
begin
//25.11.2021 bt ein Workaround hier, weil fraResub will sich nicht richtig anpassen.
  if fra <> nil then
  begin
    if fra.ResubScrollBox.VertScrollBar.IsScrollBarVisible then
      ControlWidth := fra.ResubScrollBox.Width - 27
    else
      ControlWidth := fra.ResubScrollBox.Width - 10;

    if fra.edtResubInfo.Width <> ControlWidth then fra.edtResubInfo.Width := ControlWidth;
    if fra.edtResubComment.Width <> ControlWidth then fra.edtResubComment.Width := ControlWidth;
    if fra.cxDateEdit1.Width <> ControlWidth then fra.cxDateEdit1.Width := ControlWidth;
    if fra.cbbUserGroups.Width <> ControlWidth then fra.cbbUserGroups.Width := ControlWidth;
    if fra.cxDateNavigator1.Width <> ControlWidth then fra.cxDateNavigator1.Width := ControlWidth;
  end;
end;



function TbfaPrinter.Clone(Source: TPrinter) : string;
var
  ADevice, ADriver, APort : string;
  ADevMode  : THandle;
begin
  Result := '';
  bitfarmLog.DebugBegin(llDebug, 'TbfaPrinter.Clone', ClassName);
  try
    try
        SetLength(ADevice, 255);
        SetLength(ADriver, 255);
        SetLength(APort, 255);

        Source.GetPrinter(PChar(ADevice), PChar(ADriver), PChar(APort), ADevMode);

        Result := ADevice;

        Self.SetPrinter(PChar(ADevice), PChar(ADriver), PChar(APort), ADevMode);
    except
      bitfarmLog.Write(llNormal, ltException, 'TbfaPrinter.Clone', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'TbfaPrinter.Clone', ClassName);
  end;
end;

function TbfaPrinter.GetPrnDuplex: boolean;
var
  ADevice, ADriver, APort : string;
  ADevMode : THandle;
  pDevmode : PDeviceMode;
begin
  try
    Result := False;
    SetLength(ADevice, 255);
    SetLength(ADriver, 255);
    SetLength(APort, 255);
    TbfaPrinter(Self).GetPrinter(PChar(ADevice), PChar(ADriver), PChar(APort), ADevMode);
    if ADevmode <> 0 then
    begin
      pDevMode := GlobalLock(ADevmode);
      if pDevmode <> nil then
      begin
        try
          Result := (pDevmode^.dmDuplex > 1)
        finally
          GlobalUnlock(ADevmode);
        end;
      end;
    end;
  except
    result := False;
    bitfarmLog.Write(llNormal, ltException, 'GetPrnDuplex', ClassName);
  end;
end;

function TbfaApplication.CopyFileWithBuffer(SourceStream: TStream;
  FileName, DestName: TFileName; SplForm: Boolean; AThread: TThread = nil): Integer;
var
  CopyBuffer: Pointer;
  BytesCopied, AllBytesCopied: Int64;
  Dest: Integer;
  Destination: TFileName;
  ErrorCode: Integer;
  cancel: Boolean;
  fs: TFileStream;
  ChunkSize: Integer;
begin
  ErrorCode := 0;
  try
    ChunkSize := 524288;
    GetMem(CopyBuffer, ChunkSize);
    try
      if SourceStream.Size <= 0 then
      begin
        ErrorCode := 1;
        Exit;
      end;
      try
        fs := TFileStream.Create(DestName, fmCreate);

        BytesCopied := 0;
        AllBytesCopied := 0;
        try
          if SplForm then
          begin
            if AThread <> nil then
            begin
              AThread.Synchronize(nil,
                procedure
                begin
                  frmMainForm.frmSplash.pgbBytes.Properties.Min := 0;
                  frmMainForm.frmSplash.pgbBytes.Properties.Max := SourceStream.Size;
                  frmMainForm.frmSplash.pgbBytes.Position := 0;
                  frmMainForm.frmSplash.pgbBytes.Visible := True;
                  frmMainForm.frmSplash.btnCancel.Enabled := True;
                  frmMainForm.frmSplash.Canceled := False;
                  frmMainForm.frmSplash.btnCancel.Visible := True;
                  frmMainForm.frmSplash.Update;
                end);
            end
            else
            begin
              frmMainForm.frmSplash.pgbBytes.Properties.Min := 0;
              frmMainForm.frmSplash.pgbBytes.Properties.Max := SourceStream.Size;
              frmMainForm.frmSplash.pgbBytes.Position := 0;
              frmMainForm.frmSplash.pgbBytes.Visible := True;
              frmMainForm.frmSplash.btnCancel.Enabled := True;
              frmMainForm.frmSplash.Canceled := False;
              frmMainForm.frmSplash.btnCancel.Visible := True;
              frmMainForm.frmSplash.Update;
            end;
          end;
          SourceStream.Position := 0;
          //16.11.2023 ChunkSize := 524288;
          //14.11.2023 -->
          if SourceStream.Size < ChunkSize then
            ChunkSize := SourceStream.Size;
          //14.11.2023 <--
          repeat
            BytesCopied := SourceStream.Read(CopyBuffer^, ChunkSize);
            if BytesCopied > 0 then
              fs.Write(CopyBuffer^, BytesCopied);
            AllBytesCopied := AllBytesCopied + BytesCopied;
            if SplForm then
            begin
              if AThread <> nil then
              begin
                AThread.Synchronize(nil,
                  procedure
                  begin
                    frmMainForm.frmSplash.pgbBytes.Position := AllBytesCopied;
                    frmMainForm.frmSplash.pgbBytes.Update;
                  end);
              end
              else
              begin
                frmMainForm.frmSplash.pgbBytes.Position := AllBytesCopied;
                frmMainForm.frmSplash.pgbBytes.Update;
              end;
            end;
          until (BytesCopied < ChunkSize) or bitfarmApp.CancelProcess;
        finally
          fs.Free;
        end;
      finally
        SourceStream.Position := 0; //02.08.2023
      end;
    finally
      ChunkSize := 524288; //16.11.2023
      FreeMem(CopyBuffer, ChunkSize);
    end;
  finally
    if SplForm then
    begin
      if AThread <> nil then
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            frmMainForm.frmSplash.pgbBytes.Position := 0;
            frmMainForm.frmSplash.pgbBytes.Visible := False;
            frmMainForm.frmSplash.pgbBytes.Update;
          end);
      end
      else
      begin
        frmMainForm.frmSplash.pgbBytes.Position := 0;
        frmMainForm.frmSplash.pgbBytes.Visible := False;
        frmMainForm.frmSplash.pgbBytes.Update;
      end;
    end;
    Result := ErrorCode;
  end;
end;


initialization
  OleInitialize(nil);

finalization
  OleUninitialize;

end.


