unit bfaPreview36;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TB2Item, SpTBXItem, TB2Dock, TB2Toolbar, SpTBXControls, ImgList,
  iemview, imageenview, ievect, Generics.Collections, ActnList, bfaObjects36,
  bfaThreadedThumbnail, bfaBaseObjects, bfaCommonUtils, bfaBasePreview, u_bfaTlbImport,
  hyieutils, HistoryFrame, FulltextFrame, CommentaryFrame,
  u_bfaTlbPreview, u_bfaTlbStandard, ExtCtrls, Menus, StdCtrls, TB2ExtItems,
  DropTarget, DragDrop, DropSource, DropComboTarget, SpTBXCustomizer, SpTBXEditors,
  ComCtrls, System.Actions, bfaAnnoOptionsDialog, bfaImageEnMView;

type
  TbfaPreviewKind = (pvkMulti, pvkMultiSingle, pvkSingle);

  TbfaActiveView = (avDocument, avHistory, avFulltext, avCommentary);

  TbfaFulltextPosition = record
    FWordNumber, FWordStart, FWordLength: Integer;
    FWord: String;
  end;

  TbfaPreview = class(TFrame)
    SpTBXPanel1: TSpTBXPanel;
    previewDockTop: TSpTBXDock;
    previewDockLeft: TSpTBXDock;
    AnnoToolbar: TSpTBXToolbar;
    previewToolWindow: TSpTBXToolWindow;
    previewThumbsPanel: TSpTBXPanel;
    previewDockRight: TSpTBXDock;
    PreviewSelectToolbar: TSpTBXToolbar;
    btnPreview: TSpTBXItem;
    btnFulltext: TSpTBXItem;
    btnHistory: TSpTBXItem;
    btnCommentary: TSpTBXItem;
    previewDockBottom: TSpTBXDock;
    tbi_normalmouse: TSpTBXItem;
    tbi_annoselect: TSpTBXItem;
    annotoolsSeparatorItem1: TTBSeparatorItem;
    tbi_fav1: TSpTBXItem;
    tbi_fav2: TSpTBXItem;
    tbi_fav3: TSpTBXItem;
    tbi_fav4: TSpTBXItem;
    tbi_fav5: TSpTBXItem;
    annotoolsSeparatorItem2: TTBSeparatorItem;
    tbi_stampdialog: TSpTBXItem;
    tbsub_text: TSpTBXSubmenuItem;
    tbsub_notes: TSpTBXSubmenuItem;
    tbsub_highlight: TSpTBXSubmenuItem;
    tbsub_pencil: TSpTBXSubmenuItem;
    tbi_arrow: TSpTBXItem;
    tbi_line: TSpTBXItem;
    tbi_annodelete: TSpTBXItem;
    tbi_box: TSpTBXItem;
    tbi_ellipse: TSpTBXItem;
    tbi_polygon: TSpTBXItem;
    tbi_label: TSpTBXItem;
    tbi_image: TSpTBXItem;
    tbi_length: TSpTBXItem;
    tbi_angle: TSpTBXItem;
    annotoolsSeparatorItem3: TTBSeparatorItem;
    tbi_graphicoptions: TSpTBXItem;
    tbi_rangeocr: TSpTBXItem;
    tbi_text1: TSpTBXItem;
    tbi_text2: TSpTBXItem;
    tbi_text3: TSpTBXItem;
    tbi_text4: TSpTBXItem;
    tbi_text5: TSpTBXItem;
    tbi_note1: TSpTBXItem;
    tbi_note2: TSpTBXItem;
    tbi_note3: TSpTBXItem;
    tbi_note4: TSpTBXItem;
    tbi_note5: TSpTBXItem;
    tbi_highlite1: TSpTBXItem;
    tbi_highlite2: TSpTBXItem;
    tbi_highlite3: TSpTBXItem;
    tbi_highlite4: TSpTBXItem;
    tbi_highlite5: TSpTBXItem;
    tbi_pencil1: TSpTBXItem;
    tbi_pencil2: TSpTBXItem;
    tbi_pencil3: TSpTBXItem;
    tbi_pencil4: TSpTBXItem;
    tbi_pencil5: TSpTBXItem;
    prgPreview: TSpTBXProgressBar;
    navigationToolBar: TSpTBXToolbar;
    itmBack: TSpTBXItem;
    dlgOpenFile: TOpenDialog;
    dctPreviewTarget: TDropComboTarget;
    tbiClipboardAsStamp: TSpTBXItem;
    SpTBXPopupMenu1: TSpTBXPopupMenu;
    mnuSave: TSpTBXItem;
    mnuReset: TSpTBXItem;
    SpTBXCustomizer1: TSpTBXCustomizer;
    SpTBXSeparatorItem1: TTBSeparatorItem;
    itmAuditProof: TSpTBXItem;
    itmSymLink: TSpTBXItem;
    tlbResubFavs: TSpTBXToolbar;
    tbi_SearchBar: TSpTBXItem;
    ppmAnnotations: TSpTBXPopupMenu;
    itmModifyColor: TSpTBXItem;
    itmModifyText: TSpTBXItem;
    tbi_fav6: TSpTBXItem;
    tbi_fav7: TSpTBXItem;
    tbi_fav8: TSpTBXItem;
    tbi_fav9: TSpTBXItem;
    tbi_fav10: TSpTBXItem;

    procedure ToolbarDockChanging(Sender: TObject; Floating: Boolean; DockingTo: TTBDock);
    procedure previewToolWindowClose(Sender: TObject);
    procedure tbi_note1Click(Sender: TObject);
    procedure tbi_note2Click(Sender: TObject);
    procedure tbi_normalmouseClick(Sender: TObject);
    procedure tbi_stampdialogClick(Sender: TObject);
    procedure tbi_lineClick(Sender: TObject);
    procedure tbi_rangeocrClick(Sender: TObject);
    procedure tbsub_highlightClick(Sender: TObject);
    procedure tbi_highlite1Click(Sender: TObject);
    procedure tbi_highlite2Click(Sender: TObject);
    procedure tbi_highlite3Click(Sender: TObject);
    procedure tbi_highlite4Click(Sender: TObject);
    procedure tbi_highlite5Click(Sender: TObject);
    procedure tbsub_textClick(Sender: TObject);
    procedure tbi_text1Click(Sender: TObject);
    procedure tbi_text2Click(Sender: TObject);
    procedure tbi_text3Click(Sender: TObject);
    procedure tbi_text4Click(Sender: TObject);
    procedure tbi_text5Click(Sender: TObject);
    procedure tbsub_notesClick(Sender: TObject);
    procedure tbi_note3Click(Sender: TObject);
    procedure tbi_note4Click(Sender: TObject);
    procedure tbi_note5Click(Sender: TObject);
    procedure tbsub_pencilClick(Sender: TObject);
    procedure tbi_pencil1Click(Sender: TObject);
    procedure tbi_pencil2Click(Sender: TObject);
    procedure tbi_pencil3Click(Sender: TObject);
    procedure tbi_pencil4Click(Sender: TObject);
    procedure tbi_pencil5Click(Sender: TObject);
    procedure tbi_annoselectClick(Sender: TObject);
    procedure tbi_arrowClick(Sender: TObject);
    procedure tbx_favClick(Sender: TObject);
    procedure tbi_boxClick(Sender: TObject);
    procedure tbi_ellipseClick(Sender: TObject);
    procedure tbi_polygonClick(Sender: TObject);
    procedure tbi_labelClick(Sender: TObject);
    procedure tbi_imageClick(Sender: TObject);
    procedure tbi_angleClick(Sender: TObject);
    procedure tbi_lengthClick(Sender: TObject);
    procedure tbi_annodeleteClick(Sender: TObject);
    procedure tbi_graphicoptionsClick(Sender: TObject);
    procedure actGraphicOptionsExecute(Sender: TObject);
    procedure btnPreviewClick(Sender: TObject);
    procedure btnFulltextClick(Sender: TObject);
    procedure btnHistoryClick(Sender: TObject);
    procedure btnCommentaryClick(Sender: TObject);
    procedure itmSymLinkClick(Sender: TObject);
    procedure itmBackClick(Sender: TObject);
    procedure dctPreviewTargetDrop(Sender: TObject; ShiftState: TShiftState;
      APoint: TPoint; var Effect: Integer);
    procedure dctPreviewTargetDragOver(Sender: TObject; ShiftState: TShiftState;
      APoint: TPoint; var Effect: Integer);
    procedure dctPreviewTargetLeave(Sender: TObject);
    procedure dctPreviewTargetEnter(Sender: TObject; ShiftState: TShiftState;
      APoint: TPoint; var Effect: Integer);
    procedure tbiClipboardAsStampClick(Sender: TObject);
    procedure mnuSaveClick(Sender: TObject);
    procedure mnuResetClick(Sender: TObject);
    procedure FrameExit(Sender: TObject);
    procedure tbi_SearchBarClick(Sender: TObject);
    procedure FulltextListExecute(const AWord: string);
    procedure itmModifyTextClick(Sender: TObject);
    procedure itmModifyColorClick(Sender: TObject);
  private
    { Private-Deklarationen }
    FbfaPreviewKind: TbfaPreviewKind;
    FShowingThumbnail, FDoViewResize: Boolean;
    FActiveView: TbfaActiveView;
    FShowThumbnail, // wenn Miniaturansicht Panel ein und ausschaltet wird
    FHasNotBeenSavedAfterModify, // Ist True wenn ein Dokument gedreht, invertiert, oder anderweitig veraendert wurde
    FDontSetPage, FDontUseMouseEnter, FMouseDown, FMouseSelection, Fbisktstamp, FTurned, FMViewDBLClick: Boolean;
    FimgMultiView, FimgThumbnailView, FThumbnailMView: TbfaImageEnMView;
    FimgSingleView: Tfrm_Voransicht;
    FList: TList<TbfaDocument>;
    FThumbnailThread: TThreadedThumbnails;
    FMouseDownArea: TRect;
    fLastAnnoTool: procedure(Sender: TObject) of object;
    fLastAnnoSender: TObject;
    FActiveDoc: TbfaDocument;
    FActivePage: Integer;
    FThumbnailTimer: TTimer;
    FitmThumbnail: TSpTBXItem;
    FTimerObj: TbfaImageEnMView;
    FTimerAction: Integer; // Default -1; Select 0; Deselect 1;
    FTimerIdx: Integer;
    FTimerPageSortings: Boolean;
    FbfaTlbPreview: TbfaTlbPreview;
    FbfaTlbStandard: TbfaTlbStandard;
    FbfaTlbImport: TbfaTlbImport;
    FEdit: TEdit;
    FChangeEditDocIdx: Integer;
    FChangeDocNameInProcess: Boolean;
    FFulltextTimer: TTimer;
    FSearchbarLastEdit: WideString;
    procedure PaintWindow(DC: HDC); override;
    function GetClientHeight: Integer;
    procedure SetClientHeight(Value: Integer);
    function GetpreviewDock1_Width: Integer;
    procedure SetpreviewDock1_Width(const Value: Integer);
    function GetpreviewDock2_Width: Integer;
    function GetpreviewDock3_Width: Integer;
    function GetpreviewDock4_Width: Integer;
    procedure SetpreviewDock2_Width(const Value: Integer);
    procedure SetpreviewDock3_Width(const Value: Integer);
    procedure SetpreviewDock4_Width(const Value: Integer);
    function GetAnnoToolbar_CurrentDock: TTBDock;
    procedure SetAnnoToolbar_CurrentDock(const Value: TTBDock);
    function GetToolWindow_CurrentDock: TTBDock;
    procedure SetToolWindow_CurrentDock(const Value: TTBDock);
    function GetSelectToolbar_CurrentDock: TTBDock;
    procedure SetSelectToolbar_CurrentDock(const Value: TTBDock);
    function GetAnnoToolbar_DockPos: Integer;
    function GetAnnoToolbar_DockRow: Integer;
    procedure SetAnnoToolbar_DockPos(const Value: Integer);
    procedure SetAnnoToolbar_DockRow(const Value: Integer);
    function GetToolWindow_DockPos: Integer;
    function GetToolWindow_DockRow: Integer;
    procedure SetToolWindow_DockPos(const Value: Integer);
    procedure SetToolWindow_DockRow(const Value: Integer);
    function GetSelectToolbar_DockPos: Integer;
    function GetSelectToolbar_DockRow: Integer;
    procedure SetSelectToolbar_DockPos(const Value: Integer);
    procedure SetSelectToolbar_DockRow(const Value: Integer);
    function GetAnnoToolbar_LastDock: TTBDock;
    procedure SetAnnoToolbar_LastDock(const Value: TTBDock);
    procedure SetList(Value: TList<TbfaDocument>);
    procedure SetPreviewKind(Value: TbfaPreviewKind);
    procedure SetShowThumbnail(Value: Boolean);
    procedure MultiViewDblClick(Sender: TObject);
    procedure ThumbnailViewDblClick(Sender: TObject);
    procedure MViewClick(Sender: TObject);
    procedure MViewMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure MViewEndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure MViewStartDrag(Sender: TObject);
    procedure MViewMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure MViewMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure PrevKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ShowAnnoData(annodata: PAnnoData);
    procedure ThumbnailTimerTimer(Sender: TObject);
    function CheckAnnoRights: Boolean;
//    procedure LoadFavStampValues(fktag: integer; favtext: string);
    procedure CreateTfrm_Stamps(Owner: TWinControl; Voransicht: Tfrm_Voransicht);
    procedure AskforsaveDialog(AThread: TThread);
    procedure EditKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EditKeyPress(Sender: TObject; var Key: Char);
    procedure SaveNewDocName(Save: Boolean);
    procedure MViewResize(Sender: TObject);
    procedure MViewViewChange(Sender: TObject; Change: Integer);
    function GetFloating: Boolean;
    procedure CreateThumbnail;
    procedure bfaMouseLeave;
    procedure CopyOCRResultToClipbrd;
    procedure DoDelayTimer(Sender: TObject);
    procedure SetActivePage(Value: Integer);
    procedure CloneActions(CreateActions: Boolean = True; Retranslate: Boolean = False);

  public
    { Public-Deklarationen }
    PreviewActiveated, FPreviewCreating: Boolean;
    FDelay: TTimer;
    gasfavstemp: TStringArray;
    CurrentLayer: Int64;
    CurrentLayerRights: Int64;
    StationeryIndex: Integer;
    FHistoryView: TfraHistory;
    FFulltextView: TfraFulltext;
    FCommentaryView: TfraCommentary;
    FtxPos: TList<TbfaFtxPos>;
    FtxObjList: TStringList;
    FtxSearchPos: Integer;
    FtxSearchPosOldColor: TColor;
    moused, current: TPoint;
    FStatObj: TbfaStationery;
    SearchbarToolbar: TSpTBXToolbar;
    SearchbarTextLabel: TSpTBXLabel;
    SearchbarSeperatorLabel1: TSpTBXLabel;
    SearchbarSeperatorLabel2: TSpTBXLabel;
    SearchbarTextEdit: TSpTBXEdit;
    SearchbarButtonUp: TSpTBXButton;
    SearchbarButtonDown: TSpTBXButton;
    SearchbarChkAccurate: TSpTBXCheckBox;
    SearchbarChkWholeWords: TSpTBXCheckBox;
    SearchbarChkCircle: TSpTBXCheckBox;
    fIsSettingValue: Boolean;
    SearchbarModified: Boolean;
    SearchbarPreviewModified: Boolean;
    SearchbarHistoryModified: Boolean;
    SearchbarCommentaryModified: Boolean;
    FulltextPositionLst: TList<TbfaFulltextPosition>;
    FulltextCurrentIndex: Integer;
    FActThumbnailWidth, FActThumbnailHeight: Integer;
    StampStatefield: Integer; // fr Stempel die einen Status setzen
    MainFormActionListExec: procedure(Sender: TObject) of object;
    frm_DocEditOpt: Tfrm_DocEditOpt;

    actQuit, actRelogin, actCreateBookmark, actCreateEmptyDoc, actChangePassword,
    actOptions, actEmailTIFAttachment, actEmailOriginal, actEmailLink, actPrintStandard,
    actPrintSelect, actPrintPreview,
    actViewThumbnails, actDeleteColumnOrder, actGetLastDocument,
    actGetDoc1, actGetDoc2, actGetDoc3, actGetDoc4, actGetDoc5, actSetDoc1,
    actSetDoc2, actSetDoc3, actSetDoc4, actSetDoc5, actRestoreOriginal,
    actDocEditor, actDuplicateDoc, actExportCSV, actDeleteDoc,
    actGraphicOptions, actInverted, actDeScrew, actDeSpeckle, actRemoveBorder,
    actRotateLeft, actExportXLS, actExportOO, actFlip, actRotateRight, actInfo,
    actSupport, actMergeDoc, actPreviousPage, actNextPage, actPublicAnno,
    actPrivateAnno, actStationery, actAutozoom, actZoom100, actZoomPage,
    actZoomWidth, actZoomHeight, actZoomSelect, actZoomOff, actAuditProof,
    actEditTags, actNewLink, actAddLink, actLinks, actOriginalfile,
    actCheckout, actInProgress, actIsAuditProof, actLanguageDE, actLanguageEN,
    actSave, actCancel, actLayoutSave, actLayoutDelete, actLayoutStandard,
    actSearch, actReset, actMyTasks, actDelegateTasks,
    actShowCW, actCWPrevious, actCWNext, actResubOpen, actResubWork, actResubCancel,
    actResubForward, actResubDone, actScan, actScanDialog, actLoadFile,
    actDeleteSelected, actArchive, actWPGroup, actWPUngroup,
    actWPClear, actWPLoad, actWPSave, actResubQuickForward, actPreviewBack,
    actChangeArchive, actDeletePages, actChangeDocName, actAddFolder,
    actDeleteFolder, actDeleteFavorite, actExpandAll, actCollapseAll, actRefreshTreeView,
    actExportTree, actLocalSavePreview, actEmailPreview, actSendDocumentsToWorkplace,
    actAutoRef, actShareLayer, actAddGlobal, actDeleteGlobal, actReplaceBookmark,
    actFtxPos, actCreateSymbolicLinkInImporter, actGoToOriginalDocument,
    actShowAllSymbolicLinks, actDeleteSymbolicLink, actRemoveLink,
    actDeleteLink, actAddAutoReference, actCopyOriginalDocToClipboard,
    actCopyPageToClipboard, actCopyDocLinkToClipboard, actSendPagesToWorkplace,
    actSendPagesMergedToWorkplace, actSendDocumentsToImporter,
    actSendPagesToImporter, actSendPagesMergedToImporter, actFirstPage,
    actLastPage, actClearFields, actLocalSaveLink, actEmailPDFAttachment,
    actSaveResub, actResubCreate, actHideSearchDetails, actShowIndexing,
    actHideIndexing, actCreateBookmarkForGDocID, actDocAbo, actAlt1, actAlt2,
    actAlt3, actAlt4, actAlt5, actAlt6, actAlt7, actAlt8, actAlt9, actAlt0,
    actF4, actCtrlF, actCtrlTab, actCtrlAltLeft, actCtrlAltRight, actGoToSourceArchive,
    actScanOptions, actArchiveWithDD, actChangeBookmark, actInResub, actShowInResub,
    actRangeOCR, actSendCopyToWorkplace, actCreateCopy, actShowPageSortingsFrame,
    actHidePageSortingsFrame, actAltF11, actCtrlAltF, actShowIndexingWithLimit,
    actCopyBookmark, actCreateBookmarkDialog, actCreateBookmarkMenu, actResetImporter,
    actResetDLM, actLanguage, actSendDocumentPreviewsToImport, actSaveImportValues,
    actLocalSavePDF, actLocalSaveTIF, actLocalSaveOriginal, actReOCR,
    actCopyDocToClipboard: TAction;

    actList: TActionList;

    constructor Create(AOwner: TComponent; WithMultiAndThumbnailView: Boolean = True; idx: Integer = -1); overload;
    destructor Destroy; override;
    procedure MViewImageSelect(Sender: TObject; idx: Integer);
    procedure MViewImageDeSelect(Sender: TObject; idx: Integer);
    procedure ToggleLastAnnoTool;
    procedure SetCurrentLayer(layer: Integer);
    procedure CreateImporterToolbar;
    procedure CreateSearchToolbar;
    procedure SearchToolbarSetState;
    procedure SetActivePreview(Sender: TObject);
    procedure UnCheckAllGraphicTools;
    function GetThumbnailInProcess: Boolean;
    procedure SetActions;
    procedure ShowPageNumber;
    procedure cbxZoomChange(Sender: TObject);
    procedure SearchEditChange(Sender: TObject);
    procedure SearchbarTextEditKeyPress(Sender: TObject; var Key: Char);
    procedure SearchbarTextEditKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure SearchPrevious;
    procedure SearchNext(WithDialog: Boolean = True);
    procedure SearchbarButtonDownClick(Sender: TObject);
    procedure SearchbarButtonUpClick(Sender: TObject);
    procedure SearchbarChkWholeWordsClick(Sender: TObject);
    procedure SearchbarChkAccurateClick(Sender: TObject);
    procedure tmrMarkFulltext(Sender: TObject);
    procedure MarkText;
    procedure OpenDocInNewTab;
    procedure SkipEditMode;
    procedure RefreshMultiView(Add: Boolean);
    procedure SetScanPoolAsThumbnailView(Doc: TbfaDocument);
    procedure RefreshThumbnailView(AThread: TThread; Doc: TbfaDocument; SelectedImageIdx: Integer = 0);
    procedure ResizeThumbnail(Sender: TbfaImageEnMView; Step: Integer);
    procedure ShowPage(Doc: TbfaDocument; PageIdx: Integer; Autozoom: Boolean = True;
      SetImagePos: Boolean = False; SetImagePosTothetop: Boolean = False; PageDirection: Integer = -1);
    procedure askforsave_annos2(AThread: TThread);
    procedure RefreshPreview(AThread: TThread; Doc: TbfaDocument = nil; ReloadThumbnail: Boolean = True);
    procedure SaveAnnoObjects(AThread: TThread; SetInteracts, SetIntervtBack: Boolean; IgnoreRights: Boolean = False);
    procedure KillThumbnailThread(ClearImages: Boolean = True);
    procedure RefreshPage;
    procedure SetAnnoToolBar(Enable: Boolean);
    procedure SetEdit;
    procedure SetTextFonts;
    procedure AddStationery(AThread: TThread);
    procedure RemoveStationery(AThread: TThread);
    procedure SetSaveAction(CanEnabled: Boolean);
    procedure SendPagesTo(prev: TbfaPreview; Merged: Boolean);
    procedure MViewDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure bfaSingleMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure SetCaptionsTranslated;
    function CanActivatePanelOnMouseEvent: Boolean;
    procedure DeleteFtxPosLayer;
    procedure OnStationeryClick(Sender: TObject);
    procedure ShowToolbars(Show: Boolean = True);
    procedure Paint;
//30.08.2022    procedure PageNumberChange(Sender: TObject; const Text: String);
    procedure PageNumberChange(Sender: TObject);
    procedure AcceptText(Sender: TObject; var NewText: String; var Accept: Boolean);
    procedure ChangePage(Actionname: string; Param: Integer; SetImagePos: Boolean = False; SetImagePosTothetop: Boolean = False; Autozoom: Boolean = True);
    procedure SaveToolBarLayout;
    procedure LoadToolBarLayout(idx: Integer = -1; DoStandard: Boolean = False);
    procedure LoadFavStampbuttons(var favstemp: TStringArray; tbx_fav1, tbx_fav2, tbx_fav3, tbx_fav4, tbx_fav5, tbx_fav6, tbx_fav7, tbx_fav8, tbx_fav9, tbx_fav10: TSpTBXItem);
    procedure Retranslate;
  published
    property previewDock1_Width: Integer read GetpreviewDock1_Width write SetpreviewDock1_Width;
    property previewDock2_Width: Integer read GetpreviewDock2_Width write SetpreviewDock2_Width;
    property previewDock3_Width: Integer read GetpreviewDock3_Width write SetpreviewDock3_Width;
    property previewDock4_Width: Integer read GetpreviewDock4_Width write SetpreviewDock4_Width;
    property AnnoToolbar_CurrentDock: TTBDock read GetAnnoToolbar_CurrentDock write SetAnnoToolbar_CurrentDock;
    property AnnoToolbar_LastDock: TTBDock read GetAnnoToolbar_LastDock write SetAnnoToolbar_LastDock;
    property AnnoToolbar_DockPos: Integer read GetAnnoToolbar_DockPos write SetAnnoToolbar_DockPos;
    property AnnoToolbar_DockRow: Integer read GetAnnoToolbar_DockRow write SetAnnoToolbar_DockRow;
    property ToolWindow_CurrentDock: TTBDock read GetToolWindow_CurrentDock write SetToolWindow_CurrentDock;
    property ToolWindow_DockPos: Integer read GetToolWindow_DockPos write SetToolWindow_DockPos;
    property ToolWindow_DockRow: Integer read GetToolWindow_DockRow write SetToolWindow_DockRow;
    property SelectToolbar_CurrentDock: TTBDock read GetSelectToolbar_CurrentDock write SetSelectToolbar_CurrentDock;
    property SelectToolbar_DockPos: Integer read GetSelectToolbar_DockPos write SetSelectToolbar_DockPos;
    property SelectToolbar_DockRow: Integer read GetSelectToolbar_DockRow write SetSelectToolbar_DockRow;
    property PreviewKind: TbfaPreviewKind read FbfaPreviewKind write SetPreviewKind;
    property ActiveView: TbfaActiveView read FActiveView write FActiveView;
    property MultiView: TbfaImageEnMView read FimgMultiView;
    property SingleView: Tfrm_Voransicht read FimgSingleView;
    property ThumbnailView: TbfaImageEnMView read FimgThumbnailView write FimgThumbnailView;
    property ThumbnailMView: TbfaImageEnMView read FThumbnailMView;
    property ShowThumbnail: Boolean read FShowThumbnail write SetShowThumbnail;
    property ThumbnailThread: TThreadedThumbnails read FThumbnailThread;
    property bfaTlbPreview: TbfaTlbPreview read FbfaTlbPreview;
    property bfaTlbStandard: TbfaTlbStandard read FbfaTlbStandard;
    property bfaTlbImporter: TbfaTlbImport read FbfaTlbImport;
    property ChangeDocNameInProcess: Boolean read FChangeDocNameInProcess write FChangeDocNameInProcess;
    property HistoryView: TfraHistory read FHistoryView;
    property FulltextView: TfraFulltext read FFulltextView;
    property CommentaryView: TfraCommentary read FCommentaryView;
    property Floating: Boolean read GetFloating;
    property ShowingThumbnail: Boolean read FShowingThumbnail write FShowingThumbnail;
    property DontSetPage: Boolean read FDontSetPage;
    property ActivePage: Integer read FActivePage write FActivePage;
    property ClientHeight: Integer read GetClientHeight write SetClientHeight;
    property List: TList<TbfaDocument> read FList write SetList;
    property DontUseMouseEnter: Boolean read FDontUseMouseEnter write FDontUseMouseEnter;
    property ActiveDoc: TbfaDocument read FActiveDoc write FActiveDoc;
    property Edit: TEdit read FEdit write FEdit;
    property ChangeEditDocIdx: Integer read FChangeEditDocIdx write FChangeEditDocIdx;
  end;

procedure ShowDocument(AThread: TThread; Doc: TbfaDocument; DocList: TList<TbfaDocument>;
  prev: TbfaPreview = nil; PageIdx: Integer = -1; SetCurrent: Boolean = True;
  InNewTab: Boolean = False; TabInBackground: Boolean = False; MView: TbfaImageEnMView = nil;
  ReloadThumbnail: Boolean = False; InEditmode: Boolean = False; SetFocus: Boolean = False;
  ReloadDoc: Boolean = False; ChangeToMultiSingle: Boolean = False; pnlSearchTimer: TPanel = nil;
  pnlLoadDoc: TPanel = nil; SearchString: WideString = ''; SetImagePos: Boolean = False;
  SetImagePosTothetop: Boolean = False; Autozoom: Boolean = True; PageDirection: Integer = -1;
  Floating: Boolean = False; MouseClick: Boolean = False);
procedure ShowAddFields(Doc: TbfaDocument; keepmodified: Boolean = True);
procedure ShowStateFields(Doc: TbfaDocument);
procedure RefreshSizeAddFields;

implementation

{$R *.dfm}

uses
  bfaLog, ShellAPI, CommonGUIUtils, bfaStampsDialog, u_Message,
  bfaApplication, bfaCommonImageEN, hyiedefs, gnugettext, bfaCommonStyles,
  StrUtils, ieview, bfaProcessing, Registry, SpTBXDkPanels,
  MainForm {$IFDEF ENTERPRISE}, MainFormEnterprise {$ENDIF}, bfaCommonDB, MainDataModule,
  bfaIconsDM, bfaCommonMethods, bfaCommonDialogs,
  FloatingForm, imageenproc, IOUtils, Clipbrd, u_bfaAddfield, bfaImageEnVect,
  ietextc //13.04.2021 Ticket 26789
  {$IFDEF IMAGEEN1140}
  , iexBitmaps, iexClasses
  {$ENDIF}
  ;

procedure TbfaPreview.ToolbarDockChanging(Sender: TObject;    // die Toolbars der Preview sollen nur
  Floating: Boolean; DockingTo: TTBDock);                     // innerhalb der Preview verschoben werden drfen
begin
  if Sender <> previewToolWindow then
  begin
    if (DockingTo.Name <> 'previewDockTop') and (DockingTo.Name <> 'previewDockLeft') and
      (DockingTo.Name <> 'previewDockRight') and (DockingTo.Name <> 'previewDockBottom') then
      Abort;
  end
  else
  begin
    if (DockingTo.Name <> 'previewDockLeft') and (DockingTo.Name <> 'previewDockRight') then
      Abort;
  end;
end;

procedure TbfaPreview.CreateThumbnail;
begin
  CreateThumbnailView(FThumbnailMView, Self, previewThumbsPanel);
  with FThumbnailMView do
  begin
    TabStop := True;
    OnClick := MViewClick;
    OnMouseDown := MViewMouseDown;
    OnMouseMove := MViewMouseMove;
    OnMouseUp := MViewMouseUp;
    OnDblClick := ThumbnailViewDblClick;
    OnImageSelect := MViewImageSelect;
    OnImageDeSelect := MViewImageDeSelect;
    OnKeyDown := PrevKeyDown;

    PopupMenu := frmMainForm.ppmTools;
  end;
  FimgThumbnailView := FThumbnailMView;
end;

procedure TbfaPreview.SetCaptionsTranslated;
begin
  try
    btnPreview.Caption := _('Vo&ransicht');
    btnFulltext.Caption := _('Voll&text');
    btnHistory.Caption := _('H&istory');
    btnCommentary.Caption := _('&Kommentare');

    mnuSave.Caption := _('Toolbar speichern');
    mnuReset.Caption := _('Toolbar zurcksetzen');

    tbi_normalmouse.Hint := _('Zoom- und Verschiebe-Werkzeug');
    tbi_AnnoSelect.Hint := _('Werkzeug zur Objektauswahl');
    tbi_Stampdialog.Hint := _('Stempelauswahl-Dialog');
//    tbiClipboardAsStamp.Hint := _('Zwischenablage als Stempel anzeigen');
    tbsub_Text.Hint := _('Text');

    tbsub_Notes.Hint := _('Notizen');
    tbsub_Notes.Caption := _('Notizen');
    tbi_Note1.Caption := _('Gelbe Notiz');
    tbi_Note2.Caption := _('Grne Notiz');
    tbi_Note4.Caption := _('Rote Notiz');
    tbi_Note4.Caption := _('Blaue Notiz');
    tbi_Note5.Caption := _('Orange Notiz');

    tbsub_Highlight.Hint := _('Marker');
    tbsub_pencil.Hint := _('Stifte');

    tbi_arrow.Hint := _('Pfeil');
    tbi_Line.Hint := _('Linie');
    tbi_annodelete.Hint := _('Annotation lschen');
    tbi_graphicoptions.Hint := _('Optionen zu grafischen Objekten');
    tbi_SearchBar.Hint := _('In aktuellem Reiter suchen');
    tbi_rangeocr.Hint := _('Bereichs OCR');

    SearchbarTextLabel.Caption := '  '+_('Dokument durchsuchen:')+' ';
    SearchbarChkAccurate.Caption := _('Exakte Suche');
    SearchbarChkWholeWords.Caption := _('Ganzes Wort');
    SearchbarChkCircle.Caption := _('Suche am Anfang/Ende fortsetzen');
  except
   on e:exception do
    begin
      bitfarmLog.Write(llNormal, ltException, 'TbfaPreview.SetCaptionsTranslated: ' + e.Message, ClassName);
    end;
  end;
end;

constructor TbfaPreview.Create(AOwner: TComponent; WithMultiAndThumbnailView: Boolean = True; idx: Integer = -1);
const
  EM_GETZOOM = (WM_USER + 224);
  EM_SETZOOM = (WM_USER + 225);
var
  i: Integer;
  subitem: TSpTBXSubmenuItem;
  GripColor1, GripColor2: TColor;
  GripBrushStyle: TBrushStyle;
  GripSize: Integer;
  ExtendedGrips: Boolean;
  Shape: TIEGripShape;
begin
  FPreviewCreating := True;
  try
    FActiveDoc := nil;
    FActivePage := -1;
    CurrentLayer := 0;
    CurrentLayerRights := 0;
    FChangeEditDocIdx := -1;
    FChangeDocNameInProcess := False;
    FActThumbnailWidth := bitfarmApp.MViewThumbWidth;
    FActThumbnailHeight := bitfarmApp.MViewThumbHeight;
    FDoViewResize := False;
    FtxObjList := TStringList.Create;
    FtxSearchPos := -1;
    FtxSearchPosOldColor := -1;
    PreviewActiveated := False;
    SearchbarModified := False;

    FMViewDBLClick := False;

    inherited Create(AOwner);

    if bitfarmApp <> nil then
    begin
      Font.Size := bfaFontSize; //10.09.2020
      itmBack.FontSettings.Size := bfaFontSettingsSize; //10.09.2020
      btnPreview.FontSettings.Size := bfaFontSettingsSize;
      btnFulltext.FontSettings.Size := bfaFontSettingsSize;
      btnHistory.FontSettings.Size := bfaFontSettingsSize;
      btnCommentary.FontSettings.Size := bfaFontSettingsSize;

      AnnoToolbar.Images := bfaIconsDM.bfaIcons.ilPreview;
      tbi_annodelete.Images := bfaIconsDM.bfaIcons.ilPreview;
      itmSymLink.ImageIndex := Integer(icoidx_original_view);
      tbi_normalmouse.ImageIndex := Integer(icoidx_pointer);
      tbi_annoselect.ImageIndex := Integer(icoidx_move);
//19.10.2021 Ticket 28299 -->
//      tbi_fav1.ImageIndex := Integer(icoidx_stamp_blue);
//      tbi_fav2.ImageIndex := Integer(icoidx_stamp_green);
//      tbi_fav3.ImageIndex := Integer(icoidx_stamp_yellow);
//      tbi_fav4.ImageIndex := Integer(icoidx_stamp_purple);
//      tbi_fav5.ImageIndex := Integer(icoidx_stamp_orange);
//      tbi_fav6.ImageIndex := Integer(icoidx_stamp_aqua);
//      tbi_fav7.ImageIndex := Integer(icoidx_stamp_black);
//      tbi_fav8.ImageIndex := Integer(icoidx_stamp_grey);
//      tbi_fav9.ImageIndex := Integer(icoidx_stamp_pink);
//      tbi_fav10.ImageIndex := Integer(icoidx_stamp_red);
      tbi_fav1.ImageIndex := Integer(icoidx_stamp_yellow);
      tbi_fav2.ImageIndex := Integer(icoidx_stamp_green);
      tbi_fav3.ImageIndex := Integer(icoidx_stamp_red);
      tbi_fav4.ImageIndex := Integer(icoidx_stamp_blue);
      tbi_fav5.ImageIndex := Integer(icoidx_stamp_orange);
      tbi_fav6.ImageIndex := Integer(icoidx_stamp_pink);
      tbi_fav7.ImageIndex := Integer(icoidx_stamp_grey);
      tbi_fav8.ImageIndex := Integer(icoidx_stamp_purple);
      tbi_fav9.ImageIndex := Integer(icoidx_stamp_aqua);
      tbi_fav10.ImageIndex := Integer(icoidx_stamp_black);
//19.10.2021 Ticket 28299 <--

      tbi_stampdialog.ImageIndex := Integer(icoidx_dialog_stamp);
//      tbiClipboardAsStamp.ImageIndex := Integer(icoidx_clipboard_stamp);
      tbsub_text.ImageIndex := Integer(icoidx_text);
      tbi_text1.ImageIndex := Integer(icoidx_text_1);
      tbi_text2.ImageIndex := Integer(icoidx_text_2);
      tbi_text3.ImageIndex := Integer(icoidx_text_3);
      tbi_text4.ImageIndex := Integer(icoidx_text_4);
      tbi_text5.ImageIndex := Integer(icoidx_text_5);
      tbsub_notes.ImageIndex := Integer(icoidx_note_yellow);
      tbi_note1.ImageIndex := Integer(icoidx_note_yellow);
      tbi_note2.ImageIndex := Integer(icoidx_note_green);
      tbi_note3.ImageIndex := Integer(icoidx_note_red);
      tbi_note4.ImageIndex := Integer(icoidx_note_blue);
      tbi_note5.ImageIndex := Integer(icoidx_note_orange);
      tbsub_highlight.ImageIndex := Integer(icoidx_marker_yellow);
      tbi_highlite1.ImageIndex := Integer(icoidx_marker_yellow);
      tbi_highlite2.ImageIndex := Integer(icoidx_marker_green);
      tbi_highlite3.ImageIndex := Integer(icoidx_marker_red);
      tbi_highlite4.ImageIndex := Integer(icoidx_marker_blue);
      tbi_highlite5.ImageIndex := Integer(icoidx_marker_orange);
      tbsub_pencil.ImageIndex := Integer(icoidx_pencil_yellow);
      tbi_pencil1.ImageIndex := Integer(icoidx_pencil_yellow);
      tbi_pencil2.ImageIndex := Integer(icoidx_pencil_green);
      tbi_pencil3.ImageIndex := Integer(icoidx_pencil_red);
      tbi_pencil4.ImageIndex := Integer(icoidx_pencil_blue);
      tbi_pencil5.ImageIndex := Integer(icoidx_pencil_orange);
      tbi_line.ImageIndex := Integer(icoidx_line);
      tbi_arrow.ImageIndex := Integer(icoidx_arrow);
      tbi_graphicoptions.ImageIndex := Integer(icoidx_paint_settings);
      tbi_rangeocr.ImageIndex := Integer(icoidx_ocr);
      tbi_SearchBar.ImageIndex := Integer(icoidx_search);

      actList := TActionList.Create(Self);
      CloneActions; //20.02.2019

      FMouseDown := False;
      FMouseDownArea := Rect(Point(0, 0), Point(0, 0));

      Fbisktstamp := False;
      FDontSetPage := False;
      FTurned := False;
      FDontUseMouseEnter := False;

      FtxPos := TList<TbfaFtxPos>.Create;

      FDelay := TTimer.Create(Self);
      FDelay.OnTimer := DoDelayTimer;
      FDelay.Interval := 250;
      FDelay.Enabled := False;
      FTimerObj := nil;
      FTimerAction := -1;
      FTimerIdx := -1;
      FTimerPageSortings := False;

      SpTBXPanel1.DoubleBuffered := False; // macht schwarze Ecken

      if WithMultiAndThumbnailView then
      begin
        CreateMultiView(FimgMultiView, Self, SpTBXPanel1, FActThumbnailWidth, FActThumbnailHeight);
        with FimgMultiView do
        begin
          TabStop := True;
          OnClick := MViewClick;
          OnDblClick := MultiViewDblClick;
          OnMouseDown := MViewMouseDown;
          OnMouseMove := MViewMouseMove;
          OnMouseUp := MViewMouseUp;
          OnImageSelect := MViewImageSelect;
          OnImageDeSelect := MViewImageDeSelect;
          OnKeyDown := PrevKeyDown;
          OnResize := MViewResize;
          OnViewChange := MViewViewChange;

          PopupMenu := frmMainForm.ppmTools;
        end;

        TImageEnView(FimgMultiView).DelayDisplaySelection := True;
      end;

      FimgSingleView := Tfrm_Voransicht.Create(Self);
      FimgSingleView.Parent := SpTBXPanel1;
      FimgSingleView.Name := 'FimgSingleView';
      FimgSingleView.Align := alClient;
      FimgSingleView.fParentHandle := Self.Handle;
      FimgSingleView.img_DocView.Background := stlBackgroundStyle.Color; //18.04.2023
      FimgSingleView.img_DocView.TabStop := True;
      FimgSingleView.img_DocView.IO.AutoAdjustDPI := True;
      FimgSingleView.img_DocView.IO.Aborting := True;
      FimgSingleView.img_DocView.ObjBoxInnerSelectable := True;
      FimgSingleView.img_DocView.MaxSelectionDistance := 30;
      FimgSingleView.img_DocView.MaxMovingDistance := 30;
      FimgSingleView.img_DocView.AllowOutOfBitmapMoving := False;
      FimgSingleView.img_DocView.AllowOutOfBitmapPolylines := False;
      FimgSingleView.img_DocView.MouseWheelParams.ZoomPosition := iemwMouse;
      FimgSingleView.img_DocView.OnKeyDown := PrevKeyDown;
      FimgSingleView.img_DocView.PopupMenu := frmMainForm.ppmTools;
      {$IFDEF ImageEn1140}
      if bitfarmApp.ViewerOptions.EditorOptions.DocEditorZoom then
      begin
        FimgSingleView.img_DocView.MouseWheelParams.Action := iemwVScroll;
        FimgSingleView.img_DocView.MouseWheelParams.InvertDirection := False;
        FimgSingleView.img_DocView.MouseWheelParamsAlt.Action := iemwZoom;
        FimgSingleView.img_DocView.MouseWheelParamsAlt.InvertDirection := not bitfarmApp.ViewerOptions.EditorOptions.InvertDirection;
      end else
      begin
        FimgSingleView.img_DocView.MouseWheelParams.Action := iemwZoom;
        FimgSingleView.img_DocView.MouseWheelParams.InvertDirection := not bitfarmApp.ViewerOptions.EditorOptions.InvertDirection;
        FimgSingleView.img_DocView.MouseWheelParamsAlt.Action := iemwVScroll;
        FimgSingleView.img_DocView.MouseWheelParamsAlt.InvertDirection := False;
      end;
      {$ELSE}
      FimgSingleView.img_DocView.MouseWheelParams.InvertDirection := bitfarmApp.ViewerOptions.EditorOptions.InvertDirection;
      {$ENDIF}

      FimgSingleView.img_DocView.OnMouseWheel := bfaSingleMouseWheel;
      FimgSingleView.OnPluginExecuteOnStamp := bitfarmApp.ExecutePluginViaStamp;
      FimgSingleView.img_DocView.Clear;
      FimgSingleView.img_DocView.Blank;

      FimgSingleView.fOnObjectOver := ShowAnnoData;
      FimgSingleView.fOnDblClick := OpenDocInNewTab;
      FimgSingleView.img_DocView.OnClick := SetActivePreview;
      FimgSingleView.fOnMouseLeave := bfaMouseLeave;
      FimgSingleView.fOnMouseUpSelection := CopyOCRResultToClipbrd;

      FimgSingleView.Visible := True;
      FActiveView := avDocument;
      // die weiteren Frames History, Fulltext, Discussion

      FHistoryView := TfraHistory.Create(Self);
      FHistoryView.Parent := SpTBXPanel1;
      FHistoryView.Name := 'FHistoryView';
      FHistoryView.Align := alClient;
      FHistoryView.Hide;

      FFulltextView := TfraFulltext.Create(Self);
      FFulltextView.Parent := SpTBXPanel1;
      FFulltextView.Name := 'FFulltextView';
      FFulltextView.Align := alClient;
      FFulltextView.Hide;

      FCommentaryView := TfraCommentary.Create(Self);
      FCommentaryView.Parent := SpTBXPanel1;
      FCommentaryView.Name := 'FCommentaryView';
      FCommentaryView.Align := alClient;
      FCommentaryView.Hide;
      FCommentaryView.ComQuery.Connection := dmMain.cntMain;

      if WithMultiAndThumbnailView then
        CreateThumbnail;

      FThumbnailTimer := TTimer.Create(Self);
      FThumbnailTimer.Enabled := False;
      FThumbnailTimer.Interval := 200;
      FThumbnailTimer.OnTimer := ThumbnailTimerTimer;

      FShowThumbnail := bitfarmApp.ViewerOptions.EditorOptions.ShowViewerThumbnail or
        frmMainForm.FViewerThumbnailsVisible; // bfacrm:ticket__show__31488

      previewToolWindow.Visible := FShowThumbnail;

      FbfaTlbPreview := TbfaTlbPreview.Create(Self);
      FbfaTlbPreview.CurrentDock := previewDockTop;

      CreateSearchToolbar;

      FulltextPositionLst := TList<TbfaFulltextPosition>.Create;
      FulltextCurrentIndex := -1;

      with FbfaTlbPreview do
      begin
        Name := 'FbfaTlbPreview';
        CreateComponents;

        DockMode := dmCannotFloat;
        edtPageNumber.OnChange := bitfarmApp.PageNumberChange;
        edtPageNumber.OnKeyDown := frmMainForm.edtPageNumberKeyUp;
//30.08.2022        edtPageNumber.OnAcceptText := bitfarmApp.AcceptText;

        mnuPreviousPage.Action := actPreviousPage;
        mnuNextPage.Action := actNextPage;
        mnuPublicAnno.Action := actPublicAnno;
        mnuPrivateAnno.Action := actPrivateAnno;
        mnuStationery.Action := actStationery;
        sbmStationery.Action := actStationery;
        mnuZoom100.Action := actZoom100;
        mnuZoomPage.Action := actZoomPage;
        mnuZoomWidth.Action := actZoomWidth;
        mnuZoomHeight.Action := actZoomHeight;
        mnuZoomSelect.Action := actZoomSelect;
        mnuZoomOff.Action := actZoomOff;
        sbmAutozoom.Action := actAutozoom;
        cbxZoom.OnChange := cbxZoomChange;

        mnuFtxPos.Action := actFtxPos;
        Items.Add(TTBSeparatorItem.Create(FbfaTlbPreview));
        FitmThumbnail := TSpTBXItem.Create(FbfaTlbPreview);

        Items.Add(FitmThumbnail);
        FitmThumbnail.Action := frmMainForm.actViewThumbnails;

        case bitfarmApp.ViewerOptions.EditorOptions.Autozoom of
          0:
            sbmAutozoom.ImageIndex := Integer(icoidx_preview_original);
          1:
            sbmAutozoom.ImageIndex := Integer(icoidx_preview_auto);
          2:
            sbmAutozoom.ImageIndex := Integer(icoidx_preview_width);
          3:
            sbmAutozoom.ImageIndex := Integer(icoidx_select);
          4:
            sbmAutozoom.ImageIndex := Integer(icoidx_preview_no_autozoom);
          5:
            sbmAutozoom.ImageIndex := Integer(icoidx_preview_width);
        end;

        if sbmAutozoom.ImageIndex = Integer(icoidx_preview_auto) then
          FimgSingleView.fAutozoom := False
        else
          FimgSingleView.fAutozoom := True;

        if (frmMainForm.bfaTlbPreview1.mnuStationery <> nil) then
        begin
          mnuStationery.Visible := frmMainForm.bfaTlbPreview1.mnuStationery.Visible;
          sbmStationery.Visible := frmMainForm.bfaTlbPreview1.sbmStationery.Visible;
          mnuStationery.Enabled := frmMainForm.bfaTlbPreview1.mnuStationery.Enabled;
          sbmStationery.Enabled := frmMainForm.bfaTlbPreview1.sbmStationery.Enabled;
          mnuStationery.Checked := frmMainForm.bfaTlbPreview1.mnuStationery.Checked;
          sbmStationery.Checked := frmMainForm.bfaTlbPreview1.sbmStationery.Checked;

          for i := 0 to frmMainForm.bfaTlbPreview1.sbmStationery.Count - 1 do
          begin
            sbmStationery.Add(TSpTBXItem.Create(sbmStationery));
            sbmStationery[i].Caption := frmMainForm.bfaTlbPreview1.sbmStationery[i].Caption;
            sbmStationery[i].Tag := frmMainForm.bfaTlbPreview1.sbmStationery[i].Tag;
            sbmStationery[i].Checked := frmMainForm.bfaTlbPreview1.sbmStationery[i].Checked;
            sbmStationery[i].OnClick := OnStationeryClick;
          end;
        end;
      end;

      FbfaTlbStandard := TbfaTlbStandard.Create(Self);
      FbfaTlbStandard.CurrentDock := previewDockTop;

      with FbfaTlbStandard do
      begin
        Name := 'FbfaTlbStandard';

        CreateComponents;

        DockMode := dmCannotFloat;

        tlbStandardSubmenuItemSaveTIF.Action := actLocalSaveTIF;
        tlbStandardSubmenuItemSavePDF.Action := actLocalSavePDF;
        tlbStandardSubmenuItemSaveOriginal.Action := actLocalSaveOriginal;
        tlbStandardSubmenuItemSaveLink.Action := actLocalSaveLink;
        tlbStandardSubmenuItemSavePreview.Action := actLocalSavePreview;
        tlbStandardSubmenuItemEmailPDF.Action := actEmailPDFAttachment;
        tlbStandardSubmenuItemEmailTIF.Action := actEmailTIFAttachment;
        tlbStandardSubmenuItemEmailOriginal.Action := actEmailOriginal;
        tlbStandardSubmenuItemEmailLink.Action := actEmailLink;
        tlbStandardSubmenuItemEmailPreview.Action := actEmailPreview;
        tlbStandardSubmenuItemPrintStandard.Action := actPrintStandard;
        tlbStandardSubmenuItemPrintPreview.Action := actPrintPreview;
        tlbStandardSubmenuItemClipboardDoc.Action := actCopyDocToClipboard;
        tlbStandardSubmenuItemClipboardOriginalDoc.Action := actCopyOriginalDocToClipboard;
        tlbStandardSubmenuItemClipboardPage.Action := actCopyPageToClipboard;
        tlbStandardSubmenuItemClipboardLink.Action := actCopyDocLinkToClipboard;
        if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave <> nil then
        begin
          if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action.Name = 'actLocalSaveTIF' then
            FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSaveTIF
          else if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action.Name = 'actLocalSavePDF' then
            FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSavePDF
          else if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action.Name = 'actLocalSaveOriginal' then
            FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSaveOriginal
          else if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action.Name = 'actLocalSaveLink' then
            FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSaveLink
          else if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action.Name = 'actLocalSavePreview' then
            FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSavePreview;
        end;

        if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail <> nil then
        begin
          if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action.Name = 'actEmailTIFAttachment' then
            FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailTIFAttachment
          else if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action.Name = 'actEmailPDFAttachment' then
            FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailPDFAttachment
          else if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action.Name = 'actEmailOriginal' then
            FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailOriginal
          else if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action.Name = 'actEmailLink' then
            FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailLink
          else if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action.Name = 'actEmailPreview' then
            FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailPreview;
        end;

        if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemPrint <> nil then
        begin
          if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemPrint.Action.Name = 'actPrintStandard' then
            FbfaTlbStandard.tlbStandardSubmenuItemPrint.Action := actPrintStandard
          else if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemPrint.Action.Name = 'actPrintPreview' then
            FbfaTlbStandard.tlbStandardSubmenuItemPrint.Action := actPrintPreview;
        end;

        if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemClipboard <> nil then
        begin
          if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action.Name = 'actCopyDocToClipboard' then
            FbfaTlbStandard.tlbStandardSubmenuItemClipboard.Action := actCopyDocToClipboard
          else if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action.Name = 'actCopyOriginalDocToClipboard' then
            FbfaTlbStandard.tlbStandardSubmenuItemClipboard.Action := actCopyOriginalDocToClipboard
          else if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action.Name = 'actCopyPageToClipboard' then
            FbfaTlbStandard.tlbStandardSubmenuItemClipboard.Action := actCopyPageToClipboard
          else if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action.Name = 'actCopyDocLinkToClipboard' then
            FbfaTlbStandard.tlbStandardSubmenuItemClipboard.Action := actCopyDocLinkToClipboard;
        end;

        tlbStandardTreeView.Visible := False;
        tlbStandardSearchOptions.Visible := False;
        tlbStandardThumbnail.Visible := False;
        tlbStandardFloatingWVL.Visible := False;
        tlbStandardSeparatorItem5.Visible := False;
        tlbStandardSave.Action := frmMainForm.actSave;
        tlbStandardSave.Caption := '';
        tlbStandardCancel.Action := frmMainForm.actCancel;

        tlbStandardRotateLeft.Action := actRotateLeft;
        tlbStandardFlip.Action := actFlip;
        tlbStandardRotateRight.Action := actRotateRight;
        tlbStandardEditTags.Action :=actEditTags;
        tlbStandardAutoRef.Action := actAutoRef;
        tlbStandardNewLink.Action := actNewLink;
        tlbStandardAddLink.Action := actAddLink;
        tlbStandardDeletePage.Action := actDeletePages;
      end;

      itmAuditProof.Action := frmMainForm.actAuditProof;
      FEdit := TEdit.Create(Self);
      FEdit.Parent := Self;
      FEdit.Visible := False;
      FEdit.OnKeyDown := EditKeyDown; // SJ 17.01.2020
      FEdit.OnKeyPress := EditKeyPress; // SJ 17.01.2020

      actList.Images := bfaIconsDM.bfaIcons.ilMainMenu;
      navigationToolBar.Images := bfaIconsDM.bfaIcons.ilMainMenu;

      tbi_annoselect.Images := bfaIconsDM.bfaIcons.ilMainMenu;
      tbi_normalmouse.Images := bfaIconsDM.bfaIcons.ilMainMenu;
      tbi_graphicoptions.Images := bfaIconsDM.bfaIcons.ilMainMenu;
      tbi_SearchBar.Images := bfaIconsDM.bfaIcons.ilMainMenu;
      // tbiClipboardAsStamp.Images := bfaIconsDM.bfaIcons.ilMainMenu;

      itmAuditProof.Images := bfaIconsDM.bfaIcons.ilMainMenu;
      itmSymLink.Images := bfaIconsDM.bfaIcons.ilMainMenu;
      frmMainForm.ppmTools.Images := bfaIconsDM.bfaIcons.ilMainMenu;
      bfaTlbPreview.Images := bfaIconsDM.bfaIcons.ilMainMenu;
      bfaTlbStandard.Images := bfaIconsDM.bfaIcons.ilMainMenu;
      tbi_rangeocr.Action := frmMainForm.actRangeOCR;

      SetPreviewKind(pvkSingle);

      FimgSingleView.fCbx_MainFormZoom := frmMainForm.bfaTlbPreview1.cbxZoom;
      FimgSingleView.fCbx_Zoom := FbfaTlbPreview.cbxZoom;

      ControlStyle := ControlStyle + [csDisplayDragImage];
      for i := 0 to ControlCount - 1 do
        Controls[i].ControlStyle := Controls[i].ControlStyle + [csDisplayDragImage];

      LoadFavStampbuttons(gasfavstemp, tbi_fav1, tbi_fav2, tbi_fav3, tbi_fav4, tbi_fav5, tbi_fav6, tbi_fav7, tbi_fav8, tbi_fav9, tbi_fav10);
      FStatObj := TbfaStationery.Create;
      FMouseSelection := False;
      LoadToolBarLayout(idx);
      SetCaptionsTranslated;
      //BT 15.04.2021 -->
      itmModifyColor.Images := bfaIcons.ilPreview;
      itmModifyColor.ImageIndex := Integer(icoidx_change_color);
      itmModifyText.Images := bfaIcons.ilPreview;
      itmModifyText.ImageIndex := Integer(icoidx_change_format);
      tbi_annodelete.Images := bfaIcons.ilMainMenu;
      tbi_annodelete.ImageIndex := Integer(icoidx_annotation_delete);
      //BT 15.04.2021 -->
      StampStatefield := -1;
      TranslateComponent(Self, sSysGnuViewerDomain);
    end;
  finally
    FPreviewCreating := False;
  end;
end;

destructor TbfaPreview.Destroy;
var
  i, j: Integer;
  found: Boolean;
begin
  if Application.Terminated then
  begin
    inherited Destroy;
    Exit;
  end;

  if Assigned(bitfarmApp) and bitfarmApp.ClosingMainForm then
    Exit;

  bitfarmLog.DebugBegin(llDebug, 'TbfaPreview.Destroy - ' + Self.Name, ClassName);
  try
    try
      if not bitfarmApp.ClosingMainForm then //05.12.2018
      begin
        try
          KillThumbnailThread(True);
          FThumbnailThread := nil;

          FThumbnailTimer.Enabled := False;
          FThumbnailTimer.Free;
        except
          bitfarmLog.Write(llNormal, ltException, 'TbfaPreview.Destroy; - 1', ClassName);
        end;

        try
          try
            if FimgMultiView <> nil then
            begin
              try
                FimgMultiView.Free;
              finally
                FimgMultiView := nil;
              end;
            end;
            if FimgThumbnailView <> nil then
            begin
              try
                FimgThumbnailView.Free;
              finally
                FimgThumbnailView := nil;
              end;
            end;
            if FimgSingleView <> nil then
            begin
              try
                FimgSingleView.Free;
              finally
                FimgSingleView := nil;
              end;
            end;
          except
            bitfarmLog.Write(llNormal, ltException, 'TbfaPreview.Destroy; - 2', ClassName);
          end;
        finally
          if FimgMultiView <> nil then
            FimgMultiView := nil;
          if FimgThumbnailView <> nil then
            FimgThumbnailView := nil;
          if FimgSingleView <> nil then
            FimgSingleView := nil;
        end;

        try
          if FList <> nil then
          begin
            if (FList.Count > 0) and (bitfarmApp.CurrentContainer <> nil) then
            begin
              for i := FList.Count - 1 to 0 do
              begin
                if not IsDocumentInOtherPreview(Self, FList[i]) then
                begin
                  j := 0;
                  found := False;
                  while ((not found) and Assigned(bitfarmApp.CurrentContainer)
                    and (j <= bitfarmApp.CurrentContainer.Count - 1)) do
                  begin
                    if FList[i] = bitfarmApp.CurrentContainer[j] then
                      found := True
                    else
                      Inc(j);
                  end;

                  if found then
                    bitfarmApp.CurrentContainer.Delete(j);
                  if (FList[i] <> nil) and (not bitfarmApp.ClosingMainForm) then
                  begin
                    try
                      if (bitfarmApp <> nil) then
                      begin
                        if bitfarmApp <> nil then
                        begin
                          try
                          except //17.01.2019
                            FList[i].Free;
                          end;
                        end;
                      end;
                    finally
                      FList[i] := nil;
                    end;
                  end;
                end;
                FList.Delete(i);
              end;
            end;
            FreeAndNil(FList);
          end;
        except
          bitfarmLog.Write(llNormal, ltException, 'TbfaPreview.Destroy; - 3', ClassName);
        end;

        try
          FreeAndNil(FHistoryView);
          FreeAndNil(FFulltextView);
          FreeAndNil(FCommentaryView);
        except
          bitfarmLog.Write(llNormal, ltException, 'TbfaPreview.Destroy; - 4', ClassName);
        end;

        if FtxPos <> nil then
        begin
          try
            try
              for i := 0 to FtxPos.Count - 1 do
              begin
                try
                  FtxPos[i].Free;
                finally
                  FtxPos[i] := nil;
                end;
              end;
              FreeAndNil(FtxPos);
            finally
              if FtxPos <> nil then
                FtxPos := nil;
            end;
          except
            bitfarmLog.Write(llNormal, ltException, 'TbfaPreview.Destroy; - 5', ClassName);
          end;
        end;

        try
          FreeAndNil(FtxObjList);

          FEdit.Free;
        except
          bitfarmLog.Write(llNormal, ltException, 'TbfaPreview.Destroy; - 6', ClassName);
        end;

        try
          FulltextPositionLst.Clear;
          FulltextCurrentIndex := -1;
        except
          bitfarmLog.Write(llNormal, ltException, 'TbfaPreview.Destroy; - 7', ClassName);
        end;
      end;

      try
        // SJ 10.02.2022 - bfacrm:ticket__show__30025
        // sobald das an der Preview-Toolbar hngt, kann das hier raus
        if Assigned(bitfarmApp) and bitfarmApp.ppmCalloutBallon.IsVisible then
          bitfarmApp.ppmCalloutBallon.Close;
        // bfacrm:ticket__show__30025
        inherited Destroy;
      except
        bitfarmLog.Write(llNormal, ltException, 'TbfaPreview.Destroy; - 8', ClassName);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'TbfaPreview.Destroy;', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'TbfaPreview.Destroy - ' + Self.Name, ClassName);
  end;
end;

procedure TbfaPreview.CreateImporterToolbar;
begin
  FbfaTlbImport := TbfaTlbImport.Create(Self);
  FbfaTlbImport.CurrentDock := previewDockTop;

  with FbfaTlbImport do
  begin
    CreateComponents;

    DockMode := dmCannotFloat;
    mnuScan.Action := frmMainForm.actScan;
    mnuScanDialog.Action := frmMainForm.actScanDialog;
    mnuLoadFile.Action := frmMainForm.actLoadFile;
    mnuDeleteSelected.Action := frmMainForm.actDeleteSelected;
    mnuArchive.Action := frmMainForm.actArchive;

    Images := bfaIconsDM.bfaIcons.ilMainMenu;
  end;
end;

procedure TbfaPreview.CreateSearchToolbar;
begin
  try
    bitfarmLog.DebugBegin(llDebug, 'CreateSearchToolbar', Classname);
    SearchbarToolbar := TSpTBXToolbar.Create(Self);
    with SearchbarToolbar do
    begin
      Parent := previewDockBottom;
      DockRow := 0;
      DockPos := 0;
      BiDiMode := bdLeftToRight;
      Anchors := [akLeft,akTop,akRight];
      ShrinkMode := tbsmNone;     // ST 9/23/2020   bfacrm:ticket__show__23981
      Name := 'SearchbarToolbar';
      if (Self.Owner.Name <> 'pnl_0') then
        Visible := bitfarmApp.PreviewContainer.ViewerItem.Preview.SearchbarToolbar.Visible
      else
        Visible := False;
      DockMode := dmCannotFloat;
      DockableTo := [dpTop, dpBottom];
      Floating := False;
      DefaultDock := previewDockBottom;
      DisplayMode := tbdmSelectiveCaption;
      OnDockChanging := ToolbarDockChanging;
      ShrinkMode := tbsmNone;

      SearchbarTextLabel := TSpTBXLabel.Create(Self);
      with SearchbarTextLabel do
      begin
        Parent := SearchbarToolbar;
        Caption := '  '+_('Dokument durchsuchen:')+' ';
      end;

      SearchbarTextEdit := TSpTBXEdit.Create(Self);
      with SearchbarTextEdit do
      begin
        Parent := SearchbarToolbar;
        width := 200;
        Enabled := False;

        OnKeyPress := SearchbarTextEditKeyPress;
        OnKeyDown := SearchbarTextEditKeyDown;
        OnChange := SearchEditChange;
      end;

      SearchbarSeperatorLabel1 := TSpTBXLabel.Create(Self);
      with SearchbarSeperatorLabel1 do
      begin
        Parent := SearchbarToolbar;
        Width := 5;
      end;

      SearchbarButtonUp := TSpTBXButton.Create(Self);
      with SearchbarButtonUp do
      begin
        Parent := SearchbarToolbar;
        Enabled := False;
        Height := 30;
        Width := 30;
        Images := bfaIcons.ilMainMenu;
        ImageIndex := Integer(icoidx_arrow_up);
        OnClick := SearchbarButtonUpClick; //SearchPrevious
      end;

      SearchbarButtonDown := TSpTBXButton.Create(Self);
      with SearchbarButtonDown do
      begin
        Parent := SearchbarToolbar;
        Enabled := False;
        Height := 30;
        Width := 30;
        Images := bfaIcons.ilMainMenu;
        ImageIndex := Integer(icoidx_arrow_down);
        OnClick := SearchbarButtonDownClick; //SearchNext
      end;

      SearchbarSeperatorLabel2 := TSpTBXLabel.Create(Self);
      with SearchbarSeperatorLabel2 do
      begin
        Parent := SearchbarToolbar;
        Width := 5;
      end;

      SearchbarChkAccurate := TSpTBXCheckBox.Create(Self);
      with SearchbarChkAccurate do
      begin
        Parent := SearchbarToolbar;
        Enabled := False;
        Height := 21;
        Caption := _('Exakte Suche');
        OnClick := SearchbarChkAccurateClick;
      end;

      SearchbarChkWholeWords := TSpTBXCheckBox.Create(Self);
      with SearchbarChkWholeWords do
      begin
        Parent := SearchbarToolbar;
        Enabled := False;
        Height := 21;
        Caption := _('Ganzes Wort');
        OnClick := SearchbarChkWholeWordsClick;
      end;

      SearchbarChkCircle := TSpTBXCheckBox.Create(Self);
      with SearchbarChkCircle do
      begin
        Parent := SearchbarToolbar;
        Enabled := False;
        Height := 21;
        Caption := _('Suche am Anfang/Ende fortsetzen');
      end;
    end;

    FFulltextTimer := TTimer.Create(Self);
    with FFulltextTimer do
    begin
      Enabled := False;
      Interval := 300;
      OnTimer := tmrMarkFulltext;
    end;
    bitfarmLog.DebugEnd(llDebug, 'CreateSearchToolbar', Classname);
  except
    bitfarmLog.Write(llNormal, ltException, 'CreateSearchToolbar', ClassName);
  end;
end;

procedure TbfaPreview.SearchToolbarSetState;
begin
  try
//    TODO SJ: Muss angepasst werden, sobald Property ber xml vorhanden ist
//                      aktuell bekommen wir nil zurck, wenn kein ftxpos angefragt wird.
//                      Das passiert aber auch bei Leersuchen.

//    TODO SJ: Auerdem mssen wir berlegen wie wir beim Offline-Viewer vorgehen

    //19.09.2024 SD <--bfacrm:ticket__show__39951
//    if (Self.ActiveDoc <> nil) and (Self.ActiveDoc.ID <> -1) then
//    begin
//      // Voransicht-Tab - mit OCR XML
//      if (Self.ActiveView = avDocument){ and (Self.FtxPos <> nil) and (Self.ActiveDoc.ocrxmlexsists)} then
//      begin
//        Self.SearchbarTextEdit.Enabled := True;
//        Self.SearchbarChkCircle.Enabled := True;
////        Self.SearchbarChkAccurate.Enabled := False;
////        Self.SearchbarChkWholeWords.Enabled := False;
//        Self.SearchbarChkAccurate.Enabled := True;
//        Self.SearchbarChkWholeWords.Enabled := True;
//        Self.SearchbarButtonUp.Enabled := True;
//        Self.SearchbarButtonDown.Enabled := True;
//        if SearchbarModified and (not FFulltextTimer.Enabled) then
//          FFulltextTimer.Enabled := True;
////        if (Self.FtxPos.Count = 0) then
////          frmMainForm.SetNotificationBar(_('Suchbegriff nicht gefunden!'), nil);
//{
//          // Voransicht-Tab - ohne OCR XML
//          end else if (Self.ActiveView = avDocument) and (Self.ActiveDoc.ocrxmlexsists) then
//          begin
//          Self.SearchbarTextEdit.Enabled := False;
//          Self.SearchbarChkCircle.Enabled := False;
//          Self.SearchbarChkAccurate.Enabled := False;
//          Self.SearchbarChkWholeWords.Enabled := False;
//          Self.SearchbarButtonUp.Enabled := False;
//          Self.SearchbarButtonDown.Enabled := False;
//          frmMainForm.SetNotificationBar(_('Keine Positionsinformationen vorhanden (OCR xml)'), nil);
//}
//        // Volltext-Tab
//      end else if (Self.ActiveView = avFulltext) then
//      begin
//        Self.SearchbarTextEdit.Enabled := True;
//        Self.SearchbarChkCircle.Enabled := True;
//        Self.SearchbarChkAccurate.Enabled := True;
//        Self.SearchbarChkWholeWords.Enabled := True;
//        Self.SearchbarButtonUp.Enabled := True;
//        Self.SearchbarButtonDown.Enabled := True;
//        if SearchbarModified and (not FFulltextTimer.Enabled) then
//          FFulltextTimer.Enabled := True;
//
//        // History-Tab
//      end else if (Self.ActiveView = avHistory) then
//      begin
//        Self.SearchbarTextEdit.Enabled := True;
//        Self.SearchbarChkCircle.Enabled := False;
//        Self.SearchbarChkAccurate.Enabled := False;
//        Self.SearchbarChkWholeWords.Enabled := False;
//        Self.SearchbarButtonUp.Enabled := False;
//        Self.SearchbarButtonDown.Enabled := True;
//        if (SearchbarTextEdit.Color <> cColorWhite) then
//          SearchbarTextEdit.Color := cColorWhite;
//
//        // Kommentar-Tab
//      end else if (Self.ActiveView = avCommentary) then
//      begin
//        Self.SearchbarTextEdit.Enabled := False;
//        Self.SearchbarChkCircle.Enabled := False;
//        Self.SearchbarChkAccurate.Enabled := False;
//        Self.SearchbarChkWholeWords.Enabled := False;
//        Self.SearchbarButtonUp.Enabled := False;
//        Self.SearchbarButtonDown.Enabled := False;
////        frmMainForm.SetNotificationBar(_('Suche in diesem Bereich noch nicht implementiert'), nil);
//
//        // nur zur Sicherheit
//      end else
//      begin
//        Self.SearchbarTextEdit.Enabled := False;
//        Self.SearchbarChkCircle.Enabled := False;
//        Self.SearchbarChkAccurate.Enabled := False;
//        Self.SearchbarChkWholeWords.Enabled := False;
//        Self.SearchbarButtonUp.Enabled := False;
//        Self.SearchbarButtonDown.Enabled := False;
//      end;
//
//      // kein aktives Dokument
//    end else
//    begin
//      Self.SearchbarTextEdit.Enabled := False;
//      Self.SearchbarChkCircle.Enabled := False;
//      Self.SearchbarChkAccurate.Enabled := False;
//      Self.SearchbarChkWholeWords.Enabled := False;
//      Self.SearchbarButtonUp.Enabled := False;
//      Self.SearchbarButtonDown.Enabled := False;
//    end;

    tbi_SearchBar.Enabled := (Self.ActiveDoc <> nil) and (Self.ActiveDoc.ID <> -1) and ((Self.ActiveView = avDocument) or (Self.ActiveView = avFulltext));
    Self.SearchbarToolbar.Enabled := tbi_SearchBar.Checked and tbi_SearchBar.Enabled;
    SearchbarTextLabel.Enabled := Self.SearchbarToolbar.Enabled;
    SearchbarTextEdit.Enabled := Self.SearchbarToolbar.Enabled;
    SearchbarChkCircle.Enabled := Self.SearchbarToolbar.Enabled;
    SearchbarChkAccurate.Enabled := Self.SearchbarToolbar.Enabled;
    SearchbarChkWholeWords.Enabled := Self.SearchbarToolbar.Enabled;
    SearchbarButtonUp.Enabled := Self.SearchbarToolbar.Enabled;
    SearchbarButtonDown.Enabled := Self.SearchbarToolbar.Enabled;
    //19.09.2024 SD <--bfacrm:ticket__show__39951

  except
    bitfarmLog.Write(llNormal, ltException, 'SearchToolbarSetState', ClassName);
  end;
end;

procedure TbfaPreview.SearchEditChange(Sender: TObject);
begin
  try
    try
      if fIsSettingValue then
        Exit;

      SearchbarModified := True;
      SearchbarPreviewModified := True;
      SearchbarHistoryModified := True;
      SearchbarCommentaryModified := True;
      FFulltextTimer.Enabled := False;
      FFulltextTimer.Enabled := True;

      SearchbarTextEdit.Color := cColorWhite;
    finally
      bitfarmLog.Write(llNormal, ltDebug, 'SearchEditChange', ClassName);
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SearchEditChange', ClassName);
  end;
end;

procedure TbfaPreview.SearchbarTextEditKeyPress(Sender: TObject; var Key: Char);
begin
  try
    if Key = #13 {VK_Return} then
      Key := #0;  // SJ: gegen den PLING-Ton
  except
    bitfarmLog.Write(llNormal, ltException, 'SearchbarTextEditKeyPress', ClassName);
  end;
end;

procedure TbfaPreview.SearchbarTextEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  try
    if Key = VK_RETURN then
    begin
      if (ssShift in Shift) then
        bitfarmApp.ActivePreview.SearchbarButtonUpClick(Sender)
      else
        bitfarmApp.ActivePreview.SearchbarButtonDownClick(Sender);
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SearchbarTextEditKeyDown', ClassName);
  end;
end;

procedure TbfaPreview.SearchNext(WithDialog: Boolean = True);
var
  i: Integer;
begin
  try
//  keine Volltextposition? Ciao!
    if (FulltextPositionLst.Count = 0) and (SearchbarTextEdit.Text <> '') then
    begin
      frmMainForm.SetNotificationBar(_('Suchausdruck nicht gefunden'));
      Exit;
    end;

//  initiale Suche
    if (FulltextCurrentIndex = -1) and (FulltextPositionLst.Count <> 0) and (Self.FulltextView.mmoFulltext.SelStart = 0) then
    begin
      inc(FulltextCurrentIndex);
      Self.FulltextView.mmoFulltext.SelStart := FulltextPositionLst[FulltextCurrentIndex].FWordStart;
      Self.FulltextView.mmoFulltext.SelLength := FulltextPositionLst[FulltextCurrentIndex].FWordLength;
      frmMainForm.SetNotificationBar(Format(_('Treffer %u / %u'), [FulltextCurrentIndex + 1, FulltextPositionLst.Count]));
      Exit;
    end

//   stehen wir auf dem letzten Treffer? Dann zhlen wir hoch
    else if (FulltextCurrentIndex > -1) and (FulltextCurrentIndex < FulltextPositionLst.Count - 1)
      and (FulltextPositionLst[FulltextCurrentIndex].FWordStart = Self.FulltextView.mmoFulltext.SelStart) then
    begin
//    initaler Index ist 0, auch wenn nichts markiert ist -> also bei der ersten Suche nicht increasen
      if not ((Self.FulltextView.mmoFulltext.SelStart = 0) and (Self.FulltextView.mmoFulltext.SelLength = 0) and (FulltextCurrentIndex = 0) and (FulltextPositionLst.Count = 1)) then
        inc(FulltextCurrentIndex);

      Self.FulltextView.mmoFulltext.SelStart := FulltextPositionLst[FulltextCurrentIndex].FWordStart;
      Self.FulltextView.mmoFulltext.SelLength := FulltextPositionLst[FulltextCurrentIndex].FWordLength;
      frmMainForm.SetNotificationBar(Format(_('Treffer %u / %u'), [FulltextCurrentIndex + 1, FulltextPositionLst.Count]));
      Exit;
    end else
    begin

//    wenn wir nicht auf dem letzten Treffer stehen, suchen wir den nchsten Treffer und setzen den index
      for i := 0 to FulltextPositionLst.Count - 1 do
      begin

//      gibt es ein Wort das nach der aktuellen Position vorkommt?
        if FulltextPositionLst[i].FWordStart > Self.FulltextView.mmoFulltext.SelStart then
        begin
          FulltextCurrentIndex := i;
          Self.FulltextView.mmoFulltext.SelStart := FulltextPositionLst[i].FWordStart;
          Self.FulltextView.mmoFulltext.SelLength := FulltextPositionLst[i].FWordLength;
          frmMainForm.SetNotificationBar(Format(_('Treffer %u / %u'), [FulltextCurrentIndex + 1, FulltextPositionLst.Count]));
          Exit;

//      wenn nein, stehen wir an der letzten Position und sollten ggf. wieder von Anfang an Suchen
        end else if (i = FulltextPositionLst.Count -1) and (FulltextPositionLst[0].FWordStart >= 0) then
        begin
          if SearchbarChkCircle.Checked or ((WithDialog) and
            (BfMessageDlg(_('Kein weiteres Vorkommen gefunden.\nMchten Sie vom Dokumentenanfang weitersuchen?'),
              mtConfirmation, [mbYes,mbNo]) = mrYes)) then
          begin
            FulltextCurrentIndex := 0;
            //Self.FulltextView.mmoFulltext.SelStart := 0;  // Verhalten wie beim neu laden des Dokuments. Wir stehen oben
            Self.FulltextView.mmoFulltext.SelStart := FulltextPositionLst[0].FWordStart;
            Self.FulltextView.mmoFulltext.SelLength := FulltextPositionLst[0].FWordLength;
            frmMainForm.SetNotificationBar(Format(_('Treffer %u / %u'), [FulltextCurrentIndex + 1, FulltextPositionLst.Count]));
          end;
        end;
      end;
    end;
    bitfarmLog.Write(llNormal, ltDebug, 'SearchNext', ClassName);
  except
    bitfarmLog.Write(llNormal, ltException, 'SearchNext', ClassName);
  end;
end;

procedure TbfaPreview.SearchPrevious;
var
  newpos, testdddd: Integer;
  currentpos, i: Integer;
  stype: TSearchTypes;
  txt: string;
  FulltextPosition: TbfaFulltextPosition;
begin
  try
//  my only job is to jump to the next result

//  keine Volltextposition? Ciao, weil Schleifengefahr!
    if (FulltextPositionLst.Count = 0) then
      Exit;

    // stehen wir auf dem letzten Treffer? Dann zhlen wir runter
    if (FulltextPositionLst[FulltextCurrentIndex].FWordStart = Self.FulltextView.mmoFulltext.SelStart)
      and (FulltextCurrentIndex > 0) then
    begin
      // initaler Index ist 0, auch wenn nichts markiert ist -> also bei der ersten Suche nicht increasen
//      if not (FulltextCurrentIndex = 0) then
      dec(FulltextCurrentIndex);
//        inc(FulltextCurrentIndex);
//    begin
      Self.FulltextView.mmoFulltext.SelStart := FulltextPositionLst[FulltextCurrentIndex].FWordStart;
      Self.FulltextView.mmoFulltext.SelLength := FulltextPositionLst[FulltextCurrentIndex].FWordLength;
      frmMainForm.SetNotificationBar(Format(_('Treffer %u / %u'), [FulltextCurrentIndex + 1, FulltextPositionLst.Count]));
      Exit;
    end else
    begin
      for i := FulltextPositionLst.Count -1 downto 0 do
      begin

  //    gibt es ein Wort das nach der aktuellen Position vorkommt?
        if FulltextPositionLst[i].FWordStart < Self.FulltextView.mmoFulltext.SelStart then
        begin
          Self.FulltextView.mmoFulltext.Selstart := FulltextPositionLst[i].FWordStart;
          Self.FulltextView.mmoFulltext.SelLength := FulltextPositionLst[i].FWordLength;
          FulltextCurrentIndex := i;
          frmMainForm.SetNotificationBar(Format(_('Treffer %u / %u'), [FulltextCurrentIndex + 1, FulltextPositionLst.Count]));
          Exit;

  //    wenn nein, dann wieder von Anfang an Suchen
        end else if (i = 0) and (FulltextPositionLst[FulltextPositionLst.Count-1].FWordStart >= 0) then
        begin
          if SearchbarChkCircle.Checked or ((BfMessageDlg(_('Kein weiteres Vorkommen gefunden.\nMchten Sie vom Dokumentenende weitersuchen?'),
              mtConfirmation, [mbYes,mbNo]) = mrYes)) then
          begin
            Self.FulltextView.mmoFulltext.Selstart := FulltextPositionLst[FulltextPositionLst.Count-1].FWordStart;
            Self.FulltextView.mmoFulltext.SelLength := FulltextPositionLst[FulltextPositionLst.Count-1].FWordLength;
            FulltextCurrentIndex := FulltextPositionLst.Count-1;
            frmMainForm.SetNotificationBar(Format(_('Treffer %u / %u'), [FulltextCurrentIndex + 1, FulltextPositionLst.Count]));
          end;
        end;
      end;
    end;
    bitfarmLog.Write(llNormal, ltDebug, 'SearchPrevious', ClassName);
  except
    bitfarmLog.Write(llNormal, ltException, 'SearchPrevious', ClassName);
  end;
end;

procedure TbfaPreview.SearchbarButtonDownClick(Sender: TObject);
begin
  try
    try
      if not frmMainForm.fAppStarted then
        Exit;

      bitfarmLog.Write(llNormal, ltDebug, 'SearchbarButtonDownClick', ClassName);

  //  Erst prfen ob nderung stattgefunden hat - ja: neue Suche, nein: nchste Auswahl
      SearchbarModified := SearchbarModified or (SearchbarTextEdit.Text <> FSearchbarLastEdit);
      FSearchbarLastEdit := SearchbarTextEdit.Text;

      if (bitfarmApp.ActivePreview.ActiveView = avDocument) then
      begin
        if SearchbarPreviewModified then
        begin
          bitfarmApp.LoadFtxPos(Self.FtxPos, Self.SearchbarTextEdit.Text);
          Self.RefreshPreview(nil, FActiveDoc, True);
          SearchbarPreviewModified := False;
        end;

        // -> ocrxmlexists bentigt
        // es ist nicht verlsslich dass FtxPos nil ist, wenn keine OCR xml vorliegt.
        // D.h. zum aktuell Zeitpunkt kann man nicht sagen ob keine xml vorliegt oder
        // einfach kein Treffer gefunden wurde.
        if (Self.FtxPos = nil) {(not FActiveDoc.ocrxmlexists)} then
        begin
          frmMainForm.SetNotificationBar(_('Keine Positionsinformationen vorhanden (OCR xml)'), nil);
//          end else if (Self.FtxPos = nil) or (Self.FtxPos.Count = 0) then
//          begin
//            frmMainForm.SetNotificationBar(_('Suchausdruck nicht gefunden'), nil);
        end else if (Self.FtxPos.Count > 0) then
        begin
          bitfarmApp.ActivePreview.SingleView.SelectNextFtxSearchPos;
        end else
          frmMainForm.SetNotificationBar(_('Keine Positionsinformationen vorhanden (OCR xml)'), nil);
      end;

      // SJ 11.02.2022 - TODO
      if (bitfarmApp.ActivePreview.ActiveView = avHistory) then
      begin
        if Trim(SearchbarTextEdit.Text) <> '' then
        begin
          var Filter: String;
          Filter := Format('(Benutzer like %s)', [QuotedStr('%'+SearchbarTextEdit.Text+'%')]) + ' or ' +
                    Format('(DatumString like %s)', [QuotedStr('%'+SearchbarTextEdit.Text+'%')]) + ' OR ' +
                    Format('(Aktion like %s)', [QuotedStr('%'+SearchbarTextEdit.Text+'%')]);
          bitfarmApp.ActivePreview.HistoryView.HistDataSet.Filter := Filter;
          bitfarmApp.ActivePreview.HistoryView.HistDataSet.Filtered := True;
        end else
        begin
          bitfarmApp.ActivePreview.HistoryView.HistDataSet.Filter := '';
          bitfarmApp.ActivePreview.HistoryView.HistDataSet.Filtered := False;
        end;
      end;

      if SearchbarModified then
      begin
        Self.FulltextListExecute(SearchbarTextEdit.Text);
        Self.MarkText;
      end;

      // Volltext und btnDown -> nchsten Treffer
      if bitfarmApp.ActivePreview.btnFulltext.Checked then
        Self.SearchNext;
    finally
      SearchbarModified := False;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SearchbarButtonDownClick', ClassName);
  end;
end;

procedure TbfaPreview.SearchbarButtonUpClick(Sender: TObject);
begin
  try
    try
      if not frmMainForm.fAppStarted then
        Exit;

      bitfarmLog.Write(llNormal, ltDebug, 'SearchbarButtonUpClick', ClassName);

  //  Erst prfen ob nderung stattgefunden hat - ja: neue Suche, nein: nchste Auswahl
      SearchbarModified := SearchbarModified or (SearchbarTextEdit.Text <> FSearchbarLastEdit);
      FSearchbarLastEdit := SearchbarTextEdit.Text;

      if bitfarmApp.ActivePreview.btnPreview.Checked then
      begin
        if SearchbarPreviewModified then
        begin
          bitfarmApp.LoadFtxPos(Self.FtxPos, Self.SearchbarTextEdit.Text);
          Self.RefreshPreview(nil, FActiveDoc, True);
          SearchbarPreviewModified := False;
        end;

        // -> ocrxmlexists bentigt
        // es ist nicht verlsslich dass FtxPos nil ist, wenn keine OCR xml vorliegt.
        // D.h. zum aktuell Zeitpunkt kann man nicht sagen ob keine xml vorliegt oder
        // einfach kein Treffer gefunden wurde.
        if (Self.FtxPos = nil) {(not FActiveDoc.ocrxmlexists)} then
        begin
          frmMainForm.SetNotificationBar(_('Keine Positionsinformationen vorhanden (OCR xml)'), nil);
//          end else if (Self.FtxPos = nil) or (Self.FtxPos.Count = 0) then
//          begin
//            frmMainForm.SetNotificationBar(_('Suchausdruck nicht gefunden'), nil);
        end else if (Self.FtxPos.Count > 0) then
        begin
          bitfarmApp.ActivePreview.SingleView.SelectPreviousFtxSearchPos;
        end else
          frmMainForm.SetNotificationBar(_('Keine Positionsinformationen vorhanden (OCR xml)'), nil);
      end;

      if SearchbarModified then
      begin
        Self.FulltextListExecute(SearchbarTextEdit.Text);
        Self.MarkText;
      end;

      // Volltext und btnDown -> nchsten Treffer
      if bitfarmApp.ActivePreview.btnFulltext.Checked then
        Self.SearchPrevious;
    finally
      SearchbarModified := False;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SearchbarButtonUpClick', ClassName);
  end;
end;

procedure TbfaPreview.SearchbarChkWholeWordsClick(Sender: TObject);
begin
  try
    bitfarmLog.Write(llNormal, ltDebug, 'SearchbarChkWholeWordsClick', ClassName);
    // Text neu markieren
    SearchbarModified := True;

    // wir springen nicht zum nchsten Treffer, sondern heben das aktuelle Wort erneut hervor, sollte es passen
    if Self.FulltextView.mmoFulltext.SelStart > 0 then
      Self.FulltextView.mmoFulltext.SelStart := Self.FulltextView.mmoFulltext.SelStart - 1;
    FulltextCurrentIndex := -1;

    Self.SearchbarButtonDownClick(Sender);
  except
    bitfarmLog.Write(llNormal, ltException, 'SearchbarChkWholeWordsClick', ClassName);
  end;
end;

procedure TbfaPreview.SearchbarChkAccurateClick(Sender: TObject);
begin
  try
    bitfarmLog.Write(llNormal, ltDebug, 'SearchbarChkAccurateClick', ClassName);
    // Text neu markieren
    SearchbarModified := True;

    // wir springen nicht zum nchsten Treffer, sondern heben das aktuelle Wort erneut hervor, sollte es passen
    Self.FulltextView.mmoFulltext.SelStart := Self.FulltextView.mmoFulltext.SelStart - 1;
    FulltextCurrentIndex := -1;

    Self.SearchbarButtonDownClick(Sender);
  except
    bitfarmLog.Write(llNormal, ltException, 'SearchbarChkAccurateClick', ClassName);
  end;
end;

procedure TbfaPreview.tmrMarkFulltext(Sender: TObject);
begin
  try
    try
      bitfarmLog.DebugBegin(llDebug, 'tmrMarkFulltext', ClassName);
      if not SearchbarModified then
      begin
        Self.FFulltextTimer.Enabled := False;
        bitfarmLog.Write(llNormal, ltDebug, 'tmrMarkFulltext - not modified - Exit', ClassName);
        Exit;
      end;

      if (FActiveDoc = nil) then
        Exit;

      FulltextListExecute(SearchbarTextEdit.Text);

      if (FulltextPositionLst.Count <= 0) and (SearchbarTextEdit.Text <> '') and (Length(SearchbarTextEdit.Text) > 2) then
      begin
        if ActiveView <> avHistory then
          SearchbarTextEdit.Color := cColorNoRightChg;
        MarkText;
      end else if (Length(SearchbarTextEdit.Text) < 3) or (SearchbarTextEdit.Text = '') or (FulltextPositionLst.Count > 0) then
      begin
        SearchbarTextEdit.Color := cColorWhite;
        MarkText;
      end;
      bitfarmLog.DebugEnd(llDebug, 'tmrMarkFulltext', ClassName);
    finally
      Self.FFulltextTimer.Enabled := False;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'tmrMarkFulltext', ClassName);
  end;
end;

procedure TbfaPreview.MarkText;
var
  StartPos, oldSelPos, Position, RemainingLength, WordCount, TextSize, SearchSize, i, j: Integer;
  AColor: array[0..9] of TColor;
  InputStr: string;
  StrList: TStrings;
  FulltextPosition: TbfaFulltextPosition;
  RichEdit: TRichEdit;
begin
// https://www.delphipraxis.net/1204034-post8.html
  try
    bitfarmLog.DebugBegin(llDebug, 'MarkText', ClassName);
    if (not SearchbarModified) or (FActiveDoc = nil) then
    begin
      bitfarmLog.DebugEnd(llDebug, 'MarkText - no ReDraw necessary - Exit', ClassName);
      Exit;
    end;


    RichEdit := Self.FulltextView.mmoFulltext;
    oldSelPos := RichEdit.SelStart;

    // http://bcbjournal.org/articles/vol3/9910/Faster_rich_edit_syntax_highlighting.htm
    // beschleunigt das farbige Markieren ungemein
    RichEdit.OnChange := nil;
    RichEdit.OnSelectionChange := nil;
    RichEdit.OnKeyDown := nil;

    // Reset der Farben- schneller als alles markieren und Style zurcksetzen
    RichEdit.Lines.BeginUpdate;
    RichEdit.Perform(WM_SETREDRAW, 0, 0);
    RichEdit.Clear;
    RichEdit.Text := FActiveDoc.FullTXT;
    RichEdit.SelStart := 0;
    RichEdit.Perform(WM_SETREDRAW, 1, 0);
    RichEdit.Lines.EndUpdate;

    if (FulltextPositionLst.Count = 0) then
    begin
      RichEdit.SelStart := oldSelPos;
      bitfarmLog.DebugEnd(llDebug, 'MarkText - Count:0 - Exit', ClassName);
      Exit;
    end;

    AColor[0] := gclRed; // $0000FF
    AColor[1] := gclLime; // $00FF00
    AColor[2] := gclBlue; //15.04.2021 clBlue; // $FF0000
    AColor[3] := clFuchsia; // $FF00FF
    AColor[4] := clMaroon; // $000080
    AColor[5] := gclGreen; //15.04.2021 clGreen; // $008000
    AColor[6] := clNavy; // $800000
    AColor[7] := clPurple; // $800080
    AColor[8] := gclTeal; // $808000
    AColor[9] := gclOlive; // $008080

    with RichEdit do
    begin
      Lines.BeginUpdate;
      Perform(WM_SETREDRAW, 0, 0);

      for i := 0 to FulltextPositionLst.Count - 1 do
      begin
        SelStart := FulltextPositionLst[i].FWordStart;
        SelLength := FulltextPositionLst[i].FWordLength;
        SelAttributes.Style := [fsBold];
        SelAttributes.Color := AColor[FulltextPositionLst[i].FWordNumber mod 10];
      end;

      SelLength := 0; // reset selection...
      SelStart := 0; // ntig fr die korrekte Scroll-Position des Volltextes
      SelStart := oldSelPos; // wir suchen an der alten Position weiter
      Perform(WM_SETREDRAW, 1, 0);
      Lines.EndUpdate;
    end;
    bitfarmLog.DebugEnd(llDebug, 'MarkText', ClassName);
  except
    on e: exception do
      bitfarmLog.Write(llNormal, ltException, 'MarkText: ' + e.Message, ClassName);
  end;
end;

procedure TbfaPreview.FulltextListExecute(const AWord: string);
var
  AOptions: TSearchTypes;
  RichEdit: TRichEdit;
  InputStr: string;
  StrList: TStrings;
  StartPos, TextSize, SearchSize, RemainingLength, Position, i, j: Integer;
  FulltextPosition: TbfaFulltextPosition;
begin
  try
    bitfarmLog.DebugBegin(llDebug, 'FulltextListExecute', ClassName);
    // Befllt die FulltextPositionLst
    // Aber nur, wenn SearchbarModified
    if not SearchbarModified then
    begin
      bitfarmLog.DebugEnd(llDebug, 'FulltextListExecute - not modified - Exit', ClassName);
      Exit;
    end;

    if (Length(Self.FulltextView.mmoFulltext.Text) = 0) then
    begin
      bitfarmLog.DebugEnd(llDebug, 'FulltextListExecute - Length: 0 - Exit ', ClassName);
      Exit;
    end;

    if (FulltextPositionLst <> nil) then
      FulltextPositionLst.Clear;

    if SearchbarChkWholeWords.Checked then
      AOptions := [stWholeWord];

    RichEdit := Self.FulltextView.mmoFulltext;
    InputStr := Trim(ParseSemicolonUseBackslash(AWord));

    StrList := TStringList.Create;
    StrList.Clear;
    if SearchbarChkAccurate.Checked and (LeftStr(InputStr,1) <> '"') and (RightStr(InputStr,1) <> '"') then
      StrList := StrToWords4('"'+InputStr+'"')
    else
      StrList := StrToWords4(InputStr);

    if StrList.Count = 0 then
    begin
      bitfarmLog.DebugEnd(llDebug, 'FulltextListExecute - Count:0 - Exit', ClassName);
      Exit;
    end;

    for i := 0 to StrList.Count - 1 do
    begin
      if (LeftStr(StrList[i],1) = '"') and (RightStr(StrList[i],1) = '"') then
        StrList[i] := Copy(StrList[i], 2, Length(StrList[i]) -2);

      if length(StrList[i]) > 1 then
      begin
        case Ord(StrList[i][1]) of
          $2B, $2D, $2F:
            begin
              StrList[i] := copy(StrList[i], 2, length(StrList[i]));
            end;
        end;
      end;
    end;

    with RichEdit do
    begin
      for i := 0 to StrList.Count - 1 do
      begin
        if Length(StrList[i]) < 3 then
          //08.10.2024 SD -->bfacrm:ticket__show__40157   So kann man eine exakte Suche durchfhren
//          Break;
          Continue;
          //08.10.2024 SD <--bfacrm:ticket__show__40157

        StartPos := 0;
        TextSize := Length(Text);
        SearchSize := Length(StrList[i]);
        RemainingLength := TextSize;
        Position := FindText(StrList[i], StartPos, RemainingLength, AOptions);
        bitfarmLog.Write(llNormal, ltDebug, 'Suche | Wort: '+StrList[i]+' | Lnge: '+SearchSize.ToString, ClassName);

        if Position <> -1 then
          repeat
            // selects the word and changes color
            //bitfarmLog.Write(llNormal, ltDebug, 'FulltextListExecute: '+Position.ToString+' | Remain: '+RemainingLength.ToString, ClassName);

            FulltextPosition.FWord := StrList[i];
            FulltextPosition.FWordNumber := i;
            FulltextPosition.FWordStart := Position;
            FulltextPosition.FWordLength := SearchSize;

            for j := 0 to FulltextPositionLst.Count do
            begin
              if (j = FulltextPositionLst.Count) or (FulltextPositionLst[j].FWordStart > FulltextPosition.FWordStart) then
              begin
                FulltextPositionLst.Insert(j, FulltextPosition);
                Break;
              end;
            end;

            StartPos := Position + SearchSize;
            RemainingLength := TextSize - StartPos;
            Position := FindText(StrList[i], StartPos, RemainingLength, AOptions);
          until (Position = -1);
      end;
    end;
    FSearchbarLastEdit := InputStr;
    bitfarmLog.DebugEnd(llDebug, 'FulltextListExecute', ClassName);
  except
    bitfarmLog.Write(llNormal, ltException, 'FulltextListExecute', ClassName);
  end;
end;

procedure TbfaPreview.SetPreviewKind(Value: TbfaPreviewKind); // Setzt Multi oder Single Ansicht
begin
  try
    FbfaPreviewKind := Value;
    try
      FimgSingleView.Enabled := False;
      if FimgMultiView <> nil then
      begin
        FimgMultiView.Enabled := False;
        FimgMultiView.Visible := (FbfaPreviewKind = pvkMulti);
      end;
      if FimgThumbnailView <> nil then
        FimgThumbnailView.Enabled := False;
      AnnoToolbar.Visible := (FbfaPreviewKind = pvkSingle) or (FbfaPreviewKind = pvkMultiSingle);
      previewSelectToolbar.Visible := (FbfaPreviewKind = pvkSingle) or (FbfaPreviewKind = pvkMultiSingle);
      FimgSingleView.Visible := (FbfaPreviewKind = pvkSingle) or (FbfaPreviewKind = pvkMultiSingle);
      itmBack.Visible := (FbfaPreviewKind = pvkMultiSingle);

      ShowToolbars;

      if not FPreviewCreating then //18.10.2019
        SetActions;

      SetTextFonts;

    finally
      if FimgMultiView <> nil then
        FimgMultiView.Enabled := True;
      FimgSingleView.Enabled := True;
      if FimgThumbnailView <> nil then
      begin
        FimgThumbnailView.Enabled := True;
        if (FbfaPreviewKind = pvkMultiSingle) and (FimgThumbnailView.visible) and (previewToolWindow.Visible) and (not FimgThumbnailView.focused) then
          FimgThumbnailView.SetFocus;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetPreviewKind', ClassName);
  end;
end;

function TbfaPreview.GetFloating: Boolean;
begin
  try
    Result := (TSpTBXDockablePanel(Self.Owner).Parent.Name = 'dckFloating');
  except
    bitfarmLog.Write(llNormal, ltException, 'GetFloating', ClassName);
    Result := False;
  end;
end;

procedure TbfaPreview.ShowToolbars(Show: Boolean = True);
begin
  try
    Show := Show and GetFloating;
    navigationToolBar.Visible := itmBack.Visible;
//    {$IFDEF DEBUG}
// //08.09.2016    Show := True;
//    {$ENDIF}
    FbfaTlbPreview.Visible := Show and ((FbfaPreviewKind = pvkSingle) or (FbfaPreviewKind = pvkMultiSingle));
    FbfaTlbStandard.Visible := Show;
    if FbfaTlbImport <> nil then
      FbfaTlbImport.Visible := Show; { or (Self = bitfarmApp.PreviewContainer.ImporterItem.Preview);}
  except
    bitfarmLog.Write(llNormal, ltException, 'ShowToolbars', ClassName);
  end;
end;

procedure TbfaPreview.mnuSaveClick(Sender: TObject);
var
  i: Integer;
begin
  if (not frmMainForm.fAppStarted) or (FPreviewCreating) then
    Exit;

  try
    SaveToolBarLayout;

    for i := 0 to bitfarmApp.PreviewContainer.Containers.Count - 1 do
    begin
      if bitfarmApp.PreviewContainer.Containers[i].Preview <> Self then
      begin
        bitfarmApp.PreviewContainer.Containers[i].Preview.LoadToolBarLayout;
        if bitfarmApp.PreviewContainer.Containers[i].Preview.PreviewKind = pvkMulti then
        begin
          bitfarmApp.PreviewContainer.Containers[i].Preview.ShowToolbars(False);
          bitfarmApp.PreviewContainer.Containers[i].Preview.AnnoToolbar.Visible := False;
          bitfarmApp.PreviewContainer.Containers[i].Preview.previewSelectToolbar.Visible := False;
        end;
      end;
    end;

  except
    bitfarmApp.Log.Write(llDebug, ltException, 'SpTBXItem1Click', ClassName);
  end;
end;

procedure TbfaPreview.mnuResetClick(Sender: TObject);
begin
  try
    if FileExists(BD.AppdataBitfarmPd + 'PreviewLayout.ini') then
      DeleteFile(BD.AppdataBitfarmPd + 'PreviewLayout.ini');  //09.01.2020 bleibt hier noch drin, dieses ini benutzen wir nicht mehr

//09.01.2020 neue Inis    LoadToolBarLayout;
    LoadToolBarLayout(-1, True);
  except
    bitfarmApp.Log.Write(llDebug, ltException, 'SpTBXItem2Click', ClassName);
  end;
end;

procedure TbfaPreview.SetList(Value: TList<TbfaDocument>);
var
  i: Integer;
begin
  FList := Value;
  if FList <> nil then
  begin
    if FList.Count > 1 then
      SetPreviewKind(pvkMulti)
    else
      SetPreviewKind(pvkSingle);
  end else
    SetActions;
end;

procedure TbfaPreview.SetShowThumbnail(Value: Boolean);
var
  Lst: Tlist;
  i: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'SetShowThumbnail', ClassName);
  try
    FShowThumbnail := Value;
    if FShowThumbnail then
    begin
      previewToolWindow.Visible := True;

      if FActiveDoc <> nil then
        RefreshThumbnailView(nil, FActiveDoc)
      else if FimgThumbnailView <> nil then
      begin
        if Self = bitfarmApp.PreviewContainer.ImporterItem.Preview then
          FimgThumbnailView.Visible := False
        else
          FimgThumbnailView.Clear;
      end;
    end
    else
    begin
      previewToolWindow.Visible := False;
    end;
  finally
    FShowingThumbnail := False;
    bitfarmLog.DebugEnd(llDebug, 'SetShowThumbnail', ClassName);
  end;
end;

function TbfaPreview.GetAnnoToolbar_CurrentDock: TTBDock;
begin
  Result := AnnoToolbar.CurrentDock;
end;

function TbfaPreview.GetAnnoToolbar_DockPos: Integer;
begin
  Result := AnnoToolbar.DockPos;
end;

function TbfaPreview.GetAnnoToolbar_DockRow: Integer;
begin
  Result := AnnoToolbar.DockRow;
end;

function TbfaPreview.GetAnnoToolbar_LastDock: TTBDock;
begin
  Result := AnnoToolbar.LastDock;
end;

function TbfaPreview.GetClientHeight: Integer;
begin
  Result := SpTBXPanel1.ClientHeight;
end;

function TbfaPreview.GetpreviewDock1_Width: Integer;
begin
  Result := previewDockTop.Width;
end;

function TbfaPreview.GetpreviewDock2_Width: Integer;
begin
  Result := previewDockLeft.Width;
end;

function TbfaPreview.GetpreviewDock3_Width: Integer;
begin
  Result := previewDockRight.Width;
end;

function TbfaPreview.GetpreviewDock4_Width: Integer;
begin
  Result := previewDockBottom.Width;
end;

function TbfaPreview.GetSelectToolbar_CurrentDock: TTBDock;
begin
  Result := previewSelectToolbar.CurrentDock;
end;

function TbfaPreview.GetSelectToolbar_DockPos: Integer;
begin
  Result := previewSelectToolbar.DockPos;
end;

function TbfaPreview.GetSelectToolbar_DockRow: Integer;
begin
  Result := previewSelectToolbar.DockRow;
end;

function TbfaPreview.GetToolWindow_CurrentDock: TTBDock;
begin
  Result := previewToolWindow.CurrentDock;
end;

function TbfaPreview.GetToolWindow_DockPos: Integer;
begin
  Result := previewToolWindow.DockPos;
end;

function TbfaPreview.GetToolWindow_DockRow: Integer;
begin
  Result := previewToolWindow.DockRow;
end;

procedure TbfaPreview.itmBackClick(Sender: TObject);
begin
  frmMainForm.actPreviewBack.Execute;
end;

procedure TbfaPreview.itmModifyColorClick(Sender: TObject);
var
  i, hobj: Integer;
begin
  if bitfarmApp.ColorDlg.Execute then
  begin
    for i := 0 to FimgSingleView.img_DocView.SelObjectsCount - 1 do
    begin
      hobj := FimgSingleView.img_DocView.SelObjects[i];
      if (FimgSingleView.img_DocView.ObjKind[hobj] = iekMEMO) or
        (FimgSingleView.img_DocView.ObjKind[hobj] = iekTEXT) or
        (FimgSingleView.img_DocView.ObjKind[hobj] = iekBox)
      then
        FimgSingleView.img_DocView.ObjBrushColor[hobj] := bitfarmApp.ColorDlg.Color
      else
        FimgSingleView.img_DocView.ObjPenColor[hobj] := bitfarmApp.ColorDlg.Color;
    end;
  end;
end;

procedure TbfaPreview.itmModifyTextClick(Sender: TObject);
var
  i, hobj: Integer;
  font: TFont;
begin
  try
    if (FimgSingleView.img_DocView.SelObjectsCount = 1) and
      (FimgSingleView.img_DocView.ObjTextEditMode > -1) and
      (bitfarmApp.ControlAtMousePos <> nil) then
    begin
      bitfarmApp.FontDlg.Font.Name :=
        string(TIETextControl(bitfarmApp.ControlAtMousePos).InsertingCharInfo^.name);
      bitfarmApp.FontDlg.Font.Height :=
        TIETextControl(bitfarmApp.ControlAtMousePos).InsertingCharInfo^.height;
      bitfarmApp.FontDlg.Font.Style :=
        TIETextControl(bitfarmApp.ControlAtMousePos).InsertingCharInfo^.style;
      bitfarmApp.FontDlg.Font.Color :=
        TIETextControl(bitfarmApp.ControlAtMousePos).InsertingCharInfo^.color;
    end;
  except
  end;

  if bitfarmApp.FontDlg.Execute then
  begin
    font := TFont.Create;
    try
      font.Size := bitfarmApp.FontDlg.Font.Size;
      font.Name := bitfarmApp.FontDlg.Font.Name;
      font.Style := bitfarmApp.FontDlg.Font.Style;
      font.color :=  bitfarmApp.FontDlg.Font.Color;
      font.Height := bitfarmApp.FontDlg.Font.Height;
      FimgSingleView.img_DocView.LockPaint; //29.09.2021 wegen CrashLog
      try
        for i := 0 to FimgSingleView.img_DocView.SelObjectsCount - 1 do
        begin
          hobj := FimgSingleView.img_DocView.SelObjects[i];
          if (FimgSingleView.img_DocView.ObjKind[hobj] = iekMEMO) or
             (FimgSingleView.img_DocView.ObjKind[hobj] = iekTEXT) then
          begin
            FimgSingleView.img_DocView.ObjFontHeight[hobj] := font.Height;
            FimgSingleView.img_DocView.ObjFontName[hobj] := font.Name;
            FimgSingleView.img_DocView.ObjFontStyles[hobj] := font.Style;
            FimgSingleView.img_DocView.ObjPenColor[hobj] := font.Color;

            FimgSingleView.img_DocView.SetObjFont(hobj, font);
          end;
        end;
        if (FimgSingleView.img_DocView.SelObjectsCount = 1) and
           (FimgSingleView.img_DocView.ObjTextEditMode > -1) then
        begin
          if bitfarmApp.ControlAtMousePos is TIETextControl then
          begin
            TIETextControl(bitfarmApp.ControlAtMousePos).SetXFont(font);
            TIETextControl(bitfarmApp.ControlAtMousePos).Update;
          end;
        end;
      finally
        FimgSingleView.img_DocView.UnLockPaint; //29.09.2021 wegen CrashLog
      end;
    finally
      FreeAndNil(font);
    end;
  end;
end;

procedure TbfaPreview.itmSymLinkClick(Sender: TObject);
begin
//
end;

procedure TbfaPreview.SetAnnoToolbar_CurrentDock(const Value: TTBDock);
begin
  AnnoToolbar.CurrentDock := Value;
end;

procedure TbfaPreview.SetAnnoToolbar_DockPos(const Value: Integer);
begin
  AnnoToolbar.DockPos := Value;
end;

procedure TbfaPreview.SetAnnoToolbar_DockRow(const Value: Integer);
begin
  AnnoToolbar.DockRow := Value;
end;

procedure TbfaPreview.SetAnnoToolbar_LastDock(const Value: TTBDock);
begin
  AnnoToolbar.LastDock := Value;
end;

procedure TbfaPreview.SetClientHeight(Value: Integer);
begin
  SpTBXPanel1.ClientHeight := Value;
end;

procedure TbfaPreview.SetCurrentLayer(layer: Integer);
var
  annorights: Int64;
  i: Integer;
begin
  CurrentLayer := layer;
  CurrentLayerRights := 0;
  annorights := 0;

  if FActiveDoc = nil then
    Exit;

  try
    // wir holen die Rechte, die fr den Layer vergeben sind
    if FActiveDoc.Annotations <> nil then
    begin
      for i := 0 to FActiveDoc.Annotations.Count - 1 do
      begin
        if (FActiveDoc.Annotations[i].layer = CurrentLayer) then
          annorights := (annorights or FActiveDoc.Annotations[i].Rights);
      end;
    end;

    if annorights = 0 then   // keine rechte ber die annotation? dann standardrechte
    begin
      if CurrentLayer = 0 then   // beim public layer gelten die Archivrechte
        annorights := FActiveDoc.Rights
      else if CurrentLayer = bitfarmApp.User.ID then   // private Layer hat alle Rechte
        annorights := (rightAPRead or rightAPWrite or rightAPModify)
      else
      begin  // freigegebener layer ohne eine annotation bisher? datenbankabfrage
        annorights := DbTableColumnGetInteger(
          Format('select bit_or(rights) from sys_docxs where gdocid = %d and src_userid = %d and userid = %d',
          [FActiveDoc.ID, CurrentLayer, bitfarmApp.User.ID]));

      end;
    end;
    if (CurrentLayer <>0) and (CurrentLayer <> bitfarmApp.User.ID) then
    begin
      annorights := DbTableColumnGetInteger(
        Format('select bit_or(rights) from sys_docxs where gdocid = %d and src_userid = %d and userid = %d',
        [FActiveDoc.ID, CurrentLayer, bitfarmApp.User.ID]));
    end;
    CurrentLayerRights := annorights;
  except
    CurrentLayerRights := 0;
    annorights := 0;
    bitfarmLog.Write(llNormal, ltException, 'SetCurrentLayer', ClassName);
  end;
end;

procedure TbfaPreview.SetpreviewDock1_Width(const Value: Integer);
begin
  previewDockTop.Width := Value;
end;

procedure TbfaPreview.SetpreviewDock2_Width(const Value: Integer);
begin
  previewDockLeft.Width := Value;
end;

procedure TbfaPreview.SetpreviewDock3_Width(const Value: Integer);
begin
  previewDockRight.Width := Value;
end;

procedure TbfaPreview.SetpreviewDock4_Width(const Value: Integer);
begin
  previewDockBottom.Width := Value;
end;

procedure TbfaPreview.SetSelectToolbar_CurrentDock(const Value: TTBDock);
begin
  previewSelectToolbar.CurrentDock := Value;
end;

procedure TbfaPreview.SetSelectToolbar_DockPos(const Value: Integer);
begin
  previewSelectToolbar.DockPos := Value;
end;

procedure TbfaPreview.SetSelectToolbar_DockRow(const Value: Integer);
begin
  previewSelectToolbar.DockRow := Value;
end;

procedure TbfaPreview.SetToolWindow_CurrentDock(const Value: TTBDock);
begin
  previewToolWindow.CurrentDock := Value;
end;

procedure TbfaPreview.SetToolWindow_DockPos(const Value: Integer);
begin
  previewToolWindow.DockPos := Value;
end;

procedure TbfaPreview.SetToolWindow_DockRow(const Value: Integer);
begin
  previewToolWindow.DockRow := Value;
end;

procedure TbfaPreview.UnCheckAllGraphicTools;
begin
  try
    tbi_normalmouse.Checked := False;
    tbi_fav1.Checked := False;
    tbi_fav2.Checked := False;
    tbi_fav3.Checked := False;
    tbi_fav4.Checked := False;
    tbi_fav5.Checked := False;
    tbi_fav6.Checked := False;
    tbi_fav7.Checked := False;
    tbi_fav8.Checked := False;
    tbi_fav9.Checked := False;
    tbi_fav10.Checked := False;
    tbi_stampdialog.Checked := False;
    tbi_note1.Checked := False;
    tbi_note2.Checked := False;
    tbi_note3.Checked := False;
    tbi_note4.Checked := False;
    tbi_note5.Checked := False;
    tbi_line.Checked := False;
    tbi_annoselect.Checked := False;
    tbi_rangeocr.Checked := False;
    tbsub_highlight.Checked := False;
    tbsub_notes.Checked := False;
    tbsub_pencil.Checked := False;
    tbsub_text.Checked := False;
    tbi_arrow.Checked := False;
    tbi_box.Checked := False;
    tbi_polygon.Checked := False;
    tbi_ellipse.Checked := False;
    tbi_label.Checked := False;
    tbi_image.Checked := False;
    tbi_length.Checked := False;
    tbi_annodelete.Checked := False;
    tbi_angle.Checked := False;
    tbi_graphicoptions.Checked := False;
//    tbi_rangeocr.Checked := False;
    tbi_text1.Checked := False;
    tbi_text2.Checked := False;
    tbi_text3.Checked := False;
    tbi_text4.Checked := False;
    tbi_text5.Checked := False;
    tbi_highlite1.Checked := False;
    tbi_highlite2.Checked := False;
    tbi_highlite3.Checked := False;
    tbi_highlite4.Checked := False;
    tbi_highlite5.Checked := False;
    tbi_pencil1.Checked := False;
    tbi_pencil2.Checked := False;
    tbi_pencil3.Checked := False;
    tbi_pencil4.Checked := False;
    tbi_pencil5.Checked := False;
//    tbiClipboardAsStamp.Checked := False;

    FimgSingleView.fEndPolyLineOnMouseUp := False;
//20.04.2015   dm_MainForm2.mnu_OCRZusatzfelder1.visible := false;

    if FimgSingleView.img_DocView.MouseInteractVt = [miPutPolyLine] then
    begin
      {$IFNDEF IMAGEEN1140} //17.01.2024
      FimgSingleView.img_DocView.CancelInteracts;
      FimgSingleView.img_DocView.DeSelect;
      FimgSingleView.img_DocView.UnSelAllObjects;
      FimgSingleView.img_docview.MouseInteractVt := [];
      {$ENDIF}
//06.10.2021      FimgSingleView.img_docview.BitmapResampleFilter := rfLinear;
      FimgSingleView.img_docview.BitmapResampleFilter := rfFastLinear;
      {$IFNDEF IMAGEEN1140} //17.01.2024
      FimgSingleView.createannodata(FimgSingleView.img_DocView.ObjHeapCount - 1);
      {$ENDIF}
      FimgSingleView.gbAnnoNotSaved := True;
    end;

    tbi_normalmouse.Checked := True;
    FimgSingleView.img_DocView.CancelInteracts;
    FimgSingleView.img_DocView.UnSelAllObjects;
    FimgSingleView.img_DocView.MouseInteractVt := [];
    FimgSingleView.img_DocView.MouseInteract := [miscroll];
    fbisktstamp := False;
    StampStatefield := -1;
  finally
    bitfarmLog.Write(llDebug, ltDebug, 'UnCheckAllGraphicTools', ClassName);
  end;
end;

procedure TbfaPreview.MultiViewDblClick(Sender: TObject);
var
  p: TPoint;
  LeftIdx, TopIdx, Idx, sel: Integer;
  NewTab: Boolean;
  Ctrl, Alt: Boolean;
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'MultiViewDblClick - ' + Self.Name, Classname);
  FMViewDBLClick := True;
  try
    try
      Idx := CheckIfImageAtMousePos(FimgMultiView);
      if Idx > -1 then
      begin
        Ctrl := (GetKeyState(VK_CONTROL) < 0);
        Alt := (GetKeyState(VK_MENU) < 0);
//28.09.2021 Ticket 28336     if ((FimgMultiView.ImageCount > 0) and (FimgMultiView.SelectedImage > -1)) or Alt then
        if ((FimgMultiView.ImageCount > 0) and (FimgMultiView.SelectedImage > -1)) or Ctrl then
        begin
          if FimgMultiView.SelectedImage > -1 then
          begin
            if (FActiveDoc = nil) and (Flist[FimgMultiView.SelectedImage] <> nil) then
              FActiveDoc := Flist[FimgMultiView.SelectedImage];

//28.09.2021 Ticket 28336           NewTab := (bitfarmApp.GetInNewTab(Self, Ctrl)
            NewTab := (bitfarmApp.GetInNewTab(Self, Alt)
                      and ((FActiveDoc <> nil) and (FActiveDoc.HasPreview))) //24.08.2017 wegen Ticket 10703
                      or
                      ((FActiveDoc <> nil) and (not FActiveDoc.HasPreview)) //24.08.2017 wegen Ticket 10703
                      {or
                      ((FActiveDoc = nil) and (not Flist[FimgMultiView.SelectedImage].GetInProcesses)
                            and Flist[FimgMultiView.SelectedImage].HasPreview)};

            if (not NewTab) then
              FDelay.Enabled := False;

            if FEdit.Visible then
              SaveNewDocName(True);

            if not Flist[FimgMultiView.SelectedImage].GetInProcesses then
            begin
              p := FimgMultiView.ScreenToClient(Mouse.CursorPos);
              LeftIdx := FimgMultiView.ImageX[FimgMultiView.SelectedImage] + 4 - FimgMultiView.ViewX;
              TopIdx := FimgMultiView.ImageY[FimgMultiView.SelectedImage] + FActThumbnailHeight - 15 - FimgMultiView.ViewY;

              if ((p.X >= LeftIdx) and (p.X <= LeftIdx + FActThumbnailWidth) and (p.Y >= TopIdx) and (p.Y <= TopIdx + FEdit.Height)) then
              begin
                frmMainForm.actChangeDocName.Execute;
              end else
              begin
//28.09.2021 Ticket 28336 if Alt and (Self = bitfarmApp.PreviewContainer.ImporterItem.Preview) then
                if Ctrl and (Self = bitfarmApp.PreviewContainer.ImporterItem.Preview) then
                begin
                  FDelay.Enabled := False;
                  if bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView.MultiSelectedImagesCount > 1 then
                  begin
                    sel := bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView.SelectedImage;
                    bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView.Deselect;
                    bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView.SelectedImage := sel;
                  end;

                  FTimerObj := bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView;
                  FTimerAction := 0;
                  FTimerIdx := bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView.SelectedImage;
                  FTimerPageSortings := True;
                  DoDelayTimer(Self);
                end else
                begin    // Workplace und Importer
                  if FimgMultiView.SelectedImage <> -1 then
                  begin
                    if (Self = bitfarmApp.PreviewContainer.WorkplaceItem.Preview) then
                    begin
                      if (not Flist[FimgMultiView.SelectedImage].InEditMode) and bitfarmApp.ViewerOptions.EditorOptions.WorkplaceAutoEditMode then
                      begin
                        UserAction := bitfarmApp.CreateUserAction;
                        UserAction^.Actionname := 'actInProgress';
                        UserAction^.Documents.Add(Flist[FimgMultiView.SelectedImage]);
                        UserAction^.Preview := Self;
                        bitfarmApp.MainThread.Add(UserAction);
                      end;

                      bitfarmApp.MViewImageSelect(Sender, Self, FimgMultiView.SelectedImage, -1, True, NewTab, Alt, //28.09.2021 Ticket 28336 Ctrl,
                        Flist[FimgMultiView.SelectedImage].InEditMode,
                        True, bitfarmApp.ViewerOptions.EditorOptions.WorkplaceOpenDocInWorkplace,
                        False, False, False, True, -1)

                    end else if (Self = bitfarmApp.PreviewContainer.ImporterItem.Preview) then
                    begin
                      bitfarmApp.MViewImageSelect(Sender, Self, FimgMultiView.SelectedImage, -1, True, NewTab, Alt, //28.09.2021 Ticket 28336 Ctrl,
                        Flist[FimgMultiView.SelectedImage].InEditMode,
                        True, bitfarmApp.ViewerOptions.EditorOptions.ImporterOpenDocInImporter,
                        False, False, False, True, -1);
                    end;
                  end
                  else
                    bitfarmApp.MViewImageSelect(Sender, Self, FimgMultiView.SelectedImage, -1, True, NewTab, Alt, //28.09.2021 Ticket 28336 Ctrl,
                    False, True, True);
                end;
              end;
            end
            else
              bitfarmLog.Write(llNormal, ltWarning, 'Doc.ID: ' + IntToStr(Flist[FimgMultiView.SelectedImage].ID) + '; Doc.TempID: ' + GUIDToString(Flist[FimgMultiView.SelectedImage].TempID) + _(' konnte nicht geffnet werden, weil das Dokument momentan verarbeitet wird!'), 'bfaProcessing');
          end else
          begin
//28.09.2021 Ticket 28336 if Alt and (Self = bitfarmApp.PreviewContainer.ImporterItem.Preview) then
            if Ctrl and (Self = bitfarmApp.PreviewContainer.ImporterItem.Preview) then
            begin
              FDelay.Enabled := False;
              FTimerObj := bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView;
              FTimerAction := 0;
              FTimerIdx := Idx;
              FTimerObj.SelectedImage := Idx;
              FTimerPageSortings := True;
              DoDelayTimer(Self);
            end;
          end;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'MultiViewDblClick - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'MultiViewDblClick - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.ThumbnailViewDblClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'ThumbnailViewDblClick - ' + Self.Name, Classname);
  try
    try
      if (FActivedoc <> nil) then
        if FbfaPreviewKind = pvkMulti then
          if CheckIfImageAtMousePos(FimgThumbnailView) > -1 then
            bitfarmApp.MViewImageSelect(Sender, Self, TbfaImageEnMView(Sender).SelectedImage,
              -1, True, False, False, False, True, True)
    except
      bitfarmLog.Write(llNormal, ltException, 'ThumbnailViewDblClick - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ThumbnailViewDblClick - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.RefreshMultiView(Add: Boolean);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'RefreshMultiView - ' + Self.Name, Classname);
  try
    try
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actRefreshMultiView';
      if Add then
        UserAction^.Params.Add(IntToStr(1))
      else
        UserAction^.Params.Add(IntToStr(0));
      UserAction^.Preview := Self;
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'RefreshMultiView - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'RefreshMultiView - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.MViewClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'MViewClick - ' + Self.Name, Classname);
  try
    try
      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);
    except
      bitfarmLog.Write(llNormal, ltException, 'MViewClick - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'MViewClick - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.MViewImageSelect(Sender: TObject; idx: Integer);
var
  DocIdx: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'ImageSelect - ' + Self.Name, Classname);
  try
    try
      if ((FList <> nil) and (Sender is TbfaImageEnMView)) then
      begin
        if FEdit.Visible then
          SaveNewDocName(True);

        askforsave_annos2(nil);

        if ((FbfaPreviewKind = pvkMulti) or (FbfaPreviewKind = pvkMultiSingle)) then
          DocIdx := FimgMultiView.SelectedImage
        else if FbfaPreviewKind = pvkSingle then
          DocIdx := 0;
        if (((Sender as TbfaImageEnMView).Tag = tagCollectionMView) or
            ((Sender as TbfaImageEnMView).Tag = tagThumbnailMView)) then
        begin
          if ((DocIdx > -1) and (not FList[DocIdx].GetInProcesses)) then
          begin
            FDelay.Enabled := False;
            FDelay.Enabled := True;
            FTimerObj := (Sender as TbfaImageEnMView);
            FTimerAction := 0;
            FTimerIdx := idx;
          end
          else
          begin
            FActiveDoc := nil;
            SetActivePage(-1);
            try
              if FimgThumbnailView <> nil then
              begin
                if Self = bitfarmApp.PreviewContainer.ImporterItem.Preview then
                  FimgThumbnailView.Visible := False
                else
                  FimgThumbnailView.Clear;
              end;
            except
            end;
          end;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'ImageSelect - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ImageSelect - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.MViewImageDeSelect(Sender: TObject; idx: Integer);
var
  DocIdx: Integer;
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'MViewImageDeSelect - ' + Self.Name, Classname);
  try
    try
      if ((FList <> nil) and (Sender is TbfaImageEnMView)) then
      begin
        FDelay.Enabled := False;
        FDelay.Enabled := True;
        FTimerObj := TbfaImageEnMView(Sender);
        FTimerAction := 1;
        FTimerIdx := idx;
      end;

      // bfacrm:ticket__show__30288 - nicht bei Thumbs
      if ((Sender as TbfaImageEnMView).Tag = tagCollectionMView) then
      begin
        if Assigned(bitfarmApp) then
          bitfarmApp.SetChkPrintAfterArchive(Self);
      end;
      TbfaImageEnMView(Sender).Repaint;
    except
      bitfarmLog.Write(llNormal, ltException, 'MViewImageDeSelect - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'MViewImageDeSelect - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.SetActivePreview(Sender: TObject);
var
  UserAction: PUserAction;
begin
//  if bitfarmApp.ClosingMainForm then
//    Exit;
//
//  bitfarmLog.DebugBegin(llDebug, 'SetActivePreview - ' + Self.Name, Classname);
//  try
//    try
//      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
//      begin
//        UserAction := bitfarmApp.CreateUserAction;
//        UserAction^.ActionName := 'actSetActivePreview';
//        UserAction^.Objects.Add(Sender);
//        UserAction^.Params.Add(IntToStr(Self.Parent.Tag));
//        UserAction^.Params.Add(IntToStr(Integer(bitfarmApp.CurrentView)));
//
//        UserAction^.Preview := Self;
//        bitfarmApp.MainThread.Add(UserAction);
//      end
//      else
//      begin
// //07.10.2016        if (Sender is TIEView) then
// //          TIEView(Sender).SetFocus;
//      end;
//
//
//    except
//      bitfarmLog.Write(llNormal, ltException, 'SetActivePreview - ' + Self.Name, ClassName);
//    end;
//  finally
//    bitfarmLog.DebugEnd(llDebug, 'SetActivePreview - ' + Self.Name, Classname);
//  end;
end;

procedure TbfaPreview.MViewMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  MouseDownPos: TPoint;
begin
  //OutputDebugString(PChar('MViewMouseDown - ' + Self.Name));

  FMouseSelection := False;
  frmMainForm.FIsDragging := False;

  if FEdit.Visible then
    SaveNewDocName(True);
  FMouseDown := True;
  MouseDownPos := TbfaImageEnMView(Sender).ScreenToClient(mouse.cursorpos);
  FMouseDownArea := Rect(Point(MouseDownPos.X - 20, MouseDownPos.Y - 20),
    Point(MouseDownPos.X + 20, MouseDownPos.Y + 20));

  if ((Sender is TbfaImageEnMView) and ((TbfaImageEnMView(Sender).Tag = tagCollectionMView) or
      (TbfaImageEnMView(Sender).Tag = tagThumbnailMView))) then
  begin
    with (Sender as TbfaImageEnMView).GetCanvas do
    begin
      if (CheckIfImageAtMousePos((Sender as TbfaImageEnMView)) = -1) then
      begin
        moused.X := X;
        moused.Y := Y;
        current.X := X;
        current.Y := Y;

        with (Sender as TbfaImageEnMView) do
        begin
          Pen.Width := 1;
          Pen.Style := psDash;
          Pen.Mode := pmNotXOR;
          Brush.Style := bsClear;
          Pen.Color := clBlack;
        end;

        FMouseSelection := True;
      end;
    end;
  end;

end;

procedure TbfaPreview.MViewMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  FromX, ToX, FromY, ToY, i, j, idx, k: Integer;
  SList: TStringList;
  found, back: Boolean;
begin
  FMouseDown := False;
  frmMainForm.FIsDragging := False;

  if Button = mbRight then
    Exit;

  if ((Sender is TbfaImageEnMView) and ((TbfaImageEnMView(Sender).Tag = tagCollectionMView) or
      (TbfaImageEnMView(Sender).Tag = tagThumbnailMView)) and (FMouseSelection)) then
  begin
    TbfaImageEnMView(Sender).Deselect;

    if (CheckIfImageAtMousePos(TbfaImageEnMView(Sender)) = -1) then
    begin
      with (Sender as TbfaImageEnMView).GetCanvas do
      begin
        Pen.Width := 1;
        Brush.Style := bsClear;
        Rectangle(moused.x, moused.y, current.X, current.Y);
      end;
    end;
    FMouseSelection := False;

    back := False;
    if moused.X < current.X then
    begin
      FromX := moused.X;
      ToX := current.X;
      back := back or False;
    end
    else
    begin
      FromX := current.X;
      ToX := moused.X;
      back := back or True;
    end;
    if moused.Y < current.Y then
    begin
      FromY := moused.Y;
      ToY := current.Y;
      //back := back or False;
    end
    else
    begin
      FromY := current.Y;
      ToY := moused.Y;
      //back := back or True;
    end;

    SList := TStringList.Create;
    try
//      for i := FromX to ToX do
//      begin
//        for j := FromY to ToY do
//        begin
//          idx := TbfaImageEnMView(Sender).ImageAtPos(i, j);
//          if idx > -1 then
//          begin
//            k := 0;
//            found := False;
//            while ((not found) and (k <= SList.Count - 1)) do
//            begin
//              if StrToInt(SList[k]) = idx then
//                found := True
//              else
//                inc(k);
//            end;
//
//            if (not found) then
//              SList.Add(IntToStr(idx));
//
//          end;
//        end;
//      end;

      for j := FromY to ToY do
      begin
        for i := FromX to ToX do
        begin

          idx := TbfaImageEnMView(Sender).ImageAtPos(i, j);
          if idx > -1 then
          begin
            k := 0;
            found := False;
            while ((not found) and (k <= SList.Count - 1)) do
            begin
              if StrToInt(SList[k]) = idx then
                found := True
              else
                inc(k);
            end;

            if (not found) then
              SList.Add(IntToStr(idx));

          end;
        end;
      end;

      TbfaImageEnMView(Sender).MultiSelecting := True;
      if (not back) then
      begin
        for i := 0 to SList.Count - 1 do
        begin
          TbfaImageEnMView(Sender).SelectedImage := StrToInt(SList[i]);
        end;
      end
      else
      begin
        for i := SList.Count - 1 downto 0 do
        begin
          TbfaImageEnMView(Sender).SelectedImage := StrToInt(SList[i]);
        end;
      end;
      TbfaImageEnMView(Sender).MultiSelecting := False;
    finally
      FreeAndNil(SList);
    end;

    if TbfaImageEnMView(Sender).MultiSelectedImagesCount > 0 then
      MViewImageSelect(Sender, (Sender as TbfaImageEnMView).SelectedImage)
    else
      MViewImageDeSelect(Sender, -1);
  end;
end;

procedure TbfaPreview.MViewMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  MView: TbfaImageEnMView;
  idx, imgidx, i: integer;
  drg: TDragObject;
  found: Boolean;
  FileSize: WideString;
begin
  if FDontUseMouseEnter or frmMainForm.FIsDragging then
    Exit;

  if ssLeft in Shift then
  begin
    if (Sender is TbfaImageEnMView) then
    begin
      if ((TbfaImageEnMView(Sender).Tag = tagCollectionMView) or
          (TbfaImageEnMView(Sender).Tag = tagThumbnailMView)) and (FMouseSelection) then
      begin
        TbfaImageEnMView(Sender).GetCanvas.Rectangle(moused.x, moused.y, current.X, current.Y);
        current.X := X;
        current.Y := Y;
        TbfaImageEnMView(Sender).GetCanvas.Rectangle(moused.x, moused.y, current.X, current.Y);
      end
      else
      begin
        try
          MView := (Sender as TbfaImageEnMView);
          if MView <> nil then
          begin
//            if MView.MultiSelectedImagesCount > 0 then
//            begin
            imgidx := CheckIfImageAtMousePos(MView);
            if (imgidx > -1) then
            begin
              if FMouseDown then
              begin
                if not PtInRect(FMouseDownArea, Point(X, Y)) then
                begin
                  {$IFNDEF ImageEn1140}
                  MView.MouseInteract := [];
                  {$ENDIF}
                  if (not frmMainForm.FIsDragging) and (not bitfarmApp.MViewSelectingByMouseMove) then
                  begin
                    found := False;

                    if (MView.SelectedImage <> -1) or (MView.MultiSelectedImagesCount > 0) then
                    begin
                      for i := 0 to MView.MultiSelectedImagesCount - 1 do
                      begin
                        if MView.MultiSelectedImages[i] = imgidx then
                        begin
                          found := True;
                          Break;
                        end;
                      end;
                    end;

                    if found then
                    begin
                      if (FThumbnailThread <> nil) then
                      begin
                        if (GetThumbnailInProcess) and (MView.Tag = tagThumbnailMView) then
                        begin
                          frm_Message.Show;
                          frm_Message.Update;
                          Exit;
                        end;
                      end;

                      frmMainForm.FIsDragging := True;
                      bitfarmApp.FUseFileTarget := False;
                      frmMainForm.CreateDragImage;
                      frmMainForm.desResultGrid.ImageIndex := 0;
                      frmMainForm.DropFileSource1.ImageIndex := 0;
                      MViewStartDrag(MView);
                      frmMainForm.DropExecute(True);
                    end
                    else
                    begin
                      bitfarmApp.MViewSelectingByMouseMove := True;

                      MView.SelectedImage := imgidx;

                      if MView.Tag = tagCollectionMView then
                      begin
                        bitfarmApp.MViewImageSelect(MView, Self, MView.SelectedImage, -1, True, False, False, False, False, False, True);
                      end
                      else if MView.Tag = tagThumbnailMView then
                      begin
                        bitfarmApp.MViewImageSelect(MView, Self, MView.SelectedImage);
                      end;

                    end;
                  end;
                end;
              end;
            end;
//            end;
          end;
        except
          bitfarmLog.Write(llNormal, ltException, 'MViewMouseMove - ' + Self.Name, ClassName);
        end;
      end;
    end;
  end
  else if (Sender is TbfaImageEnMView) then
  begin
    try
      if not frmMainForm.Active then
        Exit;

      MView := (Sender as TbfaImageEnMView);

      if MView.Owner <> nil then
      begin
        if ((TbfaPreview(MView.Owner).PreviewKind = pvkMulti) and (MView.Tag = tagCollectionMView)) then
        begin
          idx := MView.ImageAtPos(X, Y);
          if idx >= 0 then
          begin
            if MView.SelectedImage = idx then
            begin
              if (not VarIsNull(FList[idx].DocDate)) and
                 ((FList[idx].DocStream <> nil) and (FList[idx].DocStream.Size >= 0)) then
              begin
                // bfacrm:ticket__show__29347
//                if (not FList[idx].HasPreview) and (FList[idx].OriLoc <> '') then
                if (FList[idx].OriStream <> nil) and (FList[idx].OriLoc <> '') then //01.10.2024 SD <--bfacrm:ticket__show__39480

//24.05.2023                  FileSize := GetStreamSizeStr(FList[idx].OriStream)
                  FileSize := GetStreamSizeStr(TMemoryStream(FList[idx].OriStream))
                else
                  FileSize := GetStreamSizeStr(FList[idx].DocStream);

                MView.Hint := _('Titel') + ': ' + FList[idx].DocName + #10 + #13
                            + _('Gre') + ': ' + FileSize + #10 + #13
                            + _('Datum') + ': ' + FormatDateTime('dd.mm.yyyy', VarToDateTime(FList[idx].DocDate));
              end;
            end;
          end
          else
            MView.Hint := TbfaPreview(MView.Owner).Parent.Hint;
        end
        else
          MView.Hint := TbfaPreview(MView.Owner).Parent.Hint;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'MViewMouseMove - ' + Self.Name, ClassName);
    end;
  end;
end;

function TbfaPreview.CanActivatePanelOnMouseEvent: Boolean;
begin
  Result := //wenn nicht active und nicht Floating
    ((bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag) and (not TSpTBXDockablePanel(Self.Parent).Floating));
end;

procedure TbfaPreview.previewToolWindowClose(Sender: TObject);
begin
  FShowThumbnail := False;
end;

procedure TbfaPreview.MViewEndDrag(Sender, Target: TObject; X, Y: Integer);
var
  MView: TbfaImageEnMView;
begin
  bitfarmLog.DebugBegin(llDebug, 'MViewEndDrag - ' + Self.Name, Classname);
  try
    try
      if (Sender is TbfaImageEnMView) then
      begin
        MView := (Sender as TbfaImageEnMView);
        if MView <> nil then
        begin
          MView.MouseInteract := [];
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'MViewEndDrag - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'MViewEndDrag - ' + Self.Name, Classname);
    Screen.Cursor := crDefault;
  end;
end;

procedure TbfaPreview.MViewDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  UserAction: PUserAction;
  p: TPoint;
begin
  bitfarmLog.DebugBegin(llDebug, 'MViewDragDrop - ' + Self.Name, Classname);
  try
    try
      FThumbnailTimer.Enabled := False;
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.ActionName := 'actMViewDragDrop';
      UserAction^.Objects.Add(Sender);
      UserAction^.Objects.Add(Source);

//      P := Point(X,Y);
//      P := ScreenToClient(P);

      UserAction^.Params.Add(IntToStr(X));
      UserAction^.Params.Add(IntToStr(Y));
      if (Source is TbfaDragObject) then
      begin
        if TbfaDragObject(Source).Move then
          UserAction^.Params.Add(IntToStr(1))
        else
          UserAction^.Params.Add(IntToStr(0));

      end
      else
        UserAction^.Params.Add(IntToStr(0));
      UserAction^.Params.Add(IntToStr(-1)); //imgpos

      UserAction^.Preview := Self;
      bitfarmApp.MainThread.Add(UserAction);
    except
      bitfarmLog.Write(llNormal, ltException, 'MViewDragDrop - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'MViewDragDrop - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.SaveAnnoObjects(AThread: TThread; SetInteracts, SetIntervtBack: Boolean; IgnoreRights: Boolean = False);
var
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'SaveAnnoObjects - ' + Self.Name, Classname);
  try
    try
      if AThread = nil then
      begin
        FThumbnailTimer.Enabled := False;

        UserAction := bitfarmApp.CreateUserAction;
        UserAction^.ActionName := 'actSaveAnnoObjects';
        UserAction^.Objects.Add(FimgSingleView);
        UserAction^.Objects.Add(FActiveDoc);
        UserAction^.Params.Add(BoolToStr(SetInteracts));
        UserAction^.Params.Add(BoolToStr(SetIntervtBack));
        UserAction^.Params.Add(BoolToStr(IgnoreRights));
        UserAction^.Preview := Self;
        bitfarmApp.MainThread.Add(UserAction);
      end
      else
      begin
        bitfarmApp.SaveAnnoObjects(AThread, FimgSingleView, FActiveDoc, Self, SetInteracts, SetIntervtBack, IgnoreRights);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'SaveAnnoObjects - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SaveAnnoObjects - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.SetScanPoolAsThumbnailView(Doc: TbfaDocument);
var
  imgM: TbfaImageEnMView;
  i, idx, k: Integer;
  iebmp: TIEBitmap;
  bmp: Graphics.TBitmap;
  Anno: TbfaAnnotation;
  Fimg: TbfaImageEnVect;
  splshowing: Boolean;
  frm: TForm;
  fstyle: TFormStyle;
begin
  bitfarmLog.DebugBegin(llDebug, 'SetScanPoolAsThumbnailView - ' + Self.Name, Classname);
  try
    try
      if Doc.ThumbnailView = nil then
      begin
        imgM := nil;
        CreateThumbnailView(imgM, Self, previewToolWindow);
        Doc.ThumbnailView := imgM;
      end;

      with Doc.ThumbnailView do
      begin
//        if Parent = nil then
  //21.09.2018        Parent := previewToolWindow;

        // Ticket  25265    Wenn ich daran denke, wie lange ich daran gesucht habe, knnte ich im nachhinein ausrasten
        // wenn als Parent nicht previewThumbsPanel gesetzt wird haben wir nicht den schicke etchy Rahmen, den wir vermisst haben
        Parent := previewThumbsPanel;
        Align := alClient;
        {$IFDEF IMAGEEN1140}
//22.05.2023        FlatScrollBars := True;
        {$ELSE}
        FlatScrollBars := True;
        {$ENDIF}
        ScrollBars := ssVertical;
        Visible := True;
        TabStop := True;
        OnClick := MViewClick;
        OnMouseDown := MViewMouseDown;
        OnMouseMove := MViewMouseMove;
        OnMouseUp := MViewMouseUp;
        OnDblClick := ThumbnailViewDblClick;
        OnImageSelect := MViewImageSelect;
        OnImageDeSelect := MViewImageDeSelect;
        OnKeyDown := PrevKeyDown;

        PopupMenu := frmMainForm.ppmTools;

        if bitfarmApp <> nil then
        begin
          Background := bitfarmApp.BgColor;
          ThumbnailsBackground := bitfarmApp.BgColor;
          ThumbnailsBorderColor := bitfarmApp.BgColor;
          ThumbnailsInternalBorderColor := bitfarmApp.BgColor;
          SelectionColor := bitfarmApp.slColor;
        end;
      end;

      if (Doc.ScanPoolView <> nil) and (Doc.ScanPoolViewLoaded) and
         (Doc.ScanPoolView.ImageCount <> Doc.ThumbnailView.ImageCount) then
      begin
        if Doc.ScanPoolView.ImageCount > 0 then
        begin
//14.11.2018 Ticket 16681 -->
          frm := nil;
          if frmMainForm <> Screen.ActiveForm then
          begin
            frm := Screen.ActiveForm;
            fstyle := frm.FormStyle;
            frm.FormStyle := fsStayOnTop;
          end;
//14.11.2018 Ticket 16681 <--
          splshowing := frmMainForm.frmSplash.Showing;
          frmMainForm.frmSplash.lblLoading.Caption := _('Miniaturansicht wird aktualisiert...');
          frmMainForm.frmSplash.Update;
          frmMainForm.frmSplash.Show;

          Doc.ThumbnailView.Clear;
          Doc.ThumbnailView.LockPaint;
          try
            for i := 0 to Doc.ScanPoolView.ImageCount - 1  do
            begin
              frmMainForm.frmSplash.lblLoading.Caption := _('Miniaturansicht wird aktualisiert...');
              frmMainForm.frmSplash.lblInfo.Caption := '(' + IntToStr(i + 1) + ' / ' + IntToStr(Doc.ScanPoolView.ImageCount) + ')';
              frmMainForm.frmSplash.Update;
              frmMainForm.frmSplash.Show;
              iebmp := TIEBitmap.Create;
              bmp := Graphics.TBitmap.Create;
              try
                Doc.ScanPoolView.CopyToIEBitmap(i, iebmp);

                Anno := Doc.GetAnnotation(i, 0, idx);
                if (Anno <> nil) and (idx > -1) then
                begin
                  Fimg := CreateInvisibleVect(nil);
                  try
                    Fimg.IO.Params.ImageIndex := 0;
                    {$IFDEF ImageEN1140}
                    Fimg.Bitmap.Assign(iebmp.VclBitmap);
                    {$ELSE}
                    Fimg.IO.Bitmap.Assign(iebmp.VclBitmap);
                    {$ENDIF}
                    Fimg.IO.Params.TIFF_Compression :=
                      Doc.ScanPoolView.MIO.Params[i].TIFF_Compression;
                    Fimg.IO.Params.BitsPerSample :=
                      Doc.ScanPoolView.MIO.Params[i].BitsPerSample;
                    Fimg.IO.Params.SamplesPerPixel :=
                      Doc.ScanPoolView.MIO.Params[i].SamplesPerPixel;
                    if DrawOneThumbWithAnnos(Fimg) then
                    begin
                      FreeAndnil(iebmp);
                      iebmp := TIEBitmap.Create;
                      iebmp.Assign(Fimg.Bitmap);
                    end;
                  finally
                    Fimg.RemoveAllObjects;
                    Fimg.Clear;
//29.08.2023 -->
////10.05.2023 -->
////                    try
////                      for k := Fimg.LayersCount - 1 downto 0 do
////                        Fimg.Layers[k].Free;
////                      Fimg.SelectionMask.Free;
////                    except
////                    end;
//                    Fimg.Free;
////10.05.2023 <--
                    {$IFDEF IMAGEEN_SYNCHRONIZED}
                    Fimg.Free;
                    {$ELSE}
                    try
                      for k := Fimg.LayersCount - 1 downto 0 do
                        Fimg.Layers[k].Free;
                      Fimg.SelectionMask.Free;
                    except
                    end;
                    {$ENDIF}
//29.08.2023 <--
                    Fimg := nil;
                  end;
                end;

                try
                  Doc.ThumbnailView.InsertImageEx(i);
                  {$IFDEF ImageEn1140}
                  // SetIEBitmap deprecated - http://imageen.com/help/Compatibility.html
                  Doc.ThumbnailView.SetImage(i, iebmp);
                  {$ELSE}
                  Doc.ThumbnailView.SetIEBitmap(i, iebmp);
                  {$ENDIF}

                  Doc.ThumbnailView.Mio.Params[i].TIFF_Compression :=
                    Doc.ScanPoolView.MIO.Params[i].TIFF_Compression;
                  Doc.ThumbnailView.Mio.Params[i].BitsPerSample :=
                    Doc.ScanPoolView.MIO.Params[i].BitsPerSample;
                  Doc.ThumbnailView.Mio.Params[i].SamplesPerPixel :=
                    Doc.ScanPoolView.MIO.Params[i].SamplesPerPixel;
                except
                  bitfarmLog.Write(llNormal, ltException, 'SetScanPoolAsThumbnailView - ' + Self.Name + ' - Doc.ThumbnailView.InsertImageEx(i)', ClassName);
                end;
              finally
                FreeAndNil(iebmp);
                FreeAndNil(bmp);
              end;
            end;
          finally
            Doc.ThumbnailView.UnLockPaint;
            Doc.ThumbnailView.Update;
            if not splshowing then
              frmMainForm.frmSplash.Hide;
//14.11.2018 Ticket 16681 -->
            if frm <> nil then
            begin
              frm.FormStyle := fstyle;
            end;
//14.11.2018 Ticket 16681 <--
          end;
        end;
      end;

      FimgThumbnailView := Doc.ThumbnailView;

      try
        FimgThumbnailView.BringtoFront; //04.03.2019 Manchmal wird nichts dargestellt, aber da...

        dctPreviewTarget.Register(FimgThumbnailView);
      except
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'SetScanPoolAsThumbnailView - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetScanPoolAsThumbnailView - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.RefreshThumbnailView(AThread: TThread; Doc: TbfaDocument; SelectedImageIdx: Integer = 0);
var
  i: Integer;
  pDoc: TbfaDocument;
  inProc: Boolean;
  Lst: TList<TbfaDocument>;
  MView: TbfaImageEnMView;
begin
  bitfarmLog.DebugBegin(llDebug, 'RefreshThumbnailView - ' + Self.Name, Classname);
  try
    try
      if previewToolWindow.Visible then
      begin
        if GetThumbnailInProcess then
          KillThumbnailThread;

        if Doc.ScanPoolViewLoaded and
        // (
           (bitfarmApp.PreviewContainer.ImporterItem.Preview = Self) (*or
            (bitfarmApp.PreviewContainer.WorkplaceItem.Preview = Self)) and (Doc.ID = -1) *)then
        begin
          if AThread <> nil then
            AThread.Synchronize(nil,
              procedure
              begin
                if (Doc <> nil) and (FimgThumbnailView <> nil) and (Doc.ThumbnailView <> FimgThumbnailView) and (FimgThumbnailView.Visible) then
//26.09.2018                  FimgThumbnailView.Clear;
                  FimgThumbnailView.Visible := False;
                SetScanPoolAsThumbnailView(Doc);
              end)
          else
          begin
            if (Doc <> nil) and (FimgThumbnailView <> nil) and (Doc.ThumbnailView <> FimgThumbnailView) and (FimgThumbnailView.Visible) then
//26.09.2018              FimgThumbnailView.Clear;
              FimgThumbnailView.Visible := False;
            SetScanPoolAsThumbnailView(Doc);
          end;
        end
        else
        begin
          if ((not Doc.GetInProcesses) or (Doc.InShowProcess) or (Doc.InRefreshProcess)) then
          begin
            FThumbnailThread := TThreadedThumbnails.Create(True);
  //07.06.2018 Ticket 14576            FThumbnailThread.SetObjectsWithList(FimgThumbnailView, FtxPos, Self, Doc, SelectedImageIdx);
            if (bitfarmApp.PreviewContainer.ImporterItem.Preview = Self) (*or
                (bitfarmApp.PreviewContainer.WorkplaceItem.Preview = Self)) and (Doc.ID = -1)*) then
            begin
              if AThread <> nil then
                AThread.Synchronize(nil,
                  procedure
                  begin
                    if (Doc.ThumbnailView = nil) then
                    begin
                        CreateThumbnailView(MView, bitfarmApp.PreviewContainer.ImporterItem.Preview,
                          bitfarmApp.PreviewContainer.ImporterItem.Preview.previewToolWindow);
                        Doc.ThumbnailView := MVieW;
                    end;

                    if (Doc <> nil) and (FimgThumbnailView <> nil) and (Doc.ThumbnailView <> FimgThumbnailView) and (FimgThumbnailView.Visible) then
                      FimgThumbnailView.Visible := False;
                    SetScanPoolAsThumbnailView(Doc);
                  end)
              else
              begin
                if (Doc.ThumbnailView = nil) then
                begin
                  CreateThumbnailView(MView, bitfarmApp.PreviewContainer.ImporterItem.Preview,
                    bitfarmApp.PreviewContainer.ImporterItem.Preview.previewToolWindow);
                  Doc.ThumbnailView := MVieW;
                end;

                if (Doc <> nil) and (FimgThumbnailView <> nil) and (Doc.ThumbnailView <> FimgThumbnailView) and (FimgThumbnailView.Visible) then
                  FimgThumbnailView.Visible := False;
                SetScanPoolAsThumbnailView(Doc);
              end;
              FThumbnailThread.SetObjectsWithList(TbfaImageEnMView(Doc.ThumbnailView), FtxPos, Self, Doc, SelectedImageIdx);
            end
            else
              FThumbnailThread.SetObjectsWithList(TbfaImageEnMView(FimgThumbnailView), FtxPos, Self, Doc, SelectedImageIdx);

            FThumbnailThread.Resume;
          end;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'RefreshThumbnailView - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'RefreshThumbnailView - ' + Self.Name, Classname);
  end;
end;

function TbfaPreview.GetThumbnailInProcess: Boolean;
begin
  bitfarmLog.DebugBegin(llDebug, 'GetThumbnailInProcess - ' + Self.Name, Classname);
  try
    try
      if ((FThumbnailThread <> nil) and (not FThumbnailThread.Finished)) then
        Result := (FThumbnailThread.InProcess)
      else
        Result := False;
    except
      Result := False;
      bitfarmLog.Write(llNormal, ltException, 'GetThumbnailInProcess - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'GetThumbnailInProcess - ' + Self.Name + ' - Result: ' + BoolToStr(Result, True), Classname);
  end;
end;

procedure TbfaPreview.KillThumbnailThread(ClearImages: Boolean = True);
begin
  bitfarmLog.DebugBegin(llDebug, 'KillThumbnailThread - ' + Self.Name, Classname);
  try
    try
      if FThumbnailThread <> nil then
      begin
        if (not FThumbnailThread.Finished) and (not FThumbnailThread.Terminated) then
        begin
          bitfarmLog.Write(llDebug, ltInfo, 'KillThumbnailThread - FThumbnailThread.KillThread; - ' + Self.Name, ClassName);
          FThumbnailThread.KillThread;

          bitfarmLog.Write(llDebug, ltInfo, 'KillThumbnailThread - ClearImages: ' + BoolToStr(ClearImages, True) + ' - ' + Self.Name, ClassName);
//23.01.2019          if ClearImages then
//          begin
//            TThread.Synchronize(nil,
//              procedure
//              begin
//                try
// //24.09.2018                  if FimgThumbnailView <> nil then
// //                    FimgThumbnailView.Clear;
//                except
//                  bitfarmLog.Write(llNormal, ltException, 'KillThumbnailThread Exception - ' + Self.Name, Classname);
//                end;
//              end);
//          end;
        end;
//
//        TThread.Synchronize(nil,
//          procedure
//          begin
//            try
//              if FimgThumbnailView <> FThumbnailMView then
//              begin
//                FimgThumbnailView.Visible := False;
//                FimgThumbnailView := FThumbnailMView;
//              end;
//              except
//              bitfarmLog.Write(llNormal, ltException, 'KillThumbnailThread Exception - ' + Self.Name, Classname);
//            end;
//          end);


      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'KillThumbnailThread - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'KillThumbnailThread - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreView.MViewStartDrag(Sender: TObject);
var
  p: TPoint;
  myBmp: Graphics.TBitmap;
  i, W, H: integer;
  MView: TbfaImageEnMView;
  img: TbfaImageEnVect;
  MVOwner: TComponent;
begin
  bitfarmLog.DebugBegin(llDebug, 'MViewStartDrag - ' + Self.Name, Classname);
  try
    try
      MView := TbfaImageEnMView(Sender);
      p := MView.ScreenToClient(Mouse.CursorPos);
      if Assigned(bitfarmApp.DragObject) then
        bitfarmApp.DragObject.Destroy;
      bitfarmApp.DragObject := TbfaDragObject.Create; //(MView);
      for i := 0 to MView.MultiSelectedImagesCount - 1 do
        bitfarmApp.DragObject.SelectedList.Add(IntToStr(MView.MultiSelectedImages[i]));

      bitfarmApp.DragObject.DragSource := MView;

//19.06.2018 Ticket 14576 Die neu erstellte Thumbnailview hat kein OWner -->
      MVOwner := MView.Owner;
      if MVOwner = nil then
        MVOwner := MView.Parent.Owner;
//19.06.2018 Ticket 14576 <--

      if ((MView.Tag = tagThumbnailMView) or (MView.Tag = tagCollectionMView)) then
      begin
        bitfarmApp.DragObject.DragKind := dkPages;
        if (TbfaPreview(MVOwner).PreviewKind = pvkSingle) then
        begin
          bitfarmApp.DragObject.DocumentList.Add(TbfaPreview(MVOwner).List[0]);
          for i := 0 to MView.MultiSelectedImagesCount - 1 do
            bitfarmApp.DragObject.PageList.Add(IntToStr(MView.MultiSelectedImages[i]));
        end
        else if (TbfaPreview(MVOwner).PreviewKind = pvkMulti) then
        begin
          if (MView.Tag = tagThumbnailMView) then
          begin
            if TbfaPreview(MVOwner).MultiView.MultiSelectedImagesCount = 1 then
            begin
              bitfarmApp.DragObject.DragKind := dkPages;
              bitfarmApp.DragObject.DocumentList.Add(TbfaPreview(MVOwner).
                List[TbfaPreview(MVOwner).MultiView.MultiSelectedImages[0]]);

              for i := 0 to MView.MultiSelectedImagesCount - 1 do
              begin
                bitfarmApp.DragObject.PageList.Add(IntToStr(MView.MultiSelectedImages[i]));
              end;
            end
            else
              bitfarmApp.DragObject.DragKind := dkNone;
          end
          else if (MView.Tag = tagCollectionMView) then
          begin
            bitfarmApp.DragObject.DragKind := dkDocuments;

            for i := 0 to MView.MultiSelectedImagesCount - 1 do
            begin
              bitfarmApp.DragObject.DocumentList.Add(TbfaPreview(MVOwner).
                List[MView.MultiSelectedImages[i]]);
            end;
          end;
        end
        else if TbfaPreview(MVOwner).PreviewKind = pvkMultiSingle then
        begin
          if ((TbfaPreview(MVOwner).MultiView.MultiSelectedImagesCount > 1) or
            ((MView.Tag = tagCollectionMView) and (not TbfaPreview(MVOwner).
            List[TbfaPreview(MVOwner).MultiView.MultiSelectedImages[0]].HasPreview)) or
            ((MView.Tag = tagThumbnailMView) and (not TbfaPreview(MVOwner).
            List[TbfaPreview(MVOwner).MultiView.SelectedImage].HasPreview) and
            (TbfaPreview(MVOwner).MultiView.MultiSelectedImagesCount = 1))) then
            bitfarmApp.DragObject.DragKind := dkNone
          else
          begin
            bitfarmApp.DragObject.DragKind := dkPages;
            bitfarmApp.DragObject.DocumentList.Add(TbfaPreview(MVOwner).
              List[TbfaPreview(MVOwner).MultiView.MultiSelectedImages[0]]);
            for i := 0 to MView.MultiSelectedImagesCount - 1 do
              bitfarmApp.DragObject.PageList.Add(IntToStr(MView.MultiSelectedImages[i]));

          end;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'MViewStartDrag - ' + Self.Name, Classname);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'MViewStartDrag - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.PrevKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  idx, i: Integer;
begin
  //bitfarmLog.DebugBegin(llDebug, 'MViewKeyDown - ' + Self.Name, Classname);
  try
    try
      if Key = VK_F2 then
      begin
        bitfarmLog.Write(llDebug, ltInfo, 'TbfaPreview.PrevKeyDown - VK_F2', ClassName);
        try
          bitfarmLog.Write(llDebug, ltInfo, 'TbfaPreview.PrevKeyDown - VK_F2 - Screen.ActiveControl.Name.ActiveControl: ' +
            Screen.ActiveControl.Name, ClassName);
        except
          //
        end;
      end;
      if (Sender is TbfaImageEnMView) then
      begin
        //17.05.2019 Ticket 19262 -->
        if TbfaImageEnMView(Sender).Tag = tagThumbnailMView then
        begin
          if (Key = VK_NEXT) then
            Key := VK_DOWN
          else if (Key = VK_PRIOR) then
            Key := VK_UP;
        end;
        //17.05.2019 Ticket 19262 <--
        if ((FbfaPreviewKind = pvkMultiSingle) and (TbfaImageEnMView(Sender).Tag = tagThumbnailMView) and (Key = VK_BACK)) then
          frmMainForm.actPreviewBack.Execute
        else if ((FbfaPreviewKind = pvkMulti) and (TbfaImageEnMView(Sender).Tag = tagThumbnailMView) and (Key = VK_TAB)) then
          FimgMultiView.SetFocus
        else if ((FbfaPreviewKind = pvkMulti) and (TbfaImageEnMView(Sender).Tag = tagThumbnailMView) and (Key = VK_RETURN)) then
          bitfarmApp.MViewImageSelect(Sender, Self, TbfaImageEnMView(Sender).SelectedImage, -1, True, False, False, False, True, True)
        else if ((FbfaPreviewKind = pvkMulti) and (TbfaImageEnMView(Sender).Tag = tagCollectionMView) and (Key = VK_RETURN)) then
          bitfarmApp.MViewImageSelect(Sender, Self, TbfaImageEnMView(Sender).SelectedImage, -1, True, bitfarmApp.GetInNewTab(Self), (GetKeyState(VK_MENU) < 0), False, True, True)
        else if (Shift = [ssCtrl]) and (Key = ord('A')) then
        begin
          TbfaImageEnMView(Sender).SelectAll;
          MViewImageSelect(Sender, TbfaImageEnMView(Sender).SelectedImage);
        end
        else if (Shift = [ssShift]) and (Key = VK_END) then
        begin
          idx := TbfaImageEnMView(Sender).SelectedImage;
          if idx > -1 then
          begin
            TbfaImageEnMView(Sender).Deselect;
            TbfaImageEnMView(Sender).MultiSelecting := True;
            for i := idx to TbfaImageEnMView(Sender).ImageCount - 1 do
              TbfaImageEnMView(Sender).SelectedImage := i;
            TbfaImageEnMView(Sender).MultiSelecting := False;

            MViewImageSelect(Sender, idx);
          end;
        end
        else if (Shift = [ssShift]) and (Key = VK_HOME) then
        begin
          idx := TbfaImageEnMView(Sender).SelectedImage;
          if idx > -1 then
          begin

          end;
          TbfaImageEnMView(Sender).Deselect;
          TbfaImageEnMView(Sender).MultiSelecting := True;
          for i := idx downto 0 do
            TbfaImageEnMView(Sender).SelectedImage := i;
          TbfaImageEnMView(Sender).MultiSelecting := False;

          MViewImageSelect(Sender, idx);
        end
        else if Key = VK_DELETE then
        begin
          if ((TbfaPreview(TbfaImageEnMView(Sender).Owner).PreviewKind = pvkMulti) and (TbfaImageEnMView(Sender).Tag = tagCollectionMView)) then
            TbfaPreview(TbfaImageEnMView(Sender).Owner).actDeleteSelected.Execute
          else if (TbfaImageEnMView(Sender).Tag = tagThumbnailMView) then
            TbfaPreview(TbfaImageEnMView(Sender).Owner).actDeletePages.Execute;
        end
        else if Key = VK_ESCAPE then
          MViewImageDeSelect(Sender, -1);
      end
      else if ((Shift = [ssCtrl]) and (Key = ord('S'))) then
      begin
        if Floating then
          frmMainForm.actSave.Execute;
      end
      else if ((Sender is TbfaImageEnVect)) then
      begin
        if ((FbfaPreviewKind = pvkMultiSingle) and (Key = VK_BACK)) then
          frmMainForm.actPreviewBack.Execute
        else if Key = VK_ESCAPE then
        begin
          if (FActiveDoc <> nil) and (FActiveDoc.ID <> -1) and (FActiveDoc.InEditMode) then
          begin
            frmMainForm.actCancel.Execute;
          end;
        end
        {$IFDEF ImageEn1140}
        else if Key = VK_HOME then
          frmMainForm.actFirstPage.Execute
        else if Key = VK_END then
          frmMainForm.actLastPage.Execute
        else if (Key = VK_PRIOR) or ((Shift=[]) and (Key = VK_UP)) then
        begin
          if Self.FimgSingleView.img_DocView.ViewY > 0 then
            Self.FimgSingleView.img_DocView.DoVertScroll(iescPageUp, 0)
          else
            Self.ChangePage('actPreviousPage', 1, True, False, False);
//          frmMainForm.actPreviousPage.Execute // AutoZoom eher irritierend
        end else if (Key = VK_NEXT) or ((Shift=[]) and (Key = VK_DOWN)) then
        begin
          var mx, my: Integer;
          Self.FimgSingleView.img_DocView.GetMaxViewXY(mx, my);
          if Self.FimgSingleView.img_DocView.ViewY < my then
            Self.FimgSingleView.img_DocView.DoVertScroll(iescPageDown, 0)
          else
            Self.ChangePage('actNextPage', 1, True, True, False);
//            frmMainForm.actNextPage.Execute; // AutoZoom eher irritierend
        end
        {$ELSE}
        else if Key = VK_HOME then
          frmMainForm.actFirstPage.Execute
        else if Key = VK_END then
          frmMainForm.actLastPage.Execute
        else if (Key = VK_PRIOR) or ((Shift=[]) and (Key = VK_UP)) then
          frmMainForm.actPreviousPage.Execute
        else if (Key = VK_NEXT) or ((Shift=[]) and (Key = VK_DOWN)) then
          frmMainForm.actNextPage.Execute
        {$ENDIF}
      end

      else if Key = VK_F12 then
      begin
        if Key = VK_ESCAPE then
          MViewImageDeSelect(Sender, -1)
// SJ 26.04.2022 - bfacrm:ticket__show__30789
//        else if Key = VK_F2 then
//        begin
//          if FActiveDoc <> nil then
//          begin
//            if (FActiveDoc.ID <> -1) then
//            begin
//              if Floating then
//              begin
//                if (not FActiveDoc.InEditMode) then
//                  frmMainForm.actInProgress.Execute
//                else
//                  frmMainForm.actSave.Execute;
//              end;
//            end
//            else if ((TbfaPreview(TbfaImageEnMView(Sender).Owner).PreviewKind = pvkMulti) and (TbfaImageEnMView(Sender).Tag = tagCollectionMView)) then
//              frmMainForm.actChangeDocName.Execute
//          end;
//        end;
// SJ 26.04.2022 - bfacrm:ticket__show__30789
      end;

      if Key = VK_F12 then
      begin
        if (TbfaPreview(Self).Parent is TSpTBXDockablePanel) then
          bitfarmApp.MaximizePanel(TSpTBXDockablePanel(TbfaPreview(Self).Parent))
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'MViewKeyDown - ' + Self.Name, Classname);
    end;
  finally
    //bitfarmLog.DebugEnd(llDebug, 'MViewKeyDown - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.EditKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
// TODO SJ: SJ 17.01.2020: prfen ob editmode und auch bei F2 behandeln
//                   das wrde den Umweg ber ChangeDocName F2 sparen - bei
//                   SaveNewDocName muss jedoch noch die Infoleiste neu gesetzt
//                   werden!
  bitfarmLog.DebugBegin(llDebug, 'EditKeyDown - ' + Self.Name, Classname);
  try
    try
      if Key = VK_RETURN then  // TODO SJ: SJ 17.01.2020
        SaveNewDocName(True)
      else if Key = VK_ESCAPE then
        SaveNewDocName(False);
    except
      bitfarmLog.Write(llNormal, ltException, 'EditKeyDown - ' + Self.Name, Classname);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'EditKeyDown - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.EditKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key = #13) or (Key = #27) then // #13 = Return
  begin
    Key := #0; // gegen PLING-Ton
  end;
end;

procedure TbfaPreview.FrameExit(Sender: TObject);
begin
  if Edit.Visible then
    SaveNewDocName(True)
end;

procedure TbfaPreview.MViewResize(Sender: TObject);
begin
  if (not frmMainForm.fAppStarted) or (Self.PreviewKind <> pvkMulti) then
    Exit;

  bitfarmLog.Write(llNormal, ltDebug, 'MViewResize - ' + Self.Name, Classname);
  FDoViewResize := True;
  try
    if Assigned(FEdit) and (FEdit.Visible) then
      SetEdit;
  except
    bitfarmLog.Write(llNormal, ltException, 'MViewResize - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.MViewViewChange(Sender: TObject; Change: Integer);
begin
  bitfarmLog.DebugBegin(llDebug, 'MViewViewChange - ' + Self.Name, ClassName);
  try
    try
      if FEdit.Visible then
        SetEdit;
    except
      bitfarmLog.Write(llNormal, ltException, 'MViewViewChange - ' + Self.Name, Classname);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'MViewViewChange - ' + Self.Name, ClassName);
  end;
end;

procedure TbfaPreview.ResizeThumbnail(Sender: TbfaImageEnMView; Step: Integer);

  procedure ReSizeThumb;
  begin
    try
      Sender.ThumbWidth := Sender.ThumbWidth + Step;
      Sender.ThumbHeight := Sender.ThumbHeight + Step;

      Sender.ViewX := Sender.ImageX[Sender.SelectedImage];
      Sender.ViewY := Sender.ImageY[Sender.SelectedImage];

      FActThumbnailWidth := Sender.ThumbWidth;
      FActThumbnailHeight := Sender.ThumbHeight;

//23.08.2017 -->
      bitfarmApp.MViewThumbWidth := FActThumbnailWidth;
      bitfarmApp.MViewThumbHeight := FActThumbnailHeight;

      bitfarmApp.PreviewContainer.WorkplaceItem.Preview.MultiView.ThumbWidth :=
        bitfarmApp.MViewThumbWidth;
      bitfarmApp.PreviewContainer.WorkplaceItem.Preview.MultiView.ThumbHeight :=
        bitfarmApp.MViewThumbHeight;
      bitfarmApp.PreviewContainer.WorkplaceItem.Preview.FActThumbnailWidth :=
        bitfarmApp.MViewThumbWidth;
      bitfarmApp.PreviewContainer.WorkplaceItem.Preview.FActThumbnailHeight :=
        bitfarmApp.MViewThumbHeight;
      bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView.ThumbWidth :=
        bitfarmApp.MViewThumbWidth;
      bitfarmApp.PreviewContainer.ImporterItem.Preview.MultiView.ThumbHeight :=
        bitfarmApp.MViewThumbHeight;
      bitfarmApp.PreviewContainer.ImporterItem.Preview.FActThumbnailWidth :=
        bitfarmApp.MViewThumbWidth;
      bitfarmApp.PreviewContainer.ImporterItem.Preview.FActThumbnailHeight :=
        bitfarmApp.MViewThumbHeight;
//23.08.2017 <--

    except

    end;
  end;

begin
  try
    if ((Step < 0) and (Sender.ThumbWidth - 10 >= MINTHUMBWIDTH)) then
      ReSizeThumb
    else if ((Step > 0) and (Sender.ThumbWidth + 10 <= MAXTHUMBWIDTH)) then
      ReSizeThumb;

    MViewResize(Self);
  except
    bitfarmLog.Write(llNormal, ltException, 'ResizeThumbnail - ' + Self.Name, ClassName);
  end;
end;

procedure TbfaPreview.Retranslate;
begin
  try
    ReTranslateComponent(Self, sSysGnuViewerDomain);
    Self.HistoryView.Retranslate;
    CloneActions(False, True); // Actions werden nicht erzeugt, nur ReTranslated
    SetCaptionsTranslated;
  except
    bitfarmLog.Write(llNormal, ltException, 'Retranslate - ' + Self.Name, ClassName);
  end;
end;

procedure TbfaPreview.tbiClipboardAsStampClick(Sender: TObject);
var
  tmpFont: TFont;
  Str: TMemoryStream;
  Bmp: Graphics.TBitmap;
  mesTmp: TIEUnits;
begin
  bitfarmLog.DebugBegin(llDebug, 'tbiClipboardAsStampClick - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

//      if not (Sender is TSPTBXItem) then
//        Exit; // nur zur Sicherheit

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

//      UnCheckAllGraphicTools;
      if CheckAnnoRights then
      begin
        if Assigned(fLastAnnoTool) then  // wenn wir schon ein Werkzeug gespeichert haben, machen wir das leer,
          fLastAnnoTool := nil;         //damit beim nchsten Wechsel das neue gespeichert wird

        with Clipboard do
        begin
          try
            Open;
            // SJ: brauchen wir wegen %CLIPBOARD% nicht mehr
//            if HasFormat(CF_TEXT) then
//            begin
//              with FimgSingleView.img_DocView do
//              begin
//                ObjName[-1] := 'ClipboardAsStamp';
//                ObjKind[-1] := iekMEMO;
//                ObjPenColor[-1] := 0;
//                ObjFontName[-1] := 'Arial';
//                ObjFontStyles[-1] := [];
//                ObjFontHeight[-1] := 72;
//                ObjBrushColor[-1] := clWhite;
//                ObjBrushStyle[-1] := bsClear;
//                ObjMemoBorderStyle[-1] := psClear;
//                ObjMemoBorderColor[-1] := clBlack;
//                ObjTransparency[-1] := 255;
//                ObjMemoCharsBrushStyle[-1] := bsClear;
//                ObjFontLocked[-1] := False;	// die Schrift sollte vernderbar sein, bei einem Textstempel
//                MouseInteractVT := [miPutmemo];
//                ObjHeight[-1] := 250;
//                ObjWidth[-1] := 800;
//              end;
//
//              FimgSingleView.fObjVersion := 36;
//
//              FimgSingleView.createannodata(-1);
//
//              tmpFont:=TFont.Create;
//              tmpFont.Color := clBlack;
//              tmpFont.Size := 72;
//              tmpFont.Name := 'Arial';
//              FimgSingleView.img_DocView.SetObjFont(-1,tmpFont);
//              tmpFont.Free;
//
//              FimgSingleView.img_DocView.ObjText[-1] := AsText;
//              FimgSingleView.img_DocView.ObjStyle[-1] := [ievsSelectable,
//                ievsMoveable, ievsVisible, ievsSizeable];
//
//            end
//            else if HasFormat(CF_BITMAP) then

            // SJ: Grafikstempel setzen wir hier noch.
            //     Luft jetzt aber ber img_DocViewMouseDown
            if HasFormat(CF_BITMAP) then
            begin
              Bmp := Graphics.TBitmap.Create;
              Str := TMemoryStream.Create;
              try
                Bmp.Assign(Clipboard);
                Bmp.SaveToStream(Str);
                Str.Position := 0;

                FimgSingleView.img_DocView.ObjKind[-1] := iekBITMAP;
                FimgSingleView.img_DocView.EnableAlphaChannel := True;

                FimgSingleView.img_DocView.SetObjBitmapFromStream(-1, Str);
                FimgSingleView.img_DocView.ObjWidth[-1] :=
                  Round(Bmp.Width / FimgSingleView.img_DocView.MeasureCoefX / (FimgSingleView.img_DocView.Zoom / 100));
                FimgSingleView.img_DocView.ObjHeight[-1] :=
                  Round(Bmp.Height / FimgSingleView.img_DocView.MeasureCoefY / (FimgSingleView.img_DocView.Zoom / 100));

                FimgSingleView.img_DocView.ObjBitmapBorder[-1] := False;

                FimgSingleView.img_DocView.ObjStyle[-1] := [ievsSelectable,
                  ievsMoveable, ievsVisible, ievsSizeable];

                FimgSingleView.img_DocView.MouseInteractVt := [miPutBitmap];

              finally
                if Assigned(Bmp) then
                  FreeAndNil(Bmp);
                if Assigned(Str) then
                  FreeAndNil(Str);
              end;
            end else
            begin
              // Stream leeren
              Str := TMemoryStream.Create;
              Str.Position := 0;
              FimgSingleView.img_DocView.SetObjBitmapFromStream(-1, Str);
              BfShowMessage(_('Kein Bild in der Zwischenablage'));
              if Assigned(Str) then
                FreeAndNil(Str);
              Abort;
            end;
          finally
            Close;
          end;
        end;

        FimgSingleView.fphistorymessage := _('Stempel aus Zwischenablage');
//        tbiClipboardAsStamp.Checked := True;
        tbi_normalmouse.Checked := False;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := FimgSingleView.img_DocView.ObjWidth[-1];
        bitfarmApp.LastAnnoDefaultHeight := FimgSingleView.img_DocView.ObjHeight[-1];
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'tbiClipboardAsStampClick - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbiClipboardAsStampClick - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_angleClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_angleClick - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      UnCheckAllGraphicTools;

      {$IFDEF ENTERPRISE}
      SingleView.VirtualPluginMenuItem := nil;
      {$ENDIF}

      if CheckAnnoRights then
      begin
        if Assigned(fLastAnnoTool) then  // wenn wir schon ein Werkzeug gespeichert haben, machen wir das leer,
          fLastAnnoTool := nil;         //damit beim nchsten Wechsel das neue gespeichert wird

        FimgSingleView.ReadObjVals(8, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutAngle];
        FimgSingleView.fphistorymessage := _('Angle');
        tbi_angle.Checked := True;
        tbi_normalmouse.Checked := False;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := -1;
        bitfarmApp.LastAnnoDefaultHeight := -1;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_angleClick - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_angleClick - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_annodeleteClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_annodeleteClick - ' + Self.Name, Classname);
  try
    try
      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      //12.09.2024 SD -->bfacrm:ticket__show__39935
      if not btnPreview.Checked then
        btnPreviewClick(nil);
      //12.09.2024 SD <--bfacrm:ticket__show__39935

      FimgSingleView.AnnoDelete(Self);
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_annodeleteClick - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_annodeleteClick - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_annoselectClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_annoselectClick - ' + Self.Name, Classname);
  try
    try

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      if not btnPreview.Checked then
      //12.09.2024 SD -->bfacrm:ticket__show__39935
//        Exit;
        btnPreviewClick(nil);
      //12.09.2024 SD <--bfacrm:ticket__show__39935

      bitfarmLog.Write(llNormal, ltInfo, 'tbi_objauswahlClick - ' + Self.Name, Classname);
      if not (Sender is TSPTBXItem) then
        if not tbi_normalmouse.Checked then   // wenn nicht unmittelbar vorher Verschieben gewhlt war
          ToggleLastAnnoTool;

      UnCheckAllGraphicTools;
      if CheckAnnoRights then
      begin
        FimgSingleView.img_DocView.MouseInteractVt := [miObjectSelect];
        tbi_normalmouse.Checked := False;
        tbi_annoselect.Checked := True;
        FimgSingleView.img_DocView.Cursor := 1780;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSPTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := -1;
        bitfarmApp.LastAnnoDefaultHeight := -1;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_annoselectClick - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_annoselectClick - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_arrowClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_arrowClick - ' + Self.Name, Classname);
  try
    try

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      if not btnPreview.Checked then
      //12.09.2024 SD -->bfacrm:ticket__show__39935
//        Exit;
        btnPreviewClick(nil);
      //12.09.2024 SD <--bfacrm:ticket__show__39935

      UnCheckAllGraphicTools;

      {$IFDEF ENTERPRISE}
      SingleView.VirtualPluginMenuItem := nil;
      {$ENDIF}

      if CheckAnnoRights then
      begin
        if Assigned(fLastAnnoTool) then  // wenn wir schon ein Werkzeug gespeichert haben, machen wir das leer,
          fLastAnnoTool := nil;         //damit beim nchsten Wechsel das neue gespeichert wird

        FimgSingleView.ReadObjVals(14, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutLine];
        FimgSingleView.fphistorymessage := _('Pfeil');
        tbi_arrow.Checked := True;
        tbi_normalmouse.Checked := False;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := FimgSingleView.img_DocView.ObjWidth[-1];
        bitfarmApp.LastAnnoDefaultHeight := FimgSingleView.img_DocView.ObjHeight[-1];
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_arrowClick - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_arrowClick - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_boxClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_boxClick - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      UnCheckAllGraphicTools;

      {$IFDEF ENTERPRISE}
      SingleView.VirtualPluginMenuItem := nil;
      {$ENDIF}

      if CheckAnnoRights then
      begin
        if Assigned(fLastAnnoTool) then  // wenn wir schon ein Werkzeug gespeichert haben, machen wir das leer,
          fLastAnnoTool := nil;         //damit beim nchsten Wechsel das neue gespeichert wird

        FimgSingleView.ReadObjVals(1, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutBox];

        FimgSingleView.fphistorymessage := _('Box');
        tbi_box.Checked := True;
        tbi_normalmouse.Checked := False;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := -1;
        bitfarmApp.LastAnnoDefaultHeight := -1;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_boxClick - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_boxClick - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_ellipseClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_ellipseClick - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      UnCheckAllGraphicTools;

      {$IFDEF ENTERPRISE}
      SingleView.VirtualPluginMenuItem := nil;
      {$ENDIF}

      if CheckAnnoRights then
      begin
        if Assigned(fLastAnnoTool) then  // wenn wir schon ein Werkzeug gespeichert haben, machen wir das leer,
          fLastAnnoTool := nil;         //damit beim nchsten Wechsel das neue gespeichert wird

        FimgSingleView.ReadObjVals(2, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutEllipse];

        FimgSingleView.fphistorymessage := _('Ellipse');
        tbi_ellipse.Checked := True;
        tbi_normalmouse.Checked := False;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := -1;
        bitfarmApp.LastAnnoDefaultHeight := -1;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_ellipseClick - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_ellipseClick - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_graphicoptionsClick(Sender: TObject);
begin
  actGraphicOptions.Execute;
end;

procedure TbfaPreview.tbi_highlite1Click(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_highlite1Click - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      UnCheckAllGraphicTools;
      if CheckAnnoRights then
      begin
        FimgSingleView.ReadObjVals(11, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutBox];
        FimgSingleView.fphistorymessage := _('Marker');

        tbsub_highlight.Checked := True;

        tbsub_highlight.ImageIndex := Integer(icoidx_marker_yellow);
        tbi_normalmouse.Checked := False;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := FimgSingleView.img_DocView.ObjWidth[-1];
        bitfarmApp.LastAnnoDefaultHeight := FimgSingleView.img_DocView.ObjHeight[-1];
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_highlite1Click - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_highlite1Click - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_highlite2Click(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_highlite2Click - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      UnCheckAllGraphicTools;
      if CheckAnnoRights then
      begin
        tbsub_highlight.ImageIndex := Integer(icoidx_marker_green);
        FimgSingleView.ReadObjVals(29, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutBox];
        FimgSingleView.fphistorymessage := _('Marker');
        tbsub_highlight.Checked := True;
        tbi_normalmouse.Checked := False;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := FimgSingleView.img_DocView.ObjWidth[-1];
        bitfarmApp.LastAnnoDefaultHeight := FimgSingleView.img_DocView.ObjHeight[-1];
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_highlite2Click - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_highlite2Click - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_highlite3Click(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_highlite3Click - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      UnCheckAllGraphicTools;

      if CheckAnnoRights then
      begin
        tbsub_highlight.ImageIndex := Integer(icoidx_marker_red);
        FimgSingleView.ReadObjVals(30, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutBox];
        FimgSingleView.fphistorymessage := _('Marker');
        tbsub_highlight.Checked := True;
        tbi_normalmouse.Checked := False;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := FimgSingleView.img_DocView.ObjWidth[-1];
        bitfarmApp.LastAnnoDefaultHeight := FimgSingleView.img_DocView.ObjHeight[-1];
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_highlite3Click - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_highlite3Click - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_highlite4Click(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_highlite4Click - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      UnCheckAllGraphicTools;
      if CheckAnnoRights then
      begin
        tbsub_highlight.ImageIndex := Integer(icoidx_marker_blue);
        FimgSingleView.ReadObjVals(31, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutBox];
        FimgSingleView.fphistorymessage := _('Marker');
        tbsub_highlight.Checked := True;
        tbi_normalmouse.Checked := False;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := FimgSingleView.img_DocView.ObjWidth[-1];
        bitfarmApp.LastAnnoDefaultHeight := FimgSingleView.img_DocView.ObjHeight[-1];
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_highlite4Click - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_highlite4Click - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_highlite5Click(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_highlite5Click - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      UnCheckAllGraphicTools;
      if CheckAnnoRights then
      begin
        tbsub_highlight.ImageIndex := Integer(icoidx_marker_orange);
        FimgSingleView.ReadObjVals(32, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutBox];
        FimgSingleView.fphistorymessage := _('Marker');
        tbsub_highlight.Checked := True;
        tbi_normalmouse.Checked := False;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := FimgSingleView.img_DocView.ObjWidth[-1];
        bitfarmApp.LastAnnoDefaultHeight := FimgSingleView.img_DocView.ObjHeight[-1];
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_highlite5Click - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_highlite5Click - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_imageClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_imageClick - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      UnCheckAllGraphicTools;

      {$IFDEF ENTERPRISE}
      SingleView.VirtualPluginMenuItem := nil;
      {$ENDIF}

      if CheckAnnoRights then
      begin
        if Assigned(fLastAnnoTool) then  // wenn wir schon ein Werkzeug gespeichert haben, machen wir das leer,
          fLastAnnoTool := nil;         //damit beim nchsten Wechsel das neue gespeichert wird

        if dlgOpenFile.Execute then
        begin
          FimgSingleView.img_DocView.SetObjBitmapFromFile(-1, dlgOpenFile.FileName);

          FimgSingleView.ReadObjVals(4, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
          FimgSingleView.img_DocView.MouseInteractVt := [miPutBitmap];

          FimgSingleView.fphistorymessage := _('Bitmap');
          tbi_image.Checked := True;
          tbi_normalmouse.Checked := False;

          if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
             (Sender is TSpTBXItem) and Assigned(bitfarmApp)
          then
            bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := FimgSingleView.img_DocView.ObjWidth[-1];// SJ 30.08.2023
        bitfarmApp.LastAnnoDefaultHeight := FimgSingleView.img_DocView.ObjHeight[-1];// SJ 30.08.2023
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_imageClick - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_imageClick - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_labelClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_labelClick - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      UnCheckAllGraphicTools;

      {$IFDEF ENTERPRISE}
      SingleView.VirtualPluginMenuItem := nil;
      {$ENDIF}

      if CheckAnnoRights then
      begin
        if Assigned(fLastAnnoTool) then  // wenn wir schon ein Werkzeug gespeichert haben, machen wir das leer,
          fLastAnnoTool := nil;         //damit beim nchsten Wechsel das neue gespeichert wird

        FimgSingleView.ReadObjVals(10, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutLineLabel];

        FimgSingleView.fphistorymessage := _('LineLabel');
        tbi_label.Checked := True;
        tbi_normalmouse.Checked := False;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := -1;
        bitfarmApp.LastAnnoDefaultHeight := -1;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_labelClick - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_labelClick - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_lengthClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_lengthClick - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      UnCheckAllGraphicTools;

      {$IFDEF ENTERPRISE}
      SingleView.VirtualPluginMenuItem := nil;
      {$ENDIF}

      if CheckAnnoRights then
      begin
        if Assigned(fLastAnnoTool) then  // wenn wir schon ein Werkzeug gespeichert haben, machen wir das leer,
          fLastAnnoTool := nil;         //damit beim nchsten Wechsel das neue gespeichert wird

        FimgSingleView.ReadObjVals(7, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miDragLen];

        FimgSingleView.fphistorymessage := _('Zeilenlnge');
        tbi_length.Checked := True;
        tbi_normalmouse.Checked := False;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := -1;
        bitfarmApp.LastAnnoDefaultHeight := -1;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_lengthClick - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_lengthClick - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_lineClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_lineClick - ' + Self.Name, Classname);
  try
    try

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      if not btnPreview.Checked then
      //12.09.2024 SD -->bfacrm:ticket__show__39935
//        Exit;
        btnPreviewClick(nil);
      //12.09.2024 SD <--bfacrm:ticket__show__39935

      UnCheckAllGraphicTools;

      {$IFDEF ENTERPRISE}
      SingleView.VirtualPluginMenuItem := nil;
      {$ENDIF}

      if CheckAnnoRights then
      begin
        if Assigned(fLastAnnoTool) then  // wenn wir schon ein Werkzeug gespeichert haben, machen wir das leer,
          fLastAnnoTool := nil;         //damit beim nchsten Wechsel das neue gespeichert wird

        FimgSingleView.ReadObjVals(7, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutPolyLine];
        FimgSingleView.img_DocView.PolylineEndingMode := ieemDoubleClick; //02.06.2015 ieemManual;

        FimgSingleView.fphistorymessage := _('Linie');
        tbi_line.Checked := True;
        tbi_normalmouse.Checked := False;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := -1;
        bitfarmApp.LastAnnoDefaultHeight := -1;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_lineClick - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_lineClick - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_normalmouseClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_normalmouseClick - ' + Self.Name, Classname);
  try
    try
      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      if (not btnPreview.Checked) {17.09.2024 SD -->bfacrm:ticket__show__39987} and (Sender <> nil) then
      //12.09.2024 SD -->bfacrm:ticket__show__39935
//        Exit;
        btnPreviewClick(nil);
      //12.09.2024 SD <--bfacrm:ticket__show__39935

      if not ((Sender is TSpTBXItem) or (Sender = nil)) then   // wenn wir nicht ber den Pfeilbutton oder programmatisch hierher kommen (also nur wenn ber Tastkrzel F7)
        if not tbi_annoselect.Checked then   // wenn nicht unmittelbar vorher Select gewhlt war
          ToggleLastAnnoTool;

      UnCheckAllGraphicTools;
      tbi_normalmouse.Checked := True;
      FimgSingleView.img_DocView.DeSelect;
      FimgSingleView.img_DocView.MouseInteractVt := [];
      FimgSingleView.img_DocView.MouseInteract := [miscroll];
      FimgSingleView.img_DocView.Cursor := 0;

      if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
         (Sender is TSpTBXItem) and Assigned(bitfarmApp)
      then
        bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := -1;
        bitfarmApp.LastAnnoDefaultHeight := -1;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_normalmouseClick - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_normalmouseClick - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_note1Click(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_note1Click - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      bitfarmLog.Write(llNormal, ltInfo, 'tbi_note1Click - ' + Self.Name, ClassName);

      UnCheckAllGraphicTools;
      if CheckAnnoRights then
      begin
        tbsub_notes.ImageIndex := Integer(icoidx_note_yellow);
        FimgSingleView.ReadObjVals(9, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutMemo];
        FimgSingleView.fphistorymessage := _('Gelbe Notiz');
        tbsub_notes.Checked := True;
        tbi_normalmouse.Checked := False;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := FimgSingleView.img_DocView.ObjWidth[-1];
        bitfarmApp.LastAnnoDefaultHeight := FimgSingleView.img_DocView.ObjHeight[-1];
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_note1Click - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_note1Click - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_note2Click(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_note2Click - ' + Self.Name, Classname);
  try
    try
      if not btnPreView.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      bitfarmLog.Write(llNormal, ltInfo, 'tbi_note2Click - ' + Self.Name, ClassName);

      UnCheckAllGraphicTools;
      if CheckAnnoRights then
      begin
        tbsub_notes.ImageIndex := Integer(icoidx_note_green);
        FimgSingleView.ReadObjVals(25, -1);

        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutMemo];
        FimgSingleView.fphistorymessage := _('Grne Notiz');
        tbsub_notes.Checked := True;
        tbi_normalmouse.Checked := False;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := FimgSingleView.img_DocView.ObjWidth[-1];
        bitfarmApp.LastAnnoDefaultHeight := FimgSingleView.img_DocView.ObjHeight[-1];
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_note2Click - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_note2Click - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_note3Click(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_note3Click - ' + Self.Name, Classname);
  try
    try
      if not btnPreView.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      bitfarmLog.Write(llNormal, ltInfo, 'tbi_note3Click - ' + Self.Name, ClassName);

      UnCheckAllGraphicTools;
      if CheckAnnoRights then
      begin
        tbsub_notes.ImageIndex := Integer(icoidx_note_red);
        FimgSingleView.ReadObjVals(26, -1);

        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutMemo];
        FimgSingleView.fphistorymessage := _('Rote Notiz');
        tbsub_notes.Checked := True;
        tbi_normalmouse.Checked := False;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := FimgSingleView.img_DocView.ObjWidth[-1];
        bitfarmApp.LastAnnoDefaultHeight := FimgSingleView.img_DocView.ObjHeight[-1];
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_note3Click - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_note3Click - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_note4Click(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_note4Click - ' + Self.Name, Classname);
  try
    try
      if not btnPreView.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      bitfarmLog.Write(llNormal, ltInfo, 'tbi_note4Click - ' + Self.Name, ClassName);

      UnCheckAllGraphicTools;
      if CheckAnnoRights then
      begin
        tbsub_notes.ImageIndex := Integer(icoidx_note_blue);
        FimgSingleView.ReadObjVals(27, -1);

        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutMemo];
        FimgSingleView.fphistorymessage := _('Blaue Notiz');
        tbsub_notes.Checked := True;
        tbi_normalmouse.Checked := False;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := FimgSingleView.img_DocView.ObjWidth[-1];
        bitfarmApp.LastAnnoDefaultHeight := FimgSingleView.img_DocView.ObjHeight[-1];
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_note4Click - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_note4Click - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_note5Click(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_note5Click - ' + Self.Name, Classname);
  try
    try
      if not btnPreView.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      bitfarmLog.Write(llNormal, ltInfo, 'tbi_note5Click - ' + Self.Name, ClassName);

      UnCheckAllGraphicTools;
      if CheckAnnoRights then
      begin
        tbsub_notes.ImageIndex := Integer(icoidx_note_orange);
        FimgSingleView.ReadObjVals(28, -1);

        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutMemo];
        FimgSingleView.fphistorymessage := _('Orange Notiz');
        tbsub_notes.Checked := True;
        tbi_normalmouse.Checked := False;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := FimgSingleView.img_DocView.ObjWidth[-1];
        bitfarmApp.LastAnnoDefaultHeight := FimgSingleView.img_DocView.ObjHeight[-1];
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_note5Click - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_note5Click - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_pencil1Click(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_pencil1Click - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      UnCheckAllGraphicTools;
      if CheckAnnoRights then
      begin
        tbsub_pencil.ImageIndex := Integer(icoidx_pencil_yellow);
        FimgSingleView.ReadObjVals(16, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutPolyLine];
        FimgSingleView.fphistorymessage := _('Linie');
        tbsub_pencil.Checked := True;
        tbi_normalmouse.Checked := False;
        FimgSingleView.img_DocView.BitmapResampleFilter := rfNone;
        FimgSingleView.fEndPolylineOnMouseUp := True;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := -1;
        bitfarmApp.LastAnnoDefaultHeight := -1;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_pencil1Click - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_pencil1Click - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_pencil2Click(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_pencil2Click - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      UnCheckAllGraphicTools;
      if CheckAnnoRights then
      begin
        tbsub_pencil.ImageIndex := Integer(icoidx_pencil_green);
        FimgSingleView.ReadObjVals(17, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutPolyLine];
        FimgSingleView.fphistorymessage := _('Linie');
        tbsub_pencil.Checked := True;
        tbi_normalmouse.Checked := False;
        FimgSingleView.img_DocView.BitmapResampleFilter := rfNone;
        FimgSingleView.fEndPolylineOnMouseUp := True;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := -1;
        bitfarmApp.LastAnnoDefaultHeight := -1;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_pencil2Click - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_pencil2Click - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_pencil3Click(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_pencil3Click - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      UnCheckAllGraphicTools;
      if CheckAnnoRights then
      begin
        tbsub_pencil.ImageIndex := Integer(icoidx_pencil_red);
        FimgSingleView.ReadObjVals(18, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutPolyLine];
        FimgSingleView.fphistorymessage := _('Linie');
        tbsub_pencil.Checked := True;
        tbi_normalmouse.Checked := False;
        FimgSingleView.img_DocView.BitmapResampleFilter := rfNone;
        FimgSingleView.fEndPolylineOnMouseUp := True;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := -1;
        bitfarmApp.LastAnnoDefaultHeight := -1;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_pencil3Click - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_pencil3Click - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_pencil4Click(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_pencil4Click - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      UnCheckAllGraphicTools;
      if CheckAnnoRights then
      begin
        tbsub_pencil.ImageIndex := Integer(icoidx_pencil_blue);
        FimgSingleView.ReadObjVals(19, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutPolyLine];
        FimgSingleView.fphistorymessage := _('Linie');
        tbsub_pencil.Checked := True;
        tbi_normalmouse.Checked := False;
        FimgSingleView.img_DocView.BitmapResampleFilter := rfNone;
        FimgSingleView.fEndPolylineOnMouseUp := True;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := -1;
        bitfarmApp.LastAnnoDefaultHeight := -1;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_pencil4Click - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_pencil4Click - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_pencil5Click(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_pencil5Click - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      UnCheckAllGraphicTools;
      if CheckAnnoRights then
      begin
        tbsub_pencil.ImageIndex := Integer(icoidx_pencil_orange);
        FimgSingleView.ReadObjVals(20, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutPolyLine];
        FimgSingleView.fphistorymessage := _('Linie');
        tbsub_pencil.Checked := True;
        FimgSingleView.fEndPolylineOnMouseUp := True;
        tbi_normalmouse.Checked := False;
        FimgSingleView.img_DocView.BitmapResampleFilter := rfNone;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := -1;
        bitfarmApp.LastAnnoDefaultHeight := -1;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_pencil5Click - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_pencil5Click - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_polygonClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_polygonClick - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      UnCheckAllGraphicTools;

      {$IFDEF ENTERPRISE}
      SingleView.VirtualPluginMenuItem := nil;
      {$ENDIF}

      if CheckAnnoRights then
      begin
        if Assigned(fLastAnnoTool) then  // wenn wir schon ein Werkzeug gespeichert haben, machen wir das leer,
          fLastAnnoTool := nil;         //damit beim nchsten Wechsel das neue gespeichert wird

        FimgSingleView.ReadObjVals(12, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutPolyLine];
        FimgSingleView.img_DocView.PolylineEndingMode := ieemManual;

        FimgSingleView.fphistorymessage := _('Poligon');
        tbi_polygon.Checked := True;
        tbi_normalmouse.Checked := False;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := -1;
        bitfarmApp.LastAnnoDefaultHeight := -1;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_polygonClick - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_polygonClick - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_stampdialogClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_stampdialogClick - ' + Self.Name, Classname);
  try
    try

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      if not btnPreview.Checked then
      //12.09.2024 SD -->bfacrm:ticket__show__39935
//        Exit;
        btnPreviewClick(nil);
      //12.09.2024 SD <--bfacrm:ticket__show__39935

      UnCheckAllGraphicTools;

      {$IFDEF ENTERPRISE}
      SingleView.VirtualPluginMenuItem := nil;
      {$ENDIF}

      if CheckAnnoRights then
      begin
        if Assigned(fLastAnnoTool) then  // wenn wir schon ein Werkzeug gespeichert haben, machen wir das leer,
          fLastAnnoTool := nil;         //damit beim nchsten Wechsel das neue gespeichert wird

        tbi_stampdialog.Checked := True;
        tbi_normalmouse.Checked := False;
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        CreateTfrm_Stamps(Self, FimgSingleView);

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           Assigned(bitfarmApp) and (bitfarmApp.LastSelectedStamp <> '')
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := FimgSingleView.img_DocView.ObjWidth[-1];
        bitfarmApp.LastAnnoDefaultHeight := FimgSingleView.img_DocView.ObjHeight[-1];
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_stampdialogClick - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_stampdialogClick - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_text1Click(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_text1Click - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      UnCheckAllGraphicTools;

      {$IFDEF ENTERPRISE}
      SingleView.VirtualPluginMenuItem := nil;
      {$ENDIF}

      if CheckAnnoRights then
      begin
        if Assigned(fLastAnnoTool) then  // wenn wir schon ein Werkzeug gespeichert haben, machen wir das leer,
          fLastAnnoTool := nil;         //damit beim nchsten Wechsel das neue gespeichert wird

        tbsub_text.ImageIndex := Integer(icoidx_text_1);
        FimgSingleView.ReadObjVals(15, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutMemo];
        FimgSingleView.fphistorymessage := _('Text');
        tbsub_text.Checked := True;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := FimgSingleView.img_DocView.ObjWidth[-1];
        bitfarmApp.LastAnnoDefaultHeight := FimgSingleView.img_DocView.ObjHeight[-1];
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_text1Click - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_text1Click - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_text2Click(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_text2Click - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      UnCheckAllGraphicTools;
      if CheckAnnoRights then
      begin
        tbsub_text.ImageIndex := Integer(icoidx_text_2);
        FimgSingleView.ReadObjVals(21, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutMemo];
        FimgSingleView.fphistorymessage := _('Text');
        tbsub_text.Checked := True;
        tbi_normalmouse.Checked := False;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := FimgSingleView.img_DocView.ObjWidth[-1];
        bitfarmApp.LastAnnoDefaultHeight := FimgSingleView.img_DocView.ObjHeight[-1];
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_text2Click - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_text2Click - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_text3Click(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_text3Click - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      UnCheckAllGraphicTools;
      if CheckAnnoRights then
      begin
        tbsub_text.ImageIndex := Integer(icoidx_text_3);
        FimgSingleView.ReadObjVals(22, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutMemo];
        FimgSingleView.fphistorymessage := _('Text');
        tbsub_text.Checked := True;
        tbi_normalmouse.Checked := False;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := FimgSingleView.img_DocView.ObjWidth[-1];
        bitfarmApp.LastAnnoDefaultHeight := FimgSingleView.img_DocView.ObjHeight[-1];
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_text3Click - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_text3Click - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_text4Click(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_text4Click - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      UnCheckAllGraphicTools;
      if CheckAnnoRights then
      begin
        tbsub_text.ImageIndex := Integer(icoidx_text_4);
        FimgSingleView.ReadObjVals(23, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutMemo];
        FimgSingleView.fphistorymessage := _('Text');
        tbsub_text.Checked := True;
        tbi_normalmouse.Checked := False;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := FimgSingleView.img_DocView.ObjWidth[-1];
        bitfarmApp.LastAnnoDefaultHeight := FimgSingleView.img_DocView.ObjHeight[-1];
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_text4Click - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_text4Click - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbi_text5Click(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbi_text5Click - ' + Self.Name, Classname);
  try
    try
      if not btnPreview.Checked then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      UnCheckAllGraphicTools;
      if CheckAnnoRights then
      begin
        tbsub_text.ImageIndex := Integer(icoidx_text_5);
        FimgSingleView.ReadObjVals(24, -1);
        {$IFNDEF IMAGEEN1140} //17.01.2024
        FimgSingleView.createannodata(-1);
        {$ENDIF}
        FimgSingleView.img_DocView.MouseInteractVt := [miPutMemo];
        FimgSingleView.fphistorymessage := _('Text');
        tbsub_text.Checked := True;
        tbi_normalmouse.Checked := False;

        if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
           (Sender is TSpTBXItem) and Assigned(bitfarmApp)
        then
          bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;

        bitfarmApp.LastAnnoDefaultWidth := FimgSingleView.img_DocView.ObjWidth[-1];
        bitfarmApp.LastAnnoDefaultHeight := FimgSingleView.img_DocView.ObjHeight[-1];
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbi_text5Click - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbi_text5Click - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbsub_highlightClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbsub_highlightClick - ' + Self.Name, Classname);
  try
    try
      //12.09.2024 SD -->bfacrm:ticket__show__39935
      if not btnPreview.Checked then
        btnPreviewClick(nil);
      //12.09.2024 SD <--bfacrm:ticket__show__39935

      tbsub_highlight.Checked := True;

      if Assigned(fLastAnnoTool) then  // wenn wir schon ein Werkzeug gespeichert haben, machen wir das leer,
        fLastAnnoTool := nil;         //damit beim nchsten Wechsel das neue gespeichert wird

      {$IFDEF ENTERPRISE}
      SingleView.VirtualPluginMenuItem := nil;
      {$ENDIF}

      case tbsub_highlight.ImageIndex of
        Integer(icoidx_marker_yellow):
          tbi_highlite1Click(Sender);

        Integer(icoidx_marker_green):
          tbi_highlite2Click(Sender);

        Integer(icoidx_marker_red):
          tbi_highlite3Click(Sender);

        Integer(icoidx_marker_blue):
          tbi_highlite4Click(Sender);

        Integer(icoidx_marker_orange):
          tbi_highlite5Click(Sender);
      else
        tbi_highlite1Click(Sender);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbsub_highlightClick - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbsub_highlightClick - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbsub_notesClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbsub_notesClick - ' + Self.Name, Classname);
  try
    try
      //12.09.2024 SD -->bfacrm:ticket__show__39935
      if not btnPreview.Checked then
        btnPreviewClick(nil);
      //12.09.2024 SD <--bfacrm:ticket__show__39935

      tbsub_notes.Checked := True;

      if Assigned(fLastAnnoTool) then  // wenn wir schon ein Werkzeug gespeichert haben, machen wir das leer,
        fLastAnnoTool := nil;         //damit beim nchsten Wechsel das neue gespeichert wird

      {$IFDEF ENTERPRISE}
      SingleView.VirtualPluginMenuItem := nil;
      {$ENDIF}

      case tbsub_notes.ImageIndex of
        Integer(icoidx_note_yellow):
          tbi_note1Click(Sender);

        Integer(icoidx_note_green):
          tbi_note2Click(Sender);

        Integer(icoidx_note_red):
          tbi_note3Click(Sender);

        Integer(icoidx_note_blue):
          tbi_note4Click(Sender);

        Integer(icoidx_note_orange):
          tbi_note5Click(Sender);
      else
        tbi_note1Click(Sender);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbsub_notesClick - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbsub_notesClick - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbsub_pencilClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbsub_pencilClick - ' + Self.Name, Classname);
  try
    try
      //12.09.2024 SD -->bfacrm:ticket__show__39935
      if not btnPreview.Checked then
        btnPreviewClick(nil);
      //12.09.2024 SD <--bfacrm:ticket__show__39935

      tbsub_pencil.Checked := True;

      if Assigned(fLastAnnoTool) then  // wenn wir schon ein Werkzeug gespeichert haben, machen wir das leer,
        fLastAnnoTool := nil;         //damit beim nchsten Wechsel das neue gespeichert wird

      {$IFDEF ENTERPRISE}
      SingleView.VirtualPluginMenuItem := nil;
      {$ENDIF}

      case tbsub_pencil.ImageIndex of
        Integer(icoidx_pencil_yellow):
          tbi_pencil1Click(Sender);

        Integer(icoidx_pencil_green):
          tbi_pencil2Click(Sender);

        Integer(icoidx_pencil_red):
          tbi_pencil3Click(Sender);

        Integer(icoidx_pencil_blue):
          tbi_pencil4Click(Sender);

        Integer(icoidx_pencil_orange):
          tbi_pencil5Click(Sender);
      else
        tbi_pencil1Click(Sender);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbsub_pencilClick - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbsub_pencilClick - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbsub_textClick(Sender: TObject);
begin
  bitfarmLog.DebugBegin(llDebug, 'tbsub_textClick - ' + Self.Name, Classname);
  try
    try
      //12.09.2024 SD -->bfacrm:ticket__show__39935
      if not btnPreview.Checked then
        btnPreviewClick(nil);
      //12.09.2024 SD <--bfacrm:ticket__show__39935

      tbsub_text.Checked := True;

      if Assigned(fLastAnnoTool) then  // wenn wir schon ein Werkzeug gespeichert haben, machen wir das leer,
        fLastAnnoTool := nil;         //damit beim nchsten Wechsel das neue gespeichert wird

      {$IFDEF ENTERPRISE}
      SingleView.VirtualPluginMenuItem := nil;
      {$ENDIF}

      case tbsub_text.ImageIndex of
        Integer(icoidx_text_1):
          tbi_text1Click(Sender);

        Integer(icoidx_text_2):
          tbi_text2Click(Sender);

        Integer(icoidx_text_3):
          tbi_Text3Click(Sender);

        Integer(icoidx_text_4):
          tbi_Text4Click(Sender);

        Integer(icoidx_text_5):
          tbi_text5Click(Sender);
      else
        tbi_Text1Click(Sender);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'tbsub_textClick - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbsub_textClick - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.tbx_favClick(Sender: TObject);
var
  tbx_fav: TSPTBXItem;
begin
  bitfarmLog.DebugBegin(llDebug, 'tbx_favClick - ' + Self.Name, Classname);
  try
    try

      if not(Sender is TSpTBXItem) then
        Exit;

      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      if not btnPreview.Checked then
      //12.09.2024 SD -->bfacrm:ticket__show__39935
//        Exit;
        btnPreviewClick(nil);
      //12.09.2024 SD <--bfacrm:ticket__show__39935

      tbx_fav := TSpTBXItem(Sender);
      UnCheckAllGraphicTools;
      if CheckAnnoRights then
      begin
        if Assigned(fLastAnnoTool) then  // wenn wir schon ein Werkzeug gespeichert haben, machen wir das leer,
          fLastAnnoTool := nil;         //damit beim nchsten Wechsel das neue gespeichert wird

        try
          FimgSingleView.LoadStamp(gasfavstemp[tbx_fav.Tag]);
          FimgSingleView.fphistorymessage := _('Stempel') + ' ' + tbx_fav.Hint;
          tbx_fav.Checked := True;
          tbi_normalmouse.Checked := False;

          if (FActiveDoc <> nil) and FActiveDoc.InEditMode and
             (Sender is TSpTBXItem) and Assigned(bitfarmApp)
          then
          begin
            bitfarmApp.LastUsedAnnoTool := TSpTBXItem(Sender).Name;
            bitfarmApp.LastSelectedStampTool := TSpTBXItem(Sender).Name;
          end;

          bitfarmApp.LastAnnoDefaultWidth := FimgSingleView.img_DocView.ObjWidth[-1];
          bitfarmApp.LastAnnoDefaultHeight := FimgSingleView.img_DocView.ObjHeight[-1];
          bitfarmApp.LastSelectedStamp := gasfavstemp[tbx_fav.Tag]; //21.11.2023 bfacrm:ticket__show__36926
        except
          bitfarmLog.Write(llNormal, ltException, 'tbx_favClick - LoadStamp', ClassName);
        end;
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'tbx_favClick - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'tbx_favClick - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.ShowAnnoData(annodata: PAnnoData);
var
  lipos1: integer;
  lsv, lsTmp, fsinfo: WideString;
  itm: TSpTBXLabelItem;
begin
  try
    if annodata <> nil then
    begin
      if annodata = Pointer($FFFFFFFF) then
        Exit;

      if not Self.Floating then
        itm := frmMainForm.itmInfo
      else
        itm := TbfaFloatingForm((TSpTBXDockablePanel(Self.Owner).Parent).Parent).itmFloatingInfo;

      // TAnnoData wurde um GUID erweitert - siehe Definition
      lsv := annodata.version;
      if (lsv <> '0.1') and (lsv <> '0.2') then
        Exit;

      lsTmp := itm.Caption; // GetStatusText(cStatusPanelInfo);
      if pos(_('; zuletzt gendert am:'), string(lsTmp)) = 0 then
        fsinfo := lsTmp
      else
        fsinfo := '';

      itm.Caption := _('Autor:') + ' ' + annodata.Ersteller + _('; zuletzt gendert am:') + ' ' + annodata.Datum;
      if annodata.Veraenderer <> '' then
      begin
        if 0 = Pos(',', ReverseString(annodata.Veraenderer)) then
        begin
          lipos1 := 0;
        end else
        begin
          lipos1 := length(annodata.Veraenderer) - Pos(',', ReverseString(annodata.Veraenderer)) + 2;
        end;
        itm.Caption := itm.Caption + _('; zuletzt gendert von:') + ' ' + //3.5.0.25
          copy(annodata.Veraenderer, lipos1, length(annodata.Veraenderer));
        itm.Hint := copy(annodata.Veraenderer, 0, length(annodata.Veraenderer));
      end;
    end
    else
    begin
      if fsinfo <> '' then
        itm.Caption := fsinfo;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'ShowAnnoData - ' + Self.Name, ClassName);
  end;
end;

procedure TbfaPreview.ToggleLastAnnoTool;
var
  tmpAnnoTool: procedure(Sender: TObject) of object;
begin
  if Assigned(fLastAnnoTool) then
  begin
    FimgSingleView.img_DocView.Cursor := 1785;
    tmpAnnoTool := fLastAnnoTool;
    fLastAnnoTool := nil;
    tmpAnnoTool(fLastAnnoSender);
    Abort;
  end
  else
  begin
    if tbi_fav1.Checked then
    begin
      fLastAnnoTool := tbx_favClick;
      fLastAnnoSender := tbi_fav1;
    end
    else if tbi_fav2.Checked then
    begin
      fLastAnnoTool := tbx_favClick;
      fLastAnnoSender := tbi_fav2;
    end
    else if tbi_fav3.Checked then
    begin
      fLastAnnoTool := tbx_favClick;
      fLastAnnoSender := tbi_fav3;
    end
    else if tbi_fav4.Checked then
    begin
      fLastAnnoTool := tbx_favClick;
      fLastAnnoSender := tbi_fav4;
    end
    else if tbi_fav5.Checked then
    begin
      fLastAnnoTool := tbx_favClick;
      fLastAnnoSender := tbi_fav5;
    end
    else if tbi_fav6.Checked then
    begin
      fLastAnnoTool := tbx_favClick;
      fLastAnnoSender := tbi_fav6;
    end
    else if tbi_fav7.Checked then
    begin
      fLastAnnoTool := tbx_favClick;
      fLastAnnoSender := tbi_fav7;
    end
    else if tbi_fav8.Checked then
    begin
      fLastAnnoTool := tbx_favClick;
      fLastAnnoSender := tbi_fav8;
    end
    else if tbi_fav9.Checked then
    begin
      fLastAnnoTool := tbx_favClick;
      fLastAnnoSender := tbi_fav9;
    end
    else if tbi_fav10.Checked then
    begin
      fLastAnnoTool := tbx_favClick;
      fLastAnnoSender := tbi_fav10;
    end
    else if tbi_stampdialog.Checked then
    begin
      fLastAnnoTool := tbi_stampdialogClick;
      fLastAnnoSender := tbi_stampdialog;
    end
    else if tbi_line.Checked then
    begin
      fLastAnnoTool := tbi_lineClick;
      fLastAnnoSender := tbi_line;
    end
    else if tbi_rangeocr.Checked then
    begin
      fLastAnnoTool := tbi_rangeocrClick;
      fLastAnnoSender := tbi_rangeocr;
    end
    else if tbsub_highlight.Checked then
    begin
      fLastAnnoTool := tbsub_highlightClick;
      fLastAnnoSender := tbsub_highlight;
    end
    else if tbsub_notes.Checked then
    begin
      fLastAnnoTool := tbsub_notesClick;
      fLastAnnoSender := tbsub_notes;
    end
    else if tbsub_pencil.Checked then
    begin
      fLastAnnoTool := tbsub_pencilClick;
      fLastAnnoSender := tbsub_pencil;
    end
    else if tbsub_text.Checked then
    begin
      fLastAnnoTool := tbsub_textClick;
      fLastAnnoSender := tbsub_text;
    end
    else if tbi_arrow.Checked then
    begin
      fLastAnnoTool := tbi_arrowClick;
      fLastAnnoSender := tbi_arrow;
    end;
  end;
end;

//procedure TbfaPreview.LoadFavStampValues(fktag: integer; favtext: string);
//begin
//  bitfarmLog.DebugBegin(llDebug, 'LoadFavStampValues - ' + Self.Name, Classname);
//  try
//    try
//      UnCheckAllGraphicTools;
//      tbi_normalmouse.Checked := False;
//      FimgSingleView.LoadStamp(gasfavstemp[fktag]);
//    except
//      bitfarmLog.Write(llNormal, ltException, 'LoadFavStampValues - ' + Self.Name, ClassName);
//    end;
//  finally
//    bitfarmLog.DebugEnd(llDebug, 'LoadFavStampValues - ' + Self.Name, Classname);
//  end;
//end;


procedure TbfaPreview.CreateTfrm_Stamps(Owner: TWinControl; Voransicht: Tfrm_Voransicht);
var
  frm_Stamps: Tfrm_Stamps;
begin
  frm_Stamps := Tfrm_Stamps.Create(Owner);
  try
    frm_Stamps.fVoransicht := FimgSingleView;
    frm_Stamps.Color := stlControl.Color;
    frm_Stamps.Font.Color := stlControl.TextColor;
    frm_Stamps.lv_Stamps.Color := stlControl.Color;
    frm_Stamps.lv_Stamps.Font.Color := stlControl.TextColor;
    frm_Stamps.btn_Ok.Color := stlControl.Color;
    frm_Stamps.btn_OK.Font.Color := stlControl.TextColor;
    frm_Stamps.btn_Cancel.Color := stlControl.Color;
    frm_Stamps.btn_Cancel.Font.Color := stlControl.TextColor;
    frm_Stamps.ShowModal;
    if Assigned(bitfarmApp) then
      bitfarmApp.LastSelectedStamp := frm_Stamps.selectedStamp;
  finally
    frm_Stamps.Free;
  end;
end;

procedure TbfaPreview.dctPreviewTargetDragOver(Sender: TObject; ShiftState: TShiftState; APoint: TPoint; var Effect: Integer);
var
  im: Integer;
  imgX, imgY, docIdx: Integer;
  last, IsVScrollVisible, IsHScrollVisible: Boolean;
  sen, src: TbfaImageEnMView;
  senPrev: TbfaPreview;
  p: TPoint;
  TOwner: TComponent;

  function CanMerge(Doc: TbfaBaseDocument): Boolean;
  var
    i: Integer;
    found: Boolean;
  begin
    found := False; //02.12.2016 (Doc.ID <> -1);
    try
      i := 0;
      while ((not found) and (i <= bitfarmApp.DragObject.DocumentList.Count - 1)) do
      begin
        if (Doc = bitfarmApp.DragObject.DocumentList[i]) then
          found := True;
        inc(i);
      end;
      Result := (found = false);
    except
      Result := False;
    end;
  end;

begin
  bitfarmLog.DebugBegin(llDebug, 'MViewDragOver - ' + Self.Name, Classname);
  try
    try
      if bitfarmApp.DragObject = nil then
      begin
        if not bitfarmApp.ViewerOptions.GeneralOptions.DragDropAsWindows then
        begin
          Effect := DROPEFFECT_COPY;
          Exit;
        end;
      end;

      if ((bitfarmApp.DragObject <> nil) and (bitfarmApp.DragObject.DragSource <> TCustomDropTarget(Sender).Target) and (bitfarmApp.DragObject.DragSource = FimgThumbnailView) and (TCustomDropTarget(Sender).Target = FimgSingleView)) then
      begin
        if FbfaPreviewKind = pvkMultiSingle then
          frmMainForm.actPreviewBack.Execute
      end;

      if bitfarmApp.DragObject <> nil then
      begin
        bitfarmApp.DragObject.DragSender := dctPreviewTarget.FindTarget((TCustomDropTarget(Sender).Target as TWinControl).ClientToScreen(APoint));
      end;

//19.06.2018 Ticket 14576 -->
      TOwner := TDropComboTarget(Sender).Target.Owner;
      if TOwner = nil then
        TOwner := TDropComboTarget(Sender).Target.Parent.Owner;
//19.06.2018 Ticket 14576 <--

      if (TDropComboTarget(Sender).Target is TIEView) and
        (not ((TbfaPreview(TOwner).PreviewKind = pvkSingle) and
        (TbfaPreview(TOwner).ActiveDoc <> nil) and
        (TbfaPreview(TOwner).ActiveDoc.ID <> -1))) then
        src := TbfaImageEnMView(TDropComboTarget(Sender).Target)
      else
      begin
        if (TDropComboTarget(Sender).Target is TbfaImageEnMView) and (not
          ((TbfaPreview(TOwner).PreviewKind = pvkSingle) and
          (TbfaPreview(TOwner).ActiveDoc <> nil) and
          (TbfaPreview(TOwner).ActiveDoc.ID <> -1))) then
          src := (TDropComboTarget(Sender).Target as TbfaImageEnMView)
        else if (bitfarmApp.DragObject <> nil) or
          ((TbfaPreview(TOwner).PreviewKind = pvkSingle) and
          (TbfaPreview(TOwner).ActiveDoc <> nil) and
          (TbfaPreview(TOwner).ActiveDoc.ID <> -1)) then
        begin
          src := nil;
          Effect := DROPEFFECT_NONE;
          bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 1', ClassName);
          Exit;
        end;
      end;

      if (bitfarmApp.DragObject <> nil) and (bitfarmApp.DragObject.DragSender = FimgThumbnailView) then
      begin
        IsVScrollVisible := GetWindowLong(FimgThumbnailView.Handle, GWL_STYLE) and WS_VSCROLL <> 0;
        IsHScrollVisible := GetWindowLong(FimgThumbnailView.Handle, GWL_STYLE) and WS_HSCROLL <> 0;

        if (IsVScrollVisible or IsHScrollVisible) then
          FThumbnailTimer.Enabled := True;
      end
      else
        FThumbnailTimer.Enabled := False;

      if ((bitfarmApp.DragObject <> nil) and (src <> nil) and (TDropComboTarget(Sender).Target <> nil) and ((bitfarmApp.DragObject.DragSender is TbfaImageEnMView) and (src.MultiSelectedImagesCount > 0))) then
      begin
        sen := (bitfarmApp.DragObject.DragSender as TbfaImageEnMView);
        senPrev := TbfaPreview(sen.Owner);
//19.06.2018 Ticket 14576 -->
        if senPrev = nil then
          senPrev := TbfaPreview(sen.Parent.Owner);
//19.06.2018 Ticket 14576 <--

        if senPrev.PreviewKind = pvkSingle then
          docIdx := 0
        else
          docIdx := senPrev.MultiView.SelectedImage;

        if ((bitfarmApp.DragObject.DragKind <> dkNone) and (((bitfarmApp.DragObject.DragKind = dkPages) // Seiten werden verschoben
          and (bitfarmApp.DragObject.DocumentList[0].HasPreview) // Das Dokument wovon die Seiten verschoben werden ist ein Image
          and (not bitfarmApp.DragObject.DocumentList[0].PreviewChanging) and (((sen.Tag = tagThumbnailMView)  // Auf ein ThumbnailView werden die Seiten verschoben
          and (((senPrev.PreviewKind = pvkSingle) and (senPrev.List[0].HasPreview) and (not senPrev.List[0].PreviewChanging) and ((TbfaImageEnMView(bitfarmApp.DragObject.DragSource) = sen) or ((TbfaImageEnMView(bitfarmApp.DragObject.DragSource) <> sen) and (senPrev.List[0] <> bitfarmApp.DragObject.DocumentList[0])))) or (((senPrev.PreviewKind = pvkMulti) or (senPrev.PreviewKind = pvkMultiSingle)) and (senPrev.MultiView.MultiSelectedImagesCount = 1) and (senPrev.List[senPrev.MultiView.SelectedImage].HasPreview)
          and (not senPrev.List[senPrev.MultiView.SelectedImage].PreviewChanging) and ((TbfaImageEnMView(bitfarmApp.DragObject.DragSource) = sen) or ((TbfaImageEnMView(bitfarmApp.DragObject.DragSource) <> sen) and (senPrev.List[senPrev.MultiView.SelectedImage] <> bitfarmApp.DragObject.DocumentList[0])))))) or ((sen.Tag = tagCollectionMView)  // Auf ein CollectionView werden die Seiten verschoben
          and (senPrev.PreviewKind = pvkMulti)))) or ((bitfarmApp.DragObject.DragKind = dkDocuments) and ((sen.Tag = tagThumbnailMView)  // Auf ein ThumbnailView werden die Dokumente verschoben
          and bfaCommonImageEN.CheckIfAllDocumentsPreviewChanged(bitfarmApp.DragObject.DocumentList, True) and ((sen.Tag = tagThumbnailMView)  // Auf ein ThumbnailView werden die Dokumente verschoben
          and (((senPrev.PreviewKind = pvkSingle) and (senPrev.List[0].HasPreview) and (not senPrev.List[0].PreviewChanging)) or ((((senPrev.PreviewKind = pvkMulti) and (TbfaPreview(TbfaImageEnMView(bitfarmApp.DragObject.DragSource).Owner) <> TbfaPreview(sen.Owner))) or (senPrev.PreviewKind = pvkMultiSingle)) and (senPrev.MultiView.MultiSelectedImagesCount = 1) and (senPrev.List[senPrev.MultiView.SelectedImage].HasPreview) and (not senPrev.List[senPrev.MultiView.SelectedImage].PreviewChanging)))) or ((sen.Tag = tagCollectionMView)))))) then
        begin

          //////////////////////////////////////////////////////// Rote Linie Anzeigen -->
          last := False;

          im := sen.InsertingPoint(APoint.X, APoint.Y);
          if (sen.ImageCount > 0) and (im = sen.ImageCount) then  // als letztens einfgen
          begin
            dec(im); // sonst imgX und imgY wird immer 0 sein
            last := True;
          end;
          imgX := sen.ImageX[im] - sen.ViewX;
          imgY := sen.ImageY[im] - sen.ViewY;
          sen.Paint;
          with sen.GetCanvas do
          begin
            Pen.Color := gclLime;
            Pen.Width := 3;
            p := sen.ScreenToClient(Mouse.CursorPos);
            if not last then
            begin
              if (sen.GridWidth <> 1) then
              begin
                if (((p.X >= imgX) and (p.X <= imgX + 50)) and
                  ((p.Y >= imgY) and (p.Y <= imgY + sen.ThumbHeight))) then
                begin
                  MoveTo(imgX - 2, imgY);
                  LineTo(imgX - 2, sen.ThumbHeight + imgY);
                  bitfarmApp.DragObject.DragInsertMode := dimBefore;
                end;
                if (((p.X >= imgX + 50) and (p.X <= imgX + sen.ThumbWidth)) and
                  ((p.Y >= imgY) and (p.Y <= imgY + sen.ThumbHeight))) then
                begin
                  MoveTo(imgX + sen.ThumbWidth + 2, imgY);
                  LineTo(imgX + sen.ThumbWidth + 2, sen.ThumbHeight + imgY);
                  bitfarmApp.DragObject.DragInsertMode := dimAfter;
                end;

              end
              else if (sen.GridWidth = 1) then
              begin
                if (((p.X >= imgX) and (p.X <= imgX + sen.ThumbWidth)) and
                  ((p.Y >= imgY) and (p.Y <= imgY + 50))) then
                begin
                  MoveTo(imgX + 10, imgY - 2);
                  LineTo(imgX + sen.ThumbWidth - 10, imgY - 2);
                  bitfarmApp.DragObject.DragInsertMode := dimBefore;
                end;
                if (((p.X >= imgX) and (p.X <= imgX + sen.ThumbWidth)) and
                  ((p.Y >= imgY + 50) and (p.Y <= imgY + sen.ThumbHeight))) then
                begin
                  MoveTo(imgX + 10, sen.ThumbHeight + imgY + 2);
                  LineTo(imgX + sen.ThumbWidth - 10, sen.ThumbHeight + imgY + 2);
                  bitfarmApp.DragObject.DragInsertMode := dimAfter;
                end;
              end;

              if ((sen.Tag = tagCollectionMView) and ((FList.Count > 0) and
                (bfaCommonImageEN.CheckIfAllDocumentsPreviewChanged(bitfarmApp.DragObject.DocumentList, True))) and
                ((sen.ImageAtPos(p.X, p.y) <> -1) and (FList[sen.ImageAtPos(p.X, p.y)].HasPreview)) and
                (CanMerge(FList[sen.ImageAtPos(p.X, p.y)]))) then
              begin
                if (((p.X >= imgX + Round((sen.ThumbWidth - MINTHUMBWIDTH) div 2) + 33) and
                  (p.X <= imgX + Round((sen.ThumbWidth - MINTHUMBWIDTH) div 2) + 66)) and
                  ((p.Y >= imgY + Round((sen.ThumbHeight - MINTHUMBHEIGHT) div 2) + 33) and
                  (p.Y <= imgY + Round((sen.ThumbHeight - MINTHUMBHEIGHT) div 2) + 66))) then
                begin
                  MoveTo(imgX - 2, imgY);
                  LineTo(imgX + sen.ThumbWidth + 2, imgY);

                  MoveTo(imgX - 2, imgY);
                  LineTo(imgX - 2, sen.ThumbHeight + imgY);

                  MoveTo(imgX - 2, sen.ThumbHeight + imgY);
                  LineTo(imgX + sen.ThumbWidth + 2, sen.ThumbHeight + imgY);

                  MoveTo(imgX + sen.ThumbWidth + 2, imgY);
                  LineTo(imgX + sen.ThumbWidth + 2, sen.ThumbHeight + imgY);

                  bitfarmApp.DragObject.DragInsertMode := dimMerge;
                end;
              end;
            end
            else
            begin
              bitfarmApp.DragObject.DragInsertMode := dimAfter;
              if (sen.GridWidth <> 1) then
              begin
                MoveTo(imgX + sen.ThumbWidth, imgY);
                LineTo(imgX + sen.ThumbWidth, sen.ThumbHeight + imgY);
              end
              else
              begin
                MoveTo(imgX + 10, sen.ThumbHeight + imgY);
                LineTo(imgX + sen.ThumbWidth - 10, sen.ThumbHeight + imgY);
              end;
            end;

          end;

          //////////////////////////////////////////////////////// Rote Linie Anzeigen <--

        end
        else
        begin
          Effect := DROPEFFECT_NONE;
          bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 2', ClassName);
          bitfarmApp.DragObject.DragSender := nil;
        end;

      end
      else if (bitfarmApp.DragObject <> nil) then
      begin
        Effect := DROPEFFECT_NONE;
        bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 3', ClassName);
        bitfarmApp.DragObject.DragSender := nil;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'MViewDragOver - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'MViewDragOver - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.dctPreviewTargetDrop(Sender: TObject; ShiftState: TShiftState; APoint: TPoint; var Effect: Integer);
var
  Ctrl: TWinControl;
begin
  try
    if (TCustomDropTarget(Sender).Target is TWinControl) then
    begin
      Ctrl := (TCustomDropTarget(Sender).Target as TWinControl);
      if Ctrl <> nil then
      begin
        if (bitfarmApp.DragObject <> nil) and frmMainForm.FInside {(frmMainForm.FIsDragging)} then
        begin
          bitfarmApp.DragObject.Move := (Effect = DROPEFFECT_MOVE);
          if (Ctrl = FimgMultiView) or (Ctrl = FimgSingleView) or (Ctrl = FimgThumbnailView) then
          begin
            MViewDragDrop(bitfarmApp.DragObject.DragSender, bitfarmApp.DragObject, APoint.X, APoint.Y);
          end
          else
          begin
            Effect := DROPEFFECT_NONE;
            bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 4', ClassName);
          end;
        end
        else
        begin
          if (Ctrl = FimgMultiView) then
          begin
            if (Effect = DROPEFFECT_MOVE) and (not bitfarmApp.ViewerOptions.GeneralOptions.DragDropAsWindows) then
              Effect := DROPEFFECT_COPY;
            bitfarmApp.CreateLoadAction(Effect, dctPreviewTarget);
          end
          else
          begin
            Effect := DROPEFFECT_NONE;
            bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 5', ClassName);
          end;
        end;
      end
      else
      begin
        Effect := DROPEFFECT_NONE;
        bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 6', ClassName);
      end;
    end
    else
    begin
      Effect := DROPEFFECT_NONE;
      bitfarmLog.Write(llDebug, ltInfo, 'DROPEFFECT_NONE - 7', ClassName);
    end;
  finally
    frmMainForm.FIsDragging := False;
  end;
end;

procedure TbfaPreview.dctPreviewTargetEnter(Sender: TObject; ShiftState: TShiftState; APoint: TPoint; var Effect: Integer);
begin
  frmMainForm.FInside := True;

  if bitfarmApp.FUseFileTarget then
  begin
    if bitfarmApp.PreviewContainer.ActiveItem <> pvtImporter then
      bitfarmApp.SetViewAndArchiveAction(tvkImporter);
  end;
end;

procedure TbfaPreview.dctPreviewTargetLeave(Sender: TObject);
begin
  frmMainForm.FIsDragging := False;
  frmMainForm.FInside := False;
//23.08.2017 Ticket 10999 -->
  if Sender is TDropComboTarget then
  begin
    if TDropComboTarget(Sender).Target = frmMainForm.FViewerTreeView then
      frmMainForm.FViewerTreeview.Repaint;
    if TDropComboTarget(Sender).Target = frmMainForm.FImporterTreeView then
      frmMainForm.FImporterTreeview.Repaint;
  end;
//23.08.2017 Ticket 10999 <--

end;

procedure TbfaPreview.SetActions;
var
  i: Integer;
  CanEnabled, SearchRight, ShowRight, ModifyRight, WriteRight, EmailRight,
  PrintRight, LinkRight, ImportRight, HistoryRight, MoveRight, AWriteRight,
  AReadRight, AModifyRight, APWriteRight, APReadRight, WFBreakRight,
  ListProtokollRight, AdminRight, DeleteRight, ExportRight, RevSaveRight,
  APModifyRight, haspreview, hasAnyPreview, bEnableExportMeta, hasMultiPageDocument: Boolean;
  Rights: Int64;
begin
  if not frmMainForm.fAppStarted then
    Exit;

  bitfarmLog.DebugBegin(llDebug, 'SetActions - ' + Self.Name, Classname);
  try
    try
    // macht Probleme beim Floating
//      if frmMainForm.bfaTlbStandard1 <> nil then
//        frmMainForm.bfaTlbStandard1.BeginUpdate;
//      if frmMainForm.bfaTlbPreview1 <> nil then
//        frmMainForm.bfaTlbPreview1.BeginUpdate;
//      if frmMainForm.tlbGraphic <> nil then
//        frmMainForm.tlbGraphic.BeginUpdate;
//      if frmMainForm.tlbTools <> nil then
//        frmMainForm.tlbTools.BeginUpdate;
//      if frmMainForm.tlbDocState <> nil then
//        frmMainForm.tlbDocState.BeginUpdate;
//      if frmMainForm.tlbStatefields <> nil then
//        frmMainForm.tlbStatefields.BeginUpdate;
//      if frmMainForm.tlbPlugins <> nil then
//        frmMainForm.tlbPlugins.BeginUpdate;

//      if bfaTlbStandard <> nil then
//        bfaTlbStandard.BeginUpdate;
//      if bfaTlbPreview <> nil then
//        bfaTlbPreview.BeginUpdate;
//      if bfaTlbImporter <> nil then
//        bfaTlbImporter.BeginUpdate;
//      if navigationToolBar <> nil then
//        navigationToolBar.BeginUpdate;
//      if PreviewSelectToolbar <> nil then
//        PreviewSelectToolbar.BeginUpdate;
//      if AnnoToolbar <> nil then
//        AnnoToolbar.BeginUpdate;

      if (High(aSysArc) > 0) and (bitfarmApp.CurrentArchive.Arcid > -1) and
        (bitfarmApp.CurrentArchive.Arcid <= High(aSysArc)) and (bitfarmApp.CurrentView <> tvkResub) then
        Rights := aSysArc[bitfarmApp.CurrentArchive.Arcid].Rights
      else
        Rights := 0;  // wenn wir ber die Wiedervorlage kommen, haben wir nur das Recht, welches mit dem Dokument kommt

      frmMainForm.actSave.Enabled := False;
      frmMainForm.actCancel.Enabled := frmMainForm.actSave.Enabled;
      frmMainForm.actReOCR.Enabled := (FActiveDoc <> nil) and (FActiveDoc.ID <> -1) and
        (bitfarmApp.CurrentView <> tvkAdministrator) and not bitfarmApp.OfflineMode;
      frmMainForm.actResetDLM.Enabled := False;
      frmMainForm.actResetDLM.Visible := False;
      frmMainForm.dteSearch.Enabled := True;
      frmMainForm.actSaveImportValues.Enabled := (bitfarmApp.CurrentView = tvkImporter);
      frmMainForm.actSaveImportValues.Visible := (bitfarmApp.CurrentView = tvkImporter);

      frmMainForm.actPreviewBack.Enabled := (FbfaPreviewKind = pvkMultiSingle);

      frmMainForm.actZoomIn1.Enabled := (FActiveDoc <> nil);
      frmMainForm.actZoomIn2.Enabled := (FActiveDoc <> nil);
      frmMainForm.actZoomOut1.Enabled := (FActiveDoc <> nil);
      frmMainForm.actZoomOut2.Enabled := (FActiveDoc <> nil);
      frmMainForm.actScrollLeft.Enabled := (FActiveDoc <> nil);
      frmMainForm.actScrollRight.Enabled := (FActiveDoc <> nil);
      frmMainForm.actScrollUp.Enabled := (FActiveDoc <> nil);
      frmMainForm.actScrollDown.Enabled := (FActiveDoc <> nil);

      actIsAuditProof.Enabled := (FActiveDoc <> nil);
      frmMainForm.actRefreshDoc.Enabled := (FActiveDoc <> nil) and (FActiveDoc.ID <> -1) and
        not bitfarmApp.OfflineMode;
      actEditTags.Enabled := (FActiveDoc <> nil) and (FActiveDoc.ID <> -1) and
        not bitfarmApp.OfflineMode;
      frmMainForm.mnuBookmarks.Enabled := (FActiveDoc <> nil) and (FActiveDoc.ID <> -1) and
        not bitfarmApp.OfflineMode; // Keine Action hinterlegt;
      frmMainForm.actCreateBookmarkForGDocID.Enabled := (FActiveDoc <> nil) and (FActiveDoc.ID <> -1) and
        not bitfarmApp.OfflineMode;
      frmMainForm.actGoToSourceArchive.Enabled := (FActiveDoc <> nil) and (FActiveDoc.ID <> -1);
      frmMainForm.actArchive.Enabled := (FActiveDoc <> nil) and (FActiveDoc.ID = -1) and
        not bitfarmApp.OfflineMode;

      actRangeOCR.Enabled := (FActiveDoc <> nil) and not bitfarmApp.OfflineMode;

      if FActiveDoc <> nil then
      begin
        haspreview := True;
        for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
        begin
          if not bitfarmApp.CurrentContainer[i].HasPreview then
          begin
            haspreview := False;
            Break;
          end;
        end;

        hasAnyPreview := False;
        for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
        begin
          if bitfarmApp.CurrentContainer[i].HasPreview then
          begin
            hasAnyPreview := True;
            Break;
          end;
        end;

        hasMultiPageDocument := False;
        for i := 0 to bitfarmApp.CurrentContainer.Count - 1 do
        begin
          if (bitfarmApp.CurrentContainer[i].PageCount > 1) then
          begin
            hasMultiPageDocument := True;
            Break;
          end;
        end;

        if FActiveDoc.SymbolicArcID = -1 then
          Rights := Rights or FActiveDoc.Rights;

        CanEnabled := ((FActiveDoc.HasPreview) or (FActiveDoc.ID = -1));
        SearchRight := (CanEnabled and ((Rights and rightList) = rightList));
        ShowRight := (CanEnabled and ((Rights and rightRead) = rightRead)) or
          (FActiveDoc.ID = -1);
        ModifyRight := ((CanEnabled and ((Rights and rightModify) = rightModify)) or (FActiveDoc.ID = -1)) and
          (FActiveDoc.CheckOutUserID = -1) or (FActiveDoc.CheckOutUserID = bitfarmApp.User.ID);
        WriteRight := (((Rights and rightWrite) = rightWrite)) or
          (FActiveDoc.ID = -1);
        EmailRight := (((Rights and rightEmail) = rightEmail)) or
          (FActiveDoc.ID = -1);
        PrintRight := (CanEnabled and ((Rights and rightPrint) = rightPrint)) or
          (FActiveDoc.ID = -1);
        LinkRight := (CanEnabled and ((Rights and rightLink) = rightLink)) or
          (FActiveDoc.ID = -1);
        ImportRight := (CanEnabled and ((Rights and rightImport) = rightImport));
        HistoryRight := (CanEnabled and ((Rights and rightHistory) = rightHistory));
        MoveRight := (CanEnabled and ((Rights and rightMove) = rightMove));
        AWriteRight := (CanEnabled and FActiveDoc.InEditMode and
          ((Rights and rightAWrite) = rightAWrite)) or (FActiveDoc.ID = -1);
        AReadRight := (CanEnabled and ((Rights and rightARead) = rightARead)) or
          (FActiveDoc.ID = -1);
        AModifyRight := (CanEnabled and FActiveDoc.InEditMode and
          ((Rights and rightAModify) = rightAModify)) or (FActiveDoc.ID = -1);
        APWriteRight := (CanEnabled and FActiveDoc.InEditMode and
          ((Rights and rightAPWrite) = rightAPWrite)) or (FActiveDoc.ID = -1);
        APReadRight := (CanEnabled and ((Rights and rightAPRead) = rightAPRead)) or
          (FActiveDoc.ID = -1);
        WFBreakRight := (CanEnabled and ((Rights and rightWFBreak) = rightWFBreak));
        ListProtokollRight := (CanEnabled and ((Rights and rightListProtokoll) = rightListProtokoll));
        AdminRight := (CanEnabled and ((Rights and rightAdmin) = rightAdmin));
        DeleteRight := (CanEnabled and ((Rights and rightDelete) = rightDelete));
        ExportRight := (CanEnabled and ((Rights and rightExport) = rightExport));
        RevSaveRight := (CanEnabled and ((Rights and rightRevSave) = rightRevSave));
        APModifyRight := (CanEnabled and ((Rights and rightAPModify) = rightAPModify)) or
          (FActiveDoc.ID = -1);

        bEnableExportMeta := (FActiveDoc.ID <> -1) and ExportRight and not bitfarmApp.OfflineMode;
        frmMainForm.mnuExportMeta.Enabled := bEnableExportMeta; // Das ist ein bergeordnetes Menu ohne Action
        frmMainForm.mnuExportMeta.Enabled := bEnableExportMeta;          // Das ist ein bergeordnetes Menu ohne Action
        frmMainForm.actExportCSV.Enabled := bEnableExportMeta;
        frmMainForm.actExportXLS.Enabled := bEnableExportMeta;
        frmMainForm.actExportOO.Enabled := bEnableExportMeta;
        frmMainForm.actResetDLM.Enabled := (bitfarmApp.User.isAdmin or AdminRight) and
          (FActiveDoc.ID <> -1) and not bitfarmApp.OfflineMode;
        frmMainForm.actResetDLM.Visible := (bitfarmApp.User.isAdmin or AdminRight) and
          (FActiveDoc.ID <> -1) and not bitfarmApp.OfflineMode;

        if FActiveDoc.InEditMode then
          frmMainForm.dteSearch.Enabled := (bitfarmApp.User.isAdmin or AdminRight) and
            (FActiveDoc.ID <> -1) and frmMainForm.tbiSoExpired.Checked
        else
          frmMainForm.dteSearch.Enabled := True;

        actInProgress.Enabled := ModifyRight;
        SetSaveAction(ModifyRight);

        frmMainForm.actDuplicateDoc.Enabled := ImportRight and (FActiveDoc.ID <> -1) and not bitfarmApp.OfflineMode;

        actPreviousPage.Enabled := ((ShowRight) or
          (((FActiveDoc.ScanPoolView <> nil) and
          (FActiveDoc.ScanPoolViewLoaded) and (FActiveDoc.ScanPoolView.ImageCount > 1)) or
          (FimgSingleView.img_DocView.IO.Params.ImageCount > 1))) and (FbfaPreviewKind <> pvkMulti);
        actNextPage.Enabled := ((ShowRight) or
          (((FActiveDoc.ScanPoolView <> nil) and
          (FActiveDoc.ScanPoolViewLoaded) and (FActiveDoc.ScanPoolView.ImageCount > 1)) or
          (FimgSingleView.img_DocView.IO.Params.ImageCount > 1))) and (FbfaPreviewKind <> pvkMulti);
        actFirstPage.Enabled := ((ShowRight) or
          (((FActiveDoc.ScanPoolView <> nil) and
          (FActiveDoc.ScanPoolViewLoaded) and (FActiveDoc.ScanPoolView.ImageCount > 1)) or
          (FimgSingleView.img_DocView.IO.Params.ImageCount > 1))) and (FbfaPreviewKind <> pvkMulti);
        actLastPage.Enabled := ((ShowRight) or
          (((FActiveDoc.ScanPoolView <> nil) and
          (FActiveDoc.ScanPoolViewLoaded) and (FActiveDoc.ScanPoolView.ImageCount > 1)) or
          (FimgSingleView.img_DocView.IO.Params.ImageCount > 1))) and (FbfaPreviewKind <> pvkMulti);
        actStationery.Enabled := (bfaTlbPreview.sbmStationery.Count > 0) and (FActiveDoc.HasPreview);
        actAutozoom.Enabled := ShowRight and (FbfaPreviewKind <> pvkMulti);
        actZoom100.Enabled := ShowRight and (FbfaPreviewKind <> pvkMulti);
        actZoomPage.Enabled := ShowRight and (FbfaPreviewKind <> pvkMulti);
        actZoomWidth.Enabled := ShowRight and (FbfaPreviewKind <> pvkMulti);
        actZoomHeight.Enabled := ShowRight and (FbfaPreviewKind <> pvkMulti);
        actZoomSelect.Enabled := ShowRight and (FbfaPreviewKind <> pvkMulti);
        actZoomOff.Enabled := ShowRight and (FbfaPreviewKind <> pvkMulti);
        actRotateLeft.Enabled := ((FActiveDoc.ID = -1) or (FActiveDoc.InEditMode and ModifyRight)) and (FActiveDoc.HasPreview);
        actRotateRight.Enabled := ((FActiveDoc.ID = -1) or (FActiveDoc.InEditMode and ModifyRight)) and (FActiveDoc.HasPreview);
        actFlip.Enabled := ((FActiveDoc.ID = -1) or (FActiveDoc.InEditMode and ModifyRight)) and (FActiveDoc.HasPreview);
        actInverted.Enabled := ((FActiveDoc.ID = -1) or (FActiveDoc.InEditMode and ModifyRight)) and (FActiveDoc.HasPreview);
        actDeScrew.Enabled := ((FActiveDoc.ID = -1) or (FActiveDoc.InEditMode and ModifyRight)) and (FActiveDoc.HasPreview);
        actDeSpeckle.Enabled := ((FActiveDoc.ID = -1) or (FActiveDoc.InEditMode and ModifyRight)) and (FActiveDoc.HasPreview);
        actRemoveBorder.Enabled := ((FActiveDoc.ID = -1) or (FActiveDoc.InEditMode and ModifyRight)) and (FActiveDoc.HasPreview);
        actCopyDocToClipboard.Enabled := WriteRight;
        actCopyOriginalDocToClipboard.Enabled := (FActiveDoc.OriLoc <> '') and WriteRight;
        actCopyPageToClipboard.Enabled := WriteRight;
        actCopyDocLinkToClipboard.Enabled := (FActiveDoc.ID <> -1);
        frmMainForm.actShareLayer.Enabled := FActiveDoc.InEditMode and (not bitfarmApp.OfflineMode) and (FbfaPreviewKind <> pvkMulti);

        if (FActiveDoc.ID <> -1) and (FActiveDoc.SymbolicArcID >= 0) then
        begin
          // Suchen UND Anzeigen Recht
          frmMainForm.actGoToOriginalDocument.Enabled := (FActiveDoc.ArcID <= High(aSysArc)) and
                                                         ((aSysArc[FActiveDoc.ArcID].Rights and 3) = 3);
        end
        // --> bfacrm:ticket__show__23984 (+ bfacrm:ticket__show__33512 -> <>tvkImporter)
        else if (FActiveDoc.ArcID <> bitfarmApp.CurrentArchive.Arcid) and (bitfarmApp.CurrentView <> tvkImporter) then
          frmMainForm.actGoToOriginalDocument.Enabled := True
        else
          frmMainForm.actGoToOriginalDocument.Enabled := False;
        // <-- bfacrm:ticket__show__23984

        actAuditProof.Enabled := (FActiveDoc.ID <> -1) and ((FActiveDoc.InEditMode and RevSaveRight) or ActiveDoc.RevSave) and not bitfarmApp.OfflineMode;
        actDeleteDoc.Enabled := (FActiveDoc.ID <> -1) and
          DeleteRight and (not FActiveDoc.RevSave) and (not FActiveDoc.InEditMode) and
          (FActiveDoc.CheckOutUserID = -1) and (not bitfarmApp.OfflineMode);

        actFtxPos.Enabled := False;
        {$IFDEF ENTERPRISE}
        TfrmEnterprise(frmMainForm).actDeleteAbo.Enabled := (FActiveDoc <> nil) and
        (FActiveDoc.AboUserid.Count > 0) and (FActiveDoc.AboUserid.IndexOf(IntToStr(bitfarmApp.User.ID)) > -1);
        TfrmEnterprise(frmMainForm).actDeleteAbo.Visible := (FActiveDoc <> nil) and
        (FActiveDoc.AboUserid.Count > 0) and (FActiveDoc.AboUserid.IndexOf(IntToStr(bitfarmApp.User.ID)) > -1);
        actDocAbo.Enabled := ShowRight and (not bitfarmApp.OfflineMode) and (FbfaPreviewKind = pvkSingle);
        frmMainForm.actCreateSymbolicLinkInImporter.Enabled := (FActiveDoc.ID <> -1);
        frmMainForm.actShowAllSymbolicLinks.Enabled := (FActiveDoc.ID <> -1) and (FActiveDoc.HasSymlinks <> '');
        frmMainForm.actDeleteSymbolicLink.Enabled := (FActiveDoc.ID <> -1) and
          (FActiveDoc.SymbolicArcID >= 0) and (FActiveDoc.SymbolicArcID <> FActiveDoc.ArcID) and
          not bitfarmApp.OfflineMode;
        {$ENDIF}

        frmMainForm.actResubCreate.Enabled := (FActiveDoc.ID <> -1) and not bitfarmApp.OfflineMode;

        frmMainForm.actMergeDoc.Enabled := ShowRight and (FbfaPreviewKind = pvkMulti) and
          (FimgMultiView.MultiSelectedImagesCount > 1) and haspreview;
        frmMainForm.actWPGroup.Enabled := ShowRight and (FbfaPreviewKind = pvkMulti) and
          (FimgMultiView.MultiSelectedImagesCount > 1) and haspreview;
        frmMainForm.actWPUnGroup.Enabled := ShowRight and (FbfaPreviewKind = pvkMulti) and
          hasPreview and hasMultiPageDocument; // auch in TForm1.ppmToolsPopup
        frmMainForm.fraResub.btnResubCancel.Enabled := WFBreakRight and
          (frmMainForm.fraResub.DelegateView <> 3) and not bitfarmApp.OfflineMode;
        actRestoreOriginal.Enabled := (FActiveDoc.ID <> -1) and
          ModifyRight and (FActiveDoc.ExtLoc <> '')  and not bitfarmApp.OfflineMode;

        actPrintStandard.Enabled := PrintRight and (FActiveDoc.HasPreview);
        actPrintPreview.Enabled := PrintRight and (FActiveDoc.HasPreview);
        actLocalSavePDF.Enabled := WriteRight and (FActiveDoc.HasPreview);
        actLocalSaveTIF.Enabled := WriteRight and (FActiveDoc.HasPreview) and (bitfarmApp.CurrentView <> tvkAdministrator);
        //08.07.2024 SD -->bfacrm:ticket__show__39237 -> 13.09.2024 SD -->bfacrm:ticket__show__39948 zurck
        actLocalSaveOriginal.Enabled := WriteRight and (FActiveDoc.OriLoc <> '');
//        actLocalSaveOriginal.Enabled := WriteRight and ((FActiveDoc.OriLoc <> '') or (FActiveDoc.FileType = '.tif') or (FActiveDoc.FileType = '.tiff'));
        //08.07.2024 SD <--bfacrm:ticket__show__39237 -> 13.09.2024 SD -->bfacrm:ticket__show__39948 zurck
        actLocalSaveLink.Enabled := WriteRight and (FActiveDoc.HasPreview) and (FActiveDoc.ID <> -1);
        actLocalSavePreview.Enabled := WriteRight and (FActiveDoc.HasPreview);
        actEmailPreview.Enabled := EmailRight and (FActiveDoc.HasPreview);
        actEmailTIFAttachment.Enabled := EmailRight and (FActiveDoc.HasPreview);
        actEmailPDFAttachment.Enabled := EmailRight and (FActiveDoc.HasPreview);
        actEmailOriginal.Enabled := EmailRight and (FActiveDoc.OriLoc <> '');
        actEmailLink.Enabled := EmailRight and (FActiveDoc.ID <> -1);
        //29.07.2022 Ticket 28973 -->
        frmMainForm.actSaveCollectionPDF.Enabled := actLocalSavePDF.Enabled;
        frmMainForm.actSaveCollectionSinglePDF.Enabled := actLocalSavePDF.Enabled;
        frmMainForm.actSaveCollectionTIF.Enabled := actLocalSaveTIF.Enabled;
        frmMainForm.actSaveCollectionOriginal.Enabled := actLocalSaveOriginal.Enabled;
        frmMainForm.actEmailCollectionPDF.Enabled := actEmailPDFAttachment.Enabled;
        frmMainForm.actEmailCollectionSinglePDF.Enabled := actEmailPDFAttachment.Enabled;
        frmMainForm.actEmailCollectionTIF.Enabled := actEmailTIFAttachment.Enabled;
        frmMainForm.actEmailCollectionOriginal.Enabled := actEmailOriginal.Enabled;
        //29.07.2022 Ticket 28973 <--
        //01.10.2024 SD -->bfacrm:ticket__show__40151 das Senden an den Importer und Arbeitsplatz hngt von der Schreiben-Erlaubnis ab
        actSendDocumentsToWorkplace.Enabled := ShowRight and WriteRight;
        actSendCopyToWorkplace.Enabled := ShowRight and WriteRight;
        actSendPagesToWorkplace.Enabled := ShowRight and WriteRight;
        actSendPagesMergedToWorkplace.Enabled := ShowRight and WriteRight;
        actCreateCopy.Enabled := ShowRight and (not bitfarmApp.OfflineMode) and WriteRight;
        actSendDocumentsToImporter.Enabled := ShowRight and (not bitfarmApp.OfflineMode) and WriteRight;
//        actSendDocumentPreviewsToImport.Enabled := ShowRight and (not bitfarmApp.OfflineMode) and (ActiveDoc.OriLoc <> '') and WriteRight;
        actSendDocumentPreviewsToImport.Enabled := ShowRight and (not bitfarmApp.OfflineMode) and WriteRight;
        actSendPagesToImporter.Enabled := ShowRight and (not bitfarmApp.OfflineMode) and WriteRight;
        actSendPagesMergedToImporter.Enabled := ShowRight and (not bitfarmApp.OfflineMode) and WriteRight;
        //01.10.2024 SD <--bfacrm:ticket__show__40151

        frmMainForm.actUndockInNewTab.Enabled := ((ShowRight and hasAnyPreview) and (Floating or (Self.Parent.Tag <= pvtWorkplace)))
          or (frmMainForm.ppmToolsPopupInResultGrid and (bitfarmApp.CurrentContainer.Count > 0));
        // Documents in CurrentContainer wont be loaded @Grid - so we have no information about HasPreview
        // we will enable the action, anyway there may be the case no document has a preview
        // in that case there will be a dialog, saying that the document could not be loaded
        frmMainForm.actUndockInNewWindow.Enabled := ((ShowRight and hasAnyPreview) and ((not Floating) or (Self.Parent.Tag <= pvtWorkplace)))
          or ((not Floating) and frmMainForm.ppmToolsPopupInResultGrid and (bitfarmApp.CurrentContainer.Count > 0));

        frmMainForm.actRemoveLink.Enabled := (FActiveDoc.ID <> -1) and LinkRight and not bitfarmApp.OfflineMode;
        frmMainForm.actDeleteLink.Enabled := (FActiveDoc.ID <> -1) and LinkRight and
          (not bitfarmApp.OfflineMode) and bitfarmApp.User.isAdmin;
        actDeleteSelected.Enabled := (FList.Count > 0) and (FbfaPreviewKind <> pvkSingle);
        frmMainForm.actDeleteSelected.Enabled := actDeleteSelected.Enabled; //16.09.2022 Ticket 32287

        actAutoRef.Enabled := (FActiveDoc.ID <> -1) and LinkRight and
          (bitfarmApp.CurrentView <> tvkAdministrator) and not bitfarmApp.OfflineMode;
        actNewLink.Enabled := (FActiveDoc.ID <> -1) and LinkRight and
          (bitfarmApp.CurrentView <> tvkAdministrator) and not bitfarmApp.OfflineMode;
        actAddLink.Enabled := (FActiveDoc.ID <> -1) and not bitfarmApp.OfflineMode and
          (bitfarmApp.CurrentView <> tvkAdministrator) and LinkRight and
          ((frmMainForm.fraDocLinks <> nil) and (frmMainForm.fraDocLinks.LastLink <> ''));
        actChangeDocName.Enabled := ((FActiveDoc.ID = -1) or ModifyRight) and not bitfarmApp.OfflineMode and (FActiveDoc.CheckOutUserID = -1) ;
        actDeletePages.Enabled := (FList.Count > 0) and (FActiveDoc.ID = -1) and FActiveDoc.HasPreview  and
          (previewToolWindow.Visible) and not bitfarmApp.OfflineMode;

        if not FActiveDoc.InEditMode and (CanEnabled) and
          (FimgSingleView.img_DocView.IO.Params.ImageCount > 0) and
          (tbi_normalmouse.Enabled) then
        begin
          tbi_normalmouse.Checked := True;
          UnCheckAllGraphicTools;
        end;

        previewSelectToolbar.Enabled := True;
        FimgSingleView.Enabled := True;
        frmMainForm.bfaTlbPreview1.edtPageNumber.ReadOnly := (FbfaPreviewKind = pvkMulti); // SJ 13.10.2021

        SetAnnoToolBar((AReadRight and
          (FbfaTlbPreview.mnuPublicAnno.Checked or FbfaTlbPreview.mnuPrivateAnno.Checked)) or
          (FActiveDoc.ID = -1));
        SearchToolbarSetState;
        //bfacrm:ticket__show__21312
        if not FActiveDoc.InEditMode then
          frmMainForm.dteSearch.Rights := cAddfieldModify
        else if FActiveDoc.InEditMode and AdminRight then
          frmMainForm.dteSearch.Rights := cAddfieldModify
        else if FActiveDoc.InEditMode and (not AdminRight) then
          frmMainForm.dteSearch.Rights := cAddfieldRead;
        //bfacrm:ticket__show__21312

      end else  // FActiveDoc = nil
      begin
        actPrintStandard.Enabled := False;
        actPrintPreview.Enabled := False;
        actLocalSavePDF.Enabled := False;
        actLocalSaveTIF.Enabled := False;
        actLocalSaveOriginal.Enabled := False;
        actLocalSaveLink.Enabled := False;
        actLocalSavePreview.Enabled := False;
        actEmailPreview.Enabled := False;
        actEmailTIFAttachment.Enabled := False;
        actEmailPDFAttachment.Enabled := False;
        actEmailOriginal.Enabled := False;
        actEmailLink.Enabled := False;
        //29.07.2022 Ticket 28973 -->
        frmMainForm.actSaveCollectionPDF.Enabled := False;
        frmMainForm.actSaveCollectionSinglePDF.Enabled := False;
        frmMainForm.actSaveCollectionTIF.Enabled := False;
        frmMainForm.actSaveCollectionOriginal.Enabled := False;
        frmMainForm.actEmailCollectionPDF.Enabled := False;
        frmMainForm.actEmailCollectionSinglePDF.Enabled := False;
        frmMainForm.actEmailCollectionTIF.Enabled := False;
        frmMainForm.actEmailCollectionOriginal.Enabled := False;
        //29.07.2022 Ticket 28973 <--
        actSendDocumentsToWorkplace.Enabled := False;
        actSendCopyToWorkplace.Enabled := False;
        actSendPagesToWorkplace.Enabled := False;
        actSendPagesMergedToWorkplace.Enabled := False;
        actCreateCopy.Enabled := False;
        actSendDocumentsToImporter.Enabled := False;
        actSendDocumentPreviewsToImport.Enabled := False;
        actSendPagesToImporter.Enabled := False;
        actSendPagesMergedToImporter.Enabled := False;
        actIsAuditProof.Enabled := False;
        actRangeOCR.Enabled := False;
        actAutoRef.Enabled := False;
        actNewLink.Enabled := False;
        actAddLink.Enabled := False;
//        actChangeDocName.Enabled := False; //bfacrm:ticket__show__30572
        actDeletePages.Enabled := False;
        actInProgress.Enabled := False;
        actPreviousPage.Enabled := False;
        actNextPage.Enabled := False;
        actFirstPage.Enabled := False;
        actLastPage.Enabled := False;
        actStationery.Enabled := False;
        actAutozoom.Enabled := False;
        actZoom100.Enabled := False;
        actZoomPage.Enabled := False;
        actZoomWidth.Enabled := False;
        actZoomHeight.Enabled := False;
        actZoomSelect.Enabled := False;
        actZoomOff.Enabled := False;
        actRotateLeft.Enabled := False;
        actRotateRight.Enabled := False;
        actFlip.Enabled := False;
        actInverted.Enabled := False;
        actDeScrew.Enabled := False;
        actDeSpeckle.Enabled := False;
        actRemoveBorder.Enabled := False;
        actCopyDocToClipboard.Enabled := False;
        actCopyOriginalDocToClipboard.Enabled := False;
        actCopyPageToClipboard.Enabled := False;
        actCopyDocLinkToClipboard.Enabled := False;
        actShareLayer.Enabled := False;
        actAuditProof.Enabled := False;
        actFtxPos.Enabled := False;
        {$IFDEF ENTERPRISE}
          actDocAbo.Enabled := False;
        {$ENDIF}
        actGoToOriginalDocument.Enabled := False;
        actRestoreOriginal.Enabled := False;

        frmMainForm.actUndockInNewTab.Enabled := False;
        frmMainForm.actUndockInNewWindow.Enabled := False;
        frmMainForm.dteSearch.Rights := cAddfieldModify;
//        frmMainForm.dteSearch.Rights := cAddfieldRead; //bfacrm:ticket__show__21312

        if not Floating then
        begin
          frmMainForm.DisableMainFormActions;
          SetAnnoToolbar(False);
          previewSelectToolbar.Enabled := False;
          FimgSingleView.Enabled := False;
          frmMainForm.actDeleteSelected.Enabled := False or
            ((Self = bitfarmApp.PreviewContainer.WorkplaceItem.Preview) and (FList.Count > 0));
        end;
      end;

      if not Floating then
      begin
        frmMainForm.actPrintStandard.Enabled := actPrintStandard.Enabled;
        frmMainForm.actPrintPreview.Enabled := actPrintPreview.Enabled;
        frmMainForm.actLocalSavePDF.Enabled := actLocalSavePDF.Enabled;
        frmMainForm.actLocalSaveTIF.Enabled := actLocalSaveTIF.Enabled;
        frmMainForm.actLocalSaveOriginal.Enabled := actLocalSaveOriginal.Enabled;
        frmMainForm.actLocalSaveLink.Enabled := actLocalSaveLink.Enabled;
        frmMainForm.actLocalSavePreview.Enabled := actLocalSavePreview.Enabled;
        frmMainForm.actEmailPreview.Enabled := actEmailPreview.Enabled;
        frmMainForm.actEmailTIFAttachment.Enabled := actEmailTIFAttachment.Enabled;
        frmMainForm.actEmailPDFAttachment.Enabled := actEmailPDFAttachment.Enabled;
        frmMainForm.actEmailOriginal.Enabled := actEmailOriginal.Enabled;
        frmMainForm.actEmailLink.Enabled := actEmailLink.Enabled;
        //29.07.2022 Ticket 28973 -->
        frmMainForm.actSaveCollectionPDF.Enabled := actLocalSavePDF.Enabled;
        frmMainForm.actSaveCollectionSinglePDF.Enabled := actLocalSavePDF.Enabled;
        frmMainForm.actSaveCollectionTIF.Enabled := actLocalSaveTIF.Enabled;
        frmMainForm.actSaveCollectionOriginal.Enabled := actLocalSaveOriginal.Enabled;
        frmMainForm.actEmailCollectionPDF.Enabled := actEmailPDFAttachment.Enabled;
        frmMainForm.actEmailCollectionSinglePDF.Enabled := actEmailPDFAttachment.Enabled;
        frmMainForm.actEmailCollectionTIF.Enabled := actEmailTIFAttachment.Enabled;
        frmMainForm.actEmailCollectionOriginal.Enabled := actEmailOriginal.Enabled;
        //29.07.2022 Ticket 28973 <--
        frmMainForm.SetCollectionsCaptions; //17.09.2024 SD -->bfacrm:ticket__show__39945
        frmMainForm.actSendDocumentsToWorkplace.Enabled := actSendDocumentsToWorkplace.Enabled;
        frmMainForm.actSendCopyToWorkplace.Enabled := actSendCopyToWorkplace.Enabled;
        frmMainForm.actSendPagesToWorkplace.Enabled := actSendPagesToWorkplace.Enabled;
        frmMainForm.actSendPagesMergedToWorkplace.Enabled := actSendPagesMergedToWorkplace.Enabled;
        frmMainForm.actCreateCopy.Enabled := actCreateCopy.Enabled;
        frmMainForm.actSendDocumentsToImporter.Enabled := actSendDocumentsToImporter.Enabled;
        frmMainForm.actSendDocumentPreviewsToImport.Enabled := actSendDocumentPreviewsToImport.Enabled;
        frmMainForm.actSendPagesToImporter.Enabled := actSendPagesToImporter.Enabled;
        frmMainForm.actSendPagesMergedToImporter.Enabled := actSendPagesMergedToImporter.Enabled;

        frmMainForm.actInProgress.Enabled := actInProgress.Enabled;
        frmMainForm.actIsAuditProof.Enabled := actIsAuditProof.Enabled;
        frmMainForm.actEditTags.Enabled := actEditTags.Enabled;
        frmMainForm.actPreviousPage.Enabled := actPreviousPage.Enabled;
        frmMainForm.actNextPage.Enabled := actNextPage.Enabled;
        frmMainForm.actFirstPage.Enabled := actFirstPage.Enabled;
        frmMainForm.actLastPage.Enabled := actLastPage.Enabled;
        frmMainForm.actStationery.Enabled := actStationery.Enabled;
        frmMainForm.actAutozoom.Enabled := actAutozoom.Enabled;
        frmMainForm.actZoom100.Enabled := actZoom100.Enabled;
        frmMainForm.actZoomPage.Enabled := actZoomPage.Enabled;
        frmMainForm.actZoomWidth.Enabled := actZoomWidth.Enabled;
        frmMainForm.actZoomHeight.Enabled := actZoomHeight.Enabled;
        frmMainForm.actZoomSelect.Enabled := actZoomSelect.Enabled;
        frmMainForm.actZoomOff.Enabled := actZoomOff.Enabled;
        frmMainForm.actPublicAnno.Enabled := actPublicAnno.Enabled;
        frmMainForm.actPrivateAnno.Enabled := actPrivateAnno.Enabled;
        frmMainForm.actDeletePages.Enabled := actDeletePages.Enabled;
        // <!-- SJ 05.05.2022 - bfacrm:ticket__show__28731
        // nach unten verschoben. Egal ob Floating oder nicht, Preview-Action auf MainForm anwenden
//        frmMainForm.actRotateLeft.Enabled := actRotateLeft.Enabled;
//        frmMainForm.actRotateRight.Enabled := actRotateRight.Enabled;
//        frmMainForm.actFlip.Enabled := actFlip.Enabled;
//        frmMainForm.actInverted.Enabled := actInverted.Enabled;
//        frmMainForm.actDeScrew.Enabled := actDeScrew.Enabled;
//        frmMainForm.actDeSpeckle.Enabled := actDeSpeckle.Enabled;
//        frmMainForm.actRemoveBorder.Enabled := actRemoveBorder.Enabled;
        // SJ 05.05.2022 - bfacrm:ticket__show__28731 -->
        frmMainForm.actShareLayer.Enabled := actShareLayer.Enabled;
        frmMainForm.actDeleteDoc.Enabled := actDeleteDoc.Enabled;
        frmMainForm.actAuditProof.Enabled := actAuditProof.Enabled;
        frmMainForm.actFtxPos.Enabled := actFtxPos.Enabled;
        {$IFDEF ENTERPRISE}
        TfrmEnterprise(frmMainForm).actDocAbo.Enabled := actDocAbo.Enabled;
        {$ENDIF}
        frmMainForm.actEditTags.Enabled := actEditTags.Enabled;
        frmMainForm.actCopyDocToClipboard.Enabled := actCopyDocToClipboard.Enabled;
        frmMainForm.actCopyOriginalDocToClipboard.Enabled := actCopyOriginalDocToClipboard.Enabled;
        frmMainForm.actCopyPageToClipboard.Enabled := actCopyPageToClipboard.Enabled;
        frmMainForm.actCopyDocLinkToClipboard.Enabled := actCopyDocLinkToClipboard.Enabled;
        frmMainForm.actChangeDocName.Enabled := actChangeDocName.Enabled;
//        frmMainForm.actRefreshDoc.Enabled := actRefreshDoc.Enabled; // bfacrm:ticket__show__29424
        frmMainForm.actAutoRef.Enabled := actAutoRef.Enabled;
        frmMainForm.actNewLink.Enabled := actNewLink.Enabled;
        frmMainForm.actAddLink.Enabled := actAddLink.Enabled;
        frmMainForm.actRestoreOriginal.Enabled := actRestoreOriginal.Enabled;

        // SJ 12.06.2023 Hier auch noch SetBlueArrorws?

        bitfarmApp.SetAnnoLayer(FActiveDoc, Self);

        // mgliche Actions mit .Tag = 1
        // es sollte immer nur ein .Tag = 1 sein...
        //   frmMainForm.actLocalSavePDF
        //   frmMainForm.actLocalSaveTIF
        //   frmMainForm.actLocalSaveOriginal
        //   frmMainForm.actLocalSavePreview
        //   frmMainForm.actLocalSaveLink


        // actLocalSaveOriginal without Orifile. PDF oder TIF je nach Viewer-Option
//        if frmMainForm.actLocalSaveOriginal.Tag = 1 then
        // actLocalSaveTIF without Preview. Orifile
        // actLocalSaveTIF, actLocalSavePDF, actLocalSavePreview without Preview. Orifile
        // actLocalSaveLink with GDocID -1. PDF/TIF nach Option

        //17.09.2024 SD -->bfacrm:ticket__show__39948 Korrektur
//        // <!-- wir haben speichern mit Orifile, aber keine Orifile. PDF oder TIF je nach Viewer-Option
//        if (frmMainForm.actLocalSaveOriginal.Tag = 1) and
//           (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave <> nil) and
//           (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action <> nil) and
//           (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action.Name = 'actLocalSaveOriginal') and
//           (not actLocalSaveOriginal.Enabled) and (FActiveDoc <> nil) then
//        begin
//          if bitfarmApp.ViewerOptions.GeneralOptions.ExportPDF then
//            FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSavePDF
//          else
//            FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSaveTIF;
//        end
//        // wir haben speichern mit Orifile, aber keine Orifile. PDF oder TIF je nach Viewer-Option --!>
//
//        // <!-- wir haben TIF speichern, aber keine Voransicht. Originaldatei
//        else if (frmMainForm.actLocalSaveTIF.Tag = 1) and (not actLocalSaveTIF.Enabled) and
//                (FActiveDoc <> nil) and (not FActiveDoc.HasPreview) and
//                (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave <> nil) and
//                (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action <> nil) and
//                (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action.Name = 'actLocalSaveTIF') then
//        begin
//          if frmMainForm.actLocalSaveOriginal.Enabled then
//            FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSaveOriginal;
//        end
//        // wir haben TIF speichern, aber keine Voransicht. Originaldatei --!>
//
//        else if (frmMainForm.actLocalSaveOriginal.Tag = 1) and (actLocalSaveOriginal.Enabled) and
//                (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave <> nil) and
//                (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action <> nil) and
//                (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action.Name <> 'actEmailOriginal')  then
//          begin
//          // MainForm wird weiter unten gleich gesetzt
//          FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSaveOriginal;
//        end else if (FActiveDoc = nil) then
        // <!-- wir haben speichern mit Orifile
        if (FActiveDoc <> nil) and
            (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave <> nil) and
            (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action <> nil) then
        begin
          if (frmMainForm.actLocalSaveOriginal.Tag = 1) then
          begin
            if (actLocalSaveOriginal.Enabled) then
            begin
              if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action <> actLocalSaveOriginal then
                FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSaveOriginal
            end
            else
              if bitfarmApp.ViewerOptions.GeneralOptions.ExportPDF then
                FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSavePDF
              else
                FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSaveTIF
          end
          else
          begin
            if (frmMainForm.actLocalSaveTIF.Tag = 1) and
               (actLocalSaveTIF.Enabled) then
            begin
              if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action <> actLocalSaveTIF then
                FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSaveTIF
            end
            else if (frmMainForm.actLocalSavePDF.Tag = 1) and
               (actLocalSavePDF.Enabled) then
            begin
                if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action <> actLocalSavePDF then
                  FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSavePDF
            end
            else if (actLocalSaveOriginal.Enabled) and
              (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action <> actLocalSaveOriginal) then
              FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSaveOriginal
            //20.09.2024 BT hier fehlt noch else -->
            else
              FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSaveTIF;
            //20.09.2024 BT <--
          end
        end
        else
        //17.09.2024 SD <--bfacrm:ticket__show__39948 Korrektur
        begin
          // bei Reset setzen wir die alte Einstellung
          if frmMainForm.actLocalSavePDF.Tag = 1 then
            FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSavePDF
          else if frmMainForm.actLocalSaveTIF.Tag = 1 then
            FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSaveTIF
          else if frmMainForm.actLocalSaveOriginal.Tag = 1 then
              FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSaveOriginal
          else if frmMainForm.actLocalSavePreview.Tag = 1 then
            FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSavePreview
          else if frmMainForm.actLocalSaveLink.Tag = 1 then
            FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSaveLink
          //20.09.2024 BT hier fehlt noch else -->
          else
            FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSaveTIF;
          //20.09.2024 BT <--
        end;

        // folgendes Problem:
        // - wir wollen uns die letzte Einstellung merken. Wenn aber actEmailOriginal
        //   eingestellt ist, kann es sein dass keine Originaldatei vorliegt. Da das ganze an
        //   Actions gebunden ist, wre das ganze SubmenuItem disabled und auch die DropDown-Liste
        //   nicht mehr erreichbar. Setzen wir die Action jetzt stumpf neu, geht die Information
        //   verloren welche Action gesetzt war. Also setzen wir bei der letzten bewusst gesetzten
        //   Action den Tag der MainForm-Action auf 1.
        // - wenn der Tag nicht 1 ist, dann haben wir die Auswahl gendert, damit oben genannter
        //   Fall nicht eintritt. Das geht halt, weil wir nur eine Option haben die deaktiviert werden knnte.
        // ( - Sollte der Endanwender zwischenzeitig eine andere Option anklicken (zB actEmailTIFAttachment),
        //   ist dieser die neue gesetzte Option )
        // - ansonsten (wenn keine Orifile vorliegt) switchen wir zwischen actEmailOriginal und dem sonstigen Standard
        //   je nach Option actEmailTIFAttachment oder actEmailPDFAttachment
        //
        // mgliche Actions mit .Tag = 1
        // es sollte immer nur ein .Tag = 1 sein...
        //   frmMainForm.actEmailTIFAttachment
        //   frmMainForm.actEmailPDFAttachment
        //   frmMainForm.actEmailOriginal
        //   frmMainForm.actEmailLink
        //   frmMainForm.actEmailPreview


        //17.09.2024 SD -->bfacrm:ticket__show__39948 Korrektur
//        // <!-- wir haben Email mit Orifile, aber keine Orifile. PDF oder TIF je nach Viewer-Option
//        if (frmMainForm.actEmailOriginal.Tag = 1) and
//           (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action <> nil) and
//           (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action.Name = 'actEmailOriginal') and
//           (not actEmailOriginal.Enabled) and (FActiveDoc <> nil) then
//        begin
//          if bitfarmApp.ViewerOptions.GeneralOptions.ExportPDF then
//            FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailPDFAttachment
//          else
//            FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailTIFAttachment;
//        end
//        // wir haben Email mit Orifile, aber keine Orifile. PDF oder TIF je nach Viewer-Option --!>
//
////        // <!-- wir haben Email mit Orifile, aber keine Orifile. PDF oder TIF je nach Viewer-Option
////        if (frmMainForm.actEmailOriginal.Tag = 1) and
////           (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action <> nil) and
////           (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action.Name = 'actEmailOriginal') and
////           (not actEmailOriginal.Enabled) and (FActiveDoc <> nil) then
////        begin
////          if bitfarmApp.ViewerOptions.GeneralOptions.ExportPDF then
////            FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailPDFAttachment
////          else
////            FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailTIFAttachment;
////        end
////        // wir haben Email mit Orifile, aber keine Orifile. PDF oder TIF je nach Viewer-Option --!>
//
//        else if (frmMainForm.actEmailOriginal.Tag = 1) and (actEmailOriginal.Enabled) and
//                (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action.Name <> 'actEmailOriginal')  then
//          begin
//          // MainForm wird weiter unten gleich gesetzt
//          FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailOriginal;
//        end else if (FActiveDoc = nil) then
        if (FActiveDoc <> nil) and
            (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail <> nil) and
            (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action <> nil) then
        begin
          if (frmMainForm.actEmailOriginal.Tag = 1) then
          begin
            if (actEmailOriginal.Enabled) then
            begin
              if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action <> actEmailOriginal then
                FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailOriginal
            end
            else
              if bitfarmApp.ViewerOptions.GeneralOptions.ExportPDF then
                FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailPDFAttachment
              else
                FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailTIFAttachment
          end
          else
          begin
            if (frmMainForm.actEmailTIFAttachment.Tag = 1) and
               (actEmailTIFAttachment.Enabled) then
            begin
              if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action <> actEmailTIFAttachment then
                FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailTIFAttachment
            end
            else if (frmMainForm.actEmailPDFAttachment.Tag = 1) and
               (actEmailPDFAttachment.Enabled) then
            begin
                if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action <> actEmailPDFAttachment then
                  FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailPDFAttachment
            end
            else if (actEmailOriginal.Enabled) and
              (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action <> actEmailOriginal) then
              FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailOriginal
            //20.09.2024 BT hier fehlt noch else -->
            else
              FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailTIFAttachment;
            //20.09.2024 BT <--

          end
        end
        else
        //17.09.2024 SD <--bfacrm:ticket__show__39948 Korrektur
        begin
          // bei Reset setzen wir die alte Einstellung
          if frmMainForm.actEmailTIFAttachment.Tag = 1 then
            FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailTIFAttachment
          else if frmMainForm.actEmailPDFAttachment.Tag = 1 then
            FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailPDFAttachment
          else if frmMainForm.actEmailOriginal.Tag = 1 then
              FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailOriginal
          else if frmMainForm.actEmailLink.Tag = 1 then
            FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailLink
          else if frmMainForm.actEmailPreview.Tag = 1 then
            FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailPreview
          //20.09.2024 BT hier fehlt noch else -->
          else
            FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailTIFAttachment;
          //20.09.2024 BT <--
        end;


        // mgliche Actions mit .Tag = 1
        // es sollte immer nur ein .Tag = 1 sein...
        //   frmMainForm.actCopyDocToClipboard
        //   frmMainForm.actCopyOriginalDocToClipboard
        //   frmMainForm.actCopyPageToClipboard
        //   frmMainForm.actCopyDocLinkToClipboard

        if (frmMainForm.actCopyOriginalDocToClipboard.Tag = 1) and
           (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action <> nil) and
           (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action.Name = 'actCopyOriginalDocToClipboard') and
           (not actCopyOriginalDocToClipboard.Enabled) and (FActiveDoc <> nil) then
        begin
          FbfaTlbStandard.tlbStandardSubmenuItemClipboard.Action := actCopyDocToClipboard;
        end
        else if (frmMainForm.actCopyDocLinkToClipboard.Tag = 1) and
                (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action <> nil) and
                (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action.Name = 'actCopyDocLinkToClipboard') and
                (not actCopyDocLinkToClipboard.Enabled) and (FActiveDoc <> nil) then
          begin
          FbfaTlbStandard.tlbStandardSubmenuItemClipboard.Action := actCopyDocToClipboard;
        end
        else if (frmMainForm.actCopyOriginalDocToClipboard.Tag = 1) and (actCopyOriginalDocToClipboard.Enabled) and
                (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action.Name <> 'actCopyOriginalDocToClipboard')  then
        begin
          // MainForm wird weiter unten gleich gesetzt
          FbfaTlbStandard.tlbStandardSubmenuItemClipboard.Action := actCopyOriginalDocToClipboard;
        end else if (FActiveDoc = nil) then
        begin
          // bei Reset setzen wir die alte Einstellung
          if frmMainForm.actCopyOriginalDocToClipboard.Tag = 1 then
              FbfaTlbStandard.tlbStandardSubmenuItemClipboard.Action := actCopyOriginalDocToClipboard
          else if frmMainForm.actCopyDocLinkToClipboard.Tag = 1 then
            FbfaTlbStandard.tlbStandardSubmenuItemClipboard.Action := actCopyDocLinkToClipboard
          else if frmMainForm.actCopyPageToClipboard.Tag = 1 then
            FbfaTlbStandard.tlbStandardSubmenuItemClipboard.Action := actCopyPageToClipboard
          else if frmMainForm.actCopyDocToClipboard.Tag = 1 then
            FbfaTlbStandard.tlbStandardSubmenuItemClipboard.Action := actCopyDocToClipboard
          //20.09.2024 BT hier fehlt noch else -->
          else
            FbfaTlbStandard.tlbStandardSubmenuItemClipboard.Action := actCopyDocToClipboard;
          //20.09.2024 BT <--

        end;

//        if (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave <> nil) and
//           (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action <> nil) then
//        begin
//          if (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action.Name = 'actLocalSaveOriginal') or
//            ((FActiveDoc <> nil) and (not FActiveDoc.HasPreview)) then
//          begin
//            if actLocalSaveOriginal.Enabled then
//              FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSaveOriginal
//            else
//              FbfaTlbStandard.tlbStandardSubmenuItemSave.Action := actLocalSavePreview;
//          end;
//        end;
//
//        if (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail <> nil) and
//           (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action <> nil) then
//        begin
////          frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.LinkSubitems[n].Action
//          if (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action.Name = 'actEmailOriginal') or
//            ((FActiveDoc <> nil) and (not FActiveDoc.HasPreview)) then
//          begin
//            if actEmailOriginal.Enabled then
//              FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailOriginal
//            else
//              FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action := actEmailPreview;
//          end;
//        end;
//
//        if (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemClipboard <> nil) and
//           (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action <> nil) then
//        begin
//          if (frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action.Name = 'actCopyOriginalDocToClipboard') or
//            ((FActiveDoc <> nil) and (not FActiveDoc.HasPreview)) then
//          begin
//            if actCopyOriginalDocToClipboard.Enabled then
//              FbfaTlbStandard.tlbStandardSubmenuItemClipboard.Action := actCopyOriginalDocToClipboard
//            else
//              FbfaTlbStandard.tlbStandardSubmenuItemClipboard.Action := actCopyDocLinkToClipboard;
//          end;
//        end;

        if frmMainForm.bfaTlbPreview1.mnuPublicAnno <> nil then
        begin
          frmMainForm.bfaTlbPreview1.mnuPublicAnno.Checked := FbfaTlbPreview.mnuPublicAnno.Checked;
          frmMainForm.bfaTlbPreview1.mnuPublicAnno.Enabled := actPublicAnno.Enabled;
        end;

        if frmMainForm.bfaTlbPreview1.mnuPrivateAnno <> nil then
        begin
          frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Checked := FbfaTlbPreview.mnuPrivateAnno.Checked;
          frmMainForm.bfaTlbPreview1.mnuPrivateAnno.Enabled := actPrivateAnno.Enabled;
        end;

        if frmMainForm.bfaTlbPreview1.mnuStationery <> nil then
        begin
          frmMainForm.bfaTlbPreview1.mnuStationery.Checked := FbfaTlbPreview.mnuStationery.Checked;
          frmMainForm.bfaTlbPreview1.mnuStationery.Enabled := frmMainForm.actStationery.Enabled;
        end;

        if frmMainForm.bfaTlbPreview1.sbmStationery <> nil then
        begin
          frmMainForm.bfaTlbPreview1.sbmStationery.Checked := FbfaTlbPreview.sbmStationery.Checked;
          frmMainForm.bfaTlbPreview1.sbmStationery.Enabled := FbfaTlbPreview.sbmStationery.Enabled;
        end;

        if frmMainForm.bfaTlbPreview1.mnuFtxPos <> nil then
        begin
          frmMainForm.bfaTlbPreview1.mnuFtxPos.Checked := FbfaTlbPreview.mnuFtxPos.Checked;
          frmMainForm.bfaTlbPreview1.mnuFtxPos.Enabled := actFtxPos.Enabled;
        end;

        if frmMainForm.bfaTlbPreview1.mnuPreviousPage <> nil then
        begin
          frmMainForm.bfaTlbPreview1.mnuPreviousPage.Checked := FbfaTlbPreview.mnuPreviousPage.Checked;
          frmMainForm.bfaTlbPreview1.mnuPreviousPage.Enabled := FbfaTlbPreview.mnuPreviousPage.Enabled;
        end;

        if frmMainForm.bfaTlbPreview1.mnuNextPage <> nil then
        begin
          frmMainForm.bfaTlbPreview1.mnuNextPage.Checked := FbfaTlbPreview.mnuNextPage.Checked;
          frmMainForm.bfaTlbPreview1.mnuNextPage.Enabled := FbfaTlbPreview.mnuNextPage.Enabled;
        end;

        if frmMainForm.bfaTlbPreview1.edtPageNumber <> nil then
          frmMainForm.bfaTlbPreview1.edtPageNumber.ReadOnly := not((FActiveDoc <> nil) and (FbfaPreviewKind <> pvkMulti)); // SJ 13.10.2021

        if frmMainForm.bfaTlbStandard1.tlbStandardEditTags <> nil then
          frmMainForm.bfaTlbStandard1.tlbStandardEditTags.Action := FbfaTlbStandard.tlbStandardEditTags.Action;

        if frmMainForm.bfaTlbStandard1.tlbStandardAutoRef <> nil then
          frmMainForm.bfaTlbStandard1.tlbStandardAutoRef.Action := FbfaTlbStandard.tlbStandardAutoRef.Action;

        if frmMainForm.bfaTlbStandard1.tlbStandardNewLink <> nil then
          frmMainForm.bfaTlbStandard1.tlbStandardNewLink.Action := FbfaTlbStandard.tlbStandardNewLink.Action;

        if frmMainForm.bfaTlbStandard1.tlbStandardAddLink <> nil then
          frmMainForm.bfaTlbStandard1.tlbStandardAddLink.Action := FbfaTlbStandard.tlbStandardAddLink.Action;

        if frmMainForm.bfaTlbStandard1.tlbStandardRotateLeft <> nil then
          frmMainForm.bfaTlbStandard1.tlbStandardRotateLeft.Action := FbfaTlbStandard.tlbStandardRotateLeft.Action;

        if frmMainForm.bfaTlbStandard1.tlbStandardRotateRight <> nil then
          frmMainForm.bfaTlbStandard1.tlbStandardRotateRight.Action := FbfaTlbStandard.tlbStandardRotateRight.Action;

        if frmMainForm.bfaTlbStandard1.tlbStandardFlip <> nil then
          frmMainForm.bfaTlbStandard1.tlbStandardFlip.Action := FbfaTlbStandard.tlbStandardFlip.Action;

        if frmMainForm.bfaTlbStandard1.tlbStandardDeletePage <> nil then
          frmMainForm.bfaTlbStandard1.tlbStandardDeletePage.Action := FbfaTlbStandard.tlbStandardDeletePage.Action;

        if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave <> nil then
        begin
          frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.Action := FbfaTlbStandard.tlbStandardSubmenuItemSave.Action;
          frmMainForm.mnuLocalSave.Action := FbfaTlbStandard.tlbStandardSubmenuItemSave.Action; // SJ - bfacrm:ticket__show__33571
        end;

        if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail <> nil then
        begin
          frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.Action := FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action;
          frmMainForm.mnuEmail.Action := FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action; // SJ - bfacrm:ticket__show__33571
        end;

        if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemPrint <> nil then
          frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemPrint.Action := FbfaTlbStandard.tlbStandardSubmenuItemPrint.Action;

        if frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemClipboard <> nil then
        begin
          frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemClipboard.Action := FbfaTlbStandard.tlbStandardSubmenuItemClipboard.Action;
          frmMainForm.mnuCopyToClipboard.Action := FbfaTlbStandard.tlbStandardSubmenuItemClipboard.Action; // SJ - bfacrm:ticket__show__33571
        end;

        //05.07.2024 SD -->bfacrm:ticket__show__38036

//        if (FActiveDoc = nil) then
//          frmMainForm.actSearch.Enabled := ((bitfarmApp.CurrentArchive.Typ = 0) and (Rights = 0)) or    // wenn wir auf einen Lager stehen und es wurden keine rechte definiert
//            ((Rights and rightList) = rightList) or                  // ansonsten wird das Search-Recht geprft
//            (bitfarmApp.CurrentView = tvkResub)                     // oder wir stehen auf der WVL
//
//        else
//          frmMainForm.actSearch.Enabled := (((bitfarmApp.CurrentArchive.Typ = 0) and (Rights = 0)) or    // wenn wir auf einen Lager stehen und es wurden keine rechte definiert
//            ((Rights and rightList) = rightList) or                  // ansonsten wird das Search-Recht geprft
//            (bitfarmApp.CurrentView = tvkResub)                     // oder wir stehen auf der WVL
//            ) and (not FActiveDoc.InEditMode);

        if (FActiveDoc = nil) then
          frmMainForm.actSearch.Enabled :=
            (((bitfarmApp.CurrentArchive.Typ = 0) and (aSysArc[bitfarmApp.CurrentArchive.Arcid].Rights = 0))
            or ((aSysArc[bitfarmApp.CurrentArchive.Arcid].Rights and rightList) > 0)
            or (bitfarmApp.CurrentView = tvkResub)
            or ((bitfarmApp.FSearchObj <> nil) and (bitfarmApp.FSearchObj.Constructive)))
        else
          frmMainForm.actSearch.Enabled :=
            (((bitfarmApp.CurrentArchive.Typ = 0) and (aSysArc[bitfarmApp.CurrentArchive.Arcid].Rights = 0))
            or ((aSysArc[bitfarmApp.CurrentArchive.Arcid].Rights and rightList) > 0)
            or (bitfarmApp.CurrentView = tvkResub)
            or ((bitfarmApp.FSearchObj <> nil) and (bitfarmApp.FSearchObj.Constructive)))
            and (not FActiveDoc.InEditMode);
        //05.07.2024 SD <--bfacrm:ticket__show__38036


        //drfte nur auf Viewertab angezeigt werden
        if (bitfarmApp.FSearchObj <> nil) and (bitfarmApp.FSearchObj.SearchType in [1,2,3]) and
          (frmMainForm.tstDocumentEditors.ActiveTab = bitfarmApp.PreviewContainer.ViewerItem.Tab) then
          if (FActiveDoc = nil) then
            frmMainForm.actSearch.Enabled := bitfarmApp.FSearchObj.Constructive
          else
            frmMainForm.actSearch.Enabled := bitfarmApp.FSearchObj.Constructive
              and (not FActiveDoc.InEditMode);

        // <!-- SJ 05.05.2022 - bfacrm:ticket__show__28731
//        frmMainForm.mnuInverted.Action := actInverted;
//        frmMainForm.mnuDeScrew.Action := actDeScrew;
//        frmMainForm.mnuDeSpeckle.Action := actDeSpeckle;
//        frmMainForm.mnuRemoveBorder.Action := actRemoveBorder;
        // SJ 05.05.2022 - bfacrm:ticket__show__28731 -->
        frmMainForm.mnuRestoreOriginal.Action := frmMainForm.actRestoreOriginal;
        frmMainForm.mnuRefreshDoc.Action := frmMainForm.actReOCR;
        frmMainForm.mnuGraphicOptions.Action := frmMainForm.actGraphicOptions; //07.01.2020 Ticket 21619
        frmMainForm.mnuGraphicOptions_Main.Action := frmMainForm.actGraphicOptions; //07.01.2020 Ticket 21619

        if Assigned(frmMainForm.fraDocLinks) then
        begin
          with frmMainForm.fraDocLinks do
          begin
            btnNewLink.Enabled := (edtDocLink.Text <> '') and (bitfarmApp.CurrentContainer.Count > 0);
            btnAddAutoReference.Enabled := (bitfarmApp.CurrentContainer.Count > 0);
          end;
        end;

        //09.07.2024 SD -->bfacrm:ticket__show__37106
//        frmMainForm.actCreateEmptyDoc.Enabled := ((Rights and rightWrite) = rightWrite) and (bitfarmApp.CurrentView = tvkViewer);
        frmMainForm.actCreateEmptyDoc.Enabled := ((Rights and rightImport) = rightImport) and (bitfarmApp.CurrentView = tvkViewer);
        //09.07.2024 SD <--bfacrm:ticket__show__37106
        frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemSave.LinkSubitems := FbfaTlbStandard.tlbStandardSubmenuItemSave.LinkSubitems;
        frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemEmail.LinkSubitems := FbfaTlbStandard.tlbStandardSubmenuItemEmail.LinkSubitems;
        frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemPrint.LinkSubitems := FbfaTlbStandard.tlbStandardSubmenuItemPrint.LinkSubitems;
        frmMainForm.bfaTlbStandard1.tlbStandardSubmenuItemClipboard.LinkSubitems := FbfaTlbStandard.tlbStandardSubmenuItemClipboard.LinkSubitems;
      end;

      frmMainForm.mnuCreateEmptyDoc.Action := frmMainForm.actCreateEmptyDoc;
      frmMainForm.mnuDeleteDoc.Action := frmMainForm.actDeleteDoc;
      frmMainForm.mnuAuditProof.Action := frmMainForm.actAuditProof;
      frmMainForm.mnuExportCSV.Action := frmMainForm.mnuExportCSVFile.Action;
      frmMainForm.mnuExportXLS.Action := frmMainForm.mnuExportExcel.Action;
      frmMainForm.mnuExportOO.Action := frmMainForm.mnuExportOpenOffice.Action;

      //frmMainForm.mnuCreateEmptyDoc_Main.Action := frmMainForm.actCreateEmptyDoc;
      frmMainForm.mnuDeleteDoc_Main.Action := frmMainForm.actDeleteDoc;
      frmMainForm.mnuAuditProof_Main.Action := frmMainForm.actAuditProof;
      frmMainForm.mnuExportCSV_Main.Action := frmMainForm.mnuExportCSVFile.Action;
      frmMainForm.mnuExportXLS_Main.Action := frmMainForm.mnuExportExcel.Action;
      frmMainForm.mnuExportOO_Main.Action := frmMainForm.mnuExportOpenOffice.Action;

      frmMainForm.actRangeOCR.Enabled := actRangeOCR.Enabled;
      frmMainForm.mnuBack.Action := actPreviewBack;
      frmMainForm.mnuNewLink.Action := actNewLink;
      frmMainForm.mnuAutoRef.Action := actAutoRef;
      frmMainForm.mnuAddLink.Action := actAddLink;
      frmMainForm.mnuDelete.Action := actDeleteSelected;
      frmMainForm.mnuChangeDocName.Action := actChangeDocName;
      frmMainForm.mnuSingleSave.LinkSubitems := FbfaTlbStandard.tlbStandardSubmenuItemSave.LinkSubitems;
      frmMainForm.mnuSingleEmail.LinkSubitems := FbfaTlbStandard.tlbStandardSubmenuItemEmail.LinkSubitems;
      frmMainForm.mnuSinglePrint.LinkSubitems := FbfaTlbStandard.tlbStandardSubmenuItemPrint.LinkSubitems;
      frmMainForm.mnuSingleClipboard.LinkSubitems := FbfaTlbStandard.tlbStandardSubmenuItemClipboard.LinkSubitems;

      // <!-- SJ 05.05.2022 - bfacrm:ticket__show__28731
      frmMainForm.mnuInverted.Action := actInverted;
      frmMainForm.mnuDeScrew.Action := actDeScrew;
      frmMainForm.mnuDeSpeckle.Action := actDeSpeckle;
      frmMainForm.mnuRemoveBorder.Action := actRemoveBorder;
      frmMainForm.mnuInverted_Main.Action := actInverted;
      frmMainForm.mnuDeScrew_Main.Action := actDeScrew;
      frmMainForm.mnuDeSpeckle_Main.Action := actDeSpeckle;
      frmMainForm.mnuRemoveBorder_Main.Action := actRemoveBorder;

      frmMainForm.actRotateLeft.Enabled := actRotateLeft.Enabled;
      frmMainForm.actRotateRight.Enabled := actRotateRight.Enabled;
      frmMainForm.actFlip.Enabled := actFlip.Enabled;
      frmMainForm.actInverted.Enabled := actInverted.Enabled;
      frmMainForm.actDeScrew.Enabled := actDeScrew.Enabled;
      frmMainForm.actDeSpeckle.Enabled := actDeSpeckle.Enabled;
      frmMainForm.actRemoveBorder.Enabled := actRemoveBorder.Enabled;
      // SJ 05.05.2022 - bfacrm:ticket__show__28731 -->

      if (FActiveDoc <> nil) then
      begin
        if frmMainForm.tlbPlugins <> nil then
        begin
          frmMainForm.tlbPlugins.Enabled := not FActiveDoc.InEditMode;
          for i := 0 to frmMainForm.tlbPlugins.Items.Count -1 do
            frmMainForm.tlbPlugins.Items[i].Enabled := not FActiveDoc.InEditMode;
        end;
        if frmMainForm.mnuPlugins <> nil then
        begin
          frmMainForm.mnuPlugins.Enabled := not FActiveDoc.InEditMode;
          for i := 0 to frmMainForm.mnuPlugins.Count -1 do
            frmMainForm.mnuPlugins.Items[i].Enabled := not FActiveDoc.InEditMode;
        end;
      end else
      begin
        if frmMainForm.tlbPlugins <> nil then
        begin
//          frmMainForm.tlbPlugins.Enabled := False; // SJ 29.07.2021 - bfacrm:ticket__show__28089
          for i := 0 to frmMainForm.tlbPlugins.Items.Count -1 do
            frmMainForm.tlbPlugins.Items[i].Enabled := False;
        end;
        if frmMainForm.mnuPlugins <> nil then
        begin
          frmMainForm.mnuPlugins.Enabled := False;
          for i := 0 to frmMainForm.mnuPlugins.Count -1 do
            frmMainForm.mnuPlugins.Items[i].Enabled := False;
        end;
      end;

      if FbfaTlbPreview <> nil then
      begin
        FbfaTlbPreview.cbxZoom.Enabled := frmMainForm.actAutozoom.Enabled;
//        FbfaTlbPreview.edtPageNumber.ReadOnly := frmMainForm.actNextPage.Enabled;
      end;
      SetAnnoToolBar((AReadRight and (FbfaTlbPreview.mnuPublicAnno.Checked or FbfaTlbPreview.mnuPrivateAnno.Checked)) or ((FActiveDoc <> nil) and (FActiveDoc.ID = -1)));

      bitfarmApp.SetDocLinkActions;
      frmMainForm.actCreateBookmarkMenu.Enabled := (bitfarmApp.FSearchObj <> nil) and (bitfarmApp.FSearchObj.ID <> -1);


      frmMainForm.actCreateBookmarkDialog.Enabled := (bitfarmApp.FSearchObj <> nil) and (bitfarmApp.FSearchObj.ID <> -1)
                                                                       {and ((Rights and rightAdmin) = rightAdmin)};  // Ticket 20864
      frmMainForm.actCreateBookmarkDialog.Visible := frmMainForm.actCreateBookmarkDialog.Enabled;

      frmMainForm.actScan.Enabled := True;
      frmMainForm.actScanDialog.Enabled := True;
      frmMainForm.actViewThumbnails.Enabled := True;
      frmMainForm.actCheckoutDocs.Enabled := True and not bitfarmApp.OfflineMode;
      frmMainForm.actLoadFile.Enabled := True and not bitfarmApp.OfflineMode;
      {$IFDEF ENTERPRISE}
      TfrmEnterprise(frmMainForm).actShowAbo.Enabled := True and not bitfarmApp.OfflineMode;
      TfrmEnterprise(frmMainForm).actStartHoliday.Enabled := True and not bitfarmApp.OfflineMode;
      {$ENDIF}
      frmMainForm.actCheckoutDocsAdmin.Enabled := (bitfarmApp.User.SuAnnoList.Count > 0) and not bitfarmApp.OfflineMode;
      frmMainForm.actCheckoutDocsAdmin.Visible := (bitfarmApp.User.SuAnnoList.Count > 0) and not bitfarmApp.OfflineMode;
      frmMainForm.actChangePassword.Enabled := (bitfarmApp.User.Flags and 4 = 0) and not bitfarmApp.OfflineMode;
      frmMainForm.actChangePassword.Visible := (bitfarmApp.User.Flags and 4 = 0) and not bitfarmApp.OfflineMode;

      //17.01.2024 bfacrm:ticket__show__37424 -->
      frmMainForm.mnuSingleSave.Action := FbfaTlbStandard.tlbStandardSubmenuItemSave.Action;
      frmMainForm.mnuSingleEmail.Action := FbfaTlbStandard.tlbStandardSubmenuItemEmail.Action;
      frmMainForm.mnuSinglePrint.Action := FbfaTlbStandard.tlbStandardSubmenuItemPrint.Action;
      frmMainForm.mnuSingleClipboard.Action := FbfaTlbStandard.tlbStandardSubmenuItemClipboard.Action;
      //17.01.2024 bfacrm:ticket__show__37424 <--

    except
      bitfarmLog.Write(llNormal, ltException, 'SetActions - ' + Self.Name, ClassName);
    end;
  finally
    // macht Probleme beim Floating
//    if AnnoToolbar <> nil then
//      AnnoToolbar.EndUpdate;
//    if PreviewSelectToolbar <> nil then
//      PreviewSelectToolbar.EndUpdate;
//    if navigationToolBar <> nil then
//      navigationToolBar.EndUpdate;
//    if bfaTlbImporter <> nil then
//      bfaTlbImporter.EndUpdate;
//    if bfaTlbPreview <> nil then
//      bfaTlbPreview.EndUpdate;
//    if bfaTlbStandard <> nil then
//      bfaTlbStandard.EndUpdate;

//    if FbfaTlbStandard <> nil then
//      FbfaTlbStandard.EndUpdate;
//    if frmMainForm.tlbPlugins <> nil then
//      frmMainForm.tlbPlugins.EndUpdate;
//    if frmMainForm.tlbStatefields <> nil then
//      frmMainForm.tlbStatefields.EndUpdate;
//    if frmMainForm.tlbDocState <> nil then
//      frmMainForm.tlbDocState.EndUpdate;
//    if frmMainForm.tlbTools <> nil then
//      frmMainForm.tlbTools.EndUpdate;
//    if frmMainForm.tlbGraphic <> nil then
//      frmMainForm.tlbGraphic.EndUpdate;
//    if frmMainForm.bfaTlbPreview1 <> nil then
//      frmMainForm.bfaTlbPreview1.EndUpdate;
//    if frmMainForm.bfaTlbStandard1 <> nil then
//      frmMainForm.bfaTlbStandard1.EndUpdate;

    bitfarmLog.DebugEnd(llDebug, 'SetActions - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.SetSaveAction(CanEnabled: Boolean);
begin
  try
    if FActiveDoc <> nil then
      frmMainForm.actSave.Enabled := ((CanEnabled) and (FActiveDoc.ID <> -1) and (FActiveDoc.InEditMode))
    else
      frmMainForm.actSave.Enabled := False;
    frmMainForm.actCancel.Enabled := frmMainForm.actSave.Enabled;
  except
    bitfarmLog.Write(llNormal, ltException, 'SetSaveAction - ' + Self.Name, ClassName);
  end;
end;

procedure TbfaPreview.ShowPage(Doc: TbfaDocument; PageIdx: Integer; Autozoom: Boolean = True;
  SetImagePos: Boolean = False; SetImagePosTothetop: Boolean = False; PageDirection: Integer = -1);
var
  idx, mx, my, iPage, vx: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'ShowPage - ' + Self.Name, ClassName);
  FimgSingleView.img_DocView.LockPaint;
//21.11.2018 Ticket 16873  FimgSingleView.img_DocView.Clear;
  try
    try
      FDontSetPage := true;

      if (PageIdx > -1) and (PageDirection = -1) then
        SetActivePage(PageIdx)
      else if FActivePage = -1 then
        SetActivePage(0);
      if PageDirection <> -1 then
      begin
        if (FActiveDoc.ScanPoolView <> nil) and (FActiveDoc.ScanPoolViewLoaded) then
        begin
          iPage := FActivePage;
          if PageDirection = 1 then
          begin
            Inc(iPage);
            if iPage < 0 then
              iPage := FActiveDoc.ScanPoolView.ImageCount - 1;
            if iPage > (FActiveDoc.ScanPoolView.ImageCount - 1) then
            begin
              if not bitfarmApp.ViewerOptions.EditorOptions.DocEditorZoom then
                iPage := 0
              else
                Exit;
            end;
          end
          else if PageDirection = 0 then
          begin
            Dec(iPage);
            if iPage < 0 then
            begin
              if not bitfarmApp.ViewerOptions.EditorOptions.DocEditorZoom then
                iPage := FActiveDoc.ScanPoolView.ImageCount - 1
              else
                Exit;
            end
            else if iPage > (FActiveDoc.ScanPoolView.ImageCount - 1) then
              iPage := 0;
          end;
          SetActivePage(iPage);
        end
        else
        begin
          iPage := FActivePage;
          if PageDirection = 1 then
          begin
            Inc(iPage);
            if iPage < 0 then
              iPage := FimgSingleView.img_DocView.IO.Params.Tiff_ImageCount - 1;
            if iPage > (FimgSingleView.img_DocView.IO.Params.Tiff_ImageCount - 1) then
            begin
              if not bitfarmApp.ViewerOptions.EditorOptions.DocEditorZoom then
                iPage := 0
              else
                Exit;
            end;
          end
          else if PageDirection = 0 then
          begin
            Dec(iPage);
            if iPage < 0 then
            begin
              if not bitfarmApp.ViewerOptions.EditorOptions.DocEditorZoom then
                iPage := FimgSingleView.img_DocView.IO.Params.Tiff_ImageCount - 1
              else
                Exit;
            end
            else if iPage > (FimgSingleView.img_DocView.IO.Params.Tiff_ImageCount - 1) then
              iPage := 0;
          end;
          SetActivePage(iPage);
        end;
      end;
//31.10.2019      FimgSingleView.img_DocView.Clear; //21.11.2018 Ticket 16873

      DeleteFtxPosLayer;

      if FimgSingleView.img_DocView.ObjectsCount > 0 then
      begin
        FimgSingleView.img_DocView.DeSelect;
        FimgSingleView.img_DocView.UnSelAllObjects;
        FimgSingleView.img_DocView.RemoveAllObjects;
      end;
      FimgSingleView.img_DocView.Clear;  //31.10.2019
      FimgSingleView.img_DocView.Update;  //31.10.2019

      if SetImagePos then
      begin
        vx := FimgSingleView.img_DocView.ViewX;
        if vx = 0 then
          vx := 100;
        if SetImagePosTothetop then
          FimgSingleView.img_DocView.SetViewXY(vx, 0)
        else
        begin
          FimgSingleView.img_DocView.GetMaxViewXY(mx, my);
          FimgSingleView.img_DocView.SetViewXY(vx, my);
        end;
      end;

      bfaProcessing.LoadImage(FActivePage, FimgSingleView, Doc);

      if (FStatObj <> nil) and (FbfaTlbPreview.mnuStationery.Checked) then
      begin
        bfaProcessing.ShowStationery(FActivePage, FimgSingleView.img_DocView, FStatObj);
      end;

      if (FbfaTlbPreview.mnuPublicAnno.Enabled and FbfaTlbPreview.mnuPublicAnno.Checked) or
        (FbfaTlbPreview.mnuPrivateAnno.Enabled and FbfaTlbPreview.mnuPrivateAnno.Checked) then
      begin
        try
          Doc.GetAnnotation(FActivePage, CurrentLayer, idx);
          if idx <> -1 then
          begin
            Doc.Annotations[idx].AnnoStream.Position := 0;
            FimgSingleView.img_DocView.LoadFromStreamIEV(Doc.Annotations[idx].AnnoStream);
            Doc.Annotations[idx].AnnoStream.Position := 0;
            FimgSingleView.img_DocView.Update;
          end;
          SetAnnoToolBar(True);

        except
          on e: Exception do
          begin
            bitfarmLog.Write(llNormal, ltException, _('Fehler beim Laden der Anmerkung: ') + e.message + ' - ' + Self.Name, ClassName);
            BfShowMessage(_('Fehler beim Laden der Anmerkung: ') + e.message);
          end;
        end;
      end;

      if ((bitfarmApp.ViewerOptions.SearchOptions.FtxPos) and (FActiveView = avDocument)) then
        bitfarmApp.ShowFtxPos(FimgSingleView.img_DocView, Doc, Self, FActivePage);

      if Doc.HasPreview then
      begin
        if Autozoom then
          bitfarmApp.Autozoom(Self);
      end
      else
        FimgSingleView.img_DocView.Fit; //25.07.2017 weil die Dateien die keine Voransicht haben sollten auch angezeigt werden!

      ShowPageNumber;

    except
      bitfarmLog.Write(llNormal, ltException, 'ShowPage - ' + Self.Name, ClassName);
    end;
  finally
    FDontSetPage := False;
    FimgSingleView.img_DocView.UnLockPaint;

    bitfarmLog.DebugEnd(llDebug, 'ShowPage - ' + Self.Name, ClassName);
  end;
end;

//30.08.2022 procedure TbfaPreview.PageNumberChange(Sender: TObject; const Text: String);
procedure TbfaPreview.PageNumberChange(Sender: TObject);
var
  iPAge, imgcnt: integer;
begin
  // SJ 24.11.2020 - ChangePageByEnter entfernt - jetzt immer true
  if (bitfarmApp.ViewerOptions.GeneralOptions.ChangePageByEnter) then //06.04.2017 Ticket 10300
    Exit;

  bitfarmLog.DebugBegin(llDebug, 'PageNumberChange - ' + Self.Name, ClassName);
  try
    try
      if FDontSetPage then
        exit;

      try
        iPAge := StrToInt(Text) - 1;
      except
        on e: Exception do
        begin
          iPAge := 0;
        end;
      end;

//30.05.2018 Ticket 14576 -->
      if (FActiveDoc <> nil) and
         (FActiveDoc.ScanPoolView <> nil) and (FActiveDoc.ScanPoolViewLoaded) then
        imgcnt := FActiveDoc.ScanPoolView.ImageCount
      else
        imgcnt := FimgSingleView.img_DocView.IO.Params.Tiff_ImageCount;
//30.05.2018 Ticket 14576 <--

      with FimgSingleView.img_DocView do
      begin
        if iPAge < 0 then
          iPAge := imgcnt - 1;

        if iPAge > (imgcnt - 1) then
          iPAge := 0;

        if FActivedoc <> nil then
          ShowPage(FActiveDoc, iPAge);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'PageNumberChange - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'PageNumberChange - ' + Self.Name, ClassName);
  end;
end;

procedure TbfaPreview.AcceptText(Sender: TObject; var NewText: String; var Accept: Boolean);
var
  iPAge, imgcnt: integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'AcceptText - ' + Self.Name, ClassName);
  try
    try
      if FDontSetPage then
        exit;

      try
        iPAge := StrToInt(NewText) - 1;
      except
        on e: Exception do
        begin
          iPAge := 0;
          NewText := '1';
        end;
      end;


      if (FActiveDoc <> nil) and
         (FActiveDoc.ScanPoolView <> nil) and (FActiveDoc.ScanPoolViewLoaded) then
        imgcnt := FActiveDoc.ScanPoolView.ImageCount
      else
        imgcnt := FimgSingleView.img_DocView.IO.Params.Tiff_ImageCount;
//30.05.2018 Ticket 14576 <--

      with FimgSingleView.img_DocView do
      begin
        if iPAge < 0 then
          iPAge := imgcnt - 1;

        if iPAge > (imgcnt - 1) then
          iPAge := 0;

        if (imgcnt = 0) then
          NewText := '';

        ShowPage(FActiveDoc, iPAge);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'AcceptText - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'AcceptText - ' + Self.Name, ClassName);
  end;
end;

procedure TbfaPreview.cbxZoomChange(Sender: TObject);
var
  fpZoom: single;
  iPos: integer;
  mousePos: Tpoint;
  sZoom: string;
begin
  bitfarmLog.DebugBegin(llDebug, 'cbxZoomChange - ' + Self.Name, ClassName);
  try
    try
      // dont change the view if already changed
      if FimgSingleView.fChangeZoomtextNotView then
        exit;

      iPos := Pos('%', TSpTBXComboBox(Sender).Text);
      if iPos = -1 then
      begin
        TSpTBXComboBox(Sender).Text := TSpTBXComboBox(Sender).Text + ' %';
        iPos := Pos('%', TSpTBXComboBox(Sender).Text);
      end;

      if TSpTBXComboBox(Sender) <> FbfaTlbPreview.cbxZoom then
        FbfaTlbPreview.cbxZoom.Text := TSpTBXComboBox(Sender).Text;

      if not Floating then  //15.03.2017
        frmMainForm.bfaTlbPreview1.cbxZoom.Text := TSpTBXComboBox(Sender).Text;

      getcursorpos(mousePos);
      if iPos < 2 then
        exit;

      sZoom := copy(TSpTBXComboBox(Sender).Text, 0, iPos - 2);
      sZoom := StringReplace(sZoom, ',', bitfarmApp.FormatSettings.DecimalSeparator, [rfReplaceAll]);

      if TryStrToFloat(sZoom, fpZoom, bitfarmApp.FormatSettings) then
      begin
        try
          FimgSingleView.img_DocView.Zoom := fpZoom;
        except
          on e: Exception do
          begin
            bitfarmLog.Write(llNormal, ltException, _('Fehler bei zoomen'), ClassName);
          end;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'cbxZoomChange - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'cbxZoomChange - ' + Self.Name, ClassName);
  end;
end;

procedure TbfaPreview.ShowPageNumber;
var
  img: TbfaImageEnVect;
  cnt, idx: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'ShowPageNumber - ' + Self.Name, ClassName);
  try
    try
      if (FbfaPreviewKind = pvkMultiSingle) or (FbfaPreviewKind = pvkSingle) then
      begin
        if (FActiveDoc <> nil) and (FActiveDoc.ScanPoolView <> nil) and FActiveDoc.ScanPoolViewLoaded then
        begin
          cnt := FActiveDoc.ScanPoolView.ImageCount;
          idx := FActivePage;
        end
        else
        begin
          cnt := FimgSingleView.img_DocView.IO.Params.ImageCount;
          idx := FimgSingleView.img_DocView.IO.Params.TIFF_ImageIndex;
        end;

        // SJ 21.09.2021 bfacrm:ticket__show__28102
        if (FActiveDoc <> nil) then
        begin
          FbfaTlbPreview.edtPageNumber.Text := IntToStr(idx + 1);
//          FbfaTlbPreview.bfaTlbPreviewLabelPageCount.Caption := _('von') + ' ' + IntToStr(cnt) + ' ';
          FbfaTlbPreview.bfaTlbPreviewLabelPageCount.Caption := Format(_('von %s '), [cnt.ToString]);
          if not Floating then  //15.03.2017
          begin
            frmMainForm.bfaTlbPreview1.edtPageNumber.Text := IntToStr(idx + 1);
            frmMainForm.bfaTlbPreview1.bfaTlbPreviewLabelPageCount.Caption := FbfaTlbPreview.bfaTlbPreviewLabelPageCount.Caption;
          end;
        end
        else
        begin
          FbfaTlbPreview.edtPageNumber.Text := '';
//          FbfaTlbPreview.bfaTlbPreviewLabelPageCount.Caption := _('von') + ' ' + IntToStr(0) + ' ';
          FbfaTlbPreview.bfaTlbPreviewLabelPageCount.Caption := Format(_('von %s '), [IntToStr(0)]);
          if not Floating then
          begin
            frmMainForm.bfaTlbPreview1.edtPageNumber.Text := FbfaTlbPreview.edtPageNumber.Text;
            frmMainForm.bfaTlbPreview1.bfaTlbPreviewLabelPageCount.Caption := FbfaTlbPreview.bfaTlbPreviewLabelPageCount.Caption;
          end;
        end;
//        FbfaTlbPreview.edtPageNumber.Text := IntToStr(idx + 1);
//        FbfaTlbPreview.bfaTlbPreviewLabelPageCount.Caption := _('von') + ' ' + IntToStr(cnt) + ' ';
//        if not Floating then  //15.03.2017
//        begin
//          frmMainForm.bfaTlbPreview1.edtPageNumber.Text :=
//          IntToStr(idx + 1);
//          frmMainForm.bfaTlbPreview1.bfaTlbPreviewLabelPageCount.Caption :=
//          FbfaTlbPreview.bfaTlbPreviewLabelPageCount.Caption;
//        end;
        // SJ 21.09.2021 bfacrm:ticket__show__28102
      end
      else
      begin
        if (FActiveDoc <> nil) and (FActiveDoc.HasPreview) then
        begin
          img := CreateInvisibleVect(nil);
          try
            if (FActiveDoc <> nil) and (FActiveDoc.ScanPoolView <> nil) and FActiveDoc.ScanPoolViewLoaded then
            begin
              cnt := FActiveDoc.ScanPoolView.ImageCount;
              idx := 0;
            end  else
            begin
              FActiveDoc.DocStream.Position := 0;
              img.IO.LoadFromStream(FActiveDoc.DocStream);
//              img.IO.LoadFromStreamTIFF(FActiveDoc.DocStream);

              cnt := img.IO.Params.ImageCount;
              idx := img.IO.Params.ImageIndex;
//              idx := img.IO.Params.TIFF_ImageIndex;
            end;

//16.10.2018 Ticket 15774 -->
            if ((Self = bitfarmApp.PreviewContainer.ImporterItem.Preview) or
               (Self = bitfarmApp.PreviewContainer.WorkplaceItem.Preview)) and (FbfaPreviewKind = pvkMulti) then
            begin
              if (FimgThumbnailView <> nil) and (FimgThumbnailView.SelectedImage <> -1) and (previewToolWindow.Visible) then
              begin
                idx := FimgThumbnailView.SelectedImage;
              end;
            end;
//16.10.2018 Ticket 15774 <--

            FbfaTlbPreview.edtPageNumber.Text := IntToStr(idx + 1);
//            FbfaTlbPreview.bfaTlbPreviewLabelPageCount.Caption := _('von') + ' ' + IntToStr(cnt) + ' ';
            FbfaTlbPreview.bfaTlbPreviewLabelPageCount.Caption := Format(_('von %s '), [cnt.ToString]);
            if not Floating then  //15.03.2017
            begin
              frmMainForm.bfaTlbPreview1.edtPageNumber.Text := IntToStr(idx + 1);
              frmMainForm.bfaTlbPreview1.bfaTlbPreviewLabelPageCount.Caption := FbfaTlbPreview.bfaTlbPreviewLabelPageCount.Caption;
            end;
          finally
            FreeAndNil(img);
          end;
        end
        else
        begin
          FbfaTlbPreview.edtPageNumber.Text := '';
//          FbfaTlbPreview.bfaTlbPreviewLabelPageCount.Caption :=  _('von') + ' ' + IntToStr(0) + ' ';
          FbfaTlbPreview.bfaTlbPreviewLabelPageCount.Caption := Format(_('von %s '), [IntToStr(0)]);
          if not Floating then  //15.03.2017
          begin
            frmMainForm.bfaTlbPreview1.edtPageNumber.Text := '';
            frmMainForm.bfaTlbPreview1.bfaTlbPreviewLabelPageCount.Caption := FbfaTlbPreview.bfaTlbPreviewLabelPageCount.Caption;
          end;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'ShowPageNumber - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ShowPageNumber - ' + Self.Name, ClassName);
  end;
end;


procedure TbfaPreview.ThumbnailTimerTimer(Sender: TObject);
var
  Pt: TPoint;
begin
  // Stop timer and exit if not dragging any more
  if not FimgThumbnailView.Dragging then
  begin
    FThumbnailTimer.Enabled := False;
    Exit;
  end;

  Pt := FimgThumbnailView.ScreenToClient(Mouse.CursorPos);
  if Pt.Y < 0 then
    FimgThumbnailView.Perform(WM_VSCROLL, SB_LINEUP, 0)
  else if Pt.Y > FimgThumbnailView.ClientHeight then
    FimgThumbnailView.Perform(WM_VSCROLL, SB_LINEDOWN, 0)
  else
    FThumbnailTimer.Enabled := False;
end;

function TbfaPreview.CheckAnnoRights: Boolean;
var
  idx: Integer;
begin
  Result := False;
  if FActiveDoc = nil then
  begin
    SetActions;
    Exit;
  end;

  if FActiveDoc.ID = -1 then
    Result := True
  else
  begin
    if FbfaTlbPreview.mnuPublicAnno.Checked then
      Result := ((FActiveDoc.Rights and rightAWrite) = rightAWrite);

    if FbfaTlbPreview.mnuPrivateAnno.Checked then
    begin
      if bitfarmApp.User.ID <> CurrentLayer then
      begin
        FActiveDoc.GetAnnotation(FimgSingleView.img_DocView.IO.Params.ImageIndex, CurrentLayer, idx);
        if idx <> -1 then
          Result := (FActiveDoc.Annotations[idx].Rights and 9216) > 0;   // wenigstens schreibrecht

        if (idx <> -1) and ((rightAPWrite or rightAPModify) > 0) then   //   bfacrm:ticket__show__24052 11/11/2020
          Result := True
        else  // keine Annotation? dann Recht ber CurrentLayerRights
          Result := (CurrentLayerRights and 9216) > 0;
      end
      else  // eigenen Layer darf man immer
        Result := True;
    end;
  end;
end;

procedure TbfaPreview.CloneActions(CreateActions: Boolean = True; Retranslate: Boolean = False);
var
  i: Integer;
begin
  if not CreateActions then
    bitfarmLog.DebugBegin(llDebug, 'CloneActions - only Translations - ' + Self.Name, Classname)
  else
  bitfarmLog.DebugBegin(llDebug, 'CloneActions - ' + Self.Name, Classname);

  try
    try
      if CreateActions then
      actGraphicOptions := TAction.Create(actList);
      with actGraphicOptions do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actGraphicOptions.Name;
        ImageIndex := frmMainForm.actGraphicOptions.ImageIndex;
        Enabled := True;
        ShortCut := frmMainForm.actGraphicOptions.ShortCut;
        ActionList := actList;
        OnExecute := actGraphicOptionsExecute;
      end;
        Caption := sCaptionactGraphicOptions;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actGraphicOptions, sSysGnuViewerDomain);

      if CreateActions then
      actLocalSavePDF := TAction.Create(actList);
      with actLocalSavePDF do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actLocalSavePDF.Name;
        ImageIndex := frmMainForm.actLocalSavePDF.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actLocalSavePDF.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActLocalSavePDF;
        Hint := sCaptionActLocalSavePDF;
      end;
      if CreateActions then
        TranslateComponent(actLocalSavePDF, sSysGnuViewerDomain);

      if CreateActions then
      actLocalSaveTIF := TAction.Create(actList);
      with actLocalSaveTIF do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actLocalSaveTIF.Name;
        ImageIndex := frmMainForm.actLocalSaveTIF.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actLocalSaveTIF.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActLocalSaveTIF;
        Hint := sCaptionActLocalSaveTIF;
      end;
      if CreateActions then
        TranslateComponent(actLocalSaveTIF, sSysGnuViewerDomain);

      if CreateActions then
      actLocalSaveOriginal := TAction.Create(actList);
      with actLocalSaveOriginal do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actLocalSaveOriginal.Name;
        ImageIndex := frmMainForm.actLocalSaveOriginal.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actLocalSaveOriginal.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActLocalSaveOriginal;
        Hint := sCaptionActLocalSaveOriginal;
      end;
      if CreateActions then
        TranslateComponent(actLocalSaveOriginal, sSysGnuViewerDomain);

      if CreateActions then
      actLocalSaveLink := TAction.Create(actList);
      with actLocalSaveLink do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actLocalSaveLink.Name;
        ImageIndex := frmMainForm.actLocalSaveLink.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actLocalSaveLink.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActLocalSaveLink;
        Hint := sCaptionActLocalSaveLink;
      end;
      if CreateActions then
        TranslateComponent(actLocalSaveLink, sSysGnuViewerDomain);

      if CreateActions then
      actLocalSavePreview := TAction.Create(actList);
      with actLocalSavePreview do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actLocalSavePreview.Name;
        ImageIndex := frmMainForm.actLocalSavePreview.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actLocalSavePreview.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActLocalSavePreview;
        Hint := sHintActLocalSavePreview;
      end;
      if CreateActions then
        TranslateComponent(actLocalSavePreview, sSysGnuViewerDomain);

      if CreateActions then
      actEmailTIFAttachment := TAction.Create(actList);
      with actEmailTIFAttachment do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actEmailTIFAttachment.Name;
        ImageIndex := frmMainForm.actEmailTIFAttachment.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actEmailTIFAttachment.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActEmailTIFAttachment;
        Hint := sCaptionActEmailTIFAttachment;
      end;
      if CreateActions then
        TranslateComponent(actEmailTIFAttachment, sSysGnuViewerDomain);

      if CreateActions then
      actEmailPDFAttachment := TAction.Create(actList);
      with actEmailPDFAttachment do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actEmailPDFAttachment.Name;
        ImageIndex := frmMainForm.actEmailPDFAttachment.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actEmailPDFAttachment.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActEmailPDFAttachment;
        Hint := sCaptionActEmailPDFAttachment;
      end;
      if CreateActions then
        TranslateComponent(actEmailPDFAttachment, sSysGnuViewerDomain);

      if CreateActions then
      actEmailOriginal := TAction.Create(actList);
      with actEmailOriginal do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actEmailOriginal.Name;
        ImageIndex := frmMainForm.actEmailOriginal.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actEmailOriginal.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActEmailOriginal;
        Hint := sCaptionActEmailOriginal;
      end;
      if CreateActions then
        TranslateComponent(actEmailOriginal, sSysGnuViewerDomain);

      if CreateActions then
      actEmailLink := TAction.Create(actList);
      with actEmailLink do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actEmailLink.Name;
        ImageIndex := frmMainForm.actEmailLink.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actEmailLink.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActEmailLink;
        Hint := sCaptionActEmailLink;
      end;
      if CreateActions then
        TranslateComponent(actEmailLink, sSysGnuViewerDomain);

      if CreateActions then
      actEmailPreview := TAction.Create(actList);
      with actEmailPreview do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actEmailPreview.Name;
        ImageIndex := frmMainForm.actEmailPreview.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actEmailPreview.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActEmailPreview;
        Hint := sCaptionActEmailPreview;
      end;
      if CreateActions then
        TranslateComponent(actEmailPreview, sSysGnuViewerDomain);

      if CreateActions then
      actPrintStandard := TAction.Create(actList);
      with actPrintStandard do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actPrintStandard.Name;
        ImageIndex := frmMainForm.actPrintStandard.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actPrintStandard.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActPrintStandard;
        Hint := sHintActPrintStandard;
      end;
      if CreateActions then
        TranslateComponent(actPrintStandard, sSysGnuViewerDomain);

      if CreateActions then
      actPrintSelect := TAction.Create(actList);
      with actPrintSelect do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actPrintSelect.Name;
        ImageIndex := frmMainForm.actPrintSelect.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actPrintSelect.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActPrintSelect;
        Hint := sHintActPrintSelect;
      end;
      if CreateActions then
        TranslateComponent(actPrintSelect, sSysGnuViewerDomain);

      if CreateActions then
      actPrintPreview := TAction.Create(actList);
      with actPrintPreview do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actPrintPreview.Name;
        ImageIndex := frmMainForm.actPrintPreview.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actPrintPreview.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActPrintPreview;
        Hint := sCaptionActPrintPreview;
      end;
      if CreateActions then
        TranslateComponent(actPrintPreview, sSysGnuViewerDomain);

      if CreateActions then
      actSendDocumentsToWorkplace := TAction.Create(actList);
      with actSendDocumentsToWorkplace do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actSendDocumentsToWorkplace.Name;
        ImageIndex := frmMainForm.actSendDocumentsToWorkplace.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actSendDocumentsToWorkplace.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actSendDocumentsToWorkplaceExecute;
      end;
        Caption := sCaptionActSendDocumentsToWorkplace;
        Hint := sCaptionActSendDocumentsToWorkplace;
      end;
      if CreateActions then
        TranslateComponent(actSendDocumentsToWorkplace, sSysGnuViewerDomain);

      if CreateActions then
      actSendPagesToWorkplace := TAction.Create(actList);
      with actSendPagesToWorkplace do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actSendPagesToWorkplace.Name;
        ImageIndex := frmMainForm.actSendPagesToWorkplace.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actSendPagesToWorkplace.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actSendPagesToWorkplaceExecute;
      end;
        Caption := sCaptionActSendPagesToWorkplace;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actSendPagesToWorkplace, sSysGnuViewerDomain);

      if CreateActions then
      actSendPagesMergedToWorkplace := TAction.Create(actList);
      with actSendPagesMergedToWorkplace do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actSendPagesMergedToWorkplace.Name;
        ImageIndex := frmMainForm.actSendPagesMergedToWorkplace.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actSendPagesMergedToWorkplace.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actSendPagesMergedToWorkplaceExecute;
      end;
        Caption := sCaptionActSendPagesMergedToWorkplace;
        Hint := sCaptionActSendPagesMergedToWorkplace;
      end;
      if CreateActions then
        TranslateComponent(actSendPagesMergedToWorkplace, sSysGnuViewerDomain);

      if CreateActions then
      actSendDocumentsToImporter := TAction.Create(actList);
      with actSendDocumentsToImporter do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actSendDocumentsToImporter.Name;
        ImageIndex := frmMainForm.actSendDocumentsToImporter.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actSendDocumentsToImporter.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actSendDocumentsToImporterExecute;
      end;
        Caption := sCaptionActSendDocumentsToImporter;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actSendDocumentsToImporter, sSysGnuViewerDomain);

      if CreateActions then
      actSendDocumentPreviewsToImport := TAction.Create(actList);
      with actSendDocumentPreviewsToImport do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actSendDocumentPreviewsToImport.Name;
        ImageIndex := frmMainForm.actSendDocumentPreviewsToImport.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actSendDocumentPreviewsToImport.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actSendDocumentPreviewsToImportExecute;
      end;
        Caption := sCaptionActSendDocumentPreviewsToImport;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actSendDocumentPreviewsToImport, sSysGnuViewerDomain);

      if CreateActions then
      actSendPagesToImporter := TAction.Create(actList);
      with actSendPagesToImporter do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actSendPagesToImporter.Name;
        ImageIndex := frmMainForm.actSendPagesToImporter.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actSendPagesToImporter.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actSendPagesToImporterExecute;
      end;
        Caption := sCaptionActSendPagesToImporter;
        Hint := sCaptionActSendPagesToImporter;
      end;
      if CreateActions then
        TranslateComponent(actSendPagesToImporter, sSysGnuViewerDomain);

      if CreateActions then
      actSendPagesMergedToImporter := TAction.Create(actList);
      with actSendPagesMergedToImporter do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actSendPagesMergedToImporter.Name;
        ImageIndex := frmMainForm.actSendPagesMergedToImporter.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actSendPagesMergedToImporter.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actSendPagesMergedToImporterExecute;
      end;
        Caption := sCaptionActSendPagesMergedToImporter;
        Hint := sCaptionActSendPagesMergedToImporter;
      end;
      if CreateActions then
        TranslateComponent(actSendPagesMergedToImporter, sSysGnuViewerDomain);

      if CreateActions then
      actSendCopyToWorkplace := TAction.Create(actList);
      with actSendCopyToWorkplace do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actSendCopyToWorkplace.Name;
        ImageIndex := frmMainForm.actSendCopyToWorkplace.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actSendCopyToWorkplace.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actSendCopyToWorkplaceExecute;
      end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actSendCopyToWorkplace, sSysGnuViewerDomain);

      if CreateActions then
      actCreateCopy := TAction.Create(actList);
      with actCreateCopy do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actCreateCopy.Name;
        ImageIndex := frmMainForm.actCreateCopy.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actCreateCopy.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actCreateCopyExecute;
      end;
        Caption := sCaptionActCreateCopy;
        Hint := sCaptionActCreateCopy;
      end;
      if CreateActions then
        TranslateComponent(actCreateCopy, sSysGnuViewerDomain);

      if CreateActions then
      actInverted := TAction.Create(actList);
      with actInverted do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actInverted.Name;
        ImageIndex := frmMainForm.actInverted.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actInverted.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActInverted;
        Hint := sCaptionActInverted;
      end;
      if CreateActions then
        TranslateComponent(actInverted, sSysGnuViewerDomain);

      if CreateActions then
      actPublicAnno := TAction.Create(actList);
      with actPublicAnno do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actPublicAnno.Name;
        ImageIndex := frmMainForm.actPublicAnno.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actPublicAnno.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actPublicAnnoExecute;
      end;
        Caption := sCaptionActPublicAnno;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actPublicAnno, sSysGnuViewerDomain);

      if CreateActions then
      actPrivateAnno := TAction.Create(actList);
      with actPrivateAnno do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actPrivateAnno.Name;
        ImageIndex := frmMainForm.actPrivateAnno.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actPrivateAnno.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actPrivateAnnoExecute;
      end;
        Caption := sCaptionActPrivateAnno;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actPrivateAnno, sSysGnuViewerDomain);

      if CreateActions then
      actStationery := TAction.Create(actList);
      with actStationery do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actStationery.Name;
        ImageIndex := frmMainForm.actStationery.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actStationery.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actStationeryExecute;
      end;
        Caption := sCaptionActStationery;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actStationery, sSysGnuViewerDomain);

      if CreateActions then
      actShareLayer := TAction.Create(actList);
      with actShareLayer do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actShareLayer.Name;
        ImageIndex := frmMainForm.actShareLayer.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actShareLayer.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActShareLayer;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actShareLayer, sSysGnuViewerDomain);

      if CreateActions then
      actFirstPage := TAction.Create(actList);
      with actFirstPage do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actFirstPage.Name;
        ImageIndex := frmMainForm.actFirstPage.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actFirstPage.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actFirstPageExecute;
      end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actFirstPage, sSysGnuViewerDomain);

      if CreateActions then
      actLastPage := TAction.Create(actList);
      with actLastPage do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actLastPage.Name;
        ImageIndex := frmMainForm.actLastPage.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actLastPage.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actLastPageExecute;
      end;
        Caption := sEmptyString;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actLastPage, sSysGnuViewerDomain);

      if CreateActions then
      actRestoreOriginal := TAction.Create(actList);
      with actRestoreOriginal do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actRestoreOriginal.Name;
        ImageIndex := frmMainForm.actRestoreOriginal.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actRestoreOriginal.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actRestoreOriginalExecute;
      end;
        Caption := sCaptionActRestoreOriginal;
        Hint := sCaptionActRestoreOriginal;
      end;
      if CreateActions then
        TranslateComponent(actRestoreOriginal, sSysGnuViewerDomain);

//    // SJ 13.12.2021 - bfacrm:ticket__show__29424
//      actRefreshDoc := TAction.Create(actList);
//      with actRefreshDoc do
//      begin
//        Name := frmMainForm.actRefreshDoc.Name;
//        Caption := _(frmMainForm.actRefreshDoc.Caption);
//        ImageIndex := frmMainForm.actRefreshDoc.ImageIndex;
//        Enabled := False;
//        Hint := _(frmMainForm.actRefreshDoc.Hint);
//        ShortCut := frmMainForm.actRefreshDoc.ShortCut;
//        ActionList := actList;
//        OnExecute := frmMainForm.actListExecute;
//      end;
//    // SJ 13.12.2021 - bfacrm:ticket__show__29424

      if CreateActions then
      actDuplicateDoc := TAction.Create(actList);
      with actDuplicateDoc do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actDuplicateDoc.Name;
        ImageIndex := frmMainForm.actDuplicateDoc.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actDuplicateDoc.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Hint := sEmptyString;
        Caption := sCaptionActDuplicateDoc;
      end;
      if CreateActions then
        TranslateComponent(actDuplicateDoc, sSysGnuViewerDomain);

      if CreateActions then
      actExportCSV := TAction.Create(actList);
      with actExportCSV do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actExportCSV.Name;
        ImageIndex := frmMainForm.actExportCSV.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actExportCSV.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActExportCSV;
        Hint := sHintActExportCSV;
      end;
      if CreateActions then
        TranslateComponent(actExportCSV, sSysGnuViewerDomain);

      if CreateActions then
      actDeleteDoc := TAction.Create(actList);
      with actDeleteDoc do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actDeleteDoc.Name;
        ImageIndex := frmMainForm.actDeleteDoc.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actDeleteDoc.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActDeleteDoc;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actDeleteDoc, sSysGnuViewerDomain);

      if CreateActions then
      actDeScrew := TAction.Create(actList);
      with actDeScrew do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actDeScrew.Name;
        ImageIndex := frmMainForm.actDeScrew.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actDeScrew.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActDeScrew;
        Hint := sCaptionActDeScrew;
      end;
      if CreateActions then
        TranslateComponent(actDeScrew, sSysGnuViewerDomain);

      if CreateActions then
      actDeSpeckle := TAction.Create(actList);
      with actDeSpeckle do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actDeSpeckle.Name;
        ImageIndex := frmMainForm.actDeSpeckle.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actDeSpeckle.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActDeSpeckle;
        Hint := sCaptionActDeSpeckle;
      end;
      if CreateActions then
        TranslateComponent(actDeSpeckle, sSysGnuViewerDomain);

      if CreateActions then
      actRemoveBorder := TAction.Create(actList);
      with actRemoveBorder do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actRemoveBorder.Name;
        ImageIndex := frmMainForm.actRemoveBorder.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actRemoveBorder.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActRemoveBorder;
        Hint := sCaptionActRemoveBorder;
      end;
      if CreateActions then
        TranslateComponent(actRemoveBorder, sSysGnuViewerDomain);

      if CreateActions then
      actRotateLeft := TAction.Create(actList);
      with actRotateLeft do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actRotateLeft.Name;
        ImageIndex := frmMainForm.actRotateLeft.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actRotateLeft.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActRotateLeft;
        Hint := sCaptionActRotateLeft;
      end;
      if CreateActions then
        TranslateComponent(actRotateLeft, sSysGnuViewerDomain);

      if CreateActions then
      actExportXLS := TAction.Create(actList);
      with actExportXLS do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actExportXLS.Name;
        ImageIndex := frmMainForm.actExportXLS.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actExportXLS.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActExportXLS;
        Hint := sHintActExportXLS;
      end;
      if CreateActions then
        TranslateComponent(actExportXLS, sSysGnuViewerDomain);

      if CreateActions then
      actExportOO := TAction.Create(actList);
      with actExportOO do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actExportOO.Name;
        ImageIndex := frmMainForm.actExportOO.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actExportOO.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActExportOO;
        Hint := sHintActExportOO;
      end;
      if CreateActions then
        TranslateComponent(actExportOO, sSysGnuViewerDomain);

      if CreateActions then
      actFlip := TAction.Create(actList);
      with actFlip do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actFlip.Name;
        ImageIndex := frmMainForm.actFlip.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actFlip.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActFlip;
        Hint := sCaptionActFlip;
      end;
      if CreateActions then
        TranslateComponent(actFlip, sSysGnuViewerDomain);

      if CreateActions then
      actRotateRight := TAction.Create(actList);
      with actRotateRight do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actRotateRight.Name;
        ImageIndex := frmMainForm.actRotateRight.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actRotateRight.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActRotateRight;
        Hint := sCaptionActRotateRight;
      end;
      if CreateActions then
        TranslateComponent(actRotateRight, sSysGnuViewerDomain);

      if CreateActions then
      actMergeDoc := TAction.Create(actList);
      with actMergeDoc do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actMergeDoc.Name;
        ImageIndex := frmMainForm.actMergeDoc.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actMergeDoc.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actMergeDocExecute;
      end;
        Caption := sCaptionActMergeDoc;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actMergeDoc, sSysGnuViewerDomain);

      if CreateActions then
      actPreviousPage := TAction.Create(actList);
      with actPreviousPage do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actPreviousPage.Name;
        ImageIndex := frmMainForm.actPreviousPage.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actPreviousPage.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actPreviousPageExecute;
      end;
        Caption := sCaptionActPreviousPage;
        Hint := sCaptionActPreviousPage;
      end;
      if CreateActions then
        TranslateComponent(actPreviousPage, sSysGnuViewerDomain);

      if CreateActions then
      actNextPage := TAction.Create(actList);
      with actNextPage do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actNextPage.Name;
        ImageIndex := frmMainForm.actNextPage.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actNextPage.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actNextPageExecute;
      end;
        Caption := sCaptionActNextPage;
        Hint := sCaptionActNextPage;
      end;
      if CreateActions then
        TranslateComponent(actNextPage, sSysGnuViewerDomain);

      if CreateActions then
      actAutozoom := TAction.Create(actList);
      with actAutozoom do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actAutozoom.Name;
        ImageIndex := frmMainForm.actAutozoom.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actAutozoom.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActAutozoom;
        Hint := sCaptionactAutozoom;
      end;
      if CreateActions then
        TranslateComponent(actAutozoom, sSysGnuViewerDomain);

      if CreateActions then
      actZoom100 := TAction.Create(actList);
      with actZoom100 do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actZoom100.Name;
        ImageIndex := frmMainForm.actZoom100.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actZoom100.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActZoom100;
        Hint := sCaptionActZoom100;
      end;
      if CreateActions then
        TranslateComponent(actZoom100, sSysGnuViewerDomain);

      if CreateActions then
      actZoomPage := TAction.Create(actList);
      with actZoomPage do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actZoomPage.Name;
        ImageIndex := frmMainForm.actZoomPage.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actZoomPage.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActZoomPage;
        Hint := sCaptionActZoomPage;
      end;
      if CreateActions then
        TranslateComponent(actZoomPage, sSysGnuViewerDomain);

      if CreateActions then
      actZoomWidth := TAction.Create(actList);
      with actZoomWidth do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actZoomWidth.Name;
        ImageIndex := frmMainForm.actZoomWidth.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actZoomWidth.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActZoomWidth;
        Hint := sCaptionActZoomWidth;
      end;
      if CreateActions then
        TranslateComponent(actZoomWidth, sSysGnuViewerDomain);

      if CreateActions then
      actZoomHeight := TAction.Create(actList);
      with actZoomHeight do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actZoomHeight.Name;
        ImageIndex := frmMainForm.actZoomHeight.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actZoomHeight.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActZoomHeight;
        Hint := sCaptionActZoomHeight;
      end;
      if CreateActions then
        TranslateComponent(actZoomHeight, sSysGnuViewerDomain);

      if CreateActions then
      actZoomSelect := TAction.Create(actList);
      with actZoomSelect do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actZoomSelect.Name;
        ImageIndex := frmMainForm.actZoomSelect.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actZoomSelect.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActZoomSelect;
        Hint := sCaptionActZoomSelect;
      end;
      if CreateActions then
        TranslateComponent(actZoomSelect, sSysGnuViewerDomain);

      if CreateActions then
      actZoomOff := TAction.Create(actList);
      with actZoomOff do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actZoomOff.Name;
        ImageIndex := frmMainForm.actZoomOff.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actZoomOff.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActZoomOff;
        Hint := sCaptionActZoomOff;
      end;
      if CreateActions then
        TranslateComponent(actZoomOff, sSysGnuViewerDomain);

      if CreateActions then
      actLinks := TAction.Create(actList);
      with actLinks do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actLinks.Name;
        ImageIndex := frmMainForm.actLinks.ImageIndex;
        Enabled := True;
        ShortCut := frmMainForm.actLinks.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActLinks;
        Hint := sHintActLinks;
      end;
      if CreateActions then
        TranslateComponent(actLinks, sSysGnuViewerDomain);

      if CreateActions then
      actAuditProof := TAction.Create(actList);
      with actAuditProof do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actAuditProof.Name;
        ImageIndex := frmMainForm.actAuditProof.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actAuditProof.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actAuditProofExecute;
      end;
        Caption := sCaptionActAuditProof;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actAuditProof, sSysGnuViewerDomain);

      if CreateActions then
      actEditTags := TAction.Create(actList);
      with actEditTags do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actEditTags.Name;
        ImageIndex := frmMainForm.actEditTags.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actEditTags.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actEditTagsExecute;
      end;
        Caption := sCaptionActEditTags;
        Hint := sCaptionActEditTags;
      end;
      if CreateActions then
        TranslateComponent(actEditTags, sSysGnuViewerDomain);

      if CreateActions then
      actNewLink := TAction.Create(actList);
      with actNewLink do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actNewLink.Name;
        ImageIndex := frmMainForm.actNewLink.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actNewLink.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actNewLinkExecute;
      end;
        Caption := sCaptionActNewLink;
        Hint := sCaptionActNewLink;
      end;
      if CreateActions then
        TranslateComponent(actNewLink, sSysGnuViewerDomain);

      if CreateActions then
      actAddLink := TAction.Create(actList);
      with actAddLink do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actAddLink.Name;
        ImageIndex := frmMainForm.actAddLink.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actAddLink.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actAddLinkExecute;
      end;
        Caption := sCaptionActAddLink;
        Hint := sCaptionActAddLink;
      end;
      if CreateActions then
        TranslateComponent(actAddLink, sSysGnuViewerDomain);

      if CreateActions then
      actOriginalfile := TAction.Create(actList);
      with actOriginalfile do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actOriginalfile.Name;
        ImageIndex := frmMainForm.actOriginalfile.ImageIndex;
        Enabled := True;
        ShortCut := frmMainForm.actOriginalfile.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActOriginalfile;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actOriginalfile, sSysGnuViewerDomain);

      if CreateActions then
      actCheckout := TAction.Create(actList);
      with actCheckout do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actCheckout.Name;
        ImageIndex := frmMainForm.actCheckout.ImageIndex;
        Enabled := True;
        ShortCut := frmMainForm.actCheckout.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActCheckout;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actCheckout, sSysGnuViewerDomain);

      if CreateActions then
      actInProgress := TAction.Create(actList);
      with actInProgress do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actInProgress.Name;
        ImageIndex := frmMainForm.actInProgress.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actInProgress.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actInProgressExecute;
      end;
        Caption := sCaptionActInProgress;
        Hint := sHintActInProgress;
      end;
      if CreateActions then
        TranslateComponent(actInProgress, sSysGnuViewerDomain);

      if CreateActions then
      actIsAuditProof := TAction.Create(actList);
      with actIsAuditProof do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actIsAuditProof.Name;
        ImageIndex := frmMainForm.actIsAuditProof.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actIsAuditProof.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actListExecute;
      end;
        Caption := sCaptionActIsAuditProof;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actIsAuditProof, sSysGnuViewerDomain);

      if CreateActions then
      actDeletePages := TAction.Create(actList);
      with actDeletePages do
      begin
        if CreateActions then
        begin
        Name := frmMainForm.actDeletePages.Name;
        ImageIndex := frmMainForm.actDeletePages.ImageIndex;
        Enabled := False;
        ShortCut := frmMainForm.actDeletePages.ShortCut;
        ActionList := actList;
        OnExecute := frmMainForm.actDeletePagesExecute;
      end;
        Caption := sCaptionActDeletePages;
        Hint := sCaptionActDeletePages;
      end;
      if CreateActions then
        TranslateComponent(actDeletePages, sSysGnuViewerDomain);

      if CreateActions then
      actChangeDocName := TAction.Create(actList);
      with actChangeDocName do
      begin
        if CreateActions then
        begin
          Name := frmMainForm.actChangeDocName.Name;
          ImageIndex := frmMainForm.actChangeDocName.ImageIndex;
          Enabled := False;
          ShortCut := frmMainForm.actChangeDocName.ShortCut;
          ActionList := actList;
          OnExecute := frmMainForm.actChangeDocNameExecute;
        end;
        Caption := sCaptionActChangeDocName;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actChangeDocName, sSysGnuViewerDomain);

      if CreateActions then
        actAutoRef := TAction.Create(actList);
      with actAutoRef do
      begin
        if CreateActions then
        begin
          Name := frmMainForm.actAutoRef.Name;
          ImageIndex := frmMainForm.actAutoRef.ImageIndex;
          Enabled := False;
          ShortCut := frmMainForm.actAutoRef.ShortCut;
          ActionList := actList;
          OnExecute := frmMainForm.actAutoRefExecute;
        end;
        Caption := sCaptionActAutoRef;
        Hint := sCaptionActAutoRef;
      end;
      if CreateActions then
        TranslateComponent(actAutoRef, sSysGnuViewerDomain);

      if CreateActions then
      actFtxPos := TAction.Create(actList);
      with actFtxPos do
      begin
        if CreateActions then
        begin
          Name := frmMainForm.actFtxPos.Name;
          ImageIndex := frmMainForm.actFtxPos.ImageIndex;
          Enabled := False;
          ShortCut := frmMainForm.actFtxPos.ShortCut;
          ActionList := actList;
          OnExecute := frmMainForm.actFtxPosExecute;
        end;
        Caption := sEmptyString;
        Hint := sHintActFtxPos;
      end;
      if CreateActions then
        TranslateComponent(actFtxPos, sSysGnuViewerDomain);

      {$IFDEF ENTERPRISE}
      if CreateActions then
        actDocAbo := TAction.Create(actList);
      with actDocAbo do
      begin
        if CreateActions then
        begin
          Name := TfrmEnterprise(frmMainForm).actDocAbo.Name;
          ImageIndex := TfrmEnterprise(frmMainForm).actDocAbo.ImageIndex;
          Enabled := False;
          ShortCut := TfrmEnterprise(frmMainForm).actDocAbo.ShortCut;
          ActionList := actList;
          OnExecute := frmMainForm.actListExecute;
        end;
        Caption := sCaptionActDocAbo;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actDocAbo, sSysGnuViewerDomain);
      {$ENDIF}

      if CreateActions then
        actCopyDocToClipboard := TAction.Create(actList);
      with actCopyDocToClipboard do
      begin
        if CreateActions then
        begin
          Name := frmMainForm.actCopyDocToClipboard.Name;
          ImageIndex := frmMainForm.actCopyDocToClipboard.ImageIndex;
          Enabled := False;
          ShortCut := frmMainForm.actCopyDocToClipboard.ShortCut;
          ActionList := actList;
          OnExecute := frmMainForm.actCopyDocToClipboardExecute;
        end;
        Caption := sCaptionActCopyDocToClipboard;
        Hint := sCaptionActCopyDocToClipboard;
      end;
      if CreateActions then
        TranslateComponent(actCopyDocToClipboard, sSysGnuViewerDomain);

      if CreateActions then
        actRangeOCR := TAction.Create(actList);
      with actRangeOCR do
      begin
        if CreateActions then
        begin
          Name := frmMainForm.actRangeOCR.Name;
          ImageIndex := frmMainForm.actRangeOCR.ImageIndex;
          Enabled := True;
          ShortCut := frmMainForm.actRangeOCR.ShortCut;
          ActionList := actList;
          OnExecute := frmMainForm.actRangeOCRExecute;
        end;
        Hint := sCaptionActRangeOCR;
        Caption := sCaptionActRangeOCR;
      end;
      if CreateActions then
        TranslateComponent(actRangeOCR, sSysGnuViewerDomain);

      if CreateActions then
        actCopyOriginalDocToClipboard := TAction.Create(actList);
      with actCopyOriginalDocToClipboard do
      begin
        if CreateActions then
        begin
          Name := frmMainForm.actCopyOriginalDocToClipboard.Name;
          ImageIndex := frmMainForm.actCopyOriginalDocToClipboard.ImageIndex;
          Enabled := True;
          ShortCut := frmMainForm.actCopyOriginalDocToClipboard.ShortCut;
          ActionList := actList;
          OnExecute := frmMainForm.actCopyOriginalDocToClipboardExecute;
        end;
        Caption := sCaptionActCopyOriginalDocToClipboard;
        Hint := sCaptionActCopyOriginalDocToClipboard;
      end;
      if CreateActions then
        TranslateComponent(actCopyOriginalDocToClipboard, sSysGnuViewerDomain);

      if CreateActions then
        actCopyPageToClipboard := TAction.Create(actList);
      with actCopyPageToClipboard do
      begin
        if CreateActions then
        begin
          Name := frmMainForm.actCopyPageToClipboard.Name;
          ImageIndex := frmMainForm.actCopyPageToClipboard.ImageIndex;
          Enabled := True;
          ShortCut := frmMainForm.actCopyPageToClipboard.ShortCut;
          ActionList := actList;
          OnExecute := frmMainForm.actCopyPageToClipboardExecute;
        end;
        Caption := sCaptionActCopyPageToClipboard;
        Hint := sCaptionActCopyPageToClipboard;
      end;
      if CreateActions then
        TranslateComponent(actCopyPageToClipboard, sSysGnuViewerDomain);

      if CreateActions then
        actCopyDocLinkToClipboard := TAction.Create(actList);
      with actCopyDocLinkToClipboard do
      begin
        if CreateActions then
        begin
          Name := frmMainForm.actCopyDocLinkToClipboard.Name;
          ImageIndex := frmMainForm.actCopyDocLinkToClipboard.ImageIndex;
          Enabled := True;
          ShortCut := frmMainForm.actCopyDocLinkToClipboard.ShortCut;
          ActionList := actList;
          OnExecute := frmMainForm.actCopyDocLinkToClipboardExecute;
        end;
        Caption := sCaptionActCopyDocLinkToClipboard;
        Hint := sCaptionActCopyDocLinkToClipboard;
      end;
      if CreateActions then
        TranslateComponent(actCopyDocLinkToClipboard, sSysGnuViewerDomain);

      if CreateActions then
        actGoToOriginalDocument := TAction.Create(actList);
      with actGoToOriginalDocument do
      begin
        if CreateActions then
        begin
          Name := frmMainForm.actGoToOriginalDocument.Name;
          ImageIndex := frmMainForm.actGoToOriginalDocument.ImageIndex;
          Enabled := True;
          ShortCut := frmMainForm.actGoToOriginalDocument.ShortCut;
          ActionList := actList;
          OnExecute := frmMainForm.actListExecute;
        end;
        Caption := sCaptionActGoToOriginalDocument;
        Hint := sEmptyString;
      end;
      if CreateActions then
        TranslateComponent(actGoToOriginalDocument, sSysGnuViewerDomain);

      if CreateActions then
        actDeleteSelected := TAction.Create(actList);
      with actDeleteSelected do
      begin
        if CreateActions then
        begin
          Name := frmMainForm.actDeleteSelected.Name;
          ImageIndex := frmMainForm.actDeleteSelected.ImageIndex;
          Enabled := (FList <> nil) and (FList.Count > 0) and (FbfaPreviewKind <> pvkSingle);
          ShortCut := frmMainForm.actDeleteSelected.ShortCut;
          ActionList := actList;
          OnExecute := frmMainForm.actDeleteSelected.OnExecute;
        end;
        Caption := sCaptionActDeleteSelected;
        Hint := sCaptionActDeleteSelected;
      end;
      if CreateActions then
        TranslateComponent(actDeleteSelected, sSysGnuViewerDomain);

      if Retranslate then
      for i := 0 to actList.ActionCount -1 do
          ReTranslateComponent(actList[i], sSysGnuViewerDomain)
      else
        for i := 0 to actList.ActionCount -1 do
          TranslateComponent(actList[i], sSysGnuViewerDomain);
    except
      bitfarmLog.Write(llNormal, ltException, 'CloneActions - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'CloneActions - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.actGraphicOptionsExecute(Sender: TObject);
begin
  try
    try
      if bitfarmApp.PreviewContainer.ActiveItem <> Self.Parent.Tag then
        SetActivePreview(Self);

      frm_DocEditOpt := Tfrm_DocEditOpt.Create(Self);
      try
        frm_DocEditOpt.cbb_fav.Images := bfaIconsDM.bfaIcons.ilPreview;
        frm_DocEditOpt.cbb_fav.Items[0].ImageIndex := -1;
        frm_DocEditOpt.cbb_fav.Items[1].ImageIndex := Integer(icoidx_stamp_yellow);
        frm_DocEditOpt.cbb_fav.Items[2].ImageIndex := Integer(icoidx_stamp_green);
        frm_DocEditOpt.cbb_fav.Items[3].ImageIndex := Integer(icoidx_stamp_red);
        frm_DocEditOpt.cbb_fav.Items[4].ImageIndex := Integer(icoidx_stamp_blue);
        frm_DocEditOpt.cbb_fav.Items[5].ImageIndex := Integer(icoidx_stamp_orange);
        frm_DocEditOpt.cbb_fav.Items[6].ImageIndex := Integer(icoidx_stamp_pink);
        frm_DocEditOpt.cbb_fav.Items[7].ImageIndex := Integer(icoidx_stamp_grey);
        frm_DocEditOpt.cbb_fav.Items[8].ImageIndex := Integer(icoidx_stamp_purple);
        frm_DocEditOpt.cbb_fav.Items[9].ImageIndex := Integer(icoidx_stamp_aqua);
        frm_DocEditOpt.cbb_fav.Items[10].ImageIndex := Integer(icoidx_stamp_black);

        frm_DocEditOpt.ShowModal;
      finally
        frm_DocEditOpt.Release;
      end;
      UnCheckAllGraphicTools;

      if (FbfaPreviewKind = pvkSingle) then
        LoadFavStampbuttons(gasfavstemp, tbi_fav1, tbi_fav2, tbi_fav3, tbi_fav4, tbi_fav5, tbi_fav6, tbi_fav7, tbi_fav8, tbi_fav9, tbi_fav10);

      if (FActiveDoc <> nil) and (FbfaPreviewKind = pvkSingle) then
        SetAnnoToolBar(FActiveDoc.InEditMode);
    except
      bitfarmLog.Write(llNormal, ltException, 'actGraphicOptionsExecute', ClassName);
    end;
  finally
    frm_DocEditOpt := nil;
  end;
end;

procedure TbfaPreview.ChangePage(Actionname: string; Param: Integer; SetImagePos: Boolean = False; SetImagePosTothetop: Boolean = False; Autozoom: Boolean = True);
var
  UserAction: PUserAction;
  imgidx, imgcnt: Integer;
  ExecuteAction: Boolean;
begin
  bitfarmLog.DebugBegin(llDebug, 'ChangePage - ' + Self.Name, Classname);
  try
    try
      ExecuteAction := True;
      if (bitfarmApp.GetActivePreview <> nil) and (bitfarmApp.GetActivePreview.ActiveDoc <> nil) then
      begin
        if (bitfarmApp.GetActivePreview.ActiveDoc <> nil) and
           (bitfarmApp.GetActivePreview.ActiveDoc.ScanPoolView <> nil) and
           (bitfarmApp.GetActivePreview.ActiveDoc.ScanPoolViewLoaded) then
        begin
          imgidx := TbfaPreview(Self).ActivePage;
          imgcnt := TbfaPreview(Self).ActiveDoc.ScanPoolView.ImageCount;
        end
        else
        begin
          imgidx := bitfarmApp.GetActivePreview.SingleView.img_DocView.IO.Params.ImageIndex;
          imgcnt := bitfarmApp.GetActivePreview.SingleView.img_DocView.IO.Params.ImageCount;
        end;
      end;

      if ((Actionname = 'actPreviousPage') and (imgidx < 1)) or
         ((Actionname = 'actNextPage') and (imgidx >= imgcnt - 1))
      then
        ExecuteAction := False;

      if ExecuteAction then
      begin
        UserAction := bitfarmApp.CreateUserAction;
        UserAction^.Actionname := Actionname;
        UserAction^.Params.Add(IntToStr(Param));

        if SetImagePos then
          UserAction^.Params.Add('1')
        else
          UserAction^.Params.Add('0');

        if SetImagePosTothetop then
          UserAction^.Params.Add('1')
        else
          UserAction^.Params.Add('0');

        if Autozoom then
          UserAction^.Params.Add('1')
        else
          UserAction^.Params.Add('0');

        UserAction^.Preview := Self;
        bitfarmApp.MainThread.Add(UserAction);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'ChangePage - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'ChangePage - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.SendPagesTo(prev: TbfaPreview; Merged: Boolean);
var
  UserAction: PUserAction;
  i: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'SendPagesTo - ' + Self.Name, Classname);
  try
    try
      if (prev = bitfarmApp.PreviewContainer.WorkplaceItem.Preview) and (FList[0].ID = -1) then
        Exit;

      if (FbfaPreviewKind = pvkSingle) or (FbfaPreviewKind = pvkMultiSingle) then
      begin
        UserAction := bitfarmApp.CreateUserAction;
        if prev = bitfarmApp.PreviewContainer.WorkplaceItem.Preview then
          UserAction^.Actionname := 'actSendPagesToWorkplace'
        else if prev = bitfarmApp.PreviewContainer.ImporterItem.Preview then
          UserAction^.Actionname := 'actSendPagesToImporter';
        UserAction^.Preview := prev;
        if Merged then
          UserAction^.Options := 0
        else
          UserAction^.Options := 1;
        bitfarmApp.CloneCurrentDocs(UserAction, True);
        TbfaDocument(UserAction^.Documents[0]).SelectedPages.Clear;

        if FimgThumbnailView.MultiSelectedImagesCount > 0 then
        begin
          for i := 0 to FimgThumbnailView.MultiSelectedImagesCount - 1 do
          begin
            TbfaDocument(UserAction^.Documents[0]).SelectedPages.Add(IntToStr(FimgThumbnailView.MultiSelectedImages[i] + 1));
            UserAction^.Params.Add(IntToStr(FimgThumbnailView.MultiSelectedImages[i] + 1));
          end;
        end
        else
        begin
          TbfaDocument(UserAction^.Documents[0]).SelectedPages.Add(IntToStr(FimgSingleView.img_DocView.IO.Params.ImageIndex));
          UserAction^.Params.Add(IntToStr(FimgSingleView.img_DocView.IO.Params.ImageIndex));
        end;

        bitfarmApp.MainThread.Add(UserAction);
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'SendPagesTo - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SendPagesTo - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.AddStationery(AThread: TThread);
var
  FName: WideString;
begin
  bitfarmLog.DebugBegin(llDebug, 'AddStationery - ' + Self.Name, Classname);
  try
    try
      RemoveStationery(AThread);

      AThread.Synchronize(nil,
        procedure
        var
          i: Integer;
        begin
          FName := '';

          for i := 0 to bfaTlbPreview.sbmStationery.Count - 1 do
            if bfaTlbPreview.sbmStationery[i].Checked then
              FName := frmMainForm.bfaTlbPreview1.sbmStationery[i].Caption;

          bitfarmApp.LoadStationeryToDocument(FActiveDoc, FName);

          FStatObj.Load(FimgSingleView.img_DocView,
            FimgSingleView.img_DocView.IO.Params.ImageCount, '',
            FActiveDoc.LetterStream);

          FActiveDoc.DocStream.Position := 0;
          FimgSingleView.img_DocView.IO.LoadFromStream(FActiveDoc.DocStream);
        end);

    except
      bitfarmLog.Write(llNormal, ltException, 'AddStationery - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'AddStationery - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.SaveToolBarLayout;
begin
  if (not frmMainForm.fAppStarted) or (FPreviewCreating) then
    Exit;

  try
//09.01.2020 neue Inis   SpTBXCustomizer1.SaveLayout(BD.AppdataBitfarmPd + 'PreviewLayout.ini', 'Preview');
    SpTBXCustomizer1.SaveLayout(BD.AppdataBitfarmPd + 'ViewerLayout.ini', 'bfaPreview');
    bitfarmLog.Write(llDebug, ltinfo, 'Layout bfaPreview saved: ' + BD.AppdataBitfarmPd + 'ViewerLayout.ini', Classname);
  except
    bitfarmLog.Write(llNormal, ltException, 'SpTBXCustomizer1.SaveLayout;', ClassName);
  end;
end;

procedure TbfaPreview.LoadToolBarLayout(idx: Integer = -1; DoStandard: Boolean = False);
var
  Lyt, LytName: string; //09.01.2020
begin
  try
// 09.01.2020 neue Inis -->
    Lyt := '';
    LytName := 'bfaPreview';
    if bitfarmApp.GlobalViewerLayout <> '' then
      Lyt := bitfarmApp.GlobalViewerLayout
    else if bitfarmApp.ViewerLayout <> '' then
      Lyt := bitfarmApp.ViewerLayout
    else
    begin
      Lyt := BD.AppdataBitfarmPd + 'PreviewLayout.ini';
      LytName := 'Preview';
    end;
//09.01.2020    if FileExists(BD.AppdataBitfarmPd + 'PreviewLayout.ini') then
    if FileExists(Lyt) and not DoStandard then
// 09.01.2020 -->
    begin
      try
        if idx = 0 then   // ViewerPreview
//09.01.2020          SpTBXCustomizer1.LoadLayout(BD.AppdataBitfarmPd + 'PreviewLayout.ini', 'Preview')
          SpTBXCustomizer1.LoadLayout(Lyt, LytName)
        else begin
          with navigationToolBar do
          begin
            if bitfarmApp.PreviewContainer.ViewerItem.Preview.navigationToolBar.CurrentDock.Name = 'previewDockLeft' then
              CurrentDock := Self.previewDockLeft
            else
            if bitfarmApp.PreviewContainer.ViewerItem.Preview.navigationToolBar.CurrentDock.Name = 'previewDockRight' then
              CurrentDock := Self.previewDockRight
            else
            if bitfarmApp.PreviewContainer.ViewerItem.Preview.navigationToolBar.CurrentDock.Name = 'previewDockTop' then
              CurrentDock := Self.previewDockTop
            else
            if bitfarmApp.PreviewContainer.ViewerItem.Preview.navigationToolBar.CurrentDock.Name = 'previewDockBottom' then
              CurrentDock := Self.previewDockBottom;

            DockRow := bitfarmApp.PreviewContainer.ViewerItem.Preview.navigationToolBar.DockRow;
            DockPos := bitfarmApp.PreviewContainer.ViewerItem.Preview.navigationToolBar.DockPos;
          end;

          with AnnoToolbar do
          begin
            if bitfarmApp.PreviewContainer.ViewerItem.Preview.AnnoToolbar.CurrentDock.Name = 'previewDockLeft' then
              CurrentDock := Self.previewDockLeft
            else if bitfarmApp.PreviewContainer.ViewerItem.Preview.AnnoToolbar.CurrentDock.Name = 'previewDockRight' then
              CurrentDock := Self.previewDockRight
            else if bitfarmApp.PreviewContainer.ViewerItem.Preview.AnnoToolbar.CurrentDock.Name = 'previewDockTop' then
              CurrentDock := Self.previewDockTop
            else if bitfarmApp.PreviewContainer.ViewerItem.Preview.AnnoToolbar.CurrentDock.Name = 'previewDockBottom' then
              CurrentDock := Self.previewDockBottom;

            DockRow := bitfarmApp.PreviewContainer.ViewerItem.Preview.AnnoToolbar.DockRow;
            DockPos := bitfarmApp.PreviewContainer.ViewerItem.Preview.AnnoToolbar.DockPos;
          end;

          with previewToolWindow do
          begin
            if bitfarmApp.PreviewContainer.ViewerItem.Preview.previewToolWindow.CurrentDock.Name = 'previewDockLeft' then
              CurrentDock := Self.previewDockLeft
            else if bitfarmApp.PreviewContainer.ViewerItem.Preview.previewToolWindow.CurrentDock.Name = 'previewDockRight' then
              CurrentDock := Self.previewDockRight
            else if bitfarmApp.PreviewContainer.ViewerItem.Preview.previewToolWindow.CurrentDock.Name = 'previewDockTop' then
              CurrentDock := Self.previewDockTop
            else if bitfarmApp.PreviewContainer.ViewerItem.Preview.previewToolWindow.CurrentDock.Name = 'previewDockBottom' then
              CurrentDock := Self.previewDockBottom;

            DockRow := bitfarmApp.PreviewContainer.ViewerItem.Preview.previewToolWindow.DockRow;
            DockPos := bitfarmApp.PreviewContainer.ViewerItem.Preview.previewToolWindow.DockPos;
            ClientWidth := 96;
            ClientHeight := 839;
          end;

          with PreviewSelectToolbar do
          begin
            if bitfarmApp.PreviewContainer.ViewerItem.Preview.PreviewSelectToolbar.CurrentDock.Name = 'previewDockLeft' then
              CurrentDock := Self.previewDockLeft
            else if bitfarmApp.PreviewContainer.ViewerItem.Preview.PreviewSelectToolbar.CurrentDock.Name = 'previewDockRight' then
              CurrentDock := Self.previewDockRight
            else if bitfarmApp.PreviewContainer.ViewerItem.Preview.PreviewSelectToolbar.CurrentDock.Name = 'previewDockTop' then
              CurrentDock := Self.previewDockTop
            else if bitfarmApp.PreviewContainer.ViewerItem.Preview.PreviewSelectToolbar.CurrentDock.Name = 'previewDockBottom' then
              CurrentDock := Self.previewDockBottom;

            DockRow := bitfarmApp.PreviewContainer.ViewerItem.Preview.PreviewSelectToolbar.DockRow;
            DockPos := bitfarmApp.PreviewContainer.ViewerItem.Preview.PreviewSelectToolbar.DockPos;
          end;

          with FbfaTlbPreview do
          begin
            if bitfarmApp.PreviewContainer.ViewerItem.Preview.FbfaTlbPreview.CurrentDock.Name = 'previewDockLeft' then
              CurrentDock := Self.previewDockLeft
            else if bitfarmApp.PreviewContainer.ViewerItem.Preview.FbfaTlbPreview.CurrentDock.Name = 'previewDockRight' then
              CurrentDock := Self.previewDockRight
            else if bitfarmApp.PreviewContainer.ViewerItem.Preview.FbfaTlbPreview.CurrentDock.Name = 'previewDockTop' then
              CurrentDock := Self.previewDockTop
            else if bitfarmApp.PreviewContainer.ViewerItem.Preview.FbfaTlbPreview.CurrentDock.Name = 'previewDockBottom' then
              CurrentDock := Self.previewDockBottom;

            DockRow := bitfarmApp.PreviewContainer.ViewerItem.Preview.FbfaTlbPreview.DockRow;
            DockPos := bitfarmApp.PreviewContainer.ViewerItem.Preview.FbfaTlbPreview.DockPos;
          end;

          with FbfaTlbStandard do
          begin
            if bitfarmApp.PreviewContainer.ViewerItem.Preview.FbfaTlbStandard.CurrentDock.Name = 'previewDockLeft' then
              CurrentDock := Self.previewDockLeft
            else if bitfarmApp.PreviewContainer.ViewerItem.Preview.FbfaTlbStandard.CurrentDock.Name = 'previewDockRight' then
              CurrentDock := Self.previewDockRight
            else if bitfarmApp.PreviewContainer.ViewerItem.Preview.FbfaTlbStandard.CurrentDock.Name = 'previewDockTop' then
              CurrentDock := Self.previewDockTop
            else if bitfarmApp.PreviewContainer.ViewerItem.Preview.FbfaTlbStandard.CurrentDock.Name = 'previewDockBottom' then
              CurrentDock := Self.previewDockBottom;

            DockRow := bitfarmApp.PreviewContainer.ViewerItem.Preview.FbfaTlbStandard.DockRow;
            DockPos := bitfarmApp.PreviewContainer.ViewerItem.Preview.FbfaTlbStandard.DockPos;
          end;

          with tlbResubFavs do
          begin
            if bitfarmApp.PreviewContainer.ViewerItem.Preview.tlbResubFavs.CurrentDock.Name = 'previewDockLeft' then
              CurrentDock := Self.previewDockLeft
            else if bitfarmApp.PreviewContainer.ViewerItem.Preview.tlbResubFavs.CurrentDock.Name = 'previewDockRight' then
              CurrentDock := Self.previewDockRight
            else if bitfarmApp.PreviewContainer.ViewerItem.Preview.tlbResubFavs.CurrentDock.Name = 'previewDockTop' then
              CurrentDock := Self.previewDockTop
            else if bitfarmApp.PreviewContainer.ViewerItem.Preview.tlbResubFavs.CurrentDock.Name = 'previewDockBottom' then
              CurrentDock := Self.previewDockBottom;

            DockRow := bitfarmApp.PreviewContainer.ViewerItem.Preview.tlbResubFavs.DockRow;
            DockPos := bitfarmApp.PreviewContainer.ViewerItem.Preview.tlbResubFavs.DockPos;
          end;
        end;
        FbfaTlbPreview.Visible := Self.Floating;
        FbfaTlbStandard.Visible := Self.Floating;
        // <!-- SJ 16.12.2019 - bfacrm:ticket__show__21501
        if Self.Floating then
        begin
          FbfaTlbStandard.DockableTo := [dpTop,dpBottom];
          FbfaTlbPreview.DockableTo := [dpTop,dpBottom];
        end;
        // SJ 16.12.2019 - bfacrm:ticket__show__21501 -->
        tlbResubFavs.Visible := bitfarmApp.ViewerOptions.ResubOptions.ResubFavsInPreview;
        bitfarmLog.Write(llDebug, ltinfo, 'Layout Loaded: ' + BD.AppdataBitfarmPd + 'PreviewLayout.ini', Classname);
      except
        bitfarmLog.Write(llNormal, ltException, 'SpTBXCustomizer1.LoadLayout;', ClassName);
      end;
    end
    else
    begin
      if not FPreviewCreating then
      begin
        try
          with navigationToolBar do
          begin
            CurrentDock := previewDockTop;
            LastDock := previewDockTop;
            DockRow := 0;
            DockPos := -2;
          end;

          with AnnoToolbar do
          begin
            CurrentDock := previewDockLeft;
            LastDock := previewDockLeft;
            DockRow := 0;
            DockPos := 0;
          end;

          with previewToolWindow do
          begin
            CurrentDock := previewDockLeft;
            LastDock := previewDockLeft;
            DockRow := 0;
            DockPos := 4;
            ClientWidth := 96;
            ClientHeight := 839;
          end;

          with PreviewSelectToolbar do
          begin
            CurrentDock := previewDockRight;
            LastDock := previewDockRight;
            DockRow := 0;
            DockPos := 0;
          end;

          with FbfaTlbPreview do
          begin
            CurrentDock := previewDockTop;
            LastDock := previewDockTop;
            DockRow := 0;
            DockPos := -1;
          end;

          with FbfaTlbStandard do
          begin
            CurrentDock := previewDockTop;
            LastDock := previewDockTop;
            DockRow := 0;
            DockPos := -1;
          end;

        except
          bitfarmLog.Write(llNormal, ltException, 'Create Standard', ClassName);
        end;
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'LoadToolBarLayout', ClassName);
  end;
end;

procedure TbfaPreview.RemoveStationery(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'RemoveStationery - ' + Self.Name, Classname);
  try
    try
      if FStatObj <> nil then
      begin
        AThread.Synchronize(nil,
          procedure
          var
            i: Integer;
          begin
            if (Length(FStatObj.Layers) > 0) then
            begin
              for i := High(FStatObj.Layers) downto Low(FStatObj.Layers) do
              begin
                if FStatObj.Layers[i] <> 0 then
                begin
                  try
                    FimgSingleView.img_DocView.Layers[FStatObj.Layers[i]].Visible := False;
                    FimgSingleView.img_DocView.LayersRemove(FStatObj.Layers[i]);
                  finally
                    FStatObj.Layers[i] := 0;
                  end;
                end;
              end;
              SetLength(FStatObj.Layers, 0);
              FimgSingleView.img_DocView.Update;
            end;
          end);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'RemoveStationery - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'RemoveStationery - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.SaveNewDocName(Save: Boolean);
var
  UserAction: PUserAction;
begin
  if FChangeDocNameInProcess then
    Exit;

  bitfarmLog.DebugBegin(llDebug, 'SaveNewDocName - ' + Self.Name, Classname);
  try
    try
      if FbfaPreviewKind = pvkMulti then
      begin
        if (FChangeEditDocIdx <> -1) and (not FChangeDocNameInProcess) then
        begin
          UserAction := bitfarmApp.CreateUserAction;
          UserAction^.Actionname := 'actSaveNewDocName';
          UserAction^.Objects.Add(FList[FChangeEditDocIdx]);
          if Save then
            UserAction^.Params.Add('1')
          else
            UserAction^.Params.Add('0');
          UserAction^.Preview := Self;
          bitfarmApp.MainThread.Add(UserAction);
          FChangeDocNameInProcess := True;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'SaveNewDocName - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SaveNewDocName - ' + Self.Name, Classname);
  end;
end;

procedure TbfaPreview.AskforsaveDialog(AThread: TThread);
var
  result: Integer;
begin
  try
// 16.03.2017 -->
// Man kann nur dann nderungen machen wenn das Dokument in Editmode ist, sonst das ist ein Fehler!
    if (FActiveDoc.ID <> -1) and (not FActiveDoc.InEditMode) then
    begin
      FimgSingleView.bGDelObj := False;
      FimgSingleView.gbAnnoNotSaved := False;
      Exit;
    end;
// 16.03.2017 <--

    if ActiveDoc.ID = -1 then   // fr Dokumente im Importer keine Abfrage, da dort Annos direkt gelscht werden
      result := 0
    else
    begin

      if AThread <> nil then
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            result := BfMessageDlg(_('Sie haben Anmerkungen gelscht.') + #13 + _('Mchten Sie die nderungen speichern?'), mtConfirmation, [mbYes, mbNo], True);
          end);
      end
      else
        result := BfMessageDlg(_('Sie haben Anmerkungen gelscht.') + #13 + _('Mchten Sie die nderungen speichern?'), mtConfirmation, [mbYes, mbNo], True);
    end;

    if result = mrYes then
    begin
      SaveAnnoObjects(AThread, False, False);
      FimgSingleView.gbAnnoNotSaved := False;
      FimgSingleView.ClearHistory;
    end
    else
    begin
      FimgSingleView.bGDelObj := False;
      FimgSingleView.gbAnnoNotSaved := False;
      FimgSingleView.ClearHistory;
//16.03.2017      ShowPage(ActiveDoc, FimgSingleView.img_DocView.IO.Params.ImageIndex);
// 16.03.2017 --> Das dokument muss neu geladen werden wenn die Frage mit Nein beantwortet ist!
      if FActiveDoc.ID <> -1 then
      begin
        bitfarmApp.ReloadDocument(FActiveDoc, False, AThread);
        FActiveDoc.InEditMode := (FActiveDoc.EditmodeUserID > 0);
        ShowPage(ActiveDoc, FimgSingleView.img_DocView.IO.Params.ImageIndex);
        RefreshThumbnailView(AThread, ActiveDoc, FimgSingleView.img_DocView.IO.Params.ImageIndex);
        bitfarmApp.CreateRefreshDocumentInPreviewsAction(FActiveDoc, Self, nil, False, False, True);
      end;
//16.03.2017 <--
    end;
  except
  end;
end;

procedure TbfaPreview.askforsave_annos2(AThread: TThread);
begin
  bitfarmLog.DebugBegin(llDebug, 'askforsave_annos2 - ' + Self.Name, ClassName);
  try
    try
      if FimgSingleView.bgDelObj then
      begin
        AskforsaveDialog(AThread);
      end
      else if FimgSingleView.gbAnnoNotSaved then
      begin
        SaveAnnoObjects(AThread, False, False);
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'askforsave_annos2 - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'askforsave_annos2 - ' + Self.Name, ClassName);
  end;
end;

procedure TbfaPreview.RefreshPreview(AThread: TThread; Doc: TbfaDocument = nil;
  ReloadThumbnail: Boolean = True);
var
  Page: Integer;
  tags: TIETIFFHandler;
begin
  bitfarmLog.DebugBegin(llDebug, 'RefreshPreview - ' + Self.Name, ClassName);
  try
    try
      if Doc <> nil then
      begin
        if (Doc.ScanPoolView <> nil) and (Doc.ScanPoolViewLoaded) then
          Page := FActivePage
        else
          Page := FimgSingleView.img_DocView.IO.Params.ImageIndex;
      end
      else
      begin
        if (FActiveDoc <> nil) and
           (FActiveDoc.ScanPoolView <> nil) and (FActiveDoc.ScanPoolViewLoaded) then
          Page := FActivePage
        else
          Page := FimgSingleView.img_DocView.IO.Params.ImageIndex;
      end;

      if Page < 0 then
        Page := 0;

      AThread.Synchronize(nil,
        procedure
        begin
          try
            if Doc <> nil then
            begin
              if (Doc.ScanPoolView <> nil) and (Doc.ScanPoolViewLoaded) then
              begin
                if Page >= Doc.ScanPoolView.ImageCount then
                  Page := 0;
              end else
              begin
                tags := TIETIFFHandler.Create;
                try
                  Doc.DocStream.Position := 0;
                  tags.ReadStream(Doc.DocStream);
                  if Page >= tags.GetPagesCount then
                    Page := 0;
                finally
                  FreeAndNil(tags);
                end;
              end;

              if (FbfaPreviewKind = pvkSingle) then
              begin
                FimgSingleView.img_DocView.Clear;
                ShowPage(Doc, Page, (not bitfarmApp.FDoSave));
              end
              else if (FbfaPreviewKind = pvkMultiSingle) then
              begin
                ShowPage(Doc, Page, (not bitfarmApp.FDoSave));
              end;

              PaintWindow(GetWindowDC(Handle));

              bitfarmLog.Write(llNormal, ltInfo, 'RefreshPreview - DocTempID:' + GUIDToString(Doc.TempID) + ' - ' + Self.Name, ClassName);
            end;
          except
            bitfarmLog.Write(llNormal, ltException, 'RefreshPreview - Synchronize - ' + Self.Name, ClassName);
          end;
        end);

      AThread.Synchronize(nil,
        procedure
        begin
          try
            if (bitfarmApp.FDoSave) and (Floating) then
              tbi_normalmouseClick(Self);
          except
            bitfarmLog.Write(llNormal, ltException, 'RefreshPreview - Synchronize', ClassName);
          end;
        end);

      if (not FShowingThumbnail) and (previewToolWindow.Visible) and (ReloadThumbnail) then
      begin
        try
          AThread.Synchronize(nil,
            procedure
            begin
              if FimgThumbnailView <> nil then
                if Self = bitfarmApp.PreviewContainer.ImporterItem.Preview then
                  FimgThumbnailView.Visible := False
                else
                  FimgThumbnailView.Clear;
            end);
        except
        end;
        RefreshThumbnailView(AThread, Doc, Page);
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'RefreshPreview - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'RefreshPreview - ' + Self.Name, ClassName);
  end;
end;

procedure TbfaPreview.RefreshPage;
var
  Page: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'RefreshPage - ' + Self.Name, ClassName);
  try
    try
      if FimgSingleView.img_DocView.IO.Params.ImageIndex >= 0 then
        Page := FimgSingleView.img_DocView.IO.Params.ImageIndex
      else
        Page := 0;
      ShowPage(FActiveDoc, Page, False);
    except
      bitfarmLog.Write(llNormal, ltException, 'RefreshPage - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'RefreshPage - ' + Self.Name, ClassName);
  end;
end;

procedure TbfaPreview.SetAnnoToolBar(Enable: Boolean);
begin
  bitfarmLog.DebugBegin(llDebug, 'SetAnnoToolBar - ' + Self.Name, ClassName);
  try
    try
      if FActiveDoc <> nil then
      begin
        // <-- SJ: Via Toolbar Suchen darf man sobald ein Dokument vorhanden ist. EditMode und Rechte irrelevant

        //18.09.2024 SD -->bfacrm:ticket__show__39951
//        tbi_SearchBar.Enabled := (FActiveDoc.ID <> -1); // bfacrm:ticket__show__23189
        tbi_SearchBar.Enabled := (FActiveDoc.ID <> -1) and (btnPreview.Checked or btnFulltext.Checked);
        //18.09.2024 SD <--bfacrm:ticket__show__39951

//        tbi_SearchBar.Enabled := Enable;  // bfacrm:ticket__show__23189
//        tbi_SearchBar.Checked := Self.SearchbarToolbar.Visible; // bfacrm:ticket__show__23189
        // -->
        Enable := Enable and FActiveDoc.InEditMode;
        if CurrentLayer = 0 then  // oder ber die Archivberechtigung
          Enable := Enable and  ((FActiveDoc.ID = -1) or ((CurrentLayerRights and (rightAWrite or rightAModify)) > 0)) // wenigstens schreib oder modify rechte
        else
          Enable := Enable and ((FActiveDoc.ID = -1) or ((CurrentLayerRights and (rightAPWrite or rightAPModify)) > 0))
      end
      else
        tbi_SearchBar.Enabled := False; //18.09.2024 SD -->bfacrm:ticket__show__39951

      tbi_SearchBar.Checked := Self.SearchbarToolbar.Visible; // bfacrm:ticket__show__23189

      //18.09.2024 SD -->bfacrm:ticket__show__39951
      if tbi_SearchBar.Checked and not tbi_SearchBar.Enabled then
        Self.SearchbarToolbar.Enabled := False
      else
        Self.SearchbarToolbar.Enabled := True;
      //18.09.2024 SD -->bfacrm:ticket__show__39951

      tbi_normalmouse.Enabled := Enable;
      tbi_annoselect.Enabled := Enable;
      tbi_fav1.Enabled := Enable;
      tbi_fav2.Enabled := Enable;
      tbi_fav3.Enabled := Enable;
      tbi_fav4.Enabled := Enable;
      tbi_fav5.Enabled := Enable;
      tbi_fav6.Enabled := Enable;
      tbi_fav7.Enabled := Enable;
      tbi_fav8.Enabled := Enable;
      tbi_fav9.Enabled := Enable;
      tbi_fav10.Enabled := Enable;
      tbi_stampdialog.Enabled := Enable;
      tbi_arrow.Enabled := Enable;
      tbi_line.Enabled := Enable;
      tbi_annodelete.Enabled := Enable;
      tbi_box.Enabled := Enable;
      tbi_ellipse.Enabled := Enable;
      tbi_polygon.Enabled := Enable;
      tbi_label.Enabled := Enable;
      tbi_image.Enabled := Enable;
      tbi_length.Enabled := Enable;
      tbi_angle.Enabled := Enable;
//      tbi_graphicoptions.Enabled := (FActiveDoc <> nil);
//03.05.2017      tbi_rangeocr.Enabled := (FActiveDoc <> nil) and (FActiveDoc.HasPreview);
      tbi_text1.Enabled := Enable;
      tbi_text2.Enabled := Enable;
      tbi_text3.Enabled := Enable;
      tbi_text4.Enabled := Enable;
      tbi_text5.Enabled := Enable;
      tbi_note1.Enabled := Enable;
      tbi_note2.Enabled := Enable;
      tbi_note3.Enabled := Enable;
      tbi_note4.Enabled := Enable;
      tbi_note5.Enabled := Enable;
      tbi_highlite1.Enabled := Enable;
      tbi_highlite2.Enabled := Enable;
      tbi_highlite3.Enabled := Enable;
      tbi_highlite4.Enabled := Enable;
      tbi_highlite5.Enabled := Enable;
      tbi_pencil1.Enabled := Enable;
      tbi_pencil2.Enabled := Enable;
      tbi_pencil3.Enabled := Enable;
      tbi_pencil4.Enabled := Enable;
      tbi_pencil5.Enabled := Enable;
      tbsub_text.Enabled := Enable;
      tbsub_notes.Enabled := Enable;
      tbsub_highlight.Enabled := Enable;
      tbsub_pencil.Enabled := Enable;
//      tbiClipboardAsStamp.Enabled := Enable;
    except
      bitfarmLog.Write(llNormal, ltException, 'SetAnnoToolBar - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetAnnoToolBar - ' + Self.Name, ClassName);
  end;
end;

procedure TbfaPreview.SetEdit;
var
  LeftIdx, TopIdx: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'SetEdit - ' + Self.Name, ClassName);
  try
    try
      if FChangeEditDocIdx <> -1 then
      begin
        LeftIdx := FimgMultiView.ImageX[FChangeEditDocIdx] + 4 - FimgMultiView.ViewX;
        TopIdx := FimgMultiView.ImageY[FChangeEditDocIdx] + FActThumbnailHeight - 12 - FimgMultiView.ViewY;

        LeftIdx := LeftIdx + previewDockLeft.Width;
        TopIdx := TopIdx + previewDockTop.Height;

        FEdit.Left := LeftIdx;
        FEdit.Top := TopIdx;
        FEdit.Width := FActThumbnailWidth;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'SetEdit - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SetEdit - ' + Self.Name, ClassName);
  end;
end;

procedure TbfaPreview.SkipEditMode;
var
  UserAction: PUserAction;
begin
  try
    try
      bitfarmLog.DebugBegin(llDebug, 'SkipEditMode', ClassName);

      if (FActiveDoc = nil) then
        bitfarmLog.Write(llDebug, ltDebug, 'SkipEditMode - ActiveDoc = nil', ClassName)
      else if (not FActiveDoc.InEditMode) then
      begin
        UserAction := bitfarmApp.CreateUserAction;
        UserAction^.Actionname := 'actInProgress';
        UserAction^.Documents.Add(FActiveDoc);
        UserAction^.Preview := Self;
        bitfarmApp.MainThread.Add(UserAction);
      end else if (FActiveDoc.InEditMode) then
      begin
        UserAction := bitfarmApp.CreateUserAction;
        UserAction^.Actionname := 'actCallDoSave';
        bitfarmApp.MainThread.Add(UserAction);
      end
    except
      bitfarmLog.Write(llNormal, ltException, 'SkipEditMode', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'SkipEditMode', ClassName);
  end;
end;

procedure TbfaPreview.SetTextFonts;
var
  reg: TRegistry;
  sRegKeyName: string;

  procedure SetFonts(Button: TSpTBXItem);
  begin
    reg := TRegistry.Create;
    try
      try
        with reg do
        begin
          RootKey := HKEY_CURRENT_USER;
          OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\' + sRegKeyName, True);

          if ValueExists('ObjFontName') then
            Button.FontSettings.Name := ReadString('ObjFontName')
          else
            Button.FontSettings.Name := 'Arial';

          if ValueExists('ObjPenColor') then
            Button.FontSettings.Color := ReadInteger('ObjPenColor')
          else
            Button.FontSettings.Color := clBlack;

          if ValueExists('ObjFontHeight') then
            Button.FontSettings.Size := 25 + ReadInteger('ObjFontHeight')
          else
            Button.FontSettings.Size := 25 + 72;

          CloseKey;
        end;
      except
        bitfarmLog.Write(llNormal, ltException, 'SetFonts (' + sRegKeyName + ') - ' + Self.Name, ClassName);
      end;
    finally
      if Assigned(reg) then
        FreeAndNil(reg);
    end;
  end;

begin
  try
    sRegKeyName := bfaBasePreview.ObjTypeToStr(15);
    SetFonts(tbi_text1);
    sRegKeyName := bfaBasePreview.ObjTypeToStr(21);
    SetFonts(tbi_text2);
    sRegKeyName := bfaBasePreview.ObjTypeToStr(22);
    SetFonts(tbi_text3);
    sRegKeyName := bfaBasePreview.ObjTypeToStr(23);
    SetFonts(tbi_text4);
    sRegKeyName := bfaBasePreview.ObjTypeToStr(24);
    SetFonts(tbi_text5);
  except
    bitfarmLog.Write(llNormal, ltException, 'SetTextFonts - ' + Self.Name, ClassName);
  end;
end;

procedure TbfaPreview.OpenDocInNewTab;
var
  UserAction: PUserAction;
  i: Integer;
  LstObjs: TList;
  iPageIdx: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'OpenDocInNewTab', Classname);
  try
    try
      if (not GetFloating) then
      begin
        LstObjs := TList.Create;
        LstObjs.Add(FimgSingleView);

        if FbfaPreviewKind = pvkSingle then
          i := 0
        else
          i := FimgMultiView.MultiSelectedImages[0];

        iPageIdx := FimgSingleView.img_DocView.IO.Params.Tiff_ImageIndex;
        if iPageIdx < 0 then
          iPageIdx := 0;

        if (FList.Count > 0) then
          bitfarmApp.CallShowDocument(FList[i], nil, LstObjs, 0, iPageIdx, True, True, (GetKeyState(VK_MENU) < 0), //30.05.2017 Ticket 10703
          True, False, False, Self)
        else
          bitfarmLog.Write(llNormal, ltDebug, 'OpenDocInNewTab - Empty Preview', ClassName);
      end;

    except
      bitfarmLog.Write(llNormal, ltException, 'OpenDocInNewTab', ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'OpenDocInNewTab', Classname);
  end;
end;

procedure TbfaPreview.PaintWindow(DC: HDC);
var
  C: TCanvas;
  R: TRect;
begin
  inherited;

  if (not frmMainForm.fAppStarted) or (bitfarmApp.ClosingMainForm) then
    Exit;

  if FDoViewResize then
  begin
    FDoViewResize := False;
    Exit;
  end;

  if Self = bitfarmApp.PreviewContainer.PageSortingsItem.Preview then
    Exit;

  try
    if ((FActiveDoc <> nil) and ((FbfaPreviewKind = pvkSingle) or (FbfaPreviewKind = pvkMultiSingle)
      //09.04.2021 Ticket 26740 or (FbfaPreviewKind = pvkMulti)
      ))  then  // bfacrm:ticket__show__24402   added pvkMultiSingle
    begin
      if ((FActiveDoc.ID = -1) or (FActiveDoc.InEditMode)) then
      begin
        Self.BorderWidth := 3;
        Self.Color := gclLime;
        if bitfarmApp.PreviewContainer.ViewerItem.Preview = Self then
        begin
          if Pos(' *', bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Tab.Caption) = 0 then
            bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Tab.Caption := _('Viewer') + ' *';

          if Pos(' *', bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Panel.Caption) = 0 then
            bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Panel.Caption := _('Viewer') + ' *';

        end
        else if bitfarmApp.PreviewContainer.ImporterItem.Preview = Self then
        begin
          if Pos(' *', bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Tab.Caption) = 0 then
            bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Tab.Caption := _('Importer') + ' *';

          if Pos(' *', bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Panel.Caption) = 0 then
            bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Panel.Caption := _('Importer') + ' *';

        end
        else
        begin
          if Pos(' *', bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Tab.Caption) = 0 then
            bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Tab.Caption := FActiveDoc.DocName + ' *';

          if Pos(' *', bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Panel.Caption) = 0 then
            bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Panel.Caption := FActiveDoc.DocName + ' *';

          if pos('&', bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Tab.Caption) > 0 then
            bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Tab.Caption := StringReplace(FActiveDoc.DocName, '&', '&&', [rfReplaceAll]);
          if pos('&', bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Panel.Caption) > 0 then
            bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Panel.Caption := StringReplace(FActiveDoc.DocName, '&', '&&', [rfReplaceAll]);

        end;
        GetWindowRect(Handle, R);
        C := TCanvas.Create;
        try
          C.Handle := GetWindowDC(Handle);
          C.Pen.Color := gclLime;
          C.Pen.Width := 3;
          C.Brush.Style := bsClear;
          C.Rectangle(1, 1, R.Right - R.Left, R.Bottom - R.Top);
        finally
          C.Free;
        end;
        SetSaveAction(FActiveDoc.HasPreview);
      end
      else
      begin
        Self.BorderWidth := 3;
        Self.Color := frmMainForm.grdResultlistDevExView.clFree;
        if bitfarmApp.PreviewContainer.ViewerItem.Preview = Self then
          bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Tab.Caption := _('Viewer')
        else if bitfarmApp.PreviewContainer.ImporterItem.Preview = Self then
          bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Tab.Caption := _('Importer') +
            ' (' + IntToStr(bitfarmApp.ImportContainer.Count) + ')'
        else if bitfarmApp.PreviewContainer.WorkplaceItem.Preview = Self then
          bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Tab.Caption := _('Arbeitsplatz') +
            ' (' + IntToStr(bitfarmApp.WorkplaceContainer.Count) + ')'
        else
        begin
          if (Self.Owner.Tag <= bitfarmApp.PreviewContainer.Containers.Count - 1) then
          begin
            var CaptionText : string;
            if pos('&', FActiveDoc.DocName) > 0 then
              CaptionText := StringReplace(FActiveDoc.DocName, '&', '&&', [rfReplaceAll])
            else
              CaptionText := FActiveDoc.DocName;
            if bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Tab <> nil then
              bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Tab.Caption := CaptionText;
            if bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Panel <> nil then
              bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Panel.Caption := CaptionText;
          end;
        end;
        GetWindowRect(Handle, R);
        C := TCanvas.Create;
        try
          C.Handle := GetWindowDC(Handle);
          C.Pen.Color := frmMainForm.grdResultlistDevExView.clFree;
          C.Pen.Width := 3;
          C.Brush.Style := bsClear;
          C.Rectangle(1, 1, R.Right - R.Left - 1, R.Bottom - R.Top - 1);
        finally
          C.Free;
        end;
        SetSaveAction(False);
      end;
    end
    else
    begin
      Self.BorderWidth := 3;
      Self.Color := frmMainForm.grdResultlistDevExView.clFree;
      if bitfarmApp.PreviewContainer.ViewerItem.Preview = Self then
        bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Tab.Caption := _('Viewer')
      else if bitfarmApp.PreviewContainer.ImporterItem.Preview = Self then
        bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Tab.Caption := _('Importer') +
          ' (' + IntToStr(bitfarmApp.ImportContainer.Count) + ')'
      else if bitfarmApp.PreviewContainer.WorkplaceItem.Preview = Self then
        bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Tab.Caption := _('Arbeitsplatz') +
          ' (' + IntToStr(bitfarmApp.WorkplaceContainer.Count) + ')'
      else
      begin
        if (Self.Owner.Tag <= bitfarmApp.PreviewContainer.Containers.Count - 1) then
        begin
          bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Tab.Caption := _('Dokument');
          bitfarmApp.PreviewContainer.Containers[Self.Owner.Tag].Panel.Caption := _('Dokument');
        end;
      end;
      GetWindowRect(Handle, R);
      C := TCanvas.Create;
      try
        C.Handle := GetWindowDC(Handle);
        C.Pen.Color := frmMainForm.grdResultlistDevExView.clFree;
        C.Pen.Width := 3;
        C.Brush.Style := bsClear;
        C.Rectangle(1, 1, R.Right - R.Left - 1, R.Bottom - R.Top - 1);
      finally
        C.Free;
      end;
      SetSaveAction(False);
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'PaintWindow - ' + Self.Name, ClassName);
  end;
end;

procedure TbfaPreview.Paint;
begin
  inherited;

  if not frmMainForm.fAppStarted then
    Exit;

  PaintWindow(GetWindowDC(Handle));
end;

procedure TbfaPreview.bfaSingleMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
  try
    try
      bitfarmApp.PreviewMouseWheel(Self, nil, FimgSingleView.img_DocView, Shift,
        WheelDelta, Handled);
    finally
    {$IFNDEF ImageEn1140}
      Handled := True;
    {$ENDIF}
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'bfaSingleMouseWheel - ' + Self.Name, ClassName);
  end;
end;

procedure TbfaPreview.btnCommentaryClick(Sender: TObject);
var
  UserAction: PUserAction;
begin
  if not FCommentaryView.Visible then
  begin
    FimgSingleView.Hide;
    FHistoryView.Hide;
    FFulltextView.Hide;
    FCommentaryView.Show;

    btnPreview.Checked := False;
    btnHistory.Checked := False;
    btnFulltext.Checked := False;
    btnCommentary.Checked := True;

    ActiveView := avCommentary;
    SearchToolbarSetState;

    UserAction := bitfarmApp.CreateUserAction;
    UserAction^.Actionname := 'actLoadCommentary';
    UserAction^.Documents.Add(FActiveDoc);
    bitfarmApp.MainThread.Add(UserAction);
  end;
end;

procedure TbfaPreview.btnFulltextClick(Sender: TObject);
begin
  if not FFulltextView.Visible then
  begin
    FimgSingleView.Hide;
    FHistoryView.Hide;
    FFulltextView.Show;
    FCommentaryView.Hide;

    btnPreview.Checked := False;
    btnHistory.Checked := False;
    btnFulltext.Checked := True;
    btnCommentary.Checked := False;

    ActiveView := avFulltext;
    SearchToolbarSetState;
  end;
end;

procedure TbfaPreview.btnHistoryClick(Sender: TObject);
var
  UserAction: PUserAction;
begin
  if not FHistoryView.Visible then
  begin
    FimgSingleView.Hide;
    FHistoryView.Show;
    FFulltextView.Hide;
    FCommentaryView.Hide;

    btnPreview.Checked := False;
    btnHistory.Checked := True;
    btnFulltext.Checked := False;
    btnCommentary.Checked := False;

    ActiveView := avHistory;
    SearchToolbarSetState;

    if (FHistoryView.grdHistory{$IFDEF COMMENTGRID}.DataController{$ENDIF}.DataSource = nil) or
       (FHistoryView.grdHistory{$IFDEF COMMENTGRID}.DataController{$ENDIF}.DataSource.DataSet = nil) or
       (FHistoryView.grdHistory{$IFDEF COMMENTGRID}.DataController{$ENDIF}.DataSource.DataSet.RecordCount = 0) then
    begin
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.Actionname := 'actLoadHistory';
      UserAction^.Documents.Add(FActiveDoc);
      bitfarmApp.MainThread.Add(UserAction);
    end;
  end;
end;

procedure TbfaPreview.btnPreviewClick(Sender: TObject);
var
  UserAction: PUserAction;
begin
  if not FimgSingleView.Visible then
  begin
    //16.05.2024 SD Klick auf ButtonPreviewClick - Umsetzung durch UserAction
    UserAction := bitfarmApp.CreateUserAction;
    UserAction^.Actionname := 'actButtonPreviewClick';
    UserAction^.Preview := Self;
    bitfarmApp.MainThread.Add(UserAction);

//    FimgSingleView.Show;
//    FHistoryView.Hide;
//    FFulltextView.Hide;
//    FCommentaryView.Hide;
//    btnPreview.Checked := True;
//    btnHistory.Checked := False;
//    btnFulltext.Checked := False;
//    btnCommentary.Checked := False;
//
//    ActiveView := avDocument;
//    SearchToolbarSetState;
//
//    if SearchbarPreviewModified {and FActiveDoc.ocrxmlexists} then
//    begin
//      bitfarmApp.LoadFtxPos(Self.FtxPos, Self.SearchbarTextEdit.Text);
//      Self.RefreshPreview(nil, FActiveDoc, True);
//      Self.SearchbarPreviewModified := False;
//    end;
    //16.05.2024 SD Klick auf ButtonPreviewClick - Umsetzung durch UserAction
  end;
end;

procedure TbfaPreview.DeleteFtxPosLayer;
var
  i: Integer;
begin
  bitfarmLog.DebugBegin(llDebug, 'DeleteFtxPosLayer - ' + Self.Name, Classname);
  try
    try
      if FtxObjList.Count > 0 then
      begin
        for i := FtxObjList.Count - 1 downto 0 do
        begin
          FimgSingleView.img_DocView.RemoveObject(StrToInt(FtxObjList[i]));
          FtxObjList.Delete(i);
        end;

        FtxObjList.Clear;
        FimgSingleView.img_DocView.Update;
      end;
      FtxSearchPos := -1;
      FtxSearchPosOldColor := -1;
    except
      bitfarmLog.Write(llNormal, ltException, 'DeleteFtxPosLayer - ' + Self.Name, ClassName);
    end;
  finally
    bitfarmLog.DebugEnd(llDebug, 'DeleteFtxPosLayer - ' + Self.Name, Classname);
  end;

end;

procedure TbfaPreview.OnStationeryClick(Sender: TObject);
var
  i: Integer;
  UserAction: PUserAction;
begin
  bitfarmApp.Log.DebugBegin(llDebug, 'OnStationeryClick', Classname);
  try
    try
      if TSpTBXItem(Sender).Checked and (bfaTlbPreview.mnuStationery.Checked or bfaTlbPreview.sbmStationery.Checked) then
        Exit;

      for i := 0 to bfaTlbPreview.sbmStationery.Count - 1 do
        bfaTlbPreview.sbmStationery[i].Checked := False;
      TSpTBXItem(Sender).Checked := True;

      if bitfarmApp.PreviewContainer.ActiveItem = 0 then    // Wenn die ViewerPreview aktiv ist
      begin
        for i := 0 to frmMainForm.bfaTlbPreview1.sbmStationery.Count - 1 do
        begin
          frmMainForm.bfaTlbPreview1.sbmStationery[i].Checked :=
            bitfarmApp.PreviewContainer.Containers[bitfarmApp.PreviewContainer.ActiveItem].
            Preview.bfaTlbPreview.sbmStationery[i].Checked;
          bfaTlbPreview.sbmStationery[i].Checked :=
            frmMainForm.bfaTlbPreview1.sbmStationery[i].Checked;
        end;
      end;
      StationeryIndex := TSpTBXItem(Sender).Tag;
      UserAction := bitfarmApp.CreateUserAction;
      UserAction^.Actionname := 'actStationery';
      UserAction^.Params.Add('1');
      UserAction^.Preview := Self;
      bitfarmApp.MainThread.Add(UserAction);

      bfaTlbPreview.mnuStationery.Checked := True;
      bfaTlbPreview.sbmStationery.Checked := True;
      frmMainForm.bfaTlbPreview1.mnuStationery.Checked := True;
      frmMainForm.bfaTlbPreview1.sbmStationery.Checked := True;

    except
      bitfarmApp.Log.Write(llNormal, ltException, 'OnStationeryClick', ClassName);
    end;
  finally
    bitfarmApp.Log.DebugEnd(llDebug, 'OnStationeryClick', Classname);
  end;
end;

procedure TbfaPreview.bfaMouseLeave;
begin
  try
    bitfarmApp.SetStandardStatusInfo(nil);
  except
    bitfarmApp.Log.Write(llNormal, ltException, 'bfaMouseLeave', ClassName);
  end;
end;

procedure TbfaPreview.CopyOCRResultToClipbrd;
begin
  try
    if bitfarmApp.ViewerOptions.EditorOptions.OCRAutoClipbrd then
      bitfarmApp.CopyOCRResultToClipbrd(nil);
  except
    bitfarmApp.Log.Write(llNormal, ltException, 'CopyOCRResultToClipbrd', ClassName);
  end;
end;

procedure TbfaPreview.DoDelayTimer(Sender: TObject);
var
  ReloadThumb: Boolean;
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'DoDelayTimer - ' + Self.Name, Classname);
  try
    try
      FDelay.Enabled := False;
      if (FTimerObj <> nil) and (FTimeraction <> -1) then
      begin
        try
          if not FTimerObj.MultiSelecting then
          begin
            if FTimerAction = 0 then //Select
            begin
              if FTimerObj.Tag = tagCollectionMView then
              begin
                ReloadThumb := True;
                bitfarmApp.MViewImageSelect(FTimerObj, Self, FTimerObj.SelectedImage, -1,
                  True, False, False, False, False, False, ReloadThumb);
              end
              else if FTimerObj.Tag = tagThumbnailMView then
              begin
//12.07.2024  bfacrm:ticket__show__39299               bitfarmApp.MViewImageSelect(FTimerObj, Self, FTimerIdx, -1, False);  // Ticket 16615 Doppelkick auf Seite im Thumbview
                bitfarmApp.MViewImageSelect(FTimerObj, Self, FTimerIdx, -1, False,
                  False, False, False, False, False, False, False, False, True, -1,
                  False, True);  //12.07.2024 MouseClick soll hier True sein
              end;
            end
            else if FTimerAction = 1 then
            begin
              if FTimerObj.SelectedImage = -1 then
              begin
                if FTimerObj.MultiSelectedImagesCount > 0 then
                  ReloadThumb := (TbfaPreview(FTimerObj.Owner).List[FTimerObj.MultiSelectedImages[FTimerObj.MultiSelectedImagesCount -1]] <> FActiveDoc)
                else
                  ReloadThumb := True;

                if FTimerObj.Tag = tagCollectionMView then
                begin
                  UserAction := bitfarmApp.CreateUserAction;
                  UserAction.ActionName := 'actLeaveCurrentDocsImMultiView';
                  UserAction.Objects.Add(FTimerObj);
                  UserAction.Params.Add(IntToStr(FTimerIdx));
                  UserAction.Params.Add(BoolToStr(ReloadThumb));
                  UserAction.Preview := Self;

                  bitfarmApp.MainThread.Add(UserAction);
                end;

                if FTimerObj.MultiSelectedImages[0] <> -1 then
                  bitfarmApp.MViewImageSelect(FTimerObj, Self, FTimerObj.MultiSelectedImages[0], -1, True, False, False, False, False, False, ReloadThumb)
                else
                  frmMainForm.actHidePageSortingsFrame.Execute;
              end;
            end;
          end
          else
          begin
            FDelay.Enabled := False;
            FDelay.Enabled := True;
          end;

          if FTimerPageSortings then
            bitfarmApp.CreateShowPageSortingsFrameAction;
        finally
          FTimerObj := nil;
          FTimerAction := -1;
          FTimerPageSortings := False;
        end;
      end;
    except
      bitfarmLog.Write(llNormal, ltException, 'DoDelayTimer - ' + Self.Name, ClassName);
    end;
  finally
    FMViewDBLClick := False;
    bitfarmLog.DebugEnd(llDebug, 'DoDelayTimer - ' + Self.Name, Classname);
  end;

end;

procedure TbfaPreview.tbi_rangeocrClick(Sender: TObject);
begin
  frmMainForm.actRangeOCR.Execute;
end;

procedure TbfaPreview.tbi_SearchBarClick(Sender: TObject);
begin
  try
    Self.SearchbarToolbar.Visible := not(Self.SearchbarToolbar.Visible);
    Self.tbi_SearchBar.Checked := Self.SearchbarToolbar.Visible;
    SearchToolbarSetState;  //07.10.2024 SD <--bfacrm:ticket__show__40155
  except
    bitfarmLog.Write(llNormal, ltException, 'tbi_SearchBarClick', Classname);
  end;
end;

procedure TbfaPreview.SetActivePage(Value: Integer);
begin
  FActivePage := Value;
  if FimgThumbnailView <> nil then
  begin
    FimgThumbnailView.SelectedImage := FActivePage;
    FimgThumbnailView.CenterSelected;
  end;
end;

procedure TbfaPreview.LoadFavStampbuttons(var favstemp: TStringArray; tbx_fav1, tbx_fav2, tbx_fav3, tbx_fav4, tbx_fav5, tbx_fav6, tbx_fav7, tbx_fav8, tbx_fav9, tbx_fav10: TSpTBXItem);
var
  reg: TRegistry;
  lsStampName: string;
  slStampKeys: TStringList;
  iCount, lifav: integer;
begin
  reg := TRegistry.Create;
  try
    with reg do
    begin
      slStampKeys := TStringList.Create;
      try
        RootKey := HKEY_CURRENT_USER;
        OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps', True);
        GetKeyNames(slStampKeys);
        CloseKey;
        setlength(favstemp, slStampKeys.Count);
        //Items im Hauptformular
        tbx_fav1.Enabled := False;
        tbx_fav1.Visible := False;
        tbx_fav1.Tag := 0;
        tbx_fav2.Enabled := False;
        tbx_fav2.Visible := False;
        tbx_fav2.Tag := 0;
        tbx_fav3.Enabled := False;
        tbx_fav3.Visible := False;
        tbx_fav3.Tag := 0;
        tbx_fav4.Enabled := False;
        tbx_fav4.Visible := False;
        tbx_fav4.Tag := 0;
        tbx_fav5.Enabled := False;
        tbx_fav5.Visible := False;
        tbx_fav5.Tag := 0;
        tbx_fav6.Enabled := False;
        tbx_fav6.Visible := False;
        tbx_fav6.Tag := 0;
        tbx_fav7.Enabled := False;
        tbx_fav7.Visible := False;
        tbx_fav7.Tag := 0;
        tbx_fav8.Enabled := False;
        tbx_fav8.Visible := False;
        tbx_fav8.Tag := 0;
        tbx_fav9.Enabled := False;
        tbx_fav9.Visible := False;
        tbx_fav9.Tag := 0;
        tbx_fav10.Enabled := False;
        tbx_fav10.Visible := False;
        tbx_fav10.Tag := 0;

        for iCount := 0 to slStampKeys.Count - 1 do
        begin
          OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' +
            slStampKeys.Strings[iCount], True);

          if ValueExists('favnr') then
          begin
            lifav := ReadInteger('favnr');
            lsStampName := ReadString('StampName');
            case lifav of
              1:
                begin
                  tbx_fav1.Enabled := FActiveDoc <> nil;
                  tbx_fav1.Visible := True;
                  tbx_fav1.Hint := lsStampName;
                  tbx_fav1.Tag := iCount;
                end;

              2:
                begin
                  tbx_fav2.Enabled := FActiveDoc <> nil;
                  tbx_fav2.Visible := True;
                  tbx_fav2.Hint := lsStampName;
                  tbx_fav2.Tag := iCount;
                end;

              3:
                begin
                  tbx_fav3.Enabled := FActiveDoc <> nil;
                  tbx_fav3.Visible := True;
                  tbx_fav3.Hint := lsStampName;
                  tbx_fav3.Tag := iCount;
                end;

              4:
                begin
                  tbx_fav4.Enabled := FActiveDoc <> nil;
                  tbx_fav4.Visible := True;
                  tbx_fav4.Hint := lsStampName;
                  tbx_fav4.Tag := iCount;
                end;

              5:
                begin
                  tbx_fav5.Enabled := FActiveDoc <> nil;
                  tbx_fav5.Visible := True;
                  tbx_fav5.Hint := lsStampName;
                  tbx_fav5.Tag := iCount;
                end;

              6:
                begin
                  tbx_fav6.Enabled := FActiveDoc <> nil;
                  tbx_fav6.Visible := True;
                  tbx_fav6.Hint := lsStampName;
                  tbx_fav6.Tag := iCount;
                end;

              7:
                begin
                  tbx_fav7.Enabled := FActiveDoc <> nil;
                  tbx_fav7.Visible := True;
                  tbx_fav7.Hint := lsStampName;
                  tbx_fav7.Tag := iCount;
                end;

              8:
                begin
                  tbx_fav8.Enabled := FActiveDoc <> nil;
                  tbx_fav8.Visible := True;
                  tbx_fav8.Hint := lsStampName;
                  tbx_fav8.Tag := iCount;
                end;

              9:
                begin
                  tbx_fav9.Enabled := FActiveDoc <> nil;
                  tbx_fav9.Visible := True;
                  tbx_fav9.Hint := lsStampName;
                  tbx_fav9.Tag := iCount;
                end;

              10:
                begin
                  tbx_fav10.Enabled := FActiveDoc <> nil;
                  tbx_fav10.Visible := True;
                  tbx_fav10.Hint := lsStampName;
                  tbx_fav10.Tag := iCount;
                end;
            end;
            favstemp[iCount] := slStampKeys.Strings[iCount];
          end;
          CloseKey;
        end;
      finally
        slStampKeys.Free;
      end;
    end;
  except
    on e: Exception do
    begin
      BfShowMessage(_('Fehler beim Lesen der Stempel:') + e.Message);
    end;
  end;
end;

procedure ShowAddFields(Doc: TbfaDocument; keepmodified: Boolean = True);
var
  j, k: Integer;
  found: Boolean;
  addfield: TbfaAddField;
begin
  bitfarmLog.Write(llDebug, ltDebug, 'ShowAddFields: keepmodified ' + BoolToStr(keepmodified), 'bfaProcessing');

  try
    for j := 0 to aCurrentAddfields.Count - 1 do
    begin
      found := False;
      bitfarmLog.Write(llDebug, ltDebug, 'ShowAddFields: aCurrentAddfields.Count ' + IntToStr(j), 'bfaProcessing');
      if Doc <> nil then
      begin
        for k := 0 to Doc.AddFields.Count - 1 do
        begin
          if Doc.AddFields[k].ID = aCurrentAddfields[j].ID then  //Feld gibt es schon
          begin
            bitfarmLog.Write(llDebug, ltDebug, 'ShowAddFields: Doc.AddFields.Count ' + IntToStr(k), 'bfaProcessing');
            found := True;

            if (not keepmodified) or //22.03.2018 Ticket 14043
              (aCurrentAddfields[j].Typ = 13) or    // Gridfeld immer laden, auch wenn darber gesucht wurde
              (not ((aCurrentAddfields[j].ModifiedSearch) or    //13.05.2016
              (Doc.ID = -1) or
              ((aCurrentAddfields[j].Component <> nil) and (aCurrentAddfields[j].Component.Modified)))) then  // wenn nicht in dem Feld gesucht wurde, oder es ein nichtarchiviertes Doc ist
            begin
              bitfarmLog.Write(llDebug, ltDebug, 'ShowAddFields: Suchfeld ' + Doc.AddFields[k].DisplayName, 'bfaProcessing');

              if VarIsNull(Doc.AddFields[k].Value) then
              begin
                bitfarmLog.Write(llDebug, ltDebug, 'ShowAddFields: VarIsNull', 'bfaProcessing');

                if aCurrentAddfields[j].Component <> nil then
                begin
                  if not ((aCurrentAddfields[j].Typ = 13) and aCurrentAddfields[j].ModifiedSearch) then
                    aCurrentAddfields[j].Component.ClearValue;   // kein ClearValue bei Gridfeld und ModifiedSearch
                  if (aCurrentAddfields[j].Typ = 13) then
                     aCurrentAddfields[j].Component.compGrid.ResetGridHeight;
                  aCurrentAddfields[j].Component.Value := '';
                end;
                aCurrentAddfields[j].Value := '';
                aCurrentAddfields[j].OldValue := '';
              end else
              begin
                if aCurrentAddfields[j].Component <> nil then
                begin
                  bitfarmLog.Write(llDebug, ltDebug, 'ShowAddFields: aCurrentAddfields[j].Component <> nil', 'bfaProcessing');

                  if not ((aCurrentAddfields[j].Typ = 13) and aCurrentAddfields[j].ModifiedSearch) then
                    aCurrentAddfields[j].Component.ClearValue;      // kein ClearValue bei Gridfeld und ModifiedSearch
                  if (aCurrentAddfields[j].Typ = 13) then
                     aCurrentAddfields[j].Component.compGrid.ResetGridHeight;

                  aCurrentAddfields[j].Component.Value := Doc.AddFields[k].Value;

                end;
                bitfarmLog.Write(llDebug, ltDebug, 'ShowAddFields: aCurrentAddfields[j].Value := Doc.AddFields[k].Value', 'bfaProcessing');

                aCurrentAddfields[j].Value := Doc.AddFields[k].Value;
                aCurrentAddfields[j].OldValue := Doc.AddFields[k].Value;
              end;
            end else    // wir speichern bei einer genderten Componente zumindest den OldValue des Addfields
            begin       // damit wir beim InEditMode setzen den prfen knnen
              bitfarmLog.Write(llDebug, ltDebug, 'ShowAddFields: genderten Componente ' + Doc.AddFields[k].DisplayName, 'bfaProcessing');

              aCurrentAddfields[j].Component.ClearOldValue;
              if VarIsNull(Doc.AddFields[k].Value) then
                aCurrentAddfields[j].Component.OldValue := ''
              else
                aCurrentAddfields[j].Component.OldValue := Doc.AddFields[k].Value;
            end;
            Break;
          end;
        end;
      end
      else
      begin
        bitfarmLog.Write(llDebug, ltDebug, 'ShowAddFields: Doc = nil', 'bfaProcessing');
        if aCurrentAddfields[j].Component <> nil then
        begin
          aCurrentAddfields[j].Component.ClearValue;
          aCurrentAddfields[j].Component.Value := '';
        end;
        aCurrentAddfields[j].Value := '';
        aCurrentAddfields[j].OldValue := '';
      end;

      if (Doc <> nil) and (not found) then
      begin
        bitfarmLog.Write(llDebug, ltDebug, 'ShowAddFields: not found', 'bfaProcessing');
        if Doc.ID <> -1 then   //13.05.2016
        begin
          if aCurrentAddfields[j].Component <> nil then
          begin
            aCurrentAddfields[j].Component.ClearValue;
            aCurrentAddfields[j].Component.Value := '';
          end;
          aCurrentAddfields[j].Value := '';
          aCurrentAddfields[j].OldValue := '';
        end;

        addfield := TbfaAddField.Create;
        addfield.Clone(aCurrentAddfields[j]);
        Doc.AddFields.Add(addfield);
      end;
    end;
  except
    on e:Exception do
    begin
      bitfarmLog.Write(llNormal, ltException, 'ShowAddFields: ' + e.Message, 'bfaProcessing');
    end;
  end;
end;

procedure ShowStateFields(Doc: TbfaDocument);
var
  j, k: Integer;
  found: Boolean;
  statefield: TbfaStateField;
begin
  try
    for j := 0 to aCurrentStatefields.Count - 1 do
    begin
      found := False;

      if not ((aCurrentStatefields[j].ModifiedSearch) or
        ((aCurrentStatefields[j].Component <> nil) and (aCurrentStatefields[j].Component.Modified))) then
      begin
        if aCurrentStatefields[j].Component <> nil then
        begin
          aCurrentStatefields[j].Component.ClearValue;
          aCurrentStatefields[j].Component.Value := fsNone;
        end;
        aCurrentStatefields[j].Value := False;
        aCurrentStatefields[j].OldValue := False;
      end;

      if (Doc <> nil) then
      begin
        for k := 0 to Doc.StateFields.Count - 1 do
        begin
          if Doc.StateFields[k].ID = aCurrentStatefields[j].ID then  //Feld gibt es schon
          begin
            found := True;

//30.09.2016 !!!!!!!!            if Doc.StateFields[k].Component = nil then
//               Doc.StateFields[k].Component := aCurrentStatefields[j].Component;

            if (aCurrentStatefields[j].ModifiedSearch) or    //13.05.2016
              ((Doc.ID = -1) and (aCurrentStatefields[j].Component.Modified)) then  // wenn in dem Feld gesucht wurde
            begin                                  // bleibt der Suchbegriff stehen
              Doc.StateFields[k].Modified := aCurrentStatefields[j].Modified;
              Doc.StateFields[k].Value := aCurrentStatefields[j].Component.Value = fsSet;
            end
            else
            begin
              if ((not VarIsNull(Doc.StateFields[k].Value)) and
//                  (Doc.StateFields[k].Value <> '') and
                VarIsType(Doc.StateFields[k].Value, varBoolean) and (Doc.StateFields[k].Value)) then
              begin
                if aCurrentStatefields[j].Component <> nil then
                begin
                  aCurrentStatefields[j].Component.ClearValue;
                  aCurrentStatefields[j].Component.Value := fsSet;
                end;
                aCurrentStatefields[j].Value := True;
                aCurrentStatefields[j].OldValue := True;
              end
              else
              begin
                if aCurrentStatefields[j].Component <> nil then
                begin
                  aCurrentStatefields[j].Component.ClearValue;
                  aCurrentStatefields[j].Component.Value := fsNone;
                end;
                aCurrentStatefields[j].Value := False;
                aCurrentStatefields[j].OldValue := False;
              end;
            end;
            Break;
          end;
        end;
      end
      else
      begin
        if aCurrentStatefields[j].Component <> nil then
        begin
          aCurrentStatefields[j].Component.ClearValue;
          aCurrentStatefields[j].Component.Value := fsNone;
        end;
        aCurrentStatefields[j].Value := False;
        aCurrentStatefields[j].OldValue := False;
      end;

      if (Doc <> nil) and (not found) then
      begin
        statefield := TbfaStateField.Create;
        statefield.Clone(aCurrentStatefields[j]);
        Doc.StateFields.Add(statefield);
      end;
    end;
  except
    bitfarmLog.Write(llNormal, ltException, 'ShowStateFields', 'bfaProcessing');
  end;
end;

procedure ShowDocument(AThread: TThread; Doc: TbfaDocument; DocList: TList<TbfaDocument>;
  prev: TbfaPreview = nil; PageIdx: Integer = -1; SetCurrent: Boolean = True;
  InNewTab: Boolean = False; TabInBackground: Boolean = False; MView: TbfaImageEnMView = nil;
  ReloadThumbnail: Boolean = False; InEditmode: Boolean = False; SetFocus: Boolean = False;
  ReloadDoc: Boolean = False; ChangeToMultiSingle: Boolean = False; pnlSearchTimer: TPanel = nil;
  pnlLoadDoc: TPanel = nil; SearchString: WideString = ''; SetImagePos: Boolean = False;
  SetImagePosTothetop: Boolean = False; Autozoom: Boolean = true; PageDirection : Integer = -1;
  Floating: Boolean = False; MouseClick: Boolean = False);

  procedure ShowTheDocument(ActDoc: TbfaDocument; prv: TbfaPreview; SetIPos, SetIPosTothetop, Autozoom: Boolean);
  begin
    AThread.Synchronize(nil,
      procedure
      begin
        bitfarmLog.DebugBegin(llDebug, 'Synchronize - ShowTheDocument', 'bfaProcessing');
        ActDoc.StartShowProcess;
        try
          try
            if (ChangeToMultiSingle) then
              prv.PreviewKind := pvkMultiSingle;
            if (bitfarmApp.CurrentView = tvkImporter) and
              (bitfarmApp.PreviewContainer.PageSortingsItem.Panel.Showing) and (not prv.Floating) then
            begin
              if (bitfarmApp.PreviewContainer.ImporterItem.Preview.previewToolWindow.Visible) and
                (bitfarmApp.PreviewContainer.ImporterItem.Preview.ThumbnailView.SelectedImage > -1) then
                bitfarmApp.PreviewContainer.PageSortingsItem.Preview.ShowPage(ActDoc,
                  bitfarmApp.PreviewContainer.ImporterItem.Preview.ThumbnailView.SelectedImage, True)
              else
                bitfarmApp.PreviewContainer.PageSortingsItem.Preview.ShowPage(ActDoc, 0, True);

              if (prv.PreviewKind <> pvkMulti) and (not prv.ThumbnailView.MultiSelecting) then
              begin
                prv.ShowPage(ActDoc, PageIdx, (not bitfarmApp.FDoSave), SetIPos,
                  SetIPosTothetop, PageDirection)
              end
              else
                prv.ShowPageNumber; // 22.02.2017
            end else begin
              if (prv.PreviewKind <> pvkMulti) and (not prv.ThumbnailView.MultiSelecting) then
              begin
                if Autozoom then
                  Autozoom := (not bitfarmApp.FDoSave);  // Rckwrtskompatibilitt

                if PageIdx <> -1 then
                  prv.ShowPage(ActDoc, PageIdx, Autozoom , SetIPos, SetIPosTothetop, PageDirection)
                else
                  prv.ShowPage(ActDoc, 0, Autozoom, SetIPos, SetIPosTothetop, PageDirection);
              end
              else
                prv.ShowPageNumber; // 22.02.2017

              if (bitfarmApp.CurrentView = tvkImporter) and
                (bitfarmApp.PreviewContainer.PageSortingsItem.Panel.Showing) and (not prv.Floating) then
              begin
                if (bitfarmApp.PreviewContainer.ImporterItem.Preview.previewToolWindow.Visible) and
                  (bitfarmApp.PreviewContainer.ImporterItem.Preview.ThumbnailView.SelectedImage > -1) then
                  bitfarmApp.PreviewContainer.PageSortingsItem.Preview.ShowPage(ActDoc,
                    bitfarmApp.PreviewContainer.ImporterItem.Preview.ThumbnailView.SelectedImage, True)
                else
                  bitfarmApp.PreviewContainer.PageSortingsItem.Preview.ShowPage(ActDoc, 0, True);
              end;
            end;
            prv.itmBack.Enabled := True;
            // 10/20/2020 --> bfacrm:ticket__show__24402
            if not (ActDoc.ID =-1) and (ActDoc.InEditMode)  and  (ActDoc<> nil)  and (bitfarmApp.CurrentView = tvkWorkplace) then
              prv.Paint;
            // 10/20/2020  < -- bfacrm:ticket__show__24402

          except
            bitfarmLog.Write(llNormal, ltException, 'Synchronize - ShowTheDocument', 'bfaProcessing');
          end;
        finally
          ActDoc.EndShowProcess;
          bitfarmLog.DebugEnd(llDebug, 'Synchronize - ShowTheDocument', 'bfaProcessing');
        end;
      end);
  end;

var
  Item: TbfaPreviewContainerItem;
  OldDoc: TbfaDocument;
  TabName: WideString;
  MustReload: Boolean;
  OldColor: TColor;
  arcids: TStringList;
  DocArc: TDocArc;
  prev2: TbfaPreview;
  UserAction: PUserAction;
begin
  bitfarmLog.DebugBegin(llDebug, 'ShowDocument', 'bfaProcessing');
  bitfarmApp.ShowDocumentInProcess := True;
  try
    try
      if Doc = nil then
        Doc := DocList[0];

      OldDoc := nil;
      if prev <> nil then
        MustReload := (((not Doc.Loaded) and (Doc.ID <> -1)) or (ReloadDoc)) or (prev.ActiveDoc <> Doc)
      else
        MustReload := (((not Doc.Loaded) and (Doc.ID <> -1)) or (ReloadDoc));

      if (pnlLoadDoc <> nil) and (MustReload) then
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            OldColor := pnlLoadDoc.Color;
            pnlLoadDoc.ParentBackground := False;
            pnlLoadDoc.Color := gclRed;
            pnlLoadDoc.Caption := _('Laden');
          end);
      end;

      if Doc.GetInProcesses then
        Exit;

      if SetCurrent then
      begin
        if DocList = nil then
          bitfarmApp.SetCurrentDocs(Doc, nil, prev, AThread, InNewTab, InEditMode)
        else
          bitfarmApp.SetCurrentDocs(nil, TList(DocList), prev, AThread, InNewTab, InEditMode);
      end;

      Doc.StartShowProcess;

      if prev <> nil then
      begin
        AThread.Synchronize(nil,
          procedure
          begin
            prev.DeleteFtxPosLayer;

            if MustReload then //16.07.2018
            begin
              prev.SingleView.img_DocView.MouseInteractVt := [];
              prev.SingleView.img_DocView.Cursor := crDefault;
            end;

            prev.prgPreview.Min := 0;
            prev.prgPreview.Max := 6;
            prev.prgPreview.Position := 1;
            prev.prgPreview.Update;
          end);
      end;
      try
        if ((Doc.ID <> -1) and (MustReload)) then
        begin

          bitfarmApp.ReloadDocument(Doc, InEditmode, AThread);

          AThread.Synchronize(nil,
            procedure
            begin
              bitfarmApp.LoadFtxPos(prev.FtxPos, SearchString);
            end);
        end else
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              if prev <> nil then
              begin
                prev.prgPreview.Position := prev.prgPreview.Position + 3;
                prev.prgPreview.Update;
              end;
            end);
        end;

        if (Doc <> nil) and ((Doc.ID = -1) or ((Doc.ID <> -1) and (Doc.Loaded))) then
        begin
          if ((Doc <> nil) and (prev <> nil) and (not InNewTab)) then
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                if prev <> nil then
                begin
                  prev.prgPreview.Position := prev.prgPreview.Position + 1;
                  prev.prgPreview.Update;
                end;
              end);

            if (prev.ActiveDoc <> Doc) or (MustReload) then
            begin
              if ((not InNewTab) and (prev = bitfarmApp.PreviewContainer.ViewerItem.Preview)) then
              begin
                AThread.Synchronize(nil,
                  procedure
                  var
                    i : Integer;
                  begin
                    if (prev.List.Count > 0) then
                      OldDoc := prev.List[0];

                    if ((OldDoc <> nil) and (not IsDocumentInOtherPreview(prev, OldDoc))) and (not ReloadDoc) then
                    begin
                      try
                        OldDoc.Free;
                      finally
                        OldDoc := nil;
                      end;
                    end;

                    prev.List.Clear;
                    prev.List.Add(Doc);
                    prev.ActiveDoc := Doc;
                  end);
                arcids := TStringList.Create;
                //BT 28.06.2024 -->
                if Doc.SymbolicArcID <> -1 then
                  arcids.Add(IntToStr(Doc.SymbolicArcID))
                else
                //BT 28.06.2024 <--
                  arcids.Add(IntToStr(Doc.ArcID));

                if (((bitfarmApp.CurrentView = tvkResub) and bitfarmApp.ViewerOptions.ResubOptions.ShowAllAddfields)
                    or ((bitfarmApp.CurrentView = tvkViewer) and bitfarmApp.ViewerOptions.SearchOptions.ShowAllAddfields) //28.06.2024 BT
                   )
                then    // hier Option einbauen
                begin
                  if (bitfarmApp.CurrentView = tvkResub) then
                    arcids.Add(IntToStr(bitfarmApp.CurrentResubFields))
                  else if (bitfarmApp.CurrentView = tvkViewer) then
                    arcids.Add(IntToStr(bitfarmApp.CurrentViewerFields));
                  bitfarmApp.ReadFieldRights(arcids);
                  bitfarmApp.AddDocumentFields(Doc, AThread);
                end;
//28.06.2024 BT oben ergnzt
//                if (bitfarmApp.CurrentView = tvkViewer) and bitfarmApp.ViewerOptions.SearchOptions.ShowAllAddfields then    // hier Option einbauen
//                begin
//                  arcids.Add(IntToStr(bitfarmApp.CurrentViewerFields));
//                  bitfarmApp.ReadFieldRights(arcids);
//                  bitfarmApp.AddDocumentFields(Doc, AThread);
//                end;
              end
              else
                prev.ActiveDoc := Doc;

              if (ReloadThumbnail) or ((prev.ShowThumbnail) and
                  (prev.ThumbnailView.ImageCount = 0)) or
                 ((prev.ShowThumbnail) and (not ReloadThumbnail) and (ChangeToMultiSingle))
              then
                prev.RefreshThumbnailView(AThread, Doc, PageIdx);
            end
            else if ((((MView <> nil) and (MView.Tag <> tagThumbnailMView)) or
              (prev.ActiveDoc.ID <> -1)) and ReloadThumbnail) or
              (prev.ThumbnailView = nil) or
              ((prev.ShowThumbnail) and (prev.ThumbnailView <> nil) and (prev.ThumbnailView.ImageCount = 0)) or
              ((bitfarmApp.CurrentView = tvkImporter) and
              (bitfarmApp.PreviewContainer.ImporterItem.Preview.PreviewKind = pvkMulti) and
              (bitfarmApp.PreviewContainer.PageSortingsItem.Panel.Showing) and ReloadThumbnail)
            then
              prev.RefreshThumbnailView(AThread, prev.ActiveDoc, PageIdx);

            AThread.Synchronize(nil,
              procedure
              begin
                prev.btnFulltext.Visible := (Doc.ID <> -1);
                prev.btnHistory.Visible := (Doc.ID <> -1);
                prev.btnCommentary.Visible := (Doc.ID <> -1);
              end);
//20.10.2020
//            // haben wir mehrere Eintrge bei den Briefpapieren?
//            // Dann versuchen wir den EIntrag passend zum Archive zu whlen
//            if prev.bfaTlbPreview.sbmStationery.Count > 0 then
//            begin
//              for idx := 0 to prev.bfaTlbPreview.sbmStationery.Count -1 do
//              begin
//                if Pos(LowerCase(prev.bfaTlbPreview.sbmStationery[idx].Caption), LowerCase(aSysArc[Doc.ArcID].Backpic)) > 0 then
//                begin
//                  for j := 0 to prev.bfaTlbPreview.sbmStationery.Count -1 do
//                  begin
//                    prev.bfaTlbPreview.sbmStationery[j].Checked := False;
//                    frmMainForm.bfaTlbPreview1.sbmStationery[j].Checked := False;
//                  end;
//                  prev.bfaTlbPreview.sbmStationery[idx].Checked := True;
//                  frmMainForm.bfaTlbPreview1.sbmStationery[idx].Checked := True;
//                  Break;
//                end;
//              end;
//            end;


            // Ticket 15700
            //if Doc.LetterStream.Size = 0 then
            begin  //wenn kein Briefpapier, dann darf auch nichts anzeigen!
              if prev.bfaTlbPreview.mnuStationery.Checked or prev.bfaTlbPreview.sbmStationery.Checked then
              begin
                //prev.bfaTlbPreview.mnuStationery.Checked := False;
                //prev.RemoveStationery(AThread);
                prev.AddStationery(AThread);
              end;
            end;

            AThread.Synchronize(nil,
              procedure
              begin
                if prev <> nil then
                begin
                  prev.prgPreview.Position := prev.prgPreview.Position + 1;
                  prev.prgPreview.Update;
                end;

                if (pnlSearchTimer <> nil) and (pnlSearchTimer.Caption <> '') then
                  pnlSearchTimer.Caption := '';

                if bitfarmApp.CurrentView = tvkResub then
                begin
                  try
                    if bitfarmApp.ResubListLoaded then
                    begin
                      if frmMainForm.fraResub.btnMyTasks.Checked then
                        bitfarmApp.BMResub := frmMainForm.grdResultlistDevExView.DataController.DataSource.DataSet.FieldByName('timid').AsInteger
                      else if frmMainForm.fraResub.btnDelegateTasks.Checked then
                        bitfarmApp.BMDelegateResub := frmMainForm.grdResultlistDevExView.DataController.DataSource.DataSet.FieldByName('timid').AsInteger;
                    end
                    else
                    begin
                      bitfarmApp.ResubListLoaded := True;
                      if (bitfarmApp.BMResub = 0) and (frmMainForm.fraResub.btnMyTasks.Checked) then
                        bitfarmApp.BMResub := frmMainForm.grdResultlistDevExView.DataController.DataSource.DataSet.FieldByName('timid').AsInteger
                      else if (bitfarmApp.BMDelegateResub = 0) and (frmMainForm.fraResub.btnDelegateTasks.Checked) then
                        bitfarmApp.BMDelegateResub := frmMainForm.grdResultlistDevExView.DataController.DataSource.DataSet.FieldByName('timid').AsInteger;
                    end;
                  except
                    bitfarmLog.Write(llNormal, ltException, 'Synchronize - Save ResubBookmark - ThreadID:' + IntToStr(AThread.ThreadID), 'bfaProcessing');
                  end;
                end;
              end);
          end else
          begin
            if Doc.HasPreview then
            begin
              AThread.Synchronize(nil,
                procedure
                begin
                  bitfarmLog.DebugBegin(llDebug, 'Synchronize - ShowOneDocument, New Dokument Tab - ThreadID:' + IntToStr(AThread.ThreadID), 'bfaProcessing');
                  bitfarmApp.ShowInNewTab := True;
                  try
                    try
                      if prev <> nil then
                        prev.MultiView.Enabled := False;

                      try
                        if Doc.DocName <> '' then
                          TabName := Doc.DocName
                        else
                          TabName := _('Neues Dokument');

                        if ((Doc.ID = -1) or (Doc.Modified)) then
                          TabName := TabName + ' *';

                        if TabInBackGround then
                          bitfarmApp.fSkipTabChangeEvent := True;
                        try
                          Item := bitfarmApp.PreviewContainer.AddItem(TabName, True,
                            TabInBackGround, bitfarmApp.GetInUnDockedTab(prev) or Floating);
                        finally
                          bitfarmApp.fSkipTabChangeEvent := False;
                        end;

                        // <!-- SJ 25.11.2019
                        // prev2 : Da wir beim ausdocken aus der Trefferliste keine Referenz-Preview haben.
                        //         setz ich prev2 auf das ViewerItem. Wir knnen davon ausgehen dass wir beim
                        //         ausdocken aus der Trefferliste auf dem ViewerItem stehen. Auerdem ist das
                        //         ViewerItem ohnehin die Fallback-Einstellung
                        if prev = nil then
                        begin
                          prev := Item.Preview;
                          prev2 := bitfarmApp.PreviewContainer.ViewerItem.Preview;
                        end else
                          prev2 := prev;

                        // SJ 15.02.2023 - bfacrm:ticket__show__33991
                        Item.Preview.FbfaTlbPreview.sbmAutozoom.Action := prev2.FbfaTlbPreview.sbmAutozoom.Action;

                        try
                          try
                            if Item.Preview.SearchbarToolbar.Visible then
                            begin
                              Item.Preview.SearchbarTextEdit.Text := prev2.SearchbarTextEdit.Text;
                              Item.Preview.SearchbarChkAccurate.Checked := prev2.SearchbarChkAccurate.Checked;
                              Item.Preview.SearchbarChkWholeWords.Checked := prev2.SearchbarChkWholeWords.Checked;
                              Item.Preview.SearchbarChkCircle.Checked := prev2.SearchbarChkCircle.Checked;
                              Item.Preview.SearchbarToolbar.DockPos := prev2.SearchbarToolbar.DockPos;
                            end;
                          except
                            bitfarmLog.Write(llNormal, ltException, 'ShowDocument - SearchbarToolbar', 'bfaProcessing');
                          end;
                        finally
                          prev2 := nil;
                        end;
                        // -->

                        bitfarmApp.ChangePreviewSkin(Item.Preview);

                        prev.prgPreview.Position := prev.prgPreview.Position + 1;
                        prev.prgPreview.Update;

                        Item.Preview.DontUseMouseEnter := True;
                        Item.Preview.FPreviewCreating := True; //18.10.2019
                        try
                          Item.Preview.List := TList<TbfaDocument>.Create;
                          Item.Preview.List.Add(Doc);
                        finally
                          Item.Preview.FPreviewCreating := False; //18.10.2019
                        end;
                        if prev <> nil then
                        begin
                          prev.prgPreview.Position := prev.prgPreview.Position + 1;
                          prev.prgPreview.Update;
                        end;
                        Item.Preview.ActiveDoc := Doc;

                        bitfarmApp.CreateResubFavsInPreviews(Item.Preview);

                        Item.Preview.btnFulltext.Visible := (Doc.ID <> -1);
                        Item.Preview.btnHistory.Visible := (Doc.ID <> -1);
                        Item.Preview.btnCommentary.Visible := (Doc.ID <> -1);

                        bitfarmApp.LoadFtxPos(Item.Preview.FtxPos, bitfarmApp.GetSearchString);

//27.09.2017 Ticket 11991 -->
                        // Volltext fllen
                        Item.Preview.FulltextView.mmoFulltext.Lines.Clear;
                        Item.Preview.FulltextView.mmoFulltext.Lines.Add(Doc.FullTXT);
                        Item.Preview.FulltextView.mmoFulltext.SelStart := 0;
//27.09.2017 Ticket 11991 <--

                        if prev <> nil then
                        begin
                          prev.prgPreview.Position := prev.prgPreview.Position + 1;
                          prev.prgPreview.Update;
                        end;
//16.01.2018 Ticket 13211 -->
                        Item.Preview.bfaTlbPreview.mnuPublicAnno.Enabled :=
                          (
                            (Doc.ID = -1) or (((Doc.Rights and rightARead) = rightARead) or
                            ((Doc.Rights and rightAWrite) = rightAWrite) or //01.09.2017 Dann muss man auch lesen knnen
                            ((Doc.Rights and rightAModify) = rightAModify)) //01.09.2017 Dann muss man auch lesen knnen
                          );
                        Item.Preview.bfaTlbPreview.mnuPrivateAnno.Enabled := False;
                        Item.Preview.bfaTlbPreview.mnuPublicAnno.Checked :=                           (
                            (Doc.ID = -1) or (((Doc.Rights and rightARead) = rightARead) or
                            ((Doc.Rights and rightAWrite) = rightAWrite) or //01.09.2017 Dann muss man auch lesen knnen
                            ((Doc.Rights and rightAModify) = rightAModify)) and //01.09.2017 Dann muss man auch lesen knnen
                            // bfacrm:ticket__show__29665
                            (
                              ((prev <> Item.Preview) and prev.bfaTlbPreview.mnuPublicAnno.Checked)
                              or
                              ((prev = Item.Preview) and bitfarmApp.PreviewContainer.ViewerItem.Preview.bfaTlbPreview.mnuPublicAnno.Checked)
                            )
//                            prev.bfaTlbPreview.mnuPublicAnno.Checked // SJ 23.01.2020 wenn Annos deaktiviert sind, ohne ausdocken
                            // bfacrm:ticket__show__29665
                          );
                        Item.Preview.bfaTlbPreview.mnuPrivateAnno.Checked := False;
//16.01.2018 Ticket 13211 <--
                        Item.Preview.SetCurrentLayer(0);
                        Item.Preview.ShowPage(Doc, PageIdx);
                        Item.Preview.itmBack.Enabled := False;

                        if prev <> nil then
                        begin
                          prev.prgPreview.Position := prev.prgPreview.Position + 1;
                          prev.prgPreview.Update;
                        end;
                        Item.Preview.Update;

                      finally
                        MustReload := True;
                        Item.Preview.DontUseMouseEnter := False;
                        if prev <> nil then
                          prev.MultiView.Enabled := True;
                      end;
                    except
                      bitfarmLog.Write(llNormal, ltException, 'Synchronize - ShowOneDocument, New Dokument Tab - ThreadID:' + IntToStr(AThread.ThreadID), 'bfaProcessing');
                    end;
                  finally
                    bitfarmLog.DebugEnd(llDebug, 'Synchronize - ShowOneDocument, New Dokument Tab - ThreadID:' + IntToStr(AThread.ThreadID), 'bfaProcessing');
                    bitfarmApp.ShowInNewTab := False;
                    bitfarmApp.InCreateFloatingForm := False;
                  end;
                end);

//              kein SetActiveView fr einzelne Tabs
//              bitfarmApp.SetActiveView(AThread, Item.Panel.Tag, nil, integer(bitfarmApp.CurrentView));

              if not TabInBackground then  //02.06.2017 Ticket 10703
                bitfarmApp.ShowActiveTab(AThread, Item.Panel.Tag);

              if Item <> nil then
              begin
                Item.Preview.RefreshThumbnailView(AThread, Doc, PageIdx);

                if Item.Preview.bfaTlbPreview.mnuStationery.Checked then
                  Item.Preview.AddStationery(AThread);

                bitfarmApp.Autozoom(Item.Preview, AThread);
//23.11.2018 Ticket 16872 -->
                AThread.Synchronize(nil,
                  procedure
                  begin
                    if Item.Preview.Floating then
                      Item.Preview.SingleView.img_DocView.SetFocus;
                  end);
//23.11.2018 Ticket 16872 <--
              end;

              AThread.Synchronize(nil,
                procedure
                begin
                  if prev <> nil then
                  begin
                    prev.prgPreview.Position := prev.prgPreview.Position + 1;
                    prev.prgPreview.Update;
                  end;
                end);
            end
            else if Doc.ID = -1 then
            begin
//31.05.2017 Ticket 10703 -->
              try
                bitfarmApp.OpenInApp(AThread, Doc);
              except
                on e: Exception do
                begin
                  bitfarmLog.Write(llNormal, ltException, 'ShowDocument', 'bfaProcessing');
                end;
              end;
//31.05.2017 Ticket 10703 <--
            end;
          end;
        end
        else
        begin
          AThread.Synchronize(nil,
            procedure
            begin
              if prev <> nil then
              begin
                if prev.SingleView.img_DocView.ObjectsCount > 0 then
                  prev.SingleView.img_DocView.RemoveAllObjects;

                prev.SingleView.img_DocView.Clear;
                if prev.ThumbnailView <> nil then
                  prev.ThumbnailView.Clear;

                prev.ActiveDoc := nil;
                bitfarmApp.ShowDocumentProperties(nil, prev);

                if (pnlSearchTimer <> nil) and (pnlSearchTimer.Caption <> '') then
                  pnlSearchTimer.Caption := '';

              end;
            end);
        end;
      finally
        Doc.EndShowProcess;
      end;

      if not TabInBackground then //02.06.2017 Ticket 10703
      begin
        if (Doc <> nil) and (MustReload) and ((Doc.ID = -1) or ((Doc.ID <> -1) and (Doc.Loaded))) then
        begin
          AThread.Synchronize(nil, //31.10.2019 muss getrennt sein
            procedure
            begin
              if Item <> nil then
              begin
                bitfarmApp.FillDocLinkList;
              end
              else if prev <> nil then
              begin
                bitfarmApp.FillDocLinkList;
                bitfarmApp.ShowDocumentProperties(Doc, prev);
              end;
            end);

          AThread.Synchronize(nil, //31.10.2019 muss getrennt sein
            procedure
            begin
              if not InNewTab then
              begin
                ShowAddFields(Doc, (not InNewTab));
                ShowStateFields(Doc);
              end;

              prev.fIsSettingValue := True;
              prev.SearchbarTextEdit.Text := '';
              prev.fIsSettingValue := False;
              prev.FSearchbarLastEdit := '';
              prev.FulltextCurrentIndex := -1;

              if (prev.FulltextPositionLst.Count <> 0) then
                prev.FulltextPositionLst.Clear;

              bitfarmApp.SetStandardStatusInfo(nil);

              // existiert eine ocr-xml?
              if (prev.FtxPos <> nil) {prev.ActiveDoc.ocrxmlexists} then
                bitfarmApp.SetFtxIcon(prev, Integer(icoidx_search_result_highlighting), _('Fundstellenmarkierung'), False)
              else
                bitfarmApp.SetFtxIcon(prev, Integer(icoidx_search_result_highlighting_no), _('Keine Positionsinformationen vorhanden (OCR xml)'), False);

              // TODO SJ: differenzierung zwischen count=0 und keiner ocr-xml (prev.ActiveDoc.ocrxmlexists)

              // Alles leer, nichts gesucht. Icons mssen trotzdem gesetzt werden
              if (SearchString = '') and (prev.SearchbarTextEdit.Text = '') then
              begin

                // Searchstring oder Suchbar gesetzt
              end else if ((SearchString <> '') or (prev.SearchbarTextEdit.Text <> '')) then
              begin
                // ungleiche Sucheingaben -> Suchbar hat Prio
                if (SearchString <> prev.SearchbarTextEdit.Text) then
                begin
                  if (prev.FtxPos = nil) {prev.ActiveDoc.ocrxmlexists} then
                    frmMainForm.SetNotificationBar(_('Keine Positionsinformationen vorhanden (OCR xml)'), nil);

                  if (prev.SearchbarTextEdit.Text = '') then
                    prev.SearchbarTextEdit.Text := SearchString;

                  prev.SearchbarModified := True;
                  prev.tmrMarkFulltext(nil);
                  prev.SearchbarPreviewModified := False; // SJ 14.09.2020 bfacrm:ticket__show__23630
                  // SJ 16.12.2019 - muss raus, wegen neuladen des Thumbnails
                  // gibt Probleme beim Kill des Thumbnail-Threads
//                  prev.SearchbarButtonDownClick(nil);
                end;
              end
              else
              begin
                prev.SearchbarTextEdit.Text := SearchString;
                prev.SearchbarModified := True;
                prev.tmrMarkFulltext(nil);
                prev.SearchbarPreviewModified := False; // SJ 14.09.2020 bfacrm:ticket__show__23630
                // SJ 16.12.2019 - muss raus, wegen neuladen des Thumbnails
                // gibt Probleme beim Kill des Thumbnail-Threads
//                prev.SearchbarButtonDownClick(nil);
              end;
            end);
        end;

        if (prev <> nil) and (Item = nil) then
        begin
          if Doc.HasPreview or ((bitfarmApp.CurrentView = tvkImporter) and
            (bitfarmApp.PreviewContainer.PageSortingsItem.Panel.Showing))
          then
            ShowTheDocument(Doc, prev, SetImagePos, SetImagePosTothetop, Autozoom)
          else
          begin
            AThread.Synchronize(nil,
              procedure
              begin
                prev.ShowPageNumber;
              end);
          end;
        end;

        AThread.Synchronize(nil,
          procedure
          begin
            if prev <> nil then
            begin
              if (Doc.ID = -1) and (bitfarmApp.CurrentView = tvkImporter) then
              begin
                bitfarmApp.FillImporterFields;
                bitfarmApp.FillDocLinkList;
              end;
              if (MustReload) and (prev.SingleView.img_DocView.IO.Params.ImageCount > 0) and
                 (prev.tbi_normalmouse.Enabled) then
              begin
                prev.tbi_normalmouse.Checked := True;
                prev.UnCheckAllGraphicTools;
              end;
              //08.04.2021 Ticket  -->
              // SJ 08.02.2022 - bfacrm:ticket__show__29053
              if bitfarmApp.CanPopupBallon and bitfarmApp.ViewerOptions.GeneralOptions.HintBallons and
                 (SetCurrent or ((Item <> nil) and (Item.Preview.Floating))) then
              begin
                bitfarmApp.ppmCalloutBallon.Close;
                if prev.Floating or ((Item <> nil) and (Item.Preview.Floating)) then
                begin
                  if Item <> nil then
                  begin
                    bitfarmApp.ppmCalloutBallon.Popup(Item.Preview.bfaTlbPreview, Item.Preview.bfaTlbPreview.mnuPublicAnno.Rect);
//                    bitfarmApp.ppmCalloutBallon.Popup(Item.Preview.bfaTlbPreview, Item.Preview.bfaTlbPreview.mnuPublicAnno.Rect);
                  end else
                    bitfarmApp.ppmCalloutBallon.Popup(prev.bfaTlbPreview, prev.bfaTlbPreview.mnuPublicAnno.Rect);
                end
                else
                begin
                  if frmMainForm.bfaTlbPreview1.Visible then
                    bitfarmApp.ppmCalloutBallon.Popup(frmMainForm.bfaTlbPreview1, frmMainForm.bfaTlbPreview1.mnuPublicAnno.Rect)
                  else
                    bitfarmApp.ppmCalloutBallon.Popup(frmMainForm.tlbMainMenu, frmMainForm.mnuHelp.Rect);

                end;
              end;
//              if bitfarmApp.CanPopupBallon and bitfarmApp.ViewerOptions.GeneralOptions.HintBallons then
//              begin
//                bitfarmApp.ppmCalloutBallon.Close;
//                if prev.Floating or ((Item <> nil) and (Item.Preview.Floating)) then
//                begin
//                  if Item <> nil then
//                    bitfarmApp.ppmCalloutBallon.Popup(TbfaFloatingForm(Item.Preview.Parent.Parent.Parent))
//                  else
//                    bitfarmApp.ppmCalloutBallon.Popup(TbfaFloatingForm(prev.Parent.Parent.Parent));
//                end
//                else
//                  bitfarmApp.ppmCalloutBallon.Popup(frmMainForm);
//              end;
              // SJ 08.02.2022 - bfacrm:ticket__show__29053
              //08.04.2021 Ticket  <--
            end;
          end);
      end;

      AThread.Synchronize(nil,
        procedure
        begin
          //02.06.2022 habe rausgenommen, aber verursacht Fehler im Importer -->
//          if DocList <> nil then
//          begin
//          end
//          else
//          if Doc <> nil then
          //02.06.2022 habe rausgenommen, aber verursacht Fehler im Importer <--
          if (DocList = nil) and (Doc <> nil) then
          begin
            if Doc.Loaded then
            begin
              if bitfarmApp.CurrentContainer.Count > 0 then
              begin
                if (bitfarmApp.CurrentContainer[0].ID = Doc.ID) and (not bitfarmApp.CurrentContainer[0].Loaded) then
                  bitfarmApp.CurrentContainer[0] := Doc
                else
                begin
                  if (bitfarmApp.CurrentContainer[0].ID = Doc.ID) and (bitfarmApp.CurrentContainer.Count > 1) and
                    (bitfarmApp.CurrentContainer[1].ID = Doc.ID) and (bitfarmApp.CurrentContainer[1].Loaded)
                  then
                    bitfarmApp.CurrentContainer.Delete(0);
                end;
              end;
            end;
          end;
        end);
    except
      bitfarmLog.Write(llNormal, ltException, 'ShowDocument', 'bfaProcessing');
    end;
  finally
    if ((bitfarmApp.CurrentView = tvkViewer) or (bitfarmApp.CurrentView = tvkResub)) then
    begin
      if (Doc <> nil) and (Doc.ID <> -1) and
        ((Doc.ID <> bitfarmApp.LastDocArc.GdocID) or
        (Doc.ArcID <> bitfarmApp.LastDocArc.ArcID))then
      begin
        if (not bitfarmApp.DocHistoryFirstItem)
          and (not bitfarmApp.LastDocSearch) //14.05.2020 Ticket 21202
        then
        begin
          inc(bitfarmApp.DocHistoryIdx);
          SetLength(bitfarmApp.DocHistory, bitfarmApp.DocHistoryIdx);
          if (bitfarmApp.LastDocArc.GdocID = 0) and (bitfarmApp.LastDocArc.ArcID = 0) then
          begin
            DocArc.GdocID := Doc.ID;
            DocArc.ArcID := Doc.ArcID;
            bitfarmApp.DocHistory[bitfarmApp.DocHistoryIdx - 1] := DocArc;
          end
          else
            bitfarmApp.DocHistory[bitfarmApp.DocHistoryIdx - 1] := bitfarmApp.LastDocArc;
        end;
        bitfarmApp.LastDocArc.GdocID := Doc.ID;
        bitfarmApp.LastDocArc.ArcID := Doc.ArcID;
        bitfarmApp.DocHistoryFirstItem := False;
      end;
    end;

    if prev.PreviewKind = pvkSingle then //13.06.2024 BT
    begin
      //13.05.2024 SD Klick auf Thumbnail soll zur Voransicht wechseln -->bfacrm:ticket__show__34970
//12.07.2024 BT     if not prev.FimgSingleView.Visible then
      if (not prev.FimgSingleView.Visible) and MouseClick then //12.07.2024 bfacrm:ticket__show__39299
      begin
        //16.05.2024 SD Klick auf ButtonPreviewClick - Umsetzung durch UserAction
        prev.btnPreviewClick(nil);
      end;
      //13.05.2024 SD <--bfacrm:ticket__show__34970
    end;

    AThread.Synchronize(nil,
      procedure
      begin
        if prev <> nil then
        begin
          prev.prgPreview.Position := 0;
          prev.prgPreview.Update;
        end;

        if pnlLoadDoc <> nil then
        begin
          pnlLoadDoc.Caption := '';
          pnlLoadDoc.ParentBackground := True;
          pnlLoadDoc.Color := OldColor;
        end;
      end);

    bitfarmApp.ShowDocumentInProcess := False;
    bitfarmApp.MViewSelectingByMouseMove := False;
    bitfarmApp.LastDocSearch := False;//14.05.2020 Ticket 21202

    bitfarmLog.DebugEnd(llDebug, 'ShowDocument', 'bfaProcessing');
  end;
end;

//09.10.2024 SD -->bfacrm:ticket__show__39992
procedure RefreshSizeAddFields;
var
  j: Integer;
begin
  bitfarmLog.Write(llDebug, ltDebug, 'RefreshSizeAddFields', 'bfaProcessing');
  try
    for j := 0 to aCurrentAddfields.Count - 1 do
    begin
      //vorerst nur fr Grid
      if (aCurrentAddfields[j].Typ = 13) then
         aCurrentAddfields[j].Component.Value := aCurrentAddfields[j].Component.Value;
//         aCurrentAddfields[j].Component.Refresh;
    end;
  except
    on e:Exception do
    begin
      bitfarmLog.Write(llNormal, ltException, 'RefreshSizeAddFields: ' + e.Message, 'bfaProcessing');
    end;
  end;
end;
//09.10.2024 SD <--bfacrm:ticket__show__39992

end.
