'*******************************************************************************************
'*******************************************************************************************
'***************************      bitfarm Archiv 2023      *********************************
'*******************************************************************************************
'*******************************************************************************************
'***************  Archivierung.vbs  GPL   **************************************************
'*******************************************************************************************
'***************  Version 3.6.2.7         **************************************************
'*******************************************************************************************
'***************  Programm zur Volltextindizierung und Archivierung          ***************
'***************  in das bitfarm-Archivsystem                                ***************
'***************                                                             ***************
'***************  kontrolliert, ob neue jobdateien vorhanden sind und        ***************
'***************  wandelt die zugehrigen Postscriptdateien in tif-Dateien   ***************
'***************  um, erzeugt den passenden Volltext und speichert tif-Datei ***************
'***************  im Archiv-Baum, sowie Volltext und Referenzen              ***************
'***************  im SQL-Server.                                             ***************
'***************                                                             ***************
'***************  Syntax: <programmpfad>archivierung.vbs                     ***************
'***************                                                             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************

'*** fr den Service:

scriptdebug = False
namingdebug = False
maskdebug = False
logging = True
cleanup = True
checkstartup = False
testOMP = True
SavePPasList = False 
waitautoscan=True

preprocessing=False
resetnamingdefaults=False
perfmon=False
ReDim perfdata(100)
ReDim perfcolnames(100)
perfcounter = 0 

perfadd("start")

'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*** Variablendimenionierung

limit = 80
linklimit=200


'*******************************************************************************************
'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
extrajob = ""
extraskip = False
On Error Resume Next


Dim objWSHShell, fso, fs, FileIn, FileOut 
Dim Datei, Text, Txt, i, arrSort, arrTest(), oArgs, Druckername
Dim lngReturnCode
Dim errortxt
Dim javapath, foppath, openofficepath

Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set fs      = WScript.CreateObject("Scripting.FileSystemObject") 
Set oArgs    = WScript.Arguments 

tstamp = Timer

If checkstartup = True Then
    objWSHShell.LogEvent 2,"Archivierung.vbs: Starte... " & vbCrLf & "Tstamp:" & tstamp & vbCrLf & "Jetzt:" & Timer
End If


'ReDim sqlmappersections(limit)
'ReDim sqlmapper(limit)
ReDim params(10)
ReDim email(limit) 
ReDim txttofind(limit)
ReDim bctofind(limit)
ReDim andor(limit)
ReDim Tabelle1(limit)
ReDim searchsteps(limit)
ReDim searchstring(limit)
ReDim patterngroup(limit)
ReDim searchdirection(limit)
ReDim casezusatzfeldname(limit)
ReDim	operator(limit)
ReDim	operant(limit)
ReDim searchflag(limit)
ReDim getnextstrings(limit)
ReDim readpositions(limit)
ReDim deletespaces(limit)
ReDim deletedashes(limit)
ReDim deletedots(limit)
ReDim GetAllmyStrings(limit)
ReDim buildlink(limit)
ReDim numeric(limit)
ReDim continue(limit)
ReDim alphabetic(limit)
ReDim interval(limit)
ReDim value(limit)
ReDim istdatum(limit)
ReDim usdatum(limit)
ReDim autodatum(limit)
ReDim charlimit(limit)
ReDim linkflag(linklimit)
ReDim linkspeicher(linklimit)
ReDim cutstringleft(limit)
ReDim cutstringright(limit)
ReDim getmidstring(limit,2)
ReDim replacestring(limit,2)
ReDim Zusatzfeld(limit)
ReDim Zusatzfeldname(limit)
ReDim Zusatzfeldname2(limit)
ReDim Zwischenwert(limit)
ReDim Zwischenname(limit)
ReDim continuezusatzfeld(limit)
ReDim continuezusatzfeldname(limit)
ReDim xpaths(limit)
ReDim xpathfields(limit)
ReDim Ref(limit)
ReDim regexpglobal(limit) 
ReDim regexpcasesensitiv(limit)
ReDim ext(60)
ReDim FileInfoDescription(60)
ReDim FileInfoValue(60)
ReDim Schlagworte(60)
ReDim nosortarchiv(limit)
ReDim barcode(30)
ReDim fixvalues(30)
ReDim fixvaluenames(30)
ReDim maxvalues(5)
ReDim ocrtxtxfiles(1000)
ReDim changeresolution(100)
ReDim excelextensions(100)
ReDim exclude(limit)
ReDim symlinks(limit)
ReDim doc_xpaths(500)
ReDim doc_xpath_values(500)

excelextensions(0)=".stc"
excelextensions(1)=".sxc"
excelextensions(2)=".ots"
excelextensions(3)=".ods"
excelextensions(4)=".xltm"
excelextensions(5)=".xltx"
excelextensions(6)=".xlsm"
excelextensions(7)=".csv"
excelextensions(8)=".xls"
excelextensions(9)=".xlt"
excelextensions(10)=".xlsx"

For i=0 To 59
    ext(i)="...."
    FileInfoDescription(i)=""
    FileInfoValue(i)=""
    Schlagworte(i)=""
Next



ext(0)=".tif"
ext(1)=".ps"
ext(2)=".pdf"
ext(3)=".bmp"
ext(4)=".jpg"
ext(5)=".gif"
ext(6)=".pcl"
extcounter=7

For i = 0 To limit
    email(i)=""
    txttofind(i)=""
    bctofind(i)=""
    andor(i)=0
    Tabelle1(i)=""
    searchstring(i)=""
    searchsteps(i)=""
    nosortarchiv(i)=""
    searchdirection(i)=""
    cutstringleft(i)=0
    cutstringright(i)=0
    getmidstring(i,1)=0
    getmidstring(i,2)=0
    replacestring(i,1)=0
    replacestring(i,2)=0
    searchflag(i)=0
    linkflag(i)=0
    linkspeicher(i)=""
    ref(i)=""
    getnextstrings(i)=0
    readpositions(i)=""
    deletespaces(i)=0
    deletedashes(i)=0
    deletedots(i)=0
    GetAllmyStrings(i)=0
    buildlink(i)=""
    numeric(i)=False
    continue(i)=False
    alphabetic(i)=False
    interval(i)=False
    value(i)=False
    istdatum(i)=False
    autodatum(i)=False
    charlimit(i)=255
    Zusatzfeld(i)=""
    Zusatzfeldname(i)=""
    Zusatzfeldname2(i)=""
    Zwischenwert(i)=""
    Zwischenname(i)=""
    continuezusatzfeld(i)=""
    continuezusatzfeldname(i)=""
Next

For i = 0 To linklimit
    linkflag(i)=0
    linkspeicher(i)=""
Next


For i=0 To 100
    changeresolution(i)=""
Next

symlinkcounter=0
addpdfinfo=True
truncatedXlsPreview = False
recasesensitive=False
xlspages = 0
gdocid = 0
pdfAutoRotate = False
tifAutoRotate = False
rotatePDF = False
newstatuslang="deutsch"
gedaechtnis = 30000
dropshortstrings=False
readbarcodes=False
Defaultresolution=""
allownonrevisionsave=False
extractPDF=False
checkOCR=True
clientID=""
flag1 = False
tabellencount=0
emailcount = 0
txtfindcount = 0
bcfindcount=0
searchstringcount = 0
autoshrinkjpg = 0
'sqlmappercounter = 0
bodytxt = ""
admin=""
wfID="0"
newstatflag="0"
headertxt = ""
setworkflow=""
sendfile=False
myform=""
isdirect=False
writeempty=False
archivverzeichnis = ""
archivkopie=""
storages = ""
archive_rs = ""
archive_nrs = ""


omnipage=""
fromEMAIL=False
nowarnings=False
alternatemakedate=True
CustomPDFtoTIFFConverter=""
clientspooler=""
overridecheck=False
dublettenpruefung =False
dublettenmail=False
schattenarchiv = False
dublettengarbage=False
notifyUser=False
VCVIEWCONVERTInstalled=False
adminmail=""
externname=""
barcodemode=""
barcodemask=""
barcodesecondthreshold=""
bcsecondrun=""
eymbcrdcmdpath=""
bcpluspath=""
barcodefilter=""
mydocname=""
mailattachments=""
mainplugin=""
directplugin=""
archivtif=""
masks=""
forms=""
Zusatzfelder=0
dokdate=""
oldstatus=""
newstatus=""
Typ=""
Username=""
myname=""
Tabelle=""
archquelle = False
Filtermakro=""
Archivfilter=""
OCRFilter=""
folderID=""
docrotation=""
DokID=""
archivverzeichnis = ""
autoexportpath=""
autoexportscript=""
makepdf=False
extension=""
omnipage=""
clientprogram=""
clientspooler=""
workflows=""
archivkopie=""
dublettenpruefung =False
dublettengarbage=False
schattenarchiv = False
color=False
hires=False
backupbearbeiter=""
backupnotiz=""
backuptermin=""
backupalarm=""
backupoptionen=""
adminmail=""
externname=""
mydocname=""
OCRHandle=""
handle=""
Ausgabename=""
workflowfile=""
Serviceprinter=""
dokdate=""
archivtif=""
orginal=""
Profil=""
folderID=""
docrotation=""
docschangeable=False
fromdirect=False
quelle=""
archofficecolor=False
archpdfincolor=False
archpsincolor=False
archDWGcolor=False
archHTMLincolor=False
archJPGincolor=True
AKTSupport=False
IrfanViewInstalled=False
officeOCR=False
acceptallfiletypes=False
deletezipafterdecomp=False
zippath=""
hostversion=""
MSWordinstalled=False
MSExcelinstalled=False
MSPowerPointinstalled=False
MSOffice2007installed=False
checkexistingdocpreview=False
OCRQF=0
zusfeldzaehler=0
masklinkflag=0
OpProgramm=""
OCRPath=""
OCRDir=""
BFADocName=""
BFADoklink=""
BFAVersion=""

firstversion=False

opagentrestarts=0
opagentjobpath=""
ompmultipages=False
pages=""
tolerantocrcheck=False
notiz=""
alertonemptydoctxt=False
alertonemptydoctxtcounter=0
stoponemptydoctxt=False
emptydoctxt=False
useDSO=True
JPGNRS=False
PDFNRS=False
PPTNRS=False
GIFNRS=False
PNGNRS=False
BMPNRS=False
XMLNRS=False
NOEXTNRS=False
emlNRS=False
msgNRS=False
solidworksnrs=False
xsltconverterpath=""
xslttemplate=""
change_ext_loc=False
schattenname=""
dontconvertcommatopoint=False
dontdecompzipatall=False
alertongarbage=False
alertongarbagecounter=0
annotations=0
pcltotif=""
dontuseocrforgif=False
dontuseocrforjpg=False
dontuseocrforbmp=False
dontuseocrforpng=False
dontuseocrforcad=False
exifreader=""
dpi=""
ompwaittime = 2800
jobrunnertimeout=120
omptryonce=True
ompdontcomparetxt=True
workflows=""
opensslpath=""
sha1=""
showhost=""
dontdecompzipattachments=False
gsview=""
pluginspath=""
checksumfilename=""
maxpdfpages=10000
xlsmaxpages=10000
MSWordupdatefields = False
dontnormdokname = False
importpath=""
usejpgtotif = False
emailblack=""
emailwhite=""
emailacceptnoextension=""
attachmentarchiv=""
attachmentdontuseoriname=False
dontExtractMsgAttachments=False
setprintermethod="default"
msgconverter="outlook"
htmlconverter=""
SolidWorksConverter=""
SolidWorksSize="1000x1000"
emlconverter="emlconvert.vbs"
doknamefilter=""
ocrserver=""
renderserver=""
archmsg=True
createwvl = False
removepretag = False
userwarnings=False
emailcolor=""
rawheader=""
ftxaddrawheader=False
notificationconverttif=False
notificationmessage=""
pdftextminsize=1
pdftextverifyregex=""
loadimages=True
linkdoubleattachments=False
filterinlineattachments=False
earlyusing=False
omp19maxjobs=1
forceomp=False
normftx=True
normstr=True
normzus=True
savejob=True
ftxaddpagebreaks=False
tifpagecount=0
archivbasedir=""
directiveextensions=".tif"
mapexif=True
ocrxmlfor = ""
forcedomp = False
usepdfmacro = True
zipfilelist=False
usetesseract = True
tesslang="deu"
tessmaxpagetime=60
tessprocs=1
ismaskocr=False
xmltotext = False
xml_fields_to_tif = False
htmltemplate = ""
pdf_xml_extract = False
doc_xpaths_read = False


extractxmlattachments = True

xmlwhitelistextension=""
xmlblacklistextensions=""


For i = 0 To limit
    Zusatzfeld(i)=""
    Zusatzfeldname(i)=""
    Zusatzfeldname2(i)=""
    continuezusatzfeld(i)=""
    continuezusatzfeldname(i)=""
Next


strinput=""
dokID=0
wfID=0
linkzaehler=0
For i = 0 To linklimit
    linkspeicher(i)=""
Next	

For i=0 To 30
    barcode(i)=""
    fixvalues(i)=""
    fixvaluenames(i)=""
Next

For i=0 To 5
    maxvalues(i)=""
Next

'*********************** globale Variablen fr USE Zuordnung ******************************

richtung=""							'Eingang / Ausgang / Intern
absender=""
absenderadresse=""
empfaenger=""
cc=""
bcc=""
betreff=""
empfangsdatum=""
empfangsuhrzeit=""
versanddatum=""
versanduhrzeit=""
faxnummer=""		
fax=""
originaldatei=""				'Dateiname
kategorie=""						'Outlook, erweiterte Dateieigenschaften
groesse=""							'Dateigre in KB
autor=""								'Autor aus erweiterte Dateieigenschaften WORD, PDF, etc.
titel=""								'dto. fr Titel
herkunft=""
DocVersion=""						'Versionsnummer bei Office-Dateien
DocLink=""							'Linkstring, der alle Tochterdokumente mit Mutter verbindet



'*******************************************************************************************
'**************************  Startparameter initialisieren  ********************************
Err.clear
fullpath = WScript.ScriptFullName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
scriptname = WScript.ScriptName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
If Len(programm)=0 Then
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If


queue=programm&"queue\"
garbagepath=programm&"garbage\"
dublettenpath=programm&"dubletten\"
workflows=programm&"workflows\"
masks=programm&"masks\"
forms=programm&"forms\"
temp=programm&"temp\"
pruefdatei = programm&"checksum.txt"
lockdatei="temp\lock"
superlockdatei="temp\superlock"

templates=programm&"templates\"
pluginspath=programm&"plugins\"

'*******************************************************************************************
'*******************************************************************************************

Jahr = DatePart("yyyy",Date)
Monat = DatePart("m",Date)
Tag = DatePart("d",Date)
Stunde = DatePart("h",Time)
Minuten = DatePart("n",Time)
Sekunde = DatePart("s", Time)
zahl = Zufallszahl(0,999)
datum = Jahr&"-" & Monat & "-" & Tag & "--" & Stunde & "-" & Minuten & "-" & Sekunde
tempname = Datei
pruefdatei = programm&"checksum.txt"
exception=clientspooler
mon=Monat
If Len(mon)=1 Then
    mon="0"&mon
End If
jhr=Jahr
If Len(tag)=1 Then
    tag="0"&tag
End If
foldernumber=mon&jhr
subfoldernumber=tag

'***************************************   Schauen, ob wir dran sind ***************************
perfadd("initvars")

If checkstartup = True Then
    objWSHShell.LogEvent 2,"Archivierung.vbs: Prfe Directlock " & vbCrLf & "Tstamp:" & tstamp & vbCrLf & "Jetzt:" & Timer
End If


If Not fs.Fileexists(programm& "queuecnt.txt") Then
    If fs.fileexists(programm & "countfiles.exe") Then
        i = countfiles(programm & "queue" , "*.job")	 
        Set cntfile = fs.CreateTextFile(programm& "queuecnt.txt",True)
        cntfile.Writeline i
        cntfile.close
        Set folder = Nothing
    Else
        lngReturnCode = objWSHShell.Run(Chr(34)&programm & "countfiles.bat"&Chr(34)&" " &Chr(34)& programm&Chr(34))
    End If
End If


Err.clear
rundirect=False
directlockexist=False
If Not fs.FileExists(programm&"temp\directlock") Then
    
    
    If Not fs.FolderExists(programm&"direct") Then
        Set test = fs.CreateFolder(programm&"direct")
        Set test = Nothing
        WScript.sleep 200
        If Err.number<>0 Then
            objWshShell.LogEvent 1, "archivierung(0): kann direct-verzeichnis nicht erstellen - Berechtigung?"
            On Error Resume Next
            Err.clear
            WScript.Quit
        End If 
        
        If Not fs.FolderExists(programm&"direct") Then
            objWshShell.LogEvent 1, "archivierung(0b): kann direct-verzeichnis nicht erstellen (2) - Berechtigung?"
            WScript.Quit
        End If
    End If
    
    Set folder = fs.GetFolder(programm&"direct")
    rundirect=False
    For Each file In folder.Files
        'MsgBox(file)
        If (Right(file,3) = "job") And (Left(file.name,6) = "direct") Then'~~~~~~~~~
            rundirect=True
        End If
    Next
    Set folder=Nothing
    If rundirect=True Then
        
        
        directpath()
        
    End If
Else
    directlockexist=True
End If

If (directlockexist=True) Then
    WScript.Quit
End If

If directlockexist=True Then
    zaehler=0
    abbruch=False
    Do While abbruch = False
        If Not fs.FileExists(programm&"temp\directlock") Then
            abbruch=True
        End If
        If abbruch = False Then
            zaehler=zaehler+1
            WScript.Sleep 500
        End If
        If (zaehler > 500) And (abbruch = False) Then
            On Error Resume Next
            fs.deletefile programm&"temp\directlock", True
            objWshShell.LogEvent 1,"bitfarm-Archiv: Archivierung: Directlock musste entfernt werden."
            WScript.Quit
        End If
    Loop
    WScript.Quit
End If


If checkstartup = True Then
    objWSHShell.LogEvent 2,"Archivierung.vbs: Prfe Superlock " & vbCrLf & "Tstamp:" & tstamp & vbCrLf & "Jetzt:" & Timer
End If



If fs.FileExists(programm&superlockdatei) Then
    
    If checkstartup = True Then
        objWSHShell.LogEvent 2,"Archivierung.vbs: Superlock vorhanden, terminiere..." & vbCrLf & "Tstamp:" & tstamp & vbCrLf & "Jetzt:" & Timer
    End If
    WScript.Sleep 1000
    WScript.Quit
    
End If

If fs.FileExists(programm&lockdatei) Then
    'If fs.FileExists(programm&"temp\directlock") Then
    '	WScript.Quit
    'End If
    If testOMP=False Then
        
        WScript.quit
        
    Else
        '***************************************  SuperLock erstellen  ************************************
        Err.clear
        
        If Not fs.FileExists(programm&superlockdatei) Then
            Set lockfile = fs.CreateTextFile(programm&superlockdatei,True)
            lockfile.Writeline("superlock")
            lockfile.close
            
            Set lockfile = Nothing
            
            If Err.number<>0 Then
                objWshShell.LogEvent 1, "archivierung(1): Fehler bei superlockfile erstellen"
                Err.clear
                'Unlock(programm&superlockdatei)
                WScript.Quit
            End If
        Else
            WScript.quit 
        End If
        
        
        If checkstartup = True Then
            objWSHShell.LogEvent 2,"Archivierung.vbs: Superlock erstellt" & vbCrLf & "Tstamp:" & tstamp & vbCrLf & "Jetzt:" & Timer
        End If
        
        
        '****************************************************************************
        
        
        If waitautoscan=True Then
            tz=True
            ta=0
            Do While tz=True
                If checkautoscan=True Then
                    WScript.sleep 8000
                    ta=ta+1
                Else
                    tz=False
                End If
                If ta>50 Then
                    tz=False
                    waitautoscan=False
                End If
            Loop
        End If
        
        
        If checkstartup = True Then
            objWSHShell.LogEvent 2,"Archivierung.vbs: Prfe Aktivitt " & vbCrLf & "Tstamp:" & tstamp & vbCrLf & "Jetzt:" & Timer
        End If
        
        
        termsignal = False
        i=0
        w=0
        Do While termsignal = False
            w=w+1
            WScript.sleep 100
            If w>36000 Then
                If (checkomnipage = 1) Or (checkJobRunner = True) Or (checkghostscript = True) Or (checkfilter = 1) Or (checkPDFtoPS = True) Then
                    w = 0
                Else
                    termsignal=True
                End If
            End If
            
            If Not fs.FileExists(programm&lockdatei) Then
                Unlock(programm&superlockdatei)
                'If scriptdebug = True Then
                'objWshShell.LogEvent 0, "archivierung-debug: superlockfile gelscht " & vbCrLf & starterzeit & vbCrLf &Now() & vbCrLf & "checkdauer " & checkstoptime - checkstarttime
                'End If
                WScript.Quit
            End If
        Loop
        
        objWshShell.LogEvent 2, "bitfarm-Archiv: Archivierung: Timeout bei fehlender Archivierungsaktivitt - automatischer Dienstneustart."
        Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
        strQuery = "Select * from Win32_Process where Name='omnipage.exe'"
        Set colItems = objWMIService.ExecQuery(strQuery,,48)
        z=0
        For Each objItem In colItems
            objItem.Terminate()
            z=z+1
        Next
        If z>0 Then
            objWshShell.LogEvent 2, "bitfarm-Archiv: Terminierte Omnipage-Instanzen: "&z
        End If
        Set objItem = Nothing
        Set colItems = Nothing
        Set objWMIService = Nothing
        
        Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
        strQuery = "Select * from Win32_Process where Name='gswin32.exe'"
        Set colItems = objWMIService.ExecQuery(strQuery,,48)
        z=0
        For Each objItem In colItems
            objItem.Terminate()
            z=z+1
        Next
        If z>0 Then
            objWshShell.LogEvent 2, "bitfarm-Archiv: Terminierte Ghostscript-Instanzen: "&z
        End If
        Set objItem = Nothing
        Set colItems = Nothing
        Set objWMIService = Nothing
        
        Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
        strQuery = "Select * from Win32_Process where Name='rdtifbar.exe'"
        Set colItems = objWMIService.ExecQuery(strQuery,,48)
        z=0
        For Each objItem In colItems
            objItem.Terminate()
            z=z+1
        Next
        If z>0 Then
            objWshShell.LogEvent 2, "bitfarm-Archiv: Terminierte barcode-Instanzen: "&z
        End If
        Set objItem = Nothing
        Set colItems = Nothing
        Set objWMIService = Nothing
        
        Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
        strQuery = "Select * from Win32_Process where Name='FilterV3.exe'"
        Set colItems = objWMIService.ExecQuery(strQuery,,48)
        z=0
        For Each objItem In colItems
            objItem.Terminate()
            z=z+1
        Next
        If z>0 Then
            objWshShell.LogEvent 2, "bitfarm-Archiv: Terminierte Filter-Instanzen: "&z
        End If
        Set objItem = Nothing
        Set colItems = Nothing
        Set objWMIService = Nothing
        
        Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
        strQuery = "Select * from Win32_Process where Name='WinWord.exe'"
        Set colItems = objWMIService.ExecQuery(strQuery,,48)
        z=0
        For Each objItem In colItems
            objItem.Terminate()
            z=z+1
        Next
        If z>0 Then
            objWshShell.LogEvent 2, "bitfarm-Archiv: Terminierte WinWord-Instanzen: "&z
        End If
        Set objItem = Nothing
        Set colItems = Nothing
        Set objWMIService = Nothing
        
        Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
        strQuery = "Select * from Win32_Process where Name='Excel.exe'"
        Set colItems = objWMIService.ExecQuery(strQuery,,48)
        z=0
        For Each objItem In colItems
            objItem.Terminate()
            z=z+1
        Next
        If z>0 Then
            objWshShell.LogEvent 2, "bitfarm-Archiv: Terminierte Excel-Instanzen: "&z
        End If
        Set objItem = Nothing
        Set colItems = Nothing
        Set objWMIService = Nothing
        
        Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
        strQuery = "Select * from Win32_Process where Name='PowerPoint.exe'"
        Set colItems = objWMIService.ExecQuery(strQuery,,48)
        z=0
        For Each objItem In colItems
            objItem.Terminate()
            z=z+1
        Next
        If z>0 Then
            objWshShell.LogEvent 2, "bitfarm-Archiv: Terminierte PowerPoint-Instanzen: "&z
        End If
        Set objItem = Nothing
        Set colItems = Nothing
        Set objWMIService = Nothing
        
        If fs.FileExists(programm&"KillOP.exe") Then
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"KillOP.exe"&Chr(34),0,True)
        End If
        
        Unlock(programm&lockdatei)
        WScript.Sleep 2000
        Unlock(programm&superlockdatei)
        If scriptdebug = True Then
            objWshShell.LogEvent 1, "archivierung-debug: superlockfile gelscht.(d)"
        End If
        
        objWSHShell.Run programm&"RESTART.bat",0,False
        WScript.Quit
    End If
    
    
End If


'*************************************************************************************************
'*********************************   Verzeichnisse_anlegen    ************************************
'*************************************************************************************************
perfadd("check processes")
Verzeichnisse_anlegen
perfadd("verzeichnisse anlegen")
'*************************************************************************************************
'************************************** Lock setzen **********************************************
'*************************************************************************************************
Err.clear
If Not fs.FileExists(programm&lockdatei) Then
    Set lockfile = fs.CreateTextFile(programm&lockdatei,True)
    lockfile.Writeline("lock")
    lockfile.close
    
    Set lockfile = Nothing
    
    If Err.number<>0 Then
        objWshShell.LogEvent 1, "archivierung(1): Fehler bei lockfile erstellen - Restart."
        WScript.quit

        
    End If 
    
    If checkstartup = True Then
        objWSHShell.LogEvent 2,"Archivierung.vbs: Lock gesetzt. Inilesen " & vbCrLf & "Tstamp:" & tstamp & vbCrLf & "Jetzt:" & Timer
    End If
    
    
End If

'************************************** externe Scriptparameter **********************************
'*************************************************************************************************


perfadd("lockfile")
inilesen
perfadd("inilesen")



'*************************************************************************************************
'*************************************************************************************************
'************************************** Hauptschleife ********************************************
'*************************************************************************************************
'*************************************************************************************************

If checkstartup = True Then
    objWSHShell.LogEvent 2,"Archivierung.vbs: Starte Hauptschleife " & vbCrLf & "Tstamp:" & tstamp & vbCrLf & "Jetzt:" & Timer
End If

Set folder = fs.GetFolder(queue)

If preprocessing=True And fs.FileExists(programm&"bfa_multiocr\bfa_multiocr.exe") Then

	' Profil lesen, Omnipage-Pfad ermitteln
	readconfig(Profil) 
	If InStr(1,Omnipage,"16",1)<>0 Then
        OMPVersion=16
    End If
    If InStr(1,Omnipage,"17",1)<>0 Then
        OMPVersion=17
    End If
    If InStr(1,Omnipage,"18",1)<>0 Then
        OMPVersion=18
    End If  
    If InStr(1,Omnipage,"19",1)<>0 Then
        OMPVersion=19
    End If 
	appdatapath = objWSHShell.ExpandEnvironmentStrings("%appdata%")
    opagentjobpath = appdatapath & "\ScanSoft\Omnipage " & OMPVersion & "\"
    infolder = programm & "OCRTemp\in"
    outfolder = programm & "OCRTemp\out"
    totalpages = 0
    
    tifs = ""
    jobs = ""
    runmulti = False
	For Each file In folder.Files
		myfilename=file.name
		If (Right(myfilename,3) = "job") Then
			tempname =Replace(file.path,"." & fs.GetExtensionName(file),"")
			readjob(tempname)
			If InStr(Filtermakro,"preprocessing")<>0 Then
				If fs.FileExists(tempname &".tif") Then
					runmulti=True
					pc = Countpages(tempname &".tif")
					totalpages = totalpages + CInt(pc)
					If totalpages > 298 Then
						Exit for
					Else
						tifs = tifs & tempname &".tif;"
						jobs = jobs & tempname &".job;"
					End If
				End If
			End If
		End If
	Next
	If Not fs.FolderExists(programm&"temp\preprocessing") Then
		fs.CreateFolder(programm&"temp\preprocessing")
	Else
		ppfolder = fs.GetFolder(programm&"temp\preprocessing")
		For Each ppfile In ppfolder.files
			fs.DeleteFile ppfile,True
		Next
	End If
	If runmulti=True Then
		Set ppf = fs.CreateTextFile(programm&"temp\preprocessing.ini",True)
		ppf.WriteLine("[main]")
		ppf.WriteLine("tifs="&tifs)
		ppf.WriteLine("jobs="&jobs)
		ppf.WriteLine("opagent="&fs.getparentfoldername(omnipage)&"\OpAgent.exe")
		ppf.WriteLine("opagentjobpath="&opagentjobpath)
		ppf.WriteLine("infolder="&infolder)
		ppf.WriteLine("outfolder="&outfolder)
		ppf.WriteLine("bindir="&programm)
		ppf.WriteLine("logdir="&programm&"temp")
		ppf.WriteLine("tempdir="&programm&"temp\preprocessing")
		ppf.Close
		' run multitifocr
		Set oExec = objWSHShell.Exec(Chr(34)& programm&"bfa_multiocr\bfa_multiocr.exe" & Chr(34) & " " & Chr(34) & programm&"temp\preprocessing.ini" & Chr(34))
	    strinput = ""
	    Do While Not oExec.StdOut.AtEndOfStream
	        strinput = strinput & oExec.StdOut.Read(1)	
	    Loop
	    
	    durch = False
	    schleife = 0
	    Do While schleife < 50
	        If oExec.Status = 1 Then 
	            durch = True
	            Exit Do
	        End If
	        
	        WScript.Sleep 100  
	        schleife = schleife +1
	    Loop
		Unlock(programm&lockdatei)
		WScript.Quit
	End If
End If

For Each file In folder.files
    
    
    myfilename=file.name
    
    If Left(myfilename,2) = "~$" Then
        fs.deletefile file, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
        End If
        Unlock(programm&lockdatei)
        WScript.Quit
    End If

    
    If LCase(Right(myfilename,4)) = ".bfa" Then
        fs.deletefile file, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
        End If
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    
    If LCase(Right(myfilename,4)) = ".blf" Then
        fs.deletefile file, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
        End If
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    
    If LCase(Right(myfilename,4)) = ".var" Then
        fs.deletefile file, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
        End If
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    
    If LCase(Right(myfilename,4)) = ".bar" Then
        fs.deletefile file, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
        End If
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    
    If LCase(Right(myfilename,4)) = ".zwd" Then
        fs.deletefile file, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
        End If
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    
    If LCase(Right(myfilename,4)) = ".ocr" Then
        fs.deletefile file, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
        End If
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    
    If LCase(Right(myfilename,4)) = ".ztd" Then
        fs.deletefile file, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
        End If
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    
    If LCase(Right(myfilename,4)) = ".err" Then
        fs.deletefile file, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
        End If
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    
    If LCase(Right(myfilename,4)) = ".pid" Then
        fs.deletefile file, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
        End If
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    
    If LCase(Right(myfilename,4)) = ".xjf" Then
        fs.deletefile file, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
        End If
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    
    If LCase(Right(myfilename,4)) = ".prm" Then
        fs.deletefile file, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
        End If
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    
    If LCase(Right(myfilename,8)) = "-ocr.tif" Then
        fs.deletefile file, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
        End If
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    
    If LCase(Right(myfilename,11)) = "-archiv.tif" Then
        fs.deletefile file, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
        End If
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    
    If LCase(Right(myfilename,6)) = "_0.dat" Then
        fs.deletefile file, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
        End If
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    
    If LCase(Right(myfilename,8)) = ".tmp.txt" Then
        fs.deletefile file, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
        End If
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    
    If LCase(Right(myfilename,11)) = "barcode.tif" Then
        fs.deletefile file, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
        End If
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    
    If LCase(Right(myfilename,4)) = ".tmp" Then

        WScript.Sleep 1000
    End If
    
    If LCase(Right(myfilename,4)) = ".tmp" Then
        Err.clear
        On Error Resume Next
        If Not fs.fileexists(Left(file,Len(file)-4)&".job") Then
            fs.copyfile file, Left(file,Len(file)-4)&".job", True
            If Err.number<>0 Then
                objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Fehler beim umkopieren liegengebliebener .tmp-Datei."
                Err.clear
                On Error Resume Next
            End If
            fs.deletefile file, True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Fehler beim lschen liegengebliebener .tmp-Datei."
            End If
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
    End If
    
    
    
    If (Right(myfilename,3) = "job") And (Left(myfilename,4) = "prio") Then'~~~~~~~~~
        
        waitdirect()
        
        archivverzeichnis = ""
        ompversion=""
        ocrname=""
        makepdf=False
        extension=""
        omnipage=""
        clientspooler=""
        archivkopie=""
        dublettenpruefung =False
        dublettengarbage=False
        schattenarchiv = False
        notifyUser=False
        changeling=False
        adminmail=""
        externname=""
        Originaldatei=""
        mydocname=""
        DokID =""
        myname=""
        wfID="0"
        fromEMAIL=False
        forms=""
        dokdate=""
        oldstatus=""
        newstatus="Dokument indiziert und archiviert."
        ReDim params(10)
        params(1)=backupbearbeiter
        newstatus=getstatustext("status10", params)
        Typ=""
        Username=""
        checkstatus=True
        color=False
        hires=False
        overridecheck=False
        checkOCR=True
        Tabelle=""
        Filtermakro=""
        Archivfilter=""
        archivtif=""
        OCRFilter=""
        Profil=""
        newstatflag="0"
        orginal=""
        folderID=""
        docrotation=""
        docschangeable=False
        fromdirect=False
        quelle=""
        OCRQF=0
        zusfeldzaehler=0
        dokID=""
        linkzaehler=0
        For i = 0 To linklimit
            linkspeicher(i)=""
            linkflag(i)=0
        Next
        
        For i = 0 To limit
            
            email(i)=""
            txttofind(i)=""
            bctofind(i)=""
            andor(i)=0
            Tabelle1(i)=""
            searchstring(i)=""
            cutstringleft(i)=0
            cutstringright(i)=0
            getmidstring(i,1)=0
            getmidstring(i,2)=0
            replacestring(i,1)=0
            replacestring(i,2)=0
            searchsteps(i)=""
            nosortarchiv(i)=""
            searchdirection(i)=""
            searchflag(i)=0
            ref(i)=""
            getnextstrings(i)=0
            readpositions(i)=""
            deletespaces(i)=0
            deletedashes(i)=0
            buildlink(i)=""
            numeric(i)=False
            continue(i)=False
            alphabetic(i)=False
            interval(i)=False
            value(i)=False
            istdatum(i)=False
            autodatum(i)=False
            charlimit(i)=255
            Zusatzfeld(i)=""
            Zusatzfeldname(i)=""
            Zusatzfeldname2(i)=""
            Zwischenwert(i)=""
            Zwischenname(i)=""
            continuezusatzfeld(i)=""
            continuezusatzfeldname(i)=""
            
            
        Next
        
        For i=0 To 59
            FileInfoDescription(i)=""
            FileInfoValue(i)=""	
            Schlagworte(i)=""
        Next
        For i=0 To 30
            barcode(i)=""
        Next
        
        If checkstartup = True Then
            objWSHShell.LogEvent 2,"Archivierung.vbs: Prio.job gefunden, starte Main() " & myfilename & vbCrLf & "Tstamp:" & tstamp & vbCrLf & "Jetzt:" & Timer
        End If
        
        main()
    End If
    
    
    
    If (Right(myfilename,3) = "job") And (Left(myfilename,4) = "temp") Then'~~~~~~~~~
        
        waitdirect()
        
        archivverzeichnis = ""
        ompversion=""
        ocrname=""
        makepdf=False
        extension=""
        omnipage=""
        clientspooler=""
        archivkopie=""
        dublettenpruefung =False
        dublettengarbage=False
        schattenarchiv = False
        notifyUser=False
        changeling=False
        adminmail=""
        externname=""
        Originaldatei=""
        mydocname=""
        DokID =""
        myname=""
        wfID="0"
        fromEMAIL=False
        forms=""
        dokdate=""
        oldstatus=""
        newstatus="Dokument indiziert und archiviert."
        ReDim params(10)
        newstatus=getstatustext("status01",params)
        Typ=""
        Username=""
        checkstatus=True
        color=False
        hires=False
        overridecheck=False
        checkOCR=True
        Tabelle=""
        Filtermakro=""
        Archivfilter=""
        archivtif=""
        OCRFilter=""
        Profil=""
        orginal=""
        folderID=""
        docrotation=""
        docschangeable=False
        fromdirect=False
        quelle=""
        OCRQF=0
        zusfeldzaehler=0
        For i = 0 To limit
            Zusatzfeld(i)=""
            Zusatzfeldname(i)=""
            Zusatzfeldname2(i)=""
            
        Next
        dokID=""
        linkzaehler=0
        
        For i = 0 To linklimit
            linkspeicher(i)=""
            linkflag(i)=0
        Next
        For i = 0 To limit
            
            email(i)=""
            txttofind(i)=""
            bctofind(i)=""
            andor(i)=0
            Tabelle1(i)=""
            searchstring(i)=""
            cutstringleft(i)=0
            cutstringright(i)=0
            getmidstring(i,1)=0
            getmidstring(i,2)=0
            replacestring(i,1)=0
            replacestring(i,2)=0
            searchsteps(i)=""
            nosortarchiv(i)=""
            searchdirection(i)=""
            searchflag(i)=0
            ref(i)=""
            getnextstrings(i)=0
            readpositions(i)=""
            deletespaces(i)=0
            deletedashes(i)=0
            buildlink(i)=""
            numeric(i)=False
            continue(i)=False
            alphabetic(i)=False
            interval(i)=False
            value(i)=False
            istdatum(i)=False
            autodatum(i)=False
            charlimit(i)=255
            Zusatzfeld(i)=""
            Zusatzfeldname(i)=""
            Zusatzfeldname2(i)=""
            Zwischenwert(i)=""
            Zwischenname(i)=""
            continuezusatzfeld(i)=""
            continuezusatzfeldname(i)=""
            
            
        Next
        
        For i=0 To 59
            FileInfoDescription(i)=""
            FileInfoValue(i)=""	
            Schlagworte(i)=""
        Next
        
        If checkstartup = True Then
            objWSHShell.LogEvent 2,"Archivierung.vbs: Temp.job gefunden, starte Main() " & myfilename & vbCrLf & "Tstamp:" & tstamp & vbCrLf & "Jetzt:" & Timer
        End If
        If Left(myfilename,11) = "temp-direct" Then
        	isdirect = True
        End If
        perfadd("mainloop before main")
        main()
    End If
    
    
    
    
Next
perfadd("mainloop ende")
WScript.Sleep 50
Set folder = Nothing
WScript.Sleep 200
'************************************ Ende Primrverarbeitung ***********************************

If checkstartup = True Then
    objWSHShell.LogEvent 2,"Archivierung.vbs: Ende Primrverarbeitung "  & vbCrLf & "Tstamp:" & tstamp & vbCrLf & "Jetzt:" & Timer
End If


newentries=0
Set folder = fs.GetFolder(queue)
For Each file In folder.files
    If (Right(file,3) = "job") And (Left(file.name,4) = "temp") Then
        newentries=newentries+1
    End If
Next
WScript.Sleep 50
Set folder =Nothing
WScript.Sleep 50

If checkstartup = True Then
    objWSHShell.LogEvent 2,"Archivierung.vbs: newentries=" & newentries & vbCrLf & "Tstamp:" & tstamp & vbCrLf & "Jetzt:" & Timer
End If


If newentries > 0 Then
    Unlock(programm&lockdatei)
    WScript.Quit
End If

Set folder = fs.GetFolder(queue)
maxchanges = 100
counter = 0
For Each file In folder.files
    If (Right(file,3) = "cng") And (Left(file.name,6) = "change") Then
        counter = counter +1
        If checkstartup = True Then
            objWSHShell.LogEvent 2,"Archivierung.vbs: change.cng gefunden, starte rejob() " & file.name & vbCrLf & "Tstamp:" & tstamp & vbCrLf & "Jetzt:" & Timer
        End If
        
        waitdirect()
        rejob(file)
        If counter >= maxchanges Then
            If scriptdebug=True Then
                objWSHShell.LogEvent 0,"Archivierung.vbs " & counter & " .cng-Dateien verarbeitet, neue Archivierung.vbs wird gestartet"
            End If
            Exit For
        End If
    End If
Next
WScript.Sleep 50
Set folder = Nothing
WScript.Sleep 100

'************************************ lock lschen ***********************************
Unlock(programm&lockdatei)



'***************************  Hauptexitpunkt  **********************************
If checkstartup = True Then
    objWSHShell.LogEvent 2,"Archivierung.vbs: Hauptexitpunkt " & vbCrLf & "Tstamp:" & tstamp & vbCrLf & "Jetzt:" & Timer
End If
perfadd("mainexit")
If archservicerunning=True Then
    lngReturnCode = objWSHShell.Run(programm&"archivierung.bat",0,False)
End If
WScript.Quit


'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************  E N D E **************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************






Function Verzeichnisse_anlegen
    erfolg = True
    
    erfolg = erfolg And create_Dir(programm&"direct")
    erfolg = erfolg And create_Dir(workflows)
    erfolg = erfolg And create_Dir(forms)
    erfolg = erfolg And create_Dir(programm&"plugins")
    erfolg = erfolg And create_Dir(masks)
    erfolg = erfolg And create_Dir(programm&"templates")
    erfolg = erfolg And create_Dir(temp)
    erfolg = erfolg And create_Dir(programm&"filter")
    erfolg = erfolg And create_Dir(garbagepath)
    erfolg = erfolg And create_Dir(dublettenpath)
    erfolg = erfolg And create_Dir(programm&"queue")
    erfolg = erfolg And create_Dir(programm&"OCRTemp")
    erfolg = erfolg And create_Dir(programm&"OCRTemp\in")
    erfolg = erfolg And create_Dir(programm&"OCRTemp\out")
    
    If Not erfolg Then
        objWshShell.LogEvent 1, "archivierung(1): Konnte ein Hauptverzeichnis nicht anlegen" & vbCrLf & "Das Dokument wurde in den Garbage verschoben"
        WScript.Quit		
        
    End If 
    
    
End Function    'Verzeichnisse_anlegen


Function create_dir(foldername)
    create_dir= True
    
    If Not fs.FolderExists(foldername) Then
        Set tes1 = fs.CreateFolder(foldername)
        Set tes1 = Nothing
        WScript.sleep 200
        If Err.number<>0 Then
            objWshShell.LogEvent 1, "archivierung(0): kann das Verzeichnis" & vbCrLf & foldername& "nicht erstellen!" & vbCrLf & Err.Number & vbTab & Err.Description
            Err.clear
            WScript.Quit
        End If 
        
        If Not fs.FolderExists(foldername) Then
            objWshShell.LogEvent 1, "archivierung(0b): kann das Verzeichnis" & vbCrLf & foldername& "nicht erstellen!" & vbCrLf & Err.Number & vbTab & Err.Description
            create_dir = False
            'WScript.Quit
        End If
    End If
    
    
End Function



















'*******************************************************************************************
'*******************************************************************************************
'********************************     Directpath   *****************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************


Function directpath()
    On Error Resume Next
    
    newstatus="Dokument wartet noch auf Indizierung..."
    ReDim params(10)
    newstatus=getstatustext("status02", params)
    
    
    
    '*************************************************************************************************
    '************************************** Lock setzen **********************************************
    '*************************************************************************************************
    Err.clear
    lockdatei="temp\directlock"
    If Not fs.FileExists(programm&lockdatei) Then 
        On Error Resume Next
        Err.clear
        Set lockfile = fs.CreateTextFile(programm&lockdatei,True)
        If Err.number<>0 Then
            WScript.Quit
        End If
        
        lockfile.Writeline("lock")
        lockfile.close
        
        Set lockfile = Nothing
        
        If Err.number<>0 Then
            objWshShell.LogEvent 1, "archivierung(1): Fehler bei lockfile erstellen"
            On Error Resume Next
            Err.clear
            Unlock(programm&lockdatei)
            WScript.Quit
        End If 
    Else
        WScript.Quit
    End If
    
    '************************************** externe Scriptparameter **********************************
    '*************************************************************************************************
    
    
    inilesen
    
    
    
    
    '*************************************************************************************************
    '*************************************************************************************************
    '************************************** Dateien  verarbeiten *************************************
    '*************************************************************************************************
    '*************************************************************************************************
    
    queue=programm&"direct\"
    
    Set folder = fs.GetFolder(queue)
    For Each file In folder.files
        
        If (Right(file,3) = "job") And (Left(file.name,6) = "direct") Then'~~~~~~~~~
            
            If logging = True Then
                objWshShell.LogEvent 0,"bitfarm-Archiv Logging: Directpath " &vbCrLf& "Verarbeite Datei " & file.name
            End If
            
            archivverzeichnis = ""
            makepdf=False
            extension=""
            omnipage=""
            clientspooler=""
            'workflows=""
            archivkopie=""
            dublettenpruefung =False
            dublettengarbage=False
            schattenarchiv = False
            overridecheck=False
            notifyUser=False
            color=False
            hires=False
            adminmail=""
            Originaldatei=""
            externname=""
            mydocname=""
            fromEMAIL=False
            myname=""
            newstatflag="1"
            
            forms=""
            dokdate=""
            oldstatus=""
            dokid=""
            Typ=""
            Username=""
            Tabelle=""
            Filtermakro=""
            Archivfilter=""
            checkOCR=True
            archivtif=""
            OCRFilter=""
            Profil=""
            folderID=""
            docrotation=""
            wfID="0"
            docschangeable=False
            fromdirect=False
            quelle=""
            OCRQF=0
            zusfeldzaehler=0
            For i = 0 To limit
                Zusatzfeld(i)=""
                Zusatzfeldname(i)=""
                Zusatzfeldname2(i)=""
                continuezusatzfeld(i)=""
                continuezusatzfeldname(i)=""
            Next
            dokID=""
            linkzaehler=0
            For i = 0 To linklimit
                linkspeicher(i)=""
            Next
            
            For i=0 To 59
                FileInfoDescription(i)=""
                FileInfoValue(i)=""
                Schlagworte(i)=""	
            Next	
            
            
            
            '*************************************************************************************************
            '*************************************************************************************************
            '************************************** Hauptroutine *********************************************
            '*************************************************************************************************
            '*************************************************************************************************
            Err.clear
            tempname =Replace(file.path,"." & fs.GetExtensionName(file),"")
            If Err.number<>0 Then
                On Error Resume Next	
                Err.clear
                errortxt="Fehler bei Namensgebung tempname (Stringfehler) -> Garbage."
                objWshShell.LogEvent 2, errortxt
                Unlock(programm&lockdatei)
                WScript.Quit
            End If 
            archivtif=tempname
            
            '*************************************************************************************************
            '************************************** Jobdaten aus Warteschlange lesen *************************
            '*************************************************************************************************
            
            
            erfolgreich = readjob(tempname)
            If erfolgreich <> True Then
                WScript.sleep 1000
                erfolgreich = readjob(tempname)
            End If
            If erfolgreich <> True Then
                errortxt="Fehler bei einlesen der Jobdatei -> Garbage."
                objWSHShell.LogEvent 1, errortxt
                GetGarbage(tempname)
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
            If Profil="" Then
                errortxt="Fehler: kein Profil erkannt -> Garbage."
                objWSHShell.LogEvent 2, errortxt
                GetGarbage(tempname)
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
            
            If fs.fileexists(programm&profil&"-"&Tabelle&".wfd") Then
            	workflowfile = programm&profil&"-"&Tabelle&".wfd"
            Else
            	workflowfile = programm&profil&".wfd"
            End If
            
            
            '*************************************************************************************************
            '************************************** Konfiguration einlesen ***********************************
            '*************************************************************************************************
            
            erfolgreich = readconfig(Profil)
            If erfolgreich <> True Then
                errortxt="Fehler bei einlesen der Configdatei -> Garbage."
                objWSHShell.LogEvent 2, errortxt
                GetGarbage(tempname)
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
            
            
            If Not fs.FolderExists(programm & Profil & "-workflows") Then
                erfolg = create_dir(programm & Profil & "-workflows")
                If Not erfolg Then
                    objWSHShell.LogEvent 1," Archivierung.vbs: Konnte " & programm & Profil & "-workflows nicht anlegen. Quit"
                    WScript.Quit
                    
                End If 
            End If 
            
            
            If Not fs.FolderExists(templates) Then
                erfolg = create_dir(templates)
                If Not erfolg Then
                    objWSHShell.LogEvent 1," Archivierung.vbs: Konnte " & templates &" nicht anlegen. Quit"
                    WScript.Quit
                    
                End If 
            End If 
            
            If Not fs.FolderExists(workflows) Then
                erfolg = create_dir(workflows)
                If Not erfolg Then
                    objWSHShell.LogEvent 1," Archivierung.vbs: Konnte " & workflows &" nicht anlegen. Quit"
                    WScript.Quit
                    
                End If 
            End If 
            
            If Tabelle = "noarch" Then
                extraskip = True
            End If
            
            
            
            swdateiname=tempname&".swd"
            
            Err.clear
            If fs.fileexists(swdateiname) Then
                fs.deletefile swdateiname, True
                If Err.number<>0 Then
                    On Error Resume Next	
                    Err.clear
                    errortxt="archivierung(3a): kann alte Schlagwortdatei nicht lschen."
                    objWshShell.LogEvent 1, errortxt
                    GetGarbage(tempname)
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If 
            End If
            
            
            
            If (Typ <> "TXT") And (Typ <> "OCR") And (Typ <> "OMP") And (Typ <> "OCS") And (Typ <> "MAN") Then
                errortxt="archivierung(5): Parameter in Jobdatei fehlt: OCR_Typ=xxx"&Typ
                objWshShell.LogEvent 1, errortxt
                GetGarbage(Tempname)   
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
            
            
            '**********************************************************************************
            '********************       Typenidentifizierung        ***************************
            '**********************************************************************************
            
            handle=""
            OCRHandle=""
            
            If fs.FileExists(tempname&".tif") Then
                extension=".tif"
                
            ElseIf fs.FileExists(tempname&".") Then
                extension="."
                handle="ASCII"
                fs.copyfile	tempname&".", tempname&".asc", True
                fs.deletefile tempname&".", True
                Unlock(programm&lockdatei)
                WScript.Quit
                
            ElseIf fs.FileExists(tempname&".pdf") Then
                extension=".pdf"
                handle="pdf"	
                
            ElseIf fs.FileExists(tempname&".ps") Then
                extension=".ps"
                
            ElseIf fs.FileExists(tempname&".pcl") Then
                extension=".pcl"
            
            ElseIf fs.FileExists(tempname&".jpeg") Then
                jpgname = tempname & ".jpg"
            	fs.movefile tempname&".jpeg" , jpgname   
            	extension=".jpg"
                OCRHandle=".jpg"
                handle="jpg"
                docschangeable=False 
            ElseIf fs.FileExists(tempname&".jpg") Then
                extension=".jpg"
                OCRHandle=".jpg"
                handle="jpg"
                docschangeable=False
                'Typ="TXT"
                
            ElseIf fs.FileExists(tempname&".gif") Then
                extension=".gif"
                OCRHandle=".gif"
                handle="gif"
                'Typ="TXT"
                
            ElseIf fs.FileExists(tempname&".bmp") Then
                extension=".bmp"
                OCRHandle=".bmp"
                handle="bmp"
                Typ="TXT"
                
            ElseIf fs.FileExists(tempname&".png") Then
                extension=".png"
                OCRHandle=".png"
                handle="png"
                Typ="TXT"
                
            ElseIf fs.FileExists(tempname&".txt") Then
                extension=".txt"
                handle="Word"	
                Typ="TXT"
                
            ElseIf fs.FileExists(tempname&".odt") Then
                extension=".odt"
                handle="ODT"
                
            ElseIf fs.FileExists(tempname&".wps") Then
                extension=".wps"
                handle="ODT"    
                
            ElseIf fs.FileExists(tempname&".ods") Then
                extension=".ods"
                handle="ODT"	
                
            ElseIf fs.FileExists(tempname&".odg") Then
                extension=".odg"
                handle="ODT"	
                
            ElseIf fs.FileExists(tempname&".odp") Then
                extension=".odp"
                handle="ODT"	
                
            ElseIf fs.FileExists(tempname&".odf") Then
                extension=".odf"
                handle="ODT"	
                
            ElseIf fs.FileExists(tempname&".ott") Then
                extension=".ott"
                handle="ODT"	
                
            ElseIf fs.FileExists(tempname&".otp") Then
                extension=".otp"
                handle="ODT"	
                
            ElseIf fs.FileExists(tempname&".ots") Then
                extension=".ots"
                handle="ODT"
                
            ElseIf fs.FileExists(tempname&".otg") Then
                extension=".otg"
                handle="ODT"	
                
                ' alte OpenOffice-Formate	
            ElseIf fs.FileExists(tempname&".sdw") Then
                extension=".sdw"
                handle="ODT"
                
            ElseIf fs.FileExists(tempname&".sxw") Then
                extension=".sxw"
                handle="ODT"	
                
            ElseIf fs.FileExists(tempname&".stw") Then
                extension=".stw"
                handle="ODT"	
                
            ElseIf fs.FileExists(tempname&".sdc") Then
                extension=".sdc"
                handle="ODT"	
                
            ElseIf fs.FileExists(tempname&".stc") Then
                extension=".stc"
                handle="ODT"	
                
            ElseIf fs.FileExists(tempname&".sxc") Then
                extension=".sxc"
                handle="ODT"	
                
            ElseIf fs.FileExists(tempname&".sdd") Then
                extension=".sdd"
                handle="ODT"	
                
            ElseIf fs.FileExists(tempname&".sti") Then
                extension=".sti"
                handle="ODT"	
                
            ElseIf fs.FileExists(tempname&".sxi") Then
                extension=".sxi"
                handle="ODT"	
                
            ElseIf fs.FileExists(tempname&".sxd") Then
                extension=".sxd"
                handle="ODT"	
                
            ElseIf fs.FileExists(tempname&".std") Then
                extension=".std"
                handle="ODT"	
                
            ElseIf fs.FileExists(tempname&".sda") Then
                extension=".sda"
                handle="ODT"	
                
            ElseIf fs.FileExists(tempname&".sxm") Then
                extension=".sxm"
                handle="ODT"	
                
            ElseIf fs.FileExists(tempname&".smf") Then
                extension=".smf"
                handle="ODT"	
                
            ElseIf fs.FileExists(tempname&".vor") Then
                extension=".vor"
                handle="ODT"	
                
                
                
            ElseIf fs.FileExists(tempname&".zip") Then
                If InStr(1,tempname,"tempzip")<> 0 Or InStr(1,tempname,"temp-zip")<> 0 Or zippath="" Then
                    extension=".zip"
                    handle="unbekannt"	
                    OCRHandle=".tif"
                Else
                    
                    extension=".zip"
                    handle="ZIP"	
                End If
                
            ElseIf fs.FileExists(tempname&".rar") Then
                If InStr(1,tempname,"tempzip")<> 0 Or InStr(1,tempname,"temp-zip")<> 0 Or zippath="" Then
                    extension=".rar"
                    handle="unbekannt"	
                    OCRHandle=".tif"
                Else
                    
                    extension=".rar"
                    handle="ZIP"	
                End If	
                
                
            ElseIf fs.FileExists(tempname&".csv") Then
                If MSExcelinstalled = False Then
                    If openofficepath<>"" Then
                        extension=".csv"
                        handle="ODT"
                    Else
                        extension=".csv"
                        handle="unbekannt"	
                        OCRHandle=".tif"	
                    End If
                Else
                    extension=".csv"
                    handle="Excel"
                End If
                
                
            ElseIf fs.FileExists(tempname&".xls") Then
                If MSExcelinstalled = False Then
                    If openofficepath<>"" Then
                        extension=".xls"
                        handle="ODT"
                    Else
                        extension=".xls"
                        handle="unbekannt"	
                        OCRHandle=".tif"	
                    End If
                Else
                    extension=".xls"
                    handle="Excel"
                End If
            ElseIf fs.FileExists(tempname&".xlt") Then
                If MSExcelinstalled = False Then
                    If openofficepath<>"" Then
                        extension=".xlt"
                        handle="ODT"
                    Else
                        extension=".xlt"
                        handle="unbekannt"	
                        OCRHandle=".tif"	
                    End If
                Else
                    extension=".xlt"
                    handle="Excel"
                End If
            ElseIf fs.FileExists(tempname&".xlsx") Then
                If MSOffice2007installed = True And hostversion<>"w2k" And MSExcelinstalled = True Then
                    extension=".xlsx"
                    handle="Excel"
                Else
                    If openofficepath<>"" Then
                        extension=".xlsx"
                        handle="ODT"
                        'Typ="TXT"
                        OCRHandle=".tif"
                        
                    Else	
                        extension=".xlsx"
                        handle="unbekannt"
                        Typ="TXT"
                        OCRHandle=".tif"
                    End If
                End If	
            ElseIf fs.FileExists(tempname&".xlsm") Then
                If MSOffice2007installed = True And hostversion<>"w2k"  And MSExcelinstalled = True Then
                    extension=".xlsm"
                    handle="Excel"
                Else
                    If openofficepath<>"" Then
                        extension=".xlsm"
                        handle="ODT"
                        'Typ="TXT"
                        OCRHandle=".tif"
                    Else	
                        
                        extension=".xlsm"
                        handle="unbekannt"
                        Typ="TXT"
                        OCRHandle=".tif"
                    End If
                End If		
            ElseIf fs.FileExists(tempname&".xltx") Then
                If MSOffice2007installed = True And hostversion<>"w2k"  And MSExcelinstalled = True Then
                    extension=".xltx"
                    handle="Excel"
                Else
                    If openofficepath<>"" Then
                        extension=".xltx"
                        handle="ODT"
                        'Typ="TXT"
                        OCRHandle=".tif"
                    Else	
                        
                        extension=".xltx"
                        handle="unbekannt"
                        Typ="TXT"
                        OCRHandle=".tif"
                    End If
                End If	
            ElseIf fs.FileExists(tempname&".xltm") Then
                If MSOffice2007installed = True And hostversion<>"w2k"  And MSExcelinstalled = True Then
                    extension=".xltm"
                    handle="Excel"
                Else
                    If openofficepath<>"" Then
                        extension=".xltm"
                        handle="ODT"
                        'Typ="TXT"
                        OCRHandle=".tif"
                    Else	
                        
                        extension=".xltm"
                        handle="unbekannt"
                        Typ="TXT"
                        OCRHandle=".tif"
                    End If
                End If		
                
            ElseIf fs.FileExists(tempname&".dbf") Then
                If MSExcelinstalled = False Then
                    If openofficepath<>"" Then
                        extension=".dbf"
                        handle="ODT"
                    Else
                        extension=".dbf"
                        handle="unbekannt"	
                        OCRHandle=".tif"	
                    End If
                Else
                    extension=".dbf"
                    handle="Excel"				
                End If
                
            ElseIf fs.FileExists(tempname&".vcf") Then
                If MSWordinstalled = False Then
                    If openofficepath<>"" Then
                        extension=".vcf"
                        handle="ODT"
                    Else
                        extension=".vcf"
                        handle="unbekannt"	
                        OCRHandle=".tif"	
                    End If
                Else
                    extension=".vcf"
                    handle="Word"
                End If
                Typ="TXT"	
                If fs.fileexists(tempname&".txt") Then
                    fs.deletefile tempname&".txt", True
                End If
                fs.copyfile tempname&".vcf", tempname&".txt", True
                
            ElseIf fs.FileExists(tempname&".doc") Then
                If MSWordinstalled = False Then
                    If openofficepath<>"" Then
                        extension=".doc"
                        handle="ODT"
                    Else
                        extension=".doc"
                        handle="unbekannt"	
                        OCRHandle=".tif"	
                    End If
                Else
                    extension=".doc"
                    handle="Word"
                End If
                
            ElseIf fs.FileExists(tempname&".dot") Then
                If MSWordinstalled = False Then
                    If openofficepath<>"" Then
                        extension=".dot"
                        handle="ODT"
                    Else
                        extension=".dot"
                        handle="unbekannt"	
                        OCRHandle=".tif"	
                    End If
                Else
                    extension=".dot"
                    handle="Word"
                End If
                
            ElseIf fs.FileExists(tempname&".docx") Then
                If MSOffice2007installed = True Then
                    
                    extension=".docx"
                    handle="Word"
                Else
                    If openofficepath<>"" Then
                        extension=".docx"
                        handle="ODT"
                        'Typ="TXT"
                        OCRHandle=".tif"
                    Else	
                        
                        extension=".docx"
                        handle="unbekannt"
                        Typ="TXT"
                        OCRHandle=".tif"
                    End If
                End If
            ElseIf fs.FileExists(tempname&".vsd") Then
		        extension=".vsd"
			    handle="ODT"
			    OCRHandle=".tif"
			ElseIf fs.FileExists(tempname&".vst") Then
		        extension=".vst"
			    handle="ODT"
			    OCRHandle=".tif"
			ElseIf fs.FileExists(tempname&".vss") Then
		        extension=".vss"
			    handle="ODT"
			    OCRHandle=".tif"
			ElseIf fs.FileExists(tempname&".vsdx") Then
		        extension=".vsdx"
			    handle="ODT"
			    OCRHandle=".tif"
			ElseIf fs.FileExists(tempname&".vssx") Then
		        extension=".vssx"
			    handle="ODT"
			    OCRHandle=".tif"
			ElseIf fs.FileExists(tempname&".vstx") Then
		        extension=".vstx"
			    handle="ODT"
			    OCRHandle=".tif"
            ElseIf fs.FileExists(tempname&".docm") Then
                If MSOffice2007installed = True Then
                    extension=".docm"
                    handle="Word"
                Else
                    If openofficepath<>"" Then
                        extension=".docm"
                        handle="ODT"
                        'Typ="TXT"
                        OCRHandle=".tif"
                    Else	
                        extension=".docm"
                        handle="unbekannt"
                        Typ="TXT"
                        OCRHandle=".tif"
                    End If
                End If	
                
            ElseIf fs.FileExists(tempname&".dotx") Then
                If MSOffice2007installed = True And hostversion<>"w2k" Then
                    extension=".dotx"
                    handle="Word"
                Else
                    If openofficepath<>"" Then
                        extension=".dotx"
                        handle="ODT"
                        'Typ="TXT"
                        OCRHandle=".tif"
                    Else	
                        extension=".dotx"
                        handle="unbekannt"
                        Typ="TXT"
                        OCRHandle=".tif"
                    End If
                End If
            ElseIf fs.FileExists(tempname&".dotm") And hostversion<>"w2k" Then
                If MSOffice2007installed = True Then
                    extension=".dotm"
                    handle="Word"
                Else
                    If openofficepath<>"" Then
                        extension=".dotm"
                        handle="ODT"
                        'Typ="TXT"
                        OCRHandle=".tif"
                    Else	
                        extension=".dotm"
                        handle="unbekannt"
                        Typ="TXT"
                        OCRHandle=".tif"
                    End If
                End If				
                
            ElseIf fs.FileExists(tempname&".rtf") Then
                extension=".rtf"
                handle="Word"
            ElseIf fs.FileExists(tempname&".html") Then
                If Not fs.fileexists(tempname&".htm") Then
                    fs.copyfile tempname&".html", tempname&".htm", True
                End If
                WScript.sleep 50
                
            ElseIf fs.FileExists(tempname&".htm") Then
                extension=".htm"
                handle="Word"
            ElseIf fs.FileExists(tempname&".ppt") Then
                extension=".ppt"
                handle="Powerpoint"
            ElseIf fs.FileExists(tempname&".asc") Then
                extension=".asc"
                handle="ASCII"	
            ElseIf fs.FileExists(tempname&".pps") Then
                extension=".pps"
                handle="Powerpoint"
            ElseIf fs.FileExists(tempname&".pptx") Then
                If MSOffice2007installed = True And hostversion<>"w2k" Then
                    
                    extension=".pptx"
                    handle="Powerpoint"
                Else
                    extension=".pptx"
                    handle="ODT"
                    Typ="TXT"
                    OCRHandle=".tif"
                End If
                
            ElseIf fs.FileExists(tempname&".ppsx") Then
                If MSOffice2007installed = True And hostversion<>"w2k" Then
                    
                    extension=".ppsx"
                    handle="Powerpoint"
                Else
                    extension=".ppsx"
                    handle="unbekannt"
                    Typ="TXT"
                    OCRHandle=".tif"
                End If
                
            ElseIf fs.FileExists(tempname&".txt") Then	
                If MSWordinstalled = False Then
                    If openofficepath<>"" Then
                        extension=".txt"
                        handle="ODT"
                    Else
                        extension=".txt"
                        handle="unbekannt"	
                        OCRHandle=".tif"	
                    End If
                    
                Else
                    extension=".txt"
                    handle="Word"	
                    Typ="TXT"
                End If
            ElseIf fs.FileExists(tempname&".ini") Then	
                If MSWordinstalled = False Then
                    If openofficepath<>"" Then
                        extension=".ini"
                        handle="ODT"
                    Else
                        extension=".ini"
                        handle="unbekannt"	
                        OCRHandle=".tif"	
                    End If
                    
                Else
                    extension=".ini"
                    handle="Word"	
                    Typ="TXT"
                End If
                
            ElseIf fs.FileExists(tempname&".dwg") Then
                extension=".dwg"
                handle="AutoCAD"
            ElseIf fs.FileExists(tempname&".dxf") Then
                extension=".dxf"
                handle="AutoCAD"
            ElseIf fs.FileExists(tempname&".dwf") Then
                extension=".dwf"
                handle="AutoCAD"
            ElseIf fs.FileExists(tempname&".xml") Then
                extension=".xml"
                handle="XML"
                If xmltotext = True Then
                	If Not fs.FileExists(tempname&".ftx") Then
                		fs.CopyFile tempname&".xml", tempname&".ftx"
                		Typ="TXT"
                		handle="ODT"
                	End If
                Else
                	OCRHandle=".tif"	
                End If
            ElseIf acceptallfiletypes=True Then
                
                
                For Each file1 In folder.files
                    
                    If InStr(1,file1,tempname&".",1)<>0 Then
                        
                        w=0
                        abbruch=False
                        Do While abbruch=False
                            If w>5 Then
                                abbruch=True
                            End If
                            If (abbruch=False) And (Mid(file1,(Len(file1)-w),1)=".") Then
                                extension1=LCase(Right(file1,w+1))
                                abbruch=True
                            End If
                            If abbruch=False Then
                                w=w+1
                            End If
                        Loop
                        
                        If (extension1=".job") Or (extension1=".ftx") Or (extension1=".vtx") Or (extension1=".slw") Or (extension1=".ocr") Or (extension1=".swd") Then
                            extension1=""
                        End If
                        If extension1<>"" Then
                            extension=extension1
                        End If
                    End If
                Next
                
                If extension<>"" Then
                    handle="unbekannt"
                    Typ="TXT"
                    OCRHandle=".tif"
                End If
            End If
            
            If extension="." Then
                handle="unbekannt"
                Typ="TXT"
                OCRHandle=".tif"
            End If	
            
            
            
            
            
            '####################   BigEndian-Konvertierung fr Tif  ###############################
            
            
            convertbigendian(tempname)
            
            '#######################################################################################
            
            
            
            
            
            If extension="" Then
                errortxt="archivierung(5B): Kein Dokument zur Jobdatei vorhanden." 
                objWshShell.LogEvent 1, errortxt
                GetGarbage(Tempname)   
                Unlock(programm&lockdatei)
                WScript.Quit				
            End If
            
            If allownonrevisionsave=True Then
                If (handle="Word") Or (handle="Excel") Or (handle="AutoCAD") Or (handle="PowerPoint") Or (handle="unbekannt") Or (handle="ODT") Or (handle="AKT") Or (handle="IView") Then
                    docschangeable=True
                    If scriptdebug=True Then
                        objWshShell.LogEvent 1, "Archivierung-Debug: docschangeable4:"&docschangeable
                    End If
                End If
                If ((extension=".slddrw") And (solidworksnrs=True)) Or ((extension=".sldasm") And (solidworksnrs=True)) Or ((extension=".sldprt") And (solidworksnrs=True)) Or ((extension=".jpg") And (JPGNRS=True)) Or ((extension=".xml") And (XMLNRS=True)) Or ((extension=".pdf") And (PDFNRS=True)) Or ((extension=".ppt") And (PPTNRS=True)) Or ((extension=".pptx") And (PPTNRS=True)) Or ((extension=".png") And (PNGNRS=True)) Or ((extension=".bmp") And (BMPNRS=True)) Or ((extension=".gif") And (GIFNRS=True)) Then
                    docschangeable=True
                End If
                If ((extension=".") And (NOEXTNRS=True)) Then
                    docschangeable=True
                ElseIf ((extension=".") And (NOEXTNRS=False)) Then
                    docschangeable=False
                End If
            End If
            
            
            
            
            If fromEMAIL=True Then
                docschangeable=False
                If mailattachments="changeable" Then
                    If ((extension=".slddrw") And (solidworksnrs=True)) Or ((extension=".sldasm") And (solidworksnrs=True)) Or ((extension=".sldprt") And (solidworksnrs=True)) Or ((extension=".jpg") And (JPGNRS=True)) Or ((extension=".xml") And (XMLNRS=True))  Or ((extension=".pdf") And (PDFNRS=True)) Or ((extension=".ppt") And (PPTNRS=True)) Or ((extension=".pptx") And (PPTNRS=True)) Or ((extension=".png") And (PNGNRS=True)) Or ((extension=".bmp") And (BMPNRS=True)) Or ((extension=".gif") And (GIFNRS=True)) Or (handle="Word") Or (handle="Excel") Or (handle="AutoCAD") Or (handle="PowerPoint") Or (handle="unbekannt") Or (handle="ODT") Or (handle="AKT") Or (handle="IView") Then
                        docschangeable=True
                    End If
                    If ((extension=".") And (NOEXTNRS=True)) Then
                        docschangeable=True
                    ElseIf ((extension=".") And (NOEXTNRS=False)) Then
                        docschangeable=False
                    End If                    
                End If
                '############ Ausfiltern unerwnschter Attachments ##################
                filtermailattachments(tempname)
                
            End If
            
            
            
            
            
            If ((handle="Word") Or (handle="Excel")) And (archofficecolor=True) Then
                color=True
            End If
            
            If (handle="ODT") And (archofficecolor=True) Then
                color=True
            End If
            
            If (extension=".htm") And (archHTMLincolor=True) Then
                color=True
            End If
            
            If (handle="AutoCAD") And (archDWGcolor=True) Then
                color=True
            End If
            
            If (handle="pdf") And ((archpdfincolor=True) Or (archpdfincolor="grey")) Then
                color=True
            End If
            
            
            
            '*********************************** Frhe Dublettenprfung ***********************
            
            If (tabelle <> "workflow") And (dublettenpruefung = True) And (handle <> "")  And (fromdirect=False) And (changeling=False) Then 
                dublettengarbage=True
                If istschonarchiviert(tempname) = True Then
                    dublettengarbage=True
                    errortxt="Dublette erkannt ("&tempname&")"
                    getDublette(tempname)
                    Unlock(programm&lockdatei)
                    WScript.Quit
                Else
                    dublettengarbage=False
                End If
            End If 
            

            
            '**********************************************************************************
            '********************      Auslesen der Dateiinfos        *************************
            '**********************************************************************************
            
            
            getInfo(tempname&extension)

            
            getoriginalname(tempname)

            '**********************************************************************************
            '********************       Typenverarbeitung        ******************************
            '**********************************************************************************
            
            
            
            '******************************************
            '***** custom dpi-Einstellungen ***********
            '******************************************
            If extension<>"" Then
                Err.clear
                laenge=Len(extension)-1
                If laenge>0 Then
                    myext=Right(extension,laenge)
                    gefunden=False
                    i=0
                    Do While gefunden=False
                        If changeresolution(i)<>"" Then
                            If Len(changeresolution(i))>laenge Then
                                If Left(changeresolution(i),laenge)=myext Then
                                    gefunden=True
                                    dpi=Trim(Right(changeresolution(i),Len(changeresolution(i))-InStr(1,changeresolution(i),",",1)))
                                    If Err.number<>0 Then
                                        Err.clear
                                        On Error Resume Next
                                        objWSHShell.LogEvent 1, "bitfarm-Archiv: Archivierung (187): Unbekannter Fehler changeresolution. Bitte prfen Sie die scripts.ini auf korrekte Anwendung des changeresolution-Statements."
                                        gefunden=False
                                    End If
                                    
                                End If
                            End If
                        End If
                        If gefunden=False Then
                            i=i+1
                        End If
                        If i>99 Then
                            gefunden=True
                            
                        End If
                    Loop
                    
                    If dpi<>"" Then
                        create_custom_rsps(dpi)
                    End If
                End If			
            End If
            
            '******************************************
            '******************************************
            
            
            
            If (Defaultresolution="hires") And (dpi="") Then
                hires=True
            End If
            
            '******************************************
            '******************************************
            
            
            
            '*********************************  PDF-Datein  ***************************
            If extraskip = False Then
                If handle="pdf" Then

                    If color=False Then		
                        PDFtoTIF(tempname)
                    Else
                        PDFtoColorTIF(tempname)
                    End If
                End If
            End If
            
            '*********************************  DOC-Datein  ***************************
            If extraskip = False Then
                If handle="Word" Then
                    
                    
                    DOCtoPS(tempname)
                    
                End If
            End If
            
            '*********************************  XLS-Datein  ***************************
            If extraskip = False Then
                If handle="Excel" Then
                    
                    XLStoPS(tempname)
                    
                End If
            End If
            
            '*********************************  PP-Datein  ***************************
            If extraskip = False Then
                If handle="Powerpoint" Then
                    
                    PPTtoPS(tempname)
                    
                End If
            End If
            
            
            '*********************************  AutoCAD dwgs und dxfs  ***************************
            
            If extraskip = False Then
                If handle="AutoCAD" Then
                    
                    If color=False Then
                        DWGtoTIF(tempname)
                    Else
                        DWGtoColorTIF(tempname)
                    End If
                    
                End If
            End If
            
            '*********************************  OpenOffice odt-Dateien  ***************************
            
            
            If extraskip = False Then
                If handle="ODT" Then
                    
                    If openofficepath="" Then
                        handle="unbekannt"
                        Typ="TXT"
                        OCRHandle=".tif"
                    Else
                        
                        ODTtoPS_neu(tempname)
                    End If
                    
                End If
            End If
            
            
            
            
            '*********************************  Postscript-Datein  ***************************
            
            If extraskip = False Then
                If (fs.FileExists(tempname&".ps")) And (Not fs.fileExists(tempname&".tif")) Then
                    
                    If color=False Then
                        PStoNonOCRTIF(tempname)
                    Else
                        PStoColorNonOCRTIF(tempname)
                    End If
                    sha1 = Pruefsumme(archivtif&OCRHandle)
                    If dublettenpruefung = True Then
	                    If find_doc_by_sha1(sha1) <> False Then
			       			dublettengarbage=True
			       			errortxt="Dublette erkannt ("&tempname&")"
				            getDublette(tempname)
				            Unlock(programm&lockdatei)
				            WScript.Quit
				        End If
					End If                    
                End If
            End If
            
            '*********************************  PCL-Datein  ***************************
            
            If extraskip = False Then
                If (fs.FileExists(tempname&".pcl")) And (Not fs.fileExists(tempname&".tif")) Then
                    
                    If color=False Then
                        PCLtoTIFF(tempname)
                    Else
                        PCLtoTIFF(tempname)
                    End If
                    
                End If
            End If
            
            '*********************************  PNG-Datein  ***************************
            
            If extraskip = False Then
                If (fs.FileExists(tempname&".png")) And (Not fs.fileExists(tempname&".tif")) Then
                    
                    PNGtoTIFF(tempname)
                    
                End If
            End If
            
            
            
            
            '*********************************  ASC-Datein  ***************************
            
            
            If extraskip = False Then
                If handle="ASCII" Then
                    
                    ASCtoTIF(tempname)
                    
                End If
            End If
            
            
            
            '******************************   XML-Dateien  **************************************
            
            
            If extraskip = False Then
                If handle="XML" Then
                    
                    If color=False Then
                        XMLtoTIF(tempname)
                    Else
                        XMLtoTIF(tempname)
                    End If
                    
                End If
            End If
            
            
            
            
            
            '*********************************  unbekannte Dateien  ***************************
            
            
            If extraskip = False Then
                If handle="unbekannt" Then
                    
                    makefilltif(tempname)
                    
                    
                End If
            End If
            
            
            
            
            
            '*********************************  Prfe abschlieend auf Existenz einer TIF-Datei  ***************************
            
            
            If (extension<>".jpg") And (extension<>".bmp") And (extension<>".gif") And (handle<>"unbekannt") Then 
                If Not fs.fileExists(archivtif&".tif") Then
                    
                    On Error Resume Next
                    Err.clear
                    
                    If changeling=False Then
                        errortxt="archivierung(12): Fehler: Keine TIF-Datei erzeugt."
                        objWshShell.LogEvent 1, errortxt
                        GetGarbage(Tempname)   
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    Else
                        errortxt="archivierung(12): Hinweis: Keine TIF-Datei erzeugt, kann Voransicht nicht aktualisieren."
                        objWshShell.LogEvent 2, errortxt
                        test = aufraeumen(tempname)
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If
                Else
                    OCRHandle=".tif"
                End If
            End If
            
            
            '**********************************************************************************
            '***************************       Textextraktion        **************************
            '**********************************************************************************
            
            
            
            
            
            '**********************************************************************************
            '***************************       Filterung        *******************************
            '**********************************************************************************
            
            If fs.fileexists(tempname&".tif") Then
                
                filtern(tempname)
                
            End If
            
            
            '********************************  Open Source OCR ********************************
            
            
            
            
            '*********************************************************************************
            '****************************  Textfilter  ***************************************
            '*********************************************************************************
            
            
            
            If normftx = True Then
                If fs.fileexists(tempname&".txt") Then	
                    
                    Set quelltxtfile = fs.OpenTextFile(tempname&".txt",1)
                    
                    If Err.number<>0 Then
                        On Error Resume Next	
                        Err.clear
                        errortxt="archivierung(17h): kann txt-datei nicht ffnen ("&tempname&".txt). "&Err.number	
                        objWshShell.LogEvent 1, errortxt
                        GetGarbage(tempname)
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If
                    
                    
                    Set zieltxtfile = fs.OpenTextFile(tempname&".ztd",8,True)
                    
                    If Err.number<>0 Then
                        Err.clear
                        On Error Resume Next
                        errortxt="archivierung(17h): kann txt-datei nicht erstellen ("&tempname&".ztd). "&Err.number	
                        objWshShell.LogEvent 1, errortxt
                        GetGarbage(tempname)
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If
                    
                    Do While quelltxtfile.AtEndOfStream <> True
                        kette=normstring(quelltxtfile.ReadLine)
                        zieltxtfile.WriteLine(kette)
                    Loop
                    
                    zieltxtfile.close
                    quelltxtfile.close
                    
                    Set zieltxtfile = Nothing
                    Set quelltxtfile = Nothing
                    
                    Err.clear
                    On Error Resume Next
                    WScript.Sleep 20
                    fs.deletefile tempname&".txt", True
                    WScript.Sleep 20
                    fs.copyfile tempname&".ztd", tempname&".txt", True
                    WScript.Sleep 20
                    fs.deletefile(tempname&".ztd")
                    If Err.number<>0 Then
                        Err.clear
                        
                        errortxt="archivierung(17i): Fehler nach Textdateifilterung " & Err.Number& vbCrLf & Err.Description
                        objWshShell.LogEvent 1, errortxt
                        GetGarbage(tempname)
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If
                    
                    
                End If
            End If
            
            
            
            '**********************************************************************************
            '*********************************** SHA1 Prfsumme         ***********************
            '**********************************************************************************
            
            If opensslpath<>"" Then
                If (extension = ".ps") And (fs.FileExists(tempname & ".tif")) Then
                    sha1 = Pruefsumme(tempname & ".tif")
                Else
                    sha1 = Pruefsumme(tempname & extension)
                End If 
            End If
            
            '**********************************************************************************
            '***************************     Kopieren in Archiv      **************************
            '**********************************************************************************
            
            If tabelle <> "workflow" Then '######################
                If extraskip = False Then'****************************
                    
                    If Tabelle<>"noarch" Then'++++++++++++++++++++++++++++
                                  
                        '**********************************************************************************
                        '***************************    Verzeichnisse im Archiv anlegen    ****************
                        '**********************************************************************************
                       
                        
                        If Not fs.FolderExists(archivverzeichnis) Then
                            Set tes1 = fs.CreateFolder(archivverzeichnis)
                            Set tes1 = Nothing
                            WScript.sleep 200
                            If Err.number<>0 Then
                                objWshShell.LogEvent 1, "archivierung(0): kann archivverzeichnis-verzeichnis nicht erstellen - Berechtigung?" & vbCrLf & archivverzeichnis & vbCrLf & Err.Number& vbCrLf & Err.Description
                                Err.clear
                                On Error Resume Next
                                getgarbage(tempname)
                                Unlock(programm&lockdatei)
                                WScript.Quit
                            End If 
                            
                            If Not fs.FolderExists(archivverzeichnis) Then
                                objWshShell.LogEvent 1, "archivierung(0b): kann archivverzeichnis-verzeichnis nicht erstellen (2) - Berechtigung?"
                                getgarbage(tempname)
                                Unlock(programm&lockdatei)
                                WScript.Quit
                            End If
                        End If
                        
                        If Not fs.FolderExists(archivkopie) Then
                            Set tes1 = fs.CreateFolder(archivkopie)
                            Set tes1 = Nothing
                            WScript.sleep 200
                            If Err.number<>0 Then
                                objWshShell.LogEvent 1, "archivierung(0): kann archivkopie-verzeichnis nicht erstellen - Berechtigung?"
                                Err.clear
                                On Error Resume Next
                                getgarbage(tempname)
                                Unlock(programm&lockdatei)
                                WScript.Quit
                            End If 
                            
                            If Not fs.FolderExists(archivkopie) Then
                                objWshShell.LogEvent 1, "archivierung(0b): kann archivkopie-verzeichnis nicht erstellen (2) - Berechtigung?"
                                getgarbage(tempname)
                                Unlock(programm&lockdatei)
                                WScript.Quit
                            End If
                        End If
                        
                        Jahr = DatePart("yyyy",Date)
                        Monat = DatePart("m",Date)
                        Tag = DatePart("d",Date)
                        Stunde = DatePart("h",Time)
                        Minuten = DatePart("n",Time)
                        Sekunde = DatePart("s", Time)
                        
                        datum = Jahr&"-" & Monat & "-" & Tag & "--" & Stunde & "-" & Minuten & "-" & Sekunde
                        
                        Jahrwert=Jahr - 2000
                        
                        zahl = Zufallszahl(10000000,99999999)
                        documentID=Jahrwert&Monat&Tag&Stunde&Minuten&Sekunde&zahl
                        
                        
                        
                        Tabellex=Tabelle
                        laenge=Len(Tabellex)
                        
                        If laenge>0 Then
                            Tabelley=""
                            For x=1 To laenge
                                mychar=Mid(tabellex,x,1)
                                If (mychar<>"\") And (mychar<>"/") And (mychar<>"*") And (mychar<>"|") And (mychar<>":") And (mychar<>"<") And (mychar<>">") And (mychar<>Chr(34))  And (mychar<>"?")Then
                                    tabelley=tabelley&mychar
                                Else
                                    objWshShell.LogEvent 2, "bitfarm-Archiv: Archivnamen sollten keine Leer- und Sonderzeichen enthalten! Bitte im Admin-Tool ndern: "&Tabelle
                                End If
                            Next
                            tabellex=tabelley
                        End If
                        
                        If Len(tabellex)<1 Then
                            errortxt="archivierung(38): Fehlerhafter Archivnamen (Sonderzeichen, oder/und zu kurz). Bitte im Administrator ndern."
                            objWshShell.LogEvent 1, errortxt
                            GetGarbage(tempname)
                            Unlock(programm&lockdatei)
                            WScript.Quit
                        End If
                        
                        Ausgabeverzeichnis = Archivverzeichnis&Tabellex&folderID&"\"
                        schattenverzeichnis = archivkopie&Tabellex&folderID&"\"
                        
                        
                        If Not fs.FolderExists(Ausgabeverzeichnis) Then
                            Set tes1 = fs.CreateFolder(Ausgabeverzeichnis)
                            Set tes1 = Nothing
                            WScript.sleep 200
                            If Err.number<>0 Then
                                objWshShell.LogEvent 1, "archivierung(0): kann Ausgabeverzeichnis nicht erstellen - Berechtigung?" & vbCrLf & Ausgabeverzeichnis
                                Err.clear
                                On Error Resume Next
                                WScript.Quit
                            End If 
                            
                            If Not fs.FolderExists(Ausgabeverzeichnis) Then
                                objWshShell.LogEvent 1, "archivierung(0b): kann Ausgabeverzeichnis nicht erstellen (2) - Berechtigung?" & vbCrLf & Ausgabeverzeichnis
                                WScript.Quit
                            End If
                        End If
                        
                        
                        If Not fs.FolderExists(schattenverzeichnis) Then
                            Set tes1 = fs.CreateFolder(schattenverzeichnis)
                            Set tes1 = Nothing
                            WScript.sleep 200
                            If Err.number<>0 Then
                                objWshShell.LogEvent 1, "archivierung(0): kann schattenverzeichnis-verzeichnis nicht erstellen - Berechtigung?" & vbCrLf & schattenverzeichnis
                                Err.clear
                                On Error Resume Next
                                WScript.Quit
                            End If 
                            
                            If Not fs.FolderExists(schattenverzeichnis) Then
                                objWshShell.LogEvent 1, "archivierung(0b): kann schattenverzeichnis-verzeichnis nicht erstellen (2) - Berechtigung?" & vbCrLf & schattenverzeichnis
                                WScript.Quit
                            End If
                        End If
                        
                        
                        Ausgabeverzeichnis = Archivverzeichnis&Tabellex&folderID&"\"&foldernumber&"\"
                        schattenverzeichnis = archivkopie&Tabellex&folderID&"\"&foldernumber&"\"
                        
                        If Not fs.FolderExists(Ausgabeverzeichnis) Then
                            Set tes1 = fs.CreateFolder(Ausgabeverzeichnis)
                            Set tes1 = Nothing
                            WScript.sleep 200
                            If Err.number<>0 Then
                                objWshShell.LogEvent 1, "archivierung(0): kann Ausgabeverzeichnis-verzeichnis nicht erstellen - Berechtigung?" & vbCrLf & Ausgabeverzeichnis
                                Err.clear
                                On Error Resume Next
                                WScript.Quit
                            End If 
                            
                            If Not fs.FolderExists(Ausgabeverzeichnis) Then
                                objWshShell.LogEvent 1, "archivierung(0b): kann Ausgabeverzeichnis-verzeichnis nicht erstellen (2) - Berechtigung?" & vbCrLf & Ausgabeverzeichnis
                                WScript.Quit
                            End If
                        End If
                        
                        
                        If Not fs.FolderExists(schattenverzeichnis) Then
                            Set tes1 = fs.CreateFolder(schattenverzeichnis)
                            Set tes1 = Nothing
                            WScript.sleep 200
                            If Err.number<>0 Then
                                objWshShell.LogEvent 1, "archivierung(0): kann schattenverzeichnis-verzeichnis nicht erstellen - Berechtigung?" & vbCrLf & schattenverzeichnis
                                Err.clear
                                On Error Resume Next
                                WScript.Quit
                            End If 
                            
                            If Not fs.FolderExists(schattenverzeichnis) Then
                                objWshShell.LogEvent 1, "archivierung(0b): kann schattenverzeichnis-verzeichnis nicht erstellen (2) - Berechtigung?" & vbCrLf & schattenverzeichnis
                                WScript.Quit
                            End If
                        End If
                        
                        Ausgabeverzeichnis = Archivverzeichnis&Tabellex&folderID&"\"&foldernumber&"\"&subfoldernumber&"\"
                        schattenverzeichnis = archivkopie&Tabellex&folderID&"\"&foldernumber&"\"&subfoldernumber&"\"
                        
                        If Not fs.FolderExists(Ausgabeverzeichnis) Then
                            Set tes1 = fs.CreateFolder(Ausgabeverzeichnis)
                            Set tes1 = Nothing
                            WScript.sleep 200
                            If Err.number<>0 Then
                                objWshShell.LogEvent 1, "archivierung(0): kann Ausgabeverzeichnis-verzeichnis nicht erstellen - Berechtigung?" & vbCrLf & Ausgabeverzeichnis
                                Err.clear
                                On Error Resume Next
                                WScript.Quit
                            End If 
                            
                            If Not fs.FolderExists(Ausgabeverzeichnis) Then
                                objWshShell.LogEvent 1, "archivierung(0b): kann Ausgabeverzeichnis-verzeichnis nicht erstellen (2) - Berechtigung?" & vbCrLf & Ausgabeverzeichnis
                                WScript.Quit
                            End If
                        End If
                        
                        
                        If Not fs.FolderExists(schattenverzeichnis) Then
                            Set tes1 = fs.CreateFolder(schattenverzeichnis)
                            Set tes1 = Nothing
                            WScript.sleep 200
                            If Err.number<>0 Then
                                objWshShell.LogEvent 1, "archivierung(0): kann schattenverzeichnis-verzeichnis nicht erstellen - Berechtigung?" & vbCrLf & schattenverzeichnis
                                Err.clear
                                On Error Resume Next
                                WScript.Quit
                            End If 
                            
                            If Not fs.FolderExists(schattenverzeichnis) Then
                                objWshShell.LogEvent 1, "archivierung(0b): kann schattenverzeichnis-verzeichnis nicht erstellen (2) - Berechtigung?" & vbCrLf & schattenverzeichnis
                                WScript.Quit
                            End If
                        End If
                        
                        
                        
                        '**********************************************************************************
                        '*****************************   Freien Slot finden        ************************
                        '**********************************************************************************
                        
                        Ausgabename =  Ausgabeverzeichnis&documentID
                        schattenname = schattenverzeichnis&documentID
                        If fs.fileexists(Ausgabename&".tif") Then
                            zahl = Zufallszahl(10000000,99999999)
                            documentID=Jahrwert&Monat&Tag&Stunde&Minuten&Sekunde&zahl
                            Ausgabename =  Ausgabeverzeichnis&documentID
                            schattenname = schattenverzeichnis&documentID
                            If fs.fileexists(Ausgabename&".tif") Then
                                zahl = Zufallszahl(10000000,99999999)
                                documentID=Jahrwert&Monat&Tag&Stunde&Minuten&Sekunde&zahl
                                Ausgabename =  Ausgabeverzeichnis&documentID
                                schattenname = schattenverzeichnis&documentID
                            End If
                        End If
                        
                        
                        '**********************************************************************************
                        '**********************************************************************************
                        '**********************************************************************************
                        '****************** ftx und txt zusammenfhren vor der naming Funktion  ***********
                        
                        If fs.FileExists(tempname & ".ftx") Then
                            Set quelltxtfile = fs.OpenTextFile(tempname&".ftx",1)
                            If fs.FileExists(tempname & ".txt") Then
                                Set zieltxtfile = fs.OpenTextFile(tempname&".txt",8)
                            Else
                                Set zieltxtfile = fs.CreateTextFile(tempname&".txt",True)
                            End If
                            
                            
                            If Err.number<>0 Then
                                Err.clear	
                                On Error Resume Next
                                errortxt="archivierung(42): kann txt-datei nicht ffnen. bzw erstellen" & vbCrLf & tempname & vbCrLf & Err.Number & vbTab & Err.Description
                                objWshShell.LogEvent 1, errortxt
                                GetGarbage(tempname)
                                Unlock(programm&lockdatei)
                                WScript.Quit
                            End If
                            
                            
                            Do While quelltxtfile.AtEndOfStream <> True
                                If normftx = True Then
                                    kette=normstring(quelltxtfile.ReadLine)
                                Else
                                    kette=quelltxtfile.ReadLine
                                End If
                                zieltxtfile.WriteLine(kette&" ")
                                
                            Loop
                            
                            quelltxtfile.Close	
                            zieltxtfile.close
                            If Err.Number = 0 Then
                                
                                fs.DeleteFile(tempname & ".ftx"), True
                                If Err.Number Then
                                    objWSHShell.LogEvent 1, "konnte .ftx-Datei nicht nach dem Mergen mit .txt lschen" & vbCrLf & tempname & vbCrLf & Err.Number & vbTab & Err.Description
                                End If
                            End If
                            
                            
                            
                            WScript.Sleep 200
                        End If
                        
                        ' ******************************************************************************
                        
                        If Not fs.FileExists(tempname&".txt") Then
                            Err.clear
                            On Error Resume Next
                            Set nottextfile = fs.CreateTextFile(tempname&".txt",True)
                            If Err.number<>0 Then
                                Err.clear
                                On Error Resume Next
                                errortxt="bitfarm-archiv: archivierung(18): kann keine Dummy-Textdatei erstellen ->Garbage"
                                objWshShell.LogEvent 1, errortxt
                                GetGarbage(tempname)
                                Unlock(programm&lockdatei)
                                WScript.Quit
                            End If
                            nottextfile.writeline()
                            nottextfile.writeline()
                            nottextfile.close
                            Set nottextfile=Nothing

                            
                        End If
                        Err.clear
                        
                        If extrajob <> "" Then
                            Ausgabename = extrajob
                        End If
                        
                        If extrajob = "" Then'-------------------
                            If Not fs.FolderExists(Ausgabeverzeichnis) Then
                                Set test = fs.CreateFolder(Ausgabeverzeichnis)
                                Set test = Nothing
                                
                                WScript.sleep 200
                                If Err.number<>0 Then
                                    objWshShell.LogEvent 1, "archivierung(0): kann Ausgabeverzeichnis nicht erstellen - Berechtigung?"  & vbCrLf & Ausgabeverzeichnis
                                    Err.clear
                                    On Error Resume Next
                                    
                                End If 
                                
                                
                                
                            End If
                            
                            '**********************************************************************************
                            '******************************  Displayname festlegen  ***************************
                            '****************************** Hintergrundbild einkopieren ***********************
                            '**********************************************************************************
                            
                            
                            'using()
                            If OCRHandle=".tif" Then
                                
                                myname2=myname
                                
                                myname=naming()
                                
                                
                                
                                If ((myname="") Or (myname="Dokument")) And (myname2<>"") Then
                                    myname=myname2
                                    
                                    
                                End If
                                
                                If myname="Folie 1" Then
                                    myname="PP-Prsentation"
                                    
                                End If
                                
                                
                                
                            End If
                            
                            
                            
                            
                            If (originaldatei<>"") And ((LCase(myname)="dokument") Or (myname="")) Then
                                
                                myname=NormZusatzfeld(originaldatei)
                                
                                
                            End If
                            

                            
                            '**********************************************************************************
                            '***********************************  Variablen mappen ****************************
                            '**********************************************************************************
                            
                            
                            
                            using()
                            
                            
                            runplugin(directplugin)
                            
                            
                            '**********************************************************************************
                            '******************** letzte Namensbearbeitung und -speicherung *******************
                            '**********************************************************************************
                            
                            If (BFADocName<>"") And ((LCase(myname)="dokument") Or (myname="")) Then
                                myname=BFADocName
                            End If
                            
                            setdocname(tempname&extension)
                            
                            
                            '**********************************************************************************
                            '*************************************  ggf. Dokument drehen***********************
                            '**********************************************************************************
                            
                            If docrotation<>"" Then
                                rotatetif(archivtif)
                            End If
                            '********************************  revisionssicher oder noch nicht?  ****************
                            If docschangeable=True Then
                                Ausgabename=schattenname
                                
                            End If
                            
                            If scriptdebug=True Then
                                objWshShell.LogEvent 1, "Archivierung-Debug: docschangeable3:"&docschangeable
                            End If
                            
                            '**********************************************************************************
                            Err.clear
                            
                            If docschangeable = False Then
                                If fs.FileExists(Ausgabename&OCRHandle) Then
                                    Err.clear
                                    On Error Resume Next
                                    errortxt="archivierung(19-1): kann Grafik-Datei nicht ins Archiv-Verzeichnis kopieren."&archivtif&OCRHandle&":"&Ausgabename&OCRHandle
                                    objWshShell.LogEvent 1, errortxt
                                    GetGarbage(tempname)
                                    Unlock(programm&lockdatei)
                                    WScript.Quit
                                End If
                            End If
                            
                            If fs.FileExists(archivtif&OCRHandle) Then
                                fs.CopyFile archivtif&OCRHandle, Ausgabename&OCRHandle, False
                                If Err.number<>0 Then
                                    Err.clear
                                    On Error Resume Next
                                    errortxt="archivierung(19-2): kann Grafik-Datei nicht ins Archiv-Verzeichnis kopieren."&archivtif&OCRHandle&":"&Ausgabename&OCRHandle
                                    objWshShell.LogEvent 1, errortxt
                                    GetGarbage(tempname)
                                    Unlock(programm&lockdatei)
                                    WScript.Quit
                                End If
                            Else
                                
                                Err.clear
                                errortxt="archivierung(20-1): fr das kopieren ins Archiv keine Grafik-Datei vorhanden."
                                objWshShell.LogEvent 1, errortxt
                                GetGarbage(tempname)
                                Unlock(programm&lockdatei)
                                WScript.Quit
                            End If
                            
                            
                            If (archquelle = True) And (handle<>"") And (extension<>".txt") Then
                                If fs.FileExists(tempname&extension) Then 
                                    quelle=Ausgabename&extension
                                    If Not fs.FileExists(	Ausgabename&extension) Then
                                        fs.CopyFile tempname&extension, Ausgabename&extension, True
                                        If Err.number<>0 Then
                                            Err.clear
                                            On Error Resume Next
                                            errortxt="archivierung(19-3): kann "&extension&"-Datei nicht ins Archiv-Verzeichnis kopieren."
                                            objWshShell.LogEvent 1, errortxt
                                            GetGarbage(tempname)
                                            Unlock(programm&lockdatei)
                                            WScript.Quit
                                        End If
                                        
                                        
                                    End If
                                    
                                Else
                                    Err.clear
                                    On Error Resume Next
                                    errortxt="archivierung(20-2): fr das kopieren ins Archiv keine "&extension&"-Datei vorhanden."
                                    objWshShell.LogEvent 1, errortxt
                                    GetGarbage(tempname)
                                    Unlock(programm&lockdatei)
                                    WScript.Quit
                                End If
                            End If
                            
                            
                            
                            
                            If schattenarchiv=True Then
                                If Not fs.FolderExists(schattenverzeichnis) Then
                                    Set test = fs.CreateFolder(schattenverzeichnis)
                                    Set test = Nothing
                                    
                                    WScript.sleep 200
                                    If Err.number<>0 Then
                                        objWshShell.LogEvent 1, "archivierung(0): kann schattenverzeichnis-verzeichnis nicht erstellen - Berechtigung?" & vbCrLf & schattenverzeichnis
                                        Err.clear
                                        On Error Resume Next
                                    End If 
                                    
                                End If
                                
                                
                                
                            End If 
                            
                            
                            
                        End If'----------------
                        
                        
                        
                        '**********************************************************************************
                        '*****************  Parameter in Textdatei integrieren und kopieren  **************
                        '**********************************************************************************
                        
                        
                        Err.clear
                        If fs.FileExists(ausgabename&".txt") Then
                            errortxt="archivierung(40): textdatei bereits im Archivvereichnis vorhanden."
                            objWshShell.LogEvent 1, errortxt
                            GetGarbage(tempname)
                            Unlock(programm&lockdatei)
                            WScript.Quit
                        End If
                        
                        Set zieltxtfile = fs.CreateTextFile(ausgabename&".txt",True)
                        If Err.number<>0 Then
                            Err.clear
                            On Error Resume Next
                            errortxt="archivierung(41): kann keine neue txt-datei im Archiv erzeugen."
                            objWshShell.LogEvent 1, errortxt
                            GetGarbage(tempname)
                            Unlock(programm&lockdatei)
                            WScript.Quit
                        End If
                        
                        
                        
                        Set quelltxtfile = fs.OpenTextFile(tempname&".txt",1)
                        
                        If Err.number<>0 Then
                            Err.clear	
                            On Error Resume Next
                            errortxt="archivierung(42): kann txt-datei nicht ffnen."
                            objWshShell.LogEvent 1, errortxt
                            GetGarbage(tempname)
                            Unlock(programm&lockdatei)
                            WScript.Quit
                        End If
                        
                        
                        
                        
                        Do While quelltxtfile.AtEndOfStream <> True
                            kette=quelltxtfile.ReadLine
                            zieltxtfile.WriteLine(kette&" ")
                            
                        Loop
                        
                        quelltxtfile.close
                        
                        If fs.fileexists(tempname&".ftx") Then
                            Set quelltxtfile = Nothing
                            Set quelltxtfile = fs.OpenTextFile(tempname&".ftx",1)
                            Do While quelltxtfile.AtEndOfStream <> True
                                If normftx=True Then
                                    kette=normstring(quelltxtfile.ReadLine)
                                End If
                                zieltxtfile.WriteLine(kette&" ")
                                If schattenarchiv = True Then
                                    schattentxtfile.WriteLine(kette&" ")
                                End If 
                            Loop
                            quelltxtfile.close
                        End If
                        
                        zieltxtfile.close
                        
                        
                        
                        
                        Set zieltxtfile = Nothing
                        Set quelltxtfile = Nothing
                        
                        
                        '**********************************************************************************
                        '***************************  Schlagwortdatei umkopieren  *************************
                        '**********************************************************************************
                        
                        '############################################  Zusatzfelder und schlagwrter normieren
                        
                        
                        For x = 0 To limit
                            If zusatzfeld(x)<>"" Then zusatzfeld(x) = NormZusatzfeld(zusatzfeld(x))
                            
                            
                        Next	
                        
                        For i=0 To 59
                            If FileInfoValue(i)<>"" Then FileInfoValue(i) = NormZusatzfeld(FileInfoValue(i))
                            If Schlagworte(i)<>"" Then Schlagworte(i) = NormZusatzfeld(Schlagworte(i))
                        Next
                        
                        
                        
                        
                        
                        
                        If Not fs.fileexists(tempname&".swd") Then
                            If fs.fileexists(tempname&".slw") Then
                                fs.copyfile tempname&".slw", tempname&".swd", True
                            End If
                        End If
                        
                        erfolg=AddswFileInfo(tempname)
                        If erfolg=False Then
                            objWshShell.LogEvent 2, "bitfarm-Archiv: Archivierung 34a: Keine Dateizusatzinformationen als Schlagwort gespeichert."
                        End If
                        
                        
                        If myname ="" Then
                            myname = "Dokument"
                        End If
                        
                        
                        '**********************************************************************************
                        '***************************  Jobdatei schreiben  *********************************
                        '**********************************************************************************
                        
                        checkOCR=False
                        notifyuser=False
                        
                        erfolgreich=writejob(tempname)
                        
                        
                        If erfolgreich<>True Then
                            errortxt="Fehler beim schreiben der Job-Datei."
                            objWshShell.LogEvent 1, errortxt
                            GetGarbage(tempname)
                            Unlock(programm&lockdatei)
                            WScript.Quit
                        End If
                        
                        
                        '**********************************************************************************
                        '***************************  Vorbereitung zum Datenbanktransfer  *****************
                        '**********************************************************************************
                        
                        
                        abbruch=False
                        i=0
                        Do While abbruch=False
                            If fs.fileexists(programm&"temp\movelock") Then
                                WScript.sleep 200
                                i=i+1
                            Else
                                abbruch=True
                            End If
                            If i>30 Then
                                On Error Resume Next
                                fs.deletefile programm&"temp\movelock", True
                                Err.clear
                                On Error Resume Next
                                abbruch=True
                            End If
                        Loop
                        
                        If Err Then
                            Err.clear
                            On Error Resume Next
                        End If
                        
                        
                        
                        '**********************************************************************************
                        '***************************  bergabe an die Datenbank  **************************
                        '**********************************************************************************
                        
                        
                        
                        
                        lngReturnCode=dbimp(tempname)
                        
                        
                        
                        If lngReturnCode <> 0 Then
                            errortxt="bitfarm-Archiv: Archivierung(33b): Fehler bei bergabe an Datenbank ("&lngreturncode&")"
                            'If lngReturnCode<>6 Then
                            objWSHShell.LogEvent 1, errortxt
                            'End If
                            If lngReturnCode<>6 Then
                                GetGarbage(tempname)
                                'Unlock(programm&"temp\directlock")
                                Unlock(programm&lockdatei)
                                
                                WScript.Quit
                            End If
                        End If
                        
                        
                        If scriptdebug=True Then
                            objWshShell.LogEvent 1, "archivierung-debug: clientID: "&clientID
                        End If
                        
                        clientmsgfile=clientspooler&"msg"&clientID&".bfa"
                        
                        If fs.fileexists(clientmsgfile) Then
                            fs.deletefile clientmsgfile, True
                            If Err.number<>0 Then
                                objWshShell.LogEvent 1, "archivierung(22c): konnte Client-Messagefile nicht speichern" & vbCrLf & Err.Number& vbTab & Err.Description
                                Err.clear
                                On Error Resume Next
                            End If
                        End If
                        
                        If fs.fileexists(clientmsgfile) Then
                            objWshShell.LogEvent 1, "archivierung(22d): kann keine Nachricht an den Client senden."
                        Else
                            
                            Set msgfile = fs.CreateTextFile(clientmsgfile,True)
                            msgfile.WriteLine Dokid
                            msgfile.WriteLine wfId
                            msgfile.Close
                            Set msgfile = Nothing 
                            
                            
                        End If
                        
                        '*********************************************************************************************
                        '****  Bearbeiter zur WV noch in DB schreiben, wenn per Importer oder Manuscan festgelegt ****
                        '*********************************************************************************************
                        
                        
                        If backupbearbeiter<>"" Then
                            writebackupWV(tempname)
                            lngReturnCode=dbimp(tempname)
                            If lngReturnCode <> 0 Then
                                errortxt="bitfarm-Archiv: Archivierung(33d): Fehler bei bergabe an Datenbank ("&lngreturncode&")"
                            End If
                        End If	
                        
                        
                        '***********************************************************************************
                        
                        refreshjob(tempname)
                        
                        Err.Clear
                        If savejob=True Then
                        	fs.CopyFile tempname&".job", Ausgabename&".job", True
                        End If
                        If Err.number<>0 Then
                            Err.clear
                            On Error Resume Next
                            errortxt="bitfarm-Archiv: archivierung(19-4): kann job-Datei nicht ins Archiv-Verzeichnis kopieren."
                            objWshShell.LogEvent 2, errortxt
                            
                        End If    	
                        
                        
                        
                        '***********************************************************************************
                        
                    End If'+++++++
                End If'********
                
                '***********************************************************************************
            End If '###########
            
            
            '**********************************  importierte Schlagworte lschen ***************
            
            If fs.fileexists(tempname&".slw") Then
                fs.deletefile(tempname&".slw")
                If Err.number<>0 Then
                    objWshShell.LogEvent 1, "archivierung-Direktimport: Ausnahmefehler Schlagwortdatei"
                End If
                
            End If
            
            If fs.fileexists(tempname&".swd") Then
                fs.deletefile(tempname&".swd")
                If Err.number<>0 Then
                    objWshShell.LogEvent 1, "archivierung-Direktimport: Ausnahmefehler Schlagwortdatei"
                End If
            End If
            
            
            '**********************************  umkopieren  ************************************
            
            queue=programm&"queue\"
            
            
            newtempname = getfifo(queue,"temp-cng")
            
            
            
            

            
            If fs.fileexists(tempname&extension) Then
                fs.copyfile tempname&extension, newtempname&extension, True
            End If
            
            fs.copyfile tempname&".job", newtempname&".zjd", True
            
            
            '**********************************  aufrumen  ************************************
            
            
            
            If cleanup=True Then
                test = aufraeumen(tempname)
            End If
            
            '***********************************************************************************
            '********************************  Schreiben der neuen Jobdatei  *******************
            '***********************************************************************************
            
            
            
            writenewjob(newtempname)
            
            
            
            '**************************************************************************************
            '**************************************************************************************
            '**************************************************************************************
            '**************************************Ende directpath*********************************
            '**************************************************************************************
            '**************************************************************************************
            '**************************************************************************************
            
            
        End If
        
        WScript.Sleep 50
    Next
    
    '************************************ lock lschen ***********************************
    Set folder=Nothing
    
    Unlock(programm&lockdatei)

    WScript.Quit
End Function































































'************************************************************************************
'************************************************************************************
'************************************************************************************
'************************************************************************************
'************************************************************************************
'************************************************************************************
'******************************       Hauptfunktion        **************************
'************************************************************************************
'************************************************************************************
'************************************************************************************
'************************************************************************************
'************************************************************************************
'************************************************************************************




Function main()
    On Error Resume Next
    
    
    
    If logging = True Then
        objWshShell.LogEvent 0,"bitfarm-Archiv Logging: Mainpath " &vbCrLf& "Verarbeite Datei " & file.name
    End If
    
    
    
    '*************************************************************************************************
    '*************************************************************************************************
    '************************************** Hauptroutine *********************************************
    '*************************************************************************************************
    '*************************************************************************************************
    
    
    Err.clear
    tempname =Replace(file.path,"." & fs.GetExtensionName(file),"")

    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        errortxt="Fehler bei Namensgebung tempname (Stringfehler) -> Garbage."
        objWshShell.LogEvent 2, errortxt
        Unlock(programm&lockdatei)
        WScript.Quit
    End If 
    archivtif=tempname
    
    
    '*************************************************************************************************
    '************************************** Jobdaten aus Warteschlange lesen *************************
    '*************************************************************************************************
    
    
    erfolgreich = readjob(tempname)
    If erfolgreich <> True Then
        errortxt="Fehler bei einlesen der Jobdatei -> Garbage."
        objWSHShell.LogEvent 1, errortxt
        GetGarbage(tempname)
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    If Profil="" Then
        errortxt="Fehler: kein Profil erkannt -> Garbage."
        objWSHShell.LogEvent 2, errortxt
        GetGarbage(tempname)
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    
    
    If fs.fileexists(programm&profil&"-"&Tabelle&".wfd") Then
    	workflowfile = programm&profil&"-"&Tabelle&".wfd"
    Else
      workflowfile = programm&profil&".wfd"
    End If
            
    
    For i = 0 To linkzaehler -1
        If LCase(Left(linkspeicher(i),5)) = "email" Then
            herkunft = "eMail"
        End If
    Next 
    
    '*************************************************************************************************
    '************************************** Konfiguration einlesen ***********************************
    '*************************************************************************************************
    If InStr(filtermakro,"fromoutlook")<>0 Then
    	herkunft = "eMail"
    	fromEMail=True
    End If
    
    erfolgreich = readconfig(Profil)
	  If erfolgreich <> True Then
        errortxt="Fehler bei einlesen des Profils " & Profil & " -> Garbage."
        objWSHShell.LogEvent 1, errortxt
        GetGarbage(tempname)
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    ' archivkopie und archivverzeichnis sind bei 3.6er Versionen obsolet, wird aus storage und archive_rs/nrs zusammengebaut.
    If storages = "" Or archive_rs = "" Or archive_nrs = "" Then
    	errortxt="archivierung.vbs Fehler beim ermitteln der Archivablage-Verzeichnisse"& vbCrLf & "storages: " & storages & vbCrLf & "archive_rs: " & archive_rs & vbCrLf & "archive_nrs: " & archive_nrs
    	objWSHShell.LogEvent 1, errortxt
    	GetGarbage(tempname)
    	Unlock(programm&lockdatei)
        WScript.Quit
    Else
    	archivbasedir = objWSHShell.ExpandEnvironmentStrings(storages)    
    	archivverzeichnis = archivbasedir & "\" & archive_rs & "\"
    	archivkopie = archivbasedir & "\" & archive_nrs & "\"
    	If Not fs.FolderExists(archivverzeichnis) Then
    		errortxt="archivierung.vbs Fehler: Archivverzeichnis "& archivverzeichnis &" nicht erreichbar -> garbage"
    		objWSHShell.LogEvent 1, errortxt
    		GetGarbage(tempname)
            Unlock(programm&lockdatei)
            WScript.Quit
    	End If
    	If Not fs.FolderExists(archivkopie) Then
    		errortxt = "archivierung.vbs Fehler: Archivkopie "& archivkopie &" nicht erreichbar -> garbage"
    		objWSHShell.LogEvent 1, errortxt
    		GetGarbage(tempname)
            Unlock(programm&lockdatei)
            WScript.Quit
    	End If
    End If

    
    If InStr(1,Omnipage,"14",1)<>0 Then
        OMPVersion=14
    End If
    If InStr(1,Omnipage,"15",1)<>0 Then
        OMPVersion=15
    End If
    If InStr(1,Omnipage,"16",1)<>0 Then
        OMPVersion=16
    End If
    If InStr(1,Omnipage,"17",1)<>0 Then
        OMPVersion=17
    End If
    If InStr(1,Omnipage,"18",1)<>0 Then
        OMPVersion=18
    End If  
    If InStr(1,Omnipage,"19",1)<>0 Then
        OMPVersion=19
    End If         
    If ompversion = "" Then
    	ompversion=19
    End If         
    
    If Tabelle = "noarch" Then
        extraskip = True
    End If
    
    swdateiname=tempname&".swd"
    
    Err.clear
    If fs.fileexists(swdateiname) Then
        fs.DeleteFile swdateiname, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            errortxt="archivierung(3a): kann alte Schlagwortdatei nicht lschen."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(tempname)
            Unlock(programm&lockdatei)
            WScript.Quit
        End If 
    End If
	
    If Typ = "YMP" Then
        Typ = "OMP"
        changeling=True
    End If
    If Typ = "YCR" Then
        Typ = "OCR"
        changeling=True
    End If
    If Typ = "YXT" Then
        Typ = "TXT"
        changeling=True
    End If
    If Typ = "YCS" Then
        Typ = "OCS"
        changeling=True
    End If
    If LCase(Typ)="forceomp" Then
    	forceomp=True
    	Typ = "OMP"
    Else
    	forceomp=False
    End If
    
    If Typ = "EXT" Then
        Typ = "TXT"
        docschangeable=False
        fromEMail=True
        herkunft="eMail"
        If mailattachments="changeable" Then
            docschangeable=True
        End If

    End If
    
    If Typ ="EMP" Then
        If fs.fileexists(tempname&".ftx") Or fs.fileexists(tempname&".txt") Then
            Typ="TXT"
        Else
            Typ="OMP"
        End If
        docschangeable=False
        fromEMail=True
        herkunft="eMail"
        If mailattachments="changeable" Then
            docschangeable=True
        Else
            docschangeable=False
        End If
        If scriptdebug=True Then
            objWshShell.LogEvent 1, "Trap: "&mailattachments&" change: "&docschangeable	
        End If
     End If
    
    If Typ = "CRE" Then
        Typ = "OMP"
    End If
 		
	
    If Typ = "OMP" And Omnipage = "" And usetesseract=False Then
        OMPVersion = -1
        Typ = "OCS"
    End If
    
    
    If (Typ <> "TXT") And (Typ <> "OCR") And (Typ <> "OMP") And (Typ <> "OCS") And (Typ <> "MAN") Then
        errortxt="archivierung(5): Parameter in Jobdatei fehlt: OCR_Typ=xxx" 
        objWshShell.LogEvent 1, errortxt
        GetGarbage(Tempname)   
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    
    If (dokid<>"") And (changeling=False) Then
        fromdirect=True
        
    End If
    
    If (fs.fileexists(tempname&".err")) And (dokid<>"") Then
        fromdirect=False
    End If
    
    
    If InStr(1,tempname,"eml",1)<>0 Then
        fromEMail=True
    End If
    
    If InStr(1,tempname,".msg",1)<>0 Then
        fromEMail=True
    End If
    
    If InStr(1,tempname,"temp-msg",1)<>0 Then
        fromEMail=True
    End If
    
    If changeling=True Then
    	If Left(orginal, Len(storages))=storages Then
        	orginal = archivbasedir & Right(orginal, Len(orginal)-Len(storages))
        End If
        If Left(quelle, Len(storages))=storages Then
        	quelle = archivbasedir & Right(quelle, Len(quelle)-Len(storages))
        End If
    End If
    
    '**********************************************************************************
    '********************       Typenidentifizierung        ***************************
    '**********************************************************************************
    
    
    handle=""
    OCRHandle=""
    If herkunft="" Then
        herkunft="Datei"
    End If
    
    If fs.FileExists(tempname&".pdf") Then
        extension=".pdf"
        handle="pdf"
        OCRHandle=".tif"	
    ElseIf fs.FileExists(tempname&".sig") Then
        extension=".sig"
        handle="pdf"
        If pdfnrs=True Then
            docschangeable=True
        End If
        OCRHandle=".tif"    
    ElseIf fs.FileExists(tempname&".") Then

        handle="unbekannt"
        OCRHandle="TXT"
        extension="."
        
    ElseIf (fs.FileExists(tempname&".eml")) And InStr(tempname,"temp-cng")<>0 Then
        If InStr(emlconverter,"bfa_eml_unpacker.exe") <> 0 Then
            extension=".eml"
            handle="eml"
        Else
            extension=".eml"
            handle="Word"
        End If 
    ElseIf (fs.FileExists(tempname&".eml")) And InStr(tempname,"temp-eml")=0 Then
        extension=".eml"
        handle="eml"
    ElseIf (fs.FileExists(tempname&".eml")) And InStr(tempname,"temp-eml") And fs.FileExists(tempname&".tif") = False Then
        extension=".eml"
        handle="Word"	
    ElseIf (fs.FileExists(tempname&".eml")) And InStr(tempname,"temp-eml") And fs.FileExists(tempname&".tif") = True Then
        extension=".eml"
        handle="tif"	
    ElseIf (fs.FileExists(tempname&".jpeg")) And (fs.FileExists(tempname&".tif")=False) Then
            jpgname = tempname & ".jpg"
        	fs.movefile tempname&".jpeg" , jpgname   
        	extension=".jpg"
            OCRHandle=".jpg"
            handle="jpg"
            docschangeable=False   
            If dontuseocrforjpg = True Then
	            Typ="TXT"
	        End If  
    ElseIf (fs.FileExists(tempname&".jpg")) And (fs.FileExists(tempname&".tif")=False) Then
        extension=".jpg"
        OCRHandle=".jpg"
        handle="jpg"
        docschangeable=False
        If dontuseocrforjpg = True Then
            Typ="TXT"
        End If
        
    ElseIf fs.FileExists(tempname&".gif") Then
        extension=".gif"
        OCRHandle=".gif"
        handle="gif"
        docschangeable=False
        If dontuseocrforgif = True Then
            Typ="TXT"
        End If
        
    ElseIf fs.FileExists(tempname&".bmp") Then
        extension=".bmp"
        OCRHandle=".bmp"
        docschangeable=False
        handle="bmp"
        If dontuseocrforbmp = True Then
            Typ="TXT"
        End If
        
    ElseIf fs.FileExists(tempname&".png") Then
        extension=".png"
        OCRHandle=".png"
        docschangeable=False
        handle="png"
        If dontuseocrforpng = True Then
            Typ="TXT"
        End If
        
    ElseIf fs.FileExists(tempname&".sldprt") Then
        extension=".sldprt"
        OCRHandle=".tif"
        handle="sldprt"
        Typ="OMP"
    ElseIf fs.FileExists(tempname&".sldasm") Then
        extension=".sldasm"
        OCRHandle=".tif"
        handle="sldprt"
        Typ="OMP"
    ElseIf fs.FileExists(tempname&".slddrw") Then
        extension=".slddrw"
        OCRHandle=".tif"
        handle="sldprt"
        Typ="OMP"                
    ElseIf fs.FileExists(tempname&".odt") Then
        extension=".odt"
        handle="ODT"	
        
    ElseIf fs.FileExists(tempname&".ods") Then
        extension=".ods"
        handle="ODT"	
        
    ElseIf fs.FileExists(tempname&".odg") Then
        extension=".odg"
        handle="ODT"	
        
    ElseIf fs.FileExists(tempname&".wps") Then
        extension=".wps"
        handle="ODT"     
        
    ElseIf fs.FileExists(tempname&".odp") Then
        extension=".odp"
        handle="ODT"	
        
    ElseIf fs.FileExists(tempname&".odf") Then
        extension=".odf"
        handle="ODT"	
        
    ElseIf fs.FileExists(tempname&".ott") Then
        extension=".ott"
        handle="ODT"	
        
    ElseIf fs.FileExists(tempname&".otp") Then
        extension=".otp"
        handle="ODT"	
        
    ElseIf fs.FileExists(tempname&".ots") Then
        extension=".ots"
        handle="ODT"
        
    ElseIf fs.FileExists(tempname&".otg") Then
        extension=".otg"
        handle="ODT"	
        
        ' alte OpenOffice-Formate	
    ElseIf fs.FileExists(tempname&".sdw") Then
        extension=".sdw"
        handle="ODT"
        
    ElseIf fs.FileExists(tempname&".sxw") Then
        extension=".sxw"
        handle="ODT"	
        
    ElseIf fs.FileExists(tempname&".stw") Then
        extension=".stw"
        handle="ODT"	
        
    ElseIf fs.FileExists(tempname&".sdc") Then
        extension=".sdc"
        handle="ODT"	
        
    ElseIf fs.FileExists(tempname&".stc") Then
        extension=".stc"
        handle="ODT"	
        
    ElseIf fs.FileExists(tempname&".sxc") Then
        extension=".sxc"
        handle="ODT"	
        
    ElseIf fs.FileExists(tempname&".sdd") Then
        extension=".sdd"
        handle="ODT"	
        
    ElseIf fs.FileExists(tempname&".sti") Then
        extension=".sti"
        handle="ODT"	
        
    ElseIf fs.FileExists(tempname&".sxi") Then
        extension=".sxi"
        handle="ODT"	
        
    ElseIf fs.FileExists(tempname&".sxd") Then
        extension=".sxd"
        handle="ODT"	
        
    ElseIf fs.FileExists(tempname&".std") Then
        extension=".std"
        handle="ODT"	
        
    ElseIf fs.FileExists(tempname&".sda") Then
        extension=".sda"
        handle="ODT"	
        
    ElseIf fs.FileExists(tempname&".sxm") Then
        extension=".sxm"
        handle="ODT"	
        
    ElseIf fs.FileExists(tempname&".smf") Then
        extension=".smf"
        handle="ODT"	
        
    ElseIf fs.FileExists(tempname&".vor") Then
        extension=".vor"
        handle="ODT"	
        
        
    ElseIf (fs.FileExists(tempname&".akt")) And (AKTSupport=True) Then
        extension=".akt"
        handle="AKT"
        docschangeable=True
        
    ElseIf (fs.FileExists(tempname&".ai")) And (IrfanViewInstalled=True) Then
        extension=".ai"
        handle="IView"
        docschangeable=True	
        
    ElseIf (fs.FileExists(tempname&".eps")) And (IrfanViewInstalled=True) Then
        extension=".eps"
        handle="IView"
        docschangeable=True	  
        
    ElseIf (fs.FileExists(tempname&".psd")) And (IrfanViewInstalled=True) Then
        extension=".psd"
        handle="IView"
        docschangeable=True	    
        
    ElseIf (fs.FileExists(tempname&".cdr")) And (IrfanViewInstalled=True) Then
        extension=".cdr"
        handle="IView"
        docschangeable=True	              		
        
    ElseIf fs.FileExists(tempname&".zip") Then
        If InStr(1,tempname,"tempzip")<> 0 Or InStr(1,tempname,"temp-zip")<> 0 Or zippath="" Then
            extension=".zip"
            handle="unbekannt"	
            OCRHandle=".tif"
        Else
            
            extension=".zip"
            handle="ZIP"	
        End If
        
    ElseIf fs.FileExists(tempname&".rar") Then
        If InStr(1,tempname,"tempzip")<> 0 Or InStr(1,tempname,"temp-zip")<> 0 Or zippath="" Then
            extension=".rar"
            handle="unbekannt"	
            OCRHandle=".tif"
        Else
            
            extension=".rar"
            handle="ZIP"	
        End If	
	
    ElseIf (fs.FileExists(tempname&".plt")) And (VCVIEWCONVERTInstalled=True) Then
        extension=".plt"
        handle="Plot"
        herkunft="Plan"		
        
    ElseIf fs.FileExists(tempname&".csv") Then
        If MSExcelinstalled = False Then
            If openofficepath<>"" Then
                extension=".csv"
                handle="ODT"
            Else
                extension=".csv"
                handle="unbekannt"	
                OCRHandle=".tif"	
            End If
        Else
            extension=".csv"
            handle="Excel"
        End If
        
    ElseIf fs.FileExists(tempname&".xls") Then
        If MSExcelinstalled = False Then
            If openofficepath<>"" Then
                extension=".xls"
                handle="ODT"
            Else
                extension=".xls"
                handle="unbekannt"	
                OCRHandle=".tif"	
            End If
        Else
            extension=".xls"
            handle="Excel"
        End If
    ElseIf fs.FileExists(tempname&".xlt") Then
        If MSExcelinstalled = False Then
            If openofficepath<>"" Then
                extension=".xlt"
                handle="ODT"
            Else
                extension=".xlt"
                handle="unbekannt"	
                OCRHandle=".tif"	
            End If
        Else
            extension=".xlt"
            handle="Excel"
        End If
    ElseIf fs.FileExists(tempname&".xlsx") Then
        If MSOffice2007installed = True And hostversion<>"w2k"  And MSExcelinstalled = True  Then
            extension=".xlsx"
            handle="Excel"
        Else
            
            If openofficepath<>"" Then
                extension=".xlsx"
                handle="ODT"
                'Typ="TXT"
                OCRHandle=".tif"
                
            Else	
                extension=".xlsx"
                handle="unbekannt"
                Typ="TXT"
                OCRHandle=".tif"
            End If
        End If	
    ElseIf fs.FileExists(tempname&".xlsm") Then
        If MSOffice2007installed = True And hostversion<>"w2k"  And MSExcelinstalled = True Then
            extension=".xlsm"
            handle="Excel"
        Else
            If openofficepath<>"" Then
                extension=".xlsm"
                handle="ODT"
                'Typ="TXT"
                OCRHandle=".tif"
            Else	
                
                extension=".xlsm"
                handle="unbekannt"
                Typ="TXT"
                OCRHandle=".tif"
            End If
        End If		
    ElseIf fs.FileExists(tempname&".xltx") Then
        If MSOffice2007installed = True And hostversion<>"w2k"  And MSExcelinstalled = True Then
            extension=".xltx"
            handle="Excel"
        Else
            If openofficepath<>"" Then
                extension=".xltx"
                handle="ODT"
                'Typ="TXT"
                OCRHandle=".tif"
            Else	
                
                extension=".xltx"
                handle="unbekannt"
                Typ="TXT"
                OCRHandle=".tif"
            End If
        End If	
    ElseIf fs.FileExists(tempname&".xltm") Then
        If MSOffice2007installed = True And hostversion<>"w2k"  And MSExcelinstalled = True Then
            extension=".xltm"
            handle="Excel"
        Else
            If openofficepath<>"" Then
                extension=".xltm"
                handle="ODT"
                'Typ="TXT"
                OCRHandle=".tif"
            Else	
                
                extension=".xltm"
                handle="unbekannt"
                Typ="TXT"
                OCRHandle=".tif"
            End If
        End If		
        
        
        
    ElseIf fs.FileExists(tempname&".dbf") Then
        If MSExcelinstalled = False Then
            If openofficepath<>"" Then
                extension=".dbf"
                handle="ODT"
            Else
                extension=".dbf"
                handle="unbekannt"	
                OCRHandle=".tif"	
            End If
        Else
            extension=".dbf"
            handle="Excel"				
        End If
        
    ElseIf fs.FileExists(tempname&".vcf") Then
        If MSWordinstalled = False Then
            If openofficepath<>"" Then
                extension=".vcf"
                handle="ODT"
            Else
                extension=".vcf"
                handle="unbekannt"	
                OCRHandle=".tif"	
            End If
        Else
            extension=".vcf"
            handle="Word"
        End If
        Typ="TXT"	
        If fs.fileexists(tempname&".txt") Then
            fs.deletefile tempname&".txt", True
        End If
        fs.copyfile tempname&".vcf", tempname&".txt", True
        
    ElseIf fs.FileExists(tempname&".doc") Then
        If MSWordinstalled = False Then
            If openofficepath<>"" Then
                extension=".doc"
                handle="ODT"
            Else
                extension=".doc"
                handle="unbekannt"	
                OCRHandle=".tif"	
            End If
        Else
            extension=".doc"
            handle="Word"
        End If
        
    ElseIf fs.FileExists(tempname&".dot") Then
        If MSWordinstalled = False Then
            If openofficepath<>"" Then
                extension=".dot"
                handle="ODT"
            Else
                extension=".dot"
                handle="unbekannt"	
                OCRHandle=".tif"	
            End If
        Else
            extension=".dot"
            handle="Word"
        End If
        
    ElseIf fs.FileExists(tempname&".docx") Then
        If MSOffice2007installed = True Then
            
            extension=".docx"
            handle="Word"
        Else
            If openofficepath<>"" Then
                extension=".docx"
                handle="ODT"
                'Typ="TXT"
                OCRHandle=".tif"
            Else	
                
                extension=".docx"
                handle="unbekannt"
                Typ="TXT"
                OCRHandle=".tif"
            End If
        End If
    ElseIf fs.FileExists(tempname&".vsd") Then
        extension=".vsd"
	    handle="ODT"
	    OCRHandle=".tif"
	ElseIf fs.FileExists(tempname&".vst") Then
        extension=".vst"
	    handle="ODT"
	    OCRHandle=".tif"
	ElseIf fs.FileExists(tempname&".vss") Then
        extension=".vss"
	    handle="ODT"
	    OCRHandle=".tif"
	ElseIf fs.FileExists(tempname&".vsdx") Then
        extension=".vsdx"
	    handle="ODT"
	    OCRHandle=".tif"
	ElseIf fs.FileExists(tempname&".vssx") Then
        extension=".vssx"
	    handle="ODT"
	    OCRHandle=".tif"
	ElseIf fs.FileExists(tempname&".vstx") Then
        extension=".vstx"
	    handle="ODT"
	    OCRHandle=".tif"	    
    ElseIf fs.FileExists(tempname&".docm") Then
        If MSOffice2007installed = True Then
            extension=".docm"
            handle="Word"
        Else
            If openofficepath<>"" Then
                extension=".docm"
                handle="ODT"
                'Typ="TXT"
                OCRHandle=".tif"
            Else	
                extension=".docm"
                handle="unbekannt"
                Typ="TXT"
                OCRHandle=".tif"
            End If
        End If	
        
    ElseIf fs.FileExists(tempname&".dotx") Then
        If MSOffice2007installed = True And hostversion<>"w2k" Then
            extension=".dotx"
            handle="Word"
        Else
            If openofficepath<>"" Then
                extension=".dotx"
                handle="ODT"
                'Typ="TXT"
                OCRHandle=".tif"
            Else	
                extension=".dotx"
                handle="unbekannt"
                Typ="TXT"
                OCRHandle=".tif"
            End If
        End If
    ElseIf fs.FileExists(tempname&".dotm") And hostversion<>"w2k" Then
        If MSOffice2007installed = True Then
            extension=".dotm"
            handle="Word"
        Else
            If openofficepath<>"" Then
                extension=".dotm"
                handle="ODT"
                'Typ="TXT"
                OCRHandle=".tif"
            Else	
                extension=".dotm"
                handle="unbekannt"
                Typ="TXT"
                OCRHandle=".tif"
            End If
        End If				
        
        
    ElseIf fs.FileExists(tempname&".rtf") Then
        If MSWordinstalled = False Then
            If openofficepath<>"" Then
                extension=".rtf"
                handle="ODT"
            Else
                extension=".rtf"
                handle="unbekannt"	
                OCRHandle=".tif"	
            End If	
        Else
            extension=".rtf"
            handle="Word"
        End If
        
    ElseIf fs.FileExists(tempname&".html") Then
        If Not fs.fileexists(tempname&".htm") Then
            fs.copyfile tempname&".html", tempname&".htm", True
        End If
        WScript.sleep 50
        
        If MSWordinstalled = False Then
            If openofficepath<>"" Then
                extension=".htm"
                handle="ODT"
            Else
                extension=".htm"
                handle="unbekannt"	
                OCRHandle=".tif"	
            End If
        Else
            extension=".htm"
            handle="Word"
        End If
        If fs.FileExists(tempname&".eml")Then
            fromEMail = True
        End If
        If InStr(1,tempname,"temp-msg",1)<>0 Then
            fromEMail=True
        End If
        If InStr(1,tempname,".msg",1)<>0 Then
            fromEMail=True
        End If
    ElseIf fs.FileExists(tempname&".htm") Then
        If MSWordinstalled = False Then
            If openofficepath<>"" Then
                extension=".htm"
                handle="ODT"
            Else
                extension=".htm"
                handle="unbekannt"	
                OCRHandle=".tif"	
            End If
        Else
            extension=".htm"
            handle="Word"
        End If
        
        If fs.FileExists(tempname&".eml")Then
            fromEMail = True
        End If
        
        If fs.FileExists(tempname&".msg")Then
            fromEMail = True
        End If
        
        If InStr(1,tempname,"temp-msg",1)<>0 Then
            fromEMail=True
        End If
        
        
    ElseIf fs.FileExists(tempname&".ppt") Then
        If MSPowerPointinstalled = False Then
            If openofficepath<>"" Then
                extension=".ppt"
                handle="ODT"
            Else
                extension=".ppt"
                handle="unbekannt"	
                OCRHandle=".tif"	
            End If
        Else
            extension=".ppt"
            handle="Powerpoint"
        End If
        
    ElseIf fs.FileExists(tempname&".pptx") Then
        
        If MSOffice2007installed = True And hostversion<>"w2k" Then
            
            extension=".pptx"
            handle="Powerpoint"
        Else
            extension=".pptx"
            handle="ODT"
            Typ="TXT"
            OCRHandle=".tif"
        End If
        
    ElseIf fs.FileExists(tempname&".ppsx") Then
        
        If MSOffice2007installed = True And hostversion<>"w2k" Then
            
            extension=".ppsx"
            handle="Powerpoint"
        Else
            extension=".ppsx"
            handle="unbekannt"
            Typ="TXT"
            OCRHandle=".tif"
        End If
        
        
        
    ElseIf fs.FileExists(tempname&".pps") Then
        If MSPowerPointinstalled = False Then
            If openofficepath<>"" Then
                extension=".pps"
                handle="ODT"
            Else
                extension=".pps"
                handle="unbekannt"	
                OCRHandle=".tif"	
            End If
        Else
            extension=".pps"
            handle="Powerpoint"
        End If
        
    ElseIf fs.FileExists(tempname&".msg") Then
        extension=".msg"
        fromemail=True
        If renderserver <> "" Then
            renderclient_email(tempname)
        ElseIf LCase(msgconverter)="outlook" Then
            handle="Outlook"
        ElseIf InStr(msgconverter, "msgtext.exe")<>0 Then
            handle= "msgtext"
        Else
            handle = "unbekannt"
        End If
        herkunft = "eMail"
        
        
    ElseIf fs.FileExists(tempname&".asc") Then
        extension=".asc"
        handle="ASCII"
        herkunft="ERP"		
        
    ElseIf fs.FileExists(tempname&".dwg") Then
        extension=".dwg"
        handle="AutoCAD"
        herkunft="Plan"
    ElseIf fs.FileExists(tempname&".dxf") Then
        extension=".dxf"
        handle="AutoCAD"
        herkunft="Plan"
    ElseIf fs.FileExists(tempname&".dwf") Then
        extension=".dwf"
        handle="AutoCAD"
        herkunft="Plan"	
        
    ElseIf fs.FileExists(tempname&".ps") Then
        extension=".ps"
        herkunft="Druck"
        richtung="Ausgang"
        
    ElseIf fs.FileExists(tempname&".pcl") Then
        extension=".pcl"
        herkunft="Druck"
        richtung="Ausgang"	
        
    ElseIf fs.FileExists(tempname&".tif") Then
        extension=".tif"
        herkunft="Scan"
        richtung="Eingang"
        
    ElseIf fs.FileExists(tempname&".txt") Then	
        If MSWordinstalled = False Then
            If openofficepath<>"" Then
                extension=".txt"
                handle="ODT"
            Else
                extension=".txt"
                handle="unbekannt"	
                OCRHandle=".tif"	
            End If
            
        Else
            extension=".txt"
            handle="Word"	
            Typ="TXT"
        End If
    ElseIf fs.FileExists(tempname&".ini") Then	
        If MSWordinstalled = False Then
            If openofficepath<>"" Then
                extension=".ini"
                handle="ODT"
            Else
                extension=".ini"
                handle="unbekannt"	
                OCRHandle=".tif"	
            End If
            
        Else
            extension=".ini"
            handle="Word"	
            Typ="TXT"
        End If
    ElseIf fs.FileExists(tempname&".xml") Then
        extension=".xml"
        handle="XML"
        If xmltotext = True Then
        	If Not fs.FileExists(tempname&".ftx") Then
        		fs.CopyFile tempname&".xml", tempname&".txt"
        		Typ="TXT"
        		handle="ODT"
        	End If
        Else
        	OCRHandle=".tif"	
        End If	
    ElseIf acceptallfiletypes=True Then
        
        
        For Each file1 In folder.files
            
            If InStr(1,file1,tempname&".",1)<>0 Then
                
                extension1 = "." & LCase(fs.GetExtensionName(file1))
                
                If (extension1=".job") Or (extension1=".ftx") Or (extension1=".vtx") Or (extension1=".slw") Or (extension1=".ocr") Or (extension1=".swd") Then
                    extension1=""
                End If
                If extension1<>"" Then
                    extension=extension1
                End If
            End If
        Next
        
        If extension<>"" Then
            handle="unbekannt"
            Typ="TXT"
            OCRHandle=".tif"
        End If
    End If
    

    
    '####################   BigEndian-Konvertierung fr Tif  ###############################
    perfadd("main init document")
    convertbigendian(tempname)
    perfadd("convertbigendian")
    '#######################################################################################
    

    
    '########################       Unicodeumwandlung fr html        ########################
    
    If extension = ".htm" Or extension = ".html" Then
        If scriptdebug = True Then
            objWSHShell.LogEvent 1, "Archivierung.vbs Unicodewandlung  checkunicodehtml(" &tempname& extension&") "
        End If 
        
        checkunicodehtml(tempname& extension)
        If scriptdebug = True Then
            objWSHShell.LogEvent 1, "Archivierung.vbs Unicodewandlung  durchgefhrt "
        End If 
        
        WScript.Sleep 500
    End If
    perfadd("Unicodeumwandlung fr html")
    '########################################################################################
    
    
    
    '##################################  EML-Dateien umwandeln ##############################

    If extension=".eml" And handle = "eml" Then
        If renderserver <> "" Then
            renderclient_email(tempname)
        ElseIf emlconverter="emlconvert.vbs" Then
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"emlconvert.bat"&Chr(34)&" "&Chr(34)&tempname&".eml"&Chr(34),0,True)
            WScript.sleep 100
            If cleanup=True Then
                test = aufraeumen(tempname)
            End If
            WScript.sleep 100
            Unlock(programm&lockdatei)
            WScript.Quit
        ElseIf InStr(emlconverter, "bfa_eml_unpacker.exe")<>0 Then
            emlconvert(tempname&".eml")
        End If
    End If
    perfadd("EML-Dateien umwandeln")
    '########################################################################################
    
    
    
    
    
    '##################################  ZIP-Dateien entpacken ##############################
    
    If handle="ZIP" Then
        If (dontdecompzipattachments And fromEmail) Or (dontdecompzipatall) Then
            handle="unbekannt"	
            OCRHandle=".tif"
        Else
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"bfa_unzip.bat"&Chr(34)&" "&Chr(34)&tempname& extension&Chr(34) ,0,True)
            WScript.sleep 200
            
            If cleanup=True Then
                test = aufraeumen(tempname)
            End If
            WScript.sleep 100
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
        
        ' Text zum zip erzeugen (File-Listing des zips)
        If zipfilelist=True Then
        	txtfile = tempname & ".txt"
        	cmd = chr(34) & zippath & chr(34) & " l " & chr(34) & tempname & ".zip" & chr(34)
        	Set oExec = objWSHShell.Exec(cmd)
	    	strinput = ""
	    	strerr = ""
	    	Do While Not oExec.StdOut.AtEndOfStream
		        strinput = strinput & oExec.StdOut.ReadAll
	    	Loop
	    	Do While Not oExec.StdErr.AtEndOfStream
		        strerr = strerr & oExec.StdErr.ReadAll
	    	Loop
	    	
	    	If Not fs.FileExists(txtfile) Then
	    		Set ftxfile = fs.CreateTextFile(txtfile, True)
                ftxfile.Writeline(strinput)
                ftxfile.close
	    	End If
	    End If
	    
		
		
    End If
    '########################################################################################
    perfadd("ZIP-Dateien entpacken")
    

    
    If (extension=".txt") And (fromEMail=True) Then
        Typ="TXT"
        herkunft="eMail"

    End If
    getoriginalname(tempname)
    
    If fromEMail=True And extension<>".msg" And extension <>".eml" Then
        herkunft="eMail"
        If myname="" And attachmentdontuseoriname=False Then
            If originaldatei<>"" Then
                myname=normzusatzfeld(originaldatei)
            End If
        ElseIf normzusatzfeld(myname) = normzusatzfeld(originaldatei) And attachmentdontuseoriname=True Then
            myname = ""
        End If
        If (extension=".htm") Or (extension=".txt") Or (extension=".vcf") Then
            docschangeable=False
        End If
        If LCase(myname)="textpart.txt" Then
            myname="E-Mail Nachricht"
            originaldatei=""
        End If
    End If

    
    If extension="" Then
        errortxt="archivierung(5b): Kein Dokument zur Jobdatei vorhanden." 
        objWshShell.LogEvent 1, errortxt
        GetGarbage(Tempname)   
        Unlock(programm&lockdatei)
        WScript.Quit				
    End If
    
    If allownonrevisionsave=True Then
        If (handle="Word") Or (handle="Excel") Or (handle="AutoCAD") Or (handle="PowerPoint") Or (handle="unbekannt") Or (handle="ODT") Then
            docschangeable=True
            If scriptdebug=True Then
                objWshShell.LogEvent 0, "Archivierung-Debug: docschangeable4:"&docschangeable
            End If
        End If
        If ((extension=".slddrw") And (solidworksnrs=True)) Or ((extension=".sldasm") And (solidworksnrs=True)) Or ((extension=".sldprt") And (solidworksnrs=True)) Or ((extension=".jpg") And (JPGNRS=True)) Or ((extension=".xml") And (XMLNRS=True)) Or ((extension=".pdf") And (PDFNRS=True)) Or ((extension=".ppt") And (PPTNRS=True)) Or ((extension=".pptx") And (PPTNRS=True)) Or ((extension=".png") And (PNGNRS=True)) Or ((extension=".bmp") And (BMPNRS=True)) Or ((extension=".gif") And (GIFNRS=True)) Then
            docschangeable=True
        End If
        If ((extension=".") And (NOEXTNRS=True)) Then
            docschangeable=True
        ElseIf ((extension=".") And (NOEXTNRS=False)) Then
            docschangeable=False
        End If
        
        
    End If
    
    
    
    
    If fromEMAIL=True Then
        docschangeable=False
        If mailattachments="changeable" Then
            If ((extension=".slddrw") And (solidworksnrs=True)) Or ((extension=".sldasm") And (solidworksnrs=True)) Or ((extension=".sldprt") And (solidworksnrs=True)) Or ((extension=".jpg") And (JPGNRS=True)) Or ((extension=".xml") And (XMLNRS=True)) Or ((extension=".pdf") And (PDFNRS=True)) Or ((extension=".ppt") And (PPTNRS=True)) Or ((extension=".pptx") And (PPTNRS=True)) Or ((extension=".png") And (PNGNRS=True)) Or ((extension=".bmp") And (BMPNRS=True)) Or ((extension=".gif") And (GIFNRS=True)) Or (handle="Word") Or (handle="Excel") Or (handle="AutoCAD") Or (handle="PowerPoint") Or (handle="unbekannt") Or (handle="ODT") Or (handle="AKT") Or (handle="IView") Then
                docschangeable=True
            End If
        End If
        '############ Ausfiltern unerwnschter Attachments ##################
        filtermailattachments(tempname)
        
        
        If InStr(1,LCase(filtermakro), "color") Then
            emailcolor="color"
        End If
        
    End If
    
    
    
    
    
    
    If ((handle="Word") Or (handle="Excel") Or (handle="Outlook") Or (handle="msgtext")) And (archofficecolor=True) Then
        color=True
    End If
    
    If (handle="ODT") And (archofficecolor=True) Then
        color = True
    End If
    
    If (extension=".htm") And (archHTMLincolor=True) Then
        color=True
    End If
    
    If (handle="AutoCAD") And (archDWGcolor=True) Then
        color=True
    End If
    
    If (handle="pdf") And ((archpdfincolor=True) Or (archpdfincolor="grey")) Then
        color=True
    End If
    
    If handle="AKT"	Then
        color=True
        hires=True
    End If
    
    If handle="IView"	Then
        color=True
        hires=True
    End If
    
    
    '************** wenn changeling, dann Farbtiefe des Originaltifs *******
    '************** verwenden statt Voreinstellungen aus scripts.ini *******
    
    If changeling=True Then
        color = isColorTif(orginal)
    End If   
    
    '*********************************** Servicetrap ***********************
    
    If scriptdebug=True Then
        objWshShell.LogEvent 0, "Archivierung-Debug: Handle: " & handle & " Extension: " & extension & " FromEMail: "&fromemail
    End If
    
    
    '**********************************************************************************
    '*********************************** Frhe Dublettenprfung ***********************
    '**********************************************************************************
    
    perfadd("changeable und color prfung")
    If (tabelle <> "workflow") And (dublettenpruefung = True) And (handle <> "") And (fromdirect=False) And (changeling=False) Then 
        dublettengarbage=True
        If fs.FileExists(programm&"get_doc_by_sha.exe") And fs.FileExists(opensslpath) Then
       		shasum = Pruefsumme(tempname&extension)
       		If find_doc_by_sha1(shasum) <> False Then
       			dublettengarbage=True
       			errortxt="Dublette erkannt ("&tempname&")"
	            getDublette(tempname)
	            Unlock(programm&lockdatei)
	            WScript.Quit
       		Else
       			dublettengarbage=False
       		End If
        Else
	        If istschonarchiviert(tempname) = True Then
	            dublettengarbage=True
	            errortxt="Dublette erkannt ("&tempname&")"
	            getDublette(tempname)
	            Unlock(programm&lockdatei)
	            WScript.Quit
	        Else
	            dublettengarbage=False
	        End If
	    End If
    End If 
    perfadd("Frhe Dublettenprfung")
    
    If extension<>".sldprt" And extension<>".slddrw" And extension<>".sldasm" Then
        setwriteprotectbit(tempname&extension)
    End If
    

    
    
    
    
    
    
    '**********************************************************************************
    '********************       Typenverarbeitung        ******************************
    '**********************************************************************************
    
    
    '******************************************
    '***** custom dpi-Einstellungen ***********
    '******************************************
    If extension<>"" Then
        Err.clear
        laenge=Len(extension)-1
        If laenge>0 Then
            myext=Right(extension,laenge)
            gefunden=False
            i=0
            Do While gefunden=False
                If changeresolution(i)<>"" Then
                    If Len(changeresolution(i))>laenge Then
                        If Left(changeresolution(i),laenge)=myext Then
                            gefunden=True
                            dpi=Trim(Right(changeresolution(i),Len(changeresolution(i))-InStr(1,changeresolution(i),",",1)))
                            If Err.number<>0 Then
                                Err.clear
                                On Error Resume Next
                                objWSHShell.LogEvent 1, "bitfarm-Archiv: Archivierung (187): Unbekannter Fehler changeresolution. Bitte prfen Sie die scripts.ini auf korrekte Anwendung des changeresolution-Statements."
                                gefunden=False
                            End If
                            
                        End If
                    End If
                End If
                If gefunden=False Then
                    i=i+1
                End If
                If i>99 Then
                    gefunden=True
                    
                End If
            Loop
            customdpi=0
            If dpi<>"" Then
                create_custom_rsps(dpi)
                customdpi=dpi
            End If
        End If			
    End If
    
    '******************************************
    '******************************************
    
    
    
    If (Defaultresolution="hires") And (dpi="") Then
        hires=True
    End If
    
    '******************************************
    '******************************************
    
    
    
    If fromdirect=False Then
        '*********************************  PDF-Datein  ***************************
        
        If extraskip = False Then
            If handle="pdf" Then
                
                If renderserver <> "" Then
                    renderclient_pdf(tempname)
                Else
                    If color=False Then		
                        PDFtoTIF(tempname)
                    Else
                        PDFtoColorTIF(tempname)
                    End If
                End If
            End If
        End If
        
        
        '*********************************  DOC-Datein  ***************************
        If extraskip = False Then
            If handle="Word" Then
                
                DOCtoPS(tempname)
                
            End If
        End If
        
        '*********************************  XLS-Datein  ***************************
        If extraskip = False Then
            If handle="Excel" Then
                
                XLStoPS(tempname)
                
            End If
        End If
        
        '*********************************  PP-Datein  ***************************
        If extraskip = False Then
            If handle="Powerpoint" Then
                
                PPTtoPS(tempname)
                
            End If
        End If
        
        '*********************************  MSG-Datein  ***************************
        If extraskip = False Then
            If handle="Outlook" Then 
                MSGtoPS(tempname)
            ElseIf handle="msgtext" Then
                msgtext()
            End If    
        End If
        
        '*********************************  ASC-Datein  ***************************
        
        
        If extraskip = False Then
            If handle="ASCII" Then
                
                ASCtoTIF(tempname)
                
            End If
        End If
        
        '*********************************  solidworks-Datein  ***************************
        
        
        If extraskip = False Then
            If handle="sldprt" And solidworksconverter<> "" Then
                SLDPRTtoTIF(tempname)
            ElseIf handle="sldprt" And solidworksconverter= "" Then
                makefilltif(tempname)
            End If
        End If       
        '*********************************  AutoCAD dwgs und dxfs  ***************************
        
        If extraskip = False Then
            If handle="AutoCAD" Then
                If renderserver = "" Then
	                If dontuseocrforcad = True Then
	                    Typ="TXT"
	                End If
	                
	                If color=False Then
	                    DWGtoTIF(tempname)
	                Else
	                    DWGtoColorTIF(tempname)
	                End If
	            Else
	            	renderclient_dwg(tempname) 
	            End If
                
            End If
        End If
        
        '*********************************  AKT-Datein  ***************************
        If extraskip = False Then
            If handle="AKT" Then
                
                AKTtoPS(tempname)
                
            End If
        End If
        
        '*********************************  IView-Datein  ***************************
        If extraskip = False Then
            If handle="IView" Then
                
                IViewtoTIF(tempname)
                
            End If
        End If
        
        '*********************************  Fr E-Mail Handling  ***************************
        
        If (extension=".htm") And (fs.fileexists(tempname&".txt")) Then
            Typ="TXT"
        End If
        
        If (extension=".htm") And (fs.fileexists(tempname&".txt")=False) Then
            Typ="OMP"
        End If
        
        
        If extension=".txt" Then
            Typ="TXT"
        End If
        
        '*********************************  Plott-Dateien .plt  ***************************
        
        If extraskip = False Then
            If handle="Plot" Then
                
                If dontuseocrforcad = True Then
                    Typ="TXT"
                End If
                
                If color=False Then
                    PLTtoTIF(tempname)
                Else
                    PLTtoTIF(tempname)
                End If
                
            End If
        End If
        
        '*********************************   open Office  ***********************************
        If extraskip = False Then
            If handle="ODT" Then
                
                If renderserver <> "" Then
                    If fs.fileexists(programm&"MultiClient.exe") Then
                        renderclient_odt(tempname)
                    End If
                ElseIf openofficepath="" Then
                    handle="unbekannt"
                    Typ="TXT"
                    OCRHandle=".tif"
                Else
                    ODTtoPS_neu(tempname)
                End If
                
            End If
        End If
        
        
        
        '*********************************  Postscript-Datein  ***************************
        
        If extraskip = False Then
            If (fs.FileExists(tempname&".ps")) And (Not fs.fileExists(tempname&".tif")) Then
            	If (archpsincolor <> True And instr(1, LCase(Filtermakro), "color")<>0) Then
            		archpsincolor = True
            	End If
                If renderserver = "" Then
	                If archpsincolor=False Then
	                	color = False
	                    If Typ = "TXT" Then
	                    	If scriptdebug=True Then
	                    		objWSHShell.LogEvent 1, "archivierung.vbs: archpsincolor=False, color=False, Typ=TXT -> PStoNonOCRTIF"
	                    	End If
	                        PStoNonOCRTIF(tempname)
	                    Else
	                    	If scriptdebug=True Then
	                    		objWSHShell.LogEvent 1, "archivierung.vbs: archpsincolor=False, color=False, Typ!=TXT -> PStoTIF"
	                    	End If
	                        PStoTIF(tempname)
	                    End If
	                Else
	                	color = True
	                    If Typ = "TXT" Then
	                    	If scriptdebug=True Then
	                    		objWSHShell.LogEvent 1, "archivierung.vbs: archpsincolor=True, color=True, Typ=TXT -> PStoColorNonOCRTIF"
	                    	End If
	                        PStoColorNonOCRTIF(tempname)
	                    Else
	                    	If scriptdebug=True Then
	                    		objWSHShell.LogEvent 1, "archivierung.vbs: archpsincolor=True, color=True, Typ!=TXT -> PStoColorTIF"
	                    	End If
	                        PStoColorTIF(tempname)
	                    End If
	                End If
	            Else
	            	renderclient_ps(tempname) 
	            End If
                
                sha1 = Pruefsumme(archivtif&".tif")
                If dublettenpruefung = True Then
	                If find_doc_by_sha1(sha1) <> False Then
		       			dublettengarbage=True
		       			errortxt="Dublette erkannt ("&tempname&")"
			            getDublette(tempname)
			            Unlock(programm&lockdatei)
			            WScript.Quit
			        End If
			    End If
            End If
        End If
        
        '*********************************  PCL-Datein  ***************************
        
        If extraskip = False Then
            If (fs.FileExists(tempname&".pcl")) And (Not fs.fileExists(tempname&".tif")) Then
                
                PCLtoTIFF(tempname)
                
            End If
        End If
        
        '*********************************  PNG-Datein  ***************************
        
        If extraskip = False Then
            If (fs.FileExists(tempname&".png")) And (Not fs.fileExists(tempname&".tif")) Then
                
                PNGtoTIFF(tempname)
                
            End If
        End If
        
        
        '******************************   XML-Dateien  **************************************
        
        
        If extraskip = False Then
            If handle="XML" Then
                
                If color=False Then
                    XMLtoTIF(tempname)
                Else
                    XMLtoTIF(tempname)
                End If
                
            End If
        End If
        
        
        '******************************   JPG-Dateien  **************************************        
        
        If extraskip = False Then
            If handle="jpg" And usejpgtotif=True Then
                JPGtoTIFF(tempname)
            End If
        End If           
        
        '*********************************  unbekannte Dateien  ***************************
        
        
        If extraskip = False Then
            If handle="unbekannt" Then
                makefilltif(tempname)
            End If
        End If
        
        
        
        '*********************************  Prfe abschlieend auf Existenz der Tif-Datei  ***************************
    End If
    
    
    
    If (extension<>".jpg") And (extension<>".bmp") And (extension<>".gif") And (extension<>".sldprt")  And (extension<>".slddrw")  And (extension<>".sldasm") And (handle<>"unbekannt") Then 
        If Not fs.fileExists(archivtif&".tif") Then
            
            On Error Resume Next
            Err.clear
            
            If changeling=False Then
                errortxt="archivierung(12): Fehler: Keine TIF-Datei erzeugt."
                objWshShell.LogEvent 1, errortxt
                GetGarbage(Tempname)   
                Unlock(programm&lockdatei)
                WScript.Quit
            Else
                errortxt="archivierung(12): Hinweis: Keine TIF-Datei erzeugt, kann Voransicht nicht aktualisieren."
                objWshShell.LogEvent 1, errortxt
                test = aufraeumen(tempname)
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
        Else
            If OCRHandle<>".pdf" Then
                OCRHandle=".tif"
            End If
        End If	
        
    End If
    
    perfadd("Typverarbeitung Voransicht")
    
    resetwriteprotectbit(tempname&extension)
    
    
    
    
    
    '**********************************************************************************
    
    '**********************************************************************************
    '********************      Auslesen der Dateiinfos        *************************
    '**********************************************************************************
  
    If fromdirect=False Then
        
        getInfo(tempname&extension)
        
        getoriginalname(tempname)
        
    End If
    
    

    waitdirect()
    '**********************************************************************************
    '***************************       Textextraktion        **************************
    '**********************************************************************************
    
    ' hier die extension gegen ocrxmlfor prfen und ggfs. Typ OMP setzen
    If extension <> "" And ocrxmlfor <> "" Then
    	ocrtypes = Split(ocrxmlfor, ".")
    	For i = 0 To UBound(ocrtypes)
    		ocrtypes(i) = LCase(ocrtypes(i))
    	Next
    	tmpext = LCase(Right(extension,Len(extension)-1))
    	if IsInArray(tmpext, ocrtypes) = True Then
    		Typ="OMP"
            If tmpext <> "bmp" And tmpext <> "jpg" And tmpext <> "gif" Then
            	OCRHandle=".tif"
            Else
            	OCRHandle=extension
            End If
            forcedomp = True
    	End If
    End If
    
    checkOCR=False    
    perfadd("Dateiinfos und waitdirect")
    If extraskip = False  And isdirect = False Then
        
        '  Haben wir eine spezielle OCR-Datei?
        If fs.FileExists(tempname&".ocr") Then
            Err.clear
            On Error Resume Next
            fs.CopyFile tempname&".ocr", tempname&"-OCR.tif", True
            If Err.number <> 0 Then
                objWshShell.LogEvent 1, "archivierung(13a): konnte spezielle OCR-Grafikdatei nicht umbenennen, versuche mit Originaldatei fortzusetzen."
                OCRname=tempname
                
            Else
                OCRname=tempname&"-OCR"
            End If
        Else
            OCRname=tempname
        End If
        
        
        '**********************************************************************************
        '***************************       Filterung        *******************************
        '**********************************************************************************
        
        If (fs.fileexists(tempname&".tif")) And (fromdirect=False) Then
            
            filtern(tempname)
            
        End If
        perfadd("filtern vor ocr")
        '**********************************************************************************
        '***************       Hintergrundbild mergen (ber template)       ***************
        '**********************************************************************************
        
        
        
        If myform<>"" Then
            myformdatei=programm&"forms\"&myform
            If fs.fileexists(myformdatei) Then
                WScript.sleep 300
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"mergerv3.exe"&Chr(34)&" "&myformdatei&" "&archivtif&".tif "&archivtif&".tif fit",0,True)
                
                WScript.sleep 100
                If lngReturnCode <> 0 Then
                    objWSHShell.LogEvent 2, "archivierung: naming: Fehler bei tif-merging fr Hintergrundgrafik "&tempname&" "
                End If
            End If
            myform=""
        End If	
        perfadd("Hintergrundbild mergen (ber template)")
        '**********************************************************************************
        '***************************       autoshrink jpgs       *************************
        '**********************************************************************************
        
        
        If (extension=".jpg") And (autoshrinkjpg<>0) And (changeling=False) Then
            If JPGNRS=False Then
                objWSHShell.LogEvent 1, "bitfarm-Archiv: Archivierung: autoshrinkjpg darf bei revisionsicherem Archivieren von jpg (jgnrs=false) nicht verwendet werden!"&vbCrLf&"Das jpg wird nicht komprimiert."
            Else
                shrinkjpg(tempname)
            End If
        End If
        
        
        perfadd("autoshrink jpgs")
        '********************************  Open Source OCR ********************************
        
        If Typ = "OCR" Then
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"konvert.bat"&Chr(34)&" "&Chr(34)&OCRname&OCRHandle&Chr(34)&" "&Chr(34)&tempname&".pnm"&Chr(34),0,True)
            
            
            If lngReturnCode <> 0 Then
                Err.clear
                On Error Resume Next
                errortxt="archivierung(13): free OCR: Fehler bei Konvertierung in pnm-format."
                objWSHShell.LogEvent 1, errortxt
                GetGarbage(tempname)
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
            
            If Not fs.FileExists(tempname&".pnm") Then
                Err.clear
                On Error Resume Next
                errortxt="archivierung(14): keine pnm-Datei vorhanden, kann nicht weitermachen."
                objWshShell.LogEvent 2, errortxt
                GetGarbage(tempname)
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
            
            
            
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ocr.bat"&Chr(34)&" "&Chr(34)&tempname&".pnm"&Chr(34)&" "&Chr(34)&tempname&".txt"&Chr(34),0,True)
            
            
            
            If lngReturnCode <> 0 Then
                Err.clear
                On Error Resume Next
                errortxt="archivierung(15): Fehler bei free OCR"
                objWSHShell.LogEvent 1, errortxt
                GetGarbage(tempname)
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
            
        End If
        
        
        '********************************  Open Source OCR (ocropus)********************************
        If Typ = "OCS" Then
            
            If scriptdebug Then
                objWSHShell.LogEvent 0, Chr(34)&programm&"filterv3.exe"&Chr(34)&" "&Chr(34)&tempname&OCRHandle&Chr(34)&"  "&Chr(34)&programm&"tiff-pnm.txt"&Chr(34)&" "&Chr(34)&tempname&".pbm"&Chr(34)
            End If
            doocs=True
            If (handle="pdf") And (extractPDF=True) Then
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"PDFtoTXT.bat"&Chr(34)&" "&Chr(34)&tempname&".pdf"&Chr(34),0,True)
                If lngReturnCode <> 0 Then
                    Err.clear
                    On Error Resume Next
                    errortxt="archivierung(12): Fehler bei PDFtoTXT."
                    objWshShell.LogEvent 1, errortxt
                    GetGarbage(tempname)   
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If
                If fs.fileexists(tempname&".txt") Then
                    If ocrstatistik(tempname&".txt") = False Then
                        doocs=True
                    Else
                        If notifyuser=False Then
                            checkOCR=False
                        Else
                            notifyuser=False
                        End If
                        doocs=False
                    End If
                Else
                    errortxt="archivierung(12b): Fehler: PDFtoTXT erzeugte keine Textdatei. Benutze jetzt Omnipage."
                    objWshShell.LogEvent 2, errortxt
                    doocs=True
                End If
            End If
            
            If doocs Then
                
                
                ocsseiten = countpages(tempname & ".tif")
                If ocsseiten = 1 Then
                    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"filterv3.exe"&Chr(34)&" "&Chr(34)&tempname&OCRHandle&Chr(34)&"  "&Chr(34)&programm&"tiff-pnm.txt"&Chr(34)&" "&Chr(34)&tempname&".pbm"&Chr(34),0,True)
                    
                    
                    
                    If lngReturnCode <> 0 Then
                        Err.clear
                        On Error Resume Next
                        errortxt="archivierung(15a): Fehler bei free OCR"
                        objWSHShell.LogEvent 1, errortxt
                        fs.DeleteFile tempname&".pbm", True
                        GetGarbage(tempname)
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If
                    If scriptdebug Then
                        objWSHShell.LogEvent 0,  Chr(34)&programm&"ocropus.bat"&Chr(34)&" "&Chr(34)&tempname&".pbm"&Chr(34)&" "&Chr(34)&tempname&".html"&Chr(34)
                    End If 
                    Set oExec = objWSHShell.Exec(Chr(34)&programm&"ocropus.bat"&Chr(34)&" "&Chr(34)&tempname&".pbm"&Chr(34)&" "&Chr(34)&tempname&".html"&Chr(34) )
                    
                    Do While Not oExec.StdOut.AtEndOfStream
                        strinput = strinput & oExec.StdOut.Read(1)	
                    Loop
                    
                    durch = False
                    schleife = 0
                    Do While schleife < 50
                        If oExec.Status = 1 Then 
                            durch = True
                            Exit Do
                        End If
                        
                        WScript.Sleep 100  
                        schleife = schleife +1
                    Loop
                    
                    If scriptdebug Then
                        objWSHShell.LogEvent 4,  strinput
                    End If 
                    If Not fs.FileExists(tempname&".html") Then
                        Err.clear
                        On Error Resume Next
                        errortxt="archivierung(15b): Fehler bei free OCR"
                        objWSHShell.LogEvent 1, errortxt
                        fs.DeleteFile tempname&".pbm", True
                        GetGarbage(tempname)
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If
                    fs.DeleteFile tempname&".pbm", True
                    
                    If False Then
                        objWSHShell.LogEvent 1,Chr(34)&programm&"cygpath.exe"&Chr(34)&" "&Chr(34)&tempname&Chr(34) 
                        Set oExec    = objWSHShell.Exec(Chr(34)&programm&"cygpath.exe"&Chr(34)&" "&Chr(34)&tempname&Chr(34))
                        
                        Do While Not oExec.StdOut.AtEndOfStream
                            strinput = strinput & oExec.StdOut.Read(1)	
                        Loop
                        strinput = Left(strinput,Len(strinput)-1)
                        
                    Else
                        strinput =tempname
                    End If 
                    If scriptdebug Then
                        objWSHShell.LogEvent 1,Chr(34)&programm&"lynx.bat"&Chr(34)&"  "&Chr(34)&strinput&".html"&Chr(34)&" "&Chr(34)&tempname&".txt"&Chr(34)
                    End If
                    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"lynx.bat"&Chr(34)&"  "&Chr(34)&strinput&".html"&Chr(34)&" "&Chr(34)&tempname&".txt"&Chr(34),0,True)
                    
                    
                    If lngReturnCode <> 0 Then
                        Err.clear
                        On Error Resume Next
                        errortxt="archivierung(15c): Fehler bei free OCR "&lngReturnCode
                        objWSHShell.LogEvent 1, errortxt
                        fs.DeleteFile strinput&".html", True
                        fs.DeleteFile tempname&".pbm", True
                        GetGarbage(tempname)
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If
                    fs.DeleteFile strinput&".html", True
                Else
                    doocsmultiple(tempname)
                End If
                
            End If
            Err.clear
            
        End If
        
        
        '************************************** Omnipage  ************************************
        '*************************************************************************************
        '*************************************************************************************
        
        If Typ = "OMP" Then
            If fs.FileExists(OCRname&".xjf") Then
                fs.DeleteFile OCRname&".xjf", True
                If Err.number <> 0 Then
                    objWshShell.LogEvent 1, "archivierung(16a): noch vorhandene .xjf nicht lschbar. 2. Prozess? ("&tempname&".xjf)"
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If
            End If
            If fs.FileExists(OCRname&"_0.dat") Then
                fs.DeleteFile OCRname&"_0.dat", True
                If Err.number <> 0 Then
                    objWshShell.LogEvent 1, "archivierung(16a): noch vorhandene .dat nicht lschbar. 2. Prozess? ("&tempname&"_0.dat)"
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If
            End If
            
            
            
            lngReturnCode = ocrcommand(OCRname)
            If lngReturnCode <> 0 Then
                objWSHShell.LogEvent 1, "archivierung(16): Fehler bei Anpassen .xjf Datei Omnipage ("&OCRname&")"
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
            
            '*********************** Bei fromdirect: ist Datei noch da oder schon verschoben? **************
            
            
            If (fs.fileexists(tempname&".msg")) Then
                fromdirect=False
                docschangeable=False
                If msgNRS=True Then
                    docschangeable=True
                End If
            End If
            
            If fs.fileexists(tempname&".eml") Then
                fromdirect=False
                docschangeable=False
                If emlNRS=True Then
                    docschangeable=True
                End If
            End If
            
            
           
            
            If changeling=True Then
                If quelle<>"" Then
                    iext= "." & fs.GetExtensionName(quelle)
                    Ausgabename = Replace(quelle,iext,"")
                    Schattenname=Ausgabename
                    change_ext_loc=True
                Else
                    If orginal<>"" Then
                        iext= "." & fs.GetExtensionName(orginal)
                        Ausgabename = Replace(orginal,iext,"")
                    Else
                        objWshShell.LogEvent 1, "archivierung(33b): Ausnahmefehler"
                        WScript.Quit
                    End If
                End If
            End If
            
            
            If fromdirect=True Then
                
                If orginal<>"" Then
                    iext= "." & fs.GetExtensionName(orginal)
                    Ausgabename = Replace(orginal,iext,"")
                    
                Else
                    objWshShell.LogEvent 1, "archivierung(33d): Ausnahmefehler"
                    WScript.Quit
                End If
                
            End If
            
            If ((fromdirect=True) Or (changeling=True)) And (fs.fileexists(Ausgabename&OCRHandle)=False) Then
                If scriptdebug=True Then
                    objWshShell.LogEvent 4, "Archivierung-debug: 426: "&Ausgabename&OCRHandle
                End If
                objWshShell.LogEvent 1, "Archivierung: Dokument bereits verschoben(1)."
                erfolg=aufraeumen(tempname)
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
            
            
            
            '*********************** jetzt Omnipage starten und Prozess + Ergebniss berwachen **************
            
            If scriptdebug=True Then
                objWshShell.LogEvent 4, "Archivierung-debug: 423: "&Ausgabename&OCRHandle
            End If
            
            goomnipage=True
            
            If (handle="pdf") And (extractPDF=True) Then
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"PDFtoTXT.bat"&Chr(34)&" "&Chr(34)&tempname&".pdf"&Chr(34),0,True)
                If lngReturnCode <> 0 Then
                    Err.clear
                    On Error Resume Next
                    errortxt="archivierung(12): Fehler bei PDFtoTXT."
                    objWshShell.LogEvent 1, errortxt
                    GetGarbage(tempname)   
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If
                If forcedomp=False Then
                	goomnipage=False
                End If
                If fs.fileexists(tempname&".txt") Then
                    deltext = False
                    Set pdftxtfile = fs.GetFile(tempname&".txt")
                    If pdftxtfile.Size < pdftextminsize Then
                        If scriptdebug=True Then
                            errortxt="archivierung(12b2): Fehler: PDFtoTXT erzeugte leere Textdatei. Benutze jetzt Omnipage."
                            objWshShell.LogEvent 1, errortxt
                        End If
                        goomnipage=True
                        deltext = True
                    Else
                        If pdftextverifyregex <> "" Then
                            
                            Set txtfile = fs.OpenTextFile(tempname&".txt",1)
                            pdftxt = txtfile.ReadAll
                            txtfile.Close
                            Set objRE = New RegExp
                            objRE.Global     = False    ' Nur eine bereinstimmung  (die erste)
                            objRE.IgnoreCase = False
                            objRE.Pattern    = pdftextverifyregex
                            
                            Set colMatches = objRE.Execute(pdftxt)
                            If colMatches.Count < 1 Then
                            	'MsgBox("verifytext")
                                If scriptdebug=True Then
                                    errortxt="archivierung(12b3): PDFtoTXT erzeugt Volltext, der nicht den Richtlinien entpspricht (pdftextverifyregex matcht nicht)."
                                    objWshShell.LogEvent 1, errortxt
                                End If
                                goomnipage=True
                                deltext = True
                            End If
                            
                        Else
                            If notifyuser=False Then
                                checkOCR=False
                            Else
                                notifyuser=False
                            End If
                        End If
                    End If
                    Set pdftxtfile = Nothing
                    If deltext = True Then
                    	fs.DeleteFile(tempname&".txt")
                    End If
                Else
                    errortxt="archivierung(12b): Fehler: PDFtoTXT erzeugte keine Textdatei. Benutze jetzt Omnipage."
                    objWshShell.LogEvent 1, errortxt
                    goomnipage=True
                End If
            End If
            
            
            If goomnipage=True Then
                If (handle="pdf") Then
                    
                    
                    
                    
                    ' prfen, ob das ocr-tif in 300dpi/greyscale vorliegt.
                    cmdcp = Chr(34)&programm&"CountPages.exe " & Chr(34) & " " & Chr(34) & tempname & ".tif" & Chr(34)
    
				    Set oExec = objWSHShell.Exec(cmdcp)
				    strinput = ""
				    sTemp = ""
				    tpages = -1
				    tcolorDepth = -1
				    tdpiX = -1
				    tdpiY = -1
				    tcompression = ""
				    Do While Not oExec.StdOut.AtEndOfStream
				        strinput = oExec.StdOut.ReadLine
				        If InStr(strinput, "Anzahl Seiten:") Then
				            tpages = CInt(Right(strInput, Len(strinput)-14))
				        End If
				        If InStr(strinput, "Farbtiefe:") Then
				            tcolorDepth = CInt(Right(strinput, Len(strinput)-10))
				            'Damit auch 4 Bit Graustufentifs verarbeitet werden
				            
				        End If
				        If InStr(strinput, "DPI:") Then
				            sTemp = Right(strinput, Len(strinput)-4)
				            tdpiX = CInt(Left(sTemp, InStr(sTemp, "x") - 2))
				            tdpiY = CInt(Right(sTemp, Len(stemp) - InStr(sTemp, "x") - 1))
				        End If
				        If InStr(strinput, "Kompression:") Then
				            tcompression = Right(strinput, Len(strinput)-13)
				        End If
				    Loop
				    If tcolorDepth < 8 Then
				    	objWSHShell.LogEvent 4, "archivierung.vbs: ocr-Voransicht nicht optimal, neu in Graustufen rendern"
				        rerender = True
				    Else
				    	rerender = False
				    End If
                    
                    ' hier maxpdfpages gegenprfen, damit wir die OCR nicht auf die beschnittene Voransicht machen, auch ausfhren wenn wir rendern mssen.
                    If maxpdfpages > 0 And maxpdfpages < 1000 Or rerender=True Then
                        ' bfa_pdf2tif mit Graustufen und resolution 300
                        
                        
                    	cmd = Chr(34)&programm&"bfa_pdf2tif.exe " & Chr(34) & " -i " & Chr(34) & tempname & ".pdf" & Chr(34) & " -o " & Chr(34) & tempname & ".tif" & Chr(34) & " -d tiffgray -r 300"
                        
                        If scriptdebug = True Then
                            objWSHShell.LogEvent 4, "archivierung.vbs: bfa_pdf2tif Aufruf (fr pdf-ocr):"&vbCrLf&cmd
                        End If
                        
                        
                        ' Anzahl der PDF-Seiten ermitteln
                        If ((fs.fileexists(programm&"pdfinfo.bat")) And (fs.fileexists(programm&"pdfinfo.exe"))) Then
                            pdfpages=0
                            zaehler=0
                            strinput=""
                            If scriptdebug = True Then
                                objWshShell.LogEvent 4, "Archivierung: starte PDFInfo.exe"
                            End If
                            pdfcmd = Chr(34)&programm&"pdfinfo.bat"&Chr(34)&" "&Chr(34)&tempname&".pdf"&Chr(34)&" "&Chr(34)&tempname&".pdi"&Chr(34)
                            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"pdfinfo.bat"&Chr(34)&" "&Chr(34)&tempname&".pdf"&Chr(34)&" "&Chr(34)&tempname&".pdi"&Chr(34),0,True)
                            WScript.Sleep 1000
                            errn = Err.number
                            If fs.fileexists(tempname&".pdi") Then
                                Set quellswfile = fs.OpenTextFile(tempname&".pdi",1)
                                strinput = ""
                                Do While quellswfile.AtEndOfStream <> True
                                    strinput=strinput+quellswfile.readline&vbCrLf
                                Loop
                                quellswfile.close
                                Set quellswfile = Nothing
                                fs.deletefile tempname&".pdi",True
                            End If
                            
                            
                            If InStr(1,strinput, "Pages:",1) <> 0 Then	
                                pos = InStr(1,strinput, "Pages:",1) +6
                                pos2 = InStr(pos,strinput, vbCrLf) 
                                pages = Mid(strinput, pos, pos2 - pos)
                                pdfpages = CInt(Trim(pages))
                            End If
                        Else
                            pdfpages = 1000
                        End If
                        
                        If pdfpages > maxpdfpages Or rerender=True Then
	                        lngReturnCode = objWSHShell.Run(cmd,0,False)
	                        ' timeout anhand der Seitenanzahl ermitteln
	                        timeout = 2 * pdfpages + 30 ' 2 Sekunden pro Seite + overhead
	                        ret = timeoutprocess("bfa_pdf2tif.exe", timeout)
	                        If ret = True Then
	                            erfolg=False
	                            objWSHShell.LogEvent 1, "archivierung.vbs: bfa_pdf2tif.exe timeout!"
	                        End If
	                    End If
                        
                        
                        
                    End If
                End If
                
                If Err.number <> 0 Then
                	objWSHShell.LogEvent 1, "archivierung.vbs debug: current error " & err.number & vbCrLf & err.Description
                	err.Clear
                End If
                
                If fs.FileExists(tempname&".txt") Then
	            	If fs.FileExists(tempname&".ttxt") Then
					    fs.DeleteFile tempname&".ttxt", True
					End If 
					
					If Err.number <> 0 Then
					    objWshShell.LogEvent 1, "archivierung(16a-1): noch vorhandene .ttxt nicht lschbar. ("&tempname&".ttxt)"
						objWSHShell.LogEvent 1, "archivierung.vbs (16a-2) debug: error " & err.number & vbCrLf & err.Description
						err.Clear
					End If
					
	            	If forcedomp=True Then
	            		fs.MoveFile tempname&".txt", tempname&".ttxt"
	            	Else
	                	fs.DeleteFile tempname&".txt", True
	                End If
	                If Err.number <> 0 Then
	                    objWshShell.LogEvent 1, "archivierung(16a): noch vorhandene .txt nicht lschbar. 2. Prozess? ("&tempname&".txt)"
	                    objWSHShell.LogEvent 1, "archivierung.vbs (16b) debug: error " & err.number & vbCrLf & err.Description
	                    err.Clear
	                    WScript.Sleep 1000
	                    objWSHShell.LogEvent 1, "archivierung.vbs (16c) debug: starte zweiten Lschversuch"
	                    If forcedomp=True Then
		            		fs.MoveFile tempname&".txt", tempname&".ttxt"
		            	Else
		                	fs.DeleteFile tempname&".txt", True
		                End If
		                If err.number <> 0 Then
		                	objWSHShell.LogEvent 1, "archivierung.vbs (16d) debug: zweiter Lschversuch nicht erfolgreich. error " & err.number & vbCrLf & err.Description
	                    	Unlock(programm&lockdatei)
	                    	WScript.Quit
	                    Else
	                    	objWSHShell.LogEvent 1, "archivierung.vbs (16e) debug: zweiter Lschversuch erfolgreich"
	                    End if
	                End If
	            End If
                
                runOmnipage
                'hier ist notifyuser True, wenn kein Volltext erzeugt wurde
                If Not ompdontcomparetxt Then
                    If fs.FileExists(ocrname&".txt")= True  Then
                        If (ocrstatistik(ocrname&".txt")=False) And (typ<>"TXT") Then
                            fs.CopyFile ocrname&".txt", ocrname&"a.txt", True
                            waitdirect()
                            runOmnipage
                            
                            If fs.FileExists(ocrname&".txt")= True  Then	
                                If (ocrstatistik(ocrname&".txt")=False) And (typ<>"TXT") Then
                                    
                                    pruefa=pruefsumme(ocrname&"a.txt")
                                    pruefb=pruefsumme(ocrname&".txt")
                                    If pruefb <> pruefa Then
                                        fs.CopyFile ocrname&".txt", ocrname&"b.txt", True
                                        waitdirect()
                                        runOmnipage
                                        If fs.FileExists(ocrname&".txt")= True  Then
                                            If (ocrstatistik(ocrname&".txt")=False) And (typ<>"TXT") Then
                                                
                                                'objWshShell.LogEvent 2, "archivierung: Schlechte OCR-Statistik fr "&Ausgabename
                                                fs.DeleteFile(ocrname&"a.txt")
                                                fs.DeleteFile(ocrname&"b.txt")
                                            Else	
                                                If notifyuser=False Then
                                                    checkOCR=False
                                                Else
                                                    notifyuser=False
                                                End If
                                                fs.DeleteFile(ocrname&"a.txt")
                                                fs.DeleteFile(ocrname&"b.txt")
                                            End If
                                        End If	
                                    Else
                                        If notifyuser=False Then
                                            checkOCR=False
                                        Else
                                            notifyuser=False
                                        End If
                                        fs.DeleteFile(ocrname&"a.txt")
                                    End If
                                    
                                Else
                                    If notifyuser=False Then
                                        checkOCR=False
                                    Else
                                        notifyuser=False
                                    End If
                                    fs.DeleteFile(ocrname&"a.txt")
                                End If
                            End If
                        Else
                            If notifyuser=False Then
                                checkOCR=False
                            Else
                                notifyuser=False
                            End If
                        End If
                    End If
                Else
                    If notifyuser=False Then
                        checkOCR=False
                    End If
                End If  
                
                
                If (ocrname<>tempname) And (typ<>"TXT") Then
                    fs.copyfile ocrname&".txt", tempname&".txt", True
                End If
            Else
                If notifyuser=False Then
                    checkOCR=False
                End If
            End If
            
            
        End If
        
    End If
    
    If forcedomp=True And fs.FileExists(tempname&".ttxt") Then
    	If fs.FileExists(tempname&".txt") Then
    		fs.DeleteFile tempname&".txt",True 
    	End If
    	fs.MoveFile tempname&".ttxt", tempname&".txt"
    	
    	
    	If normftx=True Then
            If fs.fileexists(tempname&".txt") Then	
                
                Set quelltxtfile = fs.OpenTextFile(tempname&".txt",1)
                
                If Err.number<>0 Then
                    Err.clear
                    On Error Resume Next
                    errortxt="archivierung(17h): kann txt-datei nicht ffnen ("&tempname&".txt). "&Err.number	
                    objWshShell.LogEvent 1, errortxt
                    GetGarbage(tempname)
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If
                
                
                Set zieltxtfile = fs.OpenTextFile(tempname&".ztd",8,True)
                
                If Err.number<>0 Then
                    Err.clear
                    On Error Resume Next
                    errortxt="archivierung(17h): kann txt-datei nicht erstellen ("&tempname&".ztd). "&Err.number	
                    objWshShell.LogEvent 1, errortxt
                    GetGarbage(tempname)
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If
                
                Do While quelltxtfile.AtEndOfStream <> True
                    kette=normstring(quelltxtfile.ReadLine)
                    zieltxtfile.WriteLine(kette)
                    
                Loop
                
                zieltxtfile.close
                quelltxtfile.close
                
                Set zieltxtfile = Nothing
                Set quelltxtfile = Nothing
                Err.clear
                WScript.Sleep 50
                
                Set attribhandle=fs.GetFile(tempname&".txt")
                attribhandle.Attributes=attribhandle.Attributes And Not 1
                
                Set attribhandle=Nothing
                
                WScript.sleep 50
                
                fs.deletefile tempname&".txt", True
                
                WScript.Sleep 100
                fs.copyfile tempname&".ztd", tempname&".txt", True
                WScript.Sleep 100
                fs.deletefile tempname&".ztd", True
                If Err.number<>0 Then
                    Err.clear
                    On Error Resume Next
                    errortxt="archivierung(17i): Fehler nach Textdateifilterung"
                    objWshShell.LogEvent 1, errortxt
                    GetGarbage(tempname)
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If
                
                
            End If
        End If
    	
    	
    	
    End If
    perfadd("ocr")
    
    '**********************************************************************************
    '*************************      Volltext Pagebreaks         ***********************
    '**********************************************************************************         
    If fs.FileExists(programm & "bfa_add_pagebreaks.exe") And fs.FileExists(tempname & ".txt") And fs.FileExists(tempname & ".ocr_xml") And ftxaddpagebreaks <> False And ftxaddpagebreaks <> "" And usetesseract <> True Then
    	Set textfile = fs.GetFile(tempname & ".txt")
    	If textfile.Size>0 Then
    		pbstring = Replace(ftxaddpagebreaks, "\\r", "\r")
    		pbstring = Replace(pbstring, "\\n", "\n")
	    	cmd=Chr(34)&programm &"bfa_add_pagebreaks.exe"& Chr(34)&" -o " & Chr(34)&tempname&".txt"&Chr(34) & " " & Chr(34)&tempname&".ocr_xml"&Chr(34) & " " & Chr(34)&tempname&".txt"&Chr(34) & " " & Chr(34) & pbstring & Chr(34) 
	        Set oExec = objWSHShell.Exec(cmd)
	        strinput=""
	        Do While Not oExec.StdOut.AtEndOfStream
	            strinput = strinput & oExec.StdOut.ReadAll
	        Loop                    
		End If
    End If
    
    
    
    If handle="unbekannt" Then
        If Not fs.fileexists(tempname&".tif") Then	
            makefilltif(tempname)
        End If
    End If
    
    
    '*********************************************************************************
    '****************************  Textfilter  ***************************************
    '*********************************************************************************
    
    If isdirect = False Then
	    If ((Typ="TXT") Or (Typ="MAN") Or (goomnipage=False)) And extension <> ".txt" Then
	        If notifyuser=False Then
	            checkOCR=False
	        Else
	            If alertonemptydoctxt=True Then
	                emptydoctxt=True
	            Else
	                checkOCR=False
	                notifyuser=False
	            End If    
	            
	            
	            
	        End If 	
	        If normftx=True Then
	            If fs.fileexists(tempname&".txt") Then	
	                
	                Set quelltxtfile = fs.OpenTextFile(tempname&".txt",1)
	                
	                If Err.number<>0 Then
	                    Err.clear
	                    On Error Resume Next
	                    errortxt="archivierung(17h): kann txt-datei nicht ffnen ("&tempname&".txt). "&Err.number	
	                    objWshShell.LogEvent 1, errortxt
	                    GetGarbage(tempname)
	                    Unlock(programm&lockdatei)
	                    WScript.Quit
	                End If
	                
	                
	                Set zieltxtfile = fs.OpenTextFile(tempname&".ztd",8,True)
	                
	                If Err.number<>0 Then
	                    Err.clear
	                    On Error Resume Next
	                    errortxt="archivierung(17h): kann txt-datei nicht erstellen ("&tempname&".ztd). "&Err.number	
	                    objWshShell.LogEvent 1, errortxt
	                    GetGarbage(tempname)
	                    Unlock(programm&lockdatei)
	                    WScript.Quit
	                End If
	                
	                Do While quelltxtfile.AtEndOfStream <> True
	                    kette=normstring(quelltxtfile.ReadLine)
	                    zieltxtfile.WriteLine(kette)
	                    
	                Loop
	                
	                zieltxtfile.close
	                quelltxtfile.close
	                
	                Set zieltxtfile = Nothing
	                Set quelltxtfile = Nothing
	                Err.clear
	                WScript.Sleep 50
	                
	                Set attribhandle=fs.GetFile(tempname&".txt")
	                attribhandle.Attributes=attribhandle.Attributes And Not 1
	                
	                Set attribhandle=Nothing
	                
	                WScript.sleep 50
	                
	                fs.deletefile tempname&".txt", True
	                
	                WScript.Sleep 100
	                fs.copyfile tempname&".ztd", tempname&".txt", True
	                WScript.Sleep 100
	                fs.deletefile tempname&".ztd", True
	                If Err.number<>0 Then
	                    Err.clear
	                    On Error Resume Next
	                    errortxt="archivierung(17i): Fehler nach Textdateifilterung"
	                    objWshShell.LogEvent 1, errortxt
	                    GetGarbage(tempname)
	                    Unlock(programm&lockdatei)
	                    WScript.Quit
	                End If
	                
	                
	            End If
	        End If
	        
	    End If
    End If
    
    If scriptdebug=True Then
        objWshShell.LogEvent 4, "Archivierung-debug: 424: "&Ausgabename&OCRHandle
    End If
    
    
    '**********************************************************************************
    '****************** ftx und txt zusammenfhren vor der sorting und naming Funktion  ***********
    
    If fs.FileExists(tempname & ".ftx") And isdirect=False Then
        Set quelltxtfile = fs.OpenTextFile(tempname&".ftx",1)
        If fs.FileExists(tempname & ".txt") Then
            Set zieltxtfile = fs.OpenTextFile(tempname&".txt",8)
        Else
            Set zieltxtfile = fs.CreateTextFile(tempname&".txt",True)
        End If
        
        If Err.number<>0 Then
            Err.clear	
            On Error Resume Next
            errortxt="archivierung(42): kann txt-datei nicht ffnen. bzw erstellen" & vbCrLf & tempname & vbCrLf & Err.Number & vbTab & Err.Description
            objWshShell.LogEvent 1, errortxt
            GetGarbage(tempname)
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
        
        Do While quelltxtfile.AtEndOfStream <> True
            If normftx=True Then
                kette=normstring(quelltxtfile.ReadLine)
            Else
                kette=quelltxtfile.ReadLine
            End If
            zieltxtfile.WriteLine(kette&" ")
        Loop
        
        quelltxtfile.Close	
        zieltxtfile.close
        If Err.Number = 0 Then
            
            fs.DeleteFile(tempname & ".ftx"), True
            If Err.Number Then
                objWSHShell.LogEvent 1, "konnte .ftx-Datei nicht nach dem Mergen mit .txt lschen" & vbCrLf & tempname & vbCrLf & Err.Number & vbTab & Err.Description
            End If
        End If
        
        WScript.Sleep 200
    End If
    perfadd("textfilter + ftx und txt")
    
    '**********************************************************************************
    '***************************       Barcodes lesen      ****************************
    '**********************************************************************************
    
    
    barcodecomplete=False
    If fs.fileexists(tempname&".slw") Then
        Set swfile=fs.OpenTextFile(tempname&".slw",1)
        bccount = -1 
        Do While swfile.atendofstream=False
            kette=swfile.readline
            If InStr(1,kette,"Message:BarcodeRead=Complete",1)<>0 Then
                barcodecomplete=True
            End If
            If InStr(1,kette,"Barcode:",1)<>0 Then
                mybarcode=""
                If (Len(kette)-8)>0 Then
                    mybarcode=Right(kette,Len(kette)-8)
                End If
                If mybarcode<>"" Then
                    bccount = bccount + 1
                    gefunden=False
                    i=0
                    Do While gefunden=False
                        If barcode(i)="" Then
                            gefunden=True
                        End If
                        If gefunden=False Then
                            i=i+1
                        End If
                        If i>29 Then
                            i=29
                            gefunden=True
                        End If
                    Loop
                    barcode(i)=mybarcode
                    
                    ' Barcode ins Zusatzfeldarray bernehmen
                    gefunden=False
                    p=0
                    Do While gefunden=False
                        If zusatzfeldname(p)="" Then
                            gefunden=True
                            zusatzfeldname(p)="barcode"&bccount
                            zusatzfeld(p)=mybarcode
                        End If
                        If gefunden=False Then
                            p=p+1
                        End If
                        If p=limit Then
                            gefunden=True
                        End If
                    Loop
                    
                End If
            End If
        Loop
        swfile.close
        Set swfile=Nothing
    End If
    
    
    If ((readbarcodes=True) Or (InStr(Filtermakro, "readbarcodes")<>0)) And ((barcodecomplete=False) And (isdirect=False)) Then
        If eymbcrdcmdpath <> "" Then
            erfolg = runeymbcrdcmd(tempname)
        ElseIf bcpluspath <>"" Then	
            erfolg = runbcplus(tempname)
        Else
            erfolg=runbarcode(tempname)
        End If
    End If
    
    
    
    '**********************************************************************************
    '***************************     Prfen auf Dubletten    **************************
    '**********************************************************************************
    
    perfadd("barcode")
    If (tabelle <> "workflow") And (dublettenpruefung = True) And (handle = "") And (fromdirect=False) And (changeling=False) Then 
        
        
        dublettengarbage=True
        If istschonarchiviert(tempname) = True Then
            dublettengarbage=True
            Tabelle = "noarch"
        Else
            dublettengarbage=False
        End If
    End If 
    perfadd("Dubletten")
    '**********************************************************************************
    '***************************     Kopieren in Archiv      **************************
    '**********************************************************************************
    
    If scriptdebug = True Then
        objWshShell.LogEvent 0, "Archivierung-Debug - Kopieren ins Archiv" & tempname &vbCrLf& "Tabelle=" & Tabelle &vbCrLf& "extraskip=" & extraskip 
    End If
    
    
    
    If fs.fileexists(tempname&".msg") Then
        'changeling=false
        fromdirect=False
        docschangeable=False
        If msgNRS=True Then
            docschangeable=True
        End If
        extension=".msg"
        handle="Outlook"
    End If
    
    
    If fs.fileexists(tempname&".eml") Then
        'changeling=false
        fromdirect=False
        docschangeable=False
        If emlNRS=True Then
            docschangeable=True
        End If
        extension=".eml"
    End If
    

    
    If tabelle <> "workflow" Then '######################
        If extraskip = False Then'****************************
            
            If Tabelle<>"noarch" Then'++++++++++++++++++++++++++++
                
                '**********************************************************************************
                '***************************    ggf. einsortieren    ******************************
                '**********************************************************************************
                If (changeling=False) And (fromdirect=False) Then

                    redirect_Attachments
                    perfadd("redirect_Attachments")
                    If isdirect=False Then
                    	sorting()
                    	perfadd("sorting")
                    End If

                    'Das Tif auf richtlinienkonformitt prfen und abarbeiten,
                    'ggf. Kleinrechnen etc. Wird keine Richtline gefunden dann warnung und Garbage
                    If InStr(LCase(directiveextensions), LCase(extension)) <> 0 Then
                        'Funktion soll nur ausgefhrt werden, wenn Richtliniendatei auch existiert
                        If fs.FileExists(programm & "Directives.ini") Then
                        	If fs.FileExists(tempname & "-archiv.tif") Then
                        		handledirective tabelle, tempname & "-archiv.tif"
                        	Elseif fs.FileExists(tempname & ".tif") Then
                        		handledirective tabelle, tempname & ".tif"
                        	Else
								objWshShell.LogEvent 1, "archivierung.vbs: Kein Tif fr Tif-Richtlinien-Auswertung gefunden" 
                        	End If
                        End If              
                    End If
                    '/PDB>
                    perfadd("TifRichtlinie")
                    
                End If
                
                '**********************************************************************************
                '***************************    Verzeichnisse im Archiv anlegen    ****************
                '**********************************************************************************
                
                
                ' 3.6 Archivverzeichnis + Kopie kommen aus stores und archive_rs / archive_nrs, Pfade werden direkt nach readconfig zusammengebaut
                If Not fs.FolderExists(archivverzeichnis) Then
                    Set tes1 = fs.CreateFolder(archivverzeichnis)
                    Set tes1 = Nothing
                    WScript.sleep 200
                    If Err.number<>0 Then
                        objWshShell.LogEvent 1, "archivierung(0): kann archivverzeichnis-verzeichnis nicht erstellen - Berechtigung?"  & vbCrLf & archivverzeichnis & vbCrLf & Err.Number& vbCrLf & Err.Description
                        Err.clear
                        On Error Resume Next
                        getgarbage(tempname)
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If 
                    
                    If Not fs.FolderExists(archivverzeichnis) Then
                        objWshShell.LogEvent 1, "archivierung(0b): kann archivverzeichnis-verzeichnis nicht erstellen (2) - Berechtigung?"
                        getgarbage(tempname)
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If
                End If
                
                If Not fs.FolderExists(archivkopie) Then
                    Set tes1 = fs.CreateFolder(archivkopie)
                    Set tes1 = Nothing
                    WScript.sleep 200
                    If Err.number<>0 Then
                        objWshShell.LogEvent 1, "archivierung(0): kann archivkopie-verzeichnis nicht erstellen - Berechtigung?"
                        Err.clear
                        On Error Resume Next
                        getgarbage(tempname)
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If 
                    
                    If Not fs.FolderExists(archivkopie) Then
                        objWshShell.LogEvent 1, "archivierung(0b): kann archivkopie-verzeichnis nicht erstellen (2) - Berechtigung?"
                        getgarbage(tempname)
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If
                    
                    
                End If
                
                Jahr = DatePart("yyyy",Date)
                Monat = DatePart("m",Date)
                Tag = DatePart("d",Date)
                Stunde = DatePart("h",Time)
                Minuten = DatePart("n",Time)
                Sekunde = DatePart("s", Time)
                Mikrosekunden = DatePart("s", Time)
                datum = Jahr&"-" & Monat & "-" & Tag & "--" & Stunde & "-" & Minuten & "-" & Sekunde
                
                Jahrwert=Jahr - 2000
                hostname = UCase(objWSHShell.ExpandEnvironmentStrings("%computername%"))
                zahl = Zufallszahl(10000000,99999999)
                documentID=Jahrwert&Monat&Tag&Stunde&Minuten&Sekunde&hostname&zahl
                
                
                
                ' neue Ablagestrultur: <store>\<rs/nrs>\<Jahr>\<Monat>\<Tag>\<timestamp als Dateiname>.
                ' Unterordner fr Jahr, Monat und Tag checken, ggfs. anlegen 

                If Len(CStr(Tag)) < 2 Then
                	Tag = "0" & Tag
               	End If
                If Len(CStr(Monat)) < 2 Then
                	Monat = "0" & Monat
                End If	
                ' Jahres-Ordner
                tempAusgabeverzeichnis = archivverzeichnis & Jahr
                tempSchattenverzeichnis = archivkopie & Jahr
                
                Err.Clear
                If Not fs.FolderExists(tempAusgabeverzeichnis) Then
                	fs.CreateFolder(tempAusgabeverzeichnis)
                	If Err.number<>0 Then
                        objWshShell.LogEvent 1, "archivierung(0): kann Ausgabeverzeichnis nicht erstellen - Berechtigung?"  & vbCrLf & tempAusgabeverzeichnis
                        Err.clear
                        On Error Resume Next
                        WScript.Quit
                    End If 
                End If
                
                If Not fs.FolderExists(tempSchattenverzeichnis) Then
                	fs.CreateFolder(tempSchattenverzeichnis)
                	If Err.number<>0 Then
                        objWshShell.LogEvent 1, "archivierung(0): kann Ausgabeverzeichnis nicht erstellen - Berechtigung?"  & vbCrLf & tempSchattenverzeichnis
                        Err.clear
                        On Error Resume Next
                        WScript.Quit
                    End If 
                End If
                
                
                ' Monats-Ordner
                tempAusgabeverzeichnis = tempAusgabeverzeichnis & "\" & Monat
                tempSchattenverzeichnis = tempSchattenverzeichnis & "\" & Monat
                
                If Not fs.FolderExists(tempAusgabeverzeichnis) Then
                	fs.CreateFolder(tempAusgabeverzeichnis)
                	If Err.number<>0 Then
                        objWshShell.LogEvent 1, "archivierung(0): kann Ausgabeverzeichnis nicht erstellen - Berechtigung?"  & vbCrLf & tempAusgabeverzeichnis
                        Err.clear
                        On Error Resume Next
                        WScript.Quit
                    End If 
                End If
                
                If Not fs.FolderExists(tempSchattenverzeichnis) Then
                	fs.CreateFolder(tempSchattenverzeichnis)
                	If Err.number<>0 Then
                        objWshShell.LogEvent 1, "archivierung(0): kann Ausgabeverzeichnis nicht erstellen - Berechtigung?"  & vbCrLf & tempSchattenverzeichnis
                        Err.clear
                        On Error Resume Next
                        WScript.Quit
                    End If 
                End If
                
                
                ' Tages-Ordner
                tempAusgabeverzeichnis = tempAusgabeverzeichnis & "\" & Tag
                tempSchattenverzeichnis = tempSchattenverzeichnis & "\" & Tag
                
                If Not fs.FolderExists(tempAusgabeverzeichnis) Then
                	fs.CreateFolder(tempAusgabeverzeichnis)
                	If Err.number<>0 Then
                        objWshShell.LogEvent 1, "archivierung(0): kann Ausgabeverzeichnis nicht erstellen - Berechtigung?"  & vbCrLf & tempAusgabeverzeichnis
                        Err.clear
                        On Error Resume Next
                        WScript.Quit
                    End If 
                End If
                
                If Not fs.FolderExists(tempSchattenverzeichnis) Then
                	fs.CreateFolder(tempSchattenverzeichnis)
                	If Err.number<>0 Then
                        objWshShell.LogEvent 1, "archivierung(0): kann Ausgabeverzeichnis nicht erstellen - Berechtigung?"  & vbCrLf & tempSchattenverzeichnis
                        Err.clear
                        On Error Resume Next
                        WScript.Quit
                    End If 
                End If
                

                
                Ausgabeverzeichnis = tempAusgabeverzeichnis & "\"
                schattenverzeichnis = tempSchattenverzeichnis & "\"
               
                '**********************************************************************************
                '*****************************   Freien Slot finden        ************************
                '**********************************************************************************
                If (changeling=False) And (fromdirect=False) Then
                	Ausgabename =  Ausgabeverzeichnis&documentID
                    schattenname = schattenverzeichnis&documentID
                    
                	While findnameindir(documentID, Ausgabeverzeichnis) = True
                        zahl = Zufallszahl(10000000,99999999)
                        documentID=Jahrwert&Monat&Tag&Stunde&Minuten&Sekunde&hostname&zahl
                        Ausgabename =  Ausgabeverzeichnis&documentID
                        schattenname = schattenverzeichnis&documentID
                    Wend

                    If fs.fileexists(Ausgabename&".tif") Then
                        zahl = Zufallszahl(10000000,99999999)
						documentID=Jahrwert&Monat&Tag&Stunde&Minuten&Sekunde&hostname&zahl
                        Ausgabename =  Ausgabeverzeichnis&documentID
                        schattenname = schattenverzeichnis&documentID
                    End If                 
                End If
                
                If changeling=True Then
                    
                    If quelle<>"" Then
                        iext= "." & fs.GetExtensionName(quelle)
                        Ausgabename = Replace(quelle,iext,"")
                        Schattenname=Ausgabename
                        change_ext_loc=True
                    Else
                        If orginal<>"" Then
                            iext= "." & fs.GetExtensionName(orginal)
                            Ausgabename = Replace(orginal,iext,"")
                        Else
                            objWshShell.LogEvent 1, "archivierung(33b): Ausnahmefehler"
                            WScript.Quit
                        End If
                    End If
                    
                    
                End If
                
                If fromdirect=True Then
                    
                    If orginal<>"" Then
                        iext= "." & fs.GetExtensionName(orginal)
                        Ausgabename = Replace(orginal,iext,"")
                    Else
                        objWshShell.LogEvent 1, "archivierung(33c): Ausnahmefehler"
                        WScript.Quit
                    End If
                    
                End If
                
                

                '**********************************************************************************
                '**********************************************************************************
                
                
                If Not fs.FileExists(tempname&".txt") Then
                    Err.clear
                    
                    Set nottextfile = fs.CreateTextFile(tempname&".txt",True)
                    If Err.number<>0 Then
                        Err.clear
                        On Error Resume Next
                        errortxt="bitfarm-archiv: archivierung(18): kann keine Dummy-Textdatei erstellen ->Garbage"
                        objWshShell.LogEvent 1, errortxt
                        GetGarbage(tempname)
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If
                    nottextfile.writeline()
                    nottextfile.writeline()
                    nottextfile.close
                    Set nottextfile=Nothing

                    
                End If
                Err.clear
                
                If extrajob <> "" Then
                    Ausgabename = extrajob
                End If
                
                If extrajob = "" Then'-------------------
                    If Not fs.FolderExists(Ausgabeverzeichnis) Then
                        Set test = fs.CreateFolder(Ausgabeverzeichnis)
                        Set test = Nothing
                        
                        WScript.sleep 200
                        If Err.number<>0 Then
                            objWshShell.LogEvent 1, "archivierung(0): kann Ausgabeverzeichnis nicht erstellen - Berechtigung?"  & vbCrLf & Ausgabeverzeichnis
                            Err.clear
                            On Error Resume Next
                            
                        End If 
                    End If
                    
                    If schattenarchiv=True Then
                        If Not fs.FolderExists(schattenverzeichnis) Then
                            Set test = fs.CreateFolder(schattenverzeichnis)
                            Set test = Nothing
                            
                            WScript.sleep 200
                            If Err.number<>0 Then
                                objWshShell.LogEvent 1, "archivierung(0): kann schattenverzeichnis-verzeichnis nicht erstellen - Berechtigung?" & vbCrLf & schattenverzeichnis
                                Err.clear
                                On Error Resume Next
                                
                            End If 
                        End If
                        

                        
                    End If 
                    
                    
                    perfadd("Archivablage")
                    '**********************************************************************************
                    '******************************  Displayname festlegen  ***************************
                    '****************************** Hintergrundbild einkopieren ***********************
                    '**********************************************************************************
                    waitdirect()
                    
                    
                    '**********************************************************************************
                    '***********************************  Exif-Daten bei JPG **************************
                    '**********************************************************************************
                    
                    If extension=".jpg" Then                  

                        readexif()
                     
                    End If
                    
                    perfadd("readexif")
                    '**********************************************************************************
                    '***********************************  /Exif-Daten bei JPG *************************
                    '**********************************************************************************
                    
                    If isdirect=False Then
	                    If earlyusing=True Then
	                        using()
	                    End If
	                    myname2=myname
	                    
	                    myname=naming()
	                    perfadd("naming")
	                    
	                    
	                    If ((myname="") Or (myname="Dokument")) And (myname2<>"") Then
	                        myname=myname2
	                    End If
	                 End If
                    
                    '############################################  Zusatzfelder und schlagwrter normieren
                    
                    
                    For x = 0 To limit
                        If zusatzfeld(x)<>"" Then zusatzfeld(x) = NormZusatzfeld(zusatzfeld(x))
                        
                    Next	
                    
                    For i=0 To 59
                        If FileInfoValue(i)<>"" Then FileInfoValue(i) = NormZusatzfeld(FileInfoValue(i))
                        If Schlagworte(i)<>"" Then Schlagworte(i) = NormZusatzfeld(Schlagworte(i))
                    Next
                                      
                    
                    autoschlagwort()

                    
                    ' Wenn bereits eine Rotation vorgegeben wurde muss pdfAutoRotate abgeschaltet werden!
                    If docrotation <> "" And docrotation <> "0" Then
                        pdfAutoRotate = False
                    End If
                    
                    AddSWFileInfo(tempname)
                    
                    If rotatePDF And pdfAutoRotate Then
                        docrotation="270"
                        rotatetif(tempname&"-archiv")
                        docrotation = ""
                    End If
                    
                    perfadd("autoschlagwort + AddSWFileInfo")
                    
                    '**********************************************************************************
                    '***********************************  Variablen mappen ****************************
                    '**********************************************************************************
                    using()
                    perfadd("using")

             
                    writejob(tempname)
                           
                    
                    '**********************************************************************************
                    '******************** letzte Namensbearbeitung und -speicherung *******************
                    '**********************************************************************************
                    
                    If (fromEmail=True) And ((LCase(myname)="dokument") Or (myname="")) Then
                        If extension=".eml" Or extension = ".msg" Then
                            If betreff = "" Then
                                datumsstring=""
                                If empfangsdatum <> "" And empfangsuhrzeit <> "" Then
                                    datumsstring = empfangsdatum&"_"&empfangsuhrzeit
                                ElseIf versanddatum <> "" And versanduhrzeit <> "" Then
                                    datumsstring = versanddatum&"_"&versanduhrzeit
                                End If
                                myname = "E-mail vom "&datumsstring
                            Else
                                myname = "E-mail: " & betreff              
                            End If 
                        Else 
                            myname = "Anlage zur E-mail"
                        End If
                    End If
                    If (BFADocName<>"") And ((LCase(myname)="dokument") Or (myname="")) Then
                        myname=BFADocName
                    End If
                    
                    setdocname(tempname&extension)
                    
                    

                    
                    '**********************************************************************************
                    '**************** Informationen noch in Schlagwortdatei speichern *****************
                    '**********************************************************************************
                    
                    
                    writeschlagwort(tempname)
                    
                    perfadd("writeschlagwort")
                    '**********************************************************************************
                    '*************************************  ggf. Dokument drehen***********************
                    '**********************************************************************************
                    
                    If (docrotation<>"") And (fromdirect=False) Then
                        rotatetif(archivtif)
                    End If
                    perfadd("archivtif")
                    writeworkflowinfo()
                    perfadd("writeworkflowinfo")
                    
                    '**********************************************************************************
                    '**********************************************************************************
                    '**********************************************************************************
                    
                    Err.clear
                    
                    If OCRHandle=".pdf" Then
                        OCRHandle=".tif"
                    End If
         
                    If (docschangeable=True) And (changeling=False) And (fromdirect=False) Then
                        Ausgabename=schattenname

                    End If
                    

                    
                    '**********************************************************************************
                    '*********************************** Dokument Rotation    *************************
                    '**********************************************************************************
                    
                    ' autorotate mit Omnipage ocr_xml
                    If fs.FileExists(tempname&".ocr_xml") And tifAutoRotate=True Then
                        If ( fs.FileExists(programm &"bfa_get_orientation.exe") And fs.FileExists(programm &"bfa_extract_textpos.exe") ) Then
                            
                            cmd=Chr(34)&programm &"bfa_get_orientation.exe"& Chr(34)&" -xmlpath " & Chr(34)&tempname&".ocr_xml"&Chr(34)
                            Set oExec = objWSHShell.Exec(cmd)
                            strinput=""
                            Do While Not oExec.StdOut.AtEndOfStream
                                strinput = strinput & oExec.StdOut.ReadAll
                            Loop
                            
                            pageorientation=Split(strinput,vbCrLf)
                            ' -> wenn irgendeine pageorientation !=0 -> splitten, rotieren, wieder zusammenbauen
                            dorotate=False
                            For Each p In pageorientation
                                If p<>"0" And p<>"" Then
                                    dorotate=True
                                End If
                            Next
                           
                            If dorotate=True Then
                                autorotatetif archivtif & ".tif", pageorientation
                            End If
                            ' wenn Seiten gedreht wurden, muss orientation in ocr_xml auf 0 gesetzt werden!
                            cmd=Chr(34)&programm &"bfa_extract_textpos.exe"& Chr(34)&" -removens true -orientation all:0 -xmlpath " & Chr(34)&tempname&".ocr_xml"&Chr(34)
                            Set oExec = objWSHShell.Exec(cmd)
                            strinput=""
                            Do While Not oExec.StdOut.AtEndOfStream
                                strinput = strinput & oExec.StdOut.ReadAll
                            Loop
                        Else
                            objWSHShell.LogEvent 2, "archivierung.vbs: bfa_get_orientation.exe bzw. bfa_extract_textpos.exe nicht vorhanden"&vbCrLf&"Seite(n) konnten nicht gerade ausgerichtet werden."
                        End If
                        
                    End If
                    
                    ' autorotate mit Tesseract hocr
                    If fs.FileExists(tempname&".hocr") And tifAutoRotate=True Then
                    	cmd=Chr(34)&programm &"bfa_hocr.exe"& Chr(34)&" " & Chr(34)&tempname&".hocr"&Chr(34) & " -getorientation True"
                        Set oExec = objWSHShell.Exec(cmd)
                        strinput=""
                        Do While Not oExec.StdOut.AtEndOfStream
                            strinput = strinput & oExec.StdOut.ReadAll
                        Loop
                        
                        pageorientation=Split(strinput,vbCrLf)
                        ' -> wenn irgendeine pageorientation !=0 -> splitten, rotieren, wieder zusammenbauen
                        dorotate=False

                        myrotation=Split(strinput,vbCrLf)
                        
                        rotationstring = ""
                        rotindex = 0
                        For Each p In pageorientation
                            If p<>"0" And p<>"" Then
                                dorotate=True
                            End If
                            If p = "90" Then
                            	rotate = "270"
                            ElseIf p = "0" Then
                            	rotate = "0"
                            ElseIf p= "180" Then
                            	rotate = "180"
                            ElseIf p= "270" Then
                            	rotate = "90"
                            End If
                            If p <> "" Then
								myrotation(rotindex)=rotate
								rotationstring = rotationstring & rotindex+1&":"&rotate&","
							End If
							rotindex = rotindex + 1
							
                        Next
                        'If dorotate=True And (extension=".tif" Or extension=".ps") Then
                        If dorotate=True Then
                            autorotatetif archivtif & ".tif", myrotation
	                        ' wenn Seiten gedreht wurden, muss orientation in hocr-File auf 0 gesetzt werden!
	                        If Right(rotationstring, 1)="," Then
	                        	rotationstring = Left(rotationstring, Len(rotationstring)-1)
	                        End If
	                        cmd=Chr(34)&programm &"bfa_hocr.exe"& Chr(34) & " " & Chr(34)& tempname&".hocr"& Chr(34) & " -rotate " & rotationstring
	                        If scriptdebug=True Then
	                        	objWSHShell.LogEvent 0, "archvierung.vbs aktualisiere hocr-Positionsdaten:" & vbCrLf & cmd
	                        End If
	                        Set oExec = objWSHShell.Exec(cmd)
	                        strinput=""
	                        Do While Not oExec.StdOut.AtEndOfStream
	                            strinput = strinput & oExec.StdOut.ReadAll
	                        Loop
                        End If
                    End If
                    perfadd("Dokument Rotation")
                    
                    
           
                    '**********************************************************************************
                    '*********************************** SHA1 Prfsumme         ***********************
                    '**********************************************************************************
                    
                    If opensslpath<>"" Then	
                        If (extension = ".ps") And (fs.FileExists(archivtif&OCRHandle)) Then
                            sha1 = Pruefsumme(archivtif&OCRHandle)
                            If dublettenpruefung = True Then
	                            If find_doc_by_sha1(sha1) <> False Then
					       			dublettengarbage=True
					       			errortxt="Dublette erkannt ("&tempname&")"
						            getDublette(tempname)
						            Unlock(programm&lockdatei)
						            WScript.Quit
						        End If
						    End If
                        Else
                            sha1 = Pruefsumme(tempname & extension)
                        End If 
                    End If
                    
                    perfadd("SHA1")
                    
                    '**********************************************************************************
                    '********************************  prfen, ob Status noch OK  *********************
                    '**********************************************************************************
                                 
                    
                    If ((fromdirect=True) Or (changeling=True)) And (fs.fileexists(Ausgabename&OCRHandle)=False) Then
                        If scriptdebug=True Then
                            objWshShell.LogEvent 4, "Archivierung-debug: 425: "&Ausgabename&OCRHandle
                        End If
                        
                        objWshShell.LogEvent 1, "Archivierung: Dokument bereits verschoben(2)."
                        erfolg=aufraeumen(tempname)
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If
                    
                    If changeling=True Then
                        If fs.FileExists(Ausgabename&extension)<> True Then
                            checkstatus=False
                        End If

                        Ausgabename=Replace(LCase(Ausgabename), LCase(archivverzeichnis), LCase(archivkopie))
                        schattenname=Ausgabename
                        
                        parent =  fs.GetParentFolderName(Ausgabename)
                        found = False
                        Dim tocreate(10)
                        indtocreate = 0
                        Do While found = False
                            If Not fs.FolderExists(parent) Then
                                tocreate(indtocreate) = parent
                                indtocreate = indtocreate + 1 
                                parent = fs.GetParentFolderName(parent)
                            Else
                                found = True
                            End If 
                            If indtocreate >= 10 Then
                                found = True
                            End If
                        Loop
                        
                        If indtocreate > 0 Then
                            For idx = indtocreate -1 To 0 Step -1
                                path = tocreate(idx)
                                If path <> "" Then
                                    If scriptdebug Then
                                        objWshShell.LogEvent 0, "lege NRS Verzeichnis an...:" & path 
                                    End If 
                                    
                                    fs.CreateFolder(path)

                                    If Err.Number <> 0 Then
                                        objWshShell.LogEvent 1, "Konnte Verzeichnis nicht anlegen:" & path 
                                        Err.Clear
                                    End If
                                End If
                            Next
                        End If 
                    End If
                    
                    
                    '**********************************************************************************
                    '**********************  Jetzt in die Archivablage kopieren   *********************
                    '**********************************************************************************
                    
                    waitdirect()
                    If (checkstatus=True) Or (extension=".vcf") Then
                        If fs.FileExists(tempname&".ocr_xml") Then
                            Err.clear
                            If docschangeable=True Then
                                
                                fs.CopyFile tempname&".ocr_xml", schattenname&".ocr_xml", True
                                
                                If Err.number<>0 Then
                                    On Error Resume Next
                                    errortxt="archivierung(19-5): kann ocr_xml nicht ins Archiv-Verzeichnis kopieren." & vbCrLf & tempname&".ocr_xml" & vbCrLf & schattenname&".ocr_xml" & vbCrLf & Err.Number& vbCrLf & Err.description
                                    objWshShell.LogEvent 1, errortxt
                                    Err.clear
                                End If
                            Else
                                fs.CopyFile tempname&".ocr_xml", Ausgabename&".ocr_xml", True
                                If Err.number<>0 Then
                                    On Error Resume Next
                                    errortxt="archivierung(19-6): kann ocr_xml nicht ins Archiv-Verzeichnis kopieren." & vbCrLf & tempname&".ocr_xml" & vbCrLf & Ausgabename&".ocr_xml" & vbCrLf & Err.Number& vbCrLf & Err.description
                                    objWshShell.LogEvent 1, errortxt
                                    Err.clear
                                End If
                            End If
                            
                        End If
                        
                        If fs.FileExists(tempname&".hocr") Then
                            Err.clear
                            If docschangeable=True Then
                                
                                fs.CopyFile tempname&".hocr", schattenname&".hocr", True
                                
                                If Err.number<>0 Then
                                    On Error Resume Next
                                    errortxt="archivierung(19-5): kann hocr nicht ins Archiv-Verzeichnis kopieren." & vbCrLf & tempname&".hocr" & vbCrLf & schattenname&".hocr" & vbCrLf & Err.Number& vbCrLf & Err.description
                                    objWshShell.LogEvent 1, errortxt
                                    Err.clear
                                End If
                            Else
                                fs.CopyFile tempname&".hocr", Ausgabename&".hocr", True
                                If Err.number<>0 Then
                                    On Error Resume Next
                                    errortxt="archivierung(19-6): kann hocr nicht ins Archiv-Verzeichnis kopieren." & vbCrLf & tempname&".hocr" & vbCrLf & Ausgabename&".hocr" & vbCrLf & Err.Number& vbCrLf & Err.description
                                    objWshShell.LogEvent 1, errortxt
                                    Err.clear
                                End If
                            End If
                            
                        End If
                        
                        
                        If InStr(LCase(Ausgabename),LCase(archivverzeichnis))<>0 Then
                            If fs.FileExists(Ausgabename&OCRHandle) Then
                                Err.clear
                                On Error Resume Next
                                errortxt="archivierung(19-7): kann Grafik-Datei nicht ins Archiv-Verzeichnis kopieren."&archivtif&OCRHandle&":"&Ausgabename&OCRHandle
                                errortxt=errortxt & vbCrLf & "Ausgabename: " & Ausgabename
                                errortxt=errortxt & vbCrLf & "OCRHandle: " & OCRHandle
                                errortxt=errortxt & vbCrLf & "archivverzeichnis: " & archivverzeichnis
                                objWSHShell.LogEvent 1, errortxt
                                GetGarbage(tempname)
                                Unlock(programm&lockdatei)
                                WScript.Quit
                            End If
                        End If
                        
                        If (fs.FileExists(archivtif&OCRHandle)) And (fromdirect=False) Then
                            
                            fs.CopyFile archivtif&OCRHandle, Ausgabename&OCRHandle, True
                            
                            If Err.number<>0 Then
                                errortxt="archivierung(19-8): kann Grafik-Datei nicht ins Archiv-Verzeichnis kopieren." & vbCrLf & archivtif&OCRHandle & vbCrLf & Ausgabename&OCRHandle & vbCrLf & Err.Number& vbCrLf & Err.description
                                objWshShell.LogEvent 1, errortxt
                                Err.clear
                                GetGarbage(tempname)
                                Unlock(programm&lockdatei)
                                WScript.Quit
                            End If

                            If docschangeable=False Then
                                If InStr(Ausgabename,archivverzeichnis)<>0 Then
                                    If fs.FileExists(Replace(Ausgabename&OCRHandle,archivverzeichnis,archivkopie)) Then
                                        nrspath=Replace(Ausgabename&OCRHandle,archivverzeichnis,archivkopie)
                                        
                                        fs.CopyFile archivtif&OCRHandle, nrspath
                                    End If
                                End If
                            End If

                        Else
                            If Not fs.FileExists(archivtif&OCRHandle) Then
                                Err.clear
                                On Error Resume Next
                                If Right(archivtif,7) = "-archiv"  Then	
                                    archivtif = Left(archivtif,Len(Archivtif) -7)
                                End If
                                If Not fs.FileExists(archivtif&OCRHandle) Then
                                    Err.clear
                                    On Error Resume Next
                                    
                                    If changeling=False Then
                                        errortxt="archivierung(20-3): fr das kopieren ins Archiv keine Grafik-Datei vorhanden."  & vbCrLf & archivtif&OCRHandle
                                        objWshShell.LogEvent 1, errortxt
                                        GetGarbage(tempname)
                                        Unlock(programm&lockdatei)
                                        WScript.Quit
                                    Else
                                        errortxt="archivierung(20-4): Keine Aktualisierung der Grafik mglich. Prfen Sie, ob das Dokument "&dokid&" ohne Meldungen gedruckt werden kann."  & vbCrLf & archivtif&OCRHandle
                                        objWshShell.LogEvent 1, errortxt
                                        test=aufraeumen(tempname)
                                        Unlock(programm&lockdatei)
                                        WScript.Quit
                                        
                                    End If
                                Else
                                    fs.CopyFile archivtif&OCRHandle, Ausgabename&OCRHandle, True
                                    If Err.number<>0 Then
                                        Err.clear
                                        On Error Resume Next
                                        errortxt="archivierung(19-9): kann Grafik-Datei nicht ins Archiv-Verzeichnis kopieren." & vbCrLf & archivtif&OCRHandle
                                        objWSHShell.LogEvent 1, errortxt
                                        GetGarbage(tempname)
                                        Unlock(programm&lockdatei)
                                        WScript.Quit
                                    End If
                                End If
                            End If
                        End If
                        
                        If (extension=".txt") And (fs.fileexists(tempname&".eml")) Then
                            extension=".eml"
                        End If
                        
                        If (extension=".txt") And (fs.fileexists(tempname&".msg")) Then
                            extension=".msg"
                        End If
                        
                        
                        If (archquelle = True) And (handle<>"") And ((changeling=False) Or (extension=".vcf")) And (fromdirect=False) Then
                            
                            If (extension=".htm") And (fs.fileexists(tempname&".eml")) Then
                                extension=".eml"
                            End If
                            
                            If (extension=".htm") And (fs.fileexists(tempname&".msg")) Then
                                extension=".msg"
                            End If
                            
                            
                            If fs.FileExists(tempname&extension) Then 
                                quelle=Ausgabename&extension
                                If Not fs.FileExists(	Ausgabename&extension) Then
                                    fs.CopyFile tempname&extension, Ausgabename&extension, True
                                    If Err.number<>0 Then
                                        Err.clear
                                        On Error Resume Next
                                        errortxt="archivierung(19-10): kann "&extension&"-Datei nicht ins Archiv-Verzeichnis kopieren."
                                        objWshShell.LogEvent 1, errortxt
                                        GetGarbage(tempname)
                                        Unlock(programm&lockdatei)
                                        WScript.Quit
                                    End If
                                End If
                            Else
                                Err.clear
                                On Error Resume Next
                                errortxt="archivierung(20-5): fr das kopieren ins Archiv keine "&extension&"-Datei vorhanden."
                                objWshShell.LogEvent 1, errortxt
                                GetGarbage(tempname)
                                Unlock(programm&lockdatei)
                                WScript.Quit
                            End If
                        End If
                    End If
                End If '----------------------------------------------------------------------------
                
                
                perfadd("Archivablage")
                '**********************************************************************************
                '*****************  Parameter in Textdatei integrieren und kopieren  **************
                '**********************************************************************************
                
                If checkstatus=True Then 
                    Err.clear
                    
                    If fs.FileExists(ausgabename&".txt") Then
                    	realausgabename = fs.GetFile(ausgabename&".txt")
                    	ausgabename = Left(realausgabename, Len(realausgabename)-4)
                        If ((changeling=True) Or (fromdirect=True))  Then
                            fs.deletefile(ausgabename&".txt")
                            If Err.number<>0 Then
                                Err.clear
                                On Error Resume Next
                                errortxt="archivierung(41aa): kann TXT-Datei nicht lschen (Change, fromdirect)."
                                objWshShell.LogEvent 1, errortxt
                                GetGarbage(tempname)
                                Unlock(programm&lockdatei)
                                WScript.Quit
                            End If
                        Else
                            If extension <> ".txt" Then
                                errortxt="archivierung(40b): textdatei " & ausgabename&".txt" & " bereits im Archivvereichnis vorhanden."
                                objWSHShell.LogEvent 1, errortxt
                                GetGarbage(tempname)
                                Unlock(programm&lockdatei)
                                WScript.Quit
                            End If 
                        End If
                    End If
                    
                    If Not fs.FileExists(ausgabename&".txt") Then
                        Set zieltxtfile = fs.CreateTextFile(ausgabename&".txt",True)
                        If Err.number<>0 Then
                            Err.clear
                            On Error Resume Next
                            errortxt="archivierung(41): kann keine neue txt-datei im Archiv erzeugen."
                            objWshShell.LogEvent 1, errortxt
                            GetGarbage(tempname)
                            Unlock(programm&lockdatei)
                            WScript.Quit
                        End If
                        
                        Set quelltxtfile = fs.OpenTextFile(tempname&".txt",1)
                        
                        If Err.number<>0 Then
                            Err.clear	
                            On Error Resume Next
                            errortxt="archivierung(42): kann txt-datei nicht ffnen."
                            objWshShell.LogEvent 1, errortxt
                            GetGarbage(tempname)
                            Unlock(programm&lockdatei)
                            WScript.Quit
                        End If
                        
                        Do While quelltxtfile.AtEndOfStream <> True
                            kette=quelltxtfile.ReadLine
                            zieltxtfile.WriteLine(kette)
                        Loop
                        
                        quelltxtfile.close
                        
                        If fs.fileexists(tempname&".ftx") Then
                            Set quelltxtfile = Nothing
                            Set quelltxtfile = fs.OpenTextFile(tempname&".ftx",1)
                            Do While quelltxtfile.AtEndOfStream <> True
                                If normftx=True Then
                                    kette=normstring(quelltxtfile.ReadLine)
                                Else
                                    kette=quelltxtfile.ReadLine
                                End If
                                zieltxtfile.WriteLine(kette&" ")
                                If schattenarchiv = True Then
                                    schattentxtfile.WriteLine(kette&" ")
                                End If 
                            Loop
                            quelltxtfile.close
                        End If
                        
                        zieltxtfile.close
                        
                        Set zieltxtfile = Nothing
                        Set quelltxtfile = Nothing
                    End If
                    
                    waitdirect()
                    
                    If (myname ="") And (changeling=False) Then
                        myname = "Dokument"
                    End If
                    
                    perfadd("Archivablage zieltxtfile")
                    '*********************************************************************************
                    '*************************  mitgefhrte Annotations    ***************************
                    '*********************************************************************************
                    If fs.fileexists(tempname & ".iev") Then

                        fs.CopyFile tempname&".iev", schattenname&"0.iev", True
                        If Err.number<>0 Then
                            Err.clear
                            On Error Resume Next
                            errortxt="archivierung(19-12): kann .iev-Datei nicht ins NRS-Archiv-Verzeichnis kopieren."
                            objWSHShell.LogEvent 1, errortxt
                        End If
         
                    End If
                    erledigt=False
                    For s=0 To 50
                        If fs.fileexists(tempname & "_" & s & ".iev") Then
                            
                            fs.CopyFile tempname& "_" & s & ".iev", schattenname&s&".iev", True
                            If Err.number<>0 Then
                                Err.clear
                                errortxt="archivierung(19-14): kann .iev-Datei nicht ins NRS-Archiv-Verzeichnis kopieren."
                                objWSHShell.LogEvent 1, errortxt
                            Else
                                annotations=annotations+1
                            End If
                        End If
                    Next
                    
                    
                    perfadd("Annos")
                    '**********************************************************************************
                    '***************************  Jobdatei schreiben  *********************************
                    '**********************************************************************************
                    
                    
                    If changeling=True Then
                        newstatus="Dokument von "&Username&" aktualisiert."
                        ReDim params(10)
                        params(1)=Username
                        newstatus=getstatustext("status06", params)
                        If myname="Dokument" Or myname="Document" Then
                            myname=""
                        End If
                    End If
                  
                    
                    If annotations > 0 Then
                        newstatus = newstatus & " Es wurden Annotations mitgefhrt"
                    End If		
                    
                    If scriptdebug=True Then
                        objWshShell.LogEvent 0, "Archivierung-Debug: docschangeable5:"&docschangeable&" Ausgabename:"&Ausgabename
                    End If
                    If fs.FileExists(tempname&"-archiv.tif") Then
                    	tifpagecount = Countpages(tempname&"-archiv.tif") 
                    ElseIf fs.FileExists(tempname&".tif") Then
                    	tifpagecount = Countpages(tempname&".tif") 
                    End If
                    If scriptdebug=True Then
                    	objWSHShell.LogEvent 0, "archivierung.vbs tifpagecount="&tifpagecount
                    End If
                    
                    erfolgreich=writejob(tempname)
                    
                    If erfolgreich<>True Then
                        errortxt="Fehler beim schreiben der Job-Datei."
                        objWshShell.LogEvent 1, errortxt
                        GetGarbage(tempname)
                        Unlock(programm&lockdatei)
                        
                        WScript.Quit
                    End If
                    
                    writeschlagwort(tempname)
                    
                       
                    '**********************************************************************************
                    '***************************  Vorbereitung zum Datenbanktransfer  *****************
                    '**********************************************************************************
                    
                    abbruch=False
                    i=0
                    Do While abbruch=False
                        If fs.fileexists(programm&"temp\movelock") Then
                            WScript.sleep 200
                            i=i+1
                        Else
                            abbruch=True
                        End If
                        If i>30 Then
                            On Error Resume Next
                            fs.deletefile programm&"temp\movelock", True
                            Err.clear
                            On Error Resume Next
                            abbruch=True
                        End If
                    Loop
                    
                    If Err Then
                        Err.clear
                        On Error Resume Next
                    End If
                    
                    
                    
                    '**********************************************************************************
                    '***************************  bergabe an die Datenbank  **************************
                    '**********************************************************************************
                    
                    perfadd("Jobdatei")
                    
                    
                    lngReturnCode=dbimp(tempname)
                    perfadd("DBImpV3")
                    
                    If lngReturnCode <> 0 Then
                        errortxt="bitfarm-Archiv: Archivierung(33a): Fehler bei bergabe an Datenbank ("&lngreturncode&")" &vbCrLf& strinput
                        objWSHShell.LogEvent 1, errortxt
                        If lngReturnCode<>6 Then
                            GetGarbage(tempname)
                            Unlock(programm&lockdatei)
                            
                            WScript.Quit
                        End If
                    End If
                    
                    
                    '**********************************************************************************
                    '***************************  Jobdatei im Archiv sichern **************************
                    '**********************************************************************************
                    Err.Clear
                    If savejob=True Then
	                    fs.CopyFile tempname&".job", Ausgabename&".job", True
	                    If Err.number<>0 Then
	                        Err.clear
	                        
	                        On Error Resume Next
	                        errortxt="bitfarm-Archiv: archivierung(19-15): kann job-Datei nicht ins Archiv-Verzeichnis kopieren."
	                        objWshShell.LogEvent 1, errortxt
	                        
	                    End If
	                    If changeling=False Then
	                        refreshjob(Ausgabename)
	                    End If
	                End If
                    perfadd("Jobdatei im Archiv sichern")
                    If changeling = False Then
	                    If notificationconverttif And (notificationmessage <> "") Then
	                        SendConvertNotification tempname & ".job", notificationmessage
	                    End If
	                End If
                    perfadd("SendConvertNotification")
                    If perfmon = True Then
                        If fs.FileExists(tempname & ".job") Then
                            Set jobfile = fs.OpenTextfile(ausgabename & ".job")
                            sLine =""
                            Do While Not jobfile.AtEndOfStream
                                sline=jobfile.ReadLine
                                If InStr(sLine, "gdoc_id=") <> 0 Then
                                    gdocid = Right(sLine, Len(sLine) - 8)
                                    Exit Do
                                End If	
                            Loop
                            jobfile.Close
                        End If
                    End If
                    '*******************************  Speicherung der Prfsumme  ***********************
                    If dublettenpruefung = True Then
                        erfolg=istschonarchiviert(tempname)
                    End If
                    '***********************************************************************************
                End If 
                
            End If
        End If
        
        '***********************************************************************************
    End If '###########
    
    If isdirect=True Then
		
        newtempname = getfifo(queue,"temp-cng")
		If extension = ".ps" Then
			If fs.fileexists(tempname&"-archiv.tif") Then
	            fs.copyfile tempname&"-archiv.tif", newtempname&".tif", True
	        Elseif fs.fileexists(tempname&".tif") Then
	            fs.copyfile tempname&".tif", newtempname&".tif", True
        	End If
		Else
        	If fs.fileexists(tempname&extension) Then
	            fs.copyfile tempname&extension, newtempname&extension, True
        	End If
        End If
        fs.copyfile tempname&".job", newtempname&".zjd", True
        writenewjob(newtempname)
    
    End If
    '**********************************************************************************
    '************************  Jobdatei exportieren (Navision u.a.) *******************
    '**********************************************************************************
    
    
    If (autoexportpath<>"") Then
        If fs.folderexists(autoexportpath) Then
            Err.clear
            fs.CopyFile tempname&".job", autoexportpath&"Dokument"&dokid&".job", True
            If Err.number<>0 Then
                errortxt="bitfarm-Archiv: archivierung(23g): Export gescheitert."
                objWshShell.LogEvent 2, errortxt & vbCrLf & Err.number
                Err.clear
                
            Else
                WScript.Sleep 20
                If autoexportscript <> "" Then
                    If fs.FileExists(autoexportscript) Then
                        rc = objWSHShell.Run(Chr(34) &autoexportscript & Chr(34) & " " & Chr(34)& autoexportpath&"Dokument"&dokid&".job" & Chr(34) ,0,False)
                        
                    End If 
                End If 
            End If 
        End If
    End If
    
    
    perfadd("autoexportpath")
    '*********************************************************************************************
    '****  Bearbeiter zur WV noch in DB schreiben, wenn per Importer oder Manuscan festgelegt ****
    '*********************************************************************************************
    If createWvl=True Then
        writejob(tempname)
        dbimp(tempname)
    End If
    
    If backupbearbeiter<>"" Then
        writebackupWV(tempname)
        lngReturnCode=dbimp(tempname)
        If lngReturnCode <> 0 Then
            errortxt="bitfarm-Archiv: Archivierung(33c): Fehler bei bergabe an Datenbank ("&lngreturncode&")"
        End If
    End If	
    
    
    '*********************************  bei workflows: txtdatei zwischensichern  *******
    
    erfolg = create_dir(workflows)
    
    If erfolg Then
        
        If Tabelle = "workflow" Then
            If DokID="" Then
                DokID="0"
            End If
            frei=neueworkflowdatei()
            tempworkfile=workflows&"wrktxt"&frei
            fs.CopyFile tempname&".txt", tempworkfile&".txt", True
            fs.CopyFile tempname&".job", tempworkfile&".job", True
            Ausgabename = tempworkfile
        End If 
        
    End If 
    '**********************************  aufrumen  ************************************
    
    If (dublettengarbage=True) And (Tabelle<>"workflow") Then
        errortxt="Dublette erkannt ("&tempname&")"
        GetDublette(tempname)
    End If
    perfadd("Wiedervorlage Job schreiben")
    If cleanup=True Then
        test = aufraeumen(tempname)
        
        If scriptdebug = True Then
            objWshShell.LogEvent 0, "Archivierung-Debug: Cleanup durchgefhrt -> " & tempname 
        End If
    End If
    
    '***********************************************************************************
    '********************************  bergabe an workflow  ***************************
    '***********************************************************************************
    
    
    If (Tabelle <> "noarch") And (changeling=False) Then
        If myname = "" Then
            myname = "Dokument"
        End If
        If DokID="" Then
            DokID="0"
        End If
        If wfID="" Then
            wfID="0"
        End If
        If username="" Then
            username="System"
        End If
        
        thestr=Chr(34)& programm&"workflow.bat"& Chr(34) & " "& Chr(34) & Ausgabename& Chr(34) & " "&wfID&" "&DokID&" "&Profil&" "& Chr(34) &Username& Chr(34) &" "& Chr(34) & Tabelle& Chr(34)
        If scriptdebug=True Then
        	objWSHShell.LogEvent 1, "Aufruf wokflow.bat:"&vbCrLf&thestr
        End If
        lngReturnCode = objWSHShell.Run(Chr(34)& programm&"workflow.bat"& Chr(34) & " "& Chr(34) & Ausgabename& Chr(34) & " "&wfID&" "&DokID&" "&Profil&" "& Chr(34) &Username& Chr(34) &" "& Chr(34) & Tabelle& Chr(34),0,True)
        
        
        If lngReturnCode <> 0 Then
            objWSHShell.LogEvent 1, "archivierung(21a): Fehler bei workflow-bergabe: "&programm&"workflow.bat "& Chr(34) & Ausgabename& Chr(34) & " "&wfID&" "&DokID&" "&Profil&" "&Username&" "& Chr(34) & Tabelle& Chr(34)
        End If
    End If
    
    '******************   Anzahl der Jobs in der Queue zhlen und queuecnt.txt aktualisieren *******************
    perfadd("Workflow")
    If fs.fileexists(programm & "countfiles.exe") Then
        
        i = countfiles(programm & "queue" , "*.job")	
        
        If fs.Fileexists(programm& "queuecnt.txt") Then
            
            fs.DeleteFile programm& "queuecnt.txt", True
            On Error Resume Next
        End If  
        Set cntfile = fs.CreateTextFile(programm& "queuecnt.txt",True)
        cntfile.Writeline i
        cntfile.close
        
        Set folder = Nothing
        
    Else
        lngReturnCode = objWSHShell.Run(Chr(34)&programm & "countfiles.bat"&Chr(34)&" " &Chr(34)& programm&Chr(34))
    End If
    perfadd("queuecnt")
     
    
    '*****************    Benachrichtigungsmail an den Admin falls leerer doc-txt  *****************************
    
    If alertonemptydoctxt = True And emptydoctxt = True And extension = ".tif" Then
        versendet = False
        
        alerttxt = "Es wurde fr dieses Dokument kein Volltext erzeugt."
        If stoponemptydoctxt Then
            alerttxt = alerttxt  & " Der bitfarm Archivierungsdienst wurde gestoppt ! "
        End If 
        
        If alertonemptydoctxtcounter = 0 Or alertonemptydoctxtcounter = 1 Then
            lngReturnCode = objWSHShell.Run(Chr(34)&programm & "sendlinkmail.vbs"&Chr(34)&" " & adminmail & " " &  DokId & " " & Chr(34) & alerttxt & Chr(34),0,True)
        Else   'erstmal sammeln
            alle = ""
            Set alert = fs.opentextfile(programm & "\temp\alertonemptydoctxt.txt", 1, True)
            
            Do While Not(alert.atendofstream)
                zeile=alert.readline
                If zeile<>"" And InStr(1,zeile,"docid:") Then
                    i = i +1
                    zeile = Replace(zeile,"docid:","")
                    alle = alle & zeile & ";"
                End If
                'alle = Left (alle,Len(alle)-1)
            Loop
            
            If i => alertonemptydoctxtcounter Then		
                alle = alle & dokid & ";"
                lngReturnCode = objWSHShell.Run(Chr(34)&programm & "sendlinkmail.vbs"&Chr(34)&" " & adminmail & " " &  alle & " " & Chr(34) & alerttxt & Chr(34),0,True)
                If lngReturnCode<> 0 Then
                    objWSHShell.LogEvent 1,"Archivierung.vbs: Achtung! Es konnte keine Warnmail versendet werden. berprfen Sie die Konfiguration und den SMTP-Server" & vbCrLf & "Dokumente:" & alle
                Else
                    versendet = True
                End If
            Else	'hochzhlen
                alert.Close
                Set alert = fs.opentextfile(programm & "\temp\alertonemptydoctxt.txt", 8, True)
                alert.writeline "docid:" & dokid
            End If
            
            alert.close
            Set alert = Nothing
            If versendet = True Then
                fs.DeleteFile programm & "\temp\alertonemptydoctxt.txt", True
                If Err.Number<> 0 Then
                    objWSHShell.LogEvent 1,"Archivierung.vbs: Achtung! Alertonemptydoctxt.txt konnte nicht gelscht werden" & vbCrLf & Err.Description
                End If
            End If
        End If
        
        If lngReturnCode = 0 And stoponemptydoctxt Then
            ret = objWSHshell.Run("net stop " & Chr(34) &"bitfarm-archiv archivierungsdienst" & Chr(34),0,True)
            If ret = 0 Then
                objWSHShell.LogEvent 2,"Archivierung.vbs: Alertonemptydoctxt - Der Archivierungsdienst wurde erfolgreich gestoppt"
            Else
                objWSHShell.LogEvent 2,"Archivierung.vbs: Alertonemptydoctxt - Fehler:" & vbCrLf & "Der Archivierungsdienst konnte nicht gestoppt werden oder war beendet. returncode=" & ret
            End If
            
        End If 
        
    End If
    perfadd("Adminmail")
    
    '**************************************************************************************
    '**************************************************************************************
    '**************************************************************************************
    '**************************************Ende Hauptfunktion******************************
    '**************************************************************************************
    '**************************************************************************************
    '**************************************************************************************
    
    Unlock(programm&lockdatei)
    perfadd("Ende")
    perfsave()
    Set fs = Nothing
    If archservicerunning=True Then
        lngReturnCode = objWSHShell.Run(programm&"archivierung.bat",0,False)
    End If
    WScript.Quit
    
End Function







'*******************************************************************************************
'*************************************   Nebenfunktionen  **********************************
'*******************************************************************************************
'*******************************************************************************************




'*******************************************************************************************
'*************************************  ASC to TIF  ****************************************
'*******************************************************************************************
'*******************************************************************************************

Function ASCtoTIF(dateiname)
    On Error Resume Next	
    Set ascsize = fs.getfile(dateiname&".asc")
    
    If ascsize.size = 0 Then
        errortxt="bitfarm-Archiv: Archivierung: ASCtoTIF Datei 0 Byte gro  -> Garbage"
        objWshShell.LogEvent 1, errortxt
        GetGarbage(dateiname)   
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    
    Set ascsize = Nothing
    
    
    If scriptdebug = True Then
        objWshShell.LogEvent 2, "Archivierung.vbs: Java-Runtime: " & javapath & vbCrLf & "Foppath: " & foppath
    End If
    
    Err.clear
    erfolg=True
    
    Typ="TXT"
    If Not fs.fileexists(dateiname&".txt") Then
        fs.copyfile dateiname&".asc", dateiname&".txt", True
    End If
    
    fopexists = False
    
    If javapath = "" Then
        objWshShell.LogEvent 0, "Archivierung.vbs: Es wurde kein Pfad fr das JRE in der Scripts.ini bergeben"
        If foppath = "" Then
            objWshShell.LogEvent 0,"Archivierung.vbs: Es wurde kein Pfad fr das fop-Modul in der Scripts.ini bergeben"
        End If
    Else
        If foppath = "" Then
            objWshShell.LogEvent 0,"Archivierung.vbs: Es wurde kein Pfad fr das fop-Modul in der Scripts.ini bergeben"
        Else
            
            If fs.fileexists(javapath) Then
                If fs.fileexists(foppath) Then
                    fopexists = True
                Else
                    objWshShell.LogEvent 0, "Archivierung.vbs: fop-Modul nicht im angegebenen Pfad gefunden:" & vbCrLf & foppath
                End If 
            Else
                objWshShell.LogEvent 0, "Archivierung.vbs: Java-Runtime nicht im angegebenen Pfad gefunden:" & vbCrLf & javapath
            End If
        End If
    End If
    
    If fopexists = True Then
        lngReturnCode = objWSHShell.Run(programm&"ASC2FO.vbs " & foppath & " " &dateiname&".asc",0,True)
        modul = "ASC2FO"
        
    Else
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ASC2HTML.vbs"&Chr(34)&" "&Chr(34)&dateiname&".asc"&Chr(34),0,True)
        modul = "ASC2HTML"
    End If
    
    
    If lngReturnCode <> 0 Then
        Err.clear
        On Error Resume Next
        errortxt="archivierung(12): Fehler bei ASC2TIF. Verwendetes Modul: " & modul
        objWshShell.LogEvent 1, errortxt
        erfolg=False
        
    End If
    
    WScript.sleep 20
    
    If fopexists = True Then
        durchlauf = 0 
        abbruch=False
        Do While abbruch=False
            If Not fs.fileexists(dateiname & ".pdf") Then
                WScript.Sleep 100
                durchlauf = durchlauf + 1
            Else 
                abbruch=True
            End If
            If durchlauf=30 Then
                abbruch=True
            End If
        Loop
        If scriptdebug = True Then
            objWshShell.LogEvent 0, dateiname & ".pdf vorhanden. Durchlauf: " & durchlauf	
        End If
        
        If color=False Then		
            PDFtoTIF(dateiname)
        Else
            PDFtoColorTIF(dateiname)
        End If
        
        If fs.fileexists(dateiname&".fo") Then
            fs.deletefile dateiname&".fo", True
        End If
        
        
    Else
        einer=8
        zehner=9
        hunderter=9
        abbruch=False
        oldzaehler="999"
        newzaehler="998"
        
        
        Do While abbruch=False
            If fs.fileexists(dateiname&"_"&hunderter&zehner&einer&".html") Then
                extension=".html"
                DOCtoPS(dateiname&"_"&hunderter&zehner&einer)
                
                
                If fs.FileExists(dateiname&"_"&hunderter&zehner&einer&".html") Then
                    fs.deletefile dateiname&"_"&hunderter&zehner&einer&".html", True
                End If
                If fs.FileExists(dateiname&"_"&hunderter&zehner&einer&".txt") Then
                    fs.deletefile dateiname&"_"&hunderter&zehner&einer&".txt", True
                End If
                
                PStoNonOCRTIF(dateiname&"_"&hunderter&zehner&einer)
                fs.deletefile dateiname&"_"&hunderter&zehner&einer&".ps", True
                If (fs.fileexists(dateiname&"_"&oldzaehler&".tif")) And (fs.fileexists(dateiname&"_"&newzaehler&".tif")) Then
                    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"splitterv3.exe"&Chr(34)&" -m "&Chr(34)&dateiname&"_"&oldzaehler&".tif"&Chr(34)&" "&Chr(34)&dateiname&"_"&newzaehler&".tif"&Chr(34),0,True)
                    WScript.sleep 30				
                    If lngreturncode=0 Then
                        fs.deletefile dateiname&"_"&newzaehler&".tif", True
                        fs.copyfile dateiname&"_"&oldzaehler&".tif", dateiname&"_"&newzaehler&".tif", True
                        fs.deletefile dateiname&"_"&oldzaehler&".tif", True
                    Else
                        errortxt="bitfarm-Archiv: Archivierung: Fehler beim mergen der Seiten bei ASCtoTIF"
                        objWshShell.LogEvent 1, errortxt
                        GetGarbage(dateiname)   
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If
                End If
                
            End If
            
            If (hunderter=0) And (zehner=0) And (einer=1) Then
                abbruch=True
            End If
            
            If abbruch=False Then
                
                oldzaehler=newzaehler
                If einer>0 Then
                    einer=einer-1
                Else
                    If zehner>0 Then
                        zehner=zehner-1
                        einer=9
                    Else
                        If hunderter>0 Then
                            hunderter=hunderter-1
                            zehner=9
                            einer=9
                        Else
                            hunderter=0
                            zehner=0
                            einer=0
                        End If
                    End If
                End If
                newzaehler=hunderter&zehner&einer
            End If
        Loop
        
        If fs.fileexists(dateiname&"_001.tif") Then
            fs.copyfile dateiname&"_001.tif", dateiname&".tif", True
            fs.deletefile dateiname&"_001.tif", True
        End If
        
        
        
    End If
    objWshShell.LogEvent 0, "Archivierung.vbs: die Asc2Tif- Wandlung erfolgte mit :" & vbCrLf & modul
    extension=".asc"
    
End Function


'*******************************************************************************************
'*******************************************************************************************
'*************************************  PLT to TIF  *****************************************
'*******************************************************************************************
'*******************************************************************************************

Function PLTtoTIF(dateiname)
    On Error Resume Next
    Err.clear
    erfolg=True
    Typ="TXT"
    
    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"PLTtoTIF.bat"&Chr(34)&" "&Chr(34)&dateiname&".plt"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34),0,True)
    
    If lngReturnCode <> 0 Then
        Err.clear
        On Error Resume Next
        errortxt="archivierung(10-1): Fehler bei PLTCONVERT."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
        
    End If
    
    WScript.sleep 100
    If Not fs.fileexists(dateiname&"-temp.tif") Then
        Err.clear
        On Error Resume Next
        errortxt="archivierung(10-2): Fehler bei PLTtoTIF: keine TIF-Datei erzeugt. Mglicherweise zu wenig freier Festplattenspeicher."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
        
    End If
    
    If erfolg=True Then
        
        lngReturnCode = runfilter(dateiname&"-temp.tif",programm&"TIFF-SW.txt",dateiname&".tif")
         
        If lngReturnCode <> 0 Then
            Err.clear
            On Error Resume Next
            errortxt="archivierung(10-3): Fehler bei Filtern nach Ghostscript(Color)."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(dateiname)   
            Unlock(programm&lockdatei)
            WScript.Quit
            
        End If
        WScript.Sleep 200
        fs.deletefile dateiname&"-temp.tif", True
        
        If Not fs.fileexists(dateiname&".tif") Then
            Err.clear
            On Error Resume Next
            errortxt="archivierung(10-4): Fehler beim Filtern: keine TIF-Datei erzeugt. Mglicherweise zu wenig freier Festplattenspeicher oder Datei defekt."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(dateiname)   
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
    End If
    
    If erfolg=False Then
        handle="unbekannt"
        Typ="TXT"
        OCRHandle=".tif"
        color=False
    End If
    
End Function




'*******************************************************************************************
'*******************************************************************************************
'*************************************  PS to PDF  *****************************************
'*******************************************************************************************
'*******************************************************************************************

Function PStoPDF(dateiname)
    On Error Resume Next
    Err.clear
    If (isBusy=True) And (rundirect=False) Then
        objWshShell.LogEvent 1, "bitfarm-Archiv Serverdienst: Kollission mit einer weiteren Instanz entdeckt."
        WScript.Quit
    End If
    
    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"makepdf.bat"&Chr(34)&" @"&Chr(34)&programm&"pdf.rsp"&Chr(34)&" "&Chr(34)&dateiname&".pdf"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)
    If lngReturnCode <> 0 Then
        Err.clear
        On Error Resume Next
        errortxt="archivierung(10-5): Fehler bei Ghostscript."
        objWshShell.LogEvent 1, errortxt
        GetGarbage(dateiname)   
        Unlock(programm&lockdatei)
        WScript.Quit
        
    End If
    extension=".pdf"
    handle="pdf"
    
    
End Function


'*******************************************************************************************
'*******************************************************************************************
'*************************************  PS to TIF  *****************************************
'*******************************************************************************************
'*******************************************************************************************

Function PStoTIF(dateiname)
    On Error Resume Next
    If scriptdebug=True Then
		objWSHShell.LogEvent 1, "archivierung.vbs: PStoTIF"
	End If
    Err.clear
    
    erfolg=True
    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"processmonitor.bat"&Chr(34)&" ghostscript",0,True)
    If fs.fileexists(programm&"ghostscriptwatcher.bat") And fs.fileexists(programm&"ghostscriptwatcher.vbs") Then
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscriptwatcher.bat"&Chr(34),0,False)
    End If
    
    If scriptdebug=True Then
		objWSHShell.LogEvent 1, "archivierung.vbs: ghostscript " & Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-OCR.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34)
	End If
	
    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-OCR.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)
    If lngReturnCode <> 0 Then
        Err.clear
        On Error Resume Next
        errortxt="archivierung(10-6): Fehler bei Ghostscript(Color)."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
        
    End If
    
    If Not fs.fileexists(dateiname&"-temp.tif") Then
        Err.clear
        On Error Resume Next
        errortxt="archivierung(10-7): Fehler bei Ghostscript: keine TIF-Datei erzeugt. Mglicherweise zu wenig freier Festplattenspeicher."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
        
    End If
    
    If erfolg=True Then
       
        lngReturnCode = runfilter(dateiname&"-temp.tif",programm&"TIFF-300.txt",dateiname&".tif")
        
        
        If lngReturnCode <> 0 Then
            Err.clear
            On Error Resume Next
            errortxt="archivierung(10-8): Fehler bei Filtern nach Ghostscript(Color)."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(dateiname)   
            Unlock(programm&lockdatei)
            WScript.Quit
            
        End If
        WScript.Sleep 200
        fs.deletefile dateiname&"-temp.tif", True
        
        If Not fs.fileexists(dateiname&".tif") Then
            Err.clear
            On Error Resume Next
            errortxt="archivierung(10-9): Fehler beim Filtern: keine TIF-Datei erzeugt. Mglicherweise zu wenig freier Festplattenspeicher."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(dateiname)   
            Unlock(programm&lockdatei)
            WScript.Quit
            
        End If
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"processmonitor.bat"&Chr(34)&" ghostscript",0,True)
        WScript.Sleep 200
        
        If fs.fileexists(programm&"ghostscriptwatcher.bat") And fs.fileexists(programm&"ghostscriptwatcher.vbs") Then
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscriptwatcher.bat"&Chr(34),0,False)
        End If
        If hires=False Then
            If dpi="" Then
            	If scriptdebug=True Then
					objWSHShell.LogEvent 1, "archivierung.vbs: ghostscript " & Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-OCR.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34)
				End If
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-200.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-archiv.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)
            Else
            	If scriptdebug=True Then
					objWSHShell.LogEvent 1, "archivierung.vbs: ghostscript " & Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"temp\custom-bw.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-archiv.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34)
				End If
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"temp\custom-bw.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-archiv.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)
                
            End If	
        Else
        	If scriptdebug=True Then
				objWSHShell.LogEvent 1, "archivierung.vbs: ghostscript " & Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-300.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-archiv.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34)
			End If
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-300.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-archiv.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)
        End If
        
        
        If lngReturnCode <> 0 Then
            Err.clear
            On Error Resume Next
            errortxt="archivierung(10-10): Fehler bei Ghostscript."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(dateiname)   
            Unlock(programm&lockdatei)
            WScript.Quit
            
        End If
        archivtif=dateiname&"-archiv"
        
        If Not fs.fileexists(dateiname&"-archiv.tif") Then
            Err.clear
            On Error Resume Next
            errortxt="archivierung(10-11): Fehler bei Ghostscript: keine TIF-Datei erzeugt. Mglicherweise zu wenig freier Festplattenspeicher."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(dateiname)   
            Unlock(programm&lockdatei)
            WScript.Quit
            
        End If
        
        
        If ((Handle="Powerpoint")  And (SavePPasList=False)) Or (Handle="AKT") Then
            lngReturnCode = runfilter(dateiname&"-archiv.tif",programm&"PProtate.txt",dateiname&"-archiv1.tif")
            
            If lngReturnCode <> 0 Then
                Err.clear
                On Error Resume Next
                errortxt="archivierung(10-12): Fehler bei Filtern nach Ghostscript(Color)."
                objWshShell.LogEvent 1, errortxt
                GetGarbage(dateiname)   
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
            WScript.sleep 50
            fs.deletefile dateiname&"-archiv.tif", True
            WScript.sleep 50
            fs.copyfile dateiname&"-archiv1.tif", dateiname&"-archiv.tif", True
            WScript.sleep 50
            fs.deletefile dateiname&"-archiv1.tif", True
        End If
    End If
    If erfolg=False Then
        handle="unbekannt"
        Typ="TXT"
        OCRHandle=".tif"
        color=False
    End If
    
    If handle = "Excel" And truncatedXlsPreview<>False Then
        addpreviewincomplete dateiname, xlspages
    End If
    
End Function


'*******************************************************************************************
'*************************************  PS to NonOCRTIF  ***********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

Function PStoNonOCRTIF(dateiname)
    On Error Resume Next
    If scriptdebug=True Then
		objWSHShell.LogEvent 1, "archivierung.vbs: PStoNonOCRTIF"
	End If
    Err.clear
    
    erfolg=True
    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"processmonitor.bat"&Chr(34)&" ghostscript",0,True)
    WScript.Sleep 200
    If fs.fileexists(programm&"ghostscriptwatcher.bat") And fs.fileexists(programm&"ghostscriptwatcher.vbs") Then
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscriptwatcher.bat"&Chr(34),0,False)
    End If
    If hires=False Then
        If dpi="" Then
        	If scriptdebug=True Then
				objWSHShell.LogEvent 1, "archivierung.vbs: ghostscript " & Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-200.rsp"&Chr(34)&" "&Chr(34)&dateiname&".tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34)
			End If
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-200.rsp"&Chr(34)&" "&Chr(34)&dateiname&".tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)
        Else
        	If scriptdebug=True Then
				objWSHShell.LogEvent 1, "archivierung.vbs: ghostscript " & Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"temp\custom-bw.rsp"&Chr(34)&" "&Chr(34)&dateiname&".tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34)
			End If
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"temp\custom-bw.rsp"&Chr(34)&" "&Chr(34)&dateiname&".tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)
        End If
    Else
    	If scriptdebug=True Then
			objWSHShell.LogEvent 1, "archivierung.vbs: ghostscript " & Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-300.rsp"&Chr(34)&" "&Chr(34)&dateiname&".tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34)
		End If
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-300.rsp"&Chr(34)&" "&Chr(34)&dateiname&".tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)
    End If
    
    
    If lngReturnCode <> 0 Then
        Err.clear
        On Error Resume Next
        errortxt="archivierung(10-13): Fehler bei Ghostscript."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
    End If
    
    If erfolg=True Then
        If ((Handle="Powerpoint")  And (SavePPasList=False)) Or (Handle="AKT") Then
            lngReturnCode = runfilter(dateiname&".tif",programm&"PProtate.txt",dateiname&"-archiv1.tif")
            
            If lngReturnCode <> 0 Then
                Err.clear
                On Error Resume Next
                errortxt="archivierung(10-14): Fehler bei Filtern nach Ghostscript."
                objWshShell.LogEvent 1, errortxt
                GetGarbage(dateiname)   
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
            WScript.sleep 50
            fs.deletefile dateiname&".tif", True
            WScript.sleep 50
            fs.copyfile dateiname&"-archiv1.tif", dateiname&".tif", True
            WScript.sleep 50
            fs.deletefile dateiname&"-archiv1.tif", True
        End If
    End If
    
    If erfolg=False Then
        handle="unbekannt"
        Typ="TXT"
        OCRHandle=".tif"
        color=False
    End If
End Function


'*******************************************************************************************
'*******************************************************************************************
'*************************************  PS to ColorTIF  ************************************
'*******************************************************************************************
'*******************************************************************************************

Function PStoColorTIF(dateiname)
    On Error Resume Next
    If scriptdebug=True Then
		objWSHShell.LogEvent 1, "archivierung.vbs: PStoColorTIF"
	End If
    Err.clear
    
    erfolg=True
    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"processmonitor.bat"&Chr(34)&" ghostscript",0,True)
    WScript.Sleep 200
    If fs.fileexists(programm&"ghostscriptwatcher.bat") And fs.fileexists(programm&"ghostscriptwatcher.vbs") Then
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscriptwatcher.bat"&Chr(34),0,False)
    End If
    If scriptdebug=True Then
		objWSHShell.LogEvent 1, "archivierung.vbs: ghostscript " & Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-OCR.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34)
	End If
    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-OCR.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)
    If lngReturnCode <> 0 Then
        Err.clear
        On Error Resume Next
        errortxt="archivierung(10-15): Fehler bei Ghostscript(Color)."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
        
    End If
    
    If Not fs.fileexists(dateiname&"-temp.tif") Then
        Err.clear
        On Error Resume Next
        errortxt="archivierung(10-16): Fehler bei Ghostscript: keine TIF-Datei erzeugt. Mglicherweise zu wenig freier Festplattenspeicher."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
        
    End If
    
    If erfolg=True Then
        lngReturnCode = runfilter(dateiname&"-temp.tif",programm&"TIFF-300.txt",dateiname&".tif")
        
        If lngReturnCode <> 0 Then
            Err.clear
            On Error Resume Next
            errortxt="archivierung(10-17): Fehler bei Filtern nach Ghostscript(Color)."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(dateiname)   
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
        WScript.Sleep 200
        fs.deletefile dateiname&"-temp.tif", True
        
        If Not fs.fileexists(dateiname&".tif") Then
            Err.clear
            On Error Resume Next
            errortxt="archivierung(10-18): Fehler beim Filtern: keine TIF-Datei erzeugt. Mglicherweise zu wenig freier Festplattenspeicher."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(dateiname)   
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"processmonitor.bat"&Chr(34)&" ghostscript",0,True)
        WScript.Sleep 200
        If fs.fileexists(programm&"ghostscriptwatcher.bat") And fs.fileexists(programm&"ghostscriptwatcher.vbs") Then
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscriptwatcher.bat"&Chr(34),0,False)
        End If
        If hires=False Then
            If dpi="" Then
            	If scriptdebug=True Then
					objWSHShell.LogEvent 1, "archivierung.vbs: ghostscript " & Chr(34)&programm&"ghostscript.bat"&Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-200-color.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34)
				End If
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-200-color.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)
            Else
            	If scriptdebug=True Then
					objWSHShell.LogEvent 1, "archivierung.vbs: ghostscript " & Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"temp\custom-color.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34)
				End If
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"temp\custom-color.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)	
            End If
        Else
        	If scriptdebug=True Then
				objWSHShell.LogEvent 1, "archivierung.vbs: ghostscript " & Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-300-color.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34)
			End If
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-300-color.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)
        End If
        If lngReturnCode <> 0 Then
            Err.clear
            On Error Resume Next
            errortxt="archivierung(10-19): Fehler bei Ghostscript(color)."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(dateiname)   
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
        
        If Not fs.fileexists(dateiname&"-temp.tif") Then
            Err.clear
            On Error Resume Next
            errortxt="archivierung(10-20): Fehler bei Ghostscript: keine TIF-Datei erzeugt. Mglicherweise zu wenig freier Festplattenspeicher."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(dateiname)   
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
        
        lngReturnCode = runfilter(dateiname&"-temp.tif",programm&"TIFF-200.txt",dateiname&"-archiv.tif")
        
        If lngReturnCode <> 0 Then
            Err.clear
            On Error Resume Next
            errortxt="archivierung(10-21): Fehler bei Filtern nach Ghostscript(Color)."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(dateiname)   
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
        WScript.Sleep 200
        fs.deletefile dateiname&"-temp.tif", True
        
        archivtif=dateiname&"-archiv"
        
        If Not fs.fileexists(dateiname&"-archiv.tif") Then
            Err.clear
            On Error Resume Next
            errortxt="archivierung(10-22): Fehler bei Filter: keine TIF-Datei erzeugt. Mglicherweise zu wenig freier Festplattenspeicher."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(dateiname)   
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
        
        If ((Handle="Powerpoint")  And (SavePPasList=False)) Or (Handle="AKT") Then
            lngReturnCode = runfilter(dateiname&"-archiv.tif",programm&"PProtate.txt",dateiname&"-archiv1.tif")
            
            If lngReturnCode <> 0 Then
                Err.clear
                On Error Resume Next
                errortxt="archivierung(10-23): Fehler bei Filtern nach Ghostscript(Color)."
                objWshShell.LogEvent 1, errortxt
                GetGarbage(dateiname)   
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
            WScript.sleep 50
            fs.deletefile dateiname&"-archiv.tif", True
            WScript.sleep 50
            fs.copyfile dateiname&"-archiv1.tif", dateiname&"-archiv.tif", True
            WScript.sleep 50
            fs.deletefile dateiname&"-archiv1.tif", True
        End If
    End If
    
    If erfolg=False Then
        handle="unbekannt"
        Typ="TXT"
        OCRHandle=".tif"
        color=False
    End If
    
    If handle = "Excel" And truncatedXlsPreview<>False Then
        addpreviewincomplete dateiname, xlspages
    End If    
    
End Function


'*******************************************************************************************
'*************************************  PS to ColorNonOCRTIF  ******************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

Function PStoColorNonOCRTIF(dateiname)
    On Error Resume Next
    
    If scriptdebug=True Then
		objWSHShell.LogEvent 1, "archivierung.vbs: PStoColorNonOCRTIF"
	End If
	
    Err.clear
    erfolg=True
    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"processmonitor.bat"&Chr(34)&" ghostscript",0,True)
    WScript.Sleep 200
    If fs.fileexists(programm&"ghostscriptwatcher.bat") And fs.fileexists(programm&"ghostscriptwatcher.vbs") Then
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscriptwatcher.bat"&Chr(34),0,False)
    End If
    
    If hires=False Then
        If dpi="" Then
        	If scriptdebug=True Then
				objWSHShell.LogEvent 1, "archivierung.vbs: ghostscript: " &Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-200-color.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34)
			End If
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-200-color.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)
        Else
        	If scriptdebug=True Then
				objWSHShell.LogEvent 1, "archivierung.vbs: ghostscript: " & Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"temp\custom-color.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34)
			End If
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"temp\custom-color.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)
        End If
    Else
    	If scriptdebug=True Then
			objWSHShell.LogEvent 1, "archivierung.vbs: ghostscript: " & Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-300-color.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34)
		End If
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-300-color.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)
    End If
    If lngReturnCode <> 0 Then
        Err.clear
        On Error Resume Next
        errortxt="archivierung(10-24): Fehler bei Ghostscript."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
    End If
    
    If Not fs.fileexists(dateiname&"-temp.tif") Then
        Err.clear
        errortxt="archivierung(10-25): Fehler bei Ghostscript: keine TIF-Datei erzeugt. Mglicherweise zu wenig freier Festplattenspeicher."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
    End If
    
    If erfolg=True Then
        lngReturnCode = runfilter(dateiname&"-temp.tif",programm&"TIFF-200.txt",dateiname&".tif")
        
        If lngReturnCode <> 0 Then
            Err.clear
            On Error Resume Next
            errortxt="archivierung(10-26): Fehler bei Filtern nach Ghostscript(Color)."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(dateiname)   
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
        WScript.Sleep 200
        fs.deletefile dateiname&"-temp.tif", True
        
        If Not fs.fileexists(dateiname&".tif") Then
            Err.clear
            errortxt="archivierung(10-27): Fehler beim Filtern: keine TIF-Datei erzeugt. Mglicherweise zu wenig freier Festplattenspeicher."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(dateiname)   
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
        
        If ((Handle="Powerpoint")  And (SavePPasList=False)) Or (Handle="AKT") Then
            lngReturnCode = runfilter(dateiname&".tif",programm&"PProtate.txt",dateiname&"-archiv1.tif")
            
            If lngReturnCode <> 0 Then
                Err.clear
                On Error Resume Next
                errortxt="archivierung(10-28): Fehler bei Filtern nach Ghostscript."
                objWshShell.LogEvent 1, errortxt
                GetGarbage(dateiname)   
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
            WScript.sleep 50
            fs.deletefile dateiname&".tif", True
            WScript.sleep 50
            fs.copyfile dateiname&"-archiv1.tif", dateiname&".tif", True
            WScript.sleep 50
            fs.deletefile dateiname&"-archiv1.tif", True
        End If
    End If
    
    If erfolg=False Then
        handle="unbekannt"
        Typ="TXT"
        OCRHandle=".tif"
        color=False
    End If
    
End Function


'*******************************************************************************************
'*******************************************************************************************
'*************************************  PCL to TIFF ****************************************
'*******************************************************************************************
'*******************************************************************************************

Function PCLtoTIFF(dateiname)
    On Error Resume Next
    Err.clear
    
    erfolg=True
    If Not fs.fileexists(pcltotif) Then
        errortxt="archivierung(233): Fehler: Eintrag in scripts.ini prfen: pcltotif= ist nicht richtig definiert."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
    End If
    
    If erfolg=True Then
        lngReturnCode = objWSHShell.Run(Chr(34)&pcltotif&Chr(34)&" "&Chr(34)&dateiname&".pcl"&Chr(34),0,True)
        WScript.sleep 200
        
        If lngReturnCode <> 0 Then
            Err.clear
            On Error Resume Next
            errortxt="archivierung(233-a): Fehler bei PCLtoTIFF."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
        End If
    End If
    
    If Not fs.fileexists(dateiname&".tif") Then
        Err.clear
        On Error Resume Next
        errortxt="archivierung(233-b): Fehler bei PCLtoTIFF: keine TIF-Datei erzeugt."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
    End If
    
    If erfolg=True Then
        extension=".tif"
    End If
    
    If scriptdebug=True Then
        objWshShell.LogEvent 1, "Archivierung (debug-mode): beende PCLtoTIFF mit erfolg="&erfolg
    End If
    
End Function

'*******************************************************************************************
'*******************************************************************************************
'*************************************  JPG to TIFF ****************************************
'*******************************************************************************************
'*******************************************************************************************


Function JPGtoTIFF(dateiname)
    On Error Resume Next
    Err.Clear
    
    If archJPGincolor=True Then
        lngReturnCode = runfilter(dateiname&".jpg",programm&"jpg-200.txt",dateiname&".tif")
    Else
        lngReturnCode = runfilter(dateiname&".jpg",programm&"jpg-200-bw.txt",dateiname&".tif")
    End If
    If dontuseocrforjpg=False Then
        lngReturnCode = runfilter(dateiname&".jpg",programm&"jpg-ocr.txt",dateiname&"-ocr.tif")
    End If
    If fs.fileexists(dateiname&".tif") Then
        JPGtoTIFF=True
        OcrHandle=".tif"
        
        If fs.fileexists(dateiname&"-ocr.tif") Then
            fs.movefile dateiname&"-ocr.tif", dateiname&".ocr"
        End If
    Else
        JPGtoTIFF=False
    End If
    
End Function

'*******************************************************************************************
'*******************************************************************************************
'*************************************  PNG to TIFF ****************************************
'*******************************************************************************************
'*******************************************************************************************

Function PNGtoTIFF(dateiname)
    On Error Resume Next
    Err.clear
    
    erfolg=True
    If Not fs.fileexists(programm & "png2tiff.exe") Then
        errortxt="archivierung(333): Fehler: konnte png2tiff.exe nicht finden."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
    End If
    
    If erfolg=True Then
        If color = True Then
            lngReturnCode = objWSHShell.Run(Chr(34) & programm & "png2tiff.exe"&Chr(34)&" "&Chr(34)&dateiname&".png"&Chr(34),0,True)
        Else
            lngReturnCode = objWSHShell.Run(Chr(34) & programm & "png2tiff.exe"&Chr(34)&" "&Chr(34)&dateiname&".png"&Chr(34) & " bw",0,True)
        End If 
        WScript.sleep 200
        
        If lngReturnCode <> 0 Then
            Err.clear
            On Error Resume Next
            errortxt="archivierung(333-a): Fehler bei PNGtoTIFF."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
        End If
    End If
    
    If Not fs.fileexists(dateiname&".tif") Then
        Err.clear
        On Error Resume Next
        errortxt="archivierung(333-b): Fehler bei PNGtoTIFF: keine TIF-Datei erzeugt."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
    End If
    
    If erfolg=True Then
        extension=".png"
        OcrHandle=".tif"
    End If
    
    If scriptdebug=True Then
        objWshShell.LogEvent 0, "Archivierung (debug-mode): beende PNGtoTIFF mit erfolg="&erfolg
    End If
    
End Function


'*******************************************************************************************
'*************************************  XLS to PS  *****************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

Function XLStoPS(dateiname)
    On Error Resume Next
    Err.clear
    erfolg=True
    
    Set wshnet = CreateObject("WScript.Network")
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        errortxt="bitfarm-Archiv: Archivierung: Kann keinen Standarddrucker (1) festlegen. Entweder Serviceprinter nicht installiert oder Scripting Host Version zu alt."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
    End If
    If erfolg=True Then
        If setprintermethod="default" Then
            wshnet.SetDefaultPrinter "Serviceprinter"
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                errortxt="bitfarm-Archiv: Archivierung: Kann keinen Standarddrucker (2) festlegen. Entweder Serviceprinter nicht installiert oder Scripting Host Version zu alt."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
            End If
            Set wshnet=Nothing
        ElseIf setprintermethod="printui.dll" Then
            setdefault_serviceprinter()
        End If
    End If
    
    If (isBusy=True) And (rundirect=False) Then
        objWshShell.LogEvent 1, "bitfarm-Archiv Serverdienst: Kollission mit einer weiteren Instanz entdeckt."
        WScript.Quit
    End If
    If erfolg=True Then
        Set objXL = WScript.CreateObject("Excel.Application")
        If Err.number <> 0 Then
            errortxt="archivierung(11-1): Kein Excel installiert - Fehler beim Zugriff."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
            Set objXL=Nothing
            On Error Resume Next
            Err.clear
        End If
    End If
    
    Err.clear
    If erfolg=True Then
        If fs.FileExists(temp&"Serviceprinter.ps") Then
            fs.deletefile temp&"Serviceprinter.ps", True
            If Err.number <> 0 Then
                errortxt="archivierung(11-2): kann Serviceprinter.ps nicht lschen."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
                Set objXL=Nothing
                On Error Resume Next
                Err.clear
            End If
        End If
    End If
    
    Err.clear
    If erfolg=True Then
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"processmonitor.bat"&Chr(34)&" EXCEL",0,True)
        WScript.Sleep 200
        Err.clear
    End If
    
    If erfolg=True Then
        Err.Clear	
        objXL.EnableEvents = False
        Set objWb = objXl.WorkBooks.Open(dateiname&extension, UpdateLinks = 0)
        
    End If
    
    xlspages = 0
    If erfolg=True Then
        objWb.PrintOut 1,10000,,,,,True,""
        
        strComputer = "."
        Set objWMIService = GetObject("winmgmts:" _
        & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
        prnstatus = 4
        printtimeout = 0
        Do While prnstatus = 4 And printtimeout < 50
            Set colInstalledPrinters =  objWMIService.ExecQuery _
            ("Select * from Win32_Printer WHERE Name = 'Serviceprinter'")
            
            For Each objPrinter In colInstalledPrinters
                prnstatus = objPrinter.PrinterStatus
            Next
            WScript.Sleep(200)
            printtimeout = printtimeout + 1
        Loop
        
        
        If fs.fileexists(temp&"Serviceprinter.ps") Then
            If scriptdebug=True Then
            	objWSHShell.LogEvent 0, "countpspages:" & temp&"Serviceprinter.ps"
            End If
            xlspages = countpspages(temp&"Serviceprinter.ps")
        Else
            xlspages = 0
            erfolg = False
        End If
    End If
    
    If erfolg=True Then
        If xlsmaxpages<xlspages Then
            objWb.PrintOut 1,xlsmaxpages,,,,,True,""
            truncatedXlsPreview = True
        Else
            truncatedXlsPreview = False
        End If
    End If
    
    If erfolg=True Then
        WScript.Sleep 500
        objWB.Saved = True
        WScript.sleep 500
        objWb.Close False
        
        Set objWb=Nothing
        
        Err.clear
        On Error Resume Next
        
        If Err.number<>0 Then
            On Error Resume Next
            Err.clear
            errortxt="archivierung(100c): Fehler bei MS-Office zu TIF Wandlung. Bitte prfen, ob das Dokument in Office ohne weitere Meldungen gedruckt werden kann, ggf. nderungen vornehmen und erneut archivieren."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
            Set objXL=Nothing
            On Error Resume Next
        End If
    End If
    
    If erfolg=True Then
        objXL.Quit
        Set objXL = Nothing
        
        
        If Err.number<>0 Then
            On Error Resume Next
            Err.clear
            errortxt="archivierung(100d): Fehler bei MS-Office zu TIF Wandlung. Bitte prfen, ob das Dokument in Office ohne weitere Meldungen gedruckt werden kann, ggf. nderungen vornehmen und erneut archivieren." & vbCrLf & Err.Number& vbCrLf & Err.Description
            objWshShell.LogEvent 1, errortxt
            erfolg=False
        End If
    End If
    
    If erfolg=True Then
        If fs.FileExists(dateiname&".ps") Then
            fs.deletefile dateiname&".ps", True
            
        End If
    End If
    WScript.sleep 200
    If erfolg=True Then
        abbruch=False
        k=0
        Do While abbruch = False
            If fs.FileExists(temp&"Serviceprinter.ps") Then
                WScript.Sleep 400
                Err.clear
                fs.CopyFile temp&"Serviceprinter.ps", dateiname&".ps", True
                If Err.number<>0 Then
                    Err.clear
                    On Error Resume Next
                    WScript.sleep 10000
                    fs.CopyFile temp&"Serviceprinter.ps", dateiname&".ps", True
                End If
                If Err.number<>0 Then
                    errortxt="archivierung(11-3): konnte aus Postscript-Datei nicht kopieren."&Err.number
                    Err.clear
                    On Error Resume Next
                    
                    objWshShell.LogEvent 1, errortxt
                    GetGarbage(Dateiname)   
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If
                abbruch=True
            Else
                WScript.Sleep 200
                k=k+1
                If k>20 Then
                    abbruch=True
                End If
            End If
        Loop
    End If
    
    If fs.FileExists(temp&"Serviceprinter.ps") Then
        Err.clear
        fs.deletefile temp&"Serviceprinter.ps", True
        If Err.number<>0 Then
            Err.clear
        End If
    End If
    
    If erfolg=True Then		
        If Not fs.FileExists(dateiname&".ps") Then
            
            errortxt="archivierung(11-4): konnte aus XLS-Datei keine PS-Datei erzeugen."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
        End If
    End If
    
    If erfolg=False Then
        handle="unbekannt"
        Typ="TXT"
        OCRHandle=".tif"
        color=False
    End If
    
End Function


'*******************************************************************************************
'*************************************  DOC to PS  *****************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

Function DOCtoPS(dateiname)
    On Error Resume Next
    Err.clear
    erfolg=True
    tempextension=extension
    
    Set wshnet = CreateObject("WScript.Network")
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        errortxt="bitfarm-Archiv: Archivierung: Kann keinen Standarddrucker (1) festlegen. Entweder Serviceprinter nicht installiert oder Scripting Host Version zu alt."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
    End If
    
    If erfolg=True Then
        If setprintermethod="default" Then
            wshnet.SetDefaultPrinter "Serviceprinter"
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                errortxt="bitfarm-Archiv: Archivierung: Kann keinen Standarddrucker (2) festlegen. Entweder Serviceprinter nicht installiert oder Scripting Host Version zu alt."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
            End If
            Set wshnet=Nothing
        ElseIf setprintermethod="printui.dll" Then
            setdefault_serviceprinter()
        End If
    End If
    
    If (isBusy=True) And (rundirect=False) Then
        objWshShell.LogEvent 1, "bitfarm-Archiv Serverdienst: Kollission mit einer weiteren Instanz entdeckt."
        WScript.Quit
    End If
    
    
    If erfolg=True Then
        Set objWord = WScript.CreateObject("Word.Application")
        If Err.number <> 0 Then
            Err.clear
            On Error Resume Next
            errortxt="archivierung(11-5): Kein Word installiert oder Fehler beim Zugriff."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
        End If
    End If
    
    If erfolg=True Then
        Err.clear
        If fs.FileExists(temp&"Serviceprinter.ps") Then
            fs.deletefile temp&"Serviceprinter.ps", True
            If Err.number <> 0 Then
                errortxt="archivierung(11-6): kann Serviceprinter.ps nicht lschen."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
                Set objWord = Nothing
            End If
        End If
    End If
    
    Err.clear
    On Error Resume Next

    
    If extension=".vcf" Then
        extension=".txt"
    End If
    
    Err.clear
    
    If erfolg=True Then
        
        Set attribhandle=fs.GetFile(dateiname&extension)
        attribhandle.Attributes=attribhandle.Attributes And Not 1 And Not (8+16+64+128)
        Set attribhandle=Nothing
        WScript.Sleep 200
        
        '******************** Registrierungsschlssel "Deaktivierte Elemente" lschen falls vorhanden *******
        Err.clear
        On Error Resume Next
        objWSHShell.regdelete("HKEY_CURRENT_USER\Software\Microsoft\Office\10.0\Word\Resiliency\DisabledItems\")
        Err.clear
        On Error Resume Next
        objWSHShell.regdelete("HKEY_CURRENT_USER\Software\Microsoft\Office\11.0\Word\Resiliency\DisabledItems\")
        Err.clear
        On Error Resume Next
        objWSHShell.regdelete("HKEY_CURRENT_USER\Software\Microsoft\Office\12.0\Word\Resiliency\DisabledItems\")
        Err.clear
        On Error Resume Next
        Err.clear
        objWSHShell.regdelete("HKEY_CURRENT_USER\Software\Microsoft\Office\13.0\Word\Resiliency\DisabledItems\")
        Err.clear
        On Error Resume Next
        objWSHShell.regdelete("HKEY_CURRENT_USER\Software\Microsoft\Office\14.0\Word\Resiliency\DisabledItems\")
        Err.clear
        On Error Resume Next
        Err.clear
        Err.clear
        '*****************************************************************************************
    End If
    
    If erfolg = True Then
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"processmonitor.bat"&Chr(34)&" WORD",0,True)
        WScript.Sleep 200
        On Error Resume Next
        Err.clear
        erfolg = False
        versuche = 0
        Do While erfolg = False And versuche < 3 
            
            Set wordDoc = objWord.Documents.Add(dateiname&extension )
            
            WScript.sleep 200
                        
            If Err.number<>0 Then
                versuche = versuche +1
                errortxt="archivierung(100ff): Fehler bei MS-Office zu TIF Wandlung. Bitte prfen, ob das Dokument in Office ohne weitere Meldungen gedruckt werden kann, ggf. nderungen vornehmen und erneut archivieren."
                objWshShell.LogEvent 1, errortxt & vbCrLf & Err.Number & vbTab & Err.Description & vbCrLf & "Versuche:" & versuche & vbCrLf & dateiname&extension 
                Set wordDoc = Nothing
                erfolg=False
                On Error Resume Next
                Err.clear
                WScript.Sleep 2000
            Else
                erfolg = True
            End If
        Loop
        
    End If
    
    If erfolg=True Then	
        objWord.Visible = False
        objWord.DisplayAlerts = False
        objWord.Options.PrintBackground = False	
        objWord.Options.PrintHiddenText = False
        objWord.DisplayAlerts = False
        
        ' Unprotect 
        
        If objWord.ActiveDocument.ProtectionType = -1 Then    ' Dokumentenschutz ?
            If Err.number<> 0 And scriptdebug = True Then
                objWshShell.LogEvent 1,"Archivierung(100a) Fehler bei Abfrage der ProtectionType-Eigenschaft" & vbCrLf & Err.Number & vbCrLf & Err.Description	
            End If
            wordprotect = False
        Else
            objWord.ActiveDocument.Unprotect("")	
            
            If Err.Number<> 0 Then
                wordprotect = True
            Else
                wordprotect = False
            End If
        End If
        
        If scriptdebug = True Then
            objWshShell.LogEvent 4,"Archivierung DocToPs: Status nach Kennwortprfung" & vbCrLf & "wordprotect=" & wordprotect  & vbCrLf & Err.Number & vbCrLf & Err.Description	
        End If
        Err.Clear
        
        '   Printdate und Createdate Behandlung 
        If wordprotect = False And MSWordupdatefields = False Then
            For Each f1 In objWord.ActiveDocument.Sections(1).Headers(1).Range.Fields
                If InStr(1, f1.Code, "PRINTDATE") <> 0 Or InStr(1, f1.Code, "CREATEDATE") <> 0 Or InStr(1, f1.Code, "DATE") <> 0 Then
                    f1.Unlink
                End If
            Next

            If Err.number<> 0 And scriptdebug = True Then
                objWshShell.LogEvent 2,"Archivierung(100b) Fehler beim Unlink der Header" & vbCrLf & Err.Number & vbCrLf & Err.Description	
            End If

            Set f1 = Nothing
            On Error Resume Next
            Err.Clear
            
            For Each f2 In objWord.ActiveDocument.Sections(1).Footers(1).Range.Fields
                If InStr(1, f2.Code, "PRINTDATE") <> 0 Or InStr(1, f2.Code, "CREATEDATE") <> 0 Or InStr(1, f1.Code, "DATE") <> 0 Then
                    f2.Unlink
                End If
            Next

            If Err.number<> 0 And scriptdebug = True Then
                objWshShell.LogEvent 2,"Archivierung(100b) Fehler beim Unlink der Footer" & vbCrLf & Err.Number & vbCrLf & Err.Description	
            End If
            Set f2 = Nothing
            On Error Resume Next
            Err.Clear
            
            For Each f3 In objWord.ActiveDocument.Fields
                If InStr(1, f3.Code, "PRINTDATE") <> 0 Or InStr(1, f3.Code, "CREATEDATE") <> 0 Or InStr(1, f1.Code, "DATE") <> 0 Then
                    f3.Unlink
                End If
            Next

            If Err.number<> 0 And scriptdebug = True Then
                objWshShell.LogEvent 2,"Archivierung(100b) Fehler beim Unlink des Dokumenteninhaltes" & vbCrLf & Err.Number & vbCrLf & Err.Description	
            End If
            Set f3 = Nothing
            On Error Resume Next
            Err.Clear
            
            '############################################################################################
            
            If handle = "ASCII" Or fromEMAIL = True Then
                objWord.ActiveDocument.PageSetup.Orientation = 0
                objWord.ActiveDocument.PageSetup.LeftMargin = 28.4
                objWord.ActiveDocument.PageSetup.RightMargin = 18.4
                objWord.ActiveDocument.PageSetup.BottomMargin = 18.4
            End If
            
            On Error Resume Next
            Err.Clear
        End If
        
        wordDoc.PrintOut False, , , , , , 0
        
        If Err.number<>0 Then
            errortxt="archivierung(100c): Fehler bei MS-Office zu TIF Wandlung. Bitte prfen, ob das Dokument in Office ohne weitere Meldungen gedruckt werden kann, ggf. nderungen vornehmen und erneut archivieren." & vbCrLf & Err.Number & vbCrLf & Err.Description
            objWshShell.LogEvent 1, errortxt & vbCrLf & Err.Number & vbTab & Err.Description
            
            Err.clear
            erfolg=False
            On Error Resume Next
            Set wordDoc = Nothing
            Set objWord = Nothing
            On Error Resume Next
            Err.clear
        End If
    End If
    
    Err.clear
    
    
    If erfolg=True Then
        WScript.Sleep 500
        If officeOCR=False Then
            If Not fs.fileexists(dateiname&".txt") And Not fs.fileexists(dateiname&".ftx") Then
                objWord.ActiveDocument.SaveAs dateiname&".txt", 2
                
                If Err.number<>0 Then
                    errortxt="archivierung(100d): Fehler bei MS-Office zu TIF Wandlung. Bitte prfen, ob das Dokument in Office ohne weitere Meldungen als .txt gespeichert werden kann, ggf. nderungen vornehmen und erneut archivieren."
                    objWshShell.LogEvent 1, errortxt & vbCrLf & Err.Number & vbTab & Err.Description
                    erfolg=False
                    On Error Resume Next
                    Err.clear
                    Set objWord = Nothing
                    On Error Resume Next
                    Err.clear
                    
                End If
            End If
            
            Err.clear
            On Error Resume Next
            
            If fs.fileexists(dateiname&".txt") Then
                Typ="TXT"
            End If
        End If
    End If
    
    
    If erfolg=True Then
        WScript.Sleep 200	
        wordDoc.Saved = True
        
        WScript.Sleep 300
        wordDoc.Close()
        
        If Err.number<>0 Then
            errortxt="archivierung(100e): Fehler bei MS-Office zu TIF Wandlung. Bitte prfen, ob das Dokument in Office ohne weitere Meldungen gedruckt werden kann, ggf. nderungen vornehmen und erneut archivieren."
            objWshShell.LogEvent 1, errortxt & vbCrLf & Err.Number & vbTab & Err.Description
            erfolg=False
            On Error Resume Next
            Err.clear
            Set wordDoc = Nothing
            Set objWord = Nothing
            
            On Error Resume Next
            Err.clear
        End If
    End If
    
    If erfolg=True Then
        objWord.Quit
        Set wordDoc = Nothing
        Set objWord=Nothing
        
        If Err.number<>0 Then
            errortxt="archivierung(100f): Fehler bei MS-Office zu TIF Wandlung. Bitte prfen, ob das Dokument in Office ohne weitere Meldungen gedruckt werden kann, ggf. nderungen vornehmen und erneut archivieren."
            objWshShell.LogEvent 1, errortxt & vbCrLf & Err.Number & vbTab & Err.Description
            erfolg=False
            On Error Resume Next
            Err.clear
        End If
    End If
    
    If erfolg=True Then
        If fs.FileExists(dateiname&".ps") Then
            fs.deletefile dateiname&".ps", True
            WScript.sleep 200
        End If
    End If
    
    If Err.number<>0 Then
        objWshShell.LogEvent 1, "Archivierung 5-3: Ausnahmefehler"
    End If
    
    WScript.sleep 200
    If erfolg=True Then
        abbruch=False
        k=0
        Do While abbruch = False
            If fs.FileExists(temp&"Serviceprinter.ps") Then
                WScript.Sleep 600
                fs.CopyFile temp&"Serviceprinter.ps", dateiname&".ps", True
                If Err.number<>0 Then
                    Err.clear
                    On Error Resume Next
                    WScript.sleep 10000
                    fs.CopyFile temp&"Serviceprinter.ps", dateiname&".ps", True
                End If
                If Err.number<>0 Then
                    errortxt="archivierung(11-7): konnte aus Postscript-Datei nicht kopieren: " & temp&"Serviceprinter.ps -> " &  dateiname&".ps"
                    objWshShell.LogEvent 1, errortxt & vbCrLf & Err.Number & vbTab & Err.Description
                    Err.clear
                    On Error Resume Next
                    erfolg=False
                    abbruch=True
                End If
                abbruch=True
            Else
                WScript.Sleep 200
                k=k+1
                If k>280 Then
                    abbruch=True
                End If
            End If
        Loop
    End If
    
    If erfolg=True Then	
        If fs.FileExists(temp&"Serviceprinter.ps") Then
            Err.clear
            fs.deletefile temp&"Serviceprinter.ps", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
            End If
        End If
        
        
        If Not fs.FileExists(dateiname&".ps") Then
            
            errortxt="archivierung(11-8): konnte aus DOC-Datei keine PS-Datei erzeugen."
            objWshShell.LogEvent 1, errortxt & vbCrLf & Err.Number & vbTab & Err.Description
            erfolg=False
        End If
    End If
    
    If erfolg=False Then
        handle="unbekannt"
        Typ="TXT"
        OCRHandle=".tif"
        color=False
        If IsEmpty(objWord) = False Then
            Set objWord = Nothing 
        End If
    End If
    
    extension=tempextension
    
End Function



'*******************************************************************************************
'*************************************  MSG to PS  *****************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************


Function MSGtoPS(dateiname)
    On Error Resume Next
    Err.clear
    erfolg=True
    tempextension=extension
    herkunft = "eMail"
    Set wshnet = CreateObject("WScript.Network")
    If Err.number<>0 Then
        Err.clear
        errortxt="bitfarm-Archiv: Archivierung: Kann keinen Standarddrucker (1) festlegen. Entweder Serviceprinter nicht installiert oder Scripting Host Version zu alt."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
    End If
    
    If erfolg=True Then
        If setprintermethod="default" Then
            wshnet.SetDefaultPrinter "Serviceprinter"
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                errortxt="bitfarm-Archiv: Archivierung: Kann keinen Standarddrucker (2) festlegen. Entweder Serviceprinter nicht installiert oder Scripting Host Version zu alt."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
            End If
            Set wshnet=Nothing
        ElseIf setprintermethod="printui.dll" Then
            setdefault_serviceprinter()
        End If
    End If
    
    If (isBusy=True) And (rundirect=False) Then
        objWshShell.LogEvent 1, "bitfarm-Archiv Serverdienst: Kollission mit einer weiteren Instanz entdeckt."
        WScript.Quit
    End If
    
    
    If erfolg=True Then
        Set objOutlook = WScript.CreateObject("Outlook.Application")
        If Err.number <> 0 Then
            Err.clear
            errortxt="archivierung(11-5): Kein Outlook installiert oder Fehler beim Zugriff."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
        End If
    End If
    
    If erfolg=True Then
        Err.clear
        If fs.FileExists(temp&"Serviceprinter.ps") Then
            fs.deletefile temp&"Serviceprinter.ps", True
            If Err.number <> 0 Then
                errortxt="archivierung(11-6): kann Serviceprinter.ps nicht lschen."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
            End If
        End If
    End If
    
    Err.clear

    
    If extension=".vcf" Then
        extension=".txt"
    End If
    Err.clear
    
    
    If erfolg = True Then
        
        WScript.Sleep 200
        On Error Resume Next
        Err.clear
        erfolg = False
        versuche = 0
        Do While erfolg = False And versuche < 3 
            Set msg = objOutlook.CreateItemFromTemplate(dateiname&extension )
            WScript.sleep 200
            
            If Err.number<>0 Then
                Set msg = Nothing
                versuche = versuche +1
                errortxt="archivierung(100ff): Fehler bei Outlook zu TIF Wandlung. Bitte prfen, ob das Dokument in Office ohne weitere Meldungen gedruckt werden kann, ggf. nderungen vornehmen und erneut archivieren."
                objWshShell.LogEvent 1, errortxt & vbCrLf & Err.Number & vbTab & Err.Description & vbCrLf & "Versuche:" & versuche & vbCrLf & dateiname&extension
                erfolg=False
                Err.clear
                WScript.Sleep 2000
            Else
                erfolg = True
                If msg.Subject<>"" Then
                    betreff="Email:" &msg.Subject
                    For iLink = 0 To limit
                        If linkspeicher(iLink) = "" Then
                            linkspeicher(iLink) = betreff
                            Exit For
                        End If
                    Next
                End If
            End If
        Loop
    End If
    
    If erfolg Then
        msg.PrintOut 
        If Err.number<>0 Then
            errortxt="archivierung(100c): Fehler bei MSG zu TIF Wandlung. Bitte prfen, ob das Dokument in Office ohne weitere Meldungen gedruckt werden kann, ggf. nderungen vornehmen und erneut archivieren." & vbCrLf & Err.Number & vbCrLf & Err.Description
            objWshShell.LogEvent 1, errortxt & vbCrLf & Err.Number & vbTab & Err.Description
            Err.clear
            erfolg=False
        End If
    End If 
    
    Err.clear
    
    
    
    
    If erfolg=True Then
        If fs.FileExists(dateiname&".ps") Then
            fs.deletefile dateiname&".ps", True
            WScript.sleep 200
            
        End If
    End If
    
    If Err.number<>0 Then
        objWshShell.LogEvent 1, "Archivierung 5-3: Ausnahmefehler"
    End If
    
    WScript.sleep 200
    If erfolg=True Then
        abbruch=False
        k=0
        Do While abbruch = False
            If fs.FileExists(temp&"Serviceprinter.ps") Then
                
                fs.CopyFile temp&"Serviceprinter.ps", dateiname&".ps", True
                If Err.number<>0 Then
                    Err.clear
                    On Error Resume Next
                    WScript.sleep 10000
                    fs.CopyFile temp&"Serviceprinter.ps", dateiname&".ps", True
                End If
                If Err.number<>0 Then
                    errortxt="archivierung(11-7): konnte aus Postscript-Datei nicht kopieren: " & temp&"Serviceprinter.ps -> " &  dateiname&".ps"
                    objWshShell.LogEvent 1, errortxt & vbCrLf & Err.Number & vbTab & Err.Description
                    Err.clear
                    On Error Resume Next
                    erfolg=False
                    abbruch=True
                End If
                abbruch=True
            Else
                WScript.Sleep 200
                k=k+1
                If k>280 Then
                    abbruch=True
                End If
            End If
        Loop
    End If
    
    If erfolg=True Then	
        If fs.FileExists(temp&"Serviceprinter.ps") Then
            Err.clear
            fs.deletefile temp&"Serviceprinter.ps", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
            End If
        End If
        
        
        If Not fs.FileExists(dateiname&".ps") Then
            
            errortxt="archivierung(11-8): konnte aus DOC-Datei keine PS-Datei erzeugen."
            objWshShell.LogEvent 1, errortxt & vbCrLf & Err.Number & vbTab & Err.Description
            erfolg=False
        End If
    End If
    
    ' Anhnge extrahieren
    If erfolg And (Not dontExtractMsgAttachments) And (Not changeling)  And (InStr(Filtermakro,"fromoutlook")=0) Then
        If msg.Attachments.Count > 0 Then
            For iLink = 0 To limit
                If linkspeicher(iLink) = "" Then
                    linkspeicher(iLink) = betreff
                    Exit For
                End If
            Next
            
            For iAtt = 1 To msg.Attachments.Count
                
                sFilename = msg.Attachments(iAtt).FileName
                sExt = "." & fs.GetExtensionName(sFilename)
                sJobname = getfifo(queue, "temp-msg")
                msg.Attachments(iAtt).SaveAsFile sJobname & sExt
                
                If Err.Number <> 0 Then
                    Err.Clear
                Else 'erfolgreich extrahiert? dann Job und slw schreiben
                    
                    Set swdfile = fs.opentextfile(sJobname & ".slw",8,True)
                    swdfile.writeline "Dateiname=" & Replace(sFilename, fs.GetExtensionName(sFilename),"")
                    swdfile.close
                    Err.Clear
                    
                    fs.Copyfile dateiname & ".job", sJobname & ".job", True
                    WScript.Sleep 250
                    If Not writeemailjob(sJobname) Then
                        objWshShell.LogEvent 1, "Fehler beim Schreiben einer Jobdatei fr ein Attachment"
                        If Not fs.fileexists(sJobname & ".job") Then
                            fs.deletefile sJobname & ".swd", True
                            fs.deletefile sJobname & sExt, True
                            Err.Clear
                        End If 
                    End If 	
                    
                End If 
            Next
        End If 	
    End If
    
    
    If erfolg=True Then
        objOutlook.Quit
        Set msg = Nothing
        Set objOutlook=Nothing
        
        If Err.number<>0 Then
            errortxt="archivierung(100f): Fehler bei MS-Office zu TIF Wandlung. Bitte prfen, ob das Dokument in Office ohne weitere Meldungen gedruckt werden kann, ggf. nderungen vornehmen und erneut archivieren."
            objWshShell.LogEvent 1, errortxt & vbCrLf & Err.Number & vbTab & Err.Description
            erfolg=False
            Err.clear
        End If
    End If
    
    
    
    If erfolg=False Then
        handle="unbekannt"
        Typ="TXT"
        OCRHandle=".tif"
        color=False
    End If
    
    objOutlook.Quit
    Set msg = Nothing
    Set objOutlook=Nothing 
    extension=tempextension
    
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='OUTLOOK.EXE'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    z=0
    For Each objItem In colItems
        objItem.Terminate()
        z=z+1
    Next
    
End Function




'*******************************************************************************************
'*************************************  PPT to PS  *****************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

Function PPTtoPS(dateiname)
    On Error Resume Next
    erfolg=True
    
    If (isBusy=True) And (rundirect=False) Then
        objWshShell.LogEvent 1, "bitfarm-Archiv Serverdienst: Kollission mit einer weiteren Instanz entdeckt."
        WScript.Quit
    End If
    
    Set wshnet = CreateObject("WScript.Network")
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        errortxt="bitfarm-Archiv: Archivierung: Kann keinen Standarddrucker (1) festlegen. Entweder Serviceprinter nicht installiert oder Scripting Host Version zu alt."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
    End If
    
    If erfolg=True Then
        If setprintermethod="default" Then
            wshnet.SetDefaultPrinter "Serviceprinter"
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                errortxt="bitfarm-Archiv: Archivierung: Kann keinen Standarddrucker (2) festlegen. Entweder Serviceprinter nicht installiert oder Scripting Host Version zu alt."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
            End If
            Set wshnet=Nothing
        ElseIf setprintermethod="printui.dll" Then
            setdefault_serviceprinter()
        End If
    End If
    
    Err.clear
    
    If erfolg=True Then
        Set objPPT = WScript.CreateObject("PowerPoint.Application")
        If Err.number <> 0 Then
            errortxt="archivierung(11-9): Kein Powerpoint installiert - Fehler beim Zugriff."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
            
        End If
    End If
    
    If erfolg=True Then
        Err.clear
        If fs.FileExists(temp&"Serviceprinter.ps") Then
            fs.deletefile temp&"Serviceprinter.ps", True
            If Err.number <> 0 Then
                errortxt="archivierung(11-10): kann Serviceprinter.ps nicht lschen."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
            End If
        End If
    End If
    
    If erfolg=True Then
        Set attribhandle=fs.GetFile(dateiname&extension)
        attribhandle.Attributes=attribhandle.Attributes And Not 1 And Not (8+16+64+128)
        Set attribhandle=Nothing
        WScript.Sleep 200
        
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"processmonitor.bat"&Chr(34)&" POWERPOINT",0,True)
        WScript.Sleep 200
        On Error Resume Next
        Err.clear
    End If
    
    If erfolg=True Then
        Set oPPTDoc=objPPT.Presentations.Open(dateiname&extension,False,False,False)
        
        If Err.number<>0 Then
            On Error Resume Next
            Err.clear
            errortxt="archivierung(100g): Fehler bei MS-Office zu TIF Wandlung. Bitte prfen, ob das Dokument in Office ohne weitere Meldungen gedruckt werden kann, ggf. nderungen vornehmen und erneut archivieren."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
            Set objPPT=Nothing
            On Error Resume Next
            Err.clear
            
        End If
    End If
    
    
    If erfolg=True Then
        With(oPPTDoc.PrintOptions)
            .RangeType = 1
            .NumberOfCopies = 1
            
            If SavePPasList=True Then
                .OutputType = 6		
            Else
                .OutputType = 1
            End If
            .PrintHiddenSlides = False
            
            .FitToPage = True
            
            '.PrintInBackground = true
            .PrintInBackground = False 'changed due to Problems with large PPT-Files 3.5.0.10
            
            .ActivePrinter = "Serviceprinter"
        End With
        
        If Err.number<>0 Then
            On Error Resume Next
            Err.clear
            errortxt="archivierung(100h): Fehler bei MS-Office zu TIF Wandlung. Bitte prfen, ob das Dokument in Office ohne weitere Meldungen gedruckt werden kann, ggf. nderungen vornehmen und erneut archivieren."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
            Set objPPT=Nothing
            On Error Resume Next
            Err.clear
            Set oPPTDoc=Nothing
            On Error Resume Next
            Err.clear
            
        End If   
    End If 
    
    If erfolg=True Then    
        oPPTDoc.PrintOut()
        
        If Err.number<>0 Then
            On Error Resume Next
            Err.clear
            errortxt="archivierung(100i): Fehler bei MS-Office zu TIF Wandlung. Bitte prfen, ob das Dokument in Office ohne weitere Meldungen gedruckt werden kann, ggf. nderungen vornehmen und erneut archivieren."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
            Set objPPT=Nothing
            On Error Resume Next
            Err.clear
            Set oPPTDoc=Nothing
            On Error Resume Next
            Err.clear
        End If   
        
        
        
        WScript.Sleep 1000
    End If    
    
    If erfolg=True Then
        oPPTDoc.Close
        Set oPPTDoc = Nothing
        
        If Err.number<>0 Then
            On Error Resume Next
            Err.clear
            errortxt="archivierung(100j): Fehler bei MS-Office zu TIF Wandlung. Bitte prfen, ob das Dokument in Office ohne weitere Meldungen gedruckt werden kann, ggf. nderungen vornehmen und erneut archivieren."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
            Set objPPT=Nothing
            On Error Resume Next
            Err.clear
        End If
    End If
    
    If erfolg=True Then
        objPPT.Quit
        Set objPPT=Nothing
        
        If Err.number<>0 Then
            On Error Resume Next
            Err.clear
            errortxt="archivierung(100k): Fehler bei MS-Office zu TIF Wandlung. Bitte prfen, ob das Dokument in Office ohne weitere Meldungen gedruckt werden kann, ggf. nderungen vornehmen und erneut archivieren."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
        End If
    End If
    
    If erfolg=True Then
        If fs.FileExists(dateiname&".ps") Then
            fs.deletefile dateiname&".ps", True
        End If
    End If
    
    WScript.sleep 200
    
    If erfolg=True Then
        abbruch=False
        k=0
        Do While abbruch = False
            If fs.FileExists(temp&"Serviceprinter.ps") Then
                WScript.Sleep 400
                Err.clear
                fs.CopyFile temp&"Serviceprinter.ps", dateiname&".ps", True
                If Err.number<>0 Then
                    Err.clear
                    On Error Resume Next
                    WScript.sleep 10000
                    fs.CopyFile temp&"Serviceprinter.ps", dateiname&".ps", True
                End If
                If Err.number<>0 Then
                    errortxt="archivierung(11-11): konnte aus Postscript-Datei nicht kopieren."&Err.number
                    Err.clear
                    On Error Resume Next
                    
                    objWshShell.LogEvent 1, errortxt
                    erfolg=False
                    abbruch=True
                End If
                abbruch=True
            Else
                WScript.Sleep 200
                k=k+1
                If k>200 Then
                    abbruch=True
                End If
            End If
        Loop
    End If
    
    If erfolg=True Then	
        If fs.FileExists(temp&"Serviceprinter.ps") Then
            Err.clear
            fs.deletefile temp&"Serviceprinter.ps", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
            End If
        End If
    End If
    
    If erfolg=True Then		
        If Not fs.FileExists(dateiname&".ps") Then
            
            errortxt="archivierung(11-12): konnte aus PPT-Datei keine PS-Datei erzeugen."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
        End If
    End If
    
    If erfolg=False Then
        handle="unbekannt"
        Typ="TXT"
        OCRHandle=".tif"
        color=False
        
    End If
    
End Function


Function clean_emltemp()
    If scriptdebug=True Then
        objWSHShell.LogEvent 1, "archivierung.vbs: clean_emltemp gestartet."
    End If
    If fs.folderexists (programm & "emltemp\temp\meta") Then
        For Each file In fs.getfolder(programm & "emltemp\temp\meta").files 
            fs.deletefile file, True
        Next
        fs.deletefolder(programm & "emltemp\temp\meta")
    End If
    
    If fs.folderexists (programm & "emltemp\temp\attachments") Then
        For Each file In fs.getfolder(programm & "emltemp\temp\attachments").files 
            fs.deletefile file, True
        Next
        fs.deletefolder(programm & "emltemp\temp\attachments")
    End If
    
    If fs.folderexists (programm & "emltemp\temp") Then
        For Each file In fs.getfolder(programm & "emltemp\temp").files 
            fs.deletefile file, True
        Next
        
    End If
    
    If fs.folderexists (programm & "emltemp") Then
        For Each file In fs.getfolder(programm & "emltemp").files 
            fs.deletefile file, True
        Next
    End If
End Function





'*******************************************************************************************
'*************************************  ODT to PS neu (pdf) ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

Function ODTtoPS_neu(dateiname)
    On Error Resume Next
    Err.clear
    erfolg=True
    If checkexistingdocpreview = True Then
        If fs.fileexists(dateiname & ".tif") Then
            Exit Function    ' keine neue Voransicht erstellen
        End If
    End If
    
    If Not fs.FileExists(openofficepath & "soffice.exe") Then
        erfolg = False
        objWshShell.LogEvent 1, "Archivierung.vbs: ODTtoPS_neu: OpenOffice nicht korrekt installiert oder Pfad falsch!" & vbCrLf & openofficepath
        objWshShell.LogEvent 1, "Archivierung.vbs: Das Dokument wird in den Garbage verschoben, weil keine Voransicht erstellt werden konnte."
    End If
    
    ' Als PDF speichern
    If usepdfmacro = True Then
    	cmd=Chr(34)&openofficepath&"soffice"&Chr(34)&" --nofirststartwizard --headless -nocrashreport -norestore "&Chr(34)&"macro:///bitfarm.bitfarm.SpeichernAlsPDF("& dateiname & extension &","& xlsmaxpages+1000&")"&Chr(34)
    Else
		cmd = Chr(34)&openofficepath&"soffice"&Chr(34)&" --nofirststartwizard --headless --convert-to pdf:calc_pdf_Export --outdir " & Chr(34) & programm &"\queue" & Chr(34) & " "  & Chr(34) & dateiname & extension & Chr(34)    
    End If
    
    objWSHShell.LogEvent 0, "archivierung.vbs: OO-Aufruf:"&vbCrLf&cmd
    Set OExec 	 = objWSHShell.Exec(cmd)
    timeout_t1 = False
    timeout_t2 = False
    lo_start_tstamp = Now()
    If timeoutprocess("soffice.exe",480) = True Then
        errtxt = "archivierung.vbs ODTtoPS_neu: OpenOffice/LibreOffice Makro SpeichernAlsPDF gescheitert (timeout). Das Dokument wird mit verkrzter Voransicht archiviert."
        objWSHShell.LogEvent 1, errtxt
        timeout_t1 = True
        ' nochmal mit maximal 10 Seiten exportieren
        xlsmaxpages=10
        Set oExec    = objWSHShell.Exec(Chr(34)&openofficepath&"soffice"&Chr(34)&" --nofirststartwizard --headless -nocrashreport -norestore "&Chr(34)&"macro:///bitfarm.bitfarm.SpeichernAlsPDF("& dateiname & extension &","& xlsmaxpages&")"&Chr(34))
        If timeoutprocess("soffice.exe",480) = True Then
            errtxt = "archivierung.vbs ODTtoPS_neu: OpenOffice/LibreOffice Makro SpeichernAlsPDF gescheitert (timeout). Das Dokument wird mit verkrzter Voransicht archiviert."
            objWSHShell.LogEvent 1, errtxt
            timeout_t2 = True
        End If
    End If
    If timeout_t1 = False or timeout_t2 = False Then
        
        ' ltere OO-Makros (vor 1.0.6) setzen die Endung pdf nicht korrekt, wenn die ursprngliche extension mehr als 3 chars hat
        If fs.fileexists(tempname&".dpdf") Then
            fs.movefile tempname&".dpdf", tempname&".pdf"
        ElseIf fs.fileexists(tempname&".ppdf") Then
            fs.movefile tempname&".ppdf", tempname&".pdf"
        ElseIf fs.fileexists(tempname&".xpdf") Then
            fs.movefile tempname&".xpdf", tempname&".pdf"
        End If
        
        
        If Not fs.fileexists(tempname&".pdf") Then
            errtxt = "archivierung.vbs: ODTtoPS_neu: Konnte aus Officedokument kein PDF erzeugen. Das Dokument wird ohne Voransicht archiviert."
            objWSHShell.LogEvent 1, errtxt
            makefilltif(tempname)
        Else   
            ' Textextraktion mit pdf2txt.bat wenn officeocr False 
            '#### Textextraktion
            If officeOCR = False Then
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"PDFtoTXT.bat"&Chr(34)&" "&Chr(34)&tempname&".pdf"&Chr(34),0,True)
                If lngReturnCode <> 0 Then
                    Typ="OMP"
                    officeOCR=True
                End If
                
                If fs.fileexists(dateiname&".txt") Then
                    Typ="TXT"
                    ' Setzen, damit pdftotiff kein ocr-tif erzeugt(wird nicht bentigt)
                    extractpdf=True 
                Else
                    Typ="OMP"
                    officeOCR=True	
                    extractpdf=False 			
                End If
            End If
            
            
            If IsInArray(extension, excelextensions) Then
                maxpdfpages = xlsmaxpages
            Else
                maxpdfpages = 10000
            End If
            
            
            ' PDF nach Tif wandeln  
            If color = True Then
                PDFtoColorTIF(dateiname)
            Else
                PDFtoTIF(dateiname)
            End If
            If fs.fileexists(tempname&".pdf") Then
                fs.deletefile tempname&".pdf", True
            End If
            If Not fs.fileexists(tempname&".tif") Then
                errtxt = "archivierung.vbs: ODTtoPS_neu: Fehler beim Erstellen der Voransicht. Das Dokument wird ohne Voransicht archiviert."
                objWSHShell.LogEvent 1, errtxt
                makefilltif(tempname)
            End If
        End If
        
    Else
    	If Not fs.fileexists(tempname&".tif") Then
            errtxt = "archivierung.vbs: ODTtoPS_neu: Konnte aus Officedokument kein PDF erzeugen. Das Dokument wird ohne Voransicht archiviert."
            objWSHShell.LogEvent 1, errtxt
            makefilltif(tempname)
        End If
    End If
    solockfile = queue&".~lock."&Replace(tempname,queue,"",1,-1,1)&".pdf#"
    objWSHShell.LogEvent 0, "archivierung.vbs: 1 entferne temporre OO-Datei " & solockfile
    If fs.fileexists(solockfile) Then
        objWSHShell.LogEvent 0, "archivierung.vbs: 2 entferne temporre OO-Datei " & solockfile
        fs.DeleteFile solockfile,True
    End If
    If timeout_t1 =True Or timeout_t2=True Then
    	' timeout_t1 oder timeout_t2 getriggert -> entfernen von von lo erzeugten tmp-Dateien
        delete_lo_tmpfiles(lo_start_tstamp)
    End If
    If timeout_t1 = True And timeout_t2=False Then
    	' verkrzte Voransicht, Infoseite anhngen
    	objWSHShell.LogEvent 1, "archivierung.vbs verkrzte Voransicht wegen Libreoffice-Timeout"
    	
    	If LCase(newstatuslang="deutsch") Then
                msgtxt1="Diese Voransicht enthlt nicht alle Seiten des Originaldokuments." 
                msgtxt3="Fr eine komplette Dokumentenansicht ffnen Sie das Dokument"
                msgtxt4="ber den Button 'Originaldatei'."
            Else
                msgtxt1="This preview does not contain all pages of the original file."
                msgtxt3="To open the original file klick the Button 'original file'." 
                msgtxt4=""
            End If   
            
			If fs.fileexists(dateiname&"-temp.tff") Then
                fs.deletefile dateiname&"-temp.tff", True
            End If         
            
            Set temptxtfile = fs.OpenTextFile(dateiname&"-shortened_preview.tff",8,True)
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" " & msgtxt1 & " ")
            temptxtfile.writeline(" " & msgtxt3 & " ")
            temptxtfile.writeline(" " & msgtxt4 & " ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.close
            Set temptxtfile=Nothing
            
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"Text2TIF.exe"&Chr(34)&" "&Chr(34)&dateiname&"-shortened_preview.tff"&Chr(34),0,True)
            
            WScript.Sleep 200
            fs.deletefile dateiname&"-shortened_preview.tff",True
            
            If lngReturnCode <> 0 Then

                Err.clear
                errortxt="archivierung(123g): Fehler bei Text2TIF.exe"
                objWshShell.LogEvent 1, errortxt
                GetGarbage(dateiname)   
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
            
            If (fs.fileexists(dateiname&"-shortened_preview.tif")) And (fs.fileexists(dateiname&"-archiv.tif")) Then
	            lngReturnCode = objWSHShell.Run(programm&"splitterv3.exe -a " &Chr(34)&dateiname&"-archiv.tif"&Chr(34) & " " &Chr(34)& dateiname&"-shortened_preview.tif"&Chr(34),0,True)
	        End If
	        If (fs.fileexists(dateiname&"-shortened_preview.tif")) Then
	        	fs.deletefile dateiname&"-shortened_preview.tif",True
	        	
	        End If
            
            
    	
    End If
End Function



'*******************************************************************************************
'*************************************  ODT to PS  *****************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

Function ODTtoPS(dateiname)
    On Error Resume Next
    Err.clear
    
    erfolg=True
    tempextension=extension
    
    If Not fs.FileExists(openofficepath & "soffice.exe") Then
        erfolg = False
        objWshShell.LogEvent 1, "Archivierung.vbs: OpenOffice nicht korrekt installiert oder Pfad falsch !" & vbCrLf & openofficepath
    End If
    
    
    
    Set wshnet = CreateObject("WScript.Network")
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        errortxt="bitfarm-Archiv: Archivierung: Kann keinen Standarddrucker (1) fr OpenOffice festlegen. Entweder Serviceprinter nicht installiert oder Scripting Host Version zu alt."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
    End If
    
    If erfolg=True Then
        If setprintermethod="default" Then
            wshnet.SetDefaultPrinter "Serviceprinter"
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                errortxt="bitfarm-Archiv: Archivierung: Kann keinen Standarddrucker (2) festlegen. Entweder Serviceprinter nicht installiert oder Scripting Host Version zu alt."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
            End If
            Set wshnet=Nothing
        ElseIf setprintermethod="printui.dll" Then
            setdefault_serviceprinter()
        End If
    End If
    
    If (isBusy=True) And (rundirect=False) Then
        objWshShell.LogEvent 1, "bitfarm-Archiv Serverdienst: Kollission mit einer weiteren Instanz entdeckt."
        WScript.Quit
    End If
    
    If erfolg=True Then
        Err.clear
        If fs.FileExists(temp&"Serviceprinter.ps") Then
            fs.deletefile temp&"Serviceprinter.ps", True
            If Err.number <> 0 Then
                errortxt="archivierung(11-13): kann Serviceprinter.ps nicht lschen."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
                Set objWord = Nothing
            End If
        End If
    End If
    
    
    If erfolg = True Then
        Beginn = Timer
        
        If extension = ".ppt" Or extension = ".pps" Or extension = ".pptx" Then
            Set oExec    = objWSHShell.Exec(Chr(34)&openofficepath&"soffice"&Chr(34)&" --nofirststartwizard --headless -nocrashreport -norestore "&Chr(34)&"macro:///bitfarm.bitfarm.SpeichernAlsTIF("&dateiname & extension &")"&Chr(34))
        Else 
            Set oExec    = objWSHShell.Exec(Chr(34)&openofficepath&"soffice"&Chr(34)&" --nofirststartwizard --headless -nocrashreport -norestore "&Chr(34)&"macro:///bitfarm.bitfarm.drucken("& dateiname & extension &")"&Chr(34))
        End If
        Err.Clear
        
        durch = False
        schleife = 0
        Do While schleife < 800
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 100  
            schleife = schleife +1
        Loop
        Ende = Timer
        If scriptdebug = True Then
            objWshShell.LogEvent 4, "Versuche:" & schleife
        End If
        
        If durch = True Then
            erfolg = True
            If extension = ".ppt" Or extension = ".pps" Or extension = ".pptx" Then
                WScript.Sleep 100  
                If fs.Fileexists(dateiname & ".ptif") Then
                    fs.movefile dateiname & ".ptif", dateiname & ".tif"
                End If
                
                If fs.Fileexists(dateiname & ".tif") Then
                    erfolg = True	
                    If hires = True Then
                        If color = True Then
                            lngReturnCode = runfilter(dateiname&".tif",programm&"TIFF-300.txt",dateiname&"-archiv.tif")								
                        Else
                            lngReturnCode = runfilter(dateiname&".tif",programm&"TIFF-300-bw.txt",dateiname&"-archiv.tif")
                        End If
                    Else
                        If color = True Then
                            If dpi="" Then
                                lngReturnCode = runfilter(dateiname&".tif",programm&"TIFF-200.txt",dateiname&"-archiv.tif")
                            Else
                                lngReturnCode = runfilter(dateiname&".tif",programm&"temp\custom-filter-color.txt",dateiname&"-archiv.tif")
                            End If	
                        Else
                            If dpi="" Then
                                lngReturnCode = runfilter(dateiname&".tif",programm&"TIFF-200-bw.txt",dateiname&"-archiv.tif")
                            Else
                                lngReturnCode = runfilter(dateiname&".tif",programm&"temp\custom-filter-bw.txt",dateiname&"-archiv.tif")
                            End If	
                        End If
                    End If
                    
                    If lngReturnCode <> 0 Then
                        Err.clear
                        On Error Resume Next
                        errortxt="archivierung(11-14): Fehler beim Filtern des Archivtifs. Bitte Filterdateien berprfen"
                        objWshShell.LogEvent 1, errortxt
                        archivtif=dateiname
                    Else
                        archivtif=dateiname&"-archiv"	
                    End If
                    
                Else
                    objWSHShell.LogEvent 1, "Archivierung: ODTtoPS - Fehler bei .ppt zu Tif-Wandlung, Datei nicht erstellt"
                    
                    erfolg = False
                End If
                
                If fs.FileExists(dateiname&".pdf") Then
                    Err.clear
                    fs.deletefile dateiname&".pdf", True
                    If Err.number<>0 Then
                        Err.clear
                        On Error Resume Next
                    End If
                End If
                
            End If
            
        Else
            erfolg = False
            objWshShell.LogEvent 1, "Archivierung.vbs: Konnte OpenOfficeDokument nicht auf PS -Drucker ausgeben" & vbCrLf & "evtl Timeout oder nicht vorhanden" & vbCrLf & "Versuche:" & schleife
            
            Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
            strQuery = "Select * from Win32_Process where Name='soffice.bin'"
            Set colItems = objWMIService.ExecQuery(strQuery,,48)
            z=0
            For Each objItem In colItems
                objItem.Terminate()
                z=z+1
            Next
            If z>0 Then
                objWshShell.LogEvent 2, "bitfarm-Archiv Exception-Handling: Terminierte soffice.bin-Instanzen: "&z
            End If
            Set objItem = Nothing
            Set colItems = Nothing
            Set objWMIService = Nothing
            
            Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
            strQuery = "Select * from Win32_Process where Name='soffice.exe'"
            Set colItems = objWMIService.ExecQuery(strQuery,,48)
            z=0
            For Each objItem In colItems
                objItem.Terminate()
                z=z+1
            Next
            If z>0 Then
                objWshShell.LogEvent 2, "bitfarm-Archiv Exception-Handling: Terminierte soffice.exe-Instanzen: "&z
            End If
            Set objItem = Nothing
            Set colItems = Nothing
            Set objWMIService = Nothing
            
        End If
        Set oExec = Nothing
    End If
    
   
    If erfolg=True Then
        
        Set attribhandle=fs.GetFile(dateiname&extension)
        attribhandle.Attributes=attribhandle.Attributes And Not 1 And Not (8+16+64+128)
        Set attribhandle=Nothing
        WScript.Sleep 200
        
    End If
    
    Err.clear
    
    
    If erfolg = True Then
        WScript.Sleep 500
        If officeOCR=False Then
            If Not fs.fileexists(dateiname&".txt") Then	
                If extension = ".odt" Or extension=".ott" Or extension=".sdw" Or extension=".sxw" Or extension=".stw" Or extension = ".htm" Or extension=".rtf" Or extension=".doc" Or extension=".docx" Then
                    Set oExec    = objWSHShell.Exec(Chr(34)&openofficepath&"soffice"&Chr(34)&" --nofirststartwizard --headless -nocrashreport -norestore "&Chr(34)&"macro:///bitfarm.bitfarm.SpeichernAlsTXT("& dateiname & extension &")"&Chr(34))
                    On Error Resume Next
                    Do While oExec.Status = 0
                        t= t +1
                        WScript.Sleep 100
                        If oExec.Status = 1 Then Exit Do
                        If t>500 Then Exit Do	
                    Loop
                    
                    If oExec.Status <> 1 Then
                        objWSHShell.LogEvent 1, "Archivierung: ODTtoPS - Fehler beim Textspeichern einer .odt-Datei   -Timeout"
                        
                    End If
                    
                    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
                    strQuery = "Select * from Win32_Process where Name='soffice.bin'"
                    Set colItems = objWMIService.ExecQuery(strQuery,,48)
                    z=0
                    For Each objItem In colItems
                        objItem.Terminate()
                        z=z+1
                    Next
                    If z>0 Then
                        objWshShell.LogEvent 2, "bitfarm-Archiv Exception-Handling: Terminierte soffice.bin-Instanzen: "&z
                    End If
                    Set objItem = Nothing
                    Set colItems = Nothing
                    Set objWMIService = Nothing
                    
                    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
                    strQuery = "Select * from Win32_Process where Name='soffice.exe'"
                    Set colItems = objWMIService.ExecQuery(strQuery,,48)
                    z=0
                    For Each objItem In colItems
                        objItem.Terminate()
                        z=z+1
                    Next
                    If z>0 Then
                        objWshShell.LogEvent 2, "bitfarm-Archiv Exception-Handling: Terminierte soffice.exe-Instanzen: "&z
                    End If
                    Set objItem = Nothing
                    Set colItems = Nothing
                    Set objWMIService = Nothing
                    
                    
                End If
                If (extension = ".ods")  Or (extension=".ots") Or (extension=".xls") Or (extension=".csv") Or (extension=".xlt") Or (extension=".xlsx") Or (extension=".xlsm") Or (extension=".xltx") Or (extension=".xltm") Or (extension=".dbf") Or (extension=".sdc") Or (extension=".stc") Or (extension=".sxc") Then
                    Set oExec    = objWSHShell.Exec(Chr(34)&openofficepath&"scalc"&Chr(34)&" --nofirststartwizard --headless -nocrashreport -norestore "&Chr(34)&"macro:///bitfarm.bitfarm.SpeichernAlsCSV("&dateiname & extension &")"&Chr(34))
                    Do While oExec.Status = 0
                        t= t +1
                        WScript.Sleep 100
                        If oExec.Status = 1 Then Exit Do
                        If t>50 Then Exit Do	
                    Loop
                    
                    If oExec.Status <> 1 Then
                        objWSHShell.LogEvent 1, "Archivierung: ODTtoPS - Fehler beim Textspeichern einer .ods-Datei  -Timeout"
                    End If
                    
                End If
                t = 0
                Do While t<100
                    If fs.fileexists(dateiname&".txt") Then Exit Do
                    t= t +1
                    WScript.Sleep 100
                Loop
                
                Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
                strQuery = "Select * from Win32_Process where Name='soffice.bin'"
                Set colItems = objWMIService.ExecQuery(strQuery,,48)
                z=0
                For Each objItem In colItems
                    objItem.Terminate()
                    z=z+1
                Next
                If z>0 Then
                    objWshShell.LogEvent 2, "bitfarm-Archiv Exception-Handling: Terminierte soffice.bin-Instanzen: "&z
                End If
                Set objItem = Nothing
                Set colItems = Nothing
                Set objWMIService = Nothing
                
                Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
                strQuery = "Select * from Win32_Process where Name='soffice.exe'"
                Set colItems = objWMIService.ExecQuery(strQuery,,48)
                z=0
                For Each objItem In colItems
                    objItem.Terminate()
                    z=z+1
                Next
                If z>0 Then
                    objWshShell.LogEvent 2, "bitfarm-Archiv Exception-Handling: Terminierte soffice.exe-Instanzen: "&z
                End If
                Set objItem = Nothing
                Set colItems = Nothing
                Set objWMIService = Nothing
                
                
                If fs.fileexists(dateiname&".txt") Then
                    Typ="TXT"				
                End If
            End If
            
        End If
        '	
        Set oExec = Nothing
    End If
    
    WScript.sleep 200
    
    If extension<>".ppt" And extension <>".pps"  And extension <>".pptx"Then
        
        
        If erfolg=True Then
            abbruch=False
            k=0
            Do While abbruch = False
                If fs.FileExists(temp&"Serviceprinter.ps") Then
                    WScript.Sleep 400
                    Err.clear
                    fs.CopyFile temp&"Serviceprinter.ps", dateiname&".ps", True
                    If Err.number<>0 Then
                        Err.clear
                        On Error Resume Next
                        WScript.sleep 10000
                        fs.CopyFile temp&"Serviceprinter.ps", dateiname&".ps", True
                    End If
                    If Err.number<>0 Then
                        errortxt="archivierung(11-15): konnte aus Postscript-Datei nicht kopieren."&Err.number
                        Err.clear
                        On Error Resume Next
                        
                        objWshShell.LogEvent 1, errortxt
                        erfolg=False
                        abbruch=True
                    End If
                    abbruch=True
                Else
                    WScript.Sleep 200
                    k=k+1
                    If k>280 Then
                        abbruch=True
                    End If
                End If
            Loop
        End If
        
        
        If erfolg=True Then	
            Set oExec = Nothing
            If fs.FileExists(temp&"Serviceprinter.ps") Then
                Err.clear
                fs.deletefile temp&"Serviceprinter.ps", True
                If Err.number<>0 Then
                    Err.clear
                    On Error Resume Next
                End If
            End If
            
            If Not fs.FileExists(dateiname&".ps") Then
                errortxt="Archivierung.vbs: konnte aus OpenOffice-Datei keine PS-Datei erzeugen."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
            End If
        End If
        
    End If
    
    
    If erfolg=False Then
        handle="unbekannt"
        Typ="TXT"
        OCRHandle=".tif"
        color=False
        
    End If
    
    extension=tempextension
    
End Function




'*******************************************************************************************
'*************************************  PDF to TIF  ****************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************


Function PDFtoTIF(dateiname)
    
    On Error Resume Next
    Err.clear
    erfolg=True
    
    If forceomp=True Then
    	extractpdf = False
    End If
    
    If fs.fileexists(dateiname&".ps") Then
        fs.deletefile dateiname&".ps", True
    End If
    
    ' Auf schon vorhandene, mitgelieferte Voransichten prfen 
    
    
    If checkexistingdocpreview = True Then
        If fs.fileexists(dateiname & ".tif") Then
            Exit Function    ' keine neue Voransicht erstellen
        End If
    Else
        If fs.fileexists(dateiname & ".tif") Then
            fs.deletefile dateiname&".tif", True
            If Err.number<>0 Then
                
                errortxt="archivierung(13-0): Fehler bei lschen einer tif-Datei." & dateiname & ".tif" & vbCrLf & Err.number
                objWshShell.LogEvent 1, errortxt
                Err.clear
                On Error Resume Next
            End If
        End If
        
    End If
    
    If extension = ".sig" Then
        fs.copyfile dateiname & ".sig", dateiname &".pdf"
    End If
    
    ' Anzahl der PDF-Seiten ermitteln
    If ((fs.fileexists(programm&"pdfinfo.bat")) And (fs.fileexists(programm&"pdfinfo.exe"))) Then
        pdfpages=0
        zaehler=0
        strinput=""
        If scriptdebug = True Then
            objWshShell.LogEvent 4, "Archivierung: starte PDFInfo.exe"
        End If
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"pdfinfo.bat"&Chr(34)&" "&Chr(34)&dateiname&".pdf"&Chr(34)&" "&Chr(34)&dateiname&".pdi"&Chr(34),0,True)
        WScript.Sleep 1000
        errn = Err.number
        If fs.fileexists(dateiname&".pdi") Then
            Set quellswfile = fs.OpenTextFile(dateiname&".pdi",1)
            strinput = ""
            Do While quellswfile.AtEndOfStream <> True
                strinput=strinput+quellswfile.readline&vbCrLf
            Loop
            quellswfile.close
            Set quellswfile = Nothing
            fs.deletefile dateiname&".pdi",True
        End If
        
        
        If InStr(1,strinput, "Pages:",1) <> 0 Then	
            pos = InStr(1,strinput, "Pages:",1) +6
            pos2 = InStr(pos,strinput, vbCrLf) 
            pages = Mid(strinput, pos, pos2 - pos)
            pdfpages = CInt(Trim(pages))
        End If
    Else
        pdfpages = 1000
    End If
    
    
    If LCase(CustomPDFtoTIFFConverter)="pdftotiff" Then '******************************************
        
        If hires=True Then
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"pdftotiff"&Chr(34)&" -i "&Chr(34)&dateiname&".pdf"&Chr(34)&" -o "&Chr(34)&queue&Chr(34)&" -c JPG -m -x 300 -y 300",0,True)
        Else
            If dpi="" Then
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"pdftotiff"&Chr(34)&" -i "&Chr(34)&dateiname&".pdf"&Chr(34)&" -o "&Chr(34)&queue&Chr(34)&" -c JPG -m -x 200 -y 200",0,True)
            Else
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"pdftotiff"&Chr(34)&" -i "&Chr(34)&dateiname&".pdf"&Chr(34)&" -o "&Chr(34)&queue&Chr(34)&" -c JPG -m -x "&dpi&" -y "&dpi,0,True)
            End If
        End If
        If Not fs.fileexists(dateiname&".tif") Then
            Err.clear
            errortxt="archivierung(12-1): Fehler bei pdftotiff: keine TIF-Datei erzeugt. PDF-Datei mglicherweise fehlerhaft."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
        End If
        If erfolg=True Then
            fs.copyfile dateiname&".tif", dateiname&"-archiv.tif", True
            archivtif=dateiname&"-archiv"
        End If
        If erfolg=True Then
            If ((hires=False) Or (dpi<>"")) And extractPDF=False Then
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"pdftotiff"&Chr(34)&" -i "&Chr(34)&dateiname&".pdf"&Chr(34)&" -o "&Chr(34)&queue&Chr(34)&" -b 1 -m -x 300 -y 300",0,True)
            End If
        End If
    End If	'********************************************************************		 
    
    If LCase(CustomPDFtoTIFFConverter)="bfa_pdf2tif" Then '******************************************
        cropps=False
        sDevice="tiffg4"
        
        If dpi<>"0"  And dpi <> "" Then
            res = dpi
        Else
            If hires=True Then
                res = "300"
            Else
                res = "150"
            End If
        End If
        
        fversion = fs.GetFileVersion(programm&"bfa_pdf2tif.exe")
        ' Anweisung fr Archiv-Tif
        If maxpdfpages>0 Then
            If Len(fversion) >1 Then
                cmd = Chr(34)&programm&"bfa_pdf2tif.exe " & Chr(34) & " -i " & Chr(34) & dateiname & ".pdf" & Chr(34) & " -o " & Chr(34) & dateiname & ".tif" & Chr(34) & " -d " & sDevice & " -c g4 -r " & res & " -p " & maxpdfpages
            Else
                cmd = Chr(34)&programm&"bfa_pdf2tif.exe " & Chr(34) & " " & Chr(34) & dateiname & ".pdf" & Chr(34) & " " & Chr(34) & dateiname & ".tif" & Chr(34) & " " & sDevice & " " & res & " " & maxpdfpages
            End If
            
            cropps=True
        Else
            If Len(fversion) >1 Then
                cmd = Chr(34)&programm&"bfa_pdf2tif.exe " & Chr(34) & " -i " & Chr(34) & dateiname & ".pdf" & Chr(34) & " -o " & Chr(34) & dateiname & ".tif" & Chr(34) & " -c g4 -d " & sDevice & " -r " & res
            Else
                cmd = Chr(34)&programm&"bfa_pdf2tif.exe " & Chr(34) & " " & Chr(34)  & dateiname & ".pdf" & Chr(34) & " " & Chr(34) & dateiname & ".tif" & Chr(34) & " " & sDevice & " " & res
            End If
        End If  
        
        If scriptdebug = True Then
            objWSHShell.LogEvent 4, "archivierung.vbs: bfa_pdf2tif Aufruf:"&vbCrLf&cmd
        End If
        
        lngReturnCode = objWSHShell.Run(cmd,0,False)
        
        ' timeout anhand der Seitenanzahl ermitteln
        timeout = 2 * pdfpages + 30 ' 2 Sekunden pro Seite + overhead
        ret = timeoutprocess("bfa_pdf2tif.exe", timeout)
        If ret = True Then
            erfolg=False
            objWSHShell.LogEvent 1, "archivierung.vbs: bfa_pdf2tif.exe timeout!"
        End If
        
        
        
        
        If Not fs.fileexists(dateiname&".tif") Then
            Err.clear
            errortxt="archivierung(12-1): Fehler bei bfa_pdf2tif: keine TIF-Datei erzeugt. PDF-Datei mglicherweise fehlerhaft."&vbCrLf&cmd
            objWshShell.LogEvent 1, errortxt
            erfolg=False
        End If
        If erfolg=True Then
            fs.copyfile dateiname&".tif", dateiname&"-archiv.tif", True
            archivtif=dateiname&"-archiv"
        End If
        If erfolg=True Then
            ' OCR-Tif erzeugen
            If extractPDF=False Or readbarcodes=True Then
                res = "300"
                sDevice="tiffgray"
                If maxpdfpages>0 Then
                    If Len(fversion)>1 Then
                        cmd = Chr(34)&programm&"bfa_pdf2tif.exe " & Chr(34) & " -i " & Chr(34) & dateiname & ".pdf" & Chr(34) & " -o " & Chr(34) & dateiname & "-temp.tif" & Chr(34) & " -d " & sDevice & " -r " & res & " -p " & maxpdfpages  
                    Else
                        cmd = Chr(34)&programm&"bfa_pdf2tif.exe " & Chr(34) & " " & Chr(34)  & dateiname & ".pdf" & Chr(34) & " " & Chr(34) & dateiname & "-temp.tif" & Chr(34) & " " & "tiffgray" & " " & "-r300" & " " & maxpdfpages    
                    End If
                Else
                    If Len(fversion)>1 Then
                        cmd = Chr(34)&programm&"bfa_pdf2tif.exe " & Chr(34) & " -i " & Chr(34) & dateiname & ".pdf" & Chr(34) & " -o " & Chr(34) & dateiname & "-temp.tif" & Chr(34) & " -d " & sDevice & " -r " & res  
                    Else
                        cmd = Chr(34)&programm&"bfa_pdf2tif.exe " & Chr(34) & " " & Chr(34)  & dateiname & ".pdf" & Chr(34) & " " & Chr(34) & dateiname & "-temp.tif" & Chr(34) & " " & "tiffgray" & " " & "-r300" & " " & "1000"                  
                    End If
                End If
                If scriptdebug = True Then
                    objWSHShell.LogEvent 4, "archivierung.vbs: bfa_pdf2tif Aufruf:"&vbCrLf&cmd
                End If
                
                lngReturnCode = objWSHShell.Run(cmd,0,True)
                ' timeout anhand der Seitenanzahl ermitteln
                timeout = 2 * pdfpages + 30 ' 2 Sekunden pro Seite + overhead
                ret = timeoutprocess("bfa_pdf2tif.exe", timeout)
                If ret = True Then
                    erfolg=False
                    objWSHShell.LogEvent 1, "archivierung.vbs: bfa_pdf2tif.exe timeout!"
                End If
                
                If erfolg=True Then
                    lngReturnCode = runfilter(dateiname&"-temp.tif",programm&"TIFF-300.txt",dateiname&".tif")
                    If Not fs.fileexists(dateiname&".tif") Then
                        Err.clear
                        errortxt="archivierung(12-1a): Fehler bei bfa_pdf2tiff filtern: Filtern fehlgeschlagen"
                        objWshShell.LogEvent 1, errortxt
                        erfolg=False
                    Else
                        erfolg=True  
                        fs.deletefile dateiname&"-temp.tif", True
                    End If
                Else
                    errtxt = "archivierung(12-1a): Fehler bei bfa_pdf2tiff filtern: Filtern fehlgeschlagen"
                    objWshShell.LogEvent 1, errortxt
                End If
            End If
        End If
    End If	'********************************************************************
    
    
    
    If ((LCase(CustomPDFtoTIFFConverter)<>"pdftotiff")  And (LCase(CustomPDFtoTIFFConverter)<>"bfa_pdf2tif")) Or (erfolg=False) Then
        
        
        
        
        If scriptdebug = True Then
            
            turn = 0
            Do Until fs.fileexists(dateiname&".pdf") Or turn = 200
                
                WScript.sleep 100
                turn = turn +1	
                
            Loop
            If scriptdebug = True Then
                objWshShell.LogEvent 1, "Archivierung: Warteschleife fr PDF-Dokument=" & turn
            End If
        End If
        
        
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"processmonitor.bat"&Chr(34)&" PDFtoPS",0,True)
        WScript.Sleep 200
        cmd = Chr(34)&programm&"PDFtoPS.bat"&Chr(34)&" "&maxpdfpages&" "&Chr(34)&dateiname&".pdf"&Chr(34)
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"PDFtoPS.bat"&Chr(34)&" "&maxpdfpages&" "&Chr(34)&dateiname&".pdf"&Chr(34),0,True)
        
        
        
        
        
        
        If lngReturnCode <> 0 Then
            Err.clear
            On Error Resume Next
            If scriptdebug = True Then
                errortxt="archivierung(12-2): Fehler bei PDFtoPS." & dateiname & ".pdf"
                objWshShell.LogEvent 1, errortxt
            End If
            erfolg=False
        End If
        cropps=True
        
        WScript.Sleep 200
        
        
        '###############  In case that first method ist not sucessful, no PS-File could be created  ###############
        If Not fs.fileexists(dateiname&".ps") Then
            
            '**************  try with GSView on Serviceprinter, i.e for encryptet PDFs
            If scriptdebug=True Then
                objWshShell.LogEvent 1, "PDFToTif: kein .ps Datei im ersten Anlauf erzeugt, versuche Methode 2 ber GSView"
            End If
            
            erfolg=PDFtoPS_2(dateiname)
            cropps=False
        End If
        '###############################################################
        
        
        If Not fs.fileexists(dateiname&".ps") Then
            Err.clear
            errortxt="archivierung(12-3): Fehler bei PDFtoPS: keine Postscript-Datei erzeugt. PDF-Datei mglicherweise fehlerhaft." & dateiname & ".ps"
            objWshShell.LogEvent 1, errortxt
            erfolg=False
        Else
            erfolg=True    
        End If
        
        
        
        If erfolg=True Then
            
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"processmonitor.bat"&Chr(34)&" ghostscript",0,True)
            WScript.Sleep 200
            
            If fs.fileexists(programm&"ghostscriptwatcher.bat") And fs.fileexists(programm&"ghostscriptwatcher.vbs") Then
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscriptwatcher.bat"&Chr(34),0,False)
            End If
            
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-OCR.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)
            If lngReturnCode <> 0 Then
                Err.clear
                On Error Resume Next
                
                erfolg=False
                
            End If
        End If
        
        WScript.Sleep 200
        
        
        '###############  In case that first method ist not sucessful, no TIF-File could be created  ###############
        If fs.fileexists(dateiname&".ps") Then 
            
            If Not fs.fileexists(dateiname&"-temp.tif") Then
                
                '**************  try with GSView on Serviceprinter, i.e for encryptet PDFs
                
                If scriptdebug=True Then
                    objWshShell.LogEvent 1, "PDFToTif: kein .ps Datei im ersten Anlauf erzeugt, versuche Methode 2 ber GSView"
                End If
                
                If fs.fileexists(dateiname&".ps") Then
                    fs.deletefile dateiname&".ps", True
                End If
                
                erfolg=PDFToPS_2(Dateiname)
                
                If erfolg=True Then
                    
                    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"processmonitor.bat"&Chr(34)&" ghostscript",0,True)
                    WScript.Sleep 200
                    If fs.fileexists(programm&"ghostscriptwatcher.bat") And fs.fileexists(programm&"ghostscriptwatcher.vbs") Then
                        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscriptwatcher.bat"&Chr(34),0,False)
                    End If
                    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-OCR.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)
                    If lngReturnCode <> 0 Then
                        Err.clear
                        On Error Resume Next
                        errortxt="archivierung(12-4): Fehler bei Ghostscript."
                        objWshShell.LogEvent 1, errortxt
                        erfolg=False
                        
                    End If
                End If
                
                
            End If
        End If
        
        '###############################################################
        
        If erfolg=True Then
            If Not fs.fileexists(dateiname&"-temp.tif") Then
                Err.clear
                errortxt="archivierung(13-4): Fehler bei Ghostscript: keine TIF-Datei erzeugt."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
                
            End If
        End If
        
        If erfolg = True Then
            lngReturnCode = runfilter(dateiname&"-temp.tif",programm&"TIFF-300.txt",dateiname&".tif")
            
            If lngReturnCode <> 0 Then
                Err.clear
                errortxt="archivierung(13-5): Fehler bei Filtern nach Ghostscript(Color)."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
                
            End If
        End If
        
        WScript.Sleep 200
        
        If erfolg = True Then
            fs.deletefile dateiname&"-temp.tif", True
            If Not fs.fileexists(dateiname&".tif") Then
                Err.clear
                errortxt="archivierung(13-6): Fehler beim Filtern: keine TIF-Datei erzeugt."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
            End If
        End If
        
        If erfolg = True Then
            
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"processmonitor.bat"&Chr(34)&" ghostscript",0,True)
            WScript.Sleep 200
            If fs.fileexists(programm&"ghostscriptwatcher.bat") And fs.fileexists(programm&"ghostscriptwatcher.vbs") Then
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscriptwatcher.bat"&Chr(34),0,False)
            End If
            If hires=False Then
                If dpi="" Then
                    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-200.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)
                Else
                    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"temp\custom-bw.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)	
                End If	
            Else
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-300.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)
            End If
            
            If lngReturnCode <> 0 Then
                Err.clear
                errortxt="archivierung(13-7): Fehler bei Ghostscript."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
                
            End If
        End If
        
        
        
        If Not fs.fileexists(dateiname&"-temp.tif") Or erfolg=False Then
            Err.clear
            errortxt="archivierung(13-8): Fehler bei Ghostscript: keine TIF-Datei erzeugt."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
        End If
        
        
        
        If erfolg = True Then
            lngReturnCode = runfilter(dateiname&"-temp.tif",programm&"TIFF-200.txt",dateiname&"-archiv.tif")
            
            If lngReturnCode <> 0 Then
                Err.clear
                errortxt="archivierung(13-9): Fehler bei Filtern nach Ghostscript."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
            End If
        End If
        
        
        If erfolg = True Then
            WScript.Sleep 200
            fs.deletefile dateiname&"-temp.tif", True
            If Not fs.fileexists(dateiname&"-archiv.tif") Then
                Err.clear
                errortxt="archivierung(13-10): Fehler bei Filter: keine TIF-Datei erzeugt. Mglicherweise zu wenig freier Festplattenspeicher."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
            Else
                archivtif=dateiname&"-archiv"
            End If
        End If
        
    End If     
    
    '-----------------------  hier: Anfgen einer Infoseite bei seitenreduzierten Tifs  -------------------
    If (cropps=True) And (fs.fileexists(programm&"splitterv3.exe")) And (fs.fileexists(programm&"text2tif.exe")) And (erfolg=True) Then
       
        
        
        If pdfpages>maxpdfpages Then '~~~~~~~~~~~~~~~~~
            If scriptdebug = True Then
                objWshShell.LogEvent 4, "Archivierung: pdfinfo ergab "&pdfpages&" Seiten, maxpdfpages in scripts.ini ist aber "&maxpdfpages&" Seiten. Erstelle Infoseite und fge diese hinzu."
            End If
            If LCase(newstatuslang="deutsch") Then
                msgtxt1="Diese Voransicht enthlt nicht alle Seiten des Originaldokuments." 
                msgtxt2="Anzahl Seiten im Original: "&pdfpages&"."
                msgtxt3="Fr eine komplette Dokumentenansicht ffnen Sie das Dokument"
                msgtxt4="ber den Button 'Originaldatei'."
            Else
                msgtxt1="This preview does not contain all pages of the original file."
                msgtxt2="Number of pages in the original file are "&pdfpages&"."
                msgtxt3="To open the original file klick the Button 'original file'." 
                msgtxt4=""
            End If   
            
            If fs.fileexists(dateiname&"-temp.tff") Then
                fs.deletefile dateiname&"-temp.tff", True
            End If
            
            
            Set temptxtfile = fs.OpenTextFile(dateiname&"-temp.tff",8,True)
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" " & msgtxt1 & " ")
            temptxtfile.writeline(" " & msgtxt2 & " ")
            temptxtfile.writeline(" " & msgtxt3 & " ")
            temptxtfile.writeline(" " & msgtxt4 & " ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.close
            Set temptxtfile=Nothing
            
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"Text2TIF.exe"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tff"&Chr(34),0,True)
            
            
            If lngReturnCode <> 0 Then
                If extension = ".sig" Then
                    fs.deletefile dateiname &".pdf"
                End If
                Err.clear
                errortxt="archivierung(122g): Fehler bei Text2TIF.exe"
                objWshShell.LogEvent 1, errortxt
                GetGarbage(dateiname)   
                Unlock(programm&lockdatei)
                WScript.Quit
                
            End If
            
            WScript.Sleep 200
            fs.deletefile dateiname&"-temp.tff",True
            archivtif=dateiname
        End If '~~~~~~~~~~~~~~~~~~~~
        
        
        If (fs.fileexists(dateiname&"-temp.tif")) And (fs.fileexists(dateiname&"-archiv.tif")) Then
            
            lngReturnCode = objWSHShell.Run(programm&"splitterv3.exe -a " &Chr(34)&dateiname&"-archiv.tif"&Chr(34) & " " &Chr(34)& dateiname&"-temp.tif"&Chr(34),0,True)
            archivtif=dateiname&"-archiv"
        End If
        
        If (fs.fileexists(dateiname&"-temp.tif")) And (fs.fileexists(dateiname&".tif")) Then
            
            lngReturnCode = objWSHShell.Run(programm&"splitterv3.exe -a " &Chr(34)&dateiname&".tif"&Chr(34) & " " &Chr(34)& dateiname&"-temp.tif"&Chr(34),0,True)
            
        End If
        
        If fs.fileexists(dateiname&"-temp.tif") Then
            fs.deletefile dateiname&"-temp.tif", True
        End If
        
        
        If Err.number <> 0 Then
            
            On Error Resume Next
            errortxt="archivierung(34-6-1): Fehler bei droppen von PDF-Seiten."&vbCrLf&Err.Number&vbCrLf&Err.Description
            objWshShell.LogEvent 1, errortxt
            Err.clear
        End If   
        
    End If
    '------------------------------------------------------------------------------------------------------
    
    
    
    
    
    If fs.fileexists(dateiname&".ps") Then
        fs.deletefile dateiname&".ps", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            errortxt="archivierung(13-11): Fehler bei lschen der ps-Datei."
            objWshShell.LogEvent 1, errortxt
        End If
    End If
    
    
    If erfolg=True Then
        If InStr(1,filtermakro,"dropscanpdf") <> 0 And extension=".pdf" Then
            If fs.fileexists(dateiname&".pdf") Then
                fs.deletefile dateiname&".pdf", True
                If Err.number<>0 Then
                    Err.clear
                    On Error Resume Next
                    errortxt="archivierung(13-12): Fehler bei dropscanpdf der pdf-Datei." & dateiname&".pdf"
                    objWshShell.LogEvent 1, errortxt
                    erfolg=False
                Else
                    filtermakro = Replace(filtermakro,"dropscanpdf","")
                    OCRhandle=".tif"
                    extension = ".tif"
                    filterjob(dateiname)
                    
                End If
            End If	
        End If
    End If
    If extension = ".sig" Then
        fs.deletefile dateiname &".pdf", True
    End If
    
    If erfolg=False Then
        handle="unbekannt"
        Typ="TXT"
        OCRHandle=".tif"
        color=False
        makefilltif(tempname)	
    End If
    
End Function







'*******************************************************************************************
'*************************************  PDF to ColorTIF  ***********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************


Function PDFtoColorTIF(dateiname)
    
    On Error Resume Next
    Err.clear
    erfolg=True
    
    If forceomp=True Then
    	extractpdf = False
    End If
    
    If fs.fileexists(dateiname&".ps") Then
        fs.deletefile dateiname&".ps", True
    End If
    
    ' Auf schon vorhandene, mitgelieferte Voransichten prfen 
    
    
    If checkexistingdocpreview = True Then
        If fs.fileexists(dateiname & ".tif") Then
            Exit Function    ' keine neue Voransicht erstellen
        End If
    Else
        If fs.fileexists(dateiname & ".tif") Then
            fs.deletefile dateiname&".tif", True
            If Err.number<>0 Then
                
                errortxt="archivierung(13-0): Fehler bei lschen einer tif-Datei." & dateiname & ".tif" & vbCrLf & Err.number
                objWshShell.LogEvent 1, errortxt
                Err.clear
                On Error Resume Next
            End If
        End If
        
    End If
    
    If extension = ".sig" Then
        fs.copyfile dateiname & ".sig", dateiname &".pdf"
    End If
    
    ' Anzahl der PDF-Seiten ermitteln
    If ((fs.fileexists(programm&"pdfinfo.bat")) And (fs.fileexists(programm&"pdfinfo.exe"))) Then
        pdfpages=0
        zaehler=0
        strinput=""
        If scriptdebug = True Then
            objWshShell.LogEvent 4, "Archivierung: starte PDFInfo.exe"
        End If
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"pdfinfo.bat"&Chr(34)&" "&Chr(34)&dateiname&".pdf"&Chr(34)&" "&Chr(34)&dateiname&".pdi"&Chr(34),0,True)
        WScript.Sleep 1000
        errn = Err.number
        If fs.fileexists(dateiname&".pdi") Then
            Set quellswfile = fs.OpenTextFile(dateiname&".pdi",1)
            strinput = ""
            Do While quellswfile.AtEndOfStream <> True
                strinput=strinput+quellswfile.readline&vbCrLf
            Loop
            quellswfile.close
            Set quellswfile = Nothing
            fs.deletefile dateiname&".pdi",True
        End If
        
        
        If InStr(1,strinput, "Pages:",1) <> 0 Then	
            pos = InStr(1,strinput, "Pages:",1) +6
            pos2 = InStr(pos,strinput, vbCrLf) 
            pages = Mid(strinput, pos, pos2 - pos)
            pdfpages = CInt(Trim(pages))
        End If
    Else
        pdfpages = 1000
    End If
    
    
    If LCase(CustomPDFtoTIFFConverter)="pdftotiff" Then '******************************************
        
        If hires=True Then
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"pdftotiff"&Chr(34)&" -i "&Chr(34)&dateiname&".pdf"&Chr(34)&" -o "&Chr(34)&queue&Chr(34)&" -c JPG -m -x 300 -y 300",0,True)
        Else
            If dpi="" Then
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"pdftotiff"&Chr(34)&" -i "&Chr(34)&dateiname&".pdf"&Chr(34)&" -o "&Chr(34)&queue&Chr(34)&" -c JPG -m -x 200 -y 200",0,True)
            Else
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"pdftotiff"&Chr(34)&" -i "&Chr(34)&dateiname&".pdf"&Chr(34)&" -o "&Chr(34)&queue&Chr(34)&" -c JPG -m -x "&dpi&" -y "&dpi,0,True)
            End If
        End If
        If Not fs.fileexists(dateiname&".tif") Then
            Err.clear
            errortxt="archivierung(12-1): Fehler bei pdftotiff: keine TIF-Datei erzeugt. PDF-Datei mglicherweise fehlerhaft."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
        End If
        If erfolg=True Then
            fs.copyfile dateiname&".tif", dateiname&"-archiv.tif", True
            archivtif=dateiname&"-archiv"
        End If
        If erfolg=True Then
            If ((hires=False) Or (dpi<>"")) And extractPDF=False Then
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"pdftotiff"&Chr(34)&" -i "&Chr(34)&dateiname&".pdf"&Chr(34)&" -o "&Chr(34)&queue&Chr(34)&" -b 1 -m -x 300 -y 300",0,True)
            End If
        End If
    End If	'********************************************************************		 
    
    If LCase(CustomPDFtoTIFFConverter)="bfa_pdf2tif" Then '******************************************
        cropps=False
        If handle<>"ODT" Then
            If archpdfincolor="grey" Then
                sDevice="tiffgray"
            Else
                sDevice="tiff24nc"
            End If
        Else
            sDevice="tiff24nc"
        End If
        
        If dpi<>"0"  And dpi <> "" Then
            res = dpi
        Else
            If hires=True Then
                res = "300"
            Else
                res = "150"
            End If
        End If
        
        fversion = fs.GetFileVersion(programm&"bfa_pdf2tif.exe")
        ' Anweisung fr Archiv-Tif
        If maxpdfpages>0 Then
            If Len(fversion) >1 Then
                cmd = Chr(34)&programm&"bfa_pdf2tif.exe " & Chr(34) & " -i " & Chr(34) & dateiname & ".pdf" & Chr(34) & " -o " & Chr(34) & dateiname & ".tif" & Chr(34) & " -d " & sDevice & " -c lzw -r " & res & " -p " & maxpdfpages
            Else
                cmd = Chr(34)&programm&"bfa_pdf2tif.exe " & Chr(34) & " " & Chr(34) & dateiname & ".pdf" & Chr(34) & " " & Chr(34) & dateiname & ".tif" & Chr(34) & " " & sDevice & " " & res & " " & maxpdfpages
            End If
            
            cropps=True
        Else
            If Len(fversion) >1 Then
                cmd = Chr(34)&programm&"bfa_pdf2tif.exe " & Chr(34) & " -i " & Chr(34) & dateiname & ".pdf" & Chr(34) & " -o " & Chr(34) & dateiname & ".tif" & Chr(34) & " -d " & sDevice & " -c lzw -r " & res
            Else
                cmd = Chr(34)&programm&"bfa_pdf2tif.exe " & Chr(34) & " " & Chr(34)  & dateiname & ".pdf" & Chr(34) & " " & Chr(34) & dateiname & ".tif" & Chr(34) & " " & sDevice & " " & res
            End If
        End If  
        
        If scriptdebug = True Then
            objWSHShell.LogEvent 4, "archivierung.vbs: bfa_pdf2tif Aufruf:"&vbCrLf&cmd
        End If
        
        lngReturnCode = objWSHShell.Run(cmd,0,False)
        
        ' timeout anhand der Seitenanzahl ermitteln
        timeout = 2 * pdfpages + 30 ' 2 Sekunden pro Seite + overhead
        ret = timeoutprocess("bfa_pdf2tif.exe", timeout)
        If ret = True Then
            erfolg=False
            objWSHShell.LogEvent 1, "archivierung.vbs: bfa_pdf2tif.exe timeout!"
        End If
        
        
        
        
        If Not fs.fileexists(dateiname&".tif") Then
            Err.clear
            errortxt="archivierung(12-1): Fehler bei bfa_pdf2tif: keine TIF-Datei erzeugt. PDF-Datei mglicherweise fehlerhaft."&vbCrLf&cmd
            objWshShell.LogEvent 1, errortxt
            erfolg=False
        End If
        If erfolg=True Then
            fs.copyfile dateiname&".tif", dateiname&"-archiv.tif", True
            archivtif=dateiname&"-archiv"
        End If
        If erfolg=True Then
            ' OCR-Tif erzeugen
            If extractPDF=False Then
                res = "300"
                sDevice="tiffgray"
                If maxpdfpages>0 Then
                    If Len(fversion)>1 Then
                        cmd = Chr(34)&programm&"bfa_pdf2tif.exe " & Chr(34) & " -i " & Chr(34) & dateiname & ".pdf" & Chr(34) & " -o " & Chr(34) & dateiname & "-temp.tif" & Chr(34) & " -d " & sDevice & " -r " & res & " -p " & maxpdfpages  
                    Else
                        cmd = Chr(34)&programm&"bfa_pdf2tif.exe " & Chr(34) & " " & Chr(34)  & dateiname & ".pdf" & Chr(34) & " " & Chr(34) & dateiname & "-temp.tif" & Chr(34) & " " & "tiffgray" & " " & "-r300" & " " & maxpdfpages    
                    End If
                Else
                    If Len(fversion)>1 Then
                        cmd = Chr(34)&programm&"bfa_pdf2tif.exe " & Chr(34) & " -i " & Chr(34) & dateiname & ".pdf" & Chr(34) & " -o " & Chr(34) & dateiname & "-temp.tif" & Chr(34) & " -d " & sDevice & " -r " & res  
                    Else
                        cmd = Chr(34)&programm&"bfa_pdf2tif.exe " & Chr(34) & " " & Chr(34)  & dateiname & ".pdf" & Chr(34) & " " & Chr(34) & dateiname & "-temp.tif" & Chr(34) & " " & "tiffgray" & " " & "-r300" & " " & "1000"                  
                    End If
                End If
                If scriptdebug = True Then
                    objWSHShell.LogEvent 4, "archivierung.vbs: bfa_pdf2tif Aufruf:"&vbCrLf&cmd
                End If
                
                lngReturnCode = objWSHShell.Run(cmd,0,True)
                ' timeout anhand der Seitenanzahl ermitteln
                timeout = 2 * pdfpages + 30 ' 2 Sekunden pro Seite + overhead
                ret = timeoutprocess("bfa_pdf2tif.exe", timeout)
                If ret = True Then
                    erfolg=False
                    objWSHShell.LogEvent 1, "archivierung.vbs: bfa_pdf2tif.exe timeout!"
                End If
                
                If erfolg=True Then
                    lngReturnCode = runfilter(dateiname&"-temp.tif",programm&"TIFF-300.txt",dateiname&".tif")
                    If Not fs.fileexists(dateiname&".tif") Then
                        Err.clear
                        errortxt="archivierung(12-1a): Fehler bei bfa_pdf2tiff filtern: Filtern fehlgeschlagen"
                        objWshShell.LogEvent 1, errortxt
                        erfolg=False
                    Else
                        erfolg=True  
                        fs.deletefile dateiname&"-temp.tif", True
                    End If
                Else
                    errtxt = "archivierung(12-1a): Fehler bei bfa_pdf2tiff filtern: Filtern fehlgeschlagen"
                    objWshShell.LogEvent 1, errortxt
                End If
            End If
        End If
    End If	'********************************************************************
    
    
    
    If ((LCase(CustomPDFtoTIFFConverter)<>"pdftotiff")  And (LCase(CustomPDFtoTIFFConverter)<>"bfa_pdf2tif")) Or (erfolg=False) Then
        
        
        
        
        If scriptdebug = True Then
            
            turn = 0
            Do Until fs.fileexists(dateiname&".pdf") Or turn = 200
                
                WScript.sleep 100
                turn = turn +1	
                
            Loop
            If scriptdebug = True Then
                objWshShell.LogEvent 1, "Archivierung: Warteschleife fr PDF-Dokument=" & turn
            End If
        End If
        
        
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"processmonitor.bat"&Chr(34)&" PDFtoPS",0,True)
        WScript.Sleep 200
        cmd = Chr(34)&programm&"PDFtoPS.bat"&Chr(34)&" "&maxpdfpages&" "&Chr(34)&dateiname&".pdf"&Chr(34)
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"PDFtoPS.bat"&Chr(34)&" "&maxpdfpages&" "&Chr(34)&dateiname&".pdf"&Chr(34),0,True)
        
        
        
        
        
        
        If lngReturnCode <> 0 Then
            Err.clear
            On Error Resume Next
            If scriptdebug = True Then
                errortxt="archivierung(12-2): Fehler bei PDFtoPS." & dateiname & ".pdf"
                objWshShell.LogEvent 1, errortxt
            End If
            erfolg=False
        End If
        cropps=True
        
        WScript.Sleep 200
        
        
        '###############  In case that first method ist not sucessful, no PS-File could be created  ###############
        If Not fs.fileexists(dateiname&".ps") Then
            
            '**************  try with GSView on Serviceprinter, i.e for encryptet PDFs
            If scriptdebug=True Then
                objWshShell.LogEvent 1, "PDFToTif: kein .ps Datei im ersten Anlauf erzeugt, versuche Methode 2 ber GSView"
            End If
            
            erfolg=PDFtoPS_2(dateiname)
            cropps=False
        End If
        '###############################################################
        
        
        If Not fs.fileexists(dateiname&".ps") Then
            Err.clear
            errortxt="archivierung(12-3): Fehler bei PDFtoPS: keine Postscript-Datei erzeugt. PDF-Datei mglicherweise fehlerhaft." & dateiname & ".ps"
            objWshShell.LogEvent 1, errortxt
            erfolg=False
        Else
            erfolg=True    
        End If
        
        
        
        If erfolg=True Then
            
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"processmonitor.bat"&Chr(34)&" ghostscript",0,True)
            WScript.Sleep 200
            If fs.fileexists(programm&"ghostscriptwatcher.bat") And fs.fileexists(programm&"ghostscriptwatcher.vbs") Then
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscriptwatcher.bat"&Chr(34),0,False)
            End If
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-OCR.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)
            If lngReturnCode <> 0 Then
                Err.clear
                On Error Resume Next
                
                erfolg=False
                
            End If
        End If
        
        WScript.Sleep 200
        
        
        '###############  In case that first method ist not sucessful, no TIF-File could be created  ###############
        If fs.fileexists(dateiname&".ps") Then 
            
            If Not fs.fileexists(dateiname&"-temp.tif") Then
                
                '**************  try with GSView on Serviceprinter, i.e for encryptet PDFs
                
                If scriptdebug=True Then
                    objWshShell.LogEvent 1, "PDFToTif: kein .ps Datei im ersten Anlauf erzeugt, versuche Methode 2 ber GSView"
                End If
                
                If fs.fileexists(dateiname&".ps") Then
                    fs.deletefile dateiname&".ps", True
                End If
                
                erfolg=PDFToPS_2(Dateiname)
                
                If erfolg=True Then
                    
                    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"processmonitor.bat"&Chr(34)&" ghostscript",0,True)
                    WScript.Sleep 200
                    If fs.fileexists(programm&"ghostscriptwatcher.bat") And fs.fileexists(programm&"ghostscriptwatcher.vbs") Then
                        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscriptwatcher.bat"&Chr(34),0,False)
                    End If
                    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-OCR.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)
                    If lngReturnCode <> 0 Then
                        Err.clear
                        On Error Resume Next
                        errortxt="archivierung(12-4): Fehler bei Ghostscript."
                        objWshShell.LogEvent 1, errortxt
                        erfolg=False
                        
                    End If
                End If
                
                
            End If
        End If
        
        '###############################################################
        
        If erfolg=True Then
            If Not fs.fileexists(dateiname&"-temp.tif") Then
                Err.clear
                errortxt="archivierung(13-4): Fehler bei Ghostscript: keine TIF-Datei erzeugt."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
                
            End If
        End If
        
        If erfolg = True Then
            lngReturnCode = runfilter(dateiname&"-temp.tif",programm&"TIFF-300.txt",dateiname&".tif")
            
            If lngReturnCode <> 0 Then
                Err.clear
                errortxt="archivierung(13-5): Fehler bei Filtern nach Ghostscript(Color)."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
                
            End If
        End If
        
        WScript.Sleep 200
        
        If erfolg = True Then
            fs.deletefile dateiname&"-temp.tif", True
            If Not fs.fileexists(dateiname&".tif") Then
                Err.clear
                errortxt="archivierung(13-6): Fehler beim Filtern: keine TIF-Datei erzeugt."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
            End If
        End If
        
        If erfolg = True Then
            
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"processmonitor.bat"&Chr(34)&" ghostscript",0,True)
            WScript.Sleep 200
            If fs.fileexists(programm&"ghostscriptwatcher.bat") And fs.fileexists(programm&"ghostscriptwatcher.vbs") Then
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscriptwatcher.bat"&Chr(34),0,False)
            End If
            If hires=False Then
                If dpi="" Then
                    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-200-color.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)
                Else
                    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"temp\custom-color.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)	
                End If	
            Else
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-300-color.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)
            End If
            If lngReturnCode <> 0 Then
                Err.clear
                errortxt="archivierung(13-7): Fehler bei Ghostscript(color)."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
                
            End If
        End If
        
        
        
        If Not fs.fileexists(dateiname&"-temp.tif") Or erfolg = False Then
            Err.clear
            errortxt="archivierung(13-8): Fehler bei Ghostscript: keine TIF-Datei erzeugt."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
            
        End If
        
        
        
        If erfolg = True Then
            lngReturnCode = runfilter(dateiname&"-temp.tif",programm&"TIFF-200.txt",dateiname&"-archiv.tif")
            
            If lngReturnCode <> 0 Then
                Err.clear
                errortxt="archivierung(13-9): Fehler bei Filtern nach Ghostscript(Color)."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
            End If
        End If
        
        
        If erfolg = True Then
            WScript.Sleep 200
            fs.deletefile dateiname&"-temp.tif", True
            If Not fs.fileexists(dateiname&"-archiv.tif") Then
                Err.clear
                errortxt="archivierung(13-10): Fehler bei Filter: keine TIF-Datei erzeugt. Mglicherweise zu wenig freier Festplattenspeicher."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
            Else
                archivtif=dateiname&"-archiv"
            End If
        End If
        
    End If     
    
    '-----------------------  hier: Anfgen einer Infoseite bei seitenreduzierten Tifs  -------------------
    If (cropps=True) And (fs.fileexists(programm&"splitterv3.exe")) And (fs.fileexists(programm&"text2tif.exe")) And erfolg = True Then
      
        
        
        If pdfpages>maxpdfpages Then '~~~~~~~~~~~~~~~~~
            If scriptdebug = True Then
                objWshShell.LogEvent 4, "Archivierung: pdfinfo ergab "&pdfpages&" Seiten, maxpdfpages in scripts.ini ist aber "&maxpdfpages&" Seiten. Erstelle Infoseite und fge diese hinzu."
            End If
            If LCase(newstatuslang="deutsch") Then
                msgtxt1="Diese Voransicht enthlt nicht alle Seiten des Originaldokuments." 
                msgtxt2="Anzahl Seiten im Original: "&pdfpages&"."
                msgtxt3="Fr eine komplette Dokumentenansicht ffnen Sie das Dokument"
                msgtxt4="ber den Button 'Originaldatei'."
            Else
                msgtxt1="This preview does not contain all pages of the original file."
                msgtxt2="Number of pages in the original file are "&pdfpages&"."
                msgtxt3="To open the original file klick the Button 'original file'." 
                msgtxt4=""
            End If   
            
            If fs.fileexists(dateiname&"-temp.tff") Then
                fs.deletefile dateiname&"-temp.tff", True
            End If
            
            
            Set temptxtfile = fs.OpenTextFile(dateiname&"-temp.tff",8,True)
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" " & msgtxt1 & " ")
            If IsInArray(extension, excelextensions)=False Then
                temptxtfile.writeline(" " & msgtxt2 & " ")
            End If
            temptxtfile.writeline(" " & msgtxt3 & " ")
            temptxtfile.writeline(" " & msgtxt4 & " ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.writeline(" ")
            temptxtfile.close
            Set temptxtfile=Nothing
            
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"Text2TIF.exe"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tff"&Chr(34),0,True)
            
            
            If lngReturnCode <> 0 Then
                Err.clear
                errortxt="archivierung(122g): Fehler bei Text2TIF.exe"
                objWshShell.LogEvent 1, errortxt
                If extension = ".sig" Then
                    fs.deletefile dateiname &".pdf", True
                End If
                GetGarbage(dateiname)   
                Unlock(programm&lockdatei)
                WScript.Quit
                
            End If
            
            WScript.Sleep 200
            fs.deletefile dateiname&"-temp.tff",True
            archivtif=dateiname
        End If '~~~~~~~~~~~~~~~~~~~~
        
        
        If (fs.fileexists(dateiname&"-temp.tif")) And (fs.fileexists(dateiname&"-archiv.tif")) Then
            
            lngReturnCode = objWSHShell.Run(programm&"splitterv3.exe -a " &Chr(34)&dateiname&"-archiv.tif"&Chr(34) & " " &Chr(34)& dateiname&"-temp.tif"&Chr(34),0,True)
            archivtif=dateiname&"-archiv"
        End If
        
        If (fs.fileexists(dateiname&"-temp.tif")) And (fs.fileexists(dateiname&".tif")) Then
            
            lngReturnCode = objWSHShell.Run(programm&"splitterv3.exe -a " &Chr(34)&dateiname&".tif"&Chr(34) & " " &Chr(34)& dateiname&"-temp.tif"&Chr(34),0,True)
            
        End If
        
        If fs.fileexists(dateiname&"-temp.tif") Then
            fs.deletefile dateiname&"-temp.tif", True
        End If
        
        
        
        If Err.number <> 0 Then
            
            On Error Resume Next
            errortxt="archivierung(34-6-1): Fehler bei droppen von PDF-Seiten."&vbCrLf&Err.Number&vbCrLf&Err.Description
            objWshShell.LogEvent 1, errortxt
            Err.clear
        End If   
        
    End If
    '------------------------------------------------------------------------------------------------------
    
    
    
    
    
    If fs.fileexists(dateiname&".ps") Then
        fs.deletefile dateiname&".ps", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            errortxt="archivierung(13-11): Fehler bei lschen der ps-Datei."
            objWshShell.LogEvent 1, errortxt
        End If
    End If
    
    
    If erfolg=True Then
        If InStr(1,filtermakro,"dropscanpdf") <> 0 And extension=".pdf" Then
            If fs.fileexists(dateiname&".pdf") Then
                fs.deletefile dateiname&".pdf", True
                If Err.number<>0 Then
                    Err.clear
                    On Error Resume Next
                    errortxt="archivierung(13-12): Fehler bei dropscanpdf der pdf-Datei." & dateiname&".pdf"
                    objWshShell.LogEvent 1, errortxt
                    erfolg=False
                Else
                    filtermakro = Replace(filtermakro,"dropscanpdf","")
                    OCRhandle=".tif"
                    extension = ".tif"
                    filterjob(dateiname)
                    
                End If
            End If	
        End If
    End If
    
    If extension = ".sig" Then
        fs.deletefile dateiname &".pdf", True
    End If
    
    If erfolg=False Then
        handle="unbekannt"
        Typ="TXT"
        OCRHandle=".tif"
        color=False
        makefilltif(tempname)	
    End If
    
End Function

'*******************************************************************************************
'*************************************  PDF to PS  *****************************************
'*******************************************************************************************
'********************************  Variant with GSView  ************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

Function PDFtoPS_2(Dateiname)
    erfolg=True
    If scriptdebug=True Then
        objWshShell.LogEvent 1, "PDFToPS_2: kein .ps Datei im ersten Anlauf erzeugt, versuche Methode 2 ber GSView"
    End If
    
    If fs.fileexists(dateiname&".ps") Then
        fs.deletefile dateiname&".ps", True
    End If
    
    waitdirect()
    If fs.fileexists(programm&"temp\Serviceprinter.ps") Then
        fs.deletefile programm&"temp\Serviceprinter.ps", True
    End If
    
    If Err.number<>0 Then
        erfolg=False
        errortxt="archivierung(12-65): PDFToPS_2: Fehler beim umkopieren vor bfa_pdf2tif_serviceprinter"
        objWshShell.LogEvent 1, errortxt
    End If
    
    If erfolg=True Then
    	bfa_pdf2tif_serviceprinter(dateiname&".pdf")
        gsview_serviceprinter(dateiname&".pdf")
        WScript.sleep 300
    End If
    
    
    If erfolg=True Then
        If fs.fileexists(programm&"temp\Serviceprinter.ps") Then
            fs.copyfile programm&"temp\Serviceprinter.ps", dateiname&".ps", True
            fs.deletefile programm&"temp\Serviceprinter.ps", True
            If Err.number<>0 Then
                erfolg=True
                errortxt="archivierung(12-65): PDFToPS_2: Fehler beim umkopieren nach bfa_pdf2tif_serviceprinter"
                objWshShell.LogEvent 1, errortxt
            End If
        Else
            erfolg=False	
        End If
    End If
    
    
    If Not fs.fileexists(dateiname&".ps") Then
        Err.clear
        errortxt="archivierung(12-3): Fehler bei PDFtoPS_2: keine Postscript-Datei erzeugt. PDF-Datei mglicherweise fehlerhaft." & dateiname & ".ps"
        objWshShell.LogEvent 1, errortxt
        erfolg=False
        
    End If
    PDFtoPS_2=erfolg
    
End Function



'*******************************************************************************************
'*************************************  DWG to TIF  ****************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************


Function DWGtoTIF(dateiname)
	If checkexistingdocpreview = True Then
        If fs.fileexists(dateiname & ".tif") Then
            Exit Function    ' keine neue Voransicht erstellen
        End If
    End If
    On Error Resume Next
    Err.clear
    erfolg=True
    If (isBusy=True) And (rundirect=False) Then
        objWshShell.LogEvent 1, "bitfarm-Archiv Serverdienst: Kollission mit einer weiteren Instanz entdeckt."
        WScript.Quit
    End If
    
    If fs.fileexists(dateiname&".pdf") Then
        fs.deletefile dateiname&".pdf", True
        WScript.Sleep 300
    End If
    
    
    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"DWGtoPDF.bat"&Chr(34)&" "&Chr(34)&dateiname&".pdf"&Chr(34)&" "&Chr(34)&dateiname&extension&Chr(34),0,False)
    If lngReturnCode <> 0 Then
        Err.clear
        errortxt="archivierung(14-1): Fehler bei AutoCAD-Konvertierung."&vbCrLf & Chr(34)&programm&"DWGtoPDF.bat"&Chr(34)&" "&Chr(34)&dateiname&".pdf"&Chr(34)&" "&Chr(34)&dateiname&extension&Chr(34)
        objWshShell.LogEvent 1, errortxt
        erfolg=False
        
    End If
    
    If erfolg=True Then
        a=0
        
        Do While (fs.fileexists(dateiname&".pdf")=False) And (a < 120)
            WScript.Sleep 1000
            a = a + 1
        Loop
        
        If a>119 Then
            errortxt="archivierung(14-2): Fehler bei AutoCAD-Konvertierung - Timeout."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
            On Error Resume Next
            Err.clear
            Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
            On Error Resume Next
            Err.clear
            strQuery = "Select * from Win32_Process where Name='AcmeCADConverter.exe'"
            Set colItems = objWMIService.ExecQuery(strQuery,,48)
            For Each objItem In colItems
                objItem.Terminate
            Next
            Set objItem = Nothing
            Set colItems = Nothing
            Set objWMIService = Nothing
            
        End If
        
        WScript.Sleep 100
    End If
    
    If erfolg=True Then
        
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-600.rsp"&Chr(34)&" "&Chr(34)&dateiname&".tif"&Chr(34)&" "&Chr(34)&dateiname&".pdf"&Chr(34),0,True)
        If lngReturnCode <> 0 Then
            Err.clear
            errortxt="archivierung(14-3): Fehler bei Ghostscript."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(dateiname)   
            Unlock(programm&lockdatei)
            WScript.Quit
            
        End If
        
        If Not fs.fileexists(dateiname&".tif") Then
            Err.clear
            errortxt="archivierung(14-4): Fehler bei Ghostscript: keine TIF-Datei erzeugt. Mglicherweise zu wenig freier Festplattenspeicher."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(dateiname)   
            Unlock(programm&lockdatei)
            WScript.Quit
            
        End If
        
        If hires=False Then
            If dpi="" Then
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-300.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-archiv.tif"&Chr(34)&" "&Chr(34)&dateiname&".pdf"&Chr(34),0,True)
            Else
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"temp\custom-bw.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-archiv.tif"&Chr(34)&" "&Chr(34)&dateiname&".pdf"&Chr(34),0,True)
            End If	
        Else
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-400.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-archiv.tif"&Chr(34)&" "&Chr(34)&dateiname&".pdf"&Chr(34),0,True)
        End If
        If lngReturnCode <> 0 Then
            Err.clear
            errortxt="archivierung(14-5): Fehler bei Ghostscript."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(dateiname)   
            Unlock(programm&lockdatei)
            WScript.Quit
            
        End If
        archivtif=dateiname&"-archiv"
        If Not fs.fileexists(dateiname&"-archiv.tif") Then
            Err.clear
            errortxt="archivierung(14-6): Fehler bei Filter: keine TIF-Datei erzeugt. Mglicherweise zu wenig freier Festplattenspeicher." & vbCrLf & "Setze auf Standard-tif zurck" & vbCrLf &  dateiname&".tif"
            objWshShell.LogEvent 1, errortxt
            archivtif = dateiname
            
            If Not fs.fileexists(dateiname&".tif") Then
                Err.clear
                errortxt="archivierung(14-7): Fehler bei Filter: keine TIF-Datei erzeugt. Mglicherweise zu wenig freier Festplattenspeicher."  & vbCrLf &  dateiname&".tif"
                objWshShell.LogEvent 1, errortxt
                
                GetGarbage(dateiname)   
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
        End If
    End If
    
    If erfolg=False Then
        handle="unbekannt"
        Typ="TXT"
        OCRHandle=".tif"
        color=False
        
    End If
    
    
End Function


'*******************************************************************************************
'*************************************  DWG to ColorTIF  ***********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************


Function DWGtoColorTIF(dateiname)
	If checkexistingdocpreview = True Then
        If fs.fileexists(dateiname & ".tif") Then
            Exit Function    ' keine neue Voransicht erstellen
        End If
    End If
    On Error Resume Next
    Err.clear
    erfolg=True
    If (isBusy=True) And (rundirect=False) Then
        objWshShell.LogEvent 1, "bitfarm-Archiv Serverdienst: Kollission mit einer weiteren Instanz entdeckt."
        WScript.Quit
    End If
    
    If fs.fileexists(dateiname&".pdf") Then
        fs.deletefile dateiname&".pdf", True
        WScript.Sleep 300
    End If

    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"DWGtoColorPDF.bat"&Chr(34)&" "&Chr(34)&dateiname&".pdf"&Chr(34)&" "&Chr(34)&dateiname&extension&Chr(34),0,False)
    If lngReturnCode <> 0 Then
        Err.clear
        errortxt="archivierung(14-8): Fehler bei AutoCAD-Konvertierung."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
        
    End If
    
    
    If erfolg=True Then
        a=0
        
        Do While (fs.fileexists(dateiname&".pdf")=False) And (a < 120)
            WScript.Sleep 1000
            a = a + 1
        Loop
        
        If a>119 Then
            errortxt="archivierung(14-9): Fehler bei AutoCAD-Konvertierung - Timeout."
            objWshShell.LogEvent 1, errortxt
            On Error Resume Next
            Err.clear
            erfolg=False
            Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
            strQuery = "Select * from Win32_Process where Name='AcmeCADConverter.exe'"
            Set colItems = objWMIService.ExecQuery(strQuery,,48)
            For Each objItem In colItems
                objItem.Terminate
            Next
            Set objItem = Nothing
            Set colItems = Nothing
            Set objWMIService = Nothing
            
            
        End If
        
        WScript.Sleep 2000
    End If
    
    
    If erfolg=True Then
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-600.rsp"&Chr(34)&" "&Chr(34)&dateiname&".tif"&Chr(34)&" "&Chr(34)&dateiname&".pdf"&Chr(34),0,True)
        If lngReturnCode <> 0 Then
            Err.clear
            errortxt="archivierung(14-10): Fehler bei Ghostscript."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(dateiname)   
            Unlock(programm&lockdatei)
            WScript.Quit
            
        End If
        
        If Not fs.fileexists(dateiname&".tif") Then
            Err.clear
            errortxt="archivierung(14-11): Fehler bei Ghostscript: keine TIF-Datei erzeugt. Mglicherweise zu wenig freier Festplattenspeicher."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(dateiname)   
            Unlock(programm&lockdatei)
            WScript.Quit
            
        End If
        
        If hires=False Then
            If dpi="" Then
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-300-color.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".pdf"&Chr(34),0,True)
            Else
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"temp\custom-color.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".pdf"&Chr(34),0,True)
            End If
        Else
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-400-color.rsp"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tif"&Chr(34)&" "&Chr(34)&dateiname&".pdf"&Chr(34),0,True)
        End If
        If lngReturnCode <> 0 Then
            Err.clear
            errortxt="archivierung(14-12): Fehler bei Ghostscript(Color)."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(dateiname)   
            Unlock(programm&lockdatei)
            WScript.Quit
            
        End If
        
        If Not fs.fileexists(dateiname&"-temp.tif") Then
            Err.clear
            errortxt="archivierung(14-13): Fehler bei Ghostscript: keine TIF-Datei erzeugt. Mglicherweise zu wenig freier Festplattenspeicher."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(dateiname)   
            Unlock(programm&lockdatei)
            WScript.Quit
            
        End If

        
        lngReturnCode = runfilter(dateiname&"-temp.tif",programm&"TIFF-300.txt",dateiname&"-archiv.tif")
        
        If lngReturnCode <> 0 Then
            Err.clear
            errortxt="archivierung(14-14): Fehler bei Filtern nach Ghostscript(Color)."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(dateiname)   
            Unlock(programm&lockdatei)
            WScript.Quit
            
        End If
        WScript.Sleep 200
        fs.deletefile dateiname&"-temp.tif", True
        
        
        
        
        archivtif=dateiname&"-archiv"
        If Not fs.fileexists(dateiname&"-archiv.tif") Then
            Err.clear
            errortxt="archivierung(14-15): Fehler bei Filter: keine TIF-Datei erzeugt. Mglicherweise zu wenig freier Festplattenspeicher." & vbCrLf & "Setze auf Standard-tif zurck" & vbCrLf &  dateiname&".tif"
            objWshShell.LogEvent 1, errortxt
            archivtif = dateiname
            
            If Not fs.fileexists(dateiname&".tif") Then
                Err.clear
                errortxt="archivierung(14-16): Fehler bei Filter: keine TIF-Datei erzeugt. Mglicherweise zu wenig freier Festplattenspeicher."  & vbCrLf &  dateiname&".tif"
                objWshShell.LogEvent 1, errortxt
                
                GetGarbage(dateiname)   
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
        End If
    End If
    
    If erfolg=False Then
        handle="unbekannt"
        Typ="TXT"
        OCRHandle=".tif"
        color=False
        
    End If
    
End Function




'*******************************************************************************************
'************************  AKT to PS                               *************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

Function AKTtoPS(dateiname)
    On Error Resume Next
    Err.clear
    erfolg=True
    tempextension=extension
    
    Set wshnet = CreateObject("WScript.Network")
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        errortxt="bitfarm-Archiv: Archivierung: Kann keinen Standarddrucker (1) festlegen. Entweder Serviceprinter nicht installiert oder Scripting Host Version zu alt."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
    End If
    
    If erfolg=True Then
        If setprintermethod="default" Then
            wshnet.SetDefaultPrinter "Serviceprinter"
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                errortxt="bitfarm-Archiv: Archivierung: Kann keinen Standarddrucker (2) festlegen. Entweder Serviceprinter nicht installiert oder Scripting Host Version zu alt."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
            End If
            Set wshnet=Nothing
        ElseIf setprintermethod="printui.dll" Then
            setdefault_serviceprinter()
        End If
    End If
    
    If (isBusy=True) And (rundirect=False) Then
        objWshShell.LogEvent 1, "bitfarm-Archiv Serverdienst: Kollission mit einer weiteren Instanz entdeckt."
        WScript.Quit
    End If
    
    
    If erfolg=True Then
        Err.clear
        If fs.FileExists(temp&"Serviceprinter.ps") Then
            fs.deletefile temp&"Serviceprinter.ps", True
            If Err.number <> 0 Then
                errortxt="archivierung(12-1(akt)): kann Serviceprinter.ps nicht lschen."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
                
            End If
        End If
    End If
    
    If fs.fileexists(programm&"ISBconvert.bat")=False Then
        erfolg=False
        errortxt="archivierung(12-2(akt)): Fehler: isbconvert.bat nicht vorhanden."
        objWshShell.LogEvent 1, errortxt
    End If
    
    If erfolg=True Then
        

        WScript.sleep 20
        
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"isbconvert.bat"&Chr(34)&" "&Chr(34)&dateiname&".akt"&Chr(34),0,True)
        
        WScript.sleep 200
        
        If lngReturnCode <> 0 Then
            Err.clear
            errortxt="archivierung(12-3(akt)): Fehler bei AKT-CAD-Konvertierung."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
        End If
    End If
    
    
    
    If erfolg=True Then
        If fs.FileExists(dateiname&".ps") Then
            fs.deletefile dateiname&".ps", True
            
        End If
    End If
    
    WScript.sleep 200
    If erfolg=True Then
        abbruch=False
        k=0
        Do While abbruch = False
            If fs.FileExists(temp&"Serviceprinter.ps") Then
                WScript.Sleep 400
                Err.clear
                fs.CopyFile temp&"Serviceprinter.ps", dateiname&".ps", True
                If Err.number<>0 Then
                    Err.clear
                    On Error Resume Next
                    WScript.sleep 10000
                    fs.CopyFile temp&"Serviceprinter.ps", dateiname&".ps", True
                End If
                If Err.number<>0 Then
                    errortxt="archivierung(12-4(akt)): konnte aus Postscript-Datei nicht kopieren."&Err.number
                    Err.clear
                    On Error Resume Next
                    
                    objWshShell.LogEvent 1, errortxt
                    erfolg=False
                    abbruch=True
                End If
                abbruch=True
            Else
                WScript.Sleep 200
                k=k+1
                If k>280 Then
                    abbruch=True
                End If
            End If
        Loop
    End If
    
    If erfolg=True Then	
        If fs.FileExists(temp&"Serviceprinter.ps") Then
            Err.clear
            fs.deletefile temp&"Serviceprinter.ps", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
            End If
        End If
        
        
        If Not fs.FileExists(dateiname&".ps") Then
            
            errortxt="archivierung(12-5(akt)): konnte aus AKT-Datei keine PS-Datei erzeugen."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
        End If
    End If
    
    If erfolg=False Then
        handle="unbekannt"
        Typ="TXT"
        OCRHandle=".tif"
        color=True
        
    End If
    
    extension=tempextension
    
End Function



'*******************************************************************************************
'************************  IView to PS  (Umwandlung aller Formate, die mit ) ***************
'*************************************  (IrfanView in TIF gewandelt werden knnen ) ********
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

Function IViewtoTIF(dateiname)
    On Error Resume Next
    Err.clear
    erfolg=True
    tempextension=extension
    
    If (isBusy=True) And (rundirect=False) Then
        objWshShell.LogEvent 1, "bitfarm-Archiv Serverdienst: Kollission mit einer weiteren Instanz entdeckt."
        WScript.Quit
    End If
    
    
    
    If fs.fileexists(programm&"IrfanView.bat")=False Then
        erfolg=False
        errortxt="archivierung(12-2(IView)): Fehler: irfanview.bat nicht vorhanden."
        objWshShell.LogEvent 1, errortxt
    End If
    
    If erfolg=True Then
        
        
        'lngReturnCode = objWSHShell.Run(programm&"processmonitor.bat IView",0,true)
        
        WScript.sleep 20
        
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"irfanview.bat"&Chr(34)&" "&Chr(34)&dateiname&extension&Chr(34)&" "&Chr(34)&dateiname&".tif",0,True)
        
        WScript.sleep 200
        
        If lngReturnCode <> 0 Then
            Err.clear
            errortxt="archivierung(12-3(IView)): Fehler bei IrfanView-Konvertierung."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
        End If
    End If
    
    
    
    If Not fs.FileExists(dateiname&".tif") Then
        
        errortxt="archivierung(12-5(IView)): konnte keine TIF-Datei erzeugen."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
    End If
    
    
    If erfolg=False Then
        handle="unbekannt"
        Typ="TXT"
        OCRHandle=".tif"
        color=True
        
    End If
    
    extension=tempextension
    
End Function








'*******************************************************************************************
'*************************************  XML to TIF  ****************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

Function XMLtoTIF(dateiname)
    On Error Resume Next
    erfolg = True
    
    If xsltconverterpath="" Then
        objWshShell.LogEvent 1, "Archivierung.vbs XML2TIF: kein xsltconverter-Pfad in der scripts.ini angegeben"
        erfolg = False
        
    End If
    
    If xslttemplate="" Then
        objWshShell.LogEvent 1, "Archivierung.vbs XML2TIF: kein xslttemplate in der scripts.ini angegeben"
        erfolg = False
        
    End If
    
    If foppath="" Then
        objWshShell.LogEvent 1, "Archivierung.vbs XML2TIF: kein foppath in der scripts.ini angegeben"
        erfolg = False
        
    End If
    
    'erster schritt  xml2fo
    
    If erfolg = True Then
        lngReturnCode = objWSHShell.Run(Chr(34)&xsltconverterpath & Chr(34)&" -xslt2 " & Chr(34)&xslttemplate  &Chr(34)&" -in "& Chr(34)&dateiname & extension&Chr(34)& " -out " & Chr(34)&dateiname & ".fo"&Chr(34),0, True)
        
        If lngReturnCode<> 0 Then
            objWSHShell.LogEvent 1, "Archivierung.vbs XML2TIF: Fehler bei der XML2FO Wandlung. Altovaxml nicht ordnungsgem terminiert" & vbCrLf & dateiname & ".fo" & vbCrLf & "ret:" & lngReturnCode
            erfolg = False
        End If
        
        timeout = 0
        Do While timeout < 100
            timeout = timeout +1
            WScript.Sleep 50
            If fs.FileExists(dateiname & ".fo") Then
                erfolg = True
                Exit Do
            End If
        Loop
        
        If erfolg = True Then
            Set testsize = fs.getfile(dateiname & ".fo")
            If testsize.size = 0 Then
                objWSHShell.LogEvent 1, "Archivierung.vbs XML2TIF: Fehler bei der XML2FO Wandlung. FO-Datei mit 0kb erzeugt" & vbCrLf & filefo & ".fo" & vbCrLf & filefo & ".ps"
                erfolg = False
            End If
            Set testsize = Nothing
        End If
        
        
        If erfolg = False Then
            objWshShell.LogEvent 1, "Archivierung.vbs XML2TIF: Fehler bei der XML2FO Wandlung. Keine FO-Datei erzeugt" & vbCrLf & Ausgabename & vbCrLf & filefo & ".fo"
        End If
    End If
    
    
    If erfolg = True Then
        ' zweiter schritt fo2ps
        erfolg = False
        beginn = Timer
        lngReturnCode = objWSHShell.Run(Chr(34)&foppath &Chr(34)& " " & Chr(34)&dateiname & ".fo"&Chr(34)&" -ps " & Chr(34)&dateiname & ".ps"&Chr(34),0,True)
        
        If lngReturnCode<> 0 Then
            objWSHShell.LogEvent 1, "Archivierung.vbs XML2TIF: Fehler bei der FO2PS Wandlung. Fop nicht ordnungsgem terminierte" & vbCrLf & filefo & ".fo" & vbCrLf & "ret:" & lngReturnCode
            erfolg = False
        End If
        
        timeout = 0
        Do While timeout < 100
            timeout = timeout +1
            WScript.Sleep 50
            If fs.FileExists(dateiname & ".ps") Then
                erfolg = True
                Exit Do
            End If
        Loop
        
        If erfolg = True Then
            Set testsize = fs.getfile(dateiname & ".ps")
            If testsize.size = 0 Then
                objWSHShell.LogEvent 1, "Archivierung.vbs XML2TIF: Fehler bei der FO2PS Wandlung. PS-Datei mit 0kb erzeugt" & vbCrLf & filefo & ".fo" & vbCrLf & filefo & ".ps"
                erfolg = False
            End If
            Set testsize = Nothing
        End If
        
        If erfolg = False Then
            objWSHShell.LogEvent 1, "Archivierung.vbs XML2TIF: Fehler bei der FO2PS Wandlung. Keine PS-Datei erzeugt" & vbCrLf & filefo & ".fo" & vbCrLf & filefo & ".ps"
            
        End If
        
    End If
    
    ' dritter schritt ps2tif wandlung
    
    
    If erfolg = True Then
        
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"processmonitor.bat"&Chr(34)&" ghostscript",0,True)
        WScript.Sleep 200
        
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"ghostscript.bat"&Chr(34)&" @"&Chr(34)&programm&"tiff-300.rsp"&Chr(34)&" "&Chr(34)&dateiname&".tif"&Chr(34)&" "&Chr(34)&dateiname&".ps"&Chr(34),0,True)
        If lngReturnCode <> 0 Then
            Err.clear
            On Error Resume Next
            errortxt="Archivierung.vbs XML2TIF: Fehler bei Ghostscript."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
            
        End If
        WScript.Sleep 200
        
        If fs.FileExists(dateiname&".tif") Then
            erfolg = True
            'archivtif=dateiname&".tif"
        End If
        
        If erfolg = False Then
            objWshShell.LogEvent 1, "Archivierung.vbs XML2TIF: Fehler bei der PS2TIF Wandlung. Keine TIF-Datei erzeugt" & vbCrLf & filefo & ".ps" & vbCrLf & filefo & ".tif"
        End If
    End If
    
    
    If erfolg=False Then
        handle="unbekannt"
        Typ="TXT"
        OCRHandle=".tif"
    End If
    
End Function


'*******************************************************************************************
'*************************  TIF-Datei fr unbekannte Dateitypen  ***************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************


Function makefilltif(dateiname)
    On Error Resume Next
    Err.Clear
    makefilltif=True
    
    If fs.fileexists(dateiname&".tff") Then
        makefilltif=False
    End If
    
    If makefilltif=True Then
        Err.clear
        Set temptxtfile = fs.OpenTextFile(dateiname&".tff",8,True)
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        If Originaldatei<>"" Then
            temptxtfile.writeline("   Datei: "&Originaldatei&extension&"   ")
        End If
        If Originaldatei="" And myname <> "" Then
            If fromEmail Then
                temptxtfile.writeline("   Betreff:   ")
            Else
                temptxtfile.writeline("   Titel:   ")
            End If
            temptxtfile.writeline("   "&myname&"   ")
        End If
        temptxtfile.writeline(" ")
        temptxtfile.writeline("   (keine Voransicht verfgbar)   ")
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        temptxtfile.close
        Set temptxtfile=Nothing
    End If
    
    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"Text2TIF.exe"&Chr(34)&" "&Chr(34)&dateiname&".tff"&Chr(34),0,True)
    Typ="TXT"
    
    If lngReturnCode <> 0 Then
        Err.clear
        errortxt="archivierung(122a): Fehler bei Text2TIF.exe" & vbCrLf & Chr(34)&programm&"Text2TIF.exe"&Chr(34)&" "&Chr(34)&dateiname&".tff"&Chr(34)
        objWshShell.LogEvent 1, errortxt
        GetGarbage(dateiname)   
        Unlock(programm&lockdatei)
        WScript.Quit
        
    End If
    
    WScript.Sleep 100
    fs.deletefile dateiname&".tff",True
    archivtif=dateiname
    OCRHandle=".tif"
End Function

'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

Function getoriginalname(tempname)
    On Error Resume Next
    

    faxnummer=""
    fax=""
    Originaldatei=""
    
    
    If fs.fileexists(tempname&".slw") Then
        swdateiname=tempname&".swz"
        manswdateiname=tempname&".slw"
        
        
        kette=""
        Set swdatei = fs.OpenTextFile(swdateiname,8,True)
        
        x=0
        If fs.fileexists(manswdateiname) Then
            Set manswdatei = fs.OpenTextFile(manswdateiname,1)
            Do While manswdatei.AtEndOfStream <> True
                kette=manswdatei.readline
                'If swduplett(kette)=false Then
                If InStr(1,kette,"Dateiname=",1)<>0 Then
                    swdatei.Writeline(kette)
                    Originaldatei=Right(kette,Len(kette)-(InStr(1,kette,"Dateiname=",1)+9))
                    If LCase(originaldatei)="fax" Then
                        originaldatei=""
                    End If
                ElseIf InStr(1,kette,"Richtung=",1)<>0 Then
                    Richtung=Right(kette,Len(kette)-(InStr(1,kette,"Richtung=",1)+8))
                ElseIf InStr(1,kette,"Empfaenger=",1)<>0 Then
                    empfaenger=Right(kette,Len(kette)-(InStr(1,kette,"Empfaenger=",1)+10))
                ElseIf InStr(1,kette,"Absender=",1)<>0 Then
                    Absender=Right(kette,Len(kette)-(InStr(1,kette,"Absender=",1)+8))
                ElseIf InStr(1,kette,"Absenderadresse=",1)<>0 Then
                    absenderadresse=Right(kette,Len(kette)-(InStr(1,kette,"Absenderadresse=",1)+15))
                ElseIf InStr(1,kette,"Betreff=",1)<>0 Then
                    betreff=Right(kette,Len(kette)-(InStr(1,kette,"Betreff=",1)+7))
                ElseIf InStr(1,kette,"Versanddatum=",1)<>0 Then
                    Versanddatum=Right(kette,Len(kette)-(InStr(1,kette,"Versanddatum=",1)+12))
                ElseIf InStr(1,kette,"Versanduhrzeit=",1)<>0 Then
                    versanduhrzeit=Right(kette,Len(kette)-(InStr(1,kette,"Versanduhrzeit=",1)+14))
                ElseIf InStr(1,kette,"Empfangsdatum=",1)<>0 Then
                    empfangsdatum=Right(kette,Len(kette)-(InStr(1,kette,"Empfangsdatum=",1)+13))
                ElseIf InStr(1,kette,"Empfangsuhrzeit=",1)<>0 Then
                    empfangsuhrzeit=Right(kette,Len(kette)-(InStr(1,kette,"Empfangsuhrzeit=",1)+15))
                ElseIf InStr(1,kette,"Kategorie=",1)<>0 Then
                    Kategorie=Right(kette,Len(kette)-(InStr(1,kette,"Kategorie=",1)+9))
                ElseIf InStr(1,kette,"Faxnummer=",1)<>0 Then
                    faxnummer=Right(kette,Len(kette)-(InStr(1,kette,"Faxnummer=",1)+9))
                    If faxnummer<>"" Then
                        herkunft="Fax"
                    End If
                ElseIf InStr(1,kette,"Fax=",1)<>0 Then
                    Fax=Right(kette,Len(kette)-(InStr(1,kette,"Fax=",1)+3))
                    If LCase(fax)="true" Then
                        herkunft="Fax"
                    End If
                ElseIf InStr(1,kette,"CC=",1)<>0 Then
                    cc=Right(kette,Len(kette)-(InStr(1,kette,"CC=",1)+2))
                ElseIf InStr(1,kette,"BCC=",1)<>0 Then
                    bcc=Right(kette,Len(kette)-(InStr(1,kette,"BCC=",1)+3))
                    
                Else
                    swdatei.Writeline(kette)
                    x=x+1
                End If
                'End If
            Loop
            manswdatei.close
            Set manswdatei = Nothing
        End If
        swdatei.close
        Set swdatei = Nothing
        WScript.sleep 30
        fs.deletefile manswdateiname, True
        WScript.sleep 30
        fs.copyfile swdateiname, manswdateiname, True
        WScript.sleep 30
        fs.deletefile swdateiname, True
        WScript.sleep 30
    End If
    

    
End Function



'*******************************************************************************************
'*************************************  Automatische Verschlagwortung  *********************
'*******************************************************************************************
'*******************************************************************************************


Function autoschlagwort()
    On Error Resume Next
    swdateiname=tempname&".swd"
    manswdateiname=tempname&".slw"
    
    kette=""
    Set swdatei = fs.OpenTextFile(swdateiname,8,True)
    
    If readbarcodes=True Then
        For x=0 To 29
            If barcode(x)<>"" Then
                swdatei.Writeline(barcode(x))
            End If
        Next
    End If
    
    If myname <> "Dokument" Then
        swdatei.Writeline(myname)
    End If
    
    x=0
    If fs.fileexists(manswdateiname) Then
        Set manswdatei = fs.OpenTextFile(manswdateiname,1)
        Do While manswdatei.AtEndOfStream <> True
            kette=manswdatei.readline
            
            If InStr(1,kette,"Barcode:",1)<>0 Then
                kette=""
            End If
            If InStr(1,kette,"Message:BarcodeRead=Complete",1)<>0 Then
                kette=""
            End If
            
            'If swduplett(kette)=false Then
            If kette<>"" Then
                swdatei.Writeline(kette)
            End If	
            x=x+1
            
            'End If
        Loop
        manswdatei.close
        Set manswdatei = Nothing
    End If
    swdatei.close
    Set swdatei = Nothing
    
    If (handle="") And (x>0) Then
        checkOCR=False
    End If
    
    If x>1 Then
        checkOCR=False
    End If
    
    
    '**************************************************************************************************
    '******************************  Auswertung evtl. vorhandener Maskengrafiken **********************
    '**************************************************************************************************
    '**************************************************************************************************
    
    maskenindex=0
    
    Do While maskenindex<50
        
        maskengrafik=tempname&"-OCR"&maskenindex&"mask"
        
        If fs.fileExists(maskengrafik&".tif") Then
            
            '*********************  Aufbereitung fr Omnipage  **************************
            WScript.Sleep 100
            Err.clear
            autosw=programm&"queue\swtemp"
            If fs.FileExists(autosw&".tif") Then
                fs.DeleteFile autosw&".tif", True
                If Err.number <> 0 Then
                    objWshShell.LogEvent 2, "archivierung(autoschlagwort): noch vorhandene autosw-grafikdatei nicht lschbar. "
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If
            End If
            
            If ompversion>15 Then
                fs.copyfile maskengrafik&".tif", autosw&".tif", True
            Else
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"mergerv3.exe"&Chr(34)&" "&Chr(34)&programm&"blank.tif"&Chr(34)&" "&Chr(34)&maskengrafik&".tif"&Chr(34)&" "&Chr(34)&autosw&".tif"&Chr(34),0,True)
            End If
            
            WScript.Sleep 200
            If Err.number<>0 Then
                objWshShell.LogEvent 1, "archivierung(autoschlagwort): Fehler bei Omipage-Vorbereitung "&Err.number
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
            
            If Not fs.fileexists(autosw&".tif") Then
                objWshShell.LogEvent 1, "archivierung(autoschlagwort): Fehler bei Omipage-Vorbereitung: Grafikdatei existiert nicht"
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
            
            
            OCRname=autosw
            
            If fs.FileExists(OCRname&".xjf") Then
                fs.DeleteFile OCRname&".xjf", True
                If Err.number <> 0 Then
                    objWshShell.LogEvent 1, "archivierung(autoschlagwort): noch vorhandene .xjf nicht lschbar. 2. Prozess? ("&tempname&".xjf)"
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If
            End If
            If fs.FileExists(OCRname&"_0.dat") Then
                fs.DeleteFile OCRname&"_0.dat", True
                If Err.number <> 0 Then
                    objWshShell.LogEvent 1, "archivierung(autoschlagwort): noch vorhandene .dat nicht lschbar. 2. Prozess? ("&tempname&"_0.dat)"
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If
            End If
            If fs.FileExists(programm&"queue\OCR.txt") Then
                fs.DeleteFile programm&"queue\OCR.txt", True
                If Err.number <> 0 Then
                    objWshShell.LogEvent 1, "archivierung(autoschlagwort): noch vorhandene OCR.txt nicht lschbar. 2. Prozess?"
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If
            End If
            
            lngReturnCode = ocrcommand(OCRname)
            If lngReturnCode <> 0 Then
                objWSHShell.LogEvent 1, "archivierung(autoschlagwort): Fehler bei Anpassen .xjf Datei Omnipage ("&OCRname&")"
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
            
            Typ="OMP"	'die omnipage soll fr die maske auch laufen, wenn fr das gesamte dokument kein volltext bentigt wurde
            ismaskocr=True
            runOmnipage
            ismaskocr=False
            schlagwort=""
            operation=""
            maskenname=""
            If fs.fileexists(maskengrafik&".tif.mlf") Then
                Set mlfdatei=fs.OpenTextFile(maskengrafik&".tif.mlf",1)
                operation=mlfdatei.readline
                maskenname=mlfdatei.readline
                deletemaskspaces=mlfdatei.readline
                deletemaskdashes=mlfdatei.readline
                deletemaskdots=mlfdatei.readline
                getallmaskstrings=mlfdatei.readline
                masknumeric=mlfdatei.readline
                maskalphabetic=mlfdatei.readline
                maskdate=mlfdatei.readline
                maskinterval=mlfdatei.readline
                maskvalue=mlfdatei.readline
                mlfdatei.close
                Set mlfdatei=Nothing
            End If
            Err.clear
            If fs.fileexists(OCRname&".txt")=False Then
                If fs.fileexists(programm&"queue\OCR.txt") Then
                    fs.copyfile programm&"queue\OCR.txt", OCRname&".txt", True
                    If Err.number<>0 Then
                        Err.clear
                        objWSHShell.LogEvent 1, "archivierung(autoschlagwort): Fehler beim umkopieren OCR.txt"
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If
                    WScript.sleep 30
                End If
            End If
            
            
          
            If fs.fileexists(OCRname&".txt") Then
                Set autoswdatei = fs.OpenTextFile(OCRname&".txt",1)
                Set swdatei = fs.OpenTextFile(swdateiname,8,True,0)
                If getallmaskstrings=False Then
                    If autoswdatei.AtEndOfStream <> True Then
                        schlagwort=autoswdatei.readline
                    End If
                Else
                    Do While autoswdatei.AtEndOfStream <> True
                        schlagwort=schlagwort&" "&autoswdatei.readline
                    Loop
                End If
                
                validstring="1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ 	/\.,;:-_?!+*@&"
                If deletemaskspaces=1 Then
                    schlagwort=RemoveSpace(schlagwort)
                    validstring=RemoveSpace(validstring)
                    
                End If
                If deletemaskdashes=1 Then
                    schlagwort=RemoveDash(schlagwort)
                    validstring=RemoveDash(validstring)
                End If
                If deletemaskdots=1 Then
                    schlagwort=RemoveDots(Schlagwort)
                    validstring=RemoveDots(validstring)
                End If
                If masknumeric=1 Then
                    schlagwort=makenumeric(schlagwort)
                End If
                If maskalphabetic=1 Then
                    schlagwort=makealphabetic(schlagwort)
                End If
                If maskinterval=1 Then
                    schlagwort=makeinterval(schlagwort)
                End If
                If maskvalue=1 Then
                    schlagwort=makevalue(schlagwort)
                End If
                
                If maskdate="1" Then
                    schlagwort=makedate(schlagwort,False)
                End If
                
                If maskdate="2" Then
                    schlagwort=makedate(schlagwort,True)
                End If
                
                schlagwort=Trim(schlagwort)		
                
                '+++++++++++++++++++++++++++++++++++++++++++++++ evtl. Schneideanweisungen decodieren und ausfhren ++++++++++++++++++++++++++
                If schlagwort<>"" Then	
                    Err.clear			
                    If (operation>0) And (operation<64) Then
                        If (operation>31) Then
                            schlagwort=Right(schlagwort,Len(schlagwort)-(operation-32))
							If IsInArray(schlagwort, linkspeicher) = False Then
								linkspeicher(linkzaehler)=schlagwort
								linkzaehler=linkzaehler+1
							End if
                        Else
                            If (operation>0) And (operation<32) Then
                                schlagwort=Right(schlagwort,Len(schlagwort)-operation)
                            End If
                        End If
                    End If
                    
                    If (operation>64) And (operation<128) Then
                        If (operation>95) Then
                            schlagwort=Left(schlagwort,Len(schlagwort)-(operation-96))
                            If IsInArray(schlagwort, linkspeicher) = False Then
								linkspeicher(linkzaehler)=schlagwort
								linkzaehler=linkzaehler+1
							End if
                        Else	
                            
                            schlagwort=Left(schlagwort,Len(schlagwort)-(operation-64))
                        End If
                    End If
                    
                    If (operation>128) And (operation<192) Then
                        If (operation>159) Then
                            schlagwort=Left(schlagwort,(operation-160))
                            If IsInArray(schlagwort, linkspeicher) = False Then
								linkspeicher(linkzaehler)=schlagwort
								linkzaehler=linkzaehler+1
							End if
                        Else
                            schlagwort=Left(schlagwort,(operation-128))
                        End If
                    End If
                    If (operation>192) And (operation<256) Then
                        If (operation>223) Then
                            schlagwort=Right(schlagwort,(operation-224))
                            If IsInArray(schlagwort, linkspeicher) = False Then
								linkspeicher(linkzaehler)=schlagwort
								linkzaehler=linkzaehler+1
							End if
                        Else
                            schlagwort=Right(schlagwort,(operation-192))
                        End If
                    End If
                    Err.clear
                End If							
                '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                
                If schlagwort<>"" And validstring <> "" Then
                    laenge=Len(schlagwort)
                    valid=True
                    For d=1 To laenge
                        w=Mid(schlagwort,d,1)
                        If InStr(1,validstring,w) Then
                            valid=valid And True
                        Else
                            valid=valid And False
                            Exit For
                        End If 
                    Next
                    If valid=False Then
                        schlagwort=""
                    End If
                End If
                
                schlagwort=Trim(schlagwort)
                
                
                
                If schlagwort<>"" Then
                    checkOCR=False	
                    swdatei.Writeline(schlagwort)
                    
                    gefunden=False
                    d=0
                    Do While gefunden=False
                        If LCase(zusatzfeldname(d))=LCase(maskenname) Then
                            gefunden=True
                            If zusatzfeld(d)="" Then
                                zusatzfeld(d)=schlagwort
                            End If
                        End If
                        d=d+1
                        If d>=limit Then
                            gefunden=True
                        End If
                    Loop
                    If d>=limit Then
                        gefunden=False
                    End If
                    d=0
                    Do While gefunden = False
                        If Zusatzfeldname(d)="" Then
                            gefunden=True
                            zusatzfeld(d)=schlagwort
                            zusatzfeldname(d)=maskenname
                        End If
                        If gefunden=False Then
                            d=d+1
                        End If
                        If d>=limit Then
                            gefunden=True
                        End If
                    Loop
                    If d>=limit Then
                        errortxt="bitfarm-Archiv: berlauf im Zusatzfeldarray (autoschlagwort)."
                        
                        i=0
                        Do While i<limit
                            errortext=errortxt&Zusatzfeldname(i)&":"&Zusatzfeld(i)&vbCrLf
                            i=i+1
                        Loop
                        
                        objWshShell.LogEvent 1, errortxt
                        getgarbage(tempname)
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If
                    
                End If
                autoswdatei.close
                Set autoswdatei = Nothing
                swdatei.close
                Set swdatei=Nothing
                WScript.Sleep 200
            End If
            
            If schlagwort="" Then
                If overridecheck=False Then
                    notifyUser=True
                End If
            End If
            
            
            If fs.fileexists(OCRname & "_0.dat") Then
                fs.DeleteFile(OCRname & "_0.dat")
                Err.clear
            End If
            
            If fs.fileexists(OCRname & ".txt") Then
                fs.DeleteFile(OCRname & ".txt")
                Err.clear
            End If
            
            If fs.fileexists(OCRname & ".xjf") Then
                fs.DeleteFile(OCRname & ".xjf")
                Err.clear
            End If
            
            If fs.fileexists(autosw & ".tif") Then
                fs.DeleteFile(autosw & ".tif")
                Err.clear
            End If
            
            If fs.fileexists(maskengrafik&".tif") Then
                fs.DeleteFile(maskengrafik&".tif")
                Err.clear
            End If
            
            If fs.fileexists(maskengrafik&".tif.mlf") Then
                fs.DeleteFile(maskengrafik&".tif.mlf")
                Err.clear
            End If
            Err.Clear
            
            
        End If
        maskenindex=maskenindex+1
    Loop
    
    
    
    '**************************************************************************************************
    '******************************  Barcodeextraktion ************************************************
    '**************************************************************************************************
    '**************************************************************************************************
    
    maskenindex=0
    
    Do While maskenindex<50
        
        maskengrafik=tempname&"-OCR"&maskenindex&"barcode"
        
        If fs.fileExists(maskengrafik&".tif") Then
            If maskdebug=True Then
                If Not fs.FolderExists(masks&"debug") Then
                    fs.createfolder(masks&"debug")
                End If                                        
                maskdebugtif = Replace(maskengrafik&".tif", "queue", "masks\debug")
                fs.copyfile maskengrafik&".tif", maskdebugtif
            End If
            
            barcodetype=""
            operation=""
            maskenname=""
            schlagwort=""
            If fs.fileexists(maskengrafik&".tif.blf") Then
                Set mlfdatei=fs.OpenTextFile(maskengrafik&".tif.blf",1)
                operation=mlfdatei.readline
                maskenname=mlfdatei.readline
                deletemaskspaces=mlfdatei.readline
                deletemaskdashes=mlfdatei.readline
                barcodetype=mlfdatei.readline
                mlfdatei.close
                Set mlfdatei=Nothing
            End If
            
            
            If Not fs.fileexists(bcpluspath) Then
                If barcodemask="" Then
                    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"rdtifbar.exe"&Chr(34)&" "&Chr(34)&maskengrafik&".tif"&Chr(34),0,True)
                Else
                    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"rdtifbar.exe"&Chr(34)&" "&Chr(34)&maskengrafik&".tif"&Chr(34)&" -p:"&barcodemask,0,True)
                End If
                If Err.number<>0 Then
                    errortxt="archivierung(19-16): Fehler beim starten von rdtifbar ("&maskengrafik&".tif). Errornummer: "&Err.number
                    objWshShell.LogEvent 1, errortxt
                    Err.Clear
                End If
            Else
                runbcplus=True
                If (fs.fileexists(maskengrafik&".tif")) And (Not fs.fileexists(maskengrafik&".bar")) Then
                    If barcodefilter <> "" Then					
                        If fs.fileexists(programm & "filter\" & barcodefilter) Then
                            rc = runfilter(maskengrafik&".tif",programm & "filter\" & barcodefilter,maskengrafik&"-bc.tif")
                            If rc = 0 Then
                                maskengrafik = maskengrafik & "-bc"
                            End If 
                        End If 
                    End If 
                    
                    Err.Clear
                    strinput=""
                    
                    Set oExec = objWSHShell.Exec(Chr(34)&bcpluspath &Chr(34)& " "&Chr(34)&maskengrafik&".tif"&Chr(34))
                    
                    Do While Not oExec.StdOut.AtEndOfStream
                        strinput = strinput & oExec.StdOut.ReadAll
                    Loop
                    If scriptdebug = True Then
                        errortxt="archivierung(19a): Maskenextraktion Rckgabe bcplus: "&vbCrLf&strinput
                        objWshShell.LogEvent 1, errortxt
                    End If
                    durch = False
                    schleife = 0
                    Do While schleife < 100
                        If oExec.Status = 1 Then 
                            durch = True
                            Exit Do
                        End If
                        
                        WScript.Sleep 100  
                        schleife = schleife +1
                    Loop
                    
                    rc = oExec.ExitCode
                    
                    If durch = False Then
                        errortxt="archivierung(18eg): Fehler beim starten von bcplus ("&maskengrafik&".tif). rc: "&rc
                        objWshShell.LogEvent 1, errortxt
                        runbcplus=False
                    End If
                    
                    If runbcplus=True Then
                        WScript.sleep 200
                    End If
                End If
                
                
                '################################  es braucht manchmal etwas Zeit, bis die .bar Datei erscheint, deshalb drehen wir ein paar Runden...
                If runbcplus=True Then
                    gefunden=False
                    i=0
                    Do While gefunden=False
                        If fs.fileexists(maskengrafik&".bar") Then
                            gefunden=True
                        End If
                        
                        If gefunden=False Then
                            i=i+1
                            WScript.sleep 200
                        End If
                        If i>15 Then
                            Exit Do
                        End If
                    Loop
                End If
                
            End If 
            
            
            If fs.fileexists(maskengrafik&".bar") Then
                If scriptdebug = True Then
                    errortxt="archivierung(19b): Maskenextraktion erfolgreich, bar-Datei vorhanden"
                    objWshShell.LogEvent 1, errortxt
                    If maskdebug=True Then
                        If Not fs.FolderExists(masks&"debug") Then
                            fs.createfolder(masks&"debug")
                        End If                                        
                        maskdebugbar = Replace(maskengrafik&".bar", "queue", "masks\debug")
                        fs.copyfile maskengrafik&".bar", maskdebugbar
                    End If
                End If
                Set autoswdatei = fs.OpenTextFile(maskengrafik&".bar",1)
                Set swdatei = fs.OpenTextFile(swdateiname,8,True,0)
                If autoswdatei.AtEndOfStream <> True Then
                    schlagwort=autoswdatei.readline
                    
                End If
                
                validstring="1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ 	/\.,;:-_?!+*@"
                If deletemaskspaces=1 Then
                    schlagwort=RemoveSpace(schlagwort)
                    validstring=RemoveSpace(validstring)
                End If
                If deletemaskdashes=1 Then
                    schlagwort=RemoveDash(schlagwort)
                    validstring=RemoveDash(validstring)
                End If
                If deletemaskdots=1 Then
                    schlagwort=RemoveDots(Schlagwort)
                    validstring=RemoveDots(validstring)
                End If
                
                '+++++++++++++++++++++++++++++++++++++++++++++++ evtl. Schneideanweisungen decodieren und ausfhren ++++++++++++++++++++++++++
                If schlagwort<>"" Then	
                    Err.clear			
                    If (operation>0) And (operation<64) Then
                        If (operation>31) Then
                            schlagwort=Right(schlagwort,Len(schlagwort)-(operation-32))

							If IsInArray(schlagwort, linkspeicher) = False Then
								linkspeicher(linkzaehler)=schlagwort
								linkzaehler=linkzaehler+1
							End if

                        Else
                            If (operation>0) And (operation<32) Then
                                schlagwort=Right(schlagwort,Len(schlagwort)-operation)
                            End If
                        End If
                    End If
                    
                    If (operation>64) And (operation<128) Then
                        If (operation>95) Then
                            schlagwort=Left(schlagwort,Len(schlagwort)-(operation-96))
                            If IsInArray(schlagwort, linkspeicher) = False Then
								linkspeicher(linkzaehler)=schlagwort
								linkzaehler=linkzaehler+1
							End if
                        Else	
                            
                            schlagwort=Left(schlagwort,Len(schlagwort)-(operation-64))
                        End If
                    End If
                    
                    If (operation>128) And (operation<192) Then
                        If (operation>159) Then
                            schlagwort=Left(schlagwort,(operation-160))
                            If IsInArray(schlagwort, linkspeicher) = False Then
								linkspeicher(linkzaehler)=schlagwort
								linkzaehler=linkzaehler+1
							End if
                        Else
                            schlagwort=Left(schlagwort,(operation-128))
                        End If
                    End If
                    If (operation>192) And (operation<256) Then
                        If (operation>223) Then
                            schlagwort=Right(schlagwort,(operation-224))
                            If IsInArray(schlagwort, linkspeicher) = False Then
								linkspeicher(linkzaehler)=schlagwort
								linkzaehler=linkzaehler+1
							End if
                        Else
                            schlagwort=Right(schlagwort,(operation-192))
                        End If
                    End If
                    Err.clear
                End If							
                '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                
                If schlagwort<>"" And validstring <> "" Then
                    laenge=Len(schlagwort)
                    valid=True
                    For d=1 To laenge
                        w=Mid(schlagwort,d,1)
                        If InStr(1,validstring,w) Then
                            valid=valid And True
                        Else
                            valid=valid And False
                            Exit For
                        End If 
                    Next
                    If valid=False Then
                        schlagwort=""
                    End If
                End If
                
                If schlagwort<>"" Then
                    checkOCR=False	
                    swdatei.Writeline(schlagwort)
                    
                    gefunden=False
                    d=0
                    Do While gefunden=False
                        If LCase(zusatzfeldname(d))=LCase(maskenname) Then
                            gefunden=True
                            If zusatzfeld(d)="" Then
                                zusatzfeld(d)=schlagwort
                            End If
                        End If
                        d=d+1
                        If d>=limit Then
                            gefunden=True
                        End If
                    Loop
                    If d>=limit Then
                        gefunden=False
                        d=0
                        Do While gefunden = False
                            If Zusatzfeldname(d)="" Then
                                gefunden=True
                            End If
                            If gefunden=False Then
                                d=d+1
                            End If
                            If d>limit Then
                                gefunden=True
                            End If
                        Loop
                        If d>limit Then
                            errortxt="bitfarm-Archiv: berlauf im Zusatzfeldarray (barcode)."
                            objWshShell.LogEvent 1, errortxt
                        Else
                            zusatzfeld(d)=schlagwort
                            zusatzfeldname(d)=maskenname
                        End If
                    End If
                End If
                autoswdatei.close
                Set autoswdatei = Nothing
                swdatei.close
                Set swdatei=Nothing
                WScript.Sleep 200
            End If
            
            If schlagwort="" Then
                If overridecheck=False Then
                    notifyuser=True
                End If
            End If
            
            
            If fs.fileexists(maskengrafik&".tif") Then
                fs.DeleteFile(maskengrafik&".tif")
                Err.clear
            End If
            
            If fs.fileexists(maskengrafik&".tif.blf") Then
                fs.DeleteFile(maskengrafik&".tif.blf")
                Err.clear
            End If
            
            If fs.fileexists(maskengrafik&".bar") Then
                fs.DeleteFile(maskengrafik&".bar")
                Err.clear
            End If
            Err.Clear
        End If
        maskenindex=maskenindex+1
    Loop
    
    
    '**************************************************************************************************
    '******************************  Fertig, Dateien schlieen ****************************************
    '**************************************************************************************************
    
    WScript.sleep 200
    
    
End Function 


'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************


Function runTesseract()
	'On Error Resume Next
	OCRpath = programm & "OCRTemp\"
	bfatessocr = programm & "bfa_tessocr.exe"
	
	
	If ocrname="" Then
        ocrname=tempname
    End If
    
    delfolder(OCRpath & "in")
    delfolder(OCRpath & "out")
	ocrintif = OCRpath & "in\OCR" & OCRHandle
	ocrout = OCRpath & "out\OCR"
    fs.CopyFile ocrname & OCRHandle, ocrintif, True

	' calc max timeout for ocr
	If OCRHandle=".tif" Then
		maxseconds = tessmaxpagetime * Countpages(ocrintif)
	Else
		maxseconds = 120
	End If
	
	'usage: bfa_tessocr.exe [-h] [--numproc NUMPROC] [--pbstring PBSTRING]
    '                   [--lang LANG] [--outformat OUTFORMAT]
    '                   [--tessargs TESSARGS] [--overwrite]
    '                   [--tessdata TESSDATA] [--ompthreadlimit OMPTHREADLIMIT]
    '					[--txtencoding TXTENCODING]
    '                   inputfile outputbase

	cmd = Chr(34) & bfatessocr & chr(34) & " " & chr(34) & ocrintif & chr(34) & " " & Chr(34) & ocrout & Chr(34) & " --config " & chr(34) & programm & "bfa_tessocr_standalone.ini" & chr(34) & " --addorientation True --lang " & tesslang & " --outformat hocr+txt --numproc " & tessprocs  & " --txtencoding latin1 --overwrite --tessargs " & Chr(34) & "--psm 1"& Chr(34)
	If ftxaddpagebreaks <> False Then
		cmd = cmd & " --pbstring " & Chr(34)& ftxaddpagebreaks & Chr(34)
	Else
		cmd = cmd & " --pbstring " & Chr(34)&Chr(34)
	End If
	If scriptdebug=True Then
		objWSHShell.LogEvent 0, "archivierung.vbs ocrcommand: " & vbCrLf & cmd
	End If
	
	lngReturnCode = objWSHShell.Run(cmd,0,False)
	timeout = timeoutprocess("bfa_tessocr.exe", maxseconds)
	If lngReturnCode <> 0 Then
		objWSHShell.LogEvent 1, "Archivierung bfa_tessocr.exe Fehler -> returncode " &lngReturnCode
		notifyuser=True
        If alertonemptydoctxt=True Then
            emptydoctxt=True
        End If
	Else
		' check result
		If fs.FileExists(ocrout & ".txt") Then
			Set ocrfile = fs.getfile(ocrout & ".txt")
		    If ocrfile.size = 0 And Right(ocrname,6) <> "swtemp" Then
				notifyuser=True
		        If alertonemptydoctxt=True Then
		            emptydoctxt=True
		        End If
		        objWSHShell.LogEvent 1, "Archivierung bfa_tessocr.exe Fehler!" &vbCrLf & "Es wurde eine 0kb groe Textdatei zurckgegeben" & vbCrLf & ocrpath & "OUT\OCR.txt" & vbCrLf & tempname
		        erfolg = False
		        fs.DeleteFile ocrout & ".txt", True	
		        If Err.Number<> 0 Then
		            objWSHShell.LogEvent 1, "archivierung.vbs: Fehler beim lschen der 0kb OCR.txt" & vbCrLf & Err.Number & vbCrLf & Err.Description
		        End If
		        clean = clean_ocroutpath
		        If clean = False Then
		            objWSHShell.LogEvent 1, "archivierung.vbs: OCR\Out Pfad konnte nicht gerumt werden(3)"
		        End If
		    End If
		    Set ocrfile = Nothing
		Else
	        objWSHShell.LogEvent 1, "Archivierung bfa_tessocr.exe Fehler!" &vbCrLf & "Es wurde keine Textdatei zurckgegeben" & vbCrLf & ocrpath & "OUT\OCR.txt" & vbCrLf & tempname
	        erfolg = False				    
		End If
	    
	    If fs.fileexists(ocrout & ".hocr") And Right(ocrname,6) <> "swtemp" Then
	    	If fs.fileexists(tempname & ".hocr") Then
	    		fs.deletefile tempname & ".hocr"
	    	End If
	        fs.MoveFile ocrout & ".hocr", tempname&".hocr"
	 	End If
	 	
	 	If fs.fileexists(ocrout & ".txt") And Right(ocrname,6) <> "swtemp" Then
		 	If fs.fileexists(tempname & ".txt") Then
	    		fs.deletefile tempname & ".txt"
	    	End If
	    	
	    	Set objTextFile = fs.OpenTextFile(ocrout & ".txt", 1)
	    	tess_text = objTextFile.ReadAll
	    	objTextFile.close
	    	
	    	tess_text = Replace(tess_text, vbLf, vbCrLf)
	    	
	    	Set objTextFileNew = fs.CreateTextFile(tempname & ".txt")
	    	objTextFileNew.write(tess_text)
	    	objTextFileNew.close
	    	
	 	End If
	End If
End Function

Function runOmnipage()
	If usetesseract=False Then
		real_runOmnipage()
	Else
		runTesseract()
	End If
End Function


Function real_runOmnipage()
    On Error Resume Next
    
    '***************************************************************************************
    '****************************************** Omnipage 14 ********************************
    '***************************************************************************************
    If ocrserver <> "" Then
        cmd=programm&"OcrClient.exe -textout " & tempname & ".txt -xmlout " & tempname & ".ocr_xml " &ocrserver&" " & tempname & ".tif" 
        Set oExec    = objWSHShell.Exec(cmd)	
        
        Do While Not oExec.StdOut.AtEndOfStream
            strinput = strinput & oExec.StdOut.Read(1)	
        Loop
        
    End If
    
    
    
    If waitautoscan=True Then
        tz=True
        ta=0
        Do While tz=True
            If checkautoscan=True Then
                WScript.sleep 4000
                ta=ta+1
            Else
                tz=False
            End If
            If ta>80 Then
                tz=False
                waitautoscan=False
            End If
        Loop
    End If
    
    If OMPVersion=14  And (ocrserver="") Then
        flag1=3
        a=0
        durchlauf=1
        Do While (flag1 <> 0) And (durchlauf < 3)
            
            If scriptdebug=True Then
                objWshShell.LogEvent 2, "bitfarm-Archiv Debug-Archivierung "&OCRname&": Starte Omnipage 14 Durchlauf "&durchlauf 
            End If
            
            
            
            flag1=3
            
            If durchlauf > 1 Then
                WScript.sleep(3000)
                
            End If
            If isBusy=True Then
                objWshShell.LogEvent 1, "bitfarm-Archiv Serverdienst: Kollission, beende."
                WScript.Quit
            End If
            waitdirect()
            
            '******************************** Omnipage starten ******************************
      
            OMPrun = objWSHShell.Run(Chr(34)&programm&"omnipage.bat"&Chr(34)&" "&omnipage&" "&Chr(34)&OCRname&".xjf"&Chr(34),0,True)
            '******************************** auf Ergebnis warten ****************************
            WScript.Sleep 5000
            abbruch=False
            a=0
            
            Do While abbruch = False
                If checkomnipage=0 Then
                    abbruch=True
                End If
                
                If abbruch = False Then
                    
                    zaehler3=0
                    zaehler2=0
                    abbruch2=False
                    WScript.Sleep 1000
                    Do While abbruch2=False
                        mycheck=0
                        mycheck=checkomnipage
                        
                        If mycheck=3 Then
                            zaehler3=zaehler3+1
                        End If
                        
                        If mycheck=2 Then
                            zaehler2=zaehler2+1
                            If zaehler3>0 Then
                                zaehler2=zaehler2+zaehler3
                                zaehler3=0
                            End If
                        End If	
                        
                        If mycheck=1 Then
                            abbruch2=True
                        End If
                        
                        If mycheck=0 Then
                            abbruch=True
                            abbruch2=True
                        End If
                        
                        If zaehler3>50 Then
                            abbruch2=True
                            abbruch=True
                            a=ompwaittime
                        End If
                        
                        If zaehler2>65 Then
                            abbruch2=True
                            abbruch=True
                            a=ompwaittime
                        End If
                        
                        If abbruch2=False Then
                            WScript.sleep 1500
                        End If
                    Loop
                End If
                
                If abbruch=False Then	
                    WScript.Sleep 1000
                End If
                a = a + 1
                If a>=ompwaittime Then
                    abbruch=True
                End If
            Loop
            
            If scriptdebug=True Then
                objWshShell.LogEvent 4, "bitfarm-Archiv Debug-Archivierung "&OCRname&": Omnipage 14 Durchlauf "&durchlauf&" Trap 1" 
            End If
            
            If Not fs.fileexists(programm&lockdatei) Then
                objWshShell.LogEvent 1,"archivierung: Omnipage-Prozess von Dienstkontrolle terminiert."

            End If
            
            If a < ompwaittime Then
                
                flag1=2
                If abbruch=True Then
                 
                    If fs.FileExists(programm&"KillOP.exe") Then
                        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"KillOP.exe"&Chr(34),0,True)
                    End If
                    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
                    strQuery = "Select * from Win32_Process where Name='omnipage.exe'"
                    Set colItems = objWMIService.ExecQuery(strQuery,,48)
                    For Each objItem In colItems
                        objItem.Terminate()
                    Next
                    Set objItem = Nothing
                    Set colItems = Nothing
                    Set objWMIService = Nothing
                End If
                
                WScript.Sleep 300
                
                Err.clear
                On Error Resume Next
                
            Else
                
                If abbruch=True Then
                 
                    If fs.FileExists(programm&"KillOP.exe") Then
                        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"KillOP.exe"&Chr(34),0,True)
                    End If
                    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
                    strQuery = "Select * from Win32_Process where Name='omnipage.exe'"
                    Set colItems = objWMIService.ExecQuery(strQuery,,48)
                    For Each objItem In colItems
                        objItem.Terminate()
                    Next
                    Set objItem = Nothing
                    Set colItems = Nothing
                    Set objWMIService = Nothing
                    
                End If
                WScript.Sleep 5000
                objWshShell.LogEvent 1, "archivierung(17a): Omnipage-Prozess restart. Durchlauf: "&durchlauf&" ("&OCRname&")."
                
                If fs.fileexists(OCRname & "_0.dat") Then
                    fs.DeleteFile(OCRname & "_0.dat")
                    
                    If Err.number<>0 Then
                        objWshShell.LogEvent 1, "archivierung(17aa): Fehler bei Omnipage-restart."&Err.number
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If
                End If
                
                
                If fs.fileexists(OCRname & ".txt") Then
                    fs.DeleteFile(OCRname & ".txt")
                    If Err.number<>0 Then
                        objWshShell.LogEvent 1, "archivierung(17ab): Fehler beiOmnipage-Restart."&Err.number
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If
                End If
                
                WScript.Sleep(3000)
            End If
            WScript.Sleep(300)
            
            If flag1>0 Then
                flag1=1
                If fs.FileExists(OCRname&".txt") Then
                    flag1=0
 
                End If
                
            End If
            
            If scriptdebug=True Then
                objWshShell.LogEvent 4, "bitfarm-Archiv Debug-Archivierung "&OCRname&": Omnipage 14 Durchlauf "&durchlauf&" beendet mit flag1:"&flag1 
            End If
            
            durchlauf = durchlauf + 1
        Loop
        
        If scriptdebug=True Then
            objWshShell.LogEvent 1, "bitfarm-Archiv Debug-Archivierung "&OCRname&": Omnipage 14 Durchlauf komplett beendet." 
        End If
        
        '****************************** fertig. aufrumen ggf. und sind wir innerhalb 3 Durchlufen zufrieden? *************
        
        If fs.FileExists(OCRname&".pid") Then
            fs.DeleteFile OCRname&".pid", True
            If Err.number <> 0 Then
                objWshShell.LogEvent 1, "archivierung(17d): Schwerer Fehler: Kann pidfile nicht lschen!!! ("&tempname&".pid)"
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
        End If
        
    End If
    
    '***************************************************************************************
    '****************************************** Omnipage 15 ********************************
    '***************************************************************************************
    If OMPVersion=15  And (ocrserver="") Then
        
        
        flag1=3
        a=0
        durchlauf=1
        Do While (flag1 <> 0) And (durchlauf < 3)
            flag1=3
            If durchlauf > 1 Then
                WScript.sleep(3000)
                
            End If
            
            If fs.fileexists(queue&"OCR.txt") Then
                Err.clear
                fs.deletefile queue&"OCR.txt", True
                If Err.number <> 0 Then
                    Err.clear
                    On Error Resume Next
                    errortxt="bitfarm-Archiv: runomnipage() Omnipage15-Ansteuerung: konnte OCR.txt nicht lschen."
                    getgarbage(tempname)
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If
            End If
            
            If fs.fileexists(tempname&".tmp.txt") Then
                Err.clear
                fs.deletefile tempname&".tmp.txt", True
                If Err.number <> 0 Then
                    Err.clear
                    On Error Resume Next
                    errortxt="bitfarm-Archiv: runomnipage() Omnipage15-Ansteuerung: konnte tempname.tmp.txt nicht lschen."
                    getgarbage(tempname)
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If
            End If
            
            If fs.fileexists(OCRname & ".txt") Then
                fs.DeleteFile(OCRname & ".txt")
                If Err.number<>0 Then
                    objWshShell.LogEvent 1, "archivierung(17ac): Fehler bei Omnipage (Dateilschung)."&Err.number
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If
            End If
            
            If Err.number <> 0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(17ad): Allgemeiner Omnipage-Fehler."
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
            
            If Not fs.fileexists(queue&"OCR.xwf") Then
                WScript.sleep 100
                If Not fs.fileexists(queue&"OCR.xwf") Then
                    errortxt="bitfarm-Archiv: runomnipage() Omnipage15-Ansteuerung: OCR.xwf nicht vorhanden."
                    getgarbage(tempname)
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If
            End If
            
            '*******************************  reg und temp dateien lschen *******************
            cleanOMP15
            WScript.Sleep 50
            
            If isBusy=True Then
                objWshShell.LogEvent 1, "bitfarm-Archiv Serverdienst: Kollission mit einer weiteren Instanz entdeckt."
                WScript.Quit
            End If
            
            '******************************** Omnipage starten ******************************

            OMPrun = objWSHShell.Run(Chr(34)&programm&"omnipage.bat"&Chr(34)&" "& Chr(34)&omnipage&Chr(34)& " "&Chr(34)&queue&"OCR.xwf"&Chr(34),0,True)
            '******************************** auf Ergebnis warten ****************************
            WScript.Sleep 5000
            abbruch=False
            a=0
            Do While abbruch = False
                If checkomnipage=0 Then
                    abbruch=True
                End If
                
                If fs.fileexists(queue&"OCR.txt") Then
                    abbruch=True
                End If
                If abbruch = False Then
                    
                    zaehler3=0
                    zaehler2=0
                    abbruch2=False
                    WScript.Sleep 1000
                    Do While abbruch2=False
                        
                        mycheck=0
                        mycheck=checkomnipage
                        
                        If mycheck=3 Then
                            zaehler3=zaehler3+1
                        End If
                        
                        If mycheck=2 Then
                            zaehler2=zaehler2+1
                            If zaehler3>0 Then
                                zaehler2=zaehler2+zaehler3
                                zaehler3=0
                            End If
                        End If	
                        
                        If mycheck=1 Then
                            abbruch2=True
                        End If
                        
                        If mycheck=0 Then
                            abbruch=True
                            abbruch2=True
                        End If
                        
                        If zaehler3>50 Then
                            abbruch2=True
                            abbruch=True
                            a=ompwaittime
                        End If
                        
                        If zaehler2>65 Then
                            abbruch2=True
                            abbruch=True
                            a=ompwaittime
                        End If
                        
                        If abbruch2=False Then
                            WScript.sleep 1500
                        End If
                    Loop
                    
                End If
                
                If abbruch=False Then	
                    WScript.Sleep 1000
                End If
                a = a + 1
                If a>=ompwaittime Then
                    abbruch=True
                End If
            Loop
            
            If Not fs.fileexists(programm&lockdatei) Then
                objWshShell.LogEvent 1,"archivierung: Omnipage-Prozess von Dienstkontrolle terminiert."
                WScript.Quit

            End If
            
            If a < ompwaittime Then
                flag1=2
                Err.clear
                WScript.Sleep 300

                
                WScript.Sleep 300
                If Err.number <> 0 Then
                    objWshShell.LogEvent 1, "archivierung(17ae): Kann nicht umkopieren."
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If
                If abbruch=True Then
                    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"KillOP.exe"&Chr(34),0,True)
                End If
                
                WScript.Sleep 300
                
                Err.clear
            Else

                If abbruch=True Then
                    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"KillOP.exe"&Chr(34),0,True)
                End If
                WScript.Sleep 5000
                objWshShell.LogEvent 2, "archivierung(17a): Omnipage-Prozess Restart. Durchlauf: "&durchlauf&" ("&OCRname&")."
                
            End If
            WScript.Sleep(300)
            If flag1=2 Then
                flag1=1
                If fs.FileExists(queue&"OCR.txt") Then
                    flag1=0
                    
                End If
            Else
                objWshShell.LogEvent 1, "archivierung(17b-15): Fehler bei Omnipage in Durchlauf "&durchlauf&" ("&tempname&")."
            End If
            durchlauf = durchlauf + 1
        Loop
        
    End If
    
    
    
    
    '***************************************************************************************
    '****************************************** Omnipage 16, 17, 18 ************************
    '***************************************************************************************
    If ((OMPVersion=16) Or (OMPVersion=17) Or (OMPVersion=18) Or (OMPVersion=19)) And (ocrserver="") Then 
        
        
        If omp19maxjobs <> False Then  
        	If Not fs.fileexists(temp&"opcounter.txt") Then
        		curCount=0
		    	counterFile.close
		    Else
			    Set counterFile = fs.OpenTextFile(temp&"opcounter.txt",1)
			    On Error Resume Next
			    curCount = CInt(counterFile.ReadLine)
			    If Err.Number<>0 Then
			    	curCount=0
			    End If
			    counterFile.Close        
        	End If
        	curCount=curCount + 1
        	
        
        	If curCount > omp19maxjobs Then
        		safe_omp_restart
        		curCount=1
        	End If
        	
        	
        	Set counterFile = fs.CreateTextFile(temp&"opcounter.txt",True)
    		
	    	counterFile.writeLine(curCount)
	    	counterFile.close
        End If
        
        flag1=3
        a=0
        durchlauf=1
       
        If omptryonce Then
            durchlauf = 2
        End If 
        err.clear
        OpProgramm = fs.getparentfoldername(omnipage)
        OCRpath = programm & "OCRTemp\"
        opagentrestarts=0
        opagent = False
        
        Do While (flag1 <> 0) And (durchlauf < 3)
            flag1=3
            
            If durchlauf > 1 Then
                WScript.sleep(1000)
                
            End If
            
            ' Hier Routine einfgen  Omnipage 16,17,18 #######################################################
            ' zuerst IN-Pfad leeren
            If fs.fileexists(ocrpath & "IN\OCR" & OCRHandle) Then
                fs.deletefile ocrpath & "IN\OCR" & OCRHandle,True
                If Err.number<>0 Then
                    objWSHShell.LogEvent 1, "Archivierung.vbs: OmniPage"&OMPVersion& " - " &ocrpath & "IN\OCR" & OCRHandle & vbCrLf & "konnte nicht weggerumt werden(1)"
                    Err.clear
                End If
            End If
            
            ' Luft OpAgent ?
            
            If logging=True Then
                If fs.FileExists(programm&"OCR.log") Then
                    Set mydebugfile = fs.getFile(programm&"OCR.log")
                    dlm = mydebugfile.DateCreated
                    Set mydebugfile = Nothing
                    If DateDiff("d", Now(),dlm) > 2 Then
                        fs.deletefile programm&"OCR.log", True
                        WScript.Sleep 200
                    End If
                End If
                If fs.FileExists(programm&"OCR.log") Then
                    Set mydebugfile = fs.OpenTextFile(programm&"OCR.log",8)
                Else
                    Set mydebugfile = fs.CreateTextFile(programm&"OCR.log",True)
                End If
            End If	
            
            
            
            Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
            strQuery = "Select * from Win32_Process where Name='OpAgent.exe'"
            Set colItems = objWMIService.ExecQuery(strQuery,,48)
            z=0
            For Each objItem In colItems
                z=z+1
            Next
            If z>0 Then
                OpAgent=True
            End If
            Set objItem = Nothing
            Set colItems = Nothing
            Set objWMIService = Nothing
            
            If OpAgent = False Then       'Restart
                If logging = True Then
                    mydebugfile.WriteLine Now() & vbTab & "OpAgent luft nicht - Restart " 		
                    objWSHShell.LogEvent 2, "OpAgent luft nicht - Restart " 	
                End If 
                
                If omp19maxjobs = False Then
                  OpAgent = OpAgent_Restart
                Else
                	safe_omp_restart
                	opAgent = True
                End If
                
            End If
            
            
            If opAgent = True Then     ' Running
                erfolg = True
                WScript.Sleep 200
                
                If erfolg = True Then		
                    clean = clean_ocroutpath
                    If clean = False Then
                        objWSHShell.LogEvent 1, "Archivierung.vbs: OmniPage"&OMPVersion&" - OCR\Out Pfad konnte nicht gerumt werden(1)"
                        erfolg = False
                    End If
                End If
                
                If ocrname="" Then
                    ocrname=tempname
                End If
                
                ' Datei in das berwachte Verzeichnis kopieren
                If logging = True Then
                    If OCRHandle = ".tif" Then
                        seiten = countpages(ocrname & OCRHandle)
                        mydebugfile.WriteLine "Datei:" & ocrname & OCRHandle
                        mydebugfile.WriteLine "Seiten:" & seiten
                    End If 
                End If 
                
                
                If erfolg = True Then
                    fs.CopyFile ocrname & OCRHandle, ocrpath & "IN\OCR" & OCRHandle, True
                    If Err.Number <> 0 Then
                        objWSHShell.LogEvent 1, "Archivierung OmniPage "&OMPVersion&": Konnte " & ocrname & OCRHandle & "nicht nach " & OCRpath & "IN\OCR" & OCRHandle & " kopieren" & vbCrLf & Err.Number & vbCrLf & Err.Description
                        erfolg = False
                    End If
                End If
                
                ' Jetzt auf Jobrunner warten
                
                If erfolg = True Then
                    jobrunner = False
                    erfolg = False
                    timeout = 0
                    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
                    
                    Do While Jobrunner = False And timeout < jobrunnertimeout
                        
                        strQuery = "Select * from Win32_Process where Name='JobRunner.exe'"
                        Set colItems = objWMIService.ExecQuery(strQuery,,48)
                        z=0
                        
                        For Each objItem In colItems
                            z=z+1
                        Next
                        If z>0 Then
                            Jobrunner=True	
                        Else 
                            timeout = timeout +1
                            WScript.Sleep 100
                        End If
                        
                        Set colItems = Nothing
                        Set objItem = Nothing
                    Loop
                    Set objWMIService = Nothing
                    
                    
                    If logging = True Then
                        mydebugfile.WriteLine Now() & vbTab & "Jobrunner gestartet=" & jobrunner  & vbTab & "- Timeout=" & timeout		
                    End If 
                    
                    If scriptdebug = True Then
                        objWSHShell.LogEvent 4, "Archivierung OmniPage"&OMPVersion&"  Jobrunner gestartet=" & jobrunner  & " - Timeout=" & timeout	
                    End If
                    
                    If jobrunner = True Then 
                        erfolg = True 
                    Else
                        erfolg = False	
                    End If
                    
                    
                End If
                
                
                ' Jetzt Warten bis der JobRunner beendet ist
                
                If erfolg = True Then
                    If logging = True Then
                        mydebugfile.WriteLine Now() & vbTab & "Jobrunner luft " & timeout
                    End If
                    If scriptdebug = True Then
                        objWSHShell.LogEvent 4, "Archivierung OmniPage"&OMPVersion&"  Jobrunner luft  - Timeout=" & timeout
                    End If
                    ioreads = 0 
                    timeout = 0
                    setprio = 0
                    io = 0
                    
                    Set objWMIService = Nothing
                    strQuery = "Select * from Win32_Process where Name='JobRunner.exe'"
                    Set objWMIService = GetObject("winmgmts:" _
                    & "{impersonationLevel=impersonate}!\\.\root\cimv2")
                    Set objWMIService2 = Nothing
                    Set objWMIService2 = GetObject("winmgmts:" _
                    & "{impersonationLevel=impersonate}!\\.\root\cimv2")

                    Do While Jobrunner = True And timeout < 500    ' Hier muss man testen wieviel zeit man gibt bzw eine aktivittsprfung 
                        Set colItems = objWMIService.ExecQuery(strQuery,,48)
                        z=0
                        For Each objItem In colItems
                            If setprio = 0 Then
                                resultCode = objItem.SetPriority(64)
                            End If
                            z=z+1
                        Next
                        setprio = 1
                        If z=0 Then
                            Jobrunner=False
                            If logging = True Then
                                mydebugfile.WriteLine Now() & vbTab & "Jobrunner luft nicht bzw beendet"
                            End If
                            If scriptdebug = True Then
                                objWSHShell.LogEvent 4, "Archivierung OmniPage"&OMPVersion&"  Jobrunner luft nicht bzw beendet"	
                            End If
                            
                        Else	'Jobrunner luft   auf aktivitt testen 
                            
                            If logging = True Then
                                mydebugfile.WriteLine Now() & vbTab & "Jobrunner aktiv  - Timeout=" & timeout
                            End If
                            
                            Set colProcesses = objWMIService2.ExecQuery _
                            ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'JobRunner'")
                            WScript.Sleep 50
                            
                            ioreads = 0
                            ioother = 0
                            io = io + 1
                            For Each strProcess In colProcesses
                                
                                ioreads=strProcess.IOReadOperationsPerSec
                                ioother=strProcess.IOOtherOperationsPerSec
                                
                                If logging = True Then
                                    mydebugfile.WriteLine vbTab & "0-" & strProcess.IOReadOperationsPerSec
                                    
                                    mydebugfile.WriteLine vbTab & "6-" &strProcess.IOOtherOperationsPerSec
                                End If	
                                
                            Next
                            Set colProcess=Nothing
                            
                            If ioreads < 10  Then
                                timeout = timeout +1
                            End If
                            
                            If io > 9 Then	
                                If ioreads => ioreadslast Then
                                    ioreadsdiff =  ioreads - ioreadslast
                                ElseIf ioreads < ioreadslast Then
                                    ioreadsdiff = ioreadslast - ioreads
                                End If
                                If ioreadsdiff = 0 Then
                                    timeout = timeout + 1
                                End If
                                io=0
                                ioreadslast = ioreads
                            End If
                            
                            If ioother => iootherlast Then
                                iodiff =  ioother - iootherlast
                            ElseIf ioother < iootherlast Then
                                iodiff = iootherlast - ioother
                            End If
                            
                            If iodiff = 0 Then
                                timeout = timeout + 1
                            End If
                            
                            iootherlast = ioother
                            
                            WScript.Sleep 200
                            
                        End If
                        
                    Loop
                    
                    Set colItems = Nothing
                    Set objWMIService = Nothing
                    Set objWMIService2 = Nothing
                    
                    If jobrunner = True And timeout => 500 Then
                        objWSHShell.LogEvent 2, "Archivierung.vbs: OmniPage"&OMPVersion&" - Jobrunner reagiert nicht - Timeout"
                        If logging = True Then
                            mydebugfile.writeline "Archivierung.vbs: OmniPage"&OMPVersion&" - Jobrunner reagiert nicht - Timeout"
                        End If
                        ' ufrumen
                        
                        Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
                        strQuery = "Select * from Win32_Process where Name='JobRunner.exe'"
                        Set colItems = objWMIService.ExecQuery(strQuery,,48)
                        
                        For Each objItem In colItems
                            
                            objItem.Terminate
                            objWSHShell.LogEvent 4, "Archivierung.vbs: OmniPage"&OMPVersion&" - Jobrunner wurde terminiert"
                            If logging = True Then
                                mydebugfile.writeline "Archivierung.vbs: OmniPage"&OMPVersion&" - Jobrunner wurde terminiert"
                            End If
                        Next
                        Set objItem = Nothing
                        Set colItems = Nothing
                        Set objWMIService = Nothing
                        
                        If fs.fileexists(ocrpath & "IN\OCR" & OCRHandle) Then
                            fs.deletefile ocrpath & "IN\OCR" & OCRHandle,True
                            If Err.number<>0 Then
                                objWSHShell.LogEvent 1, "Archivierung.vbs: OmniPage"&OMPVersion&" - " &ocrpath & "IN\OCR" & OCRHandle & vbCrLf & "konnte nicht weggerumt werden(2)"
                                Err.clear
                            End If
                        End If
                        
                        clean = clean_ocroutpath
                        If clean = False Then
                            objWSHShell.LogEvent 1, "Archivierung.vbs: OmniPage"&OMPVersion&" - OCR\Out Pfad konnte nicht gerumt werden"
                        End If
                        If durchlauf = 1 Then    'wenn es zum kompletten Timeout kommt, wird der Opagent direkt restartet (insgesamt 3mal)
                            durchlauf = 2
                        End If
                    End If
                    
                    If jobrunner = False Then 
                        erfolg = True 'wir sind durch
                    Else
                        erfolg = False
                    End If
                    
                Else
                    
  
                    
                End If
                
                
                ' nur fr ocr_xml mit angepasstem OMP-Job
                If fs.FileExists(OcrPath & "Out\ocr.xml") And Right(ocrname,6) <> "swtemp" Then
                    fs.MoveFile OcrPath& "Out\ocr.xml", tempname&".ocr_xml"
                End If
                
                
                ' es wird generell geschaut ob eine txt vorhanden ist
                
                
                erfolg = False
                timeout = 0
                Err.clear
                If ompmultipages=True Then
                    WScript.Sleep 200
                    Set OCRDir = fs.GetFolder(OcrPath& "\OUT")
                    itxt = 0
                    pos = 0
                    pages=""
                    For Each txtfile In OCRDir.Files
                        If LCase(fs.GetExtensionName(txtfile)) = "txt" Then
                            If fs.FileExists(txtfile) Then
                                'strcmd = strcmd & txtfile.Name & " "
                                itxt = itxt +1
                                ocrtxtxfiles(itxt) = txtfile.Name
                                
                            End If
                        End If
                    Next 
                    Set OCRDir = Nothing
                    If itxt > 0 Then
                        ReDim txtlaengen(itxt)
                        
                        Set multiocrfile = fs.CreateTextFile(OcrPath& "OUT\multiocr.txt")
                        
                        For ktxt = 1 To itxt
                            Set ocrtxtpart = fs.OpenTextFile(OcrPath& "OUT\" & 	ocrtxtxfiles(ktxt))
                            Do Until ocrtxtpart.AtEndOfStream
                                ocrstr = ocrtxtpart.ReadLine
                                If normftx=True Then
                                    ocrstr = normstring(ocrstr)
                                End If
                                
                                multiocrfile.WriteLine ocrstr
                                txtlaengen(ktxt) = txtlaengen(ktxt) + Len(ocrstr) + 2
                            Loop
                            'multiocrfile.WriteLine "Seite " & ktxt
                            ocrtxtpart.Close
                        Next 
                        
                        pos = 0 
                        If itxt => 2 Then
                            pages = txtlaengen(1) 
                            pos = txtlaengen(1) 
                            If itxt => 3 Then
                                For ktxt = 2 To itxt -1
                                    pos = pos + txtlaengen(ktxt)
                                    pages = pages & "," & pos 
                                    'multiocrfile.WriteLine txtlaengen(ktxt)
                                Next
                            End If
                        End If	
                        multiocrfile.Close		
                        
                        WScript.Sleep 200
                        If fs.FileExists(OcrPath & "Out\ocr.txt") Then
                            fs.DeleteFile OcrPath & "Out\ocr.txt", True
                            WScript.Sleep 100
                        End If
						err.clear
                        fs.MoveFile OcrPath& "OUT\multiocr.txt", OcrPath & "Out\ocr.txt"
                        If Err.Number Then
                            objWSHShell.LogEvent 1, "Archivierung.vbs OmniPage"&OMPVersion&": Konnte multiocr.txt nicht nach ocr.txt umbennen"
                            erfolg = False
                        Else
                            erfolg = True	
                        End If
                    End If
                    
                Else
                    Do Until timeout > 50
                        If fs.FileExists(ocrpath & "OUT\OCR.txt") = True Then
                            If scriptdebug = True Then
                                objWSHShell.LogEvent 1, "Archivierung OmniPage"&OMPVersion&"  OCR.txt gefunden - Timeout=" & timeout
                            End If
                            erfolg = True
                            Exit Do
                        Else
                            timeout  =timeout +1
                            WScript.Sleep 100
                        End If
                    Loop
                End If
                
                ' hier auf 0 kbyte groe Textdatei prfen
                
                If erfolg = True Then
                    
                    Set ocrfile = fs.getfile(ocrpath & "OUT\OCR.txt")
                    If ocrfile.size = 0 And Right(ocrname,6) <> "swtemp" Then
                        objWSHShell.LogEvent 1, "Archivierung OmniPage"&OMPVersion&": Fehler!" &vbCrLf & "Es wurde eine 0kb groe Textdatei von der OmniPage zurckgegeben" & vbCrLf & ocrpath & "OUT\OCR.txt" & vbCrLf & tempname
                        erfolg = False
                        fs.DeleteFile ocrpath & "OUT\OCR.txt", True	
                        If Err.Number<> 0 Then
                            objWSHShell.LogEvent 1, "Archivierung OmniPage "&OMPVersion&": Fehler beim lschen der 0kb OCR.txt gelscht " & vbCrLf & Err.Number & vbCrLf & Err.Description
                        End If
                        clean = clean_ocroutpath
                        If clean = False Then
                            objWSHShell.LogEvent 1, "Archivierung.vbs: OmniPage"&OMPVersion&" - OCR\Out Pfad konnte nicht gerumt werden(3)"
                        End If
                        
                    End If
                    Set ocrfile = Nothing
                End If
                
                
                
                
                If erfolg = False Then    			'checken was los ist
                    
                    If fs.FileExists(ocrpath & "IN\OCR" & OCRHandle) = True Then
                        objWSHShell.LogEvent 1, "Archivierung OmniPage "&OMPVersion&": Fehler!" & vbCrLf & "Die OCR Datei wurde nicht verarbeitet" & vbCrLf & ocrpath & "IN\OCR" & OCRHandle
                        fs.DeleteFile ocrpath & "IN\OCR" & OCRHandle, True	
                        If Err.Number<> 0 Then
                            objWSHShell.LogEvent 1, "Archivierung OmniPage"&OMPVersion&": Fehler !" & vbCrLf & "Die nichtverarbeitete OCR-Datei konnte nicht gelscht werden " & vbCrLf & Err.Number & vbCrLf & Err.Description
                        End If
                    Else
                        objWSHShell.LogEvent 1, "Archivierung OmniPage"&OMPVersion&": Fehler !" & vbCrLf & "Die OCR Datei wurde nicht verarbeitet und vom JobRunner gelscht" & vbCrLf & "Die Datei war vermutlich fehlerhaft" & vbCrLf & ocrpath & "IN\OCR" & OCRHandle	
                    End If
                    
                End If
                
                If erfolg = True Then
                    If fs.fileexists(ocrname& ".txt") Then
                        fs.Deletefile ocrname& ".txt", True
                        If Err.number Then
                            objWSHShell.LogEvent 1, "Archivierung OmniPage"&OMPVersion&": Fehler !" & vbCrLf & "Konnte alte Textdatei in der Queue nicht lschen" & vbCrLf & ocrname& ".txt" & vbCrLf & Err.Number & vbCrLf & Err.Description
                            erfolg = False
                        End If
                    End If
                End If	
                If erfolg = True Then
                    If fs.fileexists(queue & "OCR.txt") Then
                        fs.Deletefile queue & "OCR.txt", True
                        If Err.number Then
                            objWSHShell.LogEvent 1, "Archivierung OmniPage"&OMPVersion&": Fehler !" & vbCrLf & "Konnte alte Textdatei in der Queue nicht lschen" & vbCrLf &  queue & "OCR.txt" & vbCrLf & Err.Number & vbCrLf & Err.Description
                            erfolg = False
                        End If
                    End If
                End If	
                
                
                If erfolg = True Then
                    fs.MoveFile ocrpath & "OUT\OCR.txt", queue & "OCR.txt"
                    If Err.Number <> 0 Then
                        objWSHShell.LogEvent 1, "Archivierung OmniPage"&OMPVersion&": Fehler !" & vbCrLf & "Konnte die Textdatei nicht in die Queue stellen" & vbCrLf & Err.Number & vbCrLf & Err.Description
                        erfolg = False
                    Else
                        flag1=0    'Jetzt ist alles entgltig erledigt, die Schleife kann beendet werden
                        erfolg = True
                    End If
                End If
                
                
            Else
                objWSHShell.LogEvent 1, "Archivierung OmniPage "&OMPVersion&": Schwerer Fehler!" & vbCrLf & "Opagent lsst sich nicht starten"
                erfolg = False
            End If
            
            clean = clean_ocroutpath
            If clean = False Then
                objWSHShell.LogEvent 1, "Archivierung.vbs: OmniPage "&OMPVersion&" - OCR\Out Pfad konnte nicht gerumt werden(2)"
            End If
            
            
            If logging = True Then
                mydebugfile.writeline ""
                mydebugfile.Close
            End If
            
            
            
            
            '  ########################################################
            
            If erfolg = False Then
                objWshShell.LogEvent 1, "archivierung(17b-16): Fehler bei Omnipage"&OMPVersion&" in Durchlauf "&durchlauf&" ("&tempname&")."
            End If
            durchlauf = durchlauf + 1
            
            If durchlauf = 3 And flag1<>0 And opagentrestarts < 1 Then
                If logging=True Then
                    If fs.FileExists(programm&"OCR.log") Then
                        Set mydebugfile = fs.OpenTextFile(programm&"OCR.log",8)
                    Else
                        Set mydebugfile = fs.CreateTextFile(programm&"OCR.log",True)
                    End If
                    mydebugfile.writeline "OmniPage"&OMPVersion&" nach zwei Durchlufen nicht erfolgreich - Restart "
                    mydebugfile.writeline
                    mydebugfile.close
                End If	
                If omp19maxjobs = False Then
                  opagent = OpAgent_Restart
                  opagentrestarts = opagentrestarts +1
                Else
                	safe_omp_restart
                	opagentrestarts = opagentrestarts +1
                End If
                
                If opagent = True Then
                    objWshShell.LogEvent 2, "archivierung(17b-17):Nach OpAgent_Restart einen weiteren Durchgang starten"
                    durchlauf = durchlauf + 1   ' nach opagent_restart einen weiteren durchlauf starten
                    If omptryonce Then
                        durchlauf = 3
                    End If 
                End If
            End If
            
        Loop
        
    End If '******************************
    
    If omp19maxjobs = False Then
      opagent = OpAgent_Restart
    End If
    
    
    Err.clear
    
    If fs.fileexists(tempname&".tmp.txt") Then
        fs.Deletefile tempname&".tmp.txt", True
        If Err.number Then
            objWSHShell.LogEvent 1, "Archivierung.vbs(17c-14): Konnte alte Textdatei in der Queue nicht lschen" & vbCrLf &  tempname&".tmp.txt" & vbCrLf & Err.Number & vbCrLf & Err.Description
            erfolg = False
        End If
    End If
    
    If fs.fileexists(queue&"OCR.txt") Then
        fs.CopyFile queue&"OCR.txt", tempname&".tmp.txt", True
        If Err.number <> 0 Then
            objWshShell.LogEvent 1, "Archivierung.vbs(17c-15): Kann nicht umkopieren."
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
    ElseIf fs.fileexists(ocrname&".txt") Then
        fs.CopyFile ocrname&".txt", ocrname&".tmp.txt", True
        If Err.number <> 0 Then
            objWshShell.LogEvent 1, "Archivierung.vbs(17c-16): Kann nicht umkopieren."
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
    Else
        
    End If
    
    
    
    WScript.Sleep 200
    If fs.FileExists(tempname&".tmp.txt") Then
        If fs.FileExists(queue&"OCR.txt") Then
            fs.DeleteFile queue&"OCR.txt", True
        ElseIf fs.FileExists(tempname&".txt") Then
            fs.DeleteFile tempname&".txt", True
        End If
        
        If Err.number <> 0 Then
            objWshShell.LogEvent 1, "Archivierung.vbs(17d-15): Schwerer Fehler: Kann OCR-Datei nicht lschen."
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
    Else
        ' es hat weder ocr.txt noch tempname.txt gegeben omnipage terminiert ?
        objWshShell.LogEvent 1, "Archivierung.vbs(17fff): Keine " &tempname&".tmp.txt gefunden. OmniPage wahrscheinlich terminiert" & vbCrLf & "Dokument wird ohne Volltext verarbeitet"
        typ="TXT"
        notifyuser=True
        If alertonemptydoctxt=True And ismaskocr=False Then
            emptydoctxt=True
        End If
        
       
    End If
    
    Set ocrfile = fs.getfile(tempname&".tmp.txt")
    
    If ocrfile.size = 0 And ismaskocr = False Then
        objWSHShell.LogEvent 1, "Archivierung OmniPage: Fehler !" &vbCrLf & "Es wurde eine 0kb groe Textdatei von der OmniPage zurckgegeben" & vbCrLf & tempname&".tmp.txt" 
        notifyuser=True
        If alertonemptydoctxt=True Then
            emptydoctxt=True
        End If
        Typ="TXT"
    End If 			
    
    
    '***************************************************************************************
    '***************************************************************************************
    '***************************************************************************************
    
    
    
    
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    '~~~~~~~~~~~~~~~~~~~~  umkopieren und normieren  ~~~~~~~~~~~~~~~~~~
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    Err.clear
    WScript.sleep 500
    
    
    If typ<>"TXT" Then	
        
        
        
        WScript.Sleep 200
        
        Set zieltxtfile = fs.CreateTextFile(ocrname&".txt",True)
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            errortxt="archivierung(17f): kann nach Omnipage nicht umkopieren. "&Err.number	
            objWshShell.LogEvent 1, errortxt
            GetGarbage(tempname)
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
        
        If typ<>"TXT" Then
            Set quelltxtfile = fs.OpenTextFile(tempname&".tmp.txt",1)
        End If
        
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            errortxt="archivierung(17g): kann von Omnipage erstellte txt-datei nicht ffnen ("&tempname&".tmp.txt). "&Err.number
            objWSHShell.LogEvent 1, errortxt
            GetGarbage(tempname)
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
        
        If typ<>"TXT" Then
            Do While quelltxtfile.AtEndOfStream <> True
                If typ<>"TXT" Then
                    if normftx=True Then
                        kette=normstring(quelltxtfile.ReadLine)
                    Else
                        kette=quelltxtfile.ReadLine
                    End If
                Else
                    kette=""
                End If
                
                zieltxtfile.WriteLine(kette)
                
            Loop
        End If
        
        zieltxtfile.close
        Set zieltxtfile = Nothing
        If typ<>"TXT" Then
            quelltxtfile.close
            Set quelltxtfile = Nothing
        End If
        
        
        WScript.Sleep 100
        If typ<>"TXT" Then
            fs.deletefile tempname&".tmp.txt", True
        End If
        
    End If
    
    'Else		'mehr als 2 Durchlufe
    
    If durchlauf > 2 Then
        errortxt="Archivierung.vbs (17e): Mehr als 2 Omnipage-Durchlufe gebraucht."
        
        'Meldung nur im Eventlog verewigen wenn omptryonce false ist
        'sonst wird die Meldung fr JEDES Dokument eingetragen
        If Not omptryonce Then
            objWSHShell.LogEvent 2, errortxt
        End If
        WScript.Sleep 100
        

        
        If Not(fs.Fileexists(ocrname&".txt")) Then
            objWshShell.LogEvent 1,"Archivierung.vbs (17f):Es wurde keine Volltextdatei erzeugt !" & vbCrLf & ocrname&".txt"
            typ="TXT"
            notifyuser=True
            notiz="Das Dokument konnte nicht indiziert werden"
        End If
    End If
    
    
    
    
    If scriptdebug=True Then
        objWshShell.LogEvent 4, "bitfarm-Archiv Debug-Archivierung "&OCRname&": Verlasse runomnipage-funktion" 
    End If
    
    
End Function


Function clean_ocroutpath
    On Error Resume Next
    Err.Clear
    clean_ocroutpath = True
    Set OCRDir = fs.GetFolder(OcrPath& "\OUT")
    
    
    For Each txtfile In OCRDir.Files
        If LCase(fs.GetExtensionName(txtfile)) = "txt" Or LCase(fs.GetExtensionName(txtfile)) = "xml" Then
            If fs.FileExists(txtfile) Then
                fs.deletefile txtfile ,True
                If Err.Number <> 0 Then
                    objWSHShell.LogEvent 1, "Archivierung OmniPage "&OMPVersion&": Konnte " & OCRpath & "\OUT\" & txtfile.Name & " nicht lschen" & vbCrLf & Err.Number & vbCrLf & Err.Description
                    clean_ocroutpath = False
                End If
            End If
        End If
    Next 
    Set OCRDir = Nothing
    
End Function

Function clean_ocrtemppath
    On Error Resume Next
    Err.Clear
    
    clean_ocrtemppath = True
    temppath=""
    
    
    
    
    temppath = objWSHShell.ExpandEnvironmentStrings("%temp%")    
    If Err.number<>0 Then
        Err.Clear  
        
    End If 
    If temppath<>"" Then
        If OMPVersion=16 Then
            OMPTemp=temppath&"\ScanSoft\OmniPage 16\"
        End If
        If OMPVersion=17 Then
            OMPTemp=temppath&"\ScanSoft\OmniPage 17\"
        End If
        If OMPVersion=18 Then
            OMPTemp=temppath&"\ScanSoft\OmniPage 18\"
        End If        
        
        If OMPVersion=19 Then
            OMPTemp=temppath&"\ScanSoft\OmniPage 19\"
        End If  
        
        If fs.folderexists(OMPTemp) Then
            
            Set omptempfolder = fs.getfolder(OMPTemp)
            
            For Each ofolder In omptempfolder.SubFolders
                
                If fs.folderexists(ofolder) And ofolder.name <> "Temp" Then
                    delfolder(ofolder)
                    fs.DeleteFolder ofolder, True
                    If Err.Number <> 0 Then
                        objWSHShell.LogEvent 1, "Archivierung OmniPage "&OMPVersion&": Konnte " & ofolder.name  & " nicht lschen" & vbCrLf & Err.Number & vbCrLf & Err.Description
                        clean_ocrtemppath = False
                    End If
                    
                End If
                
                
            Next
            
            Err.Clear
            
            For Each tempfile In omptempfolder.Files
                fs.deletefile tempfile, True
                If Err.Number <> 0 Then
                    objWSHShell.LogEvent 1, "Archivierung OmniPage "&OMPVersion&": Konnte " & tempfile.name  & " nicht lschen" & vbCrLf & Err.Number & vbCrLf & Err.Description
                    clean_ocrtemppath = False
                End If
            Next
            
            
            
            
            
            
            
            Set ofolder = Nothing
            Set omptempfolder = Nothing
            
        End If
        
    Else
        clean_ocrtemppath=False
        
    End If
    
    
    
End Function





'************************************************************************
'************************************************************************



Function runbarcode(tempname)
    On Error Resume Next
    
    
    runbarcode=True
    
    tempname1 = tempname
    
    If (fs.fileexists(tempname&".tif")) And (Not fs.fileexists(tempname&".bar")) Then
        If (barcodemode="") Or (barcodemode="0") Then
            Err.clear
            If barcodemask="" Then
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"rdtifbar.exe"&Chr(34)&" "&Chr(34)&tempname&".tif"&Chr(34),0,True)
            Else
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"rdtifbar.exe"&Chr(34)&" "&Chr(34)&tempname&".tif"&Chr(34)&" -p:"&barcodemask,0,True)
            End If
            
            
            
            If Err.number<>0 Then
                errortxt="archivierung(18eg): Fehler beim starten von rdtifbar ("&tempname&".tif). Errornummer: "&Err.number
                objWshShell.LogEvent 1, errortxt
                runbarcode=False
            End If
        ElseIf barcodemode="1" Then
            If fs.fileexists(tempname&".ttd") Then
                fs.deletefile tempname&".ttd", True
            End If
            If fs.fileexists(programm&"barcodefilter1.txt") Then
                
                
                lngReturnCode = runfilter(tempname&".tif",programm&"barcodefilter1.txt",tempname&"-bc.tif")
                
                tempname1 = tempname & "-bc"
                
                If lngReturnCode<>0 Then
                    Err.clear
                    errortxt="bitfarm-Archiv: Archivierung(jo): Fehler beim Filtern der Tifdatei:"&lngReturnCode	
                    objWshShell.LogEvent 1, errortxt
                    getgarbage(tempname)
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If
                WScript.Sleep 300
                If Not fs.fileexists(tempname1&".tif") Then
                    errortxt="bitfarm-Archiv: Archivierung(jx): Fehler beim Filtern der Tifdatei"
                    objWshShell.LogEvent 1, errortxt
                    getgarbage(tempname)
                    Unlock(programm&lockdatei)
                    WScript.Quit
                    Err.clear
                End If
            Else
                runbarcode=False
            End If	
            If runbarcode=True Then
                If barcodemask="" Then
                    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"rdtifbar.exe"&Chr(34)&" "&Chr(34)&tempname1&".tif"&Chr(34),0,True)
                Else
                    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"rdtifbar.exe"&Chr(34)&" "&Chr(34)&tempname1&".tif"&Chr(34)&" -p:"&barcodemask,0,True)
                End If
                If Err.number<>0 Then
                    errortxt="archivierung(18eg): Fehler beim starten von rdtifbar ("&tempname1&".tif). Errornummer: "&Err.number
                    objWshShell.LogEvent 1, errortxt
                    runbarcode=False
                End If
            End If
            
            
            
            
        Else
            errortxt="archivierung(18ek): Fehler: barcodemode= in scripts.ini: Wert wird nicht untersttzt."
            objWshShell.LogEvent 1, errortxt
            runbarcode=False
        End If
        
        If runbarcode=True Then
            WScript.sleep 1000
            waitbarcode
            WScript.sleep 200
        End If
    Else
        runbarcode = False
    End If
    
    
    
    gefunden = False
    
    
    '################################  es braucht manchmal etwas Zeit, bis die .bar Datei erscheint, deshalb drehen wir ein paar Runden...
    If runbarcode=True Then
        gefunden=False
        i=0
        Do While gefunden=False
            If fs.fileexists(tempname1&".bar") Then
                gefunden=True
            End If
            If fs.fileexists(tempname1&".tibar") Then
                gefunden=True
            End If
            
            If gefunden=False Then
                i=i+1
                WScript.sleep 200
            End If
            If i>15 Then
                gefunden=True
            End If
        Loop
    End If
    
    If (fs.fileexists(tempname1&".tibar")=True) And (fs.fileexists(tempname1&".bar")=False) Then
        fs.copyfile tempname1&".tibar", tempname1&".bar", True
        fs.deletefile tempname&".tibar", True
    End If
    
    '#################################################################################################
    
    
    
    If (runbarcode=True) And (fs.fileexists(tempname1&".bar")) Then
        
        Set mybarcodefile=fs.opentextfile(tempname1&".bar",1)
        kette=""
        i=0
        Do While mybarcodefile.atendofstream=False And i < 30
            kette=mybarcodefile.readline
           	If (kette<>"") And (kette<>vbCrLf) And (kette<>"	") And (kette<>" ") Then
                barcode(i)=Trim(kette)
                gefunden=False
                p=0
                Do While gefunden=False
                    If zusatzfeldname(p)="" Then
                        gefunden=True
                        zusatzfeldname(p)="barcode"&i
                        zusatzfeld(p)=barcode(i)
                    End If
                    If gefunden=False Then
                        p=p+1
                    End If
                    If p=limit Then
                        gefunden=True
                    End If
                Loop
                
                i=i+1
            End If
        Loop
        mybarcodefile.close
        Set mybarcodefile=Nothing
    End If
    
    
    
    
    
    If (gefunden = False) And (runbarcode = True) And (barcodesecondthreshold<>"") Then
        bcsecondrun = " -t:" & barcodesecondthreshold
        If (fs.fileexists(tempname&".tif")) And (Not fs.fileexists(tempname&".bar")) Then
            If (barcodemode="") Or (barcodemode="0") Then
                Err.clear
                
                If barcodemask="" Then
                    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"rdtifbar.exe"&Chr(34)&" "&Chr(34)&tempname&".tif"&Chr(34)& bcsecondrun,0,True)
                Else
                    
                    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"rdtifbar.exe"&Chr(34)&" "&Chr(34)&tempname&".tif"&Chr(34)&" -p:"&barcodemask & bcsecondrun,0,True)
                End If
                
                If Err.number<>0 Then
                    errortxt="archivierung(18eg): Fehler beim starten von rdtifbar ("&tempname&".tif). Errornummer: "&Err.number
                    objWshShell.LogEvent 1, errortxt
                    runbarcode=False
                End If
            ElseIf barcodemode="1" Then
                If fs.fileexists(tempname&".ttd") Then
                    fs.deletefile tempname&".ttd", True
                End If
                If fs.fileexists(programm&"barcodefilter1.txt") Then
                    
                    lngReturnCode = runfilter(tempname&".tif",programm&"barcodefilter1.txt",tempname&"-bc.tif")
                    
                    If lngReturnCode<>0 Then
                        Err.clear
                        errortxt="bitfarm-Archiv: Archivierung(jo): Fehler beim Filtern der Tifdatei:"&lngReturnCode	
                        objWshShell.LogEvent 1, errortxt
                        getgarbage(tempname)
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If
                    WScript.Sleep 300
                    If Not fs.fileexists(tempname&"-bc.tif") Then
                        errortxt="bitfarm-Archiv: Archivierung(jx): Fehler beim Filtern der Tifdatei"
                        objWshShell.LogEvent 1, errortxt
                        getgarbage(tempname)
                        Unlock(programm&lockdatei)
                        WScript.Quit
                        Err.clear
                    End If
                Else
                    runbarcode=False
                End If	
                If runbarcode=True Then
                    
                    If barcodemask="" Then
                        lngReturnCode = objWSHShell.Run(programm&"rdtifbar.exe "&tempname&"-bc.tif"& bcsecondrun,0,True)
                    Else
                        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"rdtifbar.exe"&Chr(34)&" "&Chr(34)&tempname&"-bc.tif"&Chr(34)&" -p:"&barcodemask & bcsecondrun,0,True)
                    End If
                    
                    
                    If Err.number<>0 Then
                        errortxt="archivierung(18eg): Fehler beim starten von rdtifbar ("&tempname&"-bc.tif). Errornummer: "&Err.number
                        objWshShell.LogEvent 1, errortxt
                        runbarcode=False
                    End If
                End If
                
            Else
                errortxt="archivierung(18ek): Fehler: barcodemode= in scripts.ini: Wert wird nicht untersttzt."
                objWshShell.LogEvent 1, errortxt
                runbarcode=False
            End If
            
            If runbarcode=True Then
                WScript.sleep 1000
                waitbarcode
                WScript.sleep 200
            End If
        Else
            runbarcode=False
        End If
        
        
        
        '################################  es braucht manchmal etwas Zeit, bis die .bar Datei erscheint, deshalb drehen wir ein paar Runden...
        If runbarcode=True Then
            gefunden=False
            i=0
            Do While gefunden=False
                If fs.fileexists(tempname&".bar") Then
                    gefunden=True
                End If
                If fs.fileexists(tempname&".tibar") Then
                    gefunden=True
                End If
                
                If gefunden=False Then
                    i=i+1
                    WScript.sleep 200
                End If
                If i>15 Then
                    Exit Do
                End If
            Loop
        End If
        
        If (fs.fileexists(tempname&".tibar")=True) And (fs.fileexists(tempname&".bar")=False) Then
            fs.copyfile tempname&".tibar", tempname&".bar", True
            fs.deletefile tempname&".tibar", True
        End If
        
        '#################################################################################################
        
        
        If (runbarcode=True) And (fs.fileexists(tempname&".bar")) Then
            
            Set mybarcodefile=fs.opentextfile(tempname&".bar",1)
            kette=""
            i=0
            Do While mybarcodefile.atendofstream=False
                kette=mybarcodefile.readline
                If (kette<>"") And (kette<>vbCrLf) And (kette<>"	") And (kette<>" ") And (Len(Trim(kette))>3) Then
                    barcode(i)=Trim(kette)
                    gefunden=False
                    p=0
                    Do While gefunden=False
                        If zusatzfeldname(p)="" Then
                            gefunden=True
                            zusatzfeldname(p)="barcode"&i
                            zusatzfeld(p)=barcode(i)
                        End If
                        If gefunden=False Then
                            p=p+1
                        End If
                        If p=limit Then
                            gefunden=True
                        End If
                    Loop
                    
                    i=i+1
                End If
            Loop
            mybarcodefile.close
            Set mybarcodefile=Nothing
        Else
            runbarcode=False
        End If
        
        
        
    End If
    
    
    If (fs.fileexists(tempname&"-bc.tif")) And (cleanup=True) Then
        fs.deletefile tempname&"-bc.tif", True
    End If
    
    
    If fs.fileexists(tempname&"-bc.bar") Then
        fs.copyfile tempname&"-bc.bar", tempname&".bar", True
        fs.deletefile tempname&"-bc.bar", True
        Err.clear
    End If
    
    
    If fs.fileexists(tempname&"-bc.tibar") Then
        fs.copyfile tempname&"-bc.tibar", tempname&".bar", True
        fs.deletefile tempname&"-bc.tibar", True
        Err.clear
    End If
    
    If fs.fileexists(tempname&".tibar") Then
        fs.copyfile tempname&".tibar", tempname&".bar", True
        fs.deletefile tempname&".tibar", True
        Err.clear
    End If
    
    
    
End Function




Function runeymbcrdcmd(tempname)
    On Error Resume Next
    
    
    mydocnumber = tempname& ".tif"
    myfilename = mydocnumber 
    
    
    strmask = ""
    bcsecondrun = ""
    gefunden = False
    turn=0
    For i = 0 To 29
        barcode(i) = ""
    Next
    If barcodemask <> "" Or barcodemask <> "" Then
        strmask = "-bctypes " & barcodemask & " "
    End If
    
    
    If barcodemode = 1 Then
        
        If fs.fileexists(programm&"barcodefilter1.txt") Then
            myfilename = Left(mydocnumber,Len(mydocnumber) - 4) & "-bc.tif"		
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"filterv3.bat"&Chr(34)&" "&strPfadTemp&mydocnumber&" "&Chr(34)&programm&"barcodefilter1.txt"&Chr(34)&" "&strPfadTemp&myfilename ,0,True)
            
            If lngReturnCode<>0 Then
                Err.clear
                errortxt="bitfarm-Archiv: Fehler beim Filtern der Tifdatei:"&lngReturnCode	
                objWshShell.LogEvent 1, errortxt
               
                
                myfilename = mydocnumber
                
            End If
            WScript.Sleep 300
            If Not fs.fileexists(strPfadTemp&myfilename) Then
                errortxt="bitfarm-Archiv: Fehler beim Filtern der Tifdatei"
                objWshShell.LogEvent 1, errortxt
                
                myfilename = mydocnumber
               
                Err.clear
            End If
            
           
        End If
        
    End If
    
    
    
    Do Until turn = 2 Or gefunden = True
        Set oExec    = objWSHShell.Exec(Chr(34)&eymbcrdcmdpath & Chr(34)&" "& bcsecondrun & strmask  & temppath & myfilename )	
        
        Do While Not oExec.StdOut.AtEndOfStream
            strinput = strinput & oExec.StdOut.Read(1)	
        Loop
        
        
        
        If InStr(1, strinput,"<NbCodes>") <> 0 Then
            nbcodes = strconvert(Mid(strinput,InStr(1, strinput,"<NbCodes>")+9, InStr(1, strinput,"</NbCodes>")- InStr(1, strinput,"<NbCodes>")-9))
        End If
        
        
        If nbcodes > 29 Then 
            nbcodes = 29
        End If
        
        For i = 0 To nbcodes
            If InStr(1, strinput,"<Data>") <> 0 Then
                barcode(i) = Mid(strinput,InStr(1, strinput,"<Data>")+6, InStr(1, strinput,"</Data>")- InStr(1, strinput,"<Data>")-6)
                strinput = Right(strinput,Len(strinput) - InStr(1, strinput,"</Data>") -6)
               
                
                p=0
                Do Until gefunden=True Or p = limit
                    If zusatzfeldname(p)="" Then
                        gefunden=True
                        zusatzfeldname(p)="barcode"&i
                        zusatzfeld(p)=barcode(i)
                    End If
                    If gefunden=False Then
                        p=p+1
                    End If
                    
                Loop
                
                
            End If	
        Next 
        
        
        Set oExec = Nothing
        
        If gefunden = False Then
            If barcodesecondthreshold <> "" Then
                bcsecondrun = "-minconf 0," & barcodesecondthreshold & " "
                turn=turn+1
            Else
                turn = 2 
            End If
        End If
        
        
        strinput = ""
    Loop
    
    
    
    If Right(myfilename,7) = "-bc.tif" Then
        fs.deletefile myfilename,True
    End If
    
    
    
    runeymbcrdcmd = gefunden
    
    
    
    
    
End Function



Function runbcplus(ByVal bctempname)      ' Paramter zur bergabe an bcplus mssen noch angepasst werden
    On Error Resume Next
    
    Set bcpexec = fs.getfile(bcpluspath)
    bcpdir = bcpexec.Parentfolder
    
    inidir = fs.getfolder(bcpdir&"\inis") 
    If inidir = Empty Then
    	fs.createfolder(bcpdir&"\inis")
    	fs.copyfile bcpdir&"\bcplus.ini", bcpdir&"\inis\bcplus.ini",True 
    End If
    
    inifiles = getfilenames(bcpdir&"\inis\","bcplus\d*.ini$")

    For Each inifile In inifiles
    	fs.copyfile inifile, bcpdir&"\bcplus.ini",True 

	    If Not fs.fileexists(bcpluspath) Then
	        errortxt="archivierung(18eg): BcPlus nicht gefunden ("&bcpluspath&")."
	        objWshShell.LogEvent 1, errortxt
	        runbcplus=False
	    Else
	        runbcplus=True
	        If (fs.fileexists(bctempname&".tif")) And (Not fs.fileexists(bctempname&".bar")) Then
	            
	            If barcodefilter <> "" Then					
	                If fs.fileexists(programm & "filter\" & barcodefilter) Then
	                    rc = runfilter(bctempname&".tif",programm & "filter\" & barcodefilter,bctempname&"-bc.tif")
	                    If rc = 0 Then
	                        bctempname = bctempname & "-bc"
	                    End If 
	                End If 
	            End If 

	            Err.Clear
	            strinput=""

	            Set oExec = objWSHShell.Exec(Chr(34)&bcpluspath &Chr(34)& " "&Chr(34)&bctempname&".tif"&Chr(34))
	            
	            Do While Not oExec.StdOut.AtEndOfStream
	                strinput = strinput & oExec.StdOut.ReadAll
	            Loop
	            
	            durch = False
	            schleife = 0
	            Do While schleife < 100
	                If oExec.Status = 1 Then 
	                    durch = True
	                    Exit Do
	                End If
	                
	                WScript.Sleep 100  
	                schleife = schleife +1
	            Loop
	            rc = oExec.ExitCode
	            If durch = False Then
	                errortxt="archivierung(18eg): Fehler beim starten von bcplus ("&bctempname&".tif). rc: "&rc
	                objWshShell.LogEvent 1, errortxt
	                runbcplus=False
	            End If
	            
	            If runbcplus=True Then
	                WScript.sleep 200
	            End If
	        End If
	        
	        
	        '################################  es braucht manchmal etwas Zeit, bis die .bar Datei erscheint, deshalb drehen wir ein paar Runden...
	        If runbcplus=True Then
	            gefunden=False
	            i=0
	            Do While gefunden=False
	                If fs.fileexists(bctempname&".bar") Then
	                    gefunden=True
	                End If
	                
	                If gefunden=False Then
	                    i=i+1
	                    WScript.sleep 200
	                End If
	                If i>15 Then
	                    Exit Do
	                End If
	            Loop
	        End If
	        
	        
	        If (runbcplus=True) And (fs.fileexists(bctempname&".bar")) Then
	            
	            Set mybarcodefile=fs.opentextfile(bctempname&".bar",1)
	            kette=""
	            i=0
	            Do While mybarcodefile.atendofstream=False
	                kette=mybarcodefile.readline
	                barcode(i)=Trim(kette)
	                If (kette<>"") And (kette<>vbCrLf) And (kette<>"	") And (kette<>" ") And IsInArray(normstring(Trim(kette)), Zusatzfeld) = False Then    
	                    
	                    gefunden=False
	                    p=0
	                    Do While gefunden=False
	                        If zusatzfeldname(p)="" Then
	                            gefunden=True
	                            zusatzfeldname(p)="barcode"&i
	                            zusatzfeld(p)=barcode(i)
	                        End If
	                        If gefunden=False Then
	                            p=p+1
	                        End If
	                        If p=limit Then
	                            gefunden=True
	                        End If
	                    Loop
	                    
	                    i=i+1
	                End If
	            Loop
	            mybarcodefile.close
	            Set mybarcodefile=Nothing
	        Else
	            runbcplus=False
	        End If
	        
	        
	        '*** wird von aufrauemen entfernt
	        
	        If fs.fileexists(bctempname&".bar") Then
		        fs.deletefile bctempname&".bar", True
		        Err.clear
	        End If
	        
	       
	    End If 
	Next
	    
    
End Function








'**********************************************************************************
'**********************  Fehlerhafte Dokumente aussortieren  **********************
'**********************************************************************************


Function GetGarbage(jobname)
    On Error Resume Next
    
    If changeling=False Then
        errorlog(jobname)
        i=0
        
        garbagename = getFiFo(garbagepath,"temp")
        
        
        
        If fs.fileexists(jobname & ".log") Then
            Err.clear
            fs.CopyFile jobname&".log", garbagename&".log", True
            If Err.number<>0 Then
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".job") Then
            Err.clear
            fs.CopyFile jobname&".job", garbagename&".job", True
            If Err.number<>0 Then
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".hocr") Then
            Err.clear
            fs.CopyFile jobname&".hocr", garbagename&".hocr", True
            If Err.number<>0 Then
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".ocr_xml") Then
            Err.clear
            fs.CopyFile jobname&".ocr_xml", garbagename&".ocr_xml", True
            If Err.number<>0 Then
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".tif") Then
            Err.clear
            fs.CopyFile jobname&".tif", garbagename&".tif", True
            If Err.number<>0 Then
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & "-OCR.tif") Then
            Err.clear
            fs.CopyFile jobname&"-OCR.tif", garbagename&"-OCR.tif", True
            If Err.number<>0 Then
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & "-OCR.jpg") Then
            Err.clear
            fs.CopyFile jobname&"-OCR.jpg", garbagename&"-OCR.jpg", True
            If Err.number<>0 Then
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & "-OCR.gif") Then
            Err.clear
            fs.CopyFile jobname&"-OCR.gif", garbagename&"-OCR.gif", True
            If Err.number<>0 Then
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & "-archiv.tif") Then
            Err.clear
            fs.CopyFile jobname&"-archiv.tif", garbagename&"-archiv.tif", True
            If Err.number<>0 Then
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        
        If fs.fileexists(jobname & ".bmp") Then
            Err.clear
            fs.CopyFile jobname&".bmp", garbagename&".bmp", True
            If Err.number<>0 Then
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".jpg") Then
            Err.clear
            fs.CopyFile jobname&".jpg", garbagename&".jpg", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".ftx") Then
            Err.clear
            fs.CopyFile jobname&".ftx", garbagename&".ftx", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        
        If fs.fileexists(jobname & ".bar") Then
            Err.clear
            fs.CopyFile jobname&".bar", garbagename&".bar", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        
        If fs.fileexists(jobname & ".tbar") Then
            Err.clear
            fs.CopyFile jobname&".tbar", garbagename&".tbar", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        
        
        If fs.fileexists(jobname & ".tibar") Then
            Err.clear
            fs.CopyFile jobname&".tibar", garbagename&".tibar", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        
        
        If fs.fileexists(jobname & "-bc.bar") Then
            Err.clear
            fs.CopyFile jobname&"-bc.bar", garbagename&"-bc.bar", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & "-bc.tif") Then
            Err.clear
            fs.CopyFile jobname&"-bc.tif", garbagename&"-bc.tif", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        
        If fs.fileexists(jobname & ".htm") Then
            Err.clear
            fs.CopyFile jobname&".htm", garbagename&".htm", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".html") Then
            Err.clear
            fs.CopyFile jobname&".html", garbagename&".html", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".eml") Then
            Err.clear
            fs.CopyFile jobname&".eml", garbagename&".eml", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".msg") Then
            Err.clear
            fs.CopyFile jobname&".msg", garbagename&".msg", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".var") Then
            Err.clear
            fs.CopyFile jobname&".var", garbagename&".var", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".zwd") Then
            Err.clear
            fs.CopyFile jobname&".zwd", garbagename&".zwd", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".ztd") Then
            Err.clear
            fs.CopyFile jobname&".ztd", garbagename&".ztd", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".gif") Then
            Err.clear
            fs.CopyFile jobname&".gif", garbagename&".gif", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".pdf") Then
            
            fs.CopyFile jobname&".pdf", garbagename&".pdf", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".ps") Then
            Err.clear
            fs.CopyFile jobname&".ps", garbagename&".ps", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        
        If fs.fileexists(jobname & ".pcl") Then
            Err.clear
            On Error Resume Next
            fs.CopyFile jobname&".pcl", garbagename&".pcl", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".doc") Then
            Err.clear
            fs.CopyFile jobname&".doc", garbagename&".doc", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        
        If fs.fileexists(jobname & ".docx") Then
            Err.clear
            fs.CopyFile jobname&".docx", garbagename&".docx", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".xls") Then
            Err.clear
            fs.CopyFile jobname&".xls", garbagename&".xls", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".xlsx") Then
            Err.clear
            fs.CopyFile jobname&".xlsx", garbagename&".xlsx", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".rtf") Then
            Err.clear
            fs.CopyFile jobname&".rtf", garbagename&".rtf", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".dbf") Then
            Err.clear
            fs.CopyFile jobname&".dbf", garbagename&".dbf", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".ocr") Then
            Err.clear
            fs.CopyFile jobname&".ocr", garbagename&".ocr", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".ppt") Then
            Err.clear
            fs.CopyFile jobname&".ppt", garbagename&".ppt", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        If fs.fileexists(jobname & ".pptx") Then
            Err.clear
            fs.CopyFile jobname&".pptx", garbagename&".pptx", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If        
        If fs.fileexists(jobname & ".pps") Then
            Err.clear
            fs.CopyFile jobname&".pps", garbagename&".pps", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".dwg") Then
            Err.clear
            fs.CopyFile jobname&".dwg", garbagename&".dwg", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".dxf") Then
            Err.clear
            fs.CopyFile jobname&".dxf", garbagename&".dxf", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".dwf") Then
            Err.clear
            fs.CopyFile jobname&".dwf", garbagename&".dwf", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".txt") Then
            Err.clear
            fs.CopyFile jobname&".txt", garbagename&".txt", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".xjf") Then
            Err.clear
            fs.CopyFile jobname&".xjf", garbagename&".xjf", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".swd") Then
            Err.clear
            fs.CopyFile jobname&".swd", garbagename&".swd", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        If fs.fileexists(jobname & ".slw") Then
            Err.clear
            fs.CopyFile jobname&".slw", garbagename&".slw", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        For s=0 To 50
            If fs.fileexists(jobname & "_"& s & ".iev") Then
                Err.clear
                fs.CopyFile jobname& "_" & s & ".iev", garbagename& "_"& s & ".iev", True
                If Err.number<>0 Then
                    
                    On Error Resume Next
                    objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                    Err.clear
                End If
            End If
        Next
        
        
        If fs.fileexists(jobname & ".tpl") Then
            Err.clear
            fs.CopyFile jobname&".tpl", garbagename&".tpl", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".err") Then
            Err.clear
            fs.CopyFile jobname&".err", garbagename&".err", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
        
        
        If fs.fileexists(jobname & ".odt") Then
            Err.clear
            fs.CopyFile jobname&".odt", garbagename&".odt", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If 
        
        If fs.fileexists(jobname & ".wps") Then
            Err.clear
            fs.CopyFile jobname&".wps", garbagename&".wps", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If 
        
        
        
        
        If fs.fileexists(jobname & ".ods") Then
            Err.clear
            fs.CopyFile jobname&".ods", garbagename&".ods", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If  
        
        If fs.fileexists(jobname & ".odp") Then
            Err.clear
            fs.CopyFile jobname&".odp", garbagename&".odp", True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If  
        
        If fs.fileexists(jobname & extension) Then
            Err.clear
            fs.CopyFile jobname&extension, garbagename&extension, True
            If Err.number<>0 Then
                
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Garbage lsst sich nicht verschieben."&Err.number
                Err.clear
            End If
        End If
    End If
    
    aufraeumen(jobname)
    
    
    
    '*****************    Benachrichtigungsmail an den Admin falls garbage  *****************************
    
    If alertongarbage = True  Then
        versendet = False
        garbagefile=Replace(garbagename,garbagepath,"")
        garbagefile=clientprogram&"garbage\"&garbagefile&extension
        
        If alertongarbagecounter = 0 Or alertongarbagecounter = 1 Then
            
            lngReturnCode = objWSHShell.Run(Chr(34)&programm & "sendlinkmail.vbs"&Chr(34)&" " & adminmail & " -file:" &  garbagefile & " " & Chr(34) & "Dieses Dokument wurde in den Garbage-Ordner verschoben" & Chr(34))
        Else   'erstmal sammeln
            alle = ""
            Set alert = fs.opentextfile(programm & "\temp\alertongarbage.txt", 1, True)
            
            
            
            Do While Not(alert.atendofstream)
                zeile=alert.readline
                If zeile<>"" And InStr(1,zeile,"file:") Then
                    i = i +1
                    zeile = Replace(zeile,"file:","")
                    alle = alle & zeile & ";"
                End If
                
            Loop
            
            If i => alertongarbagecounter Then		'Alarm
                alle = alle & garbagefile & ";"
                lngReturnCode = objWSHShell.Run(Chr(34)&programm & "sendlinkmail.vbs"&Chr(34)&" " & adminmail & " -file:" &  alle & " " & Chr(34) &  "Diese Dokumente wurden in den Garbage-Ordner verschoben" & Chr(34))
                If lngReturnCode<> 0 Then
                    objWSHShell.LogEvent 1,"Archivierung.vbs: Achtung! Es konnte keine Warnmail versendet werden. berprfen Sie die Konfiguration und den SMTP-Server" & vbCrLf & "Dokumente:" & alle
                Else
                    versendet = True
                End If
                
            Else	'hochzhlen
                alert.Close
                Set alert = fs.opentextfile(programm & "\temp\alertongarbage.txt", 8, True)
                alert.writeline "file:" & garbagefile
                
                
            End If
            
            alert.close
            Set alert = Nothing
            If versendet = True Then
                fs.DeleteFile programm & "\temp\alertongarbage.txt", True
                If Err.Number<> 0 Then
                    objWSHShell.LogEvent 1,"Archivierung.vbs: Achtung! Alertongarbage.txt konnte nicht gelscht werden" & vbCrLf & Err.Description
                End If
            End If
        End If
        
        
    End If
    
    
    '**************************************************************************************
End Function









'**********************************************************************************
'****************************  Dubletten aussortieren  ****************************
'**********************************************************************************


Function GetDublette(jobname)
    On Error Resume Next
    
    If changeling=False Then
       
        garbagename = getFiFo(dublettenpath,"temp")
        
        
        
        
        
        If fs.fileexists(jobname & ".log") Then
            Err.clear
            fs.CopyFile jobname&".log", garbagename&".log", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".job") Then
            Err.clear
            fs.CopyFile jobname&".job", garbagename&".job", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".tif") Then
            Err.clear
            fs.CopyFile jobname&".tif", garbagename&".tif", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & "-OCR.tif") Then
            Err.clear
            fs.CopyFile jobname&"-OCR.tif", garbagename&"-OCR.tif", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & "-archiv.tif") Then
            Err.clear
            fs.CopyFile jobname&"-archiv.tif", garbagename&"-archiv.tif", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        
        If fs.fileexists(jobname & ".bmp") Then
            Err.clear
            fs.CopyFile jobname&".bmp", garbagename&".bmp", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        
        If fs.fileexists(jobname & ".bar") Then
            Err.clear
            fs.CopyFile jobname&".bar", garbagename&".bar", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        
        If fs.fileexists(jobname & ".jpg") Then
            Err.clear
            fs.CopyFile jobname&".jpg", garbagename&".jpg", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".ftx") Then
            Err.clear
            fs.CopyFile jobname&".ftx", garbagename&".ftx", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".zwd") Then
            Err.clear
            fs.CopyFile jobname&".zwd", garbagename&".zwd", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".gif") Then
            Err.clear
            fs.CopyFile jobname&".gif", garbagename&".gif", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".pdf") Then
            Err.clear
            fs.CopyFile jobname&".pdf", garbagename&".pdf", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".ps") Then
            Err.clear
            fs.CopyFile jobname&".ps", garbagename&".ps", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".pcl") Then
            Err.clear
            On Error Resume Next
            fs.CopyFile jobname&".pcl", garbagename&".pcl", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".doc") Then
            Err.clear
            fs.CopyFile jobname&".doc", garbagename&".doc", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".xls") Then
            Err.clear
            fs.CopyFile jobname&".xls", garbagename&".xls", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".rtf") Then
            Err.clear
            fs.CopyFile jobname&".rtf", garbagename&".rtf", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".dbf") Then
            Err.clear
            fs.CopyFile jobname&".dbf", garbagename&".dbf", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".ocr") Then
            Err.clear
            fs.CopyFile jobname&".ocr", garbagename&".ocr", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".ppt") Then
            Err.clear
            fs.CopyFile jobname&".ppt", garbagename&".ppt", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".pps") Then
            Err.clear
            fs.CopyFile jobname&".pps", garbagename&".pps", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".dwg") Then
            Err.clear
            fs.CopyFile jobname&".dwg", garbagename&".dwg", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".dxf") Then
            Err.clear
            fs.CopyFile jobname&".dxf", garbagename&".dxf", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".dwf") Then
            Err.clear
            fs.CopyFile jobname&".dwf", garbagename&".dwf", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".txt") Then
            Err.clear
            fs.CopyFile jobname&".txt", garbagename&".txt", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".xjf") Then
            Err.clear
            fs.CopyFile jobname&".xjf", garbagename&".xjf", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".swd") Then
            Err.clear
            fs.CopyFile jobname&".swd", garbagename&".swd", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".slw") Then
            Err.clear
            fs.CopyFile jobname&".slw", garbagename&".slw", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".tpl") Then
            Err.clear
            fs.CopyFile jobname&".tpl", garbagename&".tpl", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & ".err") Then
            Err.clear
            fs.CopyFile jobname&".err", garbagename&".err", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
        
        If fs.fileexists(jobname & extension) Then
            Err.clear
            fs.CopyFile jobname&extension, garbagename&extension, True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                objWshShell.LogEvent 1, "archivierung(21b): Dublette lsst sich nicht verschieben."&Err.number
                
            End If
        End If
    End If
    
    
    If logging = True Then
        objWshShell.LogEvent 0,"bitfarm-Archiv Logging: Dublette verschoben " &vbCrLf& jobname &vbCrLf& "-->" & garbagename
    End If
    
    
    ' dublettenmail an admin senden
    If dublettenmail = True Then
    	garbagefile=Replace(garbagename,dublettenpath,"")
        garbagefile=clientprogram&"dubletten\"&garbagefile&extension
    	cmd = Chr(34)&programm & "sendlinkmail.vbs"&Chr(34)&" " & adminmail & " -file:" &  garbagefile & " " & Chr(34) & "Dieses Dokument wurde in den Dubletten-Ordner verschoben" & Chr(34)
		If scriptdebug=True Then
    		objWSHShell.LogEvent 1, "archivierung.vbs sende dublettenmail" & vbCrLf & cmd
    	End If
    	lngReturnCode = objWSHShell.Run(cmd)
    End If
    
    
    
    aufraeumen(jobname)
   
End Function








'**********************************************************************************
'***************************  aufrumen  **************************
'**********************************************************************************






Function aufraeumen(name1)
    On Error Resume Next
    
    '******************* kurz noch warten, vielleicht ist Ausdruck noch nicht fertig bergeben ******
    WScript.sleep 500
    '************************************************************************************************
    flagerr=False
    errfile=""
    
    
    
    Err.Clear
    If fs.fileexists(name1 & ".ocr_xml") Then
        fs.DeleteFile name1 & ".ocr_xml", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".ocr_xml"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If   
    
    If fs.fileexists(name1 & ".hocr") Then
        fs.DeleteFile name1 & ".hocr", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".hocr"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If    
    
    If fs.fileexists(name1 & ".job") Then
        fs.DeleteFile name1 & ".job", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".job"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".odt") Then
        fs.DeleteFile name1 & ".odt", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".odt"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".wps") Then
        fs.DeleteFile name1 & ".wps", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".wps"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".odp") Then
        fs.DeleteFile name1 & ".odp", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".odp"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".ods") Then
        fs.DeleteFile name1 & ".ods", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".ods"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If      
    
    
    If fs.fileexists(name1 & ".log") Then
        fs.DeleteFile name1 & ".log", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".log"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".err") Then
        fs.DeleteFile name1 & ".err", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".err"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".ocr") Then
        fs.DeleteFile name1 & ".ocr", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".ocr"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    
    If fs.fileexists(name1 & ".pdf") Then
        fs.DeleteFile name1 & ".pdf", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".pdf"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".doc") Then
        fs.DeleteFile name1 & ".doc", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".doc"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".docx") Then
        fs.DeleteFile name1 & ".docx", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".docx"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".ftx") Then
        fs.DeleteFile name1 & ".ftx", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".ftx"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".bar") Then
        fs.DeleteFile name1 & ".bar", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".bar"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".tbar") Then
        fs.DeleteFile name1 & ".tbar", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".tbar"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    
    If fs.fileexists(name1 & ".tibar") Then
        fs.DeleteFile name1 & ".tibar", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".tibar"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    
    If fs.fileexists(name1 & "-bc.bar") Then
        fs.DeleteFile name1 & "-bc.bar", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & "-bc.bar"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & "-bc.tif") Then
        fs.DeleteFile name1 & "-bc.tif", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & "-bc.tif"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".zwd") Then
        fs.DeleteFile name1 & ".zwd", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".zwd"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".ztd") Then
        fs.DeleteFile name1 & ".ztd", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".ztd"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".dbf") Then
        fs.DeleteFile name1 & ".dbf", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".dbf"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".xls") Then
        fs.DeleteFile name1 & ".xls", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".xls"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".xlsx") Then
        fs.DeleteFile name1 & ".xlsx", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".xlsx"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".rtf") Then
        fs.DeleteFile name1 & ".rtf", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".rtf"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".ppt") Then
        fs.DeleteFile name1 & ".ppt", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".ppt"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".pptx") Then
        fs.DeleteFile name1 & ".pptx", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".pptx"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".pps") Then
        fs.DeleteFile name1 & ".pps", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".pps"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".dwg") Then
        fs.DeleteFile name1 & ".dwg", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".dwg"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".dxf") Then
        fs.DeleteFile name1 & ".dxf", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".dxf"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".dwf") Then
        fs.DeleteFile name1 & ".dwf", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".dwf"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".pid") Then
        fs.DeleteFile name1 & ".pid", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".pid"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".htm") Then
        fs.DeleteFile name1 & ".htm", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".htm"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".html") Then
        fs.DeleteFile name1 & ".html", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".html"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".eml") Then
        fs.DeleteFile name1 & ".eml", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".eml"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".msg") Then
        fs.DeleteFile name1 & ".msg", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".msg"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".var") Then
        fs.DeleteFile name1 & ".var", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".var"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    
    If fs.fileexists(name1 & ".tif") Then
        fs.DeleteFile name1 & ".tif", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".tif"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & "-temp.tif") Then
        fs.DeleteFile name1 & "-temp.tif", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & "-temp.tif"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".bmp") Then
        fs.DeleteFile name1 & ".bmp", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".bmp"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".jpg") Then
        fs.DeleteFile name1 & ".jpg", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".jpg"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".gif") Then
        fs.DeleteFile name1 & ".gif", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".gif"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".png") Then
        fs.DeleteFile name1 & ".png", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".png"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & "-archiv.tif") Then
        fs.DeleteFile name1 & "-archiv.tif", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & "-archiv.tif"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & "-OCR.tif") Then
        fs.DeleteFile name1 & "-OCR.tif", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & "-OCR.tif"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & "-OCR.jpg") Then
        fs.DeleteFile name1 & "-OCR.jpg", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & "-OCR.jpg"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & "-OCR.gif") Then
        fs.DeleteFile name1 & "-OCR.gif", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & "-OCR.gif"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".xjf") Then
        fs.DeleteFile name1 & ".xjf", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".xjf"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".swd") Then
        fs.DeleteFile name1 & ".swd", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".swd"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    
    
    If fs.fileexists(name1 & "_0.dat") Then
        fs.DeleteFile name1 & "_0.dat", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & "_0.dat"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    
    
    If fs.fileexists(name1 & ".txt") Then
        fs.DeleteFile name1 & ".txt", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".txt"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & "a.txt") Then
        fs.DeleteFile name1 & "a.txt", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & "a.txt"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & "b.txt") Then
        fs.DeleteFile name1 & "b.txt", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & "b.txt"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".tmp.txt") Then
        fs.DeleteFile name1 & ".tmp.txt", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".tmp.txt"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".pnm") Then
        fs.DeleteFile name1 & ".pnm", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".pnm"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".slw") Then
        fs.DeleteFile name1 & ".slw", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".slw"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".xml") Then
        fs.DeleteFile name1 & ".xml", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".xml"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".fo") Then
        fs.DeleteFile name1 & ".fo", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".fo"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & ".iev") Then
        fs.DeleteFile name1 & ".iev", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".iev"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    
    For s=0 To 50
        If fs.fileexists(name1 & "_" & s & ".iev") Then
            fs.DeleteFile name1 & "_" & s & ".iev", True
            If Err.number<>0 Then
                flagerr=True
                errfile=errfile & vbCrLf & name1 & "_" & s & ".iev"
                errfile=errfile & vbTab & Err.Description
                Err.clear
            End If
        End If
    Next
    
    If fs.fileexists(programm&"out10.bmp") Then
        fs.DeleteFile programm&"out10.bmp", True
        If Err.number<>0 Then
            flagerr=True
            errfile=programm&"out10.bmp"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    
    
    If fs.fileexists(programm&"out20.bmp") Then
        fs.DeleteFile programm&"out20.bmp", True
        If Err.number<>0 Then
            flagerr=True
            errfile=programm&"out20.bmp"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    
    
    If fs.fileexists(programm&"out30.bmp") Then
        fs.DeleteFile programm&"out30.bmp", True
        If Err.number<>0 Then
            flagerr=True
            errfile=programm&"out30.bmp"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    
    If fs.fileexists(name1 & ".ps") Then
        fs.DeleteFile name1 & ".ps", True
        If Err.number<>0 Then
            oerr.clear
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".ps"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    
    If fs.fileexists(name1 & ".pcl") Then
        'msgbox("geht los")
        Err.clear
        fs.DeleteFile name1&".pcl", True
        'msgbox("fertig"&err.number)
        If Err.number<>0 Then
            'msgbox("errorstate")
            Err.clear
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".pcl"
        End If
        'msgbox("fertig")
    End If
    
    If fs.fileexists(name1 & ".tpl") Then
        fs.DeleteFile name1 & ".tpl", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & ".tpl"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & "-OCR_0.dat") Then
        fs.DeleteFile name1 & "-OCR_0.dat", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & "-OCR_0.dat"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & "-OCR.xjf") Then
        fs.DeleteFile name1 & "-OCR.xjf", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & "-OCR.xjf"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & "-OCR.txt") Then
        fs.DeleteFile name1 & "-OCR.txt", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & "-OCR.txt"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(name1 & extension) Then
        fs.DeleteFile name1 & extension, True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & extension
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(queue&"cut1.tif") Then
        fs.DeleteFile queue&"cut1.tif", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf &queue&"cut1.tif"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(queue&"cut2.tif") Then
        fs.DeleteFile queue&"cut2.tif", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf &queue&"cut2.tif"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    
    If fs.fileexists(queue&"cut3.tif") Then
        fs.DeleteFile queue&"cut3.tif", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf &queue&"cut3.tif"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(queue&"cut4.tif") Then
        fs.DeleteFile queue&"cut4.tif", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf &queue&"cut4.tif"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(queue&"cut5.tif") Then
        fs.DeleteFile queue&"cut5.tif", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf &queue&"cut5.tif"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(queue&"cut6.tif") Then
        fs.DeleteFile queue&"cut6.tif", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf &queue&"cut6.tif"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If fs.fileexists(queue&"OCR.xwf") Then
        fs.DeleteFile queue&"OCR.xwf", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf &queue&"OCR.xwf"
        End If
    End If
    
    If fs.fileexists(queue&"OCR.tif") Then
        fs.DeleteFile queue&"OCR.tif", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf &queue&"OCR.tif"
        End If
    End If
    
    If fs.fileexists(queue&"OCR.txt") Then
        fs.DeleteFile queue&"OCR.txt", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf &queue&"OCR.txt"
        End If
    End If
    
    If fs.fileexists(queue&"OCR.pdf") Then
        fs.DeleteFile queue&"OCR.pdf", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf &queue&"OCR.pdf"
        End If
    End If
    
    If fs.fileexists(queue&"OCR.jpg") Then
        fs.DeleteFile queue&"OCR.jpg", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf &queue&"OCR.jpg"
        End If
    End If
    
    If fs.fileexists(queue&"OCR.gif") Then
        fs.DeleteFile queue&"OCR.gif", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf &queue&"OCR.gif"
        End If
    End If
    
    If fs.fileexists(queue&"OCR.bmp") Then
        fs.DeleteFile queue&"OCR.bmp", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf &queue&"OCR.bmp"
        End If
    End If
    
    If fs.fileexists(name1 & extension &".ori") Then
        fs.DeleteFile name1 & extension &".ori", True
        If Err.number<>0 Then
            flagerr=True
            errfile=errfile & vbCrLf & name1 & extension &".ori"
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
    If flagerr=True Then
        objWshShell.LogEvent 2, "bitfarm-Archiv: Fehler beim Aufrumen. Konnte Datei nicht lschen: "&errfile
    End If
    
    
    
End Function




'***********************************************************************
'******************** OpAgent-Restart **********************************

Function safe_omp_restart
	On Error Resume Next
    cmd = "taskkill /F /IM OpAgent.exe"
    lngReturnCode = objWSHShell.Run(cmd,0,False)    
    cmd = "taskkill /F /IM Jobrunner.exe"
    lngReturnCode = objWSHShell.Run(cmd,0,False)   
    
    If opagentjobpath = "" Then
        If OMPVersion=16 Then
            opagentjobpath = objWSHShell.ExpandEnvironmentStrings("%appdata%")
            opagentjobpath = opagentjobpath & "\ScanSoft\Omnipage 16\"
        End If
        If OMPVersion=17 Then
            opagentjobpath = objWSHShell.ExpandEnvironmentStrings("%appdata%")
            opagentjobpath = opagentjobpath & "\ScanSoft\Omnipage 17\"
        End If	
        If OMPVersion=18 Then
            opagentjobpath = objWSHShell.ExpandEnvironmentStrings("%appdata%")
            opagentjobpath = opagentjobpath & "\ScanSoft\Omnipage 18\"
        End If
        If OMPVersion=19 Then
            opagentjobpath = objWSHShell.ExpandEnvironmentStrings("%appdata%")
            opagentjobpath = opagentjobpath & "\ScanSoft\Omnipage 19\"
        End If        
    End If
    
    If scriptdebug = True Then
        objWSHShell.LogEvent 4,"Opagent_Restart (safe): opagentjobpath =" & vbCrLf & opagentjobpath & vbCrLf &"OpProgramm=" & OpProgramm
    End If 
    
    
    Set jobfolder = fs.GetFolder(opagentjobpath & "Job\")
    
    For Each jobfile In jobfolder.Files
        fs.DeleteFile jobfile, True
        If Err.Number <> 0 Then
            objWSHShell.LogEvent 1,"Archivierung.vbs Opagent_Restart Das Job-Verzeichnis konnte nicht vollstndig geleert  werden" & vbCrLf & jobfile.path & vbCrLf & Err.number & vbTab & Err.description	
            Err.clear
        End If
    Next 
    
    Set jobfolder = Nothing
    
    Set reloadfolder = fs.GetFolder(opagentjobpath & "reload\")
    
    For Each jobfile In reloadfolder.Files
        fs.CopyFile jobfile, opagentjobpath & "Job\" & fs.GetFileName(jobfile)
        
        If Err.Number <> 0 Then
            objWSHShell.LogEvent 1,"Archivierung.vbs Opagent_Restart Das Reload-Verzeichnis konnte nicht vollstndig umkopiert werden" & vbCrLf & jobfile.path & vbCrLf & Err.number & vbTab & Err.description		
            Err.clear
        End If
    Next 
    
    Set reloadfolder = Nothing
    WScript.Sleep 500
    
    If fs.FileExists(OCRPath & "IN\ocr.tif") Then
        fs.DeleteFile OCRPath & "IN\ocr.tif", True
        If Err.Number <> 0 Then
            objWSHShell.LogEvent 1,"Archivierung.vbs Opagent_Restart: Konnte IN\OCR.tif nicht lschen" & vbCrLf & Err.number & " " &Err.description
        Else 
            If scriptdebug = True Then
                objWSHShell.LogEvent 4,"Archivierung.vbs Opagent_Restart: IN\OCR.tif gelscht"
            End If
        End If
        WScript.Sleep 500
    End If
    
    clean = clean_ocroutpath
    If clean = False Then
        objWSHShell.LogEvent 1, "Archivierung.vbs Opagent_Restart: - OCR\Out Pfad konnte nicht gerumt werden(2)"
    End If
    
    clean = clean_ocrtemppath
    If clean = False Then
        objWSHShell.LogEvent 1, "Archivierung.vbs Opagent_Restart:- ScanSoft\Temp Pfad konnte nicht gerumt werden"
    End If
    
    
    OpProgramm = fs.getparentfoldername(omnipage)
    ret = ObjWSHShell.Run(Chr(34)&OpProgramm &"\OpAgent.exe"&Chr(34)&" /agent",0,False)
    
    opagentfound = False
    counter = 0
    ompitem = -1
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='OpAgent.exe'"
    Do Until ((opagentfound = True) Or (counter > 100))
    	counter = counter + 1
        ompcount = 0
        Set colItems = objWMIService.ExecQuery(strQuery,,48)
	    For Each objItem In colItems
	        ompcount=ompcount+1
	        Set ompitem = objItem
	    Next
        If ompcount > 0 Then
        	opagentfound = True
        Else
        	WScript.Sleep 100
        End If
    Loop
    
    
    
    If ompitem <> -1 Then
    	Set objWMIService2 = Nothing
        Set objWMIService2 = GetObject("winmgmts:" _
        & "{impersonationLevel=impersonate}!\\.\root\cimv2")
        
    	breakcondition = False
    	OldPercentProcessorTime = 0
		pptmatch = 0
		matchesneeded = 10
		maxwaitseconds = 60
		start_tstamp = Timer
    	Do Until breakcondition = True
    		Set colProcesses = objWMIService2.ExecQuery _
                    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'OpAgent'")
    		proccount = 0
			For Each strProcess In colProcesses
				proccount = proccount + 1
				PercentProcessorTime = strProcess.PercentProcessorTime
				If PercentProcessorTime = OldPercentProcessorTime Then
					pptmatch = pptmatch +1
				Else
					pptmatch = 0
				End If
				OldPercentProcessorTime = PercentProcessorTime
			Next
			If proccount > 0 Then
				If pptmatch > matchesneeded Then
					'MsgBox("OMP ready")
					breakcondition = True
				Else
					WScript.Sleep 100
				End If
			End If
			cur_tstamp = Timer
			If cur_tstamp - start_tstamp > maxwaitseconds Then
				objWSHShell.LogEvent 1, "archivierung.vbs safe_omp_restart Omnipage nach 60 sec. noch nicht stabil, Verarbeitung wird dennoch fortgesetzt"
				breakcondition = True
			End If
    	Loop
    
    
    End If
	

End Function

Function OpAgent_Restart

        
	
    If ocrserver<>"" Then
        Exit Function
    End If
    On Error Resume Next
    cmd = "taskkill /F /IM OpAgent.exe"
    lngReturnCode = objWSHShell.Run(cmd,0,False)    
    cmd = "taskkill /F /IM Jobrunner.exe"
    lngReturnCode = objWSHShell.Run(cmd,0,False)   
    
    If opagentjobpath = "" Then
        If OMPVersion=16 Then
            opagentjobpath = objWSHShell.ExpandEnvironmentStrings("%appdata%")
            opagentjobpath = opagentjobpath & "\ScanSoft\Omnipage 16\"
        End If
        If OMPVersion=17 Then
            opagentjobpath = objWSHShell.ExpandEnvironmentStrings("%appdata%")
            opagentjobpath = opagentjobpath & "\ScanSoft\Omnipage 17\"
        End If	
        If OMPVersion=18 Then
            opagentjobpath = objWSHShell.ExpandEnvironmentStrings("%appdata%")
            opagentjobpath = opagentjobpath & "\ScanSoft\Omnipage 18\"
        End If
        If OMPVersion=19 Then
            opagentjobpath = objWSHShell.ExpandEnvironmentStrings("%appdata%")
            opagentjobpath = opagentjobpath & "\ScanSoft\Omnipage 19\"
        End If        
    End If
    
    If scriptdebug = True Then
        objWSHShell.LogEvent 4,"Opagent_Restart: opagentjobpath =" & vbCrLf & opagentjobpath & vbCrLf &"OpProgramm=" & OpProgramm
    End If 
    
    
    Set jobfolder = fs.GetFolder(opagentjobpath & "Job\")
    
    For Each jobfile In jobfolder.Files
        fs.DeleteFile jobfile, True
        If Err.Number <> 0 Then
            objWSHShell.LogEvent 1,"Archivierung.vbs Opagent_Restart Das Job-Verzeichnis konnte nicht vollstndig geleert  werden" & vbCrLf & jobfile.path & vbCrLf & Err.number & vbTab & Err.description	
            Err.clear
        End If
    Next 
    
    Set jobfolder = Nothing
    
    Set reloadfolder = fs.GetFolder(opagentjobpath & "reload\")
    
    For Each jobfile In reloadfolder.Files
        fs.CopyFile jobfile, opagentjobpath & "Job\" & fs.GetFileName(jobfile)
        
        If Err.Number <> 0 Then
            objWSHShell.LogEvent 1,"Archivierung.vbs Opagent_Restart Das Reload-Verzeichnis konnte nicht vollstndig umkopiert werden" & vbCrLf & jobfile.path & vbCrLf & Err.number & vbTab & Err.description		
            Err.clear
            OpAgent_Restart =False	
        End If
    Next 
    
    Set reloadfolder = Nothing
    WScript.Sleep 500
    
    If fs.FileExists(OCRPath & "IN\ocr.tif") Then
        fs.DeleteFile OCRPath & "IN\ocr.tif", True
        If Err.Number <> 0 Then
            objWSHShell.LogEvent 1,"Archivierung.vbs Opagent_Restart: Konnte IN\OCR.tif nicht lschen" & vbCrLf & Err.number & " " &Err.description
        Else 
            If scriptdebug = True Then
                objWSHShell.LogEvent 4,"Archivierung.vbs Opagent_Restart: IN\OCR.tif gelscht"
            End If
        End If
        WScript.Sleep 500
    End If
    
    clean = clean_ocroutpath
    If clean = False Then
        objWSHShell.LogEvent 1, "Archivierung.vbs Opagent_Restart: - OCR\Out Pfad konnte nicht gerumt werden(2)"
    End If
    
    clean = clean_ocrtemppath
    If clean = False Then
        objWSHShell.LogEvent 1, "Archivierung.vbs Opagent_Restart:- ScanSoft\Temp Pfad konnte nicht gerumt werden"
    End If
    
    OpProgramm = fs.getparentfoldername(omnipage)
    ret = ObjWSHShell.Run(Chr(34)&OpProgramm &"\OpAgent.exe"&Chr(34)&" /agent",0,False)
    WScript.Sleep 2000
    
    
    If ret = 0 Then	
        opagentrestarts = opagentrestarts +1
        If scriptdebug = True Then
        	objWSHShell.LogEvent 2,"Archivierung.vbs  OpAgent wurde neu gestartet Methode 2. Versuch." & opagentrestarts &vbCrLf & "ret:" & ret			
        End If
        OpAgent_Restart = True		
    Else
        OpAgent_Restart = False
    End If
    
    
End Function





'***********************************************************************
'******************** Suchen und ersetzen des Omnipage-Auftrages *******
'***********************************************************************

Function ocrcommand(indexname)
    On Error Resume Next
    
    If OMPVersion=14 Then
        kette=""
        
        Set ITextStream = fs.CreateTextFile(indexname&".xjf", True, False)
        If Not Err.Number=0 Then
            objWSHShell.LogEvent 1,"archivierung(32): Konnte OCR-Anweisungsdatei nicht erstellen."
            WScript.Quit
        End If
        
        
        Set omnitemplate = fs.OpenTextFile(programm&"OCR.xjf",1)
        
        Do While omnitemplate.AtEndOfStream <> True
            kette=omnitemplate.readline
            
            positioninput=InStr(1,kette,"input.tif",1)
            positionoutput=InStr(1,kette,"output.txt",1)
            
            
            If (positioninput<>0) Or (positionoutput<>0) Then
                laenge=Len(kette)
                If positioninput<>0 Then
                    kette1=Mid(kette,1,positioninput-1)
                    kette2=Mid(kette,positioninput+9,laenge-(positioninput-9))
                    kette=kette1&indexname&OCRHandle&kette2
                End If
                If positionoutput<>0 Then
                    kette1=Mid(kette,1,positionoutput-1)
                    kette2=Mid(kette,positionoutput+10,laenge-(positionoutput-10))
                    kette=kette1&indexname&".txt"&kette2
                End If
                
            End If
            
            ITextStream.WriteLine(kette)
            
            
        Loop
        omnitemplate.close
        ITextStream.close
    End If
    
    If (OMPVersion=15) Then
        
        If fs.fileexists(queue&"OCR.xwf") Then
            fs.DeleteFile(queue&"OCR.xwf")
            If Err.number<>0 Then
                objWshShell.LogEvent 1, "archivierung(31): Fehler beim Lschen alter OCR-Datei."&Err.number
                WScript.Quit
            End If
        End If
        If fs.fileexists(queue&"OCR.tif") Then
            fs.DeleteFile(queue&"OCR.tif")
            If Err.number<>0 Then
                objWshShell.LogEvent 1, "archivierung(31): Fehler beim Lschen alter OCR-Datei."&Err.number
                WScript.Quit
            End If
        End If
        If fs.fileexists(queue&"OCR.pdf") Then
            fs.DeleteFile(queue&"OCR.pdf")
            If Err.number<>0 Then
                objWshShell.LogEvent 1, "archivierung(31): Fehler beim Lschen alter OCR-Datei."&Err.number
                WScript.Quit
            End If
        End If
        If fs.fileexists(queue&"OCR.txt") Then
            fs.DeleteFile(queue&"OCR.txt")
            If Err.number<>0 Then
                objWshShell.LogEvent 1, "archivierung(31): Fehler beim Lschen alter OCR-Datei."&Err.number
                WScript.Quit
            End If
        End If
        If fs.fileexists(queue&"OCR.jpg") Then
            fs.DeleteFile(queue&"OCR.jpg")
            If Err.number<>0 Then
                objWshShell.LogEvent 1, "archivierung(31): Fehler beim Lschen alter OCR-Datei."&Err.number
                WScript.Quit
            End If
        End If
        If fs.fileexists(queue&"OCR.gif") Then
            fs.DeleteFile(queue&"OCR.gif")
            If Err.number<>0 Then
                objWshShell.LogEvent 1, "archivierung(31): Fehler beim Lschen alter OCR-Datei."&Err.number
                WScript.Quit
            End If
        End If
        If fs.fileexists(queue&"OCR.bmp") Then
            fs.DeleteFile(queue&"OCR.bmp")
            If Err.number<>0 Then
                objWshShell.LogEvent 1, "archivierung(31): Fehler beim Lschen alter OCR-Datei."&Err.number
                WScript.Quit
            End If
        End If
        WScript.Sleep 200
        
        If OCRHandle<>"" Then
            Err.clear
            If fs.fileexists(programm&"OMP"&OMPVersion&"-"&Right(OCRHandle,Len(OCRHandle)-1)&".xwf") Then
                fs.copyfile programm&"OMP"&OMPVersion&"-"&Right(OCRHandle,Len(OCRHandle)-1)&".xwf", queue&"OCR.xwf", True
                If Err.number<>0 Then
                    objWshShell.LogEvent 1, "archivierung(31b): Fehler beim Kopieren der OCR-Anweisung."&Err.number
                    WScript.Quit
                End If
            Else
                errortxt="archivierung(31c): Keine Omnipage "&OMPVersion&" Anweisungsdatei fr "&OCRHandle&" im Programmverzeichnis vorhanden!"
                objWshShell.LogEvent 1, errortxt
                GetGarbage(tempname)
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
        Else
            errortxt="archivierung(31d): Allgemeiner Fehler."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(tempname)
            Unlock(programm&lockdatei)
            WScript.Quit
            
        End If
        
        
        Err.clear
        fs.copyfile indexname&OCRHandle, queue&"OCR"&OCRHandle, True
        If Err.number<>0 Then
            objWshShell.LogEvent 1, "archivierung(31d): Fehler beim Kopieren der OCR-Grafikdatei."&Err.number
            WScript.Quit
        End If
        
        
        
        
        
        
    End If
    
End Function


'************************************************************************
'************************************************************************

Function isBusy()
    On Error Resume Next
    ompcount=0
    DWGcount=0
    GScount=0
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='omnipage.exe'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    For Each objItem In colItems
        ompcount=ompcount+1
    Next
    
    Set colItems = Nothing
    Set objWMIService = Nothing
   
    
    
    If (ompcount = 0) And (DWGcount = 0) And (GScount = 0) Then
        isBusy=False
    Else
        isBusy=True
    End If
End Function


'************************************************************************
'************************************************************************

Function filtern(tiffile)
    On Error Resume Next
    ' aus dem filtermakrostring alles rausnehmen, was nicht color, highres, oder dropscanpdf ist, sowie trennkommas bzw. semikolon
    
    
    filtername = Replace(filtermakro,"Highres","")
    filtername = Replace(filtername,"highres","")
    filtername = Replace(filtername,"color","")
    filtername = Replace(filtername,"Color","")
    filtername = Replace(filtername,"readbarcodes","")
    filtername = Replace(filtername,"colorhighres","")
    filtername = Replace(filtername,"ColorHighres","")
    filtername = Replace(filtername,"dropscanpdf","")
    filtername = Replace(filtername,",","")
    filtername = Replace(filtername,";","")
    If scriptdebug = True Then
        objWshShell.LogEvent 4, "Filtername:"&filtername
    End If
    
    If fs.fileexists(programm&"filter\"&filtername&".fad") Then
        
        erfolg=filterlesen(filtername)
        
        
        If erfolg=True Then
            
            
            If Archivfilter<>"" Then
                If fs.fileexists(programm&"filter\"&Archivfilter&".txt") Then
                    Err.clear
                    tiffile=tempname
                    If fs.fileexists(tiffile&"-archiv.tif") Then
                        fs.deletefile tiffile&"-archiv.tif", True
                        If Err.number<>0 Then
                            Err.clear
                            errortxt="bitfarm-Archiv: Archivierung: Fehler beim Lschversuch alter Filterdateien."	
                            objWshShell.LogEvent 1, errortxt
                            getgarbage(tempname)
                            Unlock(programm&lockdatei)
                            WScript.Quit
                        End If
                    End If
                    
                    
                    lngReturnCode = runfilter(tiffile&".tif",programm&"filter\"&Archivfilter&".txt",tiffile&"-archiv.tif")
                    
                    If lngReturnCode<>0 Then
                        Err.clear
                        errortxt="bitfarm-Archiv: Archivierung: Fehler beim Filtern der Tifdatei:"&lngReturnCode	
                        objWshShell.LogEvent 1, errortxt
                        getgarbage(tempname)
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If
                    WScript.Sleep 300
                    
                    If Not fs.fileexists(tiffile&"-archiv.tif") Then
                        Err.clear
                        errortxt="bitfarm-Archiv: Archivierung: Nach Filterung keine TIF-Datei vorhanden."	
                        objWshShell.LogEvent 1, errortxt
                        getgarbage(tempname)
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If
                    archivtif=tiffile&"-archiv"
                    
                End If
            End If
            
            
            If OCRFilter<>"" Then
                If fs.fileexists(programm&"filter\"&OCRFilter&".txt") Then
                    If fs.fileexists(tiffile&"-OCR.tif") Then
                        tiffile=tiffile&"-OCR"
                    End If
                    Err.clear
                    If fs.fileexists(tiffile&"-filter.tif") Then
                        fs.deletefile tiffile&"-filter.tif", True
                        If Err.number<>0 Then
                            Err.clear
                            errortxt="bitfarm-Archiv: Archivierung: Fehler beim Lschversuch alter Filterdateien."	
                            objWshShell.LogEvent 1, errortxt
                            getgarbage(tempname)
                            Unlock(programm&lockdatei)
                            WScript.Quit
                        End If
                    End If
                    
                    
                    lngReturnCode = runfilter(tiffile&".tif",programm&"filter\"&OCRFilter&".txt",tiffile&"-filter.tif")
                    
                    
                    If lngReturnCode<>0 Then
                        Err.clear
                        errortxt="bitfarm-Archiv: Archivierung: Fehler beim Filtern der Tifdatei:"&lngReturnCode	
                        objWshShell.LogEvent 1, errortxt
                        getgarbage(tempname)
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If
                    
                    WScript.Sleep 300
                    If Not fs.fileexists(tiffile&"-filter.tif") Then
                        Err.clear
                        errortxt="bitfarm-Archiv: Archivierung: Nach Filterung keine TIF-Datei vorhanden (1)."	
                        objWshShell.LogEvent 1, errortxt
                        getgarbage(tempname)
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If
                    Err.clear
                    
                    fs.copyfile tiffile&"-filter.tif", tempname&"-OCR.tif", True
                    
                    If Err.number<>0 Then
                        Err.clear
                        errortxt="bitfarm-Archiv: Archivierung: Fehler beim Umkopieren nach Filterung."	
                        objWshShell.LogEvent 1, errortxt
                        getgarbage(tempname)
                        Unlock(programm&lockdatei)
                        WScript.Quit
                    End If
                    
                    OCRname=tempname&"-OCR"
                    fs.deletefile tiffile&"-filter.tif", True
                    Err.clear
                    
                End If
            End If
            
            
        End If

        
    End If
    
End Function


'************************************************************************
'************************************************************************

Function shrinkjpg(tempname)
    On Error Resume Next
    
    mysize=0
    
    Set dateiinfo=fs.getfile(tempname&extension)
    mysize=dateiinfo.size
    mysize=Int(mysize/1000)
    WScript.sleep 20
    Set dateiinfo=Nothing
    
    
    
    If mysize>autoshrinkjpg Then
        
        autoshrinkjpg=autoshrinkjpg * 2.6
        
        jpgfaktor=Int((autoshrinkjpg/mysize)*100)
        
        If jpgfaktor>99 Then
            jpgfaktor=99
        End If
        
        
        jpgfaktor=Int(100-(100-jpgfaktor)/2)
        
        
        If jpgfaktor<12 Then
            jpgfaktor=12
        End If
        
        If jpgfaktor<40 Then
            jpgfaktor=Int(40-(40-jpgfaktor)/2)
        End If
        
        'objWshShell.LogEvent 1, "jpgfaktor"&jpgfaktor
        If fs.fileexists(programm&"temp\jpgfilter.txt") Then
            fs.deletefile programm&"temp\jpgfilter.txt", True
            If Err.number<>0 Then
                Err.clear
                errortxt="bitfarm-Archiv: Archivierung: Fehler beim Lschversuch alter JPG-Filterdatei."	
                objWshShell.LogEvent 1, errortxt
                getgarbage(tempname)
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
            WScript.sleep 50
        End If
        
        Err.clear
        
        
        Set jpgfilter=fs.CreateTextFile(programm&"temp\jpgfilter.txt",True)
        jpgfilter.writeline("COMPJPEG="&jpgfaktor)
        jpgfilter.close
        Set jpgfilter=Nothing
        
        If Err.number<>0 Then
            Err.clear
            errortxt="bitfarm-Archiv: Archivierung: Fehler beim erstellen neuer JPG-Filterdatei."	
            objWshShell.LogEvent 1, errortxt
            getgarbage(tempname)
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
        
        fs.copyfile tempname&extension, tempname&"-tmp"&extension, True
        
        
        If Err.number<>0 Then
            Err.clear
            errortxt="bitfarm-Archiv: Archivierung: Fehler beim kopieren JPG-Datei."	
            objWshShell.LogEvent 1, errortxt
            getgarbage(tempname)
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
        
        
        fs.deletefile tempname&extension, True
        
        If Err.number<>0 Then
            Err.clear
            errortxt="bitfarm-Archiv: Archivierung: Fehler beim umkopieren JPG-Datei."	
            objWshShell.LogEvent 1, errortxt
            getgarbage(tempname)
            Unlock(programm&lockdatei)
            WScript.Quit
        End If

        
        lngReturnCode = runfilter(tempname&"-tmp"&extension,programm&"temp\jpgfilter.txt",tempname&extension)
        
        
        If lngReturnCode<>0 Then
            Err.clear
            errortxt="bitfarm-Archiv: Archivierung: Fehler beim Filtern der JPG-datei:"&lngReturnCode	
            objWshShell.LogEvent 1, errortxt
            getgarbage(tempname)
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
        WScript.Sleep 300
        If fs.fileexists(tempname&extension)=False Then
            fs.copyfile tempname&"-tmp"&extension, tempname&extension, True
            Err.clear
            errortxt="bitfarm-Archiv: Archivierung: Fehler bei JPG-Shrinking - Originaldatei wurde wiederhergestellt."	
            objWshShell.LogEvent 1, errortxt
        End If
        
        If fs.fileexists(programm&"temp\jpgfilter.txt") Then
            fs.deletefile programm&"temp\jpgfilter.txt", True
            Err.clear
            On Error Resume Next
        End If
        
        WScript.sleep 20
        
        Set dateiinfo=fs.getfile(tempname&extension)
        mysize2=dateiinfo.size
        mysize2=Int(mysize2/1000)
        WScript.sleep 20
        Set dateiinfo=Nothing
        WScript.sleep 20
        
        Err.clear
        
        If mysize2>mysize Then
            fs.deletefile tempname&extension, True
            If Err.number<>0 Then
                Err.clear
                errortxt="bitfarm-Archiv: Archivierung: Fehler beim lschen JPG-Datei(2)."	
                objWshShell.LogEvent 1, errortxt
                getgarbage(tempname)
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
            fs.copyfile tempname&"-tmp"&extension, tempname&extension, True
            If Err.number<>0 Then
                Err.clear
                errortxt="bitfarm-Archiv: Archivierung: Fehler beim lschen JPG-Datei(3)."	
                objWshShell.LogEvent 1, errortxt
                getgarbage(tempname)
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
            
        End If
        
        If fs.fileexists (tempname&"-tmp"&extension) Then
            fs.deletefile tempname&"-tmp"&extension, True
        End If
        
        
    End If
    
End Function

'************************************************************************
'************************************************************************


Function SLDPRTtoTIF(tempname)
    size=Split(SolidWorksSize,"x")
    x = size(0)
    y =size(1)
    cmd = Chr(34) & solidworksconverter & Chr(34) & " " & Chr(34) & tempname&extension & Chr(34) & " " & Chr(34) & tempname & ".tif" & Chr(34) & " " & x & " " & y
    If scriptdebug= True Then
        objWSHShell.LogEvent 0, "archivierung.vbs: Aufruf SolidWorksConverter:"&vbCrLf&cmd
    End If
    Set oExec    = objWSHShell.Exec(cmd)
    Do While Not oExec.StdOut.AtEndOfStream
        strinput = strinput & oExec.StdOut.Read(1)	
    Loop
    
    durch = False
    schleife = 0
    Do While schleife < 50
        If oExec.Status = 1 Then 
            durch = True
            Exit Do
        End If
        
        WScript.Sleep 100  
        schleife = schleife +1
    Loop
    
    If Not fs.fileexists(tempname&".tif") Then
        makefilltif(tempname)
        objWSHShell.LogEvent 1, "archivierung.vbs: es konnte keine Vorschau fr die SolidWorks-Datei erstellt werden."
    End If
    
    If Not fs.fileexists(tempname&".txt") Then
        fs.CreateTextFile tempname&".txt", True, False 
    End If	
    
End Function



Function readexif()
    On Error Resume Next
 
    If fs.fileexists(tempname&".jpg") Then
        If fs.fileexists(exifreader) Then
            ReDim lines(100)		
            
            strinput = ""
            schleife = 0
            
            Beginn = Timer
            
            Set oExec    = objWSHShell.Exec(Chr(34)&exifreader & Chr(34)&" " & Chr(34)&tempname & ".jpg"&Chr(34))
            
            Do While Not oExec.StdOut.AtEndOfStream
                strinput = strinput & oExec.StdOut.Read(1)	
            Loop
            
            durch = False
            schleife = 0
            Do While schleife < 50
                If oExec.Status = 1 Then 
                    durch = True
                    Exit Do
                End If
                
                WScript.Sleep 100  
                schleife = schleife +1
            Loop
            Ende = Timer
            
            If durch = False Then
                objWshShell.LogEvent 1, "Archivierung.vbs Function Versionierung: Schwerwiegender Fehler" & vbCrLf & "ReadInfo.exe antwortet nicht oder wird nicht beendet" & vbCrLf & "Status: " & oExec.Status & vbCrLf & "Exitcode " & oExec.ExitCode & vbCrLf & "Schleife: " & schleife
                oExec.Terminate
                returnvalue = oExec.ExitCode
            End If
            
            If oExec.ExitCode <> 0 Then
                'Fehler
                versionierung = False
                
            End If
            
            If scriptdebug=True Then
                objWshShell.LogEvent 0, "Archivierung.vbs Function Versionierung: readinfo.exe ausgefhrt" & vbCrLf & "Status: " & oExec.Status & vbCrLf & "Exitcode " & oExec.ExitCode & vbCrLf & "Schleife: " & schleife &vbCrLf& strinput
            End If
            
            '  Parser fr die Zusatzfelder
            i = 0 
            Do While InStr(1,strinput,vbCrLf)
                lines(i) = Trim(Left(strinput,InStr(1,strinput,vbCrLf)-1))
                strinput = Right(strinput,Len(strinput)-InStr(1,strinput,vbCrLf)-1)
                i =i +1      
            Loop
            
            'jetzt auslesen
            j = 0
            For i = 0 To 100
                If InStr(1,lines(i),":") And InStr(1,lines(i),"File Name")= 0 And InStr(1,lines(i),"ExifTool")= 0 And InStr(1,lines(i),"Directory")= 0 Then
                    zwischenname(j) = Trim(Left(lines(i),InStr(1,lines(i),":")-1))
                    zwischenwert(j) = Trim(Right(lines(i),Len(lines(i)) - InStr(1,lines(i),":")-1))
                    j = j + 1
                    If j = limit Then Exit For
                End If    
            Next 
                                 
            Set txt = fs.opentextfile(tempname & ".txt",8,True)
            
            For i = 0 To j -1                       
                txt.writeline zwischenname(i) & " : " & zwischenwert(i)                
            Next 
            
            txt.close
            Set txt = Nothing
                       
            For i = 0 To 100
                If InStr(1,zwischenname(i),"Date") Then
                    datum = ""
                    pattern="\d{4}.\d{2}.\d{2}"
                    Set objRE = New RegExp
                    objRE.Global     = False    ' Nur eine bereinstimmung  (die erste)
                    objRE.IgnoreCase = False
                    objRE.Pattern    = pattern
                    
                    Set colMatches = objRE.Execute(zwischenwert(i))
                    For Each objMatch In colMatches
                        datum = objMatch.Value
                        
                    Next
                    Set colMatches = Nothing
                    Set objRe = Nothing
                    
                    If datum <> "" Then
                        zwischenwert(i) = Right(datum,2) & "." & Mid(datum,6,2) & "." & Left(datum,4)
                    End If
                                     
                End If        
            Next 
                       
            ' erst Temporres Array, dann zusammenfhren bei gleichnamigen Zusatzfeldern
            
            For k = 0 To limit
                If zusatzfeldname(k) <> "" Then
                    For i = 0 To j - 1
                        If LCase(zusatzfeldname(k)) = LCase(zwischenname(i)) Then
                            If zusatzfeld(k) = "" Then
                                If zwischenwert(i)<>"" Then
                                    zusatzfeld(k) = zwischenwert(i)
                                End If
                            End If			
                        End If	
                    Next
                    
                End If
            Next
            
            ' alle anderen Daten als neue Zusatzfelder hinzufgen (fr spteres Using zB)
            
            if mapexif=True Then
                For i = 0 To j - 1
                    gefunden=False	
                    
                    For k = 0 To limit
                        If LCase(zwischenname(i)) = LCase(zusatzfeldname(k)) Then
                            gefunden = True
                            Exit For
                        End If
                    Next 	
                    
                    If gefunden  = False Then
                        
                        For l = 0 To limit
                            If zusatzfeldname(l) = "" Then
                                zusatzfeldname(l) = zwischenname(i)
                                zusatzfeld(l) = zwischenwert(i)
                                Exit For
                                
                                
                            End If
                        Next 
                    End If 
                    
                Next 
            End If
                       
        End If
    End If
     
End Function




Function checkunicodehtml(htmldatei)
    On Error Resume Next
    If fs.FileExists(htmldatei) Then
        Set htmlfile = fs.OpenTextFile(htmldatei,1)
        test = htmlfile.Read(2)
        htmlfile.Close
        Set htmlfile = Nothing
        
        If Left(test,1)  = Chr(255) And Right(test,1)= Chr(254) Then
            If scriptdebug = True Then
                objWSHShell.LogEvent 4, "archivierungr:  unicode! "
            End If 
            
            If fs.FileExists(programm&"convertunicode.bat") Then
                If scriptdebug = True Then
                    objWSHShell.LogEvent 4, "archivierung: "& programm&"convertunicode.bat " & htmldatei & " " &  htmldatei & "2"
                End If 
                
                
                lngReturnCode = objWSHShell.Run(programm&"convertunicode.bat " & htmldatei & " " &  htmldatei & "2",0,True)
                
                
                If lngReturnCode<> 0 Then
                    objWSHShell.LogEvent 1, "archivierung.vbs: Fehler bei der Unicode nach UTF8-Konvertierung. convertunicode.bat konnte nicht durchgefhrt werden" & vbCrLf & pfad & "\bfa-Mail.html"
                    
                End If
                WScript.Sleep 200
                If fs.FileExists(htmldatei & "2") Then
                    fs.DeleteFile htmldatei , True
                    If Err.Number<> 0 Then
                        objWSHShell.LogEvent 1, "archivierung.vbs: Fehler bei der Unicode nach UTF8-Konvertierung. bfa-Mail2.html konnte nicht gelscht werden" & vbCrLf & pfad&"\bfa-Mail2.html"
                        Err.Clear
                        On Error Resume Next
                    Else
                        fs.MoveFile htmldatei & "2",htmldatei
                        
                    End If
                    
                End If
            Else
                objWSHShell.LogEvent 1, "archivierung: Fehler bei der Unicode nach UTF8-Konvertierung. convertunicode.bat nicht vorhanden" & vbCrLf & programm&"convertunicode.bat"
            End If
            
        End If
        
    End If
    
    
End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************



'************************************************************************
'************************************************************************

Private Function neueworkflowdatei()
    On Error Resume Next
    
    'workflows=programm&profil&"-workflows\"
    ' wird aus der con gelesen
    
    
    erfolg = create_dir(workflows)
    
    If erfolg Then
        
        i=0
        wrkfile=workflows&"wrktxt"&i&".txt"
        flag10=False
        If fs.FileExists(wrkfile) Then
            flag10=False
        Else
            flag10=True
        End If
        
        Do While flag10=False
            i = i + 1
            wrkfile=workflows&"wrktxt"&i&".txt"
            If fs.FileExists(wrkfile) Then
                flag10=False
            Else
                flag10=True
            End If
        Loop
        
        neueworkflowdatei = i
    End If 
    
End Function


'################################################################


Function writeschlagwort(tempname)
    On Error Resume Next
    
    Err.clear
    writeschlagwort=True
    
    Dim swarray(200)
    If Err.number<>0 Then
        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Fehler beim einrichten swarray:"&Err.number
        writeschlagwort=False
    End If
    
    If writeschlagwort=True Then
        For i=0 To 199
            swarray(i)=""
        Next
    End If
    
    If writeschlagwort=True Then
        If fs.fileexists(tempname&".slw") Then
            If Not fs.fileexists(tempname&".swd") Then
                fs.movefile tempname&".slw", tempname&".swd"
            Else
                fs.deletefile tempname&".slw", True
            End If
            If Err.number<>0 Then
                objWshShell.LogEvent 2, "bitfarm-Archiv: Archivierung: writeschlagwort: Fehler 3"
                Err.clear
                On Error Resume Next
                writeschlagwort=False
            End If
        End If
    End If
    
    If writeschlagwort=True Then
        If Not fs.fileexists(tempname&".swd") Then
            Set swfile=fs.opentextfile(tempname&".swd",8,1)
            swfile.close
            Set setfile=Nothing
            WScript.sleep 50
            If Err.number<>0 Then
                objWshShell.LogEvent 2, "bitfarm-Archiv: Archivierung: writeschlagwort: Fehler 4"
                Err.clear
                On Error Resume Next
                writeschlagwort=False
            End If
        End If
    End If
    
    If writeschlagwort=True Then
        fs.movefile tempname&".swd", tempname&".slw"
        WScript.sleep 50
        If Err.number<>0 Then
            objWshShell.LogEvent 2, "bitfarm-Archiv: Archivierung: Fehler beim moven der Schlagwortdatei:"&Err.number
            Err.clear
            On Error Resume Next
            writeschlagwort=False
        End If
        If Not fs.fileexists(tempname&".slw") Then
            writeschlagwort=False
        End If
        If fs.fileexists(tempname&".swd") Then
            writeschlagwort=False
        End If
    End If
    
    If writeschlagwort=True Then
        i=0
        Set swfile=fs.OpenTextFile(tempname&".slw",1)
        Do While swfile.atendofstream=False
            swarray(i)=swfile.readline
            i=i+1
            If i>199 Then
                objWshShell.LogEvent 2, "bitfarm-Archiv: Archivierung: berlauf des Schlagwortarrays (mehr als 199 Schlagworte nicht mglich)."
                Exit Do
            End If
        Loop
        swfile.close
        Set swfile=Nothing
    End If
    
    
    
    '+++++++++++++++++++++++++++++  Zusatzfelder hinzu, falls noch nicht ++++++++++++++++++++
    
    If writeschlagwort=True Then
        For i=0 To limit
            vorhanden=True
            schlagwort=zusatzfeld(i)
            slws = Split(schlagwort,";")
            For Each schlagwort In slws
	            If schlagwort<>"" Then
	                
	                
	                For t = 0 To limit
	                    If LCase(zusatzfeldname(i)) = LCase(zusatzfeldname2(t)) Then
	                        vorhanden=False
	                        Exit For
	                        
	                    End If
	                    
	                Next
	     
	                
	                If vorhanden=False Then
	                    gefunden=False
	                    t=0
	                    Do While gefunden=False
	                        If swarray(t)="" Then
	                            gefunden=True
	                        End If
	                        If gefunden=False Then
	                            t=t+1
	                        End If
	                        If t>199 Then
	                            t=199
	                            gefunden=True
	                            objWshShell.LogEvent 2, "bitfarm-Archiv: Archivierung: berlauf des Schlagwortarrays (mehr als 199 Schlagworte nicht mglich)."
	                        End If
	                    Loop
	                    swarray(t)=schlagwort
	                End If
	            End If
	        Next
        Next
    End If
    
    '+++++++++++++++++++++++++++++  Links hinzu, falls noch nicht ++++++++++++++++++++
    
    If writeschlagwort=True Then
        For i=0 To limit
            vorhanden=False
            schlagwort=""
            If Len(linkspeicher(i))>6 Then
                If (LCase(Left(linkspeicher(i),6))<>"doclin") And (LCase(Left(linkspeicher(i),6))<>"email:") Then
                    schlagwort=linkspeicher(i)
                End If
            Else
                schlagwort=linkspeicher(i)
            End If
            If schlagwort<>"" Then
                For t=0 To 199
                    If swarray(t)=linkspeicher(i) Then
                        vorhanden=True
                    End If
                Next
            End If
            If vorhanden=False Then
                gefunden=False
                t=0
                Do While gefunden=False
                    If swarray(t)="" Then
                        gefunden=True
                    End If
                    If gefunden=False Then
                        t=t+1
                    End If
                    If t>199 Then
                        t=199
                        gefunden=True
                        objWshShell.LogEvent 2, "bitfarm-Archiv: Archivierung: berlauf des Schlagwortarrays (mehr als 199 Schlagworte nicht mglich)."
                    End If
                Loop
                swarray(t)=schlagwort
            End If
        Next
    End If
    
    
    '*+++++++++++++++++++++++++++  Schlagwortdupletten entfernen ************************
    
    If writeschlagwort=True Then
        For i=0 To 199
            schlagwort=swarray(i)
            If schlagwort<>"" Then
                
                For t=0 To 199
                    If i <> t Then
                        If swarray(t)=schlagwort Then
                            swarray(t)=""
                        End If
                    End If
                    
                Next
            End If
        Next
    End If
    
    
    '***********************************  Schlagwortdatei schreiben ********************
    
    If writeschlagwort=True Then
        Set swfile=fs.OpenTextFile(tempname&".swd",8,1)
        For i=0 To 199
            If swarray(i)<>"" Then
                swfile.writeline(swarray(i))
            End If
        Next
        swfile.close
        WScript.sleep 30
        Set swfile=Nothing
        WScript.sleep 30
        If Err.number<>0 Then
            objWshShell.LogEvent 2, "bitfarm-Archiv: Archivierung: 2a Fehler beim schreiben der Schlagwortdatei:"&Err.number
            Err.clear
            On Error Resume Next
            writeschlagwort=False
        End If
        If Not fs.fileexists(tempname&".swd") Then
            writeschlagwort=False
        End If
        
    End If
    
    '**************  aufrumen ******
    If writeschlagwort=True Then
        fs.deletefile tempname&".slw", True
        If Err.number<>0 Then
            objWshShell.LogEvent 2, "bitfarm-Archiv: Archivierung: Fehler beim lschen der Schlagwortdatei:"&Err.number
            Err.clear
            On Error Resume Next
            writeschlagwort=False
        End If
    End If
    
    
End Function


'************************************************************************
'************************************************************************

Function istschonarchiviert(Datei)
    On Error Resume Next
    
    If checksumfilename = "" Then
        checksumfilename = programm&profil&"-checksums.txt"
    End If
    
    tempdatei = ""
    fertig = False
    istschonarchiviert = False
    If ((extension=".tif") Or (extension=".ps")) And opensslpath = "" Then
        If Not fs.fileexists(Datei&".txt") Then
            fertig = True
        End If
    Else
        If Not fs.fileexists(Datei&extension) Then
            fertig = True
        End If
    End If
    
    
    If Not fs.fileexists(checksumfilename) Then
        Err.clear
        
        Set checksumfile = fs.CreateTextFile(checksumfilename, True, False)
        If Err.number<>0 Then
            Err.clear
            objWshShell.LogEvent 1, "Aussortieren doppelter Eintrge: Fehler: keine Schreibberechtigungen."&Err.number
            WScript.Quit
        End If
        checksumfile.close
        Set checksumfile=Nothing
    End If
    
    If fertig=False Then
        laenge = Len(checksumfilename)
        tempdatei = Mid(checksumfilename,1,laenge-4)&"-tmp.txt"
        
        
        
        'If handle="" Then
        If ((extension=".tif") Or (extension=".ps")) And opensslpath = "" Then
            summe = Pruefsumme(Datei&".txt")
            
        Else
            If sha1 = "" Then
                summe = Pruefsumme(Datei&extension)
                
                ' leere Summe abfangen
                If opensslpath = "" Then
                    If strconvert(summe) = 0 Then
                        summe = ""
                    End If
                End If 
                
            Else
                summe = sha1
            End If 
        End If
    End If
    
    
    
    If dublettengarbage=True Then
        If (fertig = False) And (summe<>"") Then
            
            
            Set checksumfile = fs.OpenTextFile(checksumfilename,1)
            
            If summe = "" Then
                fertig = True
                'istschonarchiviert = true
                checksumfile.close
                Set checksumfile = Nothing 
            End If
            
            
            Do While fertig = False
                If checksumfile.AtEndOfStream Then
                    fertig = True
                    checksumfile.close
                    Set checksumfile = Nothing
                Else
                    kette = checksumfile.readline
                    If kette <>"" Then
                        checksum = kette
                    Else
                        checksum = ""
                    End If
                    test1=False 
                    If checksum=summe Then
                        test1=True
                    End If
                    
                    
                    If checksum = summe Then
                        istschonarchiviert = True
                        
                        If scriptdebug = True Then
                            objWshShell.LogEvent 0, "bitfarm-Archiv: Dublette erkannt." & Datei &vbCrLf& summe
                        End If
                        
                        
                        fertig = True
                        checksumfile.close
                        Set checksumfile = Nothing
                    End If
                End If
            Loop
        End If
    End If
    
    
    If (dublettengarbage = False) And (summe<>"") Then
        fertig = False
        Err.clear
        If fs.fileexists(tempdatei) Then
            fs.DeleteFile(tempdatei)
            If Err.number<>0 Then
                Err.clear
                objWshShell.LogEvent 2, "Aussortieren doppelter Eintrge: kann tempdatei nicht lschen."&Err.number
                fertig = True
            End If
        End If
        
        If fertig = False Then
            Set newchecksumfile = fs.CreateTextFile(tempdatei, True, False)
            If Err.number<>0 Then
                Err.clear
                objWshShell.LogEvent 2, "Aussortieren doppelter Eintrge: kann keine neue datei anlegen."&Err.number
                fertig = True
            End If
        End If
        
        If fertig = False Then
            Set oldchecksumfile = fs.OpenTextFile(checksumfilename,1)
            If Err.number<>0 Then
                Err.clear
                objWshShell.LogEvent 2, "Aussortieren doppelter Eintrge: kann alte Datei nicht ffnen."&Err.number
                fertig = True
            End If
        End If
        
        If fertig = False Then
            i = 0
            kette = ""
            newchecksumfile.writeline(summe)
            flag = False
            Do While flag = False
                If oldchecksumfile.AtEndOfStream Then
                    flag = True
                Else
                    kette = oldchecksumfile.readline
                    If kette <> summe Then
                        newchecksumfile.writeline(kette)
                        i = i + 1
                    End If 
                End If
                If i >= gedaechtnis Then
                    flag = True
                End If
            Loop
            newchecksumfile.close
            oldchecksumfile.close
            Set newchecksumfile = Nothing
            Set oldchecksumfile = Nothing
            fs.DeleteFile(checksumfilename)
            If Err.number<>0 Then
                Err.clear
                objWshShell.LogEvent 2, "Aussortieren doppelter Eintrge: kann alte checksumdatei nicht lschen."&Err.number
                fertig = True
            End If
            WScript.Sleep 200
            fs.CopyFile tempdatei, checksumfilename, True
            If Err.number<>0 Then
                Err.clear
                objWshShell.LogEvent 2, "Aussortieren doppelter Eintrge: kann checksumdatei nicht kopieren"
                fertig = True    			
            End If
            fs.DeleteFile(tempdatei)
            If Err.number<>0 Then
                Err.clear
                objWshShell.LogEvent 2, "Aussortieren doppelter Eintrge: kann temporre checksumdatei nicht lschen."&Err.number
                fertig = True
            End If
        End If
    End If
    
End Function




'************************************************************************
'************************************************************************

Private Function Pruefsumme(Datei)
    On Error Resume Next
    
    If opensslpath <> "" Then
        
        If fs.FileExists(opensslpath) Then
            strinput = ""
            Set oExec = objWSHShell.Exec(Chr(34)&opensslpath & Chr(34)&" dgst -sha1 " & Chr(34)&Datei&Chr(34) )
            Do While Not oExec.StdOut.AtEndOfStream
                strinput = strinput & oExec.StdOut.ReadAll
            Loop
            
            durch = False
            schleife = 0
            Do While schleife < 50
                If oExec.Status = 1 Then 
                    durch = True
                    Exit Do
                End If
                
                WScript.Sleep 100  
                schleife = schleife +1
            Loop
            
            If durch = False Or oExec.ExitCode <> 0 Then
                objWSHShell.LogEvent 1, "Archivierung.vbs: konnte sha1 Summe nicht erzeugen" & vbCrLf & Datei & vbCrLf & strinput
            Else
                If InStr(1,strinput,"=") Then
                    Pruefsumme = Trim(Right(strinput,Len(strinput) - InStr(1,strinput,"=")))
                    Pruefsumme = Replace(Pruefsumme,vbLf,"")
                    Pruefsumme = Replace(Pruefsumme,vbCr,"")
                    If InStr(1,Pruefsumme, Chr(10)) Then
                        Pruefsumme = Replace(Pruefsumme,Chr(10),"")
                    End If 
                End If 
            End If
            
        Else
            objWSHShell.LogEvent 1, "Archivierung.vbs: konnte openssl nicht finden" & vbCrLf & opensslpath 
            Pruefsumme=""
        End If 
    Else
        
        length=32
        steps=4
        lauf=0
        ReDim chrfield(length)
        ReDim mysteps(steps)
        For x=0 To length
            chrfield(x)=0
        Next
        For x=0 To steps
            mysteps(x)=0
        Next
        
        candidate=Datei
        
        fertigflag = False
        summe = ""
        wert = 0
        i = 0
        laenge = 0
        kette = ""
        If Not fs.FileExists(candidate) Then
            fertigflag = True
        Else
            Set summendatei = fs.OpenTextFile(candidate,1)
        End If
        
        laeufer=0
        Do While fertigflag = False
            If summendatei.AtEndOfStream Then
                fertigflag = True
                summendatei.close
                Set summendatei = Nothing
            Else
                kette = summendatei.readline
                
                laenge = Len(kette) - 1
                i = 0
                Do While i<=laenge
                    mysum=0
                    For x=0 To steps
                        If (x+i)<=laenge Then
                            wert = Asc(Mid(kette,i+x+1,1))
                            
                            If (wert>64) And (wert<123) Then
                                mysum=mysum+wert
                            End If
                            If (wert>47) And (wert<58) Then
                                mysum=mysum+wert
                            End If
                            
                        End If
                    Next
                    i=i+steps
                    chrfield(laeufer)=chrfield(laeufer)+mysum
                    Do While chrfield(laeufer)>10
                        chrfield(laeufer)=chrfield(laeufer)-10
                    Loop
                    laeufer=laeufer+1
                    If laeufer=length Then
                        laeufer=0
                        lauf=lauf+1
                    End If
                Loop
                
            End If 
        Loop
        
        For x=0 To length
            summe=summe&chrfield(x)
        Next
        WScript.sleep 100
        Pruefsumme=summe
        If fs.fileexists(candidate) Then
            
            Set myadatei = fs.Getfile(candidate)
            If LCase(Right(myadatei.name,3))<>"tif" Then
                
                Pruefsumme = summe & myadatei.size
            End If
            WScript.sleep 50
            Set myadatei=Nothing
        Else
            objWshShell.LogEvent 2, "Archivierung: Fehler bei Prfsumme: Datei nicht vorhanden ("&candidate&")"
        End If
        
    End If
    
End Function




'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'****************************                Sorting                 ***********************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************


Function sorting()
    On Error Resume Next
    
    For i = 0 To limit
        txttofind(i)=""
        bctofind(i)=""
        andor(i)=0
        nosortarchiv(i)=""
        Tabelle1(i)=""
    Next
    
    sortto=""
    endflag = False
    externname=""
    sortinglesen=False
    
    If Not fs.fileexists(workflowfile) Then
        endflag = True
    End If
    '=============================
    If Not endflag = True Then
        Set wfdatei = fs.OpenTextFile(workflowfile,1)
        
        If Not wfdatei.AtEndOfStream Then
            kette=Trim(Replace(Trim(wfdatei.readline), vbTab, ""))
        Else
            endflag=True
        End If
        
        Do While endflag = False 
            naminglesen=False
            sortinglesen=False
            '--------------------------------
            If Left(kette,1)<>";" Then
                
                
                If InStr(1,kette,"settings section",1)<>0 Then
                    flag1 = False
                    mycount=0
                    
                    Do While flag1 = False 
                        If wfdatei.AtEndOfStream=False Then
                            kette = Trim(Replace(Trim(wfdatei.readline), vbTab, ""))
                        Else 
                            flag1=True
                            
                        End If
                        If Left(kette,11)="end section" Then
                            flag1 = True
                        End If
                        
                        If LCase(Left(kette,9))="nosorting" Then
                            
                            wert=GetString(kette,InStr(1,kette,"nosorting",1)+10)
                            
                            nosortarchiv(mycount)=wert
                            mycount=mycount+1
                            If mycount=limit Then
                                errortxt="bitfarm-Archiv: maximale Anzahl der nosorting-Statements berschritten."
                                objWshShell.LogEvent 1, errortxt
                                getgarbage(tempname)
                                Unlock(programm&lockdatei)
                                WScript.Quit
                            End If
                            
                        End If 
                    Loop
                    
                End If
                
                
                
                If InStr(1,kette,"sorting section",1)<>0 Then
                    sortinglesen=True
                    flag1 = False
                    tabellencount=0
                    txtfindcount = 0
                    bcfindcount=0
                    For i = 0 To limit
                        txttofind(i)=""
                        bctofind(i)=""
                        Tabelle1(i)=""
                        andor(i)=2
                    Next 
                    
                    andor(1)=2
                    sortto=""
                    symlink=""
                    
                    
                    Do While flag1 = False 
                        If wfdatei.AtEndOfStream=False Then
                            kette = Trim(Replace(Trim(wfdatei.readline), vbTab, ""))
                        Else 
                            flag1=True
                            endflag=True
                        End If
                        If Left(kette,11)="end section" Then
                            flag1 = True
                        End If
                        
                        If Left(kette,12)="orindocument" Then
                            txtfindcount=txtfindcount+1
                            wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"orindocument=",1)+12)))
                            'wert=GetString(kette,InStr(1,kette,"orindocument",1)+12)
                            txttofind(txtfindcount)=wert
                            andor(txtfindcount)=1
                            
                        End If 
                        
                        If Left(kette,13)="andindocument" Then
                            txtfindcount=txtfindcount+1
                            wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"andindocument=",1)+13)))
                            'wert=GetString(kette,InStr(1,kette,"andindocument",1)+13)
                            txttofind(txtfindcount)=wert
                            andor(txtfindcount)=2
                            
                        End If 
                        
                        If Left(kette, 7)="symlink" Then
                        	If InStr(tempname,"temp-cng")=0 Then
                        		symlink=Trim(Right(kette,Len(kette)-(InStr(1,kette,"symlink=",1)+7)))
                        	End If
                        End If
                        
                        If Left(kette,13)="notindocument" Then
                            txtfindcount=txtfindcount+1
                            wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"notindocument=",1)+13)))
                            'wert=GetString(kette,InStr(1,kette,"andindocument",1)+13)
                            txttofind(txtfindcount)=wert
                            andor(txtfindcount)=3
                            
                        End If 
                        
                        
                        If Left(kette,10)="docbarcode" Then
                            bcfindcount=bcfindcount+1
                            wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"docbarcode=",1)+10)))
                            
                            bctofind(bcfindcount)=wert
                            
                            
                        End If 
                        
                        
                        If Left(kette,13)="archivtabelle" Then 
                            tabellencount=tabellencount+1
                            wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"archivtabelle=",1)+13)))
                            'wert=GetString(kette,InStr(1,kette,"archivtabelle",1)+13)
                            Tabelle1(tabellencount)=wert
                            
                        End If 			
                        
                        If Left(kette,6)="sortto" Then
                            laenge=Len(kette)+1
                            pos1=InStr(1,kette,"sortto",1)+7
                            wert=Trim(Mid(kette,pos1,laenge-pos1))
                            sortto=wert
                            
                        End If 
                        
                        
                        
                    Loop
                Else
                    sortinglesen = False
                End If
                
                '*******************************************************************************************
                '****************************        auswertung                *****************************
                '*******************************************************************************************
                
                '+++++++++++++++++++++++	
                If sortinglesen = True Then
                    
                    zutreffendbarcode = False
                    zutreffendtxt = False
                    If andor(1) = 2 Then
                        zutreffendtxt=True
                    End If
                    
                    If andor(1) = 3 Then
                        zutreffendtxt=True
                    End If
                    
                    
                    
                    If bcfindcount > 0 Then
                        For y=0 To bcfindcount
                            For i=0 To 29
                                If barcode(i)<>"" Then
                                    If bctofind(y)<>"" Then
                                        If Left(bctofind(y),9)<> "||regex||" Then
                                            If InStr(1,barcode(i),bctofind(y),1)<>0 Then
                                                zutreffendbarcode = True                                        
                                            End If
                                        Else
                                            regex = Right(bctofind(y),Len(bctofind(y))-9)
                                            Set objRE = New RegExp
                                            objRE.Global     = False
                                            objRE.IgnoreCase = Not recasesensitive
                                            objRE.Pattern    = regex
                                            Set colMatches = objRE.Execute(barcode(i))
                                            hits = colMatches.Count
                                            If hits>0 Then
                                                zutreffendbarcode = True
                                            End If
                                        End If
                                    End If
                                End If
                            Next
                        Next
                    Else
                        zutreffendbarcode = True
                        
                    End If
                    
                    
                    'MsgBox("txtfindcount:"&txtfindcount)
                    If txtfindcount > 0 Then
                        i=1
                        Do While i <= txtfindcount
                            If Left(txttofind(i),9)<> "||regex||" Then
                                'MsgBox(workflowcount&":"&txttofind(i)&":"&Datei&":"&isintextfile(txttofind(i)))
                                If andor(i) = 1 Then
                                    zutreffendtxt = zutreffendtxt Or isintextfile(txttofind(i))
                                    'MsgBox(i&":"&txtfindcount&":1:"&zutreffendtxt&":"&txttofind(i))
                                ElseIf andor(i)=2 Then
                                    zutreffendtxt = zutreffendtxt And isintextfile(txttofind(i))
                                    'MsgBox(i&":"&txtfindcount&":2:"&zutreffendtxt&":"&txttofind(i))
                                Else
                                    zutreffendtxt = zutreffendtxt And Not isintextfile(txttofind(i))
                                End If
                            Else
                                reg = Right(txttofind(i), Len(txttofind(i)) - 9)
                                If andor(i) = 1 Then
                                    zutreffendtxt = zutreffendtxt Or regintextfile(reg)
                                    'MsgBox(i&":"&txtfindcount&":1:"&zutreffendtxt&":"&txttofind(i))
                                ElseIf andor(i)=2 Then
                                    zutreffendtxt = zutreffendtxt And regintextfile(reg)
                                    'MsgBox(i&":"&txtfindcount&":2:"&zutreffendtxt&":"&txttofind(i))
                                Else
                                    zutreffendtxt = zutreffendtxt And Not regintextfile(reg)
                                End If
                                
                            End If
                            
                            i=i+1
                        Loop
                    Else
                        zutreffendtxt=True
                    End If
                    
                    zutreffendtabelle=False
                    If tabellencount=0 Then
                        zutreffendtabelle=True
                    Else
                        i=1
                        Do While i <= tabellencount
                            
                            
                            Archiv=Tabelle
                            resulttablelenght=0
                            resulttable=""	
                            '###########  Fallunterscheidung * davor / dahinter / beides / keins #########
                            
                            If Left(tabelle1(i),1)="*" Then
                                If (Right(tabelle1(i),1)="*") And (Len(tabelle1(i))>2) Then '### beides ###
                                    
                                    resulttable=Right(tabelle1(i),Len(tabelle1(i)-1))
                                    resulttable=Left(resulttable,Len(resulttable-1))
                                    If Len(archiv)>=Len(resulttable) Then
                                        If InStr(1,Archiv,resulttable,1)<>0 Then
                                            zutreffendtabelle = True
                                            If scriptdebug = True Then
                                                objWshShell.LogEvent 4, "Fall1 zutreffend: Suchstring: "&tabelle1(i)&" Archiv: "&Archiv
                                            End If
                                        End If
                                    End If
                                    
                                Else '### davor ###
                                    
                                    resulttable=Right(tabelle1(i),Len(tabelle1(i))-1)
                                    resulttablelenght=Len(resulttable)
                                    If Len(Archiv)>resulttablelenght Then
                                        If LCase(resulttable)=LCase(Right(Archiv,resulttablelenght)) Then
                                            zutreffendtabelle = True
                                            If scriptdebug = True Then
                                                objWshShell.LogEvent 4, "Fall2a zutreffend: Suchstring: "&tabelle1(i)&" Archiv: "&Archiv
                                            End If
                                        End If
                                    ElseIf Len(Archiv)=resulttablelenght Then
                                        If LCase(resulttable)=LCase(Archiv) Then
                                            zutreffendtabelle = True
                                            If scriptdebug = True Then
                                                objWshShell.LogEvent 4, "Fall2b zutreffend: Suchstring: "&tabelle1(i)&" Archiv: "&Archiv
                                            End If
                                        End If
                                    End If
                                    
                                End If
                                
                                
                                
                            ElseIf Right(tabelle1(i),1)="*" Then '### dahinter ###
                                resulttable=Left(tabelle1(i),Len(tabelle1(i))-1)
                                resulttablelenght=Len(resulttable)
                                If Len(Archiv)>resulttablelenght Then
                                    If LCase(resulttable)=LCase(Left(Archiv,resulttablelenght)) Then
                                        zutreffendtabelle = True
                                        If scriptdebug = True Then
                                            objWshShell.LogEvent 4, "Fall3a zutreffend: Suchstring: "&tabelle1(i)&" Archiv: "&Archiv
                                        End If
                                    End If
                                ElseIf Len(Archiv)=resulttablelenght Then
                                    If LCase(resulttable)=LCase(Archiv) Then
                                        zutreffendtabelle = True
                                        If scriptdebug = True Then
                                            objWshShell.LogEvent 4, "Fall3b zutreffend: Suchstring: "&tabelle1(i)&" Archiv: "&Archiv
                                        End If			
                                    End If
                                End If
                                
                                
                            Else	'### keins ###
                                
                                
                                If LCase(tabelle1(i))=LCase(Archiv) Or tabelle1(i) = folderID Then
                                    zutreffendtabelle = True
                                    If scriptdebug = True Then
                                        objWshShell.LogEvent 4, "Fall4 zutreffend: Suchstring: "&tabelle1(i)&" Archiv: "&Archiv
                                    End If
                                End If
                                
                            End If	
                            
                            '###########################################################################
                            
                            i=i+1
                        Loop
                    End If
                    
                    
               
                    
                    For i=0 To limit 
                        If LCase(tabelle)=LCase(nosortarchiv(i)) Then
                            sortto=""
                        End If
                    Next
                    
                    ' symlinks anlegen
                    If (zutreffendbarcode = True) And (zutreffendtxt = True) And (zutreffendtabelle=True) And (symlink<>"") Then
                    	' read arcids from templates
                    	sym_arcids = get_arcids_fromtemplate(symlink)
                    	' add the arcids to symlinks
                    	For Each symid In sym_arcids
                    		If symid<>"" Then
                    			If Not IsInArray(symid, symlinks) Then
                    				symlinks(symlinkcounter)=symid
                    				symlinkcounter = symlinkcounter + 1
                    			End If
                    		End If
                    	Next
                    End If
                    
                    If (zutreffendbarcode = True) And (zutreffendtxt = True) And (zutreffendtabelle=True) And (sortto<>"") Then
                        
                        If scriptdebug = True Then
                            For i = 1 To txtfindcount
                                If andor(i) = 1 Then
                                    strtext = strtext & "OR:" & txttofind(i) &vbCrLf
                                ElseIf andor(i) = 2 Then
                                    strtext = strtext & "AND:" & txttofind(i) &vbCrLf
                                Else
                                    strtext = strtext & "NOT:" & txttofind(i) &vbCrLf
                                End If		
                            Next 
                            objWshShell.LogEvent 4, "Archivierung.vbs: sorting wird ausgefhrt nach:"&sortto& vbCrLf & strtext 
                        End If
                        
                        ' ************************************************

                        copyto=""
                        If InStr(sortto,";") <> 0 Then
                            tempstr = sortto
                            sortto = Left(tempstr,InStr(tempstr,";")-1)
                            copyto = Right(tempstr,Len(tempstr)-InStr(tempstr,";"))
                        End If
                        If copyto<>"" Then
                            createcopy(copyto)
                        End If
                        ' ************************************************
                        
                        newtable=getnewtable(sortto)
                        endflag=True
                        If (newtable<>"") And (newtable<>tabelle) Then
                            erfolg=changetemplate(sortto)
                            If erfolg=False Then
                                Err.clear
                                errortxt="bitfarm-Archiv: changetemplate(sortierung) meldet Fehler."
                                objWshShell.LogEvent 1, errortxt
                                getgarbage(tempname)
                                Unlock(programm&lockdatei)
                                WScript.Quit
                            End If
                        End If
                    End If
                    '####################	
                    
                    
                End If
                '+++++++++++++++++++++++
            End If
            '----------------------
            
            
            If wfdatei.AtEndOfStream <> True Then
                kette = Trim(Replace(Trim(wfdatei.readline), vbTab, ""))
            Else
                endflag = True
            End If
        Loop
    End If
    '=============================
    
End Function



'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'****************************             redirect_Attachments       ***********************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

Function redirect_Attachments
    On Error Resume Next
    
    If (attachmentarchiv<>"") And (fromEMail=True) And (extension<>".eml") And (extension<>".msg") Then
        For i=0 To limit 
            If LCase(tabelle)=LCase(nosortarchiv(i)) Then
                attachmentarchiv=""
            End If
        Next
        
        If attachmentarchiv<>"" Then
            
            If scriptdebug = True Then
                objWshShell.LogEvent 4, "Archivierung.vbs: redirect_Attachments wird ausgefhrt von "&tabelle&" nach "&attachmentarchiv 
            End If
            newtable=getnewtable(attachmentarchiv)
            
            If (newtable<>"") And (newtable<>tabelle) Then
                erfolg=changetemplate(attachmentarchiv)
                If erfolg=False Then
                    Err.clear
                    errortxt="bitfarm-Archiv: changetemplate(redirect_Attachments) meldet Fehler."
                    objWshShell.LogEvent 1, errortxt
                    getgarbage(tempname)
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If
                
            End If
        End If
    End If
    
End Function



'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'****************************                USE-Anweisungen         ***********************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************


Function using()
    On Error Resume Next
    arrayoverflow = False
    If Not fs.fileexists(workflowfile) Then
        endflag = True
    End If
    '=============================
    If Not endflag = True Then '##################
        Set wfdatei = fs.OpenTextFile(workflowfile,1)
        
        If Not wfdatei.AtEndOfStream Then
            kette=Trim(Replace(Trim(wfdatei.readline), vbTab, ""))
        Else
            endflag=True
        End If
        
        Do While endflag = False '****************
            
            If Left(kette,1)<>";" Then '+++++++++++++++++++++
                
                
                If InStr(1,kette,"settings section",1)<>0 Then '~~~~~~~~~~~~~~
                    flag1 = False
                    mycount=0
                    
                    Do While flag1 = False '00000000000000
                        If wfdatei.AtEndOfStream=False Then
                            kette = Trim(Replace(Trim(wfdatei.readline), vbTab, ""))
                        Else 
                            flag1=True
                            
                        End If
                        If Left(kette,11)="end section" Then
                            flag1 = True
                            endflag=True
                        End If
                        
                        If Left(kette,4)="USE " Then '9999999999999
                            variable=""
                            feld=""
                            wert=kette
                            pos1=1
                            laenge=Len(wert)
                            pos2=pos1
                            abbruch=False
                            gefunden=False
                            Do While gefunden=False
                                If Mid(wert,pos1,1)="[" Then
                                    gefunden=True
                                Else
                                    pos1=pos1+1
                                End If
                                If (pos1=laenge) And (gefunden=False) Then
                                    gefunden=True
                                    abbruch=True
                                End If
                            Loop
                            
                            If abbruch=False Then
                                pos2=pos1
                                gefunden=False
                                Do While gefunden=False
                                    If Mid(wert,pos2,1)="]" Then
                                        gefunden=True
                                    Else
                                        pos2=pos2+1
                                    End If
                                    If (pos2=laenge) And (gefunden=False) Then
                                        gefunden=True
                                        abbruch=True
                                    End If
                                Loop
                                If (abbruch=False) And (pos2>pos1) Then
                                    variable=Mid(wert,pos1+1,pos2-pos1-1)
                                End If
                            End If
                            
                            If variable<>"" Then '88888888888888
                                pos1=pos2
                                
                                abbruch=False
                                gefunden=False
                                Do While gefunden=False
                                    If Mid(wert,pos1,1)="%" Then
                                        gefunden=True
                                    Else
                                        pos1=pos1+1
                                    End If
                                    If (pos1=laenge) And (gefunden=False) Then
                                        gefunden=True
                                        abbruch=True
                                    End If
                                Loop
                                
                                If abbruch=False Then
                                    pos2=pos1+1
                                    gefunden=False
                                    Do While gefunden=False
                                        If Mid(wert,pos2,1)="%" Then
                                            gefunden=True
                                        Else
                                            pos2=pos2+1
                                        End If
                                        If (pos2>laenge) And (gefunden=False) Then
                                            gefunden=True
                                            abbruch=True
                                        End If
                                    Loop
                                    If (abbruch=False) And (pos2>pos1) Then
                                        feld=Mid(wert,pos1+1,pos2-pos1-1)
                                    End If
                                    
                                End If
                                If feld="" Then
                                    variable=""
                                End If
                            End If '8888888888888888
                            
                            
                            If (LCase(variable)="groesse") And (groesse<>"") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=groesse
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=groesse
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                            End If		
                            
                            
                            If (LCase(variable)="extension") And (extension<>"") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=UCase(Right(extension,Len(extension)-1))
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=UCase(Right(extension,Len(extension)-1))
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                            End If		
                            
                            
                            If (LCase(variable)="autor") And (autor<>"") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=autor
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=autor
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                            End If		
                            
                            
                            If (LCase(variable)="titel") And (titel<>"") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=titel
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=titel
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                            End If		
                            
                            
                            If (LCase(variable)="richtung") And (richtung<>"") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=richtung
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=richtung
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                            End If		
                            
                            If (LCase(variable)="herkunft") And (herkunft<>"") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=herkunft
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=herkunft
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                            End If		
                            
                            If (LCase(variable)="betreff") And (betreff<>"") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=betreff
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=betreff
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                                
                                If LCase(feld)="dokname" Then
                                    
                                    If myname="" Or myname = "Dokument" Then
                                        myname= betreff
                                    End If
                                End If
                            End If
                            
                            If (LCase(variable)="absender") And (absender<>"") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=absender
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=absender
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                            End If
                            
                            If (LCase(variable)="absenderadresse") And (absenderadresse<>"") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=absenderadresse
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=absenderadresse
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                            End If				
                            
                            If (LCase(variable)="empfaenger") And (empfaenger<>"") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=empfaenger
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=empfaenger
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                            End If				
                            
                            If (LCase(variable)="empfangsdatum") And (empfangsdatum<>"") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=empfangsdatum
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=empfangsdatum
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                            End If				
                            
                            If (LCase(variable)="empfangsuhrzeit") And (empfangsuhrzeit<>"") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=empfangsuhrzeit
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=empfangsuhrzeit
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                            End If				
                            
                            If (LCase(variable)="versanddatum") And (versanddatum<>"") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=versanddatum
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=versanddatum
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                            End If				
                            
                            If (LCase(variable)="versanduhrzeit") And (versanduhrzeit<>"") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=versanduhrzeit
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=versanduhrzeit
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                            End If				
                            
                            If (LCase(variable)="cc") And (cc<>"") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=cc
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=cc
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                            End If				
                            
                            If (LCase(variable)="bcc") And (bcc<>"") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=bcc
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=bcc
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                            End If				
                            
                            If (LCase(variable)="faxnummer") And (Faxnummer<>"") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=Faxnummer
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=Faxnummer
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                                If LCase(feld)="dokname" Then
                                    If ((LCase(myname)="dokument") Or (myname="")) And (Len(faxnummer)>0) Then
                                        myname=faxnummer
                                    End If
                                End If
                                
                                
                            End If
                            
                            If (LCase(variable)="fax") And (fax<>"") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=fax
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=fax
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                                If LCase(feld)="dokname" Then
                                    If ((LCase(myname)="dokument") Or (myname="")) And (Len(fax)>0) Then
                                        myname=fax
                                    End If
                                End If
                            End If
                            
                            If (LCase(variable)="kategorie") And (kategorie<>"") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=kategorie
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=kategorie
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                            End If				
                            
                            
                            If (LCase(variable)="docversion") And (docversion<>"") Then
                                gefunden=False
                                
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=docversion
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=docversion
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                            End If					
                            
                            
                            If (LCase(variable)="doclink") And (doclink<>"") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=doclink
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=doclink
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                            End If												
                            
                            If (LCase(variable)="dateidatum") And (dokdate<>"") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            Set tmporifile = fs.getfile(tempname&extension)
                                            zusatzfeld(x) = Left(tmporifile.DateLastModified,10)
                                            Set tmporifile = Nothing
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        Set tmporifile = fs.getfile(tempname&extension)
                                        zusatzfeld(x) = Left(tmporifile.DateLastModified,10)
                                        Set tmporifile = Nothing
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                            End If	
                            
                            If (LCase(variable)="benutzer") And (username<>"") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=username
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=username
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                            End If																		
                            
                            If (LCase(variable)="tabelle") And (tabelle<>"") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=tabelle
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=tabelle
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                    End If
                                Loop
                            End If	
                            
                            If (LCase(variable)="originaldatei") Then
                                gefunden=False
                                For x=0 To limit
                                    If LCase(zusatzfeldname(x))=LCase(feld) Then
                                        If zusatzfeld(x)="" Then
                                            zusatzfeld(x)=originaldatei
                                        End If
                                        gefunden=True
                                    End If
                                Next
                                x=0
                                Do While gefunden=False
                                    If zusatzfeldname(x)="" Then
                                        gefunden=True
                                        zusatzfeldname(x)=feld
                                        zusatzfeld(x)=originaldatei
                                    Else
                                        x=x+1
                                    End If
                                    If x=limit Then
                                        gefunden=True
                                        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                        arrayoverflow = True
                                    End If
                                Loop
                                
                                If LCase(feld)="dokname" Then
                                    
                                    If ((LCase(myname)="dokument") Or (myname="")) And (Len(originaldatei)>0) Then
                                        If dontnormdokname = False Then
                                            myname=normzusatzfeld(originaldatei)
                                        Else
                                            myname = originaldatei
                                        End If 
                                        
                                    End If
                                    
                                End If
                            End If
                            
                            '#####################################  alle Zusatzfelder durchgehen  ########################
                            
                            For d=0 To limit
                                If (LCase(feld)=LCase(zusatzfeldname(d))) And (zusatzfeld(d)<>"") Then
                                    gefunden=False
                                    For x=0 To limit
                                        If LCase(zusatzfeldname(x))=LCase(feld) Then
                                            If zusatzfeld(x)="" Then
                                                zusatzfeld(x)=zusatzfeld(d)
                                            End If
                                            gefunden=True
                                        End If
                                    Next
                                    x=0
                                    Do While gefunden=False
                                        If zusatzfeldname(x)="" Then
                                            gefunden=True
                                            zusatzfeldname(x)=feld
                                            zusatzfeld(x)=zusatzfeld(d)
                                        Else
                                            x=x+1
                                        End If
                                        If x=limit Then
                                            gefunden=True
                                            objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Arrayberlauf bei USE Statements"
                                            arrayoverflow = True
                                        End If
                                    Loop
                                    
                                    If LCase(feld)="dokname" Then
                                        If ((LCase(myname)="dokument") Or (myname="")) And (Len(zusatzfeld(d))>0) Then
                                            myname=normstring(zusatzfeld(d))
                                        End If
                                    End If				
                                    
                                End If		
                            Next		
                            
                            
                        End If '99999999999999
                    Loop '000000000000000
                    
                End If  '~~~~~~~~~~~~~~
                
            End If '++++++++++++++++++++++++
            
            
            If wfdatei.AtEndOfStream <> True Then
                kette = Trim(Replace(Trim(wfdatei.readline), vbTab, ""))
            Else
                endflag = True
            End If
        Loop '***********************
        
        wfdatei.close
        Set wfdatei = Nothing
        
    End If '#######################
    If arrayoverflow=True Then
    	zusdebug = "archivierung.vbs Arrayberlauf bei USE Statements. Zusatzfelder Zusammenfassung:" & vbCrLf
    	For x = 0 To limit
    		zusdebug=zusdebug & x & " " & zusatzfeldname(x) & ": " & zusatzfeld(x) & vbcrlf
    	Next
    	objWSHShell.LogEvent 4, zusdebug
    End If
    
End Function





'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'****************************                Naming                  ***********************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

Function naming()
    On Error Resume Next
    
    For i = 0 To limit
    	xpaths(i)=""
		xpathfields(i)=""
        email(i)=""
        txttofind(i)=""
        bctofind(i)=""
        andor(i)=0
        Tabelle1(i)=""
        searchstring(i)=""
        patterngroup(i)=""
        cutstringleft(i)=0
        cutstringright(i)=0
        getmidstring(i,1)=0
        getmidstring(i,2)=0
        replacestring(i,1)=""
        replacestring(i,2)=""
        searchsteps(i)=""
        searchdirection(i)=""
        searchflag(i)=0
        readpositions(i)=""
        deletespaces(i)=1
        deletedashes(i)=1
        buildlink(i)=""
        numeric(i)=False
        continue(i)=False
        alphabetic(i)=False
        interval(i)=False
        value(i)=False
        istdatum(i)=False
        autodatum(i)=False
        usdatum(i)=False
        linkflag(i)=0
        getnextstrings(i)=0
        charlimit(i)=255
        exclude(i)=""

        
    Next
    
    For x=0 To 9
        fixvalues(x)=""
        fixvaluenames(x)=""
    Next
    
    For x=0 To 5
        maxvalues(x)=""
    Next
    
    maxvalue=""
    fixvalue=""
    rotate=""
    'sqlmappertempcounter=0
    docrotation=""
    endflag = False
    externname=""
    naminglesen=False
    naming="Dokument"
    If Not fs.fileexists(workflowfile) Then
        endflag = True
    End If
    '=============================
    If Not endflag = True Then
        Set wfdatei = fs.OpenTextFile(workflowfile,1)
        If scriptdebug=True Then
            objWSHShell.LogEvent 1, "archivierung.vbs debug workflowfile: " & workflowfile
        End If
        If Not wfdatei.AtEndOfStream Then
            kette=Trim(Replace(Trim(wfdatei.readline), vbTab, ""))
        Else
            endflag=True
        End If
        
        Do While endflag = False 
            
            naminglesen=False
            '--------------------------------
            If Left(kette,1)<>";" Then
                If InStr(1,kette,"naming section",1)<>0 Then
                	If namingdebug=True Then
                		objWSHShell.LogEvent 0, "archivierung.vbs debug parse naming section:" &vbcrlf& kette
						log_zusatzfelder()
                	End If
                    For i = 0 To limit
                        Zwischenwert(i)=""
                        Zwischenname(i)=""
                        continuezusatzfeld(i)=""
                        continuezusatzfeldname(i)=""
                        buildlink(i)=""
                        searchstring(i)=""
                        patterngroup(i)=""
                        cutstringleft(i)=0
                        cutstringright(i)=0
                        getmidstring(i,1)=0
                        getmidstring(i,2)=0
                        replacestring(i,1)=""
                        replacestring(i,2)=""
                        txttofind(i)=""
                        operator(i) = ""
                        operant(i) = ""
                        casezusatzfeldname(i)=""
                        exclude(i)=""
                        ' sqlmappersections(i)=""
                        If resetnamingdefaults=True Then
                          deletespaces(i)=1
                          deletedashes(i)=1
                          numeric(i)=false
	                      istdatum(i)=False
	                      usdatum(i)=False
	                      autodatum(i)=False
                        End If
                    Next
                    
                    For i=0 To 9
                        fixvalues(i)=""
                        fixvaluenames(i)=""
                    Next	
                    For i=0 To 5
                        maxvalues(i)=""
                    Next	
                    naminglesen=True
                    makepdf=False
                    overridecheck=False
                    workflowcount=workflowcount+1
                    flag1 = False
                    tabellencount=0
                    emailcount = 0
                    txtfindcount = 0
                    xpathcount = 0
                    txttofind(1)=""
                    bctofind(1)=""
                    bcfindcount=0
                    Tabelle1(1)=""
                    andor(1)=2
                    bodytxt = ""
                    headertxt = ""
                    setworkflow=""
                    displayname=""
                    myform=""
                    mymask=""
                    mybarcode=""
                    mybctype=""
                    mydocname=""
                    searchstringcount = 0
                    casecount = 0
                    buildcount = 0
                    searchdirection(0)=""
                    getnextstrings(0)=0
                    charlimit(0)=255
                    searchsteps(0)=""
                    searchstring(0)=""
                    masklinkflag=0
                    usemask=True
                    flagleft=False
                    flagright=False
                    deletemaskspaces=1
                    deletemaskdashes=1
                    deletemaskdots=1
                    getallmaskstrings=0
                    masknumeric=0
                    maskalphabetic=0
                    maskvalue=0
                    maskdate=0
                    maskinterval=0
                    readbarcodes1=False
                    rotate=""
                    fixvalue=""
                    maxvalue=""
                    makevcard=False
                    exitnaming=False
                    xpath = ""
                    htmltemplate = ""
                    pdf_xml_extract = False
                    
                    Do While flag1 = False 
                        If wfdatei.AtEndOfStream=False Then
                            kette = Trim(Replace(Trim(wfdatei.readline), vbTab, ""))
                        Else 
                            flag1=True
                            endflag=True
                        End If
                        If Left(kette,11)="end section" Then
                            flag1 = True
                            
                        End If
                        
                        If Left(kette, 15)="pdf_xml_extract" Then
                        	pdf_xml_extract = True
                        End If
                        
                        
                        If Left(kette,12)="orindocument" Then
                            txtfindcount=txtfindcount+1
                            wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"orindocument=",1)+12)))
                            'wert=GetString(kette,InStr(1,kette,"orindocument",1)+12)
                            txttofind(txtfindcount)=Trim(wert)
                            andor(txtfindcount)=1
                            
                        End If 
                        
                        ' If Left(kette,10)="sqlmapper=" Then
                            ' wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"sqlmapper=",1)+9)))
                            ' sqlmappersections(sqlmappertempcounter)=Trim(wert)
                            ' sqlmappertempcounter=sqlmappertempcounter+1
                        ' End If 
                        
                    	If Left(kette, 6)="xpath=" Then
                    		wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"xpath=",1)+5)))
                    		'objWSHShell.LogEvent 1, "archivierung.vbs debug xpath found " & wert
                    		xpath = wert
                        	xpaths(xpathcount)=wert
                        End If
                        
                        If Left(kette, 13)="htmltemplate=" Then
                    		wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"htmltemplate=",1)+12)))
                    		'objWSHShell.LogEvent 1, "archivierung.vbs debug htmltemplate found " & htmltemplate
                    		htmltemplate = wert
                        End If
                        
                        
                        If Left(kette,8)="exclude=" Then
                            wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"exclude=",1)+7)))
                            exclude(searchstringcount)=Trim(wert)
                        End If 
                        
                        If Left(kette,13)="andindocument" Then
                            txtfindcount=txtfindcount+1
                            wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"andindocument=",1)+13)))
                            'wert=GetString(kette,InStr(1,kette,"andindocument",1)+13)
                            txttofind(txtfindcount)=Trim(wert)
                            andor(txtfindcount)=2
                            
                        End If 
                        
                        
                        If Left(kette,13)="notindocument" Then
                            txtfindcount=txtfindcount+1
                            wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"notindocument=",1)+13)))
                            'wert=GetString(kette,InStr(1,kette,"andindocument",1)+13)
                            txttofind(txtfindcount)=Trim(wert)
                            andor(txtfindcount)=3
                            
                        End If 
                        
                        
                        If Left(kette,10)="docbarcode" Then
                            bcfindcount=bcfindcount+1
                            wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"docbarcode=",1)+10)))
                            'wert=GetString(kette,InStr(1,kette,"andindocument",1)+13)
                            bctofind(bcfindcount)=Trim(wert)
                            
                            
                        End If 
                        
                        If Left(kette,13)="archivtabelle" Then 
                            tabellencount=tabellencount+1
                            wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"archivtabelle=",1)+13)))
                            'wert=GetString(kette,InStr(1,kette,"archivtabelle",1)+13)
                            Tabelle1(tabellencount)=Trim(wert)
                            
                        End If 	
                        
                        
                        If Left(kette,11)="displayname" Then
                            If myname="" Or myname="Dokument" Then
                                laenge=Len(kette)+1
                                pos1=InStr(1,kette,"displayname",1)+12
                                wert=Trim(Mid(kette,pos1,laenge-pos1))
                                mydocname=wert
                            End If
                        End If 
                        
                        
                        If InStr(1,kette,"readbarcodes",1)<>0 Then
                            readbarcodes1 = True
                        End If
                        
                        
                        If Left(kette,8)="rotation" Then
                            wert=GetString(kette,InStr(1,kette,"rotation",1)+9)
                            rotate=wert
                        End If 
                        
                        If Left(kette,4)="form" Then
                            wert=GetString(kette,InStr(1,kette,"form",1)+4)
                            If Len(wert)>1 Then
                                myform=wert
                            End If
                        End If 
                        
                        If Left(kette,4)="mask" Then
                            wert=GetString(kette,InStr(1,kette,"mask",1)+4)
                            mymask=wert
                            searchstringcount=searchstringcount+1
                            searchstring(searchstringcount)=Trim(wert)
                            searchflag(searchstringcount)=0
                            linkflag(searchstringcount)=0
                            getnextstrings(searchstringcount)=0
                            numeric(searchstringcount)=False
                            continue(searchstringcount)=False
                            alphabetic(searchstringcount)=False
                            value(searchstringcount)=False
                            istdatum(searchstringcount)=False
                            autodatum(searchstringcount)=False
                            charlimit(searchstringcount)=""
                            usemask=True
                            'usemask=false
                            fixvalue=""
                            maxvalue=""
                        End If 
                        
                        If Left(kette,7)="barcode" Then
                            wert=GetString(kette,InStr(1,kette,"barcode",1)+7)
                            mybarcode=wert
                        End If 
                        
                        If Left(kette,6)="bctype" Then
                            wert=GetString(kette,InStr(1,kette,"bctype",1)+6)
                            mybctype=wert
                        End If 
                        
                        If Left(kette,7)="makepdf" Then
                            wert=LCase(GetString(kette,InStr(1,kette,"makepdf",1)+7))
                            If wert="true" Then
                                makepdf=True
                            End If
                        End If 
                        
                        If Left(kette,9)="makevcard" Then
                            makevcard=True
                        End If 
                        
                        
                        
                        If Left(kette,12)="searchstring" Then
                            laenge=Len(kette)+1
                            
                            wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"searchstring=",1)+12)))
                            searchstringcount=searchstringcount+1
                            searchstring(searchstringcount)=wert
                            searchflag(searchstringcount)=0
                            linkflag(searchstringcount)=0
                            getnextstrings(searchstringcount)=0
                            numeric(searchstringcount)=False
                            continue(searchstringcount)=False
                            alphabetic(searchstringcount)=False
                            value(searchstringcount)=False
                            istdatum(searchstringcount)=False
                            autodatum(searchstringcount)=False
                            charlimit(searchstringcount)=""
                            usemask=False
                            fixvalue=""
                            maxvalue=""
                        End If 
                        
                        
                        
                        
                        If Left(kette,13)="searchbarcode" Then
                            laenge=Len(kette)+1
                            
                            wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"searchbarcode=",1)+13)))
                            searchstringcount=searchstringcount+1
                            searchstring(searchstringcount)=wert
                            searchflag(searchstringcount)=2
                            linkflag(searchstringcount)=0
                            getnextstrings(searchstringcount)=0
                            numeric(searchstringcount)=False
                            continue(searchstringcount)=False
                            alphabetic(searchstringcount)=False
                            value(searchstringcount)=False
                            istdatum(searchstringcount)=False
                            autodatum(searchstringcount)=False
                            charlimit(searchstringcount)=""
                            usemask=False
                            fixvalue=""
                            maxvalue=""
                        End If 
                        
                        
                        
                        If Left(kette,12)="externstring" Then
                            laenge=Len(kette)+1
                            wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"externstring=",1)+12)))
                            'wert=GetString(kette,InStr(1,kette,"externstring",1)+12)
                            searchstringcount=searchstringcount+1
                            searchstring(searchstringcount)=Trim(wert)
                            searchflag(searchstringcount)=1
                            linkflag(searchstringcount)=0
                            getnextstrings(searchstringcount)=0
                            numeric(searchstringcount)=False
                            continue(searchstringcount)=False
                            alphabetic(searchstringcount)=False
                            value(searchstringcount)=False
                            istdatum(searchstringcount)=False
                            autodatum(searchstringcount)=False
                            charlimit(searchstringcount)=""
                            usemask=False
                            fixvalue=""
                            maxvalue=""
                        End If 
                        
                        
                        If Left(kette,13)="searchpattern" Then
                            laenge=Len(kette)+1
                            'wert=GetString(kette,InStr(1,kette,"searchstring",1)+12)
                            wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"searchpattern=",1)+13)))
                            searchstringcount=searchstringcount+1
                            searchstring(searchstringcount)=wert
                            searchflag(searchstringcount)=3
                            linkflag(searchstringcount)=0
                            getnextstrings(searchstringcount)=0
                            numeric(searchstringcount)=False
                            continue(searchstringcount)=False
                            alphabetic(searchstringcount)=False
                            value(searchstringcount)=False
                            istdatum(searchstringcount)=False
                            autodatum(searchstringcount)=False
                            charlimit(searchstringcount)=""
                            usemask=False
                            fixvalue=""
                            maxvalue=""
                        End If 
                        
                        If Left(kette,12)="searchxpath=" Then
                            laenge=Len(kette)+1
                            'wert=GetString(kette,InStr(1,kette,"searchstring",1)+12)
                            
                            wert= Trim(Right(kette,Len(kette)-InStr(1,kette,"=")))
                            searchstringcount=searchstringcount+1
                            searchstring(searchstringcount)=wert
                            searchflag(searchstringcount)=4
                            linkflag(searchstringcount)=0
                            getnextstrings(searchstringcount)=0
                            numeric(searchstringcount)=False
                            continue(searchstringcount)=False
                            alphabetic(searchstringcount)=False
                            value(searchstringcount)=False
                            istdatum(searchstringcount)=False
                            autodatum(searchstringcount)=False
                            charlimit(searchstringcount)=""
                            usemask=False
                            fixvalue=""
                            maxvalue=""
                        End If 
                        
                        If Left(kette, 12)="patterngroup" Then
                        	wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"searchpattern=",1)+13)))
                        	patterngroup(searchstringcount)=wert
                        End If
                        
                        
                        If Left(LCase(kette),4)="case" Then
                            casecount=casecount+1
                            laenge=Len(kette)
                            pos1=0
                            zw_kette=Trim(Right(kette,Len(kette)-4))
                            
                            If InStr(1,zw_kette,"=") Then
                                pos1=InStr(1,zw_kette,"=")
                                operator(casecount)="="
                            End If
                            
                            If InStr(1,zw_kette,"#") Then
                                pos1=InStr(1,zw_kette,"#")
                                operator(casecount)="#"
                            End If
                            
                            If InStr(1,zw_kette,">") Then
                                pos1=InStr(1,zw_kette,">")
                                operator(casecount)=">"
                            End If
                            
                            If InStr(1,zw_kette,"<") Then
                                pos1=InStr(1,zw_kette,"<")
                                operator(casecount)="<"
                            End If
                            
                            If InStr(1,zw_kette,"~") Then
                                pos1=InStr(1,zw_kette,"~")
                                operator(casecount)="~"
                            End If
                            
                            casezusatzfeldname(casecount)=Trim(Left(zw_kette,pos1-1))
                            operant(casecount)=Trim(Right(zw_kette,Len(zw_kette)-pos1))
                            
                            If (operator(casecount)<>">") And (operator(casecount)<>"=") And (operator(casecount)<>"<") And (operator(casecount)<>"#" And (operator(casecount)<>"~")) Then
                                operant(casecount)=""
                                operator(casecount)=""
                                casezusatzfeldname(casecount)=""
                                casecount=casecount-1
                            End If
                            
                        End If	
                        
                        If Left(kette,13)="readpositions" Then
                            wert=GetString(kette,InStr(1,kette,"readpositions",1)+13)
                            readpositions(searchstringcount)=wert
                        End If 
                        
                        If Left(kette,14)="nodeletespaces" Then
                            deletespaces(searchstringcount)=0
                            If usemask=True Then
                                deletemaskspaces=0
                            End If
                        End If 
                        
                        If Left(kette,14)="nodeletedashes" Then
                            deletedashes(searchstringcount)=0
                            If usemask=True Then
                                deletemaskdashes=0
                            End If
                        End If 
                        
                        If Left(kette,12)="nodeletedots" Then
                            deletedots(searchstringcount)=0
                            If usemask=True Then
                                deletemaskdots=0
                            End If
                        End If 
                        
                        If Left(kette,12)="deletespaces" Then
                            deletespaces(searchstringcount)=1
                            If usemask=True Then
                                deletemaskspaces=1
                            End If
                        End If 
                        
                        If Left(kette,12)="deletedashes" Then
                            deletedashes(searchstringcount)=1
                            If usemask=True Then
                                deletemaskdashes=1
                            End If
                        End If 
                        
                        If Left(kette,10)="deletedots" Then
                            deletedots(searchstringcount)=1
                            If usemask=True Then
                                deletemaskdots=1
                            End If
                        End If 
                        
                        If Left(kette,13)="getallstrings" Then
                            GetAllmyStrings(searchstringcount)=1
                            If usemask=True Then
                                getallmaskstrings=1
                            End If
                        End If 
                        
                        If Left(kette,10)="externname" Then
                            laenge=Len(kette)+1
                            wert=GetString(kette,InStr(1,kette,"externname",1)+10)
                            externname=wert
                        End If 
                        
                        If Left(kette,11)="searchsteps" Then
                            laenge=Len(kette)+1
                            wert=GetString(kette,InStr(1,kette,"searchsteps",1)+11)
                            searchsteps(searchstringcount)=wert
                        End If 
                        
                        If Left(kette,10)="getstrings" Then
                            laenge=Len(kette)+1
                            wert=GetString(kette,InStr(1,kette,"getstrings",1)+10)
                            getnextstrings(searchstringcount)=wert
                            
                        End If 
                        
                        If Left(kette,9)="charlimit" Then
                            laenge=Len(kette)+1
                            wert=GetString(kette,InStr(1,kette,"charlimit",1)+9)
                            charlimit(searchstringcount)=wert
                        End If 
                        
                        If Left(kette,10)="zusatzfeld" Then
                            laenge=Len(kette)+1
                            wert= Trim(Right(kette,Len(kette)-InStr(1,kette,"=")))
                            If xpath<>"" Then
                            	xpathfields(xpathcount)=wert
                            	xpathcount = xpathcount+1
                            End If
                            
                            If zwischenname(searchstringcount)<>"" Then
                                Do Until zwischenname(searchstringcount) = "" Or searchstringcount = limit
                                    searchstringcount=searchstringcount+1
                                Loop
                            End If
                            Zwischenname(searchstringcount)=wert
                            
                            If fixvalue<>"" Then
                                gefunden=False
                                i=0
                                Do While gefunden=False
                                    If fixvaluenames(i)="" Then
                                        gefunden=True
                                        fixvalues(i)=fixvalue
                                        fixvaluenames(i)=wert
                                        
                                    Else
                                        i=i+1
                                    End If
                                    If i=30 Then
                                        gefunden=True
                                    End If
                                Loop
                                
                            End If	
                            
                            If maxvalue<>"" Then
                                gefunden=False
                                i=0
                                Do While gefunden=False
                                    If maxvalues(i)="" Then
                                        gefunden=True
                                        maxvalues(i)=wert
                                        maxvalue=""
                                        
                                    Else
                                        i=i+1
                                    End If
                                    If i=5 Then
                                        gefunden=True
                                    End If
                                Loop
                                
                            End If	
                            
                            
                        End If 
                        
                        If Left(kette,10)="linkstring" Then
                            linkflag(searchstringcount)=linkflag(searchstringcount)+32
                            If usemask=True Then
                                masklinkflag=masklinkflag+32
                            End If
                            
                        End If 
                        
                        If Left(kette,10)="createlink" Then
                            'wert=GetString(kette,InStr(1,kette,"createlink",1)+10)
                            wert = Right(kette,Len(kette)-11)
                            buildlink(buildcount)=wert
                            buildcount=buildcount+1
                            
                        End If 
                        
                        If Left(kette,13)="overridecheck" Then
                            overridecheck=True
                        End If 
                        
                        
                        If LCase(Left(kette,8))="continue" Then
                            continue(searchstringcount)=True
                        End If 	
                        
                        If LCase(Left(kette,7))="numeric" Then
                            numeric(searchstringcount)=True
                            If usemask=True Then
                                masknumeric=1
                            End If
                        End If 
                        
                        If LCase(Left(kette,10))="alphabetic" Then
                            alphabetic(searchstringcount)=True
                            If usemask=True Then
                                maskalphabetic=1
                            End If
                        End If 
                        
                        If LCase(Left(kette,8))="interval" Then
                            interval(searchstringcount)=True
                            If usemask=True Then
                                maskinterval=1
                            End If
                        End If 
                        
                        If LCase(Left(kette,5))="value" Then
                            value(searchstringcount)=True
                            If usemask=True Then
                                maskvalue=1
                            End If
                        End If 
                        
                        
                        If LCase(Left(kette,4))="date" Then
                            istdatum(searchstringcount)=True
                            If usemask=True Then
                                maskdate=1
                            End If
                            If LCase(Left(kette,7))="date-us" Then
                                usdatum(searchstringcount)=True
                                If usemask=True Then
                                    maskdate=2
                                End If
                            End If
                           	If LCase(Left(kette,9))="date-auto" Then
                                autodatum(searchstringcount)=True
                                If usemask=True Then
                                    maskdate=2
                                End If
                            End If
                        End If 
                        
                        
                        If Left(kette,11)="cutawayleft" Then
                            wert=GetString(kette,InStr(1,kette,"cutawayleft",1)+11)
                            'linkflag(searchstringcount)=linkflag(searchstringcount)+wert
                            'flagleft=true
                            cutstringleft(searchstringcount) = strconvert(wert)
                            If usemask=True Then
                                masklinkflag=masklinkflag+wert
                            End If
                        End If 
                        
                        If Left(kette,12)="cutawayright" Then
                            wert=GetString(kette,InStr(1,kette,"cutawayright",1)+12)
                            cutstringright(searchstringcount)= strconvert(wert)
                            If usemask=True Then
                                masklinkflag=masklinkflag+wert+64
                            End If
                        End If 
                        
                        
                        If Left(kette,12)="getmidstring" Then
                            wert1=0
                            wert2=0
                            wert=Trim(Right(kette,Len(Kette)-InStr(1,kette,"getmidstring=")-12))
                            wert=removespace(wert)
                            trennpos=InStr(1, wert, ".")
                            wert1=strConvert(Left(wert,trennpos-1))
                            wert2=strConvert(Right(wert,Len(wert)-InStr(1,wert,".")))
                            
                            getmidstring(searchstringcount,1)= strconvert(wert1)
                  
                        End If 
                        
                        If Left(kette,13)="replacestring" Then
                            wert1=""
                            wert2=""
                            wert=Trim(Right(kette,Len(Kette)-InStr(1,kette,"replacestring=")-13))
                            wert=removespace(wert)
                            
                            wert1=Left(wert,InStr(1,wert,".")-1)
                            wert2=Right(wert,Len(wert)-InStr(1,wert,"."))
                            replacestring(searchstringcount,1)=wert1
                            replacestring(searchstringcount,2)= wert2
                        End If 
                        
                        If Left(kette,12)="takeonlyleft" Then
                            wert=GetString(kette,InStr(1,kette,"takeonlyleft",1)+12)
                            linkflag(searchstringcount)=linkflag(searchstringcount)+wert+128
                            If usemask=True Then
                                masklinkflag=masklinkflag+wert+128
                            End If
                        End If 
                        
                        If Left(kette,13)="takeonlyright" Then
                            wert=GetString(kette,InStr(1,kette,"takeonlyright",1)+13)
                            linkflag(searchstringcount)=linkflag(searchstringcount)+wert+192
                            If usemask=True Then
                                masklinkflag=masklinkflag+wert+192
                            End If
                        End If 
                        
                        If Left(kette,15)="searchdirection" Then
                            laenge=Len(kette)+1
                            wert=GetString(kette,InStr(1,kette,"searchdirection",1)+15)
                            searchdirection(searchstringcount)=wert
                        End If 
                        
                        If Left(kette,8)="fixvalue" Then
                            wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"fixvalue=",1)+8)))
                            fixvalue=wert
                            maxvalue=""
                        End If 
                        
                        If Left(kette,8)="maxvalue" Then
                            maxvalue="1"
                            fixvalue = ""
                        End If 
                        
                        If Left(kette,4)="exit" Then
                            exitnaming = True
                        End If
                        
                        
                        
                    Loop
                Else
                    naminglesen = False
                End If
                
                '*******************************************************************************************
                '****************************        auswertung                *****************************
                '*******************************************************************************************
                
                
                '+++++++++++++++++++++++	
                If naminglesen = True Then
                    
                    zutreffendbarcode = False
                    zutreffendtxt = False
                    zutreffendtabelle=False
                    zutreffendcase=False
                    
                    If andor(1) = 2 Then
                        zutreffendtxt=True
                    End If
                    
                    If andor(1) = 3 Then
                        zutreffendtxt=True
                    End If
                    
                    
                    If bcfindcount = 0 Then
                        zutreffendbarcode = True
                    Else
                        For y=0 To bcfindcount
                            
                            For i=0 To 29
                                If (barcode(i)<>"") And (bctofind(y)<>"") Then
                                    If Left(bctofind(y),9)<> "||regex||" Then
                                        If InStr(1,barcode(i),bctofind(y),1)<>0 Then
                                            zutreffendbarcode = True                                        
                                        End If
                                    Else
                                        regex = Right(bctofind(y),Len(bctofind(y))-9)
                                        Set objRE = New RegExp
                                        objRE.Global     = False    ' Nur eine bereinstimmung  (die erste)
                                        objRE.IgnoreCase = Not recasesensitive
                                        objRE.Pattern    = regex
                                        Set colMatches = objRE.Execute(barcode(i))
                                        hits = colMatches.Count
                                        If hits>0 Then
                                            zutreffendbarcode = True
                                        End If
                                    End If
                                End If
                            Next
                        Next
                        
                    End If
                    
                    
                    
                    If txtfindcount = 0 Then
                        zutreffendtxt=True
                    Else
                        i=1
                        Do While i <= txtfindcount
                            
                            
                            
                            If Left(txttofind(i),9)<> "||regex||" Then
                                'MsgBox(workflowcount&":"&txttofind(i)&":"&Datei&":"&isintextfile(txttofind(i)))
                                If andor(i) = 1 Then
                                    zutreffendtxt = zutreffendtxt Or isintextfile(txttofind(i))
                                    'MsgBox(i&":"&txtfindcount&":1:"&zutreffendtxt&":"&txttofind(i))
                                ElseIf andor(i)=2 Then
                                    zutreffendtxt = zutreffendtxt And isintextfile(txttofind(i))
                                    'MsgBox(i&":"&txtfindcount&":2:"&zutreffendtxt&":"&txttofind(i))
                                Else
                                    zutreffendtxt = zutreffendtxt And Not isintextfile(txttofind(i))
                                End If
                            Else
                                reg = Right(txttofind(i), Len(txttofind(i)) - 9)
                                If andor(i) = 1 Then
                                    zutreffendtxt = zutreffendtxt Or regintextfile(reg)
                                    'MsgBox(i&":"&txtfindcount&":1:"&zutreffendtxt&":"&txttofind(i))
                                ElseIf andor(i)=2 Then
                                    zutreffendtxt = zutreffendtxt And regintextfile(reg)
                                    'MsgBox(i&":"&txtfindcount&":2:"&zutreffendtxt&":"&txttofind(i))
                                Else
                                    zutreffendtxt = zutreffendtxt And Not regintextfile(reg)
                                End If
                            End If
                            
                            i=i+1
                        Loop
                    End If
                    
                    If tabellencount=0 Then
                        zutreffendtabelle=True
                    Else
                        i=1
                        Do While i <= tabellencount
                            'MsgBox(Tabelle1(i)&":"&Tabelle)
                            
                            Archiv=Tabelle
                            resulttablelenght=0
                            resulttable=""	
                            '###########  Fallunterscheidung * davor / dahinter / beides / keins #########
                            
                            If Left(tabelle1(i),1)="*" Then
                                If (Right(tabelle1(i),1)="*") And (Len(tabelle1(i))>2) Then '### beides ###
                                    'objWshShell.LogEvent 1, "hier!"
                                    resulttable=Right(tabelle1(i),Len(tabelle1(i)-1))
                                    resulttable=Left(resulttable,Len(resulttable-1))
                                    If Len(archiv)>=Len(resulttable) Then
                                        If InStr(1,Archiv,resulttable,1)<>0 Then
                                            zutreffendtabelle = True
                                            If scriptdebug = True Then
                                                objWshShell.LogEvent 4, "Fall1 zutreffend: Suchstring: "&tabelle1(i)&" Archiv: "&Archiv
                                            End If
                                        End If
                                    End If
                                    
                                Else '### davor ###
                                    
                                    resulttable=Right(tabelle1(i),Len(tabelle1(i))-1)
                                    resulttablelenght=Len(resulttable)
                                    If Len(Archiv)>resulttablelenght Then
                                        If LCase(resulttable)=LCase(Right(Archiv,resulttablelenght)) Then
                                            zutreffendtabelle = True
                                            If scriptdebug = True Then
                                                objWshShell.LogEvent 4, "Fall2a zutreffend: Suchstring: "&tabelle1(i)&" Archiv: "&Archiv
                                            End If
                                        End If
                                    ElseIf Len(Archiv)=resulttablelenght Then
                                        If LCase(resulttable)=LCase(Archiv) Then
                                            zutreffendtabelle = True
                                            If scriptdebug = True Then
                                                objWshShell.LogEvent 4, "Fall2b zutreffend: Suchstring: "&tabelle1(i)&" Archiv: "&Archiv
                                            End If
                                        End If
                                    End If
                                    
                                End If
                                
                            ElseIf Right(tabelle1(i),1)="*" Then '### dahinter ###
                                resulttable=Left(tabelle1(i),Len(tabelle1(i))-1)
                                resulttablelenght=Len(resulttable)
                                If Len(Archiv)>resulttablelenght Then
                                    If LCase(resulttable)=LCase(Left(Archiv,resulttablelenght)) Then
                                        zutreffendtabelle = True
                                        If scriptdebug = True Then
                                            objWshShell.LogEvent 4, "Fall3a zutreffend: Suchstring: "&tabelle1(i)&" Archiv: "&Archiv
                                        End If
                                    End If
                                ElseIf Len(Archiv)=resulttablelenght Then
                                    If LCase(resulttable)=LCase(Archiv) Then
                                        zutreffendtabelle = True
                                        If scriptdebug = True Then
                                            objWshShell.LogEvent 4, "Fall3b zutreffend: Suchstring: "&tabelle1(i)&" Archiv: "&Archiv
                                        End If			
                                    End If
                                End If
                                
                                
                            Else	'### keins ###
                                If scriptdebug = True Then
                                    objWshShell.LogEvent 4, "Status: Suchstring: "&tabelle1(i)&" Archiv: "&Archiv
                                End If
                                
                            	If LCase(tabelle1(i))=LCase(Archiv) Or tabelle1(i) = folderID Then
                                    zutreffendtabelle = True
                                	If scriptdebug = True Then
                                        objWshShell.LogEvent 4, "Fall4a zutreffend: Suchstring: "&tabelle1(i)&" Archiv: "&Archiv
                                	End If
                            	End If
                                
                            End If	
                            
                            i=i+1
                        Loop
                    End If
                    
                    '###################  Beginn: CASE-Auswertung #################################
                    
                    ccount=1
                    zutreffendcasegesamt=True
                    
                    If casecount = 0 Then
                        zutreffendcasegesamt=True
                    Else
                        
                        Do While operator(ccount)<>""
                            If scriptdebug = True Then
                                objWshShell.LogEvent 4, "Trap-case1" & vbCrLf & "zusatzfeldname("&ccount&")="&casezusatzfeldname(ccount) & vbCrLf & "operator("&ccount&")="&operator(ccount)  & vbCrLf &  "operant("&ccount&")="&operant(ccount)
                            End If 
                            
                            If (casezusatzfeldname(ccount)<>"") And (operator(ccount)<>"") And (operant(ccount)<>"") Then
                                zutreffendcase=False
                                wert=""
                                gefunden=False
                                x=0
                                Do While gefunden=False
                                    If LCase(Trim(zusatzfeldname(x)))=LCase(Trim(casezusatzfeldname(ccount))) Then
                                        gefunden=True
                                    End If
                                    If gefunden=False Then
                                        x=x+1
                                    End If
                                    If x>=limit Then
                                        gefunden=True
                                    End If
                                Loop
                                
                                If x<limit Then
                                    wert=zusatzfeld(x)
                                End If
                                
                                If scriptdebug=True Then
                                    objWshShell.LogEvent 4, "Workflow-Debug: CASE-Analyse: Zusatzfeldname:"&casezusatzfeldname(ccount)&" operator(casecount):"&operator(ccount)&" operant:"&operant(ccount) & vbCrLf & "wert:"&wert
                                End If
                                
                                
                                If InStr(operant(ccount),";")<>0 Then
                                    orOperants=Split(operant(ccount), ";")
                                    orCase=False
                                Else
                                    orOperants=False
                                    orCase=False
                                End If
                                
                                
                                If orOperants Then
                                    For operantIndex = 0 To UBound(orOperants)
                                        thisOperant = orOperants(operantIndex)
                                        If Left(thisOperant,1)="$" Or Not IsNumeric(thisOperant) Then
                                            If Left(thisOperant,1)="$" Then
                                                thisOperant=Right(thisOperant,Len(thisOperant)-1)
                                            End If 
                                            If operator(ccount)="=" Then
                                                If LCase(wert)=LCase(thisOperant) Then
                                                    zutreffendcase=True
                                                Else
                                                    zutreffendcase=False
                                                End If
                                            End If
                                            If operator(ccount)="#" Then
                                                If LCase(wert)<>LCase(thisOperant) Then
                                                    zutreffendcase=True
                                                Else
                                                    zutreffendcase=False
                                                End If
                                            End If
                                            If operator(ccount)="~" Then
                                                If InStr(1,LCase(wert),LCase(thisOperant))<>0 Then
                                                    zutreffendcase=True
                                                Else
                                                    zutreffendcase=False
                                                End If
                                            End If
                                        Else	
                                            
                                            If LCase(thisOperant) <> "true" And LCase(thisOperant) <> "false" Then
                                                valoperant=strconvert(thisOperant)
                                                valwert=valconvert(wert)
                                            Else
                                                valoperant=LCase(thisOperant)
                                                valwert=LCase(wert)
                                            End If 
                                            
                                            
                                            If operator(ccount)="=" Then
                                                If valwert=valoperant Then
                                                    zutreffendcase=True
                                                Else
                                                    zutreffendcase=False
                                                End If
                                            End If
                                            If operator(ccount)="#" Then
                                                
                                                If valwert<>valoperant Then
                                                    zutreffendcase=True
                                                Else
                                                    zutreffendcase=False
                                                End If
                                            End If
                                            If operator(ccount)=">" Then
                                                If valwert>valoperant Then
                                                    zutreffendcase=True
                                                Else
                                                    zutreffendcase=False
                                                End If
                                            End If
                                            If operator(ccount)="<" Then
                                                If valwert<valoperant Then
                                                    zutreffendcase=True
                                                Else
                                                    zutreffendcase=False
                                                End If
                                            End If
                                        End If
                                        
                                        
                                        
                                        
                                        
                                        
                                        If zutreffendcase=True Then
                                            orCase = True
                                        End If
                                        
                                    Next
                                Else
                                    If Left(operant(ccount),1)="$" Or Not IsNumeric(operant(ccount)) Then
                                        If Left(operant(ccount),1)="$" Then
                                            operant(ccount)=Right(operant(ccount),Len(operant(ccount))-1)
                                        End If 
                                        If operator(ccount)="=" Then
                                            If LCase(wert)=LCase(operant(ccount)) Then
                                                zutreffendcase=True
                                            Else
                                                zutreffendcase=False
                                            End If
                                        End If
                                        If operator(ccount)="#" Then
                                            If LCase(wert)<>LCase(operant(ccount)) Then
                                                zutreffendcase=True
                                            Else
                                                zutreffendcase=False
                                            End If
                                        End If
                                        If operator(ccount)="~" Then
                                            If InStr(1,LCase(wert),LCase(operant(ccount)))<>0 Then
                                                zutreffendcase=True
                                            Else
                                                zutreffendcase=False
                                            End If
                                        End If
                                    Else	
                                        
                                        If LCase(operant(ccount)) <> "true" And LCase(operant(ccount)) <> "false" Then
                                            valoperant=strconvert(operant(ccount))
                                            valwert=valconvert(wert)
                                        Else
                                            valoperant=LCase(operant(ccount))
                                            valwert=LCase(wert)
                                        End If 
                                        
                                        
                                        If operator(ccount)="=" Then
                                            If valwert=valoperant Then
                                                zutreffendcase=True
                                            Else
                                                zutreffendcase=False
                                            End If
                                        End If
                                        If operator(ccount)="#" Then
                                            
                                            If valwert<>valoperant Then
                                                zutreffendcase=True
                                            Else
                                                zutreffendcase=False
                                            End If
                                        End If
                                        If operator(ccount)=">" Then
                                            If valwert>valoperant Then
                                                zutreffendcase=True
                                            Else
                                                zutreffendcase=False
                                            End If
                                        End If
                                        If operator(ccount)="<" Then
                                            If valwert<valoperant Then
                                                zutreffendcase=True
                                            Else
                                                zutreffendcase=False
                                            End If
                                        End If
                                    End If
                                End If
                            Else
                                zutreffendcase=True
                            End If
                            
                            If orCase = True Then
                                zutreffendcase=True
                            End If
                            
                            If scriptdebug=True Then
                                objWshShell.LogEvent 4, "Workflow-Debug: CASE-Analyse(1): Ergebnis:"&zutreffendcase & vbCrLf & "zusatzfeldname("&casecount&")="&casezusatzfeldname(casecount) & vbCrLf & "operator("&casecount&")="&operator(casecount)  & vbCrLf &  "operant("&casecount&")="&operant(casecount)& vbCrLf & "wert:" & wert
                            End If
                            
                            ccount=ccount+1
                            
                            zutreffendcasegesamt = zutreffendcase And zutreffendcasegesamt
                            
                            
                        Loop
                        
                        
                    End If 
                    zutreffendcase=zutreffendcasegesamt
                    
                    
                    '
                    
                    '########################################################################################
                    '########################################################################################
                    
                    
                    If (zutreffendbarcode=True) And (zutreffendtabelle = True) And (zutreffendtxt = True) And (zutreffendcase = True) Then
                        ' For i = 0 To limit
                        	' If sqlmappersections(i)<>"" Then
                        		' sqlmapper(sqlmappercounter)=sqlmappersections(i)
                        		' sqlmappercounter = sqlmappercounter + 1
                        	' End If
                        ' Next
                        
                        If readbarcodes1=True Then
                            
                            
                            vorhanden=False
                            For i=0 To 29
                                If barcode(i)<>"" Then
                                    vorhanden=True
                                End If
                            Next
                            
                            If vorhanden=False Then
                                barcodecomplete=False
                                If fs.fileexists(tempname&".slw") Then
                                    Set swfile=fs.OpenTextFile(tempname&".slw",1)
                                    Do While swfile.atendofstream=False
                                        kette=swfile.readline
                                        If InStr(1,kette,"Message:BarcodeRead=Complete",1)<>0 Then
                                            barcodecomplete=True
                                        End If
                                        If InStr(1,kette,"Barcode:",1)<>0 Then
                                            mybarcode=""
                                            If (Len(kette)-8)>0 Then
                                                mybarcode=Right(kette,Len(kette)-8)
                                            End If
                                            If mybarcode<>"" Then
                                                gefunden=False
                                                i=0
                                                Do While gefunden=False
                                                    If barcode(i)="" Then
                                                        gefunden=True
                                                    End If
                                                    If gefunden=False Then
                                                        i=i+1
                                                    End If
                                                    If i>29 Then
                                                        i=29
                                                        gefunden=True
                                                    End If
                                                Loop
                                                barcode(i)=mybarcode
                                            End If
                                        End If
                                    Loop
                                    swfile.close
                                    Set swfile=Nothing
                                End If
                                
                                If barcodecomplete=False Then	
                                    
                                    
                                    If eymbcrdcmdpath <> "" Then
                                        
                                        erfolg = runeymbcrdcmd(tempname)
                                        
                                    ElseIf bcpluspath <>"" Then	
                                        
                                        erfolg = runbcplus(tempname)
                                        
                                    Else
                                        
                                        erfolg=runbarcode(tempname)
                                    End If
                                End If
                            End If
                        End If
                        
                        
                        If (makevcard=True) And (extension=".tif") Then
                            readvcard(tempname)
                        End If
                        
                        
                        
                        For i = 0 To limit
                            If zwischenname(i)<> "" Then
                                vorhanden = False
                                For j = 0 To limit
                                    If LCase(zwischenname(i)) = LCase(zusatzfeldname(j)) Then
                                        vorhanden = True
                                        
                                    End If
                                    
                                Next 
                                If vorhanden = False Then
                                    For j = 0 To limit
                                        If zusatzfeldname(j)="" Then
                                            zusatzfeldname(j)=zwischenname(i)
                                            Exit For
                                        End If
                                    Next 
                                End If
                                
                                
                            End If
                        Next 
                        
                        '===================== Umkopieren der Zusatzfeldarrays ===========
                        i=0
                        x=0
                        gefunden=False
                        Do While gefunden=False
                            If zwischenwert(x)<>"" Then
                                i=0
                                getroffen=False
                                Do While getroffen=False
                                    If LCase(zusatzfeldname(i))=LCase(zwischenname(x)) Then
                                        getroffen=True
                                        
                                        If zusatzfeld(i)="" Then
                                            zusatzfeld(i)=zwischenwert(x)
                                        End If
                                    Else
                                        i=i+1
                                    End If
                                    If i=limit Then
                                        getroffen=True
                                    End If
                                Loop
                                
                                
                                If i=limit Then
                                    
                                    i=0
                                    getroffen=False
                                    Do While getroffen=False
                                        If zusatzfeldname(i)="" Then
                                            getroffen=True
                                            
                                            zusatzfeldname(i)=zwischenname(x)
                                            zusatzfeld(i)=zwischenwert(x)
                                        Else
                                            i=i+1
                                        End If
                                        If i=limit Then
                                            getroffen=True
                                        End If
                                    Loop
                                End If
                            End If
                            x=x+1
                            If x=limit Then
                                gefunden=True
                            End If
                        Loop
                        
                        
                        
                        '################ umkopieren fixvalues ################
                        i=0
                        x=0
                        gefunden=False
                        Do While gefunden=False
                            If fixvalues(x)<>"" Then
                                i=0
                                getroffen=False
                                Do While getroffen=False
                                    If LCase(zusatzfeldname(i))=LCase(fixvaluenames(x)) Then
                                        getroffen=True
                                        
                                        If zusatzfeld(i)="" Then
                                            zusatzfeld(i)=fixvalues(x)
                                        End If
                                    End If
                                    i=i+1
                                    If i=limit Then
                                        getroffen=True
                                    End If
                                Loop
                                
                                If i=limit Then
                                    i=0
                                    getroffen=False
                                    Do While getroffen=False
                                        If zusatzfeldname(i)="" Then
                                            getroffen=True
                                            zusatzfeldname(i)=fixvaluenames(x)
                                            zusatzfeld(i)=fixvalues(x)
                                        Else
                                            i=i+1
                                        End If
                                        If i=limit Then
                                            getroffen=True
                                        End If
                                    Loop
                                End If
                            End If
                            x=x+1
                            If x=30 Then
                                gefunden=True
                            End If
                        Loop
                        
                        '################ maxxvalues ################
                        
                        gefunden=False
                        For i=0 To 5
                            If maxvalues(i)<>"" Then
                                gefunden=True
                            End If
                        Next
                        
                        If gefunden=True Then
                            If fs.fileexists(tempname&".txt") Then
                                On Error Resume Next
                                Err.clear
                                vtxtstring=""
                                Set tempfsobj = fs.OpenTextFile(tempname&".txt",1)
                                Do While  tempfsobj.AtEndOfStream = False
                                    vtxtstring=vtxtstring&vbCrLf&tempfsobj.readline
                                Loop
                                If Err.number<>0 Then
                                    Err.clear
                                    On Error Resume Next
                                End If
                                tempfsobj.close
                                Set tempfsobj=Nothing
                                If Err.number<>0 Then
                                    Err.clear
                                    On Error Resume Next
                                End If
                            End If
                            
                            If vtxtstring<>"" Then
                                If fs.fileexists(tempname & ".txt") And fs.fileexists(programm&"bfa_maxvalue.exe") Then
                                	mymaxvalue=getmaxvalue_ext(tempname&".txt")
                                Else
                                	mymaxvalue=getmaxvalue(vtxtstring)
                                End If
                                
                                If mymaxvalue<>"" Then
                                    For i=0 To 5
                                        If maxvalues(i)<>"" Then
                                            For x=0 To limit
                                                If zusatzfeldname(x)<>"" Then
                                                    If LCase(zusatzfeldname(x))=LCase(maxvalues(i)) Then
                                                    	If zusatzfeld(x)= "" Then
                                                        	zusatzfeld(x)=mymaxvalue
                                                        End If
                                                    End If
                                                End If
                                            Next
                                        End If
                                    Next
                                End If
                            End If
                            
                        End If	
                        
                        '################################
                        
                        If scriptdebug = True Then		
                            kette1="Status der Fixvalues(1)"&vbCrLf
                            For x=0 To 30
                                If fixvalues(x)<> "" Then
                                    kette1=kette1&x&":"&fixvaluenames(x)&"-"&fixvalues(x)&vbCrLf
                                End If 
                            Next
                            objWshShell.LogEvent 4,kette1
                            'MsgBox "kette1:"&kette1
                        End If	
                        
                        If scriptdebug = True Then		
                            kette1="Status der Zusatzfelder(1)"&vbCrLf
                            For x=0 To limit
                                If Zusatzfeld(x)<>"" Then
                                    kette1=kette1&x&":"&zusatzfeldname(x)&"-"&Zusatzfeld(x)&vbCrLf
                                End If 
                            Next
                            objWshShell.LogEvent 4,kette1
                            'MsgBox "kette1:"&kette1
                        End If	
                     
                        '*********************  weitere Aktion bei bereinstimmung: Rotation festlegen ***************
                        If rotate<>"" Then
                            docrotation=rotate
                        End If
                        
                        '*********************  weitere Aktion bei bereinstimmung: Hintergrundbild ***************
                        
                        If myform<>"" Then
                            myformdatei=programm&"forms\"&myform
                            If fs.fileexists(myformdatei) Then
                                'MsgBox(programm&"dokmrgv2.bat "&tempname&".tif "&myformdatei&" "&tempname&".tif")
                                WScript.sleep 300
                                'MsgBox(programm&"formmerger.exe "&archivtif&".tif "&myformdatei&" "&archivtif&".tif")
                                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"mergerv3.exe"&Chr(34)&" "&Chr(34)&myformdatei&Chr(34)&" "&Chr(34)&archivtif&".tif"&Chr(34)&" "&Chr(34)&archivtif&".tif"&Chr(34)&" fit",0,True)
                                'MsgBox("fertig!")
                                WScript.sleep 100
                                If lngReturnCode <> 0 Then
                                    objWSHShell.LogEvent 1, "archivierung: naming: Fehler bei tif-merging fr Hintergrundgrafik "&tempname&" "
                                End If
                            Else
                                If scriptdebug=True Then
                                    objWSHShell.LogEvent 1, "archivierung: naming: Fehler bei tif-merging fr Hintergrundgrafik: keine Grafikdatei gefunden."
                                End If
                            End If
                        End If
                        '*********************  weitere Aktion bei bereinstimmung: Maskenextraktion fr Autoschlagwort ***************
                        If (mymask<>"") And (rundirect=False) Then
                            
                            'mymaskdatei=programm&"masks\"&mymask&".CUT"
                            mymaskdatei=masks & mymask&".CUT"
                            
                            If fs.fileexists(mymaskdatei) Then
                                
                                fs.copyfile OCRname&".tif", programm&"temp\temp0.tif", True
                                
                                
                                
                                If maskdebug=True Then
                                    If Not fs.FolderExists(masks&"debug") Then
                                        fs.createfolder(masks&"debug")
                                    End If                                        
                                    maskdebugtif = Replace(OCRname&".tif", "queue", "masks\debug")
                                    fs.copyfile OCRname&".tif", maskdebugtif
                                End If
                                
                                
                                
                                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"cutterv3.exe"&Chr(34)&" "&Chr(34)&programm&"temp\temp0.tif"&Chr(34)&" "&Chr(34)&mymaskdatei&Chr(34),0,True)
                                If lngReturnCode <> 0 Then
                                    objWSHShell.LogEvent 1, "archivierung: naming: Fehler bei Maskenschnitt fr Autoschlagwort "&tempname&" "
                                End If
                                
                                
                                fs.deletefile programm&"temp\temp0.tif", True
                                '########################### Umsortieren der Ergebnisse ############
                                
                                
                                
                                
                                Set cutfile = fs.opentextfile(mymaskdatei)
                                
                                Do Until cutfile.AtEndofStream
                                    
                                    maskenname = cutfile.readline
                                    maskenname = Trim(Maskenname)
                                    If Left(maskenname,1) = "[" And Right(maskenname,1)="]" Then
                                        maskenname = Mid(maskenname,2,Len(maskenname)-2)
                                        maskengrafik= programm&"temp\"&maskenname&".tif"		
                                        
                                    Else
                                        maskenname = ""
                                        maskengrafik = ""
                                    End If 
                                    
                                    maskenindex=0	
                                    Err.Clear
                                    
                                    If maskenname <> "" And fs.fileexists(maskengrafik) Then
                                        
                                        freemaskslot=0
                                        Do While (freemaskslot<50)
                                            
                                            maskfile=tempname&"-OCR"&freemaskslot&"mask.tif"
                                            If fs.fileExists(maskfile) Then
                                                freemaskslot=freemaskslot+1
                                            Else
                                                freemaskslot=10000
                                            End If
                                        Loop
                                        fs.copyfile maskengrafik, maskfile, True
                                        If maskdebug=True Then
                                            If Not fs.FolderExists(masks&"debug") Then
                                                fs.createfolder(masks&"debug")
                                            End If                                        
                                            maskdebugtif = Replace(maskfile, "queue", "masks\debug")
                                            fs.copyfile maskengrafik, maskdebugtif
                                        End If
                                        fs.deletefile maskengrafik, True
                                        Set linkdatei = fs.OpenTextFile(maskfile&".mlf",8,True,0)
                                        linkdatei.Writeline(masklinkflag)
                                        linkdatei.Writeline(maskenname)
                                        linkdatei.Writeline(deletemaskspaces)
                                        linkdatei.Writeline(deletemaskdashes)
                                        linkdatei.Writeline(deletemaskdots)
                                        linkdatei.Writeline(getallmaskstrings)
                                        linkdatei.Writeline(masknumeric)
                                        linkdatei.Writeline(maskalphabetic)
                                        linkdatei.Writeline(maskdate)
                                        linkdatei.Writeline(maskinterval)
                                        linkdatei.Writeline(maskvalue)
                                        
                                        
                                        linkdatei.close
                                        If Err.number <> 0 Then
                                            Err.clear	
                                            objWshShell.LogEvent 1, "archivierung: Autoverknpfung: Fehler beim ffnen der Flagdatei."
                                            Unlock(programm&lockdatei)
                                            WScript.Quit
                                        End If
                                        Set linkdatei=Nothing
                                    End If
                                    'Next		
                                Loop
                                cutfile.close
                                Set cutfile = Nothing
                                
                            Else
                                objWSHShell.LogEvent 1, "archivierung: naming: Fehler bei Maskenschnitt fr Autoschlagwort: keine Maskendatei gefunden."
                            End If
                        End If
                        
                        
                        '*********************  weitere Aktion bei bereinstimmung: Barcodeextraktion fr Autoschlagwort ***************
                        If (mybarcode<>"") And (rundirect=False) Then
                            mymaskdatei=masks &mybarcode&".CUT"
                            
                            If fs.fileexists(mymaskdatei) Then
                                
                                fs.copyfile OCRname&".tif", programm&"temp\temp0.tif", True
                                
                                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"cutterv3.exe"&Chr(34)&" "&Chr(34)&programm&"temp\temp0.tif"&Chr(34)&" "&Chr(34)&mymaskdatei&Chr(34),0,True)
                                If lngReturnCode <> 0 Then
                                    objWSHShell.LogEvent 1, "archivierung: naming: Fehler bei Barcodeschnitt fr Autoschlagwort "&tempname&" "
                                End If
                                fs.deletefile programm&"temp\temp0.tif", True
                                '########################### Umsortieren der Ergebnisse ############
                                
                                maskenindex=0	
                                Err.clear
                                Set tempfolder = fs.GetFolder(programm&"temp")
                                For Each datei In tempfolder.files
                                    If LCase(Right(datei,3))="tif" Then
                                        maskengrafik=datei
                                        maskenname=datei.name
                                        maskenname=Left(maskenname,Len(maskenname)-4)
                                        freemaskslot=0
                                        Do While (freemaskslot<50)
                                            
                                            maskfile=tempname&"-OCR"&freemaskslot&"barcode.tif"
                                            If fs.fileExists(maskfile) Then
                                                freemaskslot=freemaskslot+1
                                            Else
                                                freemaskslot=10000
                                            End If
                                        Loop
                                        fs.copyfile maskengrafik, maskfile, True
                                        fs.deletefile maskengrafik, True
                                        Set linkdatei = fs.OpenTextFile(maskfile&".blf",8,True,0)
                                        linkdatei.Writeline(masklinkflag)
                                        linkdatei.Writeline(maskenname)
                                        linkdatei.Writeline(deletemaskspaces)
                                        linkdatei.Writeline(deletemaskdashes)
                                        linkdatei.Writeline(deletemaskdots)
                                        linkdatei.Writeline(getallmaskstrings)
                                        linkdatei.Writeline(mybctype)
                                        
                                        linkdatei.close
                                        If Err.number <> 0 Then
                                            Err.clear	
                                            objWshShell.LogEvent 1, "archivierung: Autoverknpfung: Fehler beim ffnen der Flagdatei."
                                            Unlock(programm&lockdatei)
                                            WScript.Quit
                                        End If
                                        Set linkdatei=Nothing
                                    End If
                                Next		
                                
                                'masklinkflag=0	
                                
                            Else
                                objWSHShell.LogEvent 1, "archivierung: naming: Fehler bei Maskenschnitt fr Autoschlagwort: keine Maskendatei gefunden."
                            End If
                        End If
                        
                        
                        '**************************************************************************************************************
                        '*********************  weitere Aktion bei bereinstimmung: Schlagworte nach Suchstrings finden ***************
                        '**************************************************************************************************************
                        
                        If (searchstringcount>0) And (rundirect=False) Then
                            
                            searchstrings()
                            
                        End If
                        
                        masklinkflag=0	
                        '*********************  weitere Aktion bei bereinstimmung: Zwischenwerte und Zusatzfelder synchronisieren ********
                        '*********************  bernimmt dadurch temporre Zusatzfelder  *********************
                        '*********************  Umkopieren der Zusatzfeldarrays           *********************
                        i=0
                        x=0
                        gefunden=False
                        Do While gefunden=False
                            If zwischenwert(x)<>"" Then
                                i=0
                                getroffen=False
                                Do While getroffen=False
                                    If LCase(zusatzfeldname(i))=LCase(zwischenname(x)) Then
                                        getroffen=True
                                        
                                        If zusatzfeld(i)="" Then
                                            zusatzfeld(i)=zwischenwert(x)
                                        End If
                                    Else
                                        i=i+1
                                    End If
                                    If i=limit Then
                                        getroffen=True
                                    End If
                                Loop
                                
                                
                                If i=limit Then
                                    i=0
                                    getroffen=False
                                    Do While getroffen=False
                                        If zusatzfeldname(i)="" Then
                                            getroffen=True
                                            zusatzfeldname(i)=zwischenname(x)
                                            zusatzfeld(i)=zwischenwert(x)
                                        Else
                                            i=i+1
                                        End If
                                        If i=limit Then
                                            getroffen=True
                                        End If
                                    Loop
                                End If
                            End If
                            x=x+1
                            If x=limit Then
                                gefunden=True
                            End If
                        Loop
                        
                        'continuewerte zurck in die zusatzfelder schreiben
                        'sollte das zusatzfeld schon einen wert tragen, so ist dieser auch in continuezusatzfeld enthalten
                        For i = 0 To limit
                            For x = 0 To limit
                                If LCase(zusatzfeldname(i)) = LCase(continuezusatzfeldname(x)) Then
                                    If continuezusatzfeld(x) <> "" Then
                                        zusatzfeld(i) = continuezusatzfeld(x)
                                        Exit For
                                        
                                    End If
                                End If
                            Next
                        Next 
                        
                        
                       
                        
                        '*********************  weitere Aktion bei bereinstimmung: Links zusammenbauen ***************
                        
                        '  frhes aufrufen von using und buildlinks fr createlink
                        using()
                        
                        parse_zusatzfelder()
                        parse_fixvalues()
                        buildlinks()
                        
                        
                        If doknamefilter<>"" Then
                            doknamefilterregs=Split(doknamefilter,"|")
                            For Each pattern In doknamefilterregs
                                regexpglobal(u) = True
                                regexpcasesensitiv(u) = True
                                
                                Set objRE = New RegExp
                                objRE.Global     = True 
                                objRE.IgnoreCase = Not recasesensitive
                                objRE.Pattern    = pattern
                                
                                Set colMatches = objRE.Execute(myname)
                                If colMatches.Count>0 Then
                                    myname="Dokument"
                                End If
                            Next
                        End If
                        
                        If mydocname<>"" And (myname="" Or myname="Dokument") Then
                            
                            testname = ""
                            testname = parse_displayname()
                            
                            If testname<>"" Then
                                myname = testname
                                naming = myname
                            Else
                                naming = ""
                            End If
                            
                        End If
                        
                        '*********************  weitere Aktion bei bereinstimmung: Exit auswerten ********************
                        
                        If exitnaming = True Then
                            endflag = True	
                        End If
                        
                        
                        '***********************************************************************************************	
                        
                        If scriptdebug = True Then		
                            kette1="Status der Fixvalues(2)"&vbCrLf
                            For x=0 To 30
                                If fixvalues(x) <> "" Then
                                    kette1=kette1&x&":"&fixvaluenames(x)&"-"&fixvalues(x)&vbCrLf
                                End If 
                            Next
                            objWshShell.LogEvent 4,kette1
                            'MsgBox "kette1:"&kette1
                        End If	
                        
                        If scriptdebug = True Then		
                            kette1="Status der Zusatzfelder(2)"&vbCrLf
                            For x=0 To limit
                                If Zusatzfeld(x)<> "" Then
                                    kette1=kette1&x&":"&zusatzfeldname(x)&"-"&Zusatzfeld(x)&vbCrLf
                                End If 	
                            Next
                            objWshShell.LogEvent 4,kette1
                            'MsgBox "kette1:"&kette1
                        End If	
                    End If
                    '####################	
                End If
                '+++++++++++++++++++++++
            End If
            '----------------------
            
            If wfdatei.AtEndOfStream <> True Then
                kette = Trim(Replace(Trim(wfdatei.readline), vbTab, ""))
            Else
                endflag = True
            End If
        Loop
        

        
        
    End If
    '=============================
End Function


'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************


Function parse_zusatzfelder()
    On Error Resume Next
    
    For i =0 To limit
        If zusatzfeld(i)<>"" Then
            If InStr(1,zusatzfeld(i),"%")<>0 And InStr(InStr(1,zusatzfeld(i),"%")+1,zusatzfeld(i),"%")<> 0 Then
                zusatzfeldstr=zusatzfeld(i)
                Do Until InStr(1,zusatzfeldstr,"%")=0 
                    posrep1=InStr(1,zusatzfeldstr,"%")
                    posrep2=InStr(InStr(1,zusatzfeldstr,"%")+1,zusatzfeldstr,"%")
                    replacestr =Mid(zusatzfeldstr, posrep1,posrep2-posrep1+1)
                    replacestr2=Replace(replacestr,"%","")
                    zusatzfeldstr=Replace(zusatzfeldstr,replacestr,"")
                    For j= 0 To limit
                        If zusatzfeldname(j)= replacestr2 Then
                            zusatzfeld(i)=Replace(zusatzfeld(i),replacestr,zusatzfeld(j))
                        End If	
                    Next
                    If InStr(1,zusatzfeldstr,"%")<>0 And InStr(InStr(1,zusatzfeldstr,"%")+1,zusatzfeldstr,"%")= 0 Then
                        zusatzfeldstr=Replace(zusatzfeldstr,"%","")
                    End If  
                Loop
            End If
        End If
    Next 
    
    
End Function

Function parse_fixvalues()
    On Error Resume Next
    
    For i =0 To 9
        If fixvalues(i)<>"" Then
            If InStr(1,fixvalues(i),"%")<>0 And InStr(InStr(1,fixvalues(i),"%")+1,fixvalues(i),"%")<> 0 Then
                fixvaluestr=fixvalues(i)
                Do Until InStr(1,fixvaluestr,"%")=0 
                    replacestr =Mid(fixvaluestr, InStr(1,fixvaluestr,"%"),InStr(InStr(1,fixvaluestr,"%")+1,fixvaluestr,"%"))
                    replacestr2=Replace(replacestr,"%","")
                    fixvaluestr=Replace(fixvaluestr,replacestr,"")
                    For j= 0 To 9
                        If fixvaluenames(j)= replacestr2 Then
                            fixvalues(i)=Replace(fixvalues(i),replacestr,fixvalues(j))
                        End If	
                    Next
                    
                    For j = 0 To limit	
                        If zusatzfeldname(j)= replacestr2 Then
                            fixvalues(i)=Replace(fixvalues(i),replacestr,zusatzfeld(j))
                        End If	
                        If zwischenname(j)= replacestr2 Then
                            fixvalues(i)=Replace(fixvalues(i),replacestr,zwischenwert(j))
                        End If	
                    Next
                    If InStr(1,fixvaluestr,"%")<>0 And InStr(InStr(1,fixvaluestr,"%")+1,fixvaluestr,"%")= 0 Then
                        fixvaluestr=Replace(fixvaluestr,"%","")
                    End If  
                Loop
            End If
        End If
    Next 
    
    
End Function

Function parse_zwischenwert()
    On Error Resume Next
    
    For i =0 To 9
        If zwischenwert(i)<>"" Then
            If InStr(1,zwischenwert(i),"%")<>0 And InStr(InStr(1,zwischenwert(i),"%")+1,zwischenwert(i),"%")<> 0 Then
                zwischenwerttr=zwischenwert(i)
                Do Until InStr(1,zwischenwerttr,"%")=0 
                    replacestr =Mid(zwischenwerttr, InStr(1,zwischenwerttr,"%"),InStr(InStr(1,zwischenwerttr,"%")+1,zwischenwerttr,"%"))
                    replacestr2=Replace(replacestr,"%","")
                    zwischenwerttr=Replace(zwischenwerttr,replacestr,"")
                    For j= 0 To limit
                        'If InStr(zwischenwert(i),replacestr) Then
                        If zwischenname(j)= replacestr2 Then
                            zwischenwert(i)=Replace(zwischenwert(i),replacestr,zwischenwert(j))
                        End If	
                        If zusatzfeldname(j)= replacestr2 Then
                            zwischenwert(i)=Replace(zwischenwert(i),replacestr,zusatzfeld(j))
                        End If	
                    Next
                    If InStr(1,zwischenwerttr,"%")<>0 And InStr(InStr(1,zwischenwerttr,"%")+1,zwischenwerttr,"%")= 0 Then
                        zwischenwerttr=Replace(zwischenwerttr,"%","")
                    End If                      
                Loop
            End If
        End If
    Next 
    
End Function



Function parse_displayname()
    On Error Resume Next
    
    If InStr(1,mydocname,"%")<>0 And InStr(InStr(1,mydocname,"%")+1,mydocname,"%")<> 0 Then
        strname_temp=mydocname
        Do Until InStr(1,strname_temp,"%")=0 
            posrep1=InStr(1,strname_temp,"%")
            posrep2=InStr(InStr(1,strname_temp,"%")+1,strname_temp,"%")
            replacestr =Mid(strname_temp, posrep1,posrep2-posrep1+1)
            replacestr2=Replace(replacestr,"%","")
            strname_temp=Replace(strname_temp,replacestr,"")
            For j= 0 To limit
                If zusatzfeldname(j)= replacestr2 Then
                    val = Replace(zusatzfeld(j), vbCr,"")
                    val = Replace(val, vblf,"")
                    mydocname=Replace(mydocname,replacestr,val)
                End If	
            Next
            If InStr(1,strname_temp,"%")<>0 And InStr(InStr(1,strname_temp,"%")+1,strname_temp,"%")= 0 Then
                strname_temp=Replace(strname_temp,"%","")
            End If               
        Loop
    End If
    parse_displayname = mydocname
    
End Function


Function regintextfile(reg)
    On Error Resume Next
    regintextfile=False
    gefunden1=False
    zdateiname=tempname&".txt"
    fertig1 = False
    
    If fs.fileexists(zdateiname) Then
        Set tempfsobj = fs.OpenTextFile(zdateiname,1)
        Do While fertig1=False
            If tempfsobj.AtEndOfStream = True Then
                fertig1=True
            Else
                zs=tempfsobj.readAll
                Set objRE = New RegExp
                objRE.Global     = False    ' Nur eine bereinstimmung  (die erste)
                objRE.IgnoreCase = Not recasesensitive
                objRE.Pattern    = reg
                Set colMatches = objRE.Execute(zs)
                hits = colMatches.Count
                If hits > 0 Then
                    gefunden1=True
                    fertig1=True                    
                End If  
            End If 
        Loop
        tempfsobj.close
        Set tempfsobj=Nothing
        regintextfile=gefunden1
    End If
End Function

Function isintextfile(suchtext1)
    On Error Resume Next
    isintextfile=False
    gefunden1=False
    zdateiname=tempname&".txt"
    karl=LCase(suchtext1)
    fertig1 = False
    
    If fs.fileexists(zdateiname) Then
        Set tempfsobj = fs.OpenTextFile(zdateiname,1)
        Do While fertig1=False
            
            If tempfsobj.AtEndOfStream = True Then
                fertig1=True
            Else
                zs=LCase(tempfsobj.readline)
                If InStr(1,zs,karl,0)<>0 Then
                    gefunden1=True
                    fertig1=True
                End If
            End If 
        Loop
        tempfsobj.close
        Set tempfsobj=Nothing
        isintextfile=gefunden1
    End If
    
End Function

Function isintextfile_alt(suchtext1)
    On Error Resume Next
    
    gefunden1=False
    zdateiname=tempname&".txt"
    karl=suchtext1
    fertig1 = False
    
    If fs.fileexists(zdateiname) Then
        Set tempfsobj = fs.OpenTextFile(zdateiname,1)
        Do While fertig1=False
            
            If tempfsobj.AtEndOfStream = True Then
                fertig1=True
            Else
                zs=tempfsobj.readline
                If InStr(1,zs,karl,1)<>0 Then
                    gefunden1=True
                    fertig1=True
                End If
            End If 
        Loop
        tempfsobj.close
        Set tempfsobj=Nothing
        isintextfile=gefunden1
    End If
    
End Function


'************************************************************************
'************************************************************************

Function ocrstatistik(Datei)
    On Error Resume Next
    
    ocrstatistik=True
    buchstabenzaehler=0
    gesamtzaehler=0
    ezaehler=0
    nzaehler=0
    
    Set testfile = fs.OpenTextFile(Datei,1)
    
    Do While Not testfile.AtEndOfStream
        
        kette=testfile.readline
        laenge=Len(kette)
        
        For i = 1 To laenge
            c=Mid(kette,i,1)
            a=Asc(c)
            gesamtzaehler = gesamtzaehler + 1
            
            If tolerantocrcheck = False Then
                If ((a>96) And (a<123)) Or ((a>64) And (a<91)) Then
                    buchstabenzaehler = buchstabenzaehler + 1
                End If
            Else
                If ((a>96) And (a<123)) Or ((a>64) And (a<91)) Or ((a>47) And (a<58)) Then
                    buchstabenzaehler = buchstabenzaehler + 1
                End If
            End If
            If (c = "e") Or (c = "E") Then
                ezaehler = ezaehler + 1
            End If
            If (c = "x") Or (c = "X") Then
                nzaehler = nzaehler + 1
            End If
        Next
        
    Loop
    
    
    testfile.close
    Set testfile = Nothing
    
    If buchstabenzaehler = 0 Then
        buchstabenzaehler = 1
    End If
    
    If gesamtzaehler = 0 Then
        gesamtzaehler = 1
    End If
    
    proze=ezaehler/buchstabenzaehler * 100
    prozn=nzaehler/buchstabenzaehler * 100
    prozgesamt = buchstabenzaehler/gesamtzaehler * 100
    
    If (prozn>1.4 ) Or (proze<4) Then
        'MsgBox("verdchtig")
        ocrstatistik=False
    End If
    
    If prozgesamt < 4 Then
        checkOCR=True
    End If
    
    If buchstabenzaehler<6 Then
        ocrstatistik=False
    End If
    
    If prozgesamt<60 Then
        ocrstatistik=False
    End If
    
    'MsgBox("es: "&proze&" %  :   Xs: "&prozn&" %     :     Buchstaben: "&prozgesamt&" %")
    
End Function




'************************************************************************
'************************************************************************


Function Searchstrings()
    On Error Resume Next
    
    newextern=True
    u=0
    quelldateiname=tempname&".txt"
    gefunden=False
    iregexp=0
    icol=0
    
    
    Do While u<=searchstringcount
        
        kette = ""
        schlagwort=""
        Err.clear
        
        abbruch=False
        
        
        
        If (searchstring(u)="") Or (searchstring(u)=" ") Or (searchstring(u)="	") Then
            abbruch=True
        End If
        
        
        If (abbruch=False) And (searchflag(u)=2) Then
            
            For i=0 To 29
                If barcode(i)<>"" Then
                    'kette=kette  & " " & barcode(i)
                    kette=kette  & vbCrLf & barcode(i) 'Neu: Verwendung von Zeilenumbruch statt Leerzeichen in der Kette, damit Anfang und Ende von barcodes mit regex (\n|^)...(\r|$) bei searchbarcode besser gehandelt werden knnen. Problem sind sonst barcodes mit enthaltenen Leerzeichen.
                End If
            Next
            kette = Trim(kette)
            stringlaenge=Len(kette)
            positionaktuell=1
            
            If searchstring(u)="*" Then
                abbruch1=False
                i=0
                Do While abbruch1=False
                    If barcode(i)<>"" Then
                        abbruch1=True
                        kette=barcode(i)
                        positionaktuell=1
                        stringlaenge=Len(kette)
                        searchstring(u)=""
                    End If
                    If abbruch1=False Then
                        i=i+1
                    End If
                    If i=30 Then
                        abbruch1=True
                    End If
                Loop
                
            End If
        End If
        
        
        If  (abbruch=False) And (searchflag(u)<>2) Then
            Set quelldatei=fs.OpenTextFile(quelldateiname,1)
            
            zwischenfundextern=""
            endfundextern=""
            kette=""
            
            Err.Clear

            '#################
            kette = quelldatei.readall

            '#################
            quelldatei.close
            Set quelldatei=Nothing
            stringlaenge=Len(kette)
            positionaktuell=1
            
        End If
        
        If positionaktuell >=stringlaenge Then
            abbruch=True
            
        End If
        

        Do While abbruch=False
            found = False
			If searchflag(u) = 4 Then		
				xpath = searchstring(u)
				If pdf_xml_extract = True And Not fs.fileexists(tempname &".xml") Then
					cmd = chr(34) & programm & "extract_xml_from_pdf\extract_xml_from_pdf.exe" & chr(34) & " " & Chr(34) & tempname &".pdf"
					objWSHShell.LogEvent 1, "archivierung.vbs pdf_xml_extract cmd: " & cmd
					Set oExec = objWSHShell.Exec(cmd)
				    strinput = ""
				    strerr = ""
				    Do While Not oExec.StdOut.AtEndOfStream
				        strinput = strinput & oExec.StdOut.ReadAll
				    Loop
				    Do While Not oExec.StdErr.AtEndOfStream
				        strerr = strerr & oExec.StdErr.ReadAll
				    Loop
				    
				    If oExec.ExitCode <> 0 Then
				    	objWSHShell.LogEvent 1, "archivierung.vbs extract_xml_from_pdf kein xml erzeugt." & vbCrLf & strinput & vbCrLf & strerr
						pdf_xml_extract = False
					End If
				End If
				If fs.fileexists(tempname&".xml") Then
					
					If Not fs.fileexists(tempname&".xpth") And doc_xpaths_read=False Then
						cmd = chr(34) & programm & "bfa_dump_xpaths\bfa_dump_xpaths.exe" & chr(34) & " " & Chr(34) & tempname &".xml" & Chr(34) 
						If extractxmlattachments=True Then
							If fs.folderexists(temp &"xmlattachments") Then
								For Each Datei In fs.getfolder(temp&"xmlattachments").files
									fs.deletefile Datei, true
								Next							
							End If
							cmd = cmd &  " --attdir " & Chr(34) & temp &"xmlattachments" & Chr(34)
						End If
						cmd = cmd &  " --out " & Chr(34) & tempname &".xpth" & Chr(34)
		                objWSHShell.LogEvent 1, "archivierung.vbs debug bfa_dump_xpaths cmd" & vbCrLf & cmd
		                doc_xpaths_read = True
		                Set oExec = objWSHShell.Exec(cmd)
					    strinput = ""
					    strerr = ""
					    Do While Not oExec.StdOut.AtEndOfStream
					        strinput = strinput & oExec.StdOut.ReadAll
					    Loop
					    Do While Not oExec.StdErr.AtEndOfStream
					        strerr = strerr & oExec.StdErr.ReadAll
					    Loop
					    objWSHShell.LogEvent 1, "archivierung.vbs debug bfa_dump_xpaths output" & vbCrLf & strinput & vbCrLf & strerr
						If Not fs.fileexists(tempname&".xpth") Then
					    	objWSHShell.LogEvent 1, "archivierung.vbs bfa_dump_xpaths no .xpth created"
					    Else
					    	Set xpthfile = fs.opentextfile(tempname&".xpth", 1)
					    	counter = 0
					    	Do While xpthfile.AtEndOfStream <> True
            					line = xpthfile.readline
            					result = split(line, "=")
            					doc_xpaths(counter)=result(0)
            					doc_xpath_values(counter)=result(1)
            					counter = counter + 1
            				Loop
            				xpthfile.close
            				Set xpthfile = Nothing
            				fs.deletefile tempname&".xpth", true 
					    End If
					    
					    If extractxmlattachments=True Then
					    	objWSHShell.LogEvent 1, "archivierung.vbs debug extractxmlattachments"
					    	Jahr = DatePart("yyyy",Date)
	                        Monat = DatePart("m",Date)
	                        Tag = DatePart("d",Date)
	                        Stunde = DatePart("h",Time)
	                        Minuten = DatePart("n",Time)
	                        Sekunde = DatePart("s", Time)
	                        datum = Jahr&"-" & Monat & "-" & Tag & "--" & Stunde & "-" & Minuten & "-" & Sekunde
	                        zahl = Zufallszahl(10000000,99999999)
					    	xmllink = "xml_" & Jahr&Monat&Tag&Stunde&Minuten&Sekunde&zahl
					    	If fs.fileexists(temp &"xmlattachments"&"\attachments.txt") Then
					    		fname = getfifo(queue, "temp-xml")
								If IsInArray(xmllink, linkspeicher) = False Then
									linkspeicher(linkzaehler)=xmllink
									linkzaehler=linkzaehler+1
								End if
	                            Set atttxt = fs.opentextfile(temp &"xmlattachments"&"\attachments.txt", 1, True, 0)
	                            Do While atttxt.atendofstream=False
	                            	att_path = Trim(atttxt.readline)
	                            	arch_att = ""
	                            	If fs.fileexists(att_path) Then
	                            		If xmlwhitelist <> "" Then
	                            			ext = LCase(fs.GetExtensionName(att_path))
	                            			If InStr(1, xmlwhitelistextension, ext) <> 0 Then
	                            				arch_att = att_path
	                            			End If
	                            		ElseIf xmlblacklistextension <> "" Then
	                            			If InStr(1, xmlblacklistextension, ext) <> 0 Then
	                            				arch_att = att_path
	                            			End If
	                            		Else
	                            			arch_att = att_path
	                            		End If
	                            	End If
	                            	sJobname = getfifo(queue, "temp-xml")
				                    Set swdfile = fs.opentextfile(sJobname & ".slw",8,True)
				                    swdfile.writeline "Dateiname=" & fs.getbasename(att_path)
				                    swdfile.close
				                    
				                    fs.Copyfile tempname & ".job", sJobname & ".job", True
				                    
				                    target = sJobname & "."& fs.GetExtensionName(att_path)
				                    fs.copyfile att_path, target, True
				                    WScript.Sleep 250
				                    oldtyp = Typ
				                    Typ = ""
				                    If Not writexmljob(sJobname) Then
				                        objWshShell.LogEvent 1, "Fehler beim Schreiben einer Jobdatei fr ein Attachment"
				                        If Not fs.fileexists(sJobname & ".job") Then
				                            fs.deletefile sJobname & ".swd", True
				                            fs.deletefile target, True
				                            Err.Clear
				                        End If 
				                    End If
				                    typ = oldtyp
                    
                    
	                            Loop
	                            
					    	End If
					    	
					    End If
					    
					End If
					Index = getindex(xpath, doc_xpaths)
					If Index <> -1 Then
						schlagwort = doc_xpath_values(Index)
				    	schlagwort = Replace(schlagwort, "|||newvalue|||", ";")
				    Else
				    	schlagwort = ""
				    End If
					'objWSHShell.LogEvent 1, "archivierung.vbs debug bfa_xpath_value schlagwort" & vbCrLf & schlagwort
				    If schlagwort <> "" Then
				    	' es ist mglich, dass pdf_xml_extract gesetzt ist, obwohl kein pdf vorhanden ist (reine xml-Rechnung)
				    	' xml-Rechnungen mssen dann trotz pdf_xml_extract gerendert werden
				    	If fs.fileexists(tempname&".xml") And extension=".xml" Then
				    		xml_fields_to_tif = True
				    	End If
				    	found = True
				    End If
						    
					
					If deletespaces(u)=1 Then
	                    schlagwort=removespace(schlagwort)
	                End If
	                If deletedots(u)<>0 Then
	                    schlagwort=RemoveDots(schlagwort)
	                End If
	                If numeric(u)=True Then
	                    schlagwort=makenumeric(schlagwort)
	                End If
	                If alphabetic(u)=True Then
	                    schlagwort=makealphabetic(schlagwort)
	                End If
	                If interval(u)=True Then
	                    schlagwort=makeinterval(schlagwort)
	                End If
	                If deletedashes(u)<>0 Then
	                    schlagwort=removedash(schlagwort)
	                End If
	                If istdatum(u)=True Then
	                    If usdatum(u)=True Then
	                        schlagwort=makedate(schlagwort, True)
	                    ElseIf autodatum(u) = True Then
	                    	schlagwort=makeautodate(schlagwort)
	                    Else
	                    	schlagwort=makedate(schlagwort, False)
	                    End If
	                End If
	                If value(u)=True Then
	                    schlagwort=getmaxvalue(schlagwort)
	                End If
	    			
	    			If cutstringleft(u)<>0 Then
	                                
	                    If Len(schlagwort)>cutstringleft(u) Then
	                        
	                        schlagwort=Right(schlagwort,Len(schlagwort)-cutstringleft(u))
	                        
	                    Else	
	                        If overridecheck=False Then
	                            notifyUser=True
	                        End If
	                        'schlagwort=""
	                    End If
	                End If
	                
	                If cutstringright(u)<>0 Then			
	                    
	                    If Len(schlagwort)>cutstringright(u) Then
	                        schlagwort=Left(schlagwort,Len(schlagwort)-cutstringright(u))
	                    Else
	                        If overridecheck=False Then
	                            notifyUser=True
	                        End If
	                        'schlagwort=""
	                    End If
	                End If
	                
	                If getmidstring(u,1)<>0 Then	
	                    
	                    If Len(schlagwort)>getmidstring(u,1) Then
	                        
	                        schlagwort=Mid(schlagwort,getmidstring(u,1),getmidstring(u,2))
	                        
	                    Else
	                        If overridecheck=False Then
	                            notifyUser=True
	                        End If
	                        'schlagwort=""
	                    End If
	                End If
	                
	                If replacestring(u,1)<>"" Then
	                    
	                    
	                    If InStr(1,schlagwort,replacestring(u,1))<>0 Then
	                        
	                        schlagwort=Replace(schlagwort,replacestring(u,1),replacestring(u,2))
	                        
	                    Else
	                        If overridecheck=False Then
	                            notifyUser=True
	                        End If
	                        'schlagwort=""
	                    End If
	                End If
	    			'objWSHShell.LogEvent 1, "archivierung.vbs debug bfa_xpath_value schlagwort" & vbCrLf & schlagwort & zwischenfeldname
	    			zusfeldzaehler=zusfeldzaehler+1
	            	zwischenwert(u)=schlagwort
	                        	
				End If
            ElseIf searchflag(u) = 3 Then		'RegEXP
                noregexmatch = True
                pattern = searchstring(u)
                'zum testen immer setzen
                regexpglobal(u) = True
                regexpcasesensitiv(u) = True
                
                Set objRE = New RegExp
                objRE.Global     = regexpglobal(u)    ' Nur eine bereinstimmung  (die erste)
                objRE.IgnoreCase = Not recasesensitive
                objRE.Pattern    = pattern
                
                Set colMatches = objRE.Execute(kette)

               
                If colMatches.count > 0 Then
                	noregexmatch = False
                End If
                If patterngroup(u) <> "" Then
                	If colMatches.Count > 0 Then
                		objMatch = colMatches(0)
                		If colMatches(0).Submatches.Count>CInt(patterngroup(u)) Then
                			match = colMatches(0).Submatches(patterngroup(u))
                			strlen=Len(match)
	                		pos1 = InStr(kette, match)
	                		'positionaktuell=pos1+strlen
	                				
                			doexclude = False
                			If exclude(u) <> "" Then
                				Set objREexclude = New RegExp
				                objREexclude.Global     = regexpglobal(u)    ' Nur eine bereinstimmung  (die erste)
				                objREexclude.IgnoreCase = Not recasesensitive
				                objREexclude.Pattern    = exclude(u)
				                Set colMatches = objREexclude.Execute(match)
				                If colMatches.Count > 0 Then
				                  	doexclude = True
				                  	
	                				match = ""
									
				                End If
                			End If
                			If doexclude = False Then
	                			
	                			found = True
	                			schlagwort = match
	                			
	                			If deletespaces(u)=1 Then
		                            schlagwort=removespace(schlagwort)
		                        End If
		                        If deletedots(u)<>0 Then
		                            schlagwort=RemoveDots(schlagwort)
		                        End If
		                        If numeric(u)=True Then
		                            schlagwort=makenumeric(schlagwort)
		                        End If
		                        If alphabetic(u)=True Then
		                            schlagwort=makealphabetic(schlagwort)
		                        End If
		                        If interval(u)=True Then
		                            schlagwort=makeinterval(schlagwort)
		                        End If
		                        If deletedashes(u)<>0 Then
		                            schlagwort=removedash(schlagwort)
		                        End If
		                        If istdatum(u)=True Then
		                            If usdatum(u)=True Then
		                                schlagwort=makedate(schlagwort, True)
		                            ElseIf autodatum(u) = True Then
		                            	schlagwort=makeautodate(schlagwort)
		                            Else
		                            	schlagwort=makedate(schlagwort, False)
		                            End If
		                        End If
		                        If value(u)=True Then
		                            schlagwort=getmaxvalue(schlagwort)
		                        End If
	                			
	                			
	                			zusfeldzaehler=zusfeldzaehler+1
	                        	zwischenwert(u)=schlagwort
	                        End If
                			
                		End If
                	End If
                Else
	                For Each objMatch In colMatches
	                    pos1=0
	                    strlen=0
	                    match = objMatch.Value
	                    
	                    strlen=Len(match)
	                	pos1 = InStr(kette, match)
	                    
	                    
	                    If match <> "" Then
	                    
	                    	doexclude = False
	            			If exclude(u) <> "" Then
	            				Set objREexclude = New RegExp
				                objREexclude.Global     = regexpglobal(u)    ' Nur eine bereinstimmung  (die erste)
				                objREexclude.IgnoreCase = Not recasesensitive
				                objREexclude.Pattern    = exclude(u)
				                Set colMatches = objREexclude.Execute(match)
				                If colMatches.Count > 0 Then
				                  	doexclude = True
				                  	
	                				match = ""
									
				                End If
	            			End If
	            		End If
	            		If doexclude <> True Then
            			
	                        pos1 = objMatch.FirstIndex +1
	                        If pos1 <> 0 Then
	                            found = True
	                        End If 
	                        Exit For
	                    End If 
	                Next
	                Set objRE = Nothing
	            End If
            ElseIf searchflag(u) <> 4 Then
                If searchflag(u) = 2 Then
                    If Left(searchstring(u),9) = "||regex||" Then
                        regex = Right(searchstring(u),Len(searchstring(u))-9)
                        
                        Set objRE = New RegExp
                        objRE.Global     = False
                        objRE.IgnoreCase = Not recasesensitive
                        objRE.Pattern    = regex
                        Set colMatches = objRE.Execute(kette)
                        hits = colMatches.Count
                        
                        If hits>0 Then
                        	If patterngroup(u) = "" Then
                            	match = colMatches(0)
                            	found = True
                            	pos1=InStr(1,kette,match,1)
                            	strlen=Len(match)
                        	Else
                        		match = colMatches(0).Submatches(patterngroup(u))
                        		found = True
                        		schlagwort = match
                			
	                			If deletespaces(u)=1 Then
		                            schlagwort=removespace(schlagwort)
		                        End If
		                        If deletedots(u)<>0 Then
		                            schlagwort=RemoveDots(schlagwort)
		                        End If
		                        If numeric(u)=True Then
		                            schlagwort=makenumeric(schlagwort)
		                        End If
		                        If alphabetic(u)=True Then
		                            schlagwort=makealphabetic(schlagwort)
		                        End If
		                        If interval(u)=True Then
		                            schlagwort=makeinterval(schlagwort)
		                        End If
		                        If deletedashes(u)<>0 Then
		                            schlagwort=removedash(schlagwort)
		                        End If
		                        If istdatum(u)=True Then
		                            If usdatum(u)=False Then
		                                schlagwort=makedate(schlagwort, False)
		                            Else
		                                schlagwort=makedate(schlagwort, True)
		                            End If
		                        End If
		                        If value(u)=True Then
		                            schlagwort=getmaxvalue(schlagwort)
		                        End If
	                			
	                			
	                			zusfeldzaehler=zusfeldzaehler+1
	                        	zwischenwert(u)=schlagwort
	                        	
	                        	
                            	pos1=InStr(1,kette,match,1)
                            	strlen=Len(match)
                        	End If
                        End If
                        
                    Else
                        searchstring(u) = LCase(searchstring(u))
                        If (InStr(1,kette,searchstring(u),1)<>0) Or (LCase(searchstring(u))="userinput") Then
                            found = True
                            pos1=InStr(1,kette,searchstring(u),1)
                            strlen=Len(searchstring(u))
                        End If 
                    End If
                Else
                    If (InStr(1,kette,searchstring(u),1)<>0) Or (LCase(searchstring(u))="userinput") Then
                        found = True
                        pos1=InStr(1,kette,searchstring(u),1)
                        strlen=Len(searchstring(u))
                    End If 
                End If
            End If 
			
            If found And patterngroup(u)="" and searchflag(u) <> 4 Then
                If continue(u)=False Then		' ohne continue jeweils nur einmal pro searchstring ausfhren
                    abbruch=True
                End If
                
                laenge=Len(kette)
                
                
                ergebniskette=""
                Err.clear
                
                If (searchdirection(u)="2") Or (LCase(searchdirection(u))="rechts") Or (LCase(searchdirection(u))="right") Then
                    
                    '##### sonderfall: der searchstring wird selbst zum schlagwort ####
                    If StrConvert(searchsteps(u))=0 Then
                        wortanfang=False
                        Do While ((pos1>1) And (wortanfang=False))
                            zeichen=Mid(kette,pos1,1)
                            charwert=Asc(zeichen)
                            If (zeichen=" ") Or (zeichen="	") Or (charwert=13) Or (charwert=10)  Then
                                wortanfang=True
                                pos1=pos1+1
                            Else
                                pos1=pos1-1
                            End If
                        Loop	
                        ergebniskette=Right(kette,(laenge-pos1)+1)
                    Else
                        ergebniskette=Right(kette,(laenge-pos1)-strlen+1)
                    End If
                    '###################
                    
                    
                    Err.clear
                    tempstring1=""
                    laenge=Len(ergebniskette)
                    speicherposition=1
                    posa=speicherposition
                    zaehler=0
                    tempstring2=""
                    If Len(ergebniskette)>1 Then
                        charwert=0
                        charwert=Asc(Left(ergebniskette,1))
                        If (Left(ergebniskette,1)<>" ") And (Left(ergebniskette,1)<>" ") And (Left(ergebniskette,1)<>"	") And (Left(ergebniskette,1)<>".") And (Left(ergebniskette,1)<>":") And (Left(ergebniskette,1)<>"-") And (Left(ergebniskette,1)<>"_") And (charwert<>13) And (charwert<>10) Then
                            zaehler=-1
                        End If
                    End If
                    
                    
                    If StrConvert(searchsteps(u))=0 Then
                        zaehler=-1
                    End If
                    
                    Do While (zaehler < StrConvert(searchsteps(u))) And (Len(ergebniskette)>0)
                        
                        tempstring1=getwordwithdots(ergebniskette,posa)
                        
                        charwert=0
                        If Len(tempstring1)=1 Then
                            charwert=Asc(tempstring1)
                        End If
                        If (tempstring1<>tempstring2) And (tempstring1<>"") And (tempstring1<>" ") And (tempstring1<>"	") And (tempstring1<>".") And (tempstring1<>":") And (tempstring1<>"-") And (tempstring1<>"_") And (charwert<>13) And (charwert<>10) Then
                            
                            tempstring2=tempstring1
                            
                            zaehler=zaehler+1
                        End If
                        If zaehler = StrConvert(searchsteps(u)) Then
                            Exit Do
                        End If 
                        speicherposition=speicherposition + 1
                        posa = speicherposition
                        If speicherposition>laenge Then
                            zaehler=10000
                        End If
                    Loop
                    If zaehler = StrConvert(searchsteps(u)) Then
                        
                        schlagwort=tempstring2
                        
                        
                        '********************* nachfolgende Strings noch einfgen ********
                        clim=0
                        clim=strconvert(charlimit(u))
                        If clim < 2 Then 
                            clim=254
                        End If
                        
                        
                        getline=False
                        getuntilVBCRLF=False
                        If LCase(getnextstrings(u))="all" Then
                            
                            getuntilVBCRLF=True
                        End If
                        
                        getline=False
                        If LCase(getnextstrings(u))="line" Then
                            
                            getline=True
                        End If
                        
                        gnstr=1
                        gnstr=strconvert(getnextstrings(u))
                        gnstrzaehler=1
                        poskette=speicherposition
                        
                        If (gnstr>1) And (getuntilVBCRLF=False) And (getline=False) Then
                            
                            Do While (gnstrzaehler < gnstr) And (poskette<=Len(ergebniskette))
                                tempstring1=getwordwithdots(ergebniskette,poskette)
                                
                                charwert=0
                                If Len(tempstring1)=1 Then
                                    charwert=Asc(tempstring1)
                                End If
                                If (tempstring1<>tempstring2) And (tempstring1<>"") And (tempstring1<>" ") And (tempstring1<>"	") And (tempstring1<>".") And (tempstring1<>":") And (tempstring1<>"-") And (tempstring1<>"_") And (charwert<>13) And (charwert<>10)  Then
                                    tempstring2=tempstring1
                                    schlagwort=schlagwort&" "&tempstring2
                                    If Len(schlagwort) <= clim Then
                                        gnstrzaehler=gnstrzaehler+1
                                    Else
                                        gnstrzaehler=10000
                                        If Len(schlagwort)>clim Then
                                            schlagwort=Left(schlagwort,clim)
                                        End If
                                    End If
                                End If
                                poskette=poskette+1
                            Loop
                        End If
                        
                        If getuntilVBCRLF=True Then
                            If poskette > 1 Then
                                poskette=poskette-1
                            End If
                            If InStr(poskette,ergebniskette,vbCrLf) Then
                                tempstring2= Mid(ergebniskette,poskette,InStr(poskette,ergebniskette,vbCrLf) -poskette)
                            Else
                                tempstring2 = Right(ergebniskette,Len(ergebniskette)-poskette)
                            End If
                
                            
                            schlagwort=tempstring2
                            
                        End If
                        
                        If getline=True Then
                            
                            
                            If poskette > 1 Then
                                poskette=poskette-1
                            End If
                            
                            
                            
                            poskette=InStr(1,kette,ergebniskette,1)-1
                            
                            
                            makelog=False
                            
                            
                            
                            Do While (poskette>1) And (Asc(Mid(kette,poskette,1))<>10) And (Asc(Mid(kette,poskette,1))<>13)
                                poskette=poskette-1
                                
                            Loop
                            
                            posd=poskette
                            
                            
                            
                            poskette=InStr(1,kette,ergebniskette,1)-1
                            
                            ll=Len(kette)-1
                            Do While (poskette<ll) And (Asc(Mid(kette,poskette,1))<>10) And (Asc(Mid(kette,poskette,1))<>13)
                                poskette=poskette+1
                            Loop
                            
                            pose=poskette
                            
                            
                            If pose>posd Then
                                schlagwort=Mid(kette,posd,pose-posd)
                            Else
                                schlagwort=""
                            End If
                            
                            
                        End If
                        
                        
                        If LCase(searchstring(u))="userinput" Then
                            For c=0 To limit
                                If LCase(zusatzfeldname(c))=LCase(zwischenname(u)) Then
                                    schlagwort=zusatzfeld(c)
                                    
                                End If
                            Next
                        End If		
                        
                        If deletespaces(u)=1 Then
                            schlagwort=removespace(schlagwort)
                        End If
                        If deletedots(u)<>0 Then
                            schlagwort=RemoveDots(schlagwort)
                        End If
                        If numeric(u)=True Then
                            schlagwort=makenumeric(schlagwort)
                        End If
                        If alphabetic(u)=True Then
                            schlagwort=makealphabetic(schlagwort)
                        End If
                        If interval(u)=True Then
                            schlagwort=makeinterval(schlagwort)
                        End If
                        If deletedashes(u)<>0 Then
                            schlagwort=removedash(schlagwort)
                        End If
                        If istdatum(u)=True Then
                            If usdatum(u)=False Then
                                schlagwort=makedate(schlagwort, False)
                            Else
                                schlagwort=makedate(schlagwort, True)
                            End If
                        End If
                        If value(u)=True Then

                            schlagwort=getmaxvalue(schlagwort)
                        End If
                        
                        
                        '*****************************************************************
                        
                        '+++++++++++++++++++++++++++++++++++++++++++++++ evtl. Schneideanweisungen decodieren und ausfhren ++++++++++++++++++++++++++
                        Err.clear
                        
                        If cutstringleft(u)=0 And cutstringright(u)=0 And getmidstring(u,1)=0 And replacestring(u,1)="" Then
                            
                            If (linkflag(u)>0) And (linkflag(u)<64) Then
                                
                                If (linkflag(u)>32) Then
                                    
                                    If Len(schlagwort)>linkflag(u)-32 Then
                                        schlagwort=Right(schlagwort,Len(schlagwort)-(linkflag(u)-32))
                                    Else
                                        If overridecheck=False Then
                                            notifyUser=True
                                        End If
                                    End If
                                    
                                Else
                                    
                                    If (linkflag(u)>0) And (linkflag(u)<32) Then
                                        
                                        If Len(schlagwort)>linkflag(u) Then
                                            schlagwort=Right(schlagwort,Len(schlagwort)-linkflag(u))
                                        Else
                                            If overridecheck=False Then
                                                notifyUser=True
                                            End If
                                        End If
                                        
                                    End If
                                    
                                End If
                            End If
                            
                            If (linkflag(u)>64) And (linkflag(u)<128) Then
                                
                                If (linkflag(u)>96) Then
                                    If Len(schlagwort)>linkflag(u)-96 Then
                                        schlagwort=Left(schlagwort,Len(schlagwort)-(linkflag(u)-96))
                                    Else
                                        If overridecheck=False Then
                                            notifyUser=True
                                        End If
                                    End If
                                    
                                Else
                                    
                                    If Len(schlagwort)>linkflag(u)-64 Then
                                        schlagwort=Left(schlagwort,Len(schlagwort)-(linkflag(u)-64))
                                    Else
                                        If overridecheck=False Then
                                            notifyUser=True
                                        End If
                                    End If
                                End If
                            End If
                            
                            If (linkflag(u)>128) And (linkflag(u)<192) Then
                                If (linkflag(u)>160) Then
                                    
                                    If Len(schlagwort)>linkflag(u)-160 Then
                                        schlagwort=Left(schlagwort,(linkflag(u)-160))
                                    Else
                                        If overridecheck=False Then
                                            notifyUser=True
                                        End If
                                    End If
                                    
                                Else
                                    If Len(schlagwort)>linkflag(u)-128 Then
                                        schlagwort=Left(schlagwort,(linkflag(u)-128))
                                    Else
                                        If overridecheck=False Then
                                            notifyUser=True
                                        End If
                                    End If
                                End If
                            End If
                            
                            If (linkflag(u)>192) And (linkflag(u)<256) Then
                                If (linkflag(u)>224) Then
                                    If Len(schlagwort)>linkflag(u)-224 Then
                                        schlagwort=Right(schlagwort,(linkflag(u)-224))
                                    Else
                                        If overridecheck=False Then
                                            notifyUser=True
                                        End If
                                    End If
                                Else
                                    If Len(schlagwort)>linkflag(u)-192 Then
                                        schlagwort=Right(schlagwort,(linkflag(u)-192))
                                    Else
                                        If overridecheck=False Then
                                            notifyUser=True
                                        End If
                                    End If
                                End If
                            End If
                            Err.clear						
                            
                        Else
                            
                            If cutstringleft(u)<>0 Then
                                
                                If Len(schlagwort)>cutstringleft(u) Then
                                    
                                    schlagwort=Right(schlagwort,Len(schlagwort)-cutstringleft(u))
                                    
                                Else	
                                    If overridecheck=False Then
                                        notifyUser=True
                                    End If
                                End If
                            End If
                            
                            If cutstringright(u)<>0 Then			
                                
                                If Len(schlagwort)>cutstringright(u) Then
                                    schlagwort=Left(schlagwort,Len(schlagwort)-cutstringright(u))
                                Else
                                    If overridecheck=False Then
                                        notifyUser=True
                                    End If
                                End If
                            End If
                            
                            If getmidstring(u,1)<>0 Then	
                                
                                If Len(schlagwort)>getmidstring(u,1) Then
                                    
                                    schlagwort=Mid(schlagwort,getmidstring(u,1),getmidstring(u,2))
                                    
                                Else
                                    If overridecheck=False Then
                                        notifyUser=True
                                    End If
                                End If
                            End If
                            
                            If replacestring(u,1)<>"" Then
                                
                                
                                If InStr(1,schlagwort,replacestring(u,1))<>0 Then
                                    
                                    schlagwort=Replace(schlagwort,replacestring(u,1),replacestring(u,2))
                                    
                                Else
                                    If overridecheck=False Then
                                        notifyUser=True
                                    End If
                                End If
                            End If
                            
                        End If
                        '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        
                        '++++ jetzt die funktion getpositions(schlagwort,befehlskette) ausfhren, um die relevanten Wrter zu bernehmen und Trenner (Pipes, | ) einzufgen.
                        If scriptdebug=True Then
                            objWSHShell.LogEvent 4, "readpositions("&u&"):"&readpositions(u)
                        End If
                        If readpositions(u)<>"" Then
                            schlagwort=getpositions(schlagwort,readpositions(u))
                        End If
                        '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        
                        
                        
                        '#######################  schreiben in die Schlagwortdatei ###########	
                        If (searchflag(u)=0) Or (searchflag(u)=2) Then
                            swdateiname=tempname&".swd"
                            gefundensw=False
                            Err.clear
                            Set swdatei = fs.OpenTextFile(swdateiname,1,True,0)
                            If Err.number <> 0 Then
                                Err.clear	
                                objWshShell.LogEvent 1, "archivierung: Schlagworte: Fehler beim ffnen der Schlagwortdatei."
                                Unlock(programm&lockdatei)
                                WScript.Quit
                            End If
                            Do While (gefundensw=False) And (swdatei.AtEndOfStream=False)
                                savedsw=swdatei.readline
                                If schlagwort=savedsw Then
                                    gefundensw=True
                                End If
                            Loop
                            swdatei.close
                            
                            Set swdatei=Nothing
                            If gefundensw=False Then
                                Set swdatei = fs.OpenTextFile(swdateiname,8,True,0)
                                If schlagwort<>"" Then
                                    laenge=Len(schlagwort)
                                    valid=False
                                    For d=1 To laenge
                                        w=Asc(Mid(schlagwort,d,1))
                                        If ((w>47) And (w<59)) Or ((w>64) And (w<91)) Or ((w>96) And (w<123)) Then
                                            valid=True
                                        End If
                                    Next
                                    If valid=False Then
                                        schlagwort=""
                                    End If
                                End If
                              
                                
                                If schlagwort<>"" Then
                                    swdatei.Writeline(schlagwort)						
                                End If
                                swdatei.close
                                If Err.number <> 0 Then
                                    Err.clear	
                                    objWshShell.LogEvent 1, "archivierung: Schlagworte: Fehler beim ffnen der Schlagwortdatei."
                                    Unlock(programm&lockdatei)
                                    WScript.Quit
                                End If
                                Set swdatei=Nothing
                                
                            End If
                            Err.clear
                        End If
                        '#####################################################################	
                        
                    Else
                        schlagwort=""
                    End If	
                    If schlagwort <>"" Then
                        zusfeldzaehler=zusfeldzaehler+1
                        zwischenwert(u)=schlagwort	
                    End If												
                    
                End If
                
                
                
                
                ' nach links suchen
                If (searchdirection(u)="1") Or (LCase(searchdirection(u))="links") Or (LCase(searchdirection(u))="left") Then
                    
                    
                    If StrConvert(searchsteps(u))=0 Then
                        ergebniskette=Left(kette,pos1 + strlen-1)
                    Else
                        ergebniskette=Left(kette,pos1 -1)
                    End If 
                    Err.clear
                    tempstring1=""
                    laenge=Len(ergebniskette)
                    speicherposition=laenge
                    posa=speicherposition
                    zaehler=0
                    tempstring2=""
                    
                    
                    If StrConvert(searchsteps(u))=0 Then
                        zaehler=-1
                    End If
                    
                    
                    
                    
                    Do While (zaehler < StrConvert(searchsteps(u))) And (Len(ergebniskette)>0)
                        tempstring1=getwordwithdots(ergebniskette,posa)
                        charwert=0
                        If Len(tempstring1)=1 Then
                            charwert=Asc(tempstring1)
                        End If
                        If (tempstring1<>tempstring2) And (tempstring1<>"") And (tempstring1<>" ") And (tempstring1<>"	") And (tempstring1<>".") And (tempstring1<>":") And (tempstring1<>"-") And (tempstring1<>"_") And (charwert<>13) And (charwert<>10) Then
                            tempstring2=tempstring1
                            zaehler=zaehler+1
                        End If
                        speicherposition=speicherposition - 1
                        posa = speicherposition
                        
                        If speicherposition<1 Then
                            zaehler=10000
                        End If
                    Loop
                    
                    If zaehler = StrConvert(searchsteps(u)) Then
                        schlagwort=tempstring2
                        
                        
                        
                        
                        '********************* nachfolgende Strings noch einfgen ********
                        clim=0
                        clim=strconvert(charlimit(u))
                        If clim < 2 Then 
                            clim=254
                        End If
                        
                        
                        getuntilVBCRLF=False
                        If LCase(getnextstrings(u))="all" Then
                            
                            getuntilVBCRLF=True
                        End If
                        
                        getline=False
                        If LCase(getnextstrings(u))="line" Then
                            
                            getline=True
                        End If
                        
                        gnstr=1
                        gnstr=strconvert(getnextstrings(u))
                        gnstrzaehler=1
                        poskette=speicherposition
                        
                        If (gnstr>1) And (getuntilVBCRLF=False) And (getline=False) Then
                            
                            Do While (gnstrzaehler < gnstr) And (poskette>1)
                                tempstring1=getwordwithdots(ergebniskette,poskette)
                                charwert=0
                                If Len(tempstring1)=1 Then
                                    charwert=Asc(tempstring1)
                                End If
                                If (tempstring1<>tempstring2) And (tempstring1<>"") And (tempstring1<>" ") And (tempstring1<>"	") And (tempstring1<>".") And (tempstring1<>":") And (tempstring1<>"-") And (tempstring1<>"_") And (charwert<>13) And (charwert<>10) Then
                                    tempstring2=tempstring1
                                    schlagwort=tempstring2&" "&schlagwort
                                    
                                    If Len(schlagwort) <= clim Then
                                        gnstrzaehler=gnstrzaehler+1
                                    Else
                                        gnstrzaehler=10000
                                        If Len(schlagwort)>clim Then
                                            schlagwort=Right(schlagwort,clim)
                                        End If
                                    End If
                                End If
                                
                                poskette=poskette-1
                            Loop
                            
                        End If
                        If getuntilVBCRLF=True Then
                            If poskette > 1 Then
                                poskette=poskette-1
                            End If
                            
                            
                            If InStrRev(ergebniskette,vbCrLf,poskette) Then
                                posCrLf = InStrRev(ergebniskette,vbCrLf,poskette)
                                tempstring2= Mid(ergebniskette,posCrLf+2, poskette- posCrLf+1)
                            Else
                                If InStr(1,ergebniskette,vbCrLf) Then
                                    tempstring2 = Left(ergebniskette,InStr(1,ergebniskette,vbCrLf)-1)
                                Else
                                    tempstring2 = Left(ergebniskette,laenge)
                                End If 
                            End If
                            
                            
                            
                            schlagwort=tempstring2
                            
                        End If
                        
                        If getline=True Then
                            
                            If poskette > 1 Then
                                poskette=poskette-1
                            End If
                            
                            
                            poskette=InStr(1,kette,ergebniskette,1)-1
                            
                            
                            
                            
                            Do While (poskette>1) And (Asc(Mid(kette,poskette,1))<>10) And (Asc(Mid(kette,poskette,1))<>13)
                                poskette=poskette-1
                                
                            Loop
                            
                            posd=poskette
                            
                            poskette=InStr(1,kette,ergebniskette,1)-1
                            
                            ll=Len(kette)-1
                            Do While (poskette<ll) And (Asc(Mid(kette,poskette,1))<>10) And (Asc(Mid(kette,poskette,1))<>13)
                                poskette=poskette+1
                            Loop
                            
                            pose=poskette
                            
                            
                            If pose>posd Then
                                schlagwort=Mid(kette,posd,pose-posd)
                            Else
                                schlagwort=""
                            End If
                            
                            
                        End If
                        
                        
                        If LCase(searchstring(u))="userinput" Then
                            For c=0 To limit
                                If LCase(zusatzfeldname(c))=LCase(zwischenname(u)) Then
                                    schlagwort=zusatzfeld(c)
                                    
                                End If
                            Next
                        End If		
                        
                        
                        If deletespaces(u)=1 Then
                            schlagwort=removespace(schlagwort)
                        End If
                        
                        If deletedots(u)<>0 Then
                            schlagwort=RemoveDots(schlagwort)
                        End If
                        
                        If numeric(u)=True Then
                            schlagwort=makenumeric(schlagwort)
                        End If
                        If alphabetic(u)=True Then
                            schlagwort=makealphabetic(schlagwort)
                        End If
                        If interval(u)=True Then
                            schlagwort=makeinterval(schlagwort)
                        End If
                        If deletedashes(u)<>0 Then
                            schlagwort=removedash(schlagwort)
                        End If
                        If istdatum(u)=True Then
                            If usdatum(u)=False Then
                                schlagwort=makedate(schlagwort, False)
                            Else
                                schlagwort=makedate(schlagwort, True)
                            End If
                        End If
                        If value(u)=True Then

                            schlagwort=getmaxvalue(schlagwort)
                        End If
                        
                        
                        '*****************************************************************
                        
                        '+++++++++++++++++++++++++++++++++++++++++++++++ evtl. Schneideanweisungen decodieren und ausfhren ++++++++++++++++++++++++++
                        Err.clear
                        
                        
                        If cutstringleft(u)=0 And cutstringright(u)=0 And getmidstring(u,1)=0 And replacestring(u,1)="" Then
                            
                            
                            If (linkflag(u)>0) And (linkflag(u)<64) Then
                                If (linkflag(u)>32) Then
                                    
                                    If Len(schlagwort)>=linkflag(u)-32 Then
                                        schlagwort=Right(schlagwort,Len(schlagwort)-(linkflag(u)-32))
                                    Else
                                        If overridecheck=False Then
                                            notifyUser=True
                                        End If
                                        schlagwort=""
                                    End If
                                    
                                Else
                                    
                                    If (linkflag(u)>0) And (linkflag(u)<32) Then
                                        
                                        If Len(schlagwort)>=linkflag(u) Then
                                            schlagwort=Right(schlagwort,Len(schlagwort)-linkflag(u))
                                        Else
                                            If overridecheck=False Then
                                                notifyUser=True
                                            End If
                                            schlagwort=""
                                        End If
                                        
                                    End If
                                    
                                End If
                            End If
                            
                            If (linkflag(u)>64) And (linkflag(u)<128) Then
                                
                                If (linkflag(u)>96) Then
                                    If Len(schlagwort)>=linkflag(u)-96 Then
                                        schlagwort=Left(schlagwort,Len(schlagwort)-(linkflag(u)-96))
                                    Else
                                        If overridecheck=False Then
                                            notifyUser=True
                                        End If
                                        schlagwort=""
                                    End If
                                    
                                Else
                                    
                                    If Len(schlagwort)>=linkflag(u)-64 Then
                                        schlagwort=Left(schlagwort,Len(schlagwort)-(linkflag(u)-64))
                                    Else
                                        If overridecheck=False Then
                                            notifyUser=True
                                        End If
                                        schlagwort=""
                                    End If
                                End If
                            End If
                            
                            If (linkflag(u)>128) And (linkflag(u)<192) Then
                                If (linkflag(u)>160) Then
                                    
                                    If Len(schlagwort)>=linkflag(u)-160 Then
                                        schlagwort=Left(schlagwort,(linkflag(u)-160))
                                    Else
                                        If overridecheck=False Then
                                            notifyUser=True
                                        End If
                                        schlagwort=""
                                    End If
                                    
                                Else
                                    If Len(schlagwort)>=linkflag(u)-128 Then
                                        schlagwort=Left(schlagwort,(linkflag(u)-128))
                                    Else
                                        If overridecheck=False Then
                                            notifyUser=True
                                        End If
                                        schlagwort=""
                                    End If
                                End If
                            End If
                            
                            If (linkflag(u)>192) And (linkflag(u)<256) Then
                                If (linkflag(u)>224) Then
                                    If Len(schlagwort)>=linkflag(u)-224 Then
                                        schlagwort=Right(schlagwort,(linkflag(u)-224))
                                    Else
                                        If overridecheck=False Then
                                            notifyUser=True
                                        End If
                                        schlagwort=""
                                    End If
                                Else
                                    If Len(schlagwort)>=linkflag(u)-192 Then
                                        schlagwort=Right(schlagwort,(linkflag(u)-192))
                                    Else
                                        If overridecheck=False Then
                                            notifyUser=True
                                        End If
                                        schlagwort=""
                                    End If
                                End If
                            End If
                            Err.clear						
                        Else
                            If cutstringleft(u)<>0 Then
                                
                                If Len(schlagwort)>cutstringleft(u) Then
                                    
                                    schlagwort=Right(schlagwort,Len(schlagwort)-cutstringleft(u))
                                    
                                Else	
                                    If overridecheck=False Then
                                        notifyUser=True
                                    End If
                                    'schlagwort=""
                                End If
                            End If
                            
                            If cutstringright(u)<>0 Then			
                                
                                If Len(schlagwort)>cutstringright(u) Then
                                    schlagwort=Left(schlagwort,Len(schlagwort)-cutstringright(u))
                                Else
                                    If overridecheck=False Then
                                        notifyUser=True
                                    End If
                                    'schlagwort=""
                                End If
                            End If
                            
                            If getmidstring(u,1)<>0 Then	
                                
                                If Len(schlagwort)>getmidstring(u,1) Then
                                    
                                    schlagwort=Mid(schlagwort,getmidstring(u,1),getmidstring(u,2))
                                    
                                Else
                                    If overridecheck=False Then
                                        notifyUser=True
                                    End If
                                    'schlagwort=""
                                End If
                            End If
                            
                            If replacestring(u,1)<>"" Then
                                
                                
                                If InStr(1,schlagwort,replacestring(u,1))<>0 Then
                                    
                                    schlagwort=Replace(schlagwort,replacestring(u,1),replacestring(u,2))
                                    
                                Else
                                    If overridecheck=False Then
                                        notifyUser=True
                                    End If
                                    'schlagwort=""
                                End If
                            End If
                            
                        End If
                        
                        
                        Err.clear						
                        '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        
                        '++++ jetzt die funktion readpositionss(schlagwort) ausfhren, um die relevanten Wrter zu bernehmen und Trenner (Pipes, | ) einzufgen.
                        
                        If readpositions(u)<>"" Then
                            schlagwort=getpositions(schlagwort,readpositions(u))
                        End If
                        '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        
                        
                        '#######################  schreiben in die Schlagwortdatei ###########	
                        If (searchflag(u)=0) Or (searchflag(u)=2) Then
                            
                            swdateiname=tempname&".swd"
                            gefundensw=False
                            Err.clear
                            Set swdatei = fs.OpenTextFile(swdateiname,1,True,0)
                            If Err.number <> 0 Then
                                Err.clear	
                                objWshShell.LogEvent 1, "archivierung: Schlagworte: Fehler beim ffnen der Schlagwortdatei."
                                Unlock(programm&lockdatei)
                                WScript.Quit
                            End If
                            Do While (gefundensw=False) And (swdatei.AtEndOfStream=False)
                                savedsw=swdatei.readline
                                If schlagwort=savedsw Then
                                    gefundensw=True
                                    
                                End If
                            Loop
                            swdatei.close
                            Set swdatei=Nothing
                            If gefundensw=False Then
                                Set swdatei = fs.OpenTextFile(swdateiname,8,True,0)
                            
                                If schlagwort<>"" Then
                                    laenge=Len(schlagwort)
                                    valid=False
                                    For d=1 To laenge
                                        w=Asc(Mid(schlagwort,d,1))
                                        If ((w>47) And (w<59)) Or ((w>64) And (w<91)) Or ((w>96) And (w<123)) Then
                                            valid=True
                                        End If
                                    Next
                                    If valid=False Then
                                        schlagwort=""
                                    End If
                                End If
                                
                                If schlagwort<>"" Then
                                    swdatei.Writeline(schlagwort)
                                    
                                End If
                                swdatei.close
                                If Err.number <> 0 Then
                                    Err.clear	
                                    objWshShell.LogEvent 1, "archivierung: Schlagworte: Fehler beim ffnen der Schlagwortdatei."
                                    Unlock(programm&lockdatei)
                                    WScript.Quit
                                End If
                                Set swdatei=Nothing
                               
                            End If
                            Err.clear
                            
                        End If
                        '#####################################################################
                    Else
                        schlagwort=""
                    End If	
                    
                    If schlagwort <>"" Then
                        zusfeldzaehler=zusfeldzaehler+1
                        zwischenwert(u)=schlagwort
                    End If
                End If
                
                positionaktuell=pos1  
                
            Else
				if searchflag(u) = 4 Then
					abbruch = True
				Elseif found = True And searchflag(u) = 3 Then
					If continue(u)=False Then
						abbruch=True
					End If
				Elseif found = False And searchflag(u) = 3 Then
					' wenn regex verwendet wird und es gibt kein match, kann unabhngig
					' von continue und exclude abgebrochen werden
					If noregexmatch=True Then
						abbruch=True
					Else
						If continue(u)=False And exclude(u) = "" Then
							abbruch=True
						End If
					End if
				Elseif found = False Then
					If continue(u)=False Then
						abbruch=True
					End If
				End If
            End If		'If (InStr(1,kette,searchstring(u),1)<>0)
            

			

            stringlaenge=stringlaenge-(positionaktuell+strlen)

            If stringlaenge < 0 Then
                abbruch=True
            Else
                If Len(kette)>=stringlaenge Then
                    kette=Right(kette,stringlaenge)
                    
                Else
                    kette=" "
                    abbruch=True
                End If
            End If 
            positionaktuell=1
            
            
            
			
            '#######################  schreiben in externe Datei   ###########	
            If searchflag(u)=1 Then
                
                Err.clear	
                Set externdatei = fs.OpenTextFile(externname,8,True,0)
                If Err.number <> 0 Then
                    Err.clear
                    errortxt="archivierung: Fehler bei Verbuchung in Datei "&externname&". Kein Zugriff auf Ordner? In Garbage verschoben."	
                    objWshShell.LogEvent 1, errortxt
                    GetGarbage(tempname)
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If
                
                If newextern=True Then
                    externdatei.writeline("")
                    newextern=False
                End If
                If schlagwort<>"" Then
                    externdatei.Write(schlagwort&"	")
                End If
                If Err.number <> 0 Then
                    Err.clear	
                    errortxt="archivierung: Fehler bei Verbuchung in Datei "&externname&". Kein Zugriff auf Ordner? In Garbage verschoben."
                    objWshShell.LogEvent 1, errortxt
                    GetGarbage(tempname)
                    Unlock(programm&lockdatei)
                    WScript.Quit
                End If
                externdatei.close
                Set externdatei=Nothing
                Err.clear
            End If
            
            If masklinkflag = 0 And ((linkflag(u)=>32) And (linkflag(u)<64)) Or ((linkflag(u)=>96) And (linkflag(u)<128)) Or ((linkflag(u)=>160) And (linkflag(u)<192)) Or ((linkflag(u)=>224) And (linkflag(u)<256))  Then
                If schlagwort<>"" Then
                	If IsInArray(schlagwort, linkspeicher) = False Then
                    	linkspeicher(linkzaehler)=schlagwort
                    	linkzaehler=linkzaehler+1
                    End If
                End If
            End If
            
            
			
            '#####################################################################
            
            If (schlagwort="") And (searchstring(u)<>"") And Len(continuezusatzfeld(u)) < 1 Then
                If overridecheck=False Then
                    notifyUser=True
                    If notiz <> "" Then
                        If InStr(notiz,"nicht indiziert werden")<> 0 Then
                            notiz = "Das Dokument konnte nicht zufriedenstellend indiziert werden. Bitte berprfen Sie den Volltext/Verschlagwortung und fgen Sie bei Bedarf manuell Suchbegriffe (Schlagworte) hinzu."
                        End If
                    Else
                        notiz = "Mind. ein Zusatzfeld konnte nicht automatisch befllt werden"
                    End If
                End If
            End If 
            
			
			

            
            For x=0 To limit
                If zwischenwert(x)<>"" Then
                    If  (LCase(searchstring(x))="userinput") Then
                        
                        For i=0 To limit
                            If LCase(zusatzfeldname(i))=LCase(zwischenname(x)) Then
                                If continue(x)=True Then
                                    If zusatzfeld(i) <> "" Then
                                        continuezusatzfeld(i) = zusatzfeld(i)
                                    End If
                                    If continuezusatzfeld(i) ="" Then
                                        continuezusatzfeld(i) = zwischenwert(x)
                                    Else
                                        continueWerteArr = Split(continuezusatzfeld(i), ";")
                                        wertFound = False
                                        tempArrLen = UBound(continueWerteArr)
                                        For zv = 0 To tempArrLen
                                            If continueWerteArr(zv)=zwischenwert(x) Then
                                                wertFound = True
                                            End If
                                        Next
                                        If wertFound = False Then
                                            continuezusatzfeld(i) = continuezusatzfeld(i) & ";" & zwischenwert(x) 
                                        End If
                                        
                                    End If
                                    continuezusatzfeldname(i) = zusatzfeldname(i)
                                Else
                                    zusatzfeld(i)=zwischenwert(x)
                                End If
                            End If
                        Next
                        
                    Else
                        
                        For i=0 To limit
                            If (LCase(zusatzfeldname(i))=LCase(zwischenname(x))) And (zusatzfeld(i)="" Or zusatzfeld(i)="$$$" Or continue(x)=True) Then
                                If continue(x)=True Then
                                    If zusatzfeld(i) <> "" Then
                                        continuezusatzfeld(i) = zusatzfeld(i)
                                    End If
                                    If continuezusatzfeld(i) ="" Then
                                        continuezusatzfeld(i) = zwischenwert(x)
                                    Else
                                        continueWerteArr = Split(continuezusatzfeld(i), ";")
                                        wertFound = False
                                        tempArrLen = UBound(continueWerteArr)
                                        For zv = 0 To tempArrLen
                                            If continueWerteArr(zv)=zwischenwert(x) Then
                                                wertFound = True
                                            End If
                                        Next
                                        If wertFound = False Then
                                            continuezusatzfeld(i) = continuezusatzfeld(i) & ";" & zwischenwert(x) 
                                            zusatzfeld(i) = continuezusatzfeld(i)
                                        End If
                                        
                                    End If
                                    continuezusatzfeldname(i) = zusatzfeldname(i)
                                Else
                                    zusatzfeld(i)=zwischenwert(x)
                                End If
                            End If
                        Next
                    End If
                End If
            Next
            

			
            buildlinks()
            schlagwort=""
            For x = 0 To limit
                zwischenwert(x)=""
            Next 
            
        Loop
        
        u=u+1
    Loop
    If pdf_xml_extract = True And extension=".pdf" And fs.fileexists(tempname&".pdf") And fs.fileexists(tempname&".xml") Then
    	fs.deletefile tempname&".xml", True
    End If
End Function

'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'**************************                getpositions                *********************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

Function getpositions(schlagwort,mycommandline)
    
    '**** zerlegt das Schlagwort und entnimmt nur die in der commandline angegebenen wrter
    '**** Dabei werden diese mit einem Pipe-Zeichen (|) getrennt. Im Viewer knnen diese
    '**** Datenstze dann als Tabellen angezeigt werden, z.B. als Kontierungstabelle
    
    If schlagwort<>"" Then
        '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        
        ReDim poscommand(limit)
        For x=0 To limit
            poscommand(x)=""
        Next
        
        commandcounter=0
        stringposition=0
        mycommand1=""
        mycommand2=""
        erledigt=False
        laengeS=Len(mycommandline)
        lauf=0
        
        Do While erledigt=False
            lauf=lauf+1
            stringposition=stringposition+1
            mycommand1=getcommand(mycommandline,stringposition)
            If mycommand1="" Then
                erledigt=True
                
            End If
            If stringposition>laengeS Then
                
                erledigt=True
            End If
            If (mycommand2<>mycommand1) And (erledigt=False) Then
                mycommand2=mycommand1
                poscommand(commandcounter)=mycommand2
                
                commandcounter=commandcounter+1
            End If
        Loop
        
        ergebnisschlagwort="" 
        commandcounter=0 
        erledigt=False
        Do While erledigt=False 
            
            mycommand=poscommand(commandcounter)
            
            mywordnumber=strconvert(mycommand)
            
            '++++++++++++++++++++++++++++++++++++++++++++++
            If (mywordnumber>0) And (Len(mycommand)=1) Then
                
                
                oldword=""
                newword=""
                laengeS=Len(schlagwort)-1
                wordcounter=0
                mywordposition=1
                newword=getword(schlagwort,mywordposition)
                
                oldword=newword
                abbr=False
                If mywordnumber=1 Then
                    abbruch=True
                    If ergebnisschlagwort="" Then
                        ergebnisschlagwort=newword
                    Else
                        ergebnisschlagwort=ergebnisschlagwort&"|"&newword
                    End If
                End If
                
                
                Do While abbr=False
                    newword=getword(schlagwort,mywordposition)
                    If newword<>oldword Then
                        wordcounter=wordcounter+1
                        If mywordnumber=wordcounter Then
                            abbr=True
                            If ergebnisschlagwort="" Then
                                ergebnisschlagwort=newword
                            Else
                                ergebnisschlagwort=ergebnisschlagwort&"|"&newword
                            End If
                        End If
                        oldword=newword
                    End If
                    
                    
                    mywordposition=mywordposition+1
                    
                    If mywordposition>laengeS Then
                        abbr=True
                        If ergebnisschlagwort="" Then
                            ergebnisschlagwort="(leer)"
                        Else
                            ergebnisschlagwort=ergebnisschlagwort&"|(leer)"
                        End If
                    End If
                Loop  
                
                
            End If
            '++++++++++++++++++++++++++++++++++++++++++++++
            
            commandcounter=commandcounter+1
            
            If poscommand(commandcounter)="" Then
                erledigt=True
            End If	
        Loop
        
        getpositions=ergebnisschlagwort
        
        '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    End If
    
End Function

'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'**************************                buildlinks                  *********************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

Function buildlinks()
    On Error Resume Next
	templimit = 200
    
    Dim feldname(10)
    Dim vbString(10)
    Dim temparray(200)
    stopflag=False
    For x=0 To 9
        feldname(x)=""
        vbString(x)=""
    Next
    For x=0 To templimit
        temparray(x)=""
    Next
    prestring=""
    
    
    
    For x=0 To limit
        If buildlink(x)<>"" Then
            For a=0 To templimit
                temparray(a)=""
            Next
            a=0
            
            erfolg=True
            
            kette=buildlink(x)
            
            
            
            i=0
            abbruch=False
            
            If Left(kette,1)<>"%" Then
                prestring=nextstring(kette)
                If Len(kette)>Len(prestring) Then
                    kette=Right(kette,Len(kette)-Len(prestring))
                End If
                For j=0 To templimit
                    temparray(j)=prestring
                Next
            End If
            
            
            
            Do While abbruch=False
                feldname(i)=nextfield(kette)
                
                If feldname(i)<>"" Then
                    kette=Right(kette,Len(kette)-Len(feldname(i))-1)
                    vbString(i)=nextstring(kette)
                    If Len(vbString(i))>0 Then
                        kette=Right(kette,Len(kette)-Len(vbString(i)))
                    End If
                    i=i+1
                Else
                    abbruch=True
                End If
            Loop
            
            '################### link zusammenbauen #######################
            
            
            
            i=0
            abbruch=False
            kette=""
            
            If feldname(i)="" Then 
                abbruch=False
            End If
            Do While abbruch = False
                gefunden=False
                s=0
                Do While gefunden=False
                    If zusatzfeldname(s)=feldname(i) Then
                        If zusatzfeld(s)="" Or zusatzfeld(s) = "$$$" Then
                            stopflag=True
                        End If
                        gefunden=True
                        gefunden1=False
                        
                        pos1=1
                        pos2=1
                        a=0
                        fertig1=False
                        
                        Do While fertig1=False
                            abbruch1=False
                            
                            Do While abbruch1=False
                                If Len(zusatzfeld(s)>pos2) Then
                                    If Mid(zusatzfeld(s),pos2,1)=";" Then
                                        gefunden1=True
                                        abbruch1=True
                                    End If
                                End If
                                If pos2>=Len(zusatzfeld(s)) Then
                                    abbruch1=True
                                    fertig1=True
                                End If
                                
                                pos2=pos2+1
                                
                            Loop
                            
                            If pos2>Len(zusatzfeld(s)) Then
                                pos2=Len(zusatzfeld(s))+2
                            End If
                            
                            If gefunden1=True Then
                                If Mid(zusatzfeld(s),pos1,pos2-pos1)<>"" Then
                                    zwischenstring=Trim(Mid(zusatzfeld(s),pos1,(pos2-pos1)-1))
                                    If Left(zwischenstring,1)=";" Then
                                        zwischenstring=Trim(Right(zwischenstring,Len(zwischenstring)-1))
                                    End If
                                    If Right(zwischenstring,1)=";" Then
                                        zwischenstring=Trim(Left(zwischenstring,Len(zwischenstring)-1))
                                    End If
                                    
                                    
                                    temparray(a)=temparray(a)&Zwischenstring&vbString(i)
                                    
                                    a=a+1
                                Else
                                    temparray(a)=temparray(a)&""
                                End If
                            Else	
                                If zusatzfeld(s)<>"" Then
                                    For v=0 To templimit
                                        temparray(v)=temparray(v)&zusatzfeld(s)&vbString(i)
                                    Next
                                End If
                                
                            End If
                            
                            
                            If fertig1=False Then
                                
                                pos1=pos2
                                pos2=pos1
                            End If
                        Loop
                        If gefunden1=True Then
                            Do While a<=templimit
                                temparray(a)=temparray(a)&""
                                a=a+1
                            Loop
                        End If
                        
                        
                    End If
                    s=s+1
                    If s=limit Then
                        gefunden=True
                    End If
                Loop
                i=i+1
                If feldname(i)="" Then
                    abbruch=True
                End If
            Loop
            
            
            For a=0 To templimit
                
                
                If (temparray(a)<>"") And (Len(temparray(a))>2) And (InStr(1,temparray(a),"",1)=0) Then
                    
                    gefunden=False
                    v=0
                    abbruch=False
                    Do While abbruch=False
                        If v>limit Then
                            abbruch=True
                        End If
                        If linkspeicher(v)=temparray(a) Then
                            gefunden=True
                            abbruch=True
                        End If
                        If linkspeicher(v)="" Then
                            abbruch=True
                        End If
                        If abbruch=False Then
                            v=v+1
                        End If
                    Loop
                    If (gefunden=False) And (stopflag=False) Then
						If IsInArray(temparray(a), linkspeicher) = False Then
							linkspeicher(linkzaehler)=temparray(a)
							linkzaehler=linkzaehler+1
						End If
                        If linkzaehler=linklimit Then
                            errortxt="archivierung(142): Speicherberlauf"	
                            objWshShell.LogEvent 1, errortxt
                        End If
                    End If
                End If
                
            Next
            stopflag = False
        End If
    Next
    
    
End Function

Private Function Nextfield(kette)
    On Error Resume Next
    
    pos1=1
    laenge=Len(kette)
    abbruch=False
    gefunden=False
    If laenge<2 Then 
        abbruch=True
    End If
    
    Do While abbruch=False
        If pos1=laenge Then
            abbruch=True
        End If
        If Mid(kette,pos1,1)="%" Then
            abbruch=True
            gefunden=True
        End If
        
        If abbruch=False Then
            pos1=pos1+1
        End If
    Loop
    If gefunden=True Then
        kette=Right(kette,laenge-pos1)
        laenge=Len(kette)
        abbruch=False
        gefunden=False
        If laenge<1 Then
            abbruch=True
        End If
        pos2=1
        Do While abbruch=False
            If pos2=laenge Then
                abbruch=True
            End If
            If Mid(kette,pos2,1)="%" Then
                abbruch=True
                gefunden=True
            End If
            
            If abbruch=False Then
                pos2=pos2+1
            End If
        Loop
    End If
    If gefunden=True Then
        Nextfield=Left(kette,pos2-1)
    Else
        Nextfield=""
    End If
End Function


Private Function Nextstring(kette)
    On Error Resume Next
    
    pos1=1
    laenge=Len(kette)
    abbruch=False
    gefunden=False
    If laenge<2 Then 
        abbruch=True
    End If
    
    Do While abbruch=False
        If pos1=laenge Then
            abbruch=True
        End If
        If Mid(kette,pos1,1)="%" Then
            abbruch=True
            gefunden=True
        End If
        
        If abbruch=False Then
            pos1=pos1+1
        End If
    Loop
    
    If gefunden=True Then
        Nextstring=Left(kette,pos1-1)
    Else
        Nextstring=kette
    End If
End Function





'************************************************************************
'************************************************************************


Function filtermailattachments(tempname)
    On Error Resume Next
    
    If InStr(tempname,"temp-msg")<> 0 Or InStr(tempname,"temp-eml") <> 0 Then
        erlaubt = False		
        If scriptdebug=True Then
            objWSHShell.LogEvent 4, "archivierung debug filtermailattachments gestartet auf " & tempname
        End If
     
        If emailwhite="" And emailblack="" Then
            erlaubt = True
        Else
            If emailwhite <> "" Then
                If InStr(1,emailwhite,extension) <> 0 Or emailwhite = "" Then
                    erlaubt = True
                Else
                    erlaubt = False
                End If
            ElseIf emailblack <> "" Then
                If InStr(1,emailblack,extension) = 0  Then
                    erlaubt = True
                End If
            End If
        End If
        
        If extension = "" And emailacceptnoextension = True Then
            erlaubt = True
        End If
        
        If ((extension = "") Or (extension = ".asc")) And (emailacceptnoextension = False) Then
            erlaubt = False
        End If
        
        If myname = "textpart.txt" Then
            erlaubt = True
            If Betreff = "" Then
                myname="E-Mail Nachricht"
            Else
                myname = normstring(Betreff)
            End If
            
        End If
        If scriptdebug=True Then
            objWSHShell.LogEvent 4, "archivierung debug filtermailattachments " & tempname & " = " & erlaubt
        End If
        If erlaubt=False Then
            aufraeumen(tempname)
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
    End If    
End Function




'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function changetemplate(newtemplate)
    On Error Resume Next
    
    changetemplate=True
    templatefile=templates&newtemplate&".tpl"
    If Not fs.FileExists(templatefile) Then
        Err.clear
        errortxt=templatefile&" Datei nicht vorhanden oder nicht lesbar. (changetemplate)"
        objWshShell.LogEvent 1, errortxt
        changetemplate=False
        Err.clear
    End If
    If changetemplate=True Then
        Err.clear
        
        fs.deletefile tempname&".job", True
        If Err.number<>0 Then
            errortxt="archivierung(FD): Sortieren: Lschen der alten JOB-Datei nicht mglich. "&Err.number	
            objWshShell.LogEvent 1, errortxt
            GetGarbage(tempname)
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
        WScript.Sleep 50
        fs.copyfile templatefile, tempname&".job", True
        WScript.Sleep 50
        If Not fs.fileexists(tempname&".job") Then
            errortxt="archivierung(FD): Sortieren: Nach umkopieren keine JOB-Datei vorhanden. "
            objWshShell.LogEvent 1, errortxt
            GetGarbage(tempname)
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
        
        erfolg=writejob(tempname)
        If erfolg=False Then
            changetemplate=False
            objWshShell.LogEvent 1, "Archivierung(FD): Changetemplate: Fehler writejob."
        End If
        If changetemplate=True Then
            erfolg=readjob(tempname)
            If erfolg=False Then
                changetemplate=False
                objWshShell.LogEvent 1, "Archivierung(FD): Changetemplate: Fehler readjob."
            End If
        End If
        
        If changetemplate=True Then
            erfolg=readconfig(profil)
            If erfolg=False Then
                changetemplate=False
                objWshShell.LogEvent 1, "Archivierung(FD): Changetemplate: Fehler redconfig."
            End If
            errfile=errfile & vbTab & Err.Description
            Err.clear
        End If
    End If
    
End Function



'***************************************************************************************
'***************************************************************************************
'***************************************************************************************


Function getnewtable(sortto)
    On Error Resume Next
    
    getnewtable="archivdummy"
    Err.clear
    
    templatefile=templates&sortto&".tpl"
    
    If Not fs.FileExists(templatefile) Then
        Err.clear
        errortxt=templatefile&" Datei nicht vorhanden oder nicht lesbar. (Sortierung)"
        objWshShell.LogEvent 1, errortxt
        getnewtable=""
        Err.clear
    End If
    
    If getnewtable="archivdummy" Then	
        Set jobfile = fs.OpenTextFile(templatefile,1)
        If Err.number Then
            Err.clear
            errortxt="Template nicht vorhanden oder nicht lesbar. (Sortierung)"
            objWshShell.LogEvent 1, errortxt
            getnewtable=""
            
            
        End If 
    End If
    
    
    If getnewtable="archivdummy" Then
        
        Do While jobfile.AtEndOfStream <> True
            kette=jobfile.readline
            If Left(kette,1)<>";" Then
                
                
                If InStr(1,kette,"Name=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Name=",1)+5)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        laenge=Len(kette)+1
                        pos1=InStr(1,kette,"Name=",1)+5
                        wert=Mid(kette,pos1,laenge-pos1)
                        getnewtable = wert
                    End If
                End If 
                
            End If
            
        Loop
        jobfile.close
        Set jobfile = Nothing
        
    End If
    If getnewtable="archivdummy" Then
        getnewtable=""
    End If
    
End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************



Function readjob(tempname)
    On Error Resume Next
    Err.Clear
    readjob=True
    
    If Not fs.FileExists(tempname&".job") Then
        Err.clear
        WScript.sleep 1000
        If Not fs.FileExists(tempname&".job") Then
            errortxt=tempname&".job Datei nicht vorhanden oder nicht lesbar."
            objWshShell.LogEvent 1, errortxt
            readjob=False
            Err.clear
        End If
    End If
    
    If readjob=True Then	
        Set jobfile = fs.OpenTextFile(tempname&".job",1)
        If Err.number Then
            Err.clear
            WScript.sleep 1000
            If Not fs.FileExists(tempname&".job") Then
                Set jobfile = fs.OpenTextFile(tempname&".job",1)
                errortxt="Jobdatei nicht vorhanden oder nicht lesbar."
                objWshShell.LogEvent 1, errortxt
                readjob=False
            End If
        End If 
    End If
    
    
    If readjob = True Then
        
        Do While jobfile.AtEndOfStream <> True
            kette=jobfile.readline
            If Left(kette,1)<>";" Then
                
                If Left(kette,8) ="Referenz"  And linkzaehler < linklimit Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"=",1)))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
						If IsInArray(Trim(wert), linkspeicher) = False Then
							linkspeicher(linkzaehler)=Trim(wert)
							
							If (linkspeicher(linkzaehler)<>"") And (LCase(Left(linkspeicher(linkzaehler),7))<>"doclink") Then
								checkOCR=False
							End If
							linkzaehler=linkzaehler+1
						End If
                        
                    End If
                End If
                
                If InStr(1,kette,"Profil=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Profil=",1)+7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Profil = wert
                    End If
                End If
                
                If InStr(1,kette,"OCR_Typ=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"OCR_Typ=",1)+8)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        
                        Typ = wert
                    Else
                        Typ = "MAN"	
                    End If
                End If
                
                If Left(kette,5)="Name=" Then
                    wert=Right(kette,Len(kette)-5)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                 
                        Tabelle = wert
                    End If
                    
                End If 
                
                If InStr(1,kette,"Filter=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Filter=",1)+7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Filtermakro = wert
                        If InStr(1,LCase(wert),"color",1)<>0 Then
                            color=True
                        End If
                        If InStr(1,LCase(wert),"highres",1)<>0 Then
                            autoshrinkjpg=0
                            hires=True
                        End If
                        If Len(filtermakro)>3 Then
                            If LCase(Right(filtermakro,4))=".tif" Then
                                If myform="" Then
                                    myform=filtermakro
                                End If
                            End If
                        End If
                    End If
                End If
                
                If Left(kette, 6) = "Datum=" Then
                    wert=GetString(kette,InStr(1,kette,"Datum=",1)+6)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        laenge=Len(kette)+1
                        pos1=InStr(1,kette,"Datum=",1)+6
                        wert=Mid(kette,pos1,laenge-pos1)
                        dokdate = wert
                    End If
                    
                End If 
                
                
                
                If InStr(1,kette,"DOCID=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"DOCID=",1)+5)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        dokID = wert
                    End If
                End If
                
                If InStr(1,kette,"Titel=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Titel=",1)+5))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        myname = wert
                    End If
                End If
                
                If InStr(1,kette,"Benutzer=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Benutzer=",1)+8))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        username=Trim(wert)
                    End If
                End If
                
                If InStr(1,kette,"Tabelle=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Tabelle=",1)+7))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        folderID = wert
                    End If
                End If
                
                If InStr(1,kette,"Quelle=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Quelle=",1)+6))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        quelle = wert
                    End If
                End If
                
                If InStr(1,kette,"Orginal=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Orginal=",1)+7))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Orginal = wert
                    End If
                End If
                
                
                If InStr(1,kette,"Status=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Status=",1)+7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        oldstatus = wert
                    End If
                End If
                
                If InStr(1,kette,"clientID=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"clientID=",1)+8)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        clientID = wert
                    End If
                End If
                
                If InStr(1,kette,"Bearbeiter=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Bearbeiter=",1)+10))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        backupbearbeiter = wert
                    End If
                End If
                
                If InStr(1,kette,"Notiz=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Notiz=",1)+5))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        backupnotiz = wert
                    End If
                End If
                
                If InStr(1,kette,"Termin=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Termin=",1)+6))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        backuptermin = wert
                    End If
                End If
                
                If InStr(1,kette,"Alarm=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Alarm=",1)+5))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        backupalarm = wert
                    End If
                End If
                
                
                If InStr(1,kette,"TimerOptionen=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"TimerOptionen=",1)+13))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        backupoptionen = wert
                    End If
                End If
                
                If InStr(1,kette,"Felder=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Felder=",1)+7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Zusatzfelder = strconvert(wert)
                        If Zusatzfelder > limit Then
                            errortxt="Jobdatei: mehr als "&limit&" Zusatzfelder werden nicht untersttzt."
                            objWshShell.LogEvent 1, errortxt
                            readjob=False
                        End If
                    End If
                End If
                
                
                If InStr(1,kette,"ZusTitel",1)<>0 Then
                    
                    wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"ZusTitel",1)+9)))
                    If Len(wert)>0 Then
                        If Left(wert,1)="=" Then
                            wert=Right(wert,Len(wert)-1)
                        End If
                    End If
                    
                    aussortieren=True
                    For a=1 To Len(wert)
                        If (Mid(wert,a,1)<>" ") And (Mid(wert,a,1)<>".") Then
                            aussortieren=False
                        End If
                    Next
                    If aussortieren=True Then
                        wert=""
                    End If
                    
                    
                    gefunden=False
                    x=0
                    Do While gefunden=False
                        If Zusatzfeldname(x)=wert Then
                            gefunden=True
                        End If
                        
                        If Zusatzfeldname(x)="" Then
                            gefunden=True
                            Zusatzfeldname(x)=wert
                            Zusatzfeldname2(x)=wert     ' nur zum Abgleich fr Writeschlagwort
                        End If
                        If gefunden=False Then
                            x=x+1
                        End If
                    Loop
                    
                End If
                
                If InStr(1,kette,"ZusWert",1)<>0 Then
                    
                    wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"ZusWert",1)+8)))
                    If Len(wert)>0 Then
                        If Left(wert,1)="=" Then
                            wert=Right(wert,Len(wert)-1)
                        End If
                    End If
                    
                    aussortieren=True
                    For a=1 To Len(wert)
                        If (Mid(wert,a,1)<>" ") And (Mid(wert,a,1)<>".") Then
                            
                            aussortieren=False
                        End If
                    Next
                    If aussortieren=True Then
                        wert=""
                    End If
                    
                    

                    If ((Len(wert)>0) And (wert<>" ") And (wert<>"	")) Or writeempty=True Then
                        Zusatzfeld(x)=wert
                        checkOCR=False
                    End If
                    
                End If
                
            End If
            
        Loop
        jobfile.close
        Set jobfile = Nothing
        
    End If
    
    
End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

'*******************************************************************************
Function appendBackslash(thepath)
    If Right(thepath,1)<>"\" Then
        thepath=thepath&"\"
    End If
    appendBackslash=thepath
End Function
'*******************************************************************************



Function readconfig(profil)
    On Error Resume Next
    readconfig=True
    Err.clear
    If Not fs.FileExists(programm&profil&".con") Then
        Err.clear
        errortxt=profil&".con Datei nicht im Scriptpfad vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        readconfig=False
        Err.clear
    End If
    
    If readconfig=True Then	
        Set confile = fs.OpenTextFile(programm&profil&".con",1)
        If Err.number Then
            Err.clear
            errortxt="Profilfdatei nicht im Scriptpfad vorhanden oder nicht lesbar."
            objWshShell.LogEvent 1, errortxt
            Err.clear
            readconfig=False
            
        End If 
    End If
    
    If readconfig=True Then	
        kette=confile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        Do While Scriptsflag = 0
            kette=confile.readline
            Scriptsflag=InStr(1,kette,"[Scripts]")
            If confile.AtEndOfStream = True Then
                confile.close
                Set confile=Nothing
                scriptsflag=1
                errortxt="Fehler beim Lesen der CON-Datei - falsche Formatierung."
                objWshShell.LogEvent 1, errortxt
                readconfig = False     
            End If
        Loop  
    End If
    
    
    If readconfig = True Then
        Do While confile.AtEndOfStream <> True
            kette=Trim(confile.readline)
            kette = Replace(kette,vbTab,"")
            kette = Replace(kette," = ", "=")
            If Left(kette,1)<>";" Then
                
                If InStr(1,kette,"clientprogram",1)<>0 Then
                    wert = Right(kette,Len(kette) -14)
                    clientprogram = Trim(wert)
                End If
                
                If Left(kette,13) = "clientspooler" Then
                    wert = Right(kette,Len(kette) -14)
                    clientspooler = Trim(wert)
                End If
                
                If Left(kette,16) = "uncclientspooler" Then
                    wert = Right(kette,Len(kette) -17)
                    uncclientspooler = Trim(wert)
                End If
                
                If InStr(1,kette,"archivverzeichnis",1)<>0 Then
                    wert = Right(kette,Len(kette) -18)
                    archivverzeichnis = Trim(wert)
                End If
                
                If InStr(1,kette,"archivkopie",1)<>0 Then
                    wert = Right(kette,Len(kette) -12)
                    archivkopie = Trim(wert)
                End If
                
                
                If InStr(1,kette,"storages",1)<>0 Then
                    wert = Right(kette,Len(kette) -9)
                    storages = Trim(wert)
                End If
                
                If InStr(1,kette,"archive_rs",1)<>0 Then
                	wert = Right(kette,Len(kette) -11)
                    archive_rs = Trim(wert)
                End If
                
                If InStr(1,kette,"archive_nrs",1)<>0 Then
                	wert = Right(kette,Len(kette) -12)
                    archive_nrs = Trim(wert)
                End If
                
                
                If InStr(1,kette,"gsview",1)<>0 Then
                    'wert=GetString(kette,InStr(1,kette,"gsview",1)+6)
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"gsview",1)+6))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        gsview = wert
                    End If
                End If
                
                
                If InStr(1,kette,"omnipage",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"omnipage=",1)+8))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        omnipage = Trim(wert)
                    End If
                End If
                
                If InStr(1,kette,"ghostscript",1)<>0 Then
                    wert = Right(kette,Len(kette) -12)
                    ghostscript = Trim(wert)
                End If
                
                If InStr(1,kette,"gsview",1)<>0 Then
                    wert = Right(kette,Len(kette) -7)
                    gsview = Trim(wert)
                End If		
                
                
                
                If InStr(1,kette,"druckserver1",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"druckserver1",1)+12)
                    druckserver1 = wert
                End If		
                
                If InStr(1,kette,"druckserver2",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"druckserver2",1)+12)
                    druckserver2 = wert
                End If
                
                If InStr(1,kette,"druckserver3",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"druckserver3",1)+12)
                    druckserver3 = wert
                End If
                
                If InStr(1,kette,"druckserver4",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"druckserver4",1)+12)
                    druckserver4 = wert
                End If
                
                If InStr(1,kette,"smtpserver",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"smtpserver",1)+10)
                    smtpserver = wert
                End If
                
                If InStr(1,kette,"authuser",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"authuser",1)+8)
                    authuser = wert
                End If
                
                If InStr(1,kette,"authpass",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"authpass",1)+8)
                    authpass = wert
                End If
                
                If InStr(1,kette,"backuppath",1)<>0 Then
                    wert = Right(kette,Len(kette) -11)
                    backuppath = Trim(wert)
                End If
                
                If InStr(1,kette,"backupstart",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"backupstart",1)+11)
                    backupstart = wert
                End If
                
                If InStr(1,kette,"sqldatapath",1)<>0 Then
                    wert = Right(kette,Len(kette) -12)
                    sqldatapath = Trim(wert)
                End If
                
                If InStr(1,kette,"sendername",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"sendername",1)+10)
                    sendername = wert
                End If
                
                If InStr(1,kette,"schattenarchiv",1)<>0 Then
                    wert = Right(kette,Len(kette) -15)
                    If LCase(wert)="true" Then
                        schattenarchiv=True
                    Else
                        schattenarchiv=False
                    End If
                End If
                
                If InStr(1,kette,"dublettenpruefung",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"dublettenpruefung",1)+17)
                    
                    If LCase(wert)="true" Then
                        dublettenpruefung=True
                    Else
                        dublettenpruefung=False
                    End If
                    
                End If
                If InStr(1,kette,"dublettenmail",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"dublettenmail",1)+13)
                    If LCase(wert)="true" Then
                        dublettenmail=True
                    Else
                        dublettenmail=False
                    End If
                    
                End If
                
                If InStr(1,kette,"adminmail",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"adminmail",1)+9)
                    adminmail = Trim(wert)
                End If
                
                If InStr(1,kette,"templates",1)<>0 Then
                    wert = Right(kette,Len(kette) -10)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        templates=Trim(wert)
                        templates=appendBackslash(templates)
                    End If
                End If	
                
                If InStr(1,kette,"plugins",1)<>0 Then
                	If Left(kette, 7) = "plugins" Then
	                    wert = Right(kette,Len(kette) -8)
                    	If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
	                        pluginspath=Trim(wert)
                        	pluginspath=appendBackslash(pluginspath)
                    	End If
                   	End If
                End If
                
                If InStr(1,kette,"masks",1)<>0 Then
                    wert = Right(kette,Len(kette) -6)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        masks=Trim(wert)
                        masks=appendBackslash(masks)
                    End If
                End If	
                
                If Left(Trim(LCase(Replace(kette,vbTab,""))),9)="workflows" Then
                    wert = Right(kette,Len(kette) -10)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        workflows=Trim(wert)
                    End If
                End If	
                
                If InStr(1,kette,"unverteilt",1)<>0 Then
                    wert = Right(kette,Len(kette) -11)
                    unverteilt = Trim(wert)
                End If
                
                If InStr(1,kette,"workflowfile",1)<>0 Then
                    wert = Right(kette,Len(kette) -13)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        workflowfile=Trim(wert)
                    End If
                End If	
                
                If InStr(1,kette,"checksumfile",1)<>0 Then
                    wert = Right(kette,Len(kette) -13)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        checksumfilename=Trim(wert)
                    End If
                End If	
            End If
            
        Loop
        confile.close
        Set confile = Nothing
        
    End If
    
    
End Function

'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function readstring(strFilename,strSuchstring,bGetFirst)
    On Error Resume Next
    Err.clear
    
    
    readstring=""
    
    If fs.FileExists(strFilename) Then
        
        Set oFile = fs.OpenTextFile(strFilename,1)
        If Err.number<>0 Then
            objWSHShell.LogEvent 1,"Archivierung.vbs readstring: Konnte Datei " & strFilename & " nicht ffnen" & vbCrLf & Err.number & vbTab & Err.Descrition 
            
        Else
            Do While oFile.AtEndOfStream = False
                strinput = oFile.ReadLine
                If InStr(1,LCase(strinput),LCase(strSuchstring))<>0 Then
                    readstring=Right(strinput,Len(strinput)-Len(strSuchstring)-1)
                    If bGetFirst = True Then
                        Exit Do
                    End If
                End If
            Loop
        End If
        oFile.Close
        Err.clear
        Set oFile = Nothing
        
    End If
    
End Function



'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function writeBackupWV(tempname)
    On Error Resume Next
    writeBackupWV=True
    Err.clear
    
    If Not fs.FileExists(tempname&".job") Then
        Err.clear
        errortxt=tempname&".job Datei nicht vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        writeBackupWV=False
        Err.clear
    End If
    
    If writeBackupWV=True Then	
        Set quelljobfile = fs.OpenTextFile(tempname&".job",1)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writeBackupWV=False
            
        End If 
    End If
    
    If writeBackupWV=True Then
        If fs.FileExists(tempname&".tmp") Then
            fs.DeleteFile(tempname& ".tmp")
            If Err.number Then
                Err.clear
                errortxt="Zwischendatei fr Jobdatei existierte noch, kann diese aber nicht lschen."
                objWshShell.LogEvent 1, errortxt
                writeBackupWV=False
                quelljobfile.close
                Set quelljobfile=Nothing
            End If 
            
        End If	
    End If
    
    If writeBackupWV=True Then
        Set zieljobfile = fs.OpenTextFile(tempname&".tmp",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writeBackupWV=False
            quelljobfile.close
            Set quelljobfile=Nothing
        End If 
    End If
    
    
    If writeBackupWV = True Then
        ersatzstring=""
        'newstatflag="+1"
        mystatus=0
        If Len(newstatflag)>0 Then
            mystatus=strconvert(newstatflag)
        End If
        
        mystatus=mystatus Or 1
        newstatflag=""
        newstatflag=newstatflag&mystatus
        
        newstatus="Dokument bei folgenden Benutzern / Gruppen in die Wiedervorlage gelegt: "&backupbearbeiter
        ReDim params(10)
        params(1)=backupbearbeiter
        newstatus=getstatustext("status10",params) &showhost
        notiz="Autonotiz: Dokument zur Info / Bearbeitung"
        Termin=Date()
        Alarm=Date()+7
        optionen=""
        controller=""
        
        If backuptermin<>"" Then
            termin=backuptermin
        End If
        
        If backupalarm<>"" Then
            alarm=backupalarm
        End If
        
        If backupnotiz<>"" Then
            notiz=backupnotiz
        End If
        
        If backupoptionen<>"" Then
            optionen=backupoptionen
        End If
        
        stopflag=False
        ersatzstring=""	
        ref = 1
        Do While quelljobfile.AtEndOfStream <> True
            kette=quelljobfile.readline
            ersatzstring=""
            If InStr(1,kette,"Referenz",1)<>0 Then
                zieljobfile.writeline("Referenz" & ref & "=")
                ref = ref + 1
                If quelljobfile.AtEndOfStream<>True Then
                    kette=quelljobfile.readline
                End If
            End If
            
            If InStr(1,kette,"Anzahl=",1)<>0 Then
                ersatzstring="Anzahl=0"
            End If
            
            If (InStr(1,kette,"Termin=",1)<>0) Then
                ersatzstring="Termin="&Termin
            End If
            
            If (InStr(1,kette,"Alarm=",1)<>0) Then
                ersatzstring="Alarm="&Alarm
            End If
            
            If (InStr(1,kette,"Benutzer=",1)<>0) Then
                ersatzstring="Benutzer="&username
            End If
            
            If (InStr(1,kette,"Bearbeiter=",1)<>0) Then
                ersatzstring="Bearbeiter="&backupbearbeiter
            End If
            
            If (InStr(1,kette,"Notiz=",1)<>0) Then
                ersatzstring="Notiz="&notiz
            End If
            
            If (InStr(1,kette,"TimerOptionen=",1)<>0) Then
                ersatzstring="TimerOptionen="&optionen
            End If
            

            
            If (dokID<>"") And (InStr(1,kette,"DOCID=",1)<>0) Then
                ersatzstring="DOCID="&dokID
            End If
            
          
            
            
            If InStr(1,kette,"Status=",1)<>0 Then
                ersatzstring="Status="&newstatflag
            End If
            
            If InStr(1,kette,"StatStr=",1)<>0 Then
                ersatzstring="StatStr="&newstatus
            End If
            

            If ersatzstring<>"" Then
                zieljobfile.writeline(ersatzstring)
            Else
                zieljobfile.writeline(kette)
            End If
        Loop
        quelljobfile.close
        Set quelljobfile = Nothing
        zieljobfile.close
        Set zieljobfile=Nothing
        WScript.sleep 50
        
        Err.clear
        If fs.fileexists(tempname& ".job") Then
            fs.DeleteFile(tempname& ".job")
            If Err.number Then
                Err.clear
                errortxt="Fehler beim lschen der alten jobdatei."
                objWshShell.LogEvent 1, errortxt
                writeBackupWV=False
            End If 
        End If
        
        WScript.sleep 50
        
        If writeBackupWV = True Then
            fs.CopyFile tempname&".tmp", tempname&".job", True
            If Err.number Then
                Err.clear
                errortxt="Fehler beim umkopieren Jobdatei von " & tempname & ".tmp nach " & tempname & ".job"
                objWshShell.LogEvent 1, errortxt
                writeBackupWV=False
            End If 
        End If
        
        WScript.sleep 50
        If writeBackupWV = True Then
            fs.DeleteFile(tempname& ".tmp")
            If Err.number Then
                Err.clear
                errortxt="Fehler beim lschen der zwischen-jobdatei."
                objWshShell.LogEvent 1, errortxt
                writeBackupWV=False
            End If 
        End If
        WScript.sleep 50
    End If
    
    
End Function



'***************************************************************************************
'***************************************************************************************
'***************************************************************************************


Function writejob(tempname)
    On Error Resume Next
    writejob=True
    Err.clear
    
    
    gefunden=False
    getroffen=False
    i=0
    u=0
    Do While gefunden=False
        If zusatzfeldname(i)="Richtung" Then
            gefunden=True
            getroffen=True
            u=i
        End If
        If gefunden=False Then
            i=i+1
        End If
        If i=limit Then
            gefunden=True
        End If
    Loop
    If (getroffen=True) And (zusatzfeld(u)="") Then
        zusatzfeld(i)="Intern"
    End If
    If getroffen=False Then
        gefunden=False
        i=0
        Do While gefunden=False
            If zusatzfeldname(i)="" Then
                gefunden=True
            End If
            If gefunden=False Then
                i=i+1
            End If
            If i=limit Then
                gefunden=True
            End If
        Loop
        zusatzfeldname(i)="Richtung"
        zusatzfeld(i)="Intern"
        
    End If
    

    If Not fs.FileExists(tempname&".job") Then
        Err.clear
        errortxt=tempname&".job Datei nicht vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        writejob=False
        Err.clear
    End If
    
    If writejob=True Then	
        Set quelljobfile = fs.OpenTextFile(tempname&".job",1)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writejob=False
            
        End If 
    End If
    
    If writejob=True Then
        If fs.FileExists(tempname&".tmp") Then
            fs.DeleteFile(tempname& ".tmp")
            If Err.number Then
                Err.clear
                errortxt="Zwischendatei fr Jobdatei existierte noch, kann diese aber nicht lschen."
                objWshShell.LogEvent 1, errortxt
                writejob=False
                quelljobfile.close
                Set quelljobfile=Nothing
            End If 
            
        End If	
    End If
    
    If writejob=True Then
        Set zieljobfile = fs.OpenTextFile(tempname&".tmp",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writejob=False
            quelljobfile.close
            Set quelljobfile=Nothing
        End If 
    End If
    
    
    If writejob = True Then
        
        
        '#############################  aussortieren doppelter Links  #######################
        ReDim temparray(linklimit)
        For x=0 To linklimit
            temparray(x)=""
        Next
        
        
        For x=0 To linklimit
            If (linkspeicher(x)<>"") And (Len(linkspeicher(x))>1) Then
                a=0
                gefunden=False
                Do While gefunden=False
                    If temparray(a)="" Then
                        gefunden=True
                    End If
                    If linkspeicher(x)=temparray(a) Then
                        gefunden=True
                    End If
                    If gefunden=False Then
                        a=a+1
                    End If
                    If a>linklimit Then
                        a=linklimit
                        gefunden=True
                    End If
                Loop
                If linkspeicher(x)<>temparray(a) Then
                    temparray(a)=linkspeicher(x)
                End If
            End If
        Next
        
        For x=0 To linklimit
            linkspeicher(x)=""
        Next
        
        a=0
        abbruch=False
        Do While abbruch=False
            If temparray(a)<>"" Then
                linkspeicher(a)=temparray(a)
                a=a+1
            Else
                abbruch=True
            End If
            If a>linklimit Then 
                abbruch=True
            End If
        Loop
        linkzaehler=a
        
        
        '################################################################################
        
        
        
        
        Termin=Date()
        Alarm=Date()+7
        stopflag=False
        ersatzstring=""	
        foundpages=False
        foundsha1=False
        ausgabename_resolved = Ausgabename
        schattenname_resolved = schattenname
        quelle_resolved = Quelle
        
        If LCase(Left(Ausgabename, Len(storages)))<>LCase(storages) Then
        	Ausgabename = storages & Right(ausgabename_resolved, Len(ausgabename_resolved)-Len(archivbasedir))
        End If
        
        If LCase(Left(schattenname, Len(storages)))<>LCase(storages) Then
        	schattenname = storages & Right(schattenname_resolved, Len(schattenname_resolved)-Len(archivbasedir))
        End If
        
        If LCase(Left(quelle, Len(storages)))<>LCase(storages) Then
        	quelle = storages & Right(quelle_resolved, Len(quelle_resolved)-Len(archivbasedir))
        End If
        
        
        Do While quelljobfile.AtEndOfStream <> True
            kette=quelljobfile.readline
            
            If (InStr(1,kette,"[Referenz]",1)<>0) And (quelljobfile.AtEndOfStream <> True) Then
                If foundpages = False Then
                    zieljobfile.WriteLine "Pages=" & tifpagecount
                    foundpages = True
                End If
                
                abbruch=False
                Do While abbruch=False 
                    kette=quelljobfile.readline
                    If quelljobfile.AtEndOfStream = True Then
                        abbruch=True
                    End If
                    If (InStr(1,kette,"Referenz",1)=0) And (InStr(1,kette,"Anzahl",1)=0) Then
                        abbruch = True
                    End If
                Loop
                zieljobfile.writeline("[Referenz]")
                zieljobfile.writeline("Anzahl="&linkzaehler)
                x=0
                Do While x < linkzaehler
                    zieljobfile.writeline("Referenz"&x+1&"="&linkspeicher(x))
                    x=x+1
                    
                Loop
                
            End If
            
            
            
            
            If fromdirect=True Then
                checkOCR=False
            End If
            
            ersatzstring=""
            If oldstatus = "" Then
                oldstatus=0
            End If
            If nowarnings=True Then
                checkOCR=False
                notifyuser=False
            End If
            mystatus=oldstatus
            
            
            notifyuser=False ' in Absprache mit hs -> keine wvl mehr bei nicht befllten Zusatzfeldern
            If notifyuser=True Then
                mystatus=mystatus Or 1
                newstatflag=""
                newstatflag=newstatflag&mystatus
            End If
            
            If checkOCR=True Then
                mystatus=mystatus Or 1
                newstatflag=""
                newstatflag=newstatflag&mystatus
            End If
            
            If fromEMail=True Then
                checkOCR=False
            End If
            
            
            '###################################  wg. DBIMP-Fehler hier notwendig ##########################
            If fromdirect=True Then
                checkOCR=False
            End If
            
            If (createwvl=True) Then
                
                If (InStr(1,kette,"Termin=",1)<>0) Then
                    ersatzstring="Termin="&Termin
                End If
                
                If (InStr(1,kette,"Alarm=",1)<>0) Then
                    ersatzstring="Alarm="&Alarm
                End If
                
                If userwarnings = False Then
                    If (InStr(1,kette,"Benutzer=",1)<>0) Then
                        username = admin
                        ersatzstring="Benutzer="&username
                    End If
                End If
                
                If (InStr(1,kette,"Bearbeiter=",1)<>0) Then
                    
                    If LCase(username)="error" Then
                        username="System"
                    End If
                    If LCase(username)="administratoren" Then
                        username="System"
                    End If
                    
                    If (LCase(username)="system") And (admin<>"") Then
                        ersatzstring="Bearbeiter="&admin
                    Else	
                        ersatzstring="Bearbeiter="&username
                    End If
                End If
                
                If (InStr(1,kette,"Notiz=",1)<>0) Then
                    ersatzstring="Notiz=" & notiz
                End If
                
            Else
                
                If (InStr(1,kette,"Termin=",1)<>0) Then
                    ersatzstring="Termin="
                End If
                
                If (InStr(1,kette,"Alarm=",1)<>0) Then
                    ersatzstring="Alarm="
                End If
                
                If (InStr(1,kette,"Bearbeiter=",1)<>0) Then
                    ersatzstring="Bearbeiter="
                End If

                
                If (InStr(1,kette,"Notiz=",1)<>0) Then
                    ersatzstring="Notiz="
                End If
                
            End If
            
            
            If (myname<>"") And (InStr(1,kette,"Titel=",1)<>0) Then
                ersatzstring="Titel="&myname
            End If
            
            If (dokID<>"") And (InStr(1,kette,"DOCID=",1)<>0) Then
                ersatzstring="DOCID="&dokID
            End If
            
            
            If (Ausgabename<>"") And (dokID="") And (InStr(1,kette,"Orginal=",1)<>0) Then
                
                ersatzstring="Orginal="&Ausgabename&OCRHandle
            End If	
            
            If (changeling=False) And (Username<>"") And (InStr(1,kette,"Benutzer=",1)<>0) Then
                ersatzstring="Benutzer="&Username
            End If	
            
            If (changeling=True) And (InStr(1,kette,"Benutzer=",1)<>0) Then
                ersatzstring="Benutzer="
            End If
            
            If (Ausgabename<>"") And (InStr(1,kette,"Volltext=",1)<>0) Then
                ersatzstring="Volltext="&Ausgabename&".txt"
            End If
            
            If (Typ<>"") And (InStr(1,kette,"OCR_Typ=",1)<>0) Then
                ersatzstring="OCR_Typ="&Typ
            End If
            
            If (Quelle<>"") And (InStr(1,kette,"Quelle=",1)<>0) Then
                ersatzstring="Quelle="&Quelle
            End If
            
            If (InStr(1,kette,"Kopie=",1)<>0) Then
                If docschangeable = False Then
	                schattenname = Replace(schattenname, archivverzeichnis, archivkopie)
	                If change_ext_loc = True Then
	                    If fs.getExtensionName(quelle)="jpg" And usejpgtotif=False Then
	                        newext=".jpg"
	                    Else
	                        newext=".tif"
	                    End If
	                    If fs.FileExists(schattenname & newext) Or fs.FileExists(schattenname_resolved & newext) Then
	                        ersatzstring="Kopie=" & schattenname & newext
	                    Else
	                        ersatzstring="Kopie="
	                    End If
	                Else
	                    If changeling=True And docschangeable=False Then
	                        ersatzstring="Kopie=" & schattenname & extension
	                    Else
	                        ersatzstring="Kopie="
	                    End If
	                End If
				Else
			        If changeling=True Then
			        	If fs.getExtensionName(quelle)="jpg" And usejpgtotif=False Then
	                        newext=".jpg"
	                    Else
	                        newext=".tif"
	                    End If
			        	schattenname = Replace(schattenname, archivverzeichnis, archivkopie)
	                    ersatzstring="Kopie=" & schattenname & newext
	                Else
	                    ersatzstring="Kopie="
	                End If
				End If                
            End If
            
            If InStr(1,kette,"Status=",1)<>0 Then
                ersatzstring = "Status="&mystatus
            End If
            
            If InStr(1,kette,"StatStr=",1)<>0 Then
                ersatzstring="StatStr="&newstatus  &showhost
            End If
            
            If InStr(1,kette,"OCR_QF=",1)<>0 Then
                If OCRQF>0 Then
                    ersatzstring="OCR_QF="&OCRQF
                Else
                    ersatzstring="OCR_QF=-1"
                End If
            End If
            
            If InStr(1,kette,"Schlagworte=",1)<>0 Then
                
                If fs.fileExists(tempname&".swd") Then
                    ersatzstring="Schlagworte="&tempname&".swd"
                Else
                    ersatzstring="Schlagworte="
                End If
            End If
            
            If (dokDate<>"") And (InStr(1,kette,"Datum=",1)<>0) Then
                ersatzstring="Datum="&DokDate
            End If
            
            If InStr(1,kette,"Filter=",1)<>0 Then
                If Filtermakro <> "" Then
                    ersatzstring="Filter="& filtermakro
                Else 
                    ersatzstring="Filter="
                End If
            End If
            
            If InStr(1,kette,"Pages=",1)<>0 Then
                ersatzstring="Pages="&tifpagecount
                foundpages = True
            End If
            
            If InStr(1,kette,"symlink=",1)<>0 Then
            	If Right(Trim(kette),1) <> "=" Then
            		symlinkstring = kette & ";"
            	Else
            		symlinkstring = kette
            	End If
            	For symind = 0 To limit
            		If symlinks(symind) <> "" And InStr(symlinkstring, symlinks(symind))=0 Then
            			symlinkstring = symlinkstring & symlinks(symind) & ";"	
            		End If
            	Next
            	If Right(symlinkstring, 1) = ";" Then
            		symlinkstring = Left(symlinkstring, Len(symlinkstring) - 1)
            	End If
            	
                ersatzstring=symlinkstring
                
            End If
            
            If InStr(1,kette,"Sha1=",1)<>0 Then
                ersatzstring="Sha1="&sha1
                foundsha1= True
            End If
            
            
            
            If Left(kette,8)="ZusTitel" Then
                For x=1 To limit
                    If InStr(1,kette,"ZusTitel"&x&"=",1)<>0 Then
   
                        wert = Trim(Right(kette,Len(kette)-InStr(1,kette,"=")))
                        
                        For w=0 To 58
                            If LCase(FileInfoDescription(w))=LCase(wert) Then
                                ersatzstring="ZusWert"&x&"="&FileInfoValue(w)
                                
                                '******************  Feld auch in Schlagwortdatei bernehmen
                                If fs.fileexists(tempname&".swd") Then
                                    Set zielswfile=fs.opentextfile(tempname&".swd",8,True)
                                    If (FileInfoValue(w)<>"") And (FileInfoDescription(w)<>"Gre") And (FileInfoDescription(w)<>"Typ") Then
                                        If swduplett(FileInfoValue(w))=False Then
                                            zielSWfile.writeline(FileInfoValue(w))
                                        End If
                                    End If
                                    zielswfile.close
                                    WScript.sleep 20
                                    Set zielswfile=Nothing
                                    WScript.sleep 30
                                End If
                            End If
                        Next
                        
                        For w=0 To limit
                            If LCase(Zusatzfeldname(w))=LCase(wert) Then
                                ersatzstring="ZusWert"&x&"="&Zusatzfeld(w)
                                
                                '******************  Feld auch in Schlagwortdatei bernehmen
                                If fs.fileexists(tempname&".swd") Then
                                    Set zielswfile=fs.opentextfile(tempname&".swd",8,True)
                                    If (Zusatzfeld(w)<>"") And (Zusatzfeldname(w)<>"Gre") And (Zusatzfeldname(w)<>"Typ") Then
                                        If swduplett(Zusatzfeld(w))=False Then
                                            zielSWfile.writeline(Zusatzfeld(w))
                                        End If
                                    End If
                                    zielswfile.close
                                    WScript.sleep 20
                                    Set zielswfile=Nothing
                                    WScript.sleep 30
                                End If
                            End If
                        Next
                        
                        zieljobfile.writeline(kette)
                        
                        If quelljobfile.AtEndOfStream <> True Then
                            kette=quelljobfile.readline
                            '############  hier wird ein Bug in den Job-Dateien abgefangen, formatierungsproblem mit mehreren = Zeichen bei mehr als 10 Zusatzfeldern
                            pos1=0
                            pos2=0
                            zaehler=1
                            laenge=Len(kette)
                            Do While zaehler<laenge
                                If Mid(kette,zaehler,1)="=" Then
                                    If pos1=0 Then
                                        pos1=zaehler
                                    Else
                                        pos2=zaehler
                                    End If
                                End If
                                zaehler=zaehler+1
                            Loop
                            If (pos1<>pos2) And (pos2<>0) Then
                                kette=Left(kette,pos1)&Right(kette,laenge-pos2)
                            End If
                            
                            '########################################
                            zieljobfile.writeline(kette)
                        End If
                        
                        If quelljobfile.AtEndOfStream <> True Then
                            kette=quelljobfile.readline
                        End If
                        
                    End If
                Next
                
            End If
            
            If ersatzstring<>"" Then
                zieljobfile.writeline(ersatzstring)
            Else
                zieljobfile.writeline(kette)
            End If
            
        Loop
        
        Ausgabename = ausgabename_resolved
        schattenname = schattenname_resolved
        Quelle = quelle_resolved

        
        If foundsha1 = False And opensslpath <> "" Then
            zieljobfile.WriteLine "[Hash]"
            zieljobfile.WriteLine "SHA1=" & sha1
            
        End If 
        
        quelljobfile.close
        Set quelljobfile = Nothing
        zieljobfile.close
        Set zieljobfile=Nothing
        WScript.sleep 50
        
        Err.clear
        If fs.fileexists(tempname& ".job") Then
            fs.DeleteFile(tempname& ".job")
            If Err.number Then
                Err.clear
                errortxt="Fehler beim lschen der alten jobdatei."
                objWshShell.LogEvent 1, errortxt
                writejob=False
            End If 
        End If
        
        
        WScript.sleep 50
        
        If writejob=True Then
            
            fs.CopyFile tempname&".tmp", tempname&".job", True
            If Err.number Then
                Err.clear
                errortxt="Fehler beim umkopieren Jobdatei."
                objWshShell.LogEvent 1, errortxt
                writejob=False
            End If 
        End If
        
        WScript.sleep 50
        If writejob=True Then
            fs.DeleteFile(tempname& ".tmp")
            If Err.number Then
                Err.clear
                errortxt="Fehler beim lschen der zwischen-jobdatei."
                objWshShell.LogEvent 1, errortxt
                writejob=False
            End If 
        End If
        WScript.sleep 50
        
    End If
    
    
End Function



Function writeemailjob(tempname)
    On Error Resume Next
    writeemailjob=True
    Err.clear
    
    
    gefunden=False
    getroffen=False
    i=0
    u=0
    
    
    If Not fs.FileExists(tempname&".job") Then
        Err.clear
        errortxt=tempname&".job Datei nicht vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        writejob=False
        Err.clear
    End If
    
    If writeemailjob=True Then	
        Set quelljobfile = fs.OpenTextFile(tempname&".job",1)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writeemailjob=False
            
        End If 
    End If
    
    If writeemailjob=True Then
        If fs.FileExists(tempname&".tmp") Then
            fs.DeleteFile(tempname& ".tmp")
            If Err.number Then
                Err.clear
                errortxt="Zwischendatei fr Jobdatei existierte noch, kann diese aber nicht lschen."
                objWshShell.LogEvent 1, errortxt
                writeemailjob=False
                quelljobfile.close
                Set quelljobfile=Nothing
            End If 
            
        End If	
    End If
    
    If writeemailjob=True Then
        Set zieljobfile = fs.OpenTextFile(tempname&".tmp",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writeemailjob=False
            quelljobfile.close
            Set quelljobfile=Nothing
        End If 
    End If
    
    
    If writeemailjob = True Then
        
        
        '#############################  aussortieren doppelter Links  #######################
        ReDim temparray(linklimit)
        For x=0 To linklimit
            temparray(x)=""
        Next
        
        
        For x=0 To linklimit
            If (linkspeicher(x)<>"") And (Len(linkspeicher(x))>1) Then
                a=0
                gefunden=False
                Do While gefunden=False
                    If temparray(a)="" Then
                        gefunden=True
                    End If
                    If linkspeicher(x)=temparray(a) Then
                        gefunden=True
                    End If
                    If gefunden=False Then
                        a=a+1
                    End If
                    If a>linklimit Then
                        a=linklimit
                        gefunden=True
                    End If
                Loop
                If linkspeicher(x)<>temparray(a) Then
                    temparray(a)=linkspeicher(x)
                End If
            End If
        Next
        
        For x=0 To linklimit
            linkspeicher(x)=""
        Next
        
        a=0
        abbruch=False
        Do While abbruch=False
            If temparray(a)<>"" Then
                linkspeicher(a)=temparray(a)
                a=a+1
            Else
                abbruch=True
            End If
            If a>linklimit Then 
                abbruch=True
            End If
        Loop
        linkzaehler=a
        
        
        '################################################################################
        
        
        
        
        
        stopflag=False
        ersatzstring=""	
        

        foundsha1=False
        Do While quelljobfile.AtEndOfStream <> True
            kette=quelljobfile.readline
            
            If (InStr(1,kette,"[Referenz]",1)<>0) And (quelljobfile.AtEndOfStream <> True) Then
                abbruch=False
                Do While abbruch=False 
                    kette=quelljobfile.readline
                    If quelljobfile.AtEndOfStream = True Then
                        abbruch=True
                    End If
                    If (InStr(1,kette,"Referenz",1)=0) And (InStr(1,kette,"Anzahl",1)=0) Then
                        abbruch = True
                    End If
                Loop
                zieljobfile.writeline("[Referenz]")
                zieljobfile.writeline("Anzahl="&linkzaehler)
                x=0
                Do While x < linkzaehler
                    zieljobfile.writeline("Referenz"&x+1&"="&linkspeicher(x))
                    x=x+1
                Loop
            End If
            
            ersatzstring=""
            
            If (InStr(1,kette,"Benutzer=",1)<>0) Then
                If LCase(username)="error" Then
                    username="System"
                End If
                If LCase(username)="administratoren" Then
                    username="System"
                End If
                ersatzstring="Benutzer="&username
            End If
            
            If (InStr(1,kette,"Bearbeiter=",1)<>0) Then
                ersatzstring="Bearbeiter="
            End If

            If (Ausgabename<>"") And (dokID="") And (InStr(1,kette,"Orginal=",1)<>0) Then
                
                ersatzstring="Orginal="&Ausgabename&OCRHandle
            End If	
            
            If (changeling=False) And (Username<>"") And (InStr(1,kette,"Benutzer=",1)<>0) Then
                ersatzstring="Benutzer="&Username
            End If	
            
            If (changeling=True) And (InStr(1,kette,"Benutzer=",1)<>0) Then
                ersatzstring="Benutzer="
            End If
            
            If (Ausgabename<>"") And (InStr(1,kette,"Volltext=",1)<>0) Then
                ersatzstring="Volltext="&Ausgabename&".txt"
            End If
            
            If (Typ<>"") And (InStr(1,kette,"OCR_Typ=",1)<>0) Then
                ersatzstring="OCR_Typ="&Typ
            End If
            
            If (Quelle<>"") And (InStr(1,kette,"Quelle=",1)<>0) Then
                ersatzstring="Quelle="&Quelle
            End If
            
            If (InStr(1,kette,"Kopie=",1)<>0) Then
                schattenname = Replace(schattenname, archivverzeichnis, archivkopie)
                If change_ext_loc = True Then
                    If fs.getExtensionName(quelle)="jpg" Then
                        newext=".jpg"
                    Else
                        newext=".tif"
                    End If
                    If fs.FileExists(schattenname & newext) Then
                        ersatzstring="Kopie=" & schattenname & newext
                    Else
                        ersatzstring="Kopie="
                    End If
                    
                Else
                    
                    ersatzstring="Kopie="
                End If
                
            End If
            
            
            If InStr(1,kette,"Schlagworte=",1)<>0 Then
                
                If fs.fileExists(tempname&".swd") Then
                    ersatzstring="Schlagworte="&tempname&".swd"
                Else
                    ersatzstring="Schlagworte="
                End If
            End If
            
            If (dokDate<>"") And (InStr(1,kette,"Datum=",1)<>0) Then
                ersatzstring="Datum="&DokDate
            End If
            
            If InStr(1,kette,"gdoc_id=",1)<>0 Then
                ersatzstring="gdoc_id="
            End If
            
            If InStr(1,kette,"Filter=",1)<>0 Then
                If Filtermakro <> "" Then
                    ersatzstring="Filter="& filtermakro
                Else 
                    ersatzstring="Filter="
                End If
            End If
            
            
            If ersatzstring<>"" Then
                zieljobfile.writeline(ersatzstring)
            Else
                zieljobfile.writeline(kette)
            End If
            
        Loop
        
        
        quelljobfile.close
        Set quelljobfile = Nothing
        zieljobfile.close
        Set zieljobfile=Nothing
        WScript.sleep 50
        
        Err.clear
        If fs.fileexists(tempname& ".job") Then
            fs.DeleteFile(tempname& ".job")
            If Err.number Then
                Err.clear
                errortxt="Fehler beim lschen der alten jobdatei."
                objWshShell.LogEvent 1, errortxt
                writeemailjob=False
            End If 
        End If
        
        
        WScript.sleep 50
        
        If writeemailjob=True Then
            
            fs.CopyFile tempname&".tmp", tempname&".job", True
            If Err.number Then
                Err.clear
                errortxt="Fehler beim umkopieren Jobdatei."
                objWshShell.LogEvent 1, errortxt
                writeemailjob=False
            End If 
        End If
        
        WScript.sleep 50
        If writeemailjob=True Then
            fs.DeleteFile(tempname& ".tmp")
            If Err.number Then
                Err.clear
                errortxt="Fehler beim lschen der zwischen-jobdatei."
                objWshShell.LogEvent 1, errortxt
                writeemailjob=False
            End If 
        End If
        WScript.sleep 50
        
    End If
    
    
End Function


Function writexmljob(tempname)
    On Error Resume Next
    writexmljob=True
    Err.clear
    
    
    gefunden=False
    getroffen=False
    i=0
    u=0
    
    
    If Not fs.FileExists(tempname&".job") Then
        Err.clear
        errortxt=tempname&".job Datei nicht vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        writexmljob=False
        Err.clear
    End If
    
    If writexmljob=True Then	
        Set quelljobfile = fs.OpenTextFile(tempname&".job",1)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writexmljob=False
            
        End If 
    End If
    
    If writexmljob=True Then
        If fs.FileExists(tempname&".tmp") Then
            fs.DeleteFile(tempname& ".tmp")
            If Err.number Then
                Err.clear
                errortxt="Zwischendatei fr Jobdatei existierte noch, kann diese aber nicht lschen."
                objWshShell.LogEvent 1, errortxt
                writexmljob=False
                quelljobfile.close
                Set quelljobfile=Nothing
            End If 
            
        End If	
    End If
    
    If writexmljob=True Then
        Set zieljobfile = fs.OpenTextFile(tempname&".tmp",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writexmljob=False
            quelljobfile.close
            Set quelljobfile=Nothing
        End If 
    End If
    
    
    If writexmljob = True Then
        
        
        '#############################  aussortieren doppelter Links  #######################
        ReDim temparray(linklimit)
        For x=0 To linklimit
            temparray(x)=""
        Next
        
        
        For x=0 To linklimit
            If (linkspeicher(x)<>"") And (Len(linkspeicher(x))>1) Then
                a=0
                gefunden=False
                Do While gefunden=False
                    If temparray(a)="" Then
                        gefunden=True
                    End If
                    If linkspeicher(x)=temparray(a) Then
                        gefunden=True
                    End If
                    If gefunden=False Then
                        a=a+1
                    End If
                    If a>linklimit Then
                        a=linklimit
                        gefunden=True
                    End If
                Loop
                If linkspeicher(x)<>temparray(a) Then
                    temparray(a)=linkspeicher(x)
                End If
            End If
        Next
        
        For x=0 To linklimit
            linkspeicher(x)=""
        Next
        
        a=0
        abbruch=False
        Do While abbruch=False
            If temparray(a)<>"" Then
                linkspeicher(a)=temparray(a)
                a=a+1
            Else
                abbruch=True
            End If
            If a>linklimit Then 
                abbruch=True
            End If
        Loop
        linkzaehler=a
        
        
        '################################################################################
        
        
        
        
        
        stopflag=False
        ersatzstring=""	
        
        foundsha1=False
        Do While quelljobfile.AtEndOfStream <> True
            kette=quelljobfile.readline
            
            If (InStr(1,kette,"[Referenz]",1)<>0) And (quelljobfile.AtEndOfStream <> True) Then
                abbruch=False
                Do While abbruch=False 
                    kette=quelljobfile.readline
                    If quelljobfile.AtEndOfStream = True Then
                        abbruch=True
                    End If
                    If (InStr(1,kette,"Referenz",1)=0) And (InStr(1,kette,"Anzahl",1)=0) Then
                        abbruch = True
                    End If
                Loop
                zieljobfile.writeline("[Referenz]")
                zieljobfile.writeline("Anzahl="&linkzaehler)
                x=0
                Do While x < linkzaehler
                    zieljobfile.writeline("Referenz"&x+1&"="&linkspeicher(x))
                    x=x+1
                Loop
            End If
            
            ersatzstring=""
            
            If (InStr(1,kette,"Benutzer=",1)<>0) Then
                If LCase(username)="error" Then
                    username="System"
                End If
                If LCase(username)="administratoren" Then
                    username="System"
                End If
                ersatzstring="Benutzer="&username
            End If
            
            If (InStr(1,kette,"Bearbeiter=",1)<>0) Then
                ersatzstring="Bearbeiter="
            End If
            
            
            If (Ausgabename<>"") And (dokID="") And (InStr(1,kette,"Orginal=",1)<>0) Then
                
                ersatzstring="Orginal="
            End If	
            
            If (changeling=False) And (Username<>"") And (InStr(1,kette,"Benutzer=",1)<>0) Then
                ersatzstring="Benutzer="&Username
            End If	
            
            If (changeling=True) And (InStr(1,kette,"Benutzer=",1)<>0) Then
                ersatzstring="Benutzer="
            End If
            
            If (Ausgabename<>"") And (InStr(1,kette,"Volltext=",1)<>0) Then
                ersatzstring="Volltext="
            End If
            
            If (Typ<>"") And (InStr(1,kette,"OCR_Typ=",1)<>0) Then
                ersatzstring="OCR_Typ="&Typ
            End If
            
            If (Quelle<>"") And (InStr(1,kette,"Quelle=",1)<>0) Then
                ersatzstring="Quelle="
            End If
            
            If (InStr(1,kette,"Kopie=",1)<>0) Then
                ersatzstring="Kopie="
            End If
            
            
            If InStr(1,kette,"Schlagworte=",1)<>0 Then
                
                If fs.fileExists(tempname&".swd") Then
                    ersatzstring="Schlagworte="&tempname&".swd"
                Else
                    ersatzstring="Schlagworte="
                End If
            End If
            
            If (dokDate<>"") And (InStr(1,kette,"Datum=",1)<>0) Then
                ersatzstring="Datum="&DokDate
            End If
            
            If InStr(1,kette,"gdoc_id=",1)<>0 Then
                ersatzstring="gdoc_id="
            End If
            
            If InStr(1,kette,"Filter=",1)<>0 Then
                If Filtermakro <> "" Then
                    ersatzstring="Filter="& filtermakro
                Else 
                    ersatzstring="Filter="
                End If
            End If
          
            
            If ersatzstring<>"" Then
                zieljobfile.writeline(ersatzstring)
            Else
                zieljobfile.writeline(kette)
            End If
            
        Loop
        
        
        quelljobfile.close
        Set quelljobfile = Nothing
        zieljobfile.close
        Set zieljobfile=Nothing
        WScript.sleep 50
        
        Err.clear
        If fs.fileexists(tempname& ".job") Then
            fs.DeleteFile(tempname& ".job")
            If Err.number Then
                Err.clear
                errortxt="Fehler beim lschen der alten jobdatei."
                objWshShell.LogEvent 1, errortxt
                writexmljob=False
            End If 
        End If
        
        
        WScript.sleep 50
        
        If writexmljob=True Then
            
            fs.CopyFile tempname&".tmp", tempname&".job", True
            If Err.number Then
                Err.clear
                errortxt="Fehler beim umkopieren Jobdatei."
                objWshShell.LogEvent 1, errortxt
                writexmljob=False
            End If 
        End If
        
        WScript.sleep 50
        If writexmljob=True Then
            fs.DeleteFile(tempname& ".tmp")
            If Err.number Then
                Err.clear
                errortxt="Fehler beim lschen der zwischen-jobdatei."
                objWshShell.LogEvent 1, errortxt
                writexmljob=False
            End If 
        End If
        WScript.sleep 50
        
    End If
    
    
End Function



'***************************************************************************************
'***************************************************************************************
'***************************************************************************************


Function runplugin(plugin)
    On Error Resume Next
    runplugin=True
    Err.clear
    
    If Not fs.fileexists(pluginspath & plugin) Then
        runplugin=False
    End If
    
    
    If fs.FileExists(tempname&".var") Then
        Err.clear
        fs.deletefile tempname&".var", True
        If Err.number Then
            Err.clear
            errortxt="Kann alte var-datei nicht lschen."
            objWshShell.LogEvent 1, errortxt
            runplugin=False
        End If 
        Err.clear
    End If
    
    If runplugin=True Then	
        Set varfile = fs.OpenTextFile(tempname&".var",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann var-datei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            runplugin=False
            varfile.close
            Set varfile=Nothing
        End If 
    End If
    
    
    If runplugin = True Then
        For x=0 To limit
            If zusatzfeldname(x)<>"" Then
                varfile.writeline("Zusatzfeld="&zusatzfeldname(x))
                varfile.writeline("Wert="&zusatzfeld(x))
            End If
        Next
        
        varfile.writeline("Tabelle="&tabelle)
        varfile.writeline("NotifyUser="&notifyuser)
        varfile.writeline("Docname="&myname)
        varfile.writeline("Statusflag="&oldstatus)
        varfile.writeline("Statustext="&newstatus)
        varfile.writeline("FromEmail="&fromEmail)
        varfile.writeline("Extension="&extension)
        varfile.writeline("Profil="&profil)
        varfile.writeline("Originaldatei="&Originaldatei&extension)
        varfile.writeline("Benutzer="&username)
        For x=0 To linklimit
            If linkspeicher(x)<>"" Then
                varfile.writeline("Link="&linkspeicher(x))
            End If
        Next
        
        
        varfile.close
        Set varfile=Nothing
        WScript.sleep 50
    End If
    
    oldtable=tabelle
    
    
    '###############################   Plugin starten  ############################
    
    If runplugin=True Then
        If scriptdebug=True Then
            objWshShell.LogEvent 2, "Archivierung(debug25): starte Plugin "&plugin
        End If
        lngReturnCode = objWSHShell.Run(Chr(34)&pluginspath & plugin&Chr(34)&" "&Chr(34)&tempname&Chr(34),0,True)
        
        If scriptdebug=True Then
            objWshShell.LogEvent 4, "Archivierung(debug26): Rckkehr aus Plugin "&plugin
        End If
        
        
        WScript.sleep 50
    End If
    
    '###############################   Feld zurcklesen  ##########################
    ind = -1
    If runplugin=True Then
        If fs.fileexists(tempname&".var") Then
            
            kette=""
            wert1=""
            wert2=""
            y=0
            Set varfile = fs.OpenTextFile(tempname&".var",1)
            Do While varfile.atendofstream=False
                kette=varfile.readline
                If Trim(kette)="STOPARC" Then
                    objWSHShell.LogEvent 2, "Die Archivierung wurde vom Plugin abgebrochen, beende"
                    
                    If fs.FileExists(tempname&".var") Then
                        varfile.close
                        Set varfile = Nothing
                        Err.clear
                        'fs.deletefile tempname&".var", True
                    End If
                    aufraeumen(tempname)
                    Unlock(programm&lockdatei)
                    Unlock(programm&superlockdatei)
                    WScript.Quit()
                End If
                If LCase(Trim(kette))="nrs=false" Then
                    docschangeable=False
                End If
                If LCase(Trim(kette))="nrs=true" Then
                    docschangeable=True
                End If
                If InStr(1,kette,"Zusatzfeld",1)<>0 Then
                    ind = ind + 1
                    wert1=Trim(Right(kette,Len(kette)-(InStr(1,kette,"Zusatzfeld",1)+10)))
                    kette=varfile.readline
                    wert2=Trim(Right(kette,Len(kette)-(InStr(1,kette,"Wert",1)+4)))
                    If LCase(wert1)="benutzer" And ind <=5 Then
                        Username =wert2
                    End If
                    
                    gefunden=False
                    For x=0 To limit
                        If zusatzfeldname(x)=wert1 Then
                            gefunden=True
                            
                            zusatzfeld(x)=wert2
                            
                        End If
                    Next
                    x=0
                    Do While gefunden=False
                        If zusatzfeldname(x)="" Then
                            gefunden=True
                            zusatzfeldname(x)=wert1
                            zusatzfeld(x)=wert2
                        End If
                        x=x+1
                        If x=limit Then
                            gefunden=True
                        End If
                    Loop
                    If x=limit Then
                        errortxt="bitfarm-Archiv: Archivierung: Bei Plugin-Datenbernahme Arrayberlauf (Nur "&limit&" Felder erlaubt)."
                        objWshShell.LogEvent 1, errortxt
                        runplugin=False
                    End If
                End If
                
                If InStr(1,kette,"NotifyUser=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"NotifyUser=",1)+10))
                    If LCase(wert)="true" Then
                        notifyuser=True
                    End If
                    If LCase(wert)="false" Then
                        notifyuser=False
                    End If
                End If
                
                If InStr(1,kette,"Docname=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Docname=",1)+7))
                    If wert <>"" Then
                        docname=wert
                        myname=docname
                    End If
                    
                End If 
                
                If InStr(1,kette,"Statusflag=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Statusflag=",1)+10))
                    If wert <>"" Then
                        oldstatus=wert
                    End If
                End If 
                
                If InStr(1,kette,"Statustext=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Statustext=",1)+10))
                    If wert <>"" Then
                        newstatus=wert
                    End If
                End If 		
                
                If InStr(1,kette,"Link=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Link=",1)+4))
                    If wert <>"" Then
                        If wert = "#delete#" Then
                            linkspeicher(y)=""
                        Else
                            linkspeicher(y)=wert
                        End If 
                        y=y+1
                    End If
                End If 
                
                If InStr(1,kette,"Tabelle=",1)<>0 And changeling=False Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Tabelle=",1)+7))
                    Tabelle=wert
                    
                End If 
                
                If InStr(1,kette,"Extension=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Extension=",1)+9))
                    extension=wert
                End If 
                
                If InStr(1,kette,"Benutzer=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Benutzer=",1)+8))
                    username=wert
                End If
                
            Loop
            varfile.close
            Set varfile=Nothing
            WScript.sleep 30
        End If
    End If 
    
    
    If oldtable<>tabelle And changeling=False Then
        newtable=getnewtable(tabelle)
        endflag=True
        If (newtable<>"") Then
            erfolg=changetemplate(tabelle)
            If erfolg=False Then
                Err.clear
                errortxt="bitfarm-Archiv: changetemplate(plugin) meldet Fehler."
                objWshShell.LogEvent 1, errortxt
                tabelle=oldtable
            End If
        End If
    End If

End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************



Function rejob(cngfilename)
    On Error Resume Next
    rejob = True
    oldbase=""
    Err.clear
    
    If Not fs.FileExists(cngfilename) Then
        Err.clear
        errortxt=".cng Datei nicht vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        rejob=False
        Err.clear
    End If
    
    newjobfile=False
    username=""
    mychangedoc=""
	dokid4=""
    gdocid_rejob=""
    profil4=""
    strocr="YMP"
    color=False
    filterstring=""
    
    If rejob=True Then	
        Set cngfile = fs.OpenTextFile(cngfilename,1)
        If Err.number Then
            Err.clear
            errortxt="Kann cngfile nicht zum lesen ffnen."
            objWshShell.LogEvent 1, errortxt
            rejob=False
            
        End If 
        mychangedoc=cngfile.readline
        username=cngfile.readline
        If cngfile.AtEndOfStream=False Then
            gdocid_rejob=cngfile.readline
        End If
        If cngfile.AtEndOfStream=False Then
            profil4=cngfile.readline
        End If
        
        Do Until cngfile.AtEndOfStream
            strrest = strrest & cngfile.readline 
            If Not cngfile.AtEndOfStream Then
                strrest = strrest & vbCrLf
            End If 
        Loop
        
        cngfile.close
        Set cngfile=Nothing
        WScript.sleep 50
        
    End If
    
    
    
    If Len(username)<2 Then
        username="System"
    End If
    If Len(mychangedoc)<2 Then
        rejob=False
    End If
    
    
    If Left(mychangedoc,9)="%bfastore" Then
    	' Mit store-Umgebungsvariable geliefert
    	' muss aufgelst werden
    	parts = Split(mychangedoc,"\")
    	uv = parts(0)
    	uv_resolved = objWSHShell.ExpandEnvironmentStrings(uv)
    	mychangedoc = Replace(mychangedoc, uv, uv_resolved)
    End If
    
    If fs.fileexists(mychangedoc)<>True Then
        rejob = False
        objWSHShell.LogEvent 1,"Archivierung.vbs: Rejob cngfile:bergebene Datei nicht vorhanden" & vbCrLf & mychangedoc
        fs.deletefile cngfilename, True
        If Err.number<> 0 Then
            objWSHShell.LogEvent 1,"Archivierung.vbs: Rejob cngfile: Konnte cng-File nicht lschen" & vbCrLf & cngfilename
            Err.clear
        End If
        Exit Function
        
    End If
    
    If rejob = True Then
        newtempname = getFiFo(queue,"temp-cng")
        myext = "." & fs.GetExtensionName(mychangedoc)
        oldbase = Replace(mychangedoc, myext,"")
        
        Err.clear
        fs.copyfile mychangedoc, newtempname&myext, True
        If Err.number<>0 Then
            errortxt="Fehler beim Kopieren des genderten Dokuments in die Warteschlange."
            objWshShell.LogEvent 1, errortxt
            rejob=False
            Err.clear
        End If
    End If
    
    
    
    If fs.fileexists(programm&"createnewjobfile.exe") Then
        newjobfile = True
        
        
        If profil4="" Then
            profil4=Profil
        End If
        
        If profil4<>"" And gdocid_rejob<>"" Then

            
            If InStr(gdocid_rejob,".")<>0 Then
            	parts = Split(gdocid_rejob,".")
            	gdocid_rejob = parts(1)
            End If
            
            cmd = Chr(34)&programm&"createnewjobfile.exe"&Chr(34)&" "&profil4&  " gdocid " &gdocid_rejob & " " &Chr(34)& newtempname & Chr(34)&" -ocr_typ:" & strocr 
            
            lngReturnCode = objWSHShell.Run(Chr(34)&programm&"createnewjobfile.exe"&Chr(34)&" "&profil4&  " gdocid " &gdocid_rejob & " " &Chr(34)& newtempname & Chr(34)&" -ocr_typ:" & strocr ,0,True)
            
            If lngReturnCode <> 0 Then
                Err.clear
                On Error Resume Next
                objWSHShell.LogEvent 1,"Archivierung.vbs: Rejob cngfile: createnewjobfile konnte nicht durchgefhrt werden" & vbCrLf & newtempname & ".job" & vbCrLf & cmd
                newjobfile = False
            End If
            
            WScript.sleep 500
            If Not(fs.FileExists(newtempname & ".job")) Then
                objWSHShell.LogEvent 1,"Archivierung.vbs: Rejob cngfile: createnewjobfile konnte kein Jobfile generieren" & vbCrLf & newtempname & ".job" & vbCrLf & cmd
                newjobfile = False
            End If
        Else
            newjobfile = False
        End If
    End If
    
    If newjobfile = False Then
        
        'alte methode ###############################################################
        If fs.fileexists(oldbase&".job")<>True Then
            rejob = False
            objWshShell.LogEvent 1,"Archivierung.vbs rejob: Zum Dokument ist keine Job-Datei vorhanden und konnte auch nicht generiert werden." & vbCrLf & "Die Verarbeitung wird abgebrochen, das Dokument wird aus der Queue gelscht" & vbCrLf &"mychangedoc:" & mychangedoc & vbCrLf & "newtempname:" &  newtempname&myext
            fs.DeleteFile(newtempname&myext),True
            fs.DeleteFile(cngfilename),True
            
        End If	
        
        
        If fs.fileexists(oldbase&".job") = True Then
            Set oldbasefile = fs.opentextfile(oldbase&".job")
            Do While oldbasefile.AtEndofStream <> True
                kette = oldbasefile.readline
                If (InStr(1,kette,"OCR_Typ=",1)<>0) Then
                    wert=Right(GetString(kette,InStr(1,kette,"OCR_Typ=",1)+8),2)
                    strocr="Y"&wert
                End If
                
                If InStr(1,kette,"Profil=",1)<>0 And profil4 = "" Then
                    wert=GetString(kette,InStr(1,kette,"Profil=",1)+7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        profil4 = wert
                    End If
                End If
                
               
                If Left(LCase(kette),7) = "gdocid=" And dokid4 = ""Then
                    wert=Right(kette,Len(kette)-7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        dokid4 = wert
                    End If
                End If
				
				
                If InStr(1,kette,"Filter=",1)<>0 Then
                    wert=Right(kette,Len(kette)-7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        filterstring=wert
                    End If 
                End If
            Loop
            
            oldbasefile.close
            Set oldbasefile = Nothing
            
            fs.copyfile oldbase&".job", newtempname&".job"
            If Err.Number<>0 Then
                errortxt="nderungsdienst: Jobdatei konnte nicht umkopiert werden" & vbCrLf & oldbase&".job" & vbCrLf & newtempname&".job" & vbCrLf &Err.Number& vbTab & Err.Description
                objWSHShell.LogEvent 1, errortxt
                rejob = False
                Err.Clear
            End If 
            
        Else
            rejob = False
            
        End If	
        
        'alte methode ###############################################################
    End If 	
    
    
    If rejob=True Then	
        Set quelljobfile = fs.OpenTextFile(newtempname&".job",1)
        If Err.number Then
            Err.clear
            errortxt="Kann alte Jobdatei nicht zum lesen ffnen."
            objWshShell.LogEvent 1, errortxt
            rejob=False
        End If 
    End If
    
    If rejob=True Then
        If fs.FileExists(newtempname&".tmp") Then
            fs.DeleteFile(newtempname& ".tmp")
            If Err.number Then
                Err.clear
                errortxt="nderungsdienst: Zwischendatei fr Jobdatei existierte noch, kann diese aber nicht lschen."
                objWshShell.LogEvent 1, errortxt
                rejob=False
                quelljobfile.close
                Set quelljobfile=Nothing
            End If 
            
        End If	
    End If
    
    If rejob=True Then
        Set zieljobfile = fs.OpenTextFile(newtempname&".tmp",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            rejob=False
            quelljobfile.close
            Set quelljobfile=Nothing
        End If 
    End If
    
    Err.Clear
    
    If rejob = True Then
        Termin=Date()
        Alarm=Date()+7
        stopflag=False
        ersatzstring=""	
        Do While quelljobfile.AtEndOfStream <> True
            kette=quelljobfile.readline
            
            ersatzstring=""
            
            
            If (InStr(1,kette,"Termin=",1)<>0) Then
                ersatzstring="Termin="
            End If
            
            If (InStr(1,kette,"Alarm=",1)<>0) Then
                ersatzstring="Alarm="
            End If
            
            If (InStr(1,kette,"Bearbeiter=",1)<>0) Then
                ersatzstring="Bearbeiter="
            End If
            
            If (InStr(1,kette,"Notiz=",1)<>0) Then
                ersatzstring="Notiz="
            End If
            
            If (InStr(1,kette,"Filter=",1)<>0) Then
                ersatzstring="Filter=" & filterstring
            End If
            
            
            If (Username<>"") And (InStr(1,kette,"Benutzer=",1)<>0) Then
                ersatzstring="Benutzer="&Username
            End If	
            
            
            If (InStr(1,kette,"OCR_Typ=",1)<>0) Then
                wert=Right(GetString(kette,InStr(1,kette,"OCR_Typ=",1)+8),2)
                ersatzstring="OCR_Typ=Y"&wert
            End If
            
            
            If (dokDate<>"") And (InStr(1,kette,"Datum=",1)<>0) And  (InStr(1,kette,"SVN") = 0 ) Then
                ersatzstring="Datum="
            End If
            
            If (gdocid_rejob<>"") And (InStr(1,kette,"gdocid=",1)<>0) Then
                
                
                ersatzstring="gdocid="&gdocid_rejob
                
            End If
            
            If Left(kette,8)="ZusTitel" Then
                
                For x=1 To limit
                    
                    
                    If InStr(1,kette,"ZusWert"&x&"=",1)<>0 Then
                        ersatzstring="ZusWert"&x&"="
                    End If
                    
                Next
            End If
            
            If ersatzstring<>"" Then
                zieljobfile.writeline(ersatzstring)
            Else
                zieljobfile.writeline(kette)
            End If
            
        Loop
        quelljobfile.close
        Set quelljobfile = Nothing
        zieljobfile.close
        Set zieljobfile=Nothing
        WScript.sleep 50
        
        If Err.Number <> 0 Then
            errortxt="nderungsdienst: Jobdatei konnte nicht erstellt werden" & vbCrLf & newtempname&".tmp" & vbCrLf &Err.Number& vbTab & Err.Description
            objWSHShell.LogEvent 1, errortxt
            rejob = False
            Err.Clear
        Else
            fs.deletefile newtempname&".job", True
            If Err.Number<> 0 Then
                errortxt="nderungsdienst: Jobdatei konnte nicht gelscht werden" & vbCrLf & newtempname&".job" & vbCrLf &Err.Number& vbTab & Err.Description
                objWSHShell.LogEvent 1, errortxt
                rejob = False
                Err.Clear
            Else
                
                fs.movefile newtempname&".tmp", newtempname&".job"
                If Err.Number<>0 Then
                    errortxt="nderungsdienst: Jobdatei konnte nicht umkopiert werden" & vbCrLf & newtempname&".tmp" & vbCrLf & newtempname&".job" & vbCrLf &Err.Number& vbTab & Err.Description
                    objWSHShell.LogEvent 1, errortxt
                    rejob = False
                    Err.Clear
                End If 
            End If 
            
        End If 
        Err.clear
        
    End If
    
    If rejob = True Then    'sanitytest: ist im jobfile wirklich der richtige pfad angegeben
        
        control= readstring(newtempname&".job","Quelle",True)
        control2= readstring(newtempname&".job","Orginal",True)
        
        
        control = fs.GetFileName(control)
        control2 = fs.GetFileName(control2)
        mychangefilename= fs.GetFileName(mychangedoc)
        
        
        '-------------------------------------------------
        If scriptdebug = True Then
            objWSHShell.LogEvent 4,"Archivierung.vbs rejob: control=" & control & vbCrLf & "control2=" & control2 & vbCrLf & "mychangefilename=" & mychangefilename & vbCrLf & termflag
        End If
        
        If ((LCase(control) <> LCase(mychangefilename)) And (LCase(control2) <> LCase(mychangefilename)))  Then
            objWSHShell.LogEvent 1,"Archivierung.vbs rejob: Fehler ! Der Pfad in der Job-Datei stimmt nicht mit dem bergebenen Pfad berein" & vbCrLf &"mychangedoc=" & mychangedoc & vbCrLf & "control=" & control & vbCrLf & "control2=" & control2 & vbCrLf & "docid:"& dokID4 & vbCrLf & cngfilename
            
            fs.DeleteFile(newtempname&myext),True
            If Err.number<>0 Then
                objWSHShell.LogEvent 1,"Archivierung.vbs rejob: konnte " & newtempname&myext & " nicht lschen" & vbCrLf & Err.Number & vbTab & Err.Description
                Err.Clear
            End If
            fs.DeleteFile(newtempname&".job"),True
            If Err.number<>0 Then
                objWSHShell.LogEvent 1,"Archivierung.vbs rejob: konnte " & newtempname&myext & " nicht lschen" & vbCrLf & Err.Number & vbTab & Err.Description
                Err.Clear
            End If
            fs.DeleteFile(cngfilename), True
            If Err.number<>0 Then
                objWSHShell.LogEvent 1,"Archivierung.vbs rejob: konnte " & cngfilename & " nicht lschen" & vbCrLf & Err.Number & vbTab & Err.Description
                Err.Clear
            End If
            
            Err.Clear
            rejob = False
        Else
            rejob = True
        End If
    End If
    
    
    '############################################################
    If  rejob = True Then
        fs.deletefile cngfilename, True
        If Err.number<>0 Then
            objWSHShell.LogEvent 1,"Archivierung.vbs rejob: konnte " & cngfilename & " nicht lschen" & vbCrLf & Err.Number & vbTab & Err.Description
            Err.Clear
        End If
    End If
    
    
End Function



'***************************************************************************************
'***************************************************************************************
'***************************************************************************************



Function refreshjob(tempname)
    On Error Resume Next
    refreshjob=True
    Err.clear
    
    If Not fs.FileExists(tempname&".job") Then
        Err.clear
        errortxt=tempname&".job Datei nicht vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        refreshjob=False
        Err.clear
    End If
    
    If refreshjob=True Then	
        Set quelljobfile = fs.OpenTextFile(tempname&".job",1)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            refreshjob=False
            
        End If 
    End If
    
    If refreshjob=True Then
        If fs.FileExists(tempname&".tmp") Then
            fs.DeleteFile tempname& ".tmp", True
            If Err.number Then
                Err.clear
                errortxt="Zwischendatei fr Jobdatei existierte noch, kann diese aber nicht lschen."
                objWshShell.LogEvent 1, errortxt
                refreshjob=False
                quelljobfile.close
                Set quelljobfile=Nothing
            End If 
            
        End If	
    End If
    
    If refreshjob=True Then
        Set zieljobfile = fs.OpenTextFile(tempname&".tmp",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            refreshjob=False
            quelljobfile.close
            Set quelljobfile=Nothing
        End If 
    End If
    
    
    
    If refreshjob = True Then
        
        stopflag=False
        ersatzstring=""	
        ref = 1
        Do While quelljobfile.AtEndOfStream <> True
            kette=quelljobfile.readline
            
            
            ersatzstring=""
            
            
            If InStr(1,kette,"Referenz",1)<>0 Then
                zieljobfile.writeline("Referenz" & ref & "=")
                ref = ref + 1
                If quelljobfile.AtEndOfStream<>True Then
                    kette=quelljobfile.readline
                End If
            End If
            
            
            If InStr(1,kette,"Anzahl=",1)<>0 Then
                ersatzstring="Anzahl=0"
            End If
            
            If (Termin<>"") And (InStr(1,kette,"Termin=",1)<>0) Then
                ersatzstring="Termin="
            End If
            
            If (Alarm<>"") And (InStr(1,kette,"Alarm=",1)<>0) Then
                ersatzstring="Alarm="
            End If
            
            If (InStr(1,kette,"Bearbeiter=",1)<>0) Then
                ersatzstring="Bearbeiter="
            End If
            
            If (InStr(1,kette,"Benutzer=",1)<>0) Then
                ersatzstring="Benutzer="&username
            End If
            
            If (msgbody<>"") And (InStr(1,kette,"Notiz=",1)<>0) Then
                ersatzstring="Notiz="
            End If
            
            If (dokID<>"") And (InStr(1,kette,"DOCID=",1)<>0) Then
                ersatzstring="DOCID="&dokID
            End If
            
            If ersatzstring<>"" Then
                zieljobfile.writeline(ersatzstring)
            Else
                zieljobfile.writeline(kette)
            End If
            
        Loop
        quelljobfile.close
        Set quelljobfile = Nothing
        zieljobfile.close
        Set zieljobfile=Nothing
        WScript.sleep 50
        
        Err.clear
        fs.DeleteFile(tempname& ".job")
        If Err.number Then
            Err.clear
            errortxt="Fehler beim lschen der alten jobdatei."
            objWshShell.LogEvent 1, errortxt
            refreshjob=False
        End If 
        
        
        
        If refreshjob=True Then
            
            fs.CopyFile tempname&".tmp", tempname&".job", True
            If Err.number Then
                Err.clear
                errortxt="Fehler beim umkopieren Jobdatei."
                objWshShell.LogEvent 1, errortxt
                refreshjob=False
            End If 
        End If
        
        WScript.sleep 50
        If refreshjob=True Then
            fs.DeleteFile tempname& ".tmp", True
            If Err.number Then
                Err.clear
                errortxt="Fehler beim lschen der zwischen-jobdatei."
                objWshShell.LogEvent 1, errortxt
                refreshjob=False
            End If 
        End If
        WScript.sleep 50
        
    End If
    
    
End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************


Function bcmergejob(tempname)
    On Error Resume Next
    bcmergejob=True
    Err.clear
    
    If Not fs.FileExists(tempname&".job") Then
        Err.clear
        errortxt=tempname&".job Datei nicht vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        bcmergejob=False
        Err.clear
    End If
    
    If bcmergejob=True Then	
        Set quelljobfile = fs.OpenTextFile(tempname&".job",1)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            bcmergejob=False
            
        End If 
    End If
    
    If bcmergejob=True Then
        If fs.FileExists(tempname&".tmp") Then
            fs.DeleteFile tempname& ".tmp", True
            If Err.number Then
                Err.clear
                errortxt="Zwischendatei fr Jobdatei existierte noch, kann diese aber nicht lschen."
                objWshShell.LogEvent 1, errortxt
                bcmergejob=False
                quelljobfile.close
                Set quelljobfile=Nothing
            End If 
            
        End If	
    End If
    
    If bcmergejob=True Then
        Set zieljobfile = fs.OpenTextFile(tempname&".tmp",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            bcmergejob=False
            quelljobfile.close
            Set quelljobfile=Nothing
        End If 
    End If
    
    
    
    If bcmergejob = True Then
        
        stopflag=False
        ersatzstring=""	
        Do While quelljobfile.AtEndOfStream <> True
            kette=quelljobfile.readline
            
            ersatzstring=""
            
            
            If (InStr(1,kette,"Filter=",1)<>0) Then
                If Filtermakro <> "" Then
                    ersatzstring="Filter="& filtermakro
                Else 
                    ersatzstring="Filter="
                End If
            End If
            
            
            If ersatzstring<>"" Then
                zieljobfile.writeline(ersatzstring)
            Else
                zieljobfile.writeline(kette)
            End If
            
        Loop
        quelljobfile.close
        Set quelljobfile = Nothing
        zieljobfile.close
        Set zieljobfile=Nothing
        WScript.sleep 50
        
        Err.clear
        fs.DeleteFile(tempname& ".job")
        If Err.number Then
            Err.clear
            errortxt="Fehler beim lschen der alten jobdatei."
            objWshShell.LogEvent 1, errortxt
            bcmergejob=False
        End If 
        
    End If
    
    
End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************



Function filterjob(tempname)
    On Error Resume Next
    filterjob=True
    Err.clear
    
    If Not fs.FileExists(tempname&".job") Then
        Err.clear
        errortxt=tempname&".job Datei nicht vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        filterjob=False
        Err.clear
    End If
    
    If filterjob=True Then	
        Set quelljobfile = fs.OpenTextFile(tempname&".job",1)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            filterjob=False
            
        End If 
    End If
    
    If filterjob=True Then
        If fs.FileExists(tempname&".tmp") Then
            fs.DeleteFile tempname& ".tmp", True
            If Err.number Then
                Err.clear
                errortxt="Zwischendatei fr Jobdatei existierte noch, kann diese aber nicht lschen."
                objWshShell.LogEvent 1, errortxt
                filterjob=False
                quelljobfile.close
                Set quelljobfile=Nothing
            End If 
            
        End If	
    End If
    
    If filterjob=True Then
        Set zieljobfile = fs.OpenTextFile(tempname&".tmp",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            filterjob=False
            quelljobfile.close
            Set quelljobfile=Nothing
        End If 
    End If
    
    
    
    If filterjob = True Then
        
        stopflag=False
        ersatzstring=""	
        Do While quelljobfile.AtEndOfStream <> True
            kette=quelljobfile.readline
            
            ersatzstring=""
            
            If Left(filtermakro,1)="," Then
                filtermakro = Right(filtermakro,Len(filtermakro)-1)
            End If
            If Right(filtermakro,1)="," Then
                filtermakro = Left(filtermakro,Len(filtermakro)-1)
            End If	
            
            If (InStr(1,kette,"Filter=",1)<>0) Then
                If Filtermakro <> "" Then
                    ersatzstring="Filter="& filtermakro
                Else 
                    ersatzstring="Filter="
                End If
            End If
            
            
            If ersatzstring<>"" Then
                zieljobfile.writeline(ersatzstring)
            Else
                zieljobfile.writeline(kette)
            End If
            
        Loop
        quelljobfile.close
        Set quelljobfile = Nothing
        zieljobfile.close
        Set zieljobfile=Nothing
        WScript.sleep 50
        
        Err.clear
        fs.DeleteFile(tempname& ".job")
        If Err.number Then
            Err.clear
            errortxt="Fehler beim lschen der alten jobdatei."
            objWshShell.LogEvent 1, errortxt
            filterjob=False
        End If 
        
    End If
    
    If filterjob = True Then
        fs.MoveFile tempname & ".tmp", tempname & ".job"
        If Err.number Then
            Err.clear
            errortxt="Fehler beim Umkopieren der .tmp-datei." &vbCrLf& tempname & ".tmp" &"->" &vbCrLf& tempname & ".job"
            objWshShell.LogEvent 1, errortxt
            filterjob=False
        End If 
        
    End If
    
    
End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************




Function writenewjob(tempname)
    On Error Resume Next
    writenewjob=True
    Err.clear
    
    If Not fs.FileExists(tempname&".zjd") Then
        Err.clear
        errortxt=tempname&".job Datei nicht vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        writejob=False
        Err.clear
    End If
    
    If writenewjob=True Then	
        Set quelljobfile = fs.OpenTextFile(tempname&".zjd",1)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writenewjob=False
            
        End If 
    End If
    
    If writenewjob=True Then
        If fs.FileExists(tempname&".tmp") Then
            fs.DeleteFile tempname& ".tmp", True
            If Err.number Then
                Err.clear
                errortxt="Zwischendatei fr Jobdatei existierte noch, kann diese aber nicht lschen."
                objWshShell.LogEvent 1, errortxt
                writenewjob=False
                quelljobfile.close
                Set quelljobfile=Nothing
            End If 
            
        End If	
    End If
    
    If writenewjob=True Then
        Set zieljobfile = fs.OpenTextFile(tempname&".tmp",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            writejob=False
            quelljobfile.close
            Set quelljobfile=Nothing
        End If 
    End If
    
    
    
    If writenewjob = True Then
        
        stopflag=False
        ersatzstring=""	
        Do While quelljobfile.AtEndOfStream <> True
            kette=quelljobfile.readline
            ersatzstring=""
            
            If (dokID<>"") And (InStr(1,kette,"DOCID=",1)<>0) Then
                ersatzstring="DOCID="&dokID
            End If
            
            If InStr(1,kette,"Status=",1)<>0 Then
                ersatzstring="Status=0"
            End If
            
            If InStr(1,kette,"StatStr=",1)<>0 Then
                ersatzstring="StatStr="&newstatus
            End If
            
            If InStr(1,kette,"OCR_Typ=",1)<>0 Then
                ersatzstring="OCR_Typ=YMP"
            End If
            
            If InStr(1,kette,"OCR_QF=",1)<>0 Then
                If OCRQF>0 Then
                    ersatzstring="OCR_QF="&OCRQF
                Else
                    ersatzstring="OCR_QF=-1"
                End If
            End If
            
            If ersatzstring<>"" Then
                zieljobfile.writeline(ersatzstring)
            Else
                zieljobfile.writeline(kette)
            End If
            
        Loop
        quelljobfile.close
        Set quelljobfile = Nothing
        zieljobfile.close
        Set zieljobfile=Nothing
        WScript.sleep 50
        
        Err.clear
        fs.DeleteFile(tempname& ".zjd")
        If Err.number Then
            Err.clear
            errortxt="Fehler beim lschen der alten jobdatei."
            objWshShell.LogEvent 1, errortxt
            writenewjob=False
        End If 
        
        
        'wscript.sleep 100
        
        If writenewjob=True Then
            
            fs.CopyFile tempname&".tmp", tempname&".job", True
            If Err.number Then
                Err.clear
                errortxt="Fehler beim umkopieren Jobdatei."
                objWshShell.LogEvent 1, errortxt
                writenewjob=False
            End If 
        End If
        
        WScript.sleep 50
        If writenewjob=True Then
            fs.DeleteFile tempname& ".tmp", True
            If Err.number Then
                Err.clear
                errortxt="Fehler beim lschen der zwischen-jobdatei."
                objWshShell.LogEvent 1, errortxt
                writenewjob=False
            End If 
        End If
        WScript.sleep 50
        
    End If
    
    
End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************



Function writeworkflowinfo()
    On Error Resume Next
    Err.clear
    
    If fs.FileExists(programm&"temp\workflowinfo.txt") Then
        fs.deletefile programm&"temp\workflowinfo.txt", True
        If Err.number <>0 Then
            Err.clear
            errortxt="kann temporre workflow-Informationen nicht lschen."
            objWshShell.LogEvent 1, errortxt
            getgarbage(tempname)
            WScript.Quit
            Err.clear
        End If
    End If
    
    
    Set zieljobfile = fs.OpenTextFile(programm&"temp\workflowinfo.txt",8,True)
    If Err.number Then
        Err.clear
        errortxt="Fehler beim schreiben der Workflow-Infos."
        objWshShell.LogEvent 1, errortxt
        getgarbage(tempname)
        WScript.Quit
    End If 
    
    
    For w=0 To limit
        If (Zusatzfeldname(w)<>"") And (Zusatzfeld(w)<>"") Then
            zieljobfile.writeline(Zusatzfeldname(w)&"="&Zusatzfeld(w))
        End If
    Next
    
    zieljobfile.close
    Set zieljobfile=Nothing
    WScript.sleep 50
    
    
End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************


Function addSWFileInfo(SWFile)
    On Error Resume Next
    addSWFileInfo=True
    Err.clear
    
    If extension<>"" Then
        gefunden=False
        d=0
        Do While gefunden = False
            If Zusatzfeldname(d)="" Then
                gefunden=True
            End If
            If gefunden=False Then
                d=d+1
            End If
            If d>limit Then
                gefunden=True
            End If
        Loop
        If d>limit Then
            errortxt="bitfarm-Archiv: berlauf im Zusatzfeldarray (addSWFileInfo)."
            objWshShell.LogEvent 1, errortxt
        Else		    
            zusatzfeld(d)=UCase(Right(extension,Len(extension)-1))
            If handle="pdf" Then
                zusatzfeld(d)="PDF"
            End If
            zusatzfeldname(d)="Typ"	
            
        End If
    End If
    
    
    '##############################  Gre ##############################
    
    If extension<>"" Then
        gefunden=False
        d=0
        Do While gefunden = False
            If Zusatzfeldname(d)="" Then
                gefunden=True
            End If
            If gefunden=False Then
                d=d+1
            End If
            If d>limit Then
                gefunden=True
            End If
        Loop
        If d>limit Then
            errortxt="bitfarm-Archiv: berlauf im Zusatzfeldarray (addSWFileInfo)."
            objWshShell.LogEvent 1, errortxt
        Else        
            If fs.fileexists(tempname&extension) Then
                Set dateiinfo=fs.getfile(tempname&extension)
                zusatzfeld(d)=dateiinfo.size
                groesse=zusatzfeld(d)
                Set dateiinfo=Nothing
            Else
                zusatzfeld(d)=""
            End If
            
            
            zusatzfeldname(d)="Gre"	
            
        End If
    End If
    
    '#####################################################################
    
    If Not fs.FileExists(SWFile&".swd") Then
        errortxt="bitfarm-Archiv: addSWFileInfo: Schlagwortdatei nicht vorhanden."
        objWshShell.LogEvent 2, errortxt
        addSWFileInfo=False	
    End If 
    
    
    
    If fs.FileExists(SWFile&".zwd") Then
        fs.deletefile SWFile&".zwd",True
        If Err.number <>0 Then
            Err.clear
            errortxt="bitfarm-Archiv: AddSWFileInfo: Kann temporre Schlagwortdatei nicht lschen."
            objWshShell.LogEvent 2, errortxt
            addSWFileInfo=False
        End If
    End If
    
    
    If (fs.fileexists(SWFile&".pdf")) And (addpdfinfo = True) Then
        cmd=Chr(34)&programm&"pdfinfo.bat"&Chr(34)&" "&Chr(34)&SWFile&".pdf"&Chr(34)&" "&Chr(34)&SWFile&".pdi"&Chr(34)
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"pdfinfo.bat"&Chr(34)&" "&Chr(34)&SWFile&".pdf"&Chr(34)&" "&Chr(34)&SWFile&".pdi"&Chr(34),0,True)
        If lngReturnCode <> 0 Or Err.Number<> 0 Then
            Err.clear
            errortxt="archivierung(45): Fehler bei PDFInfo. Aufruf:"&vbCrLf&cmd
            objWshShell.LogEvent 2, errortxt
        End If
    End If
    
    
    If addSWFileInfo=True Then	
        Set quellswfile = fs.OpenTextFile(SWFile&".swd",1)
        If Err.number Then
            Err.clear
            errortxt="bitfarm-Archiv: AddSWFileInfo: Kann SW-Datei nicht zum lesen ffnen."
            objWshShell.LogEvent 2, errortxt
            addSWFileInfo=False
        End If 
    End If
    
    If addSWFileInfo=True Then
        Set zielSWfile = fs.OpenTextFile(SWFile&".zwd",8,True)
        If Err.number Then
            Err.clear
            errortxt="bitfarm-Archiv: AddSWFileInfo: Kann SW-Datei nicht zum schreiben ffnen."
            objWshShell.LogEvent 2, errortxt
            addSWFileInfo=False
            quellswfile.close
            Set quellswfile=Nothing
        End If 
    End If
    
    If addSWFileInfo=True Then
        kette=""
        x=0
        Do While quellswfile.AtEndOfStream <> True
            kette=quellswfile.readline
            If swduplett(kette)=False Then
                zielSWfile.writeline(kette)
                
                x=x+1
                If x>1 Then
                    checkOCR=False
                End If
            End If
        Loop
        
        quellswfile.close
        Set quellswfile = Nothing
        
        
        
        '******************* pdf-zusatzinfos ************
        
        If fs.fileexists(SWFile&".pdi") Then
            
            Set quellswfile = fs.OpenTextFile(SWFile&".pdi",1)
            Do While quellswfile.AtEndOfStream <> True
                kette=quellswfile.readline
                
                wert=""
                zusf=""
                If InStr(1,kette,"Author:",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Author:",1)+8))
                    
                    zusf1="Autor"
                    zusf2="Verfasser"
                    autor=wert
                    
                End If
                
                If InStr(1,kette,"Page size:",1)<>0 Then
                    wert=Trim(Right(kette,Len(kette)-(InStr(1,kette,"Page size:",1)+10)))
                    sizeData = Split(wert," ")
                    xSize=sizeData(0)
                    ySize=sizeData(2)
                    If xSize>ySize Then
                        rotatePDF = True
                    End If
                End If
                
                
                
                If InStr(1,kette,"Title:",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Title:",1)+7))
                    
                    zusf1="Titel"
                    zusf2="Title"
                    titel=wert
                    
                    gefunden=False
                    vorhanden=False
                    d=0
                    Do While gefunden = False
                        If Zusatzfeldname(d)="Titel" Then
                            gefunden=True
                            If zusatzfeld(d)<>"" Then
                                vorhanden=True
                            End If
                        End If
                        
                        If gefunden=False Then
                            d=d+1
                        End If
                        If d>limit Then
                            gefunden=True
                        End If
                    Loop
                    
                    
                End If
                
                If wert<>"" Then
                    gefunden=False
                    d=0
                    Do While gefunden = False
                        If Zusatzfeldname(d)="" Then
                            gefunden=True
                        End If
                        If gefunden=False Then
                            d=d+1
                        End If
                        If d>limit Then
                            gefunden=True
                        End If
                    Loop
                    If d>limit-1 Then
                        errortxt="bitfarm-Archiv: berlauf im Zusatzfeldarray (addSWFileInfo-2)."
                        objWshShell.LogEvent 1, errortxt
                    Else
                        If (zusfeld1="Titel") And (vorhanden=False) Then
                            zusatzfeld(d)=NormZusatzfeld(wert)
                            zusatzfeldname(d)=zusf1
                            zusatzfeld(d+1)=NormZusatzfeld(wert)
                            zusatzfeldname(d+1)=zusf2
                        End If
                        
                        l=1
                        x=0
                        laenge=Len(wert)
                        mystring1=""
                        Do While l<laenge
                            mystring2=getword(wert,l)
                            If mystring2<>mystring1 Then
                                If swduplett(mystring2)=False Then
                                    zielSWfile.writeline(mystring2)
                                    x=x+1
                                    If x>1 Then
                                        checkOCR=False
                                    End If
                                End If
                                mystring1=mystring2
                            End If
                            l=l+1
                        Loop
                    End If
                End If
                
            Loop
            quellswfile.close
            Set quellswfile = Nothing
        End If
        '*********************************************
        
        
        For x=0 To 58
            If (FileInfoValue(x)<>"") And (FileInfoValue(x)<>"0") And (FileInfoValue(x)<>"0.0") Then
                If (FileInfoDescription(x)<>"Firma") And (FileInfoDescription(x)<>"Erstellungsdatum") And (FileInfoDescription(x)<>"Letzter Druck") And (FileInfoDescription(x)<>"Letzte Speicherung") And (FileInfoDescription(x)<>"Zuletzt gespeichert von") And  (FileInfoDescription(x)<>"Manager") And  (FileInfoDescription(x)<>"Revision") And (FileInfoDescription(x)<>"Gesamte Bearbeitungszeit") Then
                    kette=FileInfoValue(x)
                    gefunden=False
                    d=0
                    Do While gefunden = False
                        If Zusatzfeldname(d)="" Then
                            gefunden=True
                        End If
                        If gefunden=False Then
                            d=d+1
                        End If
                        If d>limit Then
                            gefunden=True
                        End If
                    Loop
                    If d>limit Then
                        errortxt="bitfarm-Archiv: berlauf im Zusatzfeldarray (addSWFileInfo-3)."
                        objWshShell.LogEvent 1, errortxt
                    Else
                        
                        
                        zusatzfeld(d)=NormZusatzfeld(kette)
                        zusatzfeldname(d)=NormZusatzfeld(FileInfoDescription(x))
                        
                        l=1
                        b=0
                        laenge=Len(kette)
                        mystring1=""
                        Do While l<laenge
                            mystring2=getword(kette,l)
                            If mystring2<>mystring1 Then
                                If swduplett(mystring2)=False Then
                                    'zielSWfile.writeline(mystring2)
                                    b=b+1
                                    If b>1 Then
                                        checkOCR=False
                                    End If
                                End If
                                mystring1=mystring2
                            End If
                            l=l+1
                        Loop
                    End If
                End If
            End If
        Next
        
        
        For x=0 To limit
            If (zusatzfeld(x)<>"") And (zusatzfeldname(x)<>"Gre") And (zusatzfeldname(x)<>"Typ") Then
                If swduplett(zusatzfeld(x))=False Then
                    zielSWfile.writeline(zusatzfeld(x))
                End If
            End If
        Next
        
        zielSWfile.close
        Set zielSWfile=Nothing
        WScript.sleep 50
        
        Err.clear
        If fs.fileexists(SWFile&".pdi") Then
            fs.deletefile SWFile&".pdi", True
        End If
        
        fs.DeleteFile(SWFile&".swd")
        If Err.number Then
            Err.clear
            errortxt="bitfarm-Archiv: AddSWFileInfo: Fehler beim lschen der alten SWdatei."
            objWshShell.LogEvent 1, errortxt
            addSWFileInfo=False
        End If 
        
        
        fs.CopyFile SWFile&".zwd", SWFile&".swd", True
        If Err.number Then
            Err.clear
            errortxt="bitfarm-Archiv: AddSWFileInfo: Fehler beim umkopieren SWdatei."
            objWshShell.LogEvent 1, errortxt
            addSWFileInfo=False
        End If 
        WScript.sleep 50
        fs.DeleteFile SWFile&".zwd", True
        If Err.number Then
            Err.clear
            errortxt="bitfarm-Archiv: AddSWFileInfo: Fehler beim lschen der zwischen-SWdatei."
            objWshShell.LogEvent 1, errortxt
            addSWFileInfo=False
        End If 
        
        WScript.sleep 50
        
    End If
    
    
End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function errorlog(tempname)
    On Error Resume Next
    Err.clear
    Set errfile = fs.CreateTextFile(tempname&".err",True)
    If Err.number<>0 Then
        Err.clear	
        objWshShell.LogEvent 1, "Panik: kann kein Errorlog schreiben."&Err.number
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    errfile.WriteLine(errortxt)
    errfile.close
    Set errfile=Nothing
End Function

'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function inilesen()
    On Error Resume Next
    Err.clear
    
    Set inifile = fs.OpenTextFile(programm&"scripts.ini",1)
    If Err.number Then
        objWshShell.LogEvent 1, "scripts.ini nicht im Scriptpfad vorhanden oder nicht lesbar."
        Err.clear
        WScript.Quit
    End If 
    
    kette=inifile.readline
    Scriptsflag=InStr(1,kette,"[Scripts]")
    Do While Scriptsflag = 0
        kette=inifile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        If inifile.AtEndOfStream = True Then
            inifile.close
            objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - falsche Formatierung."
            WScript.Quit
        End If
    Loop
    
    
    Do While inifile.AtEndOfStream <> True
        kette=inifile.readline
        If Left(kette,1)<>";" Then
            
            If InStr(1,kette,"Profil=",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"Profil=",1)+7)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    Profil = wert
                End If
            End If
            
            If InStr(1,kette,"Hostsystem=",1)<>0 Then
                wert=Right(kette,Len(kette)-(InStr(1,kette,"Hostsystem=",1)+10))
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    hostversion = LCase(wert)
                End If
            End If
            
            
            If InStr(1,kette,"filterinlineattachments",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"filterinlineattachments",1)+24)
                If LCase(wert)="true" Then
                    filterinlineattachments = True
                End If	
            End If             
            
            If InStr(1,kette,"usetesseract",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"usetesseract",1)+13)
                If LCase(wert)="true" Then
                    usetesseract = True
				Else
					usetesseract = False
                End If	
            End If 
            
            If InStr(1,kette,"tesslang",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"tesslang",1)+9)
                tesslang = wert
            End If
            
            If InStr(1,kette,"tessmaxpagetime",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"tessmaxpagetime",1)+16)
                tessmaxpagetime = CInt(wert)
            End If
                       
            If InStr(1,kette,"tessprocs",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"tessprocs",1)+10)
                If IsNumeric(wert) Then
                	tessprocs = CInt(wert)
                End If
            End If
                       
            If InStr(1,kette,"usepdfmacro",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"usepdfmacro",1)+12)
                If LCase(wert)="false" Then
                    usepdfmacro = False
                End If	
            End If 
            
            If InStr(1,kette,"resetnamingdefaults",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"resetnamingdefaults",1)+20)
                If LCase(wert)="true" Then
                    resetnamingdefaults = True
                End If	
            End If 
            
            If InStr(1,kette,"earlyusing",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"earlyusing",1)+11)
                If LCase(wert)="true" Then
                    earlyusing = True
                End If	
            End If 
            
            If InStr(1,kette,"mapexif",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"mapexif",1)+8)
                If LCase(wert)="false" Then
                    mapexif = False
                End If	
            End If 
            
            If InStr(1,kette,"recasesensitive",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"recasesensitive",1)+16)
                If LCase(wert)="true" Then
                    recasesensitive = True
                End If	
            End If 
            
            If InStr(1,kette, "ocrxmlfor") Then
            	wert=Right(kette,Len(kette)-(InStr(1,kette,"ocrxmlfor=",1)+9))
                If LCase(wert)<>"" Then
                    ocrxmlfor = wert
                End If	
            End If
            
            If InStr(1,kette, "xmltotext") Then
            	wert=Right(kette,Len(kette)-(InStr(1,kette,"xmltotext=",1)+9))
                If LCase(wert)="true" Then
                    xmltotext = True
                End If	
            End If
            
            If InStr(1,kette, "xmlwhitelistextension") Then
            	wert=Right(kette,Len(kette)-(InStr(1,kette,"xmlwhitelistextension",1)+22))
                xmlwhitelistextension = Trim(wert)	
            End If
            
            If InStr(1,kette, "xmlblacklistextension") Then
            	wert=Right(kette,Len(kette)-(InStr(1,kette,"xmlblacklistextension",1)+22))
                xmlblacklistextension = Trim(wert)
            End If
			
            If InStr(1,kette, "extractxmlattachments") Then
            	wert=Right(kette,Len(kette)-(InStr(1,kette,"extractxmlattachments",1)+21))
                If LCase(wert)="true" Then
                	extractxmlattachments = True
                End If
            End If
                        
            If InStr(1,kette,"pdftextminsize",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"pdftextminsize",1)+15)
                If IsNumeric(wert) Then
                    If LCase(wert)<>"" Then
                        pdftextminsize = CLng(wert)
                    End If	
                End If
            End If 
            
            If InStr(1,kette,"pdftextverifyregex",1)<>0 Then
                wert=Right(kette,Len(kette)-(InStr(1,kette,"pdftextverifyregex=",1)+18))
                If LCase(wert)<>"" Then
                    pdftextverifyregex = wert
                End If	
            End If 
            
            If InStr(1,kette,"ftxaddpagebreaks",1)<>0 Then
                wert=Right(kette,Len(kette)-(InStr(1,kette,"ftxaddpagebreaks=",1)+16))
                If LCase(wert)<>"" And LCase(wert) <> "false" Then
                    ftxaddpagebreaks = wert
                Else
                	ftxaddpagebreaks = False
                End If	
            End If 
                        
            If InStr(1,kette,"doknamefilter=",1)<>0 Then
                wert=Right(kette,Len(kette)-(InStr(1,kette,"doknamefilter=",1)+13))
                doknamefilter = wert        
            End If
            
            If InStr(1,kette,"savejob=",1)<>0 Then
                wert=Right(kette,Len(kette)-(InStr(1,kette,"savejob=",1)+7))
                If lcase(wert)="false" Then
                    savejob=False
                End If
            End If
                        
            If InStr(1,kette,"normftx=",1)<>0 Then
                wert=Right(kette,Len(kette)-(InStr(1,kette,"normftx=",1)+7))
                If lcase(wert)="false" Then
                    normftx=False
                End If
            End If
            
            If InStr(1,kette,"normstring=",1)<>0 Then
                wert=Right(kette,Len(kette)-(InStr(1,kette,"normstring=",1)+10))
                If lcase(wert)="false" Then
                    normstr=False
                End If
            End If
            
            If InStr(1,kette,"normzusatzfeld=",1)<>0 Then
                wert=Right(kette,Len(kette)-(InStr(1,kette,"normzusatzfeld=",1)+14))
                If lcase(wert)="false" Then
                    normzus=False
                End If
            End If
       
            If InStr(1,kette,"msgconverter=",1)<>0 Then
                wert=Right(kette,Len(kette)-(InStr(1,kette,"msgconverter=",1)+12))
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    msgconverter = LCase(wert)
                Else
                    msgconverter="Outlook"
                End If
            End If   
            
            If InStr(1,kette,"SolidWorksConverter=",1)<>0 Then
                wert=Right(kette,Len(kette)-(InStr(1,kette,"SolidWorksConverter=",1)+19))
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    SolidWorksConverter = LCase(wert)
                Else
                    SolidWorksConverter=""
                End If
            End If 
            
            If InStr(1,kette,"SolidWorksSize=",1)<>0 Then
                wert=Right(kette,Len(kette)-(InStr(1,kette,"SolidWorksConverter=",1)+15))
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    SolidWorksSize = LCase(wert)
                Else
                    SolidWorksSize="1000x1000"
                End If
            End If             
                                   
            If InStr(1,kette,"emlconverter=",1)<>0 Then
                wert=Right(kette,Len(kette)-(InStr(1,kette,"emlconverter=",1)+12))
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    emlconverter = LCase(wert)
                Else
                    emlconverter="emlconvert.vbs"
                End If
                
            End If                      
                                  
            If InStr(1,kette,"ftxaddrawheader",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"ftxaddrawheader",1)+16)
                If LCase(wert)="true" Then
                    ftxaddrawheader = True
                End If	
            End If 
                     
            If InStr(1,kette,"htmlconverter=",1)<>0 Then
                wert=Right(kette,Len(kette)-(InStr(1,kette,"htmlconverter=",1)+13))
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    htmlconverter = LCase(wert)
                End If
            End If
                        
            If InStr(1,kette,"removepretag",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"removepretag",1)+13)
                If LCase(wert)="true" Then
                    removepretag = True
                End If	
            End If            
            
            If InStr(1,kette,"setprintermethod=",1)<>0 Then
                wert=Right(kette,Len(kette)-(InStr(1,kette,"setprintermethod=",1)+16))
                If LCase(Trim(wert))= "printui.dll" Then
                    setprintermethod = "printui.dll"
                Else setprintermethod = "default"
                End If
            End If
            
            If InStr(1,kette,"newstatuslang=",1)<>0 Then
                wert=Right(kette,Len(kette)-(InStr(1,kette,"newstatuslang=",1)+13))
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    newstatuslang = LCase(wert)
                Else newstatuslang = "deutsch"
                End If
            End If
            
            If InStr(1,kette,"archquelle",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"archquelle",1)+11)
                If LCase(wert)="true" Then
                    archquelle = True
                End If	
            End If
            
            If InStr(1,kette,"Serviceprinter=",1)<>0 Then
                wert=Right(kette,Len(kette)-(InStr(1,kette,"Serviceprinter=",1)+14))
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    serviceprinter = wert
                End If
            End If
            
            If InStr(1,kette,"archofficeincolor",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"archofficeincolor",1)+18)
                If LCase(wert)="true" Then
                    archofficecolor = True
                End If	
                If LCase(wert)="grey" Or LCase(wert)="gray" Then
                    archofficecolor="grey"
                End If
            End If
            
            If InStr(1,kette,"archDWGincolor",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"archDWGincolor",1)+15)
                If LCase(wert)="true" Then
                    archDWGcolor = True
                ElseIf LCase(wert)="grey" Or LCase(wert)="gray" And renderserver <> "" Then
                    archDWGcolor="grey"
                Else
                	archDWGcolor=False
                End If
            End If
            
            If InStr(1,kette,"archpdfincolor",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"archpdfincolor",1)+15)
                If LCase(wert)="true" Then
                    archpdfincolor = True
                End If	
                If LCase(wert)="grey" Then
                    archpdfincolor="grey"
                End If
            End If
            
            If InStr(1,kette,"archpsincolor",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"archpsincolor",1)+14)
                If LCase(wert)="true" Then
                    archpsincolor = True
                End If	
                If LCase(wert)="grey" Then
                    archpsincolor="grey"
                End If
            End If
            
            
            If InStr(1,kette,"emailcolor",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"emailcolor",1)+11)
                If LCase(wert)="color" Then
                    emailcolor = "color"
                ElseIf LCase(wert)="bw" Then
                    emailcolor = "bw"
                ElseIf LCase(wert)="grey" Then
                    emailcolor = "grey"
                Else
                    emailcolor = "bw"
                End If
            End If
            
            
            
            If InStr(1,kette,"archHTMLincolor",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"archHTMLincolor",1)+16)
                If LCase(wert)="true" Then
                    archHTMLincolor = True
                End If	
            End If
            
            If InStr(1,kette,"archJPGincolor",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"archHTMLincolor",1)+15)
                If LCase(wert)="false" Then
                    archJPGincolor = False
                End If	
            End If
            
            If InStr(1,kette,"usejpgtotif",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"usejpgtotif",1)+11)
                If LCase(wert)="true" Then
                    usejpgtotif = True
                End If	
            End If
            
            If InStr(1,kette,"VCVIEWCONVERTInstalled",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"VCVIEWCONVERTInstalled",1)+23)
                If LCase(wert)="true" Then
                    VCVIEWCONVERTInstalled = True
                End If	
            End If
            
            If InStr(1,kette,"archmsg",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"archmsg",1)+7)
                If LCase(wert)="true" Then
                    archmsg=True
                End If
            End If   
            
            If InStr(1,kette,"ISBConverterinstalled=true",1)<>0 Then
                AKTSupport = True
            End If
            
            If InStr(1,kette,"IrfanViewInstalled=true",1)<>0 Then
                IrfanViewInstalled = True
            End If
            
            If InStr(1,kette,"alternatemakedate=false",1)<>0 Then
                alternatemakedate = False
            End If
            
            If InStr(1,kette,"useOMPforOffice",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"useOMPforOffice",1)+16)
                If LCase(wert)="true" Then
                    officeOCR = True
                End If	
            End If
            
            If InStr(1,kette,"acceptallfiletypes",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"acceptallfiletypes",1)+19)
                If LCase(wert)="true" Then
                    acceptallfiletypes = True
                End If	
            End If
            
            If InStr(1,kette,"readbarcodes",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"readbarcodes",1)+13)
                If LCase(wert)="true" Then
                    readbarcodes = True
                End If	
            End If
            
            If InStr(1,kette,"extractPDFdirect",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"extractPDFdirect",1)+17)
                If LCase(wert)="true" Then
                    extractPDF = True
                End If	
            End If
            
            If InStr(1,kette,"ScannerImportPath=",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"ScannerImportPath=",1)+18)
                importpath=wert
            End If
            
            If InStr(1,kette,"allownonrevisionsave",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"allownonrevisionsave",1)+21)
                If LCase(wert)="true" Then
                    allownonrevisionsave = True
                End If	
            End If
            
            If InStr(1,kette,"dropshortstrings",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"dropshortstrings",1)+17)
                If LCase(wert)="false" Then
                    dropshortstrings = False
                End If	
            End If
            
            If InStr(1,kette,"preventdoubledocsmemory",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"preventdoubledocsmemory",1)+24)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    gedaechtnis = strconvert(wert)
                End If
            End If
            
            If InStr(1,kette,"autoexportpath",1)<>0 Then
                'wert=GetString(kette,InStr(1,kette,"autoexportpath",1)+15)
                wert=Right(kette,Len(kette) - InStr(1, kette, "=", 1))
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    autoexportpath=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"autoexportscript",1)<>0 Then
                wert = Right(kette,Len(kette) -17)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    autoexportscript=Trim(wert)
                End If
            End If
            
            
            If InStr(1,kette,"admin=",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"admin",1)+6)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    admin=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"mailattachments",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"mailattachments",1)+16)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    mailattachments=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"mainplugin",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"mainplugin",1)+11)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    mainplugin=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"directplugin",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"directplugin",1)+13)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    directplugin=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"CustomPDFtoTIFFConverter",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"CustomPDFtoTIFFConverter",1)+25)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    CustomPDFtoTIFFConverter=Trim(wert)
                End If
            End If	
            
            If InStr(1,kette,"Defaultresolution",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"Defaultresolution",1)+18)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If wert="hires" Then
                        Defaultresolution="hires"
                    End If
                End If
            End If	
            
            If InStr(1,kette,"barcodemask",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"barcodemask",1)+12)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    barcodemask=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"barcodemode",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"barcodemode",1)+12)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    barcodemode=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"barcodesecondthreshold",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"barcodesecondthreshold",1)+23)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    barcodesecondthreshold=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"eymbcrdcmdpath",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"eymbcrdcmdpath",1)+15)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    eymbcrdcmdpath=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"bcpluspath",1)<>0 Then
                wert = Right(kette,Len(kette) -11)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    bcpluspath=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"barcodefilter",1)<>0 Then
                wert = Right(kette,Len(kette) -14)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    barcodefilter=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"javapath",1)<>0 Then
                wert = Right(kette,Len(kette) -9)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    javapath=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"foppath",1)<>0 Then
                wert = Right(kette,Len(kette) -8)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    foppath=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"autoshrinkjpg",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"autoshrinkjpg",1)+14)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    autoshrinkjpg=strconvert(Trim(wert))
                End If
            End If
            
            If InStr(1,kette,"openofficepath",1)<>0 Then
                wert = Right(kette,Len(kette) -15)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    openofficepath=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"nowarnings",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"nowarnings",1)+11)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        nowarnings=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"userwarnings",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"nowarnings",1)+13)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        userwarnings=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"checkexistingdocpreview",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"checkexistingdocpreview",1)+24)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        checkexistingdocpreview=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"deletezipafterdecomp",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"deletezipafterdecomp",1)+21)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        deletezipafterdecomp=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"dontdecompzipattachments",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"dontdecompzipattachments",1)+25)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        dontdecompzipattachments=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"dontdecompzipatall",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"dontdecompzipatall",1)+19)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        dontdecompzipatall=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"zippath",1)<>0 Then
                wert = Right(kette,Len(kette) -8)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    zippath=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"zipfilelist",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"zipfilelist",1)+11)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        zipfilelist=True
                    End If
                End If
            End If
            
            
            
            If InStr(1,kette,"MSWordinstalled",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"MSWordinstalled",1)+16)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        MSWordinstalled=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"MSExcelinstalled",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"MSExcelinstalled",1)+17)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        MSExcelinstalled=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"MSPowerPointinstalled",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"MSPowerPointinstalled",1)+22)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        MSPowerPointinstalled=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"MSOffice2007installed",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"MSOffice2007installed",1)+22)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        MSOffice2007installed=True
                    End If
                End If
            End If
            
            
            If InStr(1,kette,"emailacceptnoextension",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"emailacceptnoextension",1)+23)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        emailacceptnoextension=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"linkdoubleattachments",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"linkdoubleattachments",1)+22)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        linkdoubleattachments=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"emailwhitelistextensions",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"emailwhitelistextensions",1)+25)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    emailwhite=Trim(LCase(wert))
                End If
            End If
            
            If InStr(1,kette,"emailblacklistextensions",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"emailblacklistextensions",1)+25)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    emailblack=Trim(LCase(wert))
                End If
            End If
            
            If InStr(1,kette,"attachmentarchiv",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"attachmentarchiv",1)+17)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    attachmentarchiv=Trim(LCase(wert))
                End If
            End If
            
            If InStr(1,kette,"useDSO",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"useDSO",1)+7)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="false" Then
                        useDSO=False
                    End If
                End If
            End If
            
            
            
            If InStr(1,kette,"omp16multipages",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"omp16multipages",1)+16)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        ompmultipages=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"omp17multipages",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"omp17multipages",1)+16)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        ompmultipages=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"ompmultipages",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"ompmultipages",1)+14)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        ompmultipages=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"omptryonce",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"omptryonce",1)+11)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        omptryonce=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"ompdontcomparetxt",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"ompdontcomparetxt",1)+18)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        ompdontcomparetxt=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"ompwaittime",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"ompwaittime",1)+12)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    wert = Trim(wert)
                    wert=StrConvert(wert)
                    ompwaittime=wert
                End If
            End If
            
            If InStr(1,kette,"jobrunnertimeout",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"jobrunnertimeout",1)+17)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    wert = Trim(wert)
                    wert=StrConvert(wert)
                    jobrunnertimeout=wert
                End If
            End If
            
            If InStr(1,kette,"maxpdfpages",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"maxpdfpages",1)+12)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    wert = Trim(wert)
                    wert=StrConvert(wert)
                    maxpdfpages=wert
                End If
            End If
            
            If InStr(1,kette,"xlsmaxpages",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"xlsmaxpages",1)+12)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    wert = Trim(wert)
                    wert=StrConvert(wert)
                    xlsmaxpages=wert
                End If
            End If
            
            
            
            If InStr(1,kette,"tolerantocrcheck",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"tolerantocrcheck",1)+17)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        tolerantocrcheck=True
                    End If
                End If
            End If
            
            
            If InStr(1,kette,"alertonemptydoctxt",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"alertonemptydoctxt",1)+19)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        alertonemptydoctxt=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"stoponemptydoctxt",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"stoponemptydoctxt",1)+18)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        stoponemptydoctxt=True
                    End If
                End If
            End If
            If InStr(1,kette,"alertonemptydoctxtcounter",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"alertonemptydoctxtcounter",1)+26)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    wert = Trim(wert)
                    wert=StrConvert(wert)
                    alertonemptydoctxtcounter=wert
                    
                End If
            End If
            
            If InStr(1,kette,"alertongarbage",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"alertongarbage",1)+15)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        alertongarbage=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"alertongarbagecounter",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"alertongarbagecounter",1)+22)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    wert = Trim(wert)
                    wert=StrConvert(wert)
                    alertongarbagecounter=wert
                    
                End If
            End If
            
            If InStr(1,kette,"NOEXTNRS",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"noextNRS",1)+9)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        NOEXTNRS=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"emlNRS",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"emlNRS",1)+7)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        emlNRS=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"msgNRS",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"msgNRS",1)+7)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        msgNRS=True
                    End If
                End If
            End If
            
            
            If InStr(1,kette,"solidworksnrs",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"solidworksnrs",1)+14)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        solidworksnrs=True
                    End If
                End If
            End If
            
            
            
            If InStr(1,kette,"JPGNRS",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"JPGNRS",1)+7)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        JPGNRS=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"PDFNRS",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"PDFNRS",1)+7)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        PDFNRS=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"XMLNRS",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"XMLNRS",1)+7)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        XMLNRS=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"PPTNRS",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"PPTNRS",1)+7)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        PPTNRS=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"GIFNRS",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"GIFNRS",1)+7)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        GIFNRS=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"BMPNRS",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"BMPNRS",1)+7)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        BMPNRS=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"PNGNRS",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"PNGNRS",1)+7)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        PNGNRS=True
                    End If
                End If
            End If  
            
            
            If InStr(1,kette,"xsltconverterpath",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"xsltconverterpath",1)+17)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    xsltconverterpath=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"xslttemplate",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"xslttemplate",1)+12)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    xslttemplate=Trim(wert)
                End If
            End If		
            
            If InStr(1,kette,"pcltotif",1)<>0 Then
                wert=LCase(GetString(kette,InStr(1,kette,"pcltotif",1)+9))
                If (wert<>"") And (Len(wert)>2) Then
                    pcltotif=wert
                End If
            End If	
            
            If InStr(1,kette,"dontconvertcommatopoint",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"dontconvertcommatopoint",1)+24)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        dontconvertcommatopoint=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"dontuseocrforbmp",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"dontuseocrforbmp",1)+17)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        dontuseocrforbmp=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"dontuseocrforjpg",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"dontuseocrforjpg",1)+17)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        dontuseocrforjpg=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"dontuseocrforgif",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"dontuseocrforgif",1)+17)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        dontuseocrforgif=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"dontuseocrforpng",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"dontuseocrforpng",1)+17)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        dontuseocrforpng=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"dontuseocrforcad",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"dontuseocrforcad",1)+17)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        dontuseocrforcad=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"exifreader",1)<>0 Then
                wert = Right(kette,Len(kette) -11)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    exifreader=Trim(wert)
                End If
            End If
            
            If InStr(1,kette,"changeresolution",1)<>0 Then
                wert = Right(kette,Len(kette) -17)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    wert=Replace(wert," ","")
                    wert=Replace(wert,"	","")
                    gefunden=False
                    i=0
                    Do While gefunden = False
                        If changeresolution(i)="" Then
                            gefunden=True
                            changeresolution(i)=Trim(wert)
                        End If
                        If gefunden=False Then
                            i=i+1
                        End If
                        If i>99 Then
                            gefunden=True
                            objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Fehler inilesen: mehr als 100 changeresolution werden nicht untersttzt."
                        End If
                    Loop
                End If
            End If
            
            If InStr(1,kette,"opensslpath",1)<>0 Then
                wert = Right(kette,Len(kette) -12)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    opensslpath=Trim(objWSHShell.ExpandEnvironmentStrings(wert))
                End If
            End If
            
            If InStr(1,kette,"showhostinhist",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"showhostinhist",1)+15)
                If LCase(wert)="true" Then
                    showhost = " (" &objWSHShell.ExpandEnvironmentStrings("%computername%") &")"  
                Else
                    showhost = ""
                End If	
            End If
            
            If InStr(1,kette,"pdfAutoRotate",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"pdfAutoRotate",1)+14)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        pdfAutoRotate=True
                    Else 
                        pdfAutoRotate=False
                    End If	
                End If
            End If
            
            If InStr(1,kette,"tifAutoRotate",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"tifAutoRotate",1)+14)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        tifAutoRotate=True
                    Else 
                        tifAutoRotate=False
                    End If	
                End If
            End If
            
            
            If InStr(1,kette,"MSWordupdatefields",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"MSWordupdatefields",1)+19)
                If LCase(wert)="true" Then
                    MSWordupdatefields = True
                End If	
            End If
            
            If InStr(1,kette,"attachmentdontuseoriname",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"attachmentdontuseoriname",1)+25)
                If LCase(wert)="true" Then
                    attachmentdontuseoriname = True
                End If	
            End If   
            
            If InStr(1,kette,"dontextractmsgattachments",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"dontextractmsgattachments",1)+25)
                If LCase(wert)="true" Then
                    dontExtractMsgAttachments = True
                End If	
            End If   
            
            If InStr(1,kette,"addpdfinfo",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"addpdfinfo",1)+11)
                If LCase(wert)="false" Then
                    addpdfinfo = False
                End If	
            End If 
            
            If InStr(1,kette,"dontnormdokname",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"dontnormdokname",1)+16)
                If LCase(wert)="true" Then
                    dontnormdokname = True
                End If	
            End If            
        End If
        
        If InStr(1, kette, "notificationconverttif", 1) <> 0 Then
            wert = GetString(kette, InStr(1, kette, "notificationconverttif", 1) + 23)
            If LCase(wert) = "true" Then notificationconverttif = True
        End If
        
        If InStr(1, kette, "loadimages", 1) <> 0 Then
            wert = GetString(kette, InStr(1, kette, "loadimages", 1) + 11)
            If LCase(wert) = "false" Then loadimages = False
        End If
        
        If InStr(1, kette, "directiveextensions", 1) <> 0 Then
			If Left(kette,1)<>";" Then
	        	wert = GetString(kette, InStr(1, kette, "directiveextensions", 1) + 20)
	        	If Trim(wert) <> "" Then
	        		directiveextensions = wert
	        	Else
	        		directiveextensions = ".tif"
	        	End If
	        End If
        End If    
        
    Loop
    inifile.close
    Set inifile = Nothing
    If programm="" Then
        objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - kein Programmpfad."
        WScript.Quit
    End If
    
End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************


Function filterlesen(filtername)
    On Error Resume Next
    filterlesen=True
    Err.clear
    
    Set inifile = fs.OpenTextFile(programm&"filter\"&filtername&".fad",1)
    If Err.number Then
        Err.clear
        On Error Resume Next
        objWshShell.LogEvent 1, "Filterdatei nicht vorhanden oder nicht lesbar."
        filterlesen=False
    End If 
    
    
    Do While inifile.AtEndOfStream <> True
        kette=inifile.readline
        If Left(kette,1)<>";" Then
            
            
            
            If InStr(1,kette,"Archivfilter",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"Archivfilter",1)+12)
                
                Archivfilter = wert
                
            End If
            
            If InStr(1,kette,"OCRFilter",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"OCRFilter",1)+10)
                
                OCRFilter = wert
                
            End If
            
            
        End If
        
    Loop
    inifile.close
    Set inifile = Nothing
    If Archivfilter="" And OCRFilter="" Then
        filterlesen=False
    End If 
    
    
    
End Function



'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function getinfo(datei)
    On Error Resume Next
    fs.copyfile datei, datei&".ori"
    originalkopie = datei & ".ori"
    If useDSO=True Then
        MakroImport="0"
        BFADocName=""
        getinfo=True
        On Error Resume Next
        'On Error GoTo 0
        
        Set objFile = CreateObject("DSOFile.OleDocumentProperties")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            getinfo=False
            If scriptdebug = True Then
            	objWshShell.LogEvent 2, "bitfarm-Archiv: Dateiarchivierung: kann keine Verbindung zu DSO aufbauen. dsofile.dll registriert?"
            End If
        End If
        
        WScript.Sleep 500
        

        
        If getinfo=True Then
            resetwriteprotectbit(originalkopie)
            WScript.sleep 30
        End If
        
        If getinfo=True Then
            objFile.Open(originalkopie)
            
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                getinfo=False
                objWshShell.LogEvent 2, "bitfarm-Archiv: Dateiarchivierung: DSO-Auslesen fehlgeschlagen, Datei ist im Zugriff."
            End If
        End If
        
        If getinfo=True Then
            
            FileInfoDescription(0)="Autor"
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
            End If
            On Error Resume Next
            FileInfoValue(0)=objFile.SummaryProperties.Author
            If Err.number<>0 Then
                objWshShell.LogEvent 2, "bitfarm-Archiv: Dateiarchivierung: DSO-Auslesen fehlgeschlagen(0)" & vbCrLf & Err.number & vbCrLf & Err.Description
                Err.clear
                On Error Resume Next
            End If
            autor=FileInfoValue(0)
            FileInfoDescription(1)="Kategorie"
            FileInfoValue(1)=objFile.SummaryProperties.Category
            If Err.number<>0 Then
                objWshShell.LogEvent 2, "bitfarm-Archiv: Dateiarchivierung: DSO-Auslesen fehlgeschlagen(1)" & vbCrLf & Err.number & vbCrLf & Err.Description
                Err.clear
                On Error Resume Next
            End If
            kategorie=FileInfoValue(1)
            FileInfoDescription(2)="Bemerkungen"
            FileInfoValue(2)=objFile.SummaryProperties.Comments
            If Err.number<>0 Then
                objWshShell.LogEvent 2, "bitfarm-Archiv: Dateiarchivierung: DSO-Auslesen fehlgeschlagen(2)" & vbCrLf & Err.number & vbCrLf & Err.Description
                Err.clear
                On Error Resume Next
            End If
            If Len(FileInfoValue(2))>200 Then
                FileInfoValue(2)=""
            End If
            FileInfoDescription(3)="Firma"
            FileInfoValue(3)=objFile.SummaryProperties.Company
            If Err.number<>0 Then
                objWshShell.LogEvent 2, "bitfarm-Archiv: Dateiarchivierung: DSO-Auslesen fehlgeschlagen(3)" & vbCrLf & Err.number & vbCrLf & Err.Description
                Err.clear
                On Error Resume Next
            End If
            FileInfoDescription(4)="Erstellungsdatum"
            FileInfoValue(4)=objFile.SummaryProperties.DateCreated
            If Err.number<>0 Then
                objWshShell.LogEvent 2, "bitfarm-Archiv: Dateiarchivierung: DSO-Auslesen fehlgeschlagen(4)" & vbCrLf & Err.number & vbCrLf & Err.Description
                Err.clear
                On Error Resume Next
            End If
            Erstellungsdatum=FileInfoValue(4)
            FileInfoDescription(5)="Letzter Druck"
            FileInfoValue(5)=objFile.SummaryProperties.DateLastPrinted
            If Err.number<>0 Then
                objWshShell.LogEvent 2, "bitfarm-Archiv: Dateiarchivierung: DSO-Auslesen fehlgeschlagen(5)" & vbCrLf & Err.number & vbCrLf & Err.Description
                Err.clear
                On Error Resume Next
            End If
            FileInfoDescription(6)="Letzte Speicherung"
            FileInfoValue(6)=objFile.SummaryProperties.DateLastSaved
            If Err.number<>0 Then
                objWshShell.LogEvent 2, "bitfarm-Archiv: Dateiarchivierung: DSO-Auslesen fehlgeschlagen(6)" & vbCrLf & Err.number & vbCrLf & Err.Description
                Err.clear
                On Error Resume Next
            End If
            FileInfoDescription(7)="Stichwrter"
            FileInfoValue(7)=objFile.SummaryProperties.Keywords
            If Err.number<>0 Then
                objWshShell.LogEvent 2, "bitfarm-Archiv: Dateiarchivierung: DSO-Auslesen fehlgeschlagen(7)" & vbCrLf & Err.number & vbCrLf & Err.Description
                Err.clear
                On Error Resume Next
            End If
            FileInfoDescription(8)="Zuletzt gespeichert von"
            FileInfoValue(8)=objFile.SummaryProperties.LastSavedBy
            If Err.number<>0 Then
                objWshShell.LogEvent 2, "bitfarm-Archiv: Dateiarchivierung: DSO-Auslesen fehlgeschlagen(8)" & vbCrLf & Err.number & vbCrLf & Err.Description
                Err.clear
                On Error Resume Next
            End If
            FileInfoDescription(9)="Manager"
            FileInfoValue(9)=objFile.SummaryProperties.Manager
            If Err.number<>0 Then
                objWshShell.LogEvent 2, "bitfarm-Archiv: Dateiarchivierung: DSO-Auslesen fehlgeschlagen(9)" & vbCrLf & Err.number & vbCrLf & Err.Description
                Err.clear
                On Error Resume Next
            End If
            FileInfoDescription(10)="Revision"
            FileInfoValue(10)=objFile.SummaryProperties.RevisionNumber
            If Err.number<>0 Then
                objWshShell.LogEvent 2, "bitfarm-Archiv: Dateiarchivierung: DSO-Auslesen fehlgeschlagen(10)" & vbCrLf & Err.number & vbCrLf & Err.Description
                Err.clear
                On Error Resume Next
            End If
            FileInfoDescription(11)="Thema"
            FileInfoValue(11)=objFile.SummaryProperties.Subject
            If Err.number<>0 Then
                objWshShell.LogEvent 2, "bitfarm-Archiv: Dateiarchivierung: DSO-Auslesen fehlgeschlagen(11)" & vbCrLf & Err.number & vbCrLf & Err.Description
                Err.clear
                On Error Resume Next
            End If
            FileInfoDescription(12)="Titel"
            FileInfoValue(12)=objFile.SummaryProperties.Title
            If Err.number<>0 Then
                objWshShell.LogEvent 2, "bitfarm-Archiv: Dateiarchivierung: DSO-Auslesen fehlgeschlagen(12)" & vbCrLf & Err.number & vbCrLf & Err.Description
                Err.clear
                On Error Resume Next
            End If
            titel=FileInfoValue(12)

            FileInfoDescription(13)="Gesamte Bearbeitungszeit"
            FileInfoValue(13)=objFile.SummaryProperties.TotalEditTime
            If Err.number<>0 Then
                objWshShell.LogEvent 2, "bitfarm-Archiv: Dateiarchivierung: DSO-Auslesen fehlgeschlagen(13)" & vbCrLf & Err.number & vbCrLf & Err.Description
                Err.clear
                On Error Resume Next
            End If
            
            x=14
            For Each objProperty In objFile.CustomProperties
                If Err.number<>0 Then
                    objWshShell.LogEvent 2, "bitfarm-Archiv: Dateiarchivierung: DSO-Auslesen fehlgeschlagen(" & x & ")" & vbCrLf & Err.number & vbCrLf & Err.Description
                    Err.clear
                    On Error Resume Next
                End If
                FileInfoDescription(x)=objProperty.Name
                FileInfoDescription(x)=Mid(FileInfoDescription(x),1,Len(FileInfoDescription(x)))
                FileInfoValue(x)=objProperty.Value
                FileInfoValue(x)=Mid(FileInfoValue(x),1,Len(FileInfoValue(x)))
                x=x+1
                If x>59 Then
                    x=59
                End If
            Next
            If FileInfoDescription(x-1)="_PID_HLINKS" Then
                FileInfoValue(x-1)=""
                FileInfoDescription(x-1)=""
            End If
            
            FileInfoValue(x)=""
            FileInfoDescription(x)=""
            For x=0 To 59
                FileInfoDescription(x)=Mid(FileInfoDescription(x),1,Len(FileInfoDescription(x)))
                FileInfoValue(x)=Mid(FileInfoValue(x),1,Len(FileInfoValue(x)))

                If FileInfoDescription(x)="BFADocVersion" Then
                    DocVersion=FileInfoValue(x)
                End If
                If FileInfoDescription(x)="BFADocLink" Then
                    DocLink=FileInfoValue(x)
                    If doclink <> "" Then
                        If IsInArray(doclink, linkspeicher) = False Then
                            linkspeicher(linkzaehler)=doclink
                            linkzaehler=linkzaehler+1
                        End If
                    End If
                    
                End If
                If FileInfoDescription(x)="BFAMakroImport" Then
                    MakroImport=FileInfoValue(x)
                End If

                If FileInfoDescription(x)="BFADocName" Then
                    
                    BFADocName=FileInfoValue(x)
                    
                End If
                
                
            Next
            
        End If
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            getinfo=False
            objWshShell.LogEvent 2, "bitfarm-Archiv: Dateiarchivierung: DSO-Auslesen fehlgeschlagen, unbekannte Ursache."
        End If
        
        
        If hostversion = "w2k" And ( (extension=".docx") Or (extension=".docm")  Or (extension=".dotx") Or (extension=".dotm")  Or (extension=".xlsx") Or (extension=".xlsm") Or (extension=".xltx") Or (extension=".xltm")) Then
            If getinfo=True Then
                objFile.Close
                If Err.number<>0 Then
                    Err.clear
                    On Error Resume Next
                End If
                Set objFile=Nothing
                If Err.number<>0 Then
                    Err.clear
                    On Error Resume Next
                End If
                WScript.Sleep 50
                
            End If	
            

            getinfo = read2007(fs.getbasename(originaldatei))
            
        Else
            If changeling = False Then  	'nur erzeugen wenn das dok nicht
                'ber den nderungsdienst/Aktualisieren kommt	
                
                '###########################  ggf. einen DocLink erzeugen, wenn noch keiner existiert ######################
                If (getinfo=True) And (doclink="") And ((extension=".doc") Or (extension=".docx") Or (extension=".docm") Or (extension=".xls") Or (extension=".xlsx") Or (extension=".xlsm")) Then
                    On Error Resume Next
                    
                    Err.clear
                    objfile.Customproperties.add "BFADocLink", 4
                    
                    If Err.number<>0 Then
                        Err.clear
                        objWshShell.LogEvent 2, "bitfarm-Archiv: Archivierung: Fehler beim Versuch, einen neuen DocLink zu erstellen1"
                    End If
                    
                    
                    
                    DocLink = "DocLink-" & DatePart("yyyy", Date) & DatePart("m", Date) & DatePart("d", Date) & DatePart("h", Time) & DatePart("n", Time) & DatePart("s", Time) & zufallszahl(0,9999)
                    objFile.Save
                    Err.clear
                    
                    Set objproperty = objFile.CustomProperties.Item("BFADocLink")
                    If Err.number<>0 Then
                        Err.clear
                        On Error Resume Next
                    End If
                    
                    objproperty.Value = doclink
                    
                    If Err.number<>0 Then
                        
                        Err.clear
                        On Error Resume Next
                        
                        objWshShell.LogEvent 2, "bitfarm-Archiv: Archivierung: Fehler beim Versuch, einen neuen DocLink zu erstellen"

                    End If
                End If	
                
                
                
                
                
                '###########################  Checken, ob Dokument von Makro kommt. Wenn nicht, DocVersion eins hochzhlen (da noch nicht in Makro passiert) ######################
                If (getinfo=True) And (DocVersion<>"") And (MakroImport="0") And ((extension=".doc") Or (extension=".docx") Or (extension=".docm") Or (extension=".xls") Or (extension=".xlsx") Or (extension=".xlsm")) Then
                    On Error Resume Next
                    
                    Err.clear
                    objfile.Customproperties.add "BFAMakroImport", 4
                    If Err.number<>0 Then
                        Err.clear
                        On Error Resume Next
                    End If
                    
                    
                    numdocversion=0
                    numdocversion=strconvert(DocVersion)
                    numdocversion=numdocversion+1
                    
                    DocVersion = numdocversion
                    
                    objFile.Save
                    Err.clear
                    
                    Set objproperty = objFile.CustomProperties.Item("BFADocVersion")
                    If Err.number<>0 Then
                        Err.clear
                        On Error Resume Next
                    End If
                    
                    
                    
                    objproperty.Value = CStr(numdocversion)
                    If Err.number<>0 Then
                        Err.clear
                        On Error Resume Next
                    End If
                    
                End If	
                
                '###########################  ggf. eine DocVersion erzeugen, wenn noch keiner existiert ######################
                If (getinfo=True) And (DocVersion="") And ((extension=".doc") Or (extension=".docx") Or (extension=".docm") Or (extension=".xls") Or (extension=".xlsx") Or (extension=".xlsm")) Then
                    On Error Resume Next
                    
                    Err.clear
                    objfile.Customproperties.add "BFADocVersion", 4
                    If Err.number<>0 Then
                        Err.clear
                        On Error Resume Next
                    End If
                    
                    If Err.number<>0 Then
                        Err.clear
                        objWshShell.LogEvent 2, "bitfarm-Archiv: Archivierung: Fehler beim Versuch, einen neuen DocVersion zu erstellen1"
                    End If
                    
                    
                    
                    DocVersion = "1"
                    objFile.Save
                    Err.clear
                    
                    Set objproperty = objFile.CustomProperties.Item("BFADocVersion")
                    If Err.number<>0 Then
                        Err.clear
                        On Error Resume Next
                    End If
                    
                    objproperty.Value = DocVersion
                    If Err.number<>0 Then
                        Err.clear
                        On Error Resume Next
                    End If
                    If Err.number<>0 Then
                        Err.clear
                        objWshShell.LogEvent 2, "bitfarm-Archiv: Archivierung: Fehler beim Versuch, einen neuen DocVersion zu erstellen"
                        
                    End If
                End If	
                
                '###########################  Falls Dokument ber Makro kam, Status zurcksetzen    ######################
                If (getinfo=True) And (MakroImport<>"0") Then
                    On Error Resume Next
                    
                    MakroImport="0"
                    
                    Set objproperty = objFile.CustomProperties.Item("BFAMakroImport")
                    If Err.number<>0 Then
                        Err.clear
                        On Error Resume Next
                    End If
                    
                    objproperty.Value = MakroImport
                    If Err.number<>0 Then
                        Err.clear
                        On Error Resume Next
                    End If
                    
                End If	
                
                If getinfo=True Then
                    objFile.Save
                    If Err.number<>0 Then
                        Err.clear
                        On Error Resume Next
                        
                    End If
                End If
                
                If getinfo=True Then
                    objFile.Close
                    If Err.number<>0 Then
                        Err.clear
                        On Error Resume Next
                    End If
                    Set objFile=Nothing
                    If Err.number<>0 Then
                        Err.clear
                        On Error Resume Next
                    End If
                    WScript.Sleep 50
                    
                End If	
                '#######################################   Abfrage ber dsofile fertig     #######################################

                
                
            End If
            
        End If
        
        
        If fs.fileexists(myinfodatei) Then
            fs.deletefile(myinfodatei)
        End If
        

    End If
    If fs.fileexists(datei&".ori") Then
    	fs.deletefile datei&".ori", True
    End If
End Function



Function read2007(file2007)
    On Error Resume Next
    
    read2007 = True
    
    origname = file2007 & extension
    extract = temp & file2007 & extension
    
    
    fs.copyfile queue & file2007 & extension, temp & file2007 & extension & ".zip", True
    
    If Err.Number<> 0 Then
        objWshShell.LogEvent 2,"Archivierung read2007: Fehler beim umkopieren der zip-datei" &vbCrLf& queue & file2007 & extension&vbCrLf&temp & file2007 & extension & ".zip"
        
        read2007 = False	
    End If
    
    If read2007 = True Then
        
        
        lngReturnCode = objWSHShell.Run(Chr(34)&zippath&Chr(34)&" x " &Chr(34)& temp &file2007& extension&".zip"&Chr(34)&" -o"& Chr(34)&extract& Chr(34)&" -r -y", 0, True)
        WScript.Sleep 500
        If lngReturnCode<> 0 Then
            objWshShell.LogEvent 2,"Archivierung read2007: Fehler beim entpacken der zip datei" &vbCrLf&temp &file2007& extension&".zip"
            read2007 = False
        End If
    End If
    

    
    If read2007 = True Then
        
        
        Set core = fs.openTextFile( extract& "\docprops\core.xml")
        If Err.Number<> 0 Then
            objWshShell.LogEvent 2,"Archivierung read2007: Fehler beim ffnen der core-datei" 
            
            read2007 = False	
        Else
            
            Do While Not(core.AtendofStream)
                strcore = strcore &  core.readline
                
                
            Loop	
            
            core.close
            
            pos1 = InStr(1,strcore,"<dc:title>")
            If pos1 <> 0 Then
                pos1 = pos1 +10
            End If
            
            pos2 = InStr(1,strcore,"</dc:title>")
            Lange = Len(strcore)
            
            If pos1 <> 0 And pos2=>pos1 Then
                titel = Mid(strcore,pos1,pos2-pos1)		
                If titel <> "" Then
                    myname = normstring(titel)
                End If
            End If
        End If
        
        
    End If
    
    
    If read2007 = True Then
        
        If Not(fs.Fileexists(	extract& "\docprops\custom.xml")) Then
            objWshShell.LogEvent 2,"Archivierung: Read2007  Keine CustomProperties vorhanden, generiere.."
            erfolgcreate = create2007props(extract)
            If erfolgcreate = False Then
                objWshShell.LogEvent 2,"Archivierung: Read2007  Fehler beim generieren von Customproperties"
                read2007 = False
            End If
            
        End If
        
        
    End If
    If read2007 = True Then
        
        Set xml = fs.openTextFile( extract& "\docprops\custom.xml")
        
        If Err.Number<> 0 Then
            objWshShell.LogEvent 2,"Archivierung read2007: Fehler beim ffnen der \docprops\custom.xml"
            
            read2007 = False	
        Else
            Set out = fs.CreateTextFile(extract& "\docprops\custom2.xml",True)
            If Err.Number<> 0 Then
                objWshShell.LogEvent 2,"Archivierung read2007: Fehler beim erstellen der \docprops\custom2.xml"
                
                read2007 = False	
            Else	
                Do While Not(xml.AtendofStream)
                    strxmlhead =  xml.readline
                    out.writeline strxmlhead
                    strxml = xml.readline
                    
                    
                Loop
                
                xml.close
                
                pos1 = InStr(1,strxml,"BFADocVersion")
                If pos1 <> 0 Then
                    pos1 = pos1 +26
                End If
                pos2 = InStr(pos1,strxml,"</vt:lpwstr>")
                Lange = Len(strxml)
                
                If pos1 <> 0 And pos2=>pos1 Then
                    docversion = Mid(strxml,pos1,pos2-pos1)
                End If
                
                pos3 = InStr(1,strxml,"BFAMakroImport")
                If pos3 <> 0 Then
                    pos3 = pos3 +27
                End If
                pos4 = InStr(pos3,strxml,"</vt:lpwstr>")
                Lange = Len(strxml)
                
                If pos3 <> 0 And pos4=>pos3 Then
                    makroimport = Mid(strxml,pos3,pos4-pos3)
                End If
                
                pos5 = InStr(1,strxml,"BFADocLink")
                If pos5 <> 0 Then
                    pos5 = pos5 +23
                End If
                pos6 = InStr(pos5,strxml,"</vt:lpwstr>")
                Lange = Len(strxml)
                
                If pos5 <> 0 And pos6=>pos5 Then
                    doclink =Mid(strxml,pos5,pos6-pos5)
                End If
                
                
                
                pos7 = InStr(1,strxml,"fmtid")
                If pos7 <> 0 Then
                    pos7 = pos7 +7
                End If
                pos8 = InStr(pos7,strxml,"}")
                Lange = Len(strxml)
                
                If pos7 <> 0 And pos8=>pos7 Then
                    fmtid =Mid(strxml,pos7,pos8-pos7+1)
                End If
                
                
                If doclink = "" Then
                    DocLink = "DocLink-" & DatePart("yyyy", Date) & DatePart("m", Date) & DatePart("d", Date) & DatePart("h", Time) & DatePart("n", Time) & DatePart("s", Time) & zufallszahl(0,9999)
                End If	
                
                If docversion = "" Then
                    docversion = 0
                End If
                
                If makroimport = "" Then
                    makroimport= "0"
                End If
                
              
                
                ' eins hochzhlen, wenn dokument nicht vom makro kam, ansonsten wurde dort schon hochgezhlt
                If makroimport = "0" Then 
                    docversion = CInt(docversion)
                    docversion = docversion +1
                    docversion = CStr(docversion)
                End If
                If makroimport = "1" Then
                    makroimport ="0"
                End If
                
                If pos7 <> 0 Then
                    newxml = Mid(strxml,1,pos7-1) &fmtid & Chr(34) & " pid=""2"" name=""BFADocLink""><vt:lpwstr>"& doclink & "</vt:lpwstr></property><property fmtid=" & Chr(34) & fmtid  & Chr(34) &  " pid=""3"" name=""BFADocVersion""><vt:lpwstr>" & docversion &  "</vt:lpwstr></property><property fmtid=" & Chr(34) & fmtid   & Chr(34) &  " pid=""4"" name=""BFAMakroImport""><vt:lpwstr>" & makroimport & "</vt:lpwstr></property></Properties>"
                    'MsgBox newxml
                    out.writeline newxml
                Else
                    out.writeline strxml
                End If
                
                out.close
                
                WScript.sleep 200
                
            End If
        End If
        
        If Not(fs.Fileexists(extract& "\docprops\custom2.xml")) Then
            objWshShell.LogEvent 2,"Archivierung read2007: Fehler beim Erstellen der temp. XML-Datei" &vbCrLf& extract& "\docprops\custom2.xml"
            read2007 = False
        End If
        
    End If
    
    If read2007 = True Then
        
        
        fs.deletefile extract & "\docprops\custom.xml",True
        If Err.Number<> 0 Then
            objWshShell.LogEvent 2,"Archivierung read2007: Fehler beim lschen der urspr. XML-Datei" &vbCrLf& extract & "\docprops\custom.xml"
            
            read2007 = False	
        End If
        
    End If
    If read2007 = True Then
        fs.Movefile extract& "\docprops\custom2.xml", extract & "\docprops\custom.xml"
        If Err.Number<> 0 Then
            objWshShell.LogEvent 2,"Archivierung read2007: Fehler beim umkopieren der neuen XML-Datei" &vbCrLf& extract & "\docprops\custom2.xml"
            
            read2007 = False	
        End If
        
        
    End If
    
    
    If read2007 = True Then
        lngReturnCode = objWSHShell.Run("c:\programme\7-zip\7z a -tzip "& extract&".zip " & extract& "\*.* -r -y")
        WScript.Sleep 300
        If lngReturnCode<> 0 Then
            objWshShell.LogEvent 2,"Archivierung read2007: Fehler beim Packen des aktualisierten Zip-Containers"&vbCrLf&extract&".zip"
            read2007 = False
            
        End If
        
    End If 
    
    
    If read2007 = True Then
        
        fs.deletefile queue & file2007 & extension
        WScript.Sleep 100
        If Err.Number<> 0 Then
            objWshShell.LogEvent 2,"Archivierung read2007: Fehler beim lschen der ursp. Office Datei" &vbCrLf& queue & file2007
            
            read2007 = False	
        End If
        
    End If
    If read2007 = True Then
        
        fs.Movefile extract& ".zip", queue & origname
        WScript.Sleep 100
        If Err.Number<> 0 Then
            objWshShell.LogEvent 2,"Archivierung read2007: Fehler beim umkopieren der neuen zip-Datei zur ursp. Office Datei" &vbCrLf& extract& ".zip"&vbCrLf&queue & origname
            
            read2007 = False	
        End If
        
    End If
    If read2007 = True Then
        fs.deletefolder extract, True
        WScript.Sleep 100
        If Err.Number<> 0 Then
            objWshShell.LogEvent 2,"Archivierung read2007: Fehler beim lschen des temp Verzeichnisses" &vbCrLf& extract
            
            read2007 = False	
        End If
    End If
    If read2007 = False Then
        objWshShell.LogEvent 2,"Archivierung read2007: Allgemeiner Fehler beim Verarbeiten" &vbCrLf& extract	
    End If
    
End Function



Function create2007props(propspath)
    On Error Resume Next
    
    create2007props = True
    
    xmltemplate = programm & "xmltemplate.xml"
    
    If Not(Fs.Fileexists(xmltemplate)) Then
        objWshShell.LogEvent 2,"create2007props: Kein Template gefunden"&vbCrLf&xmltemplate
        create2007props = False
    End If
    
    If create2007props = True Then
        fs.Copyfile xmltemplate, propspath &"\docprops\custom.xml"
        If Err.Number<> 0 Then
            objWshShell.LogEvent 2,"Archivierung create2007props: Fehler beim kopieren des templates " &vbCrLf& xmltemplate
            
            create2007props= False	
        End If
    End If	
    
    ' .rels updaten
    
    If create2007props = True Then
        Set rels = fs.opentextfile(propspath &"\_rels\.rels",1)
        
        Do While Not(rels.atendofstream)
            strrels = strrels & rels.readline	
        Loop
        
        rels.close	
        
        strrels = Replace(strrels,"</Relationships>","<Relationship Id=""rId999"" Type=""http://schemas.openxmlformats.org/officeDocument/2006/relationships/custom-properties"" Target=""docProps/custom.xml""/></Relationships>")
        
        Set rels = fs.createtextfile(propspath &"\_rels\.rels", True)
        rels.writeline strrels
        rels.close
        
        If Err.Number<> 0 Then
            objWshShell.LogEvent 2,"Archivierung create2007props: Fehler beim erstellen der .rels " &vbCrLf& xmltemplate
            
            create2007props= False	
        End If
        
        
        'MsgBox "strrels:"&strrels
        
    End If
    
    '[Content_Types].xml updaten
    
    If create2007props = True Then
        'MsgBox "propspath &\[Content_Types].xml:"&propspath &"\[Content_Types].xml"
        Set cont = fs.opentextfile(propspath &"\[Content_Types].xml",1)
        
        
        Do While Not(cont.atendofstream)
            strcont = strcont & cont.readline
            
        Loop
        'MsgBox "strcont:"&strcont
        
        cont.close	
        
        strcont = Replace(strcont,"</Types>","<Override PartName=""/docProps/custom.xml"" ContentType=""application/vnd.openxmlformats-officedocument.custom-properties+xml""/></Types>")
        
        Set cont = fs.createtextfile(propspath &"\[Content_Types].xml", True)
        cont.writeline strcont
        cont.close
        
        If Err.Number<> 0 Then
            objWshShell.LogEvent 2,"Archivierung create2007props: Fehler beim erstellen der [Content_Types].xml " &vbCrLf& xmltemplate
            
            create2007props= False	
        End If
        
        'MsgBox "strcont:"&strcont
        
    End If
    
End Function



'***************************************************************************************
'***************************************************************************************
'***************************************************************************************



Function setdocname(datei)
    On Error Resume Next
    
    If useDSO=True And changeling = False Then
        '###################  setzt bei Office-Dateien eine Dateieigenschaft, um den Dokumentennamen zu speichern. Damit bei Erzeugung eines Tochterdokuments der Name vernnftig ist, wird dieser dann ausgelesen und genommen.##
        
        setdocname=True
        If myname="" Then
            setdocname=False
        End If
        
        If fs.fileexists(datei)=False Then
            setdocname=False
        End If
        
        If setdocname=True Then
            Set objFile = CreateObject("DSOFile.OleDocumentProperties")
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                setdocname=False
                objWshShell.LogEvent 2, "bitfarm-Archiv: archivierung: setdocname: kann keine Verbindung zu DSO aufbauen. dsofile.dll registriert?"
            End If
            
            WScript.Sleep 500
        End If
        
        
        If setdocname=True Then
            resetwriteprotectbit(datei)
            WScript.sleep 30
        End If
        
        If setdocname=True Then
            objFile.Open(datei)
            
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                setdocname=False
                objWshShell.LogEvent 2, "bitfarm-Archiv: Dateiarchivierung: DSO-Auslesen fehlgeschlagen, Datei ist im Zugriff."
            End If
        End If
        
        
        
        If (setdocname=True) And ((extension=".doc") Or (extension=".docx") Or (extension=".docm") Or (extension=".xls") Or (extension=".xlsx") Or (extension=".xlsm")) Then
            
            On Error Resume Next
            
            Err.clear
            objfile.Customproperties.add "BFADocName", 4
            
            If Err.number<>0 Then
                
                objWshShell.LogEvent 2, "bitfarm-Archiv: Archivierung: setdocname: Fehler beim Versuch, einen neuen BFADocName zu erstellen(1)" & vbCrLf & Err.Description
                Err.clear
            End If
            
            BFADocName = myname
            objFile.Save
            Err.clear
            
            Set objproperty = objFile.CustomProperties.Item("BFADocName")
            If Err.number<>0 Then
                objWshShell.LogEvent 2, "bitfarm-Archiv: Archivierung: setdocname: Fehler beim Versuch, einen neuen BFADocName zu erstellen(3)"& vbCrLf & Err.Description
                Err.clear
                
            End If
            
            objproperty.Value = BFADocName
            objFile.Save
            
            
            If Err.number<>0 Then
                objWshShell.LogEvent 2, "bitfarm-Archiv: Archivierung: setdocname: Fehler beim Versuch, einen neuen BFADocName zu erstellen(3)"& vbCrLf & Err.Description
                Err.clear
                
            Else
                If scriptdebug=True Then
                    objWshShell.LogEvent 2, "bitfarm-Archiv: Archivierung (debug-mode): setdocname: BFADocName als "&BFADocName&" gesetzt."
                End If
            End If
        End If	
        
        If setdocname=True Then
            objFile.Close
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
            End If
            Set objFile=Nothing
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
            End If
            WScript.Sleep 50
            
        End If		
        
    End If	
End Function

















'***************************************************************************************
'***************************************************************************************
'***************************************************************************************


Function create_custom_rsps(dpi)
    On Error Resume Next
    Err.clear
    
    
    rspfile1=programm&"temp\custom-bw.rsp"
    rspfile2=programm&"temp\custom-color.rsp"
    filterfile1=programm&"temp\custom-filter-bw.txt"
    filterfile2=programm&"temp\custom-filter-color.txt"
    
    
    If fs.fileexists(rspfile1) Then
        fs.deletefile rspfile1, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: create_custom_rsps: kann alte rsp nicht lschen: "&rspfile1
            dpi=""
            Exit Function
        End If
    End If
    
    If fs.fileexists(rspfile2) Then
        fs.deletefile rspfile2, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: create_custom_rsps: kann alte rsp nicht lschen: "&rspfile2
            dpi=""
            Exit Function
        End If
    End If
    
    If fs.fileexists(filterfile1) Then
        fs.deletefile filterfile1, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: create_custom_rsps: kann alte rsp nicht lschen: "&filterfile1
            dpi=""
            Exit Function
        End If
    End If
    
    If fs.fileexists(filterfile2) Then
        fs.deletefile filterfile2, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: create_custom_rsps: kann alte rsp nicht lschen: "&filterfile2
            dpi=""
            Exit Function
        End If
    End If
    
    Set rspfile = fs.OpenTextFile(rspfile1,8,True)
    
    rspfile.writeline("-sDEVICE=tiffg4")
    rspfile.writeline("-dNOPAUSE")
    rspfile.writeline("-dSAFER")
    rspfile.writeline("-dBATCH")
    rspfile.writeline("-r"&dpi)
    rspfile.close
    Set rspfile = Nothing
    
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: create_custom_rsps: Fehler beim anlegen rspfile"
        dpi=""
        Exit Function
    End If
    
    Set rspfile = fs.OpenTextFile(rspfile2,8,True)
    
    rspfile.writeline("-sDEVICE=tiff24nc")
    rspfile.writeline("-dNOPAUSE")
    rspfile.writeline("-dSAFER")
    rspfile.writeline("-dBATCH")
    rspfile.writeline("-r"&dpi)
    rspfile.close
    Set rspfile = Nothing
    
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: create_custom_rsps: Fehler beim anlegen rspfile"
        dpi=""
        Exit Function
    End If
    
    Set rspfile = fs.OpenTextFile(filterfile1,8,True)
    rspfile.writeline("RES="&dpi)
    rspfile.writeline("BW=-2")
    rspfile.close
    Set rspfile = Nothing
    
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: create_custom_rsps: Fehler beim anlegen filterfile1"
        dpi=""
        Exit Function
    End If
    
    
    Set rspfile = fs.OpenTextFile(filterfile2,8,True)
    rspfile.writeline("RES="&dpi)
    rspfile.writeline("compauto=80")
    rspfile.close
    Set rspfile = Nothing
    
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: create_custom_rsps: Fehler beim anlegen filterfile2"
        dpi=""
        Exit Function
    End If
    
    
    
End Function


'************************************************************************

Function waitdirect()
    On Error Resume Next
    
    If fs.FileExists(programm&"temp\directlock") Then
        warten=True
        zaehler=0
        Do While warten = True
            WScript.Sleep 537
            If Not fs.FileExists(programm&"temp\directlock") Then
                warten = False
            End If
            If zaehler>8820 Then
                
                warten=False
                objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Timeout beim Warten auf Directlock"
                On Error Resume Next
                fs.deletefile programm&"temp\directlock", True
                Err.clear
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
            zaehler=zaehler + 1
            WScript.Sleep 438
        Loop
    End If
End Function



Function setdirect()
    On Error Resume Next
    
    lockdatei2="temp\directlock"
    If Not fs.FileExists(programm&lockdatei2) Then 
        Set lockfile = fs.CreateTextFile(programm&lockdatei2,True)
        lockfile.Writeline("lock")
        lockfile.close
        
        Set lockfile = Nothing
    Else
        warten=True
        zaehler=0
        Do While warten = True
            WScript.Sleep 873
            If Not fs.FileExists(programm&"temp\directlock") Then
                warten = False
            End If
            If zaehler>820 Then
                zaehler=zaehler + 1
                warten=False
                objWshShell.LogEvent 1, "bitfarm-Archiv: Archivierung: Timeout beim Warten auf Directlock"
                On Error Resume Next
                fs.deletefile programm&"temp\directlock", True
                Err.clear
                Unlock(programm&lockdatei)
                WScript.Quit
            End If
        Loop
        On Error Resume Next
        Err.clear
        Set lockfile = fs.CreateTextFile(programm&lockdatei2,True)
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
        lockfile.Writeline("lock")
        lockfile.close
        Set lockfile = Nothing
    End If
End Function



'************************************ lock lschen ***********************************
Function Unlock(lockfileandpath)
    On Error Resume Next
    
    Err.clear
    On Error Resume Next
    If fs.fileexists(lockfileandpath) Then
        fs.DeleteFile lockfileandpath, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            WScript.Sleep 430
            fs.DeleteFile lockfileandpath, True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
                WScript.Sleep 530
                fs.DeleteFile lockfileandpath, True
                If Err.number<>0 Then
                    Err.clear
                    On Error Resume Next
                    'objWshShell.LogEvent 2, "archivierung(F1): Hinweis: konnte lockdatei nicht lschen:"&lockfileandpath
                    
                End If
            End If
            
            
        End If
    End If
    
    If checkstartup = True Then
        objWSHShell.LogEvent 0,"Archivierung.vbs: Lsche " & lockfileandpath & vbCrLf & "Tstamp:" & tstamp & vbCrLf & "Jetzt:" & Timer
    End If
    
End Function



'********************************************************************************
'********************************************************************************
'********************************************************************************
'********************************************************************************
'********************************************************************************


Function readvcard(tempname)
    On Error Resume Next
    
    readvcard=True
    kette=""
    vcardemail=""
    vcardname=""
    vcardtelefon=""
    vcardfax=""
    vcardmobil=""
    vcardfirma=""
    vcardplz=""
    vcardort=""
    vcardanschrift=""
    vcardfirma=""
    vcardweb=""
    vcardland="Deutschland"
    tempstring=""
    
    
    
    If fs.fileexists(tempname&".txt") = False Then
        readvcard=False
    End If
    
    If readvcard=True Then
        Set myvcardfile = fs.OpenTextFile(tempname&".txt",1)
        Do While myvcardfile.atendofstream=False
            kette=kette&vbCrLf&myvcardfile.readline
        Loop
        myvcardfile.close
        Set myvcardfile=Nothing
        If Len(kette)<20 Then
            readvcard=False
        End If	
        
    End If	
    
    
    '################################  Suche Position PLZ, dann Extraktion Firma und Anschrift ########################################
    
    If readvcard=True Then
        pos1=1
        laenge=Len(kette)
        PLZ=""
        posplz=0
        abbruch=False
        tempstring1=getword(kette,pos1)
        tempstring2=""
        neuerstring=True
        Do While abbruch=False
            pos1=pos1+1
            If pos1>=laenge Then 
                abbruch=True
            End If
            If abbruch=False Then
                tempstring2=getword(kette,pos1)
                If tempstring2<>tempstring1 Then
                    tempstring1=tempstring2
                    neuerstring=True
                End If
                If neuerstring=True Then
                    tempstring=tempstring1
                    If Len(tempstring)=7 Then
                        If LCase(Left(tempstring,2))="d-" Then
                            tempstring=Right(tempstring,5)
                        End If
                    End If
                    If Len(tempstring)=7 Then
                        If LCase(Left(tempstring,2))="a-" Then
                            tempstring=Right(tempstring,5)
                            vcardland="sterreich"
                        End If
                    End If
                    If Len(tempstring)=8 Then
                        If LCase(Left(tempstring,3))="ch-" Then
                            tempstring=Right(tempstring,5)
                            vcardland="Schweiz"
                        End If
                    End If
                    If Len(tempstring)=8 Then
                        If LCase(Left(tempstring,3))="nl-" Then
                            tempstring=Right(tempstring,5)
                            vcardland="Niederlande"
                        End If
                    End If
                    
                    If Len(tempstring)=5 Then
                        char1=Asc(Mid(tempstring,1,1))
                        char2=Asc(Mid(tempstring,2,1))
                        char3=Asc(Mid(tempstring,3,1))
                        char4=Asc(Mid(tempstring,4,1))
                        char5=Asc(Mid(tempstring,5,1))
                        If (char1>=48) And (char1<=57) And (char2>=48) And (char2<=57) And (char3>=48) And (char3<=57) And (char4>=48) And (char4<=57) And (char5>=48) And (char5<=57) Then 'Zahlen
                            vcardplz=tempstring
                            abbruch=True
                            posplz=pos1
                        End If	
                        
                    End If
                    neuerstring=False
                End If
            End If
        Loop
        
        If vcardplz<>"" Then
            pos1=posplz+6
            pos2=pos1
            laenge=Len(kette)
            abbruch=False
            zeichen=""
            mychar=0
            tempstring=""
            Do While abbruch=False
                If pos2>=laenge Then
                    abbruch=True
                End If
                If abbruch=False Then
                    zeichen=Mid(kette,pos2,1)
                    mychar=Asc(zeichen)
                End If
                If (mychar=13) Or (mychar=10) Or (mychar=0) Then
                    abbruch=True
                End If
                If abbruch=False Then
                    tempstring=tempstring&zeichen
                    pos2=pos2+1
                End If
            Loop
            
            vcardort=Trim(tempstring)
        End If			
        
        '#####################  Anschrift #######################
        
        If vcardplz<>"" Then
            
            
            pos1=posplz
            
            pos2=pos1-3
            abbruch=False
            zeichen=""
            mychar=0
            tempstring=""
            Do While abbruch=False
                If pos2=0 Then
                    abbruch=True
                End If
                If abbruch=False Then
                    zeichen=Mid(kette,pos2,1)
                    mychar=Asc(zeichen)
                End If
                If (mychar=13) Or (mychar=10) Or (mychar=0) Then
                    abbruch=True
                End If
                If abbruch=False Then
                    tempstring=zeichen&tempstring
                    pos2=pos2-1
                End If
            Loop
            
            vcardanschrift=Trim(tempstring)
        End If			
        
        
        
        '#####################  Firma #######################
        
        If vcardanschrift<>"" Then
            pos1=InStr(1,kette,vcardanschrift,1)
            pos2=pos1-3
            abbruch=False
            zeichen=""
            mychar=0
            tempstring=""
            
            Do While abbruch=False
                If pos2=0 Then
                    abbruch=True
                End If
                If abbruch=False Then
                    zeichen=Mid(kette,pos2,1)
                    mychar=Asc(zeichen)
                End If
                If (mychar=13) Or (mychar=10) Or (mychar=0) Then
                    abbruch=True
                End If
                If abbruch=False Then
                    tempstring=zeichen&tempstring
                    pos2=pos2-1
                End If
            Loop
            
            vcardfirma=Trim(tempstring)
            
        End If			
    End If
    
    
    '############################  alternative Firma ber gmbh ####################
    
    
    If readvcard=True Then
        If InStr(1,kette,"gmbh",1)=True Then
            abbruch=False
            laenge=Len(kette)
            pos1=InStr(1,kette,"gmbh",1)
            mychar=0
            zeichen=""
            Do While abbruch=False
                If pos1>=laenge Then
                    abbruch=True
                End If
                If abbruch=False Then
                    zeichen=Mid(kette,pos1,1)
                    mychar=Asc(zeichen)
                End If
                If (mychar=13) Or (mychar=10) Or (mychar=0) Then
                    abbruch=True
                End If
                If abbruch=False Then
                    pos1=pos1+1
                End If
            Loop
            pos2=pos1-3
            abbruch=False
            zeichen=""
            mychar=0
            tempstring=""
            Do While abbruch=False
                If pos2=0 Then
                    abbruch=True
                End If
                If abbruch=False Then
                    zeichen=Mid(kette,pos2,1)
                    mychar=Asc(zeichen)
                End If
                If (mychar=13) Or (mychar=10) Or (mychar=0) Then
                    abbruch=True
                End If
                If abbruch=False Then
                    tempstring=zeichen&tempstring
                    pos2=pos2-1
                End If
            Loop
            
            vcardfirma=Trim(tempstring)
        End If
    End If
    
    
    '####################################  auslesen E-Mail  #########################################
    
    
    If readvcard=True Then
        If InStr(1,kette,"@",1)<>0 Then
            pos1=1
            pos1=InStr(1,kette,"@",1)
            vcardemail=getword(kette,pos1)
        End If
    End If
    
    
    '####################################  auslesen Web  #########################################
    
    
    If readvcard=True Then
        If InStr(1,kette,"www.",1)<>0 Then
            pos1=1
            pos1=InStr(1,kette,"www.",1)
            vcardweb=getword(kette,pos1)
        End If
    End If
    
    
    '####################################  auslesen Telefon diverse Formatierungen  #########################################
    
    If readvcard=True Then
        If InStr(1,kette,"phone",1)<>0 Then
            pos1=1
            pos1=InStr(1,kette,"phone",1)+6
            pos2=pos1
            laenge=Len(kette)
            abbruch=False
            zeichen=""
            mychar=0
            tempstring=""
            Do While abbruch=False
                If pos2>=laenge Then
                    abbruch=True
                End If
                If abbruch=False Then
                    zeichen=Mid(kette,pos2,1)
                    mychar=Asc(zeichen)
                End If
                If (mychar=13) Or (mychar=10) Or (mychar=0) Then
                    abbruch=True
                End If
                If abbruch=False Then
                    tempstring=tempstring&zeichen
                    pos2=pos2+1
                End If
            Loop			
            vcardtelefon=Trim(tempstring)
            
        End If
    End If
    
    If readvcard=True Then
        If InStr(1,kette,"fon:",1)<>0 Then
            pos1=1
            pos1=InStr(1,kette,"fon:",1)+4
            pos2=pos1
            laenge=Len(kette)
            abbruch=False
            zeichen=""
            mychar=0
            tempstring=""
            Do While abbruch=False
                If pos2>=laenge Then
                    abbruch=True
                End If
                If abbruch=False Then
                    zeichen=Mid(kette,pos2,1)
                    mychar=Asc(zeichen)
                End If
                If (mychar=13) Or (mychar=10) Or (mychar=0) Then
                    abbruch=True
                End If
                If abbruch=False Then
                    tempstring=tempstring&zeichen
                    pos2=pos2+1
                End If
            Loop			
            vcardtelefon=Trim(tempstring)
            
        End If
    End If
    
    If readvcard=True Then
        If InStr(1,kette,"Telefon",1)<>0 Then
            pos1=1
            pos1=InStr(1,kette,"Telefon",1)+8
            pos2=pos1
            laenge=Len(kette)
            abbruch=False
            zeichen=""
            mychar=0
            tempstring=""
            Do While abbruch=False
                If pos2>=laenge Then
                    abbruch=True
                End If
                If abbruch=False Then
                    zeichen=Mid(kette,pos2,1)
                    mychar=Asc(zeichen)
                End If
                If (mychar=13) Or (mychar=10) Or (mychar=0) Then
                    abbruch=True
                End If
                If abbruch=False Then
                    tempstring=tempstring&zeichen
                    pos2=pos2+1
                End If
            Loop			
            vcardtelefon=Trim(tempstring)
            
        End If
    End If
    
    
    If readvcard=True Then
        If InStr(1,kette,"Tel.",1)<>0 Then
            pos1=1
            pos1=InStr(1,kette,"Tel.",1)+5
            pos2=pos1
            laenge=Len(kette)
            abbruch=False
            zeichen=""
            mychar=0
            tempstring=""
            Do While abbruch=False
                If pos2>=laenge Then
                    abbruch=True
                End If
                If abbruch=False Then
                    zeichen=Mid(kette,pos2,1)
                    mychar=Asc(zeichen)
                End If
                If (mychar=13) Or (mychar=10) Or (mychar=0) Then
                    abbruch=True
                End If
                If abbruch=False Then
                    tempstring=tempstring&zeichen
                    pos2=pos2+1
                End If
            Loop			
            vcardtelefon=Trim(tempstring)
            
        End If
    End If
    
    
    
    '####################################  auslesen Fax diverse Formatierungen  #########################################
    
    
    If readvcard=True Then
        If InStr(1,kette,"fax",1)<>0 Then
            pos1=1
            pos1=InStr(1,kette,"fax",1)+4
            pos2=pos1
            laenge=Len(kette)
            abbruch=False
            zeichen=""
            mychar=0
            tempstring=""
            Do While abbruch=False
                If pos2>=laenge Then
                    abbruch=True
                End If
                If abbruch=False Then
                    zeichen=Mid(kette,pos2,1)
                    mychar=Asc(zeichen)
                End If
                If (mychar=13) Or (mychar=10) Or (mychar=0) Then
                    abbruch=True
                End If
                If abbruch=False Then
                    tempstring=tempstring&zeichen
                    pos2=pos2+1
                End If
            Loop			
            
            vcardfax=Trim(tempstring)
            
        End If
    End If
    
    
    If readvcard=True Then
        If InStr(1,kette,"Telefax",1)<>0 Then
            pos1=1
            pos1=InStr(1,kette,"Telefax",1)+8
            pos2=pos1
            laenge=Len(kette)
            abbruch=False
            zeichen=""
            mychar=0
            tempstring=""
            Do While abbruch=False
                If pos2>=laenge Then
                    abbruch=True
                End If
                If abbruch=False Then
                    zeichen=Mid(kette,pos2,1)
                    mychar=Asc(zeichen)
                End If
                If (mychar=13) Or (mychar=10) Or (mychar=0) Then
                    abbruch=True
                End If
                If abbruch=False Then
                    tempstring=tempstring&zeichen
                    pos2=pos2+1
                End If
            Loop			
            
            vcardfax=Trim(tempstring)
            
        End If
    End If
    
    
    
    '####################################  auslesen Mobilfunk diverse Formatierungen  #########################################
    
    If readvcard=True Then
        If InStr(1,kette,"mobil",1)<>0 Then
            pos1=1
            pos1=InStr(1,kette,"mobil",1)+6
            pos2=pos1
            laenge=Len(kette)
            abbruch=False
            zeichen=""
            mychar=0
            tempstring=""
            Do While abbruch=False
                If pos2>=laenge Then
                    abbruch=True
                End If
                If abbruch=False Then
                    zeichen=Mid(kette,pos2,1)
                    mychar=Asc(zeichen)
                End If
                If (mychar=13) Or (mychar=10) Or (mychar=0) Then
                    abbruch=True
                End If
                If abbruch=False Then
                    tempstring=tempstring&zeichen
                    pos2=pos2+1
                End If
            Loop			
            vcardmobil=Trim(tempstring)
            
        End If
    End If
    
    
    If readvcard=True Then
        If InStr(1,kette,"mobilfunk",1)<>0 Then
            pos1=1
            pos1=InStr(1,kette,"mobilfunk",1)+10
            pos2=pos1
            laenge=Len(kette)
            abbruch=False
            zeichen=""
            mychar=0
            tempstring=""
            Do While abbruch=False
                If pos2>=laenge Then
                    abbruch=True
                End If
                If abbruch=False Then
                    zeichen=Mid(kette,pos2,1)
                    mychar=Asc(zeichen)
                End If
                If (mychar=13) Or (mychar=10) Or (mychar=0) Then
                    abbruch=True
                End If
                If abbruch=False Then
                    tempstring=tempstring&zeichen
                    pos2=pos2+1
                End If
            Loop			
            vcardmobil=Trim(tempstring)
            
        End If
    End If
    
    
    ReDim positions(10)
    ReDim length(10)
    
    For i=0 To 10
        positions(i)=0
        length(i)=0
    Next
    positions(1)=InStr(1,kette,vcardfirma,1)
    length(1)=Len(vcardfirma)
    If length(1)=0 Then
        positions(1)=0
    End If
    positions(2)=InStr(1,kette,vcardanschrift,1)
    length(2)=Len(vcardanschrift)
    If length(2)=0 Then
        positions(2)=0
    End If
    positions(3)=InStr(1,kette,vcardplz,1)
    length(3)=Len(vcardplz)
    If length(3)=0 Then
        positions(3)=0
    End If
    positions(4)=InStr(1,kette,vcardort,1)
    length(4)=Len(vcardort)
    If length(4)=0 Then
        positions(4)=0
    End If
    positions(5)=InStr(1,kette,vcardemail,1)
    length(5)=Len(vcardemail)
    If length(5)=0 Then
        positions(5)=0
    End If
    positions(6)=InStr(1,kette,vcardweb,1)
    length(6)=Len(vcardweb)
    If length(6)=0 Then
        positions(6)=0
    End If
    positions(7)=InStr(1,kette,vcardtelefon,1)
    length(7)=Len(vcardtelefon)
    If length(7)=0 Then
        positions(7)=0
    End If
    positions(8)=InStr(1,kette,vcardfax,1)
    length(8)=Len(vcardfax)
    If length(8)=0 Then
        positions(8)=0
    End If
    positions(9)=InStr(1,kette,vcardmobil,1)
    length(9)=Len(vcardmobil)
    If length(9)=0 Then
        positions(9)=0
    End If
    
    
    
    
    sortiert=False
    i=1
    zwischenwerta=0
    flag1=True
    Do While sortiert=False
        If positions(i)>positions(i+1) Then
            zwischenwerta=positions(i+1)
            positions(i+1)=positions(i)
            positions(i)=zwischenwerta
            zwischenwerta=length(i+1)
            length(i+1)=length(i)
            length(i)=zwischenwerta
            flag1=False
        End If
        i=i+1
        If i=9 Then
            If flag1=False Then
                i=1
                flag1=True
            Else
                sortiert=True
            End If
        End If
    Loop
    
    
    
    mystring=""
    maximum=0
    i=0
    gefunden=False
    Do While gefunden=False
        If positions(i)>0 Then
            gefunden=True
        Else
            i=i+1
        End If
        If i=10 Then
            gefunden=True
            readvcard=False
        End If
    Loop
    
    If readvcard=True Then
        mystring=Trim(Mid(kette,1,positions(i)))
        maximum=positions(i)
        
        
        
        For i=1 To 9
            
            If positions(i+1)>0 Then
                
                If positions(i+1)-(positions(i)+length(i))>maximum Then
                    mystring=Trim(Mid(kette,positions(i)+length(i),positions(i+1)-(positions(i)+length(i))))
                    maximum=positions(i+1)-(positions(i)+length(i))
                End If
            End If
        Next
    End If
    
    If InStr(1,mystring,"telefon",1)<>0 Then
        pos1=InStr(1,mystring,"telefon",1)
        If pos1>1 Then
            mystring=Trim(Left(mystring,pos1-1))
        End If
    End If
    
    If InStr(1,mystring,"telefax",1)<>0 Then
        pos1=InStr(1,mystring,"telefax",1)
        If pos1>1 Then
            mystring=Trim(Left(mystring,pos1-1))
        End If
    End If
    
    If InStr(1,mystring,"mobil",1)<>0 Then
        pos1=InStr(1,mystring,"mobil",1)
        If pos1>1 Then
            mystring=Trim(Left(mystring,pos1-1))
        End If
    End If
    
    If InStr(1,mystring,"fax",1)<>0 Then
        pos1=InStr(1,mystring,"fax",1)
        If pos1>1 Then
            mystring=Trim(Left(mystring,pos1-1))
        End If
    End If
    
    gefunden=False
    zeichen=""
    mychar=0
    Do While gefunden=False
        If Len(mystring)<2 Then
            gefunden=True
        End If
        If gefunden=False Then
            zeichen=Left(mystring,1)
            mychar=Asc(zeichen)
            If (mychar=13) Or (mychar=10) Then
                mystring=Right(mystring,Len(mystring)-1)
            Else
                gefunden=True
            End If
        End If
    Loop
    
    gefunden=False
    zeichen=""
    mychar=0
    Do While gefunden=False
        If Len(mystring)<2 Then
            gefunden=True
        End If
        If gefunden=False Then
            zeichen=Right(mystring,1)
            mychar=Asc(zeichen)
            If (mychar=13) Or (mychar=10) Then
                mystring=Left(mystring,Len(mystring)-1)
            Else
                gefunden=True
            End If
        End If
    Loop
    
    
    vcardname=mystring
    
    
    If readvcard=True Then
        
        If Len(vcardtelefon)>2 Then
            If Left(vcardtelefon,2)="49" Then
                vcardtelefon="+"&vcardtelefon
            End If
        End If
        If Len(vcardmobil)>2 Then
            If Left(vcardmobil,2)="49" Then
                vcardmobil="+"&vcardmobil
            End If
        End If
        If Len(vcardfax)>2 Then
            If Left(vcardfax,2)="49" Then
                vcardfax="+"&vcardfax
            End If
        End If
        
    End If
    
    
    
    
    '############################################################################################################################
    
    
    
    If fs.fileexists(tempname&".vcf") Then
        readvcard=False
    End If
    
    
    If readvcard=True Then
        Set myvcardfile = fs.OpenTextFile(tempname&".vcf",8,1)
        myvcardfile.writeline("BEGIN:VCARD")
        myvcardfile.writeline("VERSION:2.1")
        myvcardfile.writeline("FN:"&vcardname)
        myvcardfile.writeline("ORG:"&vcardfirma)
        myvcardfile.writeline("TEL;WORK;VOICE:"&vcardtelefon)
        myvcardfile.writeline("TEL;CELL;VOICE:"&vcardmobil)
        myvcardfile.writeline("TEL;WORK;FAX:"&vcardfax)
        myvcardfile.writeline("ADR;WORK;PREF:;;"&vcardanschrift&";"&vcardort&";;"&vcardplz&";"&vcardland)
        myvcardfile.writeline("URL;WORK:"&vcardweb)
        myvcardfile.writeline("EMAIL;PREF;INTERNET:"&vcardemail)
        myvcardfile.writeline("END:VCARD")
        myvcardfile.close
        Set myvcardfile=Nothing
        extension=".vcf"
        handle="VCard"
    End If
    
End Function


'************************************************************************
'************************************************************************
'************************************************************************
'************************************************************************
'************************************************************************
'************************************************************************
'************************************************************************
'************************************************************************

Private Function rotatetif(tifname)
    On Error Resume Next
    Err.clear
    mycommandfile=temp&"rotatecommand.txt"
    If fs.fileexists(mycommandfile) Then
        fs.deletefile mycommandfile, True
        If Err.number<>0 Then
            objWshShell.LogEvent 1, "archivierung(FE): Kann alte Anwesungsdatei nicht lschen."
            Err.clear
            On Error Resume Next
            WScript.Quit
        End If
    End If
    Set commandfile = fs.OpenTextFile(mycommandfile,8,True)
    commandfile.writeline "Rot="&docrotation
    commandfile.close
    Set commandfile=Nothing
    WScript.Sleep 50
    
    ' bei jpg in Verbindung mit usejpgtotif=False gibt es kein TIF!!! (Ticket 3167)
    If (extension <> ".jpg") Or (extension = ".jpg" And usejpgtotif = True) Then
        rotext = ".tif"
    Else
        rotext = ".jpg"
    End If	
    
    lngReturnCode = runfilter(tifname&rotext,mycommandfile,tifname&"-filter"&rotext)
    
    If lngReturnCode<>0 Then
        Err.clear
        On Error Resume Next
        errortxt="archivierung(FE): Fehler beim Filtern der Bilddatei:"&lngReturnCode	
        objWshShell.LogEvent 1, errortxt
        getgarbage(tempname)
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    
    fs.deletefile mycommandfile, True
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        errortxt="archivierung(FE): kann Command-Datei nicht lschen."	
        objWshShell.LogEvent 1, errortxt
        getgarbage(tempname)
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    WScript.Sleep 50
    If Not fs.fileexists(tifname&"-filter"&rotext) Then
        errortxt="archivierung(FE): Nach Filtern keine TIF-Datei erzeugt."	
        objWshShell.LogEvent 1, errortxt
        getgarbage(tempname)
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    
    Err.clear
    
    fs.deletefile tifname&rotext, True
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        errortxt="archivierung(FE): kann alte Bild-Datei nicht lschen."	
        objWshShell.LogEvent 1, errortxt
        getgarbage(tempname)
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    
    fs.copyfile tifname&"-filter"&rotext, tifname&rotext, True
    
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        errortxt="archivierung(FE): umkopieren nicht mglich."
        objWshShell.LogEvent 1, errortxt
        getgarbage(tempname)
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    WScript.Sleep 50
    If Not fs.fileexists(tifname&rotext) Then
        errortxt="archivierung(FE): Nach umkopieren keine Bild-Datei."	
        objWshShell.LogEvent 1, errortxt
        getgarbage(tempname)
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    fs.deletefile tifname&"-filter"&rotext, True
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        errortxt="archivierung(FE): Kann nach Filterung nicht aufrumen."	
        objWshShell.LogEvent 1, errortxt
        getgarbage(tempname)
        Unlock(programm&lockdatei)
        WScript.Quit
    End If	
    
End Function

'****************************************************************************************
'****************************************************************************************
'****************************************************************************************
'****************************************************************************************
'****************************************************************************************
'****************************************************************************************
'****************************************************************************************
'****************************************************************************************
'****************************************************************************************







Function runFilter(param1,param2,param3)
    On Error Resume Next
    'pa
    If scriptdebug=True Then
		objWSHShell.LogEvent 1, "archivierung.vbs: runfilter" & vbCrLf & "args: " & param1 & ", " & param2 & ", " & param3
	End If
    beginn = Timer
    If Not fs.Fileexists(param2) Then
        'Filterdatei nicht vorhanden
        objWshShell.LogEvent 1, "Archivierung.vbs: Filterdatei nicht vorhanden:" & param2
        runfilter = 4
        abbruch = True
        
    Else
        
        runfilter=0
        If scriptdebug=True Then
			objWSHShell.LogEvent 1, "archivierung.vbs: Filterrun " & Chr(34)&programm&"filterv3.bat"&Chr(34)&" "&Chr(34)&param1&Chr(34)&" "&Chr(34)&param2&Chr(34)&" "&Chr(34)&param3&Chr(34)
		End If
        Filterrun = objWSHShell.Run(Chr(34)&programm&"filterv3.bat"&Chr(34)&" "&Chr(34)&param1&Chr(34)&" "&Chr(34)&param2&Chr(34)&" "&Chr(34)&param3&Chr(34),0,True)
        
        
        Ende1 = Timer
        '******************************** auf Ergebnis warten ****************************
        WScript.Sleep 3000
        abbruch=False
 
        
    End If
    
    a=0
    Do While abbruch = False
        
        If checkfilter=0 Then
            
            abbruch=True
        End If
        
        
        If abbruch = False Then
            
            zaehler3=0
            zaehler2=0
            abbruch2=False
            WScript.Sleep 500
            Do While abbruch2=False
                
                
                mycheck=0
                mycheck=checkfilter
                
                If mycheck=3 Then
                    zaehler3=zaehler3+1
                End If
                
                If mycheck=2 Then
                    zaehler2=zaehler2+1
                    If zaehler3>0 Then
                        zaehler2=zaehler2+zaehler3
                        zaehler3=0
                    End If
                End If	
                
                If mycheck=1 Then
                    abbruch2=True
                End If
                
                If mycheck=0 Then
                    abbruch=True
                    abbruch2=True
                End If
                
                If zaehler3>10 Then
                    abbruch2=True
                    abbruch=True
                    a=ompwaittime
                    runfilter=3
                End If
                
                If zaehler2>35 Then
                    abbruch2=True
                    abbruch=True
                    a=ompwaittime
                    runfilter=2
                End If
                
                If abbruch2=False Then
                    WScript.sleep 1500
                End If
            Loop
            
            
        End If
        
        If abbruch=False Then	
            WScript.Sleep 1000
        End If
        a = a + 1
        If a>=ompwaittime Then
            abbruch=True
        End If
    Loop
    
    WScript.sleep 50
    
    If Not fs.fileexists(programm&lockdatei) Then
        objWshShell.LogEvent 2,"archivierung: Filter-Prozess von Dienstkontrolle terminiert."
        WScript.Quit
        
    End If
    
    abbruch=False
    waittime=0
    Do While abbruch=False
        Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
        strQuery = "Select * from Win32_Process where Name='FilterV3.exe'"
        Set colItems = objWMIService.ExecQuery(strQuery,,48)
        z=0
        For Each objItem In colItems
            
            z=z+1
        Next
        If z>0 Then
            waittime=waittime+1
            WScript.sleep 500
        Else
            abbruch=True
        End If
        
        If waittime>40 Then
            abbruch=True
        End If
        
    Loop
    
    If waittime>40 Then
        Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
        strQuery = "Select * from Win32_Process where Name='FilterV3.exe'"
        Set colItems = objWMIService.ExecQuery(strQuery,,48)
        z=0
        For Each objItem In colItems
            objItem.Terminate()
            z=z+1
        Next
        If z>0 Then
            objWshShell.LogEvent 2, "bitfarm-Archiv: Archivierung: Filter-Prozess terminiert bei "&tempname
            
        End If
        
        Set colItems = Nothing
        Set objWMIService = Nothing
    End If
    ende2 = Timer
    
End Function


'****************************************************************************************
'****************************************************************************************
'****************************************************************************************
'****************************************************************************************
'****************************************************************************************
'****************************************************************************************
'****************************************************************************************
'****************************************************************************************
'****************************************************************************************

Function gsview_serviceprinter(dateiname)
    
    
    '-----------------  Function for generating Postscript-Files out of PDF by spooling 
    '-----------------  them to Serviceprinter using GSView
    '-----------------  Used in PDFToTif and PDFtoCOlorTif for PDF files, that generate
    '-----------------  errors when trying to raster them via PDFtoTIF.exe
    
    gsview = fs.GetAbsolutePathName(gsview) 
    
    If scriptdebug = True Then
        objWshShell.LogEvent 0, "gsview_serviceprinter:" & Chr(34) & gsview & Chr(34) & " -sServiceprinter " &dateiname
    End If
    
    Set psprint = objWSHShell.exec (gsview & " -sServiceprinter " &dateiname)
    
    durch = False
    schleife = 0
    Do While schleife < 1000
        If psprint.Status = 1 Then 
            durch = True
            Exit Do
        End If
        
        WScript.Sleep 200  
        schleife = schleife +1
    Loop
    
    If durch = False Then
        objWshShell.LogEvent 1, "Archivierung.vbs: GSView_serviceprinter: GsView konnte nicht ausgefhrt werden" & vbCrLf & "Status: " & psprint.Status & vbTab & "Exitcode " & psprint.ExitCode & vbTab & "Schleife: " & schleife & vbCrLf &"GsView-Aufruf:" & gsview & " " & Chr(34) & "-s" & druckername & Chr(34) & " " &dateiname
        psprint.Terminate
        
        'sollte GhostView in einen Fehler gelaufen sein, kann es sein das ein gvwgs32/64 Prozess stehen bleibt
        
        
        Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
        strQuery = "Select * from Win32_Process where Name='gvwgs32.exe'"
        Set colItems = objWMIService.ExecQuery(strQuery,,48)
        z=0
        For Each objItem In colItems
            objItem.Terminate()
            z=z+1
        Next
        If z>0 Then
            objWshShell.LogEvent 2, "psprint.vbs: Terminierte gvwgs32.exe-Instanzen: "&z
        End If
        Set objItem = Nothing
        Set colItems = Nothing
        Set objWMIService = Nothing
        
        
        Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
        strQuery = "Select * from Win32_Process where Name='gvwgs64.exe'"
        Set colItems = objWMIService.ExecQuery(strQuery,,48)
        z=0
        For Each objItem In colItems
            objItem.Terminate()
            z=z+1
        Next
        If z>0 Then
            objWshShell.LogEvent 2, "psprint.vbs: Terminierte gvwgs64.exe-Instanzen: "&z
        End If
        Set objItem = Nothing
        Set colItems = Nothing
        Set objWMIService = Nothing
        
        
    End If
    
    
    
End Function



Function bfa_pdf2tif_serviceprinter(dateiname)
	cmd = Chr(34)&programm&"bfa_pdf2tif.exe" & Chr(34) & " -i " & Chr(34) & dateiname & Chr(34) & " --printer Serviceprinter"
                        
    If scriptdebug = True Then
        objWSHShell.LogEvent 4, "archivierung.vbs: bfa_pdf2tif Aufruf (fr bfa_pdf2tif_serviceprinter):"&vbCrLf&cmd
    End If 
    
    Set oexec = objWSHShell.Exec(cmd)
    durch = False
    schleife = 0
    Do While schleife < 1000
        If oexec.Status = 1 Then 
            durch = True
            Exit Do
        End If
        
        WScript.Sleep 200  
        schleife = schleife +1
    Loop
    
    If durch = False Then
		objWshShell.LogEvent 1, "archivierung.vbs bfa_pdf2tif konnte nicht ausgefhrt werden" & vbCrLf & "Status: " & oexec.Status & vbTab & "Exitcode " & oexec.ExitCode & vbTab & "Schleife: " & schleife
		oexec.Terminate()
	End If
	
End Function


'****************************************************************************************
'****************************************************************************************
'****************************************************************************************
'****************************************************************************************
'****************************************************************************************
'****************************************************************************************
'****************************************************************************************
'****************************************************************************************
'****************************************************************************************


Function dbimp(Datei)

    On Error Resume Next
    
    If scriptdebug=True Then
        objWshShell.LogEvent 4, "Archivierung.vbs Function dbimp_neu: Datei " & Datei
    End If
    dokid = 0
    wfid=0
    Do While dokid = 0 And wfid = 0 
        strinput = ""
        schleife = 0
        
        Beginn = Timer
        Set oExec    = objWSHShell.Exec(Chr(34)&programm&"DBImpV3.exe"&Chr(34)&" "&Chr(34)&Datei&".job"&Chr(34))
        
        Do While Not oExec.StdOut.AtEndOfStream
            strinput = strinput & oExec.StdOut.Read(1)	
        Loop
        
        Do While Not oExec.StdErr.AtEndOfStream
            strinput = strinput & oExec.StdErr.Read(1)	
        Loop
        
        durch = False
        schleife = 0
        Do While schleife < 50
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 100  
            schleife = schleife +1
        Loop
        Ende = Timer
        
        If durch = False Then
            objWshShell.LogEvent 1, "Archivierung.vbs Function dbimp: Schwerwiegender Fehler" & vbCrLf & "dbimpV3.exe antwortet nicht oder wird nicht beendet" & vbCrLf & "Status: " & oExec.Status & vbCrLf & "Exitcode " & oExec.ExitCode & vbCrLf & "Schleife: " & schleife
            returnvalue=100
            oExec.Terminate
            Exit Do
        Else
            returnvalue = oExec.ExitCode
        End If
        If scriptdebug=True Then
            objWshShell.LogEvent 0, "Archivierung.vbs Function dbimp: dbimpV3.exe ausgefhrt" & vbCrLf & "Status: " & oExec.Status & vbCrLf & "Exitcode " & oExec.ExitCode & vbCrLf & "Schleife: " & schleife &vbCrLf& strinput
            
        End If
        
        
        If (InStr(1,strinput,"DokID:") <> 0) Or (InStr(1,strinput,"DocID:") <> 0) Then
            If InStr(1,strinput,"DokID:") <> 0 Then
                strdokid = Right(strinput,Len(strinput)-InStr(1,strinput,"DokID:")-5)
            Else
                strdokid = Right(strinput,Len(strinput)-InStr(1,strinput,"DocID:")-5)
            End If
            
            strdokid = Left(strdokid,InStr(1,strdokid,Chr(13))-1)
            DokID = strdokid	
        End If
        
        If InStr(1,strinput,"WfID:") <> 0 Then
            strwfid = Right(strinput,Len(strinput)-InStr(1,strinput,"WfID:")-4)
            strwfid = Left(strwfid,InStr(1,strwfid,Chr(13))-1)
            wfID = strwfid
        End If
        
        If Not IsNumeric(strdokid) Then
            returnvalue = 101
        End If
        
        If returnvalue <>0 Then Exit Do
        
    Loop	
    
    
    If InStr(1,LCase(strinput),"erfolgreich" )<> 0 Then
        exec_dbimp = "DbImpV3 erfolgreich in " & Ende - Beginn
    Else
        If InStr(1,LCase(strinput),"fehler" )<> 0 Then
            exec_dbimp = "DbImpV3 Fehler in " & Ende - Beginn
            objWshShell.LogEvent 0, "Archivierung.vbs Function dbimp: dbimpV3.exe meldet einen Fehler:" & vbCrLf & strinput
            
        Else
            exec_dbimp = " DbImpV3 unbekannte Rckmeldung " & Ende - Beginn
        End If
    End If
    
    If logging = True Then
        If Not (fs.fileexists(programm & "archivierung_dbimp.log")) Then
            Set outfile = fs.CreateTextFile(programm & "archivierung_dbimp.log")
            outfile.close
        End If
        Set outfile = fs.OpenTextFile(programm & "archivierung_dbimp.log",8)	
        outfile.Writeline "Archivierung.vbs --- " & Now()
        outfile.Writeline strinput 
        outfile.Writeline exec_dbimp
        outfile.WriteLine "Durchlauf:" & Schleife
        outfile.WriteLine "Datei:" & datei
        outfile.WriteLine 
        If fs.fileexists(Datei&".job") Then
            outfile.WriteLine "Inhalt der Jobdatei:"
            outfile.WriteLine "---------------------------------------------------"
            Set myjobfile = fs.OpenTextFile(Datei&".job",1)
            Do While myjobfile.atendofstream=False
                kette=myjobfile.readline
                outfile.writeline(kette)
            Loop
            myjobfile.close
            Set myjobfile=Nothing
            outfile.WriteLine "---------------------------------------------------"
            outfile.WriteLine 
        End If
        outfile.close		
        
        objWshShell.LogEvent 0, "bitfarm-Archiv Logging: Function dbimp: retval " & returnvalue & vbCrLf & strinput
        Set outfile = Nothing
        
    Else
        
        If returnvalue <> 0 Then
            objWshShell.LogEvent 1, "Archivierung.vbs Function dbimp: retval " & returnvalue & vbCrLf & strinput
        End If
    End If
    
    
    Set oExec = Nothing
    dbimp=returnvalue
    If (checkocr=True) Or (notifyuser=True) Then
        createwvl=True
    End If
End Function






'****************************************************************************************
'****************************************************************************************
'****************************************************************************************
'****************************************************************************************




'********************************************************************************
'********************************************************************************
'********************************************************************************
'********************************************************************************

Function checkdbimpprocess
    On Error Resume Next
    
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='dbimpv3.exe'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    
    For Each objItem In colItems
        objItem.Terminate()
        objWshShell.LogEvent 2, "bitfarm-Archiv: archivierung: dbimp-Instanz wurde terminiert (checkdbimpprocess)"
    Next
    Set colItems = Nothing
    Set objWMIService = Nothing
    
    setdbimpvar(0)
    
    
End Function


'********************************************************************************
'********************************************************************************
'********************************************************************************
'********************************************************************************


Function getdbimpvar
    On Error Resume Next
    getdbimpvar=0
    
    Set WshEnv = objWSHShell.Environment("System")
    
    getdbimpvar = WshEnv("dbimp")
    
    
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
    End If
    
    Set WshEnv=Nothing
    
End Function

Function setdbimpvar(myzahl)
    On Error Resume Next
    Set WshEnv = objWSHShell.Environment("System")
    WshEnv("dbimp") = myzahl
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
    End If
    Set WshEnv=Nothing
End Function


'********************************************************************************
'********************************************************************************
'********************************************************************************
'********************************************************************************




Function checkomnipage
    On Error Resume Next
    
    checkomnipage=0
    If scriptdebug=True Then
        Set mydebugfile = fs.OpenTextFile(tempname&".log",8,True)
    End If	
    
    
    'WScript.Sleep 50
    Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    WScript.Sleep 50
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'omnipage'")
    'WScript.Sleep 50
    
    oldtestcounter1=0
    oldtestcounter2=0
    oldtestcounter3=0
    oldtestcounter4=0
    oldtestcounter5=0
    oldtestcounter6=0
    oldtestcounter7=0
    newtestcounter1=0
    newtestcounter2=0
    newtestcounter3=0
    newtestcounter4=0
    newtestcounter5=0
    newtestcounter6=0
    newtestcounter7=0
    
    kette=""
    
    For Each strProcess In colProcesses
        oldtestcounter1=strProcess.IOReadBytesPerSec
        oldtestcounter2=strProcess.IOReadOperationsPerSec
        oldtestcounter3=strProcess.IOWriteBytesPerSec
        oldtestcounter4=strProcess.IOWriteOperationsPerSec
        oldtestcounter5=strProcess.IOOtherBytesPerSec
        oldtestcounter6=strProcess.IOOtherOperationsPerSec
        oldtestcounter7=strProcess.PercentProcessorTime
        
    Next
    WScript.Sleep 2000
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'omnipage'")
    
    kette=""
    mycounter1=0
    For Each strProcess In colProcesses
        newtestcounter1=strProcess.IOReadBytesPerSec
        newtestcounter2=strProcess.IOReadOperationsPerSec
        newtestcounter3=strProcess.IOWriteBytesPerSec
        newtestcounter4=strProcess.IOWriteOperationsPerSec
        newtestcounter5=strProcess.IOOtherBytesPerSec
        newtestcounter6=strProcess.IOOtherOperationsPerSec
        newtestcounter7=strProcess.PercentProcessorTime
        mycounter1=mycounter1+1
    Next
    Set colProcess=Nothing
    Set objWMIService=Nothing
    
    
    
    test1diff=0
    test2diff=0
    test3diff=0
    test4diff=0
    test5diff=0
    test6diff=0
    test7diff=0
    
    test1diff=strconvert(Trim(newtestcounter1))-strconvert(Trim(oldtestcounter1))
    test2diff=strconvert(Trim(newtestcounter2))-strconvert(Trim(oldtestcounter2))
    test3diff=strconvert(Trim(newtestcounter3))-strconvert(Trim(oldtestcounter3))
    test4diff=strconvert(Trim(newtestcounter4))-strconvert(Trim(oldtestcounter4))
    test5diff=strconvert(Trim(newtestcounter5))-strconvert(Trim(oldtestcounter5))
    test6diff=strconvert(Trim(newtestcounter6))-strconvert(Trim(oldtestcounter6))
    test7diff=strconvert(Trim(newtestcounter7))-strconvert(Trim(oldtestcounter7))
    
    If scriptdebug=True Then
        mydebugfile.writeline(test1diff&"	:"&test2diff&"	:"&test3diff&"	:"&test4diff&"	:"&test5diff&"	:"&test6diff&"	:"&test7diff)
        
    End If
    
    If test7diff>0 Then
        checkomnipage=2
    End If
    
    zaehler1=0
    If test1diff>0 Then
        zaehler1=zaehler1+1
    End If
    If test2diff>0 Then
        zaehler1=zaehler1+1
    End If
    If test3diff>0 Then
        zaehler1=zaehler1+1
    End If
    If test4diff>0 Then
        zaehler1=zaehler1+1
    End If
    If test5diff>0 Then
        zaehler1=zaehler1+1
    End If
    If test6diff>0 Then
        zaehler1=zaehler1+1
    End If
    If test7diff>0 Then
        zaehler1=zaehler1+1
    End If
    
    If zaehler1>2 Then
        checkomnipage=1
    End If
    
    If zaehler1=0 Then
        checkomnipage=3
    End If
    
    If (test1diff=0) And (test2diff=0) And (test3diff>0) And (test3diff<60) And (test4diff>0) And (test4diff<20) And (test5diff=0) And (test6diff=0) Then
        checkomnipage=3
    End If 
    
    If checkomnipage=2 Then
        If (test1diff=0) And (test2diff=0) And (test3diff=0) And (test4diff=0) And (test5diff=0) And (test6diff=0) Then
            checkomnipage=3
        End If 
    End If
    
    If (test1diff=0) And (test2diff=0) And (test3diff=0) And (test4diff=0) And (test5diff=0) And (test6diff=0) And (test7diff=0) Then
        checkomnipage=0
    End If 
    
    
    If scriptdebug=True Then
        mydebugfile.writeline(checkomnipage)
        mydebugfile.close
        Set mydebugfile=Nothing
    End If
    
End Function




Function checkghostscript
    On Error Resume Next
    
    checkghostscript=False
    'WScript.Sleep 50
    Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    WScript.Sleep 50
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'gswin32c'")
    'WScript.Sleep 50
    oldcounter=0
    newcounter=0
    old1counter=0
    new1counter=0
    kette=""
    For Each strProcess In colProcesses
        'kette=strProcess.IOReadBytesPerSec&vbcrlf
        oldcounter=strProcess.IOReadOperationsPerSec
        'kette=kette&strProcess.IOWriteBytesPerSec&vbcrlf
        old1counter=strProcess.IOWriteOperationsPerSec
        'kette=kette&IOOtherBytesPerSec&vbcrlf
        'kette=kette&strProcess.IOOtherOperationsPerSec&vbcrlf
        'kette=kette&"Prozessorzeit"&strProcess.PercentProcessorTime
    Next
    'Set colProcess=nothing
    'Set objWMIService=nothing
    WScript.Sleep 2000
    'Set objWMIService = GetObject("winmgmts:" _
    ' & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    'WScript.Sleep 50
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'gswin32c'")
    'WScript.Sleep 50
    
    kette=""
    For Each strProcess In colProcesses
        'kette=strProcess.IOReadBytesPerSec&vbcrlf
        newcounter=strProcess.IOReadOperationsPerSec
        'kette=kette&strProcess.IOWriteBytesPerSec&vbcrlf
        new1counter=strProcess.IOWriteOperationsPerSec
        'kette=kette&IOOtherBytesPerSec&vbcrlf
        'kette=kette&strProcess.IOOtherOperationsPerSec&vbcrlf
        'kette=kette&"Prozessorzeit"&strProcess.PercentProcessorTime
    Next
    Set colProcess=Nothing
    Set objWMIService=Nothing
    
    
    If (oldcounter <> newcounter) Then
        'checkomnipage=false
        checkghostscript=True
    End If
    
    If (old1counter <> new1counter) Then
        'checkomnipage=false
        checkghostscript=True
    End If
    
    
    
End Function


Function testfilter
    On Error Resume Next
    
    testfilter=False
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='FilterV3'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    z=0
    For Each objItem In colItems
        
        z=z+1
    Next
    If z>0 Then
        testfilter=True
    End If
    
    Set colItems = Nothing
    Set objWMIService = Nothing
End Function


Function checkfilter
    On Error Resume Next
    
    
    checkfilter=0
    If scriptdebug=True Then
        Set mydebugfile = fs.OpenTextFile(tempname&".log",8,True)
    End If	
    
    
    'WScript.Sleep 50
    Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    WScript.Sleep 50
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'FilterV3'")
    'WScript.Sleep 50
    
    oldtestcounter1=0
    oldtestcounter2=0
    oldtestcounter3=0
    oldtestcounter4=0
    oldtestcounter5=0
    oldtestcounter6=0
    oldtestcounter7=0
    newtestcounter1=0
    newtestcounter2=0
    newtestcounter3=0
    newtestcounter4=0
    newtestcounter5=0
    newtestcounter6=0
    newtestcounter7=0
    
    kette=""
    
    For Each strProcess In colProcesses
        oldtestcounter1=strProcess.IOReadBytesPerSec
        oldtestcounter2=strProcess.IOReadOperationsPerSec
        oldtestcounter3=strProcess.IOWriteBytesPerSec
        oldtestcounter4=strProcess.IOWriteOperationsPerSec
        oldtestcounter5=strProcess.IOOtherBytesPerSec
        oldtestcounter6=strProcess.IOOtherOperationsPerSec
        oldtestcounter7=strProcess.PercentProcessorTime
        
    Next
    'Set colProcess=nothing
    'Set objWMIService=nothing
    WScript.Sleep 2000
    'Set objWMIService = GetObject("winmgmts:" _
    ' & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    'WScript.Sleep 50
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'FilterV3'")
    WScript.Sleep 50
    
    kette=""
    mycounter1=0
    For Each strProcess In colProcesses
        newtestcounter1=strProcess.IOReadBytesPerSec
        newtestcounter2=strProcess.IOReadOperationsPerSec
        newtestcounter3=strProcess.IOWriteBytesPerSec
        newtestcounter4=strProcess.IOWriteOperationsPerSec
        newtestcounter5=strProcess.IOOtherBytesPerSec
        newtestcounter6=strProcess.IOOtherOperationsPerSec
        newtestcounter7=strProcess.PercentProcessorTime
        mycounter1=mycounter1+1
    Next
    Set colProcess=Nothing
    Set objWMIService=Nothing
    
    
    
    test1diff=0
    test2diff=0
    test3diff=0
    test4diff=0
    test5diff=0
    test6diff=0
    test7diff=0
    
    test1diff=strconvert(Trim(newtestcounter1))-strconvert(Trim(oldtestcounter1))
    test2diff=strconvert(Trim(newtestcounter2))-strconvert(Trim(oldtestcounter2))
    test3diff=strconvert(Trim(newtestcounter3))-strconvert(Trim(oldtestcounter3))
    test4diff=strconvert(Trim(newtestcounter4))-strconvert(Trim(oldtestcounter4))
    test5diff=strconvert(Trim(newtestcounter5))-strconvert(Trim(oldtestcounter5))
    test6diff=strconvert(Trim(newtestcounter6))-strconvert(Trim(oldtestcounter6))
    test7diff=strconvert(Trim(newtestcounter7))-strconvert(Trim(oldtestcounter7))
    
    If scriptdebug=True Then
        mydebugfile.writeline("Checkfilter: "&test1diff&"	:"&test2diff&"	:"&test3diff&"	:"&test4diff&"	:"&test5diff&"	:"&test6diff&"	:"&test7diff)
        
    End If
    
    If test7diff>0 Then
        checkfilter=2
    End If
    
    zaehler1=0
    If test1diff>0 Then
        zaehler1=zaehler1+1
    End If
    If test2diff>0 Then
        zaehler1=zaehler1+1
    End If
    If test3diff>0 Then
        zaehler1=zaehler1+1
    End If
    If test4diff>0 Then
        zaehler1=zaehler1+1
    End If
    If test5diff>0 Then
        zaehler1=zaehler1+1
    End If
    If test6diff>0 Then
        zaehler1=zaehler1+1
    End If
    If test7diff>0 Then
        zaehler1=zaehler1+1
    End If
    
    If zaehler1>2 Then
        checkfilter=1
    End If
    
    If zaehler1=0 Then
        checkfilter=3
    End If
    
    
    If (test1diff>0) And (test2diff>0) And (test3diff=0) And (test4diff=0) And (test5diff>0) And (test6diff=0) And (test7diff>0) Then
        checkfilter=3
    End If 
    
    If checkfilter=2 Then
        If (test1diff=0) And (test2diff=0) And (test3diff=0) And (test4diff=0) And (test5diff=0) And (test6diff=0) Then
            checkfilter=3
        End If 
    End If
    
    If (test1diff=0) And (test2diff=0) And (test3diff=0) And (test4diff=0) And (test5diff=0) And (test6diff=0) And (test7diff=0) Then
        checkfilter=0
    End If 
    
    
    If scriptdebug=True Then
        mydebugfile.writeline("Checkfilter: "&checkfilter)
        mydebugfile.close
        Set mydebugfile=Nothing
    End If
    
    
End Function


Function checkPDFtoPS
    On Error Resume Next
    
    checkPDFtoPS=False
    'WScript.Sleep 50
    Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    WScript.Sleep 50
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'pdftops'")
    'WScript.Sleep 50
    oldcounter=0
    newcounter=0
    old1counter=0
    new1counter=0
    kette=""
    For Each strProcess In colProcesses
        'kette=strProcess.IOReadBytesPerSec&vbcrlf
        oldcounter=strProcess.IOReadOperationsPerSec
        'kette=kette&strProcess.IOWriteBytesPerSec&vbcrlf
        old1counter=strProcess.IOWriteOperationsPerSec
        'kette=kette&IOOtherBytesPerSec&vbcrlf
        'kette=kette&strProcess.IOOtherOperationsPerSec&vbcrlf
        'kette=kette&"Prozessorzeit"&strProcess.PercentProcessorTime
    Next
    'Set colProcess=nothing
    'Set objWMIService=nothing
    WScript.Sleep 2000
    'Set objWMIService = GetObject("winmgmts:" _
    ' & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    'WScript.Sleep 50
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'pdftops'")
    'WScript.Sleep 50
    
    kette=""
    For Each strProcess In colProcesses
        'kette=strProcess.IOReadBytesPerSec&vbcrlf
        newcounter=strProcess.IOReadOperationsPerSec
        'kette=kette&strProcess.IOWriteBytesPerSec&vbcrlf
        new1counter=strProcess.IOWriteOperationsPerSec
        'kette=kette&IOOtherBytesPerSec&vbcrlf
        'kette=kette&strProcess.IOOtherOperationsPerSec&vbcrlf
        'kette=kette&"Prozessorzeit"&strProcess.PercentProcessorTime
    Next
    Set colProcess=Nothing
    Set objWMIService=Nothing
    
    
    If (oldcounter <> newcounter) Then
        checkPDFtoPS=True
    End If
    
    If (old1counter <> new1counter) Then
        checkPDFtoPS=True
    End If
    
End Function


Function checkWord
    On Error Resume Next
    
    checkWord=False
    WScript.Sleep 50
    Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    WScript.Sleep 50
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'winword'")
    WScript.Sleep 50
    oldcounter=0
    newcounter=0
    old1counter=0
    new1counter=0
    kette=""
    For Each strProcess In colProcesses
        kette=strProcess.IOReadBytesPerSec&vbCrLf
        oldcounter=strProcess.IOReadOperationsPerSec
        kette=kette&strProcess.IOWriteBytesPerSec&vbCrLf
        old1counter=strProcess.IOWriteOperationsPerSec
        kette=kette&IOOtherBytesPerSec&vbCrLf
        kette=kette&strProcess.IOOtherOperationsPerSec&vbCrLf
        kette=kette&"Prozessorzeit"&strProcess.PercentProcessorTime
    Next
    Set colProcess=Nothing
    Set objWMIService=Nothing
    WScript.Sleep 2000
    Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    WScript.Sleep 50
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'winword'")
    WScript.Sleep 50
    
    kette=""
    For Each strProcess In colProcesses
        kette=strProcess.IOReadBytesPerSec&vbCrLf
        newcounter=strProcess.IOReadOperationsPerSec
        kette=kette&strProcess.IOWriteBytesPerSec&vbCrLf
        new1counter=strProcess.IOWriteOperationsPerSec
        kette=kette&IOOtherBytesPerSec&vbCrLf
        kette=kette&strProcess.IOOtherOperationsPerSec&vbCrLf
        kette=kette&"Prozessorzeit"&strProcess.PercentProcessorTime
    Next
    Set colProcess=Nothing
    Set objWMIService=Nothing
    
    
    If (oldcounter <> newcounter) Then
        
        checkWord=True
    End If
    
    If (old1counter <> new1counter) Then
        
        checkWord=True
    End If
    
    
End Function


Function checkExcel
    On Error Resume Next
    
    checkExcel=False
    WScript.Sleep 50
    Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    WScript.Sleep 50
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'excel'")
    WScript.Sleep 50
    oldcounter=0
    newcounter=0
    old1counter=0
    new1counter=0
    kette=""
    For Each strProcess In colProcesses
        kette=strProcess.IOReadBytesPerSec&vbCrLf
        oldcounter=strProcess.IOReadOperationsPerSec
        kette=kette&strProcess.IOWriteBytesPerSec&vbCrLf
        old1counter=strProcess.IOWriteOperationsPerSec
        kette=kette&IOOtherBytesPerSec&vbCrLf
        kette=kette&strProcess.IOOtherOperationsPerSec&vbCrLf
        kette=kette&"Prozessorzeit"&strProcess.PercentProcessorTime
    Next
    Set colProcess=Nothing
    Set objWMIService=Nothing
    WScript.Sleep 2000
    Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    WScript.Sleep 50
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'excel'")
    WScript.Sleep 50
    
    kette=""
    For Each strProcess In colProcesses
        kette=strProcess.IOReadBytesPerSec&vbCrLf
        newcounter=strProcess.IOReadOperationsPerSec
        kette=kette&strProcess.IOWriteBytesPerSec&vbCrLf
        new1counter=strProcess.IOWriteOperationsPerSec
        kette=kette&IOOtherBytesPerSec&vbCrLf
        kette=kette&strProcess.IOOtherOperationsPerSec&vbCrLf
        kette=kette&"Prozessorzeit"&strProcess.PercentProcessorTime
    Next
    Set colProcess=Nothing
    Set objWMIService=Nothing
    
    
    If (oldcounter <> newcounter) Then
        
        checkExcel=True
    End If
    
    If (old1counter <> new1counter) Then
        
        checkExcel=True
    End If
    
    
    
End Function


Function checkPowerPoint
    On Error Resume Next
    
    checkPowerPoint=False
    WScript.Sleep 50
    Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    WScript.Sleep 50
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'powerpoint'")
    WScript.Sleep 50
    oldcounter=0
    newcounter=0
    old1counter=0
    new1counter=0
    kette=""
    For Each strProcess In colProcesses
        kette=strProcess.IOReadBytesPerSec&vbCrLf
        oldcounter=strProcess.IOReadOperationsPerSec
        kette=kette&strProcess.IOWriteBytesPerSec&vbCrLf
        old1counter=strProcess.IOWriteOperationsPerSec
        kette=kette&IOOtherBytesPerSec&vbCrLf
        kette=kette&strProcess.IOOtherOperationsPerSec&vbCrLf
        kette=kette&"Prozessorzeit"&strProcess.PercentProcessorTime
    Next
    Set colProcess=Nothing
    Set objWMIService=Nothing
    WScript.Sleep 2000
    Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    WScript.Sleep 50
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'powerpoint'")
    WScript.Sleep 50
    
    kette=""
    For Each strProcess In colProcesses
        kette=strProcess.IOReadBytesPerSec&vbCrLf
        newcounter=strProcess.IOReadOperationsPerSec
        kette=kette&strProcess.IOWriteBytesPerSec&vbCrLf
        new1counter=strProcess.IOWriteOperationsPerSec
        kette=kette&IOOtherBytesPerSec&vbCrLf
        kette=kette&strProcess.IOOtherOperationsPerSec&vbCrLf
        kette=kette&"Prozessorzeit"&strProcess.PercentProcessorTime
    Next
    Set colProcess=Nothing
    Set objWMIService=Nothing
    
    
    If (oldcounter <> newcounter) Then
        
        checkPowerPoint=True
    End If
    
    If (old1counter <> new1counter) Then
        
        checkPowerPoint=True
    End If
    
    
    
End Function


Function checkAutoScan
    On Error Resume Next
    
    checkAutoScan=False
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='AutoScanV3.exe'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    z=0
    For Each objItem In colItems
        
        z=z+1
    Next
    If z>0 Then
        checkAutoScan=True
    End If
    
    Set colItems = Nothing
    Set objWMIService = Nothing
End Function


Function checkJobRunner
    On Error Resume Next
    
    checkJobRunner=False
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='JobRunner.exe'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    z=0
    For Each objItem In colItems
        
        z=z+1
    Next
    If z>0 Then
        checkJobRunner=True
    End If
    
    Set colItems = Nothing
    Set objWMIService = Nothing
End Function



'***************************************************************************************
'***************************************************************************************
'***************************************************************************************

Function waitbarcode()
    On Error Resume Next
    
    abbruch1=False
    Do While abbruch1=False
        Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
        'strQuery = "Select * from Win32_Process where Name='barcode.exe'"
        strQuery = "Select * from Win32_Process where Name='rdtifbar.exe'"
        Set colItems = objWMIService.ExecQuery(strQuery,,48)
        z=0
        For Each objItem In colItems
            
            z=z+1
            
        Next
        If z=0 Then
            abbruch1=True
        End If
        
        Set colItems = Nothing
        Set objWMIService = Nothing
        If abbruch1=False Then
            If checkbarcode()=0 Then
                
                
                
                Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
                'strQuery = "Select * from Win32_Process where Name='barcode.exe'"
                strQuery = "Select * from Win32_Process where Name='rdtifbar.exe'"
                Set colItems = objWMIService.ExecQuery(strQuery,,48)
                z=0
                For Each objItem In colItems
                    
                    z=z+1
                    objItem.Terminate()
                    
                Next
                
                Set colItems = Nothing
                Set objWMIService = Nothing
                abbruch1=True
            End If
            WScript.sleep 200
        End If
    Loop
    
End Function





Function checkbarcode
    On Error Resume Next
    checkbarcode=0
    
    If scriptdebug=True Then
        
        Set mydebugfile = fs.OpenTextFile(tempname&".log",8,True)
        'Set mydebugfile = fs.OpenTextFile(datei&".bclog",8,true)
    End If	
    
    WScript.Sleep 50
    Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    WScript.Sleep 50
    'Set colProcesses = objWMIService.ExecQuery _
    ' ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'barcode'")
    
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'rdtifbar'") 
    
    WScript.Sleep 50
    
    oldtestcounter1=0
    oldtestcounter2=0
    oldtestcounter3=0
    oldtestcounter4=0
    oldtestcounter5=0
    oldtestcounter6=0
    oldtestcounter7=0
    newtestcounter1=0
    newtestcounter2=0
    newtestcounter3=0
    newtestcounter4=0
    newtestcounter5=0
    newtestcounter6=0
    newtestcounter7=0
    
    kette=""
    
    For Each strProcess In colProcesses
        oldtestcounter1=strProcess.IOReadBytesPerSec
        oldtestcounter2=strProcess.IOReadOperationsPerSec
        oldtestcounter3=strProcess.IOWriteBytesPerSec
        oldtestcounter4=strProcess.IOWriteOperationsPerSec
        oldtestcounter5=strProcess.IOOtherBytesPerSec
        oldtestcounter6=strProcess.IOOtherOperationsPerSec
        oldtestcounter7=strProcess.PercentProcessorTime
        
    Next
    Set colProcess=Nothing
    Set objWMIService=Nothing
    WScript.Sleep 2000
    Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    WScript.Sleep 50
    'Set colProcesses = objWMIService.ExecQuery _
    ' ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'barcode'")
    
    
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'rdtifbar'") 
    
    WScript.Sleep 50
    
    kette=""
    mycounter1=0
    For Each strProcess In colProcesses
        newtestcounter1=strProcess.IOReadBytesPerSec
        newtestcounter2=strProcess.IOReadOperationsPerSec
        newtestcounter3=strProcess.IOWriteBytesPerSec
        newtestcounter4=strProcess.IOWriteOperationsPerSec
        newtestcounter5=strProcess.IOOtherBytesPerSec
        newtestcounter6=strProcess.IOOtherOperationsPerSec
        newtestcounter7=strProcess.PercentProcessorTime
        mycounter1=mycounter1+1
    Next
    Set colProcess=Nothing
    Set objWMIService=Nothing
    
    
    
    test1diff=0
    test2diff=0
    test3diff=0
    test4diff=0
    test5diff=0
    test6diff=0
    test7diff=0
    
    test1diff=strconvert(Trim(newtestcounter1))-strconvert(Trim(oldtestcounter1))
    test2diff=strconvert(Trim(newtestcounter2))-strconvert(Trim(oldtestcounter2))
    test3diff=strconvert(Trim(newtestcounter3))-strconvert(Trim(oldtestcounter3))
    test4diff=strconvert(Trim(newtestcounter4))-strconvert(Trim(oldtestcounter4))
    test5diff=strconvert(Trim(newtestcounter5))-strconvert(Trim(oldtestcounter5))
    test6diff=strconvert(Trim(newtestcounter6))-strconvert(Trim(oldtestcounter6))
    test7diff=strconvert(Trim(newtestcounter7))-strconvert(Trim(oldtestcounter7))
    
    If scriptdebug=True Then
        mydebugfile.writeline("rdtifbar: "&test1diff&"	:"&test2diff&"	:"&test3diff&"	:"&test4diff&"	:"&test5diff&"	:"&test6diff&"	:"&test7diff)
        
    End If
    
    If test7diff>0 Then
        checkbarcode=2
    End If
    
    If scriptdebug=True Then
        mydebugfile.writeline(checkbarcode)
        mydebugfile.close
        Set mydebugfile=Nothing
    End If
    
    
End Function





'################################################################################
'################################################################################
'################################################################################




'************************************************************************

Private Function cleanOMP15
    On Error Resume Next
    
    Hive="HKEY_CURRENT_USER\Software\ScanSoft\OmniPage15.0\OPD Document\"
    errorflag = False
    
    abbruch = False
    Err.clear
    x=1
    Do While abbruch = False
        testkey=hive&"Doc"&x
        Err.clear
        On Error Resume Next
        objWSHShell.RegDelete(testkey)
        If Err.number Then 
            
            Err.clear
            
            abbruch=True
        End If
        
        x=x+1
        
        
    Loop
    
    
    Err.clear
    temppath = objWSHShell.ExpandEnvironmentStrings("%temp%")    
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        temppath=objWSHShell.ExpandEnvironmentStrings("%systemroot%")&"\temp"
    End If 
    
    OMPTemp=temppath&"\ScanSoft\OmniPage15.0"
    
    If fs.folderexists(OMPTemp) Then
        delfolder(OMPTemp)
    End If
    
    
End Function



Function delfolder(folder)
    On Error Resume Next
    
    Set ordner=fs.getfolder(folder)
    If Not IsEmpty(ordner) Then
	    For Each file In ordner.files
	        fs.deletefile file, True
	        Err.clear
	        'WScript.Sleep 50
	    Next
	    For Each unterordner In ordner.subfolders
	        delfolder(unterordner)
	        'WScript.Sleep 50
	        fs.deletefolder unterordner, True
	    Next
	End If
    Set ordner=Nothing
End Function



'************************************************************************


'************************************************************************


Function swduplett(mySWstring)
    On Error Resume Next
    
    swduplett=False
    a=0
    stopsearch=False
    Do While stopsearch=False
        If LCase(Trim(schlagworte(a)))=LCase(Trim(mySWstring)) Then
            stopsearch=True
            swduplett=True
        End If
        a=a+1
        If a>58 Then
            stopsearch=True
        End If
    Loop
    If swduplett=False Then
        a=0
        stopsearch=False
        Do While stopsearch=False
            If schlagworte(a)="" Then
                schlagworte(a)=mySWstring
                stopsearch=True
            End If
            a=a+1
            If (stopsearch=False) And (a>58) Then
                errortxt="archivierung(FG): berlauf bei Schlagworten (>58)."	
                objWshShell.LogEvent 2, errortxt
                stopsearch=True
                swduplett=True
            End If
        Loop
    End If
    
End Function

'************************************************************************


Function pidanzahl(pidextension)
    On Error Resume Next
    
    pidzaehler = 0
    Set folder = fs.GetFolder(programm)
    For Each piddatei In folder.files
        If Right(piddatei,3) = pidextension Then
            pidzaehler = pidzaehler + 1
        End If
    Next
    Set folder = Nothing
    
    pidanzahl = pidzaehler
End Function



Function prozessanzahl(prozessname)
    On Error Resume Next
    Err.clear
    zaehler=0
    
    For Each process In GetObject("winmgmts:"). _
        ExecQuery("select name from Win32_Process where name='"&prozessname&"'")
        zaehler = zaehler + 1
    Next
    If Err.number<>0 Then
        objWshShell.LogEvent 1, "archivierung(0): Keine Connection zu WMI."
        Err.clear
        WScript.Quit
    End If
    prozessanzahl = zaehler
    Set process = Nothing
End Function



Function Zufallszahl(von, bis)
    On Error Resume Next
    
    anzahl = bis-von+1
    Randomize
    Zufallszahl = Fix(Rnd*(anzahl))+von
    
End Function


Function makeautodate(mydate)
	parser = programm & "bfa_parsedate.exe"
	If Not fs.fileexists(parser) Then
		objWSHShell.LogEvent 1, "archvierung.vbs: bfa_parsedate.exe nicht gefunden, Datum kann nicht ermittelt werden. Kontaktieren Sie den Support!"
		makeautodate = ""
	Else
		cmd = Chr(34) & parser & Chr(34) & " -text " & Chr(34) & mydate & Chr(34) & " -dateformat " & Chr(34) & "%d.%m.%Y" & Chr(34)

		If scriptdebug=True Then
			objWSHShell.LogEvent 0, "archivierung.vbs bfa_parsedate Aufruf:" & vbCrLf & cmd
		End If
		
	    Set oExec = objWSHShell.Exec(cmd)
	    strinput = ""
	    strerrinput = ""
	    Do While Not oExec.StdOut.AtEndOfStream
	        strinput = strinput & oExec.StdOut.Read(1)	
	    Loop
	    strerrinput=""
	    Do While Not oExec.StdErr.AtEndOfStream
	        strerrinput = strerrinput & oExec.StdErr.Read(1)	
	    Loop
	    If scriptdebug=True Then
			objWSHShell.LogEvent 0, "archivierung.vbs bfa_parsedate Rckgabe: " & vbCrLf & strinput & vbCrLf & strerrinput
		End If 
	    If Len(strerrinput) > 0 Then
	        objWSHShell.LogEvent 1, "archivierung.vbs Fehler beim Aufruf von bfa_parsedate.exe."&vbCrLf&"Fehler:"&vbCrLf&strerrinput
	        makeautodate = ""
	    End If
	    If Len(strinput) > 0 Then
	    	lines = Split(strinput, vbCrLf)
	    	If UBound(lines)>0 Then
	    		' erstes Datum wird genommen
	    		makeautodate= lines(0)
	    	End If
	    End If
	End If

End Function





Private Function makedate(mydate,usformat)
    
    On Error Resume Next
    
    If InStr(1,mydate,":",1)<>0 Then
        mydate=Replace(mydate,":","")
    End If
    
    
    myday="01"
    mymonth="01"
    myyear="1900"
    myhour="12"
    myminute="00"
    mysecond="00"
    
    Err.clear
    On Error Resume Next
    makedate=""
    mydate=Trim(mydate)
    datetype=0
    varlaenge=Len(mydate)
    compdate=""
    
    If alternatemakedate=False Then
        For o=1 To varlaenge
            If Mid(mydate,o,1)<>" " Then
                
                If varlaenge<12 Then
                    If LCase(Mid(mydate,o,1))="o" Then
                        compdate=compdate&"0"
                    ElseIf LCase(Mid(mydate,o,1))="s" Then
                        compdate=compdate&"5"
                    ElseIf LCase(Mid(mydate,o,1))="g" Then
                        compdate=compdate&"9"
                    ElseIf LCase(Mid(mydate,o,1))="i" Then
                        compdate=compdate&"1"
                    ElseIf Mid(mydate,o,1)="B" Then
                        compdate=compdate&"8"
                    ElseIf Mid(mydate,o,1)="b" Then
                        compdate=compdate&"6"
                    ElseIf Mid(mydate,o,1)="D" Then
                        compdate=compdate&"0"
                    ElseIf LCase(Mid(mydate,o,1))="" Then
                        compdate=compdate&"0"
                    Else
                        compdate=compdate&Mid(mydate,o,1)
                    End If
                Else
                    compdate=compdate&Mid(mydate,o,1)
                End If	
                
                
            End If
        Next
        compdate=LCase(compdate)
    Else
        compdate=LCase(mydate)
    End If
    
    
    
    ReDim chararray(60)
    ReDim chartype(60)
    For x=0 To 60
        chararray(x)=""
        chartype(x)=0
    Next
    mycharstring=""
    varlaenge=Len(compdate)
    For x=1 To varlaenge
    	thischar = Mid(compdate,x,1)
        a=Asc(Mid(compdate,x,1))
        
        chararray(x)=a
        If (a>=48) And (a<=57) Then 'Zahlen
            chartype(x)=1
        ElseIf (a>=97) And (a<=122) Then 'Buchstaben
            chartype(x)=2
        ElseIf (a>=228) And (a<=231) Then 'Buchstaben Umlaute
            chartype(x)=2
        ElseIf (a=47) Or (a=92) Or (a=45) Or (a=150) Or (a=58) Or (a=59) Or (a=44) Then ' / - 
            chartype(x)=3
        ElseIf (a=46) Then ' .
            chartype(x)=3
        Else
            chartype(x)=4
        End If
        
        mycharstring=mycharstring&chartype(x)
    Next
    
    If scriptdebug = True Then
        objWshShell.LogEvent 1, "mydate-debug: mycharstring:"&mycharstring&" compdate:"&compdate
    End If
    
    If varlaenge>6 Then
        If (chartype(1)=1) And (chartype(2)=1) And (chartype(3)=3) And (chartype(4)=2) And (chartype(5)=2) And (chartype(6)=2) And (chartype(varlaenge)=1) And (chartype(varlaenge-1)=1) And (chartype(varlaenge-2)=1) And (chartype(varlaenge-3)=1) And (chartype(varlaenge-4)=2) And (chartype(varlaenge-5)=2) And (chartype(varlaenge-6)=2) Then
            
            datetype=2
        End If
    End If
    
    If varlaenge>6 Then
        If (chartype(1)=1) And (chartype(2)=1) And (chartype(3)=3) And (chartype(4)=2) And (chartype(5)=2) And (chartype(6)=2) And (chartype(varlaenge)=1) And (chartype(varlaenge-1)=1) And (chartype(varlaenge-2)=1) And (chartype(varlaenge-3)=1)  Then
            
            datetype=2
        End If
    End If

    
    
    If varlaenge>6 Then
        If (chartype(1)=1) And (chartype(2)=3) And (chartype(3)=2) And (chartype(4)=2) And (chartype(5)=2) And (chartype(varlaenge)=1) And (chartype(varlaenge-1)=1) And (chartype(varlaenge-2)=1) And (chartype(varlaenge-3)=1) And (chartype(varlaenge-4)=2) And (chartype(varlaenge-5)=2) And (chartype(varlaenge-6)=2) Then
            datetype=8
        End If
    End If
    
    If varlaenge>6 Then
        If (chartype(1)=1) And (chartype(2)=3) And (chartype(3)=2) And (chartype(4)=2) And (chartype(5)=2) And (chartype(varlaenge)=1) And (chartype(varlaenge-1)=1) And (chartype(varlaenge-2)=1) And (chartype(varlaenge-3)=1)  Then
            datetype=8
        End If
    End If
    
    If mycharstring = "131131111" And datetype = 0 Then
    	compdate = "0" & compdate
    	mycharstring = "1131131111"
    End If
    
    If mycharstring = "113131111" And datetype = 0 Then
    	compdate = Left(compdate,3) & 0 & Right(compdate,6)
    	mycharstring = "1131131111"
    End If
    
    If mycharstring = "11422241111" Then
    	'mydate = Left(mydate,2) & Mid(mydate, 4, 2) & Right(mydate, 4)
    	mycharstring = "112221111"

    End If
    
    
    If mycharstring="1131131111" Then
        myyear=Right(compdate,4)
        myday=Left(compdate,2)
        mymonth=Mid(compdate,4,2)
        
        If usformat = False Then
            makedate=myday&"."&mymonth&"."&myyear
        Else
            makedate=mymonth&"."&myday&"."&myyear
        End If
    End If
    
    If mycharstring="1111311311" Then
        myyear=Left(compdate,4)
        myday=Right(compdate,2)
        mymonth=Mid(compdate,6,2)
        
        makedate=myday&"."&mymonth&"."&myyear
    End If
    
    
    
    
    If mycharstring="111131111" Then
        datetype=3
    End If
    
    If mycharstring="113111111" Then
        datetype=4
    End If	
    
    
    If mycharstring="11311311" Then
        datetype=5
    End If	
    
    If mycharstring="1111311" Then
        datetype=6
    End If	
    
    If mycharstring="1131111" Then
        datetype=7
    End If		
    
    If mycharstring="222111111" Then
        datetype=9
    End If	

    If mycharstring="112221111" Then
        datetype=10
    End If
    
    If mycharstring="11322231111" Then
        datetype=11
    End If
    
    If mycharstring="1311311" Then
        mycharstring="11311311"
        compdate = "0" & compdate
        datetype=5
    End If		
    
    If Right(mydate,2)="UT" Then
        datetype=1
    End If
    

    
    If scriptdebug=True Then
        objWshShell.LogEvent 1, "charstring:"&mycharstring&" datetype:"&datetype
    End If
    
   
   	If datetype=11 Then
        
        myday=Left(mydate,2)
        mymonth=Mid(mydate,4,3)
        myyear=Right(mydate,4)
        
        If LCase(mymonth)="dec" Or LCase(mymonth)="dez" Then
            mymonth="12"
        ElseIf LCase(mymonth)="nov" Then
            mymonth="11"
        ElseIf LCase(mymonth)="oct" Or LCase(mymonth)="okt" Then
            mymonth="10"
        ElseIf LCase(mymonth)="sep" Then
            mymonth="09"
        ElseIf LCase(mymonth)="aug" Then
            mymonth="08"
        ElseIf LCase(mymonth)="jul" Then
            mymonth="07"
        ElseIf LCase(mymonth)="jun" Then
            mymonth="06"
        ElseIf LCase(mymonth)="may" Or LCase(mymonth)="mai" Then
            mymonth="05"
        ElseIf LCase(mymonth)="apr" Then
            mymonth="04"
        ElseIf LCase(mymonth)="mar" Or LCase(mymonth)="mr" Then
            mymonth="03"
        ElseIf LCase(mymonth)="feb" Then
            mymonth="02"
        ElseIf LCase(mymonth)="jan" Then
            mymonth="01"
        Else
            mymonth="01"
        End If
        makedate=myday&"."&mymonth&"."&myyear
        
    End If
   
    
    If datetype=10 Then
        
        myday=Left(mydate,2)
        mymonth=Mid(mydate,4,3)
        myyear=Right(mydate,4)
        
        If LCase(mymonth)="dec" Then
            mymonth="12"
        ElseIf LCase(mymonth)="nov" Then
            mymonth="11"
        ElseIf LCase(mymonth)="oct" Then
            mymonth="10"
        ElseIf LCase(mymonth)="sep" Then
            mymonth="09"
        ElseIf LCase(mymonth)="aug" Then
            mymonth="08"
        ElseIf LCase(mymonth)="jul" Then
            mymonth="07"
        ElseIf LCase(mymonth)="jun" Then
            mymonth="06"
        ElseIf LCase(mymonth)="may" Then
            mymonth="05"
        ElseIf LCase(mymonth)="apr" Then
            mymonth="04"
        ElseIf LCase(mymonth)="mar" Then
            mymonth="03"
        ElseIf LCase(mymonth)="feb" Then
            mymonth="02"
        ElseIf LCase(mymonth)="jan" Then
            mymonth="01"
        Else
            mymonth="01"
        End If
        
        makedate=myday&"."&mymonth&"."&myyear
        
    End If
    
    
    If datetype=9 Then
        
        mymonth=Left(mydate,3)
        myday=Mid(mydate,4,2)
        myyear=Right(mydate,4)
       
        
        If LCase(mymonth)="dec" Then
            mymonth="12"
        ElseIf LCase(mymonth)="nov" Then
            mymonth="11"
        ElseIf LCase(mymonth)="oct" Then
            mymonth="10"
        ElseIf LCase(mymonth)="sep" Then
            mymonth="09"
        ElseIf LCase(mymonth)="aug" Then
            mymonth="08"
        ElseIf LCase(mymonth)="jul" Then
            mymonth="07"
        ElseIf LCase(mymonth)="jun" Then
            mymonth="06"
        ElseIf LCase(mymonth)="may" Then
            mymonth="05"
        ElseIf LCase(mymonth)="apr" Then
            mymonth="04"
        ElseIf LCase(mymonth)="mar" Then
            mymonth="03"
        ElseIf LCase(mymonth)="feb" Then
            mymonth="02"
        ElseIf LCase(mymonth)="jan" Then
            mymonth="01"
        Else
            mymonth="01"
        End If
        makedate=myday&"."&mymonth&"."&myyear
        
    End If
    
    
    
    
    If datetype=1 Then
        
        myday=Left(mydate,2)
        mymonth=Mid(mydate,4,3)
        myyear=Mid(mydate,8,4)
        myhour=Mid(mydate,13,2)
        myminute=Mid(mydate,16,2)
        mysecond=Mid(mydate,19,2)
        
        If LCase(mymonth)="dec" Then
            mymonth="12"
        ElseIf LCase(mymonth)="nov" Then
            mymonth="11"
        ElseIf LCase(mymonth)="oct" Then
            mymonth="10"
        ElseIf LCase(mymonth)="sep" Then
            mymonth="09"
        ElseIf LCase(mymonth)="aug" Then
            mymonth="08"
        ElseIf LCase(mymonth)="jul" Then
            mymonth="07"
        ElseIf LCase(mymonth)="jun" Then
            mymonth="06"
        ElseIf LCase(mymonth)="may" Then
            mymonth="05"
        ElseIf LCase(mymonth)="apr" Then
            mymonth="04"
        ElseIf LCase(mymonth)="mar" Then
            mymonth="03"
        ElseIf LCase(mymonth)="feb" Then
            mymonth="02"
        ElseIf LCase(mymonth)="jan" Then
            mymonth="01"
        Else
            mymonth="01"
        End If
        
        makedate=myday&"."&mymonth&"."&myyear
        
    End If
    
    
    
    If datetype=2 Then
        myyear=Right(compdate,4)
        myday=Left(compdate,2)
        mymonth=LCase(Mid(compdate,4,varlaenge-7))
        If mymonth="januar" Then
            mymonth="01"
        End If
        If mymonth="februar" Then
            mymonth="02"
        End If
        If mymonth="mrz" Then
            mymonth="03"
        End If
        If mymonth="april" Then
            mymonth="04"
        End If
        If mymonth="mai" Then
            mymonth="05"
        End If
        If mymonth="juni" Then
            mymonth="06"
        End If
        If mymonth="juli" Then
            mymonth="07"
        End If
        If mymonth="august" Then
            mymonth="08"
        End If
        If mymonth="september" Then
            mymonth="09"
        End If
        If mymonth="oktober" Then
            mymonth="10"
        End If
        If mymonth="november" Then
            mymonth="11"
        End If
        If mymonth="dezember" Then
            mymonth="12"
        End If
        
        If mymonth="jan." Then
            mymonth="01"
        End If
        If mymonth="feb." Then
            mymonth="02"
        End If
        If mymonth="mr." Then
            mymonth="03"
        End If
        If mymonth="apr." Then
            mymonth="04"
        End If
        If mymonth="mai" Then
            mymonth="05"
        End If
        If mymonth="jun." Then
            mymonth="06"
        End If
        If mymonth="jul." Then
            mymonth="07"
        End If
        If mymonth="august" Then
            mymonth="08"
        End If
        If mymonth="sep." Then
            mymonth="09"
        End If
        If mymonth="okt." Then
            mymonth="10"
        End If
        If mymonth="nov." Then
            mymonth="11"
        End If
        If mymonth="dez." Then
            mymonth="12"
        End If
        makedate=myday&"."&mymonth&"."&myyear
        
    End If
    
    
    
    If datetype=8 Then
        myyear=Right(compdate,4)
        myday=Left(compdate,1)
        mymonth=LCase(Mid(compdate,3,varlaenge-6))
        If mymonth="januar" Then
            mymonth="01"
        End If
        If mymonth="februar" Then
            mymonth="02"
        End If
        If mymonth="mrz" Then
            mymonth="03"
        End If
        If mymonth="april" Then
            mymonth="04"
        End If
        If mymonth="mai" Then
            mymonth="05"
        End If
        If mymonth="juni" Then
            mymonth="06"
        End If
        If mymonth="juli" Then
            mymonth="07"
        End If
        If mymonth="august" Then
            mymonth="08"
        End If
        If mymonth="september" Then
            mymonth="09"
        End If
        If mymonth="oktober" Then
            mymonth="10"
        End If
        If mymonth="november" Then
            mymonth="11"
        End If
        If mymonth="dezember" Then
            mymonth="12"
        End If
        makedate="0"&myday&"."&mymonth&"."&myyear
        
    End If
    
    
    If datetype=3 Then
        myyear=Right(compdate,4)
        myday=Left(compdate,2)
        mymonth=Mid(compdate,3,2)
        
        makedate=myday&"."&mymonth&"."&myyear
    End If
    
    
    If datetype=4 Then
        myyear=Right(compdate,4)
        myday=Left(compdate,2)
        mymonth=Mid(compdate,4,2)
        
        makedate=myday&"."&mymonth&"."&myyear
    End If
    
    
    If datetype=5 Then
        myyear=Right(compdate,2)
        myday=Left(compdate,2)
        mymonth=Mid(compdate,4,2)
        
        If strconvert(myyear)>39 Then
            myyear="19"&myyear
        Else
            myyear="20"&myyear
        End If
        
        makedate=myday&"."&mymonth&"."&myyear
    End If
    
    If datetype=6 Then
        myyear=Right(compdate,2)
        myday=Left(compdate,2)
        mymonth=Mid(compdate,3,2)
        
        If strconvert(myyear)>39 Then
            myyear="19"&myyear
        Else
            myyear="20"&myyear
        End If
        
        makedate=myday&"."&mymonth&"."&myyear
    End If
    
    If datetype=7 Then
        myyear=Right(compdate,2)
        myday=Left(compdate,2)
        mymonth=Mid(compdate,4,2)
        
        If strconvert(myyear)>39 Then
            myyear="19"&myyear
        Else
            myyear="20"&myyear
        End If
        
        makedate=myday&"."&mymonth&"."&myyear
    End If
    
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        makedate=""
    End If
    
    
End Function




'###############################################################################################
'###############################################################################################
'###############################################################################################
'###############################################################################################
'#########  Funktion ermittelt die grte kaufmnnische Dezimalzahl in einem String  ###########
'###############################################################################################
'###############################################################################################
'#########  bentigt: getword, strconvert, makevalue  ##########################################
'###############################################################################################

Function getmaxvalue_ext(kette)

	strinput = ""
    schleife = 0
    maxval = ""
    
    Set oExec    = objWSHShell.Exec(Chr(34)&programm&"bfa_maxvalue.exe"&Chr(34)&" "&Chr(34)&kette&Chr(34))
    
    Do While Not oExec.StdOut.AtEndOfStream
        strinput = strinput & oExec.StdOut.Read(1)	
    Loop
    
    durch = False
    schleife = 0
    Do While schleife < 50
        If oExec.Status = 1 Then 
            durch = True
            Exit Do
        End If
        
        WScript.Sleep 100  
        schleife = schleife +1
    Loop
    lines = Split(strinput,vbCrLf)
    r = UBound(lines)
	For Each l In lines
		If Left(l,8)="maxval: " Then
			maxval = Right(l,Len(l)-8)
		End If
	Next
	getmaxvalue_ext = Replace(maxval,".",",")
End Function

Function getmaxvalue(kette)
    On Error Resume Next
    
    If fs.fileexists(programm & "bfa_maxvalue.exe") Then
    	getmaxvalue = getmaxvalue_ext(kette)
    Else
	    
	    ReDim chardigit(20)
	    getmaxvalue=""
	    tempmaxvalue=0
	    testwort=""
	    altwort=""
	    
	    position=1
	    
	    
	    maxposition=Len(kette)-1
	    
	    
	    schleifenabbruch=False
	    
	    If maxposition<2 Then
	        schleifenabbruch=True
	        
	    End If
	    
	    If schleifenabbruch=False Then
	        testwort=getword(kette,position)
	    End If	
	    
	    
	    
	    '**************************  Hauptschleife  ************
	    Do While schleifenabbruch=False
	        If testwort<>altwort Then
	            laenge77=Len(testwort)
	            If (laenge77<21) And (laenge77>3) Then 'if-mark 1
	                isnotvalue=False
	                dezimalzeichen=""
	                dezimalzeichen=Mid(testwort,laenge77-2,1)
	                If (dezimalzeichen<>".") And (dezimalzeichen<>",") Then 
	                    isnotvalue=True
	                    
	                End If
	                
	                If isnotvalue=False Then '-- if-mark 2
	                    
	                  
	                    For x=0 To laenge77-1
	                        chardigit(x)=Asc(Mid(testwort,laenge77-x,1))
	                    Next
	                    
	                    If (chardigit(0)<48) Or (chardigit(0)>57) Then 'keine Ziffer
	                        isnotvalue=True
	                        
	                    End If
	                    If (chardigit(1)<48) Or (chardigit(1)>57) Then 'keine Ziffer
	                        isnotvalue=True
	                        
	                    End If
	                    If (chardigit(2)<>44) And (chardigit(2)<>46) Then 'kein Komma oder Punkt
	                        isnotvalue=True
	                        
	                    End If
	          
	                    
	                    For x=1 To laenge77-3
	                        If x Mod 4 = 0 Then '## mglicher Trennpunkt oder komma (schweiz)
	                            If (chardigit(x+2)<>44) And (chardigit(x+2)<>46) And ((chardigit(x+2)<48) Or (chardigit(x+2)>57)) Then 'kein Komma oder Punkt oder Ziffer
	                                isnotvalue=True
	                                
	                            End If
	                            'MsgBox("!x:"&x&" chardigit: "&chardigit(x+2))
	                        Else
	                            If (chardigit(x+2)<48) Or (chardigit(x+2)>57) Then 'keine Ziffer
	                                isnotvalue=True
	                                
	                            End If
	                            'MsgBox("x:"&x&" chardigit: "&chardigit(x+2))
	                        End If
	                    Next
	                    
	                    
	                    '================ falls wir eine Zahl haben gehts weiter zur Typkonvertierung und Grenvergleich
	                    If isnotvalue=False Then
	                        test2wort=Replace(testwort,",",".")
	                        mytestvalue1=0
	                        mytestvalue1=strconvert(makevalue(test2wort))
	                        'MsgBox(mytestvalue1)
	                        If mytestvalue1>tempmaxvalue Then
	                            
	                            'MsgBox("vorher: "&tempmaxvalue&" jetzt: "&mytestvalue1)
	                            tempmaxvalue=mytestvalue1
	                        End If
	                    End If
	                    
	                    
	                End If '-- if-mark 2
	                
	                
	            End If 'end if-mark 1
	            
	            
	            altwort=testwort
	        End If
	        
	        position=position+1	
	        
	        If position=maxposition Then
	            schleifenabbruch=True
	        Else
	            testwort=getword(kette,position)
	        End If
	    Loop
	    '************************  Ende Hauptschleife  **********
	    
	    
	    getmaxvalue=tempmaxvalue
	    
	    If InStr(1,getmaxvalue,",",1)=False Then
	        
	        getmaxvalue=getmaxvalue&",00"
	    Else
	        
	        If Len(getmaxvalue)>2 Then
	            
	            
	            If Mid(getmaxvalue,Len(getmaxvalue)-1,1)="," Then
	                
	                getmaxvalue=getmaxvalue&"0"
	            End If
	        End If
	    End If
	End If
    
End Function


'###############################################################################################
'###############################################################################################
'###############################################################################################
'###############################################################################################




Private Function strConvert(str)	
    On Error Resume Next 
    
    If Not IsNumeric(str) Then
        strConvert = 0
        
    ElseIf (InStr(1,str,".") And InStr(1,str,",")) Then
        strConvert = 0
    Else
        
        
        str1=""
        str2=""
        neg = False
        
        If InStr(1,str,",") Then
            str1 = Left(str,InStr(1,str,",")-1)
            str2 = Right(str,Len(str)-InStr(1,str,","))
        ElseIf InStr(1,str,".") Then
            str1 = Left(str,InStr(1,str,".")-1)
            str2 = Right(str,Len(str)-InStr(1,str,"."))
        Else
            str1 =str
            str2="0"
        End If
        
        If Left(str1,1) = "-" Then
            neg = True
            str1 = Replace(str1,"-","")
        End If 
        
        wert1=0
        l = Len(str1)
        For x = 1 To l
            wert1=wert1+((Asc(Mid(str1,x,1))-48)*(10^(l-x)))
        Next
        
        wert2=0
        l = Len(str2)
        For x = 1 To l
            wert2=wert2+((Asc(Mid(str2,x,1))-48)*(10^(l-x)))
        Next
        
        wert2 = wert2/(10^Len(str2))
        
        StrConvert=wert1+wert2
        
        If neg = True  Then
            strConvert = 0 - strConvert
        End If
        
    End If
    
    
End Function


Private Function ValConvert(String)
    On Error Resume Next
    Err.Clear
    ValConvert = CDbl(String)
    If Err.number <> 0 Then
        Err.Clear
        If Len(String)>2 Then
            If InStr(1,String,",",1)<>0 Then
                breakevent = False
                laenge=Len(String)
                t=laenge
                Do While breakevent=False
                    If Mid(String,t,1)="," Then
                        breakevent=True
                    Else
                        t=t-1
                    End If
                    If t=0 Then
                        breakevent=True
                    End If
                    
                Loop
                If t<>0 Then
                    String=Left(String,t-1)
                End If	
            End If
        End If		
        wert1=0
        For x = 1 To Len(String)
            wert1=wert1+((Asc(Mid(String,x,1))-48)*(10^(Len(String)-x)))
        Next
        If t<>0 Then
            wert1=wert1-1
        End If
        ValConvert=wert1
        'objWshShell.LogEvent 2, "Trap1:"&wert1
    End If
End Function



Private Function StrConvert_old(String)
    On Error Resume Next
    
    wert1=0
    l = Len(String)
    
    For x = 1 To l
        wert1=wert1+((Asc(Mid(String,x,1))-48)*(10^(l-x)))
    Next
    StrConvert=wert1
End Function


Private Function makeinterval(String)
    On Error Resume Next
    
    
    
    String=Replace(String," ","")
    String=Replace(String,"	","")
    String=Replace(String,"onate","")
    String=Replace(String,"onat","")
    String=Replace(String,"ahre","")
    String=Replace(String,"ahr","")
    String=Replace(String,"age","")
    String=Replace(String,"ag","")
    
    If (Right(String,1)="m") Or (Right(String,1)="M") Or (Right(String,1)="J") Or (Right(String,1)="j") Or (Right(String,1)="t") Or (Right(String,1)="T") Then
        makeinterval=String
    Else 
        makeinterval=""
    End If
    
    
End Function


Private Function makenumeric(String)
    On Error Resume Next
    
    tempkette=""
    o=""
    For x=1 To Len(String)
        o=Mid(String,x,1)
        
        If (o="o") Or (o="O") Or (o="q") Or (o="Q") Or (o="") Or (o="") Or (o="c") Or (o="C") Then
            o="0"
        End If
        
        If (o="i") Or (o="I") Or (o="L") Or (o="/") Then
            o="1"
        End If
        
        If (o="E") Then
            o="3"
        End If
        
        If (o="t") Then
            o="4"
        End If
        
        If (o="G") Or (o="b") Then
            o="6"
        End If
        
        If (o="g") Then
            o="9"
        End If
        
        If (o="B") Then
            o="8"
        End If
        
        
        tempkette=tempkette&o
        
    Next
    makenumeric=tempkette
End Function


Private Function makevalue(String)
    'objWshShell.LogEvent 1, "Einstieg value:"&String
    On Error Resume Next
    String=Trim(String)
    If Len(String)>3 Then
        mypos=Len(String)-2
        If Mid(String,mypos,1)="." Then
            mystring=""
            For x=1 To Len(String)
                If x<>mypos Then
                    mystring=mystring&Mid(String,x,1)
                Else
                    mystring=mystring&","
                End If
            Next
            String=mystring
        End If
        
    End If
    mystring = ""
    For x=0 To Len(String)
        wert1=Mid(String,x,1)
        If (wert1 <> ".") And (wert1<>Chr(180)) And (wert1<>Chr(96)) And (wert1<>Chr(39)) And (wert1<>" ") Then
            mystring = mystring & wert1
        End If
    Next
    makevalue=mystring
    'objWshShell.LogEvent 1, "exit value:"&String
End Function

Private Function makealphabetic(String)
    On Error Resume Next
    
    tempkette=""
    o=""
    For x=1 To Len(String)
        o=Mid(String,x,1)
        
        If o="0" Then
            o="O"
        End If
        
        If o="1" Then
            o="I"
        End If
        
        If (o="8") Then
            o="B"
        End If
        
        If (o="5") Then
            o="S"
        End If
        
        If (o="6") Then
            o="G"
        End If
        
        If (o="7") Then
            o="Z"
        End If
        
        
        
        tempkette=tempkette&o
        
    Next
    makealphabetic=tempkette
End Function




Private Function RemoveDots(String)
    On Error Resume Next
    
    String=NormString(String)
    tempkette=""
    wert1=0
    For x=1 To Len(String)
        wert1=Asc(Mid(String,x,1))
        If ((wert1<39) Or (wert1>44)) And (wert1<>58) And (wert1<>59) And (wert1<>46) Then
            tempkette=tempkette&Chr(wert1)
        End If
    Next
    RemoveDots=tempkette
End Function


Private Function RemoveSpace(String)
    On Error Resume Next
    
    String=NormString(String)
    tempkette=""
    wert1=0
    For x=1 To Len(String)
        wert1=Asc(Mid(String,x,1))
        If (wert1<>32) And (wert1<>9) Then
            tempkette=tempkette&Chr(wert1)
        End If
    Next
    RemoveSpace=tempkette
End Function

Private Function RemoveDash(String)
    On Error Resume Next
    
    String=NormString(String)
    tempkette=""
    wert1=0
    For x=1 To Len(String)
        wert1=Asc(Mid(String,x,1))
        If (wert1<>45) And (wert1<>92) And (wert1<>92) And (wert1<>124) And (wert1<>47) And (wert1<>150) And (wert1<>126) Then
            tempkette=tempkette&Chr(wert1)
        End If
    Next
    RemoveDash=tempkette
End Function





Private Function NormString(String)
	On Error Resume Next
    If normstr=True Then
	    
	    
	    tempkette=""
	    wert1=0
	    l = Len(String)
	    
	    For x = 1 To l
	        wert1=Asc(Mid(String,x,1))
	        If (wert1>=0) And (wert1<=32) Then
	            tempkette=tempkette&" "
	        Else
	            
	            If wert1=151 Then ' "" &#x97;
	                wert1=45 ' "-"
	            End If
	            If wert1=150 Then ' ""  &#x96;
	                wert1=45 ' "-"
	            End If
	            If wert1=95 Then ' "_"
	                wert1=45 ' "-"
	            End If
	            If wert1=173 Then '  &shy;
	                wert1=45 ' "-"
	            End If
	            If wert1=175 Then ' "" &macr;
	                wert1=45 ' "-" 
	            End If
	            If wert1=170 Then ' "" &ordf;
	                wert1=97 ' "a"
	            End If	
	            If wert1=161 Then '  "" &iexcl;
	                wert1=105 ' "i"
	            End If
	            If wert1=181 Then ' "" &micro;
	                wert1=117 ' "u"
	            End If
	            If wert1=213 Then ' "" &Otilde;
	                wert1=214
	            End If
	            If wert1=195 Then ' "" &Atilde;
	                wert1=196 ' ""
	            End If
	            If wert1=229 Then ' "" &aring; 
	                wert1=97 ' "a"
	            End If
	            If wert1=230 Then ' "" &aelig;
	                tempkette=tempkette&"a"
	                wert1=101 ' "e"
	            End If
	            If wert1=209 Then ' "" &Ntilde;
	                wert1=78 ' "N"
	            End If
	            If wert1=199 Then ' "" &Ccedil;
	                wert1=67 ' "C"
	            End If
	            If wert1=231 Then ' "" &ccedil;
	                wert1=99 ' "c"
	            End If
	            If wert1=241 Then ' "" &ntilde;
	                wert1=110 ' "n"
	            End If
	            If wert1=245 Then ' "" &otilde;
	                wert1=246
	            End If
	            If wert1=251 Then ' "" &ucirc;
	                wert1=252 ' ""
	            End If
	            If wert1=253 Then ' "" &yacute;
	                wert1=121 ' "y"
	            End If
	            If wert1=197 Then ' "" &Aring;
	                wert1=65 ' "A"
	            End If
	            
	            '############### Kommas in Punkte umwandeln #########
	            If dontconvertcommatopoint=False Then
	                If wert1=44 Then
	                    wert1=46
	                End If
	            End If
	            
	            If (wert1>=204) And (wert1<=207) Then '    
	                wert1=73 ' "I"
	            End If
	            If (wert1>=200) And (wert1<=203) Then '    
	                wert1=69 ' "E"
	            End If
	            If (wert1>=192) And (wert1<=194) Then '    
	                wert1=65 ' "A"
	            End If
	            If (wert1>=210) And (wert1<=211) Then '  
	                wert1=79 ' "O"
	            End If	
	            If (wert1>=212) And (wert1<=213) Then '  
	                wert1=214 ' ""
	            End If
	            If (wert1>=217) And (wert1<=218) Then '  
	                wert1=85 ' "U"
	            End If
	            If wert1=219 Then ' 
	                wert1=220 ' ""
	            End If			
	            If (wert1>=224) And (wert1<=225) Then '  
	                wert1=97 ' "a"
	            End If
	            If (wert1>=226) And (wert1<=227) Then '  
	                wert1=228 ' ""
	            End If
	            If (wert1>=232) And (wert1<=235) Then '    
	                wert1=101 ' "e"
	            End If
	            If (wert1>=236) And (wert1<=239) Then '    
	                wert1=105 ' "i"
	            End If	
	            If (wert1>=242) And (wert1<=243) Then '  
	                wert1=111 ' "o"
	            End If
	            If (wert1>=249) And (wert1<=250) Then '  
	                wert1=117 ' "u"
	            End If    
	            ' gefiltert werden:
	            '  "  $  ' + < >[ ] ^  ` { | } ~ 
	            ' + andere "exotischere" Sonderzeichen
	            If ((wert1>=40) And (wert1<=42)) Or ((wert1>=44) And (wert1<=59)) Or ((wert1>=63) And (wert1<=90)) Or ((wert1>=97) And (wert1<=122)) Or (wert1=196) Or (wert1=95) Or (wert1=214) Or (wert1=220) Or (wert1=223) Or (wert1=228) Or (wert1=246) Or (wert1=252) Or (wert1=37) Or (wert1=61) Or (wert1=92) Or (wert1=35) Or (wert1=33) Or (wert1=38) Then		
	                tempkette=tempkette+Chr(wert1)
	            Else
	                tempkette=tempkette&""
	            End If
	        End If
	        
	        
	        
	        
	    Next
	    tempkette2=""
	    
	    l = Len(tempkette)
	    'If l>3 Then
	    u=1
	    Do While u<=l
	        c1=Mid(tempkette,u,1)
	        If c1<>" " Then
	            o=0
	            wort=c1
	            Do While ((o+u)<l) And (c1<>" ")
	                o=o+1
	                c1=Mid(tempkette,u+o,1)
	                If c1<>" " Then
	                    wort=wort&c1
	                End If
	            Loop
	            u=u+o
	            If dropshortstrings=True Then
	                If Len(wort)>2 Then
	                    tempkette2=tempkette2&" "&wort
	                End If
	            Else
	                tempkette2=tempkette2&" "&wort
	            End If
	        End If
	        u=u+1
	        
	    Loop
	    
	    
	    NormString=Trim(tempkette2)
	    
    Else
    	NormString=String
    End If
End Function




Private Function NormZusatzfeld(String)
    
    On Error Resume Next
    If normzus=True Then
	    tempkette=""
	    wert1=0
	    l = Len(String)
	    
	    For x = 1 To l
	        wert1=Asc(Mid(String,x,1))
	        
	        If ((wert1>=0) And (wert1<=32)) Or (wert1=160)  Then
	            tempkette=tempkette&" "
	        Else
	            
	            If wert1=92 Then
	                wert1=47
	            End If
	            
	            
	            If ((wert1>=35) And (wert1<=38)) Or ((wert1>=40) And (wert1<=91)) Or ((wert1>=93) And (wert1<=126)) Or ((wert1>=160) And (wert1<=255)) Or (wert1=33) Or (wert1=128) Then		
	                tempkette=tempkette+Chr(wert1)
	            Else
	                tempkette=tempkette&""
	            End If
	        End If
	        
	    Next
	    tempkette2=""
	    
	    l = Len(tempkette)
	    u=1
	    Do While u<=l
	        c1=Mid(tempkette,u,1)
	        If c1<>" " Then
	            o=0
	            wort=c1
	            Do While ((o+u)<l) And (c1<>" ")
	                o=o+1
	                c1=Mid(tempkette,u+o,1)
	                If c1<>" " Then
	                    wort=wort&c1
	                End If
	            Loop
	            u=u+o
	            
	            tempkette2=tempkette2&" "&wort
	            
	        End If
	        u=u+1
	        
	    Loop
	    
	    
	    NormZusatzfeld=Trim(tempkette2)
	Else
		NormZusatzfeld=String
	End If
	    
End Function





Private Function GetString(kette,pos)
    On Error Resume Next
    
    zeichen=""
    ergebnis=""
    index=0
    charwert=0
    If Len(zeichen)=1 Then
        charwert=Asc(zeichen)
    End If
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (charwert<>13) And (charwert<>10) And (zeichen<>"	") And (index<255)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,pos+index,1)
        index=index+1
        If Len(zeichen)=1 Then
            charwert=Asc(zeichen)
        End If
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=") Or (charwert=10) Or (charwert=13)) And (ergebnis="") Then
            zeichen=""
        End If
        
    Loop
    
    GetString=Trim(ergebnis)
End Function

Private Function GetWord(kette,pos)
    On Error Resume Next
    
    zeichen=""
    ergebnis=""
    index1=pos
    'MsgBox(Len(kette)&":"&pos)
    charwert=0
    If Len(zeichen)=1 Then
        charwert=Asc(zeichen)
    End If
    Do While (zeichen<>" ") And (zeichen<>"	") And (charwert<>13) And (charwert<>10) And (index1>1)
        index1=index1-1
        
        If index1=0 Then
            zeichen=""
        Else
            zeichen=Mid(kette,index1,1)
        End If
        
        If Len(zeichen)=1 Then
            charwert=Asc(zeichen)
            If (charwert=13) Or (charwert=10) Then
                
                index1=index1+1
            End If
        End If
        
    Loop
    'MsgBox(index1)
    zeichen=""
    index2=0
    charwert=0
    If Len(zeichen)=1 Then
        charwert=Asc(zeichen)
    End If
    
    maxindex2=Len(kette)-index1+2
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (charwert<>13) And (charwert<>10) And (zeichen<>"	") And (index2<maxindex2)
        ergebnis=ergebnis+zeichen
        
        If index1+index2=0 Then
            zeichen=""
        Else
            zeichen=Mid(kette,index1+index2,1)
        End If
        
        
        index2=index2+1
        If Len(zeichen)=1 Then
            charwert=Asc(zeichen)
        End If
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen=vbCrLf) Or (zeichen="=") Or (charwert=10) Or (charwert=13)) And (ergebnis="") Then
            zeichen=""
        End If
        
    Loop
    'MsgBox(index)
    ergebnis=Trim(ergebnis)
    
    '########## fhrende .-_:; entfernen ###############
    abbruch=False
    zwischenkette=""
    x=1
    abbruch2=False
    laenge=Len(ergebnis)
    Do While abbruch=False
        
        If laenge>=x Then
            zeichen=Mid(ergebnis,x,1)
            charwert=0
            charwert=Asc(zeichen)
            If (abbruch2=False) And ((zeichen=" ") Or (zeichen="	") Or (zeichen="=") Or (charwert=13) Or (charwert=10) Or (zeichen=".") Or (zeichen=":") Or (zeichen="-") Or (zeichen="_") Or (zeichen=";") ) Then
                zeichen=""
            Else
                abbruch2=True
            End If
            zwischenkette=zwischenkette&zeichen
            x=x+1			
        Else
            abbruch=True
        End If
    Loop
    
    ergebnis=zwischenkette	
    
    '########## endstndige .-_:; entfernen ###############
    abbruch=False
    zwischenkette=""
    
    abbruch2=False
    laenge=Len(ergebnis)
    x=laenge
    
    Do While abbruch=False
        
        If x>0 Then
            zeichen=Mid(ergebnis,x,1)
            charwert=0
            charwert=Asc(zeichen)
            If (abbruch2=False) And ((zeichen=" ") Or (zeichen="	") Or (zeichen="=") Or (charwert=10) Or (charwert=13) Or (zeichen=".") Or (zeichen=":") Or (zeichen="-") Or (zeichen="_") Or (zeichen=";") ) Then
                zeichen=""
            Else
                abbruch2=True
            End If
            zwischenkette=zeichen&zwischenkette
            x=x-1			
        Else
            abbruch=True
        End If
    Loop
    
    ergebnis=zwischenkette
    
    GetWord=normstring(ergebnis)
End Function




Private Function GetWordWithDots(kette,pos)
    '####################################################################
    '# getword ohne die Funktion, entstndige sonderzeichen wie punkte  #
    '# zu enfernen. Wird jetzt in function searchstrings eingesetzt,    #
    '# da sonst die date-anweisung in einer naming section nicht        #
    '# funktioniert. HS 10.06.09                                        #
    '####################################################################
    On Error Resume Next
    
    zeichen=""
    ergebnis=""
    index1=pos
    
    charwert=0
    If Len(zeichen)=1 Then
        charwert=Asc(zeichen)
    End If
    Do While (zeichen<>" ") And (zeichen<>"	") And (charwert<>13) And (charwert<>10) And (index1>1)
        index1=index1-1
        
        If index1=0 Then
            zeichen=""
        Else
            zeichen=Mid(kette,index1,1)
        End If
        
        If Len(zeichen)=1 Then
            charwert=Asc(zeichen)
            If (charwert=13) Or (charwert=10) Then
                
                index1=index1+1
            End If
        End If
        
    Loop
    
    zeichen=""
    index2=0
    charwert=0
    If Len(zeichen)=1 Then
        charwert=Asc(zeichen)
    End If
    
    maxindex2=Len(kette)-index1+2
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (charwert<>13) And (charwert<>10) And (zeichen<>"	") And (index2<maxindex2)
        ergebnis=ergebnis+zeichen
        
        If index1+index2=0 Then
            zeichen=""
        Else
            zeichen=Mid(kette,index1+index2,1)
        End If
        
        
        index2=index2+1
        If Len(zeichen)=1 Then
            charwert=Asc(zeichen)
        End If
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen=vbCrLf) Or (zeichen="=") Or (charwert=10) Or (charwert=13)) And (ergebnis="") Then
            zeichen=""
        End If
        
    Loop
    
    ergebnis=Trim(ergebnis)
    If normftx = True Then
    	GetWordWithDots=normstring(ergebnis)
    Else
    	GetWordWithDots=ergebnis
    End If
    
End Function



Private Function GetCommand(kette,pos)
    '***** Hilfsfunktion fr getpositions, welche , wie leerzeichen behandelt.    
    On Error Resume Next
    
    zeichen=""
    ergebnis=""
    index1=pos
    
    charwert=0
    If Len(zeichen)=1 Then
        charwert=Asc(zeichen)
    End If
    Do While (zeichen<>" ") And (zeichen<>"	") And (zeichen<>",") And (charwert<>13) And (charwert<>10) And (index1>1)
        index1=index1-1
        
        If index1=0 Then
            zeichen=""
        Else
            zeichen=Mid(kette,index1,1)
        End If
        
        If Len(zeichen)=1 Then
            charwert=Asc(zeichen)
            If (charwert=13) Or (charwert=10) Then
                
                index1=index1+1
            End If
        End If
        
    Loop
    
    zeichen=""
    index2=0
    charwert=0
    If Len(zeichen)=1 Then
        charwert=Asc(zeichen)
    End If
    
    maxindex2=Len(kette)-index1+2
    Do While (zeichen<>" ") And (zeichen<>" ") And (zeichen<>",") And (zeichen<>vbCrLf) And (charwert<>13) And (charwert<>10) And (zeichen<>"	") And (index2<maxindex2)
        ergebnis=ergebnis+zeichen
        
        If index1+index2=0 Then
            zeichen=""
        Else
            zeichen=Mid(kette,index1+index2,1)
        End If
        
        
        index2=index2+1
        If Len(zeichen)=1 Then
            charwert=Asc(zeichen)
        End If
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen=",") Or (zeichen=vbCrLf) Or (zeichen="=") Or (charwert=10) Or (charwert=13)) And (ergebnis="") Then
            zeichen=""
        End If
        
    Loop
    
    ergebnis=Trim(ergebnis)
    
    GetCommand=normstring(ergebnis)
End Function

Function setwriteprotectbit(Datei)
    On Error Resume Next
    
    Set dateiobj=fs.getfile(datei)
    dateiobj.Attributes = dateiobj.Attributes Or 1
    Set dateiobj=Nothing
    setwriteprotectbit=True
    
End Function

Function resetwriteprotectbit(Datei)
    On Error Resume Next
    
    If fs.fileexists(datei) Then
        Set dateiobj=fs.getfile(datei)
        dateiobj.Attributes = dateiobj.Attributes And Not 1
        Set dateiobj=Nothing
        resetwriteprotectbit=True
    End If
End Function


Function RegRead(tempkey)
    On Error Resume Next
    
    privkey = tempkey
    
    RegRead = objWSHShell.RegRead(privkey)
    If Not Err.number=0 Then
        objWshShell.LogEvent 1, "bitfarm-Archiv: Fehler: Registrierungsschlssel nicht gesetzt."
        RegRead=""
        Err.clear
        WScript.Quit
    End If
End Function


Function Countpages(tifdatei)
    On Error Resume Next
    
    If fs.Fileexists(tifdatei) And LCase(fs.GetextensionName(tifdatei)) = "tif" And fs.FileExists(programm & "CountPages.exe") Then
        
        On Error Resume Next
        strinput = ""
        schleife = 0
        
        
        Set oExec    = objWSHShell.Exec(Chr(34)&programm&"CountPages.exe"&Chr(34)&" "&Chr(34)&tifdatei&Chr(34))
        
        Do While Not oExec.StdOut.AtEndOfStream
            strinput = strinput & oExec.StdOut.Read(1)	
        Loop
        
        durch = False
        schleife = 0
        Do While schleife < 50
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 100  
            schleife = schleife +1
        Loop
        
        If durch = False Then
            objWshShell.LogEvent 1, "Archivierung.vbs Function countpages: Schwerwiegender Fehler" & vbCrLf & "Countpages.exe antwortet nicht oder wird nicht beendet" & vbCrLf & "Status: " & oExec.Status & vbCrLf & "Exitcode " & oExec.ExitCode & vbCrLf & "Schleife: " & schleife
            countpages = 0 
            oExec.Terminate
            
        Else
            
            
            
            If InStr(1,strinput,"Seiten:") <> 0 Then
                
                
                strinput = Trim(Right(strinput,Len(strinput)-InStr(1,strinput,"Seiten:")-6))
                strinput = Left(strinput,InStr(1,strinput,Chr(13))-1)
                countpages = Trim(strconvert(strinput))
                
            End If  
        End If
    Else
        'keine tif-datei oder nicht vorhanden
        countpages = 0 
    End If
    
End Function


Function convertbigendian(tempname)
    On Error Resume Next 
    
    
    If extension = ".tif" Then
        If  fs.FileExists(tempname & ".tif") Then
            Set tiffile = fs.GetFile(tempname & ".tif")
            Set tif = tiffile.OpenAsTextStream(1)
            bytes = tif.Read(2)
            
            tif.Close
            Set tiffile = Nothing
            
            If bytes ="MM" Then
                If fs.fileexists(programm & "convertbigendian.exe") Then
                    Set oExec    = objWSHShell.Exec(programm & "convertbigendian.exe " & Chr(34) & tempname & ".tif" & Chr(34))
                    
                    Do While Not oExec.StdOut.AtEndOfStream
                        strinput = strinput & oExec.StdOut.Read(1)	
                    Loop
                    
                    durch = False
                    schleife = 0
                    Do While schleife < 50
                        If oExec.Status = 1 Then 
                            durch = True
                            Exit Do
                        End If
                        
                        WScript.Sleep 50 
                        schleife = schleife +1
                    Loop
                    
                    If oexec.ExitCode <> 0 Then
                        objWSHShell.LogEvent 1, "Archivierung: Fehler bei der BigEndian-Convertierung" &vbCrLf& tempname & ".tif" '&vbCrLf & strinput
                    Else
                        If scriptdebug = True Then
                            objWSHShell.LogEvent 0, "Archivierung: BigEndian-Convertierung durchgefhrt" &vbCrLf& tempname & ".tif"  '&vbCrLf & strinput
                        End If 
                    End If
                Else
                    objWSHShell.LogEvent 1, "Archivierung: BigEndian-Converter nicht vorhanden" &vbCrLf& programm & "convertbigendian.exe "
                End If
                
            End If 
        End If 	
        
    End If 
    
    '########################################################################################
    
    
End Function






'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'************************************   Ende    ***************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************
'**************************************************************************************



Function getfifo(fifopath,fifoname)
    On Error Resume Next
    
    If fs.fileexists(fifopath&"Thumbs.db") Then
        fs.deletefile fifopath&"Thumbs.db", True
        If Err.number<>0 Then
            objWshShell.LogEvent 1, "Archivierung.vbs: konnte Thums.db nicht lschen"
        End If 
    End If
    
    
    Dim fifofile
    Dim fifofolder
    Beginn = Timer
    tempnumber=""
    fifoname=LCase(fifoname)
    
    highest = 0
    
    
    fifofile = GetLastFile(fifopath, fifoname&"*.*")
    If fifofile<>"" Then
        strfifo = fs.GetBaseName(fifofile)
        If InStr(1,strfifo,"_0") <> 0 Then
            strfifo = Replace(strfifo,"_0","")
        End If
        If InStr(1,strfifio,"-archiv") <> 0 Then
            strfifo = Replace(strfifo,"-archiv","")
        End If
        If InStr(1,strfifio,"-temp") <> 0 Then
            strfifo = Replace(strfifo,"-temp","")
        End If
        strnumber = Right(strfifo,5)
        If IsNumeric(strnumber) Then
            highest= strConvert(strnumber)
        Else
            fifofile = GetLastFile(fifopath, fifoname&"*.job")
            If fifofile<>"" Then
                strfifo = fs.GetBaseName(fifofile)
                strnumber = Right(strfifo,5)
                If IsNumeric(strnumber) Then
                    highest= strConvert(strnumber)
                End If		
     
            End If
        End If
        
        If highest = 99999 Then       ' zahlenbereich fr diesen dateinamen voll, umbenennen
            If fifoname = "prio" Then
                objWshShell.LogEvent 2,"bitfarm-Archiv: Achtung Totaler Overflow - Queue vollgelaufen !"&vbCrLf&"Es werden keine Dokumente mehr gespoolt"
                
                Set fifofolder = Nothing
                WScript.Quit
            Else
                fifoname = "prio"
                getfifo = getfifo(fifopath,fifoname)
                
                Exit Function
            End If
        End If
        
    End If
    
    
    tempnumber = MakeFifoString(highest +1)
    WScript.Sleep 200
    
    fifofile = GetLastFile(fifopath,fifoname&"*.*")
    strfifo = fs.GetBaseName(fifofile)
    
    If strfifo = fifoname& tempnumber Then
        If scriptdebug = True Then
            objWshShell.LogEvent 0, "Archivierung.vbs" &vbCrLf& "Slot schon besetzt, Routine wird nochmals aufgerufen" &vbCrLf& tempnumber &vbCrLf& jetzt
        End If
        
        getfifo = getfifo(fifopath,fifoname)
        
        Exit Function
    End If
    
    
    If fs.FileExists(fifopath & fifoname& tempnumber & extension) Then
        highest = highest + 1
        tempnumber = MakeFifoString(highest +1)
        
        Do While fs.FileExists(fifopath & fifoname& tempnumber & extension) And highest <99999
            highest = highest + 1
            tempnumber = MakeFifoString(highest +1)
        Loop
        
    End If
    
    
    If tempnumber<>"" Then
        getfifo = fifopath & fifoname & tempnumber
    Else
        highest = 0
        
        Set fifofolder = fs.GetFolder(fifopath)
        
        For Each fifofile In fifofolder.Files
            
            strfifo = fs.GetBaseName(fifofile)
            If InStr(1,strfifo,"_0") <> 0 Then
                strfifo = Replace(strfifo,"_0","")
            End If
            If InStr(1,strfifio,"-archiv") <> 0 Then
                strfifo = Replace(strfifo,"-archiv","")
            End If
            If InStr(1,strfifio,"-temp") <> 0 Then
                strfifo = Replace(strfifo,"-temp","")
            End If
            
            If Len(strfifo) = Len(fifoname)+5 Then
                If LCase(Left(strfifo,Len(strfifo)-5)) = fifoname Then
                    
                    strnumber = Right(strfifo,5)
                    If IsNumeric(strnumber) Then
                        strnumber= strConvert(strnumber)
                        'MsgBox "strnumber=" & strnumber		
                    End If
                    If strnumber> highest Then
                        highest =  strnumber
                    End If
                End If
            End If
            
            
            If highest = 99999 Then       ' zahlenbereich fr diesen dateinamen voll, umbenennen
                If fifoname = "prio" Then
                    
                    objWshShell.LogEvent 1,"bitfarm-Archiv: Achtung Totaler Overflow - Queue vollgelaufen !"&vbCrLf&"Es werden keine Dokumente mehr gespoolt"
                    
                    Set fifofolder = Nothing
                    WScript.Quit
                Else
                    fifoname = "prio"
                    
                    getfifo = getfifo(fifopath,fifoname)
              
                    Exit Function
                End If
            End If
            
            
        Next 
        Set fifofolder = Nothing
        Set fifofile = Nothing
        
        
        tempnumber = MakeFifoString(highest +1)
        
        WScript.Sleep 1000
        
        Set fifofolder = fs.GetFolder(fifopath)
        
        For Each fifofile In fifofolder.Files
            strfifo = fs.GetBaseName(fifofile)
            
            If strfifo = fifoname& tempnumber Then
                'MsgBox "doch gefunden, die routine nochmals aufrufen"
                If scriptdebug = True Then
                    objWshShell.LogEvent 0, "Archivierung.vbs" &vbCrLf& "Slot schon besetzt, Routine wird nochmals aufgerufen" &vbCrLf& tempnumber &vbCrLf& jetzt
                End If
                
                getfifo = getfifo(fifopath,fifoname)
                Set fifofolder = Nothing
                Set fifofile = Nothing
                Exit Function
            End If
            
        Next 
        Set fifofolder = Nothing
        Set fifofile = Nothing
        
        getfifo = fifopath & fifoname & tempnumber
        
    End If
    Ende = Timer
    'MsgBox "Getfifo in : " & ende - beginn
    If scriptdebug = True Then
        objWshShell.LogEvent 0, "Archivierung.vbs: ermittelter tempname=" & getfifo
    End If 
    
End Function


Function MakeFiFoString(nummer) 
    On Error Resume Next
    
    If Len(nummer) = 1 Then MakeFiFoString = "0000" & nummer
    If Len(nummer) = 2 Then MakeFiFoString = "000" & nummer
    If Len(nummer) = 3 Then MakeFiFoString = "00" & nummer
    If Len(nummer) = 4 Then MakeFiFoString = "0" & nummer
    If Len(nummer) = 5 Then MakeFiFoString = "" & nummer
    
End Function


Function GetFirstFile(folder,mask)
    On Error Resume Next
    
    GetFirstFile=""
    If fs.FileExists(programm&"countfiles.exe") Then
        Set oExec    = objWSHShell.Exec(Chr(34)&programm&"countfiles.exe"&Chr(34)&" "& Chr(34)&folder & Chr(34)&" " & mask & " -lf")
        
  
        
        
        strinput = oExec.StdOut.ReadAll
        
        
        durch = False
        schleife = 0
        Do While schleife < 5000
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 1
            schleife = schleife +1
        Loop
        timer4 = Timer
        
        strname = strinput
        strname=Right(strinput,Len(strinput)-InStrRev(strinput,Chr(13),Len(strinput)-2)-1)
        strname = Left(strname,InStr(strname,Chr(13))-1)
        
        GetFirstFile=strname
        
        Set oExec = Nothing
    Else
        objWSHShell.LogEvent 1, "Archivierung.vbs: " & programm&"countfiles.exe nicht gefunden"
    End If
    
End Function


Function GetLastFile(folder,mask)
    On Error Resume Next
    
    GetLastFile=""
    
    If fs.FileExists(programm&"countfiles.exe") Then
        Set oExec    = objWSHShell.Exec(Chr(34)&programm&"countfiles.exe"&Chr(34)&" "& Chr(34)&folder & Chr(34)&" " & mask & " -ll")
        

        
        strinput = oExec.StdOut.ReadAll
        
        
        durch = False
        schleife = 0
        Do While schleife < 5000
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 1
            schleife = schleife +1
        Loop
        timer4 = Timer
        
        strname = strinput
        strname=Right(strinput,Len(strinput)-InStrRev(strinput,Chr(13),Len(strinput)-2)-1)
        strname = Left(strname,InStr(strname,Chr(13))-1)
        
        
        GetLastFile=strname
        
        Set oExec = Nothing
    Else
        objWSHShell.LogEvent 1, "Archivierung.vbs: " & programm&"countfiles.exe nicht gefunden"
    End If
    
End Function



Function CountFiles(folder,mask)
    On Error Resume Next
    
    CountFiles=0
    If fs.FileExists(programm&"countfiles.exe") Then
        Set oExec    = objWSHShell.Exec(Chr(34)&programm&"countfiles.exe"&Chr(34)&" "& Chr(34)&folder & Chr(34)&" " & mask)
        
        strinput = oExec.StdOut.ReadAll
        
        
        durch = False
        schleife = 0
        Do While schleife < 5000
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 1
            schleife = schleife +1
        Loop
        timer4 = Timer
        
        strname = strinput
        strname = Right(strinput,Len(strinput)-InStrRev(strinput,Chr(13),Len(strinput)-2)-1)
        strname = Left(strname,InStr(strname,Chr(13))-1)
        
        If InStr(strname,"Anzahl:") Then
            strname = Right(strname,Len(strname)-7)
            CountFiles = Strconvert(strname)
        End If
        
        Set oExec = Nothing
    Else
        objWSHShell.LogEvent 1, "Archivierung.vbs: " & programm&"countfiles.exe nicht gefunden"
    End If
    
End Function






Function getstatustext(thestatus, params)
    
    readlangfile=True
    statustextfound=False
    i=1
    '********* newstatus.lang vorhanden und lesbar?
    If Not fs.FileExists(programm&"newstatus.lang") Then
        Err.clear
        errortxt="newstatus.lang nicht im Scriptpfad vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        Err.clear
        readlangfile=False
    Else
        Err.clear	
        Set langfile = fs.OpenTextFile(programm&"newstatus.lang",1)
        
        If Err.number Then
            
            errortxt="newstatus.lang nicht im Scriptpfad vorhanden oder nicht lesbar."&vbCrLf&Err.Description
            objWshShell.LogEvent 1, errortxt
            Err.clear
            readlangfile=False
        End If 
    End If
    
    '********** nach passendem status-text suchen
    If readlangfile=True Then
        kette=langfile.readline	
        While langfile.AtEndOfStream <> True And statustextfound <> True 
            '*** passende Sprache gefunden
            If (Trim(kette)=Trim(newstatuslang)) Then                     
                While langfile.AtEndOfStream <> True And kette <> "end" And statustextfound = False
                    kette=langfile.readline
                    '*** passender Status gefunden
                    If Left(Trim(kette), 8)=thestatus Then 
                        statustext=Right(Trim(kette),Len(Trim(kette))-9)
                        While (params(i)<>"")
                            statustext=Replace(statustext, "%"&i, params(i))
                            i = i + 1                     	
                        Wend
                        getstatustext=statustext
                        statustextfound=True
                    End If 
                Wend
            End If
            kette=langfile.readline
        Wend
    End If
    
    '*** newstatus.lang nicht gefunden oder kein passender Text in newstatus.lang gefunden
    '*** standard-Text wird zurckgegeben
    
    If readlangfile=False Or statustextfound = False Then
        getstatustext="status-Text nicht gefunden!"
    End If
    
End Function

Function isColorTif(originalDatei)
    If LCase(Right(originalDatei,4))=".tif" Then
        Set oExec = objWSHShell.Exec(Chr(34)&programm&"countpages.exe"&Chr(34)& " " & Chr(34) & originalDatei & Chr(34))
        
        Do While Not oExec.StdOut.AtEndOfStream
            strinput = strinput & oExec.StdOut.Read(1)	
        Loop
        
        durch = False
        schleife = 0
        
        Do While schleife < 50
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            WScript.Sleep 100  
            schleife = schleife +1
        Loop
        
        farbTiefe = 0
        If InStr(strinput, "Farbtiefe")<>0 Then
            pos1 = InStr(strinput, "Farbtiefe") + 10
            farbtiefe = Trim(Mid(strinput, pos1, 2))
            farbtiefe = Replace(farbtiefe, vbCr, "")
            farbtiefe = Replace(farbtiefe, vbLf, "")
            farbtiefe = strConvert(farbtiefe)
        End If
        If farbTiefe > 1 Then
            isColorTif=True
        Else
            If color=True Then
                isColorTif=True
            Else
                isColorTif=False
            End If
        End If
    Else
        isColorTif=color
    End If
End Function


Function countpspages(filepath)
    Set f = fs.OpenTextFile(filepath,1,False)
    
    Set objRE = New RegExp
    objRE.IgnoreCase = False
    objRE.Pattern    = "(%%Pages:\s)(\d{1,6})"
    
    lc = 1
    Do While f.AtEndOfStream<>True
        l = f.ReadLine
        Set colMatches = objRE.Execute(l)
        For Each Match In colMatches
            countpspages = Match.Submatches(1)
        Next
    Loop
    countpspages = Int(countpspages)
    f.Close
End Function


Function addpreviewincomplete(dateiname, oripagecount)
    
    If scriptdebug = True Then
        objWshShell.LogEvent 4, "Archivierung: Dokument hat "&oripagecount&" Seiten, Vorschau nicht komplett."
    End If
    If LCase(newstatuslang="deutsch") Then
        msgtxt1="Diese Voransicht enthlt nicht alle Seiten des Originaldokuments." 
        msgtxt2="Anzahl Seiten im Original: "&oripagecount&"."
        msgtxt3="Fr eine komplette Dokumentenansicht ffnen Sie das Dokument"
        msgtxt4="ber den Button 'Originaldatei'."
    Else
        msgtxt1="This preview does not contain all pages of the original file."
        msgtxt2="Number of pages in the original file are "&oripagecount&"."
        msgtxt3="To open the original file klick the Button 'original file'." 
        msgtxt4=""
    End If   
    
    If fs.fileexists(dateiname&"-temp.tff") Then
        fs.deletefile dateiname&"-temp.tff", True
    End If
    
    
    Set temptxtfile = fs.OpenTextFile(dateiname&"-temp.tff",8,True)
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" " & msgtxt1 & " ")
    temptxtfile.writeline(" " & msgtxt2 & " ")
    temptxtfile.writeline(" " & msgtxt3 & " ")
    temptxtfile.writeline(" " & msgtxt4 & " ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.close
    Set temptxtfile=Nothing
    
    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"Text2TIF.exe"&Chr(34)&" "&Chr(34)&dateiname&"-temp.tff"&Chr(34),0,True)
    
    
    If lngReturnCode <> 0 Then
        Err.clear
        errortxt="archivierung(122g): Fehler bei Text2TIF.exe"
        objWshShell.LogEvent 1, errortxt
        GetGarbage(dateiname)   
        Unlock(programm&lockdatei)
        WScript.Quit
        
    End If
    
    WScript.Sleep 200
    fs.deletefile dateiname&"-temp.tff",True
    archivtif=dateiname
    
    
    
    If (fs.fileexists(dateiname&"-temp.tif")) And (fs.fileexists(dateiname&"-archiv.tif")) Then
        
        lngReturnCode = objWSHShell.Run(programm&"splitterv3.exe -a " &Chr(34)&dateiname&"-archiv.tif"&Chr(34) & " " &Chr(34)& dateiname&"-temp.tif"&Chr(34),0,True)
        archivtif=dateiname&"-archiv"
    End If
    
    If (fs.fileexists(dateiname&"-temp.tif")) And (fs.fileexists(dateiname&".tif")) Then
        
        lngReturnCode = objWSHShell.Run(programm&"splitterv3.exe -a " &Chr(34)&dateiname&".tif"&Chr(34) & " " &Chr(34)& dateiname&"-temp.tif"&Chr(34),0,True)
        
    End If
    
    If fs.fileexists(dateiname&"-temp.tif") Then
        fs.deletefile dateiname&"-temp.tif", True
    End If
    
    If Err.number <> 0 Then
        errortxt="archivierung(addpreviewincomplete): Fehler"
        objWshShell.LogEvent 1, errortxt
        Err.Clear
        On Error Resume Next
    End If    	
End Function

Function createcopy(copyto)
    arcar = Split(copyto,";")
    On Error Resume Next
    Err.Clear
    For i = 0 To UBound(arcar)
        If Not fs.FolderExists(importpath&arcar(i)) Then
            objWSHShell.LogEvent 1, "archivierung.vbs createcopy: Das Verzeichnis "&importpath&arcar(i)& " ist nicht vorhanden, es wird keine Kopie des Dokuments erstellt."
        Else
            destfname=importpath&arcar(i)&"\temp_copy"&extension
            zahl = 0
            While fs.fileexists(destfname)
                destfname = importpath&arcar(i)&"\temp_copy_"&zahl&extension
                zahl = zahl +1
            Wend
            fs.copyfile tempname&extension, destfname, False
            If Err.Number<>0 Then
                objWSHShell.LogEvent 1, "archivierung.vbs createcopy: Konnte Datei nicht nach "&importpath&arcar(i)&" kopieren. Es wird keine Kopie erstellt!"
                Err.Clear
            Else
                objWSHShell.LogEvent 0, "archivierung.vbs createcopy: Kopie des Dokuments in Archiv "&arcar(i)&" erstellt."
            End If
        End If
    Next
End Function


Function setdefault_serviceprinter()
    lngReturnCode = objWSHShell.Run("rundll32 printui.dll,PrintUIEntry /y /n ""Serviceprinter""",0,True)
    If lngReturnCode=0 Then
        setdefault_serviceprinter=True
    Else
        setdefault_serviceprinter=False
    End If
End Function



Function htmlencode(asciistring)
    ' & muss als erstes ersetzt werden
    Asciistring = Replace(Asciistring,"&","&amp;")
    
    Asciistring = Replace(Asciistring,"","&uuml;")
    Asciistring = Replace(Asciistring,"","&Uuml;")
    Asciistring = Replace(Asciistring,"","&auml;")
    Asciistring = Replace(Asciistring,"","&Auml;")
    Asciistring = Replace(Asciistring,"","&ouml;")
    Asciistring = Replace(Asciistring,"","&Ouml;")
    Asciistring = Replace(Asciistring,"","&szlig;")
    Asciistring = Replace(Asciistring,"","&euro;")
    
    Asciistring = Replace(Asciistring,"<","&lt;")
    Asciistring = Replace(Asciistring,">","&gt;")	
    
    htmlencode = Asciistring
End Function

Function htmldecode(asciistring)
    Asciistring = Replace(Asciistring,"&uuml;","")
    Asciistring = Replace(Asciistring,"&Uuml;","")
    Asciistring = Replace(Asciistring,"&auml;","")
    Asciistring = Replace(Asciistring,"&Auml;","")
    Asciistring = Replace(Asciistring,"&ouml;","")
    Asciistring = Replace(Asciistring,"&Ouml;","")
    Asciistring = Replace(Asciistring,"&szlig;","")
    Asciistring = Replace(Asciistring,"&euro;","")
    Asciistring = Replace(Asciistring,"&amp;","&")
    Asciistring = Replace(Asciistring,"&lt;","<")
    Asciistring = Replace(Asciistring,"&gt;",">")	
    
    htmldecode = Asciistring
End Function


Function htmluml(htmlname)
    On Error Resume Next
    Set htmlfile = fs.opentextfile(htmlname,1,-1)
    Set temphtmlfile = fs.CreateTextFile(programm&"temp\temp.html", True)
    Do While htmlfile.atendofstream <> True
        
        line = htmlfile.readline
        
        line = Replace(line,"","&uuml;")
        line = Replace(line,"","&Uuml;")
        line = Replace(line,"","&auml;")
        line = Replace(line,"","&Auml;")
        line = Replace(line,"","&ouml;")
        line = Replace(line,"","&Ouml;")
        
        line = Replace(line,"","&szlig;")
    
        temphtmlfile.writeline line
    Loop
    
    htmlfile.close
    temphtmlfile.close
    fs.deletefile htmlname, True
    fs.movefile programm&"temp\temp.html", htmlname
    
End Function



Function findinlineattachments(htmlfilename,unic)
    On Error Resume Next
    If unic="unicode" Then
        Set f = fs.opentextfile(htmlfilename,1,False,-2)
    Else
        Set f = fs.opentextfile(htmlfilename,1,False,0)
    End If
    If Err.Number<>0 Then
        findinlineattachments = "" 
    Else
        htmltext=""
        Do While f.AtEndOfStream=False
            htmltext = htmltext & f.ReadLine
        Loop
        f.close
        
        pattern = "src=""([^""]*)"""
        Set objRE = New RegExp
        objRE.Global     = True
        objRE.IgnoreCase = True
        objRE.Pattern    = pattern
        objRE.Global = True
        
        Set colMatches = objRE.Execute(htmltext)
        attachmentstring = ""
        For Each objMatch In colMatches
            attachmentstring = attachmentstring & Replace(Replace(objMatch.Value,"src=",""),"""","") & ";"
        Next
        
        pattern = "src='([^']*)'"
        Set objRE = New RegExp
        objRE.Global     = True
        objRE.IgnoreCase = True
        objRE.Pattern    = pattern
        objRE.Global = True
        
        Set colMatches = objRE.Execute(htmltext)
        For Each objMatch In colMatches
            attachmentstring = attachmentstring & Replace(Replace(objMatch.Value,"src=",""),"'","") & ";"
        Next
        
        pattern = "background=""([^""]*)"""
        Set objRE = New RegExp
        objRE.Global     = True
        objRE.IgnoreCase = True
        objRE.Pattern    = pattern
        objRE.Global = True
        Set colMatches = objRE.Execute(htmltext)
        For Each objMatch In colMatches
            attachmentstring = attachmentstring & Replace(Replace(objMatch.Value,"background=",""),"""","") & ";"
        Next
        
        
        findinlineattachments = attachmentstring
    End If
End Function


Function rtftohtml(rtffile)
    
    On Error Resume Next
    Err.clear
    erfolg=True
    tempextension=extension
    If scriptdebug=True Then
        objWshShell.LogEvent 0, "archivierung.vbs: starte Funktion rtftohtml"
    End If
    If erfolg=True Then
        Set objWord = WScript.CreateObject("Word.Application")
        If Err.number <> 0 Then
            Err.clear
            On Error Resume Next
            errortxt="archivierung(11-5): Kein Word installiert oder Fehler beim Zugriff."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
        End If
    End If
    
    
    If erfolg = True Then
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"processmonitor.bat"&Chr(34)&" WORD",0,True)
        WScript.Sleep 200
        On Error Resume Next
        Err.clear
        erfolg = False
        versuche = 0
        Do While erfolg = False And versuche < 3 
            Set wordDoc = objWord.Documents.Add(rtffile)
            WScript.sleep 200
            If Err.number<>0 Then
                
                versuche = versuche +1
                errortxt="archivierung.vbs: Fehler bei MS-Office rtftohtml."
                objWshShell.LogEvent 1, errortxt & vbCrLf & Err.Number & vbTab & Err.Description
                Set wordDoc = Nothing
                erfolg=False
                On Error Resume Next
                Err.clear
                WScript.Sleep 2000
            Else
                erfolg = True
            End If
        Loop
    End If
    
    If erfolg=True Then	
        objWord.Visible = False
        objWord.DisplayAlerts = False
        objWord.Options.PrintBackground = False	
        objWord.Options.PrintHiddenText = False
        objWord.DisplayAlerts = False
        
        Err.clear
        htmlname=Replace(LCase(rtffile),".rtf",".html")
        objWord.ActiveDocument.SaveAs htmlname, 2
        
        If Err.number<>0 Then
            
            errortxt="archivierung.vbs: Fehler bei rtftohtml." & vbCrLf & Err.Number & vbCrLf & Err.Description
            objWshShell.LogEvent 1, errortxt & vbCrLf & Err.Number & vbTab & Err.Description
            
            Err.clear
            erfolg=False
            On Error Resume Next
        End If
        
        wordDoc.Saved = True
        wordDoc.Close()
        objWord.Quit
        
        ' html-Gerst um Text bauen, Zeilenumbrche ersetzen
        If fs.fileexists(htmlname) Then
            Set htmlfile=fs.opentextfile(htmlname, 1)
            htmlcode = htmlfile.readall()
            htmlfile.close
            htmlcode="<html><head></head><body>" & Replace(htmlcode,vbCrLf,"</br>"&vbCrLf) & "</body></html>"
            Set htmlfile=fs.opentextfile(htmlname, 2)
            htmlfile.write(htmlcode)
            htmlfile.close
            
        End If
        
    End If
    wordDoc.Saved = True
    wordDoc.Close()
    objWord.Quit
    Set wordDoc = Nothing
    Set objWord=Nothing
    Err.clear
End Function

Function msgtext()
    
    ' Variablen Initialisierung
    mailinfofile = tempname&".txt"
    test=hires
    richtung=""
    absender=""
    absenderadresse=""
    empfaenger=""
    cc=""
    bcc=""
    betreff=""
    empfangsdatum=""
    empfangsuhrzeit=""
    versanddatum=""
    versanduhrzeit=""
    'myname=""
    attachmentlist = "" 
    inlineattachments = ""   
    errtxt = ""
    herkunft = "eMail"
    ' emltemp erzeugen, ggfs. leeren    
    If Not fs.folderexists (programm & "emltemp") Then
        fs.createfolder(programm & "emltemp")
    Else
        If fs.folderexists (programm & "emltemp\temp") Then
            For Each file In fs.getfolder(programm & "emltemp\temp").files 
                fs.deletefile file, True
            Next
        End If
    End If
    
    ' temp-txt Datei falls vorhanden entfernen
    If fs.fileexists(tempname&".txt") Then
        fs.deletefile tempname&".txt", True
    End If
    
    msgfile = tempname&".msg"
    cmd = Chr(34) & msgconverter & Chr(34) & " " & Chr(34) & msgfile & Chr(34) & " " & Chr(34) &tempname&".txt"&Chr(34) & " " & Chr(34) & programm & "emltemp\temp" & Chr(34) & " /d"
    
    If scriptdebug=True Then
        objWSHShell.LogEvent 0, "archivierung.vbs: msgtext-Aufruf:" & vbCrLf & cmd
    End If
    
    ' msgtext-Konverter starten
    lngReturnCode = objWSHShell.Run(cmd,0,False)
    
    
    ' msgtext nach timeout killen
    ' timeout occured -> ret = True
    ret = timeoutprocess("msgtext.exe", 30)
    If ret = True Then
        ' msgtext nach 10 Sek. noch nicht durch, Fehler behandeln
        
        errtxt = errtxt & "msgtext timeout" & vbCrLf
        objWSHShell.LogEvent 1, "archivierung.vbs: msgtext konnte die Datei nicht konvertieren"
        
        
    Else
        ' Konvertierung abgeschlossen, jetzt Ergebnis prfen
        ' in der queue findet sich ein txt-File mit den Headerinfos wenn alles okay war
        If scriptdebug=True Then
            objWSHShell.LogEvent 0, "archivierung.vbs: msgtext-return:" & vbCrLf & lngReturnCode
        End If
        
        If fs.fileexists(tempname&".txt") Then
            ' Headerdaten in die lokalen Variablen mappen
            decode = True
            mapheaderdata(tempname&".txt")
            
               
            
            
            
            
            emltempname = Replace(LCase(tempname), LCase(queue), LCase(programm) & "emltemp\temp\",1)
            If fs.fileexists(emltempname&".html") Then
                If scriptdebug=True Then
                    objWSHShell.LogEvent 0, "archivierung.vbs msgtext: HTML-E-Mail"
                End If
                previewfile = emltempname&".html"
                previewtype="html"
            ElseIf fs.fileexists(emltempname&".rtf") Then
                removepretag=False
                If scriptdebug=True Then
                    objWSHShell.LogEvent 0, "archivierung.vbs msgtext: RTF-E-Mail"
                End If
                ' TODO: auch konvertieren mit MS-Office ermglichen (fr nicht Server2012 mit MS-Office aber ohne Outlook)
                
                If mswordinstalled=True Then
                    'msoffice Konvertierung
                    rtftohtml(emltempname&".rtf")
                    If Not fs.fileexists(emltempname&".html") Then
                        errtxt = "archivierung.vbs: msgtext Fehler bei rtftohtml, es wurde kein HTML erzeugt"
                    End If
                ElseIf openofficepath <> "" Then
                    Set oExec = objWSHShell.Exec(Chr(34)&openofficepath&"soffice"&Chr(34)&" --nofirststartwizard --headless -nocrashreport -norestore "&Chr(34)&"macro:///bitfarm.bitfarm.ConvertWordToHTML("&emltempname &".rtf)"&Chr(34))
                    durch = False
                    schleife = 0
                    ret = timeoutprocess("soffice.exe",10)
                    
                    
                    If fs.fileexists(emltempname&".html") Then
                        extension = ".html"
                        fs.deletefile emltempname&".rtf", True
                    Else
                        errtxt = "archivierung.vbs: msgtext Fehler bei der msg-Verarbeitung: OpenOffice konnte rtf nicht nach html umwandeln!"&vbCrLf&"Ist das OO-Makro ConvertWordToHTML vorhanden?"
                    End If	
                Else
                    errtxt = "archivierung.vbs: msgtext Fehler bei der msg-Verarbeitung: OpenOffice/Ms-Office nicht installiert!"
                End If
                
            Else
                ' weder html noch rtf-Mail, dann erzeugte txt nehmen, HTML aus txt erzeugen (ohne die Header-Daten aus der txt)
                removepretag=False
                If scriptdebug=True Then
                    objWSHShell.LogEvent 0, "archivierung.vbs msgtext: Plaintext-E-Mail"
                End If
                ' mailinfo-File Header entfernen, Rest in html packen, mailtext lesen
                mailtext = ""
                Set txtfile = fs.opentextfile(tempname&".txt",1,False)
                If Not fs.folderexists(programm&"emltemp\temp") Then
                    fs.createfolder programm&"emltemp\temp"
                End If
                Set tmptxtfile = fs.opentextfile(emltempname&".html",2,True)
                tmptxtfile.write("<html><body>"&vbCrLf)
                startcopy=False
                kette = "first"
                ' Headerdaten und Text der Email sind durch eine Leerzeile getrennt
                Do While Trim(kette) <> "" And txtfile.atendofstream=False
                    kette = txtfile.readline
                Loop
                Do While txtfile.atendofstream=False
                    kette = txtfile.readline
                    tmptxtfile.writeline(kette&vbCrLf&"</br>")
                Loop
                txtfile.close
                tmptxtfile.write("</body></html>"&vbCrLf)
                tmptxtfile.close
                
                
            End If
            
        Else
            ' wenn keine txt erzeugt wurde, ist die Konvertierung schief gegangen...
            errtxt = errtxt & "archivierung.vbs: msgtext hat kein txt erzeugt" & vbCrLf
        End If
        
    End If
    
    ' #################################################################################
    ' an dieser Stelle prfen, ob errtxt leer ist
    ' wenn nicht ist etwas schief gegangen, dann Standardtif kopieren, Fehler loggen
    ' sonst Attachments verarbeiten, dann HTML-Kopf mit Mailheader-Daten erzeugen und ins vorhandene HTML-File mergen
    ' #################################################################################
    linkattachment = False
    If errtxt = "" Then
        Dim attachments(1000)
        Dim cid(1000)
        
        ' attachments/cids ermitteln
        If fs.fileexists(programm & "emltemp\temp\AttachmentsTxt.txt") Then
            i = 0
            Set attlist = fs.opentextfile(programm & "emltemp\temp\AttachmentsTxt.txt",1,False,-2)
            kette = " "
            While kette <> "" And attlist.atendofstream=False
                kette=attlist.readline()
                If Trim(kette)<>"" Then
                    fname= Trim(Replace(Left(kette,InStr(1,kette,";")-1),"filename:",""))
                    cidname = Trim(Right(kette,Len(kette)-InStr(1,kette,";")))
                    If fs.fileexists(fname) Then
                        attachments(i)=Replace(fname,programm & "emltemp\temp\","")
                        cid(i)=cidname
                        i=i+1
                    End If
                End If
                
            Wend
            
        End If
        
        ' Bei rtf- oder txt-Mails ist attachmentstxt leer, dann selbst ermitteln
        For Each sfile In fs.getfolder(programm & "emltemp\temp").files
            If LCase(sfile.Path) <> LCase(emltempname&".html") And LCase(sfile.Path) <> LCase(emltempname&".rtf") And LCase(sfile.Name)<>"attachmentstxt.txt" Then
                vorhanden = False
                ' prfen, ob schon vorhanden
                For a = 0 To UBound(attachments)
                    If attachments(a) = sfile.Name Then
                        vorhanden = True
                        Exit For
                    End If
                Next
                If vorhanden = False Then
                    attachments(i)=sfile.Name
                    i = i + 1
                End If
            End If
        Next
        
        
        ' inline-Attachments korrigieren (cid->Dateiname)
        inlineattachments = findinlineattachments(emltempname&".html","keinunicode")
        Set htmlfile=fs.opentextfile(emltempname&".html",1,False,-2)
        If htmlfile.atendofstream = False Then
        	htmlcode=htmlfile.readall()
        End If
        htmlfile.close
        attar = Split(inlineattachments, ";")
        For Each att In attar
            If Trim(att)<>"" Then
                For i=0 To UBound(cid)
                    If InStr(cid(i),att) Then
                        htmlcode=Replace(htmlcode,att,"file:///"&programm&"\EMLTemp\temp\"&attachments(i))
                        ' inline-attachments aus attachmentarray entfernen
                        If filterinlineattachments = True Then
                        	attachments(i)=""
                        End If
                        Exit For
                    End If
                Next
            End If
        Next
        
        
        
        
        
        ' nur nicht-inline-Attachments auflisten
        attachmentlist=""
        For i = 0 To UBound(attachments)
            If Trim(attachments(i))<>"" Then
                attachmentlist = attachmentlist&Trim(attachments(i))&"; "
            End If
        Next
        If Len(attachmentlist)>2 Then
            attachmentlist = Left(attachmentlist,Len(attachmentlist)-2)
        End If
        
        
        i=0
        ' Inline-Attachments auch im HTML-Code suchen
        If filterinlineattachments=True Then
            For Each att In attachments
                If att<> "" And IsInArray(att, attar) Or IsInArray("cid:"&att, attar) Then
                    If InStr(attachmentlist,att&";")<>0 Then
                        attachmentlist=Replace(attachmentlist,att&";","",1,1)
                    ElseIf InStr(attachmentlist,att)<>0 Then
                        attachmentlist=Replace(attachmentlist,att,"",1,1)	
                    End If
                    
                    If IsInArray("cid:"&att, attar) Then
                        If InStr(htmlcode, "src="&Chr(34)&"cid:"&att) <> 0 Then
                            htmlcode=Replace(htmlcode,"src="&Chr(34)&"cid:"&att,"src="&Chr(34)&"file:///"&programm&"\EMLTemp\temp\"&att)
                        ElseIf InStr(htmlcode, "src='cid:"&att) <> 0 Then
                            htmlcode=Replace(htmlcode,"src='cid:"&att,"src='file:///"&programm&"\EMLTemp\temp\"&att)
                        End If
                    End If
                    attachments(i)=""
                End If
                i = i + 1
            Next
        End If
        

        
        
        linkattachment = False
        For Each att In attachments
            ' nur ausfhren wenn linkattachment noch false ist, sonst wird der Link gesetzt
            If linkattachment = False  And Trim(att) <> "" Then
                ' nur wenn attachments generell archiviert werden 
                If dontExtractMsgAttachments = False Then
                    ' wenn whitelist gesetzt ist, prfen ob attachment auf whitelist steht
                    If emailwhite <> "" Then
                        dotpos = InStrRev(att,".")
                        ' wenn fname extension in whitelist linkattachment true setzen
                        If InStr(1, emailwhite, Right(att, Len(att)-dotpos),1) <> 0 Then
                            linkattachment = True
                            Exit For
                        End If
                        ' wenn blacklist gesetzt ist (und whitelist leer), prfen ob auf blacklist steht
                    ElseIf emailblack <> "" Then
                        ' wenn fname extension nicht in blacklist linkattachment true setzen
                        dotpos = InStrRev(att,".")
                        If InStr(1, emailblack, Right(att, Len(att)-dotpos),1) = 0 Then
                            linkattachment = True
                            Exit For
                        End If
                    Else
                        linkattachment = True
                        Exit For
                    End If
                End If
            End If
        Next
        
        
        ' Mailverknpfung erzeugen wenn noch attachments vorhanden (inline sind raus)
        If linkattachment = True Then
            For iLink = 0 To limit
                If linkspeicher(iLink) = "" Then
                    datumsstring=""
                    If empfangsdatum <> "" And empfangsuhrzeit <> "" Then
                        datumsstring = "_" & empfangsdatum&"_"&empfangsuhrzeit
                    ElseIf versanddatum <> "" And versanduhrzeit <> "" Then
                        datumsstring = "_" & versanddatum&"_"&versanduhrzeit
                    End If
                    
                    replbetreff = Replace(betreff, "'", "")
                    linkspeicher(iLink) = "Email: " &replbetreff & datumsstring
                    Exit For
                End If
            Next            
        End If
        
        ' HTML Header ergnzen
        mailheader = ""
        mailheader = mailheader & "<hr noshade color=""black"" size=""3"" align=""left"">" &vbCrLf&"<table>"
        rowtemplate = "<tr><td style='vertical-align:top;font-size:10.0pt;font-family:""Arial"";font-weight:bold;border-top: none; border-bottom: none; border-left: none; border-right: none; padding-top: 0cm; padding-bottom: 0.1cm; padding-left: 0.1cm; padding-right: 0cm'>%name%:</td><td style='vertical-align:top;font-size:10.0pt;font-family:""Arial"";border-top: none; border-bottom: none; border-left: none; border-right: none; padding-top: 0cm; padding-bottom: 0.1cm; padding-left: 0.1cm; padding-right: 0cm'>%value%</td></tr>"
        mailheaderend = "</table>"
        mailheadertxt = ""	
        'If absender <> "" Then
        absenderhtml=absender
        absenderhtml=htmlencode(absenderhtml)
        row = Replace(Replace(rowtemplate,"%name%","Von"),"%value%",absenderhtml)& vbCrLf
        mailheader = mailheader & row
        mailheadertxt=mailheadertxt&"Absender: "& absender& vbCrLf
        'End If
        
        
        
        'If empfaenger <> "" Then
        empfaengerhtml=empfaenger
        empfaengerhtml=htmlencode(empfaengerhtml)
        row = Replace(Replace(rowtemplate,"%name%","An"),"%value%",empfaengerhtml)
        mailheader = mailheader & row
        mailheadertxt=mailheadertxt&"Empfnger: "& empfaenger& vbCrLf
        
        If cc<>"" Then
            cchtml=cc
            cchtml=htmlencode(cchtml)
            row = Replace(Replace(rowtemplate,"%name%","CC"),"%value%",cchtml)
            mailheader = mailheader & row
            mailheadertxt=mailheadertxt&"CC: "& cc& vbCrLf
        End If
        
        If bcc<>"" Then        
            bcchtml=bcc
            bcchtml=htmlencode(bcchtml)
            row = Replace(Replace(rowtemplate,"%name%","BCC"),"%value%",bcchtml)
            mailheader = mailheader & row
            mailheadertxt=mailheadertxt&"BCC: "& bcc& vbCrLf
        End If  
        
        If empfangsdatum <> "" Then
            richtung="Eingang"
            empfangsdatumhtml=empfangsdatum & " " & empfangsuhrzeit
            empfangsdatumhtml=htmlencode(empfangsdatumhtml)
            'row = Replace(Replace(rowtemplate,"%name%","Empfangen"),"%value%",empfangsdatumhtml)
            row = Replace(Replace(rowtemplate,"%name%","Empfangen"),"%value%",htmlencode(empfangsdatum)&" "&htmlencode(empfangsuhrzeit))
            mailheader = mailheader & row
            mailheadertxt=mailheadertxt&"Empfangen: "& empfangsdatum & " " & empfangsuhrzeit& vbCrLf
        Else
            richtung="Ausgang"
        End If
        
        If versanddatum <> "" Then
            versanddatumhtml=versanddatum & " " & versanduhrzeit
            versanddatumhtml=htmlencode(versanddatumhtml)
            'row = Replace(Replace(rowtemplate,"%name%","Gesendet"),"%value%",versanddatumhtml)
            row = Replace(Replace(rowtemplate,"%name%","Gesendet"),"%value%",htmlencode(versanddatum)&" "&htmlencode(versanduhrzeit))
            mailheader = mailheader & row
            mailheadertxt=mailheadertxt&"Empfangen: "& versanddatum & " " & versanduhrzeit& vbCrLf
        End If 
        
        kategorie = ""
        If InStr(Filtermakro,"fromoutlook")=0 Then
            If fs.fileexists(tempname & ".slw") Then
                Set swfile=fs.OpenTextFile(tempname&".slw",1)
                Do While swfile.atendofstream=False
                    kette=swfile.readline
                    If InStr(1,kette,"Kategorie=",1)<>0 Then
                        kategorie = Right(kette,Len(kette)-10)
                        Exit Do
                    End If
                Loop
                swfile.close
                Set swfile=Nothing
            End If
        End If
        
        If kategorie <> "" Then
            row = Replace(Replace(rowtemplate,"%name%","Kategorie"),"%value%",htmlencode(kategorie))
            mailheader = mailheader & row
            mailheadertxt=mailheadertxt&"Kategorie: "& kategorie & vbCrLf
        End If
        
        'End If
        'If betreff <> "" Then
        betreffhtml=betreff
        betreffhtml=htmlencode(betreffhtml)
        row = Replace(Replace(rowtemplate,"%name%","Betreff"),"%value%",betreffhtml)
        mailheader = mailheader & row
        mailheadertxt=mailheadertxt&"Betreff: "& betreff& vbCrLf
        'End If
        If attachmentlist <> "" Then
            attachmentlist = Replace(attachmentlist,";","; ")
            attachmentlisthtml=attachmentlist
            attachmentlisthtml=htmlencode(attachmentlisthtml)
            row = Replace(Replace(rowtemplate,"%name%","Anlagen"),"%value%",attachmentlisthtml)
            mailheader = mailheader & row
            mailheadertxt=mailheadertxt&"Anlagen: "& attachmentlist& vbCrLf
        End If
        mailheader = mailheader & mailheaderend & "</br></br>"
        ' Position nach Body-Tag finden, um dort den Mailheader zu platzieren
        bodytagstart = InStr(1,LCase(htmlcode),"<body")
        If bodytagstart > 0 Then
            bodytagend = InStr(bodytagstart, htmlcode,">")
            bodytag = Mid(htmlcode,bodytagstart, bodytagend-bodytagstart+1)
            newhtml = Left(htmlcode,bodytagstart-1) & bodytag & mailheader & Right(htmlcode,Len(htmlcode)-bodytagend)
        Else
            removepretag=False
            newhtml = "<html>"&"<body>"&mailheader&"</body></html>"
        End If
        
        Set htmlfile = fs.opentextfile(emltempname&".html",2,True,-1)
        htmlfile.write(newhtml)
        htmlfile.close
        If removepretag=True And fs.fileexists(programm & "bfa_remove_pre.exe") Then
            cmd = Chr(34) & programm & "bfa_remove_pre.exe" & Chr(34) & " " & Chr(34) & emltempname&".html" & Chr(34) & " " & Chr(34) & emltempname&".html.tmp" & Chr(34)
            lngReturnCode = objWSHShell.Run(cmd ,0,False)
            ret = timeoutprocess("bfa_remove_pre.exe",20)
            If ret = True Then
                objWSHShell.LogEvent 1, "archivierung.vbs: emlconvert: bfa_remove_pre.exe Timeout"
            Else
                If fs.fileexists(emltempname&".html.tmp") Then
                    fs.deletefile emltempname&".html"
                    fs.movefile emltempname&".html.tmp", emltempname&".html"
                End If
            End If
        End If
        
    Else
        objWSHShell.LogEvent 1, errtxt
        
    End If
    
    
    ' Hier haben wir die fertige html-Voransicht mit Header, attachments etc...
    ' html-Konvertierung mit wkhtmltopdf und PDFtoColorTIF oder PDFtoTIF
    If fs.fileexists(emltempname&".html") Then
        If htmlconverter <> "" Then
            cwd = objwshShell.CurrentDirectory
            objwshShell.CurrentDirectory = programm & "emltemp\temp"
            f = fs.getbasename(emltempname&".html")&".html"
            If loadimages Then
                cmd = Chr(34) & htmlconverter & Chr(34) & " --disable-javascript " & f & " " & Chr(34) & emltempname&".pdf" & Chr(34)
            Else 
                cmd = Chr(34) & htmlconverter & Chr(34) & " --disable-javascript --no-images " & f & " " & Chr(34) & emltempname&".pdf" & Chr(34)
            End If
            lngReturnCode = objWSHShell.Run(cmd ,0,False)
            ret = timeoutprocess("wkhtmltopdf.exe",180)
            If ret = True Then
                objWSHShell.LogEvent 1, "archivierung.vbs: msgtext: wkhtmltopdf.exe Timeout"
            End If
            objwshShell.CurrentDirectory = cwd
            If fs.fileexists(emltempname&".pdf") Then
                olddateiname = dateiname
                dateiname = emltempname&".pdf"
                If emailcolor="" Then
                    If color=True Then
                        PDFtoColorTIF(emltempname)
                    Else
                        PDFtoTIF(emltempname)
                    End If
                Else
                    If emailcolor="color" Then
                        color=True
                        archpdfincolor=True
                        PDFtoColorTIF(emltempname)
                    ElseIf emailcolor="bw" Then
                        color = False
                        PDFtoTIF(emltempname)
                    ElseIf emailcolor="grey" Then
                        archpdfincolor="grey"
                        PDFtoColorTIF(emltempname)
                    End If
                End If
                fs.deletefile emltempname&".html"
                fs.deletefile emltempname&".pdf"
                dateiname = olddateiname
                If fs.fileexists(emltempname&"-archiv.tif") Then
                    fs.movefile emltempname&"-archiv.tif", tempname&"-archiv.tif"
                    archivtif=tempname&"-archiv"
                End If
                If fs.fileexists(emltempname&".tif") Then
                    fs.movefile emltempname&".tif", tempname&".tif"
                Else
                    ' Fehler loggen, Fehlerbehandlung
                    objWSHShell.LogEvent 1, "archivierung.vbs: msgtext: konnte aus pdf kein Tif erzeugen, Keine Voransicht..."
                    makefilltif(tempname)
                End If
            Else
                objWSHShell.LogEvent 1, "archivierung.vbs: msgtext: htmlconverter konnte kein pdf erzeugen, Keine Voransicht..."
                makefilltif(tempname)
            End If
            
        Else
            objWSHShell.LogEvent 1, "archivierung.vbs: Fehler in msgtext, kein htmlconverter vorhanden."
            makefilltif(tempname)
        End If
        
        ' extension fr die weitere Verarbeitung wieder auf msg setzen
        extension=".msg"
        
    Else
        ' KEIN HTML -> FEHLERBEHANDLUNG!!!
        objWSHShell.LogEvent 1, "archivierung.vbs: msg-Datei konnte nicht verarbeitet werden, keine Voransicht verfgbar"
        makefilltif(tempname)
    End If
    
    ' Volltext per ftx (geliefert von Outlook-Add-In)
    If fs.fileexists(tempname&".ftx") Then
        fs.deletefile tempname&".txt", True
        fs.movefile tempname&".ftx", tempname&".txt"
        Typ="TXT"
        ' Volltext per txt (geliefert von msgtext), dann Headerdaten noch in txt packen, damit sie im Volltext dabei sind
    Else
        If fs.fileexists(tempname&".txt") Then
            Set txtfile = fs.opentextfile(tempname&".txt",1,False)
            Set tmptxtfile = fs.opentextfile(tempname&".tmp.txt",2,True)
            If mailheadertxt<>"" Then
                tmptxtfile.writeline(htmldecode(mailheadertxt)&vbCrLf&vbCrLf)
            End If
            If ftxaddrawheader=False Then
            	kette = "first"
            	While Trim(kette)<>"" And Not txtfile.atendofstream
	                kette = txtfile.readline()
            	Wend
            End If
            While Not txtfile.atendofstream
                kette = txtfile.readline()
                tmptxtfile.writeline(kette)
            Wend
            txtfile.close
            tmptxtfile.close
            fs.deletefile tempname&".txt", True
            fs.movefile tempname&".tmp.txt", tempname&".txt"
            Typ="TXT"
        End If
    End If
    
    
    ' attachment-Jobs erzeugen und in queue bertragen
    If scriptdebug=True Then
		objWSHShell.LogEvent 0, "archivierung.vbs attachment-Jobs erzeugen und in queue bertragen"
	End If
	
    If Not (dontExtractMsgAttachments) And (Not changeling) And (InStr(Filtermakro,"fromoutlook")=0) Then
        
        For Each att In attachments
            If Trim(att)<>"" Then
                
                attpath = programm & "emltemp\temp\"&att
                dontarch = False
                If linkdoubleattachments=True Then
                	shasum = Pruefsumme(attpath)
                	If scriptdebug=True Then
                		objWSHShell.LogEvent 0, "archivierung.vbs prfe, ob attachment " & Chr(34) & attpath & Chr(34) & " bereits archiviert wurde (sha " & shasum & ")"
                	End If
                    If fs.fileexists(programm & "addlink.exe") Then
                        ' jetzt sha-summe in db suchen
                        ' wenn gefunden -> dem gefundenen Dokument aktuelle Email-Verknpfung mitgeben, wenn konfiguriert
                        ' aktuelle Verknpfung in linkspeicher(iLink) 
                        
                        If shasum = "" Then
                            objWSHShell.LogEvent 1, "archivierung.vbs: sha-Summe des attachments konnte nicht erzeugt werden."
                            founddocs = False
                        Else
                            founddocs = find_doc_by_sha1(shasum)	
                        End If
                        
                        If founddocs = False Then
                            dontarch = False
                        Else
                        	If scriptdebug=True Then
		                		objWSHShell.LogEvent 0, "archivierung.vbs attachment " & Chr(34) & attpath & Chr(34) & " wurde bereits archiviert (sha " & shasum & ")"
		                	End If
                            docs = Split(founddocs,vbCrLf)
                            haserror = False
                            For Each doc In docs
                            	If scriptdebug=True Then
			                		objWSHShell.LogEvent 0, "archivierung.vbs verlinke docid " & doc
			                	End If
                                If doc <> "" Then
                                    parts = Split(doc," ")
                                    gdocid = parts(0)
                                    cmd = programm & "addlink.exe " & profil & " " & gdocid & " " & Chr(34)&linkspeicher(iLink)&Chr(34)
                                    If scriptdebug=True Then
				                		objWSHShell.LogEvent 0, "archivierung.vbs verlinke attachment mit addlink.exe" & vbCrLf & cmd
				                	End If
                                    Set oExec = objWSHShell.Exec(cmd)
                                    strinput = ""
                                    strerrinput = ""
                                    Do While Not oExec.StdOut.AtEndOfStream
                                        strinput = strinput & oExec.StdOut.Read(1)	
                                    Loop
                                    strerrinput=""
                                    Do While Not oExec.StdErr.AtEndOfStream
                                        strerrinput = strerrinput & oExec.StdErr.Read(1)	
                                    Loop
                                    If scriptdebug=True Then
							    		objWSHShell.LogEvent 0, "archivierung.vbs addlink Rckgabe: " & vbCrLf & strinput & vbCrLf & strerrinput
							    	End If 
                                    If Len(strerrinput) > 0 Then
                                        objWSHShell.LogEvent 1, "archivierung.vbs Fehler beim Aufruf von addlink.exe."&vbCrLf&"Fehler:"&vbCrLf&strerrinput
                                        haserror = True
                                    End If
                                End If
                            Next
                            If haserror=False Then
                                dontarch=True
                            End If
                        End If
                    Else
                        objWSHShell.LogEvent 1, "archivierung.vbs Fehler: Email-Attachment konnte nicht verlinkt werden, da addlink.exe fehlt. Attachment wird daher archiviert."
                    End If
                    
                End If
                If dontarch = False Then
                    sJobname = getfifo(queue, "temp-msg")
                    Set swdfile = fs.opentextfile(sJobname & ".slw",8,True)
                    swdfile.writeline "Dateiname=" & fs.getbasename(att)
                    swdfile.close
                    
                    fs.Copyfile tempname & ".job", sJobname & ".job", True
                    
                    target = sJobname & "."& fs.GetExtensionName(att)
                    fs.copyfile attpath, target, True
                    WScript.Sleep 250
                    oldtyp = Typ
                    Typ = ""
                    If Not writeemailjob(sJobname) Then
                        objWshShell.LogEvent 1, "Fehler beim Schreiben einer Jobdatei fr ein Attachment"
                        If Not fs.fileexists(sJobname & ".job") Then
                            fs.deletefile sJobname & ".swd", True
                            fs.deletefile sJobname & sExt, True
                            Err.Clear
                        End If 
                    End If
                    Typ = oldtyp
                End If	
            End If
        Next
    End If

End Function



Function mapheaderdata(infofile)
    If Not fs.fileexists(infofile) Then
        mapmailinfo=False
    Else
        If fs.fileexists(programm&"bfa_extract_headerdata.exe") Then
            cmd = Chr(34) & programm &"bfa_extract_headerdata.exe" &Chr(34) & " " & Chr(34) & infofile & Chr(34)
            Set oExec = objWSHShell.Exec(cmd)
            strinput = ""
            Do While Not oExec.StdOut.AtEndOfStream
                strinput = strinput & oExec.StdOut.Read(1)	
            Loop
            strerrinput=""
            Do While Not oExec.StdErr.AtEndOfStream
                strerrinput = strerrinput & oExec.StdErr.Read(1)	
            Loop   
            On Error Resume Next 
            If Trim(strinput)<>"" Then
                headerdatalines=Split(strinput,vbCrLf)
                For Each l In headerdatalines
                    If l<>"" Then
                        key = Left(l, InStr(l,"=")-1)
                        val = Right(l, Len(l)-InStr(l,"="))
                        If key="Betreff" Then
                            betreff=val
                        ElseIf key="Absender" Then
                            absender=val
                        ElseIf key="Empfaenger" Then
                            empfaenger=val
                        ElseIf key="Versanddatum" Then
                            versanddatum=val
                        ElseIf key="Versanduhrzeit" Then
                            versanduhrzeit=val
                        ElseIf key="Empfangsdatum" Then
                            empfangsdatum=val
                        ElseIf key="Empfangsuhrzeit" Then
                            empfangsuhrzeit=val
                        ElseIf key="CC" Then
                            CC=val
                        ElseIf key="BCC" Then
                            bcc=val
                        End If
                    End If
                Next 
            Else  
                objWSHShell.LogEvent 1, "archivierung.vbs: bfa_extract_headerdata.exe konnte den Mail-Header nicht parsen!"
            End If
        Else
            objWSHShell.LogEvent 1, "archivierung.vbs: Konnte bfa_extract_headerdata.exe nicht finden. Bitte Support informieren!"
        End If
    End If
End Function

Function mapmailinfo(infofile, decode)  
    If Not fs.fileexists(infofile) Then
        mapmailinfo=False
    Else
        
        kette = ""
        Set ifile = fs.opentextfile(infofile, 1,False)
        kette  = ifile.readline()
        Do While ifile.atendofstream<>True
            If Left(kette,6)="From: " Then
                teststring=Replace(Replace(Replace(kette,"From: ",""),vbCrLf,""),"""","")
                absender=decode_header(Replace(Replace(Replace(kette,"From: ",""),vbCrLf,""),"""",""))
                kette  = ifile.readline()
                Do While (Left(kette,1)=vbTab) Or (Left(kette,1)=" ")
                    'absender = Trim( Replace(absender & decode_header(Trim(kette)),vbCrLf,"" ))
                    absender = absender & " " & Replace(Trim(kette),vbTab,"")
                    kette  = ifile.readline()
                Loop
            ElseIf Left(kette,4)="To: " Then
                empfaenger=decode_header(Replace(Replace(kette,"To: ",""),vbCrLf,""))
                kette  = ifile.readline()
                Do While (Left(kette,1)=vbTab) Or (Left(kette,1)=" ")
                    'empfaenger = empfaenger & decode_header(Trim(kette))
                    empfaenger = empfaenger & " " & Replace(Trim(kette),vbTab,"")
                    kette  = ifile.readline()
                Loop
            ElseIf Left(kette,9)="Subject: " Then
                betreff=decode_header(Replace(Replace(Trim(kette),"Subject:",""),vbCrLf,""))
                kette  = ifile.readline()
                Do While (Left(kette,1)=vbTab) Or (Left(kette,1)=" ")
                    betreff = betreff & decode_header(Trim(kette))
                    kette  = ifile.readline()
                Loop
            ElseIf Left(kette,6)="Date: " Then
                empfangsdatum=decode_header(Replace(Replace(kette,"Date: ",""),vbCrLf,""))
                kette  = ifile.readline()
                Do While (Left(kette,1)=vbTab) Or (Left(kette,1)=" ")
                    empfangsdatum = empfangsdatum & decode_header(Trim(kette))
                    kette  = ifile.readline()
                Loop
            Else
                kette  = ifile.readline()
            End If
        Loop
        mapmailinfo=True
    End If
    ifile.close
End Function



Function termprocess(prozessname)
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='"&prozessname&"'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    z=0
    For Each objItem In colItems
        objItem.Terminate()
        z=z+1
    Next
    Set colItems = Nothing
    Set objWMIService = Nothing
End Function    

Function timeoutprocess(prozessname,timeout)
    startzeit = Now
    jetzt = Now
    ende = DateAdd("s", timeout, Now)
    
    If scriptdebug = True Then
        logtxt = "archivierung.vbs: timeoutprocess berwacht " & prozessname & ", maximale Laufzeit: " & timeout & " Sekunden"
        objWSHShell.LogEvent 0, logtxt
    End If
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='"&prozessname&"'"
    runtime = 0.0
    z = 1
    Do Until (jetzt > ende) Or (z = 0)
        Set colItems = objWMIService.ExecQuery(strQuery,,48)
        z=0
        For Each objItem In colItems
            z=z+1
        Next
        If z <> 0 Then
            WScript.Sleep 250
            jetzt = Now
        End If
        
    Loop
    
    If jetzt < ende Then
        timeoutprocess=False
        If scriptdebug = True Then
            logtxt = "archivierung.vbs: timeoutprocess berwachte " & prozessname & ", Laufzeit: " & DateDiff("s", startzeit,Now)& " Sekunden"
            objWSHShell.LogEvent 0, logtxt
        End If
        
    Else
        timeoutprocess=True
        If scriptdebug = True Then
            logtxt = "archivierung.vbs: timeoutprocess berwachte " & prozessname & ", Laufzeit: " & DateDiff("s", startzeit,Now) & " Sekunden"
            objWSHShell.LogEvent 0, logtxt
        End If
        Set colItems = objWMIService.ExecQuery(strQuery,,48)
        z=0
        For Each objItem In colItems
            objItem.Terminate
        Next
    End If
    Set colItems = Nothing
    Set objWMIService = Nothing
End Function


Function emlconvert(emlfile)
    
    If archofficecolor=True Then
        color=True
    End If
    If defaultresolution="hires" Then
        hires=True
    End If
    
    ' Variablen Initialisierung
    richtung=""
    absender=""
    absenderadresse=""
    empfaenger=""
    cc=""
    bcc=""
    betreff=""
    empfangsdatum=""
    empfangsuhrzeit=""
    versanddatum=""
    versanduhrzeit=""
    'myname=""
    attachmentlist = "" 
    inlineattachments = ""   
    errtxt = ""
    herkunft = "eMail"
    ' emltemp erzeugen, ggfs. leeren    
    If Not fs.folderexists (programm & "emltemp") Then
        fs.createfolder(programm & "emltemp")
    Else
        If fs.folderexists (programm & "emltemp\temp") Then
            For Each file In fs.getfolder(programm & "emltemp\temp").files 
                fs.deletefile file, True
            Next
        End If
    End If
    tempdir=programm & "emltemp\temp"
    
    ' temp-txt Datei falls vorhanden entfernen
    If fs.fileexists(tempname&".txt") Then
        fs.deletefile tempname&".txt", True
    End If
    
    
    
    
    
    cmd = Chr(34) & emlconverter & Chr(34) & " -d " & Chr(34) & tempdir & Chr(34) & " " & Chr(34) &emlfile&Chr(34)
    
    If scriptdebug=True Then
        objWSHShell.LogEvent 0, "archivierung.vbs: bfa_eml_unpacker-Aufruf:" & vbCrLf & cmd
    End If
    ' emlconvert starten
    lngReturnCode = objWSHShell.Run(cmd,0,False)
    
    
    ' bfa_eml_unpacker nach timeout killen
    ' timeout -> ret = True
    ret = timeoutprocess("bfa_eml_unpacker.exe", 20)
    If ret = True Then
        ' msgtext nach 10 Sek. noch nicht durch, Fehler behandeln
        If scriptdebug = True Then
            errtxt = errtxt & "bfa_eml_unpacker timeout" & vbCrLf
            objWSHShell.LogEvent 1, "archivierung.vbs: bfa_eml_unpacker konnte die Datei nicht entpacken"
        End If
        
    Else
        
        ' Mail extrahiert
        ' Header-Daten mappen
        headerfile = tempdir&"\mail_header.txt"
        decode = True
        If fs.fileexists(headerfile) Then
            mapheaderdata(headerfile)
            rawheader = ""
            
            
            Set rawheaderfile = fs.opentextfile(headerfile)
            rawheader = rawheaderfile.ReadAll
            rawheaderfile.close
            
        End If

        
        
        emltempname = Replace(LCase(tempname), LCase(queue), LCase(programm) & "emltemp\temp\",1)
        fromemail=True
        
        
        
        ' html vorhanden?
        If fs.fileexists(emltempname&".html") Then
            ' HTML-Header erzeugen und hinzufgen
            ' rtf vorhanden?
        ElseIf Not fs.fileexists(emltempname&".html") And fs.fileexists(emltempname&".rtf") Then
            ' bei rtf sollte bfa_eml_unpacker immer html erzeugen
            If scriptdebug=True Then
                objWSHShell.LogEvent 0, "archivierung.vbs emlconvert: RTF-E-Mail"
            End If
            removepretag=False
            ' dann bleibt nur txt
        ElseIf fs.fileexists(emltempname&".txt") Then
            removepretag=False
            ' txt nach HTML wandeln
            If scriptdebug=True Then
                objWSHShell.LogEvent 0, "archivierung.vbs emlconvert: Plaintext-E-Mail"
            End If
            ' mailinfo-File Header entfernen, Rest in html packen, mailtext lesen
            mailtext = ""
            Set txtfile = fs.opentextfile(emltempname&".txt",1,False)
            If Not fs.folderexists(programm&"emltemp\temp") Then
                fs.createfolder programm&"emltemp\temp"
            End If
            Set tmptxtfile = fs.opentextfile(emltempname&".html",2,True)
            tmptxtfile.write("<html><head><META http-equiv=Content-Type content=" & Chr(34) & "text/html; charset=ISO-8859-1" & Chr(34) & "></head><body>"&vbCrLf)
            
            Do While txtfile.atendofstream=False
                kette = htmlencode(txtfile.readline)
                tmptxtfile.writeline(kette&vbCrLf&"</br>")
            Loop
            txtfile.close
            tmptxtfile.write("</body></html>"&vbCrLf)
            tmptxtfile.close
        Else
            Set tmptxtfile = fs.opentextfile(emltempname&".html",2,True)
            tmptxtfile.write("<html><head><META http-equiv=Content-Type content=" & Chr(34) & "text/html; charset=ISO-8859-1" & Chr(34) & "></head><body></body></html>"&vbCrLf)      
            tmptxtfile.close
        End If
        
        
        
        
        
        attachmentlist = ""
        Dim attachments(1000)
        
        Dim cid(1000)
        
        ' attachments/cids ermitteln
        If fs.fileexists(programm & "emltemp\temp\AttachmentsTxt.txt") Then
            i = 0
            Set attlist = fs.opentextfile(programm & "emltemp\temp\AttachmentsTxt.txt",1,False,-2)
            kette = " "
            While kette <> "" And attlist.atendofstream=False
                kette=attlist.readline()
                If InStr(1,kette,"|") <> 0 Then
                	trenner = "|"
                Else
                	trenner = ";"
                End If
                If Trim(kette)<>"" Then
                    fname= Trim(Replace(Left(kette,InStr(1,kette,trenner)-1),"filename:",""))
                    cidname = Trim(Right(kette,Len(kette)-InStr(1,kette,trenner)))
                    If fs.fileexists(programm & "emltemp\temp\"&fname) Then
                        attachments(i)=fname
                        If scriptdebug=True Then
                            objwshshell.logevent 1, "archivierung.vbs emlconvert attachment gefunden: " & attachments(i)
                        End If
                        If Trim(cidname)<>"" Then
                            cid(i)=cidname
                        End If
                        attachmentlist=attachmentlist&fname&"; "
                        i=i+1
                    End If
                End If
            Wend
            If scriptdebug=True Then
                objwshshell.logevent 0, "archivierung.vbs emlconvert attachmentlist vor Filtern: " & attachmentlist
            End If
            attlist.close
            fs.deletefile programm & "emltemp\temp\AttachmentsTxt.txt", True
        End If
        
        If Len(attachmentlist)>2 Then
            attachmentlist = Left(attachmentlist,Len(attachmentlist)-2)
        End If
        
        
        If fs.fileexists(emltempname&".html") Then
            ' inline-Attachments korrigieren (cid->Dateiname)
            inlineattachments = findinlineattachments(emltempname&".html","keinunicode")
            Set htmlfile=fs.opentextfile(emltempname&".html",1,False,0)
            Err.Clear
            On Error Resume next
            htmlcode=htmlfile.readall()
            If Err.Number<>0 Then
            	htmlcode = ""
            Else
            	htmlfile.close
           	End If
            attar = Split(inlineattachments, ";")
            For Each att In attar
                
                If Trim(att)<>"" Then
                    
                    For i=0 To UBound(cid)
                        
                        If cid(i)<>Empty Then
                            If InStr(att, cid(i)) Then
                                If InStr(attachmentlist," "&attachments(i)&";")<>0 Then
                                    attachmentlist=Replace(attachmentlist," "&attachments(i)&";","",1,1)
                                ElseIf InStr(attachmentlist,attachments(i)&";")<>0 Then
                                    attachmentlist=Replace(attachmentlist,attachments(i)&";","",1,1)
                                ElseIf InStr(attachmentlist,attachments(i))<>0 Then
                                    attachmentlist=Replace(attachmentlist,attachments(i),"",1,1)	
                                End If
                                ' attachmentlist=Replace(attachmentlist,attachments(i),"",1,1)
                                htmlcode=Replace(htmlcode,att,"file:///"&programm&"\EMLTemp\temp\"&attachments(i))
                                ' inline-attachments aus attachmentarray entfernen
                                If scriptdebug = True Then
                                    objwshshell.logevent 0, "archivierung.vbs emlconvert inline Attachment entfernt:" & vbCrLf & "list: " &attachmentlist & vbCrLf & att &vbCrLf & cid(i)
                                End If
                                attachments(i)=""
                                Exit For
                            End If
                        End If
                    Next
                End If
            Next
            
            i=0
            ' Inline-Attachments auch im HTML-Code suchen
            If filterinlineattachments=True Then
                For Each att In attachments
                    If att<> "" And IsInArray(att, attar) Or IsInArray("cid:"&att, attar) Then
                        If InStr(attachmentlist,att&";")<>0 Then
                            attachmentlist=Replace(attachmentlist,att&";","",1,1)
                        ElseIf InStr(attachmentlist,att)<>0 Then
                            attachmentlist=Replace(attachmentlist,att,"",1,1)	
                        End If
                        
                        If IsInArray("cid:"&att, attar) Then
                            If InStr(htmlcode, "src="&Chr(34)&"cid:"&att) <> 0 Then
                                htmlcode=Replace(htmlcode,"src="&Chr(34)&"cid:"&att,"src="&Chr(34)&"file:///"&programm&"\EMLTemp\temp\"&att)
                            ElseIf InStr(htmlcode, "src='cid:"&att) <> 0 Then
                                htmlcode=Replace(htmlcode,"src='cid:"&att,"src='file:///"&programm&"\EMLTemp\temp\"&att)
                            End If
                        End If
                        attachments(i)=""
                    End If
                    i = i + 1
                Next
            End If
            
            If scriptdebug = True Then
                For Each att In attachments
                    If Trim(att) <> "" And scriptdebug=True Then
                        objwshshell.logevent 1, "archivierung.vbs emlconvert nach inline Attachment-Filtern:" & att
                    End If
                Next
            End If
            
            linkattachment = False
            ' nur ausfhren wenn linkattachment noch false ist, sonst wird der Link gesetzt
            For Each att In attachments
                
                If Trim(att) <> "" And linkattachment = False Then
                    ' nur wenn attachments generell archiviert werden
                    If scriptdebug = True Then
                        objwshshell.logevent 1, "archivierung.vbs (1) emlconvert filter Attachment " & att
                    End If
                    If dontExtractMsgAttachments = False Then
                        ' wenn whitelist gesetzt ist, prfen ob attachment auf whitelist steht
                        If Trim(emailwhite) <> "" Then
                            dotpos = InStrRev(att,".")
                            ' wenn fname extension in whitelist linkattachment true setzen
                            If InStr(1, emailwhite, Right(att, Len(att)-dotpos),1) <> 0 Then
                                linkattachment = True
                                Exit For
                            End If
                            ' wenn blacklist gesetzt ist (und whitelist leer), prfen ob auf blacklist steht
                        ElseIf emailblack <> "" Then
                            ' wenn fname extension nicht in blacklist linkattachment true setzen
                            dotpos = InStrRev(att,".")
                            If InStr(1, emailblack, Right(att, Len(att)-dotpos), 1) = 0 Then
                                linkattachment = True
                                Exit For
                            End If
                        Else 
                            linkattachment = True
                            Exit For
                        End If
                    End If
                End If
            Next    
            
            
            attachmentlist = Trim(attachmentlist)
            If scriptdebug=True Then
                objwshshell.logevent 0, "archivierung.vbs emlconvert attachmentlist nach Filtern: " & attachmentlist
            End If
            ' HTML Header ergnzen
            mailheader = ""
            mailheader = mailheader & "<hr noshade color=""black"" size=""3"" align=""left"">" &vbCrLf&"<table>"
            rowtemplate = "<tr><td style='vertical-align:top;font-size:10.0pt;font-family:""Arial"";font-weight:bold;border-top: none; border-bottom: none; border-left: none; border-right: none; padding-top: 0cm; padding-bottom: 0.1cm; padding-left: 0.1cm; padding-right: 0cm'>%name%:</td><td style='vertical-align:top;font-size:10.0pt;font-family:""Arial"";border-top: none; border-bottom: none; border-left: none; border-right: none; padding-top: 0cm; padding-bottom: 0.1cm; padding-left: 0.1cm; padding-right: 0cm'>%value%</td></tr>"
            mailheaderend = "</table>"
            mailheadertxt = ""	
            'If absender <> "" Then
            absenderhtml=absender
            absenderhtml=htmlencode(absenderhtml)
            row = Replace(Replace(rowtemplate,"%name%","Von"),"%value%",absenderhtml)& vbCrLf
            mailheader = mailheader & row
            mailheadertxt=mailheadertxt&"Absender: "& absender
            'End If
            
            
            
            'If empfaenger <> "" Then
            empfaengerhtml=empfaenger
            empfaengerhtml=htmlencode(empfaengerhtml)
            row = Replace(Replace(rowtemplate,"%name%","An"),"%value%",empfaengerhtml)
            mailheader = mailheader & row
            mailheadertxt=mailheadertxt&"Empfnger: "& empfaenger
            
            If cc<>"" Then
                cchtml=cc
                cchtml=htmlencode(cchtml)
                row = Replace(Replace(rowtemplate,"%name%","CC"),"%value%",cchtml)
                mailheader = mailheader & row
                mailheadertxt=mailheadertxt&"CC: "& cc
            End If
            
            If bcc<>"" Then        
                bcchtml=bcc
                bcchtml=htmlencode(bcchtml)
                row = Replace(Replace(rowtemplate,"%name%","BCC"),"%value%",bcchtml)
                mailheader = mailheader & row
                mailheadertxt=mailheadertxt&"BCC: "& bcc
            End If  
            
            If empfangsdatum <> "" Then
                richtung="Eingang"
                empfangsdatumhtml=empfangsdatum & " " & empfangsuhrzeit
                empfangsdatumhtml=htmlencode(empfangsdatumhtml)
                'row = Replace(Replace(rowtemplate,"%name%","Empfangen"),"%value%",empfangsdatumhtml)
                row = Replace(Replace(rowtemplate,"%name%","Empfangen"),"%value%",htmlencode(empfangsdatum)&" "&htmlencode(empfangsuhrzeit))
                mailheader = mailheader & row
                mailheadertxt=mailheadertxt&"Empfangen: "& empfangsdatum & " " & empfangsuhrzeit
            Else
                richtung="Ausgang"
            End If
            
            If versanddatum <> "" Then
                versanddatumhtml=versanddatum & " " & versanduhrzeit
                versanddatumhtml=htmlencode(versanddatumhtml)
                'row = Replace(Replace(rowtemplate,"%name%","Gesendet"),"%value%",versanddatumhtml)
                row = Replace(Replace(rowtemplate,"%name%","Gesendet"),"%value%",htmlencode(versanddatum)&" "&htmlencode(versanduhrzeit))
                mailheader = mailheader & row
                mailheadertxt=mailheadertxt&"Empfangen: "& versanddatum & " " & versanduhrzeit
            End If    
            
            If betreff <> "" Then
                betreffhtml=betreff
                row = Replace(Replace(rowtemplate,"%name%","Betreff"),"%value%",htmlencode(betreffhtml))
                mailheader = mailheader & row
                mailheadertxt=mailheadertxt&"Betreff: "& htmlencode(betreffhtml)
            End If
            If attachmentlist <> "" Then
                attachmentlisthtml=attachmentlist
                attachmentlist = Replace(attachmentlist,";","; ")
                row = Replace(Replace(rowtemplate,"%name%","Anlagen"),"%value%",htmlencode(attachmentlisthtml))
                mailheader = mailheader & row
                mailheadertxt=mailheadertxt&"Anlagen: "& htmlencode(attachmentlisthtml)
            End If
            
            
            
            mailheader = mailheader & mailheaderend & "</br></br>"
            
            bodytagstart = InStr(1,LCase(htmlcode),"<body")
            
            
            
            
            ' Position nach Body-Tag finden, um dort den Mailheader zu platzieren
            If bodytagstart=0 Then
                metatagstart = InStr(1,LCase(htmlcode),"<meta")
                If metatagstart = 0 Then
                    newhtml = mailheader & htmlcode
                Else
                    metatagend = InStr(metatagstart, htmlcode,">")
                    metatag = Mid(htmlcode,metatagstart, metatagend-metatagstart+1)
                    newhtml = Left(htmlcode,metatagstart-1) & metatag & mailheader & Right(htmlcode,Len(htmlcode)-metatagend)
                End If
            Else
                bodytagend = InStr(bodytagstart, htmlcode,">")
                bodytag = Mid(htmlcode,bodytagstart, bodytagend-bodytagstart+1)
                newhtml = Left(htmlcode,bodytagstart-1) & bodytag & mailheader & Right(htmlcode,Len(htmlcode)-bodytagend)
            End If
            
            
            htmlhead = "<META http-equiv=Content-Type content=" & Chr(34) & "text/html; charset=utf-8" & Chr(34) & ">"&vbCrLf
            If InStr(LCase(newhtml), "<meta") = 0 Then
                newhtml = htmlhead + newhtml
            End If
            
            Set htmlfile = fs.opentextfile(emltempname&".html",2,True,0)
        	Err.Clear
            htmlfile.write(newhtml)
            If Err.Number <> 0 Then
            	htmlfile.close
            	Set htmlfile = Nothing
            	Set htmlfile = fs.opentextfile(emltempname&".html",2,True,-1)
            	htmlfile.write(newhtml)
            End If
            
            htmlfile.close
            
            
            
            If removepretag=True And fs.fileexists(programm & "bfa_remove_pre.exe") Then
                cmd = Chr(34) & programm & "bfa_remove_pre.exe" & Chr(34) & " " & Chr(34) & emltempname&".html" & Chr(34) & " " & Chr(34) & emltempname&".html.tmp" & Chr(34)
                lngReturnCode = objWSHShell.Run(cmd ,0,False)
                ret = timeoutprocess("bfa_remove_pre.exe",20)
                If ret = True Then
                    objWSHShell.LogEvent 1, "archivierung.vbs: emlconvert: bfa_remove_pre.exe Timeout"
                Else
                    If fs.fileexists(emltempname&".html.tmp") Then
                        fs.deletefile emltempname&".html"
                        fs.movefile emltempname&".html.tmp", emltempname&".html"
                    End If
                End If
            End If
            
        Else
            objWSHShell.LogEvent 1, "archivierung.vbs: Bei der E-Mailverarbeitung ist ein Fehler aufgetreten, es wurde kein HTML erzeugt."
            GetGarbage(tempname)
            Unlock(programm&lockdatei)
            WScript.Quit
        End If
    End If
    
    ' Mailverknpfung erzeugen wenn noch attachments vorhanden (inline sind raus)
    If linkattachment = True Then
        For iLink = 0 To limit
            If linkspeicher(iLink) = "" Then
                datumsstring=""
                If empfangsdatum <> "" And empfangsuhrzeit <> "" Then
                    datumsstring = "_" & empfangsdatum&"_"&empfangsuhrzeit
                ElseIf versanddatum <> "" And versanduhrzeit <> "" Then
                    datumsstring = "_" & versanddatum&"_"&versanduhrzeit
                End If
                linkspeicher(iLink) = "Email: " &betreff & datumsstring
                Exit For
            End If
        Next            
    End If
    
    
    ' Hier haben wir die fertige html-Voransicht mit Header, attachments etc...
    ' html-Konvertierung mit wkhtmltopdf und PDFtoColorTIF oder PDFtoTIF
    If fs.fileexists(emltempname&".html") Then
        If htmlconverter <> "" Then
            cwd = objwshShell.CurrentDirectory
            objwshShell.CurrentDirectory = programm & "emltemp\temp"
            f = fs.getbasename(emltempname&".html")&".html"
            If loadimages Then
                cmd = Chr(34) & htmlconverter & Chr(34) & " --disable-javascript " & f & " " & Chr(34) & emltempname&".pdf" & Chr(34)
            Else 
                cmd = Chr(34) & htmlconverter & Chr(34) & " --disable-javascript --no-images " & f & " " & Chr(34) & emltempname&".pdf" & Chr(34)
            End If
            
            lngReturnCode = objWSHShell.Run(cmd ,0,False)
            ret = timeoutprocess("wkhtmltopdf.exe",180)
            If ret = True Then
                objWSHShell.LogEvent 1, "archivierung.vbs: emlconvert: wkhtmltopdf.exe Timeout"
            End If
            

            If fs.fileexists(emltempname&".pdf") Then
                olddateiname = dateiname
                dateiname = emltempname&".pdf"
                If emailcolor="" Then
                    If color=True Then
                        PDFtoColorTIF(emltempname)
                    Else
                        PDFtoTIF(emltempname)
                    End If
                Else
                    If emailcolor="color" Then
                        color=True
                        PDFtoColorTIF(emltempname)
                    ElseIf emailcolor="bw" Then
                        color = False
                        PDFtoTIF(emltempname)
                    ElseIf emailcolor="grey" Then
                        archpdfincolor="grey"
                        PDFtoColorTIF(emltempname)
                    End If
                End If
                ' Text aus PDF holen
                
                lngReturnCode = objWSHShell.Run(Chr(34)&programm&"PDFtoTXT.bat"&Chr(34)&" "&Chr(34)&emltempname&".pdf"&Chr(34),0,True)
                If fs.fileexists(emltempname&".txt") Then
                    If fs.fileexists(tempname&".txt") Then
                        fs.deletefile tempname&".txt"
                    End If
                    Set mytemptextfile = fs.createtextfile(tempname&".txt",True)
                    Set mypdftxtfile = fs.opentextfile(emltempname&".txt")
                    
                    If ftxaddrawheader=True Then
                        emltxt = rawheader
                    Else
                        emltxt = ""
                    End If
                    
                    emltxt = emltxt & vbCrLf & mypdftxtfile.readall
                    mytemptextfile.write(emltxt)
                    mytemptextfile.close
                    mypdftxtfile.close
                    Typ="TXT"
                Else
                    Typ="OMP"
                End If
                
                
                
                
                
                fs.deletefile emltempname&".html"
                fs.deletefile emltempname&".pdf"
                dateiname = olddateiname
                If fs.fileexists(emltempname&"-archiv.tif") Then
                    fs.movefile emltempname&"-archiv.tif", tempname&"-archiv.tif"
                    archivtif=tempname&"-archiv"
                End If
                If fs.fileexists(emltempname&".tif") Then
                    fs.movefile emltempname&".tif", tempname&".tif"
                Else
                    ' Fehler loggen, Fehlerbehandlung
                    objWSHShell.LogEvent 1, "archivierung.vbs: emlconvert: konnte aus pdf kein Tif erzeugen, Keine Voransicht..."
                    makefilltif(tempname)
                End If
            Else
                objWSHShell.LogEvent 1, "archivierung.vbs: emlconvert: htmlconverter konnte kein pdf erzeugen, Keine Voransicht..."
                makefilltif(tempname)
            End If
            
        Else
            objWSHShell.LogEvent 1, "archivierung.vbs: Fehler in emlconvert, kein htmlconverter vorhanden."
            makefilltif(tempname)
        End If
        
        ' extension fr die weitere Verarbeitung wieder auf msg setzen
        extension=".eml"
        
    Else
        ' KEIN HTML -> FEHLERBEHANDLUNG!!!
        objWSHShell.LogEvent 1, "archivierung.vbs: msg-Datei konnte nicht verarbeitet werden, keine Voransicht verfgbar"
        makefilltif(tempname)
    End If
    
    If Not (dontExtractMsgAttachments) And (Not changeling) And (InStr(Filtermakro,"fromoutlook")=0) Then
        
        For Each att In attachments
            If Trim(att)<>"" Then
                attpath = programm & "emltemp\temp\"&att
                dontarch = False
                If linkdoubleattachments=True Then
                    If fs.fileexists(programm & "addlink.exe") Then
                        ' jetzt sha-summe in db suchen
                        ' wenn gefunden -> dem gefundenen Dokument aktuelle Email-Verknpfung mitgeben, wenn konfiguriert
                        ' aktuelle Verknpfung in linkspeicher(iLink) 
                        shasum = Pruefsumme(attpath)
                        If shasum = "" Then
                            objWSHShell.LogEvent 1, "archivierung.vbs: sha-Summe des attachments konnte nicht erzeugt werden."
                            founddocs = False
                        Else
                            founddocs = find_doc_by_sha1(shasum)	
                            If scriptdebug=True Then
                                objWSHShell.LogEvent 1, "archivierung.vbs: sha-Summe des attachments: " & vbCrLf & shasum
                                objWSHShell.LogEvent 1, "archivierung.vbs: sha-Summe in Archiven gesucht: " & vbCrLf & founddocs
                            End If
                        End If
                        If founddocs = False Then
                            dontarch = False
                        Else
                            docs = Split(founddocs,vbCrLf)
                            haserror = False
                            For Each doc In docs
                                If doc <> "" Then
                                    parts = Split(doc," ")
                                    gdocid = parts(0)
                                    cmd = programm & "addlink.exe " & profil & " " & gdocid & " " & Chr(34)&Replace(linkspeicher(iLink),Chr(34),"")&Chr(34)
                                    Set oExec = objWSHShell.Exec(cmd)
                                    strinput = ""
                                    strerrinput = ""
                                    Do While Not oExec.StdOut.AtEndOfStream
                                        strinput = strinput & oExec.StdOut.Read(1)	
                                    Loop
                                    strerrinput=""
                                    Do While Not oExec.StdErr.AtEndOfStream
                                        strerrinput = strerrinput & oExec.StdErr.Read(1)	
                                    Loop 
                                    If Len(strerrinput) > 0 Then
                                        objWSHShell.LogEvent 1, "archivierung.vbs Fehler beim Aufruf von addlink.exe."&vbCrLf&"Fehler:"&vbCrLf&strerrinput
                                        haserror = True
                                    End If
                                End If
                            Next
                            If haserror=False Then
                                dontarch=True
                            End If
                        End If
                    Else
                        objWSHShell.LogEvent 1, "archivierung.vbs Fehler: Email-Attachment konnte nicht verlinkt werden, da addlink.exe fehlt. Attachment wird daher archiviert."
                    End If
                    
                End If
                If dontarch = False Then
                    sJobname = getfifo(queue, "temp-msg")
                    Set swdfile = fs.opentextfile(sJobname & ".slw",8,True)
                    swdfile.writeline "Dateiname=" & fs.getbasename(att)
                    swdfile.close
                    
                    fs.Copyfile tempname & ".job", sJobname & ".job", True
                    target = sJobname & "."& fs.GetExtensionName(att)
                    
                    fs.copyfile attpath, target, True
                    WScript.Sleep 250
                    oldtyp = Typ
                    oldtitel = title
                    Typ = ""
                    If Not writeemailjob(sJobname) Then
                        objWshShell.LogEvent 1, "Fehler beim Schreiben einer Jobdatei fr ein Attachment"
                        If Not fs.fileexists(sJobname & ".job") Then
                            fs.deletefile sJobname & ".swd", True
                            fs.deletefile sJobname & sExt, True
                            Err.Clear
                        End If 
                    End If
                    Typ = oldtyp
                End If
            End If			                    
        Next
    End If
End Function

Function decode_header(headerstr)
    decode_header = ""
    
    cmd = Chr(34) & programm &"decode_header.exe" &Chr(34) & " " & Chr(34) & headerstr & Chr(34)
    Set oExec = objWSHShell.Exec(cmd)
    strinput = ""
    Do While Not oExec.StdOut.AtEndOfStream
        strinput = strinput & oExec.StdOut.Read(1)	
    Loop
    strerrinput=""
    Do While Not oExec.StdErr.AtEndOfStream
        strerrinput = strerrinput & oExec.StdErr.Read(1)	
    Loop    
    If Trim(strinput)<>"" Then
        decode_header=Trim(Replace(strinput,vbCrLf,""))
    End If 
    'Loop
End Function    

Function autorotatetif(tif,pageorientation)
    ' in pageorientation steht pro Seite die Drehung nach links in Grad
    dorotate=False
    For i = 0 To UBound(pageorientation)
        If (pageorientation(i)<>"0" And pageorientation(i)<>"") Then
            dorotate=True
            Exit For
        End If
    Next
    
    
    If dorotate=True Then
        erfolg=True
        ' bctemp-Verzeichnis anlegen
        zahl = Zufallszahl(0,99999)
        strPfadQueue = ""
        strPfadTemp = programm&"BCTemp\"
        If Not fs.FolderExists(strPfadTemp) Then
            Set test = fs.CreateFolder(strPfadTemp)
            Set test = Nothing
            WScript.sleep 200
            If Err.number<>0 Then
                objWshShell.LogEvent 1, "archivierung.vbs(autorotatetif a): kann verzeichnis nicht erstellen - Berechtigung?" & strPfadTemp
                Err.clear
            End If 
            
            If Not fs.FolderExists(strPfadTemp) Then
                objWshShell.LogEvent 1, "archivierung.vbs(autorotatetif b): kann verzeichnis nicht erstellen (2) - Berechtigung?"& strPfadTemp
                erfolg=False
            End If
        End If
        strPfadTemp=strPfadTemp&zahl&"\"	
        If Not fs.FolderExists(strPfadTemp) Then
            Set test = fs.CreateFolder(strPfadTemp)
            Set test = Nothing
            WScript.sleep 200
            If Err.number<>0 Then
                objWshShell.LogEvent 1, "archivierung.vbs(autorotatetif c): kann verzeichnis nicht erstellen - Berechtigung?" & strPfadTemp
                Err.clear
            End If 
            If Not fs.FolderExists(strPfadTemp) Then
                objWshShell.LogEvent 1, "archivierung.vbs(autorotatetif d): kann verzeichnis nicht erstellen (2) - Berechtigung?" & strPfadTemp
                erfolg=False
            End If
        End If
        If erfolg = True Then
            ' Tif kopieren und splitten
            tifname = Replace(LCase(tempname), LCase(queue), "",1)
            fs.copyfile tif, strPfadTemp&tifname&".tif", True
            
            If Err.number<>0 Then
                objWshShell.LogEvent 1, "archivierung.vbs(autorotatetif e): kann Tif-Datei nicht kopieren" & vbCrLf & tif & vbCrLf & strPfadTemp&tifname&".tif"  & vbCrLf & Err.Description
                Err.clear
                erfolg = False
            End If 
        End If
        
        If erfolg = True Then
            lngReturnCode = objWSHShell.Run(programm&"split.bat "&strPfadTemp&tifname&".tif",0,True)
            
            If lngReturnCode <> 0 Then
                objWshShell.LogEvent 1, "archivierung.vbs(autorotatetif f): Fehler beim Splitten" & vbCrLf & strPfadTemp&tifname&".tif"
                erfolg = False
            End If
        End If
        
        WScript.sleep 100
        
        If erfolg = True Then
            fs.deletefile strPfadTemp&tifname&".tif", True
            
            If Err.number<>0 Then
                objWshShell.LogEvent 1, "archivierung.vbs(autorotatetif g): kann Tif-Datei nicht lschen" & vbCrLf & strPfadTemp&tifname&".tif" & vbCrLf & Err.Description
                Err.clear
                erfolg = False
            End If 
        End If
        
        
        If erfolg=True Then
            ReDim filenames(1000)
            anzahlfiles = 0
            For o=0 To 1000
                filenames(o) = ""
            Next
            Set folder = fs.GetFolder(strPfadTemp)
            
            For Each file In folder.files 
                If LCase(Right(file,3)) = "tif" Then
                    index = Mid(file.name,InStr(1,file.name,"page")+4,Len(file.name) - 	InStr(1,file.name,"page") - 7)
                    filenames(strconvert(index)) = file.name
                    anzahlfiles = anzahlfiles +1
                End If
            Next
        End If
        
        ' Seiten einzeln drehen
        For i = 0 To UBound(pageorientation)
            If (pageorientation(i)<>"0" And pageorientation(i)<>"") Then
                If fs.fileexists(strPfadTemp&filenames(i)) Then
                    mycommandfile=temp&"rotatecommand.txt"
                    If fs.fileexists(mycommandfile) Then
                        fs.deletefile mycommandfile, True
                        If Err.number<>0 Then
                            objWshShell.LogEvent 1, "archivierung.vbs(autorotatetif h): Kann alte rotatecommand.txt nicht lschen."
                            Err.clear
                            erfolg=False
                            On Error Resume Next
                        End If
                    End If
                    
                    Set commandfile = fs.OpenTextFile(mycommandfile,8,True)
                    commandfile.writeline "Rot="&(360-CInt(pageorientation(i)))
                    commandfile.close
                    Set commandfile=Nothing
                    WScript.Sleep 50
                    
                    
                    lngReturnCode = runfilter(strPfadTemp&filenames(i),mycommandfile,strPfadTemp&"rot_"&filenames(i))
                    If lngReturnCode<>0 Then
                        If fs.fileexists(strPfadTemp&"rot_"&filenames(i)) Then
                            fs.deletefile strPfadTemp&"rot_"&filenames(i), True
                            fs.movefile strPfadTemp&filenames(i), strPfadTemp&"rot_"&filenames(i)
                        Else
                            fs.movefile strPfadTemp&filenames(i), strPfadTemp&"rot_"&filenames(i)
                        End If
                    Else
                        If fs.fileexists(strPfadTemp&"rot_"&filenames(i)) Then
                            fs.deletefile strPfadTemp&filenames(i), True
                        End If
                    End If
                    fs.deletefile mycommandfile, True
                End If
            ElseIf pageorientation(i)="0" Then
                fs.movefile strPfadTemp&filenames(i), strPfadTemp&"rot_"&filenames(i)
            End If
        Next
        
        ' prfen ob alle Seiten da sind	
        ReDim filenames(1000)
        newanzahlfiles = 0
        For o=0 To 1000
            filenames(o) = ""
        Next
        Set folder = fs.GetFolder(strPfadTemp)
        
        For Each file In folder.files 
            If LCase(Right(file,3)) = "tif" Then
                index = Mid(file.name,InStr(1,file.name,"page")+4,Len(file.name) - 	InStr(1,file.name,"page") - 7)
                filenames(strconvert(index)) = file.name
                newanzahlfiles = newanzahlfiles +1
            End If
        Next
        
        If anzahlfiles<>newanzahlfiles Then
            objWSHShell.LogEvent 1, "archivierung.vbs(autorotatetif i): Fehler bei splitten/mergen, Anzahl Seiten stimmt nicht berein."&vbCrLf&"Das Tif-Dokument wird ohne autorotate archiviert..."
            erfolg=False
        End If
        
        ' Seiten wieder zusammenmergen
        If erfolg=True Then
            rotatedtif=strPfadTemp&"rotated.tif"
            
            If fs.fileexists(strPfadTemp&filenames(0)) Then
                fs.movefile strPfadTemp&filenames(0), rotatedtif
            Else
                erfolg=False
            End If
            
            mergecounter=1
            For i = 1 To 1000
                If filenames(i)<>"" Then
                    lngReturnCode = objWSHShell.Run(programm&"splitterv3.exe -a " & rotatedtif & " " & strPfadTemp&filenames(i),0,True)
                    If lngReturnCode<>0 Then
                        erfolg=False
                    Else
                        mergecounter=mergecounter+1
                    End If
                Else
                    Exit For
                End If
            Next
            
            If mergecounter<>anzahlfiles Then
                objWSHShell.LogEvent 1, "archivierung.vbs(autorotatetif j): Fehler bei splitten/mergen, Anzahl Seiten stimmt nicht berein."&vbCrLf&"Das Tif-Dokument wird ohne autorotate archiviert..."
                erfolg=False
            End If
        End If
        
        If erfolg=True Then
            
            fs.movefile rotatedtif, tif&".tmp"
            If fs.fileexists (tif&".tmp") Then
                fs.deletefile tif, True
                fs.movefile tif&".tmp", tif
            End If
        End If
        
        ' bctemp aufrumen	
        Set folder = fs.GetFolder(strPfadTemp)
        For Each file In folder.files
            fs.deletefile file, True
            If Err.number<>0 Then
                objWshShell.LogEvent 1,"archivierung.vbs(autorotatetif k): kann datei nicht lschen."&file
                
            End If
        Next
        Set folder=Nothing
        WScript.sleep 500
        strPfadTemp=Left(strPfadTemp,Len(strPfadTemp)-1)
        
        fs.deletefolder strPfadTemp, True
        If Err.number<>0 Then
            objWshShell.LogEvent 1,"archivierung.vbs(autorotatetif k): kann Ordner nicht lschen."&strPfadTemp
            
        End If
    End If
    
End Function    


Function IsInArray(strIn, arrCheck)
    bFlag = False
    If IsArray(arrCheck) And Not IsNull(strIn) Then
        Dim i
        For i = 0 To UBound(arrCheck)
            If LCase(arrcheck(i)) = LCase(strIn) Then
                bFlag = True
                Exit For
            End If
        Next
    End If
    IsInArray = bFlag
End Function  



Public Function ConvertHTMLtoText(ByVal strHTML)
    If InStr(1,strHTML,"<") > 0 Then
        Do
            startVariable = InStr(1,strHTML,"<")
            
            endVariable = InStr(startVariable,strHTML,">")
            varName = Mid(strHTML,startVariable, endVariable-startVariable+1)
            strHTML = Replace(strHTML,varName,"")
        Loop While InStr(1,strHTML,"<") > 0
    End If
    strHTML = Replace(strHTML,"&gt;","")
    strHTML = Replace(strHTML,"&lt;","")
    strHTML = Replace(strHTML,"&szlig;","")
    ConvertHTMLtoText = strHTML
End Function 

'zhlt die vorkommen eines Zeichens innerhalb einer Zeichenkette
Function CharCount(kette, zeichen)
    Int iHit = 0
    For iCounter = 1 To Len(kette)
        If Mid(kette, iCounter, 1) = zeichen Then
            iHit = iHit + 1
        End If
    Next 
    CharCount = iHit
End Function  

'Prft ob eine Auflsungsrichtlinie fr das bergebene
'Archiv existiert und die bergebene Tif Datei dieser
'richtlinie entspricht
Sub handledirective(archiv, tiffilename)
    '---------------------------------------------------------------------------------------------------------------------------------------------
    'Arrays fr Auflsungsrichtlinien
    'Es gilt: Feld 0 Richtlinie fr Schwarz Weiss
    '         Feld 1 Richtlinie fr Graustufen
    '         Feld 2 Richtlinie fr Farb-Tifs
    Dim dpiXmin(2)
    Dim dpiXmax(2)
    Dim dpiYmin(2)
    Dim dpiYmax(2)
    
    'initialisieren der Arrays
    For iCnt = 0 To 2 Step 1
        dpiXmin(iCnt) = ""
        dpiXmax(iCnt) = ""
        dpiYmin(iCnt) = ""
        dpiYmax(iCnt) = ""
    Next
    
    arccounter = 0
    SectionGefunden = False
    sLine = ""
    isGlobal = False
    sArc = ""
    sArc2 = ""
    'Variablen zur Entgegennahme von Ausgabewerten CountPages
    pages = 0
    dpiX = 0
    dpiY = 0
    compression = ""
    colorDepth = 0
    stemp = ""
    strict = True
    kill = True
    bordercount = 0
    
    'Falls jemand in Main die Funktion aufruft und dort die Prfung auf 
    'Vorhandensein der Datei vergisst
    If Not fs.FileExists(programm&"Directives.ini") Then
        objWSHShell.LogEvent 1, "Richtliniendatei nicht existent. Tif Datei wird normal verarbeitet."
        Exit Sub
    End If
    
    'Einlesen der Richtlinien fr bergebenes Archiv
    Set inifile = fs.OpenTextFile(programm&"Directives.ini")
    
    'Suchen der Konfiguration fr das bergebene Archiv
    Do While Not SectionGefunden
        sLine = inifile.ReadLine
        If InStr(sLine, ";") <> 0 Then sline = Left(sLine, InStr(sLine, ";") - 1)
        
        strict = (InStr(sLine, "*") = 0)
        If Not strict Then
            sArc2 = Right(Trim(sline), Len(Trim(sLine)) - 1)
            sArc2 = Left(Trim(sArc2), InStr(Trim(sArc2), "*") - 1)
        End If
        If ((Trim(sLine) = "["&archiv&"]") Or (LCase(Trim(sLine)) = "[global]")) And strict Then
            SectionGefunden = True
            sArc = sLine
            If LCase(Trim(sLine)) = "[global]" Then
                isGlobal = True
            Else
                isGlobal = False
            End If
        ElseIf ((InStr(archiv, sArc2) = 1) Or (LCase(Trim(sLine)) = "[global]")) And Not strict Then
            SectionGefunden = True
            arccounter = 1
            sArc = sLine
            If LCase(Trim(sLine)) = "[global]" Then
                isGlobal = True
            Else
                isGlobal = False
            End If
        End If
        
        If (strict And archiv = sArc) Or (Not strict And Left(archiv, Len(sArc2)) = sArc2) Then
            For iCnt = 0 To 2 Step 1
                dpiXmin(iCnt) = 0
                dpiXmax(iCnt) = 0
                dpiYmin(iCnt) = 0
                dpiYmax(iCnt) = 0
            Next
        End If
    Loop
    
    'Fr das Archiv wurde keine Richtlinie gefunden
    'Also darf das tif normal verarbeitet werden
    If Not SectionGefunden Then
        Exit Sub
    End If
    
    'Einlesen der Auflsungsrichtlinien des bergebenen Archivs
    sLine = ""
    If SectionGefunden Then
        Do While True
            
            If InStr(1, LTrim(sLine), "[", 1) <> 0 Then sArc = sLine
            
            strict = (InStr(sArc, "*") = 0)
            
            If Not strict And (InStr(1, LTrim(sLine), "[", 1) <> 0) Then
                sArc2 = Right(Trim(sline), Len(Trim(sLine)) - 1)
                sArc2 = Left(Trim(sArc2), InStr(Trim(sArc2), "*") - 1)
            End If
            
            isGlobal = (LCase(sArc) = "[global]")
            
            If inifile.AtEndOfStream Then
                Exit Do
            End If 
            
            stemp = sLine
            
            sLine = inifile.ReadLine
            
            If InStr(sLine, ";") <> 0 Then sLine = Left(sLine, InStr(sLine, ";") - 1)
            'Wenn zwei sections aufeinader folgen und die erstere dem archiv entspricht
            'aber fr erstere keine Richtlinien definiert sind, dann Arrays resetten
            If ((InStr(stemp, "[") <> 0) And (InStr(sLine, "[") <> 0) And strict And archiv = sArc) Or ((InStr(stemp, "[") <> 0) And (InStr(sLine, "[") <> 0) And Not strict And (Left(archiv, Len(sArc2)) = sArc2)) Then
                For iCnt = 0 To 2 Step 1
                    dpiXmin(iCnt) = 0
                    dpiXmax(iCnt) = 0
                    dpiYmin(iCnt) = 0
                    dpiYmax(iCnt) = 0
                Next
            End If 
            
            If InStr(sLine, "BordersX1") <> 0 Then
                If Right(sLine, Len(sLine)-10) <> "" Then
                    sTemp = Right(sLine, Len(sLine) - InStr(sLine, "="))
                    'Unterscheidung. Wenn Arrayzelle Leerstring enthlt und global Section gefunden
                    'dann DPI Wert bernehmen. Ansonsten wenn Section gefunden und NICHT global dann
                    'Arrayzelle mit aktuellem Wert berschreiben!
                    If isGlobal And dpiXmin(0) = "" Then
                        dpiXmin(0) = CInt(Left(sTemp, InStr(sTemp, "-") - 1))
                    ElseIf (Not isGlobal And sArc = "["&archiv&"]" And strict) Or (Not isGlobal And (InStr(archiv, Arc2) = 1) And Not strict) Then
                        dpiXmin(0) = CInt(Left(sTemp, InStr(sTemp, "-") - 1))
                    End If
                    If isGlobal And dpiXmax(0) = "" Then
                        dpiXmax(0) = CInt(Right(sTemp, Len(sTemp) - InStr(sTemp,"-")))
                    ElseIf (Not isGlobal And sArc = "["&archiv&"]" And strict) Or (Not isGlobal And (InStr(archiv, Arc2) = 1) And Not strict) Then
                        dpiXmax(0) = CInt(Right(sTemp, Len(sTemp) - InStr(sTemp,"-")))
                    End If
                End If
            ElseIf ((InStr(sLine, "BordersX1") = 0) And strict And (sArc = "["&archiv&"]")) Or ((InStr(sLine, "BordersX1") = 0) And Not strict And (Left(archiv, Len(sArc2)) = sArc2)) Then
                If dpiXmax(0) = "" Then dpiXmax(0) = 0
                If dpiXmin(0) = "" Then dpiXmin(0) = 0
            End If
            If InStr(sLine, "BordersY1") <> 0 Then
                If Right(sLine, Len(sLine)-10) <> "" Then
                    sTemp = Right(sLine, Len(sLine) - InStr(sLine, "="))
                    If isGlobal And dpiYmin(0) = "" Then
                        dpiYmin(0) = CInt(Left(sTemp, InStr(sTemp, "-") - 1))
                    ElseIf (Not isGlobal And sArc = "["&archiv&"]" And strict) Or (Not isGlobal And (InStr(archiv, Arc2) = 1) And Not strict) Then
                        dpiYmin(0) = CInt(Left(sTemp, InStr(sTemp, "-") - 1))
                    End If
                    If isGlobal And dpiYmax(0) = "" Then
                        dpiYmax(0) = CInt(Right(sTemp, Len(sTemp) - InStr(sTemp,"-")))
                    ElseIf (Not isGlobal And sArc = "["&archiv&"]" And strict) Or (Not isGlobal And (InStr(archiv, Arc2) = 1) And Not strict) Then
                        dpiYmax(0) = CInt(Right(sTemp, Len(sTemp) - InStr(sTemp,"-")))
                    End If
                End If
            ElseIf ((InStr(sLine, "BordersY1") = 0) And strict And (sArc = "["&archiv&"]")) Or ((InStr(sLine, "BordersY1") = 0) And Not strict And (Left(archiv, Len(sArc2)) = sArc2)) Then
                If dpiYmax(0) = "" Then dpiYmax(0) = 0
                If dpiYmin(0) = "" Then dpiYmin(0) = 0
            End If
            If InStr(sLine, "BordersX8") <> 0 Then
                If Right(sLine, Len(sLine)-10) <> "" Then
                    sTemp = Right(sLine, Len(sLine) - InStr(sLine, "="))
                    If isGlobal And dpiXmin(1) = "" Then
                        dpiXmin(1) = CInt(Left(sTemp, InStr(sTemp, "-") - 1))
                    ElseIf (Not isGlobal And sArc = "["&archiv&"]" And strict) Or (Not isGlobal And (InStr(archiv, Arc2) = 1) And Not strict) Then
                        dpiXmin(1) = CInt(Left(sTemp, InStr(sTemp, "-") - 1))
                    End If
                    If isGlobal And dpiXmax(1) = "" Then
                        dpiXmax(1) = CInt(Right(sTemp, Len(sTemp) - InStr(sTemp,"-")))
                    ElseIf (Not isGlobal And sArc = "["&archiv&"]" And strict) Or (Not isGlobal And (InStr(archiv, Arc2) = 1) And Not strict) Then
                        dpiXmax(1) = CInt(Right(sTemp, Len(sTemp) - InStr(sTemp,"-")))
                    End If
                End If
            ElseIf ((InStr(sLine, "BordersX8") = 0) And strict And (sArc = "["&archiv&"]")) Or ((InStr(sLine, "BordersX8") = 0) And Not strict And (Left(archiv, Len(sArc2)) = sArc2)) Then
                If dpiXmax(1) = "" Then dpiXmax(1) = 0
                If dpiXmin(1) = "" Then dpiXmin(1) = 0
            End If
            If InStr(sLine, "BordersY8") <> 0 Then
                If Right(sLine, Len(sLine)-10) <> "" Then
                    sTemp = Right(sLine, Len(sLine) - InStr(sLine, "="))
                    If isGlobal And dpiYmin(1) = "" Then
                        dpiYmin(1) = CInt(Left(sTemp, InStr(sTemp, "-") - 1))
                    ElseIf (Not isGlobal And sArc = "["&archiv&"]" And strict) Or (Not isGlobal And (InStr(archiv, Arc2) = 1) And Not strict) Then
                        dpiYmin(1) = CInt(Left(sTemp, InStr(sTemp, "-") - 1))
                    End If
                    If isGlobal And dpiYmax(1) = "" Then
                        dpiYmax(1) = CInt(Right(sTemp, Len(sTemp) - InStr(sTemp,"-")))
                    ElseIf (Not isGlobal And sArc = "["&archiv&"]" And strict) Or (Not isGlobal And (InStr(archiv, Arc2) = 1) And Not strict) Then
                        dpiYmax(1) = CInt(Right(sTemp, Len(sTemp) - InStr(sTemp,"-")))
                    End If
                End If
            ElseIf ((InStr(sLine, "BordersY8") = 0) And strict And (sArc = "["&archiv&"]")) Or ((InStr(sLine, "BordersY8") = 0) And Not strict And (Left(archiv, Len(sArc2)) = sArc2)) Then
                If dpiYmax(1) = "" Then dpiYmax(1) = 0
                If dpiYmin(1) = "" Then dpiYmin(1) = 0
            End If
            If InStr(sLine, "BordersX24") <> 0 Then
                If Right(sLine, Len(sLine)-11) <> "" Then
                    sTemp = Right(sLine, Len(sLine) - InStr(sLine, "="))
                    If isGlobal And dpiXmin(2) = "" Then
                        dpiXmin(2) = CInt(Left(sTemp, InStr(sTemp, "-") - 1))
                    ElseIf (Not isGlobal And sArc = "["&archiv&"]" And strict) Or (Not isGlobal And (InStr(archiv, Arc2) = 1) And Not strict) Then
                        dpiXmin(2) = CInt(Left(sTemp, InStr(sTemp, "-") - 1))
                    End If
                    If isGlobal And dpiXmax(2) = "" Then
                        dpiXmax(2) = CInt(Right(sTemp, Len(sTemp) - InStr(sTemp,"-")))
                    ElseIf (Not isGlobal And sArc = "["&archiv&"]" And strict) Or (Not isGlobal And (InStr(archiv, Arc2) = 1) And Not strict) Then
                        dpiXmax(2) = CInt(Right(sTemp, Len(sTemp) - InStr(sTemp,"-")))
                    End If
                End If
            ElseIf ((InStr(sLine, "BordersX24") = 0) And strict And (sArc = "["&archiv&"]")) Or ((InStr(sLine, "BordersX24") = 0) And Not strict And (Left(archiv, Len(sArc2)) = sArc2)) Then
                If dpiXmax(2) = "" Then dpiXmax(2) = 0
                If dpiXmin(2) = "" Then dpiXmin(2) = 0
            End If
            If InStr(sLine, "BordersY24") <> 0 Then
                If Right(sLine, Len(sLine)-11) <> "" Then
                    sTemp = Right(sLine, Len(sLine) - InStr(sLine, "="))
                    If isGlobal And dpiYmin(2) = "" Then
                        dpiYmin(2) = CInt(Left(sTemp, InStr(sTemp, "-") - 1))
                    ElseIf (Not isGlobal And sArc = "["&archiv&"]" And strict) Or (Not isGlobal And (InStr(archiv, Arc2) = 1) And Not strict) Then
                        dpiYmin(2) = CInt(Left(sTemp, InStr(sTemp, "-") - 1))
                    End If
                    If isGlobal And dpiYmax(2) = "" Then
                        dpiYmax(2) = CInt(Right(sTemp, Len(sTemp) - InStr(sTemp,"-")))
                    ElseIf (Not isGlobal And sArc = "["&archiv&"]" And strict) Or (Not isGlobal And (InStr(archiv, Arc2) = 1) And Not strict) Then
                        dpiYmax(2) = CInt(Right(sTemp, Len(sTemp) - InStr(sTemp,"-")))
                    End If
                End If
            ElseIf ((InStr(sLine, "BordersY24") = 0) And strict And (sArc = "["&archiv&"]")) Or ((InStr(sLine, "BordersY24") = 0) And Not strict And (Left(archiv, Len(sArc2)) = sArc2)) Then
                If dpiYmax(2) = "" Then dpiYmax(2) = 0
                If dpiYmin(2) = "" Then dpiYmin(2) = 0
            End If
        Loop
        'Alle werte sind eingelesen. nun CountPages aufrufen
        'und die Rckgabe auswerten			
    End If	
    
    inifile.Close
    If ((InStr(sLine, "[") <> 0) And (InStr(LCase(sLine), "global") = 0)  And strict And (sArc = "["&archiv&"]")) Or ((InStr(sLine, "[") <> 0) And (InStr(LCase(sLine), "global") = 0)  And Not strict And (Left(archiv, Len(sArc2)) = sArc2)) Then
        For iCnt = 0 To 2 Step 1
            dpiXmin(iCnt) = 0
            dpiYmin(iCnt) = 0
            dpiXmax(iCnt) = 0
            dpiymax(iCnt) = 0
        Next
    End If
    'In Arrays alle Leerstrings durch 0 ersetzen
    For iCnt = 0 To 2 Step 1
        If dpiXmin(iCnt) = "" Then dpiXmin(iCnt) = 0
        If dpiYmin(iCnt) = "" Then dpiYmin(iCnt) = 0
        If dpiXmax(iCnt) = "" Then dpiXmax(iCnt) = 0
        If dpiYmax(iCnt) = "" Then dpiYmax(iCnt) = 0
    Next	
    '---------------------------------------------------------------------------------------------------------------------------------------------
    cmd = programm&"CountPages.exe "&""""&tiffilename&""""
    
    Set oExec = objWSHShell.Exec(cmd)
    strinput = ""
    sTemp = ""
    Do While Not oExec.StdOut.AtEndOfStream
        strinput = oExec.StdOut.ReadLine
        If InStr(strinput, "Anzahl Seiten:") Then
            pages = CInt(Right(strInput, Len(strinput)-14))
        End If
        If InStr(strinput, "Farbtiefe:") Then
            colorDepth = CInt(Right(strinput, Len(strinput)-10))
            'Damit auch 4 Bit Graustufentifs verarbeitet werden
            If colorDepth = 4 Then
            	colorDepth = 8
            End If
        End If
        If InStr(strinput, "DPI:") Then
            sTemp = Right(strinput, Len(strinput)-4)
            dpiX = CInt(Left(sTemp, InStr(sTemp, "x") - 2))
            dpiY = CInt(Right(sTemp, Len(stemp) - InStr(sTemp, "x") - 1))
        End If
        If InStr(strinput, "Kompression:") Then
            compression = Right(strinput, Len(strinput)-13)
        End If
    Loop
    '---------------------------------------------------------------------------------------------------------------------------------------------
    'Alle rckgabewerte von CountPages sind ermittelt.
    'Jetzt vergleichen ob die ermittelten werte mit der ausgelesenen Richtliniendefinition
    'zusammenpassen wenn nicht ggf. Filter erstellen und kleinrechnen bzw. konvertieren.
    'Ist tif zu klein, dann ab in den garbage und ggf. mail senden!
    
    'Keine Richtlinie vorhanden? Dann ab in den Garbage
    For iCnt = 0 To 2 Step 1
        If (dpiXmin(iCnt) > 0) Or (dpiXmax(iCnt) > 0) Or (dpiYmin(iCnt) > 0) Or (dpiYmax(iCnt) > 0) Then kill = False
    Next
    
    If kill Then
        Doc2Garb("archivierung: Keine gltige Richtlinie vorhanden. Das Dokument wird in Garbage verschoben")
        Exit Sub	
    End If
    
    Select Case colorDepth
        Case 1
        'Einfachster Fall
        'Es gibt keinen kleineren Farbraum als SW.
        'Hier muss nur ggf. die Auflsung runtergerechnet werden. (Oder Tif verwerfen wenn zu klein)
        If (dpiXmin(0) > 0) And (dpiXmax(0) > 0) And (dpiXmin(0) <= dpiXmax(0)) And (dpiYmin(0) > 0) And (dpiYmax(0) > 0 ) And (dpiYmin(0) <= dpiYmax(0)) Then
            'Dokument passt in Range
            If (dpiXmin(0) <= dpiX) And (dpiXmax(0) >= dpiX) And (dpiYmin(0) <= dpiY) And (dpiYmax(0) >= dpiY) Then
                If scriptdebug=True Then
                    errortxt = "archivierung: Tif wurde berprft und hat die vorgegebene Richtlinie SW erfllt. Normale Archivierung."
                    objWshShell.LogEvent 4, errortxt
                End If
                Exit Sub
            End If
            
            'Dokument ist zu gro und wird kleingerechnet (hierzu Filterdatei erzeugen)
            If (dpiXmax(0) < dpiX) Or (dpiYmax(0) < dpiY) Then
                kleinrechnen dpiXmax(0), dpiX, dpiYmax(0), dpiY, Left(tiffilename, Len(tiffilename) - 4)
                notificationmessage = "Dieses Dokument wurde durch Richtlinienangaben klein gerechnet."
                If notificationconverttif And changeling Then SendConvertNotification tempname & ".job", notificationmessage
                Exit Sub
            End If
            
            'Dokument ist zu klein und wandert in Garbage
            If(dpiX < dpiXmin(0)) Or(dpiY < dpiYmin(0)) Then
                Doc2Garb("archivierung: Tif hat Richtlinienprfung SW nicht bestanden. Dokument wird nach garbage verschoben!")
            End If
            'Richtlinie nicht angegeben daher Garbage
        ElseIf (dpiXmin(0) = 0) And (dpiXmax(0) = 0) And (dpiYmin(0) = 0) And (dpiYmax(0) = 0) Then
            'Doc2Garb("archivierung: Das Dokument wurde in Schwarzweiss gescannt. Dokument wird in Garbage verschoben da Farbraum ungltig!")
            Doc2Garb("archivierung: Das Dokument wurde in Schwarzweiss erfasst. Dokument wird in Garbage verschoben da Farbraum ungltig!")
            Exit Sub
        End If
        Case 8
        'Graustufen verhalten sich wie SW nur eben mit anderem DPI-Range
        'Wenn das Graustufen Tif nicht in die Range passt, wird geprft ob es 
        'in die SW Range passt und ggf Konvertiert
        If (dpiXmin(1) > 0) And (dpiXmax(1) > 0) And (dpiXmin(1) <= dpiXmax(1)) And (dpiYmin(1) > 0) And (dpiYmax(1) > 0 ) And (dpiYmin(1) <= dpiYmax(1)) Then
            
            'Dokument passt in Range
            If (dpiXmin(1) <= dpiX) And (dpiXmax(1) >= dpiX) And (dpiYmin(1) <= dpiY) And (dpiYmax(1) >= dpiY) Then
                If scriptdebug=True Then
                    errortxt = "archivierung: Tif wurde berprft und hat die vorgegebene Richtlinie GS erfllt. Normale Archivierung."
                    objWshShell.LogEvent 4, errortxt
                End If
                Exit Sub
            End If
            
            'Dokument ist zu gro und wird kleingerechnet (hierzu Filterdatei erzeugen)
            If (dpiXmax(1) < dpiX) Or (dpiYmax(1) < dpiY) Then
                kleinrechnen dpiXmax(1), dpiX, dpiYmax(1), dpiY, Left(tiffilename, Len(tiffilename) - 4)
                notificationmessage = "Dieses Dokument wurde durch Richtlinienangaben klein gerechnet."
                If notificationconverttif And changeling Then SendConvertNotification tempname & ".job", notificationmessage
                Exit Sub
            End If
            
            'Dokument ist zu klein 
            'Prfen ob das Dokument in die Range von sw passt
            'Falls dies der Fall ist konvertieren Falls tif zu gro fr sw dann auch runterrechnen
            If(dpiX < dpiXmin(1)) Or(dpiY < dpiYmin(1)) Then
                'Wenn gltige Range fr SW vorhanden
                If (dpiXmin(0) > 0) And (dpiXmax(0) > 0) And (dpiXmin(0) <= dpiXmax(0)) And (dpiYmin(0) > 0) And (dpiYmax(0) > 0 ) And (dpiYmin(0) <= dpiYmax(0)) Then
                    'Tif passt in Range und wird nur konvertiert 
                    If (dpiXmin(0) <= dpiX) And (dpiXmax(0) >= dpiX) And (dpiYmin(0) <= dpiY) And (dpiYmax(0) >= dpiY) Then
                        konvertieren "BW=-2", Left(tiffilename, Len(tiffilename) - 4)
                        notificationmessage = "Dieses Dokument wurde durch Richtlinienangaben nach Schwarz Weiss konvertiert."
                        If notificationconverttif And changeling Then SendConvertNotification tempname & ".job", notificationmessage
                        Exit Sub
                    End If
                    'Tif ist zu gro fr SW Range also konvertieren UND kleinrechnen
                    If (dpiXmax(0) <= dpiX) Or (dpiYmax(0) <= dpiY) Then
                        konvertierenundkleinrechnen dpiXmax(0), dpiYmax(0), "BW=-2", Left(tiffilename, Len(tiffilename) - 4)
                        notificationmessage = "Dieses Dokument wurde durch Richtlinienangaben nach Schwarz Weiss konvertiert und klein gerechnet."
                        If notificationconverttif And changeling Then SendConvertNotification tempname & ".job", notificationmessage
                        Exit Sub
                    End If
                    'Tif ist in x oder y zu klein und wird daher in Garbage verschoben
                    If(dpiXmin(0) > dpiX) Or (dpiYmin(0) > dpiY) Then
                        Doc2Garb("archivierung: Tif hat Richtlinienprfung SW nicht bestanden. Dokument wird nach garbage verschoben!")
                    End If
                Else
                    Doc2Garb("archivierung: Tif hat Richtlinienprfung GS nicht bestanden. Dokument wird nach garbage verschoben!")
                End If
            End If
            'Keine Richtlinie Vorhanden also Garbage
        ElseIf (dpiXmin(1) = 0) And (dpiXmax(1) = 0) And (dpiYmin(1) = 0) And (dpiYmax(1) = 0) Then
            Doc2Garb("archivierung: Das Dokument wurde in Graustufen erfasst. Dokument wird in Garbage verschoben da Farbraum ungltig!")
            Exit Sub	
        End If
        Case 24
        'Farb Tifs
        'Ist Richtlinie fr Farbtifs angegeben?
        If (dpiXmin(2) > 0) And (dpiXmax(2) > 0) And (dpiYmin(2) > 0) And (dpiYmax(2) > 0)  And (dpiXmin(2) <= dpiXmax(2)) And (dpiYmin(2) <= dpiYmax(2)) Then
            'Tif passt in Range
            If (dpiXmax(2) >= dpiX) And (dpiXmin(2) <= dpiX) And (dpiYmax(2) >= dpiY) And (dpiYmin(2) <= dpiY) Then
                If scriptdebug=True Then
                    errortxt = "archivierung: Tif wurde berprft und hat die vorgegebene Richtlinie CL erfllt. Normale Archivierung."
                    objWshShell.LogEvent 4, errortxt
                End If
                Exit Sub
            End If	
            'Tif ist zu gro und wird kleingerechnet
            If (dpiXmax(2) < dpiX) Or (dpiYmax(2) < dpiY) Then
                If scriptdebug=True Then
                    errortxt = "archivierung: Tif wurde berprft und hat die vorgegebene Richtlinie CL nicht erfllt. Kleinrechnen."
                    objWshShell.LogEvent 4, errortxt
                End If
                kleinrechnen dpiXmax(2), dpiX, dpiYmax(2), dpiY, Left(tiffilename, Len(tiffilename) - 4)
                notificationmessage = "Dieses Dokument wurde durch Richtlinienangaben klein gerechnet."
                If notificationconverttif And changeling Then SendConvertNotification tempname & ".job", notificationmessage
                Exit Sub
            End If
            
            'Tif ist zu klein. Nchsten hinterlegten Farbraum prfen
            'Richtline fr Graustufen
            If (dpiXmin(1) > 0) And (dpiXmax(1) > 0) And (dpiYmin(1) > 0) And (dpiYmax(1) > 0) And (dpiXmin(1) <= dpiXmax(1)) And (dpiYmin(1) <= dpiYmax(1)) Then
                'Auflsung passt in Range also nur konvertieren
                If (dpiXmin(1) <= dpiX) And (dpiYmin(1) <= dpiY) And (dpiXmax(1) >= dpiX) And (dpiYmax(1) >= dpiY) Then
                    konvertieren "Gray", Left(tiffilename, Len(tiffilename) - 4)
                    notificationmessage = "Dieses Dokument wurde durch Richtlinienangaben in Graustufen konvertiert."
                    If notificationconverttif And changeling Then SendConvertNotification tempname & ".job", notificationmessage
                    Exit Sub
                End If
                'Auflsung zu gro also kleinrechnen und konveriteren
                If (dpiX > dpiXmax(1)) Or (dpiY > dpiYmax(1)) Then
                    konvertierenundkleinrechnen dpiXmax(1), dpiYmax(1), "Gray", Left(tiffilename, Len(tiffilename) - 4)
                    notificationmessage = "Dieses Dokument wurde durch Richtlinienangaben in Graustufen konvertiert und klein gerechnet."
                    If notificationconverttif And changeling Then SendConvertNotification tempname & ".job", notificationmessage
                    Exit Sub
                End If
                
                If (dpiX < dpiXmin(1)) Or (dpiY < dpiYmin(1)) Then
                    If (dpiXmin(0) > 0) And (dpiXmax(0) > 0) And (dpiYmin(0) > 0) And (dpiYmax(0) > 0) And (dpiXmin(0) <= dpiXmax(0)) And (dpiYmin(0) <= dpiYmax(0)) Then
                        If (dpiY <= dpiYmax(0)) And (dpiX <= dpiXmax(0)) And (dpiY >= dpiYmin(0)) And (dpiX >= dpiXmin(0)) Then
                            konvertieren "BW=-2", Left(tiffilename, Len(tiffilename) - 4)
                            notificationmessage = "Dieses Dokument wurde durch Richtlinienangaben nach Schwarz Weiss konvertiert."
                            If notificationconverttif And changeling Then SendConvertNotification tempname & ".job", notificationmessage
                            Exit Sub
                        End If
                        If (dpiY > dpiYmax(0)) Or (dpX > dpiXmax(0)) Then
                            konvertierenundkleinrechnen dpiXmax(0), dpiYmax(0), "BW=-2", Left(tiffilename, Len(tiffilename) - 4)
                            notificationmessage = "Dieses Dokument wurde durch Richtlinienangaben nach Schwarz Weiss konvertiert und klein gerechnet."
                            If notificationconverttif And changeling Then SendConvertNotification tempname & ".job", notificationmessage
                            Exit Sub
                        End If
                        If (dpiY < dpiYmin(0)) Or (dpiX < dpiXmin(0)) Then
                            Doc2Garb("archivierung: Tif hat Richtlinienprfung SW nicht bestanden. Dokument wird nach garbage verschoben!")	
                        End If 	
                    End If
                End If
            End If
            'Richtlinie fr Graustufen nicht hinterlegt.
            'nun benutzen wird schwarz weiss
            If (dpiXmin(0) > 0) And (dpiXmax(0) > 0) And (dpiYmin(0) > 0) And (dpiYmax(0) > 0) And (dpiXmin(0) <= dpiXmax(0)) And (dpiYmin(0) <= dpiYmax(0)) Then
                'Auflsung passt in Range also nur konvertieren
                If (dpiXmin(0) <= dpiX) And (dpiYmin(0) <= dpiY) And (dpiXmax(0) >= dpiX) And (dpiYmax(0) >= dpiY) Then
                    konvertieren "BW=-2", Left(tiffilename, Len(tiffilename) - 4)
                    notificationmessage = "Dieses Dokument wurde durch Richtlinienangaben nach Schwarz Weiss konvertiert."
                    If notificationconverttif And changeling Then SendConvertNotification tempname & ".job", notificationmessage
                    Exit Sub
                End If
                'Auflsung zu gro also kleinrechnen und konveriteren
                If (dpiX > dpiXmax(0)) Or (dpiY > dpiYmax(0)) Then
                    konvertierenundkleinrechnen dpiXmax(0), dpiYmax(0), "BW=-2", Left(tiffilename, Len(tiffilename) - 4)
                    notificationmessage = "Dieses Dokument wurde durch Richtlinienangaben nach Schwarz Weiss konvertiert und klein gerechnet."
                    If notificationconverttif And changeling Then SendConvertNotification tempname & ".job", notificationmessage
                    Exit Sub
                End If
                If (dpiX < dpiXmax(0)) Or (dpiY < dpiYmax(0)) Then
                    Doc2Garb("archivierung: Tif hat Richtlinienprfung SW nicht bestanden. Dokument wird nach garbage verschoben!")	
                End If
            Else
                Doc2Garb("archivierung: Tif hat Richtlinienprfung CL nicht bestanden und es wurde keine weitere Richtlinie definiert. Dokument wird nach garbage verschoben!")	
            End If
        ElseIf (dpiXmin(2) = 0) And (dpiXmax(2) = 0) And (dpiYmin(2) = 0) And (dpiYmax(2) = 0) Then
            Doc2Garb("archivierung: Das Dokument wurde in Farbe erfasst. Dokument wird in Garbage verschoben da Farbraum ungltig!")
            Exit Sub		
        End If
    End Select
End Sub

'################################################################
'### Hilfsfunktionen fr die Prfung von Tifs auf Richtlinien ###
'### und gegebenenfalls Kleinrechnung und Konvertierung       ###
'################################################################
Private Sub kleinrechnen(dpiXmax, dpiX, dpiYmax, dpiY, tifname)
    If (dpiXmax < dpiX) Or (dpiYmax < dpiY) Then
        If fs.FileExists(programm&"filter\Directives.txt") Then
            fs.deletefile programm&"filter\Directives.txt", True
        End If
        
        If Not fs.FileExists(programm&"filter\Directives.fad") Then
            Set filterfile = fs.CreateTextFile(programm&"filter\Directives.fad",True)
            filterfile.WriteLine("Archivfilter=Directives")
            filterfile.Close
            Set filterfile = Nothing
        End If
        Set filterfile = fs.CreateTextFile(programm&"filter\Directives.txt",True)
        If (dpiXmax <= dpiX) And (dpiY <= dpiYmax) Then
            wert = dpiXmax
        End If
        If (dpiYmax <= dpiY) And (dpiX <= dpiXmax) Then
            wert = dpiYmax
        End If
        If (dpiXmax < dpiX) And (dpiYmax < dpiY) Then
            If (dpiXmax > dpiYmax) Then
                wert = dpiXmax				
            End If
            If (dpiYmax > dpiXmax) Then
                wert = dpiYmax				
            End If
            If (dpiXmax = dpiYmax) Then 
                wert = dpiXmax
            End If
        End If 
        filterfile.writeline("RES="& CStr(wert))
        filterfile.close()
        Set Filterfile = Nothing
        
        'Kleinrechnung durch Filter
        sBuffer=filtermakro
        filtermakro="Directives"
        filtern tifname
        filtermakro=sBuffer
    End If
End Sub

Private Sub Doc2Garb(Txt) 
    errortxt = Txt
    objWshShell.LogEvent 1, errortxt
    alertongarbage = True
    alertongarbagecounter=0
    GetGarbage tempname
    Unlock(programm&lockdatei)
    WScript.Quit
End Sub

Private Sub konvertieren(modus, tifname)
    If scriptdebug=True Then
        If modus = "BW=-2" Then
            errortxt = "archivierung: Tif wurde berprft und hat die vorgegebene Richtlinie SW erfllt. Tif wird nach SW konvertiert."
        End If
        If modus = "Gray" Then
            errortxt = "archivierung: Tif wurde berprft und hat die vorgegebene Richtlinie GS erfllt. Tif wird nach GS konvertiert."
        End If
        
        objWshShell.LogEvent 4, errortxt
    End If
    If Not fs.FileExists(programm&"filter\Directives.fad") Then
        Set filterfile = fs.CreateTextFile(programm&"filter\Directives.fad",True)
        filterfile.WriteLine("Archivfilter=Directives")
        filterfile.Close
        Set filterfile = Nothing
    End If
    Set filterfile = fs.CreateTextFile(programm&"filter\Directives.txt",True)
    filterfile.writeline(modus)
    filterfile.close()
    Set Filterfile = Nothing
    
    'Konvertierung durch Filter
    sBuffer=filtermakro
    filtermakro="Directives"
    filtern tifname
    filtermakro=sBuffer
End Sub

Private Sub konvertierenundkleinrechnen(dpiXmax, dpiYmax, modus, tifname)
    If scriptdebug=True Then
        errortxt = "archivierung: Tif wurde berprft und hat die vorgegebene Richtlinie SW nicht erfllt da es eine zu hohe Auflsung hat."&vbCrLf&" Tif wird nach SW konvertiert und kleingerechnet."
        objWshShell.LogEvent 4, errortxt
    End If
    If Not fs.FileExists(programm&"filter\Directives.fad") Then
        Set filterfile = fs.CreateTextFile(programm&"filter\Directives.fad",True)
        filterfile.WriteLine("Archivfilter=Directives")
        filterfile.Close
        Set filterfile = Nothing
    End If
    Set filterfile = fs.CreateTextFile(programm&"filter\Directives.txt",True)
    If (dpiXmax > dpiYmax) Then
        filterfile.writeline("RES=" & CStr(dpiXmax))
    End If
    If (dpiYmax > dpiXmax) Then
        filterfile.writeline("RES=" & CStr(dpiYmax))
    End If
    If (dpiXmax = dpiYmax) Then 
        filterfile.writeline("RES=" & CStr(dpiXmax))
    End If
    
    filterfile.writeline(modus)
    filterfile.close()
    Set Filterfile = Nothing
    
    'Konvertierung durch Filter
    sBuffer=filtermakro
    filtermakro="Directives"
    filtern tifname
    filtermakro=sBuffer
End Sub 

Private Sub SendConvertNotification(jobfilename, msg)
    'gdocid auslesen und als link versenden
    docid=""
    If fs.FileExists(jobfilename) Then
        Set jobfile = fs.OpenTextfile(jobfilename)
        sLine =""
        Do While Not jobfile.AtEndOfStream
            sline=jobfile.ReadLine
            If InStr(sLine, "gdoc_id=") <> 0 Then
                docid = Right(sLine, Len(sLine) - 8)
                gdocid = docid
                Exit Do
            End If	
        Loop
        jobfile.Close
        lngReturnCode = objWSHShell.Run(Chr(34)&programm & "sendlinkmail.vbs"&Chr(34)&" " & adminmail & " "& docid & " " & Chr(34) & msg & Chr(34))
    End If
    notificationmessage = ""
End Sub

Function perfadd(colname)
    If perfmon = True Then
        t = Timer
        perfdata(perfcounter) = t
        perfcolnames(perfcounter)=colname
        perfcounter = perfcounter + 1
    End If
End Function

Function perfsave()
    If perfmon = True Then
        delimiter = ";"
        
        If fs.folderexists(programm & "perfdata") = False Then
            fs.createfolder(programm & "perfdata")
        End If
        Set perfdataf = fs.opentextfile(programm & "perfdata\"&gdocid&".csv",2,True)
        'Set swdfile = fs.opentextfile(sJobname & ".slw",8,True)
        
        i = 0
        line = ""
        colname = perfcolnames(i)
        Do While colname <> ""
            line = line & colname & delimiter
            i = i + 1
            colname = perfcolnames(i)
        Loop
        perfdataf.writeline(line)
        line = ""
        i=0
        t = perfdata(i)
        oldt = perfdata(0)
        Do While perfdata(i) <> ""
            t = perfdata(i) - oldt
            oldt = perfdata(i) 
            temp = Int(t)
            
            Miliseconds = Int((t-temp) * 1000)
            
            Seconds = temp Mod 60
            temp    = Int(temp/60)
            Minutes = temp Mod 60
            Hours   = Int(temp/60)
            
            
            
            ' Let's format it
            strTime =           String(2 - Len(Hours), "0") & Hours & ":"
            strTime = strTime & String(2 - Len(Minutes), "0") & Minutes & ":"
            strTime = strTime & String(2 - Len(Seconds), "0") & Seconds & "."
            strTime = strTime & String(4 - Len(Miliseconds), "0") & Miliseconds
            line = line & strTime  & delimiter
            i = i + 1
        Loop
        perfdataf.writeline(line)
        perfdataf.close()
    End If
End Function

Function archservicerunning()
    cmd = "sc query "&Chr(34)&"bitfarm-archiv Archivierungsdienst"&Chr(34)
    Set oExec = objWSHShell.Exec(cmd)
    strinput = ""
    strerrinput = ""
    Do While Not oExec.StdOut.AtEndOfStream
        strinput = strinput & oExec.StdOut.Read(1)	
    Loop
    strerrinput=""
    Do While Not oExec.StdErr.AtEndOfStream
        strerrinput = strerrinput & oExec.StdErr.Read(1)	
    Loop   
    If InStr(strinput,"running") Then
        archservicerunning=True
    Else
        archservicerunning=False
    End If
    
End Function


Function find_doc_by_sha1(shasum)
    If fs.fileexists(programm & "get_doc_by_sha.exe") Then
        cmd = programm & "get_doc_by_sha.exe " & profil & " " & shasum
        If scriptdebug=True Then
    		objWSHShell.LogEvent 0, "archivierung.vbs get_doc_by_sha Aufruf: " & cmd
    	End If
        Set oExec = objWSHShell.Exec(cmd)
        strinput = ""
        strerrinput = ""
        Do While Not oExec.StdOut.AtEndOfStream
            strinput = strinput & oExec.StdOut.Read(1)	
        Loop
        strerrinput=""
        Do While Not oExec.StdErr.AtEndOfStream
            strerrinput = strerrinput & oExec.StdErr.Read(1)	
        Loop 
        
        If scriptdebug=True Then
    		objWSHShell.LogEvent 0, "archivierung.vbs get_doc_by_sha Ergebnis: " & vbCrLf & strinput & vbCrLf & strerrinput
    	End If
    	
    	
        If Len(strerrinput)>0 Then
            find_doc_by_sha1=False
        ElseIf Len(strinput)>0 Then
            lines = Split(strinput, vbCrLf)
            ret = ""
            For Each line In lines
                elements = Split(line, " ")
                l = UBound(elements)
                If UBound(elements)=2 Then
                    gdocid = elements(0)
                    arcid = elements(1)
                    docid = elements(2)
                    ret = ret & line & vbCrLf	
                End If
            Next
            If Trim(ret) = "" Then
            	find_doc_by_sha1=False
            Else
            	find_doc_by_sha1=ret
            End If
        End If
    Else
        objWSHShell.LogEvent 1, "get_doc_by_sha.exe nicht im Programmpfad gefunden"
        find_doc_by_sha1=False
    End If
End Function

Function addmissingpagestif(tiffile, pages)
    If LCase(newstatuslang="deutsch") Then
        msgtxt1="Diese Voransicht enthlt nicht alle Seiten des Originaldokuments." 
        msgtxt2="Anzahl Seiten im Original: "&pages&"."
        msgtxt3="Fr eine komplette Dokumentenansicht ffnen Sie das Dokument"
        msgtxt4="ber den Button 'Originaldatei'."
    Else
        msgtxt1="This preview does not contain all pages of the original file."
        msgtxt2="Number of pages in the original file are "&pages&"."
        msgtxt3="To open the original file klick the Button 'original file'." 
        msgtxt4=""
    End If   
    
    If fs.fileexists(dateiname&"-temp.tff") Then
        fs.deletefile dateiname&"-temp.tff", True
    End If
    
    
    Set temptxtfile = fs.OpenTextFile(tiffile&"-temp.tff",8,True)
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" " & msgtxt1 & " ")
    temptxtfile.writeline(" " & msgtxt2 & " ")
    temptxtfile.writeline(" " & msgtxt3 & " ")
    temptxtfile.writeline(" " & msgtxt4 & " ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.writeline(" ")
    temptxtfile.close
    Set temptxtfile=Nothing
    
    lngReturnCode = objWSHShell.Run(Chr(34)&programm&"Text2TIF.exe"&Chr(34)&" "&Chr(34)&tiffile&"-temp.tff"&Chr(34),0,True)
    
    
    If lngReturnCode <> 0 Then
        If extension = ".sig" Then
            fs.deletefile dateiname &".pdf"
        End If
        Err.clear
        errortxt="archivierung(122g): Fehler bei Text2TIF.exe"
        objWshShell.LogEvent 1, errortxt
        GetGarbage(dateiname)   
        Unlock(programm&lockdatei)
        WScript.Quit
        
    End If
    
    WScript.Sleep 200
    fs.deletefile tiffile&"-temp.tff",True
    
    
    
    
    If (fs.fileexists(tiffile&"-temp.tif")) And (fs.fileexists(tiffile)) Then
        lngReturnCode = objWSHShell.Run(programm&"splitterv3.exe -a " &Chr(34)& tiffile &Chr(34) & " " &Chr(34)& tiffile&"-temp.tif"&Chr(34),0,True)
    End If
    If (fs.fileexists(tiffile&"-temp.tif")) Then
        fs.deletefile tiffile&"-temp.tif", True
    End If
End Function

Function countpdfpages(pdffile)
    If ((fs.fileexists(programm&"pdfinfo.bat")) And (fs.fileexists(programm&"pdfinfo.exe"))) Then
        countpdfpages=0
        zaehler=0
        strinput=""
        If scriptdebug = True Then
            objWshShell.LogEvent 4, "Archivierung: starte PDFInfo.exe"
        End If
        lngReturnCode = objWSHShell.Run(Chr(34)&programm&"pdfinfo.bat"&Chr(34)&" "&Chr(34)& pdffile &Chr(34)&" "&Chr(34)&pdffile&".pdi"&Chr(34),0,True)
        WScript.Sleep 1000
        errn = Err.number
        If fs.fileexists(pdffile&".pdi") Then
            Set quellswfile = fs.OpenTextFile(pdffile&".pdi",1)
            strinput = ""
            Do While quellswfile.AtEndOfStream <> True
                strinput=strinput+quellswfile.readline&vbCrLf
            Loop
            quellswfile.close
            Set quellswfile = Nothing
            fs.deletefile pdffile&".pdi",True
        End If
        
        
        If InStr(1,strinput, "Pages:",1) <> 0 Then	
            pos = InStr(1,strinput, "Pages:",1) +6
            pos2 = InStr(pos,strinput, vbCrLf) 
            pages = Mid(strinput, pos, pos2 - pos)
            countpdfpages = CInt(Trim(pages))
        End If
    Else
        countpdfpages = -1
    End If
    
End Function


Function GetFileNames(Directory, Pattern)
    Dim FileNames(), AfterPattern()
    Dim FolderObject, fso, f
    Dim i
    i = 0
    

    Set FolderObject = fs.GetFolder(Directory)
    ReDim FileNames(FolderObject.Files.Count)
    ReDim AfterPattern(FolderObject.Files.Count)
    For Each f In FolderObject.Files
        FileNames(i) = f.Path
        i = i + 1
    Next
    'Pattern Portion
    Dim RegExp
    Set RegExp = CreateObject("VBScript.RegExp")
    RegExp.Pattern = Pattern
    RegExp.Global = False
    Dim x
    x = -1
    For i = LBound(FileNames) To UBound(FileNames)
        If RegExp.Test(FileNames(i)) = True Then
            x = x + 1
            AfterPattern(x) = FileNames(i)
            
        End If
    Next
    ReDim Preserve AfterPattern(x)
    GetFileNames = AfterPattern
    
    

    Set FolderObject = Nothing
    Set RegExp = Nothing
    
End Function

Function findnameindir(filename, dirname)

	If Not fs.fileexists(programm & "find_name_in_dir.exe") Then
		findnameindir = findnameindir_old(filename, dirname)
	Else
		strinput = ""
		cmd = Chr(34) & programm & "find_name_in_dir.exe" & Chr(34) & " " &filename & " " & Chr(34) & dirname & Chr(34)
		
		If scriptdebug = True Then
			objWSHShell.LogEvent 0, "archivierung.vbs findnameindir cmd: " & cmd
		End If
		
		Set oExec = objWSHShell.Exec(cmd)
		Do While Not oExec.StdOut.AtEndOfStream
		    strinput = strinput & oExec.StdOut.Read(1)	
		Loop
		
		strinput = Replace(Trim(strinput),vbCrLf, "")
		If strinput = "false" Then
			findnameindir=False
		Else
			findnameindir=True
		End If
	End If
End Function


Function findnameindir_old(filename, dirname)
    findnameindir_old = False
    For each afile in fs.GetFolder(dirname).Files
    	aextension = fs.GetExtensionName(afile)
    	abasename = fs.GetBaseName(afile)
    	If LCase(abasename) = LCase(filename) Then
    		findnameindir_old = True
    		Exit for
    	End If
    Next	
End Function

Function getzusval(fieldname)
	getzusval = ""
	For gzvi = 0 To limit
		If zusatzfeldname(gzvi) = fieldname Then
			getzusval = zusatzfeld(gzvi)
			Exit for
		End If
	Next
End Function

Function getzusindex(fieldname)
	getzusindex = -1
	For gzvi = 0 To limit
		If zusatzfeldname(gzvi) = fieldname Then
			getzusindex = gzvi
			Exit for
		End If
	Next
End Function

Function getindex(fieldname, arr)
	getindex = -1
	For gzvi = 0 To limit
		If arr(gzvi) = fieldname Then
			getindex = gzvi
			Exit for
		End If
	Next
End Function

' Bitwise left shift
Function Lsh(ByVal N, ByVal Bits)
    Lsh = N * (2 ^ Bits)
End Function

' Returns a version string "a.b.c.d" as a two-element numeric
' array. The first array element is the most significant 32 bits,
' and the second element is the least significant 32 bits.
Function GetVersionStringAsArray(ByVal Version)
    Dim VersionAll, VersionParts, N
    VersionAll = Array(0, 0, 0, 0)
    VersionParts = Split(Version, ".")
    For N = 0 To UBound(VersionParts)
        VersionAll(N) = CLng(VersionParts(N))
    Next
    
    Dim Hi, Lo
    Hi = Lsh(VersionAll(0), 16) + VersionAll(1)
    Lo = Lsh(VersionAll(2), 16) + VersionAll(3)
    
    GetVersionStringAsArray = Array(Hi, Lo)
End Function

' Compares two versions "a.b.c.d". If Version1 < Version2,
' returns -1. If Version1 = Version2, returns 0.
' If Version1 > Version2, returns 1.
Function CompareVersions(ByVal Version1, ByVal Version2)
    Dim Ver1, Ver2, Result
    Ver1 = GetVersionStringAsArray(Version1)
    Ver2 = GetVersionStringAsArray(Version2)
    If Ver1(0) < Ver2(0) Then
        Result = -1
    ElseIf Ver1(0) = Ver2(0) Then
        If Ver1(1) < Ver2(1) Then
            Result = -1
        ElseIf Ver1(1) = Ver2(1) Then
            Result = 0
        Else
            Result = 1
        End If
    Else
        Result = 1
    End If
    CompareVersions = Result
End Function


Function get_arcids_fromtemplate(template_string)
	ReDim templateids(100)
	cnt = 0
	template_names = Split(template_string, ";")
	For Each template_name In template_names
		'MsgBox(template_name)
		If scriptdebug=True Then
			objWSHShell.LogEvent 0, "archivierung.vbs: ermittle arcid fr folgendes Template: " & template_name
		End If
		template_pth = templates & template_name&".tpl"
		If Not fs.fileexists(template_pth) Then
			objWSHShell.LogEvent 1, "archivierung.vbs get_arcids_fromtemplate: template " & template_pth & " konnte nicht gefunden werden!"		
		Else
			Set templatefile = fs.OpenTextFile(template_pth, 1)
			Do While templatefile.AtEndOfStream <> True
        	    kette=templatefile.ReadLine
        	    If Left(LCase(kette), 5) = "arcid" Then
        	    	templateids(cnt) = Trim(Right(kette,Len(kette) - 6))
        	    	cnt = cnt + 1
        	    End If
            Loop
			
		End If
	Next
	get_arcids_fromtemplate = templateids
End Function


Function log_zusatzfelder()
	lkette="Status der Zusatzfelder:"&VBCRLF
	For x=0 to limit
	    lkette=lkette&x&":"&zusatzfeldname(x)&"-"&Zusatzfeld(x)&VBCRLF
	Next
	objWshShell.LogEvent 1,lkette
End Function

Function delete_lo_tmpfiles(timestamp)
	If scriptdebug=True Then
		objWSHShell.LogEvent 1, "archivierung.vbs delete_lo_tmpfiles called"
	End If
	Set objRE = New RegExp
    objRE.Global     = False
    objRE.IgnoreCase = True
    objRE.Pattern    = "lu.*.tmp"

	Set fs_queue = fs.GetFolder(queue)
	For Each qf In fs_queue.Files
		
		If scriptdebug=True Then
			objWSHShell.LogEvent 1, "archivierung.vbs delete_lo_tmpfiles prfe " & qf.name
		End If
		' match filename against pattern
		Set colMatches = objRE.Execute(qf.name)
    		If colMatches.Count > 0 Then
    			If scriptdebug=True Then
					objWSHShell.LogEvent 1, "archivierung.vbs delete_lo_tmpfiles match bei " & qf.name
				End If
				' we have a match, check tstamp
 				Set f = fs.GetFile(queue & qf.name)
				fdate = f.DateCreated
				If scriptdebug=True Then
					objWSHShell.LogEvent 1, "archivierung.vbs delete_lo_tmpfiles fdate/timestamp "&vbCrLf & fdate &vbCrLf&timestamp
				End If
				diff = DateDiff("s", timestamp, fdate)
				If scriptdebug=True Then
					objWSHShell.LogEvent 1, "archivierung.vbs delete_lo_tmpfiles diff "&vbCrLf & diff
				End If
				If diff > 0 Then
					' pattern+tstamp condition True -> delete the file
					If scriptdebug=True Then
						objWSHShell.LogEvent 1, "archivierung.vbs delete_lo_tmpfiles deleting "&vbCrLf & qf.name
					End If
					f.delete(True)
				Else
					If scriptdebug=True Then
						objWSHShell.LogEvent 1, "archivierung.vbs delete_lo_tmpfiles not deleting "&vbCrLf & qf.name
					End If
				End If
			Else
				If scriptdebug=True Then
					objWSHShell.LogEvent 1, "archivierung.vbs delete_lo_tmpfiles kein match bei " & qf.name
				End If
			End If
	Next
End Function		
